﻿#!/usr/bin/python
# -*- coding = utf-8 -*-
#-------------------------------------------------------------------------------
# Name:        sem_const
# Purpose:     Arabic semantic analyzer Asmai
#
# Author:      Taha Zerrouki (taha.zerrouki[at]gmail.com)
#
# Created:     29-11-2012
# Copyright:   (c) Taha Zerrouki 2011
# Licence:     GPL
#-------------------------------------------------------------------------------

#semantic table
# this is a simulation for a database only
# temporary
Subject=u'فاعلية'
Predicate=u'مفعولية'
Added = u'مضاف إليه'
Adj =u'نعت'
SemanticTable={
 u'طَلَع شَمْس':Subject,
 u'عَبَد الله':Predicate,
u'شَرَحَ دَرْسٌ':Predicate,
u'شَرَحَ كِتَابٌ':Predicate,
u'شَرَحَ شّيْخٌ':Subject,
u'شَرَّحَ طَبِيبٌ':Subject,
u'شَبَّ نَارٌ':Subject,
u'عَالَجَ مَرِيضٌ':Predicate,
u'رَسُولٌ اللهُ':Added,
u'نَسَبٌ كَرِيمٌ':Adj,
u'أَكَلَ فَاكِهَةٌ':Predicate,
u'حَرَثَ أَرْضٌ':Predicate,
u'اِنْكَسَرَ زُجاجٌ':Subject,
u'غَرَّدَ عَصْفُورٌ':Subject,
# THA={

#
u'إبَاءٌ أحَدٌ':Added, #0: 
u'إبَاءٌ إِسْلامٌ':Added, #1: 1	إبَاءَ أَحَدِ
u'إبَاءٌ أفْضَلُ':Added, #3: 3	إبَاءُ الْإِسْلَامِ
u'إبَاءٌ تَوْكِيلٌ':Added, #1: 1	إبَاءَ الْأَفْضَلِ
u'إبَاءٌ رَاهِنٌ':Added, #1: 1	إبَاءِ التَّوْكِيلِ
u'إبَاءٌ زَوْجٌ':Added, #1: 1	إبَاءِ الرَّاهِنِ
u'إبَاءٌ زَوْجٌ':Added, #1: 1	إبَاءَ الزَّوْجِ
u'إبَاءٌ صَبِيٌّ':Added, #2: 2	إبَاءِ الزَّوْجِ
u'إبَاءٌ مَالِكٌ':Added, #1: 1	إبَاءُ الصَّبِيِّ
u'إبَاءٌ مُرْتَهِنٌ':Added, #2: 2	إبَاءِ الْمَالِكِ
u'إبَاءٌ وَكِيلٌ':Added, #1: 1	إبَاءِ الْمُرْتَهِنِ
u'إبَاءٌ وَلِيٌّ':Added, #1: 1	إبَاءِ الْوَكِيلِ
u'أَبَا أَسْماءٌ':Predicate, #1: 1	إبَاءِ وَلِيِّهِ
u'أَبَا بَحْرِيٌّ':Predicate, #7: 7	أَبَا أَسْمَاءَ
u'أَبَا بردة':Predicate, #1: 1	أَبَا بَحْرِيَّةَ
u'أَبَا بُرْدَةٌ':Predicate, #13: 13	أَبَا بُرْدَةَ
u'أَبَا برزة':Predicate, #13: 13	أَبَا بُرْدَةَ
u'أَبَا بَكْرَةٌ':Predicate, #7: 7	أَبَا بَرْزَةَ
u'أَبَاتَ عند':Predicate, #22: 22	أَبَا بَكْرَةَ
u'أَبَا تَمِيمَةٌ':Predicate, #1: 1	أَبَاتَ عِنْدَ
u'أَبَا ثَعْلَبٌ':Predicate, #2: 2	أَبَا تَمِيمَةَ
u'أَبَا ثُمام':Predicate, #7: 7	أَبَا ثَعْلَبَةَ
u'أَبَا جسرة':Predicate, #7: 7	أَبَا ثُمَامَةَ
u'أَبَا جَعْدٌ':Predicate, #1: 1	أَبَا جَسْرَةَ
u'أَبَا جَمْرَةٌ':Predicate, #1: 1	أَبَا جَعْدَةَ
u'أَبَا جَمْرَة':Predicate, #2: 2	أَبَا جَمْرَةَ
u'أَبَا جَمِيلٌ':Predicate, #2: 2	أَبَا جَمْرَةَ
u'أَبَاحَ إِجْرَاءٌ':Predicate, #6: 6	أَبَا جَمِيلَةَ
u'أَبَاحَ اِسْتِصْباح':Predicate, #2: 2	أَبَاحَ إجْرَاءَ
u'أَبَاحَ أَشْيَاءٌ':Predicate, #1: 1	أَبَاحَ الاِسْتِصْبَاحَ
u'أَبَاحَ إقْدَامٌ':Predicate, #1: 1	أَبَاحَ أَشْيَاءَ
u'أَبَاحَ أكل':Predicate, #2: 2	أَبَاحَ الْإِقْدَامَ
u'أَبَاحَ أَكْلٌ':Predicate, #2: 2	أَبَاحَ الْأَكْلَ
u'أَبَاحَ إمَامٌ':Subject, #2: 2	أَبَاحَ الْأَكْلَ
u'أَبَاحَ أَمْوَالٌ':Predicate, #1: 1	أَبَاحَ الْإِمَامُ
u'أَبَا حَبٌّ':Predicate, #1: 1	أَبَاحَ الْأَمْوَالَ
u'أَبَا حَبَّةٌ':Predicate, #2: 2	أَبَا حَبَّةَ
u'إبَاحَةٌ إبْداءٌ':Added, #2: 2	أَبَا حَبَّةَ
u'إبَاحَةٌ اِتِّخَاذٌ':Added, #1: 1	إبَاحَةُ إبْدَاءِ
u'إبَاحَةٌ إِجْرَاءٌ':Added, #1: 1	إبَاحَةِ اتِّخَاذِ
u'إبَاحَةٌ أخْذٌ':Added, #2: 2	إبَاحَةُ إجْرَاءِ
u'إبَاحَةٌ أخْذٌ':Added, #1: 1	إبَاحَةَ أَخْذِ
u'إبَاحَةٌ أخْذٌ':Added, #1: 1	إبَاحَةُ أَخْذِ
u'إبَاحَةٌ أخْذٌ':Added, #1: 1	إبَاحَةِ أَخْذِ
u'إبَاحَةٌ إِخْرَاجٌ':Added, #2: 2	إبَاحَةُ الْأَخْذِ
u'إبَاحَةٌ أَدَاءٌ':Added, #1: 1	إبَاحَةِ إخْرَاجِ
u'إبَاحَةٌ أَدَاءٌ':Added, #1: 1	إبَاحَةُ أَدَاءِ
u'إبَاحَةٌ أَرْبَعُ':Added, #1: 1	إبَاحَةِ أَدَاءِ
u'إبَاحَةٌ أَزْواجٌ':Added, #1: 1	إبَاحَةُ أَرْبَعِ
u'إبَاحَةٌ أسْبَابٌ':Added, #3: 3	إبَاحَةِ أَزْوَاجِهِ
u'إبَاحَةٌ أَسْبَابٌ':Added, #1: 1	إبَاحَةِ أَسْبَابِ
u'إبَاحَةٌ اِسْتِعْمالٌ':Added, #1: 1	إبَاحَةِ أَسْبَابِ
u'إبَاحَةٌ اِسْتِعْمالٌ':Added, #1: 1	إبَاحَةِ اسْتِعْمَالِ
u'إبَاحَةٌ إِشْعارٌ':Added, #1: 1	إبَاحَةُ اسْتِعْمَالِهِ
u'إبَاحَةٌ إصابَةٌ':Added, #1: 1	إبَاحَةِ الْإِشْعَارِ
u'إبَاحَةٌ أصل':Added, #1: 1	إبَاحَةِ الْإِصَابَةِ
u'إبَاحَةٌ أًصْلٌ':Added, #2: 2	إبَاحَةُ أَصْلِهِ
u'إبَاحَةٌ إِظْهارٌ':Added, #2: 2	إبَاحَةُ أَصْلِهِ
u'إبَاحَةٌ إفْسَادٌ':Added, #1: 1	إبَاحَةِ إظْهَارِ
u'إبَاحَةٌ اِقْتِناءٌ':Added, #1: 1	إبَاحَةَ إفْسَادِ
u'إبَاحَةٌ أكل':Added, #1: 1	إبَاحَةَ اقْتِنَاءِ
u'إبَاحَةٌ أكل':Added, #1: 1	إبَاحَةُ أَكْلِ
u'إبَاحَةٌ أَكْلٌ':Added, #1: 1	إبَاحَةِ أَكْلِ
u'إبَاحَةٌ أَكْلٌ':Added, #1: 1	إبَاحَةُ أَكْلِ
u'إبَاحَةٌ أكل':Added, #1: 1	إبَاحَةِ أَكْلِ
u'إبَاحَةٌ أكل':Added, #2: 2	إبَاحَةَ الْأَكْلِ
u'إبَاحَةٌ أَكْلٌ':Added, #2: 2	إبَاحَةُ الْأَكْلِ
u'إبَاحَةٌ أَكْلٌ':Added, #2: 2	إبَاحَةَ الْأَكْلِ
u'إبَاحَةٌ أكل':Added, #2: 2	إبَاحَةُ الْأَكْلِ
u'إبَاحَةٌ أَكْلٌ':Added, #4: 4	إبَاحَةِ الْأَكْلِ
u'إبَاحَةٌ الْمَرْأَةُ':Added, #4: 4	إبَاحَةِ الْأَكْلِ
u'إبَاحَةٌ أَمْوَالٌ':Added, #1: 1	إبَاحَةِ الْمَرْأَةِ
u'إبَاحَةٌ أَمْوَالٌ':Added, #1: 1	إبَاحَةَ الْأَمْوَالِ
u'إبَاحَةٌ إيقَاعٌ':Added, #1: 1	إبَاحَةَ أَمْوَالِ
u'إبَاحَةٌ إيقَاعٌ':Added, #1: 1	إبَاحَةُ الْإِيقَاعِ
u'إبَاحَةٌ إيقَاعٌ':Added, #1: 1	إبَاحَةِ إيقَاعٍ
u'إبَاحَةٌ بَعْضٌ':Added, #5: 5	إبَاحَةَ الْإِيقَاعِ
u'إبَاحَةٌ بَقِيَّةٌ':Added, #1: 1	إبَاحَةُ بَعْضِ
u'إبَاحَةٌ بِنَاءٌ':Added, #1: 1	إبَاحَةُ بَقِيَّةِ
u'إبَاحَةٌ بَنْجٌ':Added, #1: 1	إبَاحَةِ الْبِنَاءِ
u'إبَاحَةٌ بَهيمٌ':Added, #2: 2	إبَاحَةِ الْبَنْجِ
u'إبَاحَةٌ بَهِيمَةٌ':Added, #1: 1	إبَاحَةِ بَهِيمَةِ
u'إبَاحَةٌ بَوْلٌ':Added, #1: 1	إبَاحَةِ بَهِيمَةِ
u'إبَاحَةٌ بَيْعٌ':Added, #1: 1	إبَاحَةَ الْبَوْلِ
u'إبَاحَةٌ بَيْعٌ':Added, #1: 1	إبَاحَةُ الْبَيْعِ
u'إبَاحَةٌ بَيْعٌ':Added, #1: 1	إبَاحَةِ الْبَيْعِ
u'إبَاحَةٌ بَيْعٌ':Added, #1: 1	إبَاحَةَ بَيْعِ
u'إبَاحَةٌ تَأْخِيرٌ':Added, #3: 3	إبَاحَةُ بَيْعِ
u'إبَاحَةٌ تَأْخِيرٌ':Added, #1: 1	إبَاحَةِ التَّأْخِيرِ
u'إبَاحَةٌ تِجَارَةٌ':Added, #1: 1	إبَاحَةِ تَأْخِيرِ
u'إبَاحَةٌ تَحَلُّلٌ':Added, #1: 1	إبَاحَةَ التِّجَارَةِ
u'إبَاحَةٌ تَحَلُّلٌ':Added, #1: 1	إبَاحَةِ التَّحَلُّلِ
u'إبَاحَةٌ تَحْلِيَةٌ':Added, #2: 2	إبَاحَةُ التَّحَلُّلِ
u'إبَاحَةٌ تَحْلِيَةٌ':Added, #1: 1	إبَاحَةُ تَحْلِيَةِ
u'إبَاحَةٌ تَرْخِيصٌ':Added, #1: 1	إبَاحَةِ تَحْلِيَتِهِ
u'إبَاحَةٌ تَرْكٌ':Added, #1: 1	إبَاحَةِ التَّرْخِيصِ
u'إبَاحَةٌ تَصَرُّفٌ':Added, #1: 1	إبَاحَةِ تَرْكِ
u'إبَاحَةٌ تَطَهُّرٌ':Added, #1: 1	إبَاحَةُ التَّصَرُّفِ
u'إبَاحَةٌ تَفَاؤُلٌ':Added, #1: 1	إبَاحَةِ التَّطَهُّرِ
u'إبَاحَةٌ تَفْرِيقٌ':Added, #1: 1	إبَاحَةُ التّفَاؤُلِ
u'إبَاحَةٌ تَمَلُّك':Added, #2: 2	إبَاحَةِ التَّفْرِيقِ
u'إبَاحَةٌ تَنَاوُلٌ':Added, #1: 1	إبَاحَةَ التَّمَلُّكِ
u'إبَاحَةٌ تَنَاوُلٌ':Added, #1: 1	إبَاحَةِ التَّنَاوُلِ
u'إبَاحَةٌ تَنَاوُلٌ':Added, #1: 1	إبَاحَةِ تَنَاوُلِ
u'إبَاحَةٌ تَيَمُّمٌ':Added, #2: 2	إبَاحَةُ تَنَاوُلِهِ
u'إبَاحَةٌ ثَانِي':Added, #1: 1	إبَاحَةِ التَّيَمُّمِ
u'إبَاحَةٌ ثَانِيَةٌ':Added, #1: 1	إبَاحَةِ الثَّانِيَةِ
u'إبَاحَةٌ ثِيابٌ':Added, #1: 1	إبَاحَةِ الثَّانِيَةِ
u'إبَاحَةٌ جلد':Added, #1: 1	إبَاحَةَ الثِّيَابِ
u'إبَاحَةٌ جِلْدٌ':Added, #1: 1	إبَاحَةُ جِلْدِهِ
u'إبَاحَةٌ جُلُوسٌ':Added, #1: 1	إبَاحَةُ جِلْدِهِ
u'إبَاحَةٌ جماع':Added, #1: 1	إبَاحَةِ جُلُوسِ
u'إبَاحَةٌ جِمَاعٌ':Added, #1: 1	إبَاحَةِ جِمَاعِ
u'إبَاحَةٌ جُمْلَةٌ':Added, #1: 1	إبَاحَةِ جِمَاعِ
u'إبَاحَةٌ حَرامٌ':Added, #1: 1	إبَاحَةِ الْجُمْلَةِ
u'إبَاحَةٌ حَرِيرٌ':Added, #1: 1	إبَاحَةِ الْحَرَامِ
u'إبَاحَةٌ حسد':Added, #1: 1	إبَاحَةِ الْحَرِيرِ
u'إبَاحَةٌ حسد':Added, #1: 1	إبَاحَةُ الْحَسَدِ
u'إبَاحَةٌ حَسَدٌ':Added, #1: 1	إبَاحَةِ الْحَسَدِ
u'إبَاحَةٌ حَسَدٌ':Added, #1: 1	إبَاحَةُ الْحَسَدِ
u'إبَاحَةٌ حَلْقٌ':Added, #1: 1	إبَاحَةِ الْحَسَدِ
u'إبَاحَةٌ حَلِيلَةٌ':Added, #1: 1	إبَاحَةِ الْحَلْقِ
u'إبَاحَةٌ حَيٌّ':Added, #1: 1	إبَاحَةِ حَلِيلَةِ
u'إبَاحَةٌ حَيَّةٌ':Added, #3: 3	إبَاحَةُ الْحَيَّةِ
u'إبَاحَةٌ حِيلَةٌ':Added, #3: 3	إبَاحَةُ الْحَيَّةِ
u'إبَاحَةٌ حَيَوَانٌ':Added, #1: 1	إبَاحَةِ الْحِيلَةِ
u'إبَاحَةٌ حَيَوَانٌ':Added, #1: 1	إبَاحَةَ الْحَيَوَانِ
u'إبَاحَةٌ ختان':Added, #1: 1	إبَاحَةِ الْحَيَوَانِ
u'إبَاحَةٌ خِتَانٌ':Added, #2: 2	إبَاحَةَ الْخِتَانِ
u'إبَاحَةٌ خرق':Added, #2: 2	إبَاحَةَ الْخِتَانِ
u'إبَاحَةٌ خَرْقٌ':Added, #1: 1	إبَاحَةُ خَرْقِ
u'إبَاحَةٌ خُرُوجٌ':Added, #1: 1	إبَاحَةُ خَرْقِ
u'إبَاحَةٌ خَزٌّ':Added, #2: 2	إبَاحَةِ الْخُرُوجِ
u'إبَاحَةٌ خَيْلٌ':Added, #1: 1	إبَاحَةُ الْخَزِّ
u'إبَاحَةٌ دُخُولٌ':Added, #1: 1	إبَاحَةِ الْخَيْلِ
u'إبَاحَةٌ دُخُولٌ':Added, #1: 1	إبَاحَةَ دُخُولِ
u'إبَاحَةٌ دُخُولٌ':Added, #1: 1	إبَاحَةُ دُخُولِ
u'إبَاحَةٌ دُخُولٌ':Added, #1: 1	إبَاحَةِ دُخُولِهِ
u'إبَاحَةٌ دفع':Added, #3: 3	إبَاحَةِ الدُّخُولِ
u'إبَاحَةٌ دَفْعٌ':Added, #2: 2	إبَاحَةَ الدَّفْعِ
u'إبَاحَةٌ دَمٌ':Added, #2: 2	إبَاحَةَ الدَّفْعِ
u'إبَاحَةٌ دَمٌ':Added, #1: 1	إبَاحَةُ دَمِهِ
u'إبَاحَةٌ دَيْنٌ':Added, #4: 4	إبَاحَةِ الدَّمِ
u'إبَاحَةٌ ذَبائِحُ':Added, #1: 1	إبَاحَةِ الدَّيْنِ
u'إبَاحَةٌ ذَبيحٌ':Added, #1: 1	إبَاحَةَ ذَبَائِحِ
u'إبَاحَةٌ ذَبيحَةٌ':Added, #1: 1	إبَاحَةَ ذَبِيحَةِ
u'إبَاحَةٌ ذِمِّيٌّ':Added, #1: 1	إبَاحَةَ ذَبِيحَةِ
u'إبَاحَةٌ ذَهَبٌ':Added, #1: 1	إبَاحَةَ الذِّمِّيَّةِ
u'إبَاحَةٌ رجعة':Added, #1: 1	إبَاحَةُ الذَّهَبِ
u'إبَاحَةٌ رَجْعَةٌ':Added, #2: 2	إبَاحَةِ الرَّجْعَةِ
u'إبَاحَةٌ رَجِيعٌ':Added, #2: 2	إبَاحَةِ الرَّجْعَةِ
u'إبَاحَةٌ رُسُلٌ':Added, #1: 1	إبَاحَةُ رَجِيعِ
u'إبَاحَةٌ ركعة':Added, #1: 1	إبَاحَةُ الرّسُلِ
u'إبَاحَةٌ رَكْعَةٌ':Added, #1: 1	إبَاحَةَ الرَّكْعَةِ
u'إبَاحَةٌ زَوْجٌ':Added, #1: 1	إبَاحَةَ الرَّكْعَةِ
u'إبَاحَةٌ سَبَبٌ':Added, #1: 1	إبَاحَةُ الزَّوْجِ
u'إبَاحَةٌ سَبَبٌ':Added, #1: 1	إبَاحَةِ السَّبَبِ
u'إبَاحَةٌ سِحْرٌ':Added, #2: 2	إبَاحَةُ السَّبَبِ
u'إبَاحَةٌ سَفَرٌ':Added, #1: 1	إبَاحَةُ السِّحْرِ
u'إبَاحَةٌ سَفَرٌ':Added, #1: 1	إبَاحَةُ السَّفَرِ
u'إبَاحَةٌ سَمَكٌ':Added, #3: 3	إبَاحَةَ السَّفَرِ
u'إبَاحَةٌ سِنْجَابٌ':Added, #1: 1	إبَاحَةِ السَّمَكِ
u'إبَاحَةٌ شرب':Added, #1: 1	إبَاحَةِ السِّنْجَابِ
u'إبَاحَةٌ شُرْبٌ':Added, #1: 1	إبَاحَةِ الشُّرْبِ
u'إبَاحَةٌ شرب':Added, #1: 1	إبَاحَةِ الشُّرْبِ
u'إبَاحَةٌ شُرْبٌ':Added, #1: 1	إبَاحَةَ شُرْبِ
u'إبَاحَةٌ شرب':Added, #1: 1	إبَاحَةَ شُرْبِ
u'إبَاحَةٌ شُرْبٌ':Added, #1: 1	إبَاحَةُ شُرْبِهِ
u'إبَاحَةٌ شَيْءٌ':Added, #1: 1	إبَاحَةُ شُرْبِهِ
u'إبَاحَةٌ شَيْءٌ':Added, #1: 1	إبَاحَةُ الشَّيْءِ
u'إبَاحَةٌ شَيْءٌ':Added, #1: 1	إبَاحَةَ شَيْءٍ
u'إبَاحَةٌ صَلاَةٌ':Added, #2: 2	إبَاحَةِ شَيْءٍ
u'إبَاحَةٌ صَلاَةٌ':Added, #2: 2	إبَاحَةَ الصَّلَاةِ
u'إبَاحَةٌ صَلاَةٌ':Added, #3: 3	إبَاحَةُ الصَّلَاةِ
u'إبَاحَةٌ صَيْدٌ':Added, #6: 6	إبَاحَةِ الصَّلَاةِ
u'إبَاحَةٌ صَيْدٌ':Added, #1: 1	إبَاحَةُ الصَّيْدِ
u'إبَاحَةٌ ضَبٌّ':Added, #3: 3	إبَاحَةِ الصَّيْدِ
u'إبَاحَةٌ ضَرْبٌ':Added, #1: 1	إبَاحَةَ الضَّبِّ
u'إبَاحَةٌ ضَرُورَةٌ':Added, #1: 1	إبَاحَةُ الضَّرْبِ
u'إبَاحَةٌ طعام':Added, #1: 1	إبَاحَةِ ضَرُورَةِ
u'إبَاحَةٌ طَعَامٌ':Added, #1: 1	إبَاحَةِ الطَّعَامِ
u'إبَاحَةٌ طَلاَقٌ':Added, #1: 1	إبَاحَةِ الطَّعَامِ
u'إبَاحَةٌ طَلاَقٌ':Added, #1: 1	إبَاحَةَ الطَّلَاقِ
u'إبَاحَةٌ طواف':Added, #1: 1	إبَاحَةُ الطَّلَاقِ
u'إبَاحَةٌ طواف':Added, #1: 1	إبَاحَةَ الطَّوَافِ
u'إبَاحَةٌ طَوَافٌ':Added, #1: 1	إبَاحَةِ الطَّوَافِ
u'إبَاحَةٌ طَوَافٌ':Added, #1: 1	إبَاحَةَ الطَّوَافِ
u'إبَاحَةٌ عُبُورٌ':Added, #1: 1	إبَاحَةِ الطَّوَافِ
u'إبَاحَةٌ عَدَدٌ':Added, #1: 1	إبَاحَةَ الْعُبُورِ
u'إبَاحَةٌ عَقْدٌ':Added, #3: 3	إبَاحَةِ الْعَدَدِ
u'إبَاحَةٌ عَقْدٌ':Added, #1: 1	إبَاحَةُ الْعَقْدِ
u'إبَاحَةٌ عَقْلٌ':Added, #1: 1	إبَاحَةُ عَقْدٍ
u'إبَاحَةٌ علم':Added, #1: 1	إبَاحَةَ الْعَقْلِ
u'إبَاحَةٌ عَلَمٌ':Added, #1: 1	إبَاحَةِ الْعَلَمِ
u'إبَاحَةٌ عَمَلٌ':Added, #1: 1	إبَاحَةِ الْعَلَمِ
u'إبَاحَةٌ غُسْلٌ':Added, #1: 1	إبَاحَةِ الْعَمَلِ
u'إبَاحَةٌ غناء':Added, #1: 1	إبَاحَةَ الْغُسْلِ
u'إبَاحَةٌ غِنَاءٌ':Added, #1: 1	إبَاحَةِ الْغِنَاءِ
u'إبَاحَةٌ غير':Added, #1: 1	إبَاحَةِ الْغِنَاءِ
u'إبَاحَةٌ غير':Added, #1: 1	إبَاحَةُ غَيْرِ
u'إبَاحَةٌ غَيْرٌ':Added, #1: 1	إبَاحَةِ غَيْرِ
u'إبَاحَةٌ غَيْرٌ':Added, #1: 1	إبَاحَةُ غَيْرِ
u'إبَاحَةٌ فَرْجٌ':Added, #1: 1	إبَاحَةِ غَيْرِ
u'إبَاحَةٌ فِطْرٌ':Added, #2: 2	إبَاحَةِ الْفَرْجِ
u'إبَاحَةٌ فِطْرٌ':Added, #2: 2	إبَاحَةَ الْفِطْرِ
u'إبَاحَةٌ قتال':Added, #3: 3	إبَاحَةِ الْفِطْرِ
u'إبَاحَةٌ قِتَالٌ':Added, #1: 1	إبَاحَةِ الْقِتَالِ
u'إبَاحَةٌ قتل':Added, #1: 1	إبَاحَةِ الْقِتَالِ
u'إبَاحَةٌ قَتْلٌ':Added, #1: 1	إبَاحَةِ الْقَتْلِ
u'إبَاحَةٌ قتل':Added, #1: 1	إبَاحَةِ الْقَتْلِ
u'إبَاحَةٌ قتل':Added, #1: 1	إبَاحَةَ قَتْلِ
u'إبَاحَةٌ قَتْلٌ':Added, #1: 1	إبَاحَةُ قَتْلِ
u'إبَاحَةٌ قَتْلٌ':Added, #1: 1	إبَاحَةَ قَتْلِ
u'إبَاحَةٌ قتل':Added, #1: 1	إبَاحَةُ قَتْلِ
u'إبَاحَةٌ قَتْلٌ':Added, #1: 1	إبَاحَةَ قَتْلِهِ
u'إبَاحَةٌ قتل':Added, #1: 1	إبَاحَةَ قَتْلِهِ
u'إبَاحَةٌ قَتْلٌ':Added, #2: 2	إبَاحَةَ الْقَتْلِ
u'إبَاحَةٌ قتل':Added, #2: 2	إبَاحَةَ الْقَتْلِ
u'إبَاحَةٌ قَتْلٌ':Added, #4: 4	إبَاحَةِ قَتْلِ
u'إبَاحَةٌ قِرَاءةٌ':Added, #4: 4	إبَاحَةِ قَتْلِ
u'إبَاحَةٌ قِرَاءةٌ':Added, #1: 1	إبَاحَةُ الْقِرَاءَةِ
u'إبَاحَةٌ قِرَاءةٌ':Added, #1: 1	إبَاحَةِ قِرَاءَةِ
u'إبَاحَةٌ قَصْرٌ':Added, #1: 1	إبَاحَةِ قِرَاءَتِهِ
u'إبَاحَةٌ قَضَاءٌ':Added, #1: 1	إبَاحَةِ الْقَصْرِ
u'إبَاحَةٌ قَطْعٌ':Added, #1: 1	إبَاحَةُ الْقَضَاءِ
u'إبَاحَةٌ قَطْعٌ':Added, #1: 1	إبَاحَةِ قَطْعِهِ
u'إبَاحَةٌ قِمَارٌ':Added, #2: 2	إبَاحَةِ الْقَطْعِ
u'إبَاحَةٌ كِتاب':Added, #1: 1	إبَاحَةِ الْقِمَارِ
u'إبَاحَةٌ كِتابَة':Added, #1: 1	إبَاحَةِ الْكِتَابِيَّةِ
u'إبَاحَةٌ كِتابِيّ':Added, #1: 1	إبَاحَةِ الْكِتَابِيَّةِ
u'إبَاحَةٌ كذب':Added, #1: 1	إبَاحَةِ الْكِتَابِيَّةِ
u'إبَاحَةٌ كَذِبٌ':Added, #1: 1	إبَاحَةِ الْكَذِبِ
u'إبَاحَةٌ كَسْرٌ':Added, #1: 1	إبَاحَةِ الْكَذِبِ
u'إبَاحَةٌ كَسْرٌ':Added, #1: 1	إبَاحَةُ الْكَسْرِ
u'إبَاحَةٌ كَلاَمٌ':Added, #2: 2	إبَاحَةِ الْكَسْرِ
u'إبَاحَةٌ كَلاَمٌ':Added, #1: 1	إبَاحَةُ كَلَامِ
u'إبَاحَةٌ كِيسٌ':Added, #2: 2	إبَاحَةِ الْكَلَامِ
u'إبَاحَةٌ لبس':Added, #1: 1	إبَاحَةَ كِيسِ
u'إبَاحَةٌ لُبْسٌ':Added, #1: 1	إبَاحَةُ لُبْسِ
u'إبَاحَةٌ لبس':Added, #1: 1	إبَاحَةُ لُبْسِ
u'إبَاحَةٌ لُبْسٌ':Added, #1: 1	إبَاحَةُ لُبْسِهِ
u'إبَاحَةٌ لبس':Added, #1: 1	إبَاحَةُ لُبْسِهِ
u'إبَاحَةٌ لُبْسٌ':Added, #4: 4	إبَاحَةِ لُبْسِ
u'إبَاحَةٌ لَحْمٌ':Added, #4: 4	إبَاحَةِ لُبْسِ
u'إبَاحَةٌ لُحُومٌ':Added, #2: 2	إبَاحَةِ اللَّحْمِ
u'إبَاحَةٌ لعب':Added, #1: 1	إبَاحَةِ لُحُومِ
u'إبَاحَةٌ لعب':Added, #1: 1	إبَاحَةَ اللَّعِبِ
u'إبَاحَةٌ لَعِبٌ':Added, #1: 1	إبَاحَةِ اللُّعَبِ
u'إبَاحَةٌ لُعَبٌ':Added, #1: 1	إبَاحَةَ اللَّعِبِ
u'إبَاحَةٌ مَاءٌ':Added, #1: 1	إبَاحَةِ اللُّعَبِ
u'إبَاحَةٌ مَأْكُولٌ':Added, #2: 2	إبَاحَةُ الْمَاءِ
u'إبَاحَةٌ مَالٌ':Added, #1: 1	إبَاحَةِ الْمَأْكُولِ
u'إبَاحَةٌ مَالٌ':Added, #1: 1	إبَاحَةَ الْمَالِ
u'إبَاحَةٌ مُبَاشَرَةٌ':Added, #1: 1	إبَاحَةِ مَالِ
u'إبَاحَةٌ مُبَاشَرَةٌ':Added, #1: 1	إبَاحَةُ الْمُبَاشَرَةِ
u'إبَاحَةٌ مُبَاشَرَةٌ':Added, #1: 1	إبَاحَةِ الْمُبَاشَرَةِ
u'إبَاحَةٌ مَتْرُوكٌ':Added, #2: 2	إبَاحَةَ الْمُبَاشَرَةِ
u'إبَاحَةٌ مُجِيزٌ':Added, #1: 1	إبَاحَةِ مَتْرُوكِ
u'إبَاحَةٌ مُحَرَّمٌ':Added, #1: 1	إبَاحَةُ الْمُجِيزِ
u'إبَاحَةٌ مُحَرَّمٌ':Added, #1: 1	إبَاحَةُ مُحَرَّمٍ
u'إبَاحَةٌ مَحْظُورٌ':Added, #2: 2	إبَاحَةُ الْمُحَرَّمِ
u'إبَاحَةٌ مَحْظُورٌ':Added, #1: 1	إبَاحَةِ مَحْظُورَاتِ
u'إبَاحَةٌ مَسْحٌ':Added, #2: 2	إبَاحَةُ الْمَحْظُورِ
u'إبَاحَةٌ مُشَاوَرَةٌ':Added, #1: 1	إبَاحَةِ الْمَسْحِ
u'إبَاحَةٌ مُصَابٌ':Added, #1: 1	إبَاحَةُ مُشَاوَرَةِ
u'إبَاحَةٌ مَطَرٌ':Added, #1: 1	إبَاحَةَ الْمُصَابِ
u'إبَاحَةٌ مَعَارِيضُ':Added, #1: 1	إبَاحَةِ الْمَطَرِ
u'إبَاحَةٌ مُعَامَلَةٌ':Added, #1: 1	إبَاحَةِ الْمَعَارِيضِ
u'إبَاحَةٌ مَقْصِدٌ':Added, #1: 1	إبَاحَةُ الْمُعَامَلَةِ
u'إبَاحَةٌ مُلاَمَسَةٌ':Added, #1: 1	إبَاحَةِ مَقْصِدِهِ
u'إبَاحَةٌ مَنَافِعُ':Added, #1: 1	إبَاحَةَ الْمُلَامَسَةِ
u'إبَاحَةٌ مَنَافِعُ':Added, #3: 3	إبَاحَةُ الْمَنَافِعِ
u'إبَاحَةٌ مَنْفَعَةٌ':Added, #3: 3	إبَاحَةِ مَنَافِعِ
u'إبَاحَةٌ مَنْفَعَةٌ':Added, #2: 2	إبَاحَةَ مَنْفَعَةٍ
u'إبَاحَةٌ مَيْتٌ':Added, #9: 9	إبَاحَةُ مَنْفَعَةٍ
u'إبَاحَةٌ مَيْتٌ':Added, #1: 1	إبَاحَةُ الْمَيْتَةِ
u'إبَاحَةٌ مَيْتٌ':Added, #1: 1	إبَاحَةِ الْمَيْتَةِ
u'إبَاحَةٌ مَيْتَةٌ':Added, #3: 3	إبَاحَةَ الْمَيْتَةِ
u'إبَاحَةٌ مَيْتَةٌ':Added, #1: 1	إبَاحَةُ الْمَيْتَةِ
u'إبَاحَةٌ مَيْتَةٌ':Added, #1: 1	إبَاحَةِ الْمَيْتَةِ
u'إبَاحَةٌ نَبِيٌّ':Added, #3: 3	إبَاحَةَ الْمَيْتَةِ
u'إبَاحَةٌ نَبِيذٌ':Added, #1: 1	إبَاحَةِ النَّبِيِّ
u'إبَاحَةٌ نَبِيذٌ':Added, #2: 2	إبَاحَةَ النَّبِيذِ
u'إبَاحَةٌ نِساءٌ':Added, #3: 3	إبَاحَةِ النَّبِيذِ
u'إبَاحَةٌ نشرة':Added, #1: 1	إبَاحَةِ النِّسَاءِ
u'إبَاحَةٌ نَشْرَةٌ':Added, #1: 1	إبَاحَةُ النّشْرَةِ
u'إبَاحَةٌ نُشْرَةٌ':Added, #1: 1	إبَاحَةُ النّشْرَةِ
u'إبَاحَةٌ نِصْفٌ':Added, #1: 1	إبَاحَةُ النّشْرَةِ
u'إبَاحَةٌ نُطْقٌ':Added, #1: 1	إبَاحَةِ النِّصْفِ
u'إبَاحَةٌ نَظَرٌ':Added, #2: 2	إبَاحَةِ النُّطْقِ
u'إبَاحَةٌ نَظَرٌ':Added, #1: 1	إبَاحَةُ نَظَرِ
u'إبَاحَةٌ نَظَرٌ':Added, #1: 1	إبَاحَةِ نَظَرِ
u'إبَاحَةٌ نَظَرٌ':Added, #2: 2	إبَاحَةِ النَّظَرِ
u'إبَاحَةٌ نَظَرٌ':Added, #5: 5	إبَاحَةَ النَّظَرِ
u'إبَاحَةٌ نَفَقَةٌ':Added, #5: 5	إبَاحَةُ النَّظَرِ
u'إبَاحَةٌ نَفْلٌ':Added, #1: 1	إبَاحَةُ النَّفَقَةِ
u'إبَاحَةٌ نكاح':Added, #2: 2	إبَاحَةِ النَّفْلِ
u'إبَاحَةٌ نِكَاحٌ':Added, #1: 1	إبَاحَةُ النِّكَاحِ
u'إبَاحَةٌ نكاح':Added, #1: 1	إبَاحَةُ النِّكَاحِ
u'إبَاحَةٌ نِكَاحٌ':Added, #1: 1	إبَاحَةُ نِكَاحِ
u'إبَاحَةٌ نكاح':Added, #1: 1	إبَاحَةُ نِكَاحِ
u'إبَاحَةٌ نكاح':Added, #1: 1	إبَاحَةَ نِكَاحِهِ
u'إبَاحَةٌ نِكَاحٌ':Added, #1: 1	إبَاحَةُ نِكَاحِهِ
u'إبَاحَةٌ نِكَاحٌ':Added, #1: 1	إبَاحَةَ نِكَاحِهِ
u'إبَاحَةٌ نكاح':Added, #1: 1	إبَاحَةُ نِكَاحِهِ
u'إبَاحَةٌ نِكَاحٌ':Added, #4: 4	إبَاحَةِ نِكَاحِ
u'إبَاحَةٌ هجر':Added, #4: 4	إبَاحَةِ نِكَاحِ
u'إبَاحَةٌ هَجْرٌ':Added, #2: 2	إبَاحَةُ الْهَجْرِ
u'إبَاحَةٌ وَطْءٌ':Added, #2: 2	إبَاحَةُ الْهَجْرِ
u'إبَاحَةٌ وَطْءٌ':Added, #1: 1	إبَاحَةِ الْوَطْءِ
u'إبَاحَةٌ وَطْءٌ':Added, #1: 1	إبَاحَةَ وَطْءٍ
u'إبَاحَةٌ وَطْءٌ':Added, #1: 1	إبَاحَةَ وَطْءِ
u'إبَاحَةٌ وَطْءٌ':Added, #1: 1	إبَاحَةُ وَطْءِ
u'إبَاحَةٌ يَسِيرٌ':Added, #3: 3	إبَاحَةَ الْوَطْءِ
u'إبَاحَةٌ يَسِيرٌ':Added, #1: 1	إبَاحَةِ الْيَسِيرَةِ
u'إبَاحَةٌ يَسِيرٌ':Added, #2: 2	إبَاحَةِ الْيَسِيرِ
u'أَبَاحَ تَبَرُّعٌ':Predicate, #3: 3	إبَاحَةَ يَسِيرِ
u'أَبَاحَ تَحَلُّقٌ':Predicate, #1: 1	أَبَاحَ التَّبَرُّعَ
u'أَبَاحَ تَرْكٌ':Predicate, #1: 1	أَبَاحَ التَّحَلُّقَ
u'أَبَاحَ تَسْمِيَة':Predicate, #2: 2	أَبَاحَ تَرْكَ
u'أَبَاحَ تَمْلِيك':Predicate, #1: 1	أَبَاحَ التَّسْمِيَةَ
u'أَبَاحَ تَيَمُّمٌ':Predicate, #1: 1	أَبَاحَ التَّمْلِيكَ
u'أَبَاحَ تَيَمُّمٌ':Subject, #1: 1	أَبَاحَ التَّيَمُّمَ
u'أَبَاحَ تَيَمُّمٌ':Subject, #1: 1	أَبَاحَ تَيَمُّمُهُ
u'أَبَاحَ ثِمارٌ':Predicate, #2: 2	أَبَاحَ التَّيَمُّمُ
u'أَبَاحَ جلد':Predicate, #1: 1	أَبَاحَ ثِمَارَ
u'أَبَاحَ جَلْدٌ':Predicate, #1: 1	أَبَاحَ جَلْدَ
u'أَبَاحَ جماع':Predicate, #1: 1	أَبَاحَ جَلْدَ
u'أَبَاحَ جِمَاعٌ':Predicate, #1: 1	أَبَاحَ الْجِمَاعَ
u'أَبَاحَ جمع':Predicate, #1: 1	أَبَاحَ الْجِمَاعَ
u'أَبَاحَ جَمْعٌ':Predicate, #1: 1	أَبَاحَ الْجَمْعَ
u'أَبَاحَ خطبة':Predicate, #1: 1	أَبَاحَ الْجَمْعَ
u'أَبَاحَ خِطْبَةٌ':Predicate, #1: 1	أَبَاحَ الْخِطْبَةَ
u'أَبَاحَ دُخُولٌ':Predicate, #1: 1	أَبَاحَ الْخِطْبَةَ
u'أَبَاحَ ذَرائِعُ':Predicate, #1: 1	أَبَاحَ الدُّخُولَ
u'أَبَاحَ رَاهِنٌ':Subject, #1: 1	أَبَاحَ الذَّرَائِعَ
u'أَبَا حَزْر':Predicate, #1: 1	أَبَاحَ الرَّاهِنُ
u'أَبَاحَ سُلْطَانٌ':Subject, #2: 2	أَبَا حَزْرَةَ
u'أَبَاحَ سُؤَالٌ':Predicate, #3: 3	أَبَاحَ السُّلْطَانُ
u'أَبَاحَ سَيِّدٌ':Subject, #1: 1	أَبَاحَ السُّؤَالَ
u'أَبَاحَ شَارِعٌ':Subject, #1: 1	أَبَاحَ السَّيِّدُ
u'أَبَاحَ شَحْمٌ':Predicate, #1: 1	أَبَاحَ الشَّارِعُ
u'أَبَاحَ شَرْعٌ':Subject, #1: 1	أَبَاحَ الشَّحْمَ
u'أَبَاحَ شَيْءٌ':Predicate, #2: 2	أَبَاحَ الشَّرْعُ
u'أَبَاحَ صَبِيٌّ':Predicate, #1: 1	أَبَاحَ الشَّيْءَ
u'أَبَاحَ صَيْدٌ':Predicate, #1: 1	أَبَاحَ الصَّبِيَّ
u'أَبَاحَ طَلاَقٌ':Predicate, #1: 1	أَبَاحَ صَيْدَ
u'أَبَاحَ فِطْرٌ':Predicate, #1: 1	أَبَاحَ الطَّلاَقَ
u'أَبَاحَ فَقِيرٌ':Subject, #1: 1	أَبَاحَ الْفِطْرَ
u'أَبَاحَ قذف':Predicate, #4: 4	أَبَاحَ الْفَقِيرُ
u'أَبَاحَ قَذْفٌ':Predicate, #1: 1	أَبَاحَ الْقَذْفَ
u'أَبَاحَ قَصْرٌ':Predicate, #1: 1	أَبَاحَ الْقَذْفَ
u'أَبَاحَ قَفَّالٌ':Subject, #2: 2	أَبَاحَ الْقَصْرَ
u'أَبَاحَ قَلِيلٌ':Predicate, #1: 1	أَبَاحَ الْقَفَّالُ
u'أَبَاحَ لِبَاسٌ':Predicate, #1: 1	أَبَاحَ الْقَلِيلَ
u'أَبَا حَلِيم':Predicate, #2: 2	أَبَاحَ لِبَاسَ
u'أَبَا حُمَةٌ':Predicate, #1: 1	أَبَا حَلِيمَةَ
u'أَبَاحَ مُتْعَةٌ':Predicate, #1: 1	أَبَا حُمَةَ
u'أَبَا حَمْز':Predicate, #3: 3	أَبَاحَ الْمُتْعَةَ
u'أَبَاحَ مَسٌّ':Predicate, #26: 26	أَبَا حَمْزَةَ
u'أَبَاحَ مُسْكِرٌ':Predicate, #1: 1	أَبَاحَ الْمَسَّ
u'أَبَاحَ مُطَلَّقٌ':Predicate, #3: 3	أَبَاحَ الْمُسْكِرَ
u'أَبَاحَ نَبِيٌّ':Subject, #1: 1	أَبَاحَ الْمُطَلَّقَةَ
u'أَبَاحَ نَظَرٌ':Predicate, #2: 2	أَبَاحَ النَّبِيُّ
u'أَبَا حَنْظَلٌ':Predicate, #1: 1	أَبَاحَ النَّظَرَ
u'أَبَاحَ نكاح':Predicate, #5: 5	أَبَا حَنْظَلَةَ
u'أَبَاحَ نِكَاحٌ':Predicate, #3: 3	أَبَاحَ نِكَاحَ
u'أَبَا حَنِيفٌ':Predicate, #3: 3	أَبَاحَ نِكَاحَ
u'أَبَاحَ وَطْءٌ':Predicate, #291: 291	أَبَا حَنِيفَةَ
u'أَبَا خِزام':Predicate, #2: 2	أَبَاحَ الْوَطْءَ
u'أَبَا خلدة':Predicate, #1: 1	أَبَا خِزَامَةَ
u'أَبَا رَيْحانٌ':Predicate, #1: 1	أَبَا خَلْدَةَ
u'أَبَا زرعة':Predicate, #1: 1	أَبَا رَيْحَانَةَ
u'أَبَا سَبْر':Predicate, #19: 19	أَبَا زُرْعَةَ
u'أَبَا سَعْد':Predicate, #1: 1	أَبَا سَبْرَةَ
u'أَبَا سَكِينَةٌ':Predicate, #2: 2	أَبَا سَعْدَةَ
u'أَبَا سَلاَمَةٌ':Predicate, #1: 1	أَبَا سَكِينَةَ
u'أَبَا سلمة':Predicate, #1: 1	أَبَا سَلَامَةَ
u'أَبَا سَيَّارٌ':Predicate, #46: 46	أَبَا سَلَمَةَ
u'أَبَا سَيَّارَةٌ':Predicate, #3: 3	أَبَا سَيّارَةَ
u'أَبَا شَيْبَةٌ':Predicate, #3: 3	أَبَا سَيّارَةَ
u'أَبَا صَالِحٌ':Subject, #2: 2	أَبَا شَيْبَةَ
u'أَبَا صَالِح':Subject, #1: 1	أَبَا صَالِحٌ
u'أَبَا صَخْرَةٌ':Predicate, #1: 1	أَبَا صَالِحٌ
u'أَبَا صرمة':Predicate, #1: 1	أَبَا صَخْرَةَ
u'أَبَا صَفْوَان':Predicate, #2: 2	أَبَا صِرْمَةَ
u'أَبَا طعمة':Predicate, #3: 3	أَبَا صَفْوَانَ
u'أَبَا طُعْمَةٌ':Predicate, #1: 1	أَبَا طُعْمَةَ
u'أَبَا طَلْحٌ':Predicate, #1: 1	أَبَا طُعْمَةَ
u'أَبَا طلحة':Predicate, #51: 51	أَبَا طَلْحَةَ
u'أَبَا طَيِّبٌ':Predicate, #51: 51	أَبَا طَلْحَةَ
u'أَبَا طِيبَةٌ':Predicate, #7: 7	أَبَا الطَّيِّبَ
u'أَبَا عَائِشٌ':Predicate, #1: 1	أَبَا طِيبَةَ
u'أَبَا عَبَّاسٌ':Predicate, #1: 1	أَبَا عَائِشَةَ
u'أَبَا عَبْدٌ':Predicate, #1: 1	أَبَا الْعَبَّاسَ
u'أَبَا عَبْدٌ':Subject, #8: 8	أَبَا عَبْدَ
u'أَبَا عتبة':Predicate, #2: 2	أَبَا عَبْدُ
u'أَبَا عُرْوَةٌ':Predicate, #3: 3	أَبَا عُتْبَةَ
u'أَبَا عَطِيَّةٌ':Predicate, #1: 1	أَبَا عُرْوَةَ
u'أَبَا عَلْقَم':Predicate, #1: 1	أَبَا عَطِيَّةَ
u'أَبَا عَلْقَمَة':Predicate, #2: 2	أَبَا عَلْقَمَةَ
u'أَبَا عُمَارَةٌ':Predicate, #2: 2	أَبَا عَلْقَمَةَ
u'أَبَا عُمَرٌ':Predicate, #7: 7	أَبَا عُمَارَةَ
u'أَبَا عِنَبٌ':Predicate, #5: 5	أَبَا عُمَرَ
u'أَبَا عَوان':Predicate, #1: 1	أَبَا عِنَبَةَ
u'أَبَا غَسَّانٌ':Predicate, #5: 5	أَبَا عَوَانَةَ
u'أَبَا فاخِت':Predicate, #1: 1	أَبَا غَسَّانَ
u'أَبَا فَرْوَةٌ':Predicate, #1: 1	أَبَا فَاخِتَةَ
u'أَبَا فَزارَة':Predicate, #1: 1	أَبَا فَرْوَةَ
u'أَبَا فلان':Predicate, #1: 1	أَبَا فَزَارَةَ
u'أَبَا فلان':Predicate, #10: 10	أَبَا حُذَيْفَةَ
u'أَبَا فلان':Predicate, #117: 117	أَبَا سُفْيَانَ
u'أَبَا فلان':Predicate, #1: 1	أَبَا الزُّبَيْرَ
u'أَبَا فلان':Predicate, #1: 1	أَبَا فَزَارَةَ
u'أَبَا فلان':Predicate, #1: 1	أَبَا مُعَاوِيَةَ
u'أَبَا فلان':Predicate, #25: 25	أَبَا عُثْمَانَ
u'أَبَا فلان':Predicate, #26: 26	أَبَا حَمْزَةَ
u'أَبَا فلان':Predicate, #2: 2	أَبَا جَعْفَرَ
u'أَبَا فلان':Predicate, #2: 2	أَبَا سَعْدَةَ
u'أَبَا فلان':Predicate, #2: 2	أَبَا هَارُونَ
u'أَبَا فلان':Predicate, #39: 39	أَبَا قَتَادَةَ
u'أَبَا فلان':Predicate, #5: 5	أَبَا دَاوُدَ
u'أَبَا فلان':Predicate, #7: 7	أَبَا مَرْيَمَ
u'أَبَا فلان':Subject, #80: 80	أَبَا عُبَيْدَةَ
u'أَبَا قَتاد':Predicate, #1: 1	أَبَا سُفْيَانُ
u'أَبَا قُتَيْبَةٌ':Predicate, #39: 39	أَبَا قَتَادَةَ
u'أَبَا قُحَافَةٌ':Predicate, #1: 1	أَبَا قُتَيْبَةَ
u'أَبَا قُرَّةٌ':Predicate, #1: 1	أَبَا قُحَافَةَ
u'أَبَا قَزَع':Predicate, #1: 1	أَبَا قُرّةَ
u'أَبَا كَبْشَةٌ':Predicate, #1: 1	أَبَا قَزَعَةَ
u'أَبَا لُبَابٌ':Predicate, #4: 4	أَبَا كَبْشَةَ
u'أَبَا مَحْذُور':Predicate, #34: 34	أَبَا لُبَابَةَ
u'أَبَا مرٌّ':Predicate, #19: 19	أَبَا مَحْذُورَةَ
u'أَبَا مرٌّ':Predicate, #1: 1	أَبَا مُرّةَ
u'أَبَا مَعَالِي':Predicate, #7: 7	أَبَا مُرَّةَ
u'أَبَا مُعاوِيَة':Predicate, #2: 2	أَبَا الْمَعَالِيَ
u'أَبَا مَيْسَرَةٌ':Predicate, #1: 1	أَبَا مُعَاوِيَةَ
u'أَبَا مَيْمُونٌ':Predicate, #2: 2	أَبَا مَيْسَرَةَ
u'أَبَانَ أَوَّلُ':Predicate, #1: 1	أَبَا مَيْمُونَةَ
u'أَبَا نَائِلٌ':Predicate, #1: 1	أَبَانَ الْأَوَّلَ
u'أَبَانَ بِنْتٌ':Subject, #3: 3	أَبَا نَائِلَةَ
u'إِبَانَةٌ قول':Added, #3: 3	أَبَانَ بِنْتُ
u'إِبَانَةٌ قَوْلٌ':Added, #1: 1	إِبَانَةِ قَوْلِهِ
u'أَبَانَ جَلٌّ':Predicate, #1: 1	إِبَانَةِ قَوْلِهِ
u'أَبَانَ خَطَأٌ':Subject, #1: 1	أَبَانَ جَلَّ
u'أَبَانَ رَأْسٌ':Predicate, #1: 1	أَبَانَ خَطَأٌ
u'أَبَانَ رَجُلٌ':Subject, #2: 2	أَبَانَ الرَّأْسَ
u'أَبَانَ رَجُلٌ':Subject, #1: 1	أَبَانَ الرَّجُلُ
u'أَبَانَ شافِعِيّ':Predicate, #2: 2	أَبَانَ رَجُلٌ
u'أَبَانَ صَغِيرٌ':Predicate, #1: 1	أَبَانَ الشَّافِعِيَّ
u'أَبَا نَضْرَةٌ':Predicate, #2: 2	أَبَانَ صَغِيرَةً
u'أَبَانَ طَائِفٌ':Subject, #12: 12	أَبَا نَضْرَةَ
u'أَبَانَ طَبَرِيّ':Subject, #1: 1	أَبَانَ طَائِفَةٌ
u'أَبَا نَعَامَةٌ':Predicate, #1: 1	أَبَانَ الطَّبَرِيُّ
u'أَبَانَ فرق':Subject, #1: 1	أَبَا نَعَامَةَ
u'أَبَانَ فَرْقٌ':Subject, #1: 1	أَبَانَ الْفَرْقُ
u'أَبَانَ فِقْهٌ':Predicate, #1: 1	أَبَانَ الْفَرْقُ
u'أَبَانَ فلان':Predicate, #1: 1	أَبَانَ فِقْهَ
u'أَبَانَ فلان':Subject, #1: 1	أَبَانَ الشَّافِعِيَّ
u'أَبَانَ قَالٌ':Predicate, #1: 1	أَبَانَ الطَّبَرِيُّ
u'أَبَانَ قَالٌ':Predicate, #1: 1	أَبَانَ قَالاَ
u'أَبَانَ قُرَشِيٌّ':Subject, #7: 7	أَبَانَ قَالَ
u'أَبَانَ مَبْنِيٌّ':Subject, #1: 1	أَبَانَ الْقُرَشِيُّ
u'أَبَانَ مَتْرُوكٌ':Subject, #1: 1	أَبَانَ مَبْنِيٌّ
u'أَبَانَ مَظْلُومٌ':Predicate, #1: 1	أَبَانَ مَتْرُوكٌ
u'أَبَا نَمْلَةٌ':Predicate, #3: 3	أَبَانَ الْمَظْلُومَةَ
u'أَبَانَ واحد':Predicate, #1: 1	أَبَا نَمْلَةَ
u'أَبَانَ وَاحِدٌ':Predicate, #2: 2	أَبَانَ وَاحِدَةً
u'أَبَانَ يَدٌ':Predicate, #2: 2	أَبَانَ وَاحِدَةً
u'أَبَا هُرَيْرَةٌ':Predicate, #1: 1	أَبَانَ الْيَدَ
u'أَبَا هِنْدٌ':Predicate, #413: 413	أَبَا هُرَيْرَةَ
u'أَبَا يَعْقُوبٌ':Predicate, #1: 1	أَبَا هِنْدَ
u'أبدال عُقُودٌ':Added, #2: 2	أَبَا يَعْقُوبَ
u'أَبْدَالٌ عُقُودٌ':Added, #2: 2	أَبْدَالِ الْعُقُودِ
u'أبدال مَنْفَعَةٌ':Added, #2: 2	أَبْدَالِ الْعُقُودِ
u'أَبْدَالٌ مَنْفَعَةٌ':Added, #1: 1	أَبْدَالُ مَنْفَعَتِهِ
u'أَبْدَى اِبْنٌ':Subject, #1: 1	أَبْدَالُ مَنْفَعَتِهِ
u'أَبْدَى أُسْتَاذٌ':Subject, #2: 2	أَبْدَى ابْنُ
u'أَبْدَى تَفْصِيلٌ':Predicate, #1: 1	أَبْدَى الْأُسْتَاذُ
u'أَبْدَى خِلاَفٌ':Predicate, #1: 1	أَبْدَى التَّفْصِيلَ
u'أَبْدَى فَارِقٌ':Subject, #1: 1	أَبْدَى الْخِلَافَ
u'أَبْدَى مَعَاصِي':Predicate, #1: 1	أَبْدَى الْفَارِقُ
u'أَبْدَى مُعْتَرِضٌ':Predicate, #1: 1	أَبْدَى الْمَعَاصِيَ
u'أَبْدَى مُعْتَرِضٌ':Subject, #1: 1	أَبْدَى الْمُعْتَرِضَ
u'أَبْدَى نَدَامَةٌ':Predicate, #1: 1	أَبْدَى الْمُعْتَرِضُ
u'أَبْدَى وُجُودٌ':Predicate, #1: 1	أَبْدَى النَّدَامَةَ
u'أَبْرَأَ أَبٌ':Predicate, #1: 1	أَبْدَى وُجُودَ
u'أَبْرَأَ أَجْنَبِيٌّ':Predicate, #1: 1	أَبْرَأَ الْأَبَ
u'أَبْرَأَ أحَدٌ':Predicate, #1: 1	أَبْرَأَ الْأَجْنَبِيَّ
u'أَبْرَأَ أحَدٌ':Subject, #2: 2	أَبْرَأَ أَحَدَ
u'أَبْرَأَ أَصيلٌ':Predicate, #1: 1	أَبْرَأَ أَحَدُ
u'أَبْرَأَ أَصيلٌ':Subject, #3: 3	أَبْرَأَ الْأَصِيلَ
u'أَبْرَأَ المُشْتَرِي':Predicate, #4: 4	أَبْرَأَ الْأَصِيلُ
u'أَبْرَأَ أَوَّلُ':Predicate, #11: 11	أَبْرَأَ الْمُشْتَرِيَ
u'أَبْرَأَ أَوْلاَدٌ':Predicate, #1: 1	أَبْرَأَ الْأَوَّلَ
u'أَبْرَأَ بَائِعٌ':Predicate, #1: 1	أَبْرَأَ أَوْلَادَ
u'أَبْرَأَ بَائِعٌ':Subject, #2: 2	أَبْرَأَ الْبَائِعَ
u'أَبْرَأَ حاضِرٌ':Predicate, #4: 4	أَبْرَأَ الْبَائِعُ
u'أَبَرَّ أحَدٌ':Subject, #1: 1	أَبْرَأَ الْحَاضِرَ
u'أَبْرَأَ حَمِيل':Predicate, #1: 1	أَبَرَّ أَحَدُ
u'أَبْرَأَ دَائِنٌ':Subject, #1: 1	أَبْرَأَ الْحَمِيلَ
u'أَبْرَأَ ذِمَّةٌ':Predicate, #3: 3	أَبْرَأَ الدَّائِنُ
u'أَبْرَأَ رَاهِنٌ':Predicate, #2: 2	أَبْرَأَ الذِّمَّةَ
u'أَبْرَأَ رَبُّ':Subject, #1: 1	أَبْرَأَ الرَّاهِنَ
u'إبْرَارٌ قَسَمٌ':Added, #8: 8	أَبْرَأَ رَبُّ
u'إبْرَارٌ قَسَمٌ':Added, #1: 1	إبْرَارُ الْقَسَمِ
u'إبْرَارٌ قَسَمٌ':Added, #1: 1	إبْرَارُ قَسَمٍ
u'إبْرَارٌ قَسَمٌ':Added, #1: 1	إبْرَارُ قَسَمِ
u'إبْرَارٌ قَسَمٌ':Added, #1: 1	إبْرَارَ قَسَمِهِ
u'أَبْرَأَ سَيِّدٌ':Subject, #3: 3	إبْرَارَ الْقَسَمِ
u'أَبْرَأَ صَاحِبٌ':Predicate, #1: 1	أَبْرَأَ السَّيِّدُ
u'أَبْرَأَ صَاحِبٌ':Subject, #1: 1	أَبْرَأَ صَاحِبَ
u'أَبْرَأَ ضَامِنٌ':Predicate, #2: 2	أَبْرَأَ صَاحِبُ
u'أَبْرَأَ ضَامِنٌ':Subject, #1: 1	أَبْرَأَ الضَّامِنَ
u'أَبْرَأَ طَالِبٌ':Subject, #1: 1	أَبْرَأَ الضَّامِنُ
u'أَبْرَأَ عَاقِلٌ':Predicate, #11: 11	أَبْرَأَ الطَّالِبُ
u'أَبْرَأَ عَاقِلٌ':Predicate, #1: 1	أَبْرَأَ الْعَاقِلَةَ
u'أَبْرَأَ عَبْدٌ':Predicate, #1: 1	أَبْرَأَ عَاقِلَةَ
u'أَبْرَأَ غَاصِبٌ':Predicate, #2: 2	أَبْرَأَ الْعَبْدَ
u'أَبْرَأَ غرماء':Predicate, #2: 2	أَبْرَأَ الْغَاصِبَ
u'أَبْرَأَ غرماء':Subject, #1: 1	أَبْرَأَ الْغُرَمَاءَ
u'أَبْرَأَ غَرِيمٌ':Predicate, #2: 2	أَبْرَأَ الْغُرَمَاءُ
u'أَبْرَأَ غَرِيمٌ':Subject, #2: 2	أَبْرَأَ الْغَرِيمَ
u'أَبْرَأَ فَقِيرٌ':Predicate, #8: 8	أَبْرَأَ الْغَرِيمُ
u'أَبْرَأَ فُلاَنٌ':Predicate, #1: 1	أَبْرَأَ الْفَقِيرَ
u'أَبْرَأَ فُلاَنٌ':Subject, #1: 1	أَبْرَأَ فُلَانَ
u'أَبْرَأَ قَاتِلٌ':Predicate, #1: 1	أَبْرَأَ فُلَانٌ
u'أَبْرَأَ قَيِّمٌ':Subject, #1: 1	أَبْرَأَ الْقَاتِلَ
u'أَبْرَأَ كَفِيلٌ':Predicate, #1: 1	أَبْرَأَ الْقَيِّمُ
u'أَبْرَأَ كَفِيلٌ':Subject, #5: 5	أَبْرَأَ الْكَفِيلَ
u'أَبْرَأَ مُحْتَالٌ':Predicate, #4: 4	أَبْرَأَ الْكَفِيلُ
u'أَبْرَأَ مُحْتَالٌ':Subject, #2: 2	أَبْرَأَ الْمُحْتَالَ
u'أَبْرَأَ مُحِيل':Predicate, #7: 7	أَبْرَأَ الْمُحْتَالُ
u'أَبْرَأَ مُحِيل':Subject, #1: 1	أَبْرَأَ الْمُحِيلَ
u'أَبْرَأَ مَدِينٌ':Predicate, #1: 1	أَبْرَأَ الْمُحِيلُ
u'أَبْرَأَ مَدِينٌ':Subject, #2: 2	أَبْرَأَ الْمَدِينَ
u'أَبْرَأَ مَدْيُونٌ':Predicate, #1: 1	أَبْرَأَ الْمَدِينُ
u'أَبْرَأَ مُرْتَهِنٌ':Predicate, #4: 4	أَبْرَأَ الْمَدْيُونَ
u'أَبْرَأَ مُرْتَهِنٌ':Subject, #1: 1	أَبْرَأَ الْمُرْتَهِنَ
u'أَبْرَأَ مَرِيضٌ':Subject, #7: 7	أَبْرَأَ الْمُرْتَهِنُ
u'أَبْرَأَ مُسْتَأْجِرٌ':Predicate, #1: 1	أَبْرَأَ الْمَرِيضُ
u'أَبْرَأَ مُسْتَأْجِرٌ':Subject, #1: 1	أَبْرَأَ الْمُسْتَأْجِرَ
u'أَبْرَأَ مُشْتَرِي':Predicate, #1: 1	أَبْرَأَ الْمُسْتَأْجِرُ
u'أَبْرَأَ مَطْلُوبٌ':Predicate, #11: 11	أَبْرَأَ الْمُشْتَرِيَ
u'إبْرَامٌ عَزْمٌ':Added, #1: 1	أَبْرَأَ الْمَطْلُوبَ
u'إبْرَامٌ عَقْدٌ':Added, #1: 1	إبْرَامِ الْعَزْمِ
u'أَبْرَأَ مَغْصُوب':Subject, #1: 1	إبْرَامِ الْعَقْدِ
u'أَبْرَأَ مُؤَجِّرٌ':Subject, #1: 1	أَبْرَأَ الْمَغْصُوبُ
u'أَبْرَأَ مُوَرِّث':Subject, #2: 2	أَبْرَأَ الْمُؤَجِّرُ
u'أَبْرَأَ وَارِثٌ':Predicate, #1: 1	أَبْرَأَ الْمُوَرِّثُ
u'أَبْرَأَ وَارِثٌ':Subject, #1: 1	أَبْرَأَ الْوَارِثَ
u'أَبْرَأَ وَارِثٌ':Subject, #1: 1	أَبْرَأَ الْوَارِثُ
u'أَبْرَأَ وَكِيلٌ':Predicate, #1: 1	أَبْرَأَ وَارِثٌ
u'أَبْرَأَ وَكِيلٌ':Subject, #1: 1	أَبْرَأَ الْوَكِيلَ
u'أَبْرَأَ وَكِيلٌ':Subject, #1: 1	أَبْرَأَ الْوَكِيلُ
u'أَبْرَحَ أرْضٌ':Predicate, #1: 1	أَبْرَأَ وَكِيلُ
u'أَبْرَمَ بَيْعٌ':Predicate, #2: 2	أَبْرَحَ الْأَرْضَ
u'أَبَرَّ مَطْلُوبٌ':Predicate, #1: 1	أَبْرَمَ الْبَيْعَ
u'أَبْصَرَ اِبْنٌ':Subject, #1: 1	أَبَرَّ الْمَطْلُوبَ
u'أَبْصَرَ بَطَلٌ':Predicate, #1: 1	أَبْصَرَ ابْنُ
u'أَبْصَرَ بَعْضٌ':Predicate, #1: 1	أَبْصَرَ بَطَلَ
u'أَبْصَرَ رَجُلٌ':Predicate, #1: 1	أَبْصَرَ بَعْضَ
u'أَبْصَرَ رَسُولٌ':Subject, #5: 5	أَبْصَرَ رَجُلاً
u'أَبْصَرَ عِرْفَانٌ':Predicate, #6: 6	أَبْصَرَ رَسُولُ
u'أَبْصَرَ عُمَرٌ':Subject, #1: 1	أَبْصَرَ الْعِرْفَانَ
u'أَبْصَرَ قَوْمٌ':Predicate, #4: 4	أَبْصَرَ عُمَرُ
u'أَبْصَرَ مَاءٌ':Predicate, #1: 1	أَبْصَرَ الْقَوْمَ
u'أَبْصَرَ مَوَاقِعُ':Predicate, #8: 8	أَبْصَرَ الْمَاءَ
u'أَبْصَرَ نَاسٌ':Subject, #1: 1	أَبْصَرَ مَوَاقِعَ
u'أَبْصَرَ نَبِيٌّ':Predicate, #1: 1	أَبْصَرَ النّاسُ
u'أَبْصَرَ نَبِيٌّ':Subject, #1: 1	أَبْصَرَ النَّبِيَّ
u'أَبْصَرَ هِلاَلٌ':Predicate, #1: 1	أَبْصَرَ النَّبِيُّ
u'أَبْصَرَ وَجَبٌ':Predicate, #2: 2	أَبْصَرَ الْهِلَالَ
u'إبْطَاءٌ بُرْء':Added, #1: 1	أَبْصَرَ وَجَبَ
u'إبْطَاءٌ بُرْء':Added, #1: 1	إبْطَاءَ الْبُرْءِ
u'إبْطَاءٌ رِزْقٌ':Added, #1: 1	إبْطَاءِ الْبُرْءِ
u'إبْطَاءٌ مَجِيءٌ':Added, #1: 1	إبْطَاءُ الرِّزْقِ
u'إبْطَاءٌ نِيلٌ':Added, #1: 1	إبْطَاءِ الْمَجِيءِ
u'أَبْطَأَ إمَامٌ':Subject, #1: 1	إبْطَاءِ النِّيلِ
u'أَبْطَأَ جَوَابٌ':Predicate, #1: 1	أَبْطَأَ الْإِمَامُ
u'أَبْطَأَ عِدَّةٌ':Predicate, #1: 1	أَبْطَأَ الْجَوَابَ
u'إِبْطَالٌ اِسْتِرْجَاعٌ':Added, #1: 1	أَبْطَأَ عِدَّةَ
u'إِبْطَالٌ تَحْسِين':Added, #1: 1	إِبْطَالُ اسْتِرْجَاعِ
u'إِبْطَالٌ تَحْكِيمٌ':Added, #1: 1	إِبْطَالِ التَّحْسِينِ
u'إِبْطَالٌ حَقٌّ':Added, #1: 1	إِبْطَالِ التَّحْكِيمِ
u'إِبْطَالٌ شَرِيعَةٌ':Added, #1: 1	إِبْطَالِ حَقٍّ
u'إِبْطَالٌ شَرِيعَةٌ':Added, #1: 1	إِبْطَالَ الشَّرِيعَةِ
u'إِبْطَالٌ مُكَمِّلٌ':Added, #1: 1	إِبْطَالِ الشَّرِيعَةِ
u'إِبْطَالٌ نَظَرٌ':Added, #1: 1	إِبْطَالِ الْمُكَمِّلَاتِ
u'أَبْطَأَ مَوْتٌ':Subject, #1: 1	إِبْطَالُ النَّظَرِ
u'أَبْطَأَ مُؤَذِّنٌ':Subject, #1: 1	أَبْطَأَ مَوْتُهُ
u'أَبْطَأَ وَلِيدٌ':Subject, #1: 1	أَبْطَأَ الْمُؤَذِّنُ
u'أَبْطَلَ اِبْنٌ':Subject, #1: 1	أَبْطَأَ الْوَلِيدُ
u'أَبْطَلَ إِجْمَاعٌ':Predicate, #1: 1	أَبْطَلَ ابْنُ
u'أَبْطَلَ أَذَانٌ':Predicate, #1: 1	أَبْطَلَ الْإِجْمَاعَ
u'أَبْطَلَ اِسْتِثْنَاءٌ':Predicate, #1: 1	أَبْطَلَ الْأَذَانَ
u'أَبْطَلَ إِسْلامٌ':Predicate, #1: 1	أَبْطَلَ اسْتِثْنَاءَ
u'أَبْطَلَ إمَامٌ':Subject, #1: 1	أَبْطَلَ إسْلَامَ
u'أَبْطَلَ أَمْرٌ':Predicate, #1: 1	أَبْطَلَ الْإِمَامُ
u'أَبْطَلَ بَائِعٌ':Subject, #1: 1	أَبْطَلَ أَمْرَ
u'أَبْطَلَ بَطْشٌ':Predicate, #1: 1	أَبْطَلَ الْبَائِعُ
u'أَبْطَلَ بَطَلٌ':Predicate, #1: 1	أَبْطَلَ بَطْشَ
u'أَبْطَلَ بَيْعٌ':Predicate, #1: 1	أَبْطَلَ بَطَلَ
u'أَبْطَلَ بَيْعٌ':Subject, #7: 7	أَبْطَلَ الْبَيْعَ
u'أَبْطَلَ تَسْبِيب':Predicate, #1: 1	أَبْطَلَ بَيْعُهُ
u'أَبْطَلَ تَعَدُّدٌ':Predicate, #1: 1	أَبْطَلَ التّسْبِيبَ
u'أَبْطَلَ تَعْلِيقٌ':Predicate, #1: 1	أَبْطَلَ تَعَدُّدَ
u'أَبْطَلَ تَمَتُّعٌ':Predicate, #1: 1	أَبْطَلَ التَّعْلِيقَ
u'أَبْطَلَ حِرْزٌ':Predicate, #1: 1	أَبْطَلَ التَّمَتُّعَ
u'أَبْطَلَ حَقٌّ':Predicate, #1: 1	أَبْطَلَ الْحِرْزَ
u'أَبْطَلَ حُكْمٌ':Predicate, #5: 5	أَبْطَلَ حَقَّ
u'أَبْطَلَ حكمة':Predicate, #2: 2	أَبْطَلَ حُكْمَ
u'أَبْطَلَ حِكْمَةٌ':Predicate, #1: 1	أَبْطَلَ الْحِكْمَةَ
u'أَبْطَلَ حول':Predicate, #1: 1	أَبْطَلَ الْحِكْمَةَ
u'أَبْطَلَ حَوْلٌ':Predicate, #1: 1	أَبْطَلَ حَوْلَ
u'أَبْطَلَ خيار':Predicate, #1: 1	أَبْطَلَ حَوْلَ
u'أَبْطَلَ خِيَارٌ':Predicate, #2: 2	أَبْطَلَ الْخِيَارَ
u'أَبْطَلَ دَرَاهِمُ':Predicate, #2: 2	أَبْطَلَ الْخِيَارَ
u'أَبْطَلَ رَسُولٌ':Subject, #1: 1	أَبْطَلَ الدَّرَاهِمَ
u'أَبْطَلَ رِضاً':Subject, #1: 1	أَبْطَلَ رَسُولُ
u'أَبْطَلَ رَهْنٌ':Predicate, #1: 1	أَبْطَلَ رِضَاهُ
u'أَبْطَلَ سَائِرٌ':Predicate, #2: 2	أَبْطَلَ الرَّهْنَ
u'أَبْطَلَ شَرْطٌ':Predicate, #1: 1	أَبْطَلَ سَائِرَ
u'أَبْطَلَ شَرْطٌ':Subject, #1: 1	أَبْطَلَ شَرْطَ
u'أَبْطَلَ شَرْعٌ':Subject, #1: 1	أَبْطَلَ شَرْطُهُ
u'أَبْطَلَ شَهَادَةٌ':Predicate, #1: 1	أَبْطَلَ الشَّرْعُ
u'أَبْطَلَ شَهَادَةٌ':Predicate, #1: 1	أَبْطَلَ الشَّهَادَةَ
u'أَبْطَلَ صَاحِبٌ':Subject, #2: 2	أَبْطَلَ شَهَادَةَ
u'أَبْطَلَ صَلاَةٌ':Predicate, #7: 7	أَبْطَلَ صَاحِبُ
u'أَبْطَلَ صلح':Predicate, #6: 6	أَبْطَلَ الصَّلَاةَ
u'أَبْطَلَ صُلْحٌ':Predicate, #1: 1	أَبْطَلَ الصُّلْحَ
u'أَبْطَلَ صنعة':Predicate, #1: 1	أَبْطَلَ الصُّلْحَ
u'أَبْطَلَ صَنْعَةٌ':Predicate, #1: 1	أَبْطَلَ صَنْعَةَ
u'أَبْطَلَ ظُهورٌ':Predicate, #1: 1	أَبْطَلَ صَنْعَةَ
u'أَبْطَلَ عتق':Predicate, #1: 1	أَبْطَلَ ظُهُورَ
u'أَبْطَلَ عِتْقٌ':Predicate, #1: 1	أَبْطَلَ الْعِتْقَ
u'أَبْطَلَ عَقْدٌ':Predicate, #1: 1	أَبْطَلَ الْعِتْقَ
u'أَبْطَلَ عِلَّةٌ':Predicate, #2: 2	أَبْطَلَ الْعَقْدَ
u'أَبْطَلَ علماء':Subject, #1: 1	أَبْطَلَ الْعِلَّةَ
u'أَبْطَلَ عُلَمَاءُ':Subject, #1: 1	أَبْطَلَ الْعُلَمَاءُ
u'أَبْطَلَ عَمْدٌ':Subject, #1: 1	أَبْطَلَ الْعُلَمَاءُ
u'أَبْطَلَ عَهْدٌ':Predicate, #2: 2	أَبْطَلَ عَمْدُهُ
u'أَبْطَلَ عَيْبٌ':Predicate, #2: 2	أَبْطَلَ الْعَهْدَ
u'أَبْطَلَ غَرِيمٌ':Subject, #1: 1	أَبْطَلَ الْعَيْبَ
u'أَبْطَلَ قسمة':Predicate, #1: 1	أَبْطَلَ الْغَرِيمُ
u'أَبْطَلَ قِسْمَةٌ':Predicate, #1: 1	أَبْطَلَ الْقِسْمَةَ
u'أَبْطَلَ قول':Predicate, #1: 1	أَبْطَلَ الْقِسْمَةَ
u'أَبْطَلَ قَوْلٌ':Predicate, #1: 1	أَبْطَلَ الْقَوْلَ
u'أَبْطَلَ قِيمَةٌ':Predicate, #1: 1	أَبْطَلَ الْقَوْلَ
u'أَبْطَلَ كَفَالَةٌ':Predicate, #1: 1	أَبْطَلَ قِيمَةَ
u'أَبْطَلَ كَلاَمٌ':Subject, #1: 1	أَبْطَلَ الْكَفَالَةَ
u'أَبْطَلَ مَخْرَجٌ':Predicate, #1: 1	أَبْطَلَ كَلَامُ
u'أَبْطَلَ مِلْكٌ':Predicate, #1: 1	أَبْطَلَ مَخْرَجَ
u'أَبْطَلَ مِلْكٌ':Subject, #1: 1	أَبْطَلَ مِلْكَ
u'أَبْطَلَ مَنْصُوصٌ':Predicate, #1: 1	أَبْطَلَ الْمِلْكُ
u'أَبْطَلَ مَوْهُوبٌ':Subject, #1: 1	أَبْطَلَ الْمَنْصُوصَ
u'أَبْطَلَ نَصِيبٌ':Predicate, #1: 1	أَبْطَلَ الْمَوْهُوبُ
u'أَبْطَلَ نَظَرٌ':Predicate, #1: 1	أَبْطَلَ نَصِيبَ
u'أَبْطَلَ نكاح':Predicate, #1: 1	أَبْطَلَ النَّظَرَ
u'أَبْطَلَ نِكَاحٌ':Predicate, #1: 1	أَبْطَلَ النِّكَاحَ
u'أَبْطَلَ نَمَاءٌ':Predicate, #1: 1	أَبْطَلَ النِّكَاحَ
u'أَبْطَلَ نِيَّةٌ':Predicate, #1: 1	أَبْطَلَ النَّمَاءَ
u'أَبْطَلَ وَصِيٌّ':Predicate, #6: 6	أَبْطَلَ النِّيَّةَ
u'أَبْطَلَ وَصِيٌّ':Predicate, #1: 1	أَبْطَلَ الْوَصِيَّةَ
u'أَبْطَلَ وَصِيَّةٌ':Predicate, #1: 1	أَبْطَلَ وَصِيَّةً
u'أَبْطَلَ وُضُوءٌ':Predicate, #1: 1	أَبْطَلَ الْوَصِيَّةَ
u'أَبْطَلَ وَقْفٌ':Predicate, #3: 3	أَبْطَلَ الْوُضُوءَ
u'أَبْطَلَ وِلاَيَةٌ':Predicate, #2: 2	أَبْطَلَ الْوَقْفَ
u'أَبْطَلَ وَلَهٌ':Subject, #1: 1	أَبْطَلَ وِلَايَةَ
u'أَبْطَلَ وَلِيٌّ':Subject, #1: 1	أَبْطَلَ وَلَهُ
u'إبْعَادٌ مَذْهَبٌ':Added, #1: 1	أَبْطَلَ الْوَلِيُّ
u'أَبْعَدَ سَامِريٌّ':Subject, #1: 1	إبْعَادُ الْمَذْهَبِ
u'أَبْعَدَ شَارِحٌ':Subject, #1: 1	أَبْعَدَ السَّامِرِيُّ
u'أَبْعَدَ عَرَبٌ':Predicate, #2: 2	أَبْعَدَ الشَّارِحُ
u'أَبْعَدَ قتل':Predicate, #1: 1	أَبْعَدَ الْعَرَبَ
u'أَبْعَدَ قَتْلٌ':Predicate, #1: 1	أَبْعَدَ الْقَتْلَ
u'أَبْعَدَ مَنْزِلٌ':Predicate, #1: 1	أَبْعَدَ الْقَتْلَ
u'أَبْغَضَ أنصار':Predicate, #1: 1	أَبْعَدَ مَنْزِلاً
u'أَبْغَضَ أَنْصارٌ':Predicate, #3: 3	أَبْغَضَ الأَنْصَارَ
u'أَبْغَضَ أَنْصَارٌ':Predicate, #3: 3	أَبْغَضَ الأَنْصَارَ
u'أَبْغَضَ رَسُولٌ':Predicate, #3: 3	أَبْغَضَ الأَنْصَارَ
u'أَبْقَى أَذْرُعٌ':Predicate, #2: 2	أَبْغَضَ رَسُولَ
u'أَبْقَى أَرْغِفَةٌ':Predicate, #2: 2	أَبْقَى الْأَذْرُعَ
u'أَبْقَى اِسْمٌ':Predicate, #1: 1	أَبْقَى الْأَرْغِفَةَ
u'أَبْقَى إمَاءٌ':Predicate, #1: 1	أَبْقَى اسْمَ
u'أَبْقَى ثَانِي':Predicate, #1: 1	أَبْقَى الْإِمَاءَ
u'أَبْقَى ثَانِيَةٌ':Predicate, #2: 2	أَبْقَى الثَّانِيَةَ
u'أَبْقَى حَلاَوَةٌ':Predicate, #2: 2	أَبْقَى الثَّانِيَةَ
u'أَبْقَى خَمْسَةٌ':Predicate, #1: 1	أَبْقَى حَلَاوَةَ
u'أَبْقَى شَارِحٌ':Subject, #1: 1	أَبْقَى الْخَمْسَةَ
u'أَبْقَى صُبْحٌ':Predicate, #1: 1	أَبْقَى الشَّارِحُ
u'أَبْقَى طَرِيقٌ':Predicate, #1: 1	أَبْقَى صُبْحَ
u'أَبْقَى عين':Predicate, #3: 3	أَبْقَى الطَّرِيقَ
u'أَبْقَى عَيْنٌ':Predicate, #1: 1	أَبْقَى الْعَيْنَ
u'أَبْقَى عَيْن':Predicate, #1: 1	أَبْقَى الْعَيْنَ
u'أَبْقَى قَدْرٌ':Predicate, #1: 1	أَبْقَى الْعَيْنَ
u'أَبْقَى كُتُبٌ':Predicate, #1: 1	أَبْقَى قَدْرَ
u'أَبْقَى كَلاَمٌ':Predicate, #2: 2	أَبْقَى الْكُتُبَ
u'أَبْقَى مَجْدٌ':Subject, #1: 1	أَبْقَى كَلَامَ
u'أَبْقَى نصاب':Predicate, #3: 3	أَبْقَى مَجْدُهُ
u'أَبْقَى نِصَابٌ':Predicate, #1: 1	أَبْقَى النِّصَابَ
u'أَبْقَى نِصْفٌ':Predicate, #1: 1	أَبْقَى النِّصَابَ
u'أَبْقَى يَوْمٌ':Predicate, #1: 1	أَبْقَى نِصْفَ
u'أَبْلَغَ عند':Predicate, #1: 1	أَبْقَى الْيَوْمَ
u'أَبْلَغَ قَائِلٌ':Subject, #1: 1	أَبْلَغَ عِنْدَ
u'أَبْلَغَ نَفْسٌ':Predicate, #1: 1	أَبْلَغَ الْقَائِلُ
u'إِبْهَامٌ رِجْلٌ':Added, #1: 1	أَبْلَغَ النّفْسَ
u'أَبْهَمَ إِحْرَامٌ':Predicate, #1: 1	إِبْهَامَ رِجْلِهِ
u'أَبْهَمَ إقْرَارٌ':Predicate, #5: 5	أَبْهَمَ الْإِحْرَامَ
u'أَبْهَمَ إمَامٌ':Predicate, #2: 2	أَبْهَمَ الْإِقْرَارَ
u'أَبْهَمَ بَعْضٌ':Predicate, #1: 1	أَبْهَمَ الْإِمَامَ
u'أَبْهَمَ جَوَابٌ':Predicate, #1: 1	أَبْهَمَ الْبَعْضَ
u'أَبْهَمَ طَلاَقٌ':Predicate, #1: 1	أَبْهَمَ الْجَوَابَ
u'أَبْهَمَ عتق':Predicate, #1: 1	أَبْهَمَ الطَّلَاقَ
u'أَبْهَمَ عِتْقٌ':Predicate, #1: 1	أَبْهَمَ الْعِتْقَ
u'أَبْهَمَ علم':Predicate, #1: 1	أَبْهَمَ الْعِتْقَ
u'أَبْهَمَ عَلَمٌ':Predicate, #1: 1	أَبْهَمَ الْعَلَمَ
u'أَبْهَمَ مُتَكَلِّمٌ':Subject, #1: 1	أَبْهَمَ الْعَلَمَ
u'أَبْهَمَ مُسْلِمٌ':Subject, #1: 1	أَبْهَمَ الْمُتَكَلِّمُ
u'أَبْهَمَ نِيَّةٌ':Predicate, #1: 1	أَبْهَمَ مُسْلِمٌ
u'أَبْوَالٌ إِبِلٌ':Added, #1: 1	أَبْهَمَ النِّيَّةَ
u'أَبْوَالٌ إِبِلٌ':Added, #17: 17	أَبْوَالِ الْإِبِلِ
u'أَبْوَالٌ إِبِلٌ':Added, #1: 1	أَبْوَالُ الْإِبِلِ
u'أَبْوَالٌ أُتُنٌ':Added, #3: 3	أَبْوَالَ الْإِبِلِ
u'أَبْوَالٌ أُتُن':Added, #1: 1	أَبْوَالِ الْأُتُنِ
u'أَبْوَالٌ أَنْعامٌ':Added, #1: 1	أَبْوَالِ الْأُتُنِ
u'أَبْوَالٌ أَنْعامٌ':Added, #1: 1	أَبْوَالَ الْأَنْعَامِ
u'أَبْوَالٌ أَنْعَامٌ':Added, #1: 1	أَبْوَالُ الْأَنْعَامِ
u'أَبْوَالٌ أَنْعَامٌ':Added, #1: 1	أَبْوَالَ الْأَنْعَامِ
u'أَبْوَالٌ أَنْعامٌ':Added, #1: 1	أَبْوَالُ الْأَنْعَامِ
u'أَبْوَالٌ أَنْعَامٌ':Added, #3: 3	أَبْوَالِ الْأَنْعَامِ
u'أَبْوَالٌ بَراغِيثُ':Added, #3: 3	أَبْوَالِ الْأَنْعَامِ
u'أَبْوَالٌ جَمَلٌ':Added, #1: 1	أَبْوَالُ الْبَرَاغِيثِ
u'أَبْوَالٌ دَوَابُّ':Added, #1: 1	أَبْوَالُ الْجَمَلِ
u'أَبَى أَبٌ':Subject, #1: 1	أَبْوَالِ الدَّوَابِّ
u'أَبَى أَجِيرٌ':Subject, #1: 1	أَبَى أَبٌ
u'أَبَى أحَدٌ':Subject, #1: 1	أَبَى الْأَجِيرُ
u'أَبَى أخْذٌ':Predicate, #2: 2	أَبَى أَحَدُ
u'أَبَى إِذْنٌ':Predicate, #1: 1	أَبَى أَخْذَ
u'أَبَى إِزَالَةٌ':Predicate, #1: 1	أَبَى الْإِذْنَ
u'أَبَى إِسْلامٌ':Predicate, #1: 1	أَبَى إزَالَةَ
u'أَبَى إِسْلامٌ':Predicate, #2: 2	أَبَى الإِسْلاَمَ
u'أَبَى إعْطَاءٌ':Predicate, #4: 4	أَبَى الْإِسْلَامَ
u'أَبَى أعْلَمُ':Predicate, #1: 1	أَبَى إعْطَاءَ
u'أَبَى إلْحَاقٌ':Predicate, #1: 1	أَبَى أَعْلَمَ
u'أَبَى إِنْفاقٌ':Predicate, #1: 1	أَبَى الْإِلْحَاقَ
u'أَبَى أهْلٌ':Subject, #1: 1	أَبَى الْإِنْفَاقَ
u'أَبَى أَوَّلُ':Subject, #2: 2	أَبَى أَهْلُ
u'أَبَى بَاعٌ':Predicate, #1: 1	أَبَى الْأَوَّلُ
u'أَبَى بَائِعٌ':Subject, #2: 2	أَبَى بَاعَ
u'أَبَى بَذْلٌ':Predicate, #7: 7	أَبَى الْبَائِعُ
u'أَبَى بَطَلٌ':Predicate, #1: 1	أَبَى بَذْلَ
u'أَبَى بَعْضٌ':Subject, #1: 1	أَبَى بَطَلَ
u'أَبَى بَيْعٌ':Predicate, #1: 1	أَبَى بَعْضُ
u'أَبَى بَيْعٌ':Predicate, #1: 1	أَبَى الْبَيْعَ
u'أَبَى بِيَعٌ':Predicate, #1: 1	أَبَى بَيْعَ
u'أَبَى تَسْلِيمٌ':Predicate, #4: 4	أَبَى بِيعَ
u'أَبَى تَعْزِير':Predicate, #1: 1	أَبَى التَّسْلِيمَ
u'أَبَى تَغْلِيظٌ':Predicate, #1: 1	أَبَى التَّعْزِيرَ
u'أَبَى حاكِمٌ':Subject, #1: 1	أَبَى التَّغْلِيظَ
u'أَبَى حُضورٌ':Predicate, #1: 1	أَبَى الْحَاكِمُ
u'أَبَى حُضُورٌ':Predicate, #1: 1	أَبَى الْحُضُورَ
u'أَبَى حَكَمٌ':Predicate, #1: 1	أَبَى الْحُضُورَ
u'أَبَى حَنِيفٌ':Predicate, #2: 2	أَبَى حَكَمَ
u'أَبَى خِذْلاَنٌ':Predicate, #1: 1	أَبَى حَنِيفَةَ
u'أَبَى خُرُوجٌ':Predicate, #1: 1	أَبَى خِذْلَانَ
u'أَبَى خَصْمٌ':Subject, #1: 1	أَبَى الْخُرُوجَ
u'أَبَى خَصْمٌ':Subject, #1: 1	أَبَى الْخَصْمُ
u'أَبَى دفع':Predicate, #1: 1	أَبَى خَصْمُهُ
u'أَبَى دفع':Predicate, #1: 1	أَبَى دَفَعَ
u'أَبَى دَفْعٌ':Predicate, #1: 1	أَبَى دَفْعَ
u'أَبَى ذكر':Predicate, #1: 1	أَبَى دَفْعَ
u'أَبَى ذِكْرٌ':Predicate, #1: 1	أَبَى ذِكْرَ
u'أَبَى رَاهِنٌ':Subject, #1: 1	أَبَى ذِكْرَ
u'أَبَى رَبُّ':Subject, #5: 5	أَبَى الرَّاهِنُ
u'أَبَى رَجُلٌ':Subject, #1: 1	أَبَى رَبُّهُ
u'أَبَى زَوْجٌ':Subject, #2: 2	أَبَى الرَّجُلُ
u'أَبَى زَوْجٌ':Subject, #1: 1	أَبَى زَوْجٌ
u'أَبَى سَائِرٌ':Subject, #6: 6	أَبَى الزَّوْجُ
u'أَبَى سقط':Predicate, #2: 2	أَبَى سَائِرُ
u'أَبَى سَقَطٌ':Predicate, #1: 1	أَبَى سَقَطَ
u'أَبَى سُهَيْلٌ':Subject, #1: 1	أَبَى سَقَطَ
u'أَبَى سَيِّدٌ':Subject, #1: 1	أَبَى سُهَيْلٌ
u'أَبَى سَيِّدٌ':Subject, #1: 1	أَبَى السَّيِّدُ
u'أَبَى سَيْرٌ':Predicate, #2: 2	أَبَى سَيِّدُهُ
u'أَبَى شِرَاءٌ':Predicate, #1: 1	أَبَى السَّيْرَ
u'أَبَى شَرِيكٌ':Subject, #1: 1	أَبَى الشِّرَاءَ
u'أَبَى شَرِيكٌ':Subject, #1: 1	أَبَى الشَّرِيكُ
u'أَبَى شَيْبَةٌ':Predicate, #1: 1	أَبَى شَرِيكُهُ
u'أَبَى صَاحِبٌ':Subject, #3: 3	أَبَى شَيْبَةَ
u'أَبَى صَاحِبٌ':Subject, #11: 11	أَبَى صَاحِبُ
u'أَبَى ضَرْبٌ':Predicate, #1: 1	أَبَى صَاحِبُهُ
u'أَبَى ضَمَانٌ':Predicate, #1: 1	أَبَى الضَّرْبَ
u'أَبَى عَبْدٌ':Subject, #1: 1	أَبَى الضَّمَانَ
u'أَبَى عتق':Predicate, #1: 1	أَبَى عَبْدُ
u'أَبَى عِتْقٌ':Predicate, #1: 1	أَبَى الْعِتْقَ
u'أَبَى عَدْلٌ':Subject, #1: 1	أَبَى الْعِتْقَ
u'أَبَى غرماء':Subject, #2: 2	أَبَى الْعَدْلُ
u'أَبَى غَرِيمٌ':Subject, #3: 3	أَبَى الْغُرَمَاءُ
u'أَبَى غير':Predicate, #1: 1	أَبَى الْغَرِيمُ
u'أَبَى غَيْرٌ':Predicate, #1: 1	أَبَى غَيْرَ
u'أَبَى غير':Subject, #1: 1	أَبَى غَيْرَ
u'أَبَى غَيْرٌ':Subject, #1: 1	أَبَى غَيْرُهُ
u'أَبَى فَلًا':Predicate, #1: 1	أَبَى غَيْرُهُ
u'أَبَى فُلاَنٌ':Subject, #1: 1	أَبَى فَلاَ
u'أَبَى فَيْئَةٌ':Predicate, #2: 2	أَبَى فُلَانٌ
u'أَبَى قَادِرٌ':Subject, #2: 2	أَبَى الْفَيْئَةَ
u'أَبَى قَالٌ':Predicate, #1: 1	أَبَى الْقَادِرُ
u'أَبَى قَبُولٌ':Predicate, #1: 1	أَبَى قَالَ
u'أَبَى قَبُولٌ':Predicate, #1: 1	أَبَى قَبُولَ
u'أَبَى قتل':Predicate, #2: 2	أَبَى الْقَبُولَ
u'أَبَى قسمة':Predicate, #5: 5	أَبَى قُتِلَ
u'أَبَى قِسْمَةٌ':Predicate, #1: 1	أَبَى الْقِسْمَةَ
u'أَبَى قصاص':Predicate, #1: 1	أَبَى الْقِسْمَةَ
u'أَبَى قِصَاصٌ':Predicate, #1: 1	أَبَى الْقِصَاصَ
u'أَبَى قلب':Subject, #1: 1	أَبَى الْقِصَاصَ
u'أَبَى قَلْبٌ':Subject, #1: 1	أَبَى الْقَلْبُ
u'أَبَى قَلْب':Subject, #1: 1	أَبَى الْقَلْبُ
u'أَبَى قَوْمٌ':Subject, #1: 1	أَبَى الْقَلْبُ
u'أَبَى كفر':Predicate, #1: 1	أَبَى قَوْمٌ
u'أَبَى كُفْرٌ':Predicate, #1: 1	أَبَى الْكُفْرَ
u'أَبَى مَالِكٌ':Subject, #1: 1	أَبَى الْكُفْرَ
u'أَبَى مُبَادَرَةٌ':Predicate, #1: 1	أَبَى الْمَالِكُ
u'أَبَى مُبْتاع':Subject, #1: 1	أَبَى الْمُبَادَرَةَ
u'أَبَى مَجِيءٌ':Predicate, #1: 1	أَبَى الْمُبْتَاعُ
u'أَبَى مَدْيُونٌ':Subject, #1: 1	أَبَى الْمَجِيءَ
u'أَبَى مُرْتَهِنٌ':Subject, #1: 1	أَبَى الْمَدْيُونُ
u'أَبَى مُزَارِعٌ':Subject, #6: 6	أَبَى الْمُرْتَهِنُ
u'أَبَى مُسْتَأْجِرٌ':Subject, #1: 1	أَبَى الْمُزَارِعُ
u'أَبَى مُسْتَحِقٌّ':Subject, #1: 1	أَبَى مُسْتَأْجِرُ
u'أَبَى مُسْتَعِيرٌ':Subject, #1: 1	أَبَى الْمُسْتَحِقُّ
u'أَبَى مُسَلَّمٌ':Subject, #1: 1	أَبَى الْمُسْتَعِيرُ
u'أَبَى مُضَارِبٌ':Subject, #1: 1	أَبَى الْمُسَلَّمُ
u'أَبَى مَطْلُوبٌ':Subject, #1: 1	أَبَى الْمُضَارِبُ
u'أَبَى مُعَيَّنٌ':Subject, #2: 2	أَبَى الْمَطْلُوبُ
u'أَبَى مُفْلِسٌ':Subject, #2: 2	أَبَى الْمُعَيَّنُ
u'أَبَى مُفْلِسٌ':Subject, #1: 1	أَبَى مُفْلِسٌ
u'أَبَى مَكْفُولٌ':Subject, #2: 2	أَبَى الْمُفْلِسُ
u'أَبَى مُلْتَقِط':Subject, #1: 1	أَبَى الْمَكْفُولُ
u'أَبَى مُؤَجِّرٌ':Subject, #2: 2	أَبَى الْمُلْتَقِطُ
u'أَبَى مَوْقُوفٌ':Subject, #1: 1	أَبَى الْمُؤَجِّرُ
u'أَبَى نَابٌ':Predicate, #5: 5	أَبَى الْمَوْقُوفُ
u'أَبَى نَاسٌ':Subject, #1: 1	أَبَى نَابَ
u'أَبَى نصب':Predicate, #1: 1	أَبَى النَّاسُ
u'أَبَى نَصَبٌ':Predicate, #1: 1	أَبَى نَصَبَ
u'أَبَى وَارِثٌ':Subject, #1: 1	أَبَى نَصَبَ
u'أَبَى وَاهِبٌ':Subject, #1: 1	أَبَى الْوَارِثُ
u'أَبَى وَرَثَةٌ':Subject, #1: 1	أَبَى الْوَاهِبُ
u'أَبَى وَرَثَةٌ':Subject, #2: 2	أَبَى الْوَرَثَةُ
u'أَبَى وَرَثَةٌ':Subject, #2: 2	أَبَى وَرَثَةُ
u'أَبَى وَلِيٌّ':Subject, #2: 2	أَبَى وَرَثَتُهُ
u'أَبَى وَلِيٌّ':Subject, #1: 1	أَبَى الْوَلِيُّ
u'أَبَى يَمِينٌ':Predicate, #1: 1	أَبَى وَلِيٌّ
u'أَتْبَعَ المُشْتَرِي':Predicate, #9: 9	أَبَى الْيَمِينَ
u'أَتْبَعَ أَوَّلُ':Predicate, #1: 1	أَتْبَعَ الْمُشْتَرِيَ
u'أَتْبَعَ إيقَاعٌ':Predicate, #1: 1	أَتْبَعَ الْأَوَّلَ
u'أَتْبَعَ إيقَاعٌ':Subject, #3: 3	أَتْبَعَ الْإِيقَاعَ
u'أَتْبَعَ بَائِعٌ':Predicate, #2: 2	أَتْبَعَ الْإِيقَاعُ
u'أَتْبَعَ جَانِي':Predicate, #2: 2	أَتْبَعَ الْبَائِعَ
u'أَتْبَعَ خِطَابٌ':Predicate, #1: 1	أَتْبَعَ الْجَانِيَ
u'أَتْبَعَ خُلْعٌ':Predicate, #1: 1	أَتْبَعَ الْخِطَابَ
u'أَتْبَعَ زَوْجٌ':Predicate, #1: 1	أَتْبَعَ الْخُلْعَ
u'أَتْبَعَ صَاحِبٌ':Predicate, #1: 1	أَتْبَعَ الزَّوْجَ
u'أَتْبَعَ صلح':Predicate, #1: 1	أَتْبَعَ صَاحِبَ
u'أَتْبَعَ صُلْحٌ':Predicate, #1: 1	أَتْبَعَ الصُّلْحَ
u'أَتْبَعَ عَاقِلٌ':Predicate, #1: 1	أَتْبَعَ الصُّلْحَ
u'أَتْبَعَ غَاصِبٌ':Predicate, #1: 1	أَتْبَعَ عَاقِلَةَ
u'أَتْبَعَ غرماء':Predicate, #1: 1	أَتْبَعَ الْغَاصِبَ
u'أَتْبَعَ مُدَبَّرٌ':Predicate, #1: 1	أَتْبَعَ الْغُرَمَاءَ
u'أَتْبَعَ مُشْتَرِي':Predicate, #1: 1	أَتْبَعَ الْمُدَبَّرَ
u'أَتْبَعَ وَاطِئٌ':Predicate, #1: 1	أَتْبَعَ الْمُشْتَرِيَ
u'إتْحَافٌ أهْلٌ':Added, #1: 1	أَتْبَعَ الْوَاطِئَ
u'إتْحَافٌ أهْلٌ':Added, #1: 1	إتْحَافَ أَهْلِ
u'إتْحَافٌ أهْلٌ':Added, #1: 1	إتْحَافُ أَهْلِ
u'إتْحَافٌ سَيِّدٌ':Added, #1: 1	إتْحَافِ أَهْلِ
u'إِتْعَابٌ نُفُوسٌ':Added, #1: 1	إتْحَافُ السَّيِّدِ
u'أَتْقَنَ تَأْلِيفٌ':Predicate, #1: 1	إِتْعَابُ النُّفُوسِ
u'أَتْلَفَ أَجْنَبِيٌّ':Subject, #1: 1	أَتْقَنَ التّأْلِيفَ
u'أَتْلَفَ أَجِيرٌ':Subject, #4: 4	أَتْلَفَ أَجْنَبِيٌّ
u'أَتْلَفَ أحَدٌ':Subject, #1: 1	أَتْلَفَ الْأَجِيرُ
u'أَتْلَفَ أحَدٌ':Subject, #1: 1	أَتْلَفَ أَحَدٌ
u'أَتْلَفَ أَشْيَاءٌ':Predicate, #2: 2	أَتْلَفَ أَحَدُ
u'أَتْلَفَ أصل':Predicate, #1: 1	أَتْلَفَ أَشْيَاءَ
u'أَتْلَفَ أًصْلٌ':Predicate, #1: 1	أَتْلَفَ الْأَصْلَ
u'أَتْلَفَ أَكْثَرُ':Predicate, #1: 1	أَتْلَفَ الْأَصْلَ
u'أَتْلَفَ آلةٌ':Predicate, #1: 1	أَتْلَفَ الْأَكْثَرَ
u'أَتْلَفَ إِنْسانٌ':Subject, #2: 2	أَتْلَفَ آلَةَ
u'أَتْلَفَ أهْلٌ':Subject, #2: 2	أَتْلَفَ إنْسَانٌ
u'أَتْلَفَ بَائِعٌ':Subject, #1: 1	أَتْلَفَ أَهْلُ
u'أَتْلَفَ بَعْضٌ':Predicate, #6: 6	أَتْلَفَ الْبَائِعُ
u'أَتْلَفَ بَعْضٌ':Predicate, #2: 2	أَتْلَفَ الْبَعْضَ
u'أَتْلَفَ بَقَرٌ':Predicate, #3: 3	أَتْلَفَ بَعْضَ
u'أَتْلَفَ بيض':Predicate, #1: 1	أَتْلَفَ بَقَرَةً
u'أَتْلَفَ ثِمارٌ':Predicate, #5: 5	أَتْلَفَ بَيْضَ
u'أَتْلَفَ ثَوْبٌ':Predicate, #1: 1	أَتْلَفَ الثِّمَارَ
u'أَتْلَفَ جِرَابٌ':Predicate, #1: 1	أَتْلَفَ الثَّوْبَ
u'أَتْلَفَ جُزْءٌ':Predicate, #1: 1	أَتْلَفَ الْجِرَابَ
u'أَتْلَفَ جَمَاعَةٌ':Subject, #1: 1	أَتْلَفَ الْجُزْءَ
u'أَتْلَفَ جَمْرٌ':Predicate, #1: 1	أَتْلَفَ جَمَاعَةٌ
u'أَتْلَفَ حائِطٌ':Subject, #1: 1	أَتْلَفَ الْجَمْرَ
u'أَتْلَفَ حَقٌّ':Predicate, #1: 1	أَتْلَفَ الْحَائِطُ
u'أَتْلَفَ حَلالٌ':Subject, #3: 3	أَتْلَفَ حَقَّ
u'أَتْلَفَ خَمْرٌ':Predicate, #1: 1	أَتْلَفَ حَلَالٌ
u'أَتْلَفَ خَمْرٌ':Predicate, #1: 1	أَتْلَفَ الْخَمْرَ
u'أَتْلَفَ خَمْلٌ':Predicate, #1: 1	أَتْلَفَ خَمْرَ
u'أَتْلَفَ خِنْزِيرٌ':Predicate, #1: 1	أَتْلَفَ خَمْلَ
u'أَتْلَفَ خَيْلٌ':Predicate, #2: 2	أَتْلَفَ خِنْزِيرَ
u'أَتْلَفَ دَابَّةٌ':Predicate, #1: 1	أَتْلَفَ الْخَيْلَ
u'أَتْلَفَ دِيكٌ':Predicate, #1: 1	أَتْلَفَ الدَّابَّةَ
u'أَتْلَفَ رَبُّ':Subject, #1: 1	أَتْلَفَ دِيكَ
u'أَتْلَفَ رُبْعٌ':Predicate, #5: 5	أَتْلَفَ رَبُّ
u'أَتْلَفَ رَجُلٌ':Subject, #1: 1	أَتْلَفَ رُبْعَ
u'أَتْلَفَ رَهْنٌ':Predicate, #1: 1	أَتْلَفَ رَجُلٌ
u'أَتْلَفَ شَاةٌ':Predicate, #4: 4	أَتْلَفَ الرَّهْنَ
u'أَتْلَفَ شَخْصٌ':Subject, #2: 2	أَتْلَفَ الشَّاةَ
u'أَتْلَفَ شرب':Predicate, #1: 1	أَتْلَفَ شَخْصٌ
u'أَتْلَفَ شِرْبٌ':Predicate, #4: 4	أَتْلَفَ شِرْبَ
u'أَتْلَفَ شَيْءٌ':Predicate, #4: 4	أَتْلَفَ شِرْبَ
u'أَتْلَفَ صَبِيٌّ':Subject, #1: 1	أَتْلَفَ شَيْءَ
u'أَتْلَفَ طعام':Predicate, #2: 2	أَتْلَفَ الصَّبِيُّ
u'أَتْلَفَ طَعَامٌ':Predicate, #1: 1	أَتْلَفَ الطَّعَامَ
u'أَتْلَفَ عَبْدٌ':Predicate, #1: 1	أَتْلَفَ الطَّعَامَ
u'أَتْلَفَ غَاصِبٌ':Subject, #1: 1	أَتْلَفَ عَبْدَ
u'أَتْلَفَ غِذَاءٌ':Predicate, #3: 3	أَتْلَفَ الْغَاصِبُ
u'أَتْلَفَ غير':Predicate, #1: 1	أَتْلَفَ غِذَاءَ
u'أَتْلَفَ غَيْرٌ':Predicate, #2: 2	أَتْلَفَ غَيْرَ
u'أَتْلَفَ فُلاَنٌ':Subject, #2: 2	أَتْلَفَ غَيْرَ
u'أَتْلَفَ قَابِضٌ':Subject, #1: 1	أَتْلَفَ فُلَانٌ
u'أَتْلَفَ قَدْرٌ':Predicate, #1: 1	أَتْلَفَ الْقَابِضُ
u'أَتْلَفَ قصاص':Predicate, #2: 2	أَتْلَفَ الْقَدْرَ
u'أَتْلَفَ قِصَاصٌ':Predicate, #1: 1	أَتْلَفَ الْقِصَاصَ
u'أَتْلَفَ كَافِرٌ':Subject, #1: 1	أَتْلَفَ الْقِصَاصَ
u'أَتْلَفَ كَامِلٌ':Predicate, #1: 1	أَتْلَفَ كَافِرٌ
u'أَتْلَفَ كَسْبٌ':Predicate, #1: 1	أَتْلَفَ الْكَامِلَ
u'أَتْلَفَ لَحْمٌ':Predicate, #1: 1	أَتْلَفَ كَسْبَ
u'أَتْلَفَ مَاءٌ':Predicate, #4: 4	أَتْلَفَ لَحْمَ
u'أَتْلَفَ مَالٌ':Predicate, #1: 1	أَتْلَفَ الْمَاءَ
u'أَتْلَفَ مَالٌ':Predicate, #24: 24	أَتْلَفَ مَالَ
u'أَتْلَفَ مَالِكٌ':Subject, #3: 3	أَتْلَفَ الْمَالَ
u'أَتْلَفَ مَالِيٌّ':Predicate, #2: 2	أَتْلَفَ الْمَالِكُ
u'أَتْلَفَ مَبِيعٌ':Predicate, #1: 1	أَتْلَفَ الْمَالِيَّةَ
u'أَتْلَفَ مَتْرُوكٌ':Predicate, #8: 8	أَتْلَفَ الْمَبِيعَ
u'أَتْلَفَ مُتْلِفٌ':Subject, #1: 1	أَتْلَفَ مَتْرُوكَ
u'أَتْلَفَ مَدْيُونٌ':Predicate, #1: 1	أَتْلَفَ مُتْلِفٌ
u'أَتْلَفَ مُرْتَهِنٌ':Subject, #1: 1	أَتْلَفَ الْمَدْيُونَ
u'أَتْلَفَ مَرْهُونٌ':Predicate, #1: 1	أَتْلَفَ الْمُرْتَهِنُ
u'أَتْلَفَ مَرِيضٌ':Subject, #2: 2	أَتْلَفَ الْمَرْهُونَ
u'أَتْلَفَ مُسْتَأْجِرٌ':Subject, #2: 2	أَتْلَفَ الْمَرِيضُ
u'أَتْلَفَ مُسْلِمٌ':Subject, #2: 2	أَتْلَفَ الْمُسْتَأْجِرُ
u'أَتْلَفَ مُسْلِمٌ':Subject, #1: 1	أَتْلَفَ مُسْلِمٌ
u'أَتْلَفَ مُشْتَرَكٌ':Subject, #5: 5	أَتْلَفَ الْمُسْلِمُ
u'أَتْلَفَ مَعَازِفُ':Predicate, #1: 1	أَتْلَفَ الْمُشْتَرَكُ
u'أَتْلَفَ مَغْرُورٌ':Subject, #1: 1	أَتْلَفَ الْمَعَازِفَ
u'أَتْلَفَ مُكْرَهٌ':Subject, #1: 1	أَتْلَفَ الْمَغْرُورُ
u'أَتْلَفَ مُكَلَّفٌ':Subject, #1: 1	أَتْلَفَ الْمُكْرَهُ
u'أَتْلَفَ مِلْكٌ':Predicate, #1: 1	أَتْلَفَ مُكَلَّفٌ
u'أَتْلَفَ مَنَافِعُ':Predicate, #5: 5	أَتْلَفَ مِلْكَ
u'أَتْلَفَ مَنْفَعَةٌ':Predicate, #1: 1	أَتْلَفَ مَنَافِعَ
u'أَتْلَفَ مُودِعٌ':Subject, #1: 1	أَتْلَفَ مَنْفَعَةَ
u'أَتْلَفَ مَوْقُوذ':Predicate, #1: 1	أَتْلَفَ الْمُودِعُ
u'أَتْلَفَ مَوْقُوفٌ':Subject, #1: 1	أَتْلَفَ مَوْقُوذَةَ
u'أَتْلَفَ نَائِمٌ':Subject, #1: 1	أَتْلَفَ الْمَوْقُوفُ
u'أَتْلَفَ نصاب':Predicate, #1: 1	أَتْلَفَ النَّائِمُ
u'أَتْلَفَ نِصَابٌ':Predicate, #1: 1	أَتْلَفَ نِصَابَ
u'أَتْلَفَ نِصْفٌ':Predicate, #1: 1	أَتْلَفَ نِصَابَ
u'أَتْلَفَ نِصْفٌ':Predicate, #1: 1	أَتْلَفَ النِّصْفَ
u'أَتْلَفَ نِصْفٌ':Subject, #6: 6	أَتْلَفَ نِصْفَ
u'أَتْلَفَ نَفْسٌ':Predicate, #1: 1	أَتْلَفَ نِصْفُ
u'أَتْلَفَ واحد':Subject, #2: 2	أَتْلَفَ نَفْسَ
u'أَتْلَفَ وَاحِدٌ':Subject, #1: 1	أَتْلَفَ وَاحِدٌ
u'أَتْلَفَ وَاهِبٌ':Subject, #1: 1	أَتْلَفَ وَاحِدٌ
u'أَتْلَفَ وَدِيعٌ':Predicate, #1: 1	أَتْلَفَ الْوَاهِبُ
u'أَتْلَفَ وَدِيعٌ':Predicate, #1: 1	أَتْلَفَ وَدِيعَةَ
u'أَتْلَفَ وَدِيعَةٌ':Predicate, #3: 3	أَتْلَفَ الْوَدِيعَةَ
u'أَتْلَفَ وَدِيعَةٌ':Predicate, #1: 1	أَتْلَفَ وَدِيعَةَ
u'أَتْلَفَ وَقْفٌ':Predicate, #3: 3	أَتْلَفَ الْوَدِيعَةَ
u'أَتْلَفَ ولد':Predicate, #1: 1	أَتْلَفَ الْوَقْفَ
u'أَتْلَفَ وَلَدٌ':Predicate, #2: 2	أَتْلَفَ وَلَدَ
u'أَتَمَّ أَذَانٌ':Predicate, #2: 2	أَتْلَفَ وَلَدَ
u'أَتَمَّ أَعْمَالٌ':Predicate, #1: 1	أَتَمَّ الْأَذَانَ
u'أَتَمَّ أَفْعَالٌ':Predicate, #2: 2	أَتَمَّ أَعْمَالَ
u'إتْمَامٌ إجَارَةٌ':Added, #1: 1	أَتَمَّ أَفْعَالَ
u'إتْمَامٌ أُسْبُوعٌ':Added, #2: 2	إتْمَامُ الْإِجَارَةِ
u'إتْمَامٌ أُصولٌ':Added, #1: 1	إتْمَامُ الْأُسْبُوعِ
u'إتْمَامٌ إِعادَةٌ':Added, #1: 1	إتْمَامُ الْأُصُولِ
u'إتْمَامٌ أَفْعَالٌ':Added, #1: 1	إتْمَامِ الْإِعَادَةِ
u'أَتَمَّ إمَامٌ':Subject, #1: 1	إتْمَامِ أَفْعَالِ
u'إتْمَامٌ أَمْرٌ':Added, #5: 5	أَتَمَّ الْإِمَامُ
u'إتْمَامٌ أَوَّلُ':Added, #1: 1	إتْمَامِ الْأَمْرِ
u'إتْمَامٌ أَوَّلُ':Added, #1: 1	إتْمَامُ الْأَوَّلِ
u'إتْمَامٌ بَرٌّ':Added, #1: 1	إتْمَامِ الْأَوَّلِ
u'إتْمَامٌ بِرٌّ':Added, #1: 1	إتْمَامُ الْبَرِّ
u'إتْمَامٌ بَقِيَّةٌ':Added, #1: 1	إتْمَامُ الْبِرِّ
u'إتْمَامٌ بِنَاءٌ':Added, #1: 1	إتْمَامِ بَقِيَّةِ
u'إتْمَامٌ بَيْعٌ':Added, #1: 1	إتْمَامِ بِنَاءِ
u'إتْمَامٌ تَشَهُّدٌ':Added, #1: 1	إتْمَامِ الْبَيْعِ
u'إتْمَامٌ تَطَوُّعٌ':Added, #3: 3	إتْمَامِ التَّشَهُّدِ
u'إتْمَامٌ تَطَوُّعٌ':Added, #1: 1	إتْمَامُ تَطَوُّعٍ
u'إتْمَامٌ تَعْلِيمٌ':Added, #2: 2	إتْمَامَ تَطَوُّعٍ
u'إتْمَامٌ تَكْبيرٌ':Added, #1: 1	إتْمَامِ تَعْلِيمِ
u'إتْمَامٌ ثَالِثٌ':Added, #2: 2	إتْمَامِ التَّكْبِيرِ
u'إتْمَامٌ جمعة':Added, #1: 1	إتْمَامِ الثَّالِثِ
u'إتْمَامٌ جُمُعَةٌ':Added, #1: 1	إتْمَامُ الْجُمُعَةِ
u'إتْمَامٌ جَوَابٌ':Added, #1: 1	إتْمَامُ الْجُمُعَةِ
u'إتْمَامٌ جَوَازٌ':Added, #3: 3	إتْمَامِ الْجَوَابِ
u'إتْمَامٌ حَجٌّ':Added, #1: 1	إتْمَامِ جَوَازِ
u'إتْمَامٌ حَجٌّ':Added, #2: 2	إتْمَامُ الْحَجِّ
u'إتْمَامٌ حَجٌّ':Added, #3: 3	إتْمَامَ الْحَجِّ
u'إتْمَامٌ حَفْرٌ':Added, #7: 7	إتْمَامِ الْحَجِّ
u'إتْمَامٌ خُرُوجٌ':Added, #1: 1	إتْمَامِ حَفْرِهِ
u'إتْمَامٌ رُبُعٌ':Added, #1: 1	إتْمَامِ خُرُوجِ
u'إتْمَامٌ ركعة':Added, #1: 1	إتْمَامُ الرُّبُعِ
u'إتْمَامٌ رَكْعَةٌ':Added, #1: 1	إتْمَامَ الرَّكْعَةِ
u'إتْمَامٌ رُكْنٌ':Added, #1: 1	إتْمَامَ الرَّكْعَةِ
u'إتْمَامٌ رُكْن':Added, #4: 4	إتْمَامَ الرُّكْنِ
u'إتْمَامٌ رَمْيٌ':Added, #4: 4	إتْمَامَ الرُّكْنِ
u'إتْمَامٌ رَمْيٌ':Added, #1: 1	إتْمَامُ الرَّمْيِ
u'إتْمَامٌ سُنَّةٌ':Added, #1: 1	إتْمَامِ الرَّمْيِ
u'إتْمَامٌ سنن':Added, #2: 2	إتْمَامِ سُنَّةِ
u'إتْمَامٌ سُورَةٌ':Added, #1: 1	إتْمَامِ السُّنَنِ
u'إتْمَامٌ شَرْطٌ':Added, #1: 1	إتْمَامَ السُّورَةِ
u'إتْمَامٌ شَفْعٌ':Added, #1: 1	إتْمَامِ شَرْطِ
u'إتْمَامٌ شَفْعٌ':Added, #1: 1	إتْمَامَ الشَّفْعِ
u'إتْمَامٌ شَفْعٌ':Added, #1: 1	إتْمَامُ الشَّفْعِ
u'إتْمَامٌ شَوْطٌ':Added, #1: 1	إتْمَامَ شَفْعٍ
u'إتْمَامٌ صَاعٌ':Added, #1: 1	إتْمَامِ شَوْطِ
u'إتْمَامٌ صَفٌّ':Added, #1: 1	إتْمَامِ الصَّاعِ
u'إتْمَامٌ صَلاَةٌ':Added, #1: 1	إتْمَامِ صَفٍّ
u'إتْمَامٌ صَلاَةٌ':Added, #15: 15	إتْمَامِ الصَّلَاةِ
u'إتْمَامٌ صَلاَةٌ':Added, #1: 1	إتْمَامُ صَلَاةٍ
u'إتْمَامٌ صَلاَةٌ':Added, #1: 1	إتْمَامُ صَلَاةِ
u'إتْمَامٌ صَلاَةٌ':Added, #1: 1	إتْمَامَ صَلَاتِهِ
u'إتْمَامٌ صَلاَةٌ':Added, #1: 1	إتْمَامُ صَلَاتِهِ
u'إتْمَامٌ صَلاَةٌ':Added, #20: 20	إتْمَامِ صَلَاتِهِ
u'إتْمَامٌ صَلاَةٌ':Added, #3: 3	إتْمَامَ الصَّلَاةِ
u'إتْمَامٌ صَلاَةٌ':Added, #4: 4	إتْمَامِ صَلَاةِ
u'إتْمَامٌ صَوْمٌ':Added, #6: 6	إتْمَامُ الصَّلَاةِ
u'إتْمَامٌ صَوْمٌ':Added, #1: 1	إتْمَامَ الصَّوْمِ
u'إتْمَامٌ صَوْمٌ':Added, #1: 1	إتْمَامِ الصَّوْمِ
u'إتْمَامٌ صَوْمٌ':Added, #2: 2	إتْمَامُ صَوْمِ
u'إتْمَامٌ صِيَامٌ':Added, #4: 4	إتْمَامُ الصَّوْمِ
u'إتْمَامٌ طواف':Added, #1: 1	إتْمَامُ صِيَامِ
u'إتْمَامٌ طَوَافٌ':Added, #1: 1	إتْمَامُ الطَّوَافِ
u'إتْمَامٌ طواف':Added, #1: 1	إتْمَامُ الطَّوَافِ
u'إتْمَامٌ طَوَافٌ':Added, #1: 1	إتْمَامِ طَوَافِهِ
u'إتْمَامٌ عِبَادَةٌ':Added, #1: 1	إتْمَامِ طَوَافِهِ
u'إتْمَامٌ عِبَادَةٌ':Added, #1: 1	إتْمَامُ الْعِبَادَةِ
u'إتْمَامٌ عتق':Added, #1: 1	إتْمَامِ الْعِبَادَةِ
u'إتْمَامٌ عِتْقٌ':Added, #1: 1	إتْمَامِ الْعِتْقِ
u'إتْمَامٌ عِدَّةٌ':Added, #1: 1	إتْمَامِ الْعِتْقِ
u'إتْمَامٌ عِدَّةٌ':Added, #1: 1	إتْمَامِ الْعِدَّةِ
u'إتْمَامٌ عَدَدٌ':Added, #5: 5	إتْمَامُ الْعِدَّةِ
u'إتْمَامٌ عَصْرٌ':Added, #1: 1	إتْمَامِ الْعَدَدِ
u'إتْمَامٌ عَصْرٌ':Added, #1: 1	إتْمَامَ الْعَصْرِ
u'إتْمَامٌ عَصْرٌ':Added, #1: 1	إتْمَامُ الْعَصْرِ
u'إتْمَامٌ عَقْدٌ':Added, #1: 1	إتْمَامِ الْعَصْرِ
u'إتْمَامٌ عِلَّةٌ':Added, #1: 1	إتْمَامِ عَقْدٍ
u'إتْمَامٌ عمرة':Added, #1: 1	إتْمَامِ الْعِلَّةِ
u'إتْمَامٌ عُمْرَةٌ':Added, #1: 1	إتْمَامُ عُمْرَةٍ
u'إتْمَامٌ عمرة':Added, #1: 1	إتْمَامُ عُمْرَةٍ
u'إتْمَامٌ عُمْرَةٌ':Added, #2: 2	إتْمَامِ الْعُمْرَةِ
u'إتْمَامٌ عَمَلٌ':Added, #2: 2	إتْمَامِ الْعُمْرَةِ
u'إتْمَامٌ عَمَلٌ':Added, #4: 4	إتْمَامُ الْعَمَلِ
u'إتْمَامٌ غَرَضٌ':Added, #4: 4	إتْمَامِ الْعَمَلِ
u'إتْمَامٌ غَرَضٌ':Added, #1: 1	إتْمَامُ غَرَضِ
u'إتْمَامٌ غُسْلٌ':Added, #1: 1	إتْمَامِ غَرَضِهِ
u'إتْمَامٌ فَاتِحٌ':Added, #1: 1	إتْمَامِ الْغُسْلِ
u'إتْمَامٌ فَاتِحٌ':Added, #1: 1	إتْمَامِ الْفَاتِحَةِ
u'إتْمَامٌ فَاتِحَةٌ':Added, #2: 2	إتْمَامُ الْفَاتِحَةِ
u'إتْمَامٌ فَاتِحَةٌ':Added, #1: 1	إتْمَامِ الْفَاتِحَةِ
u'إتْمَامٌ فَرْضٌ':Added, #2: 2	إتْمَامُ الْفَاتِحَةِ
u'إتْمَامٌ فَرْضٌ':Added, #1: 1	إتْمَامَ الْفَرْضِ
u'إتْمَامٌ فَرْضٌ':Added, #1: 1	إتْمَامِ فَرْضِهِ
u'إتْمَامٌ فرق':Added, #2: 2	إتْمَامِ الْفَرْضِ
u'إتْمَامٌ فَرْقٌ':Added, #1: 1	إتْمَامِ الْفَرْقِ
u'إتْمَامٌ فَرِيضَةٌ':Added, #1: 1	إتْمَامِ الْفَرْقِ
u'إتْمَامٌ فَضَائِلُ':Added, #1: 1	إتْمَامَ فَرِيضَةٍ
u'إتْمَامٌ فِعْلٌ':Added, #1: 1	إتْمَامِ الْفَضَائِلِ
u'إتْمَامٌ قتل':Added, #1: 1	إتْمَامِ فِعْلِ
u'إتْمَامٌ قَتْلٌ':Added, #1: 1	إتْمَامِ الْقَتْلِ
u'إتْمَامٌ قَصْدٌ':Added, #1: 1	إتْمَامِ الْقَتْلِ
u'إتْمَامٌ كَفَّارٌ':Added, #1: 1	إتْمَامِ قَصْدِهِ
u'إتْمَامٌ كَفَّارَةٌ':Added, #1: 1	إتْمَامِ الْكَفَّارَةِ
u'إتْمَامٌ كَلاَمٌ':Added, #1: 1	إتْمَامِ الْكَفَّارَةِ
u'إتْمَامٌ كَلاَمٌ':Added, #1: 1	إتْمَامُ الْكَلَامِ
u'إتْمَامٌ كَلِمَةٌ':Added, #2: 2	إتْمَامَ الْكَلَامِ
u'إتْمَامٌ مالِك':Added, #1: 1	إتْمَامِ كَلِمَاتِهِ
u'إتْمَامٌ مالِكِيّ':Added, #1: 1	إتْمَامِ الْمَالِكِيَّةِ
u'إتْمَامٌ مُدَّةٌ':Added, #1: 1	إتْمَامِ الْمَالِكِيَّةِ
u'إتْمَامٌ مُفْسِدٌ':Added, #1: 1	إتْمَامُ الْمُدَّةِ
u'إتْمَامٌ مَقْصُودٌ':Added, #1: 1	إتْمَامُ الْمُفْسِدِ
u'إتْمَامٌ مَقْصُودٌ':Added, #1: 1	إتْمَامِ مَقْصُودِهِ
u'إتْمَامٌ مَكْتُوبٌ':Added, #4: 4	إتْمَامُ الْمَقْصُودِ
u'إتْمَامٌ مِلْكٌ':Added, #1: 1	إتْمَامُ الْمَكْتُوبَةِ
u'إتْمَامٌ مَهْرٌ':Added, #1: 1	إتْمَامُ الْمِلْكِ
u'إتْمَامٌ مَهْرٌ':Added, #1: 1	إتْمَامُ مَهْرِ
u'إتْمَامٌ نَافِلَةٌ':Added, #1: 1	إتْمَامِ مَهْرِ
u'إتْمَامٌ نُسُكٌ':Added, #1: 1	إتْمَامُ نَافِلَتِهِ
u'إتْمَامٌ نعمة':Added, #1: 1	إتْمَامِ نُسُكِهِ
u'إتْمَامٌ نَعْمَةٌ':Added, #1: 1	إتْمَامَ النّعْمَةِ
u'إتْمَامٌ نِعْمَةٌ':Added, #1: 1	إتْمَامَ النّعْمَةِ
u'إتْمَامٌ نَفْلٌ':Added, #1: 1	إتْمَامَ النّعْمَةِ
u'إتْمَامٌ نَفْلٌ':Added, #1: 1	إتْمَامُ نَفْلِ
u'إتْمَامٌ وُضُوءٌ':Added, #3: 3	إتْمَامَ نَفْلٍ
u'إتْمَامٌ وُضُوءٌ':Added, #1: 1	إتْمَامِ وُضُوءِ
u'إتْمَامٌ يَوْمٌ':Added, #2: 2	إتْمَامِ الْوُضُوءِ
u'أَتَمَّ باقِي':Predicate, #1: 1	إتْمَامِ الْيَوْمِ
u'أَتَمَّ بَقِيَّةٌ':Predicate, #1: 1	أَتَمَّ الْبَاقِيَ
u'أَتَمَّ تَرَاوِيحُ':Predicate, #3: 3	أَتَمَّ بَقِيَّةَ
u'أَتَمَّ تَشَهُّدٌ':Predicate, #1: 1	أَتَمَّ التَّرَاوِيحَ
u'أَتَمَّ تَكْبيرٌ':Predicate, #2: 2	أَتَمَّ التَّشَهُّدَ
u'أَتَمَّ تَمٌّ':Predicate, #2: 2	أَتَمَّ التَّكْبِيرَ
u'أَتَمَّ جماع':Predicate, #1: 1	أَتَمَّ تَمَّ
u'أَتَمَّ جِمَاعٌ':Predicate, #1: 1	أَتَمَّ الْجِمَاعَ
u'أَتَمَّ جمعة':Predicate, #1: 1	أَتَمَّ الْجِمَاعَ
u'أَتَمَّ جُمُعَةٌ':Predicate, #3: 3	أَتَمَّ الْجُمُعَةَ
u'أَتَمَّ حَجٌّ':Predicate, #3: 3	أَتَمَّ الْجُمُعَةَ
u'أَتَمَّ خَمْسٌ':Predicate, #2: 2	أَتَمَّ الْحَجَّ
u'أَتَمَّ دَليلٌ':Predicate, #1: 1	أَتَمَّ خَمْسَ
u'أَتَمَّ ذَكاةٌ':Predicate, #1: 1	أَتَمَّ الدَّلِيلَ
u'أَتَمَّ رابع':Predicate, #2: 2	أَتَمَّ الذَّكَاةَ
u'أَتَمَّ رَابِعٌ':Predicate, #1: 1	أَتَمَّ الرَّابِعَةَ
u'أَتَمَّ رُكوعٌ':Predicate, #1: 1	أَتَمَّ الرَّابِعَةَ
u'أَتَمَّ رَمْيٌ':Predicate, #1: 1	أَتَمَّ الرُّكُوعَ
u'أَتَمَّ زَوْجٌ':Subject, #1: 1	أَتَمَّ الرَّمْيَ
u'أَتَمَّ سُورَةٌ':Predicate, #1: 1	أَتَمَّ الزَّوْجُ
u'أَتَمَّ شَفْعٌ':Predicate, #1: 1	أَتَمَّ السُّورَةَ
u'أَتَمَّ صَلاَةٌ':Predicate, #1: 1	أَتَمَّ الشَّفْعَ
u'أَتَمَّ صَلاَةٌ':Predicate, #14: 14	أَتَمَّ الصَّلَاةَ
u'أَتَمَّ صَلاَةٌ':Predicate, #3: 3	أَتَمَّ صَلَاةَ
u'أَتَمَّ صَوْمٌ':Predicate, #7: 7	أَتَمَّ الصَّلاَةَ
u'أَتَمَّ طَهَارَةٌ':Predicate, #1: 1	أَتَمَّ الصَّوْمَ
u'أَتَمَّ طواف':Predicate, #1: 1	أَتَمَّ الطَّهَارَةَ
u'أَتَمَّ طَوَافٌ':Predicate, #1: 1	أَتَمَّ الطَّوَافَ
u'أَتَمَّ عَبْدٌ':Subject, #1: 1	أَتَمَّ الطَّوَافَ
u'أَتَمَّ عَصْرٌ':Predicate, #1: 1	أَتَمَّ الْعَبْدُ
u'أَتَمَّ فِعْلٌ':Predicate, #1: 1	أَتَمَّ الْعَصْرَ
u'أَتَمَّ فلان':Subject, #3: 3	أَتَمَّ الْفِعْلَ
u'أَتَمَّ قَالٌ':Predicate, #1: 1	أَتَمَّ عُثْمَانُ
u'أَتَمَّ قِرَاءةٌ':Predicate, #1: 1	أَتَمَّ قَالَ
u'أَتَمَّ قَضَاءٌ':Predicate, #2: 2	أَتَمَّ الْقِرَاءَةَ
u'أَتَمَّ مُتَمَتِّعٌ':Subject, #1: 1	أَتَمَّ قَضَاءَ
u'أَتَمَّ مُسَافِرٌ':Subject, #1: 1	أَتَمَّ الْمُتَمَتِّعُ
u'أَتَمَّ مُسَافِرٌ':Subject, #1: 1	أَتَمَّ مُسَافِرٌ
u'أَتَمَّ مَسْبُوق':Subject, #2: 2	أَتَمَّ الْمُسَافِرُ
u'أَتَمَّ مَسْحٌ':Predicate, #1: 1	أَتَمَّ الْمَسْبُوقُ
u'أَتَمَّ نَافِلَةٌ':Predicate, #11: 11	أَتَمَّ مَسْحَ
u'أَتَمَّ نَصٌّ':Predicate, #3: 3	أَتَمَّ النَّافِلَةَ
u'أَتَمَّ نَظَرٌ':Predicate, #1: 1	أَتَمَّ نَصَّ
u'أَتَمَّ نَظَرٌ':Subject, #1: 1	أَتَمَّ النَّظَرَ
u'أَتَمَّ نَفَذٌ':Predicate, #1: 1	أَتَمَّ نَظَرُ
u'أَتَمَّ وُضُوءٌ':Predicate, #1: 1	أَتَمَّ نَفَذَ
u'أَتَى اِبْنٌ':Predicate, #1: 1	أَتَمَّ الْوُضُوءَ
u'أَتَى اِبْنٌ':Subject, #20: 20	أَتَى ابْنَ
u'أَتَى أَبْوَابٌ':Predicate, #8: 8	أَتَى ابْنُ
u'أَتَى أَجْنَبِيٌّ':Predicate, #4: 4	أَتَى أَبْوَابَ
u'آتَى أُجُورٌ':Predicate, #2: 2	أَتَى أَجْنَبِيَّةً
u'أَتَى أَجِيرٌ':Subject, #1: 1	آتَى أُجُورَهُنَّ
u'أَتَى أحَدٌ':Subject, #1: 1	أَتَى الْأَجِيرُ
u'أَتَى أرْضٌ':Predicate, #1: 1	أَتَى أَحَدُ
u'أَتَى أرْضٌ':Predicate, #1: 1	أَتَى الأَرْضَ
u'أَتَى إِسْلامٌ':Subject, #2: 2	أَتَى أَرْضَ
u'أَتَى أَصْحَابٌ':Subject, #1: 1	أَتَى الْإِسْلَامُ
u'أَتَى أعْرَابِيٌّ':Subject, #2: 2	أَتَى أَصْحَابُهُ
u'أَتَى أفْضَلُ':Predicate, #1: 1	أَتَى أَعْرَابِيٌّ
u'أَتَى أقَلُّ':Subject, #1: 1	أَتَى الْأَفْضَلَ
u'أَتَى الْمَرْأَةُ':Predicate, #1: 1	أَتَى أَقَلُّ
u'أَتَى إمَامٌ':Predicate, #2: 2	أَتَى الْمَرْأَةَ
u'أَتَى إمَامٌ':Subject, #1: 1	أَتَى الْإِمَامَ
u'أَتَى إمَامٌ':Subject, #1: 1	أَتَى الإِمَامُ
u'أَتَى أَمْرٌ':Predicate, #2: 2	أَتَى الْإِمَامُ
u'أَتَى أَمْرٌ':Subject, #1: 1	أَتَى الْأَمْرَ
u'أَتَى أَميرٌ':Predicate, #4: 4	أَتَى أَمْرُ
u'أَتَى أَميرٌ':Subject, #1: 1	أَتَى أَمِيرَ
u'أَتَى أُناسٌ':Subject, #1: 1	أَتَى أَمِيرُ
u'أَتَى إِنْسانٌ':Subject, #1: 1	أَتَى أُنَاسٌ
u'أَتَى أهْلٌ':Predicate, #1: 1	أَتَى الْإِنْسَانُ
u'أَتَى أهْلٌ':Subject, #6: 6	أَتَى أَهْلَ
u'أَتَى أهْلٌ':Subject, #1: 1	أَتَى أَهْلُ
u'أَتَى أَوْلِيَاءُ':Subject, #1: 1	أَتَى أَهْلُهُ
u'أَتَى بَابٌ':Predicate, #1: 1	أَتَى الْأَوْلِيَاءُ
u'أَتَى بَابٌ':Predicate, #1: 1	أَتَى الْبَابَ
u'أَتَى بَائِعٌ':Subject, #7: 7	أَتَى بَابَ
u'أَتَى بَدَلٌ':Predicate, #1: 1	أَتَى الْبَائِعُ
u'أَتَى بُسْرَةٌ':Predicate, #4: 4	أَتَى بَدَلَ
u'أَتَى بَطْنٌ':Predicate, #1: 1	أَتَى بُسْرَةَ
u'أَتَى بَعْضٌ':Predicate, #5: 5	أَتَى بَطْنَ
u'أَتَى بَعْضٌ':Subject, #1: 1	أَتَى بَعْضَ
u'أَتَى بَغْدادُ':Predicate, #3: 3	أَتَى بَعْضُ
u'أَتَى بَقاءٌ':Subject, #1: 1	أَتَى بَغْدَادَ
u'أَتَى بَلَدٌ':Predicate, #1: 1	أَتَى بَقَاءُ
u'أَتَى بَهيمٌ':Predicate, #1: 1	أَتَى الْبَلَدَ
u'أَتَى بَهِيمَةٌ':Predicate, #4: 4	أَتَى الْبَهِيمَةَ
u'أَتَى بَيْتٌ':Predicate, #4: 4	أَتَى الْبَهِيمَةَ
u'أَتَى بَيْتٌ':Predicate, #3: 3	أَتَى بَيْتَ
u'أَتَى تَنْعِيمٌ':Predicate, #7: 7	أَتَى الْبَيْتَ
u'أَتَى ثَابِتٌ':Subject, #1: 1	أَتَى التَّنْعِيمَ
u'أَتَى ثَبْتٌ':Subject, #1: 1	أَتَى ثَابِتُ
u'أَتَى جَابِرٌ':Predicate, #1: 1	أَتَى الثَّبْتُ
u'أَتَى جَارِي':Predicate, #1: 1	أَتَى جَابِرَ
u'أَتَى جَارِيَةٌ':Predicate, #1: 1	أَتَى جَارِيَةَ
u'أَتَى جِعْران':Predicate, #1: 1	أَتَى جَارِيَةَ
u'أَتَى جَمَّالٌ':Subject, #1: 1	أَتَى الْجِعْرَانَةَ
u'أَتَى جَمْرَةٌ':Predicate, #1: 1	أَتَى الْجَمَّالُ
u'أَتَى جَمْرَة':Predicate, #3: 3	أَتَى جَمْرَةَ
u'أَتَى جَمْرَةٌ':Predicate, #3: 3	أَتَى جَمْرَةَ
u'أَتَى جَمْرَة':Predicate, #7: 7	أَتَى الْجَمْرَةَ
u'أَتَى جمعة':Predicate, #7: 7	أَتَى الْجَمْرَةَ
u'أَتَى جُمُعَةٌ':Predicate, #14: 14	أَتَى الْجُمُعَةَ
u'أَتَى جمعة':Predicate, #14: 14	أَتَى الْجُمُعَةَ
u'أَتَى جَوَابٌ':Subject, #1: 1	أَتَى الْجُمَعَةَ
u'أَتَى حاجَةٌ':Predicate, #1: 1	أَتَى الْجَوَابُ
u'أَتَى حادٌّ':Subject, #1: 1	أَتَى الْحَاجَةَ
u'أَتَى حارِثٌ':Subject, #1: 1	أَتَى الْحَادُّ
u'أَتَى حَبْلٌ':Predicate, #1: 1	أَتَى الْحَارِثُ
u'أَتَى حُجَّاجٌ':Predicate, #2: 2	أَتَى حَبْلاً
u'أَتَى حَجَرٌ':Predicate, #1: 1	أَتَى الْحُجَّاجَ
u'أَتَى حَرَمٌ':Predicate, #5: 5	أَتَى الْحَجَرَ
u'أَتَى حَسَنٌ':Predicate, #1: 1	أَتَى الْحَرَمَ
u'أَتَى حَسْنَاءُ':Predicate, #1: 1	أَتَى الْحَسَنَ
u'أَتَى حَمْز':Predicate, #2: 2	أَتَى الْحَسْنَاءَ
u'أَتَى حول':Subject, #3: 3	أَتَى حَمْزَةَ
u'أَتَى حَوْلٌ':Subject, #1: 1	أَتَى الْحَوْلُ
u'أَتَى خَادِمٌ':Subject, #1: 1	أَتَى الْحَوْلُ
u'أَتَى خِبَاءٌ':Predicate, #1: 1	أَتَى خَادِمٌ
u'أَتَى خِدْرٌ':Predicate, #1: 1	أَتَى خِبَاءَ
u'أَتَى خَصْمٌ':Subject, #2: 2	أَتَى الْخِدْرَ
u'أَتَى خَطِيئَةٌ':Predicate, #1: 1	أَتَى الْخَصْمُ
u'أَتَى خَلاَءٌ':Predicate, #1: 1	أَتَى الْخَطِيئَةَ
u'أَتَى خَلاَءٌ':Predicate, #2: 2	أَتَى الْخَلَاءَ
u'أَتَى خِلاَفٌ':Subject, #4: 4	أَتَى الْخَلاَءَ
u'أَتَى خِلاَفَةٌ':Predicate, #1: 1	أَتَى خِلَافٌ
u'أَتَى خَيَّاطٌ':Subject, #1: 1	أَتَى الْخِلَافَةَ
u'أَتَى دَارٌ':Predicate, #1: 1	أَتَى الْخَيَّاطُ
u'أَتَى دَرَجٌ':Predicate, #1: 1	أَتَى دَارَ
u'أَتَى دَرَجَ':Predicate, #1: 1	أَتَى دَرَجَ
u'أَتَى دفع':Predicate, #1: 1	أَتَى دَرَجَ
u'أَتَى دَفْعٌ':Predicate, #1: 1	أَتَى الدَّفْعَ
u'أَتَى دفع':Subject, #1: 1	أَتَى الدَّفْعَ
u'أَتَى دَفْعٌ':Subject, #3: 3	أَتَى الدَّفْعُ
u'أَتَى رَأْسٌ':Subject, #3: 3	أَتَى الدَّفْعُ
u'أَتَى رَاهِنٌ':Subject, #1: 1	أَتَى رَأْسُ
u'أَتَى رَجُلٌ':Predicate, #1: 1	أَتَى الرَّاهِنُ
u'أَتَى رَجُلٌ':Subject, #1: 1	أَتَى الرَّجُلَ
u'أَتَى رَجُلٌ':Subject, #17: 17	أَتَى الرَّجُلُ
u'أَتَى رَسُولٌ':Predicate, #44: 44	أَتَى رَجُلٌ
u'أَتَى رَسُولٌ':Subject, #110: 110	أَتَى رَسُولَ
u'أَتَى رُكْنٌ':Predicate, #16: 16	أَتَى رَسُولُ
u'أَتَى رُكْن':Predicate, #2: 2	أَتَى الرُّكْنَ
u'أَتَى رَهْطٌ':Subject, #2: 2	أَتَى الرُّكْنَ
u'أَتَى زَمانٌ':Subject, #2: 2	أَتَى رَهْطٌ
u'أَتَى زَوْجٌ':Subject, #1: 1	أَتَى زَمَانٌ
u'أَتَى زَيْدٌ':Subject, #3: 3	أَتَى الزَّوْجُ
u'أَتَى سَاحِرٌ':Predicate, #1: 1	أَتَى زَيْدُ
u'أَتَى سَاحِرٌ':Subject, #1: 1	أَتَى السَّاحِرَ
u'أَتَى سَاحِلٌ':Predicate, #2: 2	أَتَى السَّاحِرُ
u'أَتَى سُباط':Predicate, #1: 1	أَتَى السَّاحِلَ
u'أَتَى سُباطَة':Predicate, #8: 8	أَتَى سُبَاطَةَ
u'أَتَى سُدَّةٌ':Predicate, #8: 8	أَتَى سُبَاطَةَ
u'أَتَى سَعْدٌ':Predicate, #1: 1	أَتَى السُّدَّةَ
u'أَتَى سَعْدٌ':Subject, #2: 2	أَتَى سَعْدَ
u'أَتَى سِقَايَةٌ':Predicate, #1: 1	أَتَى سَعْدُ
u'أَتَى سُلْطَانٌ':Predicate, #2: 2	أَتَى السِّقَايَةَ
u'أَتَى سَمَاءٌ':Predicate, #4: 4	أَتَى السُّلْطَانَ
u'أَتَى سُوقٌ':Predicate, #1: 1	أَتَى السَّمَاءَ
u'أَتَى سُوقٌ':Predicate, #1: 1	أَتَى السُّوقَ
u'أَتَى سَيِّدٌ':Subject, #1: 1	أَتَى سُوقَ
u'أَتَى سَيِّدٌ':Subject, #1: 1	أَتَى سَيِّدُ
u'أَتَى شافِعِيّ':Subject, #1: 1	أَتَى سَيِّدُهُ
u'أَتَى شَاهِدٌ':Subject, #1: 1	أَتَى الشَّافِعِيُّ
u'أَتَى شَجَرَةٌ':Predicate, #1: 1	أَتَى الشَّاهِدُ
u'أَتَى شِعْبٌ':Predicate, #1: 1	أَتَى الشَّجَرَةَ
u'أَتَى صَاحِبٌ':Predicate, #1: 1	أَتَى الشِّعْبَ
u'أَتَى صَاحِبٌ':Subject, #2: 2	أَتَى صَاحِبَ
u'أَتَى صَاحِبٌ':Subject, #1: 1	أَتَى صَاحِبُ
u'أَتَى صِبْيَانٌ':Predicate, #1: 1	أَتَى صَاحِبُهُ
u'أَتَى صَغِيرٌ':Predicate, #1: 1	أَتَى الصِّبْيَانَ
u'أَتَى صَغِيرٌ':Subject, #1: 1	أَتَى صَغِيرَةً
u'أَتَى صَفٌّ':Predicate, #1: 1	أَتَى صَغِيرٌ
u'أَتَى صَفْوَان':Predicate, #2: 2	أَتَى الصَّفَّ
u'أَتَى صَلاَةٌ':Predicate, #1: 1	أَتَى صَفْوَانَ
u'أَتَى صَلاَةٌ':Predicate, #3: 3	أَتَى الصَّلاَةَ
u'أَتَى ضَرْبٌ':Subject, #4: 4	أَتَى الصَّلَاةَ
u'أَتَى طَهُورٌ':Subject, #1: 1	أَتَى الضَّرْبُ
u'أَتَى طَيْرٌ':Predicate, #1: 1	أَتَى طَهُورُهُ
u'أَتَى عَارِي':Predicate, #1: 1	أَتَى الطَّيْرَ
u'أَتَى عَاصِمٌ':Predicate, #1: 1	أَتَى عَارِيَ
u'أَتَى عَامٌّ':Predicate, #2: 2	أَتَى عَاصِمَ
u'أَتَى عَامِّيٌّ':Subject, #1: 1	أَتَى عَامَّةً
u'أَتَى عَائِشٌ':Predicate, #1: 1	أَتَى الْعَامِّيُّ
u'أَتَى عَبَّاسٌ':Subject, #1: 1	أَتَى عَائِشَةَ
u'أَتَى عَبْدٌ':Predicate, #1: 1	أَتَى الْعَبَّاسُ
u'أَتَى عَبْدٌ':Subject, #6: 6	أَتَى عَبْدَ
u'أَتَى عَبْدٌ':Subject, #3: 3	أَتَى الْعَبْدُ
u'أَتَى عتمة':Predicate, #5: 5	أَتَى عَبْدُ
u'أَتَى عَتَمَةٌ':Predicate, #1: 1	أَتَى الْعَتَمَةَ
u'أَتَى عُرْضٌ':Predicate, #1: 1	أَتَى الْعَتَمَةَ
u'أَتَى عرفة':Predicate, #1: 1	أَتَى عُرْضَ
u'أَتَى عَسْكَرٌ':Predicate, #6: 6	أَتَى عَرَفَةَ
u'أَتَى عَطْشَان':Predicate, #1: 1	أَتَى الْعَسْكَرَ
u'أَتَى علم':Subject, #1: 1	أَتَى عَطْشَانَ
u'أَتَى عِلْمٌ':Subject, #1: 1	أَتَى الْعِلْمُ
u'أَتَى عَلِيٌّ':Predicate, #1: 1	أَتَى الْعِلْمُ
u'أَتَى عَلِيٌّ':Subject, #1: 1	أَتَى عَلِيَّ
u'أَتَى عَلِيٌّ':Subject, #1: 1	أَتَى عَلِيُّ
u'أَتَى عُمَرٌ':Predicate, #2: 2	أَتَى عَلِيٌّ
u'أَتَى عُمَرٌ':Subject, #14: 14	أَتَى عُمَرَ
u'أَتَى غَرِيمٌ':Subject, #4: 4	أَتَى عُمَرُ
u'أَتَى غَسَّانٌ':Predicate, #1: 1	أَتَى الْغَرِيمُ
u'أَتَى غير':Subject, #4: 4	أَتَى غَسّانَ
u'أَتَى غَيْرٌ':Subject, #1: 1	أَتَى غَيْرُهُ
u'أَتَى فَاحِشٌ':Predicate, #1: 1	أَتَى غَيْرُهُ
u'أَتَى فَاطِمٌ':Predicate, #1: 1	أَتَى فَاحِشَةً
u'أَتَى فَضْلٌ':Subject, #4: 4	أَتَى فَاطِمَةَ
u'أَتَى فلان':Predicate, #1: 1	أَتَى فَضْلُهُ
u'أَتَى فلان':Predicate, #12: 12	أَتَى الْمُزْدَلِفَةَ
u'أَتَى فلان':Predicate, #13: 13	أَتَى مَكَّةَ
u'أَتَى فلان':Predicate, #1: 1	أَتَى الزُّبَيْرَ
u'أَتَى فلان':Predicate, #1: 1	أَتَى خَيْبَرَ
u'أَتَى فلان':Predicate, #1: 1	أَتَى دِجْلَةَ
u'أَتَى فلان':Predicate, #1: 1	أَتَى مُعَاوِيَةَ
u'أَتَى فلان':Predicate, #2: 2	أَتَى مُزْدَلِفَةَ
u'أَتَى فلان':Predicate, #3: 3	أَتَى حَمْزَةَ
u'أَتَى فلان':Predicate, #3: 3	أَتَى مَكّةَ
u'أَتَى فلان':Subject, #4: 4	أَتَى عُثْمَانَ
u'أَتَى فلان':Subject, #1: 1	أَتَى الشَّافِعِيُّ
u'أَتَى فلان':Subject, #1: 1	أَتَى بِلَالٌ
u'أَتَى فلان':Subject, #1: 1	أَتَى حُذَيْفَةُ
u'أَتَى قَارِئٌ':Subject, #2: 2	أَتَى عُثْمَانُ
u'أَتَى قَالٌ':Predicate, #1: 1	أَتَى الْقَارِئُ
u'أَتَى قَبَائِلُ':Predicate, #1: 1	أَتَى قَالَ
u'أَتَى قُبَّةٌ':Predicate, #1: 1	أَتَى الْقَبَائِلَ
u'أَتَى قَبْرٌ':Predicate, #1: 1	أَتَى قُبَّةَ
u'أَتَى قَبْرٌ':Predicate, #3: 3	أَتَى قَبْرَ
u'أَتَى قتال':Subject, #6: 6	أَتَى الْقَبْرَ
u'أَتَى قِتَالٌ':Subject, #2: 2	أَتَى الْقِتَالُ
u'أَتَى قُرْبٌ':Predicate, #2: 2	أَتَى الْقِتَالُ
u'أَتَى قَرْيَةٌ':Predicate, #1: 1	أَتَى قُرْبَ
u'أَتَى قُزَحٌ':Predicate, #1: 1	أَتَى الْقَرْيَةَ
u'أَتَى قَصْرٌ':Predicate, #1: 1	أَتَى قُزَحَ
u'أَتَى قَيْصَرٌ':Predicate, #3: 3	أَتَى الْقَصْرَ
u'أَتَى كَافِرٌ':Subject, #2: 2	أَتَى قَيْصَرَ
u'أَتَى كَعْبٌ':Predicate, #2: 2	أَتَى الْكَافِرُ
u'أَتَى كعبة':Predicate, #3: 3	أَتَى كَعْبَ
u'أَتَى كَعْبَةٌ':Predicate, #2: 2	أَتَى الْكَعْبَةَ
u'أَتَى كُوفِيٌّ':Subject, #2: 2	أَتَى الْكَعْبَةَ
u'أَتَى مَاءٌ':Subject, #2: 2	أَتَى الْكُوفِيُّ
u'أَتَى مَاعِزٌ':Subject, #1: 1	أَتَى الْمَاءُ
u'أَتَى مُتَمَتِّعٌ':Subject, #1: 1	أَتَى مَاعِزُ
u'أَتَى مثل':Predicate, #1: 1	أَتَى الْمُتَمَتِّعُ
u'أَتَى مِثْلٌ':Predicate, #1: 1	أَتَى مِثْلَ
u'أَتَى مَجْلِسٌ':Predicate, #1: 1	أَتَى مِثْلَ
u'أَتَى مُحَارِبٌ':Subject, #3: 3	أَتَى مَجْلِسَ
u'أَتَى مَدِينٌ':Predicate, #1: 1	أَتَى الْمُحَارِبُ
u'أَتَى مَدِينَةٌ':Predicate, #6: 6	أَتَى الْمَدِينَةَ
u'أَتَى مُرْتَهِنٌ':Subject, #6: 6	أَتَى الْمَدِينَةَ
u'أَتَى مرو':Predicate, #1: 1	أَتَى الْمُرْتَهِنُ
u'أَتَى مَرِيضٌ':Predicate, #5: 5	أَتَى الْمَرْوَةَ
u'أَتَى مَسْبُوق':Subject, #1: 1	أَتَى الْمَرِيضَ
u'أَتَى مَسْجِدٌ':Predicate, #1: 1	أَتَى الْمَسْبُوقُ
u'أَتَى مَسْجِدٌ':Predicate, #2: 2	أَتَى مَسْجِدَ
u'أَتَى مُشْرِك':Predicate, #31: 31	أَتَى الْمَسْجِدَ
u'أَتَى مَشْعَرٌ':Predicate, #1: 1	أَتَى الْمُشْرِكِينَ
u'أَتَى مَشْعَر':Predicate, #3: 3	أَتَى الْمَشْعَرَ
u'أَتَى مُصَدِّقٌ':Subject, #3: 3	أَتَى الْمَشْعَرَ
u'أَتَى مُصَنِّفٌ':Subject, #1: 1	أَتَى مُصَدِّقُ
u'أَتَى مَطَرٌ':Subject, #4: 4	أَتَى الْمُصَنِّفُ
u'أَتَى مَطَرٌ':Subject, #2: 2	أَتَى مَطَرٌ
u'أَتَى مُعاوِيَة':Predicate, #3: 3	أَتَى الْمَطَرُ
u'أَتَى مُعَظَّمٌ':Predicate, #1: 1	أَتَى مُعَاوِيَةَ
u'أَتَى مُغْتَسِلٌ':Subject, #1: 1	أَتَى الْمُعَظَّمَ
u'أَتَى مَقَاعِدُ':Predicate, #1: 1	أَتَى الْمُغْتَسِلُ
u'أَتَى مَقَامٌ':Predicate, #1: 1	أَتَى الْمَقَاعِدَ
u'أَتَى مَقْبَرَةٌ':Predicate, #5: 5	أَتَى الْمَقَامَ
u'أَتَى مَكَانٌ':Predicate, #1: 1	أَتَى الْمَقْبَرَةَ
u'أَتَى مُكَلَّفٌ':Subject, #1: 1	أَتَى مَكَانَ
u'أَتَى مَلِكٌ':Predicate, #2: 2	أَتَى الْمُكَلَّفُ
u'أَتَى مَنْحَر':Predicate, #1: 1	أَتَى الْمَلِكَ
u'أَتَى مَنْزِلٌ':Predicate, #1: 1	أَتَى الْمَنْحَرَ
u'أَتَى مَوْسِمٌ':Predicate, #1: 1	أَتَى مَنْزِلَ
u'أَتَى مَوْضِعٌ':Subject, #1: 1	أَتَى الْمَوْسِمَ
u'أَتَى مَوْقِفٌ':Predicate, #1: 1	أَتَى مَوْضِعُ
u'أَتَى مُوَكِّلٌ':Subject, #3: 3	أَتَى الْمَوْقِفَ
u'أَتَى مِيقَاتٌ':Predicate, #1: 1	أَتَى الْمُوَكِّلُ
u'أَتَى نَاسٌ':Subject, #1: 1	أَتَى الْمِيقَاتَ
u'أَتَى نَبِيٌّ':Predicate, #1: 1	أَتَى نَاسٌ
u'أَتَى نَبِيٌّ':Predicate, #134: 134	أَتَى النَّبِيَّ
u'أَتَى نَبِيٌّ':Subject, #6: 6	أَتَى نَبِيَّ
u'أَتَى نِساءٌ':Predicate, #9: 9	أَتَى النَّبِيُّ
u'أَتَى نصاب':Subject, #14: 14	أَتَى النِّسَاءَ
u'أَتَى نِصَابٌ':Subject, #1: 1	أَتَى نِصَابٌ
u'أَتَى نِصْفٌ':Predicate, #1: 1	أَتَى نِصَابٌ
u'أَتَى نُعْمَانُ':Predicate, #1: 1	أَتَى نِصْفَ
u'أَتَى نَعْيٌ':Subject, #1: 1	أَتَى النّعْمَانَ
u'أَتَى نَفَرٌ':Subject, #1: 1	أَتَى نَعْيُ
u'أَتَى هِرٌّ':Subject, #1: 1	أَتَى نَفَرٌ
u'أَتَى واحد':Subject, #1: 1	أَتَى هِرٌّ
u'أَتَى وَاحِدٌ':Subject, #1: 1	أَتَى وَاحِدٌ
u'أَتَى وَادِي':Predicate, #1: 1	أَتَى وَاحِدٌ
u'أَتَى وَاقِفٌ':Subject, #1: 1	أَتَى وَادِيَ
u'أَتَى وَكِيلٌ':Subject, #3: 3	أَتَى الْوَاقِفُ
u'أَتَى وَلِيدٌ':Predicate, #2: 2	أَتَى الْوَكِيلُ
u'أَتَى يمن':Predicate, #1: 1	أَتَى الْوَلِيدَ
u'أَتَى يَمَنُ':Predicate, #1: 1	أَتَى الْيَمَنَ
u'أَتَى يَوْمٌ':Predicate, #1: 1	أَتَى الْيَمَنَ
u'أَثَابَ قِيمَةٌ':Predicate, #2: 2	أَتَى يَوْمَ
u'أَثَارَ حَرْبٌ':Predicate, #3: 3	أَثَابَ الْقِيمَةَ
u'أَثَارَ رَجُلٌ':Subject, #1: 1	أَثَارَ الْحَرْبَ
u'آثَامٌ نَاسٌ':Added, #1: 1	أَثَارَ الرَّجُلُ
u'إِثْبَاتٌ اِسْتِعْمالٌ':Added, #1: 1	آثَامِ النَّاسِ
u'إِثْبَاتٌ إمَارَةٌ':Added, #1: 1	إِثْبَاتِ اسْتِعْمَالِ
u'إِثْبَاتٌ إمَامَةٌ':Added, #1: 1	إِثْبَاتَ إِمَارَةٍ
u'إِثْبَاتٌ بَصَرٌ':Added, #2: 2	إِثْبَاتِ إِمَامَةِ
u'إِثْبَاتٌ جِلْبَابٌ':Added, #1: 1	إِثْبَاتِ بَصَرٍ
u'إِثْبَاتٌ جوارح':Added, #1: 1	إِثْبَاتُ الْجِلْبَابِ
u'إِثْبَاتٌ جَوَارِحُ':Added, #1: 1	إِثْبَاتِ الْجَوَارِحِ
u'إِثْبَاتٌ حَديثٌ':Added, #1: 1	إِثْبَاتِ الْجَوَارِحِ
u'إِثْبَاتٌ حَفْرٌ':Added, #1: 1	إِثْبَاتِ حَدِيثِ
u'إِثْبَاتٌ حُكْمٌ':Added, #1: 1	إِثْبَاتُ الْحَفْرِ
u'إِثْبَاتٌ دُعَاءٌ':Added, #1: 1	إِثْبَاتِ الْحُكْمِ
u'إِثْبَاتٌ رجعة':Added, #1: 1	إِثْبَاتُ الدُّعَاءِ
u'إِثْبَاتٌ رَجْعَةٌ':Added, #1: 1	إِثْبَاتِ الرَّجْعَةِ
u'إِثْبَاتٌ صغائر':Added, #1: 1	إِثْبَاتِ الرَّجْعَةِ
u'إِثْبَاتٌ صَغَائِرُ':Added, #1: 1	إِثْبَاتِ الصَّغَائِرِ
u'إِثْبَاتٌ صَغِيرٌ':Added, #1: 1	إِثْبَاتِ الصَّغَائِرِ
u'إِثْبَاتٌ صِفَةٌ':Added, #2: 2	إِثْبَاتِ الصَّغِيرَةِ
u'إِثْبَاتٌ صِفَةٌ':Added, #1: 1	إِثْبَاتُ الصِّفَاتِ
u'إِثْبَاتٌ صَوْمٌ':Added, #1: 1	إِثْبَاتِ الصِّفَاتِ
u'إِثْبَاتٌ ظُهْرٌ':Added, #1: 1	إِثْبَاتُ صَوْمِ
u'إِثْبَاتٌ عِبَادَةٌ':Added, #1: 1	إِثْبَاتُ الظُّهْرِ
u'إِثْبَاتٌ فَرْضٌ':Added, #1: 1	إِثْبَاتَ الْعِبَادَاتِ
u'إِثْبَاتٌ قَسْمٌ':Added, #1: 1	إِثْبَاتِ فَرْضِ
u'إِثْبَاتٌ قُنُوتٌ':Added, #1: 1	إِثْبَاتَ قَسْمِ
u'إِثْبَاتٌ نضح':Added, #1: 1	إِثْبَاتِ الْقُنُوتِ
u'إِثْبَاتٌ نَضْحٌ':Added, #1: 1	إِثْبَاتُ نَضْحِ
u'أَثْبَتَ اِبْنٌ':Subject, #1: 1	إِثْبَاتُ نَضْحِ
u'أَثْبَتَ أَحادِيثُ':Predicate, #5: 5	أَثْبَتَ ابْنُ
u'أَثْبَتَ اِخْتِلالٌ':Predicate, #1: 1	أَثْبَتَ أَحَادِيثَ
u'أَثْبَتَ إِذْنٌ':Predicate, #1: 1	أَثْبَتَ اخْتِلَالَ
u'أَثْبَتَ اِسْتِحْقَاقٌ':Predicate, #1: 1	أَثْبَتَ إذْنَ
u'أَثْبَتَ أَسْماءٌ':Predicate, #1: 1	أَثْبَتَ اسْتِحْقَاقَ
u'أَثْبَتَ أصل':Predicate, #1: 1	أَثْبَتَ الْأَسْمَاءَ
u'أَثْبَتَ أًصْلٌ':Predicate, #2: 2	أَثْبَتَ أَصْلَ
u'أَثْبَتَ أَهْلِيٌّ':Predicate, #2: 2	أَثْبَتَ أَصْلَ
u'أَثْبَتَ أهْلِيَّةٌ':Predicate, #1: 1	أَثْبَتَ أَهْلِيَّةَ
u'أَثْبَتَ بَيِّنَةٌ':Predicate, #1: 1	أَثْبَتَ أَهْلِيَّةَ
u'أَثْبَتَ تَخْصِيصٌ':Predicate, #1: 1	أَثْبَتَ بَيِّنَةَ
u'أَثْبَتَ ثَلاثُ':Predicate, #1: 1	أَثْبَتَ تَخْصِيصَ
u'أَثْبَتَ جَمَاعَةٌ':Subject, #1: 1	أَثْبَتَ ثَلَاثَ
u'أَثْبَتَ جَمِيع':Predicate, #1: 1	أَثْبَتَ جَمَاعَةٌ
u'أَثْبَتَ جَوَازٌ':Predicate, #1: 1	أَثْبَتَ الْجَمِيعَ
u'أَثْبَتَ حادِثٌ':Predicate, #1: 1	أَثْبَتَ جَوَازَ
u'أَثْبَتَ حاكِمٌ':Subject, #1: 1	أَثْبَتَ الْحَادِثَ
u'أَثْبَتَ حالٌ':Predicate, #2: 2	أَثْبَتَ حَاكِمٌ
u'أَثْبَتَ حَدٌّ':Predicate, #1: 1	أَثْبَتَ الْحَالَ
u'أَثْبَتَ حَدَثٌ':Predicate, #1: 1	أَثْبَتَ حَدَّ
u'أَثْبَتَ حَديثٌ':Subject, #1: 1	أَثْبَتَ الْحَدَثَ
u'أَثْبَتَ حَرارَةٌ':Predicate, #1: 1	أَثْبَتَ الْحَدِيثُ
u'أَثْبَتَ حُرْمَةٌ':Predicate, #1: 1	أَثْبَتَ حَرَارَةَ
u'أَثْبَتَ حُرْمَةٌ':Predicate, #1: 1	أَثْبَتَ الْحُرْمَةَ
u'أَثْبَتَ حَقٌّ':Predicate, #1: 1	أَثْبَتَ حُرْمَةَ
u'أَثْبَتَ حَقٌّ':Predicate, #2: 2	أَثْبَتَ الْحَقَّ
u'أَثْبَتَ حُكْمٌ':Predicate, #2: 2	أَثْبَتَ حَقَّ
u'أَثْبَتَ حِلٌّ':Predicate, #2: 2	أَثْبَتَ الْحُكْمَ
u'أَثْبَتَ خَطٌّ':Predicate, #2: 2	أَثْبَتَ الْحِلَّ
u'أَثْبَتَ خِلاَفٌ':Predicate, #2: 2	أَثْبَتَ الْخَطَّ
u'أَثْبَتَ خَمْرٌ':Predicate, #3: 3	أَثْبَتَ الْخِلَافَ
u'أَثْبَتَ خيار':Predicate, #1: 1	أَثْبَتَ الْخَمْرَ
u'أَثْبَتَ خِيَارٌ':Predicate, #6: 6	أَثْبَتَ الْخِيَارَ
u'أَثْبَتَ خَيْرِيٌّ':Predicate, #6: 6	أَثْبَتَ الْخِيَارَ
u'أَثْبَتَ دونٌ':Predicate, #1: 1	أَثْبَتَ الْخَيْرِيَّةَ
u'أَثْبَتَ دَيْنٌ':Predicate, #1: 1	أَثْبَتَ دُونَ
u'أَثْبَتَ رجعة':Predicate, #5: 5	أَثْبَتَ الدَّيْنَ
u'أَثْبَتَ رَجْعَةٌ':Predicate, #1: 1	أَثْبَتَ الرَّجْعَةَ
u'أَثْبَتَ رَجُلٌ':Subject, #1: 1	أَثْبَتَ الرَّجْعَةَ
u'أَثْبَتَ رَدٌّ':Predicate, #2: 2	أَثْبَتَ رَجُلٌ
u'أَثْبَتَ رَدٌّ':Predicate, #1: 1	أَثْبَتَ الرَّدَّ
u'أَثْبَتَ رَسُولٌ':Subject, #1: 1	أَثْبَتَ رَدَّ
u'أَثْبَتَ رِقٌّ':Predicate, #1: 1	أَثْبَتَ رَسُولُ
u'أَثْبَتَ رِوايَةٌ':Predicate, #2: 2	أَثْبَتَ الرِّقَّ
u'أَثْبَتَ زَوْجٌ':Subject, #1: 1	أَثْبَتَ الرِّوَايَةَ
u'أَثْبَتَ سَبَبٌ':Predicate, #1: 1	أَثْبَتَ الزَّوْجُ
u'أَثْبَتَ سَبْقٌ':Predicate, #2: 2	أَثْبَتَ سَبَبَ
u'أَثْبَتَ سَمَاعٌ':Predicate, #1: 1	أَثْبَتَ سَبْقَ
u'أَثْبَتَ سَمَاعٌ':Predicate, #1: 1	أَثْبَتَ السّمَاعَ
u'أَثْبَتَ سِنٌّ':Predicate, #1: 1	أَثْبَتَ سَمَاعَ
u'أَثْبَتَ سُنَّةٌ':Predicate, #1: 1	أَثْبَتَ سِنَّ
u'أَثْبَتَ شافِعِيّ':Subject, #1: 1	أَثْبَتَ السُّنَّةَ
u'أَثْبَتَ شَبَهٌ':Predicate, #1: 1	أَثْبَتَ الشَّافِعِيُّ
u'أَثْبَتَ شِرَاءٌ':Predicate, #1: 1	أَثْبَتَ الشَّبَهَ
u'أَثْبَتَ شَرْعٌ':Subject, #7: 7	أَثْبَتَ الشِّرَاءَ
u'أَثْبَتَ شرف':Predicate, #1: 1	أَثْبَتَ الشَّرْعُ
u'أَثْبَتَ شَرَفٌ':Predicate, #1: 1	أَثْبَتَ الشَّرَفَ
u'أَثْبَتَ شركة':Predicate, #1: 1	أَثْبَتَ الشَّرَفَ
u'أَثْبَتَ شَرِكَةٌ':Predicate, #3: 3	أَثْبَتَ الشَّرِكَةَ
u'أَثْبَتَ شفعة':Predicate, #3: 3	أَثْبَتَ الشَّرِكَةَ
u'أَثْبَتَ شُفْعَةٌ':Predicate, #1: 1	أَثْبَتَ الشُّفْعَةَ
u'أَثْبَتَ صحبة':Predicate, #1: 1	أَثْبَتَ الشُّفْعَةَ
u'أَثْبَتَ صُحْبَةٌ':Predicate, #1: 1	أَثْبَتَ الصُّحْبَةَ
u'أَثْبَتَ صَلاَةٌ':Predicate, #1: 1	أَثْبَتَ الصُّحْبَةَ
u'أَثْبَتَ طَرِيقَةٌ':Predicate, #1: 1	أَثْبَتَ الصّلَاةَ
u'أَثْبَتَ عَادَةٌ':Predicate, #1: 1	أَثْبَتَ طَرِيقَةَ
u'أَثْبَتَ عتق':Predicate, #1: 1	أَثْبَتَ الْعَادَةَ
u'أَثْبَتَ عِتْقٌ':Predicate, #1: 1	أَثْبَتَ الْعِتْقَ
u'أَثْبَتَ عجز':Predicate, #1: 1	أَثْبَتَ الْعِتْقَ
u'أَثْبَتَ عَجْزٌ':Predicate, #1: 1	أَثْبَتَ الْعَجْزَ
u'أَثْبَتَ عَدَالَةٌ':Predicate, #1: 1	أَثْبَتَ الْعَجْزَ
u'أَثْبَتَ عُرْوَةٌ':Subject, #1: 1	أَثْبَتَ الْعَدَالَةَ
u'أَثْبَتَ عزل':Predicate, #1: 1	أَثْبَتَ عُرْوَةُ
u'أَثْبَتَ عِلَّةٌ':Predicate, #1: 1	أَثْبَتَ الْعَزْلَ
u'أَثْبَتَ عِلِّيٌّ':Predicate, #2: 2	أَثْبَتَ الْعِلَّةَ
u'أَثْبَتَ عند':Predicate, #1: 1	أَثْبَتَ عِلِّيَّةَ
u'أَثْبَتَ عند':Predicate, #1: 1	أَثْبَتَ عِنْدَكَ
u'أَثْبَتَ عَيْبٌ':Predicate, #2: 2	أَثْبَتَ عِنْدَ
u'أَثْبَتَ غرماء':Subject, #1: 1	أَثْبَتَ الْعَيْبَ
u'أَثْبَتَ غَصْبٌ':Predicate, #2: 2	أَثْبَتَ الْغُرَمَاءُ
u'أَثْبَتَ غَيْبَةٌ':Predicate, #1: 1	أَثْبَتَ الْغَصْبَ
u'أَثْبَتَ غير':Subject, #1: 1	أَثْبَتَ الْغَيْبَةَ
u'أَثْبَتَ غَيْرٌ':Subject, #1: 1	أَثْبَتَ غَيْرُهُ
u'أَثْبَتَ فقهاء':Subject, #1: 1	أَثْبَتَ غَيْرُهُ
u'أَثْبَتَ فلان':Subject, #1: 1	أَثْبَتَ الْفُقَهَاءُ
u'أَثْبَتَ فلان':Subject, #1: 1	أَثْبَتَ الشَّافِعِيُّ
u'أَثْبَتَ قَاتِلٌ':Subject, #2: 2	أَثْبَتَ مُعَاوِيَةُ
u'أَثْبَتَ قَاذِفٌ':Subject, #1: 1	أَثْبَتَ الْقَاتِلُ
u'أَثْبَتَ قَالِبٌ':Subject, #1: 1	أَثْبَتَ الْقَاذِفُ
u'أَثْبَتَ قَلِيلٌ':Predicate, #1: 1	أَثْبَتَ الْقَالِبُ
u'أَثْبَتَ قول':Predicate, #1: 1	أَثْبَتَ الْقَلِيلَ
u'أَثْبَتَ قَوْلٌ':Predicate, #1: 1	أَثْبَتَ الْقَوْلَ
u'أَثْبَتَ قول':Predicate, #1: 1	أَثْبَتَ الْقَوْلَ
u'أَثْبَتَ قَوْلٌ':Predicate, #1: 1	أَثْبَتَ قَوْلَ
u'أَثْبَتَ قَوْمٌ':Subject, #1: 1	أَثْبَتَ قَوْلَ
u'أَثْبَتَ كَلاَمٌ':Predicate, #1: 1	أَثْبَتَ الْقَوْمُ
u'أَثْبَتَ لَفْظٌ':Predicate, #1: 1	أَثْبَتَ كَلَامَ
u'أَثْبَتَ مَحْمُودٌ':Subject, #1: 1	أَثْبَتَ لَفْظَ
u'أَثْبَتَ مُرْتَهِنٌ':Subject, #1: 1	أَثْبَتَ مَحْمُودُ
u'أَثْبَتَ مُرْسِلٌ':Predicate, #2: 2	أَثْبَتَ الْمُرْتَهِنُ
u'أَثْبَتَ مُصَنِّفٌ':Subject, #1: 1	أَثْبَتَ الْمُرْسِلَ
u'أَثْبَتَ مُعاوِيَة':Subject, #2: 2	أَثْبَتَ الْمُصَنِّفُ
u'أَثْبَتَ مُعْتَزِلٌ':Subject, #2: 2	أَثْبَتَ مُعَاوِيَةُ
u'أَثْبَتَ مُعْتَزِلَةٌ':Subject, #1: 1	أَثْبَتَ الْمُعْتَزِلَةُ
u'أَثْبَتَ مُعَلِّلٌ':Subject, #1: 1	أَثْبَتَ الْمُعْتَزِلَةُ
u'أَثْبَتَ مُعَلِّمٌ':Subject, #1: 1	أَثْبَتَ الْمُعَلِّلُ
u'أَثْبَتَ مُقَدَّمٌ':Subject, #1: 1	أَثْبَتَ الْمُعَلِّمُ
u'أَثْبَتَ مُقَدَّمٌ':Subject, #1: 1	أَثْبَتَ مُقَدَّمٌ
u'أَثْبَتَ مُقَدِّمٌ':Subject, #1: 1	أَثْبَتَ مُقَدّمَةٌ
u'أَثْبَتَ مُقَدِّمَةٌ':Subject, #1: 1	أَثْبَتَ مُقَدّمَةٌ
u'أَثْبَتَ مِلْكٌ':Predicate, #1: 1	أَثْبَتَ مُقَدّمَةٌ
u'أَثْبَتَ مِلْكٌ':Predicate, #1: 1	أَثْبَتَ مِلْكَ
u'أَثْبَتَ مُمَاثَلَةٌ':Predicate, #7: 7	أَثْبَتَ الْمِلْكَ
u'أَثْبَتَ مُؤَاخَذَةٌ':Predicate, #1: 1	أَثْبَتَ الْمُمَاثَلَةَ
u'أَثْبَتَ مِيرَاثٌ':Predicate, #2: 2	أَثْبَتَ الْمُؤَاخَذَةَ
u'أَثْبَتَ نزاع':Predicate, #1: 1	أَثْبَتَ الْمِيرَاثَ
u'أَثْبَتَ نِزَاعٌ':Predicate, #1: 1	أَثْبَتَ النِّزَاعَ
u'أَثْبَتَ نَسَبٌ':Predicate, #1: 1	أَثْبَتَ النِّزَاعَ
u'أَثْبَتَ نقل':Predicate, #4: 4	أَثْبَتَ النَّسَبَ
u'أَثْبَتَ نَقْلٌ':Predicate, #2: 2	أَثْبَتَ النَّقْلَ
u'أَثْبَتَ نكاح':Predicate, #2: 2	أَثْبَتَ النَّقْلَ
u'أَثْبَتَ نِكَاحٌ':Predicate, #1: 1	أَثْبَتَ النِّكَاحَ
u'أَثْبَتَ نَوْعٌ':Predicate, #1: 1	أَثْبَتَ النِّكَاحَ
u'أَثْبَتَ هاء':Predicate, #1: 1	أَثْبَتَ نَوْعَ
u'أَثْبَتَ هلاك':Predicate, #1: 1	أَثْبَتَ الْهَاءَ
u'أَثْبَتَ هَلاَكٌ':Predicate, #1: 1	أَثْبَتَ هَلَاكَ
u'أَثْبَتَ هِلاَلٌ':Predicate, #1: 1	أَثْبَتَ هَلَاكَ
u'أَثْبَتَ واحد':Subject, #1: 1	أَثْبَتَ الْهِلَالَ
u'أَثْبَتَ وَاحِدٌ':Subject, #1: 1	أَثْبَتَ وَاحِدٌ
u'أَثْبَتَ وَارِثٌ':Subject, #1: 1	أَثْبَتَ وَاحِدٌ
u'أَثْبَتَ وَاسِطٌ':Predicate, #3: 3	أَثْبَتَ الْوَارِثُ
u'أَثْبَتَ وُجُوبٌ':Predicate, #1: 1	أَثْبَتَ الْوَاسِطَةَ
u'أَثْبَتَ وُجُوبٌ':Predicate, #1: 1	أَثْبَتَ الْوُجُوبَ
u'أَثْبَتَ وَدِيعٌ':Predicate, #1: 1	أَثْبَتَ وُجُوبَ
u'أَثْبَتَ وَدِيعَةٌ':Predicate, #1: 1	أَثْبَتَ الْوَدِيعَةَ
u'أَثْبَتَ وَرَثَةٌ':Subject, #1: 1	أَثْبَتَ الْوَدِيعَةَ
u'أَثْبَتَ وَصْفٌ':Predicate, #1: 1	أَثْبَتَ الْوَرَثَةُ
u'أَثْبَتَ وَطْءٌ':Predicate, #1: 1	أَثْبَتَ الْوَصْفَ
u'أَثْبَتَ وَقْفٌ':Predicate, #1: 1	أَثْبَتَ الْوَطْءَ
u'أَثْبَتَ وَكِيلٌ':Subject, #1: 1	أَثْبَتَ الْوَقْفَ
u'أَثْبَتَ وَلاَءٌ':Predicate, #2: 2	أَثْبَتَ الْوَكِيلُ
u'أَثْبَتَ يَدٌ':Predicate, #1: 1	أَثْبَتَ الْوَلَاءَ
u'أَثَّرَ اِجْتِمَاعٌ':Subject, #1: 1	أَثْبَتَ الْيَدَ
u'آثَرَ أحَدٌ':Predicate, #1: 1	أَثَّرَ اجْتِمَاعُ
u'آثَرَ أحَدٌ':Subject, #1: 1	آثَرَ أَحَدَ
u'أَثَرَ أَصابِعُ':Predicate, #1: 1	آثَرَ أَحَدُ
u'آثَرَ إضْمارٌ':Predicate, #1: 1	أَثَرَ أَصَابِعَكَ
u'آثَرَ أفْضَلُ':Predicate, #1: 1	آثَرَ الْإِضْمَارَ
u'آثَرَ أهْلٌ':Predicate, #3: 3	آثَرَ أَفْضَلَ
u'آثَرَ بَعْضٌ':Predicate, #1: 1	آثَرَ أَهْلَ
u'آثَرَ تَعْبِيرٌ':Predicate, #1: 1	آثَرَ بَعْضَ
u'أَثَّرَ تَغَيُّرٌ':Subject, #1: 1	آثَرَ التَّعْبِيرَ
u'آثَرَ جَانِبٌ':Predicate, #1: 1	أَثَّرَ التَّغَيُّرُ
u'أَثَّرَ جُرْحٌ':Subject, #1: 1	آثَرَ الْجَانِبَ
u'أَثَّرَ جُنُونٌ':Subject, #1: 1	أَثَّرَ جُرْحُهُ
u'أَثَرَ حَديثٌ':Predicate, #1: 1	أَثَّرَ جُنُونُهُ
u'أَثَّرَ حَصِيرٌ':Subject, #1: 1	أَثَرَ الْحَدِيثَ
u'آثَرَ حَلْقٌ':Predicate, #2: 2	أَثَّرَ الْحَصِيرُ
u'أَثَرَ ذكر':Predicate, #1: 1	آثَرَ الْحَلْقَ
u'أَثَرَ ذِكْرٌ':Predicate, #1: 1	أَثَرَ ذِكْرَ
u'آثَرَ رَاحَةٌ':Predicate, #1: 1	أَثَرَ ذِكْرَ
u'أَثَّرَ رُجُوعٌ':Subject, #1: 1	آثَرَ الرَّاحَةَ
u'أَثَّرَ رِقٌّ':Subject, #1: 1	أَثَّرَ رُجُوعُهُ
u'أَثَّرَ رِمالٌ':Subject, #1: 1	أَثَّرَ الرِّقُّ
u'أَثَّرَ رِمالٌ':Subject, #1: 1	أَثَّرَ الرِّمَالُ
u'أَثَّرَ زَعْفَرانٌ':Subject, #1: 1	أَثَّرَ رِمَالُ
u'أَثَّرَ سُجُودٌ':Subject, #1: 1	أَثَّرَ الزَّعْفَرَانُ
u'أَثَّرَ سِحْرٌ':Subject, #1: 1	أَثَّرَ السُّجُودُ
u'أَثَرَ صَالِحٌ':Predicate, #1: 1	أَثَّرَ السِّحْرُ
u'أَثَرَ صَالِح':Predicate, #1: 1	أَثَرَ الصَّالِحِينَ
u'آثَرَ طَلاَقٌ':Predicate, #1: 1	أَثَرَ الصَّالِحِينَ
u'أَثَّرَ عَدَمٌ':Subject, #1: 1	آثَرَ الطَّلَاقَ
u'أَثَّرَ عرف':Subject, #2: 2	أَثَّرَ عَدَمُهُ
u'أَثَّرَ عُرْفٌ':Subject, #1: 1	أَثَّرَ الْعُرْفُ
u'أَثَرَ عُمَرٌ':Predicate, #1: 1	أَثَّرَ الْعُرْفُ
u'آثَرَ عند':Predicate, #1: 1	أَثَرَ عُمَرَ
u'أَثَّرَ فِعْلٌ':Subject, #1: 1	آثَرَ عِنْدَ
u'أَثَرَ فلان':Predicate, #2: 2	أَثَّرَ فِعْلُ
u'آثَرَ قَائِلٌ':Predicate, #1: 1	أَثَرَ خَيْبَرَ
u'آثَرَ قَائِلَةٌ':Predicate, #1: 1	آثَرَ الْقَائِلَةَ
u'أَثَّرَ قَلِيلٌ':Subject, #1: 1	آثَرَ الْقَائِلَةَ
u'أَثَرَ كَوْنٌ':Subject, #1: 1	أَثَّرَ قَلِيلُ
u'أَثَّرَ لبس':Subject, #1: 1	أَثَرَ كَوْنُ
u'أَثَّرَ لُبْسٌ':Subject, #1: 1	أَثَّرَ لُبْسُهُ
u'آثَرَ مُجَرَّدٌ':Predicate, #1: 1	أَثَّرَ لُبْسُهُ
u'أَثَّرَ مُجَرَّدٌ':Subject, #1: 1	آثَرَ مُجَرَّدَ
u'آثَرَ مُسْتَعِيرٌ':Predicate, #1: 1	أَثَّرَ مُجَرَّدُ
u'أَثَّرَ مِلْكٌ':Subject, #1: 1	آثَرَ الْمُسْتَعِيرَ
u'آثَرَ نَبِيٌّ':Subject, #2: 2	أَثَّرَ الْمِلْكُ
u'أَثَّرَ وَرْسٌ':Subject, #2: 2	آثَرَ النَّبِيُّ
u'آثَرَ وصل':Predicate, #1: 1	أَثَّرَ الْوَرْسُ
u'آثَرَ وَصْلٌ':Predicate, #1: 1	آثَرَ وَصْلَ
u'أَثَّرَ وُقُوعٌ':Subject, #1: 1	آثَرَ وَصْلَ
u'أَثَّرَ يَوْمٌ':Predicate, #1: 1	أَثَّرَ الْوُقُوعُ
u'أَثْقَلَ أَعْنَاقٌ':Predicate, #1: 1	أَثَّرَ يَوْمَ
u'أَثْقَلَ قَالٌ':Predicate, #2: 2	أَثْقَلَ الْأَعْنَاقَ
u'إِثْمٌ اِبْتِداعٌ':Added, #2: 2	أَثْقَلَ قَالَ
u'أَثِمَ إِثْمٌ':Predicate, #1: 1	إِثْمِ ابْتِدَاعِهِ
u'إِثْمٌ بِدْعَةٌ':Added, #2: 2	أَثِمَ إثْمَ
u'أَثِمَ ثَلاثَةٌ':Predicate, #1: 1	إِثْمِ الْبِدْعَةِ
u'أَثِمَ جَارٌ':Subject, #1: 1	أَثِمَ ثَلَاثَةَ
u'أَثِمَ جَمِيع':Subject, #1: 1	أَثِمَ جَارُهُ
u'أَثْمَرَ زَرْعٌ':Subject, #2: 2	أَثِمَ الْجَمِيعُ
u'أَثْمَرَ شَجَرٌ':Subject, #1: 1	أَثْمَرَ الزَّرْعُ
u'أَثْمَرَ شَيْءٌ':Predicate, #1: 1	أَثْمَرَ الشَّجَرُ
u'أَثْمَرَ شَيْءٌ':Subject, #1: 1	أَثْمَرَ الشَّيْءَ
u'أَثْمَرَ عند':Predicate, #1: 1	أَثْمَرَ الشَّيْءُ
u'أَثْمَرَ نَخْلٌ':Subject, #2: 2	أَثْمَرَ عِنْدَ
u'أَثْمَرَ نَخْلٌ':Subject, #1: 1	أَثْمَرَ نَخْلٌ
u'أَثْمَرَ نَخِيلٌ':Subject, #5: 5	أَثْمَرَ النَّخْلُ
u'أَثِمَ زَوْجٌ':Subject, #2: 2	أَثْمَرَ النَّخِيلُ
u'إِثْمٌ غَادِرٌ':Added, #1: 1	أَثِمَ الزَّوْجُ
u'أَثِمَ غَاصِبٌ':Subject, #1: 1	إِثْمِ الْغَادِرِ
u'أَثِمَ قول':Subject, #1: 1	أَثِمَ غَاصِبُهُ
u'أَثِمَ قَوْلٌ':Subject, #1: 1	أَثِمَ قَوْلُهُ
u'أَثِمَ مَارٌّ':Subject, #1: 1	أَثِمَ قَوْلُهُ
u'إِثْمٌ مَارٌّ':Added, #2: 2	أَثِمَ الْمَارُّ
u'إِثْمٌ مُبْتَدِعٌ':Added, #1: 1	إِثْمِ الْمَارِّ
u'أَثِمَ مُؤَخِّرٌ':Subject, #1: 1	إِثْمُ الْمُبْتَدِعِ
u'أَثِمَ وَدِيعٌ':Subject, #1: 1	أَثِمَ الْمُؤَخِّرُ
u'أَثِمَ وَرَثَةٌ':Subject, #1: 1	أَثِمَ الْوَدِيعُ
u'أَثِمَ وَلِيٌّ':Subject, #1: 1	أَثِمَ الْوَرَثَةُ
u'أَثْنَى رَجُلٌ':Subject, #2: 2	أَثِمَ الْوَلِيُّ
u'أَثْنَى مَعْرُوفٌ':Subject, #1: 1	أَثْنَى رَجُلٌ
u'أَثْنَى نَبِيٌّ':Subject, #1: 1	أَثْنَى مَعْرُوفٌ
u'أَجَابَ اِبْنٌ':Subject, #1: 1	أَثْنَى النَّبِيُّ
u'أَجَابَ إجَارَةٌ':Subject, #19: 19	أَجَابَ ابْنُ
u'أَجَابَ أُسْتَاذٌ':Subject, #1: 1	أَجَابَ إجَارَةُ
u'أَجَابَ أَصْحَابٌ':Subject, #2: 2	أَجَابَ الْأُسْتَاذُ
u'أَجَابَ أصل':Subject, #1: 1	أَجَابَ الْأَصْحَابُ
u'أَجَابَ أًصْلٌ':Subject, #2: 2	أَجَابَ الْأَصْلُ
u'أَجَابَ إمَامٌ':Subject, #2: 2	أَجَابَ الْأَصْلُ
u'أَجَابَ إمَامٌ':Subject, #1: 1	أَجَابَ إمَامُ
u'أَجَابَ أَميرٌ':Predicate, #4: 4	أَجَابَ الْإِمَامُ
u'أَجَابَ أَوَّلُ':Subject, #1: 1	أَجَابَ أَمِيرَ
u'أَجَابَ بَعْضٌ':Subject, #6: 6	أَجَابَ الْأَوَّلُ
u'أَجَابَ بَعْضٌ':Subject, #14: 14	أَجَابَ بَعْضُ
u'أَجَابَ تَعَلُّمٌ':Subject, #1: 1	أَجَابَ بَعْضٌ
u'أَجَابَ تَقْريرٌ':Predicate, #1: 1	أَجَابَ تَعَلُّمُ
u'أَجَابَ جَمَاعَةٌ':Subject, #1: 1	أَجَابَ التَّقْرِيرَ
u'أَجَابَ جَمَالٌ':Subject, #1: 1	أَجَابَ جَمَاعَةٌ
u'أَجَابَ جُمْهُورٌ':Subject, #1: 1	أَجَابَ جَمَالُ
u'أَجَابَ جُمْهُورٌ':Subject, #1: 1	أَجَابَ الْجُمْهُورُ
u'أَجَابَ جَمِيع':Subject, #1: 1	أَجَابَ جُمْهُورُ
u'أَجَابَ جَوَابٌ':Predicate, #2: 2	أَجَابَ الْجَمِيعُ
u'أَجَابَ حارِثٌ':Subject, #1: 1	أَجَابَ جَوَابَ
u'أَجَابَ حَجيجٌ':Subject, #1: 1	أَجَابَ الْحَارِثُ
u'أَجَابَ دَاعِي':Predicate, #1: 1	أَجَابَ الْحَجِيجُ
u'أَجَابَ رَسُولٌ':Predicate, #2: 2	أَجَابَ دَاعِيَ
u'أَجَابَ رَمْلِيٌّ':Subject, #1: 1	أَجَابَ الرَّسُولَ
u'أَجَابَ زُفَرٌ':Subject, #1: 1	أَجَابَ الرَّمْلِيُّ
u'أَجَابَ سَابِقٌ':Predicate, #1: 1	أَجَابَ زُفَرُ
u'أَجَابَ سَفِيهٌ':Predicate, #1: 1	أَجَابَ السَّابِقَ
u'أَجَابَ سُؤَالٌ':Predicate, #1: 1	أَجَابَ السَّفِيهَةَ
u'أَجَابَ سَيِّدٌ':Subject, #1: 1	أَجَابَ السُّؤَالَ
u'أَجَابَ شَارِحٌ':Subject, #1: 1	أَجَابَ السَّيِّدُ
u'أَجَابَ شافِعِيّ':Subject, #1: 1	أَجَابَ الشَّارِحُ
u'أَجَابَ شَرِيفٌ':Subject, #2: 2	أَجَابَ الشَّافِعِيُّ
u'أَجَابَ شمس':Subject, #1: 1	أَجَابَ الشَّرِيفُ
u'أَجَابَ شَمْسٌ':Subject, #1: 1	أَجَابَ الشَّمْسُ
u'أَجَابَ شمس':Subject, #1: 1	أَجَابَ الشَّمْسُ
u'أَجَابَ شَمْسٌ':Subject, #2: 2	أَجَابَ شَمْسُ
u'أَجَابَ شَيْخٌ':Subject, #2: 2	أَجَابَ شَمْسُ
u'أَجَابَ شَيْخٌ':Subject, #2: 2	أَجَابَ شَيْخُ
u'أَجَابَ صَاحِبٌ':Subject, #6: 6	أَجَابَ الشَّيْخُ
u'أَجَابَ عَالِمٌ':Subject, #3: 3	أَجَابَ صَاحِبُ
u'أَجَابَ عَلاءٌ':Subject, #2: 2	أَجَابَ الْعَالِمُ
u'أَجَابَ علم':Predicate, #1: 1	أَجَابَ عَلَاءُ
u'أَجَابَ علماء':Subject, #3: 3	أَجَابَ عُلِمَ
u'أَجَابَ عُلَمَاءُ':Subject, #1: 1	أَجَابَ الْعُلَمَاءُ
u'أَجَابَ عَلِيٌّ':Subject, #1: 1	أَجَابَ الْعُلَمَاءُ
u'أَجَابَ عِمَادٌ':Subject, #1: 1	أَجَابَ عَلِيٌّ
u'أَجَابَ عُمَرٌ':Subject, #3: 3	أَجَابَ الْعِمَادُ
u'أَجَابَ غير':Subject, #1: 1	أَجَابَ عُمَرُ
u'أَجَابَ غَيْرٌ':Subject, #2: 2	أَجَابَ غَيْرُ
u'أَجَابَ فَقِيهٌ':Subject, #2: 2	أَجَابَ غَيْرُ
u'أَجَابَ فلان':Subject, #1: 1	أَجَابَ الْفَقِيهُ
u'أَجَابَ فلان':Subject, #1: 1	أَجَابَ عُثْمَانُ
u'أَجَابَ قَفَّالٌ':Subject, #2: 2	أَجَابَ الشَّافِعِيُّ
u'أَجَابَ قول':Subject, #1: 1	أَجَابَ الْقَفَّالُ
u'أَجَابَ قَوْلٌ':Subject, #1: 1	أَجَابَ الْقَوْلُ
u'أَجَابَ كَلاَمٌ':Predicate, #1: 1	أَجَابَ الْقَوْلُ
u'أَجَابَ مُحِبٌّ':Subject, #1: 1	أَجَابَ كَلَامَ
u'أَجَابَ مُحَقِّقٌ':Subject, #1: 1	أَجَابَ الْمُحِبُّ
u'أَجَابَ مَحَلِّيٌّ':Subject, #1: 1	أَجَابَ الْمُحَقِّقُ
u'أَجَابَ مُحَمَّدٌ':Subject, #1: 1	أَجَابَ الْمَحَلِّيُّ
u'أَجَابَ مَذْهَبٌ':Subject, #1: 1	أَجَابَ مُحَمَّدٌ
u'أَجَابَ مرٌّ':Predicate, #1: 1	أَجَابَ مَذْهَبُ
u'أَجَابَ مَشَايِخُ':Subject, #3: 3	أَجَابَ مَرَّةً
u'أَجَابَ مُصَنِّفٌ':Subject, #2: 2	أَجَابَ الْمَشَايِخُ
u'أَجَابَ مُقْتَرِحٌ':Subject, #22: 22	أَجَابَ الْمُصَنِّفُ
u'أَجَابَ مُؤَذِّنٌ':Predicate, #1: 1	أَجَابَ الْمُقْتَرِحُ
u'أَجَابَ مُؤَذِّنٌ':Subject, #1: 1	أَجَابَ الْمُؤَذِّنَ
u'أَجَابَ مُؤَلِّفٌ':Subject, #1: 1	أَجَابَ الْمُؤَذِّنُ
u'أَجَابَ نَاصِرٌ':Subject, #1: 1	أَجَابَ الْمُؤَلِّفُ
u'أَجَابَ نَبِيٌّ':Predicate, #1: 1	أَجَابَ النَّاصِرُ
u'أَجَابَ نَوَوِيٌّ':Subject, #2: 2	أَجَابَ النَّبِيَّ
u'أَجَابَ وَلِيٌّ':Subject, #3: 3	أَجَابَ النَّوَوِيُّ
u'أَجَابَ وَلِيٌّ':Subject, #1: 1	أَجَابَ وَلِيُّ
u'أَجَادَ اِبْنٌ':Subject, #2: 2	أَجَابَ الْوَلِيُّ
u'أَجَارَ أَصْحَابٌ':Predicate, #1: 1	أَجَادَ ابْنُ
u'إجَارَةٌ أَرَاضِي':Added, #1: 1	أَجَارَ أَصْحَابَ
u'إجَارَةٌ أرْضٌ':Added, #1: 1	إجَارَةُ الْأَرَاضِيِ
u'إجَارَةٌ أرْضٌ':Added, #1: 1	إجَارَةِ أَرْضِ
u'إجَارَةٌ أرْضٌ':Added, #2: 2	إجَارَةِ أَرْضِهِ
u'إجَارَةٌ أرْضٌ':Added, #3: 3	إجَارَةُ أَرْضٍ
u'إجَارَةٌ أرْضٌ':Added, #4: 4	إجَارَةَ الْأَرْضِ
u'إجَارَةٌ أرْضٌ':Added, #4: 4	إجَارَةِ الْأَرْضِ
u'إجَارَةٌ أَشْجَارٌ':Added, #9: 9	إجَارَةُ الْأَرْضِ
u'إجَارَةٌ أَشْجَارٌ':Added, #1: 1	إجَارَةَ الْأَشْجَارِ
u'إجَارَةٌ أَشْجَارٌ':Added, #1: 1	إجَارَةُ الْأَشْجَارِ
u'إجَارَةٌ أصل':Added, #1: 1	إجَارَةِ الْأَشْجَارِ
u'إجَارَةٌ أًصْلٌ':Added, #1: 1	إجَارَةِ الْأَصْلِ
u'إجَارَةٌ إقْطَاعٌ':Added, #1: 1	إجَارَةِ الْأَصْلِ
u'إجَارَةٌ إقْطَاعٌ':Added, #1: 1	إجَارَةَ الْإِقْطَاعِ
u'إجَارَةٌ إقْطَاعٌ':Added, #2: 2	إجَارَةُ إقْطَاعِ
u'إجَارَةٌ إقْطَاعٌ':Added, #3: 3	إجَارَةِ الْإِقْطَاعِ
u'إجَارَةٌ أُمٌّ':Added, #5: 5	إجَارَةُ الْإِقْطَاعِ
u'إجَارَةٌ آنِيَةٌ':Added, #1: 1	إجَارَةُ أُمِّ
u'إجَارَةٌ أَوْقَافٌ':Added, #1: 1	إجَارَةُ الْآنِيَةِ
u'إجَارَةٌ أَوْقَافٌ':Added, #1: 1	إجَارَة الْأَوْقَافِ
u'إجَارَةٌ بَزّاز':Added, #4: 4	إجَارَةِ الْأَوْقَافِ
u'إجَارَةٌ بَزّازَة':Added, #2: 2	إجَارَةِ الْبَزَّازِيَّةِ
u'إجَارَةٌ بَطْنٌ':Added, #2: 2	إجَارَةِ الْبَزَّازِيَّةِ
u'إجَارَةٌ بَطْنٌ':Added, #1: 1	إجَارَةَ الْبَطْنِ
u'إجَارَةٌ بَعْضٌ':Added, #2: 2	إجَارَةِ الْبَطْنِ
u'إجَارَةٌ بلاغ':Added, #1: 1	إجَارَةَ بَعْضِ
u'إجَارَةٌ بَلاغٌ':Added, #1: 1	إجَارَةَ الْبَلَاغِ
u'إجَارَةٌ بِنَاءٌ':Added, #1: 1	إجَارَةَ الْبَلَاغِ
u'إجَارَةٌ بَنَّاءٌ':Added, #1: 1	إجَارَةُ الْبِنَاءِ
u'إجَارَةٌ بِنَاءٌ':Added, #2: 2	إجَارَةِ الْبَنَّاءِ
u'إجَارَةٌ بَهِيمَةٌ':Added, #2: 2	إجَارَةِ الْبِنَاءِ
u'إجَارَةٌ بِئْرٌ':Added, #1: 1	إجَارَةُ بَهِيمَةٍ
u'إجَارَةٌ بَيْتٌ':Added, #1: 1	إجَارَةُ الْبِئْرِ
u'إجَارَةٌ بَيْعٌ':Added, #1: 1	إجَارَةُ الْبَيْتِ
u'إجَارَةٌ بَيْعٌ':Added, #1: 1	إجَارَةَ الْبَيْعِ
u'إجَارَةٌ بَيْعٌ':Added, #1: 1	إجَارَةُ بَيْعِ
u'إجَارَةٌ بُيُوتٌ':Added, #2: 2	إجَارَةِ بَيْعِ
u'إجَارَةٌ ثِيابٌ':Added, #1: 1	إجَارَةَ الْبُيُوتِ
u'إجَارَةٌ جَحْش':Added, #1: 1	إجَارَةِ الثِّيَابِ
u'إجَارَةٌ جُزْءٌ':Added, #1: 1	إجَارَةِ الْجَحْشِ
u'إجَارَةٌ جلد':Added, #1: 1	إجَارَةِ جُزْءٍ
u'إجَارَةٌ جلد':Added, #1: 1	إجَارَةَ جِلْدِ
u'إجَارَةٌ جِلْدٌ':Added, #1: 1	إجَارَةُ جِلْدِ
u'إجَارَةٌ جِلْدٌ':Added, #1: 1	إجَارَةَ جِلْدِ
u'إجَارَةٌ حاكِمٌ':Added, #1: 1	إجَارَةُ جِلْدِ
u'إجَارَةٌ حانوتٌ':Added, #1: 1	إجَارَةَ الْحَاكِمِ
u'إجَارَةٌ حُرٌّ':Added, #1: 1	إجَارَةُ الْحَانُوتِ
u'إجَارَةٌ حِصَّةٌ':Added, #1: 1	إجَارَةِ الْحُرِّ
u'إجَارَةٌ حُلِيٌّ':Added, #1: 1	إجَارَةُ حِصَّتِهِ
u'إجَارَةٌ حَمَّامٌ':Added, #1: 1	إجَارَةُ الْحُلِيِّ
u'إجَارَةٌ حَيَوَانٌ':Added, #4: 4	إجَارَةِ الْحَمَّامِ
u'إجَارَةٌ حَيَوَانٌ':Added, #1: 1	إجَارَةِ حَيَوَانٍ
u'إجَارَةٌ خُلاصَة':Added, #2: 2	إجَارَةُ حَيَوَانٍ
u'إجَارَةٌ دَابَّةٌ':Added, #2: 2	إجَارَةِ الْخُلَاصَةِ
u'إجَارَةٌ دَابَّةٌ':Added, #1: 1	إجَارَةُ الدَّابَّةِ
u'إجَارَةٌ دَابَّةٌ':Added, #1: 1	إجَارَةِ الدَّابَّةِ
u'إجَارَةٌ دَارٌ':Added, #1: 1	إجَارَةُ دَابَّةٍ
u'إجَارَةٌ دَارٌ':Added, #1: 1	إجَارَةُ الدَّارِ
u'إجَارَةٌ دَارٌ':Added, #1: 1	إجَارَةُ دَارٍ
u'إجَارَةٌ دَارٌ':Added, #1: 1	إجَارَةِ دَارٍ
u'إجَارَةٌ دَارٌ':Added, #1: 1	إجَارَةِ دَارِهِ
u'إجَارَةٌ دَرَاهِمُ':Added, #4: 4	إجَارَةِ الدَّارِ
u'إجَارَةٌ دُفٌّ':Added, #1: 1	إجَارَةُ الدَّرَاهِمِ
u'إجَارَةٌ دَوَابُّ':Added, #1: 1	إجَارَةُ الدُّفِّ
u'إجَارَةٌ دَوَابُّ':Added, #2: 2	إجَارَةِ دَوَابِّ
u'إجَارَةٌ دُورٌ':Added, #3: 3	إجَارَةِ الدَّوَابِّ
u'إجَارَةٌ دُورٌ':Added, #2: 2	إجَارَةِ الدُّورِ
u'إجَارَةٌ دُورٌ':Added, #3: 3	إجَارَةُ الدُّورِ
u'إجَارَةٌ ذَخيرَةٌ':Added, #4: 4	إجَارَةِ دُورِ
u'إجَارَةٌ ذِمَّةٌ':Added, #1: 1	إجَارَةِ الذَّخِيرَةِ
u'إجَارَةٌ ذِمَّةٌ':Added, #1: 1	إجَارَةَ الذِّمَّةِ
u'إجَارَةٌ ذِمَّةٌ':Added, #1: 1	إجَارَةِ ذِمَّةٍ
u'إجَارَةٌ ذِمَّةٌ':Added, #29: 29	إجَارَةِ الذِّمَّةِ
u'إجَارَةٌ ذِمَّةٌ':Added, #2: 2	إجَارَةُ ذِمَّةٍ
u'إجَارَةٌ ذِمَّةٌ':Added, #6: 6	إجَارَةَ ذِمَّةٍ
u'إجَارَةٌ رَجُلٌ':Added, #8: 8	إجَارَةُ الذِّمَّةِ
u'إجَارَةٌ رَجُلٌ':Added, #1: 1	إجَارَةُ الرَّجُلِ
u'إجَارَةٌ رضاع':Added, #1: 1	إجَارَةِ الرَّجُلِ
u'إجَارَةٌ رَقَبَةٌ':Added, #3: 3	إجَارَةِ رَضَاعٍ
u'إجَارَةٌ رَقيقٌ':Added, #1: 1	إجَارَةُ الرَّقَبَةِ
u'إجَارَةٌ رَقيق':Added, #1: 1	إجَارَةُ الرَّقِيقِ
u'إجَارَةٌ زَمانٌ':Added, #1: 1	إجَارَةُ الرَّقِيقِ
u'إجَارَةٌ زَمانٌ':Added, #1: 1	إجَارَةَ زَمَانٍ
u'إجَارَةٌ زَمَنٌ':Added, #2: 2	إجَارَةِ الزَّمَانِ
u'إجَارَةٌ سَطْحٌ':Added, #1: 1	إجَارَةَ زَمَنٍ
u'إجَارَةٌ سَطْحٌ':Added, #1: 1	إجَارَةُ السَّطْحِ
u'إجَارَةٌ شَاةٌ':Added, #1: 1	إجَارَةُ سَطْحِهِ
u'إجَارَةٌ شَجَرٌ':Added, #1: 1	إجَارَةُ شَاةٍ
u'إجَارَةٌ شَجَرٌ':Added, #1: 1	إجَارَةُ الشَّجَرِ
u'إجَارَةٌ شَجَرَةٌ':Added, #2: 2	إجَارَةَ الشَّجَرِ
u'إجَارَةٌ شرب':Added, #1: 1	إجَارَةُ الشَّجَرَةِ
u'إجَارَةٌ شِرْبٌ':Added, #1: 1	إجَارَةُ الشِّرْبِ
u'إجَارَةٌ شَرِيكٌ':Added, #1: 1	إجَارَةُ الشِّرْبِ
u'إجَارَةٌ شَمْعٌ':Added, #1: 1	إجَارَةُ الشَّرِيكِ
u'إجَارَةٌ شَمْعٌ':Added, #1: 1	إجَارَةَ الشَّمْعِ
u'إجَارَةٌ شَهْرٌ':Added, #1: 1	إجَارَةُ الشَّمْعِ
u'إجَارَةٌ صَاحِبٌ':Added, #1: 1	إجَارَةِ الشَّهْرِ
u'إجَارَةٌ ضَمَانٌ':Added, #1: 1	إجَارَةُ صَاحِبِ
u'إجَارَةٌ ضَمَانٌ':Added, #1: 1	إجَارَةُ الضَّمَانِ
u'إجَارَةٌ ضَمَانٌ':Added, #1: 1	إجَارَةُ ضَمَانٍ
u'إجَارَةٌ ضَيْعَةٌ':Added, #2: 2	إجَارَةِ الضَّمَانِ
u'إجَارَةٌ طَاحُونٌ':Added, #2: 2	إجَارَةِ الضَّيْعَةِ
u'إجَارَةٌ طعام':Added, #1: 1	إجَارَةِ الطَّاحُونَةِ
u'إجَارَةٌ طَعَامٌ':Added, #1: 1	إجَارَةُ الطَّعَامِ
u'إجَارَةٌ عَبْدٌ':Added, #1: 1	إجَارَةُ الطَّعَامِ
u'إجَارَةٌ عَبْدٌ':Added, #1: 1	إجَارَةَ الْعَبْدِ
u'إجَارَةٌ عَبْدٌ':Added, #1: 1	إجَارَةُ الْعَبْدِ
u'إجَارَةٌ عَبْدٌ':Added, #1: 1	إجَارَةُ عَبْدٍ
u'إجَارَةٌ عَبْدٌ':Added, #1: 1	إجَارَةُ عَبْدِ
u'إجَارَةٌ عَبْدٌ':Added, #1: 1	إجَارَةِ عَبْدٍ
u'إجَارَةٌ عَبِيدٌ':Added, #3: 3	إجَارَةِ الْعَبْدِ
u'إجَارَةٌ عُرْبُونٌ':Added, #1: 1	إجَارَةِ عَبِيدِهِ
u'إجَارَةٌ عَرْصَةٌ':Added, #1: 1	إجَارَةُ الْعُرْبُونِ
u'إجَارَةٌ عَقْدٌ':Added, #1: 1	إجَارَةِ عَرْصَةِ
u'إجَارَةٌ علم':Added, #1: 1	إجَارَةُ الْعَقْدِ
u'إجَارَةٌ عِلْمٌ':Added, #1: 1	إجَارَةُ الْعِلْمِ
u'إجَارَةٌ عَمَلٌ':Added, #1: 1	إجَارَةُ الْعِلْمِ
u'إجَارَةٌ عين':Added, #1: 1	إجَارَةُ عَمَلِهِ
u'إجَارَةٌ عَيْنٌ':Added, #13: 13	إجَارَةُ الْعَيْنِ
u'إجَارَةٌ عَيْن':Added, #13: 13	إجَارَةُ الْعَيْنِ
u'إجَارَةٌ عَيْنٌ':Added, #13: 13	إجَارَةُ الْعَيْنِ
u'إجَارَةٌ عَيْن':Added, #13: 13	إجَارَةُ عَيْنٍ
u'إجَارَةٌ عين':Added, #13: 13	إجَارَةُ عَيْنٍ
u'إجَارَةٌ عَيْنٌ':Added, #1: 1	إجَارَةَ الْعَيْنِ
u'إجَارَةٌ عَيْن':Added, #1: 1	إجَارَةَ الْعَيْنِ
u'إجَارَةٌ عين':Added, #1: 1	إجَارَةَ الْعَيْنِ
u'إجَارَةٌ عَيْنٌ':Added, #1: 1	إجَارَةُ عَيْنِ
u'إجَارَةٌ عَيْن':Added, #1: 1	إجَارَةُ عَيْنِ
u'إجَارَةٌ عين':Added, #1: 1	إجَارَةُ عَيْنِ
u'إجَارَةٌ عين':Added, #1: 1	إجَارَةَ عَيْنِهِ
u'إجَارَةٌ عَيْنٌ':Added, #1: 1	إجَارَةُ عَيْنِهِ
u'إجَارَةٌ عَيْنٌ':Added, #1: 1	إجَارَةَ عَيْنِهِ
u'إجَارَةٌ عَيْن':Added, #1: 1	إجَارَةُ عَيْنِهِ
u'إجَارَةٌ عَيْن':Added, #1: 1	إجَارَةَ عَيْنِهِ
u'إجَارَةٌ عَيْنٌ':Added, #1: 1	إجَارَةُ عَيْنِهِ
u'إجَارَةٌ عَيْن':Added, #27: 27	إجَارَةَ عَيْنٍ
u'إجَارَةٌ عين':Added, #27: 27	إجَارَةَ عَيْنٍ
u'إجَارَةٌ عَيْنٌ':Added, #32: 32	إجَارَةِ الْعَيْنِ
u'إجَارَةٌ عَيْن':Added, #32: 32	إجَارَةِ الْعَيْنِ
u'إجَارَةٌ عَيْنٌ':Added, #32: 32	إجَارَةِ الْعَيْنِ
u'إجَارَةٌ عَيْن':Added, #3: 3	إجَارَةِ عَيْنٍ
u'إجَارَةٌ عُيُونٌ':Added, #3: 3	إجَارَةِ عَيْنٍ
u'إجَارَةٌ غَاصِبٌ':Added, #1: 1	إجَارَةِ الْعُيُونِ
u'إجَارَةٌ غَاصِبٌ':Added, #1: 1	إجَارَةَ الْغَاصِبِ
u'إجَارَةٌ غير':Added, #1: 1	إجَارَةُ الْغَاصِبِ
u'إجَارَةٌ غَيْرٌ':Added, #1: 1	إجَارَةُ غَيْرِ
u'إجَارَةٌ غير':Added, #1: 1	إجَارَةُ غَيْرِ
u'إجَارَةٌ غَيْرٌ':Added, #2: 2	إجَارَةِ الْغَيْرِ
u'إجَارَةٌ فَاسِدٌ':Added, #2: 2	إجَارَةِ الْغَيْرِ
u'إجَارَةٌ فَحْلٌ':Added, #4: 4	إجَارَةٍ فَاسِدَةٍ
u'إجَارَةٌ فُضُولِيٌّ':Added, #1: 1	إجَارَةُ فَحْلٍ
u'إجَارَةٌ فُضُولِيٌّ':Added, #1: 1	إجَارَةِ الْفُضُولِيِّ
u'إجَارَةٌ فلان':Added, #2: 2	إجَارَةُ الْفُضُولِيِّ
u'إجَارَةٌ فُلاَنٌ':Added, #2: 2	إجَارَةِ الْبَزَّازِيَّةِ
u'إجَارَةٌ قَنَاةٌ':Added, #2: 2	إجَارَةِ فُلَانٍ
u'إجَارَةٌ قَيِّمٌ':Added, #1: 1	إجَارَةِ قَنَاةِ
u'إجَارَةٌ كَافِرٌ':Added, #1: 1	إجَارَةُ الْقَيِّمِ
u'إجَارَةٌ كَلَأٌ':Added, #2: 2	إجَارَةِ الْكَافِرِ
u'إجَارَةٌ كَلْبٌ':Added, #1: 1	إجَارَةَ الْكَلَأِ
u'إجَارَةٌ كَلْبٌ':Added, #1: 1	إجَارَةُ كَلْبٍ
u'إجَارَةٌ لاَزِمٌ':Added, #3: 3	إجَارَةُ الْكَلْبِ
u'إجَارَةٌ لاَزِمَة':Added, #1: 1	إجَارَةٍ لَازِمَةٍ
u'إجَارَةٌ مَاءٌ':Added, #1: 1	إجَارَةٍ لَازِمَةٍ
u'إجَارَةٌ مَاءٌ':Added, #1: 1	إجَارَةُ مَاءٍ
u'إجَارَةٌ مَالٌ':Added, #1: 1	إجَارَةِ مَاءِ
u'إجَارَةٌ مَبِيعٌ':Added, #1: 1	إجَارَةِ مَالِ
u'إجَارَةٌ مثل':Added, #1: 1	إجَارَةُ الْمَبِيعِ
u'إجَارَةٌ مِثْلٌ':Added, #2: 2	إجَارَةِ الْمِثْلِ
u'إجَارَةٌ مثل':Added, #2: 2	إجَارَةِ الْمِثْلِ
u'إجَارَةٌ مِثْلٌ':Added, #2: 2	إجَارَةَ مِثْلِهِ
u'إجَارَةٌ مثل':Added, #2: 2	إجَارَةَ مِثْلِهِ
u'إجَارَةٌ مِثْلٌ':Added, #3: 3	إجَارَةُ الْمِثْلِ
u'إجَارَةٌ مثل':Added, #3: 3	إجَارَةُ الْمِثْلِ
u'إجَارَةٌ مثل':Added, #4: 4	إجَارَةُ مِثْلِهِ
u'إجَارَةٌ مِثْلٌ':Added, #4: 4	إجَارَةِ مِثْلِهِ
u'إجَارَةٌ مِثْلٌ':Added, #4: 4	إجَارَةُ مِثْلِهِ
u'إجَارَةٌ مَحْدُودٌ':Added, #4: 4	إجَارَةِ مِثْلِهِ
u'إجَارَةٌ مَحْدُودٌ':Added, #1: 1	إجَارَةٍ مَحْدُودٍ
u'إجَارَةٌ مُدَّةٌ':Added, #2: 2	إجَارَةُ مَحْدُودِ
u'إجَارَةٌ مُدَّةٌ':Added, #2: 2	إجَارَةَ الْمُدَّةِ
u'إجَارَةٌ مُدَّةٌ':Added, #2: 2	إجَارَةِ الْمُدَّةِ
u'إجَارَةٌ مُدَّةٌ':Added, #2: 2	إجَارَةُ مُدَّةٍ
u'إجَارَةٌ مُرْضِعٌ':Added, #4: 4	إجَارَةُ الْمُدَّةِ
u'إجَارَةٌ مَرْهُونٌ':Added, #1: 1	إجَارَةَ الْمُرْضِعِ
u'إجَارَةٌ مَرْهُونٌ':Added, #1: 1	إجَارَةُ الْمَرْهُونِ
u'إجَارَةٌ مُسْتَأْجِرٌ':Added, #1: 1	إجَارَةِ الْمَرْهُونِ
u'إجَارَةٌ مُسْتَأْجِرٌ':Added, #1: 1	إجَارَةُ الْمُسْتَأْجِرِ
u'إجَارَةٌ مُسْتَأْنَفٌ':Added, #5: 5	إجَارَةِ الْمُسْتَأْجِرِ
u'إجَارَةٌ مُسْتَقْبَلٌ':Added, #1: 1	إجَارَةٍ مُسْتَأْنَفَةٍ
u'إجَارَةٌ مُسَقَّف':Added, #1: 1	إجَارَةٍ مُسْتَقْبَلَةٍ
u'إجَارَةٌ مَسْكَنٌ':Added, #1: 1	إجَارَةُ الْمُسَقَّفِ
u'إجَارَةٌ مُسْلِمٌ':Added, #1: 1	إجَارَةِ مَسْكَنٍ
u'إجَارَةٌ مُسْلِمٌ':Added, #2: 2	إجَارَةُ الْمُسْلِمِ
u'إجَارَةٌ مُشاعٌ':Added, #3: 3	إجَارَةُ مُسْلِمٍ
u'إجَارَةٌ مُشاعٌ':Added, #10: 10	إجَارَةِ الْمُشَاعِ
u'إجَارَةٌ مُشاعٌ':Added, #1: 1	إجَارَةَ الْمُشَاعِ
u'إجَارَةٌ مُشاعٌ':Added, #2: 2	إجَارَةُ مُشَاعٍ
u'إجَارَةٌ مُشْتَرَكٌ':Added, #8: 8	إجَارَةُ الْمُشَاعِ
u'إجَارَةٌ مَشْغُولٌ':Added, #1: 1	إجَارَةِ الْمُشْتَرَكِ
u'إجَارَةٌ مُصْحَفٌ':Added, #2: 2	إجَارَةِ الْمَشْغُولِ
u'إجَارَةٌ مُصْحَفٌ':Added, #1: 1	إجَارَةِ الْمُصْحَفِ
u'إجَارَةٌ مُصْحَفٌ':Added, #1: 1	إجَارَةُ مُصْحَفٍ
u'إجَارَةٌ مُضَافٌ':Added, #2: 2	إجَارَةُ الْمُصْحَفِ
u'إجَارَةٌ مُضَافٌ':Added, #1: 1	إجَارَةِ الْمُضَافِ
u'إجَارَةٌ مُطْلَقٌ':Added, #1: 1	إجَارَةٍ مُضَافَةٍ
u'إجَارَةٌ مُغارَسَة':Added, #1: 1	إجَارَةٍ مُطْلَقَةٍ
u'إجَارَةٌ مُفْلِسٌ':Added, #1: 1	إجَارَةُ الْمُغَارَسَةِ
u'إجَارَةٌ مُفْلِسٌ':Added, #1: 1	إجَارَةَ الْمُفْلِسِ
u'إجَارَةٌ مَنَازِلُ':Added, #2: 2	إجَارَةِ الْمُفْلِسِ
u'إجَارَةٌ مَنَافِعُ':Added, #2: 2	إجَارَةِ الْمَنَازِلِ
u'إجَارَةٌ مَنَافِعُ':Added, #1: 1	إجَارَةِ الْمَنَافِعِ
u'إجَارَةٌ مَنَافِعُ':Added, #2: 2	إجَارَةَ مَنَافِعِ
u'إجَارَةٌ مَنْزِلٌ':Added, #3: 3	إجَارَةُ الْمَنَافِعِ
u'إجَارَةٌ مَنْزِلٌ':Added, #1: 1	إجَارَةَ الْمَنْزِلِ
u'إجَارَةٌ مُؤَجَّرٌ':Added, #1: 1	إجَارَةُ الْمَنْزِلِ
u'إجَارَةٌ مُؤَجِّرٌ':Added, #1: 1	إجَارَةُ الْمُؤَجَّرِ
u'إجَارَةٌ مَوْقُوفٌ':Added, #1: 1	إجَارَةُ الْمُؤَجِّرِ
u'إجَارَةٌ مَوْقُوفٌ':Added, #1: 1	إجَارَةِ الْمَوْقُوفِ
u'إجَارَةٌ مَوْقُوفٌ':Added, #2: 2	إجَارَةَ الْمَوْقُوفِ
u'إجَارَةٌ نَاظِرٌ':Added, #2: 2	إجَارَةُ الْمَوْقُوفِ
u'إجَارَةٌ نَاظِرٌ':Added, #1: 1	إجَارَةَ نَاظِرِ
u'إجَارَةٌ نَاظِرٌ':Added, #1: 1	إجَارَةُ نَاظِرِ
u'إجَارَةٌ نَاظِرٌ':Added, #1: 1	إجَارَةِ نَاظِرِ
u'إجَارَةٌ نَاظِرٌ':Added, #3: 3	إجَارَةَ النَّاظِرِ
u'إجَارَةٌ نَاظِرٌ':Added, #3: 3	إجَارَةِ النَّاظِرِ
u'إجَارَةٌ نَخْلٌ':Added, #6: 6	إجَارَةُ النَّاظِرِ
u'إجَارَةٌ نَخِيلٌ':Added, #1: 1	إجَارَةَ النَّخْلِ
u'إجَارَةٌ نِصْفٌ':Added, #1: 1	إجَارَةِ النَّخِيلِ
u'إجَارَةٌ نِصْفٌ':Added, #1: 1	إجَارَةُ نِصْفِ
u'إجَارَةٌ نَصِيبٌ':Added, #2: 2	إجَارَةُ النِّصْفِ
u'إجَارَةٌ نَصِيبٌ':Added, #1: 1	إجَارَةِ نَصِيبِ
u'إجَارَةٌ نَصِيبٌ':Added, #1: 1	إجَارَةُ نَصِيبِهِ
u'إجَارَةٌ نَفْسٌ':Added, #1: 1	إجَارَةِ نَصِيبِهِ
u'إجَارَةٌ نَفْسٌ':Added, #1: 1	إجَارَةَ النَّفْسِ
u'إجَارَةٌ نَفْسٌ':Added, #1: 1	إجَارَةُ النَّفْسِ
u'إجَارَةٌ نَفْسٌ':Added, #1: 1	إجَارَةُ نَفْسِهِ
u'إجَارَةٌ نَقْدٌ':Added, #2: 2	إجَارَةِ نَفْسِهِ
u'إجَارَةٌ نَقْد':Added, #1: 1	إجَارَةِ النَّقْدِ
u'إجَارَةٌ نَقْدٌ':Added, #1: 1	إجَارَةِ النَّقْدِ
u'إجَارَةٌ نَقْد':Added, #2: 2	إجَارَةُ النَّقْدِ
u'إجَارَةٌ نَقْدٌ':Added, #2: 2	إجَارَةُ النَّقْدِ
u'إجَارَةٌ نَقْدٌ':Added, #2: 2	إجَارَةَ نَقْدٍ
u'إجَارَةٌ نَقْد':Added, #2: 2	إجَارَةُ نَقْدٍ
u'إجَارَةٌ نَقْد':Added, #2: 2	إجَارَةَ نَقْدٍ
u'إجَارَةٌ هِبَةٌ':Added, #2: 2	إجَارَةُ نَقْدٍ
u'إجَارَةٌ هِرٌّ':Added, #3: 3	إجَارَةُ هِبَةٍ
u'إجَارَةٌ هِرٌّ':Added, #1: 1	إجَارَةُ هِرٍّ
u'إجَارَةٌ وَارِثٌ':Added, #1: 1	إجَارَةِ هِرٍّ
u'إجَارَةٌ وَقْفٌ':Added, #1: 1	إجَارَةُ الْوَارِثِ
u'إجَارَةٌ وَقْفٌ':Added, #11: 11	إجَارَةُ الْوَقْفِ
u'إجَارَةٌ وَقْفٌ':Added, #11: 11	إجَارَةِ الْوَقْفِ
u'إجَارَةٌ وَقْفٌ':Added, #1: 1	إجَارَة الْوَقْفِ
u'إجَارَةٌ وَقْفٌ':Added, #1: 1	إجَارَةِ وَقْفٍ
u'إجَارَةٌ وقفة':Added, #7: 7	إجَارَةَ الْوَقْفِ
u'إجَارَةٌ وَقْفَةٌ':Added, #1: 1	إجَارَةِ وَقْفَةٍ
u'إجَارَةٌ ولد':Added, #1: 1	إجَارَةِ وَقْفَةٍ
u'إجَارَةٌ وَلَدٌ':Added, #1: 1	إجَارَةُ الْوَلَدِ
u'إجَارَةٌ وَلِيٌّ':Added, #1: 1	إجَارَةُ الْوَلَدِ
u'أَجَارَ رَجُلٌ':Subject, #1: 1	إجَارَةُ الْوَلِيِّ
u'أَجَارَ لَطِيم':Predicate, #1: 1	أَجَارَ رَجُلٌ
u'أَجَازَ أَبٌ':Subject, #2: 2	أَجَارَ لَطِيمَةً
u'أَجَازَ اِبْنٌ':Subject, #2: 2	أَجَازَ الْأَبُ
u'أَجَازَ اِبْنٌ':Subject, #14: 14	أَجَازَ ابْنُ
u'أَجَازَ إجَارَةٌ':Predicate, #2: 2	أَجَازَ ابْنٌ
u'أَجَازَ أحَدٌ':Predicate, #3: 3	أَجَازَ الْإِجَارَةَ
u'أَجَازَ أحَدٌ':Subject, #1: 1	أَجَازَ أَحَدَ
u'أَجَازَ أحَدٌ':Subject, #1: 1	أَجَازَ أَحَدٌ
u'أَجَازَ أخْذٌ':Predicate, #1: 1	أَجَازَ أَحَدُ
u'أَجَازَ أَشْهَب':Subject, #1: 1	أَجَازَ أَخْذَ
u'أَجَازَ أكل':Predicate, #1: 1	أَجَازَ أَشْهَبُ
u'أَجَازَ أَكْلٌ':Predicate, #1: 1	أَجَازَ أَكْلَ
u'أَجَازَ إمَامٌ':Subject, #1: 1	أَجَازَ أَكْلَ
u'أَجَازَ أمَانٌ':Predicate, #2: 2	أَجَازَ الْإِمَامُ
u'أَجَازَ أَوْدِيَةٌ':Predicate, #1: 1	أَجَازَ أَمَانَ
u'أَجَازَ أَوَّلُ':Predicate, #1: 1	أَجَازَ الأَوْدِيَةَ
u'أَجَازَ أَوَّلُ':Subject, #1: 1	أَجَازَ الْأَوَّلَ
u'أَجَازَ بَائِعٌ':Subject, #2: 2	أَجَازَ الْأَوَّلُ
u'أَجَازَ بَحْرٌ':Predicate, #11: 11	أَجَازَ الْبَائِعُ
u'أَجَازَ بَدَلٌ':Predicate, #1: 1	أَجَازَ الْبَحْرَ
u'أَجَازَ بَطَلٌ':Predicate, #1: 1	أَجَازَ الْبَدَلَ
u'أَجَازَ بَعْضٌ':Predicate, #1: 1	أَجَازَ بَطَلَ
u'أَجَازَ بَعْضٌ':Predicate, #1: 1	أَجَازَ الْبَعْضَ
u'أَجَازَ بَعْضٌ':Subject, #1: 1	أَجَازَ بَعْضَ
u'أَجَازَ بَعْضٌ':Subject, #1: 1	أَجَازَ بَعْضُ
u'أَجَازَ بَعْضٌ':Subject, #2: 2	أَجَازَ بَعْضٌ
u'أَجَازَ بَقِيَّةٌ':Subject, #3: 3	أَجَازَ الْبَعْضُ
u'أَجَازَ بِنَاءٌ':Predicate, #2: 2	أَجَازَ بَقِيَّةُ
u'أَجَازَ بَيات':Predicate, #1: 1	أَجَازَ الْبِنَاءَ
u'أَجَازَ بَيْعٌ':Predicate, #1: 1	أَجَازَ الْبَيَاتَ
u'أَجَازَ بَيْعٌ':Predicate, #12: 12	أَجَازَ بَيْعَ
u'أَجَازَ بَيِّنَةٌ':Predicate, #62: 62	أَجَازَ الْبَيْعَ
u'إجَازَةٌ أَبٌ':Added, #1: 1	أَجَازَ بَيِّنَةَ
u'إجَازَةٌ أَبٌ':Added, #1: 1	إجَازَةُ الْأَبِ
u'إجَازَةٌ أَخٌ':Added, #1: 1	إجَازَةِ الْأَبِ
u'إجَازَةٌ اِقْتِضَاءٌ':Added, #1: 1	إجَازَةِ الْأَخِ
u'إجَازَةٌ أقْرَبُ':Added, #1: 1	إجَازَةُ اقْتِضَاءٍ
u'إجَازَةٌ الْمَرْأَةُ':Added, #2: 2	إجَازَةِ الْأَقْرَبِ
u'إجَازَةٌ إمَامٌ':Added, #2: 2	إجَازَةِ الْمَرْأَةِ
u'إجَازَةٌ آمِرٌ':Added, #3: 3	إجَازَةِ الْإِمَامِ
u'إجَازَةٌ أَميرٌ':Added, #1: 1	إجَازَةِ الْآمِرِ
u'إجَازَةٌ إِنْسانٌ':Added, #1: 1	إجَازَةِ الْأَمِيرِ
u'إجَازَةٌ إِنْسانٌ':Added, #1: 1	إجَازَةُ الْإِنْسَانِ
u'إجَازَةٌ أَوَّلُ':Added, #1: 1	إجَازَةِ إنْسَانٍ
u'إجَازَةٌ أَوْلاَدٌ':Added, #5: 5	إجَازَةِ الْأَوَّلِ
u'إجَازَةٌ بَائِعٌ':Added, #1: 1	إجَازَةِ أَوْلَادِ
u'إجَازَةٌ بَطْنٌ':Added, #7: 7	إجَازَةِ الْبَائِعِ
u'إجَازَةٌ بَعْضٌ':Added, #1: 1	إجَازَةِ الْبَطْنِ
u'إجَازَةٌ بَعْضٌ':Added, #1: 1	إجَازَةَ بَعْضِ
u'إجَازَةٌ بَقِيَّةٌ':Added, #1: 1	إجَازَةُ بَعْضِ
u'إجَازَةٌ بَيْتٌ':Added, #10: 10	إجَازَةِ بَقِيَّةِ
u'إجَازَةٌ بَيْعٌ':Added, #1: 1	إجَازَةِ بَيْتِ
u'إجَازَةٌ بَيْعٌ':Added, #10: 10	إجَازَةِ الْبَيْعِ
u'إجَازَةٌ بَيْعٌ':Added, #2: 2	إجَازَةِ بَيْعِ
u'إجَازَةٌ بَيْعٌ':Added, #2: 2	إجَازَةِ بَيْعِهِ
u'إجَازَةٌ بَيْعٌ':Added, #3: 3	إجَازَةُ الْبَيْعِ
u'إجَازَةٌ بَيْعٌ':Added, #3: 3	إجَازَةَ بَيْعِ
u'إجَازَةٌ تَرْكٌ':Added, #9: 9	إجَازَةَ الْبَيْعِ
u'إجَازَةٌ تَصَدُّقٌ':Added, #1: 1	إجَازَةِ التَّرْكِ
u'إجَازَةٌ تَصْدِيقٌ':Added, #1: 1	إجَازَةِ التَّصَدُّقِ
u'إجَازَةٌ تَصَرُّفٌ':Added, #1: 1	إجَازَةُ التَّصْدِيقِ
u'إجَازَةٌ تَيَمُّمٌ':Added, #1: 1	إجَازَةَ تَصَرُّفَاتِهِ
u'إجَازَةٌ جمع':Added, #1: 1	إجَازَةِ التَّيَمُّمِ
u'إجَازَةٌ جَمْعٌ':Added, #1: 1	إجَازَةُ الْجَمْعِ
u'إجَازَةٌ خيار':Added, #1: 1	إجَازَةُ الْجَمْعِ
u'إجَازَةٌ خِيَارٌ':Added, #1: 1	إجَازَةِ خِيَارِ
u'إجَازَةٌ دُفٌّ':Added, #1: 1	إجَازَةِ خِيَارِ
u'إجَازَةٌ دَلالَةٌ':Added, #1: 1	إجَازَةِ الدُّفِّ
u'إجَازَةٌ رَبُّ':Added, #1: 1	إجَازَةُ دَلَالَةٍ
u'إجَازَةٌ رَبُّ':Added, #1: 1	إجَازَةِ رَبِّ
u'إجَازَةٌ رِوايَةٌ':Added, #1: 1	إجَازَةِ رَبِّهِ
u'إجَازَةٌ رِوايَةٌ':Added, #1: 1	إجَازَةَ الرِّوَايَةِ
u'إجَازَةٌ زَوْجٌ':Added, #1: 1	إجَازَةُ رِوَايَةِ
u'إجَازَةٌ سَفِيهٌ':Added, #20: 20	إجَازَةِ الزَّوْجِ
u'إجَازَةٌ سَيِّدٌ':Added, #1: 1	إجَازَةُ السَّفِيهِ
u'إجَازَةٌ سَيِّدٌ':Added, #1: 1	إجَازَةِ السَّيِّدِ
u'إجَازَةٌ شَرْعٌ':Added, #1: 1	إجَازَةِ سَيِّدِهِ
u'إجَازَةٌ شَرِيكٌ':Added, #3: 3	إجَازَةِ الشَّرْعِ
u'إجَازَةٌ شَفِيعٌ':Added, #3: 3	إجَازَةِ شَرِيكِهِ
u'إجَازَةٌ شَفِيعٌ':Added, #1: 1	إجَازَةُ الشَّفِيعِ
u'إجَازَةٌ شَهَادَةٌ':Added, #2: 2	إجَازَةِ الشَّفِيعِ
u'إجَازَةٌ شَهَادَةٌ':Added, #1: 1	إجَازَةِ الشَّهَادَةِ
u'إجَازَةٌ صَاحِبٌ':Added, #1: 1	إجَازَةُ شَهَادَةِ
u'إجَازَةٌ صلح':Added, #5: 5	إجَازَةِ صَاحِبِهِ
u'إجَازَةٌ صُلْحٌ':Added, #1: 1	إجَازَةَ الصُّلْحِ
u'إجَازَةٌ صَوْمٌ':Added, #1: 1	إجَازَةَ الصُّلْحِ
u'إجَازَةٌ ضَرْبٌ':Added, #1: 1	إجَازَةِ الصَّوْمِ
u'إجَازَةٌ طَالِبٌ':Added, #1: 1	إجَازَةِ الضَّرْبِ
u'إجَازَةٌ طَلاَقٌ':Added, #1: 1	إجَازَةِ الطَّالِبِ
u'إجَازَةٌ عَبْدٌ':Added, #1: 1	إجَازَةِ الطَّلَاقِ
u'إجَازَةٌ عَبْدٌ':Added, #1: 1	إجَازَةِ عَبْدِ
u'إجَازَةٌ عتق':Added, #9: 9	إجَازَةِ الْعَبْدِ
u'إجَازَةٌ عِتْقٌ':Added, #1: 1	إجَازَة عِتْقِهِ
u'إجَازَةٌ عَتِيقٌ':Added, #1: 1	إجَازَة عِتْقِهِ
u'إجَازَةٌ عَقْدٌ':Added, #1: 1	إجَازَةِ الْعَتِيقِ
u'إجَازَةٌ عَقْدٌ':Added, #1: 1	إجَازَةَ عَقْدٍ
u'إجَازَةٌ عَقْدٌ':Added, #1: 1	إجَازَةِ عَقْدِ
u'إجَازَةٌ عَقْدٌ':Added, #1: 1	إجَازَةِ عَقْدِهِ
u'إجَازَةٌ عَقْدٌ':Added, #3: 3	إجَازَةَ الْعَقْدِ
u'إجَازَةٌ عُقُودٌ':Added, #3: 3	إجَازَةُ عَقْدٍ
u'إجَازَةٌ غَائِبٌ':Added, #1: 1	إجَازَةِ الْعُقُودِ
u'إجَازَةٌ غرماء':Added, #5: 5	إجَازَةِ الْغَائِبِ
u'إجَازَةٌ غَسْلٌ':Added, #6: 6	إجَازَةِ الْغُرَمَاءِ
u'إجَازَةٌ غير':Added, #1: 1	إجَازَةُ غَسْلِ
u'إجَازَةٌ غَيْرٌ':Added, #1: 1	إجَازَةِ الْغَيْرِ
u'إجَازَةٌ غير':Added, #1: 1	إجَازَةِ الْغَيْرِ
u'إجَازَةٌ غَيْرٌ':Added, #2: 2	إجَازَةِ غَيْرِهِ
u'إجَازَةٌ فُلاَنٌ':Added, #2: 2	إجَازَةِ غَيْرِهِ
u'إجَازَةٌ قَبْضٌ':Added, #2: 2	إجَازَةِ فُلَانٍ
u'إجَازَةٌ قَبْضٌ':Added, #1: 1	إجَازَةَ الْقَبْضِ
u'إجَازَةٌ قسمة':Added, #1: 1	إجَازَةُ الْقَبْضِ
u'إجَازَةٌ قِسْمَةٌ':Added, #1: 1	إجَازَةَ الْقِسْمَةِ
u'إجَازَةٌ قَضَاءٌ':Added, #1: 1	إجَازَةَ الْقِسْمَةِ
u'إجَازَةٌ كِتَابَةٌ':Added, #2: 2	إجَازَةَ قَضَاءِ
u'إجَازَةٌ كِرَاءٌ':Added, #1: 1	إجَازَةَ الْكِتَابَةِ
u'إجَازَةٌ كَفَالَةٌ':Added, #1: 1	إجَازَةُ كِرَاءِ
u'إجَازَةٌ كَلاَمٌ':Added, #1: 1	إجَازَةِ الْكَفَالَةِ
u'إجَازَةٌ مَالِكٌ':Added, #1: 1	إجَازَةِ الْكَلَامِ
u'إجَازَةٌ مَالِكٌ':Added, #1: 1	إجَازَةِ مَالِكٍ
u'إجَازَةٌ مَالِكٌ':Added, #1: 1	إجَازَةِ مَالِكِهِ
u'إجَازَةٌ مُبَادَلَةٌ':Added, #22: 22	إجَازَةِ الْمَالِكِ
u'إجَازَةٌ مَجْهُولٌ':Added, #1: 1	إجَازَةِ مُبَادَلَةِ
u'إجَازَةٌ مُجِيزٌ':Added, #1: 1	إجَازَةِ الْمَجْهُولِ
u'إجَازَةٌ مُرْتَهِنٌ':Added, #2: 2	إجَازَةِ الْمُجِيزِ
u'إجَازَةٌ مُرْتَهِنٌ':Added, #10: 10	إجَازَةِ الْمُرْتَهِنِ
u'إجَازَةٌ مُزَارِعٌ':Added, #1: 1	إجَازَةِ مُرْتَهِنِهِ
u'إجَازَةٌ مُزَارِعٌ':Added, #1: 1	إجَازَةَ الْمُزَارِعِ
u'إجَازَةٌ مُساقاة':Added, #4: 4	إجَازَةِ الْمُزَارِعِ
u'إجَازَةٌ مُسْتَأْجِرٌ':Added, #1: 1	إجَازَةِ الْمُسَاقَاةِ
u'إجَازَةٌ مُسْتَأْنَفٌ':Added, #1: 1	إجَازَةِ الْمُسْتَأْجِرِ
u'إجَازَةٌ مُسْتَحِقٌّ':Added, #1: 1	إجَازَةٍ مُسْتَأْنَفَةٍ
u'إجَازَةٌ مُسْتَحِقٌّ':Added, #5: 5	إجَازَةِ الْمُسْتَحِقِّ
u'إجَازَةٌ مُسَلَّمٌ':Added, #6: 6	إجَازَةُ الْمُسْتَحِقِّ
u'إجَازَةٌ مَغْصُوب':Added, #1: 1	إجَازَةِ الْمُسَلَّمِ
u'إجَازَةٌ مُفْلِسٌ':Added, #1: 1	إجَازَةِ الْمَغْصُوبِ
u'إجَازَةٌ مُكَاتَبَةٌ':Added, #2: 2	إجَازَةُ الْمُفْلِسِ
u'إجَازَةٌ مُكْرَهٌ':Added, #1: 1	إجَازَةَ الْمُكَاتَبَةِ
u'إجَازَةٌ مَكْفُولٌ':Added, #1: 1	إجَازَةِ الْمُكْرَهِ
u'إجَازَةٌ مَكْفُولٌ':Added, #1: 1	إجَازَةُ الْمَكْفُولِ
u'إجَازَةٌ مَنْفَعَةٌ':Added, #2: 2	إجَازَةِ الْمَكْفُولِ
u'إجَازَةٌ مُوَرِّث':Added, #1: 1	إجَازَةُ الْمَنْفَعَةِ
u'إجَازَةٌ مَوْضِعٌ':Added, #2: 2	إجَازَةِ الْمُوَرِّثِ
u'إجَازَةٌ مُوَكِّلٌ':Added, #1: 1	إجَازَةِ مَوْضِعٍ
u'إجَازَةٌ نَفْسٌ':Added, #16: 16	إجَازَةِ الْمُوَكِّلِ
u'إجَازَةٌ نَفْسٌ':Added, #1: 1	إجَازَةُ نَفْسِهِ
u'إجَازَةٌ نَقْدٌ':Added, #2: 2	إجَازَةِ نَفْسِهِ
u'إجَازَةٌ نَقْد':Added, #4: 4	إجَازَةُ نَقْدٍ
u'إجَازَةٌ نكاح':Added, #4: 4	إجَازَةُ نَقْدٍ
u'إجَازَةٌ نِكَاحٌ':Added, #1: 1	إجَازَةِ النِّكَاحِ
u'إجَازَةٌ نكاح':Added, #1: 1	إجَازَةِ النِّكَاحِ
u'إجَازَةٌ نكاح':Added, #1: 1	إجَازَةَ نِكَاحِ
u'إجَازَةٌ نِكَاحٌ':Added, #1: 1	إجَازَةِ نِكَاحٍ
u'إجَازَةٌ نِكَاحٌ':Added, #1: 1	إجَازَةَ نِكَاحِ
u'إجَازَةٌ نكاح':Added, #1: 1	إجَازَةِ نِكَاحٍ
u'إجَازَةٌ نِكَاحٌ':Added, #2: 2	إجَازَةُ النِّكَاحِ
u'إجَازَةٌ نكاح':Added, #2: 2	إجَازَةُ النِّكَاحِ
u'إجَازَةٌ نكاح':Added, #2: 2	إجَازَةُ نِكَاحِ
u'إجَازَةٌ نِكَاحٌ':Added, #2: 2	إجَازَةِ نِكَاحِ
u'إجَازَةٌ نِكَاحٌ':Added, #2: 2	إجَازَةُ نِكَاحِ
u'إجَازَةٌ واحد':Added, #2: 2	إجَازَةِ نِكَاحِ
u'إجَازَةٌ وَاحِدٌ':Added, #1: 1	إجَازَةُ وَاحِدٍ
u'إجَازَةٌ وَارِثٌ':Added, #1: 1	إجَازَةُ وَاحِدٍ
u'إجَازَةٌ وَارِثٌ':Added, #2: 2	إجَازَةَ الْوَارِثِ
u'إجَازَةٌ وَارِثٌ':Added, #2: 2	إجَازَةِ وَارِثِهِ
u'إجَازَةٌ وَارِثٌ':Added, #3: 3	إجَازَةُ الْوَارِثِ
u'إجَازَةٌ وَالِدٌ':Added, #7: 7	إجَازَةِ الْوَارِثِ
u'إجَازَةٌ وَرَثَةٌ':Added, #1: 1	إجَازَةِ وَالِدِهِ
u'إجَازَةٌ وَرَثَةٌ':Added, #1: 1	إجَازَةُ الْوَرَثَةِ
u'إجَازَةٌ وَرَثَةٌ':Added, #2: 2	إجَازَةَ الْوَرَثَةِ
u'إجَازَةٌ وَصِيٌّ':Added, #43: 43	إجَازَةِ الْوَرَثَةِ
u'إجَازَةٌ وَصِيٌّ':Added, #1: 1	إجَازَةِ الْوَصِيِّ
u'إجَازَةٌ وَصِيٌّ':Added, #1: 1	إجَازَةُ الْوَصِيَّةِ
u'إجَازَةٌ وَصِيَّةٌ':Added, #1: 1	إجَازَةِ وَصِيَّةِ
u'إجَازَةٌ وَصِيَّةٌ':Added, #1: 1	إجَازَةُ الْوَصِيَّةِ
u'إجَازَةٌ وَقْفٌ':Added, #1: 1	إجَازَةِ وَصِيَّةِ
u'إجَازَةٌ وَكِيلٌ':Added, #1: 1	إجَازَةُ الْوَقْفِ
u'إجَازَةٌ وَكِيلٌ':Added, #1: 1	إجَازَةَ الْوَكِيلِ
u'إجَازَةٌ وَكِيلٌ':Added, #1: 1	إجَازَةِ وَكِيلِهِ
u'إجَازَةٌ وَكِيلٌ':Added, #2: 2	إجَازَةُ الْوَكِيلِ
u'إجَازَةٌ ولد':Added, #2: 2	إجَازَةِ الْوَكِيلِ
u'إجَازَةٌ وَلَدٌ':Added, #1: 1	إجَازَةِ الْوَلَدِ
u'إجَازَةٌ وَلِيٌّ':Added, #1: 1	إجَازَةِ الْوَلَدِ
u'إجَازَةٌ وَلِيٌّ':Added, #13: 13	إجَازَةِ وَلِيِّهِ
u'إجَازَةٌ وَلِيٌّ':Added, #19: 19	إجَازَةِ الْوَلِيِّ
u'أَجَازَ تَأْخِيرٌ':Predicate, #1: 1	إجَازَةُ الْوَلِيِّ
u'أَجَازَ تَثْنِيَةٌ':Predicate, #3: 3	أَجَازَ تَأْخِيرَ
u'أَجَازَ تَخْصِيصٌ':Predicate, #1: 1	أَجَازَ التّثْنِيَةَ
u'أَجَازَ تَخْصِيصٌ':Predicate, #1: 1	أَجَازَ التَّخْصِيصَ
u'أَجَازَ تَرْكِيبٌ':Predicate, #3: 3	أَجَازَ تَخْصِيصَ
u'أَجَازَ تَسْبِيحٌ':Predicate, #1: 1	أَجَازَ التَّرْكِيبَ
u'أَجَازَ تَعَلُّقٌ':Predicate, #1: 1	أَجَازَ التَّسْبِيحَ
u'أَجَازَ تَقْليبٌ':Predicate, #1: 1	أَجَازَ التَّعَلُّقَ
u'أَجَازَ تَكْليفٌ':Predicate, #1: 1	أَجَازَ تَقْلِيبَ
u'أَجَازَ تَكْليفٌ':Predicate, #1: 1	أَجَازَ التَّكْلِيفَ
u'أَجَازَ تَوَكُّلٌ':Predicate, #1: 1	أَجَازَ تَكْلِيفَ
u'أَجَازَ جَازٌ':Predicate, #1: 1	أَجَازَ التَّوَكُّلَ
u'أَجَازَ جُزْءٌ':Predicate, #18: 18	أَجَازَ جَازَ
u'أَجَازَ جِوَارٌ':Predicate, #1: 1	أَجَازَ الْجُزْءَ
u'أَجَازَ حاكِمٌ':Subject, #1: 1	أَجَازَ جِوَارَ
u'أَجَازَ حالٌ':Predicate, #1: 1	أَجَازَ الْحَاكِمُ
u'أَجَازَ حُكْمٌ':Predicate, #1: 1	أَجَازَ حَالَ
u'أَجَازَ حَمْلٌ':Predicate, #2: 2	أَجَازَ حُكْمَ
u'أَجَازَ خراج':Predicate, #1: 1	أَجَازَ حَمْلَ
u'أَجَازَ خَرَاجٌ':Predicate, #1: 1	أَجَازَ الْخَرَاجَ
u'أَجَازَ خيار':Predicate, #1: 1	أَجَازَ الْخَرَاجَ
u'أَجَازَ خِيَارٌ':Predicate, #5: 5	أَجَازَ الْخِيَارَ
u'أَجَازَ ذَكاةٌ':Predicate, #5: 5	أَجَازَ الْخِيَارَ
u'أَجَازَ رَاهِنٌ':Subject, #1: 1	أَجَازَ ذَكَاةَ
u'أَجَازَ رَبُّ':Subject, #3: 3	أَجَازَ الرَّاهِنُ
u'أَجَازَ رُبُعٌ':Subject, #6: 6	أَجَازَ رَبُّ
u'أَجَازَ رَجُلٌ':Subject, #1: 1	أَجَازَ الرُّبُعُ
u'أَجَازَ رَدٌّ':Predicate, #1: 1	أَجَازَ الرَّجُلُ
u'أَجَازَ رَسُولٌ':Subject, #1: 1	أَجَازَ الرَّدَّ
u'أَجَازَ رَهْنٌ':Predicate, #7: 7	أَجَازَ رَسُولُ
u'أَجَازَ رِوايَةٌ':Predicate, #1: 1	أَجَازَ الرَّهْنَ
u'أَجَازَ زَوْجٌ':Subject, #2: 2	أَجَازَ الرِّوَايَةَ
u'أَجَازَ سَائِرٌ':Subject, #15: 15	أَجَازَ الزَّوْجُ
u'أَجَازَ سقط':Predicate, #1: 1	أَجَازَ سَائِرُ
u'أَجَازَ سَقَطٌ':Predicate, #1: 1	أَجَازَ سَقَطَ
u'أَجَازَ سَلَفٌ':Subject, #1: 1	أَجَازَ سَقَطَ
u'أَجَازَ سَلَمٌ':Predicate, #1: 1	أَجَازَ سَلَفُ
u'أَجَازَ سَيِّدٌ':Subject, #2: 2	أَجَازَ السَّلَمَ
u'أَجَازَ شافِعِيّ':Subject, #3: 3	أَجَازَ السَّيِّدُ
u'أَجَازَ شِرَاءٌ':Predicate, #1: 1	أَجَازَ الشَّافِعِيُّ
u'أَجَازَ شَرْطٌ':Predicate, #1: 1	أَجَازَ الشِّرَاءَ
u'أَجَازَ شَرْطٌ':Predicate, #1: 1	أَجَازَ الشَّرْطَ
u'أَجَازَ شَرْعٌ':Subject, #1: 1	أَجَازَ شَرْطَ
u'أَجَازَ شَرِيكٌ':Subject, #1: 1	أَجَازَ الشَّرْعُ
u'أَجَازَ شَرِيكٌ':Subject, #2: 2	أَجَازَ الشَّرِيكُ
u'أَجَازَ شَفِيعٌ':Subject, #4: 4	أَجَازَ شَرِيكُهُ
u'أَجَازَ شَهَادَةٌ':Predicate, #2: 2	أَجَازَ الشَّفِيعُ
u'أَجَازَ شَهَادَةٌ':Subject, #23: 23	أَجَازَ شَهَادَةَ
u'أَجَازَ شَيْخٌ':Subject, #1: 1	أَجَازَ شَهَادَةُ
u'أَجَازَ صَاحِبٌ':Subject, #1: 1	أَجَازَ الشَّيْخُ
u'أَجَازَ صَاحِبٌ':Subject, #5: 5	أَجَازَ صَاحِبُهُ
u'أَجَازَ صَبِيٌّ':Subject, #7: 7	أَجَازَ صَاحِبُ
u'أَجَازَ صَحَابَةٌ':Subject, #1: 1	أَجَازَ الصَّبِيُّ
u'أَجَازَ صدقة':Predicate, #1: 1	أَجَازَ الصَّحَابَةُ
u'أَجَازَ صَدَقَةٌ':Predicate, #1: 1	أَجَازَ الصَّدَقَةَ
u'أَجَازَ صَلاَةٌ':Predicate, #1: 1	أَجَازَ الصَّدَقَةَ
u'أَجَازَ صلح':Predicate, #1: 1	أَجَازَ الصَّلَاةَ
u'أَجَازَ صُلْحٌ':Predicate, #2: 2	أَجَازَ الصُّلْحَ
u'أَجَازَ صَنِيعٌ':Predicate, #2: 2	أَجَازَ الصُّلْحَ
u'أَجَازَ صَوْمٌ':Predicate, #2: 2	أَجَازَ صَنِيعَ
u'أَجَازَ ضحك':Predicate, #2: 2	أَجَازَ صَوْمَ
u'أَجَازَ ضَحِكٌ':Predicate, #1: 1	أَجَازَ الضَّحِكَ
u'أَجَازَ ضَرْبٌ':Predicate, #1: 1	أَجَازَ الضَّحِكَ
u'أَجَازَ طَالِبٌ':Subject, #2: 2	أَجَازَ ضَرْبَ
u'أَجَازَ طَلاَقٌ':Predicate, #2: 2	أَجَازَ الطَّالِبُ
u'أَجَازَ عَامِلٌ':Subject, #1: 1	أَجَازَ الطَّلاَقَ
u'أَجَازَ عَبْدٌ':Subject, #1: 1	أَجَازَ الْعَامِلُ
u'أَجَازَ عَبْدٌ':Subject, #1: 1	أَجَازَ عَبْدُ
u'أَجَازَ عتق':Predicate, #4: 4	أَجَازَ الْعَبْدُ
u'أَجَازَ عِتْقٌ':Predicate, #2: 2	أَجَازَ عِتْقَ
u'أَجَازَ عَقْدٌ':Predicate, #2: 2	أَجَازَ عِتْقَ
u'أَجَازَ عَقْدٌ':Predicate, #2: 2	أَجَازَ عَقْدَ
u'أَجَازَ علماء':Subject, #8: 8	أَجَازَ الْعَقْدَ
u'أَجَازَ عُلَمَاءُ':Subject, #2: 2	أَجَازَ الْعُلَمَاءُ
u'أَجَازَ عَمٌّ':Subject, #2: 2	أَجَازَ الْعُلَمَاءُ
u'أَجَازَ عُمَرٌ':Subject, #1: 1	أَجَازَ الْعَمُّ
u'أَجَازَ عند':Predicate, #1: 1	أَجَازَ عُمَرُ
u'أَجَازَ غَائِبٌ':Subject, #1: 1	أَجَازَ عِنْدَ
u'أَجَازَ غرماء':Subject, #2: 2	أَجَازَ الْغَائِبُ
u'أَجَازَ غَرِيمٌ':Subject, #4: 4	أَجَازَ الْغُرَمَاءُ
u'أَجَازَ غير':Subject, #1: 1	أَجَازَ غَرِيمُ
u'أَجَازَ غَيْرٌ':Subject, #1: 1	أَجَازَ الْغَيْرُ
u'أَجَازَ غير':Subject, #1: 1	أَجَازَ الْغَيْرُ
u'أَجَازَ غَيْرٌ':Subject, #1: 1	أَجَازَ غَيْرُهُ
u'أَجَازَ فَسْخٌ':Predicate, #1: 1	أَجَازَ غَيْرُهُ
u'أَجَازَ فقهاء':Subject, #1: 1	أَجَازَ الْفَسْخَ
u'أَجَازَ فلان':Subject, #1: 1	أَجَازَ الْفُقَهَاءُ
u'أَجَازَ فُلاَنٌ':Subject, #1: 1	أَجَازَ الشَّافِعِيُّ
u'أَجَازَ قَالٌ':Predicate, #1: 1	أَجَازَ فُلَانٌ
u'أَجَازَ قسمة':Predicate, #1: 1	أَجَازَ قَالَ
u'أَجَازَ قِسْمَةٌ':Predicate, #1: 1	أَجَازَ قِسْمَةَ
u'أَجَازَ قسمة':Predicate, #1: 1	أَجَازَ قِسْمَةَ
u'أَجَازَ قِسْمَةٌ':Predicate, #3: 3	أَجَازَ الْقِسْمَةَ
u'أَجَازَ قَضَاءٌ':Predicate, #3: 3	أَجَازَ الْقِسْمَةَ
u'أَجَازَ قَضَاءٌ':Predicate, #1: 1	أَجَازَ الْقَضَاءَ
u'أَجَازَ قَمْحٌ':Predicate, #1: 1	أَجَازَ قَضَاءَ
u'أَجَازَ قَوْمٌ':Subject, #1: 1	أَجَازَ الْقَمْحَ
u'أَجَازَ قِيمَةٌ':Predicate, #2: 2	أَجَازَ قَوْمٌ
u'أَجَازَ كِتَابَةٌ':Predicate, #1: 1	أَجَازَ الْقِيمَةَ
u'أَجَازَ كذب':Predicate, #6: 6	أَجَازَ الْكِتَابَةَ
u'أَجَازَ كَذِبٌ':Predicate, #1: 1	أَجَازَ الْكَذِبَ
u'أَجَازَ كِرَاءٌ':Predicate, #1: 1	أَجَازَ الْكَذِبَ
u'أَجَازَ كِرَاءٌ':Predicate, #1: 1	أَجَازَ كِرَاءَ
u'أَجَازَ كَفَالَةٌ':Predicate, #2: 2	أَجَازَ الْكِرَاءَ
u'أَجَازَ كَلاَمٌ':Predicate, #1: 1	أَجَازَ الْكَفَالَةَ
u'أَجَازَ لبس':Predicate, #4: 4	أَجَازَ الْكَلَامَ
u'أَجَازَ لُبْسٌ':Predicate, #1: 1	أَجَازَ لُبْسَ
u'أَجَازَ لعب':Predicate, #1: 1	أَجَازَ لُبْسَ
u'أَجَازَ لَعِبٌ':Predicate, #1: 1	أَجَازَ اللَّعِبَ
u'أَجَازَ مَالِكٌ':Subject, #1: 1	أَجَازَ اللَّعِبَ
u'أَجَازَ مَالِكٌ':Subject, #1: 1	أَجَازَ مَالِكُهُ
u'أَجَازَ مَالِكٌ':Subject, #23: 23	أَجَازَ مَالِكٌ
u'أَجَازَ مَأْمُورٌ':Subject, #25: 25	أَجَازَ الْمَالِكُ
u'أَجَازَ مُجْبِرٌ':Subject, #1: 1	أَجَازَ الْمَأْمُورُ
u'أَجَازَ مُرَاجَعَةٌ':Predicate, #2: 2	أَجَازَ مُجْبِرٌ
u'أَجَازَ مُرْتَهِنٌ':Subject, #2: 2	أَجَازَ مُرَاجَعَةَ
u'أَجَازَ مَرِيضٌ':Subject, #12: 12	أَجَازَ الْمُرْتَهِنُ
u'أَجَازَ مُزَارِعٌ':Subject, #2: 2	أَجَازَ الْمَرِيضُ
u'أَجَازَ مُسْتَأْجِرٌ':Subject, #7: 7	أَجَازَ الْمُزَارِعُ
u'أَجَازَ مُسْتَحِقٌّ':Predicate, #4: 4	أَجَازَ الْمُسْتَأْجِرُ
u'أَجَازَ مُسْتَحِقٌّ':Subject, #1: 1	أَجَازَ الْمُسْتَحِقَّ
u'أَجَازَ مُسْتَحَقٌّ':Subject, #19: 19	أَجَازَ الْمُسْتَحِقُّ
u'أَجَازَ مُسْتَحِقٌّ':Subject, #1: 1	أَجَازَ الْمُسْتَحَقُّ
u'أَجَازَ مَسْجِدٌ':Predicate, #1: 1	أَجَازَ مُسْتَحِقُّ
u'أَجَازَ مَسْحٌ':Predicate, #1: 1	أَجَازَ الْمَسْجِدَ
u'أَجَازَ مَطْلُوبٌ':Subject, #1: 1	أَجَازَ الْمَسْحَ
u'أَجَازَ مُعَامَلَةٌ':Predicate, #1: 1	أَجَازَ الْمَطْلُوبُ
u'أَجَازَ مَعْدُومٌ':Predicate, #1: 1	أَجَازَ الْمُعَامَلَةَ
u'أَجَازَ مَغْصُوب':Subject, #1: 1	أَجَازَ الْمَعْدُومَ
u'أَجَازَ مَفْهُومٌ':Predicate, #1: 1	أَجَازَ الْمَغْصُوبُ
u'أَجَازَ مُكَاتَبَةٌ':Predicate, #1: 1	أَجَازَ الْمَفْهُومَ
u'أَجَازَ مُكْرِهٌ':Subject, #1: 1	أَجَازَ الْمُكَاتَبَةَ
u'أَجَازَ مَلِكٌ':Subject, #1: 1	أَجَازَ الْمُكْرِهُ
u'أَجَازَ مَوْقُوفٌ':Predicate, #1: 1	أَجَازَ مَلِكُ
u'أَجَازَ مُوَكِّلٌ':Subject, #1: 1	أَجَازَ الْمَوْقُوفَ
u'أَجَازَ نِصْفٌ':Predicate, #4: 4	أَجَازَ الْمُوَكِّلُ
u'أَجَازَ نَظَرٌ':Predicate, #1: 1	أَجَازَ النِّصْفَ
u'أَجَازَ نَفَذٌ':Predicate, #1: 1	أَجَازَ النَّظَرَ
u'أَجَازَ نكاح':Predicate, #3: 3	أَجَازَ نَفَذَ
u'أَجَازَ نِكَاحٌ':Predicate, #10: 10	أَجَازَ نِكَاحَ
u'أَجَازَ نكاح':Predicate, #10: 10	أَجَازَ نِكَاحَ
u'أَجَازَ نِكَاحٌ':Predicate, #1: 1	أَجَازَ نِكَاحَهُنَّ
u'أَجَازَ نكاح':Predicate, #1: 1	أَجَازَ نِكَاحَهُنَّ
u'أَجَازَ نِكَاحٌ':Predicate, #4: 4	أَجَازَ النِّكَاحَ
u'أَجَازَ هِبَةٌ':Predicate, #4: 4	أَجَازَ النِّكَاحَ
u'أَجَازَ واحد':Subject, #1: 1	أَجَازَ هِبَةَ
u'أَجَازَ وَاحِدٌ':Subject, #2: 2	أَجَازَ وَاحِدٌ
u'أَجَازَ وَادِي':Predicate, #2: 2	أَجَازَ وَاحِدٌ
u'أَجَازَ وَارِثٌ':Predicate, #1: 1	أَجَازَ الْوَادِيَ
u'أَجَازَ وَارِثٌ':Subject, #1: 1	أَجَازَ الْوَارِثَ
u'أَجَازَ وَارِثٌ':Subject, #1: 1	أَجَازَ وَارِثٌ
u'أَجَازَ وَارِثٌ':Subject, #2: 2	أَجَازَ وَارِثُهُ
u'أَجَازَ وَجَبٌ':Predicate, #9: 9	أَجَازَ الْوَارِثُ
u'أَجَازَ وَرَثَةٌ':Subject, #1: 1	أَجَازَ وَجَبَ
u'أَجَازَ وَصِيٌّ':Predicate, #7: 7	أَجَازَ الْوَرَثَةُ
u'أَجَازَ وَصِيٌّ':Predicate, #2: 2	أَجَازَ الْوَصِيَّةَ
u'أَجَازَ وَصِيٌّ':Subject, #7: 7	أَجَازَ وَصِيَّةَ
u'أَجَازَ وَصِيَّةٌ':Predicate, #2: 2	أَجَازَ الْوَصِيُّ
u'أَجَازَ وَصِيَّةٌ':Predicate, #2: 2	أَجَازَ الْوَصِيَّةَ
u'أَجَازَ وَقْفٌ':Predicate, #7: 7	أَجَازَ وَصِيَّةَ
u'أَجَازَ وَكِيلٌ':Subject, #2: 2	أَجَازَ وَقْفَ
u'أَجَازَ وَلِيٌّ':Subject, #1: 1	أَجَازَ الْوَكِيلُ
u'أَجَازَ وَلِيٌّ':Subject, #1: 1	أَجَازَ وَلِيُّهُ
u'أَجَاعَ رَسُولٌ':Predicate, #4: 4	أَجَازَ الْوَلِيُّ
u'أَجْبَرَ إمَامٌ':Subject, #1: 1	أَجَاعَ رَسُولَ
u'أَجْبَرَ حاكِمٌ':Subject, #2: 2	أَجْبَرَ الْإِمَامُ
u'اجْتِنَابٌ أسْبَابٌ':Added, #2: 2	أَجْبَرَ الْحَاكِمُ
u'اجْتِنَابٌ أَسْبَابٌ':Added, #1: 1	اجْتِنَابَ أَسْبَابِ
u'اجْتِنَابٌ إِصْرارٌ':Added, #1: 1	اجْتِنَابَ أَسْبَابِ
u'اجْتِنَابٌ جِدال':Added, #1: 1	اجْتِنَابَ الْإِصْرَارِ
u'اجْتِنَابٌ جُلُوسٌ':Added, #2: 2	اجْتِنَابُ الْجِدَالِ
u'اجْتِنَابٌ حِجَامَةٌ':Added, #1: 1	اجْتِنَابُ الْجُلُوسِ
u'اجْتِنَابٌ حَدٌّ':Added, #1: 1	اجْتِنَابُ الْحِجَامَةِ
u'اجْتِنَابٌ حَرامٌ':Added, #1: 1	اجْتِنَابُ الْحَدِّ
u'اجْتِنَابٌ دَارٌ':Added, #1: 1	اجْتِنَابَ الْحَرَامِ
u'اجْتِنَابٌ دَسَمٌ':Added, #1: 1	اجْتِنَابَ الدَّارِ
u'اجْتِنَابٌ دَسَمٌ':Added, #1: 1	اجْتِنَابَ الدَّسَمِ
u'اجْتِنَابٌ رِجَالٌ':Added, #1: 1	اجْتِنَابِ الدَّسَمِ
u'اجْتِنَابٌ رُخَصٌ':Added, #1: 1	اجْتِنَابُ الرِّجَالِ
u'اجْتِنَابٌ رَيْبٌ':Added, #1: 1	اجْتِنَابِ الرُّخَصِ
u'اجْتِنَابٌ رِيَبٌ':Added, #1: 1	اجْتِنَابُ الرَّيْبِ
u'اجْتِنَابٌ رِيبَةٌ':Added, #1: 1	اجْتِنَابُ الرِّيَبِ
u'اجْتِنَابٌ رِيبَةٌ':Added, #1: 1	اجْتِنَابَ الرِّيبَةِ
u'اجْتِنَابٌ زِينَةٌ':Added, #1: 1	اجْتِنَابُ الرِّيبَةِ
u'اجْتِنَابٌ شَرٌّ':Added, #1: 1	اجْتِنَابُ الزِّينَةِ
u'اجْتِنَابٌ شَرْطٌ':Added, #1: 1	اجْتِنَابُ الشَّرِّ
u'اجْتِنَابٌ شعث':Added, #1: 1	اجْتِنَابُ شَرْطٍ
u'اجْتِنَابٌ طِيبٌ':Added, #1: 1	اجْتِنَابِ الشُّعْثِ
u'اجْتِنَابٌ قَبِيحٌ':Added, #1: 1	اجْتِنَابِ الطِّيبِ
u'اجْتِنَابٌ كبائر':Added, #1: 1	اجْتِنَابُ الْقَبِيحِ
u'اجْتِنَابٌ كبائر':Added, #11: 11	اجْتِنَابُ الْكَبَائِرِ
u'اجْتِنَابٌ كذب':Added, #9: 9	اجْتِنَابِ الْكَبَائِرِ
u'اجْتِنَابٌ كَذِبٌ':Added, #1: 1	اجْتِنَابِ الْكَذِبِ
u'اجْتِنَابٌ لَحْمٌ':Added, #1: 1	اجْتِنَابِ الْكَذِبِ
u'اجْتِنَابٌ مُتَشَابِهٌ':Added, #1: 1	اجْتِنَابُ لَحْمِهِ
u'اجْتِنَابٌ مُحَاذَاةٌ':Added, #1: 1	اجْتِنَابِ الْمُتَشَابِهِ
u'اجْتِنَابٌ مَحَارِمُ':Added, #1: 1	اجْتِنَابِ الْمُحَاذَاةِ
u'اجْتِنَابٌ مُحَرَّمٌ':Added, #1: 1	اجْتِنَابُ الْمَحَارِمِ
u'اجْتِنَابٌ مُحَرَّمٌ':Added, #2: 2	اجْتِنَابُ الْمُحَرَّمَاتِ
u'اجْتِنَابٌ مَحْظُورٌ':Added, #4: 4	اجْتِنَابُ الْمُحَرَّمِ
u'اجْتِنَابٌ مَنْهِيٌّ':Added, #1: 1	اجْتِنَابِ مَحْظُورَاتِ
u'اجْتِنَابٌ مَنْهِيٌّ':Added, #1: 1	اجْتِنَاب الْمَنْهِيِّ
u'اجْتِنَابٌ ميل':Added, #1: 1	اجْتِنَابِ الْمَنْهِيِّ
u'اجْتِنَابٌ مَيْلٌ':Added, #1: 1	اجْتِنَابُ مَيْلِ
u'اجْتِنَابٌ نَجَاسَةٌ':Added, #1: 1	اجْتِنَابُ مَيْلِ
u'اجْتِنَابٌ نَجَاسَةٌ':Added, #17: 17	اجْتِنَابِ النَّجَاسَةِ
u'اجْتِنَابٌ نَجَاسَةٌ':Added, #1: 1	اجْتِنَابِ النَّجَاسَاتِ
u'اجْتِنَابٌ نَجَاسَةٌ':Added, #2: 2	اجْتِنَابُ النَّجَاسَةِ
u'اجْتِنَابٌ نَعِيمٌ':Added, #6: 6	اجْتِنَابَ النَّجَاسَةِ
u'اجْتِنَابٌ نَهْيٌ':Added, #1: 1	اجْتِنَابَ نَعِيمِ
u'اجْتِنَابٌ وَجْهٌ':Added, #1: 1	اجْتِنَابِ النَّهْيِ
u'اجْتِنَابٌ يَمِينٌ':Added, #1: 1	اجْتِنَابِ الْوَجْهِ
u'أَجْحَفَ أخْذٌ':Subject, #1: 1	اجْتِنَابِ الْيَمِينِ
u'أَجْحَفَ بَيْتٌ':Subject, #1: 1	أَجْحَفَ الْأَخْذُ
u'أَجْحَفَ مُصَنِّفٌ':Subject, #1: 1	أَجْحَفَ بَيْتُ
u'إِجْرَاءٌ قِيَاسٌ':Added, #2: 2	أَجْحَفَ الْمُصَنِّفُ
u'إِجْرَاءٌ مَسْأَلَةٌ':Added, #1: 1	إِجْرَاءِ الْقِيَاسِ
u'أَجَّرَ أَبٌ':Subject, #1: 1	إِجْرَاءِ الْمَسْأَلَةِ
u'أَجَّرَ أَجِيرٌ':Subject, #2: 2	أَجَّرَ الْأَبُ
u'أَجَّرَ أحَدٌ':Subject, #1: 1	أَجَّرَ أَجِيرُ
u'آجَرَ أحَدٌ':Subject, #2: 2	أَجَّرَ أَحَدُ
u'أَجَرَ أرْضٌ':Predicate, #3: 3	آجَرَ أَحَدُ
u'أَجَرَ أرْضٌ':Predicate, #1: 1	أَجَرَ أَرْضَ
u'أَجَّرَ أرْضٌ':Predicate, #2: 2	أَجَرَ الْأَرْضَ
u'آجَرَ أرْضٌ':Predicate, #2: 2	أَجَّرَ الْأَرْضَ
u'آجَرَ أرْضٌ':Predicate, #3: 3	آجَرَ أَرْضَ
u'آجَرَ أُمٌّ':Predicate, #7: 7	آجَرَ الْأَرْضَ
u'أَجَّرَ أُمٌّ':Predicate, #1: 1	آجَرَ أُمَّ
u'أَجَّرَ بَائِعٌ':Subject, #1: 1	أَجَّرَ أُمَّ
u'أَجَّرَ بَطْنٌ':Predicate, #1: 1	أَجَّرَ الْبَائِعُ
u'أَجَّرَ بَطْنٌ':Subject, #1: 1	أَجَّرَ الْبَطْنَ
u'آجَرَ بَعْضٌ':Predicate, #3: 3	أَجَّرَ الْبَطْنُ
u'آجَرَ بَغْلٌ':Predicate, #1: 1	آجَرَ بَعْضَ
u'آجَرَ بِنَاءٌ':Predicate, #1: 1	آجَرَ الْبَغْلَ
u'أَجَّرَ بَيَاضٌ':Predicate, #2: 2	آجَرَ الْبِنَاءَ
u'أَجَّرَ حانوتٌ':Predicate, #1: 1	أَجَّرَ بَيَاضَ
u'آجَرَ حانوتٌ':Predicate, #1: 1	أَجَّرَ الْحَانُوتَ
u'آجَرَ حَجَرٌ':Predicate, #2: 2	آجَرَ الْحَانُوتَ
u'أَجَّرَ حُرٌّ':Subject, #1: 1	آجَرَ حَجَرَ
u'أَجَّرَ حِصَّةٌ':Predicate, #1: 1	أَجَّرَ الْحُرُّ
u'آجَرَ حِصَّةٌ':Predicate, #1: 1	أَجَّرَ الْحِصَّةَ
u'أَجَّرَ حِصَّةٌ':Predicate, #1: 1	آجَرَ حِصَّةَ
u'أَجَرَ دَابَّةٌ':Predicate, #1: 1	أَجَّرَ حِصَّةَ
u'آجَرَ دَابَّةٌ':Predicate, #1: 1	أَجَرَ الدَّابَّةَ
u'أَجَّرَ دَارٌ':Predicate, #2: 2	آجَرَ الدَّابَّةَ
u'أَجَّرَ دَارٌ':Predicate, #1: 1	أَجَّرَ دَارَ
u'آجَرَ دَارٌ':Predicate, #3: 3	أَجَّرَ الدَّارَ
u'آجَرَ دَارٌ':Predicate, #5: 5	آجَرَ دَارَ
u'آجَرَ رَاهِنٌ':Subject, #6: 6	آجَرَ الدَّارَ
u'أَجَّرَ رَاهِنٌ':Subject, #1: 1	آجَرَ الرَّاهِنُ
u'أَجَّرَ رَجُلٌ':Subject, #4: 4	أَجَّرَ الرَّاهِنُ
u'آجَرَ رَجُلٌ':Subject, #1: 1	أَجَّرَ الرَّجُلُ
u'آجَرَ رَجُلٌ':Subject, #2: 2	آجَرَ رَجُلٌ
u'أَجَّرَ سَفِيهٌ':Subject, #3: 3	آجَرَ الرَّجُلُ
u'أَجَّرَ سَيِّدٌ':Subject, #1: 1	أَجَّرَ السَّفِيهُ
u'أَجَّرَ شَخْصٌ':Subject, #2: 2	أَجَّرَ السَّيِّدُ
u'آجَرَ صَاحِبٌ':Subject, #1: 1	أَجَّرَ شَخْصٌ
u'أَجَّرَ صَاحِبٌ':Subject, #1: 1	آجَرَ صَاحِبُ
u'آجَرَ صَبِيٌّ':Predicate, #1: 1	أَجَّرَ صَاحِبُ
u'أَجَّرَ صَبِيٌّ':Subject, #1: 1	آجَرَ الصَّبِيَّ
u'آجَرَ صَبِيٌّ':Subject, #2: 2	أَجَّرَ الصَّبِيُّ
u'أَجَرَ صداق':Predicate, #3: 3	آجَرَ الصَّبِيُّ
u'أَجَرَ صَدَاقٌ':Predicate, #1: 1	أَجَرَ الصَّدَاقَ
u'آجَرَ صَغِيرٌ':Predicate, #1: 1	أَجَرَ الصَّدَاقَ
u'أَجَّرَ ضَالٌّ':Predicate, #1: 1	آجَرَ الصَّغِيرَ
u'آجَرَ عَامِلٌ':Subject, #1: 1	أَجَّرَ ضَالَّةَ
u'آجَرَ عَبْدٌ':Predicate, #1: 1	آجَرَ الْعَامِلُ
u'أَجَّرَ عَبْدٌ':Predicate, #1: 1	آجَرَ عَبْدَ
u'أَجَّرَ عَبْدٌ':Subject, #1: 1	أَجَّرَ عَبْدَ
u'آجَرَ عَبْدٌ':Subject, #1: 1	أَجَّرَ الْعَبْدُ
u'أَجَّرَ عَرْصَةٌ':Predicate, #4: 4	آجَرَ الْعَبْدُ
u'آجَرَ عَلِيٌّ':Subject, #1: 1	أَجَّرَ الْعَرْصَةَ
u'أَجَّرَ عين':Predicate, #1: 1	آجَرَ عَلِيٌّ
u'أَجَّرَ عَيْنٌ':Predicate, #3: 3	أَجَّرَ الْعَيْنَ
u'أَجَّرَ عَيْن':Predicate, #3: 3	أَجَّرَ الْعَيْنَ
u'آجَرَ غَاصِبٌ':Subject, #3: 3	أَجَّرَ الْعَيْنَ
u'آجَرَ غَصْبٌ':Predicate, #4: 4	آجَرَ الْغَاصِبُ
u'آجَرَ فُضُولِيٌّ':Subject, #1: 1	آجَرَ الْغَصْبَ
u'أَجَّرَ فُلاَنٌ':Subject, #1: 1	آجَرَ الْفُضُولِيُّ
u'آجَرَ فُلاَنٌ':Subject, #1: 1	أَجَّرَ فُلَانُ
u'آجَرَ قَائِمٌ':Subject, #2: 2	آجَرَ فُلَانٌ
u'آجَرَ قَرْيَةٌ':Predicate, #1: 1	آجَرَ الْقَائِمُ
u'أَجَرَ قَيِّمٌ':Subject, #1: 1	آجَرَ الْقَرْيَةَ
u'آجَرَ قَيِّمٌ':Subject, #1: 1	أَجَرَ الْقَيِّمُ
u'أَجَّرَ قَيِّمٌ':Subject, #4: 4	آجَرَ الْقَيِّمُ
u'آجَرَ مَالٌ':Predicate, #5: 5	أَجَّرَ الْقَيِّمُ
u'آجَرَ مَبِيعٌ':Predicate, #1: 1	آجَرَ مَالَ
u'أَجَّرَ مثل':Predicate, #1: 1	آجَرَ الْمَبِيعَ
u'أَجَّرَ مِثْلٌ':Predicate, #1: 1	أَجَّرَ مِثْلَ
u'أَجَّرَ مَدْيُونٌ':Subject, #1: 1	أَجَّرَ مِثْلَ
u'أَجَّرَ مُرْتَهِنٌ':Subject, #1: 1	أَجَّرَ الْمَدْيُونُ
u'آجَرَ مُرْتَهِنٌ':Subject, #1: 1	أَجَّرَ الْمُرْتَهِنُ
u'أَجَرَ مُسْتَأْجِرٌ':Subject, #2: 2	آجَرَ الْمُرْتَهِنُ
u'آجَرَ مُسْتَأْجِرٌ':Subject, #1: 1	أَجَرَ الْمُسْتَأْجِرُ
u'أَجَّرَ مُسْتَأْجِرٌ':Subject, #2: 2	آجَرَ الْمُسْتَأْجِرُ
u'آجَرَ مُسْتَعِيرٌ':Subject, #3: 3	أَجَّرَ الْمُسْتَأْجِرُ
u'أَجَّرَ مُسْتَعِيرٌ':Subject, #1: 1	آجَرَ الْمُسْتَعِيرُ
u'آجَرَ مُسْتَغِلٌّ':Predicate, #1: 1	أَجَّرَ الْمُسْتَعِيرُ
u'أَجَّرَ مُسْتَغَلٌّ':Predicate, #1: 1	آجَرَ مُسْتَغِلَّ
u'أَجَّرَ مُسْلِمٌ':Subject, #1: 1	أَجَّرَ مُسْتَغَلَّ
u'أَجَّرَ مُسْلِمٌ':Subject, #1: 1	أَجَّرَ الْمُسْلِمُ
u'آجَرَ مُسْلِمٌ':Subject, #1: 1	أَجَّرَ مُسْلِمٌ
u'آجَرَ مُشاعٌ':Predicate, #2: 2	آجَرَ مُسْلِمٌ
u'آجَرَ مَغْصُوب':Predicate, #2: 2	آجَرَ الْمُشَاعَ
u'أَجَرَ مَغْصُوب':Predicate, #1: 1	آجَرَ الْمَغْصُوبَ
u'أَجَّرَ مَغْصُوب':Predicate, #1: 1	أَجَرَ الْمَغْصُوبَ
u'أَجَّرَ مِلْكٌ':Predicate, #1: 1	أَجَّرَ الْمَغْصُوبَ
u'آجَرَ مِلْكٌ':Predicate, #1: 1	أَجَّرَ مِلْكَ
u'آجَرَ مَنْزِلٌ':Predicate, #3: 3	آجَرَ مِلْكَ
u'أَجَّرَ مَوْقُوفٌ':Predicate, #1: 1	آجَرَ مَنْزِلَ
u'أَجَّرَ مَوْقُوفٌ':Subject, #4: 4	أَجَّرَ الْمَوْقُوفَ
u'آجَرَ مَوْقُوفٌ':Subject, #2: 2	أَجَّرَ الْمَوْقُوفُ
u'أَجَّرَ نَاظِرٌ':Subject, #3: 3	آجَرَ الْمَوْقُوفُ
u'آجَرَ نَاظِرٌ':Subject, #13: 13	أَجَّرَ النَّاظِرُ
u'أَجَرَ نَاظِرٌ':Subject, #1: 1	آجَرَ النَّاظِرُ
u'أَجَرَ نَاظِرٌ':Subject, #1: 1	أَجَرَ النَّاظِرُ
u'أَجَّرَ نَاظِرٌ':Subject, #1: 1	أَجَرَ نَاظِرٌ
u'آجَرَ واحد':Subject, #1: 1	أَجَّرَ نَاظِرُهُ
u'آجَرَ وَاحِدٌ':Subject, #1: 1	آجَرَ وَاحِدٌ
u'أَجَّرَ وَاقِفٌ':Subject, #1: 1	آجَرَ وَاحِدٌ
u'آجَرَ وَصِيٌّ':Subject, #1: 1	أَجَّرَ الْوَاقِفُ
u'أَجَرَ وَقْفٌ':Predicate, #2: 2	آجَرَ الْوَصِيُّ
u'أَجَّرَ وَقْفٌ':Predicate, #1: 1	أَجَرَ الْوَقْفَ
u'آجَرَ وَقْفٌ':Predicate, #4: 4	أَجَّرَ الْوَقْفَ
u'آجَرَ وَلِيٌّ':Subject, #6: 6	آجَرَ الْوَقْفَ
u'أَجَّرَ وَلِيٌّ':Subject, #1: 1	آجَرَ وَلِيٌّ
u'أَجَّرَ وَلِيٌّ':Subject, #1: 1	أَجَّرَ وَلِيٌّ
u'أَجْرَى اِبْنٌ':Subject, #6: 6	أَجَّرَ الْوَلِيُّ
u'أَجْرَى آيَةٌ':Predicate, #1: 1	أَجْرَى ابْنُ
u'أَجْرَى تَدْبِيرٌ':Predicate, #1: 1	أَجْرَى الْآيَةَ
u'أَجْرَى حافِرٌ':Subject, #1: 1	أَجْرَى التَّدْبِيرَ
u'أَجْرَى حَدٌّ':Predicate, #1: 1	أَجْرَى حَافِرُ
u'أَجْرَى حَدٌّ':Predicate, #1: 1	أَجْرَى الْحَدَّ
u'أَجْرَى خِلاَفٌ':Predicate, #1: 1	أَجْرَى حَدَّ
u'أَجْرَى خَيْلٌ':Predicate, #4: 4	أَجْرَى الْخِلَافَ
u'أَجْرَى دَابَّةٌ':Predicate, #1: 1	أَجْرَى الْخَيْلَ
u'أَجْرَى صدق':Predicate, #1: 1	أَجْرَى الدَّابَّةَ
u'أَجْرَى صِدْقٌ':Predicate, #1: 1	أَجْرَى الصِّدْقَ
u'أَجْرَى عَادَةٌ':Predicate, #1: 1	أَجْرَى الصِّدْقَ
u'أَجْرَى عَقْدٌ':Predicate, #4: 4	أَجْرَى الْعَادَةَ
u'أَجْرَى قول':Predicate, #1: 1	أَجْرَى الْعَقْدَ
u'أَجْرَى قَوْلٌ':Predicate, #1: 1	أَجْرَى الْقَوْلَ
u'أَجْرَى كَلاَمٌ':Predicate, #1: 1	أَجْرَى الْقَوْلَ
u'أَجْرَى كَلِمَةٌ':Predicate, #1: 1	أَجْرَى كَلَامَ
u'أَجْرَى لَفْظٌ':Predicate, #2: 2	أَجْرَى كَلِمَةَ
u'أَجْرَى مَاءٌ':Predicate, #1: 1	أَجْرَى اللَّفْظَ
u'أَجْرَى مُصَنِّفٌ':Subject, #6: 6	أَجْرَى الْمَاءَ
u'أَجْرَى نَبِيٌّ':Subject, #3: 3	أَجْرَى الْمُصَنِّفُ
u'أَجْرَى نُصُوصٌ':Predicate, #1: 1	أَجْرَى النَّبِيُّ
u'أَجْرَى نَفَقَةٌ':Predicate, #1: 1	أَجْرَى النُّصُوصَ
u'أَجْرَى نَهْيٌ':Predicate, #3: 3	أَجْرَى النَّفَقَةَ
u'أَجْزَلَ مَلِكٌ':Subject, #2: 2	أَجْرَى النَّهْيَ
u'إجْفَالٌ ظَليمٌ':Added, #1: 1	أَجْزَلَ الْمَلِكُ
u'أَجَّلَ المُشْتَرِي':Predicate, #1: 1	إجْفَالِ الظّلِيمِ
u'أَجَلَّ اِمْرَأَةٌ':Predicate, #1: 1	أَجَّلَ الْمُشْتَرِيَ
u'أَجَّلَ بَدَلٌ':Predicate, #1: 1	أَجَلَّ امْرَأَةَ
u'أَجْلَبَ نَاسٌ':Subject, #1: 1	أَجَّلَ بَدَلَ
u'أَجْلَبَ نَاسٌ':Subject, #1: 1	أَجْلَبَ النّاسُ
u'أَجَّلَ ثَمَنٌ':Predicate, #2: 2	أَجْلَبَ النَّاسُ
u'أَجَّلَ ثَمَنٌ':Predicate, #1: 1	أَجَّلَ ثَمَنَ
u'أَجَّلَ ثَمَنٌ':Subject, #9: 9	أَجَّلَ الثَّمَنَ
u'أَجَّلَ دَيْنٌ':Predicate, #2: 2	أَجَّلَ ثَمَنُهُ
u'أَجْلَسَ حَسَنٌ':Predicate, #3: 3	أَجَّلَ الدَّيْنَ
u'أَجْلَسَ رَجُلٌ':Subject, #1: 1	أَجْلَسَ الْحَسَنَ
u'أَجْلَسَ رَسُولٌ':Subject, #1: 1	أَجْلَسَ رَجُلٌ
u'أَجْلَسَ عَبْدٌ':Predicate, #1: 1	أَجْلَسَ رَسُولُ
u'أَجَّلَ شَرْعٌ':Subject, #1: 1	أَجْلَسَ الْعَبْدَ
u'أَجَّلَ طَالِبٌ':Subject, #1: 1	أَجَّلَ الشَّرْعُ
u'أَجَّلَ غير':Subject, #3: 3	أَجَّلَ الطَّالِبُ
u'أَجَّلَ غَيْرٌ':Subject, #1: 1	أَجَّلَ غَيْرُ
u'أَجَّلَ مُحْتَالٌ':Predicate, #1: 1	أَجَّلَ غَيْرُ
u'أَجَّلَ مُشْتَرِي':Predicate, #1: 1	أَجَّلَ الْمُحْتَالَ
u'أَجَّلَ نَفْسٌ':Predicate, #1: 1	أَجَّلَ الْمُشْتَرِيَ
u'أَجْلَى أهْلٌ':Predicate, #3: 3	أَجَّلَ نَفْسَ
u'أَجْلَى بَدَلٌ':Predicate, #2: 2	أَجْلَى أَهْلَ
u'أَجْلَى رَسُولٌ':Subject, #1: 1	أَجْلَى بَدَلَ
u'أَجْلَى عُمَرٌ':Subject, #1: 1	أَجْلَى رَسُولُ
u'أَجْلَى عند':Predicate, #2: 2	أَجْلَى عُمَرُ
u'أَجْلَى يهود':Predicate, #2: 2	أَجْلَى عِنْدَ
u'أَجْلَى يَهُودٌ':Predicate, #8: 8	أَجْلَى الْيَهُودَ
u'إِجْمَاعٌ سَلَفٌ':Added, #8: 8	أَجْلَى الْيَهُودَ
u'إِجْمَاعٌ سَلَفٌ':Added, #1: 1	إِجْمَاعِ سَلَفِ
u'إِجْمَاعٌ صَحَابَةٌ':Added, #2: 2	إِجْمَاعُ السَّلَفِ
u'إِجْمَاعٌ عَامٌّ':Added, #1: 1	إِجْمَاعُ الصَّحَابَةِ
u'إِجْمَاعٌ علماء':Added, #1: 1	إِجْمَاعِ الْعَامَّةِ
u'إِجْمَاعٌ عُلَمَاءُ':Added, #1: 1	إِجْمَاعِ الْعُلَمَاءِ
u'إِجْمَاعٌ مُعْتَبَرٌ':Added, #1: 1	إِجْمَاعِ الْعُلَمَاءِ
u'إِجْمَاعٌ نَاسٌ':Added, #1: 1	إِجْمَاعٍ مُعْتَبَرٍ
u'إِجْمَاعٌ نَاسٌ':Added, #1: 1	إِجْمَاعَ النَّاسِ
u'أَجْمَعَ اِبْنٌ':Subject, #1: 1	إِجْمَاعُ النَّاسِ
u'أَجْمَعَ أَصْحَابٌ':Subject, #1: 1	أَجْمَعَ ابْنُ
u'أَجْمَعَ أَصْحَابٌ':Subject, #2: 2	أَجْمَعَ الْأَصْحَابُ
u'أَجْمَعَ إقامَةٌ':Predicate, #3: 3	أَجْمَعَ أَصْحَابُ
u'أَجْمَعَ إقامَةٌ':Predicate, #1: 1	أَجْمَعَ الإِقَامَةَ
u'أَجْمَعَ أَقْوَامٌ':Subject, #3: 3	أَجْمَعَ إِقَامَةَ
u'أَجْمَعَ أُمَّةٌ':Subject, #1: 1	أَجْمَعَ أَقْوَامٌ
u'أَجْمَعَ أهْلٌ':Subject, #1: 1	أَجْمَعَ الْأُمَّةُ
u'أَجْمَعَ أوائل':Subject, #27: 27	أَجْمَعَ أَهْلُ
u'أَجْمَعَ بَائِعٌ':Subject, #1: 1	أَجْمَعَ الْأَوَائِلُ
u'أَجْمَعَ بَيْنٌ':Predicate, #2: 2	أَجْمَعَ الْبَائِعُ
u'أَجْمَعَ جمع':Subject, #3: 3	أَجْمَعَ بَيْنَ
u'أَجْمَعَ جَمْعٌ':Subject, #1: 1	أَجْمَعَ جَمْعُ
u'أَجْمَعَ خُرُوجٌ':Predicate, #1: 1	أَجْمَعَ جَمْعُ
u'أَجْمَعَ خُلَفَاءُ':Subject, #1: 1	أَجْمَعَ الْخُرُوجَ
u'أَجْمَعَ خَيْرٌ':Predicate, #1: 1	أَجْمَعَ الْخُلَفَاءُ
u'أَجْمَعَ رَأْيٌ':Subject, #1: 1	أَجْمَعَ الْخَيْرَ
u'أَجْمَعَ رَسُولٌ':Subject, #1: 1	أَجْمَعَ رَأْيُ
u'أَجْمَعَ رُوَاةٌ':Subject, #5: 5	أَجْمَعَ رَسُولُ
u'أَجْمَعَ سَلَفٌ':Subject, #1: 1	أَجْمَعَ الرُّوَاةُ
u'أَجْمَعَ سَيْرٌ':Predicate, #1: 1	أَجْمَعَ السَّلَفُ
u'أَجْمَعَ صَحَابَةٌ':Subject, #1: 1	أَجْمَعَ السّيْرَ
u'أَجْمَعَ صِيَامٌ':Predicate, #7: 7	أَجْمَعَ الصَّحَابَةُ
u'أَجْمَعَ عَامٌّ':Subject, #1: 1	أَجْمَعَ الصِّيَامَ
u'أَجْمَعَ علماء':Subject, #1: 1	أَجْمَعَ عَامَّةُ
u'أَجْمَعَ عُلَمَاءُ':Subject, #1: 1	أَجْمَعَ عُلَمَاءُ
u'أَجْمَعَ علماء':Subject, #1: 1	أَجْمَعَ عُلَمَاءُ
u'أَجْمَعَ عُلَمَاءُ':Subject, #27: 27	أَجْمَعَ الْعُلَمَاءُ
u'أَجْمَعَ عمرة':Predicate, #27: 27	أَجْمَعَ الْعُلَمَاءُ
u'أَجْمَعَ عُمْرَةٌ':Predicate, #1: 1	أَجْمَعَ الْعُمْرَةَ
u'أَجْمَعَ عَوَامُّ':Subject, #1: 1	أَجْمَعَ الْعُمْرَةَ
u'أَجْمَعَ فقهاء':Subject, #1: 1	أَجْمَعَ عَوَامُّ
u'أَجْمَعَ فقهاء':Subject, #1: 1	أَجْمَعَ فُقَهَاءُ
u'أَجْمَعَ فلان':Subject, #3: 3	أَجْمَعَ الْفُقَهَاءُ
u'أَجْمَعَ فُلاَنٌ':Subject, #1: 1	أَجْمَعَ النّسّابُ
u'أَجْمَعَ قُعُودٌ':Predicate, #1: 1	أَجْمَعَ فُلَانٌ
u'أَجْمَعَ قَوْمٌ':Subject, #1: 1	أَجْمَعَ الْقُعُودَ
u'أَجْمَعَ مَالِكٌ':Subject, #2: 2	أَجْمَعَ الْقَوْمُ
u'أَجْمَعَ مُسَافِرٌ':Subject, #1: 1	أَجْمَعَ مَالِكٌ
u'أَجْمَعَ مَقَامٌ':Predicate, #1: 1	أَجْمَعَ الْمُسَافِرُ
u'أَجْمَعَ نَاسٌ':Predicate, #1: 1	أَجْمَعَ الْمَقَامَ
u'أَجْمَعَ نَاسٌ':Subject, #1: 1	أَجْمَعَ النَّاسَ
u'أَجْمَعَ نُحَاةٌ':Subject, #6: 6	أَجْمَعَ النَّاسُ
u'أَجْمَعَ نَسّاب':Subject, #1: 1	أَجْمَعَ النُّحَاةُ
u'أَجْمَلَ أَمْرٌ':Predicate, #1: 1	أَجْمَعَ النّسّابُ
u'أَجْمَلَ بَائِعٌ':Subject, #1: 1	أَجْمَلَ الْأَمْرَ
u'أَجْمَلَ تَقْديمٌ':Predicate, #1: 1	أَجْمَلَ الْبَائِعُ
u'أَجْمَلَ حساب':Predicate, #1: 1	أَجْمَلَ تَقْدِيمَ
u'أَجْمَلَ حِسَابٌ':Predicate, #2: 2	أَجْمَلَ الْحِسَابَ
u'أَجْمَلَ حُكْمٌ':Predicate, #2: 2	أَجْمَلَ الْحِسَابَ
u'أَجْمَلَ شَيْءٌ':Predicate, #1: 1	أَجْمَلَ الْحُكْمَ
u'أَجْمَلَ قِيمَةٌ':Predicate, #1: 1	أَجْمَلَ الشَّيْءَ
u'أَجْمَلَ مُخَالِفٌ':Subject, #1: 1	أَجْمَلَ الْقِيمَةَ
u'أَجْمَلَ مُصَنِّفٌ':Subject, #1: 1	أَجْمَلَ مُخَالِفُ
u'أَجْنَبَ أَبٌ':Subject, #3: 3	أَجْمَلَ الْمُصَنِّفُ
u'أَجْنَبَ رَجُلٌ':Subject, #1: 1	أَجْنَبَ الْأَبُ
u'أَجْنَبَ صَحِيحٌ':Subject, #4: 4	أَجْنَبَ الرَّجُلُ
u'أَجْنَبَ قَالٌ':Predicate, #1: 1	أَجْنَبَ الصَّحِيحُ
u'أَجْنَبَ مُسَافِرٌ':Subject, #1: 1	أَجْنَبَ قَالَ
u'أَجْنَبَ مُفَسِّرٌ':Subject, #1: 1	أَجْنَبَ الْمُسَافِرُ
u'أَجْوَافٌ حَبٌّ':Added, #1: 1	أَجْنَبَ مُفَسِّرٌ
u'أَجْوَافٌ حَبَّةٌ':Added, #1: 1	أَجْوَافُ حَبَّاتِ
u'أَجْوَافٌ طَيْرٌ':Added, #1: 1	أَجْوَافُ حَبَّاتِ
u'أَجْوَافٌ طُيُورٌ':Added, #6: 6	أَجْوَافِ طَيْرٍ
u'أَجْوَافٌ مِيَاهٌ':Added, #3: 3	أَجْوَافِ طُيُورٍ
u'أَجْوَدَ حَسَنٌ':Subject, #1: 1	أَجْوَافَ الْمِيَاهِ
u'أَجْوَدَ دَرَاهِمُ':Predicate, #1: 1	أَجْوَدَ حَسَنٌ
u'أَحَاطَ إِحْيَاءٌ':Subject, #4: 4	أَجْوَدَ دَرَاهِمَ
u'إحَاطَةٌ دَمٌ':Added, #3: 3	أَحَاطَ الْإِحْيَاءُ
u'إحَاطَةٌ دَمٌ':Added, #1: 1	إحَاطَةَ الدَّمِ
u'إحَاطَةٌ دَمٌ':Added, #1: 1	إحَاطَةُ الدَّمِ
u'إحَاطَةٌ دَيْنٌ':Added, #1: 1	إحَاطَةُ الدَّمَيْنِ
u'إحَاطَةٌ دَيْنٌ':Added, #3: 3	إحَاطَةُ الدَّيْنِ
u'إحَاطَةٌ دَيْنٌ':Added, #3: 3	إحَاطَةِ دَيْنٍ
u'إحَاطَةٌ دُيونٌ':Added, #4: 4	إحَاطَةِ الدَّيْنِ
u'إحَاطَةٌ دُيونٌ':Added, #1: 1	إحَاطَةُ الدُّيُونِ
u'إحَاطَةٌ علم':Added, #1: 1	إحَاطَةِ الدُّيُونِ
u'إحَاطَةٌ عِلْمٌ':Added, #1: 1	إحَاطَةَ عِلْمِ
u'إحَاطَةٌ علم':Added, #1: 1	إحَاطَةَ عِلْمِ
u'إحَاطَةٌ عِلْمٌ':Added, #3: 3	إحَاطَةِ عِلْمِهِ
u'إحَاطَةٌ علم':Added, #3: 3	إحَاطَةِ عِلْمِهِ
u'إحَاطَةٌ عِلْمٌ':Added, #4: 4	إحَاطَةِ الْعِلْمِ
u'إحَاطَةٌ عِيَانٌ':Added, #4: 4	إحَاطَةِ الْعِلْمِ
u'إحَاطَةٌ مُجْتَهِد':Added, #1: 1	إحَاطَةِ الْعِيَانِ
u'إحَاطَةٌ مَنْقُوص':Added, #1: 1	إحَاطَةُ الْمُجْتَهِدِ
u'أَحَاطَ جَيْشٌ':Subject, #1: 1	إحَاطَةَ مَنْقُوصٍ
u'أَحَاطَ حَرْقٌ':Subject, #2: 2	أَحَاطَ الْجَيْشُ
u'أَحَاطَ دَمٌ':Subject, #1: 1	أَحَاطَ الْحَرْقُ
u'أَحَاطَ دَيْنٌ':Predicate, #2: 2	أَحَاطَ الدَّمُ
u'أَحَاطَ دَيْنٌ':Subject, #1: 1	أَحَاطَ الدَّيْنَ
u'أَحَاطَ دَيْنٌ':Subject, #16: 16	أَحَاطَ الدَّيْنُ
u'أَحَاطَ ضَمِنٌ':Predicate, #2: 2	أَحَاطَ دَيْنُهُ
u'أَحَاطَ عَدُوٌّ':Subject, #1: 1	أَحَاطَ ضَمِنَ
u'أَحَاطَ علم':Subject, #5: 5	أَحَاطَ الْعَدُوُّ
u'أَحَاطَ عِلْمٌ':Subject, #2: 2	أَحَاطَ عِلْمُ
u'أَحَاطَ علم':Subject, #2: 2	أَحَاطَ عِلْمُ
u'أَحَاطَ عِلْمٌ':Subject, #3: 3	أَحَاطَ عِلْمُهُ
u'أَحَاطَ كُفَّارٌ':Subject, #3: 3	أَحَاطَ عِلْمُهُ
u'أَحَالَ اِبْنٌ':Subject, #2: 2	أَحَاطَ الْكُفَّارُ
u'أَحَالَ أحَدٌ':Predicate, #1: 1	أَحَالَ ابْنُ
u'أَحَالَ أحَدٌ':Subject, #1: 1	أَحَالَ أَحَدَ
u'أَحَالَ أَصيلٌ':Subject, #1: 1	أَحَالَ أَحَدُ
u'أَحَالَ بَائِعٌ':Predicate, #1: 1	أَحَالَ الْأَصِيلُ
u'أَحَالَ بَائِعٌ':Subject, #2: 2	أَحَالَ الْبَائِعَ
u'أَحَالَ بَائِعٌ':Subject, #11: 11	أَحَالَ الْبَائِعُ
u'أَحَالَ حُقوقٌ':Predicate, #1: 1	أَحَالَ بَائِعٌ
u'أَحَالَ حُقُوقٌ':Predicate, #1: 1	أَحَالَ حُقُوقَ
u'أَحَالَ دَائِنٌ':Predicate, #1: 1	أَحَالَ حُقُوقَ
u'أَحَالَ دَائِنٌ':Subject, #2: 2	أَحَالَ الدَّائِنَ
u'أَحَالَ دَرَاهِمُ':Predicate, #1: 1	أَحَالَ دَائِنُهُ
u'أَحَالَ رَاهِنٌ':Subject, #1: 1	أَحَالَ الدَّرَاهِمَ
u'أَحَالَ رَبُّ':Subject, #6: 6	أَحَالَ الرَّاهِنُ
u'أَحَالَ رَجُلٌ':Subject, #4: 4	أَحَالَ رَبُّ
u'أَحَالَ زَوْجٌ':Subject, #2: 2	أَحَالَ الرَّجُلُ
u'أَحَالَ سَاكِتٌ':Predicate, #3: 3	أَحَالَ الزَّوْجُ
u'أَحَالَ سَمَاعٌ':Predicate, #2: 2	أَحَالَ السَّاكِتَ
u'أَحَالَ سَيِّدٌ':Subject, #1: 1	أَحَالَ سَمَاعَ
u'أَحَالَ شَرِيكٌ':Subject, #1: 1	أَحَالَ سَيِّدُهُ
u'أَحَالَ صَاحِبٌ':Subject, #1: 1	أَحَالَ الشَّرِيكُ
u'أَحَالَ طَالِبٌ':Predicate, #2: 2	أَحَالَ صَاحِبُ
u'أَحَالَ طَالِبٌ':Subject, #4: 4	أَحَالَ الطَّالِبَ
u'أَحَالَ عَدَمٌ':Predicate, #4: 4	أَحَالَ الطَّالِبُ
u'أَحَالَ غَرِيمٌ':Subject, #1: 1	أَحَالَ عَدَمَ
u'أَحَالَ فَقِيرٌ':Predicate, #2: 2	أَحَالَ الْغَرِيمُ
u'أَحَالَ كَفِيلٌ':Subject, #1: 1	أَحَالَ الْفَقِيرَ
u'أَحَالَ مُحْتَالٌ':Predicate, #3: 3	أَحَالَ الْكَفِيلُ
u'أَحَالَ مُحِيل':Subject, #1: 1	أَحَالَ الْمُحْتَالَ
u'أَحَالَ مُدْرِكٌ':Subject, #1: 1	أَحَالَ الْمُحِيلُ
u'أَحَالَ مَدْيُونٌ':Predicate, #1: 1	أَحَالَ الْمُدْرِكُ
u'أَحَالَ مَدْيُونٌ':Subject, #1: 1	أَحَالَ الْمَدْيُونَ
u'أَحَالَ مُرْتَهِنٌ':Predicate, #2: 2	أَحَالَ الْمَدْيُونُ
u'أَحَالَ مُرْتَهِنٌ':Subject, #2: 2	أَحَالَ الْمُرْتَهِنَ
u'أَحَالَ مَرِيضٌ':Predicate, #4: 4	أَحَالَ الْمُرْتَهِنُ
u'أَحَالَ مَسْأَلَةٌ':Predicate, #1: 1	أَحَالَ الْمَرِيضَ
u'أَحَالَ مُسْلِمٌ':Subject, #1: 1	أَحَالَ الْمَسْأَلَةَ
u'أَحَالَ مُصَنِّفٌ':Subject, #1: 1	أَحَالَ الْمُسْلِمُ
u'أَحَالَ مُطْلَقٌ':Predicate, #2: 2	أَحَالَ الْمُصَنِّفُ
u'أَحَالَ مَطْلُوبٌ':Subject, #1: 1	أَحَالَ مُطْلَقَةً
u'أَحَالَ مَكْفُولٌ':Predicate, #3: 3	أَحَالَ الْمَطْلُوبُ
u'أَحَالَ مُوَكِّلٌ':Subject, #2: 2	أَحَالَ الْمَكْفُولَ
u'أَحَالَ مُؤَلِّفٌ':Subject, #1: 1	أَحَالَ الْمُوَكِّلُ
u'أَحَالَ مُؤَنٌ':Predicate, #1: 1	أَحَالَ الْمُؤَلِّفُ
u'أَحَالَ نَاظِرٌ':Subject, #1: 1	أَحَالَ الْمُؤَنَ
u'أَحَالَ وَكِيلٌ':Subject, #1: 1	أَحَالَ النَّاظِرُ
u'أَحَبَّ أخْذٌ':Predicate, #1: 1	أَحَالَ الْوَكِيلُ
u'أَحَبَّ اِمْرُؤٌ':Subject, #1: 1	أَحَبَّ أَخْذَ
u'أَحَبَّ إِنْسانٌ':Subject, #1: 1	أَحَبَّ امْرُؤٌ
u'أَحَبَّ أنصار':Predicate, #1: 1	أَحَبَّ الْإِنْسَانُ
u'أَحَبَّ أَنْصارٌ':Predicate, #6: 6	أَحَبَّ الأَنْصَارَ
u'أَحَبَّ أَنْصَارٌ':Predicate, #6: 6	أَحَبَّ الأَنْصَارَ
u'أَحَبَّ أَوْلِيَاءُ':Subject, #6: 6	أَحَبَّ الأَنْصَارَ
u'أَحَبَّ بَائِعٌ':Subject, #1: 1	أَحَبَّ الْأَوْلِيَاءُ
u'أَحَبَّ بَعْضٌ':Subject, #2: 2	أَحَبَّ الْبَائِعُ
u'أَحَبَّ بَقاءٌ':Predicate, #1: 1	أَحَبَّ بَعْضُ
u'أَحَبَّ بَيْنٌ':Predicate, #1: 1	أَحَبَّ الْبَقَاءَ
u'أَحَبَّ جَازٌ':Predicate, #1: 1	أَحَبَّ بَيْنَ
u'أَحَبَّ جَائِزٌ':Subject, #2: 2	أَحَبَّ جَازَ
u'أَحَبَّ حالٌ':Predicate, #1: 1	أَحَبَّ جَائِزٌ
u'أَحَبَّ حَديثٌ':Predicate, #1: 1	أَحَبَّ حَالَ
u'أَحَبَّ دنيا':Subject, #1: 1	أَحَبَّ الْحَدِيثَ
u'أَحَبَّ دُنْيا':Subject, #2: 2	أَحَبَّ دُنْيَاهُ
u'أَحَبَّ رَجُلٌ':Subject, #2: 2	أَحَبَّ دُنْيَاهُ
u'أَحَبَّ زَوْجٌ':Subject, #2: 2	أَحَبَّ الرَّجُلُ
u'أَحَبَّ سَتْرٌ':Predicate, #2: 2	أَحَبَّ الزَّوْجُ
u'أَحَبَّ شكر':Predicate, #1: 1	أَحَبَّ السَّتْرَ
u'أَحَبَّ شُكْرٌ':Predicate, #1: 1	أَحَبَّ الشُّكْرَ
u'أَحَبَّ شهرة':Predicate, #1: 1	أَحَبَّ الشُّكْرَ
u'أَحَبَّ شُهْرَةٌ':Predicate, #1: 1	أَحَبَّ الشُّهْرَةَ
u'أَحَبَّ طَهَارَةٌ':Predicate, #1: 1	أَحَبَّ الشُّهْرَةَ
u'أَحَبَّ عَبْدٌ':Subject, #1: 1	أَحَبَّ الطَّهَارَةَ
u'أَحَبَّ عُطاس':Predicate, #2: 2	أَحَبَّ عَبْدٌ
u'أَحَبَّ علم':Predicate, #1: 1	أَحَبَّ الْعُطَاسَ
u'أَحَبَّ عِلْمٌ':Predicate, #1: 1	أَحَبَّ الْعِلْمَ
u'أَحَبَّ علماء':Subject, #1: 1	أَحَبَّ الْعِلْمَ
u'أَحَبَّ عُلَمَاءُ':Subject, #1: 1	أَحَبَّ الْعُلَمَاءُ
u'أَحَبَّ عُمَرٌ':Predicate, #1: 1	أَحَبَّ الْعُلَمَاءُ
u'أَحَبَّ فَاسِقٌ':Predicate, #2: 2	أَحَبَّ عُمَرَ
u'أَحَبَّ فَسْخٌ':Predicate, #1: 1	أَحَبَّ الْفَاسِقِينَ
u'أَحَبَّ فلان':Predicate, #1: 1	أَحَبَّ الْفَسْخَ
u'أَحَبَّ قَالٌ':Predicate, #2: 2	أَحَبَّ عُثْمَانَ
u'أَحْبَلَ أمَةٌ':Predicate, #4: 4	أَحَبَّ قَالَ
u'أَحْبَلَ ثَانِي':Predicate, #2: 2	أَحْبَلَ الْأَمَةَ
u'أَحْبَلَ ثَانِيَةٌ':Predicate, #1: 1	أَحْبَلَ الثَّانِيَةَ
u'أَحْبَلَ جَارِي':Predicate, #1: 1	أَحْبَلَ الثَّانِيَةَ
u'أَحْبَلَ جَارِي':Predicate, #1: 1	أَحْبَلَ الْجَارِيَةَ
u'أَحْبَلَ جَارِيَةٌ':Predicate, #1: 1	أَحْبَلَ جَارِيَةَ
u'أَحْبَلَ جَارِيَةٌ':Predicate, #1: 1	أَحْبَلَ الْجَارِيَةَ
u'أَحْبَلَ رَاهِنٌ':Subject, #1: 1	أَحْبَلَ جَارِيَةَ
u'أَحَبَّ لِقَاءٌ':Predicate, #1: 1	أَحْبَلَ الرَّاهِنُ
u'أَحَبَّ مُبْرِئٌ':Subject, #9: 9	أَحَبَّ لِقَاءَ
u'أَحَبَّ مُتَابَعٌ':Predicate, #1: 1	أَحَبَّ الْمُبْرِئُ
u'أَحَبَّ مُتَابَعَةٌ':Predicate, #1: 1	أَحَبَّ مُتَابَعَةَ
u'أَحَبَّ مَغْصُوب':Subject, #1: 1	أَحَبَّ مُتَابَعَةَ
u'أَحَبَّ مَقَامٌ':Predicate, #1: 1	أَحَبَّ الْمَغْصُوبُ
u'أَحَبَّ مكارم':Predicate, #1: 1	أَحَبَّ مَقَامَ
u'أَحَبَّ مَكَارِمُ':Predicate, #1: 1	أَحَبَّ الْمَكَارِمَ
u'أَحَبَّ مَوْتٌ':Predicate, #1: 1	أَحَبَّ الْمَكَارِمَ
u'أَحَبَّ مُؤَذِّنٌ':Subject, #1: 1	أَحَبَّ الْمَوْتَ
u'أَحَبَّ نَاسٌ':Subject, #1: 1	أَحَبَّ الْمُؤَذِّنُ
u'أَحَبَّ وَارِثٌ':Subject, #1: 1	أَحَبَّ النَّاسُ
u'إِحْدَاثٌ أَعْمَالٌ':Added, #1: 1	أَحَبَّ الْوَارِثُ
u'إِحْدَاثٌ أَقْضِيَةٌ':Added, #1: 1	إِحْدَاثِ الْأَعْمَالِ
u'إِحْدَاثٌ أَمْرٌ':Added, #1: 1	إِحْدَاثَ الْأَقْضِيَةِ
u'إِحْدَاثٌ بِدَعٌ':Added, #1: 1	إِحْدَاثِ أَمْرٍ
u'إِحْدَاثٌ بِدَعٌ':Added, #1: 1	إِحْدَاثُ الْبِدَعِ
u'إِحْدَاثٌ بِدْعَةٌ':Added, #1: 1	إِحْدَاثِ الْبِدَعِ
u'إِحْدَاثٌ تَقْديمٌ':Added, #1: 1	إِحْدَاثِ بِدْعَةٍ
u'إِحْدَاثٌ دُعَاءٌ':Added, #1: 1	إِحْدَاثِ تَقْدِيمِ
u'إِحْدَاثٌ طَلاَقٌ':Added, #1: 1	إِحْدَاثُ الدُّعَاءِ
u'إِحْدَاثٌ عِبَادَةٌ':Added, #2: 2	إِحْدَاثَ طَلاَقٍ
u'أَحْدَثَ أَثْناءُ':Predicate, #1: 1	إِحْدَاثَ الْعِبَادَاتِ
u'أَحْدَثَ أحَدٌ':Subject, #1: 1	أَحْدَثَ أَثْنَاءَ
u'أَحْدَثَ أَذَانٌ':Predicate, #3: 3	أَحْدَثَ أَحَدٌ
u'أَحْدَثَ أَسْفَلُ':Subject, #3: 3	أَحْدَثَ الْأَذَانَ
u'أَحْدَثَ إِسْلامٌ':Predicate, #1: 1	أَحْدَثَ الْأَسْفَلُ
u'أَحْدَثَ إمَامٌ':Subject, #1: 1	أَحْدَثَ الْإِسْلَامَ
u'أَحْدَثَ إمَامٌ':Subject, #1: 1	أَحْدَثَ إمَامُهُ
u'أَحْدَثَ آمِرٌ':Subject, #40: 40	أَحْدَثَ الْإِمَامُ
u'أَحْدَثَ أَميرٌ':Subject, #1: 1	أَحْدَثَ الْآمِرُ
u'أَحْدَثَ بَائِعٌ':Subject, #3: 3	أَحْدَثَ أَمِيرُ
u'أَحْدَثَ بِرْسام':Predicate, #2: 2	أَحْدَثَ الْبَائِعُ
u'أَحْدَثَ بَطَلٌ':Predicate, #1: 1	أَحْدَثَ الْبِرْسَامَ
u'أَحْدَثَ بَعْضٌ':Subject, #1: 1	أَحْدَثَ بَطَلَ
u'أَحْدَثَ بَيْنٌ':Predicate, #1: 1	أَحْدَثَ بَعْضُ
u'أَحْدَثَ تُجَّارٌ':Subject, #1: 1	أَحْدَثَ بَيْنَ
u'أَحْدَثَ جَازٌ':Predicate, #1: 1	أَحْدَثَ التُّجَّارُ
u'أَحْدَثَ حَدَثٌ':Predicate, #4: 4	أَحْدَثَ جَازَ
u'أَحْدَثَ حَفْرٌ':Predicate, #1: 1	أَحْدَثَ الْحَدَثَ
u'أَحْدَثَ خبطة':Predicate, #1: 1	أَحْدَثَ الْحَفْرَ
u'أَحْدَثَ خَشَبٌ':Predicate, #1: 1	أَحْدَثَ الْخَبْطَةَ
u'أَحْدَثَ خَطِيبٌ':Subject, #1: 1	أَحْدَثَ الْخَشَبَ
u'أَحْدَثَ خَلْفٌ':Predicate, #2: 2	أَحْدَثَ الْخَطِيبُ
u'أَحْدَثَ خَلِيفَةٌ':Subject, #1: 1	أَحْدَثَ خَلْفَ
u'أَحْدَثَ دَائِمٌ':Subject, #1: 1	أَحْدَثَ الْخَلِيفَةُ
u'أَحْدَثَ رابع':Subject, #2: 2	أَحْدَثَ دَائِمُ
u'أَحْدَثَ رَابِعٌ':Subject, #2: 2	أَحْدَثَ الرَّابِعُ
u'أَحْدَثَ رَجُلٌ':Subject, #2: 2	أَحْدَثَ الرَّابِعُ
u'أَحْدَثَ رَجُلٌ':Subject, #2: 2	أَحْدَثَ الرَّجُلُ
u'أَحْدَثَ رِدَّةٌ':Predicate, #2: 2	أَحْدَثَ رَجُلٌ
u'أَحْدَثَ زُكامٌ':Predicate, #1: 1	أَحْدَثَ الرِّدَّةَ
u'أَحْدَثَ سَبَبٌ':Predicate, #1: 1	أَحْدَثَ الزُّكَامَ
u'أَحْدَثَ سِجْنٌ':Predicate, #1: 1	أَحْدَثَ سَبَبَ
u'أَحْدَثَ سَيَلانٌ':Predicate, #1: 1	أَحْدَثَ السِّجْنَ
u'أَحْدَثَ صَبِيٌّ':Subject, #1: 1	أَحْدَثَ السَّيَلَانَ
u'أَحْدَثَ صَرْعٌ':Predicate, #2: 2	أَحْدَثَ الصَّبِيُّ
u'أَحْدَثَ عُطاس':Predicate, #1: 1	أَحْدَثَ الصَّرْعَ
u'أَحْدَثَ غَرْسٌ':Predicate, #1: 1	أَحْدَثَ الْعُطَاسَ
u'أَحْدَثَ قضاة':Predicate, #2: 2	أَحْدَثَ الْغَرْسَ
u'أَحْدَثَ قُعُودٌ':Predicate, #1: 1	أَحْدَثَ الْقُضَاةَ
u'أَحْدَثَ قَوْمٌ':Subject, #1: 1	أَحْدَثَ الْقُعُودَ
u'أَحْدَثَ لبس':Predicate, #3: 3	أَحْدَثَ قَوْمٌ
u'أَحْدَثَ لُبْسٌ':Predicate, #1: 1	أَحْدَثَ اللُّبْسَ
u'أَحْدَثَ لَيْلٌ':Predicate, #1: 1	أَحْدَثَ اللُّبْسَ
u'أَحْدَثَ مَالِكٌ':Subject, #1: 1	أَحْدَثَ لَيْلَةَ
u'أَحْدَثَ مُسَافِرٌ':Subject, #1: 1	أَحْدَثَ الْمَالِكُ
u'أَحْدَثَ مَغْصُوب':Subject, #1: 1	أَحْدَثَ الْمُسَافِرُ
u'أَحْدَثَ مَكْسٌ':Predicate, #1: 1	أَحْدَثَ الْمَغْصُوبُ
u'أَحْدَثَ مُلُوكٌ':Subject, #2: 2	أَحْدَثَ الْمَكْسَ
u'أَحْدَثَ نَاسٌ':Subject, #1: 1	أَحْدَثَ الْمُلُوكُ
u'أَحْدَثَ نَبِيٌّ':Subject, #13: 13	أَحْدَثَ النَّاسُ
u'أَحْدَثَ نزلة':Predicate, #1: 1	أَحْدَثَ النَّبِيُّ
u'أَحْدَثَ نَزْلَةٌ':Predicate, #1: 1	أَحْدَثَ النَّزْلَةَ
u'أَحْدَثَ نِساءٌ':Subject, #1: 1	أَحْدَثَ النَّزْلَةَ
u'أَحْدَثَ نِسْيَانٌ':Predicate, #5: 5	أَحْدَثَ النِّسَاءُ
u'أَحْدَثَ نَوْمٌ':Predicate, #1: 1	أَحْدَثَ النِّسْيَانَ
u'أَحْدَثَ نِيَّةٌ':Predicate, #1: 1	أَحْدَثَ النَّوْمَ
u'أَحْدَثَ واحد':Subject, #1: 1	أَحْدَثَ النِّيَّةَ
u'أَحْدَثَ وَاحِدٌ':Subject, #1: 1	أَحْدَثَ وَاحِدٌ
u'أَحْدَثَ وَجَبٌ':Predicate, #1: 1	أَحْدَثَ وَاحِدٌ
u'أَحْدَثَ وَسْوَاسٌ':Predicate, #1: 1	أَحْدَثَ وَجَبَ
u'أَحْدَثَ وَقْتٌ':Predicate, #1: 1	أَحْدَثَ الْوَسْوَاسَ
u'أَحْدَثَ يَدٌ':Predicate, #2: 2	أَحْدَثَ وَقْتَ
u'أَحْدَثَ يَوْمٌ':Predicate, #1: 1	أَحْدَثَ الْيَدَ
u'إِحْرَامٌ الْمَرْأَةُ':Added, #1: 1	أَحْدَثَ يَوْمَ
u'إِحْرَامٌ فُلاَنٌ':Added, #1: 1	إِحْرَامُ الْمَرْأَةِ
u'أَحْرَزَ ضَمِنٌ':Predicate, #1: 1	إِحْرَامُ فُلاَنٍ
u'أَحْرَزَ عَدُوٌّ':Subject, #1: 1	أَحْرَزَ ضَمِنَ
u'أَحْرَزَ مَاءٌ':Predicate, #5: 5	أَحْرَزَ الْعَدُوُّ
u'أَحْرَزَ مَالٌ':Predicate, #1: 1	أَحْرَزَ الْمَاءَ
u'أَحْرَزَ مَمْلُوكٌ':Subject, #2: 2	أَحْرَزَ الْمَالَ
u'أَحْرَزَ مِيرَاثٌ':Predicate, #1: 1	أَحْرَزَ الْمَمْلُوكُ
u'أَحْرَزَ وَلاَءٌ':Predicate, #7: 7	أَحْرَزَ الْمِيرَاثَ
u'أَحْرَزَ ولد':Subject, #3: 3	أَحْرَزَ الْوَلاَءَ
u'أَحْرَزَ وَلَدٌ':Subject, #1: 1	أَحْرَزَ الْوَلَدُ
u'أَحْرُفٌ عتق':Added, #1: 1	أَحْرَزَ الْوَلَدُ
u'أَحْرُفٌ عِتْقٌ':Added, #2: 2	أَحْرُفِ الْعِتْقِ
u'أَحْرُفٌ كَلاَمٌ':Added, #2: 2	أَحْرُفِ الْعِتْقِ
u'أَحْرَقَ بَعْضٌ':Predicate, #2: 2	أَحْرُفِ كَلَامِهِ
u'أَحْرَقَ بِنَاءٌ':Predicate, #1: 1	أَحْرَقَ بَعْضَ
u'أَحْرَقَ بَيْتٌ':Predicate, #1: 1	أَحْرَقَ الْبِنَاءَ
u'أَحْرَقَ ثَوْبٌ':Predicate, #2: 2	أَحْرَقَ بَيْتَ
u'أَحْرَقَ حَصَائِدُ':Predicate, #2: 2	أَحْرَقَ الثَّوْبَ
u'أَحْرَقَ حَصَائِدُ':Predicate, #1: 1	أَحْرَقَ حَصَائِدَ
u'أَحْرَقَ طِيبٌ':Predicate, #2: 2	أَحْرَقَ الْحَصَائِدَ
u'أَحْرَقَ عَدُوٌّ':Subject, #1: 1	أَحْرَقَ الطِّيبَ
u'أَحْرَقَ فلان':Predicate, #1: 1	أَحْرَقَ الْعَدُوُّ
u'أَحْرَقَ قلب':Predicate, #3: 3	أَحْرَقَ الْبُوَيْرَةَ
u'أَحْرَقَ قَلْبٌ':Predicate, #1: 1	أَحْرَقَ الْقَلْبَ
u'أَحْرَقَ قَلْب':Predicate, #1: 1	أَحْرَقَ الْقَلْبَ
u'أَحْرَقَ كُدْسٌ':Predicate, #1: 1	أَحْرَقَ الْقَلْبَ
u'أَحْرَقَ مَوْضِعٌ':Predicate, #1: 1	أَحْرَقَ كُدْسَ
u'أَحْرَقَ نَاسٌ':Subject, #1: 1	أَحْرَقَ مَوْضِعَ
u'أَحْرَمَ اِبْنٌ':Subject, #1: 1	أَحْرَقَ النَّاسُ
u'أَحْرَمَ أحَدٌ':Subject, #3: 3	أَحْرَمَ ابْنُ
u'أَحْرَمَ إمَامٌ':Subject, #2: 2	أَحْرَمَ أَحَدُ
u'أَحْرَمَ إمَامٌ':Subject, #1: 1	أَحْرَمَ إمَامُ
u'أَحْرَمَ أَوَّلُ':Subject, #8: 8	أَحْرَمَ الْإِمَامُ
u'أَحْرَمَ بَائِعٌ':Subject, #1: 1	أَحْرَمَ الْأَوَّلُ
u'أَحْرَمَ بَعْضٌ':Subject, #1: 1	أَحْرَمَ بَائِعُ
u'أَحْرَمَ حالٌ':Predicate, #1: 1	أَحْرَمَ بَعْضُ
u'أَحْرَمَ حَديثٌ':Predicate, #3: 3	أَحْرَمَ حَالَ
u'أَحْرَمَ خَلْفٌ':Predicate, #1: 1	أَحْرَمَ الْحَدِيثَ
u'أَحْرَمَ دَاخِلٌ':Predicate, #4: 4	أَحْرَمَ خَلْفَ
u'أَحْرَمَ دُبُرٌ':Predicate, #2: 2	أَحْرَمَ دَاخِلَ
u'أَحْرَمَ دونٌ':Predicate, #1: 1	أَحْرَمَ دُبُرَ
u'أَحْرَمَ ذِمِّيٌّ':Subject, #1: 1	أَحْرَمَ دُونَ
u'أَحْرَمَ رَجُلٌ':Subject, #1: 1	أَحْرَمَ ذِمِّيٌّ
u'أَحْرَمَ رَجُلٌ':Subject, #1: 1	أَحْرَمَ رَجُلٌ
u'أَحْرَمَ رَسُولٌ':Subject, #6: 6	أَحْرَمَ الرَّجُلُ
u'أَحْرَمَ زَيْدٌ':Subject, #5: 5	أَحْرَمَ رَسُولُ
u'أَحْرَمَ سَفِيهٌ':Subject, #5: 5	أَحْرَمَ زَيْدٌ
u'أَحْرَمَ سُلْطَانٌ':Subject, #1: 1	أَحْرَمَ السَّفِيهُ
u'أَحْرَمَ شَخْصٌ':Subject, #1: 1	أَحْرَمَ السُّلْطَانُ
u'أَحْرَمَ صَبِيٌّ':Subject, #3: 3	أَحْرَمَ شَخْصٌ
u'أَحْرَمَ طَافٌ':Predicate, #1: 1	أَحْرَمَ صَبِيٌّ
u'أَحْرَمَ عَامٌ':Predicate, #1: 1	أَحْرَمَ طَافَ
u'أَحْرَمَ عَبْدٌ':Subject, #1: 1	أَحْرَمَ عَامَ
u'أَحْرَمَ عَبْدٌ':Subject, #2: 2	أَحْرَمَ عَبْدُهُ
u'أَحْرَمَ عَقِبٌ':Predicate, #6: 6	أَحْرَمَ الْعَبْدُ
u'أَحْرَمَ عند':Predicate, #1: 1	أَحْرَمَ عَقِبَ
u'أَحْرَمَ غَاصِبٌ':Subject, #2: 2	أَحْرَمَ عِنْدَ
u'أَحْرَمَ فلان':Subject, #2: 2	أَحْرَمَ الْغَاصِبُ
u'أَحْرَمَ فلان':Subject, #1: 1	أَحْرَمَ مَكِّيٌّ
u'أَحْرَمَ قَادِرٌ':Subject, #7: 7	أَحْرَمَ الْمَكِّيُّ
u'أَحْرَمَ لَيْلٌ':Predicate, #2: 2	أَحْرَمَ الْقَادِرُ
u'أَحْرَمَ مُتَطَوِّعٌ':Subject, #1: 1	أَحْرَمَ لَيْلَةَ
u'أَحْرَمَ مُتَمَتِّعٌ':Subject, #1: 1	أَحْرَمَ الْمُتَطَوِّعُ
u'أَحْرَمَ مثل':Subject, #2: 2	أَحْرَمَ الْمُتَمَتِّعُ
u'أَحْرَمَ مِثْلٌ':Subject, #1: 1	أَحْرَمَ مِثْلُ
u'أَحْرَمَ مُسَافِرٌ':Subject, #1: 1	أَحْرَمَ مِثْلُ
u'أَحْرَمَ مُسَافِرٌ':Subject, #2: 2	أَحْرَمَ مُسَافِرٌ
u'أَحْرَمَ مَغْصُوب':Subject, #3: 3	أَحْرَمَ الْمُسَافِرُ
u'أَحْرَمَ مَكْشُوفٌ':Predicate, #1: 1	أَحْرَمَ الْمَغْصُوبُ
u'أَحْرَمَ مَكِّيّ':Subject, #1: 1	أَحْرَمَ مَكْشُوفَ
u'أَحْرَمَ مَكِّيّ':Subject, #1: 1	أَحْرَمَ مَكِّيٌّ
u'أَحْرَمَ مُوَكِّلٌ':Subject, #7: 7	أَحْرَمَ الْمَكِّيُّ
u'أَحْرَمَ نَائِبٌ':Subject, #1: 1	أَحْرَمَ الْمُوَكِّلُ
u'أَحْرَمَ نَائِبٌ':Subject, #1: 1	أَحْرَمَ النَّائِبُ
u'أَحْرَمَ وَتَرٌ':Predicate, #2: 2	أَحْرَمَ نَائِبُهُ
u'أَحْرَمَ وَجَبٌ':Predicate, #1: 1	أَحْرَمَ وَتَرَكَ
u'أَحْرَمَ وَراء':Predicate, #1: 1	أَحْرَمَ وَجَبَ
u'أَحْرَمَ وَكِيلٌ':Subject, #4: 4	أَحْرَمَ وَرَاءَ
u'أَحْرَمَ ولد':Subject, #1: 1	أَحْرَمَ وَكِيلُ
u'أَحْرَمَ وَلَدٌ':Subject, #1: 1	أَحْرَمَ وَلَدُ
u'أَحْرَمَ وَلِيٌّ':Subject, #1: 1	أَحْرَمَ وَلَدُ
u'أَحْرَمَ وَلِيٌّ':Subject, #1: 1	أَحْرَمَ وَلِيُّهُ
u'أَحْرَمَ يَوْمٌ':Predicate, #4: 4	أَحْرَمَ الْوَلِيُّ
u'أَحْزَنَ رَسُولٌ':Predicate, #7: 7	أَحْرَمَ يَوْمَ
u'أَحَسَّ إمَامٌ':Subject, #1: 1	أَحْزَنَ رَسُولَ
u'إحْسَانٌ أَوْلِيَاءُ':Added, #1: 1	أَحَسَّ الْإِمَامُ
u'إحْسَانٌ تَصَرُّفٌ':Added, #1: 1	إحْسَانِ الْأَوْلِيَاءِ
u'إحْسَانٌ دفن':Added, #1: 1	إحْسَانَ التَّصَرُّفِ
u'إحْسَانٌ دَفْنٌ':Added, #1: 1	إحْسَانِ الدَّفْنِ
u'إحْسَانٌ ظَنٌّ':Added, #1: 1	إحْسَانِ الدَّفْنِ
u'إحْسَانٌ ظَنٌّ':Added, #1: 1	إحْسَانُ الظَّنِّ
u'إحْسَانٌ عَبْدٌ':Added, #2: 2	إحْسَانَ الظَّنِّ
u'إحْسَانٌ قِتْلَةٌ':Added, #1: 1	إحْسَانُ الْعَبْدِ
u'إحْسَانٌ قَدْرٌ':Added, #1: 1	إحْسَانِ الْقِتْلَةِ
u'إحْسَانٌ قِرَاءةٌ':Added, #1: 1	إحْسَانِ الْقَدْرِ
u'إحْسَانٌ قِنٌّ':Added, #1: 1	إحْسَانِ الْقِرَاءَةِ
u'إحْسَانٌ مَسْنُونٌ':Added, #1: 1	إحْسَانَ قِنِّهِ
u'إحْسَانٌ نَاسٌ':Added, #1: 1	إحْسَانِ الْمَسْنُونِ
u'أَحْسَنَ اِبْنٌ':Subject, #1: 1	إحْسَانَ النَّاسِ
u'أَحْسَنَ أدَب':Predicate, #3: 3	أَحْسَنَ ابْنُ
u'أَحَسَّ نَاسٌ':Subject, #1: 1	أَحْسَنَ أَدَبَ
u'أَحْسَنَ اِسْمٌ':Predicate, #1: 1	أَحَسَّ النَّاسُ
u'أَحْسَنَ إمَامٌ':Subject, #1: 1	أَحْسَنَ اسْمَ
u'أَحْسَنَ إِنْصافٌ':Predicate, #1: 1	أَحْسَنَ الْإِمَامُ
u'أَحْسَنَ بَذْلٌ':Predicate, #2: 2	أَحْسَنَ الْإِنْصَافَ
u'أَحْسَنَ بَعْضٌ':Subject, #1: 1	أَحْسَنَ بَذْلاً
u'أَحَسَّ نَبِيٌّ':Subject, #2: 2	أَحْسَنَ بَعْضُ
u'أَحْسَنَ تُرْكِيّ':Predicate, #1: 1	أَحَسَّ النَّبِيُّ
u'أَحْسَنَ تَفْسِيرٌ':Predicate, #2: 2	أَحْسَنَ التُّرْكِيَّةَ
u'أَحْسَنَ ثَناءٌ':Predicate, #2: 2	أَحْسَنَ التَّفْسِيرَ
u'أَحْسَنَ جِسْمٌ':Predicate, #2: 2	أَحْسَنَ الثَّنَاءَ
u'أَحْسَنَ حَديثٌ':Predicate, #1: 1	أَحْسَنَ جِسْمَكَ
u'أَحْسَنَ خطبة':Predicate, #1: 1	أَحْسَنَ حَدِيثَ
u'أَحْسَنَ خُطْبَةٌ':Predicate, #1: 1	أَحْسَنَ الْخُطْبَةَ
u'أَحْسَنَ زَرْعٌ':Predicate, #1: 1	أَحْسَنَ الْخُطْبَةَ
u'أَحْسَنَ زَيْدٌ':Subject, #2: 2	أَحْسَنَ زَرْعَ
u'أَحْسَنَ سُجُودٌ':Predicate, #1: 1	أَحْسَنَ زَيْدٌ
u'أَحْسَنَ شَاعِر':Subject, #1: 1	أَحْسَنَ السُّجُودَ
u'أَحْسَنَ شَرَائِطُ':Predicate, #1: 1	أَحْسَنَ الشَّاعِرُ
u'أَحْسَنَ شَرْطٌ':Predicate, #1: 1	أَحْسَنَ الشَّرَائِطَ
u'أَحْسَنَ شَيْخٌ':Subject, #3: 3	أَحْسَنَ الشَّرْطَ
u'أَحْسَنَ صَلاَةٌ':Predicate, #1: 1	أَحْسَنَ الشَّيْخُ
u'أَحْسَنَ صَلاَةٌ':Predicate, #1: 1	أَحْسَنَ الصَّلَاةَ
u'أَحْسَنَ صنعة':Predicate, #1: 1	أَحْسَنَ الصَّلاَةَ
u'أَحْسَنَ صَنْعَةٌ':Predicate, #1: 1	أَحْسَنَ صَنْعَتَكَ
u'أَحْسَنَ عِبَادَةٌ':Predicate, #1: 1	أَحْسَنَ صَنْعَتَكَ
u'أَحْسَنَ عِبَارَةٌ':Predicate, #3: 3	أَحْسَنَ عِبَادَةَ
u'أَحْسَنَ عَرَبِيٌّ':Predicate, #1: 1	أَحْسَنَ عِبَارَةَ
u'أَحْسَنَ قَالٌ':Predicate, #4: 4	أَحْسَنَ الْعَرَبِيَّةَ
u'أَحْسَنَ قَائِلٌ':Subject, #1: 1	أَحْسَنَ قَالَ
u'أَحْسَنَ قِرَاءةٌ':Predicate, #3: 3	أَحْسَنَ الْقَائِلُ
u'أَحْسَنَ قِرَاءةٌ':Predicate, #1: 1	أَحْسَنَ الْقِرَاءَةَ
u'أَحْسَنَ قَضَاءٌ':Predicate, #1: 1	أَحْسَنَ قِرَاءَةَ
u'أَحْسَنَ قول':Predicate, #1: 1	أَحْسَنَ الْقَضَاءَ
u'أَحْسَنَ قَوْلٌ':Predicate, #1: 1	أَحْسَنَ الْقَوْلَ
u'أَحْسَنَ قول':Predicate, #1: 1	أَحْسَنَ الْقَوْلَ
u'أَحْسَنَ قَوْلٌ':Predicate, #25: 25	أَحْسَنَ قَوْلَ
u'أَحْسَنَ قول':Subject, #25: 25	أَحْسَنَ قَوْلَ
u'أَحْسَنَ قَوْلٌ':Subject, #1: 1	أَحْسَنَ قَوْلُ
u'أَحْسَنَ قيام':Predicate, #1: 1	أَحْسَنَ قَوْلُ
u'أَحْسَنَ قِيَامٌ':Predicate, #1: 1	أَحْسَنَ الْقِيَامَ
u'أَحْسَنَ مِحْرَابٌ':Predicate, #1: 1	أَحْسَنَ الْقِيَامَ
u'أَحْسَنَ مُصَنِّفٌ':Subject, #1: 1	أَحْسَنَ الْمِحْرَابَ
u'أَحْسَنَ مُعْظَمٌ':Predicate, #1: 1	أَحْسَنَ الْمُصَنِّفُ
u'أَحْسَنَ مَلأٌ':Predicate, #1: 1	أَحْسَنَ مُعْظَمَ
u'أَحْسَنَ نَاسٌ':Subject, #2: 2	أَحْسَنَ مَلَأَ
u'أَحْسَنَ نَظَرٌ':Predicate, #5: 5	أَحْسَنَ النَّاسُ
u'أَحْسَنَ وُضُوءٌ':Predicate, #1: 1	أَحْسَنَ النَّظَرَ
u'أَحْسَنَ وُضُوءٌ':Predicate, #1: 1	أَحْسَنَ الْوُضُوءَ
u'أَحْصَنَ رَجُلٌ':Subject, #2: 2	أَحْسَنَ وُضُوءَهُنَّ
u'أَحْصَنَ قَالٌ':Predicate, #2: 2	أَحْصَنَ الرَّجُلُ
u'أَحْصَى رَمْلٌ':Predicate, #1: 1	أَحْصَنَ قَالَ
u'إحْضَارٌ أحَدٌ':Added, #9: 9	أَحْصَى رَمْلَ
u'إحْضَارٌ أًصْلٌ':Added, #1: 1	إحْضَارُ أَحَدٍ
u'إحْضَارٌ أَصيلٌ':Added, #1: 1	إحْضَارُ الْأَصْلَيْنِ
u'إحْضَارٌ الْمَرْأَةُ':Added, #1: 1	إحْضَارِ الْأَصِيلِ
u'إحْضَارٌ الْمَرْأَةُ':Added, #1: 1	إحْضَارِ الْمَرْأَةِ
u'إحْضَارٌ بَدَلٌ':Added, #3: 3	إحْضَارُ الْمَرْأَةِ
u'إحْضَارٌ بدن':Added, #1: 1	إحْضَارَ بَدَلِهِ
u'إحْضَارٌ بَدَنٌ':Added, #1: 1	إحْضَارِ الْبَدَنِ
u'إحْضَارٌ بَيِّنَةٌ':Added, #1: 1	إحْضَارِ الْبَدَنِ
u'إحْضَارٌ بَيِّنَةٌ':Added, #1: 1	إحْضَارَ بَيِّنَةٍ
u'إحْضَارٌ تَخْتٌ':Added, #2: 2	إحْضَارِ الْبَيِّنَةِ
u'إحْضَارٌ تَرِكَةٌ':Added, #1: 1	إحْضَارَ التَّخْتِ
u'إحْضَارٌ ثَلاثَةٌ':Added, #1: 1	إحْضَارُ التَّرِكَةِ
u'إحْضَارٌ ثَمَنٌ':Added, #1: 1	إحْضَارِ ثَلَاثَةٍ
u'إحْضَارٌ ثَمَنٌ':Added, #1: 1	إحْضَارَ الثَّمَنِ
u'إحْضَارٌ ثَمَنٌ':Added, #4: 4	إحْضَارِ الثَّمَنِ
u'إحْضَارٌ ثَوْبٌ':Added, #7: 7	إحْضَارُ الثَّمَنِ
u'إحْضَارٌ جِنٌّ':Added, #1: 1	إحْضَارُ الثَّوْبِ
u'إحْضَارٌ خَصْمٌ':Added, #1: 1	إحْضَارَ الْجِنِّ
u'إحْضَارٌ خَصْمٌ':Added, #1: 1	إحْضَارَ الْخَصْمِ
u'إحْضَارٌ خَصْمٌ':Added, #1: 1	إحْضَارُ الْخَصْمِ
u'إحْضَارٌ خَصْمٌ':Added, #1: 1	إحْضَارِ الْخَصْمِ
u'إحْضَارٌ خَصْمٌ':Added, #1: 1	إحْضَارَ خَصْمٍ
u'إحْضَارٌ خَصْمٌ':Added, #2: 2	إحْضَارَ خَصْمِهِ
u'إحْضَارٌ دَابَّةٌ':Added, #2: 2	إحْضَارِ خَصْمِهِ
u'إحْضَارٌ دَرَاهِمُ':Added, #1: 1	إحْضَارُ الدَّابَّةِ
u'إحْضَارٌ دَيْنٌ':Added, #1: 1	إحْضَارُ الدَّرَاهِمِ
u'إحْضَارٌ ذِهْنٌ':Added, #1: 1	إحْضَارِ الدَّيْنِ
u'إحْضَارٌ رَهْنٌ':Added, #1: 1	إحْضَارُ ذِهْنِهِ
u'إحْضَارٌ رَهْنٌ':Added, #17: 17	إحْضَارَ الرَّهْنِ
u'إحْضَارٌ رَهْنٌ':Added, #2: 2	إحْضَارُ الرَّهْنِ
u'إحْضَارٌ سِلَعٌ':Added, #4: 4	إحْضَارِ الرَّهْنِ
u'إحْضَارٌ سِلْعَةٌ':Added, #3: 3	إحْضَارُ السِّلَعِ
u'إحْضَارٌ شَاهِدٌ':Added, #5: 5	إحْضَارُ السِّلْعَةِ
u'إحْضَارٌ شُهُودٌ':Added, #1: 1	إحْضَارَ الشَّاهِدَيْنِ
u'إحْضَارٌ شُهُودٌ':Added, #1: 1	إحْضَارُ شُهُودِ
u'إحْضَارٌ شُهُودٌ':Added, #1: 1	إحْضَارِ شُهُودِ
u'إحْضَارٌ شوَاهِدُ':Added, #2: 2	إحْضَارِ الشُّهُودِ
u'إحْضَارٌ شَوَاهِدُ':Added, #1: 1	إحْضَارَ شَوَاهِدِهِ
u'إحْضَارٌ شَيْءٌ':Added, #1: 1	إحْضَارَ شَوَاهِدِهِ
u'إحْضَارٌ شَيْءٌ':Added, #1: 1	إحْضَارُ شَيْءٍ
u'إحْضَارٌ صَبِيٌّ':Added, #1: 1	إحْضَارِ شَيْءٍ
u'إحْضَارٌ صِبْيَانٌ':Added, #1: 1	إحْضَارَ الصَّبِيِّ
u'إحْضَارٌ صَغِيرٌ':Added, #1: 1	إحْضَارِ الصِّبْيَانِ
u'إحْضَارٌ طعام':Added, #2: 2	إحْضَارُ الصَّغِيرِ
u'إحْضَارٌ طعام':Added, #1: 1	إحْضَارَ الطَّعَامِ
u'إحْضَارٌ طَعَامٌ':Added, #1: 1	إحْضَارِ الطَّعَامِ
u'إحْضَارٌ طَعَامٌ':Added, #1: 1	إحْضَارَ الطَّعَامِ
u'إحْضَارٌ عَبْدٌ':Added, #1: 1	إحْضَارِ الطَّعَامِ
u'إحْضَارٌ عَبْدٌ':Added, #1: 1	إحْضَارِ الْعَبْدِ
u'إحْضَارٌ عَبْدٌ':Added, #1: 1	إحْضَارُ عَبْدٍ
u'إحْضَارٌ عَدَدٌ':Added, #1: 1	إحْضَارِ عَبْدٍ
u'إحْضَارٌ عُدُولٌ':Added, #1: 1	إحْضَارِ الْعَدَدِ
u'إحْضَارٌ عَيْنٌ':Added, #1: 1	إحْضَارِ الْعُدُولِ
u'إحْضَارٌ عَيْن':Added, #1: 1	إحْضَارَ عَيْنٍ
u'إحْضَارٌ عين':Added, #1: 1	إحْضَارَ عَيْنٍ
u'إحْضَارٌ عَيْنٌ':Added, #3: 3	إحْضَارِ الْعَيْنِ
u'إحْضَارٌ عَيْن':Added, #3: 3	إحْضَارِ الْعَيْنِ
u'إحْضَارٌ غَائِبٌ':Added, #3: 3	إحْضَارِ الْعَيْنِ
u'إحْضَارٌ غَرِيمٌ':Added, #1: 1	إحْضَارُ الْغَائِبِ
u'إحْضَارٌ غَرِيمٌ':Added, #1: 1	إحْضَارُ الْغَرِيمِ
u'إحْضَارٌ غُلاَمٌ':Added, #1: 1	إحْضَارِ الْغَرِيمِ
u'إحْضَارٌ غير':Added, #1: 1	إحْضَارَ الْغُلَامِ
u'إحْضَارٌ غَيْرٌ':Added, #1: 1	إحْضَارَ غَيْرِهِ
u'إحْضَارٌ فقهاء':Added, #1: 1	إحْضَارَ غَيْرِهِ
u'إحْضَارٌ فُلاَنٌ':Added, #1: 1	إحْضَارِ فُقَهَاءِ
u'إحْضَارٌ فَهْمٌ':Added, #1: 1	إحْضَارَ فُلَانٍ
u'إحْضَارٌ قلب':Added, #2: 2	إحْضَارِ الْفَهْمِ
u'إحْضَارٌ قَلْبٌ':Added, #1: 1	إحْضَارُ الْقَلْبِ
u'إحْضَارٌ قَلْب':Added, #1: 1	إحْضَارُ الْقَلْبِ
u'إحْضَارٌ قلب':Added, #1: 1	إحْضَارُ الْقَلْبِ
u'إحْضَارٌ قَلْبٌ':Added, #3: 3	إحْضَارِ الْقَلْبِ
u'إحْضَارٌ قَلْب':Added, #3: 3	إحْضَارِ الْقَلْبِ
u'إحْضَارٌ كِرْباس':Added, #3: 3	إحْضَارِ الْقَلْبِ
u'إحْضَارٌ مَالٌ':Added, #1: 1	إحْضَارُ الْكِرْبَاسِ
u'إحْضَارٌ مَالٌ':Added, #1: 1	إحْضَارِ الْمَالِ
u'إحْضَارٌ مَالٌ':Added, #1: 1	إحْضَارِ مَالٍ
u'إحْضَارٌ مَبِيعٌ':Added, #2: 2	إحْضَارِ مَالِهِ
u'إحْضَارٌ مُسْتَحَقٌّ':Added, #3: 3	إحْضَارِ الْمَبِيعِ
u'إحْضَارٌ مَغْصُوب':Added, #1: 1	إحْضَارِ الْمُسْتَحَقِّ
u'إحْضَارٌ مَكْفُولٌ':Added, #1: 1	إحْضَارِ الْمَغْصُوبِ
u'إحْضَارٌ مَكْفُولٌ':Added, #1: 1	إحْضَارَ الْمَكْفُولِ
u'إحْضَارٌ مَكْفُولٌ':Added, #1: 1	إحْضَارِ الْمَكْفُولِ
u'إحْضَارٌ مَكْفُولٌ':Added, #1: 1	إحْضَارِ مَكْفُولٍ
u'إحْضَارٌ مَنْقُولٌ':Added, #7: 7	إحْضَارُ الْمَكْفُولِ
u'إحْضَارٌ مَهْدٌ':Added, #1: 1	إحْضَارَ الْمَنْقُولِ
u'إحْضَارٌ نَفْسٌ':Added, #1: 1	إحْضَارُ الْمَهْدِ
u'إحْضَارٌ نَفْسٌ':Added, #1: 1	إحْضَارُ نَفْسِ
u'إحْضَارٌ نِيَّةٌ':Added, #3: 3	إحْضَارُ النَّفْسِ
u'إحْضَارٌ هِبَةٌ':Added, #1: 1	إحْضَارِ نِيَّةِ
u'إحْضَارٌ وَارِثٌ':Added, #1: 1	إحْضَارِ الْهِبَةِ
u'إحْضَارٌ وَجْهٌ':Added, #1: 1	إحْضَارِ وَارِثِ
u'أَحْضَرَ أَبٌ':Subject, #2: 2	إحْضَارِ وَجْهِهِ
u'أَحْضَرَ اِمْرَأَةٌ':Predicate, #3: 3	أَحْضَرَ الْأَبُ
u'أَحْضَرَ بَائِعٌ':Subject, #1: 1	أَحْضَرَ امْرَأَةَ
u'أَحْضَرَ بَيِّنَةٌ':Predicate, #2: 2	أَحْضَرَ الْبَائِعُ
u'أَحْضَرَ ثَمَنٌ':Predicate, #1: 1	أَحْضَرَ الْبَيِّنَةَ
u'أَحْضَرَ جلد':Predicate, #1: 1	أَحْضَرَ الثَّمَنَ
u'أَحْضَرَ جِلْدٌ':Predicate, #2: 2	أَحْضَرَ الْجِلْدَ
u'أَحْضَرَ خَصْمٌ':Subject, #2: 2	أَحْضَرَ الْجِلْدَ
u'أَحْضَرَ دَنانيرُ':Predicate, #2: 2	أَحْضَرَ الْخَصْمُ
u'أَحْضَرَ دَيْنٌ':Predicate, #1: 1	أَحْضَرَ الدَّنَانِيرَ
u'أَحْضَرَ رَبُّ':Subject, #2: 2	أَحْضَرَ الدَّيْنَ
u'أَحْضَرَ رَجُلٌ':Subject, #2: 2	أَحْضَرَ رَبُّ
u'أَحْضَرَ رَجُلٌ':Subject, #1: 1	أَحْضَرَ الرَّجُلُ
u'أَحْضَرَ شَفِيعٌ':Subject, #1: 1	أَحْضَرَ رَجُلٌ
u'أَحْضَرَ صَاحِبٌ':Subject, #4: 4	أَحْضَرَ الشَّفِيعُ
u'أَحْضَرَ صَانِعٌ':Subject, #1: 1	أَحْضَرَ صَاحِبُ
u'أَحْضَرَ ظالِمٌ':Predicate, #1: 1	أَحْضَرَ الصَّانِعُ
u'أَحْضَرَ عَبْدٌ':Predicate, #1: 1	أَحْضَرَ ظَالِمَةً
u'أَحْضَرَ عَبْدٌ':Subject, #1: 1	أَحْضَرَ الْعَبْدَ
u'أَحْضَرَ عند':Predicate, #1: 1	أَحْضَرَ الْعَبْدُ
u'أَحْضَرَ غَاصِبٌ':Subject, #1: 1	أَحْضَرَ عِنْدَ
u'أَحْضَرَ فَارِسٌ':Subject, #3: 3	أَحْضَرَ الْغَاصِبُ
u'أَحْضَرَ فقهاء':Predicate, #1: 1	أَحْضَرَ الْفَارِسُ
u'أَحْضَرَ كَفِيلٌ':Subject, #1: 1	أَحْضَرَ الْفُقَهَاءَ
u'أَحْضَرَ لحمة':Predicate, #2: 2	أَحْضَرَ الْكَفِيلُ
u'أَحْضَرَ لُحْمَةٌ':Predicate, #1: 1	أَحْضَرَ اللُّحْمَةَ
u'أَحْضَرَ مَالٌ':Predicate, #1: 1	أَحْضَرَ اللُّحْمَةَ
u'أَحْضَرَ مَالٌ':Predicate, #1: 1	أَحْضَرَ مَالَ
u'أَحْضَرَ مَبْلَغٌ':Predicate, #3: 3	أَحْضَرَ الْمَالَ
u'أَحْضَرَ مَجُوسِيٌّ':Predicate, #1: 1	أَحْضَرَ الْمَبْلَغَ
u'أَحْضَرَ مَحْبُوسٌ':Subject, #1: 1	أَحْضَرَ الْمَجُوسِيَّ
u'أَحْضَرَ مُرْتَهِنٌ':Subject, #1: 1	أَحْضَرَ الْمَحْبُوسُ
u'أَحْضَرَ مَغْصُوب':Predicate, #1: 1	أَحْضَرَ الْمُرْتَهِنُ
u'أَحْضَرَ مَقْصُورٌ':Predicate, #1: 1	أَحْضَرَ الْمَغْصُوبَ
u'أَحْضَرَ مَكْفُولٌ':Predicate, #2: 2	أَحْضَرَ الْمَقْصُورَ
u'أَحْضَرَ مُوَكِّلٌ':Predicate, #2: 2	أَحْضَرَ الْمَكْفُولَ
u'أَحْضَرَ نِصْفٌ':Predicate, #1: 1	أَحْضَرَ الْمُوَكِّلَ
u'أَحْضَرَ وَصِيٌّ':Predicate, #5: 5	أَحْضَرَ نِصْفَ
u'أَحْضَرَ وَصِيٌّ':Subject, #1: 1	أَحْضَرَ وَصِيَّ
u'أَحْضَرَ وَكِيلٌ':Subject, #2: 2	أَحْضَرَ الْوَصِيُّ
u'أَحْظَى عند':Predicate, #2: 2	أَحْضَرَ الْوَكِيلُ
u'أَحْقَادٌ أَعْدَاءٌ':Added, #1: 1	أَحْظَى عِنْدَ
u'أَحْكَامٌ آبارٌ':Added, #1: 1	أَحْقَادُ الْأَعْدَاءِ
u'أَحْكَامٌ أبدال':Added, #1: 1	أَحْكَامِ الْآبَارِ
u'أَحْكَامٌ أبدال':Added, #1: 1	أَحْكَامُ الْأَبْدَالِ
u'أَحْكَامٌ أَبْدَالٌ':Added, #1: 1	أَحْكَامِ الْأَبْدَالِ
u'أَحْكَامٌ أَبْدَالٌ':Added, #1: 1	أَحْكَامُ الْأَبْدَالِ
u'أَحْكَامٌ إبدالٌ':Added, #1: 1	أَحْكَامِ الْأَبْدَالِ
u'أَحْكَامٌ اِبْنٌ':Added, #1: 1	أَحْكَامُ الْإِبْدَالِ
u'أَحْكَامٌ اِبْنٌ':Added, #1: 1	أَحْكَامَ ابْنِ
u'إحْكَامٌ أبْنيَةٌ':Added, #5: 5	أَحْكَامِ ابْنِ
u'أَحْكَامٌ اِتِّفَاقٌ':Added, #1: 1	إحْكَامِ الْأَبْنِيَةِ
u'أَحْكَامٌ إجَارَةٌ':Added, #1: 1	أَحْكَامِ اتِّفَاقِ
u'أَحْكَامٌ إجَارَةٌ':Added, #2: 2	أَحْكَامِ الْإِجَارَةِ
u'أَحْكَامٌ أَجْزَاءٌ':Added, #3: 3	أَحْكَامِ إجَارَةِ
u'أَحْكَامٌ إِجْمَاعٌ':Added, #1: 1	أَحْكَامَ الْأَجْزَاءِ
u'أَحْكَامٌ أَجِيرٌ':Added, #1: 1	أَحْكَامِ الْإِجْمَاعِ
u'أَحْكَامٌ أَحْرارٌ':Added, #2: 2	أَحْكَامِ الْأَجِيرِ
u'أَحْكَامٌ أَحْرارٌ':Added, #2: 2	أَحْكَامَ الْأَحْرَارِ
u'أَحْكَامٌ أَحْرارٌ':Added, #4: 4	أَحْكَامُ الْأَحْرَارِ
u'أَحْكَامٌ إِحْرَامٌ':Added, #5: 5	أَحْكَامِ الْأَحْرَارِ
u'أَحْكَامٌ أَحْكَامٌ':Added, #4: 4	أَحْكَامِ الْإِحْرَامِ
u'إحْكَامٌ أَحْكَامٌ':Added, #1: 1	أَحْكَامِ الْأَحْكَامِ
u'أَحْكَامٌ أَحْيَاءٌ':Added, #1: 1	إحْكَامِ الْأَحْكَامِ
u'أَحْكَامٌ اِخْتِلاَفٌ':Added, #3: 3	أَحْكَامِ الْأَحْيَاءِ
u'أَحْكَامٌ آخِرَةٌ':Added, #1: 1	أَحْكَامِ اخْتِلَافِ
u'أَحْكَامٌ آخِرَةٌ':Added, #19: 19	أَحْكَامِ الْآخِرَةِ
u'أَحْكَامٌ أَخَصُّ':Added, #1: 1	أَحْكَامُ الْآخِرَةِ
u'أَحْكَامٌ أَدَاءٌ':Added, #1: 1	أَحْكَامِ الْأَخَصِّ
u'أَحْكَامٌ آدَمِيٌّ':Added, #2: 2	أَحْكَامِ الْأَدَاءِ
u'أَحْكَامٌ إِذْنٌ':Added, #3: 3	أَحْكَامِ الْآدَمِيَّةِ
u'أَحْكَامٌ إِذْنٌ':Added, #1: 1	أَحْكَامَ إذْنِ
u'أَحْكَامٌ إِذْنٌ':Added, #1: 1	أَحْكَامِ إذْنِ
u'أَحْكَامٌ أرْضٌ':Added, #2: 2	أَحْكَامُ الْإِذْنِ
u'أَحْكَامٌ اِسْتِقْرارٌ':Added, #2: 2	أَحْكَامِ أَرْضِ
u'أَحْكَامٌ اِسْتيفاءٌ':Added, #1: 1	أَحْكَامُ اسْتِقْرَارِ
u'أَحْكَامٌ إِسْلامٌ':Added, #1: 1	أَحْكَامِ اسْتِيفَاءِ
u'أَحْكَامٌ إِسْلامٌ':Added, #15: 15	أَحْكَامِ الْإِسْلَامِ
u'أَحْكَامٌ إِسْلامٌ':Added, #1: 1	أَحْكَامِ الإِسْلاَمِ
u'أَحْكَامٌ إِسْلامٌ':Added, #20: 20	أَحْكَامَ الْإِسْلَامِ
u'أَحْكَامٌ إشارَة':Added, #6: 6	أَحْكَامُ الْإِسْلَامِ
u'أَحْكَامٌ أَصيلٌ':Added, #1: 1	أَحْكَامَ الْإِشَارَةِ
u'أَحْكَامٌ إِعْرابٌ':Added, #1: 1	أَحْكَامَ الْأَصِيلِ
u'أَحْكَامٌ أَعَمُّ':Added, #1: 1	أَحْكَامُ إعْرَابِهِ
u'أَحْكَامٌ أَفْعَالٌ':Added, #1: 1	أَحْكَامِ الْأَعَمِّ
u'أَحْكَامٌ أَفْعَالٌ':Added, #1: 1	أَحْكَامِ أَفْعَالِ
u'أَحْكَامٌ إقامَةٌ':Added, #1: 1	أَحْكَامِ الْأَفْعَالِ
u'أَحْكَامٌ إقْرَارٌ':Added, #1: 1	أَحْكَامُ الْإِقَامَةِ
u'أَحْكَامٌ إقْرَارٌ':Added, #1: 1	أَحْكَامِ إقْرَارِ
u'أَحْكَامٌ إقْرَارٌ':Added, #1: 1	أَحْكَامُ الْإِقْرَارِ
u'أَحْكَامٌ إقْطَاعٌ':Added, #1: 1	أَحْكَامِ الْإِقْرَارِ
u'أَحْكَامٌ أَقْوَالٌ':Added, #2: 2	أَحْكَامِ الْإِقْطَاعِ
u'أَحْكَامٌ إكْرَاهٌ':Added, #1: 1	أَحْكَامُ أَقْوَالِ
u'أَحْكَامٌ إكْرَاهٌ':Added, #1: 1	أَحْكَامُ الإِكْرَاهِ
u'أَحْكَامٌ إكْرَاهٌ':Added, #1: 1	أَحْكَامُ الْإِكْرَاهِ
u'أَحْكَامٌ الْمَرْأَةُ':Added, #1: 1	أَحْكَامِ الْإِكْرَاهِ
u'أَحْكَامٌ الْمَرْأَةُ':Added, #1: 1	أَحْكَامُ الْمَرْأَةِ
u'أَحْكَامٌ أُمٌّ':Added, #1: 1	أَحْكَامِ الْمَرْأَةِ
u'أَحْكَامٌ إمَاءٌ':Added, #1: 1	أَحْكَامِ أُمِّ
u'أَحْكَامٌ إمَارَةٌ':Added, #1: 1	أَحْكَامُ الْإِمَاءِ
u'أَحْكَامٌ إمَامٌ':Added, #1: 1	أَحْكَامِ إمَارَتِهِ
u'أَحْكَامٌ إمَامَةٌ':Added, #1: 1	أَحْكَامِ الْإِمَامِ
u'أَحْكَامٌ أمَةٌ':Added, #1: 1	أَحْكَامِ الْإِمَامَةِ
u'أَحْكَامٌ أمَةٌ':Added, #1: 1	أَحْكَامُ الْأَمَةِ
u'أَحْكَامٌ أمَةٌ':Added, #1: 1	أَحْكَامِ الْأَمَةِ
u'أَحْكَامٌ أُمَّهَاتٌ':Added, #1: 1	أَحْكَامُ أَمَةٍ
u'أَحْكَامٌ أموات':Added, #8: 8	أَحْكَامِ أُمَّهَاتِ
u'أَحْكَامٌ أنبياء':Added, #2: 2	أَحْكَامِ الْأَمْوَاتِ
u'أَحْكَامٌ أهْلٌ':Added, #1: 1	أَحْكَامُ الأَنْبِيَاءِ
u'أَحْكَامٌ أهْلٌ':Added, #3: 3	أَحْكَامُ أَهْلِ
u'أَحْكَامٌ أَوْقَافٌ':Added, #7: 7	أَحْكَامِ أَهْلِ
u'أَحْكَامٌ أَوْقَافٌ':Added, #1: 1	أَحْكَامَ الْأَوْقَافِ
u'أَحْكَامٌ أيتام':Added, #1: 1	أَحْكَامِ الْأَوْقَافِ
u'أَحْكَامٌ أَيْمَانٌ':Added, #1: 1	أَحْكَامِ الْأَيْتَامِ
u'أَحْكَامٌ إيمَانٌ':Added, #2: 2	أَحْكَامِ الْأَيْمَانِ
u'أَحْكَامٌ باتٌّ':Added, #4: 4	أَحْكَامِ الْإِيمَانِ
u'أَحْكَامٌ بالِغٌ':Added, #1: 1	أَحْكَامُ الْبَاتِّ
u'أَحْكَامٌ بِدَعٌ':Added, #1: 1	أَحْكَامُ الْبَالِغَةِ
u'أَحْكَامٌ بُغاةٌ':Added, #2: 2	أَحْكَامِ الْبِدَعِ
u'أَحْكَامٌ بِلادٌ':Added, #1: 1	أَحْكَامُ الْبُغَاةِ
u'أَحْكَامٌ بِنَاءٌ':Added, #1: 1	أَحْكَامَ الْبِلَادِ
u'أَحْكَامٌ بِنَاءٌ':Added, #1: 1	أَحْكَامَ الْبِنَاءِ
u'إحْكَامٌ بِنَاءٌ':Added, #1: 1	أَحْكَامِ الْبِنَاءِ
u'إحْكَامٌ بِنَاءٌ':Added, #1: 1	إحْكَامَ الْبِنَاءِ
u'أَحْكَامٌ بِنْت':Added, #1: 1	إحْكَامِ الْبِنَاءِ
u'أَحْكَامٌ بُنُوَّة':Added, #1: 1	أَحْكَامِ الْبِنْتِيَّةِ
u'أَحْكَامٌ بَوَاطِنُ':Added, #1: 1	أَحْكَامِ الْبُنُوَّةِ
u'أَحْكَامٌ بِئْرٌ':Added, #1: 1	أَحْكَامَ الْبَوَاطِنِ
u'أَحْكَامٌ بيض':Added, #1: 1	أَحْكَامُ الْبِئْرِ
u'أَحْكَامٌ بَيْعٌ':Added, #1: 1	أَحْكَامُ الْبَيْضِ
u'أَحْكَامٌ بَيْعٌ':Added, #11: 11	أَحْكَامُ الْبَيْعِ
u'أَحْكَامٌ بَيْعٌ':Added, #12: 12	أَحْكَامِ الْبَيْعِ
u'أَحْكَامٌ بيوع':Added, #4: 4	أَحْكَامَ الْبَيْعِ
u'أَحْكَامٌ تَثَاؤُبٌ':Added, #1: 1	أَحْكَامِ الْبُيُوعِ
u'أَحْكَامٌ تَحَالُفٌ':Added, #1: 1	أَحْكَامِ التَّثَاؤُبِ
u'أَحْكَامٌ تَحَجُّرٌ':Added, #1: 1	أَحْكَامِ التَّحَالُفِ
u'أَحْكَامٌ تَحِيَّةٌ':Added, #1: 1	أَحْكَامِ التَّحَجُّرِ
u'أَحْكَامٌ تَرَاوِيحُ':Added, #1: 1	أَحْكَامَ تَحِيَّةِ
u'أَحْكَامٌ تَعَلُّقٌ':Added, #2: 2	أَحْكَامِ التَّرَاوِيحِ
u'أَحْكَامٌ تَعْلِيقٌ':Added, #1: 1	أَحْكَامِ التَّعَلُّقَاتِ
u'أَحْكَامٌ تَغْيِيبٌ':Added, #1: 1	أَحْكَامُ التَّعْلِيقِ
u'أَحْكَامٌ تَقْليدٌ':Added, #1: 1	أَحْكَامِ تَغْيِيبِ
u'أَحْكَامٌ تَقْليد':Added, #2: 2	أَحْكَامَ التَّقْلِيدِ
u'أَحْكَامٌ تَكاليفُ':Added, #2: 2	أَحْكَامَ التَّقْلِيدِ
u'أَحْكَامٌ تَكاليفُ':Added, #1: 1	أَحْكَامُ التَّكَالِيفِ
u'أَحْكَامٌ تَكالِيفُ':Added, #1: 1	أَحْكَامِ التَّكَالِيفِ
u'أَحْكَامٌ تَكالِيفُ':Added, #1: 1	أَحْكَامُ التَّكَالِيفِ
u'أَحْكَامٌ تَكْليفٌ':Added, #1: 1	أَحْكَامِ التَّكَالِيفِ
u'أَحْكَامٌ تَكْليفٌ':Added, #1: 1	أَحْكَامُ التَّكْلِيفِ
u'أَحْكَامٌ تِلاوَةٌ':Added, #4: 4	أَحْكَامِ التَّكْلِيفِ
u'أَحْكَامٌ تَمْلِيك':Added, #1: 1	أَحْكَامُ التّلَاوَةِ
u'أَحْكَامٌ تَمْلِيكٌ':Added, #1: 1	أَحْكَامِ التَّمْلِيكِ
u'أَحْكَامٌ تَوْبَةٌ':Added, #2: 2	أَحْكَامِ تَمْلِيكِ
u'أَحْكَامٌ تَوْقِيعٌ':Added, #1: 1	أَحْكَامِ التَّوْبَةِ
u'أَحْكَامٌ تَوْكِيلٌ':Added, #1: 1	أَحْكَامِ التَّوْقِيعَاتِ
u'أَحْكَامٌ تَوْكِيلٌ':Added, #1: 1	أَحْكَامَ التَّوْكِيلِ
u'أَحْكَامٌ تَوْكِيلٌ':Added, #1: 1	أَحْكَامِ التَّوْكِيلِ
u'أَحْكَامٌ تَيَمُّمٌ':Added, #1: 1	أَحْكَامُ تَوْكِيلِ
u'أَحْكَامٌ ثابتة':Added, #2: 2	أَحْكَامِ التَّيَمُّمِ
u'أَحْكَامٌ ثَانِي':Added, #1: 1	أَحْكَامٍ ثَابِتَةٍ
u'أَحْكَامٌ ثَانِيَةٌ':Added, #2: 2	أَحْكَامِ الثَّانِيَةِ
u'أَحْكَامٌ جَانٌّ':Added, #2: 2	أَحْكَامِ الثَّانِيَةِ
u'أَحْكَامٌ جَاهِلِيٌّ':Added, #5: 5	أَحْكَامِ الْجَانِّ
u'أَحْكَامٌ جَاهِلِيَّةٌ':Added, #1: 1	أَحْكَامُ الْجَاهِلِيَّةِ
u'أَحْكَامٌ جَرَائِمُ':Added, #1: 1	أَحْكَامُ الْجَاهِلِيَّةِ
u'أَحْكَامٌ جُزْءٌ':Added, #2: 2	أَحْكَامِ الْجَرَائِمِ
u'أَحْكَامٌ جُزْئِيٌّ':Added, #1: 1	أَحْكَامَ الْجُزْءِ
u'أَحْكَامٌ جُزْئِيٌّ':Added, #1: 1	أَحْكَامِ الْجُزْئِيَّاتِ
u'أَحْكَامٌ جُزْئِيَّةٌ':Added, #1: 1	أَحْكَامِ جُزْئِيَّاتِ
u'أَحْكَامٌ جُزْئِيَّةٌ':Added, #1: 1	أَحْكَامِ الْجُزْئِيَّاتِ
u'أَحْكَامٌ جُزْئِيَّةٌ':Added, #1: 1	أَحْكَامِ جُزْئِيَّاتِ
u'أَحْكَامٌ جِزْيَةٌ':Added, #1: 1	أَحْكَامٍ جُزْئِيَّةٍ
u'أَحْكَامٌ جماع':Added, #1: 1	أَحْكَامِ الْجِزْيَةِ
u'أَحْكَامٌ جِمَاعٌ':Added, #1: 1	أَحْكَامِ الْجِمَاعِ
u'أَحْكَامٌ جَمِيع':Added, #1: 1	أَحْكَامِ الْجِمَاعِ
u'أَحْكَامٌ جِنٌّ':Added, #1: 1	أَحْكَامَ الْجَمِيعِ
u'أَحْكَامٌ جَنَابَةٌ':Added, #2: 2	أَحْكَامِ الْجِنِّ
u'أَحْكَامٌ جَنَائِزُ':Added, #1: 1	أَحْكَامُ الْجَنَابَةِ
u'أَحْكَامٌ جِنَايَةٌ':Added, #1: 1	أَحْكَامِ الْجَنَائِزِ
u'أَحْكَامٌ جِنَايَةٌ':Added, #1: 1	أَحْكَامِ الْجِنَايَاتِ
u'أَحْكَامٌ جِنَايَةٌ':Added, #1: 1	أَحْكَامَ الْجِنَايَةِ
u'أَحْكَامٌ جِنَايَةٌ':Added, #2: 2	أَحْكَامُ الْجِنَايَاتِ
u'أَحْكَامٌ جِنَايَةٌ':Added, #3: 3	أَحْكَامِ الْجِنَايَةِ
u'أَحْكَامٌ جَنِينٌ':Added, #7: 7	أَحْكَامِ جِنَايَةِ
u'أَحْكَامٌ جَنِينٌ':Added, #1: 1	أَحْكَامَ الْجَنِينِ
u'أَحْكَامٌ جِوَارٌ':Added, #2: 2	أَحْكَامِ الْجَنِينِ
u'أَحْكَامٌ جَوَازٌ':Added, #2: 2	أَحْكَامِ الْجِوَارِ
u'أَحْكَامٌ حامِلٌ':Added, #1: 1	أَحْكَامَ جَوَازِ
u'أَحْكَامٌ حائِضٌ':Added, #2: 2	أَحْكَامِ الْحَامِلِ
u'أَحْكَامٌ حَجٌّ':Added, #1: 1	أَحْكَامِ الْحَائِضِ
u'أَحْكَامٌ حَجٌّ':Added, #1: 1	أَحْكَامُ حَجِّ
u'أَحْكَامٌ حجاب':Added, #3: 3	أَحْكَامِ الْحَجِّ
u'أَحْكَامٌ حِجابٌ':Added, #1: 1	أَحْكَامِ الْحِجَابِ
u'أَحْكَامٌ حَجْرٌ':Added, #1: 1	أَحْكَامِ الْحِجَابِ
u'أَحْكَامٌ حَدَثٌ':Added, #5: 5	أَحْكَامِ الْحَجْرِ
u'أَحْكَامٌ حَرَمٌ':Added, #1: 1	أَحْكَامُ الْحَدَثِ
u'أَحْكَامٌ حُرِّيَّةٌ':Added, #1: 1	أَحْكَامِ الْحَرَمِ
u'أَحْكَامٌ حِسْبَةٌ':Added, #2: 2	أَحْكَامِ الْحُرِّيَّةِ
u'أَحْكَامٌ حِسْبَةٌ':Added, #1: 1	أَحْكَامَ الْحِسْبَةِ
u'أَحْكَامٌ حِسْبَةٌ':Added, #1: 1	أَحْكَامُ الْحِسْبَةِ
u'إحْكَامٌ حُصُونٌ':Added, #2: 2	أَحْكَامِ الْحِسْبَةِ
u'أَحْكَامٌ حُكَّامٌ':Added, #1: 1	إحْكَامِ الْحُصُونِ
u'أَحْكَامٌ حَمَّامٌ':Added, #1: 1	أَحْكَامِ الْحُكَّامِ
u'أَحْكَامٌ حوادِثُ':Added, #1: 1	أَحْكَامُ الْحَمَّامِ
u'أَحْكَامٌ حَيْضٌ':Added, #2: 2	أَحْكَامِ الْحَوَادِثِ
u'أَحْكَامٌ حَيْضٌ':Added, #1: 1	أَحْكَامُ الْحَيْضِ
u'أَحْكَامٌ حَيْضٌ':Added, #3: 3	أَحْكَامَ الْحَيْضِ
u'أَحْكَامٌ حَيَوَانٌ':Added, #9: 9	أَحْكَامِ الْحَيْضِ
u'أَحْكَامٌ خَارِجٌ':Added, #1: 1	أَحْكَامُ الْحَيَوَانِ
u'أَحْكَامٌ خَبَرٌ':Added, #1: 1	أَحْكَامِ الْخَارِجِ
u'أَحْكَامٌ خَبَر':Added, #1: 1	أَحْكَامِ الْخَبَرِ
u'أَحْكَامٌ خِتان':Added, #1: 1	أَحْكَامِ الْخَبَرِ
u'أَحْكَامٌ خراج':Added, #1: 1	أَحْكَامِ الْخِتَانَيْنِ
u'أَحْكَامٌ خَرَاجٌ':Added, #1: 1	أَحْكَامُ خَرَاجِهِ
u'أَحْكَامٌ خَطَأٌ':Added, #1: 1	أَحْكَامُ خَرَاجِهِ
u'أَحْكَامٌ خِطَابٌ':Added, #1: 1	أَحْكَامِ الْخَطَأِ
u'أَحْكَامٌ خَلْفِيٌّ':Added, #1: 1	أَحْكَامِ الْخِطَابِ
u'إحْكَامٌ خلقة':Added, #1: 1	أَحْكَامُ الْخَلْفِيَّةِ
u'إحْكَامٌ خِلْقَةٌ':Added, #1: 1	إحْكَامُ الْخِلْقَةِ
u'أَحْكَامٌ خَلْوَةٌ':Added, #1: 1	إحْكَامُ الْخِلْقَةِ
u'أَحْكَامٌ خَمْرٌ':Added, #2: 2	أَحْكَامِ الْخَلْوَةِ
u'أَحْكَامٌ دُخُولٌ':Added, #1: 1	أَحْكَامِ الْخَمْرِ
u'أَحْكَامٌ دِماءٌ':Added, #1: 1	أَحْكَامُ الدُّخُولِ
u'أَحْكَامٌ دِيَةٌ':Added, #2: 2	أَحْكَامِ الدِّمَاءِ
u'أَحْكَامٌ دِيَةٌ':Added, #1: 1	أَحْكَامِ الدّيَاتِ
u'أَحْكَامٌ دِينٌ':Added, #1: 1	أَحْكَامِ الدِّيَةِ
u'أَحْكَامٌ دِينٌ':Added, #10: 10	أَحْكَامِ الدِّينِ
u'أَحْكَامٌ دِينٌ':Added, #1: 1	أَحْكَامَ الدِّينِ
u'أَحْكَامٌ دُيونٌ':Added, #1: 1	أَحْكَامِ دِينِهِ
u'أَحْكَامٌ ذَبائِحُ':Added, #1: 1	أَحْكَامَ الدُّيُونِ
u'أَحْكَامٌ ذكر':Added, #1: 1	أَحْكَامَ الذَّبَائِحِ
u'أَحْكَامٌ ذِكْرٌ':Added, #1: 1	أَحْكَامُ ذِكْرِ
u'أَحْكَامٌ ذِمَّةٌ':Added, #1: 1	أَحْكَامُ ذِكْرِ
u'أَحْكَامٌ ذِمِّيٌّ':Added, #12: 12	أَحْكَامِ الذِّمَّةِ
u'أَحْكَامٌ ذِمِّيٌّ':Added, #1: 1	أَحْكَامُ الذِّمِّيِّ
u'أَحْكَامٌ ذَهَبٌ':Added, #1: 1	أَحْكَامِ الذِّمِّيِّ
u'أَحْكَامٌ رَاكِبٌ':Added, #1: 1	أَحْكَام الذَّهَبِ
u'أَحْكَامٌ رَبِيبَةٌ':Added, #1: 1	أَحْكَامِ الرَّاكِبِ
u'أَحْكَامٌ رِجَالٌ':Added, #1: 1	أَحْكَامُ الرَّبِيبَةِ
u'أَحْكَامٌ رجعة':Added, #3: 3	أَحْكَامِ الرِّجَالِ
u'أَحْكَامٌ رَجْعَةٌ':Added, #1: 1	أَحْكَامِ الرَّجْعَةِ
u'أَحْكَامٌ رُجُوعٌ':Added, #1: 1	أَحْكَامِ الرَّجْعَةِ
u'أَحْكَامٌ رُخَصٌ':Added, #1: 1	أَحْكَامِ الرُّجُوعِ
u'أَحْكَامٌ رَدٌّ':Added, #1: 1	أَحْكَامِ رُخَصِ
u'أَحْكَامٌ رِدَّةٌ':Added, #1: 1	أَحْكَامِ رَدِّ
u'أَحْكَامٌ رضاع':Added, #4: 4	أَحْكَامِ الرِّدَّةِ
u'أَحْكَامٌ رضاع':Added, #2: 2	أَحْكَامِ الرَّضَاعِ
u'أَحْكَامٌ رِقٌّ':Added, #4: 4	أَحْكَامُ الرَّضَاعِ
u'أَحْكَامٌ رِقٌّ':Added, #1: 1	أَحْكَامُ الرِّقِّ
u'أَحْكَامٌ رِقٌّ':Added, #5: 5	أَحْكَامَ الرِّقِّ
u'أَحْكَامٌ رَقيقٌ':Added, #9: 9	أَحْكَامِ الرِّقِّ
u'أَحْكَامٌ رَقيق':Added, #2: 2	أَحْكَامِ الرَّقِيقِ
u'أَحْكَامٌ رِكاز':Added, #2: 2	أَحْكَامِ الرَّقِيقِ
u'أَحْكَامٌ رَمْيٌ':Added, #1: 1	أَحْكَامُ الرِّكَازِ
u'أَحْكَامٌ رَهْنٌ':Added, #1: 1	أَحْكَامِ الرَّمْيِ
u'أَحْكَامٌ رَهْنٌ':Added, #1: 1	أَحْكَامُ الرَّهْنِ
u'أَحْكَامٌ زَرْعٌ':Added, #2: 2	أَحْكَامِ الرَّهْنِ
u'أَحْكَامٌ زَكاةٌ':Added, #1: 1	أَحْكَامِ الزَّرْعِ
u'أَحْكَامٌ زَكاةٌ':Added, #1: 1	أَحْكَامُ الزَّكَاةِ
u'أَحْكَامٌ زَواجٌ':Added, #1: 1	أَحْكَامِ الزَّكَاةِ
u'أَحْكَامٌ زَوْجٌ':Added, #1: 1	أَحْكَامِ زَوَاجِ
u'أَحْكَامٌ زَوْجِيٌّ':Added, #1: 1	أَحْكَامِ الزَّوْجِ
u'أَحْكَامٌ زَوْجِيٌّ':Added, #2: 2	أَحْكَامَ الزَّوْجِيَّةِ
u'أَحْكَامٌ زَوْجِيٌّ':Added, #2: 2	أَحْكَامُ الزَّوْجِيَّةِ
u'أَحْكَامٌ سابّ':Added, #3: 3	أَحْكَامِ الزَّوْجِيَّةِ
u'أَحْكَامٌ سَائِرٌ':Added, #1: 1	أَحْكَامِ السَّابِّ
u'أَحْكَامٌ سَائِرٌ':Added, #1: 1	أَحْكَامَ سَائِرِ
u'أَحْكَامٌ سَائِقٌ':Added, #1: 1	أَحْكَامِ سَائِرِ
u'أَحْكَامٌ سباق':Added, #1: 1	أَحْكَامَ السَّائِقِ
u'أَحْكَامٌ سِبَاقٌ':Added, #1: 1	أَحْكَامِ السِّبَاقِ
u'أَحْكَامٌ سُجُودٌ':Added, #1: 1	أَحْكَامِ السِّبَاقِ
u'أَحْكَامٌ سُجُودٌ':Added, #1: 1	أَحْكَامَ سُجُودِ
u'أَحْكَامٌ سَرقَةٌ':Added, #1: 1	أَحْكَامُ سُجُودِ
u'أَحْكَامٌ سَرِقَةٌ':Added, #1: 1	أَحْكَامَ السَّرِقَةِ
u'أَحْكَامٌ سَفَرٌ':Added, #1: 1	أَحْكَامَ السَّرِقَةِ
u'أَحْكَامٌ سَفِيهٌ':Added, #3: 3	أَحْكَامِ السَّفَرِ
u'أَحْكَامٌ سَفِيهٌ':Added, #1: 1	أَحْكَامُ السَّفِيهِ
u'أَحْكَامٌ سَكْرَان':Added, #1: 1	أَحْكَامِ السَّفِيهِ
u'أَحْكَامٌ سُكُوتٌ':Added, #1: 1	أَحْكَامُ السَّكْرَانِ
u'أَحْكَامٌ سُكُوتٌ':Added, #1: 1	أَحْكَامُ سُكُوتِهِ
u'أَحْكَامٌ سَلاَمَةٌ':Added, #1: 1	أَحْكَامِ سُكُوتِهِ
u'أَحْكَامٌ سَلَمٌ':Added, #1: 1	أَحْكَامَ السَّلَامَةِ
u'أَحْكَامٌ سَهْوٌ':Added, #2: 2	أَحْكَامِ السَّلَمِ
u'أَحْكَامٌ سَهْوٌ':Added, #1: 1	أَحْكَامَ السَّهْوِ
u'أَحْكَامٌ سَهْوٌ':Added, #1: 1	أَحْكَامُ السَّهْوِ
u'أَحْكَامٌ سِياسَةٌ':Added, #3: 3	أَحْكَامِ السَّهْوِ
u'أَحْكَامٌ شَارِعٌ':Added, #1: 1	أَحْكَامِ السِّيَاسَاتِ
u'أَحْكَامٌ شِرَاءٌ':Added, #1: 1	أَحْكَامَ الشَّارِعِ
u'أَحْكَامٌ شِرَاءٌ':Added, #1: 1	أَحْكَامِ الشِّرَاءِ
u'أَحْكَامٌ شِرَاءٌ':Added, #1: 1	أَحْكَامِ شِرَاءِ
u'أَحْكَامٌ شَرَائِعُ':Added, #2: 2	أَحْكَامُ الشِّرَاءِ
u'أَحْكَامٌ شَرَائِعُ':Added, #1: 1	أَحْكَامِ شَرَائِعِ
u'أَحْكَامٌ شرب':Added, #2: 2	أَحْكَامِ الشَّرَائِعِ
u'أَحْكَامٌ شُرْبٌ':Added, #1: 1	أَحْكَامِ الشُّرْبِ
u'أَحْكَامٌ شُرْطَةٌ':Added, #1: 1	أَحْكَامِ الشُّرْبِ
u'أَحْكَامٌ شُرْطَة':Added, #1: 1	أَحْكَامِ الشُّرْطَةِ
u'أَحْكَامٌ شَرْعٌ':Added, #1: 1	أَحْكَامِ الشُّرْطَةِ
u'أَحْكَامٌ شَرْعٌ':Added, #3: 3	أَحْكَامَ الشَّرْعِ
u'أَحْكَامٌ شَرْعٌ':Added, #40: 40	أَحْكَامِ الشَّرْعِ
u'أَحْكَامٌ شَرْعِيٌّ':Added, #7: 7	أَحْكَامُ الشَّرْعِ
u'أَحْكَامٌ شركة':Added, #1: 1	أَحْكَامِ الشَّرْعِيَّةِ
u'أَحْكَامٌ شَرِكَةٌ':Added, #1: 1	أَحْكَامِ الشَّرِكَةِ
u'أَحْكَامٌ شَرِيعَةٌ':Added, #1: 1	أَحْكَامِ الشَّرِكَةِ
u'أَحْكَامٌ شَرِيعَةٌ':Added, #16: 16	أَحْكَامِ الشَّرِيعَةِ
u'أَحْكَامٌ شَرِيعَةٌ':Added, #1: 1	أَحْكَامَ الشَّرِيعَةِ
u'أَحْكَامٌ شَرِيعَةٌ':Added, #1: 1	أَحْكَامُ الشَّرِيعَةِ
u'أَحْكَامٌ شَرِيكٌ':Added, #1: 1	أَحْكَامِ شَرِيعَةِ
u'أَحْكَامٌ شَهَادَةٌ':Added, #1: 1	أَحْكَامِ الشَّرِيكِ
u'أَحْكَامٌ شَهَادَةٌ':Added, #1: 1	أَحْكَامَ الشَّهَادَةِ
u'أَحْكَامٌ شُهُودٌ':Added, #1: 1	أَحْكَامِ الشَّهَادَةِ
u'أَحْكَامٌ صَبِيٌّ':Added, #1: 1	أَحْكَامِ الشُّهُودِ
u'أَحْكَامٌ صِبْيَانٌ':Added, #2: 2	أَحْكَامِ الصَّبِيِّ
u'أَحْكَامٌ صَحِيحٌ':Added, #2: 2	أَحْكَامِ الصِّبْيَانِ
u'أَحْكَامٌ صَحِيحٌ':Added, #2: 2	أَحْكَامُ الصَّحِيحِ
u'أَحْكَامٌ صدقة':Added, #4: 4	أَحْكَامِ الصَّحِيحِ
u'أَحْكَامٌ صَدَقَةٌ':Added, #2: 2	أَحْكَامَ صَدَقَةِ
u'أَحْكَامٌ صغار':Added, #2: 2	أَحْكَامَ صَدَقَةِ
u'أَحْكَامٌ صُفْرَةٌ':Added, #9: 9	أَحْكَامِ الصِّغَارِ
u'إحْكَامٌ صُفُوفٌ':Added, #1: 1	أَحْكَامِ الصُّفْرَةِ
u'أَحْكَامٌ صَلاَةٌ':Added, #1: 1	إحْكَامِ الصُّفُوفِ
u'أَحْكَامٌ صَلاَةٌ':Added, #11: 11	أَحْكَامِ الصَّلَاةِ
u'أَحْكَامٌ صَلاَةٌ':Added, #1: 1	أَحْكَامِ الصَّلاَةِ
u'أَحْكَامٌ صَلاَةٌ':Added, #1: 1	أَحْكَامِ صَلَاةِ
u'أَحْكَامٌ صَلاَةٌ':Added, #1: 1	أَحْكَامِ صَلَاتِهِ
u'أَحْكَامٌ صَلاَةٌ':Added, #2: 2	أَحْكَامُ الصَّلَاةِ
u'أَحْكَامٌ صلح':Added, #7: 7	أَحْكَامَ الصَّلَاةِ
u'أَحْكَامٌ صُلْحٌ':Added, #1: 1	أَحْكَامُ الصُّلْحِ
u'أَحْكَامٌ صلح':Added, #1: 1	أَحْكَامُ الصُّلْحِ
u'أَحْكَامٌ صُلْحٌ':Added, #1: 1	أَحْكَامَ صُلْحِ
u'أَحْكَامٌ صنعة':Added, #1: 1	أَحْكَامَ صُلْحِ
u'أَحْكَامٌ صَنْعَةٌ':Added, #1: 1	أَحْكَامِ الصَّنْعَةِ
u'أَحْكَامٌ صَوْمٌ':Added, #1: 1	أَحْكَامِ الصَّنْعَةِ
u'أَحْكَامٌ صِيَامٌ':Added, #1: 1	أَحْكَامَ الصَّوْمِ
u'أَحْكَامٌ صَيْدٌ':Added, #1: 1	أَحْكَامِ الصِّيَامِ
u'أَحْكَامٌ صِيَغٌ':Added, #1: 1	أَحْكَامِ صَيْدِ
u'أَحْكَامٌ ضَحِيَّةٌ':Added, #1: 1	أَحْكَامِ الصِّيَغِ
u'أَحْكَامٌ ضَمَانٌ':Added, #1: 1	أَحْكَامِ الضَّحِيَّةِ
u'أَحْكَامٌ ضِيَاعٌ':Added, #1: 1	أَحْكَامِ الضَّمَانِ
u'أَحْكَامٌ طَاعَةٌ':Added, #1: 1	أَحْكَامُ الضِّيَاعِ
u'أَحْكَامٌ طَاهِرٌ':Added, #1: 1	أَحْكَامَ طَاعَتِهِ
u'أَحْكَامٌ طَاهِرٌ':Added, #3: 3	أَحْكَامُ الطَّاهِرَاتِ
u'أَحْكَامٌ طَلاَقٌ':Added, #8: 8	أَحْكَامِ الطَّاهِرَاتِ
u'أَحْكَامٌ طَلاَقٌ':Added, #1: 1	أَحْكَامَ الطَّلَاقِ
u'أَحْكَامٌ طَلاَقٌ':Added, #1: 1	أَحْكَامُ الطَّلَاقِ
u'أَحْكَامٌ طَلاَقٌ':Added, #1: 1	أَحْكَامِ الطّلَاقِ
u'أَحْكَامٌ طَلاَقٌ':Added, #1: 1	أَحْكَامُ طَلَاقِهِ
u'أَحْكَامٌ طِهَارَةٌ':Added, #2: 2	أَحْكَامِ الطَّلَاقِ
u'أَحْكَامٌ طَهَارَةٌ':Added, #1: 1	أَحْكَامِ الطِّهَارَاتِ
u'أَحْكَامٌ طَهَارَةٌ':Added, #1: 1	أَحْكَامَ الطَّهَارَةِ
u'أَحْكَامٌ طهر':Added, #1: 1	أَحْكَامِ الطَّهَارَةِ
u'أَحْكَامٌ طُهْرٌ':Added, #1: 1	أَحْكَامِ الطُّهْرِ
u'أَحْكَامٌ طواف':Added, #1: 1	أَحْكَامِ الطُّهْرِ
u'أَحْكَامٌ طَوَافٌ':Added, #1: 1	أَحْكَامَ الطَّوَافِ
u'أَحْكَامٌ عَامِلٌ':Added, #1: 1	أَحْكَامَ الطَّوَافِ
u'أَحْكَامٌ عِبَادٌ':Added, #1: 1	أَحْكَامِ الْعَامِلِ
u'أَحْكَامٌ عِبَادٌ':Added, #1: 1	أَحْكَامُ الْعِبَادِ
u'أَحْكَامٌ عَبْدٌ':Added, #1: 1	أَحْكَامِ الْعِبَادِ
u'أَحْكَامٌ عَبْدٌ':Added, #13: 13	أَحْكَامِ الْعَبْدِ
u'أَحْكَامٌ عَبْدٌ':Added, #2: 2	أَحْكَامُ الْعَبْدِ
u'أَحْكَامٌ عَبِيدٌ':Added, #2: 2	أَحْكَامُ عَبْدٍ
u'أَحْكَامٌ عَبِيدٌ':Added, #1: 1	أَحْكَامُ الْعَبِيدِ
u'أَحْكَامٌ عتق':Added, #1: 1	أَحْكَامِ الْعَبِيدِ
u'أَحْكَامٌ عِتْقٌ':Added, #4: 4	أَحْكَامِ الْعِتْقِ
u'أَحْكَامٌ عِدَّةٌ':Added, #4: 4	أَحْكَامِ الْعِتْقِ
u'أَحْكَامٌ عِدَدٌ':Added, #1: 1	أَحْكَامِ الْعِدَّةِ
u'أَحْكَامٌ عَدْلٌ':Added, #1: 1	أَحْكَامَ الْعِدَدِ
u'أَحْكَامٌ عُدْوَانٌ':Added, #2: 2	أَحْكَامُ الْعَدْلِ
u'أَحْكَامٌ عَرْضٌ':Added, #2: 2	أَحْكَامِ الْعُدْوَانِ
u'أَحْكَامٌ عِشْرَةٌ':Added, #2: 2	أَحْكَامِ الْعَرْضِ
u'أَحْكَامٌ عَقَائِدُ':Added, #1: 1	أَحْكَامِ عِشْرَةِ
u'أَحْكَامٌ عَقْدٌ':Added, #1: 1	أَحْكَامِ الْعَقَائِدِ
u'أَحْكَامٌ عَقْدٌ':Added, #10: 10	أَحْكَامِ الْعَقْدِ
u'أَحْكَامٌ عَقْدٌ':Added, #1: 1	أَحْكَامَ عَقْدِ
u'أَحْكَامٌ عَقْدٌ':Added, #2: 2	أَحْكَامِ عَقْدِ
u'أَحْكَامٌ عَقْدٌ':Added, #3: 3	أَحْكَامَ الْعَقْدِ
u'أَحْكَامٌ عَقْلٌ':Added, #4: 4	أَحْكَامُ الْعَقْدِ
u'أَحْكَامٌ عَقْلٌ':Added, #1: 1	أَحْكَامَ الْعَقْلِ
u'أَحْكَامٌ عُقَلاَءُ':Added, #1: 1	أَحْكَامِ الْعَقْلِ
u'أَحْكَامٌ عُقُودٌ':Added, #1: 1	أَحْكَامُ الْعُقَلَاءِ
u'أَحْكَامٌ عُقُودٌ':Added, #1: 1	أَحْكَامِ عُقُودِ
u'أَحْكَامٌ عِلَّةٌ':Added, #4: 4	أَحْكَامِ الْعُقُودِ
u'أَحْكَامٌ عِلَلٌ':Added, #1: 1	أَحْكَامِ الْعِلَّةِ
u'أَحْكَامٌ عِمَارَةٌ':Added, #3: 3	أَحْكَامِ الْعِلَلِ
u'أَحْكَامٌ عمرة':Added, #1: 1	أَحْكَامِ الْعِمَارَةِ
u'أَحْكَامٌ عمرة':Added, #1: 1	أَحْكَامُ الْعُمْرَةِ
u'أَحْكَامٌ عُمْرَةٌ':Added, #1: 1	أَحْكَامِ الْعُمْرَةِ
u'أَحْكَامٌ عُمْرَةٌ':Added, #1: 1	أَحْكَامُ الْعُمْرَةِ
u'أَحْكَامٌ عَوَارِضُ':Added, #1: 1	أَحْكَامِ الْعُمْرَةِ
u'أَحْكَامٌ عِوَضٌ':Added, #1: 1	أَحْكَامِ عَوَارِضِ
u'أَحْكَامٌ غَاصِبٌ':Added, #1: 1	أَحْكَامِ عِوَضِهِ
u'أَحْكَامٌ غَاصِبٌ':Added, #1: 1	أَحْكَامَ الْغَاصِبِ
u'أَحْكَامٌ غَرْسٌ':Added, #1: 1	أَحْكَامُ الْغَاصِبِ
u'أَحْكَامٌ غُسْلٌ':Added, #1: 1	أَحْكَامِ غَرْسِ
u'إحْكَامٌ غُسْلٌ':Added, #1: 1	أَحْكَامِ الْغُسْلِ
u'أَحْكَامٌ غَصْبٌ':Added, #2: 2	إحْكَامِ الْغُسْلِ
u'أَحْكَامٌ غَصْبٌ':Added, #1: 1	أَحْكَامِ الْغَصْبِ
u'أَحْكَامٌ غَلَبَةٌ':Added, #3: 3	أَحْكَامُ الْغَصْبِ
u'أَحْكَامٌ غَنَائِمُ':Added, #1: 1	أَحْكَامَ غَلَبَةِ
u'أَحْكَامٌ غَنِيمَةٌ':Added, #1: 1	أَحْكَامَ الْغَنَائِمِ
u'أَحْكَامٌ غير':Added, #1: 1	أَحْكَامِ الْغَنِيمَةِ
u'أَحْكَامٌ غَيْرٌ':Added, #1: 1	أَحْكَامَ غَيْرِ
u'أَحْكَامٌ غير':Added, #1: 1	أَحْكَامَ غَيْرِ
u'أَحْكَامٌ غَيْرٌ':Added, #1: 1	أَحْكَامُ غَيْرِهِ
u'أَحْكَامٌ فَاسِقٌ':Added, #1: 1	أَحْكَامُ غَيْرِهِ
u'أَحْكَامٌ فَرْجٌ':Added, #1: 1	أَحْكَامِ الْفَاسِقِ
u'أَحْكَامٌ فَرْجٌ':Added, #1: 1	أَحْكَامُ الْفَرْجِ
u'أَحْكَامٌ فَرْضٌ':Added, #2: 2	أَحْكَامِ الْفَرْجِ
u'أَحْكَامٌ فُرُوعٌ':Added, #1: 1	أَحْكَامَ الْفَرْضِ
u'أَحْكَامٌ فُضُولِيٌّ':Added, #3: 3	أَحْكَامِ الْفُرُوعِ
u'أَحْكَامٌ فِعْلٌ':Added, #1: 1	أَحْكَامِ الْفُضُولِيِّ
u'أَحْكَامٌ فِعْلٌ':Added, #1: 1	أَحْكَامِ الْفِعْلِ
u'إحْكَامٌ فِعْلٌ':Added, #1: 1	أَحْكَامُ فِعْلِ
u'أَحْكَامٌ فِقْهٌ':Added, #2: 2	إحْكَامُ الْفِعْلِ
u'أَحْكَامٌ فلان':Added, #2: 2	أَحْكَامِ الْفِقْهِ
u'أَحْكَامٌ فُلُوسٌ':Added, #3: 3	أَحْكَامِ الْمَسْجِدِيَّةِ
u'أَحْكَامٌ قَبْضٌ':Added, #4: 4	أَحْكَامِ الْفُلُوسِ
u'أَحْكَامٌ قَبْضٌ':Added, #1: 1	أَحْكَامَ قَبْضِ
u'أَحْكَامٌ قتال':Added, #5: 5	أَحْكَامِ الْقَبْضِ
u'أَحْكَامٌ قِتَالٌ':Added, #1: 1	أَحْكَامِ الْقِتَالِ
u'أَحْكَامٌ قتال':Added, #1: 1	أَحْكَامِ الْقِتَالِ
u'أَحْكَامٌ قتال':Added, #1: 1	أَحْكَامُ قِتَالِ
u'أَحْكَامٌ قِتَالٌ':Added, #1: 1	أَحْكَامِ قِتَالِ
u'أَحْكَامٌ قِتَالٌ':Added, #1: 1	أَحْكَامُ قِتَالِ
u'أَحْكَامٌ قتل':Added, #1: 1	أَحْكَامِ قِتَالِ
u'أَحْكَامٌ قَتْلٌ':Added, #1: 1	أَحْكَامَ الْقَتْلِ
u'أَحْكَامٌ قتل':Added, #1: 1	أَحْكَامَ الْقَتْلِ
u'أَحْكَامٌ قَتْلٌ':Added, #1: 1	أَحْكَامُ قَتْلِ
u'أَحْكَامٌ قتل':Added, #1: 1	أَحْكَامُ قَتْلِ
u'أَحْكَامٌ قَتْلٌ':Added, #5: 5	أَحْكَامِ الْقَتْلِ
u'أَحْكَامٌ قِرَاءةٌ':Added, #5: 5	أَحْكَامِ الْقَتْلِ
u'أَحْكَامٌ قراض':Added, #1: 1	أَحْكَامَ الْقِرَاءَةِ
u'أَحْكَامٌ قُرْآنٌ':Added, #2: 2	أَحْكَامِ الْقِرَاضِ
u'أَحْكَامٌ قُرْآنٌ':Added, #1: 1	أَحْكَام الْقُرْآنِ
u'أَحْكَامٌ قُرْآنٌ':Added, #1: 1	أَحْكَامَ الْقُرْآنِ
u'أَحْكَامٌ قُرْآنٌ':Added, #1: 1	أَحْكَامُ الْقُرْآنِ
u'أَحْكَامٌ قَرْضٌ':Added, #54: 54	أَحْكَامِ الْقُرْآنِ
u'أَحْكَامٌ قسمة':Added, #1: 1	أَحْكَامِ الْقَرْضِ
u'أَحْكَامٌ قِسْمَةٌ':Added, #2: 2	أَحْكَامِ قِسْمَةِ
u'أَحْكَامٌ قَضَاءٌ':Added, #2: 2	أَحْكَامِ قِسْمَةِ
u'أَحْكَامٌ قضاة':Added, #9: 9	أَحْكَامِ الْقَضَاءِ
u'أَحْكَامٌ قضاة':Added, #2: 2	أَحْكَامَ الْقُضَاةِ
u'أَحْكَامٌ كَافِرٌ':Added, #2: 2	أَحْكَامِ الْقُضَاةِ
u'أَحْكَامٌ كِتَابٌ':Added, #1: 1	أَحْكَامِ الْكَافِرِ
u'أَحْكَامٌ كِتَابٌ':Added, #1: 1	أَحْكَامُ الْكِتَابِ
u'أَحْكَامٌ كِتَابَةٌ':Added, #1: 1	أَحْكَامِ الْكِتَابِ
u'أَحْكَامٌ كِتَابَةٌ':Added, #3: 3	أَحْكَامَ الْكِتَابَةِ
u'أَحْكَامٌ كُفَّارٌ':Added, #6: 6	أَحْكَامِ الْكِتَابَةِ
u'أَحْكَامٌ كَفَّارٌ':Added, #1: 1	أَحْكَامِ الْكُفَّارِ
u'أَحْكَامٌ كَفَّارٌ':Added, #1: 1	أَحْكَامِ الْكَفَّارَةِ
u'أَحْكَامٌ كُفَّارٌ':Added, #1: 1	أَحْكَامِ كَفَّارَةِ
u'أَحْكَامٌ كَفَّارَةٌ':Added, #2: 2	أَحْكَامُ الْكُفَّارِ
u'أَحْكَامٌ كَفَّارَةٌ':Added, #1: 1	أَحْكَامِ الْكَفَّارَةِ
u'أَحْكَامٌ كَفَالَةٌ':Added, #1: 1	أَحْكَامِ كَفَّارَةِ
u'أَحْكَامٌ كفر':Added, #1: 1	أَحْكَامُ الْكَفَالَةِ
u'أَحْكَامٌ كُفْرٌ':Added, #1: 1	أَحْكَامُ الْكُفْرِ
u'أَحْكَامٌ كفر':Added, #1: 1	أَحْكَامُ الْكُفْرِ
u'أَحْكَامٌ كُفْرٌ':Added, #2: 2	أَحْكَامَ الْكُفْرِ
u'أَحْكَامٌ كفر':Added, #2: 2	أَحْكَامَ الْكُفْرِ
u'أَحْكَامٌ كُفْرٌ':Added, #4: 4	أَحْكَامِ الْكُفْرِ
u'أَحْكَامٌ كَفَنٌ':Added, #4: 4	أَحْكَامِ الْكُفْرِ
u'أَحْكَامٌ كَلاَمٌ':Added, #1: 1	أَحْكَامِ الْكَفَنِ
u'أَحْكَامٌ كَلْبٌ':Added, #3: 3	أَحْكَامِ الْكَلَامِ
u'أَحْكَامٌ كَلِمٌ':Added, #1: 1	أَحْكَامُ الْكَلْبِ
u'أَحْكَامٌ لاَحِقٌ':Added, #1: 1	أَحْكَامَ الْكَلِمِ
u'أَحْكَامٌ لاَمٌ':Added, #1: 1	أَحْكَامِ اللَّاحِقِ
u'أَحْكَامٌ لعان':Added, #1: 1	أَحْكَامِ اللَّامِ
u'أَحْكَامٌ لَفْظٌ':Added, #2: 2	أَحْكَامِ اللِّعَانِ
u'أَحْكَامٌ لَفْظٌ':Added, #1: 1	أَحْكَامَ اللَّفْظِ
u'أَحْكَامٌ لَفْظٌ':Added, #1: 1	أَحْكَامِ اللَّفْظِ
u'أَحْكَامٌ لقطة':Added, #1: 1	أَحْكَامِ اللَّفْظَيْنِ
u'أَحْكَامٌ لقطة':Added, #1: 1	أَحْكَامُ اللُّقَطَةِ
u'أَحْكَامٌ لَقِيطٌ':Added, #1: 1	أَحْكَامِ اللُّقَطَةِ
u'أَحْكَامٌ مَاءٌ':Added, #2: 2	أَحْكَامِ اللَّقِيطِ
u'أَحْكَامٌ مَالِكٌ':Added, #2: 2	أَحْكَامِ الْمَاءِ
u'أَحْكَامٌ مَالِيٌّ':Added, #1: 1	أَحْكَامُ مَالِكٍ
u'أَحْكَامٌ مَالِيٌّ':Added, #1: 1	أَحْكَامَ الْمَالِيَّةِ
u'أَحْكَامٌ مُبَادَلَةٌ':Added, #1: 1	أَحْكَامِ الْمَالِيَّةِ
u'أَحْكَامٌ مُبَاشَرَةٌ':Added, #1: 1	أَحْكَامُ الْمُبَادَلَةِ
u'أَحْكَامٌ مَبِيعٌ':Added, #1: 1	أَحْكَامُ الْمُبَاشَرَةِ
u'أَحْكَامٌ مُتَحَيِّرٌ':Added, #2: 2	أَحْكَامِ الْمَبِيعِ
u'أَحْكَامٌ مُتَّفَقٌ':Added, #1: 1	أَحْكَامِ الْمُتَحَيِّرَةِ
u'أَحْكَامٌ مُتَقَابِلٌ':Added, #1: 1	أَحْكَامٍ مُتَّفَقٍ
u'أَحْكَامٌ مُتَقَابِلٌ':Added, #1: 1	أَحْكَامِ الْمُتَقَابِلَاتِ
u'أَحْكَامٌ مَجْنُونٌ':Added, #1: 1	أَحْكَامَ الْمُتَقَابِلَةِ
u'أَحْكَامٌ مُحَارِبٌ':Added, #3: 3	أَحْكَامُ الْمَجْنُونِ
u'أَحْكَامٌ مُحِبٌّ':Added, #1: 1	أَحْكَامِ الْمُحَارِبِ
u'أَحْكَامٌ مُحَرَّرٌ':Added, #1: 1	أَحْكَامِ الْمُحِبِّ
u'أَحْكَامٌ مَحْرَمٌ':Added, #1: 1	أَحْكَامِ الْمُحَرَّرِ
u'أَحْكَامٌ مُحْرِمٌ':Added, #1: 1	أَحْكَامِ الْمَحْرَمِ
u'أَحْكَامٌ مَحْمُولٌ':Added, #1: 1	أَحْكَامِ الْمُحْرِمِ
u'أَحْكَامٌ مُدَبَّرٌ':Added, #1: 1	أَحْكَامِ الْمَحْمُولِ
u'أَحْكَامٌ مُرْتَدٌّ':Added, #1: 1	أَحْكَامِ الْمُدَبَّرِ
u'أَحْكَامٌ مَرَضٌ':Added, #2: 2	أَحْكَامِ الْمُرْتَدِّ
u'أَحْكَامٌ مَرْهُونٌ':Added, #1: 1	أَحْكَامِ الْمَرَضِ
u'أَحْكَامٌ مُرُورٌ':Added, #1: 1	أَحْكَامِ الْمَرْهُونِ
u'أَحْكَامٌ مَسَاجِدُ':Added, #1: 1	أَحْكَامِ الْمُرُورِ
u'أَحْكَامٌ مَسَاجِدُ':Added, #1: 1	أَحْكَامُ الْمَسَاجِدِ
u'أَحْكَامٌ مَسْأَلَةٌ':Added, #7: 7	أَحْكَامِ الْمَسَاجِدِ
u'أَحْكَامٌ مَسْأَلَةٌ':Added, #1: 1	أَحْكَامِ الْمَسْأَلَةِ
u'أَحْكَامٌ مَسْجِدٌ':Added, #1: 1	أَحْكَامُ مَسْأَلَةِ
u'أَحْكَامٌ مَسْجِدٌ':Added, #11: 11	أَحْكَامِ الْمَسْجِدِ
u'أَحْكَامٌ مَسْجِدٌ':Added, #2: 2	أَحْكَامَ الْمَسْجِدِ
u'أَحْكَامٌ مَسْجِد':Added, #2: 2	أَحْكَامُ الْمَسْجِدِ
u'أَحْكَامٌ مُسْلِمٌ':Added, #3: 3	أَحْكَامِ الْمَسْجِدِيَّةِ
u'أَحْكَامٌ مَشْفُوع':Added, #1: 1	أَحْكَامُ الْمُسْلِمَةِ
u'أَحْكَامٌ مُصْحَفٌ':Added, #1: 1	أَحْكَامِ الْمَشْفُوعِ
u'أَحْكَامٌ مُضَارَبَةٌ':Added, #1: 1	أَحْكَامِ الْمُصْحَفِ
u'أَحْكَامٌ مُطْلَقٌ':Added, #3: 3	أَحْكَامِ الْمُضَارَبَةِ
u'أَحْكَامٌ مَعَادِنُ':Added, #1: 1	أَحْكَامَ مُطْلَقِ
u'أَحْكَامٌ مُعَارَضَةٌ':Added, #1: 1	أَحْكَامِ الْمَعَادِنِ
u'أَحْكَامٌ مُعَامَلَةٌ':Added, #1: 1	أَحْكَامِ الْمُعَارَضَةِ
u'أَحْكَامٌ مُعَامَلَةٌ':Added, #1: 1	أَحْكَامُ الْمُعَامَلَاتِ
u'أَحْكَامٌ مُعْتَادٌ':Added, #3: 3	أَحْكَامِ الْمُعَامَلَاتِ
u'أَحْكَامٌ مُعْتَقٌ':Added, #2: 2	أَحْكَامُ الْمُعْتَادِ
u'أَحْكَامٌ مَعْدُومٌ':Added, #1: 1	أَحْكَامِ الْمُعْتَقَةِ
u'أَحْكَامٌ مَعْذُورٌ':Added, #3: 3	أَحْكَامُ الْمَعْدُومِ
u'أَحْكَامٌ مَعْصِيَةٌ':Added, #1: 1	أَحْكَامُ الْمَعْذُورِ
u'أَحْكَامٌ مَغْصُوب':Added, #1: 1	أَحْكَامِ الْمَعْصِيَةِ
u'أَحْكَامٌ مُكْرَهٌ':Added, #2: 2	أَحْكَامِ الْمَغْصُوبِ
u'أَحْكَامٌ مِلَّةٌ':Added, #1: 1	أَحْكَامِ الْمُكْرَهِ
u'أَحْكَامٌ مِلَّةٌ':Added, #1: 1	أَحْكَامَ الْمِلَّةِ
u'إحْكَامٌ مِلْكٌ':Added, #2: 2	أَحْكَامِ الْمِلَّةِ
u'أَحْكَامٌ مِلْكٌ':Added, #1: 1	إحْكَامُ مِلْكِهِ
u'أَحْكَامٌ مُلُوكٌ':Added, #4: 4	أَحْكَامِ الْمِلْكِ
u'أَحْكَامٌ مَمْلُوكٌ':Added, #1: 1	أَحْكَامِ الْمُلُوكِ
u'أَحْكَامٌ مَنَاسِكُ':Added, #1: 1	أَحْكَامِ الْمَمْلُوكِ
u'أَحْكَامٌ مَهْرٌ':Added, #2: 2	أَحْكَامِ الْمَنَاسِكِ
u'أَحْكَامٌ مُوَافِقٌ':Added, #2: 2	أَحْكَامِ الْمَهْرِ
u'أَحْكَامٌ مَوْتٌ':Added, #1: 1	أَحْكَامِ الْمُوَافِقِ
u'أَحْكَامٌ مَوْتٌ':Added, #1: 1	أَحْكَامِ الْمَوْتِ
u'أَحْكَامٌ مَوْضِعٌ':Added, #1: 1	أَحْكَامَ مَوْتِهِ
u'أَحْكَامٌ مَوْقِفٌ':Added, #1: 1	أَحْكَامِ الْمَوْضِعَيْنِ
u'أَحْكَامٌ مِيَاهٌ':Added, #1: 1	أَحْكَامَ الْمَوْقِفِ
u'أَحْكَامٌ نَاسٌ':Added, #1: 1	أَحْكَامِ الْمِيَاهِ
u'أَحْكَامٌ نَاظِرٌ':Added, #1: 1	أَحْكَامُ النَّاسِ
u'أَحْكَامٌ نَبِيٌّ':Added, #2: 2	أَحْكَامِ النَّاظِرِ
u'أَحْكَامٌ نَجَاسَةٌ':Added, #1: 1	أَحْكَامُ النَّبِيِّ
u'أَحْكَامٌ نَجَسٌ':Added, #2: 2	أَحْكَامِ النَّجَاسَاتِ
u'أَحْكَامٌ نُجُومٌ':Added, #1: 1	أَحْكَامِ النَّجَسِ
u'أَحْكَامٌ نذر':Added, #1: 1	أَحْكَامَ النُّجُومِ
u'أَحْكَامٌ نَذْرٌ':Added, #1: 1	أَحْكَامِ النَّذْرِ
u'أَحْكَامٌ نِساءٌ':Added, #1: 1	أَحْكَامِ النَّذْرِ
u'أَحْكَامٌ نِساءٌ':Added, #1: 1	أَحْكَامَ النِّسَاءِ
u'أَحْكَامٌ نِساءٌ':Added, #1: 1	أَحْكَامُ النِّسَاءِ
u'أَحْكَامٌ نَسَبٌ':Added, #4: 4	أَحْكَامِ النِّسَاءِ
u'أَحْكَامٌ نَسَبٌ':Added, #1: 1	أَحْكَامُ النَّسَبِ
u'أَحْكَامٌ نَسَبٌ':Added, #1: 1	أَحْكَامِ نَسَبِ
u'أَحْكَامٌ نَسَبٌ':Added, #1: 1	أَحْكَامِ نَسَبِهِ
u'إحْكَامٌ نَظَرٌ':Added, #7: 7	أَحْكَامِ النَّسَبِ
u'أَحْكَامٌ نَظَرٌ':Added, #1: 1	إحْكَامِ النَّظَرِ
u'أَحْكَامٌ نفاس':Added, #2: 2	أَحْكَامِ النَّظَرِ
u'أَحْكَامٌ نِفَاسٌ':Added, #3: 3	أَحْكَامِ النِّفَاسِ
u'أَحْكَامٌ نِفَاقٌ':Added, #3: 3	أَحْكَامِ النِّفَاسِ
u'إحْكَامٌ نَقْشٌ':Added, #1: 1	أَحْكَامِ النِّفَاقِ
u'أَحْكَامٌ نُقُودٌ':Added, #1: 1	إحْكَامِ النَّقْشِ
u'أَحْكَامٌ نكاح':Added, #1: 1	أَحْكَامِ النُّقُودِ
u'أَحْكَامٌ نِكَاحٌ':Added, #1: 1	أَحْكَامُ النِّكَاحِ
u'أَحْكَامٌ نكاح':Added, #1: 1	أَحْكَامُ النِّكَاحِ
u'أَحْكَامٌ نِكَاحٌ':Added, #28: 28	أَحْكَامِ النِّكَاحِ
u'أَحْكَامٌ نكاح':Added, #28: 28	أَحْكَامِ النِّكَاحِ
u'أَحْكَامٌ نِكَاحٌ':Added, #2: 2	أَحْكَامَ النِّكَاحِ
u'أَحْكَامٌ نِهَايَةٌ':Added, #2: 2	أَحْكَامَ النِّكَاحِ
u'أَحْكَامٌ نواحي':Added, #1: 1	أَحْكَامِ النِّهَايَةِ
u'أَحْكَامٌ نَوَاحِي':Added, #1: 1	أَحْكَامُ نَوَاحِيهِ
u'أَحْكَامٌ نِيَابَةٌ':Added, #1: 1	أَحْكَامُ نَوَاحِيهِ
u'أَحْكَامٌ نِيَّةٌ':Added, #1: 1	أَحْكَامِ النِّيَابَةِ
u'أَحْكَامٌ هِبَةٌ':Added, #1: 1	أَحْكَامِ النِّيَّةِ
u'أَحْكَامٌ هَدْيٌ':Added, #2: 2	أَحْكَامُ الْهِبَةِ
u'أَحْكَامٌ هَدِيٌّ':Added, #1: 1	أَحْكَامِ الْهَدْيِ
u'أَحْكَامٌ هَدِيَّةٌ':Added, #1: 1	أَحْكَامِ هَدِيَّةِ
u'أَحْكَامٌ وَاجِبٌ':Added, #1: 1	أَحْكَامِ هَدِيَّةِ
u'أَحْكَامٌ وُجُوبٌ':Added, #1: 1	أَحْكَامُ الْوَاجِبِ
u'أَحْكَامٌ وُجُوبٌ':Added, #1: 1	أَحْكَامَ الْوُجُوبِ
u'أَحْكَامٌ وَدِيعٌ':Added, #1: 1	أَحْكَامِ الْوُجُوبِ
u'أَحْكَامٌ وَدِيعَةٌ':Added, #1: 1	أَحْكَامِ وَدِيعَةِ
u'أَحْكَامٌ وَصِيٌّ':Added, #1: 1	أَحْكَامِ وَدِيعَةِ
u'أَحْكَامٌ وَصِيٌّ':Added, #1: 1	أَحْكَامُ الْوَصِيَّةِ
u'أَحْكَامٌ وَصِيَّةٌ':Added, #6: 6	أَحْكَامِ الْوَصِيَّةِ
u'أَحْكَامٌ وَصِيَّةٌ':Added, #1: 1	أَحْكَامُ الْوَصِيَّةِ
u'أَحْكَامٌ وَضْعٌ':Added, #6: 6	أَحْكَامِ الْوَصِيَّةِ
u'أَحْكَامٌ وُضُوءٌ':Added, #5: 5	أَحْكَامِ الْوَضْعِ
u'إحْكَامٌ وُضُوءٌ':Added, #1: 1	أَحْكَامِ الْوُضُوءِ
u'أَحْكَامٌ وَطْءٌ':Added, #2: 2	إحْكَامِ الْوُضُوءِ
u'أَحْكَامٌ وَطْءٌ':Added, #1: 1	أَحْكَامُ الْوَطْءِ
u'أَحْكَامٌ وَطْءٌ':Added, #4: 4	أَحْكَامَ الْوَطْءِ
u'أَحْكَامٌ وَظَائِفُ':Added, #8: 8	أَحْكَامِ الْوَطْءِ
u'أَحْكَامٌ وَقَائِعُ':Added, #1: 1	أَحْكَامِ الْوَظَائِفِ
u'أَحْكَامٌ وَقْتٌ':Added, #4: 4	أَحْكَامِ الْوَقَائِعِ
u'أَحْكَامٌ وَقْفٌ':Added, #1: 1	أَحْكَامِ الْوَقْتِ
u'أَحْكَامٌ وَقْفٌ':Added, #2: 2	أَحْكَامُ الْوَقْفِ
u'أَحْكَامٌ وُقُوعٌ':Added, #5: 5	أَحْكَامِ الْوَقْفِ
u'أَحْكَامٌ وُقُوفٌ':Added, #1: 1	أَحْكَامِ الْوُقُوعِ
u'أَحْكَامٌ وكلاء':Added, #1: 1	أَحْكَامِ الْوُقُوفِ
u'أَحْكَامٌ وَكِيلٌ':Added, #2: 2	أَحْكَامِ الْوُكَلَاءِ
u'أَحْكَامٌ وَلاَءٌ':Added, #4: 4	أَحْكَامِ الْوَكِيلِ
u'أَحْكَامٌ وَلاَءٌ':Added, #1: 1	أَحْكَامِ الْوَلاَءِ
u'أَحْكَامٌ وِلاَدَةٌ':Added, #2: 2	أَحْكَامِ الْوَلَاءِ
u'أَحْكَامٌ وِلاَدَةٌ':Added, #2: 2	أَحْكَامَ الْوِلَادَةِ
u'أَحْكَامٌ وِلاَدَةٌ':Added, #2: 2	أَحْكَامُ الْوِلَادَةِ
u'أَحْكَامٌ وِلاَيَةٌ':Added, #2: 2	أَحْكَامِ الْوِلَادَةِ
u'أَحْكَامٌ ولد':Added, #1: 1	أَحْكَامِ الْوِلَايَاتِ
u'أَحْكَامٌ وَلَدٌ':Added, #1: 1	أَحْكَامِ الْوَلَدِ
u'أَحْكَامٌ ولد':Added, #1: 1	أَحْكَامِ الْوَلَدِ
u'أَحْكَامٌ وَلَدٌ':Added, #1: 1	أَحْكَامَ وَلَدِ
u'أَحْكَامٌ ولد':Added, #1: 1	أَحْكَامَ وَلَدِ
u'أَحْكَامٌ وَلَدٌ':Added, #2: 2	أَحْكَامُ الْوَلَدِ
u'أَحْكَامٌ يَمِينٌ':Added, #2: 2	أَحْكَامُ الْوَلَدِ
u'أَحْكَامٌ يَوْمٌ':Added, #2: 2	أَحْكَامِ الْيَمِينِ
u'أَحْكَمَ أُصولٌ':Predicate, #1: 1	أَحْكَامُ يَوْمِ
u'أَحْكَمَ أَكْثَرُ':Predicate, #2: 2	أَحْكَمَ الْأُصُولَ
u'أَحْكَمَ عُلُومٌ':Predicate, #1: 1	أَحْكَمَ أَكْثَرَ
u'أَحْكَمَ مُحْتَسِبٌ':Subject, #1: 1	أَحْكَمَ عُلُومَ
u'أَحْكَمَ وَجْهٌ':Predicate, #1: 1	أَحْكَمَ مُحْتَسِبٌ
u'أَحَلَّ اِبْنٌ':Predicate, #1: 1	أَحْكَمَ وَجْهَ
u'أَحَلَّ إِتْيانٌ':Predicate, #2: 2	أَحَلَّ ابْنَ
u'أحلاف قُرَيْشٌ':Added, #1: 1	أَحَلَّ إِتْيَانَ
u'أَحْلافٌ قُرَيْشٌ':Added, #1: 1	أَحْلافِ قُرَيْشٍ
u'إِحْلاَلٌ ذَبائِحُ':Added, #1: 1	أَحْلافِ قُرَيْشٍ
u'أَحَلَّ الْمَرْأَةُ':Predicate, #1: 1	إِحْلاَلِ ذَبَائِحِ
u'إِحْلاَلٌ مَيْتٌ':Added, #1: 1	أَحَلَّ الْمَرْأَةَ
u'إِحْلاَلٌ مَيْتَةٌ':Added, #1: 1	إِحْلاَلَ الْمَيْتَةِ
u'إِحْلاَلٌ نكاح':Added, #1: 1	إِحْلاَلَ الْمَيْتَةِ
u'إِحْلاَلٌ نِكَاحٌ':Added, #1: 1	إِحْلاَلِ نِكَاحِ
u'أَحَلَّ بَيْعٌ':Predicate, #1: 1	إِحْلاَلِ نِكَاحِ
u'أَحَلَّ بَيْعٌ':Predicate, #1: 1	أَحَلَّ بَيْعَ
u'أَحَلَّ بَيْنٌ':Predicate, #2: 2	أَحَلَّ الْبَيْعَ
u'أَحَلَّ حَلالٌ':Predicate, #1: 1	أَحَلَّ بَيْنَ
u'أَحَلَّ دِماءٌ':Predicate, #1: 1	أَحَلَّ حَلاَلاً
u'أَحَلَّ رَبُّ':Subject, #1: 1	أَحَلَّ دِمَاءَ
u'أَحَلَّ رَسُولٌ':Subject, #1: 1	أَحَلَّ رَبُّ
u'أَحَلَّ سَلَفٌ':Predicate, #2: 2	أَحَلَّ رَسُولُ
u'أَحَلَّ صِحَّةٌ':Predicate, #2: 2	أَحَلَّ السَّلَفَ
u'أَحَلَّ طِلاَءٌ':Predicate, #1: 1	أَحَلَّ صِحَّةَ
u'أَحْلَفَ رَسُولٌ':Subject, #1: 1	أَحَلَّ الطِّلاَءَ
u'أَحْلَفَ طَالِبٌ':Predicate, #1: 1	أَحْلَفَ رَسُولُ
u'أَحَلَّ مُتْعَةٌ':Predicate, #1: 1	أَحْلَفَ طَالِبَ
u'أَحَلَّ مُحَرَّمٌ':Predicate, #1: 1	أَحَلَّ الْمُتْعَةَ
u'أَحَلَّ مُوَكِّلٌ':Subject, #1: 1	أَحَلَّ الْمُحَرَّمَ
u'أَحَلَّ نفر':Predicate, #1: 1	أَحَلَّ الْمُوَكِّلُ
u'أَحَلَّ نَفْرٌ':Predicate, #1: 1	أَحَلَّ النَّفْرَ
u'أَحَلَّ نكاح':Predicate, #1: 1	أَحَلَّ النَّفْرَ
u'أَحَلَّ نِكَاحٌ':Predicate, #1: 1	أَحَلَّ نِكَاحَ
u'أَحْلَى عند':Predicate, #1: 1	أَحَلَّ نِكَاحَ
u'إحْمَاءٌ زَوْجٌ':Added, #1: 1	أَحْلَى عِنْدَ
u'أَحْنَى جِذْعٌ':Predicate, #1: 1	إحْمَاءِ الزَّوْجِ
u'أَحْوَجَ اِنْكِسارٌ':Subject, #1: 1	أَحْنَى الْجِذْعَ
u'أَحْوَجَ صَاحِبٌ':Predicate, #1: 1	أَحْوَجَ انْكِسَارُهُ
u'أَحْوَجَ نَاسٌ':Predicate, #1: 1	أَحْوَجَ صَاحِبَ
u'إِحْيَاءٌ لَيْلٌ':Added, #2: 2	أَحْوَجَ النَّاسَ
u'إِحْيَاءٌ مَوَاتٌ':Added, #1: 1	إِحْيَاءَ اللَّيْلِ
u'إِحْيَاءٌ مَوَاتٌ':Added, #2: 2	إِحْيَاءِ الْمَوَاتِ
u'أَحْيَا أرْضٌ':Predicate, #3: 3	إِحْيَاءَ الْمَوَاتِ
u'أَحْيَا أَكْثَرُ':Predicate, #1: 1	أَحْيَا الْأَرْضَ
u'أَحْيَا أُمٌّ':Subject, #1: 1	أَحْيَا الْأَكْثَرَ
u'أَحْيَا أَمْرٌ':Predicate, #1: 1	أَحْيَا أُمّهُ
u'أَحْيَا بَعْضٌ':Predicate, #1: 1	أَحْيَا أَمْرَ
u'أَحْيَا ثَالِثٌ':Subject, #1: 1	أَحْيَا بَعْضَ
u'أَحْيَا جَوَانِبُ':Predicate, #1: 1	أَحْيَا ثَالِثٌ
u'أَحْيَا خُمُسٌ':Predicate, #1: 1	أَحْيَا الْجَوَانِبَ
u'أَحْيَا ذِمِّيٌّ':Subject, #1: 1	أَحْيَا خُمُسَ
u'أَحْيَا رَبِيعٌ':Subject, #2: 2	أَحْيَا ذِمِّيٌّ
u'أَحْيَا رَجُلٌ':Subject, #1: 1	أَحْيَا الرَّبِيعُ
u'أَحْيَا سَاقِي':Predicate, #1: 1	أَحْيَا رَجُلٌ
u'أَحْيَا سُفْلٌ':Predicate, #1: 1	أَحْيَا سَاقِيَةً
u'أَحْيَا شَهَادَةٌ':Predicate, #1: 1	أَحْيَا السُّفْلَ
u'أَحْيَا غير':Predicate, #1: 1	أَحْيَا الشَّهَادَةَ
u'أَحْيَا غَيْرٌ':Predicate, #2: 2	أَحْيَا غَيْرَ
u'أَحْيَا غير':Subject, #2: 2	أَحْيَا غَيْرَ
u'أَحْيَا غَيْرٌ':Subject, #1: 1	أَحْيَا غَيْرُهُ
u'أَحْيَا قَتِيلٌ':Predicate, #1: 1	أَحْيَا غَيْرُهُ
u'أَحْيَا لَيْلٌ':Predicate, #1: 1	أَحْيَا قَتِيلَ
u'أَحْيَا لَيْلٌ':Predicate, #1: 1	أَحْيَا لَيْلَةَ
u'أَحْيَا مثل':Subject, #4: 4	أَحْيَا اللَّيْلَ
u'أَحْيَا مِثْلٌ':Subject, #1: 1	أَحْيَا مِثْلُهُ
u'أَحْيَا مُسْلِمٌ':Subject, #1: 1	أَحْيَا مِثْلُهُ
u'أَحْيَا نَاسٌ':Predicate, #1: 1	أَحْيَا الْمُسْلِمُ
u'أَحْيَا نَاسٌ':Subject, #12: 12	أَحْيَا النَّاسَ
u'أَحْيَا نَفْسٌ':Predicate, #1: 1	أَحْيَا النَّاسُ
u'أَحْيَا واحد':Subject, #2: 2	أَحْيَا النَّفْسَ
u'أَحْيَا وَاحِدٌ':Subject, #2: 2	أَحْيَا وَاحِدٌ
u'أَخَافَ أهْلٌ':Predicate, #2: 2	أَحْيَا وَاحِدٌ
u'أَخَافَ رَسُولٌ':Predicate, #4: 4	أَخَافَ أَهْلَ
u'أَخَافَ رفقة':Predicate, #4: 4	أَخَافَ رَسُولَ
u'أَخَافَ رُفْقَةٌ':Predicate, #1: 1	أَخَافَ الرُّفْقَةَ
u'أَخَافَ سَبِيلٌ':Predicate, #1: 1	أَخَافَ الرُّفْقَةَ
u'أَخَافَ طَرِيقٌ':Predicate, #3: 3	أَخَافَ السَّبِيلَ
u'أَخَافَ مَدِينٌ':Predicate, #4: 4	أَخَافَ الطَّرِيقَ
u'أَخَافَ مَدِينَةٌ':Predicate, #2: 2	أَخَافَ الْمَدِينَةَ
u'أَخَافَ مُلُوكٌ':Predicate, #2: 2	أَخَافَ الْمَدِينَةَ
u'إِخْبَارٌ الْمَرْأَةُ':Added, #1: 1	أَخَافَ الْمُلُوكَ
u'أَخَذَ أَبٌ':Subject, #1: 1	إِخْبَارِ الْمَرْأَةِ
u'أَخَذَ اِبْنٌ':Subject, #4: 4	أَخَذَ الْأَبُ
u'أَخَذَ اِجْتِمَاعٌ':Subject, #21: 21	أَخَذَ ابْنُ
u'أَخَذَ أَجْرٌ':Predicate, #1: 1	أَخَذَ اجْتِمَاعُهُ
u'أَخَذَ أُجْرَةٌ':Predicate, #1: 1	أَخَذَ الْأَجْرَ
u'أَخَذَ أَجَمَةٌ':Predicate, #7: 7	أَخَذَ الْأُجْرَةَ
u'أَخَذَ أَجِيرٌ':Subject, #1: 1	أَخَذَ الْأَجَمَةَ
u'أَخَذَ أحَدٌ':Predicate, #1: 1	أَخَذَ أَجِيرُ
u'أَخَذَ أحَدٌ':Subject, #2: 2	أَخَذَ أَحَدَ
u'أَخَذَ أحَدٌ':Subject, #4: 4	أَخَذَ أَحَدُ
u'أَخَذَ أَخٌ':Subject, #7: 7	أَخَذَ أَحَدٌ
u'أَخَذَ أَرْدَأَ':Predicate, #1: 1	أَخَذَ الْأَخُ
u'أَخَذَ أرْضٌ':Predicate, #1: 1	أَخَذَ الْأَرْدَأَ
u'أَخَذَ أرْضٌ':Predicate, #15: 15	أَخَذَ الْأَرْضَ
u'أَخَذَ أَشَدُّ':Predicate, #3: 3	أَخَذَ أَرْضَ
u'أَخَذَ أَشْهَب':Subject, #1: 1	أَخَذَ الْأَشَدَّ
u'أَخَذَ أَصْحَابٌ':Subject, #1: 1	أَخَذَ أَشْهَبُ
u'أَخَذَ أَصْحَابٌ':Subject, #1: 1	أَخَذَ أَصْحَابُ
u'أَخَذَ أَصْحَابٌ':Subject, #1: 1	أَخَذَ أَصْحَابُهُ
u'أَخَذَ أصل':Predicate, #1: 1	أَخَذَ الْأَصْحَابُ
u'أَخَذَ أًصْلٌ':Predicate, #1: 1	أَخَذَ الْأَصْلَ
u'أَخَذَ أُصولٌ':Predicate, #1: 1	أَخَذَ الْأَصْلَ
u'أَخَذَ أفْضَلُ':Predicate, #1: 1	أَخَذَ الْأُصُولَ
u'أَخَذَ أقَلُّ':Predicate, #1: 1	أَخَذَ أَفْضَلَ
u'أَخَذَ أقَلُّ':Predicate, #2: 2	أَخَذَ أَقَلَّ
u'أَخَذَ أكْبَرُ':Subject, #3: 3	أَخَذَ الْأَقَلَّ
u'أَخَذَ أَكْثَرُ':Predicate, #1: 1	أَخَذَ الْأَكْبَرُ
u'أَخَذَ أَكْثَرُ':Subject, #5: 5	أَخَذَ أَكْثَرَ
u'أَخَذَ أَكْثَرُ':Subject, #1: 1	أَخَذَ الْأَكْثَرُ
u'أَخَذَ ألف':Predicate, #4: 4	أَخَذَ أَكْثَرُ
u'أَخَذَ ألْفٌ':Predicate, #2: 2	أَخَذَ أَلْفَ
u'أَخَذَ أَلْفٌ':Predicate, #2: 2	أَخَذَ أَلْفَ
u'أَخَذَ ألف':Predicate, #2: 2	أَخَذَ أَلْفَ
u'أَخَذَ ألْفٌ':Predicate, #7: 7	أَخَذَ الْأَلْفَ
u'أَخَذَ أَلْفٌ':Predicate, #7: 7	أَخَذَ الْأَلْفَ
u'أَخَذَ الْمَرْأَةُ':Predicate, #7: 7	أَخَذَ الْأَلْفَ
u'أَخَذَ المُشْتَرِي':Predicate, #1: 1	أَخَذَ الْمَرْأَةَ
u'أَخَذَ إلَهٌ':Subject, #3: 3	أَخَذَ الْمُشْتَرِيَ
u'أَخَذَ أُمٌّ':Predicate, #1: 1	أَخَذَ الْإِلَهُ
u'أَخَذَ إمَامٌ':Subject, #1: 1	أَخَذَ الْأُمَّ
u'أَخَذَ إمَامٌ':Subject, #12: 12	أَخَذَ الْإِمَامُ
u'أَخَذَ أمَانٌ':Predicate, #1: 1	أَخَذَ الإِمَامُ
u'أَخَذَ أمَةٌ':Predicate, #2: 2	أَخَذَ الْأَمَانَ
u'أَخَذَ آمِرٌ':Subject, #2: 2	أَخَذَ الْأَمَةَ
u'أَخَذَ أَمْوَالٌ':Predicate, #1: 1	أَخَذَ الْآمِرُ
u'أَخَذَ إِناءٌ':Predicate, #4: 4	أَخَذَ أَمْوَالَ
u'أَخَذَ إِناءٌ':Predicate, #1: 1	أَخَذَ الإِنَاءَ
u'أَخَذَ إِنْسانٌ':Subject, #1: 1	أَخَذَ الْإِنَاءَ
u'أَخَذَ إِنْسانٌ':Subject, #1: 1	أَخَذَ الْإِنْسَانُ
u'أَخَذَ أُهْبَةٌ':Predicate, #7: 7	أَخَذَ إنْسَانٌ
u'أَخَذَ أهْلٌ':Subject, #1: 1	أَخَذَ أُهْبَةَ
u'أَخَذَ أَوَّلُ':Predicate, #4: 4	أَخَذَ أَهْلُ
u'أَخَذَ أَوَّلُ':Subject, #1: 1	أَخَذَ الْأَوَّلَ
u'أَخَذَ أَوْلِيَاءُ':Subject, #12: 12	أَخَذَ الْأَوَّلُ
u'أَخَذَ أئِمَّةٌ':Subject, #2: 2	أَخَذَ أَوْلِيَاءُ
u'أَخَذَ باقِي':Predicate, #1: 1	أَخَذَ الْأَئِمَّةُ
u'أَخَذَ باقِي':Predicate, #12: 12	أَخَذَ الْبَاقِيَ
u'أَخَذَ باقِيَةٌ':Predicate, #1: 1	أَخَذَ الْبَاقِيَةَ
u'أَخَذَ بالِغٌ':Subject, #1: 1	أَخَذَ الْبَاقِيَةَ
u'أَخَذَ بَائِعٌ':Predicate, #1: 1	أَخَذَ الْبَالِغُ
u'أَخَذَ بَائِعٌ':Subject, #1: 1	أَخَذَ الْبَائِعَ
u'أَخَذَ بَدَلٌ':Predicate, #13: 13	أَخَذَ الْبَائِعُ
u'أَخَذَ بَدَلٌ':Predicate, #2: 2	أَخَذَ الْبَدَلَ
u'أَخَذَ بَذْرٌ':Predicate, #4: 4	أَخَذَ بَدَلَ
u'أَخَذَ بِشْرٌ':Subject, #1: 1	أَخَذَ بَذْرَ
u'أَخَذَ بِطانَةٌ':Predicate, #1: 1	أَخَذَ بِشْرُ
u'أَخَذَ بَطَلٌ':Predicate, #1: 1	أَخَذَ بِطَانَةَ
u'أَخَذَ بَطْنٌ':Subject, #2: 2	أَخَذَ بَطَلَ
u'أَخَذَ بَعْضٌ':Predicate, #1: 1	أَخَذَ الْبَطْنُ
u'أَخَذَ بَعْضٌ':Subject, #7: 7	أَخَذَ بَعْضَ
u'أَخَذَ بِنْتٌ':Predicate, #27: 27	أَخَذَ بَعْضُ
u'أَخَذَ بَوَّابٌ':Subject, #4: 4	أَخَذَ بِنْتَ
u'أَخَذَ بَيْضَةٌ':Predicate, #1: 1	أَخَذَ الْبَوَّابُ
u'أَخَذَ تَاجٌ':Predicate, #1: 1	أَخَذَ بَيْضَةَ
u'أَخَذَ تَبِيع':Predicate, #1: 1	أَخَذَ تَاجَ
u'أَخَذَ تُرَابٌ':Predicate, #1: 1	أَخَذَ التَّبِيعَ
u'أَخَذَ تَرِكَةٌ':Predicate, #3: 3	أَخَذَ التُّرَابَ
u'أَخَذَ تَرِكَةٌ':Predicate, #1: 1	أَخَذَ التَّرِكَةَ
u'أَخَذَ تَعْمِيمٌ':Predicate, #2: 2	أَخَذَ تَرِكَةَ
u'أَخَذَ تَفْسِيرٌ':Predicate, #1: 1	أَخَذَ التَّعْمِيمَ
u'أَخَذَ تَقْيِيد':Predicate, #1: 1	أَخَذَ التَّفْسِيرَ
u'أَخَذَ تمام':Predicate, #2: 2	أَخَذَ التَّقْيِيدَ
u'أَخَذَ تَمامٌ':Predicate, #2: 2	أَخَذَ تَمَامَ
u'أَخَذَ ثَالِثٌ':Predicate, #2: 2	أَخَذَ تَمَامَ
u'أَخَذَ ثَالِثٌ':Predicate, #1: 1	أَخَذَ الثَّالِثَ
u'أَخَذَ ثَالِثٌ':Subject, #1: 1	أَخَذَ الثَّالِثَةَ
u'أَخَذَ ثَانِي':Predicate, #2: 2	أَخَذَ الثَّالِثُ
u'أَخَذَ ثَدْيٌ':Predicate, #1: 1	أَخَذَ الثَّانِيَ
u'أَخَذَ ثَلاثَةٌ':Predicate, #1: 1	أَخَذَ الثَّدْيَ
u'أَخَذَ ثَلاثَةٌ':Predicate, #1: 1	أَخَذَ ثَلاثَةَ
u'أَخَذَ ثَلاثَةٌ':Predicate, #1: 1	أَخَذَ ثَلَاثَةَ
u'أَخَذَ ثَمَنٌ':Predicate, #2: 2	أَخَذَ الثَّلَاثَةَ
u'أَخَذَ ثَمَنٌ':Predicate, #15: 15	أَخَذَ الثَّمَنَ
u'أَخَذَ ثَنِيَّةٌ':Predicate, #1: 1	أَخَذَ ثَمَنَ
u'أَخَذَ ثَوْبٌ':Predicate, #1: 1	أَخَذَ الثَّنِيَّةَ
u'أَخَذَ ثَوْبٌ':Predicate, #27: 27	أَخَذَ الثَّوْبَ
u'أَخَذَ ثِيابٌ':Predicate, #3: 3	أَخَذَ ثَوْبَ
u'أَخَذَ جَارٌ':Subject, #1: 1	أَخَذَ الثِّيَابَ
u'أَخَذَ جَارِي':Predicate, #1: 1	أَخَذَ الْجَارُ
u'أَخَذَ جَارِيَةٌ':Predicate, #22: 22	أَخَذَ الْجَارِيَةَ
u'أَخَذَ جَازٌ':Predicate, #22: 22	أَخَذَ الْجَارِيَةَ
u'أَخَذَ جَائِزٌ':Predicate, #3: 3	أَخَذَ جَازَ
u'أَخَذَ جَائِزَةٌ':Predicate, #1: 1	أَخَذَ جَائِزَةَ
u'أَخَذَ جَرِيدٌ':Predicate, #1: 1	أَخَذَ جَائِزَةَ
u'أَخَذَ جِزْيَةٌ':Predicate, #1: 1	أَخَذَ جَرِيدَةً
u'أَخَذَ جلد':Predicate, #8: 8	أَخَذَ الْجِزْيَةَ
u'أَخَذَ جِلْدٌ':Predicate, #1: 1	أَخَذَ الْجِلْدَ
u'أَخَذَ جلد':Predicate, #1: 1	أَخَذَ الْجِلْدَ
u'أَخَذَ جِلْدٌ':Predicate, #1: 1	أَخَذَ جِلْدَ
u'أَخَذَ جَمَاعَةٌ':Subject, #1: 1	أَخَذَ جِلْدَ
u'أَخَذَ جَمْعٌ':Subject, #2: 2	أَخَذَ جَمَاعَةٌ
u'أَخَذَ جُمْهُورٌ':Subject, #1: 1	أَخَذَ جَمْعٌ
u'أَخَذَ جَمِيع':Predicate, #3: 3	أَخَذَ جُمْهُورُ
u'أَخَذَ جَمِيع':Subject, #9: 9	أَخَذَ الْجَمِيعَ
u'أَخَذَ جُنْدِيٌّ':Subject, #1: 1	أَخَذَ الْجَمِيعُ
u'أَخَذَ جِنْسٌ':Predicate, #1: 1	أَخَذَ جُنْدِيٌّ
u'أَخَذَ حاجٌّ':Subject, #7: 7	أَخَذَ جِنْسَ
u'أَخَذَ حاضِرٌ':Subject, #2: 2	أَخَذَ الْحَاجُّ
u'أَخَذَ حاكِمٌ':Subject, #3: 3	أَخَذَ الْحَاضِرُ
u'أَخَذَ حِجَّةٌ':Predicate, #2: 2	أَخَذَ الْحَاكِمُ
u'أَخَذَ حَجَرٌ':Predicate, #1: 1	أَخَذَ الْحِجَّةَ
u'أَخَذَ حَديثٌ':Predicate, #1: 1	أَخَذَ الْحَجَرَ
u'أَخَذَ حَرْبَةٌ':Predicate, #1: 1	أَخَذَ الْحَدِيثَ
u'أَخَذَ حسام':Subject, #2: 2	أَخَذَ الْحَرْبَةَ
u'أَخَذَ حُسَامٌ':Subject, #1: 1	أَخَذَ حُسَامُ
u'أَخَذَ حَسَنٌ':Subject, #1: 1	أَخَذَ حُسَامُ
u'أَخَذَ حُظُوظٌ':Predicate, #7: 7	أَخَذَ الْحَسَنُ
u'أَخَذَ حَفْنَةٌ':Predicate, #1: 1	أَخَذَ حُظُوظَ
u'أَخَذَ حَفْنَةٌ':Predicate, #1: 1	أَخَذَ الْحَفْنَةَ
u'أَخَذَ حَقٌّ':Predicate, #1: 1	أَخَذَ حَفْنَةَ
u'أَخَذَ حِقَاقٌ':Predicate, #1: 1	أَخَذَ الْحَقَّ
u'أَخَذَ حُكْمٌ':Predicate, #1: 1	أَخَذَ الْحِقَاقَ
u'أَخَذَ حَلالٌ':Subject, #5: 5	أَخَذَ حُكْمَ
u'أَخَذَ حَلْقَةٌ':Predicate, #4: 4	أَخَذَ حَلَالٌ
u'أَخَذَ حُلْقُومٌ':Predicate, #1: 1	أَخَذَ الْحَلْقَةَ
u'أَخَذَ حَلْوانِيٌّ':Subject, #1: 1	أَخَذَ حُلْقُومَ
u'أَخَذَ حِنْطَةٌ':Predicate, #2: 2	أَخَذَ الْحَلْوَانِيُّ
u'أَخَذَ حُوتٌ':Subject, #1: 1	أَخَذَ الْحِنْطَةَ
u'أَخَذَ خَادِمٌ':Predicate, #1: 1	أَخَذَ حُوتٌ
u'أَخَذَ خراج':Predicate, #1: 1	أَخَذَ الْخَادِمَ
u'أَخَذَ خَرَاجٌ':Predicate, #1: 1	أَخَذَ الْخَرَاجَ
u'أَخَذَ خَطٌّ':Predicate, #1: 1	أَخَذَ الْخَرَاجَ
u'أَخَذَ خُفٌّ':Predicate, #1: 1	أَخَذَ الْخَطَّ
u'أَخَذَ خلق':Predicate, #3: 3	أَخَذَ الْخُفَّ
u'أَخَذَ خَلْقٌ':Predicate, #1: 1	أَخَذَ الْخَلْقَ
u'أَخَذَ خَمْرٌ':Predicate, #1: 1	أَخَذَ الْخَلْقَ
u'أَخَذَ خَمْسٌ':Predicate, #1: 1	أَخَذَ الْخَمْرَ
u'أَخَذَ خُمُسٌ':Predicate, #1: 1	أَخَذَ خَمْسَ
u'أَخَذَ خُمُسٌ':Predicate, #3: 3	أَخَذَ الْخُمُسَ
u'أَخَذَ خوارج':Subject, #5: 5	أَخَذَ خُمُسَ
u'أَخَذَ خَوَارِجُ':Subject, #4: 4	أَخَذَ الْخَوَارِجُ
u'أَخَذَ دَابَّةٌ':Predicate, #4: 4	أَخَذَ الْخَوَارِجُ
u'أَخَذَ دَابَّةٌ':Predicate, #2: 2	أَخَذَ الدَّابَّةَ
u'أَخَذَ دَارٌ':Predicate, #2: 2	أَخَذَ دَابَّةَ
u'أَخَذَ دَجاج':Predicate, #14: 14	أَخَذَ الدَّارَ
u'أَخَذَ دَرَاهِمُ':Predicate, #2: 2	أَخَذَ الدَّجَاجَةَ
u'أَخَذَ دَقيقٌ':Predicate, #3: 3	أَخَذَ الدَّرَاهِمَ
u'أَخَذَ دَلالَةٌ':Predicate, #1: 1	أَخَذَ الدَّقِيقَ
u'أَخَذَ دَمٌ':Predicate, #1: 1	أَخَذَ الدَّلَالَةَ
u'أَخَذَ دَهْرٌ':Subject, #1: 1	أَخَذَ الدَّمَ
u'أَخَذَ دونٌ':Predicate, #1: 1	أَخَذَ الدَّهْرُ
u'أَخَذَ دِيَةٌ':Predicate, #4: 4	أَخَذَ دُونَ
u'أَخَذَ دِيَةٌ':Predicate, #1: 1	أَخَذَ الدّيَةَ
u'أَخَذَ دِيَةٌ':Predicate, #22: 22	أَخَذَ الدِّيَةَ
u'أَخَذَ دَيْنٌ':Predicate, #5: 5	أَخَذَ دِيَةَ
u'أَخَذَ ذُبابٌ':Predicate, #3: 3	أَخَذَ الدَّيْنَ
u'أَخَذَ ذِراعٌ':Predicate, #1: 1	أَخَذَ الذُّبَابَ
u'أَخَذَ ذُرِّيَّةٌ':Predicate, #1: 1	أَخَذَ الذِّرَاعَ
u'أَخَذَ ذِمَارٌ':Predicate, #2: 2	أَخَذَ الذُّرِّيَّةَ
u'أَخَذَ رَأْسٌ':Predicate, #1: 1	أَخَذَ ذِمَارَ
u'أَخَذَ رَاهِنٌ':Subject, #1: 1	أَخَذَ رَأْسَ
u'أَخَذَ رايَة':Predicate, #5: 5	أَخَذَ الرَّاهِنُ
u'أَخَذَ رايَة':Predicate, #3: 3	أَخَذَ الرّايَةَ
u'أَخَذَ رَبُّ':Subject, #7: 7	أَخَذَ الرَّايَةَ
u'أَخَذَ رَبُّ':Subject, #14: 14	أَخَذَ رَبُّ
u'أَخَذَ رُبْعٌ':Predicate, #5: 5	أَخَذَ رَبُّهُ
u'أَخَذَ رُبُعٌ':Predicate, #2: 2	أَخَذَ الرُّبْعَ
u'أَخَذَ رَجُلٌ':Predicate, #2: 2	أَخَذَ رُبُعَ
u'أَخَذَ رَجُلٌ':Subject, #1: 1	أَخَذَ رَجُلاً
u'أَخَذَ رَجُلٌ':Subject, #12: 12	أَخَذَ رَجُلٌ
u'أَخَذَ رَدْغَة':Predicate, #1: 1	أَخَذَ الرَّجُلُ
u'أَخَذَ رَدِيءٌ':Predicate, #1: 1	أَخَذَ الرَّدْغَةَ
u'أَخَذَ رِزْقٌ':Predicate, #1: 1	أَخَذَ الرَّدِيءَ
u'أَخَذَ رَسُولٌ':Predicate, #3: 3	أَخَذَ الرِّزْقَ
u'أَخَذَ رَسُولٌ':Subject, #3: 3	أَخَذَ رَسُولَ
u'أَخَذَ رَسُولٌ':Subject, #1: 1	أَخَذَ الرَّسُولُ
u'أَخَذَ رَسُولٌ':Subject, #1: 1	أَخَذَ رَسُولُهُ
u'أَخَذَ رَقيقٌ':Subject, #28: 28	أَخَذَ رَسُولُ
u'أَخَذَ رَقيق':Subject, #1: 1	أَخَذَ الرَّقِيقُ
u'أَخَذَ رَهْنٌ':Predicate, #1: 1	أَخَذَ الرَّقِيقُ
u'أَخَذَ رُومِيٌّ':Subject, #7: 7	أَخَذَ الرَّهْنَ
u'أَخَذَ زُفَرٌ':Subject, #1: 1	أَخَذَ الرُّومِيُّ
u'أَخَذَ زَكاةٌ':Predicate, #5: 5	أَخَذَ زُفَرُ
u'أَخَذَ زَوْجٌ':Subject, #6: 6	أَخَذَ الزَّكَاةَ
u'أَخَذَ زِيادَةٌ':Predicate, #12: 12	أَخَذَ الزَّوْجُ
u'أَخَذَ زَيْدٌ':Subject, #7: 7	أَخَذَ الزِّيَادَةَ
u'أَخَذَ زُيوفٌ':Predicate, #1: 1	أَخَذَ زَيْدُ
u'أَخَذَ زُيُوفٌ':Predicate, #1: 1	أَخَذَ الزُّيُوفَ
u'أَخَذَ سَابِقٌ':Subject, #1: 1	أَخَذَ الزُّيُوفَ
u'أَخَذَ سَارِقٌ':Predicate, #1: 1	أَخَذَ السَّابِقُ
u'أَخَذَ سَارِقٌ':Subject, #1: 1	أَخَذَ السَّارِقَ
u'أَخَذَ سَاعِي':Predicate, #1: 1	أَخَذَ السَّارِقُ
u'أَخَذَ سَاقٌ':Predicate, #1: 1	أَخَذَ السَّاعِيَ
u'أَخَذَ سَاكِتٌ':Subject, #2: 2	أَخَذَ السَّاقَ
u'أَخَذَ سَبَبٌ':Subject, #1: 1	أَخَذَ السَّاكِتُ
u'أَخَذَ سَبُعٌ':Subject, #1: 1	أَخَذَ السَّبَبُ
u'أَخَذَ سَبَقٌ':Predicate, #1: 1	أَخَذَ السَّبُعُ
u'أَخَذَ سَبَقٌ':Predicate, #1: 1	أَخَذَ السَّبَقَ
u'أَخَذَ سَبَلٌ':Subject, #1: 1	أَخَذَ سَبَقَ
u'أَخَذَ سِجِلٌّ':Predicate, #1: 1	أَخَذَ السّبَلُ
u'أَخَذَ سِعَايَةٌ':Predicate, #1: 1	أَخَذَ السِّجِلَّ
u'أَخَذَ سَعْدٌ':Subject, #1: 1	أَخَذَ السِّعَايَةَ
u'أَخَذَ سَعْدٌ':Subject, #1: 1	أَخَذَ سَعْدٌ
u'أَخَذَ سَعِيدٌ':Subject, #1: 1	أَخَذَ سَعْدُ
u'أَخَذَ سقط':Predicate, #1: 1	أَخَذَ سَعِيدُ
u'أَخَذَ سَقَطٌ':Predicate, #1: 1	أَخَذَ سَقَطَ
u'أَخَذَ سِكِّينٌ':Predicate, #1: 1	أَخَذَ سَقَطَ
u'أَخَذَ سَلَبٌ':Predicate, #1: 1	أَخَذَ السِّكِّينَ
u'أَخَذَ سُلْطَانٌ':Subject, #1: 1	أَخَذَ سَلَبَ
u'أَخَذَ سِلْعَةٌ':Predicate, #4: 4	أَخَذَ السُّلْطَانُ
u'أَخَذَ سِمْسَارٌ':Subject, #2: 2	أَخَذَ السِّلْعَةَ
u'أَخَذَ سِمْسِم':Predicate, #1: 1	أَخَذَ السِّمْسَارُ
u'أَخَذَ سَمَكٌ':Predicate, #1: 1	أَخَذَ سِمْسِمَةً
u'أَخَذَ سَمَكٌ':Predicate, #1: 1	أَخَذَ السَّمَكَ
u'أَخَذَ سُوقٌ':Predicate, #3: 3	أَخَذَ سَمَكَةً
u'أَخَذَ سَيِّدٌ':Subject, #2: 2	أَخَذَ سُوقَ
u'أَخَذَ سَيِّدٌ':Subject, #1: 1	أَخَذَ سَيِّدُهُ
u'أَخَذَ سَيْفٌ':Predicate, #3: 3	أَخَذَ السَّيِّدُ
u'أَخَذَ سَيْفٌ':Predicate, #1: 1	أَخَذَ السَّيْفَ
u'أَخَذَ شَاةٌ':Predicate, #1: 1	أَخَذَ السّيْفَ
u'أَخَذَ شَارِبٌ':Predicate, #2: 2	أَخَذَ الشَّاةَ
u'أَخَذَ شَارِحٌ':Subject, #1: 1	أَخَذَ شَارِبَ
u'أَخَذَ شَاعِر':Subject, #1: 1	أَخَذَ الشَّارِحُ
u'أَخَذَ شافِعِيّ':Subject, #1: 1	أَخَذَ الشَّاعِرُ
u'أَخَذَ شَاهِدٌ':Predicate, #25: 25	أَخَذَ الشَّافِعِيُّ
u'أَخَذَ شَاهِدٌ':Predicate, #1: 1	أَخَذَ الشَّاهِدَ
u'أَخَذَ شَبابٌ':Predicate, #1: 1	أَخَذَ شَاهِدَ
u'أَخَذَ شَبَابٌ':Predicate, #1: 1	أَخَذَ شَبَابَ
u'أَخَذَ شَبَهٌ':Predicate, #1: 1	أَخَذَ شَبَابَ
u'أَخَذَ شَبَهٌ':Subject, #3: 3	أَخَذَ الشَّبَهَ
u'أَخَذَ شَخْصٌ':Subject, #1: 1	أَخَذَ الشَّبَهُ
u'أَخَذَ شَرْطٌ':Predicate, #2: 2	أَخَذَ شَخْصٌ
u'أَخَذَ شَرِيكٌ':Subject, #1: 1	أَخَذَ الشَّرْطَ
u'أَخَذَ شَرِيكٌ':Subject, #1: 1	أَخَذَ شَرِيكُهُ
u'أَخَذَ شَعْرٌ':Predicate, #4: 4	أَخَذَ الشَّرِيكُ
u'أَخَذَ شفعة':Predicate, #1: 1	أَخَذَ شَعْرَ
u'أَخَذَ شُفْعَةٌ':Predicate, #3: 3	أَخَذَ الشُّفْعَةَ
u'أَخَذَ شَفِيعٌ':Subject, #3: 3	أَخَذَ الشُّفْعَةَ
u'أَخَذَ شَفِيعٌ':Subject, #2: 2	أَخَذَ شَفِيعُهُ
u'أَخَذَ شِقٌّ':Predicate, #33: 33	أَخَذَ الشَّفِيعُ
u'أَخَذَ شمس':Subject, #1: 1	أَخَذَ شِقَّ
u'أَخَذَ شَمْسٌ':Subject, #7: 7	أَخَذَ شَمْسُ
u'أَخَذَ شَيْءٌ':Predicate, #7: 7	أَخَذَ شَمْسُ
u'أَخَذَ شَيْخٌ':Subject, #1: 1	أَخَذَ الشَّيْءَ
u'أَخَذَ شَيْخٌ':Subject, #3: 3	أَخَذَ شَيْخُ
u'أَخَذَ شُيُوخٌ':Subject, #7: 7	أَخَذَ الشَّيْخُ
u'أَخَذَ صَاحِبٌ':Subject, #1: 1	أَخَذَ الشُّيُوخُ
u'أَخَذَ صَاحِبٌ':Subject, #20: 20	أَخَذَ صَاحِبُ
u'أَخَذَ صَامِتٌ':Predicate, #6: 6	أَخَذَ صَاحِبُهُ
u'أَخَذَ صَانِعٌ':Subject, #1: 1	أَخَذَ الصَّامِتَ
u'أَخَذَ صَائِدٌ':Subject, #1: 1	أَخَذَ الصَّانِعُ
u'أَخَذَ صَائِمٌ':Subject, #2: 2	أَخَذَ الصَّائِدُ
u'أَخَذَ صَحَابَةٌ':Subject, #1: 1	أَخَذَ الصَّائِمُ
u'أَخَذَ صَحِيفَةٌ':Predicate, #1: 1	أَخَذَ الصَّحَابَةُ
u'أَخَذَ صَحِيفَةٌ':Predicate, #1: 1	أَخَذَ الصّحِيفَةَ
u'أَخَذَ صَحِيفَةٌ':Subject, #2: 2	أَخَذَ الصَّحِيفَةَ
u'أَخَذَ صَدْرٌ':Subject, #1: 1	أَخَذَ الصَّحِيفَةُ
u'أَخَذَ صدقة':Predicate, #8: 8	أَخَذَ الصَّدْرُ
u'أَخَذَ صَدَقَةٌ':Predicate, #6: 6	أَخَذَ الصَّدَقَةَ
u'أَخَذَ صَرَاحَةٌ':Predicate, #6: 6	أَخَذَ الصَّدَقَةَ
u'أَخَذَ صَغِيرٌ':Predicate, #1: 1	أَخَذَ صَرَاحَةَ
u'أَخَذَ صَفَّارٌ':Subject, #2: 2	أَخَذَ الصَّغِيرَ
u'أَخَذَ صِفَةٌ':Predicate, #2: 2	أَخَذَ الصَّفَّارُ
u'أَخَذَ صَيْدٌ':Predicate, #1: 1	أَخَذَ صِفَةَ
u'أَخَذَ ضَالٌّ':Predicate, #11: 11	أَخَذَ الصَّيْدَ
u'أَخَذَ ضَمَانٌ':Predicate, #2: 2	أَخَذَ ضَالَّةً
u'أَخَذَ ضَيْعَةٌ':Predicate, #3: 3	أَخَذَ الضَّمَانَ
u'أَخَذَ طَالِبٌ':Subject, #1: 1	أَخَذَ الضَّيْعَةَ
u'أَخَذَ طَائِرٌ':Subject, #7: 7	أَخَذَ الطَّالِبُ
u'أَخَذَ طَائِفٌ':Predicate, #1: 1	أَخَذَ الطَّائِرُ
u'أَخَذَ طرف':Predicate, #1: 1	أَخَذَ طَائِفَةً
u'أَخَذَ طَرَفٌ':Predicate, #1: 1	أَخَذَ طَرَفَ
u'أَخَذَ طَرِيقٌ':Predicate, #1: 1	أَخَذَ طَرَفَ
u'أَخَذَ طعام':Predicate, #5: 5	أَخَذَ طَرِيقَ
u'أَخَذَ طَعَامٌ':Predicate, #6: 6	أَخَذَ الطَّعَامَ
u'أَخَذَ طَلاَقٌ':Predicate, #6: 6	أَخَذَ الطَّعَامَ
u'أَخَذَ ظالِمٌ':Subject, #1: 1	أَخَذَ الطَّلَاقَ
u'أَخَذَ ظَبْيٌ':Predicate, #1: 1	أَخَذَ ظَالِمٌ
u'أَخَذَ ظُفْرٌ':Predicate, #1: 1	أَخَذَ الظَّبْيَةَ
u'أَخَذَ ظِلٌّ':Subject, #1: 1	أَخَذَ الظُّفْرَ
u'أَخَذَ ظلمة':Subject, #5: 5	أَخَذَ الظِّلُّ
u'أَخَذَ عَاشِرٌ':Subject, #1: 1	أَخَذَ الظَّلَمَةُ
u'أَخَذَ عَامٌّ':Subject, #3: 3	أَخَذَ الْعَاشِرُ
u'أَخَذَ عَامِلٌ':Subject, #21: 21	أَخَذَ عَامَّةُ
u'أَخَذَ عَامِّيٌّ':Subject, #8: 8	أَخَذَ الْعَامِلُ
u'أَخَذَ عَبْدٌ':Predicate, #2: 2	أَخَذَ الْعَامِّيُّ
u'أَخَذَ عَبْدٌ':Predicate, #18: 18	أَخَذَ الْعَبْدَ
u'أَخَذَ عَبْدٌ':Subject, #1: 1	أَخَذَ عَبْدَ
u'أَخَذَ عَبْدٌ':Subject, #3: 3	أَخَذَ الْعَبْدُ
u'أَخَذَ عتق':Predicate, #3: 3	أَخَذَ عَبْدُ
u'أَخَذَ عَدُوٌّ':Subject, #1: 1	أَخَذَ عَتَقَ
u'أَخَذَ عَرْصَةٌ':Predicate, #1: 1	أَخَذَ الْعَدُوُّ
u'أَخَذَ عُرُوضٌ':Predicate, #1: 1	أَخَذَ الْعَرْصَةَ
u'أَخَذَ عَسْكَرٌ':Subject, #1: 1	أَخَذَ الْعُرُوضَ
u'أَخَذَ عُشْرٌ':Predicate, #1: 1	أَخَذَ الْعَسْكَرُ
u'أَخَذَ عُشْرٌ':Predicate, #2: 2	أَخَذَ عُشْرَ
u'أَخَذَ عَصًا':Subject, #4: 4	أَخَذَ الْعُشْرَ
u'أَخَذَ عِصَامٌ':Subject, #1: 1	أَخَذَ عَصَاهُ
u'أَخَذَ عصبة':Subject, #1: 1	أَخَذَ عِصَامٌ
u'أَخَذَ عَصَبَةٌ':Subject, #1: 1	أَخَذَ الْعَصَبَةُ
u'أَخَذَ عصبة':Subject, #1: 1	أَخَذَ الْعَصَبَةُ
u'أَخَذَ عَصَبَةٌ':Subject, #1: 1	أَخَذَ عَصَبَةُ
u'أَخَذَ عُضْوٌ':Predicate, #1: 1	أَخَذَ عَصَبَةُ
u'أَخَذَ عقبة':Predicate, #2: 2	أَخَذَ عُضْوَ
u'أَخَذَ عَقَبَةٌ':Predicate, #1: 1	أَخَذَ الْعَقَبَةَ
u'أَخَذَ عَلْقَم':Subject, #1: 1	أَخَذَ الْعَقَبَةَ
u'أَخَذَ عَلْقَمَة':Subject, #3: 3	أَخَذَ عَلْقَمَةُ
u'أَخَذَ علم':Predicate, #3: 3	أَخَذَ عَلْقَمَةُ
u'أَخَذَ عِلْمٌ':Predicate, #2: 2	أَخَذَ الْعِلْمَ
u'أَخَذَ علماء':Subject, #2: 2	أَخَذَ الْعِلْمَ
u'أَخَذَ عُلَمَاءُ':Subject, #1: 1	أَخَذَ الْعُلَمَاءُ
u'أَخَذَ علماء':Subject, #1: 1	أَخَذَ الْعُلَمَاءُ
u'أَخَذَ عُلَمَاءُ':Subject, #2: 2	أَخَذَ عُلَمَاءُ
u'أَخَذَ عَلِيٌّ':Subject, #2: 2	أَخَذَ عُلَمَاءُ
u'أَخَذَ عَمٌّ':Subject, #1: 1	أَخَذَ عَلِيٌّ
u'أَخَذَ عِمَامَةٌ':Predicate, #1: 1	أَخَذَ الْعَمُّ
u'أَخَذَ عُمَرٌ':Subject, #5: 5	أَخَذَ عِمَامَةَ
u'أَخَذَ عَنَانٌ':Predicate, #4: 4	أَخَذَ عُمَرُ
u'أَخَذَ عند':Predicate, #2: 2	أَخَذَ عَنَانَ
u'أَخَذَ عَهْدٌ':Predicate, #1: 1	أَخَذَ عِنْدَ
u'أَخَذَ عِوَضٌ':Predicate, #1: 1	أَخَذَ الْعَهْدَ
u'أَخَذَ عِوَضٌ':Predicate, #1: 1	أَخَذَ الْعِوَضَ
u'أَخَذَ عين':Predicate, #2: 2	أَخَذَ عِوَضَ
u'أَخَذَ عَيْنٌ':Predicate, #3: 3	أَخَذَ عَيْنَ
u'أَخَذَ عَيْن':Predicate, #3: 3	أَخَذَ عَيْنَ
u'أَخَذَ عين':Predicate, #3: 3	أَخَذَ عَيْنَ
u'أَخَذَ عَيْنٌ':Predicate, #6: 6	أَخَذَ الْعَيْنَ
u'أَخَذَ عَيْن':Predicate, #6: 6	أَخَذَ الْعَيْنَ
u'أَخَذَ غَاصِبٌ':Subject, #6: 6	أَخَذَ الْعَيْنَ
u'أَخَذَ غَاصِبٌ':Subject, #1: 1	أَخَذَ غَاصِبُ
u'أَخَذَ غرماء':Subject, #3: 3	أَخَذَ الْغَاصِبُ
u'أَخَذَ غرماء':Subject, #2: 2	أَخَذَ الْغُرَمَاءُ
u'أَخَذَ غَرِيمٌ':Subject, #2: 2	أَخَذَ غُرَمَاءُ
u'أَخَذَ غَزْلٌ':Predicate, #2: 2	أَخَذَ الْغَرِيمُ
u'أَخَذَ غُلاَمٌ':Predicate, #1: 1	أَخَذَ غَزْلَ
u'أَخَذَ غَلَّةٌ':Predicate, #2: 2	أَخَذَ الْغُلَامَ
u'أَخَذَ غير':Predicate, #3: 3	أَخَذَ الْغَلَّةَ
u'أَخَذَ غَيْرٌ':Predicate, #5: 5	أَخَذَ غَيْرَ
u'أَخَذَ غير':Subject, #5: 5	أَخَذَ غَيْرَ
u'أَخَذَ غَيْرٌ':Subject, #2: 2	أَخَذَ غَيْرُ
u'أَخَذَ فَاضِلٌ':Subject, #2: 2	أَخَذَ غَيْرُ
u'أَخَذَ فَاكِهٌ':Predicate, #1: 1	أَخَذَ الْفَاضِلُ
u'أَخَذَ فَرْخٌ':Predicate, #1: 1	أَخَذَ فَاكِهَةً
u'أَخَذَ فَرْضٌ':Predicate, #1: 1	أَخَذَ فَرْخَ
u'أَخَذَ فَضْلٌ':Predicate, #3: 3	أَخَذَ الْفَرْضَ
u'أَخَذَ فِقْهٌ':Predicate, #1: 1	أَخَذَ فَضْلَ
u'أَخَذَ فقهاء':Subject, #1: 1	أَخَذَ الْفِقْهَ
u'أَخَذَ فَقِيهٌ':Subject, #1: 1	أَخَذَ الْفُقَهَاءُ
u'أَخَذَ فلان':Predicate, #59: 59	أَخَذَ الْفَقِيهُ
u'أَخَذَ فلان':Predicate, #1: 1	أَخَذَ الْجُبْرَانَ
u'أَخَذَ فلان':Predicate, #1: 1	أَخَذَ سِمْسِمَةً
u'أَخَذَ فلان':Predicate, #3: 3	أَخَذَ الرّايَةَ
u'أَخَذَ فلان':Subject, #7: 7	أَخَذَ الرَّايَةَ
u'أَخَذَ فلان':Subject, #1: 1	أَخَذَ الْقَصَّابُ
u'أَخَذَ فلان':Subject, #1: 1	أَخَذَ بِلَالٌ
u'أَخَذَ فلان':Subject, #1: 1	أَخَذَ بِلاَلٌ
u'أَخَذَ فلان':Subject, #1: 1	أَخَذَ جَعْفَرٌ
u'أَخَذَ فلان':Subject, #1: 1	أَخَذَ سُفْيَانُ
u'أَخَذَ قَاتِلٌ':Predicate, #25: 25	أَخَذَ الشَّافِعِيُّ
u'أَخَذَ قَاصِدٌ':Subject, #1: 1	أَخَذَ الْقَاتِلَ
u'أَخَذَ قَبَاءٌ':Predicate, #1: 1	أَخَذَ قَاصِدُ
u'أَخَذَ قَدْرٌ':Predicate, #2: 2	أَخَذَ الْقَبَاءَ
u'أَخَذَ قَدْرٌ':Predicate, #1: 1	أَخَذَ الْقَدْرَ
u'أَخَذَ قَدُومٌ':Predicate, #9: 9	أَخَذَ قَدْرَ
u'أَخَذَ قِرَاءةٌ':Predicate, #1: 1	أَخَذَ الْقَدُومَ
u'أَخَذَ قُرْآنٌ':Predicate, #1: 1	أَخَذَ الْقِرَاءَةَ
u'أَخَذَ قُرُونٌ':Subject, #1: 1	أَخَذَ الْقُرْآنَ
u'أَخَذَ قَرْيَةٌ':Predicate, #1: 1	أَخَذَ الْقُرُونُ
u'أَخَذَ قَصّاب':Subject, #1: 1	أَخَذَ قَرْيَةَ
u'أَخَذَ قِصَّةٌ':Predicate, #1: 1	أَخَذَ الْقَصَّابُ
u'أَخَذَ قَصْعَةٌ':Predicate, #1: 1	أَخَذَ الْقِصَّةَ
u'أَخَذَ قَضَاءٌ':Predicate, #1: 1	أَخَذَ قَصْعَةَ
u'أَخَذَ قلب':Predicate, #4: 4	أَخَذَ الْقَضَاءَ
u'أَخَذَ قلب':Predicate, #1: 1	أَخَذَ الْقَلْبَ
u'أَخَذَ قَلْبٌ':Predicate, #1: 1	أَخَذَ الْقُلْبَ
u'أَخَذَ قَلْب':Predicate, #1: 1	أَخَذَ الْقَلْبَ
u'أَخَذَ قلب':Subject, #1: 1	أَخَذَ الْقَلْبَ
u'أَخَذَ قَلْبٌ':Subject, #1: 1	أَخَذَ الْقَلْبُ
u'أَخَذَ قَلْب':Subject, #1: 1	أَخَذَ الْقَلْبُ
u'أَخَذَ قَلَمٌ':Predicate, #1: 1	أَخَذَ الْقَلْبُ
u'أَخَذَ قَلَنْسُوَةٌ':Predicate, #1: 1	أَخَذَ الْقَلَمَ
u'أَخَذَ قمر':Subject, #1: 1	أَخَذَ الْقَلَنْسُوَةَ
u'أَخَذَ قَمَرٌ':Subject, #1: 1	أَخَذَ الْقَمَرُ
u'أَخَذَ قَمْلَةٌ':Predicate, #1: 1	أَخَذَ الْقَمَرُ
u'أَخَذَ قَمِيصٌ':Predicate, #1: 1	أَخَذَ الْقَمْلَةَ
u'أَخَذَ قِنٌّ':Subject, #1: 1	أَخَذَ الْقَمِيصَ
u'أَخَذَ قَوْسٌ':Predicate, #1: 1	أَخَذَ قِنُّهُ
u'أَخَذَ قِيَادٌ':Predicate, #1: 1	أَخَذَ الْقَوْسَ
u'أَخَذَ قِيمَةٌ':Predicate, #1: 1	أَخَذَ قِيَادَ
u'أَخَذَ قِيمَةٌ':Predicate, #13: 13	أَخَذَ قِيمَةَ
u'أَخَذَ كَافِرٌ':Subject, #37: 37	أَخَذَ الْقِيمَةَ
u'أَخَذَ كَبِيرٌ':Subject, #1: 1	أَخَذَ الْكَافِرُ
u'أَخَذَ كِتَابٌ':Predicate, #1: 1	أَخَذَ الْكَبِيرُ
u'أَخَذَ كِرَاءٌ':Predicate, #2: 2	أَخَذَ الْكِتَابَ
u'أَخَذَ كِسَاءٌ':Predicate, #1: 1	أَخَذَ كِرَاءَ
u'أَخَذَ كسرة':Predicate, #1: 1	أَخَذَ الْكِسَاءَ
u'أَخَذَ كِسْرَةٌ':Predicate, #1: 1	أَخَذَ كِسْرَةَ
u'أَخَذَ كَفٌّ':Predicate, #1: 1	أَخَذَ كِسْرَةَ
u'أَخَذَ كُفَّارٌ':Subject, #1: 1	أَخَذَ الْكَفَّ
u'أَخَذَ كَفِيلٌ':Predicate, #1: 1	أَخَذَ الْكُفَّارُ
u'أَخَذَ كَفِيلٌ':Subject, #4: 4	أَخَذَ الْكَفِيلَ
u'أَخَذَ كَلَأٌ':Predicate, #6: 6	أَخَذَ الْكَفِيلُ
u'أَخَذَ كَلْبٌ':Subject, #1: 1	أَخَذَ كَلَأَ
u'أَخَذَ كُوزٌ':Predicate, #5: 5	أَخَذَ الْكَلْبُ
u'أَخَذَ لبن':Predicate, #1: 1	أَخَذَ كُوزَ
u'أَخَذَ لَبَنٌ':Predicate, #1: 1	أَخَذَ اللَّبَنَ
u'أَخَذَ لبن':Predicate, #1: 1	أَخَذَ اللَّبَنَ
u'أَخَذَ لَبَنٌ':Predicate, #1: 1	أَخَذَ لَبَنَ
u'أَخَذَ لَحْمٌ':Predicate, #1: 1	أَخَذَ لَبَنَ
u'أَخَذَ لِصٌّ':Predicate, #1: 1	أَخَذَ اللَّحْمَ
u'أَخَذَ لُصُوصٌ':Subject, #1: 1	أَخَذَ اللِّصَّ
u'أَخَذَ لَطِيم':Predicate, #3: 3	أَخَذَ اللُّصُوصُ
u'أَخَذَ لَفْظٌ':Predicate, #1: 1	أَخَذَ لَطِيمَةً
u'أَخَذَ لقطة':Predicate, #1: 1	أَخَذَ لَفْظَ
u'أَخَذَ لِوَاءٌ':Predicate, #5: 5	أَخَذَ اللُّقَطَةَ
u'أَخَذَ لَيْلٌ':Predicate, #1: 1	أَخَذَ اللّوَاءَ
u'أَخَذَ مَاءٌ':Predicate, #1: 1	أَخَذَ لَيْلَةَ
u'أَخَذَ مَاءٌ':Predicate, #12: 12	أَخَذَ الْمَاءَ
u'أَخَذَ مَاءٌ':Subject, #1: 1	أَخَذَ مَاءَ
u'أَخَذَ مَاشِي':Predicate, #1: 1	أَخَذَ الْمَاءُ
u'أَخَذَ مَالٌ':Predicate, #2: 2	أَخَذَ مَاشِيَةً
u'أَخَذَ مَالٌ':Predicate, #13: 13	أَخَذَ مَالَ
u'أَخَذَ مَالٌ':Subject, #54: 54	أَخَذَ الْمَالَ
u'أَخَذَ مَالِكٌ':Subject, #1: 1	أَخَذَ مَالُهُ
u'أَخَذَ مَالِكٌ':Subject, #11: 11	أَخَذَ مَالِكٌ
u'أَخَذَ مَبِيعٌ':Predicate, #4: 4	أَخَذَ الْمَالِكُ
u'أَخَذَ مَبِيعٌ':Predicate, #1: 1	أَخَذَ مَبِيعَ
u'أَخَذَ مَتَاعٌ':Predicate, #2: 2	أَخَذَ الْمَبِيعَ
u'أَخَذَ مَتَاعٌ':Predicate, #1: 1	أَخَذَ الْمَتَاعَ
u'أَخَذَ مُتَصَوِّفٌ':Subject, #1: 1	أَخَذَ مَتَاعَ
u'أَخَذَ مُتَّفَقٌ':Subject, #1: 1	أَخَذَ الْمُتَصَوِّفَةُ
u'أَخَذَ مثل':Predicate, #1: 1	أَخَذَ الْمُتَّفَقُ
u'أَخَذَ مِثْلٌ':Predicate, #1: 1	أَخَذَ الْمِثْلَ
u'أَخَذَ مثل':Predicate, #1: 1	أَخَذَ الْمِثْلَ
u'أَخَذَ مِثْلٌ':Predicate, #4: 4	أَخَذَ مِثْلَ
u'أَخَذَ مَجْمُوعٌ':Predicate, #4: 4	أَخَذَ مِثْلَ
u'أَخَذَ مَجْنُونٌ':Subject, #1: 1	أَخَذَ الْمَجْمُوعَ
u'أَخَذَ مَجْنِيٌّ':Subject, #1: 1	أَخَذَ الْمَجْنُونُ
u'أَخَذَ مَجُوسِيٌّ':Subject, #1: 1	أَخَذَ الْمَجْنِيُّ
u'أَخَذَ مُحْتَالٌ':Predicate, #1: 1	أَخَذَ مَجُوسِيٌّ
u'أَخَذَ مُحْتَالٌ':Subject, #1: 1	أَخَذَ الْمُحْتَالَ
u'أَخَذَ مُحْرِمٌ':Subject, #1: 1	أَخَذَ الْمُحْتَالُ
u'أَخَذَ مُحَلِّل':Subject, #2: 2	أَخَذَ الْمُحْرِمُ
u'أَخَذَ مُحَمَّدٌ':Subject, #1: 1	أَخَذَ الْمُحَلِّلُ
u'أَخَذَ مُحَمَّدٌ':Subject, #5: 5	أَخَذَ مُحَمَّدُ
u'أَخَذَ مُحِيل':Subject, #6: 6	أَخَذَ مُحَمَّدٌ
u'أَخَذَ مَخْرَجٌ':Predicate, #1: 1	أَخَذَ الْمُحِيلُ
u'أَخَذَ مُدٌّ':Predicate, #1: 1	أَخَذَ مَخْرَجَ
u'أَخَذَ مَدْفُوعٌ':Predicate, #1: 1	أَخَذَ الْمُدَّ
u'أَخَذَ مَدْلُولٌ':Subject, #1: 1	أَخَذَ الْمَدْفُوعَ
u'أَخَذَ مَذْبُوحٌ':Predicate, #1: 1	أَخَذَ الْمَدْلُولُ
u'أَخَذَ مرٌّ':Predicate, #1: 1	أَخَذَ الْمَذْبُوحَ
u'أَخَذَ مُرْتَهِنٌ':Subject, #2: 2	أَخَذَ مَرَّةً
u'أَخَذَ مُرْسِلٌ':Subject, #4: 4	أَخَذَ الْمُرْتَهِنُ
u'أَخَذَ مُزَارِعٌ':Subject, #1: 1	أَخَذَ الْمُرْسِلُ
u'أَخَذَ مَسْأَلَةٌ':Predicate, #1: 1	أَخَذَ الْمُزَارِعُ
u'أَخَذَ مُسْتَحِقٌّ':Subject, #2: 2	أَخَذَ الْمَسْأَلَةَ
u'أَخَذَ مُسْتَعِيرٌ':Predicate, #1: 1	أَخَذَ الْمُسْتَحِقُّ
u'أَخَذَ مُسْتَعِيرٌ':Subject, #1: 1	أَخَذَ الْمُسْتَعِيرَ
u'أَخَذَ مُسْلِمٌ':Subject, #1: 1	أَخَذَ الْمُسْتَعِيرُ
u'أَخَذَ مَشَايِخُ':Subject, #3: 3	أَخَذَ الْمُسْلِمُ
u'أَخَذَ مَشَايِخُ':Subject, #4: 4	أَخَذَ الْمَشَايِخُ
u'أَخَذَ مُشْتَرِي':Predicate, #8: 8	أَخَذَ مَشَايِخُ
u'أَخَذَ مَشْفُوع':Predicate, #3: 3	أَخَذَ الْمُشْتَرِيَ
u'أَخَذَ مَصْبُوغ':Predicate, #1: 1	أَخَذَ الْمَشْفُوعَةَ
u'أَخَذَ مُصَدِّقٌ':Subject, #1: 1	أَخَذَ الْمَصْبُوغَ
u'أَخَذَ مُصَنَّفٌ':Subject, #7: 7	أَخَذَ الْمُصَدِّقُ
u'أَخَذَ مُصَنِّفٌ':Subject, #1: 1	أَخَذَ الْمُصَنَّفُ
u'أَخَذَ مَصْنُوعٌ':Predicate, #4: 4	أَخَذَ الْمُصَنِّفُ
u'أَخَذَ مُضَارِبٌ':Subject, #1: 1	أَخَذَ الْمَصْنُوعَ
u'أَخَذَ مَطْلُوبٌ':Predicate, #3: 3	أَخَذَ الْمُضَارِبُ
u'أَخَذَ مَظْرُوفٌ':Predicate, #1: 1	أَخَذَ الْمَطْلُوبَ
u'أَخَذَ مُعْتَقٌ':Predicate, #1: 1	أَخَذَ الْمَظْرُوفَ
u'أَخَذَ مُعَلِّمٌ':Subject, #2: 2	أَخَذَ الْمُعْتَقَ
u'أَخَذَ مَعِيبٌ':Predicate, #1: 1	أَخَذَ الْمُعَلِّمُ
u'أَخَذَ مَغْصُوب':Predicate, #1: 1	أَخَذَ الْمَعِيبَ
u'أَخَذَ مَغْصُوب':Subject, #3: 3	أَخَذَ الْمَغْصُوبَ
u'أَخَذَ مَفَاتِيحُ':Predicate, #1: 1	أَخَذَ الْمَغْصُوبُ
u'أَخَذَ مِفْتَاحٌ':Predicate, #1: 1	أَخَذَ مَفَاتِيحَ
u'أَخَذَ مُقَابِلٌ':Predicate, #1: 1	أَخَذَ مِفْتَاحَ
u'أَخَذَ مَقَاطِعُ':Subject, #1: 1	أَخَذَ مُقَابِلَ
u'أَخَذَ مِقْدَارٌ':Predicate, #1: 1	أَخَذَ الْمَقَاطِعُ
u'أَخَذَ مَقْضِيّ':Subject, #1: 1	أَخَذَ الْمِقْدَارَ
u'أَخَذَ مَقْطُوعٌ':Predicate, #1: 1	أَخَذَ الْمَقْضِيُّ
u'أَخَذَ مَكّاس':Subject, #1: 1	أَخَذَ الْمَقْطُوعَ
u'أَخَذَ مَكْسُورٌ':Predicate, #2: 2	أَخَذَ الْمَكَّاسُ
u'أَخَذَ مَكْفُولٌ':Subject, #1: 1	أَخَذَ الْمَكْسُورَ
u'أَخَذَ مِكْيَالٌ':Subject, #1: 1	أَخَذَ الْمَكْفُولُ
u'أَخَذَ مُلْتَقِط':Subject, #1: 1	أَخَذَ الْمِكْيَالُ
u'أَخَذَ مُلْكٌ':Predicate, #1: 1	أَخَذَ الْمُلْتَقِطُ
u'أَخَذَ مَلَكٌ':Subject, #1: 1	أَخَذَ الْمُلْكَ
u'أَخَذَ مُنْكِرٌ':Subject, #1: 1	أَخَذَ الْمَلَكُ
u'أَخَذَ مُؤَجَّرٌ':Subject, #1: 1	أَخَذَ الْمُنْكِرُ
u'أَخَذَ مُؤَجِّرٌ':Subject, #1: 1	أَخَذَ الْمُؤَجَّرُ
u'أَخَذَ مَوْجُودٌ':Predicate, #1: 1	أَخَذَ الْمُؤَجِّرُ
u'أَخَذَ مُودِعٌ':Subject, #5: 5	أَخَذَ الْمَوْجُودَ
u'أَخَذَ مُؤَذِّنٌ':Predicate, #1: 1	أَخَذَ الْمُودِعُ
u'أَخَذَ مُؤَذِّنٌ':Subject, #1: 1	أَخَذَ الْمُؤَذِّنِينَ
u'أَخَذَ مَيْتٌ':Predicate, #6: 6	أَخَذَ الْمُؤَذِّنُ
u'أَخَذَ مَيْتَةٌ':Predicate, #1: 1	أَخَذَ الْمَيْتَةَ
u'أَخَذَ مِيثَاقٌ':Predicate, #1: 1	أَخَذَ الْمَيْتَةَ
u'أَخَذَ مِيثَاقٌ':Predicate, #1: 1	أَخَذَ مِيثَاقَ
u'أَخَذَ نَاسٌ':Subject, #2: 2	أَخَذَ الْمِيثَاقَ
u'أَخَذَ نَاسٌ':Subject, #3: 3	أَخَذَ النّاسُ
u'أَخَذَ نَاقِصٌ':Predicate, #4: 4	أَخَذَ النَّاسُ
u'أَخَذَ نَبِيٌّ':Subject, #1: 1	أَخَذَ النَّاقِصَ
u'أَخَذَ نَحْلٌ':Predicate, #8: 8	أَخَذَ النَّبِيُّ
u'أَخَذَ نَحْوٌ':Predicate, #1: 1	أَخَذَ النَّحْلَ
u'أَخَذَ نَخَّاسٌ':Subject, #1: 1	أَخَذَ نَحْوَ
u'أَخَذَ نَخِيلٌ':Predicate, #1: 1	أَخَذَ النَّخَّاسُ
u'أَخَذَ نِساءٌ':Subject, #1: 1	أَخَذَ النَّخِيلَ
u'أَخَذَ نصاب':Predicate, #1: 1	أَخَذَ نِسَاءُ
u'أَخَذَ نِصَابٌ':Predicate, #1: 1	أَخَذَ النِّصَابَ
u'أَخَذَ نَصْرَانِيٌّ':Subject, #1: 1	أَخَذَ النِّصَابَ
u'أَخَذَ نِصْفٌ':Predicate, #2: 2	أَخَذَ النَّصْرَانِيُّ
u'أَخَذَ نِصْفٌ':Predicate, #12: 12	أَخَذَ النِّصْفَ
u'أَخَذَ نَصِيبٌ':Predicate, #34: 34	أَخَذَ نِصْفَ
u'أَخَذَ نَعْجَةٌ':Predicate, #4: 4	أَخَذَ نَصِيبَ
u'أَخَذَ نَعْلٌ':Predicate, #1: 1	أَخَذَ النَّعْجَةَ
u'أَخَذَ نَفَقَةٌ':Predicate, #1: 1	أَخَذَ نَعْلَ
u'أَخَذَ نَقْضٌ':Predicate, #3: 3	أَخَذَ النَّفَقَةَ
u'أَخَذَ نَمَاءٌ':Predicate, #5: 5	أَخَذَ النَّقْضَ
u'أَخَذَ هَدِيٌّ':Predicate, #1: 1	أَخَذَ نَمَاءَ
u'أَخَذَ هَدِيَّةٌ':Predicate, #1: 1	أَخَذَ الْهَدِيَّةَ
u'أَخَذَ هِرٌّ':Predicate, #1: 1	أَخَذَ الْهَدِيَّةَ
u'أَخَذَ هِلاَلٌ':Subject, #1: 1	أَخَذَ هِرَّةً
u'أَخَذَ وَاجِبٌ':Predicate, #1: 1	أَخَذَ هِلَالٌ
u'أَخَذَ واحد':Predicate, #2: 2	أَخَذَ الْوَاجِبَ
u'أَخَذَ وَاحِدٌ':Predicate, #3: 3	أَخَذَ وَاحِدَةً
u'أَخَذَ واحد':Subject, #3: 3	أَخَذَ وَاحِدَةً
u'أَخَذَ وَاحِدٌ':Subject, #1: 1	أَخَذَ وَاحِدٌ
u'أَخَذَ وَارِثٌ':Subject, #1: 1	أَخَذَ وَاحِدٌ
u'أَخَذَ وَارِثٌ':Subject, #1: 1	أَخَذَ الْوَارِثُ
u'أَخَذَ وَارِثٌ':Subject, #1: 1	أَخَذَ وَارِثُ
u'أَخَذَ وَالِدٌ':Subject, #1: 1	أَخَذَ وَارِثُهُ
u'أَخَذَ وَالِدٌ':Subject, #1: 1	أَخَذَ الْوَالِدُ
u'أَخَذَ وَدِيعٌ':Predicate, #1: 1	أَخَذَ وَالِدُهُ
u'أَخَذَ وَدِيعٌ':Predicate, #1: 1	أَخَذَ وَدِيعَةَ
u'أَخَذَ وَدِيعَةٌ':Predicate, #3: 3	أَخَذَ الْوَدِيعَةَ
u'أَخَذَ وَدِيعَةٌ':Predicate, #1: 1	أَخَذَ وَدِيعَةَ
u'أَخَذَ وَرَثَةٌ':Subject, #3: 3	أَخَذَ الْوَدِيعَةَ
u'أَخَذَ وسط':Predicate, #1: 1	أَخَذَ الْوَرَثَةُ
u'أَخَذَ وَسَطٌ':Predicate, #2: 2	أَخَذَ الْوَسَطَ
u'أَخَذَ وَصْفٌ':Predicate, #2: 2	أَخَذَ الْوَسَطَ
u'أَخَذَ وَصِيٌّ':Subject, #2: 2	أَخَذَ الْوَصْفَ
u'أَخَذَ وَقْفٌ':Predicate, #3: 3	أَخَذَ الْوَصِيُّ
u'أَخَذَ وَكِيلٌ':Subject, #1: 1	أَخَذَ الْوَقْفَ
u'أَخَذَ وَكِيلٌ':Subject, #2: 2	أَخَذَ الْوَكِيلُ
u'أَخَذَ ولد':Predicate, #2: 2	أَخَذَ وَكِيلُهُ
u'أَخَذَ وَلَدٌ':Predicate, #5: 5	أَخَذَ الْوَلَدَ
u'أَخَذَ وَلَهٌ':Subject, #5: 5	أَخَذَ الْوَلَدَ
u'أَخَذَ وَلِيٌّ':Subject, #6: 6	أَخَذَ وَلَهُ
u'أَخَذَ وَلِيٌّ':Subject, #2: 2	أَخَذَ وَلِيُّ
u'أَخَذَ يَوْمٌ':Predicate, #3: 3	أَخَذَ الْوَلِيُّ
u'إِخْرَاجٌ حَديثٌ':Added, #2: 2	أَخَذَ يَوْمَ
u'إِخْرَاجٌ خُمُسٌ':Added, #1: 1	إِخْرَاجِ حَدِيثِ
u'إِخْرَاجٌ دَقيقٌ':Added, #1: 1	إِخْرَاجِ الْخُمُسِ
u'أَخَّرَ أَجْرٌ':Predicate, #1: 1	إِخْرَاجُ الدَّقِيقِ
u'إِخْرَاجٌ رِوايَةٌ':Added, #1: 1	أَخَّرَ الْأَجْرَ
u'إِخْرَاجٌ زَكاةٌ':Added, #1: 1	إِخْرَاجِ رِوَايَةِ
u'إِخْرَاجٌ صدقة':Added, #2: 2	إِخْرَاجِ زَكَاةِ
u'إِخْرَاجٌ صَدَقَةٌ':Added, #2: 2	إِخْرَاجِ الصَّدَقَةِ
u'إِخْرَاجٌ عَبَّاسٌ':Added, #2: 2	إِخْرَاجِ الصَّدَقَةِ
u'إِخْرَاجٌ قِيَمٌ':Added, #1: 1	إِخْرَاجُ الْعَبَّاسِ
u'أَخَّرَ إِجْمَاعٌ':Predicate, #1: 1	إِخْرَاجِ الْقِيَمِ
u'أَخَّرَ أَجِيرٌ':Subject, #1: 1	أَخَّرَ الْإِجْمَاعَ
u'إِخْرَاجٌ يهود':Added, #1: 1	أَخَّرَ أَجِيرُ
u'إِخْرَاجٌ يَهُودٌ':Added, #6: 6	إِخْرَاجَ الْيَهُودِ
u'أَخَّرَ أحَدٌ':Subject, #6: 6	إِخْرَاجَ الْيَهُودِ
u'أَخَّرَ إِحْرَامٌ':Predicate, #1: 1	أَخَّرَ أَحَدُ
u'أَخَّرَ إِحْرَامٌ':Predicate, #1: 1	أَخَّرَ إحْرَامَ
u'أَخَّرَ أخْذٌ':Predicate, #4: 4	أَخَّرَ الْإِحْرَامَ
u'أَخَّرَ أَدَاءٌ':Predicate, #4: 4	أَخَّرَ الْأَخْذَ
u'أَخَّرَ أَذَانٌ':Predicate, #3: 3	أَخَّرَ أَدَاءَ
u'أَخَّرَ إِسْلامٌ':Predicate, #1: 1	أَخَّرَ أَذَانَ
u'أَخَّرَ أصل':Predicate, #1: 1	أَخَّرَ الْإِسْلَامَ
u'أَخَّرَ أًصْلٌ':Predicate, #1: 1	أَخَّرَ أَصْلَ
u'أَخَّرَ إِعْتاقٌ':Predicate, #1: 1	أَخَّرَ أَصْلَ
u'أَخَّرَ إقامَةٌ':Predicate, #1: 1	أَخَّرَ إعْتَاقَ
u'أَخَّرَ إقامَةٌ':Predicate, #1: 1	أَخَّرَ الإِقَامَةَ
u'أَخَّرَ إقامَةٌ':Predicate, #2: 2	أَخَّرَ إقَامَةَ
u'أَخَّرَ أقَلُّ':Predicate, #3: 3	أَخَّرَ الْإِقَامَةَ
u'أَخَّرَ أكَّارٌ':Subject, #1: 1	أَخَّرَ أَقَلَّ
u'أَخَّرَ أَكْثَرُ':Predicate, #1: 1	أَخَّرَ الْأَكَّارُ
u'أَخَّرَ أَكْثَرُ':Predicate, #1: 1	أَخَّرَ أَكْثَرَ
u'أَخَّرَ إمَامٌ':Subject, #1: 1	أَخَّرَ الْأَكْثَرَ
u'أَخَّرَ أَمْرٌ':Predicate, #5: 5	أَخَّرَ الْإِمَامُ
u'أَخَّرَ إِنْكارٌ':Predicate, #1: 1	أَخَّرَ الْأَمْرَ
u'أَخَّرَ إيقَاعٌ':Predicate, #2: 2	أَخَّرَ الْإِنْكَارَ
u'أَخَّرَ إيمَانٌ':Predicate, #2: 2	أَخَّرَ الْإِيقَاعَ
u'أَخَّرَ بَابٌ':Predicate, #1: 1	أَخَّرَ الْإِيمَانَ
u'أَخَّرَ بَائِعٌ':Subject, #4: 4	أَخَّرَ بَابَ
u'أَخَّرَ بَطَلٌ':Predicate, #2: 2	أَخَّرَ الْبَائِعُ
u'أَخَّرَ بَيَانٌ':Predicate, #1: 1	أَخَّرَ بَطَلَ
u'أَخَّرَ بَيْعٌ':Predicate, #2: 2	أَخَّرَ بَيَانَ
u'أَخَّرَ تَحَلُّلٌ':Predicate, #1: 1	أَخَّرَ الْبَيْعَ
u'أَخَّرَ تَسْلِيمٌ':Predicate, #1: 1	أَخَّرَ التَّحَلُّلَ
u'أَخَّرَ تَعْرِيفٌ':Predicate, #2: 2	أَخَّرَ تَسْلِيمَ
u'أَخَّرَ تَعْلِيقٌ':Predicate, #2: 2	أَخَّرَ التَّعْرِيفَ
u'أَخَّرَ تَفْرِيقٌ':Predicate, #1: 1	أَخَّرَ التَّعْلِيقَ
u'أَخَّرَ تَفْرِيقٌ':Predicate, #1: 1	أَخَّرَ التَّفْرِيقَ
u'أَخَّرَ تَكْليفٌ':Predicate, #1: 1	أَخَّرَ تَفْرِيقَ
u'أَخَّرَ تِلاوَةٌ':Predicate, #1: 1	أَخَّرَ التَّكْلِيفَ
u'أَخَّرَ ثَمَنٌ':Predicate, #1: 1	أَخَّرَ التِّلَاوَةَ
u'أَخْرَجَ أَبٌ':Subject, #11: 11	أَخَّرَ الثَّمَنَ
u'أَخْرَجَ اِبْنٌ':Subject, #1: 1	أَخْرَجَ الْأَبُ
u'أَخْرَجَ أثَرٌ':Predicate, #26: 26	أَخْرَجَ ابْنُ
u'أَخْرَجَ إجَارَةٌ':Predicate, #1: 1	أَخْرَجَ أَثَرَ
u'أَخْرَجَ أَجْنَبِيٌّ':Subject, #1: 1	أَخْرَجَ الْإِجَارَةَ
u'أَخْرَجَ أَجْوَدُ':Predicate, #3: 3	أَخْرَجَ أَجْنَبِيٌّ
u'أَخْرَجَ أحَدٌ':Subject, #1: 1	أَخْرَجَ أَجْوَدَ
u'أَخْرَجَ آدَمُ':Predicate, #1: 1	أَخْرَجَ أَحَدُ
u'أَخْرَجَ أَرْبَعُ':Predicate, #1: 1	أَخْرَجَ آدَمَ
u'أَخْرَجَ أَرْبَعَةٌ':Predicate, #3: 3	أَخْرَجَ أَرْبَعَ
u'أَخْرَجَ أَسيرٌ':Predicate, #2: 2	أَخْرَجَ أَرْبَعَةَ
u'أَخْرَجَ أكُولٌ':Predicate, #1: 1	أَخْرَجَ الْأَسِيرَةَ
u'أَخْرَجَ ألف':Predicate, #2: 2	أَخْرَجَ الْأَكُولَةَ
u'أَخْرَجَ ألْفٌ':Predicate, #1: 1	أَخْرَجَ أَلْفَ
u'أَخْرَجَ أَلْفٌ':Predicate, #1: 1	أَخْرَجَ أَلْفَ
u'أَخْرَجَ إمَامٌ':Subject, #1: 1	أَخْرَجَ أَلْفَ
u'أَخْرَجَ آمِرٌ':Subject, #1: 1	أَخْرَجَ الْإِمَامُ
u'أَخْرَجَ أهْلٌ':Subject, #4: 4	أَخْرَجَ الْآمِرُ
u'أَخْرَجَ بَائِعٌ':Subject, #1: 1	أَخْرَجَ أَهْلُ
u'أَخْرَجَ بُخَارِيٌّ':Subject, #1: 1	أَخْرَجَ الْبَائِعُ
u'أَخْرَجَ بَذْرٌ':Predicate, #17: 17	أَخْرَجَ الْبُخَارِيُّ
u'أَخَّرَ جَبْرٌ':Predicate, #1: 1	أَخْرَجَ الْبَذْرَ
u'أَخْرَجَ بَزَّارٌ':Subject, #1: 1	أَخَّرَ الْجَبْرَ
u'أَخْرَجَ بَعْضٌ':Predicate, #4: 4	أَخْرَجَ الْبَزَّارُ
u'أَخْرَجَ بَعْضٌ':Predicate, #1: 1	أَخْرَجَ الْبَعْضَ
u'أَخْرَجَ بَقَرٌ':Predicate, #7: 7	أَخْرَجَ بَعْضَ
u'أَخْرَجَ بَيْعٌ':Predicate, #2: 2	أَخْرَجَ بَقَرَةً
u'أَخْرَجَ بَيْعٌ':Predicate, #1: 1	أَخْرَجَ الْبَيْعَ
u'أَخْرَجَ بَيْعَةٌ':Predicate, #1: 1	أَخْرَجَ بَيْعَ
u'أَخْرَجَ تَحْرِيرٌ':Predicate, #1: 1	أَخْرَجَ بَيْعَةَ
u'أَخْرَجَ تَصْدِيقٌ':Predicate, #1: 1	أَخْرَجَ تَحْرِيرَ
u'أَخْرَجَ تَفاوُت':Predicate, #5: 5	أَخْرَجَ التَّصْدِيقَ
u'أَخْرَجَ تَمْر':Predicate, #2: 2	أَخْرَجَ التَّفَاوُتَ
u'أَخْرَجَ ثَانِي':Predicate, #1: 1	أَخْرَجَ التَّمْرَ
u'أَخْرَجَ ثَانِيَةٌ':Predicate, #1: 1	أَخْرَجَ الثَّانِيَةَ
u'أَخْرَجَ ثَلاثَةٌ':Predicate, #1: 1	أَخْرَجَ الثَّانِيَةَ
u'أَخْرَجَ جِذْعٌ':Predicate, #1: 1	أَخْرَجَ الثَّلَاثَةَ
u'أَخْرَجَ جَمَاعَةٌ':Subject, #1: 1	أَخْرَجَ الْجِذْعَ
u'أَخْرَجَ جَمَاعَةٌ':Subject, #1: 1	أَخْرَجَ الْجَمَاعَةُ
u'أَخْرَجَ جَوْزٌ':Predicate, #3: 3	أَخْرَجَ جَمَاعَةٌ
u'أَخْرَجَ حارِثٌ':Subject, #1: 1	أَخْرَجَ الْجَوْزَ
u'أَخْرَجَ حاكِمٌ':Subject, #1: 1	أَخْرَجَ الْحَارِثُ
u'أَخْرَجَ حالٌ':Predicate, #13: 13	أَخْرَجَ الْحَاكِمُ
u'أَخْرَجَ حَدَّادٌ':Subject, #1: 1	أَخْرَجَ حَالَ
u'أَخْرَجَ حَديثٌ':Predicate, #1: 1	أَخْرَجَ الْحَدَّادُ
u'أَخْرَجَ حَديثٌ':Predicate, #1: 1	أَخْرَجَ الْحَدِيثَ
u'أَخْرَجَ حَديدَةٌ':Predicate, #4: 4	أَخْرَجَ حَدِيثَ
u'أَخْرَجَ حُرٌّ':Predicate, #1: 1	أَخْرَجَ الْحَدِيدَةَ
u'أَخْرَجَ حُروفٌ':Predicate, #1: 1	أَخْرَجَ الْحُرَّ
u'أَخْرَجَ حَقٌّ':Predicate, #1: 1	أَخْرَجَ الْحُرُوفَ
u'أَخْرَجَ حَلالٌ':Subject, #1: 1	أَخْرَجَ حَقَّ
u'أَخْرَجَ حَلالٌ':Subject, #1: 1	أَخْرَجَ الْحَلَالُ
u'أَخْرَجَ خُبْزٌ':Predicate, #1: 1	أَخْرَجَ حَلَالٌ
u'أَخْرَجَ خلق':Predicate, #2: 2	أَخْرَجَ الْخُبْزَ
u'أَخْرَجَ خَلْقٌ':Predicate, #1: 1	أَخْرَجَ الْخَلْقَ
u'أَخْرَجَ خَمْرٌ':Predicate, #1: 1	أَخْرَجَ الْخَلْقَ
u'أَخْرَجَ خَمْسٌ':Predicate, #1: 1	أَخْرَجَ الْخَمْرَ
u'أَخْرَجَ دَابَّةٌ':Predicate, #1: 1	أَخْرَجَ خَمْسَ
u'أَخْرَجَ دَاخِلٌ':Subject, #1: 1	أَخْرَجَ الدَّابَّةَ
u'أَخْرَجَ دَرَاهِمُ':Predicate, #2: 2	أَخْرَجَ الدَّاخِلُ
u'أَخْرَجَ دَرَاهِمُ':Predicate, #2: 2	أَخْرَجَ دَرَاهِمَ
u'أَخْرَجَ دَقيقٌ':Predicate, #3: 3	أَخْرَجَ الدَّرَاهِمَ
u'أَخْرَجَ دَمٌ':Predicate, #3: 3	أَخْرَجَ الدَّقِيقَ
u'أَخْرَجَ دَنانيرُ':Predicate, #1: 1	أَخْرَجَ دَمَ
u'أَخْرَجَ دونٌ':Predicate, #2: 2	أَخْرَجَ دَنَانِيرَ
u'أَخْرَجَ ذكر':Predicate, #1: 1	أَخْرَجَ دُونَ
u'أَخْرَجَ ذَكَرٌ':Predicate, #1: 1	أَخْرَجَ الذَّكَرَ
u'أَخْرَجَ ذِئْبٌ':Subject, #1: 1	أَخْرَجَ الذَّكَرَ
u'أَخْرَجَ رَاهِنٌ':Subject, #1: 1	أَخْرَجَ الذِّئْبُ
u'أَخْرَجَ رَبُّ':Subject, #1: 1	أَخْرَجَ الرَّاهِنُ
u'أَخْرَجَ رُبُعٌ':Predicate, #2: 2	أَخْرَجَ رَبُّ
u'أَخْرَجَ رُبْعٌ':Predicate, #2: 2	أَخْرَجَ رُبُعَ
u'أَخْرَجَ رَدِيءٌ':Predicate, #2: 2	أَخْرَجَ رُبْعَ
u'أَخْرَجَ رِسَالَةٌ':Predicate, #2: 2	أَخْرَجَ الرَّدِيءَ
u'أَخْرَجَ رَسُولٌ':Subject, #1: 1	أَخْرَجَ الرِّسَالَةَ
u'أَخْرَجَ رِوايَةٌ':Predicate, #1: 1	أَخْرَجَ الرَّسُولُ
u'أَخْرَجَ ريحٌ':Subject, #1: 1	أَخْرَجَ رِوَايَةَ
u'أَخَّرَ جَزَاءٌ':Predicate, #1: 1	أَخْرَجَ الرِّيحُ
u'أَخْرَجَ زَكاةٌ':Predicate, #7: 7	أَخَّرَ الْجَزَاءَ
u'أَخْرَجَ زَكاةٌ':Predicate, #11: 11	أَخْرَجَ زَكَاةَ
u'أَخْرَجَ زَوائِدُ':Predicate, #7: 7	أَخْرَجَ الزَّكَاةَ
u'أَخَّرَ جِزْيَةٌ':Predicate, #1: 1	أَخْرَجَ زَوَائِدَ
u'أَخْرَجَ سَارِقٌ':Subject, #1: 1	أَخَّرَ الْجِزْيَةَ
u'أَخْرَجَ سَائِرٌ':Predicate, #8: 8	أَخْرَجَ السَّارِقُ
u'أَخْرَجَ سَبَبٌ':Predicate, #1: 1	أَخْرَجَ سَائِرَ
u'أَخْرَجَ سَبْعَةٌ':Predicate, #1: 1	أَخْرَجَ السَّبَبَ
u'أَخْرَجَ سَبَقٌ':Predicate, #1: 1	أَخْرَجَ سَبْعَةَ
u'أَخْرَجَ سَرقَةٌ':Predicate, #2: 2	أَخْرَجَ السَّبَقَ
u'أَخْرَجَ سَرِقَةٌ':Predicate, #5: 5	أَخْرَجَ السَّرِقَةَ
u'أَخْرَجَ سُلْطَانٌ':Subject, #5: 5	أَخْرَجَ السَّرِقَةَ
u'أَخْرَجَ سَهْمٌ':Subject, #1: 1	أَخْرَجَ السُّلْطَانُ
u'أَخْرَجَ شَاةٌ':Predicate, #2: 2	أَخْرَجَ السَّهْمُ
u'أَخْرَجَ شافِعِيّ':Subject, #1: 1	أَخْرَجَ الشَّاةَ
u'أَخْرَجَ شَجَرٌ':Subject, #2: 2	أَخْرَجَ الشَّافِعِيُّ
u'أَخْرَجَ شَخْصٌ':Subject, #1: 1	أَخْرَجَ شَجَرُ
u'أَخْرَجَ شَرِيكٌ':Subject, #1: 1	أَخْرَجَ شَخْصٌ
u'أَخْرَجَ شَهْوَةٌ':Predicate, #1: 1	أَخْرَجَ الشَّرِيكُ
u'أَخْرَجَ شُهُودٌ':Predicate, #1: 1	أَخْرَجَ الشَّهْوَةَ
u'أَخْرَجَ شَيْخٌ':Subject, #1: 1	أَخْرَجَ الشُّهُودَ
u'أَخْرَجَ شَيْرَجٌ':Predicate, #1: 1	أَخْرَجَ الشَّيْخُ
u'أَخْرَجَ صَاحِبٌ':Subject, #2: 2	أَخْرَجَ الشَّيْرَجَ
u'أَخْرَجَ صَانِعٌ':Subject, #3: 3	أَخْرَجَ صَاحِبُ
u'أَخْرَجَ صدقة':Predicate, #1: 1	أَخْرَجَ الصَّانِعُ
u'أَخْرَجَ صَدَقَةٌ':Predicate, #1: 1	أَخْرَجَ صَدَقَةَ
u'أَخْرَجَ صَلاَةٌ':Predicate, #1: 1	أَخْرَجَ صَدَقَةَ
u'أَخْرَجَ صَيْدٌ':Predicate, #1: 1	أَخْرَجَ الصَّلَاةَ
u'أَخْرَجَ ضَحِيَّةٌ':Predicate, #3: 3	أَخْرَجَ الصَّيْدَ
u'أَخْرَجَ ضربة':Predicate, #1: 1	أَخْرَجَ الضَّحِيَّةَ
u'أَخْرَجَ ضَرْبَةٌ':Predicate, #2: 2	أَخْرَجَ الضَّرْبَةَ
u'أَخْرَجَ ضَمَانٌ':Subject, #2: 2	أَخْرَجَ الضَّرْبَةَ
u'أَخْرَجَ طَبَرِيّ':Subject, #1: 1	أَخْرَجَ ضَمَانٌ
u'أَخْرَجَ طعام':Predicate, #4: 4	أَخْرَجَ الطَّبَرِيُّ
u'أَخْرَجَ طَعَامٌ':Predicate, #1: 1	أَخْرَجَ الطَّعَامَ
u'أَخْرَجَ طَلاَقٌ':Predicate, #1: 1	أَخْرَجَ الطَّعَامَ
u'أَخْرَجَ ظَبْيٌ':Predicate, #1: 1	أَخْرَجَ الطَّلَاقَ
u'أَخْرَجَ ظَبْيٌ':Predicate, #2: 2	أَخْرَجَ ظَبْيَةَ
u'أَخْرَجَ ظَرْفٌ':Predicate, #5: 5	أَخْرَجَ ظَبْيَةً
u'أَخْرَجَ ظُهْرٌ':Predicate, #1: 1	أَخْرَجَ الظَّرْفَ
u'أَخْرَجَ عَامِلٌ':Subject, #1: 1	أَخْرَجَ الظُّهْرَ
u'أَخْرَجَ عَبْدٌ':Predicate, #1: 1	أَخْرَجَ الْعَامِلُ
u'أَخْرَجَ عَبْدٌ':Predicate, #1: 1	أَخْرَجَ عَبْدَ
u'أَخْرَجَ عَبْدٌ':Subject, #3: 3	أَخْرَجَ الْعَبْدَ
u'أَخْرَجَ عَبْدٌ':Subject, #2: 2	أَخْرَجَ الْعَبْدُ
u'أَخْرَجَ عُشْرٌ':Predicate, #8: 8	أَخْرَجَ عَبْدُ
u'أَخْرَجَ عُشْرٌ':Predicate, #1: 1	أَخْرَجَ الْعُشْرَ
u'أَخْرَجَ عَقَارٌ':Predicate, #1: 1	أَخْرَجَ عُشْرَ
u'أَخْرَجَ عِلَّةٌ':Predicate, #1: 1	أَخْرَجَ الْعَقَارَ
u'أَخْرَجَ عُمَرٌ':Subject, #1: 1	أَخْرَجَ الْعِلَّةَ
u'أَخْرَجَ عين':Predicate, #2: 2	أَخْرَجَ عُمَرُ
u'أَخْرَجَ عَيْنٌ':Predicate, #2: 2	أَخْرَجَ الْعَيْنَ
u'أَخْرَجَ عَيْن':Predicate, #2: 2	أَخْرَجَ الْعَيْنَ
u'أَخْرَجَ غَافِلٌ':Predicate, #2: 2	أَخْرَجَ الْعَيْنَ
u'أَخْرَجَ غير':Predicate, #1: 1	أَخْرَجَ الْغَافِلَ
u'أَخْرَجَ غَيْرٌ':Predicate, #1: 1	أَخْرَجَ غَيْرَ
u'أَخْرَجَ غير':Subject, #1: 1	أَخْرَجَ غَيْرَ
u'أَخْرَجَ غَيْرٌ':Subject, #1: 1	أَخْرَجَ غَيْرُ
u'أَخْرَجَ فِدَاءٌ':Predicate, #1: 1	أَخْرَجَ غَيْرُ
u'أَخْرَجَ فُضُولٌ':Predicate, #2: 2	أَخْرَجَ فِدَاءَ
u'أَخْرَجَ فلان':Predicate, #1: 1	أَخْرَجَ الْفُضُولَ
u'أَخْرَجَ فلان':Subject, #1: 1	أَخْرَجَ الْجُبْرَانَ
u'أَخْرَجَ فلان':Subject, #12: 12	أَخْرَجَ التِّرْمِذِيُّ
u'أَخْرَجَ فلان':Subject, #1: 1	أَخْرَجَ الْمُتَصَدِّقُ
u'أَخْرَجَ فلان':Subject, #22: 22	أَخْرَجَ الطَّبَرَانِيُّ
u'أَخْرَجَ فلان':Subject, #2: 2	أَخْرَجَ الشَّافِعِيُّ
u'أَخْرَجَ فلان':Subject, #4: 4	أَخْرَجَ الطَّبَرِيُّ
u'أَخْرَجَ قَابِضٌ':Subject, #7: 7	أَخْرَجَ الْبَيْهَقِيُّ
u'أَخْرَجَ قَتِيلٌ':Predicate, #1: 1	أَخْرَجَ الْقَابِضُ
u'أَخْرَجَ قِدْرٌ':Predicate, #2: 2	أَخْرَجَ الْقَتِيلَ
u'أَخْرَجَ قَدْرٌ':Predicate, #1: 1	أَخْرَجَ الْقِدْرَ
u'أَخْرَجَ قَرِيبٌ':Predicate, #3: 3	أَخْرَجَ قَدْرَ
u'أَخْرَجَ قَرِيبٌ':Predicate, #1: 1	أَخْرَجَ الْقَرِيبَ
u'أَخْرَجَ قِيمَةٌ':Predicate, #1: 1	أَخْرَجَ الْقَرِيبَةَ
u'أَخْرَجَ قِيمَةٌ':Predicate, #1: 1	أَخْرَجَ الْقِيمَةَ
u'أَخْرَجَ كِتَابٌ':Predicate, #6: 6	أَخْرَجَ قِيمَةَ
u'أَخْرَجَ كَفَنٌ':Predicate, #2: 2	أَخْرَجَ الْكِتَابَ
u'أَخْرَجَ كَلاَمٌ':Predicate, #1: 1	أَخْرَجَ الْكَفَنَ
u'أَخْرَجَ كَلْبٌ':Predicate, #14: 14	أَخْرَجَ الْكَلَامَ
u'أَخْرَجَ كَنِيفٌ':Predicate, #1: 1	أَخْرَجَ الْكَلْبَ
u'أَخْرَجَ كَيْلٌ':Predicate, #1: 1	أَخْرَجَ الْكَنِيفَ
u'أَخْرَجَ مَاءٌ':Predicate, #1: 1	أَخْرَجَ الْكَيْلَ
u'أَخْرَجَ مَالٌ':Predicate, #2: 2	أَخْرَجَ الْمَاءَ
u'أَخْرَجَ مَالٌ':Predicate, #2: 2	أَخْرَجَ مَالَ
u'أَخْرَجَ مَالِكٌ':Subject, #7: 7	أَخْرَجَ الْمَالَ
u'أَخْرَجَ مَأْمُورٌ':Subject, #1: 1	أَخْرَجَ الْمَالِكُ
u'أَخْرَجَ مَبِيعٌ':Predicate, #3: 3	أَخْرَجَ الْمَأْمُورُ
u'أَخْرَجَ مَتَاعٌ':Predicate, #1: 1	أَخْرَجَ الْمَبِيعَ
u'أَخْرَجَ مُتَصَدِّق':Subject, #1: 1	أَخْرَجَ الْمَتَاعَ
u'أَخْرَجَ مَجَازٌ':Predicate, #1: 1	أَخْرَجَ الْمُتَصَدِّقُ
u'أَخْرَجَ مُحَمَّدٌ':Subject, #1: 1	أَخْرَجَ الْمَجَازَ
u'أَخْرَجَ مُخَاطَبٌ':Subject, #1: 1	أَخْرَجَ مُحَمَّدٌ
u'أَخْرَجَ مَخْرَجٌ':Predicate, #2: 2	أَخْرَجَ الْمُخَاطَبُ
u'أَخْرَجَ مَسْجِدٌ':Predicate, #1: 1	أَخْرَجَ مَخْرَجَ
u'أَخْرَجَ مُسْلِمٌ':Subject, #1: 1	أَخْرَجَ مَسْجِدَ
u'أَخْرَجَ مُقْرِضٌ':Subject, #40: 40	أَخْرَجَ مُسْلِمٌ
u'أَخَّرَ جُمْلَةٌ':Predicate, #1: 1	أَخْرَجَ الْمُقْرِضُ
u'أَخْرَجَ مُلْتَقِط':Subject, #1: 1	أَخَّرَ الْجُمْلَةَ
u'أَخْرَجَ مِنْبَرٌ':Predicate, #2: 2	أَخْرَجَ الْمُلْتَقِطُ
u'أَخْرَجَ مَنْفَعَةٌ':Predicate, #1: 1	أَخْرَجَ الْمِنْبَرَ
u'أَخْرَجَ مُوسِرٌ':Subject, #1: 1	أَخْرَجَ الْمَنْفَعَةَ
u'أَخْرَجَ نَاسٌ':Predicate, #1: 1	أَخْرَجَ الْمُوسِرُ
u'أَخْرَجَ نصاب':Predicate, #1: 1	أَخْرَجَ النَّاسَ
u'أَخْرَجَ نِصَابٌ':Predicate, #2: 2	أَخْرَجَ نِصَابَ
u'أَخْرَجَ نصاب':Predicate, #2: 2	أَخْرَجَ نِصَابَ
u'أَخْرَجَ نِصَابٌ':Predicate, #3: 3	أَخْرَجَ النِّصَابَ
u'أَخْرَجَ وَاجِبٌ':Predicate, #3: 3	أَخْرَجَ النِّصَابَ
u'أَخْرَجَ وَارِثٌ':Subject, #2: 2	أَخْرَجَ الْوَاجِبَ
u'أَخْرَجَ وَدِيعٌ':Predicate, #1: 1	أَخْرَجَ الْوَارِثَاتُ
u'أَخْرَجَ وَدِيعَةٌ':Predicate, #2: 2	أَخْرَجَ الْوَدِيعَةَ
u'أَخْرَجَ وسط':Predicate, #2: 2	أَخْرَجَ الْوَدِيعَةَ
u'أَخْرَجَ وَسَطٌ':Predicate, #2: 2	أَخْرَجَ الْوَسَطَ
u'أَخْرَجَ وَكِيلٌ':Predicate, #2: 2	أَخْرَجَ الْوَسَطَ
u'أَخْرَجَ وَكِيلٌ':Subject, #3: 3	أَخْرَجَ الْوَكِيلَ
u'أَخْرَجَ وَكِيلٌ':Subject, #1: 1	أَخْرَجَ وَكِيلُ
u'أَخْرَجَ ولد':Predicate, #4: 4	أَخْرَجَ الْوَكِيلُ
u'أَخْرَجَ وَلَدٌ':Predicate, #1: 1	أَخْرَجَ الْوَلَدَ
u'أَخْرَجَ ولد':Predicate, #1: 1	أَخْرَجَ الْوَلَدَ
u'أَخْرَجَ وَلَدٌ':Predicate, #1: 1	أَخْرَجَ وَلَدَ
u'أَخْرَجَ يسار':Predicate, #1: 1	أَخْرَجَ وَلَدَ
u'أَخْرَجَ يَسَارٌ':Predicate, #1: 1	أَخْرَجَ الْيَسَارَ
u'أَخَّرَ حَجٌّ':Predicate, #1: 1	أَخْرَجَ الْيَسَارَ
u'أَخَّرَ حَدٌّ':Predicate, #6: 6	أَخَّرَ الْحَجَّ
u'أَخَّرَ حَقٌّ':Predicate, #1: 1	أَخَّرَ حَدَّ
u'أَخَّرَ حُكْمٌ':Predicate, #2: 2	أَخَّرَ حَقَّ
u'أَخَّرَ حَلْقٌ':Predicate, #2: 2	أَخَّرَ الْحُكْمَ
u'أَخَّرَ حَوَالَةٌ':Predicate, #12: 12	أَخَّرَ الْحَلْقَ
u'أَخَّرَ ختان':Predicate, #1: 1	أَخَّرَ الْحَوَالَةَ
u'أَخَّرَ خِتَانٌ':Predicate, #1: 1	أَخَّرَ الْخِتَانَ
u'أَخَّرَ خطبة':Predicate, #1: 1	أَخَّرَ الْخِتَانَ
u'أَخَّرَ خُطْبَةٌ':Predicate, #1: 1	أَخَّرَ الْخُطْبَةَ
u'أَخَّرَ خُلْعٌ':Predicate, #1: 1	أَخَّرَ الْخُطْبَةَ
u'أَخَّرَ خيار':Predicate, #2: 2	أَخَّرَ الْخُلْعَ
u'أَخَّرَ خِيَارٌ':Predicate, #1: 1	أَخَّرَ خِيَارَ
u'أَخَّرَ دُخُولٌ':Predicate, #1: 1	أَخَّرَ خِيَارَ
u'أَخَّرَ دُعَاءٌ':Predicate, #1: 1	أَخَّرَ الدُّخُولَ
u'أَخَّرَ دفع':Predicate, #1: 1	أَخَّرَ الدُّعَاءَ
u'أَخَّرَ دَفْعٌ':Predicate, #5: 5	أَخَّرَ دَفْعَ
u'أَخَّرَ ذكر':Predicate, #5: 5	أَخَّرَ دَفْعَ
u'أَخَّرَ ذِكْرٌ':Predicate, #2: 2	أَخَّرَ ذِكْرَ
u'أَخَّرَ راتِب':Predicate, #2: 2	أَخَّرَ ذِكْرَ
u'أَخَّرَ رَأْسٌ':Predicate, #1: 1	أَخَّرَ الرَّاتِبَةَ
u'أَخَّرَ رُجُوعٌ':Predicate, #1: 1	أَخَّرَ رَأْسَ
u'أَخَّرَ رَدٌّ':Predicate, #2: 2	أَخَّرَ الرُّجُوعَ
u'أَخَّرَ رَدٌّ':Predicate, #1: 1	أَخَّرَ رَدَّ
u'أَخَّرَ رَسُولٌ':Subject, #3: 3	أَخَّرَ الرَّدَّ
u'أَخَّرَ رَمْيٌ':Predicate, #4: 4	أَخَّرَ رَسُولُ
u'أَخَّرَ رَمْيٌ':Predicate, #4: 4	أَخَّرَ الرَّمْيَ
u'أَخَّرَ زِراعَةٌ':Predicate, #8: 8	أَخَّرَ رَمْيَ
u'أَخَّرَ زَرْعٌ':Predicate, #1: 1	أَخَّرَ الزِّرَاعَةَ
u'أَخَّرَ زَكاةٌ':Predicate, #1: 1	أَخَّرَ الزَّرْعَ
u'أَخَّرَ زَكاةٌ':Predicate, #1: 1	أَخَّرَ زَكَاةَ
u'أَخَّرَ زِيارَةٌ':Predicate, #4: 4	أَخَّرَ الزَّكَاةَ
u'أَخْرَسَ أَصَمّ':Predicate, #1: 1	أَخَّرَ الزِّيَارَةَ
u'أَخَّرَ سجدة':Predicate, #2: 2	أَخْرَسَ أَصَمَّ
u'أَخَّرَ سَجْدَةٌ':Predicate, #1: 1	أَخَّرَ سَجْدَةَ
u'أَخَّرَ سُجُودٌ':Predicate, #1: 1	أَخَّرَ سَجْدَةَ
u'أَخْرَسَ حالٌ':Predicate, #1: 1	أَخَّرَ سُجُودَ
u'أَخَّرَ سلام':Predicate, #1: 1	أَخْرَسَ حَالَ
u'أَخَّرَ سَلاَمٌ':Predicate, #1: 1	أَخَّرَ السَّلَامَ
u'أَخْرَسَ مَفْهُومٌ':Subject, #1: 1	أَخَّرَ السَّلَامَ
u'أَخَّرَ سُنَّةٌ':Predicate, #1: 1	أَخْرَسَ مَفْهُومَةٌ
u'أَخَّرَ سُورَةٌ':Predicate, #2: 2	أَخَّرَ السُّنَّةَ
u'أَخْرَسَ وَلَهٌ':Subject, #1: 1	أَخَّرَ السُّورَةَ
u'أَخَّرَ شَرْطٌ':Predicate, #1: 1	أَخْرَسَ وَلَهُ
u'أَخَّرَ شَرْعٌ':Subject, #22: 22	أَخَّرَ الشَّرْطَ
u'أَخَّرَ شُرُوعٌ':Predicate, #1: 1	أَخَّرَ الشَّرْعُ
u'أَخَّرَ شَهَادَةٌ':Predicate, #1: 1	أَخَّرَ الشُّرُوعَ
u'أَخَّرَ شَيْخٌ':Subject, #1: 1	أَخَّرَ الشَّهَادَةَ
u'أَخَّرَ صداق':Predicate, #1: 1	أَخَّرَ الشَّيْخُ
u'أَخَّرَ صَدَاقٌ':Predicate, #1: 1	أَخَّرَ الصَّدَاقَ
u'أَخَّرَ صَلاَةٌ':Predicate, #1: 1	أَخَّرَ الصَّدَاقَ
u'أَخَّرَ صَلاَةٌ':Predicate, #15: 15	أَخَّرَ الصَّلَاةَ
u'أَخَّرَ صَلاَةٌ':Predicate, #1: 1	أَخَّرَ الصَّلاةَ
u'أَخَّرَ صَلاَةٌ':Predicate, #2: 2	أَخَّرَ صَلاةَ
u'أَخَّرَ صَلاَةٌ':Predicate, #3: 3	أَخَّرَ صَلَاةَ
u'أَخَّرَ صَوْمٌ':Predicate, #6: 6	أَخَّرَ الصَّلاَةَ
u'أَخَّرَ صِيَامٌ':Predicate, #2: 2	أَخَّرَ الصَّوْمَ
u'أَخَّرَ ضَمِنٌ':Predicate, #1: 1	أَخَّرَ صِيَامَ
u'أَخَّرَ طَالِبٌ':Subject, #2: 2	أَخَّرَ ضَمِنَ
u'أَخَّرَ طَائِفٌ':Subject, #9: 9	أَخَّرَ الطَّالِبُ
u'أَخَّرَ طَلاَقٌ':Predicate, #1: 1	أَخَّرَ الطَّائِفُ
u'أَخَّرَ طلب':Predicate, #3: 3	أَخَّرَ الطَّلَاقَ
u'أَخَّرَ طَلَبٌ':Predicate, #11: 11	أَخَّرَ الطَّلَبَ
u'أَخَّرَ طواف':Predicate, #11: 11	أَخَّرَ الطَّلَبَ
u'أَخَّرَ طَوَافٌ':Predicate, #11: 11	أَخَّرَ طَوَافَ
u'أَخَّرَ طواف':Predicate, #11: 11	أَخَّرَ طَوَافَ
u'أَخَّرَ طَوَافٌ':Predicate, #4: 4	أَخَّرَ الطَّوَافَ
u'أَخَّرَ ظَرْفٌ':Predicate, #4: 4	أَخَّرَ الطَّوَافَ
u'أَخَّرَ ظُهْرٌ':Predicate, #3: 3	أَخَّرَ الظَّرْفَ
u'أَخَّرَ عَاقِدٌ':Subject, #20: 20	أَخَّرَ الظُّهْرَ
u'أَخَّرَ عتق':Predicate, #1: 1	أَخَّرَ الْعَاقِدُ
u'أَخَّرَ عِتْقٌ':Predicate, #1: 1	أَخَّرَ الْعِتْقَ
u'أَخَّرَ عِدَّةٌ':Predicate, #1: 1	أَخَّرَ الْعِتْقَ
u'أَخَّرَ عَرْضٌ':Predicate, #1: 1	أَخَّرَ عِدَّةَ
u'أَخَّرَ عِشَاءٌ':Predicate, #1: 1	أَخَّرَ عَرْضَ
u'أَخَّرَ عَصْرٌ':Predicate, #6: 6	أَخَّرَ الْعِشَاءَ
u'أَخَّرَ عمرة':Predicate, #6: 6	أَخَّرَ الْعَصْرَ
u'أَخَّرَ عُمْرَةٌ':Predicate, #2: 2	أَخَّرَ الْعُمْرَةَ
u'أَخَّرَ غَرِيمٌ':Predicate, #2: 2	أَخَّرَ الْعُمْرَةَ
u'أَخَّرَ غُسْلٌ':Predicate, #2: 2	أَخَّرَ الْغَرِيمَ
u'أَخَّرَ غَسْلٌ':Predicate, #1: 1	أَخَّرَ الْغُسْلَ
u'أَخَّرَ غير':Subject, #1: 1	أَخَّرَ غَسْلَ
u'أَخَّرَ غَيْرٌ':Subject, #1: 1	أَخَّرَ غَيْرُ
u'أَخَّرَ فَاتِحٌ':Predicate, #1: 1	أَخَّرَ غَيْرُ
u'أَخَّرَ فَاتِحَةٌ':Predicate, #1: 1	أَخَّرَ الْفَاتِحَةَ
u'أَخَّرَ فَجْرٌ':Predicate, #1: 1	أَخَّرَ الْفَاتِحَةَ
u'أَخَّرَ فِدْيَةٌ':Predicate, #1: 1	أَخَّرَ الْفَجْرَ
u'أَخَّرَ فُرْصَةٌ':Predicate, #1: 1	أَخَّرَ الْفِدْيَةَ
u'أَخَّرَ فَرْضٌ':Predicate, #1: 1	أَخَّرَ الْفُرْصَةَ
u'أَخَّرَ فَصْلٌ':Predicate, #1: 1	أَخَّرَ الْفَرْضَ
u'أَخَّرَ فِعْلٌ':Predicate, #3: 3	أَخَّرَ فَصْلَ
u'أَخَّرَ فلان':Predicate, #1: 1	أَخَّرَ فِعْلَ
u'أَخَّرَ قَاتِلٌ':Predicate, #1: 1	أَخَّرَ الرَّاتِبَةَ
u'أَخَّرَ قَالٌ':Predicate, #1: 1	أَخَّرَ الْقَاتِلَ
u'أَخَّرَ قَبْضٌ':Predicate, #1: 1	أَخَّرَ قَالَ
u'أَخَّرَ قتال':Predicate, #1: 1	أَخَّرَ الْقَبْضَ
u'أَخَّرَ قِتَالٌ':Predicate, #2: 2	أَخَّرَ الْقِتَالَ
u'أَخَّرَ قَدَرٌ':Subject, #2: 2	أَخَّرَ الْقِتَالَ
u'أَخَّرَ قُدُومٌ':Predicate, #1: 1	أَخَّرَ الْقَدَرُ
u'أَخَّرَ قِرَاءةٌ':Predicate, #1: 1	أَخَّرَ الْقُدُومَ
u'أَخَّرَ قُرْبَانٌ':Predicate, #1: 1	أَخَّرَ الْقِرَاءَةَ
u'أَخَّرَ قَضَاءٌ':Predicate, #1: 1	أَخَّرَ الْقُرْبَانَ
u'أَخَّرَ قَضَاءٌ':Predicate, #5: 5	أَخَّرَ الْقَضَاءَ
u'أَخَّرَ قَطْعٌ':Predicate, #8: 8	أَخَّرَ قَضَاءَ
u'أَخَّرَ قَطْعٌ':Predicate, #1: 1	أَخَّرَ الْقَطْعَ
u'أَخَّرَ قول':Predicate, #3: 3	أَخَّرَ قَطْعَ
u'أَخَّرَ قَوْلٌ':Predicate, #1: 1	أَخَّرَ الْقَوْلَ
u'أَخَّرَ قَوْمٌ':Predicate, #1: 1	أَخَّرَ الْقَوْلَ
u'أَخَّرَ قِيَاسٌ':Subject, #1: 1	أَخَّرَ قَوْمَ
u'أَخَّرَ قَيِّمٌ':Subject, #1: 1	أَخَّرَ الْقِيَاسُ
u'أَخَّرَ كِتَابٌ':Predicate, #1: 1	أَخَّرَ الْقَيِّمُ
u'أَخَّرَ كَفِيلٌ':Predicate, #1: 1	أَخَّرَ الْكِتَابَ
u'أَخَّرَ لَيْلٌ':Predicate, #2: 2	أَخَّرَ الْكَفِيلَ
u'أَخَّرَ مَالٌ':Predicate, #1: 1	أَخَّرَ لَيْلَةً
u'أَخَّرَ مَأْمُورٌ':Predicate, #1: 1	أَخَّرَ الْمَالَ
u'أَخَّرَ مُتَقَدِّمٌ':Predicate, #1: 1	أَخَّرَ الْمَأْمُورَ
u'أَخَّرَ مَجْنِيٌّ':Subject, #2: 2	أَخَّرَ الْمُتَقَدِّمَةَ
u'أَخَّرَ مُحْتَالٌ':Predicate, #2: 2	أَخَّرَ الْمَجْنِيُّ
u'أَخَّرَ مُحْتَكِرٌ':Subject, #1: 1	أَخَّرَ الْمُحْتَالَ
u'أَخَّرَ مُدَرِّسٌ':Subject, #1: 1	أَخَّرَ الْمُحْتَكِرُ
u'أَخَّرَ مَرِيضٌ':Subject, #1: 1	أَخَّرَ الْمُدَرِّسُ
u'أَخَّرَ مُسَافِرٌ':Subject, #2: 2	أَخَّرَ الْمَرِيضُ
u'أَخَّرَ مُسْتَحِقٌّ':Subject, #1: 1	أَخَّرَ الْمُسَافِرُ
u'أَخَّرَ مُصَنِّفٌ':Subject, #1: 1	أَخَّرَ مُسْتَحِقُّ
u'أَخَّرَ مُضَارِبٌ':Subject, #2: 2	أَخَّرَ الْمُصَنِّفُ
u'أَخَّرَ مَعْرِفَةٌ':Predicate, #1: 1	أَخَّرَ الْمُضَارِبُ
u'أَخَّرَ مَعْرِفَة':Predicate, #1: 1	أَخَّرَ مَعْرِفَةَ
u'أَخَّرَ مَعْطُوف':Predicate, #1: 1	أَخَّرَ مَعْرِفَةَ
u'أَخَّرَ مَعْمُولٌ':Predicate, #1: 1	أَخَّرَ الْمَعْطُوفَ
u'أَخَّرَ مَغْرِبٌ':Predicate, #1: 1	أَخَّرَ الْمَعْمُولَ
u'أَخَّرَ مُقَدَّمٌ':Predicate, #10: 10	أَخَّرَ الْمَغْرِبَ
u'أَخَّرَ مُؤَدّاة':Predicate, #1: 1	أَخَّرَ الْمُقَدَّمَةَ
u'أَخَّرَ ناذِر':Subject, #1: 1	أَخَّرَ الْمُؤَدَّاةَ
u'أَخَّرَ نَبِيٌّ':Subject, #1: 1	أَخَّرَ النَّاذِرُ
u'أَخَّرَ نُجُومٌ':Predicate, #2: 2	أَخَّرَ النَّبِيُّ
u'أَخَّرَ نُزُولٌ':Predicate, #1: 1	أَخَّرَ نُجُومَ
u'أَخَّرَ نُسُكٌ':Predicate, #1: 1	أَخَّرَ النُّزُولَ
u'أَخَّرَ نَقْدٌ':Predicate, #1: 1	أَخَّرَ النُّسُكَ
u'أَخَّرَ نَقْد':Predicate, #1: 1	أَخَّرَ النَّقْدَ
u'أَخَّرَ وَاجِبٌ':Predicate, #1: 1	أَخَّرَ النَّقْدَ
u'أَخَّرَ وَصِيٌّ':Predicate, #3: 3	أَخَّرَ الْوَاجِبَ
u'أَخَّرَ وَصِيَّةٌ':Predicate, #2: 2	أَخَّرَ الْوَصِيَّةَ
u'أَخَّرَ وَكِيلٌ':Subject, #2: 2	أَخَّرَ الْوَصِيَّةَ
u'أَخَّرَ وَلاَءٌ':Predicate, #1: 1	أَخَّرَ الْوَكِيلُ
u'أَخَّرَ يَمِينٌ':Predicate, #2: 2	أَخَّرَ وَلَاءَ
u'أَخْطَأَ اِبْنٌ':Subject, #1: 1	أَخَّرَ الْيَمِينَ
u'أَخْطَأَ إمَامٌ':Subject, #2: 2	أَخْطَأَ ابْنُ
u'أَخْطَأَ أهْلٌ':Subject, #1: 1	أَخْطَأَ الْإِمَامُ
u'أَخْطَأَ جَمٌّ':Subject, #2: 2	أَخْطَأَ أَهْلُ
u'أَخْطَأَ جِهَةٌ':Predicate, #1: 1	أَخْطَأَ الْجَمُّ
u'أَخْطَأَ حاكِمٌ':Subject, #1: 1	أَخْطَأَ جِهَةَ
u'أَخْطَأَ حُجَّةٌ':Predicate, #2: 2	أَخْطَأَ الْحَاكِمُ
u'أَخْطَأَ حَقٌّ':Predicate, #3: 3	أَخْطَأَ الْحُجَّةَ
u'أَخْطَأَ خَطِيئَةٌ':Predicate, #2: 2	أَخْطَأَ الْحَقَّ
u'أَخْطَأَ دَليلٌ':Predicate, #1: 1	أَخْطَأَ الْخَطِيئَةَ
u'أَخْطَأَ رَأْيٌ':Predicate, #1: 1	أَخْطَأَ الدَّلِيلَ
u'أَخْطَأَ سُنَّةٌ':Predicate, #1: 1	أَخْطَأَ الرَّأْيَ
u'أَخْطَأَ شَاهِدٌ':Subject, #19: 19	أَخْطَأَ السُّنَّةَ
u'أَخْطَأَ صَوَابٌ':Predicate, #1: 1	أَخْطَأَ الشَّاهِدُ
u'أَخْطَأَ ضَرٌّ':Predicate, #1: 1	أَخْطَأَ الصَّوَابَ
u'أَخْطَأَ طَبِيبٌ':Subject, #1: 1	أَخْطَأَ ضَرَّ
u'أَخْطَأَ طَرِيقٌ':Predicate, #1: 1	أَخْطَأَ الطَّبِيبُ
u'أَخْطَأَ طَرِيقٌ':Predicate, #1: 1	أَخْطَأَ طَرِيقَ
u'أَخْطَأَ ظَنٌّ':Subject, #4: 4	أَخْطَأَ الطَّرِيقَ
u'أَخْطَأَ عَامِلٌ':Subject, #1: 1	أَخْطَأَ ظَنُّهُ
u'أَخْطَأَ عَبْدٌ':Subject, #1: 1	أَخْطَأَ الْعَامِلُ
u'أَخْطَأَ عَدَدٌ':Predicate, #1: 1	أَخْطَأَ عَبْدُ
u'أَخْطَأَ عَدَدٌ':Subject, #3: 3	أَخْطَأَ الْعَدَدَ
u'أَخْطَأَ عُمَرٌ':Subject, #1: 1	أَخْطَأَ عَدَدٌ
u'أَخْطَأَ عند':Predicate, #1: 1	أَخْطَأَ عُمَرُ
u'أَخْطَأَ عين':Predicate, #1: 1	أَخْطَأَ عِنْدَ
u'أَخْطَأَ عَيْنٌ':Predicate, #1: 1	أَخْطَأَ عَيْنَ
u'أَخْطَأَ عَيْن':Predicate, #1: 1	أَخْطَأَ عَيْنَ
u'أَخْطَأَ فلان':Subject, #1: 1	أَخْطَأَ عَيْنَ
u'أَخْطَأَ قِبْلَةٌ':Predicate, #1: 1	أَخْطَأَ حَاتِمٌ
u'أَخْطَأَ قِرْطَاسٌ':Predicate, #10: 10	أَخْطَأَ الْقِبْلَةَ
u'أَخْطَأَ كَاتِبٌ':Subject, #1: 1	أَخْطَأَ الْقِرْطَاسَ
u'أَخْطَأَ كَبِيرٌ':Subject, #1: 1	أَخْطَأَ الْكَاتِبُ
u'أَخْطَأَ مَالِكٌ':Subject, #1: 1	أَخْطَأَ الْكَبِيرُ
u'أَخْطَأَ مثل':Predicate, #1: 1	أَخْطَأَ مَالِكٌ
u'أَخْطَأَ مِثْلٌ':Predicate, #1: 1	أَخْطَأَ مِثْلَ
u'أَخْطَأَ مُجْتَهِد':Subject, #1: 1	أَخْطَأَ مِثْلَ
u'أَخْطَأَ مُفَصَّلٌ':Predicate, #1: 1	أَخْطَأَ مُجْتَهِدٌ
u'أَخْطَأَ نَاسٌ':Subject, #1: 1	أَخْطَأَ الْمُفَصّلَ
u'أَخْطَأَ نَصٌّ':Predicate, #2: 2	أَخْطَأَ النَّاسُ
u'أَخْطَأَ نَفَرٌ':Subject, #2: 2	أَخْطَأَ النَّصَّ
u'أَخْطَأَ نَقَّادٌ':Subject, #1: 1	أَخْطَأَ نَفَرٌ
u'أَخْطَأَ واحد':Predicate, #1: 1	أَخْطَأَ النَّقَّادُ
u'أَخْطَأَ وَاحِدٌ':Predicate, #1: 1	أَخْطَأَ وَاحِدَةَ
u'أَخْطَأَ واحد':Subject, #1: 1	أَخْطَأَ وَاحِدَةَ
u'أَخْطَأَ وَاحِدٌ':Subject, #1: 1	أَخْطَأَ وَاحِدٌ
u'أَخْطَأَ وصل':Predicate, #1: 1	أَخْطَأَ وَاحِدٌ
u'أَخْطَأَ وَقْتٌ':Predicate, #1: 1	أَخْطَأَ وَصَلَ
u'إِخْفَاءٌ أَعْمَالٌ':Added, #1: 1	أَخْطَأَ الْوَقْتَ
u'إِخْفَاءٌ تَشَهُّدٌ':Added, #1: 1	إِخْفَاءِ الْأَعْمَالِ
u'أَخَفَّ صَلاَةٌ':Predicate, #1: 1	إِخْفَاءِ التَّشَهُّدِ
u'أَخَفَّ صَلاَةٌ':Predicate, #1: 1	أَخَفَّ الصَّلَاةَ
u'أَخْفَى رَجُلٌ':Predicate, #2: 2	أَخَفَّ الصَّلاَةَ
u'أَخْفَى رَجُلٌ':Subject, #1: 1	أَخْفَى الرَّجُلَ
u'أَخْفَى رَسُولٌ':Subject, #1: 1	أَخْفَى رَجُلٌ
u'أَخْفَى غناء':Predicate, #1: 1	أَخْفَى رَسُولُ
u'أَخْفَى غِنَاءٌ':Predicate, #1: 1	أَخْفَى الْغِنَاءَ
u'أَخْفَى لَيْلٌ':Predicate, #1: 1	أَخْفَى الْغِنَاءَ
u'أَخَلَّ إمَامٌ':Subject, #2: 2	أَخْفَى لَيْلَةَ
u'أَخْلَصَ إيمَانٌ':Predicate, #1: 1	أَخَلَّ الْإِمَامُ
u'أَخْلَفَ بَدَلٌ':Subject, #1: 1	أَخْلَصَ الْإِيمَانَ
u'أَخْلَفَ دونٌ':Predicate, #1: 1	أَخْلَفَ بَدَلُ
u'أَخْلَفَ شَرْطٌ':Predicate, #1: 1	أَخْلَفَ دُونَ
u'أَخْلَفَ غَنَمٌ':Predicate, #1: 1	أَخْلَفَ الشَّرْطَ
u'أَخْلَفَ ولد':Subject, #1: 1	أَخْلَفَ الْغَنَمَ
u'أَخْلَفَ وَلَدٌ':Subject, #2: 2	أَخْلَفَ الْوَلَدُ
u'أَخَلَّ مُتَكَلِّمٌ':Subject, #2: 2	أَخْلَفَ الْوَلَدُ
u'أَخَلَّ مُصَنِّفٌ':Subject, #1: 1	أَخَلَّ الْمُتَكَلِّمُ
u'أَخَلَّ واحد':Subject, #5: 5	أَخَلَّ الْمُصَنِّفُ
u'أَخَلَّ وَاحِدٌ':Subject, #2: 2	أَخَلَّ وَاحِدٌ
u'أَخْلَى جَانِبٌ':Predicate, #2: 2	أَخَلَّ وَاحِدٌ
u'أَخْلَى وُجُودٌ':Predicate, #1: 1	أَخْلَى جَانِبَ
u'آخَى بَيْنٌ':Predicate, #1: 1	أَخْلَى الْوُجُودَ
u'آخَى رَجُلٌ':Subject, #14: 14	آخَى بَيْنَ
u'آخَى رَسُولٌ':Subject, #1: 1	آخَى الرَّجُلُ
u'آخَى نَبِيٌّ':Subject, #8: 8	آخَى رَسُولُ
u'أَدَاءٌ اِبْنٌ':Added, #17: 17	آخَى النَّبِيُّ
u'أَدَاءٌ أُجْرَةٌ':Added, #1: 1	أَدَاءِ ابْنِهِ
u'أَدَاءٌ أُجْرَةٌ':Added, #1: 1	أَدَاءُ الْأُجْرَةِ
u'أَدَاءٌ أحَدٌ':Added, #1: 1	أَدَاءِ الْأُجْرَةِ
u'أَدَاءٌ أَحْكَامٌ':Added, #1: 1	أَدَاءُ أَحَدِ
u'أَدَاءٌ أخْرِجَةٌ':Added, #1: 1	أَدَاءِ الْأَحْكَامِ
u'أَدَاءٌ أَرْبَعَةٌ':Added, #1: 1	أَدَاءِ الْأَخْرِجَةِ
u'أَدَاءٌ أَرْكانٌ':Added, #1: 1	أَدَاءِ أَرْبَعَةِ
u'أَدَاءٌ أَرْكَانٌ':Added, #1: 1	أَدَاءُ الْأَرْكَانِ
u'أَدَاءٌ أَرْكانٌ':Added, #1: 1	أَدَاءُ الْأَرْكَانِ
u'أَدَاءٌ أَرْكَانٌ':Added, #3: 3	أَدَاءِ أَرْكَانِهِ
u'أَدَاءٌ أَرْكانٌ':Added, #3: 3	أَدَاءِ أَرْكَانِهِ
u'أَدَاءٌ أَرْكانٌ':Added, #3: 3	أَدَاءَ الْأَرْكَانِ
u'أَدَاءٌ أَرْكَانٌ':Added, #3: 3	أَدَاءِ الْأَرْكَانِ
u'أَدَاءٌ أَرْكَانٌ':Added, #3: 3	أَدَاءَ الْأَرْكَانِ
u'أَدَاءٌ أُسْبُوعٌ':Added, #3: 3	أَدَاءِ الْأَرْكَانِ
u'أَدَاءٌ أَشْهُرٌ':Added, #1: 1	أَدَاءِ أُسْبُوعٍ
u'أَدَاءٌ أَصْحَابٌ':Added, #1: 1	أَدَاءِ أَشْهُرِ
u'أَدَاءٌ أصل':Added, #1: 1	أَدَاءِ أَصْحَابِ
u'أَدَاءٌ أًصْلٌ':Added, #1: 1	أَدَاءِ أَصْلِ
u'أَدَاءٌ أصل':Added, #1: 1	أَدَاءِ أَصْلِ
u'أَدَاءٌ أصل':Added, #1: 1	أَدَاءُ الْأَصْلِ
u'أَدَاءٌ أًصْلٌ':Added, #1: 1	أَدَاءِ الْأَصْلِ
u'أَدَاءٌ أًصْلٌ':Added, #1: 1	أَدَاءُ الْأَصْلِ
u'أَدَاءٌ أعْظَمُ':Added, #1: 1	أَدَاءِ الْأَصْلِ
u'أَدَاءٌ أَعْمَالٌ':Added, #1: 1	أَدَاءُ أَعْظَمِ
u'أَدَاءٌ أَعْمَالٌ':Added, #12: 12	أَدَاءِ الْأَعْمَالِ
u'أَدَاءٌ أَعْمَالٌ':Added, #1: 1	أَدَاءُ الْأَعْمَالِ
u'أَدَاءٌ أَفْعَالٌ':Added, #2: 2	أَدَاءُ أَعْمَالِ
u'أَدَاءٌ أَفْعَالٌ':Added, #12: 12	أَدَاءُ الْأَفْعَالِ
u'أَدَاءٌ أَفْعَالٌ':Added, #13: 13	أَدَاءِ الْأَفْعَالِ
u'أَدَاءٌ أَفْعَالٌ':Added, #1: 1	أَدَاءَ أَفْعَالٍ
u'أَدَاءٌ أَفْعَالٌ':Added, #2: 2	أَدَاءُ أَفْعَالِ
u'أَدَاءٌ أَفْعَالٌ':Added, #2: 2	أَدَاءِ أَفْعَالِ
u'أَدَاءٌ أقْصَرُ':Added, #2: 2	أَدَاءَ الْأَفْعَالِ
u'أَدَاءٌ أقَلُّ':Added, #1: 1	أَدَاءِ أَقْصَرِ
u'أَدَاءٌ أَكْثَرُ':Added, #1: 1	أَدَاءِ الْأَقَلِّ
u'أَدَاءٌ أَكْثَرُ':Added, #1: 1	أَدَاءَ أَكْثَرِ
u'أَدَاءٌ أَكْثَرُ':Added, #1: 1	أَدَاءِ أَكْثَرِ
u'أَدَاءٌ أَكْثَرُ':Added, #2: 2	أَدَاءُ أَكْثَرِ
u'أَدَاءٌ أَكْمَلُ':Added, #3: 3	أَدَاءِ الْأَكْثَرِ
u'أَدَاءٌ ألف':Added, #1: 1	أَدَاءِ الْأَكْمَلِ
u'أَدَاءٌ ألْفٌ':Added, #1: 1	أَدَاءَ الْأَلْفِ
u'أَدَاءٌ أَلْفٌ':Added, #1: 1	أَدَاءَ الْأَلْفِ
u'أَدَاءٌ ألْفٌ':Added, #1: 1	أَدَاءَ الْأَلْفِ
u'أَدَاءٌ أَلْفٌ':Added, #1: 1	أَدَاءِ أَلْفٍ
u'أَدَاءٌ ألف':Added, #1: 1	أَدَاءِ أَلْفٍ
u'أَدَاءٌ ألْفٌ':Added, #8: 8	أَدَاءِ الْأَلْفِ
u'أَدَاءٌ أَلْفٌ':Added, #8: 8	أَدَاءِ الْأَلْفِ
u'أَدَاءٌ أَلْفَاظٌ':Added, #8: 8	أَدَاءِ الْأَلْفِ
u'أَدَاءٌ إمَامٌ':Added, #1: 1	أَدَاءِ الْأَلْفَاظِ
u'أَدَاءٌ أمَانٌ':Added, #1: 1	أَدَاءِ الْإِمَامِ
u'أَدَاءٌ أمَانٌ':Added, #1: 1	أَدَاءِ الأَمَانَاتِ
u'أَدَاءٌ أمَانَةٌ':Added, #2: 2	أَدَاءِ الْأَمَانَاتِ
u'أَدَاءٌ أمَانَةٌ':Added, #1: 1	أَدَاءِ الأَمَانَاتِ
u'أَدَاءٌ أمَانَةٌ':Added, #1: 1	أَدَاءَ الْأَمَانَةِ
u'أَدَاءٌ أمَانَةٌ':Added, #1: 1	أَدَاءُ أَمَانَةٍ
u'أَدَاءٌ أمَانَةٌ':Added, #2: 2	أَدَاءِ الْأَمَانَاتِ
u'أَدَاءٌ أمَانَةٌ':Added, #2: 2	أَدَاءُ الْأَمَانَةِ
u'أَدَاءٌ آمِرٌ':Added, #6: 6	أَدَاءِ الْأَمَانَةِ
u'أَدَاءٌ إِمْكانٌ':Added, #1: 1	أَدَاءِ الْآمِرِ
u'أَدَاءٌ أوامر':Added, #1: 1	أَدَاءِ إمْكَانِ
u'أَدَاءٌ أَوامِرُ':Added, #1: 1	أَدَاءِ أَوَامِرِ
u'أَدَاءٌ أَوَّلُ':Added, #1: 1	أَدَاءِ أَوَامِرِ
u'أَدَاءٌ أَيْمَانٌ':Added, #3: 3	أَدَاءِ الْأَوَّلِ
u'أَدَاءٌ إيمَانٌ':Added, #1: 1	أَدَاءِ الْأَيْمَانِ
u'أَدَاءٌ إيمَانٌ':Added, #1: 1	أَدَاءُ الْإِيمَانِ
u'أَدَاءٌ بَدَلٌ':Added, #1: 1	أَدَاءِ الْإِيمَانِ
u'أَدَاءٌ بَدَلٌ':Added, #1: 1	أَدَاءَ الْبَدَلِ
u'أَدَاءٌ بَدَلٌ':Added, #1: 1	أَدَاءُ بَدَلِ
u'أَدَاءٌ بَدَلٌ':Added, #26: 26	أَدَاءِ الْبَدَلِ
u'أَدَاءٌ بَدَلٌ':Added, #27: 27	أَدَاءِ بَدَلِ
u'أَدَاءٌ بَعْضٌ':Added, #8: 8	أَدَاءُ الْبَدَلِ
u'أَدَاءٌ بَعْضٌ':Added, #1: 1	أَدَاءَ الْبَعْضِ
u'أَدَاءٌ بَعْضٌ':Added, #1: 1	أَدَاءِ بَعْضِ
u'أَدَاءٌ بَعْضٌ':Added, #1: 1	أَدَاءِ بَعْضِهِ
u'أَدَاءٌ بَعْضٌ':Added, #2: 2	أَدَاءِ الْبَعْضِ
u'أَدَاءٌ بَعيرٌ':Added, #2: 2	أَدَاءَ بَعْضِ
u'أَدَاءٌ بَقِيَّةٌ':Added, #1: 1	أَدَاءِ الْبَعِيرِ
u'أَدَاءٌ بَقِيَّةٌ':Added, #1: 1	أَدَاءُ بَقِيَّةِ
u'أَدَاءٌ تَرَاوِيحُ':Added, #1: 1	أَدَاءِ بَقِيَّةِ
u'أَدَاءٌ تَرَاوِيحُ':Added, #1: 1	أَدَاءَ التَّرَاوِيحِ
u'أَدَاءٌ تَرَاوِيحُ':Added, #1: 1	أَدَاءِ التَّرَاوِيحِ
u'أَدَاءٌ تَطَوُّعٌ':Added, #2: 2	أَدَاءُ التَّرَاوِيحِ
u'أَدَاءٌ تَطَوُّعٌ':Added, #1: 1	أَدَاءِ التَّطَوُّعِ
u'أَدَاءٌ تَطَوُّعٌ':Added, #2: 2	أَدَاءَ التَّطَوُّعِ
u'أَدَاءٌ تَمْييزٌ':Added, #2: 2	أَدَاءُ التَّطَوُّعِ
u'أَدَاءٌ ثَانِي':Added, #1: 1	أَدَاءِ التَّمْيِيزِ
u'أَدَاءٌ ثَانِيَةٌ':Added, #1: 1	أَدَاءُ الثَّانِيَةِ
u'أَدَاءٌ ثَلاثَةٌ':Added, #1: 1	أَدَاءُ الثَّانِيَةِ
u'أَدَاءٌ ثَمَنٌ':Added, #1: 1	أَدَاءِ ثَلَاثَةِ
u'أَدَاءٌ ثَمَنٌ':Added, #21: 21	أَدَاءِ الثَّمَنِ
u'أَدَاءٌ ثَمَنٌ':Added, #2: 2	أَدَاءُ الثَّمَنِ
u'أَدَاءٌ ثَمَنٌ':Added, #2: 2	أَدَاءُ ثَمَنٍ
u'أَدَاءٌ ثَوْبٌ':Added, #3: 3	أَدَاءَ الثَّمَنِ
u'أَدَاءٌ جُزْءٌ':Added, #1: 1	أَدَاءِ ثَوْبٍ
u'أَدَاءٌ جُزْءٌ':Added, #1: 1	أَدَاءَ جُزْءٍ
u'أَدَاءٌ جَزَاءٌ':Added, #2: 2	أَدَاءُ جُزْءٍ
u'أَدَاءٌ جَزَاءٌ':Added, #1: 1	أَدَاءَ الْجَزَاءِ
u'أَدَاءٌ جَزَاءٌ':Added, #2: 2	أَدَاءِ جَزَاءِ
u'أَدَاءٌ جِزْيَةٌ':Added, #6: 6	أَدَاءِ الْجَزَاءِ
u'أَدَاءٌ جِزْيَةٌ':Added, #19: 19	أَدَاءِ الْجِزْيَةِ
u'أَدَاءٌ جِزْيَةٌ':Added, #1: 1	أَدَاءَ الْجِزْيَةِ
u'أَدَاءٌ جِزْيَةٌ':Added, #1: 1	أَدَاءِ جِزْيَةٍ
u'أَدَاءٌ جمعة':Added, #1: 1	أَدَاءِ جِزْيَتِهِ
u'أَدَاءٌ جمعة':Added, #2: 2	أَدَاءَ الْجُمُعَةِ
u'أَدَاءٌ جُمُعَةٌ':Added, #2: 2	أَدَاءُ الْجُمُعَةِ
u'أَدَاءٌ جُمُعَةٌ':Added, #2: 2	أَدَاءَ الْجُمُعَةِ
u'أَدَاءٌ جمعة':Added, #2: 2	أَدَاءُ الْجُمُعَةِ
u'أَدَاءٌ جُمُعَةٌ':Added, #9: 9	أَدَاءِ الْجُمُعَةِ
u'أَدَاءٌ حاضِرٌ':Added, #9: 9	أَدَاءِ الْجُمُعَةِ
u'أَدَاءٌ حاضِرٌ':Added, #1: 1	أَدَاءِ الْحَاضِرَةِ
u'أَدَاءٌ حَجٌّ':Added, #2: 2	أَدَاءِ الْحَاضِرِ
u'أَدَاءٌ حَجٌّ':Added, #12: 12	أَدَاءُ الْحَجِّ
u'أَدَاءٌ حَجّ':Added, #14: 14	أَدَاءِ الْحَجِّ
u'أَدَاءٌ حَجٌّ':Added, #2: 2	أَدَاءُ حَجَّتَيْنِ
u'أَدَاءٌ حَدٌّ':Added, #3: 3	أَدَاءَ الْحَجِّ
u'أَدَاءٌ حُروفٌ':Added, #1: 1	أَدَاءُ الْحَدِّ
u'أَدَاءٌ حِصَّةٌ':Added, #2: 2	أَدَاءِ الْحُرُوفِ
u'أَدَاءٌ حَقٌّ':Added, #1: 1	أَدَاءُ حِصَّتِهِ
u'أَدَاءٌ حَقٌّ':Added, #1: 1	أَدَاءَ الْحَقِّ
u'أَدَاءٌ حَقٌّ':Added, #1: 1	أَدَاءِ حَقِّ
u'أَدَاءٌ حَقٌّ':Added, #1: 1	أَدَاءُ حَقِّهِ
u'أَدَاءٌ حَقٌّ':Added, #1: 1	أَدَاءِ حَقّهِ
u'أَدَاءٌ حَقٌّ':Added, #1: 1	أَدَاءِ حَقِّهِ
u'أَدَاءٌ حَقٌّ':Added, #2: 2	أَدَاءَ حَقِّهِ
u'أَدَاءٌ حَقٌّ':Added, #3: 3	أَدَاءُ الْحَقِّ
u'أَدَاءٌ حَقٌّ':Added, #3: 3	أَدَاءِ حَقٍّ
u'أَدَاءٌ حُقوقٌ':Added, #9: 9	أَدَاءِ الْحَقِّ
u'أَدَاءٌ حُقُوقٌ':Added, #1: 1	أَدَاءُ الْحُقُوقِ
u'أَدَاءٌ حُقوقٌ':Added, #1: 1	أَدَاءُ الْحُقُوقِ
u'أَدَاءٌ حُقوقٌ':Added, #1: 1	أَدَاءُ حُقُوقِهِ
u'أَدَاءٌ حُقُوقٌ':Added, #1: 1	أَدَاءِ حُقُوقِهِ
u'أَدَاءٌ حُقُوقٌ':Added, #1: 1	أَدَاءُ حُقُوقِهِ
u'أَدَاءٌ حُقوقٌ':Added, #1: 1	أَدَاءِ حُقُوقِهِ
u'أَدَاءٌ حُقوقٌ':Added, #2: 2	أَدَاءُ حُقُوقِ
u'أَدَاءٌ حُقُوقٌ':Added, #2: 2	أَدَاءِ حُقُوقِ
u'أَدَاءٌ حُقُوقٌ':Added, #2: 2	أَدَاءُ حُقُوقِ
u'أَدَاءٌ حُقوقٌ':Added, #2: 2	أَدَاءِ حُقُوقِ
u'أَدَاءٌ حُقُوقٌ':Added, #6: 6	أَدَاءِ الْحُقُوقِ
u'أَدَاءٌ حَمْلٌ':Added, #6: 6	أَدَاءِ الْحُقُوقِ
u'أَدَاءٌ حِنْطَةٌ':Added, #1: 1	أَدَاءِ حَمْلِهِ
u'أَدَاءٌ حِنْطَةٌ':Added, #1: 1	أَدَاءُ الْحِنْطَةِ
u'أَدَاءٌ خدمة':Added, #1: 1	أَدَاءِ الْحِنْطَةِ
u'أَدَاءٌ خِدْمَةٌ':Added, #1: 1	أَدَاءَ خِدْمَةٍ
u'أَدَاءٌ خراج':Added, #1: 1	أَدَاءَ خِدْمَةٍ
u'أَدَاءٌ خَرَاجٌ':Added, #2: 2	أَدَاءَ الْخَرَاجِ
u'أَدَاءٌ خَلَفٌ':Added, #2: 2	أَدَاءَ الْخَرَاجِ
u'أَدَاءٌ خَلْفٌ':Added, #1: 1	أَدَاءُ خَلَفِهِ
u'أَدَاءٌ خَلِيفَةٌ':Added, #1: 1	أَدَاءُ خَلْفِهِ
u'أَدَاءٌ خَمْرٌ':Added, #1: 1	أَدَاءُ الْخَلِيفَةِ
u'أَدَاءٌ خُمُسٌ':Added, #1: 1	أَدَاءِ الْخَمْرِ
u'أَدَاءٌ خَمْسَةٌ':Added, #1: 1	أَدَاءَ الْخُمُسِ
u'أَدَاءٌ دَرَاهِمُ':Added, #1: 1	أَدَاءَ الْخَمْسَةِ
u'أَدَاءٌ دِرْهَمٌ':Added, #1: 1	أَدَاءُ الدَّرَاهِمِ
u'أَدَاءٌ دِرْهَم':Added, #1: 1	أَدَاءُ دِرْهَمٍ
u'أَدَاءٌ دِرْهَمٌ':Added, #1: 1	أَدَاءُ دِرْهَمٍ
u'أَدَاءٌ دِرْهَم':Added, #1: 1	أَدَاءُ دِرْهَمَيْنِ
u'أَدَاءٌ دَقيقٌ':Added, #1: 1	أَدَاءُ دِرْهَمَيْنِ
u'أَدَاءٌ دَقيقٌ':Added, #1: 1	أَدَاءُ الدَّقِيقِ
u'أَدَاءٌ دَنانيرُ':Added, #1: 1	أَدَاءِ الدَّقِيقِ
u'أَدَاءٌ دَنانيرُ':Added, #1: 1	أَدَاءُ الدَّنَانِيرِ
u'أَدَاءٌ دِيَةٌ':Added, #1: 1	أَدَاءِ الدَّنَانِيرِ
u'أَدَاءٌ دَيْنٌ':Added, #1: 1	أَدَاءِ الدِّيَةِ
u'أَدَاءٌ دَيْنٌ':Added, #10: 10	أَدَاءِ الدَّيْنِ
u'أَدَاءٌ دَيْنٌ':Added, #2: 2	أَدَاءُ دَيْنِ
u'أَدَاءٌ دَيْنٌ':Added, #4: 4	أَدَاءَ الدَّيْنِ
u'أَدَاءٌ دَيْنٌ':Added, #5: 5	أَدَاءُ الدَّيْنِ
u'أَدَاءٌ دِينارٌ':Added, #7: 7	أَدَاءِ دَيْنِهِ
u'أَدَاءٌ دِينارٌ':Added, #1: 1	أَدَاءُ الدِّينَارِ
u'أَدَاءٌ دُيونٌ':Added, #1: 1	أَدَاءِ الدِّينَارِ
u'أَدَاءٌ دُيونٌ':Added, #1: 1	أَدَاءَ الدُّيُونِ
u'أَدَاءٌ دُيونٌ':Added, #1: 1	أَدَاءُ الدُّيُونِ
u'أَدَاءٌ دُيونٌ':Added, #1: 1	أَدَاءِ الدُّيُونِ
u'أَدَاءٌ دُيونٌ':Added, #1: 1	أَدَاءُ دُيُونِ
u'أَدَاءٌ دُيونٌ':Added, #1: 1	أَدَاءِ دُيُونِهِ
u'أَدَاءٌ رَبُّ':Added, #2: 2	أَدَاءِ دُيُونِ
u'أَدَاءٌ رُبْعٌ':Added, #1: 1	أَدَاءُ رَبِّ
u'أَدَاءٌ رِسَالَةٌ':Added, #1: 1	أَدَاءِ رُبْعِ
u'أَدَاءٌ رَسُولٌ':Added, #1: 1	أَدَاءِ الرِّسَالَةِ
u'أَدَاءٌ ركعة':Added, #1: 1	أَدَاءَ الرَّسُولِ
u'أَدَاءٌ ركعة':Added, #1: 1	أَدَاءَ الرَّكْعَةِ
u'أَدَاءٌ رَكْعَةٌ':Added, #1: 1	أَدَاءِ الرَّكْعَةِ
u'أَدَاءٌ رَكْعَةٌ':Added, #1: 1	أَدَاءَ الرَّكْعَةِ
u'أَدَاءٌ ركعة':Added, #1: 1	أَدَاءِ الرَّكْعَةِ
u'أَدَاءٌ رَكْعَةٌ':Added, #1: 1	أَدَاءِ رَكْعَةٍ
u'أَدَاءٌ رُكْنٌ':Added, #1: 1	أَدَاءِ رَكْعَةٍ
u'أَدَاءٌ رُكْن':Added, #13: 13	أَدَاءِ رُكْنٍ
u'أَدَاءٌ رُكْنٌ':Added, #13: 13	أَدَاءِ رُكْنٍ
u'أَدَاءٌ رُكْن':Added, #2: 2	أَدَاءُ الرُّكْنِ
u'أَدَاءٌ رُكْنٌ':Added, #2: 2	أَدَاءُ الرُّكْنِ
u'أَدَاءٌ رُكْن':Added, #2: 2	أَدَاءُ رُكْنٍ
u'أَدَاءٌ رُكْنٌ':Added, #2: 2	أَدَاءُ رُكْنٍ
u'أَدَاءٌ رُكْن':Added, #3: 3	أَدَاءَ رُكْنٍ
u'أَدَاءٌ رُكْنٌ':Added, #3: 3	أَدَاءَ رُكْنٍ
u'أَدَاءٌ رُكْنٌ':Added, #4: 4	أَدَاءَ الرُّكْنِ
u'أَدَاءٌ رُكْن':Added, #4: 4	أَدَاءِ الرُّكْنِ
u'أَدَاءٌ رُكْن':Added, #4: 4	أَدَاءَ الرُّكْنِ
u'أَدَاءٌ رُكوعٌ':Added, #4: 4	أَدَاءِ الرُّكْنِ
u'أَدَاءٌ رَمْيٌ':Added, #1: 1	أَدَاءُ الرُّكُوعِ
u'أَدَاءٌ زَكاةٌ':Added, #1: 1	أَدَاءِ رَمْيِ
u'أَدَاءٌ زَكاةٌ':Added, #13: 13	أَدَاءَ الزَّكَاةِ
u'أَدَاءٌ زَكاةٌ':Added, #1: 1	أَدَاءِ زَكَاةِ
u'أَدَاءٌ زَكاةٌ':Added, #27: 27	أَدَاءُ الزَّكَاةِ
u'أَدَاءٌ زَكاةٌ':Added, #37: 37	أَدَاءِ الزَّكَاةِ
u'أَدَاءٌ زَكاةٌ':Added, #5: 5	أَدَاءُ زَكَاةِ
u'أَدَاءٌ زَكَواتٌ':Added, #7: 7	أَدَاءُ زَكَاتِهِ
u'أَدَاءٌ سابع':Added, #1: 1	أَدَاءُ الزَّكَوَاتِ
u'أَدَاءٌ سَابعٌ':Added, #1: 1	أَدَاءُ السَّابِعَةِ
u'أَدَاءٌ سادس':Added, #1: 1	أَدَاءُ السَّابِعَةِ
u'أَدَاءٌ سادس':Added, #1: 1	أَدَاءَ السَّادِسَةِ
u'أَدَاءٌ سادس':Added, #1: 1	أَدَاءُ السَّادِسَةِ
u'أَدَاءٌ سَادِسٌ':Added, #1: 1	أَدَاءِ السَّادِسَةِ
u'أَدَاءٌ سَادِسٌ':Added, #1: 1	أَدَاءَ السَّادِسَةِ
u'أَدَاءٌ سَادِسٌ':Added, #1: 1	أَدَاءُ السَّادِسَةِ
u'أَدَاءٌ سَائِرٌ':Added, #1: 1	أَدَاءِ السَّادِسَةِ
u'أَدَاءٌ سِتٌّ':Added, #1: 1	أَدَاءِ سَائِرِ
u'أَدَاءٌ سجدة':Added, #1: 1	أَدَاءِ سِتِّ
u'أَدَاءٌ سَجْدَةٌ':Added, #1: 1	أَدَاءَ السَّجْدَةِ
u'أَدَاءٌ سجدة':Added, #1: 1	أَدَاءَ السَّجْدَةِ
u'أَدَاءٌ سجدة':Added, #4: 4	أَدَاءُ السَّجْدَةِ
u'أَدَاءٌ سَجْدَةٌ':Added, #4: 4	أَدَاءِ السَّجْدَةِ
u'أَدَاءٌ سَجْدَةٌ':Added, #4: 4	أَدَاءُ السَّجْدَةِ
u'أَدَاءٌ سُجُودٌ':Added, #4: 4	أَدَاءِ السَّجْدَةِ
u'أَدَاءٌ سِعَايَةٌ':Added, #1: 1	أَدَاءِ سُجُودِ
u'أَدَاءٌ سِعَايَةٌ':Added, #1: 1	أَدَاءِ سِعَايَتِهِ
u'أَدَاءٌ سلام':Added, #5: 5	أَدَاءِ السِّعَايَةِ
u'أَدَاءٌ سَلاَمٌ':Added, #1: 1	أَدَاءِ السَّلَامِ
u'أَدَاءٌ سُنَّةٌ':Added, #1: 1	أَدَاءِ السَّلَامِ
u'أَدَاءٌ سُنَّةٌ':Added, #2: 2	أَدَاءُ السُّنَّةِ
u'أَدَاءٌ سنن':Added, #5: 5	أَدَاءِ السُّنَّةِ
u'أَدَاءٌ سَهْوٌ':Added, #2: 2	أَدَاءِ السُّنَنِ
u'أَدَاءٌ شَاةٌ':Added, #1: 1	أَدَاءُ السَّهْوِ
u'أَدَاءٌ شَرَائِعُ':Added, #1: 1	أَدَاءِ الشَّاةِ
u'أَدَاءٌ شَرْطٌ':Added, #1: 1	أَدَاءِ الشَّرَائِعِ
u'أَدَاءٌ شَطْرٌ':Added, #1: 1	أَدَاءِ الشَّرْطِ
u'أَدَاءٌ شَفْعٌ':Added, #1: 1	أَدَاءِ الشَّطْرِ
u'أَدَاءٌ شَهَادَةٌ':Added, #1: 1	أَدَاءَ شَفْعَيْنِ
u'أَدَاءٌ شَهَادَةٌ':Added, #1: 1	أَدَاءِ شَهَادَةِ
u'أَدَاءٌ شَهَادَةٌ':Added, #20: 20	أَدَاءَ الشَّهَادَةِ
u'أَدَاءٌ شَهَادَةٌ':Added, #21: 21	أَدَاءُ الشَّهَادَةِ
u'أَدَاءٌ شَهَادَةٌ':Added, #2: 2	أَدَاءَ الشَّهَادَاتِ
u'أَدَاءٌ شَهَادَةٌ':Added, #2: 2	أَدَاءُ شَهَادَةٍ
u'أَدَاءٌ شَهَادَةٌ':Added, #3: 3	أَدَاءِ شَهَادَتِهِ
u'أَدَاءٌ شُهُودٌ':Added, #71: 71	أَدَاءِ الشَّهَادَةِ
u'أَدَاءٌ شَيْءٌ':Added, #1: 1	أَدَاءِ الشُّهُودِ
u'أَدَاءٌ شَيْءٌ':Added, #3: 3	أَدَاءَ شَيْءٍ
u'أَدَاءٌ شَيْءٌ':Added, #5: 5	أَدَاءِ شَيْءٍ
u'أَدَاءٌ صَاحِبٌ':Added, #7: 7	أَدَاءُ شَيْءٍ
u'أَدَاءٌ صُبْحٌ':Added, #1: 1	أَدَاءِ صَاحِبِهِ
u'أَدَاءٌ صَبِيٌّ':Added, #1: 1	أَدَاءِ الصُّبْحِ
u'أَدَاءٌ صدقة':Added, #1: 1	أَدَاءُ الصَّبِيِّ
u'أَدَاءٌ صَدَقَةٌ':Added, #1: 1	أَدَاءِ صَدَقَةِ
u'أَدَاءٌ صدقة':Added, #1: 1	أَدَاءِ صَدَقَةِ
u'أَدَاءٌ صَدَقَةٌ':Added, #2: 2	أَدَاءِ الصَّدَقَةِ
u'أَدَاءٌ صَغِيرٌ':Added, #2: 2	أَدَاءِ الصَّدَقَةِ
u'أَدَاءٌ صَلاَةٌ':Added, #3: 3	أَدَاءِ الصَّغِيرِ
u'أَدَاءٌ صَلاَةٌ':Added, #15: 15	أَدَاءَ الصَّلَاةِ
u'أَدَاءٌ صَلاَةٌ':Added, #1: 1	أَدَاءَ صَلَاةٍ
u'أَدَاءٌ صَلاَةٌ':Added, #1: 1	أَدَاءَ صَلَاةِ
u'أَدَاءٌ صَلاَةٌ':Added, #22: 22	أَدَاءُ الصَّلَاةِ
u'أَدَاءٌ صَلاَةٌ':Added, #2: 2	أَدَاءِ صَلَاةِ
u'أَدَاءٌ صَلاَةٌ':Added, #48: 48	أَدَاءِ الصَّلَاةِ
u'أَدَاءٌ صَلَوَاتٌ':Added, #7: 7	أَدَاءُ صَلَاةٍ
u'أَدَاءٌ صَلَوَاتٌ':Added, #1: 1	أَدَاءَ الصَّلَوَاتِ
u'أَدَاءٌ صَلَوَاتٌ':Added, #1: 1	أَدَاءِ الصَّلَوَاتِ
u'أَدَاءٌ صَوْم':Added, #1: 1	أَدَاءِ صَلَوَاتٍ
u'أَدَاءٌ صَوْمٌ':Added, #1: 1	أَدَاءُ الصَّوْمَيْنِ
u'أَدَاءٌ صَوْمٌ':Added, #1: 1	أَدَاءَ صَوْمِ
u'أَدَاءٌ صَوْمٌ':Added, #1: 1	أَدَاءِ صَوْمِ
u'أَدَاءٌ صَوْمٌ':Added, #28: 28	أَدَاءِ الصَّوْمِ
u'أَدَاءٌ صَوْمٌ':Added, #2: 2	أَدَاءُ الصَّوْمِ
u'أَدَاءٌ صَوْمٌ':Added, #2: 2	أَدَاءُ صَوْمِ
u'أَدَاءٌ صِيَامٌ':Added, #4: 4	أَدَاءَ الصَّوْمِ
u'أَدَاءٌ ضَامِنٌ':Added, #1: 1	أَدَاءِ صِيَامِ
u'أَدَاءٌ ضَامِنٌ':Added, #1: 1	أَدَاءَ الضَّامِنِ
u'أَدَاءٌ ضَامِنٌ':Added, #1: 1	أَدَاءُ ضَامِنٍ
u'أَدَاءٌ ضَمَانٌ':Added, #2: 2	أَدَاءِ الضَّامِنِ
u'أَدَاءٌ ضَمَانٌ':Added, #1: 1	أَدَاءُ الضَّمَانِ
u'أَدَاءٌ ضَمَانٌ':Added, #1: 1	أَدَاءِ ضَمَانِهِ
u'أَدَاءٌ ضَمَانٌ':Added, #34: 34	أَدَاءِ الضَّمَانِ
u'أَدَاءٌ طَاعَةٌ':Added, #3: 3	أَدَاءَ الضَّمَانِ
u'أَدَاءٌ طَاعَةٌ':Added, #1: 1	أَدَاءُ الطَّاعَةِ
u'أَدَاءٌ طَالِبٌ':Added, #1: 1	أَدَاءِ الطَّاعَةِ
u'أَدَاءٌ طعام':Added, #1: 1	أَدَاءِ الطَّالِبِ
u'أَدَاءٌ طَعَامٌ':Added, #1: 1	أَدَاءَ طَعَامٍ
u'أَدَاءٌ طواف':Added, #1: 1	أَدَاءَ طَعَامٍ
u'أَدَاءٌ طَوَافٌ':Added, #2: 2	أَدَاءِ الطَّوَافِ
u'أَدَاءٌ ظُهْرٌ':Added, #2: 2	أَدَاءِ الطَّوَافِ
u'أَدَاءٌ ظُهْرٌ':Added, #15: 15	أَدَاءُ الظُّهْرِ
u'أَدَاءٌ ظُهْرٌ':Added, #16: 16	أَدَاءِ الظُّهْرِ
u'أَدَاءٌ عِبَادَةٌ':Added, #3: 3	أَدَاءَ الظُّهْرِ
u'أَدَاءٌ عِبَادَةٌ':Added, #1: 1	أَدَاءُ عِبَادَةٍ
u'أَدَاءٌ عِبَادَةٌ':Added, #2: 2	أَدَاءَ الْعِبَادَةِ
u'أَدَاءٌ عِبَادَةٌ':Added, #2: 2	أَدَاءِ عِبَادَةٍ
u'أَدَاءٌ عِبَادَةٌ':Added, #3: 3	أَدَاءُ الْعِبَادَةِ
u'أَدَاءٌ عِبَادَةٌ':Added, #4: 4	أَدَاءِ الْعِبَادَاتِ
u'أَدَاءٌ عَبْدٌ':Added, #7: 7	أَدَاءِ الْعِبَادَةِ
u'أَدَاءٌ عَبْدٌ':Added, #1: 1	أَدَاءِ الْعَبْدِ
u'أَدَاءٌ عِشَاءٌ':Added, #1: 1	أَدَاءِ عَبْدِ
u'أَدَاءٌ عِشَاءٌ':Added, #2: 2	أَدَاءُ الْعِشَاءِ
u'أَدَاءٌ عُشْرٌ':Added, #4: 4	أَدَاءِ الْعِشَاءِ
u'أَدَاءٌ عُشْرٌ':Added, #2: 2	أَدَاءُ الْعُشْرِ
u'أَدَاءٌ عَصْرٌ':Added, #4: 4	أَدَاءِ الْعُشْرِ
u'أَدَاءٌ عَصْرٌ':Added, #1: 1	أَدَاءُ عَصْرِهِ
u'أَدَاءٌ عَصْرٌ':Added, #2: 2	أَدَاءَ الْعَصْرِ
u'أَدَاءٌ عَصْرٌ':Added, #4: 4	أَدَاءُ الْعَصْرِ
u'أَدَاءٌ علم':Added, #4: 4	أَدَاءِ الْعَصْرِ
u'أَدَاءٌ عِلْمٌ':Added, #1: 1	أَدَاءُ الْعِلْمِ
u'أَدَاءٌ عمرة':Added, #1: 1	أَدَاءُ الْعِلْمِ
u'أَدَاءٌ عُمْرَةٌ':Added, #3: 3	أَدَاءُ الْعُمْرَةِ
u'أَدَاءٌ عمرة':Added, #3: 3	أَدَاءُ الْعُمْرَةِ
u'أَدَاءٌ عُمْرَةٌ':Added, #8: 8	أَدَاءِ الْعُمْرَةِ
u'أَدَاءٌ عَمَلٌ':Added, #8: 8	أَدَاءِ الْعُمْرَةِ
u'أَدَاءٌ عِوَضٌ':Added, #1: 1	أَدَاءَ الْعَمَلِ
u'أَدَاءٌ عين':Added, #1: 1	أَدَاءِ الْعِوَضِ
u'أَدَاءٌ عَيْنٌ':Added, #1: 1	أَدَاءُ عَيْنِ
u'أَدَاءٌ عَيْن':Added, #1: 1	أَدَاءُ عَيْنِ
u'أَدَاءٌ عين':Added, #1: 1	أَدَاءُ عَيْنِ
u'أَدَاءٌ عَيْنٌ':Added, #2: 2	أَدَاءَ الْعَيْنِ
u'أَدَاءٌ عَيْن':Added, #2: 2	أَدَاءَ الْعَيْنِ
u'أَدَاءٌ غَاصِبٌ':Added, #2: 2	أَدَاءَ الْعَيْنِ
u'أَدَاءٌ غُسْلٌ':Added, #1: 1	أَدَاءِ الْغَاصِبِ
u'أَدَاءٌ غَلَّةٌ':Added, #1: 1	أَدَاءَ الْغُسْلِ
u'أَدَاءٌ غير':Added, #1: 1	أَدَاءِ الْغَلَّةِ
u'أَدَاءٌ غَيْرٌ':Added, #1: 1	أَدَاءِ الْغَيْرِ
u'أَدَاءٌ غير':Added, #1: 1	أَدَاءِ الْغَيْرِ
u'أَدَاءٌ غَيْرٌ':Added, #1: 1	أَدَاءُ غَيْرِ
u'أَدَاءٌ غير':Added, #1: 1	أَدَاءُ غَيْرِ
u'أَدَاءٌ غَيْرٌ':Added, #2: 2	أَدَاءِ غَيْرِهِ
u'أَدَاءٌ فَاسِقٌ':Added, #2: 2	أَدَاءِ غَيْرِهِ
u'أَدَاءٌ فَاسِقٌ':Added, #1: 1	أَدَاءُ الْفَاسِقِ
u'أَدَاءٌ فِدَاءٌ':Added, #1: 1	أَدَاءُ فَاسِقٍ
u'أَدَاءٌ فَرَائِضُ':Added, #1: 1	أَدَاءِ الْفِدَاءِ
u'أَدَاءٌ فَرَائِضُ':Added, #11: 11	أَدَاءِ الْفَرَائِضِ
u'أَدَاءٌ فَرَائِضُ':Added, #1: 1	أَدَاءِ فَرَائِضِهِ
u'أَدَاءٌ فَرَائِضُ':Added, #2: 2	أَدَاءُ الْفَرَائِضِ
u'أَدَاءٌ فَرْضٌ':Added, #3: 3	أَدَاءَ الْفَرَائِضِ
u'أَدَاءٌ فَرْضٌ':Added, #13: 13	أَدَاءِ الْفَرْضِ
u'أَدَاءٌ فَرْضٌ':Added, #1: 1	أَدَاءُ فَرْضٍ
u'أَدَاءٌ فَرْضٌ':Added, #1: 1	أَدَاءِ فَرْضٍ
u'أَدَاءٌ فَرْضٌ':Added, #1: 1	أَدَاءِ فَرْضِهِ
u'أَدَاءٌ فَرْضٌ':Added, #1: 1	أَدَاءُ فَرْضَيْنِ
u'أَدَاءٌ فَرْضٌ':Added, #2: 2	أَدَاءَ فَرْضِ
u'أَدَاءٌ فَرْضٌ':Added, #2: 2	أَدَاءُ فَرْضِ
u'أَدَاءٌ فَرْضٌ':Added, #3: 3	أَدَاءُ فَرْضِهِ
u'أَدَاءٌ فَرْضٌ':Added, #8: 8	أَدَاءُ الْفَرْضِ
u'أَدَاءٌ فَرْعٌ':Added, #9: 9	أَدَاءِ فَرْضِ
u'أَدَاءٌ فُرُوعٌ':Added, #2: 2	أَدَاءِ الْفَرْعِ
u'أَدَاءٌ فُرُوعٌ':Added, #1: 1	أَدَاءُ الْفُرُوعِ
u'أَدَاءٌ فَرِيضَةٌ':Added, #1: 1	أَدَاءِ الْفُرُوعِ
u'أَدَاءٌ فَرِيضَةٌ':Added, #1: 1	أَدَاءِ الْفَرِيضَةِ
u'أَدَاءٌ فَرِيضَةٌ':Added, #1: 1	أَدَاءَ فَرِيضَةٍ
u'أَدَاءٌ فَرِيضَةٌ':Added, #2: 2	أَدَاءَ الْفَرِيضَةِ
u'أَدَاءٌ فَرِيضَةٌ':Added, #2: 2	أَدَاءُ الْفَرِيضَةِ
u'أَدَاءٌ فَضْلٌ':Added, #2: 2	أَدَاءُ فَرِيضَةٍ
u'أَدَاءٌ فَضْلٌ':Added, #1: 1	أَدَاءِ الْفَضْلِ
u'أَدَاءٌ فِعْلٌ':Added, #2: 2	أَدَاءُ فَضْلِ
u'أَدَاءٌ فُلاَنٌ':Added, #1: 1	أَدَاءِ الْفِعْلِ
u'أَدَاءٌ فلان':Added, #1: 1	أَدَاءَ فُلَانٍ
u'أَدَاءٌ فلان':Added, #4: 4	أَدَاءِ الصَّلَاتَيْنِ
u'أَدَاءٌ قَاصِرٌ':Added, #5: 5	أَدَاءُ الصَّلَاتَيْنِ
u'أَدَاءٌ قَائِلٌ':Added, #1: 1	أَدَاءَ قَاصِرٍ
u'أَدَاءٌ قَدْرٌ':Added, #1: 1	أَدَاءِ الْقَائِلِ
u'أَدَاءٌ قَدْرٌ':Added, #1: 1	أَدَاءُ الْقَدْرِ
u'أَدَاءٌ قَدْرٌ':Added, #1: 1	أَدَاءِ الْقَدْرِ
u'أَدَاءٌ قَدْرٌ':Added, #1: 1	أَدَاءُ قَدْرِ
u'أَدَاءٌ قُرْبَةٌ':Added, #2: 2	أَدَاءَ قَدْرِ
u'أَدَاءٌ قَرْضٌ':Added, #1: 1	أَدَاءِ الْقُرْبَةِ
u'أَدَاءٌ قِسْطٌ':Added, #1: 1	أَدَاءُ الْقَرْضِ
u'أَدَاءٌ قِنْطَارٌ':Added, #1: 1	أَدَاءِ قِسْطِهِ
u'أَدَاءٌ قِيمَةٌ':Added, #1: 1	أَدَاءِ الْقِنْطَارِ
u'أَدَاءٌ قِيمَةٌ':Added, #12: 12	أَدَاءِ الْقِيمَةِ
u'أَدَاءٌ قِيمَةٌ':Added, #4: 4	أَدَاءُ الْقِيمَةِ
u'أَدَاءٌ كَامِلٌ':Added, #5: 5	أَدَاءَ الْقِيمَةِ
u'أَدَاءٌ كِتَابَةٌ':Added, #1: 1	أَدَاءُ الْكَامِلِ
u'أَدَاءٌ كِتَابَةٌ':Added, #15: 15	أَدَاءِ الْكِتَابَةِ
u'أَدَاءٌ كِتَابَةٌ':Added, #3: 3	أَدَاءِ كِتَابَةِ
u'أَدَاءٌ كِرَاءٌ':Added, #4: 4	أَدَاءِ كِتَابَتِهِ
u'أَدَاءٌ كَفَّارٌ':Added, #1: 1	أَدَاءِ الْكِرَاءِ
u'أَدَاءٌ كَفَّارٌ':Added, #1: 1	أَدَاءِ الْكَفَّارَاتِ
u'أَدَاءٌ كَفَّارٌ':Added, #2: 2	أَدَاءَ الْكَفَّارَةِ
u'أَدَاءٌ كَفَّارٌ':Added, #2: 2	أَدَاءُ الْكَفَّارَةِ
u'أَدَاءٌ كَفَّارَةٌ':Added, #2: 2	أَدَاءِ الْكَفَّارَةِ
u'أَدَاءٌ كَفَّارَةٌ':Added, #1: 1	أَدَاءِ الْكَفَّارَاتِ
u'أَدَاءٌ كَفَّارَةٌ':Added, #2: 2	أَدَاءَ الْكَفَّارَةِ
u'أَدَاءٌ كَفَّارَةٌ':Added, #2: 2	أَدَاءُ الْكَفَّارَةِ
u'أَدَاءٌ كَفِيلٌ':Added, #2: 2	أَدَاءِ الْكَفَّارَةِ
u'أَدَاءٌ لاَزِمٌ':Added, #2: 2	أَدَاءِ الْكَفِيلِ
u'أَدَاءٌ لَفْظٌ':Added, #1: 1	أَدَاءِ اللَّازِمِ
u'أَدَاءٌ لَوَازِمُ':Added, #2: 2	أَدَاءُ اللَّفْظِ
u'أَدَاءٌ مَالٌ':Added, #1: 1	أَدَاءِ اللَّوَازِمِ
u'أَدَاءٌ مَالٌ':Added, #1: 1	أَدَاءَ الْمَالِ
u'أَدَاءٌ مَالٌ':Added, #22: 22	أَدَاءِ الْمَالِ
u'أَدَاءٌ مَالٌ':Added, #3: 3	أَدَاءُ الْمَالِ
u'أَدَاءٌ مَأْمُورٌ':Added, #5: 5	أَدَاءِ مَالِ
u'أَدَاءٌ مَأْمُورٌ':Added, #1: 1	أَدَاءِ الْمَأْمُورِ
u'أَدَاءٌ مَأْمُورٌ':Added, #2: 2	أَدَاءَ الْمَأْمُورِ
u'أَدَاءٌ مثل':Added, #2: 2	أَدَاءُ الْمَأْمُورِ
u'أَدَاءٌ مِثْلٌ':Added, #2: 2	أَدَاءِ الْمِثْلِ
u'أَدَاءٌ مثل':Added, #2: 2	أَدَاءِ الْمِثْلِ
u'أَدَاءٌ مِثْلٌ':Added, #3: 3	أَدَاءُ الْمِثْلِ
u'أَدَاءٌ مثل':Added, #3: 3	أَدَاءُ الْمِثْلِ
u'أَدَاءٌ مِثْلٌ':Added, #7: 7	أَدَاءُ مِثْلِ
u'أَدَاءٌ مَجْنُونٌ':Added, #7: 7	أَدَاءُ مِثْلِ
u'أَدَاءٌ مُحْرِمٌ':Added, #1: 1	أَدَاءِ الْمَجْنُونِ
u'أَدَاءٌ مُحِيل':Added, #1: 1	أَدَاءِ الْمُحْرِمِ
u'أَدَاءٌ مَشْرُوطٌ':Added, #2: 2	أَدَاءُ الْمُحِيلِ
u'أَدَاءٌ مُعَجَّلٌ':Added, #1: 1	أَدَاءُ الْمَشْرُوطِ
u'أَدَاءٌ مَعْلُومٌ':Added, #1: 1	أَدَاءِ الْمُعَجَّلِ
u'أَدَاءٌ مَغْرِبٌ':Added, #1: 1	أَدَاءِ الْمَعْلُومِ
u'أَدَاءٌ مَغْرِبٌ':Added, #1: 1	أَدَاءَ الْمَغْرِبِ
u'أَدَاءٌ مَغْرِبٌ':Added, #1: 1	أَدَاءُ الْمَغْرِبِ
u'أَدَاءٌ مَغْصُوب':Added, #6: 6	أَدَاءِ الْمَغْرِبِ
u'أَدَاءٌ مِقْدَارٌ':Added, #1: 1	أَدَاءِ الْمَغْصُوبِ
u'أَدَاءٌ مُكَاتَبَةٌ':Added, #1: 1	أَدَاءِ مِقْدَارِ
u'أَدَاءٌ مُكَاتَبَةٌ':Added, #1: 1	أَدَاءِ مُكَاتَبَةِ
u'أَدَاءٌ مَكْتُوبٌ':Added, #2: 2	أَدَاءِ الْمُكَاتَبَةِ
u'أَدَاءٌ مَكْتُوبٌ':Added, #1: 1	أَدَاءَ الْمَكْتُوبَةِ
u'أَدَاءٌ مَكْتُوبٌ':Added, #2: 2	أَدَاءِ مَكْتُوبَاتِ
u'أَدَاءٌ مَكْتُوبٌ':Added, #3: 3	أَدَاءُ الْمَكْتُوبَةِ
u'أَدَاءٌ مَكْتُوبٌ':Added, #6: 6	أَدَاءِ الْمَكْتُوبَاتِ
u'أَدَاءٌ مُلْتَزِمٌ':Added, #6: 6	أَدَاءِ الْمَكْتُوبَةِ
u'أَدَاءٌ مَنَاسِكُ':Added, #1: 1	أَدَاءُ مُلْتَزِمِهِ
u'أَدَاءٌ مَنْذُور':Added, #1: 1	أَدَاءِ الْمَنَاسِكِ
u'أَدَاءٌ مَهْرٌ':Added, #1: 1	أَدَاءِ الْمَنْذُورِ
u'أَدَاءٌ مُوجِبٌ':Added, #1: 1	أَدَاءُ الْمَهْرِ
u'أَدَاءٌ مُوَكِّلٌ':Added, #2: 2	أَدَاءِ مُوجِبِ
u'أَدَاءٌ مُوَكِّلٌ':Added, #1: 1	أَدَاءُ الْمُوَكِّلِ
u'أَدَاءٌ نَاسٌ':Added, #3: 3	أَدَاءِ الْمُوَكِّلِ
u'أَدَاءٌ نَافِلَةٌ':Added, #1: 1	أَدَاءِ النَّاسِ
u'أَدَاءٌ نَافِلَةٌ':Added, #1: 1	أَدَاءِ النَّافِلَةِ
u'أَدَاءٌ نَافِلَةٌ':Added, #2: 2	أَدَاءَ النَّافِلَةِ
u'أَدَاءٌ نَاقِصٌ':Added, #2: 2	أَدَاءُ النَّافِلَةِ
u'أَدَاءٌ نَائِبٌ':Added, #1: 1	أَدَاءُ النَّاقِصِ
u'أَدَاءٌ نَجْمٌ':Added, #3: 3	أَدَاءَ نَائِبِهِ
u'أَدَاءٌ نَجْمٌ':Added, #2: 2	أَدَاءِ نَجْمَيْنِ
u'أَدَاءٌ نُجُومٌ':Added, #6: 6	أَدَاءِ نَجْمٍ
u'أَدَاءٌ نُجُومٌ':Added, #1: 1	أَدَاءِ نُجُومٍ
u'أَدَاءٌ نُجُومٌ':Added, #1: 1	أَدَاءِ نُجُومِ
u'أَدَاءٌ نُجُومٌ':Added, #1: 1	أَدَاءُ نُجُومِهِ
u'أَدَاءٌ نُجُومٌ':Added, #1: 1	أَدَاءِ نُجُومِهِ
u'أَدَاءٌ نذر':Added, #8: 8	أَدَاءِ النُّجُومِ
u'أَدَاءٌ نَذْرٌ':Added, #1: 1	أَدَاءِ النَّذْرِ
u'أَدَاءٌ نُسُكٌ':Added, #1: 1	أَدَاءِ النَّذْرِ
u'أَدَاءٌ نُسُكٌ':Added, #1: 1	أَدَاءُ النُّسُكِ
u'أَدَاءٌ نُسُكٌ':Added, #2: 2	أَدَاءَ النُّسُكِ
u'أَدَاءٌ نُسُكٌ':Added, #5: 5	أَدَاءِ النُّسُكَيْنِ
u'أَدَاءٌ نِصْفٌ':Added, #6: 6	أَدَاءِ النُّسُكِ
u'أَدَاءٌ نِصْفٌ':Added, #1: 1	أَدَاءَ نِصْفِ
u'أَدَاءٌ نِصْفٌ':Added, #1: 1	أَدَاءِ نِصْفِ
u'أَدَاءٌ نَصِيبٌ':Added, #2: 2	أَدَاءُ نِصْفِ
u'أَدَاءٌ نَفَقَةٌ':Added, #1: 1	أَدَاءِ نَصِيبِ
u'أَدَاءٌ نَفْلٌ':Added, #1: 1	أَدَاءِ النَّفَقَةِ
u'أَدَاءٌ نَفْلٌ':Added, #3: 3	أَدَاءِ النَّفْلِ
u'أَدَاءٌ نقل':Added, #8: 8	أَدَاءُ النَّفْلِ
u'أَدَاءٌ نَقْلٌ':Added, #1: 1	أَدَاءَ النَّقْلِ
u'أَدَاءٌ نَوَافِلُ':Added, #1: 1	أَدَاءَ النَّقْلِ
u'أَدَاءٌ نَوَافِلُ':Added, #1: 1	أَدَاءِ النَّوَافِلِ
u'أَدَاءٌ وَاجِبٌ':Added, #1: 1	أَدَاءِ نَوَافِلِ
u'أَدَاءٌ وَاجِبٌ':Added, #19: 19	أَدَاءِ الْوَاجِبِ
u'أَدَاءٌ وَاجِبٌ':Added, #1: 1	أَدَاءُ وَاجِبٍ
u'أَدَاءٌ وَاجِبٌ':Added, #1: 1	أَدَاءِ وَاجِبٍ
u'أَدَاءٌ وَاجِبٌ':Added, #1: 1	أَدَاءِ وَاجِبِ
u'أَدَاءٌ وَاجِبٌ':Added, #1: 1	أَدَاءِ وَاجِبَاتِهِ
u'أَدَاءٌ وَاجِبٌ':Added, #2: 2	أَدَاءِ الْوَاجِبَاتِ
u'أَدَاءٌ وَاجِبٌ':Added, #6: 6	أَدَاءُ الْوَاجِبِ
u'أَدَاءٌ واحد':Added, #7: 7	أَدَاءَ الْوَاجِبِ
u'أَدَاءٌ وَاحِدٌ':Added, #1: 1	أَدَاءُ وَاحِدَةٍ
u'أَدَاءٌ وُجُودٌ':Added, #1: 1	أَدَاءُ وَاحِدَةٍ
u'أَدَاءٌ وَحْيٌ':Added, #1: 1	أَدَاءَ وُجُودِ
u'أَدَاءٌ وُضُوءٌ':Added, #1: 1	أَدَاءِ الْوَحْيِ
u'أَدَاءٌ وُضُوءٌ':Added, #2: 2	أَدَاءُ الْوُضُوءِ
u'أَدَاءٌ وَظِيفٌ':Added, #2: 2	أَدَاءِ الْوُضُوءِ
u'أَدَاءٌ وَظِيفَةٌ':Added, #1: 1	أَدَاءِ وَظِيفَةِ
u'أَدَاءٌ وَقْت':Added, #1: 1	أَدَاءِ وَظِيفَةِ
u'أَدَاءٌ وَقْت':Added, #1: 1	أَدَاءِ الْوَقْتِيَّةِ
u'أَدَاءٌ وَقْتِيّ':Added, #2: 2	أَدَاءُ الْوَقْتِيَّةِ
u'أَدَاءٌ وَقْتِيّ':Added, #1: 1	أَدَاءِ الْوَقْتِيَّةِ
u'أَدَاءٌ ولد':Added, #2: 2	أَدَاءُ الْوَقْتِيَّةِ
u'أَدَاءٌ وَلَدٌ':Added, #1: 1	أَدَاءِ الْوَلَدِ
u'أَدَاءٌ يَمِينٌ':Added, #1: 1	أَدَاءِ الْوَلَدِ
u'أَدَارَ حُكْمٌ':Predicate, #1: 1	أَدَاءِ الْيَمِينِ
u'أَدَارَ مَاءٌ':Predicate, #1: 1	أَدَارَ الْحُكْمَ
u'أَدَامَ حِفْظٌ':Predicate, #3: 3	أَدَارَ الْمَاءَ
u'أَدَانَ عَبْدٌ':Predicate, #1: 1	أَدَامَ الْحِفْظَ
u'أَدَانَ مُسْلِمٌ':Subject, #3: 3	أَدَانَ الْعَبْدَ
u'أَدَّبَ بَعْضٌ':Predicate, #1: 1	أَدَانَ مُسْلِمٌ
u'أَدَّبَ حاكِمٌ':Subject, #2: 2	أَدَّبَ بَعْضَ
u'أَدْبَرَ رَجُلٌ':Subject, #1: 1	أَدَّبَ الْحَاكِمُ
u'أَدْبَرَ زَمانٌ':Subject, #5: 5	أَدْبَرَ الرَّجُلُ
u'أَدْبَرَ شَيْطَانٌ':Subject, #1: 1	أَدْبَرَ الزَّمَانُ
u'أَدْبَرَ قَالٌ':Predicate, #4: 4	أَدْبَرَ الشَّيْطَانُ
u'أَدْبَرَ نَجْمٌ':Subject, #5: 5	أَدْبَرَ قَالَ
u'أَدْبَرَ وقع':Predicate, #1: 1	أَدْبَرَ نَجْمُهُ
u'أَدْبَرَ وَلَهٌ':Subject, #1: 1	أَدْبَرَ وَقَعَ
u'أَدَّبَ قَاسِمٌ':Predicate, #2: 2	أَدْبَرَ وَلَهُ
u'إدْخَالٌ أَحْجارٌ':Added, #2: 2	أَدَّبَ الْقَاسِمَ
u'إدْخَالٌ إِحْرَامٌ':Added, #1: 1	إدْخَالُ أَحْجَارِ
u'إدْخَالٌ إِحْرَامٌ':Added, #1: 1	إدْخَالُ إحْرَامِ
u'إدْخَالٌ إِحْرَامٌ':Added, #1: 1	إدْخَالُ الْإِحْرَامِ
u'إدْخَالٌ إِحْرَامٌ':Added, #2: 2	إدْخَالَ الْإِحْرَامِ
u'إدْخَالٌ أُصْبُعٌ':Added, #3: 3	إدْخَالَ إحْرَامِ
u'إدْخَالٌ إِصْبَعٌ':Added, #1: 1	إدْخَالَ الْأُصْبُعَيْنِ
u'إدْخَالٌ أعْيانٌ':Added, #2: 2	إدْخَالِ الْإِصْبَعِ
u'إدْخَالٌ أَعْيَانٌ':Added, #1: 1	إدْخَالُ الْأَعْيَانِ
u'إدْخَالٌ إفْشَاءٌ':Added, #1: 1	إدْخَالُ الْأَعْيَانِ
u'إدْخَالٌ ألف':Added, #1: 1	إدْخَالُ إفْشَاءِ
u'إدْخَالٌ أمَةٌ':Added, #2: 2	إدْخَالُ الْأَلِفِ
u'إدْخَالٌ أمَةٌ':Added, #1: 1	إدْخَالِ الْأَمَةِ
u'إدْخَالٌ أَنْوَاعٌ':Added, #2: 2	إدْخَالُ الْأَمَةِ
u'إدْخَالٌ باء':Added, #1: 1	إدْخَالَ الْأَنْوَاعِ
u'إدْخَالٌ باء':Added, #1: 1	إدْخَالَ الْبَاءِ
u'إدْخَالٌ بَعيدٌ':Added, #1: 1	إدْخَالِ الْبَاءِ
u'إدْخَالٌ بِغالٌ':Added, #1: 1	إدْخَالِ الْبَعِيدِ
u'إدْخَالٌ بَهيمٌ':Added, #1: 1	إدْخَالِ الْبِغَالِ
u'إدْخَالٌ بَهيمٌ':Added, #1: 1	إدْخَالَ الْبَهِيمَةِ
u'إدْخَالٌ بَهِيمَةٌ':Added, #1: 1	إدْخَالِ الْبَهِيمَةِ
u'إدْخَالٌ بَهِيمَةٌ':Added, #1: 1	إدْخَالَ الْبَهِيمَةِ
u'إدْخَالٌ تاء':Added, #1: 1	إدْخَالِ الْبَهِيمَةِ
u'إدْخَالٌ تُرَابٌ':Added, #3: 3	إدْخَالُ التَّاءِ
u'إدْخَالٌ ثَالِثٌ':Added, #1: 1	إدْخَالُ تُرَابِ
u'إدْخَالٌ ثَالِثٌ':Added, #1: 1	إدْخَالُ الثَّالِثِ
u'إدْخَالٌ ثَانِي':Added, #1: 1	إدْخَالَ ثَالِثٍ
u'إدْخَالٌ ثَانِيَةٌ':Added, #1: 1	إدْخَالُ الثَّانِيَةِ
u'إدْخَالٌ جِذْعٌ':Added, #1: 1	إدْخَالُ الثَّانِيَةِ
u'إدْخَالٌ جِذْعٌ':Added, #1: 1	إدْخَالَ جِذْعٍ
u'إدْخَالٌ جُزْءٌ':Added, #2: 2	إدْخَالِ جِذْعٍ
u'إدْخَالٌ جَمَاعَةٌ':Added, #2: 2	إدْخَالُ جُزْءٍ
u'إدْخَالٌ حُبوبٌ':Added, #1: 1	إدْخَالِ جَمَاعَةٍ
u'إدْخَالٌ حُبوبٌ':Added, #1: 1	إدْخَالُ الْحُبُوبِ
u'إدْخَالٌ حَجٌّ':Added, #1: 1	إدْخَالِ الْحُبُوبِ
u'إدْخَالٌ حَجٌّ':Added, #1: 1	إدْخَالَ الْحَجِّ
u'إدْخَالٌ حَجٌّ':Added, #5: 5	إدْخَالِ الْحَجِّ
u'إدْخَالٌ حَجَرٌ':Added, #6: 6	إدْخَالُ الْحَجِّ
u'إدْخَالٌ حَدٌّ':Added, #1: 1	إدْخَالِ الْحَجَرِ
u'إدْخَالٌ حُرٌّ':Added, #1: 1	إدْخَالُ الْحَدِّ
u'إدْخَالٌ حَرائِرُ':Added, #1: 1	إدْخَالُ الْحُرَّةِ
u'إدْخَالٌ حَرَائِرُ':Added, #1: 1	إدْخَالِ الْحَرَائِرِ
u'إدْخَالٌ حَطِيم':Added, #1: 1	إدْخَالِ الْحَرَائِرِ
u'إدْخَالٌ حُكْمٌ':Added, #1: 1	إدْخَالُ الْحَطِيمِ
u'إدْخَالٌ خرقة':Added, #1: 1	إدْخَالِ حُكْمِ
u'إدْخَالٌ خِرْقَةٌ':Added, #1: 1	إدْخَالُ خِرْقَةٍ
u'إدْخَالٌ خَشَبَةٌ':Added, #1: 1	إدْخَالُ خِرْقَةٍ
u'إدْخَالٌ خصيان':Added, #1: 1	إدْخَالُ خَشَبَةٍ
u'إدْخَالٌ خلق':Added, #1: 1	إدْخَالَ الْخُصْيَانِ
u'إدْخَالٌ خَلْقٌ':Added, #1: 1	إدْخَالِ خَلْقِ
u'إدْخَالٌ خَمْرٌ':Added, #1: 1	إدْخَالِ خَلْقِ
u'إدْخَالٌ خَيْلٌ':Added, #2: 2	إدْخَالِ الْخَمْرِ
u'إدْخَالٌ دَرَاهِمُ':Added, #1: 1	إدْخَالِ الْخَيْلِ
u'إدْخَالٌ دَرَاهِمُ':Added, #1: 1	إدْخَالَ الدَّرَاهِمِ
u'إدْخَالٌ دَرَاهِمُ':Added, #1: 1	إدْخَالُ الدَّرَاهِمِ
u'إدْخَالٌ دَوَابُّ':Added, #1: 1	إدْخَالِ الدَّرَاهِمِ
u'إدْخَالٌ دَوَابُّ':Added, #1: 1	إدْخَالِ دَوَابِّهِ
u'إدْخَالٌ دَيْنٌ':Added, #2: 2	إدْخَالُ الدَّوَابِّ
u'إدْخَالٌ دَيْنٌ':Added, #1: 1	إدْخَالَ الدَّيْنِ
u'إدْخَالٌ ذكر':Added, #1: 1	إدْخَالُ دَيْنِ
u'إدْخَالٌ ذَكَرٌ':Added, #1: 1	إدْخَالُ الذَّكَرِ
u'إدْخَالٌ ذكر':Added, #1: 1	إدْخَالُ الذَّكَرِ
u'إدْخَالٌ ذَكَرٌ':Added, #1: 1	إدْخَالُ ذَكَرِهِ
u'إدْخَالٌ ذِمِّيٌّ':Added, #1: 1	إدْخَالُ ذَكَرِهِ
u'إدْخَالٌ رَجُلٌ':Added, #1: 1	إدْخَالُ الذِّمِّيِّ
u'إدْخَالٌ رَجُلٌ':Added, #1: 1	إدْخَالُ الرَّجُلِ
u'إدْخَالٌ رِجْلٌ':Added, #1: 1	إدْخَالِ رَجُلٍ
u'إدْخَالٌ رِفْقٌ':Added, #2: 2	إدْخَالِ الرِّجْلِ
u'إدْخَالٌ رِفْقٌ':Added, #1: 1	إدْخَالِ الرِّفْقِ
u'إدْخَالٌ زِبْلٌ':Added, #1: 1	إدْخَالِ رِفْقٍ
u'إدْخَالٌ زَوْجٌ':Added, #1: 1	إدْخَالِ الزِّبْلِ
u'إدْخَالٌ زَوْجَةٌ':Added, #1: 1	إدْخَالِ الزَّوْجِ
u'إدْخَالٌ زَوْجَةٌ':Added, #1: 1	إدْخَالَ الزَّوْجَةِ
u'إدْخَالٌ سَائِرٌ':Added, #1: 1	إدْخَالِ الزَّوْجَةِ
u'إدْخَالٌ سُرُورٌ':Added, #1: 1	إدْخَالُ سَائِرِ
u'إدْخَالٌ سُرُورٌ':Added, #1: 1	إدْخَالَ السّرُورِ
u'إدْخَالٌ سُرُورٌ':Added, #1: 1	إدْخَالَ السُّرُورِ
u'إدْخَالٌ سُرُورٌ':Added, #1: 1	إدْخَالُ السُّرُورِ
u'إدْخَالٌ سَفِينَةٌ':Added, #1: 1	إدْخَالِ السُّرُورِ
u'إدْخَالٌ سِكِّينٌ':Added, #1: 1	إدْخَالِ سَفِينَةٍ
u'إدْخَالٌ سِلْعَةٌ':Added, #1: 1	إدْخَالِ السِّكِّينِ
u'إدْخَالٌ شرب':Added, #1: 1	إدْخَالِ سِلْعَتِهِ
u'إدْخَالٌ شُرْبٌ':Added, #1: 1	إدْخَالِ الشُّرْبِ
u'إدْخَالٌ شَعْرٌ':Added, #1: 1	إدْخَالِ الشُّرْبِ
u'إدْخَالٌ شَهْرٌ':Added, #2: 2	إدْخَالُ شَعْرِ
u'إدْخَالٌ شَيْءٌ':Added, #1: 1	إدْخَالُ شَهْرٍ
u'إدْخَالٌ شَيْءٌ':Added, #1: 1	إدْخَالِ الشَّيْءِ
u'إدْخَالٌ شَيْءٌ':Added, #1: 1	إدْخَالَ شَيْءٍ
u'إدْخَالٌ شَيْءٌ':Added, #2: 2	إدْخَالُ شَيْءٍ
u'إدْخَالٌ صَبِيٌّ':Added, #5: 5	إدْخَالِ شَيْءٍ
u'إدْخَالٌ صِبْيَانٌ':Added, #1: 1	إدْخَالِ صَبِيِّ
u'إدْخَالٌ صَفْقَةٌ':Added, #2: 2	إدْخَالَ الصِّبْيَانِ
u'إدْخَالٌ صلح':Added, #1: 1	إدْخَالُ صَفْقَةِ
u'إدْخَالٌ صُلْحٌ':Added, #1: 1	إدْخَالُ صُلْحِ
u'إدْخَالٌ ضَرَّةٌ':Added, #1: 1	إدْخَالُ صُلْحِ
u'إدْخَالٌ ضَرَرٌ':Added, #1: 1	إدْخَالِ الضَّرَّةِ
u'إدْخَالٌ ضَرَرٌ':Added, #1: 1	إدْخَالِ ضَرَرٍ
u'إدْخَالٌ ضَرَرٌ':Added, #2: 2	إدْخَالُ الضَّرَرِ
u'إدْخَالٌ ضَعِيفٌ':Added, #3: 3	إدْخَالَ الضَّرَرِ
u'إدْخَالٌ ضَيْمٌ':Added, #1: 1	إدْخَالُ الضَّعِيفِ
u'إدْخَالٌ طَرِيقٌ':Added, #1: 1	إدْخَالِ الضَّيْمِ
u'إدْخَالٌ طعام':Added, #1: 1	إدْخَالِ الطَّرِيقِ
u'إدْخَالٌ طعام':Added, #1: 1	إدْخَالُ الطَّعَامِ
u'إدْخَالٌ طَعَامٌ':Added, #1: 1	إدْخَالِ الطَّعَامِ
u'إدْخَالٌ طَعَامٌ':Added, #1: 1	إدْخَالُ الطَّعَامِ
u'إدْخَالٌ ظاهِرٌ':Added, #1: 1	إدْخَالِ الطَّعَامِ
u'إدْخَالٌ ظاهِرَة':Added, #1: 1	إدْخَالُ الظَّاهِرَةِ
u'إدْخَالٌ ظُفْرٌ':Added, #1: 1	إدْخَالُ الظَّاهِرَةِ
u'إدْخَالٌ عَارٌ':Added, #2: 2	إدْخَالُ الظُّفْرِ
u'إدْخَالٌ عِبَادَةٌ':Added, #1: 1	إدْخَالِ الْعَارِ
u'إدْخَالٌ عَصَبٌ':Added, #1: 1	إدْخَالُ عِبَادَةٍ
u'إدْخَالٌ عُضْوٌ':Added, #1: 1	إدْخَالِ الْعَصَبِ
u'إدْخَالٌ عُضْوٌ':Added, #1: 1	إدْخَالِ الْعُضْوِ
u'إدْخَالٌ عَقْدٌ':Added, #1: 1	إدْخَالُ عُضْوٍ
u'إدْخَالٌ علم':Added, #1: 1	إدْخَالِ عَقْدِ
u'إدْخَالٌ عَلَمٌ':Added, #1: 1	إدْخَالُ الْعَلَمِ
u'إدْخَالٌ عمرة':Added, #1: 1	إدْخَالُ الْعَلَمِ
u'إدْخَالٌ عُمْرَةٌ':Added, #1: 1	إدْخَالَ الْعُمْرَةِ
u'إدْخَالٌ عمرة':Added, #1: 1	إدْخَالَ الْعُمْرَةِ
u'إدْخَالٌ عُمْرَةٌ':Added, #1: 1	إدْخَالُ عُمْرَةٍ
u'إدْخَالٌ عمرة':Added, #1: 1	إدْخَالُ عُمْرَةٍ
u'إدْخَالٌ عُمْرَةٌ':Added, #3: 3	إدْخَالُ الْعُمْرَةِ
u'إدْخَالٌ عمرة':Added, #3: 3	إدْخَالُ الْعُمْرَةِ
u'إدْخَالٌ عُمْرَةٌ':Added, #5: 5	إدْخَالِ الْعُمْرَةِ
u'إدْخَالٌ عَمَلٌ':Added, #5: 5	إدْخَالِ الْعُمْرَةِ
u'إدْخَالٌ عَيْنٌ':Added, #1: 1	إدْخَالِ عَمَلِ
u'إدْخَالٌ عَيْن':Added, #1: 1	إدْخَالِ عَيْنٍ
u'إدْخَالٌ عين':Added, #1: 1	إدْخَالِ عَيْنٍ
u'إدْخَالٌ عَيْنٌ':Added, #3: 3	إدْخَالِ عَيْنِهِ
u'إدْخَالٌ عَيْن':Added, #3: 3	إدْخَالِ عَيْنِهِ
u'إدْخَالٌ غَايَةٌ':Added, #3: 3	إدْخَالِ عَيْنِهِ
u'إدْخَالٌ غَمٌّ':Added, #1: 1	إدْخَالِ الْغَايَةِ
u'إدْخَالٌ غَمٌّ':Added, #1: 1	إدْخَالِ الْغَمِّ
u'إدْخَالٌ غير':Added, #1: 1	إدْخَالَ غَمٍّ
u'إدْخَالٌ غَيْرٌ':Added, #1: 1	إدْخَالُ غَيْرِ
u'إدْخَالٌ غير':Added, #1: 1	إدْخَالُ غَيْرِ
u'إدْخَالٌ غَيْرٌ':Added, #1: 1	إدْخَالَ غَيْرِهِ
u'إدْخَالٌ غَيْظٌ':Added, #1: 1	إدْخَالَ غَيْرِهِ
u'إدْخَالٌ غَيْظٌ':Added, #1: 1	إدْخَالَ الْغَيْظِ
u'إدْخَالٌ فَاسِقٌ':Added, #1: 1	إدْخَالُ الْغَيْظِ
u'إدْخَالٌ فَرْجٌ':Added, #1: 1	إدْخَالُ الْفَاسِقِ
u'إدْخَالٌ قَدْرٌ':Added, #6: 6	إدْخَالُ الْفَرْجِ
u'إدْخَالٌ قدرة':Added, #1: 1	إدْخَالُ قَدْرِ
u'إدْخَالٌ قُدْرَةٌ':Added, #1: 1	إدْخَالِ الْقُدْرَةِ
u'إدْخَالٌ كَفٌّ':Added, #1: 1	إدْخَالِ الْقُدْرَةِ
u'إدْخَالٌ مَاءٌ':Added, #1: 1	إدْخَالِ الْكَفِّ
u'إدْخَالٌ مَاءٌ':Added, #1: 1	إدْخَالُ الْمَاءِ
u'إدْخَالٌ مَاءٌ':Added, #2: 2	إدْخَالَ الْمَاءِ
u'إدْخَالٌ مَالِكٌ':Added, #2: 2	إدْخَالِ الْمَاءِ
u'إدْخَالٌ مثل':Added, #1: 1	إدْخَالُ مَالِكٍ
u'إدْخَالٌ مِثْلٌ':Added, #1: 1	إدْخَالَ مِثْلِ
u'إدْخَالٌ مُحَلِّل':Added, #1: 1	إدْخَالَ مِثْلِ
u'إدْخَالٌ مِرْفَقٌ':Added, #2: 2	إدْخَالِ الْمُحَلِّلِ
u'إدْخَالٌ مُسَافِرٌ':Added, #1: 1	إدْخَالَ الْمِرْفَقَيْنِ
u'إدْخَالٌ مَسْجِدٌ':Added, #1: 1	إدْخَالَ مُسَافِرٍ
u'إدْخَالٌ مَسَرَّةٌ':Added, #2: 2	إدْخَالَ الْمَسْجِدِ
u'إدْخَالٌ مَشَقَّةٌ':Added, #1: 1	إدْخَالِ الْمَسَرَّةِ
u'إدْخَالٌ مَصْدَرٌ':Added, #1: 1	إدْخَالَ الْمَشَقَّةِ
u'إدْخَالٌ مُصَنِّفٌ':Added, #1: 1	إدْخَالِ الْمَصْدَرِ
u'إدْخَالٌ مُكَلَّفٌ':Added, #1: 1	إدْخَالَ الْمُصَنِّفِ
u'إدْخَالٌ مُمَيِّزٌ':Added, #1: 1	إدْخَالُ الْمُكَلَّفِ
u'إدْخَالٌ مَنِيٌّ':Added, #1: 1	إدْخَالُ الْمُمَيِّزِ
u'إدْخَالٌ مَنِيٌّ':Added, #1: 1	إدْخَالِ الْمَنِيِّ
u'إدْخَالٌ مَهْرٌ':Added, #2: 2	إدْخَالَ الْمَنِيِّ
u'إدْخَالٌ نَاقِصٌ':Added, #1: 1	إدْخَالُ الْمَهْرِ
u'إدْخَالٌ نَاقِصٌ':Added, #1: 1	إدْخَالُ نَاقِصَةِ
u'إدْخَالٌ نَبِيٌّ':Added, #2: 2	إدْخَالِ نَاقِصَةِ
u'إدْخَالٌ نَجَاسَةٌ':Added, #2: 2	إدْخَالِ النَّبِيِّ
u'إدْخَالٌ نَجَاسَةٌ':Added, #1: 1	إدْخَالُ النَّجَاسَةِ
u'إدْخَالٌ نُسُورٌ':Added, #2: 2	إدْخَالِ النَّجَاسَةِ
u'إدْخَالٌ نِعَالٌ':Added, #1: 1	إدْخَالُ النُّسُورِ
u'إدْخَالٌ نَقْصٌ':Added, #1: 1	إدْخَالِ النِّعَالِ
u'إدْخَالٌ نَقْصٌ':Added, #1: 1	إدْخَالُ النَّقْصِ
u'إدْخَالٌ نَقْصٌ':Added, #1: 1	إدْخَالِ النَّقْصِ
u'إدْخَالٌ نُقْصَانٌ':Added, #2: 2	إدْخَالَ النَّقْصِ
u'إدْخَالٌ نكاح':Added, #1: 1	إدْخَالِ النُّقْصَانِ
u'إدْخَالٌ نِكَاحٌ':Added, #1: 1	إدْخَالَ النِّكَاحِ
u'إدْخَالٌ وَارِثٌ':Added, #1: 1	إدْخَالَ النِّكَاحِ
u'إدْخَالٌ وَارِثٌ':Added, #1: 1	إدْخَالِ الْوَارِثِ
u'إدْخَالٌ وَارِثٌ':Added, #1: 1	إدْخَالَ وَارِثٍ
u'إدْخَالٌ وُجُودٌ':Added, #1: 1	إدْخَالِ وَارِثٍ
u'إدْخَالٌ وَعِيدٌ':Added, #1: 1	إدْخَالَ وُجُودِ
u'إدْخَالٌ وَهْنٌ':Added, #1: 1	إدْخَالَ الْوَعِيدِ
u'إدْخَالٌ يَدٌ':Added, #1: 1	إدْخَالِ الْوَهْنِ
u'إدْخَالٌ يَدٌ':Added, #1: 1	إدْخَالَ الْيَدَيْنِ
u'إدْخَالٌ يَدٌ':Added, #1: 1	إدْخَالِ الْيَدَيْنِ
u'إدْخَالٌ يَدٌ':Added, #2: 2	إدْخَالَ الْيَدِ
u'إدْخَالٌ يَدٌ':Added, #5: 5	إدْخَالُ الْيَدِ
u'أَدْخَلَ إِحْرَامٌ':Predicate, #7: 7	إدْخَالِ الْيَدِ
u'أَدْخَلَ أَحْكَامٌ':Predicate, #5: 5	أَدْخَلَ إحْرَامَ
u'أَدْخَلَ آدَمِيٌّ':Predicate, #1: 1	أَدْخَلَ الْأَحْكَامَ
u'أَدْخَلَ أَصابِعُ':Predicate, #1: 1	أَدْخَلَ الْآدَمِيَّ
u'أَدْخَلَ أَصْنَامٌ':Predicate, #1: 1	أَدْخَلَ أَصَابِعَ
u'أَدْخَلَ إِطْعامٌ':Predicate, #1: 1	أَدْخَلَ الْأَصْنَامَ
u'أَدْخَلَ أَعْمَالٌ':Predicate, #1: 1	أَدْخَلَ الْإِطْعَامَ
u'أَدْخَلَ ألف':Predicate, #1: 1	أَدْخَلَ الْأَعْمَالَ
u'أَدْخَلَ أَنْدَلُسُ':Predicate, #2: 2	أَدْخَلَ الْأَلِفَ
u'أَدْخَلَ باء':Predicate, #1: 1	أَدْخَلَ الْأَنْدَلُسَ
u'أَدْخَلَ بَاغِي':Predicate, #1: 1	أَدْخَلَ الْبَاءَ
u'أَدْخَلَ بَعْضٌ':Predicate, #1: 1	أَدْخَلَ الْبَاغِيَ
u'أَدْخَلَ بَقَرٌ':Predicate, #2: 2	أَدْخَلَ بَعْضَ
u'أَدْخَلَ بَقَرٌ':Predicate, #1: 1	أَدْخَلَ الْبَقَرَ
u'أَدْخَلَ بَيْضَةٌ':Predicate, #1: 1	أَدْخَلَ الْبَقَرَةَ
u'أَدْخَلَ بَيْنٌ':Predicate, #1: 1	أَدْخَلَ الْبَيْضَةَ
u'أَدْخَلَ تَسْمِيَة':Predicate, #5: 5	أَدْخَلَ بَيْنَ
u'أَدْخَلَ ثَانِي':Predicate, #1: 1	أَدْخَلَ التَّسْمِيَةَ
u'أَدْخَلَ ثَانِيَةٌ':Predicate, #1: 1	أَدْخَلَ الثَّانِيَةَ
u'أَدْخَلَ ثَمَنٌ':Predicate, #1: 1	أَدْخَلَ الثَّانِيَةَ
u'أَدْخَلَ جلد':Predicate, #1: 1	أَدْخَلَ الثَّمَنَ
u'أَدْخَلَ جِلْدٌ':Predicate, #1: 1	أَدْخَلَ جِلْدَ
u'أَدْخَلَ حَجٌّ':Predicate, #1: 1	أَدْخَلَ جِلْدَ
u'أَدْخَلَ حَديثٌ':Predicate, #4: 4	أَدْخَلَ الْحَجَّ
u'أَدْخَلَ حَرْفٌ':Predicate, #1: 1	أَدْخَلَ الْحَدِيثَ
u'أَدْخَلَ حَرَمٌ':Predicate, #5: 5	أَدْخَلَ حَرْفَ
u'أَدْخَلَ حَرُور':Subject, #2: 2	أَدْخَلَ الْحَرَمَ
u'أَدْخَلَ حِمَارٌ':Predicate, #1: 1	أَدْخَلَ الْحَرُورِيَّةُ
u'أَدْخَلَ حِنْطَةٌ':Predicate, #1: 1	أَدْخَلَ الْحِمَارَ
u'أَدْخَلَ حَيٌّ':Predicate, #1: 1	أَدْخَلَ الْحِنْطَةَ
u'أَدْخَلَ حَيَّةٌ':Predicate, #1: 1	أَدْخَلَ الْحَيَّةَ
u'أَدْخَلَ خَارِجٌ':Subject, #1: 1	أَدْخَلَ الْحَيَّةَ
u'أَدْخَلَ خَشَّابٌ':Subject, #3: 3	أَدْخَلَ الْخَارِجُ
u'أَدْخَلَ خَمْرٌ':Predicate, #1: 1	أَدْخَلَ الْخَشَّابُ
u'أَدْخَلَ دَابَّةٌ':Predicate, #1: 1	أَدْخَلَ الْخَمْرَ
u'أَدْخَلَ دونٌ':Predicate, #1: 1	أَدْخَلَ الدَّابَّةَ
u'أَدْخَلَ رَأْسٌ':Predicate, #1: 1	أَدْخَلَ دُونَ
u'أَدْخَلَ رَأْسٌ':Predicate, #1: 1	أَدْخَلَ الرَّأْسَ
u'أَدْخَلَ رَجُلٌ':Subject, #2: 2	أَدْخَلَ رَأْسَ
u'أَدْخَلَ رَجُلٌ':Subject, #1: 1	أَدْخَلَ الرَّجُلُ
u'أَدْخَلَ سَبْعَةٌ':Predicate, #2: 2	أَدْخَلَ رَجُلٌ
u'أَدْخَلَ سِرَاجٌ':Predicate, #1: 1	أَدْخَلَ سَبْعَةَ
u'أَدْخَلَ سكر':Predicate, #1: 1	أَدْخَلَ السِّرَاجَ
u'أَدْخَلَ سُكْرٌ':Predicate, #2: 2	أَدْخَلَ السُّكْرَ
u'أَدْخَلَ سِكِّينٌ':Predicate, #2: 2	أَدْخَلَ السُّكْرَ
u'أَدْخَلَ سَلِيمٌ':Subject, #3: 3	أَدْخَلَ السِّكِّينَ
u'أَدْخَلَ سِمْسِم':Predicate, #1: 1	أَدْخَلَ السَّلِيمُ
u'أَدْخَلَ شُعْبَةٌ':Subject, #1: 1	أَدْخَلَ سِمْسِمَةً
u'أَدْخَلَ شَكٌّ':Predicate, #1: 1	أَدْخَلَ شُعْبَةُ
u'أَدْخَلَ صَاحِبٌ':Subject, #7: 7	أَدْخَلَ الشَّكَّ
u'أَدْخَلَ صَبِيٌّ':Subject, #2: 2	أَدْخَلَ صَاحِبُ
u'أَدْخَلَ صَيْدٌ':Predicate, #3: 3	أَدْخَلَ الصَّبِيُّ
u'أَدْخَلَ عَامِلٌ':Subject, #1: 1	أَدْخَلَ صَيْدَ
u'أَدْخَلَ عمرة':Predicate, #2: 2	أَدْخَلَ الْعَامِلُ
u'أَدْخَلَ عُمْرَةٌ':Predicate, #1: 1	أَدْخَلَ الْعُمْرَةَ
u'أَدْخَلَ غير':Predicate, #1: 1	أَدْخَلَ الْعُمْرَةَ
u'أَدْخَلَ غَيْرٌ':Predicate, #1: 1	أَدْخَلَ غَيْرَ
u'أَدْخَلَ فَاهٌ':Subject, #1: 1	أَدْخَلَ غَيْرَ
u'أَدْخَلَ فساد':Predicate, #1: 1	أَدْخَلَ فَاهُ
u'أَدْخَلَ فَسَادٌ':Predicate, #2: 2	أَدْخَلَ الْفَسَادَ
u'أَدْخَلَ فَصِيلٌ':Predicate, #2: 2	أَدْخَلَ الْفَسَادَ
u'أَدْخَلَ فلان':Predicate, #1: 1	أَدْخَلَ فَصِيلَ
u'أَدْخَلَ قَرْضٌ':Predicate, #1: 1	أَدْخَلَ سِمْسِمَةً
u'أَدْخَلَ كَافِرٌ':Subject, #1: 1	أَدْخَلَ الْقَرْضَ
u'أَدْخَلَ كِتَابٌ':Predicate, #1: 1	أَدْخَلَ الْكَافِرُ
u'أَدْخَلَ كَفٌّ':Predicate, #1: 1	أَدْخَلَ الْكِتَابَ
u'أَدْخَلَ كُفَّارٌ':Predicate, #1: 1	أَدْخَلَ الْكَفَّ
u'أَدْخَلَ كَلْبٌ':Subject, #1: 1	أَدْخَلَ الْكُفَّارَ
u'أَدْخَلَ لاَمٌ':Predicate, #1: 1	أَدْخَلَ الْكَلْبُ
u'أَدْخَلَ لاَمٌ':Predicate, #1: 1	أَدْخَلَ اللَّامَ
u'أَدْخَلَ لَحْمٌ':Predicate, #1: 1	أَدْخَلَ لَامَ
u'أَدْخَلَ لِفَافَةٌ':Predicate, #1: 1	أَدْخَلَ اللَّحْمَ
u'أَدْخَلَ لَوْحٌ':Predicate, #1: 1	أَدْخَلَ اللِّفَافَةَ
u'أَدْخَلَ مَأْمُورٌ':Predicate, #2: 2	أَدْخَلَ اللَّوْحَ
u'أَدْخَلَ مُحْدِثٌ':Subject, #1: 1	أَدْخَلَ الْمَأْمُورَ
u'أَدْخَلَ مُحْرِمٌ':Subject, #2: 2	أَدْخَلَ الْمُحْدِثُ
u'أَدْخَلَ مَرَارَةٌ':Predicate, #1: 1	أَدْخَلَ الْمُحْرِمُ
u'أَدْخَلَ مَرَافِقُ':Predicate, #2: 2	أَدْخَلَ الْمَرَارَةَ
u'أَدْخَلَ مُسْتَعِيرٌ':Subject, #1: 1	أَدْخَلَ الْمَرَافِقَ
u'أَدْخَلَ مُسْتَيْقِظ':Subject, #1: 1	أَدْخَلَ الْمُسْتَعِيرُ
u'أَدْخَلَ مُصَنِّفٌ':Subject, #1: 1	أَدْخَلَ الْمُسْتَيْقِظُ
u'أَدْخَلَ مُغِلّ':Predicate, #2: 2	أَدْخَلَ الْمُصَنِّفُ
u'أَدْخَلَ مُؤْمِنٌ':Predicate, #1: 1	أَدْخَلَ مُغِلَّ
u'أَدْخَلَ نِساءٌ':Subject, #1: 1	أَدْخَلَ الْمُؤْمِنَ
u'أَدْخَلَ نَقْصٌ':Predicate, #2: 2	أَدْخَلَ النِّسَاءُ
u'أَدْخَلَ نَقْضٌ':Predicate, #9: 9	أَدْخَلَ النَّقْصَ
u'أَدْخَلَ وَاقِفٌ':Subject, #2: 2	أَدْخَلَ النَّقْضَ
u'أَدْخَلَ يَدٌ':Predicate, #1: 1	أَدْخَلَ الْوَاقِفُ
u'إِدْرَاجٌ سِعَايَةٌ':Added, #1: 1	أَدْخَلَ الْيَدَ
u'إِدْرَاجٌ قول':Added, #1: 1	إِدْرَاجِ السِّعَايَةِ
u'إِدْرَاجٌ قَوْلٌ':Added, #1: 1	إِدْرَاجِ قَوْلِ
u'إدْرَارٌ أُمٌّ':Added, #1: 1	إِدْرَاجِ قَوْلِ
u'إدْرَارٌ إِنْفاقٌ':Added, #1: 1	إدْرَارِ الْأُمِّ
u'إدْرَارٌ بَوْلٌ':Added, #1: 1	إدْرَارُ الْإِنْفَاقِ
u'إدْرَارٌ رِزْقٌ':Added, #1: 1	إدْرَارِ الْبَوْلِ
u'إدْرَارٌ رِزْقٌ':Added, #1: 1	إدْرَارُ رِزْقِهِ
u'إدْرَارٌ نَفَقَةٌ':Added, #1: 1	إدْرَارِ رِزْقِهِ
u'إِدْرَاكٌ حَجٌّ':Added, #1: 1	إدْرَارُ النَّفَقَةِ
u'إِدْرَاكٌ حقائق':Added, #1: 1	إِدْرَاكِ الْحَجِّ
u'إِدْرَاكٌ حَقَائِقُ':Added, #1: 1	إِدْرَاكِ الْحَقَائِقِ
u'إِدْرَاكٌ ركعة':Added, #1: 1	إِدْرَاكِ الْحَقَائِقِ
u'إِدْرَاكٌ رَكْعَةٌ':Added, #1: 1	إِدْرَاكِ الرَّكْعَةِ
u'إِدْرَاكٌ صَلاَةٌ':Added, #1: 1	إِدْرَاكِ الرَّكْعَةِ
u'أَدْرَجَ جَمَاعَةٌ':Subject, #1: 1	إِدْرَاكِ صَلاَةِ
u'أَدْرَجَ حُكْمٌ':Predicate, #1: 1	أَدْرَجَ جَمَاعَةٌ
u'أَدْرَجَ حَنَفِيَّةٌ':Subject, #1: 1	أَدْرَجَ الْحُكْمَ
u'أَدْرَجَ قِرَاءةٌ':Predicate, #1: 1	أَدْرَجَ الْحَنَفِيَّةُ
u'أَدْرَجَ مَاءٌ':Predicate, #1: 1	أَدْرَجَ الْقِرَاءَةَ
u'أَدَرَّ حَيْضٌ':Predicate, #1: 1	أَدْرَجَ الْمَاءَ
u'أَدْرَكَ أحَدٌ':Predicate, #1: 1	أَدَرَّ الْحَيْضَ
u'أَدْرَكَ اِخْتِلاَفٌ':Predicate, #3: 3	أَدْرَكَ أَحَدَ
u'أَدْرَكَ آخِرُ':Predicate, #1: 1	أَدْرَكَ الاِخْتِلاَفَ
u'أَدْرَكَ أَذَانٌ':Predicate, #3: 3	أَدْرَكَ آخِرَ
u'أَدْرَكَ إِسْلامٌ':Predicate, #1: 1	أَدْرَكَ الْأَذَانَ
u'أَدْرَكَ إِسْلامٌ':Predicate, #1: 1	أَدْرَكَ الإِسْلاَمَ
u'أَدْرَكَ أَصْحَابٌ':Subject, #6: 6	أَدْرَكَ الْإِسْلَامَ
u'أَدْرَكَ أقَلُّ':Predicate, #1: 1	أَدْرَكَ أَصْحَابُ
u'أَدْرَكَ المُشْتَرِي':Predicate, #2: 2	أَدْرَكَ أَقَلَّ
u'أَدْرَكَ إمَامٌ':Predicate, #1: 1	أَدْرَكَ الْمُشْتَرِيَ
u'أَدْرَكَ إمَامٌ':Predicate, #1: 1	أَدْرَكَ الإِمَامَ
u'أَدْرَكَ إمَامٌ':Predicate, #1: 1	أَدْرَكَ إمَامَ
u'أَدْرَكَ إمَامٌ':Subject, #84: 84	أَدْرَكَ الْإِمَامَ
u'أَدْرَكَ أوَانٌ':Predicate, #3: 3	أَدْرَكَ الْإِمَامُ
u'أَدْرَكَ أَوَّلُ':Predicate, #1: 1	أَدْرَكَ أَوَانَ
u'أَدْرَكَ أَوَّلُ':Subject, #16: 16	أَدْرَكَ أَوَّلَ
u'أَدْرَكَ أَوْلاَدٌ':Subject, #3: 3	أَدْرَكَ الْأَوَّلُ
u'أَدْرَكَ أيَّامٌ':Subject, #1: 1	أَدْرَكَ أَوْلاَدُهُ
u'أَدْرَكَ أَيَّامٌ':Subject, #1: 1	أَدْرَكَ أَيَّامُ
u'أَدْرَكَ بَاذِنْجَانٌ':Subject, #1: 1	أَدْرَكَ أَيَّامُ
u'أَدْرَكَ باكُورَةٌ':Predicate, #1: 1	أَدْرَكَ الْبَاذِنْجَانُ
u'أَدْرَكَ بَعْضٌ':Predicate, #1: 1	أَدْرَكَ بَاكُورَةَ
u'أَدْرَكَ بَعْضٌ':Subject, #1: 1	أَدْرَكَ بَعْضَ
u'أَدْرَكَ بَعْضٌ':Subject, #1: 1	أَدْرَكَ بَعْضُ
u'أَدْرَكَ بَيْعٌ':Predicate, #1: 1	أَدْرَكَ بَعْضُهُ
u'أَدْرَكَ تَابِعِيٌّ':Subject, #1: 1	أَدْرَكَ الْبَيْعَ
u'أَدْرَكَ تَحَوُّلٌ':Predicate, #1: 1	أَدْرَكَ التَّابِعِيُّ
u'أَدْرَكَ تَشَهُّدٌ':Predicate, #1: 1	أَدْرَكَ تَحَوُّلَ
u'أَدْرَكَ تَشَهُّدٌ':Predicate, #1: 1	أَدْرَكَ تَشَهُّدَ
u'أَدْرَكَ تَقْصيرٌ':Predicate, #2: 2	أَدْرَكَ التَّشَهُّدَ
u'أَدْرَكَ تَكْبِير':Predicate, #1: 1	أَدْرَكَ التَّقْصِيرَ
u'أَدْرَكَ تَكْبِير':Predicate, #1: 1	أَدْرَكَ تَكْبِيرَةَ
u'أَدْرَكَ ثَالِثٌ':Predicate, #3: 3	أَدْرَكَ التَّكْبِيرَةَ
u'أَدْرَكَ ثَانِي':Predicate, #1: 1	أَدْرَكَ ثَالِثَةَ
u'أَدْرَكَ ثَانِي':Predicate, #2: 2	أَدْرَكَ الثَّانِيَةَ
u'أَدْرَكَ ثَانِيَةٌ':Predicate, #4: 4	أَدْرَكَ ثَانِيَةَ
u'أَدْرَكَ ثَانِيَةٌ':Predicate, #2: 2	أَدْرَكَ الثَّانِيَةَ
u'أَدْرَكَ ثَمَرٌ':Subject, #4: 4	أَدْرَكَ ثَانِيَةَ
u'أَدْرَكَ جَاهِلِيٌّ':Predicate, #3: 3	أَدْرَكَ الثَّمَرُ
u'أَدْرَكَ جَاهِلِيَّةٌ':Predicate, #2: 2	أَدْرَكَ الْجَاهِلِيَّةَ
u'أَدْرَكَ جُلُوسٌ':Predicate, #2: 2	أَدْرَكَ الْجَاهِلِيَّةَ
u'أَدْرَكَ جَمَاعَةٌ':Predicate, #2: 2	أَدْرَكَ الْجُلُوسَ
u'أَدْرَكَ جمعة':Predicate, #8: 8	أَدْرَكَ الْجَمَاعَةَ
u'أَدْرَكَ جُمُعَةٌ':Predicate, #12: 12	أَدْرَكَ الْجُمُعَةَ
u'أَدْرَكَ حاضِرٌ':Predicate, #12: 12	أَدْرَكَ الْجُمُعَةَ
u'أَدْرَكَ حَجٌّ':Predicate, #1: 1	أَدْرَكَ الْحَاضِرَةَ
u'أَدْرَكَ حَدٌّ':Predicate, #28: 28	أَدْرَكَ الْحَجَّ
u'أَدْرَكَ حَرْبٌ':Predicate, #1: 1	أَدْرَكَ حَدَّ
u'أَدْرَكَ حول':Predicate, #1: 1	أَدْرَكَ الْحَرْبَ
u'أَدْرَكَ حَوْلٌ':Predicate, #1: 1	أَدْرَكَ الْحَوْلَ
u'أَدْرَكَ خَارِجٌ':Subject, #1: 1	أَدْرَكَ الْحَوْلَ
u'أَدْرَكَ خدمة':Predicate, #1: 1	أَدْرَكَ الْخَارِجُ
u'أَدْرَكَ خِدْمَةٌ':Predicate, #1: 1	أَدْرَكَ الْخِدْمَةَ
u'أَدْرَكَ خَلِيفَةٌ':Predicate, #1: 1	أَدْرَكَ الْخِدْمَةَ
u'أَدْرَكَ دَليلٌ':Predicate, #1: 1	أَدْرَكَ الْخَلِيفَةَ
u'أَدْرَكَ دونٌ':Predicate, #1: 1	أَدْرَكَ الدَّلِيلَ
u'أَدْرَكَ ذَكاةٌ':Predicate, #4: 4	أَدْرَكَ دُونَ
u'أَدْرَكَ رَجُلٌ':Subject, #2: 2	أَدْرَكَ ذَكَاةَ
u'أَدْرَكَ رَدَّةٌ':Predicate, #2: 2	أَدْرَكَ الرَّجُلُ
u'أَدْرَكَ رِدَّةٌ':Predicate, #1: 1	أَدْرَكَ الرّدّةَ
u'أَدْرَكَ رَسُولٌ':Predicate, #1: 1	أَدْرَكَ الرّدّةَ
u'أَدْرَكَ رَسُولٌ':Subject, #1: 1	أَدْرَكَ رَسُولَ
u'أَدْرَكَ رَغَدٌ':Predicate, #1: 1	أَدْرَكَ رَسُولُ
u'أَدْرَكَ ركعة':Predicate, #1: 1	أَدْرَكَ الرّغَدَ
u'أَدْرَكَ رَكْعَةٌ':Predicate, #1: 1	أَدْرَكَ رَكْعَةَ
u'أَدْرَكَ ركعة':Predicate, #1: 1	أَدْرَكَ رَكْعَةَ
u'أَدْرَكَ رَكْعَةٌ':Predicate, #22: 22	أَدْرَكَ الرَّكْعَةَ
u'أَدْرَكَ رُكوعٌ':Predicate, #22: 22	أَدْرَكَ الرَّكْعَةَ
u'أَدْرَكَ رُكوعٌ':Predicate, #5: 5	أَدْرَكَ رُكُوعَ
u'أَدْرَكَ رَمَضانُ':Predicate, #7: 7	أَدْرَكَ الرُّكُوعَ
u'أَدْرَكَ زَرْعٌ':Predicate, #9: 9	أَدْرَكَ رَمَضَانَ
u'أَدْرَكَ زَرْعٌ':Subject, #3: 3	أَدْرَكَ الزَّرْعَ
u'أَدْرَكَ زَمانٌ':Predicate, #9: 9	أَدْرَكَ الزَّرْعُ
u'أَدْرَكَ زَمَنٌ':Predicate, #1: 1	أَدْرَكَ زَمَانَ
u'أَدْرَكَ زَوْجٌ':Subject, #1: 1	أَدْرَكَ زَمَنَ
u'أَدْرَكَ سجدة':Predicate, #1: 1	أَدْرَكَ الزَّوْجُ
u'أَدْرَكَ سَجْدَةٌ':Predicate, #2: 2	أَدْرَكَ السَّجْدَةَ
u'أَدْرَكَ سَلَفٌ':Predicate, #2: 2	أَدْرَكَ السَّجْدَةَ
u'أَدْرَكَ شَهْرٌ':Predicate, #1: 1	أَدْرَكَ السَّلَفَ
u'أَدْرَكَ صُبْحٌ':Predicate, #3: 3	أَدْرَكَ شَهْرَ
u'أَدْرَكَ صَبِيٌّ':Subject, #10: 10	أَدْرَكَ الصُّبْحَ
u'أَدْرَكَ صَغِيرٌ':Subject, #3: 3	أَدْرَكَ الصَّبِيُّ
u'أَدْرَكَ صَفْوَان':Predicate, #4: 4	أَدْرَكَ الصَّغِيرُ
u'أَدْرَكَ صَلاَةٌ':Predicate, #1: 1	أَدْرَكَ صَفْوَانَ
u'أَدْرَكَ صَلاَةٌ':Predicate, #19: 19	أَدْرَكَ الصَّلَاةَ
u'أَدْرَكَ صَيْدٌ':Predicate, #6: 6	أَدْرَكَ الصَّلاَةَ
u'أَدْرَكَ ظُهْرٌ':Predicate, #5: 5	أَدْرَكَ الصَّيْدَ
u'أَدْرَكَ عَائِشٌ':Predicate, #3: 3	أَدْرَكَ الظُّهْرَ
u'أَدْرَكَ عَبْدٌ':Subject, #4: 4	أَدْرَكَ عَائِشَةَ
u'أَدْرَكَ عرفة':Predicate, #2: 2	أَدْرَكَ عَبْدُ
u'أَدْرَكَ عَصْرٌ':Predicate, #14: 14	أَدْرَكَ عَرَفَةَ
u'أَدْرَكَ عَصْرٌ':Predicate, #2: 2	أَدْرَكَ عَصْرَ
u'أَدْرَكَ عَقْلٌ':Subject, #8: 8	أَدْرَكَ الْعَصْرَ
u'أَدْرَكَ عُلْوٌ':Subject, #1: 1	أَدْرَكَ الْعَقْلُ
u'أَدْرَكَ عُمَرٌ':Predicate, #1: 1	أَدْرَكَ الْعُلْوُ
u'أَدْرَكَ عَهْدٌ':Predicate, #9: 9	أَدْرَكَ عُمَرَ
u'أَدْرَكَ فَاتِحٌ':Predicate, #1: 1	أَدْرَكَ عَهْدَ
u'أَدْرَكَ فَاتِحَةٌ':Predicate, #1: 1	أَدْرَكَ الْفَاتِحَةَ
u'أَدْرَكَ فرد':Predicate, #1: 1	أَدْرَكَ الْفَاتِحَةَ
u'أَدْرَكَ فَرْدٌ':Predicate, #1: 1	أَدْرَكَ الْفَرْدَ
u'أَدْرَكَ فَضْلٌ':Predicate, #1: 1	أَدْرَكَ الْفَرْدَ
u'أَدْرَكَ فَضِيلٌ':Predicate, #4: 4	أَدْرَكَ فَضْلَ
u'أَدْرَكَ فَضِيلَةٌ':Predicate, #1: 1	أَدْرَكَ فَضِيلَةَ
u'أَدْرَكَ فُلاَنٌ':Subject, #1: 1	أَدْرَكَ فَضِيلَةَ
u'أَدْرَكَ فُلاَنٌ':Subject, #2: 2	أَدْرَكَ فُلَانٌ
u'أَدْرَكَ قَدْرٌ':Predicate, #7: 7	أَدْرَكَ فُلَانُ
u'أَدْرَكَ قِرَاءةٌ':Predicate, #1: 1	أَدْرَكَ قَدْرَ
u'أَدْرَكَ قَسْمٌ':Predicate, #2: 2	أَدْرَكَ قِرَاءَةَ
u'أَدْرَكَ قَوْمٌ':Predicate, #1: 1	أَدْرَكَ الْقَسْمَ
u'أَدْرَكَ قيام':Predicate, #2: 2	أَدْرَكَ الْقَوْمَ
u'أَدْرَكَ قِيَامٌ':Predicate, #3: 3	أَدْرَكَ الْقِيَامَ
u'أَدْرَكَ كَلْبٌ':Predicate, #3: 3	أَدْرَكَ الْقِيَامَ
u'أَدْرَكَ لَقِيطٌ':Subject, #1: 1	أَدْرَكَ الْكَلْبَ
u'أَدْرَكَ لَيْلٌ':Predicate, #4: 4	أَدْرَكَ اللَّقِيطُ
u'أَدْرَكَ مَاءٌ':Predicate, #4: 4	أَدْرَكَ لَيْلَةَ
u'أَدْرَكَ مَالِكٌ':Subject, #1: 1	أَدْرَكَ الْمَاءَ
u'أَدْرَكَ مَحَلٌّ':Predicate, #1: 1	أَدْرَكَ مَالِكٌ
u'أَدْرَكَ مُحَمَّدٌ':Subject, #3: 3	أَدْرَكَ مَحَلَّ
u'أَدْرَكَ مُدٌّ':Predicate, #1: 1	أَدْرَكَ مُحَمَّدُ
u'أَدْرَكَ مُدَّةٌ':Predicate, #3: 3	أَدْرَكَ مُدَّ
u'أَدْرَكَ مُرْسِلٌ':Subject, #3: 3	أَدْرَكَ مُدَّةَ
u'أَدْرَكَ مَسَاءٌ':Predicate, #4: 4	أَدْرَكَ الْمُرْسِلُ
u'أَدْرَكَ مُسَافِرٌ':Subject, #1: 1	أَدْرَكَ الْمَسَاءَ
u'أَدْرَكَ مَسْبُوق':Predicate, #1: 1	أَدْرَكَ الْمُسَافِرُ
u'أَدْرَكَ مَسْبُوق':Subject, #1: 1	أَدْرَكَ الْمَسْبُوقَ
u'أَدْرَكَ مَسْبُوق':Subject, #1: 1	أَدْرَكَ مَسْبُوقُ
u'أَدْرَكَ مَسْمُوعٌ':Predicate, #9: 9	أَدْرَكَ الْمَسْبُوقُ
u'أَدْرَكَ مُشْتَرِي':Predicate, #1: 1	أَدْرَكَ الْمَسْمُوعَ
u'أَدْرَكَ مَصْلَحَةٌ':Predicate, #1: 1	أَدْرَكَ الْمُشْتَرِيَ
u'أَدْرَكَ مُعْظَمٌ':Predicate, #1: 1	أَدْرَكَ الْمَصْلَحَةَ
u'أَدْرَكَ مُهَاجِرٌ':Predicate, #1: 1	أَدْرَكَ مُعْظَمَ
u'أَدْرَكَ مَوْلِدٌ':Predicate, #1: 1	أَدْرَكَ الْمُهَاجِرِينَ
u'أَدْرَكَ مِيرَاثٌ':Predicate, #1: 1	أَدْرَكَ مَوْلِدَ
u'أَدْرَكَ نَاسٌ':Predicate, #1: 1	أَدْرَكَ الْمِيرَاثَ
u'أَدْرَكَ نَاسٌ':Subject, #1: 1	أَدْرَكَ النَّاسَ
u'أَدْرَكَ نَبِيٌّ':Predicate, #2: 2	أَدْرَكَ النَّاسُ
u'أَدْرَكَ نَبِيٌّ':Subject, #6: 6	أَدْرَكَ النَّبِيَّ
u'أَدْرَكَ نَيْلٌ':Predicate, #1: 1	أَدْرَكَ النَّبِيُّ
u'أَدْرَكَ وُجُوبٌ':Predicate, #1: 1	أَدْرَكَ النَّيْلَ
u'أَدْرَكَ وَقْتٌ':Predicate, #1: 1	أَدْرَكَ الْوُجُوبَ
u'أَدْرَكَ وَقْتٌ':Predicate, #3: 3	أَدْرَكَ الْوَقْتَ
u'أَدْرَكَ وُقُوفٌ':Predicate, #3: 3	أَدْرَكَ وَقْتَ
u'أَدْرَكَ ولد':Subject, #7: 7	أَدْرَكَ الْوُقُوفَ
u'أَدْرَكَ وَلَدٌ':Subject, #1: 1	أَدْرَكَ الْوَلَدُ
u'أَدْرَكَ ولد':Subject, #1: 1	أَدْرَكَ الْوَلَدُ
u'أَدْرَكَ وَلَدٌ':Subject, #2: 2	أَدْرَكَ وَلَدُهُ
u'أَدْرَكَ يَتِيمٌ':Subject, #2: 2	أَدْرَكَ وَلَدُهُ
u'أَدْرَى حَقِيقٌ':Predicate, #2: 2	أَدْرَكَ الْيَتِيمُ
u'أَدْرَى حَقِيقَةٌ':Predicate, #1: 1	أَدْرَى حَقِيقَةَ
u'أَدْرَى غَائِبٌ':Predicate, #1: 1	أَدْرَى حَقِيقَةَ
u'أَدْلَى جَمَاعَةٌ':Subject, #1: 1	أَدْرَى الْغَائِبَ
u'أَدْلَى شَخْصٌ':Subject, #3: 3	أَدْلَى جَمَاعَةٌ
u'أَدْمَنَ رَسُولٌ':Subject, #1: 1	أَدْلَى شَخْصٌ
u'أَدْمَنَ قرع':Predicate, #1: 1	أَدْمَنَ رَسُولُ
u'أَدْمَنَ قَرْعٌ':Predicate, #3: 3	أَدْمَنَ قَرْعَ
u'أَدْنَى إِرْسَالٌ':Subject, #3: 3	أَدْمَنَ قَرْعَ
u'أَدْنَى بَصيرَةٌ':Subject, #1: 1	أَدْنَى إِرْسَالٌ
u'أَدْنَى جَازٌ':Predicate, #1: 1	أَدْنَى بَصِيرَةٌ
u'أَدْنَى حَسَنٌ':Subject, #2: 2	أَدْنَى جَازَ
u'أَدْنَى فلان':Predicate, #1: 1	أَدْنَى حَسَنٌ
u'أَدْنَى مثل':Predicate, #1: 1	أَدْنَى خَيْبَرَ
u'أَدْنَى مِثْلٌ':Predicate, #1: 1	أَدْنَى مِثْلَ
u'أَدْنَى مَرَاتِبُ':Predicate, #1: 1	أَدْنَى مِثْلَ
u'أَدْنَى مُرْسَلٌ':Predicate, #1: 1	أَدْنَى مَرَاتِبَ
u'أَدْنَى مُسْلِمٌ':Predicate, #1: 1	أَدْنَى الْمُرْسَلِينَ
u'أَدْنَى مُؤْمِنٌ':Predicate, #4: 4	أَدْنَى الْمُسْلِمِينَ
u'أَدَّى أَبٌ':Subject, #1: 1	أَدْنَى الْمُؤْمِنِينَ
u'أَدَّى إِثْبَاتٌ':Subject, #11: 11	أَدَّى الْأَبُ
u'أَدَّى اِجْتِهَادٌ':Subject, #1: 1	أَدَّى إثْبَاتُهُ
u'أَدَّى اِجْتِهَادٌ':Subject, #2: 2	أَدَّى اجْتِهَادُ
u'أَدَّى أَجْرٌ':Predicate, #5: 5	أَدَّى اجْتِهَادُهُ
u'أَدَّى أَجْرٌ':Predicate, #1: 1	أَدَّى أَجْرَ
u'أَدَّى أُجْرَةٌ':Predicate, #1: 1	أَدَّى الْأَجْرَ
u'أَدَّى أَجْوَدُ':Predicate, #1: 1	أَدَّى الْأُجْرَةَ
u'أَدَّى أحَدٌ':Subject, #3: 3	أَدَّى أَجْوَدَ
u'أَدَّى إحْضَارٌ':Subject, #6: 6	أَدَّى أَحَدُ
u'أَدَّى أَرْبَعُ':Predicate, #1: 1	أَدَّى إحْضَارُهُ
u'أَدَّى أَرْبَعَةٌ':Predicate, #3: 3	أَدَّى أَرْبَعَ
u'أَدَّى أَرْدَأَ':Predicate, #4: 4	أَدَّى أَرْبَعَةَ
u'أَدَّى أَسْفَلُ':Predicate, #1: 1	أَدَّى أَرْدَأَ
u'أَدَّى أَسْفَلُ':Subject, #1: 1	أَدَّى الْأَسْفَلَ
u'أَدَّى أَصيلٌ':Subject, #1: 1	أَدَّى الْأَسْفَلُ
u'أَدَّى أَعْمَالٌ':Predicate, #2: 2	أَدَّى الْأَصِيلُ
u'أَدَّى أَفْعَالٌ':Predicate, #1: 1	أَدَّى الْأَعْمَالَ
u'أَدَّى أقَلُّ':Predicate, #3: 3	أَدَّى الْأَفْعَالَ
u'أَدَّى أَكْثَرُ':Predicate, #3: 3	أَدَّى أَقَلَّ
u'أَدَّى أَكْثَرُ':Predicate, #2: 2	أَدَّى أَكْثَرَ
u'أَدَّى ألف':Predicate, #2: 2	أَدَّى الْأَكْثَرَ
u'أَدَّى ألْفٌ':Predicate, #8: 8	أَدَّى الْأَلْفَ
u'أَدَّى أَلْفٌ':Predicate, #8: 8	أَدَّى الْأَلْفَ
u'أَدَّى إمَامٌ':Subject, #8: 8	أَدَّى الْأَلْفَ
u'أَدَّى إمَامٌ':Subject, #1: 1	أَدَّى الإِمَامُ
u'أَدَّى إمَامٌ':Subject, #1: 1	أَدَّى إمَامٌ
u'أَدَّى أمَانٌ':Subject, #7: 7	أَدَّى الْإِمَامُ
u'أَدَّى أمَانَةٌ':Predicate, #1: 1	أَدَّى أَمَانُ
u'أَدَّى أمَانَةٌ':Predicate, #1: 1	أَدَّى الأَمَانَةَ
u'أَدَّى آمِرٌ':Subject, #4: 4	أَدَّى الْأَمَانَةَ
u'أَدَّى أَوَّلُ':Predicate, #4: 4	أَدَّى الْآمِرُ
u'أَدَّى أَوَّلُ':Subject, #2: 2	أَدَّى الْأَوَّلَ
u'أَدَّى بَدَلٌ':Predicate, #6: 6	أَدَّى الْأَوَّلُ
u'أَدَّى بَدَلٌ':Predicate, #19: 19	أَدَّى بَدَلَ
u'أَدَّى بَطَلٌ':Predicate, #9: 9	أَدَّى الْبَدَلَ
u'أَدَّى بَعْضٌ':Predicate, #1: 1	أَدَّى بَطَلَ
u'أَدَّى بَعْضٌ':Predicate, #11: 11	أَدَّى الْبَعْضَ
u'أَدَّى بَعْضٌ':Subject, #17: 17	أَدَّى بَعْضَ
u'أَدَّى بَعيرٌ':Predicate, #1: 1	أَدَّى الْبَعْضُ
u'أَدَّى تَرَاوِيحُ':Predicate, #2: 2	أَدَّى الْبَعِيرَ
u'أَدَّى تَرْكٌ':Subject, #1: 1	أَدَّى التَّرَاوِيحَ
u'أَدَّى تَغْيِيرٌ':Subject, #1: 1	أَدَّى تَرْكُهُ
u'أَدَّى ثُبُوتٌ':Subject, #1: 1	أَدَّى التَّغْيِيرُ
u'أَدَّى ثَلاثُ':Predicate, #1: 1	أَدَّى ثُبُوتُهُ
u'أَدَّى ثَلاثَةٌ':Predicate, #4: 4	أَدَّى ثَلَاثَ
u'أَدَّى ثَمَنٌ':Predicate, #11: 11	أَدَّى ثَلَاثَةَ
u'أَدَّى جَازٌ':Predicate, #16: 16	أَدَّى الثَّمَنَ
u'أَدَّى جَزَاءٌ':Predicate, #1: 1	أَدَّى جَازَ
u'أَدَّى جَزَاءٌ':Predicate, #1: 1	أَدَّى جَزَاءَ
u'أَدَّى جِزْيَةٌ':Predicate, #7: 7	أَدَّى الْجَزَاءَ
u'أَدَّى جمعة':Predicate, #1: 1	أَدَّى الْجِزْيَةَ
u'أَدَّى جُمُعَةٌ':Predicate, #1: 1	أَدَّى الْجُمُعَةَ
u'أَدَّى جَيِّدٌ':Predicate, #1: 1	أَدَّى الْجُمُعَةَ
u'أَدَّى حاضِرٌ':Subject, #1: 1	أَدَّى الْجَيِّدَ
u'أَدَّى حَجٌّ':Predicate, #3: 3	أَدَّى الْحَاضِرُ
u'أَدَّى حُرٌّ':Subject, #3: 3	أَدَّى الْحَجَّ
u'أَدَّى حُرٌّ':Subject, #1: 1	أَدَّى حُرٌّ
u'أَدَّى حِصَّةٌ':Predicate, #3: 3	أَدَّى الْحُرُّ
u'أَدَّى حَظٌّ':Predicate, #2: 2	أَدَّى حِصَّةَ
u'أَدَّى حَقٌّ':Predicate, #1: 1	أَدَّى حَظَّ
u'أَدَّى حَقٌّ':Predicate, #11: 11	أَدَّى حَقَّ
u'أَدَّى خَارِجٌ':Predicate, #3: 3	أَدَّى الْحَقَّ
u'أَدَّى خامس':Predicate, #1: 1	أَدَّى خَارِجَ
u'أَدَّى خَامِسٌ':Predicate, #1: 1	أَدَّى الْخَامِسَةَ
u'أَدَّى خراج':Predicate, #1: 1	أَدَّى الْخَامِسَةَ
u'أَدَّى خَرَاجٌ':Predicate, #3: 3	أَدَّى الْخَرَاجَ
u'أَدَّى خراج':Predicate, #3: 3	أَدَّى الْخَرَاجَ
u'أَدَّى خَرَاجٌ':Predicate, #3: 3	أَدَّى خَرَاجَ
u'أَدَّى خِلاَفٌ':Predicate, #3: 3	أَدَّى خَرَاجَ
u'أَدَّى خَمْرٌ':Predicate, #1: 1	أَدَّى خِلَافَ
u'أَدَّى خَمْسٌ':Predicate, #14: 14	أَدَّى الْخَمْرَ
u'أَدَّى خَمْسَةٌ':Predicate, #3: 3	أَدَّى خَمْسَ
u'أَدَّى دَرَاهِمُ':Predicate, #9: 9	أَدَّى خَمْسَةَ
u'أَدَّى دَقيقٌ':Predicate, #3: 3	أَدَّى الدَّرَاهِمَ
u'أَدَّى دِيَةٌ':Predicate, #1: 1	أَدَّى الدَّقِيقَ
u'أَدَّى دَيْنٌ':Predicate, #1: 1	أَدَّى دِيَةَ
u'أَدَّى دَيْنٌ':Predicate, #14: 14	أَدَّى الدَّيْنَ
u'أَدَّى رَاهِنٌ':Subject, #8: 8	أَدَّى دَيْنَ
u'أَدَّى رُبُعٌ':Predicate, #2: 2	أَدَّى الرَّاهِنُ
u'أَدَّى رُطَبٌ':Predicate, #3: 3	أَدَّى رُبُعَ
u'أَدَّى رِعايَةٌ':Subject, #1: 1	أَدَّى الرُّطَبَ
u'أَدَّى رُكْنٌ':Predicate, #1: 1	أَدَّى رِعَايَةُ
u'أَدَّى رُكْن':Predicate, #1: 1	أَدَّى الرُّكْنَ
u'أَدَّى رُكْنٌ':Predicate, #1: 1	أَدَّى الرُّكْنَ
u'أَدَّى رُكْن':Predicate, #3: 3	أَدَّى رُكْنَ
u'أَدَّى زَكاةٌ':Predicate, #3: 3	أَدَّى رُكْنَ
u'أَدَّى زَكاةٌ':Predicate, #16: 16	أَدَّى زَكَاةَ
u'أَدَّى زَوْجٌ':Subject, #17: 17	أَدَّى الزَّكَاةَ
u'أَدَّى زُيوفٌ':Predicate, #6: 6	أَدَّى الزَّوْجُ
u'أَدَّى زُيُوفٌ':Predicate, #2: 2	أَدَّى الزُّيُوفَ
u'أَدَّى سِعَايَةٌ':Predicate, #2: 2	أَدَّى الزُّيُوفَ
u'أَدَّى سقط':Predicate, #3: 3	أَدَّى السِّعَايَةَ
u'أَدَّى سَقَطٌ':Predicate, #3: 3	أَدَّى سَقَطَ
u'أَدَّى سُنَّةٌ':Predicate, #3: 3	أَدَّى سَقَطَ
u'أَدَّى سَيِّدٌ':Predicate, #1: 1	أَدَّى السُّنَّةَ
u'أَدَّى سَيِّدٌ':Subject, #1: 1	أَدَّى السَّيِّدَ
u'أَدَّى شَاهِدٌ':Subject, #1: 1	أَدَّى السَّيِّدُ
u'أَدَّى شَاهِدٌ':Subject, #1: 1	أَدَّى شَاهِدٌ
u'أَدَّى شكر':Predicate, #2: 2	أَدَّى الشَّاهِدُ
u'أَدَّى شُكْرٌ':Predicate, #1: 1	أَدَّى الشُّكْرَ
u'أَدَّى شكر':Predicate, #1: 1	أَدَّى الشُّكْرَ
u'أَدَّى شُكْرٌ':Predicate, #3: 3	أَدَّى شُكْرَ
u'أَدَّى شَهَادَةٌ':Predicate, #3: 3	أَدَّى شُكْرَ
u'أَدَّى صداق':Predicate, #1: 1	أَدَّى الشَّهَادَةَ
u'أَدَّى صَدَاقٌ':Predicate, #1: 1	أَدَّى الصَّدَاقَ
u'أَدَّى صدقة':Predicate, #1: 1	أَدَّى الصَّدَاقَ
u'أَدَّى صَدَقَةٌ':Predicate, #1: 1	أَدَّى الصَّدَقَةَ
u'أَدَّى صدقة':Predicate, #1: 1	أَدَّى الصَّدَقَةَ
u'أَدَّى صَدَقَةٌ':Predicate, #5: 5	أَدَّى صَدَقَةَ
u'أَدَّى صَلاَةٌ':Predicate, #5: 5	أَدَّى صَدَقَةَ
u'أَدَّى ضَارِبٌ':Subject, #3: 3	أَدَّى الصَّلَاةَ
u'أَدَّى ضَامِنٌ':Subject, #2: 2	أَدَّى الضَّارِبُ
u'أَدَّى ضَمَانٌ':Predicate, #3: 3	أَدَّى الضَّامِنُ
u'أَدَّى ضَمَانٌ':Predicate, #13: 13	أَدَّى الضَّمَانَ
u'أَدَّى طَائِفٌ':Predicate, #2: 2	أَدَّى ضَمَانَ
u'أَدَّى طعام':Predicate, #1: 1	أَدَّى طَائِفَةً
u'أَدَّى طَعَامٌ':Predicate, #1: 1	أَدَّى الطَّعَامَ
u'أَدَّى ظُهْرٌ':Predicate, #1: 1	أَدَّى الطَّعَامَ
u'أَدَّى عَاقِدٌ':Subject, #1: 1	أَدَّى الظُّهْرَ
u'أَدَّى عِبَادَةٌ':Predicate, #1: 1	أَدَّى الْعَاقِدُ
u'أَدَّى عَبْدٌ':Subject, #4: 4	أَدَّى الْعِبَادَةَ
u'أَدَّى عتق':Predicate, #7: 7	أَدَّى الْعَبْدُ
u'أَدَّى عَدَمٌ':Subject, #21: 21	أَدَّى عَتَقَ
u'أَدَّى عُشْرٌ':Predicate, #1: 1	أَدَّى عَدَمُ
u'أَدَّى عُشْرٌ':Predicate, #2: 2	أَدَّى الْعُشْرَ
u'أَدَّى عَصْرٌ':Predicate, #2: 2	أَدَّى عُشْرَ
u'أَدَّى عقر':Predicate, #1: 1	أَدَّى الْعَصْرَ
u'أَدَّى عُقْرٌ':Predicate, #1: 1	أَدَّى الْعُقْرَ
u'أَدَّى عمرة':Predicate, #1: 1	أَدَّى الْعُقْرَ
u'أَدَّى عُمْرَةٌ':Predicate, #2: 2	أَدَّى الْعُمْرَةَ
u'أَدَّى غَاصِبٌ':Subject, #2: 2	أَدَّى الْعُمْرَةَ
u'أَدَّى غَائِبٌ':Subject, #7: 7	أَدَّى الْغَاصِبُ
u'أَدَّى غير':Predicate, #2: 2	أَدَّى الْغَائِبُ
u'أَدَّى غَيْرٌ':Predicate, #1: 1	أَدَّى غَيْرَ
u'أَدَّى غير':Subject, #1: 1	أَدَّى غَيْرَ
u'أَدَّى غَيْرٌ':Subject, #3: 3	أَدَّى غَيْرُهُ
u'أَدَّى فَاسِقٌ':Predicate, #3: 3	أَدَّى غَيْرُهُ
u'أَدَّى فِدَاءٌ':Predicate, #1: 1	أَدَّى الْفَاسِقَ
u'أَدَّى فَرْضٌ':Predicate, #2: 2	أَدَّى الْفِدَاءَ
u'أَدَّى فَرْضٌ':Predicate, #4: 4	أَدَّى الْفَرْضَ
u'أَدَّى فَضْلٌ':Predicate, #6: 6	أَدَّى فَرْضَ
u'أَدَّى فُلاَنٌ':Subject, #1: 1	أَدَّى الْفَضْلَ
u'أَدَّى قَابِلٌ':Subject, #1: 1	أَدَّى فُلَانٌ
u'أَدَّى قَتِيلٌ':Predicate, #2: 2	أَدَّى الْقَابِلُ
u'أَدَّى قَدْرٌ':Predicate, #1: 1	أَدَّى قَتِيلَ
u'أَدَّى قِيمَةٌ':Predicate, #7: 7	أَدَّى قَدْرَ
u'أَدَّى قِيمَةٌ':Predicate, #14: 14	أَدَّى الْقِيمَةَ
u'أَدَّى قِيمَةٌ':Subject, #9: 9	أَدَّى قِيمَةَ
u'أَدَّى كِتَابَةٌ':Predicate, #1: 1	أَدَّى قِيمَتُهُ
u'أَدَّى كَفِيلٌ':Predicate, #11: 11	أَدَّى الْكِتَابَةَ
u'أَدَّى كَفِيلٌ':Subject, #1: 1	أَدَّى الْكَفِيلَ
u'أَدَّى مَالٌ':Predicate, #18: 18	أَدَّى الْكَفِيلُ
u'أَدَّى مَالٌ':Predicate, #13: 13	أَدَّى الْمَالَ
u'أَدَّى مَتْرُوكٌ':Predicate, #4: 4	أَدَّى مَالَ
u'أَدَّى مثل':Predicate, #1: 1	أَدَّى الْمَتْرُوكَةَ
u'أَدَّى مِثْلٌ':Predicate, #4: 4	أَدَّى مِثْلَ
u'أَدَّى مُحْتَالٌ':Subject, #4: 4	أَدَّى مِثْلَ
u'أَدَّى مُحْرِمٌ':Subject, #4: 4	أَدَّى الْمُحْتَالُ
u'أَدَّى مُحِيل':Subject, #1: 1	أَدَّى الْمُحْرِمُ
u'أَدَّى مُدَبَّرٌ':Subject, #3: 3	أَدَّى الْمُحِيلُ
u'أَدَّى مَدْيُونٌ':Subject, #2: 2	أَدَّى الْمُدَبَّرُ
u'أَدَّى مَدْيُونٌ':Subject, #1: 1	أَدَّى مَدْيُونٌ
u'أَدَّى مُرْتَهِنٌ':Subject, #2: 2	أَدَّى الْمَدْيُونُ
u'أَدَّى مُسَلَّمٌ':Subject, #2: 2	أَدَّى الْمُرْتَهِنُ
u'أَدَّى مَشْرُوطٌ':Predicate, #1: 1	أَدَّى الْمُسَلَّمُ
u'أَدَّى مَطْلُوبٌ':Predicate, #1: 1	أَدَّى الْمَشْرُوطَ
u'أَدَّى مُعِير':Subject, #1: 1	أَدَّى الْمَطْلُوبَ
u'أَدَّى مِقْدَارٌ':Predicate, #1: 1	أَدَّى الْمُعِيرُ
u'أَدَّى مُقَيَّدٌ':Subject, #1: 1	أَدَّى مِقْدَارَ
u'أَدَّى مُكَاتَبَةٌ':Predicate, #1: 1	أَدَّى مُقَيَّدٌ
u'أَدَّى مَكَانٌ':Predicate, #9: 9	أَدَّى الْمُكَاتَبَةَ
u'أَدَّى مُكَسَّرٌ':Predicate, #2: 2	أَدَّى مَكَانَ
u'أَدَّى مَكْفُولٌ':Subject, #1: 1	أَدَّى مُكَسَّرَةً
u'أَدَّى مَنْذُور':Predicate, #2: 2	أَدَّى الْمَكْفُولُ
u'أَدَّى مَهْرٌ':Predicate, #2: 2	أَدَّى الْمَنْذُورَ
u'أَدَّى مَهْرٌ':Predicate, #1: 1	أَدَّى مَهْرَ
u'أَدَّى مَوْقِعٌ':Predicate, #2: 2	أَدَّى الْمَهْرَ
u'أَدَّى مُوَكِّلٌ':Subject, #1: 1	أَدَّى مَوْقِعَ
u'أَدَّى مَوْلُودٌ':Subject, #1: 1	أَدَّى الْمُوَكِّلُ
u'أَدَّى نُجُومٌ':Predicate, #1: 1	أَدَّى الْمَوْلُودُ
u'أَدَّى نُجُومٌ':Predicate, #12: 12	أَدَّى النُّجُومَ
u'أَدَّى نِصْفٌ':Predicate, #1: 1	أَدَّى نُجُومَ
u'أَدَّى نِصْفٌ':Predicate, #12: 12	أَدَّى نِصْفَ
u'أَدَّى نَصِيبٌ':Predicate, #3: 3	أَدَّى النِّصْفَ
u'أَدَّى نَظَرٌ':Subject, #1: 1	أَدَّى نَصِيبَ
u'أَدَّى نَفَقَةٌ':Predicate, #1: 1	أَدَّى نَظَرُهُ
u'أَدَّى نُقْصَانٌ':Predicate, #1: 1	أَدَّى نَفَقَةَ
u'أَدَّى وَاجِبٌ':Predicate, #1: 1	أَدَّى النُّقْصَانَ
u'أَدَّى وَاجِبٌ':Predicate, #1: 1	أَدَّى وَاجِبَ
u'أَدَّى واحد':Predicate, #2: 2	أَدَّى الْوَاجِبَ
u'أَدَّى وَاحِدٌ':Predicate, #1: 1	أَدَّى وَاحِدَةً
u'أَدَّى واحد':Subject, #1: 1	أَدَّى وَاحِدَةً
u'أَدَّى وَاحِدٌ':Subject, #3: 3	أَدَّى وَاحِدٌ
u'أَدَّى وَارِثٌ':Subject, #3: 3	أَدَّى وَاحِدٌ
u'أَدَّى وُجُوبٌ':Subject, #1: 1	أَدَّى الْوَارِثُ
u'أَدَّى وَرَثَةٌ':Subject, #1: 1	أَدَّى وُجُوبُهُ
u'أَدَّى وسط':Predicate, #1: 1	أَدَّى وَرَثَتُهُ
u'أَدَّى وَسَطٌ':Predicate, #1: 1	أَدَّى الْوَسَطَ
u'أَدَّى وَظِيفٌ':Predicate, #1: 1	أَدَّى الْوَسَطَ
u'أَدَّى وَظِيفَةٌ':Predicate, #1: 1	أَدَّى الْوَظِيفَةَ
u'أَدَّى وَقْت':Subject, #1: 1	أَدَّى الْوَظِيفَةَ
u'أَدَّى وَقْتِيّ':Subject, #1: 1	أَدَّى وَقْتِيَّةٌ
u'أَدَّى وقع':Predicate, #1: 1	أَدَّى وَقْتِيَّةٌ
u'أَدَّى وَكِيلٌ':Subject, #2: 2	أَدَّى وَقَعَ
u'أَدَّى ولد':Subject, #1: 1	أَدَّى الْوَكِيلُ
u'أَدَّى وَلَدٌ':Subject, #1: 1	أَدَّى وَلَدُ
u'أَدَّى ولد':Subject, #1: 1	أَدَّى وَلَدُ
u'أَدَّى وَلَدٌ':Subject, #6: 6	أَدَّى الْوَلَدُ
u'أَدَّى وَلِيٌّ':Subject, #6: 6	أَدَّى الْوَلَدُ
u'أَدَّى يَمِينٌ':Predicate, #2: 2	أَدَّى الْوَلِيُّ
u'إذَاعَةٌ أسْرَارٌ':Added, #1: 1	أَدَّى يَمِينَ
u'إذَاعَةٌ أَسْرَارٌ':Added, #1: 1	إذَاعَةِ الْأَسْرَارِ
u'أَذَانٌ اِبْنٌ':Added, #1: 1	إذَاعَةِ الْأَسْرَارِ
u'أَذَانٌ اِبْنٌ':Added, #2: 2	أَذَانِ ابْنِ
u'أَذَانٌ أَرْبَعَةٌ':Added, #6: 6	أَذَانَ ابْنِ
u'أَذَانٌ إعْلاَمٌ':Added, #1: 1	أَذَانُ أَرْبَعَةٍ
u'أَذَانٌ الْمَرْأَةُ':Added, #1: 1	أَذَانِ الْإِعْلَامِ
u'أَذَانٌ الْمَرْأَةُ':Added, #2: 2	أَذَانَ الْمَرْأَةِ
u'أَذَانٌ الْمَرْأَةُ':Added, #2: 2	أَذَانِ الْمَرْأَةِ
u'أَذَانٌ اِمْرَأَةٌ':Added, #6: 6	أَذَانُ الْمَرْأَةِ
u'أَذَانٌ أهْلٌ':Added, #1: 1	أَذَانُ امْرَأَةٍ
u'أَذَانٌ بالِغٌ':Added, #1: 1	أَذَانَ أَهْلِ
u'أَذَانٌ بالِغٌ':Added, #1: 1	أَذَانَ الْبَالِغِ
u'أَذَانٌ ثِقَةٌ':Added, #1: 1	أَذَانُ الْبَالِغِ
u'أَذَانٌ ثِقَةٌ':Added, #1: 1	أَذَانَ ثِقَةٍ
u'أَذَانٌ جَمَاعَةٌ':Added, #1: 1	أَذَانِ ثِقَةٍ
u'أَذَانٌ جَمَاعَةٌ':Added, #1: 1	أَذَانِ الْجَمَاعَةِ
u'أَذَانٌ جَمَاعَةٌ':Added, #1: 1	أَذَانُ جَمَاعَةٍ
u'أَذَانٌ جمعة':Added, #2: 2	أَذَانَ الْجَمَاعَةِ
u'أَذَانٌ جُمُعَةٌ':Added, #13: 13	أَذَانِ الْجُمُعَةِ
u'أَذَانٌ جمعة':Added, #13: 13	أَذَانِ الْجُمُعَةِ
u'أَذَانٌ جُمُعَةٌ':Added, #1: 1	أَذَانَ الْجُمُعَةِ
u'أَذَانٌ حَيٌّ':Added, #1: 1	أَذَانَ الْجُمُعَةِ
u'أَذَانٌ حَيٌّ':Added, #1: 1	أَذَانَ الْحَيِّ
u'أَذَانٌ خطبة':Added, #4: 4	أَذَانُ الْحَيِّ
u'أَذَانٌ خُطْبَةٌ':Added, #2: 2	أَذَانِ الْخُطْبَةِ
u'أَذَانٌ رَاتِبٌ':Added, #2: 2	أَذَانِ الْخُطْبَةِ
u'أَذَانٌ رَاتِب':Added, #1: 1	أَذَانِ الرَّاتِبِ
u'أَذَانٌ رَسُولٌ':Added, #1: 1	أَذَانِ الرَّاتِبِ
u'أَذَانٌ سَابِقٌ':Added, #2: 2	أَذَانُ رَسُولِ
u'أَذَانٌ سِرَاجٌ':Added, #1: 1	أَذَانٍ سَابِقٍ
u'أَذَانٌ سَكْرَان':Added, #1: 1	أَذَانِ السِّرَاجِ
u'أَذَانٌ صُبْحٌ':Added, #1: 1	أَذَانُ السَّكْرَانِ
u'أَذَانٌ صُبْحٌ':Added, #2: 2	أَذَانُ الصُّبْحِ
u'أَذَانٌ صَبِيٌّ':Added, #7: 7	أَذَانِ الصُّبْحِ
u'أَذَانٌ صَبِيٌّ':Added, #1: 1	أَذَانُ صَبِيٍّ
u'أَذَانٌ صَلاَةٌ':Added, #5: 5	أَذَانُ الصَّبِيِّ
u'أَذَانٌ صَلاَةٌ':Added, #1: 1	أَذَانَ صَلاةٍ
u'أَذَانٌ عَبْدٌ':Added, #1: 1	أَذَانُ صَلاَةِ
u'أَذَانٌ عَبْدٌ':Added, #1: 1	أَذَانَ عَبْدِ
u'أَذَانٌ عِشَاءٌ':Added, #3: 3	أَذَانُ الْعَبْدِ
u'أَذَانٌ عَصْرٌ':Added, #3: 3	أَذَانِ الْعِشَاءِ
u'أَذَانٌ عِيسَوِيّ':Added, #4: 4	أَذَانَ الْعَصْرِ
u'أَذَانٌ غير':Added, #1: 1	أَذَانُ الْعِيسَوِيِّ
u'أَذَانٌ غَيْرٌ':Added, #1: 1	أَذَانُ الْغَيْرِ
u'أَذَانٌ غير':Added, #1: 1	أَذَانُ الْغَيْرِ
u'أَذَانٌ غَيْرٌ':Added, #1: 1	أَذَانُ غَيْرِهِ
u'أَذَانٌ غير':Added, #1: 1	أَذَانُ غَيْرِهِ
u'أَذَانٌ غَيْرٌ':Added, #2: 2	أَذَانِ غَيْرِهِ
u'أَذَانٌ غير':Added, #2: 2	أَذَانِ غَيْرِهِ
u'أَذَانٌ غَيْرٌ':Added, #4: 4	أَذَانَ غَيْرِهِ
u'أَذَانٌ فَاجِرٌ':Added, #4: 4	أَذَانَ غَيْرِهِ
u'أَذَانٌ فَاسِقٌ':Added, #1: 1	أَذَانِ الْفَاجِرِ
u'أَذَانٌ فَاسِقٌ':Added, #3: 3	أَذَانِ الْفَاسِقِ
u'أَذَانٌ فَجْرٌ':Added, #5: 5	أَذَانُ الْفَاسِقِ
u'أَذَانٌ فَجْرٌ':Added, #10: 10	أَذَانِ الْفَجْرِ
u'أَذَانٌ فلان':Added, #3: 3	أَذَانَ الْفَجْرِ
u'أَذَانٌ فلان':Added, #15: 15	أَذَانُ بِلَالٍ
u'أَذَانٌ فلان':Added, #1: 1	أَذَانَ بِلاَلٍ
u'أَذَانٌ فلان':Added, #1: 1	أَذَانِ بِلَالٍ
u'أَذَانٌ فلان':Added, #3: 3	أَذَانُ بِلالٍ
u'أَذَانٌ فلان':Added, #4: 4	أَذَانِ بِلاَلٍ
u'أَذَانٌ فلان':Added, #5: 5	أَذَانَ بِلَالٍ
u'أَذَانٌ قَاعِدٌ':Added, #5: 5	أَذَانُ بِلاَلٍ
u'أَذَانٌ كَافِرٌ':Added, #1: 1	أَذَانِ الْقَاعِدِ
u'أَذَانٌ كَافِرٌ':Added, #1: 1	أَذَانُ الْكَافِرِ
u'أَذَانٌ مَجْنُونٌ':Added, #1: 1	أَذَانُ كَافِرٍ
u'أَذَانٌ مَجْنُونٌ':Added, #1: 1	أَذَانُ الْمَجْنُونِ
u'أَذَانٌ مُحْدِثٌ':Added, #1: 1	أَذَانِ الْمَجْنُونِ
u'أَذَانٌ مُحْدِثٌ':Added, #1: 1	أَذَانَ الْمُحْدِثِ
u'أَذَانٌ مُحْدِثٌ':Added, #1: 1	أَذَانُ مُحْدِثٍ
u'أَذَانٌ مُحْدِثٌ':Added, #3: 3	أَذَانُ الْمُحْدِثِ
u'أَذَانٌ مُرَاهِقٌ':Added, #3: 3	أَذَانِ الْمُحْدِثِ
u'أَذَانٌ مَسْجِدٌ':Added, #4: 4	أَذَانُ الْمُرَاهِقِ
u'أَذَانٌ مَغْرِبٌ':Added, #1: 1	أَذَانِ مَسْجِدِهِ
u'أَذَانٌ مَغْرِبٌ':Added, #11: 11	أَذَانِ الْمَغْرِبِ
u'أَذَانٌ مُمَيِّزٌ':Added, #2: 2	أَذَانَ الْمَغْرِبِ
u'أَذَانٌ مَنَارٌ':Added, #3: 3	أَذَانُ الْمُمَيِّزِ
u'أَذَانٌ مِنْبَرٌ':Added, #1: 1	أَذَانِ الْمَنَارِ
u'أَذَانٌ مُنْخَفِضٌ':Added, #1: 1	أَذَانِ الْمِنْبَرِ
u'أَذَانٌ مُنْفَرِدٌ':Added, #2: 2	أَذَانٍ مُنْخَفِضٍ
u'أَذَانٌ مُؤَذِّنٌ':Added, #1: 1	أَذَانِ الْمُنْفَرِدِ
u'أَذَانٌ مُؤَذِّنٌ':Added, #3: 3	أَذَانُ الْمُؤَذِّنِ
u'أَذَانٌ مَوْلُودٌ':Added, #3: 3	أَذَانِ الْمُؤَذِّنِ
u'أَذَانٌ نِساءٌ':Added, #3: 3	أَذَانِ الْمَوْلُودِ
u'أَذَانٌ هشام':Added, #1: 1	أَذَانَ النِّسَاءِ
u'أَذَانٌ هِشَامٌ':Added, #1: 1	أَذَانِ هِشَامٍ
u'أَذَانٌ واحد':Added, #1: 1	أَذَانِ هِشَامٍ
u'أَذَانٌ وَاحِدٌ':Added, #1: 1	أَذَانٍ وَاحِدٍ
u'أَذَانٌ وَحْدٌ':Added, #1: 1	أَذَانٍ وَاحِدٍ
u'أَذَانٌ وَقْتٌ':Added, #1: 1	أَذَانُ وَحْدِهِ
u'أَذَانٌ يَوْمٌ':Added, #1: 1	أَذَانَ الْوَقْتِ
u'أَذَانٌ يَوْمٌ':Added, #1: 1	أَذَانُ يَوْمٍ
u'أَذَلَّ اِبْنٌ':Predicate, #1: 1	أَذَانُ يَوْمِ
u'أَذَلَّ حِرْصٌ':Subject, #1: 1	أَذَلَّ ابْنَ
u'أَذَلَّ دَهْرٌ':Subject, #1: 1	أَذَلَّ الْحِرْصُ
u'أَذِنَ أَبٌ':Subject, #1: 1	أَذَلَّ الدَّهْرُ
u'أَذَّنَ اِبْنٌ':Subject, #5: 5	أَذِنَ الْأَبُ
u'أَذِنَ أحَدٌ':Subject, #1: 1	أَذَّنَ ابْنُ
u'أَذَّنَ أحَدٌ':Subject, #1: 1	أَذِنَ أَحَدٌ
u'أَذِنَ أحَدٌ':Subject, #1: 1	أَذَّنَ أَحَدُ
u'أَذِنَ أَصيلٌ':Subject, #6: 6	أَذِنَ أَحَدُ
u'أَذِنَ أفْضَلُ':Subject, #1: 1	أَذِنَ الْأَصِيلُ
u'أَذِنَ إمَامٌ':Subject, #2: 2	أَذِنَ الْأَفْضَلُ
u'إِذْنٌ إمَامٌ':Added, #18: 18	أَذِنَ الْإِمَامُ
u'أَذِنَ إِنْسانٌ':Subject, #1: 1	إِذْنِ الإِمَامِ
u'أَذَّنَ إِنْسانٌ':Subject, #1: 1	أَذِنَ إنْسَانٌ
u'أَذِنَ أهْلٌ':Subject, #1: 1	أَذَّنَ إِنْسَانٌ
u'أَذَّنَ أَوَّلُ':Subject, #1: 1	أَذِنَ أَهْلُهُ
u'أَذِنَ بالِغٌ':Subject, #1: 1	أَذَّنَ الْأَوَّلُ
u'أَذِنَ بَائِعٌ':Subject, #1: 1	أَذِنَ الْبَالِغُ
u'أَذْنَبَ تَائِبٌ':Subject, #9: 9	أَذِنَ الْبَائِعُ
u'أَذْنَبَ صَغِيرٌ':Predicate, #1: 1	أَذْنَبَ التَّائِبُ
u'أَذْنَبَ عَبْدٌ':Subject, #1: 1	أَذْنَبَ صَغِيرَةً
u'أَذَّنَ بَعْضٌ':Subject, #1: 1	أَذْنَبَ الْعَبْدُ
u'إِذْنٌ بِكْرٌ':Added, #2: 2	أَذَّنَ بَعْضُ
u'أَذَّنَ ثَلاثَةٌ':Predicate, #1: 1	إِذْنِ الْبِكْرِ
u'أَذِنَ جَلاَلٌ':Subject, #1: 1	أَذَّنَ الثَّلَاثَةَ
u'أَذِنَ حاكِمٌ':Subject, #1: 1	أَذِنَ جَلَالُ
u'أَذِنَ حاكِمٌ':Subject, #1: 1	أَذِنَ حَاكِمٌ
u'أَذَّنَ خَمْسٌ':Predicate, #5: 5	أَذِنَ الْحَاكِمُ
u'أَذِنَ رَاهِنٌ':Subject, #1: 1	أَذَّنَ خَمْسَ
u'أَذِنَ رَبُّ':Subject, #14: 14	أَذِنَ الرَّاهِنُ
u'أَذِنَ رَجُلٌ':Subject, #3: 3	أَذِنَ رَبُّ
u'أَذِنَ رَجُلٌ':Subject, #19: 19	أَذِنَ الرَّجُلُ
u'أَذَّنَ رَجُلٌ':Subject, #2: 2	أَذِنَ رَجُلٌ
u'أَذِنَ رَسُولٌ':Predicate, #3: 3	أَذَّنَ رَجُلٌ
u'آذَنَ رَسُولٌ':Subject, #1: 1	أَذِنَ رَسُولَ
u'أَذِنَ رَسُولٌ':Subject, #1: 1	آذَنَ رَسُولُ
u'أَذِنَ زَوْجٌ':Subject, #6: 6	أَذِنَ رَسُولُ
u'أَذِنَ زَيْدٌ':Subject, #6: 6	أَذِنَ الزَّوْجُ
u'أَذَّنَ سَبْعٌ':Predicate, #1: 1	أَذِنَ زَيْدٌ
u'أَذَّنَ سَعْدٌ':Subject, #2: 2	أَذَّنَ سَبْعَ
u'أَذَّنَ سَكْرَان':Subject, #1: 1	أَذَّنَ سَعْدُ
u'أَذِنَ سَيِّدٌ':Subject, #1: 1	أَذَّنَ السَّكْرَانُ
u'أَذِنَ سَيِّدٌ':Subject, #11: 11	أَذِنَ السَّيِّدُ
u'إِذْنٌ سَيِّدٌ':Added, #7: 7	أَذِنَ سَيِّدُهُ
u'أَذِنَ شَارِعٌ':Subject, #3: 3	إِذْنِ سَيِّدِهِ
u'أَذِنَ شَرْعٌ':Subject, #3: 3	أَذِنَ الشَّارِعُ
u'أَذِنَ شَرِيكٌ':Subject, #1: 1	أَذِنَ الشَّرْعُ
u'أَذِنَ شَرِيكٌ':Subject, #2: 2	أَذِنَ الشَّرِيكُ
u'أَذِنَ صَاحِبٌ':Subject, #2: 2	أَذِنَ شَرِيكُهُ
u'أَذِنَ صَاحِبٌ':Subject, #1: 1	أَذِنَ صَاحِبُ
u'أَذَّنَ ظُهْرٌ':Subject, #1: 1	أَذِنَ صَاحِبُهُ
u'أَذِنَ عَبْدٌ':Predicate, #1: 1	أَذَّنَ الظُّهْرُ
u'أَذِنَ عَبْدٌ':Subject, #1: 1	أَذِنَ الْعَبْدَ
u'أَذِنَ عَبْدٌ':Subject, #1: 1	أَذِنَ الْعَبْدُ
u'أَذَّنَ غير':Subject, #1: 1	أَذِنَ عَبْدٌ
u'أَذَّنَ غَيْرٌ':Subject, #1: 1	أَذَّنَ غَيْرُهُ
u'أَذِنَ غير':Subject, #1: 1	أَذَّنَ غَيْرُهُ
u'أَذِنَ غَيْرٌ':Subject, #3: 3	أَذِنَ غَيْرُ
u'أَذَّنَ فلان':Subject, #3: 3	أَذِنَ غَيْرُ
u'أَذِنَ فلان':Subject, #11: 11	أَذَّنَ بِلاَلٌ
u'أَذَّنَ فلان':Subject, #1: 1	أَذِنَ مُعَاوِيَةُ
u'أَذَّنَ فلان':Subject, #3: 3	أَذَّنَ بِلالٌ
u'أَذِنَ قَيِّمٌ':Subject, #9: 9	أَذَّنَ بِلَالٌ
u'أَذِنَ كَافِرٌ':Subject, #1: 1	أَذِنَ قَيِّمٌ
u'أَذَّنَ كَافِرٌ':Subject, #1: 1	أَذِنَ الْكَافِرُ
u'آذَنَ لَيْلٌ':Predicate, #1: 1	أَذَّنَ كَافِرٌ
u'أَذَّنَ لَيْلٌ':Predicate, #1: 1	آذَنَ لَيْلَةً
u'أَذِنَ مَالِكٌ':Subject, #2: 2	أَذَّنَ لَيْلَةً
u'أَذِنَ مَالِكٌ':Subject, #1: 1	أَذِنَ الْمَالِكُ
u'إِذْنٌ مَالِكٌ':Added, #1: 1	أَذِنَ مَالِكُهُ
u'أَذَّنَ مرٌّ':Predicate, #1: 1	إِذْنِ مَالِكِهِ
u'أَذِنَ مُرْتَهِنٌ':Subject, #1: 1	أَذَّنَ مَرَّةً
u'أَذَّنَ مُسَافِرٌ':Subject, #11: 11	أَذِنَ الْمُرْتَهِنُ
u'أَذِنَ مُسْتَأْجِرٌ':Predicate, #2: 2	أَذَّنَ الْمُسَافِرُ
u'أَذَّنَ مُسْتَقْبِلٌ':Predicate, #1: 1	أَذِنَ الْمُسْتَأْجِرَ
u'أَذِنَ مُسْلِمٌ':Subject, #1: 1	أَذَّنَ مُسْتَقْبِلَ
u'أَذِنَ مُسْلِمٌ':Subject, #1: 1	أَذِنَ مُسْلِمٌ
u'أَذِنَ مُضَارِبٌ':Subject, #6: 6	أَذِنَ الْمُسْلِمُ
u'أَذِنَ مَطْلُوبٌ':Subject, #1: 1	أَذِنَ الْمُضَارِبُ
u'أَذِنَ مُعاوِيَة':Subject, #1: 1	أَذِنَ الْمَطْلُوبُ
u'أَذِنَ مُعِير':Subject, #1: 1	أَذِنَ مُعَاوِيَةُ
u'أَذَّنَ مَلَكٌ':Subject, #1: 1	أَذِنَ الْمُعِيرُ
u'أَذَّنَ مَلَكٌ':Subject, #1: 1	أَذَّنَ مَلَكٌ
u'إِذْنٌ مَوَالِي':Added, #2: 2	أَذَّنَ الْمَلَكُ
u'أَذِنَ مُؤَجِّرٌ':Subject, #5: 5	إِذْنِ مَوَالِيهِ
u'أَذَّنَ مُؤَذِّنٌ':Subject, #1: 1	أَذِنَ الْمُؤَجِّرُ
u'أَذَّنَ مُؤَذِّنٌ':Subject, #21: 21	أَذَّنَ الْمُؤَذِّنُ
u'أَذَّنَ مُؤَذِّنٌ':Subject, #2: 2	أَذَّنَ مُؤَذِّنٌ
u'أَذِنَ مُوَكِّلٌ':Subject, #3: 3	أَذَّنَ مُؤَذِّنُ
u'أَذِنَ نَاسٌ':Predicate, #2: 2	أَذِنَ الْمُوَكِّلُ
u'آذَنَ نَبِيٌّ':Predicate, #1: 1	أَذِنَ النَّاسَ
u'أَذِنَ نَبِيٌّ':Subject, #1: 1	آذَنَ النَّبِيَّ
u'أَذِنَ واحد':Subject, #3: 3	أَذِنَ النَّبِيُّ
u'أَذِنَ وَاحِدٌ':Subject, #2: 2	أَذِنَ وَاحِدٌ
u'أَذَّنَ واحد':Subject, #2: 2	أَذِنَ وَاحِدٌ
u'أَذَّنَ وَاحِدٌ':Subject, #8: 8	أَذَّنَ وَاحِدٌ
u'أَذِنَ وَارِثٌ':Subject, #8: 8	أَذَّنَ وَاحِدٌ
u'أَذِنَ وَالِدٌ':Subject, #4: 4	أَذِنَ الْوَارِثُ
u'أَذِنَ وَرَثَةٌ':Subject, #1: 1	أَذِنَ الْوَالِدُ
u'أَذِنَ وَصِيٌّ':Subject, #2: 2	أَذِنَ الْوَرَثَةُ
u'أَذِنَ وَكِيلٌ':Predicate, #3: 3	أَذِنَ الْوَصِيُّ
u'أَذِنَ ولد':Subject, #1: 1	أَذِنَ الْوَكِيلَ
u'أَذِنَ وَلَدٌ':Subject, #1: 1	أَذِنَ الْوَلَدُ
u'أَذِنَ وَلِيٌّ':Subject, #1: 1	أَذِنَ الْوَلَدُ
u'أَذِنَ وَلِيٌّ':Subject, #1: 1	أَذِنَ وَلِيُّ
u'أَذِنَ وَلِيٌّ':Subject, #1: 1	أَذِنَ وَلِيُّهُ
u'إِذْنٌ وَلِيٌّ':Added, #7: 7	أَذِنَ الْوَلِيُّ
u'أذهب إِحْسَاسٌ':Predicate, #5: 5	إِذْنِ وَلِيِّهِ
u'أَذْهَبَ إِحْسَاسٌ':Predicate, #1: 1	أَذْهَبَ الْإِحْسَاسَ
u'أذهب بَصَرٌ':Predicate, #1: 1	أَذْهَبَ الْإِحْسَاسَ
u'أَذْهَبَ بَصَرٌ':Predicate, #1: 1	أَذْهَبَ بَصَرَ
u'أذهب بَعْضٌ':Predicate, #1: 1	أَذْهَبَ بَصَرَ
u'أَذْهَبَ بَعْضٌ':Predicate, #1: 1	أَذْهَبَ بَعْضَ
u'أذهب تَعْيِيبٌ':Subject, #1: 1	أَذْهَبَ بَعْضَ
u'أَذْهَبَ تَعْيِيبٌ':Subject, #1: 1	أَذْهَبَ التَّعْيِيبُ
u'أذهب خُشُوعٌ':Predicate, #1: 1	أَذْهَبَ التَّعْيِيبُ
u'أَذْهَبَ خُشُوعٌ':Predicate, #2: 2	أَذْهَبَ الْخُشُوعَ
u'أذهب رَجُلٌ':Subject, #2: 2	أَذْهَبَ الْخُشُوعَ
u'أَذْهَبَ رَجُلٌ':Subject, #1: 1	أَذْهَبَ رَجُلٌ
u'أذهب رَوْنَقٌ':Predicate, #1: 1	أَذْهَبَ رَجُلٌ
u'أَذْهَبَ رَوْنَقٌ':Predicate, #1: 1	أَذْهَبَ رَوْنَقَ
u'أذهب سَمْعٌ':Predicate, #1: 1	أَذْهَبَ رَوْنَقَ
u'أَذْهَبَ سَمْعٌ':Predicate, #1: 1	أَذْهَبَ سَمْعَ
u'أذهب سَيْل':Subject, #1: 1	أَذْهَبَ سَمْعَ
u'أَذْهَبَ سَيْل':Subject, #1: 1	أَذْهَبَ السَّيْلُ
u'أذهب ضَوْءٌ':Predicate, #1: 1	أَذْهَبَ السَّيْلُ
u'أَذْهَبَ ضَوْءٌ':Predicate, #1: 1	أَذْهَبَ ضَوْءَ
u'أذهب ضَوْءٌ':Predicate, #1: 1	أَذْهَبَ ضَوْءَ
u'أَذْهَبَ ضَوْءٌ':Predicate, #2: 2	أَذْهَبَ الضَّوْءَ
u'أذهب عين':Predicate, #2: 2	أَذْهَبَ الضَّوْءَ
u'أذهب عَيْنٌ':Predicate, #1: 1	أَذْهَبَ الْعَيْنَ
u'أذهب عَيْن':Predicate, #1: 1	أَذْهَبَ الْعَيْنَ
u'أَذْهَبَ عين':Predicate, #1: 1	أَذْهَبَ الْعَيْنَ
u'أَذْهَبَ عَيْنٌ':Predicate, #1: 1	أَذْهَبَ الْعَيْنَ
u'أَذْهَبَ عَيْن':Predicate, #1: 1	أَذْهَبَ الْعَيْنَ
u'أذهب قَالٌ':Predicate, #1: 1	أَذْهَبَ الْعَيْنَ
u'أَذْهَبَ قَالٌ':Predicate, #1: 1	أَذْهَبَ قَالَ
u'أذهب مَعْرِفَةٌ':Predicate, #1: 1	أَذْهَبَ قَالَ
u'أذهب مَعْرِفَة':Predicate, #1: 1	أَذْهَبَ الْمَعْرِفَةَ
u'أَذْهَبَ مَعْرِفَةٌ':Predicate, #1: 1	أَذْهَبَ الْمَعْرِفَةَ
u'أَذْهَبَ مَعْرِفَة':Predicate, #1: 1	أَذْهَبَ الْمَعْرِفَةَ
u'أذهب نُطْقٌ':Predicate, #1: 1	أَذْهَبَ الْمَعْرِفَةَ
u'أَذْهَبَ نُطْقٌ':Predicate, #1: 1	أَذْهَبَ النُّطْقَ
u'آذَى جِدار':Predicate, #1: 1	أَذْهَبَ النُّطْقَ
u'آذَى رَسُولٌ':Predicate, #1: 1	آذَى الْجِدَارَ
u'آذَى صَالِحٌ':Predicate, #4: 4	آذَى رَسُولَ
u'آذَى صَالِح':Predicate, #1: 1	آذَى الصَّالِحِينَ
u'آذَى مُسْلِمٌ':Predicate, #1: 1	آذَى الصَّالِحِينَ
u'أَرَادَ أَبٌ':Subject, #1: 1	آذَى الْمُسْلِمِينَ
u'أَرَادَ إبَاحَةٌ':Predicate, #7: 7	أَرَادَ الْأَبُ
u'أَرَادَ إِبِلٌ':Predicate, #1: 1	أَرَادَ الْإِبَاحَةَ
u'أَرَادَ أَبْلَق':Predicate, #1: 1	أَرَادَ الْإِبِلَ
u'أَرَادَ اِبْنٌ':Predicate, #1: 1	أَرَادَ الْأَبْلَقَ
u'أَرَادَ اِبْنٌ':Subject, #1: 1	أَرَادَ ابْنَ
u'أَرَادَ أَبْوَالٌ':Predicate, #10: 10	أَرَادَ ابْنُ
u'أَرَادَ إتْمَامٌ':Predicate, #1: 1	أَرَادَ أَبْوَالَ
u'أَرَادَ إِتْيانٌ':Predicate, #1: 1	أَرَادَ إتْمَامَ
u'أَرَادَ إِتْيانٌ':Predicate, #1: 1	أَرَادَ إِتْيَانَ
u'أَرَادَ إِثْبَاتٌ':Predicate, #1: 1	أَرَادَ الْإِتْيَانَ
u'أَرَادَ إجَارَةٌ':Predicate, #7: 7	أَرَادَ إثْبَاتَ
u'أَرَادَ إجَازَةٌ':Predicate, #1: 1	أَرَادَ إجَارَةَ
u'أَرَادَ إجَازَةٌ':Predicate, #1: 1	أَرَادَ إجَازَةَ
u'أَرَادَ إِجْرَاءٌ':Predicate, #1: 1	أَرَادَ الْإِجَازَةَ
u'أَرَادَ إِجْلاَءٌ':Predicate, #1: 1	أَرَادَ إجْرَاءَ
u'أَرَادَ إِجْمَاعٌ':Predicate, #2: 2	أَرَادَ إجْلَاءَ
u'أَرَادَ أَجْنَبِيٌّ':Predicate, #1: 1	أَرَادَ إجْمَاعَ
u'أَرَادَ أَجْنَبِيٌّ':Subject, #2: 2	أَرَادَ الْأَجْنَبِيَّةَ
u'أَرَادَ أَجِيرٌ':Subject, #1: 1	أَرَادَ أَجْنَبِيٌّ
u'أَرَادَ إحَاطَةٌ':Predicate, #1: 1	أَرَادَ الْأَجِيرُ
u'أَرَادَ أحَدٌ':Predicate, #2: 2	أَرَادَ الْإِحَاطَةَ
u'أَرَادَ أحَدٌ':Subject, #3: 3	أَرَادَ أَحَدَ
u'أَرَادَ أحَدٌ':Subject, #3: 3	أَرَادَ أَحَدٌ
u'أَرَادَ إِحْدَاثٌ':Predicate, #8: 8	أَرَادَ أَحَدُ
u'أَرَادَ إِحْرَامٌ':Predicate, #4: 4	أَرَادَ إحْدَاثَ
u'أَرَادَ إحْضَارٌ':Predicate, #17: 17	أَرَادَ الْإِحْرَامَ
u'أَرَادَ أَحَقُّ':Subject, #1: 1	أَرَادَ إحْضَارَ
u'أَرَادَ إِحْيَاءٌ':Predicate, #1: 1	أَرَادَ الْأَحَقُّ
u'أَرَادَ أَخٌ':Subject, #4: 4	أَرَادَ إحْيَاءَ
u'أَرَادَ إِخْبَارٌ':Predicate, #1: 1	أَرَادَ الْأَخُ
u'أَرَادَ اِخْتِصَارٌ':Predicate, #5: 5	أَرَادَ الْإِخْبَارَ
u'أَرَادَ أخْذٌ':Predicate, #1: 1	أَرَادَ الاخْتِصَارَ
u'أَرَادَ أخْذٌ':Predicate, #12: 12	أَرَادَ أَخْذَ
u'أَرَادَ آخِرُ':Predicate, #4: 4	أَرَادَ الْأَخْذَ
u'أَرَادَ إِخْرَاجٌ':Predicate, #2: 2	أَرَادَ آخِرَ
u'أَرَادَ إِخْرَاجٌ':Predicate, #1: 1	أَرَادَ إخْرَاجَ
u'أَرَادَ آخِرَةٌ':Predicate, #4: 4	أَرَادَ إِخْرَاجَ
u'أَرَادَ آخِرَةٌ':Predicate, #1: 1	أَرَادَ الآخِرَةَ
u'أَرَادَ أَخَصُّ':Predicate, #3: 3	أَرَادَ الْآخِرَةَ
u'أَرَادَ أَخِيرٌ':Predicate, #1: 1	أَرَادَ الْأَخَصَّ
u'أَرَادَ أَدَاءٌ':Predicate, #1: 1	أَرَادَ الْأَخِيرَ
u'أَرَادَ أَدَاءٌ':Predicate, #1: 1	أَرَادَ الْأَدَاءَ
u'أَرَادَ أدَب':Predicate, #3: 3	أَرَادَ أَدَاءَ
u'أَرَادَ إدْخَالٌ':Predicate, #1: 1	أَرَادَ الأَدَبَ
u'أَرَادَ إِذْلاَلٌ':Predicate, #2: 2	أَرَادَ إدْخَالَ
u'أَرَادَ أرْبَابٌ':Subject, #1: 1	أَرَادَ إذْلَالَ
u'أَرَادَ إِرْثٌ':Predicate, #1: 1	أَرَادَ أَرْبَابُ
u'أَرَادَ إِرْسَالٌ':Predicate, #1: 1	أَرَادَ إرْثَ
u'أَرَادَ إِزَالَةٌ':Predicate, #1: 1	أَرَادَ إرْسَالَ
u'أَرَادَ أَزْواجٌ':Predicate, #1: 1	أَرَادَ إزَالَةَ
u'أَرَادَ اِسْتِبْدَالٌ':Predicate, #2: 2	أَرَادَ الْأَزْوَاجَ
u'أَرَادَ اِسْتِجْلاَبٌ':Predicate, #1: 1	أَرَادَ اسْتِبْدَالَ
u'أَرَادَ اِسْتِدَامَةٌ':Predicate, #1: 1	أَرَادَ اسْتِجْلَابَ
u'أَرَادَ اِسْتِرْدَادٌ':Predicate, #2: 2	أَرَادَ اسْتِدَامَةَ
u'أَرَادَ اِسْتِصْحابٌ':Predicate, #1: 1	أَرَادَ اسْتِرْدَادَ
u'أَرَادَ اِسْتِطابَةٌ':Subject, #1: 1	أَرَادَ اسْتِصْحَابَ
u'أَرَادَ اِسْتِمْتاعٌ':Predicate, #1: 1	أَرَادَ اسْتِطَابَةُ
u'أَرَادَ اِسْتِئْنَافٌ':Predicate, #1: 1	أَرَادَ اسْتِمْتَاعَ
u'أَرَادَ اِسْتِيطانٌ':Predicate, #4: 4	أَرَادَ اسْتِئْنَافَ
u'أَرَادَ اِسْتيعابٌ':Predicate, #1: 1	أَرَادَ اسْتِيطَانَ
u'أَرَادَ إِسْقاطٌ':Predicate, #1: 1	أَرَادَ اسْتِيعَابَ
u'أَرَادَ إِسْلامٌ':Predicate, #3: 3	أَرَادَ إسْقَاطَ
u'أَرَادَ اِسْمٌ':Predicate, #1: 1	أَرَادَ الْإِسْلَامَ
u'أَرَادَ إشارَة':Predicate, #1: 1	أَرَادَ اسْمَ
u'أَرَادَ أَشْخَاصٌ':Predicate, #1: 1	أَرَادَ الْإِشَارَةَ
u'أَرَادَ أَشْهَب':Subject, #1: 1	أَرَادَ الْأَشْخَاصَ
u'أَرَادَ أَصْحَابٌ':Predicate, #1: 1	أَرَادَ أَشْهَبُ
u'أَرَادَ أصْغَرٌ':Predicate, #1: 1	أَرَادَ أَصْحَابَ
u'أَرَادَ أَصْغَرُ':Predicate, #1: 1	أَرَادَ الْأَصْغَرَ
u'أَرَادَ أصل':Predicate, #1: 1	أَرَادَ الْأَصْغَرَ
u'أَرَادَ أًصْلٌ':Predicate, #1: 1	أَرَادَ أَصْلَ
u'أَرَادَ إِصْلاحٌ':Predicate, #1: 1	أَرَادَ أَصْلَ
u'أَرَادَ إِصْلاحٌ':Predicate, #1: 1	أَرَادَ إصْلَاحَ
u'أَرَادَ أُصولٌ':Predicate, #1: 1	أَرَادَ الْإِصْلَاحَ
u'أَرَادَ إضافَةٌ':Predicate, #2: 2	أَرَادَ أُصُولَ
u'أَرَادَ إِضْرابٌ':Predicate, #1: 1	أَرَادَ إضَافَةَ
u'أَرَادَ إِطْعامٌ':Predicate, #1: 1	أَرَادَ الْإِضْرَابَ
u'أَرَادَ إِطْلاعٌ':Predicate, #1: 1	أَرَادَ الْإِطْعَامَ
u'أَرَادَ إِطْلاقٌ':Predicate, #1: 1	أَرَادَ الْإِطْلَاعَ
u'أَرَادَ إِظْهارٌ':Predicate, #1: 1	أَرَادَ الْإِطْلَاقَ
u'أَرَادَ إِعادَةٌ':Predicate, #3: 3	أَرَادَ إظْهَارَ
u'أَرَادَ اِعْتِقادٌ':Predicate, #1: 1	أَرَادَ الْإِعَادَةَ
u'أَرَادَ اِعْتِكافٌ':Predicate, #1: 1	أَرَادَ اعْتِقَادَ
u'أَرَادَ اِعْتِكافٌ':Predicate, #1: 1	أَرَادَ الاِعْتِكَافَ
u'أَرَادَ إِعْدامٌ':Predicate, #2: 2	أَرَادَ اعْتِكَافَ
u'أَرَادَ أَعْذَارٌ':Predicate, #1: 1	أَرَادَ إعْدَامَ
u'أَرَادَ إعْطَاءٌ':Predicate, #1: 1	أَرَادَ الْأَعْذَارَ
u'أَرَادَ أَعْلاَمٌ':Predicate, #2: 2	أَرَادَ إعْطَاءَ
u'أَرَادَ إعْلاَمٌ':Predicate, #1: 1	أَرَادَ الْأَعْلَامَ
u'أَرَادَ أَعَمُّ':Predicate, #1: 1	أَرَادَ الْإِعْلَامَ
u'أَرَادَ أَعَمُّ':Predicate, #1: 1	أَرَادَ أَعَمَّ
u'أَرَادَ أعْمَش':Predicate, #1: 1	أَرَادَ الْأَعَمَّ
u'أَرَادَ اِفْتِتَاحٌ':Predicate, #1: 1	أَرَادَ الْأَعْمَشَ
u'أَرَادَ إِفْطارٌ':Predicate, #3: 3	أَرَادَ افْتِتَاحَ
u'أَرَادَ إقالَةٌ':Predicate, #1: 1	أَرَادَ الْإِفْطَارَ
u'أَرَادَ إقامَةٌ':Predicate, #1: 1	أَرَادَ الْإِقَالَةَ
u'أَرَادَ إقامَةٌ':Predicate, #2: 2	أَرَادَ الْإِقَامَةَ
u'أَرَادَ إقْدَامٌ':Predicate, #4: 4	أَرَادَ إقَامَةَ
u'أَرَادَ أقْرأُ':Predicate, #1: 1	أَرَادَ الْإِقْدَامَ
u'أَرَادَ إقْرَارٌ':Predicate, #1: 1	أَرَادَ الْأَقْرَأَ
u'أَرَادَ إقْطَاعٌ':Predicate, #1: 1	أَرَادَ الْإِقْرَارَ
u'أَرَادَ أكابر':Subject, #1: 1	أَرَادَ إقْطَاعَ
u'أَرَادَ أكْبَرُ':Predicate, #1: 1	أَرَادَ الْأَكَابِرُ
u'أَرَادَ أكْبَرُ':Subject, #1: 1	أَرَادَ الْأَكْبَرَ
u'أَرَادَ أَكْثَرُ':Predicate, #1: 1	أَرَادَ الْأَكْبَرُ
u'أَرَادَ أَكْثَرُ':Subject, #2: 2	أَرَادَ أَكْثَرَ
u'أَرَادَ إكْرَامٌ':Predicate, #3: 3	أَرَادَ أَكْثَرُ
u'أَرَادَ أكل':Predicate, #1: 1	أَرَادَ الْإِكْرَامَ
u'أَرَادَ أَكْلٌ':Predicate, #1: 1	أَرَادَ أَكْلَ
u'أَرَادَ أكل':Predicate, #1: 1	أَرَادَ أَكْلَ
u'أَرَادَ أَكْلٌ':Predicate, #4: 4	أَرَادَ الْأَكْلَ
u'أَرَادَ إِلْزَامٌ':Predicate, #4: 4	أَرَادَ الْأَكْلَ
u'أَرَادَ ألف':Predicate, #1: 1	أَرَادَ إلْزَامَ
u'أَرَادَ ألْفٌ':Predicate, #1: 1	أَرَادَ الْأَلْفَ
u'أَرَادَ أَلْفٌ':Predicate, #1: 1	أَرَادَ الْأَلْفَ
u'أَرَادَ إمَامٌ':Subject, #1: 1	أَرَادَ الْأَلْفَ
u'أَرَادَ أَمْرٌ':Predicate, #20: 20	أَرَادَ الْإِمَامُ
u'أَرَادَ إِمْضاءٌ':Predicate, #1: 1	أَرَادَ الْأَمْرَ
u'أَرَادَ إِمْضاءٌ':Predicate, #1: 1	أَرَادَ الْإِمْضَاءَ
u'أَرَادَ أُمَّهَاتٌ':Predicate, #1: 1	أَرَادَ إمْضَاءَ
u'أَرَادَ أَمْوَالٌ':Predicate, #1: 1	أَرَادَ الْأُمّهَاتَ
u'أَرَادَ أَميرٌ':Subject, #1: 1	أَرَادَ الْأَمْوَالَ
u'أَرَادَ أَميرٌ':Subject, #1: 1	أَرَادَ أَمِيرُ
u'أَرَادَ اِنْتِقاضٌ':Predicate, #2: 2	أَرَادَ الْأَمِيرُ
u'أَرَادَ اِنْحِطاطٌ':Predicate, #1: 1	أَرَادَ انْتِقَاضَ
u'أَرَادَ إِنْزالٌ':Predicate, #1: 1	أَرَادَ انْحِطَاطَ
u'أَرَادَ إِنْسانٌ':Subject, #1: 1	أَرَادَ الْإِنْزَالَ
u'أَرَادَ إِنْسانٌ':Subject, #2: 2	أَرَادَ الْإِنْسَانُ
u'أَرَادَ إِنْشاءٌ':Predicate, #4: 4	أَرَادَ إنْسَانٌ
u'أَرَادَ إِنْصافٌ':Predicate, #1: 1	أَرَادَ إنْشَاءَ
u'أَرَادَ إهَانَةٌ':Predicate, #1: 1	أَرَادَ الإِنْصَافَ
u'أَرَادَ أهْلٌ':Predicate, #1: 1	أَرَادَ الْإِهَانَةَ
u'أَرَادَ أهْلٌ':Subject, #2: 2	أَرَادَ أَهْلَ
u'أَرَادَ أهْلٌ':Subject, #10: 10	أَرَادَ أَهْلُ
u'أَرَادَ إِهْلاَكٌ':Predicate, #3: 3	أَرَادَ أَهْلُهُ
u'أَرَادَ أوْسَطُ':Predicate, #1: 1	أَرَادَ إهْلَاكَ
u'أَرَادَ أوْسَطُ':Subject, #1: 1	أَرَادَ الْأَوْسَطَ
u'أَرَادَ أَوْقَاتٌ':Predicate, #1: 1	أَرَادَ الْأَوْسَطُ
u'أَرَادَ أَوَّلُ':Predicate, #1: 1	أَرَادَ أَوْقَاتَ
u'أَرَادَ أَوَّلُ':Subject, #4: 4	أَرَادَ الْأَوَّلَ
u'أَرَادَ أيَّامٌ':Predicate, #3: 3	أَرَادَ الْأَوَّلُ
u'أَرَادَ أَيَّامٌ':Predicate, #1: 1	أَرَادَ الْأَيَّامَ
u'أَرَادَ أيَّامٌ':Predicate, #1: 1	أَرَادَ الْأَيَّامَ
u'أَرَادَ أَيَّامٌ':Predicate, #1: 1	أَرَادَ أَيَّامَ
u'أَرَادَ آيَةٌ':Predicate, #1: 1	أَرَادَ أَيَّامَ
u'أَرَادَ إِيجَابٌ':Predicate, #1: 1	أَرَادَ الْآيَةَ
u'أَرَادَ إِيجَابٌ':Predicate, #1: 1	أَرَادَ الْإِيجَابَ
u'أَرَادَ إِيجَابٌ':Subject, #2: 2	أَرَادَ إيجَابَ
u'أَرَادَ إيقَاعٌ':Predicate, #1: 1	أَرَادَ الْإِيجَابُ
u'أَرَادَ إيقَاعٌ':Predicate, #1: 1	أَرَادَ الْإِيقَاعَ
u'أَرَادَ بالِغٌ':Predicate, #2: 2	أَرَادَ إيقَاعَ
u'أَرَادَ بَائِعٌ':Subject, #1: 1	أَرَادَ الْبَالِغَةَ
u'أَرَادَ بَائِعٌ':Subject, #1: 1	أَرَادَ بَائِعُ
u'أَرَادَ بُحْبُوحَةٌ':Predicate, #21: 21	أَرَادَ الْبَائِعُ
u'أَرَادَ بَحْثٌ':Predicate, #1: 1	أَرَادَ بُحْبُوحَةَ
u'أَرَادَ بَحْرٌ':Predicate, #1: 1	أَرَادَ الْبَحْثَ
u'أَرَادَ بُخَارِيٌّ':Subject, #1: 1	أَرَادَ الْبَحْرَ
u'أَرَادَ بَخِيلٌ':Subject, #2: 2	أَرَادَ الْبُخَارِيُّ
u'أَرَادَ بَدْءٌ':Predicate, #3: 3	أَرَادَ الْبَخِيلُ
u'أَرَادَ بَذْلٌ':Predicate, #1: 1	أَرَادَ بَدْءَ
u'أَرَادَ بِرٌّ':Predicate, #1: 1	أَرَادَ بَذْلَ
u'أَرَادَ بِرٌّ':Predicate, #1: 1	أَرَادَ الْبِرَّ
u'أَرَادَ بَراءةٌ':Predicate, #1: 1	أَرَادَ بِرَّ
u'أَرَادَ براز':Predicate, #6: 6	أَرَادَ الْبَرَاءَةَ
u'أَرَادَ بِرازٌ':Predicate, #1: 1	أَرَادَ الْبِرَازَ
u'أَرَادَ براز':Predicate, #1: 1	أَرَادَ الْبِرَازَ
u'أَرَادَ بَرَازٌ':Predicate, #2: 2	أَرَادَ الْبَرَازَ
u'أَرَادَ بَعْضٌ':Predicate, #2: 2	أَرَادَ الْبَرَازَ
u'أَرَادَ بَعْضٌ':Predicate, #1: 1	أَرَادَ الْبَعْضَ
u'أَرَادَ بَعْضٌ':Subject, #6: 6	أَرَادَ بَعْضَ
u'أَرَادَ بَعْضٌ':Subject, #3: 3	أَرَادَ الْبَعْضُ
u'أَرَادَ بُغْضٌ':Predicate, #5: 5	أَرَادَ بَعْضُ
u'أَرَادَ بَقاءٌ':Predicate, #1: 1	أَرَادَ بُغْضَ
u'أَرَادَ بَقاءٌ':Predicate, #2: 2	أَرَادَ بَقَاءَ
u'أَرَادَ بِلادٌ':Predicate, #5: 5	أَرَادَ الْبَقَاءَ
u'أَرَادَ بِنَاءٌ':Predicate, #1: 1	أَرَادَ الْبِلَادَ
u'أَرَادَ بِنَاءٌ':Predicate, #2: 2	أَرَادَ بِنَاءَ
u'أَرَادَ بَوْلٌ':Predicate, #3: 3	أَرَادَ الْبِنَاءَ
u'أَرَادَ بَيَانٌ':Predicate, #1: 1	أَرَادَ بَوْلَ
u'أَرَادَ بَيْتٌ':Predicate, #7: 7	أَرَادَ بَيَانَ
u'أَرَادَ بيض':Predicate, #2: 2	أَرَادَ بَيْتَ
u'أَرَادَ بَيْعٌ':Predicate, #1: 1	أَرَادَ بَيْضَ
u'أَرَادَ بَيْعٌ':Predicate, #11: 11	أَرَادَ بَيْعَ
u'إِرَادَةٌ إِصْلاحٌ':Added, #2: 2	أَرَادَ الْبَيْعَ
u'إِرَادَةٌ تَأْكِيدٌ':Added, #1: 1	إِرَادَةَ إِصْلاَحِ
u'إِرَادَةٌ حَجٌّ':Added, #1: 1	إِرَادَةِ التَّأْكِيدِ
u'إِرَادَةٌ ضَحِيَّةٌ':Added, #1: 1	إِرَادَةِ حَجٍّ
u'أَرَادَ تَأْخِيرٌ':Predicate, #1: 1	إِرَادَةِ الضَّحِيَّةِ
u'أَرَادَ تَأْخِيرٌ':Predicate, #1: 1	أَرَادَ تَأْخِيرَ
u'أَرَادَ تَارِيخٌ':Predicate, #2: 2	أَرَادَ التَّأْخِيرَ
u'أَرَادَ تَأْسِيسٌ':Predicate, #1: 1	أَرَادَ التَّارِيخَ
u'أَرَادَ تَأْكِيدٌ':Predicate, #1: 1	أَرَادَ تَأْسِيسَ
u'أَرَادَ تَأْكِيدٌ':Predicate, #3: 3	أَرَادَ التَّأْكِيدَ
u'أَرَادَ تَتَابُعٌ':Predicate, #3: 3	أَرَادَ تَأْكِيدَ
u'أَرَادَ تَثْبِيط':Predicate, #1: 1	أَرَادَ التَّتَابُعَ
u'أَرَادَ تَجْدِيدٌ':Predicate, #1: 1	أَرَادَ التَّثْبِيطَ
u'أَرَادَ تَحْرِيم':Predicate, #1: 1	أَرَادَ التَّجْدِيدَ
u'أَرَادَ تَحْرِيمٌ':Predicate, #1: 1	أَرَادَ التَّحْرِيمِيَّةَ
u'أَرَادَ تَحْرِيمٌ':Predicate, #1: 1	أَرَادَ تَحْرِيمَ
u'أَرَادَ تَحْصِيلٌ':Predicate, #4: 4	أَرَادَ التَّحْرِيمَ
u'أَرَادَ تَحْقِيقٌ':Predicate, #2: 2	أَرَادَ تَحْصِيلَ
u'أَرَادَ تَحْقِيقٌ':Predicate, #1: 1	أَرَادَ تَحْقِيقَ
u'أَرَادَ تَحَلُّلٌ':Predicate, #2: 2	أَرَادَ التَّحْقِيقَ
u'أَرَادَ تَحْلِيف':Predicate, #1: 1	أَرَادَ التَّحَلُّلَ
u'أَرَادَ تَحَمُّلٌ':Predicate, #3: 3	أَرَادَ تَحْلِيفَ
u'أَرَادَ تَحَوُّلٌ':Predicate, #2: 2	أَرَادَ تَحَمُّلَ
u'أَرَادَ تَحْوِيلٌ':Predicate, #4: 4	أَرَادَ التَّحَوُّلَ
u'أَرَادَ تَخْرِيبٌ':Predicate, #1: 1	أَرَادَ تَحْوِيلَ
u'أَرَادَ تَخْصِيصٌ':Predicate, #1: 1	أَرَادَ تَخْرِيبَ
u'أَرَادَ تَخْصِيصٌ':Predicate, #1: 1	أَرَادَ التَّخْصِيصَ
u'أَرَادَ تَخَلُّصٌ':Predicate, #1: 1	أَرَادَ تَخْصِيصَ
u'أَرَادَ تَخْوِيفٌ':Predicate, #2: 2	أَرَادَ التَّخَلُّصَ
u'أَرَادَ تَخْيِيرٌ':Predicate, #1: 1	أَرَادَ تَخْوِيفَ
u'أَرَادَ تَخْيِيرٌ':Predicate, #1: 1	أَرَادَ تَخْيِيرَ
u'أَرَادَ تَدْبِيرٌ':Predicate, #2: 2	أَرَادَ التَّخْيِيرَ
u'أَرَادَ تَرَاوِيحُ':Predicate, #1: 1	أَرَادَ التَّدْبِيرَ
u'أَرَادَ تَرْكٌ':Predicate, #1: 1	أَرَادَ التَّرَاوِيحَ
u'أَرَادَ تَزْوِيجٌ':Predicate, #2: 2	أَرَادَ تَرْكَ
u'أَرَادَ تَسَاوِي':Predicate, #3: 3	أَرَادَ تَزْوِيجَ
u'أَرَادَ تَسَرِّي':Predicate, #1: 1	أَرَادَ تَسَاوِيَ
u'أَرَادَ تَسْكِينٌ':Predicate, #1: 1	أَرَادَ التَّسَرِّيَ
u'أَرَادَ تَسْمِيَة':Predicate, #3: 3	أَرَادَ تَسْكِينَ
u'أَرَادَ تَسْهِيلٌ':Predicate, #1: 1	أَرَادَ التَّسْمِيَةَ
u'أَرَادَ تَسْهِيلٌ':Predicate, #1: 1	أَرَادَ التَّسْهِيلَ
u'أَرَادَ تَسَوُّرٌ':Predicate, #2: 2	أَرَادَ تَسْهِيلَ
u'أَرَادَ تَشْبِيه':Predicate, #1: 1	أَرَادَ التَّسَوُّرَ
u'أَرَادَ تَشْبِيه':Predicate, #2: 2	أَرَادَ التّشْبِيهَ
u'أَرَادَ تَشْدِيدٌ':Predicate, #3: 3	أَرَادَ التَّشْبِيهَ
u'أَرَادَ تَصَدُّقٌ':Predicate, #1: 1	أَرَادَ التَّشْدِيدَ
u'أَرَادَ تَصَرُّفٌ':Predicate, #1: 1	أَرَادَ التَّصَدُّقَ
u'أَرَادَ تَصْرِيحٌ':Predicate, #4: 4	أَرَادَ التَّصَرُّفَ
u'أَرَادَ تَضْحِيَةٌ':Predicate, #1: 1	أَرَادَ التَّصْرِيحَ
u'أَرَادَ تَضْمِين':Predicate, #2: 2	أَرَادَ التَّضْحِيَةَ
u'أَرَادَ تَطَرُّبٌ':Predicate, #1: 1	أَرَادَ التَّضْمِينَ
u'أَرَادَ تَطْيِيرٌ':Predicate, #1: 1	أَرَادَ التَّطَرُّبَ
u'أَرَادَ تَعْجِيل':Predicate, #1: 1	أَرَادَ تَطْيِيرَ
u'أَرَادَ تَعْجِيل':Predicate, #3: 3	أَرَادَ التَّعْجِيلَ
u'أَرَادَ تَعَرُّضٌ':Predicate, #3: 3	أَرَادَ تَعْجِيلَ
u'أَرَادَ تَعْرِيفٌ':Predicate, #1: 1	أَرَادَ التَّعَرُّضَ
u'أَرَادَ تَعْرِيفٌ':Predicate, #2: 2	أَرَادَ التَّعْرِيفَ
u'أَرَادَ تَعْظِيمٌ':Predicate, #5: 5	أَرَادَ تَعْرِيفَ
u'أَرَادَ تَعْلِيقٌ':Predicate, #1: 1	أَرَادَ التَّعْظِيمَ
u'أَرَادَ تَعْلِيقٌ':Predicate, #14: 14	أَرَادَ التَّعْلِيقَ
u'أَرَادَ تَعْلِيلٌ':Predicate, #2: 2	أَرَادَ تَعْلِيقَ
u'أَرَادَ تَعْلِيمٌ':Predicate, #1: 1	أَرَادَ التَّعْلِيلَ
u'أَرَادَ تَعْلِيمٌ':Predicate, #2: 2	أَرَادَ التَّعْلِيمَ
u'أَرَادَ تَعَمُّدٌ':Predicate, #4: 4	أَرَادَ تَعْلِيمَ
u'أَرَادَ تَعْمِيمٌ':Predicate, #1: 1	أَرَادَ تَعَمُّدَ
u'أَرَادَ تَعْيِينٌ':Predicate, #1: 1	أَرَادَ التَّعْمِيمَ
u'أَرَادَ تَغْلِيظٌ':Predicate, #3: 3	أَرَادَ التَّعْيِينَ
u'أَرَادَ تَغْيِيبٌ':Predicate, #5: 5	أَرَادَ التَّغْلِيظَ
u'أَرَادَ تَغْيِيرٌ':Predicate, #1: 1	أَرَادَ تَغْيِيبَ
u'أَرَادَ تَفْرِيغٌ':Predicate, #1: 1	أَرَادَ تَغْيِيرَ
u'أَرَادَ تَفْصِيلٌ':Predicate, #1: 1	أَرَادَ تَفْرِيغَ
u'أَرَادَ تَفْضِيلٌ':Predicate, #2: 2	أَرَادَ التَّفْصِيلَ
u'أَرَادَ تَفْهِيمٌ':Predicate, #1: 1	أَرَادَ تَفْضِيلَ
u'أَرَادَ تَقَابُلٌ':Predicate, #1: 1	أَرَادَ تَفْهِيمَ
u'أَرَادَ تَقْبيحٌ':Predicate, #1: 1	أَرَادَ التَّقَابُلَ
u'أَرَادَ تَقَدُّمٌ':Predicate, #1: 1	أَرَادَ تَقْبِيحَ
u'أَرَادَ تَقَدُّمٌ':Predicate, #1: 1	أَرَادَ تَقَدُّمَ
u'أَرَادَ تَقْديرٌ':Predicate, #2: 2	أَرَادَ التَّقَدُّمَ
u'أَرَادَ تَقْديرٌ':Predicate, #1: 1	أَرَادَ تَقْدِيرَ
u'أَرَادَ تَقْديمٌ':Predicate, #3: 3	أَرَادَ التَّقْدِيرَ
u'أَرَادَ تَقْريرٌ':Predicate, #2: 2	أَرَادَ تَقْدِيمَ
u'أَرَادَ تَقْليدٌ':Predicate, #1: 1	أَرَادَ التَّقْرِيرَ
u'أَرَادَ تَقْليد':Predicate, #1: 1	أَرَادَ تَقْلِيدَ
u'أَرَادَ تَكْبيرٌ':Predicate, #1: 1	أَرَادَ تَقْلِيدَ
u'أَرَادَ تَكْثيرٌ':Predicate, #3: 3	أَرَادَ التَّكْبِيرَ
u'أَرَادَ تَكْرارٌ':Predicate, #1: 1	أَرَادَ تَكْثِيرَ
u'أَرَادَ تَكْرارٌ':Predicate, #1: 1	أَرَادَ تَكْرَارَ
u'أَرَادَ تَكَشُّفٌ':Predicate, #5: 5	أَرَادَ التَّكْرَارَ
u'أَرَادَ تَكْليفٌ':Predicate, #1: 1	أَرَادَ التَّكَشُّفَ
u'أَرَادَ تَلْبيَةٌ':Predicate, #1: 1	أَرَادَ التَّكْلِيفَ
u'أَرَادَ تَلْخيصٌ':Predicate, #1: 1	أَرَادَ التَّلْبِيَةَ
u'أَرَادَ تَلَذُّذٌ':Predicate, #1: 1	أَرَادَ التَّلْخِيصَ
u'أَرَادَ تمام':Predicate, #2: 2	أَرَادَ التَّلَذُّذَ
u'أَرَادَ تَمامٌ':Predicate, #1: 1	أَرَادَ تَمَامَ
u'أَرَادَ تَمَتُّعٌ':Predicate, #1: 1	أَرَادَ تَمَامَ
u'أَرَادَ تَمَلُّك':Predicate, #6: 6	أَرَادَ التَّمَتُّعَ
u'أَرَادَ تَمْلِيك':Predicate, #1: 1	أَرَادَ التَّمَلُّكَ
u'أَرَادَ تَمْلِيكٌ':Predicate, #1: 1	أَرَادَ التَّمْلِيكَ
u'أَرَادَ تَمْييزٌ':Predicate, #1: 1	أَرَادَ تَمْلِيكَ
u'أَرَادَ تَنْبِيه':Predicate, #1: 1	أَرَادَ تَمْيِيزَهُنَّ
u'أَرَادَ تَنْبِيهٌ':Predicate, #1: 1	أَرَادَ التَّنْبِيهَ
u'أَرَادَ تَنْجِيزٌ':Predicate, #1: 1	أَرَادَ تَنْبِيهَ
u'أَرَادَ تَنَحِّي':Predicate, #1: 1	أَرَادَ التَّنْجِيزَ
u'أَرَادَ تَنْزِيه':Predicate, #1: 1	أَرَادَ التَّنَحِّيَ
u'أَرَادَ تَنْظِيفٌ':Predicate, #1: 1	أَرَادَ التَّنْزِيهِيَّةَ
u'أَرَادَ تَنَفُّلٌ':Predicate, #1: 1	أَرَادَ التَّنْظِيفَ
u'أَرَادَ تَنْفِيذٌ':Predicate, #1: 1	أَرَادَ التَّنَفُّلَ
u'أَرَادَ تَنْفِيرٌ':Predicate, #1: 1	أَرَادَ تَنْفِيذَ
u'أَرَادَ تَنْقِيصٌ':Predicate, #1: 1	أَرَادَ التَّنْفِيرَ
u'أَرَادَ تَهَجُّدٌ':Predicate, #2: 2	أَرَادَ تَنْقِيصَ
u'أَرَادَ تَهَوُّدٌ':Predicate, #1: 1	أَرَادَ التَّهَجُّدَ
u'أَرَادَ تَوْبَةٌ':Predicate, #1: 1	أَرَادَ التّهَوّدَ
u'أَرَادَ تَوْزِيعٌ':Predicate, #1: 1	أَرَادَ تَوْبَةَ
u'أَرَادَ تَوَسُّعٌ':Predicate, #1: 1	أَرَادَ التَّوْزِيعَ
u'أَرَادَ تَوَقُّفٌ':Predicate, #2: 2	أَرَادَ التَّوَسُّعَ
u'أَرَادَ تَوْكِيدٌ':Predicate, #1: 1	أَرَادَ التَّوَقُّفَ
u'أَرَادَ تَوْكِيلٌ':Predicate, #1: 1	أَرَادَ تَوْكِيدَ
u'أَرَادَ تَيَمُّمٌ':Predicate, #2: 2	أَرَادَ التَّوْكِيلَ
u'أَرَادَ ثَانِي':Predicate, #3: 3	أَرَادَ التَّيَمُّمَ
u'أَرَادَ ثُبُوتٌ':Predicate, #4: 4	أَرَادَ الثَّانِيَ
u'أَرَادَ ثَعَالِبُ':Predicate, #1: 1	أَرَادَ الثُّبُوتَ
u'أَرَادَ ثَغْرٌ':Predicate, #1: 1	أَرَادَ الثّعَالِبَ
u'أَرَادَ ثَلاثُ':Predicate, #2: 2	أَرَادَ الثَّغْرَ
u'أَرَادَ ثَلاثُ':Predicate, #1: 1	أَرَادَ ثَلَاثَ
u'أَرَادَ ثَمَرٌ':Predicate, #5: 5	أَرَادَ الثَّلَاثَ
u'أَرَادَ ثَوابٌ':Predicate, #1: 1	أَرَادَ الثَّمَرَ
u'أَرَادَ جَارٌ':Subject, #3: 3	أَرَادَ الثَّوَابَ
u'أَرَادَ جَارِحٌ':Predicate, #1: 1	أَرَادَ الْجَارُ
u'أَرَادَ جَارِحَةٌ':Predicate, #1: 1	أَرَادَ الْجَارِحَةَ
u'أَرَادَ جَازٌ':Predicate, #1: 1	أَرَادَ الْجَارِحَةَ
u'أَرَادَ جِدار':Predicate, #1: 1	أَرَادَ جَازَ
u'أَرَادَ جُذام':Predicate, #1: 1	أَرَادَ الْجِدَارَ
u'أَرَادَ جُذامَة':Predicate, #1: 1	أَرَادَ جُذَامَةَ
u'أَرَادَ جَزَاءٌ':Predicate, #1: 1	أَرَادَ جُذَامَةَ
u'أَرَادَ جُلُوسٌ':Predicate, #1: 1	أَرَادَ الْجَزَاءَ
u'أَرَادَ جماع':Predicate, #4: 4	أَرَادَ الْجُلُوسَ
u'أَرَادَ جِمَاعٌ':Predicate, #1: 1	أَرَادَ الْجِمَاعَ
u'أَرَادَ جَمَاعَةٌ':Predicate, #1: 1	أَرَادَ الْجِمَاعَ
u'أَرَادَ جَمَاعَةٌ':Subject, #1: 1	أَرَادَ الْجَمَاعَةَ
u'أَرَادَ جمع':Predicate, #1: 1	أَرَادَ جَمَاعَةٌ
u'أَرَادَ جَمْعٌ':Predicate, #2: 2	أَرَادَ الْجَمْعَ
u'أَرَادَ جمع':Predicate, #2: 2	أَرَادَ الْجَمْعَ
u'أَرَادَ جَمْعٌ':Predicate, #5: 5	أَرَادَ جَمْعَ
u'أَرَادَ جمعة':Predicate, #5: 5	أَرَادَ جَمْعَ
u'أَرَادَ جُمُعَةٌ':Predicate, #2: 2	أَرَادَ الْجُمُعَةَ
u'أَرَادَ جَمِيع':Predicate, #2: 2	أَرَادَ الْجُمُعَةَ
u'أَرَادَ جِنَايَةٌ':Predicate, #1: 1	أَرَادَ الْجَمِيعَ
u'أَرَادَ جِنْسٌ':Predicate, #1: 1	أَرَادَ جِنَايَةَ
u'أَرَادَ جِهَةٌ':Predicate, #2: 2	أَرَادَ الْجِنْسَ
u'أَرَادَ جَوَابٌ':Predicate, #1: 1	أَرَادَ الْجِهَةَ
u'أَرَادَ جَوَازٌ':Predicate, #4: 4	أَرَادَ الْجَوَابَ
u'أَرَادَ جَوَازٌ':Predicate, #2: 2	أَرَادَ جَوَازَ
u'أَرَادَ حاجٌّ':Subject, #4: 4	أَرَادَ الْجَوَازَ
u'أَرَادَ حاجَةٌ':Predicate, #1: 1	أَرَادَ الْحَاجُّ
u'أَرَادَ حاجَةٌ':Predicate, #1: 1	أَرَادَ الْحَاجَةَ
u'أَرَادَ حاكِمٌ':Subject, #1: 1	أَرَادَ حَاجَةَ
u'أَرَادَ حالٌ':Predicate, #2: 2	أَرَادَ الْحَاكِمُ
u'أَرَادَ حَبْسٌ':Predicate, #3: 3	أَرَادَ الْحَالَ
u'أَرَادَ حَجٌّ':Predicate, #1: 1	أَرَادَ حَبْسَ
u'أَرَادَ حَجٌّ':Predicate, #19: 19	أَرَادَ الْحَجَّ
u'أَرَادَ حِجَامَةٌ':Predicate, #2: 2	أَرَادَ حَجَّ
u'أَرَادَ حُجَّةٌ':Predicate, #2: 2	أَرَادَ الْحِجَامَةَ
u'أَرَادَ حَجْرٌ':Predicate, #1: 1	أَرَادَ حُجَّةَ
u'أَرَادَ حُدوثٌ':Predicate, #1: 1	أَرَادَ حَجْرَ
u'أَرَادَ حَديثٌ':Predicate, #1: 1	أَرَادَ حُدُوثَ
u'أَرَادَ حَديثٌ':Predicate, #1: 1	أَرَادَ الْحَدِيثَ
u'أَرَادَ حُرٌّ':Subject, #2: 2	أَرَادَ حَدِيثَ
u'أَرَادَ حَرامٌ':Predicate, #1: 1	أَرَادَ حُرٌّ
u'أَرَادَ حَرَمٌ':Predicate, #1: 1	أَرَادَ الْحَرَامَ
u'أَرَادَ حَرَمٌ':Predicate, #2: 2	أَرَادَ حَرَمَ
u'أَرَادَ حُرْمَةٌ':Predicate, #3: 3	أَرَادَ الْحَرَمَ
u'أَرَادَ حساب':Predicate, #1: 1	أَرَادَ الْحُرْمَةَ
u'أَرَادَ حِسَابٌ':Predicate, #3: 3	أَرَادَ الْحِسَابَ
u'أَرَادَ حَصْرٌ':Predicate, #3: 3	أَرَادَ الْحِسَابَ
u'أَرَادَ حَصْرٌ':Predicate, #1: 1	أَرَادَ الْحَصْرَ
u'أَرَادَ حُصُول':Predicate, #2: 2	أَرَادَ حَصْرَ
u'أَرَادَ حُضورٌ':Predicate, #1: 1	أَرَادَ حُصُولَ
u'أَرَادَ حُضُورٌ':Predicate, #1: 1	أَرَادَ الْحُضُورَ
u'أَرَادَ حُضورٌ':Predicate, #1: 1	أَرَادَ الْحُضُورَ
u'أَرَادَ حُضُورٌ':Predicate, #2: 2	أَرَادَ حُضُورَ
u'أَرَادَ حَفْرٌ':Predicate, #2: 2	أَرَادَ حُضُورَ
u'أَرَادَ حَفْرٌ':Predicate, #1: 1	أَرَادَ الْحَفْرَ
u'أَرَادَ حِفْظٌ':Predicate, #2: 2	أَرَادَ حَفْرَ
u'أَرَادَ حَقٌّ':Predicate, #1: 1	أَرَادَ حِفْظَ
u'أَرَادَ حَقِيقٌ':Predicate, #2: 2	أَرَادَ الْحَقَّ
u'أَرَادَ حَقِيقٌ':Predicate, #1: 1	أَرَادَ الْحَقِيقَةَ
u'أَرَادَ حَقِيقَةٌ':Predicate, #8: 8	أَرَادَ حَقِيقَةَ
u'أَرَادَ حَقِيقَةٌ':Predicate, #1: 1	أَرَادَ الْحَقِيقَةَ
u'أَرَادَ حِكَايَةٌ':Predicate, #8: 8	أَرَادَ حَقِيقَةَ
u'أَرَادَ حُكْمٌ':Predicate, #2: 2	أَرَادَ حِكَايَةَ
u'أَرَادَ حُكْمٌ':Predicate, #1: 1	أَرَادَ حُكْمَ
u'أَرَادَ حِلْفٌ':Predicate, #7: 7	أَرَادَ الْحُكْمَ
u'أَرَادَ حَلْقٌ':Predicate, #2: 2	أَرَادَ حِلْفَ
u'أَرَادَ حَلْقٌ':Predicate, #1: 1	أَرَادَ حَلْقَ
u'أَرَادَ حَمْلٌ':Predicate, #3: 3	أَرَادَ الْحَلْقَ
u'أَرَادَ حُمْلاَنٌ':Predicate, #2: 2	أَرَادَ حَمْلَ
u'أَرَادَ حَنَفِيَّةٌ':Subject, #1: 1	أَرَادَ حُمْلَانَ
u'أَرَادَ حَوْضٌ':Predicate, #2: 2	أَرَادَ الْحَنَفِيَّةُ
u'أَرَادَ حَيَاةٌ':Predicate, #1: 1	أَرَادَ الْحَوْضَ
u'أَرَادَ حَيْضَةٌ':Predicate, #2: 2	أَرَادَ حَيَاةَ
u'أَرَادَ حِيلَةٌ':Predicate, #1: 1	أَرَادَ الْحَيْضَةَ
u'أَرَادَ خَالِدٌ':Subject, #13: 13	أَرَادَ الْحِيلَةَ
u'أَرَادَ خِبْرَةٌ':Predicate, #1: 1	أَرَادَ خَالِدٌ
u'أَرَادَ خَتْمٌ':Predicate, #1: 1	أَرَادَ الْخِبْرَةَ
u'أَرَادَ خُرُوجٌ':Predicate, #1: 1	أَرَادَ الْخَتْمَ
u'أَرَادَ خُرُوجٌ':Predicate, #1: 1	أَرَادَ خُرُوجَ
u'أَرَادَ خَصْمٌ':Subject, #30: 30	أَرَادَ الْخُرُوجَ
u'أَرَادَ خُصُومَةٌ':Predicate, #2: 2	أَرَادَ الْخَصْمُ
u'أَرَادَ خِطَابٌ':Predicate, #1: 1	أَرَادَ الْخُصُومَةَ
u'أَرَادَ خطبة':Predicate, #1: 1	أَرَادَ الْخِطَابَ
u'أَرَادَ خُطْبَةٌ':Predicate, #1: 1	أَرَادَ الْخُطْبَةَ
u'أَرَادَ خطبة':Predicate, #1: 1	أَرَادَ الْخُطْبَةَ
u'أَرَادَ خِطْبَةٌ':Predicate, #2: 2	أَرَادَ خِطْبَةَ
u'أَرَادَ خَلاَءٌ':Predicate, #2: 2	أَرَادَ خِطْبَةَ
u'أَرَادَ خَلاَءٌ':Predicate, #1: 1	أَرَادَ الْخَلَاءَ
u'أَرَادَ خلاص':Predicate, #1: 1	أَرَادَ الْخَلاَءَ
u'أَرَادَ خَلاَصٌ':Predicate, #3: 3	أَرَادَ الْخَلَاصَ
u'أَرَادَ خِلاَفٌ':Predicate, #3: 3	أَرَادَ الْخَلَاصَ
u'أَرَادَ خِلاَفٌ':Predicate, #1: 1	أَرَادَ الْخِلَافَ
u'أَرَادَ خِلاَفٌ':Predicate, #1: 1	أَرَادَ خِلَافَ
u'أَرَادَ خِلاَفَةٌ':Predicate, #1: 1	أَرَادَ خِلاَفَ
u'أَرَادَ خُلْعٌ':Predicate, #1: 1	أَرَادَ الْخِلَافَةَ
u'أَرَادَ خلق':Predicate, #2: 2	أَرَادَ خُلْعَ
u'أَرَادَ خَلْقٌ':Predicate, #1: 1	أَرَادَ خَلْقَ
u'أَرَادَ خَمْسٌ':Predicate, #1: 1	أَرَادَ خَلْقَ
u'أَرَادَ خَوْفٌ':Predicate, #1: 1	أَرَادَ خَمْسَ
u'أَرَادَ دَارٌ':Predicate, #1: 1	أَرَادَ خَوْفَ
u'أَرَادَ دُخُولٌ':Predicate, #2: 2	أَرَادَ الدَّارَ
u'أَرَادَ دُخُولٌ':Predicate, #12: 12	أَرَادَ الدُّخُولَ
u'أَرَادَ دَرَاهِمُ':Predicate, #23: 23	أَرَادَ دُخُولَ
u'أَرَادَ دَرَاهِمُ':Predicate, #1: 1	أَرَادَ الدَّرَاهِمَ
u'أَرَادَ دُعَاءٌ':Predicate, #1: 1	أَرَادَ دَرَاهِمَ
u'أَرَادَ دُعَاءٌ':Predicate, #1: 1	أَرَادَ الدّعَاءَ
u'أَرَادَ دفع':Predicate, #4: 4	أَرَادَ الدُّعَاءَ
u'أَرَادَ دَفْعٌ':Predicate, #1: 1	أَرَادَ الدَّفْعَ
u'أَرَادَ دفع':Predicate, #1: 1	أَرَادَ الدَّفْعَ
u'أَرَادَ دَفْعٌ':Predicate, #6: 6	أَرَادَ دَفْعَ
u'أَرَادَ دفن':Predicate, #6: 6	أَرَادَ دَفْعَ
u'أَرَادَ دَفْنٌ':Predicate, #2: 2	أَرَادَ الدَّفْنَ
u'أَرَادَ دَلالَةٌ':Predicate, #2: 2	أَرَادَ الدَّفْنَ
u'أَرَادَ دَمٌ':Predicate, #1: 1	أَرَادَ دَلَالَةَ
u'أَرَادَ دونٌ':Predicate, #1: 1	أَرَادَ الدَّمَ
u'أَرَادَ ذَكاةٌ':Predicate, #1: 1	أَرَادَ دُونَ
u'أَرَادَ ذكر':Predicate, #1: 1	أَرَادَ الذَّكَاةَ
u'أَرَادَ ذِكْرٌ':Predicate, #4: 4	أَرَادَ ذِكْرَ
u'أَرَادَ ذَمٌّ':Predicate, #4: 4	أَرَادَ ذِكْرَ
u'أَرَادَ ذِمِّيٌّ':Subject, #1: 1	أَرَادَ ذَمَّ
u'أَرَادَ ذَهَابٌ':Predicate, #1: 1	أَرَادَ الذِّمِّيُّ
u'أَرَادَ رابع':Predicate, #4: 4	أَرَادَ الذَّهَابَ
u'أَرَادَ رَابِعٌ':Predicate, #1: 1	أَرَادَ الرَّابِعَةَ
u'أَرَادَ رَاهِنٌ':Subject, #1: 1	أَرَادَ الرَّابِعَةَ
u'أَرَادَ رَبُّ':Subject, #4: 4	أَرَادَ الرَّاهِنُ
u'أَرَادَ رَبُّ':Subject, #1: 1	أَرَادَ الرَّبُّ
u'أَرَادَ رَبُّ':Subject, #1: 1	أَرَادَ رَبُّهُ
u'أَرَادَ رِبْحٌ':Predicate, #20: 20	أَرَادَ رَبُّ
u'أَرَادَ رَبْطٌ':Predicate, #1: 1	أَرَادَ رِبْحَ
u'أَرَادَ رِجَالٌ':Predicate, #1: 1	أَرَادَ رَبْطَ
u'أَرَادَ رجعة':Predicate, #1: 1	أَرَادَ الرِّجَالَ
u'أَرَادَ رَجْعَةٌ':Predicate, #2: 2	أَرَادَ الرَّجْعَةَ
u'أَرَادَ رَجُلٌ':Subject, #2: 2	أَرَادَ الرَّجْعَةَ
u'أَرَادَ رَجُلٌ':Subject, #11: 11	أَرَادَ رَجُلٌ
u'أَرَادَ رَجُلٌ':Subject, #1: 1	أَرَادَ الرّجُلُ
u'أَرَادَ رُجُوعٌ':Predicate, #48: 48	أَرَادَ الرَّجُلُ
u'أَرَادَ رُجُوعٌ':Predicate, #1: 1	أَرَادَ الرّجُوعَ
u'أَرَادَ رُجُوعٌ':Predicate, #25: 25	أَرَادَ الرُّجُوعَ
u'أَرَادَ رَدٌّ':Predicate, #2: 2	أَرَادَ رُجُوعَ
u'أَرَادَ رَدٌّ':Predicate, #5: 5	أَرَادَ رَدَّ
u'أَرَادَ رَسُولٌ':Subject, #8: 8	أَرَادَ الرَّدَّ
u'أَرَادَ رَسُولٌ':Subject, #11: 11	أَرَادَ رَسُولُ
u'أَرَادَ رَسُولٌ':Subject, #1: 1	أَرَادَ الرَّسُولُ
u'أَرَادَ رَفْعٌ':Predicate, #1: 1	أَرَادَ رَسُولُهُ
u'أَرَادَ رَفْعٌ':Predicate, #3: 3	أَرَادَ الرَّفْعَ
u'أَرَادَ رِفْقٌ':Predicate, #6: 6	أَرَادَ رَفْعَ
u'أَرَادَ رُقادٌ':Predicate, #1: 1	أَرَادَ الرّفْقَ
u'أَرَادَ رِقَّةٌ':Predicate, #1: 1	أَرَادَ الرّقَادَ
u'أَرَادَ رُكوبٌ':Predicate, #1: 1	أَرَادَ رِقّةَ
u'أَرَادَ رُكوعٌ':Predicate, #1: 1	أَرَادَ الرُّكُوبَ
u'أَرَادَ رماح':Predicate, #2: 2	أَرَادَ الرُّكُوعَ
u'أَرَادَ رِماحٌ':Predicate, #1: 1	أَرَادَ الرّمَاحَ
u'أَرَادَ رَمَلٌ':Predicate, #1: 1	أَرَادَ الرّمَاحَ
u'أَرَادَ رَمْيٌ':Predicate, #1: 1	أَرَادَ الرَّمَلَ
u'أَرَادَ رَهْنٌ':Predicate, #1: 1	أَرَادَ الرَّمْيَ
u'أَرَادَ زَارِعٌ':Subject, #1: 1	أَرَادَ رَهْنَ
u'أَرَادَ زَكاةٌ':Predicate, #1: 1	أَرَادَ الزَّارِعُ
u'أَرَادَ زَكاةٌ':Predicate, #1: 1	أَرَادَ الزّكَاةَ
u'أَرَادَ زُكاةٌ':Predicate, #1: 1	أَرَادَ الزَّكَاةَ
u'أَرَادَ زَمانٌ':Predicate, #1: 1	أَرَادَ الزّكَاةَ
u'أَرَادَ زَمَنٌ':Predicate, #1: 1	أَرَادَ الزَّمَانَ
u'أَرَادَ زَوْجٌ':Subject, #1: 1	أَرَادَ الزَّمَنَ
u'أَرَادَ زَوْجٌ':Subject, #1: 1	أَرَادَ زَوْجُ
u'أَرَادَ زِيادَةٌ':Predicate, #28: 28	أَرَادَ الزَّوْجُ
u'أَرَادَ زِيادَةٌ':Predicate, #2: 2	أَرَادَ زِيَادَةَ
u'أَرَادَ زِيارَةٌ':Predicate, #3: 3	أَرَادَ الزِّيَادَةَ
u'أَرَادَ زَيْدٌ':Predicate, #1: 1	أَرَادَ زِيَارَةَ
u'أَرَادَ زَيْنَبٌ':Predicate, #1: 1	أَرَادَ زَيْدَ
u'أَرَادَ زِينَةٌ':Predicate, #1: 1	أَرَادَ زَيْنَبَ
u'أَرَادَ سَارٌّ':Predicate, #1: 1	أَرَادَ الزِّينَةَ
u'أَرَادَ سَاكِتٌ':Subject, #1: 1	أَرَادَ سَارّةَ
u'أَرَادَ سائِل':Subject, #2: 2	أَرَادَ السَّاكِتُ
u'أَرَادَ سَائِلٌ':Subject, #1: 1	أَرَادَ السَّائِلُ
u'أَرَادَ سِجِلٌّ':Predicate, #1: 1	أَرَادَ السَّائِلُ
u'أَرَادَ سُجُودٌ':Predicate, #1: 1	أَرَادَ السِّجِلَّ
u'أَرَادَ سَخِينٌ':Predicate, #11: 11	أَرَادَ السُّجُودَ
u'أَرَادَ سِدْرٌ':Predicate, #1: 1	أَرَادَ سَخِينَةَ
u'أَرَادَ سِدْرٌ':Predicate, #1: 1	أَرَادَ السِّدْرَ
u'أَرَادَ سَرقَةٌ':Predicate, #1: 1	أَرَادَ سِدْرَ
u'أَرَادَ سَرِقَةٌ':Predicate, #1: 1	أَرَادَ سَرِقَةَ
u'أَرَادَ سَعَادَةٌ':Predicate, #1: 1	أَرَادَ سَرِقَةَ
u'أَرَادَ سَفَرٌ':Predicate, #1: 1	أَرَادَ السَّعَادَةَ
u'أَرَادَ سقط':Predicate, #17: 17	أَرَادَ السَّفَرَ
u'أَرَادَ سُقُوطٌ':Predicate, #1: 1	أَرَادَ السَّقْطَ
u'أَرَادَ سَقْيٌ':Predicate, #1: 1	أَرَادَ سُقُوطَ
u'أَرَادَ سَقْيٌ':Predicate, #1: 1	أَرَادَ السَّقْيَ
u'أَرَادَ سَلاَمَةٌ':Predicate, #4: 4	أَرَادَ سَقْيَ
u'أَرَادَ سَلْبٌ':Predicate, #1: 1	أَرَادَ السَّلَامَةَ
u'أَرَادَ سُلْطَانٌ':Subject, #1: 1	أَرَادَ سَلْبَ
u'أَرَادَ سُلُوكٌ':Predicate, #4: 4	أَرَادَ السُّلْطَانُ
u'أَرَادَ سُلُوك':Predicate, #2: 2	أَرَادَ سُلُوكَ
u'أَرَادَ سُنَّةٌ':Predicate, #2: 2	أَرَادَ سُلُوكَ
u'أَرَادَ سُنَّةٌ':Predicate, #1: 1	أَرَادَ سُنَّةَ
u'أَرَادَ سُؤَالٌ':Predicate, #2: 2	أَرَادَ السُّنَّةَ
u'أَرَادَ سُؤَالٌ':Predicate, #1: 1	أَرَادَ السُّؤَالَ
u'أَرَادَ سَيِّدٌ':Subject, #1: 1	أَرَادَ سُؤَالَ
u'أَرَادَ سَيِّدٌ':Subject, #1: 1	أَرَادَ سَيّدَاهُ
u'أَرَادَ سَيِّدٌ':Subject, #1: 1	أَرَادَ سَيِّدُهُ
u'أَرَادَ سَيْفٌ':Predicate, #8: 8	أَرَادَ السَّيِّدُ
u'أَرَادَ سُيوفٌ':Predicate, #1: 1	أَرَادَ السّيْفَ
u'أَرَادَ شَاعِر':Subject, #1: 1	أَرَادَ السّيُوفَ
u'أَرَادَ شافِعِيّ':Subject, #1: 1	أَرَادَ الشّاعِرُ
u'أَرَادَ شَائِعٌ':Subject, #9: 9	أَرَادَ الشَّافِعِيُّ
u'أَرَادَ شَتْمٌ':Predicate, #1: 1	أَرَادَ شَائِعٌ
u'أَرَادَ شَجَرَةٌ':Predicate, #1: 1	أَرَادَ الشَّتْمَ
u'أَرَادَ شَخْصٌ':Subject, #1: 1	أَرَادَ شَجَرَةَ
u'أَرَادَ شَخْصٌ':Subject, #1: 1	أَرَادَ الشَّخْصُ
u'أَرَادَ شِرَاءٌ':Predicate, #2: 2	أَرَادَ شَخْصٌ
u'أَرَادَ شِرَاءٌ':Predicate, #7: 7	أَرَادَ الشِّرَاءَ
u'أَرَادَ شَرْطٌ':Predicate, #9: 9	أَرَادَ شِرَاءَ
u'أَرَادَ شركاء':Subject, #3: 3	أَرَادَ الشَّرْطَ
u'أَرَادَ شركة':Predicate, #1: 1	أَرَادَ الشُّرَكَاءُ
u'أَرَادَ شِرْكَةٌ':Predicate, #2: 2	أَرَادَ الشِّرْكَةَ
u'أَرَادَ شركة':Predicate, #2: 2	أَرَادَ الشِّرْكَةَ
u'أَرَادَ شَرِكَةٌ':Predicate, #4: 4	أَرَادَ الشَّرِكَةَ
u'أَرَادَ شُرُوعٌ':Predicate, #4: 4	أَرَادَ الشَّرِكَةَ
u'أَرَادَ شِفَاءٌ':Predicate, #4: 4	أَرَادَ الشُّرُوعَ
u'أَرَادَ شفعة':Predicate, #1: 1	أَرَادَ الشِّفَاءَ
u'أَرَادَ شُفْعَةٌ':Predicate, #1: 1	أَرَادَ الشُّفْعَةَ
u'أَرَادَ شَفِيعٌ':Subject, #1: 1	أَرَادَ الشُّفْعَةَ
u'أَرَادَ شَقٌّ':Predicate, #7: 7	أَرَادَ الشَّفِيعُ
u'أَرَادَ شَقٌّ':Predicate, #1: 1	أَرَادَ الشَّقَّ
u'أَرَادَ شَقَاءٌ':Predicate, #1: 1	أَرَادَ شَقَّ
u'أَرَادَ شُمُول':Predicate, #1: 1	أَرَادَ الشَّقَاءَ
u'أَرَادَ شَهْرٌ':Predicate, #1: 1	أَرَادَ الشُّمُولَ
u'أَرَادَ شَهْوَةٌ':Predicate, #1: 1	أَرَادَ الشَّهْرَ
u'أَرَادَ شُهُودٌ':Subject, #2: 2	أَرَادَ الشَّهْوَةَ
u'أَرَادَ شَيْخٌ':Predicate, #1: 1	أَرَادَ الشُّهُودُ
u'أَرَادَ شَيْخٌ':Subject, #1: 1	أَرَادَ الشَّيْخَ
u'أَرَادَ شَيْطَانٌ':Subject, #5: 5	أَرَادَ الشَّيْخُ
u'أَرَادَ صَاحِبٌ':Predicate, #1: 1	أَرَادَ الشَّيْطَانُ
u'أَرَادَ صَاحِبٌ':Subject, #1: 1	أَرَادَ صَاحِبَ
u'أَرَادَ صَاحِبٌ':Subject, #1: 1	أَرَادَ صَاحِبُهُ
u'أَرَادَ صَاعٌ':Predicate, #23: 23	أَرَادَ صَاحِبُ
u'أَرَادَ صَبٌّ':Predicate, #1: 1	أَرَادَ صَاعَ
u'أَرَادَ صَبِيٌّ':Predicate, #1: 1	أَرَادَ صَبَّ
u'أَرَادَ صِبْيَةٌ':Subject, #1: 1	أَرَادَ الصَّبِيَّ
u'أَرَادَ صِحَّةٌ':Predicate, #1: 1	أَرَادَ الصِّبْيَةُ
u'أَرَادَ صِحَّةٌ':Predicate, #1: 1	أَرَادَ الصِّحَّةَ
u'أَرَادَ صدقة':Predicate, #1: 1	أَرَادَ صِحَّةَ
u'أَرَادَ صَدَقَةٌ':Predicate, #2: 2	أَرَادَ الصَّدَقَةَ
u'أَرَادَ صَرْفٌ':Predicate, #2: 2	أَرَادَ الصَّدَقَةَ
u'أَرَادَ صَرْف':Predicate, #1: 1	أَرَادَ صَرْفَ
u'أَرَادَ صُعُودٌ':Predicate, #1: 1	أَرَادَ صَرْفَ
u'أَرَادَ صُفْرَةٌ':Predicate, #1: 1	أَرَادَ الصُّعُودَ
u'أَرَادَ صَلاَةٌ':Predicate, #1: 1	أَرَادَ الصُّفْرَةَ
u'أَرَادَ صَلاَةٌ':Predicate, #1: 1	أَرَادَ صَلَاةَ
u'أَرَادَ صلْبٌ':Predicate, #23: 23	أَرَادَ الصَّلَاةَ
u'أَرَادَ صَلْبٌ':Predicate, #1: 1	أَرَادَ الصَّلْبَ
u'أَرَادَ صُنَّاعٌ':Subject, #1: 1	أَرَادَ الصَّلْبَ
u'أَرَادَ صُورٌ':Predicate, #1: 1	أَرَادَ الصُّنَّاعُ
u'أَرَادَ صُوَرٌ':Predicate, #1: 1	أَرَادَ الصُّوَرَ
u'أَرَادَ صَوْمٌ':Predicate, #1: 1	أَرَادَ الصُّوَرَ
u'أَرَادَ صِيَامٌ':Predicate, #2: 2	أَرَادَ الصَّوْمَ
u'أَرَادَ صِيغَةٌ':Predicate, #2: 2	أَرَادَ الصِّيَامَ
u'أَرَادَ ضَرْبٌ':Predicate, #1: 1	أَرَادَ صِيغَةَ
u'أَرَادَ ضَرَرٌ':Predicate, #3: 3	أَرَادَ ضَرْبَ
u'أَرَادَ ضَمٌّ':Predicate, #1: 1	أَرَادَ الضَّرَرَ
u'أَرَادَ ضَمَانٌ':Predicate, #1: 1	أَرَادَ ضَمَّ
u'أَرَادَ ضَيْفٌ':Subject, #1: 1	أَرَادَ ضَمَانَ
u'أَرَادَ طَالِبٌ':Predicate, #1: 1	أَرَادَ الضَّيْفُ
u'أَرَادَ طَالِبٌ':Subject, #1: 1	أَرَادَ طَالِبَ
u'أَرَادَ طَالِقٌ':Predicate, #3: 3	أَرَادَ الطَّالِبُ
u'أَرَادَ طَبْخٌ':Predicate, #1: 1	أَرَادَ طَالِقَةً
u'أَرَادَ طَرِيقٌ':Predicate, #1: 1	أَرَادَ طَبْخَ
u'أَرَادَ طعام':Predicate, #3: 3	أَرَادَ الطَّرِيقَ
u'أَرَادَ طَعَامٌ':Predicate, #1: 1	أَرَادَ الطَّعَامَ
u'أَرَادَ طَلاَقٌ':Predicate, #1: 1	أَرَادَ الطَّعَامَ
u'أَرَادَ طَلاَقٌ':Predicate, #12: 12	أَرَادَ الطَّلَاقَ
u'أَرَادَ طَمٌّ':Predicate, #4: 4	أَرَادَ طَلَاقَ
u'أَرَادَ طهر':Predicate, #1: 1	أَرَادَ الطَّمَّ
u'أَرَادَ طُهْرٌ':Predicate, #1: 1	أَرَادَ الطُّهْرَ
u'أَرَادَ طوال':Predicate, #1: 1	أَرَادَ الطُّهْرَ
u'أَرَادَ طَوْقٌ':Predicate, #1: 1	أَرَادَ الطِّوَالَ
u'أَرَادَ طُولٌ':Predicate, #1: 1	أَرَادَ طَوْقَ
u'أَرَادَ طَوْلٌ':Predicate, #1: 1	أَرَادَ الطّوْلَ
u'أَرَادَ ظالِمٌ':Predicate, #1: 1	أَرَادَ الطّوْلَ
u'أَرَادَ ظالِمٌ':Subject, #1: 1	أَرَادَ الظَّالِمِينَ
u'أَرَادَ ظاهِرٌ':Predicate, #1: 1	أَرَادَ ظَالِمٌ
u'أَرَادَ ظاهِرٌ':Predicate, #2: 2	أَرَادَ الظَّاهِرَةَ
u'أَرَادَ ظاهِرَة':Predicate, #2: 2	أَرَادَ ظَاهِرَ
u'أَرَادَ ظَرْفٌ':Predicate, #2: 2	أَرَادَ الظَّاهِرَةَ
u'أَرَادَ ظُلْمٌ':Predicate, #1: 1	أَرَادَ الظَّرْفَ
u'أَرَادَ ظهار':Predicate, #1: 1	أَرَادَ الظُّلْمَ
u'أَرَادَ عَامِرٌ':Predicate, #2: 2	أَرَادَ الظِّهَارَ
u'أَرَادَ عَامِلٌ':Subject, #1: 1	أَرَادَ عَامِرَ
u'أَرَادَ عَائِدٌ':Subject, #5: 5	أَرَادَ الْعَامِلُ
u'أَرَادَ عَائِشٌ':Predicate, #1: 1	أَرَادَ عَائِدٌ
u'أَرَادَ عَبَّاسٌ':Subject, #1: 1	أَرَادَ عَائِشَةَ
u'أَرَادَ عَبْدٌ':Predicate, #1: 1	أَرَادَ عَبّاسُ
u'أَرَادَ عَبْدٌ':Predicate, #1: 1	أَرَادَ عَبْدَ
u'أَرَادَ عَبْدٌ':Subject, #2: 2	أَرَادَ الْعَبْدَ
u'أَرَادَ عَبْدٌ':Subject, #3: 3	أَرَادَ عَبْدُ
u'أَرَادَ عتق':Predicate, #8: 8	أَرَادَ الْعَبْدُ
u'أَرَادَ عِتْقٌ':Predicate, #1: 1	أَرَادَ الْعِتْقَ
u'أَرَادَ عتق':Predicate, #1: 1	أَرَادَ الْعِتْقَ
u'أَرَادَ عِتْقٌ':Predicate, #2: 2	أَرَادَ عِتْقَ
u'أَرَادَ عَثَاكِيلُ':Predicate, #2: 2	أَرَادَ عِتْقَ
u'أَرَادَ عَدٌّ':Predicate, #1: 1	أَرَادَ الْعَثَاكِيلَ
u'أَرَادَ عَدَدٌ':Predicate, #1: 1	أَرَادَ عَدَّ
u'أَرَادَ عَدْلٌ':Subject, #1: 1	أَرَادَ الْعَدَدَ
u'أَرَادَ عَدَمٌ':Predicate, #2: 2	أَرَادَ الْعَدْلُ
u'أَرَادَ عُدُولٌ':Predicate, #3: 3	أَرَادَ عَدَمَ
u'أَرَادَ عرف':Predicate, #2: 2	أَرَادَ الْعُدُولَ
u'أَرَادَ عُرْفٌ':Predicate, #2: 2	أَرَادَ عُرْفَ
u'أَرَادَ عُرْوَةٌ':Subject, #2: 2	أَرَادَ عُرْفَ
u'أَرَادَ عزل':Predicate, #1: 1	أَرَادَ عُرْوَةُ
u'أَرَادَ عَصَافِيرُ':Predicate, #1: 1	أَرَادَ عَزْلَ
u'أَرَادَ عَصَافِيرُ':Subject, #2: 2	أَرَادَ الْعَصَافِيرَ
u'أَرَادَ عَصْرٌ':Predicate, #1: 1	أَرَادَ الْعَصَافِيرُ
u'أَرَادَ عطف':Predicate, #1: 1	أَرَادَ عَصْرَ
u'أَرَادَ عَطْفٌ':Predicate, #1: 1	أَرَادَ الْعَطْفَ
u'أَرَادَ عَطِيَّةٌ':Predicate, #1: 1	أَرَادَ الْعَطْفَ
u'أَرَادَ عَقْدٌ':Predicate, #1: 1	أَرَادَ الْعَطِيَّةَ
u'أَرَادَ عَقْلٌ':Predicate, #1: 1	أَرَادَ الْعَقْدَ
u'أَرَادَ عَكْسٌ':Predicate, #1: 1	أَرَادَ الْعَقْلَ
u'أَرَادَ علم':Predicate, #1: 1	أَرَادَ الْعَكْسَ
u'أَرَادَ عِلْمٌ':Predicate, #3: 3	أَرَادَ الْعِلْمَ
u'أَرَادَ علماء':Predicate, #3: 3	أَرَادَ الْعِلْمَ
u'أَرَادَ عُلَمَاءُ':Predicate, #1: 1	أَرَادَ عُلَمَاءَ
u'أَرَادَ عَمٌّ':Subject, #1: 1	أَرَادَ عُلَمَاءَ
u'أَرَادَ عِمَارَةٌ':Predicate, #1: 1	أَرَادَ الْعَمُّ
u'أَرَادَ عُمَرٌ':Predicate, #2: 2	أَرَادَ الْعِمَارَةَ
u'أَرَادَ عُمَرٌ':Subject, #1: 1	أَرَادَ عُمَرَ
u'أَرَادَ عمرة':Predicate, #10: 10	أَرَادَ عُمَرُ
u'أَرَادَ عُمْرَةٌ':Predicate, #1: 1	أَرَادَ الْعُمْرَةَ
u'أَرَادَ عمرة':Predicate, #1: 1	أَرَادَ الْعُمْرَةَ
u'أَرَادَ عُمْرَةٌ':Predicate, #1: 1	أَرَادَ عُمْرَةَ
u'أَرَادَ عَمَلٌ':Predicate, #1: 1	أَرَادَ عُمْرَةَ
u'أَرَادَ عُمُومٌ':Predicate, #2: 2	أَرَادَ الْعَمَلَ
u'أَرَادَ عند':Predicate, #2: 2	أَرَادَ الْعُمُومَ
u'أَرَادَ عَوْدٌ':Predicate, #1: 1	أَرَادَ عِنْدَ
u'أَرَادَ عَوْدَةٌ':Predicate, #5: 5	أَرَادَ الْعَوْدَ
u'أَرَادَ عَيْبٌ':Predicate, #1: 1	أَرَادَ الْعَوْدَةَ
u'أَرَادَ عين':Predicate, #1: 1	أَرَادَ الْعَيْبَ
u'أَرَادَ عَيْنٌ':Predicate, #1: 1	أَرَادَ عَيْنَ
u'أَرَادَ عَيْن':Predicate, #1: 1	أَرَادَ عَيْنَ
u'أَرَادَ غَاصِبٌ':Subject, #1: 1	أَرَادَ عَيْنَ
u'أَرَادَ غَائِبٌ':Subject, #9: 9	أَرَادَ الْغَاصِبُ
u'أَرَادَ غَايَةٌ':Predicate, #1: 1	أَرَادَ الْغَائِبُ
u'أَرَادَ غرماء':Subject, #1: 1	أَرَادَ غَايَةَ
u'أَرَادَ غَرِيمٌ':Subject, #1: 1	أَرَادَ الْغُرَمَاءُ
u'أَرَادَ غَرِيمٌ':Subject, #2: 2	أَرَادَ غَرِيمُهُ
u'أَرَادَ غَزْوٌ':Predicate, #4: 4	أَرَادَ الْغَرِيمُ
u'أَرَادَ غَزْوَةٌ':Predicate, #1: 1	أَرَادَ الْغَزْوَ
u'أَرَادَ غُسْلٌ':Predicate, #1: 1	أَرَادَ غَزْوَةَ
u'أَرَادَ غَسْلٌ':Predicate, #3: 3	أَرَادَ الْغُسْلَ
u'أَرَادَ غطاريف':Predicate, #3: 3	أَرَادَ غَسْلَ
u'أَرَادَ غَلَبَةٌ':Predicate, #1: 1	أَرَادَ الْغَطَارِيفَ
u'أَرَادَ غَمٌّ':Predicate, #1: 1	أَرَادَ غَلَبَةَ
u'أَرَادَ غير':Predicate, #1: 1	أَرَادَ غَمَّ
u'أَرَادَ غَيْرٌ':Predicate, #24: 24	أَرَادَ غَيْرَ
u'أَرَادَ غير':Subject, #24: 24	أَرَادَ غَيْرَ
u'أَرَادَ غَيْرٌ':Subject, #1: 1	أَرَادَ غَيْرُ
u'أَرَادَ غير':Subject, #1: 1	أَرَادَ غَيْرُ
u'أَرَادَ غَيْرٌ':Subject, #1: 1	أَرَادَ غَيْرُهُ
u'أَرَادَ فُجُورٌ':Predicate, #1: 1	أَرَادَ غَيْرُهُ
u'أَرَادَ فِدَاءٌ':Predicate, #1: 1	أَرَادَ الْفُجُورَ
u'أَرَادَ فِرَاقٌ':Predicate, #1: 1	أَرَادَ فِدَاءَ
u'أَرَادَ فَرَسٌ':Predicate, #2: 2	أَرَادَ فِرَاقَ
u'أَرَادَ فَرْضٌ':Predicate, #1: 1	أَرَادَ فَرَسَ
u'أَرَادَ فَرْضٌ':Predicate, #1: 1	أَرَادَ الْفَرْضَ
u'أَرَادَ فَرَطٌ':Predicate, #1: 1	أَرَادَ فَرْضَ
u'أَرَادَ فَرْعٌ':Subject, #1: 1	أَرَادَ الْفَرَطَ
u'أَرَادَ فِرْقَةٌ':Predicate, #1: 1	أَرَادَ الْفَرْعُ
u'أَرَادَ فَرِيضَةٌ':Predicate, #1: 1	أَرَادَ الْفِرْقَةَ
u'أَرَادَ فَسْخٌ':Predicate, #1: 1	أَرَادَ الْفَرِيضَةَ
u'أَرَادَ فَسْخٌ':Predicate, #12: 12	أَرَادَ الْفَسْخَ
u'أَرَادَ فَصْلٌ':Predicate, #1: 1	أَرَادَ فَسْخَ
u'أَرَادَ فِطَامٌ':Predicate, #1: 1	أَرَادَ فَصْلَ
u'أَرَادَ فِطْرٌ':Predicate, #1: 1	أَرَادَ الْفِطَامَ
u'أَرَادَ فِعْلٌ':Predicate, #3: 3	أَرَادَ الْفِطْرَ
u'أَرَادَ فِقْهٌ':Predicate, #3: 3	أَرَادَ فِعْلَ
u'أَرَادَ فقهاء':Predicate, #1: 1	أَرَادَ الْفِقْهَ
u'أَرَادَ فَقِيهٌ':Subject, #1: 1	أَرَادَ الْفُقَهَاءَ
u'أَرَادَ فلان':Predicate, #2: 2	أَرَادَ الْفَقِيهُ
u'أَرَادَ فلان':Subject, #1: 1	أَرَادَ مَكَّةَ
u'أَرَادَ فلان':Subject, #1: 1	أَرَادَ الزَّمَخْشَرِيُّ
u'أَرَادَ فلان':Subject, #1: 1	أَرَادَ بِلَالٌ
u'أَرَادَ فلان':Subject, #1: 1	أَرَادَ حُذَيْفَةُ
u'أَرَادَ فلان':Subject, #1: 1	أَرَادَ مُعَاوِيَةُ
u'أَرَادَ فلان':Subject, #2: 2	أَرَادَ عُثْمَانُ
u'أَرَادَ فلان':Subject, #3: 3	أَرَادَ الْمُتَصَدِّقُ
u'أَرَادَ فَهْمٌ':Predicate, #9: 9	أَرَادَ الشَّافِعِيُّ
u'أَرَادَ قَابِضٌ':Subject, #1: 1	أَرَادَ فَهْمَ
u'أَرَادَ قَالٌ':Predicate, #1: 1	أَرَادَ الْقَابِضُ
u'أَرَادَ قَائِلٌ':Subject, #1: 1	أَرَادَ قَالَ
u'أَرَادَ قَائِلٌ':Subject, #1: 1	أَرَادَ قَائِلُهُ
u'أَرَادَ قَبُولٌ':Predicate, #2: 2	أَرَادَ الْقَائِلُ
u'أَرَادَ قَبُولٌ':Predicate, #1: 1	أَرَادَ الْقَبُولَ
u'أَرَادَ قتال':Predicate, #1: 1	أَرَادَ قَبُولَ
u'أَرَادَ قِتَالٌ':Predicate, #2: 2	أَرَادَ الْقِتَالَ
u'أَرَادَ قتل':Predicate, #2: 2	أَرَادَ الْقِتَالَ
u'أَرَادَ قَتْلٌ':Predicate, #1: 1	أَرَادَ قَتْلَكَ
u'أَرَادَ قتل':Predicate, #1: 1	أَرَادَ قَتْلَكَ
u'أَرَادَ قَتْلٌ':Predicate, #8: 8	أَرَادَ قَتْلَ
u'أَرَادَ قَدْرٌ':Predicate, #8: 8	أَرَادَ قَتْلَ
u'أَرَادَ قدرة':Predicate, #2: 2	أَرَادَ قَدْرَ
u'أَرَادَ قُدْرَةٌ':Predicate, #1: 1	أَرَادَ الْقُدْرَةَ
u'أَرَادَ قِرَاءةٌ':Predicate, #1: 1	أَرَادَ الْقُدْرَةَ
u'أَرَادَ قِرَانٌ':Predicate, #5: 5	أَرَادَ قِرَاءَةَ
u'أَرَادَ قُرْبَةٌ':Predicate, #2: 2	أَرَادَ الْقِرَانَ
u'أَرَادَ قَرْيَةٌ':Predicate, #1: 1	أَرَادَ الْقُرْبَةَ
u'أَرَادَ قَسَمٌ':Predicate, #1: 1	أَرَادَ الْقَرْيَةَ
u'أَرَادَ قسمة':Predicate, #1: 1	أَرَادَ الْقَسَمَ
u'أَرَادَ قِسْمَةٌ':Predicate, #5: 5	أَرَادَ قِسْمَةَ
u'أَرَادَ قسمة':Predicate, #5: 5	أَرَادَ قِسْمَةَ
u'أَرَادَ قِسْمَةٌ':Predicate, #8: 8	أَرَادَ الْقِسْمَةَ
u'أَرَادَ قصاص':Predicate, #8: 8	أَرَادَ الْقِسْمَةَ
u'أَرَادَ قِصَاصٌ':Predicate, #1: 1	أَرَادَ الْقِصَاصَ
u'أَرَادَ قَصْرٌ':Predicate, #1: 1	أَرَادَ الْقِصَاصَ
u'أَرَادَ قَصِيلٌ':Predicate, #2: 2	أَرَادَ الْقَصْرَ
u'أَرَادَ قَضَاءٌ':Predicate, #1: 1	أَرَادَ الْقَصِيلَ
u'أَرَادَ قَضَاءٌ':Predicate, #2: 2	أَرَادَ الْقَضَاءَ
u'أَرَادَ قَطْعٌ':Predicate, #9: 9	أَرَادَ قَضَاءَ
u'أَرَادَ قَطْعٌ':Predicate, #1: 1	أَرَادَ قَطْعَ
u'أَرَادَ قلب':Predicate, #3: 3	أَرَادَ الْقَطْعَ
u'أَرَادَ قَلْبٌ':Predicate, #1: 1	أَرَادَ الْقَلْبَ
u'أَرَادَ قَلْب':Predicate, #1: 1	أَرَادَ الْقَلْبَ
u'أَرَادَ قمر':Predicate, #1: 1	أَرَادَ الْقَلْبَ
u'أَرَادَ قَمَرٌ':Predicate, #1: 1	أَرَادَ الْقَمَرَ
u'أَرَادَ قَنَاعَةٌ':Predicate, #1: 1	أَرَادَ الْقَمَرَ
u'أَرَادَ قُنُوتٌ':Predicate, #1: 1	أَرَادَ الْقَنَاعَةَ
u'أَرَادَ قَوَد':Predicate, #1: 1	أَرَادَ الْقُنُوتَ
u'أَرَادَ قول':Predicate, #2: 2	أَرَادَ الْقَوَدَ
u'أَرَادَ قَوْلٌ':Predicate, #1: 1	أَرَادَ قَوْلَ
u'أَرَادَ قَوْمٌ':Predicate, #1: 1	أَرَادَ قَوْلَ
u'أَرَادَ قَوْمٌ':Subject, #1: 1	أَرَادَ قَوْمَ
u'أَرَادَ قَوْمٌ':Subject, #1: 1	أَرَادَ قَوْمُهُ
u'أَرَادَ قَوْمٌ':Subject, #2: 2	أَرَادَ قَوْمٌ
u'أَرَادَ قِيَاسٌ':Predicate, #7: 7	أَرَادَ الْقَوْمُ
u'أَرَادَ قيام':Predicate, #1: 1	أَرَادَ قِيَاسَ
u'أَرَادَ قِيَامٌ':Predicate, #1: 1	أَرَادَ قِيَامَ
u'أَرَادَ قيام':Predicate, #1: 1	أَرَادَ قِيَامَ
u'أَرَادَ قِيَامٌ':Predicate, #4: 4	أَرَادَ الْقِيَامَ
u'أَرَادَ قَيِّمٌ':Subject, #4: 4	أَرَادَ الْقِيَامَ
u'أَرَادَ قِيمَةٌ':Predicate, #5: 5	أَرَادَ الْقَيِّمُ
u'أَرَادَ كَافِرٌ':Subject, #3: 3	أَرَادَ الْقِيمَةَ
u'أَرَادَ كبر':Predicate, #3: 3	أَرَادَ الْكَافِرُ
u'أَرَادَ كِبَرٌ':Predicate, #2: 2	أَرَادَ كِبَرَ
u'أَرَادَ كِتَابٌ':Predicate, #2: 2	أَرَادَ كِبَرَ
u'أَرَادَ كِتَابَةٌ':Predicate, #1: 1	أَرَادَ الْكِتَابَ
u'أَرَادَ كِتَابَةٌ':Predicate, #2: 2	أَرَادَ الْكِتَابَةَ
u'أَرَادَ كَثْرَةٌ':Predicate, #6: 6	أَرَادَ كِتَابَةَ
u'أَرَادَ كَثِيرٌ':Predicate, #1: 1	أَرَادَ كَثْرَةَ
u'أَرَادَ كَرَامَةٌ':Predicate, #1: 1	أَرَادَ الْكَثِيرَ
u'أَرَادَ كَرَاهَةٌ':Predicate, #1: 1	أَرَادَ الْكَرَامَةَ
u'أَرَادَ كَسْرٌ':Predicate, #6: 6	أَرَادَ كَرَاهَةَ
u'أَرَادَ كَعْبٌ':Subject, #1: 1	أَرَادَ كَسْرَ
u'أَرَادَ كَفٌّ':Predicate, #1: 1	أَرَادَ كَعْبُ
u'أَرَادَ كَفِيلٌ':Subject, #1: 1	أَرَادَ الْكَفَّ
u'أَرَادَ كَلاَمٌ':Predicate, #4: 4	أَرَادَ الْكَفِيلُ
u'أَرَادَ كَلْكَل':Predicate, #1: 1	أَرَادَ الْكَلَامَ
u'أَرَادَ كَلِمٌ':Predicate, #1: 1	أَرَادَ الْكَلْكَلَ
u'أَرَادَ كَمَالٌ':Predicate, #1: 1	أَرَادَ الْكَلِمَ
u'أَرَادَ كَمَالٌ':Predicate, #1: 1	أَرَادَ الْكَمَالَ
u'أَرَادَ كُمَيْتٌ':Subject, #1: 1	أَرَادَ كَمَالَ
u'أَرَادَ كِنَايَةٌ':Predicate, #1: 1	أَرَادَ الْكُمَيْتُ
u'أَرَادَ كُوفِيٌّ':Subject, #1: 1	أَرَادَ الْكِنَايَةَ
u'أَرَادَ كَيْلٌ':Predicate, #1: 1	أَرَادَ الْكُوفِيُّ
u'أَرَادَ لبنة':Predicate, #1: 1	أَرَادَ كَيْلاَ
u'أَرَادَ لَبِنَةٌ':Predicate, #1: 1	أَرَادَ لَبِنَةَ
u'أَرَادَ لَحْمٌ':Predicate, #1: 1	أَرَادَ لَبِنَةَ
u'أَرَادَ لَحْنٌ':Predicate, #1: 1	أَرَادَ اللَّحْمَ
u'أَرَادَ لُزُومٌ':Predicate, #1: 1	أَرَادَ اللّحْنَ
u'أَرَادَ لعان':Predicate, #1: 1	أَرَادَ لُزُومَ
u'أَرَادَ لَفْظٌ':Predicate, #1: 1	أَرَادَ اللِّعَانَ
u'أَرَادَ لَفْظٌ':Predicate, #1: 1	أَرَادَ اللَّفْظَ
u'أَرَادَ مَاءٌ':Predicate, #5: 5	أَرَادَ لَفْظَ
u'أَرَادَ مَالِكٌ':Subject, #1: 1	أَرَادَ مَاءَ
u'أَرَادَ مَالِكٌ':Subject, #10: 10	أَرَادَ الْمَالِكُ
u'أَرَادَ مَالِكٌ':Subject, #3: 3	أَرَادَ مَالِكٌ
u'أَرَادَ مَالِكٌ':Subject, #3: 3	أَرَادَ مَالِكُ
u'أَرَادَ مَأْمُورٌ':Subject, #3: 3	أَرَادَ مَالِكُهُ
u'أَرَادَ مُبَالَغَةٌ':Predicate, #2: 2	أَرَادَ الْمَأْمُورُ
u'أَرَادَ مُبْتَدِئٌ':Subject, #2: 2	أَرَادَ الْمُبَالَغَةَ
u'أَرَادَ مُتَحَجِّرٌ':Subject, #5: 5	أَرَادَ الْمُبْتَدِئُ
u'أَرَادَ مُتَصَدِّق':Subject, #1: 1	أَرَادَ الْمُتَحَجِّرُ
u'أَرَادَ مُتْعَةٌ':Predicate, #3: 3	أَرَادَ الْمُتَصَدِّقُ
u'أَرَادَ مُتَقَدِّمٌ':Predicate, #1: 1	أَرَادَ الْمُتْعَةَ
u'أَرَادَ مُتَكَلِّمٌ':Subject, #1: 1	أَرَادَ الْمُتَقَدِّمِينَ
u'أَرَادَ مُتَمَتِّعٌ':Subject, #1: 1	أَرَادَ الْمُتَكَلِّمُ
u'أَرَادَ مثل':Predicate, #3: 3	أَرَادَ الْمُتَمَتِّعُ
u'أَرَادَ مِثْلٌ':Predicate, #5: 5	أَرَادَ مِثْلَ
u'أَرَادَ مَجَازٌ':Predicate, #5: 5	أَرَادَ مِثْلَ
u'أَرَادَ مُجَاهِدٌ':Predicate, #1: 1	أَرَادَ الْمَجَازَ
u'أَرَادَ مُجَاهِدٌ':Subject, #1: 1	أَرَادَ الْمُجَاهِدِينَ
u'أَرَادَ مُجْتَهِد':Predicate, #1: 1	أَرَادَ مُجَاهِدٌ
u'أَرَادَ مُجَرَّدٌ':Predicate, #1: 1	أَرَادَ الْمُجْتَهِدِينَ
u'أَرَادَ مَجْمُوعٌ':Predicate, #2: 2	أَرَادَ مُجَرَّدَ
u'أَرَادَ مُحْرِمٌ':Subject, #2: 2	أَرَادَ مَجْمُوعَ
u'أَرَادَ مَحْرُومٌ':Subject, #1: 1	أَرَادَ الْمُحْرِمُ
u'أَرَادَ مُحَمَّدٌ':Predicate, #1: 1	أَرَادَ الْمَحْرُومُ
u'أَرَادَ مُحَمَّدٌ':Subject, #1: 1	أَرَادَ مُحَمَّدَ
u'أَرَادَ مُحِيل':Subject, #2: 2	أَرَادَ مُحَمَّدٌ
u'أَرَادَ مُخَالِفٌ':Subject, #1: 1	أَرَادَ الْمُحِيلُ
u'أَرَادَ مَدْيُونٌ':Subject, #2: 2	أَرَادَ الْمُخَالِفُ
u'أَرَادَ مَدْيُونٌ':Subject, #1: 1	أَرَادَ الْمَدْيُونُ
u'أَرَادَ مَذْكُورٌ':Predicate, #1: 1	أَرَادَ مَدْيُونُ
u'أَرَادَ مرٌّ':Predicate, #1: 1	أَرَادَ الْمَذْكُورَ
u'أَرَادَ مُرَاعَاةٌ':Predicate, #1: 1	أَرَادَ مَرَّةً
u'أَرَادَ مُرْتَدٌّ':Predicate, #1: 1	أَرَادَ مُرَاعَاةَ
u'أَرَادَ مُرْتَهِنٌ':Subject, #1: 1	أَرَادَ الْمُرْتَدَّ
u'أَرَادَ مَرِحٌ':Predicate, #5: 5	أَرَادَ الْمُرْتَهِنُ
u'أَرَادَ مُرُورٌ':Predicate, #1: 1	أَرَادَ الْمَرِحَ
u'أَرَادَ مُرِيدٌ':Subject, #2: 2	أَرَادَ الْمُرُورَ
u'أَرَادَ مُزَارِعٌ':Subject, #2: 2	أَرَادَ مُرِيدٌ
u'أَرَادَ مُسَافِرٌ':Subject, #6: 6	أَرَادَ الْمُزَارِعُ
u'أَرَادَ مَسْأَلَةٌ':Predicate, #2: 2	أَرَادَ الْمُسَافِرُ
u'أَرَادَ مُسْتَأْجِرٌ':Predicate, #1: 1	أَرَادَ مَسْأَلَةَ
u'أَرَادَ مُسْتَأْجِرٌ':Subject, #1: 1	أَرَادَ الْمُسْتَأْجِرَ
u'أَرَادَ مُسْتَحِقٌّ':Subject, #11: 11	أَرَادَ الْمُسْتَأْجِرُ
u'أَرَادَ مُسْتَعِيرٌ':Subject, #2: 2	أَرَادَ الْمُسْتَحِقُّ
u'أَرَادَ مَسْحٌ':Predicate, #2: 2	أَرَادَ الْمُسْتَعِيرُ
u'أَرَادَ مَسْكَنَةٌ':Predicate, #5: 5	أَرَادَ الْمَسْحَ
u'أَرَادَ مُسْلِمٌ':Subject, #1: 1	أَرَادَ الْمَسْكَنَةَ
u'أَرَادَ مُسْلِمٌ':Subject, #2: 2	أَرَادَ الْمُسْلِمُ
u'أَرَادَ مَسِيرٌ':Predicate, #3: 3	أَرَادَ مُسْلِمٌ
u'أَرَادَ مُشَابَهَةٌ':Predicate, #1: 1	أَرَادَ الْمَسِيرَ
u'أَرَادَ مُشْرِفٌ':Subject, #1: 1	أَرَادَ الْمُشَابَهَةَ
u'أَرَادَ مُشْرِك':Predicate, #1: 1	أَرَادَ الْمُشْرِفُ
u'أَرَادَ مُشْرِك':Subject, #1: 1	أَرَادَ الْمُشْرِكِينَ
u'أَرَادَ مَشْرُوطٌ':Subject, #1: 1	أَرَادَ مُشْرِكٌ
u'أَرَادَ مَشْيٌ':Predicate, #1: 1	أَرَادَ الْمَشْرُوطُ
u'أَرَادَ مَصْدَرٌ':Predicate, #1: 1	أَرَادَ الْمَشْيَ
u'أَرَادَ مُصَنِّفٌ':Subject, #3: 3	أَرَادَ الْمَصْدَرَ
u'أَرَادَ مَصِيرٌ':Predicate, #6: 6	أَرَادَ الْمُصَنِّفُ
u'أَرَادَ مُضَارَبَةٌ':Predicate, #1: 1	أَرَادَ الْمَصِيرَ
u'أَرَادَ مُضْطَرٌّ':Subject, #1: 1	أَرَادَ الْمُضَارَبَةَ
u'أَرَادَ مَضْمُومٌ':Predicate, #1: 1	أَرَادَ الْمُضْطَرُّ
u'أَرَادَ مُطَالَبٌ':Predicate, #1: 1	أَرَادَ الْمَضْمُومَ
u'أَرَادَ مُطَالَبَةٌ':Predicate, #1: 1	أَرَادَ مُطَالَبَةَ
u'أَرَادَ مُطْلَقٌ':Predicate, #1: 1	أَرَادَ مُطَالَبَةَ
u'أَرَادَ مُطْلَقٌ':Predicate, #1: 1	أَرَادَ الْمُطْلَقَ
u'أَرَادَ مَطْلُوبٌ':Subject, #3: 3	أَرَادَ مُطْلَقَ
u'أَرَادَ مُطَهَّرٌ':Predicate, #1: 1	أَرَادَ الْمَطْلُوبُ
u'أَرَادَ مُعَاوَدَةٌ':Predicate, #1: 1	أَرَادَ الْمُطَهَّرِينَ
u'أَرَادَ مُعاوِيَة':Subject, #2: 2	أَرَادَ مُعَاوَدَةَ
u'أَرَادَ مُعْتَرِضٌ':Subject, #1: 1	أَرَادَ مُعَاوِيَةُ
u'أَرَادَ مَعْرِفَةٌ':Predicate, #1: 1	أَرَادَ الْمُعْتَرِضُ
u'أَرَادَ مَعْرِفَة':Predicate, #1: 1	أَرَادَ الْمَعْرِفَةَ
u'أَرَادَ مَعْرِفَةٌ':Predicate, #1: 1	أَرَادَ الْمَعْرِفَةَ
u'أَرَادَ مَعْرِفَة':Predicate, #2: 2	أَرَادَ مَعْرِفَةَ
u'أَرَادَ مُعْظَمٌ':Predicate, #2: 2	أَرَادَ مَعْرِفَةَ
u'أَرَادَ مُعَلِّلٌ':Subject, #1: 1	أَرَادَ مُعْظَمَ
u'أَرَادَ مُعَلِّمٌ':Subject, #1: 1	أَرَادَ الْمُعَلِّلُ
u'أَرَادَ مَعِيٌّ':Predicate, #1: 1	أَرَادَ الْمُعَلِّمُ
u'أَرَادَ مَعِيَّةٌ':Predicate, #4: 4	أَرَادَ الْمَعِيَّةَ
u'أَرَادَ مُعِير':Subject, #4: 4	أَرَادَ الْمَعِيَّةَ
u'أَرَادَ مَغَازِي':Predicate, #2: 2	أَرَادَ الْمُعِيرُ
u'أَرَادَ مَغْفِرَةٌ':Predicate, #1: 1	أَرَادَ الْمَغَازِيَ
u'أَرَادَ مُفَاوِضٌ':Subject, #2: 2	أَرَادَ الْمَغْفِرَةَ
u'أَرَادَ مُفْلِسٌ':Subject, #1: 1	أَرَادَ الْمُفَاوِضُ
u'أَرَادَ مَفْهُومٌ':Predicate, #1: 1	أَرَادَ الْمُفْلِسُ
u'أَرَادَ مُقَاتِلٌ':Subject, #1: 1	أَرَادَ الْمَفْهُومَ
u'أَرَادَ مُقَامٌ':Predicate, #1: 1	أَرَادَ الْمُقَاتِلُ
u'أَرَادَ مِقْدَارٌ':Predicate, #1: 1	أَرَادَ الْمُقَامَ
u'أَرَادَ مَقْذُوفٌ':Subject, #1: 1	أَرَادَ مِقْدَارَ
u'أَرَادَ مُقْرِضٌ':Subject, #3: 3	أَرَادَ الْمَقْذُوفُ
u'أَرَادَ مُقِيمٌ':Subject, #1: 1	أَرَادَ الْمُقْرِضُ
u'أَرَادَ مُكَافَأَةٌ':Predicate, #1: 1	أَرَادَ الْمُقِيمُ
u'أَرَادَ مَكَانٌ':Predicate, #1: 1	أَرَادَ الْمُكَافَأَةَ
u'أَرَادَ مُكَلَّفٌ':Subject, #1: 1	أَرَادَ الْمَكَانَ
u'أَرَادَ مَلأٌ':Predicate, #2: 2	أَرَادَ الْمُكَلَّفُ
u'أَرَادَ مُلْتَقِط':Subject, #1: 1	أَرَادَ الْمَلَأَ
u'أَرَادَ مِلْكٌ':Predicate, #1: 1	أَرَادَ الْمُلْتَقِطُ
u'أَرَادَ مَلَكٌ':Predicate, #1: 1	أَرَادَ الْمِلْكَ
u'أَرَادَ مِلْكٌ':Predicate, #1: 1	أَرَادَ مَلَكَ
u'أَرَادَ مُمَاثَلَةٌ':Predicate, #1: 1	أَرَادَ مِلْكَ
u'أَرَادَ مَنٌّ':Predicate, #3: 3	أَرَادَ الْمُمَاثَلَةَ
u'أَرَادَ مُنْتَقِلٌ':Subject, #1: 1	أَرَادَ الْمَنَّ
u'أَرَادَ مَنْصُورٌ':Subject, #2: 2	أَرَادَ الْمُنْتَقِلُ
u'أَرَادَ مَنْعٌ':Predicate, #1: 1	أَرَادَ الْمَنْصُورُ
u'أَرَادَ مَنْعٌ':Predicate, #2: 2	أَرَادَ الْمَنْعَ
u'أَرَادَ مَنْفَعَةٌ':Predicate, #2: 2	أَرَادَ مَنْعَ
u'أَرَادَ مَوَاضِعُ':Predicate, #1: 1	أَرَادَ الْمَنْفَعَةَ
u'أَرَادَ مُودَعٌ':Subject, #1: 1	أَرَادَ مَوَاضِعَ
u'أَرَادَ مَوْضِعٌ':Predicate, #2: 2	أَرَادَ الْمُودَعُ
u'أَرَادَ مُوَكِّلٌ':Subject, #1: 1	أَرَادَ الْمَوْضِعَ
u'أَرَادَ نَاسٌ':Predicate, #2: 2	أَرَادَ الْمُوَكِّلُ
u'أَرَادَ نَاسٌ':Subject, #1: 1	أَرَادَ النَّاسَ
u'أَرَادَ نَاصِرٌ':Predicate, #1: 1	أَرَادَ نَاسٌ
u'أَرَادَ نَاظِرٌ':Subject, #1: 1	أَرَادَ النَّاصِرَ
u'أَرَادَ نَاقَةٌ':Predicate, #3: 3	أَرَادَ النَّاظِرُ
u'أَرَادَ نَاقَة':Predicate, #1: 1	أَرَادَ النَّاقَةَ
u'أَرَادَ نَبِيٌّ':Subject, #1: 1	أَرَادَ النَّاقَةَ
u'أَرَادَ نِدَاءٌ':Predicate, #17: 17	أَرَادَ النَّبِيُّ
u'أَرَادَ نذر':Predicate, #1: 1	أَرَادَ النِّدَاءَ
u'أَرَادَ نَذْرٌ':Predicate, #5: 5	أَرَادَ النَّذْرَ
u'أَرَادَ نُزُولٌ':Predicate, #5: 5	أَرَادَ النَّذْرَ
u'أَرَادَ نِساءٌ':Subject, #1: 1	أَرَادَ النُّزُولَ
u'أَرَادَ نُسُكٌ':Predicate, #1: 1	أَرَادَ النِّسَاءُ
u'أَرَادَ نصب':Predicate, #3: 3	أَرَادَ النُّسُكَ
u'أَرَادَ نَصْبٌ':Predicate, #2: 2	أَرَادَ نَصْبَ
u'أَرَادَ نِصْفٌ':Predicate, #2: 2	أَرَادَ نَصْبَ
u'أَرَادَ نُطْقٌ':Predicate, #2: 2	أَرَادَ نِصْفَ
u'أَرَادَ نَفَلٌ':Predicate, #1: 1	أَرَادَ النُّطْقَ
u'أَرَادَ نَفْيٌ':Predicate, #1: 1	أَرَادَ النَّفَلَ
u'أَرَادَ نَفْيٌ':Predicate, #1: 1	أَرَادَ النّفْيَ
u'أَرَادَ نقرة':Predicate, #5: 5	أَرَادَ نَفْيَ
u'أَرَادَ نُقْرَةٌ':Predicate, #1: 1	أَرَادَ النُّقْرَةَ
u'أَرَادَ نَقْضٌ':Predicate, #1: 1	أَرَادَ النُّقْرَةَ
u'أَرَادَ نقل':Predicate, #2: 2	أَرَادَ نَقْضَ
u'أَرَادَ نَقْلٌ':Predicate, #1: 1	أَرَادَ النَّقْلَ
u'أَرَادَ نقل':Predicate, #1: 1	أَرَادَ النَّقْلَ
u'أَرَادَ نَقْلٌ':Predicate, #6: 6	أَرَادَ نَقْلَ
u'أَرَادَ نكاح':Predicate, #6: 6	أَرَادَ نَقْلَ
u'أَرَادَ نِكَاحٌ':Predicate, #1: 1	أَرَادَ النِّكَاحَ
u'أَرَادَ نكاح':Predicate, #1: 1	أَرَادَ النِّكَاحَ
u'أَرَادَ نِكَاحٌ':Predicate, #2: 2	أَرَادَ نِكَاحَ
u'أَرَادَ نَهْيٌ':Predicate, #2: 2	أَرَادَ نِكَاحَ
u'أَرَادَ نَوْعِيٌّ':Predicate, #2: 2	أَرَادَ النَّهْيَ
u'أَرَادَ نَوْمٌ':Predicate, #1: 1	أَرَادَ النَّوْعِيَّةَ
u'أَرَادَ نَوَوِيٌّ':Subject, #3: 3	أَرَادَ النَّوْمَ
u'أَرَادَ نِيَّةٌ':Predicate, #1: 1	أَرَادَ النَّوَوِيُّ
u'أَرَادَ نِيَّةٌ':Predicate, #1: 1	أَرَادَ النِّيَّةَ
u'أَرَادَ هِبَةٌ':Predicate, #1: 1	أَرَادَ نِيَّةَ
u'أَرَادَ هجرة':Predicate, #1: 1	أَرَادَ الْهِبَةَ
u'أَرَادَ هِجْرَةٌ':Predicate, #4: 4	أَرَادَ الْهِجْرَةَ
u'أَرَادَ هِدَايَةٌ':Predicate, #4: 4	أَرَادَ الْهِجْرَةَ
u'أَرَادَ هَدْمٌ':Predicate, #1: 1	أَرَادَ هِدَايَةَ
u'أَرَادَ هَدْيٌ':Predicate, #2: 2	أَرَادَ هَدْمَ
u'أَرَادَ وَاجِبٌ':Predicate, #1: 1	أَرَادَ الْهَدْيَ
u'أَرَادَ وَاجِبٌ':Subject, #1: 1	أَرَادَ الْوَاجِبَ
u'أَرَادَ واحد':Predicate, #1: 1	أَرَادَ وَاجِبٌ
u'أَرَادَ وَاحِدٌ':Predicate, #1: 1	أَرَادَ الْوَاحِدَ
u'أَرَادَ واحد':Predicate, #1: 1	أَرَادَ الْوَاحِدَ
u'أَرَادَ وَاحِدٌ':Predicate, #3: 3	أَرَادَ وَاحِدَةً
u'أَرَادَ واحد':Subject, #3: 3	أَرَادَ وَاحِدَةً
u'أَرَادَ وَاحِدٌ':Subject, #8: 8	أَرَادَ وَاحِدٌ
u'أَرَادَ وَارِثٌ':Subject, #8: 8	أَرَادَ وَاحِدٌ
u'أَرَادَ وَارِثٌ':Subject, #1: 1	أَرَادَ وَارِثٌ
u'أَرَادَ وَارِثٌ':Subject, #1: 1	أَرَادَ وَارِثُ
u'أَرَادَ وَاقِفٌ':Subject, #6: 6	أَرَادَ الْوَارِثُ
u'أَرَادَ وَاهِبٌ':Subject, #5: 5	أَرَادَ الْوَاقِفُ
u'أَرَادَ وَتْرٌ':Predicate, #9: 9	أَرَادَ الْوَاهِبُ
u'أَرَادَ وَجْهٌ':Predicate, #1: 1	أَرَادَ الْوَتْرَ
u'أَرَادَ وُجُوبٌ':Predicate, #1: 1	أَرَادَ الْوَجْهَ
u'أَرَادَ وَحْدَةٌ':Predicate, #2: 2	أَرَادَ الْوُجُوبَ
u'أَرَادَ وَرَثَةٌ':Subject, #1: 1	أَرَادَ الْوَحْدَةَ
u'أَرَادَ وَرَثَةٌ':Subject, #1: 1	أَرَادَ وَرَثَتُهُ
u'أَرَادَ وَسْوَسَةٌ':Predicate, #4: 4	أَرَادَ الْوَرَثَةُ
u'أَرَادَ وصال':Predicate, #1: 1	أَرَادَ الْوَسْوَسَةَ
u'أَرَادَ وِصَالٌ':Predicate, #1: 1	أَرَادَ الْوِصَالَ
u'أَرَادَ وَصْفٌ':Predicate, #1: 1	أَرَادَ الْوِصَالَ
u'أَرَادَ وُصُولٌ':Predicate, #2: 2	أَرَادَ وَصْفَ
u'أَرَادَ وَصِيٌّ':Subject, #4: 4	أَرَادَ الْوُصُولَ
u'أَرَادَ وَضْعٌ':Predicate, #4: 4	أَرَادَ الْوَصِيُّ
u'أَرَادَ وَضْعٌ':Predicate, #1: 1	أَرَادَ الْوَضْعَ
u'أَرَادَ وُضُوءٌ':Predicate, #2: 2	أَرَادَ وَضْعَ
u'أَرَادَ وَطْءٌ':Predicate, #3: 3	أَرَادَ الْوُضُوءَ
u'أَرَادَ وَقْتٌ':Predicate, #3: 3	أَرَادَ الْوَطْءَ
u'أَرَادَ وَقْفٌ':Predicate, #1: 1	أَرَادَ وَقْتَ
u'أَرَادَ وُقُوعٌ':Predicate, #2: 2	أَرَادَ الْوَقْفَ
u'أَرَادَ وُقُوفٌ':Predicate, #2: 2	أَرَادَ وُقُوعَ
u'أَرَادَ وَكِيلٌ':Subject, #3: 3	أَرَادَ الْوُقُوفَ
u'أَرَادَ وَكِيلٌ':Subject, #1: 1	أَرَادَ وَكِيلُ
u'أَرَادَ وِلاَيَةٌ':Predicate, #3: 3	أَرَادَ الْوَكِيلُ
u'أَرَادَ ولد':Predicate, #1: 1	أَرَادَ الْوِلَايَةَ
u'أَرَادَ وَلَدٌ':Predicate, #2: 2	أَرَادَ وَلَدَ
u'أَرَادَ ولد':Subject, #2: 2	أَرَادَ وَلَدَ
u'أَرَادَ وَلَدٌ':Subject, #3: 3	أَرَادَ الْوَلَدُ
u'أَرَادَ وَلِيٌّ':Subject, #3: 3	أَرَادَ الْوَلَدُ
u'أَرَادَ وَلِيٌّ':Subject, #2: 2	أَرَادَ وَلِيُّهُ
u'أَرَادَ وَلِيٌّ':Subject, #3: 3	أَرَادَ الْوَلِيُّ
u'أَرَادَ يَدٌ':Predicate, #6: 6	أَرَادَ وَلِيُّ
u'أَرَادَ يَمِينٌ':Predicate, #2: 2	أَرَادَ يَدَ
u'أَرَاقَ خَمْرٌ':Predicate, #7: 7	أَرَادَ الْيَمِينَ
u'أَرَاقَ خَمْرٌ':Predicate, #1: 1	أَرَاقَ الْخَمْرَ
u'أَرَاقَ خُمُورٌ':Predicate, #1: 1	أَرَاقَ خَمْرَ
u'أَرَاقَ دَمٌ':Predicate, #3: 3	أَرَاقَ خُمُورَ
u'أَرَاقَ زَيْتٌ':Predicate, #1: 1	أَرَاقَ دَمَ
u'أَرَاقَ سُؤْرٌ':Predicate, #1: 1	أَرَاقَ زَيْتَ
u'أَرَاقَ لبن':Predicate, #1: 1	أَرَاقَ سُؤْرَ
u'أَرَاقَ لَبَنٌ':Predicate, #1: 1	أَرَاقَ اللَّبَنَ
u'أَرَاقَ مَاءٌ':Predicate, #1: 1	أَرَاقَ اللَّبَنَ
u'أَرَاقَ مَاءٌ':Predicate, #1: 1	أَرَاقَ مَاءَ
u'أَرِبَ رَجُلٌ':Subject, #8: 8	أَرَاقَ الْمَاءَ
u'أَرْجاءُ هُوَّةٌ':Added, #1: 1	أَرِبَ الرَّجُلُ
u'أَرْجَاءٌ هُوَّةٌ':Added, #1: 1	أَرْجَاءَ هُوّةٍ
u'أَرْجَعَ رَسُولٌ':Subject, #1: 1	أَرْجَاءَ هُوّةٍ
u'أَرْجَعَ ضَمِيرٌ':Predicate, #1: 1	أَرْجَعَ رَسُولُ
u'أَرْجَعَ ضَمِيرٌ':Predicate, #1: 1	أَرْجَعَ الضَّمِيرَ
u'أَرْجَفَ أهْلٌ':Subject, #1: 1	أَرْجَعَ ضَمِيرَ
u'إِرْخَاءٌ طرف':Added, #1: 1	أَرْجَفَ أَهْلُ
u'إِرْخَاءٌ طَرَفٌ':Added, #1: 1	إِرْخَاءِ طَرَفِ
u'أَرَّخَ شُهُودٌ':Subject, #1: 1	إِرْخَاءِ طَرَفِ
u'أَرَّخَ شُهُودٌ':Subject, #1: 1	أَرَّخَ شُهُودُ
u'أَرَّخَ مَحْكُومٌ':Subject, #1: 1	أَرَّخَ شُهُودُهُ
u'أَرْخَى حجاب':Predicate, #1: 1	أَرَّخَ الْمَحْكُومُ
u'أَرْخَى حِجابٌ':Predicate, #1: 1	أَرْخَى الْحِجَابَ
u'أَرْخَى سِتْرٌ':Predicate, #1: 1	أَرْخَى الْحِجَابَ
u'أَرْخَى لَيْلٌ':Subject, #2: 2	أَرْخَى السِّتْرَ
u'أَرْدَفَ إِثْمٌ':Predicate, #1: 1	أَرْخَى اللَّيْلُ
u'أَرْدَفَ حَجٌّ':Predicate, #1: 1	أَرْدَفَ إثْمَ
u'أَرْدَفَ حَرامٌ':Predicate, #11: 11	أَرْدَفَ الْحَجَّ
u'أَرْدَفَ حَرْفٌ':Predicate, #1: 1	أَرْدَفَ الْحَرَامَ
u'أَرْدَفَ رَجُلٌ':Predicate, #1: 1	أَرْدَفَ حَرْفَ
u'أَرْدَفَ رَسُولٌ':Subject, #1: 1	أَرْدَفَ رَجُلاً
u'أَرْدَفَ فَضْلٌ':Predicate, #1: 1	أَرْدَفَ رَسُولُ
u'أَرْدَفَ فَضْلٌ':Subject, #8: 8	أَرْدَفَ الْفَضْلَ
u'أَرْدَفَ قلب':Predicate, #1: 1	أَرْدَفَ الْفَضْلُ
u'أَرْدَفَ مَالِكٌ':Subject, #1: 1	أَرْدَفَ قَلَبَ
u'أَرْدَفَ نَبِيٌّ':Subject, #2: 2	أَرْدَفَ الْمَالِكُ
u'إِرْسَالٌ رُسُلٌ':Added, #1: 1	أَرْدَفَ النَّبِيُّ
u'إِرْسَالٌ رَسُولٌ':Added, #1: 1	إِرْسَالِ الرُّسُلِ
u'إِرْسَالٌ شِعْرٌ':Added, #1: 1	إِرْسَالُ رَسُولِ
u'إِرْسَالٌ غير':Added, #1: 1	إِرْسَالِ الشِّعْرِ
u'إِرْسَالٌ غَيْرٌ':Added, #1: 1	إِرْسَالُ غَيْرِهِ
u'إِرْسَالٌ قطر':Added, #1: 1	إِرْسَالُ غَيْرِهِ
u'إِرْسَالٌ قَطْرٌ':Added, #1: 1	إِرْسَالِ الْقَطْرِ
u'إِرْسَالٌ كَلْبٌ':Added, #1: 1	إِرْسَالِ الْقَطْرِ
u'إِرْسَالٌ ولائد':Added, #1: 1	إِرْسَالِ الْكَلْبِ
u'أَرْسَلَ أَبٌ':Subject, #1: 1	إِرْسَالِ الْوَلاَئِدِ
u'أَرْسَلَ اِبْنٌ':Predicate, #1: 1	أَرْسَلَ الْأَبُ
u'أَرْسَلَ اِبْنٌ':Subject, #1: 1	أَرْسَلَ ابْنَ
u'أَرْسَلَ أَزْواجٌ':Subject, #4: 4	أَرْسَلَ ابْنُ
u'أَرْسَلَ أسْوَد':Subject, #3: 3	أَرْسَلَ أَزْوَاجُ
u'أَرْسَلَ أَقْوَامٌ':Subject, #1: 1	أَرْسَلَ الأَسْوَدُ
u'أَرْسَلَ أُمٌّ':Predicate, #1: 1	أَرْسَلَ الْأَقْوَامُ
u'أَرْسَلَ إمَامٌ':Subject, #2: 2	أَرْسَلَ أُمَّ
u'أَرْسَلَ أمراء':Subject, #1: 1	أَرْسَلَ الْإِمَامُ
u'أَرْسَلَ أَميرٌ':Subject, #1: 1	أَرْسَلَ أُمَرَاءُ
u'أَرْسَلَ أَميرٌ':Subject, #1: 1	أَرْسَلَ الْأَمِيرُ
u'أَرْسَلَ إِنْسانٌ':Subject, #1: 1	أَرْسَلَ أَمِيرُ
u'أَرْسَلَ أيَّامٌ':Predicate, #2: 2	أَرْسَلَ إنْسَانٌ
u'أَرْسَلَ أَيَّامٌ':Predicate, #1: 1	أَرْسَلَ أَيَّامَ
u'أَرْسَلَ بَدَلٌ':Predicate, #1: 1	أَرْسَلَ أَيَّامَ
u'أَرْسَلَ بُسْرٌ':Predicate, #1: 1	أَرْسَلَ الْبَدَلَ
u'أَرْسَلَ بَهيمٌ':Predicate, #1: 1	أَرْسَلَ بُسْرَ
u'أَرْسَلَ بَهِيمَةٌ':Predicate, #1: 1	أَرْسَلَ الْبَهِيمَةَ
u'أَرْسَلَ تَفْوِيضٌ':Predicate, #1: 1	أَرْسَلَ الْبَهِيمَةَ
u'أَرْسَلَ ثَلاثُ':Predicate, #2: 2	أَرْسَلَ التَّفْوِيضَ
u'أَرْسَلَ ثَلاثَةٌ':Predicate, #2: 2	أَرْسَلَ الثَّلَاثَ
u'أَرْسَلَ جَارِي':Predicate, #1: 1	أَرْسَلَ ثَلَاثَةَ
u'أَرْسَلَ جَارِيَةٌ':Predicate, #1: 1	أَرْسَلَ جَارِيَةَ
u'أَرْسَلَ جَمَاعَةٌ':Subject, #1: 1	أَرْسَلَ جَارِيَةَ
u'أَرْسَلَ جَمْعٌ':Subject, #1: 1	أَرْسَلَ جَمَاعَةٌ
u'أَرْسَلَ حَديثٌ':Predicate, #1: 1	أَرْسَلَ جَمْعٌ
u'أَرْسَلَ حَكَمٌ':Subject, #1: 1	أَرْسَلَ الْحَدِيثَ
u'أَرْسَلَ حَلالٌ':Subject, #1: 1	أَرْسَلَ الْحَكَمُ
u'أَرْسَلَ حَلالٌ':Subject, #1: 1	أَرْسَلَ حَلَالٌ
u'أَرْسَلَ دَابَّةٌ':Predicate, #2: 2	أَرْسَلَ الْحَلَالُ
u'أَرْسَلَ رَجُلٌ':Subject, #1: 1	أَرْسَلَ الدَّابَّةَ
u'أَرْسَلَ رَسُولٌ':Predicate, #1: 1	أَرْسَلَ رَجُلٌ
u'أَرْسَلَ رَسُولٌ':Subject, #1: 1	أَرْسَلَ الرَّسُولَ
u'أَرْسَلَ رِياحٌ':Predicate, #11: 11	أَرْسَلَ رَسُولُ
u'أَرْسَلَ سَعِيدٌ':Subject, #1: 1	أَرْسَلَ الرِّيَاحَ
u'أَرْسَلَ سُلْطَانٌ':Subject, #2: 2	أَرْسَلَ سَعِيدُ
u'أَرْسَلَ سَهْمٌ':Predicate, #1: 1	أَرْسَلَ السُّلْطَانُ
u'أَرْسَلَ صَاحِبٌ':Subject, #1: 1	أَرْسَلَ السَّهْمَ
u'أَرْسَلَ صَائِدٌ':Subject, #1: 1	أَرْسَلَ صَاحِبُ
u'أَرْسَلَ صَوْبٌ':Predicate, #1: 1	أَرْسَلَ الصَّائِدُ
u'أَرْسَلَ صَيْدٌ':Predicate, #1: 1	أَرْسَلَ صَوْبَ
u'أَرْسَلَ طَلاَقٌ':Predicate, #2: 2	أَرْسَلَ الصَّيْدَ
u'أَرْسَلَ عَامِلٌ':Predicate, #1: 1	أَرْسَلَ الطَّلَاقَ
u'أَرْسَلَ عَبَّاسٌ':Subject, #1: 1	أَرْسَلَ الْعَامِلَ
u'أَرْسَلَ عَبْدٌ':Predicate, #1: 1	أَرْسَلَ الْعَبَّاسُ
u'أَرْسَلَ عَبْدٌ':Subject, #1: 1	أَرْسَلَ الْعَبْدَ
u'أَرْسَلَ عتق':Predicate, #1: 1	أَرْسَلَ عَبْدُ
u'أَرْسَلَ عِتْقٌ':Predicate, #1: 1	أَرْسَلَ الْعِتْقَ
u'أَرْسَلَ عُمَرٌ':Subject, #1: 1	أَرْسَلَ الْعِتْقَ
u'أَرْسَلَ فلان':Predicate, #3: 3	أَرْسَلَ عُمَرُ
u'أَرْسَلَ فلان':Subject, #1: 1	أَرْسَلَ عُثْمَانَ
u'أَرْسَلَ فلان':Subject, #1: 1	أَرْسَلَ النَّجَاشِيُّ
u'أَرْسَلَ فلان':Subject, #1: 1	أَرْسَلَ عُثْمَانُ
u'أَرْسَلَ فلان':Subject, #1: 1	أَرْسَلَ قَيْسٌ
u'أَرْسَلَ قَيْس':Subject, #1: 1	أَرْسَلَ مُعَاوِيَةُ
u'أَرْسَلَ كِتَابٌ':Predicate, #1: 1	أَرْسَلَ قَيْسٌ
u'أَرْسَلَ كِتَابَةٌ':Predicate, #1: 1	أَرْسَلَ الْكِتَابَ
u'أَرْسَلَ كَلاَمٌ':Predicate, #1: 1	أَرْسَلَ الْكِتَابَةَ
u'أَرْسَلَ كَلْبٌ':Predicate, #1: 1	أَرْسَلَ الْكَلَامَ
u'أَرْسَلَ مَاءٌ':Predicate, #2: 2	أَرْسَلَ الْكَلْبَ
u'أَرْسَلَ مَجُوسِيٌّ':Subject, #3: 3	أَرْسَلَ الْمَاءَ
u'أَرْسَلَ مُحْرِمٌ':Subject, #2: 2	أَرْسَلَ الْمَجُوسِيُّ
u'أَرْسَلَ مُسْتَأْجِرٌ':Predicate, #2: 2	أَرْسَلَ مُحْرِمٌ
u'أَرْسَلَ مُسْلِمٌ':Subject, #1: 1	أَرْسَلَ الْمُسْتَأْجِرَ
u'أَرْسَلَ مُسْلِمٌ':Subject, #5: 5	أَرْسَلَ مُسْلِمٌ
u'أَرْسَلَ مُعاوِيَة':Subject, #7: 7	أَرْسَلَ الْمُسْلِمُ
u'أَرْسَلَ مَلَكٌ':Predicate, #1: 1	أَرْسَلَ مُعَاوِيَةُ
u'أَرْسَلَ نَبِيٌّ':Subject, #1: 1	أَرْسَلَ الْمَلَكَ
u'أَرْسَلَ نَجاشِيّ':Subject, #3: 3	أَرْسَلَ النَّبِيُّ
u'أَرْسَلَ نذر':Predicate, #1: 1	أَرْسَلَ النَّجَاشِيُّ
u'أَرْسَلَ نَذْرٌ':Predicate, #2: 2	أَرْسَلَ النَّذْرَ
u'أَرْسَلَ نَصْرَانِيٌّ':Subject, #2: 2	أَرْسَلَ النَّذْرَ
u'أَرْسَلَ وَتَرٌ':Predicate, #1: 1	أَرْسَلَ النَّصْرَانِيُّ
u'أَرْسَلَ وَكِيلٌ':Subject, #1: 1	أَرْسَلَ وَتَرَكَ
u'أَرْسَلَ ولد':Predicate, #1: 1	أَرْسَلَ الْوَكِيلُ
u'أَرْسَلَ وَلَدٌ':Predicate, #1: 1	أَرْسَلَ الْوَلَدَ
u'أَرْشَدَ شَيْخٌ':Subject, #1: 1	أَرْسَلَ الْوَلَدَ
u'أَرْضَعَ خامس':Predicate, #1: 1	أَرْشَدَ الشَّيْخُ
u'أَرْضَعَ خَامِسٌ':Predicate, #1: 1	أَرْضَعَ الْخَامِسَةَ
u'أَرْضَعَ خَمْسٌ':Subject, #1: 1	أَرْضَعَ الْخَامِسَةَ
u'أَرْضَى جَازٌ':Predicate, #1: 1	أَرْضَعَ خَمْسُ
u'أَرْغَمَ أَنْفٌ':Predicate, #2: 2	أَرْضَى جَازَ
u'أَرِقَ لَيْلٌ':Predicate, #1: 1	أَرْغَمَ أَنْفَ
u'أَرْكَبَ صَغِيرٌ':Predicate, #1: 1	أَرِقَ لَيْلَةً
u'أَرْكَبَ قَدْرٌ':Predicate, #2: 2	أَرْكَبَ الصَّغِيرَ
u'أَرْهَبَ عُمَرٌ':Subject, #1: 1	أَرْكَبَ قَدْرَ
u'أَرْوَى بِنْتٌ':Predicate, #1: 1	أَرْهَبَ عُمَرُ
u'أَرْوَى بِنْتٌ':Subject, #1: 1	أَرْوَى بِنْتَ
u'أَرْوَى عَمَّةٌ':Subject, #2: 2	أَرْوَى بِنْتُ
u'أَرَى اِبْنٌ':Predicate, #1: 1	أَرْوَى عَمّةُ
u'أَرَى أَبْوَابٌ':Predicate, #2: 2	أَرَى ابْنَ
u'أَرَى أثَرٌ':Predicate, #1: 1	أَرَى الْأَبْوَابَ
u'أَرَى أَجْسَامٌ':Predicate, #1: 1	أَرَى أَثَرَ
u'أَرَى أخْبَارٌ':Predicate, #1: 1	أَرَى أَجْسَامَ
u'أَرَى أَخْبَارٌ':Predicate, #1: 1	أَرَى الْأَخْبَارَ
u'أَرَى اِخْتِيَارٌ':Predicate, #1: 1	أَرَى الْأَخْبَارَ
u'أَرَى أخْذٌ':Predicate, #1: 1	أَرَى اخْتِيَارَ
u'أَرَى أَسْرَعُ':Predicate, #1: 1	أَرَى الْأَخْذَ
u'أَرَى إِسْقاطٌ':Predicate, #1: 1	أَرَى أَسْرَعَ
u'أَرَى إعْلاَمٌ':Predicate, #1: 1	أَرَى إسْقَاطَ
u'أَرَى إمَامٌ':Predicate, #1: 1	أَرَى الْإِعْلَامَ
u'أَرَى أُمَّةٌ':Predicate, #2: 2	أَرَى الإِمَامَ
u'أَرَى أَمْرٌ':Predicate, #1: 1	أَرَى أُمّةَ
u'أَرَى أَمْرٌ':Predicate, #1: 1	أَرَى الْأَمْرَ
u'أَرَى أُمُورٌ':Predicate, #2: 2	أَرَى أَمْرَ
u'أَرَى أَميرٌ':Predicate, #1: 1	أَرَى الْأُمُورَ
u'أَرَى إِنْسانٌ':Predicate, #1: 1	أَرَى أَمِيرَ
u'أَرَى أَوْلاَدٌ':Predicate, #1: 1	أَرَى الْإِنْسَانَ
u'أَرَى بَعْضٌ':Predicate, #1: 1	أَرَى أَوْلاَدَ
u'أَرَى بَيَاضٌ':Predicate, #1: 1	أَرَى بَعْضَ
u'أَرَى بَيْعٌ':Predicate, #2: 2	أَرَى بَيَاضَ
u'أَرَى بَيْعٌ':Predicate, #1: 1	أَرَى بَيْعَ
u'أَرَى تَأَخُّرٌ':Predicate, #2: 2	أَرَى بَيْعَهُنَّ
u'أَرَى تَرْكٌ':Predicate, #1: 1	أَرَى التَّأَخُّرَ
u'أَرَى تَفْتِيشٌ':Predicate, #1: 1	أَرَى تَرْكَ
u'أَرَى تَقْديمٌ':Predicate, #1: 1	أَرَى التَّفْتِيشَ
u'أَرَى جِسْمٌ':Predicate, #1: 1	أَرَى تَقْدِيمَ
u'أَرَى جَهْدٌ':Predicate, #1: 1	أَرَى جِسْمَكَ
u'أَرَى جَوَازٌ':Predicate, #2: 2	أَرَى الْجَهْدَ
u'أَرَى حَجٌّ':Predicate, #1: 1	أَرَى جَوَازَ
u'أَرَى حَلْقٌ':Predicate, #1: 1	أَرَى الْحَجَّ
u'أَرَى حِلْمٌ':Predicate, #1: 1	أَرَى الْحَلْقَ
u'أَرَى خدم':Predicate, #2: 2	أَرَى الْحِلْمَ
u'أَرَى خَدَمٌ':Predicate, #1: 1	أَرَى خَدَمَ
u'أَرَى خِصَالٌ':Predicate, #1: 1	أَرَى خَدَمَ
u'أَرَى خَلَلٌ':Predicate, #1: 1	أَرَى الْخِصَالَ
u'أَرَى خَيْرٌ':Predicate, #1: 1	أَرَى خَلَلَ
u'أَرَى دَمٌ':Predicate, #1: 1	أَرَى خَيْرَ
u'أَرَى دَهْرٌ':Predicate, #1: 1	أَرَى الدَّمَ
u'أَرَى دَهْرٌ':Predicate, #1: 1	أَرَى الدّهْرَ
u'أَرَى دِيَارٌ':Predicate, #3: 3	أَرَى الدَّهْرَ
u'أَرَى ذكر':Predicate, #2: 2	أَرَى الدِّيَارَ
u'أَرَى رَاحِلٌ':Predicate, #1: 1	أَرَى ذُكِرَ
u'أَرَى رَاحِلَةٌ':Predicate, #1: 1	أَرَى رَاحِلَتَكَ
u'أَرَى رَبِيعَةٌ':Predicate, #1: 1	أَرَى رَاحِلَتَكَ
u'أَرَى رَجُلٌ':Predicate, #1: 1	أَرَى رَبِيعَةَ
u'أَرَى رَجُلٌ':Predicate, #1: 1	أَرَى الرَّجُلَ
u'أَرَى رَدٌّ':Predicate, #2: 2	أَرَى رَجُلاً
u'أَرَى رَسُولٌ':Predicate, #1: 1	أَرَى رَدَّ
u'أَرَى رِوايَةٌ':Predicate, #11: 11	أَرَى رَسُولَ
u'أَرَى سَبْعٌ':Predicate, #1: 1	أَرَى رِوَايَةَ
u'أَرَى سَعَادَةٌ':Predicate, #1: 1	أَرَى سَبْعَ
u'أَرَى سعر':Predicate, #1: 1	أَرَى السَّعَادَةَ
u'أَرَى سِعْرٌ':Predicate, #1: 1	أَرَى سِعْرَ
u'أَرَى سقط':Predicate, #1: 1	أَرَى سِعْرَ
u'أَرَى سِقْطٌ':Predicate, #1: 1	أَرَى السِّقْطَ
u'أَرَى سَلَمٌ':Predicate, #1: 1	أَرَى السِّقْطَ
u'أَرَى سلمة':Predicate, #2: 2	أَرَى السَّلَمَ
u'أَرَى سُيوفٌ':Predicate, #1: 1	أَرَى سَلَمَةَ
u'أَرَى شفق':Predicate, #2: 2	أَرَى السّيُوفَ
u'أَرَى شَفَقٌ':Predicate, #1: 1	أَرَى الشَّفَقَ
u'أَرَى شَكٌّ':Predicate, #1: 1	أَرَى الشَّفَقَ
u'أَرَى شمس':Predicate, #1: 1	أَرَى شَكَّ
u'أَرَى شَمْسٌ':Predicate, #1: 1	أَرَى الشَّمْسَ
u'أَرَى شَهَادَةٌ':Predicate, #1: 1	أَرَى الشَّمْسَ
u'أَرَى شَيْطَانٌ':Predicate, #1: 1	أَرَى شَهَادَتَكَ
u'أَرَى شَيْطَانٌ':Predicate, #1: 1	أَرَى الشَّيْطَانَ
u'أَرَى صَاحِبٌ':Predicate, #1: 1	أَرَى شَيْطَانَكَ
u'أَرَى صَفِيٌّ':Predicate, #1: 1	أَرَى صَاحِبَ
u'أَرَى صَلاَةٌ':Predicate, #1: 1	أَرَى صَفِيَّةَ
u'أَرَى صَوَابٌ':Predicate, #1: 1	أَرَى الصَّلَاةَ
u'أَرَى طَرِيقٌ':Predicate, #1: 1	أَرَى الصَّوَابَ
u'أَرَى طَلْحٌ':Predicate, #1: 1	أَرَى الطَّرِيقَ
u'أَرَى طلحة':Predicate, #2: 2	أَرَى طَلْحَةَ
u'أَرَى عُصْفُر':Predicate, #2: 2	أَرَى طَلْحَةَ
u'أَرَى علماء':Predicate, #1: 1	أَرَى الْعُصْفُرَ
u'أَرَى عُلَمَاءُ':Predicate, #1: 1	أَرَى الْعُلَمَاءَ
u'أَرَى عَوان':Predicate, #1: 1	أَرَى الْعُلَمَاءَ
u'أَرَى غير':Predicate, #2: 2	أَرَى الْعَوَانَ
u'أَرَى غَيْرٌ':Predicate, #5: 5	أَرَى غَيْرَ
u'أَرَى فقهاء':Predicate, #5: 5	أَرَى غَيْرَ
u'أَرَى فُلاَنٌ':Predicate, #1: 1	أَرَى الْفُقَهَاءَ
u'أَرَى قاف':Predicate, #1: 1	أَرَى فُلَانَةَ
u'أَرَى قَالٌ':Predicate, #4: 4	أَرَى الْقَافَةَ
u'أَرَى قتل':Predicate, #1: 1	أَرَى قَالَ
u'أَرَى قَتْلٌ':Predicate, #2: 2	أَرَى قَتْلَ
u'أَرَى قُرْعَةٌ':Predicate, #2: 2	أَرَى قَتْلَ
u'أَرَى قسمة':Predicate, #2: 2	أَرَى الْقُرْعَةَ
u'أَرَى قِسْمَةٌ':Predicate, #1: 1	أَرَى قِسْمَةَ
u'أَرَى قول':Predicate, #1: 1	أَرَى قِسْمَةَ
u'أَرَى قَوْلٌ':Predicate, #1: 1	أَرَى قَوْلَ
u'أَرَى قَوْمٌ':Predicate, #1: 1	أَرَى قَوْلَ
u'أَرَى قَوْمٌ':Predicate, #1: 1	أَرَى قَوْمَكَ
u'أَرَى كَرَاهَةٌ':Predicate, #2: 2	أَرَى الْقَوْمَ
u'أَرَى كَرَاهِيَةٌ':Predicate, #1: 1	أَرَى الْكَرَاهَةَ
u'أَرَى لَيْلٌ':Predicate, #1: 1	أَرَى الْكَرَاهِيَةَ
u'أَرَى مثل':Predicate, #1: 1	أَرَى اللَّيْلَةَ
u'أَرَى مِثْلٌ':Predicate, #2: 2	أَرَى مِثْلَ
u'أَرَى مَحْشُوّ':Predicate, #2: 2	أَرَى مِثْلَ
u'أَرَى مُخَالِفٌ':Predicate, #1: 1	أَرَى مَحْشُوَّ
u'أَرَى مَدْفُونٌ':Predicate, #2: 2	أَرَى الْمُخَالِفِينَ
u'أَرَى مَسْأَلَةٌ':Predicate, #1: 1	أَرَى الْمَدْفُونَ
u'أَرَى مُؤَامَرَةٌ':Predicate, #1: 1	أَرَى الْمَسْأَلَةَ
u'أَرَى مَوْتٌ':Predicate, #1: 1	أَرَى مُؤَامَرَتَكَ
u'أَرَى مَوْصُولٌ':Predicate, #4: 4	أَرَى الْمَوْتَ
u'أَرَى ميل':Predicate, #1: 1	أَرَى الْمَوْصُولَ
u'أَرَى مِيلٌ':Predicate, #1: 1	أَرَى الْمِيلَ
u'أَرَى نَاسٌ':Predicate, #1: 1	أَرَى الْمِيلَ
u'أَرَى نَبِيٌّ':Predicate, #6: 6	أَرَى النَّاسَ
u'أَرَى نِساءٌ':Predicate, #1: 1	أَرَى النَّبِيَّ
u'أَرَى نَوَاصِي':Predicate, #4: 4	أَرَى النِّسَاءَ
u'أَرَى هَجِينٌ':Predicate, #1: 1	أَرَى نَوَاصِيَ
u'أَرَى هُدْهُدٌ':Predicate, #1: 1	أَرَى الْهَجِينَ
u'أَرَى هَدِيٌّ':Predicate, #3: 3	أَرَى الْهُدْهُدَ
u'أَرَى هَدِيَّةٌ':Predicate, #3: 3	أَرَى الْهَدِيَّةَ
u'أَرَى وَجْهٌ':Predicate, #3: 3	أَرَى الْهَدِيَّةَ
u'أَرَى يَوْمٌ':Predicate, #1: 1	أَرَى وَجْهَ
u'أَزَالَ أثَرٌ':Predicate, #1: 1	أَرَى الْيَوْمَ
u'أَزَالَ أحَدٌ':Predicate, #1: 1	أَزَالَ أَثَرَ
u'أَزَالَ إِشْكالٌ':Predicate, #1: 1	أَزَالَ أَحَدَ
u'أَزَالَ آلةٌ':Predicate, #1: 1	أَزَالَ الْإِشْكَالَ
u'أَزَالَ ألَمٌ':Subject, #1: 1	أَزَالَ الْآلَةَ
u'أَزَالَ اِمْتِناعٌ':Predicate, #1: 1	أَزَالَ أَلَمُ
u'أَزَالَ أَمْنٌ':Predicate, #1: 1	أَزَالَ امْتِنَاعَ
u'أَزَالَ بَابٌ':Predicate, #1: 1	أَزَالَ الْأَمْنَ
u'أَزَالَ بَكارَةٌ':Predicate, #1: 1	أَزَالَ بَابَ
u'أَزَالَ بَكارَةٌ':Predicate, #1: 1	أَزَالَ الْبَكَارَةَ
u'إِزَالَةٌ بِدَعٌ':Added, #5: 5	أَزَالَ بَكَارَةَ
u'إِزَالَةٌ نَجَاسَةٌ':Added, #1: 1	إِزَالَةَ بِدَعِ
u'أَزَالَ تَعَدِّي':Predicate, #1: 1	إِزَالَةِ النَّجَاسَاتِ
u'أَزَالَ ثَلاثُ':Predicate, #8: 8	أَزَالَ التَّعَدِّيَ
u'أَزَالَ جَمَالٌ':Predicate, #2: 2	أَزَالَ ثَلَاثَ
u'أَزَالَ حائِطٌ':Predicate, #1: 1	أَزَالَ الْجَمَالَ
u'أَزَالَ حجاب':Predicate, #1: 1	أَزَالَ الْحَائِطَ
u'أَزَالَ حِجابٌ':Predicate, #1: 1	أَزَالَ الْحِجَابَ
u'أَزَالَ حِرْزٌ':Predicate, #1: 1	أَزَالَ الْحِجَابَ
u'أَزَالَ حِفْظٌ':Predicate, #1: 1	أَزَالَ الْحِرْزَ
u'أَزَالَ حُكْمٌ':Predicate, #2: 2	أَزَالَ حِفْظَ
u'أَزَالَ حُكْمٌ':Predicate, #1: 1	أَزَالَ الْحُكْمَ
u'أَزَالَ دَمٌ':Predicate, #1: 1	أَزَالَ حُكْمَ
u'أَزَالَ رَهْنٌ':Predicate, #1: 1	أَزَالَ الدَّمَ
u'أَزَالَ ريحٌ':Predicate, #1: 1	أَزَالَ الرَّهْنَ
u'أَزَالَ سَاتِرٌ':Predicate, #1: 1	أَزَالَ الرِّيحَ
u'أَزَالَ سَلاَمَةٌ':Predicate, #1: 1	أَزَالَ السَّاتِرَ
u'أَزَالَ شُبْهَةٌ':Predicate, #1: 1	أَزَالَ سَلَامَةَ
u'أَزَالَ شَعْرٌ':Predicate, #1: 1	أَزَالَ الشُّبْهَةَ
u'أَزَالَ شَعْرٌ':Predicate, #1: 1	أَزَالَ شَعْرَةً
u'أَزَالَ شُكُوكٌ':Predicate, #5: 5	أَزَالَ شَعْرَ
u'أَزَالَ ضَرَرٌ':Predicate, #1: 1	أَزَالَ الشُّكُوكَ
u'أَزَالَ طَهُور':Predicate, #1: 1	أَزَالَ الضَّرَرَ
u'أَزَالَ ظَنٌّ':Predicate, #1: 1	أَزَالَ الطَّهُورِيَّةَ
u'أَزَالَ عين':Predicate, #1: 1	أَزَالَ ظَنَّ
u'أَزَالَ عَيْنٌ':Predicate, #2: 2	أَزَالَ الْعَيْنَ
u'أَزَالَ عَيْن':Predicate, #2: 2	أَزَالَ الْعَيْنَ
u'أَزَالَ غَاصِبٌ':Subject, #2: 2	أَزَالَ الْعَيْنَ
u'أَزَالَ قَبْضٌ':Predicate, #1: 1	أَزَالَ غَاصِبٌ
u'أَزَالَ قَذَرٌ':Predicate, #1: 1	أَزَالَ الْقَبْضَ
u'أَزَالَ قِسْطٌ':Predicate, #1: 1	أَزَالَ الْقَذَرَ
u'أَزَالَ قول':Predicate, #1: 1	أَزَالَ الْقِسْطَ
u'أَزَالَ قَوْلٌ':Predicate, #1: 1	أَزَالَ الْقَوْلَ
u'أَزَالَ لبس':Predicate, #1: 1	أَزَالَ الْقَوْلَ
u'أَزَالَ لَبْسٌ':Predicate, #1: 1	أَزَالَ اللَّبْسَ
u'أَزَالَ لَوْنٌ':Predicate, #1: 1	أَزَالَ اللَّبْسَ
u'أَزَالَ مَبِيعٌ':Predicate, #1: 1	أَزَالَ لَوْنَ
u'أَزَالَ مُحَابَاةٌ':Predicate, #2: 2	أَزَالَ الْمَبِيعَ
u'أَزَالَ مِلْكٌ':Predicate, #3: 3	أَزَالَ الْمُحَابَاةَ
u'أَزَالَ مِلْكٌ':Predicate, #2: 2	أَزَالَ مِلْكَ
u'أَزَالَ مُؤَجِّرٌ':Subject, #3: 3	أَزَالَ الْمِلْكَ
u'أَزَالَ نَجَاسَةٌ':Predicate, #1: 1	أَزَالَ الْمُؤَجِّرُ
u'أَزَالَ نُطْقٌ':Predicate, #2: 2	أَزَالَ النَّجَاسَةَ
u'أَزَالَ نُقْصَانٌ':Predicate, #1: 1	أَزَالَ النُّطْقَ
u'أَزَالَ ورق':Predicate, #1: 1	أَزَالَ النُّقْصَانَ
u'أَزَالَ وَرَقٌ':Predicate, #1: 1	أَزَالَ وَرَقَ
u'أَزَالَ وَصْفٌ':Predicate, #1: 1	أَزَالَ وَرَقَ
u'أَزَالَ وِلاَيَةٌ':Predicate, #1: 1	أَزَالَ الْوَصْفَ
u'أَزَالَ وَلِيٌّ':Subject, #1: 1	أَزَالَ الْوِلَايَةَ
u'أَزَالَ يَدٌ':Predicate, #1: 1	أَزَالَ الْوَلِيُّ
u'أَزْحَفَ عَلِيٌّ':Predicate, #1: 1	أَزَالَ يَدَ
u'آزَرَ حيطانٌ':Predicate, #1: 1	أَزْحَفَ عَلِيَّ
u'أَزْعَجَ مَالِكٌ':Predicate, #1: 1	آزَرَ حِيطَانَ
u'أَزْكَى عند':Predicate, #1: 1	أَزْعَجَ الْمَالِكَ
u'أَزْمَنَ صَيْدٌ':Subject, #9: 9	أَزْكَى عِنْدَ
u'أَزْمَنَ عَبْدٌ':Subject, #1: 1	أَزْمَنَ صَيْدٌ
u'أَزْهَرَ قَالٌ':Predicate, #1: 1	أَزْمَنَ عَبْدٌ
u'أَزْهَقَ سَائِرٌ':Predicate, #8: 8	أَزْهَرَ قَالَ
u'أَزْهَى بَطَلٌ':Predicate, #1: 1	أَزْهَقَ سَائِرَ
u'أَزْهَى حائِطٌ':Subject, #1: 1	أَزْهَى بَطَلَ
u'أَزْهَى نَخْلٌ':Subject, #2: 2	أَزْهَى حَائِطُهُ
u'أَسَاءَ اِبْنٌ':Subject, #1: 1	أَزْهَى النَّخْلُ
u'أَسَاءَ أَجِيرٌ':Subject, #1: 1	أَسَاءَ ابْنُ
u'أَسَاءَ أدَب':Predicate, #1: 1	أَسَاءَ الْأَجِيرُ
u'أَسَاءَ إمَامٌ':Subject, #6: 6	أَسَاءَ الْأَدَبَ
u'أَسَاءَ زَوْجٌ':Subject, #1: 1	أَسَاءَ الْإِمَامُ
u'أَسَاءَ صَلاَةٌ':Predicate, #1: 1	أَسَاءَ الزَّوْجُ
u'أَسَاءَ ظَنٌّ':Predicate, #1: 1	أَسَاءَ الصَّلاَةَ
u'أَسَاءَ عَبْدٌ':Subject, #1: 1	أَسَاءَ الظَّنَّ
u'أَسَاءَ عَمَلٌ':Predicate, #1: 1	أَسَاءَ عَبْدُهُ
u'أَسَاءَ نَظَرٌ':Predicate, #1: 1	أَسَاءَ الْعَمَلَ
u'أَسَاءَ وَتَرٌ':Predicate, #1: 1	أَسَاءَ النَّظَرَ
u'إِسْبَاغٌ وُضُوءٌ':Added, #1: 1	أَسَاءَ وَتَرَكَ
u'إِسْبَاغٌ وُضُوءٌ':Added, #2: 2	إِسْبَاغِ الْوُضُوءِ
u'أَسْبَغَ وُضُوءٌ':Predicate, #7: 7	إِسْبَاغُ الْوُضُوءِ
u'أَسْبَلَ زَرْعٌ':Subject, #1: 1	أَسْبَغَ الْوُضُوءَ
u'اسْتَبْطَأَ نَاسٌ':Predicate, #1: 1	أَسْبَلَ الزّرْعُ
u'أَسْدَى اِبْنٌ':Subject, #1: 1	اسْتَبْطَأَ النّاسَ
u'أَسَرَّ أحَدٌ':Subject, #1: 1	أَسْدَى ابْنُ
u'أَسَرَ أَصْحَابٌ':Subject, #1: 1	أَسَرَّ أَحَدٌ
u'أَسْرٌ أَقْدَارٌ':Added, #3: 3	أَسَرَ أَصْحَابُ
u'أَسَرَّ إمَامٌ':Subject, #1: 1	أَسْرِ الْأَقْدَارِ
u'أَسَرَ أهْلٌ':Subject, #1: 1	أَسَرَّ الْإِمَامُ
u'أَسَرَّ حَديثٌ':Predicate, #2: 2	أَسَرَ أَهْلُ
u'أَسَرَ رَسُولٌ':Subject, #1: 1	أَسَرَّ الْحَدِيثَ
u'أَسْرٌ رِقٌّ':Added, #1: 1	أَسَرَ رَسُولُ
u'أَسْرٌ شَيْطَانٌ':Added, #2: 2	أَسْرِ الرِّقِّ
u'أَسْرٌ صِغَرٌ':Added, #1: 1	أَسْرِ الشَّيْطَانِ
u'أَسْرَعَ إِجَابَةٌ':Predicate, #1: 1	أَسْرِ الصِّغَرِ
u'أَسْرَعَ أَسْرَعُ':Predicate, #1: 1	أَسْرَعَ الْإِجَابَةَ
u'أَسَرَ عَبَّاسٌ':Predicate, #1: 1	أَسْرَعَ أَسْرَعَ
u'أَسَرَّ عَبْدٌ':Subject, #1: 1	أَسَرَ الْعَبَّاسَ
u'أَسْرَعَ ثَالِثٌ':Subject, #1: 1	أَسَرَّ عَبْدٌ
u'أَسْرَعَ جَازٌ':Predicate, #1: 1	أَسْرَعَ الثَّالِثَةُ
u'أَسَرَ عَدُوٌّ':Subject, #1: 1	أَسْرَعَ جَازَ
u'أَسْرٌ عَدُوٌّ':Added, #4: 4	أَسَرَ الْعَدُوُّ
u'أَسْرٌ عَدُوٌّ':Added, #1: 1	أَسْرِ الْعَدُوِّ
u'أَسْرَعَ سَيْرٌ':Predicate, #1: 1	أَسْرِ عَدُوٍّ
u'أَسَرَ عقبة':Predicate, #1: 1	أَسْرَعَ السَّيْرَ
u'أَسَرَ عُقْبَةٌ':Predicate, #1: 1	أَسَرَ عُقْبَةَ
u'أَسْرَعَ نَاسٌ':Predicate, #1: 1	أَسَرَ عُقْبَةَ
u'أَسْرَعَ نَاسٌ':Subject, #2: 2	أَسْرَعَ النَّاسَ
u'أَسْرَعَ هضم':Predicate, #2: 2	أَسْرَعَ النَّاسُ
u'أَسْرَعَ هَضْمٌ':Predicate, #1: 1	أَسْرَعَ الْهَضْمَ
u'أَسْرَعَ وَجَبٌ':Predicate, #1: 1	أَسْرَعَ الْهَضْمَ
u'أَسْرَعَ وَلِيٌّ':Subject, #2: 2	أَسْرَعَ وَجَبَ
u'أَسَرَّ غير':Predicate, #1: 1	أَسْرَعَ وَلِيُّ
u'أَسَرَّ غَيْرٌ':Predicate, #1: 1	أَسَرَّ غَيْرَ
u'أَسْرَفَ اِبْنٌ':Subject, #1: 1	أَسَرَّ غَيْرَ
u'أَسْرَفَ ضَمِنٌ':Predicate, #1: 1	أَسْرَفَ ابْنُ
u'أَسَرَ فلان':Predicate, #1: 1	أَسْرَفَ ضَمِنَ
u'أَسَرَّ قِرَاءةٌ':Predicate, #1: 1	أَسَرَ عَقِيلَ
u'أَسَرَّ قول':Predicate, #1: 1	أَسَرَّ الْقِرَاءَةَ
u'أَسَرَّ قَوْلٌ':Predicate, #1: 1	أَسَرَّ الْقَوْلَ
u'أَسْرٌ كَافِرٌ':Added, #1: 1	أَسَرَّ الْقَوْلَ
u'أَسَرَ كُفَّارٌ':Subject, #1: 1	أَسْرِ الْكَافِرِ
u'أَسَرَّ كفر':Predicate, #1: 1	أَسَرَ الْكُفَّارُ
u'أَسَرَّ كُفْرٌ':Predicate, #7: 7	أَسَرَّ الْكُفْرَ
u'أَسَرَّ مَالِكٌ':Subject, #7: 7	أَسَرَّ الْكُفْرَ
u'أَسَرَّ مَعْصِيَةٌ':Predicate, #1: 1	أَسَرَّ مَالِكٌ
u'أَسْرٌ مَقَادِيرُ':Added, #1: 1	أَسَرَّ الْمَعْصِيَةَ
u'أَسْرَى أهْلٌ':Subject, #1: 1	أَسْرِ الْمَقَادِيرِ
u'أَسْرَى فلان':Predicate, #1: 1	أَسْرَى أَهْلُ
u'أَسْرَى مُسْلِمٌ':Predicate, #2: 2	أَسْرَى مَكَّةَ
u'أَسْرَى مُسْلِمٌ':Predicate, #1: 1	أَسْرَى مُسْلِمِينَ
u'أَسْرَى مُشْرِك':Predicate, #6: 6	أَسْرَى الْمُسْلِمِينَ
u'أَسَرَ يَوْمٌ':Predicate, #2: 2	أَسْرَى الْمُشْرِكِينَ
u'أَسَّسَ قَوَاعِدُ':Predicate, #1: 1	أَسَرَ يَوْمَ
u'أَسْعَدَ مَذْكُورٌ':Predicate, #2: 2	أَسَّسَ قَوَاعِدَ
u'أَسْعَفَ مُصَنِّفٌ':Subject, #1: 1	أَسْعَدَ الْمَذْكُورَ
u'أَسْفَرَ دفع':Predicate, #1: 1	أَسْعَفَ الْمُصَنِّفُ
u'أَسْفَرَ سَفَرٌ':Subject, #2: 2	أَسْفَرَ دَفَعَ
u'أَسْفَرَ شَيْءٌ':Subject, #1: 1	أَسْفَرَ السَّفَرُ
u'أَسْفَرَ صُبْحٌ':Subject, #1: 1	أَسْفَرَ الشَّيْءُ
u'أَسْفَرَ فَجْرٌ':Subject, #2: 2	أَسْفَرَ الصُّبْحُ
u'أَسْقَطَ أَبٌ':Subject, #2: 2	أَسْفَرَ الْفَجْرُ
u'أَسْقَطَ اِبْنٌ':Subject, #2: 2	أَسْقَطَ الْأَبُ
u'أَسْقَطَ أثَرٌ':Predicate, #1: 1	أَسْقَطَ ابْنُ
u'أَسْقَطَ إِثْمٌ':Predicate, #1: 1	أَسْقَطَ أَثَرَ
u'أَسْقَطَ أَجْرٌ':Predicate, #1: 1	أَسْقَطَ الْإِثْمَ
u'أَسْقَطَ أَجَلٌ':Predicate, #1: 1	أَسْقَطَ الْأَجْرَ
u'أَسْقَطَ أحَدٌ':Subject, #11: 11	أَسْقَطَ الْأَجَلَ
u'أَسْقَطَ أصل':Predicate, #1: 1	أَسْقَطَ أَحَدُ
u'أَسْقَطَ أًصْلٌ':Predicate, #1: 1	أَسْقَطَ أَصْلَ
u'أَسْقَطَ أَصيلٌ':Subject, #1: 1	أَسْقَطَ أَصْلَ
u'أَسْقَطَ اِعْتِبارٌ':Predicate, #1: 1	أَسْقَطَ الْأَصِيلُ
u'أَسْقَطَ أُمٌّ':Predicate, #4: 4	أَسْقَطَ اعْتِبَارَ
u'أَسْقَطَ إمَامٌ':Subject, #1: 1	أَسْقَطَ أُمَّ
u'أَسْقَطَ أَميرٌ':Subject, #1: 1	أَسْقَطَ الْإِمَامُ
u'أَسْقَطَ أَوَّلُ':Predicate, #1: 1	أَسْقَطَ أَمِيرُ
u'أَسْقَطَ بَائِعٌ':Subject, #2: 2	أَسْقَطَ الْأَوَّلَ
u'أَسْقَطَ بَعْضٌ':Predicate, #2: 2	أَسْقَطَ الْبَائِعُ
u'أَسْقَطَ بَعْضٌ':Subject, #5: 5	أَسْقَطَ بَعْضَ
u'أَسْقَطَ بَعْضٌ':Subject, #2: 2	أَسْقَطَ الْبَعْضُ
u'أَسْقَطَ تَحِيَّةٌ':Predicate, #2: 2	أَسْقَطَ بَعْضُ
u'أَسْقَطَ تَصَدُّقٌ':Predicate, #1: 1	أَسْقَطَ تَحِيَّةَ
u'أَسْقَطَ تَقَوُّمٌ':Predicate, #1: 1	أَسْقَطَ التَّصَدُّقَ
u'أَسْقَطَ ثَمَنٌ':Predicate, #2: 2	أَسْقَطَ تَقَوُّمَ
u'أَسْقَطَ جَزَاءٌ':Predicate, #1: 1	أَسْقَطَ الثَّمَنَ
u'أَسْقَطَ جِزْيَةٌ':Predicate, #1: 1	أَسْقَطَ الْجَزَاءَ
u'أَسْقَطَ جَمَاعَةٌ':Predicate, #1: 1	أَسْقَطَ الْجِزْيَةَ
u'أَسْقَطَ جمعة':Predicate, #1: 1	أَسْقَطَ الْجَمَاعَةَ
u'أَسْقَطَ جُمُعَةٌ':Predicate, #1: 1	أَسْقَطَ الْجُمُعَةَ
u'أَسْقَطَ جِنَايَةٌ':Predicate, #1: 1	أَسْقَطَ الْجُمُعَةَ
u'أَسْقَطَ جَوْدَةٌ':Predicate, #1: 1	أَسْقَطَ الْجِنَايَةَ
u'أَسْقَطَ حاضِرٌ':Subject, #1: 1	أَسْقَطَ الْجَوْدَةَ
u'أَسْقَطَ حَدٌّ':Predicate, #1: 1	أَسْقَطَ الْحَاضِرُ
u'أَسْقَطَ حَرَجٌ':Predicate, #1: 1	أَسْقَطَ الْحَدَّ
u'أَسْقَطَ حُرْمَةٌ':Predicate, #4: 4	أَسْقَطَ الْحَرَجَ
u'أَسْقَطَ حَقٌّ':Predicate, #1: 1	أَسْقَطَ حُرْمَةَ
u'أَسْقَطَ حِكَايَةٌ':Predicate, #5: 5	أَسْقَطَ حَقَّ
u'أَسْقَطَ حُكْمٌ':Predicate, #1: 1	أَسْقَطَ حِكَايَةَ
u'أَسْقَطَ خَالِصٌ':Predicate, #2: 2	أَسْقَطَ حُكْمَ
u'أَسْقَطَ خُصُومَةٌ':Predicate, #1: 1	أَسْقَطَ خَالِصَ
u'أَسْقَطَ خيار':Predicate, #1: 1	أَسْقَطَ الْخُصُومَةَ
u'أَسْقَطَ خِيَارٌ':Predicate, #10: 10	أَسْقَطَ الْخِيَارَ
u'أَسْقَطَ خيار':Predicate, #10: 10	أَسْقَطَ الْخِيَارَ
u'أَسْقَطَ خِيَارٌ':Predicate, #4: 4	أَسْقَطَ خِيَارَ
u'أَسْقَطَ دِرْهَمٌ':Predicate, #4: 4	أَسْقَطَ خِيَارَ
u'أَسْقَطَ دِرْهَم':Predicate, #1: 1	أَسْقَطَ الدِّرْهَمَ
u'أَسْقَطَ دَيْنٌ':Predicate, #1: 1	أَسْقَطَ الدِّرْهَمَ
u'أَسْقَطَ ذكر':Predicate, #3: 3	أَسْقَطَ الدَّيْنَ
u'أَسْقَطَ ذِكْرٌ':Predicate, #1: 1	أَسْقَطَ ذِكْرَ
u'أَسْقَطَ رابع':Predicate, #1: 1	أَسْقَطَ ذِكْرَ
u'أَسْقَطَ رَابِعٌ':Predicate, #1: 1	أَسْقَطَ الرَّابِعَ
u'أَسْقَطَ رَبُّ':Subject, #1: 1	أَسْقَطَ الرَّابِعَ
u'أَسْقَطَ رِطْلٌ':Predicate, #1: 1	أَسْقَطَ رَبُّ
u'أَسْقَطَ رَهْنٌ':Predicate, #1: 1	أَسْقَطَ الرِّطْلَ
u'أَسْقَطَ زَكاةٌ':Predicate, #1: 1	أَسْقَطَ الرَّهْنَ
u'أَسْقَطَ شَارِعٌ':Subject, #1: 1	أَسْقَطَ الزَّكَاةَ
u'أَسْقَطَ شَرْعٌ':Subject, #1: 1	أَسْقَطَ الشَّارِعُ
u'أَسْقَطَ شفعة':Predicate, #1: 1	أَسْقَطَ الشَّرْعُ
u'أَسْقَطَ شُفْعَةٌ':Predicate, #1: 1	أَسْقَطَ الشُّفْعَةَ
u'أَسْقَطَ صَاحِبٌ':Subject, #1: 1	أَسْقَطَ الشُّفْعَةَ
u'أَسْقَطَ ضَمَانٌ':Predicate, #2: 2	أَسْقَطَ صَاحِبُ
u'أَسْقَطَ طَلاَقٌ':Predicate, #2: 2	أَسْقَطَ الضَّمَانَ
u'أَسْقَطَ ظُهْرٌ':Predicate, #1: 1	أَسْقَطَ الطَّلَاقَ
u'أَسْقَطَ عَامِلٌ':Subject, #1: 1	أَسْقَطَ الظُّهْرَ
u'أَسْقَطَ عَبْدٌ':Predicate, #2: 2	أَسْقَطَ الْعَامِلُ
u'أَسْقَطَ عَبْدٌ':Subject, #2: 2	أَسْقَطَ عَبْدَ
u'أَسْقَطَ عَدَالَةٌ':Predicate, #1: 1	أَسْقَطَ الْعَبْدُ
u'أَسْقَطَ عَصْرٌ':Predicate, #1: 1	أَسْقَطَ الْعَدَالَةَ
u'أَسْقَطَ عِصْمَةٌ':Predicate, #1: 1	أَسْقَطَ الْعَصْرَ
u'أَسْقَطَ عُقُوبَةٌ':Predicate, #1: 1	أَسْقَطَ عِصْمَةَ
u'أَسْقَطَ غانِم':Subject, #1: 1	أَسْقَطَ عُقُوبَةَ
u'أَسْقَطَ غِشٌّ':Predicate, #1: 1	أَسْقَطَ الْغَانِمُ
u'أَسْقَطَ فاء':Predicate, #2: 2	أَسْقَطَ الْغِشَّ
u'أَسْقَطَ فَرْضٌ':Predicate, #1: 1	أَسْقَطَ الْفَاءَ
u'أَسْقَطَ فَرْضٌ':Predicate, #1: 1	أَسْقَطَ فَرْضَ
u'أَسْقَطَ فَسْخٌ':Predicate, #3: 3	أَسْقَطَ الْفَرْضَ
u'أَسْقَطَ فَسْخٌ':Subject, #1: 1	أَسْقَطَ الْفَسْخَ
u'أَسْقَطَ فِعْلٌ':Predicate, #1: 1	أَسْقَطَ الْفَسْخُ
u'أَسْقَطَ فلان':Subject, #1: 1	أَسْقَطَ الْفِعْلَ
u'أَسْقَطَ قَارِئٌ':Subject, #1: 1	أَسْقَطَ الْغَانِمُ
u'أَسْقَطَ قتل':Predicate, #1: 1	أَسْقَطَ الْقَارِئُ
u'أَسْقَطَ قَتْلٌ':Predicate, #1: 1	أَسْقَطَ الْقَتْلَ
u'أَسْقَطَ قَدْرٌ':Predicate, #1: 1	أَسْقَطَ الْقَتْلَ
u'أَسْقَطَ قَرِيبٌ':Subject, #2: 2	أَسْقَطَ قَدْرَ
u'أَسْقَطَ قصاص':Predicate, #1: 1	أَسْقَطَ الْقَرِيبُ
u'أَسْقَطَ قِصَاصٌ':Predicate, #2: 2	أَسْقَطَ الْقِصَاصَ
u'أَسْقَطَ قَضَاءٌ':Predicate, #2: 2	أَسْقَطَ الْقِصَاصَ
u'أَسْقَطَ قَوَد':Predicate, #2: 2	أَسْقَطَ الْقَضَاءَ
u'أَسْقَطَ قول':Subject, #1: 1	أَسْقَطَ الْقَوَدَ
u'أَسْقَطَ قَوْلٌ':Subject, #2: 2	أَسْقَطَ قَوْلُهُ
u'أَسْقَطَ قَيْدٌ':Predicate, #2: 2	أَسْقَطَ قَوْلُهُ
u'أَسْقَطَ كِتَابٌ':Predicate, #1: 1	أَسْقَطَ قَيْدَ
u'أَسْقَطَ كُسُورٌ':Predicate, #1: 1	أَسْقَطَ الْكِتَابَ
u'أَسْقَطَ كَلاَمٌ':Predicate, #1: 1	أَسْقَطَ الْكُسُورَ
u'أَسْقَطَ لعان':Subject, #1: 1	أَسْقَطَ الْكَلَامَ
u'أَسْقَطَ لَفْظٌ':Predicate, #1: 1	أَسْقَطَ اللِّعَانُ
u'أَسْقَطَ لَفْظَةٌ':Predicate, #1: 1	أَسْقَطَ لَفْظَ
u'أَسْقَطَ مَالِكٌ':Subject, #1: 1	أَسْقَطَ لَفْظَةَ
u'أَسْقَطَ مُحَمَّدٌ':Subject, #1: 1	أَسْقَطَ مَالِكٌ
u'أَسْقَطَ مَدْيُونٌ':Subject, #1: 1	أَسْقَطَ مُحَمَّدٌ
u'أَسْقَطَ مُرْتَهِنٌ':Subject, #3: 3	أَسْقَطَ الْمَدْيُونُ
u'أَسْقَطَ مُرْتَهِنٌ':Subject, #2: 2	أَسْقَطَ الْمُرْتَهِنُ
u'أَسْقَطَ مُشَارِكٌ':Subject, #2: 2	أَسْقَطَ مُرْتَهِنٌ
u'أَسْقَطَ مُصَنِّفٌ':Subject, #1: 1	أَسْقَطَ الْمُشَارِكُ
u'أَسْقَطَ مُضَارِبٌ':Subject, #3: 3	أَسْقَطَ الْمُصَنِّفُ
u'أَسْقَطَ مُفْسِدٌ':Predicate, #2: 2	أَسْقَطَ الْمُضَارِبُ
u'أَسْقَطَ مُلاَزَمَةٌ':Predicate, #3: 3	أَسْقَطَ الْمُفْسِدَ
u'أَسْقَطَ مُؤَلِّفٌ':Subject, #1: 1	أَسْقَطَ الْمُلَازَمَةَ
u'أَسْقَطَ نَبِيٌّ':Subject, #1: 1	أَسْقَطَ الْمُؤَلِّفُ
u'أَسْقَطَ هاء':Predicate, #1: 1	أَسْقَطَ النَّبِيُّ
u'أَسْقَطَ وَارِثٌ':Subject, #2: 2	أَسْقَطَ الْهَاءَ
u'أَسْقَطَ وُجُوبٌ':Predicate, #1: 1	أَسْقَطَ الْوَارِثُ
u'أَسْقَطَ وُجُوبٌ':Predicate, #1: 1	أَسْقَطَ الْوُجُوبَ
u'أَسْقَطَ وَرَثَةٌ':Subject, #1: 1	أَسْقَطَ وُجُوبَ
u'أَسْقَطَ وَصِيٌّ':Subject, #1: 1	أَسْقَطَ الْوَرَثَةُ
u'أَسْقَطَ وَكِيلٌ':Subject, #1: 1	أَسْقَطَ وَصِيٌّ
u'أَسْقَطَ وَلِيٌّ':Subject, #1: 1	أَسْقَطَ الْوَكِيلُ
u'أَسْقَطَ يَمِينٌ':Predicate, #1: 1	أَسْقَطَ الْوَلِيُّ
u'أَسْقَطَ يَوْمٌ':Predicate, #1: 1	أَسْقَطَ الْيَمِينَ
u'أَسْكَرَ جَرَّةٌ':Subject, #4: 4	أَسْقَطَ الْيَوْمَ
u'أَسْكَرَ طَاهِرٌ':Subject, #1: 1	أَسْكَرَ الْجَرَّةُ
u'أَسْكَرَ فرق':Subject, #1: 1	أَسْكَرَ طَاهِرٌ
u'أَسْكَرَ فَرْقٌ':Subject, #1: 1	أَسْكَرَ الْفَرْقُ
u'أَسْكَرَ فرق':Subject, #1: 1	أَسْكَرَ الْفَرْقُ
u'أَسْكَرَ قَدَحٌ':Subject, #2: 2	أَسْكَرَ الْفَرَقُ
u'أَسْكَرَ كَثِيرٌ':Subject, #1: 1	أَسْكَرَ الْقَدَحُ
u'أَسْكَنَ بَائِعٌ':Subject, #34: 34	أَسْكَرَ كَثِيرُهُ
u'أَسْكَنَ بَيْتٌ':Predicate, #1: 1	أَسْكَنَ الْبَائِعُ
u'أَسْكَنَ فَقِيرٌ':Predicate, #1: 1	أَسْكَنَ الْبَيْتَ
u'إِسْلامٌ الْمَرْءُ':Added, #1: 1	أَسْكَنَ الْفَقِيرَ
u'إِسْلامٌ عَبَّاسٌ':Added, #1: 1	إِسْلامِ الْمَرْءِ
u'أَسْلَفَ دَرَاهِمُ':Predicate, #1: 1	إِسْلامُ عَبَّاسِ
u'أَسْلَفَ رَجُلٌ':Predicate, #1: 1	أَسْلَفَ دَرَاهِمَ
u'أَسْلَفَ رَجُلٌ':Subject, #1: 1	أَسْلَفَ رَجُلاً
u'أَسْلَفَ غير':Subject, #1: 1	أَسْلَفَ الرَّجُلُ
u'أَسْلَفَ غَيْرٌ':Subject, #1: 1	أَسْلَفَ غَيْرُ
u'أَسْلَفَ مَالٌ':Predicate, #1: 1	أَسْلَفَ غَيْرُ
u'أَسْلَفَ مَعْرُوفٌ':Predicate, #1: 1	أَسْلَفَ مَالاً
u'أَسْلَمَ أَبٌ':Subject, #1: 1	أَسْلَفَ الْمَعْرُوفَ
u'أَسْلَمَ اِبْنٌ':Predicate, #11: 11	أَسْلَمَ الْأَبُ
u'أَسْلَمَ اِبْنٌ':Subject, #1: 1	أَسْلَمَ ابْنَ
u'أَسْلَمَ اِبْنٌ':Subject, #2: 2	أَسْلَمَ ابْنُ
u'أَسْلَمَ أحَدٌ':Subject, #2: 2	أَسْلَمَ ابْنُهُ
u'أَسْلَمَ أحَدٌ':Subject, #32: 32	أَسْلَمَ أَحَدُ
u'أَسْلَمَ آدَمُ':Predicate, #3: 3	أَسْلَمَ أَحَدٌ
u'أَسْلَمَ أَرْبَعُ':Subject, #1: 1	أَسْلَمَ آدَمَ
u'أَسْلَمَ أَسْفَلُ':Subject, #1: 1	أَسْلَمَ أَرْبَعُ
u'أَسْلَمَ أَسيرٌ':Subject, #1: 1	أَسْلَمَ الْأَسْفَلُ
u'أَسْلَمَ أصل':Subject, #5: 5	أَسْلَمَ الْأَسِيرُ
u'أَسْلَمَ أًصْلٌ':Subject, #1: 1	أَسْلَمَ أَصْلُهُ
u'أَسْلَمَ إِعْلاءٌ':Predicate, #1: 1	أَسْلَمَ أَصْلُهُ
u'أَسْلَمَ أَكْثَرُ':Subject, #1: 1	أَسْلَمَ إعْلَاءَ
u'أَسْلَمَ أمَةٌ':Predicate, #1: 1	أَسْلَمَ أَكْثَرُ
u'أَسْلَمَ أهْلٌ':Subject, #1: 1	أَسْلَمَ الْأَمَةَ
u'أَسْلَمَ أهْلٌ':Subject, #15: 15	أَسْلَمَ أَهْلُ
u'أَسْلَمَ أَوْجُهٌ':Subject, #3: 3	أَسْلَمَ أَهْلُهُ
u'أَسْلَمَ أَوَّلُ':Subject, #1: 1	أَسْلَمَ أَوْجُهٌ
u'أَسْلَمَ بَانٌ':Predicate, #4: 4	أَسْلَمَ الْأَوَّلُ
u'أَسْلَمَ بَائِعٌ':Subject, #3: 3	أَسْلَمَ بَانَ
u'أَسْلَمَ بَطَلٌ':Predicate, #10: 10	أَسْلَمَ الْبَائِعُ
u'أَسْلَمَ بَعْضٌ':Subject, #3: 3	أَسْلَمَ بَطَلَ
u'أَسْلَمَ بَعْضٌ':Subject, #2: 2	أَسْلَمَ الْبَعْضُ
u'أَسْلَمَ بيض':Predicate, #3: 3	أَسْلَمَ بَعْضُ
u'أَسْلَمَ بَيْنٌ':Predicate, #7: 7	أَسْلَمَ بَيْضَ
u'أَسْلَمَ جَارِي':Predicate, #1: 1	أَسْلَمَ بَيْنَ
u'أَسْلَمَ جَازٌ':Predicate, #6: 6	أَسْلَمَ جَارِيَةً
u'أَسْلَمَ حارِثٌ':Subject, #6: 6	أَسْلَمَ جَازَ
u'أَسْلَمَ حالٌ':Predicate, #2: 2	أَسْلَمَ الْحَارِثُ
u'أَسْلَمَ حُكْمٌ':Predicate, #1: 1	أَسْلَمَ حَالَ
u'أَسْلَمَ حُكْمٌ':Subject, #1: 1	أَسْلَمَ حُكْمَ
u'أَسْلَمَ حَلٌّ':Predicate, #1: 1	أَسْلَمَ حُكْمُ
u'أَسْلَمَ حَلِيفٌ':Subject, #2: 2	أَسْلَمَ حَلَّ
u'أَسْلَمَ حَمْز':Subject, #1: 1	أَسْلَمَ حَلِيفُ
u'أَسْلَمَ حِنْطَةٌ':Predicate, #2: 2	أَسْلَمَ حَمْزَةُ
u'أَسْلَمَ خلائق':Subject, #1: 1	أَسْلَمَ الْحِنْطَةَ
u'أَسْلَمَ خَلائِقُ':Subject, #1: 1	أَسْلَمَ خَلَائِقُ
u'أَسْلَمَ خَلْقٌ':Subject, #1: 1	أَسْلَمَ خَلَائِقُ
u'أَسْلَمَ خَمْسٌ':Predicate, #2: 2	أَسْلَمَ خَلْقٌ
u'أَسْلَمَ خَوْفٌ':Predicate, #2: 2	أَسْلَمَ خَمْسَ
u'أَسْلَمَ دَرَاهِمُ':Predicate, #1: 1	أَسْلَمَ خَوْفَ
u'أَسْلَمَ دَرَاهِمُ':Predicate, #3: 3	أَسْلَمَ الدَّرَاهِمَ
u'أَسْلَمَ دِهْقانٌ':Subject, #6: 6	أَسْلَمَ دَرَاهِمَ
u'أَسْلَمَ ذِمِّيٌّ':Subject, #2: 2	أَسْلَمَ دِهْقَانٌ
u'أَسْلَمَ ذِمِّيٌّ':Subject, #12: 12	أَسْلَمَ الذِّمِّيُّ
u'أَسْلَمَ رَبُّ':Subject, #4: 4	أَسْلَمَ ذِمِّيٌّ
u'أَسْلَمَ رَجُلٌ':Subject, #1: 1	أَسْلَمَ رَبُّ
u'أَسْلَمَ رَجُلٌ':Subject, #13: 13	أَسْلَمَ رَجُلٌ
u'أَسْلَمَ رَسُولٌ':Predicate, #17: 17	أَسْلَمَ الرَّجُلُ
u'أَسْلَمَ رَسُولٌ':Subject, #1: 1	أَسْلَمَ رَسُولَ
u'أَسْلَمَ رِقابٌ':Subject, #1: 1	أَسْلَمَ رَسُولُ
u'أَسْلَمَ رَقيقٌ':Subject, #1: 1	أَسْلَمَ الرِّقَابُ
u'أَسْلَمَ رَقيق':Subject, #1: 1	أَسْلَمَ الرَّقِيقُ
u'أَسْلَمَ زَوْجٌ':Subject, #1: 1	أَسْلَمَ الرَّقِيقُ
u'أَسْلَمَ زَوْجٌ':Subject, #10: 10	أَسْلَمَ زَوْجُ
u'أَسْلَمَ زَيْدٌ':Subject, #20: 20	أَسْلَمَ الزَّوْجُ
u'أَسْلَمَ سَارِقٌ':Subject, #1: 1	أَسْلَمَ زَيْدُ
u'أَسْلَمَ سَفِيهٌ':Subject, #1: 1	أَسْلَمَ السَّارِقُ
u'أَسْلَمَ سقط':Predicate, #1: 1	أَسْلَمَ السَّفِيهُ
u'أَسْلَمَ سَقَطٌ':Predicate, #5: 5	أَسْلَمَ سَقَطَ
u'أَسْلَمَ سَمٌّ':Subject, #5: 5	أَسْلَمَ سَقَطَ
u'أَسْلَمَ سَواءٌ':Subject, #1: 1	أَسْلَمَ سَمّاهُ
u'أَسْلَمَ سَيِّدٌ':Subject, #1: 1	أَسْلَمَ سَوَاءٌ
u'أَسْلَمَ سَيِّدٌ':Subject, #2: 2	أَسْلَمَ السَّيِّدُ
u'أَسْلَمَ سَيْفٌ':Predicate, #2: 2	أَسْلَمَ سَيِّدُهُ
u'أَسْلَمَ شَفِيعٌ':Subject, #2: 2	أَسْلَمَ السَّيْفَ
u'أَسْلَمَ شُهُودٌ':Subject, #2: 2	أَسْلَمَ الشَّفِيعُ
u'أَسْلَمَ شَيْءٌ':Subject, #2: 2	أَسْلَمَ الشُّهُودُ
u'أَسْلَمَ شَيْخٌ':Subject, #1: 1	أَسْلَمَ شَيْءٌ
u'أَسْلَمَ صَاحِبٌ':Subject, #1: 1	أَسْلَمَ شَيْخٌ
u'أَسْلَمَ صَاحِبٌ':Subject, #1: 1	أَسْلَمَ صَاحِبُ
u'أَسْلَمَ صَبِيٌّ':Subject, #1: 1	أَسْلَمَ صَاحِبُهُ
u'أَسْلَمَ صَبِيٌّ':Subject, #1: 1	أَسْلَمَ الصَّبِيُّ
u'أَسْلَمَ صَفْوَان':Predicate, #1: 1	أَسْلَمَ صَبِيٌّ
u'أَسْلَمَ صَفْوَان':Subject, #1: 1	أَسْلَمَ صَفْوَانَ
u'أَسْلَمَ ضَالٌّ':Predicate, #4: 4	أَسْلَمَ صَفْوَانُ
u'أَسْلَمَ ضرار':Subject, #1: 1	أَسْلَمَ الضَّالَّةَ
u'أَسْلَمَ طَالِبٌ':Subject, #1: 1	أَسْلَمَ ضِرَارٌ
u'أَسْلَمَ ظاهِرٌ':Subject, #8: 8	أَسْلَمَ الطَّالِبُ
u'أَسْلَمَ عَابِدٌ':Subject, #1: 1	أَسْلَمَ ظَاهِرُ
u'أَسْلَمَ عَادٌ':Predicate, #1: 1	أَسْلَمَ الْعَابِدُ
u'أَسْلَمَ عَامٌ':Predicate, #2: 2	أَسْلَمَ عَادَ
u'أَسْلَمَ عَبَّاسٌ':Subject, #6: 6	أَسْلَمَ عَامَ
u'أَسْلَمَ عَبْدٌ':Subject, #2: 2	أَسْلَمَ الْعَبّاسُ
u'أَسْلَمَ عَبْدٌ':Subject, #14: 14	أَسْلَمَ عَبْدٌ
u'أَسْلَمَ عَبْدٌ':Subject, #14: 14	أَسْلَمَ عَبْدُ
u'أَسْلَمَ عَبْدٌ':Subject, #17: 17	أَسْلَمَ الْعَبْدُ
u'أَسْلَمَ عَبِيدٌ':Subject, #5: 5	أَسْلَمَ عَبْدُهُ
u'أَسْلَمَ عَتِيقٌ':Subject, #1: 1	أَسْلَمَ عَبِيدُ
u'أَسْلَمَ عَشْرٌ':Predicate, #2: 2	أَسْلَمَ الْعَتِيقُ
u'أَسْلَمَ عصم':Predicate, #1: 1	أَسْلَمَ عَشْرَةَ
u'أَسْلَمَ عِلْجٌ':Subject, #2: 2	أَسْلَمَ عَصَمَ
u'أَسْلَمَ عَلْقَم':Subject, #1: 1	أَسْلَمَ الْعِلْجُ
u'أَسْلَمَ عَلْقَمَة':Subject, #1: 1	أَسْلَمَ عَلْقَمَةُ
u'أَسْلَمَ عَلِيٌّ':Subject, #1: 1	أَسْلَمَ عَلْقَمَةُ
u'أَسْلَمَ عُمَرٌ':Subject, #2: 2	أَسْلَمَ عَلِيٌّ
u'أَسْلَمَ عند':Predicate, #5: 5	أَسْلَمَ عُمَرُ
u'أَسْلَمَ غَلَّةٌ':Predicate, #5: 5	أَسْلَمَ عِنْدَ
u'أَسْلَمَ غير':Predicate, #1: 1	أَسْلَمَ الْغَلَّةَ
u'أَسْلَمَ غَيْرٌ':Predicate, #1: 1	أَسْلَمَ غَيْرَ
u'أَسْلَمَ غير':Subject, #1: 1	أَسْلَمَ غَيْرَ
u'أَسْلَمَ غَيْرٌ':Subject, #1: 1	أَسْلَمَ غَيْرُ
u'أَسْلَمَ فِتْيَانٌ':Subject, #1: 1	أَسْلَمَ غَيْرُ
u'أَسْلَمَ فُرَاتٌ':Subject, #1: 1	أَسْلَمَ فِتْيَانُ
u'أَسْلَمَ فَرِيضَةٌ':Subject, #1: 1	أَسْلَمَ فُرَاتٌ
u'أَسْلَمَ فلان':Subject, #1: 1	أَسْلَمَ فَرِيضَةٌ
u'أَسْلَمَ فُلاَنٌ':Subject, #1: 1	أَسْلَمَ عَيَّاشُ
u'أَسْلَمَ فُلاَنٌ':Subject, #1: 1	أَسْلَمَ فُلَانٌ
u'أَسْلَمَ فلان':Subject, #1: 1	أَسْلَمَ فُلَانُ
u'أَسْلَمَ فلان':Subject, #2: 2	أَسْلَمَ حَمْزَةُ
u'أَسْلَمَ فلان':Subject, #2: 2	أَسْلَمَ عُثْمَانُ
u'أَسْلَمَ فُلُوسٌ':Predicate, #3: 3	أَسْلَمَ الزُّبَيْرُ
u'أَسْلَمَ قَاتِلٌ':Subject, #2: 2	أَسْلَمَ الْفُلُوسَ
u'أَسْلَمَ قَالٌ':Predicate, #7: 7	أَسْلَمَ الْقَاتِلُ
u'أَسْلَمَ قَوْمٌ':Subject, #21: 21	أَسْلَمَ قَالَ
u'أَسْلَمَ كَافِرٌ':Subject, #2: 2	أَسْلَمَ قَوْمٌ
u'أَسْلَمَ كَافِرٌ':Subject, #17: 17	أَسْلَمَ كَافِرٌ
u'أَسْلَمَ كبار':Subject, #32: 32	أَسْلَمَ الْكَافِرُ
u'أَسْلَمَ كَبِيرٌ':Subject, #1: 1	أَسْلَمَ الْكِبَارُ
u'أَسْلَمَ كَفِيلٌ':Subject, #2: 2	أَسْلَمَ الْكَبِيرُ
u'أَسْلَمَ مَالِكٌ':Subject, #4: 4	أَسْلَمَ الْكَفِيلُ
u'أَسْلَمَ مَبِيعٌ':Predicate, #1: 1	أَسْلَمَ مَالِكُهُ
u'أَسْلَمَ مَجْرُوحٌ':Subject, #2: 2	أَسْلَمَ الْمَبِيعَ
u'أَسْلَمَ مَجُوسِيٌّ':Subject, #3: 3	أَسْلَمَ الْمَجْرُوحُ
u'أَسْلَمَ مَجُوسِيٌّ':Subject, #1: 1	أَسْلَمَ مَجُوسِيٌّ
u'أَسْلَمَ مُحَمَّدٌ':Subject, #2: 2	أَسْلَمَ الْمَجُوسِيُّ
u'أَسْلَمَ مُدَبَّرٌ':Subject, #1: 1	أَسْلَمَ مُحَمَّدُ
u'أَسْلَمَ مُدَبَّرٌ':Subject, #4: 4	أَسْلَمَ مُدَبَّرٌ
u'أَسْلَمَ مَدَنِيٌّ':Subject, #4: 4	أَسْلَمَ مُدَبَّرُ
u'أَسْلَمَ مَدْيُونٌ':Subject, #1: 1	أَسْلَمَ الْمَدَنِيُّ
u'أَسْلَمَ مُرْتَدٌّ':Subject, #1: 1	أَسْلَمَ الْمَدْيُونُ
u'أَسْلَمَ مُرْسَلٌ':Predicate, #14: 14	أَسْلَمَ الْمُرْتَدُّ
u'أَسْلَمَ مَرِيضٌ':Subject, #1: 1	أَسْلَمَ مُرْسَلاً
u'أَسْلَمَ مُزَارِعٌ':Subject, #1: 1	أَسْلَمَ الْمَرِيضُ
u'أَسْلَمَ مُشْرِك':Subject, #1: 1	أَسْلَمَ الْمُزَارِعُ
u'أَسْلَمَ مَشْهُودٌ':Subject, #2: 2	أَسْلَمَ مُشْرِكٌ
u'أَسْلَمَ مَضْمُونٌ':Subject, #7: 7	أَسْلَمَ الْمَشْهُودُ
u'أَسْلَمَ مَطْلُوبٌ':Subject, #1: 1	أَسْلَمَ الْمَضْمُونُ
u'أَسْلَمَ مُفَرَّع':Subject, #3: 3	أَسْلَمَ الْمَطْلُوبُ
u'أَسْلَمَ مُقْرِضٌ':Subject, #1: 1	أَسْلَمَ مُفَرَّعٌ
u'أَسْلَمَ مَلِكٌ':Subject, #4: 4	أَسْلَمَ الْمُقْرِضُ
u'أَسْلَمَ مُنْقَطِعٌ':Subject, #1: 1	أَسْلَمَ الْمَلِكُ
u'أَسْلَمَ مُوَرِّث':Subject, #1: 1	أَسْلَمَ مُنْقَطِعٌ
u'أَسْلَمَ مُوسِرٌ':Subject, #1: 1	أَسْلَمَ مُوَرِّثُهُ
u'أَسْلَمَ مَوْصُولٌ':Predicate, #1: 1	أَسْلَمَ مُوسِرٌ
u'أَسْلَمَ نَاسٌ':Subject, #1: 1	أَسْلَمَ مَوْصُولاً
u'أَسْلَمَ نَاسٌ':Subject, #2: 2	أَسْلَمَ النّاسُ
u'أَسْلَمَ نَبَطِيٌّ':Subject, #6: 6	أَسْلَمَ النَّاسُ
u'أَسْلَمَ نَخْلٌ':Predicate, #2: 2	أَسْلَمَ النَّبَطِيُّ
u'أَسْلَمَ نِساءٌ':Subject, #1: 1	أَسْلَمَ النَّخْلَ
u'أَسْلَمَ نَصْرَانِيٌّ':Subject, #1: 1	أَسْلَمَ نِسَاءٌ
u'أَسْلَمَ نَصْرَانِيٌّ':Subject, #2: 2	أَسْلَمَ نَصْرَانِيٌّ
u'أَسْلَمَ نَصْلٌ':Predicate, #5: 5	أَسْلَمَ النَّصْرَانِيُّ
u'أَسْلَمَ نَفَذٌ':Predicate, #1: 1	أَسْلَمَ النَّصْلَ
u'أَسْلَمَ نقار':Predicate, #8: 8	أَسْلَمَ نَفَذَ
u'أَسْلَمَ نقرة':Predicate, #2: 2	أَسْلَمَ نُقَارَ
u'أَسْلَمَ نُقْرَةٌ':Predicate, #1: 1	أَسْلَمَ نُقْرَةَ
u'أَسْلَمَ نُقُودٌ':Predicate, #1: 1	أَسْلَمَ نُقْرَةَ
u'أَسْلَمَ نَقِيبٌ':Subject, #1: 1	أَسْلَمَ النُّقُودَ
u'أَسْلَمَ واحد':Subject, #1: 1	أَسْلَمَ النَّقِيبُ
u'أَسْلَمَ وَاحِدٌ':Subject, #5: 5	أَسْلَمَ وَاحِدٌ
u'أَسْلَمَ وَارِثٌ':Subject, #5: 5	أَسْلَمَ وَاحِدٌ
u'أَسْلَمَ وَجَبٌ':Predicate, #2: 2	أَسْلَمَ الْوَارِثُ
u'أَسْلَمَ وُجُوبٌ':Subject, #3: 3	أَسْلَمَ وَجَبَ
u'أَسْلَمَ وَكِيلٌ':Subject, #1: 1	أَسْلَمَ وُجُوبُ
u'أَسْلَمَ ولد':Subject, #1: 1	أَسْلَمَ وَكِيلُهُ
u'أَسْلَمَ وَلَدٌ':Subject, #1: 1	أَسْلَمَ وَلَدُ
u'أَسْلَمَ ولد':Subject, #1: 1	أَسْلَمَ وَلَدُ
u'أَسْلَمَ وَلَدٌ':Subject, #2: 2	أَسْلَمَ الْوَلَدُ
u'أَسْلَمَ ولد':Subject, #2: 2	أَسْلَمَ الْوَلَدُ
u'أَسْلَمَ وَلَدٌ':Subject, #2: 2	أَسْلَمَ وَلَدُهُ
u'أَسْلَمَ وَلَهٌ':Subject, #2: 2	أَسْلَمَ وَلَدُهُ
u'أَسْلَمَ يَوْمٌ':Predicate, #7: 7	أَسْلَمَ وَلَهُ
u'أَسْلَمَ يَوْمٌ':Predicate, #1: 1	أَسْلَمَ الْيَوْمَ
u'أَسْمَعَ أهْلٌ':Predicate, #4: 4	أَسْلَمَ يَوْمَ
u'أَسْمَعَ بَعْضٌ':Predicate, #2: 2	أَسْمَعَ أَهْلَ
u'أَسْمَعَ نَاسٌ':Predicate, #1: 1	أَسْمَعَ بَعْضَ
u'أَسْنَدَ إِثْمٌ':Predicate, #1: 1	أَسْمَعَ النَّاسَ
u'أَسْنَدَ أَمْرٌ':Predicate, #1: 1	أَسْنَدَ الْإِثْمَ
u'أَسْنَدَ حافِظٌ':Subject, #1: 1	أَسْنَدَ الْأَمْرَ
u'أَسْنَدَ حاكِمٌ':Subject, #1: 1	أَسْنَدَ الْحَافِظُ
u'أَسْنَدَ حُكْمٌ':Predicate, #1: 1	أَسْنَدَ الْحَاكِمُ
u'أَسْنَدَ دفن':Predicate, #1: 1	أَسْنَدَ الْحُكْمَ
u'أَسْنَدَ دَفْنٌ':Predicate, #1: 1	أَسْنَدَ الدَّفْنَ
u'أَسْنَدَ رَسُولٌ':Predicate, #1: 1	أَسْنَدَ الدَّفْنَ
u'أَسْنَدَ رَسُولٌ':Subject, #1: 1	أَسْنَدَ رَسُولَ
u'أَسْنَدَ زائِدٌ':Subject, #1: 1	أَسْنَدَ رَسُولُ
u'أَسْنَدَ طَلاَقٌ':Predicate, #1: 1	أَسْنَدَ زَائِدَةُ
u'أَسْنَدَ عَدَمٌ':Predicate, #1: 1	أَسْنَدَ الطَّلَاقَ
u'أَسْنَدَ عَطَاءٌ':Subject, #1: 1	أَسْنَدَ عَدَمَ
u'أَسْنَدَ مِلْكٌ':Predicate, #1: 1	أَسْنَدَ عَطَاءُ
u'أَسْنَدَ نَظَرٌ':Predicate, #1: 1	أَسْنَدَ الْمِلْكَ
u'أَسْنَدَ نَعِيمٌ':Predicate, #1: 1	أَسْنَدَ النَّظَرَ
u'أَسْنَدَ هشام':Subject, #1: 1	أَسْنَدَ النَّعِيمَ
u'أَسْنَدَ هِشَامٌ':Subject, #1: 1	أَسْنَدَ هِشَامُ
u'أَسْنَدَ وَكِيلٌ':Subject, #1: 1	أَسْنَدَ هِشَامُ
u'أَسَنَّ رَسُولٌ':Predicate, #1: 1	أَسْنَدَ الْوَكِيلُ
u'أَسَنَّ رَسُولٌ':Subject, #1: 1	أَسَنَّ رَسُولَ
u'أَسَنَّ فلان':Subject, #1: 1	أَسَنَّ رَسُولُ
u'أَسْهَلَ دَمٌ':Predicate, #1: 1	أَسَنَّ عَقِيلٌ
u'أَسْهَلَ صَفْرَاء':Predicate, #1: 1	أَسْهَلَ الدَّمَ
u'أَسْهَمَ رَسُولٌ':Subject, #1: 1	أَسْهَلَ صَفْرَاءَ
u'أَسْهَمَ يَوْمٌ':Predicate, #4: 4	أَسْهَمَ رَسُولُ
u'أَشَارَ اِبْنٌ':Subject, #2: 2	أَسْهَمَ يَوْمَ
u'أَشَارَ أَصْحَابٌ':Subject, #23: 23	أَشَارَ ابْنُ
u'أَشَارَ أصل':Subject, #2: 2	أَشَارَ الْأَصْحَابُ
u'أَشَارَ أًصْلٌ':Subject, #1: 1	أَشَارَ الْأَصْلُ
u'أَشَارَ إمَامٌ':Subject, #1: 1	أَشَارَ الْأَصْلُ
u'أَشَارَ إمَامٌ':Subject, #1: 1	أَشَارَ إمَامُ
u'أَشَارَ بُخَارِيٌّ':Subject, #8: 8	أَشَارَ الْإِمَامُ
u'أَشَارَ بَعْضٌ':Subject, #1: 1	أَشَارَ الْبُخَارِيُّ
u'أَشَارَ جَلاَلٌ':Subject, #5: 5	أَشَارَ بَعْضُ
u'أَشَارَ حاضِرٌ':Subject, #1: 1	أَشَارَ الْجَلَالُ
u'أَشَارَ حاكِمٌ':Subject, #1: 1	أَشَارَ حَاضِرٌ
u'أَشَارَ حَديثٌ':Subject, #3: 3	أَشَارَ الْحَاكِمُ
u'أَشَارَ رَسُولٌ':Subject, #1: 1	أَشَارَ الْحَدِيثُ
u'أَشَارَ زَوْجٌ':Subject, #13: 13	أَشَارَ رَسُولُ
u'أَشَارَ سائِل':Subject, #1: 1	أَشَارَ الزَّوْجُ
u'أَشَارَ سَائِلٌ':Subject, #2: 2	أَشَارَ السَّائِلُ
u'أَشَارَ سَيِّدٌ':Subject, #2: 2	أَشَارَ السَّائِلُ
u'أَشَارَ شَارِحٌ':Subject, #1: 1	أَشَارَ السَّيِّدُ
u'أَشَارَ شافِعِيّ':Subject, #2: 2	أَشَارَ الشَّارِحُ
u'أَشَارَ شمس':Subject, #6: 6	أَشَارَ الشَّافِعِيُّ
u'أَشَارَ شَمْسٌ':Subject, #3: 3	أَشَارَ شَمْسُ
u'أَشَارَ شُهُودٌ':Subject, #3: 3	أَشَارَ شَمْسُ
u'أَشَارَ شَيْبانِيّ':Subject, #1: 1	أَشَارَ الشُّهُودُ
u'أَشَارَ شَيْخٌ':Subject, #1: 1	أَشَارَ الشَّيْبَانِيُّ
u'أَشَارَ شَيْخٌ':Subject, #1: 1	أَشَارَ شَيْخُ
u'أَشَارَ صَاحِبٌ':Subject, #8: 8	أَشَارَ الشَّيْخُ
u'أَشَارَ صَدْرٌ':Subject, #9: 9	أَشَارَ صَاحِبُ
u'أَشَارَ صِدِّيقٌ':Subject, #1: 1	أَشَارَ الصَّدْرُ
u'أَشَارَ طَبَرِيّ':Subject, #3: 3	أَشَارَ الصِّدِّيقُ
u'أَشَارَ طَبِيبٌ':Subject, #1: 1	أَشَارَ الطَّبَرِيُّ
u'أَشَارَ ظَهيرٌ':Subject, #1: 1	أَشَارَ الطَّبِيبُ
u'أَشَارَ عَارِفٌ':Subject, #3: 3	أَشَارَ ظَهِيرُ
u'أَشَارَ عَلِيٌّ':Subject, #1: 1	أَشَارَ الْعَارِفُ
u'أَشَارَ عَلِيٌّ':Subject, #1: 1	أَشَارَ عَلِيُّ
u'أَشَارَ عُمَرٌ':Subject, #3: 3	أَشَارَ عَلِيٌّ
u'أَشَارَ فخر':Subject, #6: 6	أَشَارَ عُمَرُ
u'أَشَارَ فَخْرٌ':Subject, #3: 3	أَشَارَ فَخْرُ
u'أَشَارَ فَرَسٌ':Subject, #3: 3	أَشَارَ فَخْرُ
u'أَشَارَ فلان':Subject, #1: 1	أَشَارَ الْفَرَسُ
u'أَشَارَ فلان':Subject, #1: 1	أَشَارَ الطَّبَرِيُّ
u'أَشَارَ قَالٌ':Predicate, #6: 6	أَشَارَ الشَّافِعِيُّ
u'أَشَارَ قول':Subject, #1: 1	أَشَارَ قَالَ
u'أَشَارَ قَوْلٌ':Subject, #2: 2	أَشَارَ قَوْلُهُ
u'أَشَارَ مَالِكٌ':Subject, #2: 2	أَشَارَ قَوْلُهُ
u'أَشَارَ مُبَرِّدٌ':Subject, #2: 2	أَشَارَ مَالِكٌ
u'أَشَارَ مثل':Predicate, #1: 1	أَشَارَ الْمُبَرِّدُ
u'أَشَارَ مِثْلٌ':Predicate, #1: 1	أَشَارَ مِثْلَ
u'أَشَارَ مُحْرِمٌ':Subject, #1: 1	أَشَارَ مِثْلَ
u'أَشَارَ مُحَقِّقٌ':Subject, #3: 3	أَشَارَ الْمُحْرِمُ
u'أَشَارَ مُحَمَّدٌ':Subject, #1: 1	أَشَارَ الْمُحَقِّقُ
u'أَشَارَ مُسْلِمٌ':Subject, #32: 32	أَشَارَ مُحَمَّدٌ
u'أَشَارَ مُصَنِّفٌ':Subject, #2: 2	أَشَارَ مُسْلِمٌ
u'أَشَارَ مُؤَلِّفٌ':Subject, #60: 60	أَشَارَ الْمُصَنِّفُ
u'أَشَارَ نَاطِقٌ':Subject, #8: 8	أَشَارَ الْمُؤَلِّفُ
u'أَشَارَ نَبِيٌّ':Subject, #1: 1	أَشَارَ نَاطِقٌ
u'أَشَارَ نَوَوِيٌّ':Subject, #8: 8	أَشَارَ النَّبِيُّ
u'أَشَارَ وَالِدٌ':Subject, #2: 2	أَشَارَ النَّوَوِيُّ
u'أَشَارَ وقع':Predicate, #1: 1	أَشَارَ الْوَالِدُ
u'أَشَارَ وَلِيٌّ':Subject, #1: 1	أَشَارَ وَقَعَ
u'أَشْبَعَ اِبْنٌ':Subject, #2: 2	أَشَارَ الْوَلِيُّ
u'أَشْبَعَ إمَامٌ':Subject, #1: 1	أَشْبَعَ ابْنُ
u'أَشْبَعَ أئِمَّةٌ':Subject, #1: 1	أَشْبَعَ إمَامُ
u'أَشْبَعَ حَرَكَةٌ':Predicate, #1: 1	أَشْبَعَ الْأَئِمَّةُ
u'أَشْبَعَ كَلاَمٌ':Predicate, #1: 1	أَشْبَعَ حَرَكَةَ
u'أَشْبَعَ نَوَوِيٌّ':Subject, #1: 1	أَشْبَعَ الْكَلَامَ
u'أَشْبَهَ أَثْمانٌ':Predicate, #1: 1	أَشْبَعَ النَّوَوِيُّ
u'أَشْبَهَ إجَارَةٌ':Predicate, #1: 1	أَشْبَهَ الْأَثْمَانَ
u'أَشْبَهَ أَجْنَبِيٌّ':Predicate, #1: 1	أَشْبَهَ الْإِجَارَةَ
u'أَشْبَهَ اِسْتِعْمالٌ':Predicate, #2: 2	أَشْبَهَ الْأَجْنَبِيَّ
u'أَشْبَهَ أصل':Predicate, #1: 1	أَشْبَهَ اسْتِعْمَالَ
u'أَشْبَهَ أًصْلٌ':Predicate, #1: 1	أَشْبَهَ الْأَصْلَ
u'أَشْبَهَ بَائِعٌ':Predicate, #1: 1	أَشْبَهَ الْأَصْلَ
u'أَشْبَهَ بَهيمٌ':Predicate, #1: 1	أَشْبَهَ بَائِعَ
u'أَشْبَهَ بَهِيمَةٌ':Predicate, #1: 1	أَشْبَهَ الْبَهِيمَةَ
u'أَشْبَهَ بَيْعٌ':Predicate, #1: 1	أَشْبَهَ الْبَهِيمَةَ
u'أَشْبَهَ تالِف':Predicate, #2: 2	أَشْبَهَ الْبَيْعَ
u'أَشْبَهَ تَدْلِيس':Predicate, #2: 2	أَشْبَهَ التَّالِفَ
u'أَشْبَهَ تَسْبِيحٌ':Predicate, #1: 1	أَشْبَهَ التَّدْلِيسَ
u'أَشْبَهَ تَلْبيَةٌ':Predicate, #1: 1	أَشْبَهَ التَّسْبِيحَ
u'أَشْبَهَ تَمْر':Predicate, #2: 2	أَشْبَهَ التَّلْبِيَةَ
u'أَشْبَهَ تَوَاتُرٌ':Predicate, #1: 1	أَشْبَهَ التَّمْرَ
u'أَشْبَهَ تَوَاضُعٌ':Predicate, #1: 1	أَشْبَهَ التَّوَاتُرَ
u'أَشْبَهَ ثَمَنٌ':Predicate, #1: 1	أَشْبَهَ التَّوَاضُعَ
u'أَشْبَهَ جَمِيع':Subject, #1: 1	أَشْبَهَ الثَّمَنَ
u'أَشْبَهَ جَنَابَةٌ':Predicate, #1: 1	أَشْبَهَ الْجَمِيعُ
u'أَشْبَهَ حُبوبٌ':Predicate, #1: 1	أَشْبَهَ الْجَنَابَةَ
u'أَشْبَهَ حَجٌّ':Predicate, #1: 1	أَشْبَهَ الْحُبُوبَ
u'أَشْبَهَ حِلْفٌ':Subject, #1: 1	أَشْبَهَ الْحَجَّ
u'أَشْبَهَ حَيْضٌ':Predicate, #1: 1	أَشْبَهَ حِلْفُ
u'أَشْبَهَ خِلاَفٌ':Predicate, #1: 1	أَشْبَهَ الْحَيْضَ
u'أَشْبَهَ دَمٌ':Predicate, #1: 1	أَشْبَهَ الْخِلَافَ
u'أَشْبَهَ دُهْنٌ':Predicate, #1: 1	أَشْبَهَ الدَّمَ
u'أَشْبَهَ دِيَةٌ':Predicate, #1: 1	أَشْبَهَ دُهْنَ
u'أَشْبَهَ دَيْنٌ':Predicate, #1: 1	أَشْبَهَ الدِّيَةَ
u'أَشْبَهَ زانِي':Predicate, #1: 1	أَشْبَهَ الدَّيْنَ
u'أَشْبَهَ زَوالٌ':Predicate, #1: 1	أَشْبَهَ الزَّانِيَ
u'أَشْبَهَ سِباعٌ':Predicate, #1: 1	أَشْبَهَ زَوَالَ
u'أَشْبَهَ سَفَرٌ':Predicate, #1: 1	أَشْبَهَ السِّبَاعَ
u'أَشْبَهَ سَفِيهٌ':Predicate, #1: 1	أَشْبَهَ سَفَرَ
u'أَشْبَهَ سُقُوطٌ':Predicate, #1: 1	أَشْبَهَ السَّفِيهَ
u'أَشْبَهَ شَرْطٌ':Subject, #1: 1	أَشْبَهَ السُّقُوطَ
u'أَشْبَهَ شَهَادَةٌ':Predicate, #1: 1	أَشْبَهَ الشَّرْطُ
u'أَشْبَهَ شَيْءٌ':Predicate, #1: 1	أَشْبَهَ الشَّهَادَةَ
u'أَشْبَهَ صَاحِبٌ':Subject, #2: 2	أَشْبَهَ الشَّيْءَ
u'أَشْبَهَ صَغِيرٌ':Predicate, #1: 1	أَشْبَهَ صَاحِبُهُ
u'أَشْبَهَ صَلاَةٌ':Subject, #1: 1	أَشْبَهَ الصَّغِيرَ
u'أَشْبَهَ صُوفٌ':Predicate, #1: 1	أَشْبَهَ صَلَاتُهُ
u'أَشْبَهَ ضَرُورِيٌّ':Predicate, #1: 1	أَشْبَهَ الصُّوفَ
u'أَشْبَهَ ضَمَانٌ':Predicate, #1: 1	أَشْبَهَ الضَّرُورِيَّ
u'أَشْبَهَ ضَمِنٌ':Predicate, #1: 1	أَشْبَهَ ضَمَانَ
u'أَشْبَهَ فِرْعَوْنُ':Predicate, #1: 1	أَشْبَهَ ضَمِنَ
u'أَشْبَهَ فُرْقَةٌ':Predicate, #1: 1	أَشْبَهَ فِرْعَوْنَ
u'أَشْبَهَ فَسْخٌ':Predicate, #2: 2	أَشْبَهَ الْفُرْقَةَ
u'أَشْبَهَ فَهْدٌ':Predicate, #1: 1	أَشْبَهَ الْفَسْخَ
u'أَشْبَهَ قَرَابَةٌ':Predicate, #1: 1	أَشْبَهَ الْفَهْدَ
u'أَشْبَهَ قول':Subject, #1: 1	أَشْبَهَ الْقَرَابَةَ
u'أَشْبَهَ قَوْلٌ':Subject, #2: 2	أَشْبَهَ قَوْلُهُ
u'أَشْبَهَ قول':Subject, #2: 2	أَشْبَهَ قَوْلُهُ
u'أَشْبَهَ قَوْلٌ':Subject, #5: 5	أَشْبَهَ قَوْلُ
u'أَشْبَهَ قيام':Predicate, #5: 5	أَشْبَهَ قَوْلُ
u'أَشْبَهَ قِيَامٌ':Predicate, #1: 1	أَشْبَهَ الْقِيَامَ
u'أَشْبَهَ كُفَّارٌ':Predicate, #1: 1	أَشْبَهَ الْقِيَامَ
u'أَشْبَهَ كَلاَمٌ':Predicate, #2: 2	أَشْبَهَ الْكُفَّارَ
u'أَشْبَهَ مَسْكَنٌ':Predicate, #2: 2	أَشْبَهَ كَلَامَ
u'أَشْبَهَ مَعِيبٌ':Predicate, #1: 1	أَشْبَهَ الْمَسْكَنَ
u'أَشْبَهَ مُقَوَّمٌ':Predicate, #1: 1	أَشْبَهَ الْمَعِيبَ
u'أَشْبَهَ مَنِيٌّ':Predicate, #1: 1	أَشْبَهَ الْمُقَوَّمَ
u'أَشْبَهَ مَوْرُوثٌ':Predicate, #1: 1	أَشْبَهَ الْمَنِيَّ
u'أَشْبَهَ نَفَقَةٌ':Predicate, #1: 1	أَشْبَهَ الْمَوْرُوثَ
u'أَشْبَهَ نكاح':Predicate, #2: 2	أَشْبَهَ نَفَقَةَ
u'أَشْبَهَ نِكَاحٌ':Predicate, #1: 1	أَشْبَهَ النِّكَاحَ
u'أَشْبَهَ وُجُودِيٌّ':Predicate, #1: 1	أَشْبَهَ النِّكَاحَ
u'أَشْبَهَ ولد':Subject, #1: 1	أَشْبَهَ الْوُجُودِيَّ
u'أَشْبَهَ وَلَدٌ':Subject, #6: 6	أَشْبَهَ الْوَلَدُ
u'أَشْبَهَ وَلِيٌّ':Predicate, #6: 6	أَشْبَهَ الْوَلَدُ
u'أَشْتَاتٌ رِوايَةٌ':Added, #1: 1	أَشْبَهَ الْوَلِيَّ
u'أَشْتَاتٌ عُلُومٌ':Added, #1: 1	أَشْتَاتُ الرِّوَايَةِ
u'أَشْتَاتٌ فَضَائِلُ':Added, #1: 1	أَشْتَاتِ الْعُلُومِ
u'أَشَدَّ أفْضَلُ':Subject, #1: 1	أَشْتَاتِ الْفَضَائِلِ
u'أَشَدَّ تَعْجِيل':Predicate, #1: 1	أَشَدَّ أَفْضَلُ
u'أَشَدَّ حَرٌّ':Predicate, #1: 1	أَشَدَّ تَعْجِيلاً
u'أَشَدَّ صَوْتٌ':Predicate, #1: 1	أَشَدَّ حَرَّ
u'أَشَدَّ مَسْأَلَةٌ':Predicate, #1: 1	أَشَدَّ صَوْتَكَ
u'أَشَدَّ وَجَعٌ':Predicate, #1: 1	أَشَدَّ مَسْأَلَتَكَ
u'أَشْرَاطٌ سَاعَةٌ':Added, #1: 1	أَشَدَّ وَجَعَ
u'أَشْرَاطٌ سَاعَةٌ':Added, #1: 1	أَشْرَاطَ السَّاعَةِ
u'أَشْرَاطٌ سَاعَةٌ':Added, #26: 26	أَشْرَاطِ السَّاعَةِ
u'أشراف أشراف':Added, #4: 4	أَشْرَاطُ السَّاعَةِ
u'أشراف أَشْرَافٌ':Added, #3: 3	أَشْرَافِ الْأَشْرَافِ
u'أَشْرَافٌ أشراف':Added, #3: 3	أَشْرَافِ الْأَشْرَافِ
u'أَشْرَافٌ أَشْرَافٌ':Added, #3: 3	أَشْرَافِ الْأَشْرَافِ
u'أشراف أهْلٌ':Added, #3: 3	أَشْرَافِ الْأَشْرَافِ
u'أَشْرَافٌ أهْلٌ':Added, #1: 1	أَشْرَافِ أَهْلِ
u'أشراف عَبْدٌ':Added, #1: 1	أَشْرَافِ أَهْلِ
u'أَشْرَافٌ عَبْدٌ':Added, #1: 1	أَشْرَافُ عَبْدِ
u'أشراف عَرَبٌ':Added, #1: 1	أَشْرَافُ عَبْدِ
u'أَشْرَافٌ عَرَبٌ':Added, #1: 1	أَشْرَافُ الْعَرَبِ
u'أشراف عَرَبٌ':Added, #1: 1	أَشْرَافُ الْعَرَبِ
u'أَشْرَافٌ عَرَبٌ':Added, #3: 3	أَشْرَافِ الْعَرَبِ
u'أشراف قُرَيْشٌ':Added, #3: 3	أَشْرَافِ الْعَرَبِ
u'أَشْرَافٌ قُرَيْشٌ':Added, #1: 1	أَشْرَافُ قُرَيْشٍ
u'أشراف قُرَيْشٌ':Added, #1: 1	أَشْرَافُ قُرَيْشٍ
u'أَشْرَافٌ قُرَيْشٌ':Added, #3: 3	أَشْرَافَ قُرَيْشٍ
u'أشراف قُرَيْشٌ':Added, #3: 3	أَشْرَافَ قُرَيْشٍ
u'أَشْرَافٌ قُرَيْشٌ':Added, #6: 6	أَشْرَافِ قُرَيْشٍ
u'أشراف قَوْمٌ':Added, #6: 6	أَشْرَافِ قُرَيْشٍ
u'أَشْرَافٌ قَوْمٌ':Added, #1: 1	أَشْرَافِ الْقَوْمِ
u'أشراف قَوْمٌ':Added, #1: 1	أَشْرَافِ الْقَوْمِ
u'أَشْرَافٌ قَوْمٌ':Added, #2: 2	أَشْرَافُ قَوْمِهِ
u'أشراف نَاسٌ':Added, #2: 2	أَشْرَافُ قَوْمِهِ
u'أَشْرَافٌ نَاسٌ':Added, #1: 1	أَشْرَافَ النَّاسِ
u'أشراف نَاسٌ':Added, #1: 1	أَشْرَافَ النَّاسِ
u'أشراف نَاسٌ':Added, #2: 2	أَشْرَافِ النّاسِ
u'أَشْرَافٌ نَاسٌ':Added, #2: 2	أَشْرَافِ النَّاسِ
u'أَشْرَافٌ نَاسٌ':Added, #2: 2	أَشْرَافِ النّاسِ
u'أشراف نَاسٌ':Added, #2: 2	أَشْرَافِ النَّاسِ
u'أَشْرَافٌ نَاسٌ':Added, #3: 3	أَشْرَافُ النَّاسِ
u'أشراف يمن':Added, #3: 3	أَشْرَافُ النَّاسِ
u'أشراف يَمَنُ':Added, #2: 2	أَشْرَافِ الْيَمَنِ
u'أَشْرَافٌ يمن':Added, #2: 2	أَشْرَافِ الْيَمَنِ
u'أَشْرَافٌ يَمَنُ':Added, #2: 2	أَشْرَافِ الْيَمَنِ
u'أَشْرَبَ مَاءٌ':Predicate, #2: 2	أَشْرَافِ الْيَمَنِ
u'أَشْرَعَ رَجُلٌ':Subject, #1: 1	أَشْرَبَ الْمَاءَ
u'أَشْرَفَ ثَوْرٌ':Subject, #1: 1	أَشْرَعَ رَجُلٌ
u'أَشْرَفَ جِدار':Subject, #1: 1	أَشْرَفَ ثَوْرُهُ
u'أَشْرَفَ جَمَاعَةٌ':Subject, #2: 2	أَشْرَفَ الْجِدَارُ
u'أَشْرَفَ رَسُولٌ':Subject, #1: 1	أَشْرَفَ جَمَاعَةٌ
u'أَشْرَفَ رَقيقٌ':Subject, #2: 2	أَشْرَفَ رَسُولُ
u'أَشْرَفَ رَقيق':Subject, #1: 1	أَشْرَفَ الرَّقِيقُ
u'أَشْرَفَ شَيْءٌ':Subject, #1: 1	أَشْرَفَ الرَّقِيقُ
u'أَشْرَفَ صَاحِبٌ':Subject, #1: 1	أَشْرَفَ الشَّيْءُ
u'أَشْرَفَ عند':Predicate, #1: 1	أَشْرَفَ صَاحِبُهُ
u'أَشْرَفَ فلان':Subject, #1: 1	أَشْرَفَ عِنْدَ
u'أَشْرَفَ مُقَاتِلٌ':Predicate, #2: 2	أَشْرَفَ عُثْمَانُ
u'أَشْرَفَ نَاسٌ':Subject, #1: 1	أَشْرَفَ الْمُقَاتِلِينَ
u'أَشْرَفَ نَبِيٌّ':Subject, #1: 1	أَشْرَفَ النَّاسُ
u'أَشْرَفَ نكاح':Subject, #1: 1	أَشْرَفَ النَّبِيُّ
u'أَشْرَفَ نِكَاحٌ':Subject, #1: 1	أَشْرَفَ النِّكَاحُ
u'أَشْرَقَ بَلَدٌ':Subject, #1: 1	أَشْرَفَ النِّكَاحُ
u'أَشْرَقَ نُورٌ':Subject, #1: 1	أَشْرَقَ الْبَلَدُ
u'أَشْرَكَ إِخْوَةٌ':Predicate, #1: 1	أَشْرَقَ نُورُهُ
u'أَشْرَكَ بَيْنٌ':Predicate, #1: 1	أَشْرَكَ الإِخْوَةَ
u'أَشْرَكَ ثَالِثٌ':Predicate, #3: 3	أَشْرَكَ بَيْنَ
u'أَشْرَكَ جَازٌ':Predicate, #2: 2	أَشْرَكَ الثَّالِثَ
u'أَشْرَكَ حَديثٌ':Predicate, #1: 1	أَشْرَكَ جَازَ
u'أَشْرَكَ رابع':Predicate, #3: 3	أَشْرَكَ الْحَدِيثَ
u'أَشْرَكَ رَابِعٌ':Predicate, #1: 1	أَشْرَكَ الرَّابِعَةَ
u'أَشْرَكَ رَجُلٌ':Subject, #1: 1	أَشْرَكَ الرَّابِعَةَ
u'أَشْرَكَ رَسُولٌ':Subject, #1: 1	أَشْرَكَ رَجُلٌ
u'أَشْرَكَ سِتٌّ':Predicate, #1: 1	أَشْرَكَ رَسُولُ
u'أَشْرَكَ طوال':Predicate, #1: 1	أَشْرَكَ سِتَّةً
u'أَشْرَكَ غير':Predicate, #1: 1	أَشْرَكَ طَوَالَ
u'أَشْرَكَ غَيْرٌ':Predicate, #1: 1	أَشْرَكَ غَيْرَهُنَّ
u'أَشْرَكَ قَوْمٌ':Predicate, #1: 1	أَشْرَكَ غَيْرَهُنَّ
u'أَشْعَارٌ أهْلٌ':Added, #1: 1	أَشْرَكَ الْقَوْمَ
u'أَشْعَارٌ بَدْرٌ':Added, #1: 1	أَشْعَارِ أَهْلِ
u'أَشْعَارٌ بَعْضٌ':Added, #2: 2	أَشْعَارِ بَدْرٍ
u'أَشْعَارٌ جَاهِلِيٌّ':Added, #1: 1	أَشْعَارِ بَعْضِ
u'أَشْعَارٌ جَاهِلِيَّةٌ':Added, #1: 1	أَشْعَارِ الْجَاهِلِيَّةِ
u'أَشْعَارٌ جبناء':Added, #1: 1	أَشْعَارِ الْجَاهِلِيَّةِ
u'أَشْعَارٌ سِيَرٌ':Added, #1: 1	أَشْعَارِ الْجُبَنَاءِ
u'أَشْعَارٌ سيرَةٌ':Added, #2: 2	أَشْعَارِ السّيَرِ
u'أَشْعَارٌ ضرار':Added, #1: 1	أَشْعَارِ السّيرَةِ
u'أَشْعَارٌ عَرَبٌ':Added, #1: 1	أَشْعَارِ ضِرَارٍ
u'أَشْعَارٌ عَرَبٌ':Added, #2: 2	أَشْعَارِ الْعَرَبِ
u'أَشْعَارٌ قدماء':Added, #3: 3	أَشْعَارُ الْعَرَبِ
u'أَشْعَارٌ كَلاَمٌ':Added, #1: 1	أَشْعَارِ الْقُدَمَاءِ
u'أَشْعَارٌ يَوْمٌ':Added, #1: 1	أَشْعَارِ كَلَامِ
u'أَشْعَرَ بدن':Predicate, #3: 3	أَشْعَارِ يَوْمِ
u'أَشْعَرَ بُدْنٌ':Predicate, #1: 1	أَشْعَرَ الْبُدْنَ
u'أَشْعَرَ بدن':Predicate, #1: 1	أَشْعَرَ الْبُدْنَ
u'أَشْعَرَ بَدَنٌ':Predicate, #2: 2	أَشْعَرَ الْبَدَنَ
u'أَشْعَرَ جَنِينٌ':Subject, #2: 2	أَشْعَرَ الْبَدَنَ
u'أَشْعَرَ حالٌ':Subject, #1: 1	أَشْعَرَ الْجَنِينُ
u'أَشْعَرَ رَسُولٌ':Subject, #1: 1	أَشْعَرَ الْحَالُ
u'أَشْعَرَ سُكُوتٌ':Subject, #1: 1	أَشْعَرَ رَسُولُ
u'أَشْعَرَ قول':Subject, #1: 1	أَشْعَرَ سُكُوتُهُ
u'أَشْعَرَ قَوْلٌ':Subject, #6: 6	أَشْعَرَ قَوْلُ
u'أَشْعَرَ قول':Subject, #6: 6	أَشْعَرَ قَوْلُ
u'أَشْعَرَ قَوْلٌ':Subject, #6: 6	أَشْعَرَ قَوْلُهُ
u'أَشْعَرَ كَلاَمٌ':Subject, #6: 6	أَشْعَرَ قَوْلُهُ
u'أَشْعَرَ كَلاَمٌ':Subject, #1: 1	أَشْعَرَ كَلَامُهُ
u'أَشْعَرَ هَدْيٌ':Predicate, #4: 4	أَشْعَرَ كَلَامُ
u'أَشْعَلَ طرف':Predicate, #1: 1	أَشْعَرَ الْهَدْيَ
u'أَشْعَلَ طَرَفٌ':Predicate, #1: 1	أَشْعَلَ طَرَفَ
u'أَشْغَلَ ظَرْفٌ':Predicate, #1: 1	أَشْعَلَ طَرَفَ
u'أَشْغَلَ هَوَاءٌ':Predicate, #1: 1	أَشْغَلَ ظَرْفَ
u'أَشْفَاعٌ عَشْرٌ':Added, #1: 1	أَشْغَلَ هَوَاءَ
u'أَشْفَقَ نَبِيٌّ':Subject, #1: 1	أَشْفَاعِ الْعَشْرِ
u'أَشْفَى عَيٌّ':Predicate, #1: 1	أَشْفَقَ النَّبِيُّ
u'أَشْفَى وَرِعٌ':Predicate, #1: 1	أَشْفَى الْعَيَّ
u'أَشْكَالٌ لعان':Added, #1: 1	أَشْفَى وَرِعَ
u'أَشْكَلَ أرْبَابٌ':Subject, #1: 1	أَشْكَالَ اللِّعَانِ
u'أَشْكَلَ أقْرَع':Predicate, #1: 1	أَشْكَلَ أَرْبَابُهُ
u'أَشْكَلَ أَمْرٌ':Subject, #1: 1	أَشْكَلَ أَقْرَعَ
u'أَشْكَلَ أَمْرٌ':Subject, #5: 5	أَشْكَلَ الْأَمْرُ
u'أَشْكَلَ أَوَّلُ':Subject, #5: 5	أَشْكَلَ أَمْرُهُ
u'أَشْكَلَ تَقْسيطٌ':Subject, #1: 1	أَشْكَلَ الْأَوَّلُ
u'أَشْكَلَ تَوْجِيهٌ':Subject, #1: 1	أَشْكَلَ التَّقْسِيطُ
u'أَشْكَلَ جَوَابٌ':Subject, #1: 1	أَشْكَلَ تَوْجِيهُ
u'أَشْكَلَ حالٌ':Subject, #1: 1	أَشْكَلَ جَوَابُهُ
u'أَشْكَلَ حالٌ':Subject, #1: 1	أَشْكَلَ حَالُهُ
u'أَشْكَلَ حالٌ':Subject, #2: 2	أَشْكَلَ حَالُ
u'أَشْكَلَ حُكْمٌ':Subject, #4: 4	أَشْكَلَ الْحَالُ
u'أَشْكَلَ خرق':Subject, #2: 2	أَشْكَلَ الْحُكْمُ
u'أَشْكَلَ خَرْقٌ':Subject, #1: 1	أَشْكَلَ الْخَرْقُ
u'أَشْكَلَ رَمَضانُ':Subject, #1: 1	أَشْكَلَ الْخَرْقُ
u'أَشْكَلَ سَابِقٌ':Subject, #1: 1	أَشْكَلَ رَمَضَانُ
u'أَشْكَلَ سِنٌّ':Subject, #2: 2	أَشْكَلَ السَّابِقُ
u'أَشْكَلَ شَيْءٌ':Subject, #1: 1	أَشْكَلَ سِنُّ
u'أَشْكَلَ فرق':Predicate, #1: 1	أَشْكَلَ شَيْءٌ
u'أَشْكَلَ فَرْقٌ':Predicate, #1: 1	أَشْكَلَ الْفَرْقَ
u'أَشْكَلَ كَيْفِيَّةٌ':Subject, #1: 1	أَشْكَلَ الْفَرْقَ
u'أَشْكَلَ مَذْهَبٌ':Subject, #1: 1	أَشْكَلَ كَيْفِيَّةُ
u'أَشْكَلَ مَنْطُوقٌ':Subject, #1: 1	أَشْكَلَ مَذْهَبُ
u'أَشْكَلَ وَقْتٌ':Predicate, #1: 1	أَشْكَلَ مَنْطُوقُهُ
u'أَشَلَّ أَنْفٌ':Predicate, #1: 1	أَشْكَلَ وَقْتَ
u'أَشَلَّ دِيَةٌ':Subject, #1: 1	أَشَلَّ الْأَنْفَ
u'أَشَلَّ مَارِنٌ':Predicate, #1: 1	أَشَلَّ دِيَةٌ
u'أَشْمَتَ أَعْدَاءٌ':Predicate, #2: 2	أَشَلَّ الْمَارِنَ
u'أَشْهَدَ أَبٌ':Subject, #1: 1	أَشْمَتَ الْأَعْدَاءَ
u'أَشْهَدَ أحَدٌ':Subject, #1: 1	أَشْهَدَ الْأَبُ
u'أَشْهَدَ بَاعِثٌ':Subject, #1: 1	أَشْهَدَ أَحَدُ
u'أَشْهَدَ بَائِعٌ':Subject, #1: 1	أَشْهَدَ الْبَاعِثُ
u'أَشْهَدَ جمعة':Predicate, #2: 2	أَشْهَدَ الْبَائِعُ
u'أَشْهَدَ جُمُعَةٌ':Predicate, #1: 1	أَشْهَدَ الْجُمُعَةَ
u'أَشْهَدَ رَبُّ':Subject, #1: 1	أَشْهَدَ الْجُمُعَةَ
u'أَشْهَدَ رَجُلٌ':Subject, #1: 1	أَشْهَدَ رَبُّ
u'أَشْهَدَ رَجُلٌ':Subject, #2: 2	أَشْهَدَ رَجُلٌ
u'أَشْهَدَ سقط':Predicate, #4: 4	أَشْهَدَ الرَّجُلُ
u'أَشْهَدَ سَقَطٌ':Predicate, #1: 1	أَشْهَدَ سَقَطَ
u'أَشْهَدَ صَاحِبٌ':Subject, #1: 1	أَشْهَدَ سَقَطَ
u'أَشْهَدَ عند':Predicate, #1: 1	أَشْهَدَ صَاحِبُ
u'أَشْهَدَ غَاصِبٌ':Subject, #12: 12	أَشْهَدَ عِنْدَ
u'أَشْهَدَ فُلاَنٌ':Subject, #1: 1	أَشْهَدَ الْغَاصِبُ
u'أَشْهَدَ قَالٌ':Predicate, #2: 2	أَشْهَدَ فُلَانٌ
u'أَشْهَدَ مَجْرُوحٌ':Subject, #3: 3	أَشْهَدَ قَالَ
u'أَشْهَدَ مَكْفُولٌ':Predicate, #1: 1	أَشْهَدَ الْمَجْرُوحُ
u'أَشْهَدَ مُلْتَقِط':Subject, #1: 1	أَشْهَدَ الْمَكْفُولَ
u'أَشْهَدَ نَاظِرٌ':Subject, #5: 5	أَشْهَدَ الْمُلْتَقِطُ
u'أَشْهَدَ وَاقِفٌ':Subject, #1: 1	أَشْهَدَ النَّاظِرُ
u'أَشْهَدَ وَتَرٌ':Predicate, #1: 1	أَشْهَدَ الْوَاقِفُ
u'أَشْهَدَ وَقْتٌ':Predicate, #1: 1	أَشْهَدَ وَتَرَكَ
u'أَشْهُرٌ تَسْيِيرٌ':Added, #8: 8	أَشْهَدَ وَقْتَ
u'أَشْهُرٌ حَجٌّ':Added, #1: 1	أَشْهُرَ التَّسْيِيرِ
u'أَشْهُرٌ حَجٌّ':Added, #12: 12	أَشْهُرَ الْحَجِّ
u'أَشْهُرٌ حَجٌّ':Added, #31: 31	أَشْهُرُ الْحَجِّ
u'أَشْهُرٌ حَجٌّ':Added, #339: 339	أَشْهُرِ الْحَجِّ
u'أَشْهُرٌ حَرامٌ':Added, #3: 3	أَشْهُر الْحَجِّ
u'أَشْهُرٌ حَرامٌ':Added, #1: 1	أَشْهُرَ الْحَرَامِ
u'أَشْهُرٌ حُرُمٌ':Added, #1: 1	أَشْهُرِ الْحَرَامِ
u'أَشْهُرٌ حَمْلٌ':Added, #2: 2	أَشْهُرِ الْحُرُمِ
u'أَشْهُرٌ عَامٌ':Added, #1: 1	أَشْهُرِ الْحَمْلِ
u'أَشْهُرٌ عِدَّةٌ':Added, #1: 1	أَشْهُرِ الْعَامِ
u'أَشْهُرٌ مُدَّةٌ':Added, #1: 1	أَشْهُرِ الْعِدَّةِ
u'أَشْهُرٌ وَجْهٌ':Added, #2: 2	أَشْهُرِ مُدَّةِ
u'أَشْهَى عند':Predicate, #2: 2	أَشْهُرُ الْوَجْهَيْنِ
u'أَشْوَاطٌ رَمَلٌ':Added, #1: 1	أَشْهَى عِنْدَكَ
u'أَشْوَاطٌ صَدْرٌ':Added, #1: 1	أَشْوَاطِ الرَّمَلِ
u'أَشْوَاطٌ طواف':Added, #1: 1	أَشْوَاطِ الصَّدْرِ
u'أَشْوَاطٌ طَوَافٌ':Added, #1: 1	أَشْوَاطُ الطَّوَافِ
u'أَشْوَاطٌ طواف':Added, #1: 1	أَشْوَاطُ الطَّوَافِ
u'أَشْوَاطٌ طواف':Added, #1: 1	أَشْوَاطُ طَوَافٍ
u'أَشْوَاطٌ طَوَافٌ':Added, #1: 1	أَشْوَاطِ طَوَافِ
u'أَشْوَاطٌ طَوَافٌ':Added, #1: 1	أَشْوَاطُ طَوَافٍ
u'أَشْوَاطٌ طواف':Added, #1: 1	أَشْوَاطِ طَوَافِ
u'أَشْوَاطٌ طَوَافٌ':Added, #3: 3	أَشْوَاطَ الطَّوَافِ
u'أَشْوَاطٌ طواف':Added, #3: 3	أَشْوَاطَ الطَّوَافِ
u'أَشْوَاطٌ طَوَافٌ':Added, #8: 8	أَشْوَاطِ الطَّوَافِ
u'أَشْوَاطٌ عمرة':Added, #8: 8	أَشْوَاطِ الطَّوَافِ
u'أَشْوَاطٌ عُمْرَةٌ':Added, #4: 4	أَشْوَاطِ الْعُمْرَةِ
u'أَصَابَ أَبٌ':Predicate, #4: 4	أَشْوَاطِ الْعُمْرَةِ
u'أَصَابَ اِبْنٌ':Predicate, #1: 1	أَصَابَ الْأَبَ
u'أَصَابَ أَجِيرٌ':Subject, #6: 6	أَصَابَ ابْنَ
u'أَصَابَ أحَدٌ':Predicate, #1: 1	أَصَابَ الْأَجِيرُ
u'أَصَابَ أحَدٌ':Subject, #2: 2	أَصَابَ أَحَدَ
u'أَصَابَ أَحْيَاءٌ':Predicate, #1: 1	أَصَابَ أَحَدُ
u'أَصَابَ أَرَاضِي':Predicate, #1: 1	أَصَابَ الْأَحْيَاءَ
u'أَصَابَ أَرْبَعُ':Predicate, #2: 2	أَصَابَ الْأَرَاضِيَ
u'أَصَابَ أَرْبَعَةٌ':Predicate, #1: 1	أَصَابَ الْأَرْبَعَ
u'أَصَابَ أرْضٌ':Predicate, #1: 1	أَصَابَ الْأَرْبَعَةَ
u'أَصَابَ أرْضٌ':Predicate, #1: 1	أَصَابَ الأَرْضَ
u'أَصَابَ أَسْفَلُ':Predicate, #8: 8	أَصَابَ الْأَرْضَ
u'أَصَابَ إِسْنادٌ':Predicate, #1: 1	أَصَابَ الْأَسْفَلَ
u'أَصَابَ أَصْحَابٌ':Predicate, #1: 1	أَصَابَ الإِسْنَادَ
u'أَصَابَ أصل':Predicate, #1: 1	أَصَابَ أَصْحَابَ
u'أَصَابَ أًصْلٌ':Predicate, #5: 5	أَصَابَ الْأَصْلَ
u'أَصَابَ أعْيانٌ':Subject, #5: 5	أَصَابَ الْأَصْلَ
u'أَصَابَ أَعْيَانٌ':Subject, #1: 1	أَصَابَ الْأَعْيَانُ
u'أَصَابَ أقرباء':Predicate, #1: 1	أَصَابَ الْأَعْيَانُ
u'أَصَابَ ألف':Predicate, #1: 1	أَصَابَ الْأَقْرِبَاءَ
u'أَصَابَ ألْفٌ':Predicate, #1: 1	أَصَابَ الْأَلْفَ
u'أَصَابَ أَلْفٌ':Predicate, #1: 1	أَصَابَ الْأَلْفَ
u'أَصَابَ ألف':Subject, #1: 1	أَصَابَ الْأَلْفَ
u'أَصَابَ ألْفٌ':Subject, #1: 1	أَصَابَ الْأَلْفُ
u'أَصَابَ أَلْفٌ':Subject, #1: 1	أَصَابَ الْأَلْفُ
u'أَصَابَ أُمٌّ':Predicate, #1: 1	أَصَابَ الْأَلْفُ
u'أَصَابَ أُمٌّ':Subject, #8: 8	أَصَابَ الْأُمَّ
u'أَصَابَ إمَامٌ':Predicate, #1: 1	أَصَابَ أُمّهُ
u'أَصَابَ إمَامٌ':Subject, #1: 1	أَصَابَ الْإِمَامَ
u'أَصَابَ أمَانَةٌ':Predicate, #2: 2	أَصَابَ الْإِمَامُ
u'أَصَابَ أُمَمٌ':Predicate, #1: 1	أَصَابَ الْأَمَانَةَ
u'أَصَابَ أموات':Predicate, #1: 1	أَصَابَ الْأُمَمَ
u'أَصَابَ أَميرٌ':Subject, #1: 1	أَصَابَ الْأَمْوَاتَ
u'أَصَابَ إِناءٌ':Predicate, #1: 1	أَصَابَ الْأَمِيرُ
u'أَصَابَ إِناثٌ':Predicate, #1: 1	أَصَابَ الْإِنَاءَ
u'أَصَابَ أنصار':Predicate, #1: 1	أَصَابَ الْإِنَاثَ
u'أَصَابَ أَنْصارٌ':Predicate, #1: 1	أَصَابَ الأَنْصَارَ
u'أَصَابَ أَنْصَارٌ':Predicate, #1: 1	أَصَابَ الأَنْصَارَ
u'أَصَابَ أهْلٌ':Predicate, #1: 1	أَصَابَ الأَنْصَارَ
u'أَصَابَ أهْلٌ':Subject, #5: 5	أَصَابَ أَهْلَ
u'أَصَابَ أوانِي':Predicate, #7: 7	أَصَابَ أَهْلُ
u'أَصَابَ أَوَّلُ':Predicate, #1: 1	أَصَابَ أَوَانِيَ
u'أَصَابَ أَوَّلُ':Subject, #1: 1	أَصَابَ الْأَوَّلَ
u'أَصَابَ أَوْلاَدٌ':Predicate, #1: 1	أَصَابَ الْأَوَّلُ
u'أَصَابَ أَوْلاَدٌ':Subject, #1: 1	أَصَابَ أَوْلَادَ
u'أَصَابَ بدن':Predicate, #1: 1	أَصَابَ الْأَوْلَادُ
u'أَصَابَ بَدَنٌ':Predicate, #2: 2	أَصَابَ الْبَدَنَ
u'أَصَابَ بدن':Predicate, #2: 2	أَصَابَ الْبَدَنَ
u'أَصَابَ بَدَنٌ':Predicate, #2: 2	أَصَابَ بَدَنَ
u'أَصَابَ بَعْضٌ':Predicate, #2: 2	أَصَابَ بَدَنَ
u'أَصَابَ بَعْضٌ':Subject, #2: 2	أَصَابَ بَعْضَ
u'أَصَابَ بَعيرٌ':Predicate, #2: 2	أَصَابَ الْبَعْضُ
u'أَصَابَ بَعيرٌ':Subject, #1: 1	أَصَابَ الْبَعِيرَ
u'أَصَابَ بِنَاءٌ':Predicate, #1: 1	أَصَابَ الْبَعِيرُ
u'أَصَابَ بِنْتٌ':Predicate, #4: 4	أَصَابَ الْبِنَاءَ
u'أَصَابَ بَوْلٌ':Predicate, #6: 6	أَصَابَ بِنْتَ
u'أَصَابَ بَوْلٌ':Subject, #1: 1	أَصَابَ الْبَوْلَ
u'أَصَابَ بَوْلٌ':Subject, #1: 1	أَصَابَ بَوْلُ
u'أَصَابَ بَيْتٌ':Predicate, #2: 2	أَصَابَ الْبَوْلُ
u'أَصَابَ بيض':Predicate, #1: 1	أَصَابَ الْبَيْتَ
u'أَصَابَ بَيْنٌ':Predicate, #1: 1	أَصَابَ بَيْضَ
u'أَصَابَ تُرَابٌ':Subject, #1: 1	أَصَابَ بَيْنَ
u'أَصَابَ تِسْعَةٌ':Predicate, #1: 1	أَصَابَ التُّرَابُ
u'أَصَابَ تَفْسِيرٌ':Predicate, #1: 1	أَصَابَ تِسْعَةَ
u'أَصَابَ ثَابِتٌ':Predicate, #1: 1	أَصَابَ التَّفْسِيرَ
u'أَصَابَ ثَابِتٌ':Subject, #1: 1	أَصَابَ الثَّابِتَ
u'أَصَابَ ثَانِي':Predicate, #4: 4	أَصَابَ الثَّابِتُ
u'أَصَابَ ثَمَرٌ':Predicate, #1: 1	أَصَابَ الثَّانِيَ
u'أَصَابَ ثَمَرَةٌ':Predicate, #1: 1	أَصَابَ الثَّمَرَ
u'أَصَابَ ثَمَنٌ':Subject, #3: 3	أَصَابَ الثَّمَرَةَ
u'أَصَابَ ثَوْبٌ':Predicate, #2: 2	أَصَابَ ثَمَنُ
u'أَصَابَ ثَوْبٌ':Predicate, #29: 29	أَصَابَ الثَّوْبَ
u'أَصَابَ ثَوْبٌ':Subject, #7: 7	أَصَابَ ثَوْبَ
u'أَصَابَ جَارِي':Predicate, #2: 2	أَصَابَ الثَّوْبُ
u'أَصَابَ جَارِي':Predicate, #3: 3	أَصَابَ الْجَارِيَةَ
u'أَصَابَ جَارِيَةٌ':Predicate, #3: 3	أَصَابَ جَارِيَةً
u'أَصَابَ جُبّةٌ':Predicate, #3: 3	أَصَابَ الْجَارِيَةَ
u'أَصَابَ جُرْحٌ':Predicate, #1: 1	أَصَابَ جُبَّةَ
u'أَصَابَ جلد':Predicate, #1: 1	أَصَابَ الْجُرْحَ
u'أَصَابَ جِلْدٌ':Predicate, #1: 1	أَصَابَ جِلْدَ
u'أَصَابَ جلد':Predicate, #1: 1	أَصَابَ جِلْدَ
u'أَصَابَ جِلْدٌ':Predicate, #2: 2	أَصَابَ الْجِلْدَ
u'أَصَابَ جَمَاجِمُ':Predicate, #2: 2	أَصَابَ الْجِلْدَ
u'أَصَابَ جَوَاهِرُ':Predicate, #1: 1	أَصَابَ الْجَمَاجِمَ
u'أَصَابَ جَيْشٌ':Subject, #1: 1	أَصَابَ جَوَاهِرَ
u'أَصَابَ حائِطٌ':Predicate, #1: 1	أَصَابَ الْجَيْشُ
u'أَصَابَ حائِطٌ':Subject, #1: 1	أَصَابَ الْحَائِطَ
u'أَصَابَ حَبٌّ':Predicate, #1: 1	أَصَابَ الْحَائِطُ
u'أَصَابَ حَبَّةٌ':Predicate, #1: 1	أَصَابَ حَبَّةَ
u'أَصَابَ حَجَرٌ':Predicate, #1: 1	أَصَابَ حَبَّةَ
u'أَصَابَ حَجَرٌ':Subject, #2: 2	أَصَابَ الْحَجَرَ
u'أَصَابَ حَدٌّ':Predicate, #1: 1	أَصَابَ الْحَجَرُ
u'أَصَابَ حَديدٌ':Subject, #1: 1	أَصَابَ الْحَدَّ
u'أَصَابَ حِصَّةٌ':Predicate, #1: 1	أَصَابَ الْحَدِيدُ
u'أَصَابَ حَقٌّ':Predicate, #7: 7	أَصَابَ حِصَّةَ
u'أَصَابَ حَقِيبَةٌ':Predicate, #12: 12	أَصَابَ الْحَقَّ
u'أَصَابَ حَلالٌ':Predicate, #2: 2	أَصَابَ الْحَقِيبَةَ
u'أَصَابَ حَلالٌ':Subject, #1: 1	أَصَابَ الْحَلاَلَ
u'أَصَابَ حَلالٌ':Subject, #1: 1	أَصَابَ الْحَلاَلُ
u'أَصَابَ حَلالٌ':Subject, #2: 2	أَصَابَ الْحَلَالُ
u'أَصَابَ حِمَارٌ':Predicate, #2: 2	أَصَابَ حَلَالٌ
u'أَصَابَ خدمة':Predicate, #2: 2	أَصَابَ حِمَارَ
u'أَصَابَ خِدْمَةٌ':Predicate, #1: 1	أَصَابَ الْخِدْمَةَ
u'أَصَابَ خُسْران':Predicate, #1: 1	أَصَابَ الْخِدْمَةَ
u'أَصَابَ خُفٌّ':Predicate, #1: 1	أَصَابَ الْخُسْرَانَ
u'أَصَابَ خُفٌّ':Predicate, #2: 2	أَصَابَ خُفَّ
u'أَصَابَ خَمْسٌ':Predicate, #4: 4	أَصَابَ الْخُفَّ
u'أَصَابَ خوارج':Subject, #1: 1	أَصَابَ خَمْسَ
u'أَصَابَ خَوَارِجُ':Subject, #2: 2	أَصَابَ الْخَوَارِجُ
u'أَصَابَ دَجاج':Predicate, #2: 2	أَصَابَ الْخَوَارِجُ
u'أَصَابَ دَرَاهِمُ':Predicate, #1: 1	أَصَابَ الدَّجَاجَةَ
u'أَصَابَ دَمٌ':Predicate, #1: 1	أَصَابَ الدَّرَاهِمَ
u'أَصَابَ دِماغٌ':Predicate, #1: 1	أَصَابَ الدَّمَ
u'أَصَابَ دَنانيرُ':Predicate, #1: 1	أَصَابَ الدِّمَاغَ
u'أَصَابَ دونٌ':Predicate, #2: 2	أَصَابَ الدَّنَانِيرَ
u'أَصَابَ دِيَةٌ':Predicate, #1: 1	أَصَابَ دُونَ
u'أَصَابَ دِينارٌ':Subject, #1: 1	أَصَابَ الدِّيَةَ
u'أَصَابَ ذُكورٌ':Predicate, #1: 1	أَصَابَ الدِّينَارُ
u'أَصَابَ ذَهَبٌ':Predicate, #1: 1	أَصَابَ الذُّكُورَ
u'أَصَابَ ذَهَبٌ':Subject, #1: 1	أَصَابَ الذَّهَبَ
u'أَصَابَ رَاحِلٌ':Predicate, #1: 1	أَصَابَ الذَّهَبُ
u'أَصَابَ رَاحِلَةٌ':Predicate, #1: 1	أَصَابَ الرَّاحِلَةَ
u'أَصَابَ رَأْسٌ':Subject, #1: 1	أَصَابَ الرَّاحِلَةَ
u'أَصَابَ رَبُّ':Predicate, #3: 3	أَصَابَ رَأْسُهُ
u'أَصَابَ رَجُلٌ':Predicate, #1: 1	أَصَابَ رَبَّ
u'أَصَابَ رِجْلٌ':Predicate, #1: 1	أَصَابَ الرَّجُلَ
u'أَصَابَ رَجُلٌ':Subject, #1: 1	أَصَابَ رِجْلَكَ
u'أَصَابَ رَجُلٌ':Subject, #2: 2	أَصَابَ الرَّجُلُ
u'أَصَابَ رَسُولٌ':Predicate, #2: 2	أَصَابَ رَجُلٌ
u'أَصَابَ رَسُولٌ':Subject, #1: 1	أَصَابَ رَسُولَ
u'أَصَابَ رَقَبَةٌ':Predicate, #3: 3	أَصَابَ رَسُولُ
u'أَصَابَ رَقيقٌ':Predicate, #2: 2	أَصَابَ الرَّقَبَةَ
u'أَصَابَ رَقيق':Predicate, #1: 1	أَصَابَ الرَّقِيقَ
u'أَصَابَ زَرْعٌ':Predicate, #1: 1	أَصَابَ الرَّقِيقَ
u'أَصَابَ زَرْعٌ':Predicate, #1: 1	أَصَابَ زَرْعَ
u'أَصَابَ زَوْجٌ':Predicate, #9: 9	أَصَابَ الزَّرْعَ
u'أَصَابَ زِيادَةٌ':Predicate, #1: 1	أَصَابَ الزَّوْجَ
u'أَصَابَ زَيْتٌ':Predicate, #1: 1	أَصَابَ الزِّيَادَةَ
u'أَصَابَ زَيْدٌ':Subject, #1: 1	أَصَابَ الزَّيْتَ
u'أَصَابَ زَيْنَبٌ':Predicate, #1: 1	أَصَابَ زَيْدٌ
u'أَصَابَ سَاقِطٌ':Predicate, #1: 1	أَصَابَ زَيْنَبَ
u'أَصَابَ سِتٌّ':Predicate, #2: 2	أَصَابَ السَّاقِطَ
u'أَصَابَ سَقْفٌ':Predicate, #2: 2	أَصَابَ سِتَّةً
u'أَصَابَ سِلْعَةٌ':Predicate, #1: 1	أَصَابَ السَّقْفَ
u'أَصَابَ سُنَّةٌ':Predicate, #3: 3	أَصَابَ السِّلْعَةَ
u'أَصَابَ سَهْمٌ':Subject, #3: 3	أَصَابَ السُّنَّةَ
u'أَصَابَ سَهْمٌ':Subject, #1: 1	أَصَابَ السّهْمُ
u'أَصَابَ سَهْمٌ':Subject, #1: 1	أَصَابَ سَهْمٌ
u'أَصَابَ سَهْمٌ':Subject, #2: 2	أَصَابَ سَهْمُ
u'أَصَابَ سَهْمٌ':Subject, #4: 4	أَصَابَ سَهْمُهُ
u'أَصَابَ سُهَيْلٌ':Predicate, #9: 9	أَصَابَ السَّهْمُ
u'أَصَابَ سَيِّدٌ':Subject, #1: 1	أَصَابَ سُهَيْلاً
u'أَصَابَ سَيْفٌ':Subject, #2: 2	أَصَابَ السَّيِّدُ
u'أَصَابَ شَاةٌ':Predicate, #1: 1	أَصَابَ السّيْفُ
u'أَصَابَ شَاعِر':Subject, #1: 1	أَصَابَ الشَّاةَ
u'أَصَابَ شَهْرٌ':Predicate, #1: 1	أَصَابَ الشَّاعِرُ
u'أَصَابَ صَاحِبٌ':Predicate, #1: 1	أَصَابَ شَهْرَ
u'أَصَابَ صَاحِبٌ':Subject, #2: 2	أَصَابَ صَاحِبَ
u'أَصَابَ صَاحِبٌ':Subject, #1: 1	أَصَابَ صَاحِبُ
u'أَصَابَ صَبِيٌّ':Predicate, #1: 1	أَصَابَ صَاحِبُهُ
u'أَصَابَ صَبِيٌّ':Subject, #1: 1	أَصَابَ الصَّبِيَّ
u'أَصَابَ صَغِيرٌ':Subject, #3: 3	أَصَابَ الصَّبِيُّ
u'أَصَابَ صَيْدٌ':Predicate, #1: 1	أَصَابَ الصَّغِيرُ
u'أَصَابَ صَيْدٌ':Predicate, #1: 1	أَصَابَ صَيْدَ
u'أَصَابَ صَيْدٌ':Subject, #7: 7	أَصَابَ الصَّيْدَ
u'أَصَابَ ضَرْبٌ':Predicate, #1: 1	أَصَابَ الصَّيْدُ
u'أَصَابَ طرف':Predicate, #1: 1	أَصَابَ الضَّرْبَ
u'أَصَابَ طَرَفٌ':Predicate, #2: 2	أَصَابَ طَرَفَ
u'أَصَابَ طرف':Subject, #2: 2	أَصَابَ طَرَفَ
u'أَصَابَ طَرَفٌ':Subject, #1: 1	أَصَابَ الطَّرَفُ
u'أَصَابَ طَرِيقٌ':Predicate, #1: 1	أَصَابَ الطَّرَفُ
u'أَصَابَ طِينٌ':Subject, #1: 1	أَصَابَ طَرِيقَ
u'أَصَابَ ظِلْفٌ':Predicate, #1: 1	أَصَابَ الطِّينُ
u'أَصَابَ عِبَادٌ':Subject, #1: 1	أَصَابَ الظِّلْفَ
u'أَصَابَ عَبْدٌ':Predicate, #1: 1	أَصَابَ الْعِبَادُ
u'أَصَابَ عتق':Predicate, #3: 3	أَصَابَ الْعَبْدَ
u'أَصَابَ عِتْقٌ':Predicate, #6: 6	أَصَابَ الْعِتْقَ
u'أَصَابَ عتق':Subject, #6: 6	أَصَابَ الْعِتْقَ
u'أَصَابَ عِتْقٌ':Subject, #1: 1	أَصَابَ الْعِتْقُ
u'أَصَابَ عَذَابٌ':Subject, #1: 1	أَصَابَ الْعِتْقُ
u'أَصَابَ عَرْصَةٌ':Predicate, #2: 2	أَصَابَ الْعَذَابُ
u'أَصَابَ عَسْكَرٌ':Subject, #1: 1	أَصَابَ الْعَرْصَةَ
u'أَصَابَ عُضْوٌ':Predicate, #1: 1	أَصَابَ الْعَسْكَرُ
u'أَصَابَ عقر':Predicate, #1: 1	أَصَابَ الْعُضْوَ
u'أَصَابَ عُقْرٌ':Predicate, #1: 1	أَصَابَ الْعُقْرَ
u'أَصَابَ عَقُورٌ':Predicate, #1: 1	أَصَابَ الْعُقْرَ
u'أَصَابَ عَلَقَةٌ':Predicate, #1: 1	أَصَابَ الْعَقُورَ
u'أَصَابَ عَلِيٌّ':Subject, #1: 1	أَصَابَ الْعَلَقَةَ
u'أَصَابَ عُمَرٌ':Subject, #1: 1	أَصَابَ عَلِيٌّ
u'أَصَابَ عَمَلٌ':Subject, #3: 3	أَصَابَ عُمَرُ
u'أَصَابَ عنق':Predicate, #1: 1	أَصَابَ الْعَمَلُ
u'أَصَابَ عُنُقٌ':Predicate, #1: 1	أَصَابَ عُنُقَ
u'أَصَابَ عَيْبٌ':Subject, #1: 1	أَصَابَ عُنُقَ
u'أَصَابَ عِيرٌ':Predicate, #1: 1	أَصَابَ الْعَيْبُ
u'أَصَابَ عين':Predicate, #1: 1	أَصَابَ عِيرَ
u'أَصَابَ عَيْنٌ':Predicate, #3: 3	أَصَابَ عَيْنَ
u'أَصَابَ عَيْن':Predicate, #3: 3	أَصَابَ عَيْنَ
u'أَصَابَ غبار':Subject, #3: 3	أَصَابَ عَيْنَ
u'أَصَابَ غُبَارٌ':Subject, #2: 2	أَصَابَ الْغُبَارُ
u'أَصَابَ غَرَضٌ':Predicate, #2: 2	أَصَابَ الْغُبَارُ
u'أَصَابَ غرماء':Predicate, #3: 3	أَصَابَ الْغَرَضَ
u'أَصَابَ غُلاَمٌ':Subject, #1: 1	أَصَابَ الْغُرَمَاءَ
u'أَصَابَ غِلْمَانٌ':Subject, #1: 1	أَصَابَ الْغُلاَمُ
u'أَصَابَ غير':Predicate, #1: 1	أَصَابَ غِلْمَانُ
u'أَصَابَ غَيْرٌ':Predicate, #5: 5	أَصَابَ غَيْرَ
u'أَصَابَ غير':Subject, #5: 5	أَصَابَ غَيْرَ
u'أَصَابَ غَيْرٌ':Subject, #1: 1	أَصَابَ غَيْرُ
u'أَصَابَ غير':Subject, #1: 1	أَصَابَ غَيْرُ
u'أَصَابَ غَيْرٌ':Subject, #1: 1	أَصَابَ غَيْرُهُ
u'أَصَابَ فَاحِشٌ':Predicate, #1: 1	أَصَابَ غَيْرُهُ
u'أَصَابَ فَارِغٌ':Predicate, #1: 1	أَصَابَ فَاحِشَةً
u'أَصَابَ فَرْخٌ':Predicate, #3: 3	أَصَابَ الْفَارِغَ
u'أَصَابَ فِرْدَوْسٌ':Predicate, #1: 1	أَصَابَ فَرْخَ
u'أَصَابَ فَرَسٌ':Predicate, #1: 1	أَصَابَ الْفِرْدَوْسَ
u'أَصَابَ فَرِيقٌ':Predicate, #1: 1	أَصَابَ الْفَرَسَ
u'أَصَابَ فطرة':Predicate, #1: 1	أَصَابَ فَرِيقَ
u'أَصَابَ فِطْرَةٌ':Predicate, #3: 3	أَصَابَ الْفِطْرَةَ
u'أَصَابَ فقراء':Predicate, #3: 3	أَصَابَ الْفِطْرَةَ
u'أَصَابَ فلان':Predicate, #3: 3	أَصَابَ الْفُقَرَاءَ
u'أَصَابَ فَمٌ':Subject, #1: 1	أَصَابَ عُثْمَانَ
u'أَصَابَ قِبْلَةٌ':Predicate, #1: 1	أَصَابَ فَمُ
u'أَصَابَ قَرَابَةٌ':Predicate, #14: 14	أَصَابَ الْقِبْلَةَ
u'أَصَابَ قُرَبٌ':Predicate, #4: 4	أَصَابَ قَرَابَةَ
u'أَصَابَ قُرَبٌ':Subject, #1: 1	أَصَابَ الْقُرَبَ
u'أَصَابَ قَفِيز':Subject, #1: 1	أَصَابَ الْقُرَبُ
u'أَصَابَ قَوْمٌ':Subject, #1: 1	أَصَابَ الْقَفِيزُ
u'أَصَابَ قِيمَةٌ':Predicate, #1: 1	أَصَابَ الْقَوْمُ
u'أَصَابَ قِيمَةٌ':Predicate, #10: 10	أَصَابَ قِيمَةَ
u'أَصَابَ كَلْبٌ':Subject, #4: 4	أَصَابَ الْقِيمَةَ
u'أَصَابَ كَلْبٌ':Subject, #2: 2	أَصَابَ كَلْبُ
u'أَصَابَ كُمٌّ':Predicate, #3: 3	أَصَابَ الْكَلْبُ
u'أَصَابَ كُوزٌ':Predicate, #1: 1	أَصَابَ الْكُمَّ
u'أَصَابَ لبن':Predicate, #1: 1	أَصَابَ الْكُوزَ
u'أَصَابَ لَبَنٌ':Predicate, #1: 1	أَصَابَ اللَّبَنَ
u'أَصَابَ لِثَةٌ':Predicate, #1: 1	أَصَابَ اللَّبَنَ
u'أَصَابَ لِصٌّ':Subject, #1: 1	أَصَابَ اللِّثَةَ
u'أَصَابَ لَطِيم':Predicate, #1: 1	أَصَابَ اللِّصُّ
u'أَصَابَ لعاب':Subject, #1: 1	أَصَابَ لَطِيمَةً
u'أَصَابَ لُعَابٌ':Subject, #1: 1	أَصَابَ لُعَابُ
u'أَصَابَ مَاءٌ':Predicate, #1: 1	أَصَابَ لُعَابُ
u'أَصَابَ مَاءٌ':Subject, #7: 7	أَصَابَ الْمَاءَ
u'أَصَابَ مَالٌ':Predicate, #7: 7	أَصَابَ الْمَاءُ
u'أَصَابَ مَالٌ':Predicate, #1: 1	أَصَابَ مَالاً
u'أَصَابَ مَبِيعٌ':Predicate, #2: 2	أَصَابَ الْمَالَ
u'أَصَابَ مثل':Predicate, #1: 1	أَصَابَ الْمَبِيعَ
u'أَصَابَ مِثْلٌ':Predicate, #1: 1	أَصَابَ مِثْلَ
u'أَصَابَ مُحَابَاةٌ':Predicate, #1: 1	أَصَابَ مِثْلَ
u'أَصَابَ مُحْتَاجٌ':Predicate, #5: 5	أَصَابَ الْمُحَابَاةَ
u'أَصَابَ مُحْرِمٌ':Predicate, #1: 1	أَصَابَ الْمُحْتَاجِينَ
u'أَصَابَ مُحْرِمٌ':Subject, #1: 1	أَصَابَ الْمُحْرِمَ
u'أَصَابَ مُحْرِمٌ':Subject, #2: 2	أَصَابَ مُحْرِمٌ
u'أَصَابَ مَحَلٌّ':Predicate, #3: 3	أَصَابَ الْمُحْرِمُ
u'أَصَابَ مَدْيُونٌ':Predicate, #1: 1	أَصَابَ الْمَحَلَّ
u'أَصَابَ مَذْبَحٌ':Predicate, #1: 1	أَصَابَ الْمَدْيُونَ
u'أَصَابَ مَرِيضٌ':Predicate, #3: 3	أَصَابَ الْمَذْبَحَ
u'أَصَابَ مُزَارِعٌ':Subject, #1: 1	أَصَابَ الْمَرِيضَ
u'أَصَابَ مُسْتَحَقٌّ':Predicate, #2: 2	أَصَابَ الْمُزَارِعُ
u'أَصَابَ مُسْتَحِقٌّ':Predicate, #1: 1	أَصَابَ الْمُسْتَحَقَّ
u'أَصَابَ مُسْلِمٌ':Predicate, #3: 3	أَصَابَ الْمُسْتَحِقَّ
u'أَصَابَ مُسْلِمٌ':Predicate, #1: 1	أَصَابَ الْمُسْلِمَ
u'أَصَابَ مُسْلِمٌ':Predicate, #1: 1	أَصَابَ الْمُسْلِمِينَ
u'أَصَابَ مُسْلِمٌ':Subject, #4: 4	أَصَابَ مُسْلِمَةً
u'أَصَابَ مَسْمُوعٌ':Predicate, #1: 1	أَصَابَ الْمُسْلِمُ
u'أَصَابَ مُضَارِبٌ':Predicate, #2: 2	أَصَابَ الْمَسْمُوعَ
u'أَصَابَ مُضَارِبٌ':Subject, #1: 1	أَصَابَ الْمُضَارِبَ
u'أَصَابَ مَضْمُونٌ':Predicate, #1: 1	أَصَابَ الْمُضَارِبُ
u'أَصَابَ مَعِدَةٌ':Predicate, #1: 1	أَصَابَ الْمَضْمُونَ
u'أَصَابَ مَعْدِنٌ':Predicate, #1: 1	أَصَابَ الْمَعِدَةَ
u'أَصَابَ مِعْراض':Predicate, #1: 1	أَصَابَ مَعْدِنَ
u'أَصَابَ مِعْراض':Subject, #1: 1	أَصَابَ الْمِعْرَاضَ
u'أَصَابَ مَعْمُولٌ':Subject, #1: 1	أَصَابَ الْمِعْرَاضُ
u'أَصَابَ مَقْتَلٌ':Predicate, #1: 1	أَصَابَ الْمَعْمُولُ
u'أَصَابَ مُقَدَّمٌ':Subject, #2: 2	أَصَابَ الْمَقْتَلَ
u'أَصَابَ مَنِيٌّ':Subject, #1: 1	أَصَابَ الْمُقَدَّمَةُ
u'أَصَابَ مَهْرٌ':Predicate, #1: 1	أَصَابَ الْمَنِيُّ
u'أَصَابَ مَهْرٌ':Predicate, #6: 6	أَصَابَ الْمَهْرَ
u'أَصَابَ مَوْتٌ':Subject, #9: 9	أَصَابَ مَهْرَ
u'أَصَابَ مَوْضِعٌ':Predicate, #1: 1	أَصَابَ الْمَوْتُ
u'أَصَابَ مَوْضِعٌ':Predicate, #2: 2	أَصَابَ الْمَوْضِعَ
u'أَصَابَ مَوْضُوعٌ':Subject, #5: 5	أَصَابَ مَوْضِعَ
u'أَصَابَ مُؤْمِنٌ':Predicate, #1: 1	أَصَابَ الْمَوْضُوعُ
u'أَصَابَ مُؤْمِنٌ':Predicate, #1: 1	أَصَابَ الْمُؤْمِنِينَ
u'أَصَابَ نَاسٌ':Predicate, #2: 2	أَصَابَ الْمُؤْمِنَ
u'أَصَابَ نَاسٌ':Subject, #15: 15	أَصَابَ النَّاسَ
u'أَصَابَ نَاسٌ':Subject, #1: 1	أَصَابَ النّاسُ
u'أَصَابَ نَائِبٌ':Subject, #4: 4	أَصَابَ النَّاسُ
u'أَصَابَ نَبِيٌّ':Subject, #1: 1	أَصَابَ النَّائِبُ
u'أَصَابَ نَخْلٌ':Predicate, #1: 1	أَصَابَ النَّبِيُّ
u'أَصَابَ نِساءٌ':Predicate, #1: 1	أَصَابَ النَّخْلَ
u'أَصَابَ نُسُكٌ':Predicate, #2: 2	أَصَابَ النِّسَاءَ
u'أَصَابَ نَسْلٌ':Predicate, #5: 5	أَصَابَ النُّسُكَ
u'أَصَابَ نِصْفٌ':Predicate, #1: 1	أَصَابَ النَّسْلَ
u'أَصَابَ نَصِيبٌ':Predicate, #1: 1	أَصَابَ النِّصْفَ
u'أَصَابَ نَقْصٌ':Predicate, #1: 1	أَصَابَ نَصِيبَ
u'أَصَابَ نُقْصَانٌ':Predicate, #1: 1	أَصَابَ النَّقْصَ
u'أَصَابَ نَمَاءٌ':Predicate, #1: 1	أَصَابَ النُّقْصَانَ
u'أَصَابَ هَدَفٌ':Predicate, #4: 4	أَصَابَ النَّمَاءَ
u'أَصَابَ واحد':Predicate, #1: 1	أَصَابَ الْهَدَفَ
u'أَصَابَ وَاحِدٌ':Predicate, #1: 1	أَصَابَ الْوَاحِدَ
u'أَصَابَ واحد':Subject, #1: 1	أَصَابَ الْوَاحِدَ
u'أَصَابَ وَاحِدٌ':Subject, #2: 2	أَصَابَ وَاحِدٌ
u'أَصَابَ وَجَبٌ':Predicate, #2: 2	أَصَابَ وَاحِدٌ
u'أَصَابَ وَجْهٌ':Predicate, #1: 1	أَصَابَ وَجَبَ
u'أَصَابَ وُجُوبٌ':Predicate, #6: 6	أَصَابَ وَجْهَ
u'أَصَابَ وَرَثَةٌ':Subject, #1: 1	أَصَابَ وُجُوبَ
u'أَصَابَ وَصِيفٌ':Subject, #2: 2	أَصَابَ الْوَرَثَةُ
u'أَصَابَ وَكِيلٌ':Subject, #1: 1	أَصَابَ الْوَصِيفُ
u'أَصَابَ ولد':Predicate, #1: 1	أَصَابَ الْوَكِيلُ
u'أَصَابَ وَلَدٌ':Predicate, #4: 4	أَصَابَ الْوَلَدَ
u'أَصَابَ ولد':Predicate, #4: 4	أَصَابَ الْوَلَدَ
u'أَصَابَ وَلَدٌ':Predicate, #8: 8	أَصَابَ وَلَدَ
u'أَصَابَ ولد':Subject, #8: 8	أَصَابَ وَلَدَ
u'أَصَابَ وَلَدٌ':Subject, #2: 2	أَصَابَ الْوَلَدُ
u'أَصَابَ وَلِيدٌ':Predicate, #2: 2	أَصَابَ الْوَلَدُ
u'أَصْبَحَ إبْلِيسُ':Subject, #1: 1	أَصَابَ الْوَلِيدَ
u'أَصْبَحَ اِبْنٌ':Subject, #1: 1	أَصْبَحَ إبْلِيسُ
u'أَصْبَحَ أهْلٌ':Subject, #4: 4	أَصْبَحَ ابْنُ
u'أَصْبَحَ بَوْلٌ':Subject, #3: 3	أَصْبَحَ أَهْلُ
u'أَصْبَحَ حَقٌّ':Subject, #1: 1	أَصْبَحَ الْبَوْلُ
u'أَصْبَحَ خَبِيث':Predicate, #1: 1	أَصْبَحَ الْحَقُّ
u'أَصْبَحَ دَخَلٌ':Predicate, #6: 6	أَصْبَحَ خَبِيثَ
u'أَصْبَحَ دِينارٌ':Subject, #3: 3	أَصْبَحَ دَخَلَ
u'أَصْبَحَ ذكر':Predicate, #1: 1	أَصْبَحَ الدِّينَارُ
u'أَصْبَحَ ذَكَرٌ':Predicate, #1: 1	أَصْبَحَ ذَكَرَ
u'أَصْبَحَ ذكرة':Predicate, #1: 1	أَصْبَحَ ذَكَرَ
u'أَصْبَحَ رَجُلٌ':Subject, #1: 1	أَصْبَحَ ذَكَرْتهنَّ
u'أَصْبَحَ رَجُلٌ':Subject, #1: 1	أَصْبَحَ الرَّجُلُ
u'أَصْبَحَ رَسُولٌ':Subject, #2: 2	أَصْبَحَ رَجُلٌ
u'أَصْبَحَ ركب':Predicate, #12: 12	أَصْبَحَ رَسُولُ
u'أَصْبَحَ شرب':Predicate, #3: 3	أَصْبَحَ رَكِبَ
u'أَصْبَحَ صَوْتٌ':Subject, #2: 2	أَصْبَحَ شَرِبَ
u'أَصْبَحَ ضَيْفٌ':Subject, #1: 1	أَصْبَحَ صَوْتُ
u'أَصْبَحَ عَبْدٌ':Subject, #1: 1	أَصْبَحَ الضَّيْفُ
u'أَصْبَحَ عرف':Predicate, #1: 1	أَصْبَحَ عَبْدُ
u'أَصْبَحَ عُمَرٌ':Subject, #1: 1	أَصْبَحَ عَرَفَ
u'أَصْبَحَ عند':Predicate, #1: 1	أَصْبَحَ عُمَرُ
u'أَصْبَحَ غير':Predicate, #2: 2	أَصْبَحَ عِنْدَ
u'أَصْبَحَ غَيْرٌ':Predicate, #6: 6	أَصْبَحَ غَيْرَ
u'أَصْبَحَ فَرِيقٌ':Subject, #6: 6	أَصْبَحَ غَيْرَ
u'أَصْبَحَ قَالٌ':Predicate, #4: 4	أَصْبَحَ فَرِيقٌ
u'أَصْبَحَ قَوْمٌ':Subject, #9: 9	أَصْبَحَ قَالَ
u'أَصْبَحَ مُحَمَّدٌ':Subject, #2: 2	أَصْبَحَ الْقَوْمُ
u'أَصْبَحَ مُسَافِرٌ':Subject, #1: 1	أَصْبَحَ مُحَمّدٌ
u'أَصْبَحَ مُلْكٌ':Subject, #3: 3	أَصْبَحَ الْمُسَافِرُ
u'أَصْبَحَ نَاسٌ':Subject, #3: 3	أَصْبَحَ مُلْكُ
u'أَصْبَحَ نَاسٌ':Subject, #2: 2	أَصْبَحَ النّاسُ
u'أَصْبَحَ نَبِيٌّ':Subject, #5: 5	أَصْبَحَ النَّاسُ
u'أَصْبَحَ نَظَرٌ':Predicate, #1: 1	أَصْبَحَ النَّبِيُّ
u'أَصْبَحَ وَجْهٌ':Subject, #1: 1	أَصْبَحَ نَظَرَ
u'أَصْبَحَ وقع':Predicate, #1: 1	أَصْبَحَ وَجْهُهُ
u'أَصْبَحَ وَنِيَّةٌ':Subject, #1: 1	أَصْبَحَ وَقَعَ
u'أَصْبَحَ يَوْمٌ':Predicate, #1: 1	أَصْبَحَ وَنِيَّتُهُ
u'أَصْبَحَ يَوْمٌ':Predicate, #5: 5	أَصْبَحَ الْيَوْمَ
u'أَصْبَحَ يَوْمٌ':Subject, #8: 8	أَصْبَحَ يَوْمَ
u'أَصْبَغَ إجَازَةٌ':Subject, #1: 1	أَصْبَحَ يَوْمُ
u'أَصْبَغَ بَزَّارٌ':Subject, #1: 1	أَصْبَغَ إجَازَتُهُ
u'أَصْبَغَ تَفْسِيرٌ':Subject, #1: 1	أَصْبَغَ الْبَزَّارُ
u'أَصْبَغَ غير':Subject, #1: 1	أَصْبَغَ تَفْسِيرٌ
u'أَصْبَغَ غَيْرٌ':Subject, #1: 1	أَصْبَغَ غَيْرُهُ
u'أَصْبَغَ قَالٌ':Predicate, #1: 1	أَصْبَغَ غَيْرُهُ
u'أَصْبَغَ مثل':Predicate, #1: 1	أَصْبَغَ قَالَ
u'أَصْبَغَ مِثْلٌ':Predicate, #1: 1	أَصْبَغَ مِثْلَ
u'أَصْبَغَ وَهْمٌ':Subject, #1: 1	أَصْبَغَ مِثْلَ
u'أَصَحَّ تَابِعٌ':Predicate, #1: 1	أَصْبَغَ وَهْمٌ
u'أَصْدَقَ أَبٌ':Subject, #1: 1	أَصَحَّ التَّابِعِينَ
u'أَصْدَقَ تَوْرَاةٌ':Predicate, #2: 2	أَصْدَقَ الْأَبُ
u'أَصْدَقَ ذِمِّيٌّ':Subject, #1: 1	أَصْدَقَ التَّوْرَاةَ
u'أَصْدَقَ رَجُلٌ':Subject, #1: 1	أَصْدَقَ ذِمِّيٌّ
u'أَصْدَقَ زَوْجَةٌ':Predicate, #1: 1	أَصْدَقَ الرَّجُلُ
u'أَصْدَقَ طَلْحٌ':Subject, #1: 1	أَصْدَقَ الزَّوْجَةَ
u'أَصْدَقَ طلحة':Subject, #1: 1	أَصْدَقَ طَلْحَةُ
u'أَصْدَقَ كَافِرٌ':Subject, #1: 1	أَصْدَقَ طَلْحَةُ
u'أَصْدَقَ كِتاب':Predicate, #2: 2	أَصْدَقَ الْكَافِرُ
u'أَصْدَقَ كِتابَة':Predicate, #1: 1	أَصْدَقَ كِتَابِيَّةً
u'أَصْدَقَ كِتابِيّ':Predicate, #1: 1	أَصْدَقَ كِتَابِيَّةً
u'أَصْدَقَ وَلِيٌّ':Subject, #1: 1	أَصْدَقَ كِتَابِيَّةً
u'أَصَرَّ أهْلٌ':Subject, #2: 2	أَصْدَقَ الْوَلِيُّ
u'أَصَرَّ بَاعٌ':Predicate, #1: 1	أَصَرَّ أَهْلُ
u'أَصَرَّ بَائِعٌ':Subject, #1: 1	أَصَرَّ بَاعَ
u'أَصَرَّ حَكَمٌ':Predicate, #1: 1	أَصَرَّ الْبَائِعُ
u'أَصَرَّ زَوْجٌ':Subject, #1: 1	أَصَرَّ حَكَمَ
u'أَصَرَّ قتل':Predicate, #1: 1	أَصَرَّ الزَّوْجُ
u'أَصَرَّ مُعَلِّمٌ':Subject, #2: 2	أَصَرَّ قُتِلَ
u'أَصْغَى أَميرٌ':Subject, #1: 1	أَصَرَّ الْمُعَلِّمُ
u'أَصْغَى إِناءٌ':Predicate, #1: 1	أَصْغَى أَمِيرُ
u'أَصْفَى أرْضٌ':Predicate, #1: 1	أَصْغَى الْإِنَاءَ
u'أَصْفَى سَبْعَةٌ':Predicate, #1: 1	أَصْفَى أَرْضَ
u'أَصْفَى عَبْدٌ':Subject, #1: 1	أَصْفَى سَبْعَةَ
u'أَصْفَى عُمَرٌ':Subject, #1: 1	أَصْفَى عَبْدُ
u'أَصْفَى فلان':Subject, #1: 1	أَصْفَى عُمَرُ
u'أَصْفَى مَاءٌ':Predicate, #1: 1	أَصْفَى حُذَيْفَةُ
u'أَصْلَحَ أَمْعاءٌ':Predicate, #1: 1	أَصْفَى الْمَاءَ
u'أَصْلَحَ أَمْعَاءٌ':Predicate, #1: 1	أَصْلَحَ أَمْعَاءَ
u'أَصْلَحَ بَيْنٌ':Predicate, #1: 1	أَصْلَحَ أَمْعَاءَ
u'أَصْلَحَ ثَانِي':Predicate, #4: 4	أَصْلَحَ بَيْنَ
u'أَصْلَحَ ثَانِيَةٌ':Predicate, #1: 1	أَصْلَحَ الثَّانِيَةَ
u'أَصْلَحَ جَازٌ':Predicate, #1: 1	أَصْلَحَ الثَّانِيَةَ
u'أَصْلَحَ خَاطِبٌ':Predicate, #1: 1	أَصْلَحَ جَازَ
u'أَصْلَحَ سِتٌّ':Predicate, #1: 1	أَصْلَحَ الْخَاطِبِينَ
u'أَصْلَحَ غير':Predicate, #1: 1	أَصْلَحَ السِّتَّةَ
u'أَصْلَحَ غَيْرٌ':Predicate, #1: 1	أَصْلَحَ غَيْرَ
u'أَصْلَحَ مَذْكُورٌ':Predicate, #1: 1	أَصْلَحَ غَيْرَ
u'أَصْلَحَ مُسْتَأْجِرٌ':Subject, #1: 1	أَصْلَحَ مَذْكُورَةً
u'أَصْلَحَ وَلَهٌ':Subject, #2: 2	أَصْلَحَ الْمُسْتَأْجِرُ
u'أَصْنَامٌ عَرَبٌ':Added, #1: 1	أَصْلَحَ وَلَهُ
u'أَصْنَامٌ قَبَائِلُ':Added, #1: 1	أَصْنَامِ الْعَرَبِ
u'أَصْنَامٌ قَوْمٌ':Added, #1: 1	أَصْنَامُ الْقَبَائِلِ
u'أَصْوَاتٌ أهْلٌ':Added, #1: 1	أَصْنَامُ قَوْمِ
u'أَصْوَاتٌ أَوْلاَدٌ':Added, #1: 1	أَصْوَاتَ أَهْلِ
u'أَصْوَاتٌ حَمِيرٌ':Added, #1: 1	أَصْوَاتِ الْأَوْلَادِ
u'أَصْوَاتٌ رِجَالٌ':Added, #1: 1	أَصْوَاتِ الْحَمِيرِ
u'أَصْوَاتٌ رُومٌ':Added, #1: 1	أَصْوَاتَ الرِّجَالِ
u'أَصْوَاتٌ سِباعٌ':Added, #1: 1	أَصْوَاتُ الرُّومِ
u'أَصْوَاتٌ طَيْرٌ':Added, #1: 1	أَصْوَاتَ السّبَاعِ
u'أَصْوَاتٌ طُيُورٌ':Added, #1: 1	أَصْوَاتُ الطَّيْرِ
u'أَصْوَاتٌ مَعَازِفُ':Added, #1: 1	أَصْوَاتُ الطُّيُورِ
u'أَصْوَاتٌ نَاسٌ':Added, #1: 1	أَصْوَاتُ الْمَعَازِفِ
u'أَصْوَاتٌ هام':Added, #1: 1	أَصْوَاتَ النَّاسِ
u'أَضَاءَ صُبْحٌ':Subject, #1: 1	أَصْوَاتُ هَامٍ
u'أَضَاءَ ضَوْءٌ':Subject, #1: 1	أَضَاءَ الصُّبْحُ
u'أَضَاءَ فَجْرٌ':Subject, #1: 1	أَضَاءَ الضَّوْءُ
u'أَضَاعَ صَلاَةٌ':Predicate, #4: 4	أَضَاءَ الْفَجْرُ
u'أَضَاعَ مَرْبَأٌ':Subject, #1: 1	أَضَاعَ الصَّلَاةَ
u'أَضَافَ اِبْنٌ':Subject, #1: 1	أَضَاعَ الْمَرْبَأَةُ
u'أَضَافَ إجَارَةٌ':Predicate, #1: 1	أَضَافَ ابْنُ
u'أَضَافَ أَجْزَاءٌ':Predicate, #3: 3	أَضَافَ الْإِجَارَةَ
u'أَضَافَ أَجَلٌ':Predicate, #3: 3	أَضَافَ الْأَجْزَاءَ
u'أَضَافَ إِعْتاقٌ':Predicate, #1: 1	أَضَافَ الْأَجَلَ
u'أَضَافَ إقْرَارٌ':Predicate, #2: 2	أَضَافَ الْإِعْتَاقَ
u'أَضَافَ أكل':Predicate, #5: 5	أَضَافَ الْإِقْرَارَ
u'أَضَافَ أَكْلٌ':Predicate, #1: 1	أَضَافَ الْأَكْلَ
u'أَضَافَ ألف':Predicate, #1: 1	أَضَافَ الْأَكْلَ
u'أَضَافَ ألْفٌ':Predicate, #2: 2	أَضَافَ الْأَلْفَ
u'أَضَافَ أَلْفٌ':Predicate, #2: 2	أَضَافَ الْأَلْفَ
u'أَضَافَ إِيجَابٌ':Predicate, #2: 2	أَضَافَ الْأَلْفَ
u'أَضَافَ بَدَلٌ':Predicate, #1: 1	أَضَافَ الْإِيجَابَ
u'أَضَافَ بَراءةٌ':Predicate, #3: 3	أَضَافَ الْبَدَلَ
u'أَضَافَ بَيْعٌ':Predicate, #3: 3	أَضَافَ الْبَرَاءَةَ
u'أَضَافَ بُيُوتٌ':Predicate, #2: 2	أَضَافَ الْبَيْعَ
u'أَضَافَ تَأْثِيرٌ':Predicate, #1: 1	أَضَافَ الْبُيُوتَ
u'أَضَافَ تَحْرِيمٌ':Predicate, #1: 1	أَضَافَ التَّأْثِيرَ
u'أَضَافَ تَخْيِيرٌ':Predicate, #2: 2	أَضَافَ التَّحْرِيمَ
u'أَضَافَ تَدْبِيرٌ':Predicate, #1: 1	أَضَافَ التَّخْيِيرَ
u'أَضَافَ تَزَوُّجٌ':Predicate, #2: 2	أَضَافَ التَّدْبِيرَ
u'أَضَافَ تَسْمِيَة':Predicate, #1: 1	أَضَافَ التَّزَوُّجَ
u'أَضَافَ تَصَرُّفٌ':Predicate, #1: 1	أَضَافَ التَّسْمِيَةَ
u'أَضَافَ ثَلاثَةٌ':Predicate, #2: 2	أَضَافَ التَّصَرُّفَ
u'أَضَافَ جَارِي':Predicate, #1: 1	أَضَافَ الثَّلَاثَةَ
u'أَضَافَ جَارِيَةٌ':Predicate, #1: 1	أَضَافَ الْجَارِيَةَ
u'أَضَافَ جُزْءٌ':Predicate, #1: 1	أَضَافَ الْجَارِيَةَ
u'أَضَافَ جَزَاءٌ':Predicate, #3: 3	أَضَافَ الْجُزْءَ
u'أَضَافَ جمع':Predicate, #1: 1	أَضَافَ الْجَزَاءَ
u'أَضَافَ جَمْعٌ':Predicate, #1: 1	أَضَافَ الْجَمْعَ
u'أَضَافَ حائِطٌ':Predicate, #1: 1	أَضَافَ الْجَمْعَ
u'أَضَافَ حَجٌّ':Predicate, #1: 1	أَضَافَ الْحَائِطَ
u'أَضَافَ حُرْمَةٌ':Predicate, #1: 1	أَضَافَ الْحَجَّ
u'أَضَافَ حُرِّيَّةٌ':Predicate, #1: 1	أَضَافَ الْحُرْمَةَ
u'أَضَافَ حُكْمٌ':Predicate, #2: 2	أَضَافَ الْحُرِّيَّةَ
u'أَضَافَ خُرُوجٌ':Predicate, #3: 3	أَضَافَ الْحُكْمَ
u'أَضَافَ رَجُلٌ':Predicate, #1: 1	أَضَافَ الْخُرُوجَ
u'أَضَافَ رِزْقٌ':Predicate, #1: 1	أَضَافَ رَجُلاً
u'أَضَافَ رَسُولٌ':Subject, #1: 1	أَضَافَ الرِّزْقَ
u'أَضَافَ ركعة':Predicate, #1: 1	أَضَافَ الرَّسُولُ
u'أَضَافَ رَكْعَةٌ':Predicate, #1: 1	أَضَافَ رَكْعَةَ
u'أَضَافَ زَوْجٌ':Subject, #1: 1	أَضَافَ رَكْعَةَ
u'أَضَافَ زِيادَةٌ':Predicate, #2: 2	أَضَافَ الزَّوْجُ
u'أَضَافَ سَيِّئٌ':Predicate, #2: 2	أَضَافَ الزِّيَادَةَ
u'أَضَافَ شَاةٌ':Predicate, #1: 1	أَضَافَ السَّيِّئَةَ
u'أَضَافَ شِرَاءٌ':Predicate, #1: 1	أَضَافَ الشَّاةَ
u'أَضَافَ صدقة':Predicate, #5: 5	أَضَافَ الشِّرَاءَ
u'أَضَافَ صَدَقَةٌ':Predicate, #1: 1	أَضَافَ الصَّدَقَةَ
u'أَضَافَ صلح':Predicate, #1: 1	أَضَافَ الصَّدَقَةَ
u'أَضَافَ صُلْحٌ':Predicate, #3: 3	أَضَافَ الصُّلْحَ
u'أَضَافَ صَوْمٌ':Predicate, #3: 3	أَضَافَ الصُّلْحَ
u'أَضَافَ صَيْدٌ':Predicate, #1: 1	أَضَافَ الصَّوْمَ
u'أَضَافَ صِيغَةٌ':Predicate, #1: 1	أَضَافَ الصَّيْدَ
u'أَضَافَ ضَمَانٌ':Predicate, #1: 1	أَضَافَ صِيغَةَ
u'أَضَافَ طَلاَقٌ':Predicate, #1: 1	أَضَافَ الضَّمَانَ
u'أَضَافَ طَلاَقٌ':Predicate, #2: 2	أَضَافَ طَلَاقَ
u'أَضَافَ ظَرْفٌ':Predicate, #41: 41	أَضَافَ الطَّلَاقَ
u'أَضَافَ ظهار':Predicate, #1: 1	أَضَافَ الظَّرْفَ
u'أَضَافَ عَائِشٌ':Predicate, #2: 2	أَضَافَ الظِّهَارَ
u'أَضَافَ عتق':Predicate, #1: 1	أَضَافَ عَائِشَةَ
u'أَضَافَ عِتْقٌ':Predicate, #14: 14	أَضَافَ الْعِتْقَ
u'أَضَافَ عَقْدٌ':Predicate, #14: 14	أَضَافَ الْعِتْقَ
u'أَضَافَ عمرة':Predicate, #25: 25	أَضَافَ الْعَقْدَ
u'أَضَافَ عُمْرَةٌ':Predicate, #1: 1	أَضَافَ الْعُمْرَةَ
u'أَضَافَ غَنِيمَةٌ':Predicate, #1: 1	أَضَافَ الْعُمْرَةَ
u'أَضَافَ فَسْخٌ':Predicate, #1: 1	أَضَافَ الْغَنِيمَةَ
u'أَضَافَ فُضُولِيٌّ':Subject, #1: 1	أَضَافَ الْفَسْخَ
u'أَضَافَ فِعْلٌ':Predicate, #1: 1	أَضَافَ الْفُضُولِيُّ
u'أَضَافَ فِعْلٌ':Predicate, #1: 1	أَضَافَ فِعْلَ
u'أَضَافَ قَبْضٌ':Predicate, #4: 4	أَضَافَ الْفِعْلَ
u'أَضَافَ قَبْضٌ':Predicate, #1: 1	أَضَافَ قَبْضَ
u'أَضَافَ قَرْضٌ':Predicate, #4: 4	أَضَافَ الْقَبْضَ
u'أَضَافَ قَوْمٌ':Subject, #2: 2	أَضَافَ الْقَرْضَ
u'أَضَافَ كَفَالَةٌ':Predicate, #1: 1	أَضَافَ قَوْمٌ
u'أَضَافَ كَفِيلٌ':Subject, #2: 2	أَضَافَ الْكَفَالَةَ
u'أَضَافَ كَلِمَةٌ':Predicate, #2: 2	أَضَافَ الْكَفِيلُ
u'أَضَافَ لعان':Predicate, #2: 2	أَضَافَ كَلِمَةَ
u'أَضَافَ لَفْظٌ':Predicate, #1: 1	أَضَافَ اللِّعَانَ
u'أَضَافَ لَفْظَةٌ':Predicate, #1: 1	أَضَافَ لَفْظَ
u'أَضَافَ مَالٌ':Predicate, #1: 1	أَضَافَ لَفْظَةَ
u'أَضَافَ مَالٌ':Predicate, #1: 1	أَضَافَ مَالَ
u'أَضَافَ مَبِيعٌ':Predicate, #5: 5	أَضَافَ الْمَالَ
u'أَضَافَ مُتْعَةٌ':Predicate, #1: 1	أَضَافَ الْمَبِيعَ
u'أَضَافَ مِثْقَالٌ':Predicate, #1: 1	أَضَافَ الْمُتْعَةَ
u'أَضَافَ مَسَاجِدُ':Predicate, #3: 3	أَضَافَ الْمِثْقَالَ
u'أَضَافَ مَشِيئَةٌ':Predicate, #1: 1	أَضَافَ الْمَسَاجِدَ
u'أَضَافَ مَصْدَرٌ':Predicate, #3: 3	أَضَافَ الْمَشِيئَةَ
u'أَضَافَ مُضَارَبَةٌ':Predicate, #1: 1	أَضَافَ الْمَصْدَرَ
u'أَضَافَ مِقْدَارٌ':Predicate, #1: 1	أَضَافَ الْمُضَارَبَةَ
u'أَضَافَ مَقْصُودٌ':Predicate, #1: 1	أَضَافَ الْمِقْدَارَ
u'أَضَافَ مِلْكٌ':Predicate, #1: 1	أَضَافَ الْمَقْصُودَ
u'أَضَافَ مَنْعٌ':Predicate, #1: 1	أَضَافَ الْمِلْكَ
u'أَضَافَ مَنْفَعَةٌ':Predicate, #1: 1	أَضَافَ الْمَنْعَ
u'أَضَافَ مِيرَاثٌ':Predicate, #1: 1	أَضَافَ مَنْفَعَةَ
u'أَضَافَ نذر':Predicate, #2: 2	أَضَافَ الْمِيرَاثَ
u'أَضَافَ نَذْرٌ':Predicate, #7: 7	أَضَافَ النَّذْرَ
u'أَضَافَ نِصْفٌ':Predicate, #7: 7	أَضَافَ النَّذْرَ
u'أَضَافَ نَفْخ':Predicate, #1: 1	أَضَافَ النِّصْفَ
u'أَضَافَ نَفْيٌ':Predicate, #1: 1	أَضَافَ النّفْخَ
u'أَضَافَ نكاح':Predicate, #1: 1	أَضَافَ نَفْيَ
u'أَضَافَ نِكَاحٌ':Predicate, #9: 9	أَضَافَ النِّكَاحَ
u'أَضَافَ هِبَةٌ':Predicate, #9: 9	أَضَافَ النِّكَاحَ
u'أَضَافَ وَاهِبٌ':Subject, #5: 5	أَضَافَ الْهِبَةَ
u'أَضَافَ وُجُوبٌ':Predicate, #1: 1	أَضَافَ الْوَاهِبُ
u'أَضَافَ وَصِيٌّ':Predicate, #1: 1	أَضَافَ الْوُجُوبَ
u'أَضَافَ وَصِيَّةٌ':Predicate, #4: 4	أَضَافَ الْوَصِيَّةَ
u'أَضَافَ وَقْفٌ':Predicate, #4: 4	أَضَافَ الْوَصِيَّةَ
u'أَضَافَ وَكِيلٌ':Subject, #1: 1	أَضَافَ الْوَقْفَ
u'أَضَافَ يَمِينٌ':Predicate, #6: 6	أَضَافَ الْوَكِيلُ
u'أَضْجَعَ ذَبيحٌ':Predicate, #5: 5	أَضَافَ الْيَمِينَ
u'أَضْجَعَ ذَبيحَةٌ':Predicate, #1: 1	أَضْجَعَ الذَّبِيحَةَ
u'أَضْجَعَ رَجُلٌ':Subject, #1: 1	أَضْجَعَ الذَّبِيحَةَ
u'أَضْجَعَ شَاةٌ':Predicate, #1: 1	أَضْجَعَ رَجُلٌ
u'أَضْحَى بواسط':Predicate, #1: 1	أَضْجَعَ الشَّاةَ
u'أَضْحَى رِوايَةٌ':Subject, #1: 1	أَضْحَى بِوَاسِطَ
u'أَضْحَى كَبْشٌ':Subject, #1: 1	أَضْحَى رِوَايَةٌ
u'أَضْحَى مُؤْمِنٌ':Subject, #1: 1	أَضْحَى كَبْشٌ
u'أَضْعَفَ اِزْداد':Predicate, #1: 1	أَضْحَى مُؤْمِنٌ
u'أَضْعَفَ صدقة':Predicate, #1: 1	أَضْعَفَ ازْدَادَ
u'أَضْعَفَ صَدَقَةٌ':Predicate, #1: 1	أَضْعَفَ الصَّدَقَةَ
u'أَضْعَفَ غَرَامَةٌ':Predicate, #1: 1	أَضْعَفَ الصَّدَقَةَ
u'أَضْعَفَ قُوَّةٌ':Predicate, #1: 1	أَضْعَفَ الْغَرَامَةَ
u'أَضْعَفَ قُوَّة':Predicate, #1: 1	أَضْعَفَ قُوَّةَ
u'أَضَلَّ خلق':Predicate, #1: 1	أَضْعَفَ قُوَّةَ
u'أَضَلَّ سَعْدٌ':Subject, #1: 1	أَضَلَّ خَلَقَ
u'أَضَلَّ نَاقَةٌ':Predicate, #1: 1	أَضَلَّ سَعْدُ
u'أَضَلَّ نَاقَة':Predicate, #1: 1	أَضَلَّ النَّاقَةَ
u'أَضْمَرَ إِحْرَامٌ':Predicate, #1: 1	أَضَلَّ النَّاقَةَ
u'أَضْمَرَ اِلْتِمَاسٌ':Predicate, #1: 1	أَضْمَرَ الْإِحْرَامَ
u'أَضْمَرَ حَرْفٌ':Predicate, #1: 1	أَضْمَرَ الْتِمَاسَ
u'أَضْمَرَ عَدَاوَةٌ':Predicate, #1: 1	أَضْمَرَ حَرْفَ
u'أَضْمَرَ قول':Predicate, #1: 1	أَضْمَرَ الْعَدَاوَةَ
u'أَضْمَرَ قَوْلٌ':Predicate, #1: 1	أَضْمَرَ الْقَوْلَ
u'أَضْمَرَ مُبْتَدَأٌ':Predicate, #1: 1	أَضْمَرَ الْقَوْلَ
u'أَضْوَاءٌ سُنَّةٌ':Added, #1: 1	أَضْمَرَ الْمُبْتَدَأَ
u'أَضْيَافٌ إِسْلامٌ':Added, #1: 1	أَضْوَاءِ السُّنَّةِ
u'أَضْيَافٌ إِسْلامٌ':Added, #3: 3	أَضْيَافُ الإِسْلاَمِ
u'أَضْيَافٌ شِتَاءٌ':Added, #3: 3	أَضْيَافُ الْإِسْلَامِ
u'أَطَابَ كَلاَمٌ':Predicate, #1: 1	أَضْيَافَ الشّتَاءِ
u'أَطَارَ فِرَاشٌ':Predicate, #1: 1	أَطَابَ الْكَلَامَ
u'أَطَاعَ رَسُولٌ':Predicate, #1: 1	أَطَارَ فِرَاشَ
u'أَطَاعَ نَاسٌ':Predicate, #1: 1	أَطَاعَ الرَّسُولَ
u'أَطَاعَ نَاسٌ':Subject, #2: 2	أَطَاعَ النّاسَ
u'أَطَافَ لَيْلٌ':Predicate, #1: 1	أَطَاعَ النّاسُ
u'أَطَاقَ إحْسَانٌ':Predicate, #1: 1	أَطَافَ اللَّيْلَةَ
u'أَطَاقَ أصل':Predicate, #1: 1	أَطَاقَ الْإِحْسَانَ
u'أَطَاقَ أًصْلٌ':Predicate, #1: 1	أَطَاقَ أَصْلَ
u'أَطَاقَ صَوْمٌ':Predicate, #1: 1	أَطَاقَ أَصْلَ
u'أَطَاقَ قتال':Predicate, #1: 1	أَطَاقَ الصَّوْمَ
u'أَطَاقَ قِتَالٌ':Predicate, #2: 2	أَطَاقَ الْقِتَالَ
u'أَطَاقَ قيام':Predicate, #2: 2	أَطَاقَ الْقِتَالَ
u'أَطَاقَ قِيَامٌ':Predicate, #2: 2	أَطَاقَ الْقِيَامَ
u'أَطَالَ إقامَةٌ':Predicate, #2: 2	أَطَاقَ الْقِيَامَ
u'أَطَالَ أكل':Predicate, #2: 2	أَطَالَ الْإِقَامَةَ
u'أَطَالَ أَكْلٌ':Predicate, #1: 1	أَطَالَ الْأَكْلَ
u'أَطَالَ إمَامٌ':Subject, #1: 1	أَطَالَ الْأَكْلَ
u'أَطَالَ بَحْثٌ':Predicate, #2: 2	أَطَالَ الْإِمَامُ
u'أَطَالَ بِشْرٌ':Subject, #1: 1	أَطَالَ الْبَحْثَ
u'أَطَالَ تَشَهُّدٌ':Predicate, #1: 1	أَطَالَ بِشْرُ
u'أَطَالَ جُلُوسٌ':Predicate, #1: 1	أَطَالَ التَّشَهُّدَ
u'أَطَالَ جَمَاعَةٌ':Subject, #3: 3	أَطَالَ الْجُلُوسَ
u'أَطَالَ جَمْعٌ':Subject, #1: 1	أَطَالَ جَمَاعَةٌ
u'أَطَالَ خلق':Subject, #1: 1	أَطَالَ جَمْعٌ
u'أَطَالَ خَلْقٌ':Subject, #1: 1	أَطَالَ الْخَلْقُ
u'أَطَالَ رَجُلٌ':Subject, #1: 1	أَطَالَ الْخَلْقُ
u'أَطَالَ رُكوعٌ':Predicate, #1: 1	أَطَالَ الرَّجُلُ
u'أَطَالَ سُجُودٌ':Predicate, #3: 3	أَطَالَ الرُّكُوعَ
u'أَطَالَ شُرَّاحٌ':Subject, #2: 2	أَطَالَ السُّجُودَ
u'أَطَالَ شرب':Predicate, #1: 1	أَطَالَ شُرَّاحُ
u'أَطَالَ شُرْبٌ':Predicate, #1: 1	أَطَالَ الشُّرْبَ
u'أَطَالَ صَلاَةٌ':Predicate, #1: 1	أَطَالَ الشُّرْبَ
u'أَطَالَ عَبْدٌ':Subject, #1: 1	أَطَالَ الصَّلَاةَ
u'أَطَالَ غير':Subject, #1: 1	أَطَالَ عَبْدٌ
u'أَطَالَ غَيْرٌ':Subject, #1: 1	أَطَالَ غَيْرُهُ
u'أَطَالَ فَصْلٌ':Predicate, #1: 1	أَطَالَ غَيْرُهُ
u'أَطَالَ فَصْلٌ':Subject, #1: 1	أَطَالَ الْفَصْلَ
u'أَطَالَ قِرَاءةٌ':Predicate, #1: 1	أَطَالَ الْفَصْلُ
u'أَطَالَ قُعُودٌ':Predicate, #4: 4	أَطَالَ الْقِرَاءَةَ
u'أَطَالَ قول':Predicate, #1: 1	أَطَالَ الْقُعُودَ
u'أَطَالَ قَوْلٌ':Predicate, #1: 1	أَطَالَ الْقَوْلَ
u'أَطَالَ قيام':Predicate, #1: 1	أَطَالَ الْقَوْلَ
u'أَطَالَ قِيَامٌ':Predicate, #1: 1	أَطَالَ قِيَامَ
u'أَطَالَ قيام':Predicate, #1: 1	أَطَالَ قِيَامَ
u'أَطَالَ قِيَامٌ':Predicate, #5: 5	أَطَالَ الْقِيَامَ
u'أَطَالَ كَلاَمٌ':Predicate, #5: 5	أَطَالَ الْقِيَامَ
u'أَطَالَ مُحَقِّقٌ':Subject, #5: 5	أَطَالَ الْكَلَامَ
u'أَطَالَ مَقْدِسِيٌّ':Predicate, #5: 5	أَطَالَ الْمُحَقِّقُ
u'أَطَالَ نَظَرٌ':Predicate, #1: 1	أَطَالَ الْمَقْدِسِيَّ
u'أَطَالَ نَفَسٌ':Predicate, #1: 1	أَطَالَ النَّظَرَ
u'أَطَالَ نَوَوِيٌّ':Subject, #1: 1	أَطَالَ النَّفَسَ
u'أَطَالَ وُقُوفٌ':Predicate, #1: 1	أَطَالَ النَّوَوِيُّ
u'أَطْباقٌ رَأْسٌ':Added, #1: 1	أَطَالَ الْوُقُوفَ
u'أَطْبَاقٌ رَأْسٌ':Added, #1: 1	أَطْبَاقُ الرّأْسِ
u'أَطْبَقَ أحْمَر':Subject, #1: 1	أَطْبَاقُ الرّأْسِ
u'أَطْبَقَ أسْوَد':Subject, #5: 5	أَطْبَقَ الْأَحْمَرُ
u'أَطْبَقَ أَصْحَابٌ':Subject, #1: 1	أَطْبَقَ أَسْوَدُ
u'أَطْبَقَ أئِمَّةٌ':Subject, #1: 1	أَطْبَقَ الْأَصْحَابُ
u'أَطْبَقَ دَمٌ':Subject, #2: 2	أَطْبَقَ أَئِمَّةُ
u'أَطْبَقَ سَوادٌ':Predicate, #5: 5	أَطْبَقَ الدَّمُ
u'أَطْبَقَ سَوادٌ':Subject, #2: 2	أَطْبَقَ السَّوَادَ
u'أَطْبَقَ غيم':Subject, #3: 3	أَطْبَقَ السَّوَادُ
u'أَطْبَقَ غَيْمٌ':Subject, #4: 4	أَطْبَقَ الْغَيْمُ
u'أَطْبَقَ نَاسٌ':Subject, #4: 4	أَطْبَقَ الْغَيْمُ
u'أَطْرافٌ أَحْرارٌ':Added, #3: 3	أَطْبَقَ النَّاسُ
u'أَطْرَافٌ أَحْرارٌ':Added, #1: 1	أَطْرَافِ الْأَحْرَارِ
u'أَطْرافٌ أَحْكَامٌ':Added, #1: 1	أَطْرَافِ الْأَحْرَارِ
u'أَطْرَافٌ أَحْكَامٌ':Added, #1: 1	أَطْرَافِ الْأَحْكَامِ
u'أَطْرافٌ آدَمِيٌّ':Added, #1: 1	أَطْرَافِ الْأَحْكَامِ
u'أَطْرَافٌ آدَمِيٌّ':Added, #1: 1	أَطْرَافَ الْآدَمِيِّ
u'أَطْرافٌ أرْضٌ':Added, #1: 1	أَطْرَافَ الْآدَمِيِّ
u'أَطْرافٌ أرْضٌ':Added, #1: 1	أَطْرَافُ الْأَرْضِ
u'أَطْرَافٌ أرْضٌ':Added, #1: 1	أَطْرَافِ الْأَرْضِ
u'أَطْرَافٌ أرْضٌ':Added, #1: 1	أَطْرَافُ الْأَرْضِ
u'أَطْرافٌ أَصابِعُ':Added, #1: 1	أَطْرَافِ الْأَرْضِ
u'أَطْرَافٌ أَصابِعُ':Added, #10: 10	أَطْرَافِ أَصَابِعِهِ
u'أَطْرافٌ أَصابِعُ':Added, #10: 10	أَطْرَافِ أَصَابِعِهِ
u'أَطْرَافٌ أَصابِعُ':Added, #2: 2	أَطْرَافَ أَصَابِعِهِ
u'أَطْرافٌ أَصابِعُ':Added, #2: 2	أَطْرَافَ أَصَابِعِهِ
u'أَطْرَافٌ أَصابِعُ':Added, #2: 2	أَطْرَافَ الْأَصَابِعِ
u'أَطْرافٌ أَصابِعُ':Added, #2: 2	أَطْرَافَ الْأَصَابِعِ
u'أَطْرَافٌ أَصابِعُ':Added, #3: 3	أَطْرَافُ الْأَصَابِعِ
u'أَطْرافٌ أَصابِعُ':Added, #3: 3	أَطْرَافُ الْأَصَابِعِ
u'أَطْرَافٌ أَصابِعُ':Added, #4: 4	أَطْرَافَ أَصَابِعِ
u'أَطْرافٌ أَصابِعُ':Added, #4: 4	أَطْرَافَ أَصَابِعِ
u'أَطْرَافٌ أَصابِعُ':Added, #8: 8	أَطْرَافِ أَصَابِعِ
u'أَطْرافٌ أَصابِعُ':Added, #8: 8	أَطْرَافِ أَصَابِعِ
u'أَطْرَافٌ أَصابِعُ':Added, #9: 9	أَطْرَافِ الْأَصَابِعِ
u'أَطْرافٌ أَقْدَامٌ':Added, #9: 9	أَطْرَافِ الْأَصَابِعِ
u'أَطْرَافٌ أَقْدَامٌ':Added, #1: 1	أَطْرَافِ الْأَقْدَامِ
u'أَطْرافٌ بادِي':Added, #1: 1	أَطْرَافِ الْأَقْدَامِ
u'أَطْرَافٌ بادِي':Added, #1: 1	أَطْرَافَ الْبَادِيَةِ
u'أَطْرافٌ بَادِيَةٌ':Added, #1: 1	أَطْرَافَ الْبَادِيَةِ
u'أَطْرَافٌ بَادِيَةٌ':Added, #1: 1	أَطْرَافَ الْبَادِيَةِ
u'أَطْرافٌ بِلادٌ':Added, #1: 1	أَطْرَافَ الْبَادِيَةِ
u'أَطْرَافٌ بِلادٌ':Added, #1: 1	أَطْرَافَ الْبِلَادِ
u'أَطْرافٌ بِلادٌ':Added, #1: 1	أَطْرَافَ الْبِلَادِ
u'أَطْرَافٌ بِلادٌ':Added, #2: 2	أَطْرَافِ الْبِلَادِ
u'أَطْرافٌ بِلادٌ':Added, #2: 2	أَطْرَافِ الْبِلَادِ
u'أَطْرَافٌ بِلادٌ':Added, #2: 2	أَطْرَافُ بِلَادِ
u'أَطْرافٌ بَلَدٌ':Added, #2: 2	أَطْرَافُ بِلَادِ
u'أَطْرَافٌ بَلَدٌ':Added, #5: 5	أَطْرَافِ الْبَلَدِ
u'أَطْرافٌ بَيْتٌ':Added, #5: 5	أَطْرَافِ الْبَلَدِ
u'أَطْرَافٌ بَيْتٌ':Added, #1: 1	أَطْرَافِ الْبَيْتِ
u'أَطْرافٌ ثَوْبٌ':Added, #1: 1	أَطْرَافِ الْبَيْتِ
u'أَطْرَافٌ ثَوْبٌ':Added, #1: 1	أَطْرَافِ الثّوْبِ
u'أَطْرافٌ ثَوْبٌ':Added, #1: 1	أَطْرَافِ الثّوْبِ
u'أَطْرَافٌ ثَوْبٌ':Added, #5: 5	أَطْرَافِ الثَّوْبِ
u'أَطْرافٌ ثِيابٌ':Added, #5: 5	أَطْرَافِ الثَّوْبِ
u'أَطْرَافٌ ثِيابٌ':Added, #1: 1	أَطْرَافِ الثِّيَابِ
u'أَطْرافٌ جَبْهَةٌ':Added, #1: 1	أَطْرَافِ الثِّيَابِ
u'أَطْرَافٌ جَبْهَةٌ':Added, #2: 2	أَطْرَافِ الْجَبْهَةِ
u'أَطْرافٌ جَبْهَةٌ':Added, #2: 2	أَطْرَافِ الْجَبْهَةِ
u'أَطْرَافٌ جَبْهَةٌ':Added, #2: 2	أَطْرَافِ جَبْهَتِهِ
u'أَطْرافٌ جَبِيرَة':Added, #2: 2	أَطْرَافِ جَبْهَتِهِ
u'أَطْرَافٌ جَبِيرَة':Added, #1: 1	أَطْرَافِ الْجَبِيرَةِ
u'أَطْرافٌ جُذُوعٌ':Added, #1: 1	أَطْرَافِ الْجَبِيرَةِ
u'أَطْرَافٌ جُذُوعٌ':Added, #1: 1	أَطْرَافُ جُذُوعٍ
u'أَطْرافٌ جُذُوعٌ':Added, #1: 1	أَطْرَافُ جُذُوعٍ
u'أَطْرَافٌ جُذُوعٌ':Added, #1: 1	أَطْرَافُ جُذُوعِهِ
u'أَطْرافٌ حافِرٌ':Added, #1: 1	أَطْرَافُ جُذُوعِهِ
u'أَطْرَافٌ حافِرٌ':Added, #1: 1	أَطْرَافِ حَافِرِ
u'أَطْرافٌ حافِظٌ':Added, #1: 1	أَطْرَافِ حَافِرِ
u'أَطْرَافٌ حافِظٌ':Added, #2: 2	أَطْرَافِ الْحَافِظِ
u'أَطْرافٌ حَجَرٌ':Added, #2: 2	أَطْرَافِ الْحَافِظِ
u'أَطْرَافٌ حَجَرٌ':Added, #1: 1	أَطْرَافِ حَجَرٍ
u'أَطْرافٌ حُرٌّ':Added, #1: 1	أَطْرَافِ حَجَرٍ
u'أَطْرَافٌ حُرٌّ':Added, #3: 3	أَطْرَافِ الْحُرِّ
u'أَطْرافٌ حَرَمٌ':Added, #3: 3	أَطْرَافِ الْحُرِّ
u'أَطْرَافٌ حَرَمٌ':Added, #1: 1	أَطْرَافِ الْحَرَمِ
u'أَطْرافٌ حيطانٌ':Added, #1: 1	أَطْرَافِ الْحَرَمِ
u'أَطْرَافٌ حيطانٌ':Added, #1: 1	أَطْرَافِ الْحِيطَانِ
u'أَطْرافٌ حَيَوَانٌ':Added, #1: 1	أَطْرَافِ الْحِيطَانِ
u'أَطْرَافٌ حَيَوَانٌ':Added, #1: 1	أَطْرَافَ حَيَوَانٍ
u'أَطْرافٌ حَيَوَانٌ':Added, #1: 1	أَطْرَافَ حَيَوَانٍ
u'أَطْرَافٌ حَيَوَانٌ':Added, #5: 5	أَطْرَافِ الْحَيَوَانِ
u'أَطْرافٌ خَاصِرَةٌ':Added, #5: 5	أَطْرَافِ الْحَيَوَانِ
u'أَطْرَافٌ خَاصِرَةٌ':Added, #1: 1	أَطْرَافُ الْخَاصِرَةِ
u'أَطْرافٌ خَشَبٌ':Added, #1: 1	أَطْرَافُ الْخَاصِرَةِ
u'أَطْرَافٌ خَشَبٌ':Added, #1: 1	أَطْرَافِ الْخَشَبِ
u'أَطْرافٌ خَشَبٌ':Added, #1: 1	أَطْرَافِ الْخَشَبِ
u'أَطْرَافٌ خَشَبٌ':Added, #1: 1	أَطْرَافُ خَشَبِ
u'أَطْرافٌ خَشَبٌ':Added, #1: 1	أَطْرَافُ خَشَبِ
u'أَطْرَافٌ خَشَبٌ':Added, #1: 1	أَطْرَافَ خَشَبِهِ
u'أَطْرافٌ رَطْبَةٌ':Added, #1: 1	أَطْرَافَ خَشَبِهِ
u'أَطْرَافٌ رَطْبَةٌ':Added, #1: 1	أَطْرَافَ الرَّطْبَةِ
u'أَطْرافٌ سِتٌّ':Added, #1: 1	أَطْرَافَ الرَّطْبَةِ
u'أَطْرَافٌ سِتٌّ':Added, #1: 1	أَطْرَافِ السِّتَّةِ
u'أَطْرافٌ سَمَاءٌ':Added, #1: 1	أَطْرَافِ السِّتَّةِ
u'أَطْرَافٌ سَمَاءٌ':Added, #1: 1	أَطْرَافِ السَّمَاءِ
u'أَطْرافٌ سَمَاءٌ':Added, #1: 1	أَطْرَافِ السَّمَاءِ
u'أَطْرَافٌ سَمَاءٌ':Added, #2: 2	أَطْرَافُ السَّمَاءِ
u'أَطْرافٌ سهام':Added, #2: 2	أَطْرَافُ السَّمَاءِ
u'أَطْرَافٌ سهام':Added, #1: 1	أَطْرَافِ السِّهَامِ
u'أَطْرافٌ سِهَامٌ':Added, #1: 1	أَطْرَافِ السِّهَامِ
u'أَطْرَافٌ سِهَامٌ':Added, #1: 1	أَطْرَافِ السِّهَامِ
u'أَطْرافٌ شَاةٌ':Added, #1: 1	أَطْرَافِ السِّهَامِ
u'أَطْرَافٌ شَاةٌ':Added, #1: 1	أَطْرَافَ شَاةٍ
u'أَطْرافٌ شَجَرٌ':Added, #1: 1	أَطْرَافَ شَاةٍ
u'أَطْرَافٌ شَجَرٌ':Added, #1: 1	أَطْرَافَ الشّجَرِ
u'أَطْرافٌ شَجَرٌ':Added, #1: 1	أَطْرَافَ الشّجَرِ
u'أَطْرَافٌ شَجَرٌ':Added, #2: 2	أَطْرَافِ الشَّجَرِ
u'أَطْرافٌ شَعْرٌ':Added, #2: 2	أَطْرَافِ الشَّجَرِ
u'أَطْرافٌ شَعْرٌ':Added, #1: 1	أَطْرَافَ الشَّعْرِ
u'أَطْرَافٌ شَعْرٌ':Added, #1: 1	أَطْرَافُ الشَّعْرِ
u'أَطْرَافٌ شَعْرٌ':Added, #1: 1	أَطْرَافَ الشَّعْرِ
u'أَطْرافٌ شَعَرٌ':Added, #1: 1	أَطْرَافُ الشَّعْرِ
u'أَطْرَافٌ شَعَرٌ':Added, #1: 1	أَطْرَافِ شَعَرِهِ
u'أَطْرافٌ شَعْرٌ':Added, #1: 1	أَطْرَافِ شَعَرِهِ
u'أَطْرَافٌ شَعْرٌ':Added, #2: 2	أَطْرَافِ شَعْرِ
u'أَطْرافٌ شَعْرٌ':Added, #2: 2	أَطْرَافِ شَعْرِ
u'أَطْرَافٌ شَعْرٌ':Added, #3: 3	أَطْرَافِ شَعْرِهِ
u'أَطْرافٌ شَوَارِبُ':Added, #3: 3	أَطْرَافِ شَعْرِهِ
u'أَطْرَافٌ شَوَارِبُ':Added, #1: 1	أَطْرَافُ الشَّوَارِبِ
u'أَطْرافٌ صَحِيحٌ':Added, #1: 1	أَطْرَافُ الشَّوَارِبِ
u'أَطْرَافٌ صَحِيحٌ':Added, #1: 1	أَطْرَافِ الصَّحِيحِ
u'أَطْرافٌ ضلع':Added, #1: 1	أَطْرَافِ الصَّحِيحِ
u'أَطْرَافٌ ضلع':Added, #1: 1	أَطْرَافُ الضِّلْعِ
u'أَطْرافٌ ضِلْعٌ':Added, #1: 1	أَطْرَافُ الضِّلْعِ
u'أَطْرَافٌ ضِلْعٌ':Added, #1: 1	أَطْرَافُ الضِّلْعِ
u'أَطْرافٌ عِبَارَةٌ':Added, #1: 1	أَطْرَافُ الضِّلْعِ
u'أَطْرَافٌ عِبَارَةٌ':Added, #1: 1	أَطْرَافِ الْعِبَارَةِ
u'أَطْرافٌ عَبْدٌ':Added, #1: 1	أَطْرَافِ الْعِبَارَةِ
u'أَطْرَافٌ عَبْدٌ':Added, #3: 3	أَطْرَافَ الْعَبْدِ
u'أَطْرافٌ عَبْدٌ':Added, #3: 3	أَطْرَافَ الْعَبْدِ
u'أَطْرَافٌ عَبْدٌ':Added, #5: 5	أَطْرَافِ الْعَبْدِ
u'أَطْرافٌ عَبِيدٌ':Added, #5: 5	أَطْرَافِ الْعَبْدِ
u'أَطْرَافٌ عَبِيدٌ':Added, #1: 1	أَطْرَافَ الْعَبِيدِ
u'أَطْرافٌ عَبِيدٌ':Added, #1: 1	أَطْرَافَ الْعَبِيدِ
u'أَطْرَافٌ عَبِيدٌ':Added, #2: 2	أَطْرَافِ الْعَبِيدِ
u'أَطْرافٌ عَصَبٌ':Added, #2: 2	أَطْرَافِ الْعَبِيدِ
u'أَطْرَافٌ عَصَبٌ':Added, #1: 1	أَطْرَافُ عَصَبٍ
u'أَطْرافٌ فُصُولٌ':Added, #1: 1	أَطْرَافُ عَصَبٍ
u'أَطْرَافٌ فُصُولٌ':Added, #1: 1	أَطْرَافَ الْفُصُولِ
u'أَطْرافٌ كَفٌّ':Added, #1: 1	أَطْرَافَ الْفُصُولِ
u'أَطْرَافٌ كَفٌّ':Added, #1: 1	أَطْرَافِ الْكَفِّ
u'أَطْرافٌ كَلاَمٌ':Added, #1: 1	أَطْرَافِ الْكَفِّ
u'أَطْرافٌ كَلاَمٌ':Added, #1: 1	أَطْرَافَ الْكَلَامِ
u'أَطْرَافٌ كَلاَمٌ':Added, #1: 1	أَطْرَافُ الْكَلَامِ
u'أَطْرَافٌ كَلاَمٌ':Added, #1: 1	أَطْرَافَ الْكَلَامِ
u'أَطْرافٌ كَلاَمٌ':Added, #1: 1	أَطْرَافُ الْكَلَامِ
u'أَطْرَافٌ كَلاَمٌ':Added, #1: 1	أَطْرَافِ كَلَامِهِ
u'أَطْرافٌ كَلاَمٌ':Added, #1: 1	أَطْرَافِ كَلَامِهِ
u'أَطْرَافٌ كَلاَمٌ':Added, #2: 2	أَطْرَافُ كَلَامِ
u'أَطْرافٌ لِحْيَةٌ':Added, #2: 2	أَطْرَافُ كَلَامِ
u'أَطْرَافٌ لِحْيَةٌ':Added, #2: 2	أَطْرَافِ اللِّحْيَةِ
u'أَطْرافٌ لِحْيَةٌ':Added, #2: 2	أَطْرَافِ اللِّحْيَةِ
u'أَطْرَافٌ لِحْيَةٌ':Added, #4: 4	أَطْرَافِ لِحْيَتِهِ
u'أَطْرافٌ مَزَارِعُ':Added, #4: 4	أَطْرَافِ لِحْيَتِهِ
u'أَطْرَافٌ مَزَارِعُ':Added, #1: 1	أَطْرَافِ الْمَزَارِعِ
u'أَطْرافٌ مَسْأَلَةٌ':Added, #1: 1	أَطْرَافِ الْمَزَارِعِ
u'أَطْرَافٌ مَسْأَلَةٌ':Added, #1: 1	أَطْرَافِ الْمَسْأَلَةِ
u'أَطْرافٌ مِصْرٌ':Added, #1: 1	أَطْرَافِ الْمَسْأَلَةِ
u'أَطْرَافٌ مِصْرٌ':Added, #1: 1	أَطْرَافِ الْمِصْرِ
u'أَطْرافٌ مَمْلَكَةٌ':Added, #1: 1	أَطْرَافِ الْمِصْرِ
u'أَطْرَافٌ مَمْلَكَةٌ':Added, #4: 4	أَطْرَافِ مَمْلَكَتِهِ
u'أَطْرافٌ ميل':Added, #4: 4	أَطْرَافِ مَمْلَكَتِهِ
u'أَطْرافٌ مِيلٌ':Added, #1: 1	أَطْرَافِ الْمِيلِ
u'أَطْرَافٌ ميل':Added, #1: 1	أَطْرَافِ الْمِيلِ
u'أَطْرَافٌ مِيلٌ':Added, #1: 1	أَطْرَافِ الْمِيلِ
u'أَطْرافٌ نَفْسٌ':Added, #1: 1	أَطْرَافِ الْمِيلِ
u'أَطْرَافٌ نَفْسٌ':Added, #1: 1	أَطْرَافَ نَفْسِهِ
u'أَطْرافٌ وَشِيجٌ':Added, #1: 1	أَطْرَافَ نَفْسِهِ
u'أَطْرَافٌ وَشِيجٌ':Added, #2: 2	أَطْرَافَ الْوَشِيجِ
u'أَطْرَقَ أَحْنَف':Subject, #2: 2	أَطْرَافَ الْوَشِيجِ
u'أَطْعَمَ بَعْضٌ':Predicate, #1: 1	أَطْرَقَ الأَحْنَفُ
u'أَطْعَمَ بَعْضٌ':Predicate, #1: 1	أَطْعَمَ الْبَعْضَ
u'أَطْعِمَةٌ ظلمة':Added, #2: 2	أَطْعَمَ بَعْضَ
u'أَطْعِمَةٌ كُفَّارٌ':Added, #1: 1	أَطْعِمَةِ الظَّلَمَةِ
u'أَطْعِمَةٌ مَغْنَمٌ':Added, #1: 1	أَطْعِمَةَ الْكُفَّارِ
u'أَطْعَمَ ثَرِيدٌ':Predicate, #1: 1	أَطْعِمَةِ الْمَغْنَمِ
u'أَطْعَمَ خُبْزٌ':Predicate, #1: 1	أَطْعَمَ الثّرِيدَ
u'أَطْعَمَ خَدِيج':Predicate, #1: 1	أَطْعَمَ خُبْزَ
u'أَطْعَمَ خَمْسَةٌ':Predicate, #1: 1	أَطْعَمَ خَدِيجَةَ
u'أَطْعَمَ رَسُولٌ':Subject, #7: 7	أَطْعَمَ خَمْسَةَ
u'أَطْعَمَ سِتٌّ':Predicate, #2: 2	أَطْعَمَ رَسُولُ
u'أَطْعَمَ طعام':Predicate, #2: 2	أَطْعَمَ سِتَّةَ
u'أَطْعَمَ طَعَامٌ':Predicate, #2: 2	أَطْعَمَ الطَّعَامَ
u'أَطْعَمَ عَاجِزٌ':Subject, #2: 2	أَطْعَمَ الطَّعَامَ
u'أَطْعَمَ عَشْرٌ':Predicate, #1: 1	أَطْعَمَ الْعَاجِزُ
u'أَطْعَمَ عَشْرٌ':Predicate, #1: 1	أَطْعَمَ عَشْرَةَ
u'أَطْعَمَ فقراء':Predicate, #2: 2	أَطْعَمَ عَشْرَةً
u'أَطْعَمَ فلان':Predicate, #1: 1	أَطْعَمَ فُقَرَاءَ
u'أَطْعَمَ كَفَّارٌ':Predicate, #1: 1	أَطْعَمَ خَدِيجَةَ
u'أَطْعَمَ كَفَّارَةٌ':Predicate, #1: 1	أَطْعَمَ كَفَّارَةَ
u'أَطْعَمَ مساكين':Predicate, #1: 1	أَطْعَمَ كَفَّارَةَ
u'أَطْعَمَ مَغْصُوب':Predicate, #1: 1	أَطْعَمَ مَسَاكِينَ
u'أَطْعَمَ نَبِيٌّ':Subject, #1: 1	أَطْعَمَ الْمَغْصُوبَ
u'أَطْعَمَ يَوْمٌ':Predicate, #1: 1	أَطْعَمَ النَّبِيُّ
u'أَطْفَأَ حَرارَةٌ':Predicate, #1: 1	أَطْعَمَ الْيَوْمَ
u'أَطْفَأَ سِرَاجٌ':Predicate, #1: 1	أَطْفَأَ الْحَرَارَةَ
u'أَطْلَعَ أحَدٌ':Subject, #1: 1	أَطْفَأَ السِّرَاجَ
u'أَطْلَعَ إمَامٌ':Predicate, #1: 1	أَطْلَعَ أَحَدُ
u'أَطْلَعَ بَعْضٌ':Subject, #1: 1	أَطْلَعَ الْإِمَامَ
u'أَطْلَعَ ثَمَرٌ':Subject, #1: 1	أَطْلَعَ بَعْضُ
u'أَطْلَقَ اِبْنٌ':Subject, #1: 1	أَطْلَعَ ثَمَرُ
u'أَطْلَقَ أُجْرَةٌ':Predicate, #7: 7	أَطْلَقَ ابْنُ
u'أَطْلَقَ أحَدٌ':Subject, #1: 1	أَطْلَقَ الْأُجْرَةَ
u'أَطْلَقَ إِحْرَامٌ':Predicate, #1: 1	أَطْلَقَ أَحَدٌ
u'أَطْلَقَ أَدَاءٌ':Predicate, #2: 2	أَطْلَقَ الْإِحْرَامَ
u'أَطْلَقَ إِذْنٌ':Predicate, #1: 1	أَطْلَقَ الْأَدَاءَ
u'أَطْلَقَ إِرَادَةٌ':Predicate, #2: 2	أَطْلَقَ الْإِذْنَ
u'أَطْلَقَ أَرْبَعَةٌ':Predicate, #1: 1	أَطْلَقَ الْإِرَادَةَ
u'أَطْلَقَ إِرْشَادٌ':Subject, #2: 2	أَطْلَقَ أَرْبَعَةَ
u'أَطْلَقَ إِسْلامِيُّ':Predicate, #2: 2	أَطْلَقَ الْإِرْشَادُ
u'أَطْلَقَ اِسْمٌ':Predicate, #1: 1	أَطْلَقَ الْإِسْلَامِيَّ
u'أَطْلَقَ اِشْتِراطٌ':Predicate, #18: 18	أَطْلَقَ اسْمَ
u'أَطْلَقَ اِشْتِراطٌ':Subject, #1: 1	أَطْلَقَ اشْتِرَاطَ
u'أَطْلَقَ أَصْحَابٌ':Subject, #1: 1	أَطْلَقَ اشْتِرَاطُ
u'أَطْلَقَ إضْمارٌ':Predicate, #11: 11	أَطْلَقَ الْأَصْحَابُ
u'أَطْلَقَ إِعارَةٌ':Predicate, #1: 1	أَطْلَقَ الْإِضْمَارَ
u'أَطْلَقَ إفْتَاءٌ':Predicate, #3: 3	أَطْلَقَ الْإِعَارَةَ
u'أَطْلَقَ أفْضَلِيَّةٌ':Predicate, #2: 2	أَطْلَقَ الْإِفْتَاءَ
u'أَطْلَقَ إقْرَارٌ':Predicate, #1: 1	أَطْلَقَ أَفْضَلِيَّةَ
u'أَطْلَقَ أَكْثَرُ':Predicate, #3: 3	أَطْلَقَ الْإِقْرَارَ
u'أَطْلَقَ أَكْثَرُ':Subject, #1: 1	أَطْلَقَ أَكْثَرَ
u'أَطْلَقَ اِلْتِزَامٌ':Predicate, #6: 6	أَطْلَقَ أَكْثَرُ
u'أَطْلَقَ إلْغَاءٌ':Predicate, #1: 1	أَطْلَقَ الْتِزَامَ
u'أَطْلَقَ الْمَرْأَةُ':Predicate, #1: 1	أَطْلَقَ إلْغَاءَ
u'أَطْلَقَ إمَامٌ':Subject, #1: 1	أَطْلَقَ الْمَرْأَةَ
u'أَطْلَقَ أمَةٌ':Predicate, #18: 18	أَطْلَقَ الْإِمَامُ
u'أَطْلَقَ أَمْرٌ':Predicate, #1: 1	أَطْلَقَ الْأَمَةَ
u'أَطْلَقَ إِنْكارٌ':Predicate, #3: 3	أَطْلَقَ الْأَمْرَ
u'أَطْلَقَ أهْلٌ':Predicate, #1: 1	أَطْلَقَ إنْكَارَ
u'أَطْلَقَ أوَانٌ':Predicate, #1: 1	أَطْلَقَ أَهْلَ
u'أَطْلَقَ أَوَّلُ':Predicate, #1: 1	أَطْلَقَ الْأَوَانَ
u'أَطْلَقَ أئِمَّةٌ':Subject, #2: 2	أَطْلَقَ الْأَوَّلَ
u'أَطْلَقَ أيَّامٌ':Predicate, #5: 5	أَطْلَقَ الْأَئِمَّةُ
u'أَطْلَقَ أَيَّامٌ':Predicate, #1: 1	أَطْلَقَ الْأَيَّامَ
u'أَطْلَقَ آيَةٌ':Predicate, #1: 1	أَطْلَقَ الْأَيَّامَ
u'أَطْلَقَ أَيْمَانٌ':Predicate, #1: 1	أَطْلَقَ الْآيَةَ
u'أَطْلَقَ بَائِنٌ':Predicate, #1: 1	أَطْلَقَ الْأَيْمَانَ
u'أَطْلَقَ بدنة':Predicate, #1: 1	أَطْلَقَ الْبَائِنَ
u'أَطْلَقَ بَطَلٌ':Predicate, #1: 1	أَطْلَقَ الْبَدَنَةَ
u'أَطْلَقَ بَطْنٌ':Predicate, #1: 1	أَطْلَقَ بَطَلَ
u'أَطْلَقَ بَعْضٌ':Subject, #1: 1	أَطْلَقَ الْبَطْنَ
u'أَطْلَقَ بِنَاءٌ':Predicate, #3: 3	أَطْلَقَ بَعْضُ
u'أَطْلَقَ بَيْعٌ':Predicate, #1: 1	أَطْلَقَ الْبِنَاءَ
u'أَطْلَقَ تَحْرِيمٌ':Predicate, #1: 1	أَطْلَقَ الْبَيْعَ
u'أَطْلَقَ تَحْرِيمٌ':Predicate, #1: 1	أَطْلَقَ التَّحْرِيمَ
u'أَطْلَقَ تَحْلِيلٌ':Predicate, #1: 1	أَطْلَقَ تَحْرِيمَ
u'أَطْلَقَ تَخْرِيجٌ':Predicate, #1: 1	أَطْلَقَ تَحْلِيلَ
u'أَطْلَقَ تَخْيِيرٌ':Predicate, #1: 1	أَطْلَقَ التَّخْرِيجَ
u'أَطْلَقَ تَذَكُّرٌ':Predicate, #1: 1	أَطْلَقَ التَّخْيِيرَ
u'أَطْلَقَ تَشْبِيهٌ':Predicate, #1: 1	أَطْلَقَ التَّذَكُّرَ
u'أَطْلَقَ تَصَرُّفٌ':Predicate, #1: 1	أَطْلَقَ تَشْبِيهَ
u'أَطْلَقَ تَعْلِيقٌ':Predicate, #1: 1	أَطْلَقَ التَّصَرُّفَ
u'أَطْلَقَ تَفْوِيضٌ':Predicate, #1: 1	أَطْلَقَ التَّعْلِيقَ
u'أَطْلَقَ تَكْليفٌ':Predicate, #1: 1	أَطْلَقَ التَّفْوِيضَ
u'أَطْلَقَ تَنْفِيلٌ':Predicate, #1: 1	أَطْلَقَ تَكْلِيفَ
u'أَطْلَقَ تَوَصُّلٌ':Predicate, #1: 1	أَطْلَقَ التَّنْفِيلَ
u'أَطْلَقَ تَوْكِيلٌ':Predicate, #1: 1	أَطْلَقَ التَّوَصُّلَ
u'أَطْلَقَ ثُبُوتٌ':Predicate, #3: 3	أَطْلَقَ التَّوْكِيلَ
u'أَطْلَقَ ثَلاثَةٌ':Predicate, #2: 2	أَطْلَقَ الثُّبُوتَ
u'أَطْلَقَ ثَلاثَةٌ':Predicate, #1: 1	أَطْلَقَ الثَّلَاثَةَ
u'أَطْلَقَ ثَمَنٌ':Predicate, #1: 1	أَطْلَقَ ثَلَاثَةَ
u'أَطْلَقَ جَازٌ':Predicate, #8: 8	أَطْلَقَ الثَّمَنَ
u'أَطْلَقَ جَرَيان':Predicate, #2: 2	أَطْلَقَ جَازَ
u'أَطْلَقَ جَمَاعَةٌ':Subject, #1: 1	أَطْلَقَ جَرَيَانَ
u'أَطْلَقَ جمع':Predicate, #10: 10	أَطْلَقَ جَمَاعَةٌ
u'أَطْلَقَ جَمْعٌ':Predicate, #3: 3	أَطْلَقَ الْجَمْعَ
u'أَطْلَقَ جَمْعٌ':Subject, #3: 3	أَطْلَقَ الْجَمْعَ
u'أَطْلَقَ جُنُونٌ':Predicate, #1: 1	أَطْلَقَ جَمْعٌ
u'أَطْلَقَ جَوَابٌ':Predicate, #1: 1	أَطْلَقَ الْجُنُونَ
u'أَطْلَقَ جَوَابٌ':Predicate, #10: 10	أَطْلَقَ الْجَوَابَ
u'أَطْلَقَ جَوَازٌ':Predicate, #1: 1	أَطْلَقَ جَوَابَ
u'أَطْلَقَ جَوَازٌ':Predicate, #2: 2	أَطْلَقَ جَوَازَ
u'أَطْلَقَ حاجَةٌ':Predicate, #3: 3	أَطْلَقَ الْجَوَازَ
u'أَطْلَقَ حاكِمٌ':Subject, #1: 1	أَطْلَقَ الْحَاجَةَ
u'أَطْلَقَ حَجٌّ':Predicate, #2: 2	أَطْلَقَ الْحَاكِمُ
u'أَطْلَقَ حَجَرٌ':Predicate, #2: 2	أَطْلَقَ الْحَجَّ
u'أَطْلَقَ حَجْرٌ':Predicate, #1: 1	أَطْلَقَ الْحَجَرَ
u'أَطْلَقَ حَدَثٌ':Predicate, #1: 1	أَطْلَقَ الْحَجْرَ
u'أَطْلَقَ حُرْمَةٌ':Predicate, #1: 1	أَطْلَقَ الْحَدَثَ
u'أَطْلَقَ حَقٌّ':Predicate, #4: 4	أَطْلَقَ الْحُرْمَةَ
u'أَطْلَقَ حَمْلٌ':Predicate, #2: 2	أَطْلَقَ الْحَقَّ
u'أَطْلَقَ حَوَالَةٌ':Predicate, #1: 1	أَطْلَقَ حَمْلَ
u'أَطْلَقَ خُبْزٌ':Predicate, #2: 2	أَطْلَقَ الْحَوَالَةَ
u'أَطْلَقَ خطبة':Predicate, #1: 1	أَطْلَقَ الْخُبْزَ
u'أَطْلَقَ خُطْبَةٌ':Predicate, #1: 1	أَطْلَقَ الْخُطْبَةَ
u'أَطْلَقَ خِلاَفٌ':Predicate, #1: 1	أَطْلَقَ الْخُطْبَةَ
u'أَطْلَقَ خِلاَفٌ':Subject, #507: 507	أَطْلَقَ الْخِلَافَ
u'أَطْلَقَ خيار':Predicate, #1: 1	أَطْلَقَ الْخِلَافُ
u'أَطْلَقَ خِيَارٌ':Predicate, #4: 4	أَطْلَقَ الْخِيَارَ
u'أَطْلَقَ دَارٌ':Predicate, #4: 4	أَطْلَقَ الْخِيَارَ
u'أَطْلَقَ دَرَاهِمُ':Predicate, #1: 1	أَطْلَقَ دَارَ
u'أَطْلَقَ دَعْوَةٌ':Predicate, #1: 1	أَطْلَقَ الدَّرَاهِمَ
u'أَطْلَقَ ذكر':Predicate, #1: 1	أَطْلَقَ الدَّعْوَةَ
u'أَطْلَقَ ذِكْرٌ':Predicate, #4: 4	أَطْلَقَ ذِكْرَ
u'أَطْلَقَ ذِمِّيٌّ':Subject, #4: 4	أَطْلَقَ ذِكْرَ
u'أَطْلَقَ رَبُّ':Subject, #1: 1	أَطْلَقَ الذِّمِّيُّ
u'أَطْلَقَ رَجْعِيٌّ':Predicate, #1: 1	أَطْلَقَ رَبُّ
u'أَطْلَقَ رَجُلٌ':Subject, #2: 2	أَطْلَقَ الرَّجْعِيَّ
u'أَطْلَقَ رضاع':Predicate, #2: 2	أَطْلَقَ الرَّجُلُ
u'أَطْلَقَ رُكوبٌ':Predicate, #1: 1	أَطْلَقَ الرَّضَاعَ
u'أَطْلَقَ رَهْنٌ':Predicate, #5: 5	أَطْلَقَ الرُّكُوبَ
u'أَطْلَقَ رِوايَةٌ':Predicate, #1: 1	أَطْلَقَ رَهْنَ
u'أَطْلَقَ زَوْجَةٌ':Predicate, #4: 4	أَطْلَقَ الرِّوَايَةَ
u'أَطْلَقَ سكر':Predicate, #1: 1	أَطْلَقَ الزَّوْجَةَ
u'أَطْلَقَ سُكْرٌ':Predicate, #1: 1	أَطْلَقَ السُّكْرَ
u'أَطْلَقَ سُلْطَانٌ':Subject, #1: 1	أَطْلَقَ السُّكْرَ
u'أَطْلَقَ سَلَفٌ':Subject, #1: 1	أَطْلَقَ السُّلْطَانُ
u'أَطْلَقَ سُؤَالٌ':Predicate, #1: 1	أَطْلَقَ السَّلَفُ
u'أَطْلَقَ سُورَةٌ':Predicate, #1: 1	أَطْلَقَ السُّؤَالَ
u'أَطْلَقَ شَارِعٌ':Predicate, #1: 1	أَطْلَقَ السُّورَةَ
u'أَطْلَقَ شَارِعٌ':Subject, #1: 1	أَطْلَقَ الشَّارِعَ
u'أَطْلَقَ شافِعِيّ':Subject, #2: 2	أَطْلَقَ الشَّارِعُ
u'أَطْلَقَ شُبْهَةٌ':Predicate, #8: 8	أَطْلَقَ الشَّافِعِيُّ
u'أَطْلَقَ شَرْطٌ':Predicate, #1: 1	أَطْلَقَ الشُّبْهَةَ
u'أَطْلَقَ شَرْعٌ':Subject, #1: 1	أَطْلَقَ الشَّرْطَ
u'أَطْلَقَ شركاء':Subject, #1: 1	أَطْلَقَ الشَّرْعُ
u'أَطْلَقَ شَقٌّ':Predicate, #2: 2	أَطْلَقَ الشُّرَكَاءُ
u'أَطْلَقَ شَهَادَةٌ':Predicate, #1: 1	أَطْلَقَ الشَّقَّ
u'أَطْلَقَ شَهْرٌ':Predicate, #1: 1	أَطْلَقَ الشَّهَادَةَ
u'أَطْلَقَ شَيْخٌ':Subject, #1: 1	أَطْلَقَ شَهْرَ
u'أَطْلَقَ صَاحِبٌ':Subject, #3: 3	أَطْلَقَ الشَّيْخُ
u'أَطْلَقَ صَبْغٌ':Predicate, #4: 4	أَطْلَقَ صَاحِبُ
u'أَطْلَقَ صَبِيٌّ':Predicate, #2: 2	أَطْلَقَ الصَّبْغَ
u'أَطْلَقَ صَحَابِيٌّ':Subject, #3: 3	أَطْلَقَ الصَّبِيَّ
u'أَطْلَقَ صِحَّةٌ':Predicate, #1: 1	أَطْلَقَ الصَّحَابِيُّ
u'أَطْلَقَ صَدْرٌ':Subject, #3: 3	أَطْلَقَ الصِّحَّةَ
u'أَطْلَقَ صدقة':Predicate, #1: 1	أَطْلَقَ صَدْرُ
u'أَطْلَقَ صَدَقَةٌ':Predicate, #1: 1	أَطْلَقَ الصَّدَقَةَ
u'أَطْلَقَ صَرِيحٌ':Predicate, #1: 1	أَطْلَقَ الصَّدَقَةَ
u'أَطْلَقَ صَلاَةٌ':Predicate, #1: 1	أَطْلَقَ صَرِيحَ
u'أَطْلَقَ صَلاَةٌ':Predicate, #1: 1	أَطْلَقَ صَلَاةَ
u'أَطْلَقَ صلح':Predicate, #5: 5	أَطْلَقَ الصَّلَاةَ
u'أَطْلَقَ صُلْحٌ':Predicate, #1: 1	أَطْلَقَ الصُّلْحَ
u'أَطْلَقَ صَوْمٌ':Predicate, #1: 1	أَطْلَقَ الصُّلْحَ
u'أَطْلَقَ ضَرَرٌ':Predicate, #1: 1	أَطْلَقَ الصَّوْمَ
u'أَطْلَقَ طعام':Predicate, #1: 1	أَطْلَقَ الضَّرَرَ
u'أَطْلَقَ طَعَامٌ':Predicate, #1: 1	أَطْلَقَ الطَّعَامَ
u'أَطْلَقَ طَلاَقٌ':Predicate, #1: 1	أَطْلَقَ الطَّعَامَ
u'أَطْلَقَ ظَنّ':Predicate, #2: 2	أَطْلَقَ الطَّلَاقَ
u'أَطْلَقَ ظَنِّيّ':Predicate, #1: 1	أَطْلَقَ ظَنِّيَّةَ
u'أَطْلَقَ عارِيَّةٌ':Predicate, #1: 1	أَطْلَقَ ظَنِّيَّةَ
u'أَطْلَقَ عِبَارَةٌ':Predicate, #3: 3	أَطْلَقَ الْعَارِيَّةَ
u'أَطْلَقَ عَبْدٌ':Predicate, #2: 2	أَطْلَقَ الْعِبَارَةَ
u'أَطْلَقَ عتق':Predicate, #2: 2	أَطْلَقَ الْعَبْدَ
u'أَطْلَقَ عتق':Predicate, #1: 1	أَطْلَقَ عَتَقَ
u'أَطْلَقَ عِتْقٌ':Predicate, #1: 1	أَطْلَقَ عِتْقَ
u'أَطْلَقَ عتق':Predicate, #1: 1	أَطْلَقَ عِتْقَ
u'أَطْلَقَ عِتْقٌ':Predicate, #2: 2	أَطْلَقَ الْعِتْقَ
u'أَطْلَقَ عَدَمٌ':Predicate, #2: 2	أَطْلَقَ الْعِتْقَ
u'أَطْلَقَ عَفْوٌ':Predicate, #6: 6	أَطْلَقَ عَدَمَ
u'أَطْلَقَ عَقْدٌ':Predicate, #1: 1	أَطْلَقَ الْعَفْوَ
u'أَطْلَقَ عَقْدٌ':Predicate, #1: 1	أَطْلَقَ عَقْدَ
u'أَطْلَقَ علم':Predicate, #4: 4	أَطْلَقَ الْعَقْدَ
u'أَطْلَقَ عِلْمٌ':Predicate, #1: 1	أَطْلَقَ الْعِلْمَ
u'أَطْلَقَ عَمَلٌ':Predicate, #1: 1	أَطْلَقَ الْعِلْمَ
u'أَطْلَقَ عُمُومٌ':Predicate, #1: 1	أَطْلَقَ الْعَمَلَ
u'أَطْلَقَ عند':Predicate, #1: 1	أَطْلَقَ عُمُومَ
u'أَطْلَقَ عَوْدٌ':Predicate, #1: 1	أَطْلَقَ عِنْدَ
u'أَطْلَقَ عَيْبٌ':Predicate, #1: 1	أَطْلَقَ عَوْدَ
u'أَطْلَقَ غَائِبٌ':Predicate, #1: 1	أَطْلَقَ الْعَيْبَ
u'أَطْلَقَ غَسْلٌ':Predicate, #1: 1	أَطْلَقَ الْغَائِبَ
u'أَطْلَقَ غير':Subject, #1: 1	أَطْلَقَ الْغَسْلَ
u'أَطْلَقَ غَيْرٌ':Subject, #2: 2	أَطْلَقَ غَيْرُ
u'أَطْلَقَ فقهاء':Subject, #2: 2	أَطْلَقَ غَيْرُ
u'أَطْلَقَ فلان':Predicate, #1: 1	أَطْلَقَ الْفُقَهَاءُ
u'أَطْلَقَ فلان':Subject, #1: 1	أَطْلَقَ مَكَّةَ
u'أَطْلَقَ فِنَاءٌ':Predicate, #8: 8	أَطْلَقَ الشَّافِعِيُّ
u'أَطْلَقَ قَالٌ':Predicate, #1: 1	أَطْلَقَ الْفِنَاءَ
u'أَطْلَقَ قَائِلٌ':Subject, #2: 2	أَطْلَقَ قَالَ
u'أَطْلَقَ قَدْرٌ':Predicate, #1: 1	أَطْلَقَ قَائِلُ
u'أَطْلَقَ قَرِيبٌ':Predicate, #1: 1	أَطْلَقَ قَدْرَ
u'أَطْلَقَ قضاة':Subject, #1: 1	أَطْلَقَ الْقَرِيبَ
u'أَطْلَقَ قول':Predicate, #1: 1	أَطْلَقَ الْقُضَاةُ
u'أَطْلَقَ قَوْلٌ':Predicate, #13: 13	أَطْلَقَ الْقَوْلَ
u'أَطْلَقَ قيام':Predicate, #13: 13	أَطْلَقَ الْقَوْلَ
u'أَطْلَقَ قِيَامٌ':Predicate, #2: 2	أَطْلَقَ الْقِيَامَ
u'أَطْلَقَ كَافِرٌ':Predicate, #2: 2	أَطْلَقَ الْقِيَامَ
u'أَطْلَقَ كِتَابَةٌ':Predicate, #2: 2	أَطْلَقَ الْكَافِرَ
u'أَطْلَقَ كذب':Predicate, #1: 1	أَطْلَقَ الْكِتَابَةَ
u'أَطْلَقَ كَذِبٌ':Predicate, #1: 1	أَطْلَقَ الْكَذِبَ
u'أَطْلَقَ كَرَاهَةٌ':Predicate, #1: 1	أَطْلَقَ الْكَذِبَ
u'أَطْلَقَ كُفَّارٌ':Subject, #8: 8	أَطْلَقَ الْكَرَاهَةَ
u'أَطْلَقَ كفر':Predicate, #1: 1	أَطْلَقَ كُفَّارٌ
u'أَطْلَقَ كُفْرٌ':Predicate, #1: 1	أَطْلَقَ الْكُفْرَ
u'أَطْلَقَ كَلَأٌ':Predicate, #1: 1	أَطْلَقَ الْكُفْرَ
u'أَطْلَقَ كَلاَمٌ':Predicate, #1: 1	أَطْلَقَ الْكَلَأَ
u'أَطْلَقَ لَفْظٌ':Predicate, #5: 5	أَطْلَقَ الْكَلَامَ
u'أَطْلَقَ لَفْظٌ':Predicate, #3: 3	أَطْلَقَ اللَّفْظَ
u'أَطْلَقَ لَيْلٌ':Predicate, #4: 4	أَطْلَقَ لَفْظَ
u'أَطْلَقَ مَاءٌ':Predicate, #1: 1	أَطْلَقَ اللَّيْلَةَ
u'أَطْلَقَ مَاسِحٌ':Predicate, #1: 1	أَطْلَقَ الْمَاءَ
u'أَطْلَقَ مَالٌ':Predicate, #1: 1	أَطْلَقَ الْمَاسِحَ
u'أَطْلَقَ مَالِكٌ':Subject, #1: 1	أَطْلَقَ الْمَالَ
u'أَطْلَقَ مُبَايَعَةٌ':Predicate, #1: 1	أَطْلَقَ الْمَالِكُ
u'أَطْلَقَ مثل':Predicate, #1: 1	أَطْلَقَ الْمُبَايَعَةَ
u'أَطْلَقَ مِثْلٌ':Predicate, #1: 1	أَطْلَقَ الْمِثْلَ
u'أَطْلَقَ مَحَلٌّ':Predicate, #1: 1	أَطْلَقَ الْمِثْلَ
u'أَطْلَقَ مُحَمَّدٌ':Subject, #1: 1	أَطْلَقَ مَحَلَّ
u'أَطْلَقَ مَحْمُولٌ':Subject, #7: 7	أَطْلَقَ مُحَمَّدٌ
u'أَطْلَقَ مُدَّةٌ':Predicate, #3: 3	أَطْلَقَ مَحْمُولٌ
u'أَطْلَقَ مَرِيضٌ':Subject, #1: 1	أَطْلَقَ مُدَّةَ
u'أَطْلَقَ مَسْأَلَةٌ':Predicate, #1: 1	أَطْلَقَ الْمَرِيضُ
u'أَطْلَقَ مَسْأَلَةٌ':Predicate, #1: 1	أَطْلَقَ الْمَسْأَلَةَ
u'أَطْلَقَ مَسْجِدٌ':Predicate, #1: 1	أَطْلَقَ مَسْأَلَةَ
u'أَطْلَقَ مَصْلَحَةٌ':Predicate, #1: 1	أَطْلَقَ الْمَسْجِدَ
u'أَطْلَقَ مُصَنِّفٌ':Subject, #1: 1	أَطْلَقَ الْمَصْلَحَةَ
u'أَطْلَقَ مُضَافٌ':Predicate, #71: 71	أَطْلَقَ الْمُصَنِّفُ
u'أَطْلَقَ مُطْلِقٌ':Subject, #1: 1	أَطْلَقَ الْمُضَافَ
u'أَطْلَقَ مَطْلُوبٌ':Predicate, #1: 1	أَطْلَقَ مُطْلِقٌ
u'أَطْلَقَ مُعْتَدٌّ':Predicate, #1: 1	أَطْلَقَ الْمَطْلُوبَ
u'أَطْلَقَ مُعْظَمٌ':Subject, #1: 1	أَطْلَقَ الْمُعْتَدَّةَ
u'أَطْلَقَ مُغَنِّي':Predicate, #1: 1	أَطْلَقَ مُعْظَمُ
u'أَطْلَقَ مُقَارَنٌ':Predicate, #1: 1	أَطْلَقَ الْمُغَنِّيَةَ
u'أَطْلَقَ مُقَارَنَةٌ':Predicate, #1: 1	أَطْلَقَ الْمُقَارَنَةَ
u'أَطْلَقَ مُقَيَّدٌ':Subject, #1: 1	أَطْلَقَ الْمُقَارَنَةَ
u'أَطْلَقَ مَكْتُوبٌ':Predicate, #2: 2	أَطْلَقَ مُقَيَّدٌ
u'أَطْلَقَ مِلْكٌ':Predicate, #1: 1	أَطْلَقَ الْمَكْتُوبَ
u'أَطْلَقَ مَمْلُوكٌ':Subject, #4: 4	أَطْلَقَ الْمِلْكَ
u'أَطْلَقَ مَنْعٌ':Predicate, #1: 1	أَطْلَقَ الْمَمْلُوكُ
u'أَطْلَقَ مَوْقُوفٌ':Subject, #5: 5	أَطْلَقَ الْمَنْعَ
u'أَطْلَقَ مُؤَلِّفٌ':Subject, #1: 1	أَطْلَقَ مَوْقُوفَةٌ
u'أَطْلَقَ نَجَاسَةٌ':Predicate, #1: 1	أَطْلَقَ الْمُؤَلِّفُ
u'أَطْلَقَ نَجَسٌ':Predicate, #1: 1	أَطْلَقَ نَجَاسَةَ
u'أَطْلَقَ نِدَاءٌ':Predicate, #2: 2	أَطْلَقَ النَّجَسَ
u'أَطْلَقَ نذر':Predicate, #1: 1	أَطْلَقَ النِّدَاءَ
u'أَطْلَقَ نَذْرٌ':Predicate, #6: 6	أَطْلَقَ النَّذْرَ
u'أَطْلَقَ نَصْرَانِيٌّ':Predicate, #6: 6	أَطْلَقَ النَّذْرَ
u'أَطْلَقَ نَظَرٌ':Predicate, #1: 1	أَطْلَقَ النَّصْرَانِيَّ
u'أَطْلَقَ نَفَقَةٌ':Predicate, #2: 2	أَطْلَقَ النَّظَرَ
u'أَطْلَقَ نَفْيٌ':Predicate, #2: 2	أَطْلَقَ النَّفَقَةَ
u'أَطْلَقَ نقلة':Subject, #1: 1	أَطْلَقَ نَفْيَ
u'أَطْلَقَ نَقَلَةٌ':Subject, #1: 1	أَطْلَقَ النَّقَلَةُ
u'أَطْلَقَ نكاح':Predicate, #1: 1	أَطْلَقَ النَّقَلَةُ
u'أَطْلَقَ نِكَاحٌ':Predicate, #1: 1	أَطْلَقَ النِّكَاحَ
u'أَطْلَقَ نَوَوِيٌّ':Subject, #1: 1	أَطْلَقَ النِّكَاحَ
u'أَطْلَقَ نِيَّةٌ':Predicate, #2: 2	أَطْلَقَ النَّوَوِيُّ
u'أَطْلَقَ نِيَّةٌ':Predicate, #13: 13	أَطْلَقَ النِّيَّةَ
u'أَطْلَقَ هِبَةٌ':Predicate, #3: 3	أَطْلَقَ نِيَّةَ
u'أَطْلَقَ وَاجِبٌ':Predicate, #1: 1	أَطْلَقَ الْهِبَةَ
u'أَطْلَقَ واحد':Predicate, #1: 1	أَطْلَقَ الْوَاجِبَ
u'أَطْلَقَ وَاحِدٌ':Predicate, #1: 1	أَطْلَقَ الْوَاحِدَ
u'أَطْلَقَ وَارِثٌ':Predicate, #1: 1	أَطْلَقَ الْوَاحِدَ
u'أَطْلَقَ وَاقِفٌ':Subject, #1: 1	أَطْلَقَ الْوَارِثَ
u'أَطْلَقَ وُجُوبٌ':Predicate, #1: 1	أَطْلَقَ الْوَاقِفُ
u'أَطْلَقَ وَزِيرٌ':Subject, #2: 2	أَطْلَقَ وُجُوبَ
u'أَطْلَقَ وَصِيٌّ':Predicate, #1: 1	أَطْلَقَ الْوَزِيرُ
u'أَطْلَقَ وَصِيَّةٌ':Predicate, #2: 2	أَطْلَقَ الْوَصِيَّةَ
u'أَطْلَقَ وَقْتٌ':Predicate, #2: 2	أَطْلَقَ الْوَصِيَّةَ
u'أَطْلَقَ وقع':Predicate, #2: 2	أَطْلَقَ الْوَقْتَ
u'أَطْلَقَ وَقْفٌ':Predicate, #4: 4	أَطْلَقَ وَقَعَ
u'أَطْلَقَ وُقُوعٌ':Predicate, #1: 1	أَطْلَقَ وَقْفَ
u'أَطْلَقَ وُقُوعٌ':Predicate, #1: 1	أَطْلَقَ الْوُقُوعَ
u'أَطْلَقَ وَلَهٌ':Subject, #1: 1	أَطْلَقَ وُقُوعَ
u'أَطْلَقَ وَلِيٌّ':Subject, #1: 1	أَطْلَقَ وَلَهُ
u'أَطْلَقَ يَدٌ':Predicate, #1: 1	أَطْلَقَ وَلِيُّ
u'أَطْلَقَ يَمِينٌ':Predicate, #1: 1	أَطْلَقَ الْيَدَ
u'أَطْمَاعٌ آمال':Added, #3: 3	أَطْلَقَ الْيَمِينَ
u'أَطْمَاعٌ عَبْدٌ':Added, #1: 1	أَطْمَاعُ آمَالِهِ
u'أَطْمَاعٌ فقراء':Added, #1: 1	أَطْمَاعُ عَبْدٍ
u'أَطْمَاعٌ نَفْسٌ':Added, #1: 1	أَطْمَاعُ الْفُقَرَاءِ
u'أَطْمَاعٌ نَفْسٌ':Added, #1: 1	أَطْمَاعِ النَّفْسِ
u'أَطْمَاعٌ وَرَثَةٌ':Added, #1: 1	أَطْمَاعُ نَفْسِهِ
u'أَطْنَبَ اِبْنٌ':Subject, #1: 1	أَطْمَاعُ الْوَرَثَةِ
u'أَطْنَبَ إمَامٌ':Subject, #1: 1	أَطْنَبَ ابْنُ
u'أَطْوَلَ قَالٌ':Predicate, #1: 1	أَطْنَبَ الْإِمَامُ
u'أَظَلَّ رَأْسٌ':Predicate, #1: 1	أَطْوَلَ قَالَ
u'أَظَلَّ زَمانٌ':Subject, #1: 1	أَظَلَّ رَأْسَ
u'أَظْلَمَ أهْلٌ':Subject, #2: 2	أَظَلَّ زَمَانُهُ
u'أَظْلَمَ لَيْلٌ':Subject, #1: 1	أَظْلَمَ أَهْلُهُ
u'أَظْلَمَ هواد':Subject, #1: 1	أَظْلَمَ لَيْلُهُ
u'أَظْهَرَ اِبْنٌ':Subject, #1: 1	أَظْلَمَ هَوَادُ
u'أَظْهَرَ إِسْلامٌ':Predicate, #2: 2	أَظْهَرَ ابْنُ
u'أَظْهَرَ إِسْلامٌ':Predicate, #2: 2	أَظْهَرَ الإِسْلاَمَ
u'أَظْهَرَ أَغْرَاضٌ':Predicate, #3: 3	أَظْهَرَ الْإِسْلَامَ
u'أَظْهَرَ أَوَّلُ':Subject, #1: 1	أَظْهَرَ الْأَغْرَاضَ
u'أَظْهَرَ إيمَانٌ':Predicate, #1: 1	أَظْهَرَ الْأَوَّلُ
u'أَظْهَرَ بَحْثٌ':Subject, #1: 1	أَظْهَرَ الإِيمَانَ
u'أَظْهَرَ بَطْنٌ':Predicate, #1: 1	أَظْهَرَ الْبَحْثُ
u'أَظْهَرَ بَعْضٌ':Predicate, #1: 1	أَظْهَرَ بَطْنَ
u'أَظْهَرَ بَيَانٌ':Subject, #1: 1	أَظْهَرَ بَعْضَ
u'أَظْهَرَ بَيْعٌ':Predicate, #1: 1	أَظْهَرَ الْبَيَانُ
u'أَظْهَرَ بَيْعٌ':Predicate, #1: 1	أَظْهَرَ الْبَيْعَ
u'أَظْهَرَ تَبَرُّمٌ':Predicate, #1: 1	أَظْهَرَ بَيْعَ
u'أَظْهَرَ تَرْكٌ':Predicate, #1: 1	أَظْهَرَ التَّبَرُّمَ
u'أَظْهَرَ تَوَاضُعٌ':Predicate, #1: 1	أَظْهَرَ التَّرْكَ
u'أَظْهَرَ تَوْبَةٌ':Predicate, #1: 1	أَظْهَرَ التَّوَاضُعَ
u'أَظْهَرَ جِلْدَةٌ':Predicate, #1: 1	أَظْهَرَ التَّوْبَةَ
u'أَظْهَرَ جَمِيلٌ':Predicate, #1: 1	أَظْهَرَ الْجِلْدَةَ
u'أَظْهَرَ حالٌ':Predicate, #1: 1	أَظْهَرَ الْجَمِيلَ
u'أَظْهَرَ حُرِّيَّةٌ':Predicate, #1: 1	أَظْهَرَ حَالَ
u'أَظْهَرَ حَقٌّ':Predicate, #1: 1	أَظْهَرَ الْحُرِّيَّةَ
u'أَظْهَرَ حَقٌّ':Predicate, #1: 1	أَظْهَرَ الْحَقَّ
u'أَظْهَرَ حَقِيقٌ':Predicate, #2: 2	أَظْهَرَ حَقَّ
u'أَظْهَرَ حَقِيقَةٌ':Predicate, #1: 1	أَظْهَرَ حَقِيقَةَ
u'أَظْهَرَ خَارِقٌ':Predicate, #1: 1	أَظْهَرَ حَقِيقَةَ
u'أَظْهَرَ خَطَأٌ':Predicate, #1: 1	أَظْهَرَ خَارِقَةً
u'أَظْهَرَ خِلاَفٌ':Predicate, #1: 1	أَظْهَرَ الْخَطَأَ
u'أَظْهَرَ خَيْرٌ':Predicate, #1: 1	أَظْهَرَ خِلَافَ
u'أَظْهَرَ دِينٌ':Predicate, #3: 3	أَظْهَرَ الْخَيْرَ
u'أَظْهَرَ ذِمِّيٌّ':Subject, #1: 1	أَظْهَرَ الدِّينَ
u'أَظْهَرَ رِدَّةٌ':Predicate, #1: 1	أَظْهَرَ الذِّمِّيُّ
u'أَظْهَرَ زَوْجٌ':Subject, #2: 2	أَظْهَرَ الرِّدَّةَ
u'أَظْهَرَ شَخْصٌ':Subject, #1: 1	أَظْهَرَ الزَّوْجُ
u'أَظْهَرَ شَرْعٌ':Subject, #1: 1	أَظْهَرَ شَخْصٌ
u'أَظْهَرَ صَغِيرٌ':Predicate, #1: 1	أَظْهَرَ الشَّرْعُ
u'أَظْهَرَ ظاهِرٌ':Predicate, #1: 1	أَظْهَرَ صَغِيرَةً
u'أَظْهَرَ عَدَمٌ':Predicate, #1: 1	أَظْهَرَ الظَّاهِرِينَ
u'أَظْهَرَ عَشْرٌ':Predicate, #1: 1	أَظْهَرَ عَدَمَ
u'أَظْهَرَ عَصَبِيٌّ':Predicate, #1: 1	أَظْهَرَ عَشْرَةً
u'أَظْهَرَ عَصَبِيَّةٌ':Predicate, #1: 1	أَظْهَرَ الْعَصَبِيَّةَ
u'أَظْهَرَ عَلِيٌّ':Subject, #1: 1	أَظْهَرَ الْعَصَبِيَّةَ
u'أَظْهَرَ عَيْبٌ':Predicate, #1: 1	أَظْهَرَ عَلِيٌّ
u'أَظْهَرَ غضب':Predicate, #2: 2	أَظْهَرَ عَيْبَ
u'أَظْهَرَ غَضَبٌ':Predicate, #1: 1	أَظْهَرَ الْغَضَبَ
u'أَظْهَرَ غناء':Predicate, #1: 1	أَظْهَرَ الْغَضَبَ
u'أَظْهَرَ غَنَاءٌ':Predicate, #1: 1	أَظْهَرَ غَنَاءَ
u'أَظْهَرَ فَاقَةٌ':Predicate, #1: 1	أَظْهَرَ غَنَاءَ
u'أَظْهَرَ فِسْقٌ':Predicate, #2: 2	أَظْهَرَ الْفَاقَةَ
u'أَظْهَرَ قذف':Predicate, #2: 2	أَظْهَرَ الْفِسْقَ
u'أَظْهَرَ قَذْفٌ':Predicate, #1: 1	أَظْهَرَ الْقَذْفَ
u'أَظْهَرَ قَوْمٌ':Subject, #1: 1	أَظْهَرَ الْقَذْفَ
u'أَظْهَرَ كَمَالٌ':Predicate, #2: 2	أَظْهَرَ قَوْمٌ
u'أَظْهَرَ مراد':Predicate, #1: 1	أَظْهَرَ كَمَالَ
u'أَظْهَرَ مُرَادٌ':Predicate, #1: 1	أَظْهَرَ الْمُرَادَ
u'أَظْهَرَ مُسْتَأْجِرٌ':Subject, #1: 1	أَظْهَرَ الْمُرَادَ
u'أَظْهَرَ مُعْجِزٌ':Predicate, #1: 1	أَظْهَرَ الْمُسْتَأْجِرُ
u'أَظْهَرَ مُعْجِزَةٌ':Predicate, #1: 1	أَظْهَرَ الْمُعْجِزَةَ
u'أَظْهَرَ مَعَرَّة':Predicate, #1: 1	أَظْهَرَ الْمُعْجِزَةَ
u'أَظْهَرَ مَعْصِيَةٌ':Predicate, #3: 3	أَظْهَرَ مَعَرَّةَ
u'أَظْهَرَ ميل':Predicate, #1: 1	أَظْهَرَ الْمَعْصِيَةَ
u'أَظْهَرَ مَيْلٌ':Predicate, #1: 1	أَظْهَرَ الْمَيْلَ
u'أَعَادَ إبَاحَةٌ':Predicate, #1: 1	أَظْهَرَ الْمَيْلَ
u'أَعَادَ اِبْنٌ':Subject, #1: 1	أَعَادَ إبَاحَةَ
u'أَعَادَ إثْرٌ':Predicate, #1: 1	أَعَادَ ابْنُ
u'أَعَادَ أَذَانٌ':Predicate, #1: 1	أَعَادَ إثْرَ
u'أَعَادَ إشارَة':Predicate, #3: 3	أَعَادَ الْأَذَانَ
u'أَعَادَ أُصْبُعٌ':Predicate, #1: 1	أَعَادَ الْإِشَارَةَ
u'أَعَادَ إقامَةٌ':Predicate, #1: 1	أَعَادَ الْأُصْبُعَ
u'أَعَادَ إقْرَارٌ':Predicate, #4: 4	أَعَادَ الْإِقَامَةَ
u'أَعَادَ إمَامٌ':Subject, #2: 2	أَعَادَ الْإِقْرَارَ
u'أَعَادَ أَمْرٌ':Predicate, #3: 3	أَعَادَ الْإِمَامُ
u'أَعَادَ أَوَّلُ':Predicate, #1: 1	أَعَادَ الْأَمْرَ
u'أَعَادَ إِيجَابٌ':Predicate, #1: 1	أَعَادَ الْأَوَّلَ
u'أَعَادَ بُنْيانٌ':Predicate, #1: 1	أَعَادَ الْإِيجَابَ
u'أَعَادَ بَيِّنَةٌ':Predicate, #1: 1	أَعَادَ الْبُنْيَانَ
u'أَعَادَ تَرَاوِيحُ':Predicate, #8: 8	أَعَادَ الْبَيِّنَةَ
u'أَعَادَ تَعَوُّذٌ':Predicate, #1: 1	أَعَادَ التَّرَاوِيحَ
u'أَعَادَ تَلْبيَةٌ':Predicate, #2: 2	أَعَادَ التَّعَوُّذَ
u'أَعَادَ تَيَمُّمٌ':Predicate, #1: 1	أَعَادَ التَّلْبِيَةَ
u'أَعَادَ ثَانِي':Predicate, #7: 7	أَعَادَ التَّيَمُّمَ
u'أَعَادَ ثَانِيَةٌ':Predicate, #3: 3	أَعَادَ الثَّانِيَةَ
u'أَعَادَ جِمَارٌ':Predicate, #3: 3	أَعَادَ الثَّانِيَةَ
u'أَعَادَ جَمْرَةٌ':Predicate, #1: 1	أَعَادَ الْجِمَارَ
u'أَعَادَ جَمْرَة':Predicate, #1: 1	أَعَادَ الْجَمْرَةَ
u'أَعَادَ حاكِمٌ':Subject, #1: 1	أَعَادَ الْجَمْرَةَ
u'أَعَادَ حائِطٌ':Predicate, #1: 1	أَعَادَ الْحَاكِمُ
u'أَعَادَ حَجٌّ':Predicate, #1: 1	أَعَادَ حَائِطَ
u'أَعَادَ حجاب':Predicate, #4: 4	أَعَادَ الْحَجَّ
u'أَعَادَ حِجابٌ':Predicate, #1: 1	أَعَادَ الْحِجَابَ
u'أَعَادَ حُكْمٌ':Predicate, #1: 1	أَعَادَ الْحِجَابَ
u'أَعَادَ خَارِجٌ':Subject, #1: 1	أَعَادَ حُكْمَ
u'أَعَادَ خَائِفٌ':Subject, #1: 1	أَعَادَ الْخَارِجُ
u'أَعَادَ خطبة':Predicate, #1: 1	أَعَادَ الْخَائِفُ
u'أَعَادَ خُطْبَةٌ':Predicate, #1: 1	أَعَادَ الْخُطْبَةَ
u'أَعَادَ دُعَاءٌ':Predicate, #1: 1	أَعَادَ الْخُطْبَةَ
u'أَعَادَ دَلْوٌ':Predicate, #2: 2	أَعَادَ الدُّعَاءَ
u'أَعَادَ ذكر':Predicate, #1: 1	أَعَادَ الدَّلْوَ
u'أَعَادَ ذِكْرٌ':Predicate, #1: 1	أَعَادَ ذِكْرَ
u'أَعَادَ رُكْنٌ':Predicate, #1: 1	أَعَادَ ذِكْرَ
u'أَعَادَ رُكْن':Predicate, #2: 2	أَعَادَ الرُّكْنَ
u'أَعَادَ رُكوعٌ':Predicate, #2: 2	أَعَادَ الرُّكْنَ
u'أَعَادَ زَمانٌ':Predicate, #2: 2	أَعَادَ الرُّكُوعَ
u'أَعَادَ سجدة':Predicate, #1: 1	أَعَادَ الزَّمَانَ
u'أَعَادَ سَجْدَةٌ':Predicate, #2: 2	أَعَادَ السَّجْدَةَ
u'أَعَادَ سُجُودٌ':Predicate, #2: 2	أَعَادَ السَّجْدَةَ
u'أَعَادَ سِنٌّ':Predicate, #3: 3	أَعَادَ السُّجُودَ
u'أَعَادَ سُورَةٌ':Predicate, #1: 1	أَعَادَ السِّنَّ
u'أَعَادَ شَرْطٌ':Predicate, #1: 1	أَعَادَ السُّورَةَ
u'أَعَادَ صَاحِبٌ':Predicate, #1: 1	أَعَادَ الشَّرْطَ
u'أَعَادَ صَلاَةٌ':Predicate, #1: 1	أَعَادَ صَاحِبَ
u'أَعَادَ صَلاَةٌ':Predicate, #1: 1	أَعَادَ الصَّلاةَ
u'أَعَادَ صَلاَةٌ':Predicate, #1: 1	أَعَادَ صَلاَةَ
u'أَعَادَ صَلاَةٌ':Predicate, #26: 26	أَعَادَ الصَّلَاةَ
u'أَعَادَ صَلاَةٌ':Predicate, #3: 3	أَعَادَ صَلَاةَ
u'أَعَادَ ضَرْبٌ':Predicate, #5: 5	أَعَادَ الصَّلاَةَ
u'أَعَادَ ضَمِيرٌ':Predicate, #3: 3	أَعَادَ الضَّرْبَ
u'أَعَادَ طَبْخٌ':Predicate, #3: 3	أَعَادَ الضَّمِيرَ
u'أَعَادَ طلب':Predicate, #5: 5	أَعَادَ الطَّبْخَ
u'أَعَادَ طَلَبٌ':Predicate, #1: 1	أَعَادَ الطَّلَبَ
u'أَعَادَ طَهَارَةٌ':Predicate, #1: 1	أَعَادَ الطَّلَبَ
u'أَعَادَ طواف':Predicate, #1: 1	أَعَادَ الطَّهَارَةَ
u'أَعَادَ طَوَافٌ':Predicate, #12: 12	أَعَادَ الطَّوَافَ
u'أَعَادَ طواف':Predicate, #12: 12	أَعَادَ الطَّوَافَ
u'أَعَادَ طَوَافٌ':Predicate, #2: 2	أَعَادَ طَوَافَ
u'أَعَادَ ظُهْرٌ':Predicate, #2: 2	أَعَادَ طَوَافَ
u'أَعَادَ عَامِلٌ':Predicate, #5: 5	أَعَادَ الظُّهْرَ
u'أَعَادَ عِشَاءٌ':Predicate, #1: 1	أَعَادَ الْعَامِلَ
u'أَعَادَ عَصْرٌ':Predicate, #2: 2	أَعَادَ الْعِشَاءَ
u'أَعَادَ عُمُومٌ':Predicate, #2: 2	أَعَادَ الْعَصْرَ
u'أَعَادَ عند':Predicate, #1: 1	أَعَادَ الْعُمُومَ
u'أَعَادَ غَاصِبٌ':Subject, #1: 1	أَعَادَ عِنْدَ
u'أَعَادَ غير':Subject, #1: 1	أَعَادَ الْغَاصِبُ
u'أَعَادَ غَيْرٌ':Subject, #1: 1	أَعَادَ غَيْرُ
u'أَعَادَ فَاتِحٌ':Predicate, #1: 1	أَعَادَ غَيْرُ
u'أَعَادَ فَاتِحَةٌ':Predicate, #3: 3	أَعَادَ الْفَاتِحَةَ
u'أَعَادَ فَجْرٌ':Predicate, #3: 3	أَعَادَ الْفَاتِحَةَ
u'أَعَادَ قَالٌ':Predicate, #2: 2	أَعَادَ الْفَجْرَ
u'أَعَادَ قِرَاءةٌ':Predicate, #1: 1	أَعَادَ قَالَ
u'أَعَادَ قِرَاءةٌ':Predicate, #2: 2	أَعَادَ قِرَاءَةَ
u'أَعَادَ قَيْءٌ':Predicate, #5: 5	أَعَادَ الْقِرَاءَةَ
u'أَعَادَ كَلِمَةٌ':Predicate, #1: 1	أَعَادَ الْقَيْءَ
u'أَعَادَ لاَمٌ':Predicate, #3: 3	أَعَادَ كَلِمَةَ
u'أَعَادَ لعان':Predicate, #1: 1	أَعَادَ اللَّامَ
u'أَعَادَ لَفْظٌ':Predicate, #2: 2	أَعَادَ اللِّعَانَ
u'أَعَادَ مَاءٌ':Predicate, #1: 1	أَعَادَ اللَّفْظَ
u'أَعَادَ مرٌّ':Predicate, #1: 1	أَعَادَ الْمَاءَ
u'أَعَادَ مَسْأَلَةٌ':Predicate, #2: 2	أَعَادَ مَرَّةً
u'أَعَادَ مُسْتَحِقٌّ':Subject, #3: 3	أَعَادَ الْمَسْأَلَةَ
u'أَعَادَ مَسْحٌ':Predicate, #2: 2	أَعَادَ الْمُسْتَحِقُّ
u'أَعَادَ مُصَنِّفٌ':Subject, #3: 3	أَعَادَ الْمَسْحَ
u'أَعَادَ مُطَالَبٌ':Predicate, #2: 2	أَعَادَ الْمُصَنِّفُ
u'أَعَادَ مُطَالَبَةٌ':Predicate, #1: 1	أَعَادَ الْمُطَالَبَةَ
u'أَعَادَ مَغْرِبٌ':Predicate, #1: 1	أَعَادَ الْمُطَالَبَةَ
u'أَعَادَ مُقَدَّمٌ':Predicate, #3: 3	أَعَادَ الْمَغْرِبَ
u'أَعَادَ مُنَكَّسٌ':Subject, #2: 2	أَعَادَ الْمُقَدَّمَ
u'أَعَادَ نَصٌّ':Predicate, #1: 1	أَعَادَ الْمُنَكَّسُ
u'أَعَادَ نَظَرٌ':Predicate, #2: 2	أَعَادَ نَصَّ
u'أَعَادَ وداع':Predicate, #1: 1	أَعَادَ النَّظَرَ
u'أَعَادَ وَدَاعٌ':Predicate, #3: 3	أَعَادَ الْوَدَاعَ
u'أَعَادَ وُضُوءٌ':Predicate, #3: 3	أَعَادَ الْوَدَاعَ
u'أَعَادَ وُضُوءٌ':Predicate, #10: 10	أَعَادَ الْوُضُوءَ
u'أَعَادَ وَقْفٌ':Predicate, #1: 1	أَعَادَ وُضُوءَ
u'أَعَادَ وَلِيٌّ':Subject, #1: 1	أَعَادَ الْوَقْفَ
u'أَعَارَ أرْضٌ':Predicate, #6: 6	أَعَادَ الْوَلِيُّ
u'أَعَارَ بَائِعٌ':Subject, #3: 3	أَعَارَ الْأَرْضَ
u'أَعَارَ ثَوْبٌ':Predicate, #2: 2	أَعَارَ الْبَائِعُ
u'أَعَارَ جَازٌ':Predicate, #1: 1	أَعَارَ ثَوْبَ
u'أَعَارَ رَسُولٌ':Predicate, #1: 1	أَعَارَ جَازَ
u'أَعَارَ رَهْنٌ':Predicate, #2: 2	أَعَارَ رَسُولَ
u'أَعَارَ شَرِيكٌ':Subject, #1: 1	أَعَارَ الرَّهْنَ
u'أَعَارَ طِينٌ':Predicate, #1: 1	أَعَارَ الشَّرِيكُ
u'أَعَارَ عَبْدٌ':Predicate, #1: 1	أَعَارَ الطِّينَ
u'أَعَارَ عَبْدٌ':Subject, #1: 1	أَعَارَ الْعَبْدَ
u'أَعَارَ عَشْرٌ':Predicate, #1: 1	أَعَارَ عَبْدٌ
u'أَعَارَ كَلْبٌ':Predicate, #1: 1	أَعَارَ عَشْرَةَ
u'أَعَارَ مَالِكٌ':Subject, #1: 1	أَعَارَ الْكَلْبَ
u'أَعَارَ مُحْرِمٌ':Subject, #1: 1	أَعَارَ الْمَالِكُ
u'أَعَارَ مُرْتَهِنٌ':Subject, #1: 1	أَعَارَ الْمُحْرِمُ
u'أَعَارَ مساكين':Predicate, #5: 5	أَعَارَ الْمُرْتَهِنُ
u'أَعَارَ مُسْتَأْجِرٌ':Predicate, #1: 1	أَعَارَ الْمَسَاكِينَ
u'أَعَارَ مُسْتَأْجِرٌ':Subject, #1: 1	أَعَارَ الْمُسْتَأْجِرَ
u'أَعَارَ مُسْتَحِقٌّ':Subject, #1: 1	أَعَارَ الْمُسْتَأْجِرُ
u'أَعَارَ مُسْلِمٌ':Subject, #1: 1	أَعَارَ مُسْتَحِقُّ
u'أَعَالَ رَجُلٌ':Subject, #2: 2	أَعَارَ الْمُسْلِمُ
u'أَعَالَ فَرَائِضُ':Predicate, #1: 1	أَعَالَ الرَّجُلُ
u'أَعَانَ أَجْرٌ':Subject, #3: 3	أَعَالَ الْفَرَائِضَ
u'أَعَانَ إِنْسانٌ':Subject, #1: 1	أَعَانَ أَجْرُ
u'أَعَانَ جَمِيع':Predicate, #1: 1	أَعَانَ إنْسَانٌ
u'أَعَانَ ظالِمٌ':Predicate, #1: 1	أَعَانَ الْجَمِيعَ
u'أَعَانَ مُحَارِبٌ':Predicate, #1: 1	أَعَانَ الظَّالِمَ
u'أَعَانَ مُحْرِمٌ':Subject, #1: 1	أَعَانَ الْمُحَارِبِينَ
u'أَعَانَ مُسْلِمٌ':Subject, #1: 1	أَعَانَ مُحْرِمٌ
u'أَعْتَقَ أَبٌ':Predicate, #1: 1	أَعَانَ مُسْلِمٌ
u'أَعْتَقَ أَبٌ':Subject, #8: 8	أَعْتَقَ الْأَبَ
u'أَعْتَقَ أَبٌ':Subject, #1: 1	أَعْتَقَ أَبٌ
u'أَعْتَقَ اِبْنٌ':Predicate, #5: 5	أَعْتَقَ الْأَبُ
u'أَعْتَقَ اِبْنٌ':Subject, #2: 2	أَعْتَقَ ابْنَ
u'أَعْتَقَ أَجْنَبِيٌّ':Subject, #2: 2	أَعْتَقَ ابْنُ
u'أَعْتَقَ أَجْنَبِيٌّ':Subject, #1: 1	أَعْتَقَ أَجْنَبِيٌّ
u'أَعْتَقَ أحَدٌ':Predicate, #2: 2	أَعْتَقَ الْأَجْنَبِيُّ
u'أَعْتَقَ أحَدٌ':Subject, #24: 24	أَعْتَقَ أَحَدَ
u'أَعْتَقَ أحَدٌ':Subject, #1: 1	أَعْتَقَ أَحَدٌ
u'أَعْتَقَ أَخٌ':Subject, #29: 29	أَعْتَقَ أَحَدُ
u'أَعْتَقَ آخِرُ':Subject, #1: 1	أَعْتَقَ الْأَخُ
u'أَعْتَقَ أَرْبَعُ':Predicate, #1: 1	أَعْتَقَ الْآخِرُ
u'أَعْتَقَ أَرْبَعَةٌ':Predicate, #1: 1	أَعْتَقَ أَرْبَعَ
u'أَعْتَقَ أَسْفَلُ':Subject, #1: 1	أَعْتَقَ أَرْبَعَةَ
u'أَعْتَقَ أصل':Subject, #1: 1	أَعْتَقَ الْأَسْفَلُ
u'أَعْتَقَ أًصْلٌ':Subject, #3: 3	أَعْتَقَ الْأَصْلُ
u'أَعْتَقَ أُمٌّ':Predicate, #3: 3	أَعْتَقَ الْأَصْلُ
u'أَعْتَقَ أُمٌّ':Predicate, #18: 18	أَعْتَقَ الْأُمَّ
u'أَعْتَقَ إمَامٌ':Subject, #30: 30	أَعْتَقَ أُمَّ
u'أَعْتَقَ أمَةٌ':Predicate, #1: 1	أَعْتَقَ الْإِمَامُ
u'أَعْتَقَ أَنْصَافٌ':Predicate, #8: 8	أَعْتَقَ الْأَمَةَ
u'أَعْتَقَ أهْلٌ':Predicate, #1: 1	أَعْتَقَ الْأَنْصَافَ
u'أَعْتَقَ أَوَّلُ':Predicate, #2: 2	أَعْتَقَ أَهْلَ
u'أَعْتَقَ أَوَّلُ':Predicate, #1: 1	أَعْتَقَ الْأَوَّلَ
u'أَعْتَقَ أَوَّلُ':Subject, #1: 1	أَعْتَقَ أَوَّلَ
u'أَعْتَقَ أَوْلاَدٌ':Predicate, #1: 1	أَعْتَقَ الْأَوَّلُ
u'أَعْتَقَ باقِي':Predicate, #1: 1	أَعْتَقَ الْأَوْلَادَ
u'أَعْتَقَ بَائِعٌ':Subject, #2: 2	أَعْتَقَ الْبَاقِيَ
u'أَعْتَقَ بَعْضٌ':Predicate, #2: 2	أَعْتَقَ الْبَائِعُ
u'أَعْتَقَ بَعْضٌ':Predicate, #13: 13	أَعْتَقَ بَعْضَ
u'أَعْتَقَ بَعْضٌ':Subject, #1: 1	أَعْتَقَ الْبَعْضَ
u'أَعْتَقَ ثَلاثَةٌ':Predicate, #1: 1	أَعْتَقَ بَعْضُ
u'أَعْتَقَ ثَلاثَةٌ':Predicate, #2: 2	أَعْتَقَ الثَّلَاثَةَ
u'أَعْتَقَ جَارِي':Predicate, #3: 3	أَعْتَقَ ثَلَاثَةَ
u'أَعْتَقَ جَارِي':Predicate, #14: 14	أَعْتَقَ جَارِيَةً
u'أَعْتَقَ جَارِي':Predicate, #2: 2	أَعْتَقَ جَارِيَةَ
u'أَعْتَقَ جَارِيَةٌ':Predicate, #4: 4	أَعْتَقَ الْجَارِيَةَ
u'أَعْتَقَ جَارِيَةٌ':Predicate, #2: 2	أَعْتَقَ جَارِيَةَ
u'أَعْتَقَ جَازٌ':Predicate, #4: 4	أَعْتَقَ الْجَارِيَةَ
u'أَعْتَقَ جَانِي':Predicate, #2: 2	أَعْتَقَ جَازَ
u'أَعْتَقَ جَمَاعَةٌ':Subject, #2: 2	أَعْتَقَ الْجَانِيَةَ
u'أَعْتَقَ جَنِينٌ':Predicate, #1: 1	أَعْتَقَ جَمَاعَةٌ
u'أَعْتَقَ حاضِرٌ':Predicate, #1: 1	أَعْتَقَ جَنِينَ
u'أَعْتَقَ حاضِرٌ':Predicate, #1: 1	أَعْتَقَ الْحَاضِرَةَ
u'أَعْتَقَ حامِلٌ':Predicate, #2: 2	أَعْتَقَ الْحَاضِرَ
u'أَعْتَقَ حِصَّةٌ':Predicate, #1: 1	أَعْتَقَ الْحَامِلَ
u'أَعْتَقَ حَصَلٌ':Predicate, #1: 1	أَعْتَقَ حِصَّةَ
u'أَعْتَقَ حَمْلٌ':Predicate, #1: 1	أَعْتَقَ حَصَلَ
u'أَعْتَقَ حَمْلٌ':Predicate, #1: 1	أَعْتَقَ حَمْلَ
u'أَعْتَقَ خَمْسَةٌ':Predicate, #9: 9	أَعْتَقَ الْحَمْلَ
u'أَعْتَقَ ذِمِّيٌّ':Predicate, #1: 1	أَعْتَقَ خَمْسَةَ
u'أَعْتَقَ ذِمِّيٌّ':Subject, #1: 1	أَعْتَقَ الذِّمِّيَّ
u'أَعْتَقَ رَاهِنٌ':Subject, #3: 3	أَعْتَقَ الذِّمِّيُّ
u'أَعْتَقَ رَبُّ':Subject, #10: 10	أَعْتَقَ الرَّاهِنُ
u'أَعْتَقَ رُبُعٌ':Predicate, #2: 2	أَعْتَقَ رَبُّ
u'أَعْتَقَ رَجُلٌ':Predicate, #1: 1	أَعْتَقَ رُبُعَ
u'أَعْتَقَ رَجُلٌ':Subject, #5: 5	أَعْتَقَ رَجُلاً
u'أَعْتَقَ رَجُلٌ':Subject, #21: 21	أَعْتَقَ الرَّجُلُ
u'أَعْتَقَ رَسُولٌ':Subject, #9: 9	أَعْتَقَ رَجُلٌ
u'أَعْتَقَ رَقيقٌ':Predicate, #2: 2	أَعْتَقَ رَسُولُ
u'أَعْتَقَ رَقيق':Predicate, #3: 3	أَعْتَقَ رَقِيقَ
u'أَعْتَقَ زَوْجٌ':Subject, #3: 3	أَعْتَقَ رَقِيقَ
u'أَعْتَقَ سَاكِتٌ':Subject, #1: 1	أَعْتَقَ الزَّوْجُ
u'أَعْتَقَ سَائِبٌ':Predicate, #2: 2	أَعْتَقَ السَّاكِتُ
u'أَعْتَقَ سِتٌّ':Predicate, #5: 5	أَعْتَقَ سَائِبَةً
u'أَعْتَقَ سِتٌّ':Predicate, #14: 14	أَعْتَقَ سِتَّةَ
u'أَعْتَقَ سَلِيمٌ':Predicate, #1: 1	أَعْتَقَ سِتَّةً
u'أَعْتَقَ سَواءٌ':Subject, #1: 1	أَعْتَقَ السَّلِيمَ
u'أَعْتَقَ سَيِّدٌ':Subject, #1: 1	أَعْتَقَ سَوَاءٌ
u'أَعْتَقَ شَخْصٌ':Subject, #17: 17	أَعْتَقَ السَّيِّدُ
u'أَعْتَقَ شَرِيكٌ':Subject, #2: 2	أَعْتَقَ شَخْصٌ
u'أَعْتَقَ شَرِيكٌ':Subject, #5: 5	أَعْتَقَ الشَّرِيكُ
u'أَعْتَقَ صَادِقٌ':Subject, #9: 9	أَعْتَقَ شَرِيكُهُ
u'أَعْتَقَ صَغِيرٌ':Predicate, #1: 1	أَعْتَقَ صَادِقٌ
u'أَعْتَقَ صَفِيٌّ':Predicate, #1: 1	أَعْتَقَ الصَّغِيرَ
u'أَعْتَقَ ضَمِنٌ':Predicate, #17: 17	أَعْتَقَ صَفِيَّةَ
u'أَعْتَقَ ضَمِيرٌ':Subject, #1: 1	أَعْتَقَ ضَمِنَ
u'أَعْتَقَ عَامِلٌ':Subject, #1: 1	أَعْتَقَ ضَمِيرٌ
u'أَعْتَقَ عَبْدٌ':Predicate, #1: 1	أَعْتَقَ الْعَامِلُ
u'أَعْتَقَ عَبْدٌ':Predicate, #46: 46	أَعْتَقَ الْعَبْدَ
u'أَعْتَقَ عَبْدٌ':Subject, #5: 5	أَعْتَقَ عَبْدَ
u'أَعْتَقَ عَبْدٌ':Subject, #1: 1	أَعْتَقَ عَبْدُهُ
u'أَعْتَقَ عَتِيقٌ':Subject, #5: 5	أَعْتَقَ الْعَبْدُ
u'أَعْتَقَ عند':Predicate, #1: 1	أَعْتَقَ الْعَتِيقُ
u'أَعْتَقَ غَاصِبٌ':Subject, #2: 2	أَعْتَقَ عِنْدَ
u'أَعْتَقَ غَائِبٌ':Predicate, #1: 1	أَعْتَقَ الْغَاصِبُ
u'أَعْتَقَ غُلاَمٌ':Predicate, #1: 1	أَعْتَقَ الْغَائِبَ
u'أَعْتَقَ غير':Predicate, #2: 2	أَعْتَقَ الْغُلَامَ
u'أَعْتَقَ غَيْرٌ':Predicate, #2: 2	أَعْتَقَ غَيْرَ
u'أَعْتَقَ فُلاَنٌ':Subject, #2: 2	أَعْتَقَ غَيْرَ
u'أَعْتَقَ قَالٌ':Predicate, #1: 1	أَعْتَقَ فُلَانٌ
u'أَعْتَقَ قُرَشِيٌّ':Subject, #2: 2	أَعْتَقَ قَالَ
u'أَعْتَقَ قِنٌّ':Subject, #2: 2	أَعْتَقَ الْقُرَشِيُّ
u'أَعْتَقَ قِيمَةٌ':Predicate, #1: 1	أَعْتَقَ الْقِنُّ
u'أَعْتَقَ كَافِرٌ':Predicate, #1: 1	أَعْتَقَ قِيمَةَ
u'أَعْتَقَ كَافِرٌ':Predicate, #1: 1	أَعْتَقَ الْكَافِرَ
u'أَعْتَقَ كَافِرٌ':Predicate, #1: 1	أَعْتَقَ الْكَافِرَةَ
u'أَعْتَقَ كَافِرٌ':Subject, #1: 1	أَعْتَقَ كَافِرَةً
u'أَعْتَقَ كَافِرٌ':Subject, #5: 5	أَعْتَقَ كَافِرٌ
u'أَعْتَقَ مَالِكٌ':Subject, #8: 8	أَعْتَقَ الْكَافِرُ
u'أَعْتَقَ مَالِكٌ':Subject, #1: 1	أَعْتَقَ مَالِكُ
u'أَعْتَقَ مَأْمُورٌ':Subject, #5: 5	أَعْتَقَ الْمَالِكُ
u'أَعْتَقَ مُبَاحٌ':Predicate, #1: 1	أَعْتَقَ الْمَأْمُورُ
u'أَعْتَقَ مَبِيعٌ':Predicate, #1: 1	أَعْتَقَ مُبَاحَ
u'أَعْتَقَ مَحْجُورٌ':Subject, #9: 9	أَعْتَقَ الْمَبِيعَ
u'أَعْتَقَ مُدَبَّرٌ':Predicate, #1: 1	أَعْتَقَ الْمَحْجُورُ
u'أَعْتَقَ مُدَبَّرٌ':Predicate, #1: 1	أَعْتَقَ الْمُدَبَّرَةَ
u'أَعْتَقَ مَدْيُونٌ':Predicate, #4: 4	أَعْتَقَ الْمُدَبَّرَ
u'أَعْتَقَ مُرْتَدٌّ':Subject, #3: 3	أَعْتَقَ الْمَدْيُونَ
u'أَعْتَقَ مَرْهُونٌ':Predicate, #1: 1	أَعْتَقَ الْمُرْتَدُّ
u'أَعْتَقَ مَرِيضٌ':Subject, #3: 3	أَعْتَقَ الْمَرْهُونَ
u'أَعْتَقَ مُسْتَغْرِقٌ':Subject, #6: 6	أَعْتَقَ الْمَرِيضُ
u'أَعْتَقَ مُسْلِمٌ':Subject, #1: 1	أَعْتَقَ مُسْتَغْرِقُ
u'أَعْتَقَ مُسْلِمٌ':Subject, #3: 3	أَعْتَقَ مُسْلِمٌ
u'أَعْتَقَ مُشْتَقٌّ':Subject, #5: 5	أَعْتَقَ الْمُسْلِمُ
u'أَعْتَقَ مُصَدِّقٌ':Subject, #1: 1	أَعْتَقَ مُشْتَقٌّ
u'أَعْتَقَ مُضَارِبٌ':Subject, #1: 1	أَعْتَقَ الْمُصَدِّقُ
u'أَعْتَقَ مُعْتَقٌ':Subject, #4: 4	أَعْتَقَ الْمُضَارِبُ
u'أَعْتَقَ مُعْسِرٌ':Subject, #1: 1	أَعْتَقَ الْمُعْتَقُ
u'أَعْتَقَ مُعَلِّقٌ':Subject, #3: 3	أَعْتَقَ مُعْسِرٌ
u'أَعْتَقَ مَغْصُوب':Predicate, #1: 1	أَعْتَقَ الْمُعَلِّقُ
u'أَعْتَقَ مُكَاتَبَةٌ':Predicate, #1: 1	أَعْتَقَ الْمَغْصُوبَ
u'أَعْتَقَ مِلْكٌ':Predicate, #1: 1	أَعْتَقَ الْمُكَاتَبَةَ
u'أَعْتَقَ مَلِيٌّ':Subject, #6: 6	أَعْتَقَ مِلْكَ
u'أَعْتَقَ مَلِيءٌ':Subject, #1: 1	أَعْتَقَ الْمَلِيُّ
u'أَعْتَقَ مَنْذُور':Predicate, #2: 2	أَعْتَقَ الْمَلِيءُ
u'أَعْتَقَ مُوسِرٌ':Subject, #1: 1	أَعْتَقَ الْمَنْذُورَ
u'أَعْتَقَ مُوسِرٌ':Subject, #2: 2	أَعْتَقَ الْمُوسِرُ
u'أَعْتَقَ مُوَكِّلٌ':Subject, #4: 4	أَعْتَقَ مُوسِرٌ
u'أَعْتَقَ نَاقِصٌ':Predicate, #1: 1	أَعْتَقَ الْمُوَكِّلُ
u'أَعْتَقَ نَحْوٌ':Predicate, #1: 1	أَعْتَقَ نَاقِصَ
u'أَعْتَقَ نسمة':Predicate, #1: 1	أَعْتَقَ نَحْوَ
u'أَعْتَقَ نَسَمَةٌ':Predicate, #1: 1	أَعْتَقَ نَسَمَةَ
u'أَعْتَقَ نَصْرَانِيٌّ':Subject, #1: 1	أَعْتَقَ نَسَمَةَ
u'أَعْتَقَ نِصْفٌ':Predicate, #1: 1	أَعْتَقَ نَصْرَانِيٌّ
u'أَعْتَقَ نِصْفٌ':Predicate, #33: 33	أَعْتَقَ نِصْفَ
u'أَعْتَقَ نَصِيبٌ':Predicate, #6: 6	أَعْتَقَ النِّصْفَ
u'أَعْتَقَ واحد':Predicate, #3: 3	أَعْتَقَ نَصِيبَ
u'أَعْتَقَ وَاحِدٌ':Predicate, #4: 4	أَعْتَقَ وَاحِدَةً
u'أَعْتَقَ واحد':Subject, #4: 4	أَعْتَقَ وَاحِدَةً
u'أَعْتَقَ وَاحِدٌ':Subject, #2: 2	أَعْتَقَ وَاحِدٌ
u'أَعْتَقَ وَارِثٌ':Subject, #2: 2	أَعْتَقَ وَاحِدٌ
u'أَعْتَقَ وَارِثٌ':Subject, #1: 1	أَعْتَقَ وَارِثٌ
u'أَعْتَقَ وَاهِبٌ':Subject, #4: 4	أَعْتَقَ الْوَارِثُ
u'أَعْتَقَ وَرَثَةٌ':Subject, #2: 2	أَعْتَقَ الْوَاهِبُ
u'أَعْتَقَ وَكِيلٌ':Subject, #1: 1	أَعْتَقَ الْوَرَثَةُ
u'أَعْتَقَ ولد':Predicate, #1: 1	أَعْتَقَ الْوَكِيلُ
u'أَعْتَقَ وَلَدٌ':Predicate, #1: 1	أَعْتَقَ وَلَدَ
u'أَعْتَقَ ولد':Predicate, #1: 1	أَعْتَقَ وَلَدَ
u'أَعْتَقَ وَلَدٌ':Predicate, #9: 9	أَعْتَقَ الْوَلَدَ
u'أَعْتَقَ وَلِيٌّ':Subject, #9: 9	أَعْتَقَ الْوَلَدَ
u'أَعْجَبَ إمَامٌ':Predicate, #1: 1	أَعْتَقَ الْوَلِيُّ
u'أَعْجَبَ رَسُولٌ':Predicate, #1: 1	أَعْجَبَ الْإِمَامَ
u'أَعْجَبَ كُفَّارٌ':Predicate, #1: 1	أَعْجَبَ رَسُولَ
u'أَعْجَبَ نَبِيٌّ':Predicate, #1: 1	أَعْجَبَ الْكُفَّارَ
u'أَعْجَمَ كِتَابٌ':Subject, #1: 1	أَعْجَبَ النَّبِيَّ
u'أَعَدَّ أحَدٌ':Subject, #1: 1	أَعْجَمَ الْكِتَابُ
u'أعداد أَضْلاَعٌ':Added, #1: 1	أَعَدَّ أَحَدٌ
u'أَعْدَادٌ أَضْلاَعٌ':Added, #1: 1	أَعْدَادِ أَضْلَاعِهِ
u'أعداد بُيُوتٌ':Added, #1: 1	أَعْدَادِ أَضْلَاعِهِ
u'أَعْدَادٌ بُيُوتٌ':Added, #1: 1	أَعْدَادِ بُيُوتِ
u'أعداد تَسْبِيحٌ':Added, #1: 1	أَعْدَادِ بُيُوتِ
u'أَعْدَادٌ تَسْبِيحٌ':Added, #1: 1	أَعْدَادِ التَّسْبِيحَاتِ
u'أعداد تَسْبِيحَةٌ':Added, #1: 1	أَعْدَادِ التَّسْبِيحَاتِ
u'أَعْدَادٌ تَسْبِيحَةٌ':Added, #1: 1	أَعْدَادِ التَّسْبِيحَاتِ
u'أعداد جِلْدٌ':Added, #1: 1	أَعْدَادِ التَّسْبِيحَاتِ
u'أَعْدَادٌ جِلْدٌ':Added, #1: 1	أَعْدَادِ جِلْدٍ
u'أعداد جَوَاهِرُ':Added, #1: 1	أَعْدَادِ جِلْدٍ
u'أَعْدَادٌ جَوَاهِرُ':Added, #1: 1	أَعْدَادِ الْجَوَاهِرِ
u'أعداد طَلاَقٌ':Added, #1: 1	أَعْدَادِ الْجَوَاهِرِ
u'أَعْدَادٌ طَلاَقٌ':Added, #1: 1	أَعْدَادِ الطَّلَاقِ
u'أعداد مَجْمُوعٌ':Added, #1: 1	أَعْدَادِ الطَّلَاقِ
u'أَعْدَادٌ مَجْمُوعٌ':Added, #1: 1	أَعْدَادُ الْمَجْمُوعِ
u'أعداد مَسَائِلُ':Added, #1: 1	أَعْدَادُ الْمَجْمُوعِ
u'أَعْدَادٌ مَسَائِلُ':Added, #1: 1	أَعْدَادِ الْمَسَائِلِ
u'أعداد مَعْلُومٌ':Added, #1: 1	أَعْدَادِ الْمَسَائِلِ
u'أَعْدَادٌ مَعْلُومٌ':Added, #1: 1	أَعْدَادِ الْمَعْلُومِ
u'أعداد مِيَاهٌ':Added, #1: 1	أَعْدَادِ الْمَعْلُومِ
u'أَعْدَادٌ مِيَاهٌ':Added, #1: 1	أَعْدَادَ مِيَاهِ
u'أَعَدَّ دَارٌ':Predicate, #1: 1	أَعْدَادَ مِيَاهِ
u'أَعَدَّ رَسُولٌ':Subject, #1: 1	أَعَدَّ الدَّارَ
u'أَعْدَمَ أصل':Predicate, #1: 1	أَعَدَّ رَسُولُ
u'أَعْدَمَ أًصْلٌ':Predicate, #1: 1	أَعْدَمَ أَصْلَ
u'أَعْدَمَ غَرِيمٌ':Subject, #1: 1	أَعْدَمَ أَصْلَ
u'أَعْدَمَ قَالٌ':Predicate, #1: 1	أَعْدَمَ الْغَرِيمُ
u'أَعْدَمَ وَاطِئٌ':Subject, #1: 1	أَعْدَمَ قَالَ
u'أَعْذَرَ رَجُلٌ':Subject, #1: 1	أَعْدَمَ الْوَاطِئُ
u'أَعْذَرَ نَبِيٌّ':Subject, #1: 1	أَعْذَرَ الرَّجُلُ
u'أَعْرَاضٌ خَيْلٌ':Added, #1: 1	أَعْذَرَ نَبِيُّ
u'إعْرَاضٌ سَيِّدٌ':Added, #1: 1	أَعْرَاضِ الْخَيْلِ
u'إعْرَاضٌ صَاحِبٌ':Added, #2: 2	إعْرَاضُ السَّيِّدِ
u'إعْرَاضٌ مَالِكٌ':Added, #1: 1	إعْرَاضُ صَاحِبِهِ
u'أَعْرَاضٌ مَسْجِدٌ':Added, #1: 1	إعْرَاضُ الْمَالِكِ
u'إعْرَاضٌ مُفْلِسٌ':Added, #1: 1	أَعْرَاضِ الْمَسْجِدِ
u'أَعْرَاضٌ نَاسٌ':Added, #1: 1	إعْرَاضُ مُفْلِسٍ
u'أَعْرَاضٌ نَاسٌ':Added, #1: 1	أَعْرَاضَ النَّاسِ
u'إعْرَاضٌ وَرَثَةٌ':Added, #3: 3	أَعْرَاضِ النَّاسِ
u'أَعْرَبَ هاء':Predicate, #1: 1	إعْرَاضِ الْوَرَثَةِ
u'أَعْرَجَ شَدِيدٌ':Predicate, #1: 1	أَعْرَبَ الْهَاءَ
u'أَعْرَضَ بَائِعٌ':Subject, #2: 2	أَعْرَجَ شَدِيدَ
u'أَعْرَضَ بَطَلٌ':Predicate, #2: 2	أَعْرَضَ الْبَائِعُ
u'أَعْرَضَ جُمْهُورٌ':Subject, #1: 1	أَعْرَضَ بَطَلَ
u'أَعْرَضَ حاكِمٌ':Subject, #1: 1	أَعْرَضَ الْجُمْهُورُ
u'أَعْرَضَ حَنَفِيَّةٌ':Subject, #3: 3	أَعْرَضَ الْحَاكِمُ
u'أَعْرَضَ رَاهِنٌ':Subject, #1: 1	أَعْرَضَ الْحَنَفِيَّةُ
u'أَعْرَضَ زَوْجٌ':Subject, #2: 2	أَعْرَضَ الرَّاهِنُ
u'أَعْرَضَ مُصَنِّفٌ':Subject, #1: 1	أَعْرَضَ الزَّوْجُ
u'أَعْرَضَ نَبِيٌّ':Subject, #1: 1	أَعْرَضَ الْمُصَنِّفُ
u'أَعْرَضَ وَارِثٌ':Subject, #3: 3	أَعْرَضَ النَّبِيُّ
u'إعْزَازٌ إِسْلامٌ':Added, #3: 3	أَعْرَضَ الْوَارِثُ
u'إعْزَازٌ إِسْلامٌ':Added, #1: 1	إعْزَازَ الْإِسْلَامِ
u'إعْزَازٌ دِينٌ':Added, #2: 2	إعْزَازِ الْإِسْلَامِ
u'إعْزَازٌ دَيْنٌ':Added, #1: 1	إعْزَازَ الدِّينِ
u'إعْزَازٌ دِينٌ':Added, #1: 1	إعْزَازَ الدَّيْنِ
u'إعْزَازٌ دِينٌ':Added, #3: 3	إعْزَازُ دِينِ
u'إعْزَازٌ دِينٌ':Added, #4: 4	إعْزَازُ الدِّينِ
u'أَعَزَّ إِسْلامٌ':Predicate, #5: 5	إعْزَازِ الدِّينِ
u'أَعَزَّ إِسْلامٌ':Predicate, #1: 1	أَعَزَّ الإِسْلاَمَ
u'أَعَزَّ دَرَاهِمُ':Predicate, #4: 4	أَعَزَّ الْإِسْلَامَ
u'أَعَزَّ عَدُوٌّ':Predicate, #1: 1	أَعَزَّ الدَّرَاهِمَ
u'أَعَزَّ علم':Predicate, #1: 1	أَعَزَّ عَدُوَّ
u'أَعَزَّ عِلْمٌ':Predicate, #1: 1	أَعَزَّ الْعِلْمَ
u'أَعَزَّ عند':Predicate, #1: 1	أَعَزَّ الْعِلْمَ
u'أَعْسَرَ أقْرَبُ':Subject, #1: 1	أَعَزَّ عِنْدَ
u'أَعْسَرَ أَيْسَرُ':Predicate, #1: 1	أَعْسَرَ الْأَقْرَبُ
u'أَعْسَرَ بَائِعٌ':Subject, #1: 1	أَعْسَرَ أَيْسَرَ
u'أَعْسَرَ بِيَعٌ':Predicate, #1: 1	أَعْسَرَ الْبَائِعُ
u'أَعْسَرَ جَازٌ':Predicate, #1: 1	أَعْسَرَ بِيعَ
u'أَعْسَرَ رَاهِنٌ':Subject, #1: 1	أَعْسَرَ جَازَ
u'أَعْسَرَ زَوْجٌ':Subject, #2: 2	أَعْسَرَ الرَّاهِنُ
u'أَعْسَرَ زَوْجٌ':Subject, #2: 2	أَعْسَرَ زَوْجُ
u'أَعْسَرَ مُعْسِرٌ':Subject, #5: 5	أَعْسَرَ الزَّوْجُ
u'أَعْسَرَ مُوسِرٌ':Subject, #1: 1	أَعْسَرَ الْمُعْسِرُ
u'أَعْسَرَ مُوسِرٌ':Subject, #1: 1	أَعْسَرَ الْمُوسِرُ
u'أَعْسَرَ نَفَقَةٌ':Predicate, #1: 1	أَعْسَرَ مُوسِرٌ
u'أعْشَارٌ أَمْوَالٌ':Added, #1: 1	أَعْسَرَ نَفَقَةَ
u'أَعْشَارٌ أَمْوَالٌ':Added, #1: 1	أَعْشَارُ الْأَمْوَالِ
u'أعْشَارٌ بصرة':Added, #1: 1	أَعْشَارُ الْأَمْوَالِ
u'أَعْشَارٌ بصرة':Added, #1: 1	أَعْشَارَ الْبَصْرَةِ
u'أعْشَارٌ ثِمارٌ':Added, #1: 1	أَعْشَارَ الْبَصْرَةِ
u'أَعْشَارٌ ثِمارٌ':Added, #1: 1	أَعْشَارِ الثِّمَارِ
u'أعْشَارٌ ثَمَنٌ':Added, #1: 1	أَعْشَارِ الثِّمَارِ
u'أَعْشَارٌ ثَمَنٌ':Added, #4: 4	أَعْشَارِ الثَّمَنِ
u'أعْشَارٌ حَبٌّ':Added, #4: 4	أَعْشَارِ الثَّمَنِ
u'أَعْشَارٌ حَبٌّ':Added, #3: 3	أَعْشَارِ حَبَّةٍ
u'أعْشَارٌ حَبَّةٌ':Added, #3: 3	أَعْشَارِ حَبَّةٍ
u'أَعْشَارٌ حَبَّةٌ':Added, #3: 3	أَعْشَارِ حَبَّةٍ
u'أعْشَارٌ حَلالٌ':Added, #3: 3	أَعْشَارِ حَبَّةٍ
u'أَعْشَارٌ حَلالٌ':Added, #1: 1	أَعْشَارِ الْحَلَالِ
u'أعْشَارٌ دِرْهَمٌ':Added, #1: 1	أَعْشَارِ الْحَلَالِ
u'أعْشَارٌ دِرْهَم':Added, #2: 2	أَعْشَارِ دِرْهَمٍ
u'أَعْشَارٌ دِرْهَمٌ':Added, #2: 2	أَعْشَارِ دِرْهَمٍ
u'أَعْشَارٌ دِرْهَم':Added, #2: 2	أَعْشَارِ دِرْهَمٍ
u'أعْشَارٌ دِيَةٌ':Added, #2: 2	أَعْشَارِ دِرْهَمٍ
u'أَعْشَارٌ دِيَةٌ':Added, #5: 5	أَعْشَارِ الدِّيَةِ
u'أعْشَارٌ دِينارٌ':Added, #5: 5	أَعْشَارِ الدِّيَةِ
u'أَعْشَارٌ دِينارٌ':Added, #1: 1	أَعْشَارِ الدِّينَارِ
u'أعْشَارٌ رِبْحٌ':Added, #1: 1	أَعْشَارِ الدِّينَارِ
u'أَعْشَارٌ رِبْحٌ':Added, #1: 1	أَعْشَارِ الرِّبْحِ
u'أعْشَارٌ رِزْقٌ':Added, #1: 1	أَعْشَارِ الرِّبْحِ
u'أَعْشَارٌ رِزْقٌ':Added, #2: 2	أَعْشَارِ الرِّزْقِ
u'أعْشَارٌ صَفْقَةٌ':Added, #2: 2	أَعْشَارِ الرِّزْقِ
u'أَعْشَارٌ صَفْقَةٌ':Added, #1: 1	أَعْشَارِ الصَّفْقَةِ
u'أعْشَارٌ علم':Added, #1: 1	أَعْشَارِ الصَّفْقَةِ
u'أَعْشَارٌ علم':Added, #5: 5	أَعْشَارِ الْعِلْمِ
u'أعْشَارٌ عِلْمٌ':Added, #5: 5	أَعْشَارِ الْعِلْمِ
u'أَعْشَارٌ عِلْمٌ':Added, #5: 5	أَعْشَارِ الْعِلْمِ
u'أعْشَارٌ قلب':Added, #5: 5	أَعْشَارِ الْعِلْمِ
u'أَعْشَارٌ قلب':Added, #2: 2	أَعْشَارِ الْقَلْبِ
u'أعْشَارٌ قَلْبٌ':Added, #2: 2	أَعْشَارِ الْقَلْبِ
u'أعْشَارٌ قَلْب':Added, #2: 2	أَعْشَارِ الْقَلْبِ
u'أَعْشَارٌ قَلْبٌ':Added, #2: 2	أَعْشَارِ الْقَلْبِ
u'أَعْشَارٌ قَلْب':Added, #2: 2	أَعْشَارِ الْقَلْبِ
u'أعْشَارٌ قِيمَةٌ':Added, #2: 2	أَعْشَارِ الْقَلْبِ
u'أَعْشَارٌ قِيمَةٌ':Added, #1: 1	أَعْشَارِ الْقِيمَةِ
u'أعْشَارٌ مَالٌ':Added, #1: 1	أَعْشَارِ الْقِيمَةِ
u'أَعْشَارٌ مَالٌ':Added, #1: 1	أَعْشَارِ الْمَالِ
u'أعْشَارٌ نِصْفٌ':Added, #1: 1	أَعْشَارِ الْمَالِ
u'أَعْشَارٌ نِصْفٌ':Added, #4: 4	أَعْشَارِ نِصْفِ
u'أَعْشَبَ مَكَانٌ':Subject, #4: 4	أَعْشَارِ نِصْفِ
u'إعْطَاءٌ اِبْنٌ':Added, #1: 1	أَعْشَبَ الْمَكَانُ
u'إعْطَاءٌ أُجْرَةٌ':Added, #1: 1	إعْطَاءُ ابْنِهِ
u'إعْطَاءٌ أُجْرَةٌ':Added, #1: 1	إعْطَاءُ أُجْرَةِ
u'إعْطَاءٌ أَحْكَامٌ':Added, #1: 1	إعْطَاءُ الْأُجْرَةِ
u'إعْطَاءٌ أَحْكَامٌ':Added, #1: 1	إعْطَاءِ أَحْكَامِ
u'إعْطَاءٌ أَخٌ':Added, #1: 1	إعْطَاءِ الْأَحْكَامِ
u'إعْطَاءٌ أرْضٌ':Added, #1: 1	إعْطَاءِ الْأَخِ
u'إعْطَاءٌ أصل':Added, #1: 1	إعْطَاءُ أَرْضٍ
u'إعْطَاءٌ أًصْلٌ':Added, #1: 1	إعْطَاءُ أَصْلِهِ
u'إعْطَاءٌ أصل':Added, #1: 1	إعْطَاءُ أَصْلِهِ
u'إعْطَاءٌ أًصْلٌ':Added, #1: 1	إعْطَاءُ الْأَصْلِ
u'إعْطَاءٌ آلاَفٌ':Added, #1: 1	إعْطَاءُ الْأَصْلِ
u'إعْطَاءٌ ألْفٌ':Added, #1: 1	إعْطَاءِ آلَافٍ
u'إعْطَاءٌ أَلْفٌ':Added, #1: 1	إعْطَاءِ أَلْفٍ
u'إعْطَاءٌ ألف':Added, #1: 1	إعْطَاءِ أَلْفٍ
u'إعْطَاءٌ ألْفٌ':Added, #3: 3	إعْطَاءُ الْأَلْفِ
u'إعْطَاءٌ أَلْفٌ':Added, #3: 3	إعْطَاءُ الْأَلْفِ
u'إعْطَاءٌ إمَامٌ':Added, #3: 3	إعْطَاءُ الْأَلْفِ
u'إعْطَاءٌ إمَامٌ':Added, #1: 1	إعْطَاءُ الْإِمَامِ
u'إعْطَاءٌ إمَامٌ':Added, #1: 1	إعْطَاءِ الْإِمَامِ
u'إعْطَاءٌ أمَانٌ':Added, #2: 2	إعْطَاءَ الْإِمَامِ
u'إعْطَاءٌ أمَانٌ':Added, #1: 1	إعْطَاءَ الْأَمَانِ
u'إعْطَاءٌ أَمْدَادٌ':Added, #2: 2	إعْطَاءِ الْأَمَانِ
u'إعْطَاءٌ إِنْسَاءٌ':Added, #1: 1	إعْطَاءِ الْأَمْدَادِ
u'إعْطَاءٌ أهْلٌ':Added, #1: 1	إعْطَاءُ الْإِنْسَاءِ
u'إعْطَاءٌ أَوَّلُ':Added, #1: 1	إعْطَاءُ أَهْلِ
u'إعْطَاءٌ بِضاعَةٌ':Added, #2: 2	إعْطَاءُ الْأَوَّلِ
u'إعْطَاءٌ بَعْضٌ':Added, #1: 1	إعْطَاءِ الْبِضَاعَةِ
u'إعْطَاءٌ بَعْضٌ':Added, #1: 1	إعْطَاءُ الْبَعْضِ
u'إعْطَاءٌ بَعْضٌ':Added, #1: 1	إعْطَاءِ الْبَعْضِ
u'إعْطَاءٌ بَعْضٌ':Added, #1: 1	إعْطَاءُ بَعْضِهِ
u'إعْطَاءٌ بَعْضٌ':Added, #3: 3	إعْطَاءُ بَعْضِ
u'إعْطَاءٌ بَقَّالٌ':Added, #3: 3	إعْطَاءِ بَعْضِ
u'إعْطَاءٌ بَقِيَّةٌ':Added, #1: 1	إعْطَاءِ الْبَقَّالِ
u'إعْطَاءٌ تَسْمِيَة':Added, #1: 1	إعْطَاءِ بَقِيَّةِ
u'إعْطَاءٌ ثَالِثٌ':Added, #1: 1	إعْطَاءِ التَّسْمِيَةِ
u'إعْطَاءٌ ثَلاثَةٌ':Added, #1: 1	إعْطَاءَ الثَّالِثِ
u'إعْطَاءٌ ثَلاثَةٌ':Added, #1: 1	إعْطَاءِ الثَّلَاثَةِ
u'إعْطَاءٌ ثَلاثَةٌ':Added, #1: 1	إعْطَاءُ ثَلَاثَةٍ
u'إعْطَاءٌ ثَمَنٌ':Added, #1: 1	إعْطَاءِ ثَلَاثَةٍ
u'إعْطَاءٌ ثَوْبٌ':Added, #3: 3	إعْطَاءُ الثَّمَنِ
u'إعْطَاءٌ جَارِي':Added, #1: 1	إعْطَاءِ الثَّوْبِ
u'إعْطَاءٌ جَارِيَةٌ':Added, #1: 1	إعْطَاءِ الْجَارِيَةِ
u'إعْطَاءٌ جِزْيَةٌ':Added, #1: 1	إعْطَاءِ الْجَارِيَةِ
u'إعْطَاءٌ جِزْيَةٌ':Added, #1: 1	إعْطَاءِ الْجِزْيَةِ
u'إعْطَاءٌ جِزْيَةٌ':Added, #2: 2	إعْطَاءُ الْجِزْيَةِ
u'إعْطَاءٌ جُمْلَةٌ':Added, #3: 3	إعْطَاءَ الْجِزْيَةِ
u'إعْطَاءٌ جَمِيع':Added, #1: 1	إعْطَاءَ جُمْلَةِ
u'إعْطَاءٌ حَقٌّ':Added, #1: 1	إعْطَاءُ الْجَمِيعِ
u'إعْطَاءٌ حَقٌّ':Added, #1: 1	إعْطَاءَ الْحَقِّ
u'إعْطَاءٌ حَقٌّ':Added, #1: 1	إعْطَاءِ الْحَقِّ
u'إعْطَاءٌ حُكْمٌ':Added, #1: 1	إعْطَاءَ حَقِّ
u'إعْطَاءٌ حَلالٌ':Added, #2: 2	إعْطَاءُ الْحُكْمِ
u'إعْطَاءٌ حَيَاةٌ':Added, #1: 1	إعْطَاءَ الْحَلَالِ
u'إعْطَاءٌ خَادِمٌ':Added, #1: 1	إعْطَاءُ الْحَيَاةِ
u'إعْطَاءٌ خَمْسٌ':Added, #1: 1	إعْطَاءُ خَادِمٍ
u'إعْطَاءٌ دَرَاهِمُ':Added, #1: 1	إعْطَاءِ الْخَمْسِ
u'إعْطَاءٌ دِرْهَمٌ':Added, #3: 3	إعْطَاءِ الدَّرَاهِمِ
u'إعْطَاءٌ دِرْهَم':Added, #2: 2	إعْطَاءُ الدِّرْهَمِ
u'إعْطَاءٌ دَنانيرُ':Added, #2: 2	إعْطَاءُ الدِّرْهَمِ
u'إعْطَاءٌ دَنِيٌّ':Added, #2: 2	إعْطَاءِ الدَّنَانِيرِ
u'إعْطَاءٌ دِيَةٌ':Added, #3: 3	إعْطَاءِ الدَّنِيَّةِ
u'إعْطَاءٌ دِينارٌ':Added, #1: 1	إعْطَاءَ الدِّيَةِ
u'إعْطَاءٌ ذَرارِيٌّ':Added, #1: 1	إعْطَاءَ الدِّينَارِ
u'إعْطَاءٌ ذِمَّةٌ':Added, #2: 2	إعْطَاءِ الذَّرَارِيِّ
u'إعْطَاءٌ ذَهَبٌ':Added, #1: 1	إعْطَاءُ الذِّمَّةِ
u'إعْطَاءٌ رُبُعٌ':Added, #2: 2	إعْطَاءِ الذَّهَبِ
u'إعْطَاءٌ رَجُلٌ':Added, #1: 1	إعْطَاءِ رُبُعِ
u'إعْطَاءٌ رَسُولٌ':Added, #2: 2	إعْطَاءُ الرَّجُلِ
u'إعْطَاءٌ زَكاةٌ':Added, #2: 2	إعْطَاءُ رَسُولِ
u'إعْطَاءٌ زَكاةٌ':Added, #2: 2	إعْطَاءُ الزَّكَاةِ
u'إعْطَاءٌ زَوْجَةٌ':Added, #3: 3	إعْطَاءِ الزَّكَاةِ
u'إعْطَاءٌ زَوْجَةٌ':Added, #1: 1	إعْطَاءُ الزَّوْجَةِ
u'إعْطَاءٌ زِيادَةٌ':Added, #1: 1	إعْطَاءُ زَوْجَةٍ
u'إعْطَاءٌ زُيوفٌ':Added, #2: 2	إعْطَاءِ الزِّيَادَةِ
u'إعْطَاءٌ زُيُوفٌ':Added, #1: 1	إعْطَاءُ الزُّيُوفِ
u'إعْطَاءٌ سائِل':Added, #1: 1	إعْطَاءُ الزُّيُوفِ
u'إعْطَاءٌ سَائِلٌ':Added, #1: 1	إعْطَاءِ السَّائِلِ
u'إعْطَاءٌ سِلاَحٌ':Added, #1: 1	إعْطَاءِ السَّائِلِ
u'إعْطَاءٌ سَلَبٌ':Added, #2: 2	إعْطَاءَ سِلَاحٍ
u'إعْطَاءٌ سُؤَالٌ':Added, #2: 2	إعْطَاءِ السَّلَبِ
u'إعْطَاءٌ شَيْءٌ':Added, #1: 1	إعْطَاءُ سُؤَالِ
u'إعْطَاءٌ شَيْءٌ':Added, #2: 2	إعْطَاءُ الشَّيْءِ
u'إعْطَاءٌ شَيْءٌ':Added, #2: 2	إعْطَاءُ شَيْءٍ
u'إعْطَاءٌ صداق':Added, #2: 2	إعْطَاءِ شَيْءٍ
u'إعْطَاءٌ صَدَاقٌ':Added, #1: 1	إعْطَاءِ الصَّدَاقِ
u'إعْطَاءٌ صَغِيرٌ':Added, #1: 1	إعْطَاءِ الصَّدَاقِ
u'إعْطَاءٌ صِنْفٌ':Added, #1: 1	إعْطَاءِ الصَّغِيرِ
u'إعْطَاءٌ ضَابِطٌ':Added, #1: 1	إعْطَاءُ الصِّنْفِ
u'إعْطَاءٌ طعام':Added, #1: 1	إعْطَاءِ ضَابِطٍ
u'إعْطَاءٌ طَعَامٌ':Added, #1: 1	إعْطَاءُ طَعَامٍ
u'إعْطَاءٌ عَامِلٌ':Added, #1: 1	إعْطَاءُ طَعَامٍ
u'إعْطَاءٌ عَقِبٌ':Added, #1: 1	إعْطَاءُ الْعَامِلِ
u'إعْطَاءٌ عَقْلٌ':Added, #1: 1	إعْطَاءِ عَقِبِهِ
u'إعْطَاءٌ عُودٌ':Added, #1: 1	إعْطَاءُ الْعَقْلِ
u'إعْطَاءٌ غِذَاءٌ':Added, #1: 1	إعْطَاءُ عُودٍ
u'إعْطَاءٌ غَلَّةٌ':Added, #1: 1	إعْطَاءُ الْغِذَاءِ
u'إعْطَاءٌ غَلَّةٌ':Added, #1: 1	إعْطَاءُ الْغَلَّةِ
u'إعْطَاءٌ غير':Added, #1: 1	إعْطَاءِ الْغَلَّةِ
u'إعْطَاءٌ غَيْرٌ':Added, #1: 1	إعْطَاءِ الْغَيْرِ
u'إعْطَاءٌ غير':Added, #1: 1	إعْطَاءِ الْغَيْرِ
u'إعْطَاءٌ غَيْرٌ':Added, #1: 1	إعْطَاءِ غَيْرِهِ
u'إعْطَاءٌ فَاجِرٌ':Added, #1: 1	إعْطَاءِ غَيْرِهِ
u'إعْطَاءٌ فَرَسٌ':Added, #1: 1	إعْطَاءُ الْفَاجِرِ
u'إعْطَاءٌ فُرُوعٌ':Added, #1: 1	إعْطَاءِ الْفَرَسِ
u'إعْطَاءٌ فقراء':Added, #1: 1	إعْطَاءُ الْفُرُوعِ
u'إعْطَاءٌ فَقِيرٌ':Added, #1: 1	إعْطَاءِ الْفُقَرَاءِ
u'إعْطَاءٌ فَقِيرٌ':Added, #1: 1	إعْطَاءَ الْفَقِيرِ
u'إعْطَاءٌ فَقِيرٌ':Added, #1: 1	إعْطَاءُ الْفَقِيرِ
u'إعْطَاءٌ فُلاَنٌ':Added, #1: 1	إعْطَاءِ الْفَقِيرِ
u'إعْطَاءٌ فلان':Added, #1: 1	إعْطَاءَ فُلَانٍ
u'إعْطَاءٌ فَلْسٌ':Added, #3: 3	إعْطَاءِ الْجُبْرَانِ
u'إعْطَاءٌ قَابِلٌ':Added, #1: 1	إعْطَاءِ فَلْسٍ
u'إعْطَاءٌ قَاتِلٌ':Added, #1: 1	إعْطَاءِ الْقَابِلَةِ
u'إعْطَاءٌ قَلِيلٌ':Added, #1: 1	إعْطَاءِ الْقَاتِلِ
u'إعْطَاءٌ قَمِيصٌ':Added, #2: 2	إعْطَاءُ الْقَلِيلِ
u'إعْطَاءٌ قِيمَةٌ':Added, #1: 1	إعْطَاءِ الْقَمِيصِ
u'إعْطَاءٌ قِيمَةٌ':Added, #1: 1	إعْطَاءِ الْقِيمَةِ
u'إعْطَاءٌ قِيمَةٌ':Added, #1: 1	إعْطَاءِ قِيمَةِ
u'إعْطَاءٌ كَفِيلٌ':Added, #1: 1	إعْطَاءِ قِيمَتِهِ
u'إعْطَاءٌ كَفِيلٌ':Added, #17: 17	إعْطَاءِ الْكَفِيلِ
u'إعْطَاءٌ كَفِيلٌ':Added, #2: 2	إعْطَاءَ الْكَفِيلِ
u'إعْطَاءٌ لَحْمٌ':Added, #2: 2	إعْطَاءُ الْكَفِيلِ
u'إعْطَاءٌ مَاءٌ':Added, #1: 1	إعْطَاءِ اللَّحْمِ
u'إعْطَاءٌ مَاشِي':Added, #1: 1	إعْطَاءَ الْمَاءِ
u'إعْطَاءٌ مَاشِيَةٌ':Added, #1: 1	إعْطَاءِ مَاشِيَةٍ
u'إعْطَاءٌ مَالٌ':Added, #1: 1	إعْطَاءِ مَاشِيَةٍ
u'إعْطَاءٌ مَالٌ':Added, #1: 1	إعْطَاءَ الْمَالِ
u'إعْطَاءٌ مَالٌ':Added, #1: 1	إعْطَاءُ مَالٍ
u'إعْطَاءٌ مَالٌ':Added, #1: 1	إعْطَاءِ مَالِهِ
u'إعْطَاءٌ مَالٌ':Added, #2: 2	إعْطَاءُ الْمَالِ
u'إعْطَاءٌ مَالٌ':Added, #2: 2	إعْطَاءِ مَالٍ
u'إعْطَاءٌ مَالِكٌ':Added, #6: 6	إعْطَاءِ الْمَالِ
u'إعْطَاءٌ مَالِكٌ':Added, #1: 1	إعْطَاءِ الْمَالِكِ
u'إعْطَاءٌ مُتَّصِلٌ':Added, #1: 1	إعْطَاءِ مَالِكِهِ
u'إعْطَاءٌ مثل':Added, #1: 1	إعْطَاءِ الْمُتَّصِلِ
u'إعْطَاءٌ مِثْلٌ':Added, #1: 1	إعْطَاءِ الْمِثْلِ
u'إعْطَاءٌ مثل':Added, #1: 1	إعْطَاءِ الْمِثْلِ
u'إعْطَاءٌ مِثْلٌ':Added, #1: 1	إعْطَاءُ مِثْلِ
u'إعْطَاءٌ مَحْرُومٌ':Added, #1: 1	إعْطَاءُ مِثْلِ
u'إعْطَاءٌ مُدٌّ':Added, #1: 1	إعْطَاءِ مَحْرُومٍ
u'إعْطَاءٌ مساكين':Added, #1: 1	إعْطَاءُ الْمُدِّ
u'إعْطَاءٌ مَسْأَلَةٌ':Added, #1: 1	إعْطَاءُ الْمَسَاكِينِ
u'إعْطَاءٌ مِسْكِينٌ':Added, #2: 2	إعْطَاءِ الْمَسْأَلَةِ
u'إعْطَاءٌ مُسْلِمٌ':Added, #1: 1	إعْطَاءَ الْمِسْكِينِ
u'إعْطَاءٌ مُشَبَّهٌ':Added, #1: 1	إعْطَاءُ مُسْلِمٍ
u'إعْطَاءٌ مَطْلُوبٌ':Added, #1: 1	إعْطَاءُ الْمُشَبَّهِ
u'إعْطَاءٌ مُقَاتِلٌ':Added, #1: 1	إعْطَاءِ الْمَطْلُوبِ
u'إعْطَاءٌ مُقَاتِلٌ':Added, #1: 1	إعْطَاءُ الْمُقَاتِلَةِ
u'إعْطَاءٌ مِقْدَارٌ':Added, #2: 2	إعْطَاءِ الْمُقَاتِلَةِ
u'إعْطَاءٌ مُمَوَّنٌ':Added, #1: 1	إعْطَاءَ مِقْدَارٍ
u'إعْطَاءٌ مَنَاصِبُ':Added, #1: 1	إعْطَاءَ مُمَوَّنِهِ
u'إعْطَاءٌ مَنْفَعَةٌ':Added, #1: 1	إعْطَاءُ الْمَنَاصِبِ
u'إعْطَاءٌ مَنْفَعَةٌ':Added, #1: 1	إعْطَاءِ الْمَنْفَعَةِ
u'إعْطَاءٌ مَنْفَعَةٌ':Added, #2: 2	إعْطَاءُ الْمَنْفَعَةِ
u'إعْطَاءٌ مَهْرٌ':Added, #3: 3	إعْطَاءُ مَنْفَعَةِ
u'إعْطَاءٌ مَوْجُودٌ':Added, #1: 1	إعْطَاءَ مَهْرٍ
u'إعْطَاءٌ مُؤَلَّفٌ':Added, #2: 2	إعْطَاءُ الْمَوْجُودِ
u'إعْطَاءٌ مُؤَلِّفٌ':Added, #1: 1	إعْطَاءُ الْمُؤَلّفَةِ
u'إعْطَاءٌ نَائِبٌ':Added, #1: 1	إعْطَاءُ الْمُؤَلّفَةِ
u'إعْطَاءٌ نَائِبَةٌ':Added, #1: 1	إعْطَاءِ النَّائِبَةِ
u'إعْطَاءٌ نَبِيٌّ':Added, #1: 1	إعْطَاءِ النَّائِبَةِ
u'إعْطَاءٌ نُجُومٌ':Added, #1: 1	إعْطَاءُ النَّبِيِّ
u'إعْطَاءٌ نصاب':Added, #1: 1	إعْطَاءُ النُّجُومِ
u'إعْطَاءٌ نِصَابٌ':Added, #1: 1	إعْطَاءَ نِصَابٍ
u'إعْطَاءٌ نِصْفٌ':Added, #1: 1	إعْطَاءَ نِصَابٍ
u'إعْطَاءٌ نَفْسٌ':Added, #2: 2	إعْطَاءِ النِّصْفِ
u'إعْطَاءٌ نَفَقَةٌ':Added, #2: 2	إعْطَاءُ نَفْسِهِ
u'إعْطَاءٌ نَفْلٌ':Added, #1: 1	إعْطَاءِ النَّفَقَةِ
u'إعْطَاءٌ هَدِيٌّ':Added, #1: 1	إعْطَاءِ النَّفْلِ
u'إعْطَاءٌ هَدِيَّةٌ':Added, #1: 1	إعْطَاءُ الْهَدِيَّةِ
u'إعْطَاءٌ واحد':Added, #1: 1	إعْطَاءُ الْهَدِيَّةِ
u'إعْطَاءٌ وَاحِدٌ':Added, #1: 1	إعْطَاءُ وَاحِدَةٍ
u'إعْطَاءٌ وَارِثٌ':Added, #1: 1	إعْطَاءُ وَاحِدَةٍ
u'إعْطَاءٌ وَارِثٌ':Added, #1: 1	إعْطَاءُ الْوَارِثِ
u'إعْطَاءٌ وَدِيعٌ':Added, #1: 1	إعْطَاءِ الْوَارِثِ
u'إعْطَاءٌ وَدِيعَةٌ':Added, #1: 1	إعْطَاءِ الْوَدِيعَةِ
u'إعْطَاءٌ وَسَائِلُ':Added, #1: 1	إعْطَاءِ الْوَدِيعَةِ
u'إعْطَاءٌ وَكِيلٌ':Added, #1: 1	إعْطَاءِ الْوَسَائِلِ
u'إعْطَاءٌ وَكِيلٌ':Added, #1: 1	إعْطَاءِ وَكِيلِ
u'إعْطَاءٌ ولد':Added, #1: 1	إعْطَاءُ وَكِيلِهِ
u'إعْطَاءٌ وَلَدٌ':Added, #1: 1	إعْطَاءِ الْوَلَدِ
u'إعْطَاءٌ وَلِيٌّ':Added, #1: 1	إعْطَاءِ الْوَلَدِ
u'إعْطَاءٌ يَهُودِيٌّ':Added, #1: 1	إعْطَاءِ الْوَلِيِّ
u'أَعْطَى أَبٌ':Subject, #1: 1	إعْطَاءُ الْيَهُودِيِّ
u'أَعْطَى اِبْنٌ':Predicate, #1: 1	أَعْطَى الْأَبُ
u'أَعْطَى أَجْرٌ':Predicate, #1: 1	أَعْطَى ابْنَ
u'أَعْطَى أَجْوَدُ':Predicate, #1: 1	أَعْطَى الأَجْرَ
u'أَعْطَى أحَدٌ':Predicate, #2: 2	أَعْطَى أَجْوَدَ
u'أَعْطَى أحَدٌ':Subject, #1: 1	أَعْطَى أَحَدَ
u'أَعْطَى أُخْتٌ':Predicate, #2: 2	أَعْطَى أَحَدُ
u'أَعْطَى أَرْبَعَةٌ':Predicate, #3: 3	أَعْطَى الأُخْتَ
u'أَعْطَى أَرْبَعَةٌ':Predicate, #1: 1	أَعْطَى أَرْبَعَةَ
u'أَعْطَى أسْبَابٌ':Predicate, #1: 1	أَعْطَى الْأَرْبَعَةَ
u'أَعْطَى أَسْبَابٌ':Predicate, #1: 1	أَعْطَى أَسْبَابَ
u'أَعْطَى آسِيَةٌ':Predicate, #1: 1	أَعْطَى أَسْبَابَ
u'أَعْطَى أَصْحَابٌ':Predicate, #1: 1	أَعْطَى آسِيَةَ
u'أَعْطَى أعْرَابِيٌّ':Predicate, #1: 1	أَعْطَى أَصْحَابَ
u'أَعْطَى أقْرَع':Predicate, #1: 1	أَعْطَى الْأَعْرَابِيَّ
u'أَعْطَى أقَلُّ':Predicate, #1: 1	أَعْطَى الأَقْرَعَ
u'أَعْطَى أَكْثَرُ':Predicate, #1: 1	أَعْطَى أَقَلَّ
u'أَعْطَى أُمٌّ':Predicate, #1: 1	أَعْطَى أَكْثَرَ
u'أَعْطَى أُمٌّ':Predicate, #1: 1	أَعْطَى الأُمَّ
u'أَعْطَى إمَامٌ':Predicate, #4: 4	أَعْطَى الْأُمَّ
u'أَعْطَى إمَامٌ':Subject, #1: 1	أَعْطَى الْإِمَامَ
u'أَعْطَى إمَامٌ':Subject, #1: 1	أَعْطَى إمَامٌ
u'أَعْطَى آمِرٌ':Predicate, #6: 6	أَعْطَى الْإِمَامُ
u'أَعْطَى آمِرٌ':Subject, #1: 1	أَعْطَى الْآمِرَ
u'أَعْطَى أهْلٌ':Predicate, #1: 1	أَعْطَى الْآمِرُ
u'أَعْطَى أَوَّلُ':Predicate, #3: 3	أَعْطَى أَهْلَ
u'أَعْطَى أَوَّلُ':Subject, #2: 2	أَعْطَى الْأَوَّلَ
u'أَعْطَى بَائِعٌ':Subject, #1: 1	أَعْطَى أَوَّلُهُ
u'أَعْطَى بَذْرٌ':Predicate, #1: 1	أَعْطَى الْبَائِعُ
u'أَعْطَى بَعْضٌ':Predicate, #1: 1	أَعْطَى بَذْرَ
u'أَعْطَى بَقَرٌ':Predicate, #4: 4	أَعْطَى بَعْضَ
u'أَعْطَى بِنْتٌ':Predicate, #2: 2	أَعْطَى الْبَقَرَ
u'أَعْطَى تَبِيع':Predicate, #1: 1	أَعْطَى بِنْتَ
u'أَعْطَى ثَلاثُ':Predicate, #1: 1	أَعْطَى تَبِيعَةً
u'أَعْطَى ثَمَنٌ':Predicate, #1: 1	أَعْطَى الثَّلَاثَ
u'أَعْطَى جَارٌ':Subject, #3: 3	أَعْطَى الثَّمَنَ
u'أَعْطَى جَازٌ':Predicate, #1: 1	أَعْطَى الْجَارُ
u'أَعْطَى جَزَّارٌ':Predicate, #1: 1	أَعْطَى جَازَ
u'أَعْطَى جِزْيَةٌ':Predicate, #3: 3	أَعْطَى الْجَزَّارَ
u'أَعْطَى حامِلٌ':Subject, #2: 2	أَعْطَى الْجِزْيَةَ
u'أَعْطَى حَديثٌ':Predicate, #1: 1	أَعْطَى حَامِلُ
u'أَعْطَى حَرْبَةٌ':Predicate, #1: 1	أَعْطَى الْحَدِيثَ
u'أَعْطَى حَسَنٌ':Subject, #1: 1	أَعْطَى الْحَرْبَةَ
u'أَعْطَى حُقوقٌ':Predicate, #1: 1	أَعْطَى الْحَسَنُ
u'أَعْطَى حُقُوقٌ':Predicate, #1: 1	أَعْطَى الْحُقُوقَ
u'أَعْطَى حُكْمٌ':Predicate, #1: 1	أَعْطَى الْحُقُوقَ
u'أَعْطَى حُكْمٌ':Subject, #1: 1	أَعْطَى حُكْمَ
u'أَعْطَى حَلْوانِيٌّ':Predicate, #1: 1	أَعْطَى حُكْمُ
u'أَعْطَى خراج':Predicate, #1: 1	أَعْطَى الْحَلْوَانِيَّ
u'أَعْطَى خَرَاجٌ':Predicate, #1: 1	أَعْطَى خَرَاجَ
u'أَعْطَى دَابَّةٌ':Predicate, #1: 1	أَعْطَى خَرَاجَ
u'أَعْطَى دَرَاهِمُ':Predicate, #1: 1	أَعْطَى دَابَّةَ
u'أَعْطَى دَنانيرُ':Predicate, #3: 3	أَعْطَى الدَّرَاهِمَ
u'أَعْطَى دَواءٌ':Predicate, #2: 2	أَعْطَى الدَّنَانِيرَ
u'أَعْطَى دِيَةٌ':Predicate, #1: 1	أَعْطَى الدَّوَاءَ
u'أَعْطَى دِيَةٌ':Predicate, #1: 1	أَعْطَى الدِّيَةَ
u'أَعْطَى رَجُلٌ':Predicate, #1: 1	أَعْطَى دِيَةَ
u'أَعْطَى رَجُلٌ':Predicate, #1: 1	أَعْطَى الرَّجُلَ
u'أَعْطَى رَجُلٌ':Subject, #1: 1	أَعْطَى رَجُلاً
u'أَعْطَى رَجُلٌ':Subject, #2: 2	أَعْطَى الرَّجُلُ
u'أَعْطَى رَسُولٌ':Subject, #2: 2	أَعْطَى رَجُلٌ
u'أَعْطَى زُرَّاعٌ':Subject, #10: 10	أَعْطَى رَسُولُ
u'أَعْطَى زَكاةٌ':Predicate, #1: 1	أَعْطَى الزُّرَّاعُ
u'أَعْطَى زِيادَةٌ':Predicate, #1: 1	أَعْطَى زَكَاةَ
u'أَعْطَى زَيْدٌ':Predicate, #1: 1	أَعْطَى الزِّيَادَةَ
u'أَعْطَى زُيوفٌ':Predicate, #1: 1	أَعْطَى زَيْدَ
u'أَعْطَى زُيُوفٌ':Predicate, #1: 1	أَعْطَى الزُّيُوفَ
u'أَعْطَى سَبَقٌ':Predicate, #1: 1	أَعْطَى الزُّيُوفَ
u'أَعْطَى سَرَاوِيلُ':Predicate, #1: 1	أَعْطَى السَّبَقَ
u'أَعْطَى سَرِيٌّ':Predicate, #1: 1	أَعْطَى السَّرَاوِيلَ
u'أَعْطَى سَرِيَّةٌ':Predicate, #1: 1	أَعْطَى السَّرِيَّةَ
u'أَعْطَى سِكِّينٌ':Predicate, #1: 1	أَعْطَى السَّرِيَّةَ
u'أَعْطَى سَلَبٌ':Predicate, #1: 1	أَعْطَى السِّكِّينَ
u'أَعْطَى سلمة':Predicate, #1: 1	أَعْطَى سَلَبَ
u'أَعْطَى شَاعِر':Predicate, #3: 3	أَعْطَى سَلَمَةَ
u'أَعْطَى شَخْصٌ':Subject, #1: 1	أَعْطَى الشَّاعِرَ
u'أَعْطَى شَرْعٌ':Subject, #1: 1	أَعْطَى شَخْصٌ
u'أَعْطَى صَاحِبٌ':Predicate, #1: 1	أَعْطَى الشَّرْعُ
u'أَعْطَى صَاحِبٌ':Subject, #3: 3	أَعْطَى صَاحِبَ
u'أَعْطَى صَاحِبٌ':Subject, #1: 1	أَعْطَى صَاحِبُ
u'أَعْطَى صَاعٌ':Predicate, #1: 1	أَعْطَى صَاحِبُهُ
u'أَعْطَى صَبِيٌّ':Predicate, #1: 1	أَعْطَى الصَّاعَ
u'أَعْطَى صَفْوَان':Predicate, #1: 1	أَعْطَى الصَّبِيَّ
u'أَعْطَى صَيْرَفِيٌّ':Predicate, #5: 5	أَعْطَى صَفْوَانَ
u'أَعْطَى طَالِبٌ':Predicate, #1: 1	أَعْطَى الصَّيْرَفِيَّ
u'أَعْطَى طعام':Predicate, #3: 3	أَعْطَى الطَّالِبَ
u'أَعْطَى طَعَامٌ':Predicate, #1: 1	أَعْطَى الطَّعَامَ
u'أَعْطَى طعام':Predicate, #1: 1	أَعْطَى الطَّعَامَ
u'أَعْطَى طَعَامٌ':Predicate, #3: 3	أَعْطَى طَعَامَ
u'أَعْطَى عَاشِرٌ':Predicate, #3: 3	أَعْطَى طَعَامَ
u'أَعْطَى عَبْدٌ':Predicate, #1: 1	أَعْطَى الْعَاشِرَ
u'أَعْطَى عَبْدٌ':Subject, #1: 1	أَعْطَى الْعَبْدَ
u'أَعْطَى عُرْوَةٌ':Predicate, #1: 1	أَعْطَى الْعَبْدُ
u'أَعْطَى عُشْرٌ':Predicate, #1: 1	أَعْطَى عُرْوَةَ
u'أَعْطَى عَشْرٌ':Predicate, #1: 1	أَعْطَى عُشْرَ
u'أَعْطَى عَشْرٌ':Predicate, #1: 1	أَعْطَى عَشْرَةً
u'أَعْطَى عَمٌّ':Predicate, #1: 1	أَعْطَى عَشْرَةَ
u'أَعْطَى عُمَرٌ':Subject, #1: 1	أَعْطَى الْعَمَّ
u'أَعْطَى عين':Predicate, #1: 1	أَعْطَى عُمَرُ
u'أَعْطَى عَيْنٌ':Predicate, #1: 1	أَعْطَى عَيْنَ
u'أَعْطَى عَيْن':Predicate, #1: 1	أَعْطَى عَيْنَ
u'أَعْطَى غَاصِبٌ':Subject, #1: 1	أَعْطَى عَيْنَ
u'أَعْطَى غُلاَمٌ':Predicate, #1: 1	أَعْطَى الْغَاصِبُ
u'أَعْطَى غَلَّةٌ':Predicate, #1: 1	أَعْطَى الْغُلَامَ
u'أَعْطَى غير':Predicate, #1: 1	أَعْطَى غَلَّةَ
u'أَعْطَى غَيْرٌ':Predicate, #2: 2	أَعْطَى غَيْرَ
u'أَعْطَى غير':Subject, #2: 2	أَعْطَى غَيْرَ
u'أَعْطَى غَيْرٌ':Subject, #1: 1	أَعْطَى غَيْرُ
u'أَعْطَى فَارِسٌ':Predicate, #1: 1	أَعْطَى غَيْرُ
u'أَعْطَى فِدْيَةٌ':Predicate, #2: 2	أَعْطَى الْفَارِسَ
u'أَعْطَى فَرَسٌ':Predicate, #1: 1	أَعْطَى الْفِدْيَةَ
u'أَعْطَى فَضْلٌ':Predicate, #1: 1	أَعْطَى فَرَسَ
u'أَعْطَى فَضْلٌ':Predicate, #1: 1	أَعْطَى الْفَضْلَ
u'أَعْطَى فقراء':Predicate, #1: 1	أَعْطَى فَضْلَ
u'أَعْطَى فقراء':Predicate, #2: 2	أَعْطَى الْفُقَرَاءَ
u'أَعْطَى فَقِيرٌ':Predicate, #2: 2	أَعْطَى فُقَرَاءَ
u'أَعْطَى فلان':Predicate, #1: 1	أَعْطَى الْفَقِيرَ
u'أَعْطَى فلان':Predicate, #1: 1	أَعْطَى بِلَالَ
u'أَعْطَى فُلاَنٌ':Subject, #3: 3	أَعْطَى خَيْبَرَ
u'أَعْطَى قَابِلٌ':Predicate, #1: 1	أَعْطَى فُلَانٌ
u'أَعْطَى قَالٌ':Predicate, #1: 1	أَعْطَى الْقَابِلَةَ
u'أَعْطَى قَوْمٌ':Predicate, #1: 1	أَعْطَى قَالَ
u'أَعْطَى قَيِّمٌ':Subject, #1: 1	أَعْطَى الْقَوْمَ
u'أَعْطَى قِيمَةٌ':Predicate, #1: 1	أَعْطَى الْقَيِّمُ
u'أَعْطَى قِيمَةٌ':Predicate, #1: 1	أَعْطَى الْقِيمَةَ
u'أَعْطَى كَفَّارٌ':Predicate, #6: 6	أَعْطَى قِيمَةَ
u'أَعْطَى كَفَّارَةٌ':Predicate, #3: 3	أَعْطَى كَفَّارَةَ
u'أَعْطَى كَفِيلٌ':Predicate, #3: 3	أَعْطَى كَفَّارَةَ
u'أَعْطَى كَفِيلٌ':Subject, #1: 1	أَعْطَى الْكَفِيلَ
u'أَعْطَى كَلاَمٌ':Subject, #1: 1	أَعْطَى الْكَفِيلُ
u'أَعْطَى مَالٌ':Predicate, #1: 1	أَعْطَى كَلَامُ
u'أَعْطَى مَالٌ':Predicate, #1: 1	أَعْطَى الْمَالَ
u'أَعْطَى مَالِكٌ':Subject, #1: 1	أَعْطَى مَالَ
u'أَعْطَى مُحَمَّدٌ':Subject, #1: 1	أَعْطَى الْمَالِكُ
u'أَعْطَى مُحَمَّدٌ':Subject, #1: 1	أَعْطَى مُحَمّدٌ
u'أَعْطَى مُدٌّ':Predicate, #2: 2	أَعْطَى مُحَمَّدٌ
u'أَعْطَى مَدْيُونٌ':Subject, #1: 1	أَعْطَى الْمُدَّ
u'أَعْطَى مساكين':Predicate, #1: 1	أَعْطَى الْمَدْيُونُ
u'أَعْطَى مُسْتَأْجِرٌ':Predicate, #1: 1	أَعْطَى مَسَاكِينَ
u'أَعْطَى مُسْتَأْجِرٌ':Subject, #1: 1	أَعْطَى الْمُسْتَأْجِرَ
u'أَعْطَى مُسْلِمٌ':Subject, #1: 1	أَعْطَى الْمُسْتَأْجِرُ
u'أَعْطَى مُصْلِحٌ':Predicate, #1: 1	أَعْطَى الْمُسْلِمُ
u'أَعْطَى مُضَارِبٌ':Subject, #1: 1	أَعْطَى الْمُصْلِحِينَ
u'أَعْطَى مَطْلُوبٌ':Subject, #1: 1	أَعْطَى الْمُضَارِبُ
u'أَعْطَى مَكّاس':Predicate, #1: 1	أَعْطَى الْمَطْلُوبُ
u'أَعْطَى مِلْكٌ':Subject, #1: 1	أَعْطَى الْمَكَّاسَ
u'أَعْطَى مَنَافِعُ':Predicate, #1: 1	أَعْطَى مِلْكٌ
u'أَعْطَى مُؤَجِّرٌ':Subject, #1: 1	أَعْطَى الْمَنَافِعَ
u'أَعْطَى مُؤَلَّفٌ':Predicate, #1: 1	أَعْطَى الْمُؤَجِّرُ
u'أَعْطَى نَاسٌ':Predicate, #4: 4	أَعْطَى الْمُؤَلَّفَةَ
u'أَعْطَى نَافِعٌ':Subject, #1: 1	أَعْطَى النَّاسَ
u'أَعْطَى نَبِيٌّ':Predicate, #1: 1	أَعْطَى نَافِعٌ
u'أَعْطَى نَبِيٌّ':Subject, #1: 1	أَعْطَى النَّبِيَّ
u'أَعْطَى نِساءٌ':Predicate, #6: 6	أَعْطَى النَّبِيُّ
u'أَعْطَى نِصْفٌ':Predicate, #1: 1	أَعْطَى النِّسَاءَ
u'أَعْطَى نِصْفٌ':Predicate, #3: 3	أَعْطَى النِّصْفَ
u'أَعْطَى نَفْسٌ':Predicate, #3: 3	أَعْطَى نِصْفَ
u'أَعْطَى نَفَقَةٌ':Predicate, #1: 1	أَعْطَى النَّفْسَ
u'أَعْطَى نَفَقَةٌ':Predicate, #1: 1	أَعْطَى نَفَقَةَ
u'أَعْطَى واحد':Predicate, #2: 2	أَعْطَى النَّفَقَةَ
u'أَعْطَى وَاحِدٌ':Predicate, #1: 1	أَعْطَى وَاحِدَةً
u'أَعْطَى وَارِثٌ':Subject, #1: 1	أَعْطَى وَاحِدَةً
u'أَعْطَى وَاقِفٌ':Predicate, #3: 3	أَعْطَى الْوَارِثُ
u'أَعْطَى وَاقِفٌ':Subject, #3: 3	أَعْطَى الْوَاقِفَ
u'أَعْطَى وَحْيٌ':Predicate, #1: 1	أَعْطَى الْوَاقِفُ
u'أَعْطَى ورق':Predicate, #1: 1	أَعْطَى وَحْيَ
u'أَعْطَى وَرِقٌ':Predicate, #1: 1	أَعْطَى الْوَرِقَ
u'أَعْطَى وَصِيٌّ':Predicate, #1: 1	أَعْطَى الْوَرِقَ
u'أَعْطَى وَصِيٌّ':Subject, #1: 1	أَعْطَى الْوَصِيَّ
u'أَعْطَى وَكِيلٌ':Subject, #4: 4	أَعْطَى الْوَصِيُّ
u'أَعْطَى ولد':Predicate, #2: 2	أَعْطَى الْوَكِيلُ
u'أَعْطَى وَلَدٌ':Predicate, #1: 1	أَعْطَى الْوَلَدَ
u'أَعْطَى يَتِيمٌ':Predicate, #1: 1	أَعْطَى الْوَلَدَ
u'أَعْظَمَ أَجْرٌ':Predicate, #1: 1	أَعْطَى الْيَتِيمَ
u'أَعْظَمَ ذَنْبٌ':Predicate, #3: 3	أَعْظَمَ أَجْرَ
u'أَعْظَمَ فِرْيَةٌ':Predicate, #3: 3	أَعْظَمَ الذَّنْبَ
u'أَعْظَمَ مَالِكٌ':Subject, #1: 1	أَعْظَمَ الْفِرْيَةَ
u'أَعْظَمَ مُسْلِمٌ':Predicate, #2: 2	أَعْظَمَ مَالِكٌ
u'أَعَفَّ فَرْعٌ':Subject, #1: 1	أَعْظَمَ الْمُسْلِمِينَ
u'أعْقَابٌ صَلَوَاتٌ':Added, #1: 1	أَعَفَّ الْفَرْعُ
u'أَعْقَابٌ صَلَوَاتٌ':Added, #2: 2	أَعْقَابِ الصَّلَوَاتِ
u'أعْقَابٌ فَرَائِضُ':Added, #2: 2	أَعْقَابِ الصَّلَوَاتِ
u'أَعْقَابٌ فَرَائِضُ':Added, #1: 1	أَعْقَابِ الْفَرَائِضِ
u'أعْقَابٌ لَيْلٌ':Added, #1: 1	أَعْقَابِ الْفَرَائِضِ
u'أَعْقَابٌ لَيْلٌ':Added, #1: 1	أَعْقَابِ لَيْلٍ
u'أعْقَابٌ نَاسٌ':Added, #1: 1	أَعْقَابِ لَيْلٍ
u'أَعْقَابٌ نَاسٌ':Added, #1: 1	أَعْقَابَ النَّاسِ
u'أَعْقَبَ بدن':Predicate, #1: 1	أَعْقَابَ النَّاسِ
u'أَعْقَبَ بَدَنٌ':Predicate, #1: 1	أَعْقَبَ الْبَدَنَ
u'أَعْقَبَ جُمْلَةٌ':Predicate, #1: 1	أَعْقَبَ الْبَدَنَ
u'أَعْقَبَ حلْوٌ':Predicate, #1: 1	أَعْقَبَ جُمْلَةَ
u'أَعْقَبَ رَمْيٌ':Predicate, #1: 1	أَعْقَبَ الْحُلْوَ
u'أَعْقَبَ فَتْحٌ':Subject, #1: 1	أَعْقَبَ الرَّمْيَ
u'أَعْقَبَ فِعْلٌ':Predicate, #1: 1	أَعْقَبَ فَتْحٌ
u'أَعْقَبَ لَفْظٌ':Predicate, #1: 1	أَعْقَبَ الْفِعْلَ
u'أَعْقَبَ مَسْحٌ':Predicate, #2: 2	أَعْقَبَ لَفْظَ
u'أَعْقَبَ وَصِيٌّ':Predicate, #1: 1	أَعْقَبَ الْمَسْحَ
u'أَعْقَبَ وَصِيَّةٌ':Predicate, #1: 1	أَعْقَبَ وَصِيَّةَ
u'أَعْقَبَ وَلاَءٌ':Predicate, #1: 1	أَعْقَبَ وَصِيَّةَ
u'أَعْقَلَ بِشْرٌ':Predicate, #3: 3	أَعْقَبَ الْوَلَاءَ
u'أَعْلَمَ المُشْتَرِي':Predicate, #1: 1	أَعْقَلَ بِشْرَ
u'أَعْلَمَ أَميرٌ':Predicate, #3: 3	أَعْلَمَ الْمُشْتَرِيَ
u'أَعْلَمَ خُلَفَاءُ':Predicate, #1: 1	أَعْلَمَ الْأَمِيرَ
u'أَعْلَمَ دَافِعٌ':Predicate, #1: 1	أَعْلَمَ الْخُلَفَاءَ
u'أَعْلَمَ رَبُّ':Predicate, #1: 1	أَعْلَمَ الدَّافِعَ
u'أَعْلَمَ رَبُّ':Subject, #1: 1	أَعْلَمَ رَبَّ
u'أَعْلَمَ رَسُولٌ':Subject, #2: 2	أَعْلَمَ رَبُّ
u'أَعْلَمَ زَيْدٌ':Subject, #1: 1	أَعْلَمَ رَسُولُ
u'أَعْلَمَ سَفَهٌ':Predicate, #1: 1	أَعْلَمَ زَيْدٌ
u'أَعْلَمَ سُلْطَانٌ':Predicate, #1: 1	أَعْلَمَ السَّفَهَ
u'أَعْلَمَ صَاحِبٌ':Predicate, #1: 1	أَعْلَمَ السُّلْطَانَ
u'أَعْلَمَ صَاحِبٌ':Subject, #2: 2	أَعْلَمَ صَاحِبَ
u'أَعْلَمَ صدق':Predicate, #1: 1	أَعْلَمَ صَاحِبُ
u'أَعْلَمَ صِدْقٌ':Predicate, #1: 1	أَعْلَمَ صِدْقَ
u'أَعْلَمَ عَالِمٌ':Subject, #1: 1	أَعْلَمَ صِدْقَ
u'أَعْلَمَ علماء':Predicate, #1: 1	أَعْلَمَ الْعَالِمُ
u'أَعْلَمَ عُلَمَاءُ':Predicate, #1: 1	أَعْلَمَ الْعُلَمَاءَ
u'أَعْلَمَ فَقِيرٌ':Predicate, #1: 1	أَعْلَمَ الْعُلَمَاءَ
u'أَعْلَمَ فلان':Predicate, #1: 1	أَعْلَمَ الْفَقِيرَ
u'أَعْلَمَ قَاضِي':Predicate, #2: 2	أَعْلَمَ عُثْمَانَ
u'أَعْلَمَ لُصُوصٌ':Predicate, #1: 1	أَعْلَمَ الْقَاضِيَ
u'أَعْلَمَ مُسْتَأْجِرٌ':Subject, #2: 2	أَعْلَمَ اللُّصُوصَ
u'أَعْلَمَ مُسْتَحِقٌّ':Predicate, #1: 1	أَعْلَمَ الْمُسْتَأْجِرُ
u'أَعْلَمَ مُشْتَرِي':Predicate, #1: 1	أَعْلَمَ الْمُسْتَحِقَّ
u'أَعْلَمَ مَشْهُودٌ':Predicate, #3: 3	أَعْلَمَ الْمُشْتَرِيَ
u'أَعْلَمَ نَاسٌ':Predicate, #1: 1	أَعْلَمَ الْمَشْهُودَ
u'أَعْلَمَ وَالِي':Predicate, #1: 1	أَعْلَمَ النّاسَ
u'أَعْلَمَ وَكِيلٌ':Subject, #1: 1	أَعْلَمَ الْوَالِيَ
u'أَعْلَنَ رَسُولٌ':Subject, #1: 1	أَعْلَمَ الْوَكِيلُ
u'أَعْلَى جَازٌ':Predicate, #1: 1	أَعْلَنَ رَسُولُ
u'أَعْلَى جَهَنَّمُ':Predicate, #1: 1	أَعْلَى جَازَ
u'أَعْلَى عِلِّيٌّ':Predicate, #1: 1	أَعْلَى جَهَنَّمَ
u'أَعْلَى فلان':Predicate, #3: 3	أَعْلَى عِلِّيِّينَ
u'أَعْلَى فلان':Predicate, #3: 3	أَعْلَى مَكّةَ
u'أَعْلَى قَدْرٌ':Predicate, #7: 7	أَعْلَى مَكَّةَ
u'أَعْلَى مثل':Predicate, #1: 1	أَعْلَى قَدْرَ
u'أَعْلَى مِثْلٌ':Predicate, #1: 1	أَعْلَى مِثْلَ
u'أَعْلَى مَعَالِمُ':Predicate, #1: 1	أَعْلَى مِثْلَ
u'إعْمَاءٌ عَيْنٌ':Added, #2: 2	أَعْلَى مَعَالِمَ
u'إعْمَاءٌ عَيْن':Added, #1: 1	إعْمَاءِ عَيْنٍ
u'أعماق بِرٌّ':Added, #1: 1	إعْمَاءِ عَيْنٍ
u'أَعْمَاقٌ بِرٌّ':Added, #1: 1	أَعْمَاقِ الْبِرِّ
u'أعماق مَسْجِدٌ':Added, #1: 1	أَعْمَاقِ الْبِرِّ
u'أَعْمَاقٌ مَسْجِدٌ':Added, #3: 3	أَعْمَاقُ الْمَسْجِدِ
u'أَعْمَالٌ أبدانٌ':Added, #3: 3	أَعْمَاقُ الْمَسْجِدِ
u'أَعْمَالٌ أبدانٌ':Added, #1: 1	أَعْمَالُ الْأَبَدَانِ
u'أَعْمَالٌ أبدانٌ':Added, #1: 1	أَعْمَالُ الْأَبْدَانِ
u'أَعْمَالٌ آخِرَةٌ':Added, #2: 2	أَعْمَالِ الْأَبْدَانِ
u'إعْمَالٌ أَرْجَحُ':Added, #2: 2	أَعْمَالِ الْآخِرَةِ
u'أَعْمَالٌ أُسْبُوعٌ':Added, #1: 1	إعْمَالُ الْأَرْجَحِ
u'إعْمَالٌ اِسْمٌ':Added, #1: 1	أَعْمَالِ الْأُسْبُوعِ
u'إعْمَالٌ أَلْفَاظٌ':Added, #1: 1	إعْمَالِ اسْمِ
u'أَعْمَالٌ أَمَاكِنُ':Added, #2: 2	إعْمَالُ الْأَلْفَاظِ
u'أَعْمَالٌ أُمَّةٌ':Added, #1: 1	أَعْمَالِ الْأَمَاكِنِ
u'أَعْمَالٌ أهْلٌ':Added, #1: 1	أَعْمَالِ أُمَّتِهِ
u'إعْمَالٌ أَوَّلُ':Added, #5: 5	أَعْمَالِ أَهْلِ
u'أَعْمَالٌ إيمَانٌ':Added, #1: 1	إعْمَالِ الْأَوَّلِ
u'إعْمَالٌ بَذْلٌ':Added, #1: 1	أَعْمَالَ الْإِيمَانِ
u'أَعْمَالٌ بِرٌّ':Added, #1: 1	إعْمَالُ الْبَذْلِ
u'أَعْمَالٌ بَرٌّ':Added, #18: 18	أَعْمَالِ الْبِرِّ
u'أَعْمَالٌ بِرٌّ':Added, #1: 1	أَعْمَالِ الْبَرِّ
u'أَعْمَالٌ بِرٌّ':Added, #1: 1	أَعْمَالُ الْبِرِّ
u'أَعْمَالٌ بصرة':Added, #1: 1	أَعْمَالُ بِرٍّ
u'أَعْمَالٌ بَيْتٌ':Added, #1: 1	أَعْمَالِ الْبَصْرَةِ
u'أَعْمَالٌ تِجَارَةٌ':Added, #1: 1	أَعْمَالِ الْبَيْتِ
u'إعْمَالٌ تَحَالُفٌ':Added, #2: 2	أَعْمَالِ التِّجَارَةِ
u'أَعْمَالٌ ثَلاثَةٌ':Added, #1: 1	إعْمَالُ التَّحَالُفِ
u'أَعْمَالٌ جَارِحٌ':Added, #2: 2	أَعْمَالٍ ثَلَاثَةٍ
u'أَعْمَالٌ جَارِحَةٌ':Added, #1: 1	أَعْمَالِ الْجَارِحَةِ
u'أَعْمَالٌ جهاد':Added, #1: 1	أَعْمَالِ الْجَارِحَةِ
u'أَعْمَالٌ جِهَادٌ':Added, #2: 2	أَعْمَالِ الْجِهَادِ
u'أَعْمَالٌ جوارح':Added, #2: 2	أَعْمَالِ الْجِهَادِ
u'أَعْمَالٌ جَوَارِحُ':Added, #1: 1	أَعْمَالُ الْجَوَارِحِ
u'أَعْمَالٌ جوارح':Added, #1: 1	أَعْمَالُ الْجَوَارِحِ
u'أَعْمَالٌ جَوَارِحُ':Added, #3: 3	أَعْمَالَ الْجَوَارِحِ
u'أَعْمَالٌ جوارح':Added, #3: 3	أَعْمَالَ الْجَوَارِحِ
u'أَعْمَالٌ جَوَارِحُ':Added, #5: 5	أَعْمَالِ الْجَوَارِحِ
u'أَعْمَالٌ حَجٌّ':Added, #5: 5	أَعْمَالِ الْجَوَارِحِ
u'أَعْمَالٌ حَجٌّ':Added, #30: 30	أَعْمَالِ الْحَجِّ
u'إعْمَالٌ حَقِيقٌ':Added, #6: 6	أَعْمَالَ الْحَجِّ
u'إعْمَالٌ حَقِيقَةٌ':Added, #1: 1	إعْمَالُ الْحَقِيقَةِ
u'أَعْمَالٌ خَارِجٌ':Added, #1: 1	إعْمَالُ الْحَقِيقَةِ
u'أَعْمَالٌ خَاصَّةٌ':Added, #1: 1	أَعْمَالَ الْخَارِجِ
u'إعْمَالٌ خَبَرٌ':Added, #1: 1	أَعْمَالٍ خَاصَّةٍ
u'إعْمَالٌ خَبَر':Added, #1: 1	إعْمَالُ خَبَرِ
u'أَعْمَالٌ خلق':Added, #1: 1	إعْمَالُ خَبَرِ
u'أَعْمَالٌ خَلْقٌ':Added, #1: 1	أَعْمَالِ الْخَلْقِ
u'أَعْمَالٌ خِيَاطَةٌ':Added, #1: 1	أَعْمَالِ الْخَلْقِ
u'إعْمَالٌ دَليلٌ':Added, #1: 1	أَعْمَالِ الْخِيَاطَةِ
u'إعْمَالٌ دَليلٌ':Added, #1: 1	إعْمَالَ الدَّلِيلَيْنِ
u'أَعْمَالٌ ذَكاةٌ':Added, #1: 1	إعْمَالُ الدَّلِيلَيْنِ
u'إعْمَالٌ رَاجِحٌ':Added, #1: 1	أَعْمَالِ الذَّكَاةِ
u'إعْمَالٌ رَأْيٌ':Added, #1: 1	إعْمَالِ الرَّاجِحِ
u'أَعْمَالٌ رِجَالٌ':Added, #1: 1	إعْمَالُ الرَّأْيِ
u'إعْمَالٌ رَجْلٌ':Added, #1: 1	أَعْمَالِ الرِّجَالِ
u'إعْمَالٌ سَبَبٌ':Added, #1: 1	إعْمَالِ الرَّجْلِ
u'إعْمَالٌ سَبَبٌ':Added, #1: 1	إعْمَالَ السَّبَبِ
u'إعْمَالٌ شَبَهٌ':Added, #1: 1	إعْمَالِ السَّبَبِ
u'أَعْمَالٌ شَرٌّ':Added, #2: 2	إعْمَالَ الشَّبَهَيْنِ
u'أَعْمَالٌ شَرِيعَةٌ':Added, #1: 1	أَعْمَالِ الشَّرِّ
u'إعْمَالٌ شَهَادَةٌ':Added, #1: 1	أَعْمَالِ الشَّرِيعَةِ
u'أَعْمَالٌ صَبِيٌّ':Added, #1: 1	إعْمَالُ الشَّهَادَةِ
u'أَعْمَالٌ صِبْيَانٌ':Added, #1: 1	أَعْمَالِ الصَّبِيِّ
u'أَعْمَالٌ صَحَابَةٌ':Added, #1: 1	أَعْمَالِ الصِّبْيَانِ
u'أَعْمَالٌ صَلاَةٌ':Added, #1: 1	أَعْمَالِ الصَّحَابَةِ
u'أَعْمَالٌ صَلاَةٌ':Added, #1: 1	أَعْمَالَ الصَّلَاةِ
u'أَعْمَالٌ صَلاَةٌ':Added, #1: 1	أَعْمَالِ صَلَاةٍ
u'أَعْمَالٌ صَلاَةٌ':Added, #27: 27	أَعْمَالِ الصَّلَاةِ
u'إعْمَالٌ ضِدٌّ':Added, #5: 5	أَعْمَالِ صَلَاتِهِ
u'إعْمَالٌ ضَرُورَةٌ':Added, #1: 1	إعْمَالُ الضِّدَّيْنِ
u'أَعْمَالٌ طَاعَةٌ':Added, #1: 1	إعْمَالُ الضَّرُورَةِ
u'أَعْمَالٌ طَاعَةٌ':Added, #1: 1	أَعْمَالُ الطَّاعَاتِ
u'إعْمَالٌ عَامٌّ':Added, #1: 1	أَعْمَالَ الطَّاعَةِ
u'أَعْمَالٌ عِبَادٌ':Added, #1: 1	إعْمَالِ الْعَامِّ
u'أَعْمَالٌ عِبَادٌ':Added, #2: 2	أَعْمَالَ الْعِبَادِ
u'أَعْمَالٌ عِبَادٌ':Added, #4: 4	أَعْمَالُ الْعِبَادِ
u'أَعْمَالٌ عِبَادَةٌ':Added, #6: 6	أَعْمَالِ الْعِبَادِ
u'إعْمَالٌ عزل':Added, #3: 3	أَعْمَالِ الْعِبَادَاتِ
u'أَعْمَالٌ عمرة':Added, #2: 2	إعْمَالِ عَزْلِهِ
u'أَعْمَالٌ عُمْرَةٌ':Added, #11: 11	أَعْمَالِ الْعُمْرَةِ
u'أَعْمَالٌ عمرة':Added, #11: 11	أَعْمَالِ الْعُمْرَةِ
u'أَعْمَالٌ عُمْرَةٌ':Added, #1: 1	أَعْمَالُ عُمْرَةٍ
u'أَعْمَالٌ عمرة':Added, #1: 1	أَعْمَالُ عُمْرَةٍ
u'أَعْمَالٌ عُمْرَةٌ':Added, #2: 2	أَعْمَالُ الْعُمْرَةِ
u'أَعْمَالٌ عمرة':Added, #2: 2	أَعْمَالُ الْعُمْرَةِ
u'أَعْمَالٌ عُمْرَةٌ':Added, #5: 5	أَعْمَالَ الْعُمْرَةِ
u'أَعْمَالٌ غير':Added, #5: 5	أَعْمَالَ الْعُمْرَةِ
u'أَعْمَالٌ غَيْرٌ':Added, #1: 1	أَعْمَالِ غَيْرِهِ
u'أَعْمَالٌ فِرْقَةٌ':Added, #1: 1	أَعْمَالِ غَيْرِهِ
u'إعْمَالٌ فِكْرٌ':Added, #1: 1	أَعْمَالِ الْفِرْقَةِ
u'إعْمَالٌ فِكْرٌ':Added, #1: 1	إعْمَالُ الْفِكْرِ
u'أَعْمَالٌ قلب':Added, #1: 1	إعْمَالِ الْفِكْرِ
u'أَعْمَالٌ قَلْبٌ':Added, #5: 5	أَعْمَالِ الْقَلْبِ
u'أَعْمَالٌ قَلْب':Added, #5: 5	أَعْمَالِ الْقَلْبِ
u'أَعْمَالٌ قُلُوبٌ':Added, #5: 5	أَعْمَالِ الْقَلْبِ
u'أَعْمَالٌ قُلُوبٌ':Added, #13: 13	أَعْمَالِ الْقُلُوبِ
u'أَعْمَالٌ كُفَّارٌ':Added, #1: 1	أَعْمَالُ الْقُلُوبِ
u'أَعْمَالٌ لِسَانٌ':Added, #1: 1	أَعْمَالِ الْكُفَّارِ
u'إعْمَالٌ لَفْظٌ':Added, #1: 1	أَعْمَالَ اللِّسَانِ
u'إعْمَالٌ لَفْظٌ':Added, #1: 1	إعْمَالَ اللَّفْظِ
u'إعْمَالٌ لَفْظٌ':Added, #1: 1	إعْمَالُ اللَّفْظِ
u'إعْمَالٌ مُتَقَدِّمٌ':Added, #2: 2	إعْمَالِ اللَّفْظِ
u'أَعْمَالٌ مَجَانِينُ':Added, #1: 1	إعْمَالُ الْمُتَقَدِّمِ
u'أَعْمَالٌ مُساقاة':Added, #1: 1	أَعْمَالِ الْمَجَانِينِ
u'إعْمَالٌ مُسْتَعَارٌ':Added, #1: 1	أَعْمَالِ الْمُسَاقَاةِ
u'إعْمَالٌ مُشْتَرَكٌ':Added, #1: 1	إعْمَالُ الْمُسْتَعَارِ
u'إعْمَالٌ مُشْتَرَكٌ':Added, #1: 1	إعْمَالَ الْمُشْتَرَكِ
u'إعْمَالٌ مَصْدَرٌ':Added, #1: 1	إعْمَالِ الْمُشْتَرَكِ
u'إعْمَالٌ مَطِيٌّ':Added, #1: 1	إعْمَالِ الْمَصْدَرِ
u'إعْمَالٌ مَطِيٌّ':Added, #1: 1	إعْمَالُ الْمَطِيِّ
u'أَعْمَالٌ مُعَامَلَةٌ':Added, #2: 2	إعْمَالِ الْمَطِيِّ
u'إعْمَالٌ مَفْهُومٌ':Added, #1: 1	أَعْمَالِ الْمُعَامَلَةِ
u'إعْمَالٌ مُقَدَّرٌ':Added, #1: 1	إعْمَالِ الْمَفْهُومِ
u'أَعْمَالٌ مُكَلَّفٌ':Added, #1: 1	إعْمَالِ مُقَدَّرٍ
u'أَعْمَالٌ مَنْزِلٌ':Added, #1: 1	أَعْمَالِ الْمُكَلَّفِ
u'أَعْمَالٌ نَاسٌ':Added, #1: 1	أَعْمَالِ مَنْزِلِهِ
u'أَعْمَالٌ نَاسٌ':Added, #1: 1	أَعْمَالَ النَّاسِ
u'أَعْمَالٌ نَاسٌ':Added, #1: 1	أَعْمَالُ النَّاسِ
u'أَعْمَالٌ نُسُكٌ':Added, #2: 2	أَعْمَالِ النَّاسِ
u'أَعْمَالٌ نُسُكٌ':Added, #1: 1	أَعْمَالَ النُّسُكِ
u'أَعْمَالٌ نُسُكٌ':Added, #1: 1	أَعْمَالُ النُّسُكَيْنِ
u'أَعْمَالٌ نَفْسٌ':Added, #2: 2	أَعْمَالِ النُّسُكِ
u'أَعْمَالٌ نقلة':Added, #1: 1	أَعْمَالِ نَفْسِهِ
u'إعْمَالٌ نِيَّةٌ':Added, #1: 1	أَعْمَالِ النَّقْلَةِ
u'إعْمَالٌ وَجْهٌ':Added, #1: 1	إعْمَالُ نِيَّتِهِ
u'أَعْمَالٌ وُضُوءٌ':Added, #1: 1	إعْمَالِ الْوَجْهَيْنِ
u'أَعْمَالٌ وُلاَةٌ':Added, #1: 1	أَعْمَالِ الْوُضُوءِ
u'أَعْمَالٌ يَتِيمٌ':Added, #1: 1	أَعْمَالِ الْوُلاَةِ
u'أَعْمَالٌ يَدٌ':Added, #1: 1	أَعْمَالِ الْيَتِيمِ
u'إعْمَالٌ يَقِينٌ':Added, #1: 1	أَعْمَالِ الْيَدِ
u'أَعْمَالٌ يَوْمٌ':Added, #1: 1	إعْمَالُ الْيَقِينِ
u'أَعْمَالٌ يَوْمٌ':Added, #1: 1	أَعْمَالُ يَوْمِ
u'أَعْمَامٌ أَبٌ':Added, #1: 1	أَعْمَالِ يَوْمِ
u'أَعْمَامٌ أَبٌ':Added, #2: 2	أَعْمَامِ الْأَبِ
u'أَعْمَامٌ أُمٌّ':Added, #7: 7	أَعْمَامُ الْأَبِ
u'أَعْمَامٌ نَبِيٌّ':Added, #1: 1	أَعْمَامِ الْأُمِّ
u'أَعْمَامٌ وَاقِفٌ':Added, #1: 1	أَعْمَامِ النَّبِيِّ
u'أَعْمَامٌ وَصِيٌّ':Added, #1: 1	أَعْمَامِ الْوَاقِفِ
u'أَعْمَرَ رَجُلٌ':Predicate, #1: 1	أَعْمَامِ الْوَصِيِّ
u'أَعْمَرَ رَسُولٌ':Subject, #2: 2	أَعْمَرَ رَجُلاً
u'أَعْمَرَ طَائِفٌ':Predicate, #2: 2	أَعْمَرَ رَسُولُ
u'أَعْمَرَ عَائِشٌ':Predicate, #2: 2	أَعْمَرَ طَائِفَةً
u'أَعْمَلَ إِطْلاقٌ':Predicate, #2: 2	أَعْمَرَ عَائِشَةَ
u'أَعْمَلَ رَاجِحٌ':Predicate, #1: 1	أَعْمَلَ إطْلَاقَ
u'أَعْمَلَ عَمَلٌ':Predicate, #1: 1	أَعْمَلَ الرَّاجِحَ
u'أَعْمَى أَبْكَم':Predicate, #1: 1	أَعْمَلَ عَمَلاً
u'أَعْمَى أَبْكَم':Subject, #1: 1	أَعْمَى أَبْكَمَ
u'أَعْمَى أخرَس':Predicate, #1: 1	أَعْمَى أَبْكَمُ
u'أَعْمَى أَصَمّ':Predicate, #2: 2	أَعْمَى أَخْرَسَ
u'أَعْمَى أَصَمّ':Subject, #1: 1	أَعْمَى أَصَمَّ
u'أَعْمَى أعْرَج':Subject, #2: 2	أَعْمَى أَصَمُّ
u'أَعْمَى تَخَلُّفٌ':Predicate, #1: 1	أَعْمَى أَعْرَجُ
u'أَعْمَى تَقْليدٌ':Subject, #1: 1	أَعْمَى التَّخَلُّفَ
u'أَعْمَى تَقْليد':Subject, #1: 1	أَعْمَى التَّقْلِيدُ
u'أَعْمَى دونٌ':Predicate, #1: 1	أَعْمَى التَّقْلِيدُ
u'أَعْمَى ذكر':Predicate, #1: 1	أَعْمَى دُونَ
u'أَعْمَى عند':Predicate, #1: 1	أَعْمَى ذُكِرَ
u'أَعْمَى قَالٌ':Predicate, #5: 5	أَعْمَى عِنْدَ
u'أَعْمَى قول':Subject, #1: 1	أَعْمَى قَالَ
u'أَعْمَى قَوْلٌ':Subject, #1: 1	أَعْمَى قَوْلُهُ
u'أَعْمَى مُسَاكَنَةٌ':Subject, #1: 1	أَعْمَى قَوْلُهُ
u'أَعْمَى نَبِيٌّ':Predicate, #1: 1	أَعْمَى مُسَاكَنَةُ
u'أَعْمَى وَجَبٌ':Predicate, #1: 1	أَعْمَى النَّبِيَّ
u'أَعْمَى وَقْتٌ':Predicate, #1: 1	أَعْمَى وَجَبَ
u'أَعْمَى يَوْمٌ':Predicate, #1: 1	أَعْمَى وَقْتَ
u'أَعْوَاضٌ عُرُوضٌ':Added, #1: 1	أَعْمَى يَوْمَ
u'أَعْوَاضٌ مُعَامَلَةٌ':Added, #1: 1	أَعْوَاضِ الْعُرُوضِ
u'أَعْوَانٌ إمَارَةٌ':Added, #1: 1	أَعْوَاضِ الْمُعَامَلَاتِ
u'أَعْوَانٌ إمَامٌ':Added, #1: 1	أَعْوَانِ الْإِمَارَةِ
u'أَعْوَانٌ حُكَّامٌ':Added, #1: 1	أَعْوَانِ الْإِمَامِ
u'أَعْوَانٌ رَجُلٌ':Added, #1: 1	أَعْوَانِ الْحُكَّامِ
u'أَعْوَانٌ رَجُلٌ':Added, #1: 1	أَعْوَانُ الرّجُلِ
u'أَعْوَانٌ زَمانٌ':Added, #1: 1	أَعْوَانُ الرَّجُلِ
u'أَعْوَانٌ سَلاَطِينُ':Added, #1: 1	أَعْوَانِ الزَّمَانِ
u'أَعْوَانٌ سُلْطَانٌ':Added, #1: 1	أَعْوَانُ السَّلَاطِينِ
u'أَعْوَانٌ سُلْطَانٌ':Added, #2: 2	أَعْوَانَ السُّلْطَانِ
u'أَعْوَانٌ سُلْطَانٌ':Added, #3: 3	أَعْوَانُ السُّلْطَانِ
u'أَعْوَانٌ شَيْطَانٌ':Added, #4: 4	أَعْوَانِ السُّلْطَانِ
u'أَعْوَانٌ ظلمة':Added, #1: 1	أَعْوَانَ الشَّيْطَانِ
u'أَعْوَانٌ ظلمة':Added, #3: 3	أَعْوَانُ الظَّلَمَةِ
u'أَعْوَانٌ عَامِلٌ':Added, #4: 4	أَعْوَانِ الظَّلَمَةِ
u'أَعْوَانٌ وُلاَةٌ':Added, #1: 1	أَعْوَانُ الْعَامِلِ
u'أَعْوَرَ أقْرَع':Predicate, #2: 2	أَعْوَانُ الْوُلَاةِ
u'أَعْوَرَ عَبْدٌ':Subject, #1: 1	أَعْوَرَ أَقْرَعَ
u'أَعْوَرَ مَبِيعٌ':Subject, #1: 1	أَعْوَرَ الْعَبْدُ
u'أَعْوَرَ يَمِينٌ':Subject, #1: 1	أَعْوَرَ الْمَبِيعُ
u'أَعْوَزَ اِسْتيفاءٌ':Subject, #1: 1	أَعْوَرَ يَمِينٌ
u'أَعْوَزَ بَيْتٌ':Subject, #1: 1	أَعْوَزَ اسْتِيفَاءُ
u'أَعْوَزَ حَبْرٌ':Subject, #1: 1	أَعْوَزَ بَيْتُ
u'أَعْوَزَ مثل':Predicate, #1: 1	أَعْوَزَ الْحَبْرُ
u'أَعْوَزَ مِثْلٌ':Predicate, #1: 1	أَعْوَزَ الْمِثْلَ
u'أَعْوَزَ مثل':Subject, #1: 1	أَعْوَزَ الْمِثْلَ
u'أَعْوَزَ مِثْلٌ':Subject, #1: 1	أَعْوَزَ الْمِثْلُ
u'أَعْوَزَ وُصُولٌ':Subject, #1: 1	أَعْوَزَ الْمِثْلُ
u'أَعْيَا مُشَاوِرٌ':Subject, #1: 1	أَعْوَزَ الْوُصُولُ
u'أعْيانٌ أَزْواجٌ':Added, #1: 1	أَعْيَا الْمُشَاوِرُ
u'أَعْيَانٌ أَزْواجٌ':Added, #2: 2	أَعْيَانِ الْأَزْوَاجِ
u'أعْيانٌ أَشْهُرٌ':Added, #2: 2	أَعْيَانِ الْأَزْوَاجِ
u'أَعْيَانٌ أَشْهُرٌ':Added, #1: 1	أَعْيَانِ الْأَشْهُرِ
u'أعْيانٌ أَصْحَابٌ':Added, #1: 1	أَعْيَانِ الْأَشْهُرِ
u'أَعْيَانٌ أَصْحَابٌ':Added, #1: 1	أَعْيَانِ الْأَصْحَابِ
u'أعْيانٌ أَعْرَاضٌ':Added, #1: 1	أَعْيَانِ الْأَصْحَابِ
u'أَعْيَانٌ أَعْرَاضٌ':Added, #1: 1	أَعْيَانِ الْأَعْرَاضِ
u'أعْيانٌ أعْيانٌ':Added, #1: 1	أَعْيَانِ الْأَعْرَاضِ
u'أعْيانٌ أَعْيَانٌ':Added, #1: 1	أَعْيَانِ أَعْيَانِ
u'أَعْيَانٌ أعْيانٌ':Added, #1: 1	أَعْيَانِ أَعْيَانِ
u'أَعْيَانٌ أَعْيَانٌ':Added, #1: 1	أَعْيَانِ أَعْيَانِ
u'أعْيانٌ أفاضل':Added, #1: 1	أَعْيَانِ أَعْيَانِ
u'أَعْيَانٌ أفاضل':Added, #1: 1	أَعْيَانِ الْأَفَاضِلِ
u'أعْيانٌ أَمْوَالٌ':Added, #1: 1	أَعْيَانِ الْأَفَاضِلِ
u'أَعْيَانٌ أَمْوَالٌ':Added, #1: 1	أَعْيَانَ الْأَمْوَالِ
u'أعْيانٌ أَمْوَالٌ':Added, #1: 1	أَعْيَانَ الْأَمْوَالِ
u'أَعْيَانٌ أَمْوَالٌ':Added, #1: 1	أَعْيَانِ أَمْوَالٍ
u'أعْيانٌ أَمْوَالٌ':Added, #1: 1	أَعْيَانِ أَمْوَالٍ
u'أعْيانٌ أَمْوَالٌ':Added, #1: 1	أَعْيَانُ أَمْوَالِهِ
u'أَعْيَانٌ أَمْوَالٌ':Added, #1: 1	أَعْيَانِ أَمْوَالِهِ
u'أَعْيَانٌ أَمْوَالٌ':Added, #1: 1	أَعْيَانُ أَمْوَالِهِ
u'أعْيانٌ أَمْوَالٌ':Added, #1: 1	أَعْيَانِ أَمْوَالِهِ
u'أَعْيَانٌ أَمْوَالٌ':Added, #2: 2	أَعْيَانِ الْأَمْوَالِ
u'أعْيانٌ أَمْوَالٌ':Added, #2: 2	أَعْيَانِ الْأَمْوَالِ
u'أَعْيَانٌ أَمْوَالٌ':Added, #3: 3	أَعْيَانِ أَمْوَالِ
u'أعْيانٌ أيتام':Added, #3: 3	أَعْيَانِ أَمْوَالِ
u'أَعْيَانٌ أيتام':Added, #1: 1	أَعْيَانِ الْأَيْتَامِ
u'أعْيانٌ بِدَعٌ':Added, #1: 1	أَعْيَانِ الْأَيْتَامِ
u'أَعْيَانٌ بِدَعٌ':Added, #1: 1	أَعْيَانَ الْبِدَعِ
u'أعْيانٌ بَلَدٌ':Added, #1: 1	أَعْيَانَ الْبِدَعِ
u'أَعْيَانٌ بَلَدٌ':Added, #1: 1	أَعْيَانِ الْبَلَدِ
u'أعْيانٌ تَرِكَةٌ':Added, #1: 1	أَعْيَانِ الْبَلَدِ
u'أَعْيَانٌ تَرِكَةٌ':Added, #10: 10	أَعْيَانِ التَّرِكَةِ
u'أعْيانٌ تَرِكَةٌ':Added, #10: 10	أَعْيَانِ التَّرِكَةِ
u'أَعْيَانٌ تَرِكَةٌ':Added, #2: 2	أَعْيَانُ التَّرِكَةِ
u'أعْيانٌ تَرِكَةٌ':Added, #2: 2	أَعْيَانُ التَّرِكَةِ
u'أَعْيَانٌ تَرِكَةٌ':Added, #3: 3	أَعْيَانَ التَّرِكَةِ
u'أعْيانٌ تُهَمٌ':Added, #3: 3	أَعْيَانَ التَّرِكَةِ
u'أَعْيَانٌ تُهَمٌ':Added, #1: 1	أَعْيَانِ التُّهَمِ
u'أعْيانٌ ثِمارٌ':Added, #1: 1	أَعْيَانِ التُّهَمِ
u'أَعْيَانٌ ثِمارٌ':Added, #1: 1	أَعْيَانِ الثِّمَارِ
u'أعْيانٌ خُصُومٌ':Added, #1: 1	أَعْيَانِ الثِّمَارِ
u'أَعْيَانٌ خُصُومٌ':Added, #1: 1	أَعْيَانِ الْخُصُومِ
u'أعْيانٌ خَيْلٌ':Added, #1: 1	أَعْيَانِ الْخُصُومِ
u'أَعْيَانٌ خَيْلٌ':Added, #1: 1	أَعْيَانِ الْخَيْلِ
u'أعْيانٌ دَرَاهِمُ':Added, #1: 1	أَعْيَانِ الْخَيْلِ
u'أَعْيَانٌ دَرَاهِمُ':Added, #1: 1	أَعْيَانِ الدَّرَاهِمِ
u'أعْيانٌ دَنانيرُ':Added, #1: 1	أَعْيَانِ الدَّرَاهِمِ
u'أَعْيَانٌ دَنانيرُ':Added, #3: 3	أَعْيَانِ الدَّنَانِيرِ
u'أعْيانٌ رَجُلٌ':Added, #3: 3	أَعْيَانِ الدَّنَانِيرِ
u'أَعْيَانٌ رَجُلٌ':Added, #1: 1	أَعْيَانِ رَجُلٍ
u'أعْيانٌ رَقيقٌ':Added, #1: 1	أَعْيَانِ رَجُلٍ
u'أعْيانٌ رَقيق':Added, #4: 4	أَعْيَانِ الرَّقِيقِ
u'أَعْيَانٌ رَقيقٌ':Added, #4: 4	أَعْيَانِ الرَّقِيقِ
u'أَعْيَانٌ رَقيق':Added, #4: 4	أَعْيَانِ الرَّقِيقِ
u'أعْيانٌ رَهْنٌ':Added, #4: 4	أَعْيَانِ الرَّقِيقِ
u'أَعْيَانٌ رَهْنٌ':Added, #2: 2	أَعْيَانِ الرَّهْنِ
u'أعْيانٌ زَوْجٌ':Added, #2: 2	أَعْيَانِ الرَّهْنِ
u'أَعْيَانٌ زَوْجٌ':Added, #1: 1	أَعْيَانَ الزَّوْجَيْنِ
u'أعْيانٌ صَحَابَةٌ':Added, #1: 1	أَعْيَانَ الزَّوْجَيْنِ
u'أعْيانٌ صَحَابَةٌ':Added, #1: 1	أَعْيَانَ الصَّحَابَةِ
u'أَعْيَانٌ صَحَابَةٌ':Added, #1: 1	أَعْيَانِ الصَّحَابَةِ
u'أَعْيَانٌ صَحَابَةٌ':Added, #1: 1	أَعْيَانَ الصَّحَابَةِ
u'أعْيانٌ صَلَوَاتٌ':Added, #1: 1	أَعْيَانِ الصَّحَابَةِ
u'أَعْيَانٌ صَلَوَاتٌ':Added, #1: 1	أَعْيَانُ الصَّلَوَاتِ
u'أعْيانٌ عَدَدٌ':Added, #1: 1	أَعْيَانُ الصَّلَوَاتِ
u'أَعْيَانٌ عَدَدٌ':Added, #1: 1	أَعْيَانُ عَدَدِهِ
u'أعْيانٌ عَصْرٌ':Added, #1: 1	أَعْيَانُ عَدَدِهِ
u'أَعْيَانٌ عَصْرٌ':Added, #1: 1	أَعْيَانُ الْعَصْرِ
u'أعْيانٌ عقاد':Added, #1: 1	أَعْيَانُ الْعَصْرِ
u'أَعْيَانٌ عقاد':Added, #1: 1	أَعْيَانِ الْعِقَادِ
u'أعْيانٌ فقراء':Added, #1: 1	أَعْيَانِ الْعِقَادِ
u'أَعْيَانٌ فقراء':Added, #1: 1	أَعْيَانِ فُقَرَاءِ
u'أعْيانٌ فقهاء':Added, #1: 1	أَعْيَانِ فُقَرَاءِ
u'أَعْيَانٌ فقهاء':Added, #1: 1	أَعْيَانِ فُقَهَاءِ
u'أعْيانٌ فِنَاءٌ':Added, #1: 1	أَعْيَانِ فُقَهَاءِ
u'أَعْيَانٌ فِنَاءٌ':Added, #1: 1	أَعْيَانِ الْفِنَاءِ
u'أعْيانٌ قُرَيْشٌ':Added, #1: 1	أَعْيَانِ الْفِنَاءِ
u'أَعْيَانٌ قُرَيْشٌ':Added, #1: 1	أَعْيَانِ قُرَيْشٍ
u'أعْيانٌ كَسْبٌ':Added, #1: 1	أَعْيَانِ قُرَيْشٍ
u'أَعْيَانٌ كَسْبٌ':Added, #1: 1	أَعْيَانِ كَسْبِهِ
u'أعْيانٌ مَالٌ':Added, #1: 1	أَعْيَانِ كَسْبِهِ
u'أَعْيَانٌ مَالٌ':Added, #18: 18	أَعْيَانِ مَالِهِ
u'أعْيانٌ مَالٌ':Added, #18: 18	أَعْيَانِ مَالِهِ
u'أَعْيَانٌ مَالٌ':Added, #1: 1	أَعْيَان مَالِهِ
u'أعْيانٌ مَالٌ':Added, #1: 1	أَعْيَان مَالِهِ
u'أَعْيَانٌ مَالٌ':Added, #3: 3	أَعْيَانِ مَالِ
u'أعْيانٌ مَالِكٌ':Added, #3: 3	أَعْيَانِ مَالِ
u'أَعْيَانٌ مَالِكٌ':Added, #1: 1	أَعْيَانِ الْمَالِكِ
u'أعْيانٌ مَبِيعٌ':Added, #1: 1	أَعْيَانِ الْمَالِكِ
u'أَعْيَانٌ مَبِيعٌ':Added, #1: 1	أَعْيَانِ الْمَبِيعِ
u'أعْيانٌ مُحَرَّمٌ':Added, #1: 1	أَعْيَانِ الْمَبِيعِ
u'أَعْيَانٌ مُحَرَّمٌ':Added, #1: 1	أَعْيَانِ الْمُحَرَّمَاتِ
u'أعْيانٌ مَخْلُوقٌ':Added, #1: 1	أَعْيَانِ الْمُحَرَّمَاتِ
u'أَعْيَانٌ مَخْلُوقٌ':Added, #1: 1	أَعْيَانِ الْمَخْلُوقَاتِ
u'أعْيانٌ مَسَائِلُ':Added, #1: 1	أَعْيَانِ الْمَخْلُوقَاتِ
u'أَعْيَانٌ مَسَائِلُ':Added, #2: 2	أَعْيَانِ الْمَسَائِلِ
u'أعْيانٌ مَشَايِخُ':Added, #2: 2	أَعْيَانِ الْمَسَائِلِ
u'أَعْيَانٌ مَشَايِخُ':Added, #1: 1	أَعْيَانِ الْمَشَايِخِ
u'أعْيانٌ مَغْصُوب':Added, #1: 1	أَعْيَانِ الْمَشَايِخِ
u'أَعْيَانٌ مَغْصُوب':Added, #1: 1	أَعْيَانِ الْمَغْصُوبَاتِ
u'أعْيانٌ مَلاَئِكَةٌ':Added, #1: 1	أَعْيَانِ الْمَغْصُوبَاتِ
u'أَعْيَانٌ مَلاَئِكَةٌ':Added, #1: 1	أَعْيَانِ الْمَلَائِكَةِ
u'أعْيانٌ مَوَارِيثُ':Added, #1: 1	أَعْيَانِ الْمَلَائِكَةِ
u'أَعْيَانٌ مَوَارِيثُ':Added, #1: 1	أَعْيَانِ الْمَوَارِيثِ
u'أعْيانٌ نَاسٌ':Added, #1: 1	أَعْيَانِ الْمَوَارِيثِ
u'أعْيانٌ نَاسٌ':Added, #1: 1	أَعْيَانَ النَّاسِ
u'أعْيانٌ نَاسٌ':Added, #1: 1	أَعْيَانُ النَّاسِ
u'أَعْيَانٌ نَاسٌ':Added, #1: 1	أَعْيَانِ النَّاسِ
u'أَعْيَانٌ نَاسٌ':Added, #1: 1	أَعْيَانَ النَّاسِ
u'أَعْيَانٌ نَاسٌ':Added, #1: 1	أَعْيَانُ النَّاسِ
u'أعْيانٌ نَجَاسَةٌ':Added, #1: 1	أَعْيَانِ النَّاسِ
u'أَعْيَانٌ نَجَاسَةٌ':Added, #1: 1	أَعْيَانُ النَّجَاسَةِ
u'أعْيانٌ وَارِثٌ':Added, #1: 1	أَعْيَانُ النَّجَاسَةِ
u'أَعْيَانٌ وَارِثٌ':Added, #1: 1	أَعْيَانِ الْوَارِثِ
u'أعْيانٌ وَرَثَةٌ':Added, #1: 1	أَعْيَانِ الْوَارِثِ
u'أَعْيَانٌ وَرَثَةٌ':Added, #1: 1	أَعْيَانَ الْوَرَثَةِ
u'أعْيانٌ وَقْفٌ':Added, #1: 1	أَعْيَانَ الْوَرَثَةِ
u'أَعْيَانٌ وَقْفٌ':Added, #1: 1	أَعْيَانِ الْوَقْفِ
u'أَعْيُنٌ أَرْبَعَةٌ':Added, #1: 1	أَعْيَانِ الْوَقْفِ
u'أَعْيُنٌ أنصار':Added, #1: 1	أَعْيُنٍ أَرْبَعَةٍ
u'أَعْيُنٌ أَنْصارٌ':Added, #1: 1	أَعْيُنِ الأَنْصَارِ
u'أَعْيُنٌ أَنْصَارٌ':Added, #1: 1	أَعْيُنِ الأَنْصَارِ
u'أَعْيُنٌ رُعاَةٌ':Added, #1: 1	أَعْيُنِ الأَنْصَارِ
u'أَعْيُنٌ سُوءٌ':Added, #3: 3	أَعْيُنَ الرُّعَاةِ
u'أَعْيُنٌ عَامٌّ':Added, #1: 1	أَعْيُنَ سُوءٍ
u'أَعْيُنٌ عين':Added, #1: 1	أَعْيُنِ عَامَّةِ
u'أَعْيُنٌ عَيْنٌ':Added, #1: 1	أَعْيُنِ الْعَيْنِ
u'أَعْيُنٌ عَيْن':Added, #1: 1	أَعْيُنِ الْعَيْنِ
u'أَعْيُنٌ كُفَّارٌ':Added, #1: 1	أَعْيُنِ الْعَيْنِ
u'أَعْيُنٌ نَاسٌ':Added, #1: 1	أَعْيُنَ الْكُفّارِ
u'أَعْيُنٌ نَاسٌ':Added, #16: 16	أَعْيُنِ النَّاسِ
u'أَغَارَ إشارَة':Subject, #1: 1	أَعْيُنَ النَّاسِ
u'أَغَارَ إِنْسانٌ':Subject, #1: 1	أَغَارَ إشَارَةٌ
u'أَغَارَ أهْلٌ':Subject, #3: 3	أَغَارَ إنْسَانٌ
u'أَغَارَ ثَعْلَبٌ':Subject, #2: 2	أَغَارَ أَهْلُ
u'أَغَارَ حَبْلٌ':Predicate, #1: 1	أَغَارَ الثَّعْلَبُ
u'أَغَارَ حَديثٌ':Predicate, #2: 2	أَغَارَ الْحَبْلَ
u'أَغَارَ رَجُلٌ':Subject, #1: 1	أَغَارَ الْحَدِيثَ
u'أَغَارَ رَسُولٌ':Subject, #2: 2	أَغَارَ رَجُلٌ
u'أَغَارَ عَدُوٌّ':Subject, #6: 6	أَغَارَ رَسُولُ
u'أَغَارَ قَالٌ':Predicate, #1: 1	أَغَارَ الْعَدُوُّ
u'أَغَارَ قَوْمٌ':Subject, #1: 1	أَغَارَ قَالَ
u'أَغَارَ كُرْزٌ':Subject, #1: 1	أَغَارَ قَوْمٌ
u'أَغَارَ لَفْظٌ':Subject, #1: 1	أَغَارَ كُرْزُ
u'إغَاظَةٌ كُفَّارٌ':Added, #1: 1	أَغَارَ لَفْظُ
u'أَغْبَرَ ثَائِرٌ':Predicate, #1: 1	إغَاظَةِ الْكُفَّارِ
u'أَغْبَرَ قَدَمٌ':Subject, #1: 1	أَغْبَرَ ثَائِرَ
u'أَغْبَرَ مُتَغَيِّرٌ':Predicate, #1: 1	أَغْبَرَ قَدَمَاهُ
u'إغْرَاءٌ حَيَوَانٌ':Added, #1: 1	أَغْبَرَ مُتَغَيِّرَ
u'إغْرَاءٌ حَيَوَانٌ':Added, #1: 1	إغْرَاءُ الْحَيَوَانِ
u'إغْرَاءٌ سَبُعٌ':Added, #2: 2	إغْرَاءِ الْحَيَوَانِ
u'إغْرَاءٌ هِرٌّ':Added, #1: 1	إغْرَاءُ السَّبُعِ
u'أَغْرَاسٌ جَنَّةٌ':Added, #1: 1	إغْرَاءِ الْهِرَّةِ
u'أَغْرَقَ نَزْعٌ':Predicate, #1: 1	أَغْرَاسَ الْجَنَّةِ
u'أَغْرَمَ رَجُلٌ':Predicate, #1: 1	أَغْرَقَ النَّزْعَ
u'أَغْرَمَ رَسُولٌ':Subject, #1: 1	أَغْرَمَ رَجُلاً
u'أَغْرَمَ سَارِقٌ':Predicate, #1: 1	أَغْرَمَ الرَّسُولُ
u'أَغْرَمَ وَرَثَةٌ':Predicate, #1: 1	أَغْرَمَ السَّارِقَ
u'أَغْشَى تَعَصُّبٌ':Subject, #1: 1	أَغْرَمَ الْوَرَثَةَ
u'أَغْضَبَ عُمَرٌ':Predicate, #1: 1	أَغْشَى التَّعَصُّبُ
u'أَغْضَى رَسُولٌ':Subject, #1: 1	أَغْضَبَ عُمَرَ
u'أَغْفَلَ تَأَلُّفٌ':Predicate, #1: 1	أَغْضَى رَسُولُ
u'أَغْفَلَ تَكْبِير':Predicate, #1: 1	أَغْفَلَ تَأَلُّفَ
u'أَغْفَلَ خلق':Subject, #1: 1	أَغْفَلَ تَكْبِيرَةَ
u'أَغْفَلَ خَلْقٌ':Subject, #1: 1	أَغْفَلَ الْخَلْقُ
u'أَغْفَلَ عَالِمٌ':Subject, #1: 1	أَغْفَلَ الْخَلْقُ
u'أَغْفَلَ فقهاء':Subject, #1: 1	أَغْفَلَ الْعَالِمُ
u'أَغْفَلَ قِرَاءةٌ':Predicate, #1: 1	أَغْفَلَ الْفُقَهَاءُ
u'أَغْفَى رَسُولٌ':Subject, #1: 1	أَغْفَلَ قِرَاءَةَ
u'أَغْلَظَ إمَامٌ':Subject, #1: 1	أَغْفَى رَسُولُ
u'أَغْلَظَ إمَامٌ':Subject, #1: 1	أَغْلَظَ الْإِمَامُ
u'أَغْلَظَ رَجُلٌ':Subject, #1: 1	أَغْلَظَ إمَامُ
u'أَغْلَقَ أَبْوَابٌ':Predicate, #1: 1	أَغْلَظَ رَجُلٌ
u'أَغْلَقَ بَابٌ':Predicate, #1: 1	أَغْلَقَ أَبْوَابَ
u'أَغْلَقَ بَابٌ':Predicate, #17: 17	أَغْلَقَ الْبَابَ
u'أَغْلَى أَرْبَعَةٌ':Predicate, #3: 3	أَغْلَقَ بَابَ
u'أَغْلَى بالِغٌ':Predicate, #1: 1	أَغْلَى أَرْبَعَةَ
u'أَغْلَى غَاصِبٌ':Subject, #1: 1	أَغْلَى بَالِغِينَ
u'أغمار عَوَامُّ':Added, #1: 1	أَغْلَى الْغَاصِبُ
u'أَغْمارٌ عَوَامُّ':Added, #1: 1	أَغْمَارُ الْعَوَامِّ
u'أَغْمَارٌ عَوَامُّ':Added, #1: 1	أَغْمَارُ الْعَوَامِّ
u'إغْنَاءٌ فقراء':Added, #1: 1	أَغْمَارُ الْعَوَامِّ
u'إغْنَاءٌ فَقِيرٌ':Added, #1: 1	إغْنَاءُ الْفُقَرَاءِ
u'إغْنَاءٌ مُحْتَاجٌ':Added, #5: 5	إغْنَاءُ الْفَقِيرِ
u'إغْنَاءٌ مُرَادِفٌ':Added, #3: 3	إغْنَاءُ الْمُحْتَاجِ
u'إغْنَاءٌ مِلْحَفَةٌ':Added, #1: 1	إغْنَاءُ الْمُرَادِفِ
u'إغْنَاءٌ وَرَثَةٌ':Added, #1: 1	إغْنَاءُ الْمِلْحَفَةِ
u'أَغْنَى ثَانِي':Predicate, #1: 1	إغْنَاءِ وَرَثَةِ
u'أَغْنَى سَواءٌ':Subject, #1: 1	أَغْنَى الثَّانِيَ
u'أَغْنَى فِعْلٌ':Subject, #1: 1	أَغْنَى سَوَاءٌ
u'أَفَاءَ قَسَمٌ':Predicate, #1: 1	أَغْنَى فِعْلُهُ
u'أَفَادَ آخِرُ':Predicate, #2: 2	أَفَاءَ قَسَمَ
u'أَفَادَ آخِرَةٌ':Predicate, #1: 1	أَفَادَ آخِرَ
u'أَفَادَ إِرَادَةٌ':Predicate, #1: 1	أَفَادَ الْآخِرَةَ
u'أَفَادَ اِسْتِثْنَاءٌ':Subject, #1: 1	أَفَادَ إرَادَةَ
u'أَفَادَ اِشْتِراطٌ':Predicate, #1: 1	أَفَادَ اسْتِثْنَاءُ
u'أَفَادَ ألف':Predicate, #2: 2	أَفَادَ اشْتِرَاطَ
u'أَفَادَ ألْفٌ':Predicate, #1: 1	أَفَادَ أَلْفَ
u'أَفَادَ أَلْفٌ':Predicate, #1: 1	أَفَادَ أَلْفَ
u'أَفَادَ أَمْرٌ':Subject, #1: 1	أَفَادَ أَلْفَ
u'أَفَادَ أَمْنٌ':Predicate, #1: 1	أَفَادَ الْأَمْرُ
u'أَفَادَ بَدَلٌ':Predicate, #1: 1	أَفَادَ الْأَمْنَ
u'أَفَادَ بَيَانٌ':Predicate, #1: 1	أَفَادَ الْبَدَلَ
u'إفَادَةٌ إبَاحَةٌ':Added, #1: 1	أَفَادَ بَيَانَ
u'إفَادَةٌ إِبْطَالٌ':Added, #2: 2	إفَادَةِ الْإِبَاحَةِ
u'إفَادَةٌ أحَدٌ':Added, #1: 1	إفَادَةِ إبْطَالِ
u'إفَادَةٌ أَحْكَامٌ':Added, #1: 1	إفَادَةِ أَحَدِ
u'إفَادَةٌ أَحْكَامٌ':Added, #1: 1	إفَادَةُ الْأَحْكَامِ
u'إفَادَةٌ إِرَادَةٌ':Added, #1: 1	إفَادَةِ الْأَحْكَامِ
u'إفَادَةٌ إِسْنادٌ':Added, #1: 1	إفَادَةِ إرَادَةِ
u'إفَادَةٌ اِعْتِبارٌ':Added, #1: 1	إفَادَةَ إسْنَادِ
u'إفَادَةٌ أَفْعَالٌ':Added, #1: 1	إفَادَةَ اعْتِبَارِ
u'إفَادَةٌ أَلْفَاظٌ':Added, #1: 1	إفَادَةُ الْأَفْعَالِ
u'إفَادَةٌ أمَانٌ':Added, #1: 1	إفَادَةِ الْأَلْفَاظِ
u'إفَادَةٌ آيَةٌ':Added, #1: 1	إفَادَةِ الْأَمَانِ
u'إفَادَةٌ آيَةٌ':Added, #1: 1	إفَادَةَ الْآيَةِ
u'إفَادَةٌ بِشْرٌ':Added, #1: 1	إفَادَةِ الْآيَةِ
u'إفَادَةٌ بَصيرٌ':Added, #1: 1	إفَادَةُ الْبِشْرِ
u'إفَادَةٌ بَصيرَةٌ':Added, #4: 4	إفَادَةِ الْبَصِيرَةِ
u'إفَادَةٌ بَقاءٌ':Added, #4: 4	إفَادَةِ الْبَصِيرَةِ
u'إفَادَةٌ بَيَانٌ':Added, #1: 1	إفَادَةِ بَقَاءِ
u'إفَادَةٌ بَيْعٌ':Added, #1: 1	إفَادَةِ الْبَيَانِ
u'إفَادَةٌ تَحَجُّرٌ':Added, #1: 1	إفَادَةِ الْبَيْعِ
u'إفَادَةٌ تَحْرِيمٌ':Added, #1: 1	إفَادَةُ التَّحَجُّرِ
u'إفَادَةٌ تَحْلِيلٌ':Added, #1: 1	إفَادَةِ التَّحْرِيمِ
u'إفَادَةٌ تَخْمِين':Added, #1: 1	إفَادَةِ التَّحْلِيلِ
u'إفَادَةٌ تَعْلِيقٌ':Added, #1: 1	إفَادَةِ التَّخْمِينِ
u'إفَادَةٌ تَعْلِيمٌ':Added, #1: 1	إفَادَةِ تَعْلِيقِ
u'إفَادَةٌ تَكْرارٌ':Added, #1: 1	إفَادَةُ تَعْلِيمِ
u'إفَادَةٌ تمام':Added, #1: 1	إفَادَةِ التَّكْرَارِ
u'إفَادَةٌ تَمامٌ':Added, #1: 1	إفَادَةِ تَمَامِ
u'إفَادَةٌ تَمْلِيك':Added, #1: 1	إفَادَةِ تَمَامِ
u'إفَادَةٌ ثُبُوتٌ':Added, #1: 1	إفَادَةُ التَّمْلِيكِ
u'إفَادَةٌ جَزَاءٌ':Added, #1: 1	إفَادَةِ ثُبُوتِ
u'إفَادَةٌ جُمُوعٌ':Added, #1: 1	إفَادَةَ جَزَاءِ
u'إفَادَةٌ جِنْسٌ':Added, #1: 1	إفَادَةَ الْجُمُوعِ
u'إفَادَةٌ حُرِّيَّةٌ':Added, #1: 1	إفَادَةَ جِنْسِهِ
u'إفَادَةٌ حَصْرٌ':Added, #1: 1	إفَادَةِ الْحُرِّيَّةِ
u'إفَادَةٌ حَصْرٌ':Added, #1: 1	إفَادَةُ الْحَصْرِ
u'إفَادَةٌ حَقِيقٌ':Added, #1: 1	إفَادَةِ الْحَصْرِ
u'إفَادَةٌ حَقِيقَةٌ':Added, #3: 3	إفَادَةِ حَقِيقَةِ
u'إفَادَةٌ حُكْمٌ':Added, #3: 3	إفَادَةِ حَقِيقَةِ
u'إفَادَةٌ حُكْمٌ':Added, #1: 1	إفَادَةُ الْحُكْمِ
u'إفَادَةٌ حُكْمٌ':Added, #1: 1	إفَادَةُ حُكْمٍ
u'إفَادَةٌ حُكْمٌ':Added, #1: 1	إفَادَةِ حُكْمِ
u'إفَادَةٌ حُكْمٌ':Added, #1: 1	إفَادَةِ حُكْمِهِ
u'إفَادَةٌ حَيَاةٌ':Added, #7: 7	إفَادَةِ الْحُكْمِ
u'إفَادَةٌ خَبَرٌ':Added, #1: 1	إفَادَةِ الْحَيَاةِ
u'إفَادَةٌ خَبَر':Added, #1: 1	إفَادَةُ الْخَبَرِ
u'إفَادَةٌ خَبَرٌ':Added, #1: 1	إفَادَةُ الْخَبَرِ
u'إفَادَةٌ خَبَر':Added, #1: 1	إفَادَةُ خَبَرِ
u'إفَادَةٌ دَليلٌ':Added, #1: 1	إفَادَةُ خَبَرِ
u'إفَادَةٌ دَوَرانٌ':Added, #1: 1	إفَادَةَ الدَّلِيلِ
u'إفَادَةٌ دَوَرانٌ':Added, #1: 1	إفَادَةُ الدَّوَرَانِ
u'إفَادَةٌ شَارِعٌ':Added, #2: 2	إفَادَةِ الدَّوَرَانِ
u'إفَادَةٌ صِحَّةٌ':Added, #1: 1	إفَادَةُ الشَّارِعِ
u'إفَادَةٌ صَحِيحٌ':Added, #1: 1	إفَادَةُ صِحَّةِ
u'إفَادَةٌ ضِدٌّ':Added, #1: 1	إفَادَةَ الصَّحِيحِ
u'إفَادَةٌ ضَمٌّ':Added, #1: 1	إفَادَةِ ضِدَّيْنِ
u'إفَادَةٌ ضَمِيرٌ':Added, #1: 1	إفَادَةِ ضَمِّ
u'إفَادَةٌ ظَنٌّ':Added, #1: 1	إفَادَةُ ضَمِيرِ
u'إفَادَةٌ ظَنٌّ':Added, #1: 1	إفَادَةَ الظَّنِّ
u'إفَادَةٌ عتق':Added, #4: 4	إفَادَةِ الظَّنِّ
u'إفَادَةٌ عِتْقٌ':Added, #1: 1	إفَادَةِ الْعِتْقِ
u'إفَادَةٌ عَدَدٌ':Added, #1: 1	إفَادَةِ الْعِتْقِ
u'إفَادَةٌ عَدَمٌ':Added, #1: 1	إفَادَةِ عَدَدٍ
u'إفَادَةٌ عِصْمَةٌ':Added, #2: 2	إفَادَةُ عَدَمِ
u'إفَادَةٌ علم':Added, #1: 1	إفَادَةِ الْعِصْمَةِ
u'إفَادَةٌ علم':Added, #1: 1	إفَادَةَ الْعِلْمِ
u'إفَادَةٌ عِلْمٌ':Added, #1: 1	إفَادَةُ الْعِلْمِ
u'إفَادَةٌ عِلْمٌ':Added, #1: 1	إفَادَةَ الْعِلْمِ
u'إفَادَةٌ علم':Added, #1: 1	إفَادَةُ الْعِلْمِ
u'إفَادَةٌ عِلْمٌ':Added, #1: 1	إفَادَةَ عِلْمِهِ
u'إفَادَةٌ علم':Added, #1: 1	إفَادَةَ عِلْمِهِ
u'إفَادَةٌ عِلْمٌ':Added, #3: 3	إفَادَةِ الْعِلْمِ
u'إفَادَةٌ عِلِّيٌّ':Added, #3: 3	إفَادَةِ الْعِلْمِ
u'إفَادَةٌ عُمُومٌ':Added, #2: 2	إفَادَةِ الْعِلِّيَّةِ
u'إفَادَةٌ عُمُومٌ':Added, #1: 1	إفَادَةَ الْعُمُومِ
u'إفَادَةٌ عُمُومٌ':Added, #1: 1	إفَادَةِ الْعُمُومِ
u'إفَادَةٌ غير':Added, #2: 2	إفَادَةُ الْعُمُومِ
u'إفَادَةٌ غَيْرٌ':Added, #1: 1	إفَادَةُ غَيْرِ
u'إفَادَةٌ فَرْض':Added, #1: 1	إفَادَةُ غَيْرِ
u'إفَادَةٌ فَرْضِيّ':Added, #1: 1	إفَادَةِ الْفَرْضِيَّةِ
u'إفَادَةٌ فَرْضِيَّة':Added, #1: 1	إفَادَةِ الْفَرْضِيَّةِ
u'إفَادَةٌ فُرْقَةٌ':Added, #1: 1	إفَادَةِ الْفَرْضِيَّةِ
u'إفَادَةٌ قرائن':Added, #1: 1	إفَادَةِ الْفُرْقَةِ
u'إفَادَةٌ قرائن':Added, #1: 1	إفَادَةَ الْقَرَائِنِ
u'إفَادَةٌ قَطْعٌ':Added, #1: 1	إفَادَةِ الْقَرَائِنِ
u'إفَادَةٌ قُوَّةٌ':Added, #1: 1	إفَادَةِ الْقَطْعِ
u'إفَادَةٌ قُوَّة':Added, #1: 1	إفَادَةِ قُوَّةٍ
u'إفَادَةٌ كَوْنٌ':Added, #1: 1	إفَادَةِ قُوَّةٍ
u'إفَادَةٌ لاَمٌ':Added, #1: 1	إفَادَةِ كَوْنِهِ
u'إفَادَةٌ لاَمٌ':Added, #1: 1	إفَادَةَ اللَّامِ
u'إفَادَةٌ لَفْظٌ':Added, #1: 1	إفَادَةِ لَامِ
u'إفَادَةٌ مَالِكٌ':Added, #1: 1	إفَادَةِ لَفْظٍ
u'إفَادَةٌ مثل':Added, #1: 1	إفَادَةِ الْمَالِكِ
u'إفَادَةٌ مِثْلٌ':Added, #2: 2	إفَادَةِ مِثْلِ
u'إفَادَةٌ مُجَرَّدٌ':Added, #2: 2	إفَادَةِ مِثْلِ
u'إفَادَةٌ مراد':Added, #1: 1	إفَادَةُ مُجَرَّدِ
u'إفَادَةٌ مُرَادٌ':Added, #1: 1	إفَادَةِ مُرَادِهِ
u'إفَادَةٌ مراد':Added, #1: 1	إفَادَةِ مُرَادِهِ
u'إفَادَةٌ مُرَادٌ':Added, #2: 2	إفَادَةِ الْمُرَادِ
u'إفَادَةٌ مَرْتَبَةٌ':Added, #2: 2	إفَادَةِ الْمُرَادِ
u'إفَادَةٌ مُسْتَفِيضٌ':Added, #1: 1	إفَادَةُ مَرْتَبَتِهِ
u'إفَادَةٌ مَصْدَرٌ':Added, #1: 1	إفَادَةُ الْمُسْتَفِيضِ
u'إفَادَةٌ مَطْلُوبٌ':Added, #1: 1	إفَادَةُ الْمَصْدَرِ
u'إفَادَةٌ مَعْنًى':Added, #2: 2	إفَادَةِ الْمَطْلُوبِ
u'إفَادَةٌ مِلْكٌ':Added, #2: 2	إفَادَةِ الْمَعْنَيَيْنِ
u'إفَادَةٌ مِلْكٌ':Added, #1: 1	إفَادَةُ الْمِلْكِ
u'إفَادَةٌ مُوَاظَبَةٌ':Added, #7: 7	إفَادَةِ الْمِلْكِ
u'إفَادَةٌ نَسَبٌ':Added, #1: 1	إفَادَةُ الْمُوَاظَبَةِ
u'إفَادَةٌ نِسْبَةٌ':Added, #1: 1	إفَادَةِ النَّسَبِ
u'إفَادَةٌ نَظَافَةٌ':Added, #2: 2	إفَادَةُ النِّسْبَةِ
u'إفَادَةٌ نَفْيٌ':Added, #1: 1	إفَادَةِ النَّظَافَةِ
u'إفَادَةٌ نَفْيٌ':Added, #1: 1	إفَادَةُ النَّفْيِ
u'إفَادَةٌ نَفْيٌ':Added, #1: 1	إفَادَةِ النَّفْيِ
u'إفَادَةٌ وَجْهٌ':Added, #2: 2	إفَادَةِ نَفْيِ
u'إفَادَةٌ وُجُوبٌ':Added, #1: 1	إفَادَةِ وَجْهِ
u'إفَادَةٌ وُجُوبٌ':Added, #1: 1	إفَادَةِ وُجُوبِهِ
u'إفَادَةٌ وَصْفٌ':Added, #2: 2	إفَادَةِ الْوُجُوبِ
u'إفَادَةٌ وَصْفٌ':Added, #1: 1	إفَادَةِ الْوَصْفِ
u'إفَادَةٌ وُقُوعٌ':Added, #1: 1	إفَادَةَ وَصْفٍ
u'إفَادَةٌ وُقُوعٌ':Added, #1: 1	إفَادَةُ وُقُوعِ
u'إفَادَةٌ وِلاَيَةٌ':Added, #1: 1	إفَادَةِ وُقُوعِ
u'إفَادَةٌ وِلاَيَةٌ':Added, #1: 1	إفَادَةِ الْوِلَايَةِ
u'إفَادَةٌ ولد':Added, #1: 1	إفَادَةِ وِلَايَةِ
u'إفَادَةٌ وَلَدٌ':Added, #1: 1	إفَادَةِ وَلَدِ
u'أَفَادَ تَأْخِيرٌ':Predicate, #1: 1	إفَادَةِ وَلَدِ
u'أَفَادَ تَأْكِيدٌ':Predicate, #1: 1	أَفَادَ تَأْخِيرَ
u'أَفَادَ تَحْرِيمٌ':Predicate, #1: 1	أَفَادَ تَأْكِيدَ
u'أَفَادَ تَخْيِيرٌ':Predicate, #1: 1	أَفَادَ التَّحْرِيمَ
u'أَفَادَ تَذْكِرَةٌ':Predicate, #1: 1	أَفَادَ التَّخْيِيرَ
u'أَفَادَ تَصْرِيحٌ':Predicate, #1: 1	أَفَادَ تَذْكِرَةَ
u'أَفَادَ تَعْبِيرٌ':Subject, #1: 1	أَفَادَ التَّصْرِيحَ
u'أَفَادَ تَفْرِقَة':Predicate, #1: 1	أَفَادَ تَعْبِيرُهُ
u'أَفَادَ تَقْديمٌ':Subject, #1: 1	أَفَادَ التَّفْرِقَةَ
u'أَفَادَ تَقْيِيد':Subject, #1: 1	أَفَادَ التَّقْدِيمُ
u'أَفَادَ تَكْريرٌ':Subject, #1: 1	أَفَادَ التَّقْيِيدُ
u'أَفَادَ تَكْميلٌ':Predicate, #1: 1	أَفَادَ التَّكْرِيرُ
u'أَفَادَ ثَلاثُ':Predicate, #1: 1	أَفَادَ التَّكْمِيلَ
u'أَفَادَ ثَلاثَةٌ':Predicate, #1: 1	أَفَادَ الثَّلَاثَ
u'أَفَادَ جماع':Predicate, #1: 1	أَفَادَ ثَلَاثَةَ
u'أَفَادَ جِمَاعٌ':Predicate, #1: 1	أَفَادَ الْجِمَاعَ
u'أَفَادَ جَوَازٌ':Predicate, #1: 1	أَفَادَ الْجِمَاعَ
u'أَفَادَ جَوَازٌ':Predicate, #1: 1	أَفَادَ الْجَوَازَ
u'أَفَادَ حَدَثٌ':Predicate, #1: 1	أَفَادَ جَوَازَ
u'أَفَادَ حَديثٌ':Subject, #1: 1	أَفَادَ الْحَدَثَ
u'أَفَادَ حُرْمَةٌ':Predicate, #1: 1	أَفَادَ الْحَدِيثُ
u'أَفَادَ حُرِّيَّةٌ':Predicate, #2: 2	أَفَادَ حُرْمَةَ
u'أَفَادَ حَصْرٌ':Predicate, #1: 1	أَفَادَ حُرِّيَّةَ
u'أَفَادَ حُصُول':Predicate, #2: 2	أَفَادَ الْحَصْرَ
u'أَفَادَ حُكْمٌ':Predicate, #1: 1	أَفَادَ حُصُولَ
u'أَفَادَ خَبَرٌ':Subject, #3: 3	أَفَادَ الْحُكْمَ
u'أَفَادَ خَبَر':Subject, #1: 1	أَفَادَ الْخَبَرُ
u'أَفَادَ خَمْسَةٌ':Predicate, #1: 1	أَفَادَ الْخَبَرُ
u'أَفَادَ دُخُولٌ':Predicate, #2: 2	أَفَادَ خَمْسَةَ
u'أَفَادَ دفع':Predicate, #1: 1	أَفَادَ دُخُولَ
u'أَفَادَ دَفْعٌ':Predicate, #1: 1	أَفَادَ دَفْعَ
u'أَفَادَ رَجُلٌ':Subject, #1: 1	أَفَادَ دَفْعَ
u'أَفَادَ سُنِّيٌّ':Predicate, #2: 2	أَفَادَ رَجُلٌ
u'أَفَادَ سَيِّدٌ':Subject, #2: 2	أَفَادَ سُنِّيَّةَ
u'أَفَادَ شَارِحٌ':Subject, #1: 1	أَفَادَ السَّيِّدُ
u'أَفَادَ شَخْصٌ':Predicate, #1: 1	أَفَادَ الشَّارِحُ
u'أَفَادَ شَيْخٌ':Subject, #1: 1	أَفَادَ الشَّخْصَ
u'أَفَادَ صِحَّةٌ':Predicate, #2: 2	أَفَادَ شَيْخُ
u'أَفَادَ صَرِيحٌ':Subject, #2: 2	أَفَادَ صِحَّةَ
u'أَفَادَ ظَنٌّ':Predicate, #1: 1	أَفَادَ صَرِيحُ
u'أَفَادَ عَالِمٌ':Subject, #1: 1	أَفَادَ الظَّنَّ
u'أَفَادَ عَدَمٌ':Predicate, #1: 1	أَفَادَ الْعَالِمُ
u'أَفَادَ علم':Predicate, #2: 2	أَفَادَ عَدَمَ
u'أَفَادَ عِلْمٌ':Predicate, #7: 7	أَفَادَ الْعِلْمَ
u'أَفَادَ علم':Subject, #7: 7	أَفَادَ الْعِلْمَ
u'أَفَادَ عِلْمٌ':Subject, #1: 1	أَفَادَ الْعِلْمُ
u'أَفَادَ عِلِّيٌّ':Predicate, #1: 1	أَفَادَ الْعِلْمُ
u'أَفَادَ عُمُومٌ':Predicate, #1: 1	أَفَادَ الْعِلِّيَّةَ
u'أَفَادَ عُمُومٌ':Predicate, #1: 1	أَفَادَ عُمُومَ
u'أَفَادَ فَرْض':Predicate, #2: 2	أَفَادَ الْعُمُومَ
u'أَفَادَ فَرْضِيّ':Predicate, #2: 2	أَفَادَ الْفَرْضِيَّةَ
u'أَفَادَ فَرْضِيَّة':Predicate, #2: 2	أَفَادَ الْفَرْضِيَّةَ
u'أَفَادَ فرق':Predicate, #2: 2	أَفَادَ الْفَرْضِيَّةَ
u'أَفَادَ فَرْقٌ':Predicate, #2: 2	أَفَادَ الْفَرْقَ
u'أَفَادَ فُرْقَةٌ':Predicate, #2: 2	أَفَادَ الْفَرْقَ
u'أَفَادَ فلان':Subject, #1: 1	أَفَادَ الْفُرْقَةَ
u'أَفَادَ فلان':Subject, #1: 1	أَفَادَ الْقُرْطُبِيُّ
u'أَفَادَ قُرْطُبِيّ':Subject, #1: 1	أَفَادَ النَّاشِرِيُّ
u'أَفَادَ قَضَاءٌ':Predicate, #1: 1	أَفَادَ الْقُرْطُبِيُّ
u'أَفَادَ قَطْعٌ':Predicate, #1: 1	أَفَادَ الْقَضَاءَ
u'أَفَادَ قول':Subject, #2: 2	أَفَادَ الْقَطْعَ
u'أَفَادَ قَوْلٌ':Subject, #1: 1	أَفَادَ قَوْلُ
u'أَفَادَ قول':Subject, #1: 1	أَفَادَ قَوْلُ
u'أَفَادَ قَوْلٌ':Subject, #3: 3	أَفَادَ قَوْلُهُ
u'أَفَادَ كَرَاهَةٌ':Predicate, #3: 3	أَفَادَ قَوْلُهُ
u'أَفَادَ كَفَّارٌ':Predicate, #1: 1	أَفَادَ كَرَاهَةَ
u'أَفَادَ كَفَّارَةٌ':Predicate, #1: 1	أَفَادَ الْكَفَّارَةَ
u'أَفَادَ كَلاَمٌ':Subject, #1: 1	أَفَادَ الْكَفَّارَةَ
u'أَفَادَ كَلاَمٌ':Subject, #1: 1	أَفَادَ الْكَلَامُ
u'أَفَادَ كَلاَمٌ':Subject, #3: 3	أَفَادَ كَلَامُ
u'أَفَادَ كَوْنٌ':Predicate, #4: 4	أَفَادَ كَلَامُهُ
u'أَفَادَ لَفْظٌ':Subject, #2: 2	أَفَادَ كَوْنَ
u'أَفَادَ لَمْسٌ':Predicate, #1: 1	أَفَادَ اللَّفْظُ
u'أَفَادَ مَالٌ':Predicate, #1: 1	أَفَادَ اللَّمْسَ
u'أَفَادَ مُخَالَفَةٌ':Predicate, #1: 1	أَفَادَ الْمَالَ
u'أَفَادَ مَسْحٌ':Predicate, #1: 1	أَفَادَ الْمُخَالَفَةَ
u'أَفَادَ مُصَنِّفٌ':Subject, #1: 1	أَفَادَ مَسْحَ
u'أَفَادَ مِلْكٌ':Predicate, #9: 9	أَفَادَ الْمُصَنِّفُ
u'أَفَادَ مُنَاسَبَةٌ':Predicate, #5: 5	أَفَادَ الْمِلْكَ
u'أَفَادَ مَنْعٌ':Predicate, #1: 1	أَفَادَ الْمُنَاسَبَةَ
u'أَفَادَ نَفْيٌ':Predicate, #1: 1	أَفَادَ مَنْعَ
u'أَفَادَ نَهْيٌ':Subject, #2: 2	أَفَادَ نَفْيَ
u'أَفَادَ نَوَوِيٌّ':Subject, #1: 1	أَفَادَ النَّهْيُ
u'أَفَادَ وُجُوبٌ':Predicate, #1: 1	أَفَادَ النَّوَوِيُّ
u'أَفَادَ وُجُوبٌ':Predicate, #2: 2	أَفَادَ وُجُوبَ
u'أَفَادَ وَضْعٌ':Predicate, #4: 4	أَفَادَ الْوُجُوبَ
u'أَفَادَ وُقُوعٌ':Predicate, #1: 1	أَفَادَ وَضْعَ
u'أَفَاضَ إمَامٌ':Subject, #1: 1	أَفَادَ الْوُقُوعَ
u'إِفَاضَةٌ مَاءٌ':Added, #7: 7	أَفَاضَ الْإِمَامُ
u'أَفَاضَ رَسُولٌ':Subject, #1: 1	إِفَاضَةِ الْمَاءِ
u'أَفَاضَ قَالٌ':Predicate, #14: 14	أَفَاضَ رَسُولُ
u'أَفَاضَ قَوْمٌ':Subject, #1: 1	أَفَاضَ قَالَ
u'أَفَاضَ مَاءٌ':Predicate, #1: 1	أَفَاضَ الْقَوْمُ
u'أَفَاضَ مُصَنِّفٌ':Subject, #2: 2	أَفَاضَ الْمَاءَ
u'أَفَاضَ نَاسٌ':Subject, #1: 1	أَفَاضَ الْمُصَنِّفُ
u'أَفَاضَ نَاسٌ':Subject, #1: 1	أَفَاضَ النّاسُ
u'أَفَاضَ نَبِيٌّ':Subject, #9: 9	أَفَاضَ النَّاسُ
u'أَفَاضَ يَوْمٌ':Predicate, #2: 2	أَفَاضَ النَّبِيُّ
u'أَفَاقَ أَبٌ':Subject, #3: 3	أَفَاضَ يَوْمَ
u'أَفَاقَ آخِرُ':Predicate, #1: 1	أَفَاقَ الْأَبُ
u'أَفَاقَ أَكْثَرُ':Predicate, #1: 1	أَفَاقَ آخِرَ
u'أَفَاقَ إمَامٌ':Subject, #2: 2	أَفَاقَ أَكْثَرَ
u'أَفَاقَ بَعْضٌ':Predicate, #1: 1	أَفَاقَ الْإِمَامُ
u'أَفَاقَ رَسُولٌ':Subject, #1: 1	أَفَاقَ بَعْضَ
u'أَفَاقَ سَكْرَان':Subject, #1: 1	أَفَاقَ رَسُولُ
u'أَفَاقَ عند':Predicate, #1: 1	أَفَاقَ السَّكْرَانُ
u'أَفَاقَ قَالٌ':Predicate, #1: 1	أَفَاقَ عِنْدَ
u'أَفَاقَ لَحْظ':Predicate, #5: 5	أَفَاقَ قَالَ
u'أَفَاقَ لَيْلٌ':Predicate, #1: 1	أَفَاقَ لَحْظَةً
u'أَفَاقَ مَجْنُونٌ':Subject, #1: 1	أَفَاقَ لَيْلَةً
u'أَفَاقَ مَجْنُونٌ':Subject, #19: 19	أَفَاقَ الْمَجْنُونُ
u'أَفَاقَ مَرِيضٌ':Subject, #4: 4	أَفَاقَ مَجْنُونٌ
u'أَفَاقَ مَعْتُوهٌ':Subject, #4: 4	أَفَاقَ الْمَرِيضُ
u'أَفَاقَ وَصِيٌّ':Subject, #1: 1	أَفَاقَ الْمَعْتُوهُ
u'إفْتَاءٌ اِبْنٌ':Added, #2: 2	أَفَاقَ الْوَصِيُّ
u'إفْتَاءٌ اِبْنٌ':Added, #2: 2	إفْتَاءَ ابْنِ
u'إفْتَاءٌ اِبْنٌ':Added, #3: 3	إفْتَاءِ ابْنِ
u'إفْتَاءٌ أخرَس':Added, #4: 4	إفْتَاءُ ابْنِ
u'إفْتَاءٌ أكابر':Added, #1: 1	إفْتَاءُ الْأَخْرَسِ
u'إفْتَاءٌ أَوَّلُ':Added, #1: 1	إفْتَاءُ الْأَكَابِرِ
u'إفْتَاءٌ بَعْضٌ':Added, #1: 1	إفْتَاءُ الْأَوَّلِ
u'إفْتَاءٌ بَعْضٌ':Added, #1: 1	إفْتَاءِ بَعْضِ
u'إفْتَاءٌ تَاجٌ':Added, #2: 2	إفْتَاءُ بَعْضِ
u'إفْتَاءٌ جَلاَلٌ':Added, #1: 1	إفْتَاءُ التَّاجِ
u'إفْتَاءٌ شرف':Added, #1: 1	إفْتَاءُ الْجَلَالِ
u'إفْتَاءٌ شَرَفٌ':Added, #2: 2	إفْتَاءُ الشَّرَفِ
u'إفْتَاءٌ شَيْخٌ':Added, #2: 2	إفْتَاءُ الشَّرَفِ
u'إفْتَاءٌ شَيْخٌ':Added, #1: 1	إفْتَاءِ الشَّيْخِ
u'إفْتَاءٌ شَيْخٌ':Added, #1: 1	إفْتَاءِ شَيْخِهِ
u'إفْتَاءٌ عِزٌّ':Added, #2: 2	إفْتَاءَ الشَّيْخِ
u'إفْتَاءٌ غير':Added, #1: 1	إفْتَاءُ الْعِزِّ
u'إفْتَاءٌ غَيْرٌ':Added, #2: 2	إفْتَاءِ غَيْرِ
u'إفْتَاءٌ مُقَلِّدٌ':Added, #2: 2	إفْتَاءِ غَيْرِ
u'إفْتَاءٌ مُقَلِّدٌ':Added, #1: 1	إفْتَاءُ مُقَلِّدٍ
u'إفْتَاءٌ نَاسٌ':Added, #2: 2	إفْتَاءِ الْمُقَلِّدِ
u'إفْتَاءٌ نَوَوِيٌّ':Added, #1: 1	إفْتَاءُ النَّاسِ
u'إفْتَاءٌ وَالِدٌ':Added, #1: 1	إفْتَاءُ النَّوَوِيِّ
u'إفْتَاءٌ وَالِدٌ':Added, #1: 1	إفْتَاءُ الْوَالِدِ
u'إفْتَاءٌ وَلِيٌّ':Added, #1: 1	إفْتَاءُ وَالِدٍ
u'أَفْتَى إبْلِيسُ':Subject, #1: 1	إفْتَاءُ الْوَلِيِّ
u'أَفْتَى اِبْنٌ':Subject, #1: 1	أَفْتَى إِبْلِيسُ
u'أَفْتَى أحَدٌ':Subject, #70: 70	أَفْتَى ابْنُ
u'أَفْتَى أَشْيَاخٌ':Subject, #1: 1	أَفْتَى أَحَدٌ
u'أَفْتَى أكابر':Subject, #1: 1	أَفْتَى الْأَشْيَاخُ
u'أَفْتَى إمَامٌ':Subject, #1: 1	أَفْتَى أَكَابِرُ
u'أَفْتَى أهْلٌ':Subject, #13: 13	أَفْتَى الْإِمَامُ
u'أَفْتَى أئِمَّةٌ':Subject, #1: 1	أَفْتَى أَهْلُ
u'أَفْتَى بُرْهانٌ':Subject, #2: 2	أَفْتَى أَئِمَّةُ
u'أَفْتَى بُرْهَانٌ':Subject, #2: 2	أَفْتَى بُرْهَانُ
u'أَفْتَى بُرْهانٌ':Subject, #2: 2	أَفْتَى بُرْهَانُ
u'أَفْتَى بُرْهَانٌ':Subject, #3: 3	أَفْتَى الْبُرْهَانُ
u'أَفْتَى بَعْضٌ':Predicate, #3: 3	أَفْتَى الْبُرْهَانُ
u'أَفْتَى بَعْضٌ':Subject, #1: 1	أَفْتَى بَعْضَ
u'أَفْتَى بَعْضٌ':Subject, #18: 18	أَفْتَى بَعْضُ
u'أَفْتَى تَاجٌ':Subject, #1: 1	أَفْتَى الْبَعْضُ
u'أَفْتَى تَاجٌ':Subject, #1: 1	أَفْتَى تَاجُ
u'أَفْتَى جَلاَلٌ':Subject, #2: 2	أَفْتَى التَّاجُ
u'أَفْتَى جَمَاعَةٌ':Subject, #2: 2	أَفْتَى الْجَلَالُ
u'أَفْتَى جَمَاعَةٌ':Subject, #1: 1	أَفْتَى جَمَاعَةُ
u'أَفْتَى جَمَالٌ':Subject, #6: 6	أَفْتَى جَمَاعَةٌ
u'أَفْتَى جَمْعٌ':Subject, #1: 1	أَفْتَى الْجَمَالُ
u'أَفْتَى رُكْنٌ':Subject, #7: 7	أَفْتَى جَمْعٌ
u'أَفْتَى رُكْن':Subject, #1: 1	أَفْتَى رُكْنُ
u'أَفْتَى سَبْعَةٌ':Subject, #1: 1	أَفْتَى رُكْنُ
u'أَفْتَى سِرَاجٌ':Subject, #1: 1	أَفْتَى سَبْعَةٌ
u'أَفْتَى شَارِحٌ':Subject, #1: 1	أَفْتَى سِرَاجُ
u'أَفْتَى شمس':Subject, #3: 3	أَفْتَى الشَّارِحُ
u'أَفْتَى شَمْسٌ':Subject, #1: 1	أَفْتَى الشَّمْسُ
u'أَفْتَى شمس':Subject, #1: 1	أَفْتَى الشَّمْسُ
u'أَفْتَى شَمْسٌ':Subject, #1: 1	أَفْتَى شَمْسُ
u'أَفْتَى شَيْخٌ':Subject, #1: 1	أَفْتَى شَمْسُ
u'أَفْتَى شَيْخٌ':Subject, #23: 23	أَفْتَى الشَّيْخُ
u'أَفْتَى شُيُوخٌ':Subject, #8: 8	أَفْتَى شَيْخُ
u'أَفْتَى صَاحِبٌ':Subject, #1: 1	أَفْتَى الشُّيُوخُ
u'أَفْتَى صَدْرٌ':Subject, #2: 2	أَفْتَى صَاحِبُ
u'أَفْتَى صَدْرٌ':Subject, #1: 1	أَفْتَى صَدْرُ
u'أَفْتَى ظَهيرٌ':Subject, #7: 7	أَفْتَى الصَّدْرُ
u'أَفْتَى عَامٌّ':Predicate, #1: 1	أَفْتَى ظَهِيرُ
u'أَفْتَى عِزٌّ':Subject, #1: 1	أَفْتَى الْعَامَّةَ
u'أَفْتَى عُمَرٌ':Predicate, #1: 1	أَفْتَى الْعِزُّ
u'أَفْتَى عُمْرَانِيٌّ':Subject, #1: 1	أَفْتَى عُمَرَ
u'أَفْتَى غير':Subject, #1: 1	أَفْتَى الْعُمْرَانِيُّ
u'أَفْتَى غَيْرٌ':Subject, #1: 1	أَفْتَى غَيْرُهُ
u'أَفْتَى غير':Subject, #1: 1	أَفْتَى غَيْرُهُ
u'أَفْتَى غَيْرٌ':Subject, #4: 4	أَفْتَى غَيْرُ
u'أَفْتَى فخر':Subject, #4: 4	أَفْتَى غَيْرُ
u'أَفْتَى فَخْرٌ':Subject, #1: 1	أَفْتَى فَخْرُ
u'أَفْتَى فقهاء':Subject, #1: 1	أَفْتَى فَخْرُ
u'أَفْتَى فَقِيهٌ':Subject, #1: 1	أَفْتَى فُقَهَاءُ
u'أَفْتَى قَفَّالٌ':Subject, #6: 6	أَفْتَى الْفَقِيهُ
u'أَفْتَى مُجْتَهِد':Subject, #14: 14	أَفْتَى الْقَفَّالُ
u'أَفْتَى مَشَايِخُ':Subject, #1: 1	أَفْتَى الْمُجْتَهِدُ
u'أَفْتَى مُقَلِّدٌ':Subject, #5: 5	أَفْتَى الْمَشَايِخُ
u'أَفْتَى نَاسٌ':Predicate, #1: 1	أَفْتَى مُقَلِّدُهُ
u'أَفْتَى نَوَوِيٌّ':Subject, #2: 2	أَفْتَى النَّاسَ
u'أَفْتَى واحد':Subject, #13: 13	أَفْتَى النَّوَوِيُّ
u'أَفْتَى وَاحِدٌ':Subject, #1: 1	أَفْتَى وَاحِدٌ
u'أَفْتَى وَالِدٌ':Subject, #1: 1	أَفْتَى وَاحِدٌ
u'أَفْتَى وَالِدٌ':Subject, #12: 12	أَفْتَى الْوَالِدُ
u'أَفْتَى وَلِيٌّ':Subject, #2: 2	أَفْتَى وَالِدُ
u'أَفْحَشَ قَالٌ':Predicate, #1: 1	أَفْتَى الْوَلِيُّ
u'إِفْرَادٌ إقامَةٌ':Added, #1: 1	أَفْحَشَ قَالَ
u'إِفْرَادٌ اللهُ':Added, #3: 3	إِفْرَادِ الإِقَامَةِ
u'إِفْرَادٌ حَجٌّ':Added, #1: 1	إِفْرَادُ اللهِ
u'إِفْرَادٌ رَبُّ':Added, #2: 2	إِفْرَادِ الْحَجِّ
u'إِفْرَادٌ سَائِرٌ':Added, #1: 1	إِفْرَادَ الرَّبِّ
u'إِفْرَادٌ شَرْعٌ':Added, #1: 1	إِفْرَادِ سَائِرِ
u'إِفْرَاطٌ صَلاَةٌ':Added, #1: 1	إِفْرَادِ الشَّرْعِ
u'أَفْرَخَ طَيْرٌ':Subject, #1: 1	إِفْرَاطُ صَلاَةِ
u'أَفْرَدَ أحَدٌ':Predicate, #4: 4	أَفْرَخَ طَيْرٌ
u'أَفْرَدَ إقامَةٌ':Predicate, #1: 1	أَفْرَدَ أَحَدَ
u'أَفْرَدَ إقْرَارٌ':Predicate, #6: 6	أَفْرَدَ الْإِقَامَةَ
u'أَفْرَدَ أُمٌّ':Predicate, #1: 1	أَفْرَدَ إقْرَارَ
u'أَفْرَدَ إمَامٌ':Subject, #3: 3	أَفْرَدَ الْأُمَّ
u'أَفْرَدَ بَعْضٌ':Predicate, #1: 1	أَفْرَدَ الْإِمَامُ
u'أَفْرَدَ بَيْعٌ':Predicate, #1: 1	أَفْرَدَ بَعْضَ
u'أَفْرَدَ جَلاَلٌ':Subject, #1: 1	أَفْرَدَ بَيْعَ
u'أَفْرَدَ حَجٌّ':Predicate, #1: 1	أَفْرَدَ الْجَلَالُ
u'أَفْرَدَ دَمٌ':Subject, #12: 12	أَفْرَدَ الْحَجَّ
u'أَفْرَدَ رَأْسٌ':Predicate, #1: 1	أَفْرَدَ دَمُ
u'أَفْرَدَ صِدِّيقٌ':Subject, #1: 1	أَفْرَدَ الرَّأْسَ
u'أَفْرَدَ صَيْدٌ':Predicate, #1: 1	أَفْرَدَ الصِّدِّيقُ
u'أَفْرَدَ ضَمِيرٌ':Predicate, #1: 1	أَفْرَدَ الصَّيْدَ
u'أَفْرَدَ عَقْدٌ':Predicate, #2: 2	أَفْرَدَ الضَّمِيرَ
u'أَفْرَدَ عمرة':Predicate, #3: 3	أَفْرَدَ الْعَقْدَ
u'أَفْرَدَ عُمْرَةٌ':Predicate, #1: 1	أَفْرَدَ الْعُمْرَةَ
u'أَفْرَدَ عَمَلٌ':Predicate, #1: 1	أَفْرَدَ الْعُمْرَةَ
u'أَفْرَدَ قدم':Predicate, #1: 1	أَفْرَدَ عَمَلَ
u'أَفْرَدَ قَدَمٌ':Predicate, #1: 1	أَفْرَدَ الْقَدَمَ
u'أَفْرَدَ قَصْدٌ':Predicate, #1: 1	أَفْرَدَ الْقَدَمَ
u'أَفْرَدَ مَاءٌ':Predicate, #1: 1	أَفْرَدَ قَصْدَ
u'أَفْرَدَ مَسْأَلَةٌ':Predicate, #3: 3	أَفْرَدَ مَاءَ
u'أَفْرَدَ مُعَامَلَةٌ':Predicate, #1: 1	أَفْرَدَ مَسْأَلَةَ
u'أَفْرَدَ نَبِيٌّ':Predicate, #1: 1	أَفْرَدَ الْمُعَامَلَةَ
u'أَفْرَدَ وَعْدٌ':Predicate, #1: 1	أَفْرَدَ النَّبِيَّ
u'أَفْرَدَ وَكِيلٌ':Subject, #1: 1	أَفْرَدَ الْوَعْدَ
u'أَفْرَدَ يَوْمٌ':Predicate, #1: 1	أَفْرَدَ الْوَكِيلُ
u'أَفْرَزَ إمَامٌ':Subject, #1: 1	أَفْرَدَ الْيَوْمَ
u'أَفْرَزَ زَكاةٌ':Predicate, #1: 1	أَفْرَزَ الْإِمَامُ
u'أَفْرَزَ عُشْرٌ':Predicate, #1: 1	أَفْرَزَ زَكَاةَ
u'أَفْرَزَ فلان':Subject, #1: 1	أَفْرَزَ الْعُشْرَ
u'أَفْرَزَ قَصّاب':Subject, #1: 1	أَفْرَزَ الْقَصَّابُ
u'أَفْرَزَ مَالِكٌ':Subject, #1: 1	أَفْرَزَ الْقَصَّابُ
u'أَفْرَطَ جهل':Subject, #1: 1	أَفْرَزَ الْمَالِكُ
u'أَفْرَطَ جَهْلٌ':Subject, #1: 1	أَفْرَطَ جَهْلُهُ
u'أَفْرَطَ شَاعِر':Subject, #1: 1	أَفْرَطَ جَهْلُهُ
u'أَفْرَطَ طُولٌ':Predicate, #1: 1	أَفْرَطَ شَاعِرٌ
u'أَفْرَطَ عَادٌ':Predicate, #1: 1	أَفْرَطَ طُولَ
u'أَفْرَطَ فَزَعٌ':Subject, #1: 1	أَفْرَطَ عَادَ
u'أَفْرَطَ قَارِئٌ':Subject, #1: 1	أَفْرَطَ فَزَعُهُ
u'أَفْرَغَ أرْضٌ':Predicate, #1: 1	أَفْرَطَ الْقَارِئُ
u'أَفْرَغَ إِناءٌ':Predicate, #1: 1	أَفْرَغَ الْأَرْضَ
u'أَفْرَغَ باقِي':Predicate, #1: 1	أَفْرَغَ الْإِنَاءَ
u'أَفْرَكَ زَرْعٌ':Subject, #2: 2	أَفْرَغَ بَاقِيَ
u'أَفْرَكَ زَرْعٌ':Subject, #1: 1	أَفْرَكَ زَرْعُهُ
u'إفْسَادٌ أَجْنَبِيٌّ':Added, #2: 2	أَفْرَكَ الزَّرْعُ
u'إفْسَادٌ إِحْرَامٌ':Added, #1: 1	إفْسَادِ الْأَجْنَبِيِّ
u'إفْسَادٌ إِحْرَامٌ':Added, #1: 1	إفْسَادَ الْإِحْرَامِ
u'إفْسَادٌ أَدَاءٌ':Added, #1: 1	إفْسَادِ الْإِحْرَامِ
u'إفْسَادٌ أَضْدادٌ':Added, #1: 1	إفْسَادَ الْأَدَاءِ
u'إفْسَادٌ أَضْدَادٌ':Added, #1: 1	إفْسَادِ الْأَضْدَادِ
u'إفْسَادٌ الْمَرْأَةُ':Added, #1: 1	إفْسَادِ الْأَضْدَادِ
u'إفْسَادٌ أَمْرٌ':Added, #1: 1	إفْسَادَ الْمَرْأَةِ
u'إفْسَادٌ بَدَنٌ':Added, #1: 1	إفْسَادُ أَمْرِ
u'إفْسَادٌ بِنَاءٌ':Added, #1: 1	إفْسَادُ بَدَنٍ
u'إفْسَادٌ بَيْعٌ':Added, #1: 1	إفْسَادِ بِنَاءٍ
u'إفْسَادٌ جِرَاحَةٌ':Added, #1: 1	إفْسَادَ الْبَيْعِ
u'إفْسَادٌ جُزْءٌ':Added, #1: 1	إفْسَادِ الْجِرَاحَةِ
u'إفْسَادٌ حَجٌّ':Added, #1: 1	إفْسَادِ الْجُزْءِ
u'إفْسَادٌ خَشَبٌ':Added, #2: 2	إفْسَادِ الْحَجِّ
u'إفْسَادٌ خُفٌّ':Added, #1: 1	إفْسَادَ خَشَبِ
u'إفْسَادٌ خَلْوَةٌ':Added, #1: 1	إفْسَادُ الْخُفِّ
u'إفْسَادٌ دِينٌ':Added, #1: 1	إفْسَادِ الْخَلْوَةِ
u'إفْسَادٌ رِقٌّ':Added, #1: 1	إفْسَادَ دِينِ
u'إفْسَادٌ زَرْعٌ':Added, #1: 1	إفْسَادِ الرِّقِّ
u'إفْسَادٌ شَهْوَةٌ':Added, #1: 1	إفْسَادَ الزَّرْعِ
u'إفْسَادٌ شَيْءٌ':Added, #1: 1	إفْسَادِ شَهْوَةِ
u'إفْسَادٌ صَلاَةٌ':Added, #1: 1	إفْسَادِ شَيْءٍ
u'إفْسَادٌ صَلاَةٌ':Added, #1: 1	إفْسَادُ الصَّلَاةِ
u'إفْسَادٌ صَلاَةٌ':Added, #1: 1	إفْسَادِ صَلَاةِ
u'إفْسَادٌ صَلاَةٌ':Added, #1: 1	إفْسَادَ صَلَاتِهِ
u'إفْسَادٌ صَلاَةٌ':Added, #2: 2	إفْسَادَ الصَّلَاةِ
u'إفْسَادٌ صَوْمٌ':Added, #4: 4	إفْسَادِ الصَّلَاةِ
u'إفْسَادٌ صَوْمٌ':Added, #10: 10	إفْسَادِ الصَّوْمِ
u'إفْسَادٌ صَوْمٌ':Added, #1: 1	إفْسَادِ صَوْمٍ
u'إفْسَادٌ صَوْمٌ':Added, #1: 1	إفْسَادِ صَوْمِهِ
u'إفْسَادٌ صَوْمٌ':Added, #2: 2	إفْسَادَ الصَّوْمِ
u'إفْسَادٌ صَوْمٌ':Added, #3: 3	إفْسَادُ الصَّوْمِ
u'إفْسَادٌ طعام':Added, #6: 6	إفْسَادِ صَوْمِ
u'إفْسَادٌ طَعَامٌ':Added, #1: 1	إفْسَادِ الطَّعَامِ
u'إفْسَادٌ عِبَادَةٌ':Added, #1: 1	إفْسَادِ الطَّعَامِ
u'إفْسَادٌ عِبَادَةٌ':Added, #1: 1	إفْسَادِ الْعِبَادَاتِ
u'إفْسَادٌ عِبَادَةٌ':Added, #1: 1	إفْسَادِ عِبَادَةٍ
u'إفْسَادٌ عِبَادَةٌ':Added, #2: 2	إفْسَادَ الْعِبَادَةِ
u'إفْسَادٌ عُضْوٌ':Added, #2: 2	إفْسَادِ الْعِبَادَةِ
u'إفْسَادٌ عَقَائِدُ':Added, #1: 1	إفْسَادِ عُضْوٍ
u'إفْسَادٌ عَقْدٌ':Added, #1: 1	إفْسَادِ عَقَائِدِ
u'إفْسَادٌ عَقْدٌ':Added, #1: 1	إفْسَادَ الْعَقْدِ
u'إفْسَادٌ عَكْسٌ':Added, #1: 1	إفْسَادِ الْعَقْدِ
u'إفْسَادٌ عِلَّةٌ':Added, #1: 1	إفْسَادُ عَكْسِهِ
u'إفْسَادٌ عِمَامَةٌ':Added, #2: 2	إفْسَادُ الْعِلَّةِ
u'إفْسَادٌ غير':Added, #1: 1	إفْسَادُ الْعِمَامَةِ
u'إفْسَادٌ غَيْرٌ':Added, #1: 1	إفْسَادَ غَيْرِهِ
u'إفْسَادٌ فِرَاشٌ':Added, #1: 1	إفْسَادَ غَيْرِهِ
u'إفْسَادٌ فِرَاشٌ':Added, #1: 1	إفْسَادَ الْفِرَاشِ
u'إفْسَادٌ قَضَاءٌ':Added, #3: 3	إفْسَادُ الْفِرَاشِ
u'إفْسَادٌ قِنٌّ':Added, #1: 1	إفْسَادِ الْقَضَاءِ
u'إفْسَادٌ قَهْقَه':Added, #1: 1	إفْسَادُ الْقِنِّ
u'إفْسَادٌ قَهْقَهَة':Added, #1: 1	إفْسَادَ الْقَهْقَهَةِ
u'إفْسَادٌ قَوِيٌّ':Added, #1: 1	إفْسَادَ الْقَهْقَهَةِ
u'إفْسَادٌ قِيَاسٌ':Added, #1: 1	إفْسَادُ الْقَوِيِّ
u'إفْسَادٌ كَلْبٌ':Added, #1: 1	إفْسَادِ الْقِيَاسِ
u'إفْسَادٌ مَاءٌ':Added, #1: 1	إفْسَادُ الْكَلْبِ
u'إفْسَادٌ مَاءٌ':Added, #1: 1	إفْسَادَ الْمَاءِ
u'إفْسَادٌ مَاءٌ':Added, #1: 1	إفْسَادُ مَاءٍ
u'إفْسَادٌ مَالٌ':Added, #2: 2	إفْسَادِ الْمَاءِ
u'إفْسَادٌ مَالٌ':Added, #1: 1	إفْسَادُ الْمَالِ
u'إفْسَادٌ مَالٌ':Added, #1: 1	إفْسَادَ مَالِهِ
u'إفْسَادٌ مَعَاشٌ':Added, #2: 2	إفْسَادِ الْمَالِ
u'إفْسَادٌ مَغْسُولٌ':Added, #1: 1	إفْسَادِ مَعَاشِهِ
u'إفْسَادٌ مُقَدِّمٌ':Added, #1: 1	إفْسَادِ الْمَغْسُولِ
u'إفْسَادٌ مُقَدِّمَةٌ':Added, #1: 1	إفْسَادَ مُقَدِّمَةِ
u'إفْسَادٌ مَلْزُوم':Added, #1: 1	إفْسَادَ مُقَدِّمَةِ
u'إفْسَادٌ مَنِيٌّ':Added, #1: 1	إفْسَادِ الْمَلْزُومِ
u'إفْسَادٌ نُسُكٌ':Added, #2: 2	إفْسَادِ الْمَنِيِّ
u'إفْسَادٌ نُسُكٌ':Added, #1: 1	إفْسَادُ النُّسُكِ
u'إفْسَادٌ نَصِيبٌ':Added, #1: 1	إفْسَادِ النُّسُكَيْنِ
u'إفْسَادٌ نَصِيبٌ':Added, #1: 1	إفْسَادُ النَّصِيبِ
u'إفْسَادٌ نَصِيبٌ':Added, #1: 1	إفْسَادَ نَصِيبِ
u'إفْسَادٌ نكاح':Added, #1: 1	إفْسَادُ نَصِيبِ
u'إفْسَادٌ نِكَاحٌ':Added, #2: 2	إفْسَادُ النِّكَاحِ
u'إفْسَادٌ نكاح':Added, #2: 2	إفْسَادُ النِّكَاحِ
u'إفْسَادٌ نِكَاحٌ':Added, #4: 4	إفْسَادَ النِّكَاحِ
u'إفْسَادٌ نكاح':Added, #4: 4	إفْسَادَ النِّكَاحِ
u'إفْسَادٌ نِكَاحٌ':Added, #5: 5	إفْسَادِ النِّكَاحِ
u'إفْسَادٌ وَصْفٌ':Added, #5: 5	إفْسَادِ النِّكَاحِ
u'إفْسَادٌ وَصْفٌ':Added, #1: 1	إفْسَادُ الْوَصْفِ
u'أَفْسَدَ إمَامٌ':Subject, #1: 1	إفْسَادِ الْوَصْفِ
u'أَفْسَدَ إِنْسانٌ':Subject, #2: 2	أَفْسَدَ الْإِمَامُ
u'أَفْسَدَ بَيْعٌ':Predicate, #1: 1	أَفْسَدَ إنْسَانٌ
u'أَفْسَدَ تَأْلِيفٌ':Predicate, #3: 3	أَفْسَدَ الْبَيْعَ
u'أَفْسَدَ تَصْرِيحٌ':Subject, #1: 1	أَفْسَدَ تَأْلِيفَ
u'أَفْسَدَ تَطَوُّعٌ':Predicate, #1: 1	أَفْسَدَ التَّصْرِيحُ
u'أَفْسَدَ تَعْرِيفٌ':Predicate, #1: 1	أَفْسَدَ التَّطَوُّعَ
u'أَفْسَدَ ثَوْبٌ':Predicate, #1: 1	أَفْسَدَ التَّعْرِيفَ
u'أَفْسَدَ جمعة':Predicate, #2: 2	أَفْسَدَ الثَّوْبَ
u'أَفْسَدَ جُمُعَةٌ':Predicate, #1: 1	أَفْسَدَ الْجُمُعَةَ
u'أَفْسَدَ حَجٌّ':Predicate, #1: 1	أَفْسَدَ الْجُمُعَةَ
u'أَفْسَدَ حِجَّةٌ':Predicate, #4: 4	أَفْسَدَ الْحَجَّ
u'أَفْسَدَ حُرٌّ':Subject, #1: 1	أَفْسَدَ حِجَّةَ
u'أَفْسَدَ خُفٌّ':Predicate, #1: 1	أَفْسَدَ الْحُرُّ
u'أَفْسَدَ خَمْرٌ':Predicate, #1: 1	أَفْسَدَ الْخُفَّ
u'أَفْسَدَ خَيَّاطٌ':Subject, #1: 1	أَفْسَدَ الْخَمْرَ
u'أَفْسَدَ رَاهِنٌ':Subject, #1: 1	أَفْسَدَ الْخَيَّاطُ
u'أَفْسَدَ زَرْعٌ':Predicate, #1: 1	أَفْسَدَ الرَّاهِنُ
u'أَفْسَدَ سِدْرٌ':Subject, #1: 1	أَفْسَدَ الزَّرْعَ
u'أَفْسَدَ سُنَّةٌ':Predicate, #1: 1	أَفْسَدَ السِّدْرُ
u'أَفْسَدَ سُنَّةٌ':Predicate, #1: 1	أَفْسَدَ السُّنَّةَ
u'أَفْسَدَ شَخْصٌ':Subject, #1: 1	أَفْسَدَ سُنَّةَ
u'أَفْسَدَ شَرِيكٌ':Subject, #1: 1	أَفْسَدَ شَخْصٌ
u'أَفْسَدَ شَفْعٌ':Predicate, #1: 1	أَفْسَدَ شَرِيكُهُ
u'أَفْسَدَ صَبِيٌّ':Subject, #3: 3	أَفْسَدَ الشَّفْعَ
u'أَفْسَدَ صَلاَةٌ':Predicate, #2: 2	أَفْسَدَ الصَّبِيُّ
u'أَفْسَدَ صَلاَةٌ':Predicate, #11: 11	أَفْسَدَ الصَّلَاةَ
u'أَفْسَدَ صُورَةٌ':Predicate, #1: 1	أَفْسَدَ صَلَاةَ
u'أَفْسَدَ صُورَةٌ':Predicate, #1: 1	أَفْسَدَ الصُّورَةَ
u'أَفْسَدَ صَوْمٌ':Predicate, #1: 1	أَفْسَدَ صُورَةَ
u'أَفْسَدَ صَوْمٌ':Predicate, #1: 1	أَفْسَدَ الصَّوْمَ
u'أَفْسَدَ طَبَّاخٌ':Subject, #2: 2	أَفْسَدَ صَوْمَ
u'أَفْسَدَ طعام':Predicate, #1: 1	أَفْسَدَ الطَّبَّاخُ
u'أَفْسَدَ طَعَامٌ':Predicate, #1: 1	أَفْسَدَ الطَّعَامَ
u'أَفْسَدَ ظُهْرٌ':Predicate, #1: 1	أَفْسَدَ الطَّعَامَ
u'أَفْسَدَ عَبْدٌ':Subject, #1: 1	أَفْسَدَ الظُّهْرَ
u'أَفْسَدَ عَبْدٌ':Subject, #1: 1	أَفْسَدَ عَبْدُ
u'أَفْسَدَ عَقَائِدُ':Predicate, #3: 3	أَفْسَدَ الْعَبْدُ
u'أَفْسَدَ عَقْدٌ':Predicate, #1: 1	أَفْسَدَ الْعَقَائِدَ
u'أَفْسَدَ عمرة':Predicate, #1: 1	أَفْسَدَ الْعَقْدَ
u'أَفْسَدَ عُمْرَةٌ':Predicate, #1: 1	أَفْسَدَ الْعُمْرَةَ
u'أَفْسَدَ قَضَاءٌ':Predicate, #1: 1	أَفْسَدَ الْعُمْرَةَ
u'أَفْسَدَ قَضَاءٌ':Predicate, #3: 3	أَفْسَدَ الْقَضَاءَ
u'أَفْسَدَ كَثْرَةٌ':Subject, #6: 6	أَفْسَدَ قَضَاءَ
u'أَفْسَدَ كُوفِيٌّ':Subject, #1: 1	أَفْسَدَ كَثْرَةُ
u'أَفْسَدَ مَاءٌ':Predicate, #1: 1	أَفْسَدَ الْكُوفِيُّ
u'أَفْسَدَ مَاءٌ':Subject, #1: 1	أَفْسَدَ مَاءَ
u'أَفْسَدَ مَالِكٌ':Subject, #1: 1	أَفْسَدَ الْمَاءُ
u'أَفْسَدَ مُتَمَتِّعٌ':Subject, #1: 1	أَفْسَدَ مَالِكٌ
u'أَفْسَدَ مُتَمَتِّعٌ':Subject, #1: 1	أَفْسَدَ مُتَمَتِّعٌ
u'أَفْسَدَ مَخْرَجٌ':Predicate, #2: 2	أَفْسَدَ الْمُتَمَتِّعُ
u'أَفْسَدَ مِزَاجٌ':Predicate, #1: 1	أَفْسَدَ مَخْرَجَ
u'أَفْسَدَ مُسْتَحَقٌّ':Predicate, #1: 1	أَفْسَدَ الْمِزَاجَ
u'أَفْسَدَ مَطَرٌ':Subject, #1: 1	أَفْسَدَ الْمُسْتَحَقَّ
u'أَفْسَدَ مُفْسِدٌ':Subject, #2: 2	أَفْسَدَ الْمَطَرُ
u'أَفْسَدَ مَنْبِتٌ':Predicate, #1: 1	أَفْسَدَ مُفْسِدٌ
u'أَفْسَدَ مَنْذُور':Predicate, #1: 1	أَفْسَدَ الْمَنْبِتَ
u'أَفْسَدَ نَاسٌ':Subject, #2: 2	أَفْسَدَ الْمَنْذُورَ
u'أَفْسَدَ نَصِيبٌ':Predicate, #1: 1	أَفْسَدَ النَّاسُ
u'أَفْسَدَ نكاح':Predicate, #1: 1	أَفْسَدَ نَصِيبَ
u'أَفْسَدَ نِكَاحٌ':Predicate, #4: 4	أَفْسَدَ نِكَاحَ
u'إفْشَاءٌ رَجُلٌ':Added, #4: 4	أَفْسَدَ نِكَاحَ
u'إفْشَاءٌ سِرٌّ':Added, #1: 1	إفْشَاءُ الرَّجُلِ
u'إفْشَاءٌ سِرٌّ':Added, #1: 1	إفْشَاءِ سِرِّهِ
u'إفْشَاءٌ سِرٌّ':Added, #2: 2	إفْشَاءَ السِّرِّ
u'إفْشَاءٌ سلام':Added, #5: 5	إفْشَاءُ السِّرِّ
u'إفْشَاءٌ سلام':Added, #1: 1	إفْشَاءَ السَّلَامِ
u'إفْشَاءٌ سَلاَمٌ':Added, #1: 1	إفْشَاءُ السَّلَامِ
u'إفْشَاءٌ سَلاَمٌ':Added, #1: 1	إفْشَاءَ السَّلَامِ
u'إفْشَاءٌ سلام':Added, #1: 1	إفْشَاءُ السَّلَامِ
u'إفْشَاءٌ سَلاَمٌ':Added, #3: 3	إفْشَاءِ السَّلَامِ
u'إفْشَاءٌ نكاح':Added, #3: 3	إفْشَاءِ السَّلَامِ
u'إفْشَاءٌ نِكَاحٌ':Added, #1: 1	إفْشَاءِ النِّكَاحِ
u'أَفْشَى سِرٌّ':Predicate, #1: 1	إفْشَاءِ النِّكَاحِ
u'إفْصَاحٌ اِبْنٌ':Added, #1: 1	أَفْشَى السِّرَّ
u'أَفْصَحَ مُصَنِّفٌ':Subject, #2: 2	إفْصَاحِ ابْنِ
u'أَفْضَلَ جَازٌ':Predicate, #2: 2	أَفْصَحَ الْمُصَنِّفُ
u'أَفْضَلَ حاضِرٌ':Predicate, #1: 1	أَفْضَلَ جَازَ
u'أَفْضَلَ خَلْفٌ':Predicate, #1: 1	أَفْضَلَ الْحَاضِرِينَ
u'أَفْضَلَ صَوَابٌ':Subject, #1: 1	أَفْضَلَ خَلْفَ
u'أَفْضَلَ عند':Predicate, #1: 1	أَفْضَلَ صَوَابُهُ
u'أَفْضَلَ قَالٌ':Predicate, #5: 5	أَفْضَلَ عِنْدَ
u'أَفْضَلَ قول':Subject, #1: 1	أَفْضَلَ قَالَ
u'أَفْضَلَ قَوْلٌ':Subject, #1: 1	أَفْضَلَ قَوْلُهُ
u'أَفْضَلَ مَالِيٌّ':Predicate, #1: 1	أَفْضَلَ قَوْلُهُ
u'أَفْضَلَ مُؤْمِنٌ':Predicate, #1: 1	أَفْضَلَ مَالِيَّةً
u'أَفْضَلَ نَظَرٌ':Subject, #1: 1	أَفْضَلَ الْمُؤْمِنِينَ
u'أَفْضَى أَمْرٌ':Subject, #1: 1	أَفْضَلَ نَظَرٌ
u'أَفْضَى أَمْرٌ':Subject, #1: 1	أَفْضَى الأَمْرُ
u'أَفْضَى إيقَاعٌ':Subject, #2: 2	أَفْضَى الْأَمْرُ
u'أَفْضَى تَرْكٌ':Subject, #1: 1	أَفْضَى إيقَاعُ
u'أَفْضَى تَعْطِيلٌ':Subject, #1: 1	أَفْضَى تَرْكُ
u'أَفْضَى جُرْحٌ':Subject, #1: 1	أَفْضَى التَّعْطِيلُ
u'أَفْضَى حَرْبٌ':Subject, #1: 1	أَفْضَى الْجُرْحُ
u'أَفْضَى حُزْنٌ':Subject, #1: 1	أَفْضَى الْحَرْبُ
u'أَفْضَى دفع':Subject, #1: 1	أَفْضَى الْحُزْنُ
u'أَفْضَى دَفْعٌ':Subject, #1: 1	أَفْضَى الدَّفْعُ
u'أَفْضَى دفع':Subject, #1: 1	أَفْضَى الدَّفْعُ
u'أَفْضَى دَفْعٌ':Subject, #1: 1	أَفْضَى دَفْعُهُ
u'أَفْضَى رَأْيٌ':Subject, #1: 1	أَفْضَى دَفْعُهُ
u'أَفْضَى رَدٌّ':Subject, #1: 1	أَفْضَى رَأْيُهُ
u'أَفْضَى علم':Subject, #1: 1	أَفْضَى الرَّدُّ
u'أَفْضَى عِلْمٌ':Subject, #1: 1	أَفْضَى عِلْمُ
u'أَفْضَى فِعْلٌ':Subject, #1: 1	أَفْضَى عِلْمُ
u'أَفْضَى فُلاَنٌ':Subject, #1: 1	أَفْضَى فِعْلُهُ
u'أَفْضَى كَفٌّ':Subject, #1: 1	أَفْضَى فُلَانٌ
u'أَفْضَى نَظَرٌ':Subject, #1: 1	أَفْضَى الْكَفُّ
u'أَفْضَى نقل':Subject, #1: 1	أَفْضَى نَظَرُهُ
u'أَفْضَى نَقْلٌ':Subject, #1: 1	أَفْضَى النَّقْلُ
u'أَفْضَى وُجُودٌ':Subject, #1: 1	أَفْضَى النَّقْلُ
u'أَفْطَرَ أيَّامٌ':Predicate, #1: 1	أَفْضَى وُجُودُهُ
u'أَفْطَرَ أَيَّامٌ':Predicate, #1: 1	أَفْطَرَ الْأَيَّامَ
u'أَفْطَرَ أيَّامٌ':Predicate, #1: 1	أَفْطَرَ الْأَيَّامَ
u'أَفْطَرَ أَيَّامٌ':Predicate, #5: 5	أَفْطَرَ أَيَّامَ
u'أَفْطَرَ جَازٌ':Predicate, #5: 5	أَفْطَرَ أَيَّامَ
u'أَفْطَرَ حَديثٌ':Predicate, #1: 1	أَفْطَرَ جَازَ
u'أَفْطَرَ رَسُولٌ':Subject, #1: 1	أَفْطَرَ الْحَدِيثَ
u'أَفْطَرَ رَمَضانُ':Predicate, #2: 2	أَفْطَرَ رَسُولُ
u'أَفْطَرَ صَائِمٌ':Subject, #2: 2	أَفْطَرَ رَمَضَانَ
u'أَفْطَرَ عُمَرٌ':Subject, #21: 21	أَفْطَرَ الصَّائِمُ
u'أَفْطَرَ عند':Predicate, #1: 1	أَفْطَرَ عُمَرُ
u'أَفْطَرَ فرح':Predicate, #8: 8	أَفْطَرَ عِنْدَ
u'أَفْطَرَ فَرِحٌ':Predicate, #3: 3	أَفْطَرَ فَرِحَ
u'أَفْطَرَ فَلًا':Predicate, #3: 3	أَفْطَرَ فَرِحَ
u'أَفْطَرَ فُلاَنٌ':Subject, #1: 1	أَفْطَرَ فَلاَ
u'أَفْطَرَ قَالٌ':Predicate, #1: 1	أَفْطَرَ فُلاَنٌ
u'أَفْطَرَ مُتَطَوِّعٌ':Subject, #8: 8	أَفْطَرَ قَالَ
u'أَفْطَرَ مُقِيمٌ':Subject, #1: 1	أَفْطَرَ الْمُتَطَوِّعُ
u'أَفْطَرَ نَاسٌ':Subject, #1: 1	أَفْطَرَ الْمُقِيمُ
u'أَفْطَرَ نَبِيٌّ':Subject, #4: 4	أَفْطَرَ النَّاسُ
u'أَفْطَرَ وَجَبٌ':Predicate, #2: 2	أَفْطَرَ النَّبِيُّ
u'أَفْطَرَ يَوْمٌ':Predicate, #1: 1	أَفْطَرَ وَجَبَ
u'أَفْقَدَ دَرَاهِمُ':Predicate, #10: 10	أَفْطَرَ يَوْمَ
u'أَفْقَرَ مُقْرِضٌ':Predicate, #1: 1	أَفْقَدَ دَرَاهِمَ
u'إفْكٌ غَوِيٌّ':Added, #1: 1	أَفْقَرَ الْمُقْرِضَ
u'أَفِكَ قَوْمٌ':Subject, #1: 1	إفْكَ الْغَوِيِّ
u'أَفْلَتَ صَيْدٌ':Subject, #1: 1	أَفِكَ قَوْمٌ
u'أَفْلَحَ أَصْحَابٌ':Subject, #1: 1	أَفْلَتَ الصَّيْدُ
u'أَفْلَحَ رَجُلٌ':Subject, #1: 1	أَفْلَحَ أَصْحَابُهُ
u'أَفْلَحَ قَالٌ':Predicate, #1: 1	أَفْلَحَ الرَّجُلُ
u'أَفْلَحَ قَوْمٌ':Subject, #1: 1	أَفْلَحَ قَالَ
u'أَفْلَحَ نَبِيٌّ':Subject, #1: 1	أَفْلَحَ قَوْمٌ
u'أَفْلَحَ وَجْهٌ':Subject, #1: 1	أَفْلَحَ نَبِيّهُ
u'أَفْلَسَ رَاهِنٌ':Subject, #2: 2	أَفْلَحَ الْوَجْهُ
u'أَفْلَسَ رَجُلٌ':Subject, #1: 1	أَفْلَسَ الرَّاهِنُ
u'أَفْلَسَ سَيِّدٌ':Subject, #7: 7	أَفْلَسَ الرَّجُلُ
u'أَفْلَسَ صَاحِبٌ':Subject, #1: 1	أَفْلَسَ السَّيِّدُ
u'أَفْلَسَ ضَامِنٌ':Subject, #1: 1	أَفْلَسَ صَاحِبُهُ
u'أَفْلَسَ غَرِيمٌ':Subject, #2: 2	أَفْلَسَ الضَّامِنُ
u'أَفْلَسَ قَرْضٌ':Subject, #1: 1	أَفْلَسَ الْغَرِيمُ
u'أَفْلَسَ قول':Subject, #1: 1	أَفْلَسَ الْقَرْضُ
u'أَفْلَسَ قَوْلٌ':Subject, #1: 1	أَفْلَسَ قَوْلُهُ
u'أَفْلَسَ مَالِكٌ':Subject, #1: 1	أَفْلَسَ قَوْلُهُ
u'أَفْلَسَ مُبْتاع':Subject, #1: 1	أَفْلَسَ الْمَالِكُ
u'أَفْلَسَ مُسْتَأْجِرٌ':Subject, #1: 1	أَفْلَسَ مُبْتَاعُ
u'أَفْلَسَ مُؤَجِّرٌ':Subject, #2: 2	أَفْلَسَ مُسْتَأْجِرُهُ
u'أَفْهَامٌ أَصْحَابٌ':Added, #1: 1	أَفْلَسَ مُؤَجِّرُ
u'أَفْهَامٌ بَعْضٌ':Added, #1: 1	أَفْهَامُ الْأَصْحَابِ
u'أَفْهَامٌ عَامٌّ':Added, #1: 1	أَفْهَامَ بَعْضِ
u'أَفْهَامٌ علماء':Added, #2: 2	أَفْهَامِ الْعَامَّةِ
u'أَفْهَامٌ عُلَمَاءُ':Added, #1: 1	أَفْهَامِ الْعُلَمَاءِ
u'أَفْهَامٌ علماء':Added, #1: 1	أَفْهَامِ الْعُلَمَاءِ
u'أَفْهَامٌ عُلَمَاءُ':Added, #2: 2	أَفْهَامُ الْعُلَمَاءِ
u'أَفْهَامٌ نَاسٌ':Added, #2: 2	أَفْهَامُ الْعُلَمَاءِ
u'أَفْهَامٌ نَاسٌ':Added, #1: 1	أَفْهَامَ النَّاسِ
u'أَفْهَمَ آدَمِيٌّ':Predicate, #1: 1	أَفْهَامِ النَّاسِ
u'أَفْهَمَ إِطْلاقٌ':Subject, #1: 1	أَفْهَمَ الْآدَمِيِّينَ
u'أَفْهَمَ اِقْتِصَارٌ':Subject, #1: 1	أَفْهَمَ إطْلَاقُ
u'أَفْهَمَ رَمْيٌ':Predicate, #2: 2	أَفْهَمَ اقْتِصَارُهُ
u'أَفْهَمَ عند':Predicate, #1: 1	أَفْهَمَ الرَّمْيَ
u'أَفْهَمَ قول':Subject, #1: 1	أَفْهَمَ عِنْدَ
u'أَفْهَمَ قَوْلٌ':Subject, #8: 8	أَفْهَمَ قَوْلُهُ
u'أَفْهَمَ كَلاَمٌ':Subject, #8: 8	أَفْهَمَ قَوْلُهُ
u'أَفْهَمَ كَلاَمٌ':Subject, #4: 4	أَفْهَمَ كَلَامُهُ
u'أَقَالَ أحَدٌ':Subject, #6: 6	أَفْهَمَ كَلَامُ
u'أَقَالَ بَائِعٌ':Subject, #1: 1	أَقَالَ أَحَدُ
u'أَقَالَ بَيْعٌ':Predicate, #3: 3	أَقَالَ الْبَائِعُ
u'أَقَالَ ثَلاثَةٌ':Predicate, #12: 12	أَقَالَ الْبَيْعَ
u'أَقَالَ رَسُولٌ':Subject, #1: 1	أَقَالَ ثَلاَثَةَ
u'أَقَالَ سَلَمٌ':Predicate, #1: 1	أَقَالَ رَسُولُ
u'أَقَالَ عَقْدٌ':Predicate, #1: 1	أَقَالَ السَّلَمَ
u'أَقَالَ كَفِيلٌ':Subject, #3: 3	أَقَالَ الْعَقْدَ
u'أَقَالَ مَالِكٌ':Subject, #1: 1	أَقَالَ الْكَفِيلُ
u'أَقَالَ وَكِيلٌ':Subject, #1: 1	أَقَالَ مَالِكٌ
u'أَقَامَ أَبٌ':Subject, #1: 1	أَقَالَ الْوَكِيلُ
u'أَقَامَ اِبْنٌ':Subject, #2: 2	أَقَامَ الْأَبُ
u'أَقَامَ أَجَلٌ':Predicate, #2: 2	أَقَامَ ابْنُ
u'أَقَامَ أَجْنَبِيٌّ':Predicate, #1: 1	أَقَامَ الْأَجَلَ
u'أَقَامَ أَجْنَبِيٌّ':Subject, #1: 1	أَقَامَ الْأَجْنَبِيَّ
u'أَقَامَ أحَدٌ':Subject, #5: 5	أَقَامَ الْأَجْنَبِيُّ
u'أَقَامَ أحَدٌ':Subject, #1: 1	أَقَامَ أَحَدٌ
u'أَقَامَ أَخٌ':Subject, #7: 7	أَقَامَ أَحَدُ
u'أَقَامَ آدَمُ':Subject, #8: 8	أَقَامَ الْأَخُ
u'أَقَامَ أَرْبَعَةٌ':Predicate, #1: 1	أَقَامَ آدَمُ
u'أَقَامَ أَرْبَعَةٌ':Subject, #1: 1	أَقَامَ أَرْبَعَةَ
u'أَقَامَ أَسْفَلُ':Predicate, #1: 1	أَقَامَ أَرْبَعَةٌ
u'أَقَامَ أَشْهُرٌ':Predicate, #1: 1	أَقَامَ أَسْفَلَ
u'أَقَامَ اِعْتِدالٌ':Predicate, #1: 1	أَقَامَ الْأَشْهُرَ
u'أَقَامَ أَعْيَارٌ':Predicate, #1: 1	أَقَامَ اعْتِدَالَ
u'أَقَامَ أفْضَلُ':Predicate, #1: 1	أَقَامَ الْأَعْيَارَ
u'أَقَامَ أَقْوَالٌ':Predicate, #1: 1	أَقَامَ الأَفْضَلَ
u'أَقَامَ أكْبَرُ':Subject, #1: 1	أَقَامَ أَقْوَالَ
u'أَقَامَ أَكْثَرُ':Predicate, #1: 1	أَقَامَ الْأَكْبَرُ
u'أَقَامَ أَكْثَرُ':Predicate, #3: 3	أَقَامَ الْأَكْثَرَ
u'أَقَامَ أكل':Predicate, #6: 6	أَقَامَ أَكْثَرَ
u'أَقَامَ أَكْلٌ':Predicate, #1: 1	أَقَامَ الْأَكْلَ
u'أَقَامَ إمَامٌ':Subject, #1: 1	أَقَامَ الْأَكْلَ
u'أَقَامَ أهْلٌ':Subject, #2: 2	أَقَامَ الْإِمَامُ
u'أَقَامَ أَهْلِيٌّ':Predicate, #4: 4	أَقَامَ أَهْلُ
u'أَقَامَ أهْلِيَّةٌ':Predicate, #1: 1	أَقَامَ الْأَهْلِيَّةَ
u'أَقَامَ أَوَّلُ':Subject, #1: 1	أَقَامَ الْأَهْلِيَّةَ
u'أَقَامَ أَوْلاَدٌ':Subject, #6: 6	أَقَامَ الْأَوَّلُ
u'أَقَامَ أئِمَّةٌ':Subject, #1: 1	أَقَامَ أَوْلَادُ
u'أَقَامَ أيَّامٌ':Predicate, #1: 1	أَقَامَ الْأَئِمَّةُ
u'أَقَامَ أَيَّامٌ':Predicate, #1: 1	أَقَامَ أَيَّامَ
u'أَقَامَ بَائِعٌ':Subject, #1: 1	أَقَامَ أَيَّامَ
u'أَقَامَ بَعْضٌ':Predicate, #23: 23	أَقَامَ الْبَائِعُ
u'أَقَامَ بَقِيَّةٌ':Predicate, #3: 3	أَقَامَ بَعْضَ
u'أَقَامَ بَيِّنَةٌ':Predicate, #1: 1	أَقَامَ بَقِيَّةَ
u'أَقَامَ بَيِّنَةٌ':Subject, #388: 388	أَقَامَ الْبَيِّنَةَ
u'أَقَامَ تارِك':Subject, #1: 1	أَقَامَ بَيِّنَةٌ
u'أَقَامَ تِسْعَةٌ':Predicate, #3: 3	أَقَامَ تَارِكٌ
u'أَقَامَ تَصَدُّقٌ':Predicate, #1: 1	أَقَامَ تِسْعَةَ
u'أَقَامَ ثَالِثٌ':Subject, #1: 1	أَقَامَ التَّصَدُّقَ
u'أَقَامَ ثَالِثٌ':Subject, #2: 2	أَقَامَ الثَّالِثُ
u'أَقَامَ ثَلاثَةٌ':Predicate, #3: 3	أَقَامَ ثَالِثٌ
u'أَقَامَ ثَمانِيَةٌ':Predicate, #1: 1	أَقَامَ ثَلَاثَةَ
u'أَقَامَ جمعة':Predicate, #1: 1	أَقَامَ ثَمَانِيَةَ
u'أَقَامَ جُمُعَةٌ':Predicate, #3: 3	أَقَامَ الْجُمُعَةَ
u'أَقَامَ حاضِرٌ':Subject, #3: 3	أَقَامَ الْجُمُعَةَ
u'أَقَامَ حاكِمٌ':Subject, #3: 3	أَقَامَ الْحَاضِرُ
u'أَقَامَ حَدٌّ':Predicate, #6: 6	أَقَامَ الْحَاكِمُ
u'أَقَامَ حَدٌّ':Predicate, #2: 2	أَقَامَ حَدَّ
u'أَقَامَ حَيٌّ':Subject, #9: 9	أَقَامَ الْحَدَّ
u'أَقَامَ خَارِجٌ':Predicate, #1: 1	أَقَامَ الْحَيُّ
u'أَقَامَ خَارِجٌ':Subject, #1: 1	أَقَامَ خَارِجَ
u'أَقَامَ خَارِجٌ':Subject, #1: 1	أَقَامَ خَارِجٌ
u'أَقَامَ خَصْمٌ':Subject, #28: 28	أَقَامَ الْخَارِجُ
u'أَقَامَ خَصْمٌ':Subject, #1: 1	أَقَامَ الْخَصْمُ
u'أَقَامَ خَمْسَةٌ':Predicate, #1: 1	أَقَامَ خَصْمُهُ
u'أَقَامَ دَاخِلٌ':Subject, #3: 3	أَقَامَ خَمْسَةَ
u'أَقَامَ دَليلٌ':Predicate, #2: 2	أَقَامَ الدَّاخِلُ
u'أَقَامَ دونٌ':Predicate, #3: 3	أَقَامَ الدَّلِيلَ
u'أَقَامَ دِينٌ':Predicate, #1: 1	أَقَامَ دُونَ
u'أَقَامَ ذِمِّيٌّ':Subject, #1: 1	أَقَامَ الدِّينَ
u'أَقَامَ ذِمِّيٌّ':Subject, #1: 1	أَقَامَ ذِمِّيٌّ
u'أَقَامَ رَاهِنٌ':Subject, #2: 2	أَقَامَ الذِّمِّيُّ
u'أَقَامَ رَأْيٌ':Predicate, #7: 7	أَقَامَ الرَّاهِنُ
u'أَقَامَ رَبُّ':Subject, #1: 1	أَقَامَ رَأْيَ
u'أَقَامَ رَجُلٌ':Predicate, #7: 7	أَقَامَ رَبُّ
u'أَقَامَ رَجُلٌ':Subject, #1: 1	أَقَامَ الرَّجُلَ
u'أَقَامَ رَجُلٌ':Subject, #10: 10	أَقَامَ الرَّجُلُ
u'أَقَامَ رَسُولٌ':Subject, #64: 64	أَقَامَ رَجُلٌ
u'أَقَامَ زادٌ':Predicate, #28: 28	أَقَامَ رَسُولُ
u'أَقَامَ زَوْجٌ':Subject, #1: 1	أَقَامَ زَادَ
u'أَقَامَ زَوْجٌ':Subject, #1: 1	أَقَامَ زَوْجُ
u'أَقَامَ زَيْدٌ':Subject, #25: 25	أَقَامَ الزَّوْجُ
u'أَقَامَ سَاكِنٌ':Subject, #1: 1	أَقَامَ زَيْدٌ
u'أَقَامَ سَبْعٌ':Predicate, #2: 2	أَقَامَ السَّاكِنُ
u'أَقَامَ سَبْعَةٌ':Predicate, #2: 2	أَقَامَ سَبْعَ
u'أَقَامَ سَعْدٌ':Subject, #1: 1	أَقَامَ سَبْعَةَ
u'أَقَامَ سِقَايَةٌ':Predicate, #1: 1	أَقَامَ سَعْدٌ
u'أَقَامَ سُنَّةٌ':Predicate, #1: 1	أَقَامَ سِقَايَةَ
u'أَقَامَ سَيِّدٌ':Subject, #1: 1	أَقَامَ السُّنَّةَ
u'أَقَامَ شافِعِيّ':Subject, #4: 4	أَقَامَ السَّيِّدُ
u'أَقَامَ شَاهِدٌ':Subject, #1: 1	أَقَامَ الشَّافِعِيُّ
u'أَقَامَ شَاهِدٌ':Subject, #1: 1	أَقَامَ شَاهِدٌ
u'أَقَامَ شُبْهَةٌ':Predicate, #2: 2	أَقَامَ الشَّاهِدُ
u'أَقَامَ شَخْصٌ':Subject, #1: 1	أَقَامَ شُبْهَةَ
u'أَقَامَ شَرْعٌ':Subject, #2: 2	أَقَامَ شَخْصٌ
u'أَقَامَ شَرِيكٌ':Subject, #1: 1	أَقَامَ الشَّرْعُ
u'أَقَامَ شَطْرٌ':Predicate, #1: 1	أَقَامَ الشَّرِيكُ
u'أَقَامَ شَفِيعٌ':Subject, #1: 1	أَقَامَ شَطْرَ
u'أَقَامَ شَهَادَةٌ':Predicate, #7: 7	أَقَامَ الشَّفِيعُ
u'أَقَامَ شَهْرٌ':Predicate, #2: 2	أَقَامَ الشَّهَادَةَ
u'أَقَامَ شَهْرٌ':Predicate, #1: 1	أَقَامَ الشَّهْرَ
u'أَقَامَ شُهُودٌ':Subject, #1: 1	أَقَامَ شَهْرَ
u'أَقَامَ شَيْءٌ':Predicate, #1: 1	أَقَامَ الشُّهُودُ
u'أَقَامَ شَيْخٌ':Subject, #1: 1	أَقَامَ الشَّيْءَ
u'أَقَامَ صَاحِبٌ':Subject, #1: 1	أَقَامَ الشَّيْخُ
u'أَقَامَ صَلاَةٌ':Predicate, #17: 17	أَقَامَ صَاحِبُ
u'أَقَامَ صَلاَةٌ':Predicate, #11: 11	أَقَامَ الصَّلاَةَ
u'أَقَامَ طَالِبٌ':Subject, #4: 4	أَقَامَ الصَّلَاةَ
u'أَقَامَ طعام':Predicate, #7: 7	أَقَامَ الطَّالِبُ
u'أَقَامَ طَعَامٌ':Predicate, #1: 1	أَقَامَ الطَّعَامَ
u'أَقَامَ ظَنٌّ':Predicate, #1: 1	أَقَامَ الطَّعَامَ
u'أَقَامَ عَادَةٌ':Predicate, #1: 1	أَقَامَ الظَّنَّ
u'أَقَامَ عَامٌ':Predicate, #1: 1	أَقَامَ الْعَادَةَ
u'أَقَامَ عَبْدٌ':Subject, #1: 1	أَقَامَ عَامَ
u'أَقَامَ عَبْدٌ':Subject, #20: 20	أَقَامَ الْعَبْدُ
u'أَقَامَ عَبْدٌ':Subject, #2: 2	أَقَامَ عَبْدٌ
u'أَقَامَ عَجُوزٌ':Predicate, #4: 4	أَقَامَ عَبْدُ
u'أَقَامَ عَدْلٌ':Subject, #1: 1	أَقَامَ الْعَجُوزَ
u'أَقَامَ عَدُوٌّ':Subject, #1: 1	أَقَامَ الْعَدْلُ
u'أَقَامَ عَسْكَرٌ':Subject, #1: 1	أَقَامَ الْعَدُوُّ
u'أَقَامَ عِشَاءٌ':Predicate, #1: 1	أَقَامَ الْعَسْكَرُ
u'أَقَامَ عصبة':Predicate, #3: 3	أَقَامَ الْعِشَاءَ
u'أَقَامَ عَصَبَةٌ':Predicate, #1: 1	أَقَامَ عَصَبَةَ
u'أَقَامَ عَصْرٌ':Predicate, #1: 1	أَقَامَ عَصَبَةَ
u'أَقَامَ عُمَرٌ':Subject, #1: 1	أَقَامَ الْعَصْرَ
u'أَقَامَ عند':Predicate, #1: 1	أَقَامَ عُمَرُ
u'أَقَامَ عند':Predicate, #1: 1	أَقَامَ عِنْدَهُنَّ
u'أَقَامَ عِيدٌ':Predicate, #22: 22	أَقَامَ عِنْدَ
u'أَقَامَ غَاصِبٌ':Subject, #1: 1	أَقَامَ الْعِيدَ
u'أَقَامَ غَرِيمٌ':Subject, #8: 8	أَقَامَ الْغَاصِبُ
u'أَقَامَ غُلاَمٌ':Subject, #7: 7	أَقَامَ الْغَرِيمُ
u'أَقَامَ غير':Subject, #2: 2	أَقَامَ الْغُلَامُ
u'أَقَامَ غَيْرٌ':Subject, #1: 1	أَقَامَ غَيْرُ
u'أَقَامَ غير':Subject, #1: 1	أَقَامَ غَيْرُ
u'أَقَامَ غَيْرٌ':Subject, #5: 5	أَقَامَ غَيْرُهُ
u'أَقَامَ فلان':Subject, #5: 5	أَقَامَ غَيْرُهُ
u'أَقَامَ فلان':Subject, #1: 1	أَقَامَ الشَّافِعِيُّ
u'أَقَامَ فلان':Subject, #1: 1	أَقَامَ بِلَالٌ
u'أَقَامَ فلان':Subject, #1: 1	أَقَامَ بِلاَلٌ
u'أَقَامَ قَاتِلٌ':Subject, #2: 2	أَقَامَ عُثْمَانُ
u'أَقَامَ قَاذِفٌ':Subject, #5: 5	أَقَامَ الْقَاتِلُ
u'أَقَامَ قتل':Predicate, #5: 5	أَقَامَ الْقَاذِفُ
u'أَقَامَ قول':Subject, #1: 1	أَقَامَ قَتَلَ
u'أَقَامَ قَوْلٌ':Subject, #1: 1	أَقَامَ الْقَوْلُ
u'أَقَامَ قَوْمٌ':Subject, #1: 1	أَقَامَ الْقَوْلُ
u'أَقَامَ قَيِّمٌ':Subject, #2: 2	أَقَامَ قَوْمٌ
u'أَقَامَ قَيِّمٌ':Subject, #1: 1	أَقَامَ الْقَيِّمُ
u'أَقَامَ قِيمَةٌ':Predicate, #1: 1	أَقَامَ قَيِّمُ
u'أَقَامَ كَافِرٌ':Subject, #1: 1	أَقَامَ الْقِيمَةَ
u'أَقَامَ كَفِيلٌ':Subject, #1: 1	أَقَامَ كَافِرٌ
u'أَقَامَ كَلاَمٌ':Predicate, #3: 3	أَقَامَ الْكَفِيلُ
u'أَقَامَ مَالٌ':Subject, #1: 1	أَقَامَ الْكَلَامَ
u'أَقَامَ مَالِكٌ':Subject, #2: 2	أَقَامَ الْمَالُ
u'أَقَامَ مَالِكٌ':Subject, #1: 1	أَقَامَ مَالِكٌ
u'أَقَامَ مَأْمُورٌ':Subject, #7: 7	أَقَامَ الْمَالِكُ
u'أَقَامَ مَحْبُوسٌ':Subject, #2: 2	أَقَامَ الْمَأْمُورُ
u'أَقَامَ مُحْتَالٌ':Subject, #1: 1	أَقَامَ الْمَحْبُوسُ
u'أَقَامَ مَحْكُومٌ':Subject, #1: 1	أَقَامَ الْمُحْتَالُ
u'أَقَامَ مُحَمَّدٌ':Subject, #1: 1	أَقَامَ الْمَحْكُومُ
u'أَقَامَ مَخْرَجٌ':Predicate, #2: 2	أَقَامَ مُحَمَّدٌ
u'أَقَامَ مُدَّةٌ':Predicate, #1: 1	أَقَامَ الْمَخْرَجَ
u'أَقَامَ مَدْيُونٌ':Subject, #1: 1	أَقَامَ مُدَّةَ
u'أَقَامَ مُرْتَهِنٌ':Subject, #2: 2	أَقَامَ الْمَدْيُونُ
u'أَقَامَ مُسَافِرٌ':Subject, #3: 3	أَقَامَ الْمُرْتَهِنُ
u'أَقَامَ مُسْتَأْجِرٌ':Subject, #5: 5	أَقَامَ الْمُسَافِرُ
u'أَقَامَ مُسْتَحِقٌّ':Subject, #2: 2	أَقَامَ الْمُسْتَأْجِرُ
u'أَقَامَ مُسْتَعِيرٌ':Subject, #2: 2	أَقَامَ الْمُسْتَحِقُّ
u'أَقَامَ مُسْتَهْلِكٌ':Subject, #3: 3	أَقَامَ الْمُسْتَعِيرُ
u'أَقَامَ مُسْلِمٌ':Subject, #1: 1	أَقَامَ الْمُسْتَهْلِكُ
u'أَقَامَ مُسْلِمٌ':Subject, #2: 2	أَقَامَ الْمُسْلِمُ
u'أَقَامَ مَشْهُودٌ':Subject, #5: 5	أَقَامَ مُسْلِمٌ
u'أَقَامَ مُصَرِّحٌ':Subject, #7: 7	أَقَامَ الْمَشْهُودُ
u'أَقَامَ مُضَارِبٌ':Subject, #1: 1	أَقَامَ الْمُصَرِّحُ
u'أَقَامَ مَغْرِبٌ':Predicate, #3: 3	أَقَامَ الْمُضَارِبُ
u'أَقَامَ مَغْصُوب':Subject, #2: 2	أَقَامَ الْمَغْرِبَ
u'أَقَامَ مَقْذُوفٌ':Subject, #1: 1	أَقَامَ الْمَغْصُوبُ
u'أَقَامَ مَقْضِيّ':Subject, #1: 1	أَقَامَ الْمَقْذُوفُ
u'أَقَامَ مَقْطُوعٌ':Subject, #2: 2	أَقَامَ الْمَقْضِيُّ
u'أَقَامَ مَقْطُوعَةٌ':Subject, #1: 1	أَقَامَ الْمَقْطُوعَةُ
u'أَقَامَ مَكْفُولٌ':Subject, #1: 1	أَقَامَ الْمَقْطُوعَةُ
u'أَقَامَ مُلْتَقِط':Subject, #1: 1	أَقَامَ الْمَكْفُولُ
u'أَقَامَ مَنَارٌ':Predicate, #1: 1	أَقَامَ الْمُلْتَقِطُ
u'أَقَامَ مُؤَجِّرٌ':Subject, #1: 1	أَقَامَ مَنَارَ
u'أَقَامَ مُودِعٌ':Subject, #1: 1	أَقَامَ الْمُؤَجِّرُ
u'أَقَامَ مُؤَذِّنٌ':Subject, #5: 5	أَقَامَ الْمُودِعُ
u'أَقَامَ مُوَكِّلٌ':Subject, #7: 7	أَقَامَ الْمُؤَذِّنُ
u'أَقَامَ مَوْهُوبٌ':Subject, #2: 2	أَقَامَ الْمُوَكِّلُ
u'أَقَامَ نَاسٌ':Subject, #2: 2	أَقَامَ الْمَوْهُوبُ
u'أَقَامَ نَاظِرٌ':Subject, #1: 1	أَقَامَ النَّاسُ
u'أَقَامَ نَبِيٌّ':Subject, #1: 1	أَقَامَ النَّاظِرُ
u'أَقَامَ نُسُكٌ':Predicate, #4: 4	أَقَامَ النَّبِيُّ
u'أَقَامَ نَصْرَانِيٌّ':Subject, #1: 1	أَقَامَ النُّسُكَ
u'أَقَامَ نَصْرَانِيٌّ':Subject, #1: 1	أَقَامَ نَصْرَانِيٌّ
u'أَقَامَ نِصْفٌ':Predicate, #2: 2	أَقَامَ النَّصْرَانِيُّ
u'أَقَامَ نُكُولٌ':Predicate, #1: 1	أَقَامَ النِّصْفَ
u'أَقَامَ واحد':Subject, #1: 1	أَقَامَ النُّكُولَ
u'أَقَامَ وَاحِدٌ':Subject, #1: 1	أَقَامَ الْوَاحِدُ
u'أَقَامَ واحد':Subject, #1: 1	أَقَامَ الْوَاحِدُ
u'أَقَامَ وَاحِدٌ':Subject, #5: 5	أَقَامَ وَاحِدٌ
u'أَقَامَ وَارِثٌ':Subject, #5: 5	أَقَامَ وَاحِدٌ
u'أَقَامَ وَارِثٌ':Subject, #1: 1	أَقَامَ وَارِثُهُ
u'أَقَامَ وَاهِبٌ':Subject, #4: 4	أَقَامَ الْوَارِثُ
u'أَقَامَ وَرَثَةٌ':Subject, #2: 2	أَقَامَ الْوَاهِبُ
u'أَقَامَ وَرَثَةٌ':Subject, #1: 1	أَقَامَ وَرَثَةُ
u'أَقَامَ وَصِيٌّ':Predicate, #4: 4	أَقَامَ الْوَرَثَةُ
u'أَقَامَ وَصِيٌّ':Subject, #1: 1	أَقَامَ الْوَصِيَّ
u'أَقَامَ وَكِيلٌ':Predicate, #1: 1	أَقَامَ وَصِيُّهُ
u'أَقَامَ وَكِيلٌ':Subject, #1: 1	أَقَامَ الْوَكِيلَ
u'أَقَامَ ولد':Subject, #5: 5	أَقَامَ الْوَكِيلُ
u'أَقَامَ وَلَدٌ':Subject, #1: 1	أَقَامَ الْوَلَدُ
u'أَقَامَ وَلِيٌّ':Subject, #1: 1	أَقَامَ الْوَلَدُ
u'أَقَامَ يَدٌ':Predicate, #1: 1	أَقَامَ وَلِيُّ
u'أَقَامَ يَوْمٌ':Predicate, #1: 1	أَقَامَ يَدَ
u'أَقْبَالٌ نِساءٌ':Added, #1: 1	أَقَامَ يَوْمَ
u'أَقْبَحَ بُخْلٌ':Predicate, #3: 3	أَقْبَالِ النِّسَاءِ
u'أَقْبَحَ تَزْهِيدٌ':Predicate, #1: 1	أَقْبَحَ الْبُخْلَ
u'أَقْبَحَ تَفْرِيطٌ':Predicate, #1: 1	أَقْبَحَ التَّزْهِيدَ
u'أَقْبَحَ قَارِئٌ':Predicate, #1: 1	أَقْبَحَ التَّفْرِيطَ
u'أَقْبَحَ كذب':Predicate, #1: 1	أَقْبَحَ الْقَارِئَ
u'أَقْبَحَ كَذِبٌ':Predicate, #1: 1	أَقْبَحَ الْكَذِبَ
u'أَقْبَلَ اِبْنٌ':Subject, #1: 1	أَقْبَحَ الْكَذِبَ
u'أَقْبَلَ أَصْحَابٌ':Subject, #2: 2	أَقْبَلَ ابْنُ
u'أَقْبَلَ أعْرَابِيٌّ':Subject, #1: 1	أَقْبَلَ أَصْحَابُ
u'أَقْبَلَ بَعْضٌ':Subject, #1: 1	أَقْبَلَ أَعْرَابِيٌّ
u'أَقْبَلَ ثَلاثَةٌ':Subject, #1: 1	أَقْبَلَ الْبَعْضُ
u'أَقْبَلَ ثَلاثَةٌ':Subject, #1: 1	أَقْبَلَ ثَلاثَةُ
u'أَقْبَلَ حَسَنٌ':Subject, #1: 1	أَقْبَلَ ثَلاَثَةُ
u'أَقْبَلَ رَاكِبٌ':Subject, #1: 1	أَقْبَلَ الْحَسَنُ
u'أَقْبَلَ رَجُلٌ':Subject, #1: 1	أَقْبَلَ رَاكِبٌ
u'أَقْبَلَ رَجُلٌ':Subject, #19: 19	أَقْبَلَ رَجُلٌ
u'أَقْبَلَ رَسُولٌ':Subject, #1: 1	أَقْبَلَ الرَّجُلُ
u'أَقْبَلَ رَكْبٌ':Subject, #20: 20	أَقْبَلَ رَسُولُ
u'أَقْبَلَ سَعْدٌ':Subject, #1: 1	أَقْبَلَ رَكْبٌ
u'أَقْبَلَ شَيْخٌ':Subject, #2: 2	أَقْبَلَ سَعْدٌ
u'أَقْبَلَ ظَلامٌ':Subject, #1: 1	أَقْبَلَ شَيْخٌ
u'أَقْبَلَ عَبَّاسٌ':Subject, #1: 1	أَقْبَلَ الظَّلَامُ
u'أَقْبَلَ عَبْدٌ':Subject, #1: 1	أَقْبَلَ الْعَبَّاسُ
u'أَقْبَلَ عَبْدٌ':Subject, #1: 1	أَقْبَلَ عَبْدٌ
u'أَقْبَلَ عَدُوٌّ':Subject, #2: 2	أَقْبَلَ عَبْدُ
u'أَقْبَلَ عقبة':Subject, #1: 1	أَقْبَلَ الْعَدُوُّ
u'أَقْبَلَ عُقْبَةٌ':Subject, #1: 1	أَقْبَلَ عُقْبَةُ
u'أَقْبَلَ عَلِيٌّ':Subject, #1: 1	أَقْبَلَ عُقْبَةُ
u'أَقْبَلَ عُمَرٌ':Subject, #1: 1	أَقْبَلَ عَلِيُّ
u'أَقْبَلَ غير':Predicate, #6: 6	أَقْبَلَ عُمَرُ
u'أَقْبَلَ غَيْرٌ':Predicate, #1: 1	أَقْبَلَ غَيْرَ
u'أَقْبَلَ فلان':Subject, #1: 1	أَقْبَلَ غَيْرَ
u'أَقْبَلَ قَالٌ':Predicate, #2: 2	أَقْبَلَ عُثْمَانُ
u'أَقْبَلَ قَوْمٌ':Subject, #3: 3	أَقْبَلَ قَالَ
u'أَقْبَلَ لَيْلٌ':Subject, #1: 1	أَقْبَلَ الْقَوْمُ
u'أَقْبَلَ نَاسٌ':Subject, #8: 8	أَقْبَلَ اللَّيْلُ
u'أَقْبَلَ نَاسٌ':Subject, #1: 1	أَقْبَلَ النّاسُ
u'أَقْبَلَ نَبِيٌّ':Subject, #1: 1	أَقْبَلَ النَّاسُ
u'أَقْبَلَ نَحْوٌ':Predicate, #1: 1	أَقْبَلَ نَبِيُّ
u'أَقْبَلَ نَفَرٌ':Subject, #4: 4	أَقْبَلَ نَحْوَ
u'أَقْبَلَ هَدِيٌّ':Predicate, #2: 2	أَقْبَلَ نَفَرٌ
u'أَقْبَلَ يَوْمٌ':Predicate, #3: 3	أَقْبَلَ هَدِيَّةً
u'إقْحَامٌ قول':Added, #1: 1	أَقْبَلَ يَوْمَ
u'إقْحَامٌ قَوْلٌ':Added, #1: 1	إقْحَامَ قَوْلِهِ
u'إقْحَامٌ مثل':Added, #1: 1	إقْحَامَ قَوْلِهِ
u'إقْحَامٌ مِثْلٌ':Added, #1: 1	إقْحَامِ الْمِثْلِ
u'أَقْحَمَ كَلاَمٌ':Predicate, #1: 1	إقْحَامِ الْمِثْلِ
u'أَقْحَمَ لَفْظٌ':Predicate, #1: 1	أَقْحَمَ الْكَلَامَ
u'أَقْحَمَ لِوَاءٌ':Predicate, #1: 1	أَقْحَمَ لَفْظَ
u'إقْدَامٌ أَكْثَرُ':Added, #1: 1	أَقْحَمَ اللّوَاءَ
u'إقْدَامٌ الْمَرْءُ':Added, #1: 1	إقْدَامَ أَكْثَرِ
u'إقْدَامٌ بَائِعٌ':Added, #1: 1	إقْدَامَ الْمَرْءِ
u'إقْدَامٌ حاكِمٌ':Added, #1: 1	إقْدَامَ الْبَائِعِ
u'إقْدَامٌ خَلِيلٌ':Added, #1: 1	إقْدَامِ الْحَاكِمِ
u'إقْدَامٌ زَوْجٌ':Added, #1: 1	إقْدَامِ الْخَلِيلِ
u'إقْدَامٌ مُكْرَهٌ':Added, #1: 1	إقْدَامَ الزَّوْجَيْنِ
u'إقْدَامٌ مُنْكِرٌ':Added, #1: 1	إقْدَامِ الْمُكْرَهِ
u'أَقْدَمَ بَائِعٌ':Subject, #1: 1	إقْدَامَ الْمُنْكِرِ
u'أَقْدَمَ زَوْجٌ':Subject, #1: 1	أَقْدَمَ الْبَائِعُ
u'أَقْدَمَ غير':Predicate, #1: 1	أَقْدَمَ الزَّوْجُ
u'أَقْدَمَ غَيْرٌ':Predicate, #1: 1	أَقْدَمَ غَيْرَ
u'أَقْدَمَ فلان':Predicate, #1: 1	أَقْدَمَ غَيْرَ
u'أَقْدَمَ مَدِينٌ':Predicate, #1: 1	أَقْدَمَ خَيْبَرَ
u'أَقْدَمَ مَدِينَةٌ':Predicate, #2: 2	أَقْدَمَ الْمَدِينَةَ
u'أَقْذَارٌ جَاهِلِيٌّ':Added, #2: 2	أَقْدَمَ الْمَدِينَةَ
u'أَقْذَارٌ جَاهِلِيَّةٌ':Added, #1: 1	أَقْذَارِ الْجَاهِلِيّةِ
u'أَقْرَأَ اِبْنٌ':Subject, #1: 1	أَقْذَارِ الْجَاهِلِيّةِ
u'أَقَرَّ أَبٌ':Subject, #1: 1	أَقْرَأَ ابْنُ
u'أَقْرَأَ بَقَرٌ':Predicate, #9: 9	أَقَرَّ الْأَبُ
u'أَقَرَّ اِبْنٌ':Predicate, #1: 1	أَقْرَأَ الْبَقَرَةَ
u'أَقَرَّ اِبْنٌ':Subject, #1: 1	أَقَرَّ ابْنَ
u'أَقَرَّ اِبْنٌ':Subject, #2: 2	أَقَرَّ ابْنُ
u'أَقَرَّ أَجْنَبِيٌّ':Subject, #3: 3	أَقَرَّ ابْنٌ
u'أَقَرَّ أَجْنَبِيٌّ':Subject, #1: 1	أَقَرَّ أَجْنَبِيٌّ
u'أَقَرَّ أَجِيرٌ':Subject, #1: 1	أَقَرَّ الْأَجْنَبِيُّ
u'أَقَرَّ أحَدٌ':Subject, #4: 4	أَقَرَّ الْأَجِيرُ
u'أَقَرَّ أَخٌ':Subject, #33: 33	أَقَرَّ أَحَدُ
u'أَقَرَّ أخرَس':Subject, #3: 3	أَقَرَّ الْأَخُ
u'إقْرَارٌ أَبٌ':Added, #1: 1	أَقَرَّ الْأَخْرَسُ
u'إقْرَارٌ أَبٌ':Added, #1: 1	إقْرَارَ الْأَبِ
u'إقْرَارٌ أَبٌ':Added, #1: 1	إقْرَارُ الْأَبِ
u'إقْرَارٌ آباءٌ':Added, #4: 4	إقْرَارِ الْأَبِ
u'إقْرَارٌ اِبْنٌ':Added, #1: 1	إقْرَارَ الْآبَاءِ
u'إقْرَارٌ أَجْنَبِيٌّ':Added, #1: 1	إقْرَارِ ابْنِهِ
u'إقْرَارٌ أحَدٌ':Added, #1: 1	إقْرَارَ الْأَجْنَبِيِّ
u'إقْرَارٌ أحَدٌ':Added, #1: 1	إقْرَارَ أَحَدِ
u'إقْرَارٌ أحَدٌ':Added, #3: 3	إقْرَارُ أَحَدِ
u'إقْرَارٌ أَخٌ':Added, #3: 3	إقْرَارِ أَحَدِ
u'إقْرَارٌ أُسْتَاذٌ':Added, #1: 1	إقْرَارِ الْأَخِ
u'إقْرَارٌ أصل':Added, #1: 1	إقْرَارِ الْأُسْتَاذِ
u'إقْرَارٌ أًصْلٌ':Added, #3: 3	إقْرَارِ الْأَصْلِ
u'إقْرَارٌ أَصيلٌ':Added, #3: 3	إقْرَارِ الْأَصْلِ
u'إقْرَارٌ إقْرَارٌ':Added, #1: 1	إقْرَارَ الْأَصِيلِ
u'إقْرَارٌ الْمَرْءُ':Added, #1: 1	إقْرَارِ إقْرَارٍ
u'إقْرَارٌ الْمَرْأَةُ':Added, #2: 2	إقْرَارِ الْمَرْءِ
u'إقْرَارٌ الْمَرْأَةُ':Added, #10: 10	إقْرَارُ الْمَرْأَةِ
u'إقْرَارٌ الْمَرْأَةُ':Added, #20: 20	إقْرَارِ الْمَرْأَةِ
u'إقْرَارٌ إمَامٌ':Added, #3: 3	إقْرَارَ الْمَرْأَةِ
u'إقْرَارٌ إمَامٌ':Added, #1: 1	إقْرَارَ الْإِمَامِ
u'إقْرَارٌ اِمْرَأَةٌ':Added, #1: 1	إقْرَارُ الْإِمَامِ
u'إقْرَارٌ إِنْسانٌ':Added, #2: 2	إقْرَارِ امْرَأَةٍ
u'إقْرَارٌ إِنْسانٌ':Added, #2: 2	إقْرَارِ الْإِنْسَانِ
u'إقْرَارٌ إِنْسانٌ':Added, #3: 3	إقْرَارَ الْإِنْسَانِ
u'إقْرَارٌ آنِيَةٌ':Added, #3: 3	إقْرَارُ الْإِنْسَانِ
u'إقْرَارٌ أهْلٌ':Added, #1: 1	إقْرَارِ آنِيَةِ
u'إقْرَارٌ أَوَّلُ':Added, #1: 1	إقْرَارُ أَهْلِ
u'إقْرَارٌ بالِغٌ':Added, #2: 2	إقْرَارِ الْأَوَّلِ
u'إقْرَارٌ بَائِعٌ':Added, #1: 1	إقْرَارُ الْبَالِغَةِ
u'إقْرَارٌ بَائِعٌ':Added, #2: 2	إقْرَارَ الْبَائِعِ
u'إقْرَارٌ بَائِعٌ':Added, #35: 35	إقْرَارِ الْبَائِعِ
u'إقْرَارٌ بَزّاز':Added, #3: 3	إقْرَارُ الْبَائِعِ
u'إقْرَارٌ بَزّازَة':Added, #1: 1	إقْرَارِ الْبَزَّازِيَّةِ
u'أَقَرَّ أَرْبَعُ':Predicate, #1: 1	إقْرَارِ الْبَزَّازِيَّةِ
u'أَقَرَّ أَرْبَعَةٌ':Subject, #8: 8	أَقَرَّ أَرْبَعَ
u'إقْرَارٌ بَعْضٌ':Added, #1: 1	أَقَرَّ أَرْبَعَةٌ
u'إقْرَارٌ بَعْضٌ':Added, #1: 1	إقْرَارُ بَعْضِ
u'إقْرَارٌ بِكْرٌ':Added, #1: 1	إقْرَارِ بَعْضِ
u'إقْرَارٌ بِنَاءٌ':Added, #2: 2	إقْرَارُ بِكْرٍ
u'إقْرَارٌ بِنْتٌ':Added, #1: 1	إقْرَارِ الْبِنَاءِ
u'إقْرَارٌ تَلْخيصٌ':Added, #2: 2	إقْرَارِ الْبِنْتِ
u'إقْرَارٌ ثَلاثُ':Added, #1: 1	إقْرَارِ تَلْخِيصِ
u'إقْرَارٌ جَارِي':Added, #1: 1	إقْرَارُ الثَّلَاثِ
u'إقْرَارٌ جَارِي':Added, #1: 1	إقْرَارَ الْجَارِيَةِ
u'إقْرَارٌ جَارِيَةٌ':Added, #1: 1	إقْرَارِ جَارِيَةٍ
u'إقْرَارٌ جَارِيَةٌ':Added, #1: 1	إقْرَارَ الْجَارِيَةِ
u'إقْرَارٌ جَاهِلِيٌّ':Added, #1: 1	إقْرَارِ جَارِيَةٍ
u'إقْرَارٌ جَاهِلِيَّةٌ':Added, #1: 1	إقْرَارُ الْجَاهِلِيّةِ
u'إقْرَارٌ جُحُود':Added, #1: 1	إقْرَارُ الْجَاهِلِيّةِ
u'إقْرَارٌ حاكِمٌ':Added, #1: 1	إقْرَارِ الْجُحُودِ
u'إقْرَارٌ حُرٌّ':Added, #1: 1	إقْرَارَ الْحَاكِمِ
u'إقْرَارٌ خان':Added, #1: 1	إقْرَارِ الْحُرَّةِ
u'إقْرَارٌ خانَة':Added, #1: 1	إقْرَارِ الْخَانِيَّةِ
u'إقْرَارٌ خَرْسَاء':Added, #1: 1	إقْرَارِ الْخَانِيَّةِ
u'إقْرَارٌ خَصْمٌ':Added, #1: 1	إقْرَارُ الْخَرْسَاءِ
u'إقْرَارٌ خُصُومٌ':Added, #6: 6	إقْرَارِ الْخَصْمِ
u'إقْرَارٌ خُلاصَة':Added, #1: 1	إقْرَارَ الْخُصُومِ
u'إقْرَارٌ دَاخِلٌ':Added, #1: 1	إقْرَارِ الْخُلَاصَةِ
u'إقْرَارٌ دَلالَةٌ':Added, #4: 4	إقْرَارَ الدَّاخِلِ
u'إقْرَارٌ رَاهِنٌ':Added, #1: 1	إقْرَارَ دَلَالَةٍ
u'إقْرَارٌ رَاهِنٌ':Added, #3: 3	إقْرَارُ الرَّاهِنِ
u'إقْرَارٌ رَبُّ':Added, #7: 7	إقْرَارِ الرَّاهِنِ
u'إقْرَارٌ رَجُلٌ':Added, #1: 1	إقْرَارِ رَبِّ
u'إقْرَارٌ رَجُلٌ':Added, #1: 1	إقْرَارِ الرَّجُلَيْنِ
u'إقْرَارٌ رَجُلٌ':Added, #2: 2	إقْرَارَ رَجُلٍ
u'إقْرَارٌ رَجُلٌ':Added, #2: 2	إقْرَارُ رَجُلٍ
u'إقْرَارٌ رَجُلٌ':Added, #5: 5	إقْرَارَ الرَّجُلِ
u'إقْرَارٌ رَجُلٌ':Added, #7: 7	إقْرَارِ رَجُلٍ
u'إقْرَارٌ رَجُلٌ':Added, #8: 8	إقْرَارِ الرَّجُلِ
u'إقْرَارٌ رَسُولٌ':Added, #9: 9	إقْرَارُ الرَّجُلِ
u'إقْرَارٌ رَشيدٌ':Added, #1: 1	إقْرَارُ الرّسُولِ
u'إقْرَارٌ زَكاةٌ':Added, #1: 1	إقْرَارِ الرَّشِيدِ
u'إقْرَارٌ زَوْجٌ':Added, #1: 1	إقْرَارِ الزَّكَاةِ
u'إقْرَارٌ زَوْجٌ':Added, #13: 13	إقْرَارِ الزَّوْجِ
u'إقْرَارٌ زَوْجٌ':Added, #1: 1	إقْرَارِ الزَّوْجَيْنِ
u'إقْرَارٌ زَوْجٌ':Added, #3: 3	إقْرَارَ الزَّوْجِ
u'إقْرَارٌ زَيْدٌ':Added, #6: 6	إقْرَارُ الزَّوْجِ
u'إقْرَارٌ سَارِقٌ':Added, #4: 4	إقْرَارِ زَيْدٍ
u'إقْرَارٌ سَائِرٌ':Added, #1: 1	إقْرَارِ السَّارِقِ
u'إقْرَارٌ سَفِيهٌ':Added, #1: 1	إقْرَارِ سَائِرِ
u'إقْرَارٌ سَفِيهٌ':Added, #2: 2	إقْرَارَ السَّفِيهِ
u'إقْرَارٌ سَكْرَان':Added, #3: 3	إقْرَارُ السَّفِيهَةِ
u'إقْرَارٌ سَيِّدٌ':Added, #2: 2	إقْرَارُ السَّكْرَانِ
u'إقْرَارٌ سَيِّدٌ':Added, #1: 1	إقْرَارِ سَيِّدِ
u'إقْرَارٌ سَيِّدٌ':Added, #1: 1	إقْرَارِ سَيِّدِهِ
u'إقْرَارٌ سَيِّدٌ':Added, #2: 2	إقْرَارَ السَّيِّدِ
u'إقْرَارٌ سَيِّدٌ':Added, #2: 2	إقْرَارُ سَيِّدِهِ
u'إقْرَارٌ سَيِّدٌ':Added, #3: 3	إقْرَارِ السَّيِّدِ
u'إقْرَارٌ شَاهِدٌ':Added, #4: 4	إقْرَارُ السَّيِّدِ
u'إقْرَارٌ شَخْصٌ':Added, #2: 2	إقْرَارُ الشَّاهِدِ
u'إقْرَارٌ شركاء':Added, #1: 1	إقْرَارُ الشَّخْصِ
u'إقْرَارٌ شَرِيكٌ':Added, #1: 1	إقْرَارِ شُرَكَاءِ
u'إقْرَارٌ شَرِيكٌ':Added, #1: 1	إقْرَارُ شَرِيكِ
u'إقْرَارٌ شُهُودٌ':Added, #2: 2	إقْرَارِ الشَّرِيكِ
u'إقْرَارٌ شَيْخٌ':Added, #3: 3	إقْرَارِ الشُّهُودِ
u'إقْرَارٌ صَاحِبٌ':Added, #1: 1	إقْرَارَ الشَّيْخِ
u'إقْرَارٌ صَاحِبٌ':Added, #1: 1	إقْرَارَ صَاحِبِ
u'إقْرَارٌ صَاحِبٌ':Added, #1: 1	إقْرَارِ صَاحِبِهِ
u'إقْرَارٌ صَبِيٌّ':Added, #6: 6	إقْرَارِ صَاحِبِ
u'إقْرَارٌ صَبِيٌّ':Added, #1: 1	إقْرَارُ صَبِيٍّ
u'إقْرَارٌ صَبِيٌّ':Added, #3: 3	إقْرَارَ الصَّبِيِّ
u'إقْرَارٌ صَبِيٌّ':Added, #3: 3	إقْرَارِ الصَّبِيِّ
u'إقْرَارٌ صِحَّةٌ':Added, #6: 6	إقْرَارُ الصَّبِيِّ
u'إقْرَارٌ صَحِيحٌ':Added, #1: 1	إقْرَارُ الصِّحَّةِ
u'إقْرَارٌ ضَمَانٌ':Added, #3: 3	إقْرَارِ الصَّحِيحِ
u'إقْرَارٌ ضَمَانٌ':Added, #1: 1	إقْرَارُ الضَّمَانِ
u'إقْرَارٌ طَالِبٌ':Added, #2: 2	إقْرَارَ الضَّمَانِ
u'إقْرَارٌ طَالِبٌ':Added, #2: 2	إقْرَارَ الطَّالِبِ
u'إقْرَارٌ ظاهِرٌ':Added, #2: 2	إقْرَارِ الطَّالِبِ
u'إقْرَارٌ عَاقِدٌ':Added, #1: 1	إقْرَارٍ ظَاهِرٍ
u'إقْرَارٌ عَامِلٌ':Added, #1: 1	إقْرَارَ الْعَاقِدِ
u'إقْرَارٌ عَامِلٌ':Added, #1: 1	إقْرَارُ الْعَامِلِ
u'إقْرَارٌ عَبْدٌ':Added, #1: 1	إقْرَارِ الْعَامِلِ
u'إقْرَارٌ عَبْدٌ':Added, #10: 10	إقْرَارَ الْعَبْدِ
u'إقْرَارٌ عَبْدٌ':Added, #19: 19	إقْرَارِ الْعَبْدِ
u'إقْرَارٌ عَبْدٌ':Added, #26: 26	إقْرَارُ الْعَبْدِ
u'إقْرَارٌ عُمَّالٌ':Added, #2: 2	إقْرَارِ عَبْدٍ
u'إقْرَارٌ عُيُونٌ':Added, #1: 1	إقْرَارِ الْعُمَّالِ
u'إقْرَارٌ غَاصِبٌ':Added, #1: 1	إقْرَارِ الْعُيُونِ
u'إقْرَارٌ غَاصِبٌ':Added, #2: 2	إقْرَارُ الْغَاصِبِ
u'إقْرَارٌ غَائِبٌ':Added, #5: 5	إقْرَارِ الْغَاصِبِ
u'إقْرَارٌ غَائِبٌ':Added, #1: 1	إقْرَارِ الْغَائِبِ
u'إقْرَارٌ غَرِيمٌ':Added, #2: 2	إقْرَارِ غَائِبٍ
u'إقْرَارٌ غَرِيمٌ':Added, #1: 1	إقْرَارَ الْغَرِيمِ
u'إقْرَارٌ غَرِيمٌ':Added, #1: 1	إقْرَارُ الْغَرِيمِ
u'إقْرَارٌ غَرِيمٌ':Added, #1: 1	إقْرَارِ الْغَرِيمِ
u'إقْرَارٌ غَرِيمٌ':Added, #1: 1	إقْرَارَ غَرِيمِ
u'إقْرَارٌ غير':Added, #1: 1	إقْرَارِ غَرِيمِهِ
u'إقْرَارٌ غَيْرٌ':Added, #1: 1	إقْرَارِ غَيْرِ
u'إقْرَارٌ غير':Added, #1: 1	إقْرَارِ غَيْرِ
u'إقْرَارٌ غَيْرٌ':Added, #2: 2	إقْرَارُ غَيْرِ
u'إقْرَارٌ غير':Added, #2: 2	إقْرَارُ غَيْرِ
u'إقْرَارٌ غَيْرٌ':Added, #2: 2	إقْرَارِ غَيْرِهِ
u'إقْرَارٌ غير':Added, #2: 2	إقْرَارِ غَيْرِهِ
u'إقْرَارٌ غَيْرٌ':Added, #3: 3	إقْرَارَ غَيْرِ
u'إقْرَارٌ غير':Added, #3: 3	إقْرَارَ غَيْرِ
u'إقْرَارٌ غَيْرٌ':Added, #3: 3	إقْرَارَ غَيْرِهِ
u'إقْرَارٌ فَاسِقٌ':Added, #3: 3	إقْرَارَ غَيْرِهِ
u'إقْرَارٌ فلان':Added, #1: 1	إقْرَارُ الْفَاسِقِ
u'إقْرَارٌ فلان':Added, #1: 1	إقْرَارِ الْبَزَّازِيَّةِ
u'إقْرَارٌ فُلاَنٌ':Added, #1: 1	إقْرَارِ الْخَانِيَّةِ
u'إقْرَارٌ فُلاَنٌ':Added, #1: 1	إقْرَارَ فُلَانٍ
u'إقْرَارٌ فُلاَنٌ':Added, #1: 1	إقْرَارِ فُلَانٍ
u'إقْرَارٌ فُلاَنٌ':Added, #2: 2	إقْرَارُ فُلَانٍ
u'إقْرَارٌ قَاتِلٌ':Added, #2: 2	إقْرَارِ فُلَانِ
u'إقْرَارٌ قَاتِلٌ':Added, #10: 10	إقْرَارِ الْقَاتِلِ
u'إقْرَارٌ كَامِلٌ':Added, #1: 1	إقْرَارَ الْقَاتِلِ
u'إقْرَارٌ كَذِبٌ':Added, #1: 1	إقْرَارَ الْكَامِلِ
u'إقْرَارٌ كَذِبٌ':Added, #1: 1	إقْرَارٍ كَذِبٍ
u'إقْرَارٌ كَفِيلٌ':Added, #1: 1	إقْرَارِ كَذِبٍ
u'إقْرَارٌ كَفِيلٌ':Added, #1: 1	إقْرَارُ الْكَفِيلِ
u'إقْرَارٌ مَالِكٌ':Added, #1: 1	إقْرَارِ الْكَفِيلِ
u'إقْرَارٌ مَالِكٌ':Added, #1: 1	إقْرَارَ الْمَالِكِ
u'إقْرَارٌ مَالِكٌ':Added, #1: 1	إقْرَارُ الْمَالِكِ
u'إقْرَارٌ مُتَعَاقِدٌ':Added, #1: 1	إقْرَارِ الْمَالِكِ
u'إقْرَارٌ مَجْنُونٌ':Added, #7: 7	إقْرَارِ الْمُتَعَاقِدَيْنِ
u'إقْرَارٌ مَجْنِيٌّ':Added, #1: 1	إقْرَارُ الْمَجْنُونِ
u'إقْرَارٌ مَجْهُولٌ':Added, #1: 1	إقْرَارُ الْمَجْنِيِّ
u'إقْرَارٌ مَحْبُوسٌ':Added, #1: 1	إقْرَارِ مَجْهُولِ
u'إقْرَارٌ مَحْجُورٌ':Added, #1: 1	إقْرَارُ الْمَحْبُوسِ
u'إقْرَارٌ مَحْجُورٌ':Added, #1: 1	إقْرَارِ الْمَحْجُورِ
u'إقْرَارٌ مُدَبَّرٌ':Added, #2: 2	إقْرَارُ الْمَحْجُورِ
u'إقْرَارٌ مَدْيُونٌ':Added, #1: 1	إقْرَارُ الْمُدَبَّرِ
u'إقْرَارٌ مَذْكُورٌ':Added, #1: 1	إقْرَارِ الْمَدْيُونِ
u'إقْرَارٌ مرٌّ':Added, #1: 1	إقْرَارِ الْمَذْكُورِ
u'إقْرَارٌ مرٌّ':Added, #1: 1	إقْرَارُ مَرَّتَيْنِ
u'إقْرَارٌ مُرْتَدٌّ':Added, #1: 1	إقْرَارِ مَرَّتَيْنِ
u'إقْرَارٌ مُرْتَدٌّ':Added, #1: 1	إقْرَارُ الْمُرْتَدِّ
u'إقْرَارٌ مُرْتَهِنٌ':Added, #2: 2	إقْرَارُ مُرْتَدٍّ
u'إقْرَارٌ مُرْتَهِنٌ':Added, #1: 1	إقْرَارَ الْمُرْتَهِنِ
u'إقْرَارٌ مَرَضٌ':Added, #3: 3	إقْرَارِ الْمُرْتَهِنِ
u'إقْرَارٌ مَرِيضٌ':Added, #1: 1	إقْرَارِ الْمَرَضِ
u'إقْرَارٌ مَرِيضٌ':Added, #14: 14	إقْرَارِ الْمَرِيضِ
u'إقْرَارٌ مَرِيضٌ':Added, #20: 20	إقْرَارُ الْمَرِيضِ
u'إقْرَارٌ مُسْتَأْجِرٌ':Added, #7: 7	إقْرَارَ الْمَرِيضِ
u'إقْرَارٌ مُسْتَحَقٌّ':Added, #1: 1	إقْرَارِ الْمُسْتَأْجِرِ
u'إقْرَارٌ مُسْتَحِقٌّ':Added, #1: 1	إقْرَارِ الْمُسْتَحَقِّ
u'إقْرَارٌ مُسْتَحِقٌّ':Added, #1: 1	إقْرَارُ الْمُسْتَحِقِّ
u'إقْرَارٌ مُسْتَوْدَعٌ':Added, #1: 1	إقْرَارِ الْمُسْتَحِقِّ
u'إقْرَارٌ مُشْتَرِي':Added, #1: 1	إقْرَارَ الْمُسْتَوْدَعِ
u'إقْرَارٌ مَشْهُودٌ':Added, #2: 2	إقْرَارِ مُشْتَرِيهِ
u'إقْرَارٌ مُصَدَّقٌ':Added, #1: 1	إقْرَارَ الْمَشْهُودِ
u'إقْرَارٌ مُضَارِبٌ':Added, #1: 1	إقْرَارُ الْمُصَدَّقِ
u'إقْرَارٌ مُضَارِبٌ':Added, #2: 2	إقْرَارُ الْمُضَارِبِ
u'إقْرَارٌ مُطْلَقٌ':Added, #3: 3	إقْرَارِ الْمُضَارِبِ
u'إقْرَارٌ مَعْزُولٌ':Added, #1: 1	إقْرَارٍ مُطْلَقٍ
u'إقْرَارٌ مُفْلِسٌ':Added, #1: 1	إقْرَارُ الْمَعْزُولِ
u'إقْرَارٌ مُفْلِسٌ':Added, #2: 2	إقْرَارُ الْمُفْلِسِ
u'إقْرَارٌ مَقْتُولٌ':Added, #2: 2	إقْرَارِ الْمُفْلِسِ
u'إقْرَارٌ مَقْذُوفٌ':Added, #5: 5	إقْرَارِ الْمَقْتُولِ
u'إقْرَارٌ مُكْرَهٌ':Added, #3: 3	إقْرَارِ الْمَقْذُوفِ
u'إقْرَارٌ مَكْفُولٌ':Added, #4: 4	إقْرَارُ الْمُكْرَهِ
u'إقْرَارٌ مِلْكٌ':Added, #3: 3	إقْرَارِ الْمَكْفُولِ
u'إقْرَارٌ مُمَيِّزٌ':Added, #1: 1	إقْرَارِ مِلْكِهِ
u'إقْرَارٌ مُمَيِّزٌ':Added, #1: 1	إقْرَارُ الْمُمَيِّزِ
u'إقْرَارٌ مُمَيِّزٌ':Added, #1: 1	إقْرَارِ الْمُمَيِّزِ
u'إقْرَارٌ مُنْيَةٌ':Added, #2: 2	إقْرَارِ مُمَيِّزٍ
u'إقْرَارٌ مُودَعٌ':Added, #2: 2	إقْرَارِ مُنْيَةِ
u'إقْرَارٌ مُودِعٌ':Added, #1: 1	إقْرَارَ الْمُودَعِ
u'إقْرَارٌ مُودَعٌ':Added, #1: 1	إقْرَارُ الْمُودِعِ
u'إقْرَارٌ مُوَرِّث':Added, #2: 2	إقْرَارِ الْمُودَعِ
u'إقْرَارٌ مُوَكِّلٌ':Added, #1: 1	إقْرَارِ الْمُوَرِّثِ
u'إقْرَارٌ مُوَكِّلٌ':Added, #1: 1	إقْرَارُ الْمُوَكِّلِ
u'إقْرَارٌ نَائِبٌ':Added, #1: 1	إقْرَارِ الْمُوَكِّلِ
u'إقْرَارٌ نَبِيٌّ':Added, #2: 2	إقْرَارُ نَائِبِهِ
u'إقْرَارٌ نَبِيٌّ':Added, #1: 1	إقْرَارَ النَّبِيِّ
u'إقْرَارٌ نَبِيٌّ':Added, #1: 1	إقْرَارُ النَّبِيِّ
u'إقْرَارٌ نَفْسٌ':Added, #1: 1	إقْرَارِ النَّبِيِّ
u'إقْرَارٌ نَفْسٌ':Added, #1: 1	إقْرَارِ نَفْسِهِ
u'إقْرَارٌ واحد':Added, #2: 2	إقْرَارَ نَفْسِهِ
u'إقْرَارٌ وَاحِدٌ':Added, #1: 1	إقْرَارُ وَاحِدٍ
u'إقْرَارٌ واحد':Added, #1: 1	إقْرَارُ وَاحِدٍ
u'إقْرَارٌ وَاحِدٌ':Added, #3: 3	إقْرَارٍ وَاحِدٍ
u'إقْرَارٌ وَارِثٌ':Added, #3: 3	إقْرَارٍ وَاحِدٍ
u'إقْرَارٌ وَارِثٌ':Added, #1: 1	إقْرَارَ الْوَارِثِ
u'إقْرَارٌ وَارِثٌ':Added, #1: 1	إقْرَارَ الْوَارِثَةِ
u'إقْرَارٌ وَارِثٌ':Added, #1: 1	إقْرَارَ وَارِثٍ
u'إقْرَارٌ وَارِثٌ':Added, #1: 1	إقْرَارَ وَارِثِ
u'إقْرَارٌ وَارِثٌ':Added, #1: 1	إقْرَارُ وَارِثٍ
u'إقْرَارٌ وَارِثٌ':Added, #1: 1	إقْرَارُ وَارِثِ
u'إقْرَارٌ وَاقِعٌ':Added, #3: 3	إقْرَارِ الْوَارِثِ
u'إقْرَارٌ وَاقِفٌ':Added, #1: 1	إقْرَارِ الْوَاقِعَاتِ
u'إقْرَارٌ وَاقِفٌ':Added, #1: 1	إقْرَارَ الْوَاقِفِ
u'إقْرَارٌ وَاقِفٌ':Added, #1: 1	إقْرَارُ الْوَاقِفِ
u'إقْرَارٌ وَالِدٌ':Added, #3: 3	إقْرَارِ الْوَاقِفِ
u'إقْرَارٌ وَالِدٌ':Added, #1: 1	إقْرَارَ الْوَالِدِ
u'إقْرَارٌ وَالِدٌ':Added, #1: 1	إقْرَارِ وَالِدِهِ
u'إقْرَارٌ وَاهِبٌ':Added, #2: 2	إقْرَارِ الْوَالِدِ
u'إقْرَارٌ وَرَثَةٌ':Added, #6: 6	إقْرَارِ الْوَاهِبِ
u'إقْرَارٌ وَرَثَةٌ':Added, #1: 1	إقْرَارَ الْوَرَثَةِ
u'إقْرَارٌ وَرَثَةٌ':Added, #1: 1	إقْرَارِ الْوَرَثَةِ
u'إقْرَارٌ وَصِيٌّ':Added, #3: 3	إقْرَارُ الْوَرَثَةِ
u'إقْرَارٌ وَصِيٌّ':Added, #1: 1	إقْرَارَ الْوَصِيِّ
u'إقْرَارٌ وَصِيٌّ':Added, #2: 2	إقْرَارُ الْوَصِيِّ
u'إقْرَارٌ وَكِيلٌ':Added, #6: 6	إقْرَارِ الْوَصِيِّ
u'إقْرَارٌ وَكِيلٌ':Added, #10: 10	إقْرَارِ الْوَكِيلِ
u'إقْرَارٌ وَكِيلٌ':Added, #13: 13	إقْرَارُ الْوَكِيلِ
u'إقْرَارٌ ولد':Added, #7: 7	إقْرَارَ الْوَكِيلِ
u'إقْرَارٌ وَلَدٌ':Added, #1: 1	إقْرَارُ الْوَلَدِ
u'إقْرَارٌ ولد':Added, #1: 1	إقْرَارُ الْوَلَدِ
u'إقْرَارٌ وَلَدٌ':Added, #1: 1	إقْرَارِ وَلَدِهِ
u'إقْرَارٌ وَلِيٌّ':Added, #1: 1	إقْرَارِ وَلَدِهِ
u'إقْرَارٌ وَلِيٌّ':Added, #1: 1	إقْرَارَ الْوَلِيِّ
u'إقْرَارٌ وَلِيٌّ':Added, #1: 1	إقْرَارُ الْوَلِيِّ
u'إقْرَارٌ يَتِيمٌ':Added, #4: 4	إقْرَارِ الْوَلِيِّ
u'أَقَرَّ أُسْتَاذٌ':Subject, #2: 2	إقْرَارِ الْيَتِيمِ
u'أَقْرَأَ سُورَةٌ':Predicate, #1: 1	أَقَرَّ الْأُسْتَاذُ
u'أَقْرَأَ علم':Predicate, #2: 2	أَقْرَأَ سُورَةَ
u'أَقْرَأَ عِلْمٌ':Predicate, #1: 1	أَقْرَأَ عِلْمَ
u'أَقْرَأَ قُرْآنٌ':Predicate, #1: 1	أَقْرَأَ عِلْمَ
u'أَقَرَّ إمَامٌ':Subject, #5: 5	أَقْرَأَ الْقُرْآنَ
u'أَقَرَّ آمِرٌ':Subject, #1: 1	أَقَرَّ الْإِمَامُ
u'أَقَرَّ إِنْسانٌ':Subject, #4: 4	أَقَرَّ الْآمِرُ
u'أَقَرَّ أهْلٌ':Predicate, #1: 1	أَقَرَّ إنْسَانٌ
u'أَقَرَّ أهْلٌ':Subject, #2: 2	أَقَرَّ أَهْلَ
u'أَقَرَّ أَوَّلُ':Subject, #2: 2	أَقَرَّ أَهْلُهُ
u'أَقَرَّ بالِغٌ':Subject, #2: 2	أَقَرَّ الْأَوَّلُ
u'أَقَرَّ بَائِعٌ':Subject, #1: 1	أَقَرَّ الْبَالِغُ
u'أَقَرَّ بَائِعٌ':Subject, #1: 1	أَقَرَّ بَائِعُ
u'أَقْرَبَ جَازٌ':Predicate, #41: 41	أَقَرَّ الْبَائِعُ
u'أَقْرَبَ سقط':Predicate, #5: 5	أَقْرَبَ جَازَ
u'أَقْرَبَ سَقَطٌ':Predicate, #1: 1	أَقْرَبَ سَقَطَ
u'أَقَرَّ بَطَلٌ':Predicate, #1: 1	أَقْرَبَ سَقَطَ
u'أَقَرَّ بَعْضٌ':Subject, #1: 1	أَقَرَّ بَطَلَ
u'أَقْرَبَ قَالٌ':Predicate, #2: 2	أَقَرَّ بَعْضُ
u'أَقْرَبَ نَبِيٌّ':Predicate, #1: 1	أَقْرَبَ قَالَ
u'أَقْرَبَ وَاقِعٌ':Subject, #1: 1	أَقْرَبَ النَّبِيِّينَ
u'أَقَرَّ بَيْعٌ':Predicate, #1: 1	أَقْرَبَ الْوَاقِعُ
u'أَقَرَّ بَيْنٌ':Predicate, #1: 1	أَقَرَّ بَيْعَ
u'أَقَرَّ جَازٌ':Predicate, #5: 5	أَقَرَّ بَيْنَ
u'أَقَرَّ حاضِرٌ':Subject, #1: 1	أَقَرَّ جَازَ
u'أَقَرَّ حاكِمٌ':Subject, #2: 2	أَقَرَّ الْحَاضِرُ
u'أَقَرَّ حالٌ':Predicate, #1: 1	أَقَرَّ الْحَاكِمُ
u'أَقَرَّ حالَةٌ':Predicate, #2: 2	أَقَرَّ حَالَ
u'أَقَرَّ حُرٌّ':Subject, #1: 1	أَقَرَّ حَالَةَ
u'أَقَرَّ حُرٌّ':Subject, #1: 1	أَقَرَّ حُرٌّ
u'أَقَرَّ حَكَمٌ':Predicate, #8: 8	أَقَرَّ الْحُرُّ
u'أَقَرَّ حَلٌّ':Predicate, #2: 2	أَقَرَّ حَكَمَ
u'أَقَرَّ خَصْمٌ':Subject, #1: 1	أَقَرَّ حَلَّ
u'أَقَرَّ خَصِيٌّ':Subject, #7: 7	أَقَرَّ الْخَصْمُ
u'أَقَرَّ خَمْسٌ':Predicate, #2: 2	أَقَرَّ الْخَصِيُّ
u'أَقَرَّ دَافِعٌ':Subject, #1: 1	أَقَرَّ خَمْسَ
u'أَقَرَّ ذِمِّيٌّ':Subject, #2: 2	أَقَرَّ الدَّافِعُ
u'أَقَرَّ ذِمِّيٌّ':Subject, #1: 1	أَقَرَّ ذِمِّيٌّ
u'أَقَرَّ رَاهِنٌ':Subject, #2: 2	أَقَرَّ الذِّمِّيُّ
u'أَقَرَّ رَبُّ':Subject, #11: 11	أَقَرَّ الرَّاهِنُ
u'أَقَرَّ رَجُلٌ':Subject, #9: 9	أَقَرَّ رَبُّ
u'أَقَرَّ رَجُلٌ':Subject, #14: 14	أَقَرَّ رَجُلٌ
u'أَقَرَّ رَسُولٌ':Subject, #54: 54	أَقَرَّ الرَّجُلُ
u'أَقَرَّ رَوْضٌ':Predicate, #2: 2	أَقَرَّ الرَّسُولُ
u'أَقَرَّ زَارِعٌ':Subject, #1: 1	أَقَرَّ الرَّوْضَ
u'أَقَرَّ زَوْجٌ':Subject, #1: 1	أَقَرَّ الزَّارِعُ
u'أَقَرَّ زَيْدٌ':Subject, #37: 37	أَقَرَّ الزَّوْجُ
u'أَقَرَّ زَيْدٌ':Subject, #1: 1	أَقَرَّ زَيْدُ
u'أَقَرَّ سَارِقٌ':Subject, #2: 2	أَقَرَّ زَيْدٌ
u'أَقَرَّ سَاكِنٌ':Subject, #3: 3	أَقَرَّ السَّارِقُ
u'أَقَرَّ سَفِيهٌ':Subject, #1: 1	أَقَرَّ السَّاكِنُ
u'أَقَرَّ سَيِّدٌ':Subject, #1: 1	أَقَرَّ السَّفِيهُ
u'أَقَرَّ شَاهِدٌ':Subject, #8: 8	أَقَرَّ السَّيِّدُ
u'أَقَرَّ شَخْصٌ':Subject, #1: 1	أَقَرَّ الشَّاهِدُ
u'أَقَرَّ شِرَاءٌ':Predicate, #2: 2	أَقَرَّ شَخْصٌ
u'أَقَرَّ شركاء':Subject, #1: 1	أَقَرَّ الشِّرَاءَ
u'أَقَرَّ شَرِيكٌ':Subject, #1: 1	أَقَرَّ شُرَكَاءُ
u'أَقَرَّ شَفِيعٌ':Subject, #1: 1	أَقَرَّ شَرِيكُهُ
u'أَقَرَّ شُهُودٌ':Subject, #1: 1	أَقَرَّ الشَّفِيعُ
u'أَقَرَّ صَاحِبٌ':Subject, #1: 1	أَقَرَّ الشُّهُودُ
u'أَقَرَّ صَانِعٌ':Subject, #6: 6	أَقَرَّ صَاحِبُ
u'أَقَرَّ صَبِيٌّ':Subject, #1: 1	أَقَرَّ الصَّانِعُ
u'أَقَرَّ صَحِيحٌ':Subject, #5: 5	أَقَرَّ الصَّبِيُّ
u'أَقَرَّ صلح':Subject, #1: 1	أَقَرَّ الصَّحِيحُ
u'أَقَرَّ صُلْحٌ':Subject, #1: 1	أَقَرَّ الصُّلْحُ
u'أَقْرَضَ أحَدٌ':Subject, #1: 1	أَقَرَّ الصُّلْحُ
u'أَقَرَّ ضَارِبٌ':Subject, #1: 1	أَقْرَضَ أَحَدُ
u'أَقْرَضَ بَذْرٌ':Predicate, #1: 1	أَقَرَّ الضَّارِبُ
u'أَقْرَضَ دَرَاهِمُ':Predicate, #1: 1	أَقْرَضَ الْبَذْرَ
u'أَقْرَضَ دَرَاهِمُ':Predicate, #1: 1	أَقْرَضَ دَرَاهِمَ
u'أَقْرَضَ رَجُلٌ':Predicate, #2: 2	أَقْرَضَ الدَّرَاهِمَ
u'أَقْرَضَ رَجُلٌ':Subject, #1: 1	أَقْرَضَ رَجُلاً
u'أَقْرَضَ رَجُلٌ':Subject, #2: 2	أَقْرَضَ رَجُلٌ
u'أَقْرَضَ عَبْدٌ':Predicate, #4: 4	أَقْرَضَ الرَّجُلُ
u'أَقْرَضَ مَاءٌ':Predicate, #1: 1	أَقْرَضَ الْعَبْدَ
u'أَقْرَضَ مَالٌ':Predicate, #1: 1	أَقْرَضَ الْمَاءَ
u'أَقْرَضَ نَصْرَانِيٌّ':Subject, #5: 5	أَقْرَضَ مَالَ
u'أَقْرَضَ وَدِيعٌ':Predicate, #2: 2	أَقْرَضَ النَّصْرَانِيُّ
u'أَقْرَضَ وَدِيعَةٌ':Predicate, #1: 1	أَقْرَضَ الْوَدِيعَةَ
u'أَقْرَضَ وَصِيٌّ':Subject, #1: 1	أَقْرَضَ الْوَدِيعَةَ
u'أَقَرَّ طَالِبٌ':Subject, #2: 2	أَقْرَضَ الْوَصِيُّ
u'أَقَرَّ ظالِمٌ':Subject, #9: 9	أَقَرَّ الطَّالِبُ
u'أَقْرَعَ أسْوَد':Predicate, #1: 1	أَقَرَّ الظَّالِمُ
u'أَقَرَّ عَامِلٌ':Subject, #1: 1	أَقْرَعَ أَسْوَدَ
u'أَقَرَّ عَامِلٌ':Subject, #1: 1	أَقَرَّ الْعَامِلُ
u'أَقَرَّ عَبْدٌ':Subject, #1: 1	أَقَرَّ عَامِلُ
u'أَقَرَّ عَبْدٌ':Subject, #2: 2	أَقَرَّ عَبْدُ
u'أَقَرَّ عَبْدٌ':Subject, #73: 73	أَقَرَّ الْعَبْدُ
u'أَقْرَعَ بَيْنٌ':Predicate, #7: 7	أَقَرَّ عَبْدٌ
u'أَقْرَعَ بَيْنٌ':Predicate, #22: 22	أَقْرَعَ بَيْنَ
u'أَقْرَعَ حَديثٌ':Predicate, #4: 4	أَقْرَعَ بَيْنَهُنَّ
u'أَقَرَّ عَدْلٌ':Subject, #1: 1	أَقْرَعَ الْحَدِيثَ
u'أَقْرَعَ غير':Subject, #3: 3	أَقَرَّ الْعَدْلُ
u'أَقْرَعَ غَيْرٌ':Subject, #1: 1	أَقْرَعَ غَيْرُهُ
u'أَقْرَعَ قَالٌ':Predicate, #1: 1	أَقْرَعَ غَيْرُهُ
u'أَقْرَعَ مرٌّ':Predicate, #1: 1	أَقْرَعَ قَالَ
u'أَقَرَّ عُمَرٌ':Subject, #1: 1	أَقْرَعَ مَرَّةً
u'أَقْرَعَ نَبِيٌّ':Subject, #1: 1	أَقَرَّ عُمَرُ
u'أَقَرَّ عند':Predicate, #2: 2	أَقْرَعَ النَّبِيُّ
u'أَقْرَعَ وَارِثٌ':Subject, #28: 28	أَقَرَّ عِنْدَ
u'أَقْرَعَ وَرَثَةٌ':Subject, #2: 2	أَقْرَعَ وَارِثُهُ
u'أَقَرَّ غَاصِبٌ':Subject, #1: 1	أَقْرَعَ وَرَثَتُهُ
u'أَقَرَّ غَائِبٌ':Subject, #6: 6	أَقَرَّ الْغَاصِبُ
u'أَقَرَّ غرماء':Subject, #1: 1	أَقَرَّ الْغَائِبُ
u'أَقَرَّ غرماء':Subject, #1: 1	أَقَرَّ الْغُرَمَاءُ
u'أَقَرَّ غَرِيمٌ':Subject, #1: 1	أَقَرَّ غُرَمَاءُ
u'أَقَرَّ غير':Subject, #16: 16	أَقَرَّ الْغَرِيمُ
u'أَقَرَّ غَيْرٌ':Subject, #2: 2	أَقَرَّ غَيْرُ
u'أَقَرَّ فُلاَنٌ':Subject, #2: 2	أَقَرَّ غَيْرُ
u'أَقَرَّ فُلاَنٌ':Subject, #17: 17	أَقَرَّ فُلَانُ
u'أَقَرَّ قَابِضٌ':Subject, #54: 54	أَقَرَّ فُلَانٌ
u'أَقَرَّ قَاتِلٌ':Subject, #1: 1	أَقَرَّ الْقَابِضُ
u'أَقَرَّ قَاطِعٌ':Subject, #3: 3	أَقَرَّ الْقَاتِلُ
u'أَقَرَّ قَالٌ':Predicate, #5: 5	أَقَرَّ الْقَاطِعُ
u'أَقَرَّ قَائِلٌ':Subject, #1: 1	أَقَرَّ قَالَ
u'أَقَرَّ قَائِمٌ':Subject, #1: 1	أَقَرَّ الْقَائِلُ
u'أَقَرَّ قَسام':Predicate, #1: 1	أَقَرَّ قَائِمٌ
u'أَقَرَّ قَسامَة':Predicate, #3: 3	أَقَرَّ الْقَسَامَةَ
u'أَقَرَّ قَوْمٌ':Subject, #3: 3	أَقَرَّ الْقَسَامَةَ
u'أَقَرَّ قَوْمٌ':Subject, #1: 1	أَقَرَّ الْقَوْمُ
u'أَقَرَّ كُفَّارٌ':Subject, #1: 1	أَقَرَّ قَوْمٌ
u'أَقَرَّ كَفِيلٌ':Subject, #1: 1	أَقَرَّ الْكُفَّارُ
u'أَقَرَّ لَقِيطٌ':Subject, #4: 4	أَقَرَّ الْكَفِيلُ
u'أَقَرَّ مَاعِزٌ':Subject, #2: 2	أَقَرَّ اللَّقِيطُ
u'أَقَرَّ مَالٌ':Predicate, #1: 1	أَقَرَّ مَاعِزٌ
u'أَقَرَّ مَأْمُورٌ':Predicate, #2: 2	أَقَرَّ الْمَالَ
u'أَقَرَّ مُتَطَوِّعٌ':Predicate, #1: 1	أَقَرَّ الْمَأْمُورَ
u'أَقَرَّ مَجْنِيٌّ':Subject, #1: 1	أَقَرَّ الْمُتَطَوِّعَ
u'أَقَرَّ مَجْهُولٌ':Subject, #2: 2	أَقَرَّ الْمَجْنِيُّ
u'أَقَرَّ مَحْبُوسٌ':Subject, #1: 1	أَقَرَّ مَجْهُولٌ
u'أَقَرَّ مَحْجُورٌ':Subject, #2: 2	أَقَرَّ الْمَحْبُوسُ
u'أَقَرَّ مُحِيل':Subject, #2: 2	أَقَرَّ الْمَحْجُورُ
u'أَقَرَّ مُدَبَّرٌ':Subject, #1: 1	أَقَرَّ الْمُحِيلُ
u'أَقَرَّ مَدْيُونٌ':Subject, #3: 3	أَقَرَّ الْمُدَبَّرُ
u'أَقَرَّ مرٌّ':Predicate, #2: 2	أَقَرَّ الْمَدْيُونُ
u'أَقَرَّ مُرَاهِقٌ':Subject, #3: 3	أَقَرَّ مَرَّةً
u'أَقَرَّ مُرْتَهِنٌ':Subject, #1: 1	أَقَرَّ مُرَاهِقٌ
u'أَقَرَّ مُرْسِلٌ':Subject, #11: 11	أَقَرَّ الْمُرْتَهِنُ
u'أَقَرَّ مَرِيضٌ':Subject, #1: 1	أَقَرَّ الْمُرْسِلُ
u'أَقَرَّ مُسْتَحِقٌّ':Subject, #37: 37	أَقَرَّ الْمَرِيضُ
u'أَقَرَّ مُسْتَعِيرٌ':Subject, #2: 2	أَقَرَّ الْمُسْتَحِقُّ
u'أَقَرَّ مُسْتَوْدَعٌ':Subject, #2: 2	أَقَرَّ الْمُسْتَعِيرُ
u'أَقَرَّ مُسْلِمٌ':Subject, #1: 1	أَقَرَّ الْمُسْتَوْدَعُ
u'أَقَرَّ مُسْلِمٌ':Subject, #1: 1	أَقَرَّ الْمُسْلِمُ
u'أَقَرَّ مَشْهُودٌ':Subject, #1: 1	أَقَرَّ مُسْلِمٌ
u'أَقَرَّ مُضَارِبٌ':Subject, #1: 1	أَقَرَّ الْمَشْهُودُ
u'أَقَرَّ مُطْلَقٌ':Predicate, #7: 7	أَقَرَّ الْمُضَارِبُ
u'أَقَرَّ مَطْلُوبٌ':Subject, #1: 1	أَقَرَّ مُطْلَقَ
u'أَقَرَّ مَعْزُولٌ':Subject, #10: 10	أَقَرَّ الْمَطْلُوبُ
u'أَقَرَّ مُفْلِسٌ':Subject, #1: 1	أَقَرَّ الْمَعْزُولُ
u'أَقَرَّ مَقْضِيّ':Subject, #2: 2	أَقَرَّ مُفْلِسٌ
u'أَقَرَّ مَكْفُولٌ':Subject, #2: 2	أَقَرَّ الْمَقْضِيُّ
u'أَقَرَّ مُلْتَقِط':Subject, #2: 2	أَقَرَّ الْمَكْفُولُ
u'أَقَرَّ مَنْصُوبٌ':Subject, #3: 3	أَقَرَّ الْمُلْتَقِطُ
u'أَقَرَّ مُنْكِرٌ':Subject, #2: 2	أَقَرَّ مَنْصُوبُ
u'أَقَرَّ مُؤَجِّرٌ':Subject, #1: 1	أَقَرَّ الْمُنْكِرُ
u'أَقَرَّ مُودَعٌ':Subject, #1: 1	أَقَرَّ الْمُؤَجِّرُ
u'أَقَرَّ مَوْقُوفٌ':Subject, #3: 3	أَقَرَّ الْمُودَعُ
u'أَقَرَّ مُوَكِّلٌ':Subject, #1: 1	أَقَرَّ الْمَوْقُوفُ
u'أَقَرَّ نَاطِقٌ':Subject, #3: 3	أَقَرَّ الْمُوَكِّلُ
u'أَقَرَّ نَاظِرٌ':Subject, #1: 1	أَقَرَّ النَّاطِقُ
u'أَقَرَّ نَسَبٌ':Predicate, #1: 1	أَقَرَّ نَاظِرُ
u'أَقَرَّ نَصٌّ':Predicate, #1: 1	أَقَرَّ النَّسَبَ
u'أَقَرَّ نُصُوصٌ':Predicate, #3: 3	أَقَرَّ النَّصَّ
u'أَقَرَّ نَفْعٌ':Predicate, #1: 1	أَقَرَّ النُّصُوصَ
u'أَقَرَّ نَوَوِيٌّ':Subject, #1: 1	أَقَرَّ نَفْعَ
u'أَقَرَّ واحد':Subject, #1: 1	أَقَرَّ النَّوَوِيُّ
u'أَقَرَّ وَاحِدٌ':Subject, #4: 4	أَقَرَّ وَاحِدٌ
u'أَقَرَّ وَارِثٌ':Subject, #4: 4	أَقَرَّ وَاحِدٌ
u'أَقَرَّ وَاقِفٌ':Subject, #16: 16	أَقَرَّ الْوَارِثُ
u'أَقَرَّ وَالِدٌ':Subject, #1: 1	أَقَرَّ الْوَاقِفُ
u'أَقَرَّ وَرَثَةٌ':Subject, #1: 1	أَقَرَّ الْوَالِدُ
u'أَقَرَّ وَرَثَةٌ':Subject, #1: 1	أَقَرَّ وَرَثَةٌ
u'أَقَرَّ وَصِيٌّ':Subject, #6: 6	أَقَرَّ الْوَرَثَةُ
u'أَقَرَّ وَصِيٌّ':Subject, #30: 30	أَقَرَّ الْوَصِيُّ
u'أَقَرَّ وَقْتٌ':Predicate, #4: 4	أَقَرَّ وَصِيُّ
u'أَقَرَّ وَكِيلٌ':Subject, #1: 1	أَقَرَّ وَقْتَ
u'أَقَرَّ وَكِيلٌ':Subject, #1: 1	أَقَرَّ وَكِيلُ
u'أَقَرَّ ولد':Subject, #26: 26	أَقَرَّ الْوَكِيلُ
u'أَقَرَّ وَلَدٌ':Subject, #2: 2	أَقَرَّ الْوَلَدُ
u'أَقَرَّ وَلِيٌّ':Subject, #2: 2	أَقَرَّ الْوَلَدُ
u'أَقَرَّ وَلِيٌّ':Subject, #2: 2	أَقَرَّ الْوَلِيُّ
u'أَقَرَّ يَهُودِيٌّ':Subject, #2: 2	أَقَرَّ وَلِيُّ
u'أَقَرَّ يَوْمٌ':Predicate, #1: 1	أَقَرَّ يَهُودِيٌّ
u'أَقَرَّ يَوْمٌ':Predicate, #1: 1	أَقَرَّ الْيَوْمَ
u'أَقْسَطَ رَجُلٌ':Subject, #1: 1	أَقَرَّ يَوْمَ
u'أَقْسَطَ سَلْبٌ':Subject, #1: 1	أَقْسَطَ الرّجُلُ
u'أَقْسَمَ إمَامٌ':Subject, #1: 1	أَقْسَطَ سَلْبُ
u'أَقْسَمَ أَوْلِيَاءُ':Subject, #1: 1	أَقْسَمَ الْإِمَامُ
u'أَقْسَمَ حارِثٌ':Subject, #1: 1	أَقْسَمَ أَوْلِيَاءُ
u'أَقْسَمَ رِجَالٌ':Subject, #1: 1	أَقْسَمَ حَارِثَةُ
u'أَقْسَمَ رَسُولٌ':Subject, #1: 1	أَقْسَمَ الرِّجَالُ
u'أَقْضِيَةٌ جَامِعٌ':Added, #1: 1	أَقْسَمَ رَسُولُ
u'إقْطَاعٌ إجَارَةٌ':Added, #4: 4	أَقْضِيَةِ الْجَامِعِ
u'إقْطَاعٌ أرْضٌ':Added, #1: 1	إقْطَاعَ إجَارَةٍ
u'إقْطَاعٌ إمَامٌ':Added, #1: 1	إقْطَاعِ الْأَرْضِ
u'إقْطَاعٌ تَضْمِينٌ':Added, #2: 2	إقْطَاعُ الْإِمَامِ
u'إقْطَاعٌ تَمْلِيك':Added, #1: 1	إقْطَاعَ تَضْمِينٍ
u'إقْطَاعٌ تَمْلِيك':Added, #1: 1	إقْطَاعَ التَّمْلِيكِ
u'إقْطَاعٌ تَمْلِيك':Added, #1: 1	إقْطَاعُ التَّمْلِيكِ
u'إقْطَاعٌ تَمْلِيكٌ':Added, #3: 3	إقْطَاعِ التَّمْلِيكِ
u'إقْطَاعٌ تَمْلِيكٌ':Added, #4: 4	إقْطَاعَ تَمْلِيكٍ
u'إقْطَاعٌ جُلُوسٌ':Added, #4: 4	إقْطَاعُ تَمْلِيكٍ
u'إقْطَاعٌ جُلُوسٌ':Added, #1: 1	إقْطَاعَ الْجُلُوسِ
u'إقْطَاعٌ جُلُوسٌ':Added, #1: 1	إقْطَاعُ الْجُلُوسِ
u'إقْطَاعٌ رَقَبَةٌ':Added, #1: 1	إقْطَاعُ جُلُوسٍ
u'إقْطَاعٌ سُلْطَانٌ':Added, #1: 1	إقْطَاعُ رَقَبَتِهِ
u'إقْطَاعٌ عُشْرٌ':Added, #1: 1	إقْطَاعِ السُّلْطَانِ
u'إقْطَاعٌ غير':Added, #1: 1	إقْطَاعُ الْعُشْرِ
u'إقْطَاعٌ غَيْرٌ':Added, #2: 2	إقْطَاعُ غَيْرِ
u'إقْطَاعٌ مَرَافِقُ':Added, #2: 2	إقْطَاعُ غَيْرِ
u'إقْطَاعٌ مَعَادِنُ':Added, #1: 1	إقْطَاعِ الْمَرَافِقِ
u'إقْطَاعٌ مَعَادِنُ':Added, #1: 1	إقْطَاعَ الْمَعَادِنِ
u'إقْطَاعٌ مَعَادِنُ':Added, #1: 1	إقْطَاعِ الْمَعَادِنِ
u'إقْطَاعٌ ملح':Added, #2: 2	إقْطَاعُ الْمَعَادِنِ
u'إقْطَاعٌ مِلْحٌ':Added, #1: 1	إقْطَاعَ مِلْحِ
u'إقْطَاعٌ مَمْلُوكٌ':Added, #1: 1	إقْطَاعَ مِلْحِ
u'إقْطَاعٌ مَنْفَعَةٌ':Added, #1: 1	إقْطَاعُ مَمْلُوكٍ
u'إقْطَاعٌ مَوَاتٌ':Added, #1: 1	إقْطَاعُ مَنْفَعَةِ
u'إقْطَاعٌ مَوَاتٌ':Added, #1: 1	إقْطَاعَ الْمَوَاتِ
u'إقْطَاعٌ مَوَاتٌ':Added, #1: 1	إقْطَاعِ الْمَوَاتِ
u'إقْطَاعٌ مَوْضِعٌ':Added, #1: 1	إقْطَاعُ مَوَاتٍ
u'إقْطَاعٌ نَبِيٌّ':Added, #1: 1	إقْطَاعُ مَوْضِعٍ
u'أَقْطَعَ أَبْيَض':Predicate, #1: 1	إقْطَاعَ النَّبِيِّ
u'أَقْطَعَ أَرْبَعُ':Predicate, #1: 1	أَقْطَعَ أَبْيَضَ
u'أَقْطَعَ إمَامٌ':Subject, #1: 1	أَقْطَعَ أَرْبَعَ
u'أَقْطَعَ أنصار':Predicate, #4: 4	أَقْطَعَ الْإِمَامُ
u'أَقْطَعَ أَنْصارٌ':Predicate, #2: 2	أَقْطَعَ الأَنْصَارَ
u'أَقْطَعَ أَنْصَارٌ':Predicate, #2: 2	أَقْطَعَ الأَنْصَارَ
u'أَقْطَعَ بَحْرٌ':Predicate, #2: 2	أَقْطَعَ الأَنْصَارَ
u'أَقْطَعَ دُورٌ':Predicate, #1: 1	أَقْطَعَ الْبَحْرَ
u'أَقْطَعَ رَسُولٌ':Subject, #2: 2	أَقْطَعَ الدُّورَ
u'أَقْطَعَ سُلْطَانٌ':Subject, #1: 1	أَقْطَعَ رَسُولُ
u'أَقْطَعَ طَلْحٌ':Predicate, #2: 2	أَقْطَعَ السُّلْطَانُ
u'أَقْطَعَ طلحة':Predicate, #1: 1	أَقْطَعَ طَلْحَةَ
u'أَقْطَعَ عَقِيقٌ':Predicate, #1: 1	أَقْطَعَ طَلْحَةَ
u'أَقْطَعَ فلان':Predicate, #1: 1	أَقْطَعَ الْعَقِيقَ
u'أَقْطَعَ فلان':Predicate, #1: 1	أَقْطَعَ بِلالَ
u'أَقْطَعَ فلان':Predicate, #1: 1	أَقْطَعَ بِلَالَ
u'أَقْطَعَ فلان':Predicate, #4: 4	أَقْطَعَ بِلاَلَ
u'أَقْطَعَ فلان':Subject, #8: 8	أَقْطَعَ الزُّبَيْرَ
u'أَقْطَعَ قِرَاءةٌ':Predicate, #1: 1	أَقْطَعَ بِلَالُ
u'أَقْطَعَ نَاسٌ':Predicate, #1: 1	أَقْطَعَ الْقِرَاءَةَ
u'أَقْطَعَ نَبِيٌّ':Subject, #3: 3	أَقْطَعَ النَّاسَ
u'أَقْعَدَ اِبْنٌ':Predicate, #2: 2	أَقْطَعَ النَّبِيُّ
u'أَقْعَدَ أَجْنَبِيٌّ':Predicate, #2: 2	أَقْعَدَ ابْنَ
u'أَقْعَدَ الْمَرْأَةُ':Predicate, #1: 1	أَقْعَدَ الْأَجْنَبِيَّ
u'أَقْعَدَ خَيَّاطٌ':Subject, #1: 1	أَقْعَدَ الْمَرْأَةَ
u'أَقْعَدَ صَانِعٌ':Subject, #2: 2	أَقْعَدَ الْخَيَّاطُ
u'أَقْعَدَ عند':Predicate, #1: 1	أَقْعَدَ الصَّانِعُ
u'أَقْفَرَ أهْلٌ':Subject, #1: 1	أَقْعَدَ عِنْدَ
u'أَقْفَرَ رَسْمٌ':Subject, #3: 3	أَقْفَرَ أَهْلُ
u'أَقْفَلَ بَابٌ':Predicate, #1: 1	أَقْفَرَ رَسْمُهُ
u'أَقْوَالٌ أَرْبَعَةٌ':Added, #1: 1	أَقْفَلَ الْبَابَ
u'أَقْوَالٌ أَصْحَابٌ':Added, #3: 3	أَقْوَالٍ أَرْبَعَةٍ
u'أَقْوَالٌ أَقْرَانٌ':Added, #1: 1	أَقْوَالُ أَصْحَابِهِ
u'أَقْوَالٌ إمَامٌ':Added, #1: 1	أَقْوَالُ أَقْرَانِ
u'أَقْوَالٌ إِنْسانٌ':Added, #1: 1	أَقْوَالِ الْإِمَامِ
u'أَقْوَالٌ أهْلٌ':Added, #1: 1	أَقْوَالِ الْإِنْسَانِ
u'أَقْوَالٌ ثَلاثَةٌ':Added, #3: 3	أَقْوَالِ أَهْلِ
u'أَقْوَالٌ خَمْسَةٌ':Added, #5: 5	أَقْوَالٍ ثَلَاثَةٍ
u'أَقْوَالٌ دَائِرَةٌ':Added, #2: 2	أَقْوَالٍ خَمْسَةٍ
u'أَقْوَالٌ رِجَالٌ':Added, #1: 1	أَقْوَالٍ دَائِرَةٍ
u'أَقْوَالٌ زُورٌ':Added, #1: 1	أَقْوَالَ الرِّجَالِ
u'أَقْوَالٌ سَبْعَةٌ':Added, #1: 1	أَقْوَالِ الزُّورِ
u'أَقْوَالٌ سَكْرَان':Added, #1: 1	أَقْوَالٍ سَبْعَةٍ
u'أَقْوَالٌ شَارِعٌ':Added, #4: 4	أَقْوَالِ السَّكْرَانِ
u'أَقْوَالٌ شافِعِيّ':Added, #1: 1	أَقْوَالِ الشَّارِعِ
u'أَقْوَالٌ شُعرَاءُ':Added, #5: 5	أَقْوَالِ الشَّافِعِيِّ
u'أَقْوَالٌ شُعَرَاءُ':Added, #2: 2	أَقْوَالِ الشُّعَرَاءِ
u'أَقْوَالٌ شُيُوخٌ':Added, #2: 2	أَقْوَالِ الشُّعَرَاءِ
u'أَقْوَالٌ شُيُوخٌ':Added, #1: 1	أَقْوَالِ الشُّيُوخِ
u'أَقْوَالٌ صَحَابَةٌ':Added, #1: 1	أَقْوَالُ شُيُوخِ
u'أَقْوَالٌ صَحَابَةٌ':Added, #1: 1	أَقْوَالَ الصَّحَابَةِ
u'أَقْوَالٌ صَحَابَةٌ':Added, #4: 4	أَقْوَالُ الصَّحَابَةِ
u'أَقْوَالٌ صَحْبٌ':Added, #8: 8	أَقْوَالِ الصَّحَابَةِ
u'أَقْوَالٌ صَلاَةٌ':Added, #1: 1	أَقْوَالَ الصَّحْبِ
u'أَقْوَالٌ صَلاَةٌ':Added, #1: 1	أَقْوَالَ الصَّلَاةِ
u'أَقْوَالٌ صُوفِيٌّ':Added, #1: 1	أَقْوَالِ الصَّلَاةِ
u'أَقْوَالٌ صُوفِيَّةٌ':Added, #1: 1	أَقْوَالِ الصُّوفِيَّةِ
u'أَقْوَالٌ عتق':Added, #1: 1	أَقْوَالِ الصُّوفِيَّةِ
u'أَقْوَالٌ عِتْقٌ':Added, #1: 1	أَقْوَالُ عِتْقِ
u'أَقْوَالٌ علماء':Added, #1: 1	أَقْوَالُ عِتْقِ
u'أَقْوَالٌ عُلَمَاءُ':Added, #1: 1	أَقْوَالَ الْعُلَمَاءِ
u'أَقْوَالٌ علماء':Added, #1: 1	أَقْوَالَ الْعُلَمَاءِ
u'أَقْوَالٌ عُلَمَاءُ':Added, #2: 2	أَقْوَالُ الْعُلَمَاءِ
u'أَقْوَالٌ علماء':Added, #2: 2	أَقْوَالُ الْعُلَمَاءِ
u'أَقْوَالٌ عُلَمَاءُ':Added, #9: 9	أَقْوَالِ الْعُلَمَاءِ
u'أَقْوَالٌ غير':Added, #9: 9	أَقْوَالِ الْعُلَمَاءِ
u'أَقْوَالٌ غَيْرٌ':Added, #1: 1	أَقْوَالَ غَيْرِهِ
u'أَقْوَالٌ غَيْرَةٌ':Added, #1: 1	أَقْوَالَ غَيْرِهِ
u'أَقْوَالٌ فقهاء':Added, #1: 1	أَقْوَالِ الْغَيْرَةِ
u'أَقْوَالٌ فلان':Added, #5: 5	أَقْوَالِ الْفُقَهَاءِ
u'أَقْوَالٌ مَالِكٌ':Added, #5: 5	أَقْوَالِ الشَّافِعِيِّ
u'أَقْوَالٌ مُجْتَهِد':Added, #2: 2	أَقْوَالِ مَالِكٍ
u'أَقْوَالٌ مَذْهَبٌ':Added, #2: 2	أَقْوَالَ الْمُجْتَهِدِ
u'أَقْوَالٌ مُسْتَحَقٌّ':Added, #1: 1	أَقْوَالِ الْمَذْهَبِ
u'أَقْوَالٌ مَشَايِخُ':Added, #1: 1	أَقْوَالُ الْمُسْتَحَقِّ
u'أَقْوَالٌ مَشَايِخُ':Added, #1: 1	أَقْوَالُ الْمَشَايِخِ
u'أَقْوَالٌ مِلْكٌ':Added, #1: 1	أَقْوَالِ الْمَشَايِخِ
u'أَقْوَالٌ نَاسٌ':Added, #4: 4	أَقْوَالِ الْمِلْكِ
u'أَقْوَالٌ وَكِيلٌ':Added, #2: 2	أَقْوَالِ النَّاسِ
u'أَقْوَى أَجْزَاءٌ':Predicate, #2: 2	أَقْوَالَ الْوَكِيلِ
u'أَقْوَى عتق':Subject, #1: 1	أَقْوَى أَجْزَاءَ
u'أَقْوَى عِتْقٌ':Subject, #1: 1	أَقْوَى الْعِتْقُ
u'أَقْوَى عَدَمٌ':Subject, #1: 1	أَقْوَى الْعِتْقُ
u'أَقْوَى عند':Predicate, #1: 1	أَقْوَى عَدَمُ
u'أَقْوَى قَالٌ':Predicate, #2: 2	أَقْوَى عِنْدَ
u'أَقْوَى مُخَالِفٌ':Subject, #5: 5	أَقْوَى قَالَ
u'أَقْوَى وَجَبٌ':Predicate, #1: 1	أَقْوَى مُخَالِفٌ
u'أَقْوَى وَلَهٌ':Subject, #1: 1	أَقْوَى وَجَبَ
u'أَقْيِسَةٌ فقهاء':Added, #1: 1	أَقْوَى وَلَهُ
u'أَقْيِسَةٌ نَبِيٌّ':Added, #1: 1	أَقْيِسَةِ الْفُقَهَاءِ
u'أَكْبَرَ خُزَاعَةٌ':Predicate, #1: 1	أَقْيِسَةِ النَّبِيِّ
u'إكْثَارٌ أكل':Added, #1: 1	أَكْبَرَ خُزَاعَةَ
u'إكْثَارٌ أَكْلٌ':Added, #1: 1	إكْثَارُ الْأَكْلِ
u'إكْثَارٌ أَيْمَانٌ':Added, #1: 1	إكْثَارُ الْأَكْلِ
u'إكْثَارٌ تَنْوِيرٌ':Added, #1: 1	إكْثَارُ الْأَيْمَانِ
u'إكْثَارٌ حَجٌّ':Added, #1: 1	إكْثَارُ التَّنْوِيرِ
u'إكْثَارٌ دُعَاءٌ':Added, #1: 1	إكْثَارَ الْحَجِّ
u'إكْثَارٌ ذكر':Added, #1: 1	إكْثَارُ الدُّعَاءِ
u'إكْثَارٌ ذِكْرٌ':Added, #1: 1	إكْثَارِ الذِّكْرِ
u'إكْثَارٌ صَلاَةٌ':Added, #1: 1	إكْثَارِ الذِّكْرِ
u'إكْثَارٌ صَوْمٌ':Added, #1: 1	إكْثَارِ الصَّلَاةِ
u'إكْثَارٌ صَوْمٌ':Added, #1: 1	إكْثَارِ الصَّوْمِ
u'إكْثَارٌ طواف':Added, #2: 2	إكْثَارُ الصَّوْمِ
u'إكْثَارٌ طَوَافٌ':Added, #1: 1	إكْثَارُ الطَّوَافِ
u'إكْثَارٌ وُقُودٌ':Added, #1: 1	إكْثَارُ الطَّوَافِ
u'أَكْثَرَ اِبْنٌ':Predicate, #1: 1	إكْثَارِ الْوُقُودِ
u'أَكْثَرَ اِبْنٌ':Subject, #1: 1	أَكْثَرَ ابْنَ
u'أَكْثَرَ أحَدٌ':Subject, #1: 1	أَكْثَرَ ابْنُ
u'أَكْثَرَ أخْذٌ':Predicate, #1: 1	أَكْثَرَ أَحَدٌ
u'أَكْثَرَ أقْرَع':Predicate, #1: 1	أَكْثَرَ الْأَخْذَ
u'أَكْثَرَ أكل':Predicate, #1: 1	أَكْثَرَ أَقْرَعَ
u'أَكْثَرَ أَكْلٌ':Predicate, #1: 1	أَكْثَرَ أَكْلَ
u'أَكْثَرَ أَنْفَعُ':Predicate, #1: 1	أَكْثَرَ أَكْلَ
u'أَكْثَرَ أَوْرَامٌ':Predicate, #1: 1	أَكْثَرَ أَنْفَعَ
u'أَكْثَرَ بَطَلٌ':Predicate, #1: 1	أَكْثَرَ الْأَوْرَامَ
u'أَكْثَرَ بَيْعٌ':Subject, #1: 1	أَكْثَرَ بَطَلَ
u'أَكْثَرَ تَسْوِيَةٌ':Predicate, #1: 1	أَكْثَرَ بَيْعٌ
u'أَكْثَرَ تَشْنِيعٌ':Predicate, #1: 1	أَكْثَرَ التَّسْوِيَةَ
u'أَكْثَرَ تَنَقُّلٌ':Predicate, #1: 1	أَكْثَرَ التَّشْنِيعَ
u'أَكْثَرَ جَازٌ':Predicate, #1: 1	أَكْثَرَ التَّنَقُّلَ
u'أَكْثَرَ جمع':Predicate, #18: 18	أَكْثَرَ جَازَ
u'أَكْثَرَ خِلاَفٌ':Predicate, #1: 1	أَكْثَرَ جَمَعَ
u'أَكْثَرَ دَخَلٌ':Predicate, #1: 1	أَكْثَرَ الْخِلَافَ
u'أَكْثَرَ دفع':Predicate, #1: 1	أَكْثَرَ دَخَلَ
u'أَكْثَرَ دونٌ':Predicate, #1: 1	أَكْثَرَ دَفَعَ
u'أَكْثَرَ ذكر':Predicate, #1: 1	أَكْثَرَ دُونَ
u'أَكْثَرَ ذكر':Predicate, #1: 1	أَكْثَرَ ذُكِرَ
u'أَكْثَرَ ذِكْرٌ':Predicate, #4: 4	أَكْثَرَ ذِكْرَ
u'أَكْثَرَ رَافِعٌ':Subject, #4: 4	أَكْثَرَ ذِكْرَ
u'أَكْثَرَ رِجْلٌ':Predicate, #1: 1	أَكْثَرَ رَافِعٌ
u'أَكْثَرَ رَجُلٌ':Subject, #1: 1	أَكْثَرَ الرِّجْلَ
u'أَكْثَرَ رَدٌّ':Predicate, #1: 1	أَكْثَرَ الرَّجُلُ
u'أَكْثَرَ رَفْعٌ':Predicate, #2: 2	أَكْثَرَ رَدَّ
u'أَكْثَرَ زِيارَةٌ':Predicate, #1: 1	أَكْثَرَ رَفْعَ
u'أَكْثَرَ سَواءٌ':Subject, #1: 1	أَكْثَرَ الزِّيَارَةَ
u'أَكْثَرَ شُهُودٌ':Predicate, #2: 2	أَكْثَرَ سَوَاءٌ
u'أَكْثَرَ صَبٌّ':Predicate, #1: 1	أَكْثَرَ شُهُودَ
u'أَكْثَرَ ضَمَانٌ':Subject, #1: 1	أَكْثَرَ الصَّبَّ
u'أَكْثَرَ ضَمِنٌ':Predicate, #1: 1	أَكْثَرَ الضَّمَانُ
u'أَكْثَرَ عَبَّاسٌ':Subject, #1: 1	أَكْثَرَ ضَمِنَ
u'أَكْثَرَ عَبْدٌ':Subject, #1: 1	أَكْثَرَ عَبّاسٌ
u'أَكْثَرَ عِبْرٌ':Predicate, #1: 1	أَكْثَرَ عَبْدٌ
u'أَكْثَرَ عتق':Predicate, #1: 1	أَكْثَرَ الْعِبْرَ
u'أَكْثَرَ عُمَرٌ':Subject, #1: 1	أَكْثَرَ عَتَقَ
u'أَكْثَرَ عند':Predicate, #1: 1	أَكْثَرَ عُمَرُ
u'أَكْثَرَ غلب':Predicate, #1: 1	أَكْثَرَ عِنْدَ
u'أَكْثَرَ فلان':Subject, #1: 1	أَكْثَرَ غَلَبَ
u'أَكْثَرَ فَلَكٌ':Predicate, #1: 1	أَكْثَرَ عُثْمَانُ
u'أَكْثَرَ قَالٌ':Predicate, #2: 2	أَكْثَرَ فَلَكَ
u'أَكْثَرَ قَوْمٌ':Subject, #9: 9	أَكْثَرَ قَالَ
u'أَكْثَرَ قَوْمٌ':Subject, #1: 1	أَكْثَرَ الْقَوْمُ
u'أَكْثَرَ كذب':Predicate, #1: 1	أَكْثَرَ قَوْمٌ
u'أَكْثَرَ كَذِبٌ':Predicate, #2: 2	أَكْثَرَ الْكَذِبَ
u'أَكْثَرَ مَبِيتٌ':Predicate, #2: 2	أَكْثَرَ الْكَذِبَ
u'أَكْثَرَ مُتَأَخِّرٌ':Predicate, #1: 1	أَكْثَرَ الْمَبِيتَ
u'أَكْثَرَ مَحَالٌّ':Predicate, #1: 1	أَكْثَرَ الْمُتَأَخِّرِينَ
u'أَكْثَرَ مَحَالُّ':Predicate, #2: 2	أَكْثَرَ مَحَالَّ
u'أَكْثَرَ مُخْتَلِفٌ':Predicate, #2: 2	أَكْثَرَ مَحَالَّ
u'أَكْثَرَ مُذَاكَرَةٌ':Predicate, #1: 1	أَكْثَرَ مُخْتَلِفَةً
u'أَكْثَرَ مَسَائِلُ':Predicate, #1: 1	أَكْثَرَ الْمُذَاكَرَةَ
u'أَكْثَرَ مَشُورَةٌ':Predicate, #1: 1	أَكْثَرَ مَسَائِلَ
u'أَكْثَرَ مُصَنِّفٌ':Predicate, #1: 1	أَكْثَرَ الْمَشُورَةَ
u'أَكْثَرَ مُفَسِّرٌ':Predicate, #1: 1	أَكْثَرَ الْمُصَنِّفِينَ
u'أَكْثَرَ مِقْدَارٌ':Predicate, #2: 2	أَكْثَرَ الْمُفَسِّرِينَ
u'أَكْثَرَ مِقْدَارٌ':Subject, #1: 1	أَكْثَرَ مِقْدَارَ
u'أَكْثَرَ نَاسٌ':Subject, #1: 1	أَكْثَرَ مِقْدَارُ
u'أَكْثَرَ نَاسٌ':Subject, #11: 11	أَكْثَرَ النَّاسُ
u'أَكْثَرَ نَحْوٌ':Predicate, #1: 1	أَكْثَرَ النّاسُ
u'أَكْثَرَ نَفِيرٌ':Predicate, #1: 1	أَكْثَرَ نَحْوَ
u'أَكْثَرَ نقل':Predicate, #1: 1	أَكْثَرَ النَّفِيرَ
u'أَكْثَرَ نَقَلٌ':Predicate, #1: 1	أَكْثَرَ نَقَلَ
u'أَكْثَرَ نَمِيمٌ':Predicate, #1: 1	أَكْثَرَ نَقَلَ
u'أَكْثَرَ وَجَبٌ':Predicate, #1: 1	أَكْثَرَ النَّمِيمَةَ
u'أَكْثَرَ وَقِيعٌ':Predicate, #3: 3	أَكْثَرَ وَجَبَ
u'أَكْثَرَ وَقِيعَةٌ':Predicate, #1: 1	أَكْثَرَ الْوَقِيعَةَ
u'أَكَّدَ أَنْسَابٌ':Predicate, #1: 1	أَكْثَرَ الْوَقِيعَةَ
u'أَكَّدَ أَوَّلُ':Predicate, #1: 1	أَكَّدَ الْأَنْسَابَ
u'أَكَّدَ تَعْلِيلٌ':Predicate, #1: 1	أَكَّدَ الْأَوَّلَ
u'أَكَّدَ ثَانِي':Predicate, #1: 1	أَكَّدَ تَعْلِيلَ
u'أَكَّدَ ثَانِي':Predicate, #1: 1	أَكَّدَ الثَّانِيَ
u'أَكَّدَ ثَانِيَةٌ':Predicate, #3: 3	أَكَّدَ الثَّانِيَةَ
u'أَكَّدَ حالٌ':Subject, #3: 3	أَكَّدَ الثَّانِيَةَ
u'أَكَّدَ دلك':Predicate, #1: 1	أَكَّدَ الْحَالُ
u'أَكَّدَ دَلْكٌ':Predicate, #1: 1	أَكَّدَ الدَّلْكَ
u'أَكَّدَ رِوايَةٌ':Predicate, #1: 1	أَكَّدَ الدَّلْكَ
u'أَكَّدَ سُقُوطٌ':Predicate, #1: 1	أَكَّدَ رِوَايَةَ
u'أَكَّدَ شافِعِيّ':Subject, #1: 1	أَكَّدَ سُقُوطَ
u'أَكَّدَ فَرْضٌ':Predicate, #1: 1	أَكَّدَ الشَّافِعِيُّ
u'أَكَّدَ فِعْلٌ':Predicate, #1: 1	أَكَّدَ الْفَرْضَ
u'أَكَّدَ فلان':Subject, #1: 1	أَكَّدَ الْفِعْلَ
u'أَكَّدَ قَصْدٌ':Predicate, #1: 1	أَكَّدَ الشَّافِعِيُّ
u'أَكَّدَ كَلاَمٌ':Predicate, #1: 1	أَكَّدَ قَصْدَ
u'أَكَّدَ مُحَمَّدٌ':Subject, #1: 1	أَكَّدَ الْكَلَامَ
u'أَكَّدَ نَبِيٌّ':Subject, #1: 1	أَكَّدَ مُحَمَّدُ
u'أَكَّدَ نَفْيٌ':Predicate, #1: 1	أَكَّدَ النَّبِيُّ
u'أَكْذَبَ أحَدٌ':Predicate, #2: 2	أَكَّدَ النَّفْيَ
u'أَكْذَبَ أصل':Predicate, #1: 1	أَكْذَبَ أَحَدَ
u'أَكْذَبَ أًصْلٌ':Predicate, #1: 1	أَكْذَبَ الْأَصْلَ
u'أَكْذَبَ أَوَّلُ':Predicate, #1: 1	أَكْذَبَ الْأَصْلَ
u'أَكْذَبَ رَجُلٌ':Subject, #1: 1	أَكْذَبَ الْأَوَّلَ
u'أَكْذَبَ شَاهِدٌ':Predicate, #2: 2	أَكْذَبَ الرَّجُلُ
u'أَكْذَبَ شَاهِدٌ':Predicate, #2: 2	أَكْذَبَ الشَّاهِدَ
u'أَكْذَبَ عند':Predicate, #3: 3	أَكْذَبَ شَاهِدَ
u'أَكْذَبَ غرائب':Predicate, #1: 1	أَكْذَبَ عِنْدَ
u'أَكْذَبَ مَلاَعِنُ':Subject, #1: 1	أَكْذَبَ الْغَرَائِبَ
u'إكْرَاءٌ شَأْنٌ':Added, #3: 3	أَكْذَبَ الْمَلَاعِنُ
u'إكْرَاءٌ شَهْرٌ':Added, #1: 1	إكْرَاءَ الشَّأْنِ
u'إكْرَاءٌ شَيْءٌ':Added, #1: 1	إكْرَاءُ الشَّهْرِ
u'إكْرَامٌ الْمَرْءُ':Added, #1: 1	إكْرَاءُ شَيْءٍ
u'إكْرَامٌ بَعْضٌ':Added, #1: 1	إكْرَامِ الْمَرْءِ
u'إكْرَامٌ خُبْزٌ':Added, #1: 1	إكْرَامَ بَعْضِ
u'إكْرَامٌ خلق':Added, #2: 2	إكْرَامِ الْخُبْزِ
u'إكْرَامٌ خَلْقٌ':Added, #1: 1	إكْرَامَ الْخَلْقِ
u'إكْرَامٌ سَعْدٌ':Added, #1: 1	إكْرَامَ الْخَلْقِ
u'إكْرَامٌ علماء':Added, #1: 1	إكْرَامُ سَعْدٍ
u'إكْرَامٌ عُلَمَاءُ':Added, #1: 1	إكْرَامِ الْعُلَمَاءِ
u'إكْرَامٌ كَبِيرٌ':Added, #1: 1	إكْرَامِ الْعُلَمَاءِ
u'إكْرَامٌ كَرِيمٌ':Added, #1: 1	إكْرَامِ الْكَبِيرِ
u'إكْرَامٌ مُقَيَّدٌ':Added, #1: 1	إكْرَامِ كَرِيمِ
u'إكْرَامٌ مُؤْمِنٌ':Added, #1: 1	إكْرَامٍ مُقَيَّدٍ
u'إكْرَاهٌ أحَدٌ':Added, #1: 1	إكْرَامَ الْمُؤْمِنِ
u'إكْرَاهٌ أصل':Added, #1: 1	إكْرَاهِ أَحَدٍ
u'إكْرَاهٌ أًصْلٌ':Added, #1: 1	إكْرَاهِ الْأَصْلِ
u'إكْرَاهٌ إمَامٌ':Added, #1: 1	إكْرَاهِ الْأَصْلِ
u'إكْرَاهٌ بَاطِلٌ':Added, #1: 1	إكْرَاهُ الْإِمَامِ
u'إكْرَاهٌ تَنْوِيرٌ':Added, #1: 1	إكْرَاهِ الْبَاطِلِ
u'إكْرَاهٌ جَاهِلٌ':Added, #1: 1	إكْرَاهِ التَّنْوِيرِ
u'إكْرَاهٌ حامِلٌ':Added, #1: 1	إكْرَاهُ جَاهِلٍ
u'إكْرَاهٌ حُرٌّ':Added, #1: 1	إكْرَاهَ الْحَامِلِ
u'إكْرَاهٌ حَمْلٌ':Added, #1: 1	إكْرَاهِ حُرَّةٍ
u'إكْرَاهٌ دَائِنٌ':Added, #1: 1	إكْرَاهِ الْحَمْلِ
u'إكْرَاهٌ ذِمِّيٌّ':Added, #1: 1	إكْرَاهِ الدَّائِنِ
u'إكْرَاهٌ ذِمِّيٌّ':Added, #1: 1	إكْرَاهَ الذِّمِّيِّ
u'إكْرَاهٌ رَجُلٌ':Added, #1: 1	إكْرَاهُ الذِّمِّيِّ
u'إكْرَاهٌ رُسُلٌ':Added, #1: 1	إكْرَاهَ الرَّجُلِ
u'إكْرَاهٌ سُلْطَانٌ':Added, #1: 1	إكْرَاهُ الرُّسُلِ
u'إكْرَاهٌ سُلْطَانٌ':Added, #1: 1	إكْرَاهَ السُّلْطَانِ
u'إكْرَاهٌ شَيْخٌ':Added, #1: 1	إكْرَاهِ السُّلْطَانِ
u'إكْرَاهٌ طَلاَقٌ':Added, #2: 2	إكْرَاهِ شَيْخِ
u'إكْرَاهٌ غير':Added, #1: 1	إكْرَاهِ الطَّلَاقِ
u'إكْرَاهٌ غَيْرٌ':Added, #1: 1	إكْرَاهِ غَيْرِ
u'إكْرَاهٌ غير':Added, #1: 1	إكْرَاهِ غَيْرِ
u'إكْرَاهٌ غَيْرٌ':Added, #1: 1	إكْرَاهِ غَيْرِهِ
u'إكْرَاهٌ لُصُوصٌ':Added, #1: 1	إكْرَاهِ غَيْرِهِ
u'إكْرَاهٌ مَبْسُوطٌ':Added, #1: 1	إكْرَاهِ اللُّصُوصِ
u'إكْرَاهٌ مَجُوسِيٌّ':Added, #1: 1	إكْرَاهِ الْمَبْسُوطِ
u'إكْرَاهٌ مَحْكُومٌ':Added, #2: 2	إكْرَاهِ الْمَجُوسِيِّ
u'إكْرَاهٌ مُرْتَدٌّ':Added, #1: 1	إكْرَاهِ الْمَحْكُومِ
u'إكْرَاهٌ مُرْتَدٌّ':Added, #1: 1	إكْرَاهُ الْمُرْتَدِّ
u'إكْرَاهٌ مَرِيضٌ':Added, #1: 1	إكْرَاهِ الْمُرْتَدِّ
u'إكْرَاهٌ مِنَحٌ':Added, #1: 1	إكْرَاهُ الْمَرِيضِ
u'أَكْرَمَ رَبُّ':Subject, #1: 1	إكْرَاهِ الْمِنَحِ
u'أَكْرَمَ سُلْطَانٌ':Predicate, #1: 1	أَكْرَمَ رَبُّهُ
u'أَكْرَمَ شَابٌّ':Subject, #1: 1	أَكْرَمَ سُلْطَانَ
u'أَكْرَمَ قِبْلَةٌ':Predicate, #1: 1	أَكْرَمَ شَابٌّ
u'أَكْرَمَ كِتَابٌ':Predicate, #1: 1	أَكْرَمَ الْقِبْلَةَ
u'أَكْرَمَ مُشْتَقٌّ':Subject, #1: 1	أَكْرَمَ كِتَابَ
u'أَكْرَمَ وَجْهٌ':Predicate, #1: 1	أَكْرَمَ مُشْتَقٌّ
u'أَكْرَهَ اِبْنٌ':Subject, #1: 1	أَكْرَمَ وَجْهَ
u'أَكْرَهَ أَجْنَبِيٌّ':Subject, #1: 1	أَكْرَهَ ابْنُ
u'أَكْرَهَ أحَدٌ':Subject, #2: 2	أَكْرَهَ أَجْنَبِيٌّ
u'أَكْرَهَ الْمَرْأَةُ':Predicate, #1: 1	أَكْرَهَ أَحَدُ
u'أَكْرَهَ إمَامٌ':Subject, #3: 3	أَكْرَهَ الْمَرْأَةَ
u'أَكْرَهَ حَلالٌ':Subject, #2: 2	أَكْرَهَ الْإِمَامُ
u'أَكْرَهَ ذِمِّيٌّ':Subject, #1: 1	أَكْرَهَ حَلَالٌ
u'أَكْرَهَ رَجُلٌ':Subject, #3: 3	أَكْرَهَ ذِمِّيٌّ
u'أَكْرَهَ رَجُلٌ':Subject, #1: 1	أَكْرَهَ رَجُلٌ
u'أَكْرَهَ زَوْجٌ':Subject, #3: 3	أَكْرَهَ الرَّجُلُ
u'أَكْرَهَ زَوْجَةٌ':Predicate, #1: 1	أَكْرَهَ الزَّوْجُ
u'أَكْرَهَ سَعْدٌ':Subject, #1: 1	أَكْرَهَ الزَّوْجَةَ
u'أَكْرَهَ سُلْطَانٌ':Subject, #1: 1	أَكْرَهَ سَعْدٌ
u'أَكْرَهَ شَخْصٌ':Subject, #5: 5	أَكْرَهَ السُّلْطَانُ
u'أَكْرَهَ صَاحِبٌ':Predicate, #3: 3	أَكْرَهَ شَخْصٌ
u'أَكْرَهَ صَائِمٌ':Subject, #1: 1	أَكْرَهَ صَاحِبَ
u'أَكْرَهَ صَبِيٌّ':Subject, #1: 1	أَكْرَهَ صَائِمٌ
u'أَكْرَهَ عَاقِلٌ':Predicate, #1: 1	أَكْرَهَ الصَّبِيُّ
u'أَكْرَهَ فَاعِلٌ':Subject, #1: 1	أَكْرَهَ عَاقِلَةً
u'أَكْرَهَ فُلاَنٌ':Subject, #1: 1	أَكْرَهَ الْفَاعِلُ
u'أَكْرَهَ قَابِضٌ':Predicate, #1: 1	أَكْرَهَ فُلَانُ
u'أَكْرَهَ قَوْمٌ':Subject, #1: 1	أَكْرَهَ الْقَابِضَ
u'أَكْرَهَ مَجُوسِيٌّ':Subject, #1: 1	أَكْرَهَ قَوْمٌ
u'أَكْرَهَ مُحْرِمٌ':Subject, #1: 1	أَكْرَهَ مَجُوسِيٌّ
u'أَكْرَهَ مُسْلِمٌ':Subject, #3: 3	أَكْرَهَ مُحْرِمٌ
u'أَكْرَهَ وَلِيٌّ':Subject, #3: 3	أَكْرَهَ مُسْلِمٌ
u'أَكْرَى رِباعٌ':Predicate, #1: 1	أَكْرَهَ الْوَلِيُّ
u'أَكْرَى رِبَاعٌ':Predicate, #1: 1	أَكْرَى الرِّبَاعَ
u'أَكْرَى مُشَاةٌ':Subject, #1: 1	أَكْرَى الرِّبَاعَ
u'أَكْرَى مَطْمُورٌ':Predicate, #1: 1	أَكْرَى مُشَاةٌ
u'أَكْرَى نَاظِرٌ':Subject, #2: 2	أَكْرَى مَطْمُورَةً
u'أَكْرَى نِصْفٌ':Predicate, #1: 1	أَكْرَى نَاظِرُ
u'أَكْرَى وَصِيٌّ':Subject, #1: 1	أَكْرَى نِصْفَ
u'أَكْفَانٌ اِبْنَة':Added, #1: 1	أَكْرَى الْوَصِيُّ
u'أَكْفَانٌ اِمْرَأَةٌ':Added, #2: 2	أَكْفَانِ ابْنَتِهِ
u'أَكْفَانٌ رِجَالٌ':Added, #1: 1	أَكْفَانِ امْرَأَتِهِ
u'أَكْفَانٌ فقراء':Added, #1: 1	أَكْفَانِ الرِّجَالِ
u'أَكَلَ أُجْرَةٌ':Predicate, #3: 3	أَكْفَانِ فُقَرَاءِ
u'أكل أُجْرَةٌ':Added, #1: 1	أَكَلَ الْأُجْرَةَ
u'أَكْلٌ أُجْرَةٌ':Added, #4: 4	أَكْلُ أُجْرَتِهِ
u'أَكَلَ أَجْنَبِيٌّ':Subject, #4: 4	أَكْلُ أُجْرَتِهِ
u'أَكَلَ أُجُورٌ':Predicate, #1: 1	أَكَلَ الْأَجْنَبِيُّ
u'أَكَلَ أحَدٌ':Predicate, #1: 1	أَكَلَ أُجُورَ
u'أَكَلَ أحَدٌ':Subject, #1: 1	أَكَلَ أَحَدَ
u'أَكَلَ أحَدٌ':Subject, #1: 1	أَكَلَ أَحَدُ
u'أَكَلَ آخِرُ':Predicate, #2: 2	أَكَلَ أَحَدٌ
u'أَكَلَ إِدَامٌ':Predicate, #4: 4	أَكَلَ آخِرَ
u'أَكَلَ آدَمُ':Subject, #1: 1	أَكَلَ الْإِدَامَ
u'أَكَلَ أَرُزٌّ':Predicate, #1: 1	أَكَلَ آدَمُ
u'أكل أَطْعِمَةٌ':Added, #1: 1	أَكَلَ الْأَرُزَّ
u'أَكْلٌ أَطْعِمَةٌ':Added, #1: 1	أَكْلَ الْأَطْعِمَةِ
u'أكل أَطْعِمَةٌ':Added, #1: 1	أَكْلَ الْأَطْعِمَةِ
u'أَكْلٌ أَطْعِمَةٌ':Added, #2: 2	أَكْلُ الْأَطْعِمَةِ
u'أكل أفيُونٌ':Added, #2: 2	أَكْلُ الْأَطْعِمَةِ
u'أَكْلٌ أفيُونٌ':Added, #1: 1	أَكْلُ الْأَفْيُونِ
u'أَكَلَ أقَلُّ':Predicate, #1: 1	أَكْلُ الْأَفْيُونِ
u'أَكَلَ أقَلُّ':Predicate, #1: 1	أَكَلَ أَقَلَّ
u'أكل أقَلُّ':Added, #1: 1	أَكَلَ الْأَقَلَّ
u'أَكْلٌ أقَلُّ':Added, #1: 1	أَكْلُ الْأَقَلِّ
u'أَكَلَ أَكْثَرُ':Predicate, #1: 1	أَكْلُ الْأَقَلِّ
u'أَكَلَ أَكْثَرُ':Predicate, #1: 1	أَكَلَ الْأَكْثَرَ
u'أكل أَكْثَرُ':Added, #3: 3	أَكَلَ أَكْثَرَ
u'أَكْلٌ أَكْثَرُ':Added, #1: 1	أَكْلُ أَكْثَرِ
u'أكل الْمَرْءُ':Added, #1: 1	أَكْلُ أَكْثَرِ
u'أَكْلٌ الْمَرْءُ':Added, #1: 1	أَكْلَ الْمَرْءِ
u'أكل أُمَّةٌ':Added, #1: 1	أَكْلَ الْمَرْءِ
u'أَكْلٌ أُمَّةٌ':Added, #1: 1	أَكْلُ أُمّتِهِ
u'أكل أَمْوَالٌ':Added, #1: 1	أَكْلُ أُمّتِهِ
u'أَكْلٌ أَمْوَالٌ':Added, #10: 10	أَكْلِ أَمْوَالِ
u'أكل أَمْوَالٌ':Added, #10: 10	أَكْلِ أَمْوَالِ
u'أَكْلٌ أَمْوَالٌ':Added, #1: 1	أَكْل أَمْوَالِ
u'أكل أَمْوَالٌ':Added, #1: 1	أَكْل أَمْوَالِ
u'أَكْلٌ أَمْوَالٌ':Added, #2: 2	أَكْلُ أَمْوَالِ
u'أكل أَمْوَالٌ':Added, #2: 2	أَكْلُ أَمْوَالِ
u'أَكْلٌ أَمْوَالٌ':Added, #4: 4	أَكْلَ أَمْوَالِ
u'أكل أنبياء':Added, #4: 4	أَكْلَ أَمْوَالِ
u'أَكْلٌ أنبياء':Added, #1: 1	أَكْلُ الْأَنْبِيَاءِ
u'أَكَلَ إِنْسانٌ':Subject, #1: 1	أَكْلُ الْأَنْبِيَاءِ
u'أكل إِنْسانٌ':Added, #2: 2	أَكَلَ إنْسَانٌ
u'أكل إِنْسانٌ':Added, #1: 1	أَكْلَ الْإِنْسَانِ
u'أَكْلٌ إِنْسانٌ':Added, #1: 1	أَكْلُ الْإِنْسَانِ
u'أَكْلٌ إِنْسانٌ':Added, #1: 1	أَكْلَ الْإِنْسَانِ
u'أَكَلَ أهْلٌ':Subject, #1: 1	أَكْلُ الْإِنْسَانِ
u'أكل أهْلٌ':Added, #1: 1	أَكَلَ أَهْلُ
u'أَكْلٌ أهْلٌ':Added, #2: 2	أَكْلَ أَهْلِ
u'أَكَلَ أَوَّلُ':Predicate, #2: 2	أَكْلَ أَهْلِ
u'أكل أَوَّلُ':Added, #1: 1	أَكَلَ أَوّلَ
u'أَكْلٌ أَوَّلُ':Added, #1: 1	أَكْلِ الْأَوَّلِ
u'أَكَلَ بَازٌ':Subject, #1: 1	أَكْلِ الْأَوَّلِ
u'أكل باقَةٌ':Added, #1: 1	أَكَلَ الْبَازُ
u'أَكْلٌ باقَةٌ':Added, #1: 1	أَكْلُ بَاقِيهِ
u'أَكَلَ باقِي':Predicate, #1: 1	أَكْلُ بَاقِيهِ
u'أكل باقِي':Added, #1: 1	أَكَلَ الْبَاقِيَ
u'أَكْلٌ باقِي':Added, #1: 1	أَكْلُ بَاقِيهِ
u'أَكَلَ بالِغٌ':Subject, #1: 1	أَكْلُ بَاقِيهِ
u'أَكَلَ بَائِعٌ':Subject, #1: 1	أَكَلَ الْبَالِغُ
u'أكل بُرٌّ':Added, #3: 3	أَكَلَ الْبَائِعُ
u'أَكْلٌ بُرٌّ':Added, #2: 2	أَكْلُ الْبُرِّ
u'أكل بَرَكَةٌ':Added, #2: 2	أَكْلُ الْبُرِّ
u'أَكْلٌ بَرَكَةٌ':Added, #1: 1	أَكْلُ بَرَكَةٍ
u'أَكَلَ بُسْرٌ':Predicate, #1: 1	أَكْلُ بَرَكَةٍ
u'أكل بُسْرٌ':Added, #1: 1	أَكَلَ الْبُسْرَ
u'أكل بُسْرٌ':Added, #1: 1	أَكْلُ الْبُسْرِ
u'أَكْلٌ بُسْرٌ':Added, #1: 1	أَكْلِ الْبُسْرِ
u'أَكْلٌ بُسْرٌ':Added, #1: 1	أَكْلُ الْبُسْرِ
u'أَكَلَ بَصَلٌ':Predicate, #1: 1	أَكْلِ الْبُسْرِ
u'أكل بَصَلٌ':Added, #3: 3	أَكَلَ الْبَصَلَ
u'أَكْلٌ بَصَلٌ':Added, #2: 2	أَكْلِ الْبَصَلِ
u'أَكَلَ بِطِّيخٌ':Predicate, #2: 2	أَكْلِ الْبَصَلِ
u'أكل بِطِّيخٌ':Added, #1: 1	أَكَلَ الْبِطِّيخَ
u'أَكْلٌ بِطِّيخٌ':Added, #1: 1	أَكْلِ الْبِطِّيخِ
u'أَكَلَ بَعْضٌ':Predicate, #1: 1	أَكْلِ الْبِطِّيخِ
u'أكل بَعْضٌ':Added, #5: 5	أَكَلَ بَعْضَ
u'أَكْلٌ بَعْضٌ':Added, #1: 1	أَكْلَ بَعْضِهِ
u'أكل بَعْضٌ':Added, #1: 1	أَكْلَ بَعْضِهِ
u'أكل بَعْضٌ':Added, #2: 2	أَكْلَ الْبَعْضِ
u'أَكْلٌ بَعْضٌ':Added, #2: 2	أَكْلِ الْبَعْضِ
u'أَكْلٌ بَعْضٌ':Added, #2: 2	أَكْلَ الْبَعْضِ
u'أكل بَعْضٌ':Added, #2: 2	أَكْلِ الْبَعْضِ
u'أَكْلٌ بَعْضٌ':Added, #2: 2	أَكْلِ بَعْضِ
u'أكل بَقْل':Added, #2: 2	أَكْلِ بَعْضِ
u'أَكْلٌ بَقْل':Added, #1: 1	أَكْلُ الْبَقْلَةِ
u'أَكَلَ بَنْجٌ':Predicate, #1: 1	أَكْلُ الْبَقْلَةِ
u'أكل بَنْجٌ':Added, #1: 1	أَكَلَ الْبَنْجَ
u'أَكْلٌ بَنْجٌ':Added, #2: 2	أَكْلُ الْبَنْجِ
u'أكل بَهائِمُ':Added, #2: 2	أَكْلُ الْبَنْجِ
u'أَكْلٌ بَهائِمُ':Added, #1: 1	أَكْلَ الْبَهَائِمِ
u'أَكَلَ بيض':Predicate, #1: 1	أَكْلَ الْبَهَائِمِ
u'أكل بيض':Added, #1: 1	أَكَلَ الْبَيْضَ
u'أَكْلٌ بيض':Added, #1: 1	أَكْلُ الْبَيْضِ
u'أكل بُيُوتٌ':Added, #1: 1	أَكْلُ الْبَيْضِ
u'أَكْلٌ بُيُوتٌ':Added, #1: 1	أَكْلُ بُيُوتِ
u'أَكْلَةٌ جَزُورٌ':Added, #1: 1	أَكْلُ بُيُوتِ
u'أَكْلَةٌ سَحَرٌ':Added, #1: 1	أَكْلَةُ جَزُورٍ
u'أَكْلَةٌ يَوْمٌ':Added, #3: 3	أَكْلَةُ السَّحَرِ
u'أَكَلَ تِبْن':Predicate, #1: 1	أَكْلَةِ الْيَوْمِ
u'أكل تُرَابٌ':Added, #1: 1	أَكَلَ التِّبْنَ
u'أَكْلٌ تُرَابٌ':Added, #1: 1	أَكْلُ التُّرَابِ
u'أكل تُرَابٌ':Added, #1: 1	أَكْلُ التُّرَابِ
u'أَكْلٌ تُرَابٌ':Added, #1: 1	أَكْلِ تُرَابٍ
u'أكل تِرْيَاقٌ':Added, #1: 1	أَكْلِ تُرَابٍ
u'أَكْلٌ تِرْيَاقٌ':Added, #1: 1	أَكْلُ التِّرْيَاقِ
u'أكل تِرْيَاقٌ':Added, #1: 1	أَكْلُ التِّرْيَاقِ
u'أَكْلٌ تِرْيَاقٌ':Added, #3: 3	أَكْلِ التِّرْيَاقِ
u'أكل تُفَّاحٌ':Added, #3: 3	أَكْلِ التِّرْيَاقِ
u'أَكْلٌ تُفَّاحٌ':Added, #1: 1	أَكْلَ التُّفَّاحِ
u'أَكَلَ تَكَلُّفٌ':Subject, #1: 1	أَكْلَ التُّفَّاحِ
u'أَكَلَ تَمْر':Predicate, #1: 1	أَكَلَ تَكَلُّفٌ
u'أكل تَمْر':Added, #2: 2	أَكَلَ التَّمْرَ
u'أَكْلٌ تَمْر':Added, #1: 1	أَكْلَ التَّمْرِ
u'أكل تَمْر':Added, #1: 1	أَكْلَ التَّمْرِ
u'أَكْلٌ تَمْر':Added, #3: 3	أَكْلِ التَّمْرِ
u'أكل تَمْرَةٌ':Added, #3: 3	أَكْلِ التَّمْرِ
u'أَكْلٌ تَمْرَةٌ':Added, #1: 1	أَكْلِ تَمْرَةٍ
u'أَكَلَ ثِمارٌ':Predicate, #1: 1	أَكْلِ تَمْرَةٍ
u'أَكَلَ ثَمَرٌ':Predicate, #1: 1	أَكَلَ الثِّمَارَ
u'أكل ثَمَرٌ':Added, #1: 1	أَكَلَ الثّمَرَ
u'أَكْلٌ ثَمَرٌ':Added, #1: 1	أَكْلُ ثَمَرِهِ
u'أكل ثَمَرٌ':Added, #1: 1	أَكْلُ ثَمَرِهِ
u'أَكْلٌ ثَمَرٌ':Added, #2: 2	أَكْلُ الثَّمَرِ
u'أكل ثَمَرٌ':Added, #2: 2	أَكْلُ الثَّمَرِ
u'أَكْلٌ ثَمَرٌ':Added, #2: 2	أَكْلُ ثَمَرِ
u'أكل ثَمَرَةٌ':Added, #2: 2	أَكْلُ ثَمَرِ
u'أَكْلٌ ثَمَرَةٌ':Added, #2: 2	أَكْلَ الثَّمَرَةِ
u'أَكَلَ ثَمَنٌ':Predicate, #2: 2	أَكْلَ الثَّمَرَةِ
u'أَكَلَ ثَوْرٌ':Predicate, #1: 1	أَكَلَ ثَمَنَ
u'أكل ثَوْرٌ':Added, #1: 1	أَكَلَ ثَوْرَ
u'أَكْلٌ ثَوْرٌ':Added, #1: 1	أَكْلِ ثَوْرٍ
u'أَكَلَ ثُومٌ':Predicate, #1: 1	أَكْلِ ثَوْرٍ
u'أكل ثُومٌ':Added, #5: 5	أَكَلَ الثُّومَ
u'أَكْلٌ ثُومٌ':Added, #1: 1	أَكْلُ الثُّومِ
u'أكل ثُومٌ':Added, #1: 1	أَكْلُ الثُّومِ
u'أَكْلٌ ثُومٌ':Added, #2: 2	أَكْلَ ثُومٍ
u'أكل ثُومٌ':Added, #2: 2	أَكْلَ ثُومٍ
u'أَكْلٌ ثُومٌ':Added, #9: 9	أَكْلِ الثُّومِ
u'أكل جَبَابِرَةٌ':Added, #9: 9	أَكْلِ الثُّومِ
u'أَكْلٌ جَبَابِرَةٌ':Added, #1: 1	أَكْلُ الْجَبَابِرَةِ
u'أَكَلَ جُبْنٌ':Predicate, #1: 1	أَكْلُ الْجَبَابِرَةِ
u'أكل جُبْنٌ':Added, #1: 1	أَكَلَ الْجُبْنَ
u'أَكْلٌ جُبْنٌ':Added, #3: 3	أَكْلِ الْجُبْنِ
u'أكل جَذَعٌ':Added, #3: 3	أَكْلِ الْجُبْنِ
u'أَكْلٌ جَذَعٌ':Added, #1: 1	أَكْلُ جَذَعٍ
u'أكل جَرَادٌ':Added, #1: 1	أَكْلُ جَذَعٍ
u'أَكْلٌ جَرَادٌ':Added, #2: 2	أَكْلُ الْجَرَادِ
u'أكل جَرَادٌ':Added, #2: 2	أَكْلُ الْجَرَادِ
u'أَكْلٌ جَرَادٌ':Added, #5: 5	أَكْلِ الْجَرَادِ
u'أكل جلد':Added, #5: 5	أَكْلِ الْجَرَادِ
u'أَكْلٌ جلد':Added, #2: 2	أَكْلِ الْجِلْدِ
u'أكل جِلْدٌ':Added, #2: 2	أَكْلِ الْجِلْدِ
u'أَكْلٌ جِلْدٌ':Added, #2: 2	أَكْلِ الْجِلْدِ
u'أكل جَمِيع':Added, #2: 2	أَكْلِ الْجِلْدِ
u'أَكْلٌ جَمِيع':Added, #1: 1	أَكْلُ الْجَمِيعِ
u'أكل جَنِينٌ':Added, #1: 1	أَكْلُ الْجَمِيعِ
u'أَكْلٌ جَنِينٌ':Added, #1: 1	أَكْلُ الْجَنِينِ
u'أَكَلَ جَوْزٌ':Predicate, #1: 1	أَكْلُ الْجَنِينِ
u'أكل جَوْزٌ':Added, #2: 2	أَكَلَ جَوْزَةً
u'أَكْلٌ جَوْزٌ':Added, #2: 2	أَكْلِ جَوْزَةِ
u'أَكَلَ جِيَفٌ':Predicate, #2: 2	أَكْلِ جَوْزَةِ
u'أكل جِيَفٌ':Added, #5: 5	أَكَلَ الْجِيَفَ
u'أَكْلٌ جِيَفٌ':Added, #1: 1	أَكْلَ الْجِيَفِ
u'أكل جِيفَةٌ':Added, #1: 1	أَكْلَ الْجِيَفِ
u'أَكْلٌ جِيفَةٌ':Added, #1: 1	أَكْلَ الْجِيفَةِ
u'أكل حامِضٌ':Added, #1: 1	أَكْلَ الْجِيفَةِ
u'أَكْلٌ حامِضٌ':Added, #2: 2	أَكْلِ الْحَامِضِ
u'أَكَلَ حَبٌّ':Predicate, #2: 2	أَكْلِ الْحَامِضِ
u'أَكَلَ حَبٌّ':Predicate, #1: 1	أَكَلَ حَبَّةً
u'أَكَلَ حَبَّةٌ':Predicate, #2: 2	أَكَلَ حَبَّةَ
u'أكل حُبوبٌ':Added, #2: 2	أَكَلَ حَبَّةَ
u'أَكْلٌ حُبوبٌ':Added, #1: 1	أَكْلُ الْحُبُوبِ
u'أَكَلَ حَديثٌ':Predicate, #1: 1	أَكْلُ الْحُبُوبِ
u'أكل حَرامٌ':Added, #1: 1	أَكَلَ الْحَدِيثَ
u'أَكْلٌ حَرامٌ':Added, #1: 1	أَكْلَ الْحَرَامِ
u'أكل حَرامٌ':Added, #1: 1	أَكْلَ الْحَرَامِ
u'أكل حَرامٌ':Added, #3: 3	أَكْلُ الْحَرَامِ
u'أَكْلٌ حَرامٌ':Added, #3: 3	أَكْلِ الْحَرَامِ
u'أَكْلٌ حَرامٌ':Added, #3: 3	أَكْلُ الْحَرَامِ
u'أكل حَشِيشٌ':Added, #3: 3	أَكْلِ الْحَرَامِ
u'أَكْلٌ حَشِيشٌ':Added, #1: 1	أَكْلِ الْحَشِيشِ
u'أكل حَشِيشٌ':Added, #1: 1	أَكْلِ الْحَشِيشِ
u'أَكْلٌ حَشِيشٌ':Added, #2: 2	أَكْلُ الْحَشِيشِ
u'أكل حِصَّةٌ':Added, #2: 2	أَكْلُ الْحَشِيشِ
u'أَكْلٌ حِصَّةٌ':Added, #1: 1	أَكْلُ حِصَّةِ
u'أَكَلَ حَلالٌ':Subject, #1: 1	أَكْلُ حِصَّةِ
u'أكل حَلالٌ':Added, #1: 1	أَكَلَ الْحَلَالُ
u'أَكْلٌ حَلالٌ':Added, #1: 1	أَكْلَ الْحَلَالِ
u'أكل حَلالٌ':Added, #1: 1	أَكْلَ الْحَلَالِ
u'أَكْلٌ حَلالٌ':Added, #3: 3	أَكْلِ الْحَلَالِ
u'أكل حَلالٌ':Added, #3: 3	أَكْلِ الْحَلَالِ
u'أَكْلٌ حَلالٌ':Added, #4: 4	أَكْلُ الْحَلَالِ
u'أَكَلَ حِمَارٌ':Subject, #4: 4	أَكْلُ الْحَلَالِ
u'أكل حِمَارٌ':Added, #1: 1	أَكَلَ الْحِمَارُ
u'أَكْلٌ حِمَارٌ':Added, #2: 2	أَكْلِ الْحِمَارِ
u'أكل حمر':Added, #2: 2	أَكْلِ الْحِمَارِ
u'أَكْلٌ حمر':Added, #1: 1	أَكْلُ الْحُمُرِ
u'أكل حُمُرٌ':Added, #1: 1	أَكْلُ الْحُمُرِ
u'أَكْلٌ حُمُرٌ':Added, #1: 1	أَكْلُ الْحُمُرِ
u'أكل حمر':Added, #1: 1	أَكْلُ الْحُمُرِ
u'أَكْلٌ حمر':Added, #4: 4	أَكْلِ الْحُمُرِ
u'أكل حُمُرٌ':Added, #4: 4	أَكْلِ الْحُمُرِ
u'أَكْلٌ حُمُرٌ':Added, #4: 4	أَكْلِ الْحُمُرِ
u'أَكَلَ حُمْرَةٌ':Predicate, #4: 4	أَكْلِ الْحُمُرِ
u'أَكَلَ حِنْطَةٌ':Predicate, #1: 1	أَكَلَ الْحُمْرَةَ
u'أكل حِنْطَةٌ':Added, #3: 3	أَكَلَ الْحِنْطَةَ
u'أَكْلٌ حِنْطَةٌ':Added, #1: 1	أَكْلِ الْحِنْطَةِ
u'أكل حِنْطَةٌ':Added, #1: 1	أَكْلِ الْحِنْطَةِ
u'أَكْلٌ حِنْطَةٌ':Added, #1: 1	أَكْلِ حِنْطَةٍ
u'أكل حَيٌّ':Added, #1: 1	أَكْلِ حِنْطَةٍ
u'أَكْلٌ حَيٌّ':Added, #1: 1	أَكْلِ الْحَيَّةِ
u'أكل حَيَّةٌ':Added, #1: 1	أَكْلِ الْحَيَّةِ
u'أَكْلٌ حَيَّةٌ':Added, #1: 1	أَكْلِ الْحَيَّةِ
u'أكل حِيتَانٌ':Added, #1: 1	أَكْلِ الْحَيَّةِ
u'أَكْلٌ حِيتَانٌ':Added, #1: 1	أَكْلِ الْحِيتَانِ
u'أكل حَيَوَانٌ':Added, #1: 1	أَكْلِ الْحِيتَانِ
u'أَكْلٌ حَيَوَانٌ':Added, #1: 1	أَكْلَ الْحَيَوَانِ
u'أكل حَيَوَانٌ':Added, #1: 1	أَكْلَ الْحَيَوَانِ
u'أَكْلٌ حَيَوَانٌ':Added, #1: 1	أَكْلُ حَيَوَانٍ
u'أكل حَيَوَانٌ':Added, #1: 1	أَكْلُ حَيَوَانٍ
u'أَكْلٌ حَيَوَانٌ':Added, #3: 3	أَكْلُ الْحَيَوَانِ
u'أَكَلَ خَادِمٌ':Subject, #3: 3	أَكْلُ الْحَيَوَانِ
u'أَكَلَ خُبْزٌ':Predicate, #1: 1	أَكَلَ خَادِمُهُ
u'أَكَلَ خُبْزٌ':Predicate, #7: 7	أَكَلَ الْخُبْزَ
u'أكل خُبْزٌ':Added, #7: 7	أَكَلَ خُبْزَ
u'أَكْلٌ خُبْزٌ':Added, #1: 1	أَكْلُ خُبْزٍ
u'أكل خُبْزٌ':Added, #1: 1	أَكْلُ خُبْزٍ
u'أَكْلٌ خُبْزٌ':Added, #2: 2	أَكْلَ الْخُبْزِ
u'أكل خُبْزٌ':Added, #2: 2	أَكْلَ الْخُبْزِ
u'أَكْلٌ خُبْزٌ':Added, #2: 2	أَكْلَ خُبْزِ
u'أكل خُبْزٌ':Added, #2: 2	أَكْلَ خُبْزِ
u'أَكْلٌ خُبْزٌ':Added, #3: 3	أَكْلُ خُبْزِ
u'أكل خُبْزٌ':Added, #3: 3	أَكْلُ خُبْزِ
u'أَكْلٌ خُبْزٌ':Added, #7: 7	أَكْلِ الْخُبْزِ
u'أكل خَطَّافٌ':Added, #7: 7	أَكْلِ الْخُبْزِ
u'أكل خُطَّافٌ':Added, #1: 1	أَكْلُ الْخَطَّافِ
u'أَكْلٌ خَطَّافٌ':Added, #1: 1	أَكْلِ الْخُطَّافِ
u'أَكْلٌ خُطَّافٌ':Added, #1: 1	أَكْلُ الْخَطَّافِ
u'أَكَلَ خِلاَفٌ':Subject, #1: 1	أَكْلِ الْخُطَّافِ
u'أكل خِلْف':Added, #1: 1	أَكَلَ خِلَافُ
u'أَكْلٌ خِلْف':Added, #1: 1	أَكْلِ خِلْفَةِ
u'أكل خِلْفَة':Added, #1: 1	أَكْلِ خِلْفَةِ
u'أَكْلٌ خِلْفَة':Added, #1: 1	أَكْلِ خِلْفَةِ
u'أَكَلَ خَمْسٌ':Predicate, #1: 1	أَكْلِ خِلْفَةِ
u'أكل خِنْزِيرٌ':Added, #1: 1	أَكَلَ خَمْسَ
u'أكل خِنْزِيرٌ':Added, #1: 1	أَكْلِ خِنْزِيرٍ
u'أَكْلٌ خِنْزِيرٌ':Added, #1: 1	أَكْلِ خِنْزِيرِ
u'أَكْلٌ خِنْزِيرٌ':Added, #1: 1	أَكْلِ خِنْزِيرٍ
u'أكل خِنْزِيرٌ':Added, #1: 1	أَكْلِ خِنْزِيرِ
u'أَكْلٌ خِنْزِيرٌ':Added, #2: 2	أَكْلِ الْخِنْزِيرِ
u'أكل خَيْلٌ':Added, #2: 2	أَكْلِ الْخِنْزِيرِ
u'أَكْلٌ خَيْلٌ':Added, #2: 2	أَكْلُ الْخَيْلِ
u'أكل خَيْلٌ':Added, #2: 2	أَكْلُ الْخَيْلِ
u'أَكْلٌ خَيْلٌ':Added, #3: 3	أَكْلِ الْخَيْلِ
u'أكل دَابَّةٌ':Added, #3: 3	أَكْلِ الْخَيْلِ
u'أَكْلٌ دَابَّةٌ':Added, #1: 1	أَكْلِ الدَّابَّةِ
u'أكل دَابَّةٌ':Added, #1: 1	أَكْلِ الدَّابَّةِ
u'أَكْلٌ دَابَّةٌ':Added, #1: 1	أَكْلُ دَابَّةٍ
u'أَكَلَ دَاخِلٌ':Predicate, #1: 1	أَكْلُ دَابَّةٍ
u'أَكَلَ دَجاج':Predicate, #1: 1	أَكَلَ دَاخِلَ
u'أكل دَجَاجٌ':Added, #1: 1	أَكَلَ الدَّجَاجَةَ
u'أَكْلٌ دَجَاجٌ':Added, #1: 1	أَكْلُ الدَّجَاجِ
u'أكل دِرْهَمٌ':Added, #1: 1	أَكْلُ الدَّجَاجِ
u'أكل دِرْهَم':Added, #1: 1	أَكْلُ دِرْهَمٍ
u'أَكْلٌ دِرْهَمٌ':Added, #1: 1	أَكْلُ دِرْهَمٍ
u'أَكْلٌ دِرْهَم':Added, #1: 1	أَكْلُ دِرْهَمٍ
u'أَكَلَ دَقيقٌ':Predicate, #1: 1	أَكْلُ دِرْهَمٍ
u'أكل دَقيقٌ':Added, #3: 3	أَكَلَ الدَّقِيقَ
u'أَكْلٌ دَقيقٌ':Added, #1: 1	أَكْلُ دَقِيقِ
u'أكل دَقيقٌ':Added, #1: 1	أَكْلُ دَقِيقِ
u'أَكْلٌ دَقيقٌ':Added, #4: 4	أَكْلَ الدَّقِيقِ
u'أكل دَواءٌ':Added, #4: 4	أَكْلَ الدَّقِيقِ
u'أَكْلٌ دَواءٌ':Added, #1: 1	أَكْلِ الدَّوَاءِ
u'أكل دَوَابُّ':Added, #1: 1	أَكْلِ الدَّوَاءِ
u'أَكْلٌ دَوَابُّ':Added, #1: 1	أَكْلِ الدَّوَابِّ
u'أكل دُودٌ':Added, #1: 1	أَكْلِ الدَّوَابِّ
u'أَكْلٌ دُودٌ':Added, #1: 1	أَكْلِ الدُّودِ
u'أكل دُودٌ':Added, #1: 1	أَكْلِ الدُّودِ
u'أَكْلٌ دُودٌ':Added, #2: 2	أَكْلِ دُودِ
u'أكل دُودٌ':Added, #2: 2	أَكْلِ دُودِ
u'أَكْلٌ دُودٌ':Added, #6: 6	أَكْلُ دُودِ
u'أَكَلَ دونٌ':Predicate, #6: 6	أَكْلُ دُودِ
u'أَكَلَ ذَبيحٌ':Predicate, #1: 1	أَكَلَ دُونَ
u'أكل ذَبيحٌ':Added, #1: 1	أَكَلَ ذَبِيحَةَ
u'أكل ذَبيحٌ':Added, #1: 1	أَكْلَ ذَبِيحَةِ
u'أكل ذَبيحٌ':Added, #1: 1	أَكْلُ ذَبِيحَةِ
u'أَكْلٌ ذَبيحٌ':Added, #1: 1	أَكْلِ ذَبِيحَةِ
u'أَكْلٌ ذَبيحٌ':Added, #1: 1	أَكْلَ ذَبِيحَةِ
u'أَكْلٌ ذَبيحٌ':Added, #1: 1	أَكْلُ ذَبِيحَةِ
u'أكل ذَبيحٌ':Added, #1: 1	أَكْلِ ذَبِيحَةِ
u'أكل ذَبيحٌ':Added, #1: 1	أَكْلُ ذَبِيحَتِهِ
u'أَكْلٌ ذَبيحٌ':Added, #1: 1	أَكْلِ ذَبِيحَتِهِ
u'أَكْلٌ ذَبيحٌ':Added, #1: 1	أَكْلُ ذَبِيحَتِهِ
u'أَكَلَ ذَبيحَةٌ':Predicate, #1: 1	أَكْلِ ذَبِيحَتِهِ
u'أكل ذَبيحَةٌ':Added, #1: 1	أَكَلَ ذَبِيحَةَ
u'أكل ذَبيحَةٌ':Added, #1: 1	أَكْلَ ذَبِيحَةِ
u'أكل ذَبيحَةٌ':Added, #1: 1	أَكْلُ ذَبِيحَةِ
u'أَكْلٌ ذَبيحَةٌ':Added, #1: 1	أَكْلِ ذَبِيحَةِ
u'أَكْلٌ ذَبيحَةٌ':Added, #1: 1	أَكْلَ ذَبِيحَةِ
u'أَكْلٌ ذَبيحَةٌ':Added, #1: 1	أَكْلُ ذَبِيحَةِ
u'أكل ذَبيحَةٌ':Added, #1: 1	أَكْلِ ذَبِيحَةِ
u'أكل ذَبيحَةٌ':Added, #1: 1	أَكْلُ ذَبِيحَتِهِ
u'أَكْلٌ ذَبيحَةٌ':Added, #1: 1	أَكْلِ ذَبِيحَتِهِ
u'أَكْلٌ ذَبيحَةٌ':Added, #1: 1	أَكْلُ ذَبِيحَتِهِ
u'أكل ذَكاةٌ':Added, #1: 1	أَكْلِ ذَبِيحَتِهِ
u'أَكْلٌ ذَكاةٌ':Added, #1: 1	أَكْلِ ذَكَاتِهِ
u'أكل ذُكورٌ':Added, #1: 1	أَكْلِ ذَكَاتِهِ
u'أَكْلٌ ذُكورٌ':Added, #1: 1	أَكْلِ الذُّكُورِ
u'أَكَلَ ذِئْبٌ':Subject, #1: 1	أَكْلِ الذُّكُورِ
u'أكل ذِئْبٌ':Added, #2: 2	أَكَلَ الذِّئْبُ
u'أكل ذِئْبٌ':Added, #1: 1	أَكْلَ الذِّئْبِ
u'أَكْلٌ ذِئْبٌ':Added, #1: 1	أَكْلُ الذِّئْبِ
u'أَكْلٌ ذِئْبٌ':Added, #1: 1	أَكْلَ الذِّئْبِ
u'أَكَلَ رَأْسٌ':Predicate, #1: 1	أَكْلُ الذِّئْبِ
u'أكل راغِب':Added, #1: 1	أَكَلَ الرَّأْسَ
u'أَكْلٌ راغِب':Added, #1: 1	أَكْلَ رَاغِبٍ
u'أَكَلَ رَاهِنٌ':Subject, #1: 1	أَكْلَ رَاغِبٍ
u'أكل رِبْحٌ':Added, #1: 1	أَكَلَ الرَّاهِنُ
u'أَكْلٌ رِبْحٌ':Added, #1: 1	أَكْلُ الرِّبْحِ
u'أَكَلَ رَجُلٌ':Subject, #1: 1	أَكْلُ الرِّبْحِ
u'أَكَلَ رَجُلٌ':Subject, #12: 12	أَكَلَ الرَّجُلُ
u'أكل رَجُلٌ':Added, #1: 1	أَكَلَ رَجُلٌ
u'أَكْلٌ رَجُلٌ':Added, #1: 1	أَكْلُ الرَّجُلِ
u'أكل رَخَم':Added, #1: 1	أَكْلُ الرَّجُلِ
u'أَكْلٌ رَخَم':Added, #1: 1	أَكْلَ الرَّخَمِ
u'أَكَلَ رَدٌّ':Predicate, #1: 1	أَكْلَ الرَّخَمِ
u'أَكَلَ رَسُولٌ':Subject, #1: 1	أَكَلَ رَدَّ
u'أَكَلَ رُطَبٌ':Predicate, #9: 9	أَكَلَ رَسُولُ
u'أكل رُطَبٌ':Added, #3: 3	أَكَلَ الرُّطَبَ
u'أكل رُطَبٌ':Added, #1: 1	أَكْلَ الرُّطَبِ
u'أكل رُطَبٌ':Added, #1: 1	أَكْلُ الرّطَبِ
u'أَكْلٌ رُطَبٌ':Added, #1: 1	أَكْلُ الرُّطَبِ
u'أَكْلٌ رُطَبٌ':Added, #1: 1	أَكْلَ الرُّطَبِ
u'أَكْلٌ رُطَبٌ':Added, #1: 1	أَكْلُ الرّطَبِ
u'أكل رُطَبٌ':Added, #1: 1	أَكْلُ الرُّطَبِ
u'أَكْلٌ رُطَبٌ':Added, #4: 4	أَكْلِ الرُّطَبِ
u'أَكَلَ رَغيفٌ':Predicate, #4: 4	أَكْلِ الرُّطَبِ
u'أكل رَغيفٌ':Added, #1: 1	أَكَلَ الرَّغِيفَ
u'أكل رَغيفٌ':Added, #1: 1	أَكْلَ الرَّغِيفِ
u'أَكْلٌ رَغيفٌ':Added, #1: 1	أَكْلِ الرَّغِيفِ
u'أَكْلٌ رَغيفٌ':Added, #1: 1	أَكْلَ الرَّغِيفِ
u'أكل رَقيقٌ':Added, #1: 1	أَكْلِ الرَّغِيفِ
u'أكل رَقيق':Added, #1: 1	أَكْلِ رَقِيقِ
u'أَكْلٌ رَقيقٌ':Added, #1: 1	أَكْلِ رَقِيقِ
u'أَكْلٌ رَقيق':Added, #1: 1	أَكْلِ رَقِيقِ
u'أكل رُمَّانَةٌ':Added, #1: 1	أَكْلِ رَقِيقِ
u'أكل رُمَّانَةٌ':Added, #1: 1	أَكْلَ الرُّمَّانَةِ
u'أَكْلٌ رُمَّانَةٌ':Added, #1: 1	أَكْلِ الرُّمَّانَةِ
u'أَكْلٌ رُمَّانَةٌ':Added, #1: 1	أَكْلَ الرُّمَّانَةِ
u'أكل رَوْثٌ':Added, #1: 1	أَكْلِ الرُّمَّانَةِ
u'أَكْلٌ رَوْثٌ':Added, #1: 1	أَكْلِ رَوْثِ
u'أكل زادٌ':Added, #1: 1	أَكْلِ رَوْثِ
u'أَكْلٌ زادٌ':Added, #1: 1	أَكْلِ زَادٍ
u'أكل زائِدٌ':Added, #1: 1	أَكْلِ زَادٍ
u'أَكْلٌ زائِدٌ':Added, #1: 1	أَكْلُ الزَّائِدِ
u'أكل زُبْدٌ':Added, #1: 1	أَكْلُ الزَّائِدِ
u'أَكْلٌ زُبْدٌ':Added, #1: 1	أَكْلِ الزُّبْدِ
u'أكل زَبيبٌ':Added, #1: 1	أَكْلِ الزُّبْدِ
u'أَكْلٌ زَبيبٌ':Added, #1: 1	أَكْلُ الزَّبِيبِ
u'أَكَلَ زَرْعٌ':Predicate, #1: 1	أَكْلُ الزَّبِيبِ
u'أَكَلَ زَعْفَرانٌ':Predicate, #1: 1	أَكَلَ الزَّرْعَ
u'أكل زَوائِدُ':Added, #2: 2	أَكَلَ الزَّعْفَرَانَ
u'أَكْلٌ زَوائِدُ':Added, #1: 1	أَكْلِ زَوَائِدِ
u'أَكَلَ سَبْعٌ':Predicate, #1: 1	أَكْلِ زَوَائِدِ
u'أَكَلَ سَبُعٌ':Subject, #2: 2	أَكَلَ سَبْعَ
u'أكل سَبُعٌ':Added, #12: 12	أَكَلَ السَّبُعُ
u'أكل سُبْعٌ':Added, #1: 1	أَكْلَ السَّبُعِ
u'أَكْلٌ سَبُعٌ':Added, #1: 1	أَكْلِ السُّبْعِ
u'أَكْلٌ سُبْعٌ':Added, #1: 1	أَكْلَ السَّبُعِ
u'أكل سَبْعٌ':Added, #1: 1	أَكْلِ السُّبْعِ
u'أَكْلٌ سَبْعٌ':Added, #1: 1	أَكْلَ سَبْعٍ
u'أكل سَحُورٌ':Added, #1: 1	أَكْلَ سَبْعٍ
u'أكل سُحُورٌ':Added, #1: 1	أَكْلِ السَّحُورِ
u'أكل سُحُورٌ':Added, #1: 1	أَكْلَ السُّحُورِ
u'أَكْلٌ سَحُورٌ':Added, #1: 1	أَكْلِ السُّحُورِ
u'أَكْلٌ سُحُورٌ':Added, #1: 1	أَكْلِ السَّحُورِ
u'أَكْلٌ سُحُورٌ':Added, #1: 1	أَكْلَ السُّحُورِ
u'أكل سَحُورٌ':Added, #1: 1	أَكْلِ السُّحُورِ
u'أكل سُحُورٌ':Added, #2: 2	أَكْلُ السَّحُورِ
u'أَكْلٌ سَحُورٌ':Added, #2: 2	أَكْلُ السُّحُورِ
u'أَكْلٌ سُحُورٌ':Added, #2: 2	أَكْلُ السَّحُورِ
u'أكل سُكَّرٌ':Added, #2: 2	أَكْلُ السُّحُورِ
u'أَكْلٌ سُكَّرٌ':Added, #1: 1	أَكْلَ السُّكَّرِ
u'أكل سِلْعَةٌ':Added, #1: 1	أَكْلَ السُّكَّرِ
u'أَكْلٌ سِلْعَةٌ':Added, #1: 1	أَكْلِ السِّلْعَةِ
u'أكل سَمَكٌ':Added, #1: 1	أَكْلِ السِّلْعَةِ
u'أَكْلٌ سَمَكٌ':Added, #1: 1	أَكْلُ السَّمَكَاتِ
u'أكل سَمَكٌ':Added, #1: 1	أَكْلُ السَّمَكَاتِ
u'أكل سَمَكٌ':Added, #1: 1	أَكْلُ السَّمَكَةِ
u'أَكْلٌ سَمَكٌ':Added, #1: 1	أَكْلِ السَّمَكَةِ
u'أَكْلٌ سَمَكٌ':Added, #1: 1	أَكْلُ السَّمَكَةِ
u'أكل سَمَكٌ':Added, #1: 1	أَكْلِ السَّمَكَةِ
u'أَكْلٌ سَمَكٌ':Added, #1: 1	أَكْلُ سَمَكِ
u'أكل سَمَكٌ':Added, #1: 1	أَكْلُ سَمَكِ
u'أَكْلٌ سَمَكٌ':Added, #2: 2	أَكْلِ السَّمَكِ
u'أكل سِنَّوْرٌ':Added, #2: 2	أَكْلِ السَّمَكِ
u'أَكْلٌ سِنَّوْرٌ':Added, #2: 2	أَكْلِ السِّنَّوْرِ
u'أَكَلَ سُوسٌ':Subject, #2: 2	أَكْلِ السِّنَّوْرِ
u'أكل سَوِيق':Added, #2: 2	أَكَلَ السُّوسُ
u'أَكْلٌ سَوِيق':Added, #1: 1	أَكْلُ السَّوِيقِ
u'أكل سَيِّدٌ':Added, #1: 1	أَكْلُ السَّوِيقِ
u'أَكْلٌ سَيِّدٌ':Added, #1: 1	أَكْلَ السَّيِّدِ
u'أكل شَاةٌ':Added, #1: 1	أَكْلَ السَّيِّدِ
u'أَكْلٌ شَاةٌ':Added, #1: 1	أَكْلُ شَاتِهِ
u'أكل شَاةٌ':Added, #1: 1	أَكْلُ شَاتِهِ
u'أَكْلٌ شَاةٌ':Added, #2: 2	أَكْلُ الشَّاةِ
u'أَكَلَ شَاهِدٌ':Subject, #2: 2	أَكْلُ الشَّاةِ
u'أكل شَجَرَةٌ':Added, #1: 1	أَكَلَ الشَّاهِدُ
u'أَكْلٌ شَجَرَةٌ':Added, #6: 6	أَكْلِ الشَّجَرَةِ
u'أَكَلَ شَحْمٌ':Predicate, #6: 6	أَكْلِ الشَّجَرَةِ
u'أكل شُحُومٌ':Added, #4: 4	أَكَلَ شَحْمَ
u'أَكْلٌ شُحُومٌ':Added, #2: 2	أَكْلُ شُحُومِ
u'أكل شَخْصٌ':Added, #2: 2	أَكْلُ شُحُومِ
u'أَكْلٌ شَخْصٌ':Added, #1: 1	أَكْلِ الشَّخْصِ
u'أكل شَعِيرٌ':Added, #1: 1	أَكْلِ الشَّخْصِ
u'أكل شَعِيرٌ':Added, #1: 1	أَكْلَ الشّعِيرِ
u'أَكْلٌ شَعِيرٌ':Added, #1: 1	أَكْلِ الشَّعِيرِ
u'أَكْلٌ شَعِيرٌ':Added, #1: 1	أَكْلَ الشّعِيرِ
u'أكل شُهُودٌ':Added, #1: 1	أَكْلِ الشَّعِيرِ
u'أَكْلٌ شُهُودٌ':Added, #1: 1	أَكْلَ شُهُودِ
u'أكل شَيْءٌ':Added, #1: 1	أَكْلَ شُهُودِ
u'أَكْلٌ شَيْءٌ':Added, #4: 4	أَكْلِ شَيْءٍ
u'أكل شَيْءٌ':Added, #4: 4	أَكْلِ شَيْءٍ
u'أَكْلٌ شَيْءٌ':Added, #6: 6	أَكْلَ شَيْءٍ
u'أكل شَيْءٌ':Added, #6: 6	أَكْلَ شَيْءٍ
u'أَكْلٌ شَيْءٌ':Added, #7: 7	أَكْلُ شَيْءٍ
u'أكل شَيْطَانٌ':Added, #7: 7	أَكْلُ شَيْءٍ
u'أَكْلٌ شَيْطَانٌ':Added, #1: 1	أَكْلُ الشَّيْطَانِ
u'أكل شَيْهَم':Added, #1: 1	أَكْلُ الشَّيْطَانِ
u'أَكْلٌ شَيْهَم':Added, #1: 1	أَكْلُ الشّيْهَمِ
u'أَكَلَ صَائِمٌ':Subject, #1: 1	أَكْلُ الشّيْهَمِ
u'أَكَلَ صَقْرٌ':Subject, #11: 11	أَكَلَ الصَّائِمُ
u'أَكَلَ صَيْدٌ':Predicate, #1: 1	أَكَلَ الصَّقْرُ
u'أكل صَيْدٌ':Added, #3: 3	أَكَلَ الصَّيْدَ
u'أَكْلٌ صَيْدٌ':Added, #1: 1	أَكْلُ الصَّيْدِ
u'أكل صَيْدٌ':Added, #1: 1	أَكْلُ الصَّيْدِ
u'أكل صَيْدٌ':Added, #1: 1	أَكْلُ صَيْدٍ
u'أكل صَيْدٌ':Added, #1: 1	أَكْلُ صَيْدِ
u'أَكْلٌ صَيْدٌ':Added, #1: 1	أَكْلِ صَيْدٍ
u'أَكْلٌ صَيْدٌ':Added, #1: 1	أَكْلُ صَيْدٍ
u'أَكْلٌ صَيْدٌ':Added, #1: 1	أَكْلُ صَيْدِ
u'أكل صَيْدٌ':Added, #1: 1	أَكْلِ صَيْدٍ
u'أَكْلٌ صَيْدٌ':Added, #1: 1	أَكْلِ صَيْدِهِ
u'أكل صَيْدٌ':Added, #1: 1	أَكْلِ صَيْدِهِ
u'أَكْلٌ صَيْدٌ':Added, #5: 5	أَكْلَ الصَّيْدِ
u'أكل صَيْدٌ':Added, #5: 5	أَكْلَ الصَّيْدِ
u'أَكْلٌ صَيْدٌ':Added, #9: 9	أَكْلِ الصَّيْدِ
u'أكل ضَبٌّ':Added, #9: 9	أَكْلِ الصَّيْدِ
u'أَكْلٌ ضَبٌّ':Added, #1: 1	أَكْلَ الضَّبِّ
u'أكل ضَبٌّ':Added, #1: 1	أَكْلَ الضَّبِّ
u'أَكْلٌ ضَبٌّ':Added, #2: 2	أَكْلِ الضَّبِّ
u'أَكَلَ ضَمِنٌ':Predicate, #2: 2	أَكْلِ الضَّبِّ
u'أكل ضَيْفٌ':Added, #1: 1	أَكَلَ ضَمِنَ
u'أَكْلٌ ضَيْفٌ':Added, #2: 2	أَكْلُ الضَّيْفِ
u'أكل طَاهِرٌ':Added, #2: 2	أَكْلُ الضَّيْفِ
u'أَكْلٌ طَاهِرٌ':Added, #1: 1	أَكْلُ طَاهِرٍ
u'أكل طَرِيقَةٌ':Added, #1: 1	أَكْلُ طَاهِرٍ
u'أَكْلٌ طَرِيقَةٌ':Added, #1: 1	أَكْلِ الطَّرِيقَةِ
u'أَكَلَ طعام':Predicate, #1: 1	أَكْلِ الطَّرِيقَةِ
u'أَكَلَ طَعَامٌ':Predicate, #16: 16	أَكَلَ الطَّعَامَ
u'أَكَلَ طعام':Predicate, #16: 16	أَكَلَ الطَّعَامَ
u'أَكَلَ طَعَامٌ':Predicate, #6: 6	أَكَلَ طَعَامَ
u'أكل طعام':Added, #6: 6	أَكَلَ طَعَامَ
u'أَكْلٌ طعام':Added, #11: 11	أَكْلِ الطَّعَامِ
u'أكل طَعَامٌ':Added, #11: 11	أَكْلِ الطَّعَامِ
u'أَكْلٌ طَعَامٌ':Added, #11: 11	أَكْلِ الطَّعَامِ
u'أكل طعام':Added, #11: 11	أَكْلِ الطَّعَامِ
u'أَكْلٌ طعام':Added, #1: 1	أَكْلُ طَعَامٍ
u'أكل طَعَامٌ':Added, #1: 1	أَكْلُ طَعَامٍ
u'أَكْلٌ طَعَامٌ':Added, #1: 1	أَكْلُ طَعَامٍ
u'أكل طعام':Added, #1: 1	أَكْلُ طَعَامٍ
u'أكل طعام':Added, #1: 1	أَكْلُ طَعَامِهِ
u'أَكْلٌ طعام':Added, #1: 1	أَكْلِ طَعَامِهِ
u'أَكْلٌ طعام':Added, #1: 1	أَكْلُ طَعَامِهِ
u'أكل طَعَامٌ':Added, #1: 1	أَكْلِ طَعَامِهِ
u'أكل طَعَامٌ':Added, #1: 1	أَكْلُ طَعَامِهِ
u'أَكْلٌ طَعَامٌ':Added, #1: 1	أَكْلِ طَعَامِهِ
u'أَكْلٌ طَعَامٌ':Added, #1: 1	أَكْلُ طَعَامِهِ
u'أكل طعام':Added, #1: 1	أَكْلِ طَعَامِهِ
u'أَكْلٌ طعام':Added, #2: 2	أَكْلُ الطَّعَامِ
u'أكل طَعَامٌ':Added, #2: 2	أَكْلُ الطَّعَامِ
u'أَكْلٌ طَعَامٌ':Added, #2: 2	أَكْلُ الطَّعَامِ
u'أكل طعام':Added, #2: 2	أَكْلُ الطَّعَامِ
u'أَكْلٌ طعام':Added, #2: 2	أَكْلِ طَعَامٍ
u'أكل طَعَامٌ':Added, #2: 2	أَكْلِ طَعَامٍ
u'أَكْلٌ طَعَامٌ':Added, #2: 2	أَكْلِ طَعَامٍ
u'أكل طعام':Added, #2: 2	أَكْلِ طَعَامٍ
u'أَكْلٌ طعام':Added, #3: 3	أَكْلَ الطَّعَامِ
u'أكل طَعَامٌ':Added, #3: 3	أَكْلَ الطَّعَامِ
u'أَكْلٌ طَعَامٌ':Added, #3: 3	أَكْلَ الطَّعَامِ
u'أكل طعام':Added, #3: 3	أَكْلَ الطَّعَامِ
u'أَكْلٌ طعام':Added, #3: 3	أَكْلُ طَعَامِ
u'أكل طَعَامٌ':Added, #3: 3	أَكْلُ طَعَامِ
u'أَكْلٌ طَعَامٌ':Added, #3: 3	أَكْلُ طَعَامِ
u'أكل طعام':Added, #3: 3	أَكْلُ طَعَامِ
u'أَكْلٌ طعام':Added, #4: 4	أَكْلِ طَعَامِ
u'أكل طَعَامٌ':Added, #4: 4	أَكْلِ طَعَامِ
u'أَكْلٌ طَعَامٌ':Added, #4: 4	أَكْلِ طَعَامِ
u'أكل طَيِّبٌ':Added, #4: 4	أَكْلِ طَعَامِ
u'أَكْلٌ طَيِّبٌ':Added, #1: 1	أَكْلِ الطَّيِّبِ
u'أكل طِيبٌ':Added, #1: 1	أَكْلِ الطَّيِّبِ
u'أَكْلٌ طِيبٌ':Added, #2: 2	أَكْلِ الطِّيبِ
u'أكل طَيِّبٌ':Added, #2: 2	أَكْلِ الطِّيبِ
u'أَكْلٌ طَيِّبٌ':Added, #2: 2	أَكْلِ الطَّيِّبَاتِ
u'أَكَلَ طِينٌ':Predicate, #2: 2	أَكْلِ الطَّيِّبَاتِ
u'أكل طِينٌ':Added, #6: 6	أَكَلَ الطِّينَ
u'أَكْلٌ طِينٌ':Added, #5: 5	أَكْلُ الطِّينِ
u'أكل طِينٌ':Added, #5: 5	أَكْلُ الطِّينِ
u'أَكْلٌ طِينٌ':Added, #7: 7	أَكْلَ الطِّينِ
u'أكل طِينٌ':Added, #7: 7	أَكْلَ الطِّينِ
u'أَكْلٌ طِينٌ':Added, #8: 8	أَكْلِ الطِّينِ
u'أكل ظِباءٌ':Added, #8: 8	أَكْلِ الطِّينِ
u'أَكْلٌ ظِباءٌ':Added, #1: 1	أَكْلُ الظِّبَاءِ
u'أَكَلَ عَبْدٌ':Subject, #1: 1	أَكْلُ الظِّبَاءِ
u'أَكَلَ عَشَاءٌ':Predicate, #2: 2	أَكَلَ الْعَبْدُ
u'أكل عَشْرٌ':Added, #2: 2	أَكَلَ الْعَشَاءَ
u'أَكْلٌ عَشْرٌ':Added, #1: 1	أَكْلِ عَشْرَةٍ
u'أكل عَشِيٌّ':Added, #1: 1	أَكْلِ عَشْرَةٍ
u'أَكْلٌ عَشِيٌّ':Added, #1: 1	أَكْلِ الْعَشِيِّ
u'أكل عَصَافِيرُ':Added, #1: 1	أَكْلِ الْعَشِيِّ
u'أَكْلٌ عَصَافِيرُ':Added, #1: 1	أَكْلُ الْعَصَافِيرِ
u'أَكَلَ عَصِيدَةٌ':Predicate, #1: 1	أَكْلُ الْعَصَافِيرِ
u'أكل عُضْوٌ':Added, #1: 1	أَكَلَ الْعَصِيدَةَ
u'أَكْلٌ عُضْوٌ':Added, #1: 1	أَكْلُ عُضْوٍ
u'أكل عُضْوٌ':Added, #1: 1	أَكْلُ عُضْوٍ
u'أَكْلٌ عُضْوٌ':Added, #1: 1	أَكْلُ عُضْوِهِ
u'أَكَلَ عَقِبٌ':Predicate, #1: 1	أَكْلُ عُضْوِهِ
u'أكل عِنَبٌ':Added, #1: 1	أَكَلَ عَقِبَ
u'أكل عِنَبٌ':Added, #1: 1	أَكْلَ الْعِنَبِ
u'أَكْلٌ عِنَبٌ':Added, #1: 1	أَكْلِ الْعِنَبِ
u'أَكْلٌ عِنَبٌ':Added, #1: 1	أَكْلَ الْعِنَبِ
u'أَكَلَ عند':Predicate, #1: 1	أَكْلِ الْعِنَبِ
u'أَكَلَ عين':Predicate, #5: 5	أَكَلَ عِنْدَ
u'أَكَلَ عَيْنٌ':Predicate, #4: 4	أَكَلَ عَيْنَ
u'أَكَلَ عَيْن':Predicate, #4: 4	أَكَلَ عَيْنَ
u'أكل عَيْنٌ':Added, #4: 4	أَكَلَ عَيْنَ
u'أكل عَيْن':Added, #1: 1	أَكْلِ عَيْنٍ
u'أَكْلٌ عَيْنٌ':Added, #1: 1	أَكْلِ عَيْنٍ
u'أَكْلٌ عَيْن':Added, #1: 1	أَكْلِ عَيْنٍ
u'أكل عين':Added, #1: 1	أَكْلِ عَيْنٍ
u'أكل عَيْنٌ':Added, #2: 2	أَكْلِ عَيْنِ
u'أكل عَيْن':Added, #2: 2	أَكْلِ عَيْنِ
u'أَكْلٌ عين':Added, #2: 2	أَكْلِ عَيْنِ
u'أَكْلٌ عَيْنٌ':Added, #2: 2	أَكْلِ عَيْنِ
u'أَكْلٌ عَيْن':Added, #2: 2	أَكْلِ عَيْنِ
u'أكل عين':Added, #2: 2	أَكْلِ عَيْنِ
u'أكل عَيْنٌ':Added, #2: 2	أَكْلِ عَيْنِهِ
u'أكل عَيْن':Added, #2: 2	أَكْلِ عَيْنِهِ
u'أَكْلٌ عين':Added, #2: 2	أَكْلِ عَيْنِهِ
u'أَكْلٌ عَيْنٌ':Added, #2: 2	أَكْلِ عَيْنِهِ
u'أَكْلٌ عَيْن':Added, #2: 2	أَكْلِ عَيْنِهِ
u'أكل غَدَاءٌ':Added, #2: 2	أَكْلِ عَيْنِهِ
u'أَكْلٌ غَدَاءٌ':Added, #1: 1	أَكْلُ الْغَدَاءِ
u'أكل غُدَّةٌ':Added, #1: 1	أَكْلُ الْغَدَاءِ
u'أَكْلٌ غُدَّةٌ':Added, #1: 1	أَكْلُ الْغُدَّةِ
u'أكل غُدَّةٌ':Added, #1: 1	أَكْلُ الْغُدَّةِ
u'أَكْلٌ غُدَّةٌ':Added, #2: 2	أَكْلَ الْغُدَّةِ
u'أكل غِرْبَانٌ':Added, #2: 2	أَكْلَ الْغُدَّةِ
u'أَكْلٌ غِرْبَانٌ':Added, #1: 1	أَكْلِ الْغِرْبَانِ
u'أَكَلَ غير':Predicate, #1: 1	أَكْلِ الْغِرْبَانِ
u'أَكَلَ غَيْرٌ':Predicate, #1: 1	أَكَلَ غَيْرَ
u'أَكَلَ غير':Subject, #1: 1	أَكَلَ غَيْرَ
u'أَكَلَ غَيْرٌ':Subject, #1: 1	أَكَلَ غَيْرُهُ
u'أكل غير':Added, #1: 1	أَكَلَ غَيْرُهُ
u'أكل غير':Added, #1: 1	أَكْلُ غَيْرِهِ
u'أكل غَيْرٌ':Added, #1: 1	أَكْلِ غَيْرِهِ
u'أكل غَيْرٌ':Added, #1: 1	أَكْلُ غَيْرِهِ
u'أَكْلٌ غير':Added, #1: 1	أَكْلِ غَيْرِهِ
u'أَكْلٌ غير':Added, #1: 1	أَكْلُ غَيْرِهِ
u'أَكْلٌ غَيْرٌ':Added, #1: 1	أَكْلِ غَيْرِهِ
u'أَكْلٌ غَيْرٌ':Added, #1: 1	أَكْلُ غَيْرِهِ
u'أَكَلَ فَاكِهٌ':Predicate, #1: 1	أَكْلِ غَيْرِهِ
u'أكل فَاكِهٌ':Added, #1: 1	أَكَلَ فَاكِهَةً
u'أَكْلٌ فَاكِهٌ':Added, #1: 1	أَكْلُ الْفَاكِهَةِ
u'أكل فَاكِهٌ':Added, #1: 1	أَكْلُ الْفَاكِهَةِ
u'أَكْلٌ فَاكِهٌ':Added, #2: 2	أَكْلِ الْفَاكِهَةِ
u'أكل فَاكِهٌ':Added, #2: 2	أَكْلِ الْفَاكِهَةِ
u'أَكْلٌ فَاكِهٌ':Added, #2: 2	أَكْلُ فَاكِهَةٍ
u'أكل فَاكِهَةٌ':Added, #2: 2	أَكْلُ فَاكِهَةٍ
u'أَكْلٌ فَاكِهَةٌ':Added, #1: 1	أَكْلُ الْفَاكِهَةِ
u'أكل فَاكِهَةٌ':Added, #1: 1	أَكْلُ الْفَاكِهَةِ
u'أَكْلٌ فَاكِهَةٌ':Added, #2: 2	أَكْلِ الْفَاكِهَةِ
u'أكل فَاكِهَةٌ':Added, #2: 2	أَكْلِ الْفَاكِهَةِ
u'أَكْلٌ فَاكِهَةٌ':Added, #2: 2	أَكْلُ فَاكِهَةٍ
u'أكل فَرِيكٌ':Added, #2: 2	أَكْلُ فَاكِهَةٍ
u'أَكْلٌ فَرِيكٌ':Added, #1: 1	أَكْلُ الْفَرِيكِ
u'أَكَلَ فِطْرٌ':Predicate, #1: 1	أَكْلُ الْفَرِيكِ
u'أَكَلَ فَلًا':Predicate, #1: 1	أَكَلَ الْفِطْرَ
u'أَكَلَ فُلاَنٌ':Subject, #2: 2	أَكَلَ فَلاَ
u'أكل فلان':Added, #1: 1	أَكَلَ فُلَانٌ
u'أَكْلٌ فلان':Added, #1: 1	أَكْلَ رَاغِبٍ
u'أَكَلَ فُولٌ':Predicate, #1: 1	أَكْلَ رَاغِبٍ
u'أَكَلَ فُول':Predicate, #1: 1	أَكَلَ الْفُولَ
u'أكل فِيلٌ':Added, #2: 2	أَكَلَ الْفُولِيَّةَ
u'أَكْلٌ فِيلٌ':Added, #1: 1	أَكْلَ الْفِيلِ
u'أكل قَاذُورٌ':Added, #1: 1	أَكْلَ الْفِيلِ
u'أَكْلٌ قَاذُورٌ':Added, #1: 1	أَكْلِ الْقَاذُورَاتِ
u'أكل قَاذُورَاتٌ':Added, #1: 1	أَكْلِ الْقَاذُورَاتِ
u'أَكْلٌ قَاذُورَاتٌ':Added, #1: 1	أَكْلِ الْقَاذُورَاتِ
u'أَكَلَ قَالٌ':Predicate, #1: 1	أَكْلِ الْقَاذُورَاتِ
u'أَكَلَ قِثَّاءٌ':Predicate, #2: 2	أَكَلَ قَالَ
u'أَكَلَ قَدْرٌ':Predicate, #1: 1	أَكَلَ الْقِثَّاءَ
u'أكل قَديدٌ':Added, #1: 1	أَكَلَ قَدْرَ
u'أَكْلٌ قَديدٌ':Added, #1: 1	أَكْلِ الْقَدِيدِ
u'أَكَلَ قِشْرٌ':Predicate, #1: 1	أَكْلِ الْقَدِيدِ
u'أكل قِشْرٌ':Added, #3: 3	أَكَلَ قِشْرَ
u'أَكْلٌ قِشْرٌ':Added, #1: 1	أَكْلُ الْقِشْرِ
u'أَكَلَ قِطٌّ':Subject, #1: 1	أَكْلُ الْقِشْرِ
u'أَكَلَ قَطَائِفُ':Predicate, #1: 1	أَكَلَ قِطٌّ
u'أَكَلَ قَلِيلٌ':Predicate, #1: 1	أَكَلَ الْقَطَائِفَ
u'أكل قَلِيلٌ':Added, #1: 1	أَكَلَ الْقَلِيلَ
u'أَكْلٌ قَلِيلٌ':Added, #1: 1	أَكْلُ الْقَلِيلِ
u'أكل قَلِيلٌ':Added, #1: 1	أَكْلُ الْقَلِيلِ
u'أَكْلٌ قَلِيلٌ':Added, #1: 1	أَكْلُ قَلِيلِ
u'أكل قَلِيلٌ':Added, #1: 1	أَكْلُ قَلِيلِ
u'أَكْلٌ قَلِيلٌ':Added, #1: 1	أَكْلِ قَلِيلِهِ
u'أكل قَلِيلٌ':Added, #1: 1	أَكْلِ قَلِيلِهِ
u'أَكْلٌ قَلِيلٌ':Added, #2: 2	أَكْلِ قَلِيلِ
u'أكل قُنْفُذٌ':Added, #2: 2	أَكْلِ قَلِيلِ
u'أَكْلٌ قُنْفُذٌ':Added, #1: 1	أَكْلِ الْقُنْفُذِ
u'أَكَلَ قوائم':Predicate, #1: 1	أَكْلِ الْقُنْفُذِ
u'أَكَلَ قَوَائِمُ':Predicate, #2: 2	أَكَلَ قَوَائِمَ
u'أَكَلَ قَوْمٌ':Subject, #2: 2	أَكَلَ قَوَائِمَ
u'أَكَلَ كَتِفٌ':Predicate, #1: 1	أَكَلَ الْقَوْمُ
u'أَكَلَ كَثِيرٌ':Predicate, #5: 5	أَكَلَ كَتِفَ
u'أكل كَثِيرٌ':Added, #2: 2	أَكَلَ الْكَثِيرَ
u'أَكْلٌ كَثِيرٌ':Added, #2: 2	أَكْلِ الْكَثِيرِ
u'أَكَلَ كُرَّاثٌ':Predicate, #2: 2	أَكْلِ الْكَثِيرِ
u'أكل كُرَّاثٌ':Added, #3: 3	أَكَلَ الْكُرَّاثَ
u'أَكْلٌ كُرَّاثٌ':Added, #1: 1	أَكْلِ الْكُرَّاثِ
u'أَكَلَ كَلْبٌ':Predicate, #1: 1	أَكْلِ الْكُرَّاثِ
u'أَكَلَ كَلْبٌ':Subject, #1: 1	أَكَلَ الْكَلْبَ
u'أكل كَلْبٌ':Added, #5: 5	أَكَلَ الْكَلْبُ
u'أَكْلٌ كَلْبٌ':Added, #1: 1	أَكْلُ الْكَلْبِ
u'أَكَلَ كَنْزٌ':Predicate, #1: 1	أَكْلُ الْكَلْبِ
u'أَكَلَ لبن':Predicate, #1: 1	أَكَلَ الْكَنْزَ
u'أَكَلَ لَبَنٌ':Predicate, #1: 1	أَكَلَ اللَّبَنَ
u'أَكَلَ لَحْمٌ':Predicate, #1: 1	أَكَلَ اللَّبَنَ
u'أَكَلَ لَحْمٌ':Predicate, #17: 17	أَكَلَ لَحْمَ
u'أكل لَحْمٌ':Added, #3: 3	أَكَلَ اللَّحْمَ
u'أَكْلٌ لَحْمٌ':Added, #10: 10	أَكْلِ اللَّحْمِ
u'أكل لَحْمٌ':Added, #10: 10	أَكْلِ اللَّحْمِ
u'أَكْلٌ لَحْمٌ':Added, #16: 16	أَكْلِ لَحْمِ
u'أكل لَحْمٌ':Added, #16: 16	أَكْلِ لَحْمِ
u'أكل لَحْمٌ':Added, #1: 1	أَكْلَ لَحْمٍ
u'أَكْلٌ لَحْمٌ':Added, #1: 1	أَكْلِ لَحْمٍ
u'أَكْلٌ لَحْمٌ':Added, #1: 1	أَكْلَ لَحْمٍ
u'أكل لَحْمٌ':Added, #1: 1	أَكْلِ لَحْمٍ
u'أَكْلٌ لَحْمٌ':Added, #2: 2	أَكْلُ لَحْمِهِ
u'أكل لَحْمٌ':Added, #2: 2	أَكْلُ لَحْمِهِ
u'أَكْلٌ لَحْمٌ':Added, #3: 3	أَكْلَ اللَّحْمِ
u'أكل لَحْمٌ':Added, #3: 3	أَكْلَ اللَّحْمِ
u'أَكْلٌ لَحْمٌ':Added, #4: 4	أَكْلِ لَحْمِهِ
u'أكل لَحْمٌ':Added, #4: 4	أَكْلِ لَحْمِهِ
u'أَكْلٌ لَحْمٌ':Added, #5: 5	أَكْلَ لَحْمِ
u'أكل لَحْمٌ':Added, #5: 5	أَكْلَ لَحْمِ
u'أَكْلٌ لَحْمٌ':Added, #6: 6	أَكْلُ اللَّحْمِ
u'أكل لَحْمٌ':Added, #6: 6	أَكْلُ اللَّحْمِ
u'أَكْلٌ لَحْمٌ':Added, #6: 6	أَكْلُ لَحْمِ
u'أكل لُحُومٌ':Added, #6: 6	أَكْلُ لَحْمِ
u'أَكْلٌ لُحُومٌ':Added, #1: 1	أَكْلَ اللُّحُومِ
u'أكل لُحُومٌ':Added, #1: 1	أَكْلَ اللُّحُومِ
u'أَكْلٌ لُحُومٌ':Added, #27: 27	أَكْلِ لُحُومِ
u'أكل لُحُومٌ':Added, #27: 27	أَكْلِ لُحُومِ
u'أَكْلٌ لُحُومٌ':Added, #5: 5	أَكْلُ لُحُومِ
u'أَكَلَ لِسَانٌ':Predicate, #5: 5	أَكْلُ لُحُومِ
u'أكل لِسَانٌ':Added, #2: 2	أَكَلَ اللِّسَانَ
u'أَكْلٌ لِسَانٌ':Added, #1: 1	أَكْلَ اللِّسَانِ
u'أكل لُقَمٌ':Added, #1: 1	أَكْلَ اللِّسَانِ
u'أَكْلٌ لُقَمٌ':Added, #1: 1	أَكْل لُقَمٍ
u'أكل لُقْمَةٌ':Added, #1: 1	أَكْل لُقَمٍ
u'أَكْلٌ لُقْمَةٌ':Added, #1: 1	أَكْلُ لُقْمَةٍ
u'أكل مَارٌّ':Added, #1: 1	أَكْلُ لُقْمَةٍ
u'أَكْلٌ مَارٌّ':Added, #1: 1	أَكْلَ الْمَارَّةِ
u'أكل مَارَّةٌ':Added, #1: 1	أَكْلَ الْمَارَّةِ
u'أَكْلٌ مَارَّةٌ':Added, #1: 1	أَكْلَ الْمَارَّةِ
u'أَكَلَ مَالٌ':Predicate, #1: 1	أَكْلَ الْمَارَّةِ
u'أَكَلَ مَالٌ':Predicate, #3: 3	أَكَلَ الْمَالَ
u'أكل مَالٌ':Added, #5: 5	أَكَلَ مَالَ
u'أَكْلٌ مَالٌ':Added, #16: 16	أَكْلِ مَالِ
u'أكل مَالٌ':Added, #16: 16	أَكْلِ مَالِ
u'أَكْلٌ مَالٌ':Added, #1: 1	أَكْلَ الْمَالِ
u'أكل مَالٌ':Added, #1: 1	أَكْلَ الْمَالِ
u'أكل مَالٌ':Added, #1: 1	أَكْلَ مَالٍ
u'أَكْلٌ مَالٌ':Added, #1: 1	أَكْلِ مَالٍ
u'أَكْلٌ مَالٌ':Added, #1: 1	أَكْلَ مَالٍ
u'أكل مَالٌ':Added, #1: 1	أَكْلِ مَالٍ
u'أَكْلٌ مَالٌ':Added, #2: 2	أَكْلَ مَالِ
u'أكل مَالٌ':Added, #2: 2	أَكْلَ مَالِ
u'أَكْلٌ مَالٌ':Added, #4: 4	أَكْلُ الْمَالِ
u'أكل مَالٌ':Added, #4: 4	أَكْلُ الْمَالِ
u'أَكْلٌ مَالٌ':Added, #8: 8	أَكْلُ مَالِ
u'أكل مَالٌ':Added, #8: 8	أَكْلُ مَالِ
u'أَكْلٌ مَالٌ':Added, #9: 9	أَكْلِ الْمَالِ
u'أَكَلَ مَالِكٌ':Subject, #9: 9	أَكْلِ الْمَالِ
u'أكل مُتَّخَذ':Added, #1: 1	أَكَلَ الْمَالِكُ
u'أَكْلٌ مُتَّخَذ':Added, #1: 1	أَكْلِ الْمُتَّخَذِ
u'أكل مَتْخُوم':Added, #1: 1	أَكْلِ الْمُتَّخَذِ
u'أَكْلٌ مَتْخُوم':Added, #1: 1	أَكْلَ الْمَتْخُومِ
u'أَكَلَ مَتْرُوكٌ':Predicate, #1: 1	أَكْلَ الْمَتْخُومِ
u'أَكَلَ مُحْرِمٌ':Subject, #3: 3	أَكَلَ مَتْرُوكَ
u'أكل مُحَرَّمٌ':Added, #4: 4	أَكَلَ الْمُحْرِمُ
u'أكل مُحْرِمٌ':Added, #1: 1	أَكْلِ الْمُحَرَّمِ
u'أَكْلٌ مُحَرَّمٌ':Added, #1: 1	أَكْلُ الْمُحْرِمِ
u'أَكْلٌ مُحْرِمٌ':Added, #1: 1	أَكْلِ الْمُحَرَّمِ
u'أكل مُحَرَّمٌ':Added, #1: 1	أَكْلُ الْمُحْرِمِ
u'أَكْلٌ مُحَرَّمٌ':Added, #1: 1	أَكْلِ مُحَرَّمٍ
u'أكل مُخَدِّرٌ':Added, #1: 1	أَكْلِ مُحَرَّمٍ
u'أَكْلٌ مُخَدِّرٌ':Added, #1: 1	أَكْلِ الْمُخَدِّرَاتِ
u'أَكَلَ مُرْتَهِنٌ':Subject, #1: 1	أَكْلِ الْمُخَدِّرَاتِ
u'أَكَلَ مَرَقٌ':Predicate, #3: 3	أَكَلَ الْمُرْتَهِنُ
u'أَكَلَ مَرَقٌ':Predicate, #1: 1	أَكَلَ الْمَرَقَ
u'أكل مَرَقٌ':Added, #1: 1	أَكَلَ الْمَرَقَةَ
u'أَكْلٌ مَرَقٌ':Added, #1: 1	أَكْلُ مَرَقَةٍ
u'أَكَلَ مرقة':Predicate, #1: 1	أَكْلُ مَرَقَةٍ
u'أكل مرقة':Added, #1: 1	أَكَلَ الْمَرَقَةَ
u'أَكْلٌ مرقة':Added, #1: 1	أَكْلُ مَرَقَةٍ
u'أَكَلَ مَسْرُوقٌ':Predicate, #1: 1	أَكْلُ مَرَقَةٍ
u'أكل مِسْكٌ':Added, #1: 1	أَكَلَ الْمَسْرُوقَ
u'أَكْلٌ مِسْكٌ':Added, #1: 1	أَكْلُ الْمِسْكِ
u'أكل مُسْكِرٌ':Added, #1: 1	أَكْلُ الْمِسْكِ
u'أَكْلٌ مُسْكِرٌ':Added, #1: 1	أَكْلُ الْمُسْكِرِ
u'أَكَلَ مِشْمِشٌ':Predicate, #1: 1	أَكْلُ الْمُسْكِرِ
u'أَكَلَ مَشْوِيٌّ':Predicate, #1: 1	أَكَلَ الْمِشْمِشَ
u'أكل مَشْوِيٌّ':Added, #2: 2	أَكَلَ مَشْوِيَّ
u'أَكْلٌ مَشْوِيٌّ':Added, #1: 1	أَكْلِ الْمَشْوِيِّ
u'أكل مُصَابٌ':Added, #1: 1	أَكْلِ الْمَشْوِيِّ
u'أَكْلٌ مُصَابٌ':Added, #1: 1	أَكْلُ الْمُصَابِ
u'أكل مَصَارِينُ':Added, #1: 1	أَكْلُ الْمُصَابِ
u'أَكْلٌ مَصَارِينُ':Added, #1: 1	أَكْلِ الْمَصَارِينِ
u'أكل مُضِرٌّ':Added, #1: 1	أَكْلِ الْمَصَارِينِ
u'أَكْلٌ مُضِرٌّ':Added, #1: 1	أَكْلُ الْمُضِرِّ
u'أَكَلَ مُضْطَرٌّ':Subject, #1: 1	أَكْلُ الْمُضِرِّ
u'أكل مُضْطَرٌّ':Added, #2: 2	أَكَلَ الْمُضْطَرُّ
u'أَكْلٌ مُضْطَرٌّ':Added, #1: 1	أَكْلِ الْمُضْطَرِّ
u'أكل مُضْطَرٌّ':Added, #1: 1	أَكْلِ الْمُضْطَرِّ
u'أَكْلٌ مُضْطَرٌّ':Added, #1: 1	أَكْلِ مُضْطَرٍّ
u'أَكَلَ مَطْبُوخٌ':Predicate, #1: 1	أَكْلِ مُضْطَرٍّ
u'أَكَلَ مُعَلَّمٌ':Subject, #1: 1	أَكَلَ الْمَطْبُوخَ
u'أكل مُفْطِر':Added, #1: 1	أَكَلَ الْمُعَلَّمُ
u'أَكْلٌ مُفْطِر':Added, #2: 2	أَكْلِ الْمُفْطِرِ
u'أكل مَقْطُوعٌ':Added, #2: 2	أَكْلِ الْمُفْطِرِ
u'أَكْلٌ مَقْطُوعٌ':Added, #2: 2	أَكْلُ الْمَقْطُوعِ
u'أكل مَكْرُوهٌ':Added, #2: 2	أَكْلُ الْمَقْطُوعِ
u'أَكْلٌ مَكْرُوهٌ':Added, #1: 1	أَكْلَ الْمَكْرُوهِ
u'أَكَلَ ملح':Predicate, #1: 1	أَكْلَ الْمَكْرُوهِ
u'أَكَلَ مِلْحٌ':Predicate, #3: 3	أَكَلَ الْمِلْحَ
u'أكل ملح':Added, #3: 3	أَكَلَ الْمِلْحَ
u'أَكْلٌ ملح':Added, #1: 1	أَكْلَ الْمِلْحِ
u'أكل مِلْحٌ':Added, #1: 1	أَكْلَ الْمِلْحِ
u'أَكْلٌ مِلْحٌ':Added, #1: 1	أَكْلَ الْمِلْحِ
u'أَكَلَ مِلْكٌ':Predicate, #1: 1	أَكْلَ الْمِلْحِ
u'أكل مُنْتِنٌ':Added, #2: 2	أَكَلَ مِلْكَ
u'أَكْلٌ مُنْتِنٌ':Added, #1: 1	أَكْلِ الْمُنْتِنِ
u'أَكَلَ مَيْتٌ':Predicate, #1: 1	أَكْلِ الْمُنْتِنِ
u'أكل مَيْتٌ':Added, #11: 11	أَكَلَ الْمَيْتَةَ
u'أَكْلٌ مَيْتٌ':Added, #19: 19	أَكْلَ الْمَيْتَةِ
u'أكل مَيْتٌ':Added, #19: 19	أَكْلَ الْمَيْتَةِ
u'أَكْلٌ مَيْتٌ':Added, #1: 1	أَكْلُ الْمَيْتَاتِ
u'أكل مَيْتٌ':Added, #1: 1	أَكْلُ الْمَيْتَاتِ
u'أكل مَيْتٌ':Added, #1: 1	أَكْلَ مَيْتَتِهِ
u'أَكْلٌ مَيْتٌ':Added, #1: 1	أَكْلِ مَيْتَتِهِ
u'أَكْلٌ مَيْتٌ':Added, #1: 1	أَكْلَ مَيْتَتِهِ
u'أكل مَيْتٌ':Added, #1: 1	أَكْلِ مَيْتَتِهِ
u'أَكْلٌ مَيْتٌ':Added, #26: 26	أَكْلُ الْمَيْتَةِ
u'أكل مَيْتٌ':Added, #26: 26	أَكْلُ الْمَيْتَةِ
u'أَكْلٌ مَيْتٌ':Added, #28: 28	أَكْلِ الْمَيْتَةِ
u'أَكَلَ مَيْتَةٌ':Predicate, #28: 28	أَكْلِ الْمَيْتَةِ
u'أكل مَيْتَةٌ':Added, #11: 11	أَكَلَ الْمَيْتَةَ
u'أَكْلٌ مَيْتَةٌ':Added, #19: 19	أَكْلَ الْمَيْتَةِ
u'أكل مَيْتَةٌ':Added, #19: 19	أَكْلَ الْمَيْتَةِ
u'أَكْلٌ مَيْتَةٌ':Added, #1: 1	أَكْلُ الْمَيْتَاتِ
u'أكل مَيْتَةٌ':Added, #1: 1	أَكْلُ الْمَيْتَاتِ
u'أكل مَيْتَةٌ':Added, #1: 1	أَكْلَ مَيْتَتِهِ
u'أَكْلٌ مَيْتَةٌ':Added, #1: 1	أَكْلِ مَيْتَتِهِ
u'أَكْلٌ مَيْتَةٌ':Added, #1: 1	أَكْلَ مَيْتَتِهِ
u'أكل مَيْتَةٌ':Added, #1: 1	أَكْلِ مَيْتَتِهِ
u'أَكْلٌ مَيْتَةٌ':Added, #26: 26	أَكْلُ الْمَيْتَةِ
u'أكل مَيْتَةٌ':Added, #26: 26	أَكْلُ الْمَيْتَةِ
u'أَكْلٌ مَيْتَةٌ':Added, #28: 28	أَكْلِ الْمَيْتَةِ
u'أكل مَيْتَةٌ':Added, #28: 28	أَكْلِ الْمَيْتَةِ
u'أَكْلٌ مَيْتَةٌ':Added, #3: 3	أَكْلِ مَيْتَةٍ
u'أكل مِيرَاثٌ':Added, #3: 3	أَكْلِ مَيْتَةٍ
u'أكل مِيرَاثٌ':Added, #1: 1	أَكْلُ مِيرَاثِهِ
u'أَكْلٌ مِيرَاثٌ':Added, #1: 1	أَكْلِ مِيرَاثِهِ
u'أَكْلٌ مِيرَاثٌ':Added, #1: 1	أَكْلُ مِيرَاثِهِ
u'أَكَلَ نَاسٌ':Subject, #1: 1	أَكْلِ مِيرَاثِهِ
u'أكل نَاسٌ':Added, #1: 1	أَكَلَ النَّاسُ
u'أكل نَاسٌ':Added, #1: 1	أَكْلَ النَّاسِ
u'أَكْلٌ نَاسٌ':Added, #1: 1	أَكْلِ النَّاسِ
u'أَكْلٌ نَاسٌ':Added, #1: 1	أَكْلَ النَّاسِ
u'أكل نَاظِرٌ':Added, #1: 1	أَكْلِ النَّاسِ
u'أَكْلٌ نَاظِرٌ':Added, #1: 1	أَكْلِ النَّاظِرِ
u'أكل نبات':Added, #1: 1	أَكْلِ النَّاظِرِ
u'أَكْلٌ نبات':Added, #1: 1	أَكْلَ النَّبَاتِ
u'أكل نَبَاتٌ':Added, #1: 1	أَكْلَ النَّبَاتِ
u'أَكْلٌ نَبَاتٌ':Added, #1: 1	أَكْلَ النَّبَاتِ
u'أكل نَبِيٌّ':Added, #1: 1	أَكْلَ النَّبَاتِ
u'أَكْلٌ نَبِيٌّ':Added, #2: 2	أَكْلِ النَّبِيِّ
u'أكل نَجَاسَةٌ':Added, #2: 2	أَكْلِ النَّبِيِّ
u'أَكْلٌ نَجَاسَةٌ':Added, #1: 1	أَكْلُ النَّجَاسَةِ
u'أكل نَجَاسَةٌ':Added, #1: 1	أَكْلُ النَّجَاسَةِ
u'أَكْلٌ نَجَاسَةٌ':Added, #1: 1	أَكْلُ نَجَاسَةٍ
u'أَكَلَ نَحْوٌ':Predicate, #1: 1	أَكْلُ نَجَاسَةٍ
u'أكل نَحْوٌ':Added, #3: 3	أَكَلَ نَحْوَ
u'أكل نَحْوٌ':Added, #1: 1	أَكْلُ نَحْوِ
u'أَكْلٌ نَحْوٌ':Added, #1: 1	أَكْلِ نَحْوِ
u'أَكْلٌ نَحْوٌ':Added, #1: 1	أَكْلُ نَحْوِ
u'أكل نَعَمٌ':Added, #1: 1	أَكْلِ نَحْوِ
u'أَكْلٌ نَعَمٌ':Added, #1: 1	أَكْلُ نَعَمٍ
u'أكل نَفْسٌ':Added, #1: 1	أَكْلُ نَعَمٍ
u'أَكْلٌ نَفْسٌ':Added, #2: 2	أَكْلَ نَفْسِ
u'أكل نهار':Added, #2: 2	أَكْلَ نَفْسِ
u'أَكْلٌ نهار':Added, #2: 2	أَكْلِ النَّهَارِ
u'أكل نَهَارٌ':Added, #2: 2	أَكْلِ النَّهَارِ
u'أَكْلٌ نَهَارٌ':Added, #2: 2	أَكْلِ النَّهَارِ
u'أَكَلَ هَدِيٌّ':Predicate, #2: 2	أَكْلِ النَّهَارِ
u'أكل هَدِيٌّ':Added, #1: 1	أَكَلَ هَدِيَّةً
u'أَكْلٌ هَدِيٌّ':Added, #1: 1	أَكْلُ هَدِيَّتِهِ
u'أكل هَدِيَّةٌ':Added, #1: 1	أَكْلُ هَدِيَّتِهِ
u'أَكْلٌ هَدِيَّةٌ':Added, #1: 1	أَكْلُ هَدِيَّتِهِ
u'أكل هِرٌّ':Added, #1: 1	أَكْلُ هَدِيَّتِهِ
u'أكل هِرٌّ':Added, #1: 1	أَكْلُ الْهِرِّ
u'أَكْلٌ هِرٌّ':Added, #1: 1	أَكْلِ الْهِرِّ
u'أَكْلٌ هِرٌّ':Added, #1: 1	أَكْلُ الْهِرِّ
u'أكل هِرٌّ':Added, #1: 1	أَكْلِ الْهِرِّ
u'أَكْلٌ هِرٌّ':Added, #1: 1	أَكْلِ الْهِرَّةِ
u'أكل واحد':Added, #1: 1	أَكْلِ الْهِرَّةِ
u'أَكْلٌ واحد':Added, #1: 1	أَكْلُ الْوَاحِدِ
u'أكل وَاحِدٌ':Added, #1: 1	أَكْلُ الْوَاحِدِ
u'أَكْلٌ وَاحِدٌ':Added, #1: 1	أَكْلُ الْوَاحِدِ
u'أكل واحد':Added, #1: 1	أَكْلُ الْوَاحِدِ
u'أكل واحد':Added, #1: 1	أَكْلُ وَاحِدَةٍ
u'أَكْلٌ واحد':Added, #1: 1	أَكْلِ وَاحِدَةٍ
u'أَكْلٌ واحد':Added, #1: 1	أَكْلُ وَاحِدَةٍ
u'أكل وَاحِدٌ':Added, #1: 1	أَكْلِ وَاحِدَةٍ
u'أكل وَاحِدٌ':Added, #1: 1	أَكْلُ وَاحِدَةٍ
u'أَكْلٌ وَاحِدٌ':Added, #1: 1	أَكْلِ وَاحِدَةٍ
u'أَكْلٌ وَاحِدٌ':Added, #1: 1	أَكْلُ وَاحِدَةٍ
u'أكل واحد':Added, #1: 1	أَكْلِ وَاحِدَةٍ
u'أَكْلٌ واحد':Added, #2: 2	أَكْلُ الْوَاحِدَةِ
u'أكل وَاحِدٌ':Added, #2: 2	أَكْلُ الْوَاحِدَةِ
u'أَكْلٌ وَاحِدٌ':Added, #2: 2	أَكْلُ الْوَاحِدَةِ
u'أَكَلَ وَاطِئٌ':Subject, #2: 2	أَكْلُ الْوَاحِدَةِ
u'أَكَلَ وَجَبٌ':Predicate, #1: 1	أَكَلَ وَاطِئٌ
u'أكل وَحْشِيٌّ':Added, #1: 1	أَكَلَ وَجَبَ
u'أَكْلٌ وَحْشِيٌّ':Added, #1: 1	أَكْلِ الْوَحْشِيِّ
u'أَكَلَ ورق':Predicate, #1: 1	أَكْلِ الْوَحْشِيِّ
u'أَكَلَ وَرَقٌ':Predicate, #3: 3	أَكَلَ وَرَقَ
u'أَكَلَ وَصِيٌّ':Subject, #3: 3	أَكَلَ وَرَقَ
u'أكل وَصِيٌّ':Added, #1: 1	أَكَلَ الْوَصِيُّ
u'أَكْلٌ وَصِيٌّ':Added, #1: 1	أَكْلُ الْوَصِيِّ
u'أكل ولد':Added, #1: 1	أَكْلُ الْوَصِيِّ
u'أكل ولد':Added, #1: 1	أَكْلُ الْوَلَدِ
u'أَكْلٌ ولد':Added, #1: 1	أَكْلِ الْوَلَدِ
u'أَكْلٌ ولد':Added, #1: 1	أَكْلُ الْوَلَدِ
u'أكل وَلَدٌ':Added, #1: 1	أَكْلِ الْوَلَدِ
u'أكل وَلَدٌ':Added, #1: 1	أَكْلُ الْوَلَدِ
u'أَكْلٌ وَلَدٌ':Added, #1: 1	أَكْلِ الْوَلَدِ
u'أَكْلٌ وَلَدٌ':Added, #1: 1	أَكْلُ الْوَلَدِ
u'أَكَلَ يَابِسٌ':Predicate, #1: 1	أَكْلِ الْوَلَدِ
u'أكل يَابِسٌ':Added, #1: 1	أَكَلَ الْيَابِسَ
u'أَكْلٌ يَابِسٌ':Added, #1: 1	أَكْلُ الْيَابِسِ
u'أكل يَسِيرٌ':Added, #1: 1	أَكْلُ الْيَابِسِ
u'أَكْلٌ يَسِيرٌ':Added, #1: 1	أَكْلُ الْيَسِيرِ
u'أَكَلَ يَوْمٌ':Predicate, #1: 1	أَكْلُ الْيَسِيرِ
u'أَكَلَ يَوْمٌ':Predicate, #1: 1	أَكَلَ الْيَوْمَ
u'أكل يَوْمٌ':Added, #6: 6	أَكَلَ يَوْمَ
u'أَكْلٌ يَوْمٌ':Added, #1: 1	أَكْلِ يَوْمٍ
u'إِكْمَالٌ سُورَةٌ':Added, #1: 1	أَكْلِ يَوْمٍ
u'إِكْمَالٌ صداق':Added, #1: 1	إِكْمَالِ سُورَةٍ
u'إِكْمَالٌ صَدَاقٌ':Added, #2: 2	إِكْمَالِ الصَّدَاقِ
u'إِكْمَالٌ عِدَّةٌ':Added, #2: 2	إِكْمَالِ الصَّدَاقِ
u'إِكْمَالٌ عِدَّةٌ':Added, #1: 1	إِكْمَالَ الْعِدَّةِ
u'أَكْمَلَ إقامَةٌ':Predicate, #1: 1	إِكْمَالِ الْعِدَّةِ
u'أَكْمَلَ بَقَرٌ':Predicate, #1: 1	أَكْمَلَ إقَامَةَ
u'أَكْمَلَ بَقِيَّةٌ':Predicate, #1: 1	أَكْمَلَ الْبَقَرَةَ
u'أَكْمَلَ خَمْسَةٌ':Predicate, #1: 1	أَكْمَلَ بَقِيَّةَ
u'أَكْمَلَ دِينٌ':Predicate, #1: 1	أَكْمَلَ خَمْسَةَ
u'أَكْمَلَ رَحْمَن':Subject, #2: 2	أَكْمَلَ الدِّينَ
u'أَكْمَلَ سُنَّةٌ':Predicate, #1: 1	أَكْمَلَ الرَّحْمَنُ
u'أَكْمَلَ صَلاَةٌ':Predicate, #1: 1	أَكْمَلَ السُّنَّةَ
u'أَكْمَلَ صَلاَةٌ':Predicate, #1: 1	أَكْمَلَ الصَّلَاةَ
u'أَكْمَلَ طَهَارَةٌ':Predicate, #2: 2	أَكْمَلَ صَلَاةَ
u'أَكْمَلَ طواف':Predicate, #2: 2	أَكْمَلَ الطَّهَارَةَ
u'أَكْمَلَ طَوَافٌ':Predicate, #1: 1	أَكْمَلَ الطَّوَافَ
u'أَكْمَلَ طواف':Predicate, #1: 1	أَكْمَلَ الطَّوَافَ
u'أَكْمَلَ طَوَافٌ':Predicate, #1: 1	أَكْمَلَ طَوَافَ
u'أَكْمَلَ عِدَّةٌ':Predicate, #1: 1	أَكْمَلَ طَوَافَ
u'أَكْمَلَ غَسْلٌ':Predicate, #1: 1	أَكْمَلَ الْعِدَّةَ
u'أَكْمَلَ فلان':Subject, #1: 1	أَكْمَلَ الْغَسْلَ
u'أَكْمَلَ قِرَاءةٌ':Predicate, #1: 1	أَكْمَلَ الرَّحْمَنُ
u'أَكْمَلَ لَيْلٌ':Predicate, #1: 1	أَكْمَلَ الْقِرَاءَةَ
u'أَكْمَلَ مُبْتَدَأٌ':Predicate, #1: 1	أَكْمَلَ اللَّيْلَةَ
u'أَكْمَلَ مُدَّةٌ':Predicate, #1: 1	أَكْمَلَ الْمُبْتَدَأَ
u'أَكْمَلَ وُضُوءٌ':Predicate, #1: 1	أَكْمَلَ الْمُدَّةَ
u'أَكْمَلَ وَطْءٌ':Predicate, #2: 2	أَكْمَلَ الْوُضُوءَ
u'أَلَا أحَدٌ':Subject, #1: 1	أَكْمَلَ الْوَطْءَ
u'أَلَا بَأسٌ':Predicate, #3: 3	أَلَا أَحَدٌ
u'أَلَا بَطَلٌ':Predicate, #1: 1	أَلَا بَأْسَ
u'أَلَا بَكَرٌ':Predicate, #1: 1	أَلَا بَطَلَ
u'أَلَا حَرْفٌ':Subject, #1: 1	أَلَا بَكَرَ
u'أَلَا خَالِدٌ':Subject, #1: 1	أَلَا حَرْفُ
u'أَلَا ذَهَبٌ':Predicate, #1: 1	أَلَا خَالِدٌ
u'أَلَا رَجُلٌ':Subject, #1: 1	أَلَا ذَهَبَ
u'أَلَا سَاءَ':Predicate, #5: 5	أَلَا رَجُلٌ
u'أَلَا سَبِيلٌ':Predicate, #1: 1	أَلَا سَاءَ
u'أَلَا لعنة':Subject, #1: 1	أَلَا سَبِيلَ
u'أَلَا لَعْنَةٌ':Subject, #8: 8	أَلَا لَعْنَةُ
u'آلَ أَمْرٌ':Subject, #8: 8	أَلَا لَعْنَةُ
u'آلَ أَمْرٌ':Subject, #1: 1	آلَ أَمْرُ
u'آلَ أَمْرٌ':Subject, #1: 1	آلَ أَمْرُهُ
u'أَلَا مُشَمِّر':Subject, #31: 31	آلَ الْأَمْرُ
u'أَلَانَ حطاب':Subject, #1: 1	أَلَا مُشَمِّرٌ
u'أَلَا هَلَكٌ':Predicate, #1: 1	أَلَانَ حِطَابُ
u'أَلْبَابٌ أَلْبَابٌ':Added, #1: 1	أَلَا هَلَكَ
u'أَلْبَابٌ علماء':Added, #1: 1	أَلْبَابَ الْأَلْبَابِ
u'أَلْبَابٌ عُلَمَاءُ':Added, #1: 1	أَلْبَابُ الْعُلَمَاءِ
u'إلْبَاسٌ ثَوْبٌ':Added, #1: 1	أَلْبَابُ الْعُلَمَاءِ
u'إلْبَاسٌ جَلٌّ':Added, #1: 1	إلْبَاسَ الثَّوْبِ
u'إلْبَاسٌ جلد':Added, #1: 1	إلْبَاسُ الْجَلِّ
u'إلْبَاسٌ جِلْدٌ':Added, #1: 1	إلْبَاسُ جِلْدِ
u'إلْبَاسٌ ذُكورٌ':Added, #1: 1	إلْبَاسُ جِلْدِ
u'إلْبَاسٌ ذَهَبٌ':Added, #1: 1	إلْبَاسِ الذُّكُورِ
u'إلْبَاسٌ صَبِيٌّ':Added, #1: 1	إلْبَاسُ ذَهَبٍ
u'إلْبَاسٌ صِبْيَانٌ':Added, #1: 1	إلْبَاسِ الصَّبِيِّ
u'إلْبَاسٌ غير':Added, #1: 1	إلْبَاسَ الصِّبْيَانِ
u'إلْبَاسٌ غَيْرٌ':Added, #2: 2	إلْبَاسُ غَيْرِهِ
u'آلَ بَخِيلٌ':Subject, #2: 2	إلْبَاسُ غَيْرِهِ
u'آلَ بَرْبَرٌ':Predicate, #1: 1	آلَ الْبَخِيلُ
u'أَلَبَ رَجُلٌ':Subject, #3: 3	آلَ بَرْبَرَ
u'أَلَبَّ رَجُلٌ':Subject, #1: 1	أَلَبَ الرَّجُلُ
u'أَلْبَسَ ثَوْبٌ':Predicate, #1: 1	أَلَبَّ الرَّجُلُ
u'أَلْبَسَ مُحْرِمٌ':Subject, #1: 1	أَلْبَسَ الثَّوْبَ
u'إلْجَاءٌ حِسِّيٌّ':Added, #5: 5	أَلْبَسَ الْمُحْرِمُ
u'أَلْجَأَ حاكِمٌ':Predicate, #1: 1	إلْجَاءٍ حِسِّيٍّ
u'أَلْجَأَ سَبُعٌ':Predicate, #2: 2	أَلْجَأَ الْحَاكِمَ
u'أَلْجَأَ سَمَكٌ':Predicate, #1: 1	أَلْجَأَ السَّبُعَ
u'أَلْجَأَ قَاضِي':Predicate, #1: 1	أَلْجَأَ سَمَكَةً
u'أَلْجَأَ مُبَرِّدٌ':Predicate, #2: 2	أَلْجَأَ الْقَاضِيَ
u'أَلْجَأَ وَكِيلٌ':Predicate, #1: 1	أَلْجَأَ الْمُبَرِّدَ
u'آلَ جَفْنَةٌ':Predicate, #1: 1	أَلْجَأَ الْوَكِيلَ
u'أَلْجَمَ فَاهٌ':Subject, #1: 1	آلَ جَفْنَةَ
u'إلْحَاقٌ آبارٌ':Added, #2: 2	أَلْجَمَ فَاهُ
u'إلْحَاقٌ أبْنيَةٌ':Added, #1: 1	إلْحَاقُ الْآبَارِ
u'إلْحَاقٌ إِجَابَةٌ':Added, #1: 1	إلْحَاقُ أَبْنِيَةِ
u'إلْحَاقٌ أَجَلٌ':Added, #1: 1	إلْحَاقُ إجَابَةِ
u'إلْحَاقٌ أَجَلٌ':Added, #1: 1	إلْحَاقُ أَجَلٍ
u'إلْحَاقٌ أَجَلٌ':Added, #1: 1	إلْحَاقَ الْأَجَلِ
u'إلْحَاقٌ إِحْرَامٌ':Added, #2: 2	إلْحَاقِ الْأَجَلِ
u'إلْحَاقٌ أحْمَر':Added, #1: 1	إلْحَاقُ الْإِحْرَامِ
u'إلْحَاقٌ أَخٌ':Added, #1: 1	إلْحَاقُ الْأَحْمَرِ
u'إلْحَاقٌ أَرْبَعُ':Added, #1: 1	إلْحَاقِ الْأَخِ
u'إلْحَاقٌ أَرْبَعَةٌ':Added, #1: 1	إلْحَاقِ الْأَرْبَعِ
u'إلْحَاقٌ إِزَالَةٌ':Added, #1: 1	إلْحَاقَ الْأَرْبَعَةِ
u'إلْحَاقٌ أَسْماءٌ':Added, #1: 1	إلْحَاقِ إزَالَةِ
u'إلْحَاقٌ أمَةٌ':Added, #1: 1	إلْحَاقُ الْأَسْمَاءِ
u'إلْحَاقٌ أُمَّةٌ':Added, #1: 1	إلْحَاقُ الْأَمَةِ
u'إلْحَاقٌ بِنْتٌ':Added, #1: 1	إلْحَاقِ الْأُمَّةِ
u'إلْحَاقٌ بيض':Added, #1: 1	إلْحَاقِ الْبِنْتَيْنِ
u'إلْحَاقٌ بَيْعٌ':Added, #1: 1	إلْحَاقُ الْبَيْضِ
u'إلْحَاقٌ تاء':Added, #1: 1	إلْحَاقُ الْبَيْعِ
u'إلْحَاقٌ تَابِعٌ':Added, #2: 2	إلْحَاقُ التَّاءِ
u'إلْحَاقٌ تَشَهُّدٌ':Added, #1: 1	إلْحَاقَ التَّابِعِ
u'إلْحَاقٌ تَعْلِيقٌ':Added, #1: 1	إلْحَاقُ التَّشَهُّدِ
u'إلْحَاقٌ تَكْبيرٌ':Added, #3: 3	إلْحَاقُ التَّعْلِيقِ
u'إلْحَاقٌ ثَانِي':Added, #1: 1	إلْحَاقُ التَّكْبِيرِ
u'إلْحَاقٌ ثَانِيَةٌ':Added, #1: 1	إلْحَاقِ الثَّانِيَةِ
u'إلْحَاقٌ جَارٌ':Added, #1: 1	إلْحَاقِ الثَّانِيَةِ
u'إلْحَاقٌ جَاهِلٌ':Added, #1: 1	إلْحَاقُ الْجَارِ
u'إلْحَاقٌ جَبِيرَة':Added, #1: 1	إلْحَاقِ الْجَاهِلِ
u'إلْحَاقٌ جِرَاحَةٌ':Added, #1: 1	إلْحَاقُ الْجَبِيرَةِ
u'إلْحَاقٌ جَمَاعَةٌ':Added, #1: 1	إلْحَاقُ الْجِرَاحَةِ
u'إلْحَاقٌ حَجٌّ':Added, #1: 1	إلْحَاقُ جَمَاعَةٍ
u'إلْحَاقٌ حُكْمٌ':Added, #1: 1	إلْحَاقُ الْحَجِّ
u'إلْحَاقٌ حُمْرَةٌ':Added, #1: 1	إلْحَاقِ حُكْمٍ
u'إلْحَاقٌ خَائِفٌ':Added, #1: 1	إلْحَاقُ الْحُمْرَةِ
u'إلْحَاقٌ خُلْعٌ':Added, #1: 1	إلْحَاقِ الْخَائِفِ
u'إلْحَاقٌ دِرْهَمٌ':Added, #1: 1	إلْحَاقِ الْخُلْعِ
u'إلْحَاقٌ دِرْهَم':Added, #1: 1	إلْحَاقُ الدِّرْهَمِ
u'إلْحَاقٌ دُهْنٌ':Added, #1: 1	إلْحَاقُ الدِّرْهَمِ
u'إلْحَاقٌ ذَمٌّ':Added, #1: 1	إلْحَاقُ الدُّهْنِ
u'إلْحَاقٌ رَاكِعٌ':Added, #1: 1	إلْحَاقُ الذَّمِّ
u'إلْحَاقٌ رَاهِنٌ':Added, #2: 2	إلْحَاقُ الرَّاكِعِ
u'إلْحَاقٌ رِجَالٌ':Added, #1: 1	إلْحَاقُ الرَّاهِنِ
u'إلْحَاقٌ رِجْلٌ':Added, #1: 1	إلْحَاقِ الرِّجَالِ
u'إلْحَاقٌ رضاع':Added, #1: 1	إلْحَاقَ رِجْلِ
u'إلْحَاقٌ رَطْبَةٌ':Added, #1: 1	إلْحَاقَ الرَّضَاعِ
u'إلْحَاقٌ رَمْيٌ':Added, #1: 1	إلْحَاقِ الرَّطْبَةِ
u'إلْحَاقٌ زَمَنٌ':Added, #1: 1	إلْحَاقَ الرَّمْيِ
u'إلْحَاقٌ زَوْجَةٌ':Added, #1: 1	إلْحَاقَ زَمَنِ
u'إلْحَاقٌ زَوْجَةٌ':Added, #1: 1	إلْحَاقِ الزَّوْجَاتِ
u'إلْحَاقٌ زِيادَةٌ':Added, #2: 2	إلْحَاقُ الزَّوْجَةِ
u'إلْحَاقٌ زِيادَةٌ':Added, #1: 1	إلْحَاق الزِّيَادَةِ
u'إلْحَاقٌ زِيادَةٌ':Added, #1: 1	إلْحَاقَ الزِّيَادَةِ
u'إلْحَاقٌ زِيادَةٌ':Added, #1: 1	إلْحَاقِ الزِّيَادَةِ
u'إلْحَاقٌ سَابِقٌ':Added, #5: 5	إلْحَاقُ الزِّيَادَةِ
u'إلْحَاقٌ سِتٌّ':Added, #1: 1	إلْحَاقُ السَّابِقِ
u'إلْحَاقٌ سُجُودٌ':Added, #1: 1	إلْحَاقِ السِّتَّةِ
u'إلْحَاقٌ سَفَرٌ':Added, #1: 1	إلْحَاقُ السُّجُودِ
u'إلْحَاقٌ سَفِينَةٌ':Added, #1: 1	إلْحَاقُ سَفَرِهِ
u'إلْحَاقٌ سَفِيهٌ':Added, #1: 1	إلْحَاقَ السَّفِينَةِ
u'إلْحَاقٌ شَارِبٌ':Added, #1: 1	إلْحَاقُ السَّفِيهِ
u'إلْحَاقٌ شَاهِدٌ':Added, #1: 1	إلْحَاقِ الشَّارِبِ
u'إلْحَاقٌ شَرْطٌ':Added, #1: 1	إلْحَاقَ الشَّاهِدِ
u'إلْحَاقٌ شُرُوطٌ':Added, #1: 1	إلْحَاق الشَّرْطِ
u'إلْحَاقٌ شُرُوعٌ':Added, #1: 1	إلْحَاقُ شُرُوطٍ
u'إلْحَاقٌ شَيْءٌ':Added, #1: 1	إلْحَاقِ الشُّرُوعِ
u'إلْحَاقٌ شَيْءٌ':Added, #1: 1	إلْحَاقَ الشَّيْءِ
u'إلْحَاقٌ شَيْنٌ':Added, #1: 1	إلْحَاقُ الشَّيْءِ
u'إلْحَاقٌ شَيْنٌ':Added, #1: 1	إلْحَاقُ الشَّيْنِ
u'إلْحَاقٌ صُورَةٌ':Added, #1: 1	إلْحَاقِ الشَّيْنِ
u'إلْحَاقٌ صَيْدٌ':Added, #1: 1	إلْحَاقِ صُورَةٍ
u'إلْحَاقٌ ضَرَرٌ':Added, #1: 1	إلْحَاقُ صَيْدِ
u'إلْحَاقٌ ضَرَرٌ':Added, #1: 1	إلْحَاق الضَّرَرِ
u'إلْحَاقٌ ضَرَرٌ':Added, #4: 4	إلْحَاقَ الضَّرَرِ
u'إلْحَاقٌ ضَرَرٌ':Added, #4: 4	إلْحَاقُ ضَرَرٍ
u'إلْحَاقٌ ضَرَرٌ':Added, #7: 7	إلْحَاقِ الضَّرَرِ
u'إلْحَاقٌ ضَمَانٌ':Added, #9: 9	إلْحَاقُ الضَّرَرِ
u'إلْحَاقٌ طَاعُونٌ':Added, #1: 1	إلْحَاقُ ضَمَانِ
u'إلْحَاقٌ طَائِرٌ':Added, #1: 1	إلْحَاقَ الطَّاعُونِ
u'إلْحَاقٌ طرف':Added, #1: 1	إلْحَاقَ الطَّائِرِ
u'إلْحَاقٌ طَرَفٌ':Added, #1: 1	إلْحَاقُ طَرَفِ
u'إلْحَاقٌ طَلاَقٌ':Added, #1: 1	إلْحَاقُ طَرَفِ
u'إلْحَاقٌ عَادَةٌ':Added, #2: 2	إلْحَاقِ الطَّلَاقِ
u'إلْحَاقٌ عَارٌ':Added, #1: 1	إلْحَاقِ الْعَادَةِ
u'إلْحَاقٌ عَارٌ':Added, #1: 1	إلْحَاقَ عَارٍ
u'إلْحَاقٌ عارِيَّةٌ':Added, #1: 1	إلْحَاقُ عَارٍ
u'إلْحَاقٌ عَبْدٌ':Added, #1: 1	إلْحَاقُ الْعَارِيَّةِ
u'إلْحَاقٌ عَتِيقٌ':Added, #1: 1	إلْحَاقَ الْعَبْدِ
u'إلْحَاقٌ عُرُوقٌ':Added, #1: 1	إلْحَاقُ الْعَتِيقِ
u'إلْحَاقٌ عِلَّةٌ':Added, #2: 2	إلْحَاقُ عُرُوقِهِ
u'إلْحَاقٌ عَمْدٌ':Added, #1: 1	إلْحَاقِ الْعِلَّةِ
u'إلْحَاقٌ غَمُوس':Added, #1: 1	إلْحَاقِ الْعَمْدِ
u'إلْحَاقٌ غير':Added, #1: 1	إلْحَاقُ الْغَمُوسِ
u'إلْحَاقٌ غير':Added, #1: 1	إلْحَاقَ غَيْرِ
u'إلْحَاقٌ غَيْرٌ':Added, #1: 1	إلْحَاقُ غَيْرِ
u'إلْحَاقٌ غَيْرٌ':Added, #1: 1	إلْحَاقَ غَيْرِ
u'إلْحَاقٌ غير':Added, #1: 1	إلْحَاقُ غَيْرِ
u'إلْحَاقٌ غير':Added, #1: 1	إلْحَاقُ غَيْرِهِ
u'إلْحَاقٌ غَيْرٌ':Added, #1: 1	إلْحَاقِ غَيْرِهِ
u'إلْحَاقٌ غَيْرٌ':Added, #1: 1	إلْحَاقُ غَيْرِهِ
u'إلْحَاقٌ غير':Added, #1: 1	إلْحَاقِ غَيْرِهِ
u'إلْحَاقٌ غَيْرٌ':Added, #2: 2	إلْحَاقُ الْغَيْرِ
u'إلْحَاقٌ غير':Added, #2: 2	إلْحَاقُ الْغَيْرِ
u'إلْحَاقٌ غَيْرٌ':Added, #2: 2	إلْحَاقِ غَيْرِ
u'إلْحَاقٌ غير':Added, #2: 2	إلْحَاقِ غَيْرِ
u'إلْحَاقٌ غَيْرٌ':Added, #2: 2	إلْحَاقَ غَيْرِهِ
u'إلْحَاقٌ غَيْظٌ':Added, #2: 2	إلْحَاقَ غَيْرِهِ
u'إلْحَاقٌ فاء':Added, #1: 1	إلْحَاقَ الْغَيْظِ
u'إلْحَاقٌ فَاتِحٌ':Added, #1: 1	إلْحَاقُ الْفَاءِ
u'إلْحَاقٌ فَاتِحَةٌ':Added, #1: 1	إلْحَاقَ الْفَاتِحَةِ
u'إلْحَاقٌ فرد':Added, #1: 1	إلْحَاقَ الْفَاتِحَةِ
u'إلْحَاقٌ فَرْدٌ':Added, #1: 1	إلْحَاقُ الْفَرْدِ
u'إلْحَاقٌ فَرْعٌ':Added, #1: 1	إلْحَاقُ الْفَرْدِ
u'إلْحَاقٌ فَرْعٌ':Added, #1: 1	إلْحَاقَ الْفَرْعِ
u'إلْحَاقٌ فَرْعٌ':Added, #1: 1	إلْحَاقِ الْفَرْعِ
u'إلْحَاقٌ فَرْعٌ':Added, #1: 1	إلْحَاقُ فَرْعٍ
u'إلْحَاقٌ فُرُوعٌ':Added, #4: 4	إلْحَاقُ الْفَرْعِ
u'إلْحَاقٌ فِسْقٌ':Added, #1: 1	إلْحَاقُ الْفُرُوعِ
u'إلْحَاقٌ فِعْلٌ':Added, #1: 1	إلْحَاقُ الْفِسْقِ
u'إلْحَاقٌ فَقْدٌ':Added, #1: 1	إلْحَاقِ فِعْلِهِ
u'إلْحَاقٌ قاف':Added, #1: 1	إلْحَاقُ فَقْدِ
u'إلْحَاقٌ قاف':Added, #1: 1	إلْحَاقَ الْقَافَةِ
u'إلْحَاقٌ قَائِمٌ':Added, #2: 2	إلْحَاقِ قَافَةٍ
u'إلْحَاقٌ قَلِيلٌ':Added, #2: 2	إلْحَاقُ الْقَائِمِ
u'إلْحَاقٌ قُمْرِيُّ':Added, #1: 1	إلْحَاقُ قَلِيلِهِ
u'إلْحَاقٌ قَوَّادٌ':Added, #1: 1	إلْحَاقُ الْقُمْرِيِّ
u'إلْحَاقٌ قول':Added, #2: 2	إلْحَاقُ الْقَوَّادَةِ
u'إلْحَاقٌ قَوْلٌ':Added, #1: 1	إلْحَاقُ قَوْلِ
u'إلْحَاقٌ قول':Added, #1: 1	إلْحَاقُ قَوْلِ
u'إلْحَاقٌ قول':Added, #1: 1	إلْحَاقَ قَوْلِهِ
u'إلْحَاقٌ قَوْلٌ':Added, #1: 1	إلْحَاقُ قَوْلِهِ
u'إلْحَاقٌ قَوْلٌ':Added, #1: 1	إلْحَاقَ قَوْلِهِ
u'إلْحَاقٌ كَافِرٌ':Added, #1: 1	إلْحَاقُ قَوْلِهِ
u'إلْحَاقٌ كبائر':Added, #1: 1	إلْحَاقُ الْكَافِرِ
u'إلْحَاقٌ كَبْت':Added, #1: 1	إلْحَاقِ الْكَبَائِرِ
u'إلْحَاقٌ كَلْبٌ':Added, #1: 1	إلْحَاقَ الْكَبْتِ
u'إلْحَاقٌ لِسَانٌ':Added, #1: 1	إلْحَاقُ الْكَلْبِ
u'إلْحَاقٌ لَفْظٌ':Added, #1: 1	إلْحَاقُ اللِّسَانِ
u'إلْحَاقٌ مَاءٌ':Added, #1: 1	إلْحَاقُ اللَّفْظِ
u'إلْحَاقٌ مَبْتُوت':Added, #1: 1	إلْحَاقُ الْمَاءِ
u'إلْحَاقٌ مُتْعَةٌ':Added, #1: 1	إلْحَاقُ الْمَبْتُوتَةِ
u'إلْحَاقٌ مُتَعَهِّدٌ':Added, #1: 1	إلْحَاقُ الْمُتْعَةِ
u'إلْحَاقٌ مثل':Added, #1: 1	إلْحَاقُ مُتَعَهِّدِ
u'إلْحَاقٌ مِثْلٌ':Added, #1: 1	إلْحَاقُ مِثْلِهِ
u'إلْحَاقٌ مُخْتَلَفٌ':Added, #1: 1	إلْحَاقُ مِثْلِهِ
u'إلْحَاقٌ مَدْلُولٌ':Added, #1: 1	إلْحَاقُ الْمُخْتَلَفِ
u'إلْحَاقٌ مُرْتَدٌّ':Added, #1: 1	إلْحَاقُ الْمَدْلُولِ
u'إلْحَاقٌ مَسْأَلَةٌ':Added, #1: 1	إلْحَاق الْمُرْتَدِّ
u'إلْحَاقٌ مَسَائِلُ':Added, #1: 1	إلْحَاقَ مَسْأَلَةِ
u'إلْحَاقٌ مَسْحٌ':Added, #1: 1	إلْحَاقِ الْمَسَائِلِ
u'إلْحَاقٌ مَسْكُوتٌ':Added, #1: 1	إلْحَاقَ الْمَسْحِ
u'إلْحَاقٌ مَسْكُوتٌ':Added, #1: 1	إلْحَاقَ الْمَسْكُوتِ
u'إلْحَاقٌ مَسْكُوتٌ':Added, #1: 1	إلْحَاقُ الْمَسْكُوتِ
u'إلْحَاقٌ مَسْكُوتٌ':Added, #2: 2	إلْحَاقُ مَسْكُوتٍ
u'إلْحَاقٌ مُسْلِمٌ':Added, #3: 3	إلْحَاقِ الْمَسْكُوتِ
u'إلْحَاقٌ مُضَارِبٌ':Added, #1: 1	إلْحَاقُ الْمُسْلِمِ
u'إلْحَاقٌ مَعْدُودٌ':Added, #1: 1	إلْحَاقِ الْمُضَارِبِ
u'إلْحَاقٌ مُعَلَّقٌ':Added, #2: 2	إلْحَاقُ الْمَعْدُودِ
u'إلْحَاقٌ مُعَلَّلٌ':Added, #1: 1	إلْحَاقِ الْمُعَلَّقِ
u'إلْحَاقٌ مَغْصُوب':Added, #1: 1	إلْحَاقُ الْمُعَلَّلِ
u'إلْحَاقٌ مُغَيَّرٌ':Added, #1: 1	إلْحَاقُ الْمَغْصُوبِ
u'إلْحَاقٌ مَنْعٌ':Added, #2: 2	إلْحَاقِ الْمُغَيَّرِ
u'إلْحَاقٌ مَنْقُولٌ':Added, #1: 1	إلْحَاقَ الْمَنْعِ
u'إلْحَاقٌ مَوَاتٌ':Added, #1: 1	إلْحَاقُ الْمَنْقُولِ
u'إلْحَاقٌ مَوْتٌ':Added, #2: 2	إلْحَاقُ الْمَوَاتِ
u'إلْحَاقٌ نَبِيذٌ':Added, #1: 1	إلْحَاقِ الْمَوْتِ
u'إلْحَاقٌ نَحْوٌ':Added, #1: 1	إلْحَاقُ النَّبِيذِ
u'إلْحَاقٌ نذر':Added, #1: 1	إلْحَاقِ نَحْوِ
u'إلْحَاقٌ نَذْرٌ':Added, #3: 3	إلْحَاقُ النَّذْرِ
u'إلْحَاقٌ نِساءٌ':Added, #3: 3	إلْحَاقُ النَّذْرِ
u'إلْحَاقٌ نَسَبٌ':Added, #2: 2	إلْحَاقِ النِّسَاءِ
u'إلْحَاقٌ نَسَبٌ':Added, #1: 1	إلْحَاقَ النَّسَبِ
u'إلْحَاقٌ نَسَبٌ':Added, #2: 2	إلْحَاقُ النَّسَبِ
u'إلْحَاقٌ نَظِيرٌ':Added, #3: 3	إلْحَاقِ النَّسَبِ
u'إلْحَاقٌ نَفْلٌ':Added, #1: 1	إلْحَاقِ النَّظِيرِ
u'إلْحَاقٌ نَقْصٌ':Added, #1: 1	إلْحَاقُ النَّفْلِ
u'إلْحَاقٌ نَقْصٌ':Added, #1: 1	إلْحَاقُ النَّقْصِ
u'إلْحَاقٌ نِيَّةٌ':Added, #1: 1	إلْحَاقَ نَقْصٍ
u'إلْحَاقٌ هِبَةٌ':Added, #1: 1	إلْحَاقِ النِّيَّةِ
u'إلْحَاقٌ هِبَةٌ':Added, #1: 1	إلْحَاقَ الْهِبَةِ
u'إلْحَاقٌ هِرٌّ':Added, #2: 2	إلْحَاقُ الْهِبَةِ
u'إلْحَاقٌ وَارِثٌ':Added, #1: 1	إلْحَاقُ الْهِرَّةِ
u'إلْحَاقٌ وَصْفٌ':Added, #1: 1	إلْحَاقِ الْوَارِثِ
u'إلْحَاقٌ وَصِيٌّ':Added, #1: 1	إلْحَاقِ الْوَصْفِ
u'إلْحَاقٌ وَطْءٌ':Added, #1: 1	إلْحَاقُ الْوَصِيِّ
u'إلْحَاقٌ وَعِيدٌ':Added, #1: 1	إلْحَاقُ وَطْءِ
u'إلْحَاقٌ وَقْفٌ':Added, #1: 1	إلْحَاقُ الْوَعِيدِ
u'إلْحَاقٌ وَقْفٌ':Added, #1: 1	إلْحَاقُ الْوَقْفِ
u'إلْحَاقٌ وَكِيلٌ':Added, #1: 1	إلْحَاقِ الْوَقْفِ
u'إلْحَاقٌ وَلاَءٌ':Added, #1: 1	إلْحَاقِ الْوَكِيلِ
u'إلْحَاقٌ ولد':Added, #1: 1	إلْحَاقِ الْوَلَاءِ
u'إلْحَاقٌ وَلَدٌ':Added, #1: 1	إلْحَاقَ الْوَلَدِ
u'إلْحَاقٌ وَلَدٌ':Added, #1: 1	إلْحَاقَ الْوَلَدِ
u'إلْحَاقٌ وَلَدٌ':Added, #1: 1	إلْحَاقُ وَلَدٍ
u'إلْحَاقٌ ولد':Added, #1: 1	إلْحَاقِ وَلَدٍ
u'إلْحَاقٌ وَلَدٌ':Added, #2: 2	إلْحَاقُ الْوَلَدِ
u'إلْحَاقٌ ولد':Added, #2: 2	إلْحَاقُ الْوَلَدِ
u'إلْحَاقٌ وَلَدٌ':Added, #2: 2	إلْحَاقِ وَلَدِهِ
u'إلْحَاقٌ يَسِيرٌ':Added, #2: 2	إلْحَاقِ وَلَدِهِ
u'آلَ حالٌ':Subject, #1: 1	إلْحَاقُ يَسِيرِ
u'آلَ حُبٌّ':Subject, #1: 1	آلَ الْحَالُ
u'أَلَحَّ خَصْمٌ':Subject, #1: 1	آلَ حُبُّ
u'أَلْحَفَ حَديثٌ':Predicate, #5: 5	أَلَحَّ الْخَصْمُ
u'أَلْحَقَ اِبْنٌ':Predicate, #1: 1	أَلْحَفَ الْحَدِيثَ
u'أَلْحَقَ أَجَلٌ':Predicate, #1: 1	أَلْحَقَ ابْنَ
u'أَلْحَقَ إِخْرَاجٌ':Predicate, #1: 1	أَلْحَقَ الْأَجَلَ
u'أَلْحَقَ أَصْحَابٌ':Subject, #1: 1	أَلْحَقَ إخْرَاجَ
u'أَلْحَقَ أَطْرافٌ':Predicate, #1: 1	أَلْحَقَ الْأَصْحَابُ
u'أَلْحَقَ أَطْرَافٌ':Predicate, #1: 1	أَلْحَقَ الْأَطْرَافَ
u'أَلْحَقَ إمَامٌ':Subject, #1: 1	أَلْحَقَ الْأَطْرَافَ
u'أَلْحَقَ أمَانٌ':Predicate, #1: 1	أَلْحَقَ إمَامُ
u'أَلْحَقَ أهْلٌ':Subject, #1: 1	أَلْحَقَ أَمَانَ
u'أَلْحَقَ أَوَّلُ':Predicate, #1: 1	أَلْحَقَ أَهْلُ
u'أَلْحَقَ أَوْلاَدٌ':Predicate, #2: 2	أَلْحَقَ الْأَوَّلَ
u'أَلْحَقَ بَعْضٌ':Subject, #2: 2	أَلْحَقَ أَوْلَادَ
u'أَلْحَقَ تَابِعٌ':Predicate, #2: 2	أَلْحَقَ بَعْضُ
u'أَلْحَقَ ثَانِي':Predicate, #1: 1	أَلْحَقَ التَّابِعِينَ
u'أَلْحَقَ جَبْرٌ':Predicate, #2: 2	أَلْحَقَ الثَّانِيَ
u'أَلْحَقَ جَزَاءٌ':Predicate, #1: 1	أَلْحَقَ الْجَبْرَ
u'أَلْحَقَ خُصُومَةٌ':Predicate, #1: 1	أَلْحَقَ الْجَزَاءَ
u'أَلْحَقَ خَمْسٌ':Predicate, #1: 1	أَلْحَقَ الْخُصُومَةَ
u'أَلْحَقَ دَيْنٌ':Predicate, #1: 1	أَلْحَقَ الْخَمْسَ
u'أَلْحَقَ زِيادَةٌ':Predicate, #1: 1	أَلْحَقَ الدَّيْنَ
u'أَلْحَقَ شافِعِيّ':Subject, #1: 1	أَلْحَقَ زِيَادَةَ
u'أَلْحَقَ شَرْطٌ':Predicate, #1: 1	أَلْحَقَ الشَّافِعِيُّ
u'أَلْحَقَ شَيْنٌ':Predicate, #1: 1	أَلْحَقَ الشَّرْطَ
u'أَلْحَقَ صِفَةٌ':Predicate, #7: 7	أَلْحَقَ الشَّيْنَ
u'أَلْحَقَ ضَرْبٌ':Predicate, #1: 1	أَلْحَقَ صِفَةَ
u'أَلْحَقَ طَائِفٌ':Subject, #1: 1	أَلْحَقَ ضَرْبَ
u'أَلْحَقَ ظَنٌّ':Predicate, #1: 1	أَلْحَقَ طَائِفَةٌ
u'أَلْحَقَ عَارِضٌ':Predicate, #1: 1	أَلْحَقَ الظَّنَّ
u'أَلْحَقَ عَامِدٌ':Predicate, #1: 1	أَلْحَقَ الْعَارِضَ
u'أَلْحَقَ عَبْدٌ':Predicate, #1: 1	أَلْحَقَ الْعَامِدَ
u'أَلْحَقَ علماء':Subject, #1: 1	أَلْحَقَ الْعَبْدَ
u'أَلْحَقَ عُلَمَاءُ':Subject, #1: 1	أَلْحَقَ الْعُلَمَاءُ
u'أَلْحَقَ فلان':Subject, #1: 1	أَلْحَقَ الْعُلَمَاءُ
u'أَلْحَقَ فِيلٌ':Predicate, #1: 1	أَلْحَقَ الشَّافِعِيُّ
u'أَلْحَقَ قَرْضٌ':Predicate, #1: 1	أَلْحَقَ الْفِيلَ
u'أَلْحَقَ كَسْبٌ':Predicate, #1: 1	أَلْحَقَ الْقَرْضَ
u'أَلْحَقَ مَالِكٌ':Subject, #1: 1	أَلْحَقَ الْكَسْبَ
u'أَلْحَقَ مَسَائِلُ':Predicate, #1: 1	أَلْحَقَ مَالِكٌ
u'أَلْحَقَ مُصَنِّفٌ':Subject, #1: 1	أَلْحَقَ مَسَائِلَ
u'أَلْحَقَ مُلْحَقٌ':Predicate, #7: 7	أَلْحَقَ الْمُصَنِّفُ
u'أَلْحَقَ نَبِيٌّ':Subject, #1: 1	أَلْحَقَ الْمُلْحَقَ
u'أَلْحَقَ نَوْعٌ':Predicate, #1: 1	أَلْحَقَ النَّبِيُّ
u'أَلْحَقَ هِبَةٌ':Predicate, #1: 1	أَلْحَقَ نَوْعَ
u'أَلْحَقَ واحد':Predicate, #1: 1	أَلْحَقَ الْهِبَةَ
u'أَلْحَقَ وَاحِدٌ':Predicate, #3: 3	أَلْحَقَ الْوَاحِدَ
u'أَلْحَقَ وَعِيدٌ':Predicate, #3: 3	أَلْحَقَ الْوَاحِدَ
u'آلَ زَعْمٌ':Subject, #1: 1	أَلْحَقَ الْوَعِيدَ
u'أَلْزَمَ باقِي':Predicate, #1: 1	آلَ زَعْمُهُ
u'أَلْزَمَ بُخَارِيٌّ':Predicate, #1: 1	أَلْزَمَ الْبَاقِيَ
u'أَلْزَمَ حاكِمٌ':Subject, #1: 1	أَلْزَمَ الْبُخَارِيَّ
u'أَلْزَمَ حاكِمٌ':Subject, #1: 1	أَلْزَمَ الْحَاكِمُ
u'أَلْزَمَ خلق':Predicate, #1: 1	أَلْزَمَ حَاكِمٌ
u'أَلْزَمَ خَلْقٌ':Predicate, #2: 2	أَلْزَمَ الْخَلْقَ
u'أَلْزَمَ ذِمَّةٌ':Predicate, #2: 2	أَلْزَمَ الْخَلْقَ
u'أَلْزَمَ رَسُولٌ':Subject, #1: 1	أَلْزَمَ ذِمَّةَ
u'أَلْزَمَ سَكْرَان':Predicate, #1: 1	أَلْزَمَ رَسُولُ
u'أَلْزَمَ سُلْطَانٌ':Subject, #1: 1	أَلْزَمَ السَّكْرَانَ
u'أَلْزَمَ شَيْخٌ':Subject, #1: 1	أَلْزَمَ السُّلْطَانُ
u'أَلْزَمَ صَبِيٌّ':Predicate, #1: 1	أَلْزَمَ الشَّيْخُ
u'أَلْزَمَ عَقْدٌ':Predicate, #1: 1	أَلْزَمَ الصَّبِيَّ
u'أَلْزَمَ قَائِلٌ':Predicate, #2: 2	أَلْزَمَ الْعَقْدَ
u'أَلْزَمَ كَفَّارٌ':Predicate, #1: 1	أَلْزَمَ الْقَائِلِينَ
u'أَلْزَمَ كَفَّارَةٌ':Predicate, #1: 1	أَلْزَمَ الْكَفَّارَةَ
u'أَلْزَمَ مَالِكٌ':Subject, #1: 1	أَلْزَمَ الْكَفَّارَةَ
u'أَلْزَمَ مُحَمَّدٌ':Subject, #1: 1	أَلْزَمَ مَالِكُ
u'أَلْزَمَ مُسْلِمٌ':Predicate, #1: 1	أَلْزَمَ مُحَمَّدٌ
u'أَلْزَمَ مَهْرٌ':Predicate, #1: 1	أَلْزَمَ الْمُسْلِمَ
u'أَلْزَمَ نَاسٌ':Predicate, #1: 1	أَلْزَمَ الْمَهْرَ
u'أَلْزَمَ نذر':Predicate, #1: 1	أَلْزَمَ النَّاسَ
u'أَلْزَمَ نَذْرٌ':Predicate, #1: 1	أَلْزَمَ نَذْرَ
u'أَلْزَمَ وَكِيلٌ':Predicate, #1: 1	أَلْزَمَ نَذْرَ
u'أَلْزَمَ يَقِينٌ':Predicate, #2: 2	أَلْزَمَ الْوَكِيلَ
u'آلَ صَفْوَان':Predicate, #3: 3	أَلْزَمَ الْيَقِينَ
u'إلْغَاءٌ أثَرٌ':Added, #1: 1	آلَ صَفْوَانَ
u'إلْغَاءٌ إجَازَةٌ':Added, #1: 1	إلْغَاءِ أَثَرِ
u'إلْغَاءٌ أحَدٌ':Added, #1: 1	إلْغَاءُ إجَازَةِ
u'إلْغَاءٌ أحَدٌ':Added, #1: 1	إلْغَاءُ أَحَدِ
u'إلْغَاءٌ إشارَة':Added, #1: 1	إلْغَاءِ أَحَدِ
u'إلْغَاءٌ إقْرَارٌ':Added, #1: 1	إلْغَاءَ الْإِشَارَةِ
u'إلْغَاءٌ إقْرَارٌ':Added, #1: 1	إلْغَاءِ إقْرَارِهِ
u'إلْغَاءٌ أَوَّلُ':Added, #1: 1	إلْغَاءِ الْإِقْرَارِ
u'إلْغَاءٌ أَوَّلُ':Added, #1: 1	إلْغَاءُ الْأَوَّلِ
u'إلْغَاءٌ بَعْضٌ':Added, #1: 1	إلْغَاءِ الْأَوَّلِ
u'إلْغَاءٌ تَسْمِيَة':Added, #1: 1	إلْغَاءَ الْبَعْضِ
u'إلْغَاءٌ تَسْمِيَة':Added, #1: 1	إلْغَاءِ تَسْمِيَةِ
u'إلْغَاءٌ تَصَرُّفٌ':Added, #2: 2	إلْغَاءِ التَّسْمِيَةِ
u'إلْغَاءٌ تَفْصِيلٌ':Added, #1: 1	إلْغَاءَ التَّصَرُّفِ
u'إلْغَاءٌ ثَلاثَةٌ':Added, #1: 1	إلْغَاءِ تَفْصِيلِهِ
u'إلْغَاءٌ جُزْءٌ':Added, #1: 1	إلْغَاءُ ثَلَاثَةِ
u'إلْغَاءٌ جِهَةٌ':Added, #1: 1	إلْغَاءَ الْجُزْءِ
u'إلْغَاءٌ جِهَةٌ':Added, #1: 1	إلْغَاءِ الْجِهَةِ
u'إلْغَاءٌ حُكْمٌ':Added, #1: 1	إلْغَاءُ جِهَةِ
u'إلْغَاءٌ خَبَرٌ':Added, #1: 1	إلْغَاءِ حُكْمِهِ
u'إلْغَاءٌ خَبَرٌ':Added, #1: 1	إلْغَاءَ الْخَبَرِ
u'إلْغَاءٌ خَبَر':Added, #1: 1	إلْغَاءُ الْخَبَرِ
u'إلْغَاءٌ خَبَر':Added, #1: 1	إلْغَاءَ الْخَبَرِ
u'إلْغَاءٌ خُصُوصِيٌّ':Added, #1: 1	إلْغَاءُ الْخَبَرِ
u'إلْغَاءٌ دَمٌ':Added, #1: 1	إلْغَاءُ خُصُوصِيَّاتِ
u'إلْغَاءٌ رَاجِحٌ':Added, #1: 1	إلْغَاءُ الدَّمِ
u'إلْغَاءٌ زائِدٌ':Added, #1: 1	إلْغَاءُ الرَّاجِحِ
u'إلْغَاءٌ زِيادَةٌ':Added, #1: 1	إلْغَاءِ زَائِدٍ
u'إلْغَاءٌ سَابِقٌ':Added, #1: 1	إلْغَاءُ الزِّيَادَةِ
u'إلْغَاءٌ سَائِرٌ':Added, #1: 1	إلْغَاءُ السَّابِقِ
u'إلْغَاءٌ سَائِرٌ':Added, #1: 1	إلْغَاءَ سَائِرِ
u'إلْغَاءٌ شَرْطٌ':Added, #1: 1	إلْغَاءِ سَائِرِ
u'إلْغَاءٌ شَرْطٌ':Added, #1: 1	إلْغَاءَ الشَّرْطِ
u'إلْغَاءٌ شَرْطٌ':Added, #1: 1	إلْغَاءُ الشَّرْطِ
u'إلْغَاءٌ شَرْعٌ':Added, #1: 1	إلْغَاءِ الشَّرْطِ
u'إلْغَاءٌ شَكٌّ':Added, #1: 1	إلْغَاءُ الشَّرْعِ
u'إلْغَاءٌ شَيْءٌ':Added, #1: 1	إلْغَاءُ الشَّكِّ
u'إلْغَاءٌ طَلاَقٌ':Added, #1: 1	إلْغَاء شَيْءٍ
u'إلْغَاءٌ عِبَارَةٌ':Added, #5: 5	إلْغَاءِ الطَّلَاقِ
u'إلْغَاءٌ عِبَارَةٌ':Added, #1: 1	إلْغَاءِ عِبَارَةِ
u'إلْغَاءٌ عتق':Added, #1: 1	إلْغَاءِ عِبَارَتِهِ
u'إلْغَاءٌ عِتْقٌ':Added, #1: 1	إلْغَاءُ الْعِتْقِ
u'إلْغَاءٌ عَدَدٌ':Added, #1: 1	إلْغَاءُ الْعِتْقِ
u'إلْغَاءٌ عِلَّةٌ':Added, #1: 1	إلْغَاءَ الْعَدَدِ
u'إلْغَاءٌ فَارِقٌ':Added, #1: 1	إلْغَاءُ الْعِلَّةِ
u'إلْغَاءٌ فَارِقٌ':Added, #1: 1	إلْغَاءِ الْفَارِقِ
u'إلْغَاءٌ فِعْلٌ':Added, #1: 1	إلْغَاءِ فَارِقٍ
u'إلْغَاءٌ قَاطِعٌ':Added, #4: 4	إلْغَاءِ فِعْلِ
u'إلْغَاءٌ قَصْدٌ':Added, #1: 1	إلْغَاءِ الْقَاطِعِ
u'إلْغَاءٌ قول':Added, #1: 1	إلْغَاءَ قَصْدِ
u'إلْغَاءٌ قَوْلٌ':Added, #1: 1	إلْغَاءِ قَوْلِ
u'إلْغَاءٌ قول':Added, #1: 1	إلْغَاءِ قَوْلِ
u'إلْغَاءٌ قول':Added, #3: 3	إلْغَاءُ قَوْلِهِ
u'إلْغَاءٌ قَوْلٌ':Added, #3: 3	إلْغَاءِ قَوْلِهِ
u'إلْغَاءٌ قَوْلٌ':Added, #3: 3	إلْغَاءُ قَوْلِهِ
u'إلْغَاءٌ قَيْدٌ':Added, #3: 3	إلْغَاءِ قَوْلِهِ
u'إلْغَاءٌ كَلاَمٌ':Added, #1: 1	إلْغَاءَ الْقَيْدِ
u'إلْغَاءٌ كَلاَمٌ':Added, #1: 1	إلْغَاءِ كَلَامِهِ
u'إلْغَاءٌ كَلاَمٌ':Added, #2: 2	إلْغَاءُ الْكَلَامِ
u'إلْغَاءٌ كَوْنٌ':Added, #4: 4	إلْغَاءِ الْكَلَامِ
u'إلْغَاءٌ لَفْظٌ':Added, #1: 1	إلْغَاءُ كَوْنِهِ
u'إلْغَاءٌ لَفْظٌ':Added, #1: 1	إلْغَاءَ اللَّفْظِ
u'إلْغَاءٌ لَفْظٌ':Added, #1: 1	إلْغَاءِ اللَّفْظِ
u'إلْغَاءٌ مَجْمُوعٌ':Added, #3: 3	إلْغَاءُ اللَّفْظِ
u'إلْغَاءٌ مُحَابَاةٌ':Added, #1: 1	إلْغَاءَ الْمَجْمُوعِ
u'إلْغَاءٌ مَسٌّ':Added, #1: 1	إلْغَاءُ الْمُحَابَاةِ
u'إلْغَاءٌ مُقَيَّدٌ':Added, #1: 1	إلْغَاءَ مَسِّ
u'إلْغَاءٌ مُكْثٌ':Added, #1: 1	إلْغَاءُ الْمُقَيَّدِ
u'إلْغَاءٌ مَوْصُوفٌ':Added, #1: 1	إلْغَاءُ الْمُكْثِ
u'إلْغَاءٌ نذر':Added, #1: 1	إلْغَاءِ الْمَوْصُوفِ
u'إلْغَاءٌ نَذْرٌ':Added, #1: 1	إلْغَاءَ النَّذْرِ
u'إلْغَاءٌ نِيَّةٌ':Added, #1: 1	إلْغَاءَ النَّذْرِ
u'إلْغَاءٌ نِيَّةٌ':Added, #1: 1	إلْغَاءِ النِّيَّةِ
u'إلْغَاءٌ نِيَّةٌ':Added, #1: 1	إلْغَاءُ نِيَّةِ
u'إلْغَاءٌ همزة':Added, #2: 2	إلْغَاءِ نِيَّةِ
u'إلْغَاءٌ هَمْزَةٌ':Added, #1: 1	إلْغَاءِ الْهَمْزَةِ
u'إلْغَاءٌ واحد':Added, #1: 1	إلْغَاءِ الْهَمْزَةِ
u'إلْغَاءٌ وَاحِدٌ':Added, #1: 1	إلْغَاءِ وَاحِدَةٍ
u'إلْغَاءٌ وُجُودٌ':Added, #1: 1	إلْغَاءِ وَاحِدَةٍ
u'إلْغَاءٌ وَزْنٌ':Added, #1: 1	إلْغَاءِ وُجُودِ
u'إلْغَاءٌ وسط':Added, #1: 1	إلْغَاءَ الْوَزْنِ
u'إلْغَاءٌ وَسَطٌ':Added, #1: 1	إلْغَاءِ الْوَسَطِ
u'إلْغَاءٌ وَصْفٌ':Added, #1: 1	إلْغَاءِ الْوَسَطِ
u'إلْغَاءٌ وَصْف':Added, #1: 1	إلْغَاءَ الْوَصْفِ
u'إلْغَاءٌ وَصْفٌ':Added, #1: 1	إلْغَاءِ الْوَصْفِيَّةِ
u'إلْغَاءٌ وَصْفٌ':Added, #1: 1	إلْغَاءِ وَصْفِ
u'إلْغَاءٌ وَصْفٌ':Added, #4: 4	إلْغَاءُ الْوَصْفِ
u'إلْغَاءٌ وَصْفَة':Added, #6: 6	إلْغَاءِ الْوَصْفِ
u'إلْغَاءٌ وَصْفِيّ':Added, #1: 1	إلْغَاءِ الْوَصْفِيَّةِ
u'إلْغَاءٌ وَصْفِيَّة':Added, #1: 1	إلْغَاءِ الْوَصْفِيَّةِ
u'إلْغَاءٌ وَقْفٌ':Added, #1: 1	إلْغَاءِ الْوَصْفِيَّةِ
u'إلْغَاءٌ يَوْمٌ':Added, #1: 1	إلْغَاءُ الْوَقْفِ
u'أَلْغَى اِبْنٌ':Subject, #2: 2	إلْغَاءُ الْيَوْمِ
u'أَلْغَى إشارَة':Predicate, #2: 2	أَلْغَى ابْنُ
u'أَلْغَى تَعَلُّقٌ':Predicate, #1: 1	أَلْغَى الْإِشَارَةَ
u'أَلْغَى ذكر':Predicate, #1: 1	أَلْغَى تَعَلُّقَ
u'أَلْغَى ذِكْرٌ':Predicate, #1: 1	أَلْغَى ذِكْرَ
u'أَلْغَى شَارِعٌ':Subject, #1: 1	أَلْغَى ذِكْرَ
u'أَلْغَى شافِعِيّ':Subject, #2: 2	أَلْغَى الشَّارِعُ
u'أَلْغَى شَرْعٌ':Subject, #2: 2	أَلْغَى الشَّافِعِيُّ
u'أَلْغَى صَاحِبٌ':Predicate, #1: 1	أَلْغَى الشَّرْعُ
u'أَلْغَى فلان':Subject, #1: 1	أَلْغَى صَاحِبَ
u'أَلْغَى كَسْرٌ':Predicate, #2: 2	أَلْغَى الشَّافِعِيُّ
u'أَلْغَى لَفْظٌ':Predicate, #1: 1	أَلْغَى الْكَسْرَ
u'أَلْغَى نَظَرٌ':Predicate, #1: 1	أَلْغَى لَفْظَ
u'أَلْغَى وَصْفٌ':Predicate, #1: 1	أَلْغَى النَّظَرَ
u'ألف اِبْنٌ':Added, #2: 2	أَلْغَى وَصْفَ
u'ألْفٌ اِبْنٌ':Added, #1: 1	أَلْفِ ابْنِ
u'أَلْفٌ اِبْنٌ':Added, #1: 1	أَلْفِ ابْنِ
u'ألف أَتِيٌّ':Added, #1: 1	أَلْفِ ابْنِ
u'ألْفٌ أَتِيٌّ':Added, #1: 1	أَلْفَ أَتِيَّةٍ
u'أَلْفٌ أَتِيٌّ':Added, #1: 1	أَلْفَ أَتِيَّةٍ
u'ألف آجُرَّة':Added, #1: 1	أَلْفَ أَتِيَّةٍ
u'ألْفٌ آجُرَّة':Added, #1: 1	أَلْفَ آجُرَّةٍ
u'ألْفٌ آجُرَّة':Added, #1: 1	أَلْفٍ آجُرَّةٍ
u'أَلْفٌ آجُرَّة':Added, #1: 1	أَلْفَ آجُرَّةٍ
u'أَلْفٌ آجُرَّة':Added, #1: 1	أَلْفٍ آجُرَّةٍ
u'ألف اِسْتِرْواح':Added, #1: 1	أَلْفَ آجُرَّةٍ
u'ألْفٌ اِسْتِرْواح':Added, #1: 1	أَلْفِ اسْتِرْوَاحٍ
u'أَلْفٌ اِسْتِرْواح':Added, #1: 1	أَلْفِ اسْتِرْوَاحٍ
u'ألف اِسْمٌ':Added, #1: 1	أَلْفِ اسْتِرْوَاحٍ
u'ألْفٌ اِسْمٌ':Added, #3: 3	أَلْفُ اسْمٍ
u'أَلْفٌ اِسْمٌ':Added, #3: 3	أَلْفُ اسْمٍ
u'ألف إصابَةٌ':Added, #3: 3	أَلْفُ اسْمٍ
u'ألْفٌ إصابَةٌ':Added, #1: 1	أَلْفِ إصَابَةٍ
u'أَلْفٌ إصابَةٌ':Added, #1: 1	أَلْفِ إصَابَةٍ
u'ألف اِعْتِراضٌ':Added, #1: 1	أَلْفِ إصَابَةٍ
u'ألْفٌ اِعْتِراضٌ':Added, #1: 1	أَلْفِ اعْتِرَاضَاتٍ
u'أَلْفٌ اِعْتِراضٌ':Added, #1: 1	أَلْفِ اعْتِرَاضَاتٍ
u'أَلِفَ أكْبَرُ':Predicate, #1: 1	أَلْفِ اعْتِرَاضَاتٍ
u'أَلِفَ أكْبَرُ':Subject, #2: 2	أَلِفَ أَكْبَرَ
u'ألف ألْفٌ':Added, #1: 1	أَلِفَ أَكْبَرُ
u'ألف أَلْفٌ':Added, #15: 15	أَلْفِ أَلْفٍ
u'ألْفٌ ألْفٌ':Added, #15: 15	أَلْفِ أَلْفٍ
u'ألْفٌ أَلْفٌ':Added, #15: 15	أَلْفِ أَلْفٍ
u'أَلْفٌ ألْفٌ':Added, #15: 15	أَلْفِ أَلْفٍ
u'أَلْفٌ أَلْفٌ':Added, #15: 15	أَلْفِ أَلْفٍ
u'ألف ألْفٌ':Added, #15: 15	أَلْفِ أَلْفٍ
u'ألف أَلْفٌ':Added, #17: 17	أَلْفَ أَلْفٍ
u'ألْفٌ ألْفٌ':Added, #17: 17	أَلْفَ أَلْفٍ
u'ألْفٌ أَلْفٌ':Added, #17: 17	أَلْفَ أَلْفٍ
u'أَلْفٌ ألْفٌ':Added, #17: 17	أَلْفَ أَلْفٍ
u'أَلْفٌ أَلْفٌ':Added, #17: 17	أَلْفَ أَلْفٍ
u'ألف ألف':Added, #17: 17	أَلْفَ أَلْفٍ
u'ألف ألْفٌ':Added, #24: 24	أَلْفَ أَلْفِ
u'ألف أَلْفٌ':Added, #24: 24	أَلْفَ أَلْفِ
u'ألْفٌ ألف':Added, #24: 24	أَلْفَ أَلْفِ
u'ألْفٌ ألْفٌ':Added, #24: 24	أَلْفَ أَلْفِ
u'ألْفٌ أَلْفٌ':Added, #24: 24	أَلْفَ أَلْفِ
u'أَلْفٌ ألف':Added, #24: 24	أَلْفَ أَلْفِ
u'أَلْفٌ ألْفٌ':Added, #24: 24	أَلْفَ أَلْفِ
u'أَلْفٌ أَلْفٌ':Added, #24: 24	أَلْفَ أَلْفِ
u'ألف ألْفٌ':Added, #24: 24	أَلْفَ أَلْفِ
u'ألف أَلْفٌ':Added, #5: 5	أَلْفُ أَلْفٍ
u'ألْفٌ ألْفٌ':Added, #5: 5	أَلْفُ أَلْفٍ
u'ألْفٌ أَلْفٌ':Added, #5: 5	أَلْفُ أَلْفٍ
u'أَلْفٌ ألْفٌ':Added, #5: 5	أَلْفُ أَلْفٍ
u'أَلْفٌ أَلْفٌ':Added, #5: 5	أَلْفُ أَلْفٍ
u'ألف ألف':Added, #5: 5	أَلْفُ أَلْفٍ
u'ألف ألْفٌ':Added, #7: 7	أَلْفِ أَلْفِ
u'ألف أَلْفٌ':Added, #7: 7	أَلْفِ أَلْفِ
u'ألْفٌ ألف':Added, #7: 7	أَلْفِ أَلْفِ
u'ألْفٌ ألْفٌ':Added, #7: 7	أَلْفِ أَلْفِ
u'ألْفٌ أَلْفٌ':Added, #7: 7	أَلْفِ أَلْفِ
u'أَلْفٌ ألف':Added, #7: 7	أَلْفِ أَلْفِ
u'أَلْفٌ ألْفٌ':Added, #7: 7	أَلْفِ أَلْفِ
u'أَلْفٌ أَلْفٌ':Added, #7: 7	أَلْفِ أَلْفِ
u'ألف أَمْرٌ':Added, #7: 7	أَلْفِ أَلْفِ
u'ألْفٌ أَمْرٌ':Added, #1: 1	أَلْفُ أَمْرٍ
u'أَلْفٌ أَمْرٌ':Added, #1: 1	أَلْفُ أَمْرٍ
u'ألف اِمْرَأَةٌ':Added, #1: 1	أَلْفُ أَمْرٍ
u'ألف اِمْرَأَةٌ':Added, #1: 1	أَلْفَ امْرَأَةٍ
u'ألْفٌ اِمْرَأَةٌ':Added, #1: 1	أَلْفُ امْرَأَةٍ
u'ألْفٌ اِمْرَأَةٌ':Added, #1: 1	أَلْفَ امْرَأَةٍ
u'أَلْفٌ اِمْرَأَةٌ':Added, #1: 1	أَلْفُ امْرَأَةٍ
u'أَلْفٌ اِمْرَأَةٌ':Added, #1: 1	أَلْفَ امْرَأَةٍ
u'ألف إِناءٌ':Added, #1: 1	أَلْفُ امْرَأَةٍ
u'ألْفٌ إِناءٌ':Added, #1: 1	أَلْفُ إنَاءٍ
u'أَلْفٌ إِناءٌ':Added, #1: 1	أَلْفُ إنَاءٍ
u'ألف أهْلٌ':Added, #1: 1	أَلْفُ إنَاءٍ
u'ألْفٌ أهْلٌ':Added, #1: 1	أَلْفَ أَهْلِ
u'أَلْفٌ أهْلٌ':Added, #1: 1	أَلْفَ أَهْلِ
u'ألف آيَةٌ':Added, #1: 1	أَلْفَ أَهْلِ
u'ألف آيَةٌ':Added, #1: 1	أَلْفَ آيَةٍ
u'ألْفٌ آيَةٌ':Added, #1: 1	أَلْفُ آيَةٍ
u'ألْفٌ آيَةٌ':Added, #1: 1	أَلْفَ آيَةٍ
u'أَلْفٌ آيَةٌ':Added, #1: 1	أَلْفُ آيَةٍ
u'أَلْفٌ آيَةٌ':Added, #1: 1	أَلْفَ آيَةٍ
u'ألف آيَةٌ':Added, #1: 1	أَلْفُ آيَةٍ
u'ألْفٌ آيَةٌ':Added, #2: 2	أَلْفِ آيَةٍ
u'أَلْفٌ آيَةٌ':Added, #2: 2	أَلْفِ آيَةٍ
u'ألف بَاعٌ':Added, #2: 2	أَلْفِ آيَةٍ
u'ألْفٌ بَاعٌ':Added, #3: 3	أَلْفُ بَاعٍ
u'أَلْفٌ بَاعٌ':Added, #3: 3	أَلْفُ بَاعٍ
u'ألف بُدّ':Added, #3: 3	أَلْفُ بَاعٍ
u'ألْفٌ بُدّ':Added, #3: 3	أَلْفُ بُدٍّ
u'أَلْفٌ بُدّ':Added, #3: 3	أَلْفُ بُدٍّ
u'ألف بِئْرٌ':Added, #3: 3	أَلْفُ بُدٍّ
u'ألْفٌ بِئْرٌ':Added, #1: 1	أَلْفَ بِئْرٍ
u'أَلْفٌ بِئْرٌ':Added, #1: 1	أَلْفَ بِئْرٍ
u'ألف بَيْتٌ':Added, #1: 1	أَلْفَ بِئْرٍ
u'ألْفٌ بَيْتٌ':Added, #3: 3	أَلْفَ بَيْتٍ
u'أَلْفٌ بَيْتٌ':Added, #3: 3	أَلْفَ بَيْتٍ
u'ألْفٌ بيض':Added, #3: 3	أَلْفَ بَيْتٍ
u'أَلْفٌ بيض':Added, #2: 2	أَلْفٍ بِيضٍ
u'ألف بَيْضَةٌ':Added, #2: 2	أَلْفٍ بِيضٍ
u'ألْفٌ بَيْضَةٌ':Added, #1: 1	أَلْفَ بَيْضَةٍ
u'أَلْفٌ بَيْضَةٌ':Added, #1: 1	أَلْفَ بَيْضَةٍ
u'ألف تَسْبِيحَةٌ':Added, #1: 1	أَلْفَ بَيْضَةٍ
u'ألْفٌ تَسْبِيحَةٌ':Added, #1: 1	أَلْفِ تَسْبِيحَةٍ
u'أَلْفٌ تَسْبِيحَةٌ':Added, #1: 1	أَلْفِ تَسْبِيحَةٍ
u'ألف ثُعْبَانٌ':Added, #1: 1	أَلْفِ تَسْبِيحَةٍ
u'ألْفٌ ثُعْبَانٌ':Added, #1: 1	أَلْفَ ثُعْبَانٍ
u'أَلْفٌ ثُعْبَانٌ':Added, #1: 1	أَلْفَ ثُعْبَانٍ
u'ألف ثَوْبٌ':Added, #1: 1	أَلْفَ ثُعْبَانٍ
u'ألْفٌ ثَوْبٌ':Added, #1: 1	أَلْفِ ثَوْبٍ
u'أَلْفٌ ثَوْبٌ':Added, #1: 1	أَلْفِ ثَوْبٍ
u'ألف جَرِيب':Added, #1: 1	أَلْفِ ثَوْبٍ
u'ألْفٌ جَرِيب':Added, #10: 10	أَلْفِ جَرِيبٍ
u'أَلْفٌ جَرِيب':Added, #10: 10	أَلْفِ جَرِيبٍ
u'ألف جَرِيب':Added, #10: 10	أَلْفِ جَرِيبٍ
u'ألْفٌ جَرِيب':Added, #5: 5	أَلْفَ جَرِيبٍ
u'أَلْفٌ جَرِيب':Added, #5: 5	أَلْفَ جَرِيبٍ
u'ألف جُزْءٌ':Added, #5: 5	أَلْفَ جَرِيبٍ
u'ألْفٌ جُزْءٌ':Added, #1: 1	أَلْفَ جُزْءٍ
u'أَلْفٌ جُزْءٌ':Added, #1: 1	أَلْفَ جُزْءٍ
u'ألف جُزْءٌ':Added, #1: 1	أَلْفَ جُزْءٍ
u'ألْفٌ جُزْءٌ':Added, #4: 4	أَلْفِ جُزْءٍ
u'أَلْفٌ جُزْءٌ':Added, #4: 4	أَلْفِ جُزْءٍ
u'ألف جمع':Added, #4: 4	أَلْفِ جُزْءٍ
u'ألْفٌ جمع':Added, #1: 1	أَلْفُ الْجَمْعِ
u'أَلْفٌ جمع':Added, #1: 1	أَلْفُ الْجَمْعِ
u'ألف جَمْعٌ':Added, #1: 1	أَلْفُ الْجَمْعِ
u'ألْفٌ جَمْعٌ':Added, #1: 1	أَلْفُ الْجَمْعِ
u'أَلْفٌ جَمْعٌ':Added, #1: 1	أَلْفُ الْجَمْعِ
u'ألف جَوْزٌ':Added, #1: 1	أَلْفُ الْجَمْعِ
u'ألْفٌ جَوْزٌ':Added, #2: 2	أَلْفَ جَوْزَةٍ
u'أَلْفٌ جَوْزٌ':Added, #2: 2	أَلْفَ جَوْزَةٍ
u'ألْفٌ جِيَادٌ':Added, #2: 2	أَلْفَ جَوْزَةٍ
u'أَلْفٌ جِيَادٌ':Added, #1: 1	أَلْفٍ جِيَادٍ
u'ألف حازِمٌ':Added, #1: 1	أَلْفٍ جِيَادٍ
u'ألف حازِمٌ':Added, #1: 1	أَلْفَ حَازِمٍ
u'ألْفٌ حازِمٌ':Added, #1: 1	أَلْفُ حَازِمٍ
u'ألْفٌ حازِمٌ':Added, #1: 1	أَلْفَ حَازِمٍ
u'أَلْفٌ حازِمٌ':Added, #1: 1	أَلْفُ حَازِمٍ
u'أَلْفٌ حازِمٌ':Added, #1: 1	أَلْفَ حَازِمٍ
u'ألف حَجَرٌ':Added, #1: 1	أَلْفُ حَازِمٍ
u'ألْفٌ حَجَرٌ':Added, #1: 1	أَلْفَ حَجَرٍ
u'أَلْفٌ حَجَرٌ':Added, #1: 1	أَلْفَ حَجَرٍ
u'ألف حَديثٌ':Added, #1: 1	أَلْفَ حَجَرٍ
u'ألف حَديثٌ':Added, #3: 3	أَلْفَ حَدِيثٍ
u'ألْفٌ حَديثٌ':Added, #3: 3	أَلْفِ حَدِيثٍ
u'ألْفٌ حَديثٌ':Added, #3: 3	أَلْفَ حَدِيثٍ
u'أَلْفٌ حَديثٌ':Added, #3: 3	أَلْفِ حَدِيثٍ
u'أَلْفٌ حَديثٌ':Added, #3: 3	أَلْفَ حَدِيثٍ
u'ألف حَسَنٌ':Added, #3: 3	أَلْفِ حَدِيثٍ
u'ألْفٌ حَسَنٌ':Added, #10: 10	أَلْفِ حَسَنَةٍ
u'أَلْفٌ حَسَنٌ':Added, #10: 10	أَلْفِ حَسَنَةٍ
u'ألف حَسَنٌ':Added, #10: 10	أَلْفِ حَسَنَةٍ
u'ألْفٌ حَسَنٌ':Added, #1: 1	أَلْفُ حَسَنَةٍ
u'أَلْفٌ حَسَنٌ':Added, #1: 1	أَلْفُ حَسَنَةٍ
u'ألف حَسَنٌ':Added, #1: 1	أَلْفُ حَسَنَةٍ
u'ألْفٌ حَسَنٌ':Added, #4: 4	أَلْفَ حَسَنَةٍ
u'أَلْفٌ حَسَنٌ':Added, #4: 4	أَلْفَ حَسَنَةٍ
u'ألف حَسَنَةٌ':Added, #4: 4	أَلْفَ حَسَنَةٍ
u'ألْفٌ حَسَنَةٌ':Added, #10: 10	أَلْفِ حَسَنَةٍ
u'أَلْفٌ حَسَنَةٌ':Added, #10: 10	أَلْفِ حَسَنَةٍ
u'ألف حَسَنَةٌ':Added, #10: 10	أَلْفِ حَسَنَةٍ
u'ألْفٌ حَسَنَةٌ':Added, #1: 1	أَلْفُ حَسَنَةٍ
u'أَلْفٌ حَسَنَةٌ':Added, #1: 1	أَلْفُ حَسَنَةٍ
u'ألف حَسَنَةٌ':Added, #1: 1	أَلْفُ حَسَنَةٍ
u'ألْفٌ حَسَنَةٌ':Added, #4: 4	أَلْفَ حَسَنَةٍ
u'أَلْفٌ حَسَنَةٌ':Added, #4: 4	أَلْفَ حَسَنَةٍ
u'ألف حِنْطَةٌ':Added, #4: 4	أَلْفَ حَسَنَةٍ
u'ألْفٌ حِنْطَةٌ':Added, #1: 1	أَلْفُ حِنْطَةٍ
u'أَلْفٌ حِنْطَةٌ':Added, #1: 1	أَلْفُ حِنْطَةٍ
u'ألف خَادِمٌ':Added, #1: 1	أَلْفُ حِنْطَةٍ
u'ألْفٌ خَادِمٌ':Added, #5: 5	أَلْفَ خَادِمٍ
u'أَلْفٌ خَادِمٌ':Added, #5: 5	أَلْفَ خَادِمٍ
u'ألف خَتْم':Added, #5: 5	أَلْفَ خَادِمٍ
u'ألْفٌ خَتْم':Added, #2: 2	أَلْفَ خَتْمَةٍ
u'أَلْفٌ خَتْم':Added, #2: 2	أَلْفَ خَتْمَةٍ
u'ألف خُطْوَةٌ':Added, #2: 2	أَلْفَ خَتْمَةٍ
u'ألْفٌ خُطْوَةٌ':Added, #2: 2	أَلْفُ خُطْوَةٍ
u'أَلْفٌ خُطْوَةٌ':Added, #2: 2	أَلْفُ خُطْوَةٍ
u'ألف خُطْوَةٌ':Added, #2: 2	أَلْفُ خُطْوَةٍ
u'ألْفٌ خُطْوَةٌ':Added, #3: 3	أَلْفَ خُطْوَةٍ
u'أَلْفٌ خُطْوَةٌ':Added, #3: 3	أَلْفَ خُطْوَةٍ
u'ألف خَطِيئَةٌ':Added, #3: 3	أَلْفَ خُطْوَةٍ
u'ألْفٌ خَطِيئَةٌ':Added, #1: 1	أَلْفُ خَطِيئَةٍ
u'أَلْفٌ خَطِيئَةٌ':Added, #1: 1	أَلْفُ خَطِيئَةٍ
u'ألف خِنْزِيرٌ':Added, #1: 1	أَلْفُ خَطِيئَةٍ
u'ألْفٌ خِنْزِيرٌ':Added, #1: 1	أَلْفِ خِنْزِيرٍ
u'أَلْفٌ خِنْزِيرٌ':Added, #1: 1	أَلْفِ خِنْزِيرٍ
u'ألف خَيْرٌ':Added, #1: 1	أَلْفِ خِنْزِيرٍ
u'ألْفٌ خَيْرٌ':Added, #1: 1	أَلْفَ خَيْرٍ
u'أَلْفٌ خَيْرٌ':Added, #1: 1	أَلْفَ خَيْرٍ
u'ألف دَارٌ':Added, #1: 1	أَلْفَ خَيْرٍ
u'ألْفٌ دَارٌ':Added, #2: 2	أَلْفَ دَارٍ
u'أَلْفٌ دَارٌ':Added, #2: 2	أَلْفَ دَارٍ
u'ألف درجة':Added, #2: 2	أَلْفَ دَارٍ
u'ألْفٌ درجة':Added, #1: 1	أَلْفُ دَرَجَةٍ
u'أَلْفٌ درجة':Added, #1: 1	أَلْفُ دَرَجَةٍ
u'ألف دَرَجَةٌ':Added, #1: 1	أَلْفُ دَرَجَةٍ
u'ألْفٌ دَرَجَةٌ':Added, #1: 1	أَلْفُ دَرَجَةٍ
u'أَلْفٌ دَرَجَةٌ':Added, #1: 1	أَلْفُ دَرَجَةٍ
u'ألف دِرْهَمٌ':Added, #1: 1	أَلْفُ دَرَجَةٍ
u'ألف دِرْهَمٌ':Added, #1: 1	أَلْفَ دِرْهَمِ
u'ألف دِرْهَم':Added, #1: 1	أَلْفُ دِرْهَمِ
u'ألف دِرْهَم':Added, #1: 1	أَلْفَ دِرْهَمِ
u'ألْفٌ دِرْهَمٌ':Added, #1: 1	أَلْفُ دِرْهَمِ
u'ألْفٌ دِرْهَمٌ':Added, #1: 1	أَلْفٍ دِرْهَمٍ
u'ألْفٌ دِرْهَمٌ':Added, #1: 1	أَلْفَ دِرْهَمِ
u'ألْفٌ دِرْهَم':Added, #1: 1	أَلْفُ دِرْهَمِ
u'ألْفٌ دِرْهَم':Added, #1: 1	أَلْفٍ دِرْهَمٍ
u'ألْفٌ دِرْهَم':Added, #1: 1	أَلْفَ دِرْهَمِ
u'أَلْفٌ دِرْهَمٌ':Added, #1: 1	أَلْفُ دِرْهَمِ
u'أَلْفٌ دِرْهَمٌ':Added, #1: 1	أَلْفٍ دِرْهَمٍ
u'أَلْفٌ دِرْهَمٌ':Added, #1: 1	أَلْفَ دِرْهَمِ
u'أَلْفٌ دِرْهَم':Added, #1: 1	أَلْفُ دِرْهَمِ
u'أَلْفٌ دِرْهَم':Added, #1: 1	أَلْفٍ دِرْهَمٍ
u'أَلْفٌ دِرْهَم':Added, #1: 1	أَلْفَ دِرْهَمِ
u'ألف دِرْهَمٌ':Added, #1: 1	أَلْفُ دِرْهَمِ
u'ألف دِرْهَم':Added, #2: 2	أَلْف دِرْهَمٍ
u'ألْفٌ دِرْهَمٌ':Added, #2: 2	أَلْف دِرْهَمٍ
u'ألْفٌ دِرْهَم':Added, #2: 2	أَلْف دِرْهَمٍ
u'أَلْفٌ دِرْهَمٌ':Added, #2: 2	أَلْف دِرْهَمٍ
u'أَلْفٌ دِرْهَم':Added, #2: 2	أَلْف دِرْهَمٍ
u'ألف دِرْهَمٌ':Added, #2: 2	أَلْف دِرْهَمٍ
u'ألف دِرْهَم':Added, #467: 467	أَلْفِ دِرْهَمٍ
u'ألْفٌ دِرْهَمٌ':Added, #467: 467	أَلْفِ دِرْهَمٍ
u'ألْفٌ دِرْهَم':Added, #467: 467	أَلْفِ دِرْهَمٍ
u'أَلْفٌ دِرْهَمٌ':Added, #467: 467	أَلْفِ دِرْهَمٍ
u'أَلْفٌ دِرْهَم':Added, #467: 467	أَلْفِ دِرْهَمٍ
u'ألف دِرْهَمٌ':Added, #467: 467	أَلْفِ دِرْهَمٍ
u'ألف دِرْهَم':Added, #753: 753	أَلْفَ دِرْهَمٍ
u'ألْفٌ دِرْهَمٌ':Added, #753: 753	أَلْفَ دِرْهَمٍ
u'ألْفٌ دِرْهَم':Added, #753: 753	أَلْفَ دِرْهَمٍ
u'أَلْفٌ دِرْهَمٌ':Added, #753: 753	أَلْفَ دِرْهَمٍ
u'أَلْفٌ دِرْهَم':Added, #753: 753	أَلْفَ دِرْهَمٍ
u'ألف دِرْهَمٌ':Added, #753: 753	أَلْفَ دِرْهَمٍ
u'ألف دِرْهَم':Added, #764: 764	أَلْفُ دِرْهَمٍ
u'ألْفٌ دِرْهَمٌ':Added, #764: 764	أَلْفُ دِرْهَمٍ
u'ألْفٌ دِرْهَم':Added, #764: 764	أَلْفُ دِرْهَمٍ
u'أَلْفٌ دِرْهَمٌ':Added, #764: 764	أَلْفُ دِرْهَمٍ
u'أَلْفٌ دِرْهَم':Added, #764: 764	أَلْفُ دِرْهَمٍ
u'ألف دِينارٌ':Added, #764: 764	أَلْفُ دِرْهَمٍ
u'ألْفٌ دِينارٌ':Added, #18: 18	أَلْفِ دِينَارٍ
u'أَلْفٌ دِينارٌ':Added, #18: 18	أَلْفِ دِينَارٍ
u'ألف دِينارٌ':Added, #18: 18	أَلْفِ دِينَارٍ
u'ألْفٌ دِينارٌ':Added, #32: 32	أَلْفُ دِينَارٍ
u'أَلْفٌ دِينارٌ':Added, #32: 32	أَلْفُ دِينَارٍ
u'ألف دِينارٌ':Added, #32: 32	أَلْفُ دِينَارٍ
u'ألْفٌ دِينارٌ':Added, #54: 54	أَلْفَ دِينَارٍ
u'أَلْفٌ دِينارٌ':Added, #54: 54	أَلْفَ دِينَارٍ
u'ألف ذِراعٌ':Added, #54: 54	أَلْفَ دِينَارٍ
u'ألْفٌ ذِراعٌ':Added, #4: 4	أَلْفِ ذِرَاعٍ
u'أَلْفٌ ذِراعٌ':Added, #4: 4	أَلْفِ ذِرَاعٍ
u'ألف ذِراعٌ':Added, #4: 4	أَلْفِ ذِرَاعٍ
u'ألْفٌ ذِراعٌ':Added, #5: 5	أَلْفُ ذِرَاعٍ
u'أَلْفٌ ذِراعٌ':Added, #5: 5	أَلْفُ ذِرَاعٍ
u'ألف ذِراعٌ':Added, #5: 5	أَلْفُ ذِرَاعٍ
u'ألْفٌ ذِراعٌ':Added, #7: 7	أَلْفَ ذِرَاعٍ
u'أَلْفٌ ذِراعٌ':Added, #7: 7	أَلْفَ ذِرَاعٍ
u'ألف ذُؤابَةٌ':Added, #7: 7	أَلْفَ ذِرَاعٍ
u'ألْفٌ ذُؤابَةٌ':Added, #1: 1	أَلْفَ ذُؤَابَةٍ
u'أَلْفٌ ذُؤابَةٌ':Added, #1: 1	أَلْفَ ذُؤَابَةٍ
u'ألف رَأْسٌ':Added, #1: 1	أَلْفَ ذُؤَابَةٍ
u'ألْفٌ رَأْسٌ':Added, #1: 1	أَلْفِ رَأْسٍ
u'أَلْفٌ رَأْسٌ':Added, #1: 1	أَلْفِ رَأْسٍ
u'ألف رَاكِبٌ':Added, #1: 1	أَلْفِ رَأْسٍ
u'ألْفٌ رَاكِبٌ':Added, #1: 1	أَلْفِ رَاكِبٍ
u'أَلْفٌ رَاكِبٌ':Added, #1: 1	أَلْفِ رَاكِبٍ
u'ألف رَجُلٌ':Added, #1: 1	أَلْفِ رَاكِبٍ
u'ألْفٌ رَجُلٌ':Added, #2: 2	أَلْفَ رَجُلٍ
u'أَلْفٌ رَجُلٌ':Added, #2: 2	أَلْفَ رَجُلٍ
u'ألف رَجُلٌ':Added, #2: 2	أَلْفَ رَجُلٍ
u'ألْفٌ رَجُلٌ':Added, #3: 3	أَلْفُ رَجُلٍ
u'أَلْفٌ رَجُلٌ':Added, #3: 3	أَلْفُ رَجُلٍ
u'ألف رَجُلٌ':Added, #3: 3	أَلْفُ رَجُلٍ
u'ألْفٌ رَجُلٌ':Added, #5: 5	أَلْفِ رَجُلٍ
u'أَلْفٌ رَجُلٌ':Added, #5: 5	أَلْفِ رَجُلٍ
u'ألف رِطْلٌ':Added, #5: 5	أَلْفِ رَجُلٍ
u'ألْفٌ رِطْلٌ':Added, #1: 1	أَلْفِ رِطْلِ
u'أَلْفٌ رِطْلٌ':Added, #1: 1	أَلْفِ رِطْلِ
u'ألف رِطْلٌ':Added, #1: 1	أَلْفِ رِطْلِ
u'ألْفٌ رِطْلٌ':Added, #2: 2	أَلْفُ رِطْلٍ
u'أَلْفٌ رِطْلٌ':Added, #2: 2	أَلْفُ رِطْلٍ
u'آلَ فِرْعَوْنُ':Predicate, #2: 2	أَلْفُ رِطْلٍ
u'ألف ركعة':Added, #7: 7	آلَ فِرْعَوْنَ
u'ألْفٌ ركعة':Added, #1: 1	أَلْفِ رَكْعَةٍ
u'أَلْفٌ ركعة':Added, #1: 1	أَلْفِ رَكْعَةٍ
u'ألف رَكْعَةٌ':Added, #1: 1	أَلْفِ رَكْعَةٍ
u'ألْفٌ رَكْعَةٌ':Added, #1: 1	أَلْفِ رَكْعَةٍ
u'أَلْفٌ رَكْعَةٌ':Added, #1: 1	أَلْفِ رَكْعَةٍ
u'ألف ركعة':Added, #1: 1	أَلْفِ رَكْعَةٍ
u'ألْفٌ ركعة':Added, #2: 2	أَلْفَ رَكْعَةٍ
u'أَلْفٌ ركعة':Added, #2: 2	أَلْفَ رَكْعَةٍ
u'ألف رَكْعَةٌ':Added, #2: 2	أَلْفَ رَكْعَةٍ
u'ألْفٌ رَكْعَةٌ':Added, #2: 2	أَلْفَ رَكْعَةٍ
u'أَلْفٌ رَكْعَةٌ':Added, #2: 2	أَلْفَ رَكْعَةٍ
u'ألف رِيشَةٌ':Added, #2: 2	أَلْفَ رَكْعَةٍ
u'ألْفٌ رِيشَةٌ':Added, #1: 1	أَلْفَ رِيشَةٍ
u'أَلْفٌ رِيشَةٌ':Added, #1: 1	أَلْفَ رِيشَةٍ
u'ألف زانِي':Added, #1: 1	أَلْفَ رِيشَةٍ
u'ألْفٌ زانِي':Added, #2: 2	أَلْفِ زَانِيَةٍ
u'أَلْفٌ زانِي':Added, #2: 2	أَلْفِ زَانِيَةٍ
u'ألف زِمامٌ':Added, #2: 2	أَلْفِ زَانِيَةٍ
u'ألْفٌ زِمامٌ':Added, #1: 1	أَلْفِ زِمَامٍ
u'أَلْفٌ زِمامٌ':Added, #1: 1	أَلْفِ زِمَامٍ
u'ألف زِمامٌ':Added, #1: 1	أَلْفِ زِمَامٍ
u'ألْفٌ زِمامٌ':Added, #2: 2	أَلْفَ زِمَامٍ
u'أَلْفٌ زِمامٌ':Added, #2: 2	أَلْفَ زِمَامٍ
u'ألف زَيْدٌ':Added, #2: 2	أَلْفَ زِمَامٍ
u'ألْفٌ زَيْدٌ':Added, #2: 2	أَلْفِ زَيْدٍ
u'أَلْفٌ زَيْدٌ':Added, #2: 2	أَلْفِ زَيْدٍ
u'ألف سِعَايَةٌ':Added, #2: 2	أَلْفِ زَيْدٍ
u'ألْفٌ سِعَايَةٌ':Added, #1: 1	أَلْفَ السِّعَايَةِ
u'أَلْفٌ سِعَايَةٌ':Added, #1: 1	أَلْفَ السِّعَايَةِ
u'ألف سَنَةٌ':Added, #1: 1	أَلْفَ السِّعَايَةِ
u'ألْفٌ سَنَةٌ':Added, #10: 10	أَلْفِ سَنَةٍ
u'أَلْفٌ سَنَةٌ':Added, #10: 10	أَلْفِ سَنَةٍ
u'ألف سُنَّةٌ':Added, #10: 10	أَلْفِ سَنَةٍ
u'ألْفٌ سُنَّةٌ':Added, #1: 1	أَلْفَ سُنَّةٍ
u'أَلْفٌ سُنَّةٌ':Added, #1: 1	أَلْفَ سُنَّةٍ
u'ألف سَنَةٌ':Added, #1: 1	أَلْفَ سُنَّةٍ
u'ألْفٌ سَنَةٌ':Added, #58: 58	أَلْفَ سَنَةٍ
u'أَلْفٌ سَنَةٌ':Added, #58: 58	أَلْفَ سَنَةٍ
u'ألف سَنَةٌ':Added, #58: 58	أَلْفَ سَنَةٍ
u'ألْفٌ سَنَةٌ':Added, #6: 6	أَلْفُ سَنَةٍ
u'أَلْفٌ سَنَةٌ':Added, #6: 6	أَلْفُ سَنَةٍ
u'ألف سَهْمٌ':Added, #6: 6	أَلْفُ سَنَةٍ
u'ألْفٌ سَهْمٌ':Added, #1: 1	أَلْفَ سَهْمٍ
u'أَلْفٌ سَهْمٌ':Added, #1: 1	أَلْفَ سَهْمٍ
u'ألف سَهْمٌ':Added, #1: 1	أَلْفَ سَهْمٍ
u'ألْفٌ سَهْمٌ':Added, #5: 5	أَلْفِ سَهْمٍ
u'أَلْفٌ سَهْمٌ':Added, #5: 5	أَلْفِ سَهْمٍ
u'ألْفٌ سود':Added, #5: 5	أَلْفِ سَهْمٍ
u'أَلْفٌ سود':Added, #4: 4	أَلْفٍ سُودٍ
u'ألْفٌ سُودٌ':Added, #4: 4	أَلْفٍ سُودٍ
u'أَلْفٌ سُودٌ':Added, #4: 4	أَلْفٍ سُودٍ
u'ألف شَاةٌ':Added, #4: 4	أَلْفٍ سُودٍ
u'ألْفٌ شَاةٌ':Added, #2: 2	أَلْفُ شَاةٍ
u'أَلْفٌ شَاةٌ':Added, #2: 2	أَلْفُ شَاةٍ
u'ألف شَاةٌ':Added, #2: 2	أَلْفُ شَاةٍ
u'ألْفٌ شَاةٌ':Added, #3: 3	أَلْفَ شَاةٍ
u'أَلْفٌ شَاةٌ':Added, #3: 3	أَلْفَ شَاةٍ
u'ألف شِعْبٌ':Added, #3: 3	أَلْفَ شَاةٍ
u'ألْفٌ شِعْبٌ':Added, #2: 2	أَلْفَ شِعْبٍ
u'أَلْفٌ شِعْبٌ':Added, #2: 2	أَلْفَ شِعْبٍ
u'ألف شَهْرٌ':Added, #2: 2	أَلْفَ شِعْبٍ
u'ألف شَهْرٌ':Added, #1: 1	أَلْفُ شَهْرٍ
u'ألْفٌ شَهْرٌ':Added, #1: 1	أَلْفِ شَهْرِ
u'ألْفٌ شَهْرٌ':Added, #1: 1	أَلْفُ شَهْرٍ
u'أَلْفٌ شَهْرٌ':Added, #1: 1	أَلْفِ شَهْرِ
u'أَلْفٌ شَهْرٌ':Added, #1: 1	أَلْفُ شَهْرٍ
u'ألف شَهْرٌ':Added, #1: 1	أَلْفِ شَهْرِ
u'ألْفٌ شَهْرٌ':Added, #22: 22	أَلْفِ شَهْرٍ
u'أَلْفٌ شَهْرٌ':Added, #22: 22	أَلْفِ شَهْرٍ
u'ألف شَهْرٌ':Added, #22: 22	أَلْفِ شَهْرٍ
u'ألْفٌ شَهْرٌ':Added, #3: 3	أَلْفَ شَهْرٍ
u'أَلْفٌ شَهْرٌ':Added, #3: 3	أَلْفَ شَهْرٍ
u'ألف شَيْءٌ':Added, #3: 3	أَلْفَ شَهْرٍ
u'ألْفٌ شَيْءٌ':Added, #1: 1	أَلْفِ شَيْءٍ
u'أَلْفٌ شَيْءٌ':Added, #1: 1	أَلْفِ شَيْءٍ
u'أَلَّفَ شَيْخٌ':Subject, #1: 1	أَلْفِ شَيْءٍ
u'ألف صَاحِبٌ':Added, #1: 1	أَلَّفَ الشَّيْخُ
u'ألْفٌ صَاحِبٌ':Added, #1: 1	أَلْفِ صَاحِبِهِ
u'أَلْفٌ صَاحِبٌ':Added, #1: 1	أَلْفِ صَاحِبِهِ
u'ألف صَبَاحٌ':Added, #1: 1	أَلْفِ صَاحِبِهِ
u'ألْفٌ صَبَاحٌ':Added, #1: 1	أَلْفَ صَبَاحٍ
u'أَلْفٌ صَبَاحٌ':Added, #1: 1	أَلْفَ صَبَاحٍ
u'ألف صَحَابِيٌّ':Added, #1: 1	أَلْفَ صَبَاحٍ
u'ألْفٌ صَحَابِيٌّ':Added, #1: 1	أَلْفَ صَحَابِيٍّ
u'أَلْفٌ صَحَابِيٌّ':Added, #1: 1	أَلْفَ صَحَابِيٍّ
u'ألف صدقة':Added, #1: 1	أَلْفَ صَحَابِيٍّ
u'ألْفٌ صدقة':Added, #1: 1	أَلْفُ صَدَقَةٍ
u'أَلْفٌ صدقة':Added, #1: 1	أَلْفُ صَدَقَةٍ
u'ألف صَدَقَةٌ':Added, #1: 1	أَلْفُ صَدَقَةٍ
u'ألْفٌ صَدَقَةٌ':Added, #1: 1	أَلْفُ صَدَقَةٍ
u'أَلْفٌ صَدَقَةٌ':Added, #1: 1	أَلْفُ صَدَقَةٍ
u'ألف صَلاَةٌ':Added, #1: 1	أَلْفُ صَدَقَةٍ
u'ألْفٌ صَلاَةٌ':Added, #1: 1	أَلْفَ صَلاَةٍ
u'أَلْفٌ صَلاَةٌ':Added, #1: 1	أَلْفَ صَلاَةٍ
u'ألف صَلاَةٌ':Added, #1: 1	أَلْفَ صَلاَةٍ
u'ألْفٌ صَلاَةٌ':Added, #2: 2	أَلْفُ صَلَاةٍ
u'أَلْفٌ صَلاَةٌ':Added, #2: 2	أَلْفُ صَلَاةٍ
u'ألف صَلاَةٌ':Added, #2: 2	أَلْفُ صَلَاةٍ
u'ألْفٌ صَلاَةٌ':Added, #38: 38	أَلْفِ صَلَاةٍ
u'أَلْفٌ صَلاَةٌ':Added, #38: 38	أَلْفِ صَلَاةٍ
u'ألف صَلاَةٌ':Added, #38: 38	أَلْفِ صَلَاةٍ
u'ألْفٌ صَلاَةٌ':Added, #6: 6	أَلْفِ صَلاَةٍ
u'أَلْفٌ صَلاَةٌ':Added, #6: 6	أَلْفِ صَلاَةٍ
u'ألف صَلاَةٌ':Added, #6: 6	أَلْفِ صَلاَةٍ
u'ألف صَلاَةٌ':Added, #9: 9	أَلْفِ صَلاةٍ
u'ألْفٌ صَلاَةٌ':Added, #9: 9	أَلْفَ صَلَاةٍ
u'ألْفٌ صَلاَةٌ':Added, #9: 9	أَلْفِ صَلاةٍ
u'أَلْفٌ صَلاَةٌ':Added, #9: 9	أَلْفَ صَلَاةٍ
u'أَلْفٌ صَلاَةٌ':Added, #9: 9	أَلْفِ صَلاةٍ
u'ألف صُورَةٌ':Added, #9: 9	أَلْفَ صَلَاةٍ
u'ألْفٌ صُورَةٌ':Added, #1: 1	أَلْفِ صُورَةٍ
u'أَلْفٌ صُورَةٌ':Added, #1: 1	أَلْفِ صُورَةٍ
u'ألف طَرْدِيّ':Added, #1: 1	أَلْفِ صُورَةٍ
u'ألْفٌ طَرْدِيّ':Added, #1: 1	أَلْفِ طَرْدِيَّاتٍ
u'أَلْفٌ طَرْدِيّ':Added, #1: 1	أَلْفِ طَرْدِيَّاتٍ
u'ألف عَابِدٌ':Added, #1: 1	أَلْفِ طَرْدِيَّاتٍ
u'ألْفٌ عَابِدٌ':Added, #2: 2	أَلْفِ عَابِدٍ
u'أَلْفٌ عَابِدٌ':Added, #2: 2	أَلْفِ عَابِدٍ
u'ألف عَامٌ':Added, #2: 2	أَلْفِ عَابِدٍ
u'ألْفٌ عَامٌ':Added, #2: 2	أَلْفَ عَامٍ
u'أَلْفٌ عَامٌ':Added, #2: 2	أَلْفَ عَامٍ
u'ألف عَامٌ':Added, #2: 2	أَلْفَ عَامٍ
u'ألْفٌ عَامٌ':Added, #3: 3	أَلْفُ عَامٍ
u'أَلْفٌ عَامٌ':Added, #3: 3	أَلْفُ عَامٍ
u'ألف عَامٌ':Added, #3: 3	أَلْفُ عَامٍ
u'ألْفٌ عَامٌ':Added, #6: 6	أَلْفِ عَامٍ
u'أَلْفٌ عَامٌ':Added, #6: 6	أَلْفِ عَامٍ
u'ألف عَذْقٌ':Added, #6: 6	أَلْفِ عَامٍ
u'ألْفٌ عَذْقٌ':Added, #1: 1	أَلْفَ عَذْقٍ
u'أَلْفٌ عَذْقٌ':Added, #1: 1	أَلْفَ عَذْقٍ
u'ألف عَقْرَبٌ':Added, #1: 1	أَلْفَ عَذْقٍ
u'ألْفٌ عَقْرَبٌ':Added, #1: 1	أَلْفَ عَقْرَبٍ
u'أَلْفٌ عَقْرَبٌ':Added, #1: 1	أَلْفَ عَقْرَبٍ
u'ألف عَمُودٌ':Added, #1: 1	أَلْفَ عَقْرَبٍ
u'ألْفٌ عَمُودٌ':Added, #1: 1	أَلْفِ عَمُودٍ
u'أَلْفٌ عَمُودٌ':Added, #1: 1	أَلْفِ عَمُودٍ
u'ألف عِيرٌ':Added, #1: 1	أَلْفِ عَمُودٍ
u'ألْفٌ عِيرٌ':Added, #1: 1	أَلْفَ عِيرٍ
u'أَلْفٌ عِيرٌ':Added, #1: 1	أَلْفَ عِيرٍ
u'ألف عَيْنٌ':Added, #1: 1	أَلْفَ عِيرٍ
u'ألف عَيْن':Added, #1: 1	أَلْفَ عَيْنٍ
u'ألْفٌ عَيْنٌ':Added, #1: 1	أَلْفَ عَيْنٍ
u'ألْفٌ عَيْن':Added, #1: 1	أَلْفَ عَيْنٍ
u'أَلْفٌ عَيْنٌ':Added, #1: 1	أَلْفَ عَيْنٍ
u'أَلْفٌ عَيْن':Added, #1: 1	أَلْفَ عَيْنٍ
u'ألف غَمْس':Added, #1: 1	أَلْفَ عَيْنٍ
u'ألْفٌ غَمْس':Added, #1: 1	أَلْفَ غَمْسَةٍ
u'أَلْفٌ غَمْس':Added, #1: 1	أَلْفَ غَمْسَةٍ
u'ألف فَارِسٌ':Added, #1: 1	أَلْفَ غَمْسَةٍ
u'ألْفٌ فَارِسٌ':Added, #1: 1	أَلْفِ فَارِسٍ
u'أَلْفٌ فَارِسٌ':Added, #1: 1	أَلْفِ فَارِسٍ
u'ألف فَرَسٌ':Added, #1: 1	أَلْفِ فَارِسٍ
u'ألْفٌ فَرَسٌ':Added, #2: 2	أَلْفَ فَرَسٍ
u'أَلْفٌ فَرَسٌ':Added, #2: 2	أَلْفَ فَرَسٍ
u'ألف فَرِيضَةٌ':Added, #2: 2	أَلْفَ فَرَسٍ
u'ألْفٌ فَرِيضَةٌ':Added, #1: 1	أَلْفُ فَرِيضَةٍ
u'أَلْفٌ فَرِيضَةٌ':Added, #1: 1	أَلْفُ فَرِيضَةٍ
u'آلَفَ فُلاَنٌ':Subject, #1: 1	أَلْفُ فَرِيضَةٍ
u'ألف فُلاَنٌ':Added, #1: 1	آلَفَ فُلَانٌ
u'ألْفٌ فُلاَنٌ':Added, #2: 2	أَلْفِ فُلَانٍ
u'أَلْفٌ فُلاَنٌ':Added, #2: 2	أَلْفِ فُلَانٍ
u'ألف فَلْسٌ':Added, #2: 2	أَلْفِ فُلَانٍ
u'ألف فَلْسٌ':Added, #1: 1	أَلْفُ فَلْسٍ
u'ألْفٌ فَلْسٌ':Added, #1: 1	أَلْفِ فَلْسٍ
u'ألْفٌ فَلْسٌ':Added, #1: 1	أَلْفُ فَلْسٍ
u'أَلْفٌ فَلْسٌ':Added, #1: 1	أَلْفِ فَلْسٍ
u'أَلْفٌ فَلْسٌ':Added, #1: 1	أَلْفُ فَلْسٍ
u'ألف فَمٌ':Added, #1: 1	أَلْفِ فَلْسٍ
u'ألْفٌ فَمٌ':Added, #1: 1	أَلْفِ فَمٍ
u'أَلْفٌ فَمٌ':Added, #1: 1	أَلْفِ فَمٍ
u'ألف فِيلٌ':Added, #1: 1	أَلْفِ فَمٍ
u'ألْفٌ فِيلٌ':Added, #1: 1	أَلْفُ فِيلٍ
u'أَلْفٌ فِيلٌ':Added, #1: 1	أَلْفُ فِيلٍ
u'ألف قَدَمٌ':Added, #1: 1	أَلْفُ فِيلٍ
u'ألْفٌ قَدَمٌ':Added, #3: 3	أَلْفَ قَدَمٍ
u'أَلْفٌ قَدَمٌ':Added, #3: 3	أَلْفَ قَدَمٍ
u'ألف قراض':Added, #3: 3	أَلْفَ قَدَمٍ
u'ألْفٌ قراض':Added, #1: 1	أَلْفِ الْقِرَاضِ
u'أَلْفٌ قراض':Added, #1: 1	أَلْفِ الْقِرَاضِ
u'ألف قَرْضٌ':Added, #1: 1	أَلْفِ الْقِرَاضِ
u'ألف قَرْضٌ':Added, #2: 2	أَلْفُ الْقَرْضِ
u'ألْفٌ قَرْضٌ':Added, #2: 2	أَلْفِ الْقَرْضِ
u'ألْفٌ قَرْضٌ':Added, #2: 2	أَلْفُ الْقَرْضِ
u'أَلْفٌ قَرْضٌ':Added, #2: 2	أَلْفِ الْقَرْضِ
u'أَلْفٌ قَرْضٌ':Added, #2: 2	أَلْفُ الْقَرْضِ
u'أَلِفَ قَرِيبٌ':Subject, #2: 2	أَلْفِ الْقَرْضِ
u'ألف قَرْيَةٌ':Added, #1: 1	أَلِفَ الْقَرِيبُ
u'ألْفٌ قَرْيَةٌ':Added, #1: 1	أَلْفِ قَرْيَةٍ
u'أَلْفٌ قَرْيَةٌ':Added, #1: 1	أَلْفِ قَرْيَةٍ
u'ألف قَطْرَةٌ':Added, #1: 1	أَلْفِ قَرْيَةٍ
u'ألْفٌ قَطْرَةٌ':Added, #1: 1	أَلْفَ قَطْرَةٍ
u'أَلْفٌ قَطْرَةٌ':Added, #1: 1	أَلْفَ قَطْرَةٍ
u'ألف قُلَّةٌ':Added, #1: 1	أَلْفَ قَطْرَةٍ
u'ألْفٌ قُلَّةٌ':Added, #1: 1	أَلْفُ قُلَّةٍ
u'أَلْفٌ قُلَّةٌ':Added, #1: 1	أَلْفُ قُلَّةٍ
u'ألف قَهْرَمان':Added, #1: 1	أَلْفُ قُلَّةٍ
u'ألْفٌ قَهْرَمان':Added, #1: 1	أَلْفُ قَهْرَمَانٍ
u'أَلْفٌ قَهْرَمان':Added, #1: 1	أَلْفُ قَهْرَمَانٍ
u'ألف قَوْلٌ':Added, #1: 1	أَلْفُ قَهْرَمَانٍ
u'ألْفٌ قَوْلٌ':Added, #1: 1	أَلْفَ قَوْلٍ
u'أَلْفٌ قَوْلٌ':Added, #1: 1	أَلْفَ قَوْلٍ
u'آلَفَ قَوْمٌ':Predicate, #1: 1	أَلْفَ قَوْلٍ
u'أَلِفَ كَرَمٌ':Predicate, #1: 1	آلَفَ الْقَوْمَ
u'ألف كَلْبٌ':Added, #1: 1	أَلِفَ الْكَرَمَ
u'ألْفٌ كَلْبٌ':Added, #1: 1	أَلْفِ كَلْبٍ
u'أَلْفٌ كَلْبٌ':Added, #1: 1	أَلْفِ كَلْبٍ
u'ألف كَلِمَةٌ':Added, #1: 1	أَلْفِ كَلْبٍ
u'ألف كَلِمَةٌ':Added, #1: 1	أَلْفَ كَلِمَةٍ
u'ألْفٌ كَلِمَةٌ':Added, #1: 1	أَلْفِ كَلِمَةٍ
u'ألْفٌ كَلِمَةٌ':Added, #1: 1	أَلْفَ كَلِمَةٍ
u'أَلْفٌ كَلِمَةٌ':Added, #1: 1	أَلْفِ كَلِمَةٍ
u'أَلْفٌ كَلِمَةٌ':Added, #1: 1	أَلْفَ كَلِمَةٍ
u'آلَ فلان':Predicate, #1: 1	أَلْفِ كَلِمَةٍ
u'ألف لبنة':Added, #1: 1	آلَ دَاوُدَ
u'ألْفٌ لبنة':Added, #1: 1	أَلْفَ لَبِنَةٍ
u'أَلْفٌ لبنة':Added, #1: 1	أَلْفَ لَبِنَةٍ
u'ألف لَبِنَةٌ':Added, #1: 1	أَلْفَ لَبِنَةٍ
u'ألْفٌ لَبِنَةٌ':Added, #1: 1	أَلْفَ لَبِنَةٍ
u'أَلْفٌ لَبِنَةٌ':Added, #1: 1	أَلْفَ لَبِنَةٍ
u'ألف لِسَانٌ':Added, #1: 1	أَلْفَ لَبِنَةٍ
u'ألْفٌ لِسَانٌ':Added, #1: 1	أَلْفِ لِسَانٍ
u'أَلْفٌ لِسَانٌ':Added, #1: 1	أَلْفِ لِسَانٍ
u'ألف لَوْنٌ':Added, #1: 1	أَلْفِ لِسَانٍ
u'ألْفٌ لَوْنٌ':Added, #1: 1	أَلْفُ لَوْنٍ
u'أَلْفٌ لَوْنٌ':Added, #1: 1	أَلْفُ لَوْنٍ
u'ألف لَيْلٌ':Added, #1: 1	أَلْفُ لَوْنٍ
u'ألْفٌ لَيْلٌ':Added, #2: 2	أَلْفِ لَيْلَةٍ
u'أَلْفٌ لَيْلٌ':Added, #2: 2	أَلْفِ لَيْلَةٍ
u'أَلَّفَ مُتَخَصِّصٌ':Subject, #2: 2	أَلْفِ لَيْلَةٍ
u'ألف مِثْقَالٌ':Added, #1: 1	أَلَّفَ الْمُتَخَصِّصُ
u'ألْفٌ مِثْقَالٌ':Added, #2: 2	أَلْفَ مِثْقَالِ
u'أَلْفٌ مِثْقَالٌ':Added, #2: 2	أَلْفَ مِثْقَالِ
u'ألف مِثْقَالٌ':Added, #2: 2	أَلْفَ مِثْقَالِ
u'ألْفٌ مِثْقَالٌ':Added, #4: 4	أَلْفُ مِثْقَالِ
u'أَلْفٌ مِثْقَالٌ':Added, #4: 4	أَلْفُ مِثْقَالِ
u'ألف مُجَلَّدٌ':Added, #4: 4	أَلْفُ مِثْقَالِ
u'ألْفٌ مُجَلَّدٌ':Added, #1: 1	أَلْفَ مُجَلَّدٍ
u'أَلْفٌ مُجَلَّدٌ':Added, #1: 1	أَلْفَ مُجَلَّدٍ
u'ألف مِحْبَرَةٌ':Added, #1: 1	أَلْفَ مُجَلَّدٍ
u'ألْفٌ مِحْبَرَةٌ':Added, #1: 1	أَلْفَ مِحْبَرَةٍ
u'أَلْفٌ مِحْبَرَةٌ':Added, #1: 1	أَلْفَ مِحْبَرَةٍ
u'ألف مُدٌّ':Added, #1: 1	أَلْفَ مِحْبَرَةٍ
u'ألف مُدٌّ':Added, #1: 1	أَلْفَ مُدٍّ
u'ألْفٌ مُدٌّ':Added, #1: 1	أَلْفُ مُدٍّ
u'ألْفٌ مُدٌّ':Added, #1: 1	أَلْفَ مُدٍّ
u'أَلْفٌ مُدٌّ':Added, #1: 1	أَلْفُ مُدٍّ
u'أَلْفٌ مُدٌّ':Added, #1: 1	أَلْفَ مُدٍّ
u'ألف مرٌّ':Added, #1: 1	أَلْفُ مُدٍّ
u'ألْفٌ مرٌّ':Added, #35: 35	أَلْفَ مَرَّةٍ
u'أَلْفٌ مرٌّ':Added, #35: 35	أَلْفَ مَرَّةٍ
u'ألف مَرَّةٌ':Added, #35: 35	أَلْفَ مَرَّةٍ
u'ألْفٌ مَرَّةٌ':Added, #35: 35	أَلْفَ مَرَّةٍ
u'أَلْفٌ مَرَّةٌ':Added, #35: 35	أَلْفَ مَرَّةٍ
u'أَلِفَ مَسْأَلَةٌ':Predicate, #35: 35	أَلْفَ مَرَّةٍ
u'ألف مَسْأَلَةٌ':Added, #1: 1	أَلِفَ الْمَسْأَلَةَ
u'ألْفٌ مَسْأَلَةٌ':Added, #3: 3	أَلْفَ مَسْأَلَةٍ
u'أَلْفٌ مَسْأَلَةٌ':Added, #3: 3	أَلْفَ مَسْأَلَةٍ
u'ألف مَسْأَلَةٌ':Added, #3: 3	أَلْفَ مَسْأَلَةٍ
u'ألْفٌ مَسْأَلَةٌ':Added, #8: 8	أَلْفِ مَسْأَلَةٍ
u'أَلْفٌ مَسْأَلَةٌ':Added, #8: 8	أَلْفِ مَسْأَلَةٍ
u'ألف مُضَارِبٌ':Added, #8: 8	أَلْفِ مَسْأَلَةٍ
u'ألْفٌ مُضَارِبٌ':Added, #1: 1	أَلْفِ الْمُضَارِبِ
u'أَلْفٌ مُضَارِبٌ':Added, #1: 1	أَلْفِ الْمُضَارِبِ
u'ألف مُضَارَبَةٌ':Added, #1: 1	أَلْفِ الْمُضَارِبِ
u'ألْفٌ مُضَارَبَةٌ':Added, #1: 1	أَلْفُ الْمُضَارَبَةِ
u'أَلْفٌ مُضَارَبَةٌ':Added, #1: 1	أَلْفُ الْمُضَارَبَةِ
u'ألف مُضَارَبَةٌ':Added, #1: 1	أَلْفُ الْمُضَارَبَةِ
u'ألْفٌ مُضَارَبَةٌ':Added, #2: 2	أَلْفَ الْمُضَارَبَةِ
u'أَلْفٌ مُضَارَبَةٌ':Added, #2: 2	أَلْفَ الْمُضَارَبَةِ
u'ألف مُضَارَبَةٌ':Added, #2: 2	أَلْفَ الْمُضَارَبَةِ
u'ألْفٌ مُضَارَبَةٌ':Added, #3: 3	أَلْفِ الْمُضَارَبَةِ
u'أَلْفٌ مُضَارَبَةٌ':Added, #3: 3	أَلْفِ الْمُضَارَبَةِ
u'ألْفٌ مُطْلَقٌ':Added, #3: 3	أَلْفِ الْمُضَارَبَةِ
u'أَلْفٌ مُطْلَقٌ':Added, #1: 1	أَلْفٍ مُطْلَقٍ
u'ألف مُقَاتِلٌ':Added, #1: 1	أَلْفٍ مُطْلَقٍ
u'ألْفٌ مُقَاتِلٌ':Added, #1: 1	أَلْفِ مُقَاتِلٍ
u'أَلْفٌ مُقَاتِلٌ':Added, #1: 1	أَلْفِ مُقَاتِلٍ
u'ألف مُقَنَّعٌ':Added, #1: 1	أَلْفِ مُقَاتِلٍ
u'ألْفٌ مُقَنَّعٌ':Added, #1: 1	أَلْفِ مُقَنّعٍ
u'ألْفٌ مُقَنَّعٌ':Added, #1: 1	أَلْفٍ مُقَنّعٍ
u'أَلْفٌ مُقَنَّعٌ':Added, #1: 1	أَلْفِ مُقَنّعٍ
u'أَلْفٌ مُقَنَّعٌ':Added, #1: 1	أَلْفٍ مُقَنّعٍ
u'ألف مَلَكٌ':Added, #1: 1	أَلْفِ مُقَنّعٍ
u'ألْفٌ مَلَكٌ':Added, #18: 18	أَلْفَ مَلَكٍ
u'أَلْفٌ مَلَكٌ':Added, #18: 18	أَلْفَ مَلَكٍ
u'ألف مَلِكٌ':Added, #18: 18	أَلْفَ مَلَكٍ
u'ألْفٌ مَلِكٌ':Added, #1: 1	أَلْفَ مَلِكٍ
u'أَلْفٌ مَلِكٌ':Added, #1: 1	أَلْفَ مَلِكٍ
u'ألف مَلَكٌ':Added, #1: 1	أَلْفَ مَلِكٍ
u'ألْفٌ مَلَكٌ':Added, #4: 4	أَلْفِ مَلَكٍ
u'أَلْفٌ مَلَكٌ':Added, #4: 4	أَلْفِ مَلَكٍ
u'ألف مَمْلُوكٌ':Added, #4: 4	أَلْفِ مَلَكٍ
u'ألف مَمْلُوكٌ':Added, #1: 1	أَلْفَ مَمْلُوكٍ
u'ألْفٌ مَمْلُوكٌ':Added, #1: 1	أَلْفُ مَمْلُوكٍ
u'ألْفٌ مَمْلُوكٌ':Added, #1: 1	أَلْفَ مَمْلُوكٍ
u'أَلْفٌ مَمْلُوكٌ':Added, #1: 1	أَلْفُ مَمْلُوكٍ
u'أَلْفٌ مَمْلُوكٌ':Added, #1: 1	أَلْفَ مَمْلُوكٍ
u'ألف مَنٌّ':Added, #1: 1	أَلْفُ مَمْلُوكٍ
u'ألف مَنٌّ':Added, #6: 6	أَلْفَ مَنٍّ
u'ألْفٌ مَنٌّ':Added, #6: 6	أَلْفُ مَنٍّ
u'ألْفٌ مَنٌّ':Added, #6: 6	أَلْفَ مَنٍّ
u'أَلْفٌ مَنٌّ':Added, #6: 6	أَلْفُ مَنٍّ
u'أَلْفٌ مَنٌّ':Added, #6: 6	أَلْفَ مَنٍّ
u'ألف مَهْرٌ':Added, #6: 6	أَلْفُ مَنٍّ
u'ألْفٌ مَهْرٌ':Added, #1: 1	أَلْفَ الْمَهْرِ
u'أَلْفٌ مَهْرٌ':Added, #1: 1	أَلْفَ الْمَهْرِ
u'ألْفٌ مُؤَجَّلٌ':Added, #1: 1	أَلْفَ الْمَهْرِ
u'أَلْفٌ مُؤَجَّلٌ':Added, #4: 4	أَلْفٍ مُؤَجَّلٍ
u'أَلِفَ نَاسٌ':Subject, #4: 4	أَلْفٍ مُؤَجَّلٍ
u'ألف نخلة':Added, #1: 1	أَلِفَ النَّاسُ
u'ألْفٌ نخلة':Added, #2: 2	أَلْفَ نَخْلَةٍ
u'أَلْفٌ نخلة':Added, #2: 2	أَلْفَ نَخْلَةٍ
u'ألف نَخْلَةٌ':Added, #2: 2	أَلْفَ نَخْلَةٍ
u'ألْفٌ نَخْلَةٌ':Added, #2: 2	أَلْفَ نَخْلَةٍ
u'أَلْفٌ نَخْلَةٌ':Added, #2: 2	أَلْفَ نَخْلَةٍ
u'ألف نَفْسٌ':Added, #2: 2	أَلْفَ نَخْلَةٍ
u'ألف نَفْسٌ':Added, #1: 1	أَلْفَ نَفْسٍ
u'ألْفٌ نَفْسٌ':Added, #1: 1	أَلْفُ نَفْسٍ
u'ألْفٌ نَفْسٌ':Added, #1: 1	أَلْفَ نَفْسٍ
u'أَلْفٌ نَفْسٌ':Added, #1: 1	أَلْفُ نَفْسٍ
u'أَلْفٌ نَفْسٌ':Added, #1: 1	أَلْفَ نَفْسٍ
u'ألف وَجْهٌ':Added, #1: 1	أَلْفُ نَفْسٍ
u'ألف وَجْهٌ':Added, #1: 1	أَلْفُ وَجْهٍ
u'ألْفٌ وَجْهٌ':Added, #1: 1	أَلْفِ وَجْهٍ
u'ألْفٌ وَجْهٌ':Added, #1: 1	أَلْفُ وَجْهٍ
u'أَلْفٌ وَجْهٌ':Added, #1: 1	أَلْفِ وَجْهٍ
u'أَلْفٌ وَجْهٌ':Added, #1: 1	أَلْفُ وَجْهٍ
u'ألف وَرَقَةٌ':Added, #1: 1	أَلْفِ وَجْهٍ
u'ألْفٌ وَرَقَةٌ':Added, #3: 3	أَلْفِ وَرَقَةٍ
u'أَلْفٌ وَرَقَةٌ':Added, #3: 3	أَلْفِ وَرَقَةٍ
u'ألف وَسْقٌ':Added, #3: 3	أَلْفِ وَرَقَةٍ
u'ألْفٌ وَسْقٌ':Added, #2: 2	أَلْفَ وَسْقٍ
u'أَلْفٌ وَسْقٌ':Added, #2: 2	أَلْفَ وَسْقٍ
u'ألف وَقِيّ':Added, #2: 2	أَلْفَ وَسْقٍ
u'ألْفٌ وَقِيّ':Added, #1: 1	أَلْفِ وَقِيَّةٍ
u'أَلْفٌ وَقِيّ':Added, #1: 1	أَلْفِ وَقِيَّةٍ
u'ألف يَهُودِيٌّ':Added, #1: 1	أَلْفِ وَقِيَّةٍ
u'ألْفٌ يَهُودِيٌّ':Added, #1: 1	أَلْفِ يَهُودِيٍّ
u'أَلْفٌ يَهُودِيٌّ':Added, #1: 1	أَلْفِ يَهُودِيٍّ
u'ألف يَوْمٌ':Added, #1: 1	أَلْفِ يَهُودِيٍّ
u'ألْفٌ يَوْمٌ':Added, #1: 1	أَلْفَ يَوْمٍ
u'أَلْفٌ يَوْمٌ':Added, #1: 1	أَلْفَ يَوْمٍ
u'ألف يَوْمٌ':Added, #1: 1	أَلْفَ يَوْمٍ
u'ألْفٌ يَوْمٌ':Added, #4: 4	أَلْفِ يَوْمٍ
u'أَلْفٌ يَوْمٌ':Added, #4: 4	أَلْفِ يَوْمٍ
u'إِلْقَاءٌ عَدَاوَةٌ':Added, #4: 4	أَلْفِ يَوْمٍ
u'إِلْقَاءٌ مُخَالِفٌ':Added, #3: 3	إِلْقَاءِ الْعَدَاوَةِ
u'أَلْقَى أَحِبَّةٌ':Predicate, #1: 1	إِلْقَاءُ الْمُخَالِفِ
u'أَلْقَى أحَدٌ':Predicate, #2: 2	أَلْقَى الْأَحِبّةَ
u'أَلْقَى أحَدٌ':Subject, #2: 2	أَلْقَى أَحَدَ
u'أَلْقَى أَذَانٌ':Predicate, #1: 1	أَلْقَى أَحَدٌ
u'أَلْقَى أَلْوَاحٌ':Predicate, #1: 1	أَلْقَى الْأَذَانَ
u'أَلْقَى آمِرٌ':Predicate, #1: 1	أَلْقَى الْأَلْوَاحَ
u'أَلْقَى بَحْرٌ':Subject, #1: 1	أَلْقَى الْآمِرَ
u'أَلْقَى بَذْرٌ':Predicate, #2: 2	أَلْقَى الْبَحْرُ
u'أَلْقَى تُرَابٌ':Predicate, #4: 4	أَلْقَى الْبَذْرَ
u'أَلْقَى جِلْبَابٌ':Predicate, #1: 1	أَلْقَى التُّرَابَ
u'أَلْقَى جُوَالِقٌ':Predicate, #5: 5	أَلْقَى جِلْبَابَ
u'أَلْقَى حَبٌّ':Predicate, #1: 1	أَلْقَى جُوَالِقَ
u'أَلْقَى حَشِيشٌ':Predicate, #1: 1	أَلْقَى حَبَّ
u'أَلْقَى دَابَّةٌ':Predicate, #2: 2	أَلْقَى الْحَشِيشَ
u'أَلْقَى رَجُلٌ':Subject, #1: 1	أَلْقَى دَابَّةَ
u'أَلْقَى رَسُولٌ':Predicate, #1: 1	أَلْقَى رَجُلٌ
u'أَلْقَى رَوْث':Predicate, #1: 1	أَلْقَى رَسُولَ
u'أَلْقَى سِلاَحٌ':Predicate, #2: 2	أَلْقَى الرَّوْثَةَ
u'أَلْقَى سِلاَحٌ':Predicate, #1: 1	أَلْقَى السِّلَاحَ
u'أَلْقَى سَمْعٌ':Predicate, #3: 3	أَلْقَى السِّلاَحَ
u'أَلْقَى سَمَكٌ':Predicate, #2: 2	أَلْقَى السَّمْعَ
u'أَلْقَى سِنٌّ':Predicate, #1: 1	أَلْقَى سَمَكَةً
u'أَلْقَى شبكة':Predicate, #1: 1	أَلْقَى السِّنَّ
u'أَلْقَى شَبَكَةٌ':Predicate, #1: 1	أَلْقَى الشَّبَكَةَ
u'أَلْقَى شَخْصٌ':Subject, #1: 1	أَلْقَى الشَّبَكَةَ
u'أَلْقَى شَيْخٌ':Subject, #1: 1	أَلْقَى شَخْصٌ
u'أَلْقَى شَيْطَانٌ':Subject, #1: 1	أَلْقَى الشَّيْخُ
u'أَلْقَى شَيْطَانٌ':Subject, #2: 2	أَلْقَى الشّيْطَانُ
u'أَلْقَى صَاحِبٌ':Subject, #9: 9	أَلْقَى الشَّيْطَانُ
u'أَلْقَى صَاحِبٌ':Subject, #1: 1	أَلْقَى صَاحِبُ
u'أَلْقَى صَدِيقٌ':Predicate, #1: 1	أَلْقَى صَاحِبُهُ
u'أَلْقَى قُمَامَةٌ':Predicate, #2: 2	أَلْقَى الصَّدِيقَ
u'أَلْقَى مَاءٌ':Predicate, #2: 2	أَلْقَى الْقُمَامَةَ
u'أَلْقَى مَالٌ':Predicate, #1: 1	أَلْقَى الْمَاءَ
u'أَلْقَى مَتَاعٌ':Predicate, #1: 1	أَلْقَى مَالَ
u'أَلْقَى مِنْطَقَةٌ':Predicate, #1: 1	أَلْقَى الْمَتَاعَ
u'أَلْقَى نَائِمٌ':Subject, #1: 1	أَلْقَى الْمِنْطَقَةَ
u'أَلْقَى نَبِيٌّ':Subject, #1: 1	أَلْقَى النَّائِمُ
u'أَلْقَى نَجَاسَةٌ':Predicate, #1: 1	أَلْقَى النَّبِيُّ
u'أَلْقَى نَجَسٌ':Predicate, #1: 1	أَلْقَى النَّجَاسَةَ
u'أَلْقَى هَارِبٌ':Subject, #1: 1	أَلْقَى النَّجَسَ
u'آلَ كَلاَمٌ':Subject, #1: 1	أَلْقَى هَارِبٌ
u'إِلْمَامٌ بِدْعَةٌ':Added, #2: 2	آلَ كَلَامُ
u'آلَمَ حَيَوَانٌ':Predicate, #1: 1	إِلْمَامِ بِدْعَةٍ
u'آلَ مِلْكٌ':Subject, #1: 1	آلَمَ الْحَيَوَانَ
u'آلَمَ مَضْرُوبٌ':Predicate, #1: 1	آلَ الْمِلْكُ
u'آلَ نَظَرٌ':Subject, #1: 1	آلَمَ الْمَضْرُوبَ
u'إلْهَامٌ حَقٌّ':Added, #2: 2	آلَ النَّظَرُ
u'إلْهَامٌ خَاطِرٌ':Added, #1: 1	إلْهَامِ الْحَقِّ
u'إلْهَامٌ شَيَاطِينُ':Added, #1: 1	إلْهَامُ خَاطِرٍ
u'إلْهَامٌ مُبْتَدَأٌ':Added, #1: 1	إلْهَامَ الشَّيَاطِينِ
u'أَلْهَمَ نحلة':Predicate, #1: 1	إلْهَامِ الْمُبْتَدَأِ
u'أَلْهَمَ نَحْلَةٌ':Predicate, #1: 1	أَلْهَمَ النَّحْلَةَ
u'أَلْوَاحٌ أَكْتَافٌ':Added, #1: 1	أَلْهَمَ النَّحْلَةَ
u'أَلْوَاحٌ حانوتٌ':Added, #1: 1	أَلْوَاحِ الْأَكْتَافِ
u'أَلْوَاحٌ دَكاكينُ':Added, #1: 1	أَلْوَاحُ الْحَانُوتِ
u'أَلْوَاحٌ سَفِينَةٌ':Added, #1: 1	أَلْوَاحُ الدَّكَاكِينِ
u'أَلْوَاحٌ سَفِينَةٌ':Added, #1: 1	أَلْوَاحِ السَّفِينَةِ
u'أَلْوَاحٌ قُبُورٌ':Added, #1: 1	أَلْوَاحِ سَفِينَةٍ
u'آلَ وَقْفٌ':Subject, #1: 1	أَلْوَاحِ الْقُبُورِ
u'آلَى أقَلُّ':Predicate, #1: 1	آلَ الْوَقْفُ
u'آلَى أَكْثَرُ':Predicate, #1: 1	آلَى أَقَلَّ
u'آلَى ذِمِّيٌّ':Subject, #1: 1	آلَى أَكْثَرَ
u'آلَى رَجُلٌ':Subject, #1: 1	آلَى الذِّمِّيُّ
u'آلَى رَسُولٌ':Subject, #6: 6	آلَى الرَّجُلُ
u'آلَى مُرْتَدٌّ':Subject, #5: 5	آلَى رَسُولُ
u'آلَى نَبِيٌّ':Subject, #1: 1	آلَى مُرْتَدٌّ
u'أَمَاتَ إمَامٌ':Subject, #1: 1	آلَى النَّبِيُّ
u'أَمَاتَ رَسُولٌ':Subject, #1: 1	أَمَاتَ الْإِمَامُ
u'أَمَاتَ زَيْدٌ':Subject, #1: 1	أَمَاتَ رَسُولُ
u'أَمَاتَ فُلاَنٌ':Subject, #1: 1	أَمَاتَ زَيْدٌ
u'أَمَاتَ مُرْسَلٌ':Predicate, #1: 1	أَمَاتَ فُلَانٌ
u'أَمَاتَ نَاسٌ':Subject, #1: 1	أَمَاتَ الْمُرْسَلِينَ
u'أَمَّ أخرَس':Predicate, #1: 1	أَمَاتَ النَّاسُ
u'إمَارَةٌ اِبْنٌ':Added, #1: 1	أَمَّ الْأَخْرَسَ
u'إمَارَةٌ بِلادٌ':Added, #1: 1	إمَارَةِ ابْنِ
u'إمَارَةٌ بَلَدٌ':Added, #1: 1	إمَارَةِ الْبِلَادِ
u'إمَارَةٌ رُجُوعٌ':Added, #1: 1	إمَارَةَ بَلَدٍ
u'إمَارَةٌ سفهاء':Added, #1: 1	إمَارَةُ الرُّجُوعِ
u'إمَارَةٌ سفهاء':Added, #1: 1	إمَارَةُ السُّفَهَاءِ
u'إمَارَةٌ صُبْيَانٌ':Added, #1: 1	إمَارَةِ السُّفَهَاءِ
u'إمَارَةٌ صِبْيَانٌ':Added, #1: 1	إمَارَةُ الصّبْيَانِ
u'إمَارَةٌ فلان':Added, #1: 1	إمَارَةُ الصّبْيَانِ
u'إمَاطَةٌ حَلالٌ':Added, #1: 1	إمَارَةُ جَعْفَرٍ
u'أَمَّ أَكْثَرُ':Predicate, #1: 1	إمَاطَةِ حَلَالٍ
u'أَمَّ أَلْثَغ':Subject, #3: 3	أَمَّ أَكْثَرَ
u'إمَامَةٌ اِبْنٌ':Added, #1: 1	أَمَّ أَلْثَغُ
u'إمَامَةٌ اِبْنٌ':Added, #1: 1	إمَامَةُ ابْنٍ
u'إمَامَةٌ أحَدٌ':Added, #2: 2	إمَامَةِ ابْنِ
u'إمَامَةٌ أَحْدَب':Added, #1: 1	إمَامَةَ أَحَدٍ
u'إمَامَةٌ أخرَس':Added, #2: 2	إمَامَةُ الْأَحْدَبِ
u'إمَامَةٌ أعْرَابِيٌّ':Added, #1: 1	إمَامَةِ الْأَخْرَسِ
u'إمَامَةٌ أعْرَابِيٌّ':Added, #1: 1	إمَامَةُ الْأَعْرَابِيِّ
u'إمَامَةٌ أَلْثَغ':Added, #1: 1	إمَامَةِ الْأَعْرَابِيِّ
u'إمَامَةٌ الْمَرْأَةُ':Added, #1: 1	إمَامَةُ الْأَلْثَغِ
u'إمَامَةٌ الْمَرْأَةُ':Added, #2: 2	إمَامَةَ الْمَرْأَةِ
u'إمَامَةٌ الْمَرْأَةُ':Added, #2: 2	إمَامَةِ الْمَرْأَةِ
u'إمَامَةٌ إمَامٌ':Added, #4: 4	إمَامَةُ الْمَرْأَةِ
u'إمَامَةٌ إمَامٌ':Added, #1: 1	إمَامَةَ إمَامِ
u'إمَامَةٌ اِمْرَأَةٌ':Added, #1: 1	إمَامَةُ إمَامِ
u'إمَامَةٌ أُمِّيٌّ':Added, #1: 1	إمَامَةُ امْرَأَةٍ
u'إمَامَةٌ أُمِّيٌّ':Added, #1: 1	إمَامَةُ الْأُمِّيِّ
u'إمَامَةٌ أُمِّيٌّ':Added, #2: 2	إمَامَةُ أُمِّيٍّ
u'إمَامَةٌ إِنْسانٌ':Added, #4: 4	إمَامَةِ الْأُمِّيِّ
u'إمَامَةٌ إِنْسانٌ':Added, #1: 1	إمَامَةَ الْإِنْسَانِ
u'إمَامَةٌ أَوَّلُ':Added, #1: 1	إمَامَةُ الْإِنْسَانِ
u'إمَامَةٌ تَرَاوِيحُ':Added, #1: 1	إمَامَةُ الْأَوَّلِ
u'إمَامَةٌ تَمْتامٌ':Added, #1: 1	إمَامَةَ التَّرَاوِيحِ
u'إمَامَةٌ جَامِعٌ':Added, #1: 1	إمَامَةُ التَّمْتَامِ
u'إمَامَةٌ جَمَاعَةٌ':Added, #1: 1	إمَامَةَ الْجَامِعِ
u'إمَامَةٌ جمع':Added, #1: 1	إمَامَةِ الْجَمَاعَةِ
u'إمَامَةٌ جُمَعٌ':Added, #1: 1	إمَامَةِ الْجُمَعِ
u'إمَامَةٌ جمعة':Added, #1: 1	إمَامَةِ الْجُمَعِ
u'إمَامَةٌ جُمُعَةٌ':Added, #2: 2	إمَامَةِ الْجُمُعَةِ
u'إمَامَةٌ جمعة':Added, #2: 2	إمَامَةِ الْجُمُعَةِ
u'إمَامَةٌ جُمُعَةٌ':Added, #3: 3	إمَامَةَ الْجُمُعَةِ
u'إمَامَةٌ جُنْدِيٌّ':Added, #3: 3	إمَامَةَ الْجُمُعَةِ
u'إمَامَةٌ جِنِّيٌّ':Added, #1: 1	إمَامَةُ الْجُنْدِيِّ
u'إمَامَةٌ خُلَفَاءُ':Added, #1: 1	إمَامَةِ الْجِنِّيِّ
u'إمَامَةٌ رِجَالٌ':Added, #1: 1	إمَامَةِ الْخُلَفَاءِ
u'إمَامَةٌ رَجُلٌ':Added, #2: 2	إمَامَةِ الرِّجَالِ
u'إمَامَةٌ رَجُلٌ':Added, #1: 1	إمَامَةُ الرَّجُلِ
u'إمَامَةٌ رَجُلٌ':Added, #1: 1	إمَامَةُ رَجُلٍ
u'إمَامَةٌ شَارِبٌ':Added, #1: 1	إمَامَةِ رَجُلٍ
u'إمَامَةٌ صَاحِبٌ':Added, #1: 1	إمَامَةِ شَارِبِ
u'إمَامَةٌ صَبِيٌّ':Added, #1: 1	إمَامَةَ صَاحِبِهِ
u'إمَامَةٌ صَبِيٌّ':Added, #2: 2	إمَامَةَ الصَّبِيِّ
u'إمَامَةٌ صَبِيٌّ':Added, #2: 2	إمَامَةُ صَبِيٍّ
u'إمَامَةٌ صَبِيٌّ':Added, #3: 3	إمَامَةُ الصَّبِيِّ
u'إمَامَةٌ صِبْيَانٌ':Added, #5: 5	إمَامَةِ الصَّبِيِّ
u'إمَامَةٌ صِدِّيقٌ':Added, #1: 1	إمَامَةِ الصِّبْيَانِ
u'إمَامَةٌ صَلاَةٌ':Added, #1: 1	إمَامَةَ الصِّدِّيقِ
u'إمَامَةٌ صَلَوَاتٌ':Added, #10: 10	إمَامَةِ الصَّلَاةِ
u'إمَامَةٌ صَلَوَاتٌ':Added, #1: 1	إمَامَةُ الصَّلَوَاتِ
u'إمَامَةٌ صَلَوَاتٌ':Added, #1: 1	إمَامَةِ الصَّلَوَاتِ
u'إمَامَةٌ عَاجِزٌ':Added, #2: 2	إمَامَةَ الصَّلَوَاتِ
u'إمَامَةٌ عَاجِزٌ':Added, #1: 1	إمَامَةُ الْعَاجِزِ
u'إمَامَةٌ عَامِّيٌّ':Added, #1: 1	إمَامَةُ عَاجِزٍ
u'إمَامَةٌ عِبَادَةٌ':Added, #1: 1	إمَامَةِ الْعَامِّيِّ
u'إمَامَةٌ عَبْدٌ':Added, #1: 1	إمَامَةِ الْعِبَادَةِ
u'إمَامَةٌ عَبْدٌ':Added, #1: 1	إمَامَةَ الْعَبْدِ
u'إمَامَةٌ عَبْدٌ':Added, #1: 1	إمَامَةِ الْعَبْدِ
u'إمَامَةٌ عَبْدٌ':Added, #1: 1	إمَامَةُ عَبْدٍ
u'إمَامَةٌ عَدْلٌ':Added, #4: 4	إمَامَةُ الْعَبْدِ
u'إمَامَةٌ عَلِيٌّ':Added, #1: 1	إمَامَةُ الْعَدْلِ
u'إمَامَةٌ عَلِيٌّ':Added, #1: 1	إمَامَةِ عَلِيِّ
u'إمَامَةٌ عِيدٌ':Added, #4: 4	إمَامَةِ عَلِيٍّ
u'إمَامَةٌ غير':Added, #1: 1	إمَامَةِ الْعِيدِ
u'إمَامَةٌ غَيْرٌ':Added, #2: 2	إمَامَةَ غَيْرِهِ
u'إمَامَةٌ فَاسِقٌ':Added, #2: 2	إمَامَةَ غَيْرِهِ
u'إمَامَةٌ فَاسِقٌ':Added, #1: 1	إمَامَةُ فَاسِقٍ
u'إمَامَةٌ فَاسِقٌ':Added, #2: 2	إمَامَةَ الْفَاسِقِ
u'إمَامَةٌ فَاسِقٌ':Added, #2: 2	إمَامَةُ الْفَاسِقِ
u'إمَامَةٌ فَرْضٌ':Added, #9: 9	إمَامَةِ الْفَاسِقِ
u'إمَامَةٌ قَارِئٌ':Added, #1: 1	إمَامَةِ الْفَرْضِ
u'إمَامَةٌ قَارِئٌ':Added, #1: 1	إمَامَةَ الْقَارِئِ
u'إمَامَةٌ قَاعِدٌ':Added, #1: 1	إمَامَةِ الْقَارِئِ
u'إمَامَةٌ كَافِرٌ':Added, #1: 1	إمَامَةُ الْقَاعِدِ
u'إمَامَةٌ كَافِرٌ':Added, #1: 1	إمَامَةُ الْكَافِرِ
u'إمَامَةٌ كَافِرٌ':Added, #1: 1	إمَامَةِ الْكَافِرِ
u'إمَامَةٌ لَحَّانٌ':Added, #1: 1	إمَامَةُ كَافِرٍ
u'إمَامَةٌ لَحَّانٌ':Added, #1: 1	إمَامَةِ اللَّحَّانِ
u'إمَامَةٌ مَاسِحٌ':Added, #4: 4	إمَامَةُ اللَّحَّانِ
u'إمَامَةٌ مُتَأَخِّرٌ':Added, #1: 1	إمَامَةُ الْمَاسِحِ
u'إمَامَةٌ مَجْذُومٌ':Added, #1: 1	إمَامَةِ الْمُتَأَخِّرِ
u'إمَامَةٌ مَجْنُونٌ':Added, #1: 1	إمَامَةُ الْمَجْذُومِ
u'إمَامَةٌ مُحْدِثٌ':Added, #1: 1	إمَامَةُ الْمَجْنُونِ
u'إمَامَةٌ مُحْدِثٌ':Added, #1: 1	إمَامَةُ الْمُحْدِثِ
u'إمَامَةٌ مُرْسِلٌ':Added, #2: 2	إمَامَةُ مُحْدِثٍ
u'إمَامَةٌ مُسَافِرٌ':Added, #1: 1	إمَامَةِ الْمُرْسِلِ
u'إمَامَةٌ مُسَافِرٌ':Added, #1: 1	إمَامَةُ مُسَافِرٍ
u'إمَامَةٌ مُسَافِرٌ':Added, #1: 1	إمَامَةِ مُسَافِرٍ
u'إمَامَةٌ مُسَافِرٌ':Added, #2: 2	إمَامَةُ الْمُسَافِرِ
u'إمَامَةٌ مَسْبُوق':Added, #2: 2	إمَامَةِ الْمُسَافِرِ
u'إمَامَةٌ مَسْبُوق':Added, #1: 1	إمَامَةُ مَسْبُوقٍ
u'إمَامَةٌ مَسْجِدٌ':Added, #2: 2	إمَامَةِ مَسْبُوقٍ
u'إمَامَةٌ مُشْتَغِل':Added, #1: 1	إمَامَةَ الْمَسْجِدِ
u'إمَامَةٌ مُعِيدٌ':Added, #1: 1	إمَامَةِ الْمُشْتَغِلِ
u'إمَامَةٌ مُقِيمٌ':Added, #1: 1	إمَامَةُ الْمُعِيدِ
u'إمَامَةٌ مَلَكٌ':Added, #1: 1	إمَامَةُ مُقِيمٍ
u'إمَامَةٌ مُوَسْوَسٌ':Added, #1: 1	إمَامَةِ الْمَلَكِ
u'إمَامَةٌ مُوَسْوِسٌ':Added, #1: 1	إمَامَةُ الْمُوَسْوَسِ
u'إمَامَةٌ نِساءٌ':Added, #1: 1	إمَامَةُ الْمُوَسْوِسِ
u'إمَامَةٌ نِساءٌ':Added, #1: 1	إمَامَةُ النِّسَاءِ
u'إمَامَةٌ نِساءٌ':Added, #1: 1	إمَامَةِ النِّسَاءِ
u'إمَامَةٌ وَحْيٌ':Added, #4: 4	إمَامَةَ النِّسَاءِ
u'إمَامَةٌ ولد':Added, #2: 2	إمَامَةُ وَحْيٍ
u'إمَامَةٌ وَلَدٌ':Added, #1: 1	إمَامَةُ وَلَدِ
u'إمَامَةٌ وَلِيٌّ':Added, #1: 1	إمَامَةُ وَلَدِ
u'أَمَّ اِمْرَأَةٌ':Subject, #1: 1	إمَامَةُ وَلِيِّ
u'أَمَّ أُمِّيٌّ':Subject, #2: 2	أَمَّ امْرَأَةٌ
u'أَمَّ أُمِّيٌّ':Subject, #1: 1	أَمَّ الْأُمِّيُّ
u'أَمَّ بَيْتٌ':Predicate, #4: 4	أَمَّ أُمِّيٌّ
u'أَمَّ جَمِيع':Predicate, #1: 1	أَمَّ الْبَيْتَ
u'أَمَدَّ أهْلٌ':Subject, #1: 1	أَمَّ الْجَمِيعَ
u'أَمَرَ أَبٌ':Predicate, #1: 1	أَمَدَّ أَهْلُ
u'أَمَرَ أَبٌ':Subject, #1: 1	أَمَرَ الْأَبَ
u'أَمْرٌ أَبٌ':Added, #1: 1	أَمَرَ الْأَبُ
u'أَمْرٌ أَبٌ':Added, #1: 1	أَمْرُ الْأَبِ
u'أَمْرٌ إبَاحَةٌ':Added, #1: 1	أَمْرِ الْأَبِ
u'أَمْرٌ إبَاحَةٌ':Added, #2: 2	أَمْرَ إبَاحَةٍ
u'أَمَرَ إبْلِيسُ':Predicate, #3: 3	أَمْرُ إبَاحَةٍ
u'أَمَّرَ اِبْنٌ':Predicate, #1: 1	أَمَرَ إبْلِيسَ
u'أَمَرَ اِبْنٌ':Predicate, #1: 1	أَمَّرَ ابْنَ
u'أَمْرٌ اِبْنٌ':Added, #2: 2	أَمَرَ ابْنَ
u'أَمْرٌ اِبْنٌ':Added, #1: 1	أَمْرَ ابْنِ
u'أَمْرٌ اِبْنٌ':Added, #1: 1	أَمْرِ ابْنِ
u'أَمَرَّ إِبْهَامٌ':Predicate, #4: 4	أَمْرُ ابْنِ
u'أَمَرَ آتِي':Predicate, #1: 1	أَمَرَّ إبْهَامَ
u'أَمْرٌ إِجْلاَءٌ':Added, #1: 1	أَمَرَ الْآتِيَ
u'أَمْرٌ أَجْنَبِيٌّ':Added, #1: 1	أَمْرُ إجْلَاءِ
u'أَمَرَ أحَدٌ':Subject, #2: 2	أَمْرِ الْأَجْنَبِيِّ
u'أَمْرٌ أحَدٌ':Added, #2: 2	أَمَرَ أَحَدُ
u'أَمْرٌ أحَدٌ':Added, #1: 1	أَمْر أَحَدِ
u'أَمْرٌ أحَدٌ':Added, #1: 1	أَمْرِ أَحَدٍ
u'أَمْرٌ أَحْيَاءٌ':Added, #2: 2	أَمْرَ أَحَدٍ
u'أَمَرَ أُخْتٌ':Predicate, #1: 1	أَمْرِ الْأَحْيَاءِ
u'أَمْرٌ آخِرَةٌ':Added, #1: 1	أَمَرَ أُخْتَ
u'أَمْرٌ آخِرَةٌ':Added, #10: 10	أَمْرِ الْآخِرَةِ
u'أَمْرٌ آخِرَةٌ':Added, #1: 1	أَمْرِ آخِرَةٍ
u'أَمْرٌ آخِرَةٌ':Added, #1: 1	أَمْرَ آخِرَتِهِ
u'أَمْرٌ آخِرَةٌ':Added, #1: 1	أَمْرِ آخِرَتِهِ
u'أَمْرٌ آخِرَةٌ':Added, #1: 1	أَمْرَ الْآخِرَةِ
u'أَمْرٌ إِرْشَادٌ':Added, #2: 2	أَمْرُ الْآخِرَةِ
u'أَمْرٌ أرْضٌ':Added, #3: 3	أَمْرُ إرْشَادٍ
u'أَمْرٌ أرْضٌ':Added, #1: 1	أَمْرِ أَرْضِهِ
u'أَمْرٌ اِسْتِعاذَةٌ':Added, #1: 1	أَمْرِ الأَرْضِ
u'أَمْرٌ إِسْلامٌ':Added, #1: 1	أَمْرُ الاِسْتِعَاذَةِ
u'أَمْرٌ إِسْلامٌ':Added, #1: 1	أَمْرَ الْإِسْلَامِ
u'أَمْرٌ إِسْلامٌ':Added, #1: 1	أَمْرُ الْإِسْلَامِ
u'أَمَرَ أَسْماءٌ':Predicate, #2: 2	أَمْرِ الْإِسْلَامِ
u'أَمْرٌ أسْوَد':Added, #1: 1	أَمَرَ أَسْمَاءَ
u'أَمَرَ أَسيرٌ':Subject, #1: 1	أَمْرُ الْأَسْوَدِ
u'أَمْرٌ أصاغر':Added, #2: 2	أَمَرَ الْأَسِيرُ
u'أَمْرٌ أَصْحَابٌ':Added, #1: 1	أَمْرِ الْأَصَاغِرِ
u'أَمْرٌ أصل':Added, #1: 1	أَمْرِ أَصْحَابِ
u'أَمْرٌ أًصْلٌ':Added, #1: 1	أَمْرِ الْأَصْلِ
u'أَمْرٌ أَصْلِيٌّ':Added, #1: 1	أَمْرِ الْأَصْلِ
u'أَمَرَ أَصيلٌ':Subject, #2: 2	أَمْرٍ أَصْلِيٍّ
u'أَمْرَاضٌ أَعْمَالٌ':Added, #1: 1	أَمَرَ الْأَصِيلُ
u'أَمْرَاضٌ حَلْقٌ':Added, #1: 1	أَمْرَاضِ الْأَعْمَالِ
u'أَمْرَاضٌ خُلَفَاءُ':Added, #1: 1	أَمْرَاضِ الْحَلْقِ
u'أَمْرَاضٌ رَأْسٌ':Added, #1: 1	أَمْرَاضِ الْخُلَفَاءِ
u'أَمْرَاضٌ رَدِيئة':Added, #1: 1	أَمْرَاضِ الرَّأْسِ
u'أَمْرَاضٌ شَبابٌ':Added, #2: 2	أَمْرَاضٍ رَدِيئَةٍ
u'أَمْرَاضٌ شَبَابٌ':Added, #1: 1	أَمْرَاضِ الشَّبَابِ
u'أَمْرَاضٌ عَصَبٌ':Added, #1: 1	أَمْرَاضِ الشَّبَابِ
u'أَمْرَاضٌ عين':Added, #1: 1	أَمْرَاضِ الْعَصَبِ
u'أَمْرَاضٌ عَيْنٌ':Added, #1: 1	أَمْرَاضِ الْعَيْنِ
u'أَمْرَاضٌ عَيْن':Added, #1: 1	أَمْرَاضِ الْعَيْنِ
u'أَمْرَاضٌ قلب':Added, #1: 1	أَمْرَاضِ الْعَيْنِ
u'أَمْرَاضٌ قَلْبٌ':Added, #1: 1	أَمْرَاضِ الْقَلْبِ
u'أَمْرَاضٌ قَلْب':Added, #1: 1	أَمْرَاضِ الْقَلْبِ
u'أَمْرَاضٌ قُلُوبٌ':Added, #1: 1	أَمْرَاضِ الْقَلْبِ
u'أَمْرٌ أَطْفَالٌ':Added, #3: 3	أَمْرَاضِ الْقُلُوبِ
u'أَمْرٌ أَطْفَالٌ':Added, #2: 2	أَمْرِ أَطْفَالِهِ
u'أَمَرَ أعْرَابِيٌّ':Predicate, #3: 3	أَمْرِ الْأَطْفَالِ
u'أَمْرٌ إعْلاَمٌ':Added, #2: 2	أَمَرَ الْأَعْرَابِيَّ
u'أَمْرٌ إعْلاَمٌ':Added, #1: 1	أَمْرُ الْإِعْلَامِ
u'أَمْرٌ إعْلاَمٌ':Added, #1: 1	أَمْرِ الْإِعْلَامِ
u'أَمَرَ أَعْوَانٌ':Predicate, #2: 2	أَمْرُ إعْلَامٍ
u'أَمْرٌ إقْرَارٌ':Added, #1: 1	أَمَرَ الْأَعْوَانَ
u'أَمْرٌ إِلْزَامٌ':Added, #1: 1	أَمْرِ الْإِقْرَارِ
u'أَمَرَ اللهُ':Subject, #1: 1	أَمْرُ الْإِلْزَامِ
u'أَمْرٌ اللهُ':Added, #4: 4	أَمَرَ اللهُ
u'أَمْرٌ اللهُ':Added, #1: 1	أَمْرِ اللهِ
u'أَمْرٌ الْمَرْأَةُ':Added, #7: 7	أَمْرُ اللهِ
u'أَمْرٌ الْمَرْأَةُ':Added, #1: 1	أَمْرَ الْمَرْأَةِ
u'أَمْرٌ الْمَرْأَةُ':Added, #1: 1	أَمْرُ الْمَرْأَةِ
u'أَمَرَ المُشْتَرِي':Predicate, #1: 1	أَمْرِ الْمَرْأَةِ
u'أَمَرَ إلَهٌ':Subject, #2: 2	أَمَرَ الْمُشْتَرِيَ
u'أَمْرٌ إلَهٌ':Added, #1: 1	أَمَرَ الْإِلَهُ
u'أَمَرَ أُمٌّ':Predicate, #1: 1	أَمْرَ الْإِلَهِ
u'أَمَرَ إمَامٌ':Subject, #4: 4	أَمَرَ أُمَّ
u'أَمْرٌ إمَامٌ':Added, #12: 12	أَمَرَ الْإِمَامُ
u'أَمْرٌ إمَامٌ':Added, #11: 11	أَمْرِ الْإِمَامِ
u'أَمْرٌ إمَامٌ':Added, #1: 1	أَمْرِ الإِمَامِ
u'أَمْرٌ إمَامٌ':Added, #1: 1	أَمْر الْإِمَامِ
u'أَمْرٌ إمَامٌ':Added, #2: 2	أَمْرُ الْإِمَامِ
u'أَمْرٌ إمَامَةٌ':Added, #6: 6	أَمْرَ الْإِمَامِ
u'أَمْرٌ أمَانَةٌ':Added, #1: 1	أَمْرُ الْإِمَامَةِ
u'أَمَرَ أُمَّةٌ':Predicate, #1: 1	أَمْرَ الْأَمَانَةِ
u'أَمْرٌ أمَةٌ':Added, #1: 1	أَمَرَ الْأُمَّةَ
u'أَمْرٌ أُمَّةٌ':Added, #1: 1	أَمْرَ الْأَمَةِ
u'أَمْرٌ أُمَّةٌ':Added, #1: 1	أَمْرِ الْأُمَّةِ
u'أَمَرَ أَمْرٌ':Predicate, #1: 1	أَمْرَ أُمَّةِ
u'أَمْرٌ آمِرٌ':Added, #1: 1	أَمَرَ أَمْرَ
u'أَمْرٌ آمِرٌ':Added, #1: 1	أَمْر الْآمِرِ
u'أَمْرٌ آمِرٌ':Added, #3: 3	أَمْرِ الْآمِرِ
u'أَمَرَ اِمْرَأَةٌ':Predicate, #6: 6	أَمْرَ الْآمِرِ
u'أَمْرٌ اِمْرَأَةٌ':Added, #1: 1	أَمَرَ امْرَأَةَ
u'أَمْرٌ اِمْرَأَةٌ':Added, #1: 1	أَمْرَ امْرَأَةِ
u'أَمْرٌ اِمْرَأَةٌ':Added, #1: 1	أَمْرُ امْرَأَةٍ
u'أَمْرٌ أَمْوَالٌ':Added, #42: 42	أَمْرَ امْرَأَتِهِ
u'أَمَرَ أَميرٌ':Subject, #1: 1	أَمْرُ أَمْوَالِ
u'أَمَرَ أَميرٌ':Subject, #1: 1	أَمَرَ أَمِيرُ
u'أَمْرٌ أَميرٌ':Added, #5: 5	أَمَرَ الْأَمِيرُ
u'أَمْرٌ أَميرٌ':Added, #1: 1	أَمْرِ الْأَمِيرِ
u'أَمْرٌ إِنْذارٌ':Added, #2: 2	أَمْرَ الْأَمِيرِ
u'أَمَرَ إِنْسانٌ':Subject, #2: 2	أَمْرُ إنْذَارٍ
u'أَمْرٌ إِنْسانٌ':Added, #1: 1	أَمَرَ إنْسَانٌ
u'أَمْرٌ أنصار':Added, #1: 1	أَمْرُ الْإِنْسَانِ
u'أَمْرٌ أَنْصارٌ':Added, #1: 1	أَمْرُ الْأَنْصَارِ
u'أَمْرٌ أَنْصَارٌ':Added, #1: 1	أَمْرُ الْأَنْصَارِ
u'أَمَرَ أهْلٌ':Predicate, #1: 1	أَمْرُ الْأَنْصَارِ
u'أَمْرٌ أهْلٌ':Added, #3: 3	أَمَرَ أَهْلَ
u'أَمْرٌ أهْلٌ':Added, #1: 1	أَمْرَ أَهْلِ
u'أَمْرٌ أَهِلَّةٌ':Added, #3: 3	أَمْرِ أَهْلِ
u'أَمَرَ أَوْصِيَاءٌ':Predicate, #1: 1	أَمْرُ الْأَهِلَّةِ
u'أَمْرٌ أَوْقَافٌ':Added, #1: 1	أَمَرَ الْأَوْصِيَاءَ
u'أَمَرَ أَوَّلُ':Predicate, #1: 1	أَمْرَ الْأَوْقَافِ
u'أَمْرٌ أَوَّلُ':Added, #1: 1	أَمَرَ الْأَوَّلَ
u'أَمَرَ أَوْلِيَاءُ':Predicate, #1: 1	أَمْرَ الْأَوَّلِ
u'أَمْرٌ أَوْلِيَاءُ':Added, #1: 1	أَمَرَ الْأَوْلِيَاءَ
u'أَمْرٌ أئِمَّةٌ':Added, #3: 3	أَمْرِ الْأَوْلِيَاءِ
u'أَمْرٌ أئِمَّةٌ':Added, #1: 1	أَمْرَ الْأَئِمَّةِ
u'أَمْرٌ أئِمَّةٌ':Added, #1: 1	أَمْرُ الْأَئِمَّةِ
u'أَمْرٌ أيتام':Added, #1: 1	أَمْرِ الْأَئِمَّةِ
u'أَمْرٌ أيتام':Added, #1: 1	أَمْرَ الْأَيْتَامِ
u'أَمْرٌ إِيجَابٌ':Added, #2: 2	أَمْرِ الْأَيْتَامِ
u'أَمْرٌ إِيجَابٌ':Added, #1: 1	أَمْرَ الْإِيجَابِ
u'أَمْرٌ إِيجَابٌ':Added, #1: 1	أَمْرِ الْإِيجَابِ
u'أَمْرٌ إِيجَابٌ':Added, #1: 1	أَمْرِ إيجَابٍ
u'أَمْرٌ إِيجَابٌ':Added, #2: 2	أَمْرُ الْإِيجَابِ
u'أَمْرٌ إِيجَابٌ':Added, #5: 5	أَمْرُ إيجَابٍ
u'أَمْرٌ بَاطِلٌ':Added, #9: 9	أَمْرَ إيجَابٍ
u'أَمْرٌ بَاطن':Added, #1: 1	أَمْرٍ بَاطِلٍ
u'أَمْرٌ باطِنٌ':Added, #3: 3	أَمْرٍ بَاطِنٍ
u'أَمَرَ بالِغٌ':Subject, #3: 3	أَمْرٍ بَاطِنٍ
u'أَمَرَ بَائِعٌ':Predicate, #1: 1	أَمَرَ بَالِغٌ
u'أَمَرَ بَائِعٌ':Subject, #10: 10	أَمَرَ الْبَائِعَ
u'أَمْرٌ بَائِعٌ':Added, #5: 5	أَمَرَ الْبَائِعُ
u'أَمْرٌ بَائِعٌ':Added, #1: 1	أَمْرُ الْبَائِعِ
u'أَمْرٌ بَدْرٌ':Added, #1: 1	أَمْرِ الْبَائِعِ
u'أَمْرٌ بِدَعٌ':Added, #1: 1	أَمْرُ بَدْرٍ
u'أَمْرٌ بَدَلٌ':Added, #1: 1	أَمْرَ الْبِدَعِ
u'أَمَرَ بَعْضٌ':Predicate, #1: 1	أَمْرِ الْبَدَلِ
u'أَمَرَ بَعْضٌ':Subject, #7: 7	أَمَرَ بَعْضَ
u'أَمْرٌ بَقِيَّةٌ':Added, #1: 1	أَمَرَ بَعْضُ
u'أَمْرٌ بَيْتٌ':Added, #1: 1	أَمْرِ بَقِيَّةِ
u'أَمْرٌ بَيْتٌ':Added, #1: 1	أَمْرَ الْبَيْتِ
u'أَمْرٌ بَيْتٌ':Added, #1: 1	أَمْرِ الْبَيْتِ
u'أَمْرٌ بَيِّنٌ':Added, #1: 1	أَمْرَ بَيْتِ
u'أَمْرٌ بَيِّنَةٌ':Added, #3: 3	أَمْرٍ بَيِّنٍ
u'أَمْرٌ تَابِعٌ':Added, #1: 1	أَمْرُ الْبَيِّنَاتِ
u'أَمْرٌ تَأْدِيبٌ':Added, #4: 4	أَمْرٍ تَابِعٍ
u'أَمْرٌ تَبْلِيغٌ':Added, #1: 1	أَمْرِ التَّأْدِيبِ
u'أَمْرٌ تَبْلِيغٌ':Added, #1: 1	أَمْرُ التَّبْلِيغِ
u'أَمْرٌ تِجَارَةٌ':Added, #1: 1	أَمْرِ التَّبْلِيغِ
u'أَمْرٌ تَحْرِيمٌ':Added, #1: 1	أَمْرِ تِجَارَتِهِ
u'أَمْرٌ تَحْصِيلٌ':Added, #1: 1	أَمْرِ التَّحْرِيمِ
u'أَمْرٌ تَحْوِيلٌ':Added, #1: 1	أَمْرِ تَحْصِيلِ
u'أَمْرٌ تَخْمِينٌ':Added, #1: 1	أَمْرَ تَحْوِيلٍ
u'أَمْرٌ تَخْيِيرٌ':Added, #1: 1	أَمْرُ تَخْمِينٍ
u'أَمْرٌ تَرْبِيَةٌ':Added, #1: 1	أَمْرُ تَخْيِيرٍ
u'أَمْرٌ تَرِكَةٌ':Added, #1: 1	أَمْرَ التَّرْبِيَةِ
u'أَمْرٌ تَرِكَةٌ':Added, #1: 1	أَمْرَ التَّرِكَةِ
u'أَمْرٌ تَزْكِيَةٌ':Added, #2: 2	أَمْرِ التَّرِكَةِ
u'أَمْرٌ تَسْلِيمٌ':Added, #1: 1	أَمْرَ التَّزْكِيَةِ
u'أَمْرٌ تَصْفِيقٌ':Added, #1: 1	أَمْرِ التَّسْلِيمِ
u'أَمْرٌ تَعْدِيلٌ':Added, #1: 1	أَمْرُ التَّصْفِيقِ
u'أَمْرٌ تَعْرِيفٌ':Added, #1: 1	أَمْرُ التَّعْدِيلِ
u'أَمْرٌ تَعْلِيمٌ':Added, #1: 1	أَمْرُ التَّعْرِيفِ
u'أَمْرٌ تَقَدُّمٌ':Added, #1: 1	أَمْرُ تَعْلِيمِ
u'أَمْرٌ تَقْويمٌ':Added, #1: 1	أَمْرِ التَّقَدُّمِ
u'أَمْرٌ تَمَلُّك':Added, #1: 1	أَمْرُ التَّقْوِيمِ
u'أَمْرٌ تَيَمُّمٌ':Added, #1: 1	أَمْرَ التَّمَلُّكِ
u'أَمَرَ ثَابِتٌ':Predicate, #1: 1	أَمْرُ التَّيَمُّمِ
u'أَمْرٌ ثَابِتٌ':Added, #1: 1	أَمَرَ ثَابِتَ
u'أَمْرٌ ثَالِثٌ':Added, #1: 1	أَمْرِ ثَابِتِ
u'أَمْرٌ ثَلاثُ':Added, #1: 1	أَمْرٍ ثَالِثٍ
u'أَمْرٌ ثَلاثَةٌ':Added, #2: 2	أَمْرُ ثَلَاثِ
u'أَمْرٌ ثَلاثَةٌ':Added, #1: 1	أَمْرُ الثّلَاثَةِ
u'أَمَرَ ثُمام':Predicate, #1: 1	أَمْرِ الثَّلَاثَةِ
u'أَمَرَ جَارِي':Predicate, #1: 1	أَمَرَ ثُمَامَةَ
u'أَمَرَ جَارِيَةٌ':Predicate, #1: 1	أَمَرَ الْجَارِيَةَ
u'أَمَّ رِجَالٌ':Predicate, #1: 1	أَمَرَ الْجَارِيَةَ
u'أَمَرَ جالِب':Predicate, #2: 2	أَمَّ الرِّجَالَ
u'أَمْرٌ جَامِعٌ':Added, #1: 1	أَمَرَ الْجَالِبَ
u'أَمْرٌ جَاهِلِيٌّ':Added, #6: 6	أَمْرٍ جَامِعٍ
u'أَمْرٌ جَاهِلِيٌّ':Added, #13: 13	أَمْرِ الْجَاهِلِيَّةِ
u'أَمْرٌ جَاهِلِيٌّ':Added, #1: 1	أَمْرَ الْجَاهِلِيَّةِ
u'أَمْرٌ جَاهِلِيٌّ':Added, #1: 1	أَمْرُ الْجَاهِلِيّةِ
u'أَمْرٌ جَاهِلِيٌّ':Added, #2: 2	أَمْرُ الْجَاهِلِيَّةِ
u'أَمْرٌ جَاهِلِيٌّ':Added, #3: 3	أَمْرِ الْجَاهِلِيّةِ
u'أَمْرٌ جَاهِلِيَّةٌ':Added, #4: 4	أَمْرَ الْجَاهِلِيّةِ
u'أَمْرٌ جَاهِلِيَّةٌ':Added, #13: 13	أَمْرِ الْجَاهِلِيَّةِ
u'أَمْرٌ جَاهِلِيَّةٌ':Added, #1: 1	أَمْرَ الْجَاهِلِيَّةِ
u'أَمْرٌ جَاهِلِيَّةٌ':Added, #1: 1	أَمْرُ الْجَاهِلِيّةِ
u'أَمْرٌ جَاهِلِيَّةٌ':Added, #2: 2	أَمْرُ الْجَاهِلِيَّةِ
u'أَمْرٌ جَاهِلِيَّةٌ':Added, #3: 3	أَمْرِ الْجَاهِلِيّةِ
u'أَمْرٌ جَائِزٌ':Added, #4: 4	أَمْرَ الْجَاهِلِيّةِ
u'أَمْرٌ جِبِلَّةٌ':Added, #1: 1	أَمْرٍ جَائِزٍ
u'أَمْرٌ جَدَلِيٌّ':Added, #1: 1	أَمْرُ الْجِبِلَّةِ
u'أَمْرٌ جَديدٌ':Added, #1: 1	أَمْرٍ جَدَلِيٍّ
u'أَمْرٌ جَرَادٌ':Added, #3: 3	أَمْرٍ جَدِيدٍ
u'أَمَّ رَجُلٌ':Subject, #1: 1	أَمْرِ الْجَرَادِ
u'أَمَّ رَجُلٌ':Subject, #3: 3	أَمَّ رَجُلٌ
u'أَمْرٌ جَلِيٌّ':Added, #5: 5	أَمَّ الرَّجُلُ
u'أَمْرٌ جَمَاعَةٌ':Added, #3: 3	أَمْرٍ جَلِيٍّ
u'أَمْرٌ جَمَاعَةٌ':Added, #2: 2	أَمْرِ الْجَمَاعَةِ
u'أَمْرٌ جمعة':Added, #2: 2	أَمْرُ جَمَاعَةٍ
u'أَمْرٌ جمعة':Added, #1: 1	أَمْرَ الْجُمُعَةِ
u'أَمْرٌ جُمُعَةٌ':Added, #1: 1	أَمْرُ الْجُمُعَةِ
u'أَمْرٌ جُمُعَةٌ':Added, #1: 1	أَمْرَ الْجُمُعَةِ
u'أَمْرٌ جُمْلَةٌ':Added, #1: 1	أَمْرُ الْجُمُعَةِ
u'أَمْرٌ جَنَابَةٌ':Added, #1: 1	أَمْرِ الْجُمْلَةِ
u'أَمْرٌ جِنَايَةٌ':Added, #2: 2	أَمْرِ الْجَنَابَةِ
u'أَمْرٌ جُنْدٌ':Added, #1: 1	أَمْرُ الْجِنَايَاتِ
u'أَمْرٌ جهاد':Added, #1: 1	أَمْرَ الْجُنْدِ
u'أَمْرٌ جهاد':Added, #1: 1	أَمْرَ الْجِهَادِ
u'أَمْرٌ جِهَادٌ':Added, #1: 1	أَمْرِ الْجِهَادِ
u'أَمْرٌ جِهَادٌ':Added, #1: 1	أَمْرَ الْجِهَادِ
u'أَمْرٌ جَوَابٌ':Added, #1: 1	أَمْرِ الْجِهَادِ
u'أَمْرٌ جَيْشٌ':Added, #1: 1	أَمْرُ جَوَابِهِ
u'أَمْرٌ جُيوشٌ':Added, #1: 1	أَمْرِ الْجَيْشِ
u'أَمْرٌ حاجٌّ':Added, #1: 1	أَمْرَ الْجُيُوشِ
u'أَمْرٌ حادِثٌ':Added, #1: 1	أَمْرِ الْحَاجِّ
u'أَمْرٌ حارِثٌ':Added, #1: 1	أَمْرٍ حَادِثٍ
u'أَمْرٌ حاضِرٌ':Added, #1: 1	أَمْرُ الْحَارِثِ
u'أَمَرَ حاكِمٌ':Subject, #1: 1	أَمْرِ الْحَاضِرِ
u'أَمْرٌ حاكِمٌ':Added, #4: 4	أَمَرَ الْحَاكِمُ
u'أَمْرٌ حالِيٌّ':Added, #5: 5	أَمْرِ الْحَاكِمِ
u'أَمْرٌ حائِضٌ':Added, #1: 1	أَمْرٍ حَالِيٍّ
u'أَمَرَ حَبَشَة':Predicate, #1: 1	أَمْرُ الْحَائِضِ
u'أَمْرٌ حَبَشَة':Added, #1: 1	أَمَرَ الْحَبَشَةَ
u'أَمْرٌ حَبَشَة':Added, #1: 1	أَمْرَ الْحَبَشَةِ
u'أَمْرٌ حَبَشَة':Added, #2: 2	أَمْرُ الْحَبَشَةِ
u'أَمْرٌ حَتْمٌ':Added, #4: 4	أَمْرِ الْحَبَشَةِ
u'أَمْرٌ حَجٌّ':Added, #1: 1	أَمْرُ حَتْمٍ
u'أَمْرٌ حَجٌّ':Added, #1: 1	أَمْرَ الْحَجِّ
u'أَمْرٌ حِجَامَةٌ':Added, #5: 5	أَمْرِ الْحَجِّ
u'أَمْرٌ حَدٌّ':Added, #1: 1	أَمْرَ الْحِجَامَةِ
u'أَمْرٌ حُدودٌ':Added, #3: 3	أَمْرَ الْحَدِّ
u'أَمْرٌ حَديثٌ':Added, #1: 1	أَمْرَ الْحُدُودِ
u'أَمَرَ حُرٌّ':Predicate, #1: 1	أَمْرِ الْحَدِيثِ
u'أَمَرَ حُرٌّ':Subject, #1: 1	أَمَرَ الْحُرَّ
u'أَمْرٌ حُرٌّ':Added, #2: 2	أَمَرَ الْحُرُّ
u'أَمْرٌ حَرْبٌ':Added, #1: 1	أَمْرُ الْحُرِّ
u'أَمْرٌ حَسَنٌ':Added, #5: 5	أَمْرِ الْحَرْبِ
u'أَمْرٌ حَسَنٌ':Added, #1: 1	أَمْرِ الْحَسَنِ
u'أَمْرٌ حِسِّيٌّ':Added, #1: 1	أَمْرٍ حَسَنٍ
u'أَمْرٌ حَفَظَةٌ':Added, #2: 2	أَمْرٍ حِسِّيٍّ
u'أَمْرٌ حُكَّامٌ':Added, #1: 1	أَمْر الْحَفَظَةِ
u'أَمَرَ حَكَمٌ':Predicate, #1: 1	أَمْرُ الْحُكَّامِ
u'أَمَرَ حَلالٌ':Subject, #1: 1	أَمَرَ حَكَمَ
u'أَمْرٌ حِمَارٌ':Added, #1: 1	أَمَرَ حَلَالٌ
u'أَمْرٌ حَيٌّ':Added, #1: 1	أَمْرِ الْحِمَارِ
u'أَمْرٌ حَيَّةٌ':Added, #1: 1	أَمْرِ الْحَيّةِ
u'أَمْرٌ حَيْضٌ':Added, #1: 1	أَمْرِ الْحَيّةِ
u'أَمْرٌ حَيْضٌ':Added, #1: 1	أَمْرِ الْحَيْضِ
u'أَمَرَ خَاتِنٌ':Predicate, #2: 2	أَمْرَ الْحَيْضِ
u'أَمْرٌ خَارِجٌ':Added, #1: 1	أَمَرَ خَاتِنَةً
u'أَمَرَ خَازِنٌ':Predicate, #10: 10	أَمْرٍ خَارِجٍ
u'أَمْرٌ خاصّ':Added, #1: 1	أَمَرَ خَازِنَ
u'أَمَرَ خَالِدٌ':Predicate, #5: 5	أَمْرٍ خَاصٍّ
u'أَمْرٌ خَالِقٌ':Added, #4: 4	أَمَرَ خَالِدَ
u'أَمْرٌ خامس':Added, #1: 1	أَمْرِ خَالِقِهِ
u'أَمْرٌ خَامِسٌ':Added, #1: 1	أَمْرٍ خَامِسٍ
u'أَمْرٌ خدم':Added, #1: 1	أَمْرٍ خَامِسٍ
u'أَمْرٌ خَدَمٌ':Added, #1: 1	أَمْرِ الْخَدَمِ
u'أَمْرٌ خدمة':Added, #1: 1	أَمْرِ الْخَدَمِ
u'أَمْرٌ خِدْمَةٌ':Added, #1: 1	أَمْرَ الْخِدْمَةِ
u'أَمْرٌ خدمة':Added, #1: 1	أَمْرَ الْخِدْمَةِ
u'أَمْرٌ خِدْمَةٌ':Added, #1: 1	أَمْرَ خِدْمَتِهِ
u'أَمْرٌ خُرُوجٌ':Added, #1: 1	أَمْرَ خِدْمَتِهِ
u'أَمْرٌ خُصُومَةٌ':Added, #1: 1	أَمْرَ الْخُرُوجِ
u'أَمْرٌ خِلاَفٌ':Added, #1: 1	أَمْرِ خُصُومَةٍ
u'أَمْرٌ خِلاَفَةٌ':Added, #1: 1	أَمْرُ الْخِلَافِ
u'أَمْرٌ خلق':Added, #1: 1	أَمْرَ الْخِلَافَةِ
u'أَمْرٌ خَلْقٌ':Added, #2: 2	أَمْرِ الْخَلْقِ
u'أَمْرٌ خَلِيفَةٌ':Added, #2: 2	أَمْرِ الْخَلْقِ
u'أَمْرٌ خَلِيفَةٌ':Added, #1: 1	أَمْرَ الْخَلِيفَةِ
u'أَمْرٌ خَمْرٌ':Added, #2: 2	أَمْرِ الْخَلِيفَةِ
u'أَمْرٌ خَنْدَقٌ':Added, #1: 1	أَمْرِ الْخَمْرِ
u'أَمْرٌ خَنْدَقٌ':Added, #1: 1	أَمْرُ الْخَنْدَقِ
u'أَمْرٌ خوارج':Added, #2: 2	أَمْرِ الْخَنْدَقِ
u'أَمْرٌ خَوَارِجُ':Added, #1: 1	أَمْرُ الْخَوَارِجِ
u'أَمْرٌ خَيْلٌ':Added, #1: 1	أَمْرُ الْخَوَارِجِ
u'أَمْرٌ دَاخِلٌ':Added, #1: 1	أَمْرَ الْخَيْلِ
u'أَمْرٌ دَافِعٌ':Added, #2: 2	أَمْرٍ دَاخِلٍ
u'أَمْرٌ دَافِعٌ':Added, #1: 1	أَمْرِ الدَّافِعِ
u'أَمْرٌ دَائِنٌ':Added, #2: 2	أَمْرُ الدَّافِعِ
u'أَمَرَ دَلٌّ':Predicate, #1: 1	أَمْرِ الدَّائِنِ
u'أَمْرٌ دَمٌ':Added, #1: 1	أَمَرَ دَلَّ
u'أَمْرٌ دِماءٌ':Added, #3: 3	أَمْرِ الدَّمِ
u'أَمْرٌ دِماءٌ':Added, #1: 1	أَمْرُ الدِّمَاءِ
u'أَمْرٌ دُنْيَوِيٌّ':Added, #2: 2	أَمْرِ الدِّمَاءِ
u'أَمَرَ دِهْقانٌ':Predicate, #9: 9	أَمْرٍ دُنْيَوِيٍّ
u'أَمَرَ دِهْقانٌ':Subject, #1: 1	أَمَرَ الدِّهْقَانَ
u'أَمْرٌ دُورٌ':Added, #1: 1	أَمَرَ الدِّهْقَانُ
u'أَمْرٌ دَوْس':Added, #1: 1	أَمْرُ الدُّورِ
u'أَمْرٌ دِيانَةٌ':Added, #1: 1	أَمْرُ دَوْسٍ
u'أَمْرٌ دِيَةٌ':Added, #1: 1	أَمْرِ الدِّيَانَةِ
u'أَمْرٌ دِينٌ':Added, #1: 1	أَمْرُ الدِّيَةِ
u'أَمْرٌ دِينٌ':Added, #1: 1	أَمْرَ الدِّينِ
u'أَمْرٌ دَيْنٌ':Added, #1: 1	أَمْرِ الدّينِ
u'أَمْرٌ دَيْنٌ':Added, #1: 1	أَمْرِ الدّينِ
u'أَمْرٌ دَيْنٌ':Added, #1: 1	أَمْرَ الدَّيْنِ
u'أَمْرٌ دِينٌ':Added, #1: 1	أَمْرِ الدَّيْنِ
u'أَمْرٌ دِينٌ':Added, #1: 1	أَمْرَ دِينِ
u'أَمْرٌ دِينٌ':Added, #1: 1	أَمْرُ دِينِهِ
u'أَمْرٌ دِينٌ':Added, #21: 21	أَمْرِ الدِّينِ
u'أَمْرٌ دِينِيٌّ':Added, #7: 7	أَمْرِ دِينِهِ
u'أَمْرٌ ذاتِيٌّ':Added, #9: 9	أَمْرٍ دِينِيٍّ
u'أَمَرَ ذِمِّيٌّ':Predicate, #1: 1	أَمْرٍ ذَاتِيٍّ
u'أَمَرَ ذِمِّيٌّ':Predicate, #1: 1	أَمَرَ الذِّمِّيَّةَ
u'أَمْرٌ ذِمِّيٌّ':Added, #2: 2	أَمَرَ الذِّمِّيَّ
u'أَمْرٌ ذَهَابٌ':Added, #1: 1	أَمْرِ الذِّمِّيِّ
u'أَمْرٌ رابع':Added, #1: 1	أَمْرُ ذَهَابِهِ
u'أَمْرٌ رَابِعٌ':Added, #1: 1	أَمْرٍ رَابِعٍ
u'أَمَرَ رَاكِبٌ':Predicate, #1: 1	أَمْرٍ رَابِعٍ
u'أَمْرٌ رَاهِبٌ':Added, #1: 1	أَمَرَ الرَّاكِبَ
u'أَمْرٌ رَاهِنٌ':Added, #2: 2	أَمْرُ الرَّاهِبِ
u'أَمَرَ رَبُّ':Predicate, #1: 1	أَمْرِ الرَّاهِنِ
u'أَمَرَ رَبُّ':Subject, #2: 2	أَمَرَ رَبَّ
u'أَمْرٌ رَبُّ':Added, #8: 8	أَمَرَ رَبُّ
u'أَمْرٌ رَبُّ':Added, #1: 1	أَمْرَ رَبِّهِ
u'أَمْرٌ رَبُّ':Added, #1: 1	أَمْرِ رَبِّهِ
u'أَمْرٌ رباط':Added, #3: 3	أَمْرِ رَبِّ
u'أَمْرٌ رِبَاطٌ':Added, #2: 2	أَمْرَ الرِّبَاطِ
u'أَمَرَ رَبِيعٌ':Predicate, #2: 2	أَمْرَ الرِّبَاطِ
u'أَمَرَ رَبِيعَةٌ':Predicate, #2: 2	أَمَرَ الرَّبِيعَ
u'أَمَرَ رِجَالٌ':Predicate, #1: 1	أَمَرَ رَبِيعَةَ
u'أَمَرَ رَجُلٌ':Predicate, #2: 2	أَمَرَ الرِّجَالَ
u'أَمَرَ رَجُلٌ':Subject, #10: 10	أَمَرَ رَجُلاً
u'أَمَرَ رَجُلٌ':Subject, #10: 10	أَمَرَ رَجُلٌ
u'أَمْرٌ رَجُلٌ':Added, #5: 5	أَمَرَ الرَّجُلُ
u'أَمْرٌ رَجُلٌ':Added, #1: 1	أَمْرِ الرّجُلِ
u'أَمْرٌ رَجُلٌ':Added, #1: 1	أَمْرُ رَجُلٍ
u'أَمْرٌ رَجُلٌ':Added, #1: 1	أَمْرِ رَجُلٍ
u'أَمْرٌ رَجُلٌ':Added, #2: 2	أَمْرُ الرَّجُلِ
u'أَمْرٌ رِدَّةٌ':Added, #2: 2	أَمْرِ الرَّجُلِ
u'أَمْرٌ رِسَالَةٌ':Added, #2: 2	أَمْرِ الرِّدَّةِ
u'أَمَرَ رَسُولٌ':Predicate, #1: 1	أَمْرَ الرِّسَالَةِ
u'أَمَرَ رَسُولٌ':Predicate, #1: 1	أَمَرَ الرَّسُولَ
u'أَمَرَ رَسُولٌ':Subject, #1: 1	أَمَرَ رَسُولَ
u'أَمَرَ رَسُولٌ':Subject, #119: 119	أَمَرَ رَسُولُ
u'أَمَرَ رَسُولٌ':Subject, #1: 1	أَمَرَ الرَّسُولُ
u'أَمَّرَ رَسُولٌ':Subject, #2: 2	أَمَرَ الرّسُولُ
u'أَمْرٌ رَسُولٌ':Added, #3: 3	أَمَّرَ رَسُولُ
u'أَمْرٌ رَسُولٌ':Added, #12: 12	أَمْرِ رَسُولِ
u'أَمْرٌ رَسُولٌ':Added, #1: 1	أَمْرُ الرّسُولِ
u'أَمْرٌ رَسُولٌ':Added, #1: 1	أَمْرِ الرّسُولِ
u'أَمْرٌ رَسُولٌ':Added, #1: 1	أَمْرِ رَسُولِهِ
u'أَمْرٌ رَسُولٌ':Added, #5: 5	أَمْرَ رَسُولِ
u'أَمْرٌ رضاع':Added, #7: 7	أَمْرُ رَسُولِ
u'أَمْرٌ رضاع':Added, #1: 1	أَمْرُ الرَّضَاعِ
u'أَمْرٌ رِفادَةٌ':Added, #1: 1	أَمْرِ الرَّضَاعِ
u'أَمْرٌ رِفادَةٌ':Added, #1: 1	أَمْرَ الرّفَادَةِ
u'أَمْرٌ رِقٌّ':Added, #1: 1	أَمْرِ الرّفَادَةِ
u'أَمْرٌ رُكْنٌ':Added, #1: 1	أَمْرَ الرِّقِّ
u'أَمْرٌ رُكْن':Added, #1: 1	أَمْرِ الرّكْنِ
u'أَمَرَ رَهْطٌ':Predicate, #1: 1	أَمْرِ الرّكْنِ
u'أَمْرٌ روحٌ':Added, #1: 1	أَمَرَ الرَّهْطَ
u'أَمْرٌ رَوْحٌ':Added, #1: 1	أَمْرِ الرّوحِ
u'أَمْرٌ زادٌ':Added, #1: 1	أَمْرِ الرّوحِ
u'أَمْرٌ زانِي':Added, #1: 1	أَمْرِ الزَّادِ
u'أَمْرٌ زائِدٌ':Added, #1: 1	أَمْرَ الزَّانِيَيْنِ
u'أَمْرٌ زَكاةٌ':Added, #9: 9	أَمْرٍ زَائِدٍ
u'أَمْرٌ زَكاةٌ':Added, #1: 1	أَمْرَ الزَّكَاةِ
u'أَمْرٌ زَوالٌ':Added, #1: 1	أَمْرُ الزَّكَاةِ
u'أَمَرَ زَوْجٌ':Predicate, #1: 1	أَمْرِ الزَّوَالِ
u'أَمْرٌ زَوْجٌ':Added, #3: 3	أَمَرَ الزَّوْجَ
u'أَمْرٌ زَوْجٌ':Added, #1: 1	أَمْرُ الزَّوْجِ
u'أَمْرٌ زَوْجَةٌ':Added, #3: 3	أَمْرِ الزَّوْجِ
u'أَمَرَ زَيْدٌ':Predicate, #1: 1	أَمْرَ الزَّوْجَةِ
u'أَمْرٌ زَيْدٌ':Added, #1: 1	أَمَرَ زَيْدَ
u'أَمْرٌ زَيْدٌ':Added, #1: 1	أَمْرُ زَيْدٍ
u'أَمْرٌ سَاحِرٌ':Added, #2: 2	أَمْرِ زَيْدٍ
u'أَمْرٌ سَارِقٌ':Added, #2: 2	أَمْرِ السَّاحِرِ
u'أَمْرٌ سَاعَةٌ':Added, #1: 1	أَمْرِ السَّارِقِ
u'أَمْرٌ سَاعَةٌ':Added, #1: 1	أَمْرَ السَّاعَةِ
u'أَمْرٌ سَاعَةٌ':Added, #1: 1	أَمْرُ السَّاعَةِ
u'أَمْرٌ سِحْرٌ':Added, #1: 1	أَمْرِ السَّاعَةِ
u'أَمْرٌ سَرَائِرُ':Added, #1: 1	أَمْرِ السِّحْرِ
u'أَمْرٌ سُرُورٌ':Added, #1: 1	أَمْرَ السَّرَائِرِ
u'أَمْرٌ سِعَايَةٌ':Added, #1: 1	أَمْرُ سُرُورٍ
u'أَمْرٌ سَعْدٌ':Added, #2: 2	أَمْرَ السِّعَايَةِ
u'أَمْرٌ سَفَالَةٌ':Added, #1: 1	أَمْرِ سَعْدٍ
u'أَمْرٌ سَفَرٌ':Added, #1: 1	أَمْرُ السّفَالَةِ
u'أَمْرٌ سِقَايَةٌ':Added, #1: 1	أَمْرِ السَّفَرِ
u'أَمْرٌ سَقِيفَةٌ':Added, #1: 1	أَمْرَ السِّقَايَةِ
u'أَمَرَّ سِكِّينٌ':Predicate, #1: 1	أَمْرُ سَقِيفَةِ
u'أَمَرَ سُلْطَانٌ':Subject, #4: 4	أَمَرَّ السِّكِّينَ
u'أَمْرٌ سُلْطَانٌ':Added, #9: 9	أَمَرَ السُّلْطَانُ
u'أَمْرٌ سُلْطَانٌ':Added, #1: 1	أَمْر السُّلْطَانِ
u'أَمْرٌ سُلْطَانٌ':Added, #1: 1	أَمْرَ السُّلْطَانِ
u'أَمْرٌ سُلْطَانٌ':Added, #6: 6	أَمْرُ السُّلْطَانِ
u'أَمْرٌ سِلْعَةٌ':Added, #9: 9	أَمْرِ السُّلْطَانِ
u'أَمْرٌ سَلَفٌ':Added, #4: 4	أَمْرِ سِلْعَتِهِ
u'أَمَرَ سلمة':Predicate, #1: 1	أَمْرُ السَّلَفِ
u'أَمَّرَ سُنَّةٌ':Predicate, #1: 1	أَمَرَ سَلَمَةَ
u'أَمْرٌ سُنَّةٌ':Added, #1: 1	أَمَّرَ السُّنَّةَ
u'أَمْرٌ سَهْلٌ':Added, #1: 1	أَمْرِ السُّنَّةِ
u'أَمْرٌ سُهَيْلٌ':Added, #1: 1	أَمْرِ سَهْلِ
u'أَمَّ رَسُولٌ':Predicate, #1: 1	أَمْرُ سُهَيْلِ
u'أَمَرَ سَيِّدٌ':Subject, #1: 1	أَمَّ رَسُولَ
u'أَمْرٌ سَيِّدٌ':Added, #3: 3	أَمَرَ السَّيِّدُ
u'أَمْرٌ سَيِّدٌ':Added, #1: 1	أَمْرُ السَّيِّدِ
u'أَمْرٌ سَيِّدٌ':Added, #1: 1	أَمْرَ سَيِّدِهِ
u'أَمْرٌ سَيِّدٌ':Added, #2: 2	أَمْرَ السَّيِّدِ
u'أَمْرٌ سَيْرٌ':Added, #6: 6	أَمْرِ السَّيِّدِ
u'أَمَرَ شَارِعٌ':Subject, #1: 1	أَمْرِ السَّيْرِ
u'أَمْرٌ شَارِعٌ':Added, #6: 6	أَمَرَ الشَّارِعُ
u'أَمْرٌ شَارِعٌ':Added, #10: 10	أَمْرِ الشَّارِعِ
u'أَمْرٌ شَارِعٌ':Added, #1: 1	أَمْرُ الشَّارِعِ
u'أَمَرَ شافِعِيّ':Subject, #5: 5	أَمْرَ الشَّارِعِ
u'أَمْرٌ شَاقٌّ':Added, #1: 1	أَمَرَ الشَّافِعِيُّ
u'أَمْرٌ شَاهِدٌ':Added, #1: 1	أَمْرٍ شَاقٍّ
u'أَمْرٌ شُبْهَةٌ':Added, #1: 1	أَمْرِ الشَّاهِدَيْنِ
u'أَمْرٌ شَتٌّ':Added, #1: 1	أَمْرِ الشُّبْهَةِ
u'أَمْرٌ شَخْصٌ':Added, #1: 1	أَمْرٍ شَتٍّ
u'أَمْرٌ شَدِيدٌ':Added, #1: 1	أَمْرِ الشَّخْصِ
u'أَمْرٌ شرب':Added, #1: 1	أَمْرَ الشَّدِيدَةِ
u'أَمْرٌ شُرْبٌ':Added, #1: 1	أَمْرِ شُرْبِ
u'أَمَرَ شَرْعٌ':Subject, #1: 1	أَمْرِ شُرْبِ
u'أَمْرٌ شَرْعٌ':Added, #5: 5	أَمَرَ الشَّرْعُ
u'أَمْرٌ شَرْعٌ':Added, #2: 2	أَمْرُ الشَّرْعِ
u'أَمْرٌ شَرْعٌ':Added, #4: 4	أَمْرَ الشَّرْعِ
u'أَمْرٌ شَرْعِيٌّ':Added, #5: 5	أَمْرِ الشَّرْعِ
u'أَمْرٌ شركاء':Added, #3: 3	أَمْرٍ شَرْعِيٍّ
u'أَمْرٌ شركة':Added, #1: 1	أَمْرِ الشُّرَكَاءِ
u'أَمْرٌ شركة':Added, #1: 1	أَمْرَ الشَّرِكَةِ
u'أَمْرٌ شركة':Added, #1: 1	أَمْرَ الشِّرْكَةِ
u'أَمْرٌ شَرِكَةٌ':Added, #1: 1	أَمْرِ الشَّرِكَةِ
u'أَمْرٌ شَرِكَةٌ':Added, #1: 1	أَمْرَ الشَّرِكَةِ
u'أَمْرٌ شِرْكَةٌ':Added, #1: 1	أَمْرِ الشَّرِكَةِ
u'أَمَرَ شَرِيكٌ':Subject, #1: 1	أَمْرَ الشِّرْكَةِ
u'أَمْرٌ شَرِيكٌ':Added, #1: 1	أَمَرَ الشَّرِيكُ
u'أَمْرٌ شَرِيكٌ':Added, #1: 1	أَمْرِ الشَّرِيكِ
u'أَمْرٌ شفعة':Added, #1: 1	أَمْرِ شَرِيكِهِ
u'أَمْرٌ شُفْعَةٌ':Added, #1: 1	أَمْرُ الشُّفْعَةِ
u'أَمْرٌ شمس':Added, #1: 1	أَمْرُ الشُّفْعَةِ
u'أَمْرٌ شَمْسٌ':Added, #1: 1	أَمْرِ الشَّمْسِ
u'أَمْرٌ شَهَادَةٌ':Added, #1: 1	أَمْرِ الشَّمْسِ
u'أَمْرٌ شُهُودٌ':Added, #1: 1	أَمْرَ الشَّهَادَةِ
u'أَمْرٌ شَيَاطِينُ':Added, #1: 1	أَمْرِ الشُّهُودِ
u'أَمَرَ صَاحِبٌ':Predicate, #1: 1	أَمْرُ الشّيَاطِينِ
u'أَمَرَ صَاحِبٌ':Subject, #2: 2	أَمَرَ صَاحِبَ
u'أَمْرٌ صَاحِبٌ':Added, #3: 3	أَمَرَ صَاحِبُ
u'أَمْرٌ صَاحِبٌ':Added, #17: 17	أَمْرِ صَاحِبِهِ
u'أَمْرٌ صَاحِبٌ':Added, #1: 1	أَمْر صَاحِبِهِ
u'أَمَرَ صَبِيٌّ':Subject, #4: 4	أَمْرِ صَاحِبِ
u'أَمَرَ صَبِيٌّ':Subject, #1: 1	أَمَرَ صَبِيٌّ
u'أَمْرٌ صَبِيٌّ':Added, #2: 2	أَمَرَ الصَّبِيُّ
u'أَمْرٌ صَحَابَةٌ':Added, #3: 3	أَمْرَ الصَّبِيِّ
u'أَمْرٌ صَحِيفَةٌ':Added, #1: 1	أَمْرَ الصَّحَابَةِ
u'أَمْرٌ صدقة':Added, #1: 1	أَمْرِ الصّحِيفَةِ
u'أَمْرٌ صَدَقَةٌ':Added, #1: 1	أَمْرِ الصّدَقَةِ
u'أَمْرٌ صدقة':Added, #1: 1	أَمْرِ الصّدَقَةِ
u'أَمْرٌ صَدَقَةٌ':Added, #2: 2	أَمْرِ الصَّدَقَةِ
u'أَمْرٌ صَرْفٌ':Added, #2: 2	أَمْرِ الصَّدَقَةِ
u'أَمْرٌ صَرْف':Added, #2: 2	أَمْرِ الصَّرْفِ
u'أَمْرٌ صَعْبٌ':Added, #2: 2	أَمْرِ الصَّرْفِ
u'أَمْرٌ صَلاَةٌ':Added, #1: 1	أَمْرٍ صَعْبٍ
u'أَمْرٌ صَلاَةٌ':Added, #1: 1	أَمْرِ الصَّلاةِ
u'أَمْرٌ صَلاَةٌ':Added, #1: 1	أَمْرَ الصَّلَاةِ
u'أَمْرٌ صَلاَةٌ':Added, #1: 1	أَمْرُ الصَّلَاةِ
u'أَمْرٌ صَلاَةٌ':Added, #1: 1	أَمْرِ صَلَاةِ
u'أَمْرٌ صَلاَةٌ':Added, #1: 1	أَمْرَ صَلَاتِهِ
u'أَمْرٌ صَوَابٌ':Added, #3: 3	أَمْرِ الصَّلَاةِ
u'أَمْرٌ صُوفٌ':Added, #1: 1	أَمْرِ الصّوَابِ
u'أَمْرٌ ضِدٌّ':Added, #1: 1	أَمْرِ الصُّوفِ
u'أَمْرٌ ضَرْبٌ':Added, #1: 1	أَمْرِ الضِّدَّيْنِ
u'أَمْرٌ ضَرُورِيٌّ':Added, #1: 1	أَمْرِ الضَّرْبِ
u'أَمْرٌ ضلال':Added, #1: 1	أَمْرٍ ضَرُورِيٍّ
u'أَمْرٌ ضَلاَلٌ':Added, #1: 1	أَمْرِ الضّلَالِ
u'أَمْرٌ طَارِئٌ':Added, #1: 1	أَمْرِ الضّلَالِ
u'أَمْرٌ طَاعَةٌ':Added, #1: 1	أَمْرٍ طَارِئٍ
u'أَمَرَ طَائِفٌ':Subject, #1: 1	أَمْرِ طَاعَةٍ
u'أَمْرٌ طعام':Added, #1: 1	أَمَرَ طَائِفَةٌ
u'أَمْرٌ طَعَامٌ':Added, #1: 1	أَمْرُ الطَّعَامِ
u'أَمْرٌ طعام':Added, #1: 1	أَمْرُ الطَّعَامِ
u'أَمْرٌ طَعَامٌ':Added, #2: 2	أَمْرِ الطَّعَامِ
u'أَمْرٌ طِفْلٌ':Added, #2: 2	أَمْرِ الطَّعَامِ
u'أَمْرٌ طَلاَقٌ':Added, #2: 2	أَمْرِ الطِّفْلِ
u'أَمْرٌ طَلاَقٌ':Added, #1: 1	أَمْرَ الطَّلاَقِ
u'أَمْرٌ طَهَارَةٌ':Added, #1: 1	أَمْرِ الطَّلاَقِ
u'أَمْرٌ طَهَارَةٌ':Added, #1: 1	أَمْرِ الطَّهَارَةِ
u'أَمَرَ ظالِمٌ':Subject, #2: 2	أَمْرَ الطَّهَارَةِ
u'أَمْرٌ ظاهِرٌ':Added, #1: 1	أَمَرَ الظَّالِمُ
u'أَمْرٌ عَادِيٌّ':Added, #4: 4	أَمْرٍ ظَاهِرٍ
u'أَمْرٌ عَارِضٌ':Added, #3: 3	أَمْرٍ عَادِيٍّ
u'أَمَرَ عَاصِمٌ':Predicate, #1: 1	أَمْرٍ عَارِضٍ
u'أَمْرٌ عَامٌّ':Added, #3: 3	أَمَرَ عَاصِمَ
u'أَمْرٌ عَامٌّ':Added, #1: 1	أَمْرِ الْعَامَّةِ
u'أَمْرٌ عَامٌّ':Added, #1: 1	أَمْرٍ عَامٍّ
u'أَمْرٌ عَامٌّ':Added, #3: 3	أَمْرَ الْعَامَّةِ
u'أَمَرَ عَامِرٌ':Predicate, #3: 3	أَمْرُ الْعَامَّةِ
u'أَمْرٌ عَامِرٌ':Added, #1: 1	أَمَرَ عَامِرَ
u'أَمَرَ عَامِلٌ':Predicate, #1: 1	أَمْرُ عَامِرِ
u'أَمْرٌ عَامِلٌ':Added, #2: 2	أَمَرَ عَامِلَ
u'أَمْرٌ عَامِلٌ':Added, #2: 2	أَمْرَ الْعَامِلِ
u'أَمَرَ عَائِشٌ':Predicate, #3: 3	أَمْرِ الْعَامِلِ
u'أَمْرٌ عِبَادَةٌ':Added, #2: 2	أَمَرَ عَائِشَةَ
u'أَمَرَ عَبَّاسٌ':Predicate, #2: 2	أَمْرِ الْعِبَادَةِ
u'أَمَرَ عَبْدٌ':Predicate, #1: 1	أَمَرَ الْعَبَّاسَ
u'أَمَرَ عَبْدٌ':Predicate, #2: 2	أَمَرَ الْعَبْدَ
u'أَمَرَ عَبْدٌ':Subject, #8: 8	أَمَرَ عَبْدَ
u'أَمْرٌ عَبْدٌ':Added, #2: 2	أَمَرَ الْعَبْدُ
u'أَمْرٌ عَبْدٌ':Added, #1: 1	أَمْرُ الْعَبْدِ
u'أَمْرٌ عَبْدٌ':Added, #1: 1	أَمْرِ عَبْدِهِ
u'أَمْرٌ عَبْدٌ':Added, #2: 2	أَمْرُ عَبْدِ
u'أَمْرٌ عِدَّةٌ':Added, #2: 2	أَمْرَ عَبْدِهِ
u'أَمْرٌ عِدَّةٌ':Added, #1: 1	أَمْرَ الْعِدَّةِ
u'أَمْرٌ عِدَّةٌ':Added, #1: 1	أَمْرُ الْعِدَّةِ
u'أَمْرٌ عَدْلٌ':Added, #6: 6	أَمْرِ الْعِدَّةِ
u'أَمْرٌ عَدُوٌّ':Added, #1: 1	أَمْرِ الْعَدْلِ
u'أَمْرٌ عَرَبٌ':Added, #1: 1	أَمْرَ الْعَدُوِّ
u'أَمْرٌ عَزِيزٌ':Added, #2: 2	أَمْرُ الْعَرَبِ
u'أَمْرٌ عَظِيم':Added, #1: 1	أَمْرُ الْعَزِيزِ
u'أَمْرٌ عقبة':Added, #7: 7	أَمْرٍ عَظِيمٍ
u'أَمْرٌ عَقَبَةٌ':Added, #1: 1	أَمْرُ الْعَقَبَةِ
u'أَمْرٌ عُقُولٌ':Added, #1: 1	أَمْرُ الْعَقَبَةِ
u'أَمْرٌ عُلُوقٌ':Added, #1: 1	أَمْرُ الْعُقُولِ
u'أَمَرَ عَلِيٌّ':Subject, #2: 2	أَمْرِ الْعُلُوقِ
u'أَمْرٌ عَلِيٌّ':Added, #4: 4	أَمَرَ عَلِيٌّ
u'أَمْرٌ عَمٌّ':Added, #1: 1	أَمْرِ عَلِيٍّ
u'أَمَرَ عُمَرٌ':Predicate, #2: 2	أَمْرِ عَمّهِ
u'أَمَرَ عُمَرٌ':Subject, #7: 7	أَمَرَ عُمَرَ
u'أَمَرَ عُمُرٌ':Subject, #13: 13	أَمَرَ عُمَرُ
u'أَمَرَ عَنْكَبُوتٌ':Predicate, #1: 1	أَمَرَ عُمُرُ
u'أَمْرٌ عَوَامُّ':Added, #1: 1	أَمَرَ الْعَنْكَبُوتَ
u'أَمَرَ عَوان':Predicate, #1: 1	أَمْرَ الْعَوَامِّ
u'أَمَرَ غَاصِبٌ':Predicate, #1: 1	أَمَرَ الْعَوَانَ
u'أَمَرَ غَاصِبٌ':Subject, #1: 1	أَمَرَ الْغَاصِبَ
u'أَمْرٌ غَاصِبٌ':Added, #1: 1	أَمَرَ الْغَاصِبُ
u'أَمْرٌ غَالِبٌ':Added, #1: 1	أَمْرِ الْغَاصِبِ
u'أَمْرٌ غَامِضٌ':Added, #1: 1	أَمْرٍ غَالِبٍ
u'أَمَرَ غَائِبٌ':Predicate, #1: 1	أَمْرٍ غَامِضٍ
u'أَمْرٌ غَائِبٌ':Added, #1: 1	أَمَرَ الْغَائِبَ
u'أَمْرٌ غَائِبٌ':Added, #1: 1	أَمْرَ الْغَائِبِ
u'أَمْرٌ غَرُورٌ':Added, #1: 1	أَمْرُ الْغَائِبِ
u'أَمَرَ غَرِيمٌ':Predicate, #1: 1	أَمْرَ الْغَرُورِ
u'أَمْرٌ غَرِيمٌ':Added, #1: 1	أَمَرَ الْغَرِيمَ
u'أَمْرٌ غِشٌّ':Added, #1: 1	أَمْرِ غَرِيمِهِ
u'أَمَرَ غُلاَمٌ':Predicate, #1: 1	أَمْرَ الْغِشِّ
u'أَمْرٌ غَمُوس':Added, #1: 1	أَمَرَ الْغُلَامَ
u'أَمْرٌ غَنَائِمُ':Added, #1: 1	أَمْرُ الْغَمُوسِ
u'أَمْرٌ غَنَائِمُ':Added, #1: 1	أَمْرَ الْغَنَائِمِ
u'أَمْرٌ غَنَمٌ':Added, #1: 1	أَمْرِ الْغَنَائِمِ
u'أَمْرٌ غُوَاةٌ':Added, #1: 1	أَمْرَ الْغَنَمِ
u'أَمْرٌ غَيْبٌ':Added, #1: 1	أَمْرُ الْغُوَاةِ
u'أَمْرٌ غِيبَةٌ':Added, #1: 1	أَمْرَ غَيْبٍ
u'أَمَرَ غير':Predicate, #1: 1	أَمْرِ الْغِيبَةِ
u'أَمَرَ غَيْرٌ':Predicate, #1: 1	أَمَرَ غَيْرَ
u'أَمَرَ غير':Subject, #1: 1	أَمَرَ غَيْرَ
u'أَمَرَ غَيْرٌ':Subject, #1: 1	أَمَرَ غَيْرُ
u'أَمْرٌ غير':Added, #1: 1	أَمَرَ غَيْرُ
u'أَمْرٌ غَيْرٌ':Added, #1: 1	أَمْرُ غَيْرِهِ
u'أَمْرٌ غير':Added, #1: 1	أَمْرُ غَيْرِهِ
u'أَمْرٌ غير':Added, #2: 2	أَمْرَ غَيْرِهِ
u'أَمْرٌ غَيْرٌ':Added, #2: 2	أَمْرِ غَيْرِهِ
u'أَمْرٌ غَيْرٌ':Added, #2: 2	أَمْرَ غَيْرِهِ
u'أَمْرٌ غَيْرَةٌ':Added, #2: 2	أَمْرِ غَيْرِهِ
u'أَمَرَ فَاطِمٌ':Predicate, #1: 1	أَمْرَ الْغَيْرَةِ
u'أَمْرٌ فَتْحٌ':Added, #6: 6	أَمَرَ فَاطِمَةَ
u'أَمْرٌ فتنة':Added, #1: 1	أَمْرَ الْفَتْحِ
u'أَمْرٌ فِتْنَةٌ':Added, #1: 1	أَمْرِ الْفِتْنَةِ
u'أَمْرٌ فتنة':Added, #1: 1	أَمْرِ الْفِتْنَةِ
u'أَمْرٌ فِتْنَةٌ':Added, #2: 2	أَمْرُ الْفِتْنَةِ
u'أَمْرٌ فِتْيَةٌ':Added, #2: 2	أَمْرُ الْفِتْنَةِ
u'أَمْرٌ فِدَاءٌ':Added, #2: 2	أَمْرِ الْفِتْيَةِ
u'أَمْرٌ فَرْجٌ':Added, #1: 1	أَمْرِ الْفِدَاءِ
u'أَمَرَ فَرَزْدَقٌ':Predicate, #1: 1	أَمْرِ الْفَرْجِ
u'أَمْرٌ فَرْضٌ':Added, #1: 1	أَمَرَ الْفَرَزْدَقَ
u'أَمْرٌ فُرْقَةٌ':Added, #1: 1	أَمْرُ فَرْضٍ
u'أَمْرٌ فَرِيقٌ':Added, #1: 1	أَمْرِ فُرْقَةِ
u'أَمَرَ فلان':Predicate, #1: 1	أَمْرَ الْفَرِيقَيْنِ
u'أَمَرَ فلان':Predicate, #13: 13	أَمَرَ بِلاَلاً
u'أَمَرَ فلان':Predicate, #1: 1	أَمَرَ الزّبَيْرَ
u'أَمَرَ فلان':Predicate, #1: 1	أَمَرَ الزُّبَيْرَ
u'أَمَرَ فلان':Predicate, #1: 1	أَمَرَ مُعَاوِيَةَ
u'أَمَرَ فلان':Subject, #2: 2	أَمَرَ الْمِقْدَادَ
u'أَمَرَ فلان':Subject, #1: 1	أَمَرَ الشَّافِعِيُّ
u'أَمْرٌ فلان':Added, #6: 6	أَمَرَ عُثْمَانُ
u'أَمْرٌ فَوْرٌ':Added, #1: 1	أَمْرُ عَوْفِ
u'أَمْرٌ فَوْرٌ':Added, #1: 1	أَمْرَ الْفَوْرِ
u'أَمْرٌ فِيلٌ':Added, #2: 2	أَمْرِ الْفَوْرِ
u'أَمْرٌ قَائِلٌ':Added, #1: 1	أَمْرُ الْفِيلِ
u'أَمْرٌ قَائِمٌ':Added, #1: 1	أَمْرَ الْقَائِلِ
u'أَمْرٌ قِبْلَةٌ':Added, #2: 2	أَمْرٍ قَائِمٍ
u'أَمْرٌ قِبْلَةٌ':Added, #1: 1	أَمْرَ الْقِبْلَةِ
u'أَمْرٌ قتل':Added, #7: 7	أَمْرِ الْقِبْلَةِ
u'أَمْرٌ قَتْلٌ':Added, #1: 1	أَمْرِ الْقَتْلِ
u'أَمْرٌ قَتِيلٌ':Added, #1: 1	أَمْرِ الْقَتْلِ
u'أَمْرٌ قِرَاءةٌ':Added, #2: 2	أَمْرُ الْقَتِيلِ
u'أَمْرٌ قِرَانٌ':Added, #1: 1	أَمْرِ الْقِرَاءَةِ
u'أَمْرٌ قُرَيْشٌ':Added, #1: 1	أَمْرُ الْقِرَانِ
u'أَمْرٌ قَسام':Added, #2: 2	أَمْرَ قُرَيْشٍ
u'أَمْرٌ قَسامَة':Added, #1: 1	أَمْرِ الْقَسَامَةِ
u'أَمْرٌ قسمة':Added, #1: 1	أَمْرِ الْقَسَامَةِ
u'أَمْرٌ قِسْمَةٌ':Added, #1: 1	أَمْرُ الْقِسْمَةِ
u'أَمْرٌ قسمة':Added, #1: 1	أَمْرُ الْقِسْمَةِ
u'أَمْرٌ قِسْمَةٌ':Added, #1: 1	أَمْرُ قِسْمَةِ
u'أَمْرٌ قصاص':Added, #1: 1	أَمْرُ قِسْمَةِ
u'أَمْرٌ قِصَاصٌ':Added, #1: 1	أَمْرِ الْقِصَاصِ
u'أَمْرٌ قَضَاءٌ':Added, #1: 1	أَمْرِ الْقِصَاصِ
u'أَمْرٌ قَضَاءٌ':Added, #2: 2	أَمْرَ الْقَضَاءِ
u'أَمْرٌ قول':Added, #3: 3	أَمْرِ الْقَضَاءِ
u'أَمْرٌ قَوْلٌ':Added, #1: 1	أَمْرُ قَوْلِ
u'أَمْرٌ قَوْمٌ':Added, #1: 1	أَمْرُ قَوْلِ
u'أَمْرٌ قَوْمٌ':Added, #1: 1	أَمْرَ الْقَوْمِ
u'أَمْرٌ قَوْمٌ':Added, #1: 1	أَمْرُ الْقَوْمِ
u'أَمْرٌ قَوْمٌ':Added, #1: 1	أَمْرِ الْقَوْمِ
u'أَمْرٌ قَوْمٌ':Added, #1: 1	أَمْرَ قَوْمٍ
u'أَمْرٌ قَوْمٌ':Added, #1: 1	أَمْرُ قَوْمٍ
u'أَمْرٌ قيام':Added, #2: 2	أَمْرِ قَوْمِهِ
u'أَمْرٌ قِيَامٌ':Added, #1: 1	أَمْرِ قِيَامِ
u'أَمْرٌ قَيِّمٌ':Added, #1: 1	أَمْرِ قِيَامِ
u'أَمَرَ كَاتِبٌ':Predicate, #1: 1	أَمْرِ الْقَيِّمِ
u'أَمْرٌ كَاتِبٌ':Added, #2: 2	أَمَرَ الْكَاتِبَ
u'أَمْرٌ كَاهِنٌ':Added, #1: 1	أَمْرِ كَاتِبِهِ
u'أَمْرٌ كَائِنٌ':Added, #1: 1	أَمْرِ الْكَاهِنَيْنِ
u'أَمْرٌ كبار':Added, #4: 4	أَمْرٍ كَائِنٍ
u'أَمَرَ كُتَّابٌ':Predicate, #1: 1	أَمْرُ الْكِبَارِ
u'أَمْرٌ كِتَابٌ':Added, #1: 1	أَمَرَ الْكُتَّابَ
u'أَمَرَ كَعْبٌ':Predicate, #1: 1	أَمْرَ الْكِتَابِ
u'أَمْرٌ كَعْبٌ':Added, #1: 1	أَمَرَ كَعْبَ
u'أَمْرٌ كعبة':Added, #1: 1	أَمْرُ كَعْبِ
u'أَمْرٌ كَعْبَةٌ':Added, #3: 3	أَمْرِ الْكَعْبَةِ
u'أَمْرٌ كَفَاءةٌ':Added, #3: 3	أَمْرِ الْكَعْبَةِ
u'أَمْرٌ كُفَّارٌ':Added, #1: 1	أَمْرُ الْكَفَاءَةِ
u'أَمَرَ كَفِيلٌ':Predicate, #2: 2	أَمْرِ الْكُفَّارِ
u'أَمْرٌ كَفِيلٌ':Added, #3: 3	أَمَرَ الْكَفِيلَ
u'أَمْرٌ كلاب':Added, #1: 1	أَمْرِ الْكَفِيلِ
u'أَمْرٌ كِلاَبٌ':Added, #2: 2	أَمْرِ الْكِلَابِ
u'أَمْرٌ كَلالَةٌ':Added, #2: 2	أَمْرِ الْكِلَابِ
u'أَمْرٌ كُلِّيٌّ':Added, #1: 1	أَمْرِ الْكَلاَلَةِ
u'أَمْرٌ كَوْنِيٌّ':Added, #1: 1	أَمْرٍ كُلِّيٍّ
u'أَمْرٌ لحاق':Added, #1: 1	أَمْرٍ كَوْنِيٍّ
u'أَمْرٌ لِحَاقٌ':Added, #1: 1	أَمْرُ اللِّحَاقِ
u'أَمْرٌ لُغَوِيٌّ':Added, #1: 1	أَمْرُ اللِّحَاقِ
u'أَمْرٌ لَفْظٌ':Added, #2: 2	أَمْرٍ لُغَوِيٍّ
u'أَمْرٌ لَفْظَةٌ':Added, #1: 1	أَمْرِ اللَّفْظِ
u'أَمَرَّ مَاءٌ':Predicate, #1: 1	أَمْرُ اللَّفْظَةِ
u'أَمْرٌ مَاءٌ':Added, #5: 5	أَمَرَّ الْمَاءَ
u'أَمْرٌ مَاشِي':Added, #3: 3	أَمْرِ الْمَاءِ
u'أَمْرٌ مَاشِيَةٌ':Added, #1: 1	أَمْرِ الْمَاشِيَةِ
u'أَمْرٌ مَالٌ':Added, #1: 1	أَمْرِ الْمَاشِيَةِ
u'أَمَرَ مَالِكٌ':Subject, #1: 1	أَمْرَ الْمَالِ
u'أَمَرَ مَالِكٌ':Subject, #1: 1	أَمَرَ مَالِكٌ
u'أَمْرٌ مَالِكٌ':Added, #2: 2	أَمَرَ الْمَالِكُ
u'أَمْرٌ مَالِكٌ':Added, #1: 1	أَمْرَ الْمَالِكِ
u'أَمْرٌ مَالِكٌ':Added, #2: 2	أَمْر الْمَالِكِ
u'أَمْرٌ مَالِكٌ':Added, #2: 2	أَمْرِ مَالِكِهِ
u'أَمْرٌ مُبَاحٌ':Added, #3: 3	أَمْرِ الْمَالِكِ
u'أَمْرٌ مَبِيتٌ':Added, #1: 1	أَمْرٍ مُبَاحٍ
u'أَمْرٌ مَبِيعٌ':Added, #1: 1	أَمْرِ الْمَبِيتِ
u'أَمْرٌ مُتَعَذِّرٌ':Added, #1: 1	أَمْرُ الْمَبِيعَاتِ
u'أَمْرٌ مُتَقَدِّمٌ':Added, #1: 1	أَمْرٍ مُتَعَذِّرٍ
u'أَمْرٌ مُتَلاعِن':Added, #3: 3	أَمْرٍ مُتَقَدِّمٍ
u'أَمْرٌ مُتَوَقَّعٌ':Added, #2: 2	أَمْرِ الْمُتَلاَعِنَيْنِ
u'أَمْرٌ مثل':Added, #1: 1	أَمْرٍ مُتَوَقَّعٍ
u'أَمْرٌ مِثْلٌ':Added, #1: 1	أَمْرَ مِثْلِهِ
u'أَمْرٌ مُجَاوِرٌ':Added, #1: 1	أَمْرَ مِثْلِهِ
u'أَمَرَ مُجْتَهِد':Subject, #2: 2	أَمْرٍ مُجَاوِرٍ
u'أَمْرٌ مُجْتَهِد':Added, #1: 1	أَمَرَ الْمُجْتَهِدُ
u'أَمْرٌ مُجْتَهِد':Added, #1: 1	أَمْرَ الْمُجْتَهِدِ
u'أَمْرٌ مَجْزُوم':Added, #1: 1	أَمْرُ الْمُجْتَهِدِ
u'أَمَرَ مَجْنِيٌّ':Subject, #1: 1	أَمْرٍ مَجْزُومٍ
u'أَمْرٌ مَجُوسٌ':Added, #1: 1	أَمَرَ الْمَجْنِيُّ
u'أَمَرَ مَجُوسِيٌّ':Predicate, #1: 1	أَمْرُ الْمَجُوسِ
u'أَمَرَ مُحْتَكِرٌ':Predicate, #2: 2	أَمَرَ الْمَجُوسِيَّ
u'أَمْرٌ مُحْتَكِرٌ':Added, #2: 2	أَمَرَ الْمُحْتَكِرَ
u'أَمْرٌ مُحْتَمَلٌ':Added, #1: 1	أَمْرُ الْمُحْتَكِرِ
u'أَمَرَ مُحْدِثٌ':Predicate, #3: 3	أَمْرٍ مُحْتَمَلٍ
u'أَمْرٌ مَحْذُوفٌ':Added, #1: 1	أَمَرَ الْمُحْدِثَ
u'أَمَرَ مُحْرِمٌ':Predicate, #1: 1	أَمْرٍ مَحْذُوفٍ
u'أَمَرَ مُحْرِمٌ':Subject, #1: 1	أَمَرَ الْمُحْرِمَ
u'أَمَرَ مُحْرِمٌ':Subject, #1: 1	أَمَرَ مُحْرِمٌ
u'أَمْرٌ مُحَرَّمٌ':Added, #4: 4	أَمَرَ الْمُحْرِمُ
u'أَمْرٌ مَحْسُوسٌ':Added, #3: 3	أَمْرٍ مُحَرَّمٍ
u'أَمْرٌ مَحْصُورٌ':Added, #2: 2	أَمْرٍ مَحْسُوسٍ
u'أَمْرٌ مَحْظُورٌ':Added, #1: 1	أَمْرٍ مَحْصُورٍ
u'أَمْرٌ مُحَقَّقٌ':Added, #1: 1	أَمْرٍ مَحْظُورٍ
u'أَمَرَ مُحَمَّدٌ':Subject, #2: 2	أَمْرٍ مُحَقَّقٍ
u'أَمْرٌ مُحَمَّدٌ':Added, #1: 1	أَمَرَ مُحَمَّدُ
u'أَمْرٌ مُحَمَّدٌ':Added, #1: 1	أَمْرَ مُحَمّدٍ
u'أَمْرٌ مُحَمَّدٌ':Added, #1: 1	أَمْرَ مُحَمَّدٍ
u'أَمْرٌ مُحَمَّدٌ':Added, #1: 1	أَمْرُ مُحَمّدٍ
u'أَمْرٌ مُحَمَّدٌ':Added, #1: 1	أَمْرِ مُحَمّدٍ
u'أَمَرَ مُحِيل':Subject, #3: 3	أَمْرِ مُحَمَّدٍ
u'أَمْرٌ مُحِيل':Added, #1: 1	أَمَرَ الْمُحِيلُ
u'أَمْرٌ مُحِيل':Added, #1: 1	أَمْرَ الْمُحِيلِ
u'أَمَرَ مُخَاطَبٌ':Predicate, #2: 2	أَمْرِ الْمُحِيلِ
u'أَمْرٌ مُخَاطِبٌ':Added, #1: 1	أَمَرَ الْمُخَاطَبَ
u'أَمْرٌ مُخَالِفٌ':Added, #3: 3	أَمْرِ الْمُخَاطِبِ
u'أَمْرٌ مُخْتَلَفٌ':Added, #2: 2	أَمْرٍ مُخَالِفٍ
u'أَمْرٌ مَخْصُوصٌ':Added, #4: 4	أَمْرٍ مُخْتَلَفٍ
u'أَمْرٌ مَخُوفٌ':Added, #2: 2	أَمْرٍ مَخْصُوصٍ
u'أَمَرَ مُدَّعِي':Predicate, #3: 3	أَمْرٍ مَخُوفٍ
u'أَمْرٌ مَدِينٌ':Added, #4: 4	أَمَرَ الْمُدَّعِيَ
u'أَمْرٌ مَدِينَةٌ':Added, #1: 1	أَمْرِ الْمَدِينَةِ
u'أَمَرَ مَدْيُونٌ':Predicate, #1: 1	أَمْرِ الْمَدِينَةِ
u'أَمْرٌ مَدْيُونٌ':Added, #1: 1	أَمَرَ الْمَدْيُونَ
u'أَمْرٌ مَدْيُونٌ':Added, #1: 1	أَمْرُ الْمَدْيُونِ
u'أَمْرٌ مُرْتَكِبٌ':Added, #2: 2	أَمْرِ الْمَدْيُونِ
u'أَمَرَ مُرْتَهِنٌ':Predicate, #1: 1	أَمْرِ مُرْتَكِبِهِ
u'أَمَرَ مُرْتَهِنٌ':Subject, #1: 1	أَمَرَ الْمُرْتَهِنَ
u'أَمْرٌ مُرْتَهِنٌ':Added, #2: 2	أَمَرَ الْمُرْتَهِنُ
u'أَمْرٌ مُرْشِدٌ':Added, #1: 1	أَمْرِ الْمُرْتَهِنِ
u'أَمْرٌ مُزَارِعٌ':Added, #1: 1	أَمْرِ مُرْشِدِ
u'أَمْرٌ مَسْأَلَةٌ':Added, #6: 6	أَمْرِ الْمُزَارِعِ
u'أَمَرَ مُسْتَأْجِرٌ':Predicate, #1: 1	أَمْرَ الْمَسْأَلَةِ
u'أَمْرٌ مُسْتَحِقٌّ':Added, #1: 1	أَمَرَ الْمُسْتَأْجِرَ
u'أَمْرٌ مُسْتَقْبَلٌ':Added, #2: 2	أَمْرِ الْمُسْتَحِقِّ
u'أَمْرٌ مَسْجِدٌ':Added, #4: 4	أَمْرٍ مُسْتَقْبَلٍ
u'أَمَرَ مُسْلِمٌ':Predicate, #1: 1	أَمْرُ مَسْجِدِ
u'أَمَرَ مُسَلَّمٌ':Subject, #2: 2	أَمَرَ الْمُسْلِمِينَ
u'أَمَرَ مُسْلِمٌ':Subject, #1: 1	أَمَرَ الْمُسَلَّمُ
u'أَمْرٌ مُسَلَّمٌ':Added, #2: 2	أَمَرَ الْمُسْلِمُ
u'أَمْرٌ مُشْتَرَكٌ':Added, #1: 1	أَمْرِ الْمُسَلَّمِ
u'أَمَرَ مُشْتَرِي':Predicate, #1: 1	أَمْرٍ مُشْتَرَكٍ
u'أَمْرٌ مُضَارِبٌ':Added, #2: 2	أَمَرَ الْمُشْتَرِيَ
u'أَمْرٌ مُضَارِبٌ':Added, #1: 1	أَمْر الْمُضَارِبِ
u'أَمْرٌ مُضَارَبَةٌ':Added, #1: 1	أَمْرَ الْمُضَارِبِ
u'أَمْرٌ مَطْلُوبٌ':Added, #1: 1	أَمْرِ الْمُضَارَبَةِ
u'أَمْرٌ مَطْلُوبٌ':Added, #1: 1	أَمْرٍ مَطْلُوبٍ
u'أَمْرٌ مَطْلُوبٌ':Added, #2: 2	أَمْر الْمَطْلُوبِ
u'أَمْرٌ مَطْلُوبٌ':Added, #2: 2	أَمْرُ الْمَطْلُوبِ
u'أَمْرٌ مَظْنُون':Added, #5: 5	أَمْرِ الْمَطْلُوبِ
u'أَمْرٌ مَعَاشٌ':Added, #1: 1	أَمْرٍ مَظْنُونٍ
u'أَمْرٌ مَعَاشٌ':Added, #1: 1	أَمْرِ مَعَاشِ
u'أَمْرٌ مَعَاشٌ':Added, #1: 1	أَمْرِ مَعَاشِهِ
u'أَمَرَ مُعاوِيَة':Predicate, #2: 2	أَمْرِ الْمَعَاشِ
u'أَمْرٌ مَعْدُومٌ':Added, #1: 1	أَمَرَ مُعَاوِيَةَ
u'أَمْرٌ مَعْدُومٌ':Added, #1: 1	أَمْرَ الْمَعْدُومِ
u'أَمْرٌ مَعْدُومٌ':Added, #1: 1	أَمْرَ مَعْدُومٍ
u'أَمْرٌ مَعْرُوفٌ':Added, #2: 2	أَمْرِ الْمَعْدُومِ
u'أَمْرٌ مَعْقُولٌ':Added, #2: 2	أَمْرٍ مَعْرُوفٍ
u'أَمْرٌ مَعْلُومٌ':Added, #2: 2	أَمْرٍ مَعْقُولٍ
u'أَمْرٌ مَعِيشَةٌ':Added, #3: 3	أَمْرٍ مَعْلُومٍ
u'أَمْرٌ مَعِيشَةٌ':Added, #1: 1	أَمْرَ مَعِيشَتِهِ
u'أَمْرٌ مُعَيَّنٌ':Added, #2: 2	أَمْرِ الْمَعِيشَةِ
u'أَمْرٌ مَغَانِمُ':Added, #3: 3	أَمْرٍ مُعَيَّنٍ
u'أَمْرٌ مَفْهُومٌ':Added, #1: 1	أَمْرَ الْمَغَانِمِ
u'أَمْرٌ مُقَارِنٌ':Added, #1: 1	أَمْرٍ مَفْهُومٍ
u'أَمَرَ مُقْرِضٌ':Subject, #1: 1	أَمْرٍ مُقَارِنٍ
u'أَمْرٌ مَقْصُودٌ':Added, #1: 1	أَمَرَ الْمُقْرِضُ
u'أَمْرٌ مَقْطُوعٌ':Added, #2: 2	أَمْرٍ مَقْصُودٍ
u'أَمْرٌ مُقَلِّدٌ':Added, #1: 1	أَمْرٍ مَقْطُوعٍ
u'أَمْرٌ مَكْرُوهٌ':Added, #1: 1	أَمْرُ مُقَلِّدِهِ
u'أَمْرٌ مَكْفُولٌ':Added, #3: 3	أَمْرٍ مَكْرُوهٍ
u'أَمَرَ مُلْتَقِط':Subject, #2: 2	أَمْرِ الْمَكْفُولِ
u'أَمَرَ مَلِكٌ':Subject, #1: 1	أَمَرَ الْمُلْتَقِطُ
u'أَمْرٌ مُمْكِنٌ':Added, #1: 1	أَمَرَ الْمَلِكُ
u'أَمْرٌ مُمْكِن':Added, #1: 1	أَمْرٍ مُمْكِنٍ
u'أَمْرٌ مُنَاسِبٌ':Added, #1: 1	أَمْرٍ مُمْكِنٍ
u'أَمْرٌ مَنَاسِكُ':Added, #1: 1	أَمْرٍ مُنَاسِبٍ
u'أَمْرٌ مِنَّةٌ':Added, #2: 2	أَمْرِ الْمَنَاسِكِ
u'أَمْرٌ مُنْتَظَر':Added, #1: 1	أَمْرَ الْمِنَّةِ
u'أَمْرٌ مَنْدُوبٌ':Added, #2: 2	أَمْرٍ مُنْتَظَرٍ
u'أَمَرَ مُهَاجِرٌ':Predicate, #1: 1	أَمْرٍ مَنْدُوبٍ
u'أَمْرٌ مُهَاجِرٌ':Added, #1: 1	أَمَرَ الْمُهَاجِرِينَ
u'أَمْرٌ مُهِمٌّ':Added, #1: 1	أَمْرُ الْمُهَاجِرَاتِ
u'أَمْرٌ مُوالاة':Added, #2: 2	أَمْرٍ مُهِمٍّ
u'أَمْرٌ مَوْجُودٌ':Added, #1: 1	أَمْرَ الْمُوَالَاةِ
u'أَمَرَ مُودَعٌ':Predicate, #2: 2	أَمْرٍ مَوْجُودٍ
u'أَمَرَ مُودِعٌ':Subject, #1: 1	أَمَرَ الْمُودَعَ
u'أَمَرَ مُؤَذِّنٌ':Predicate, #1: 1	أَمَرَ الْمُودِعُ
u'أَمَرَ مُؤَذِّنٌ':Subject, #4: 4	أَمَرَ الْمُؤَذِّنَ
u'أَمْرٌ مُوَرِّث':Added, #1: 1	أَمَرَ الْمُؤَذِّنُ
u'أَمْرٌ مَوْضُوعٌ':Added, #1: 1	أَمْرِ الْمُوَرِّثِ
u'أَمَرَ مُوَكِّلٌ':Subject, #1: 1	أَمْرِ الْمَوْضُوعِ
u'أَمْرٌ مُوَكَّلٌ':Added, #1: 1	أَمَرَ الْمُوَكِّلُ
u'أَمْرٌ مُوَكِّلٌ':Added, #1: 1	أَمْرَ الْمُوَكَّلِ
u'أَمْرٌ مُوَكِّلٌ':Added, #1: 1	أَمْرَ مُوَكِّلِهِ
u'أَمْرٌ مُوَكِّلٌ':Added, #4: 4	أَمْرَ الْمُوَكِّلِ
u'أَمَرَ مُؤْمِنٌ':Predicate, #8: 8	أَمْرِ الْمُوَكِّلِ
u'أَمْرٌ مُؤْمِنٌ':Added, #3: 3	أَمَرَ الْمُؤْمِنِينَ
u'أَمْرٌ مَوْهُومٌ':Added, #1: 1	أَمْرِ الْمُؤْمِنِ
u'أَمْرٌ مِيرَاثٌ':Added, #2: 2	أَمْرٍ مَوْهُومٍ
u'أَمْرٌ نَارٌ':Added, #1: 1	أَمْرُ مِيرَاثِهِ
u'أَمْرٌ نَارٌ':Added, #1: 1	أَمْرَ النَّارِ
u'أَمَرَ نَاسٌ':Predicate, #1: 1	أَمْرِ النَّارِ
u'أَمَرَ نَاسٌ':Predicate, #25: 25	أَمَرَ النَّاسَ
u'أَمَرَ نَاسٌ':Subject, #3: 3	أَمَرَ النّاسَ
u'أَمْرٌ نَاسٌ':Added, #1: 1	أَمَرَ النَّاسُ
u'أَمْرٌ نَاسٌ':Added, #1: 1	أَمْرَ النَّاسِ
u'أَمْرٌ نَاسٌ':Added, #21: 21	أَمْرِ النَّاسِ
u'أَمْرٌ نَاسٌ':Added, #3: 3	أَمْرُ النّاسِ
u'أَمْرٌ نَاسٌ':Added, #3: 3	أَمْرُ النَّاسِ
u'أَمْرٌ نَاسٌ':Added, #5: 5	أَمْرَ النّاسِ
u'أَمَرَ نَاصِرٌ':Subject, #6: 6	أَمْرِ النّاسِ
u'أَمْرٌ نَاقَةٌ':Added, #1: 1	أَمَرَ النَّاصِرُ
u'أَمْرٌ نَاقَة':Added, #1: 1	أَمْرِ النَّاقَةِ
u'أَمْرٌ نُبُوءةٌ':Added, #1: 1	أَمْرِ النَّاقَةِ
u'أَمْرٌ نُبُوَّةٌ':Added, #1: 1	أَمْرَ النّبُوءَةِ
u'أَمْرٌ نُبُوَّةٌ':Added, #1: 1	أَمْرُ النّبُوّةِ
u'أَمَرَ نَبِيٌّ':Predicate, #1: 1	أَمْرِ النّبُوّةِ
u'أَمَّرَ نَبِيٌّ':Subject, #1: 1	أَمَرَ النَّبِيَّ
u'أَمَرَ نَبِيٌّ':Subject, #2: 2	أَمَّرَ النَّبِيُّ
u'أَمْرٌ نَبِيٌّ':Added, #44: 44	أَمَرَ النَّبِيُّ
u'أَمْرٌ نَبِيٌّ':Added, #1: 1	أَمْرُ النَّبِيِّ
u'أَمْرٌ نَبِيٌّ':Added, #3: 3	أَمْرَ النَّبِيِّ
u'أَمْرٌ نَبِيذٌ':Added, #6: 6	أَمْرِ النَّبِيِّ
u'أَمَرَ نَجَّارٌ':Predicate, #1: 1	أَمْرَ النَّبِيذِ
u'أَمْرٌ نَجَاسَةٌ':Added, #1: 1	أَمَرَ النَّجَّارَ
u'أَمْرٌ نَحْوٌ':Added, #1: 1	أَمْرِ النَّجَاسَةِ
u'أَمْرٌ نَدْبٌ':Added, #1: 1	أَمْرِ نَحْوِ
u'أَمْرٌ نَدْبٌ':Added, #2: 2	أَمْرَ النَّدْبِ
u'أَمْرٌ نَدْبٌ':Added, #2: 2	أَمْرِ النَّدْبِ
u'أَمْرٌ نَدْبٌ':Added, #3: 3	أَمْرَ نَدْبٍ
u'أَمْرٌ نِذَارَةٌ':Added, #8: 8	أَمْرُ نَدْبٍ
u'أَمْرٌ نِساءٌ':Added, #1: 1	أَمْرُ النِّذَارَةِ
u'أَمْرٌ نِساءٌ':Added, #1: 1	أَمْرَ النّسَاءِ
u'أَمْرٌ نِساءٌ':Added, #1: 1	أَمْرُ النِّسَاءِ
u'أَمْرٌ نَسَبٌ':Added, #2: 2	أَمْرِ النِّسَاءِ
u'أَمْرٌ نَسَبٌ':Added, #1: 1	أَمْرُ النَّسَبِ
u'أَمْرٌ نَسَبٌ':Added, #2: 2	أَمْرِ النَّسَبِ
u'أَمْرٌ نَظَرٌ':Added, #3: 3	أَمْرَ النَّسَبِ
u'أَمْرٌ نَفْسٌ':Added, #1: 1	أَمْرَ النَّظَرِ
u'أَمْرٌ نَفْسٌ':Added, #10: 10	أَمْرَ نَفْسِهِ
u'أَمْرٌ نَفْسٌ':Added, #1: 1	أَمْرَ النَّفْسِ
u'أَمْرٌ نُفَسَاءُ':Added, #8: 8	أَمْرِ نَفْسِهِ
u'أَمْرٌ نَفْسِيٌّ':Added, #1: 1	أَمْرِ النُّفَسَاءِ
u'أَمْرٌ نكاح':Added, #1: 1	أَمْرٍ نَفْسِيٍّ
u'أَمْرٌ نِكَاحٌ':Added, #1: 1	أَمْرُ النِّكَاحِ
u'أَمْرٌ نكاح':Added, #1: 1	أَمْرُ النِّكَاحِ
u'أَمْرٌ نِكَاحٌ':Added, #2: 2	أَمْرَ النِّكَاحِ
u'أَمْرٌ نكاح':Added, #2: 2	أَمْرَ النِّكَاحِ
u'أَمْرٌ نِكَاحٌ':Added, #4: 4	أَمْرِ النِّكَاحِ
u'أَمْرٌ نَوَازِلُ':Added, #4: 4	أَمْرِ النِّكَاحِ
u'أَمْرٌ نَوَافِلُ':Added, #1: 1	أَمْرُ النَّوَازِلِ
u'أَمْرٌ هُدْنَةٌ':Added, #1: 1	أَمْرَ النَّوَافِلِ
u'أَمْرٌ هِلاَلٌ':Added, #1: 1	أَمْرُ الْهُدْنَةِ
u'أَمْرٌ وَاجِبٌ':Added, #2: 2	أَمْرَ الْهِلَالِ
u'أَمْرٌ وَاجِبٌ':Added, #1: 1	أَمْرِ الْوَاجِبِ
u'أَمْرٌ واحد':Added, #2: 2	أَمْرٍ وَاجِبٍ
u'أَمْرٌ وَاحِدٌ':Added, #1: 1	أَمْرُ وَاحِدٍ
u'أَمْرٌ واحد':Added, #1: 1	أَمْرُ وَاحِدٍ
u'أَمْرٌ وَاحِدٌ':Added, #6: 6	أَمْرٍ وَاحِدٍ
u'أَمْرٌ وَارِثٌ':Added, #6: 6	أَمْرٍ وَاحِدٍ
u'أَمْرٌ وَاعِظٌ':Added, #1: 1	أَمْرِ الْوَارِثِ
u'أَمْرٌ وَاقِعٌ':Added, #1: 1	أَمْرِ الْوَاعِظِ
u'أَمَرَ وَاقِفٌ':Subject, #1: 1	أَمْرٍ وَاقِعٍ
u'أَمْرٌ وَالِدٌ':Added, #3: 3	أَمَرَ الْوَاقِفُ
u'أَمْرٌ وَالِدٌ':Added, #1: 1	أَمْرُ الْوَالِدِ
u'أَمْرٌ وَالِدٌ':Added, #1: 1	أَمْرِ وَالِدِهِ
u'أَمْرٌ وَاهِبٌ':Added, #2: 2	أَمْرِ الْوَالِدَيْنِ
u'أَمْرٌ وَاهِبٌ':Added, #3: 3	أَمْرَ الْوَاهِبِ
u'أَمْرٌ وَبَاءٌ':Added, #3: 3	أَمْرِ الْوَاهِبِ
u'أَمَرَّ وَجْهٌ':Predicate, #1: 1	أَمْرِ الْوَبَاءِ
u'أَمْرٌ وُجُوبٌ':Added, #3: 3	أَمَرَّ الْوَجْهَ
u'أَمْرٌ وُجُوبٌ':Added, #1: 1	أَمْرَ الْوُجُوبِ
u'أَمْرٌ وُجُوبٌ':Added, #1: 1	أَمْرَ وُجُوبٍ
u'أَمْرٌ وُجُودِيٌّ':Added, #2: 2	أَمْرِ الْوُجُوبِ
u'أَمَرَ وَرَثَةٌ':Predicate, #4: 4	أَمْرٍ وُجُودِيٍّ
u'أَمْرٌ وَرَثَةٌ':Added, #1: 1	أَمَرَ الْوَرَثَةَ
u'أَمْرٌ وَزِيرٌ':Added, #1: 1	أَمْرِ الْوَرَثَةِ
u'أَمْرٌ وُشَاةٌ':Added, #1: 1	أَمْرُ الْوَزِيرَيْنِ
u'أَمَرَ وَصِيٌّ':Subject, #1: 1	أَمْرَ الْوُشَاةِ
u'أَمْرٌ وَصِيٌّ':Added, #4: 4	أَمَرَ الْوَصِيُّ
u'أَمْرٌ وَصِيٌّ':Added, #1: 1	أَمْرَ الْوَصِيَّةِ
u'أَمْرٌ وَصِيٌّ':Added, #1: 1	أَمْرِ الْوَصِيَّيْنِ
u'أَمْرٌ وَصِيٌّ':Added, #1: 1	أَمْرِ وَصِيِّهِ
u'أَمْرٌ وَصِيَّةٌ':Added, #2: 2	أَمْرِ الْوَصِيِّ
u'أَمْرٌ وَفْدٌ':Added, #1: 1	أَمْرَ الْوَصِيَّةِ
u'أَمْرٌ وَقْفٌ':Added, #1: 1	أَمْرُ وَفْدِ
u'أَمْرٌ وَقْفٌ':Added, #1: 1	أَمْر الْوَقْفِ
u'أَمْرٌ وَقْفٌ':Added, #1: 1	أَمْرُ الْوَقْفِ
u'أَمْرٌ وَقْفٌ':Added, #3: 3	أَمْرَ الْوَقْفِ
u'أَمَرَ وَكِيلٌ':Predicate, #8: 8	أَمْرِ الْوَقْفِ
u'أَمَرَ وَكِيلٌ':Subject, #1: 1	أَمَرَ الْوَكِيلَ
u'أَمْرٌ وَكِيلٌ':Added, #2: 2	أَمَرَ الْوَكِيلُ
u'أَمْرٌ وِلاَيَةٌ':Added, #1: 1	أَمْرَ الْوَكِيلَيْنِ
u'أَمْرٌ وَلَدٌ':Added, #2: 2	أَمْرِ الْوِلَايَةِ
u'أَمْرٌ ولد':Added, #1: 1	أَمْرُ وَلَدٍ
u'أَمْرٌ وَلَدٌ':Added, #2: 2	أَمْرَ الْوَلَدِ
u'أَمْرٌ ولد':Added, #2: 2	أَمْرَ الْوَلَدِ
u'أَمْرٌ وَلَدٌ':Added, #3: 3	أَمْرُ الْوَلَدِ
u'أَمَرَ وَلِيٌّ':Predicate, #3: 3	أَمْرُ الْوَلَدِ
u'أَمَرَ وَلِيٌّ':Subject, #1: 1	أَمَرَ وَلِيَّ
u'أَمَرَ وَلِيٌّ':Subject, #1: 1	أَمَرَ الْوَلِيُّ
u'أَمْرٌ وَلِيٌّ':Added, #1: 1	أَمَرَ وَلِيُّ
u'أَمْرٌ وَلِيٌّ':Added, #1: 1	أَمْرِ وَلِيِّ
u'أَمْرٌ وَلِيٌّ':Added, #1: 1	أَمْرُ وَلِيِّهِ
u'أَمْرٌ وَلِيدٌ':Added, #2: 2	أَمْرِ وَلِيِّهِ
u'أَمْرٌ يَتِيمٌ':Added, #1: 1	أَمْرِ الْوَلِيدِ
u'أَمْرٌ يمن':Added, #2: 2	أَمْرِ الْيَتِيمِ
u'أَمْرٌ يمن':Added, #1: 1	أَمْرُ الْيَمَنِ
u'أَمْرٌ يَمَنُ':Added, #1: 1	أَمْرِ الْيَمَنِ
u'أَمْرٌ يَمَنُ':Added, #1: 1	أَمْرُ الْيَمَنِ
u'أَمْرٌ يهود':Added, #1: 1	أَمْرِ الْيَمَنِ
u'أَمْرٌ يَهُودٌ':Added, #3: 3	أَمْرِ الْيَهُودِ
u'أَمَسَّ حَجَرٌ':Predicate, #3: 3	أَمْرِ الْيَهُودِ
u'أَمَسَّ سَمَاءٌ':Predicate, #4: 4	أَمَسَّ الْحَجَرَ
u'أَمْسَكَ باقِي':Predicate, #5: 5	أَمَسَّ السَّمَاءَ
u'أَمْسَكَ بَائِعٌ':Subject, #1: 1	أَمْسَكَ الْبَاقِيَ
u'أَمْسَكَ بَعْضٌ':Subject, #1: 1	أَمْسَكَ الْبَائِعُ
u'أَمْسَكَ بَقِيَّةٌ':Predicate, #1: 1	أَمْسَكَ بَعْضُ
u'أَمْسَكَ ثَانِي':Predicate, #4: 4	أَمْسَكَ بَقِيَّةَ
u'أَمْسَكَ ثَانِيَةٌ':Predicate, #1: 1	أَمْسَكَ الثَّانِيَةَ
u'أَمْسَكَ ثَمَنٌ':Predicate, #1: 1	أَمْسَكَ الثَّانِيَةَ
u'أَمْسَكَ ثَوْبٌ':Predicate, #1: 1	أَمْسَكَ الثَّمَنَ
u'أَمْسَكَ ثَوْرٌ':Predicate, #2: 2	أَمْسَكَ الثَّوْبَ
u'أَمْسَكَ جَارِي':Predicate, #1: 1	أَمْسَكَ الثَّوْرَ
u'أَمْسَكَ جَارِيَةٌ':Predicate, #1: 1	أَمْسَكَ الْجَارِيَةَ
u'أَمْسَكَ حَجَرٌ':Predicate, #1: 1	أَمْسَكَ الْجَارِيَةَ
u'أَمْسَكَ حَلالٌ':Subject, #3: 3	أَمْسَكَ الْحَجَرَ
u'أَمْسَكَ حُلَّةٌ':Predicate, #1: 1	أَمْسَكَ حَلَالٌ
u'أَمْسَكَ حَيٌّ':Predicate, #1: 1	أَمْسَكَ الْحُلَّةَ
u'أَمْسَكَ حَيَّةٌ':Predicate, #1: 1	أَمْسَكَ الْحَيَّةَ
u'أَمْسَكَ خَشَبَةٌ':Predicate, #1: 1	أَمْسَكَ الْحَيَّةَ
u'أَمْسَكَ خَطِيبٌ':Subject, #1: 1	أَمْسَكَ خَشَبَةَ
u'أَمْسَكَ خُفٌّ':Predicate, #1: 1	أَمْسَكَ الْخَطِيبُ
u'أَمْسَكَ خَمْرٌ':Predicate, #1: 1	أَمْسَكَ الْخُفَّ
u'أَمْسَكَ دَجاج':Predicate, #1: 1	أَمْسَكَ الْخَمْرَ
u'أَمْسَكَ دِينارٌ':Predicate, #1: 1	أَمْسَكَ دَجَاجَةً
u'أَمْسَكَ رَجُلٌ':Predicate, #3: 3	أَمْسَكَ الدِّينَارَ
u'أَمْسَكَ رَجُلٌ':Subject, #1: 1	أَمْسَكَ رَجُلاً
u'أَمْسَكَ شَجَرَةٌ':Predicate, #3: 3	أَمْسَكَ الرَّجُلُ
u'أَمْسَكَ شَيْءٌ':Predicate, #1: 1	أَمْسَكَ الشَّجَرَةَ
u'أَمْسَكَ صدقة':Predicate, #1: 1	أَمْسَكَ الشَّيْءَ
u'أَمْسَكَ صَدَقَةٌ':Predicate, #1: 1	أَمْسَكَ الصَّدَقَةَ
u'أَمْسَكَ صَيْدٌ':Predicate, #1: 1	أَمْسَكَ الصَّدَقَةَ
u'أَمْسَكَ صَيْدٌ':Predicate, #1: 1	أَمْسَكَ الصَّيْدَ
u'أَمْسَكَ ضَيْفٌ':Subject, #3: 3	أَمْسَكَ صَيْدَ
u'أَمْسَكَ طَشْت':Predicate, #1: 1	أَمْسَكَ الضَّيْفُ
u'أَمْسَكَ عَبْدٌ':Predicate, #1: 1	أَمْسَكَ الطَّشْتَ
u'أَمْسَكَ عين':Predicate, #4: 4	أَمْسَكَ الْعَبْدَ
u'أَمْسَكَ عَيْنٌ':Predicate, #2: 2	أَمْسَكَ الْعَيْنَ
u'أَمْسَكَ عَيْن':Predicate, #2: 2	أَمْسَكَ الْعَيْنَ
u'أَمْسَكَ غرماء':Subject, #2: 2	أَمْسَكَ الْعَيْنَ
u'أَمْسَكَ غَلَّةٌ':Predicate, #1: 1	أَمْسَكَ الْغُرَمَاءُ
u'أَمْسَكَ غير':Subject, #1: 1	أَمْسَكَ غَلَّةَ
u'أَمْسَكَ غَيْرٌ':Subject, #2: 2	أَمْسَكَ غَيْرُهُ
u'أَمْسَكَ فَرَسٌ':Predicate, #2: 2	أَمْسَكَ غَيْرُهُ
u'أَمْسَكَ فُسْطَاطٌ':Predicate, #2: 2	أَمْسَكَ الْفَرَسَ
u'أَمْسَكَ فُوهٌ':Subject, #1: 1	أَمْسَكَ الْفُسْطَاطَ
u'أَمْسَكَ قَارُورَةٌ':Predicate, #1: 1	أَمْسَكَ فُوهُ
u'أَمْسَكَ قُوتٌ':Predicate, #1: 1	أَمْسَكَ الْقَارُورَةَ
u'أَمْسَكَ كَلْبٌ':Predicate, #5: 5	أَمْسَكَ قُوتَ
u'أَمْسَكَ كَلْبٌ':Subject, #1: 1	أَمْسَكَ الْكَلْبَ
u'أَمْسَكَ مُحْرِمٌ':Subject, #1: 1	أَمْسَكَ الْكَلْبُ
u'أَمْسَكَ مُحْرِمٌ':Subject, #1: 1	أَمْسَكَ الْمُحْرِمُ
u'أَمْسَكَ مَدْفُوعٌ':Predicate, #2: 2	أَمْسَكَ مُحْرِمٌ
u'أَمْسَكَ مُسْتَأْجِرٌ':Subject, #1: 1	أَمْسَكَ الْمَدْفُوعَ
u'أَمْسَكَ مُصْحَفٌ':Predicate, #1: 1	أَمْسَكَ الْمُسْتَأْجِرُ
u'أَمْسَكَ مَغْصُوب':Predicate, #1: 1	أَمْسَكَ الْمُصْحَفَ
u'أَمْسَكَ مُفْطِر':Subject, #1: 1	أَمْسَكَ الْمَغْصُوبَ
u'أَمْسَكَ مَقْبُوضٌ':Predicate, #1: 1	أَمْسَكَ الْمُفْطِرُ
u'أَمْسَكَ نَاسٌ':Subject, #1: 1	أَمْسَكَ الْمَقْبُوضَ
u'أَمْسَكَ نِصْفٌ':Predicate, #1: 1	أَمْسَكَ النَّاسُ
u'أَمْسَكَ نَقْضٌ':Predicate, #1: 1	أَمْسَكَ النِّصْفَ
u'أَمْسَكَ واحد':Subject, #1: 1	أَمْسَكَ النَّقْضَ
u'أَمْسَكَ وَاحِدٌ':Subject, #1: 1	أَمْسَكَ وَاحِدٌ
u'أَمْسَكَ ولد':Predicate, #1: 1	أَمْسَكَ وَاحِدٌ
u'أَمْسَكَ وَلَدٌ':Predicate, #1: 1	أَمْسَكَ الْوَلَدَ
u'أَمَّ سلمة':Predicate, #1: 1	أَمْسَكَ الْوَلَدَ
u'أَمَسَّ واحد':Predicate, #1: 1	أَمَّ سَلَمَةَ
u'أَمَسَّ وَاحِدٌ':Predicate, #1: 1	أَمَسَّ وَاحِدَةً
u'أَمْسَى بَيْضَةٌ':Predicate, #1: 1	أَمَسَّ وَاحِدَةً
u'أَمْسَى تَسَوُّرٌ':Predicate, #2: 2	أَمْسَى بَيْضَةَ
u'أَمْسَى جَلاَبِيبُ':Subject, #1: 1	أَمْسَى تَسَوّرَ
u'أَمْسَى رَسُولٌ':Subject, #2: 2	أَمْسَى الْجَلَابِيبُ
u'أَمْسَى رَفيقٌ':Predicate, #3: 3	أَمْسَى رَسُولُ
u'أَمْسَى سَقَامٌ':Subject, #3: 3	أَمْسَى رَفِيقَ
u'أَمْسَى شرب':Predicate, #1: 1	أَمْسَى سَقَامٌ
u'أَمْسَى عند':Predicate, #1: 1	أَمْسَى شَرِبَ
u'أَمْسَى قَالٌ':Predicate, #1: 1	أَمْسَى عِنْدَ
u'أَمْسَى لَيْلٌ':Predicate, #1: 1	أَمْسَى قَالَ
u'أَمْسَى نَزَلٌ':Predicate, #1: 1	أَمْسَى لَيْلَةَ
u'أَمَّ صَبِيٌّ':Subject, #1: 1	أَمْسَى نَزَلَ
u'أَمَصَّ لبن':Predicate, #2: 2	أَمَّ الصَّبِيُّ
u'أَمَصَّ لَبَنٌ':Predicate, #1: 1	أَمَصَّ اللَّبَنَ
u'أَمْضَى إجَارَةٌ':Predicate, #1: 1	أَمَصَّ اللَّبَنَ
u'أَمْضَى اِجْتِهَادٌ':Predicate, #2: 2	أَمْضَى الْإِجَارَةَ
u'أَمْضَى أَمْرٌ':Predicate, #1: 1	أَمْضَى اجْتِهَادَ
u'أَمْضَى بَيْعٌ':Predicate, #1: 1	أَمْضَى الْأَمْرَ
u'أَمْضَى حُكْمٌ':Predicate, #7: 7	أَمْضَى الْبَيْعَ
u'أَمْضَى رَدٌّ':Predicate, #2: 2	أَمْضَى الْحُكْمَ
u'أَمْضَى صدقة':Predicate, #1: 1	أَمْضَى الرَّدَّ
u'أَمْضَى صَدَقَةٌ':Predicate, #2: 2	أَمْضَى الصَّدَقَةَ
u'أَمْضَى صلح':Predicate, #2: 2	أَمْضَى الصَّدَقَةَ
u'أَمْضَى صُلْحٌ':Predicate, #1: 1	أَمْضَى الصُّلْحَ
u'أَمْضَى ضَمَانٌ':Predicate, #1: 1	أَمْضَى الصُّلْحَ
u'أَمْضَى عتق':Predicate, #4: 4	أَمْضَى الضَّمَانَ
u'أَمْضَى عِتْقٌ':Predicate, #1: 1	أَمْضَى الْعِتْقَ
u'أَمْضَى عَقْدٌ':Predicate, #1: 1	أَمْضَى الْعِتْقَ
u'أَمْضَى عُمَرٌ':Subject, #3: 3	أَمْضَى الْعَقْدَ
u'أَمْضَى فَسْخٌ':Predicate, #1: 1	أَمْضَى عُمَرُ
u'أَمْضَى قَسْمٌ':Predicate, #1: 1	أَمْضَى الْفَسْخَ
u'أَمْضَى قَضَاءٌ':Predicate, #2: 2	أَمْضَى قَسْمَ
u'أَمْضَى قَضَاءٌ':Predicate, #1: 1	أَمْضَى الْقَضَاءَ
u'أَمْضَى قول':Predicate, #1: 1	أَمْضَى قَضَاءَ
u'أَمْضَى قَوْلٌ':Predicate, #2: 2	أَمْضَى قَوْلَ
u'أَمْضَى وَقْفٌ':Predicate, #2: 2	أَمْضَى قَوْلَ
u'أَمْضَى وَكِيلٌ':Subject, #1: 1	أَمْضَى الْوَقْفَ
u'أَمْضَى يَوْمٌ':Predicate, #4: 4	أَمْضَى الْوَكِيلُ
u'أَمْطَارٌ رَبِيعٌ':Added, #1: 1	أَمْضَى الْيَوْمَ
u'أَمْطَرَ قَالٌ':Predicate, #1: 1	أَمْطَارُ الرَّبِيعِ
u'أَمْطَرَ مَطَرٌ':Predicate, #1: 1	أَمْطَرَ قَالَ
u'أَمَّ عَبْدٌ':Subject, #1: 1	أَمْطَرَ مَطَرَ
u'أَمَّ عَدْلٌ':Predicate, #5: 5	أَمَّ الْعَبْدُ
u'أَمَّ عُرَاةٌ':Predicate, #1: 1	أَمَّ الْعَدْلَ
u'أَمْعَنَ اِبْنٌ':Subject, #1: 1	أَمَّ الْعُرَاةَ
u'أَمْعَنَ مُصَنِّفٌ':Subject, #1: 1	أَمْعَنَ ابْنُ
u'أَمْعَنَ نَظَرٌ':Predicate, #1: 1	أَمْعَنَ الْمُصَنِّفُ
u'أَمَّ غاسِل':Predicate, #7: 7	أَمْعَنَ النَّظَرَ
u'أَمَّ غير':Subject, #1: 1	أَمَّ الْغَاسِلِينَ
u'أَمَّ غَيْرٌ':Subject, #2: 2	أَمَّ غَيْرُهُ
u'أَمَّ قَارِئٌ':Predicate, #2: 2	أَمَّ غَيْرُهُ
u'أَمَّ قَاصِرٌ':Subject, #3: 3	أَمَّ قَارِئِينَ
u'أَمَّ قَاصِرٌ':Subject, #1: 1	أَمَّ الْقَاصِرُ
u'أَمَّ قَوْمٌ':Predicate, #1: 1	أَمَّ قَاصِرٌ
u'أَمْكَنَ أَبٌ':Predicate, #3: 3	أَمَّ الْقَوْمَ
u'أَمْكَنَ اِبْتِداءٌ':Subject, #1: 1	يُمْكِنُ الْأَبَ
u'أَمْكَنَ إبدالٌ':Subject, #1: 1	يُمْكِنُ ابْتِدَاءُ
u'أَمْكَنَ إِبْرَازٌ':Subject, #2: 2	أَمْكَنَ الْإِبْدَالُ
u'أَمْكَنَ إِبْطَالٌ':Subject, #1: 1	يُمْكِنُ إبْرَازُ
u'أَمْكَنَ إِبْطَالٌ':Subject, #2: 2	يُمْكِنُ إبْطَالُ
u'أَمْكَنَ إِبْقَاءٌ':Subject, #9: 9	يُمْكِنُ إبْطَالُهُ
u'أَمْكَنَ إِتْلاَفٌ':Subject, #7: 7	يُمْكِنُ إبْقَاءُ
u'أَمْكَنَ إِتْيانٌ':Subject, #2: 2	يُمْكِنُ إتْلَافُ
u'أَمْكَنَ إِتْيانٌ':Subject, #1: 1	يُمْكِنُ إتْيَانُ
u'أَمْكَنَ إِتْيانٌ':Subject, #1: 1	يُمْكِنُ إتْيَانُهُ
u'أَمْكَنَ إِتْيانٌ':Subject, #2: 2	أَمْكَنَ الْإِتْيَانُ
u'أَمْكَنَ إِثْبَاتٌ':Subject, #4: 4	يُمْكِنُ الْإِتْيَانُ
u'أَمْكَنَ إِثْبَاتٌ':Subject, #1: 1	يُمْكِنُ إِثْبَاتُهُ
u'أَمْكَنَ إِثْبَاتٌ':Subject, #24: 24	يُمْكِنُ إثْبَاتُ
u'أَمْكَنَ إِثْبَاتٌ':Subject, #47: 47	يُمْكِنُ إثْبَاتُهُ
u'أَمْكَنَ إِثْبَاتٌ':Subject, #4: 4	أَمْكَنَ إثْبَاتُ
u'أَمْكَنَ إجَارَةٌ':Subject, #7: 7	أَمْكَنَ إثْبَاتُهُ
u'أَمْكَنَ إجَارَةٌ':Subject, #1: 1	يُمْكِنُ إجَارَتُهُ
u'أَمْكَنَ إجَازَةٌ':Subject, #2: 2	أَمْكَنَ إجَارَتُهُ
u'أَمْكَنَ إِجْبَارٌ':Subject, #1: 1	يُمْكِنُ إجَازَةُ
u'أَمْكَنَ إِجْبَارٌ':Subject, #1: 1	يُمْكِنُ إجْبَارُهُ
u'أَمْكَنَ اِجْتِمَاعٌ':Subject, #2: 2	يُمْكِنُ إجْبَارُ
u'أَمْكَنَ اِجْتِمَاعٌ':Subject, #1: 1	أَمْكَنَ اجْتِمَاعُ
u'أَمْكَنَ اِجْتِمَاعٌ':Subject, #1: 1	أَمْكَنَ اجْتِمَاعُهُ
u'أَمْكَنَ اِجْتِمَاعٌ':Subject, #1: 1	يُمْكِنُ اجْتِمَاعُ
u'أَمْكَنَ إِجْرَاءٌ':Subject, #2: 2	يُمْكِنُ اجْتِمَاعُهُ
u'أَمْكَنَ إِجْمَاعٌ':Subject, #1: 1	أَمْكَنَ إجْرَاءُ
u'أَمْكَنَ أَجِيرٌ':Subject, #1: 1	يُمْكِنُ الْإِجْمَاعُ
u'أَمْكَنَ إحَاطَةٌ':Subject, #1: 1	يُمْكِنُ أَجِيرُ
u'أَمْكَنَ إحَاطَةٌ':Subject, #1: 1	يُمْكِنُ إحَاطَةُ
u'أَمْكَنَ إِحالَةٌ':Predicate, #4: 4	يُمْكِنُ الْإِحَاطَةُ
u'أَمْكَنَ إِحالَةٌ':Subject, #1: 1	أَمْكَنَ إحَالَةَ
u'أَمْكَنَ إِحالَةٌ':Subject, #1: 1	يُمْكِنُ إحَالَةُ
u'أَمْكَنَ إِحالَةٌ':Subject, #2: 2	أَمْكَنَ إحَالَةُ
u'أَمْكَنَ إِحْبَاطٌ':Subject, #3: 3	يُمْكِنُ إحَالَتُهُ
u'أَمْكَنَ اِحْترَازٌ':Subject, #1: 1	يُمْكِنُ إحْبَاطُهُ
u'أَمْكَنَ أحَدٌ':Subject, #1: 1	يُمْكِنُ احْتِرَازُهُ
u'أَمْكَنَ إِحْدَاثٌ':Subject, #2: 2	يُمْكِنُ أَحَدٌ
u'أَمْكَنَ إِحْدَاثٌ':Subject, #11: 11	يُمْكِنُ إحْدَاثُهُ
u'أَمْكَنَ إِحْدَاثٌ':Subject, #1: 1	أَمْكَنَ إحْدَاثُ
u'أَمْكَنَ إِحْدَاثٌ':Subject, #1: 1	أَمْكَنَ إحْدَاثُهُ
u'أَمْكَنَ إِحْرَازٌ':Subject, #1: 1	يُمْكِنُ إِحْدَاثُ
u'أَمْكَنَ إحْضَارٌ':Subject, #7: 7	يُمْكِنُ إحْرَازُهُ
u'أَمْكَنَ إِخْبَارٌ':Subject, #6: 6	يُمْكِنُ إحْضَارُهُ
u'أَمْكَنَ اِختبَارٌ':Subject, #1: 1	يُمْكِنُ الْإِخْبَارُ
u'أَمْكَنَ أخْذٌ':Subject, #1: 1	يُمْكِنُ اخْتِبَارُهُ
u'أَمْكَنَ أخْذٌ':Subject, #17: 17	يُمْكِنُ أَخْذُهُ
u'أَمْكَنَ أخْذٌ':Subject, #1: 1	أَمْكَنَ الْأَخْذُ
u'أَمْكَنَ أخْذٌ':Subject, #2: 2	أَمْكَنَ أَخْذُ
u'أَمْكَنَ أخْذٌ':Subject, #3: 3	أَمْكَنَ أَخْذُهُ
u'أَمْكَنَ أخْذٌ':Subject, #4: 4	يُمْكِنُ أَخْذُ
u'أَمْكَنَ إِخْرَاجٌ':Subject, #6: 6	يُمْكِنُ الْأَخْذُ
u'أَمْكَنَ إِخْرَاجٌ':Subject, #10: 10	يُمْكِنُ إخْرَاجُهُ
u'أَمْكَنَ إِخْرَاجٌ':Subject, #1: 1	يُمْكِنُ الْإِخْرَاجُ
u'أَمْكَنَ إِخْرَاجٌ':Subject, #2: 2	أَمْكَنَ إخْرَاجُهُ
u'أَمْكَنَ إِخْلالٌ':Subject, #8: 8	يُمْكِنُ إخْرَاجُ
u'أَمْكَنَ أَدَاءٌ':Subject, #1: 1	يُمْكِنُ الْإِخْلَالُ
u'أَمْكَنَ أَدَاءٌ':Subject, #1: 1	يُمْكِنُ أَدَاءُ
u'أَمْكَنَ اِدِّخارٌ':Subject, #3: 3	يُمْكِنُ الْأَدَاءُ
u'أَمْكَنَ إدْخَالٌ':Subject, #2: 2	يُمْكِنُ ادِّخَارُهُ
u'أَمْكَنَ إدْخَالٌ':Subject, #2: 2	يُمْكِنُ إدْخَالُهُ
u'أَمْكَنَ إِدْرَاجٌ':Subject, #3: 3	يُمْكِنُ إدْخَالُ
u'أَمْكَنَ إِدْرَاكٌ':Subject, #1: 1	يُمْكِنُ إدْرَاجُ
u'أَمْكَنَ إِدْرَاكٌ':Subject, #1: 1	أَمْكَنَ إدْرَاكُ
u'أَمْكَنَ إِدْرَاكٌ':Subject, #1: 1	يُمْكِنُ إدْرَاكُ
u'أَمْكَنَ إِدْرَاكٌ':Subject, #2: 2	أَمْكَنَ إدْرَاكُهُ
u'أَمْكَنَ اِدِّعَاءٌ':Subject, #3: 3	يُمْكِنُ إدْرَاكُهُ
u'أَمْكَنَ إِذْنٌ':Subject, #2: 2	يُمْكِنُ ادِّعَاءُ
u'أَمْكَنَ إِذْنٌ':Subject, #1: 1	أَمْكَنَ إذْنُ
u'أَمْكَنَ إِرَادَةٌ':Subject, #1: 1	يُمْكِنُ إذْنُهُ
u'أَمْكَنَ اِرْتِفَاعٌ':Subject, #2: 2	يُمْكِنُ إرَادَةُ
u'أَمْكَنَ إِرْجَاعٌ':Subject, #1: 1	يُمْكِنُ ارْتِفَاعُ
u'أَمْكَنَ إِرْجَاعٌ':Subject, #1: 1	يُمْكِنُ إرْجَاعُ
u'أَمْكَنَ أرْضٌ':Predicate, #1: 1	يُمْكِنُ إرْجَاعُهُ
u'أَمْكَنَ إِزَالَةٌ':Subject, #1: 1	أَمْكَنَ الأَرْضَ
u'أَمْكَنَ إِزَالَةٌ':Subject, #1: 1	أَمْكَنَ إزَالَةُ
u'أَمْكَنَ إِزَالَةٌ':Subject, #1: 1	أَمْكَنَ إزَالَتُهُ
u'أَمْكَنَ إِزَالَةٌ':Subject, #3: 3	يُمْكِنُ إزَالَةُ
u'أَمْكَنَ إِسَالَةٌ':Subject, #7: 7	يُمْكِنُ إزَالَتُهُ
u'أَمْكَنَ اِسْتِثْنَاءٌ':Subject, #1: 1	يُمْكِنُ إسَالَتُهُ
u'أَمْكَنَ اِسْتِحْقَاقٌ':Subject, #1: 1	يُمْكِنُ اسْتِثْنَاءُ
u'أَمْكَنَ اِسْتِخْرَاجٌ':Subject, #2: 2	يُمْكِنُ اسْتِحْقَاقُهُ
u'أَمْكَنَ اِسْتِخْرَاجٌ':Subject, #1: 1	أَمْكَنَ اسْتِخْرَاجُ
u'أَمْكَنَ اِسْتِدْرَاكٌ':Subject, #1: 1	يُمْكِنُ اسْتِخْرَاجُ
u'أَمْكَنَ اِسْتِدْراك':Subject, #1: 1	أَمْكَنَ اسْتِدْرَاكُهُ
u'أَمْكَنَ اِسْتِدْرَاكٌ':Subject, #4: 4	يُمْكِنُ اسْتِدْرَاكُ
u'أَمْكَنَ اِسْتِدْلاَلٌ':Subject, #8: 8	يُمْكِنُ اسْتِدْرَاكُهُ
u'أَمْكَنَ اِسْتِرْجَاعٌ':Subject, #1: 1	يُمْكِنُ الاِسْتِدْلاَلُ
u'أَمْكَنَ اِسْتِرْجَاعٌ':Subject, #1: 1	يُمْكِنُ اسْتِرْجَاعُ
u'أَمْكَنَ اِسْتِرْدَادٌ':Subject, #1: 1	يُمْكِنُ اسْتِرْجَاعُهُ
u'أَمْكَنَ اِسْتِطْراق':Subject, #1: 1	يُمْكِنُ اسْتِرْدَادُهُ
u'أَمْكَنَ اِسْتِطْلاعٌ':Subject, #1: 1	يُمْكِنُ اسْتِطْرَاقُ
u'أَمْكَنَ اِسْتِعْلامٌ':Subject, #1: 1	أَمْكَنَ اسْتِطْلَاعُ
u'أَمْكَنَ اِسْتِعْلامٌ':Subject, #1: 1	يُمْكِنُ اسْتِعْلَامُ
u'أَمْكَنَ اِسْتِعْمالٌ':Subject, #5: 5	يُمْكِنُ اسْتِعْلَامُهُ
u'أَمْكَنَ اِسْتِعْمالٌ':Subject, #1: 1	أَمْكَنَ اسْتِعْمَالُهُ
u'أَمْكَنَ اِسْتِعْمالٌ':Subject, #2: 2	يُمْكِنُ اسْتِعْمَالُ
u'أَمْكَنَ اِسْتِفادَةٌ':Subject, #6: 6	يُمْكِنُ اسْتِعْمَالُهُ
u'أَمْكَنَ اِسْتِقْرارٌ':Subject, #1: 1	يُمْكِنُ اسْتِفَادَتُهُ
u'أَمْكَنَ اِسْتِقْلالٌ':Subject, #1: 1	يُمْكِنُ اسْتِقْرَارُ
u'أَمْكَنَ اِسْتِقْلالٌ':Subject, #1: 1	يُمْكِنُ اسْتِقْلَالُ
u'أَمْكَنَ اِسْتِناد':Subject, #2: 2	يُمْكِنُ اسْتِقْلَالُهُ
u'أَمْكَنَ اِسْتيعابٌ':Subject, #1: 1	يُمْكِنُ اسْتِنَادُ
u'أَمْكَنَ اِسْتيعابٌ':Subject, #4: 4	يُمْكِنُ اسْتِيعَابُ
u'أَمْكَنَ اِسْتيفاءٌ':Predicate, #4: 4	يُمْكِنُ اسْتِيعَابُهُ
u'أَمْكَنَ اِسْتيفاءٌ':Subject, #1: 1	يُمْكِنُ اسْتِيفَاءَ
u'أَمْكَنَ اِسْتيفاءٌ':Subject, #12: 12	يُمْكِنُ اسْتِيفَاءُ
u'أَمْكَنَ إِسْقاطٌ':Subject, #1: 1	أَمْكَنَ اسْتِيفَاءُ
u'أَمْكَنَ إِسْقاطٌ':Subject, #4: 4	يُمْكِنُ إسْقَاطُ
u'أَمْكَنَ إِسْنادٌ':Subject, #4: 4	يُمْكِنُ إسْقَاطُهُ
u'أَمْكَنَ إِسْنادٌ':Subject, #1: 1	يُمْكِنُ إسْنَادُ
u'أَمْكَنَ إشارَة':Subject, #1: 1	يُمْكِنُ إسْنَادُهُ
u'أَمْكَنَ اِشْتِباهٌ':Subject, #1: 1	يُمْكِنُ الْإِشَارَةُ
u'أَمْكَنَ اِشْتِراطٌ':Subject, #1: 1	أَمْكَنَ اشْتِبَاهُهُ
u'أَمْكَنَ اِشْتِقاقٌ':Subject, #3: 3	يُمْكِنُ اشْتِرَاطُ
u'أَمْكَنَ إصابَةٌ':Subject, #1: 1	يُمْكِنُ اشْتِقَاقُهُ
u'أَمْكَنَ أصل':Subject, #2: 2	يُمْكِنُ إصَابَةُ
u'أَمْكَنَ أًصْلٌ':Subject, #1: 1	أَمْكَنَ الْأَصْلُ
u'أَمْكَنَ إِصْلاحٌ':Subject, #1: 1	أَمْكَنَ الْأَصْلُ
u'أَمْكَنَ إِصْلاحٌ':Subject, #1: 1	أَمْكَنَ إصْلَاحٌ
u'أَمْكَنَ إِصْلاحٌ':Subject, #1: 1	أَمْكَنَ إصْلَاحُ
u'أَمْكَنَ إِصْلاحٌ':Subject, #1: 1	يُمْكِنُ إصْلَاحُهُ
u'أَمْكَنَ إضافَةٌ':Subject, #2: 2	أَمْكَنَ إصْلَاحُهُ
u'أَمْكَنَ إضْمارٌ':Subject, #1: 1	يُمْكِنُ إضَافَتُهُ
u'أَمْكَنَ إضْمارٌ':Subject, #2: 2	يُمْكِنُ إضْمَارُ
u'أَمْكَنَ إِطْفاءٌ':Subject, #3: 3	يُمْكِنُ إضْمَارُهُ
u'أَمْكَنَ اِطِّلاعٌ':Subject, #1: 1	يُمْكِنُ إطْفَاءُ
u'أَمْكَنَ اِطِّلاعٌ':Subject, #1: 1	يُمْكِنُ اطِّلَاعُهُ
u'أَمْكَنَ إِظْهارٌ':Subject, #2: 2	يُمْكِنُ اطِّلَاعُ
u'أَمْكَنَ إِعادَةٌ':Subject, #2: 2	يُمْكِنُ إظْهَارُ
u'أَمْكَنَ إِعادَةٌ':Subject, #2: 2	أَمْكَنَ إعَادَتُهُ
u'أَمْكَنَ إِعادَةٌ':Subject, #2: 2	يُمْكِنُ إعَادَةُ
u'أَمْكَنَ إِعانَةٌ':Subject, #4: 4	يُمْكِنُ إعَادَتُهُ
u'أَمْكَنَ إِعْتاقٌ':Subject, #1: 1	أَمْكَنَ الْإِعَانَةُ
u'أَمْكَنَ إِعْتاقٌ':Subject, #1: 1	يُمْكِنُ إعْتَاقُ
u'أَمْكَنَ اِعْتِبارٌ':Predicate, #1: 1	يُمْكِنُ إعْتَاقُهُ
u'أَمْكَنَ اِعْتِبارٌ':Subject, #1: 1	يُمْكِنُ اعْتِبَارَ
u'أَمْكَنَ اِعْتِبارٌ':Subject, #12: 12	يُمْكِنُ اعْتِبَارُهُ
u'أَمْكَنَ اِعْتِبارٌ':Subject, #2: 2	أَمْكَنَ اعْتِبَارُ
u'أَمْكَنَ اِعْتِبارٌ':Subject, #2: 2	أَمْكَنَ اعْتِبَارُهُ
u'أَمْكَنَ إعْطَاءٌ':Subject, #32: 32	يُمْكِنُ اعْتِبَارُ
u'أَمْكَنَ إعْلاَمٌ':Subject, #1: 1	يُمْكِنُ الْإِعْطَاءُ
u'أَمْكَنَ إعْلاَمٌ':Subject, #1: 1	أَمْكَنَ إعْلَامُهُ
u'أَمْكَنَ إعْمَالٌ':Subject, #1: 1	يُمْكِنُ إعْلَامُ
u'أَمْكَنَ إعْمَالٌ':Subject, #1: 1	أَمْكَنَ إعْمَالُهُ
u'أَمْكَنَ إعْمَالٌ':Subject, #1: 1	يُمْكِنُ إعْمَالُهُ
u'أَمْكَنَ اِفْتِراسٌ':Subject, #2: 2	يُمْكِنُ إعْمَالُ
u'أَمْكَنَ إِفْرَادٌ':Subject, #1: 1	يُمْكِنُ افْتِرَاسُ
u'أَمْكَنَ إِفْرَادٌ':Subject, #2: 2	أَمْكَنَ إفْرَادُ
u'أَمْكَنَ إِفْرَادٌ':Subject, #3: 3	يُمْكِنُ إفْرَادُ
u'أَمْكَنَ إِفْرَادٌ':Subject, #4: 4	يُمْكِنُ إفْرَادُهُ
u'أَمْكَنَ إِفْرَاغٌ':Subject, #5: 5	أَمْكَنَ إفْرَادُهُ
u'أَمْكَنَ إقامَةٌ':Subject, #3: 3	يُمْكِنُ الْإِفْرَاغُ
u'أَمْكَنَ إقامَةٌ':Subject, #15: 15	يُمْكِنُ إقَامَةُ
u'أَمْكَنَ إقامَةٌ':Subject, #1: 1	يُمْكِنُ إقَامَتُهُ
u'أَمْكَنَ إقامَةٌ':Subject, #1: 1	يُمْكِنُ الْإِقَامَةُ
u'أَمْكَنَ اِقْتِداءٌ':Subject, #2: 2	أَمْكَنَ إقَامَةُ
u'أَمْكَنَ اِقْتِرَاضٌ':Subject, #1: 1	يُمْكِنُ اقْتِدَاءُ
u'أَمْكَنَ إقْدَامٌ':Subject, #1: 1	يُمْكِنُ اقْتِرَاضُ
u'أَمْكَنَ اِكْتِسَابٌ':Subject, #1: 1	يُمْكِنُ الْإِقْدَامُ
u'أَمْكَنَ أَكْثَرُ':Subject, #1: 1	يُمْكِنُ اكْتِسَابُهُ
u'أَمْكَنَ إكْرَاهٌ':Subject, #1: 1	يُمْكِنُ أَكْثَرُ
u'أَمْكَنَ أكل':Subject, #1: 1	يُمْكِنُ الْإِكْرَاهُ
u'أَمْكَنَ أَكْلٌ':Subject, #1: 1	يُمْكِنُ أَكْلُ
u'أَمْكَنَ أكل':Subject, #1: 1	يُمْكِنُ أَكْلُ
u'أَمْكَنَ أَكْلٌ':Subject, #6: 6	يُمْكِنُ أَكْلُهُ
u'أَمْكَنَ إِكْمَالٌ':Subject, #6: 6	يُمْكِنُ أَكْلُهُ
u'أَمْكَنَ اِلْتِذاذٌ':Subject, #1: 1	أَمْكَنَ إكْمَالُ
u'أَمْكَنَ اِلْتِزَامٌ':Subject, #1: 1	يُمْكِنُ الْتِذَاذُهُ
u'أَمْكَنَ اِلْتِقَاطٌ':Subject, #1: 1	يُمْكِنُ الْتِزَامُ
u'أَمْكَنَ إلْحَاقٌ':Subject, #2: 2	يُمْكِنُ الْتِقَاطُهُ
u'أَمْكَنَ إلْحَاقٌ':Subject, #2: 2	أَمْكَنَ إلْحَاقُهُ
u'أَمْكَنَ إلْحَاقٌ':Subject, #2: 2	يُمْكِنُ الْإِلْحَاقُ
u'أَمْكَنَ إلْحَاقٌ':Subject, #2: 2	يُمْكِنُ إلْحَاقُ
u'أَمْكَنَ إِلْزَامٌ':Subject, #8: 8	يُمْكِنُ إلْحَاقُهُ
u'أَمْكَنَ إِلْزَامٌ':Subject, #2: 2	يُمْكِنُ إلْزَامُ
u'أَمْكَنَ إلْغَاءٌ':Subject, #3: 3	يُمْكِنُ إلْزَامُهُ
u'أَمْكَنَ إمَامٌ':Predicate, #1: 1	يُمْكِنُ إلْغَاءُ
u'أَمْكَنَ إمَامٌ':Subject, #3: 3	أَمْكَنَ الْإِمَامَ
u'أَمْكَنَ اِمْتِثَالٌ':Subject, #1: 1	أَمْكَنَ الْإِمَامُ
u'أَمْكَنَ أَمْرٌ':Subject, #1: 1	يُمْكِنُ امْتِثَالُهُ
u'أَمْكَنَ أَمْنٌ':Subject, #1: 1	أَمْكَنَ الْأَمْرُ
u'أَمْكَنَ اِنْتِزاعٌ':Subject, #1: 1	يُمْكِنُ الْأَمْنُ
u'أَمْكَنَ اِنْتِشارٌ':Subject, #3: 3	يُمْكِنُ انْتِزَاعُهُ
u'أَمْكَنَ اِنْتِظارٌ':Subject, #1: 1	يُمْكِنُ انْتِشَارُهُ
u'أَمْكَنَ اِنْتِظارٌ':Subject, #1: 1	يُمْكِنُ انْتِظَارُ
u'أَمْكَنَ اِنْتِفاعٌ':Subject, #1: 1	يُمْكِنُ انْتِظَارُهُ
u'أَمْكَنَ اِنْتِقاضٌ':Subject, #1: 1	يُمْكِنُ انْتِفَاعُ
u'أَمْكَنَ إِنْسانٌ':Subject, #1: 1	يُمْكِنُ انْتِقَاضُهُ
u'أَمْكَنَ إِنْشاءٌ':Subject, #2: 2	يُمْكِنُ الْإِنْسَانُ
u'أَمْكَنَ إِنْشادٌ':Subject, #4: 4	يُمْكِنُ إنْشَاءُ
u'أَمْكَنَ اِنْصِرافٌ':Subject, #2: 2	يُمْكِنُ إنْشَادُهُ
u'أَمْكَنَ اِنْفِكاكٌ':Subject, #1: 1	أَمْكَنَ انْصِرَافُ
u'أَمْكَنَ اِنْفِكاكٌ':Subject, #2: 2	يُمْكِنُ انْفِكَاكُ
u'أَمْكَنَ اِنْقِسَامٌ':Subject, #2: 2	يُمْكِنُ انْفِكَاكُهُ
u'أَمْكَنَ اِنْقِضاءٌ':Subject, #1: 1	يُمْكِنُ انْقِسَامُهُ
u'أَمْكَنَ اِنْقِطاعٌ':Subject, #3: 3	يُمْكِنُ انْقِضَاءُ
u'أَمْكَنَ اِنْقِيادٌ':Subject, #1: 1	يُمْكِنُ انْقِطَاعُهُ
u'أَمْكَنَ اِنْكِشَافٌ':Subject, #1: 1	أَمْكَنَ انْقِيَادُ
u'أَمْكَنَ إهْدَارٌ':Subject, #1: 1	يُمْكِنُ انْكِشَافُ
u'أَمْكَنَ إهْمَالٌ':Subject, #1: 1	يُمْكِنُ إهْدَارُهُ
u'أَمْكَنَ إِيجَابٌ':Subject, #1: 1	يُمْكِنُ إهْمَالُ
u'أَمْكَنَ إِيجَابٌ':Subject, #33: 33	يُمْكِنُ إيجَابُ
u'أَمْكَنَ إِيجَابٌ':Subject, #8: 8	أَمْكَنَ إيجَابُ
u'أَمْكَنَ إيرَادٌ':Subject, #9: 9	يُمْكِنُ إيجَابُهُ
u'أَمْكَنَ إيصَالٌ':Subject, #1: 1	يُمْكِنُ إيرَادُ
u'أَمْكَنَ إيصَالٌ':Subject, #1: 1	يُمْكِنُ إيصَالُهُ
u'أَمْكَنَ إيقَاعٌ':Subject, #4: 4	يُمْكِنُ إيصَالُ
u'أَمْكَنَ إيقَاعٌ':Subject, #1: 1	يُمْكِنُ الْإِيقَاعُ
u'أَمْكَنَ إيقَاعٌ':Subject, #3: 3	يُمْكِنُ إيقَاعُ
u'أَمْكَنَ بَخْسٌ':Subject, #9: 9	يُمْكِنُ إيقَاعُهُ
u'أَمْكَنَ بَقاءٌ':Subject, #1: 1	يُمْكِنُ الْبَخْسُ
u'أَمْكَنَ بَقاءٌ':Subject, #1: 1	يُمْكِنُ بَقَاءُ
u'أَمْكَنَ بُلُوغٌ':Subject, #2: 2	يُمْكِنُ الْبَقَاءُ
u'أَمْكَنَ بُلُوغٌ':Subject, #1: 1	يُمْكِنُ الْبُلُوغُ
u'أَمْكَنَ بُلُوغٌ':Subject, #2: 2	يُمْكِنُ بُلُوغُهُ
u'أَمْكَنَ بِنَاءٌ':Subject, #3: 3	يُمْكِنُ بُلُوغُ
u'أَمْكَنَ بِنَاءٌ':Subject, #2: 2	أَمْكَنَ الْبِنَاءُ
u'أَمْكَنَ بِنَاءٌ':Subject, #4: 4	يُمْكِنُ الْبِنَاءُ
u'أَمْكَنَ بُنْيانٌ':Subject, #5: 5	يُمْكِنُ بِنَاءُ
u'أَمْكَنَ بَيْعٌ':Subject, #1: 1	يُمْكِنُ الْبُنْيَانُ
u'أَمْكَنَ بَيْعٌ':Subject, #3: 3	أَمْكَنَ بَيْعُ
u'أَمْكَنَ بَيْعٌ':Subject, #4: 4	أَمْكَنَ بَيْعُهُ
u'أَمْكَنَ تَأْثِيرٌ':Subject, #6: 6	يُمْكِنُ بَيْعُهُ
u'أَمْكَنَ تَأْخِيرٌ':Subject, #1: 1	يُمْكِنُ تَأْثِيرُ
u'أَمْكَنَ تَأْخِيرٌ':Subject, #1: 1	أَمْكَنَ التَّأْخِيرُ
u'أَمْكَنَ تَأْخِيرٌ':Subject, #1: 1	أَمْكَنَ تَأْخِيرُ
u'أَمْكَنَ تَأْخِيرٌ':Subject, #1: 1	يُمْكِنُ تَأْخِيرُهُ
u'أَمْكَنَ تَأْيِيدٌ':Subject, #6: 6	يُمْكِنُ تَأْخِيرُ
u'أَمْكَنَ تَبْعِيض':Subject, #1: 1	يُمْكِنُ تَأْيِيدُ
u'أَمْكَنَ تَبْعِيض':Subject, #1: 1	يُمْكِنُ التَّبْعِيضُ
u'أَمْكَنَ تَبْعِيض':Subject, #1: 1	يُمْكِنُ تَبْعِيضُ
u'أَمْكَنَ تَتَابُعٌ':Subject, #2: 2	يُمْكِنُ تَبْعِيضُهُ
u'أَمْكَنَ تَتْمِيم':Subject, #2: 2	يُمْكِنُ تَتَابُعُ
u'أَمْكَنَ تَجْزِئَةٌ':Subject, #1: 1	أَمْكَنَ تَتْمِيمُهُ
u'أَمْكَنَ تَجْزِئَةٌ':Subject, #1: 1	يُمْكِنُ تَجْزِئَةُ
u'أَمْكَنَ تَجْفِيفٌ':Subject, #1: 1	يُمْكِنُ تَجْزِئَتُهُ
u'أَمْكَنَ تَجْفِيفٌ':Subject, #1: 1	أَمْكَنَ تَجْفِيفُهُ
u'أَمْكَنَ تَجْوِيزٌ':Subject, #2: 2	يُمْكِنُ تَجْفِيفُهُ
u'أَمْكَنَ تَجْوِيزٌ':Subject, #1: 1	أَمْكَنَ تَجْوِيزُهُ
u'أَمْكَنَ تَحَالُفٌ':Subject, #1: 1	يُمْكِنُ تَجْوِيزُ
u'أَمْكَنَ تَحْدِيدٌ':Subject, #1: 1	يُمْكِنُ التَّحَالُفُ
u'أَمْكَنَ تَحَرُّرٌ':Subject, #4: 4	يُمْكِنُ تَحْدِيدُهُ
u'أَمْكَنَ تَحَرُّزٌ':Predicate, #1: 1	يُمْكِنُ التَّحَرُّرُ
u'أَمْكَنَ تَحَرُّزٌ':Subject, #3: 3	يُمْكِنُ التَّحَرُّزَ
u'أَمْكَنَ تَحَرُّزٌ':Subject, #5: 5	أَمْكَنَ التَّحَرُّزُ
u'أَمْكَنَ تَحْرِيقٌ':Subject, #73: 73	يُمْكِنُ التَّحَرُّزُ
u'أَمْكَنَ تَحْصِيلٌ':Subject, #2: 2	يُمْكِنُ تَحْرِيقُهُ
u'أَمْكَنَ تَحْصِيلٌ':Subject, #1: 1	أَمْكَنَ تَحْصِيلُهُ
u'أَمْكَنَ تَحْصِيلٌ':Subject, #5: 5	أَمْكَنَ تَحْصِيلُ
u'أَمْكَنَ تَحْصِيلٌ':Subject, #6: 6	يُمْكِنُ تَحْصِيلُهُ
u'أَمْكَنَ تَحَقُّقٌ':Subject, #7: 7	يُمْكِنُ تَحْصِيلُ
u'أَمْكَنَ تَحَقُّقٌ':Subject, #1: 1	أَمْكَنَ تَحَقُّقُهُ
u'أَمْكَنَ تَحَقُّقٌ':Subject, #2: 2	أَمْكَنَ تَحَقُّقُ
u'أَمْكَنَ تَحَقُّقٌ':Subject, #2: 2	يُمْكِنُ تَحَقُّقُ
u'أَمْكَنَ تَحْقِيقٌ':Subject, #2: 2	يُمْكِنُ تَحَقُّقُهُ
u'أَمْكَنَ تَحْقِيقٌ':Subject, #2: 2	أَمْكَنَ تَحْقِيقُهُ
u'أَمْكَنَ تَحْقِيقٌ':Subject, #2: 2	يُمْكِنُ تَحْقِيقُهُ
u'أَمْكَنَ تَحْقِيقٌ':Subject, #6: 6	أَمْكَنَ تَحْقِيقُ
u'أَمْكَنَ تَحَلُّلٌ':Subject, #7: 7	يُمْكِنُ تَحْقِيقُ
u'أَمْكَنَ تَحَيُّل':Subject, #1: 1	يُمْكِنُ تَحَلُّلُ
u'أَمْكَنَ تَخْرِيجٌ':Subject, #1: 1	يُمْكِنُ التَّحَيُّلُ
u'أَمْكَنَ تَخْرِيجٌ':Subject, #2: 2	أَمْكَنَ تَخْرِيجُهُ
u'أَمْكَنَ تَخْرِيجٌ':Subject, #3: 3	يُمْكِنُ تَخْرِيجُ
u'أَمْكَنَ تَخْصِيصٌ':Subject, #7: 7	يُمْكِنُ تَخْرِيجُهُ
u'أَمْكَنَ تَخْصِيصٌ':Subject, #1: 1	أَمْكَنَ تَخْصِيصُ
u'أَمْكَنَ تَخْصِيصٌ':Subject, #1: 1	أَمْكَنَ تَخْصِيصُهُ
u'أَمْكَنَ تَخْصِيصٌ':Subject, #2: 2	يُمْكِنُ تَخْصِيصُ
u'أَمْكَنَ تَخْفِيفٌ':Subject, #2: 2	يُمْكِنُ تَخْصِيصُهُ
u'أَمْكَنَ تَخَلُّفٌ':Subject, #1: 1	أَمْكَنَ التَّخْفِيفُ
u'أَمْكَنَ تَخَلُّفٌ':Subject, #1: 1	يُمْكِنُ التَّخَلُّفُ
u'أَمْكَنَ تَخْلِيصٌ':Subject, #1: 1	يُمْكِنُ تَخَلُّفُ
u'أَمْكَنَ تَخْلِيصٌ':Subject, #1: 1	يُمْكِنُ تَخْلِيصُ
u'أَمْكَنَ تَخْلِيصٌ':Subject, #2: 2	أَمْكَنَ تَخْلِيصُ
u'أَمْكَنَ تَخْلِيصٌ':Subject, #2: 2	يُمْكِنُ تَخْلِيصُهُ
u'أَمْكَنَ تَخْيِيرٌ':Subject, #4: 4	أَمْكَنَ تَخْلِيصُهُ
u'أَمْكَنَ تَخْيِيرٌ':Subject, #1: 1	أَمْكَنَ التَّخْيِيرُ
u'أَمْكَنَ تَدَارُكٌ':Subject, #1: 1	يُمْكِنُ التَّخْيِيرُ
u'أَمْكَنَ تَدَارُكٌ':Subject, #1: 1	أَمْكَنَ التَّدَارُكُ
u'أَمْكَنَ تَدَارُكٌ':Subject, #1: 1	أَمْكَنَ تَدَارُكُ
u'أَمْكَنَ تَدَارُكٌ':Subject, #22: 22	يُمْكِنُ تَدَارُكُهُ
u'أَمْكَنَ تَدَارُكٌ':Subject, #3: 3	يُمْكِنُ التَّدَارُكُ
u'أَمْكَنَ تَرْتِيبٌ':Subject, #3: 3	يُمْكِنُ تَدَارُكُ
u'أَمْكَنَ تَرْجِيحٌ':Subject, #2: 2	أَمْكَنَ تَرْتِيبُ
u'أَمْكَنَ تَرْجِيحٌ':Subject, #1: 1	أَمْكَنَ التَّرْجِيحُ
u'أَمْكَنَ تَرْجِيحٌ':Subject, #2: 2	أَمْكَنَ تَرْجِيحُ
u'أَمْكَنَ تَرْجِيحٌ':Subject, #2: 2	يُمْكِنُ التَّرْجِيحُ
u'أَمْكَنَ تَرَدُّدٌ':Subject, #4: 4	يُمْكِنُ تَرْجِيحُ
u'أَمْكَنَ تَرَقُّبٌ':Subject, #1: 1	يُمْكِنُ التَّرَدُّدُ
u'أَمْكَنَ تَرْكٌ':Subject, #1: 1	يُمْكِنُ تَرَقُّبُ
u'أَمْكَنَ تَرْكٌ':Subject, #3: 3	يُمْكِنُ تَرْكُهُ
u'أَمْكَنَ تَرْكٌ':Subject, #4: 4	أَمْكَنَ تَرْكُهُ
u'أَمْكَنَ تَزْوِيرٌ':Subject, #4: 4	يُمْكِنُ تَرْكُ
u'أَمْكَنَ تَسْقِيف':Subject, #1: 1	يُمْكِنُ تَزْوِيرُ
u'أَمْكَنَ تَسْقِيف':Subject, #11: 11	يُمْكِنُ تَسْقِيفُهُ
u'أَمْكَنَ تَسْلِيمٌ':Subject, #1: 1	أَمْكَنَ تَسْقِيفُهُ
u'أَمْكَنَ تَسْلِيمٌ':Subject, #17: 17	يُمْكِنُ تَسْلِيمُهُ
u'أَمْكَنَ تَسْلِيمٌ':Subject, #2: 2	أَمْكَنَ التَّسْلِيمُ
u'أَمْكَنَ تَسْلِيمٌ':Subject, #3: 3	أَمْكَنَ تَسْلِيمُهُ
u'أَمْكَنَ تَسْلِيمٌ':Subject, #3: 3	يُمْكِنُ التَّسْلِيمُ
u'أَمْكَنَ تَسْوِيَةٌ':Subject, #4: 4	يُمْكِنُ تَسْلِيمُ
u'أَمْكَنَ تَسْوِيَةٌ':Subject, #1: 1	أَمْكَنَ التَّسْوِيَةُ
u'أَمْكَنَ تَسْوِيَةٌ':Subject, #1: 1	يُمْكِنُ التَّسْوِيَةُ
u'أَمْكَنَ تَسْيِيلٌ':Subject, #1: 1	يُمْكِنُ تَسْوِيَةُ
u'أَمْكَنَ تَشْكِيك':Subject, #1: 1	يُمْكِنُ تَسْيِيلُهُ
u'أَمْكَنَ تَصْحِيحٌ':Subject, #1: 1	يُمْكِنُ التَّشْكِيكُ
u'أَمْكَنَ تَصْحِيحٌ':Subject, #12: 12	يُمْكِنُ تَصْحِيحُهُ
u'أَمْكَنَ تَصْحِيحٌ':Subject, #16: 16	يُمْكِنُ تَصْحِيحُ
u'أَمْكَنَ تَصْحِيحٌ':Subject, #1: 1	يُمْكِنُ التَّصْحِيحُ
u'أَمْكَنَ تَصْحِيحٌ':Subject, #22: 22	أَمْكَنَ تَصْحِيحُهُ
u'أَمْكَنَ تَصَدُّقٌ':Subject, #4: 4	أَمْكَنَ تَصْحِيحُ
u'أَمْكَنَ تَصْدِيقٌ':Subject, #2: 2	يُمْكِنُ التَّصَدُّقُ
u'أَمْكَنَ تَصَرُّفٌ':Subject, #1: 1	يُمْكِنُ تَصْدِيقُهُ
u'أَمْكَنَ تَصْرِيحٌ':Subject, #1: 1	يُمْكِنُ التَّصَرُّفُ
u'أَمْكَنَ تَصَوُّرٌ':Subject, #1: 1	يُمْكِنُ التَّصْرِيحُ
u'أَمْكَنَ تَصَوُّرٌ':Subject, #1: 1	أَمْكَنَ تَصَوُّرُهُ
u'أَمْكَنَ تَصَوُّرٌ':Subject, #1: 1	يُمْكِنُ تَصَوُّرُهُ
u'أَمْكَنَ تَصْوِيرٌ':Subject, #3: 3	يُمْكِنُ تَصَوُّرُ
u'أَمْكَنَ تَصْوِيرٌ':Subject, #1: 1	يُمْكِنُ تَصْوِيرُ
u'أَمْكَنَ تَضْمِين':Subject, #5: 5	يُمْكِنُ تَصْوِيرُهُ
u'أَمْكَنَ تَضْمِينٌ':Subject, #1: 1	أَمْكَنَ التَّضْمِينُ
u'أَمْكَنَ تَضْيِيقٌ':Subject, #2: 2	أَمْكَنَ تَضْمِينُ
u'أَمْكَنَ تَطَرُّقٌ':Subject, #1: 1	يُمْكِنُ تَضْيِيقُ
u'أَمْكَنَ تَطَرُّقٌ':Subject, #1: 1	يُمْكِنُ التَّطَرُّقُ
u'أَمْكَنَ تَطْلِيقٌ':Subject, #1: 1	يُمْكِنُ تَطَرُّقُ
u'أَمْكَنَ تَطْهِيرٌ':Subject, #1: 1	يُمْكِنُ التَّطْلِيقُ
u'أَمْكَنَ تَطْهِيرٌ':Subject, #1: 1	أَمْكَنَ تَطْهِيرُ
u'أَمْكَنَ تَطْهِيرٌ':Subject, #2: 2	أَمْكَنَ تَطْهِيرُهُ
u'أَمْكَنَ تَعَارُضٌ':Subject, #7: 7	يُمْكِنُ تَطْهِيرُهُ
u'أَمْكَنَ تَعَاوُنٌ':Subject, #1: 1	يُمْكِنُ التَّعَارُضُ
u'أَمْكَنَ تَعْبِيرٌ':Subject, #1: 1	أَمْكَنَ التَّعَاوُنُ
u'أَمْكَنَ تَعَدُّدٌ':Subject, #2: 2	يُمْكِنُ التَّعْبِيرُ
u'أَمْكَنَ تَعَدِّي':Subject, #1: 1	أَمْكَنَ تَعَدُّدُهُ
u'أَمْكَنَ تَعْدِيَة':Subject, #1: 1	يُمْكِنُ تَعَدِّيَةُ
u'أَمْكَنَ تَعْدِيلٌ':Subject, #2: 2	يُمْكِنُ التَّعْدِيَةُ
u'أَمْكَنَ تَعْدِيلٌ':Subject, #2: 2	يُمْكِنُ تَعْدِيلُهُ
u'أَمْكَنَ تَعَرُّفٌ':Subject, #6: 6	يُمْكِنُ التَّعْدِيلُ
u'أَمْكَنَ تَعَرُّفٌ':Subject, #1: 1	أَمْكَنَ التَّعَرُّفُ
u'أَمْكَنَ تَعَرُّفٌ':Subject, #1: 1	أَمْكَنَ تَعَرُّفُ
u'أَمْكَنَ تَعَرُّفٌ':Subject, #1: 1	يُمْكِنُ التَّعَرُّفُ
u'أَمْكَنَ تَعْرِيفٌ':Subject, #1: 1	يُمْكِنُ تَعَرُّفُ
u'أَمْكَنَ تَعْرِيفٌ':Subject, #1: 1	أَمْكَنَ التَّعْرِيفُ
u'أَمْكَنَ تَعْرِيفٌ':Subject, #1: 1	أَمْكَنَ تَعْرِيفُهُ
u'أَمْكَنَ تَعْرِيفٌ':Subject, #1: 1	يُمْكِنُ التَّعْرِيفُ
u'أَمْكَنَ تَعَقُّلٌ':Subject, #1: 1	يُمْكِنُ تَعْرِيفُهُ
u'أَمْكَنَ تَعَلُّقٌ':Subject, #1: 1	يُمْكِنُ تَعَقُّلُ
u'أَمْكَنَ تَعَلُّمٌ':Subject, #2: 2	يُمْكِنُ التَّعَلُّقُ
u'أَمْكَنَ تَعَلُّمٌ':Subject, #1: 1	أَمْكَنَ التَّعَلُّمُ
u'أَمْكَنَ تَعَلُّمٌ':Subject, #1: 1	يُمْكِنُ التَّعَلُّمُ
u'أَمْكَنَ تَعْلِيقٌ':Subject, #1: 1	يُمْكِنُ تَعَلُّمُهُ
u'أَمْكَنَ تَعْلِيقٌ':Subject, #1: 1	يُمْكِنُ تَعْلِيقُهُ
u'أَمْكَنَ تَعْلِيلٌ':Subject, #2: 2	يُمْكِنُ تَعْلِيقُ
u'أَمْكَنَ تَعْلِيلٌ':Subject, #1: 1	أَمْكَنَ تَعْلِيلُهُ
u'أَمْكَنَ تَعْلِيلٌ':Subject, #1: 1	يُمْكِنُ التَّعْلِيلُ
u'أَمْكَنَ تَعْلِيمٌ':Subject, #1: 1	يُمْكِنُ تَعْلِيلُ
u'أَمْكَنَ تَعْلِيمٌ':Subject, #1: 1	يُمْكِنُ تَعْلِيمُهُ
u'أَمْكَنَ تَعْمِيمٌ':Subject, #2: 2	يُمْكِنُ تَعْلِيمُ
u'أَمْكَنَ تَعْمِيمٌ':Subject, #1: 1	يُمْكِنُ تَعْمِيمُ
u'أَمْكَنَ تَعَيُّنٌ':Subject, #1: 1	يُمْكِنُ تَعْمِيمُهُ
u'أَمْكَنَ تَعَيُّنٌ':Subject, #1: 1	أَمْكَنَ تَعَيُّنُ
u'أَمْكَنَ تَعْيِينٌ':Subject, #1: 1	يُمْكِنُ تَعَيُّنُهُ
u'أَمْكَنَ تَعْيِينٌ':Subject, #1: 1	يُمْكِنُ تَعْيِينُ
u'أَمْكَنَ تَغْرِيمٌ':Subject, #3: 3	يُمْكِنُ تَعْيِينُهُ
u'أَمْكَنَ تَغْلِيبٌ':Subject, #1: 1	يُمْكِنُ تَغْرِيمُهُ
u'أَمْكَنَ تَغْيِيبٌ':Subject, #1: 1	يُمْكِنُ تَغْلِيبُ
u'أَمْكَنَ تَغْيِيرٌ':Subject, #1: 1	يُمْكِنُ تَغْيِيبُ
u'أَمْكَنَ تَفاوُت':Subject, #1: 1	يُمْكِنُ تَغْيِيرُهُ
u'أَمْكَنَ تَفْرِيع':Subject, #1: 1	يُمْكِنُ التَّفَاوُتُ
u'أَمْكَنَ تَفْرِيغٌ':Subject, #1: 1	أَمْكَنَ التَّفْرِيعُ
u'أَمْكَنَ تَفْرِيقٌ':Subject, #1: 1	يُمْكِنُ تَفْرِيغُ
u'أَمْكَنَ تَفْصِيلٌ':Predicate, #1: 1	يُمْكِنُ التَّفْرِيقُ
u'أَمْكَنَ تَفْصِيلٌ':Subject, #1: 1	أَمْكَنَ التَّفْصِيلَ
u'أَمْكَنَ تَقَدُّمٌ':Subject, #1: 1	يُمْكِنُ التَّفْصِيلُ
u'أَمْكَنَ تَقْديرٌ':Subject, #1: 1	يُمْكِنُ تَقَدُّمُهُ
u'أَمْكَنَ تَقْديرٌ':Subject, #1: 1	أَمْكَنَ تَقْدِيرُهُ
u'أَمْكَنَ تَقْديرٌ':Subject, #1: 1	يُمْكِنُ التَّقْدِيرُ
u'أَمْكَنَ تَقْديرٌ':Subject, #1: 1	يُمْكِنُ تَقْدِيرُهُ
u'أَمْكَنَ تَقْديرٌ':Subject, #2: 2	أَمْكَنَ تَقْدِيرُ
u'أَمْكَنَ تَقْديمٌ':Subject, #6: 6	يُمْكِنُ تَقْدِيرُ
u'أَمْكَنَ تَقَرُّبٌ':Subject, #4: 4	يُمْكِنُ تَقْدِيمُهُ
u'أَمْكَنَ تَقْريرٌ':Subject, #1: 1	أَمْكَنَ التَّقَرُّبُ
u'أَمْكَنَ تَقْريرٌ':Subject, #1: 1	يُمْكِنُ التَّقْرِيرُ
u'أَمْكَنَ تَقْريرٌ':Subject, #2: 2	يُمْكِنُ تَقْرِيرُهُ
u'أَمْكَنَ تَقْويمٌ':Subject, #4: 4	يُمْكِنُ تَقْرِيرُ
u'أَمْكَنَ تَقْيِيد':Subject, #3: 3	يُمْكِنُ تَقْوِيمُهُ
u'أَمْكَنَ تَقْيِيد':Subject, #1: 1	يُمْكِنُ تَقْيِيدُ
u'أَمْكَنَ تَقْيِيد':Subject, #2: 2	يُمْكِنُ تَقْيِيدُهُ
u'أَمْكَنَ تَكْرارٌ':Subject, #3: 3	يُمْكِنُ التَّقْيِيدُ
u'أَمْكَنَ تَكَرُّرٌ':Subject, #1: 1	يُمْكِنُ تَكْرَارُهُ
u'أَمْكَنَ تَكَلُّمٌ':Subject, #2: 2	يُمْكِنُ تَكَرُّرُهُ
u'أَمْكَنَ تَكْليفٌ':Subject, #1: 1	يُمْكِنُ التَّكَلُّمُ
u'أَمْكَنَ تَكْميلٌ':Subject, #2: 2	يُمْكِنُ تَكْلِيفُ
u'أَمْكَنَ تَكْميلٌ':Subject, #1: 1	أَمْكَنَ تَكْمِيلُ
u'أَمْكَنَ تَلْخيصٌ':Subject, #4: 4	يُمْكِنُ تَكْمِيلُ
u'أَمْكَنَ تَلَفُّظٌ':Subject, #1: 1	يُمْكِنُ تَلْخِيصُ
u'أَمْكَنَ تَمَلُّكٌ':Subject, #1: 1	يُمْكِنُ التَّلَفُّظُ
u'أَمْكَنَ تَمَلُّكٌ':Subject, #1: 1	يُمْكِنُ تَمَلُّكُ
u'أَمْكَنَ تَمْلِيكٌ':Subject, #1: 1	يُمْكِنُ تَمَلُّكُهُ
u'أَمْكَنَ تَمَوُّلٌ':Subject, #6: 6	يُمْكِنُ تَمْلِيكُهُ
u'أَمْكَنَ تَمْييزٌ':Subject, #1: 1	يُمْكِنُ تَمَوُّلُهُ
u'أَمْكَنَ تَمْييزٌ':Subject, #15: 15	يُمْكِنُ التَّمْيِيزُ
u'أَمْكَنَ تَمْييزٌ':Subject, #1: 1	أَمْكَنَ تَمْيِيزٌ
u'أَمْكَنَ تَمْييزٌ':Subject, #1: 1	أَمْكَنَ تَمْيِيزُ
u'أَمْكَنَ تَمْييزٌ':Subject, #2: 2	أَمْكَنَ تَمْيِيزُهُ
u'أَمْكَنَ تَمْييزٌ':Subject, #6: 6	يُمْكِنُ تَمْيِيزُهُ
u'أَمْكَنَ تَناجُز':Subject, #8: 8	أَمْكَنَ التَّمْيِيزُ
u'أَمْكَنَ تَنَاوُلٌ':Subject, #1: 1	يُمْكِنُ التَّنَاجُزُ
u'أَمْكَنَ تَنَاوُلٌ':Subject, #1: 1	أَمْكَنَ تَنَاوُلُهُ
u'أَمْكَنَ تَنْزِيلٌ':Subject, #1: 1	يُمْكِنُ تَنَاوُلُهُ
u'أَمْكَنَ تَنْزِيلٌ':Subject, #1: 1	أَمْكَنَ تَنْزِيلُهُ
u'أَمْكَنَ تَنْزِيلٌ':Subject, #1: 1	يُمْكِنُ تَنْزِيلُ
u'أَمْكَنَ تَنْزِيلٌ':Subject, #1: 1	يُمْكِنُ تَنْزِيلُهُ
u'أَمْكَنَ تَنْشِيفٌ':Subject, #3: 3	أَمْكَنَ تَنْزِيلُ
u'أَمْكَنَ تَنْصِيفٌ':Subject, #1: 1	يُمْكِنُ تَنْشِيفُ
u'أَمْكَنَ تَنْصِيفٌ':Subject, #1: 1	أَمْكَنَ تَنْصِيفُهُ
u'أَمْكَنَ تَنْفِيذٌ':Predicate, #2: 2	يُمْكِنُ تَنْصِيفُهُ
u'أَمْكَنَ تَنْفِيذٌ':Subject, #1: 1	أَمْكَنَ تَنْفِيذَ
u'أَمْكَنَ تَنْفِيذٌ':Subject, #1: 1	أَمْكَنَ تَنْفِيذُهُ
u'أَمْكَنَ تَنْفِيذٌ':Subject, #2: 2	يُمْكِنُ تَنْفِيذُهُ
u'أَمْكَنَ تَنْفِيذٌ':Subject, #3: 3	أَمْكَنَ تَنْفِيذُ
u'أَمْكَنَ تَوْجِيهٌ':Subject, #4: 4	يُمْكِنُ تَنْفِيذُ
u'أَمْكَنَ تَوْجِيهٌ':Subject, #5: 5	يُمْكِنُ تَوْجِيهُهُ
u'أَمْكَنَ تَوْرِيث':Subject, #8: 8	يُمْكِنُ تَوْجِيهُ
u'أَمْكَنَ تَوْزِيعٌ':Subject, #1: 1	يُمْكِنُ تَوْرِيثُهُ
u'أَمْكَنَ تَوْزِيعٌ':Subject, #1: 1	يُمْكِنُ التَّوْزِيعُ
u'أَمْكَنَ تَوَصُّلٌ':Subject, #2: 2	أَمْكَنَ التَّوْزِيعُ
u'أَمْكَنَ تَوَصُّلٌ':Subject, #11: 11	يُمْكِنُ التَّوَصُّلُ
u'أَمْكَنَ تَوَصُّلٌ':Subject, #1: 1	أَمْكَنَ التَّوَصُّلُ
u'أَمْكَنَ تَوْظِيفٌ':Subject, #1: 1	أَمْكَنَ تَوَصُّلُهُ
u'أَمْكَنَ تَوْفِيَةٌ':Subject, #1: 1	يُمْكِنُ تَوْظِيفُ
u'أَمْكَنَ تَوْفِيقٌ':Subject, #3: 3	يُمْكِنُ تَوْفِيَةُ
u'أَمْكَنَ تَوْفِيقٌ':Subject, #14: 14	يُمْكِنُ التَّوْفِيقُ
u'أَمْكَنَ تَوَقُّفٌ':Subject, #7: 7	أَمْكَنَ التَّوْفِيقُ
u'أَمْكَنَ تَوَقُّفٌ':Subject, #1: 1	يُمْكِنُ تَوَقُّفُهُ
u'أَمْكَنَ تَوْكِيلٌ':Subject, #3: 3	يُمْكِنُ تَوَقُّفُ
u'أَمْكَنَ تَيَمُّمٌ':Subject, #1: 1	يُمْكِنُ تَوْكِيلُ
u'أَمْكَنَ ثُبُوتٌ':Subject, #2: 2	يُمْكِنُ التَّيَمُّمُ
u'أَمْكَنَ ثُبُوتٌ':Subject, #2: 2	يُمْكِنُ ثُبُوتُهُ
u'أَمْكَنَ جَبْرٌ':Subject, #3: 3	يُمْكِنُ ثُبُوتُ
u'أَمْكَنَ جَرٌّ':Subject, #3: 3	يُمْكِنُ جَبْرُهُ
u'أَمْكَنَ جَرَيان':Subject, #2: 2	يُمْكِنُ جَرُّهُ
u'أَمْكَنَ جَزْم':Subject, #2: 2	يُمْكِنُ جَرَيَانُ
u'أَمْكَنَ جَسٌّ':Subject, #1: 1	يُمْكِنُ الْجَزْمُ
u'أَمْكَنَ جماع':Subject, #2: 2	يُمْكِنُ جَسُّهُ
u'أَمْكَنَ جِمَاعٌ':Subject, #1: 1	يُمْكِنُ جِمَاعُهُ
u'أَمْكَنَ جمع':Subject, #1: 1	يُمْكِنُ جِمَاعُهُ
u'أَمْكَنَ جَمْعٌ':Subject, #1: 1	أَمْكَنَ جَمْعُ
u'أَمْكَنَ جَمْعٌ':Subject, #1: 1	أَمْكَنَ جَمْعٌ
u'أَمْكَنَ جمع':Subject, #1: 1	أَمْكَنَ جَمْعُ
u'أَمْكَنَ جَمْعٌ':Subject, #20: 20	أَمْكَنَ الْجَمْعُ
u'أَمْكَنَ جمع':Subject, #20: 20	أَمْكَنَ الْجَمْعُ
u'أَمْكَنَ جَمْعٌ':Subject, #36: 36	يُمْكِنُ الْجَمْعُ
u'أَمْكَنَ جمع':Subject, #36: 36	يُمْكِنُ الْجَمْعُ
u'أَمْكَنَ جَمْعٌ':Subject, #3: 3	أَمْكَنَ جَمْعُهُ
u'أَمْكَنَ جمع':Subject, #3: 3	أَمْكَنَ جَمْعُهُ
u'أَمْكَنَ جَمْعٌ':Subject, #3: 3	يُمْكِنُ جَمْعُ
u'أَمْكَنَ جمع':Subject, #3: 3	يُمْكِنُ جَمْعُ
u'أَمْكَنَ جَمْعٌ':Subject, #4: 4	يُمْكِنُ جَمْعُهُ
u'أَمْكَنَ جَوَابٌ':Predicate, #4: 4	يُمْكِنُ جَمْعُهُ
u'أَمْكَنَ جَوَابٌ':Subject, #1: 1	يُمْكِنُ الْجَوَابَ
u'أَمْكَنَ جَوَابٌ':Subject, #17: 17	يُمْكِنُ الْجَوَابُ
u'أَمْكَنَ حاكِمٌ':Predicate, #1: 1	أَمْكَنَ الْجَوَابُ
u'أَمْكَنَ حاكِمٌ':Subject, #1: 1	يُمْكِنُ الْحَاكِمَ
u'أَمْكَنَ حَبْسٌ':Subject, #1: 1	يُمْكِنُ الْحَاكِمُ
u'أَمْكَنَ حَجٌّ':Subject, #1: 1	يُمْكِنُ حَبْسُ
u'أَمْكَنَ حَجْرٌ':Subject, #1: 1	يُمْكِنُ الْحَجُّ
u'أَمْكَنَ حَجْمٌ':Subject, #1: 1	يُمْكِنُ الْحَجْرُ
u'أَمْكَنَ حَدٌّ':Subject, #1: 1	يُمْكِنُ حَجْمُهُ
u'أَمْكَنَ حَدٌّ':Subject, #1: 1	أَمْكَنَ حَدُّ
u'أَمْكَنَ حُدوثٌ':Subject, #1: 1	أَمْكَنَ حَدُّهُ
u'أَمْكَنَ حُدوثٌ':Subject, #10: 10	يُمْكِنُ حُدُوثُهُ
u'أَمْكَنَ حُدوثٌ':Subject, #1: 1	أَمْكَنَ حُدُوثُهُ
u'أَمْكَنَ حُدوثٌ':Subject, #1: 1	يُمْكِنُ حُدُوثُ
u'أَمْكَنَ حِرْزٌ':Subject, #2: 2	أَمْكَنَ حُدُوثُ
u'أَمْكَنَ حُسْبَانٌ':Subject, #1: 1	يُمْكِنُ حِرْزُهُ
u'أَمْكَنَ حَصْرٌ':Subject, #1: 1	يُمْكِنُ حُسْبَانُ
u'أَمْكَنَ حَصْرٌ':Subject, #2: 2	يُمْكِنُ حَصْرُهُ
u'أَمْكَنَ حَصَلٌ':Predicate, #6: 6	يُمْكِنُ حَصْرُ
u'أَمْكَنَ حُصُول':Subject, #1: 1	أَمْكَنَ حَصَلَ
u'أَمْكَنَ حُضورٌ':Subject, #1: 1	أَمْكَنَ حُصُولُهُ
u'أَمْكَنَ حُضُورٌ':Subject, #1: 1	أَمْكَنَ حُضُورُهُ
u'أَمْكَنَ حُضورٌ':Subject, #1: 1	أَمْكَنَ حُضُورُهُ
u'أَمْكَنَ حُضُورٌ':Subject, #1: 1	يُمْكِنُ حُضُورُهُ
u'أَمْكَنَ حِفْظٌ':Predicate, #1: 1	يُمْكِنُ حُضُورُهُ
u'أَمْكَنَ حِفْظٌ':Subject, #1: 1	أَمْكَنَ الْحِفْظَ
u'أَمْكَنَ حِفْظٌ':Subject, #1: 1	أَمْكَنَ الْحِفْظُ
u'أَمْكَنَ حِفْظٌ':Subject, #2: 2	يُمْكِنُ حِفْظُ
u'أَمْكَنَ حَقِيقٌ':Subject, #5: 5	أَمْكَنَ حِفْظُهُ
u'أَمْكَنَ حَقِيقَةٌ':Subject, #1: 1	يُمْكِنُ حَقِيقَتُهُ
u'أَمْكَنَ حَقِيقِيٌّ':Subject, #1: 1	يُمْكِنُ حَقِيقَتُهُ
u'أَمْكَنَ حُكْمٌ':Subject, #1: 1	أَمْكَنَ الْحَقِيقِيُّ
u'أَمْكَنَ حَلْقٌ':Subject, #11: 11	يُمْكِنُ الْحُكْمُ
u'أَمْكَنَ حَمْلٌ':Subject, #1: 1	يُمْكِنُ الْحَلْقُ
u'أَمْكَنَ حَمْلٌ':Subject, #1: 1	أَمْكَنَ الْحَمْلُ
u'أَمْكَنَ حَمْلٌ':Subject, #38: 38	يُمْكِنُ حَمْلُ
u'أَمْكَنَ حَمْلٌ':Subject, #3: 3	أَمْكَنَ حَمْلُ
u'أَمْكَنَ حَمْلٌ':Subject, #57: 57	يُمْكِنُ حَمْلُهُ
u'أَمْكَنَ حَمْلٌ':Subject, #7: 7	يُمْكِنُ الْحَمْلُ
u'أَمْكَنَ حَيَاةٌ':Subject, #9: 9	أَمْكَنَ حَمْلُهُ
u'أَمْكَنَ حَيَاةٌ':Subject, #1: 1	أَمْكَنَ حَيَاتُهُ
u'أَمْكَنَ حِيلَةٌ':Subject, #2: 2	يُمْكِنُ الْحَيَاةُ
u'أَمْكَنَ ختان':Subject, #1: 1	يُمْكِنُ حِيلَةٌ
u'أَمْكَنَ خِتَانٌ':Subject, #1: 1	يُمْكِنُ خِتَانُهُ
u'أَمْكَنَ خدش':Subject, #1: 1	يُمْكِنُ خِتَانُهُ
u'أَمْكَنَ خَدْشٌ':Subject, #1: 1	يُمْكِنُ الْخَدْشُ
u'أَمْكَنَ خدمة':Subject, #1: 1	يُمْكِنُ الْخَدْشُ
u'أَمْكَنَ خِدْمَةٌ':Subject, #1: 1	يُمْكِنُ خِدْمَةُ
u'أَمْكَنَ خُرُوجٌ':Subject, #1: 1	يُمْكِنُ خِدْمَةُ
u'أَمْكَنَ خُرُوجٌ':Subject, #1: 1	أَمْكَنَ خُرُوجُ
u'أَمْكَنَ خُرُوجٌ':Subject, #1: 1	أَمْكَنَ خُرُوجُهُ
u'أَمْكَنَ خُرُوجٌ':Subject, #1: 1	يُمْكِنُ خُرُوجُ
u'أَمْكَنَ خُرُوجٌ':Subject, #1: 1	يُمْكِنُ خُرُوجُهُ
u'أَمْكَنَ خَطَأٌ':Subject, #2: 2	يُمْكِنُ الْخُرُوجُ
u'أَمْكَنَ خلاص':Subject, #1: 1	يُمْكِنُ الْخَطَأُ
u'أَمْكَنَ خَلاَصٌ':Subject, #1: 1	يُمْكِنُ الْخَلَاصُ
u'أَمْكَنَ خلط':Subject, #1: 1	يُمْكِنُ الْخَلَاصُ
u'أَمْكَنَ دُخُولٌ':Subject, #1: 1	يُمْكِنُ الْخَلْطُ
u'أَمْكَنَ دُخُولٌ':Subject, #1: 1	يُمْكِنُ الدُّخُولُ
u'أَمْكَنَ دُخُولٌ':Subject, #2: 2	يُمْكِنُ دُخُولُ
u'أَمْكَنَ دفع':Subject, #4: 4	يُمْكِنُ دُخُولُهُ
u'أَمْكَنَ دَفْعٌ':Subject, #15: 15	يُمْكِنُ دَفْعُ
u'أَمْكَنَ دفع':Subject, #15: 15	يُمْكِنُ دَفْعُ
u'أَمْكَنَ دَفْعٌ':Subject, #16: 16	يُمْكِنُ دَفْعُهُ
u'أَمْكَنَ دفع':Subject, #16: 16	يُمْكِنُ دَفْعُهُ
u'أَمْكَنَ دَفْعٌ':Subject, #1: 1	أَمْكَنَ الدَّفْعُ
u'أَمْكَنَ دفع':Subject, #1: 1	أَمْكَنَ الدَّفْعُ
u'أَمْكَنَ دَفْعٌ':Subject, #2: 2	أَمْكَنَ دَفْعُ
u'أَمْكَنَ دفع':Subject, #2: 2	أَمْكَنَ دَفْعُ
u'أَمْكَنَ دَفْعٌ':Subject, #3: 3	يُمْكِنُ الدَّفْعُ
u'أَمْكَنَ دفع':Subject, #3: 3	يُمْكِنُ الدَّفْعُ
u'أَمْكَنَ دَفْعٌ':Subject, #7: 7	أَمْكَنَ دَفْعُهُ
u'أَمْكَنَ دفن':Subject, #7: 7	أَمْكَنَ دَفْعُهُ
u'أَمْكَنَ دَفْنٌ':Subject, #1: 1	أَمْكَنَ دَفْنُ
u'أَمْكَنَ دفن':Subject, #1: 1	أَمْكَنَ دَفْنُ
u'أَمْكَنَ دَفْنٌ':Subject, #1: 1	يُمْكِنُ دَفْنُهُ
u'أَمْكَنَ دَلٌّ':Predicate, #1: 1	يُمْكِنُ دَفْنُهُ
u'أَمْكَنَ دَلالَةٌ':Subject, #1: 1	أَمْكَنَ دَلَّ
u'أَمْكَنَ دونٌ':Predicate, #1: 1	أَمْكَنَ الدَّلَالَةُ
u'أَمْكَنَ ذَهَابٌ':Subject, #1: 1	يُمْكِنُ دُونَ
u'أَمْكَنَ ذَهَابٌ':Subject, #1: 1	يُمْكِنُ ذَهَابُ
u'أَمْكَنَ رَاجِعٌ':Subject, #1: 1	يُمْكِنُ ذَهَابُهُ
u'أَمْكَنَ رَاكِبٌ':Predicate, #1: 1	أَمْكَنَ رَاجِعٌ
u'أَمْكَنَ رَبْطٌ':Subject, #1: 1	أَمْكَنَ الرَّاكِبَ
u'أَمْكَنَ رَجُلٌ':Subject, #1: 1	يُمْكِنُ رَبْطُ
u'أَمْكَنَ رُجُوعٌ':Subject, #1: 1	أَمْكَنَ الرَّجُلُ
u'أَمْكَنَ رُجُوعٌ':Subject, #1: 1	يُمْكِنُ رُجُوعُ
u'أَمْكَنَ رُجُوعٌ':Subject, #2: 2	أَمْكَنَ الرُّجُوعُ
u'أَمْكَنَ رُجُوعٌ':Subject, #2: 2	يُمْكِنُ رُجُوعُهُ
u'أَمْكَنَ رَدٌّ':Subject, #7: 7	يُمْكِنُ الرُّجُوعُ
u'أَمْكَنَ رَدٌّ':Subject, #15: 15	يُمْكِنُ رَدُّهُ
u'أَمْكَنَ رَدٌّ':Subject, #1: 1	أَمْكَنَ الرَّدُّ
u'أَمْكَنَ رَدٌّ':Subject, #1: 1	أَمْكَنَ رَدُّ
u'أَمْكَنَ رَدٌّ':Subject, #1: 1	يُمْكِنُ الرَّدُّ
u'أَمْكَنَ رَدٌّ':Subject, #4: 4	أَمْكَنَ رَدُّهُ
u'أَمْكَنَ رَسْمٌ':Subject, #8: 8	يُمْكِنُ رَدُّ
u'أَمْكَنَ رِعايَةٌ':Subject, #1: 1	يُمْكِنُ رَسْمُهُ
u'أَمْكَنَ رِعايَةٌ':Subject, #1: 1	يُمْكِنُ رِعَايَةُ
u'أَمْكَنَ رَفْعٌ':Subject, #2: 2	يُمْكِنُ رِعَايَتُهُ
u'أَمْكَنَ رَفْعٌ':Subject, #11: 11	يُمْكِنُ رَفْعُهُ
u'أَمْكَنَ رُقِيٌّ':Subject, #1: 1	يُمْكِنُ الرَّفْعُ
u'أَمْكَنَ رُقِيٌّ':Subject, #1: 1	أَمْكَنَ رُقِيُّهُ
u'أَمْكَنَ رُكوبٌ':Subject, #1: 1	يُمْكِنُ الرُّقِيُّ
u'أَمْكَنَ رُكوبٌ':Subject, #1: 1	يُمْكِنُ الرُّكُوبُ
u'أَمْكَنَ رُؤْيَةٌ':Subject, #1: 1	يُمْكِنُ رُكُوبُهُ
u'أَمْكَنَ رُؤْيَةٌ':Subject, #6: 6	يُمْكِنُ رُؤْيَتُهُ
u'أَمْكَنَ زِراعَةٌ':Subject, #7: 7	يُمْكِنُ رُؤْيَةُ
u'أَمْكَنَ زِراعَةٌ':Subject, #1: 1	يُمْكِنُ الزِّرَاعَةُ
u'أَمْكَنَ زَرْعٌ':Subject, #2: 2	يُمْكِنُ زِرَاعَةُ
u'أَمْكَنَ زَرْعٌ':Subject, #2: 2	أَمْكَنَ زَرْعُهُ
u'أَمْكَنَ زَوالٌ':Subject, #2: 2	يُمْكِنُ زَرْعُهُ
u'أَمْكَنَ زَوالٌ':Subject, #1: 1	أَمْكَنَ زَوَالُ
u'أَمْكَنَ زَوالٌ':Subject, #2: 2	أَمْكَنَ زَوَالُهُ
u'أَمْكَنَ زَوالٌ':Subject, #4: 4	يُمْكِنُ زَوَالُ
u'أَمْكَنَ زَوْجٌ':Predicate, #5: 5	يُمْكِنُ زَوَالُهُ
u'أَمْكَنَ زَوْجٌ':Subject, #1: 1	يُمْكِنُ الزَّوْجَ
u'أَمْكَنَ زِيادَةٌ':Subject, #1: 1	أَمْكَنَ الزَّوْجُ
u'أَمْكَنَ زِيادَةٌ':Subject, #1: 1	يُمْكِنُ زِيَادَةُ
u'أَمْكَنَ سَاخِرٌ':Predicate, #3: 3	يُمْكِنُ الزِّيَادَةُ
u'أَمْكَنَ سَائِرٌ':Predicate, #1: 1	أَمْكَنَ السَّاخِرَ
u'أَمْكَنَ سَبْقٌ':Subject, #1: 1	أَمْكَنَ سَائِرَ
u'أَمْكَنَ سَبْقٌ':Subject, #1: 1	أَمْكَنَ سَبْقُ
u'أَمْكَنَ سَبْقٌ':Subject, #1: 1	يُمْكِنُ سَبْقُ
u'أَمْكَنَ سَبْيٌ':Subject, #2: 2	يُمْكِنُ سَبْقُهُ
u'أَمْكَنَ سُجُودٌ':Subject, #1: 1	أَمْكَنَ السَّبْيُ
u'أَمْكَنَ سُجُودٌ':Subject, #1: 1	يُمْكِنُ السُّجُودُ
u'أَمْكَنَ سَدٌّ':Subject, #1: 1	يُمْكِنُ سُجُودُ
u'أَمْكَنَ سَرَيَانٌ':Subject, #1: 1	أَمْكَنَ سَدُّ
u'أَمْكَنَ سُقُوطٌ':Subject, #2: 2	أَمْكَنَ السَّرَيَانُ
u'أَمْكَنَ سَقْيٌ':Subject, #1: 1	يُمْكِنُ سُقُوطُهُ
u'أَمْكَنَ سَقْيٌ':Subject, #1: 1	يُمْكِنُ سَقْيُهُ
u'أَمْكَنَ سُلْطَانٌ':Predicate, #2: 2	يُمْكِنُ السَّقْيُ
u'أَمْكَنَ سَلَمٌ':Subject, #1: 1	أَمْكَنَ السُّلْطَانَ
u'أَمْكَنَ سُلُوكٌ':Subject, #1: 1	يُمْكِنُ السَّلَمُ
u'أَمْكَنَ سُلُوك':Subject, #1: 1	أَمْكَنَ سُلُوكُهُ
u'أَمْكَنَ سُلُوكٌ':Subject, #1: 1	أَمْكَنَ سُلُوكُهُ
u'أَمْكَنَ سُلُوك':Subject, #1: 1	يُمْكِنُ سُلُوكُهُ
u'أَمْكَنَ سَمَاعٌ':Subject, #1: 1	يُمْكِنُ سُلُوكُهُ
u'أَمْكَنَ سَمَاعٌ':Subject, #1: 1	أَمْكَنَ سَمَاعُ
u'أَمْكَنَ سَمَاعٌ':Subject, #1: 1	أَمْكَنَ سَمَاعُهُ
u'أَمْكَنَ سُؤَالٌ':Subject, #1: 1	يُمْكِنُ السَّمَاعُ
u'أَمْكَنَ شَاهِدٌ':Subject, #1: 1	أَمْكَنَ سُؤَالُهُ
u'أَمْكَنَ شُبْهَةٌ':Subject, #1: 1	يُمْكِنُ الشَّاهِدُ
u'أَمْكَنَ شَدٌّ':Subject, #1: 1	يُمْكِنُ الشُّبْهَةُ
u'أَمْكَنَ شِرَاءٌ':Subject, #1: 1	يُمْكِنُ شَدُّ
u'أَمْكَنَ شِرَاءٌ':Subject, #1: 1	يُمْكِنُ شِرَاءُ
u'أَمْكَنَ شرب':Subject, #2: 2	يُمْكِنُ الشِّرَاءُ
u'أَمْكَنَ شُرْبٌ':Subject, #4: 4	يُمْكِنُ شُرْبُهُ
u'أَمْكَنَ شَرْطٌ':Subject, #4: 4	يُمْكِنُ شُرْبُهُ
u'أَمْكَنَ شركة':Subject, #3: 3	يُمْكِنُ شَرْطٌ
u'أَمْكَنَ شَرِكَةٌ':Subject, #1: 1	يُمْكِنُ الشَّرِكَةُ
u'أَمْكَنَ شُرُوعٌ':Subject, #1: 1	يُمْكِنُ الشَّرِكَةُ
u'أَمْكَنَ شفعة':Subject, #1: 1	يُمْكِنُ الشُّرُوعُ
u'أَمْكَنَ شُفْعَةٌ':Subject, #1: 1	يُمْكِنُ الشُّفْعَةُ
u'أَمْكَنَ شَهَادَةٌ':Subject, #1: 1	يُمْكِنُ الشُّفْعَةُ
u'أَمْكَنَ شُهُودٌ':Subject, #1: 1	يُمْكِنُ الشَّهَادَةُ
u'أَمْكَنَ شَيْطَانٌ':Predicate, #1: 1	يُمْكِنُ شُهُودُهُ
u'أَمْكَنَ صِبَا':Subject, #1: 1	أَمْكَنَ الشَّيْطَانَ
u'أَمْكَنَ صَبْغٌ':Subject, #2: 2	أَمْكَنَ صِبَاهُ
u'أَمْكَنَ صَبِيٌّ':Predicate, #1: 1	أَمْكَنَ الصَّبْغُ
u'أَمْكَنَ صِحَّةٌ':Subject, #2: 2	أَمْكَنَ الصَّبِيَّ
u'أَمْكَنَ صِحَّةٌ':Subject, #1: 1	يُمْكِنُ صِحَّةُ
u'أَمْكَنَ صدق':Subject, #2: 2	يُمْكِنُ صِحَّتُهُ
u'أَمْكَنَ صِدْقٌ':Subject, #3: 3	يُمْكِنُ صِدْقُهُ
u'أَمْكَنَ صَرْفٌ':Subject, #3: 3	يُمْكِنُ صِدْقُهُ
u'أَمْكَنَ صَرْف':Subject, #1: 1	يُمْكِنُ الصَّرْفُ
u'أَمْكَنَ صَرْفٌ':Subject, #1: 1	يُمْكِنُ الصَّرْفُ
u'أَمْكَنَ صَرْف':Subject, #2: 2	أَمْكَنَ صَرْفُهُ
u'أَمْكَنَ صَرْفٌ':Subject, #2: 2	أَمْكَنَ صَرْفُهُ
u'أَمْكَنَ صَرْف':Subject, #5: 5	أَمْكَنَ صَرْفُ
u'أَمْكَنَ صَرْفٌ':Subject, #5: 5	أَمْكَنَ صَرْفُ
u'أَمْكَنَ صَرْف':Subject, #8: 8	يُمْكِنُ صَرْفُ
u'أَمْكَنَ صَرْفٌ':Subject, #8: 8	يُمْكِنُ صَرْفُ
u'أَمْكَنَ صَرْف':Subject, #9: 9	يُمْكِنُ صَرْفُهُ
u'أَمْكَنَ صُعُودٌ':Subject, #9: 9	يُمْكِنُ صَرْفُهُ
u'أَمْكَنَ صَغِيرٌ':Predicate, #2: 2	يُمْكِنُ صُعُودُهُ
u'أَمْكَنَ صَلاَةٌ':Subject, #2: 2	يُمْكِنُ الصَّغِيرَ
u'أَمْكَنَ صَلاَةٌ':Subject, #1: 1	أَمْكَنَ الصَّلَاةُ
u'أَمْكَنَ صَوْمٌ':Subject, #2: 2	يُمْكِنُ الصَّلَاةُ
u'أَمْكَنَ صَوْنٌ':Subject, #1: 1	يُمْكِنُ صَوْمُ
u'أَمْكَنَ صَوْنٌ':Subject, #1: 1	أَمْكَنَ صَوْنُهُ
u'أَمْكَنَ صَوْنٌ':Subject, #4: 4	يُمْكِنُ صَوْنُ
u'أَمْكَنَ ضَبْطٌ':Subject, #4: 4	يُمْكِنُ صَوْنُهُ
u'أَمْكَنَ ضَبْطٌ':Subject, #18: 18	يُمْكِنُ ضَبْطُهُ
u'أَمْكَنَ ضَبْطٌ':Subject, #1: 1	أَمْكَنَ ضَبْطُهُ
u'أَمْكَنَ ضَبْطٌ':Subject, #6: 6	أَمْكَنَ ضَبْطُ
u'أَمْكَنَ ضَرْبٌ':Subject, #8: 8	يُمْكِنُ ضَبْطُ
u'أَمْكَنَ ضَمٌّ':Subject, #1: 1	يُمْكِنُ ضَرْبُ
u'أَمْكَنَ ضَمَانٌ':Subject, #1: 1	يُمْكِنُ ضَمُّ
u'أَمْكَنَ طَالِبٌ':Predicate, #1: 1	يُمْكِنُ ضَمَانُ
u'أَمْكَنَ طَبِيبٌ':Predicate, #1: 1	أَمْكَنَ الطَّالِبَ
u'أَمْكَنَ طَرْحٌ':Subject, #1: 1	أَمْكَنَ الطَّبِيبَ
u'أَمْكَنَ طَرْحٌ':Subject, #2: 2	أَمْكَنَ طَرْحُهُ
u'أَمْكَنَ طَرْدٌ':Subject, #2: 2	يُمْكِنُ طَرْحُهُ
u'أَمْكَنَ طلب':Subject, #3: 3	يُمْكِنُ طَرْدُهُ
u'أَمْكَنَ طَلَبٌ':Subject, #1: 1	يُمْكِنُ الطَّلَبُ
u'أَمْكَنَ طهر':Subject, #1: 1	يُمْكِنُ الطَّلَبُ
u'أَمْكَنَ طُهْرٌ':Subject, #1: 1	أَمْكَنَ طُهْرُهُ
u'أَمْكَنَ طهر':Subject, #1: 1	أَمْكَنَ طُهْرُهُ
u'أَمْكَنَ طُهْرٌ':Subject, #3: 3	يُمْكِنُ طُهْرُهُ
u'أَمْكَنَ ظُهورٌ':Subject, #3: 3	يُمْكِنُ طُهْرُهُ
u'أَمْكَنَ ظُهورٌ':Subject, #1: 1	أَمْكَنَ ظُهُورُ
u'أَمْكَنَ ظُهورٌ':Subject, #1: 1	يُمْكِنُ ظُهُورُ
u'أَمْكَنَ عَاجِزٌ':Predicate, #1: 1	يُمْكِنُ ظُهُورُهُ
u'أَمْكَنَ عَامِلٌ':Subject, #1: 1	أَمْكَنَ الْعَاجِزَ
u'أَمْكَنَ عُبُورٌ':Subject, #1: 1	أَمْكَنَ الْعَامِلُ
u'أَمْكَنَ عُبُورٌ':Subject, #1: 1	يُمْكِنُ الْعُبُورُ
u'أَمْكَنَ عتق':Subject, #1: 1	يُمْكِنُ عُبُورُ
u'أَمْكَنَ عِتْقٌ':Subject, #3: 3	يُمْكِنُ عِتْقُهُ
u'أَمْكَنَ عُثُور':Subject, #3: 3	يُمْكِنُ عِتْقُهُ
u'أَمْكَنَ عَدٌّ':Subject, #1: 1	أَمْكَنَ الْعُثُورُ
u'أَمْكَنَ عَدَدٌ':Subject, #2: 2	يُمْكِنُ عَدُّهُ
u'أَمْكَنَ عَدَمٌ':Subject, #1: 1	يُمْكِنُ عَدَدُهُ
u'أَمْكَنَ عُدُولٌ':Subject, #1: 1	أَمْكَنَ عَدَمُ
u'أَمْكَنَ عُرْيَانٌ':Predicate, #1: 1	يُمْكِنُ الْعُدُولُ
u'أَمْكَنَ عزل':Subject, #1: 1	أَمْكَنَ الْعُرْيَانَ
u'أَمْكَنَ عَصْرٌ':Subject, #1: 1	يُمْكِنُ عَزْلُهُ
u'أَمْكَنَ عَصْرٌ':Subject, #1: 1	أَمْكَنَ عَصْرُهُ
u'أَمْكَنَ عَصْرٌ':Subject, #1: 1	يُمْكِنُ عَصْرُ
u'أَمْكَنَ عَقْدٌ':Subject, #1: 1	يُمْكِنُ عَصْرُهُ
u'أَمْكَنَ عَقْدٌ':Subject, #1: 1	يُمْكِنُ عَقْدُ
u'أَمْكَنَ عُقُوبَةٌ':Subject, #1: 1	يُمْكِنُ عَقْدُهُ
u'أَمْكَنَ علم':Predicate, #1: 1	يُمْكِنُ الْعُقُوبَةُ
u'أَمْكَنَ علم':Subject, #1: 1	أَمْكَنَ عُلِمَ
u'أَمْكَنَ عِلْمٌ':Subject, #1: 1	أَمْكَنَ عِلْمُ
u'أَمْكَنَ علم':Subject, #1: 1	أَمْكَنَ عِلْمُ
u'أَمْكَنَ عِلْمٌ':Subject, #2: 2	يُمْكِنُ عِلْمُ
u'أَمْكَنَ علم':Subject, #2: 2	يُمْكِنُ عِلْمُ
u'أَمْكَنَ عِلْمٌ':Subject, #2: 2	يُمْكِنُ عِلْمُهُ
u'أَمْكَنَ علم':Subject, #2: 2	يُمْكِنُ عِلْمُهُ
u'أَمْكَنَ عِلْمٌ':Subject, #4: 4	يُمْكِنُ الْعِلْمُ
u'أَمْكَنَ عُلُوقٌ':Subject, #4: 4	يُمْكِنُ الْعِلْمُ
u'أَمْكَنَ عِمَارَةٌ':Subject, #1: 1	يُمْكِنُ الْعُلُوقُ
u'أَمْكَنَ عِمَارَةٌ':Subject, #2: 2	يُمْكِنُ الْعِمَارَةُ
u'أَمْكَنَ عِمَارَةٌ':Subject, #2: 2	يُمْكِنُ عِمَارَتُهُ
u'أَمْكَنَ عَمَلٌ':Subject, #3: 3	يُمْكِنُ عِمَارَةُ
u'أَمْكَنَ عَمَلٌ':Subject, #1: 1	يُمْكِنُ عَمَلُهُ
u'أَمْكَنَ عَمَلٌ':Subject, #21: 21	أَمْكَنَ الْعَمَلُ
u'أَمْكَنَ عِنَايَةٌ':Subject, #7: 7	يُمْكِنُ الْعَمَلُ
u'أَمْكَنَ عند':Predicate, #1: 1	يُمْكِنُ الْعِنَايَةُ
u'أَمْكَنَ عَهْدٌ':Subject, #1: 1	أَمْكَنَ عِنْدَ
u'أَمْكَنَ عَوْدٌ':Subject, #1: 1	أَمْكَنَ الْعَهْدُ
u'أَمْكَنَ عَوْدٌ':Subject, #1: 1	أَمْكَنَ عَوْدُهُ
u'أَمْكَنَ عَوْدٌ':Subject, #3: 3	يُمْكِنُ عَوْدُ
u'أَمْكَنَ عَوْل':Subject, #4: 4	يُمْكِنُ عَوْدُهُ
u'أَمْكَنَ غَسْلٌ':Subject, #1: 1	أَمْكَنَ الْعَوْلُ
u'أَمْكَنَ غَسْلٌ':Subject, #1: 1	أَمْكَنَ غَسْلُ
u'أَمْكَنَ غُسْلٌ':Subject, #1: 1	يُمْكِنُ الْغَسْلُ
u'أَمْكَنَ غُسْلٌ':Subject, #2: 2	أَمْكَنَ الْغُسْلُ
u'أَمْكَنَ غُسْلٌ':Subject, #2: 2	أَمْكَنَ غُسْلُهُ
u'أَمْكَنَ غَسْلٌ':Subject, #2: 2	يُمْكِنُ غُسْلُهُ
u'أَمْكَنَ غَسْلٌ':Subject, #3: 3	أَمْكَنَ غَسْلُهُ
u'أَمْكَنَ غَلَطٌ':Subject, #3: 3	يُمْكِنُ غَسْلُهُ
u'أَمْكَنَ غير':Subject, #1: 1	يُمْكِنُ الْغَلَطُ
u'أَمْكَنَ غَيْرٌ':Subject, #1: 1	يُمْكِنُ غَيْرُ
u'أَمْكَنَ غير':Subject, #1: 1	يُمْكِنُ غَيْرُ
u'أَمْكَنَ غَيْرٌ':Subject, #2: 2	أَمْكَنَ غَيْرُهُ
u'أَمْكَنَ غير':Subject, #2: 2	أَمْكَنَ غَيْرُهُ
u'أَمْكَنَ غَيْرٌ':Subject, #2: 2	يُمْكِنُ غَيْرُهُ
u'أَمْكَنَ فَتْحٌ':Predicate, #2: 2	يُمْكِنُ غَيْرُهُ
u'أَمْكَنَ فَتْحٌ':Subject, #1: 1	يُمْكِنُ فَتْحَ
u'أَمْكَنَ فَتْحٌ':Subject, #1: 1	يُمْكِنُ فَتْحُ
u'أَمْكَنَ فَتْحٌ':Subject, #3: 3	أَمْكَنَ فَتْحُ
u'أَمْكَنَ فَرْضٌ':Subject, #3: 3	يُمْكِنُ فَتْحُهُ
u'أَمْكَنَ فَرْضٌ':Subject, #1: 1	يُمْكِنُ الْفَرْضُ
u'أَمْكَنَ فَرْضٌ':Subject, #1: 1	يُمْكِنُ فَرْضُ
u'أَمْكَنَ فرق':Predicate, #1: 1	يُمْكِنُ فَرْضُهُ
u'أَمْكَنَ فَرْقٌ':Predicate, #1: 1	يُمْكِنُ الْفَرْقَ
u'أَمْكَنَ فرق':Subject, #1: 1	يُمْكِنُ الْفَرْقَ
u'أَمْكَنَ فَرْقٌ':Subject, #23: 23	يُمْكِنُ الْفَرْقُ
u'أَمْكَنَ فَرْقٌ':Subject, #23: 23	يُمْكِنُ الْفَرْقُ
u'أَمْكَنَ فرق':Subject, #2: 2	يُمْكِنُ فَرْقٌ
u'أَمْكَنَ فَرْقٌ':Subject, #6: 6	أَمْكَنَ الْفَرْقُ
u'أَمْكَنَ فَرْكٌ':Subject, #6: 6	أَمْكَنَ الْفَرْقُ
u'أَمْكَنَ فَسْخٌ':Subject, #3: 3	يُمْكِنُ فَرْكُهُ
u'أَمْكَنَ فَسْخٌ':Subject, #1: 1	أَمْكَنَ الْفَسْخُ
u'أَمْكَنَ فَسْخٌ':Subject, #1: 1	أَمْكَنَ فَسْخُهُ
u'أَمْكَنَ فَسْخٌ':Subject, #2: 2	أَمْكَنَ فَسْخُ
u'أَمْكَنَ فَسْخٌ':Subject, #2: 2	يُمْكِنُ فَسْخُهُ
u'أَمْكَنَ فَسْخٌ':Subject, #4: 4	يُمْكِنُ فَسْخُ
u'أَمْكَنَ فَصْلٌ':Subject, #7: 7	يُمْكِنُ الْفَسْخُ
u'أَمْكَنَ فَصْلٌ':Subject, #1: 1	أَمْكَنَ الْفَصْلُ
u'أَمْكَنَ فَصْلٌ':Subject, #1: 1	يُمْكِنُ الْفَصْلُ
u'أَمْكَنَ فَصْلٌ':Subject, #2: 2	يُمْكِنُ فَصْلُ
u'أَمْكَنَ فَصْلٌ':Subject, #3: 3	أَمْكَنَ فَصْلُهُ
u'أَمْكَنَ فِعْلٌ':Subject, #7: 7	يُمْكِنُ فَصْلُهُ
u'أَمْكَنَ فِعْلٌ':Subject, #1: 1	يُمْكِنُ فِعْلُ
u'أَمْكَنَ فَكٌّ':Subject, #5: 5	يُمْكِنُ فِعْلُهُ
u'أَمْكَنَ فِكَاكٌ':Subject, #1: 1	يُمْكِنُ فَكُّ
u'أَمْكَنَ فَهْمٌ':Subject, #1: 1	يُمْكِنُ فِكَاكُهُ
u'أَمْكَنَ فَهْمٌ':Subject, #1: 1	أَمْكَنَ فَهْمُ
u'أَمْكَنَ قَاضِي':Predicate, #3: 3	يُمْكِنُ فَهْمُهُ
u'أَمْكَنَ قَالٌ':Predicate, #1: 1	يُمْكِنُ الْقَاضِيَ
u'أَمْكَنَ قَبْضٌ':Subject, #1: 1	يُمْكِنُ قَالَ
u'أَمْكَنَ قَبْضٌ':Subject, #3: 3	يُمْكِنُ قَبْضُ
u'أَمْكَنَ قَبُولٌ':Subject, #6: 6	يُمْكِنُ قَبْضُهُ
u'أَمْكَنَ قتال':Subject, #1: 1	يُمْكِنُ قَبُولُهُ
u'أَمْكَنَ قِتَالٌ':Subject, #2: 2	يُمْكِنُ الْقِتَالُ
u'أَمْكَنَ قتل':Subject, #2: 2	يُمْكِنُ الْقِتَالُ
u'أَمْكَنَ قَتْلٌ':Subject, #1: 1	يُمْكِنُ الْقَتْلُ
u'أَمْكَنَ قَدَحٌ':Subject, #1: 1	يُمْكِنُ الْقَتْلُ
u'أَمْكَنَ قُدُومٌ':Subject, #1: 1	يُمْكِنُ الْقَدَحُ
u'أَمْكَنَ قَسْمٌ':Subject, #2: 2	يُمْكِنُ قُدُومُهُ
u'أَمْكَنَ قَسْمٌ':Subject, #2: 2	أَمْكَنَ قَسْمُهُ
u'أَمْكَنَ قسمة':Subject, #2: 2	يُمْكِنُ قَسْمُهُ
u'أَمْكَنَ قِسْمَةٌ':Subject, #11: 11	يُمْكِنُ قِسْمَتُهُ
u'أَمْكَنَ قسمة':Subject, #11: 11	يُمْكِنُ قِسْمَتُهُ
u'أَمْكَنَ قِسْمَةٌ':Subject, #2: 2	يُمْكِنُ الْقِسْمَةُ
u'أَمْكَنَ قسمة':Subject, #2: 2	يُمْكِنُ الْقِسْمَةُ
u'أَمْكَنَ قِسْمَةٌ':Subject, #4: 4	يُمْكِنُ قِسْمَةُ
u'أَمْكَنَ قصاص':Subject, #4: 4	يُمْكِنُ قِسْمَةُ
u'أَمْكَنَ قِصَاصٌ':Subject, #2: 2	أَمْكَنَ الْقِصَاصُ
u'أَمْكَنَ قَضَاءٌ':Subject, #2: 2	أَمْكَنَ الْقِصَاصُ
u'أَمْكَنَ قَضَاءٌ':Subject, #11: 11	يُمْكِنُ الْقَضَاءُ
u'أَمْكَنَ قَضَاءٌ':Subject, #1: 1	يُمْكِنُ قَضَاءُ
u'أَمْكَنَ قَطْعٌ':Subject, #4: 4	أَمْكَنَ الْقَضَاءُ
u'أَمْكَنَ قَطْعٌ':Subject, #10: 10	يُمْكِنُ قَطْعُ
u'أَمْكَنَ قَطْعٌ':Subject, #1: 1	يُمْكِنُ الْقَطْعُ
u'أَمْكَنَ قَوَد':Subject, #5: 5	يُمْكِنُ قَطْعُهُ
u'أَمْكَنَ قول':Subject, #1: 1	أَمْكَنَ الْقَوَدُ
u'أَمْكَنَ قَوْلٌ':Subject, #1: 1	أَمْكَنَ قَوْلُهُ
u'أَمْكَنَ قول':Subject, #1: 1	أَمْكَنَ قَوْلُهُ
u'أَمْكَنَ قَوْلٌ':Subject, #29: 29	يُمْكِنُ الْقَوْلُ
u'أَمْكَنَ قول':Subject, #29: 29	يُمْكِنُ الْقَوْلُ
u'أَمْكَنَ قَوْلٌ':Subject, #8: 8	أَمْكَنَ الْقَوْلُ
u'أَمْكَنَ قِيَاسٌ':Subject, #8: 8	أَمْكَنَ الْقَوْلُ
u'أَمْكَنَ قِيَاسٌ':Subject, #2: 2	يُمْكِنُ الْقِيَاسُ
u'أَمْكَنَ قِيَاسٌ':Subject, #2: 2	يُمْكِنُ قِيَاسُ
u'أَمْكَنَ قيام':Subject, #2: 2	يُمْكِنُ قِيَاسُهُ
u'أَمْكَنَ قِيَامٌ':Subject, #1: 1	يُمْكِنُ قِيَامُهُ
u'أَمْكَنَ قيام':Subject, #1: 1	يُمْكِنُ قِيَامُهُ
u'أَمْكَنَ قِيَامٌ':Subject, #2: 2	يُمْكِنُ الْقِيَامُ
u'أَمْكَنَ كَرْع':Subject, #2: 2	يُمْكِنُ الْقِيَامُ
u'أَمْكَنَ كَشْفٌ':Subject, #2: 2	يُمْكِنُ الْكَرْعُ
u'أَمْكَنَ كَشْفٌ':Subject, #1: 1	أَمْكَنَ كَشْفُهُ
u'أَمْكَنَ كَفٌّ':Subject, #1: 1	يُمْكِنُ الْكَشْفُ
u'أَمْكَنَ كَلاَمٌ':Subject, #1: 1	يُمْكِنُ كَفُّ
u'أَمْكَنَ كَوْنٌ':Subject, #1: 1	يُمْكِنُ الْكَلَامُ
u'أَمْكَنَ كَوْنٌ':Subject, #24: 24	يُمْكِنُ كَوْنُهُ
u'أَمْكَنَ كَوْنٌ':Subject, #2: 2	أَمْكَنَ كَوْنُ
u'أَمْكَنَ كَوْنٌ':Subject, #5: 5	يُمْكِنُ كَوْنُ
u'أَمْكَنَ كَيْلٌ':Subject, #8: 8	أَمْكَنَ كَوْنُهُ
u'أَمْكَنَ كَيْلٌ':Subject, #1: 1	أَمْكَنَ كَيْلُهُ
u'أَمْكَنَ لبس':Subject, #2: 2	يُمْكِنُ كَيْلُهُ
u'أَمْكَنَ لُبْسٌ':Subject, #1: 1	أَمْكَنَ لُبْسُ
u'أَمْكَنَ لبس':Subject, #1: 1	أَمْكَنَ لُبْسُ
u'أَمْكَنَ لُبْسٌ':Subject, #1: 1	يُمْكِنُ لُبْسُهُ
u'أَمْكَنَ لَفْظٌ':Subject, #1: 1	يُمْكِنُ لُبْسُهُ
u'أَمْكَنَ لَقْطٌ':Subject, #1: 1	يُمْكِنُ لَفْظُهُ
u'أَمْكَنَ مَاءٌ':Subject, #1: 1	يُمْكِنُ لَقْطُهُ
u'أَمْكَنَ مَارٌّ':Predicate, #1: 1	أَمْكَنَ مَاءٌ
u'أَمْكَنَ مُبَادَرَةٌ':Subject, #1: 1	أَمْكَنَ الْمَارَّ
u'أَمْكَنَ مُتَابَعٌ':Subject, #1: 1	يُمْكِنُ الْمُبَادَرَةُ
u'أَمْكَنَ مُتَابَعٌ':Subject, #2: 2	أَمْكَنَ مُتَابَعَةُ
u'أَمْكَنَ مُتَابَعَةٌ':Subject, #3: 3	يُمْكِنُ مُتَابَعَةُ
u'أَمْكَنَ مُتَابَعَةٌ':Subject, #2: 2	أَمْكَنَ مُتَابَعَةُ
u'أَمْكَنَ مثل':Predicate, #3: 3	يُمْكِنُ مُتَابَعَةُ
u'أَمْكَنَ مِثْلٌ':Predicate, #1: 1	أَمْكَنَ مِثْلَ
u'أَمْكَنَ مثل':Subject, #1: 1	أَمْكَنَ مِثْلَ
u'أَمْكَنَ مِثْلٌ':Subject, #4: 4	يُمْكِنُ مِثْلُهُ
u'أَمْكَنَ مُجَاوَزَةٌ':Subject, #4: 4	يُمْكِنُ مِثْلُهُ
u'أَمْكَنَ مُخَاصَمَةٌ':Subject, #1: 1	يُمْكِنُ الْمُجَاوَزَةُ
u'أَمْكَنَ مُدَاوَاةٌ':Subject, #1: 1	يُمْكِنُ مُخَاصَمَتُهُ
u'أَمْكَنَ مُدَّعِي':Predicate, #1: 1	يُمْكِنُ مُدَاوَاتُهُ
u'أَمْكَنَ مُرَاجَعَةٌ':Subject, #1: 1	يُمْكِنُ الْمُدَّعِيَ
u'أَمْكَنَ مُرَاجَعَةٌ':Subject, #1: 1	أَمْكَنَ مُرَاجَعَتُهُ
u'أَمْكَنَ مُرَاعَاةٌ':Subject, #1: 1	يُمْكِنُ مُرَاجَعَتُهُ
u'أَمْكَنَ مُرَاعَاةٌ':Subject, #1: 1	يُمْكِنُ مُرَاعَاةُ
u'أَمْكَنَ مُرُورٌ':Subject, #4: 4	أَمْكَنَ مُرَاعَاةُ
u'أَمْكَنَ مُرُورٌ':Subject, #1: 1	أَمْكَنَ الْمُرُورُ
u'أَمْكَنَ مُرُورٌ':Subject, #1: 1	يُمْكِنُ الْمُرُورُ
u'أَمْكَنَ مَرِيضٌ':Predicate, #2: 2	يُمْكِنُ مُرُورُ
u'أَمْكَنَ مُزَاحَمَةٌ':Subject, #1: 1	أَمْكَنَ الْمَرِيضَ
u'أَمْكَنَ مُسَاوَاةٌ':Subject, #1: 1	أَمْكَنَ الْمُزَاحَمَةُ
u'أَمْكَنَ مَسْحٌ':Subject, #4: 4	يُمْكِنُ الْمُسَاوَاةُ
u'أَمْكَنَ مَسْحٌ':Subject, #1: 1	يُمْكِنُ الْمَسْحُ
u'أَمْكَنَ مَسْحٌ':Subject, #1: 1	يُمْكِنُ مَسْحُ
u'أَمْكَنَ مَسْحٌ':Subject, #2: 2	أَمْكَنَ مَسْحُهُ
u'أَمْكَنَ مُشَاحَّةٌ':Subject, #2: 2	يُمْكِنُ مَسْحُهُ
u'أَمْكَنَ مَشْيٌ':Subject, #1: 1	يُمْكِنُ الْمُشَاحَّةُ
u'أَمْكَنَ مُصَادَفَةٌ':Subject, #8: 8	يُمْكِنُ الْمَشْيُ
u'أَمْكَنَ مَصِيرٌ':Subject, #1: 1	أَمْكَنَ مُصَادَفَتُهُ
u'أَمْكَنَ مُضِيٌّ':Subject, #1: 1	يُمْكِنُ الْمَصِيرُ
u'أَمْكَنَ مُطَالَبٌ':Subject, #4: 4	يُمْكِنُ الْمُضِيُّ
u'أَمْكَنَ مُطَالَبٌ':Subject, #1: 1	يُمْكِنُ الْمُطَالَبَةُ
u'أَمْكَنَ مُطَالَبٌ':Subject, #2: 2	يُمْكِنُ مُطَالَبَةُ
u'أَمْكَنَ مُطَالَبَةٌ':Subject, #2: 2	يُمْكِنُ مُطَالَبَتُهُ
u'أَمْكَنَ مُطَالَبَةٌ':Subject, #1: 1	يُمْكِنُ الْمُطَالَبَةُ
u'أَمْكَنَ مُطَالَبَةٌ':Subject, #2: 2	يُمْكِنُ مُطَالَبَةُ
u'أَمْكَنَ مُعَارَضَةٌ':Subject, #2: 2	يُمْكِنُ مُطَالَبَتُهُ
u'أَمْكَنَ مَعَارِيضُ':Subject, #1: 1	يُمْكِنُ مُعَارَضَتُهُ
u'أَمْكَنَ مَعْرِفَةٌ':Predicate, #4: 4	أَمْكَنَ الْمَعَارِيضُ
u'أَمْكَنَ مَعْرِفَة':Predicate, #1: 1	يُمْكِنُ مَعْرِفَةَ
u'أَمْكَنَ مَعْرِفَةٌ':Subject, #1: 1	يُمْكِنُ مَعْرِفَةَ
u'أَمْكَنَ مَعْرِفَة':Subject, #10: 10	يُمْكِنُ مَعْرِفَتُهُ
u'أَمْكَنَ مَعْرِفَةٌ':Subject, #10: 10	يُمْكِنُ مَعْرِفَتُهُ
u'أَمْكَنَ مَعْرِفَة':Subject, #1: 1	أَمْكَنَ مَعْرِفَتُهُ
u'أَمْكَنَ مَعْرِفَةٌ':Subject, #1: 1	أَمْكَنَ مَعْرِفَتُهُ
u'أَمْكَنَ مَعْرِفَة':Subject, #8: 8	أَمْكَنَ مَعْرِفَةُ
u'أَمْكَنَ مَعْرِفَةٌ':Subject, #8: 8	أَمْكَنَ مَعْرِفَةُ
u'أَمْكَنَ مَعْرِفَة':Subject, #8: 8	يُمْكِنُ مَعْرِفَةُ
u'أَمْكَنَ مَعُونَةٌ':Subject, #8: 8	يُمْكِنُ مَعْرِفَةُ
u'أَمْكَنَ مُغالَبَة':Subject, #1: 1	أَمْكَنَ الْمَعُونَةُ
u'أَمْكَنَ مُغْتاب':Subject, #1: 1	يُمْكِنُ مُغَالَبَتُهُ
u'أَمْكَنَ مُفْسِدٌ':Subject, #1: 1	يُمْكِنُ الْمُغْتَابُ
u'أَمْكَنَ مَقَامٌ':Subject, #1: 1	يُمْكِنُ مُفْسِدٌ
u'أَمْكَنَ مُقَامٌ':Subject, #1: 1	يُمْكِنُ الْمَقَامُ
u'أَمْكَنَ مُقَدَّمٌ':Subject, #1: 1	يُمْكِنُ الْمُقَامُ
u'أَمْكَنَ مُكَلَّفٌ':Subject, #1: 1	أَمْكَنَ مُقَدَّمٌ
u'أَمْكَنَ مُمَاثَلَةٌ':Subject, #2: 2	يُمْكِنُ الْمُكَلَّفُ
u'أَمْكَنَ مُنَازَعٌ':Subject, #6: 6	يُمْكِنُ الْمُمَاثَلَةُ
u'أَمْكَنَ مُنَازَعَةٌ':Subject, #3: 3	يُمْكِنُ الْمُنَازَعَةُ
u'أَمْكَنَ مَنْعٌ':Subject, #3: 3	يُمْكِنُ الْمُنَازَعَةُ
u'أَمْكَنَ مَنْعٌ':Subject, #2: 2	يُمْكِنُ مَنْعُ
u'أَمْكَنَ مُوَاظَبَةٌ':Subject, #5: 5	يُمْكِنُ مَنْعُهُ
u'أَمْكَنَ مُودَعٌ':Predicate, #3: 3	يُمْكِنُ مُوَاظَبَةُ
u'أَمْكَنَ مُوَكِّلٌ':Predicate, #1: 1	يُمْكِنُ الْمُودَعَ
u'أَمْكَنَ مَيْزٌ':Subject, #1: 1	يُمْكِنُ الْمُوَكِّلَ
u'أَمْكَنَ نَحْتٌ':Subject, #2: 2	يُمْكِنُ الْمَيْزُ
u'أَمْكَنَ نزاع':Subject, #1: 1	أَمْكَنَ نَحْتُهُ
u'أَمْكَنَ نِزَاعٌ':Subject, #1: 1	يُمْكِنُ النِّزَاعُ
u'أَمْكَنَ نَزْعٌ':Subject, #1: 1	يُمْكِنُ النِّزَاعُ
u'أَمْكَنَ نَزْعٌ':Subject, #1: 1	أَمْكَنَ نَزْعُهُ
u'أَمْكَنَ نَزْعٌ':Subject, #1: 1	يُمْكِنُ نَزْعُ
u'أَمْكَنَ نِسْبَةٌ':Subject, #2: 2	يُمْكِنُ نَزْعُهُ
u'أَمْكَنَ نِسْبَةٌ':Subject, #1: 1	أَمْكَنَ نِسْبَةُ
u'أَمْكَنَ نِسْبَةٌ':Subject, #2: 2	أَمْكَنَ نِسْبَتُهُ
u'أَمْكَنَ نَظَرٌ':Subject, #2: 2	يُمْكِنُ نِسْبَتُهُ
u'أَمْكَنَ نُفُوذٌ':Subject, #1: 1	أَمْكَنَ النَّظَرُ
u'أَمْكَنَ نُفُوذٌ':Subject, #1: 1	يُمْكِنُ النُّفُوذُ
u'أَمْكَنَ نَفْيٌ':Subject, #1: 1	يُمْكِنُ نُفُوذُهُ
u'أَمْكَنَ نَقْضٌ':Subject, #1: 1	يُمْكِنُ نَفْيُهُ
u'أَمْكَنَ نَقْضٌ':Subject, #11: 11	يُمْكِنُ نَقْضُهُ
u'أَمْكَنَ نَقْضٌ':Subject, #1: 1	أَمْكَنَ نَقْضُ
u'أَمْكَنَ نقل':Subject, #4: 4	يُمْكِنُ نَقْضُ
u'أَمْكَنَ نَقْلٌ':Subject, #1: 1	يُمْكِنُ النَّقْلُ
u'أَمْكَنَ نقل':Subject, #1: 1	يُمْكِنُ النَّقْلُ
u'أَمْكَنَ نَقْلٌ':Subject, #1: 1	يُمْكِنُ نَقْلُ
u'أَمْكَنَ نقل':Subject, #1: 1	يُمْكِنُ نَقْلُ
u'أَمْكَنَ نَقْلٌ':Subject, #6: 6	أَمْكَنَ نَقْلُهُ
u'أَمْكَنَ نقل':Subject, #6: 6	أَمْكَنَ نَقْلُهُ
u'أَمْكَنَ نَقْلٌ':Subject, #9: 9	يُمْكِنُ نَقْلُهُ
u'أَمْكَنَ نِيَّةٌ':Subject, #9: 9	يُمْكِنُ نَقْلُهُ
u'أَمْكَنَ هَتْكٌ':Subject, #1: 1	يُمْكِنُ نِيَّتُهُ
u'أَمْكَنَ هَدْمٌ':Subject, #1: 1	يُمْكِنُ هَتْكُ
u'أَمْكَنَ وَاجِبٌ':Subject, #1: 1	أَمْكَنَ هَدْمُهُ
u'أَمْكَنَ وَاصِلٌ':Predicate, #3: 3	أَمْكَنَ وَاجِبٌ
u'أَمْكَنَ وُجُوبٌ':Subject, #1: 1	أَمْكَنَ الْوَاصِلَ
u'أَمْكَنَ وُجُودٌ':Subject, #1: 1	يُمْكِنُ الْوُجُوبُ
u'أَمْكَنَ وُجُودٌ':Subject, #1: 1	أَمْكَنَ وُجُودُ
u'أَمْكَنَ وُجُودٌ':Subject, #2: 2	يُمْكِنُ وُجُودُهُ
u'أَمْكَنَ وُرُودٌ':Subject, #9: 9	يُمْكِنُ وُجُودُ
u'أَمْكَنَ وَصْفٌ':Subject, #1: 1	يُمْكِنُ وُرُودُهُ
u'أَمْكَنَ وَصْفٌ':Subject, #1: 1	أَمْكَنَ وَصْفُهُ
u'أَمْكَنَ وَصْفٌ':Subject, #4: 4	يُمْكِنُ وَصْفُ
u'أَمْكَنَ وُصُولٌ':Subject, #6: 6	يُمْكِنُ وَصْفُهُ
u'أَمْكَنَ وُصُولٌ':Subject, #10: 10	يُمْكِنُ الْوُصُولُ
u'أَمْكَنَ وُصُولٌ':Subject, #1: 1	يُمْكِنُ وُصُولُهُ
u'أَمْكَنَ وُصُولٌ':Subject, #2: 2	أَمْكَنَ وُصُولُهُ
u'أَمْكَنَ وُصُولٌ':Subject, #2: 2	يُمْكِنُ وُصُولُ
u'أَمْكَنَ وَضْعٌ':Subject, #5: 5	أَمْكَنَ الْوُصُولُ
u'أَمْكَنَ وَضْعٌ':Subject, #1: 1	يُمْكِنُ وَضْعُ
u'أَمْكَنَ وَطْءٌ':Predicate, #1: 1	يُمْكِنُ وَضْعُهُ
u'أَمْكَنَ وَطْءٌ':Subject, #1: 1	أَمْكَنَ الْوَطْءَ
u'أَمْكَنَ وَطْءٌ':Subject, #3: 3	أَمْكَنَ الْوَطْءُ
u'أَمْكَنَ وَفَاءٌ':Subject, #3: 3	يُمْكِنُ الْوَطْءُ
u'أَمْكَنَ وُقُوعٌ':Subject, #6: 6	يُمْكِنُ الْوَفَاءُ
u'أَمْكَنَ وُقُوعٌ':Subject, #10: 10	يُمْكِنُ وُقُوعُهُ
u'أَمْكَنَ وُقُوعٌ':Subject, #1: 1	أَمْكَنَ وُقُوعُ
u'أَمْكَنَ وُقُوعٌ':Subject, #1: 1	يُمْكِنُ الْوُقُوعُ
u'أَمْكَنَ وُقُوعٌ':Subject, #2: 2	أَمْكَنَ وُقُوعُهُ
u'أَمْكَنَ وُقُوفٌ':Subject, #3: 3	يُمْكِنُ وُقُوعُ
u'أَمْكَنَ وُقُوفٌ':Subject, #15: 15	يُمْكِنُ الْوُقُوفُ
u'أَمْكَنَ ولد':Predicate, #1: 1	أَمْكَنَ الْوُقُوفُ
u'أَمْكَنَ وَلَدٌ':Predicate, #1: 1	أَمْكَنَ الْوَلَدَ
u'أَمْكَنَ وَلَهٌ':Subject, #1: 1	أَمْكَنَ الْوَلَدَ
u'أَمْكَنَ يَقِينٌ':Subject, #2: 2	أَمْكَنَ وَلَهُ
u'أَمَّلَ بَقاءٌ':Predicate, #1: 1	يُمْكِنُ الْيَقِينُ
u'أَمْلَسَ أقَلُّ':Subject, #1: 1	أَمَّلَ الْبَقَاءَ
u'أَمْلَقَ حاجٌّ':Subject, #1: 1	أَمْلَسَ أَقَلُّ
u'أَمْلَى ثَمانِيَةٌ':Predicate, #1: 1	أَمْلَقَ حَاجٌّ
u'أَمْلَى شَيْخٌ':Subject, #1: 1	أَمْلَى ثَمَانِيَةَ
u'أَمَّ مُسَافِرٌ':Predicate, #1: 1	أَمْلَى الشَّيْخُ
u'أَمَّ مُسَافِرٌ':Subject, #3: 3	أَمَّ مُسَافِرِينَ
u'أَمَّ مُقِيمٌ':Subject, #2: 2	أَمَّ الْمُسَافِرُ
u'أَمَّ مُقِيمٌ':Subject, #1: 1	أَمَّ الْمُقِيمُ
u'أَمَّ مُؤْمِنٌ':Predicate, #2: 2	أَمَّ مُقِيمٌ
u'أَمَّنَ أحَدٌ':Subject, #2: 2	أَمَّ الْمُؤْمِنِينَ
u'أَمَّ نَاسٌ':Predicate, #1: 1	أَمَّنَ أَحَدٌ
u'أَمَّنَ إمَامٌ':Subject, #14: 14	أَمَّ النَّاسَ
u'أَمِنَ إمَامٌ':Subject, #13: 13	أَمَّنَ الْإِمَامُ
u'أَمَّنَ إمَامٌ':Subject, #1: 1	أَمِنَ الْإِمَامُ
u'أَمْنٌ إِمْلاقٌ':Added, #3: 3	أَمَّنَ الإِمَامُ
u'أَمْنٌ أَمْوَالٌ':Added, #1: 1	أَمْنِ إمْلَاقٍ
u'أَمَّنَ بالِغٌ':Subject, #1: 1	أَمْنَ الْأَمْوَالِ
u'أَمَّنَ بالِغٌ':Subject, #1: 1	أَمَّنَ الْبَالِغُ
u'أَمِنَ بِرْسام':Predicate, #1: 1	أَمَّنَ بَالِغٌ
u'آمَنَ بَعْضٌ':Subject, #1: 1	أَمِنَ الْبِرْسَامَ
u'أَمْنٌ بَلَدٌ':Added, #1: 1	آمَنَ بَعْضُ
u'أَمَّ نَبِيٌّ':Predicate, #1: 1	أَمْنِ الْبَلَدِ
u'أَمَّ نَبِيٌّ':Subject, #1: 1	أَمَّ النَّبِيَّ
u'أَمْنٌ تَخَلُّلٌ':Added, #1: 1	أَمَّ النَّبِيُّ
u'أَمِنَ تَشْوِيشٌ':Predicate, #1: 1	أَمْنِ التَّخَلُّلِ
u'أَمِنَ تَعْيِيرٌ':Predicate, #1: 1	أَمِنَ التَّشْوِيشَ
u'أَمِنَ تَغَيُّرٌ':Subject, #1: 1	أَمِنَ تَعْيِيرَ
u'أَمْنٌ تَفَسُّخٌ':Added, #1: 1	أَمِنَ التَّغَيُّرُ
u'أَمْنٌ تَلَفٌ':Added, #2: 2	أَمْنِ تَفَسُّخِهِ
u'أَمْنٌ تَلْويثٌ':Added, #2: 2	أَمْنِ تَلَفِهِ
u'أَمْنٌ تَلْويثٌ':Added, #1: 1	أَمْنِ التَّلْوِيثِ
u'أَمْنٌ جَحْد':Added, #2: 2	أَمْنِ تَلْوِيثِهِ
u'أَمِنَ جُهَّالٌ':Subject, #2: 2	أَمْنَ الْجَحْدِ
u'أَمْنٌ جوائح':Added, #1: 1	أَمِنَ الْجُهَّالُ
u'أَمْنٌ جَوَائِحُ':Added, #1: 1	أَمْنِ الْجَوَائِحِ
u'أَمْنٌ حُدوثٌ':Added, #1: 1	أَمْنِ الْجَوَائِحِ
u'أَمِنَ حُضورٌ':Predicate, #1: 1	أَمْنِ حُدُوثِ
u'أَمِنَ حُضُورٌ':Predicate, #1: 1	أَمِنَ حُضُورَ
u'أَمِنَ حيفٌ':Predicate, #1: 1	أَمِنَ حُضُورَ
u'أَمِنَ حَيْفٌ':Predicate, #1: 1	أَمِنَ الْحَيْفَ
u'أَمْنٌ حيفٌ':Added, #1: 1	أَمِنَ الْحَيْفَ
u'أَمْنٌ حَيْفٌ':Added, #1: 1	أَمْنَ الْحَيْفِ
u'أَمْنٌ حيفٌ':Added, #1: 1	أَمْنَ الْحَيْفِ
u'أَمْنٌ حَيْفٌ':Added, #2: 2	أَمْنُ الْحَيْفِ
u'أَمْنٌ حَيَوَانٌ':Added, #2: 2	أَمْنُ الْحَيْفِ
u'أَمْنٌ خَائِفٌ':Added, #1: 1	أَمْنِ الْحَيَوَانِ
u'أَمْنٌ خطر':Added, #1: 1	أَمْنَ الْخَائِفِ
u'أَمْنٌ خَطَرٌ':Added, #1: 1	أَمْنُ خَطَرِ
u'أَمْنٌ خطر':Added, #1: 1	أَمْنُ خَطَرِ
u'أَمْنٌ خَطَرٌ':Added, #2: 2	أَمْنَ خَطَرِ
u'أَمِنَ دَاءٌ':Predicate, #2: 2	أَمْنَ خَطَرِ
u'آمَنَ دَخَلٌ':Predicate, #2: 2	أَمِنَ دَاءَ
u'أَمَّنَ دونٌ':Predicate, #1: 1	آمَنَ دَخَلَ
u'أَمَّنَ رَجُلٌ':Subject, #1: 1	أَمَّنَ دُونَ
u'أَمِنَ رَجُلٌ':Subject, #1: 1	أَمَّنَ الرَّجُلُ
u'آمَنَ رَجُلٌ':Subject, #1: 1	أَمِنَ رَجُلٌ
u'أَمَّنَ رَجُلٌ':Subject, #2: 2	آمَنَ الرَّجُلُ
u'آمَنَ رَسُولٌ':Subject, #2: 2	أَمَّنَ رَجُلٌ
u'أَمَّنَ رَسُولٌ':Subject, #1: 1	آمَنَ الرّسُولُ
u'آمَنَ رَسُولٌ':Subject, #3: 3	أَمَّنَ رَسُولُ
u'آمَنَ رَسُولٌ':Subject, #4: 4	آمَنَ رَسُولُ
u'آمَنَ رَغْمٌ':Predicate, #5: 5	آمَنَ الرَّسُولُ
u'آمَنَ سفهاء':Subject, #1: 1	آمَنَ رَغْمَ
u'أَمِنَ سَلْبٌ':Predicate, #1: 1	آمَنَ السّفَهَاءُ
u'أَمِنَ شَخْصٌ':Subject, #1: 1	أَمِنَ السَّلْبَ
u'أَمِنَ شَهْوَةٌ':Predicate, #1: 1	أَمِنَ شَخْصٌ
u'أَمْنٌ شَهْوَةٌ':Added, #4: 4	أَمِنَ الشَّهْوَةَ
u'أَمِنَ صَبِيٌّ':Subject, #2: 2	أَمْنِ الشَّهْوَةِ
u'أَمَّنَ صَبِيٌّ':Subject, #1: 1	أَمِنَ الصَّبِيُّ
u'أَمْنٌ صَيْدٌ':Added, #1: 1	أَمَّنَ الصَّبِيُّ
u'أَمْنٌ صَيْدٌ':Added, #1: 1	أَمْنُ الصَّيْدِ
u'أَمْنٌ صَيْدٌ':Added, #1: 1	أَمْنُ صَيْدِ
u'أَمِنَ ضَرَرٌ':Predicate, #2: 2	أَمْنِ الصَّيْدِ
u'أَمْنٌ ضَرَرٌ':Added, #1: 1	أَمِنَ الضَّرَرَ
u'أَمْنٌ ضَرَرٌ':Added, #1: 1	أَمْنِ ضَرَرٍ
u'أَمِنَ طَرِيقٌ':Predicate, #5: 5	أَمْنِ الضَّرَرِ
u'أَمْنٌ طَرِيقٌ':Added, #1: 1	أَمِنَ الطَّرِيقَ
u'أَمْنٌ طَرِيقٌ':Added, #25: 25	أَمْنِ الطَّرِيقِ
u'أَمْنٌ طَرِيقٌ':Added, #2: 2	أَمْنِ طَرِيقٍ
u'أَمْنٌ طَرِيقٌ':Added, #4: 4	أَمْنُ الطَّرِيقِ
u'أَمِنَ ظُهورٌ':Predicate, #6: 6	أَمْنَ الطَّرِيقِ
u'أَمِنَ ظُهورٌ':Predicate, #1: 1	أَمِنَ ظُهُورَ
u'أَمْنٌ عَاهَةٌ':Added, #2: 2	أَمِنَ الظُّهُورَ
u'أَمِنَ عَبَثٌ':Predicate, #1: 1	أَمْنُ الْعَاهَةِ
u'أَمِنَ عَبْدٌ':Subject, #1: 1	أَمِنَ الْعَبَثَ
u'أَمْنٌ عَدُوٌّ':Added, #1: 1	أَمِنَ عَبْدٌ
u'آمَنَ عند':Predicate, #1: 1	أَمْنِ عَدُوٍّ
u'أَمْنٌ غَائِلَةٌ':Added, #1: 1	آمَنَ عِنْدَ
u'أَمِنَ غَدْرٌ':Predicate, #1: 1	أَمْنِ غَائِلَةِ
u'أَمِنَ فتنة':Predicate, #1: 1	أَمِنَ الْغَدْرَ
u'أَمِنَ فِتْنَةٌ':Predicate, #7: 7	أَمِنَ الْفِتْنَةَ
u'أَمْنٌ فتنة':Added, #7: 7	أَمِنَ الْفِتْنَةَ
u'أَمْنٌ فِتْنَةٌ':Added, #11: 11	أَمْنِ الْفِتْنَةِ
u'أَمْنٌ فساد':Added, #11: 11	أَمْنِ الْفِتْنَةِ
u'أَمْنٌ فَسَادٌ':Added, #2: 2	أَمْنُ الْفَسَادِ
u'أَمَّنَ فلان':Predicate, #2: 2	أَمْنُ الْفَسَادِ
u'أَمِنَ فَوَاتٌ':Predicate, #1: 1	أَمَّنَ الزُّبَيْرَ
u'أَمِنَ فَوَاتٌ':Predicate, #1: 1	أَمِنَ الْفَوَاتَ
u'أَمْنٌ فَوَاتٌ':Added, #2: 2	أَمِنَ فَوَاتَ
u'أَمَّنَ قَارِئٌ':Subject, #3: 3	أَمْنِ الْفَوَاتِ
u'أَمَّنَ قَالٌ':Predicate, #2: 2	أَمَّنَ الْقَارِئُ
u'أَمْنٌ قول':Added, #1: 1	أَمَّنَ قَالَ
u'أَمْنٌ قَوْلٌ':Added, #1: 1	أَمْنِ قَوْلِهِ
u'أَمِنَ لبس':Predicate, #1: 1	أَمْنِ قَوْلِهِ
u'أَمِنَ لَبْسٌ':Predicate, #1: 1	أَمِنَ اللَّبْسَ
u'آمَنَ لَحْمٌ':Subject, #1: 1	أَمِنَ اللَّبْسَ
u'أَمِنَ مُرُورٌ':Predicate, #1: 1	آمَنَ اللّحْمُ
u'أَمْنٌ مُطَالَبٌ':Added, #4: 4	أَمِنَ الْمُرُورَ
u'أَمْنٌ مُطَالَبَةٌ':Added, #1: 1	أَمْنَ مُطَالَبَتِهِ
u'أَمِنَ مَكْرٌ':Predicate, #1: 1	أَمْنَ مُطَالَبَتِهِ
u'أَمْنٌ مَكْرٌ':Added, #3: 3	أَمِنَ الْمَكْرَ
u'أَمْنٌ مَكْرٌ':Added, #1: 1	أَمْنُ الْمَكْرِ
u'آمَنَ مَلِكٌ':Subject, #2: 2	أَمْنِ الْمَكْرِ
u'آمَنَ نَاسٌ':Subject, #1: 1	آمَنَ الْمَلِكُ
u'أَمَّنَ نَاسٌ':Subject, #1: 1	آمَنَ النّاسُ
u'آمَنَ نَاسٌ':Subject, #1: 1	أَمَّنَ النَّاسُ
u'أَمِنَ نَاسٌ':Subject, #3: 3	آمَنَ النَّاسُ
u'أَمِنَ نَظَرٌ':Predicate, #7: 7	أَمِنَ النَّاسُ
u'آمَنَ نَفَذٌ':Predicate, #1: 1	أَمِنَ النَّظَرَ
u'أَمِنَ هلاك':Predicate, #1: 1	آمَنَ نَفَذَ
u'أَمِنَ هَلاَكٌ':Predicate, #1: 1	أَمِنَ الْهَلَاكَ
u'أَمْنٌ وَحْشٌ':Added, #1: 1	أَمِنَ الْهَلَاكَ
u'أَمِنَ وُقُوعٌ':Predicate, #1: 1	أَمْنُ الْوَحْشِ
u'أَمْهَرَ عَبْدٌ':Predicate, #1: 1	أَمِنَ الْوُقُوعَ
u'أَمْهَلَ فُلاَنٌ':Predicate, #1: 1	أَمْهَرَ عَبْدَ
u'أُمُورٌ آخِرَةٌ':Added, #1: 1	أَمْهَلَ فُلَانَ
u'أُمُورٌ أَرْبَعَةٌ':Added, #9: 9	أُمُورِ الْآخِرَةِ
u'أُمُورٌ إِسْلامٌ':Added, #4: 4	أُمُورٍ أَرْبَعَةٍ
u'أُمُورٌ إِسْلامٌ':Added, #1: 1	أُمُورِ الإِسْلاَمِ
u'أُمُورٌ إِسْلامٌ':Added, #1: 1	أُمُورَ الْإِسْلَامِ
u'أُمُورٌ أَمْرٌ':Added, #2: 2	أُمُورِ الْإِسْلَامِ
u'أُمُورٌ أُمَّهَاتٌ':Added, #1: 1	أُمُورِ أَمْرِ
u'أُمُورٌ أَوْقَافٌ':Added, #1: 1	أُمُورٍ أُمَّهَاتٍ
u'أُمُورٌ أَوْقَافٌ':Added, #1: 1	أُمُورَ الْأَوْقَافِ
u'أُمُورٌ أَوْلاَدٌ':Added, #5: 5	أُمُورِ الْأَوْقَافِ
u'أُمُورٌ أَوْلاَدٌ':Added, #1: 1	أُمُورِ أَوْلَادِ
u'أُمُورٌ تِجَارَةٌ':Added, #2: 2	أُمُورِ أَوْلَادِهِ
u'أُمُورٌ تَقْليدٌ':Added, #3: 3	أُمُورِ التِّجَارَةِ
u'أُمُورٌ تَقْليد':Added, #1: 1	أُمُورَ التَّقْلِيدِ
u'أُمُورٌ ثَلاثَةٌ':Added, #1: 1	أُمُورَ التَّقْلِيدِ
u'أُمُورٌ جُزْئِيَّةٌ':Added, #11: 11	أُمُورٍ ثَلَاثَةٍ
u'أُمُورٌ جُهَّالٌ':Added, #1: 1	أُمُورٍ جُزْئِيَّةٍ
u'أُمُورٌ حاجٌّ':Added, #1: 1	أُمُورَ الْجُهَّالِ
u'أُمُورٌ حَجٌّ':Added, #1: 1	أُمُورَ الْحَاجِّ
u'أُمُورٌ حَجٌّ':Added, #1: 1	أُمُورَ الْحَجِّ
u'أُمُورٌ حُجَّاجٌ':Added, #2: 2	أُمُورِ الْحَجِّ
u'أُمُورٌ حُروبٌ':Added, #1: 1	أُمُورِ الْحُجَّاجِ
u'أُمُورٌ خلق':Added, #1: 1	أُمُورُ الْحُرُوبِ
u'أُمُورٌ خَلْقٌ':Added, #1: 1	أُمُورَ خَلْقِهِ
u'أُمُورٌ خَمْسَةٌ':Added, #1: 1	أُمُورَ خَلْقِهِ
u'أُمُورٌ دِيانَةٌ':Added, #1: 1	أُمُورٍ خَمْسَةٍ
u'أُمُورٌ دِيانَةٌ':Added, #5: 5	أُمُورِ الدِّيَانَةِ
u'أُمُورٌ دِينٌ':Added, #6: 6	أُمُورِ الدِّيَانَاتِ
u'أُمُورٌ دِينٌ':Added, #1: 1	أُمُورَ الدِّينِ
u'أُمُورٌ دِينٌ':Added, #2: 2	أُمُورِ دِينِهِ
u'أُمُورٌ دِينٌ':Added, #36: 36	أُمُورِ الدِّينِ
u'أُمُورٌ رَسُولٌ':Added, #3: 3	أُمُورُ الدِّينِ
u'أُمُورٌ رُشْدٌ':Added, #1: 1	أُمُورِ الرَّسُولِ
u'أُمُورٌ رَعِيَّةٌ':Added, #1: 1	أُمُورَ رُشْدٍ
u'أُمُورٌ زَمانٌ':Added, #1: 1	أُمُورِ الرَّعِيَّةِ
u'أُمُورٌ سُلْطَانٌ':Added, #1: 1	أُمُورَ زَمَانِهِ
u'أُمُورٌ سُنَّةٌ':Added, #4: 4	أُمُورِ السُّلْطَانِ
u'أُمُورٌ شَرْعٌ':Added, #1: 1	أُمُورِ السُّنَّةِ
u'أُمُورٌ شَرْعٌ':Added, #1: 1	أُمُورَ الشَّرْعِ
u'أُمُورٌ صَغِيرٌ':Added, #2: 2	أُمُورِ الشَّرْعِ
u'أُمُورٌ صَلاَةٌ':Added, #2: 2	أُمُورِ الصَّغِيرِ
u'أُمُورٌ صَيْدٌ':Added, #1: 1	أُمُورِ الصَّلَاةِ
u'أُمُورٌ عَامٌّ':Added, #1: 1	أُمُورِ الصَّيْدِ
u'أُمُورٌ عَامٌّ':Added, #1: 1	أُمُورَ الْعَامَّةِ
u'أُمُورٌ عِبَادٌ':Added, #5: 5	أُمُورِ الْعَامَّةِ
u'أُمُورٌ عَبِيدٌ':Added, #2: 2	أُمُورَ عِبَادِهِ
u'أُمُورٌ عَوْرَةٌ':Added, #1: 1	أُمُورِ الْعَبِيدِ
u'أُمُورٌ فِقْهٌ':Added, #1: 1	أُمُورِ الْعَوْرَاتِ
u'أُمُورٌ قتال':Added, #1: 1	أُمُورُ الْفِقْهِ
u'أُمُورٌ قِتَالٌ':Added, #1: 1	أُمُورِ الْقِتَالِ
u'أُمُورٌ كعبة':Added, #1: 1	أُمُورِ الْقِتَالِ
u'أُمُورٌ كَعْبَةٌ':Added, #1: 1	أُمُورِ الْكَعْبَةِ
u'أُمُورٌ كُلِّيَّةٌ':Added, #1: 1	أُمُورِ الْكَعْبَةِ
u'أُمُورٌ مُسَلَّمَةٌ':Added, #1: 1	أُمُورٍ كُلِّيَّةٍ
u'أُمُورٌ مَعَاشٌ':Added, #1: 1	أُمُورٍ مُسَلَّمَةٍ
u'أُمُورٌ مِلَّةٌ':Added, #1: 1	أُمُورِ الْمَعَاشِ
u'أُمُورٌ مُهِمَّةٌ':Added, #1: 1	أُمُورِ الْمِلَّةِ
u'أُمُورٌ مُؤْمِنٌ':Added, #3: 3	أُمُورٍ مُهِمَّةٍ
u'أُمُورٌ نَاسٌ':Added, #1: 1	أُمُورَ الْمُؤْمِنِ
u'أُمُورٌ نَاسٌ':Added, #12: 12	أُمُورِ النَّاسِ
u'أُمُورٌ نِساءٌ':Added, #2: 2	أُمُورُ النَّاسِ
u'أُمُورٌ نُسُكٌ':Added, #2: 2	أُمُورِ النِّسَاءِ
u'أُمُورٌ نَفْسٌ':Added, #1: 1	أُمُورِ النُّسُكِ
u'أُمُورٌ وَاقِفٌ':Added, #3: 3	أُمُورِ نَفْسِهِ
u'أَنَّ أَبٌ':Predicate, #2: 2	أُمُورِ الْوَاقِفِ
u'أَنَّ أَبٌ':Predicate, #138: 138	أَنَّ الْأَبَ
u'أَنَّ إبَاءٌ':Predicate, #2: 2	أَنَّ أَبَ
u'أَنَّ إبَاءٌ':Predicate, #1: 1	أَنَّ إبَاءَ
u'أَنَّ آباءٌ':Predicate, #3: 3	أَنَّ الْإِبَاءَ
u'أَنَّ إبَاحَةٌ':Predicate, #5: 5	أَنَّ الْآبَاءَ
u'أَنَّ إبَاحَةٌ':Predicate, #10: 10	أَنَّ إبَاحَةَ
u'أَنَّ آبارٌ':Predicate, #21: 21	أَنَّ الْإِبَاحَةَ
u'أَنَّ إِبَانَةٌ':Predicate, #2: 2	أَنَّ آبَارَ
u'أَنَّ اِبْتِداءٌ':Predicate, #5: 5	أَنَّ الْإِبَانَةَ
u'أَنَّ اِبْتِلاَعٌ':Predicate, #74: 74	أَنَّ ابْتِدَاءَ
u'أَنَّ أبجر':Predicate, #1: 1	أَنَّ ابْتِلَاعَ
u'أَنَّ إبْداءٌ':Predicate, #2: 2	أَنَّ أَبْجَرَ
u'أَنَّ إبدالٌ':Predicate, #1: 1	أَنَّ إبْدَاءَ
u'أَنَّ إبدالٌ':Predicate, #1: 1	أَنَّ إبْدَالَ
u'أَنَّ أبطأ':Predicate, #2: 2	أَنَّ الْإِبْدَالَ
u'أَنَّ إِبْطَالٌ':Predicate, #1: 1	أَنَّ الْأَبْطَأَ
u'أَنَّ إِبْطَالٌ':Predicate, #1: 1	أَنَّ الْإِبْطَالَ
u'أَنَّ أَبْعَدُ':Predicate, #4: 4	أَنَّ إبْطَالَ
u'أَنَابَ غَائِبٌ':Subject, #2: 2	أَنَّ الْأَبْعَدَ
u'أَنَّ إِبْقَاءٌ':Predicate, #1: 1	أَنَابَ الْغَائِبُ
u'أَنَّ أَبْكَم':Predicate, #1: 1	أَنَّ إبْقَاءَ
u'أَنَّ إِبِلٌ':Predicate, #1: 1	أَنَّ الْأَبْكَمَ
u'أَنَّ إِبِلٌ':Predicate, #1: 1	أَنَّ إبِلَ
u'أَنَّ إبْلِيسُ':Predicate, #9: 9	أَنَّ الْإِبِلَ
u'أَنَّ اِبْنٌ':Predicate, #5: 5	أَنَّ إبْلِيسَ
u'أَنَّ اِبْنٌ':Subject, #743: 743	أَنَّ ابْنَ
u'أَنَّ أَبْنَاءٌ':Predicate, #2: 2	أَنَّ ابْنُ
u'أَنَّ أَبْنَاءٌ':Predicate, #1: 1	أَنَّ أَبْنَاءَ
u'أَنَابَ نَاظِرٌ':Subject, #1: 1	أَنَّ الْأَبْنَاءَ
u'أَنَّ اِبْنَة':Predicate, #1: 1	أَنَابَ النَّاظِرُ
u'أَنَّ إِبْهَامٌ':Predicate, #14: 14	أَنَّ ابْنَةَ
u'أَنَّ إِبْهَامٌ':Predicate, #1: 1	أَنَّ إِبْهَامَ
u'أَنَّ أَبْوَابٌ':Predicate, #1: 1	أَنَّ الْإِبْهَامَ
u'أَنَّ أَبْوَابٌ':Predicate, #2: 2	أَنَّ أَبْوَابَ
u'أَنَّ أَبْوَالٌ':Predicate, #2: 2	أَنَّ الْأَبْوَابَ
u'أَنَّ أُبُوَّةٌ':Predicate, #1: 1	أَنَّ الْأَبْوَالَ
u'أَنَّ أَبْيَض':Predicate, #1: 1	أَنَّ الْأُبُوَّةَ
u'أَنَّ أَبْيَض':Predicate, #1: 1	أَنَّ أَبْيَضَ
u'أَنَّ اِتِّبَاعٌ':Predicate, #2: 2	أَنَّ الْأَبْيَضَ
u'أَنَّ اِتِّحَادٌ':Predicate, #8: 8	أَنَّ اتِّبَاعَ
u'أَنَّ اِتِّخَاذٌ':Predicate, #6: 6	أَنَّ اتِّحَادَ
u'أَنَّ اِتِّصَافٌ':Predicate, #3: 3	أَنَّ اتِّخَاذَ
u'أَنَّ اِتِّصَالٌ':Predicate, #2: 2	أَنَّ اتِّصَافَ
u'أَنَّ اِتِّفَاقٌ':Predicate, #8: 8	أَنَّ اتِّصَالَ
u'أَنَّ إِتْلاَفٌ':Predicate, #5: 5	أَنَّ اتِّفَاقَ
u'أَنَّ إِتْلاَفٌ':Predicate, #8: 8	أَنَّ إتْلَافَ
u'أَنَّ إتْمَامٌ':Predicate, #8: 8	أَنَّ الْإِتْلَافَ
u'أَنَّ إتْمَامٌ':Predicate, #2: 2	أَنَّ إتْمَامَ
u'أَنَّ آتِي':Predicate, #5: 5	أَنَّ الْإِتْمَامَ
u'أَنَّ إِتْيانٌ':Predicate, #1: 1	أَنَّ الْآتِيَ
u'أَنَّ إِتْيانٌ':Predicate, #1: 1	أَنَّ إتْيَانَ
u'أَنَّ إِتْيانٌ':Predicate, #1: 1	أَنَّ إِتْيَانَ
u'أَنَّ إثَابَةٌ':Predicate, #7: 7	أَنَّ الْإِتْيَانَ
u'أَنَّ آثَارٌ':Predicate, #2: 2	أَنَّ الْإِثَابَةَ
u'أَنَّ آثَارٌ':Predicate, #1: 1	أَنَّ آثَارَ
u'أَنَّ إِثْبَاتٌ':Predicate, #9: 9	أَنَّ الْآثَارَ
u'أَنَّ إِثْبَاتٌ':Predicate, #19: 19	أَنَّ إثْبَاتَ
u'أَنَّ إِثْخَانٌ':Predicate, #5: 5	أَنَّ الْإِثْبَاتَ
u'أَنَّ أثَرٌ':Predicate, #1: 1	أَنَّ الْإِثْخَانَ
u'أَنَّ أثَرٌ':Predicate, #16: 16	أَنَّ أَثَرَ
u'أَنَّ إِثْمٌ':Predicate, #2: 2	أَنَّ الْأَثَرَ
u'أَنَّ إِثْمٌ':Predicate, #18: 18	أَنَّ الْإِثْمَ
u'أَنَّ إِثمَارٌ':Predicate, #5: 5	أَنَّ إثْمَ
u'أَنَّ أَثْمانٌ':Predicate, #1: 1	أَنَّ الْإِثْمَارَ
u'أَنَّ أَثْوابٌ':Predicate, #3: 3	أَنَّ الْأَثْمَانَ
u'أَنَّ إِجَابَةٌ':Predicate, #1: 1	أَنَّ الْأَثْوَابَ
u'أَنَّ إِجَابَةٌ':Predicate, #2: 2	أَنَّ إجَابَةَ
u'أَنَّ إجَارَةٌ':Predicate, #4: 4	أَنَّ الْإِجَابَةَ
u'أَنَّ إجَارَةٌ':Predicate, #20: 20	أَنَّ إجَارَةَ
u'أَنَّ إجَازَةٌ':Predicate, #71: 71	أَنَّ الْإِجَارَةَ
u'أَنَّ إجَازَةٌ':Predicate, #29: 29	أَنَّ الْإِجَازَةَ
u'أَنَّ آجَالٌ':Predicate, #8: 8	أَنَّ إجَازَةَ
u'أَنَّ إِجْبَارٌ':Predicate, #1: 1	أَنَّ الْآجَالَ
u'أَنَّ إِجْبَارٌ':Predicate, #1: 1	أَنَّ إجْبَارَ
u'أَنَّ اِجْتِمَاعٌ':Predicate, #2: 2	أَنَّ الْإِجْبَارَ
u'أَنَّ اجْتِنَابٌ':Predicate, #6: 6	أَنَّ اجْتِمَاعَ
u'أَنَّ اِجْتِهَادٌ':Predicate, #2: 2	أَنَّ اجْتِنَابَ
u'أَنَّ أَجْذَم':Predicate, #4: 4	أَنَّ اجْتِهَادَ
u'أَنَّ أَجْرٌ':Predicate, #1: 1	أَنَّ الْأَجْذَمَ
u'أَنَّ آجُرٌّ':Predicate, #14: 14	أَنَّ أَجْرَ
u'أَنَّ أَجْرٌ':Predicate, #6: 6	أَنَّ الْآجُرَّ
u'أَنَّ إِجْرَاءٌ':Predicate, #9: 9	أَنَّ الْأَجْرَ
u'أَنَّ إِجْرَاءٌ':Predicate, #1: 1	أَنَّ الْإِجْرَاءَ
u'أَنَّ أُجْرَةٌ':Predicate, #2: 2	أَنَّ إجْرَاءَ
u'أَنَّ أُجْرَةٌ':Predicate, #16: 16	أَنَّ أُجْرَةَ
u'أَنَّ أَجْزَاءٌ':Predicate, #34: 34	أَنَّ الْأُجْرَةَ
u'أَنَّ أَجْزَاءٌ':Predicate, #10: 10	أَنَّ أَجْزَاءَ
u'أَنَّ إِجْزَاءٌ':Predicate, #2: 2	أَنَّ الْأَجْزَاءَ
u'أَنَّ أَجْسَامٌ':Predicate, #5: 5	أَنَّ الْإِجْزَاءَ
u'أَنَّ أَجَلٌ':Predicate, #2: 2	أَنَّ الْأَجْسَامَ
u'أَنَّ أَجَلٌ':Predicate, #24: 24	أَنَّ الْأَجَلَ
u'أَنَّ إِجْمَاعٌ':Predicate, #2: 2	أَنَّ أَجَلَ
u'أَنَّ إِجْمَاعٌ':Predicate, #77: 77	أَنَّ الْإِجْمَاعَ
u'أَنَّ إِجْمَالٌ':Predicate, #9: 9	أَنَّ إجْمَاعَ
u'أَنَّ أجْمَع':Predicate, #3: 3	أَنَّ الْإِجْمَالَ
u'أَنَّ أَجْنَبِيٌّ':Predicate, #1: 1	أَنَّ أَجْمَعِينَ
u'أَنَّ أَجْنَبِيٌّ':Predicate, #17: 17	أَنَّ الْأَجْنَبِيَّ
u'أَنَّ إِجْهَاضٌ':Predicate, #2: 2	أَنَّ الْأَجْنَبِيَّةَ
u'أَنَّ أَجْوِبَةٌ':Predicate, #1: 1	أَنَّ الْإِجْهَاضَ
u'أَنَّ أَجِيرٌ':Predicate, #1: 1	أَنَّ الْأَجْوِبَةَ
u'أَنَّ أَجِيرٌ':Predicate, #16: 16	أَنَّ الْأَجِيرَ
u'أَنَّ أَحادِيثُ':Predicate, #2: 2	أَنَّ أَجِيرَ
u'أَنَّ أَحادِيثُ':Predicate, #1: 1	أَنَّ الأَحَادِيثَ
u'أَنَّ أَحادِيثُ':Predicate, #4: 4	أَنَّ أَحَادِيثَ
u'أَنَّ إحَاطَةٌ':Predicate, #6: 6	أَنَّ الْأَحَادِيثَ
u'أَنَّ إحَاطَةٌ':Predicate, #1: 1	أَنَّ إحَاطَةَ
u'أَنَّ إِحالَةٌ':Predicate, #2: 2	أَنَّ الْإِحَاطَةَ
u'أَنَّ إِحالَةٌ':Predicate, #1: 1	أَنَّ إحَالَةَ
u'أَنَّ أَحْبارٌ':Predicate, #1: 1	أَنَّ الْإِحَالَةَ
u'أَنَّ أَحْبَارٌ':Predicate, #2: 2	أَنَّ أَحْبَارَ
u'أَنَّ إِحْبَاطٌ':Predicate, #2: 2	أَنَّ أَحْبَارَ
u'أَنَّ اِحْتِمَالٌ':Predicate, #1: 1	أَنَّ الْإِحْبَاطَ
u'أَنَّ أحَدٌ':Predicate, #13: 13	أَنَّ احْتِمَالَ
u'أَنَّ أحَدٌ':Predicate, #110: 110	أَنَّ أَحَدَ
u'أَنَّ أَحْداثٌ':Predicate, #1: 1	أَنَّ الْأَحَدَ
u'أَنَّ أَحْدَاثٌ':Predicate, #1: 1	أَنَّ الْأَحْدَاثَ
u'أَنَّ إِحْدَاثٌ':Predicate, #1: 1	أَنَّ الْأَحْدَاثَ
u'أَنَّ إِحْدَاثٌ':Predicate, #1: 1	أَنَّ الْإِحْدَاثَ
u'أَنَّ إِحْرَازٌ':Predicate, #5: 5	أَنَّ إحْدَاثَ
u'أَنَّ إِحْرَاقٌ':Predicate, #2: 2	أَنَّ الْإِحْرَازَ
u'أَنَّ إِحْرَامٌ':Predicate, #2: 2	أَنَّ الْإِحْرَاقَ
u'أَنَّ إِحْرَامٌ':Predicate, #12: 12	أَنَّ إحْرَامَ
u'أَنَّ إحْسَانٌ':Predicate, #42: 42	أَنَّ الْإِحْرَامَ
u'أَنَّ إحْسَانٌ':Predicate, #1: 1	أَنَّ إحْسَانَ
u'أَنَّ أَحْسَنُ':Predicate, #1: 1	أَنَّ الْإِحْسَانَ
u'أَنَّ أَحْسَنُ':Predicate, #4: 4	أَنَّ أَحْسَنَ
u'أَنَّ إحْضَارٌ':Predicate, #7: 7	أَنَّ الْأَحْسَنَ
u'أَنَّ أَحَقُّ':Predicate, #2: 2	أَنَّ إحْضَارَ
u'أَنَّ أَحَقُّ':Predicate, #2: 2	أَنَّ أَحَقَّ
u'أَنَّ أَحْكَامٌ':Predicate, #6: 6	أَنَّ الْأَحَقَّ
u'أَنَّ أَحْكَامٌ':Predicate, #12: 12	أَنَّ أَحْكَامَ
u'أَنَّ أحكم':Predicate, #42: 42	أَنَّ الْأَحْكَامَ
u'أَنَّ إحْمَاءٌ':Predicate, #1: 1	أَنَّ أَحْكُمَ
u'أَنَّ أحْمَر':Predicate, #2: 2	أَنَّ الْإِحْمَاءَ
u'أَنَّ أَحْنَف':Predicate, #2: 2	أَنَّ الْأَحْمَرَ
u'أَنَّ أَحْوالٌ':Predicate, #2: 2	أَنَّ الْأَحْنَفَ
u'أَنَّ أحْوَالٌ':Predicate, #5: 5	أَنَّ الْأَحْوَالَ
u'أَنَّ أَحْوالٌ':Predicate, #5: 5	أَنَّ الْأَحْوَالَ
u'أَنَّ أحْوَالٌ':Predicate, #6: 6	أَنَّ أَحْوَالَ
u'أَنَّ أَحْيَاءٌ':Predicate, #6: 6	أَنَّ أَحْوَالَ
u'أَنَّ إِحْيَاءٌ':Predicate, #1: 1	أَنَّ الْأَحْيَاءَ
u'أَنَّ إِحْيَاءٌ':Predicate, #3: 3	أَنَّ إحْيَاءَ
u'أَنَّ أَخٌ':Predicate, #4: 4	أَنَّ الْإِحْيَاءَ
u'أَنَاخَ اِبْنٌ':Subject, #23: 23	أَنَّ الْأَخَ
u'أَنَّ أخْبَارٌ':Predicate, #1: 1	أَنَاخَ ابْنُ
u'أَنَّ أَخْبَارٌ':Predicate, #1: 1	أَنَّ الأَخْبَارَ
u'أَنَّ أخْبَارٌ':Predicate, #1: 1	أَنَّ الأَخْبَارَ
u'أَنَّ أَخْبَارٌ':Predicate, #3: 3	أَنَّ أَخْبَارَ
u'أَنَّ إِخْبَارٌ':Predicate, #3: 3	أَنَّ أَخْبَارَ
u'أَنَّ إِخْبَارٌ':Predicate, #3: 3	أَنَّ الْإِخْبَارَ
u'أَنَّ أخْبَارٌ':Predicate, #6: 6	أَنَّ إخْبَارَ
u'أَنَّ أَخْبَارٌ':Predicate, #7: 7	أَنَّ الْأَخْبَارَ
u'أَنَّ أُخْتٌ':Predicate, #7: 7	أَنَّ الْأَخْبَارَ
u'أَنَّ أُخْتٌ':Predicate, #10: 10	أَنَّ الْأُخْتَ
u'أَنَّ أخْتَانٌ':Predicate, #15: 15	أَنَّ أُخْتَ
u'أَنَّ اِخْتِلاطٌ':Predicate, #2: 2	أَنَّ الْأَخْتَانَ
u'أَنَّ اِخْتِلاَفٌ':Predicate, #1: 1	أَنَّ اخْتِلَاطَ
u'أَنَّ اِخْتِيَارٌ':Predicate, #28: 28	أَنَّ اخْتِلَافَ
u'أَنَّ اِخْتِيَارٌ':Predicate, #1: 1	أَنَّ الاِخْتِيَارَ
u'أَنَّ أخْذٌ':Predicate, #8: 8	أَنَّ اخْتِيَارَ
u'أَنَّ أخْذٌ':Predicate, #33: 33	أَنَّ أَخْذَ
u'أَنَّ آخِرُ':Predicate, #35: 35	أَنَّ الْأَخْذَ
u'أَنَّ إِخْرَاجٌ':Predicate, #29: 29	أَنَّ آخِرَ
u'أَنَّ إِخْرَاجٌ':Predicate, #12: 12	أَنَّ الْإِخْرَاجَ
u'أَنَاخَ رَجُلٌ':Subject, #9: 9	أَنَّ إخْرَاجَ
u'أَنَّ أخرَس':Predicate, #1: 1	أَنَاخَ رَجُلٌ
u'أَنَاخَ سَالِمٌ':Subject, #4: 4	أَنَّ الْأَخْرَسَ
u'أَنَّ أَخَصُّ':Predicate, #1: 1	أَنَاخَ سَالِمٌ
u'أَنَاخَ عند':Predicate, #1: 1	أَنَّ الْأَخَصَّ
u'أَنَّ إِخْفَاءٌ':Predicate, #1: 1	أَنَاخَ عِنْدَ
u'أَنَّ إِخْلاَصٌ':Predicate, #3: 3	أَنَّ الْإِخْفَاءَ
u'أَنَّ إِخْلاَصٌ':Predicate, #1: 1	أَنَّ إخْلَاصَ
u'أَنَّ أَخْلاَطٌ':Predicate, #4: 4	أَنَّ الْإِخْلَاصَ
u'أَنَّ إِخْلالٌ':Predicate, #1: 1	أَنَّ الْأَخْلَاطَ
u'أَنَاخَ نَاسٌ':Subject, #2: 2	أَنَّ الْإِخْلَالَ
u'أَنَّ إِخْوَةٌ':Predicate, #1: 1	أَنَاخَ النَّاسُ
u'أَنَّ إِخْوَةٌ':Predicate, #17: 17	أَنَّ الْإِخْوَةَ
u'أَنَّ إِخْوَةٌ':Predicate, #1: 1	أَنَّ إخْوَةَ
u'أَنَّ أُخُوَّةٌ':Predicate, #2: 2	أَنَّ الإِخْوَةَ
u'أَنَّ أُخُوَّةٌ':Subject, #3: 3	أَنَّ الْأُخُوَّةَ
u'أَنَّ أَخِيرٌ':Predicate, #1: 1	أَنَّ الْأُخُوَّةُ
u'أَنَّ أَخِيرٌ':Predicate, #1: 1	أَنَّ الْأَخِيرَةَ
u'أَنَّ أَدَاءٌ':Predicate, #2: 2	أَنَّ الْأَخِيرَ
u'أَنَّ أَدَاءٌ':Predicate, #15: 15	أَنَّ الْأَدَاءَ
u'أَنَّ آدابٌ':Predicate, #28: 28	أَنَّ أَدَاءَ
u'أَنَّ آدابٌ':Predicate, #1: 1	أَنَّ آدَابَ
u'أَنَّ أدَاةٌ':Predicate, #2: 2	أَنَّ الْآدَابَ
u'أَنَّ أدَاةٌ':Predicate, #1: 1	أَنَّ الْأَدَاةَ
u'أَنَّ إِدَامٌ':Predicate, #2: 2	أَنَّ أَدَاةَ
u'أَنَّ إِدَانَةٌ':Predicate, #6: 6	أَنَّ الْإِدَامَ
u'أَنَّ أدَب':Predicate, #2: 2	أَنَّ الْإِدَانَةَ
u'أَنَّ إدْخَالٌ':Predicate, #1: 1	أَنَّ أَدَبَ
u'أَنَّ إدْخَالٌ':Predicate, #1: 1	أَنَّ الْإِدْخَالَ
u'أَنَّ إِدْرَاكٌ':Predicate, #9: 9	أَنَّ إدْخَالَ
u'أَنَّ إِدْرَاكٌ':Predicate, #6: 6	أَنَّ الْإِدْرَاكَ
u'أَنَّ اِدِّعَاءٌ':Predicate, #8: 8	أَنَّ إدْرَاكَ
u'أَنَّ أدْعِيَةٌ':Predicate, #3: 3	أَنَّ ادِّعَاءَ
u'أَنَّ أدْعِيَةٌ':Predicate, #1: 1	أَنَّ أَدْعِيَةَ
u'أَنَّ آدَمُ':Predicate, #2: 2	أَنَّ الْأَدْعِيَةَ
u'أَنَّ إِدْمَانٌ':Predicate, #10: 10	أَنَّ آدَمَ
u'أَنَّ آدَمِيٌّ':Predicate, #2: 2	أَنَّ الْإِدْمَانَ
u'أَنَّ أَدْهانٌ':Predicate, #5: 5	أَنَّ الْآدَمِيَّ
u'أَنَّ أَدْوِيَةٌ':Predicate, #2: 2	أَنَّ الْأَدْهَانَ
u'أَنَّ آذَانٌ':Predicate, #1: 1	أَنَّ الْأَدْوِيَةَ
u'أَنَّ أَذَانٌ':Predicate, #2: 2	أَنَّ الْآذَانَ
u'أَنَّ أَذَانٌ':Predicate, #30: 30	أَنَّ الْأَذَانَ
u'أَنَّ أَذَانٌ':Predicate, #4: 4	أَنَّ أَذَانَ
u'أَنَّ إِذْنٌ':Predicate, #4: 4	أَنَّ الأَذَانَ
u'أَنَّ إِذْنٌ':Predicate, #12: 12	أَنَّ إذْنَ
u'أَنَّ إِذْنٌ':Predicate, #1: 1	أَنَّ الإِذْنَ
u'أَنَّ إِرَادَةٌ':Predicate, #38: 38	أَنَّ الْإِذْنَ
u'أَنَّ إِرَادَةٌ':Predicate, #4: 4	أَنَّ إرَادَةَ
u'أَنَّ أَرَاضِي':Predicate, #6: 6	أَنَّ الْإِرَادَةَ
u'أَنَّ إِرَاقَةٌ':Predicate, #4: 4	أَنَّ الْأَرَاضِيَ
u'أَنَّ إِرَاقَةٌ':Predicate, #1: 1	أَنَّ إرَاقَةَ
u'أَنَّ أَرَاكٌ':Predicate, #2: 2	أَنَّ الْإِرَاقَةَ
u'أَنَّ أرْبَابٌ':Predicate, #2: 2	أَنَّ الْأَرَاكَ
u'أَنَّ أَرْبَاحٌ':Predicate, #7: 7	أَنَّ أَرْبَابَ
u'أَنَّ أَرْبَعُ':Predicate, #1: 1	أَنَّ الْأَرْبَاحَ
u'أَنَّ أَرْبَعُ':Predicate, #1: 1	أَنَّ أَرْبَعَ
u'أَنَّ أرْبِعَاءُ':Predicate, #9: 9	أَنَّ الْأَرْبَعَ
u'أَنَّ أَرْبِعَاءُ':Predicate, #1: 1	أَنَّ الْأَرْبِعَاءَ
u'أَنَّ أَرْبَعَةٌ':Predicate, #1: 1	أَنَّ الْأَرْبِعَاءَ
u'أَنَّ أَرْبَعَةٌ':Predicate, #2: 2	أَنَّ أَرْبَعَةَ
u'أَنَّ اِرْتِسَامٌ':Predicate, #6: 6	أَنَّ الْأَرْبَعَةَ
u'أَنَّ اِرْتِفَاعٌ':Predicate, #1: 1	أَنَّ ارْتِسَامَ
u'أَنَّ اِرْتِكَابٌ':Predicate, #4: 4	أَنَّ ارْتِفَاعَ
u'أَنَّ إِرْثٌ':Predicate, #3: 3	أَنَّ ارْتِكَابَ
u'أَنَّ إِرْثٌ':Predicate, #10: 10	أَنَّ الْإِرْثَ
u'أَنَّ أَرْجَحُ':Predicate, #4: 4	أَنَّ إرْثَ
u'أَنَّ أَرْجَحُ':Predicate, #1: 1	أَنَّ أَرْجَحَ
u'أَنَّ أَرْجُلٌ':Predicate, #8: 8	أَنَّ الْأَرْجَحَ
u'أَنَّ إِرْخَاءٌ':Predicate, #1: 1	أَنَّ الْأَرْجُلَ
u'أَنَّ أَرْدَأَ':Predicate, #2: 2	أَنَّ الْإِرْخَاءَ
u'أَنَّ أَرُزٌّ':Predicate, #1: 1	أَنَّ الْأَرْدَأَ
u'أَنَّ إِرْسَالٌ':Predicate, #2: 2	أَنَّ الْأَرُزَّ
u'أَنَّ إِرْسَالٌ':Predicate, #3: 3	أَنَّ إرْسَالَ
u'أَنَّ إِرْشَادٌ':Predicate, #8: 8	أَنَّ الْإِرْسَالَ
u'أَنَّ أرْضٌ':Predicate, #1: 1	أَنَّ الْإِرْشَادَ
u'أَنَّ أرْضٌ':Predicate, #73: 73	أَنَّ الْأَرْضَ
u'أَنَّ أرْضٌ':Predicate, #8: 8	أَنَّ أَرْضَ
u'أَنَّ إِرْضاعٌ':Predicate, #8: 8	أَنَّ الأَرْضَ
u'أَنَّ إِرْضاعٌ':Predicate, #1: 1	أَنَّ إرْضَاعَ
u'أَنَّ أَرِقَّاءُ':Predicate, #5: 5	أَنَّ الْإِرْضَاعَ
u'أَنَّ أَرْكانٌ':Predicate, #1: 1	أَنَّ الْأَرِقَّاءَ
u'أَنَّ أَرْكَانٌ':Predicate, #1: 1	أَنَّ الْأَرْكَانَ
u'أَنَّ أَرْكانٌ':Predicate, #1: 1	أَنَّ الْأَرْكَانَ
u'أَنَّ أَرْكَانٌ':Predicate, #5: 5	أَنَّ أَرْكَانَ
u'أَنَارَ كَوْنٌ':Predicate, #5: 5	أَنَّ أَرْكَانَ
u'أَنَّ أَرْمَلُ':Predicate, #1: 1	أَنَارَ الْكَوْنَ
u'أَنَّ إِرْهَابٌ':Predicate, #1: 1	أَنَّ الْأَرْمَلَةَ
u'أَنَّ أَرْواحٌ':Predicate, #1: 1	أَنَّ الْإِرْهَابَ
u'أَنَّ أَرْواحٌ':Predicate, #3: 3	أَنَّ أَرْوَاحَ
u'أَنَّ إِزَارٌ':Predicate, #4: 4	أَنَّ الْأَرْوَاحَ
u'أَنَّ إِزَالَةٌ':Predicate, #3: 3	أَنَّ الْإِزَارَ
u'أَنَّ إِزَالَةٌ':Predicate, #1: 1	أَنَّ الْإِزَالَةَ
u'أَنَّ اِزْدِيَادٌ':Predicate, #24: 24	أَنَّ إزَالَةَ
u'أَنَّ أَزْمِنَةٌ':Predicate, #1: 1	أَنَّ ازْدِيَادَ
u'أَنَّ أَزْهَر':Predicate, #1: 1	أَنَّ الْأَزْمِنَةَ
u'أَنَّ أَزْواجٌ':Predicate, #1: 1	أَنَّ أَزْهَرَ
u'أَنَّ أَزْواجٌ':Predicate, #2: 2	أَنَّ الْأَزْوَاجَ
u'أَنَّ أَزْيَدُ':Predicate, #4: 4	أَنَّ أَزْوَاجَ
u'أَنَّ إِسَاءةٌ':Predicate, #1: 1	أَنَّ الْأَزْيَدَ
u'أَنَّ أَسَابِيعُ':Predicate, #3: 3	أَنَّ الْإِسَاءَةَ
u'أَنَّ أَسْآرٌ':Predicate, #1: 1	أَنَّ الْأَسَابِيعَ
u'أَنَّ أسَاسٌ':Predicate, #1: 1	أَنَّ أَسْآرَ
u'أَنَّ أَسَاسٌ':Predicate, #1: 1	أَنَّ أَسَاسَ
u'أَنَّ أسْبَابٌ':Predicate, #1: 1	أَنَّ أَسَاسَ
u'أَنَّ أَسْبَابٌ':Predicate, #7: 7	أَنَّ الْأَسْبَابَ
u'أَنَّ أسْبَابٌ':Predicate, #7: 7	أَنَّ الْأَسْبَابَ
u'أَنَّ أَسْبَابٌ':Predicate, #8: 8	أَنَّ أَسْبَابَ
u'أَنَّ إِسْبَاغٌ':Predicate, #8: 8	أَنَّ أَسْبَابَ
u'أَنَّ أَسْبَقُ':Predicate, #1: 1	أَنَّ الْإِسْبَاغَ
u'أَنَّ أُسْتَاذٌ':Predicate, #2: 2	أَنَّ الْأَسْبَقَ
u'أَنَّ اِسْتِبَانَةٌ':Predicate, #5: 5	أَنَّ الْأُسْتَاذَ
u'أَنَّ اِسْتِبْدَالٌ':Predicate, #1: 1	أَنَّ اسْتِبَانَةَ
u'أَنَّ اِسْتِبْراء':Predicate, #1: 1	أَنَّ اسْتِبْدَالَ
u'أَنَّ اِسْتِتارٌ':Predicate, #1: 1	أَنَّ اسْتِبْرَاءَ
u'أَنَّ اِسْتِثْنَاءٌ':Predicate, #1: 1	أَنَّ اسْتِتَارَ
u'أَنَّ اِسْتِحَالَةٌ':Predicate, #17: 17	أَنَّ اسْتِثْنَاءَ
u'أَنَّ اِسْتِحْسان':Predicate, #1: 1	أَنَّ اسْتِحَالَةَ
u'أَنَّ اِسْتِحْقَاقٌ':Predicate, #1: 1	أَنَّ اسْتِحْسَانَ
u'أَنَّ اِسْتِخْدامٌ':Predicate, #26: 26	أَنَّ اسْتِحْقَاقَ
u'أَنَّ اِسْتِدَامَةٌ':Predicate, #1: 1	أَنَّ اسْتِخْدَامَ
u'أَنَّ اِسْتِدْعَاءٌ':Predicate, #4: 4	أَنَّ اسْتِدَامَةَ
u'أَنَّ اِسْتِدْلاَلٌ':Predicate, #2: 2	أَنَّ اسْتِدْعَاءَ
u'أَنَّ اِسْتِسْقَاءٌ':Predicate, #2: 2	أَنَّ اسْتِدْلَالَ
u'أَنَّ اِسْتِعارَةٌ':Predicate, #1: 1	أَنَّ الاِسْتِسْقَاءَ
u'أَنَّ اِسْتِعْمالٌ':Predicate, #2: 2	أَنَّ اسْتِعَارَةَ
u'أَنَّ اِسْتِغْرَاقٌ':Predicate, #15: 15	أَنَّ اسْتِعْمَالَ
u'أَنَّ اِسْتِغْفارٌ':Predicate, #4: 4	أَنَّ اسْتِغْرَاقَ
u'أَنَّ اِسْتِفادَةٌ':Predicate, #1: 1	أَنَّ اسْتِغْفَارَ
u'أَنَّ اِسْتِقْبالٌ':Predicate, #1: 1	أَنَّ اسْتِفَادَةَ
u'أَنَّ اِسْتِقْراءٌ':Predicate, #4: 4	أَنَّ اسْتِقْبَالَ
u'أَنَّ اِسْتِقْرارٌ':Predicate, #1: 1	أَنَّ اسْتِقْرَاءَ
u'أَنَّ اِسْتِقْلالٌ':Predicate, #1: 1	أَنَّ اسْتِقْرَارَ
u'أَنَّ اِسْتِلامٌ':Predicate, #1: 1	أَنَّ اسْتِقْلَالَ
u'أَنَّ اِسْتِلْحاق':Predicate, #2: 2	أَنَّ اسْتِلَامَ
u'أَنَّ اِسْتِلْزامٌ':Predicate, #1: 1	أَنَّ اسْتِلْحَاقَ
u'أَنَّ اِسْتِماعٌ':Predicate, #1: 1	أَنَّ اسْتِلْزَامَ
u'أَنَّ اِسْتِمْدادٌ':Predicate, #1: 1	أَنَّ اسْتِمَاعَ
u'أَنَّ اِسْتِمْرارٌ':Predicate, #2: 2	أَنَّ اسْتِمْدَادَ
u'أَنَّ اِسْتِنابَة':Predicate, #1: 1	أَنَّ اسْتِمْرَارَ
u'أَنَّ اِسْتِناد':Predicate, #1: 1	أَنَّ اسْتِنَابَةَ
u'أَنَّ اِسْتِنْباطٌ':Predicate, #3: 3	أَنَّ اسْتِنَادَ
u'أَنَّ اِسْتِواءٌ':Predicate, #2: 2	أَنَّ اسْتِنْبَاطَ
u'أَنَّ اِسْتِئْجَارٌ':Predicate, #1: 1	أَنَّ اسْتِوَاءَ
u'أَنَّ اِسْتيعابٌ':Predicate, #7: 7	أَنَّ اسْتِئْجَارَ
u'أَنَّ اِسْتيفاءٌ':Predicate, #7: 7	أَنَّ اسْتِيعَابَ
u'أَنَّ اِسْتِيلاد':Predicate, #8: 8	أَنَّ اسْتِيفَاءَ
u'أَنَّ اِسْتِيلاد':Predicate, #1: 1	أَنَّ اسْتِيلَادَ
u'أَنَّ أَسَدٌ':Predicate, #1: 1	أَنَّ الاِسْتِيلاَدَ
u'أَنَّ أَسَدٌ':Predicate, #1: 1	أَنَّ أَسَدَ
u'أَنَّ إِسْراءٌ':Predicate, #1: 1	أَنَّ الْأَسَدَ
u'أَنَّ إِسْراعٌ':Predicate, #1: 1	أَنَّ الْإِسْرَاءَ
u'أَنَّ إِسْرافٌ':Predicate, #1: 1	أَنَّ الْإِسْرَاعَ
u'أَنَّ أَسْفَلُ':Predicate, #3: 3	أَنَّ الْإِسْرَافَ
u'أَنَّ أَسْفَلُ':Predicate, #1: 1	أَنَّ أَسْفَلَ
u'أَنَّ إِسْقاطٌ':Predicate, #1: 1	أَنَّ الْأَسْفَلَ
u'أَنَّ إِسْقاطٌ':Predicate, #3: 3	أَنَّ الْإِسْقَاطَ
u'أَنَّ أُسْقُفٌ':Predicate, #5: 5	أَنَّ إسْقَاطَ
u'أَنَّ إِسْكارٌ':Predicate, #1: 1	أَنَّ أُسْقُفَ
u'أَنَّ إِسْكانٌ':Predicate, #4: 4	أَنَّ الْإِسْكَارَ
u'أَنَّ إِسْلامٌ':Predicate, #1: 1	أَنَّ الْإِسْكَانَ
u'أَنَّ إِسْلامٌ':Predicate, #27: 27	أَنَّ الْإِسْلَامَ
u'أَنَّ إِسْلامٌ':Predicate, #2: 2	أَنَّ الإِسْلاَمَ
u'أَنَّ اِسْمٌ':Predicate, #7: 7	أَنَّ إسْلَامَ
u'أَنَّ أَسْماءٌ':Predicate, #81: 81	أَنَّ اسْمَ
u'أَنَّ أَسْماءٌ':Predicate, #35: 35	أَنَّ أَسْمَاءَ
u'أَنَّ إِسْماعٌ':Predicate, #6: 6	أَنَّ الْأَسْمَاءَ
u'أَنَّ إِسْنادٌ':Predicate, #1: 1	أَنَّ إسْمَاعَ
u'أَنَّ إِسْنادٌ':Predicate, #4: 4	أَنَّ الْإِسْنَادَ
u'أَنَّ أسْنَانٌ':Predicate, #6: 6	أَنَّ إسْنَادَ
u'أَنَّ أسْنَانٌ':Predicate, #1: 1	أَنَّ أَسْنَانَ
u'أَنَّ أسْنَانٌ':Predicate, #1: 1	أَنَّ الأَسْنَانَ
u'أَنَّ أَسْوَأُ':Predicate, #1: 1	أَنَّ الْأَسْنَانَ
u'أَنَّ أَسْواقٌ':Predicate, #1: 1	أَنَّ أَسْوَأَ
u'أَنَّ أسْوَد':Predicate, #2: 2	أَنَّ أَسْوَاقَ
u'أَنَّ أسْوَد':Predicate, #2: 2	أَنَّ الأَسْوَدَ
u'أَنَّ أَسيرٌ':Predicate, #5: 5	أَنَّ الْأَسْوَدَ
u'أَنَّ إشارَة':Predicate, #7: 7	أَنَّ الْأَسِيرَ
u'أَنَّ إشارَة':Predicate, #1: 1	أَنَّ إِشَارَةَ
u'أَنَّ إشارَة':Predicate, #37: 37	أَنَّ الْإِشَارَةَ
u'أَنَّ إشاعَةٌ':Predicate, #6: 6	أَنَّ إشَارَةَ
u'أَنَّ أشباه':Predicate, #2: 2	أَنَّ الْإِشَاعَةَ
u'أَنَّ أشْبَاهٌ':Predicate, #1: 1	أَنَّ الْأَشْبَاهَ
u'أَنَّ أَشْبَاهٌ':Predicate, #1: 1	أَنَّ الْأَشْبَاهَ
u'أَنَّ أشْبَهُ':Predicate, #1: 1	أَنَّ الْأَشْبَاهَ
u'أَنَّ اِشْتِباهٌ':Predicate, #12: 12	أَنَّ الْأَشْبَهَ
u'أَنَّ اِشْتِدادٌ':Predicate, #1: 1	أَنَّ اشْتِبَاهَ
u'أَنَّ اِشْتِراءٌ':Predicate, #1: 1	أَنَّ اشْتِدَادَ
u'أَنَّ اِشْتِراطٌ':Predicate, #1: 1	أَنَّ اشْتِرَاءَ
u'أَنَّ اِشْتِغالٌ':Predicate, #56: 56	أَنَّ اشْتِرَاطَ
u'أَنَّ اِشْتِقاقٌ':Predicate, #2: 2	أَنَّ اشْتِغَالَ
u'أَنَّ اِشْتِهارٌ':Predicate, #1: 1	أَنَّ اشْتِقَاقَ
u'أَنَّ أَشْجَارٌ':Predicate, #1: 1	أَنَّ اشْتِهَارَ
u'أَنَّ إِشْراعٌ':Predicate, #2: 2	أَنَّ الْأَشْجَارَ
u'أَنَّ أَشْرِبَةٌ':Predicate, #2: 2	أَنَّ إشْرَاعَ
u'أَنَّ أشرف':Predicate, #1: 1	أَنَّ الْأَشْرِبَةَ
u'أَنَّ أَشْرَفُ':Predicate, #2: 2	أَنَّ أَشْرَفَ
u'أَنَّ إِشْعارٌ':Predicate, #2: 2	أَنَّ أَشْرَفَ
u'أَنَّ إِشْعارٌ':Predicate, #1: 1	أَنَّ إشْعَارَ
u'أَنَّ إِشْعارٌ':Predicate, #1: 1	أَنَّ الإِشْعَارَ
u'أَنَّ أَشْعَث':Predicate, #1: 1	أَنَّ الْإِشْعَارَ
u'أَنَّ أَشْعَث':Predicate, #1: 1	أَنَّ أَشْعَثَ
u'أَنَّ أَشْكَالٌ':Predicate, #3: 3	أَنَّ الأَشْعَثَ
u'أَنَّ إِشْكالٌ':Predicate, #2: 2	أَنَّ الْأَشْكَالَ
u'أَنَّ إِشْكالٌ':Predicate, #3: 3	أَنَّ إشْكَالَ
u'أَنَّ أَشْهَب':Predicate, #7: 7	أَنَّ الْإِشْكَالَ
u'أَنَّ أشْهَرُ':Predicate, #3: 3	أَنَّ أَشْهَبَ
u'أَنَّ أَشْهُرٌ':Predicate, #10: 10	أَنَّ الْأَشْهَرَ
u'أَنَّ أَشْهُرٌ':Predicate, #5: 5	أَنَّ أَشْهُرَ
u'أَنَّ أَشْيَاءٌ':Predicate, #6: 6	أَنَّ الْأَشْهُرَ
u'أَنَّ أَشْيَاخٌ':Predicate, #7: 7	أَنَّ الْأَشْيَاءَ
u'أَنَّ إصابَةٌ':Predicate, #1: 1	أَنَّ الْأَشْيَاخَ
u'أَنَّ إصابَةٌ':Predicate, #2: 2	أَنَّ إصَابَةَ
u'أَنَّ أَصابِعُ':Predicate, #4: 4	أَنَّ الْإِصَابَةَ
u'أَنَّ أَصابِعُ':Predicate, #1: 1	أَنَّ الأَصَابِعَ
u'أَنَّ أصاغر':Predicate, #6: 6	أَنَّ الْأَصَابِعَ
u'أَنَّ أَصالَةٌ':Predicate, #1: 1	أَنَّ الْأَصَاغِرَ
u'أَنَّ أَصالَةٌ':Predicate, #1: 1	أَنَّ أَصَالَةَ
u'أَنَّ أَصْبَاغٌ':Predicate, #1: 1	أَنَّ الْأَصَالَةَ
u'أَنَّ أُصْبُعٌ':Predicate, #1: 1	أَنَّ أَصْبَاغَ
u'أَنَّ أَصْحَابٌ':Predicate, #4: 4	أَنَّ الْأُصْبُعَ
u'أَنَّ أَصْحَابٌ':Predicate, #1: 1	أَنَّ أَصْحَابَكَ
u'أَنَّ أَصْحَابٌ':Predicate, #58: 58	أَنَّ أَصْحَابَ
u'أَنَّ إِصْرارٌ':Predicate, #62: 62	أَنَّ الْأَصْحَابَ
u'أَنَّ إِصْطَبْلٌ':Predicate, #3: 3	أَنَّ الْإِصْرَارَ
u'أَنَّ اِصْطِدامٌ':Predicate, #1: 1	أَنَّ الْإِصْطَبْلَ
u'أَنَّ اِصْطِلاحٌ':Predicate, #1: 1	أَنَّ اصْطِدَامَ
u'أَنَّ اِصْطِيادٌ':Predicate, #3: 3	أَنَّ اصْطِلَاحَ
u'أَنَّ أصْغَرٌ':Predicate, #1: 1	أَنَّ اصْطِيَادَ
u'أَنَّ أَصْغَرُ':Predicate, #2: 2	أَنَّ الْأَصْغَرَ
u'أَنَّ أَصْفَر':Predicate, #2: 2	أَنَّ الْأَصْغَرَ
u'أَنَّ أصل':Predicate, #1: 1	أَنَّ الْأَصْفَرَ
u'أَنَّ أًصْلٌ':Predicate, #108: 108	أَنَّ أَصْلَ
u'أَنَّ أصل':Predicate, #108: 108	أَنَّ أَصْلَ
u'أَنَّ أًصْلٌ':Predicate, #234: 234	أَنَّ الْأَصْلَ
u'أَنَّ إِصْلاحٌ':Predicate, #234: 234	أَنَّ الْأَصْلَ
u'أَنَّ إِصْلاحٌ':Predicate, #2: 2	أَنَّ إصْلَاحَ
u'أَنَّ أَصْلِيٌّ':Predicate, #2: 2	أَنَّ الْإِصْلَاحَ
u'أَنَّ أَصَمّ':Predicate, #4: 4	أَنَّ الْأَصْلِيَّ
u'أَنَّ أَصْنَافٌ':Predicate, #1: 1	أَنَّ الْأَصَمَّ
u'أَنَّ أَصْنَافٌ':Predicate, #2: 2	أَنَّ أَصْنَافَ
u'أَنَّ أَصْهَارٌ':Predicate, #3: 3	أَنَّ الْأَصْنَافَ
u'أَنَّ أُصولٌ':Predicate, #1: 1	أَنَّ الْأَصْهَارَ
u'أَنَّ أُصولٌ':Predicate, #14: 14	أَنَّ أُصُولَ
u'أَنَّ أَصيلٌ':Predicate, #5: 5	أَنَّ الْأُصُولَ
u'أَنَّ إِضاعَةٌ':Predicate, #4: 4	أَنَّ الْأَصِيلَ
u'أَنَّ إضافَةٌ':Predicate, #3: 3	أَنَّ إضَاعَةَ
u'أَنَّ إضافَةٌ':Predicate, #15: 15	أَنَّ إضَافَةَ
u'أَنَّ اِضْطِجاعٌ':Predicate, #24: 24	أَنَّ الْإِضَافَةَ
u'أَنَّ اِضْطِرابٌ':Predicate, #1: 1	أَنَّ الاِضْطِجَاعَ
u'أَنَّ إضْمارٌ':Predicate, #1: 1	أَنَّ الاضْطِرَابَ
u'أَنَّ إضْمارٌ':Predicate, #1: 1	أَنَّ إضْمَارَ
u'أَنَاطَ إِسْقاطٌ':Predicate, #7: 7	أَنَّ الْإِضْمَارَ
u'أَنَّ إِطالَةٌ':Predicate, #1: 1	أَنَاطَ الْإِسْقَاطَ
u'أَنَّ إِطالَةٌ':Predicate, #1: 1	أَنَّ الْإِطَالَةَ
u'أَنَّ إِطْباقٌ':Predicate, #3: 3	أَنَّ إطَالَةَ
u'أَنَاطَ تَوْلِيَةٌ':Predicate, #1: 1	أَنَّ إطْبَاقَ
u'أَنَاطَ حُكْمٌ':Predicate, #1: 1	أَنَاطَ التَّوْلِيَةَ
u'أَنَاطَ حِلٌّ':Predicate, #3: 3	أَنَاطَ الْحُكْمَ
u'أَنَّ أَطْرافٌ':Predicate, #1: 1	أَنَاطَ الْحِلَّ
u'أَنَّ أَطْرَافٌ':Predicate, #8: 8	أَنَّ الْأَطْرَافَ
u'أَنَاطَ شَارِعٌ':Subject, #8: 8	أَنَّ الْأَطْرَافَ
u'أَنَّ إِطْعامٌ':Predicate, #1: 1	أَنَاطَ الشَّارِعُ
u'أَنَّ إِطْعامٌ':Predicate, #1: 1	أَنَّ إطْعَامَ
u'أَنَّ أَطْفَالٌ':Predicate, #2: 2	أَنَّ الْإِطْعَامَ
u'أَنَّ أَطْفَالٌ':Predicate, #1: 1	أَنَّ أَطْفَالَ
u'أَنَّ اِطِّلاعٌ':Predicate, #2: 2	أَنَّ الْأَطْفَالَ
u'أَنَّ إِطْلاقٌ':Predicate, #1: 1	أَنَّ اطِّلَاعَ
u'أَنَّ إِطْلاقٌ':Predicate, #2: 2	أَنَّ إِطْلَاقَ
u'أَنَّ إِطْلاقٌ':Predicate, #48: 48	أَنَّ إطْلَاقَ
u'أَنَاطَ مُصَنِّفٌ':Subject, #9: 9	أَنَّ الْإِطْلَاقَ
u'أَنَّ أَطْوَلُ':Predicate, #3: 3	أَنَاطَ الْمُصَنِّفُ
u'أَنَّ إِظْهارٌ':Predicate, #1: 1	أَنَّ أَطْوَلَ
u'أَنَّ أظهر':Predicate, #2: 2	أَنَّ إظْهَارَ
u'أَنَّ إِعادَةٌ':Predicate, #16: 16	أَنَّ الْأَظْهَرَ
u'أَنَّ إِعادَةٌ':Predicate, #16: 16	أَنَّ الْإِعَادَةَ
u'أَنَّ إِعارَةٌ':Predicate, #8: 8	أَنَّ إعَادَةَ
u'أَنَّ إِعارَةٌ':Predicate, #10: 10	أَنَّ الْإِعَارَةَ
u'أَنَّ إِعانَةٌ':Predicate, #3: 3	أَنَّ إعَارَةَ
u'أَنَّ إِعْتاقٌ':Predicate, #2: 2	أَنَّ الْإِعَانَةَ
u'أَنَّ إِعْتاقٌ':Predicate, #13: 13	أَنَّ إعْتَاقَ
u'أَنَّ اِعْتِبارٌ':Predicate, #35: 35	أَنَّ الْإِعْتَاقَ
u'أَنَّ اِعْتِراضٌ':Predicate, #40: 40	أَنَّ اعْتِبَارَ
u'أَنَّ اِعْتِرافٌ':Predicate, #1: 1	أَنَّ اعْتِرَاضَ
u'أَنَّ اِعْتِزالٌ':Predicate, #2: 2	أَنَّ اعْتِرَافَ
u'أَنَّ اِعْتِقادٌ':Predicate, #1: 1	أَنَّ اعْتِزَالَ
u'أَنَّ اِعْتِكافٌ':Predicate, #7: 7	أَنَّ اعْتِقَادَ
u'أَنَّ اِعْتِمادٌ':Predicate, #1: 1	أَنَّ اعْتِكَافَ
u'أَنَّ إِعْجازٌ':Predicate, #1: 1	أَنَّ اعْتِمَادَ
u'أَنَّ إِعْدادٌ':Predicate, #6: 6	أَنَّ الْإِعْجَازَ
u'أَنَّ إِعْدامٌ':Predicate, #1: 1	أَنَّ إعْدَادَ
u'أَنَّ أَعْذَارٌ':Predicate, #1: 1	أَنَّ إعْدَامَ
u'أَنَّ أَعْذَارٌ':Predicate, #1: 1	أَنَّ أَعْذَارَ
u'أَنَّ أَعْرابٌ':Predicate, #1: 1	أَنَّ الْأَعْذَارَ
u'أَنَّ إِعْرابٌ':Predicate, #1: 1	أَنَّ الأَعْرَابَ
u'أَنَّ أَعْرابٌ':Predicate, #1: 1	أَنَّ الْإِعْرَابَ
u'أَنَّ أعْرَابِيٌّ':Predicate, #2: 2	أَنَّ الْأَعْرَابَ
u'أَنَّ أعْرَابِيٌّ':Predicate, #1: 1	أَنَّ أَعْرَابِيَّةً
u'أَنَّ أعْرَابِيٌّ':Predicate, #1: 1	أَنَّ الأَعْرَابِيَّ
u'أَنَّ إعْرَاضٌ':Predicate, #3: 3	أَنَّ الْأَعْرَابِيَّ
u'أَنَّ أَعْضَاءٌ':Predicate, #4: 4	أَنَّ الْإِعْرَاضَ
u'أَنَّ أَعْضَاءٌ':Predicate, #3: 3	أَنَّ الْأَعْضَاءَ
u'أَنَّ إعْطَاءٌ':Predicate, #5: 5	أَنَّ أَعْضَاءَ
u'أَنَّ إعْطَاءٌ':Predicate, #6: 6	أَنَّ إعْطَاءَ
u'أَنَّ أعْظَمُ':Predicate, #6: 6	أَنَّ الْإِعْطَاءَ
u'أَنَّ إعْلاَمٌ':Predicate, #7: 7	أَنَّ أَعْظَمَ
u'أَنَّ أَعْلاَمٌ':Predicate, #1: 1	أَنَّ الْإِعْلَامَ
u'أَنَّ إعْلاَنٌ':Predicate, #2: 2	أَنَّ الْأَعْلَامَ
u'أَنَّ أعْلَمُ':Predicate, #2: 2	أَنَّ الْإِعْلَانَ
u'أَنَّ أَعَمُّ':Predicate, #2: 2	أَنَّ الْأَعْلَمَ
u'أَنَّ أَعَمُّ':Predicate, #1: 1	أَنَّ أَعَمَّ
u'أَنَّ أَعْمَالٌ':Predicate, #2: 2	أَنَّ الْأَعَمَّ
u'أَنَّ إعْمَالٌ':Predicate, #10: 10	أَنَّ الْأَعْمَالَ
u'أَنَّ أَعْمَالٌ':Predicate, #2: 2	أَنَّ إعْمَالَ
u'أَنَّ أَعْمَامٌ':Predicate, #3: 3	أَنَّ أَعْمَالَ
u'أَنَّ أعْمَش':Predicate, #1: 1	أَنَّ الْأَعْمَامَ
u'أَنَّ أعْمَش':Predicate, #1: 1	أَنَّ الْأَعْمَشَ
u'أَنَّ أَعْوَاضٌ':Predicate, #2: 2	أَنَّ الأَعْمَشَ
u'أَنَّ أعْوَر':Predicate, #1: 1	أَنَّ الْأَعْوَاضَ
u'أَنَّ أعْيانٌ':Predicate, #1: 1	أَنَّ الْأَعْوَرَ
u'أَنَّ أَعْيَانٌ':Predicate, #1: 1	أَنَّ أَعْيَانَ
u'أَنَّ أعْيانٌ':Predicate, #1: 1	أَنَّ أَعْيَانَ
u'أَنَّ أَعْيَانٌ':Predicate, #7: 7	أَنَّ الْأَعْيَانَ
u'أَنَّ اِغْتِسَالٌ':Predicate, #7: 7	أَنَّ الْأَعْيَانَ
u'أَنَّ أغَرّ':Predicate, #1: 1	أَنَّ اغْتِسَالَ
u'أَنَّ أَغْرَاسٌ':Predicate, #1: 1	أَنَّ الأَغَرَّ
u'أَنَّ أَغْرَاضٌ':Predicate, #1: 1	أَنَّ الْأَغْرَاسَ
u'أَنَّ أَغْرَاضٌ':Predicate, #4: 4	أَنَّ أَغْرَاضَ
u'أَنَّ أَغْنِيَاء':Predicate, #4: 4	أَنَّ الْأَغْرَاضَ
u'أَنَّ إفَادَةٌ':Predicate, #2: 2	أَنَّ الْأَغْنِيَاءَ
u'أَنَّ إفَادَةٌ':Predicate, #1: 1	أَنَّ إفَادَةَ
u'أَنَّ آفَةٌ':Predicate, #1: 1	أَنَّ الْإِفَادَةَ
u'أَنَّ إفْتَاءٌ':Predicate, #1: 1	أَنَّ الْآفَةَ
u'أَنَّ اِفْتِتَاحٌ':Predicate, #7: 7	أَنَّ الْإِفْتَاءَ
u'أَنَّ اِفْتِداء':Predicate, #4: 4	أَنَّ افْتِتَاحَ
u'أَنَّ اِفْتِرَاقٌ':Predicate, #1: 1	أَنَّ افْتِدَاءَ
u'أَنَّ اِفْتِقَارٌ':Predicate, #1: 1	أَنَّ افْتِرَاقَ
u'أَنَّ أَفْرَادٌ':Predicate, #1: 1	أَنَّ افْتِقَارَ
u'أَنَّ أَفْرَادٌ':Predicate, #3: 3	أَنَّ أَفْرَادَ
u'أَنَّ إِفْرَادٌ':Predicate, #5: 5	أَنَّ الْأَفْرَادَ
u'أَنَّ إِفْرَادٌ':Predicate, #6: 6	أَنَّ إفْرَادَ
u'أَنَّ إفْسَادٌ':Predicate, #6: 6	أَنَّ الْإِفْرَادَ
u'أَنَّ إفْسَادٌ':Predicate, #2: 2	أَنَّ الْإِفْسَادَ
u'أَنَّ أفْضَلُ':Predicate, #5: 5	أَنَّ إفْسَادَ
u'أَنَّ أفْضَلُ':Predicate, #16: 16	أَنَّ أَفْضَلَ
u'أَنَّ أفْضَلِيَّةٌ':Predicate, #80: 80	أَنَّ الْأَفْضَلَ
u'أَنَّ أفْضَلِيَّةٌ':Predicate, #2: 2	أَنَّ أَفْضَلِيَّةَ
u'أَنَّ إِفْطارٌ':Predicate, #3: 3	أَنَّ الْأَفْضَلِيَّةَ
u'أَنَّ إِفْطارٌ':Predicate, #1: 1	أَنَّ إفْطَارَ
u'أَنَّ أَفْعَالٌ':Predicate, #4: 4	أَنَّ الْإِفْطَارَ
u'أَنَّ أَفْعَالٌ':Predicate, #11: 11	أَنَّ الْأَفْعَالَ
u'أَنَّ أَفْكَارٌ':Predicate, #8: 8	أَنَّ أَفْعَالَ
u'أَنَّ إفْلاَسٌ':Predicate, #1: 1	أَنَّ الْأَفْكَارَ
u'أَنَّ أَفْلاَكٌ':Predicate, #6: 6	أَنَّ الْإِفْلَاسَ
u'أَنَّ أفْواهٌ':Predicate, #3: 3	أَنَّ الْأَفْلَاكَ
u'أَنَّ أَفْواهٌ':Predicate, #2: 2	أَنَّ أَفْوَاهَ
u'أَنَّ أَفْوَاهٌ':Predicate, #2: 2	أَنَّ أَفْوَاهَ
u'أَنَّ أقارب':Predicate, #2: 2	أَنَّ أَفْوَاهَ
u'أَنَّ أقارب':Predicate, #1: 1	أَنَّ أَقَارِبَ
u'أَنَّ إقالَةٌ':Predicate, #2: 2	أَنَّ الْأَقَارِبَ
u'أَنَّ إقالَةٌ':Predicate, #1: 1	أَنَّ إقَالَةَ
u'أَنَّ إقالَةٌ':Predicate, #1: 1	أَنَّ الإِقَالَةَ
u'أَنَّ إقامَةٌ':Predicate, #20: 20	أَنَّ الْإِقَالَةَ
u'أَنَّ إقامَةٌ':Predicate, #19: 19	أَنَّ إقَامَةَ
u'أَنَّ إقامَةٌ':Predicate, #1: 1	أَنَّ الإِقَامَةَ
u'أَنَّ اِقْتِداءٌ':Predicate, #7: 7	أَنَّ الْإِقَامَةَ
u'أَنَّ اِقْتِران':Predicate, #10: 10	أَنَّ اقْتِدَاءَ
u'أَنَّ اِقْتِصَارٌ':Predicate, #2: 2	أَنَّ اقْتِرَانَ
u'أَنَّ اِقْتِضَاءٌ':Predicate, #3: 3	أَنَّ اقْتِصَارَ
u'أَنَّ اِقْتِناءٌ':Predicate, #4: 4	أَنَّ اقْتِضَاءَ
u'أَنَّ إقْدَامٌ':Predicate, #1: 1	أَنَّ اقْتِنَاءَ
u'أَنَّ إقْدَامٌ':Predicate, #1: 1	أَنَّ إقْدَامَ
u'أَنَّ أقْدَمُ':Predicate, #7: 7	أَنَّ الْإِقْدَامَ
u'أَنَّ أقْرأُ':Predicate, #1: 1	أَنَّ أَقْدَمَ
u'أَنَّ إِقْراءٌ':Predicate, #2: 2	أَنَّ الْأَقْرَأَ
u'أَنَّ إقْرَارٌ':Predicate, #2: 2	أَنَّ الْإِقْرَاءَ
u'أَنَّ إقْرَارٌ':Predicate, #30: 30	أَنَّ إقْرَارَ
u'أَنَّ إِقْراضٌ':Predicate, #71: 71	أَنَّ الْإِقْرَارَ
u'أَنَّ إِقْراضٌ':Predicate, #1: 1	أَنَّ الْإِقْرَاضَ
u'أَنَّ أقْرَبُ':Predicate, #2: 2	أَنَّ إقْرَاضَ
u'أَنَّ أقْرَبُ':Predicate, #1: 1	أَنَّ أَقْرَبَهُنَّ
u'أَنَّ أقْرَبُ':Predicate, #3: 3	أَنَّ أَقْرَبَ
u'أَنَّ أقْرَع':Predicate, #6: 6	أَنَّ الْأَقْرَبَ
u'أَنَّ أَقْسَامٌ':Predicate, #2: 2	أَنَّ الأَقْرَعَ
u'أَنَّ أَقْسَامٌ':Predicate, #1: 1	أَنَّ أَقْسَامَ
u'أَنَّ إقْطَاعٌ':Predicate, #7: 7	أَنَّ الْأَقْسَامَ
u'أَنَّ أقَلُّ':Predicate, #1: 1	أَنَّ الْإِقْطَاعَ
u'أَنَّ أقَلُّ':Predicate, #49: 49	أَنَّ أَقَلَّ
u'أَنَّ أقَلِّيَّةٌ':Predicate, #6: 6	أَنَّ الْأَقَلَّ
u'أَنَّ أَقْوَالٌ':Predicate, #1: 1	أَنَّ الْأَقَلِّيَّةَ
u'أَنَّ أَقْيِسَةٌ':Predicate, #5: 5	أَنَّ الْأَقْوَالَ
u'أَنَّ أكابر':Predicate, #1: 1	أَنَّ الْأَقْيِسَةَ
u'أَنَّ أكَّارٌ':Predicate, #1: 1	أَنَّ أَكَابِرَ
u'أَنَّ أكْبَرُ':Predicate, #1: 1	أَنَّ الْأَكَّارَ
u'أَنَّ اِكْتِفَاءٌ':Predicate, #5: 5	أَنَّ أَكْبَرَ
u'أَنَّ إكْثَارٌ':Predicate, #2: 2	أَنَّ اكْتِفَاءَ
u'أَنَّ أَكْثَرُ':Predicate, #3: 3	أَنَّ الْإِكْثَارَ
u'أَنَّ أَكْثَرُ':Predicate, #17: 17	أَنَّ الْأَكْثَرِينَ
u'أَنَّ أَكْثَرُ':Predicate, #20: 20	أَنَّ الْأَكْثَرَ
u'أَنَّ أكْثَرِيَّةٌ':Predicate, #72: 72	أَنَّ أَكْثَرَ
u'أَنَّ إكْرَامٌ':Predicate, #1: 1	أَنَّ الْأَكْثَرِيَّةَ
u'أَنَّ إكْرَامٌ':Predicate, #1: 1	أَنَّ إكْرَامَ
u'أَنَّ إكْرَاهٌ':Predicate, #3: 3	أَنَّ الْإِكْرَامَ
u'أَنَّ إكْرَاهٌ':Predicate, #2: 2	أَنَّ إكْرَاهَ
u'أَنَّ أكرياء':Predicate, #49: 49	أَنَّ الْإِكْرَاهَ
u'أَنَّ أكل':Predicate, #1: 1	أَنَّ الْأَكْرِيَاءَ
u'أَنَّ أَكْلٌ':Predicate, #15: 15	أَنَّ الْأَكْلَ
u'أَنَّ أكل':Predicate, #15: 15	أَنَّ الْأَكْلَ
u'أَنَّ أَكْلٌ':Predicate, #16: 16	أَنَّ أَكْلَ
u'أَنَّ إِكْمَالٌ':Predicate, #16: 16	أَنَّ أَكْلَ
u'أَنَّ أَكْمَلُ':Predicate, #2: 2	أَنَّ إكْمَالَ
u'أَنَّ آلةٌ':Predicate, #6: 6	أَنَّ الْأَكْمَلَ
u'أَنَّ آلةٌ':Predicate, #3: 3	أَنَّ آلَةَ
u'أَنَّ اِلْتِزَامٌ':Predicate, #4: 4	أَنَّ الْآلَةَ
u'أَنَّ اِلْتِقَاءٌ':Predicate, #10: 10	أَنَّ الْتِزَامَ
u'أَنَّ اِلْتِقَاطٌ':Predicate, #1: 1	أَنَّ الْتِقَاءَ
u'أَنَّ إلْجَاءٌ':Predicate, #2: 2	أَنَّ الْتِقَاطَ
u'أَنَّ إلْحَاحٌ':Predicate, #1: 1	أَنَّ الْإِلْجَاءَ
u'أَنَّ إلْحَادٌ':Predicate, #1: 1	أَنَّ الْإِلْحَاحَ
u'أَنَّ إلْحَاقٌ':Predicate, #1: 1	أَنَّ الْإِلْحَادَ
u'أَنَّ إلْحَاقٌ':Predicate, #3: 3	أَنَّ الْإِلْحَاقَ
u'أَنَّ إِلْزَامٌ':Predicate, #8: 8	أَنَّ إلْحَاقَ
u'أَنَّ إِلْزَامٌ':Predicate, #1: 1	أَنَّ الْإِلْزَامَ
u'أَنَّ ألف':Predicate, #1: 1	أَنَّ إلْزَامَ
u'أَنَّ ألف':Predicate, #17: 17	أَنَّ الْأَلِفَ
u'أَنَّ ألْفٌ':Predicate, #19: 19	أَنَّ الْأَلْفَ
u'أَنَّ أَلْفٌ':Predicate, #19: 19	أَنَّ الْأَلْفَ
u'أَنَّ ألف':Predicate, #19: 19	أَنَّ الْأَلْفَ
u'أَنَّ ألْفٌ':Predicate, #1: 1	أَنَّ أَلْفَ
u'أَنَّ أَلْفٌ':Predicate, #1: 1	أَنَّ أَلْفَ
u'أَنَّ أَلْفَاظٌ':Predicate, #1: 1	أَنَّ أَلْفَ
u'أَنَّ أَلْفَاظٌ':Predicate, #11: 11	أَنَّ الْأَلْفَاظَ
u'أَنَّ أُلْفَةٌ':Predicate, #9: 9	أَنَّ أَلْفَاظَ
u'أَنَّ إِلْقَاءٌ':Predicate, #1: 1	أَنَّ الْأُلْفَةَ
u'أَنَّ إِلْقَاءٌ':Predicate, #2: 2	أَنَّ الْإِلْقَاءَ
u'أَنَّ أَلْقَابٌ':Predicate, #3: 3	أَنَّ إلْقَاءَ
u'أَنَّ اللهُ':Predicate, #1: 1	أَنَّ الْأَلْقَابَ
u'أَنَّ ألَمٌ':Predicate, #1: 1	أَنَّ اللهَ
u'أَنَّ الْمَرْءُ':Predicate, #1: 1	أَنَّ الْأَلَمَ
u'أَنَّ الْمَرْأَةُ':Predicate, #10: 10	أَنَّ الْمَرْءَ
u'أَنَّ المُشْتَرِي':Predicate, #189: 189	أَنَّ الْمَرْأَةَ
u'أَنَّ إلَهٌ':Predicate, #212: 212	أَنَّ الْمُشْتَرِيَ
u'أَنَّ إلْهَامٌ':Predicate, #1: 1	أَنَّ إِلَهَكَ
u'أَنَّ أَلْوَانٌ':Predicate, #1: 1	أَنَّ الْإِلْهَامَ
u'أَنَّ ألُوفٌ':Subject, #1: 1	أَنَّ أَلْوَانَ
u'أَنَّ ألْيَةٌ':Predicate, #1: 1	أَنَّ أُلُوفٌ
u'أَنَّ أُمٌّ':Predicate, #1: 1	أَنَّ الْأَلْيَةَ
u'أَنَّ أُمٌّ':Predicate, #135: 135	أَنَّ أُمَّ
u'أَنَّ أُمٌّ':Predicate, #1: 1	أَنَّ الأُمَّ
u'أَنَّ إمَارَةٌ':Predicate, #59: 59	أَنَّ الْأُمَّ
u'أَنَّ أمَارَةٌ':Predicate, #3: 3	أَنَّ إمَارَةَ
u'أَنَّ آمال':Predicate, #4: 4	أَنَّ الْأَمَارَةَ
u'أَنَّ إمَامٌ':Predicate, #1: 1	أَنَّ الْآمَالَ
u'أَنَّ إمَامٌ':Predicate, #17: 17	أَنَّ إمَامَ
u'أَنَّ إمَامٌ':Predicate, #342: 342	أَنَّ الْإِمَامَ
u'أَنَّ إمَامَةٌ':Predicate, #3: 3	أَنَّ الإِمَامَ
u'أَنَّ إمَامَةٌ':Predicate, #11: 11	أَنَّ إمَامَةَ
u'أَنَّ إمَامَةٌ':Predicate, #1: 1	أَنَّ إمَامَتَهُنَّ
u'أَنَّ أمَانٌ':Predicate, #7: 7	أَنَّ الْإِمَامَةَ
u'أَنَّ أمَانٌ':Predicate, #3: 3	أَنَّ الْأَمَانَ
u'أَنَّ أمَانَةٌ':Predicate, #5: 5	أَنَّ أَمَانَ
u'أَنَّ أمَانَةٌ':Predicate, #1: 1	أَنَّ الأَمَانَةَ
u'أَنَّ أُمَّةٌ':Predicate, #7: 7	أَنَّ الْأَمَانَةَ
u'أَنَّ أُمَّةٌ':Predicate, #18: 18	أَنَّ الْأُمَّةَ
u'أَنَّ أُمَّةٌ':Predicate, #1: 1	أَنَّ الأُمَّةَ
u'أَنَّ أمَةٌ':Predicate, #1: 1	أَنَّ أُمَّةَ
u'أَنَّ أمَةٌ':Predicate, #4: 4	أَنَّ أَمَةَ
u'أَنَّ اِمْتِدَادٌ':Predicate, #57: 57	أَنَّ الْأَمَةَ
u'أَنَّ أَمْتِعَةٌ':Predicate, #1: 1	أَنَّ امْتِدَادَ
u'أَنَّ اِمْتِناعٌ':Predicate, #1: 1	أَنَّ الْأَمْتِعَةَ
u'أَنَّ اِمْتِيازٌ':Predicate, #11: 11	أَنَّ امْتِنَاعَ
u'أَنَّ أمثال':Predicate, #2: 2	أَنَّ امْتِيَازَ
u'أَنَّ أَمْثَالٌ':Predicate, #1: 1	أَنَّ أَمْثَالَ
u'أَنَّ أمثال':Predicate, #1: 1	أَنَّ أَمْثَالَ
u'أَنَّ أَمْثَالٌ':Predicate, #2: 2	أَنَّ الْأَمْثَالَ
u'أَنَّ أَمْثِلَةٌ':Predicate, #2: 2	أَنَّ الْأَمْثَالَ
u'أَنَّ أَمَدٌ':Predicate, #1: 1	أَنَّ أَمْثِلَةَ
u'أَنَّ أَمْرٌ':Predicate, #2: 2	أَنَّ أَمَدَ
u'أَنَّ أَمْرٌ':Predicate, #13: 13	أَنَّ الأَمْرَ
u'أَنَّ أَمْرٌ':Predicate, #1: 1	أَنَّ أَمْرَهُنَّ
u'أَنَّ أَمْرٌ':Predicate, #20: 20	أَنَّ أَمْرَ
u'أَنَّ آمِرٌ':Predicate, #259: 259	أَنَّ الْأَمْرَ
u'أَنَّ أمراء':Predicate, #33: 33	أَنَّ الْآمِرَ
u'أَنَّ اِمْرَأَةٌ':Predicate, #1: 1	أَنَّ أُمَرَاءَ
u'أَنَّ إِمْرارٌ':Predicate, #27: 27	أَنَّ امْرَأَةَ
u'أَنَّ إِمْرارٌ':Predicate, #1: 1	أَنَّ الْإِمْرَارَ
u'أَنَّ أَمْرَاضٌ':Predicate, #2: 2	أَنَّ إمْرَارَ
u'أَنَّ أَمْرَد':Predicate, #2: 2	أَنَّ الْأَمْرَاضَ
u'أَنَّ إِمْساكٌ':Predicate, #6: 6	أَنَّ الْأَمْرَدَ
u'أَنَّ إِمْضاءٌ':Predicate, #4: 4	أَنَّ الْإِمْسَاكَ
u'أَنَّ أَمْعاءٌ':Predicate, #9: 9	أَنَّ الْإِمْضَاءَ
u'أَنَّ أَمْعَاءٌ':Predicate, #1: 1	أَنَّ أَمْعَاءَ
u'أَنَامَ غُلاَمٌ':Subject, #1: 1	أَنَّ أَمْعَاءَ
u'أَنَّ إِمْكانٌ':Predicate, #1: 1	أَنَامَ الْغُلامُ
u'أَنَّ إِمْكانٌ':Predicate, #10: 10	أَنَّ إمْكَانَ
u'أَنَّ أَمْلاكٌ':Predicate, #5: 5	أَنَّ الْإِمْكَانَ
u'أَنَّ أَمْلاَكٌ':Predicate, #1: 1	أَنَّ الْأَمْلَاكَ
u'أَنَّ أَمْنٌ':Predicate, #1: 1	أَنَّ الْأَمْلَاكَ
u'أَنَّ إِمْهالٌ':Predicate, #3: 3	أَنَّ أَمْنَ
u'أَنَّ أَمْوَالٌ':Predicate, #3: 3	أَنَّ الْإِمْهَالَ
u'أَنَّ أَمْوَالٌ':Predicate, #11: 11	أَنَّ الْأَمْوَالَ
u'أَنَّ أُمُورٌ':Predicate, #5: 5	أَنَّ أَمْوَالَ
u'أَنَّ أُمومَةٌ':Predicate, #8: 8	أَنَّ الْأُمُورَ
u'أَنَّ أُمِّيٌّ':Predicate, #3: 3	أَنَّ الْأُمُومَةَ
u'أَنَّ أَميرٌ':Predicate, #2: 2	أَنَّ الْأُمِّيِّينَ
u'أَنَّ أَميرٌ':Predicate, #8: 8	أَنَّ الْأَمِيرَ
u'أَنَّ أَمينٌ':Predicate, #9: 9	أَنَّ أَمِيرَ
u'أَنَّ أَمينٌ':Predicate, #1: 1	أَنَّ أَمِينَ
u'أَنَّ إِناءٌ':Predicate, #6: 6	أَنَّ الْأَمِينَ
u'أَنَّ إِناءٌ':Predicate, #1: 1	أَنَّ إنَاءَ
u'أَنَّ إِناثٌ':Predicate, #2: 2	أَنَّ الْإِنَاءَ
u'أَنَّ إِنْباتٌ':Predicate, #2: 2	أَنَّ الْإِنَاثَ
u'أَنَّ أنبياء':Predicate, #3: 3	أَنَّ الْإِنْبَاتَ
u'أَنَّ اِنْتِصابٌ':Predicate, #21: 21	أَنَّ الْأَنْبِيَاءَ
u'أَنَّ اِنْتِظارٌ':Predicate, #1: 1	أَنَّ انْتِصَابَ
u'أَنَّ اِنْتِفاء':Predicate, #1: 1	أَنَّ انْتِظَارَ
u'أَنَّ اِنْتِقاضٌ':Predicate, #8: 8	أَنَّ انْتِفَاءَ
u'أَنَّ اِنْتِقالٌ':Predicate, #2: 2	أَنَّ انْتِقَاضَ
u'أَنَّ اِنْتِهاءٌ':Predicate, #2: 2	أَنَّ انْتِقَالَ
u'أَنَّ اِنْحِرافٌ':Predicate, #1: 1	أَنَّ انْتِهَاءَ
u'أَنَّ اِنْحِصارٌ':Predicate, #1: 1	أَنَّ انْحِرَافَ
u'أَنَّ إِنْذارٌ':Predicate, #1: 1	أَنَّ انْحِصَارَ
u'أَنَّ إِنْزالٌ':Predicate, #1: 1	أَنَّ الْإِنْذَارَ
u'أَنَّ إِنْزالٌ':Predicate, #3: 3	أَنَّ إنْزَالَ
u'أَنَّ إِنْسَاءٌ':Predicate, #4: 4	أَنَّ الْإِنْزَالَ
u'أَنَّ إِنْسانٌ':Predicate, #1: 1	أَنَّ الْإِنْسَاءَ
u'أَنَّ إِنْسانٌ':Predicate, #1: 1	أَنَّ الإِنْسَانَ
u'أَنَّ إِنْسِيٌّ':Predicate, #91: 91	أَنَّ الْإِنْسَانَ
u'أَنَّ إِنْشاءٌ':Predicate, #1: 1	أَنَّ الْإِنْسِيَّ
u'أَنَّ إِنْشاءٌ':Predicate, #4: 4	أَنَّ إنْشَاءَ
u'أَنَّ إِنْشادٌ':Predicate, #5: 5	أَنَّ الْإِنْشَاءَ
u'أَنَّ أنصار':Predicate, #1: 1	أَنَّ الْإِنْشَادَ
u'أَنَّ أَنْصارٌ':Predicate, #3: 3	أَنَّ الْأَنْصَارَ
u'أَنَّ أَنْصَارٌ':Predicate, #3: 3	أَنَّ الْأَنْصَارَ
u'أَنَّ أنصار':Predicate, #3: 3	أَنَّ الْأَنْصَارَ
u'أَنَّ أَنْصارٌ':Predicate, #8: 8	أَنَّ الأَنْصَارَ
u'أَنَّ أَنْصَارٌ':Predicate, #8: 8	أَنَّ الأَنْصَارَ
u'أَنَّ إِنْصافٌ':Predicate, #8: 8	أَنَّ الأَنْصَارَ
u'أَنَّ أَنْصِبَاءُ':Predicate, #1: 1	أَنَّ الْإِنْصَافَ
u'أَنَّ إِنْعامٌ':Predicate, #2: 2	أَنَّ الْأَنْصِبَاءَ
u'أَنَّ اِنْعِقَادٌ':Predicate, #1: 1	أَنَّ الْإِنْعَامَ
u'أَنَّ أَنْفٌ':Predicate, #7: 7	أَنَّ انْعِقَادَ
u'أَنَّ إِنْفاقٌ':Predicate, #1: 1	أَنَّ الْأَنْفَ
u'أَنَّ إِنْفاقٌ':Predicate, #1: 1	أَنَّ الْإِنْفَاقَ
u'أَنَّ اِنْفِرادٌ':Predicate, #1: 1	أَنَّ إنْفَاقَ
u'أَنَّ اِنْفِصالٌ':Predicate, #1: 1	أَنَّ انْفِرَادَ
u'أَنَّ اِنْفِكاكٌ':Predicate, #2: 2	أَنَّ انْفِصَالَ
u'أَنَّ اِنْقِبَاضٌ':Predicate, #2: 2	أَنَّ انْفِكَاكَ
u'أَنَّ اِنْقِرَاضٌ':Predicate, #1: 1	أَنَّ انْقِبَاضَ
u'أَنَّ اِنْقِضاءٌ':Predicate, #2: 2	أَنَّ انْقِرَاضَ
u'أَنَّ اِنْقِطاعٌ':Predicate, #3: 3	أَنَّ انْقِضَاءَ
u'أَنَّ اِنْقِلابٌ':Predicate, #3: 3	أَنَّ انْقِطَاعَ
u'أَنَّ إِنْكارٌ':Predicate, #2: 2	أَنَّ انْقِلَابَ
u'أَنَّ إِنْكارٌ':Predicate, #11: 11	أَنَّ إنْكَارَ
u'أَنَّ اِنْكِشَافٌ':Predicate, #5: 5	أَنَّ الْإِنْكَارَ
u'أَنَّ أُنْمُلَةٌ':Predicate, #2: 2	أَنَّ انْكِشَافَ
u'أَنَّ إنْهَاءٌ':Predicate, #1: 1	أَنَّ الْأُنْمُلَةَ
u'أَنَّ إنْهَاءٌ':Predicate, #1: 1	أَنَّ الْإِنْهَاءَ
u'أَنَّ أَنْهَارٌ':Predicate, #1: 1	أَنَّ إنْهَاءَ
u'أَنَّ أَنْهَارٌ':Predicate, #1: 1	أَنَّ أَنْهَارَ
u'أَنَّ أَنْوَارٌ':Predicate, #4: 4	أَنَّ الْأَنْهَارَ
u'أَنَّ أَنْوَاعٌ':Predicate, #1: 1	أَنَّ الْأَنْوَارَ
u'أَنَّ أَنْوَاعٌ':Predicate, #1: 1	أَنَّ الْأَنْوَاعَ
u'أَنَّ آنِيَةٌ':Predicate, #3: 3	أَنَّ أَنْوَاعَ
u'أَنَّ إهَابٌ':Predicate, #1: 1	أَنَّ آنِيَةَ
u'أَنَّ إهْدَاءٌ':Predicate, #1: 1	أَنَّ الْإِهَابَ
u'أَنَّ إهْدَاءٌ':Predicate, #1: 1	أَنَّ إهْدَاءَ
u'أَنَّ أهْلٌ':Predicate, #3: 3	أَنَّ الْإِهْدَاءَ
u'أَنَّ أهْلٌ':Predicate, #173: 173	أَنَّ أَهْلَ
u'أَنَّ إِهْلاَكٌ':Predicate, #3: 3	أَنَّ الْأَهْلَ
u'أَنَّ إهْلاَلٌ':Predicate, #1: 1	أَنَّ الْإِهْلَاكَ
u'أَنَّ إهْلاَلٌ':Predicate, #1: 1	أَنَّ إهْلَالَ
u'أَنَّ أَهِلَّةٌ':Predicate, #1: 1	أَنَّ إِهْلاَلَ
u'أَنَّ أَهِلَّةٌ':Predicate, #1: 1	أَنَّ الْأَهِلَّةَ
u'أَنَّ أَهْلِيٌّ':Predicate, #2: 2	أَنَّ الأَهِلَّةَ
u'أَنَّ أَهْلِيٌّ':Predicate, #3: 3	أَنَّ الْأَهْلِيَّةَ
u'أَنَّ أهْلِيَّةٌ':Predicate, #7: 7	أَنَّ أَهْلِيَّةَ
u'أَنَّ أهْلِيَّةٌ':Predicate, #3: 3	أَنَّ الْأَهْلِيَّةَ
u'أَنَّ أوامر':Predicate, #7: 7	أَنَّ أَهْلِيَّةَ
u'أَنَّ أَوامِرُ':Predicate, #2: 2	أَنَّ الْأَوَامِرَ
u'أَنَّ أوَانٌ':Predicate, #2: 2	أَنَّ الْأَوَامِرَ
u'أَنَّ أوائل':Predicate, #2: 2	أَنَّ أَوَانَ
u'أَنَّ أَوْتَارٌ':Predicate, #1: 1	أَنَّ أَوَائِلَ
u'أَنَّ أوْجَهُ':Predicate, #1: 1	أَنَّ الْأَوْتَارَ
u'أَنَّ أَوْجُهٌ':Predicate, #22: 22	أَنَّ الْأَوْجَهَ
u'أَنَّ أَوْرَاقٌ':Predicate, #6: 6	أَنَّ الْأَوْجُهَ
u'أَنَّ أَوْزَانٌ':Predicate, #1: 1	أَنَّ أَوْرَاقَ
u'أَنَّ أوْسَطُ':Predicate, #1: 1	أَنَّ الْأَوْزَانَ
u'أَنَّ أَوْصَافٌ':Predicate, #3: 3	أَنَّ الْأَوْسَطَ
u'أَنَّ أَوْصِيَاءٌ':Predicate, #10: 10	أَنَّ الْأَوْصَافَ
u'أَنَّ أَوْطَانٌ':Predicate, #1: 1	أَنَّ الْأَوْصِيَاءَ
u'أَنَّ أَوْقَاتٌ':Predicate, #4: 4	أَنَّ الْأَوْطَانَ
u'أَنَّ أَوْقَاتٌ':Predicate, #2: 2	أَنَّ الْأَوْقَاتَ
u'أَنَّ أَوْقَافٌ':Predicate, #4: 4	أَنَّ أَوْقَاتَ
u'أَنَّ أَوَّلُ':Predicate, #2: 2	أَنَّ الْأَوْقَافَ
u'أَنَّ أَوَّلُ':Predicate, #168: 168	أَنَّ الْأَوَّلَ
u'أَنَّ أَوَّلُ':Predicate, #1: 1	أَنَّ الأَوَّلَ
u'أَنَّ أَوَّلُ':Predicate, #4: 4	أَنَّ الْأَوَّلِينَ
u'أَنَّ أَوْلاَدٌ':Predicate, #63: 63	أَنَّ أَوَّلَ
u'أَنَّ أَوْلاَدٌ':Predicate, #15: 15	أَنَّ الْأَوْلَادَ
u'أَنَّ أَوْلَوِيٌّ':Predicate, #16: 16	أَنَّ أَوْلَادَ
u'أَنَّ أَوَّلِيٌّ':Predicate, #1: 1	أَنَّ أَوْلَوِيَّةَ
u'أَنَّ أَوْلِيَاءُ':Predicate, #1: 1	أَنَّ الْأَوَّلِيَّةَ
u'أَنَّ أَوْلِيَاءُ':Predicate, #5: 5	أَنَّ الْأَوْلِيَاءَ
u'أَنَّ أَوْهَامٌ':Predicate, #5: 5	أَنَّ أَوْلِيَاءَ
u'أَنَّ آيٌ':Predicate, #1: 1	أَنَّ أَوْهَامَ
u'أَنَّ أئِمَّةٌ':Predicate, #1: 1	أَنَّ آيَ
u'أَنَّ أئِمَّةٌ':Predicate, #15: 15	أَنَّ الْأَئِمَّةَ
u'أَنَّ أئِمَّةٌ':Predicate, #1: 1	أَنَّ الأَئِمَّةَ
u'أَنَّ أيَّامٌ':Predicate, #3: 3	أَنَّ أَئِمَّةَ
u'أَنَّ أَيَّامٌ':Predicate, #10: 10	أَنَّ أَيَّامَ
u'أَنَّ أيَّامٌ':Predicate, #10: 10	أَنَّ أَيَّامَ
u'أَنَّ أَيَّامٌ':Predicate, #4: 4	أَنَّ الْأَيَّامَ
u'أَنَّ آيَةٌ':Predicate, #4: 4	أَنَّ الْأَيَّامَ
u'أَنَّ آيَةٌ':Predicate, #22: 22	أَنَّ آيَةَ
u'أَنَّ آيَةٌ':Predicate, #2: 2	أَنَّ الآيَةَ
u'أَنَّ أيتام':Predicate, #74: 74	أَنَّ الْآيَةَ
u'أَنَّ إِيثَارٌ':Predicate, #1: 1	أَنَّ أَيْتَامَ
u'أَنَّ إِيثَارٌ':Predicate, #1: 1	أَنَّ إيثَارَ
u'أَنَّ إِيجَابٌ':Predicate, #3: 3	أَنَّ الْإِيثَارَ
u'أَنَّ إِيجَابٌ':Predicate, #16: 16	أَنَّ الْإِيجَابَ
u'أَنَّ إِيجَارٌ':Predicate, #24: 24	أَنَّ إيجَابَ
u'أَنَّ إِيجَارٌ':Predicate, #1: 1	أَنَّ الْإِيجَارَ
u'أَنَّ إِيدَاعٌ':Predicate, #1: 1	أَنَّ إيجَارَ
u'أَنَّ إِيدَاعٌ':Predicate, #1: 1	أَنَّ إيدَاعَ
u'أَنَّ أَيْدِي':Predicate, #3: 3	أَنَّ الْإِيدَاعَ
u'أَنَّ إيرَادٌ':Predicate, #2: 2	أَنَّ الْأَيْدِيَ
u'أَنَّ إيرَادٌ':Predicate, #4: 4	أَنَّ إيرَادَ
u'أَنَّ إيصَالٌ':Predicate, #5: 5	أَنَّ الْإِيرَادَ
u'أَنَّ إيصَالٌ':Predicate, #1: 1	أَنَّ الْإِيصَالَ
u'أَنَّ إيقَاعٌ':Predicate, #2: 2	أَنَّ إيصَالَ
u'أَنَّ إيقَاعٌ':Predicate, #10: 10	أَنَّ إيقَاعَ
u'أَنَّ أيِّمٌ':Predicate, #11: 11	أَنَّ الْإِيقَاعَ
u'أَنَّ أَيْمَانٌ':Predicate, #1: 1	أَنَّ الْأَيِّمَ
u'أَنَّ أَيْمَانٌ':Predicate, #15: 15	أَنَّ الْأَيْمَانَ
u'أَنَّ أَيْمَانٌ':Predicate, #1: 1	أَنَّ الأَيْمَانَ
u'أَنَّ إيمَانٌ':Predicate, #2: 2	أَنَّ أَيْمَانَ
u'أَنَّ إيمَانٌ':Predicate, #32: 32	أَنَّ الْإِيمَانَ
u'أَنَّ أَيْمَنُ':Predicate, #4: 4	أَنَّ إيمَانَ
u'أَنَّ أَيْمَن':Predicate, #1: 1	أَنَّ الْأَيْمَنَ
u'أَنَّ أَيْمَنُ':Predicate, #1: 1	أَنَّ الْأَيْمَنَ
u'أَنَّ أَيْمَن':Predicate, #2: 2	أَنَّ أَيْمَنَ
u'أَنَّ إِيهَامٌ':Predicate, #2: 2	أَنَّ أَيْمَنَ
u'أَنَّ باء':Predicate, #1: 1	أَنَّ الْإِيهَامَ
u'أَنْبَأَ اِبْنٌ':Subject, #13: 13	أَنَّ الْبَاءَ
u'أَنَّ بَابٌ':Predicate, #3: 3	أَنْبَأَ ابْنُ
u'أَنَّ بَابٌ':Predicate, #14: 14	أَنَّ بَابَ
u'أَنْبَأَ بِشْرٌ':Subject, #7: 7	أَنَّ الْبَابَ
u'أَنَّ بَاحِثٌ':Predicate, #1: 1	أَنْبَأَ بِشْرُ
u'أَنَّ بادِي':Predicate, #1: 1	أَنَّ الْبَاحِثَ
u'أَنَّ بادِئٌ':Predicate, #1: 1	أَنَّ الْبَادِيَ
u'أَنَّ باذِلٌ':Predicate, #2: 2	أَنَّ الْبَادِئَ
u'أَنَّ بَارِي':Predicate, #1: 1	أَنَّ الْبَاذِلَ
u'أَنَّ بَارِئٌ':Predicate, #8: 8	أَنَّ الْبَارِيَ
u'أَنَّ بَاطِلٌ':Predicate, #8: 8	أَنَّ الْبَارِئَ
u'أَنَّ بَاطن':Predicate, #10: 10	أَنَّ الْبَاطِلَ
u'أَنَّ باطِنٌ':Predicate, #2: 2	أَنَّ الْبَاطِنَ
u'أَنَّ بَاطن':Predicate, #2: 2	أَنَّ الْبَاطِنَ
u'أَنَّ باطِنٌ':Predicate, #4: 4	أَنَّ بَاطِنَ
u'أَنَّ بَاعِثٌ':Predicate, #4: 4	أَنَّ بَاطِنَ
u'أَنَّ بَاغِي':Predicate, #1: 1	أَنَّ بَاعِثَ
u'أَنْبَأَ فَاطِمٌ':Predicate, #3: 3	أَنَّ الْبَاغِيَ
u'أَنَّ باقِي':Predicate, #2: 2	أَنْبَأَ فَاطِمَةَ
u'أَنَّ باقِي':Predicate, #1: 1	أَنَّ بَاقِيَ
u'أَنَّ باقِي':Predicate, #25: 25	أَنَّ الْبَاقِيَ
u'أَنَّ باقِيَةٌ':Predicate, #2: 2	أَنَّ الْبَاقِيَةَ
u'أَنَّ بالِغٌ':Predicate, #2: 2	أَنَّ الْبَاقِيَةَ
u'أَنَّ بالِغٌ':Predicate, #1: 1	أَنَّ الْبَالِغَةَ
u'أَنْبَأَ مُسْلِمٌ':Subject, #2: 2	أَنَّ الْبَالِغَ
u'أَنَّ بَانٌ':Predicate, #1: 1	أَنْبَأَ مُسْلِمٌ
u'أَنَّ بَائِعٌ':Predicate, #1: 1	أَنَّ الْبَانَ
u'أَنَّ بَائِعٌ':Predicate, #1: 1	أَنَّ الْبَائِعَةَ
u'أَنَّ بَائِعٌ':Predicate, #212: 212	أَنَّ الْبَائِعَ
u'أَنَّ بَائِنٌ':Predicate, #6: 6	أَنَّ بَائِعَ
u'أَنَّ بَائِنٌ':Predicate, #1: 1	أَنَّ الْبَائِنَةَ
u'أَنَّ بَتُّ':Predicate, #9: 9	أَنَّ الْبَائِنَ
u'أَنَّ بَتّ':Predicate, #1: 1	أَنَّ الْبَتَّ
u'أَنَّ بتات':Predicate, #1: 1	أَنَّ الْبَتَّ
u'أَنَّ بَتَاتٌ':Predicate, #1: 1	أَنَّ الْبَتَاتَ
u'أَنْبَتَ رَبِيعٌ':Subject, #1: 1	أَنَّ الْبَتَاتَ
u'أَنْبَتَ زَيْتونٌ':Subject, #2: 2	أَنْبَتَ الرَّبِيعُ
u'أَنْبَتَ شَعْرٌ':Predicate, #1: 1	أَنْبَتَ الزّيْتُونُ
u'أَنْبَتَ شَعَرٌ':Predicate, #2: 2	أَنْبَتَ الشَّعْرَ
u'أَنْبَتَ ضَرَبٌ':Predicate, #4: 4	أَنْبَتَ الشَّعَرَ
u'أَنْبَتَ طَلْحٌ':Predicate, #1: 1	أَنْبَتَ ضَرَبَ
u'أَنْبَتَ قتل':Predicate, #1: 1	أَنْبَتَ الطّلْحَ
u'أَنْبَتَ كَافِرٌ':Subject, #3: 3	أَنْبَتَ قُتِلَ
u'أَنْبَتَ لَحْمٌ':Predicate, #1: 1	أَنْبَتَ الْكَافِرُ
u'أَنَّ بُجْرَةٌ':Predicate, #3: 3	أَنْبَتَ اللَّحْمَ
u'أَنَّ بَحْثٌ':Predicate, #1: 1	أَنَّ الْبُجْرَةَ
u'أَنَّ بَحْثٌ':Predicate, #11: 11	أَنَّ الْبَحْثَ
u'أَنَّ بَحْرٌ':Predicate, #4: 4	أَنَّ بَحْثَ
u'أَنَّ بُخَارِيٌّ':Predicate, #3: 3	أَنَّ الْبَحْرَ
u'أَنَّ بُخْلٌ':Predicate, #16: 16	أَنَّ الْبُخَارِيَّ
u'أَنَّ بخلاء':Predicate, #1: 1	أَنَّ الْبُخْلَ
u'أَنَّ بَدْءٌ':Predicate, #1: 1	أَنَّ الْبُخَلَاءَ
u'أَنَّ بِدَايَةٌ':Predicate, #1: 1	أَنَّ الْبَدْءَ
u'أَنَّ بِدَايَةٌ':Predicate, #1: 1	أَنَّ الْبِدَايَةَ
u'أَنَّ بِدَعٌ':Predicate, #1: 1	أَنَّ بِدَايَةَ
u'أَنَّ بِدْعَةٌ':Predicate, #22: 22	أَنَّ الْبِدَعَ
u'أَنَّ بَدَلٌ':Predicate, #12: 12	أَنَّ الْبِدْعَةَ
u'أَنَّ بَدَلٌ':Predicate, #16: 16	أَنَّ الْبَدَلَ
u'أَنَّ بدن':Predicate, #16: 16	أَنَّ بَدَلَ
u'أَنَّ بَدَنٌ':Predicate, #3: 3	أَنَّ بَدَنَ
u'أَنَّ بدن':Predicate, #3: 3	أَنَّ بَدَنَ
u'أَنَّ بَدَنٌ':Predicate, #8: 8	أَنَّ الْبَدَنَ
u'أَنَّ بدنة':Predicate, #8: 8	أَنَّ الْبَدَنَ
u'أَنَّ بدنيٌّ':Predicate, #6: 6	أَنَّ الْبَدَنَةَ
u'أَنَّ بديهيٌّ':Predicate, #1: 1	أَنَّ الْبَدَنِيَّةَ
u'أَنَّ بَديهِيٌّ':Predicate, #1: 1	أَنَّ الْبَدِيهِيَّ
u'أَنَّ بَذْرٌ':Predicate, #1: 1	أَنَّ الْبَدِيهِيَّ
u'أَنَّ بَذْلٌ':Predicate, #13: 13	أَنَّ الْبَذْرَ
u'أَنَّ بَذْلٌ':Predicate, #4: 4	أَنَّ الْبَذْلَ
u'أَنَّ بِرٌّ':Predicate, #4: 4	أَنَّ بَذْلَ
u'أَنَّ بُرٌّ':Predicate, #11: 11	أَنَّ الْبِرَّ
u'أَنَّ بُرٌّ':Predicate, #1: 1	أَنَّ بُرَّةَ
u'أَنَّ بَرٌّ':Predicate, #2: 2	أَنَّ الْبُرَّ
u'أَنَّ بِرٌّ':Predicate, #4: 4	أَنَّ الْبَرَّ
u'أَنَّ بُرْء':Predicate, #5: 5	أَنَّ بِرَّ
u'أَنَّ براءٌ':Predicate, #1: 1	أَنَّ الْبُرْءَ
u'أَنَّ بَراءٌ':Predicate, #13: 13	أَنَّ الْبَرَاءَ
u'أَنَّ بَراءةٌ':Predicate, #13: 13	أَنَّ الْبَرَاءَ
u'أَنَّ بَراءةٌ':Predicate, #11: 11	أَنَّ الْبَرَاءَةَ
u'أَنَّ بَراغِيثُ':Predicate, #5: 5	أَنَّ بَرَاءَةَ
u'أَنَّ بَرْقٌ':Predicate, #2: 2	أَنَّ الْبَرَاغِيثَ
u'أَنَّ برقيٌّ':Predicate, #2: 2	أَنَّ الْبَرْقَ
u'أَنَّ بَرَكَةٌ':Predicate, #1: 1	أَنَّ الْبَرْقِيَّ
u'أَنَّ بَرْنامَجٌ':Predicate, #1: 1	أَنَّ بَرَكَةَ
u'أَنَّ بُرْهانٌ':Predicate, #1: 1	أَنَّ الْبَرْنَامَجَ
u'أَنَّ بُرْهَانٌ':Predicate, #1: 1	أَنَّ الْبُرْهَانَ
u'أَنَّ بُرْهانٌ':Predicate, #1: 1	أَنَّ الْبُرْهَانَ
u'أَنَّ بُرْهَانٌ':Predicate, #2: 2	أَنَّ بُرْهَانَ
u'أَنَّ بُروجٌ':Predicate, #2: 2	أَنَّ بُرْهَانَ
u'أَنَّ بروزٌ':Predicate, #1: 1	أَنَّ الْبُرُوجَ
u'أَنَّ بَرِّيٌّ':Predicate, #1: 1	أَنَّ الْبُرُوزَ
u'أَنَّ بَريدٌ':Predicate, #1: 1	أَنَّ الْبَرِّيَّ
u'أَنَّ بَزّ':Predicate, #1: 1	أَنَّ الْبَرِيدَ
u'أَنَّ بَزَّارٌ':Predicate, #1: 1	أَنَّ الْبَزَّ
u'أَنَّ بساط':Predicate, #1: 1	أَنَّ الْبَزَّارَ
u'أَنَّ بِساطٌ':Predicate, #1: 1	أَنَّ الْبِسَاطَ
u'أَنَّ بَساطَةٌ':Predicate, #1: 1	أَنَّ الْبِسَاطَ
u'أَنَّ بُسْرٌ':Predicate, #1: 1	أَنَّ الْبَسَاطَةَ
u'أَنَّ بُسْرَةٌ':Predicate, #5: 5	أَنَّ بُسْرَ
u'أَنَّ بسط':Predicate, #4: 4	أَنَّ بُسْرَةَ
u'أَنَّ بَسْطٌ':Predicate, #1: 1	أَنَّ الْبَسْطَ
u'أَنَّ بسط':Predicate, #1: 1	أَنَّ الْبَسْطَ
u'أَنَّ بَسْطٌ':Predicate, #2: 2	أَنَّ بَسْطَ
u'أَنَّ بَسْمَلَةٌ':Predicate, #2: 2	أَنَّ بَسْطَ
u'أَنَّ بَسيطٌ':Predicate, #3: 3	أَنَّ الْبَسْمَلَةَ
u'أَنَّ بِشارَةٌ':Predicate, #2: 2	أَنَّ الْبَسِيطَ
u'أَنَّ بِشْرٌ':Predicate, #4: 4	أَنَّ الْبِشَارَةَ
u'أَنَّ بَشَرَةٌ':Predicate, #1: 1	أَنَّ بِشْرَ
u'أَنَّ بصرة':Predicate, #1: 1	أَنَّ الْبَشَرَةَ
u'أَنَّ بَصيرٌ':Predicate, #2: 2	أَنَّ بَصْرَةَ
u'أَنَّ بَطٌّ':Predicate, #4: 4	أَنَّ الْبَصِيرَ
u'أَنَّ بَطّال':Predicate, #1: 1	أَنَّ الْبَطَّ
u'أَنَّ بِطانَةٌ':Predicate, #1: 1	أَنَّ بَطَّالاً
u'أَنَّ بَطْشٌ':Predicate, #1: 1	أَنَّ الْبِطَانَةَ
u'أَنَّ بَطْنٌ':Predicate, #1: 1	أَنَّ الْبَطْشَ
u'أَنَّ بَطْنٌ':Predicate, #1: 1	أَنَّ بَطْنَ
u'أَنَّ بَطِيءٌ':Predicate, #2: 2	أَنَّ الْبَطْنَ
u'أَنَّ بِطِّيخٌ':Predicate, #1: 1	أَنَّ الْبَطِيءَ
u'أَنَّ بَعْثٌ':Predicate, #1: 1	أَنَّ الْبِطِّيخَ
u'أَنَّ بَعْثٌ':Predicate, #2: 2	أَنَّ الْبَعْثَ
u'أَنَّ بُعْدٌ':Predicate, #2: 2	أَنَّ بَعْثَ
u'أَنَّ بُعْدٌ':Predicate, #2: 2	أَنَّ بُعْدَ
u'أَنَّ بَعْضٌ':Predicate, #4: 4	أَنَّ الْبُعْدَ
u'أَنَّ بَعْضٌ':Predicate, #1: 1	أَنَّ بَعْضَهُنَّ
u'أَنَّ بَعْضٌ':Predicate, #204: 204	أَنَّ بَعْضَ
u'أَنَّ بَعيدٌ':Predicate, #4: 4	أَنَّ الْبَعْضَ
u'أَنَّ بَعيدٌ':Predicate, #1: 1	أَنَّ الْبَعِيدَةَ
u'أَنَّ بَعيرٌ':Predicate, #2: 2	أَنَّ الْبَعِيدَ
u'أَنَّ بُغاةٌ':Predicate, #6: 6	أَنَّ الْبَعِيرَ
u'أَنَّ بَغْدادِيٌّ':Predicate, #3: 3	أَنَّ الْبُغَاةَ
u'أَنَّ بُغْضٌ':Predicate, #1: 1	أَنَّ الْبَغْدَادِيِّينَ
u'أَنَّ بَغْلٌ':Predicate, #1: 1	أَنَّ بُغْضَ
u'أَنَّ بَقاءٌ':Predicate, #1: 1	أَنَّ بَغْلاً
u'أَنَّ بَقاءٌ':Predicate, #22: 22	أَنَّ بَقَاءَ
u'أَنَّ بِقاعٌ':Predicate, #2: 2	أَنَّ الْبَقَاءَ
u'أَنَّ بِقاعٌ':Predicate, #1: 1	أَنَّ الْبِقَاعَ
u'أَنَّ بَقَرٌ':Predicate, #1: 1	أَنَّ بِقَاعَ
u'أَنَّ بَقَرٌ':Predicate, #1: 1	أَنَّ بَقَرَةً
u'أَنَّ بَقَرٌ':Predicate, #5: 5	أَنَّ الْبَقَرَ
u'أَنَّ بُقْعَةٌ':Predicate, #6: 6	أَنَّ الْبَقَرَةَ
u'أَنَّ بَقِيَّةٌ':Predicate, #4: 4	أَنَّ الْبُقْعَةَ
u'أَنَّ بَقِيَّةٌ':Predicate, #17: 17	أَنَّ بَقِيَّةَ
u'أَنَّ بُكاءٌ':Predicate, #2: 2	أَنَّ الْبَقِيَّةَ
u'أَنَّ بُكاءٌ':Predicate, #10: 10	أَنَّ الْبُكَاءَ
u'أَنَّ بَكارَةٌ':Predicate, #1: 1	أَنَّ بُكَاءَ
u'أَنَّ بِكْرٌ':Predicate, #1: 1	أَنَّ الْبَكَارَةَ
u'أَنَّ بُكْرَةٌ':Predicate, #11: 11	أَنَّ الْبِكْرَ
u'أَنَّ بِلادٌ':Predicate, #1: 1	أَنَّ الْبُكْرَةَ
u'أَنَّ بِلادٌ':Predicate, #1: 1	أَنَّ بِلاَدَ
u'أَنَّ بِلادٌ':Predicate, #2: 2	أَنَّ بِلَادَ
u'أَنَّ بَلاطٌ':Predicate, #3: 3	أَنَّ الْبِلَادَ
u'أَنَّ بَلاغَةٌ':Predicate, #1: 1	أَنَّ الْبَلَاطَ
u'أَنَّ بَلَدٌ':Predicate, #1: 1	أَنَّ الْبَلَاغَةَ
u'أَنَّ بَلَدِيٌّ':Predicate, #5: 5	أَنَّ الْبَلَدَ
u'أَنَّ بَلْغَم':Predicate, #1: 1	أَنَّ الْبَلَدِيَّ
u'أَنَّ بُلُوغٌ':Predicate, #4: 4	أَنَّ الْبَلْغَمَ
u'أَنَّ بِنَاءٌ':Predicate, #5: 5	أَنَّ الْبُلُوغَ
u'أَنَّ بِنَاءٌ':Predicate, #16: 16	أَنَّ بِنَاءَ
u'أَنَّ بناتٌ':Predicate, #35: 35	أَنَّ الْبِنَاءَ
u'أَنَّ بناتٌ':Predicate, #1: 1	أَنَّ الْبَنَاتَ
u'أَنَّ بَنَادِقُ':Predicate, #2: 2	أَنَّ بَنَاتَ
u'أَنَّ بِنْتٌ':Predicate, #1: 1	أَنَّ الْبَنَادِقَ
u'أَنَّ بِنْتٌ':Predicate, #10: 10	أَنَّ الْبِنْتَ
u'أَنَّ بَنْجٌ':Predicate, #11: 11	أَنَّ بِنْتَ
u'أَنَّ بَنْدَر':Predicate, #6: 6	أَنَّ الْبَنْجَ
u'أَنَّ بُنْدُقٌ':Predicate, #1: 1	أَنَّ الْبَنْدَرَ
u'أَنَّ بُنْدُقٌ':Predicate, #1: 1	أَنَّ الْبُنْدُقَةَ
u'أَنَّ بَنَفْسَجٌ':Predicate, #3: 3	أَنَّ الْبُنْدُقَ
u'أَنَّ بُنُوَّة':Predicate, #1: 1	أَنَّ الْبَنَفْسَجَ
u'أَنَّ بُنْيانٌ':Predicate, #1: 1	أَنَّ الْبُنُوَّةَ
u'أَنَّ بَهائِمُ':Predicate, #1: 1	أَنَّ الْبُنْيَانَ
u'أَنَّ بَهيمٌ':Predicate, #6: 6	أَنَّ الْبَهَائِمَ
u'أَنَّ بَهِيمَةٌ':Predicate, #5: 5	أَنَّ الْبَهِيمَةَ
u'أَنَّ بواكي':Predicate, #5: 5	أَنَّ الْبَهِيمَةَ
u'أَنَّ بُؤْسٌ':Predicate, #1: 1	أَنَّ بَوَاكِيَ
u'أَنَّ بَوْلٌ':Predicate, #1: 1	أَنَّ الْبُؤْسَ
u'أَنَّ بَوْلٌ':Predicate, #11: 11	أَنَّ الْبَوْلَ
u'أَنَّ بِئْرٌ':Predicate, #9: 9	أَنَّ بَوْلَ
u'أَنَّ بِئْرٌ':Predicate, #1: 1	أَنَّ بِئْرَ
u'أَنَّ بَيَاضٌ':Predicate, #9: 9	أَنَّ الْبِئْرَ
u'أَنَّ بَيَانٌ':Predicate, #5: 5	أَنَّ الْبَيَاضَ
u'أَنَّ بَيَانٌ':Predicate, #10: 10	أَنَّ بَيَانَ
u'أَنَّ بَيْتٌ':Predicate, #24: 24	أَنَّ الْبَيَانَ
u'أَنَّ بَيْتٌ':Predicate, #13: 13	أَنَّ بَيْتَ
u'أَنَّ بيض':Predicate, #17: 17	أَنَّ الْبَيْتَ
u'أَنَّ بيض':Predicate, #1: 1	أَنَّ بَيْضَ
u'أَنَّ بَيْضاء':Predicate, #6: 6	أَنَّ الْبَيْضَ
u'أَنَّ بَيْضَةٌ':Predicate, #1: 1	أَنَّ الْبَيْضَاءَ
u'أَنَّ بَيْطارٌ':Predicate, #2: 2	أَنَّ الْبَيْضَةَ
u'أَنَّ بَيْعٌ':Predicate, #1: 1	أَنَّ الْبَيْطَارَ
u'أَنَّ بِيَعٌ':Predicate, #233: 233	أَنَّ الْبَيْعَ
u'أَنَّ بَيْعٌ':Predicate, #2: 2	أَنَّ الْبِيَعَ
u'أَنَّ بَيْعَةٌ':Predicate, #92: 92	أَنَّ بَيْعَ
u'أَنَّ بَيْعَةٌ':Predicate, #1: 1	أَنَّ الْبَيْعَةَ
u'أَنَّ بَيْنٌ':Predicate, #3: 3	أَنَّ بَيْعَةَ
u'أَنَّ بَيِّنَةٌ':Predicate, #50: 50	أَنَّ بَيْنَ
u'أَنَّ بَيِّنَةٌ':Predicate, #36: 36	أَنَّ بَيِّنَةَ
u'أَنَّ بُيُوتٌ':Predicate, #63: 63	أَنَّ الْبَيِّنَةَ
u'أَنَّ بُيُوتٌ':Predicate, #1: 1	أَنَّ بُيُوتَهُنَّ
u'أَنَّ بُيُوتٌ':Predicate, #2: 2	أَنَّ الْبُيُوتَ
u'أَنَّ تاء':Predicate, #2: 2	أَنَّ بُيُوتَ
u'أَنَّ تَابِعٌ':Predicate, #1: 1	أَنَّ التَّاءَ
u'أَنَّ تَابِعٌ':Predicate, #3: 3	أَنَّ التَّابِعِينَ
u'أَنَّ تَأْبِيدٌ':Predicate, #6: 6	أَنَّ التَّابِعَ
u'أَنَّ تَأْثِيرٌ':Predicate, #4: 4	أَنَّ التَّأْبِيدَ
u'أَنَّ تَأْثِيرٌ':Predicate, #6: 6	أَنَّ التَّأْثِيرَ
u'أَنَّ تَاجٌ':Predicate, #8: 8	أَنَّ تَأْثِيرَ
u'أَنَّ تَاجِرٌ':Predicate, #1: 1	أَنَّ تَاجَ
u'أَنَّ تَأْجِيلٌ':Predicate, #2: 2	أَنَّ التَّاجِرَ
u'أَنَّ تَأْجِيلٌ':Predicate, #3: 3	أَنَّ التَّأْجِيلَ
u'أَنَّ تَأَخُّرٌ':Predicate, #5: 5	أَنَّ تَأْجِيلَ
u'أَنَّ تَأْخِيرٌ':Predicate, #3: 3	أَنَّ تَأَخُّرَ
u'أَنَّ تَأْخِيرٌ':Predicate, #24: 24	أَنَّ تَأْخِيرَ
u'أَنَّ تَأْدِيبٌ':Predicate, #31: 31	أَنَّ التَّأْخِيرَ
u'أَنَّ تَأْدِيبٌ':Predicate, #1: 1	أَنَّ تَأْدِيبَ
u'أَنَّ تارِك':Predicate, #2: 2	أَنَّ التَّأْدِيبَ
u'أَنَّ تارِك':Predicate, #11: 11	أَنَّ تَارِكَ
u'أَنَّ تَارِيخٌ':Predicate, #2: 2	أَنَّ التَّارِكَ
u'أَنَّ تَارِيخٌ':Predicate, #2: 2	أَنَّ تَارِيخَ
u'أَنَّ تَاسِعٌ':Predicate, #5: 5	أَنَّ التَّارِيخَ
u'أَنَّ تَأْسِيسٌ':Predicate, #1: 1	أَنَّ التَّاسِعَ
u'أَنَّ تَافِهٌ':Predicate, #3: 3	أَنَّ التَّأْسِيسَ
u'أَنَّ تَأَكُّدٌ':Predicate, #1: 1	أَنَّ التَّافِهَ
u'أَنَّ تَأْكِيدٌ':Predicate, #2: 2	أَنَّ التَّأَكُّدَ
u'أَنَّ تالِف':Predicate, #9: 9	أَنَّ التَّأْكِيدَ
u'أَنَّ تَأْلِيفٌ':Predicate, #2: 2	أَنَّ التَّالِفَ
u'أَنَّ تَأْلِيفٌ':Predicate, #1: 1	أَنَّ التَّأْلِيفَ
u'أَنَّ تَامٌّ':Predicate, #1: 1	أَنَّ تَأْلِيفَ
u'أَنَّ تَأْمِينٌ':Predicate, #4: 4	أَنَّ تَامَّ
u'أَنَّ تَأَهُّبٌ':Predicate, #1: 1	أَنَّ تَأْمِينَ
u'أَنَّ تَائِبٌ':Predicate, #1: 1	أَنَّ التَّأَهُّبَ
u'أَنَّ تَأْيِيدٌ':Predicate, #3: 3	أَنَّ التَّائِبَ
u'أَنَّ تُبَّانٌ':Predicate, #1: 1	أَنَّ تَأْيِيدَ
u'أَنَّ تَبَايُنٌ':Predicate, #1: 1	أَنَّ التُّبَّانَ
u'أَنَّ تَبَايُنٌ':Predicate, #2: 2	أَنَّ تَبَايُنَ
u'أَنَّ تَبَخْتُرٌ':Predicate, #3: 3	أَنَّ التَّبَايُنَ
u'أَنَّ تَبَدُّلٌ':Predicate, #1: 1	أَنَّ التَّبَخْتُرَ
u'أَنَّ تَبْدِيلٌ':Predicate, #2: 2	أَنَّ تَبَدُّلَ
u'أَنَّ تَبْدِيلٌ':Predicate, #1: 1	أَنَّ التَّبْدِيلَ
u'أَنَّ تَبْذِيرٌ':Predicate, #1: 1	أَنَّ تَبْدِيلَ
u'أَنَّ تِبْر':Predicate, #4: 4	أَنَّ التَّبْذِيرَ
u'أَنَّ تِبْرٌ':Predicate, #1: 1	أَنَّ التِّبْرَ
u'أَنَّ تَبَرُّعٌ':Predicate, #1: 1	أَنَّ تِبْرَ
u'أَنَّ تَبَرُّعٌ':Predicate, #2: 2	أَنَّ تَبَرُّعَ
u'أَنَّ تَبَسُّمٌ':Predicate, #5: 5	أَنَّ التَّبَرُّعَ
u'أَنَّ تَبَع':Predicate, #3: 3	أَنَّ التَّبَسُّمَ
u'أَنَّ تَبَع':Predicate, #1: 1	أَنَّ التَّبَعَ
u'أَنَّ تَبَع':Predicate, #2: 2	أَنَّ تَبَعِيَّةَ
u'أَنَّ تَبَعِيّ':Predicate, #5: 5	أَنَّ التَّبَعِيَّةَ
u'أَنَّ تَبَعِيّ':Predicate, #2: 2	أَنَّ تَبَعِيَّةَ
u'أَنَّ تَبَعِيَّة':Predicate, #5: 5	أَنَّ التَّبَعِيَّةَ
u'أَنَّ تَبَعِيَّة':Predicate, #2: 2	أَنَّ تَبَعِيَّةَ
u'أَنَّ تَبْعِيض':Predicate, #5: 5	أَنَّ التَّبَعِيَّةَ
u'أَنَّ تَبْلِيغٌ':Predicate, #3: 3	أَنَّ التَّبْعِيضَ
u'أَنَّ تِبْيان':Predicate, #1: 1	أَنَّ التَّبْلِيغَ
u'أَنَّ تَبِيع':Predicate, #1: 1	أَنَّ التِّبْيَانَ
u'أَنَّ تَبَيُّنٌ':Predicate, #1: 1	أَنَّ التَّبِيعَ
u'أَنَّ تَبْيِين':Predicate, #1: 1	أَنَّ تَبَيُّنَ
u'أَنَّ تَتَابُعٌ':Predicate, #1: 1	أَنَّ التَّبْيِينَ
u'أَنَّ تَتَبُّعٌ':Predicate, #2: 2	أَنَّ التَّتَابُعَ
u'أَنَّ تَثْلِيثٌ':Predicate, #1: 1	أَنَّ تَتَبُّعَ
u'أَنَّ تَثْنِيَةٌ':Predicate, #2: 2	أَنَّ التَّثْلِيثَ
u'أَنْتَجَ إِثْبَاتٌ':Predicate, #3: 3	أَنَّ التَّثْنِيَةَ
u'أَنَّ تُجَّارٌ':Predicate, #2: 2	أَنْتَجَ إثْبَاتَ
u'أَنَّ تِجَارَةٌ':Predicate, #1: 1	أَنَّ التُّجَّارَ
u'أَنَّ تِجَارَةٌ':Predicate, #1: 1	أَنَّ تِجَارَةَ
u'أَنَّ تجَانُسٌ':Predicate, #6: 6	أَنَّ التِّجَارَةَ
u'أَنَّ تجَانُسٌ':Predicate, #1: 1	أَنَّ التَّجَانُسَ
u'أَنَّ تَجَدُّدٌ':Predicate, #1: 1	أَنَّ تَجَانُسَ
u'أَنَّ تَجْدِيدٌ':Predicate, #4: 4	أَنَّ تَجَدُّدَ
u'أَنَّ تَجْدِيدٌ':Predicate, #1: 1	أَنَّ تَجْدِيدَ
u'أَنَّ تَجْرِبَةٌ':Predicate, #2: 2	أَنَّ التَّجْدِيدَ
u'أَنَّ تَجْرِبَةٌ':Predicate, #1: 1	أَنَّ التَّجْرِبَةَ
u'أَنَّ تَجَلُّدٌ':Predicate, #1: 1	أَنَّ تَجْرِبَةَ
u'أَنْتَجَ مَزِيدٌ':Predicate, #1: 1	أَنَّ التَّجَلُّدَ
u'أَنْتَجَ نَتِيجَةٌ':Predicate, #1: 1	أَنْتَجَ مَزِيدَ
u'أَنْتَجَ نَفْيٌ':Predicate, #1: 1	أَنْتَجَ النَّتِيجَةَ
u'أَنَّ تَجْهِيزٌ':Predicate, #2: 2	أَنْتَجَ نَفْيَ
u'أَنَّ تَجَوُّزٌ':Predicate, #1: 1	أَنَّ التَّجْهِيزَ
u'أَنَّ تَجْوِيزٌ':Predicate, #1: 1	أَنَّ التَّجَوُّزَ
u'أَنَّ تَجْوِيزٌ':Predicate, #1: 1	أَنَّ التَّجْوِيزَ
u'أَنَّ تَحَالُفٌ':Predicate, #3: 3	أَنَّ تَجْوِيزَ
u'أَنَّ تَحَجُّرٌ':Predicate, #11: 11	أَنَّ التَّحَالُفَ
u'أَنَّ تَحَدِّي':Predicate, #1: 1	أَنَّ تَحَجُّرَ
u'أَنَّ تَحْدِيدٌ':Predicate, #2: 2	أَنَّ التَّحَدِّيَ
u'أَنَّ تَحْدِيدٌ':Predicate, #1: 1	أَنَّ تَحْدِيدَ
u'آنَ تَحْدِيدٌ':Subject, #5: 5	أَنَّ التَّحْدِيدَ
u'أَنَّ تَحَرُّكٌ':Predicate, #1: 1	آنَ تَحْدِيدُ
u'أَنَّ تَحَرِّي':Predicate, #1: 1	أَنَّ تَحَرُّكَ
u'أَنَّ تَحَرِّي':Predicate, #2: 2	أَنَّ تَحَرِّيَ
u'أَنَّ تَحْرِيرٌ':Predicate, #6: 6	أَنَّ التَّحَرِّيَ
u'أَنَّ تَحْرِيضٌ':Predicate, #1: 1	أَنَّ تَحْرِيرَ
u'أَنَّ تَحْرِيقٌ':Predicate, #1: 1	أَنَّ التَّحْرِيضَ
u'أَنَّ تَحْرِيك':Predicate, #2: 2	أَنَّ تَحْرِيقَ
u'أَنَّ تَحْرِيكٌ':Predicate, #2: 2	أَنَّ التَّحْرِيكَ
u'أَنَّ تَحْرِيمٌ':Predicate, #2: 2	أَنَّ تَحْرِيكَ
u'أَنَّ تَحْرِيم':Predicate, #23: 23	أَنَّ تَحْرِيمَ
u'أَنَّ تَحْرِيمٌ':Predicate, #2: 2	أَنَّ تَحْرِيمَةَ
u'أَنَّ تَحْرِيم':Predicate, #37: 37	أَنَّ التَّحْرِيمَ
u'أَنَّ تَحَسُّسٌ':Predicate, #6: 6	أَنَّ التَّحْرِيمَةَ
u'أَنَّ تَحْسِينٌ':Predicate, #1: 1	أَنَّ التَّحَسُّسَ
u'أَنَّ تَحَقُّقٌ':Predicate, #1: 1	أَنَّ تَحْسِينَ
u'أَنَّ تَحْقِيقٌ':Predicate, #6: 6	أَنَّ تَحَقُّقَ
u'أَنَّ تَحْقِيق':Predicate, #14: 14	أَنَّ التَّحْقِيقَ
u'أَنَّ تَحْقِيقٌ':Predicate, #1: 1	أَنَّ التَّحْقِيقِيَّةَ
u'أَنَّ تَحْقِيقِيّ':Predicate, #4: 4	أَنَّ تَحْقِيقَ
u'أَنَّ تَحْكِيمٌ':Predicate, #1: 1	أَنَّ التَّحْقِيقِيَّةَ
u'أَنَّ تَحْكِيمٌ':Predicate, #4: 4	أَنَّ التَّحْكِيمَ
u'أَنَّ تَحَلُّلٌ':Predicate, #4: 4	أَنَّ تَحْكِيمَ
u'أَنَّ تَحَلُّلٌ':Predicate, #11: 11	أَنَّ التَّحَلُّلَ
u'أَنَّ تَحْلِيف':Predicate, #2: 2	أَنَّ تَحَلُّلَ
u'أَنَّ تَحْلِيف':Predicate, #1: 1	أَنَّ تَحْلِيفَ
u'أَنَّ تَحْلِيلٌ':Predicate, #4: 4	أَنَّ التَّحْلِيفَ
u'أَنَّ تَحْلِيلٌ':Predicate, #1: 1	أَنَّ تَحْلِيلَ
u'أَنَّ تَحَمُّلٌ':Predicate, #4: 4	أَنَّ التَّحْلِيلَ
u'أَنَّ تَحَمُّلٌ':Predicate, #2: 2	أَنَّ تَحَمُّلَ
u'أَنَّ تَحْمِيلٌ':Predicate, #4: 4	أَنَّ التَّحَمُّلَ
u'أَنَّ تَحَوُّلٌ':Predicate, #3: 3	أَنَّ التَّحْمِيلَ
u'أَنَّ تَحْوِيلٌ':Predicate, #1: 1	أَنَّ التَّحَوُّلَ
u'أَنَّ تَحِيَّةٌ':Predicate, #1: 1	أَنَّ تَحْوِيلَ
u'أَنَّ تَحِيَّةٌ':Predicate, #3: 3	أَنَّ التَّحِيَّةَ
u'أَنَّ تَحَيُّرٌ':Predicate, #3: 3	أَنَّ تَحِيَّةَ
u'أَنَّ تَخَالُفٌ':Predicate, #1: 1	أَنَّ التَّحَيُّرَ
u'أَنَّ تَخْدِيرٌ':Predicate, #1: 1	أَنَّ التَّخَالُفَ
u'أَنَّ تَخْرِيجٌ':Predicate, #1: 1	أَنَّ التَّخْدِيرَ
u'أَنَّ تَخْرِيجٌ':Predicate, #2: 2	أَنَّ تَخْرِيجَ
u'أَنَّ تَخْصِيصٌ':Predicate, #4: 4	أَنَّ التَّخْرِيجَ
u'أَنَّ تَخْصِيصٌ':Predicate, #16: 16	أَنَّ تَخْصِيصَ
u'أَنَّ تَخَطِّي':Predicate, #41: 41	أَنَّ التَّخْصِيصَ
u'أَنَّ تَخْفِيفٌ':Predicate, #1: 1	أَنَّ التَّخَطِّيَ
u'أَنَّ تَخْفِيفٌ':Predicate, #1: 1	أَنَّ تَخْفِيفَ
u'أَنَّ تَخَلُّفٌ':Predicate, #4: 4	أَنَّ التَّخْفِيفَ
u'أَنَّ تَخَلُّلٌ':Predicate, #4: 4	أَنَّ التَّخَلُّفَ
u'أَنَّ تَخْلِيَة':Predicate, #2: 2	أَنَّ تَخَلُّلَ
u'أَنَّ تَخْلِيصٌ':Predicate, #7: 7	أَنَّ التَّخْلِيَةَ
u'أَنَّ تَخَمُّرٌ':Predicate, #4: 4	أَنَّ تَخْلِيصَ
u'أَنَّ تَخَمُّرٌ':Predicate, #1: 1	أَنَّ التَّخَمُّرَ
u'أَنَّ تَخَوُّفٌ':Predicate, #1: 1	أَنَّ تَخَمُّرَ
u'أَنَّ تَخْوِيفٌ':Predicate, #1: 1	أَنَّ التَّخَوُّفَ
u'أَنَّ تَخْيِيرٌ':Predicate, #1: 1	أَنَّ التَّخْوِيفَ
u'أَنَّ تَخْيِيرٌ':Predicate, #23: 23	أَنَّ التَّخْيِيرَ
u'أَنَّ تَدَاخُلٌ':Predicate, #2: 2	أَنَّ تَخْيِيرَ
u'أَنَّ تَدَارُكٌ':Predicate, #6: 6	أَنَّ التَّدَاخُلَ
u'أَنَّ تَدَاوِي':Predicate, #5: 5	أَنَّ التَّدَارُكَ
u'أَنَّ تَدَايُنٌ':Predicate, #2: 2	أَنَّ التَّدَاوِيَ
u'أَنَّ تَدْبِيرٌ':Predicate, #1: 1	أَنَّ التَّدَايُنَ
u'أَنَّ تَدْبِيرٌ':Predicate, #3: 3	أَنَّ تَدْبِيرَ
u'أَنَّ تَدْلِيس':Predicate, #46: 46	أَنَّ التَّدْبِيرَ
u'أَنَّ تَذْكيرٌ':Predicate, #1: 1	أَنَّ التَّدْلِيسَ
u'أَنَّ تَذْكيرٌ':Predicate, #1: 1	أَنَّ التَّذْكِيرَ
u'أَنَّ تُرَابٌ':Predicate, #1: 1	أَنَّ تَذْكِيرَ
u'أَنَّ تُرَابٌ':Predicate, #10: 10	أَنَّ التُّرَابَ
u'أَنَّ تَرَاخِي':Predicate, #6: 6	أَنَّ تُرَابَ
u'أَنَّ تَرَاخِي':Predicate, #1: 1	أَنَّ تَرَاخِيَ
u'أَنَّ تَرَاضِي':Predicate, #2: 2	أَنَّ التَّرَاخِيَ
u'أَنَّ تَرَاوِيحُ':Predicate, #2: 2	أَنَّ التَّرَاضِيَ
u'أَنَّ تُرْبَةٌ':Predicate, #9: 9	أَنَّ التَّرَاوِيحَ
u'أَنَّ تَرَبُّصٌ':Predicate, #3: 3	أَنَّ التُّرْبَةَ
u'أَنَّ تَرْبِيعٌ':Predicate, #1: 1	أَنَّ التَّرَبُّصَ
u'أَنَّ تَرْتِيبٌ':Predicate, #1: 1	أَنَّ تَرْبِيعَ
u'أَنَّ تَرْتِيبٌ':Predicate, #49: 49	أَنَّ التَّرْتِيبَ
u'أَنَّ تَرْجَمَةٌ':Predicate, #9: 9	أَنَّ تَرْتِيبَ
u'أَنَّ تَرْجَمَةٌ':Predicate, #2: 2	أَنَّ تَرْجَمَةَ
u'أَنَّ تَرَجِّي':Predicate, #4: 4	أَنَّ التَّرْجَمَةَ
u'أَنَّ تَرْجِيحٌ':Predicate, #1: 1	أَنَّ التَّرَجِّيَ
u'أَنَّ تَرْجِيحٌ':Predicate, #14: 14	أَنَّ التَّرْجِيحَ
u'أَنَّ تَرْجِيعٌ':Predicate, #2: 2	أَنَّ تَرْجِيحَ
u'أَنَّ تَرْخِيصٌ':Predicate, #4: 4	أَنَّ التَّرْجِيعَ
u'أَنَّ تَرَدُّدٌ':Predicate, #2: 2	أَنَّ التَّرْخِيصَ
u'أَنَّ تَرَدُّدٌ':Predicate, #1: 1	أَنَّ تَرَدُّدَ
u'أَنَّ تَرْدِيدٌ':Predicate, #9: 9	أَنَّ التَّرَدُّدَ
u'أَنَّ تُرْس':Predicate, #1: 1	أَنَّ التَّرْدِيدَ
u'أَنَّ تَرْكٌ':Predicate, #1: 1	أَنَّ التُّرْسَ
u'أَنَّ تَرْكٌ':Predicate, #85: 85	أَنَّ تَرْكَ
u'أَنَّ تَرِكَةٌ':Predicate, #9: 9	أَنَّ التَّرْكَ
u'أَنَّ تَرِكَةٌ':Predicate, #10: 10	أَنَّ التَّرِكَةَ
u'أَنَّ تُرْكِيّ':Predicate, #4: 4	أَنَّ تَرِكَةَ
u'أَنَّ تَرْكِيبٌ':Predicate, #1: 1	أَنَّ التُّرْكِيَّ
u'أَنَّ تَرْكِيبٌ':Predicate, #1: 1	أَنَّ التَّرْكِيبَ
u'أَنَّ تَرْوِيع':Predicate, #2: 2	أَنَّ تَرْكِيبَ
u'أَنَّ تِرْيَاقٌ':Predicate, #1: 1	أَنَّ التَّرْوِيعَ
u'أَنَّ تَزْكِيَةٌ':Predicate, #1: 1	أَنَّ التِّرْيَاقَ
u'أَنَّ تَزْكِيَةٌ':Predicate, #11: 11	أَنَّ التَّزْكِيَةَ
u'أَنَّ تَزَوُّجٌ':Predicate, #4: 4	أَنَّ تَزْكِيَةَ
u'أَنَّ تَزَوُّجٌ':Predicate, #3: 3	أَنَّ تَزَوُّجَ
u'أَنَّ تَزْوِيجٌ':Predicate, #6: 6	أَنَّ التَّزَوُّجَ
u'أَنَّ تَزْوِيجٌ':Predicate, #11: 11	أَنَّ التَّزْوِيجَ
u'أَنَّ تَزْيِينٌ':Predicate, #6: 6	أَنَّ تَزْوِيجَ
u'أَنَّ تَسَاوِي':Predicate, #1: 1	أَنَّ تَزْيِينَ
u'أَنَّ تَسَاوِي':Predicate, #1: 1	أَنَّ تَسَاوِيَ
u'أَنَّ تَسَبُّبٌ':Predicate, #2: 2	أَنَّ التَّسَاوِيَ
u'أَنَّ تَسْبِيحٌ':Predicate, #2: 2	أَنَّ التَّسَبُّبَ
u'أَنَّ تَسْخِيرٌ':Predicate, #2: 2	أَنَّ التَّسْبِيحَ
u'أَنَّ تَسَرِّي':Predicate, #2: 2	أَنَّ التَّسْخِيرَ
u'أَنَّ تَسْرِيحٌ':Predicate, #2: 2	أَنَّ التَّسَرِّيَ
u'أَنَّ تِسْعَةٌ':Predicate, #1: 1	أَنَّ التَّسْرِيحَ
u'أَنَّ تَسْعِيرٌ':Predicate, #3: 3	أَنَّ التِّسْعَةَ
u'أَنَّ تَسْقِيف':Predicate, #1: 1	أَنَّ التَّسْعِيرَ
u'أَنَّ تَسَلُّطٌ':Predicate, #1: 1	أَنَّ التَّسْقِيفَ
u'أَنَّ تَسْلِيطٌ':Predicate, #1: 1	أَنَّ تَسَلُّطَ
u'أَنَّ تَسْلِيمٌ':Predicate, #1: 1	أَنَّ تَسْلِيطَ
u'أَنَّ تَسْلِيمٌ':Predicate, #10: 10	أَنَّ تَسْلِيمَ
u'أَنَّ تَسَمُّعٌ':Predicate, #18: 18	أَنَّ التَّسْلِيمَ
u'أَنَّ تَسْمِيَة':Predicate, #1: 1	أَنَّ تَسَمُّعَ
u'أَنَّ تَسْمِيَة':Predicate, #13: 13	أَنَّ تَسْمِيَةَ
u'أَنَّ تَسْمِيعٌ':Predicate, #27: 27	أَنَّ التَّسْمِيَةَ
u'أَنَّ تَسْوِيَةٌ':Predicate, #1: 1	أَنَّ التَّسْمِيعَ
u'أَنَّ تَسْوِيَةٌ':Predicate, #12: 12	أَنَّ التَّسْوِيَةَ
u'أَنَّ تَسْيِيبٌ':Predicate, #1: 1	أَنَّ تَسْوِيَةَ
u'أَنَّ تَسْيِيلٌ':Predicate, #1: 1	أَنَّ تَسْيِيبَ
u'أَنَّ تَشَابُهٌ':Predicate, #1: 1	أَنَّ تَسْيِيلَ
u'أَنَّ تَشَبُّه':Predicate, #2: 2	أَنَّ التَّشَابُهَ
u'أَنَّ تَشْبِيه':Predicate, #5: 5	أَنَّ التَّشَبُّهَ
u'أَنَّ تَشْبِيهٌ':Predicate, #14: 14	أَنَّ التَّشْبِيهَ
u'أَنَّ تَشْدِيدٌ':Predicate, #3: 3	أَنَّ تَشْبِيهَ
u'أَنَّ تَشْرِيك':Predicate, #3: 3	أَنَّ التَّشْدِيدَ
u'أَنَّ تَشَهُّدٌ':Predicate, #2: 2	أَنَّ التَّشْرِيكَ
u'أَنَّ تَشَهُّدٌ':Predicate, #1: 1	أَنَّ تَشَهُّدَ
u'أَنَّ تَشْهِيرٌ':Predicate, #6: 6	أَنَّ التَّشَهُّدَ
u'أَنَّ تَصَادُقٌ':Predicate, #2: 2	أَنَّ التَّشْهِيرَ
u'أَنَّ تَصْحِيحٌ':Predicate, #1: 1	أَنَّ التَّصَادُقَ
u'أَنَّ تَصْحِيحٌ':Predicate, #19: 19	أَنَّ تَصْحِيحَ
u'أَنَّ تَصَدُّقٌ':Predicate, #6: 6	أَنَّ التَّصْحِيحَ
u'أَنَّ تَصْدِيقٌ':Predicate, #11: 11	أَنَّ التَّصَدُّقَ
u'أَنَّ تَصْدِيقٌ':Predicate, #5: 5	أَنَّ تَصْدِيقَ
u'أَنَّ تَصَرُّفٌ':Predicate, #6: 6	أَنَّ التَّصْدِيقَ
u'أَنَّ تَصَرُّفٌ':Predicate, #26: 26	أَنَّ التَّصَرُّفَ
u'أَنَّ تَصْرِيحٌ':Predicate, #42: 42	أَنَّ تَصَرُّفَ
u'أَنَّ تَصْمِيمٌ':Predicate, #2: 2	أَنَّ التَّصْرِيحَ
u'أَنَّ تَصَوُّرٌ':Predicate, #1: 1	أَنَّ تَصْمِيمَ
u'أَنَّ تَصَوُّرٌ':Predicate, #3: 3	أَنَّ التَّصَوُّرَ
u'أَنَّ تَصْوِيبٌ':Predicate, #3: 3	أَنَّ تَصَوُّرَ
u'أَنَّ تَصْوِيرٌ':Predicate, #1: 1	أَنَّ التَّصْوِيبَ
u'أَنَّ تَصْوِيرٌ':Predicate, #2: 2	أَنَّ تَصْوِيرَ
u'أَنَّ تَضَادٌّ':Predicate, #4: 4	أَنَّ التَّصْوِيرَ
u'أَنَّ تَضْحِيَةٌ':Predicate, #1: 1	أَنَّ التَّضَادَّ
u'أَنَّ تَضْحِيَةٌ':Predicate, #1: 1	أَنَّ تَضْحِيَةَ
u'أَنَّ تَضْعِيفٌ':Predicate, #3: 3	أَنَّ التَّضْحِيَةَ
u'أَنَّ تَضْعِيفٌ':Predicate, #3: 3	أَنَّ التَّضْعِيفَ
u'أَنَّ تَضَمُّخٌ':Predicate, #3: 3	أَنَّ تَضْعِيفَ
u'أَنَّ تَضَمُّنٌ':Predicate, #1: 1	أَنَّ التَّضَمُّخَ
u'أَنَّ تَضْمِينٌ':Predicate, #1: 1	أَنَّ التَّضَمُّنَ
u'أَنَّ تَضْمِين':Predicate, #3: 3	أَنَّ تَضْمِينَ
u'أَنَّ تَضْيِيقٌ':Predicate, #4: 4	أَنَّ التَّضْمِينَ
u'أَنَّ تَضْيِيقٌ':Predicate, #1: 1	أَنَّ تَضْيِيقَ
u'أَنَّ تَطَبُّبٌ':Predicate, #2: 2	أَنَّ التَّضْيِيقَ
u'أَنَّ تَطْبِيقٌ':Predicate, #1: 1	أَنَّ التَّطَبُّبَ
u'أَنَّ تَطَلُّعٌ':Predicate, #1: 1	أَنَّ التَّطْبِيقَ
u'أَنَّ تَطْلِيقٌ':Predicate, #1: 1	أَنَّ التَّطَلُّعَ
u'أَنَّ تَطْلِيقٌ':Predicate, #1: 1	أَنَّ التَّطْلِيقَ
u'أَنَّ تَطَهُّرٌ':Predicate, #1: 1	أَنَّ تَطْلِيقَ
u'أَنَّ تَطْهِيرٌ':Predicate, #1: 1	أَنَّ التَّطَهُّرَ
u'أَنَّ تَطْهِيرٌ':Predicate, #2: 2	أَنَّ تَطْهِيرَ
u'أَنَّ تَطَوُّعٌ':Predicate, #7: 7	أَنَّ التَّطْهِيرَ
u'أَنَّ تَطْوِيلٌ':Predicate, #11: 11	أَنَّ التَّطَوُّعَ
u'أَنَّ تَطْوِيلٌ':Predicate, #2: 2	أَنَّ التَّطْوِيلَ
u'أَنَّ تَطَيُّبٌ':Predicate, #3: 3	أَنَّ تَطْوِيلَ
u'أَنَّ تَطَيُّبٌ':Predicate, #1: 1	أَنَّ التَّطَيُّبَ
u'أَنَّ تَطْيِيبٌ':Predicate, #1: 1	أَنَّ تَطَيُّبَ
u'أَنَّ تَعَادُلٌ':Predicate, #1: 1	أَنَّ التَّطْيِيبَ
u'أَنَّ تَعَادُلٌ':Predicate, #1: 1	أَنَّ التَّعَادُلَ
u'أَنَّ تَعَارُضٌ':Predicate, #1: 1	أَنَّ تَعَادُلَ
u'أَنَّ تَعَارُضٌ':Predicate, #1: 1	أَنَّ تَعَارُضَ
u'أَنَّ تَعَاطِي':Predicate, #4: 4	أَنَّ التَّعَارُضَ
u'أَنَّ تَعَاطِي':Predicate, #1: 1	أَنَّ التَّعَاطِيَ
u'أَنَّ تَعَاقُبٌ':Predicate, #1: 1	أَنَّ تَعَاطِيَ
u'أَنَّ تَعَامُلٌ':Predicate, #2: 2	أَنَّ التَّعَاقُبَ
u'أَنَّ تَعَبُّدٌ':Predicate, #4: 4	أَنَّ التَّعَامُلَ
u'أَنَّ تَعْبِيرٌ':Predicate, #5: 5	أَنَّ التَّعَبُّدَ
u'أَنَّ تَعْبِيرٌ':Predicate, #12: 12	أَنَّ التَّعْبِيرَ
u'أَنَّ تَعَجُّبٌ':Predicate, #5: 5	أَنَّ تَعْبِيرَ
u'أَنَّ تَعْجِيل':Predicate, #1: 1	أَنَّ التَّعَجُّبَ
u'أَنَّ تَعْجِيل':Predicate, #4: 4	أَنَّ تَعْجِيلَ
u'أَنَّ تَعَدُّدٌ':Predicate, #7: 7	أَنَّ التَّعْجِيلَ
u'أَنَّ تَعَدُّدٌ':Predicate, #1: 1	أَنَّ التَّعَدُّدَ
u'أَنَّ تَعَدِّي':Predicate, #3: 3	أَنَّ تَعَدُّدَ
u'أَنَّ تَعَدِّي':Predicate, #1: 1	أَنَّ التَّعَدِّيَةَ
u'أَنَّ تَعَدِّي':Predicate, #2: 2	أَنَّ تَعَدِّيَ
u'أَنَّ تَعْدِيَة':Predicate, #4: 4	أَنَّ التَّعَدِّيَ
u'أَنَّ تَعْدِيد':Predicate, #2: 2	أَنَّ التَّعْدِيَةَ
u'أَنَّ تَعْدِيلٌ':Predicate, #1: 1	أَنَّ تَعْدِيدَ
u'أَنَّ تَعْدِيلٌ':Predicate, #5: 5	أَنَّ التَّعْدِيلَ
u'أَنَّ تَعَذُّرٌ':Predicate, #5: 5	أَنَّ تَعْدِيلَ
u'أَنَّ تَعْذِيب':Predicate, #5: 5	أَنَّ تَعَذُّرَ
u'أَنَّ تَعَرُّضٌ':Predicate, #1: 1	أَنَّ تَعْذِيبَ
u'أَنَّ تَعْرِيبٌ':Predicate, #4: 4	أَنَّ التَّعَرُّضَ
u'أَنَّ تَعْرِيضٌ':Predicate, #1: 1	أَنَّ التَّعْرِيبَ
u'أَنَّ تَعْرِيفٌ':Predicate, #7: 7	أَنَّ التَّعْرِيضَ
u'أَنَّ تَعْرِيفٌ':Predicate, #11: 11	أَنَّ تَعْرِيفَ
u'أَنَّ تَعْزِيَةٌ':Predicate, #23: 23	أَنَّ التَّعْرِيفَ
u'أَنَّ تَعْزِير':Predicate, #1: 1	أَنَّ التَّعْزِيَةَ
u'أَنَّ تَعَصُّبٌ':Predicate, #9: 9	أَنَّ التَّعْزِيرَ
u'أَنَّ تَعْطِيلٌ':Predicate, #1: 1	أَنَّ التَّعَصُّبَ
u'أَنَّ تَعْظِيمٌ':Predicate, #1: 1	أَنَّ تَعْطِيلَ
u'أَنَّ تَعْظِيمٌ':Predicate, #1: 1	أَنَّ التَّعْظِيمَ
u'أَنَّ تَعْفِيرٌ':Predicate, #2: 2	أَنَّ تَعْظِيمَ
u'أَنَّ تَعْقِيبٌ':Predicate, #1: 1	أَنَّ التَّعْفِيرَ
u'أَنَّ تَعَلُّقٌ':Predicate, #1: 1	أَنَّ تَعْقِيبَ
u'أَنَّ تَعَلُّقٌ':Predicate, #23: 23	أَنَّ تَعَلُّقَ
u'أَنَّ تَعَلُّمٌ':Predicate, #6: 6	أَنَّ التَّعَلُّقَ
u'أَنَّ تَعْلِيقٌ':Predicate, #4: 4	أَنَّ تَعَلُّمَ
u'أَنَّ تَعْلِيقٌ':Predicate, #22: 22	أَنَّ تَعْلِيقَ
u'أَنَّ تَعْلِيلٌ':Predicate, #44: 44	أَنَّ التَّعْلِيقَ
u'أَنَّ تَعْلِيلٌ':Predicate, #22: 22	أَنَّ التَّعْلِيلَ
u'أَنَّ تَعْلِيمٌ':Predicate, #9: 9	أَنَّ تَعْلِيلَ
u'أَنَّ تَعْلِيمٌ':Predicate, #7: 7	أَنَّ التَّعْلِيمَ
u'أَنَّ تَعَمُّدٌ':Predicate, #8: 8	أَنَّ تَعْلِيمَ
u'أَنَّ تَعْمِيرٌ':Predicate, #8: 8	أَنَّ تَعَمُّدَ
u'أَنَّ تَعْمِيمٌ':Predicate, #2: 2	أَنَّ التَّعْمِيرَ
u'أَنَّ تَعْمِيمٌ':Predicate, #1: 1	أَنَّ تَعْمِيمَ
u'أَنَّ تَعَهُّدٌ':Predicate, #5: 5	أَنَّ التَّعْمِيمَ
u'أَنَّ تَعَوُّذٌ':Predicate, #1: 1	أَنَّ التَّعَهُّدَ
u'أَنَّ تَعْوِيلٌ':Predicate, #4: 4	أَنَّ التَّعَوُّذَ
u'أَنَّ تَعْوِيلٌ':Predicate, #1: 1	أَنَّ تَعْوِيلَ
u'أَنَّ تَعَيُّنٌ':Predicate, #2: 2	أَنَّ التَّعْوِيلَ
u'أَنَّ تَعْيِيبٌ':Predicate, #4: 4	أَنَّ تَعَيُّنَ
u'أَنَّ تَعْيِينٌ':Predicate, #1: 1	أَنَّ التَّعْيِيبَ
u'أَنَّ تَعْيِينٌ':Predicate, #15: 15	أَنَّ التَّعْيِينَ
u'أَنَّ تَغَايُرٌ':Predicate, #18: 18	أَنَّ تَعْيِينَ
u'أَنَّ تَغْرِيبٌ':Predicate, #1: 1	أَنَّ تَغَايُرَ
u'أَنَّ تَغْرِيقٌ':Predicate, #3: 3	أَنَّ التَّغْرِيبَ
u'أَنَّ تَغْطِيَةٌ':Predicate, #2: 2	أَنَّ تَغْرِيقَ
u'أَنَّ تَغْلِيظٌ':Predicate, #5: 5	أَنَّ تَغْطِيَةَ
u'أَنَّ تَغَوُّطٌ':Predicate, #8: 8	أَنَّ التَّغْلِيظَ
u'أَنَّ تَغَيُّرٌ':Predicate, #1: 1	أَنَّ التَّغَوُّطَ
u'أَنَّ تَغَيُّرٌ':Predicate, #4: 4	أَنَّ تَغَيُّرَ
u'أَنَّ تَغْيِيبٌ':Predicate, #5: 5	أَنَّ التَّغَيُّرَ
u'أَنَّ تَغْيِيرٌ':Predicate, #1: 1	أَنَّ تَغْيِيبَ
u'أَنَّ تَغْيِيرٌ':Predicate, #2: 2	أَنَّ تَغْيِيرَ
u'أَنَّ تَفَاخُرٌ':Predicate, #5: 5	أَنَّ التَّغْيِيرَ
u'أَنَّ تَفَاضُلٌ':Predicate, #1: 1	أَنَّ التَّفَاخُرَ
u'أَنَّ تَفاوُت':Predicate, #2: 2	أَنَّ التَّفَاضُلَ
u'أَنَّ تَفَرُّدٌ':Predicate, #14: 14	أَنَّ التَّفَاوُتَ
u'أَنَّ تَفَرُّقٌ':Predicate, #2: 2	أَنَّ التَّفَرُّدَ
u'أَنَّ تَفَرُّقٌ':Predicate, #1: 1	أَنَّ تَفَرُّقَ
u'أَنَّ تَفْرِقَة':Predicate, #4: 4	أَنَّ التَّفَرُّقَ
u'أَنَّ تَفْرِيطٌ':Predicate, #3: 3	أَنَّ التَّفْرِقَةَ
u'أَنَّ تَفْرِيع':Predicate, #2: 2	أَنَّ التَّفْرِيطَ
u'أَنَّ تَفْرِيغٌ':Predicate, #2: 2	أَنَّ التَّفْرِيعَ
u'أَنَّ تَفْرِيقٌ':Predicate, #2: 2	أَنَّ تَفْرِيغَ
u'أَنَّ تَفْرِيقٌ':Predicate, #11: 11	أَنَّ التَّفْرِيقَ
u'أَنَّ تَفْسِيرٌ':Predicate, #8: 8	أَنَّ تَفْرِيقَ
u'أَنَّ تَفْسِيرٌ':Predicate, #14: 14	أَنَّ تَفْسِيرَ
u'أَنَّ تَفْصِيلٌ':Predicate, #2: 2	أَنَّ التَّفْسِيرَ
u'أَنَّ تَفْصِيلٌ':Predicate, #12: 12	أَنَّ التَّفْصِيلَ
u'أَنَّ تَفْضِيلٌ':Predicate, #4: 4	أَنَّ تَفْصِيلَ
u'أَنَّ تَفْضِيلٌ':Predicate, #1: 1	أَنَّ تَفْضِيلَ
u'أَنَّ تَفْلِيسٌ':Predicate, #3: 3	أَنَّ التَّفْضِيلَ
u'أَنَّ تَفْوِيت':Predicate, #2: 2	أَنَّ التَّفْلِيسَ
u'أَنَّ تَفْوِيضٌ':Predicate, #1: 1	أَنَّ تَفْوِيتَ
u'أَنَّ تَفْوِيضٌ':Predicate, #2: 2	أَنَّ تَفْوِيضَ
u'أَنَّ تَقابُض':Predicate, #4: 4	أَنَّ التَّفْوِيضَ
u'أَنَّ تَقَابُلٌ':Predicate, #3: 3	أَنَّ التَّقَابُضَ
u'أَنَّ تَقادُم':Predicate, #1: 1	أَنَّ التَّقَابُلَ
u'أَنَّ تَقَارُبٌ':Predicate, #3: 3	أَنَّ التَّقَادُمَ
u'أَنَّ تَقاطُرٌ':Predicate, #1: 1	أَنَّ التَّقَارُبَ
u'أَنَّ تَقَبُّلٌ':Predicate, #2: 2	أَنَّ التَّقَاطُرَ
u'أَنَّ تَقَدُّمٌ':Predicate, #1: 1	أَنَّ التَّقَبُّلَ
u'أَنَّ تَقَدُّمٌ':Predicate, #1: 1	أَنَّ التَّقَدُّمَ
u'أَنَّ تَقْدِمَةٌ':Predicate, #9: 9	أَنَّ تَقَدُّمَ
u'أَنَّ تَقْديرٌ':Predicate, #1: 1	أَنَّ التَّقْدِمَةَ
u'أَنَّ تَقْديرٌ':Predicate, #40: 40	أَنَّ التَّقْدِيرَ
u'أَنَّ تَقْديمٌ':Predicate, #4: 4	أَنَّ تَقْدِيرَ
u'أَنَّ تَقْديمٌ':Predicate, #19: 19	أَنَّ التَّقْدِيمَ
u'أَنَّ تَقْريرٌ':Predicate, #21: 21	أَنَّ تَقْدِيمَ
u'أَنَّ تَقْريرٌ':Predicate, #3: 3	أَنَّ التَّقْرِيرَ
u'أَنَّ تَقْسيطٌ':Predicate, #5: 5	أَنَّ تَقْرِيرَ
u'أَنَّ تَقْسِيمٌ':Predicate, #1: 1	أَنَّ التَّقْسِيطَ
u'أَنَّ تَقْصيرٌ':Predicate, #3: 3	أَنَّ التَّقْسِيمَ
u'أَنَّ تَقْصيرٌ':Predicate, #1: 1	أَنَّ التَّقْصِيرَ
u'أَنَّ تَقَطُّعٌ':Predicate, #1: 1	أَنَّ تَقْصِيرَ
u'أَنَّ تَقْطيعٌ':Predicate, #1: 1	أَنَّ التَّقَطُّعَ
u'أَنَّ تَقَلُّدٌ':Predicate, #1: 1	أَنَّ تَقْطِيعَ
u'أَنَّ تَقْليدٌ':Predicate, #1: 1	أَنَّ التَّقَلُّدَ
u'أَنَّ تَقْليد':Predicate, #12: 12	أَنَّ التَّقْلِيدَ
u'أَنَّ تَقْليدٌ':Predicate, #12: 12	أَنَّ التَّقْلِيدَ
u'أَنَّ تَقْليد':Predicate, #5: 5	أَنَّ تَقْلِيدَ
u'أَنَّ تَقْليلٌ':Predicate, #5: 5	أَنَّ تَقْلِيدَ
u'أَنَّ تَقْليمٌ':Predicate, #1: 1	أَنَّ التَّقْلِيلَ
u'أَنَّ تَقَوُّمٌ':Predicate, #1: 1	أَنَّ تَقْلِيمَ
u'أَنَّ تَقَوُّمٌ':Predicate, #2: 2	أَنَّ تَقَوُّمَ
u'أَنَّ تَقْوِيَةٌ':Predicate, #6: 6	أَنَّ التَّقَوُّمَ
u'أَنَّ تَقْويمٌ':Predicate, #1: 1	أَنَّ تَقْوِيَةَ
u'أَنَّ تَقِيٌّ':Predicate, #9: 9	أَنَّ التَّقْوِيمَ
u'أَنَّ تَقَيُّدٌ':Predicate, #1: 1	أَنَّ التَّقِيَّ
u'أَنَّ تَقَيُّدٌ':Predicate, #1: 1	أَنَّ التَّقَيُّدَ
u'أَنَّ تَقْيِيد':Predicate, #1: 1	أَنَّ تَقَيُّدَ
u'أَنَّ تَقْيِيد':Predicate, #12: 12	أَنَّ تَقْيِيدَ
u'أَنَّ تَكاسُلٌ':Predicate, #41: 41	أَنَّ التَّقْيِيدَ
u'أَنَّ تَكامُلٌ':Predicate, #1: 1	أَنَّ التَّكَاسُلَ
u'أَنَّ تَكْبيرٌ':Predicate, #1: 1	أَنَّ تَكَامُلَ
u'أَنَّ تَكْبِير':Predicate, #18: 18	أَنَّ التَّكْبِيرَ
u'أَنَّ تَكْبيرٌ':Predicate, #2: 2	أَنَّ التَّكْبِيرَةَ
u'أَنَّ تَكْبِير':Predicate, #2: 2	أَنَّ تَكْبِيرَ
u'أَنَّ تَكْثيرٌ':Predicate, #6: 6	أَنَّ تَكْبِيرَةَ
u'أَنَّ تَكْثيرٌ':Predicate, #1: 1	أَنَّ التَّكْثِيرَ
u'أَنَّ تَكْذيبٌ':Predicate, #1: 1	أَنَّ تَكْثِيرَ
u'أَنَّ تَكْذيبٌ':Predicate, #1: 1	أَنَّ التَّكْذِيبَ
u'أَنَّ تَكْرارٌ':Predicate, #6: 6	أَنَّ تَكْذِيبَ
u'أَنَّ تَكْرارٌ':Predicate, #10: 10	أَنَّ التَّكْرَارَ
u'أَنَّ تَكَرُّرٌ':Predicate, #7: 7	أَنَّ تَكْرَارَ
u'أَنَّ تَكْريرٌ':Predicate, #2: 2	أَنَّ تَكَرُّرَ
u'أَنَّ تَكَسُّبٌ':Predicate, #2: 2	أَنَّ تَكْرِيرَ
u'أَنَّ تَكْفيرٌ':Predicate, #1: 1	أَنَّ التَّكَسُّبَ
u'أَنَّ تَكْفيرٌ':Predicate, #3: 3	أَنَّ تَكْفِيرَ
u'أَنَّ تَكَلُّمٌ':Predicate, #9: 9	أَنَّ التَّكْفِيرَ
u'أَنَّ تَكْليفٌ':Predicate, #3: 3	أَنَّ التَّكَلُّمَ
u'أَنَّ تَكْليفٌ':Predicate, #20: 20	أَنَّ التَّكْلِيفَ
u'أَنَّ تَكْليمٌ':Predicate, #3: 3	أَنَّ تَكْلِيفَ
u'أَنَّ تَكْوينٌ':Predicate, #2: 2	أَنَّ التَّكْلِيمَ
u'أَنَّ تَلاطُمٌ':Predicate, #1: 1	أَنَّ التَّكْوِينَ
u'أَنَّ تِلاوَةٌ':Predicate, #1: 1	أَنَّ تَلَاطُمَ
u'أَنَّ تَلَبُّسٌ':Predicate, #7: 7	أَنَّ التِّلَاوَةَ
u'أَنَّ تَلْبيَةٌ':Predicate, #2: 2	أَنَّ التَّلَبُّسَ
u'أَنَّ تَلْبيَةٌ':Predicate, #2: 2	أَنَّ تَلْبِيَةَ
u'أَنَّ تَلَثُّمٌ':Predicate, #7: 7	أَنَّ التَّلْبِيَةَ
u'أَنَّ تَلْحِين':Predicate, #1: 1	أَنَّ التَّلَثُّمَ
u'أَنَّ تَلَذُّذٌ':Predicate, #2: 2	أَنَّ التَّلْحِينَ
u'أَنَّ تَلْطيخٌ':Predicate, #1: 1	أَنَّ التَّلَذُّذَ
u'أَنَّ تَلَفٌ':Predicate, #1: 1	أَنَّ تَلْطِيخَ
u'أَنَّ تَلَف':Predicate, #3: 3	أَنَّ تَلَفَ
u'أَنَّ تَلَفُّظٌ':Predicate, #5: 5	أَنَّ التَّلَفَ
u'أَنَّ تَلْفيقٌ':Predicate, #4: 4	أَنَّ التَّلَفُّظَ
u'أَنَّ تَلَقِّي':Predicate, #1: 1	أَنَّ تَلْفِيقَ
u'أَنَّ تَلَقِّي':Predicate, #1: 1	أَنَّ التَّلَقِّيَ
u'أَنَّ تَلْقِين':Predicate, #2: 2	أَنَّ تَلَقِّيَ
u'أَنَّ تَلْقينٌ':Predicate, #1: 1	أَنَّ التَّلْقِينَ
u'أَنَّ تِلْميذٌ':Predicate, #1: 1	أَنَّ تَلْقِينَ
u'أَنَّ تَلَوُّمٌ':Predicate, #4: 4	أَنَّ التِّلْمِيذَ
u'أَنَّ تَماثيلُ':Predicate, #1: 1	أَنَّ التَّلَوُّمَ
u'أَنَّ تَمادِي':Predicate, #1: 1	أَنَّ التَّمَاثِيلَ
u'أَنَّ تمام':Predicate, #1: 1	أَنَّ التَّمَادِيَ
u'أَنَّ تَمامٌ':Predicate, #15: 15	أَنَّ تَمَامَ
u'أَنَّ تمام':Predicate, #15: 15	أَنَّ تَمَامَ
u'أَنَّ تَمامٌ':Predicate, #3: 3	أَنَّ التَّمَامَ
u'أَنَّ تَمايُزٌ':Predicate, #3: 3	أَنَّ التَّمَامَ
u'أَنَّ تَمَتُّعٌ':Predicate, #1: 1	أَنَّ تَمَايُزَ
u'أَنَّ تِمْثالٌ':Predicate, #5: 5	أَنَّ التَّمَتُّعَ
u'أَنَّ تَمْثيلٌ':Predicate, #2: 2	أَنَّ التِّمْثَالَ
u'أَنَّ تَمْثيلٌ':Predicate, #1: 1	أَنَّ التَّمْثِيلَ
u'أَنَّ تَمْر':Predicate, #2: 2	أَنَّ تَمْثِيلَ
u'أَنَّ تَمْرَةٌ':Predicate, #11: 11	أَنَّ التَّمْرَ
u'أَنَّ تِمْساحٌ':Predicate, #2: 2	أَنَّ التَّمْرَةَ
u'أَنَّ تَمْشِيَةٌ':Predicate, #1: 1	أَنَّ التِّمْسَاحَ
u'أَنَّ تَمَكُّنٌ':Predicate, #1: 1	أَنَّ تَمْشِيَةَ
u'أَنَّ تَمَكُّنٌ':Predicate, #1: 1	أَنَّ تَمَكُّنَ
u'أَنَّ تَمْكِينٌ':Predicate, #8: 8	أَنَّ التَّمَكُّنَ
u'أَنَّ تَمَلُّكٌ':Predicate, #1: 1	أَنَّ تَمْكِينَ
u'أَنَّ تَمَلُّك':Predicate, #1: 1	أَنَّ تَمَلُّكَ
u'أَنَّ تَمْلِيك':Predicate, #2: 2	أَنَّ التَّمَلُّكَ
u'أَنَّ تَمْلِيكٌ':Predicate, #12: 12	أَنَّ التَّمْلِيكَ
u'أَنَّ تَمْييزٌ':Predicate, #5: 5	أَنَّ تَمْلِيكَ
u'أَنَّ تَمْييزٌ':Predicate, #2: 2	أَنَّ التَّمْيِيزَ
u'أَنَّ تَنَازُعٌ':Predicate, #4: 4	أَنَّ تَمْيِيزَ
u'أَنَّ تَنَازُعٌ':Predicate, #1: 1	أَنَّ تَنَازُعَ
u'أَنَّ تَنَاقُضٌ':Predicate, #6: 6	أَنَّ التَّنَازُعَ
u'أَنَّ تَنَاوُلٌ':Predicate, #10: 10	أَنَّ التَّنَاقُضَ
u'أَنَّ تَنَاوُلٌ':Predicate, #1: 1	أَنَّ التَّنَاوُلَ
u'أَنَّ تَنْبِيهٌ':Predicate, #3: 3	أَنَّ تَنَاوُلَ
u'أَنَّ تَنْبِيه':Predicate, #1: 1	أَنَّ تَنْبِيهَ
u'أَنَّ تَنجُّسٌ':Predicate, #3: 3	أَنَّ التَّنْبِيهَ
u'أَنَّ تَنْجِيزٌ':Predicate, #1: 1	أَنَّ التَّنَجُّسَ
u'أَنَّ تَنْجِيزٌ':Predicate, #1: 1	أَنَّ التَّنْجِيزَ
u'أَنَّ تَنْجِيسٌ':Predicate, #1: 1	أَنَّ تَنْجِيزَ
u'أَنَّ تَنْجِيمٌ':Predicate, #1: 1	أَنَّ تَنْجِيسَ
u'أَنَّ تَنَحْنُحٌ':Predicate, #1: 1	أَنَّ التَّنْجِيمَ
u'أَنَّ تَنَزُّه':Predicate, #1: 1	أَنَّ التَّنَحْنُحَ
u'أَنَّ تَنْزِيلٌ':Predicate, #1: 1	أَنَّ التَّنَزُّهَ
u'أَنَّ تَنْشِيفٌ':Predicate, #1: 1	أَنَّ التَّنْزِيلَ
u'أَنَّ تَنْصِيص':Predicate, #1: 1	أَنَّ تَنْشِيفَ
u'أَنَّ تَنْصِيفٌ':Predicate, #7: 7	أَنَّ التَّنْصِيصَ
u'أَنَّ تَنْظِيرٌ':Predicate, #3: 3	أَنَّ التَّنْصِيفَ
u'أَنَّ تَنْعِيمٌ':Predicate, #1: 1	أَنَّ تَنْظِيرَ
u'أَنَّ تَنَفُّلٌ':Predicate, #1: 1	أَنَّ التَّنْعِيمَ
u'أَنَّ تَنَفُّلٌ':Predicate, #1: 1	أَنَّ تَنَفُّلَ
u'أَنَّ تَنْفِيذٌ':Predicate, #2: 2	أَنَّ التَّنَفُّلَ
u'أَنَّ تَنْفِيذٌ':Predicate, #1: 1	أَنَّ التَّنْفِيذَ
u'أَنَّ تَنْفِيلٌ':Predicate, #5: 5	أَنَّ تَنْفِيذَ
u'أَنَّ تَنْقِيةٌ':Predicate, #2: 2	أَنَّ التَّنْفِيلَ
u'أَنَّ تَنْقِيحٌ':Predicate, #1: 1	أَنَّ تَنْقِيَةَ
u'أَنَّ تَنْكِيسٌ':Predicate, #4: 4	أَنَّ تَنْقِيحَ
u'أَنَّ تَنْوِينٌ':Predicate, #1: 1	أَنَّ تَنْكِيسَ
u'أَنَّ تَهَجُّدٌ':Predicate, #1: 1	أَنَّ التَّنْوِينَ
u'أَنَّ تَهْدِيدٌ':Predicate, #1: 1	أَنَّ التَّهَجُّدَ
u'أَنَّ تُهْمَةٌ':Predicate, #1: 1	أَنَّ التَّهْدِيدَ
u'أَنَّ تُهْمَةٌ':Predicate, #1: 1	أَنَّ تُهْمَةَ
u'أَنَّ تَوَابِلُ':Predicate, #6: 6	أَنَّ التُّهْمَةَ
u'أَنَّ تَوَاتُرٌ':Predicate, #1: 1	أَنَّ التَّوَابِلَ
u'أَنَّ تَوَارُثٌ':Predicate, #5: 5	أَنَّ التَّوَاتُرَ
u'أَنَّ تَوَارِيخُ':Predicate, #5: 5	أَنَّ التَّوَارُثَ
u'أَنَّ تَوْبَةٌ':Predicate, #1: 1	أَنَّ التَّوَارِيخَ
u'أَنَّ تَوْبَةٌ':Predicate, #22: 22	أَنَّ التَّوْبَةَ
u'أَنَّ تَوَجُّهٌ':Predicate, #3: 3	أَنَّ تَوْبَةَ
u'أَنَّ تَوْجِيهٌ':Predicate, #8: 8	أَنَّ التَّوَجُّهَ
u'أَنَّ تَوْحِيدٌ':Predicate, #2: 2	أَنَّ تَوْجِيهَ
u'أَنَّ تَوْرَاةٌ':Predicate, #1: 1	أَنَّ التَّوْحِيدَ
u'أَنَّ تَوْرِيَةٌ':Predicate, #1: 1	أَنَّ التَّوْرَاةَ
u'أَنَّ تَوْرِيث':Predicate, #1: 1	أَنَّ التَّوْرِيَةَ
u'أَنَّ تَوْزِيعٌ':Predicate, #2: 2	أَنَّ التَّوْرِيثَ
u'أَنَّ تَوْسِعَة':Predicate, #2: 2	أَنَّ التَّوْزِيعَ
u'أَنَّ تَوَسُّلٌ':Predicate, #1: 1	أَنَّ التَّوْسِعَةَ
u'أَنَّ تَوْسِيعٌ':Predicate, #1: 1	أَنَّ التَّوَسُّلَ
u'أَنَّ تَوَصُّلٌ':Predicate, #3: 3	أَنَّ التَّوْسِيعَ
u'أَنَّ تَوَضُّؤٌ':Predicate, #1: 1	أَنَّ التَّوَصُّلَ
u'أَنَّ تَوْفِيقٌ':Predicate, #1: 1	أَنَّ التَّوَضُّؤَ
u'أَنَّ تَوَقُّعٌ':Predicate, #12: 12	أَنَّ التَّوْفِيقَ
u'أَنَّ تَوَقُّفٌ':Predicate, #2: 2	أَنَّ تَوَقُّعَ
u'أَنَّ تَوَقُّفٌ':Predicate, #1: 1	أَنَّ تَوَقُّفَ
u'أَنَّ تَوْقِيت':Predicate, #3: 3	أَنَّ التَّوَقُّفَ
u'أَنَّ تَوَكُّلٌ':Predicate, #9: 9	أَنَّ التَّوْقِيتَ
u'أَنَّ تَوَكُّلٌ':Predicate, #1: 1	أَنَّ تَوَكُّلَ
u'أَنَّ تَوْكِيدٌ':Predicate, #5: 5	أَنَّ التَّوَكُّلَ
u'أَنَّ تَوْكِيلٌ':Predicate, #1: 1	أَنَّ التَّوْكِيدَ
u'أَنَّ تَوْكِيلٌ':Predicate, #40: 40	أَنَّ التَّوْكِيلَ
u'أَنَّ تَوْلِيَةٌ':Predicate, #7: 7	أَنَّ تَوْكِيلَ
u'أَنَّ تَوْلِيَةٌ':Predicate, #2: 2	أَنَّ تَوْلِيَةَ
u'أَنَّ تَوَهُّمٌ':Predicate, #3: 3	أَنَّ التَّوْلِيَةَ
u'أَنَّ تَوَهُّمٌ':Predicate, #1: 1	أَنَّ التَّوَهُّمَ
u'أَنَّ تَيَقُّظٌ':Predicate, #1: 1	أَنَّ تَوَهُّمَ
u'أَنَّ تَيَقُّنٌ':Predicate, #1: 1	أَنَّ التَّيَقُّظَ
u'أَنَّ تَيَمُّمٌ':Predicate, #2: 2	أَنَّ تَيَقُّنَ
u'أَنَّ تَيَمُّمٌ':Predicate, #2: 2	أَنَّ تَيَمُّمَ
u'أَنَّ ثَابِتٌ':Predicate, #53: 53	أَنَّ التَّيَمُّمَ
u'أَنَّ ثَابِتٌ':Predicate, #1: 1	أَنَّ الثَّابِتَةَ
u'أَنَّ ثَابِتٌ':Predicate, #36: 36	أَنَّ الثَّابِتَ
u'أَنَّ ثابتة':Predicate, #5: 5	أَنَّ ثَابِتَ
u'أَنَّ ثَالِثٌ':Predicate, #1: 1	أَنَّ الثَّابِتَةَ
u'أَنَّ ثَالِثٌ':Predicate, #14: 14	أَنَّ الثَّالِثَ
u'أَنَّ ثَامِنٌ':Predicate, #4: 4	أَنَّ الثَّالِثَةَ
u'أَنَّ ثَانِي':Predicate, #2: 2	أَنَّ الثَّامِنَ
u'أَنَّ ثَانِي':Predicate, #22: 22	أَنَّ الثَّانِيَةَ
u'أَنَّ ثَانِيَةٌ':Predicate, #72: 72	أَنَّ الثَّانِيَ
u'أَنَّ ثُبُوتٌ':Predicate, #22: 22	أَنَّ الثَّانِيَةَ
u'أَنَّ ثُبُوتٌ':Predicate, #53: 53	أَنَّ ثُبُوتَ
u'أَنَّ ثَدْيٌ':Predicate, #9: 9	أَنَّ الثُّبُوتَ
u'أَنَّثَ ضَمِيرٌ':Predicate, #1: 1	أَنَّ الثَّدْيَ
u'أَنَّثَ طَلاَقٌ':Predicate, #1: 1	أَنَّثَ الضَّمِيرَ
u'أَنَّثَ ظُهْرٌ':Predicate, #1: 1	أَنَّثَ الطَّلَاقَ
u'أَنَّ ثُعْبَانٌ':Predicate, #1: 1	أَنَّثَ الظُّهْرَ
u'أَنَّ ثَعْلَبٌ':Predicate, #1: 1	أَنَّ الثُّعْبَانَ
u'أَنَّثَ فِعْلٌ':Predicate, #4: 4	أَنَّ ثَعْلَبَةَ
u'أَنَّ ثِقَةٌ':Predicate, #1: 1	أَنَّثَ فِعْلَ
u'أَنَّ ثَقِيلٌ':Predicate, #1: 1	أَنَّ الثِّقَةَ
u'أَنَّ ثَلاثُ':Predicate, #3: 3	أَنَّ الثَّقِيلَ
u'أَنَّ ثَلاثُ':Predicate, #1: 1	أَنَّ ثَلاَثَ
u'أَنَّ ثَلاثُ':Predicate, #28: 28	أَنَّ الثَّلَاثَ
u'أَنَّ ثَلاثُ':Predicate, #2: 2	أَنَّ الثَّلاَثَ
u'أَنَّ ثَلاثَةٌ':Predicate, #2: 2	أَنَّ ثَلَاثَ
u'أَنَّ ثَلاثَةٌ':Predicate, #11: 11	أَنَّ الثَّلَاثَةَ
u'أَنَّ ثَلاثَةٌ':Predicate, #1: 1	أَنَّ ثَلاَثَةَ
u'أَنَّ ثِمارٌ':Predicate, #5: 5	أَنَّ ثَلَاثَةَ
u'أَنَّ ثِمارٌ':Predicate, #1: 1	أَنَّ الثِّمَارَ
u'أَنَّ ثُمام':Predicate, #2: 2	أَنَّ ثِمَارَ
u'أَنَّ ثَمانِيَةٌ':Predicate, #4: 4	أَنَّ ثُمَامَةَ
u'أَنَّ ثَمانِين':Predicate, #1: 1	أَنَّ الثَّمَانِيَةَ
u'أَنَّ ثَمانِين':Predicate, #2: 2	أَنَّ الثَّمَانِينَ
u'أَنَّ ثَمَرٌ':Predicate, #3: 3	أَنَّ ثَمَانِينَ
u'أَنَّ ثَمَرٌ':Predicate, #2: 2	أَنَّ ثَمَرَ
u'أَنَّ ثَمَرَةٌ':Predicate, #4: 4	أَنَّ الثَّمَرَ
u'أَنَّ ثَمَرَةٌ':Predicate, #30: 30	أَنَّ الثَّمَرَةَ
u'أَنَّثَ مُصَنِّفٌ':Subject, #9: 9	أَنَّ ثَمَرَةَ
u'أَنَّ ثَمَنٌ':Predicate, #1: 1	أَنَّثَ الْمُصَنِّفُ
u'أَنَّ ثَمَن':Predicate, #111: 111	أَنَّ الثَّمَنَ
u'أَنَّ ثَمَنٌ':Predicate, #1: 1	أَنَّ ثَمَنِيَّةَ
u'أَنَّ ثَمَن':Predicate, #7: 7	أَنَّ ثَمَنَ
u'أَنَّ ثَناءٌ':Predicate, #8: 8	أَنَّ الثَّمَنِيَّةَ
u'أَنَّ ثَناءٌ':Predicate, #2: 2	أَنَّ الثَّنَاءَ
u'أَنَّ ثُنائِيٌّ':Predicate, #2: 2	أَنَّ ثَنَاءَ
u'أَنَّ ثَوابٌ':Predicate, #1: 1	أَنَّ الثُّنَائِيَّ
u'أَنَّ ثَوابٌ':Predicate, #12: 12	أَنَّ الثَّوَابَ
u'أَنَّ ثَوْبٌ':Predicate, #12: 12	أَنَّ ثَوَابَ
u'أَنَّ ثَوْرِيٌّ':Predicate, #24: 24	أَنَّ الثَّوْبَ
u'أَنَّ ثِيابٌ':Predicate, #3: 3	أَنَّ الثَّوْرِيَّ
u'أَنَّ ثِيابٌ':Predicate, #10: 10	أَنَّ الثِّيَابَ
u'أَنَّ ثَيِّبٌ':Predicate, #1: 1	أَنَّ ثِيَابَ
u'أَنَّ جَابِرٌ':Predicate, #4: 4	أَنَّ الثَّيِّبَ
u'أَنَّ جَابِرٌ':Predicate, #1: 1	أَنَّ الْجَابِرَ
u'أَنَّ جَابِي':Predicate, #30: 30	أَنَّ جَابِرَ
u'أَنَّ جَاحِدٌ':Predicate, #2: 2	أَنَّ الْجَابِيَ
u'أَنَّ جَاحِدٌ':Predicate, #1: 1	أَنَّ جَاحِدَ
u'أَنَّ جَادٌّ':Predicate, #2: 2	أَنَّ الْجَاحِدَ
u'أَنَّ جَادَّةٌ':Predicate, #1: 1	أَنَّ الْجَادَّةَ
u'أَنَّ جَارٌ':Predicate, #1: 1	أَنَّ الْجَادَّةَ
u'أَنَّ جَارٌ':Predicate, #2: 2	أَنَّ جَارَ
u'أَنَّ جَارِحٌ':Predicate, #8: 8	أَنَّ الْجَارَ
u'أَنَّ جَارِي':Predicate, #2: 2	أَنَّ الْجَارِحَ
u'أَنَّ جَارِي':Predicate, #24: 24	أَنَّ جَارِيَةً
u'أَنَّ جَارِي':Predicate, #3: 3	أَنَّ جَارِيَةَ
u'أَنَّ جَارِي':Predicate, #63: 63	أَنَّ الْجَارِيَةَ
u'أَنَّ جَارِيَةٌ':Predicate, #6: 6	أَنَّ الْجَارِيَ
u'أَنَّ جَارِيَةٌ':Predicate, #3: 3	أَنَّ جَارِيَةَ
u'أَنْجَاسٌ جَاهِلِيٌّ':Added, #63: 63	أَنَّ الْجَارِيَةَ
u'أَنْجَاسٌ جَاهِلِيَّةٌ':Added, #1: 1	أَنْجَاسِ الْجَاهِلِيَّةِ
u'أَنَّ جَاسُوسٌ':Predicate, #1: 1	أَنْجَاسِ الْجَاهِلِيَّةِ
u'أَنَّ جالِب':Predicate, #3: 3	أَنَّ الْجَاسُوسَ
u'أَنَّ جَالِسٌ':Predicate, #1: 1	أَنَّ جَالِبَهُنَّ
u'أَنَّ جَامِدٌ':Predicate, #4: 4	أَنَّ الْجَالِسَ
u'أَنَّ جَامِعٌ':Predicate, #4: 4	أَنَّ الْجَامِدَ
u'أَنَّ جَامِعٌ':Predicate, #10: 10	أَنَّ الْجَامِعَ
u'أَنَّ جَانٌّ':Predicate, #1: 1	أَنَّ جَامِعَ
u'أَنَّ جَانِبٌ':Predicate, #1: 1	أَنَّ الْجَانَّ
u'أَنَّ جَانِبٌ':Predicate, #2: 2	أَنَّ الْجَانِبَ
u'أَنَّ جَانِي':Predicate, #4: 4	أَنَّ جَانِبَ
u'أَنَّ جَاهِلٌ':Predicate, #8: 8	أَنَّ الْجَانِيَ
u'أَنَّ جَاهِلِيٌّ':Predicate, #9: 9	أَنَّ الْجَاهِلَ
u'أَنَّ جَاهِلِيَّةٌ':Predicate, #3: 3	أَنَّ الْجَاهِلِيَّةَ
u'أَنَّ جَائِحٌ':Predicate, #3: 3	أَنَّ الْجَاهِلِيَّةَ
u'أَنَّ جَائِحٌ':Predicate, #1: 1	أَنَّ جَائِحَةً
u'أَنَّ جاَئِحَةٌ':Predicate, #1: 1	أَنَّ جَائِحَةَ
u'أَنَّ جَائِرٌ':Predicate, #1: 1	أَنَّ جَائِحَةَ
u'أَنَّ جَائِزٌ':Predicate, #2: 2	أَنَّ الْجَائِرَ
u'أَنَّ جَائِزٌ':Predicate, #1: 1	أَنَّ جَائِزَةَ
u'أَنَّ جَائِزَةٌ':Predicate, #4: 4	أَنَّ الْجَائِزَ
u'أَنَّ جَائِعٌ':Predicate, #1: 1	أَنَّ جَائِزَةَ
u'أَنَّ جِبَالٌ':Predicate, #1: 1	أَنَّ الْجَائِعَ
u'أَنَّ جِبَايَةٌ':Predicate, #1: 1	أَنَّ الْجِبَالَ
u'أَنَّ جَبْرٌ':Predicate, #1: 1	أَنَّ الْجِبَايَةَ
u'أَنَّ جَبْرِيٌّ':Predicate, #2: 2	أَنَّ الْجَبْرَ
u'أَنَّ جَبِيرَة':Predicate, #1: 1	أَنَّ الْجَبْرِيَّ
u'أَنَّ جَحْد':Predicate, #8: 8	أَنَّ الْجَبِيرَةَ
u'أَنْجَحَ قَالٌ':Predicate, #1: 1	أَنَّ الْجَحْدَ
u'أَنَّ جُحُود':Predicate, #1: 1	أَنْجَحَ قَالَ
u'أَنَّ جُحُود':Predicate, #4: 4	أَنَّ جُحُودَ
u'أَنَّ جداد':Predicate, #9: 9	أَنَّ الْجُحُودَ
u'أَنَّ جِدار':Predicate, #1: 1	أَنَّ الْجِدَادَ
u'أَنَّ جِدال':Predicate, #7: 7	أَنَّ الْجِدَارَ
u'أَنْجَدَ رَجُلٌ':Subject, #3: 3	أَنَّ الْجِدَالَ
u'أَنَّ جَديدٌ':Predicate, #1: 1	أَنْجَدَ الرَّجُلُ
u'أَنَّ جَدِيدٌ':Predicate, #2: 2	أَنَّ الْجَدِيدَ
u'أَنَّ جَدِيرٌ':Predicate, #2: 2	أَنَّ الْجَدِيدَ
u'أَنَّ جُذَاذٌ':Predicate, #1: 1	أَنَّ الْجَدِيرَ
u'أَنَّ جَذَعٌ':Predicate, #1: 1	أَنَّ الْجُذَاذَ
u'أَنَّ جَذَع':Predicate, #10: 10	أَنَّ الْجَذَعَ
u'أَنَّ جَذَع':Predicate, #1: 1	أَنَّ الْجَذَعَةَ
u'أَنَّ جَذَعَة':Predicate, #1: 1	أَنَّ جَذَعَةَ
u'أَنَّ جَذَعَة':Predicate, #1: 1	أَنَّ الْجَذَعَةَ
u'أَنَّ جَرٌّ':Predicate, #1: 1	أَنَّ جَذَعَةَ
u'أَنَّ جَرٌّ':Predicate, #2: 2	أَنَّ جَرَّ
u'أَنَّ جُرْأَةٌ':Predicate, #4: 4	أَنَّ الْجَرَّ
u'أَنَّ جراح':Predicate, #1: 1	أَنَّ الْجُرْأَةَ
u'أَنَّ جِرَاحٌ':Predicate, #1: 1	أَنَّ الْجِرَاحَ
u'أَنَّ جراح':Predicate, #1: 1	أَنَّ الْجِرَاحَ
u'أَنَّ جِرَاحٌ':Predicate, #3: 3	أَنَّ جِرَاحَ
u'أَنَّ جِرَاحَةٌ':Predicate, #3: 3	أَنَّ جِرَاحَ
u'أَنَّ جَرَادٌ':Predicate, #6: 6	أَنَّ الْجِرَاحَةَ
u'أَنَّ جُرْحٌ':Predicate, #4: 4	أَنَّ الْجَرَادَ
u'أَنَّ جُرْحٌ':Predicate, #1: 1	أَنَّ جُرْحَ
u'أَنَّ جِرْمٌ':Predicate, #8: 8	أَنَّ الْجُرْحَ
u'أَنَّ جَرِيحٌ':Predicate, #2: 2	أَنَّ جِرْمَ
u'أَنَّ جَرِيرٌ':Predicate, #3: 3	أَنَّ الْجَرِيحَ
u'أَنَّ جَرِيمَةٌ':Predicate, #2: 2	أَنَّ جَرِيرَ
u'أَنَّ جَرِيمَةٌ':Predicate, #1: 1	أَنَّ الْجَرِيمَةَ
u'أَنَّ جُزْءٌ':Predicate, #1: 1	أَنَّ جَرِيمَةَ
u'أَنَّ جُزْءٌ':Predicate, #11: 11	أَنَّ الْجُزْءَ
u'أَنَّ جَزَاءٌ':Predicate, #3: 3	أَنَّ جُزْءَ
u'أَنَّ جَزَاءٌ':Predicate, #19: 19	أَنَّ الْجَزَاءَ
u'أَنَّ جِزَّة':Predicate, #7: 7	أَنَّ جَزَاءَ
u'أَنَّ جزع':Predicate, #1: 1	أَنَّ الْجِزَّةَ
u'أَنَّ جَزَعٌ':Predicate, #1: 1	أَنَّ الْجَزَعَ
u'أَنَّ جَزْم':Predicate, #1: 1	أَنَّ الْجَزَعَ
u'أَنْجَزَ وَقْفٌ':Predicate, #6: 6	أَنَّ الْجَزْمَ
u'أَنَّ جِزْيَةٌ':Predicate, #1: 1	أَنْجَزَ الْوَقْفَ
u'أَنَّ جِزْيَةٌ':Predicate, #14: 14	أَنَّ الْجِزْيَةَ
u'أَنَّ جَسٌّ':Predicate, #2: 2	أَنَّ جِزْيَةَ
u'أَنَّ جَسَدٌ':Predicate, #2: 2	أَنَّ الْجَسَّ
u'أَنَّ جِسْمٌ':Predicate, #1: 1	أَنَّ الْجَسَدَ
u'أَنَّ جشاء':Predicate, #1: 1	أَنَّ جِسْمَ
u'أَنَّ جُشَاءٌ':Predicate, #1: 1	أَنَّ الْجُشَاءَ
u'أَنَّ جَصَّاصٌ':Predicate, #1: 1	أَنَّ الْجُشَاءَ
u'أَنَّ جفاف':Predicate, #1: 1	أَنَّ الْجَصَّاصَ
u'أَنَّ جَفَافٌ':Predicate, #2: 2	أَنَّ الْجَفَافَ
u'أَنَّ جَلاَلٌ':Predicate, #2: 2	أَنَّ الْجَفَافَ
u'أَنَّ جَلْبٌ':Predicate, #1: 1	أَنَّ الْجَلَالَ
u'أَنَّ جلد':Predicate, #1: 1	أَنَّ الْجَلْبَ
u'أَنَّ جَلْدٌ':Predicate, #2: 2	أَنَّ جَلْدَ
u'أَنَّ جلد':Predicate, #2: 2	أَنَّ جَلْدَ
u'أَنَّ جِلْدٌ':Predicate, #5: 5	أَنَّ جِلْدَ
u'أَنَّ جلد':Predicate, #5: 5	أَنَّ جِلْدَ
u'أَنَّ جَلْدٌ':Predicate, #6: 6	أَنَّ الْجَلْدَ
u'أَنَّ جلد':Predicate, #6: 6	أَنَّ الْجَلْدَ
u'أَنَّ جِلْدٌ':Predicate, #9: 9	أَنَّ الْجِلْدَ
u'أَنَّ جلسة':Predicate, #9: 9	أَنَّ الْجِلْدَ
u'أَنَّ جلسة':Predicate, #1: 1	أَنَّ الْجَلْسَةَ
u'أَنَّ جَلْسَةٌ':Predicate, #1: 1	أَنَّ الْجِلْسَةَ
u'أَنَّ جِلْسَةٌ':Predicate, #1: 1	أَنَّ الْجَلْسَةَ
u'أَنَّ جلسة':Predicate, #1: 1	أَنَّ الْجِلْسَةَ
u'أَنَّ جَلْسَةٌ':Predicate, #1: 1	أَنَّ جَلْسَةَ
u'أَنَّ جُلُودٌ':Predicate, #1: 1	أَنَّ جَلْسَةَ
u'أَنَّ جُلُوسٌ':Predicate, #1: 1	أَنَّ الْجُلُودَ
u'أَنَّ جُلُوسٌ':Predicate, #3: 3	أَنَّ جُلُوسَ
u'أَنَّ جَمٌّ':Predicate, #8: 8	أَنَّ الْجُلُوسَ
u'أَنَّ جِمَارٌ':Predicate, #1: 1	أَنَّ الْجَمَّ
u'أَنَّ جماع':Predicate, #1: 1	أَنَّ الْجِمَارَ
u'أَنَّ جِمَاعٌ':Predicate, #13: 13	أَنَّ الْجِمَاعَ
u'أَنَّ جماع':Predicate, #13: 13	أَنَّ الْجِمَاعَ
u'أَنَّ جِمَاعٌ':Predicate, #2: 2	أَنَّ جِمَاعَ
u'أَنَّ جَمَاعَةٌ':Predicate, #2: 2	أَنَّ جِمَاعَ
u'أَنَّ جَمَاعَةٌ':Predicate, #1: 1	أَنَّ جَمَاعَةَ
u'أَنَّ جَمَالٌ':Predicate, #38: 38	أَنَّ الْجَمَاعَةَ
u'أَنَّ جَمَّالٌ':Predicate, #1: 1	أَنَّ الْجَمَالَ
u'أَنَّ جَمْرَةٌ':Predicate, #2: 2	أَنَّ الْجَمَّالَ
u'أَنَّ جَمْرَة':Predicate, #1: 1	أَنَّ جَمْرَةَ
u'أَنَّ جمع':Predicate, #1: 1	أَنَّ جَمْرَةَ
u'أَنَّ جَمْعٌ':Predicate, #19: 19	أَنَّ جَمْعَ
u'أَنَّ جمع':Predicate, #19: 19	أَنَّ جَمْعَ
u'أَنَّ جَمْعٌ':Predicate, #76: 76	أَنَّ الْجَمْعَ
u'أَنَّ جمعة':Predicate, #76: 76	أَنَّ الْجَمْعَ
u'أَنَّ جُمُعَةٌ':Predicate, #38: 38	أَنَّ الْجُمُعَةَ
u'أَنَّ جَمَلٌ':Predicate, #38: 38	أَنَّ الْجُمُعَةَ
u'أَنَّ جُمْلَةٌ':Predicate, #4: 4	أَنَّ الْجَمَلَ
u'أَنَّ جُمْلَةٌ':Predicate, #7: 7	أَنَّ جُمْلَةَ
u'أَنَّ جُمْهُورٌ':Predicate, #9: 9	أَنَّ الْجُمْلَةَ
u'أَنَّ جُمْهُورٌ':Predicate, #8: 8	أَنَّ جُمْهُورَ
u'أَنَّ جُمُوعٌ':Predicate, #9: 9	أَنَّ الْجُمْهُورَ
u'أَنَّ جَمِيع':Predicate, #1: 1	أَنَّ جُمُوعَ
u'أَنَّ جَمِيلٌ':Predicate, #36: 36	أَنَّ الْجَمِيعَ
u'أَنَّ جَمِيلٌ':Predicate, #1: 1	أَنَّ الْجَمِيلَةَ
u'أَنَّ جِنٌّ':Predicate, #6: 6	أَنَّ جَمِيلَةَ
u'أَنَّ جَنَابَةٌ':Predicate, #10: 10	أَنَّ الْجِنَّ
u'أَنَّ جِنَانٌ':Predicate, #6: 6	أَنَّ الْجَنَابَةَ
u'أَنَّ جِنَايَةٌ':Predicate, #1: 1	أَنَّ الْجِنَانَ
u'أَنَّ جِنَايَةٌ':Predicate, #18: 18	أَنَّ جِنَايَةَ
u'أَنَّ جَنْبٌ':Predicate, #33: 33	أَنَّ الْجِنَايَةَ
u'أَنَّ جَنَّةٌ':Predicate, #1: 1	أَنَّ الْجَنْبَ
u'أَنَّ جُنْدٌ':Predicate, #18: 18	أَنَّ الْجَنَّةَ
u'أَنَّ جُنْدِيٌّ':Predicate, #3: 3	أَنَّ الْجُنْدَ
u'أَنَّ جِنْسٌ':Predicate, #1: 1	أَنَّ الْجُنْدِيَّ
u'أَنَّ جِنْسٌ':Predicate, #12: 12	أَنَّ الْجِنْسَ
u'أَنَّ جُنُونٌ':Predicate, #6: 6	أَنَّ جِنْسَ
u'أَنَّ جِنِّيٌّ':Predicate, #14: 14	أَنَّ الْجُنُونَ
u'أَنَّ جَنِينٌ':Predicate, #3: 3	أَنَّ الْجِنِّيَّ
u'أَنَّ جَنِينٌ':Predicate, #12: 12	أَنَّ الْجَنِينَ
u'أَنَّ جهاد':Predicate, #3: 3	أَنَّ جَنِينَ
u'أَنَّ جِهَادٌ':Predicate, #9: 9	أَنَّ الْجِهَادَ
u'أَنَّ جُهَّالٌ':Predicate, #9: 9	أَنَّ الْجِهَادَ
u'أَنَّ جَهالَة':Predicate, #1: 1	أَنَّ الْجُهَّالَ
u'أَنَّ جَهالَة':Predicate, #19: 19	أَنَّ جَهَالَةَ
u'أَنَّ جِهَةٌ':Predicate, #30: 30	أَنَّ الْجَهَالَةَ
u'أَنَّ جِهَةٌ':Predicate, #5: 5	أَنَّ الْجِهَةَ
u'أَنَّ جَهْر':Predicate, #7: 7	أَنَّ جِهَةَ
u'أَنَّ جهر':Predicate, #1: 1	أَنَّ الْجَهْرِيَّةَ
u'أَنَّ جَهْرٌ':Predicate, #1: 1	أَنَّ جَهْرَ
u'أَنَّ جهر':Predicate, #1: 1	أَنَّ جَهْرَ
u'أَنَّ جَهْرٌ':Predicate, #9: 9	أَنَّ الْجَهْرَ
u'أَنَّ جَهْرَة':Predicate, #9: 9	أَنَّ الْجَهْرَ
u'أَنَّ جَهْرِيّ':Predicate, #1: 1	أَنَّ الْجَهْرِيَّةَ
u'أَنَّ جهل':Predicate, #1: 1	أَنَّ الْجَهْرِيَّةَ
u'أَنَّ جَهْلٌ':Predicate, #16: 16	أَنَّ الْجَهْلَ
u'أَنَّ جَهَنَّمُ':Predicate, #16: 16	أَنَّ الْجَهْلَ
u'أَنَّ جَهَنَّمِيّ':Predicate, #3: 3	أَنَّ جَهَنَّمَ
u'أَنَّ جَوَابٌ':Predicate, #1: 1	أَنَّ الْجَهَنَّمِيِّينَ
u'أَنَّ جَوَابٌ':Predicate, #16: 16	أَنَّ جَوَابَ
u'أَنَّ جَوَابٌ':Predicate, #1: 1	أَنَّ جَوَابَهُنَّ
u'أَنَّ جِوَارٌ':Predicate, #34: 34	أَنَّ الْجَوَابَ
u'أَنَّ جَوَازٌ':Predicate, #2: 2	أَنَّ الْجِوَارَ
u'أَنَّ جَوَازٌ':Predicate, #21: 21	أَنَّ الْجَوَازَ
u'أَنَّ جَوَامِعُ':Predicate, #38: 38	أَنَّ جَوَازَ
u'أَنَّ جَوَامِيسُ':Predicate, #1: 1	أَنَّ جَوَامِعَ
u'أَنَّ جوائح':Predicate, #3: 3	أَنَّ الْجَوَامِيسَ
u'أَنَّ جَوَائِحُ':Predicate, #2: 2	أَنَّ الْجَوَائِحَ
u'أَنَّ جَوْدَةٌ':Predicate, #2: 2	أَنَّ الْجَوَائِحَ
u'أَنَّ جَوْرَبٌ':Predicate, #4: 4	أَنَّ الْجَوْدَةَ
u'أَنَّ جَوْزٌ':Predicate, #1: 1	أَنَّ الْجَوْرَبَ
u'أَنَّ جَوْزٌ':Predicate, #3: 3	أَنَّ الْجَوْزَ
u'أَنَّ جَوْهَرٌ':Predicate, #4: 4	أَنَّ الْجَوْزَةَ
u'أَنَّ جَوْهَرٌ':Predicate, #1: 1	أَنَّ الْجَوْهَرَةَ
u'أَنَّ جَوْهَرِيٌّ':Predicate, #5: 5	أَنَّ الْجَوْهَرَ
u'أَنَّ جَيْبٌ':Predicate, #2: 2	أَنَّ الْجَوْهَرِيَّ
u'أَنَّ جِيرَانٌ':Predicate, #1: 1	أَنَّ الْجَيْبَ
u'أَنَّ جَيْشٌ':Predicate, #1: 1	أَنَّ الْجِيرَانَ
u'أَنَّ جَيْشٌ':Predicate, #1: 1	أَنَّ الْجَيْشَ
u'أَنْحَاءٌ ضَرُورِيٌّ':Added, #2: 2	أَنَّ جَيْشَ
u'أَنْحَاءٌ ضَرُورِيَّاتٌ':Added, #3: 3	أَنْحَاءِ الضَّرُورِيَّاتِ
u'أَنَّ حاجٌّ':Predicate, #3: 3	أَنْحَاءِ الضَّرُورِيَّاتِ
u'أَنَّ حاجَةٌ':Predicate, #11: 11	أَنَّ الْحَاجَّ
u'أَنَّ حاجَةٌ':Predicate, #1: 1	أَنَّ حَاجَةَ
u'أَنَّ حاجِزٌ':Predicate, #41: 41	أَنَّ الْحَاجَةَ
u'أَنَّ حادٌّ':Predicate, #1: 1	أَنَّ الْحَاجِزَ
u'أَنَّ حادِثٌ':Predicate, #1: 1	أَنَّ الْحَادَّ
u'أَنَّ حادِثٌ':Predicate, #12: 12	أَنَّ الْحَادِثَ
u'أَنَّ حارٌّ':Predicate, #2: 2	أَنَّ الْحَادِثَةَ
u'أَنَّ حارِثٌ':Predicate, #1: 1	أَنَّ الْحَارَّ
u'أَنَّ حارِثٌ':Predicate, #16: 16	أَنَّ الْحَارِثَ
u'أَنَّ حارِسٌ':Predicate, #4: 4	أَنَّ حَارِثَةَ
u'أَنَّ حاصِلٌ':Predicate, #1: 1	أَنَّ حَارِسَ
u'أَنَّ حاصِلٌ':Predicate, #15: 15	أَنَّ حَاصِلَ
u'أَنَّ حاضِرٌ':Predicate, #9: 9	أَنَّ الْحَاصِلَ
u'أَنَّ حاضِرٌ':Predicate, #16: 16	أَنَّ الْحَاضِرَ
u'أَنَّ حاضِرٌ':Predicate, #1: 1	أَنَّ الْحَاضِرَةَ
u'أَنَّ حاضِرٌ':Predicate, #2: 2	أَنَّ الْحَاضِرِينَ
u'أَنَّ حاضِنٌ':Predicate, #2: 2	أَنَّ حَاضِرَ
u'أَنَّ حاضِنٌ':Predicate, #1: 1	أَنَّ الْحَاضِنَ
u'أَنَّ حاطِبٌ':Predicate, #1: 1	أَنَّ الْحَاضِنَةَ
u'أَنَّ حافِرٌ':Predicate, #2: 2	أَنَّ حَاطِبَ
u'أَنَّ حافِرٌ':Predicate, #1: 1	أَنَّ الْحَافِرَ
u'أَنَّ حافِظٌ':Predicate, #2: 2	أَنَّ حَافِرَ
u'أَنَّ حاكِمٌ':Predicate, #1: 1	أَنَّ الْحَافِظَ
u'أَنَّ حاكِمٌ':Predicate, #1: 1	أَنَّ حَاكِمَ
u'أَنَّ حالٌ':Predicate, #99: 99	أَنَّ الْحَاكِمَ
u'أَنَّ حالٌ':Predicate, #13: 13	أَنَّ الْحَالَ
u'أَنَّ حالَةٌ':Predicate, #18: 18	أَنَّ حَالَ
u'أَنَّ حالَةٌ':Predicate, #11: 11	أَنَّ حَالَةَ
u'أَنَّ حامِلٌ':Predicate, #3: 3	أَنَّ الْحَالَةَ
u'أَنَّ حامِلٌ':Predicate, #30: 30	أَنَّ الْحَامِلَ
u'أَنَّ حائِضٌ':Predicate, #3: 3	أَنَّ حَامِلَ
u'أَنَّ حائِطٌ':Predicate, #17: 17	أَنَّ الْحَائِضَ
u'أَنَّ حائِكٌ':Predicate, #16: 16	أَنَّ الْحَائِطَ
u'أَنَّ حائِلٌ':Predicate, #2: 2	أَنَّ الْحَائِكَ
u'أَنَّ حُبٌّ':Predicate, #4: 4	أَنَّ الْحَائِلَ
u'أَنَّ حَبٌّ':Predicate, #1: 1	أَنَّ الْحُبَّ
u'أَنَّ حُبٌّ':Predicate, #1: 1	أَنَّ الْحَبَّةَ
u'أَنَّ حَبٌّ':Predicate, #1: 1	أَنَّ حُبَّ
u'أَنَّ حَبٌّ':Predicate, #2: 2	أَنَّ الْحَبَّ
u'أَنَّ حَبَّةٌ':Predicate, #2: 2	أَنَّ حَبَّةَ
u'أَنَّ حَبَّةٌ':Predicate, #1: 1	أَنَّ الْحَبَّةَ
u'أَنَّ حَبْسٌ':Predicate, #2: 2	أَنَّ حَبَّةَ
u'أَنَّ حَبْسٌ':Predicate, #12: 12	أَنَّ الْحَبْسَ
u'أَنَّ حَبَشَة':Predicate, #3: 3	أَنَّ حَبْسَ
u'أَنَّ حَبْلٌ':Predicate, #1: 1	أَنَّ الْحَبَشَةَ
u'أَنَّ حَبْلٌ':Predicate, #1: 1	أَنَّ الْحَبْلَ
u'أَنَّ حُبوبٌ':Predicate, #1: 1	أَنَّ حَبْلَ
u'أَنَّ حَبيبٌ':Predicate, #1: 1	أَنَّ الْحُبُوبَ
u'أَنَّ حَبيبٌ':Predicate, #1: 1	أَنَّ حَبِيبَةَ
u'أَنَّ حَتّ':Predicate, #3: 3	أَنَّ حَبِيبَ
u'أَنَّ حَجٌّ':Predicate, #1: 1	أَنَّ الْحَتَّ
u'أَنَّ حَجٌّ':Predicate, #5: 5	أَنَّ حَجَّ
u'أَنَّ حجاب':Predicate, #67: 67	أَنَّ الْحَجَّ
u'أَنَّ حِجابٌ':Predicate, #1: 1	أَنَّ الْحِجَابَ
u'أَنَّ حُجَّاجٌ':Predicate, #1: 1	أَنَّ الْحِجَابَ
u'أَنَّ حِجارَةٌ':Predicate, #1: 1	أَنَّ الْحُجَّاجَ
u'أَنَّ حجاز':Predicate, #1: 1	أَنَّ الْحِجَارَةَ
u'أَنَّ حَجَّام':Predicate, #1: 1	أَنَّ الْحِجَازَ
u'أَنَّ حِجَامَةٌ':Predicate, #1: 1	أَنَّ الْحَجَّامَ
u'أَنَّ حجبة':Predicate, #2: 2	أَنَّ الْحِجَامَةَ
u'أَنَّ حِجَّةٌ':Predicate, #1: 1	أَنَّ الْحُجْبَةَ
u'أَنَّ حُجَّة':Predicate, #1: 1	أَنَّ حِجَّةَ
u'أَنَّ حُجَّةٌ':Predicate, #1: 1	أَنَّ حُجِّيَّةَ
u'أَنَّ حُجَّةٌ':Predicate, #23: 23	أَنَّ الْحُجَّةَ
u'أَنَّ حُجَجٌ':Predicate, #3: 3	أَنَّ حُجَّةَ
u'أَنَّ حَجْرٌ':Predicate, #1: 1	أَنَّ الْحُجَجَ
u'أَنَّ حَجْرٌ':Predicate, #1: 1	أَنَّ حَجْرَ
u'أَنَّ حِجْرٌ':Predicate, #22: 22	أَنَّ الْحَجْرَ
u'أَنَّ حَجَرٌ':Predicate, #4: 4	أَنَّ الْحِجْرَ
u'أَنَّ حُجْرَةٌ':Predicate, #6: 6	أَنَّ الْحَجَرَ
u'أَنَّ حُجِّيَّة':Predicate, #1: 1	أَنَّ الْحُجْرَةَ
u'أَنَّ حَدٌّ':Predicate, #1: 1	أَنَّ حُجِّيَّةَ
u'أَنَّ حَدٌّ':Predicate, #34: 34	أَنَّ حَدَّ
u'أَنَّ حداد':Predicate, #55: 55	أَنَّ الْحَدَّ
u'أَنَّ حِدادٌ':Predicate, #2: 2	أَنَّ الْحِدَادَ
u'أَنَّ حَدَثٌ':Predicate, #2: 2	أَنَّ الْحِدَادَ
u'أَنَّ حَدَثٌ':Predicate, #28: 28	أَنَّ الْحَدَثَ
u'أَنَّ حُدوثٌ':Predicate, #2: 2	أَنَّ حَدَثَ
u'أَنَّ حُدوثٌ':Predicate, #1: 1	أَنَّ الْحُدُوثَ
u'أَنَّ حُدودٌ':Predicate, #8: 8	أَنَّ حُدُوثَ
u'أَنَّ حَديثٌ':Predicate, #29: 29	أَنَّ الْحُدُودَ
u'أَنَّ حَديثٌ':Predicate, #40: 40	أَنَّ حَدِيثَ
u'أَنَّ حَديثٌ':Subject, #64: 64	أَنَّ الْحَدِيثَ
u'أَنَّ حَديدٌ':Predicate, #1: 1	أَنَّ الْحَدِيثُ
u'أَنَّ حَذَرٌ':Predicate, #1: 1	أَنَّ الْحَدِيدَ
u'أَنَّ حَذْف':Predicate, #1: 1	أَنَّ الْحَذَرَ
u'أَنَّ حُرٌّ':Predicate, #3: 3	أَنَّ الْحَذْفَ
u'أَنَّ حُرٌّ':Predicate, #12: 12	أَنَّ الْحُرَّةَ
u'أَنَّ حُرٌّ':Predicate, #1: 1	أَنَّ حُرَّةً
u'أَنَّ حُرَّاثٌ':Predicate, #39: 39	أَنَّ الْحُرَّ
u'أَنَّ حَرارَةٌ':Predicate, #1: 1	أَنَّ الْحُرَّاثَ
u'أَنَّ حَرارَةٌ':Predicate, #1: 1	أَنَّ الْحَرَارَةَ
u'أَنَّ حَرامٌ':Predicate, #1: 1	أَنَّ حَرَارَةَ
u'أَنَّ حَرْبٌ':Predicate, #5: 5	أَنَّ الْحَرَامَ
u'أَنَّ حَرْبِيّ':Predicate, #1: 1	أَنَّ الْحَرْبَ
u'أَنَّ حَرْثٌ':Predicate, #1: 1	أَنَّ الْحَرْبِيِّينَ
u'أَنَّ حَرْثٌ':Predicate, #1: 1	أَنَّ حَرْثَ
u'أَنَّ حَرَجٌ':Predicate, #3: 3	أَنَّ الْحَرْثَ
u'أَنَّ حِرْزٌ':Predicate, #2: 2	أَنَّ الْحَرَجَ
u'أَنَّ حِرْزٌ':Predicate, #1: 1	أَنَّ حِرْزَ
u'أَنَّ حَرْفٌ':Predicate, #5: 5	أَنَّ الْحِرْزَ
u'أَنَّ حِرَفٌ':Predicate, #17: 17	أَنَّ حَرْفَ
u'أَنَّ حَرْفٌ':Predicate, #2: 2	أَنَّ الْحِرَفَ
u'أَنَّ حِرْفَةٌ':Predicate, #4: 4	أَنَّ الْحَرْفَ
u'أَنَّ حَرْقٌ':Predicate, #2: 2	أَنَّ الْحِرْفَةَ
u'أَنَّ حَرَكَةٌ':Predicate, #1: 1	أَنَّ الْحَرْقَ
u'أَنَّ حَرَكَةٌ':Predicate, #3: 3	أَنَّ الْحَرَكَةَ
u'أَنَّ حَرَمٌ':Predicate, #7: 7	أَنَّ حَرَكَةَ
u'أَنَّ حَرَمٌ':Predicate, #1: 1	أَنَّ حَرَمَ
u'أَنَّ حِرْمَانٌ':Predicate, #5: 5	أَنَّ الْحَرَمَ
u'أَنَّ حُرْمَةٌ':Predicate, #2: 2	أَنَّ حِرْمَانَ
u'أَنَّ حُرْمَةٌ':Predicate, #37: 37	أَنَّ الْحُرْمَةَ
u'أَنَّ حَرُور':Predicate, #60: 60	أَنَّ حُرْمَةَ
u'أَنَّ حُروفٌ':Predicate, #2: 2	أَنَّ الْحَرُورِيَّةَ
u'أَنَّ حُروفٌ':Predicate, #1: 1	أَنَّ حُرُوفَ
u'أَنَّ حُرِّيَّةٌ':Predicate, #6: 6	أَنَّ الْحُرُوفَ
u'أَنَّ حُرِّيَّةٌ':Predicate, #11: 11	أَنَّ الْحُرِّيَّةَ
u'أَنَّ حَرِيرٌ':Predicate, #1: 1	أَنَّ حُرِّيَّةَ
u'أَنَّ حَرِيصٌ':Predicate, #1: 1	أَنَّ الْحَرِيرَ
u'أَنَّ حَرِيقٌ':Predicate, #1: 1	أَنَّ الْحَرِيصَ
u'أَنَّ حَرِيمٌ':Predicate, #2: 2	أَنَّ الْحَرِيقَ
u'أَنَّ حَرِيمٌ':Predicate, #2: 2	أَنَّ حَرِيمَ
u'أَنَّ حِزْبٌ':Predicate, #3: 3	أَنَّ الْحَرِيمَ
u'أَنَّ حَزْمٌ':Predicate, #1: 1	أَنَّ الْحِزْبَ
u'أَنَّ حُزْنٌ':Predicate, #1: 1	أَنَّ الْحَزْمَ
u'أَنَّ حُزْنٌ':Predicate, #1: 1	أَنَّ الْحُزْنَ
u'أَنَّ حِسٌّ':Predicate, #1: 1	أَنَّ حُزْنَ
u'أَنَّ حساب':Predicate, #2: 2	أَنَّ الْحِسَّ
u'أَنَّ حِسَابٌ':Predicate, #1: 1	أَنَّ الْحِسَابَ
u'أَنَّ حَسَبٌ':Predicate, #1: 1	أَنَّ الْحِسَابَ
u'أَنَّ حِسْبَةٌ':Predicate, #1: 1	أَنَّ الْحَسَبَ
u'أَنَّ حسد':Predicate, #1: 1	أَنَّ الْحِسْبَةَ
u'أَنَّ حَسَدٌ':Predicate, #3: 3	أَنَّ الْحَسَدَ
u'أَنَّ حَسْمٌ':Predicate, #3: 3	أَنَّ الْحَسَدَ
u'أَنَّ حَسَنٌ':Predicate, #2: 2	أَنَّ الْحَسْمَ
u'أَنَّ حُسْنٌ':Predicate, #49: 49	أَنَّ الْحَسَنَ
u'أَنَّ حُسْنٌ':Predicate, #5: 5	أَنَّ حُسْنَ
u'أَنَّ حَسَنٌ':Predicate, #8: 8	أَنَّ الْحُسْنَ
u'أَنَّ حَسَنَةٌ':Predicate, #9: 9	أَنَّ الْحَسَنَةَ
u'أَنَّ حَشَفَةٌ':Predicate, #9: 9	أَنَّ الْحَسَنَةَ
u'أَنَّ حِشْمَةٌ':Predicate, #1: 1	أَنَّ حَشَفَةَ
u'أَنَّ حَشِيشٌ':Predicate, #1: 1	أَنَّ حِشْمَةَ
u'أَنَّ حَشِيشٌ':Predicate, #1: 1	أَنَّ الْحَشِيشَ
u'أَنَّ حَشِيشٌ':Predicate, #1: 1	أَنَّ حَشِيشَ
u'أَنَّ حَصَادٌ':Predicate, #4: 4	أَنَّ الْحَشِيشَةَ
u'أَنَّ حِصَّةٌ':Predicate, #3: 3	أَنَّ الْحَصَادَ
u'أَنَّ حِصَّةٌ':Predicate, #1: 1	أَنَّ الْحِصَّةَ
u'أَنَّ حَصْرٌ':Predicate, #6: 6	أَنَّ حِصَّةَ
u'أَنَّ حُصُرٌ':Predicate, #1: 1	أَنَّ حَصْرَ
u'أَنَّ حَصْرٌ':Predicate, #1: 1	أَنَّ حُصُرَ
u'أَنَّ حِصْرِمٌ':Predicate, #8: 8	أَنَّ الْحَصْرَ
u'أَنَّ حُصُول':Predicate, #1: 1	أَنَّ الْحِصْرِمَ
u'أَنَّ حُصُول':Predicate, #15: 15	أَنَّ حُصُولَ
u'أَنَّ حُصُونٌ':Predicate, #2: 2	أَنَّ الْحُصُولَ
u'أَنَّ حَصِيرٌ':Predicate, #1: 1	أَنَّ الْحُصُونَ
u'أَنَّ حَضَانَةٌ':Predicate, #1: 1	أَنَّ الْحَصِيرَ
u'أَنَّ حضرة':Predicate, #7: 7	أَنَّ الْحَضَانَةَ
u'أَنَّ حَضْرَةٌ':Predicate, #2: 2	أَنَّ حَضْرَةَ
u'أَنَّ حَضَرِيٌّ':Predicate, #2: 2	أَنَّ حَضْرَةَ
u'أَنَّ حُضورٌ':Predicate, #1: 1	أَنَّ الْحَضَرِيَّ
u'أَنَّ حُضُورٌ':Predicate, #1: 1	أَنَّ حُضُورَهُنَّ
u'أَنَّ حُضورٌ':Predicate, #1: 1	أَنَّ حُضُورَهُنَّ
u'أَنَّ حُضُورٌ':Predicate, #2: 2	أَنَّ الْحُضُورَ
u'أَنَّ حُضورٌ':Predicate, #2: 2	أَنَّ الْحُضُورَ
u'أَنَّ حُضُورٌ':Predicate, #6: 6	أَنَّ حُضُورَ
u'أَنَّ حَطّ':Predicate, #6: 6	أَنَّ حُضُورَ
u'أَنَّ حَطَبٌ':Predicate, #7: 7	أَنَّ الْحَطَّ
u'أَنَّ حَطِيم':Predicate, #3: 3	أَنَّ الْحَطَبَ
u'أَنَّ حَظٌّ':Predicate, #1: 1	أَنَّ الْحَطِيمَ
u'أَنَّ حَظٌّ':Predicate, #1: 1	أَنَّ حَظَّ
u'أَنَّ حِظارٌ':Predicate, #2: 2	أَنَّ الْحَظَّ
u'أَنَّ حَظْر':Predicate, #1: 1	أَنَّ الْحِظَارَ
u'أَنَّ حُظُوظٌ':Predicate, #5: 5	أَنَّ الْحَظْرَ
u'أَنَّ حَفْرٌ':Predicate, #1: 1	أَنَّ حُظُوظَ
u'أَنَّ حَفْصٌ':Predicate, #2: 2	أَنَّ الْحَفْرَ
u'أَنَّ حِفْظٌ':Predicate, #4: 4	أَنَّ حَفْصَ
u'أَنَّ حِفْظٌ':Predicate, #1: 1	أَنَّ الْحِفْظَ
u'أَنَّ حَقٌّ':Predicate, #8: 8	أَنَّ حِفْظَ
u'أَنَّ حَقٌّ':Predicate, #144: 144	أَنَّ الْحَقَّ
u'أَنَّ حقائق':Predicate, #91: 91	أَنَّ حَقَّ
u'أَنَّ حَقَائِقُ':Predicate, #3: 3	أَنَّ الْحَقَائِقَ
u'أَنَّ حقد':Predicate, #3: 3	أَنَّ الْحَقَائِقَ
u'أَنَّ حِقد':Predicate, #1: 1	أَنَّ الْحِقْدَ
u'أَنَّ حِقْدٌ':Predicate, #1: 1	أَنَّ الْحِقْدَ
u'أَنَّ حَقْنٌ':Predicate, #1: 1	أَنَّ الْحِقْدَ
u'أَنَّ حُقْنَةٌ':Predicate, #2: 2	أَنَّ حَقْنَ
u'أَنَّ حُقوقٌ':Predicate, #1: 1	أَنَّ الْحُقْنَةَ
u'أَنَّ حُقُوقٌ':Predicate, #14: 14	أَنَّ الْحُقُوقَ
u'أَنَّ حُقوقٌ':Predicate, #14: 14	أَنَّ الْحُقُوقَ
u'أَنَّ حُقُوقٌ':Predicate, #17: 17	أَنَّ حُقُوقَ
u'أَنَّ حَقِيقٌ':Predicate, #17: 17	أَنَّ حُقُوقَ
u'أَنَّ حَقِيقٌ':Predicate, #27: 27	أَنَّ الْحَقِيقَةَ
u'أَنَّ حَقِيقَةٌ':Predicate, #32: 32	أَنَّ حَقِيقَةَ
u'أَنَّ حَقِيقَةٌ':Predicate, #27: 27	أَنَّ الْحَقِيقَةَ
u'أَنَّ حُكَّامٌ':Predicate, #32: 32	أَنَّ حَقِيقَةَ
u'أَنَّ حِكَايَةٌ':Predicate, #5: 5	أَنَّ الْحُكَّامَ
u'أَنَّ حَكَمٌ':Predicate, #3: 3	أَنَّ حِكَايَةَ
u'أَنَّ حُكْمٌ':Predicate, #1: 1	أَنَّ حَكَمَ
u'أَنَّ حَكَمٌ':Predicate, #1: 1	أَنَّ حُكْمَهُنَّ
u'أَنَّ حُكْمٌ':Predicate, #20: 20	أَنَّ الْحَكَمَ
u'أَنَّ حُكْمٌ':Predicate, #265: 265	أَنَّ حُكْمَ
u'أَنَّ حكمة':Predicate, #371: 371	أَنَّ الْحُكْمَ
u'أَنَّ حِكْمَةٌ':Predicate, #11: 11	أَنَّ الْحِكْمَةَ
u'أَنَّ حكمة':Predicate, #11: 11	أَنَّ الْحِكْمَةَ
u'أَنَّ حكمة':Predicate, #1: 1	أَنَّ حَكَمَةَ
u'أَنَّ حِكْمَةٌ':Predicate, #3: 3	أَنَّ حِكْمَةَ
u'أَنَّ حُكُومَةٌ':Predicate, #3: 3	أَنَّ حِكْمَةَ
u'أَنَّ حُكُومَةٌ':Predicate, #1: 1	أَنَّ حُكُومَةَ
u'أَنَّ حَكِيمٌ':Predicate, #2: 2	أَنَّ الْحُكُومَةَ
u'أَنَّ حَكِيمٌ':Predicate, #12: 12	أَنَّ حَكِيمَ
u'أَنَّ حَكِيمٌ':Predicate, #1: 1	أَنَّ حَكِيمَةَ
u'أَنَّ حِلٌّ':Predicate, #5: 5	أَنَّ الْحَكِيمَ
u'أَنَّ حِلٌّ':Predicate, #13: 13	أَنَّ حِلَّ
u'أَنَّ حَلٌّ':Predicate, #18: 18	أَنَّ الْحِلَّ
u'أَنَّ حَلالٌ':Predicate, #1: 1	أَنَّ الْحَلَّ
u'أَنَّ حَلاَوَةٌ':Predicate, #12: 12	أَنَّ الْحَلَالَ
u'أَنَّ حلب':Predicate, #1: 1	أَنَّ الْحَلَاوَةَ
u'أَنَّ حُلَّةٌ':Predicate, #1: 1	أَنَّ الْحَلْبَ
u'أَنَّ حَلْقٌ':Predicate, #1: 1	أَنَّ الْحُلَّةَ
u'أَنَّ حَلْقٌ':Predicate, #23: 23	أَنَّ الْحَلْقَ
u'أَنَّ حَلْقَةٌ':Predicate, #6: 6	أَنَّ حَلْقَ
u'أَنَّ حُلَلٌ':Predicate, #3: 3	أَنَّ الْحَلْقَةَ
u'أَنَّ حُلْمٌ':Predicate, #1: 1	أَنَّ الْحُلَلَ
u'أَنَّ حُلُمٌ':Predicate, #1: 1	أَنَّ الْحُلْمَ
u'أَنَّ حَلَمَةٌ':Predicate, #2: 2	أَنَّ الْحُلُمَ
u'أَنَّ حلْوٌ':Predicate, #1: 1	أَنَّ حَلَمَةَ
u'أَنَّ حَلْواءُ':Predicate, #2: 2	أَنَّ الْحُلْوَ
u'أَنَّ حَلْوانِيٌّ':Predicate, #1: 1	أَنَّ الْحَلْوَاءَ
u'أَنَّ حُلِيٌّ':Predicate, #1: 1	أَنَّ الْحَلْوَانِيَّ
u'أَنَّ حُلِيٌّ':Predicate, #1: 1	أَنَّ حُلِيَّ
u'أَنَّ حَلِيبٌ':Predicate, #8: 8	أَنَّ الْحُلِيَّ
u'أَنَّ حِلْيَةٌ':Predicate, #1: 1	أَنَّ الْحَلِيبَ
u'أَنَّ حَلِيلَةٌ':Predicate, #2: 2	أَنَّ الْحِلْيَةَ
u'أَنَّ حَلِيلَةٌ':Predicate, #1: 1	أَنَّ الْحَلِيلَةَ
u'أَنَّ حَمَّادٌ':Predicate, #1: 1	أَنَّ حَلِيلَةَ
u'أَنَّ حِمَارٌ':Predicate, #4: 4	أَنَّ حَمَّادَ
u'أَنَّ حَمَّالٌ':Predicate, #5: 5	أَنَّ الْحِمَارَ
u'أَنَّ حَمَامٌ':Predicate, #1: 1	أَنَّ الْحَمَّالَ
u'أَنَّ حَمَّامٌ':Predicate, #2: 2	أَنَّ الْحَمَامَ
u'أَنَّ حَمَّامِيٌّ':Predicate, #3: 3	أَنَّ الْحَمَّامَ
u'أَنَّ حَمْدٌ':Predicate, #2: 2	أَنَّ الْحَمَّامِيَّ
u'أَنَّ حَمْدٌ':Subject, #4: 4	أَنَّ الْحَمْدَ
u'أَنَّ حمر':Predicate, #4: 4	أَنَّ الْحَمْدُ
u'أَنَّ حمر':Predicate, #1: 1	أَنَّ الْحُمُرَ
u'أَنَّ حُمُرٌ':Predicate, #1: 1	أَنَّ الْحُمْرَ
u'أَنَّ حُمْرَةٌ':Predicate, #1: 1	أَنَّ الْحُمُرَ
u'أَنَّ حَمْز':Predicate, #2: 2	أَنَّ الْحُمْرَةَ
u'أَنَّ حَمْقَاء':Predicate, #11: 11	أَنَّ حَمْزَةَ
u'أَنَّ حَمْلٌ':Predicate, #1: 1	أَنَّ الْحَمْقَاءَ
u'أَنَّ حَمْلٌ':Predicate, #21: 21	أَنَّ حَمْلَ
u'أَنَّ حَمَلَةٌ':Predicate, #60: 60	أَنَّ الْحَمْلَ
u'أَنَّ حُمُوضَةٌ':Predicate, #1: 1	أَنَّ حَمَلَةَ
u'أَنَّ حُمُولَةٌ':Predicate, #1: 1	أَنَّ الْحُمُوضَةَ
u'أَنَّ حَمِيل':Predicate, #1: 1	أَنَّ حُمُولَةَ
u'أَنَّ حِنَّاءٌ':Predicate, #1: 1	أَنَّ الْحَمِيلَ
u'أَنَّ حِنْثٌ':Predicate, #2: 2	أَنَّ الْحِنَّاءَ
u'أَنَّ حَنَشٌ':Predicate, #9: 9	أَنَّ الْحِنْثَ
u'أَنَّ حِنْطَةٌ':Predicate, #1: 1	أَنَّ حَنَشَ
u'أَنَّ حَنْظَلٌ':Predicate, #9: 9	أَنَّ الْحِنْطَةَ
u'أَنَّ حَنَفِيَّةٌ':Predicate, #11: 11	أَنَّ حَنْظَلَةَ
u'أَنَّ حُنُوٌّ':Predicate, #17: 17	أَنَّ الْحَنَفِيَّةَ
u'أَنَّ حَنِيفيٌّ':Predicate, #1: 1	أَنَّ الْحُنُوَّ
u'أَنَّ حَنِيفِيٌّ':Predicate, #1: 1	أَنَّ الْحَنِيفِيَّةَ
u'أَنَّ حَوَّاءُ':Predicate, #1: 1	أَنَّ الْحَنِيفِيَّةَ
u'أَنَّ حوادِثُ':Predicate, #2: 2	أَنَّ حَوَّاءَ
u'أَنَّ حَواصِلُ':Predicate, #4: 4	أَنَّ الْحَوَادِثَ
u'أَنَّ حَوَالَةٌ':Predicate, #1: 1	أَنَّ الْحَوَاصِلَ
u'أَنَّ حَوَالَةٌ':Predicate, #1: 1	أَنَّ حَوَالَةَ
u'أَنَّ حَوانِيتُ':Predicate, #38: 38	أَنَّ الْحَوَالَةَ
u'أَنَّ حَوائِجُ':Predicate, #1: 1	أَنَّ الْحَوَانِيتَ
u'أَنَّ حَوْزٌ':Predicate, #1: 1	أَنَّ الْحَوَائِجَ
u'أَنَّ حَوْزٌ':Predicate, #1: 1	أَنَّ الْحَوْزَ
u'أَنَّ حَوْشٌ':Predicate, #1: 1	أَنَّ حَوْزَ
u'أَنَّ حَوْضٌ':Predicate, #1: 1	أَنَّ الْحَوْشَ
u'أَنَّ حول':Predicate, #1: 1	أَنَّ الْحَوْضَ
u'أَنَّ حَوْلٌ':Predicate, #10: 10	أَنَّ الْحَوْلَ
u'أَنَّ حول':Predicate, #10: 10	أَنَّ الْحَوْلَ
u'أَنَّ حَوْلٌ':Predicate, #2: 2	أَنَّ حَوْلَ
u'أَنَّ حَوْلاَء':Predicate, #2: 2	أَنَّ حَوْلَ
u'أَنَّ حَيٌّ':Predicate, #1: 1	أَنَّ الْحَوْلاَءَ
u'أَنَّ حَيَاءٌ':Predicate, #8: 8	أَنَّ الْحَيَّ
u'أَنَّ حَيَاةٌ':Predicate, #1: 1	أَنَّ الْحَيَاءَ
u'أَنَّ حَيَاةٌ':Predicate, #14: 14	أَنَّ الْحَيَاةَ
u'أَنَّ حِيازَة':Predicate, #2: 2	أَنَّ حَيَاةَ
u'أَنَّ حِيازَة':Predicate, #2: 2	أَنَّ الْحِيَازَةَ
u'أَنَّ حِيَاضٌ':Predicate, #2: 2	أَنَّ حِيَازَةَ
u'أَنَّ حَيْضٌ':Predicate, #1: 1	أَنَّ الْحِيَاضَ
u'أَنَّ حَيْضٌ':Predicate, #25: 25	أَنَّ الْحَيْضَ
u'أَنَّ حَيْضَةٌ':Predicate, #3: 3	أَنَّ حَيْضَ
u'أَنَّ حِيَلٌ':Predicate, #3: 3	أَنَّ الْحَيْضَةَ
u'أَنَّ حِيلَةٌ':Predicate, #3: 3	أَنَّ الْحِيَلَ
u'أَنَّ حِيلَةٌ':Predicate, #1: 1	أَنَّ حِيلَةَ
u'أَنَّ حَيْلُولَةٌ':Predicate, #7: 7	أَنَّ الْحِيلَةَ
u'أَنَّ حَيْلُولَةٌ':Predicate, #1: 1	أَنَّ حَيْلُولَةَ
u'أَنَّ حَيَوَانٌ':Predicate, #2: 2	أَنَّ الْحَيْلُولَةَ
u'أَنَّ حَيَوَانٌ':Predicate, #14: 14	أَنَّ الْحَيَوَانَ
u'أَنَّ خَادِمٌ':Predicate, #2: 2	أَنَّ حَيَوَانَ
u'أَنَّ خَادِمٌ':Predicate, #1: 1	أَنَّ الْخَادِمَ
u'أَنَّ خَارِجٌ':Predicate, #2: 2	أَنَّ خَادِمَ
u'أَنَّ خَارِجٌ':Predicate, #1: 1	أَنَّ الْخَارِجَةَ
u'أَنَّ خَارِجٌ':Predicate, #4: 4	أَنَّ خَارِجَةَ
u'أَنَّ خَارِقٌ':Predicate, #57: 57	أَنَّ الْخَارِجَ
u'أَنَّ خاصّ':Predicate, #1: 1	أَنَّ خَارِقَ
u'أَنَّ خَاصَّةٌ':Predicate, #10: 10	أَنَّ الْخَاصَّ
u'أَنَّ خَافِضٌ':Predicate, #1: 1	أَنَّ الْخَاصَّةَ
u'أَنَّ خَالٌ':Predicate, #1: 1	أَنَّ الْخَافِضَةَ
u'أَنَّ خَالٌ':Predicate, #3: 3	أَنَّ الْخَالَ
u'أَنَّ خَالِدٌ':Predicate, #5: 5	أَنَّ الْخَالَةَ
u'أَنَّ خَالِصٌ':Predicate, #22: 22	أَنَّ خَالِدَ
u'أَنَّ خامس':Predicate, #2: 2	أَنَّ الْخَالِصَ
u'أَنَّ خَامِسٌ':Predicate, #1: 1	أَنَّ الْخَامِسَ
u'أَنَّ خامس':Predicate, #1: 1	أَنَّ الْخَامِسَ
u'أَنَّ خَامِسٌ':Predicate, #1: 1	أَنَّ الْخَامِسَةَ
u'أَنَّ خَبَّازٌ':Predicate, #1: 1	أَنَّ الْخَامِسَةَ
u'أَنَّ خُبْثٌ':Predicate, #1: 1	أَنَّ الْخَبَّازَ
u'أَنَّ خَبَرٌ':Predicate, #1: 1	أَنَّ الْخُبْثَ
u'أَنَّ خَبَر':Predicate, #38: 38	أَنَّ خَبَرَ
u'أَنَّ خَبَرٌ':Predicate, #38: 38	أَنَّ خَبَرَ
u'أَنَّ خَبَر':Predicate, #43: 43	أَنَّ الْخَبَرَ
u'أَنَّ خُبْزٌ':Predicate, #43: 43	أَنَّ الْخَبَرَ
u'أَنَّ خَبِيث':Predicate, #4: 4	أَنَّ الْخُبْزَ
u'أَنَّ ختان':Predicate, #1: 1	أَنَّ الْخَبِيثَ
u'أَنَّ خِتَانٌ':Predicate, #2: 2	أَنَّ خِتَانَ
u'أَنَّ ختان':Predicate, #2: 2	أَنَّ خِتَانَ
u'أَنَّ خِتَانٌ':Predicate, #3: 3	أَنَّ الْخِتَانَ
u'أَنَّ خَتْمٌ':Predicate, #3: 3	أَنَّ الْخِتَانَ
u'أَنَّ خَتْمٌ':Predicate, #29: 29	أَنَّ خَتْمَ
u'أَنَّ خَتَنٌ':Predicate, #4: 4	أَنَّ الْخَتْمَ
u'أَنَّ خَدٌّ':Predicate, #1: 1	أَنَّ الْخَتَنَ
u'أَنَّ خَدْش':Predicate, #4: 4	أَنَّ الْخَدَّ
u'أَنَّ خدمة':Predicate, #2: 2	أَنَّ الْخَدْشَةَ
u'أَنَّ خِدْمَةٌ':Predicate, #7: 7	أَنَّ الْخِدْمَةَ
u'أَنَّ خَدِيج':Predicate, #7: 7	أَنَّ الْخِدْمَةَ
u'أَنَّ خراج':Predicate, #1: 1	أَنَّ خَدِيجَةَ
u'أَنَّ خَرَاجٌ':Predicate, #2: 2	أَنَّ خَرَاجَ
u'أَنَّ خراج':Predicate, #2: 2	أَنَّ خَرَاجَ
u'أَنَّ خَرَاجٌ':Predicate, #30: 30	أَنَّ الْخَرَاجَ
u'أَنَّ خُراسانِيّ':Predicate, #30: 30	أَنَّ الْخَرَاجَ
u'أَنَّ خَرِبٌ':Predicate, #1: 1	أَنَّ الْخُرَاسَانِيِّينَ
u'أَنَّ خَرْج':Predicate, #4: 4	أَنَّ الْخَرِبَةَ
u'أَنَّ خرق':Predicate, #1: 1	أَنَّ الْخَرْجَ
u'أَنَّ خَرْقٌ':Predicate, #1: 1	أَنَّ خَرْقَ
u'أَنَّ خرق':Predicate, #1: 1	أَنَّ خَرْقَ
u'أَنَّ خَرْقٌ':Predicate, #5: 5	أَنَّ الْخَرْقَ
u'أَنَّ خرقة':Predicate, #5: 5	أَنَّ الْخَرْقَ
u'أَنَّ خِرْقَةٌ':Predicate, #1: 1	أَنَّ الْخِرْقَةَ
u'أَنَّ خُرُوجٌ':Predicate, #1: 1	أَنَّ الْخِرْقَةَ
u'أَنَّ خُرُوجٌ':Predicate, #19: 19	أَنَّ خُرُوجَ
u'أَنَّ خُرُوجٌ':Predicate, #2: 2	أَنَّ خُرُوجَهُنَّ
u'أَنَّ خُرُوقٌ':Predicate, #40: 40	أَنَّ الْخُرُوجَ
u'أَنَّ خَرِيفٌ':Predicate, #2: 2	أَنَّ الْخُرُوقَ
u'أَنَّ خَزٌّ':Predicate, #1: 1	أَنَّ الْخَرِيفَ
u'أَنَّ خُزَاعَةٌ':Predicate, #1: 1	أَنَّ الْخَزَّ
u'أَنَّ خِزَانَةٌ':Predicate, #1: 1	أَنَّ خُزَاعَةَ
u'أَنَّ خُسْران':Predicate, #1: 1	أَنَّ خِزَانَةَ
u'أَنَّ خُسُوفٌ':Predicate, #2: 2	أَنَّ الْخُسْرَانَ
u'أَنَّ خَشَبٌ':Predicate, #2: 2	أَنَّ خُسُوفَ
u'أَنَّ خَشْخاش':Predicate, #3: 3	أَنَّ الْخَشَبَ
u'أَنَّ خَشِنٌ':Predicate, #2: 2	أَنَّ الْخَشْخَاشَةَ
u'أَنَّ خُشُوعٌ':Predicate, #1: 1	أَنَّ الْخَشِنَةَ
u'أَنَّ خَشْيَةٌ':Predicate, #2: 2	أَنَّ الْخُشُوعَ
u'أَنَّ خِصاء':Predicate, #2: 2	أَنَّ خَشْيَةَ
u'أَنَّ خِصاء':Predicate, #1: 1	أَنَّ خِصَاءَ
u'أَنَّ خِصَالٌ':Predicate, #2: 2	أَنَّ الْخِصَاءَ
u'أَنَّ خَصْلَةٌ':Predicate, #2: 2	أَنَّ خِصَالَ
u'أَنَّ خَصْمٌ':Predicate, #1: 1	أَنَّ الْخَصْلَةَ
u'أَنَّ خُصُوصِيٌّ':Predicate, #21: 21	أَنَّ الْخَصْمَ
u'أَنَّ خُصُومَةٌ':Predicate, #1: 1	أَنَّ الْخُصُوصِيَّةَ
u'أَنَّ خَصِيٌّ':Predicate, #11: 11	أَنَّ الْخُصُومَةَ
u'أَنَّ خَصِيٌّ':Predicate, #1: 1	أَنَّ خَصِيَّ
u'أَنَّ خِضَابٌ':Predicate, #2: 2	أَنَّ الْخَصِيَّ
u'أَنَّ خِضَابٌ':Predicate, #1: 1	أَنَّ خِضَابَ
u'أَنَّ خضب':Predicate, #3: 3	أَنَّ الْخِضَابَ
u'أَنَّ خَضْبٌ':Predicate, #1: 1	أَنَّ خَضْبَ
u'أَنَّ خضر':Predicate, #1: 1	أَنَّ خَضْبَ
u'أَنَّ خَضِرٌ':Predicate, #3: 3	أَنَّ الْخَضِرَ
u'أَنَّ خُضْرَةٌ':Predicate, #3: 3	أَنَّ الْخَضِرَ
u'أَنَّ خَطٌّ':Predicate, #3: 3	أَنَّ الْخُضْرَةَ
u'أَنَّ خَطَأٌ':Predicate, #8: 8	أَنَّ الْخَطَّ
u'أَنَّ خَطَأٌ':Predicate, #13: 13	أَنَّ الْخَطَأَ
u'أَنَّ خِطَابٌ':Predicate, #2: 2	أَنَّ خَطَأَ
u'أَنَّ خِطَابٌ':Predicate, #25: 25	أَنَّ الْخِطَابَ
u'أَنَّ خَطْبٌ':Predicate, #6: 6	أَنَّ خِطَابَ
u'أَنَّ خُطَبٌ':Predicate, #1: 1	أَنَّ الْخَطْبَ
u'أَنَّ خُطَبٌ':Predicate, #1: 1	أَنَّ الْخُطَبَ
u'أَنَّ خطبة':Predicate, #1: 1	أَنَّ خُطَبَ
u'أَنَّ خُطْبَةٌ':Predicate, #19: 19	أَنَّ الْخُطْبَةَ
u'أَنَّ خطبة':Predicate, #19: 19	أَنَّ الْخُطْبَةَ
u'أَنَّ خُطْبَةٌ':Predicate, #2: 2	أَنَّ خُطْبَةَ
u'أَنَّ خطر':Predicate, #2: 2	أَنَّ خُطْبَةَ
u'أَنَّ خَطَرٌ':Predicate, #1: 1	أَنَّ الْخَطَرَ
u'أَنَّ خَطِيبٌ':Predicate, #1: 1	أَنَّ الْخَطَرَ
u'أَنَّ خُفٌّ':Predicate, #11: 11	أَنَّ الْخَطِيبَ
u'أَنَّ خَفَاءٌ':Predicate, #13: 13	أَنَّ الْخُفَّ
u'أَنَّ خُفَّاشٌ':Predicate, #1: 1	أَنَّ الْخَفَاءَ
u'أَنَّ خفاف':Predicate, #1: 1	أَنَّ الْخُفَّاشَ
u'أَنَّ خِفَافٌ':Predicate, #3: 3	أَنَّ الْخِفَافَ
u'أَنَّ خُفَرَاءُ':Predicate, #3: 3	أَنَّ الْخِفَافَ
u'أَنَّ خَفِيٌّ':Predicate, #1: 1	أَنَّ الْخُفَرَاءَ
u'أَنَّ خَفِيٌّ':Predicate, #1: 1	أَنَّ الْخَفِيَّ
u'أَنَّ خَلاَءٌ':Predicate, #1: 1	أَنَّ الْخَفِيَّةَ
u'أَنَّ خلاد':Predicate, #1: 1	أَنَّ الْخَلَاءَ
u'أَنَّ خِلاَفٌ':Predicate, #1: 1	أَنَّ خَلادَ
u'أَنَّ خِلاَفٌ':Predicate, #16: 16	أَنَّ خِلَافَ
u'أَنَّ خِلاَفَةٌ':Predicate, #277: 277	أَنَّ الْخِلَافَ
u'أَنَّ خِلاَفَةٌ':Predicate, #1: 1	أَنَّ الْخِلَافَةَ
u'أَنَّ خلط':Predicate, #1: 1	أَنَّ خِلَافَةَ
u'أَنَّ خلط':Predicate, #3: 3	أَنَّ خَلْطَ
u'أَنَّ خُلْعٌ':Predicate, #9: 9	أَنَّ الْخَلْطَ
u'أَنَّ خُلْعٌ':Predicate, #2: 2	أَنَّ خُلْعَ
u'أَنَّ خَلْفٌ':Predicate, #43: 43	أَنَّ الْخُلْعَ
u'أَنَّ خَلْفٌ':Predicate, #1: 1	أَنَّ الْخَلْفَ
u'أَنَّ خَلَفٌ':Predicate, #2: 2	أَنَّ خَلْفَ
u'أَنَّ خَلَفٌ':Predicate, #3: 3	أَنَّ خَلَفَ
u'أَنَّ خُلَفَاءُ':Predicate, #5: 5	أَنَّ الْخَلَفَ
u'أَنَّ خَلْفِيٌّ':Predicate, #10: 10	أَنَّ الْخُلَفَاءَ
u'أَنَّ خلق':Predicate, #3: 3	أَنَّ الْخَلْفِيَّةَ
u'أَنَّ خَلْقٌ':Predicate, #10: 10	أَنَّ الْخَلْقَ
u'أَنَّ خَلْوَةٌ':Predicate, #10: 10	أَنَّ الْخَلْقَ
u'أَنَّ خَلْوَةٌ':Predicate, #16: 16	أَنَّ الْخَلْوَةَ
u'أَنَّ خُلُوصٌ':Predicate, #3: 3	أَنَّ خَلْوَةَ
u'أَنَّ خُلُوصٌ':Predicate, #1: 1	أَنَّ الْخُلُوصَ
u'أَنَّ خَلِيطٌ':Predicate, #1: 1	أَنَّ خُلُوصَ
u'أَنَّ خَلِيفَةٌ':Predicate, #2: 2	أَنَّ الْخَلِيطَ
u'أَنَّ خَلِيلٌ':Predicate, #8: 8	أَنَّ الْخَلِيفَةَ
u'أَنَّ خَمْرٌ':Predicate, #3: 3	أَنَّ الْخَلِيلَ
u'أَنَّ خَمْسٌ':Predicate, #33: 33	أَنَّ الْخَمْرَ
u'أَنَّ خُمُسٌ':Predicate, #1: 1	أَنَّ خَمْسَ
u'أَنَّ خَمْسٌ':Predicate, #3: 3	أَنَّ خُمُسَ
u'أَنَّ خُمُسٌ':Predicate, #5: 5	أَنَّ الْخَمْسَ
u'أَنَّ خَمْسَةٌ':Predicate, #8: 8	أَنَّ الْخُمُسَ
u'أَنَّ خَمْسَةٌ':Predicate, #2: 2	أَنَّ خَمْسَةَ
u'أَنَّ خَمِيرٌ':Predicate, #9: 9	أَنَّ الْخَمْسَةَ
u'أَنَّ خِنْزِيرٌ':Predicate, #1: 1	أَنَّ الْخَمِيرَ
u'أَنَّ خُنُوثَة':Predicate, #4: 4	أَنَّ الْخِنْزِيرَ
u'أَنَّ خُوَارٌ':Predicate, #1: 1	أَنَّ الْخُنُوثَةَ
u'أَنَّ خوارج':Predicate, #1: 1	أَنَّ خُوَارَ
u'أَنَّ خَوَارِجُ':Predicate, #3: 3	أَنَّ الْخَوَارِجَ
u'أَنَّ خَوَاصُّ':Predicate, #3: 3	أَنَّ الْخَوَارِجَ
u'أَنَّ خَوَاصّ':Predicate, #1: 1	أَنَّ الْخَوَاصَّ
u'أَنَّ خَوَاصُّ':Predicate, #1: 1	أَنَّ الْخَوَاصَّ
u'أَنَّ خَوَاصّ':Predicate, #4: 4	أَنَّ خَوَاصَّ
u'أَنَّ خَوْخَةٌ':Predicate, #4: 4	أَنَّ خَوَاصَّ
u'أَنَّ خَوْضٌ':Predicate, #1: 1	أَنَّ الْخَوْخَةَ
u'أَنَّ خَوْفٌ':Predicate, #1: 1	أَنَّ خَوْضَ
u'أَنَّ خَوْفٌ':Predicate, #11: 11	أَنَّ الْخَوْفَ
u'أَنَّ خَوْلَةٌ':Predicate, #5: 5	أَنَّ خَوْفَ
u'أَنَّ خيار':Predicate, #7: 7	أَنَّ خَوْلَةَ
u'أَنَّ خِيَارٌ':Predicate, #54: 54	أَنَّ الْخِيَارَ
u'أَنَّ خيار':Predicate, #54: 54	أَنَّ الْخِيَارَ
u'أَنَّ خِيَارٌ':Predicate, #56: 56	أَنَّ خِيَارَ
u'أَنَّ خِيَاطَةٌ':Predicate, #56: 56	أَنَّ خِيَارَ
u'أَنَّ خِيَاطَةٌ':Predicate, #1: 1	أَنَّ خِيَاطَةَ
u'أَنَّ خِيَانَةٌ':Predicate, #2: 2	أَنَّ الْخِيَاطَةَ
u'أَنَّ خَيْرٌ':Predicate, #2: 2	أَنَّ الْخِيَانَةَ
u'أَنَّ خَيْرٌ':Predicate, #10: 10	أَنَّ خَيْرَ
u'أَنَّ خِيرَةٌ':Predicate, #9: 9	أَنَّ الْخَيْرَ
u'أَنَّ خِيرَةٌ':Predicate, #2: 2	أَنَّ الْخِيَرَةَ
u'أَنَّ خَيْطٌ':Predicate, #3: 3	أَنَّ الْخِيرَةَ
u'أَنَّ خَيْلٌ':Predicate, #1: 1	أَنَّ الْخَيْطَ
u'أَنَّ خَيْلٌ':Predicate, #1: 1	أَنَّ خَيْلاً
u'أَنَّ خَيْلٌ':Predicate, #2: 2	أَنَّ خَيْلَ
u'أَنَّ دَاءٌ':Predicate, #5: 5	أَنَّ الْخَيْلَ
u'أَنَّ دَابَّةٌ':Predicate, #2: 2	أَنَّ دَاءَ
u'أَنَّ دَاجِنٌ':Predicate, #15: 15	أَنَّ الدَّابَّةَ
u'أَنَّ دَاخِلٌ':Predicate, #1: 1	أَنَّ دَاجِنَةً
u'أَنَّ دَارٌ':Predicate, #14: 14	أَنَّ الدَّاخِلَ
u'أَنَّ دَارٌ':Predicate, #142: 142	أَنَّ الدَّارَ
u'أَنَّ دَاعِي':Predicate, #4: 4	أَنَّ دَارَ
u'أَنَّ دَاعِي':Predicate, #11: 11	أَنَّ الدَّاعِيَ
u'أَنَّ دَاعِي':Predicate, #1: 1	أَنَّ دَاعِيَ
u'أَنَّ دَافِعٌ':Predicate, #1: 1	أَنَّ دَاعِيَةَ
u'أَنَّ دَافِعٌ':Predicate, #1: 1	أَنَّ دَافِعَ
u'أَنَّ دَاليَةٌ':Predicate, #8: 8	أَنَّ الدَّافِعَ
u'أَنَّ دَامِي':Predicate, #1: 1	أَنَّ الدَّالِيَةَ
u'أَنَّ دَائِنٌ':Predicate, #1: 1	أَنَّ الدَّامِيَةَ
u'أَنَّ دِبَاغٌ':Predicate, #7: 7	أَنَّ الدَّائِنَ
u'أَنَّ دَبْرٌ':Predicate, #2: 2	أَنَّ الدِّبَاغَ
u'أَنَّ دَجَاجٌ':Predicate, #1: 1	أَنَّ الدَّبْرَ
u'أَنَّ دَجَّالٌ':Predicate, #2: 2	أَنَّ الدَّجَاجَ
u'أَنَّ دُخَانٌ':Predicate, #2: 2	أَنَّ الدَّجَّالَ
u'أَنَّ دُخَانٌ':Predicate, #1: 1	أَنَّ الدُّخَانَ
u'أَنَّ دُخُولٌ':Predicate, #1: 1	أَنَّ دُخَانَ
u'أَنَّ دُخُولٌ':Predicate, #1: 1	أَنَّ دُخُولَهُنَّ
u'أَنَّ دُخُولٌ':Predicate, #20: 20	أَنَّ دُخُولَ
u'أَنَّ دُرٌّ':Predicate, #24: 24	أَنَّ الدُّخُولَ
u'أَنَّ دُرٌّ':Predicate, #1: 1	أَنَّ الدُّرَّةَ
u'أَنَّ دَرْء':Predicate, #1: 1	أَنَّ دُرَّةً
u'أَنَّ دَرْء':Predicate, #1: 1	أَنَّ الدَّرْءَ
u'أَنَّ دَرَاهِمُ':Predicate, #2: 2	أَنَّ دَرْءَ
u'أَنَّ دَرَاهِمُ':Predicate, #1: 1	أَنَّ دَرَاهِمَ
u'أَنَّ دُرَّةٌ':Predicate, #41: 41	أَنَّ الدَّرَاهِمَ
u'أَنَّ درجة':Predicate, #1: 1	أَنَّ الدُّرَّةَ
u'أَنَّ دَرَجَةٌ':Predicate, #2: 2	أَنَّ دَرَجَةَ
u'أَنَّ دِرْهَمٌ':Predicate, #2: 2	أَنَّ دَرَجَةَ
u'أَنَّ دِرْهَم':Predicate, #10: 10	أَنَّ الدِّرْهَمَ
u'أَنَّ دِرْهَمٌ':Predicate, #10: 10	أَنَّ الدِّرْهَمَ
u'أَنَّ دِرْهَم':Predicate, #2: 2	أَنَّ دِرْهَمَ
u'أَنَّ دُعَاءٌ':Predicate, #2: 2	أَنَّ دِرْهَمَ
u'أَنَّ دُعَاءٌ':Predicate, #24: 24	أَنَّ الدُّعَاءَ
u'أَنَّ دَعْوَةٌ':Predicate, #5: 5	أَنَّ دُعَاءَ
u'أَنَّ دَعْوَةٌ':Predicate, #5: 5	أَنَّ الدَّعْوَةَ
u'أَنَّ دُفٌّ':Predicate, #5: 5	أَنَّ دَعْوَةَ
u'أَنَّ دَفْتَرٌ':Predicate, #2: 2	أَنَّ الدُّفَّ
u'أَنَّ دفع':Predicate, #1: 1	أَنَّ الدَّفْتَرَ
u'أَنَّ دَفْعٌ':Predicate, #27: 27	أَنَّ الدَّفْعَ
u'أَنَّ دفع':Predicate, #27: 27	أَنَّ الدَّفْعَ
u'أَنَّ دَفْعٌ':Predicate, #9: 9	أَنَّ دَفْعَ
u'أَنَّ دفعة':Predicate, #9: 9	أَنَّ دَفْعَ
u'أَنَّ دَفْعَةٌ':Predicate, #1: 1	أَنَّ الدَّفْعَةَ
u'أَنَّ دفن':Predicate, #1: 1	أَنَّ الدَّفْعَةَ
u'أَنَّ دَفْنٌ':Predicate, #1: 1	أَنَّ الدَّفْنَ
u'أَنَّ دفن':Predicate, #1: 1	أَنَّ الدَّفْنَ
u'أَنَّ دَفْنٌ':Predicate, #1: 1	أَنَّ دَفْنَ
u'أَنَّ دَفِينٌ':Predicate, #1: 1	أَنَّ دَفْنَ
u'أَنَّ دَفِين':Predicate, #1: 1	أَنَّ دَفِينَ
u'أَنَّ دَقيقٌ':Predicate, #1: 1	أَنَّ دَفِينَ
u'أَنَّ دَقيقٌ':Predicate, #2: 2	أَنَّ دَقِيقَ
u'أَنَّ دُكَّانٌ':Predicate, #4: 4	أَنَّ الدَّقِيقَ
u'أَنَّ دَكَّةٌ':Predicate, #1: 1	أَنَّ الدُّكَّانَ
u'أَنَّ دِلاءٌ':Predicate, #1: 1	أَنَّ الدَّكَّةَ
u'أَنَّ دَلالَةٌ':Predicate, #1: 1	أَنَّ الدِّلَاءَ
u'أَنَّ دَلالَةٌ':Predicate, #21: 21	أَنَّ الدَّلَالَةَ
u'أَنَّ دَلائِلُ':Predicate, #34: 34	أَنَّ دَلَالَةَ
u'أَنَّ دَلائِلُ':Predicate, #1: 1	أَنَّ الدَّلَائِلَ
u'أَنَّ دلك':Predicate, #2: 2	أَنَّ دَلَائِلَ
u'أَنَّ دَلْكٌ':Predicate, #3: 3	أَنَّ الدَّلْكَ
u'أَنَّ دَلْوٌ':Predicate, #3: 3	أَنَّ الدَّلْكَ
u'أَنَّ دُلوكٌ':Predicate, #2: 2	أَنَّ الدَّلْوَ
u'أَنَّ دَليلٌ':Predicate, #3: 3	أَنَّ الدُّلُوكَ
u'أَنَّ دَليلٌ':Predicate, #1: 1	أَنَّ الدَّلِيلِينَ
u'أَنَّ دَليلٌ':Predicate, #22: 22	أَنَّ دَلِيلَ
u'أَنَّ دَمٌ':Predicate, #51: 51	أَنَّ الدَّلِيلَ
u'أَنَّ دَمٌ':Predicate, #18: 18	أَنَّ دَمَ
u'أَنَّ دِماءٌ':Predicate, #65: 65	أَنَّ الدَّمَ
u'أَنَّ دِماءٌ':Predicate, #2: 2	أَنَّ دِمَاءَ
u'أَنَّ دِماغٌ':Predicate, #3: 3	أَنَّ الدِّمَاءَ
u'أَنَّ دِمَشْقُ':Predicate, #1: 1	أَنَّ الدِّمَاغَ
u'أَنَّ دَنٌّ':Predicate, #1: 1	أَنَّ دِمَشْقَ
u'أَنَّ دَنانيرُ':Predicate, #1: 1	أَنَّ دَنَّ
u'أَنَّ دَنانيرُ':Predicate, #10: 10	أَنَّ الدَّنَانِيرَ
u'أَنَّ دُنُوٌّ':Predicate, #1: 1	أَنَّ دَنَانِيرَ
u'أَنَّ دَهْرٌ':Predicate, #1: 1	أَنَّ دُنُوَّ
u'أَنَّ دِهْقان':Predicate, #5: 5	أَنَّ الدَّهْرَ
u'أَنَّ دُهْنٌ':Predicate, #1: 1	أَنَّ دِهْقَانَةَ
u'أَنَّ دَواءٌ':Predicate, #4: 4	أَنَّ الدُّهْنَ
u'أَنَّ دَواعِي':Predicate, #6: 6	أَنَّ الدَّوَاءَ
u'أَنَّ دَوَاعِي':Predicate, #6: 6	أَنَّ دَوَاعِيَ
u'أَنَّ دَوامٌ':Predicate, #6: 6	أَنَّ دَوَاعِيَ
u'أَنَّ دَوامٌ':Predicate, #3: 3	أَنَّ دَوَامَ
u'أَنَّ دَواوينُ':Predicate, #5: 5	أَنَّ الدَّوَامَ
u'أَنَّ دُودَةٌ':Predicate, #1: 1	أَنَّ الدَّوَاوِينَ
u'أَنَّ دُورٌ':Predicate, #8: 8	أَنَّ الدُّودَةَ
u'أَنَّ دَوْرٌ':Predicate, #2: 2	أَنَّ دُورَ
u'أَنَّ دُورٌ':Predicate, #4: 4	أَنَّ الدَّوْرَ
u'أَنَّ دَوَرانٌ':Predicate, #5: 5	أَنَّ الدُّورَ
u'أَنَّ دُولابٌ':Predicate, #1: 1	أَنَّ دَوَرَانَ
u'أَنَّ دونٌ':Predicate, #2: 2	أَنَّ الدُّولَابَ
u'أَنَّ دِيانَةٌ':Predicate, #1: 1	أَنَّ دُونَ
u'أَنَّ دِيَةٌ':Predicate, #1: 1	أَنَّ دِيَانَةَ
u'أَنَّ دِيَةٌ':Predicate, #27: 27	أَنَّ دِيَةَ
u'أَنْدِيَةٌ تَحْقِيقٌ':Added, #48: 48	أَنَّ الدِّيَةَ
u'أَنْدِيَةٌ قَوْمٌ':Added, #1: 1	أَنْدِيَةُ التَّحْقِيقِ
u'أَنَّ دَيْنٌ':Predicate, #1: 1	أَنْدِيَةِ قَوْمِهِ
u'أَنَّ دِينٌ':Predicate, #142: 142	أَنَّ الدَّيْنَ
u'أَنَّ دَيْنٌ':Predicate, #1: 1	أَنَّ دِينَكَ
u'أَنَّ دِينٌ':Predicate, #28: 28	أَنَّ دَيْنَ
u'أَنَّ دِينٌ':Predicate, #3: 3	أَنَّ دِينَ
u'أَنَّ دِينارٌ':Predicate, #6: 6	أَنَّ الدِّينَ
u'أَنَّ دِينارٌ':Predicate, #1: 1	أَنَّ دِينَارَ
u'أَنَّ دِيوانٌ':Predicate, #3: 3	أَنَّ الدِّينَارَ
u'أَنَّ دَيُّوثٌ':Predicate, #1: 1	أَنَّ الدِّيوَانَ
u'أَنَّ دُيونٌ':Predicate, #1: 1	أَنَّ الدَّيُّوثَ
u'أَنَّ دُيونٌ':Predicate, #3: 3	أَنَّ دُيُونَ
u'أَنَّ ذاكِرٌ':Predicate, #9: 9	أَنَّ الدُّيُونَ
u'أَنَّ ذاهِب':Predicate, #1: 1	أَنَّ الذَّاكِرَ
u'أَنَّ ذاهِل':Predicate, #1: 1	أَنَّ الذَّاهِبَ
u'أَنَّ ذُبابٌ':Predicate, #1: 1	أَنَّ الذَّاهِلَ
u'أَنَّ ذَبيحٌ':Predicate, #1: 1	أَنَّ الذُّبَابَ
u'أَنَّ ذَبيحٌ':Predicate, #2: 2	أَنَّ الذَّبِيحَةَ
u'أَنَّ ذَبيحَةٌ':Predicate, #4: 4	أَنَّ ذَبِيحَةَ
u'أَنَّ ذَبيحَةٌ':Predicate, #2: 2	أَنَّ الذَّبِيحَةَ
u'أَنَّ ذَرارِيٌّ':Predicate, #4: 4	أَنَّ ذَبِيحَةَ
u'أَنَّ ذَرارِيٌّ':Predicate, #1: 1	أَنَّ الذَّرَارِيَّ
u'أَنَّ ذِراعٌ':Predicate, #1: 1	أَنَّ ذَرَارِيَّ
u'أَنَّ ذِراعٌ':Predicate, #11: 11	أَنَّ الذِّرَاعَ
u'أَنَّ ذَرائِعُ':Predicate, #1: 1	أَنَّ ذِرَاعَ
u'أَنَّ ذَرْعٌ':Predicate, #4: 4	أَنَّ الذَّرَائِعَ
u'أَنْذَرَ عَلِيٌّ':Subject, #1: 1	أَنَّ الذَّرْعَ
u'أَنَّ ذُرِّيَّةٌ':Predicate, #1: 1	أَنْذَرَ عَلِيٌّ
u'أَنَّ ذَريعٌ':Predicate, #1: 1	أَنَّ الذُّرِّيَّةَ
u'أَنَّ ذَريعَةٌ':Predicate, #1: 1	أَنَّ الذَّرِيعَةَ
u'أَنَّ ذقن':Predicate, #1: 1	أَنَّ الذَّرِيعَةَ
u'أَنَّ ذَقَنٌ':Predicate, #1: 1	أَنَّ الذَّقَنَ
u'أَنَّ ذَكاةٌ':Predicate, #1: 1	أَنَّ الذَّقَنَ
u'أَنَّ ذكر':Predicate, #13: 13	أَنَّ الذَّكَاةَ
u'أَنَّ ذِكْرٌ':Predicate, #102: 102	أَنَّ ذِكْرَ
u'أَنَّ ذكر':Predicate, #102: 102	أَنَّ ذِكْرَ
u'أَنَّ ذِكْرٌ':Predicate, #10: 10	أَنَّ الذِّكْرَ
u'أَنَّ ذكر':Predicate, #10: 10	أَنَّ الذِّكْرَ
u'أَنَّ ذَكَرٌ':Predicate, #17: 17	أَنَّ الذَّكَرَ
u'أَنَّ ذكر':Predicate, #17: 17	أَنَّ الذَّكَرَ
u'أَنَّ ذَكَرٌ':Predicate, #1: 1	أَنَّ ذَكَرَ
u'أَنَّ ذُكورٌ':Predicate, #1: 1	أَنَّ ذَكَرَ
u'أَنَّ ذُكورٌ':Predicate, #1: 1	أَنَّ ذُكُورَ
u'أَنَّ ذُكورَةٌ':Predicate, #2: 2	أَنَّ الذُّكُورَ
u'أَنَّ ذُلٌّ':Predicate, #4: 4	أَنَّ الذُّكُورَةَ
u'أَنَّ ذَمٌّ':Predicate, #1: 1	أَنَّ ذُلَّ
u'أَنَّ ذَمٌّ':Predicate, #1: 1	أَنَّ ذَمَّ
u'أَنَّ ذِمَّةٌ':Predicate, #3: 3	أَنَّ الذَّمَّ
u'أَنَّ ذِمَّةٌ':Predicate, #1: 1	أَنَّ ذِمَّةَ
u'أَنَّ ذِمِّيٌّ':Predicate, #2: 2	أَنَّ الذِّمَّةَ
u'أَنَّ ذِمِّيٌّ':Predicate, #39: 39	أَنَّ الذِّمِّيَّ
u'أَنَّ ذَنَبٌ':Predicate, #6: 6	أَنَّ الذِّمِّيَّةَ
u'أَنَّ ذَنْبٌ':Predicate, #1: 1	أَنَّ الذَّنَبَ
u'أَنَّ ذَنْبٌ':Predicate, #1: 1	أَنَّ ذَنْبَ
u'أَنَّ ذُنُوبٌ':Predicate, #7: 7	أَنَّ الذَّنْبَ
u'أَنَّ ذَهَابٌ':Predicate, #5: 5	أَنَّ الذُّنُوبَ
u'أَنَّ ذَهَابٌ':Predicate, #5: 5	أَنَّ الذَّهَابَ
u'أَنَّ ذَهَبٌ':Predicate, #8: 8	أَنَّ ذَهَابَ
u'أَنَّ ذِهْنٌ':Predicate, #2: 2	أَنَّ الذَّهَبَ
u'أَنَّ ذِئْبٌ':Predicate, #1: 1	أَنَّ الذِّهْنَ
u'أَنَّ ذَيْلٌ':Predicate, #3: 3	أَنَّ الذِّئْبَ
u'أَنَّ رَابِطٌ':Predicate, #1: 1	أَنَّ ذَيْلَ
u'أَنَّ رابع':Predicate, #1: 1	أَنَّ الرَّابِطَ
u'أَنَّ رَابِعٌ':Predicate, #1: 1	أَنَّ الرَّابِعَةَ
u'أَنَّ رابع':Predicate, #1: 1	أَنَّ الرَّابِعَةَ
u'أَنَّ رَابِعٌ':Predicate, #1: 1	أَنَّ رَابِعَ
u'أَنَّ رابع':Predicate, #1: 1	أَنَّ رَابِعَ
u'أَنَّ رَابِعٌ':Predicate, #7: 7	أَنَّ الرَّابِعَ
u'أَنَّ رَاتِبٌ':Predicate, #7: 7	أَنَّ الرَّابِعَ
u'أَنَّ رَاتِب':Predicate, #2: 2	أَنَّ الرَّاتِبَ
u'أَنَّ راتِب':Predicate, #2: 2	أَنَّ الرَّاتِبَ
u'أَنَّ رَاجِحٌ':Predicate, #2: 2	أَنَّ الرَّاتِبَةَ
u'أَنَّ رَاجِزٌ':Predicate, #49: 49	أَنَّ الرَّاجِحَ
u'أَنَّ رَاجِعٌ':Predicate, #1: 1	أَنَّ الرَّاجِزَ
u'أَنَّ رَاجِي':Predicate, #3: 3	أَنَّ الرَّاجِعَ
u'أَنَّ رَاجِي':Predicate, #1: 1	أَنَّ الرَّاجِيَ
u'أَنَّ رَاحَةٌ':Predicate, #1: 1	أَنَّ رَاجِيَ
u'أَنَّ رَاحِلٌ':Predicate, #1: 1	أَنَّ رَاحَةَ
u'أَنَّ رَاحِلَةٌ':Predicate, #1: 1	أَنَّ الرَّاحِلَةَ
u'أَنَّ رَأْسٌ':Predicate, #1: 1	أَنَّ الرَّاحِلَةَ
u'أَنَّ رَأْسٌ':Predicate, #23: 23	أَنَّ رَأْسَ
u'أَنَّ رَأْسٌ':Subject, #9: 9	أَنَّ الرَّأْسَ
u'أَنَّ رَاسِخٌ':Predicate, #1: 1	أَنَّ الرَّأْسُ
u'أَنَّ رَاسِخٌ':Predicate, #1: 1	أَنَّ الرَّاسِخَ
u'أَنَّ رَاشِدٌ':Predicate, #2: 2	أَنَّ الرَّاسِخِينَ
u'أَنَّ رَاعِفٌ':Predicate, #1: 1	أَنَّ الرَّاشِدِينَ
u'أَنَّ رَاعِي':Predicate, #1: 1	أَنَّ الرَّاعِفَ
u'أَنَّ راغِب':Predicate, #1: 1	أَنَّ الرَّاعِيَ
u'أَنَّ رَافِضٌ':Predicate, #1: 1	أَنَّ الرَّاغِبَ
u'أَنَّ رَافِضَةٌ':Predicate, #1: 1	أَنَّ الرَّافِضَةَ
u'أَنَّ رَافِعٌ':Predicate, #1: 1	أَنَّ الرَّافِضَةَ
u'أَنَّ رَاكِبٌ':Predicate, #8: 8	أَنَّ رَافِعَ
u'أَنَّ رَاكِعٌ':Predicate, #6: 6	أَنَّ الرَّاكِبَ
u'أَنَّ رَامِي':Predicate, #1: 1	أَنَّ الرَّاكِعَ
u'أَنَّ رَاهِبٌ':Predicate, #4: 4	أَنَّ الرَّامِيَ
u'أَنَّ رَاهِنٌ':Predicate, #1: 1	أَنَّ الرَّاهِبَ
u'أَنَّ رَاوِي':Predicate, #40: 40	أَنَّ الرَّاهِنَ
u'أَنَّ رَاوِي':Predicate, #18: 18	أَنَّ الرَّاوِيَ
u'أَنَّ رَأْيٌ':Predicate, #2: 2	أَنَّ رَاوِيَ
u'أَنَّ رَائِحٌ':Predicate, #12: 12	أَنَّ الرَّأْيَ
u'أَنَّ رَائِحٌ':Predicate, #2: 2	أَنَّ الرَّائِحَةَ
u'أَنَّ رَائِحَةٌ':Predicate, #3: 3	أَنَّ رَائِحَةَ
u'أَنَّ رَائِحَةٌ':Predicate, #2: 2	أَنَّ الرَّائِحَةَ
u'أَنَّ رايَة':Predicate, #3: 3	أَنَّ رَائِحَةَ
u'أَنَّ رَبُّ':Predicate, #1: 1	أَنَّ رَايَةَ
u'أَنَّ رَبُّ':Predicate, #1: 1	أَنَّ رَبَّكَ
u'أَنَّ رَبُّ':Predicate, #4: 4	أَنَّ الرَّبَّ
u'أَنَّ رباط':Predicate, #50: 50	أَنَّ رَبَّ
u'أَنَّ رِبَاطٌ':Predicate, #1: 1	أَنَّ الرِّبَاطَ
u'أَنَّ رِباعٌ':Predicate, #1: 1	أَنَّ الرِّبَاطَ
u'أَنَّ رِبَاعٌ':Predicate, #1: 1	أَنَّ رِبَاعَ
u'أَنَّ رَبَائِبُ':Predicate, #1: 1	أَنَّ رِبَاعَ
u'أَنَّ رِبْحٌ':Predicate, #1: 1	أَنَّ الرَّبَائِبَ
u'أَنَّ رِبْحٌ':Predicate, #2: 2	أَنَّ رِبْحَ
u'أَنَّ رَبْعٌ':Predicate, #51: 51	أَنَّ الرِّبْحَ
u'أَنَّ رُبُعٌ':Predicate, #1: 1	أَنَّ الرَّبْعَ
u'أَنَّ رُبْعٌ':Predicate, #1: 1	أَنَّ الرُّبُعَ
u'أَنَّ رُبْعٌ':Predicate, #4: 4	أَنَّ رُبْعَ
u'أَنَّ رَبِيعٌ':Predicate, #6: 6	أَنَّ الرُّبْعَ
u'أَنَّ رَبِيعَةٌ':Predicate, #5: 5	أَنَّ الرَّبِيعَ
u'أَنَّ رُتْبَةٌ':Predicate, #4: 4	أَنَّ رَبِيعَةَ
u'أَنَّ رَجاء':Predicate, #3: 3	أَنَّ رُتْبَةَ
u'أَنَّ رَجَاءٌ':Predicate, #1: 1	أَنَّ الرَّجَاءَ
u'أَنَّ رَجاء':Predicate, #1: 1	أَنَّ الرَّجَاءَ
u'أَنَّ رَجَاءٌ':Predicate, #1: 1	أَنَّ رَجَاءَ
u'أَنَّ رِجَالٌ':Predicate, #1: 1	أَنَّ رَجَاءَ
u'أَنَّ رِجَالٌ':Predicate, #11: 11	أَنَّ رِجَالاً
u'أَنَّ رُجْحانٌ':Predicate, #8: 8	أَنَّ الرِّجَالَ
u'أَنَّ رُجْحانٌ':Predicate, #1: 1	أَنَّ رُجْحَانَ
u'أَنَّ رَجَزٌ':Predicate, #4: 4	أَنَّ الرُّجْحَانَ
u'أَنَّ رجعة':Predicate, #2: 2	أَنَّ الرَّجَزَ
u'أَنَّ رَجْعَةٌ':Predicate, #16: 16	أَنَّ الرَّجْعَةَ
u'أَنَّ رَجْعِيٌّ':Predicate, #16: 16	أَنَّ الرَّجْعَةَ
u'أَنَّ رَجْعِيٌّ':Predicate, #2: 2	أَنَّ الرَّجْعِيَّ
u'أَنَّ رَجْعِيَّةٌ':Predicate, #6: 6	أَنَّ الرَّجْعِيَّةَ
u'أَنَّ رَجُلٌ':Predicate, #6: 6	أَنَّ الرَّجْعِيَّةَ
u'أَنَّ رَجُلٌ':Predicate, #166: 166	أَنَّ الرَّجُلَ
u'أَنَّ رَجْمٌ':Predicate, #482: 482	أَنَّ رَجُلاً
u'أَنَّ رَجْمٌ':Predicate, #10: 10	أَنَّ الرَّجْمَ
u'أَنَّ رُجُوعٌ':Predicate, #1: 1	أَنَّ رَجْمَ
u'أَنَّ رُجُوعٌ':Predicate, #15: 15	أَنَّ رُجُوعَ
u'أَنَّ رَحْلٌ':Predicate, #32: 32	أَنَّ الرُّجُوعَ
u'أَنَّ رَحْلٌ':Predicate, #1: 1	أَنَّ رَحْلَ
u'أَنَّ رحلة':Predicate, #4: 4	أَنَّ الرَّحْلَ
u'أَنَّ رِحْلَةٌ':Predicate, #1: 1	أَنَّ الرِّحْلَةَ
u'أَنَّ رحم':Predicate, #1: 1	أَنَّ الرِّحْلَةَ
u'أَنَّ رَحِمٌ':Predicate, #4: 4	أَنَّ الرَّحِمَ
u'أَنَّ رحمة':Predicate, #4: 4	أَنَّ الرَّحِمَ
u'أَنَّ رَحْمَةٌ':Predicate, #1: 1	أَنَّ رَحْمَةَ
u'أَنَّ رحمة':Predicate, #1: 1	أَنَّ رَحْمَةَ
u'أَنَّ رَحْمَةٌ':Predicate, #2: 2	أَنَّ الرَّحْمَةَ
u'أَنَّ رَحْمَن':Predicate, #2: 2	أَنَّ الرَّحْمَةَ
u'أَنَّ رَحِيمٌ':Predicate, #1: 1	أَنَّ الرَّحْمَنَ
u'أَنَّ رُخَامٌ':Predicate, #1: 1	أَنَّ الرَّحِيمَ
u'أَنَّ رُخَصٌ':Predicate, #1: 1	أَنَّ الرُّخَامَ
u'أَنَّ رُخْصَةٌ':Predicate, #2: 2	أَنَّ الرُّخَصَ
u'أَنَّ رُخْصَةٌ':Predicate, #14: 14	أَنَّ الرُّخْصَةَ
u'أَنَّ رَدٌّ':Predicate, #1: 1	أَنَّ رُخْصَةَ
u'أَنَّ رَدٌّ':Predicate, #13: 13	أَنَّ رَدَّ
u'أَنَّ رِدْء':Predicate, #46: 46	أَنَّ الرَّدَّ
u'أَنَّ رَدَاءةٌ':Predicate, #1: 1	أَنَّ الرِّدْءَ
u'أَنَّ رِدَّةٌ':Predicate, #1: 1	أَنَّ الرَّدَاءَةَ
u'أَنَّ رَدِيءٌ':Predicate, #29: 29	أَنَّ الرِّدَّةَ
u'أَنَّ رِزْقٌ':Predicate, #1: 1	أَنَّ رَدِيءَ
u'أَنَّ رِزْقٌ':Predicate, #2: 2	أَنَّ رِزْقَ
u'أَنَّ رِسَالَةٌ':Predicate, #3: 3	أَنَّ الرِّزْقَ
u'أَنَّ رُسُلٌ':Predicate, #3: 3	أَنَّ الرِّسَالَةَ
u'أَنَّ رَسُولٌ':Predicate, #4: 4	أَنَّ الرُّسُلَ
u'أَنَّ رَسُولٌ':Predicate, #16: 16	أَنَّ الرَّسُولَ
u'أَنَّ رَسُولٌ':Predicate, #1: 1	أَنَّ رسُولَ
u'أَنَّ رَسُولٌ':Predicate, #2: 2	أَنَّ رَسُولَكَ
u'أَنَّ رَسُولٌ':Subject, #3531: 3531	أَنَّ رَسُولَ
u'أَنَّ رُسُومٌ':Predicate, #1: 1	أَنَّ رَسُولُ
u'أَنَّ رَشٌّ':Predicate, #1: 1	أَنَّ رُسُومَ
u'أَنَّ رُشْدٌ':Predicate, #2: 2	أَنَّ الرَّشَّ
u'أَنَّ رَشيدٌ':Predicate, #3: 3	أَنَّ الرُّشْدَ
u'أَنَّ رَشيدٌ':Predicate, #11: 11	أَنَّ الرَّشِيدَ
u'أَنَّ رَصاصٌ':Predicate, #1: 1	أَنَّ الرَّشِيدَةَ
u'أَنَّ رِضاً':Subject, #1: 1	أَنَّ رَصَاصَةً
u'أَنَّ رضاع':Predicate, #2: 2	أَنَّ رِضَاهُ
u'أَنَّ رضاع':Predicate, #11: 11	أَنَّ الرَّضَاعَ
u'أَنَّ رَضْخ':Predicate, #1: 1	أَنَّ رَضَاعَ
u'أَنَّ رَضْراض':Predicate, #1: 1	أَنَّ الرَّضْخَ
u'أَنَّ رضع':Predicate, #1: 1	أَنَّ رَضْرَاضَ
u'أَنَّ رضعة':Predicate, #1: 1	أَنَّ رَضِعَ
u'أَنَّ رَضيعٌ':Predicate, #1: 1	أَنَّ الرَّضْعَةَ
u'أَنَّ رَضيعٌ':Predicate, #1: 1	أَنَّ الرَّضِيعَ
u'أَنَّ رُطَبٌ':Predicate, #1: 1	أَنَّ الرَّضِيعَةَ
u'أَنَّ رَطْبٌ':Predicate, #12: 12	أَنَّ الرُّطَبَ
u'أَنَّ رِطْلٌ':Predicate, #7: 7	أَنَّ الرَّطْبَ
u'أَنَّ رُطوبَةٌ':Predicate, #1: 1	أَنَّ الرِّطْلَ
u'أَنَّ رُطوبَةٌ':Predicate, #2: 2	أَنَّ الرُّطُوبَةَ
u'أَنَّ رُعاَةٌ':Predicate, #2: 2	أَنَّ رُطُوبَةَ
u'أَنَّ رِعايَةٌ':Predicate, #2: 2	أَنَّ الرُّعَاةَ
u'أَنَّ رِعايَةٌ':Predicate, #1: 1	أَنَّ الرِّعَايَةَ
u'أَنَّ رَعْدٌ':Predicate, #2: 2	أَنَّ رِعَايَةَ
u'أَنَّ رَعْيٌ':Predicate, #1: 1	أَنَّ الرَّعْدَ
u'أَنَّ رَعِيَّةٌ':Predicate, #1: 1	أَنَّ رَعْيَ
u'أَنَّ رَغْبَةٌ':Predicate, #1: 1	أَنَّ الرَّعِيَّةَ
u'أَنَّ رَغيبٌ':Predicate, #3: 3	أَنَّ الرَّغْبَةَ
u'أَنَّ رَغيبَةٌ':Predicate, #1: 1	أَنَّ الرَّغِيبَةَ
u'أَنَّ رَغيفٌ':Predicate, #1: 1	أَنَّ الرَّغِيبَةَ
u'أَنَّ رَفْضٌ':Predicate, #1: 1	أَنَّ الرَّغِيفَ
u'أَنَّ رَفْعٌ':Predicate, #2: 2	أَنَّ رَفْضَ
u'أَنَّ رَفْعٌ':Predicate, #15: 15	أَنَّ الرَّفْعَ
u'أَنَّ رفقة':Predicate, #17: 17	أَنَّ رَفْعَ
u'أَنَّ رُفْقَةٌ':Predicate, #1: 1	أَنَّ الرُّفْقَةَ
u'أَنَّ رَفيقٌ':Predicate, #1: 1	أَنَّ الرُّفْقَةَ
u'أَنَّ رِقٌّ':Predicate, #1: 1	أَنَّ الرَّفِيقَ
u'أَنَّ رِقٌّ':Predicate, #28: 28	أَنَّ الرِّقَّ
u'أَنَّ رَقَبَةٌ':Predicate, #2: 2	أَنَّ رِقَّ
u'أَنَّ رَقَبَةٌ':Predicate, #5: 5	أَنَّ رَقَبَةَ
u'أَنَّ رِقَّةٌ':Predicate, #9: 9	أَنَّ الرَّقَبَةَ
u'أَنَّ رَقْمٌ':Predicate, #1: 1	أَنَّ الرِّقَّةَ
u'أَنَّ رَقْم':Predicate, #6: 6	أَنَّ الرَّقْمَ
u'أَنَّ رَقيقٌ':Predicate, #6: 6	أَنَّ الرَّقْمَ
u'أَنَّ رَقيق':Predicate, #10: 10	أَنَّ الرَّقِيقَ
u'أَنَّ رَقيقٌ':Predicate, #10: 10	أَنَّ الرَّقِيقَ
u'أَنَّ رَقيق':Predicate, #1: 1	أَنَّ رَقِيقَ
u'أَنَّ رِكاز':Predicate, #1: 1	أَنَّ رَقِيقَ
u'أَنَّ ركبة':Predicate, #4: 4	أَنَّ الرِّكَازَ
u'أَنَّ رُكْبَةٌ':Predicate, #2: 2	أَنَّ الرُّكْبَةَ
u'أَنَّ ركعة':Predicate, #2: 2	أَنَّ الرُّكْبَةَ
u'أَنَّ رَكْعَةٌ':Predicate, #10: 10	أَنَّ الرَّكْعَةَ
u'أَنَّ رُكْنٌ':Predicate, #10: 10	أَنَّ الرَّكْعَةَ
u'أَنَّ رُكْن':Predicate, #14: 14	أَنَّ الرُّكْنَ
u'أَنَّ رُكْنٌ':Predicate, #14: 14	أَنَّ الرُّكْنَ
u'أَنَّ رُكْن':Predicate, #21: 21	أَنَّ رُكْنَ
u'أَنَّ رُكْن':Predicate, #21: 21	أَنَّ رُكْنَ
u'أَنَّ رُكْن':Predicate, #2: 2	أَنَّ رُكْنِيَّةَ
u'أَنَّ رُكْنِيّ':Predicate, #3: 3	أَنَّ الرُّكْنِيَّةَ
u'أَنَّ رُكْنِيّ':Predicate, #2: 2	أَنَّ رُكْنِيَّةَ
u'أَنَّ رَكوبٌ':Predicate, #3: 3	أَنَّ الرُّكْنِيَّةَ
u'أَنَّ رُكوبٌ':Predicate, #1: 1	أَنَّ رَكُوبَ
u'أَنَّ رُكوبٌ':Predicate, #2: 2	أَنَّ رُكُوبَ
u'أَنَّ رُكوعٌ':Predicate, #3: 3	أَنَّ الرُّكُوبَ
u'أَنَّ رُكوعٌ':Predicate, #18: 18	أَنَّ الرُّكُوعَ
u'أَنَّ رَمادٌ':Predicate, #1: 1	أَنَّ رُكُوعَ
u'أَنَّ رَمادٌ':Predicate, #1: 1	أَنَّ الرَّمَادَ
u'أَنَّ رمد':Predicate, #1: 1	أَنَّ رَمَادَ
u'أَنَّ رَمَدٌ':Predicate, #2: 2	أَنَّ الرَّمَدَ
u'أَنَّ رَمَضانُ':Predicate, #2: 2	أَنَّ الرَّمَدَ
u'أَنَّ رَمَلٌ':Predicate, #7: 7	أَنَّ رَمَضَانَ
u'أَنَّ رَمْيٌ':Predicate, #2: 2	أَنَّ الرَّمَلَ
u'أَنَّ رَمْيٌ':Predicate, #15: 15	أَنَّ الرَّمْيَ
u'أَنَّ رُهْبانٌ':Predicate, #3: 3	أَنَّ رَمْيَ
u'أَنَّ رُهْبَانٌ':Predicate, #1: 1	أَنَّ رُهْبَانَ
u'أَنَّ رَهْبانِيَّةٌ':Predicate, #1: 1	أَنَّ رُهْبَانَ
u'أَنَّ رَهْطٌ':Predicate, #2: 2	أَنَّ الرَّهْبَانِيَّةَ
u'أَنَّ رَهْنٌ':Predicate, #4: 4	أَنَّ الرَّهْطَ
u'أَنَّ رَهْنٌ':Predicate, #4: 4	أَنَّ رَهْنَ
u'أَنَّ رَهينٌ':Predicate, #55: 55	أَنَّ الرَّهْنَ
u'أَنَّ رَهينَةٌ':Predicate, #1: 1	أَنَّ الرَّهِينَةَ
u'أَنَّ رُوَاةٌ':Predicate, #1: 1	أَنَّ الرَّهِينَةَ
u'أَنَّ رَواتِبُ':Predicate, #1: 1	أَنَّ الرُّوَاةَ
u'أَنَّ رَوَاتِبُ':Predicate, #1: 1	أَنَّ رَوَاتِبَ
u'أَنَّ رَواتِبُ':Predicate, #1: 1	أَنَّ رَوَاتِبَ
u'أَنَّ رَوَاتِبُ':Predicate, #3: 3	أَنَّ الرَّوَاتِبَ
u'أَنَّ رَواحٌ':Predicate, #3: 3	أَنَّ الرَّوَاتِبَ
u'أَنَّ روائح':Predicate, #3: 3	أَنَّ الرَّوَاحَ
u'أَنَّ رَوائِحُ':Predicate, #1: 1	أَنَّ الرَّوَائِحَ
u'أَنَّ رَوَائِحُ':Predicate, #1: 1	أَنَّ الرَّوَائِحَ
u'أَنَّ رِوايَةٌ':Predicate, #1: 1	أَنَّ الرَّوَائِحَ
u'أَنَّ رِوايَةٌ':Predicate, #31: 31	أَنَّ الرِّوَايَةَ
u'أَنَّ رَوْثٌ':Predicate, #37: 37	أَنَّ رِوَايَةَ
u'أَنَّ روحٌ':Predicate, #1: 1	أَنَّ الرَّوْثَ
u'أَنَّ روحٌ':Predicate, #10: 10	أَنَّ الرُّوحَ
u'أَنَّ روحٌ':Predicate, #1: 1	أَنَّ رُوحَ
u'أَنَّ رَوْحٌ':Predicate, #2: 2	أَنَّ رَوْحَ
u'أَنَّ رَوْشَن':Predicate, #2: 2	أَنَّ رَوْحَ
u'أَنَّ رَوْضَةٌ':Predicate, #1: 1	أَنَّ الرَّوْشَنَ
u'أَنَّ رُومٌ':Predicate, #1: 1	أَنَّ الرَّوْضَةَ
u'أَنَّ رُؤْيَا':Subject, #3: 3	أَنَّ الرُّومَ
u'أَنَّ رُؤْيَةٌ':Predicate, #1: 1	أَنَّ رُؤْيَاهُ
u'أَنَّ رُؤْيَةٌ':Predicate, #12: 12	أَنَّ رُؤْيَةَ
u'أَنَّ رِياحٌ':Predicate, #5: 5	أَنَّ الرُّؤْيَةَ
u'أَنَّ رِياضَةٌ':Predicate, #1: 1	أَنَّ الرِّيَاحَ
u'أَنَّ رِيبَةٌ':Predicate, #2: 2	أَنَّ الرِّيَاضَةَ
u'أَنَّ ريحٌ':Predicate, #2: 2	أَنَّ الرِّيبَةَ
u'أَنَّ رَيْحانٌ':Predicate, #9: 9	أَنَّ الرِّيحَ
u'أَنَّ رِيشٌ':Predicate, #1: 1	أَنَّ الرَّيْحَانَ
u'أَنَّ ريعٌ':Predicate, #1: 1	أَنَّ الرِّيشَ
u'أَنَّ رَيْعٌ':Predicate, #1: 1	أَنَّ الرَّيْعَ
u'أَنَّ ريعٌ':Predicate, #1: 1	أَنَّ الرَّيْعَ
u'أَنَّ رِيقٌ':Predicate, #4: 4	أَنَّ الرِّيعَ
u'أَنَّ زاجِرٌ':Predicate, #1: 1	أَنَّ الرِّيقَ
u'أَنَّ زَارِعٌ':Predicate, #1: 1	أَنَّ الزَّاجِرَ
u'أَنْزَالٌ أرْضٌ':Added, #1: 1	أَنَّ الزَّارِعَ
u'أَنْزَالٌ كَرْمٌ':Added, #2: 2	أَنْزَالِ الْأَرْضِ
u'أَنْزَالٌ كُرُومٌ':Added, #1: 1	أَنْزَالَ كَرْمٍ
u'أَنَّ زانِي':Predicate, #1: 1	أَنْزَالَ الْكُرُومِ
u'أَنَّ زانِي':Predicate, #2: 2	أَنَّ الزَّانِيَةَ
u'أَنَّ زاي':Predicate, #6: 6	أَنَّ الزَّانِيَ
u'أَنَّ زائِدٌ':Predicate, #1: 1	أَنَّ الزَّايَ
u'أَنَّ زائِدٌ':Predicate, #22: 22	أَنَّ الزَّائِدَ
u'أَنَّ زائِغٌ':Predicate, #3: 3	أَنَّ الزَّائِدَةَ
u'أَنَّ زائِغٌ':Predicate, #1: 1	أَنَّ الزَّائِغَ
u'أَنَّ زائِلٌ':Predicate, #1: 1	أَنَّ الزَّائِغَةَ
u'أَنَّ زَبيبٌ':Predicate, #1: 1	أَنَّ الزَّائِلَ
u'أَنَّ زَجَّاجٌ':Predicate, #3: 3	أَنَّ الزَّبِيبَ
u'أَنَّ زَجْرٌ':Predicate, #1: 1	أَنَّ الزَّجَّاجَ
u'أَنَّ زِحامٌ':Predicate, #4: 4	أَنَّ الزَّجْرَ
u'أَنَّ زِرٌّ':Predicate, #1: 1	أَنَّ الزِّحَامَ
u'أَنَّ زِراعَةٌ':Predicate, #1: 1	أَنَّ زِرَّ
u'أَنَّ زَرافَةٌ':Predicate, #1: 1	أَنَّ الزِّرَاعَةَ
u'أَنَّ زَرْعٌ':Predicate, #1: 1	أَنَّ الزَّرَافَةَ
u'أَنَّ زَرْعٌ':Predicate, #26: 26	أَنَّ الزَّرْعَ
u'أَنَّ زَريعَةٌ':Predicate, #2: 2	أَنَّ زَرْعَ
u'أَنَّ زَعامَةٌ':Predicate, #1: 1	أَنَّ الزَّرِيعَةَ
u'أَنَّ زَعْفَرانٌ':Predicate, #1: 1	أَنَّ الزَّعَامَةَ
u'أَنَّ زَعْمٌ':Predicate, #3: 3	أَنَّ الزَّعْفَرَانَ
u'أَنَّ زَعيمٌ':Predicate, #3: 3	أَنَّ زَعْمَ
u'أَنَّ زُفَرٌ':Predicate, #2: 2	أَنَّ الزَّعِيمَ
u'أَنَّ زِقٌّ':Predicate, #8: 8	أَنَّ زُفَرَ
u'أَنَّ زِقاقٌ':Predicate, #1: 1	أَنَّ الزِّقَّ
u'أَنَّ زَكاةٌ':Predicate, #1: 1	أَنَّ الزِّقَاقَ
u'أَنَّ زَكاةٌ':Predicate, #61: 61	أَنَّ الزَّكَاةَ
u'أَنْزَلَ آدَمُ':Predicate, #7: 7	أَنَّ زَكَاةَ
u'أَنْزَلَ أَرْبَعُ':Predicate, #1: 1	أَنْزَلَ آدَمَ
u'أَنْزَلَ اللهُ':Subject, #1: 1	أَنْزَلَ أَرْبَعَ
u'أَنْزَلَ إِنْجيلٌ':Predicate, #2: 2	أَنْزَلَ اللهُ
u'أَنْزَلَ أيَّامٌ':Predicate, #8: 8	أَنْزَلَ الْإِنْجِيلَ
u'أَنْزَلَ أَيَّامٌ':Predicate, #1: 1	أَنْزَلَ الْأَيَّامَ
u'أَنْزَلَ بَلاءٌ':Predicate, #1: 1	أَنْزَلَ الْأَيَّامَ
u'أَنْزَلَ تَحْرِيمٌ':Predicate, #1: 1	أَنْزَلَ الْبَلَاءَ
u'أَنْزَلَ تَوْرَاةٌ':Predicate, #3: 3	أَنْزَلَ تَحْرِيمَ
u'أَنْزَلَ حَطَبٌ':Predicate, #17: 17	أَنْزَلَ التَّوْرَاةَ
u'أَنْزَلَ حَقٌّ':Predicate, #1: 1	أَنْزَلَ الْحَطَبَ
u'أَنْزَلَ دَاءٌ':Predicate, #1: 1	أَنْزَلَ الْحَقَّ
u'أَنْزَلَ دَواءٌ':Predicate, #5: 5	أَنْزَلَ الدَّاءَ
u'أَنْزَلَ رحمة':Predicate, #1: 1	أَنْزَلَ الدَّوَاءَ
u'أَنْزَلَ رَحْمَةٌ':Predicate, #1: 1	أَنْزَلَ الرَّحْمَةَ
u'أَنْزَلَ رَحْمَن':Subject, #1: 1	أَنْزَلَ الرَّحْمَةَ
u'أَنْزَلَ رَسُولٌ':Subject, #1: 1	أَنْزَلَ الرَّحْمَنُ
u'أَنْزَلَ رَغْبَةٌ':Predicate, #1: 1	أَنْزَلَ رَسُولُ
u'أَنْزَلَ سَكِينَةٌ':Predicate, #1: 1	أَنْزَلَ الرَّغْبَةَ
u'أَنْزَلَ سُورَةٌ':Predicate, #1: 1	أَنْزَلَ السَّكِينَةَ
u'أَنْزَلَ شَرِيعَةٌ':Predicate, #2: 2	أَنْزَلَ سُورَةَ
u'أَنْزَلَ شِفَاءٌ':Predicate, #1: 1	أَنْزَلَ الشَّرِيعَةَ
u'أَنْزَلَ صَبِيٌّ':Subject, #1: 1	أَنْزَلَ الشِّفَاءَ
u'أَنْزَلَ عند':Predicate, #1: 1	أَنْزَلَ الصَّبِيُّ
u'أَنْزَلَ فلان':Subject, #1: 1	أَنْزَلَ عِنْدَ
u'أَنْزَلَ قُرْآنٌ':Predicate, #1: 1	أَنْزَلَ الرَّحْمَنُ
u'أَنْزَلَ كِتَابٌ':Predicate, #4: 4	أَنْزَلَ الْقُرْآنَ
u'أَنْزَلَ كُتُبٌ':Predicate, #3: 3	أَنْزَلَ الْكِتَابَ
u'أَنْزَلَ كُفَّارٌ':Predicate, #1: 1	أَنْزَلَ الْكُتُبَ
u'أَنْزَلَ لَمْسٌ':Predicate, #1: 1	أَنْزَلَ الْكُفّارَ
u'أَنْزَلَ مَطَرٌ':Predicate, #1: 1	أَنْزَلَ اللَّمْسَ
u'أَنْزَلَ مَنِيٌّ':Predicate, #2: 2	أَنْزَلَ الْمَطَرَ
u'أَنْزَلَ نَبِيٌّ':Subject, #2: 2	أَنْزَلَ الْمَنِيَّ
u'أَنْزَلَ وَجَبٌ':Predicate, #1: 1	أَنْزَلَ النَّبِيُّ
u'أَنْزَلَ وَفْدٌ':Predicate, #2: 2	أَنْزَلَ وَجَبَ
u'أَنَّ زَمانٌ':Predicate, #4: 4	أَنْزَلَ وَفْدَ
u'أَنَّ زَمانٌ':Predicate, #3: 3	أَنَّ زَمَانَ
u'أَنَّ زمر':Predicate, #6: 6	أَنَّ الزَّمَانَ
u'أَنَّ زَمْرٌ':Predicate, #1: 1	أَنَّ زَمْرَ
u'أَنَّ زَمَنٌ':Predicate, #1: 1	أَنَّ زَمْرَ
u'أَنَّ زَمَنٌ':Predicate, #1: 1	أَنَّ الزَّمَنَ
u'أَنَّ زناة':Predicate, #6: 6	أَنَّ زَمَنَ
u'أَنَّ زَنادِقَةٌ':Predicate, #1: 1	أَنَّ الزُّنَاةَ
u'أَنَّ زِنَة':Predicate, #1: 1	أَنَّ الزَّنَادِقَةَ
u'أَنَّ زِنْديقٌ':Predicate, #1: 1	أَنَّ زِنَةَ
u'أَنَّ زَوالٌ':Predicate, #2: 2	أَنَّ الزِّنْدِيقَ
u'أَنَّ زَوائِدُ':Predicate, #18: 18	أَنَّ زَوَالَ
u'أَنَّ زَوائِدُ':Predicate, #1: 1	أَنَّ الزَّوَائِدَ
u'أَنَّ زَوْجٌ':Predicate, #2: 2	أَنَّ زَوَائِدَ
u'أَنَّ زَوْجٌ':Predicate, #15: 15	أَنَّ زَوْجَ
u'أَنَّ زَوْجَةٌ':Predicate, #173: 173	أَنَّ الزَّوْجَ
u'أَنَّ زَوْجَةٌ':Predicate, #21: 21	أَنَّ الزَّوْجَةَ
u'أَنَّ زَوْجِيٌّ':Predicate, #6: 6	أَنَّ زَوْجَةَ
u'أَنَّ زِيادَةٌ':Predicate, #6: 6	أَنَّ الزَّوْجِيَّةَ
u'أَنَّ زِيادَةٌ':Predicate, #113: 113	أَنَّ الزِّيَادَةَ
u'أَنَّ زِيارَةٌ':Predicate, #24: 24	أَنَّ زِيَادَةَ
u'أَنَّ زِيارَةٌ':Predicate, #2: 2	أَنَّ الزِّيَارَةَ
u'أَنَّ زَيْتٌ':Predicate, #2: 2	أَنَّ زِيَارَةَ
u'أَنَّ زَيْتونٌ':Predicate, #5: 5	أَنَّ الزَّيْتَ
u'أَنَّ زَيْدٌ':Predicate, #1: 1	أَنَّ الزَّيْتُونَ
u'أَنَّ زَيْغ':Predicate, #55: 55	أَنَّ زَيْدَ
u'أَنَّ زَيْغٌ':Predicate, #1: 1	أَنَّ زَيْغَةَ
u'أَنَّ زَيْنَبٌ':Predicate, #3: 3	أَنَّ الزَّيْغَ
u'أَنَّ زُيوفٌ':Predicate, #21: 21	أَنَّ زَيْنَبَ
u'أَنَّ زُيُوفٌ':Predicate, #5: 5	أَنَّ الزُّيُوفَ
u'أَنَّ س':Predicate, #5: 5	أَنَّ الزُّيُوفَ
u'أَنَّ سابّ':Predicate, #1: 1	أَنَّ السِّينَ
u'أَنَّ سابّ':Predicate, #2: 2	أَنَّ السَّابَّ
u'أَنْسَابٌ بَطْنٌ':Added, #2: 2	أَنَّ سَابَّ
u'أَنْسَابٌ بَعْضٌ':Added, #1: 1	أَنْسَابُ الْبَطْنِ
u'أَنَّ سَابِحٌ':Predicate, #1: 1	أَنْسَابِ بَعْضِ
u'أَنْسَابٌ شِعْبٌ':Added, #1: 1	أَنَّ السَّابِحَ
u'أَنْسَابٌ عَرَبٌ':Added, #1: 1	أَنْسَابُ الشِّعْبِ
u'أَنْسَابٌ عَرَبٌ':Added, #1: 1	أَنْسَابَ الْعَرَبِ
u'أَنْسَابٌ عِمَارَةٌ':Added, #1: 1	أَنْسَابُ الْعَرَبِ
u'أَنَّ سابِغ':Predicate, #1: 1	أَنْسَابُ الْعِمَارَةِ
u'أَنْسَابٌ فلان':Added, #1: 1	أَنَّ السَّابِغَ
u'أَنَّ سَابِقٌ':Predicate, #2: 2	أَنْسَابِ الزُّبَيْرِ
u'أَنَّ سَابِقٌ':Predicate, #2: 2	أَنَّ السَّابِقَةَ
u'أَنْسَابٌ قَبَائِلُ':Added, #8: 8	أَنَّ السَّابِقَ
u'أَنْسَابٌ قُرَيْشٌ':Added, #1: 1	أَنْسَابُ الْقَبَائِلِ
u'أَنْسَابٌ نَاسٌ':Added, #5: 5	أَنْسَابِ قُرَيْشٍ
u'أَنَّ سَاتِرٌ':Predicate, #2: 2	أَنْسَابَ النَّاسِ
u'أَنَّ سَاجِدٌ':Predicate, #1: 1	أَنَّ السَّاتِرَ
u'أَنَّ سَاحِرٌ':Predicate, #3: 3	أَنَّ السَّاجِدَ
u'أَنَّ سَاحِرٌ':Predicate, #1: 1	أَنَّ السَّاحِرَةَ
u'أَنَّ سادس':Predicate, #3: 3	أَنَّ السَّاحِرَ
u'أَنَّ سَادِسٌ':Predicate, #1: 1	أَنَّ سَادِسَ
u'أَنَّ سَارِقٌ':Predicate, #1: 1	أَنَّ سَادِسَ
u'أَنَّ سَارِي':Predicate, #18: 18	أَنَّ السَّارِقَ
u'أَنَّ سَاعَةٌ':Predicate, #2: 2	أَنَّ السَّارِيَ
u'أَنَّ سَاعَةٌ':Predicate, #1: 1	أَنَّ سَاعَةَ
u'أَنَّ سَاعِي':Predicate, #5: 5	أَنَّ السَّاعَةَ
u'أَنَّ سَاقِطٌ':Predicate, #16: 16	أَنَّ السَّاعِيَ
u'أَنَّ سَاقِطٌ':Predicate, #1: 1	أَنَّ سَاقِطَةَ
u'أَنَّ سَاقِي':Predicate, #2: 2	أَنَّ السَّاقِطَ
u'أَنَّ سَاكِتٌ':Predicate, #1: 1	أَنَّ السَّاقِيَ
u'أَنَّ سَاكِتٌ':Predicate, #1: 1	أَنَّ السَّاكِتِينَ
u'أَنَّ سَاكِنٌ':Predicate, #4: 4	أَنَّ السَّاكِتَ
u'أَنَّ سَالِبٌ':Predicate, #2: 2	أَنَّ السَّاكِنَ
u'أَنَّ سَالِمٌ':Predicate, #1: 1	أَنَّ السَّالِبَةَ
u'أَنَّ سَامِرٌ':Predicate, #8: 8	أَنَّ سَالِمَ
u'أَنَّ سَامِعٌ':Predicate, #1: 1	أَنَّ سَامِرَ
u'أَنَّ سَامِعٌ':Predicate, #1: 1	أَنَّ السَّامِعَ
u'أَنَّ سَاهِرٌ':Predicate, #2: 2	أَنَّ سَامِعَ
u'أَنَّ سَاهِي':Predicate, #1: 1	أَنَّ سَاهِرَ
u'أَنَّ سَائِبٌ':Predicate, #4: 4	أَنَّ السَّاهِيَ
u'أَنَّ سَائِبٌ':Predicate, #1: 1	أَنَّ سَائِبَةً
u'أَنَّ سَائِرٌ':Predicate, #7: 7	أَنَّ السَّائِبَ
u'أَنَّ سَائِقٌ':Predicate, #25: 25	أَنَّ سَائِرَ
u'أَنَّ سائِل':Predicate, #2: 2	أَنَّ السَّائِقَ
u'أَنَّ سَائِلٌ':Predicate, #16: 16	أَنَّ السَّائِلَ
u'أَنَّ سائِل':Predicate, #16: 16	أَنَّ السَّائِلَ
u'أَنَّ سَائِلٌ':Predicate, #3: 3	أَنَّ سَائِلاً
u'أَنَّ سَائِمَةٌ':Predicate, #3: 3	أَنَّ سَائِلاً
u'أَنَّ سَبٌّ':Predicate, #1: 1	أَنَّ السَّائِمَةَ
u'أَنَّ سَبَّابٌ':Predicate, #3: 3	أَنَّ سَبَّ
u'أَنَّ سَبَّابَةٌ':Predicate, #2: 2	أَنَّ السَّبَّابَةَ
u'أَنَّ سِباعٌ':Predicate, #2: 2	أَنَّ السَّبَّابَةَ
u'أَنَّ سَبَبٌ':Predicate, #2: 2	أَنَّ السِّبَاعَ
u'أَنَّ سَبَبٌ':Predicate, #127: 127	أَنَّ سَبَبَ
u'أَنَّ سَبَبِيَّةٌ':Predicate, #97: 97	أَنَّ السَّبَبَ
u'أَنَّ سَبَبِيَّةٌ':Predicate, #2: 2	أَنَّ سَبَبِيَّةَ
u'أَنَّ سَبْتٌ':Predicate, #8: 8	أَنَّ السَّبَبِيَّةَ
u'أَنَّ سَبْرٌ':Predicate, #2: 2	أَنَّ السَّبْتَ
u'أَنَّ سُبْعٌ':Predicate, #4: 4	أَنَّ السَّبْرَ
u'أَنَّ سَبُعٌ':Predicate, #1: 1	أَنَّ سُبْعَ
u'أَنَّ سَبْعٌ':Predicate, #2: 2	أَنَّ السَّبُعَ
u'أَنَّ سَبْعَةٌ':Predicate, #6: 6	أَنَّ السَّبْعَ
u'أَنَّ سَبْعَةٌ':Predicate, #1: 1	أَنَّ سَبْعَةَ
u'أَنَّ سَبْقٌ':Predicate, #3: 3	أَنَّ السَّبْعَةَ
u'أَنَّ سَبَقٌ':Predicate, #2: 2	أَنَّ سَبْقَ
u'أَنَّ سَبْقٌ':Predicate, #3: 3	أَنَّ السَّبَقَ
u'أَنَّ سَبْكٌ':Predicate, #4: 4	أَنَّ السَّبْقَ
u'أَنَّ سَبْيٌ':Predicate, #1: 1	أَنَّ السَّبْكَ
u'أَنَّ سَبِيكةٌ':Predicate, #7: 7	أَنَّ السَّبْيَ
u'أَنَّ سَبِيلٌ':Predicate, #2: 2	أَنَّ سَبِيكَةَ
u'أَنَّ سَبِيلٌ':Predicate, #1: 1	أَنَّ سَبِيلَ
u'أَنَّ سِتٌّ':Predicate, #4: 4	أَنَّ السَّبِيلَ
u'أَنَّ سِتٌّ':Predicate, #1: 1	أَنَّ السِّتَّ
u'أَنَّ سِتٌّ':Predicate, #2: 2	أَنَّ السِّتَّةَ
u'أَنَّ سِتٌّ':Predicate, #2: 2	أَنَّ سِتَّةَ
u'أَنَّ سَتْرٌ':Predicate, #4: 4	أَنَّ سِتَّةً
u'أَنَّ سِتْرٌ':Predicate, #13: 13	أَنَّ سَتْرَ
u'أَنَّ سَتْرٌ':Predicate, #1: 1	أَنَّ سِتْرَ
u'أَنَّ سِتْرٌ':Predicate, #2: 2	أَنَّ السَّتْرَ
u'أَنَّ سترة':Predicate, #5: 5	أَنَّ السِّتْرَ
u'أَنَّ سِتْرَةٌ':Predicate, #1: 1	أَنَّ سِتْرَةَ
u'أَنَّ سترة':Predicate, #1: 1	أَنَّ سِتْرَةَ
u'أَنَّ سُتْرَةٌ':Predicate, #3: 3	أَنَّ السُّتْرَةَ
u'أَنَّ سترة':Predicate, #3: 3	أَنَّ السُّتْرَةَ
u'أَنَّ سُتْرَةٌ':Predicate, #3: 3	أَنَّ سُتْرَةَ
u'أَنَّ سجدة':Predicate, #3: 3	أَنَّ سُتْرَةَ
u'أَنَّ سَجْدَةٌ':Predicate, #9: 9	أَنَّ السَّجْدَةَ
u'أَنَّ سجدة':Predicate, #9: 9	أَنَّ السَّجْدَةَ
u'أَنَّ سَجْدَةٌ':Predicate, #9: 9	أَنَّ سَجْدَةَ
u'أَنَّ سِجْنٌ':Predicate, #9: 9	أَنَّ سَجْدَةَ
u'أَنَّ سُجُودٌ':Predicate, #1: 1	أَنَّ السِّجْنَ
u'أَنَّ سُجُودٌ':Predicate, #12: 12	أَنَّ سُجُودَ
u'أَنَّ سُحْتٌ':Predicate, #23: 23	أَنَّ السُّجُودَ
u'أَنَّ سَحَرٌ':Predicate, #1: 1	أَنَّ السُّحْتَ
u'أَنَّ سِحْرٌ':Predicate, #1: 1	أَنَّ السَّحَرَ
u'أَنَّ سَحَرَةٌ':Predicate, #7: 7	أَنَّ السِّحْرَ
u'أَنَّ سَحَرَةٌ':Predicate, #1: 1	أَنَّ السَّحَرَةَ
u'أَنَّ سَحُورٌ':Predicate, #1: 1	أَنَّ سَحَرَةَ
u'أَنَّ سُحُورٌ':Predicate, #1: 1	أَنَّ السَّحُورَ
u'أَنَّ سَخَاءٌ':Predicate, #2: 2	أَنَّ السُّحُورَ
u'أَنَّ سَخْلَة':Predicate, #1: 1	أَنَّ السَّخَاءَ
u'أَنَّ سَدٌّ':Predicate, #1: 1	أَنَّ السَّخْلَةَ
u'أَنَّ سَدٌّ':Predicate, #1: 1	أَنَّ السَّدَّ
u'أَنَّ سِدْرٌ':Predicate, #3: 3	أَنَّ سَدَّ
u'أَنَّ سِرٌّ':Predicate, #1: 1	أَنَّ السِّدْرَ
u'أَنَّ سِرٌّ':Predicate, #1: 1	أَنَّ سِرَّ
u'أَنَّ سَرَابِيلُ':Predicate, #2: 2	أَنَّ السِّرَّ
u'أَنَّ سراح':Predicate, #1: 1	أَنَّ السَّرَابِيلَ
u'أَنَّ سَرَاحٌ':Predicate, #1: 1	أَنَّ السَّرَاحَ
u'أَنَّ سرب':Predicate, #1: 1	أَنَّ السَّرَاحَ
u'أَنَّ سِرْبٌ':Predicate, #1: 1	أَنَّ السِّرْبَ
u'أَنَّ سُرَّةٌ':Predicate, #1: 1	أَنَّ السِّرْبَ
u'أَنَّ سَرْجٌ':Predicate, #6: 6	أَنَّ السُّرَّةَ
u'أَنَّ سَرْدٌ':Predicate, #1: 1	أَنَّ السَّرْجَ
u'أَنَّ سِرْدَابٌ':Predicate, #2: 2	أَنَّ سَرْدَ
u'آنَسَ رُشْدٌ':Predicate, #2: 2	أَنَّ السِّرْدَابَ
u'أَنَّ سَرَف':Predicate, #1: 1	آنَسَ الرُّشْدَ
u'أُنْسٌ رَفيقٌ':Added, #2: 2	أَنَّ السَّرَفَ
u'أَنَّ سَرقَةٌ':Predicate, #1: 1	أُنْسُ رَفِيقِ
u'أَنَّ سَرِقَةٌ':Predicate, #15: 15	أَنَّ السَّرِقَةَ
u'أَنَّ سَرقَةٌ':Predicate, #15: 15	أَنَّ السَّرِقَةَ
u'أَنَّ سَرِقَةٌ':Predicate, #2: 2	أَنَّ سَرِقَةَ
u'أَنَّ سُرُورٌ':Predicate, #2: 2	أَنَّ سَرِقَةَ
u'أَنَّ سَرِيٌّ':Predicate, #1: 1	أَنَّ السُّرُورَ
u'أَنَّ سَرِيٌّ':Predicate, #1: 1	أَنَّ سَرِيَّةً
u'أَنَّ سَرَيَانٌ':Predicate, #4: 4	أَنَّ السَّرِيَّةَ
u'أَنَّ سَرِيَّةٌ':Predicate, #1: 1	أَنَّ السَّرَيَانَ
u'أَنَّ سَرِيرٌ':Predicate, #4: 4	أَنَّ السَّرِيَّةَ
u'أُنْسٌ صَدِيقٌ':Added, #1: 1	أَنَّ السَّرِيرَ
u'أَنَّ سَطْحٌ':Predicate, #1: 1	أُنْسِ الصَّدِيقِ
u'أَنَّ سَطْحٌ':Predicate, #2: 2	أَنَّ السَّطْحَ
u'أَنَّ سِعَايَةٌ':Predicate, #3: 3	أَنَّ سَطْحَ
u'أَنَّ سَعَةٌ':Predicate, #4: 4	أَنَّ السِّعَايَةَ
u'أَنَّ سَعْدٌ':Predicate, #1: 1	أَنَّ سَعَةَ
u'أَنَّ سعر':Predicate, #38: 38	أَنَّ سَعْدَ
u'أَنَّ سِعْرٌ':Predicate, #1: 1	أَنَّ السِّعْرَ
u'أَنَّ سَعِيدٌ':Predicate, #1: 1	أَنَّ السِّعْرَ
u'أَنَّ سَفَرٌ':Predicate, #50: 50	أَنَّ سَعِيدَ
u'أَنَّ سَفَرٌ':Predicate, #24: 24	أَنَّ السَّفَرَ
u'أَنَّ سَفْرَةٌ':Predicate, #2: 2	أَنَّ سَفَرَ
u'أَنَّ سُفْلٌ':Predicate, #2: 2	أَنَّ السَّفْرَةَ
u'أَنَّ سَفِلَةٌ':Predicate, #3: 3	أَنَّ السُّفْلَ
u'أَنَّ سفهاء':Predicate, #1: 1	أَنَّ السَّفِلَةَ
u'أَنَّ سَفِينَةٌ':Predicate, #1: 1	أَنَّ السُّفَهَاءَ
u'أَنَّ سَفِيهٌ':Predicate, #3: 3	أَنَّ السَّفِينَةَ
u'أَنَّ سَقَّاءٌ':Predicate, #17: 17	أَنَّ السَّفِيهَ
u'أَنَّ سقط':Predicate, #1: 1	أَنَّ السَّقَّاءَ
u'أَنَّ سِقْطٌ':Predicate, #3: 3	أَنَّ السِّقْطَ
u'أَنَّ سَقْفٌ':Predicate, #3: 3	أَنَّ السِّقْطَ
u'أَنَّ سَقْفٌ':Predicate, #1: 1	أَنَّ سَقْفَ
u'أَنَّ سُقُوطٌ':Predicate, #3: 3	أَنَّ السَّقْفَ
u'أَنَّ سُقُوطٌ':Predicate, #12: 12	أَنَّ سُقُوطَ
u'أَنَّ سَقْيٌ':Predicate, #7: 7	أَنَّ السُّقُوطَ
u'أَنَّ سَقْيٌ':Predicate, #1: 1	أَنَّ سَقْيَ
u'أَنَّ سُكَّانٌ':Predicate, #9: 9	أَنَّ السَّقْيَ
u'أَنَّ سُكَّانٌ':Predicate, #1: 1	أَنَّ السُّكَّانَ
u'أَنَّ سِكَّةٌ':Predicate, #1: 1	أَنَّ سُكَّانَ
u'أَنَّ سكر':Predicate, #2: 2	أَنَّ السِّكَّةَ
u'أَنَّ سُكْرٌ':Predicate, #6: 6	أَنَّ السُّكْرَ
u'أَنَّ سَكْرَان':Predicate, #6: 6	أَنَّ السُّكْرَ
u'أَنَّ سَكَنْجَبِين':Predicate, #12: 12	أَنَّ السَّكْرَانَ
u'أَنَّ سُكُوتٌ':Predicate, #1: 1	أَنَّ السَّكَنْجَبِينَ
u'أَنَّ سُكُوتٌ':Predicate, #10: 10	أَنَّ سُكُوتَ
u'أَنَّ سَكِينَةٌ':Predicate, #16: 16	أَنَّ السُّكُوتَ
u'أَنَّ سِلاَحٌ':Predicate, #2: 2	أَنَّ السَّكِينَةَ
u'أَنَّ سلام':Predicate, #1: 1	أَنَّ السِّلَاحَ
u'أَنَّ سَلاَمٌ':Predicate, #12: 12	أَنَّ سَلَامَ
u'أَنَّ سلام':Predicate, #12: 12	أَنَّ سَلَامَ
u'أَنَّ سَلاَمٌ':Predicate, #26: 26	أَنَّ السَّلَامَ
u'أَنَّ سَلاَمَةٌ':Predicate, #26: 26	أَنَّ السَّلَامَ
u'أَنَّ سَلاَمَةٌ':Predicate, #2: 2	أَنَّ سَلامَةَ
u'أَنَّ سَلاَمَةٌ':Predicate, #2: 2	أَنَّ سَلَامَةَ
u'أَنَّ سَلَبٌ':Predicate, #4: 4	أَنَّ السَّلَامَةَ
u'أَنَّ سَلْبٌ':Predicate, #1: 1	أَنَّ السَّلَبَ
u'أَنَّ سَلَسٌ':Predicate, #1: 1	أَنَّ سَلْبَ
u'أَنَّ سُلْطَانٌ':Predicate, #2: 2	أَنَّ سَلَسَ
u'أَنَّ سِلْعَةٌ':Predicate, #25: 25	أَنَّ السُّلْطَانَ
u'أَنَّ سَلَفٌ':Predicate, #5: 5	أَنَّ السِّلْعَةَ
u'أَنَّ سَلَفٌ':Predicate, #1: 1	أَنَّ سَلَفَ
u'أَنَّ سَلَمٌ':Predicate, #25: 25	أَنَّ السَّلَفَ
u'أَنَّ سُلَّمٌ':Predicate, #15: 15	أَنَّ السَّلَمَ
u'أَنَّ سلمة':Predicate, #1: 1	أَنَّ السُّلَّمَ
u'أَنَّ سَلِيمٌ':Predicate, #12: 12	أَنَّ سَلَمَةَ
u'أَنَّ سَمَاءٌ':Predicate, #1: 1	أَنَّ سَلِيمَ
u'أَنَّ سَمَاعٌ':Predicate, #3: 3	أَنَّ السَّمَاءَ
u'أَنَّ سَمَاعٌ':Predicate, #2: 2	أَنَّ سَمَاعَ
u'أَنَّ سَمَاوِيٌّ':Predicate, #4: 4	أَنَّ السَّمَاعَ
u'أَنَّ سِمَةٌ':Predicate, #1: 1	أَنَّ السَّمَاوِيَّ
u'أَنَّ سمرة':Predicate, #2: 2	أَنَّ السِّمَةَ
u'أَنَّ سِمْسَارٌ':Predicate, #5: 5	أَنَّ سَمُرَةَ
u'أَنَّ سَمْعٌ':Predicate, #2: 2	أَنَّ السِّمْسَارَ
u'أَنَّ سَمَكٌ':Predicate, #4: 4	أَنَّ السَّمْعَ
u'أَنَّ سَمَكٌ':Predicate, #1: 1	أَنَّ السَّمَكَ
u'أَنَّ سَمَكٌ':Predicate, #1: 1	أَنَّ السَّمَكَةَ
u'أَنَّ سَمْنٌ':Predicate, #1: 1	أَنَّ سَمَكَةً
u'أَنَّ سَمْنٌ':Predicate, #1: 1	أَنَّ سَمْنَ
u'أَنَّ سُمُومٌ':Predicate, #3: 3	أَنَّ السَّمْنَ
u'أَنَّ سِنٌّ':Predicate, #1: 1	أَنَّ السُّمُومَ
u'أَنَّ سِنٌّ':Predicate, #1: 1	أَنَّ السِّنَّ
u'أَنَّ سُنَّةٌ':Predicate, #5: 5	أَنَّ سِنَّ
u'أَنَّ سُنَّةٌ':Predicate, #102: 102	أَنَّ السُّنَّةَ
u'أَنَّ سَنَةٌ':Predicate, #12: 12	أَنَّ سُنَّةَ
u'أَنَّ سَنَدٌ':Predicate, #8: 8	أَنَّ السَّنَةَ
u'أَنَّ سنن':Predicate, #4: 4	أَنَّ السَّنَدَ
u'أَنَّ سنن':Predicate, #2: 2	أَنَّ سُنَنَ
u'أَنَّ سِنَّوْرٌ':Predicate, #3: 3	أَنَّ السُّنَنَ
u'أَنَّ سُنِّيٌّ':Predicate, #1: 1	أَنَّ السِّنَّوْرَ
u'أَنَّ سُنِّيٌّ':Predicate, #1: 1	أَنَّ السُّنِّيَّ
u'أَنَّ سهام':Predicate, #1: 1	أَنَّ سُنِّيَّةَ
u'أَنَّ سِهَامٌ':Predicate, #3: 3	أَنَّ سِهَامَ
u'أَنَّ سَهْلٌ':Predicate, #3: 3	أَنَّ سِهَامَ
u'أَنَّ سَهْلٌ':Predicate, #14: 14	أَنَّ سَهْلَ
u'أَنَّ سَهْلٌ':Predicate, #1: 1	أَنَّ سَهْلاً
u'أَنَّ سَهْمٌ':Predicate, #2: 2	أَنَّ سَهْلَةَ
u'أَنَّ سَهْمٌ':Predicate, #12: 12	أَنَّ السَّهْمَ
u'أَنَّ سَهْمٌ':Predicate, #2: 2	أَنَّ سَهْمَكَ
u'أَنَّ سَهْوٌ':Predicate, #6: 6	أَنَّ سَهْمَ
u'أَنَّ سُهَيْلٌ':Predicate, #10: 10	أَنَّ السَّهْوَ
u'أَنَّ سُوءٌ':Predicate, #1: 1	أَنَّ سُهَيْلَ
u'أَنَّ سَوادٌ':Predicate, #5: 5	أَنَّ سُوءَ
u'أَنَّ سِواكٌ':Predicate, #8: 8	أَنَّ السَّوَادَ
u'أَنَّ سُؤَالٌ':Predicate, #4: 4	أَنَّ السِّوَاكَ
u'أَنَّ سُؤَالٌ':Predicate, #10: 10	أَنَّ سُؤَالَ
u'أَنَّ سَوائِمُ':Predicate, #18: 18	أَنَّ السُّؤَالَ
u'أَنَّ سَوَائِمُ':Predicate, #1: 1	أَنَّ السَّوَائِمَ
u'أَنَّ سود':Predicate, #1: 1	أَنَّ السَّوَائِمَ
u'أَنَّ سُودٌ':Predicate, #1: 1	أَنَّ السُّودَ
u'أَنَّ سَوْداء':Predicate, #1: 1	أَنَّ السُّودَ
u'أَنَّ سُؤْرٌ':Predicate, #1: 1	أَنَّ السَّوْدَاءَ
u'أَنَّ سورٌ':Predicate, #1: 1	أَنَّ السُّؤْرَ
u'أَنَّ سُؤْرٌ':Predicate, #2: 2	أَنَّ السُّورَ
u'أَنَّ سُورَةٌ':Predicate, #9: 9	أَنَّ سُؤْرَ
u'أَنَّ سُورَةٌ':Predicate, #10: 10	أَنَّ السُّورَةَ
u'أَنَّ سَوِيق':Predicate, #8: 8	أَنَّ سُورَةَ
u'أَنَّ سِياسَةٌ':Predicate, #3: 3	أَنَّ السَّوِيقَ
u'أَنَّ سِياقٌ':Predicate, #3: 3	أَنَّ السِّيَاسَةَ
u'أَنَّ سِياقٌ':Predicate, #3: 3	أَنَّ السِّيَاقَ
u'أَنَّ سَيِّدٌ':Predicate, #5: 5	أَنَّ سِيَاقَ
u'أَنَّ سَيِّدٌ':Predicate, #4: 4	أَنَّ سَيِّدَ
u'أَنَّ سِيَرٌ':Predicate, #51: 51	أَنَّ السَّيِّدَ
u'أَنَّ سَيْرٌ':Predicate, #1: 1	أَنَّ السِّيَرَ
u'أَنْسَى شِدَّةٌ':Predicate, #2: 2	أَنَّ سَيْرَ
u'أَنْسَى عَوْم':Predicate, #2: 2	أَنْسَى شِدَّةَ
u'أَنَّ سَيْفٌ':Predicate, #1: 1	أَنْسَى الْعَوْمَ
u'أَنَّ سَيْفٌ':Predicate, #2: 2	أَنَّ سَيْفَ
u'أَنْسَى قول':Predicate, #5: 5	أَنَّ السَّيْفَ
u'أَنْسَى قَوْلٌ':Predicate, #2: 2	أَنْسَى قَوْلَ
u'أَنَّ سَيَلانٌ':Predicate, #2: 2	أَنْسَى قَوْلَ
u'أَنَّ سَيَلانٌ':Predicate, #1: 1	أَنَّ سَيَلَانَ
u'أَنَّ سِين':Predicate, #3: 3	أَنَّ السَّيَلَانَ
u'أَنَّ سُيوفٌ':Predicate, #1: 1	أَنَّ السِّينَ
u'أَنَّ سَيِّئٌ':Predicate, #1: 1	أَنَّ سُيُوفَ
u'أَنْشَأَ إجَارَةٌ':Predicate, #1: 1	أَنَّ سَيِّئَةَ
u'أَنْشَأَ إِحْرَامٌ':Predicate, #1: 1	أَنْشَأَ الْإِجَارَةَ
u'أَنْشَأَ إِحْرَامٌ':Predicate, #1: 1	أَنْشَأَ إحْرَامَ
u'أَنْشَأَ أَمْرٌ':Predicate, #3: 3	أَنْشَأَ الْإِحْرَامَ
u'أَنْشَأَ إِيدَاعٌ':Predicate, #1: 1	أَنْشَأَ الْأَمْرَ
u'أَنَّ شَابٌّ':Predicate, #1: 1	أَنْشَأَ الْإِيدَاعَ
u'أَنَّ شَابٌّ':Predicate, #1: 1	أَنَّ الشَّابَّةَ
u'أَنَّ شَاةٌ':Predicate, #5: 5	أَنَّ الشَّابَّ
u'أَنَّ شَاةٌ':Subject, #29: 29	أَنَّ الشَّاةَ
u'أَنْشَأَ تَدْبِيرٌ':Predicate, #1: 1	أَنَّ شَاةٌ
u'أَنْشَأَ تَلْبيَةٌ':Predicate, #1: 1	أَنْشَأَ تَدْبِيرَ
u'أَنْشَأَ تَوْكِيلٌ':Predicate, #2: 2	أَنْشَأَ التَّلْبِيَةَ
u'أَنْشَأَ حَجٌّ':Predicate, #1: 1	أَنْشَأَ التَّوْكِيلَ
u'أَنْشَأَ خُصُومَةٌ':Predicate, #2: 2	أَنْشَأَ الْحَجَّ
u'أَنَّ شاذَرْوان':Predicate, #1: 1	أَنْشَأَ الْخُصُومَةَ
u'أَنَّ شَارِبٌ':Predicate, #1: 1	أَنَّ الشَّاذَرْوَانَ
u'أَنْشَأَ رَجُلٌ':Subject, #3: 3	أَنَّ الشَّارِبَ
u'أَنَّ شَارِحٌ':Predicate, #1: 1	أَنْشَأَ رَجُلٌ
u'أَنَّ شَارِحٌ':Predicate, #1: 1	أَنَّ شَارِحَ
u'أَنَّ شَارِعٌ':Predicate, #8: 8	أَنَّ الشَّارِحَ
u'أَنَّ شَارِعٌ':Predicate, #1: 1	أَنَّ شَارِعَ
u'أَنْشَأَ سَفَرٌ':Predicate, #62: 62	أَنَّ الشَّارِعَ
u'أَنْشَأَ سَفَرٌ':Predicate, #16: 16	أَنْشَأَ السَّفَرَ
u'أَنْشَأَ صَلاَةٌ':Predicate, #4: 4	أَنْشَأَ سَفَرَ
u'أَنْشَأَ طَلاَقٌ':Predicate, #1: 1	أَنْشَأَ الصَّلَاةَ
u'أَنْشَأَ عتق':Predicate, #3: 3	أَنْشَأَ الطَّلَاقَ
u'أَنْشَأَ عِتْقٌ':Predicate, #2: 2	أَنْشَأَ الْعِتْقَ
u'أَنَّ شَاعِر':Predicate, #2: 2	أَنْشَأَ الْعِتْقَ
u'أَنْشَأَ عَقْدٌ':Predicate, #2: 2	أَنَّ الشَّاعِرَ
u'أَنْشَأَ فَسْخٌ':Predicate, #1: 1	أَنْشَأَ الْعَقْدَ
u'أَنَّ شافِع':Predicate, #1: 1	أَنْشَأَ الْفَسْخَ
u'أَنْشَأَ فِعْلٌ':Predicate, #4: 4	أَنَّ الشَّافِعِيَّةَ
u'أَنَّ شافِعِيّ':Predicate, #1: 1	أَنْشَأَ الْفِعْلَ
u'أَنَّ شافِعِيّ':Predicate, #135: 135	أَنَّ الشَّافِعِيَّ
u'أَنَّ شَافِي':Predicate, #4: 4	أَنَّ الشَّافِعِيَّةَ
u'أَنْشَأَ كِتَابَةٌ':Predicate, #4: 4	أَنَّ الشَّافِيَ
u'أَنْشَأَ مُسَافِرٌ':Subject, #1: 1	أَنْشَأَ الْكِتَابَةَ
u'أَنَّ شَامِيٌّ':Predicate, #1: 1	أَنْشَأَ مُسَافِرٌ
u'أَنَّ شَأْنٌ':Predicate, #1: 1	أَنَّ الشَّامِيَّ
u'أَنَّ شَأْنٌ':Predicate, #2: 2	أَنَّ الشَّأْنَ
u'أَنْشَأَ نَاسٌ':Subject, #4: 4	أَنَّ شَأْنَ
u'أَنْشَأَ نذر':Predicate, #1: 1	أَنْشَأَ نَاسٌ
u'أَنْشَأَ نَذْرٌ':Predicate, #1: 1	أَنْشَأَ النَّذْرَ
u'أَنَّ شَاهِدٌ':Predicate, #1: 1	أَنْشَأَ النَّذْرَ
u'أَنَّ شَاهِدٌ':Predicate, #1: 1	أَنَّ شَاهِدِينَ
u'أَنَّ شَاهِدٌ':Predicate, #3: 3	أَنَّ شَاهِدَ
u'أَنْشَأَ وَدِيعٌ':Predicate, #66: 66	أَنَّ الشَّاهِدَ
u'أَنْشَأَ وَدِيعَةٌ':Predicate, #2: 2	أَنْشَأَ الْوَدِيعَةَ
u'أَنَّ شَائِعٌ':Predicate, #2: 2	أَنْشَأَ الْوَدِيعَةَ
u'أَنَّ شَبابٌ':Predicate, #1: 1	أَنَّ الشَّائِعَ
u'أَنَّ شَبَابٌ':Predicate, #1: 1	أَنَّ الشَّبَابَ
u'أَنَّ شَبّابَة':Predicate, #1: 1	أَنَّ الشَّبَابَ
u'أَنَّ شَبَابِيكُ':Predicate, #2: 2	أَنَّ الشَّبَّابَةَ
u'أَنَّ شُبَّانٌ':Predicate, #1: 1	أَنَّ الشَّبَابِيكَ
u'أَنَّ شِبْرٌ':Predicate, #1: 1	أَنَّ الشُّبَّانَ
u'أَنَّ شِبْلٌ':Predicate, #1: 1	أَنَّ الشِّبْرَ
u'أَنَّ شِبْهٌ':Predicate, #2: 2	أَنَّ شِبْلَ
u'أَنَّ شَبَهٌ':Predicate, #3: 3	أَنَّ شِبْهَ
u'أَنَّ شُبْهَةٌ':Predicate, #5: 5	أَنَّ الشَّبَهَ
u'أَنَّ شُبْهَةٌ':Predicate, #18: 18	أَنَّ الشُّبْهَةَ
u'أَنَّ شَتْمٌ':Predicate, #9: 9	أَنَّ شُبْهَةَ
u'أَنَّ شجاع':Predicate, #1: 1	أَنَّ الشَّتْمَ
u'أَنَّ شجَاعٌ':Predicate, #1: 1	أَنَّ الشُّجَاعَ
u'أَنَّ شجَاعٌ':Predicate, #1: 1	أَنَّ الشُّجَاعَ
u'أَنَّ شَجَاعَةٌ':Predicate, #1: 1	أَنَّ الشَّجَاعَةَ
u'أَنَّ شَجَّةٌ':Predicate, #1: 1	أَنَّ الشَّجَاعَةَ
u'أَنَّ شَجَرٌ':Predicate, #4: 4	أَنَّ الشَّجَّةَ
u'أَنَّ شَجَرٌ':Predicate, #3: 3	أَنَّ شَجَرَ
u'أَنَّ شَجَرَةٌ':Predicate, #9: 9	أَنَّ الشَّجَرَ
u'أَنَّ شَجَرَةٌ':Predicate, #1: 1	أَنَّ شَجَرَةَ
u'أَنَّ شُحٌّ':Predicate, #5: 5	أَنَّ الشَّجَرَةَ
u'أَنَّ شَحْمٌ':Predicate, #1: 1	أَنَّ الشُّحَّ
u'أَنَّ شَحْمٌ':Predicate, #1: 1	أَنَّ الشَّحْمَ
u'أَنَّ شُحُومٌ':Predicate, #2: 2	أَنَّ شَحْمَ
u'أَنَّ شَخْصٌ':Predicate, #1: 1	أَنَّ الشُّحُومَ
u'أَنَّ شَخْصِيٌّ':Predicate, #14: 14	أَنَّ الشَّخْصَ
u'أَنَّ شَدٌّ':Predicate, #1: 1	أَنَّ الشَّخْصِيَّ
u'أَنْشَدَ اِبْنٌ':Subject, #3: 3	أَنَّ الشَّدَّ
u'أَنْشَدَ أرْبَابٌ':Subject, #3: 3	أَنْشَدَ ابْنُ
u'أَنْشَدَ بَعْضٌ':Subject, #1: 1	أَنْشَدَ أَرْبَابُ
u'أَنَّ شِدَّةٌ':Predicate, #1: 1	أَنْشَدَ بَعْضُ
u'أَنَّ شِدَّةٌ':Predicate, #1: 1	أَنَّ شِدَّةَ
u'أَنْشَدَ ثَعْلَبٌ':Subject, #2: 2	أَنَّ الشِّدَّةَ
u'أَنْشَدَ رَسُولٌ':Predicate, #1: 1	أَنْشَدَ ثَعْلَبٌ
u'أَنْشَدَ شافِعِيّ':Subject, #1: 1	أَنْشَدَ رَسُولَ
u'أَنْشَدَ عُمَرٌ':Subject, #1: 1	أَنْشَدَ الشَّافِعِيُّ
u'أَنْشَدَ فَقِيهٌ':Subject, #1: 1	أَنْشَدَ عُمَرُ
u'أَنْشَدَ فلان':Subject, #1: 1	أَنْشَدَ فَقِيهُ
u'أَنْشَدَ كَعْبٌ':Subject, #1: 1	أَنْشَدَ الشَّافِعِيُّ
u'أَنْشَدَ لقطة':Predicate, #3: 3	أَنْشَدَ كَعْبُ
u'أَنْشَدَ مَحْمُودٌ':Subject, #1: 1	أَنْشَدَ اللُّقَطَةَ
u'أَنْشَدَ نَبِيٌّ':Predicate, #1: 1	أَنْشَدَ مَحْمُودٌ
u'أَنَّ شَرٌّ':Predicate, #1: 1	أَنْشَدَ النَّبِيَّ
u'أَنَّ شَرٌّ':Predicate, #2: 2	أَنَّ شَرَّ
u'أَنَّ شِرَاءٌ':Predicate, #3: 3	أَنَّ الشَّرَّ
u'أَنَّ شِرَاءٌ':Predicate, #24: 24	أَنَّ شِرَاءَ
u'أَنَّ شُرَّابٌ':Predicate, #33: 33	أَنَّ الشِّرَاءَ
u'أَنَّ شَرَابٌ':Predicate, #16: 16	أَنَّ الشُّرَّابَ
u'أَنَّ شُرَّاحٌ':Predicate, #1: 1	أَنَّ الشَّرَابَ
u'أَنَّ شَرَائِطُ':Predicate, #1: 1	أَنَّ شُرَّاحَ
u'أَنَّ شَرَائِطُ':Predicate, #3: 3	أَنَّ الشَّرَائِطَ
u'أَنَّ شَرَائِعُ':Predicate, #6: 6	أَنَّ شَرَائِطَ
u'أَنَّ شَرَائِعُ':Predicate, #1: 1	أَنَّ شَرَائِعَ
u'أَنَّ شرب':Predicate, #4: 4	أَنَّ الشَّرَائِعَ
u'أَنَّ شرب':Predicate, #5: 5	أَنَّ الشُّرْبَ
u'أَنَّ شُرْبٌ':Predicate, #5: 5	أَنَّ الشِّرْبَ
u'أَنَّ شِرْبٌ':Predicate, #5: 5	أَنَّ الشُّرْبَ
u'أَنَّ شرب':Predicate, #5: 5	أَنَّ الشِّرْبَ
u'أَنَّ شُرْبٌ':Predicate, #8: 8	أَنَّ شُرْبَ
u'أَنَّ شربة':Predicate, #8: 8	أَنَّ شُرْبَ
u'أَنَّ شَرَبَةٌ':Predicate, #1: 1	أَنَّ شَرَبَةَ
u'أَنَّ شَرَج':Predicate, #1: 1	أَنَّ شَرَبَةَ
u'أَنَّ شَرْطٌ':Predicate, #1: 1	أَنَّ الشَّرَجَ
u'أَنَّ شَرْطٌ':Predicate, #147: 147	أَنَّ شَرْطَ
u'أَنَّ شَرَطٌ':Predicate, #173: 173	أَنَّ الشَّرْطَ
u'أَنَّ شَرَطٌ':Predicate, #1: 1	أَنَّ الشَّرَطَ
u'أَنَّ شَرْعٌ':Predicate, #1: 1	أَنَّ شَرَطَ
u'أَنَّ شَرْعٌ':Predicate, #18: 18	أَنَّ شَرْعَ
u'أَنْشَرَ عَظْمٌ':Predicate, #89: 89	أَنَّ الشَّرْعَ
u'أَنَّ شَرْعِيٌّ':Predicate, #2: 2	أَنْشَرَ الْعَظْمَ
u'أَنَّ شَرْعِيٌّ':Predicate, #2: 2	أَنَّ الشَّرْعِيَّ
u'أَنَّ شَرْعِيٌّ':Predicate, #4: 4	أَنَّ الشَّرْعِيَّةَ
u'أَنَّ شرف':Predicate, #4: 4	أَنَّ شَرْعِيَّةَ
u'أَنَّ شَرَفٌ':Predicate, #2: 2	أَنَّ شَرَفَ
u'أَنَّ شرق':Predicate, #2: 2	أَنَّ شَرَفَ
u'أَنَّ شَرْقٌ':Predicate, #1: 1	أَنَّ شَرْقَ
u'أَنَّ شَرَكٌ':Predicate, #1: 1	أَنَّ شَرْقَ
u'أَنَّ شركاء':Predicate, #1: 1	أَنَّ الشَّرَكَ
u'أَنَّ شركة':Predicate, #3: 3	أَنَّ الشُّرَكَاءَ
u'أَنَّ شَرِكَةٌ':Predicate, #18: 18	أَنَّ الشَّرِكَةَ
u'أَنَّ شركة':Predicate, #18: 18	أَنَّ الشَّرِكَةَ
u'أَنَّ شِرْكَةٌ':Predicate, #1: 1	أَنَّ الشِّرْكَةَ
u'أَنَّ شركة':Predicate, #1: 1	أَنَّ الشِّرْكَةَ
u'أَنَّ شَرِكَةٌ':Predicate, #9: 9	أَنَّ شَرِكَةَ
u'أَنَّ شُرُوطٌ':Predicate, #9: 9	أَنَّ شَرِكَةَ
u'أَنَّ شُرُوطٌ':Predicate, #10: 10	أَنَّ الشُّرُوطَ
u'أَنَّ شُرُوعٌ':Predicate, #11: 11	أَنَّ شُرُوطَ
u'آنَ شُرُوعٌ':Subject, #20: 20	أَنَّ الشُّرُوعَ
u'أَنَّ شَرِيعَةٌ':Predicate, #1: 1	آنَ الشُّرُوعُ
u'أَنَّ شَرِيعَةٌ':Predicate, #12: 12	أَنَّ الشَّرِيعَةَ
u'أَنَّ شَرِيفٌ':Predicate, #3: 3	أَنَّ شَرِيعَةَ
u'أَنَّ شَرِيقٌ':Predicate, #1: 1	أَنَّ الشَّرِيفَةَ
u'أَنَّ شَرِيكٌ':Predicate, #1: 1	أَنَّ شَرِيقَ
u'أَنَّ شَرِيكٌ':Predicate, #23: 23	أَنَّ الشَّرِيكَ
u'أَنَّ شَطْرٌ':Predicate, #3: 3	أَنَّ شَرِيكَ
u'أَنَّ شَطْرٌ':Predicate, #1: 1	أَنَّ الشَّطْرَ
u'أَنَّ شِطْرَنْجٌ':Predicate, #2: 2	أَنَّ شَطْرَ
u'أَنَّ شَعَائِرُ':Predicate, #2: 2	أَنَّ الشِّطْرَنْجَ
u'أَنَّ شَعَائِرُ':Predicate, #1: 1	أَنَّ شَعَائِرَ
u'أَنَّ شُعْبَةٌ':Predicate, #2: 2	أَنَّ الشَّعَائِرَ
u'أَنَّ شَعْبِيٌّ':Predicate, #7: 7	أَنَّ شُعْبَةَ
u'أَنَّ شعث':Predicate, #2: 2	أَنَّ الشَّعْبِيَّ
u'أَنَّ شَعْرٌ':Predicate, #1: 1	أَنَّ الشُّعْثَ
u'أَنَّ شَعَرٌ':Predicate, #12: 12	أَنَّ الشَّعْرَ
u'أَنَّ شِعْرٌ':Predicate, #2: 2	أَنَّ الشَّعَرَ
u'أَنَّ شَعْرٌ':Predicate, #5: 5	أَنَّ الشِّعْرَ
u'أَنَّ شُعرَاءُ':Predicate, #7: 7	أَنَّ شَعْرَ
u'أَنَّ شُعَرَاءُ':Predicate, #1: 1	أَنَّ الشُّعَرَاءَ
u'أَنَّ شُعُوبٌ':Predicate, #1: 1	أَنَّ الشُّعَرَاءَ
u'أَنَّ شَعِيرٌ':Predicate, #2: 2	أَنَّ الشُّعُوبَ
u'أَنَّ شِفَاءٌ':Predicate, #3: 3	أَنَّ الشَّعِيرَ
u'أَنَّ شَفْرَةٌ':Predicate, #4: 4	أَنَّ الشِّفَاءَ
u'أَنَّ شَفْعٌ':Predicate, #1: 1	أَنَّ الشَّفْرَةَ
u'أَنَّ شفعة':Predicate, #9: 9	أَنَّ الشَّفْعَ
u'أَنَّ شُفْعَةٌ':Predicate, #23: 23	أَنَّ الشُّفْعَةَ
u'أَنَّ شفق':Predicate, #23: 23	أَنَّ الشُّفْعَةَ
u'أَنَّ شَفَقٌ':Predicate, #3: 3	أَنَّ الشَّفَقَ
u'أَنَّ شَفِيعٌ':Predicate, #3: 3	أَنَّ الشَّفَقَ
u'أَنَّ شَقٌّ':Predicate, #51: 51	أَنَّ الشَّفِيعَ
u'أَنَّ شَقٌّ':Predicate, #3: 3	أَنَّ الشَّقَّ
u'أَنَّ شُقَّةٌ':Predicate, #4: 4	أَنَّ شَقَّ
u'أَنَّ شَقِيقٌ':Predicate, #1: 1	أَنَّ الشُّقَّةَ
u'أَنَّ شَكٌّ':Predicate, #3: 3	أَنَّ الشَّقِيقَ
u'أَنَّ شكر':Predicate, #31: 31	أَنَّ الشَّكَّ
u'أَنَّ شُكْرٌ':Predicate, #1: 1	أَنَّ شُكْرَ
u'أَنَّ شَلَبِيّ':Predicate, #1: 1	أَنَّ شُكْرَ
u'أَنَّ شمال':Predicate, #1: 1	أَنَّ الشَّلَبِيَّ
u'أَنَّ شَمَالٌ':Predicate, #1: 1	أَنَّ الشَّمَالَ
u'أَنَّ شمس':Predicate, #1: 1	أَنَّ الشَّمَالَ
u'أَنَّ شَمْسٌ':Predicate, #3: 3	أَنَّ شَمْسَ
u'أَنَّ شمس':Predicate, #3: 3	أَنَّ شَمْسَ
u'أَنَّ شَمْسٌ':Predicate, #52: 52	أَنَّ الشَّمْسَ
u'أَنَّ شُمُول':Predicate, #52: 52	أَنَّ الشَّمْسَ
u'أَنَّ شُمُول':Predicate, #1: 1	أَنَّ الشُّمُولَ
u'أَنَّ شَهَادَةٌ':Predicate, #1: 1	أَنَّ شُمُولَ
u'أَنَّ شَهَادَةٌ':Predicate, #108: 108	أَنَّ الشَّهَادَةَ
u'أَنَّ شَهَادَةٌ':Predicate, #2: 2	أَنَّ شَهَادَتَهُنَّ
u'أَنَّ شهداء':Predicate, #54: 54	أَنَّ شَهَادَةَ
u'أَنَّ شَهْرٌ':Predicate, #1: 1	أَنَّ شُهَدَاءَ
u'أَنَّ شهرة':Predicate, #20: 20	أَنَّ الشَّهْرَ
u'أَنَّ شُهْرَةٌ':Predicate, #1: 1	أَنَّ الشُّهْرَةَ
u'أَنَّ شَهْوَةٌ':Predicate, #1: 1	أَنَّ الشُّهْرَةَ
u'أَنَّ شَهْوَةٌ':Predicate, #1: 1	أَنَّ شَهْوَةَ
u'أَنَّ شُهُودٌ':Predicate, #5: 5	أَنَّ الشَّهْوَةَ
u'أَنَّ شُهُودٌ':Predicate, #18: 18	أَنَّ شُهُودَ
u'أَنَّ شَهِيدٌ':Predicate, #68: 68	أَنَّ الشُّهُودَ
u'أَنَّ شَهِيدٌ':Predicate, #5: 5	أَنَّ شَهِيدَ
u'أَنَّ شَوّاء':Predicate, #7: 7	أَنَّ الشَّهِيدَ
u'أَنَّ شَوْكَةٌ':Predicate, #1: 1	أَنَّ الشَّوَّاءَ
u'أَنَّ شَيْءٌ':Predicate, #1: 1	أَنَّ الشَّوْكَةَ
u'أَنَّ شَيَاطِينُ':Predicate, #35: 35	أَنَّ الشَّيْءَ
u'أَنَّ شَيْخٌ':Predicate, #2: 2	أَنَّ الشَّيَاطِينَ
u'أَنَّ شَيْخٌ':Predicate, #2: 2	أَنَّ شَيْخَ
u'أَنَّ شَيْخُوخَةٌ':Predicate, #64: 64	أَنَّ الشَّيْخَ
u'أَنَّ شِيرازِيّ':Predicate, #2: 2	أَنَّ الشَّيْخُوخَةَ
u'أَنَّ شَيْطَانٌ':Predicate, #1: 1	أَنَّ الشِّيرَازِيَّ
u'أَنَّ شُيُوخٌ':Predicate, #15: 15	أَنَّ الشَّيْطَانَ
u'أَنْصَابٌ حَرَمٌ':Added, #1: 1	أَنَّ شُيُوخَ
u'أَنْصَابٌ حَرَمٌ':Added, #1: 1	أَنْصَابُ الْحَرَمِ
u'أَنَّ صَابِئٌ':Predicate, #1: 1	أَنْصَابِ الْحَرَمِ
u'أَنَّ صَاحِبٌ':Predicate, #2: 2	أَنَّ الصَّابِئِينَ
u'أَنَّ صَاحِبٌ':Predicate, #1: 1	أَنَّ صَاحِبَةَ
u'أَنَّ صَاحِبٌ':Predicate, #1: 1	أَنَّ صَاحِبَكَ
u'أَنَّ صَادِرٌ':Predicate, #238: 238	أَنَّ صَاحِبَ
u'أَنَّ صَادِقٌ':Predicate, #4: 4	أَنَّ الصَّادِرَ
u'أَنَّ صَادِقٌ':Predicate, #1: 1	أَنَّ الصَّادِقِينَ
u'أَنَّ صَاعٌ':Predicate, #3: 3	أَنَّ الصَّادِقَ
u'أَنَّ صَاعٌ':Predicate, #1: 1	أَنَّ صَاعَ
u'أَنَّ صَالِحٌ':Predicate, #7: 7	أَنَّ الصَّاعَ
u'أَنَّ صَالِح':Predicate, #1: 1	أَنَّ صَالِحَ
u'أَنَّ صَالِحٌ':Predicate, #1: 1	أَنَّ صَالِحَ
u'أَنَّ صَالِح':Predicate, #2: 2	أَنَّ الصَّالِحَ
u'أَنَّ صَانِعٌ':Predicate, #2: 2	أَنَّ الصَّالِحَ
u'أَنَّ صَانِعٌ':Predicate, #1: 1	أَنَّ الصَّانِعَ
u'أَنَّ صَائِحٌ':Predicate, #1: 1	أَنَّ صَانِعَ
u'أَنَّ صَائِغٌ':Predicate, #1: 1	أَنَّ الصَّائِحَ
u'أَنَّ صَائِمٌ':Predicate, #1: 1	أَنَّ الصَّائِغَ
u'أَنَّ صَبٌّ':Predicate, #11: 11	أَنَّ الصَّائِمَ
u'أَنَّ صَبَّاغٌ':Predicate, #5: 5	أَنَّ الصَّبَّ
u'أَنَّ صِبَاغَةٌ':Predicate, #3: 3	أَنَّ الصَّبَّاغَ
u'أَنَّ صُبْحٌ':Predicate, #1: 1	أَنَّ الصِّبَاغَةَ
u'أَنَّ صبر':Predicate, #10: 10	أَنَّ الصُّبْحَ
u'أَنَّ صَبْرٌ':Predicate, #8: 8	أَنَّ الصَّبْرَ
u'أَنَّ صبرة':Predicate, #8: 8	أَنَّ الصَّبْرَ
u'أَنَّ صُبْرَةٌ':Predicate, #4: 4	أَنَّ الصُّبْرَةَ
u'أَنَّ صِبْغٌ':Predicate, #4: 4	أَنَّ الصُّبْرَةَ
u'أَنَّ صَبْغٌ':Predicate, #3: 3	أَنَّ الصِّبْغَ
u'أَنَّ صَبِيٌّ':Predicate, #4: 4	أَنَّ الصَّبْغَ
u'أَنَّ صَبِيٌّ':Predicate, #3: 3	أَنَّ الصَّبِيَّةَ
u'أَنَّ صَبِيٌّ':Predicate, #3: 3	أَنَّ صَبِيَّةً
u'أَنَّ صِبْيَانٌ':Predicate, #61: 61	أَنَّ الصَّبِيَّ
u'أَنَّ صَبِيحٌ':Predicate, #5: 5	أَنَّ الصِّبْيَانَ
u'أَنْصَتَ غفر':Predicate, #1: 1	أَنَّ صَبِيحَةَ
u'أَنَّ صَحَابَةٌ':Predicate, #1: 1	أَنْصَتَ غُفِرَ
u'أَنَّ صَحَابِيٌّ':Predicate, #74: 74	أَنَّ الصَّحَابَةَ
u'أَنَّ صحاح':Predicate, #10: 10	أَنَّ الصَّحَابِيَّ
u'أَنَّ صحبة':Predicate, #1: 1	أَنَّ الصِّحَاحَ
u'أَنَّ صُحْبَةٌ':Predicate, #1: 1	أَنَّ الصُّحْبَةَ
u'أَنَّ صِحَّةٌ':Predicate, #1: 1	أَنَّ الصُّحْبَةَ
u'أَنَّ صِحَّةٌ':Predicate, #18: 18	أَنَّ الصِّحَّةَ
u'أَنَّ صَحْوٌ':Predicate, #32: 32	أَنَّ صِحَّةَ
u'أَنَّ صَحِيحٌ':Predicate, #2: 2	أَنَّ الصَّحْوَ
u'أَنَّ صَحِيحٌ':Predicate, #1: 1	أَنَّ الصَّحِيحَةَ
u'أَنَّ صداق':Predicate, #224: 224	أَنَّ الصَّحِيحَ
u'أَنَّ صَدَاقٌ':Predicate, #19: 19	أَنَّ الصَّدَاقَ
u'أَنَّ صَدْرٌ':Predicate, #19: 19	أَنَّ الصَّدَاقَ
u'أَنَّ صَدْرٌ':Predicate, #4: 4	أَنَّ الصَّدْرَ
u'أَنَّ صدق':Predicate, #8: 8	أَنَّ صَدْرَ
u'أَنَّ صِدْقٌ':Predicate, #4: 4	أَنَّ الصِّدْقَ
u'أَنَّ صدق':Predicate, #4: 4	أَنَّ الصِّدْقَ
u'أَنَّ صِدْقٌ':Predicate, #4: 4	أَنَّ صِدْقَ
u'أَنَّ صدقة':Predicate, #4: 4	أَنَّ صِدْقَ
u'أَنَّ صَدَقَةٌ':Predicate, #11: 11	أَنَّ صَدَقَةَ
u'أَنَّ صدقة':Predicate, #11: 11	أَنَّ صَدَقَةَ
u'أَنَّ صَدَقَةٌ':Predicate, #44: 44	أَنَّ الصَّدَقَةَ
u'أَنَّ صُدُورٌ':Predicate, #44: 44	أَنَّ الصَّدَقَةَ
u'أَنَّ صَدُوقٌ':Predicate, #1: 1	أَنَّ صُدُورَ
u'أَنَّ صِدِّيقٌ':Predicate, #1: 1	أَنَّ الصَّدُوقَ
u'أَنَّ صَرَاحَةٌ':Predicate, #8: 8	أَنَّ الصِّدِّيقَ
u'أَنَّ صِرَاطٌ':Predicate, #3: 3	أَنَّ الصَّرَاحَةَ
u'أَنَّ صَرْفٌ':Predicate, #3: 3	أَنَّ الصِّرَاطَ
u'أَنَّ صَرْف':Predicate, #11: 11	أَنَّ الصَّرْفَ
u'أَنَّ صَرْفٌ':Predicate, #11: 11	أَنَّ الصَّرْفَ
u'أَنَّ صَرْف':Predicate, #11: 11	أَنَّ صَرْفَ
u'أَنَّ صَرِيحٌ':Predicate, #11: 11	أَنَّ صَرْفَ
u'أَنَّ صَرِيحٌ':Predicate, #15: 15	أَنَّ الصَّرِيحَ
u'أَنَّ صَعْبٌ':Predicate, #9: 9	أَنَّ صَرِيحَ
u'أَنَّ صَعِيدٌ':Predicate, #14: 14	أَنَّ الصَّعْبَ
u'أَنَّ صغار':Predicate, #12: 12	أَنَّ الصَّعِيدَ
u'أَنَّ صغائر':Predicate, #2: 2	أَنَّ الصِّغَارَ
u'أَنَّ صَغَائِرُ':Predicate, #9: 9	أَنَّ الصَّغَائِرَ
u'أَنَّ صَغِيرٌ':Predicate, #9: 9	أَنَّ الصَّغَائِرَ
u'أَنَّ صَغِيرٌ':Predicate, #1: 1	أَنَّ صَغِيرَةً
u'أَنَّ صَغِيرٌ':Predicate, #21: 21	أَنَّ الصَّغِيرَةَ
u'أَنَّ صَغِيرٌ':Predicate, #2: 2	أَنَّ صَغِيرَ
u'أَنَّ صَفٌّ':Predicate, #33: 33	أَنَّ الصَّغِيرَ
u'أَنَّ صَفٌّ':Predicate, #2: 2	أَنَّ صَفَّ
u'أَنْصَفَ إمَامٌ':Subject, #6: 6	أَنَّ الصَّفَّ
u'أَنَّ صِفَةٌ':Predicate, #2: 2	أَنْصَفَ الْإِمَامُ
u'أَنَّ صِفَةٌ':Predicate, #20: 20	أَنَّ الصِّفَةَ
u'أَنَّ صُفْرَةٌ':Predicate, #29: 29	أَنَّ صِفَةَ
u'أَنْصَفَ علم':Predicate, #2: 2	أَنَّ الصُّفْرَةَ
u'أَنْصَفَ قَالٌ':Predicate, #2: 2	أَنْصَفَ عَلِمَ
u'أَنَّ صَفْقَةٌ':Predicate, #1: 1	أَنْصَفَ قَالَ
u'أَنْصَفَ مُحَقِّقٌ':Subject, #16: 16	أَنَّ الصَّفْقَةَ
u'أَنْصَفَ نَاسٌ':Predicate, #1: 1	أَنْصَفَ الْمُحَقِّقُ
u'أَنْصَفَ نَوَوِيٌّ':Subject, #1: 1	أَنْصَفَ النَّاسَ
u'أَنَّ صَفْوَان':Predicate, #1: 1	أَنْصَفَ النَّوَوِيُّ
u'أَنَّ صُفُوفٌ':Predicate, #22: 22	أَنَّ صَفْوَانَ
u'أَنَّ صُفُوفٌ':Predicate, #1: 1	أَنَّ الصُّفُوفَ
u'أَنَّ صَفِيٌّ':Predicate, #1: 1	أَنَّ صُفُوفَ
u'أَنَّ صَفِيٌّ':Predicate, #1: 1	أَنَّ الصَّفِيَّ
u'أَنَّ صَكٌّ':Predicate, #24: 24	أَنَّ صَفِيَّةَ
u'أَنَّ صَلاَبَةٌ':Predicate, #1: 1	أَنَّ الصَّكَّ
u'أَنَّ صَلاَةٌ':Predicate, #1: 1	أَنَّ الصَّلَابَةَ
u'أَنَّ صَلاَةٌ':Predicate, #150: 150	أَنَّ الصَّلَاةَ
u'أَنَّ صَلاَةٌ':Predicate, #1: 1	أَنَّ الصَّلاةَ
u'أَنَّ صَلاَةٌ':Predicate, #3: 3	أَنَّ صَلاَةَ
u'أَنَّ صَلاَةٌ':Predicate, #7: 7	أَنَّ الصَّلاَةَ
u'أَنَّ صَلاَحٌ':Predicate, #82: 82	أَنَّ صَلَاةَ
u'أَنَّ صَلاَحٌ':Predicate, #1: 1	أَنَّ الصَّلَاحَ
u'أَنَّ صَلاَحِيَةٌ':Predicate, #7: 7	أَنَّ صَلَاحَ
u'أَنَّ صَلاَحِيَّةٌ':Predicate, #1: 1	أَنَّ الصَّلَاحِيَةَ
u'أَنَّ صَلاَحِيَّةٌ':Predicate, #1: 1	أَنَّ صَلَاحِيَّةَ
u'أَنَّ صُلْب':Predicate, #2: 2	أَنَّ الصَّلَاحِيَّةَ
u'أَنَّ صلْبٌ':Predicate, #1: 1	أَنَّ الصُّلْبِيَّةَ
u'أَنَّ صَلْبٌ':Predicate, #3: 3	أَنَّ الصَّلْبَ
u'أَنَّ صُلْبِيّ':Predicate, #3: 3	أَنَّ الصَّلْبَ
u'أَنَّ صِلَةٌ':Predicate, #1: 1	أَنَّ الصُّلْبِيَّةَ
u'أَنَّ صِلَةٌ':Predicate, #1: 1	أَنَّ الصِّلَةَ
u'أَنَّ صلح':Predicate, #2: 2	أَنَّ صِلَةَ
u'أَنَّ صُلْحٌ':Predicate, #2: 2	أَنَّ صُلْحَ
u'أَنَّ صلح':Predicate, #2: 2	أَنَّ صُلْحَ
u'أَنَّ صُلْحٌ':Predicate, #40: 40	أَنَّ الصُّلْحَ
u'أَنَّ صَلِيبٌ':Predicate, #40: 40	أَنَّ الصُّلْحَ
u'أَنَّ صمات':Predicate, #1: 1	أَنَّ الصَّلِيبَ
u'أَنَّ صمت':Predicate, #1: 1	أَنَّ الصُّمَاتَ
u'أَنَّ صَمْتٌ':Predicate, #2: 2	أَنَّ الصَّمْتَ
u'أَنَّ صَنْجٌ':Predicate, #2: 2	أَنَّ الصَّمْتَ
u'أَنَّ صَنْج':Predicate, #1: 1	أَنَّ الصَّنْجَ
u'أَنَّ صنعة':Predicate, #1: 1	أَنَّ صَنْجَةَ
u'أَنَّ صَنْعَةٌ':Predicate, #3: 3	أَنَّ الصَّنْعَةَ
u'أَنَّ صِنْفٌ':Predicate, #3: 3	أَنَّ الصَّنْعَةَ
u'أَنَّ صَنِيعٌ':Predicate, #2: 2	أَنَّ الصِّنْفَ
u'أَنَّ صَنِيعَةٌ':Predicate, #1: 1	أَنَّ الصَّنِيعَةَ
u'أَنَّ صِهْرِيجٌ':Predicate, #1: 1	أَنَّ الصَّنِيعَةَ
u'أَنَّ صَوَابٌ':Predicate, #1: 1	أَنَّ الصِّهْرِيجَ
u'أَنَّ صَوَابٌ':Predicate, #1: 1	أَنَّ صَوَابَ
u'أَنَّ صَوْتٌ':Predicate, #41: 41	أَنَّ الصَّوَابَ
u'أَنَّ صَوْتٌ':Predicate, #2: 2	أَنَّ الصَّوْتَ
u'أَنَّ صُورٌ':Predicate, #3: 3	أَنَّ صَوْتَ
u'أَنَّ صُوَرٌ':Predicate, #16: 16	أَنَّ الصُّوَرَ
u'أَنَّ صُورٌ':Predicate, #16: 16	أَنَّ الصُّوَرَ
u'أَنَّ صُوَرٌ':Predicate, #6: 6	أَنَّ صُوَرَ
u'أَنَّ صُورَةٌ':Predicate, #6: 6	أَنَّ صُوَرَ
u'أَنَّ صُورَةٌ':Predicate, #21: 21	أَنَّ الصُّورَةَ
u'أَنَّ صُوفٌ':Predicate, #56: 56	أَنَّ صُورَةَ
u'أَنَّ صُوفِيٌّ':Predicate, #3: 3	أَنَّ الصُّوفَ
u'أَنَّ صُوفِيٌّ':Subject, #1: 1	أَنَّ الصُّوفِيَّةَ
u'أَنَّ صُوفِيَّةٌ':Predicate, #1: 1	أَنَّ الصُّوفِيَّةُ
u'أَنَّ صُوفِيَّةٌ':Subject, #1: 1	أَنَّ الصُّوفِيَّةَ
u'أَنَّ صَوْمٌ':Predicate, #1: 1	أَنَّ الصُّوفِيَّةُ
u'أَنَّ صَوْمٌ':Predicate, #30: 30	أَنَّ صَوْمَ
u'أَنَّ صَوْنٌ':Predicate, #69: 69	أَنَّ الصَّوْمَ
u'أَنَّ صِيَاحٌ':Predicate, #1: 1	أَنَّ صَوْنَ
u'أَنَّ صِيَاغَةٌ':Predicate, #1: 1	أَنَّ الصِّيَاحَ
u'أَنَّ صِيَامٌ':Predicate, #1: 1	أَنَّ الصِّيَاغَةَ
u'أَنَّ صِيَامٌ':Predicate, #2: 2	أَنَّ صِيَامَ
u'أَنَّ صَيْدٌ':Predicate, #5: 5	أَنَّ الصِّيَامَ
u'أَنَّ صَيْدٌ':Predicate, #21: 21	أَنَّ الصَّيْدَ
u'أَنَّ صَيْرَفِيٌّ':Predicate, #5: 5	أَنَّ صَيْدَ
u'أَنَّ صَيْرُورَة':Predicate, #9: 9	أَنَّ الصَّيْرَفِيَّ
u'أَنَّ صِيَغٌ':Predicate, #2: 2	أَنَّ صَيْرُورَةَ
u'أَنَّ صِيَغٌ':Predicate, #1: 1	أَنَّ الصِّيَغَ
u'أَنَّ صِيغَةٌ':Predicate, #1: 1	أَنَّ صِيَغَ
u'أَنَّ صِيغَةٌ':Predicate, #17: 17	أَنَّ الصِّيغَةَ
u'أَنَّ ضَابِطٌ':Predicate, #21: 21	أَنَّ صِيغَةَ
u'أَنَّ ضَابِطٌ':Predicate, #2: 2	أَنَّ ضَابِطَ
u'أَنَّ ضَارِبٌ':Predicate, #4: 4	أَنَّ الضَّابِطَ
u'أَنَّ ضَارِبٌ':Predicate, #1: 1	أَنَّ ضَارِبَ
u'أَنَّ ضَامِنٌ':Predicate, #6: 6	أَنَّ الضَّارِبَ
u'أَنَّ ضَأْنٌ':Predicate, #6: 6	أَنَّ الضَّامِنَ
u'أَنَّ ضَبَّةٌ':Predicate, #1: 1	أَنَّ الضَّأْنَ
u'أَنَّ ضَبْطٌ':Predicate, #1: 1	أَنَّ الضَّبَّةَ
u'أَنَّ ضَبْطٌ':Predicate, #1: 1	أَنَّ ضَبْطَ
u'أَنَّ ضحك':Predicate, #3: 3	أَنَّ الضَّبْطَ
u'أَنَّ ضَحِكٌ':Predicate, #1: 1	أَنَّ الضَّحِكَ
u'أَنَّ ضَحْوَةٌ':Predicate, #1: 1	أَنَّ الضَّحِكَ
u'أَنَّ ضَحِيَّةٌ':Predicate, #1: 1	أَنَّ الضَّحْوَةَ
u'أَنَّ ضِدٌّ':Predicate, #3: 3	أَنَّ الضَّحِيَّةَ
u'أَنَّ ضرار':Predicate, #2: 2	أَنَّ الضِّدَّ
u'أَنَّ ضَرْبٌ':Predicate, #1: 1	أَنَّ الضِّرَارَ
u'أَنَّ ضَرَبٌ':Predicate, #11: 11	أَنَّ الضَّرْبَ
u'أَنَّ ضَرْبٌ':Predicate, #2: 2	أَنَّ ضَرَبَ
u'أَنَّ ضَرَرٌ':Predicate, #5: 5	أَنَّ ضَرْبَ
u'أَنَّ ضَرَرٌ':Predicate, #1: 1	أَنَّ ضَرَرَهُنَّ
u'أَنَّ ضَرَرٌ':Predicate, #3: 3	أَنَّ ضَرَرَ
u'أَنَّ ضرع':Predicate, #9: 9	أَنَّ الضَّرَرَ
u'أَنَّ ضَرْعٌ':Predicate, #1: 1	أَنَّ الضَّرْعَ
u'أَنَّ ضَرُورَةٌ':Predicate, #1: 1	أَنَّ الضَّرْعَ
u'أَنَّ ضَرُورِيٌّ':Predicate, #14: 14	أَنَّ الضَّرُورَةَ
u'أَنَّ ضِعْفٌ':Predicate, #4: 4	أَنَّ الضَّرُورِيَّ
u'أَنَّ ضِعْفٌ':Predicate, #1: 1	أَنَّ ضِعْفَ
u'أَنَّ ضَعِيفٌ':Predicate, #2: 2	أَنَّ الضِّعْفَ
u'أَنَّ ضَعِيفٌ':Predicate, #1: 1	أَنَّ ضَعِيفَ
u'أَنَّ ضِغْثٌ':Predicate, #7: 7	أَنَّ الضَّعِيفَ
u'أَنَّ ضَفْرٌ':Predicate, #2: 2	أَنَّ الضِّغْثَ
u'أَنَّ ضلال':Predicate, #2: 2	أَنَّ الضَّفْرَ
u'أَنَّ ضَلاَلٌ':Predicate, #2: 2	أَنَّ الضَّلَالَ
u'أَنَّ ضَلاَلَةٌ':Predicate, #2: 2	أَنَّ الضَّلَالَ
u'أَنَّ ضَلاَلَةٌ':Predicate, #1: 1	أَنَّ الضَّلَالَةَ
u'أَنَّ ضَمٌّ':Predicate, #1: 1	أَنَّ الضَّلاَلَةَ
u'أَنَّ ضَمٌّ':Predicate, #5: 5	أَنَّ ضَمَّ
u'أَنَّ ضَمَانٌ':Predicate, #6: 6	أَنَّ الضَّمَّ
u'أَنَّ ضَمَانٌ':Predicate, #40: 40	أَنَّ ضَمَانَ
u'أَنَّ ضَمَائِرُ':Predicate, #66: 66	أَنَّ الضَّمَانَ
u'أَنَّ ضَمَائِرُ':Predicate, #1: 1	أَنَّ الضَّمَائِرَ
u'أَنَّ ضَمْرٌ':Predicate, #1: 1	أَنَّ ضَمَائِرَ
u'أَنَّ ضمرة':Predicate, #1: 1	أَنَّ ضَمْرَةَ
u'أَنَّ ضَمِيرٌ':Predicate, #1: 1	أَنَّ ضَمْرَةَ
u'أَنَّ ضَمِيرٌ':Predicate, #56: 56	أَنَّ الضَّمِيرَ
u'أَنَّ ضَوْءٌ':Predicate, #8: 8	أَنَّ ضَمِيرَ
u'أَنَّ ضَيَاعٌ':Predicate, #6: 6	أَنَّ الضَّوْءَ
u'أَنَّ ضَيَاعٌ':Predicate, #1: 1	أَنَّ الضَّيَاعَ
u'أَنَّ ضِيَافَةٌ':Predicate, #1: 1	أَنَّ ضَيَاعَ
u'أَنَّ ضَيْعَةٌ':Predicate, #13: 13	أَنَّ الضِّيَافَةَ
u'أَنَّ ضَيْفٌ':Predicate, #2: 2	أَنَّ الضَّيْعَةَ
u'أَنَّ ضَيِّقٌ':Predicate, #9: 9	أَنَّ الضَّيْفَ
u'أَنَّ ضِيقٌ':Predicate, #1: 1	أَنَّ الضَّيِّقَ
u'أَنَّ طَارِقٌ':Predicate, #2: 2	أَنَّ ضِيقَ
u'أَنَّ طَارِقٌ':Predicate, #1: 1	أَنَّ الطَّارِقَ
u'أَنَّ طَارِئٌ':Predicate, #5: 5	أَنَّ طَارِقَ
u'أَنَّ طَاعَةٌ':Predicate, #4: 4	أَنَّ الطَّارِئَ
u'أَنَّ طَاعَةٌ':Predicate, #3: 3	أَنَّ الطَّاعَةَ
u'أَنَّ طَاعِنٌ':Predicate, #4: 4	أَنَّ طَاعَةَ
u'أَنَّ طَاعُونٌ':Predicate, #2: 2	أَنَّ الطَّاعِنَ
u'أَنَّ طَاغِي':Predicate, #7: 7	أَنَّ الطَّاعُونَ
u'أَنَّ طَافِحٌ':Predicate, #1: 1	أَنَّ الطَّاغِيَةَ
u'أَنَّ طَافِي':Predicate, #1: 1	أَنَّ الطَّافِحَ
u'أَنَّ طَاقَةٌ':Predicate, #2: 2	أَنَّ الطَّافِيَ
u'أَنَّ طَالِبٌ':Predicate, #1: 1	أَنَّ الطَّاقَةَ
u'أَنَّ طَالِبٌ':Predicate, #30: 30	أَنَّ الطَّالِبَ
u'أَنَّ طَالِعٌ':Predicate, #3: 3	أَنَّ طَالِبَ
u'أَنَّ طَالِقٌ':Predicate, #1: 1	أَنَّ الطَّالِعَ
u'أَنَّ طَالِقٌ':Predicate, #1: 1	أَنَّ الطَّالِقَ
u'أَنَّ طَاهِرٌ':Predicate, #1: 1	أَنَّ طَالِقَ
u'أَنَّ طَاهِرٌ':Predicate, #1: 1	أَنَّ الطَّاهِرَةَ
u'أَنَّ طَاهِرٌ':Predicate, #2: 2	أَنَّ الطَّاهِرَ
u'أَنَّ طَائِرٌ':Predicate, #2: 2	أَنَّ طَاهِرَ
u'أَنَّ طَائِفٌ':Predicate, #3: 3	أَنَّ الطَّائِرَ
u'أَنَّ طَائِفٌ':Predicate, #11: 11	أَنَّ الطَّائِفَةَ
u'أَنَّ طَائِفٌ':Predicate, #3: 3	أَنَّ الطَّائِفَ
u'أَنَّ طِبَاعٌ':Predicate, #9: 9	أَنَّ طَائِفَةً
u'أَنَّ طِبَاعٌ':Predicate, #1: 1	أَنَّ طِبَاعَ
u'أَنَّ طَبْخٌ':Predicate, #2: 2	أَنَّ الطِّبَاعَ
u'أَنَّ طَبْخٌ':Predicate, #1: 1	أَنَّ طَبْخَ
u'أَنَّ طَبَرِيّ':Predicate, #5: 5	أَنَّ الطَّبْخَ
u'أَنَّ طَبْعٌ':Predicate, #2: 2	أَنَّ الطَّبَرِيَّ
u'أَنَّ طَبَقَةٌ':Predicate, #1: 1	أَنَّ طَبْعَ
u'أَنَّ طَبِيبٌ':Predicate, #2: 2	أَنَّ الطَّبَقَةَ
u'أَنَّ طَبِيخٌ':Predicate, #1: 1	أَنَّ الطَّبِيبَ
u'أَنَّ طحن':Predicate, #2: 2	أَنَّ الطَّبِيخَ
u'أَنَّ طَرّار':Predicate, #1: 1	أَنَّ الطَّحْنَ
u'أَنَّ طَرْحٌ':Predicate, #4: 4	أَنَّ الطَّرَّارَ
u'أَنَّ طَرْد':Predicate, #1: 1	أَنَّ طَرْحَ
u'أَنَّ طَرْدٌ':Predicate, #1: 1	أَنَّ الطَّرْدِيَّةَ
u'أَنَّ طَرْدٌ':Predicate, #1: 1	أَنَّ طَرْدَ
u'أَنَّ طَرْدَة':Predicate, #2: 2	أَنَّ الطَّرْدَ
u'أَنَّ طَرْدِيّ':Predicate, #1: 1	أَنَّ الطَّرْدِيَّةَ
u'أَنَّ طرف':Predicate, #1: 1	أَنَّ الطَّرْدِيَّةَ
u'أَنَّ طرف':Predicate, #1: 1	أَنَّ الطَّرَفَ
u'أَنَّ طَرَفٌ':Predicate, #1: 1	أَنَّ الطَّرْفَ
u'أَنَّ طَرْفٌ':Predicate, #1: 1	أَنَّ الطَّرَفَ
u'أَنَّ طرف':Predicate, #1: 1	أَنَّ الطَّرْفَ
u'أَنَّ طَرَفٌ':Predicate, #5: 5	أَنَّ طَرَفَ
u'أَنَّ طُرُقٌ':Predicate, #5: 5	أَنَّ طَرَفَ
u'أَنَّ طُرُقٌ':Predicate, #1: 1	أَنَّ الطُّرُقَ
u'أَنَّ طَرِيقٌ':Predicate, #2: 2	أَنَّ طُرُقَ
u'أَنَّ طَرِيقٌ':Predicate, #16: 16	أَنَّ الطَّرِيقَ
u'أَنَّ طَرِيقَةٌ':Predicate, #18: 18	أَنَّ طَرِيقَ
u'أَنَّ طَرِيقَةٌ':Predicate, #2: 2	أَنَّ الطَّرِيقَةَ
u'أَنَّ طَسْت':Predicate, #6: 6	أَنَّ طَرِيقَةَ
u'أَنَّ طعام':Predicate, #1: 1	أَنَّ الطَّسْتَ
u'أَنَّ طَعَامٌ':Predicate, #15: 15	أَنَّ الطَّعَامَ
u'أَنَّ طعام':Predicate, #15: 15	أَنَّ الطَّعَامَ
u'أَنَّ طَعَامٌ':Predicate, #2: 2	أَنَّ طَعَامَ
u'أَنَّ طعام':Subject, #2: 2	أَنَّ طَعَامَ
u'أَنَّ طَعَامٌ':Subject, #1: 1	أَنَّ الطَّعَامُ
u'أَنَّ طَعْنٌ':Predicate, #1: 1	أَنَّ الطَّعَامُ
u'أَنَّ طعنة':Predicate, #3: 3	أَنَّ الطَّعْنَ
u'أَنَّ طَعْنَةٌ':Predicate, #1: 1	أَنَّ الطَّعْنَةَ
u'أَنَّ طِفْلٌ':Predicate, #1: 1	أَنَّ الطَّعْنَةَ
u'أَنَّ طلاح':Predicate, #8: 8	أَنَّ الطِّفْلَ
u'أَنَّ طَلاَقٌ':Predicate, #1: 1	أَنَّ الطَّلَاحَ
u'أَنَّ طَلاَقٌ':Predicate, #197: 197	أَنَّ الطَّلَاقَ
u'أَنَّ طَلاَقٌ':Predicate, #1: 1	أَنَّ طَلاَقَ
u'أَنَّ طَلاَقٌ':Predicate, #22: 22	أَنَّ طَلَاقَ
u'أَنَّ طلب':Predicate, #3: 3	أَنَّ الطَّلاَقَ
u'أَنَّ طَلَبٌ':Predicate, #11: 11	أَنَّ الطَّلَبَ
u'أَنَّ طلب':Predicate, #11: 11	أَنَّ الطَّلَبَ
u'أَنَّ طَلَبٌ':Predicate, #20: 20	أَنَّ طَلَبَ
u'أَنَّ طَلَبَةٌ':Predicate, #20: 20	أَنَّ طَلَبَ
u'أَنَّ طَلَبِيَّةٌ':Predicate, #1: 1	أَنَّ الطَّلَبَةَ
u'أَنَّ طَلْحٌ':Predicate, #1: 1	أَنَّ الطَّلَبِيَّةَ
u'أَنَّ طَلْحٌ':Subject, #7: 7	أَنَّ طَلْحَةَ
u'أَنَّ طلحة':Predicate, #1: 1	أَنَّ طَلْحَةُ
u'أَنَّ طلحة':Subject, #7: 7	أَنَّ طَلْحَةَ
u'أَنَّ طَلْعٌ':Predicate, #1: 1	أَنَّ طَلْحَةُ
u'أَنَّ طَلْقٌ':Predicate, #4: 4	أَنَّ الطَّلْعَ
u'أَنَّ طُلُوعٌ':Predicate, #1: 1	أَنَّ طَلْقَ
u'أَنَّ طُلُوعٌ':Predicate, #1: 1	أَنَّ الطُّلُوعَ
u'أَنَّ طُمَأْنِينَةٌ':Predicate, #2: 2	أَنَّ طُلُوعَ
u'أَنَّ طَهَارَةٌ':Predicate, #2: 2	أَنَّ الطُّمَأْنِينَةَ
u'أَنَّ طَهَارَةٌ':Predicate, #15: 15	أَنَّ طَهَارَةَ
u'أَنَّ طهر':Predicate, #47: 47	أَنَّ الطَّهَارَةَ
u'أَنَّ طُهْرٌ':Predicate, #22: 22	أَنَّ الطُّهْرَ
u'أَنَّ طهرة':Predicate, #22: 22	أَنَّ الطُّهْرَ
u'أَنَّ طَهُورٌ':Predicate, #1: 1	أَنَّ الطَّهِرَةَ
u'أَنَّ طوارق':Predicate, #9: 9	أَنَّ الطَّهُورَ
u'أَنَّ طَوَارِقُ':Predicate, #1: 1	أَنَّ طَوَارِقَ
u'أَنَّ طَوَّافٌ':Predicate, #1: 1	أَنَّ طَوَارِقَ
u'أَنَّ طواف':Predicate, #1: 1	أَنَّ الطَّوَّافِينَ
u'أَنَّ طَوَافٌ':Predicate, #26: 26	أَنَّ طَوَافَ
u'أَنَّ طواف':Predicate, #26: 26	أَنَّ طَوَافَ
u'أَنَّ طَوَافٌ':Predicate, #37: 37	أَنَّ الطَّوَافَ
u'أَنَّ طَوَالِعُ':Predicate, #37: 37	أَنَّ الطَّوَافَ
u'أَنَّ طُوفَانٌ':Predicate, #2: 2	أَنَّ الطَّوَالِعَ
u'أَنَّ طَوْلٌ':Predicate, #1: 1	أَنَّ الطُّوفَانَ
u'أَنَّ طُولٌ':Predicate, #2: 2	أَنَّ الطَّوْلَ
u'أَنَّ طَوِيلٌ':Predicate, #3: 3	أَنَّ طُولَ
u'أَنَّ طَيَالِسَةٌ':Predicate, #1: 1	أَنَّ الطَّوِيلَةَ
u'أَنَّ طَيِّبٌ':Predicate, #1: 1	أَنَّ الطَّيَالِسَةَ
u'أَنَّ طِيبٌ':Predicate, #1: 1	أَنَّ الطَّيِّبَ
u'أَنَّ طَيْرٌ':Predicate, #4: 4	أَنَّ الطِّيبَ
u'أَنَّ طَيْرٌ':Predicate, #1: 1	أَنَّ طَيْرَ
u'أَنَّ طِيَرَةٌ':Predicate, #4: 4	أَنَّ الطَّيْرَ
u'أَنَّ طَيْلَسَانٌ':Predicate, #3: 3	أَنَّ الطِّيَرَةَ
u'أَنَّ طِينٌ':Predicate, #1: 1	أَنَّ الطَّيْلَسَانَ
u'أَنْظَارٌ أئِمَّةٌ':Added, #4: 4	أَنَّ الطِّينَ
u'أَنْظَارٌ نَاسٌ':Added, #1: 1	أَنْظَارِ الْأَئِمَّةِ
u'أَنْظَارٌ وَقْفٌ':Added, #1: 1	أَنْظَارُ النَّاسِ
u'أَنَّ ظالِمٌ':Predicate, #1: 1	أَنْظَارُ وَقْفٍ
u'أَنَّ ظاهِرٌ':Predicate, #3: 3	أَنَّ الظَّالِمَ
u'أَنَّ ظاهِرٌ':Predicate, #107: 107	أَنَّ الظَّاهِرَ
u'أَنَّ ظاهِر':Predicate, #144: 144	أَنَّ ظَاهِرَ
u'أَنَّ ظاهِرَة':Predicate, #2: 2	أَنَّ الظَّاهِرِيَّةَ
u'أَنَّ ظاهِرِيّ':Predicate, #2: 2	أَنَّ الظَّاهِرِيَّةَ
u'أَنَّ ظَرْفٌ':Predicate, #2: 2	أَنَّ الظَّاهِرِيَّةَ
u'أَنَّ ظَرْفٌ':Predicate, #1: 1	أَنَّ ظَرْفَ
u'أَنَّ ظُروفٌ':Predicate, #5: 5	أَنَّ الظَّرْفَ
u'أَنَّ ظِلٌّ':Predicate, #1: 1	أَنَّ الظُّرُوفَ
u'أَنَّ ظُلْمٌ':Predicate, #1: 1	أَنَّ ظِلَّ
u'أَنَّ ظلمة':Predicate, #4: 4	أَنَّ الظُّلْمَ
u'أَنَّ ظَنٌّ':Predicate, #1: 1	أَنَّ الظَّلَمَةَ
u'أَنَّ ظَنٌّ':Predicate, #23: 23	أَنَّ الظَّنَّ
u'أَنَّ ظُنونٌ':Predicate, #5: 5	أَنَّ ظَنَّ
u'أَنَّ ظهار':Predicate, #1: 1	أَنَّ ظُنُونَ
u'أَنَّ ظهار':Predicate, #15: 15	أَنَّ الظِّهَارَ
u'أَنَّ ظُهْرٌ':Predicate, #1: 1	أَنَّ ظِهَارَ
u'أَنَّ ظَهْرٌ':Predicate, #15: 15	أَنَّ الظُّهْرَ
u'أَنَّ ظَهْرٌ':Predicate, #1: 1	أَنَّ الظَّهْرَ
u'أَنَّ ظُهْرٌ':Predicate, #2: 2	أَنَّ ظَهْرَ
u'أَنَّ ظُهورٌ':Predicate, #2: 2	أَنَّ ظُهْرَ
u'أَنَّ ظُهورٌ':Predicate, #3: 3	أَنَّ الظُّهُورَ
u'آنَ ظُهورٌ':Subject, #7: 7	أَنَّ ظُهُورَ
u'أَنَّ عَاجٌ':Predicate, #1: 1	آنَ ظُهُورُهُ
u'أَنَّ عَاجِزٌ':Predicate, #1: 1	أَنَّ الْعَاجَ
u'أَنَّ عَاجِزٌ':Predicate, #10: 10	أَنَّ الْعَاجِزَ
u'أَنَّ عَادَةٌ':Predicate, #1: 1	أَنَّ الْعَاجِزَةَ
u'أَنَّ عَادَةٌ':Predicate, #50: 50	أَنَّ الْعَادَةَ
u'أَنَّ عَادِلٌ':Predicate, #5: 5	أَنَّ عَادَةَ
u'أَنَّ عادِم':Predicate, #3: 3	أَنَّ الْعَادِلَ
u'أَنَّ عَادِي':Predicate, #1: 1	أَنَّ عَادِمَ
u'أَنَّ عَارِضٌ':Predicate, #3: 3	أَنَّ الْعَادِيَ
u'أَنَّ عَارِي':Predicate, #4: 4	أَنَّ الْعَارِضَ
u'أَنَّ عارِيَّةٌ':Predicate, #3: 3	أَنَّ الْعَارِيَ
u'أَنَّ عَاشِرٌ':Predicate, #10: 10	أَنَّ الْعَارِيَّةَ
u'أَنَّ عَاشِقٌ':Predicate, #3: 3	أَنَّ الْعَاشِرَ
u'أَنَّ عَاصِبٌ':Predicate, #2: 2	أَنَّ الْعَاشِقَ
u'أَنَّ عَاصِرٌ':Predicate, #1: 1	أَنَّ الْعَاصِبَ
u'أَنَّ عَاصِمٌ':Predicate, #1: 1	أَنَّ الْعَاصِرَ
u'أَنَّ عَاصِمٌ':Predicate, #1: 1	أَنَّ الْعَاصِمَ
u'أَنَّ عَاصِي':Predicate, #8: 8	أَنَّ عَاصِمَ
u'أَنَّ عَاطِفٌ':Predicate, #2: 2	أَنَّ الْعَاصِيَ
u'أَنَّ عَاطِفَةٌ':Predicate, #1: 1	أَنَّ الْعَاطِفَةَ
u'أَنَّ عَافِي':Predicate, #1: 1	أَنَّ الْعَاطِفَةَ
u'أَنَّ عَاقِدٌ':Predicate, #1: 1	أَنَّ الْعَافِيَ
u'أَنَّ عَاقِلٌ':Predicate, #7: 7	أَنَّ الْعَاقِدَ
u'أَنَّ عَاقِلٌ':Predicate, #12: 12	أَنَّ الْعَاقِلَةَ
u'أَنَّ عَاقِلٌ':Predicate, #4: 4	أَنَّ عَاقِلَةَ
u'أَنَّ عَالَمٌ':Predicate, #5: 5	أَنَّ الْعَاقِلَ
u'أَنَّ عَالِمٌ':Predicate, #10: 10	أَنَّ الْعَالَمَ
u'أَنَّ عَالِمٌ':Predicate, #14: 14	أَنَّ الْعَالِمَ
u'أَنَّ عَالِمٌ':Subject, #2: 2	أَنَّ عَالِمَ
u'أَنَّ عَالِي':Predicate, #1: 1	أَنَّ الْعَالِمُ
u'أَنَّ عَامٌّ':Predicate, #2: 2	أَنَّ الْعَالِيَةَ
u'أَنَّ عَامٌ':Predicate, #18: 18	أَنَّ عَامَّةَ
u'أَنَّ عَامٌّ':Predicate, #1: 1	أَنَّ الْعَامَ
u'أَنَّ عَامٌّ':Predicate, #32: 32	أَنَّ الْعَامَّ
u'أَنَّ عَامِرٌ':Predicate, #6: 6	أَنَّ الْعَامَّةَ
u'أَنَّ عَامِلٌ':Predicate, #5: 5	أَنَّ عَامِرَ
u'أَنَّ عَامِلٌ':Predicate, #1: 1	أَنَّ الْعَامِلَةَ
u'أَنَّ عَامِلٌ':Predicate, #1: 1	أَنَّ عَامِلاً
u'أَنَّ عَامِلٌ':Predicate, #36: 36	أَنَّ الْعَامِلَ
u'أَنَّ عَامِّيٌّ':Predicate, #6: 6	أَنَّ عَامِلَ
u'أَنَّ عَانَةٌ':Predicate, #14: 14	أَنَّ الْعَامِّيَّ
u'أَنَّ عَاهَةٌ':Predicate, #1: 1	أَنَّ الْعَانَةَ
u'أَنَّ عَائِدٌ':Predicate, #1: 1	أَنَّ الْعَاهَةَ
u'أَنَّ عَائِشٌ':Predicate, #3: 3	أَنَّ الْعَائِدَ
u'أَنَّ عِبَادٌ':Predicate, #199: 199	أَنَّ عَائِشَةَ
u'أَنَّ عِبَادَةٌ':Predicate, #6: 6	أَنَّ الْعِبَادَ
u'أَنَّ عِبَادَةٌ':Predicate, #10: 10	أَنَّ الْعِبَادَةَ
u'أَنَّ عِبَارَةٌ':Predicate, #2: 2	أَنَّ عِبَادَةَ
u'أَنَّ عِبَارَةٌ':Predicate, #32: 32	أَنَّ عِبَارَةَ
u'أَنَّ عَبَّاسٌ':Predicate, #9: 9	أَنَّ الْعِبَارَةَ
u'أَنَّ عَبَّاسٌ':Predicate, #1: 1	أَنَّ عَبَّاسَ
u'أَنَّ عَبَثٌ':Predicate, #21: 21	أَنَّ الْعَبَّاسَ
u'أَنَّ عَبْدٌ':Predicate, #2: 2	أَنَّ الْعَبَثَ
u'أَنَّ عَبْدٌ':Predicate, #282: 282	أَنَّ الْعَبْدَ
u'أَنَّ عَبْدٌ':Subject, #566: 566	أَنَّ عَبْدَ
u'أَنَّ عَبَدَةٌ':Predicate, #1: 1	أَنَّ عَبْدُ
u'أَنَّ عبرة':Predicate, #1: 1	أَنَّ عَبَدَةَ
u'أَنَّ عِبْرَةٌ':Predicate, #127: 127	أَنَّ الْعِبْرَةَ
u'أَنَّ عبرة':Subject, #127: 127	أَنَّ الْعِبْرَةَ
u'أَنَّ عِبْرَةٌ':Subject, #1: 1	أَنَّ الْعِبْرَةُ
u'أَنَّ عُبُودِيَّةٌ':Predicate, #1: 1	أَنَّ الْعِبْرَةُ
u'أَنَّ عُبُورٌ':Predicate, #1: 1	أَنَّ الْعُبُودِيَّةَ
u'أَنَّ عَبِيدٌ':Predicate, #1: 1	أَنَّ الْعُبُورَ
u'أَنَّ عَبِيدٌ':Predicate, #1: 1	أَنَّ عَبِيدَ
u'أَنَّ عتاق':Predicate, #6: 6	أَنَّ الْعَبِيدَ
u'أَنَّ عتبة':Predicate, #2: 2	أَنَّ الْعَتَاقَ
u'أَنَّ عتق':Predicate, #8: 8	أَنَّ عُتْبَةَ
u'أَنَّ عِتْقٌ':Predicate, #105: 105	أَنَّ الْعِتْقَ
u'أَنَّ عتق':Predicate, #105: 105	أَنَّ الْعِتْقَ
u'أَنَّ عِتْقٌ':Predicate, #18: 18	أَنَّ عِتْقَ
u'أَنَّ عَتِيقٌ':Predicate, #18: 18	أَنَّ عِتْقَ
u'أَنَّ عُثُور':Predicate, #2: 2	أَنَّ الْعَتِيقَ
u'أَنَّ عُثُور':Predicate, #1: 1	أَنَّ عُثُورَ
u'أَنَّ عُجْبٌ':Predicate, #2: 2	أَنَّ الْعُثُورَ
u'أَنَّ عجز':Predicate, #1: 1	أَنَّ الْعُجْبَ
u'أَنَّ عَجْزٌ':Predicate, #14: 14	أَنَّ الْعَجْزَ
u'أَنَّ عَجْلاَن':Predicate, #14: 14	أَنَّ الْعَجْزَ
u'أَنَّ عجلة':Predicate, #1: 1	أَنَّ الْعَجْلاَنَ
u'أَنَّ عَجَلَةٌ':Predicate, #1: 1	أَنَّ الْعَجَلَةَ
u'أَنَّ عَجَمِيٌّ':Predicate, #1: 1	أَنَّ الْعَجَلَةَ
u'أَنَّ عَجْوَةٌ':Predicate, #4: 4	أَنَّ الْعَجَمِيَّ
u'أَنَّ عَجُوزٌ':Predicate, #1: 1	أَنَّ الْعَجْوَةَ
u'أَنَّ عَدٌّ':Predicate, #2: 2	أَنَّ الْعَجُوزَ
u'أَنَّ عَدٌّ':Predicate, #2: 2	أَنَّ عَدَّ
u'أَنَّ عَدَالَةٌ':Predicate, #3: 3	أَنَّ الْعَدَّ
u'أَنَّ عَدَالَةٌ':Predicate, #16: 16	أَنَّ الْعَدَالَةَ
u'أَنَّ عَدَاوَةٌ':Predicate, #1: 1	أَنَّ عَدَالَةَ
u'أَنَّ عَدَاوَةٌ':Predicate, #1: 1	أَنَّ عَدَاوَةَ
u'أَنَّ عِدَّةٌ':Predicate, #3: 3	أَنَّ الْعَدَاوَةَ
u'أَنَّ عِدَّةٌ':Predicate, #14: 14	أَنَّ عِدَّةَ
u'أَنَّ عَدَدٌ':Predicate, #52: 52	أَنَّ الْعِدَّةَ
u'أَنَّ عَدَدٌ':Predicate, #19: 19	أَنَّ الْعَدَدَ
u'أَنَّ عَدْلٌ':Predicate, #9: 9	أَنَّ عَدَدَ
u'أَنَّ عَدَمٌ':Predicate, #22: 22	أَنَّ الْعَدْلَ
u'أَنَّ عَدَمٌ':Predicate, #156: 156	أَنَّ عَدَمَ
u'أَنَّ عَدُوٌّ':Predicate, #7: 7	أَنَّ الْعَدَمَ
u'أَنَّ عُدُولٌ':Predicate, #14: 14	أَنَّ الْعَدُوَّ
u'أَنَّ عَذَابٌ':Predicate, #8: 8	أَنَّ الْعُدُولَ
u'أَنَّ عَذَابٌ':Predicate, #4: 4	أَنَّ عَذَابَ
u'أَنَّ عِذَارٌ':Predicate, #5: 5	أَنَّ الْعَذَابَ
u'أَنَّ عُذْرٌ':Predicate, #1: 1	أَنَّ الْعِذَارَ
u'أَنَّ عُذْرٌ':Predicate, #12: 12	أَنَّ الْعُذْرَ
u'أَنَّ عَذِرَةٌ':Predicate, #1: 1	أَنَّ عُذْرَ
u'أَنَّ عُرَاةٌ':Predicate, #1: 1	أَنَّ عَذِرَةَ
u'أَنَّ عِراقِيّ':Predicate, #3: 3	أَنَّ الْعُرَاةَ
u'أَنَّ عِرَاكٌ':Predicate, #2: 2	أَنَّ الْعِرَاقِيِّينَ
u'أَنَّ عَرَبٌ':Predicate, #1: 1	أَنَّ عِرَاكَ
u'أَنَّ عَرَبِيٌّ':Predicate, #29: 29	أَنَّ الْعَرَبَ
u'أَنَّ عَرَبِيٌّ':Predicate, #1: 1	أَنَّ الْعَرَبِيَّةَ
u'أَنَّ عَرْصَةٌ':Predicate, #4: 4	أَنَّ الْعَرَبِيَّ
u'أَنَّ عَرْضٌ':Predicate, #1: 1	أَنَّ الْعَرْصَةَ
u'أَنَّ عِرْضٌ':Predicate, #12: 12	أَنَّ الْعَرْضَ
u'أَنَّ عُرْضٌ':Predicate, #1: 1	أَنَّ الْعِرْضَ
u'أَنَّ عَرَضٌ':Predicate, #1: 1	أَنَّ عُرْضَ
u'أَنَّ عَرْضٌ':Predicate, #2: 2	أَنَّ الْعَرَضَ
u'أَنَّ عرف':Predicate, #2: 2	أَنَّ عَرْضَ
u'أَنَّ عُرْفٌ':Predicate, #4: 4	أَنَّ عُرْفَ
u'أَنَّ عرف':Predicate, #4: 4	أَنَّ عُرْفَ
u'أَنَّ عُرْفٌ':Predicate, #55: 55	أَنَّ الْعُرْفَ
u'أَنَّ عرفة':Predicate, #55: 55	أَنَّ الْعُرْفَ
u'أَنَّ عَرَقٌ':Predicate, #2: 2	أَنَّ عَرَفَةَ
u'أَنَّ عِرْقٌ':Predicate, #1: 1	أَنَّ الْعَرَقَ
u'أَنَّ عَرَقٌ':Predicate, #1: 1	أَنَّ الْعِرْقَ
u'أَنَّ عُرْوَةٌ':Predicate, #1: 1	أَنَّ عَرَقَ
u'أَنَّ عُرْوَةٌ':Predicate, #19: 19	أَنَّ عُرْوَةَ
u'أَنَّ عُرُوضٌ':Predicate, #1: 1	أَنَّ الْعُرْوَةَ
u'أَنَّ عُرُوضٌ':Predicate, #3: 3	أَنَّ عُرُوضَ
u'أَنَّ عُرُوقٌ':Predicate, #5: 5	أَنَّ الْعُرُوضَ
u'أَنَّ عُرْيَانٌ':Predicate, #3: 3	أَنَّ الْعُرُوقَ
u'أَنَّ عَزَائِمُ':Predicate, #1: 1	أَنَّ الْعُرْيَانَ
u'أَنَّ عِزَّةٌ':Predicate, #1: 1	أَنَّ عَزَائِمَ
u'أَنَّ عزل':Predicate, #1: 1	أَنَّ عِزَّةَ
u'أَنَّ عزل':Predicate, #13: 13	أَنَّ الْعَزْلَ
u'أَنَّ عَزْمٌ':Predicate, #3: 3	أَنَّ عَزْلَ
u'أَنَّ عَزِيزٌ':Predicate, #4: 4	أَنَّ الْعَزْمَ
u'أَنَّ عَزِيمَةٌ':Predicate, #1: 1	أَنَّ الْعَزِيزَ
u'أَنَّ عَزِيمَةٌ':Predicate, #1: 1	أَنَّ عَزِيمَةَ
u'أَنَّ عسر':Predicate, #3: 3	أَنَّ الْعَزِيمَةَ
u'أَنَّ عُسْرٌ':Predicate, #1: 1	أَنَّ الْعُسْرَ
u'أَنَّ عُسْرَةٌ':Predicate, #1: 1	أَنَّ الْعُسْرَ
u'أَنَّ عُسْرَةٌ':Predicate, #1: 1	أَنَّ الْعُسْرَةَ
u'أَنَّ عَسْكَرٌ':Predicate, #1: 1	أَنَّ عُسْرَةَ
u'أَنَّ عَسَلٌ':Predicate, #3: 3	أَنَّ الْعَسْكَرَ
u'أَنَّ عُسُولٌ':Predicate, #4: 4	أَنَّ الْعَسَلَ
u'أَنَّ عِشَاءٌ':Predicate, #1: 1	أَنَّ الْعُسُولَ
u'أَنَّ عُشْبٌ':Predicate, #5: 5	أَنَّ الْعِشَاءَ
u'أَنَّ عَشْرٌ':Predicate, #1: 1	أَنَّ الْعُشْبَ
u'أَنَّ عُشْرٌ':Predicate, #1: 1	أَنَّ عَشْرَ
u'أَنَّ عَشْرٌ':Predicate, #1: 1	أَنَّ عُشْرَ
u'أَنَّ عَشْرٌ':Predicate, #2: 2	أَنَّ عَشْرَةً
u'أَنَّ عَشْرٌ':Predicate, #2: 2	أَنَّ عَشْرَةَ
u'أَنَّ عُشْرٌ':Predicate, #3: 3	أَنَّ الْعَشْرَ
u'أَنَّ عصبة':Predicate, #9: 9	أَنَّ الْعُشْرَ
u'أَنَّ عَصَبَةٌ':Predicate, #1: 1	أَنَّ عَصَبَةَ
u'أَنَّ عصبة':Predicate, #1: 1	أَنَّ عَصَبَةَ
u'أَنَّ عَصَبَةٌ':Predicate, #2: 2	أَنَّ الْعَصَبَةَ
u'أَنَّ عَصَبِيٌّ':Predicate, #2: 2	أَنَّ الْعَصَبَةَ
u'أَنَّ عَصَبِيَّةٌ':Predicate, #2: 2	أَنَّ الْعَصَبِيَّةَ
u'أَنَّ عَصْرٌ':Predicate, #2: 2	أَنَّ الْعَصَبِيَّةَ
u'أَنَّ عِصْمَةٌ':Predicate, #14: 14	أَنَّ الْعَصْرَ
u'أَنَّ عِصْمَةٌ':Predicate, #10: 10	أَنَّ الْعِصْمَةَ
u'أَنَّ عِصْيَانٌ':Predicate, #4: 4	أَنَّ عِصْمَةَ
u'أَنَّ عَصِيرٌ':Predicate, #1: 1	أَنَّ الْعِصْيَانَ
u'أَنَّ عَضْب':Predicate, #9: 9	أَنَّ الْعَصِيرَ
u'أَنَّ عَضُدٌ':Predicate, #1: 1	أَنَّ الْعَضْبَ
u'أَنَّ عُضْوٌ':Predicate, #1: 1	أَنَّ عَضُدَ
u'أَنَّ عَطَاءٌ':Predicate, #3: 3	أَنَّ الْعُضْوَ
u'أَنَّ عُطاس':Predicate, #17: 17	أَنَّ عَطَاءَ
u'أَنَّ عَطْشَان':Predicate, #1: 1	أَنَّ الْعُطَاسَ
u'أَنَّ عطف':Predicate, #2: 2	أَنَّ الْعَطْشَانَ
u'أَنَّ عَطْفٌ':Predicate, #10: 10	أَنَّ الْعَطْفَ
u'أَنَّ عطف':Predicate, #10: 10	أَنَّ الْعَطْفَ
u'أَنَّ عَطْفٌ':Predicate, #3: 3	أَنَّ عَطْفَ
u'أَنَّ عَطِيَّةٌ':Predicate, #3: 3	أَنَّ عَطْفَ
u'أَنَّ عَطِيَّةٌ':Predicate, #2: 2	أَنَّ عَطِيَّةَ
u'أَنَّ عظام':Predicate, #5: 5	أَنَّ الْعَطِيَّةَ
u'أَنَّ عِظَامٌ':Predicate, #1: 1	أَنَّ عِظَامَ
u'أَنَّ عِظَةٌ':Predicate, #1: 1	أَنَّ عِظَامَ
u'أَنَّ عَظْمٌ':Predicate, #1: 1	أَنَّ الْعِظَةَ
u'أَنَّ عَظِيمٌ':Predicate, #3: 3	أَنَّ عَظْمَ
u'أَنَّ عَظِيم':Predicate, #1: 1	أَنَّ الْعَظِيمَ
u'أَنَّ عَظِيمٌ':Predicate, #1: 1	أَنَّ الْعَظِيمَ
u'أَنَّ عَظِيم':Predicate, #1: 1	أَنَّ عَظِيمَ
u'أَنَّ عِفَّةٌ':Predicate, #1: 1	أَنَّ عَظِيمَ
u'أَنَّ عَفْوٌ':Predicate, #2: 2	أَنَّ الْعِفَّةَ
u'أَنَّ عَفْوٌ':Predicate, #28: 28	أَنَّ الْعَفْوَ
u'أَنَّ عقاب':Predicate, #3: 3	أَنَّ عَفْوَ
u'أَنَّ عِقَابٌ':Predicate, #1: 1	أَنَّ عِقَابَ
u'أَنَّ عَقَارٌ':Predicate, #1: 1	أَنَّ عِقَابَ
u'أَنَّ عَقَائِدُ':Predicate, #10: 10	أَنَّ الْعَقَارَ
u'أَنَّ عقبة':Predicate, #1: 1	أَنَّ الْعَقَائِدَ
u'أَنَّ عُقْبَةٌ':Predicate, #7: 7	أَنَّ عُقْبَةَ
u'أَنَّ عَقْدٌ':Predicate, #7: 7	أَنَّ عُقْبَةَ
u'أَنَّ عُقَدٌ':Predicate, #148: 148	أَنَّ الْعَقْدَ
u'أَنَّ عِقْدٌ':Predicate, #1: 1	أَنَّ عُقَدَ
u'أَنَّ عَقْدٌ':Predicate, #1: 1	أَنَّ عِقْدَ
u'أَنَّ عقدة':Predicate, #36: 36	أَنَّ عَقْدَ
u'أَنَّ عُقْدَةٌ':Predicate, #3: 3	أَنَّ الْعُقْدَةَ
u'أَنَّ عقر':Predicate, #3: 3	أَنَّ الْعُقْدَةَ
u'أَنَّ عُقْرٌ':Predicate, #1: 1	أَنَّ عُقْرَ
u'أَنَّ عَقْرَبٌ':Predicate, #1: 1	أَنَّ عُقْرَ
u'أَنَّ عَقْلٌ':Predicate, #2: 2	أَنَّ الْعَقْرَبَ
u'أَنَّ عَقْلٌ':Predicate, #52: 52	أَنَّ الْعَقْلَ
u'أَنَّ عُقَلاَءُ':Predicate, #8: 8	أَنَّ عَقْلَ
u'أَنَّ عَقْلِيٌّ':Predicate, #1: 1	أَنَّ الْعُقَلَاءَ
u'أَنَّ عُقُوبَةٌ':Predicate, #4: 4	أَنَّ الْعَقْلِيَّةَ
u'أَنَّ عُقُوبَةٌ':Predicate, #1: 1	أَنَّ عُقُوبَةَ
u'أَنَّ عُقُودٌ':Predicate, #5: 5	أَنَّ الْعُقُوبَةَ
u'أَنَّ عُقُودٌ':Predicate, #1: 1	أَنَّ عُقُودَ
u'أَنَّ عَقُورٌ':Predicate, #8: 8	أَنَّ الْعُقُودَ
u'أَنَّ عُقُوقٌ':Predicate, #2: 2	أَنَّ الْعَقُورَ
u'أَنَّ عُقُولٌ':Predicate, #1: 1	أَنَّ الْعُقُوقَ
u'أَنَّ عَقِيقَةٌ':Predicate, #6: 6	أَنَّ الْعُقُولَ
u'أَنَّ عَكْسٌ':Predicate, #4: 4	أَنَّ الْعَقِيقَةَ
u'أَنَّ عَكْسٌ':Predicate, #2: 2	أَنَّ عَكْسَ
u'أَنَّ عَلاءٌ':Predicate, #7: 7	أَنَّ الْعَكْسَ
u'أَنَّ عَلاءٌ':Predicate, #1: 1	أَنَّ الْعَلَاءَ
u'أَنَّ عَلاَقَةٌ':Predicate, #2: 2	أَنَّ الْعَلاَءَ
u'أَنَّ عَلاَمَةٌ':Predicate, #5: 5	أَنَّ الْعَلَاقَةَ
u'أَنَّ عَلاَمَةٌ':Predicate, #2: 2	أَنَّ عَلَامَةَ
u'أَنَّ عَلاَنِيَةٌ':Predicate, #3: 3	أَنَّ الْعَلَامَةَ
u'أَنَّ عِلَّةٌ':Predicate, #3: 3	أَنَّ الْعَلَانِيَةَ
u'أَنَّ عِلَّةٌ':Predicate, #131: 131	أَنَّ الْعِلَّةَ
u'أَنَّ عِلْجٌ':Predicate, #57: 57	أَنَّ عِلَّةَ
u'أَنْعَلَ خُفٌّ':Predicate, #1: 1	أَنَّ الْعِلْجَ
u'أَنْعَلَ دَابَّةٌ':Predicate, #1: 1	أَنْعَلَ الْخُفَّ
u'أَنَّ عَلَفٌ':Predicate, #2: 2	أَنْعَلَ الدَّابَّةَ
u'أَنَّ عَلَقَةٌ':Predicate, #2: 2	أَنَّ الْعَلَفَ
u'أَنَّ عَلْقَم':Predicate, #3: 3	أَنَّ الْعَلَقَةَ
u'أَنَّ عَلْقَمَة':Predicate, #7: 7	أَنَّ عَلْقَمَةَ
u'أَنَّ عِلَلٌ':Predicate, #7: 7	أَنَّ عَلْقَمَةَ
u'أَنَّ علم':Predicate, #11: 11	أَنَّ الْعِلَلَ
u'أَنَّ عِلْمٌ':Predicate, #22: 22	أَنَّ عِلْمَ
u'أَنَّ علم':Predicate, #22: 22	أَنَّ عِلْمَ
u'أَنَّ عَلَمٌ':Predicate, #3: 3	أَنَّ الْعَلَمَ
u'أَنَّ علم':Predicate, #3: 3	أَنَّ الْعَلَمَ
u'أَنَّ عِلْمٌ':Predicate, #54: 54	أَنَّ الْعِلْمَ
u'أَنَّ علم':Predicate, #54: 54	أَنَّ الْعِلْمَ
u'أَنَّ عَلَمٌ':Predicate, #5: 5	أَنَّ عَلَمَ
u'أَنَّ علماء':Predicate, #5: 5	أَنَّ عَلَمَ
u'أَنَّ عُلَمَاءُ':Predicate, #37: 37	أَنَّ الْعُلَمَاءَ
u'أَنَّ علماء':Predicate, #37: 37	أَنَّ الْعُلَمَاءَ
u'أَنَّ عُلَمَاءُ':Predicate, #6: 6	أَنَّ عُلَمَاءَ
u'أَنَّ عُلْوٌ':Predicate, #6: 6	أَنَّ عُلَمَاءَ
u'أَنَّ عُلُوٌّ':Predicate, #1: 1	أَنَّ الْعُلْوَ
u'أَنَّ عُلُوٌّ':Predicate, #1: 1	أَنَّ عُلُوَّ
u'أَنَّ عَلُوفَة':Predicate, #4: 4	أَنَّ الْعُلُوَّ
u'أَنَّ عُلُوقٌ':Predicate, #1: 1	أَنَّ الْعَلُوفَةَ
u'أَنَّ عُلُومٌ':Predicate, #21: 21	أَنَّ الْعُلُوقَ
u'أَنَّ عُلُومٌ':Predicate, #12: 12	أَنَّ الْعُلُومَ
u'أَنَّ عَلِيٌّ':Predicate, #1: 1	أَنَّ عُلُومَ
u'أَنَّ عِلِّيٌّ':Predicate, #18: 18	أَنَّ عَلِيَّ
u'أَنَّ عَمٌّ':Predicate, #2: 2	أَنَّ الْعِلِّيَّةَ
u'أَنَّ عَمٌّ':Predicate, #4: 4	أَنَّ الْعَمَّ
u'أَنَّ عِمَادٌ':Predicate, #6: 6	أَنَّ عَمَّ
u'أَنَّ عِمَارَةٌ':Predicate, #1: 1	أَنَّ الْعِمَادَ
u'أَنَّ عُمَارَةٌ':Predicate, #2: 2	أَنَّ عِمَارَةَ
u'أَنَّ عِمَارَةٌ':Predicate, #5: 5	أَنَّ عُمَارَةَ
u'أَنَّ عِمَامَةٌ':Predicate, #6: 6	أَنَّ الْعِمَارَةَ
u'أَنَّ عُمَانُ':Predicate, #5: 5	أَنَّ الْعِمَامَةَ
u'أَنَّ عَمَّةٌ':Predicate, #1: 1	أَنَّ عُمَانَ
u'أَنَّ عَمَّةٌ':Predicate, #4: 4	أَنَّ عَمَّةَ
u'أَنَّ عَمْد':Predicate, #5: 5	أَنَّ الْعَمَّةَ
u'أَنَّ عَمْدٌ':Predicate, #1: 1	أَنَّ الْعَمْدِيَّةَ
u'أَنَّ عَمْدٌ':Predicate, #1: 1	أَنَّ عَمْدَ
u'أَنَّ عُمْدَةٌ':Predicate, #4: 4	أَنَّ الْعَمْدَ
u'أَنَّ عَمْدِيّ':Predicate, #2: 2	أَنَّ الْعُمْدَةَ
u'أَنَّ عُمُرٌ':Predicate, #1: 1	أَنَّ الْعَمْدِيَّةَ
u'أَنَّ عُمُرٌ':Predicate, #1: 1	أَنَّ الْعُمُرَ
u'أَنَّ عُمَرٌ':Predicate, #1: 1	أَنَّ عُمُرَ
u'أَنَّ عمرة':Predicate, #801: 801	أَنَّ عُمَرَ
u'أَنَّ عُمْرَةٌ':Predicate, #17: 17	أَنَّ الْعُمْرَةَ
u'أَنَّ عمرة':Predicate, #17: 17	أَنَّ الْعُمْرَةَ
u'أَنَّ عُمْرَةٌ':Predicate, #1: 1	أَنَّ عُمْرَةَ
u'أَنَّ عمرة':Predicate, #1: 1	أَنَّ عُمْرَةَ
u'أَنَّ عمش':Predicate, #4: 4	أَنَّ عَمْرَةَ
u'أَنَّ عَمَلٌ':Predicate, #1: 1	أَنَّ الْعُمْشَ
u'أَنَّ عَمَلٌ':Predicate, #18: 18	أَنَّ عَمَلَ
u'أَنَّ عَمَلِيٌّ':Predicate, #76: 76	أَنَّ الْعَمَلَ
u'أَنَّ عُمُومٌ':Predicate, #1: 1	أَنَّ الْعَمَلِيَّ
u'أَنَّ عُمُوم':Predicate, #18: 18	أَنَّ عُمُومَ
u'أَنَّ عُمُومٌ':Predicate, #3: 3	أَنَّ عُمُومَةً
u'أَنَّ عمياء':Predicate, #55: 55	أَنَّ الْعُمُومَ
u'أَنَّ عَنَاءٌ':Predicate, #1: 1	أَنَّ الْعَمْيَاءَ
u'أَنَّ عُنَّابٌ':Predicate, #1: 1	أَنَّ الْعَنَاءَ
u'أَنَّ عِنان':Predicate, #1: 1	أَنَّ الْعُنَّابَ
u'أَنَّ عَنَانٌ':Predicate, #1: 1	أَنَّ الْعِنَانَ
u'أَنَّ عِنَانٌ':Predicate, #1: 1	أَنَّ الْعَنَانَ
u'أَنَّ عِنَبٌ':Predicate, #1: 1	أَنَّ الْعِنَانَ
u'أَنَّ عُنَّة':Predicate, #1: 1	أَنَّ الْعِنَبَ
u'أَنَّ عند':Predicate, #3: 3	أَنَّ الْعُنَّةَ
u'أَنَّ عُنْوَانٌ':Predicate, #133: 133	أَنَّ عِنْدَ
u'أَنَّ عَهْدٌ':Predicate, #1: 1	أَنَّ الْعُنْوَانَ
u'أَنَّ عُهْدَةٌ':Predicate, #10: 10	أَنَّ الْعَهْدَ
u'أَنَّ عُهْدَةٌ':Predicate, #2: 2	أَنَّ عُهْدَةَ
u'أَنَّ عَوَارِضُ':Predicate, #9: 9	أَنَّ الْعُهْدَةَ
u'أَنَّ عَوَاقِلُ':Predicate, #1: 1	أَنَّ الْعَوَارِضَ
u'أَنَّ عَوَّامٌ':Predicate, #3: 3	أَنَّ الْعَوَاقِلَ
u'أَنَّ عَوَامُّ':Predicate, #1: 1	أَنَّ الْعَوَّامَ
u'أَنَّ عَوَائِدُ':Predicate, #2: 2	أَنَّ الْعَوَامَّ
u'أَنَّ عَوْدٌ':Predicate, #1: 1	أَنَّ الْعَوَائِدَ
u'أَنَّ عُودٌ':Predicate, #12: 12	أَنَّ الْعَوْدَ
u'أَنَّ عَوْدٌ':Predicate, #3: 3	أَنَّ الْعُودَ
u'أَنَّ عَوْدَةٌ':Predicate, #5: 5	أَنَّ عَوْدَ
u'أَنَّ عَوْرَةٌ':Predicate, #2: 2	أَنَّ الْعَوْدَةَ
u'أَنَّ عَوْرَةٌ':Predicate, #3: 3	أَنَّ الْعَوْرَةَ
u'أَنَّ عِوَضٌ':Predicate, #7: 7	أَنَّ عَوْرَةَ
u'أَنَّ عِيَادَةٌ':Predicate, #11: 11	أَنَّ الْعِوَضَ
u'أَنَّ عِيَادَةٌ':Predicate, #1: 1	أَنَّ الْعِيَادَةَ
u'أَنَّ عِيَانٌ':Predicate, #2: 2	أَنَّ عِيَادَةَ
u'أَنَّ عَيْبٌ':Predicate, #1: 1	أَنَّ الْعِيَانَ
u'أَنَّ عِيدٌ':Predicate, #30: 30	أَنَّ الْعَيْبَ
u'أَنَّ عِيدٌ':Predicate, #1: 1	أَنَّ عِيدَ
u'أَنَّ عين':Predicate, #2: 2	أَنَّ الْعِيدَ
u'أَنَّ عَيْنٌ':Predicate, #12: 12	أَنَّ عَيْنَ
u'أَنَّ عَيْن':Predicate, #12: 12	أَنَّ عَيْنَ
u'أَنَّ عين':Predicate, #12: 12	أَنَّ عَيْنَ
u'أَنَّ عَيْنٌ':Predicate, #73: 73	أَنَّ الْعَيْنَ
u'أَنَّ عَيْن':Predicate, #73: 73	أَنَّ الْعَيْنَ
u'أَنَّ عَيْنِيَّةٌ':Predicate, #73: 73	أَنَّ الْعَيْنَ
u'أَنَّ عُيُوبٌ':Predicate, #1: 1	أَنَّ الْعَيْنِيَّةَ
u'أَنَّ عُيُوبٌ':Predicate, #1: 1	أَنَّ الْعُيُوبَ
u'أَنَّ عُيُونٌ':Predicate, #3: 3	أَنَّ عُيُوبَ
u'أَنَّ غاسِل':Predicate, #4: 4	أَنَّ عُيُونَ
u'أَنَّ غاسِل':Predicate, #1: 1	أَنَّ غَاسِلَ
u'أَنَّ غَاشٌّ':Predicate, #2: 2	أَنَّ الْغَاسِلَ
u'أَنَّ غَاصِبٌ':Predicate, #2: 2	أَنَّ الْغَاشَّ
u'أَنَّ غَاصِبٌ':Predicate, #2: 2	أَنَّ غَاصِبَ
u'أَنَّ غَافِلٌ':Predicate, #51: 51	أَنَّ الْغَاصِبَ
u'أَنَّ غَالِبٌ':Predicate, #1: 1	أَنَّ الْغَافِلَ
u'أَنَّ غَالِبٌ':Predicate, #14: 14	أَنَّ غَالِبَ
u'أَنَّ غانِم':Predicate, #47: 47	أَنَّ الْغَالِبَ
u'أَنَّ غَائِبٌ':Predicate, #3: 3	أَنَّ الْغَانِمِينَ
u'أَنَّ غَائِصٌ':Predicate, #37: 37	أَنَّ الْغَائِبَ
u'أَنَّ غَايَةٌ':Predicate, #1: 1	أَنَّ الْغَائِصَ
u'أَنَّ غَايَةٌ':Predicate, #12: 12	أَنَّ الْغَايَةَ
u'أَنَّ غبار':Predicate, #8: 8	أَنَّ غَايَةَ
u'أَنَّ غُبَارٌ':Predicate, #1: 1	أَنَّ غُبَارَ
u'أَنَّ غبار':Predicate, #1: 1	أَنَّ غُبَارَ
u'أَنَّ غُبَارٌ':Predicate, #3: 3	أَنَّ الْغُبَارَ
u'أَنَّ غِبْطَةٌ':Predicate, #3: 3	أَنَّ الْغُبَارَ
u'أَنَّ غَبْنٌ':Predicate, #2: 2	أَنَّ الْغِبْطَةَ
u'أَنَّ غداة':Predicate, #5: 5	أَنَّ الْغَبْنَ
u'أَنَّ غَدَاةٌ':Predicate, #1: 1	أَنَّ الْغَدَاةَ
u'أَنَّ غَدْرٌ':Predicate, #1: 1	أَنَّ الْغَدَاةَ
u'أَنَّ غَدِيرٌ':Predicate, #1: 1	أَنَّ الْغَدْرَ
u'أَنَّ غِذَاءٌ':Predicate, #2: 2	أَنَّ الْغَدِيرَ
u'أَنَّ غُرَابٌ':Predicate, #1: 1	أَنَّ غِذَاءَ
u'أَنَّ غِرَارَةٌ':Predicate, #2: 2	أَنَّ الْغُرَابَ
u'أَنَّ غِرَاسٌ':Predicate, #1: 1	أَنَّ الْغِرَارَةَ
u'أَنَّ غرباء':Predicate, #3: 3	أَنَّ الْغِرَاسَ
u'أَنَّ غُرَّةٌ':Predicate, #1: 1	أَنَّ الْغُرَبَاءَ
u'أَنَّ غَرَضٌ':Predicate, #5: 5	أَنَّ الْغُرَّةَ
u'أَنَّ غَرَضٌ':Predicate, #10: 10	أَنَّ غَرَضَ
u'أَنَّ غُرْمٌ':Predicate, #16: 16	أَنَّ الْغَرَضَ
u'أَنَّ غرماء':Predicate, #4: 4	أَنَّ الْغُرْمَ
u'أَنَّ غَرِيبٌ':Predicate, #17: 17	أَنَّ الْغُرَمَاءَ
u'أَنَّ غَرِيبٌ':Predicate, #1: 1	أَنَّ الْغَرِيبَةَ
u'أَنَّ غَرِيمٌ':Predicate, #3: 3	أَنَّ الْغَرِيبَ
u'أَنَّ غَرِيمٌ':Predicate, #20: 20	أَنَّ الْغَرِيمَ
u'أَنَّ غَزْلٌ':Predicate, #2: 2	أَنَّ غَرِيمَ
u'أَنَّ غَزْلٌ':Predicate, #1: 1	أَنَّ الْغَزْلَ
u'أَنَّ غَزْوَةٌ':Predicate, #4: 4	أَنَّ غَزْلَ
u'أَنَّ غُسَالَةٌ':Predicate, #1: 1	أَنَّ غَزْوَةَ
u'أَنَّ غَسَّانٌ':Predicate, #2: 2	أَنَّ غُسَالَةَ
u'أَنَّ غَسْلٌ':Predicate, #2: 2	أَنَّ غَسَّانَ
u'أَنَّ غُسْلٌ':Predicate, #20: 20	أَنَّ غَسْلَ
u'أَنَّ غَسْلٌ':Predicate, #29: 29	أَنَّ الْغُسْلَ
u'أَنَّ غُسْلٌ':Predicate, #8: 8	أَنَّ الْغَسْلَ
u'أَنَّ غِشٌّ':Predicate, #9: 9	أَنَّ غُسْلَ
u'أَنَّ غَصْبٌ':Predicate, #3: 3	أَنَّ الْغِشَّ
u'أَنَّ غَصْبٌ':Predicate, #13: 13	أَنَّ غَصْبَ
u'أَنَّ غَضٌّ':Predicate, #19: 19	أَنَّ الْغَصْبَ
u'أَنَّ غضب':Predicate, #1: 1	أَنَّ غَضَّ
u'أَنَّ غَضَبٌ':Predicate, #10: 10	أَنَّ غَضَبَ
u'أَنَّ غضب':Predicate, #10: 10	أَنَّ غَضَبَ
u'أَنَّ غَضَبٌ':Predicate, #6: 6	أَنَّ الْغَضَبَ
u'أَنَّ غفلة':Predicate, #6: 6	أَنَّ الْغَضَبَ
u'أَنَّ غَفْلَةٌ':Predicate, #6: 6	أَنَّ الْغَفْلَةَ
u'أَنَّ غُلاَمٌ':Predicate, #6: 6	أَنَّ الْغَفْلَةَ
u'أَنَّ غَلَبَةٌ':Predicate, #17: 17	أَنَّ الْغُلَامَ
u'أَنَّ غَلَبَةٌ':Predicate, #2: 2	أَنَّ غَلَبَةَ
u'أَنَّ غَلَّةٌ':Predicate, #8: 8	أَنَّ الْغَلَبَةَ
u'أَنَّ غَلَّةٌ':Predicate, #3: 3	أَنَّ غَلَّةَ
u'أَنَّ غَلَطٌ':Predicate, #9: 9	أَنَّ الْغَلَّةَ
u'أَنَّ غُلُول':Predicate, #5: 5	أَنَّ الْغَلَطَ
u'أَنَّ غَلَيَانٌ':Predicate, #2: 2	أَنَّ الْغُلُولَ
u'أَنَّ غَلِيظٌ':Predicate, #2: 2	أَنَّ الْغَلَيَانَ
u'أَنَّ غَمُوس':Predicate, #1: 1	أَنَّ الْغَلِيظَةَ
u'أَنَّ غناء':Predicate, #1: 1	أَنَّ الْغَمُوسَ
u'أَنَّ غِنَاءٌ':Predicate, #4: 4	أَنَّ الْغِنَاءَ
u'أَنَّ غَنَمٌ':Predicate, #4: 4	أَنَّ الْغِنَاءَ
u'أَنَّ غَنَمٌ':Predicate, #1: 1	أَنَّ الْغَنَمَ
u'أَنَّ غَنِيٌّ':Predicate, #2: 2	أَنَّ غَنَمَ
u'أَنَّ غَنِيمَةٌ':Predicate, #4: 4	أَنَّ الْغَنِيَّ
u'أَنَّ غَنِيمَةٌ':Predicate, #11: 11	أَنَّ الْغَنِيمَةَ
u'أَنَّ غُولٌ':Predicate, #1: 1	أَنَّ غَنِيمَةَ
u'أَنَّ غِيبَةٌ':Predicate, #1: 1	أَنَّ الْغُولَ
u'أَنَّ غِيبَةٌ':Predicate, #16: 16	أَنَّ الْغِيبَةَ
u'أَنَّ غَيْبَةٌ':Predicate, #1: 1	أَنَّ غِيبَةَ
u'أَنَّ غَيْبَةٌ':Predicate, #1: 1	أَنَّ غَيْبَةَ
u'أَنَّ غير':Predicate, #4: 4	أَنَّ الْغَيْبَةَ
u'أَنَّ غَيْرٌ':Predicate, #132: 132	أَنَّ غَيْرَ
u'أَنَّ غير':Predicate, #132: 132	أَنَّ غَيْرَ
u'أَنَّ غَيْرٌ':Predicate, #3: 3	أَنَّ الْغَيْرَ
u'أَنَّ غَيْرِيَّةٌ':Predicate, #3: 3	أَنَّ الْغَيْرَ
u'أَنَّ فاء':Predicate, #1: 1	أَنَّ غَيْرِيَّةَ
u'أَنَّ فَاتِحٌ':Predicate, #11: 11	أَنَّ الْفَاءَ
u'أَنَّ فَاتِحَةٌ':Predicate, #12: 12	أَنَّ الْفَاتِحَةَ
u'أَنَّ فَاجِرٌ':Predicate, #12: 12	أَنَّ الْفَاتِحَةَ
u'أَنَّ فَاحِشٌ':Predicate, #1: 1	أَنَّ الْفَاجِرَ
u'أَنَّ فَاحِشٌ':Predicate, #1: 1	أَنَّ الْفَاحِشَةَ
u'أَنَّ فَأْرٌ':Predicate, #9: 9	أَنَّ الْفَاحِشَ
u'أَنَّ فَأْرٌ':Predicate, #1: 1	أَنَّ فَأْرَةً
u'أَنَّ فَارِسِيٌّ':Predicate, #2: 2	أَنَّ الْفَأْرَةَ
u'أَنَّ فَارِسِيٌّ':Predicate, #1: 1	أَنَّ الْفَارِسِيَّةَ
u'أَنَّ فَارِقٌ':Predicate, #2: 2	أَنَّ الْفَارِسِيَّ
u'أَنَّ فَاسِدٌ':Predicate, #3: 3	أَنَّ الْفَارِقَ
u'أَنَّ فَاسِدٌ':Predicate, #11: 11	أَنَّ الْفَاسِدَ
u'أَنَّ فَاسِدٌ':Predicate, #1: 1	أَنَّ الْفَاسِدَةَ
u'أَنَّ فَاسِقٌ':Predicate, #4: 4	أَنَّ فَاسِدَ
u'أَنَّ فَاسِقٌ':Predicate, #24: 24	أَنَّ الْفَاسِقَ
u'أَنَّ فَاصِلٌ':Predicate, #2: 2	أَنَّ الْفَاسِقَةَ
u'أَنَّ فَاضِلٌ':Predicate, #1: 1	أَنَّ الْفَاصِلَ
u'أَنَّ فَاطِمٌ':Predicate, #4: 4	أَنَّ الْفَاضِلَ
u'أَنَّ فَاعِلٌ':Predicate, #81: 81	أَنَّ فَاطِمَةَ
u'أَنَّ فَاعِلٌ':Predicate, #7: 7	أَنَّ الْفَاعِلَ
u'أَنَّ فَاقِدٌ':Predicate, #8: 8	أَنَّ فَاعِلَ
u'أَنَّ فَاقِدٌ':Predicate, #1: 1	أَنَّ فَاقِدَةَ
u'أَنَّ فَاكِهٌ':Predicate, #4: 4	أَنَّ فَاقِدَ
u'أَنَّ فَاكِهَةٌ':Predicate, #3: 3	أَنَّ الْفَاكِهَةَ
u'أَنَّ فَأْلٌ':Predicate, #3: 3	أَنَّ الْفَاكِهَةَ
u'أَنَّ فَائِدَةٌ':Predicate, #1: 1	أَنَّ الْفَأْلَ
u'أَنَّ فَائِدَةٌ':Predicate, #23: 23	أَنَّ فَائِدَةَ
u'أَنَّ فَائِقٌ':Predicate, #5: 5	أَنَّ الْفَائِدَةَ
u'أَنَّ فَتْحٌ':Predicate, #1: 1	أَنَّ الْفَائِقَةَ
u'أَنَّ فَتْحٌ':Predicate, #5: 5	أَنَّ فَتْحَ
u'أَنَّ فترة':Predicate, #6: 6	أَنَّ الْفَتْحَ
u'أَنَّ فَتْرَةٌ':Predicate, #1: 1	أَنَّ الْفَتْرَةَ
u'أَنَّ فَتْقٌ':Predicate, #1: 1	أَنَّ الْفَتْرَةَ
u'أَنَّ فتنة':Predicate, #2: 2	أَنَّ الْفَتْقَ
u'أَنَّ فِتْنَةٌ':Predicate, #4: 4	أَنَّ الْفِتْنَةَ
u'أَنَّ فَجْرٌ':Predicate, #4: 4	أَنَّ الْفِتْنَةَ
u'أَنَّ فَجْرٌ':Predicate, #1: 1	أَنَّ فَجْرَ
u'أَنَّ فَحْصٌ':Predicate, #30: 30	أَنَّ الْفَجْرَ
u'أَنَّ فَحْمٌ':Predicate, #1: 1	أَنَّ فَحْصَ
u'أَنَّ فخر':Predicate, #1: 1	أَنَّ الْفَحْمَ
u'أَنَّ فَخْرٌ':Predicate, #5: 5	أَنَّ فَخْرَ
u'أَنَّ فِدَاءٌ':Predicate, #5: 5	أَنَّ فَخْرَ
u'أَنْفَدَ مَقَاتِلُ':Predicate, #3: 3	أَنَّ فِدَاءَ
u'أَنَّ فِدْيَةٌ':Predicate, #1: 1	أَنْفَدَ الْمَقَاتِلَ
u'أَنَّ فِدْيَةٌ':Predicate, #2: 2	أَنَّ فِدْيَةَ
u'أَنَّ فَذٌّ':Predicate, #5: 5	أَنَّ الْفِدْيَةَ
u'أَنْفَذَ اِبْنٌ':Predicate, #3: 3	أَنَّ الْفَذَّ
u'أَنْفَذَ اِجْتِهَادٌ':Predicate, #1: 1	أَنْفَذَ ابْنَ
u'أَنْفَذَ أَوَّلُ':Subject, #1: 1	أَنْفَذَ اجْتِهَادَ
u'أَنْفَذَ آيَةٌ':Predicate, #1: 1	أَنْفَذَ الْأَوَّلُ
u'أَنْفَذَ حُكْمٌ':Predicate, #1: 1	أَنْفَذَ الْآيَةَ
u'أَنْفَذَ زَوْجٌ':Subject, #2: 2	أَنْفَذَ الْحُكْمَ
u'أَنْفَذَ سُلْطَانٌ':Subject, #1: 1	أَنْفَذَ الزَّوْجُ
u'أَنْفَذَ سَهْمٌ':Subject, #2: 2	أَنْفَذَ السُّلْطَانُ
u'أَنْفَذَ عين':Predicate, #2: 2	أَنْفَذَ السَّهْمُ
u'أَنْفَذَ عَيْنٌ':Predicate, #1: 1	أَنْفَذَ الْعَيْنَ
u'أَنْفَذَ عَيْن':Predicate, #1: 1	أَنْفَذَ الْعَيْنَ
u'أَنْفَذَ قَاتِلٌ':Subject, #1: 1	أَنْفَذَ الْعَيْنَ
u'أَنْفَذَ قَضَاءٌ':Predicate, #1: 1	أَنْفَذَ قَاتِلُهُ
u'أَنْفَذَ مَقَاتِلُ':Predicate, #2: 2	أَنْفَذَ الْقَضَاءَ
u'أَنْفَذَ مَقْتَلٌ':Predicate, #1: 1	أَنْفَذَ مَقَاتِلَ
u'أَنْفَذَ مَقْتَلٌ':Subject, #1: 1	أَنْفَذَ مَقْتَلَ
u'أَنْفَذَ مِقْدَارٌ':Predicate, #1: 1	أَنْفَذَ مَقْتَلٌ
u'أَنْفَذَ نَبِيٌّ':Subject, #1: 1	أَنْفَذَ مِقْدَارَ
u'أَنْفَذَ وَصِيٌّ':Predicate, #3: 3	أَنْفَذَ النَّبِيُّ
u'أَنْفَذَ وَصِيَّةٌ':Predicate, #3: 3	أَنْفَذَ الْوَصِيَّةَ
u'أَنَّ فُرَاتٌ':Predicate, #3: 3	أَنْفَذَ الْوَصِيَّةَ
u'أَنَّ فرار':Predicate, #1: 1	أَنَّ فُرَاتَ
u'أَنَّ فِرَارٌ':Predicate, #1: 1	أَنَّ الْفِرَارَ
u'أَنَّ فِرَاشٌ':Predicate, #1: 1	أَنَّ الْفِرَارَ
u'أَنَّ فِرَاشٌ':Predicate, #1: 1	أَنَّ فِرَاشَ
u'أَنَّ فراغ':Predicate, #8: 8	أَنَّ الْفِرَاشَ
u'أَنَّ فَرَاغٌ':Predicate, #2: 2	أَنَّ فَرَاغَ
u'أَنَّ فِرَاقٌ':Predicate, #2: 2	أَنَّ فَرَاغَ
u'أَنَّ فَرَائِضُ':Predicate, #3: 3	أَنَّ الْفِرَاقَ
u'أَنَّ فَرَائِضُ':Predicate, #3: 3	أَنَّ الْفَرَائِضَ
u'أَنَّ فَرَجٌ':Predicate, #3: 3	أَنَّ فَرَائِضَ
u'أَنَّ فَرْجٌ':Predicate, #1: 1	أَنَّ الْفَرَجَ
u'أَنَّ فُرْجَةٌ':Predicate, #1: 1	أَنَّ الْفَرْجَ
u'أَنَّ فرح':Predicate, #1: 1	أَنَّ الْفُرْجَةَ
u'أَنَّ فَرَحٌ':Predicate, #2: 2	أَنَّ الْفَرَحَ
u'أَنَّ فَرْدٌ':Predicate, #2: 2	أَنَّ الْفَرَحَ
u'أَنَّ فرد':Predicate, #1: 1	أَنَّ الْفَرْدِيَّةَ
u'أَنَّ فَرْدٌ':Predicate, #2: 2	أَنَّ الْفَرْدَ
u'أَنَّ فَرْدِيٌّ':Predicate, #2: 2	أَنَّ الْفَرْدَ
u'أَنَّ فَرْدِيَّةٌ':Predicate, #1: 1	أَنَّ الْفَرْدِيَّةَ
u'أَنَّ فَرَسٌ':Predicate, #1: 1	أَنَّ الْفَرْدِيَّةَ
u'أَنَّ فَرْشٌ':Predicate, #5: 5	أَنَّ الْفَرَسَ
u'أَنَّ فَرْض':Predicate, #1: 1	أَنَّ الْفَرْشَ
u'أَنَّ فَرْضٌ':Predicate, #3: 3	أَنَّ الْفَرْضِيَّةَ
u'أَنَّ فَرْضٌ':Predicate, #41: 41	أَنَّ فَرْضَ
u'أَنَّ فَرْضِيّ':Predicate, #61: 61	أَنَّ الْفَرْضَ
u'أَنَّ فَرْضِيّ':Predicate, #1: 1	أَنَّ الْفَرْضِيِّينَ
u'أَنَّ فَرْضِيَّة':Predicate, #3: 3	أَنَّ الْفَرْضِيَّةَ
u'أَنَّ فَرْطٌ':Predicate, #3: 3	أَنَّ الْفَرْضِيَّةَ
u'أَنَّ فَرْعٌ':Predicate, #2: 2	أَنَّ فَرْطَ
u'أَنَّ فَرْعٌ':Predicate, #17: 17	أَنَّ الْفَرْعَ
u'أَنَّ فِرْعَوْنُ':Predicate, #2: 2	أَنَّ فَرْعَ
u'أَنَّ فَرْعِيٌّ':Predicate, #4: 4	أَنَّ فِرْعَوْنَ
u'أَنَّ فرق':Predicate, #1: 1	أَنَّ الْفَرْعِيَّةَ
u'أَنَّ فِرَقٌ':Predicate, #1: 1	أَنَّ الْفِرَقَ
u'أَنَّ فرق':Predicate, #1: 1	أَنَّ الْفِرَقَ
u'أَنَّ فرق':Predicate, #1: 1	أَنَّ فَرْقَ
u'أَنَّ فَرْقٌ':Predicate, #1: 1	أَنَّ فِرَقَ
u'أَنَّ فِرَقٌ':Predicate, #1: 1	أَنَّ فَرْقَ
u'أَنَّ فرق':Predicate, #1: 1	أَنَّ فِرَقَ
u'أَنَّ فَرْقٌ':Predicate, #1: 1	أَنَّ فَرْقَكَ
u'أَنَّ فرق':Predicate, #1: 1	أَنَّ فَرْقَكَ
u'أَنَّ فرق':Predicate, #2: 2	أَنَّ الْفَرَقَ
u'أَنَّ فَرْقٌ':Predicate, #51: 51	أَنَّ الْفَرْقَ
u'أَنَّ فِرْقَةٌ':Predicate, #51: 51	أَنَّ الْفَرْقَ
u'أَنَّ فِرْقَةٌ':Predicate, #1: 1	أَنَّ فِرْقَةَ
u'أَنَّ فُرْقَةٌ':Predicate, #2: 2	أَنَّ الْفِرْقَةَ
u'أَنَّ فُرْقَةٌ':Predicate, #2: 2	أَنَّ فُرْقَةَ
u'أَنَّ فَرْوَةٌ':Predicate, #45: 45	أَنَّ الْفُرْقَةَ
u'أَنَّ فَرُّوخٌ':Predicate, #2: 2	أَنَّ فَرْوَةَ
u'أَنَّ فُرُوضٌ':Predicate, #1: 1	أَنَّ فَرُّوخَ
u'أَنَّ فُرُوضٌ':Predicate, #1: 1	أَنَّ فُرُوضَ
u'أَنَّ فُرُوعٌ':Predicate, #3: 3	أَنَّ الْفُرُوضَ
u'أَنَّ فُرُوعٌ':Predicate, #10: 10	أَنَّ الْفُرُوعَ
u'أَنَّ فَرِيضَةٌ':Predicate, #2: 2	أَنَّ فُرُوعَ
u'أَنَّ فَرِيضَةٌ':Predicate, #1: 1	أَنَّ فَرِيضَةَ
u'أَنَّ فَرِيقٌ':Predicate, #3: 3	أَنَّ الْفَرِيضَةَ
u'أَنَّ فساد':Predicate, #6: 6	أَنَّ الْفَرِيقَ
u'أَنَّ فَسَادٌ':Predicate, #30: 30	أَنَّ فَسَادَ
u'أَنَّ فساد':Predicate, #30: 30	أَنَّ فَسَادَ
u'أَنَّ فَسَادٌ':Predicate, #43: 43	أَنَّ الْفَسَادَ
u'أَنْفُسٌ أَعْرَاضٌ':Added, #43: 43	أَنَّ الْفَسَادَ
u'أَنْفُسٌ أَعْمَالٌ':Added, #1: 1	أَنْفُسَ الْأَعْرَاضِ
u'أَنَّ فُسَّاقٌ':Predicate, #1: 1	أَنْفُسُ الْأَعْمَالِ
u'أَنْفُسٌ أهْلٌ':Added, #4: 4	أَنَّ الْفُسَّاقَ
u'أَنْفُسٌ أَوْسَاطٌ':Added, #2: 2	أَنْفُسَ أَهْلِ
u'أَنْفُسٌ تَكاليفُ':Added, #2: 2	أَنْفُسِ أَوْسَاطِ
u'أَنْفُسٌ تَكالِيفُ':Added, #1: 1	أَنْفُسِ التَّكَالِيفِ
u'أَنَّ فَسْخٌ':Predicate, #1: 1	أَنْفُسِ التَّكَالِيفِ
u'أَنَّ فَسْخٌ':Predicate, #11: 11	أَنَّ فَسْخَ
u'أَنْفُسٌ رَقَب':Added, #43: 43	أَنَّ الْفَسْخَ
u'أَنْفُسٌ سُوءٌ':Added, #1: 1	أَنْفُسِ رَقَبَتَيْنِ
u'أَنَّ فِسْقٌ':Predicate, #1: 1	أَنْفُسَ سُوءٍ
u'أَنَّ فسقة':Predicate, #9: 9	أَنَّ الْفِسْقَ
u'أَنَّ فسقة':Predicate, #1: 1	أَنَّ الْفَسَقَةَ
u'أَنْفُسٌ مُحَمَّدٌ':Added, #2: 2	أَنَّ فَسَقَةَ
u'أَنْفُسٌ نَاسٌ':Added, #1: 1	أَنْفُسٍ مُحَمَّدٍ
u'أَنَّ فُسُوقٌ':Predicate, #3: 3	أَنْفُسِ النَّاسِ
u'أَنَّ فَصٌّ':Predicate, #1: 1	أَنَّ الْفُسُوقَ
u'أَنَّ فَصٌّ':Predicate, #1: 1	أَنَّ فَصَّ
u'أَنَّ فِصاد':Predicate, #2: 2	أَنَّ الْفَصَّ
u'أَنَّ فَصْد':Predicate, #1: 1	أَنَّ الْفِصَادَ
u'أَنَّ فَصْلٌ':Predicate, #1: 1	أَنَّ الْفَصْدَ
u'أَنَّ فَصْلٌ':Predicate, #20: 20	أَنَّ الْفَصْلَ
u'أَنَّ فُصُولٌ':Predicate, #3: 3	أَنَّ فَصْلَ
u'أَنَّ فَصِيلَةٌ':Predicate, #1: 1	أَنَّ فُصُولَ
u'أَنَّ فَضٌّ':Predicate, #1: 1	أَنَّ الْفَصِيلَةَ
u'أَنَّ فَضَائِلُ':Predicate, #1: 1	أَنَّ الْفَضَّ
u'أَنَّ فِضَّةٌ':Predicate, #1: 1	أَنَّ الْفَضَائِلَ
u'أَنَّ فَضْلٌ':Predicate, #7: 7	أَنَّ الْفِضَّةَ
u'أَنَّ فَضْلٌ':Predicate, #7: 7	أَنَّ فَضْلَ
u'أَنَّ فضلة':Predicate, #9: 9	أَنَّ الْفَضْلَ
u'أَنَّ فَضْلَةٌ':Predicate, #1: 1	أَنَّ الْفَضْلَةَ
u'أَنَّ فُضُولٌ':Predicate, #1: 1	أَنَّ الْفَضْلَةَ
u'أَنَّ فُضُولِيٌّ':Predicate, #1: 1	أَنَّ فُضُولَ
u'أَنَّ فَضِيلٌ':Predicate, #14: 14	أَنَّ الْفُضُولِيَّ
u'أَنَّ فَضِيلَةٌ':Predicate, #2: 2	أَنَّ الْفَضِيلَةَ
u'أَنَّ فِطْرٌ':Predicate, #2: 2	أَنَّ الْفَضِيلَةَ
u'أَنَّ فِطْرٌ':Predicate, #12: 12	أَنَّ الْفِطْرَ
u'أَنَّ فطرة':Predicate, #1: 1	أَنَّ فِطْرَ
u'أَنَّ فِطْرَةٌ':Predicate, #8: 8	أَنَّ الْفِطْرَةَ
u'أَنَّ فطن':Predicate, #8: 8	أَنَّ الْفِطْرَةَ
u'أَنَّ فَظٌّ':Predicate, #1: 1	أَنَّ فُطْنَ
u'أَنَّ فِعْلٌ':Predicate, #1: 1	أَنَّ الْفَظَّ
u'أَنَّ فِعْلٌ':Predicate, #46: 46	أَنَّ فِعْلَ
u'أَنَّ فَقْء':Predicate, #70: 70	أَنَّ الْفِعْلَ
u'أَنْفَقَ أحَدٌ':Subject, #1: 1	أَنَّ فَقْءَ
u'أَنْفَقَ أحَدٌ':Subject, #1: 1	أَنْفَقَ أَحَدٌ
u'أَنْفَقَ أَكْثَرُ':Predicate, #1: 1	أَنْفَقَ أَحَدُ
u'أَنْفَقَ باقِي':Predicate, #1: 1	أَنْفَقَ الْأَكْثَرَ
u'أَنْفَقَ بَعْضٌ':Predicate, #1: 1	أَنْفَقَ الْبَاقِيَ
u'أَنْفَقَ ثَلاثَةٌ':Predicate, #1: 1	أَنْفَقَ بَعْضَ
u'أَنْفَقَ ثَمَنٌ':Predicate, #1: 1	أَنْفَقَ ثَلَاثَةَ
u'أَنْفَقَ حالٌ':Predicate, #1: 1	أَنْفَقَ الثَّمَنَ
u'أَنْفَقَ حَرامٌ':Predicate, #1: 1	أَنْفَقَ حَالَ
u'أَنْفَقَ حَسَبٌ':Predicate, #1: 1	أَنْفَقَ الْحَرَامَ
u'أَنْفَقَ خَمْسَةٌ':Predicate, #1: 1	أَنْفَقَ حَسَبَ
u'أَنَّ فَقْدٌ':Predicate, #2: 2	أَنْفَقَ الْخَمْسَةَ
u'أَنْفَقَ دَرَاهِمُ':Predicate, #6: 6	أَنَّ فَقْدَ
u'أَنْفَقَ دَرَاهِمُ':Predicate, #1: 1	أَنْفَقَ دَرَاهِمَ
u'أَنْفَقَ دونٌ':Predicate, #4: 4	أَنْفَقَ الدَّرَاهِمَ
u'أَنَّ فقر':Predicate, #1: 1	أَنْفَقَ دُونَ
u'أَنَّ فَقْرٌ':Predicate, #8: 8	أَنَّ الْفَقْرَ
u'أَنَّ فقراء':Predicate, #8: 8	أَنَّ الْفَقْرَ
u'أَنَّ فقراء':Predicate, #2: 2	أَنَّ فُقَرَاءَ
u'أَنْفَقَ رَاهِنٌ':Subject, #6: 6	أَنَّ الْفُقَرَاءَ
u'أَنْفَقَ رَبُّ':Subject, #1: 1	أَنْفَقَ الرَّاهِنُ
u'أَنْفَقَ رِبْحٌ':Predicate, #2: 2	أَنْفَقَ رَبُّ
u'أَنْفَقَ رَبِيعَةٌ':Subject, #1: 1	أَنْفَقَ رِبْحَ
u'أَنْفَقَ رَجُلٌ':Subject, #1: 1	أَنْفَقَ رَبِيعَةُ
u'أَنْفَقَ زَوْجٌ':Subject, #4: 4	أَنْفَقَ الرَّجُلُ
u'أَنْفَقَ زُيوفٌ':Predicate, #1: 1	أَنْفَقَ الزَّوْجُ
u'أَنْفَقَ زُيُوفٌ':Predicate, #1: 1	أَنْفَقَ الزُّيُوفَ
u'أَنْفَقَ شَرِيكٌ':Subject, #1: 1	أَنْفَقَ الزُّيُوفَ
u'أَنْفَقَ صَاحِبٌ':Subject, #1: 1	أَنْفَقَ الشَّرِيكُ
u'أَنْفَقَ صَاحِبٌ':Subject, #1: 1	أَنْفَقَ صَاحِبُ
u'أَنْفَقَ عُمَرٌ':Subject, #1: 1	أَنْفَقَ صَاحِبُهُ
u'أَنْفَقَ غير':Predicate, #1: 1	أَنْفَقَ عُمَرُ
u'أَنْفَقَ غَيْرٌ':Predicate, #2: 2	أَنْفَقَ غَيْرَ
u'أَنْفَقَ مَالٌ':Predicate, #2: 2	أَنْفَقَ غَيْرَ
u'أَنْفَقَ مَالٌ':Predicate, #1: 1	أَنْفَقَ الْمَالَ
u'أَنْفَقَ مَالِكٌ':Subject, #1: 1	أَنْفَقَ مَالَ
u'أَنْفَقَ مُبْتاع':Subject, #1: 1	أَنْفَقَ الْمَالِكُ
u'أَنْفَقَ مثل':Predicate, #2: 2	أَنْفَقَ الْمُبْتَاعُ
u'أَنْفَقَ مِثْلٌ':Predicate, #4: 4	أَنْفَقَ مِثْلَ
u'أَنْفَقَ مَدْفُوعٌ':Subject, #4: 4	أَنْفَقَ مِثْلَ
u'أَنْفَقَ مُرْتَهِنٌ':Subject, #1: 1	أَنْفَقَ الْمَدْفُوعُ
u'أَنْفَقَ مُرْتَهِنٌ':Subject, #10: 10	أَنْفَقَ الْمُرْتَهِنُ
u'أَنْفَقَ مُسْتَأْجِرٌ':Subject, #2: 2	أَنْفَقَ مُرْتَهِنٌ
u'أَنْفَقَ مُضَارِبٌ':Subject, #2: 2	أَنْفَقَ الْمُسْتَأْجِرُ
u'أَنْفَقَ مِلْءٌ':Predicate, #4: 4	أَنْفَقَ الْمُضَارِبُ
u'أَنْفَقَ مُلْتَقِط':Subject, #2: 2	أَنْفَقَ مِلْءَ
u'أَنْفَقَ مُودِعٌ':Subject, #7: 7	أَنْفَقَ الْمُلْتَقِطُ
u'أَنْفَقَ مُودَعٌ':Subject, #1: 1	أَنْفَقَ الْمُودِعُ
u'أَنْفَقَ مُودَعٌ':Subject, #1: 1	أَنْفَقَ مُودَعُهُ
u'أَنْفَقَ مُوسِرٌ':Subject, #4: 4	أَنْفَقَ الْمُودَعُ
u'أَنْفَقَ مُؤْمِنٌ':Subject, #1: 1	أَنْفَقَ الْمُوسِرُ
u'أَنْفَقَ نَصٌّ':Predicate, #2: 2	أَنْفَقَ الْمُؤْمِنُ
u'أَنْفَقَ نِصْفٌ':Predicate, #1: 1	أَنْفَقَ نَصَّ
u'أَنْفَقَ نَفَقَةٌ':Predicate, #1: 1	أَنْفَقَ النِّصْفَ
u'أَنْفَقَ نَفَقَةٌ':Subject, #1: 1	أَنْفَقَ نَفَقَةَ
u'أَنَّ فِقْهٌ':Predicate, #1: 1	أَنْفَقَ نَفَقَةٌ
u'أَنَّ فقهاء':Predicate, #14: 14	أَنَّ الْفِقْهَ
u'أَنْفَقَ وَارِثٌ':Subject, #17: 17	أَنَّ الْفُقَهَاءَ
u'أَنْفَقَ وَدِيعٌ':Predicate, #1: 1	أَنْفَقَ الْوَارِثُ
u'أَنْفَقَ وَدِيعٌ':Predicate, #1: 1	أَنْفَقَ الْوَدِيعَةَ
u'أَنْفَقَ وَدِيعَةٌ':Predicate, #1: 1	أَنْفَقَ وَدِيعَةَ
u'أَنْفَقَ وَدِيعَةٌ':Predicate, #1: 1	أَنْفَقَ الْوَدِيعَةَ
u'أَنْفَقَ وَرَثَةٌ':Subject, #1: 1	أَنْفَقَ وَدِيعَةَ
u'أَنْفَقَ وَرَثَةٌ':Subject, #1: 1	أَنْفَقَ الْوَرَثَةُ
u'أَنْفَقَ وَصِيٌّ':Subject, #2: 2	أَنْفَقَ وَرَثَةُ
u'أَنْفَقَ وَكِيلٌ':Subject, #2: 2	أَنْفَقَ الْوَصِيُّ
u'أَنْفَقَ وَلِيٌّ':Subject, #1: 1	أَنْفَقَ الْوَكِيلُ
u'أَنَّ فَقِيرٌ':Predicate, #1: 1	أَنْفَقَ وَلِيُّ
u'أَنَّ فَقِيهٌ':Predicate, #25: 25	أَنَّ الْفَقِيرَ
u'أَنَّ فَقِيهٌ':Predicate, #1: 1	أَنَّ فَقِيهَ
u'أَنَّ فَكٌّ':Predicate, #7: 7	أَنَّ الْفَقِيهَ
u'أَنَّ فِكْرٌ':Predicate, #1: 1	أَنَّ فَكَّ
u'أَنَّ فِكْرَةٌ':Predicate, #3: 3	أَنَّ الْفِكْرَ
u'أَنَّ فلان':Predicate, #1: 1	أَنَّ الْفِكْرَةَ
u'أَنَّ فلان':Predicate, #10: 10	أَنَّ بِلاَلاً
u'أَنَّ فلان':Predicate, #114: 114	أَنَّ عُثْمَانَ
u'أَنَّ فلان':Predicate, #11: 11	أَنَّ حَمْزَةَ
u'أَنَّ فلان':Predicate, #135: 135	أَنَّ الشَّافِعِيَّ
u'أَنَّ فُلاَنٌ':Predicate, #13: 13	أَنَّ حَفْصَةَ
u'أَنَّ فلان':Predicate, #13: 13	أَنَّ فُلَانَةَ
u'أَنَّ فلان':Predicate, #18: 18	أَنَّ سُفْيَانَ
u'أَنَّ فلان':Predicate, #1: 1	أَنَّ الْبَنْدَرَ
u'أَنَّ فلان':Predicate, #1: 1	أَنَّ التَّرَجِّيَ
u'أَنَّ فلان':Predicate, #1: 1	أَنَّ الْجُبْرَانَ
u'أَنَّ فلان':Predicate, #1: 1	أَنَّ الْخُرَاسَانِيِّينَ
u'أَنَّ فلان':Predicate, #1: 1	أَنَّ الرَّاغِبَ
u'أَنَّ فلان':Predicate, #1: 1	أَنَّ الرَّحْمَنَ
u'أَنَّ فلان':Predicate, #1: 1	أَنَّ الزَّمَخْشَرِيَّ
u'أَنَّ فلان':Predicate, #1: 1	أَنَّ الشَّلَبِيَّ
u'أَنَّ فلان':Predicate, #1: 1	أَنَّ الْمَمْلُوكِيَّةَ
u'أَنَّ فلان':Predicate, #1: 1	أَنَّ بِلاَلَ
u'أَنَّ فلان':Predicate, #1: 1	أَنَّ حَاتِمَ
u'أَنَّ فلان':Predicate, #1: 1	أَنَّ خَدِيجَةَ
u'أَنَّ فلان':Predicate, #1: 1	أَنَّ رَايَةَ
u'أَنَّ فلان':Predicate, #1: 1	أَنَّ رُومَةَ
u'أَنَّ فلان':Predicate, #1: 1	أَنَّ شَبَابَةَ
u'أَنَّ فُلاَنٌ':Predicate, #1: 1	أَنَّ عُبَيْدَةَ
u'أَنَّ فلان':Predicate, #1: 1	أَنَّ فُلاَنَةَ
u'أَنَّ فلان':Predicate, #1: 1	أَنَّ قَابِيلَ
u'أَنَّ فلان':Predicate, #1: 1	أَنَّ مِقْدَادَ
u'أَنَّ فلان':Predicate, #1: 1	أَنَّ هِرَقْلَ
u'أَنَّ فلان':Predicate, #21: 21	أَنَّ حُذَيْفَةَ
u'أَنَّ فلان':Predicate, #23: 23	أَنَّ الزُّبَيْرَ
u'أَنَّ فلان':Predicate, #24: 24	أَنَّ مَكَّةَ
u'أَنَّ فلان':Predicate, #25: 25	أَنَّ الْمَكِّيَّ
u'أَنَّ فلان':Predicate, #2: 2	أَنَّ الْبَيْهَقِيَّ
u'أَنَّ فلان':Predicate, #2: 2	أَنَّ الْحَامِدَ
u'أَنَّ فلان':Predicate, #2: 2	أَنَّ الرَّاتِبَةَ
u'أَنَّ فلان':Predicate, #2: 2	أَنَّ الرَّازِيَّ
u'أَنَّ فلان':Predicate, #2: 2	أَنَّ الطَّبَرَانِيَّ
u'أَنَّ فلان':Predicate, #2: 2	أَنَّ الطَّبَرِيَّ
u'أَنَّ فلان':Predicate, #2: 2	أَنَّ الظَّاهِرِيَّةَ
u'أَنَّ فلان':Predicate, #2: 2	أَنَّ الْمُتَصَدِّقَ
u'أَنَّ فلان':Predicate, #2: 2	أَنَّ الْمِقْدَادَ
u'أَنَّ فلان':Predicate, #2: 2	أَنَّ النَّهَارِيَّةَ
u'أَنَّ فلان':Predicate, #2: 2	أَنَّ تَمِيمَ
u'أَنَّ فلان':Predicate, #2: 2	أَنَّ جُبْرَانَ
u'أَنَّ فلان':Predicate, #2: 2	أَنَّ حَامِدَ
u'أَنَّ فلان':Predicate, #2: 2	أَنَّ رُكْنِيَّةَ
u'أَنَّ فلان':Predicate, #2: 2	أَنَّ عَوْفَ
u'أَنَّ فلان':Predicate, #2: 2	أَنَّ عَيَّاشَ
u'أَنَّ فُلاَنٌ':Predicate, #2: 2	أَنَّ مَكْحُولاً
u'أَنَّ فلان':Predicate, #36: 36	أَنَّ فُلَانَ
u'أَنَّ فلان':Predicate, #3: 3	أَنَّ الرُّكْنِيَّةَ
u'أَنَّ فلان':Predicate, #3: 3	أَنَّ الصَّلَاتِيَّةَ
u'أَنَّ فلان':Predicate, #3: 3	أَنَّ الْغَانِمِينَ
u'أَنَّ فلان':Predicate, #3: 3	أَنَّ النَّجَاشِيَّ
u'أَنَّ فلان':Predicate, #3: 3	أَنَّ بِلْقِيسَ
u'أَنَّ فلان':Predicate, #3: 3	أَنَّ زِيَادَ
u'أَنَّ فلان':Predicate, #3: 3	أَنَّ لُقْمَانَ
u'أَنَّ فلان':Predicate, #3: 3	أَنَّ مَرْيَمَ
u'أَنَّ فلان':Predicate, #4: 4	أَنَّ الشَّافِعِيَّةَ
u'أَنَّ فلان':Predicate, #4: 4	أَنَّ الْغَامِدِيَّةَ
u'أَنَّ فلان':Predicate, #4: 4	أَنَّ خَيْبَرَ
u'أَنَّ فلان':Predicate, #4: 4	أَنَّ دَاوُدَ
u'أَنَّ فلان':Predicate, #4: 4	أَنَّ عَقِيلَ
u'أَنَّ فلان':Predicate, #59: 59	أَنَّ مُعَاوِيَةَ
u'أَنَّ فلان':Predicate, #5: 5	أَنَّ التِّرْمِذِيَّ
u'أَنَّ فلان':Predicate, #5: 5	أَنَّ جُبَيْرَ
u'أَنَّ فلان':Predicate, #5: 5	أَنَّ جَعْفَرَ
u'أَنَّ فلان':Predicate, #6: 6	أَنَّ الْمَرْوِيَّ
u'أَنَّ فلان':Predicate, #6: 6	أَنَّ هَارُونَ
u'أَنَّ فلان':Predicate, #7: 7	أَنَّ رِفَاعَةَ
u'أَنَّ فلان':Predicate, #8: 8	أَنَّ شُعَيْبَ
u'أَنَّ فَلْسٌ':Predicate, #9: 9	أَنَّ قَتَادَةَ
u'أَنَّ فُلْكٌ':Predicate, #1: 1	أَنَّ الْفَلْسَ
u'أَنَّ فُلُوسٌ':Predicate, #1: 1	أَنَّ الْفُلْكَ
u'أَنَّ فَمٌ':Predicate, #5: 5	أَنَّ الْفُلُوسَ
u'أَنَّ فِنَاءٌ':Predicate, #2: 2	أَنَّ الْفَمَ
u'أَنَّ فِنَاءٌ':Predicate, #1: 1	أَنَّ فِنَاءَ
u'أَنَّ فَهْمٌ':Predicate, #4: 4	أَنَّ الْفِنَاءَ
u'أَنَّ فَهْمٌ':Predicate, #4: 4	أَنَّ الْفَهْمَ
u'أَنَّ فَوَاتٌ':Predicate, #6: 6	أَنَّ فَهْمَ
u'أَنَّ فَوَاتٌ':Predicate, #1: 1	أَنَّ الْفَوَاتَ
u'أَنَّ فواكه':Predicate, #9: 9	أَنَّ فَوَاتَ
u'أَنَّ فَوَاكِهُ':Predicate, #1: 1	أَنَّ الْفَوَاكِهَ
u'أَنَّ فَوَائِدُ':Predicate, #1: 1	أَنَّ الْفَوَاكِهَ
u'أَنَّ فَوَائِدُ':Predicate, #2: 2	أَنَّ الْفَوَائِدَ
u'أَنَّ فَوْر':Predicate, #2: 2	أَنَّ فَوَائِدَ
u'أَنَّ فَوْرٌ':Predicate, #1: 1	أَنَّ الْفَوْرِيَّةَ
u'أَنَّ فَوْرَة':Predicate, #3: 3	أَنَّ الْفَوْرَ
u'أَنَّ فَوْرِيّ':Predicate, #1: 1	أَنَّ الْفَوْرِيَّةَ
u'أَنَّ فَوْق':Predicate, #1: 1	أَنَّ الْفَوْرِيَّةَ
u'أَنَّ فَوْقِيّ':Predicate, #1: 1	أَنَّ الْفَوْقِيَّةَ
u'أَنَّ فُوم':Predicate, #1: 1	أَنَّ الْفَوْقِيَّةَ
u'أَنَّ فَيْءٌ':Predicate, #1: 1	أَنَّ الْفُومَ
u'أَنَّ فِئَةٌ':Predicate, #8: 8	أَنَّ الْفَيْءَ
u'أَنَّ فَيْئَةٌ':Predicate, #1: 1	أَنَّ الْفِئَةَ
u'أَنَّ قَابِضٌ':Predicate, #1: 1	أَنَّ فَيْئَةَ
u'أَنَّ قَابِضٌ':Predicate, #1: 1	أَنَّ قَابِضَ
u'أَنَّ قَابِلٌ':Predicate, #4: 4	أَنَّ الْقَابِضَ
u'أَنَّ قَابِلٌ':Predicate, #1: 1	أَنَّ الْقَابِلَ
u'أَنْقَابٌ مَدِينٌ':Added, #4: 4	أَنَّ الْقَابِلَةَ
u'أَنْقَابٌ مَدِينَةٌ':Added, #1: 1	أَنْقَابِ الْمَدِينَةِ
u'أَنَّ قَاتِلٌ':Predicate, #1: 1	أَنْقَابِ الْمَدِينَةِ
u'أَنَّ قَاتِلٌ':Predicate, #26: 26	أَنَّ الْقَاتِلَ
u'أَنَّ قَادِرٌ':Predicate, #3: 3	أَنَّ قَاتِلَ
u'أَنَّ قَادِمٌ':Predicate, #11: 11	أَنَّ الْقَادِرَ
u'أَنَّ قَاذِفٌ':Predicate, #2: 2	أَنَّ الْقَادِمَ
u'أَنَّ قَاذِفٌ':Predicate, #1: 1	أَنَّ قَاذِفَ
u'أَنَّ قَارِئٌ':Predicate, #4: 4	أَنَّ الْقَاذِفَ
u'أَنَّ قَاسِمٌ':Predicate, #8: 8	أَنَّ الْقَارِئَ
u'أَنَّ قَاصِدٌ':Predicate, #14: 14	أَنَّ الْقَاسِمَ
u'أَنَّ قَاصِرٌ':Predicate, #1: 1	أَنَّ قَاصِدَ
u'أَنَّ قَاضِي':Predicate, #1: 1	أَنَّ الْقَاصِرَةَ
u'أَنَّ قَاضِي':Predicate, #36: 36	أَنَّ قَاضِيَ
u'أَنَّ قَاطِعٌ':Predicate, #445: 445	أَنَّ الْقَاضِيَ
u'أَنَّ قَاطِعٌ':Predicate, #1: 1	أَنَّ الْقَاطِعَةَ
u'أَنَّ قَاعَةٌ':Predicate, #6: 6	أَنَّ الْقَاطِعَ
u'أَنَّ قَاعِدٌ':Predicate, #1: 1	أَنَّ الْقَاعَةَ
u'أَنَّ قَاعِدٌ':Predicate, #11: 11	أَنَّ الْقَاعِدَةَ
u'أَنَّ قَاعِدٌ':Predicate, #2: 2	أَنَّ الْقَاعِدَ
u'أَنَّ قَاعِدٌ':Subject, #5: 5	أَنَّ قَاعِدَةَ
u'أَنَّ قاف':Predicate, #1: 1	أَنَّ قَاعِدَةُ
u'أَنَّ قَافِلٌ':Predicate, #1: 1	أَنَّ الْقَافَةَ
u'أَنَّ قَافِلَةٌ':Predicate, #2: 2	أَنَّ الْقَافِلَةَ
u'أَنَّ قَالٌ':Predicate, #2: 2	أَنَّ الْقَافِلَةَ
u'أَنَّ قَامَةٌ':Predicate, #1: 1	أَنَّ قَالَ
u'أَنَّ قَامُوسٌ':Predicate, #1: 1	أَنَّ قَامَةَ
u'أَنَّ قانِص':Predicate, #1: 1	أَنَّ الْقَامُوسَ
u'أَنَّ قَاهِرٌ':Predicate, #1: 1	أَنَّ الْقَانِصَ
u'أَنَّ قَائِلٌ':Predicate, #1: 1	أَنَّ الْقَاهِرَةَ
u'أَنَّ قَائِلٌ':Predicate, #1: 1	أَنَّ الْقَائِلَةَ
u'أَنَّ قَائِلٌ':Predicate, #23: 23	أَنَّ الْقَائِلِينَ
u'أَنَّ قَائِلٌ':Predicate, #27: 27	أَنَّ الْقَائِلَ
u'أَنَّ قَائِلَةٌ':Predicate, #5: 5	أَنَّ قَائِلَ
u'أَنَّ قَائِمٌ':Predicate, #1: 1	أَنَّ الْقَائِلَةَ
u'أَنَّ قَبَائِلُ':Predicate, #6: 6	أَنَّ الْقَائِمَ
u'أَنَّ قُبَّةٌ':Predicate, #3: 3	أَنَّ الْقَبَائِلَ
u'أَنَّ قُبْحٌ':Predicate, #1: 1	أَنَّ قُبَّةَ
u'أَنَّ قُبْحٌ':Predicate, #1: 1	أَنَّ الْقُبْحَ
u'أَنَّ قَبْرٌ':Predicate, #2: 2	أَنَّ قُبْحَ
u'أَنَّ قَبْرٌ':Predicate, #1: 1	أَنَّ قَبْرَ
u'أَنَّ قَبْضٌ':Predicate, #3: 3	أَنَّ الْقَبْرَ
u'أَنَّ قَبْضٌ':Predicate, #17: 17	أَنَّ قَبْضَ
u'أَنَّ قُبُلٌ':Predicate, #45: 45	أَنَّ الْقَبْضَ
u'أَنَّ قِبْلَةٌ':Predicate, #2: 2	أَنَّ الْقُبُلَ
u'أَنَّ قِبْلَةٌ':Predicate, #12: 12	أَنَّ الْقِبْلَةَ
u'أَنَّ قُبْلَةٌ':Predicate, #1: 1	أَنَّ قِبْلَةَ
u'أَنَّ قُبُورٌ':Predicate, #8: 8	أَنَّ الْقُبْلَةَ
u'أَنَّ قَبُولٌ':Predicate, #2: 2	أَنَّ الْقُبُورَ
u'أَنَّ قَبُولٌ':Predicate, #22: 22	أَنَّ الْقَبُولَ
u'أَنَّ قَبِيعَةٌ':Predicate, #22: 22	أَنَّ قَبُولَ
u'أَنَّ قَبِيلَةٌ':Predicate, #3: 3	أَنَّ قَبِيعَةَ
u'أَنَّ قَتاد':Predicate, #4: 4	أَنَّ الْقَبِيلَةَ
u'أَنَّ قتال':Predicate, #9: 9	أَنَّ قَتَادَةَ
u'أَنَّ قِتَالٌ':Predicate, #1: 1	أَنَّ قِتَالَ
u'أَنَّ قتال':Predicate, #1: 1	أَنَّ قِتَالَ
u'أَنَّ قِتَالٌ':Predicate, #3: 3	أَنَّ الْقِتَالَ
u'أَنَّ قتل':Predicate, #3: 3	أَنَّ الْقِتَالَ
u'أَنَّ قَتْلٌ':Predicate, #31: 31	أَنَّ قَتْلَ
u'أَنَّ قتل':Predicate, #31: 31	أَنَّ قَتْلَ
u'أَنَّ قَتْلٌ':Predicate, #53: 53	أَنَّ الْقَتْلَ
u'أَنَّ قَتِيلٌ':Predicate, #53: 53	أَنَّ الْقَتْلَ
u'أَنَّ قِثَّاءٌ':Predicate, #3: 3	أَنَّ الْقَتِيلَ
u'أَنَّ قَدَحٌ':Predicate, #2: 2	أَنَّ الْقِثَّاءَ
u'أَنَّ قَدْرٌ':Predicate, #4: 4	أَنَّ قَدَحَ
u'أَنَّ قَدْرٌ':Predicate, #15: 15	أَنَّ الْقَدْرَ
u'أَنَّ قِدْرٌ':Predicate, #17: 17	أَنَّ قَدْرَ
u'أَنَّ قَدَرُ':Predicate, #1: 1	أَنَّ الْقِدْرَ
u'أَنَّ قَدَر':Predicate, #2: 2	أَنَّ الْقَدَرِيَّةَ
u'أَنَّ قَدَرُ':Predicate, #2: 2	أَنَّ الْقَدَرِيَّةَ
u'أَنَّ قَدَر':Predicate, #2: 2	أَنَّ قَدَرِيَّةَ
u'أَنَّ قدرة':Predicate, #2: 2	أَنَّ قَدَرِيَّةَ
u'أَنَّ قُدْرَةٌ':Predicate, #2: 2	أَنَّ قُدْرَةَ
u'أَنَّ قدرة':Predicate, #2: 2	أَنَّ قُدْرَةَ
u'أَنَّ قُدْرَةٌ':Predicate, #31: 31	أَنَّ الْقُدْرَةَ
u'أَنَّ قَدَرِيّ':Predicate, #31: 31	أَنَّ الْقُدْرَةَ
u'أَنَّ قَدَرِيّ':Predicate, #2: 2	أَنَّ الْقَدَرِيَّةَ
u'أَنَّ قدم':Predicate, #2: 2	أَنَّ قَدَرِيَّةَ
u'أَنَّ قِدَمٌ':Predicate, #1: 1	أَنَّ الْقِدَمَ
u'أَنَّ قدم':Predicate, #1: 1	أَنَّ الْقِدَمَ
u'أَنَّ قَدَمٌ':Predicate, #8: 8	أَنَّ الْقَدَمَ
u'أَنَّ قُدْوَةٌ':Predicate, #8: 8	أَنَّ الْقَدَمَ
u'أَنَّ قُدُومٌ':Predicate, #1: 1	أَنَّ الْقُدْوَةَ
u'أَنَّ قُدُومٌ':Predicate, #1: 1	أَنَّ قُدُومَ
u'أَنَّ قَدِيمٌ':Predicate, #2: 2	أَنَّ الْقُدُومَ
u'أَنَّ قذف':Predicate, #1: 1	أَنَّ الْقَدِيمَ
u'أَنَّ قَذْفٌ':Predicate, #5: 5	أَنَّ قَذْفَ
u'أَنَّ قذف':Predicate, #5: 5	أَنَّ قَذْفَ
u'أَنَّ قَذْفٌ':Predicate, #6: 6	أَنَّ الْقَذْفَ
u'أَنْقَذَ مَالٌ':Predicate, #6: 6	أَنَّ الْقَذْفَ
u'أَنَّ قُرْء':Predicate, #1: 1	أَنْقَذَ مَالَ
u'أَنَّ قِرَاءةٌ':Predicate, #9: 9	أَنَّ الْقُرْءَ
u'أَنَّ قِرَاءةٌ':Predicate, #33: 33	أَنَّ قِرَاءَةَ
u'أَنَّ قَرَابَةٌ':Predicate, #57: 57	أَنَّ الْقِرَاءَةَ
u'أَنَّ قَرَابَةٌ':Predicate, #12: 12	أَنَّ الْقَرَابَةَ
u'أَنَّ قرار':Predicate, #7: 7	أَنَّ قَرَابَةَ
u'أَنَّ قَرَارٌ':Predicate, #1: 1	أَنَّ قَرَارَ
u'أَنَّ قرار':Predicate, #1: 1	أَنَّ قَرَارَ
u'أَنَّ قَرَارٌ':Predicate, #5: 5	أَنَّ الْقَرَارَ
u'أَنَّ قَرَارِيطُ':Predicate, #5: 5	أَنَّ الْقَرَارَ
u'أَنَّ قراض':Predicate, #1: 1	أَنَّ الْقَرَارِيطَ
u'أَنَّ قراض':Predicate, #1: 1	أَنَّ قِرَاضَ
u'أَنَّ قِرام':Predicate, #3: 3	أَنَّ الْقِرَاضَ
u'أَنَّ قِرَانٌ':Predicate, #1: 1	أَنَّ الْقِرَامَ
u'أَنَّ قُرْآنٌ':Predicate, #15: 15	أَنَّ الْقِرَانَ
u'أَنَّ قرائن':Predicate, #32: 32	أَنَّ الْقُرْآنَ
u'أَنَّ قرائن':Predicate, #1: 1	أَنَّ قَرَائِنَ
u'أَنَّ قُرْبٌ':Predicate, #3: 3	أَنَّ الْقَرَائِنَ
u'أَنَّ قُرْبٌ':Predicate, #1: 1	أَنَّ قُرْبَ
u'أَنَّ قُرْبَانٌ':Predicate, #6: 6	أَنَّ الْقُرْبَ
u'أَنَّ قِرْبَةٌ':Predicate, #2: 2	أَنَّ الْقُرْبَانَ
u'أَنَّ قُرْبَةٌ':Predicate, #1: 1	أَنَّ الْقِرْبَةَ
u'أَنَّ قُرَّةٌ':Predicate, #3: 3	أَنَّ الْقُرْبَةَ
u'أَنَّ قُرَشِيٌّ':Predicate, #1: 1	أَنَّ قُرَّةَ
u'أَنَّ قَرْضٌ':Predicate, #1: 1	أَنَّ الْقُرَشِيَّ
u'أَنَّ قَرْضٌ':Predicate, #3: 3	أَنَّ قَرْضَ
u'أَنَّ قُرْعَةٌ':Predicate, #8: 8	أَنَّ الْقَرْضَ
u'أَنَّ قُرْعَةٌ':Predicate, #13: 13	أَنَّ الْقُرْعَةَ
u'أَنَّ قُرُوء':Predicate, #2: 2	أَنَّ قُرْعَةَ
u'أَنَّ قَرِيبٌ':Predicate, #3: 3	أَنَّ الْقُرُوءَ
u'أَنَّ قَرْيَةٌ':Predicate, #9: 9	أَنَّ الْقَرِيبَ
u'أَنَّ قَرِينٌ':Predicate, #3: 3	أَنَّ الْقَرْيَةَ
u'أَنَّ قَرِينٌ':Predicate, #12: 12	أَنَّ الْقَرِينَةَ
u'أَنَّ قَزٌّ':Predicate, #4: 4	أَنَّ قَرِينَةَ
u'أَنَّ قَزَع':Predicate, #1: 1	أَنَّ الْقَزَّ
u'أَنَّ قَسام':Predicate, #2: 2	أَنَّ قَزَعَةَ
u'أَنَّ قَسامَة':Predicate, #15: 15	أَنَّ الْقَسَامَةَ
u'أَنَّ قِسْمٌ':Predicate, #15: 15	أَنَّ الْقَسَامَةَ
u'أَنَّ قَسْمٌ':Predicate, #2: 2	أَنَّ الْقِسْمَ
u'أَنَّ قَسْمٌ':Predicate, #2: 2	أَنَّ قَسْمَ
u'أَنَّ قسمة':Predicate, #8: 8	أَنَّ الْقَسْمَ
u'أَنَّ قِسْمَةٌ':Predicate, #18: 18	أَنَّ قِسْمَةَ
u'أَنَّ قسمة':Predicate, #18: 18	أَنَّ قِسْمَةَ
u'أَنَّ قِسْمَةٌ':Predicate, #33: 33	أَنَّ الْقِسْمَةَ
u'أَنَّ قِشْرٌ':Predicate, #33: 33	أَنَّ الْقِسْمَةَ
u'أَنَّ قَصٌّ':Predicate, #1: 1	أَنَّ قِشْرَ
u'أَنَّ قصاص':Predicate, #3: 3	أَنَّ قَصَّ
u'أَنَّ قِصَاصٌ':Predicate, #52: 52	أَنَّ الْقِصَاصَ
u'أَنَّ قَصَبٌ':Predicate, #52: 52	أَنَّ الْقِصَاصَ
u'أَنَّ قِصَّةٌ':Predicate, #1: 1	أَنَّ الْقَصَبَ
u'أَنَّ قِصَّةٌ':Predicate, #3: 3	أَنَّ قِصَّةَ
u'أَنْقَصَ جَازٌ':Predicate, #6: 6	أَنَّ الْقِصَّةَ
u'أَنَّ قَصْدٌ':Predicate, #1: 1	أَنْقَصَ جَازَ
u'أَنَّ قَصْدٌ':Predicate, #12: 12	أَنَّ قَصْدَ
u'أَنَّ قَصْرٌ':Predicate, #40: 40	أَنَّ الْقَصْدَ
u'أَنَّ قَصْرٌ':Predicate, #20: 20	أَنَّ الْقَصْرَ
u'أَنْقَصَ قَالٌ':Predicate, #2: 2	أَنَّ قَصْرَ
u'أَنَّ قُصُورٌ':Predicate, #1: 1	أَنْقَصَ قَالَ
u'أَنَّ قَضَاءٌ':Predicate, #1: 1	أَنَّ قُصُورَ
u'أَنَّ قَضَاءٌ':Predicate, #111: 111	أَنَّ الْقَضَاءَ
u'أَنَّ قضاة':Predicate, #43: 43	أَنَّ قَضَاءَ
u'أَنَّ قضاة':Predicate, #5: 5	أَنَّ قُضَاةَ
u'أَنَّ قَضِيَّةٌ':Predicate, #6: 6	أَنَّ الْقُضَاةَ
u'أَنَّ قَضِيَّةٌ':Predicate, #21: 21	أَنَّ قَضِيَّةَ
u'أَنَّ قِطَارٌ':Predicate, #3: 3	أَنَّ الْقَضِيَّةَ
u'آنَ قِطَافٌ':Subject, #1: 1	أَنَّ الْقِطَارَ
u'أَنَّ قَطْرَةٌ':Predicate, #1: 1	آنَ قِطَافُ
u'أَنَّ قِطَطٌ':Predicate, #1: 1	أَنَّ الْقَطْرَةَ
u'أَنَّ قَطْعٌ':Predicate, #1: 1	أَنَّ الْقِطَطَ
u'أَنَّ قَطْعٌ':Predicate, #16: 16	أَنَّ قَطْعَ
u'أَنَّ قطعة':Predicate, #47: 47	أَنَّ الْقَطْعَ
u'أَنَّ قِطْعَةٌ':Predicate, #1: 1	أَنَّ الْقِطْعَةَ
u'أَنَّ قُطْنٌ':Predicate, #1: 1	أَنَّ الْقِطْعَةَ
u'أَنَّ قَطِيفَةٌ':Predicate, #2: 2	أَنَّ الْقُطْنَ
u'أَنَّ قعدة':Predicate, #1: 1	أَنَّ الْقَطِيفَةَ
u'أَنَّ قَعْدَةٌ':Predicate, #5: 5	أَنَّ الْقَعْدَةَ
u'أَنَّ قَعْرٌ':Predicate, #5: 5	أَنَّ الْقَعْدَةَ
u'أَنَّ قُعُودٌ':Predicate, #3: 3	أَنَّ قَعْرَ
u'أَنَّ قُعُودٌ':Predicate, #17: 17	أَنَّ الْقُعُودَ
u'أَنَّ قَفَّالٌ':Predicate, #1: 1	أَنَّ قُعُودَ
u'أَنَّ قَفِيز':Predicate, #3: 3	أَنَّ الْقَفَّالَ
u'أَنَّ قَلاَئِدُ':Predicate, #3: 3	أَنَّ الْقَفِيزَ
u'أَنَّ قلب':Predicate, #1: 1	أَنَّ الْقَلَائِدَ
u'أَنَّ قَلْبٌ':Predicate, #11: 11	أَنَّ الْقَلْبَ
u'أَنَّ قَلْب':Predicate, #11: 11	أَنَّ الْقَلْبَ
u'أَنَّ قلب':Predicate, #11: 11	أَنَّ الْقَلْبَ
u'أَنَّ قَلْبٌ':Predicate, #1: 1	أَنَّ قَلْبَ
u'أَنَّ قَلْب':Predicate, #1: 1	أَنَّ قَلْبَ
u'أَنَّ قِلَّةٌ':Predicate, #1: 1	أَنَّ قَلْبَ
u'أَنَّ قَلْسٌ':Predicate, #1: 1	أَنَّ الْقِلَّةَ
u'أَنَّ قَلَمٌ':Predicate, #3: 3	أَنَّ الْقَلْسَ
u'أَنَّ قُلُوبٌ':Predicate, #2: 2	أَنَّ الْقَلَمَ
u'أَنَّ قُلُوبٌ':Predicate, #2: 2	أَنَّ الْقُلُوبَ
u'أَنَّ قَلِيلٌ':Predicate, #2: 2	أَنَّ قُلُوبَ
u'أَنَّ قَلِيلٌ':Predicate, #33: 33	أَنَّ الْقَلِيلَ
u'أَنَّ قِمَارٌ':Predicate, #5: 5	أَنَّ قَلِيلَ
u'أَنَّ قَمْحٌ':Predicate, #1: 1	أَنَّ الْقِمَارَ
u'أَنَّ قمر':Predicate, #4: 4	أَنَّ الْقَمْحَ
u'أَنَّ قَمَرٌ':Predicate, #6: 6	أَنَّ الْقَمَرَ
u'أَنَّ قَمْلٌ':Predicate, #6: 6	أَنَّ الْقَمَرَ
u'أَنَّ قَمِيصٌ':Predicate, #1: 1	أَنَّ الْقَمْلَ
u'أَنَّ قِنٌّ':Predicate, #8: 8	أَنَّ الْقَمِيصَ
u'أَنَّ قِنٌّ':Predicate, #1: 1	أَنَّ قِنَّ
u'أَنَّ قَنَاةٌ':Predicate, #2: 2	أَنَّ الْقِنَّ
u'أَنَّ قَنْصٌ':Predicate, #1: 1	أَنَّ الْقَنَاةَ
u'أَنَّ قِنْطَارٌ':Predicate, #1: 1	أَنَّ الْقَنْصَ
u'أَنَّ قُنُوتٌ':Predicate, #1: 1	أَنَّ الْقِنْطَارَ
u'أَنَّ قُنُوتٌ':Predicate, #13: 13	أَنَّ الْقُنُوتَ
u'أَنَّ قَهْقَه':Predicate, #1: 1	أَنَّ قُنُوتَ
u'أَنَّ قَهْقَه':Predicate, #1: 1	أَنَّ قَهْقَهَةَ
u'أَنَّ قَهْقَهَة':Predicate, #4: 4	أَنَّ الْقَهْقَهَةَ
u'أَنَّ قَهْقَهَة':Predicate, #1: 1	أَنَّ قَهْقَهَةَ
u'أَنَّ قَهْوَةٌ':Predicate, #4: 4	أَنَّ الْقَهْقَهَةَ
u'أَنَّ قَوَاعِدُ':Predicate, #1: 1	أَنَّ الْقَهْوَةَ
u'أَنَّ قَوَاعِدُ':Predicate, #2: 2	أَنَّ الْقَوَاعِدَ
u'أَنَّ قوافل':Predicate, #2: 2	أَنَّ قَوَاعِدَ
u'أَنَّ قَوَافِلُ':Predicate, #2: 2	أَنَّ الْقَوَافِلَ
u'أَنَّ قُوَّامٌ':Predicate, #2: 2	أَنَّ الْقَوَافِلَ
u'أَنَّ قِوَامٌ':Predicate, #1: 1	أَنَّ الْقُوَّامَ
u'أَنَّ قُوَّةٌ':Predicate, #2: 2	أَنَّ قِوَامَ
u'أَنَّ قُوَّة':Predicate, #2: 2	أَنَّ قُوَّةَ
u'أَنَّ قُوَّةٌ':Predicate, #2: 2	أَنَّ قُوَّةَ
u'أَنَّ قُوَّة':Predicate, #4: 4	أَنَّ الْقُوَّةَ
u'أَنَّ قَوَد':Predicate, #4: 4	أَنَّ الْقُوَّةَ
u'أَنَّ قول':Predicate, #11: 11	أَنَّ الْقَوَدَ
u'أَنَّ قَوْلٌ':Predicate, #1: 1	أَنَّ قَوْلَهُنَّ
u'أَنَّ قول':Predicate, #1: 1	أَنَّ قَوْلَهُنَّ
u'أَنَّ قَوْلٌ':Predicate, #286: 286	أَنَّ قَوْلَ
u'أَنَّ قول':Predicate, #286: 286	أَنَّ قَوْلَ
u'أَنَّ قَوْلٌ':Predicate, #298: 298	أَنَّ الْقَوْلَ
u'أَنَّ قَوْلَةٌ':Predicate, #298: 298	أَنَّ الْقَوْلَ
u'أَنَّ قَوْمٌ':Predicate, #1: 1	أَنَّ قَوْلَةَ
u'أَنَّ قَوْمٌ':Predicate, #23: 23	أَنَّ الْقَوْمَ
u'أَنَّ قَوْمَةٌ':Predicate, #5: 5	أَنَّ قَوْمَ
u'أَنَّ قَوِيٌّ':Predicate, #2: 2	أَنَّ الْقَوْمَةَ
u'أَنَّ قَيْءٌ':Predicate, #2: 2	أَنَّ الْقَوِيَّ
u'أَنَّ قِيَاسٌ':Predicate, #1: 1	أَنَّ الْقَيْءَ
u'أَنَّ قِيَاسٌ':Predicate, #130: 130	أَنَّ الْقِيَاسَ
u'أَنَّ قِيافَة':Predicate, #31: 31	أَنَّ قِيَاسَ
u'أَنَّ قيام':Predicate, #1: 1	أَنَّ الْقِيَافَةَ
u'أَنَّ قِيَامٌ':Predicate, #15: 15	أَنَّ قِيَامَ
u'أَنَّ قيام':Predicate, #15: 15	أَنَّ قِيَامَ
u'أَنَّ قِيَامٌ':Predicate, #29: 29	أَنَّ الْقِيَامَ
u'آنَ قيام':Subject, #29: 29	أَنَّ الْقِيَامَ
u'آنَ قِيَامٌ':Subject, #1: 1	آنَ قِيَامُ
u'أَنَّ قِيَامَةٌ':Predicate, #1: 1	آنَ قِيَامُ
u'أَنَّ قَيْحٌ':Predicate, #1: 1	أَنَّ الْقِيَامَةَ
u'أَنَّ قَيْدٌ':Predicate, #1: 1	أَنَّ الْقَيْحَ
u'أَنَّ قَيْدٌ':Predicate, #14: 14	أَنَّ قَيْدَ
u'أَنَّ قَيْصَرٌ':Predicate, #9: 9	أَنَّ الْقَيْدَ
u'أَنَّ قَيْلُولَةٌ':Predicate, #1: 1	أَنَّ قَيْصَرَ
u'أَنَّ قَيِّمٌ':Predicate, #1: 1	أَنَّ الْقَيْلُولَةَ
u'أَنَّ قَيِّمٌ':Predicate, #10: 10	أَنَّ الْقَيِّمَ
u'أَنَّ قَيِّمٌ':Subject, #2: 2	أَنَّ قَيِّمَ
u'أَنَّ قِيمَةٌ':Predicate, #1: 1	أَنَّ الْقَيِّمُ
u'أَنَّ قِيمَةٌ':Predicate, #33: 33	أَنَّ الْقِيمَةَ
u'أَنَّ قُيُودٌ':Predicate, #45: 45	أَنَّ قِيمَةَ
u'أَنَّ كَاتِبٌ':Predicate, #1: 1	أَنَّ الْقُيُودَ
u'أَنَّ كَاتِبٌ':Predicate, #1: 1	أَنَّ الْكَاتِبِينَ
u'أَنَّ كَاتِبٌ':Predicate, #2: 2	أَنَّ كَاتِبَ
u'أَنَّ كَاذِبٌ':Predicate, #6: 6	أَنَّ الْكَاتِبَ
u'أَنَّ كَاشِفٌ':Predicate, #1: 1	أَنَّ الْكَاذِبَ
u'أَنَّ كَاغِدٌ':Predicate, #1: 1	أَنَّ كَاشِفَ
u'أَنَّ كَافِرٌ':Predicate, #1: 1	أَنَّ الْكَاغِدَ
u'أَنَّ كَافِرٌ':Predicate, #1: 1	أَنَّ الْكَافِرِينَ
u'أَنَّ كَافِرٌ':Predicate, #2: 2	أَنَّ الْكَافِرَةَ
u'أَنَّ كَافِلٌ':Predicate, #51: 51	أَنَّ الْكَافِرَ
u'أَنَّ كَافُورٌ':Predicate, #4: 4	أَنَّ الْكَافِلَ
u'أَنَّ كَامِلٌ':Predicate, #2: 2	أَنَّ الْكَافُورَ
u'أَنَّ كَامِلٌ':Predicate, #1: 1	أَنَّ الْكَامِلَةَ
u'أَنَّ كَامِلٌ':Predicate, #1: 1	أَنَّ كَامِلَ
u'أَنَّ كُبَادٌ':Predicate, #3: 3	أَنَّ الْكَامِلَ
u'أَنَّ كبار':Predicate, #1: 1	أَنَّ الْكُبَادَ
u'أَنَّ كبار':Predicate, #1: 1	أَنَّ الْكِبَارَ
u'أَنَّ كبائر':Predicate, #3: 3	أَنَّ كِبَارَ
u'أَنَّ كبر':Predicate, #5: 5	أَنَّ الْكَبَائِرَ
u'أَنَّ كِبْرٌ':Predicate, #1: 1	أَنَّ الْكِبْرَ
u'أَنَّ كَبِيرٌ':Predicate, #1: 1	أَنَّ الْكِبْرَ
u'أَنَّ كَبِيرٌ':Predicate, #12: 12	أَنَّ الْكَبِيرَةَ
u'أَنَّ كَبِيرٌ':Predicate, #1: 1	أَنَّ كَبِيرَ
u'أَنَّ كِتَابٌ':Predicate, #4: 4	أَنَّ الْكَبِيرَ
u'أَنَّ كِتَابٌ':Predicate, #15: 15	أَنَّ كِتَابَ
u'أَنَّ كِتاب':Predicate, #26: 26	أَنَّ الْكِتَابَ
u'أَنَّ كِتَابَةٌ':Predicate, #6: 6	أَنَّ الْكِتَابِيَّةَ
u'أَنَّ كِتَابَةٌ':Predicate, #10: 10	أَنَّ كِتَابَةَ
u'أَنَّ كِتابَة':Predicate, #49: 49	أَنَّ الْكِتَابَةَ
u'أَنَّ كِتابِيّ':Predicate, #6: 6	أَنَّ الْكِتَابِيَّةَ
u'أَنَّ كَتَّانٌ':Predicate, #6: 6	أَنَّ الْكِتَابِيَّةَ
u'أَنَّ كُتُبٌ':Predicate, #5: 5	أَنَّ الْكَتَّانَ
u'أَنَّ كُتُبٌ':Predicate, #6: 6	أَنَّ كُتُبَ
u'أَنَّ كَتَبَةٌ':Predicate, #8: 8	أَنَّ الْكُتُبَ
u'أَنَّ كِتْمَانٌ':Predicate, #1: 1	أَنَّ الْكَتَبَةَ
u'أَنَّ كِتْمَانٌ':Predicate, #1: 1	أَنَّ الْكِتْمَانَ
u'أَنَّ كَثْرَةٌ':Predicate, #1: 1	أَنَّ كِتْمَانَ
u'أَنَّ كَثْرَةٌ':Predicate, #15: 15	أَنَّ كَثْرَةَ
u'أَنَّ كَثِيرٌ':Predicate, #9: 9	أَنَّ الْكَثْرَةَ
u'أَنَّ كَثِيرٌ':Predicate, #22: 22	أَنَّ الْكَثِيرَ
u'أَنَّ كَثِيرٌ':Predicate, #3: 3	أَنَّ كَثِيرَ
u'أَنْكَحَ أُمٌّ':Predicate, #9: 9	أَنَّ كَثِيرِينَ
u'أَنْكَحَ أمَةٌ':Predicate, #1: 1	أَنْكَحَ أُمَّ
u'أَنْكَحَ خَدِيج':Predicate, #2: 2	أَنْكَحَ الْأَمَةَ
u'أَنْكَحَ رَجُلٌ':Subject, #2: 2	أَنْكَحَ خَدِيجَةَ
u'أَنْكَحَ رَسُولٌ':Predicate, #2: 2	أَنْكَحَ الرَّجُلُ
u'أَنْكَحَ سَيِّدٌ':Subject, #1: 1	أَنْكَحَ رَسُولَ
u'أَنْكَحَ عَبْدٌ':Predicate, #1: 1	أَنْكَحَ سَيِّدُ
u'أَنْكَحَ فلان':Predicate, #1: 1	أَنْكَحَ عَبْدَ
u'أَنْكَحَ قَالٌ':Predicate, #2: 2	أَنْكَحَ خَدِيجَةَ
u'أَنَّ كحل':Predicate, #1: 1	أَنْكَحَ قَالَ
u'أَنَّ كُحْلٌ':Predicate, #1: 1	أَنَّ الْكُحْلَ
u'أَنْكَحَ واحد':Predicate, #1: 1	أَنَّ الْكُحْلَ
u'أَنْكَحَ وَاحِدٌ':Predicate, #1: 1	أَنْكَحَ وَاحِدَةً
u'أَنْكَحَ وَالِدٌ':Subject, #1: 1	أَنْكَحَ وَاحِدَةً
u'أَنَّ كذب':Predicate, #1: 1	أَنْكَحَ الْوَالِدُ
u'أَنَّ كَذِبٌ':Predicate, #14: 14	أَنَّ الْكَذِبَ
u'أَنَّ كَذْبَةٌ':Predicate, #14: 14	أَنَّ الْكَذِبَ
u'أَنَّ كِرَاءٌ':Predicate, #1: 1	أَنَّ الْكَذْبَةَ
u'أَنَّ كِرَاءٌ':Predicate, #1: 1	أَنَّ كِرَاءَ
u'أَنْكَرَ أَبٌ':Subject, #6: 6	أَنَّ الْكِرَاءَ
u'أَنْكَرَ اِبْنٌ':Subject, #4: 4	أَنْكَرَ الْأَبُ
u'أَنْكَرَ إِثْبَاتٌ':Predicate, #5: 5	أَنْكَرَ ابْنُ
u'أَنْكَرَ إجَارَةٌ':Predicate, #1: 1	أَنْكَرَ إِثْبَاتَ
u'أَنْكَرَ إِجْمَاعٌ':Predicate, #3: 3	أَنْكَرَ الْإِجَارَةَ
u'أَنْكَرَ أَجْنَبِيٌّ':Subject, #2: 2	أَنْكَرَ الْإِجْمَاعَ
u'أَنْكَرَ إِجْهَاضٌ':Predicate, #3: 3	أَنْكَرَ الْأَجْنَبِيُّ
u'أَنْكَرَ أحَدٌ':Predicate, #1: 1	أَنْكَرَ الْإِجْهَاضَ
u'أَنْكَرَ أحَدٌ':Subject, #2: 2	أَنْكَرَ أَحَدَ
u'أَنْكَرَ أحَدٌ':Subject, #2: 2	أَنْكَرَ أَحَدٌ
u'أَنْكَرَ أَدَاءٌ':Predicate, #3: 3	أَنْكَرَ أَحَدُ
u'أَنْكَرَ أَدَاءٌ':Predicate, #1: 1	أَنْكَرَ أَدَاءَ
u'أَنْكَرَ إِذْنٌ':Predicate, #1: 1	أَنْكَرَ الْأَدَاءَ
u'أَنْكَرَ إِذْنٌ':Predicate, #1: 1	أَنْكَرَ إذْنَ
u'أَنْكَرَ إِرْثٌ':Predicate, #3: 3	أَنْكَرَ الْإِذْنَ
u'أَنْكَرَ إِسْراءٌ':Predicate, #1: 1	أَنْكَرَ الْإِرْثَ
u'أَنْكَرَ اِشْتِراطٌ':Predicate, #2: 2	أَنْكَرَ الْإِسْرَاءَ
u'أَنْكَرَ اِشْتِراطٌ':Predicate, #1: 1	أَنْكَرَ اشْتِرَاطَ
u'أَنْكَرَ اِشْتِمالٌ':Predicate, #1: 1	أَنْكَرَ الاِشْتِرَاطَ
u'أَنْكَرَ أَصْحَابٌ':Subject, #1: 1	أَنْكَرَ اشْتِمَالَ
u'أَنْكَرَ أصل':Predicate, #1: 1	أَنْكَرَ أَصْحَابُهُ
u'أَنْكَرَ أًصْلٌ':Predicate, #16: 16	أَنْكَرَ أَصْلَ
u'أَنْكَرَ أصل':Predicate, #16: 16	أَنْكَرَ أَصْلَ
u'أَنْكَرَ أًصْلٌ':Predicate, #1: 1	أَنْكَرَ الْأَصْلَ
u'أَنْكَرَ أصل':Subject, #1: 1	أَنْكَرَ الْأَصْلَ
u'أَنْكَرَ أًصْلٌ':Subject, #4: 4	أَنْكَرَ الْأَصْلُ
u'أَنْكَرَ أُصولٌ':Predicate, #4: 4	أَنْكَرَ الْأَصْلُ
u'أَنْكَرَ إِعْجازٌ':Predicate, #1: 1	أَنْكَرَ أُصُولَ
u'أَنْكَرَ إقْرَارٌ':Predicate, #1: 1	أَنْكَرَ إعْجَازَ
u'أَنْكَرَ أَكْثَرُ':Predicate, #3: 3	أَنْكَرَ الْإِقْرَارَ
u'أَنْكَرَ إلَهٌ':Predicate, #1: 1	أَنْكَرَ أَكْثَرَ
u'أَنَّ كَرّام':Predicate, #1: 1	أَنْكَرَ الْإِلَهَ
u'أَنْكَرَ إمَامٌ':Subject, #1: 1	أَنَّ الْكَرَّامِيَّةَ
u'أَنْكَرَ إمَامَةٌ':Predicate, #3: 3	أَنْكَرَ الْإِمَامُ
u'أَنْكَرَ أَمْرٌ':Predicate, #1: 1	أَنْكَرَ إمَامَةَ
u'أَنْكَرَ آمِرٌ':Subject, #1: 1	أَنْكَرَ الْأَمْرَ
u'أَنَّ كَرَاهَةٌ':Predicate, #1: 1	أَنْكَرَ الْآمِرُ
u'أَنَّ كَرَاهَةٌ':Predicate, #17: 17	أَنَّ كَرَاهَةَ
u'أَنْكَرَ أهْلٌ':Subject, #57: 57	أَنَّ الْكَرَاهَةَ
u'أَنَّ كَرَاهِيَةٌ':Predicate, #4: 4	أَنْكَرَ أَهْلُ
u'أَنْكَرَ أئِمَّةٌ':Subject, #2: 2	أَنَّ الْكَرَاهِيَةَ
u'أَنْكَرَ إِيدَاعٌ':Predicate, #1: 1	أَنْكَرَ الْأَئِمَّةُ
u'أَنَّ كَرْبٌ':Predicate, #3: 3	أَنْكَرَ الْإِيدَاعَ
u'أَنْكَرَ بَاطن':Predicate, #1: 1	أَنَّ الْكَرْبَ
u'أَنْكَرَ باطِنٌ':Predicate, #1: 1	أَنْكَرَ الْبَاطِنَ
u'أَنْكَرَ بَائِعٌ':Subject, #1: 1	أَنْكَرَ الْبَاطِنَ
u'أَنْكَرَ بِشْرٌ':Subject, #6: 6	أَنْكَرَ الْبَائِعُ
u'أَنْكَرَ بَعْثٌ':Predicate, #1: 1	أَنْكَرَ بِشْرٌ
u'أَنْكَرَ بَعْثٌ':Predicate, #2: 2	أَنْكَرَ بَعْثَ
u'أَنْكَرَ بَعْضٌ':Predicate, #4: 4	أَنْكَرَ الْبَعْثَ
u'أَنْكَرَ بَعْضٌ':Subject, #2: 2	أَنْكَرَ بَعْضَ
u'أَنْكَرَ بَيْعٌ':Predicate, #5: 5	أَنْكَرَ بَعْضُ
u'أَنْكَرَ بَيْعٌ':Predicate, #1: 1	أَنْكَرَ بَيْعَ
u'أَنْكَرَ تَأْكِيدٌ':Predicate, #6: 6	أَنْكَرَ الْبَيْعَ
u'أَنْكَرَ تَدْبِيرٌ':Predicate, #1: 1	أَنْكَرَ تَأْكِيدَ
u'أَنْكَرَ تَصَوُّرٌ':Predicate, #3: 3	أَنْكَرَ التَّدْبِيرَ
u'أَنْكَرَ تَعَيُّنٌ':Predicate, #1: 1	أَنْكَرَ تَصَوُّرَ
u'أَنْكَرَ تمام':Predicate, #4: 4	أَنْكَرَ تَعَيُّنَ
u'أَنْكَرَ تَمامٌ':Predicate, #1: 1	أَنْكَرَ تَمَامَ
u'أَنْكَرَ تَمْلِيك':Predicate, #1: 1	أَنْكَرَ تَمَامَ
u'أَنْكَرَ تَوْكِيلٌ':Predicate, #2: 2	أَنْكَرَ التَّمْلِيكَ
u'أَنْكَرَ ثُبُوتٌ':Predicate, #1: 1	أَنْكَرَ التَّوْكِيلَ
u'أَنْكَرَ ثِقَة':Subject, #3: 3	أَنْكَرَ ثُبُوتَ
u'أَنْكَرَ ثَلاثُ':Predicate, #1: 1	أَنْكَرَ الثِّقَاتُ
u'أَنْكَرَ جَمَاعَةٌ':Subject, #1: 1	أَنْكَرَ الثَّلَاثَ
u'أَنْكَرَ جُمْهُورٌ':Subject, #4: 4	أَنْكَرَ جَمَاعَةٌ
u'أَنْكَرَ جَوَازٌ':Predicate, #1: 1	أَنْكَرَ جُمْهُورٌ
u'أَنْكَرَ حاكِمٌ':Subject, #1: 1	أَنْكَرَ الْجَوَازَ
u'أَنْكَرَ حُجَّة':Predicate, #1: 1	أَنْكَرَ الْحَاكِمُ
u'أَنْكَرَ حَجْرٌ':Predicate, #1: 1	أَنْكَرَ حُجِّيَّةَ
u'أَنْكَرَ حُجِّيَّة':Predicate, #1: 1	أَنْكَرَ الْحَجْرَ
u'أَنْكَرَ حَديثٌ':Predicate, #1: 1	أَنْكَرَ حُجِّيَّةَ
u'أَنْكَرَ حُرْمَةٌ':Predicate, #2: 2	أَنْكَرَ حَدِيثَ
u'أَنْكَرَ حَسَنٌ':Subject, #1: 1	أَنْكَرَ حُرْمَةَ
u'أَنْكَرَ حَقٌّ':Predicate, #1: 1	أَنْكَرَ الْحَسَنُ
u'أَنْكَرَ حَقِيقٌ':Predicate, #1: 1	أَنْكَرَ الْحَقَّ
u'أَنْكَرَ حَقِيقَةٌ':Predicate, #1: 1	أَنْكَرَ حَقِيقَةَ
u'أَنْكَرَ حُكْمٌ':Predicate, #1: 1	أَنْكَرَ حَقِيقَةَ
u'أَنْكَرَ حَمْلٌ':Predicate, #3: 3	أَنْكَرَ الْحُكْمَ
u'أَنْكَرَ حَيَاةٌ':Predicate, #1: 1	أَنْكَرَ حَمْلَ
u'أَنْكَرَ خَبَرٌ':Predicate, #1: 1	أَنْكَرَ حَيَاةَ
u'أَنْكَرَ خَبَر':Predicate, #1: 1	أَنْكَرَ خَبَرَ
u'أَنْكَرَ خَصْمٌ':Subject, #1: 1	أَنْكَرَ خَبَرَ
u'أَنْكَرَ خَصْمٌ':Subject, #1: 1	أَنْكَرَ خَصْمُهُ
u'أَنْكَرَ خُضْرَةٌ':Predicate, #4: 4	أَنْكَرَ الْخَصْمُ
u'أَنْكَرَ خَطٌّ':Predicate, #1: 1	أَنْكَرَ الْخُضْرَةَ
u'أَنْكَرَ خِلاَفٌ':Predicate, #1: 1	أَنْكَرَ الْخَطَّ
u'أَنْكَرَ خِلاَفَةٌ':Predicate, #1: 1	أَنْكَرَ الْخِلَافَ
u'أَنْكَرَ خُلْعٌ':Predicate, #2: 2	أَنْكَرَ خِلَافَةَ
u'أَنْكَرَ دَافِعٌ':Subject, #1: 1	أَنْكَرَ الْخُلْعَ
u'أَنْكَرَ دُخُولٌ':Predicate, #2: 2	أَنْكَرَ الدَّافِعُ
u'أَنْكَرَ دُعَاءٌ':Predicate, #5: 5	أَنْكَرَ الدُّخُولَ
u'أَنْكَرَ دونٌ':Predicate, #1: 1	أَنْكَرَ الدُّعَاءَ
u'أَنْكَرَ دَيْنٌ':Predicate, #1: 1	أَنْكَرَ دُونَ
u'أَنْكَرَ ذكر':Predicate, #7: 7	أَنْكَرَ الدَّيْنَ
u'أَنْكَرَ ذَكَرٌ':Predicate, #1: 1	أَنْكَرَ ذَكَرَ
u'أَنْكَرَ رَبُّ':Subject, #1: 1	أَنْكَرَ ذَكَرَ
u'أَنْكَرَ رَجُلٌ':Subject, #5: 5	أَنْكَرَ رَبُّ
u'أَنْكَرَ رَجُلٌ':Subject, #1: 1	أَنْكَرَ رَجُلٌ
u'أَنْكَرَ رِسَالَةٌ':Predicate, #2: 2	أَنْكَرَ الرَّجُلُ
u'أَنْكَرَ رِسَالَةٌ':Predicate, #1: 1	أَنْكَرَ الرِّسَالَةَ
u'أَنْكَرَ رَسُولٌ':Subject, #1: 1	أَنْكَرَ رِسَالَةَ
u'أَنْكَرَ رِقٌّ':Predicate, #1: 1	أَنْكَرَ رَسُولُ
u'أَنْكَرَ رَهْنٌ':Predicate, #1: 1	أَنْكَرَ الرِّقَّ
u'أَنْكَرَ رِوايَةٌ':Predicate, #2: 2	أَنْكَرَ الرَّهْنَ
u'أَنْكَرَ رُؤْيَةٌ':Predicate, #1: 1	أَنْكَرَ الرِّوَايَةَ
u'أَنْكَرَ زَوْجٌ':Subject, #3: 3	أَنْكَرَ الرُّؤْيَةَ
u'أَنْكَرَ زَوْجِيٌّ':Predicate, #13: 13	أَنْكَرَ الزَّوْجُ
u'أَنْكَرَ زِيادَةٌ':Predicate, #1: 1	أَنْكَرَ الزَّوْجِيَّةَ
u'أَنْكَرَ زِيارَةٌ':Predicate, #2: 2	أَنْكَرَ الزِّيَادَةَ
u'أَنْكَرَ سَبَبٌ':Predicate, #1: 1	أَنْكَرَ الزِّيَارَةَ
u'أَنْكَرَ سَبَبٌ':Predicate, #1: 1	أَنْكَرَ سَبَبَ
u'أَنْكَرَ سَرقَةٌ':Predicate, #5: 5	أَنْكَرَ السَّبَبَ
u'أَنْكَرَ سَرِقَةٌ':Predicate, #1: 1	أَنْكَرَ السَّرِقَةَ
u'أَنْكَرَ سَفِيهٌ':Subject, #1: 1	أَنْكَرَ السَّرِقَةَ
u'أَنْكَرَ سُنَّةٌ':Predicate, #1: 1	أَنْكَرَ السَّفِيهُ
u'أَنْكَرَ سَواءٌ':Subject, #1: 1	أَنْكَرَ سُنَّةَ
u'أَنْكَرَ سَيِّدٌ':Subject, #1: 1	أَنْكَرَ سَوَاءٌ
u'أَنَّ كرش':Predicate, #3: 3	أَنْكَرَ السَّيِّدُ
u'أَنَّ كَرِشٌ':Predicate, #2: 2	أَنَّ الْكَرِشَ
u'أَنْكَرَ شَاهِدٌ':Subject, #2: 2	أَنَّ الْكَرِشَ
u'أَنْكَرَ شَخْصٌ':Subject, #1: 1	أَنْكَرَ شَاهِدُ
u'أَنْكَرَ شِرَاءٌ':Predicate, #1: 1	أَنْكَرَ شَخْصٌ
u'أَنْكَرَ شِرَاءٌ':Predicate, #1: 1	أَنْكَرَ شِرَاءَ
u'أَنْكَرَ شَرْطٌ':Predicate, #9: 9	أَنْكَرَ الشِّرَاءَ
u'أَنْكَرَ شَرْطٌ':Predicate, #1: 1	أَنْكَرَ شَرْطَ
u'أَنْكَرَ شركة':Predicate, #4: 4	أَنْكَرَ الشَّرْطَ
u'أَنْكَرَ شَرِكَةٌ':Predicate, #1: 1	أَنْكَرَ شَرِكَةَ
u'أَنْكَرَ شركة':Predicate, #1: 1	أَنْكَرَ شَرِكَةَ
u'أَنْكَرَ شَرِكَةٌ':Predicate, #3: 3	أَنْكَرَ الشَّرِكَةَ
u'أَنْكَرَ شَرِيكٌ':Subject, #3: 3	أَنْكَرَ الشَّرِكَةَ
u'أَنْكَرَ شَفَاعَةٌ':Predicate, #1: 1	أَنْكَرَ الشَّرِيكُ
u'أَنْكَرَ شَهَادَةٌ':Predicate, #1: 1	أَنْكَرَ الشَّفَاعَةَ
u'أَنْكَرَ شَهْرٌ':Predicate, #3: 3	أَنْكَرَ الشَّهَادَةَ
u'أَنْكَرَ شَهْوَةٌ':Predicate, #1: 1	أَنْكَرَ الشَّهْرَ
u'أَنْكَرَ شُهُودٌ':Subject, #1: 1	أَنْكَرَ الشَّهْوَةَ
u'أَنْكَرَ شَيْخٌ':Subject, #6: 6	أَنْكَرَ شُهُودُ
u'أَنْكَرَ صَاحِبٌ':Subject, #1: 1	أَنْكَرَ الشَّيْخُ
u'أَنْكَرَ صَاحِبٌ':Subject, #1: 1	أَنْكَرَ صَاحِبُ
u'أَنْكَرَ صَبَّاغٌ':Subject, #2: 2	أَنْكَرَ صَاحِبُهُ
u'أَنْكَرَ صحبة':Predicate, #1: 1	أَنْكَرَ الصَّبَّاغُ
u'أَنْكَرَ صُحْبَةٌ':Predicate, #1: 1	أَنْكَرَ صُحْبَةَ
u'أَنْكَرَ صِحَّةٌ':Predicate, #1: 1	أَنْكَرَ صُحْبَةَ
u'أَنْكَرَ صِحَّةٌ':Predicate, #1: 1	أَنْكَرَ صِحَّةَ
u'أَنْكَرَ صَنِيعٌ':Predicate, #9: 9	أَنْكَرَ الصِّحَّةَ
u'أَنْكَرَ صَنِيعَةٌ':Predicate, #1: 1	أَنْكَرَ الصَّنِيعَةَ
u'أَنْكَرَ ضَمِنٌ':Predicate, #1: 1	أَنْكَرَ الصَّنِيعَةَ
u'أَنْكَرَ طَالِبٌ':Subject, #1: 1	أَنْكَرَ ضَمِنَ
u'أَنْكَرَ طَلاَقٌ':Predicate, #3: 3	أَنْكَرَ الطَّالِبُ
u'أَنْكَرَ طلب':Predicate, #3: 3	أَنْكَرَ الطَّلَاقَ
u'أَنْكَرَ طَلَبٌ':Predicate, #2: 2	أَنْكَرَ طَلَبَ
u'أَنَّ كَرْع':Predicate, #2: 2	أَنْكَرَ طَلَبَ
u'أَنْكَرَ عَامٌّ':Subject, #1: 1	أَنَّ الْكَرْعَ
u'أَنْكَرَ عَامِلٌ':Subject, #1: 1	أَنْكَرَ عَامَّةُ
u'أَنْكَرَ عَبَّاسٌ':Subject, #2: 2	أَنْكَرَ الْعَامِلُ
u'أَنْكَرَ عَبْدٌ':Subject, #1: 1	أَنْكَرَ الْعَبّاسُ
u'أَنْكَرَ عَدَدٌ':Predicate, #2: 2	أَنْكَرَ الْعَبْدُ
u'أَنْكَرَ عَدْلٌ':Subject, #1: 1	أَنْكَرَ الْعَدَدَ
u'أَنْكَرَ عَفْوٌ':Predicate, #1: 1	أَنْكَرَ الْعَدْلُ
u'أَنْكَرَ عَقْدٌ':Predicate, #1: 1	أَنْكَرَ عَفْوَ
u'أَنْكَرَ عِلَّةٌ':Predicate, #1: 1	أَنْكَرَ الْعَقْدَ
u'أَنْكَرَ علم':Predicate, #1: 1	أَنْكَرَ عِلَّةَ
u'أَنْكَرَ عِلْمٌ':Predicate, #1: 1	أَنْكَرَ الْعِلْمَ
u'أَنْكَرَ علماء':Subject, #1: 1	أَنْكَرَ الْعِلْمَ
u'أَنْكَرَ عُلَمَاءُ':Subject, #1: 1	أَنْكَرَ الْعُلَمَاءُ
u'أَنْكَرَ عُمَرٌ':Subject, #1: 1	أَنْكَرَ الْعُلَمَاءُ
u'أَنْكَرَ عُمُومٌ':Predicate, #2: 2	أَنْكَرَ عُمَرُ
u'أَنْكَرَ عُمُومٌ':Predicate, #1: 1	أَنْكَرَ الْعُمُومَ
u'أَنْكَرَ عند':Predicate, #1: 1	أَنْكَرَ عُمُومَ
u'أَنْكَرَ عَوَاقِلُ':Subject, #1: 1	أَنْكَرَ عِنْدَ
u'أَنْكَرَ عَيْبٌ':Predicate, #2: 2	أَنْكَرَ الْعَوَاقِلُ
u'أَنْكَرَ عين':Predicate, #2: 2	أَنْكَرَ الْعَيْبَ
u'أَنْكَرَ عَيْنٌ':Predicate, #1: 1	أَنْكَرَ الْعَيْنَ
u'أَنْكَرَ عَيْن':Predicate, #1: 1	أَنْكَرَ الْعَيْنَ
u'أَنْكَرَ غَائِبٌ':Subject, #1: 1	أَنْكَرَ الْعَيْنَ
u'أَنْكَرَ فتنة':Predicate, #3: 3	أَنْكَرَ الْغَائِبُ
u'أَنْكَرَ فِتْنَةٌ':Predicate, #1: 1	أَنْكَرَ فِتْنَةَ
u'أَنْكَرَ فُلاَنٌ':Subject, #1: 1	أَنْكَرَ فِتْنَةَ
u'أَنْكَرَ قَاتِلٌ':Subject, #4: 4	أَنْكَرَ فُلَانٌ
u'أَنْكَرَ قَاذِفٌ':Subject, #1: 1	أَنْكَرَ الْقَاتِلُ
u'أَنْكَرَ قَالٌ':Predicate, #2: 2	أَنْكَرَ الْقَاذِفُ
u'أَنْكَرَ قَبْضٌ':Predicate, #2: 2	أَنْكَرَ قَالَ
u'أَنْكَرَ قَبْضٌ':Predicate, #4: 4	أَنْكَرَ قَبْضَ
u'أَنْكَرَ قدرة':Predicate, #5: 5	أَنْكَرَ الْقَبْضَ
u'أَنْكَرَ قُدْرَةٌ':Predicate, #1: 1	أَنْكَرَ الْقُدْرَةَ
u'أَنْكَرَ قُرْآنٌ':Predicate, #1: 1	أَنْكَرَ الْقُدْرَةَ
u'أَنْكَرَ قَرْضٌ':Predicate, #2: 2	أَنْكَرَ الْقُرْآنَ
u'أَنْكَرَ قَصْدٌ':Predicate, #1: 1	أَنْكَرَ الْقَرْضَ
u'أَنْكَرَ قَضَاءٌ':Predicate, #1: 1	أَنْكَرَ قَصْدَ
u'أَنْكَرَ قُنُوتٌ':Predicate, #2: 2	أَنْكَرَ الْقَضَاءَ
u'أَنْكَرَ قول':Predicate, #1: 1	أَنْكَرَ الْقُنُوتَ
u'أَنْكَرَ قَوْلٌ':Predicate, #4: 4	أَنْكَرَ الْقَوْلَ
u'أَنْكَرَ قَوْمٌ':Subject, #4: 4	أَنْكَرَ الْقَوْلَ
u'أَنْكَرَ قِيَاسٌ':Predicate, #1: 1	أَنْكَرَ قَوْمٌ
u'أَنْكَرَ قيام':Predicate, #1: 1	أَنْكَرَ الْقِيَاسَ
u'أَنْكَرَ قِيَامٌ':Predicate, #3: 3	أَنْكَرَ قِيَامَ
u'أَنْكَرَ قِيَامَةٌ':Predicate, #3: 3	أَنْكَرَ قِيَامَ
u'أَنْكَرَ كِتَابَةٌ':Predicate, #1: 1	أَنْكَرَ الْقِيَامَةَ
u'أَنْكَرَ كَفَالَةٌ':Predicate, #1: 1	أَنْكَرَ الْكِتَابَةَ
u'أَنْكَرَ كَفِيلٌ':Subject, #1: 1	أَنْكَرَ الْكَفَالَةَ
u'أَنْكَرَ لَوْنٌ':Predicate, #2: 2	أَنْكَرَ الْكَفِيلُ
u'أَنَّ كَرْمٌ':Predicate, #1: 1	أَنْكَرَ لَوْنَ
u'أَنْكَرَ مَالٌ':Predicate, #4: 4	أَنَّ الْكَرْمَ
u'أَنْكَرَ مَالِكٌ':Subject, #4: 4	أَنْكَرَ الْمَالَ
u'أَنْكَرَ مَالِكٌ':Subject, #1: 1	أَنْكَرَ مَالِكُ
u'أَنْكَرَ مَالِكٌ':Subject, #3: 3	أَنْكَرَ الْمَالِكُ
u'أَنْكَرَ مُتَوَاتِرٌ':Predicate, #4: 4	أَنْكَرَ مَالِكٌ
u'أَنْكَرَ مَجَازٌ':Predicate, #1: 1	أَنْكَرَ الْمُتَوَاتِرَ
u'أَنْكَرَ مَجَازٌ':Predicate, #1: 1	أَنْكَرَ مَجَازَ
u'أَنْكَرَ مَحْبُوسٌ':Subject, #2: 2	أَنْكَرَ الْمَجَازَ
u'أَنْكَرَ مَحْكُومٌ':Subject, #1: 1	أَنْكَرَ الْمَحْبُوسُ
u'أَنْكَرَ مُرْتَهِنٌ':Subject, #1: 1	أَنْكَرَ مَحْكُومٌ
u'أَنْكَرَ مُسْتَأْجِرٌ':Subject, #3: 3	أَنْكَرَ الْمُرْتَهِنُ
u'أَنْكَرَ مُسْتَعِيرٌ':Subject, #2: 2	أَنْكَرَ الْمُسْتَأْجِرُ
u'أَنْكَرَ مَسْحٌ':Predicate, #1: 1	أَنْكَرَ الْمُسْتَعِيرُ
u'أَنْكَرَ مَشْهُودٌ':Subject, #1: 1	أَنْكَرَ الْمَسْحَ
u'أَنْكَرَ مَشْهُورٌ':Predicate, #1: 1	أَنْكَرَ الْمَشْهُودُ
u'أَنْكَرَ مُصَنِّفٌ':Subject, #1: 1	أَنْكَرَ الْمَشْهُورَ
u'أَنْكَرَ مَضْمُونٌ':Subject, #1: 1	أَنْكَرَ الْمُصَنِّفُ
u'أَنْكَرَ مَطْلُوبٌ':Subject, #1: 1	أَنْكَرَ الْمَضْمُونُ
u'أَنْكَرَ مُعَامَلَةٌ':Predicate, #1: 1	أَنْكَرَ الْمَطْلُوبُ
u'أَنْكَرَ مُعَانِدٌ':Subject, #1: 1	أَنْكَرَ الْمُعَامَلَةَ
u'أَنْكَرَ مُعانَقَة':Predicate, #1: 1	أَنْكَرَ الْمُعَانِدُ
u'أَنْكَرَ مِعْرَاجٌ':Predicate, #1: 1	أَنْكَرَ الْمُعَانَقَةَ
u'أَنْكَرَ مَعْرِفَةٌ':Predicate, #3: 3	أَنْكَرَ الْمِعْرَاجَ
u'أَنْكَرَ مَعْرِفَة':Predicate, #4: 4	أَنْكَرَ مَعْرِفَةَ
u'أَنْكَرَ مُعِير':Subject, #4: 4	أَنْكَرَ مَعْرِفَةَ
u'أَنْكَرَ مُغالاة':Predicate, #1: 1	أَنْكَرَ الْمُعِيرُ
u'أَنْكَرَ مُفْلِسٌ':Subject, #1: 1	أَنْكَرَ الْمُغَالَاةَ
u'أَنْكَرَ مَفْهُومٌ':Predicate, #1: 1	أَنْكَرَ الْمُفْلِسُ
u'أَنْكَرَ مَقْذُوفٌ':Subject, #2: 2	أَنْكَرَ الْمَفْهُومَ
u'أَنْكَرَ مَقْضِيّ':Subject, #1: 1	أَنْكَرَ الْمَقْذُوفُ
u'أَنْكَرَ مِلْكٌ':Predicate, #1: 1	أَنْكَرَ الْمَقْضِيُّ
u'أَنْكَرَ مَوْتٌ':Predicate, #2: 2	أَنْكَرَ مِلْكَ
u'أَنْكَرَ مُؤَجِّرٌ':Subject, #2: 2	أَنْكَرَ مَوْتَ
u'أَنْكَرَ مُودَعٌ':Subject, #1: 1	أَنْكَرَ الْمُؤَجِّرُ
u'أَنْكَرَ مُودِعٌ':Subject, #1: 1	أَنْكَرَ الْمُودَعُ
u'أَنْكَرَ مُوَكِّلٌ':Subject, #3: 3	أَنْكَرَ الْمُودِعُ
u'أَنْكَرَ مُوَكِّلٌ':Subject, #3: 3	أَنْكَرَ مُوَكِّلُهُ
u'أَنْكَرَ نَاظِرٌ':Subject, #6: 6	أَنْكَرَ الْمُوَكِّلُ
u'أَنْكَرَ نُبُوَّةٌ':Predicate, #1: 1	أَنْكَرَ النَّاظِرُ
u'أَنْكَرَ نَبِيٌّ':Subject, #1: 1	أَنْكَرَ نُبُوَّةَ
u'أَنْكَرَ نِسْبَةٌ':Predicate, #1: 1	أَنْكَرَ النَّبِيُّ
u'أَنْكَرَ نَفَذٌ':Predicate, #2: 2	أَنْكَرَ نِسْبَةَ
u'أَنْكَرَ نكاح':Predicate, #1: 1	أَنْكَرَ نَفَذَ
u'أَنْكَرَ نِكَاحٌ':Predicate, #5: 5	أَنْكَرَ النِّكَاحَ
u'أَنْكَرَ نَوَوِيٌّ':Subject, #5: 5	أَنْكَرَ النِّكَاحَ
u'أَنْكَرَ وَاجِدٌ':Subject, #2: 2	أَنْكَرَ النَّوَوِيُّ
u'أَنْكَرَ واحد':Subject, #1: 1	أَنْكَرَ وَاجِدُهُ
u'أَنْكَرَ وَاحِدٌ':Subject, #2: 2	أَنْكَرَ وَاحِدٌ
u'أَنْكَرَ وَارِثٌ':Subject, #2: 2	أَنْكَرَ وَاحِدٌ
u'أَنْكَرَ وَاهِبٌ':Subject, #5: 5	أَنْكَرَ الْوَارِثُ
u'أَنْكَرَ وَجْهٌ':Predicate, #1: 1	أَنْكَرَ الْوَاهِبُ
u'أَنْكَرَ وُجُوبٌ':Predicate, #1: 1	أَنْكَرَ وَجْهَ
u'أَنْكَرَ وُجُوبٌ':Predicate, #2: 2	أَنْكَرَ الْوُجُوبَ
u'أَنْكَرَ وُجُودٌ':Predicate, #9: 9	أَنْكَرَ وُجُوبَ
u'أَنْكَرَ وَدِيعٌ':Subject, #5: 5	أَنْكَرَ وُجُودَ
u'أَنْكَرَ وِرَاثَةٌ':Subject, #1: 1	أَنْكَرَ الْوَدِيعُ
u'أَنْكَرَ وَرَثَةٌ':Subject, #1: 1	أَنْكَرَ الْوِرَاثَةُ
u'أَنْكَرَ وُصُولٌ':Predicate, #5: 5	أَنْكَرَ الْوَرَثَةُ
u'أَنْكَرَ وَصِيٌّ':Subject, #1: 1	أَنْكَرَ وُصُولَ
u'أَنْكَرَ وَضْعٌ':Predicate, #1: 1	أَنْكَرَ الْوَصِيُّ
u'أَنْكَرَ وَضْعٌ':Predicate, #1: 1	أَنْكَرَ الْوَضْعَ
u'أَنْكَرَ وَطْءٌ':Predicate, #1: 1	أَنْكَرَ وَضْعَ
u'أَنْكَرَ وُقُوعٌ':Predicate, #1: 1	أَنْكَرَ الْوَطْءَ
u'أَنْكَرَ وِكَالَةٌ':Predicate, #2: 2	أَنْكَرَ وُقُوعَ
u'أَنْكَرَ وَكِيلٌ':Subject, #1: 1	أَنْكَرَ الْوِكَالَةَ
u'أَنْكَرَ وِلاَدَةٌ':Predicate, #4: 4	أَنْكَرَ الْوَكِيلُ
u'أَنْكَرَ ولد':Predicate, #2: 2	أَنْكَرَ الْوِلَادَةَ
u'أَنْكَرَ وَلَدٌ':Predicate, #1: 1	أَنْكَرَ وَلَدَ
u'أَنْكَرَ ولد':Predicate, #1: 1	أَنْكَرَ وَلَدَ
u'أَنْكَرَ وَلَدٌ':Predicate, #2: 2	أَنْكَرَ الْوَلَدَ
u'أَنْكَرَ ولد':Subject, #2: 2	أَنْكَرَ الْوَلَدَ
u'أَنْكَرَ وَلَدٌ':Subject, #1: 1	أَنْكَرَ الْوَلَدُ
u'أَنْكَرَ وَلِيٌّ':Subject, #1: 1	أَنْكَرَ الْوَلَدُ
u'أَنْكَرَ وَلِيٌّ':Subject, #2: 2	أَنْكَرَ وَلِيُّهُ
u'أَنَّ كُرُومٌ':Predicate, #4: 4	أَنْكَرَ الْوَلِيُّ
u'أَنَّ كَرِيٌّ':Predicate, #1: 1	أَنَّ الْكُرُومَ
u'أَنَّ كَرِيمٌ':Predicate, #1: 1	أَنَّ الْكَرِيَّ
u'أَنْكَرَ يَمِينٌ':Predicate, #2: 2	أَنَّ الْكَرِيمَ
u'أَنَّ كَسْبٌ':Predicate, #1: 1	أَنْكَرَ الْيَمِينَ
u'أَنَّ كَسْبٌ':Predicate, #13: 13	أَنَّ كَسْبَ
u'أَنَّ كَسْرٌ':Predicate, #14: 14	أَنَّ الْكَسْبَ
u'أَنَّ كَسْرٌ':Predicate, #1: 1	أَنَّ الْكَسْرَ
u'أَنَّ كُسُوفٌ':Predicate, #2: 2	أَنَّ كَسْرَ
u'أَنَّ كُسُوفٌ':Predicate, #1: 1	أَنَّ الْكُسُوفَ
u'أَنَّ كَسِيرٌ':Predicate, #1: 1	أَنَّ كُسُوفَ
u'أَنَّ كَسِيرٌ':Predicate, #1: 1	أَنَّ الْكَسِيرَ
u'أَنَّ كَشْفٌ':Predicate, #1: 1	أَنَّ الْكَسِيرَةَ
u'أَنَّ كَشْفٌ':Predicate, #1: 1	أَنَّ الْكَشْفَ
u'آنَ كَشْفٌ':Subject, #4: 4	أَنَّ كَشْفَ
u'أَنَّ كَعْبٌ':Predicate, #1: 1	آنَ كَشْفُ
u'أَنَّ كَعْبٌ':Predicate, #11: 11	أَنَّ كَعْبَ
u'أَنَّ كعبة':Predicate, #2: 2	أَنَّ الْكَعْبَ
u'أَنَّ كَعْبَةٌ':Predicate, #1: 1	أَنَّ الْكَعْبَةَ
u'أَنَّ كَفٌّ':Predicate, #1: 1	أَنَّ الْكَعْبَةَ
u'أَنَّ كَفٌّ':Predicate, #1: 1	أَنَّ كَفَّ
u'أَنَّ كَفَاءةٌ':Predicate, #7: 7	أَنَّ الْكَفَّ
u'أَنَّ كَفَّارٌ':Predicate, #11: 11	أَنَّ الْكَفَاءَةَ
u'أَنَّ كُفَّارٌ':Predicate, #1: 1	أَنَّ الْكَفَّارَ
u'أَنَّ كَفَّارٌ':Predicate, #40: 40	أَنَّ الْكُفَّارَ
u'أَنَّ كُفَّارٌ':Predicate, #50: 50	أَنَّ الْكَفَّارَةَ
u'أَنَّ كَفَّارٌ':Predicate, #5: 5	أَنَّ كُفَّارَ
u'أَنَّ كَفَّارَةٌ':Predicate, #8: 8	أَنَّ كَفَّارَةَ
u'أَنَّ كَفَّارَةٌ':Predicate, #50: 50	أَنَّ الْكَفَّارَةَ
u'أَنَّ كَفَالَةٌ':Predicate, #8: 8	أَنَّ كَفَّارَةَ
u'أَنَّ كِفَايَةٌ':Predicate, #48: 48	أَنَّ الْكَفَالَةَ
u'أَنَّ كِفَايَةٌ':Predicate, #1: 1	أَنَّ كِفَايَةَ
u'أَنَّ كفر':Predicate, #3: 3	أَنَّ الْكِفَايَةَ
u'أَنَّ كُفْرٌ':Predicate, #23: 23	أَنَّ الْكُفْرَ
u'أَنَّ كفر':Predicate, #23: 23	أَنَّ الْكُفْرَ
u'أَنَّ كُفْرٌ':Predicate, #3: 3	أَنَّ كُفْرَ
u'أَنَّ كَفَرَةٌ':Predicate, #3: 3	أَنَّ كُفْرَ
u'أَنَّ كَفَنٌ':Predicate, #2: 2	أَنَّ الْكَفَرَةَ
u'أَنَّ كَفَنٌ':Predicate, #2: 2	أَنَّ كَفَنَ
u'أَنَّ كَفِيلٌ':Predicate, #3: 3	أَنَّ الْكَفَنَ
u'أَنَّ كَلَأٌ':Predicate, #33: 33	أَنَّ الْكَفِيلَ
u'أَنَّ كلاب':Predicate, #1: 1	أَنَّ الْكَلَأَ
u'أَنَّ كلاب':Predicate, #1: 1	أَنَّ الْكِلَابَ
u'أَنَّ كِلاَبٌ':Predicate, #1: 1	أَنَّ الْكِلاَبَ
u'أَنَّ كِلاَبٌ':Predicate, #1: 1	أَنَّ الْكِلَابَ
u'أَنَّ كلاب':Predicate, #1: 1	أَنَّ الْكِلاَبَ
u'أَنَّ كِلاَبٌ':Predicate, #1: 1	أَنَّ كِلابَ
u'أَنَّ كَلالَةٌ':Predicate, #1: 1	أَنَّ كِلابَ
u'أَنَّ كَلاَلِيبُ':Predicate, #7: 7	أَنَّ الْكَلَالَةَ
u'أَنَّ كَلاَمٌ':Predicate, #1: 1	أَنَّ كَلَالِيبَ
u'أَنَّ كَلاَمٌ':Predicate, #175: 175	أَنَّ الْكَلَامَ
u'أَنَّ كَلاَمٌ':Predicate, #183: 183	أَنَّ كَلَامَ
u'أَنَّ كَلاَمٌ':Predicate, #1: 1	أَنَّ الْكَلاَمَ
u'أَنَّ كَلْبٌ':Predicate, #2: 2	أَنَّ كَلَامَكَ
u'أَنَّ كَلْبٌ':Predicate, #18: 18	أَنَّ الْكَلْبَ
u'أَنَّ كَلِمَةٌ':Predicate, #1: 1	أَنَّ كَلْبَ
u'أَنَّ كَلِمَةٌ':Predicate, #39: 39	أَنَّ كَلِمَةَ
u'أَنَّ كُلِّيٌّ':Predicate, #6: 6	أَنَّ الْكَلِمَةَ
u'أَنَّ كُلِّيٌّ':Predicate, #2: 2	أَنَّ الْكُلِّيَّةَ
u'أَنَّ كُلِّيَّةٌ':Predicate, #3: 3	أَنَّ الْكُلِّيَّ
u'أَنَّ كُمٌّ':Predicate, #2: 2	أَنَّ الْكُلِّيَّةَ
u'أَنَّ كَمْأَةٌ':Predicate, #1: 1	أَنَّ الْكُمَّ
u'أَنَّ كَمَالٌ':Predicate, #1: 1	أَنَّ الْكَمْأَةَ
u'أَنَّ كَمَالٌ':Predicate, #16: 16	أَنَّ كَمَالَ
u'أَنَّ كِمَامٌ':Predicate, #5: 5	أَنَّ الْكَمَالَ
u'أَنَّ كَمْدٌ':Predicate, #1: 1	أَنَّ الْكِمَامَ
u'أَنَّ كِنَانَةٌ':Predicate, #1: 1	أَنَّ الْكَمْدَ
u'أَنَّ كِنَايَةٌ':Predicate, #1: 1	أَنَّ كِنَانَةَ
u'أَنَّ كَنْزٌ':Predicate, #9: 9	أَنَّ الْكِنَايَةَ
u'أَنَّ كُنْيَةٌ':Predicate, #4: 4	أَنَّ الْكَنْزَ
u'أَنَّ كَهْلٌ':Predicate, #1: 1	أَنَّ الْكُنْيَةَ
u'أَنَّ كوافر':Predicate, #1: 1	أَنَّ الْكَهْلَ
u'أَنَّ كَوَافِرُ':Predicate, #1: 1	أَنَّ الْكَوَافِرَ
u'أَنَّ كَوَاكِبُ':Predicate, #1: 1	أَنَّ الْكَوَافِرَ
u'أَنَّ كوامل':Predicate, #5: 5	أَنَّ الْكَوَاكِبَ
u'أَنَّ كُوبَة':Predicate, #1: 1	أَنَّ الْكَوَامِلَ
u'أَنَّ كُوَّةٌ':Predicate, #2: 2	أَنَّ الْكُوبَةَ
u'أَنَّ كَوْثَرٌ':Predicate, #1: 1	أَنَّ الْكُوَّةَ
u'أَنَّ كُوزٌ':Predicate, #1: 1	أَنَّ الْكَوْثَرَ
u'أَنَّ كَوْنٌ':Predicate, #3: 3	أَنَّ الْكُوزَ
u'أَنَّ كَوْنٌ':Predicate, #2: 2	أَنَّ الْكَوْنَ
u'أَنَّ كِيسٌ':Predicate, #62: 62	أَنَّ كَوْنَ
u'أَنَّ كَيْفِيَّةٌ':Predicate, #2: 2	أَنَّ الْكِيسَ
u'أَنَّ كَيْفِيَّةٌ':Predicate, #1: 1	أَنَّ الْكَيْفِيَّةَ
u'أَنَّ كَيْلٌ':Predicate, #4: 4	أَنَّ كَيْفِيَّةَ
u'أَنَّ كَيْلٌ':Predicate, #2: 2	أَنَّ كَيْلَ
u'أَنَّ لاَحِقٌ':Predicate, #3: 3	أَنَّ الْكَيْلَ
u'أَنَّ لاَزِمٌ':Predicate, #10: 10	أَنَّ اللَّاحِقَ
u'أَنَّ لاَزِمٌ':Predicate, #14: 14	أَنَّ اللَّازِمَ
u'أَنَّ لاَعِبٌ':Predicate, #7: 7	أَنَّ لَازِمَ
u'أَنَّ لاَعِبٌ':Predicate, #1: 1	أَنَّ اللَّاعِبَ
u'أَنَّ لاَمٌ':Predicate, #1: 1	أَنَّ لَاعِبَ
u'أَنَّ لاَمٌ':Predicate, #20: 20	أَنَّ اللَّامَ
u'أَنَّ لاَئِقٌ':Predicate, #5: 5	أَنَّ لَامَ
u'أَنَّ لِبَاسٌ':Predicate, #4: 4	أَنَّ اللَّائِقَ
u'أَنَّ لِبَاسٌ':Predicate, #1: 1	أَنَّ اللِّبَاسَ
u'أَنَّ لَبَدٌ':Predicate, #4: 4	أَنَّ لِبَاسَ
u'أَنَّ لبس':Predicate, #1: 1	أَنَّ اللَّبَدَ
u'أَنَّ لُبْسٌ':Predicate, #10: 10	أَنَّ لُبْسَ
u'أَنَّ لبس':Predicate, #10: 10	أَنَّ لُبْسَ
u'أَنَّ لَبْسٌ':Predicate, #1: 1	أَنَّ اللَّبْسَ
u'أَنَّ لبس':Predicate, #1: 1	أَنَّ اللَّبْسَ
u'أَنَّ لُبْسٌ':Predicate, #6: 6	أَنَّ اللُّبْسَ
u'أَنَّ لبن':Predicate, #6: 6	أَنَّ اللُّبْسَ
u'أَنَّ لَبَنٌ':Predicate, #10: 10	أَنَّ لَبَنَ
u'أَنَّ لبن':Predicate, #10: 10	أَنَّ لَبَنَ
u'أَنَّ لَبَنٌ':Predicate, #20: 20	أَنَّ اللَّبَنَ
u'أَنَّ لبن':Predicate, #20: 20	أَنَّ اللَّبَنَ
u'أَنَّ لَبِنٌ':Predicate, #2: 2	أَنَّ اللَّبِنَ
u'أَنَّ لَجْلاَجٌ':Predicate, #2: 2	أَنَّ اللَّبِنَ
u'أَنَّ لَحْدٌ':Predicate, #1: 1	أَنَّ اللَّجْلاَجَ
u'أَنَّ لَحْمٌ':Predicate, #1: 1	أَنَّ اللَّحْدَ
u'أَنَّ لَحْمٌ':Predicate, #20: 20	أَنَّ اللَّحْمَ
u'أَنَّ لحمة':Predicate, #6: 6	أَنَّ لَحْمَ
u'أَنَّ لُحْمَةٌ':Predicate, #2: 2	أَنَّ اللُّحْمَةَ
u'أَنَّ لَحْنٌ':Predicate, #2: 2	أَنَّ اللُّحْمَةَ
u'أَنَّ لُحُومٌ':Predicate, #2: 2	أَنَّ اللَّحْنَ
u'أَنَّ لَحْيٌ':Predicate, #1: 1	أَنَّ لُحُومَ
u'أَنَّ لِحْيَةٌ':Predicate, #1: 1	أَنَّ اللَّحْيَ
u'أَنَّ لَذَّةٌ':Predicate, #3: 3	أَنَّ اللِّحْيَةَ
u'أَنَّ لَذَّةٌ':Predicate, #1: 1	أَنَّ اللَّذَّةَ
u'أَنَّ لُزُومٌ':Predicate, #2: 2	أَنَّ لَذَّةَ
u'أَنَّ لُزُومٌ':Predicate, #15: 15	أَنَّ لُزُومَ
u'أَنَّ لِسَانٌ':Predicate, #5: 5	أَنَّ اللُّزُومَ
u'أَنَّ لِسَانٌ':Predicate, #1: 1	أَنَّ اللِّسَانَ
u'أَنَّ لِسَانِيُّ':Predicate, #1: 1	أَنَّ لِسَانَ
u'أَنَّ لَسْعٌ':Predicate, #1: 1	أَنَّ اللِّسَانِيَّ
u'أَنَّ لِصٌّ':Predicate, #1: 1	أَنَّ لَسْعَ
u'أَنَّ لَطْمَةٌ':Predicate, #1: 1	أَنَّ اللِّصَّ
u'أَنَّ لعاب':Predicate, #1: 1	أَنَّ اللَّطْمَةَ
u'أَنَّ لُعَابٌ':Predicate, #3: 3	أَنَّ اللُّعَابَ
u'أَنَّ لعان':Predicate, #3: 3	أَنَّ اللُّعَابَ
u'أَنَّ لعب':Predicate, #18: 18	أَنَّ اللِّعَانَ
u'أَنَّ لَعِبٌ':Predicate, #5: 5	أَنَّ اللَّعِبَ
u'أَنَّ لَعْن':Predicate, #5: 5	أَنَّ اللَّعِبَ
u'أَنَّ لعنة':Predicate, #3: 3	أَنَّ اللَّعْنَ
u'أَنَّ لَعْنَةٌ':Predicate, #1: 1	أَنَّ اللَّعْنَةَ
u'أَنَّ لعنة':Predicate, #1: 1	أَنَّ اللَّعْنَةَ
u'أَنَّ لَعْنَةٌ':Predicate, #9: 9	أَنَّ لَعْنَةَ
u'أَنَّ لُغَةٌ':Predicate, #9: 9	أَنَّ لَعْنَةَ
u'أَنَّ لُغَةٌ':Predicate, #13: 13	أَنَّ اللُّغَةَ
u'أَنَّ لَغْوٌ':Predicate, #1: 1	أَنَّ لُغَةَ
u'أَنَّ لَغْوٌ':Predicate, #2: 2	أَنَّ لَغْوَ
u'أَنَّ لُغَوِيٌّ':Predicate, #5: 5	أَنَّ اللَّغْوَ
u'أَنَّ لُغَوِيٌّ':Predicate, #1: 1	أَنَّ اللُّغَوِيَّ
u'أَنَّ لُغَوِيٌّ':Predicate, #1: 1	أَنَّ اللُّغَوِيَّةَ
u'أَنَّ لِفَافَةٌ':Predicate, #1: 1	أَنَّ اللُّغَوِيِّينَ
u'أَنَّ لَفْظٌ':Predicate, #1: 1	أَنَّ اللِّفَافَةَ
u'أَنَّ لَفْظٌ':Predicate, #103: 103	أَنَّ اللَّفْظَ
u'أَنَّ لَفْظَةٌ':Predicate, #111: 111	أَنَّ لَفْظَ
u'أَنَّ لَفْظَةٌ':Predicate, #27: 27	أَنَّ لَفْظَةَ
u'أَنَّ لَفْظِيٌّ':Predicate, #4: 4	أَنَّ اللَّفْظَةَ
u'أَنَّ لَقَبٌ':Predicate, #1: 1	أَنَّ اللَّفْظِيَّ
u'أَنَّ لقطة':Predicate, #1: 1	أَنَّ اللَّقَبَ
u'أَنَّ لقطة':Predicate, #3: 3	أَنَّ لُقَطَةَ
u'أَنَّ لَقِيطٌ':Predicate, #5: 5	أَنَّ اللُّقَطَةَ
u'أَنَّ لَمْسٌ':Predicate, #5: 5	أَنَّ اللَّقِيطَ
u'أَنَّ لَمْسٌ':Predicate, #1: 1	أَنَّ لَمْسَ
u'أَنَّ لِواط':Predicate, #8: 8	أَنَّ اللَّمْسَ
u'أَنَّ لِواط':Subject, #3: 3	أَنَّ اللِّوَاطَ
u'أَنَّ لِواطَة':Subject, #1: 1	أَنَّ اللِّوَاطَةُ
u'أَنَّ لَوْحٌ':Predicate, #1: 1	أَنَّ اللِّوَاطَةُ
u'أَنَّ لَوْزٌ':Predicate, #3: 3	أَنَّ اللَّوْحَ
u'أَنَّ لُؤْلُؤٌ':Predicate, #1: 1	أَنَّ اللَّوْزَ
u'أَنَّ لُؤْلُؤَةٌ':Predicate, #1: 1	أَنَّ اللُّؤْلُؤَ
u'أَنَّ لَوْنٌ':Predicate, #1: 1	أَنَّ لُؤْلُؤَةَ
u'أَنَّ لَيَالِي':Predicate, #1: 1	أَنَّ لَوْنَ
u'أَنَّ لَيْثٌ':Predicate, #1: 1	أَنَّ اللَّيَالِيَ
u'أَنَّ لَيْثٌ':Predicate, #3: 3	أَنَّ لَيْثَ
u'أَنَّ لَيْلٌ':Predicate, #7: 7	أَنَّ اللَّيْثَ
u'أَنَّ لَيْلٌ':Predicate, #19: 19	أَنَّ اللَّيْلَ
u'أَنَّ لَيْلٌ':Predicate, #5: 5	أَنَّ اللَّيْلَةَ
u'أَنَّ لِينٌ':Predicate, #5: 5	أَنَّ لَيْلَةَ
u'أَنَّ مَاءٌ':Predicate, #1: 1	أَنَّ لِينَ
u'أَنَّ مَاءٌ':Predicate, #187: 187	أَنَّ الْمَاءَ
u'أَنَّ مَادَّةٌ':Predicate, #31: 31	أَنَّ مَاءَ
u'أَنَّ مَارٌّ':Predicate, #1: 1	أَنَّ الْمَادَّةَ
u'أَنَّ مَاسِحٌ':Predicate, #9: 9	أَنَّ الْمَارَّ
u'أَنَّ مَاسِحٌ':Predicate, #1: 1	أَنَّ مَاسِحَ
u'أَنَّ مَاشِطٌ':Predicate, #2: 2	أَنَّ الْمَاسِحَ
u'أَنَّ مَاشِي':Predicate, #2: 2	أَنَّ مَاشِطَةً
u'أَنَّ مَاشِي':Predicate, #1: 1	أَنَّ الْمَاشِيَ
u'أَنَّ مَاشِي':Predicate, #1: 1	أَنَّ مَاشِيَةَ
u'أَنَّ مَاشِيَةٌ':Predicate, #3: 3	أَنَّ الْمَاشِيَةَ
u'أَنَّ مَاشِيَةٌ':Predicate, #1: 1	أَنَّ مَاشِيَةَ
u'أَنَّ مَاضِي':Predicate, #3: 3	أَنَّ الْمَاشِيَةَ
u'أَنَّ مَاعِزٌ':Predicate, #2: 2	أَنَّ الْمَاضِيَ
u'أَنَّ مَاعُونٌ':Predicate, #1: 1	أَنَّ مَاعِزَ
u'أَنَّ مَأْكُولٌ':Predicate, #1: 1	أَنَّ الْمَاعُونَ
u'أَنَّ مَالٌ':Predicate, #2: 2	أَنَّ الْمَأْكُولَ
u'أَنَّ مَآلٌ':Predicate, #137: 137	أَنَّ الْمَالَ
u'أَنَّ مَالٌ':Predicate, #2: 2	أَنَّ مَآلَ
u'أَنَّ مَالِكٌ':Predicate, #43: 43	أَنَّ مَالَ
u'أَنَّ مالِك':Predicate, #17: 17	أَنَّ مَالِكَ
u'أَنَّ مالِك':Predicate, #1: 1	أَنَّ الْمَالِكِيَّةَ
u'أَنَّ مَالِكٌ':Predicate, #1: 1	أَنَّ مَالِكِيَّةَ
u'أَنَّ مالِكِيّ':Predicate, #54: 54	أَنَّ الْمَالِكَ
u'أَنَّ مالِكِيّ':Predicate, #1: 1	أَنَّ الْمَالِكِيَّةَ
u'أَنَّ مَالِيٌّ':Predicate, #1: 1	أَنَّ مَالِكِيَّةَ
u'أَنَّ مَالِيٌّ':Predicate, #3: 3	أَنَّ الْمَالِيَّةَ
u'أَنَّ مَأْمُورٌ':Predicate, #3: 3	أَنَّ مَالِيَّةَ
u'أَنَّ مَأْمُورٌ':Predicate, #1: 1	أَنَّ الْمَأْمُورِينَ
u'أَنَّ مَأْمُونٌ':Predicate, #40: 40	أَنَّ الْمَأْمُورَ
u'أَنَّ مَأْمُونٌ':Predicate, #1: 1	أَنَّ الْمَأْمُونَةَ
u'أَنَّ مَانِعٌ':Predicate, #3: 3	أَنَّ الْمَأْمُونَ
u'أَنَّ مَانِعٌ':Predicate, #1: 1	أَنَّ الْمَانِعِينَ
u'أَنَّ مَائِعٌ':Predicate, #42: 42	أَنَّ الْمَانِعَ
u'أَنَّ مَائِعٌ':Predicate, #1: 1	أَنَّ الْمَائِعَةَ
u'أَنَّ مَائِيُّ':Predicate, #5: 5	أَنَّ الْمَائِعَ
u'أَنَّ مَائِيُّ':Predicate, #1: 1	أَنَّ الْمَائِيَّ
u'أَنَّ مُبَاحٌ':Predicate, #1: 1	أَنَّ مَائِيَّ
u'أَنَّ مَبَاحِثُ':Predicate, #13: 13	أَنَّ الْمُبَاحَ
u'أَنَّ مُبَادِرٌ':Predicate, #3: 3	أَنَّ مَبَاحِثَ
u'أَنَّ مُبَادَرَةٌ':Predicate, #1: 1	أَنَّ الْمُبَادِرَ
u'أَنَّ مُبَادَلَةٌ':Predicate, #7: 7	أَنَّ الْمُبَادَرَةَ
u'أَنَّ مُبَادَلَةٌ':Predicate, #2: 2	أَنَّ الْمُبَادَلَةَ
u'أَنَّ مَبَادِئُ':Predicate, #2: 2	أَنَّ مُبَادَلَةَ
u'أَنَّ مُبَارَاةٌ':Predicate, #1: 1	أَنَّ الْمَبَادِئَ
u'أَنَّ مُبَاشِرٌ':Predicate, #1: 1	أَنَّ الْمُبَارَاةَ
u'أَنَّ مُبَاشَرَةٌ':Predicate, #4: 4	أَنَّ الْمُبَاشِرَ
u'أَنَّ مُبَاشَرَةٌ':Predicate, #2: 2	أَنَّ مُبَاشَرَةَ
u'أَنَّ مُبَالَغَةٌ':Predicate, #3: 3	أَنَّ الْمُبَاشَرَةَ
u'أَنَّ مُبَايَعَةٌ':Predicate, #4: 4	أَنَّ الْمُبَالَغَةَ
u'أَنَّ مُبْتاع':Predicate, #1: 1	أَنَّ الْمُبَايَعَةَ
u'أَنَّ مُبْتَدَأٌ':Predicate, #5: 5	أَنَّ الْمُبْتَاعَ
u'أَنَّ مُبْتَدِعٌ':Predicate, #3: 3	أَنَّ الْمُبْتَدَأَ
u'أَنَّ مُبْتَدِئٌ':Predicate, #10: 10	أَنَّ الْمُبْتَدِعَ
u'أَنَّ مَبْتُوت':Predicate, #2: 2	أَنَّ الْمُبْتَدِئَ
u'أَنَّ مَبْدَأٌ':Predicate, #1: 1	أَنَّ الْمَبْتُوتَةَ
u'أَنَّ مَبْذُول':Predicate, #1: 1	أَنَّ مَبْدَأَ
u'أَنَّ مُبَرِّدٌ':Predicate, #1: 1	أَنَّ الْمَبْذُولَ
u'أَنَّ مُبْطِلٌ':Predicate, #1: 1	أَنَّ الْمُبَرِّدَ
u'أَنَّ مَبْلَغٌ':Predicate, #5: 5	أَنَّ الْمُبْطِلَ
u'أَنَّ مَبْلَغٌ':Predicate, #1: 1	أَنَّ الْمَبْلَغَ
u'أَنَّ مَبْنِيٌّ':Predicate, #1: 1	أَنَّ مَبْلَغَ
u'أَنَّ مُبْهَمٌ':Predicate, #1: 1	أَنَّ الْمَبْنِيَّ
u'أَنَّ مَبِيتٌ':Predicate, #1: 1	أَنَّ الْمُبْهَمَ
u'أَنَّ مُبِيحٌ':Predicate, #4: 4	أَنَّ الْمَبِيتَ
u'أَنَّ مَبِيعٌ':Predicate, #2: 2	أَنَّ الْمُبِيحَ
u'أَنَّ مُبَيَّنٌ':Predicate, #76: 76	أَنَّ الْمَبِيعَ
u'أَنَّ مُتَابَعٌ':Predicate, #2: 2	أَنَّ الْمُبَيَّنَ
u'أَنَّ مُتَابَعٌ':Predicate, #1: 1	أَنَّ الْمُتَابَعَةَ
u'أَنَّ مُتَابَعَةٌ':Predicate, #1: 1	أَنَّ مُتَابَعَةَ
u'أَنَّ مُتَابَعَةٌ':Predicate, #1: 1	أَنَّ الْمُتَابَعَةَ
u'أَنَّ مُتَأَخِّرٌ':Predicate, #1: 1	أَنَّ مُتَابَعَةَ
u'أَنَّ مُتَأَخِّرٌ':Predicate, #1: 1	أَنَّ مُتَأَخِّرَ
u'أَنَّ مُتَأَخِّرٌ':Predicate, #2: 2	أَنَّ الْمُتَأَخِّرَةَ
u'أَنَّ مُتَأَخِّرٌ':Predicate, #4: 4	أَنَّ الْمُتَأَخِّرِينَ
u'أَنَّ مُتارَكَة':Predicate, #5: 5	أَنَّ الْمُتَأَخِّرَ
u'أَنَّ مُتارَكَة':Predicate, #1: 1	أَنَّ مُتَارَكَةَ
u'أَنَّ مَتَاعٌ':Predicate, #2: 2	أَنَّ الْمُتَارَكَةَ
u'أَنَّ مُتَبَرِّعٌ':Predicate, #12: 12	أَنَّ الْمَتَاعَ
u'أَنَّ مُتَّجَهٌ':Predicate, #2: 2	أَنَّ الْمُتَبَرِّعَ
u'أَنَّ مُتَّجِهٌ':Predicate, #1: 1	أَنَّ الْمُتَّجَهَ
u'أَنَّ مُتَّحِدٌ':Predicate, #2: 2	أَنَّ الْمُتَّجِهَ
u'أَنَّ مُتَحَصِّل':Predicate, #1: 1	أَنَّ الْمُتَّحِدَ
u'أَنَّ مُتَحَيِّرٌ':Predicate, #1: 1	أَنَّ الْمُتَحَصِّلَ
u'أَنَّ مُتَّخَذ':Predicate, #2: 2	أَنَّ الْمُتَحَيِّرَةَ
u'أَنَّ مُتَخَيَّل':Predicate, #1: 1	أَنَّ الْمُتَّخَذَ
u'أَنَّ مُتَرَادِفٌ':Predicate, #1: 1	أَنَّ الْمُتَخَيَّلَةَ
u'أَنَّ مُتَرَتِّب':Predicate, #1: 1	أَنَّ الْمُتَرَادِفَ
u'أَنَّ مَتْرُوكٌ':Predicate, #1: 1	أَنَّ الْمُتَرَتِّبَ
u'أَنَّ مَتْرُوكٌ':Predicate, #2: 2	أَنَّ الْمَتْرُوكَةَ
u'أَنَّ مَتْرُوكٌ':Predicate, #2: 2	أَنَّ مَتْرُوكَ
u'أَنَّ مُتَزَوِّجٌ':Predicate, #9: 9	أَنَّ الْمَتْرُوكَ
u'أَنَّ مُتَزَوِّجٌ':Predicate, #1: 1	أَنَّ الْمُتَزَوِّجَ
u'أَنَّ مُتَسَبِّبٌ':Predicate, #1: 1	أَنَّ الْمُتَزَوِّجَةَ
u'أَنَّ مُتَشَابِهٌ':Predicate, #1: 1	أَنَّ الْمُتَسَبِّبَ
u'أَنَّ مُتَصَدِّق':Predicate, #3: 3	أَنَّ الْمُتَشَابِهَ
u'أَنَّ مُتَصَرِّفٌ':Predicate, #2: 2	أَنَّ الْمُتَصَدِّقَ
u'أَنَّ مُتَّصِف':Predicate, #2: 2	أَنَّ الْمُتَصَرِّفَ
u'أَنَّ مُتَّصِف':Predicate, #1: 1	أَنَّ الْمُتَّصِفَ
u'أَنَّ مُتَّصِلٌ':Predicate, #1: 1	أَنَّ الْمُتَّصِفِينَ
u'أَنَّ مُتَّصِلٌ':Predicate, #1: 1	أَنَّ الْمُتَّصِلَةَ
u'أَنَّ مُتَعَارَفٌ':Predicate, #2: 2	أَنَّ الْمُتَّصِلَ
u'أَنَّ مُتَعاطِي':Predicate, #3: 3	أَنَّ الْمُتَعَارَفَ
u'أَنَّ مُتَعاهِد':Predicate, #1: 1	أَنَّ الْمُتَعَاطِيَ
u'أَنَّ مُتْعَةٌ':Predicate, #1: 1	أَنَّ الْمُتَعَاهِدَ
u'أَنَّ مُتَعَجِّل':Predicate, #20: 20	أَنَّ الْمُتْعَةَ
u'أَنَّ مُتَعَقِّلٌ':Predicate, #1: 1	أَنَّ الْمُتَعَجِّلَ
u'أَنَّ مُتَعَلِّقٌ':Predicate, #1: 1	أَنَّ مُتَعَقِّلَ
u'أَنَّ مُتَعَلِّقٌ':Predicate, #1: 1	أَنَّ الْمُتَعَلِّقِينَ
u'أَنَّ مُتَعَلِّقٌ':Predicate, #5: 5	أَنَّ الْمُتَعَلِّقَ
u'أَنَّ مُتَعَلِّمٌ':Predicate, #5: 5	أَنَّ مُتَعَلِّقَ
u'أَنَّ مُتَعَلِّمٌ':Predicate, #1: 1	أَنَّ الْمُتَعَلِّمِينَ
u'أَنَّ مُتَعَمِّدٌ':Predicate, #2: 2	أَنَّ الْمُتَعَلِّمَ
u'أَنَّ مُتَعَمِّدٌ':Predicate, #2: 2	أَنَّ الْمُتَعَمِّدَ
u'أَنَّ مُتَعَنِّتٌ':Predicate, #2: 2	أَنَّ مُتَعَمِّدَ
u'أَنَّ مُتَغَلِّب':Predicate, #1: 1	أَنَّ الْمُتَعَنِّتَ
u'أَنَّ مُتَغَيِّرٌ':Predicate, #1: 1	أَنَّ الْمُتَغَلِّبَ
u'أَنَّ مُتَفَرِّعٌ':Predicate, #3: 3	أَنَّ الْمُتَغَيِّرَ
u'أَنَّ مُتَفَرِّقٌ':Predicate, #1: 1	أَنَّ الْمُتَفَرِّعَ
u'أَنَّ مُتَفَرِّقٌ':Predicate, #1: 1	أَنَّ الْمُتَفَرِّقَ
u'أَنَّ مُتَقَارِبٌ':Predicate, #1: 1	أَنَّ الْمُتَفَرِّقَةَ
u'أَنَّ مُتَقاضِي':Predicate, #2: 2	أَنَّ الْمُتَقَارِبَ
u'أَنَّ مُتَقَدِّمٌ':Predicate, #1: 1	أَنَّ الْمُتَقَاضِيَ
u'أَنَّ مُتَقَدِّمٌ':Predicate, #1: 1	أَنَّ الْمُتَقَدِّمِينَ
u'أَنَّ مُتَكَرِّرٌ':Predicate, #7: 7	أَنَّ الْمُتَقَدِّمَ
u'أَنَّ مُتَكَلِّمٌ':Predicate, #1: 1	أَنَّ الْمُتَكَرِّرَ
u'أَنَّ مُتَكَلِّمٌ':Predicate, #1: 1	أَنَّ الْمُتَكَلِّمِينَ
u'أَنَّ مُتَلاَحِمٌ':Predicate, #22: 22	أَنَّ الْمُتَكَلِّمَ
u'أَنَّ مُتْلِفٌ':Predicate, #2: 2	أَنَّ الْمُتَلَاحِمَةَ
u'أَنَّ مُتْلِفٌ':Predicate, #1: 1	أَنَّ مُتْلِفَ
u'أَنَّ مُتَمَتِّعٌ':Predicate, #4: 4	أَنَّ الْمُتْلِفَ
u'أَنَّ مُتَمَسِّك':Predicate, #13: 13	أَنَّ الْمُتَمَتِّعَ
u'أَنَّ مَتْنٌ':Predicate, #1: 1	أَنَّ الْمُتَمَسِّكِينَ
u'أَنَّ مُتَنازَع':Predicate, #1: 1	أَنَّ الْمَتْنَ
u'أَنَّ مُتَنَاقِضٌ':Predicate, #1: 1	أَنَّ الْمُتَنَازَعَ
u'أَنَّ مُتَوَاتِرٌ':Predicate, #5: 5	أَنَّ الْمُتَنَاقِضَ
u'أَنَّ مُتَوَاطِئٌ':Predicate, #1: 1	أَنَّ الْمُتَوَاتِرَ
u'أَنَّ مُتَوَسِّطٌ':Predicate, #1: 1	أَنَّ الْمُتَوَاطِئَ
u'أَنَّ مُتَوَقِّف':Predicate, #2: 2	أَنَّ الْمُتَوَسِّطَ
u'أَنَّ مُتَوَكِّلٌ':Predicate, #2: 2	أَنَّ الْمُتَوَقِّفَ
u'أَنَّ مُتَوَلِّدٌ':Predicate, #1: 1	أَنَّ الْمُتَوَكِّلَ
u'أَنَّ مُتَوَلِّدٌ':Predicate, #1: 1	أَنَّ الْمُتَوَلِّدَةَ
u'أَنَّ مُتَوَلِّي':Predicate, #3: 3	أَنَّ الْمُتَوَلِّدَ
u'أَنَّ مُتَوَلِّي':Predicate, #17: 17	أَنَّ الْمُتَوَلِّيَ
u'أَنَّ مُتُونٌ':Predicate, #1: 1	أَنَّ مُتَوَلِّيَ
u'أَنَّ مُتَيَسِّرٌ':Predicate, #2: 2	أَنَّ الْمُتُونَ
u'أَنَّ مُتَيَقِّن':Predicate, #1: 1	أَنَّ الْمُتَيَسِّرَ
u'أَنَّ مَثار':Predicate, #1: 1	أَنَّ الْمُتَيَقِّنَ
u'أَنَّ مِثَالٌ':Predicate, #1: 1	أَنَّ مَثَارَ
u'أَنَّ مِثَالٌ':Predicate, #1: 1	أَنَّ مِثَالَ
u'أَنَّ مَثَانَةٌ':Predicate, #2: 2	أَنَّ الْمِثَالَ
u'أَنَّ مُثْبَتٌ':Predicate, #1: 1	أَنَّ الْمَثَانَةَ
u'أَنَّ مثل':Predicate, #1: 1	أَنَّ الْمُثْبَتَ
u'أَنَّ مِثْلٌ':Predicate, #10: 10	أَنَّ الْمِثْلَ
u'أَنَّ مثل':Predicate, #10: 10	أَنَّ الْمِثْلَ
u'أَنَّ مِثْلٌ':Predicate, #68: 68	أَنَّ مِثْلَ
u'أَنَّ مِثْلِيٌّ':Predicate, #68: 68	أَنَّ مِثْلَ
u'أَنَّ مِثْلِيٌّ':Predicate, #1: 1	أَنَّ الْمِثْلِيَّةَ
u'أَنَّ مَثْمُون':Predicate, #6: 6	أَنَّ الْمِثْلِيَّ
u'أَنَّ مَجَازٌ':Predicate, #1: 1	أَنَّ الْمَثْمُونَ
u'أَنَّ مَجَازٌ':Predicate, #1: 1	أَنَّ مَجَازَ
u'أَنَّ مُجَازَفَةٌ':Predicate, #43: 43	أَنَّ الْمَجَازَ
u'أَنَّ مَجَازِيٌّ':Predicate, #1: 1	أَنَّ الْمُجَازَفَةَ
u'أَنَّ مَجَالِسُ':Predicate, #1: 1	أَنَّ مَجَازِيَّ
u'أَنَّ مُجَالَسَةٌ':Predicate, #1: 1	أَنَّ الْمَجَالِسَ
u'أَنَّ مَجَامِعُ':Predicate, #1: 1	أَنَّ مُجَالَسَةَ
u'أَنَّ مُجَانَبَةٌ':Predicate, #1: 1	أَنَّ الْمَجَامِعَ
u'أَنَّ مُجَانَسَةٌ':Predicate, #1: 1	أَنَّ مُجَانَبَةَ
u'أَنَّ مُجَاهِدٌ':Predicate, #6: 6	أَنَّ الْمُجَانَسَةَ
u'أَنَّ مُجَاوِرٌ':Predicate, #2: 2	أَنَّ الْمُجَاهِدَ
u'أَنَّ مُجَاوِرٌ':Predicate, #1: 1	أَنَّ الْمُجَاوِرَ
u'أَنَّ مُجَاوَرَةٌ':Predicate, #1: 1	أَنَّ الْمُجَاوِرَةَ
u'أَنَّ مُجَاوَزَةٌ':Predicate, #3: 3	أَنَّ الْمُجَاوَرَةَ
u'أَنَّ مُجْتَهِد':Predicate, #3: 3	أَنَّ الْمُجَاوَزَةَ
u'أَنَّ مُجْتَهِد':Predicate, #32: 32	أَنَّ الْمُجْتَهِدَ
u'أَنَّ مَجْدٌ':Predicate, #3: 3	أَنَّ الْمُجْتَهِدِينَ
u'أَنَّ مُجَدِّدٌ':Predicate, #5: 5	أَنَّ الْمَجْدَ
u'أَنَّ مَجْذُومٌ':Predicate, #1: 1	أَنَّ الْمُجَدِّدَ
u'أَنَّ مُجَرَّدٌ':Predicate, #1: 1	أَنَّ الْمَجْذُومَ
u'أَنَّ مَجْرُوحٌ':Predicate, #79: 79	أَنَّ مُجَرَّدَ
u'أَنَّ مَجْلِسٌ':Predicate, #1: 1	أَنَّ الْمَجْرُوحَ
u'أَنَّ مَجْلِسٌ':Predicate, #1: 1	أَنَّ مَجْلِسَ
u'أَنَّ مُجْمِعٌ':Predicate, #6: 6	أَنَّ الْمَجْلِسَ
u'أَنَّ مُجْمَلٌ':Predicate, #1: 1	أَنَّ مُجْمِعَ
u'أَنَّ مَجْمُوعٌ':Predicate, #2: 2	أَنَّ الْمُجْمَلَ
u'أَنَّ مَجْمُوعٌ':Predicate, #8: 8	أَنَّ الْمَجْمُوعَ
u'أَنَّ مَجْنُونٌ':Predicate, #9: 9	أَنَّ مَجْمُوعَ
u'أَنَّ مَجْنُونٌ':Predicate, #14: 14	أَنَّ الْمَجْنُونَ
u'أَنَّ مَجْنِيٌّ':Predicate, #2: 2	أَنَّ الْمَجْنُونَةَ
u'أَنَّ مَجْهَلَةٌ':Predicate, #3: 3	أَنَّ الْمَجْنِيَّ
u'أَنَّ مَجْهُولٌ':Predicate, #1: 1	أَنَّ مَجْهَلَةَ
u'أَنَّ مَجْهُولٌ':Predicate, #1: 1	أَنَّ الْمَجْهُولِينَ
u'أَنَّ مَجْهُولٌ':Predicate, #3: 3	أَنَّ الْمَجْهُولَ
u'أَنَّ مَجُوسٌ':Predicate, #3: 3	أَنَّ الْمَجْهُولَةَ
u'أَنَّ مَجُوسِيٌّ':Predicate, #5: 5	أَنَّ الْمَجُوسَ
u'أَنَّ مَجُوسِيَّةٌ':Predicate, #4: 4	أَنَّ الْمَجُوسِيَّ
u'أَنَّ مَجِيءٌ':Predicate, #2: 2	أَنَّ الْمَجُوسِيَّةَ
u'أَنَّ مَجِيءٌ':Predicate, #1: 1	أَنَّ الْمَجِيءَ
u'أَنَّ مُجِيزٌ':Predicate, #4: 4	أَنَّ مَجِيءَ
u'أَنَّ مُحَابَاةٌ':Predicate, #1: 1	أَنَّ الْمُجِيزَ
u'أَنَّ مُحَاجَّةٌ':Predicate, #7: 7	أَنَّ الْمُحَابَاةَ
u'أَنَّ مُحَاذَاةٌ':Predicate, #1: 1	أَنَّ الْمُحَاجَّةَ
u'أَنَّ مُحَاذَاةٌ':Predicate, #2: 2	أَنَّ مُحَاذَاةَ
u'أَنَّ مُحَارِبٌ':Predicate, #8: 8	أَنَّ الْمُحَاذَاةَ
u'أَنَّ مُحَارَبَةٌ':Predicate, #1: 1	أَنَّ الْمُحَارِبَ
u'أَنَّ مَحَارِمُ':Predicate, #1: 1	أَنَّ الْمُحَارَبَةَ
u'أَنَّ مُحَاسَبَةٌ':Predicate, #3: 3	أَنَّ الْمَحَارِمَ
u'أَنَّ مُحَاشَاةٌ':Predicate, #1: 1	أَنَّ مُحَاسَبَةَ
u'أَنَّ مُحَافَظَةٌ':Predicate, #2: 2	أَنَّ الْمُحَاشَاةَ
u'أَنَّ مُحالَفَة':Predicate, #6: 6	أَنَّ الْمُحَافَظَةَ
u'أَنَّ مَحَبَّةٌ':Predicate, #1: 1	أَنَّ الْمُحَالَفَةَ
u'أَنَّ مَحَبَّةٌ':Predicate, #1: 1	أَنَّ الْمَحَبَّةَ
u'أَنَّ مَحَبَّةٌ':Predicate, #1: 1	أَنَّ مَحَبَّةَ
u'أَنَّ مَحْبُوسٌ':Predicate, #1: 1	أَنَّ مَحَبَّتَكَ
u'أَنَّ مَحْبُوسٌ':Predicate, #1: 1	أَنَّ الْمَحْبُوسَةَ
u'أَنَّ مُحْتَاجٌ':Predicate, #3: 3	أَنَّ الْمَحْبُوسَ
u'أَنَّ مُحْتَاجٌ':Predicate, #1: 1	أَنَّ الْمُحْتَاجِينَ
u'أَنَّ مُحْتَالٌ':Predicate, #4: 4	أَنَّ الْمُحْتَاجَ
u'أَنَّ مُحْتَرِفٌ':Predicate, #19: 19	أَنَّ الْمُحْتَالَ
u'أَنَّ مُحْتَرَمٌ':Predicate, #1: 1	أَنَّ الْمُحْتَرِفَ
u'أَنَّ مُحْتَسِبٌ':Predicate, #2: 2	أَنَّ الْمُحْتَرَمَةَ
u'أَنَّ مُحْتَمَلٌ':Predicate, #2: 2	أَنَّ الْمُحْتَسِبَ
u'أَنَّ مِحْجَن':Predicate, #1: 1	أَنَّ الْمُحْتَمَلَ
u'أَنَّ مَحْجُوبٌ':Predicate, #1: 1	أَنَّ مِحْجَنَ
u'أَنَّ مَحْجُورٌ':Predicate, #1: 1	أَنَّ الْمَحْجُوبَ
u'أَنَّ مَحْجُورٌ':Predicate, #12: 12	أَنَّ الْمَحْجُورَ
u'أَنَّ مُحَدِّثٌ':Predicate, #2: 2	أَنَّ الْمَحْجُورَةَ
u'أَنَّ مُحْدِثٌ':Predicate, #1: 1	أَنَّ الْمُحَدِّثَ
u'أَنَّ مَحْدُودٌ':Predicate, #6: 6	أَنَّ الْمُحْدِثَ
u'أَنَّ مَحْذُور':Predicate, #3: 3	أَنَّ الْمَحْدُودَ
u'أَنَّ مَحْذُوفٌ':Subject, #3: 3	أَنَّ الْمَحْذُورَ
u'أَنَّ مِحْرَابٌ':Predicate, #1: 1	أَنَّ مَحْذُوفٌ
u'أَنَّ مِحْرَابٌ':Predicate, #1: 1	أَنَّ الْمِحْرَابَ
u'أَنَّ مُحَرَّرٌ':Predicate, #2: 2	أَنَّ مِحْرَابَ
u'أَنَّ مَحْرَمٌ':Predicate, #1: 1	أَنَّ الْمُحَرَّرَ
u'أَنَّ مُحَرَّمٌ':Predicate, #14: 14	أَنَّ الْمَحْرَمَ
u'أَنَّ مُحَرَّمٌ':Predicate, #14: 14	أَنَّ الْمُحَرَّمَ
u'أَنَّ مُحْرِمٌ':Predicate, #1: 1	أَنَّ الْمُحَرَّمَةَ
u'أَنَّ مُحْرِمٌ':Predicate, #1: 1	أَنَّ الْمُحْرِمَةَ
u'أَنَّ مُحَرَّمٌ':Predicate, #1: 1	أَنَّ الْمُحْرِمِينَ
u'أَنَّ مُحْرِمٌ':Predicate, #1: 1	أَنَّ مُحَرَّمَ
u'أَنَّ مُحْرِمٌ':Predicate, #1: 1	أَنَّ مُحْرِمَ
u'أَنَّ مَحْرَم':Predicate, #40: 40	أَنَّ الْمُحْرِمَ
u'أَنَّ مَحْرَمَة':Predicate, #7: 7	أَنَّ الْمَحْرَمِيَّةَ
u'أَنَّ مَحْرُومٌ':Predicate, #7: 7	أَنَّ الْمَحْرَمِيَّةَ
u'أَنَّ مُحْسِنٌ':Predicate, #3: 3	أَنَّ الْمَحْرُومَ
u'أَنَّ مُحَصِّل':Predicate, #1: 1	أَنَّ الْمُحْسِنَ
u'أَنَّ مُحَصَّل':Predicate, #1: 1	أَنَّ مُحَصِّلَ
u'أَنَّ مُحْصَنٌ':Predicate, #3: 3	أَنَّ مُحَصَّلَ
u'أَنَّ مَحْصُورٌ':Predicate, #1: 1	أَنَّ الْمُحْصَنَ
u'أَنَّ مَحْضٌ':Predicate, #1: 1	أَنَّ الْمَحْصُورِينَ
u'أَنَّ مَحْضَرٌ':Predicate, #4: 4	أَنَّ مَحْضَ
u'أَنَّ مَحْظُورٌ':Predicate, #1: 1	أَنَّ الْمَحْضَرَ
u'أَنَّ مَحْفُوظٌ':Predicate, #4: 4	أَنَّ الْمَحْظُورَ
u'أَنَّ مُحَقِّقٌ':Predicate, #5: 5	أَنَّ الْمَحْفُوظَ
u'أَنَّ مُحَقِّقٌ':Predicate, #1: 1	أَنَّ الْمُحَقِّقَ
u'أَنَّ مُحْكَمٌ':Predicate, #1: 1	أَنَّ الْمُحَقِّقِينَ
u'أَنَّ مُحَكَّمٌ':Predicate, #1: 1	أَنَّ مُحْكَمَ
u'أَنَّ مُحْكَمٌ':Predicate, #8: 8	أَنَّ الْمُحَكَّمَ
u'أَنَّ مَحْكُومٌ':Predicate, #8: 8	أَنَّ الْمُحْكَمَ
u'أَنَّ مَحَلٌّ':Predicate, #6: 6	أَنَّ الْمَحْكُومَ
u'أَنَّ مَحَلٌّ':Predicate, #19: 19	أَنَّ الْمَحَلَّ
u'أَنَّ مَحَلٌّ':Subject, #279: 279	أَنَّ مَحَلَّ
u'أَنَّ مَحَلَّةٌ':Predicate, #1: 1	أَنَّ مَحَلُّهُ
u'أَنَّ مُحَلِّل':Predicate, #1: 1	أَنَّ الْمَحَلَّةَ
u'أَنَّ مُحَمَّدٌ':Predicate, #2: 2	أَنَّ الْمُحَلِّلَ
u'أَنَّ مُحَمَّدٌ':Subject, #91: 91	أَنَّ مُحَمَّدَ
u'أَنَّ مَحْمِلٌ':Predicate, #2: 2	أَنَّ مُحَمَّدٌ
u'أَنَّ مَحْمَلٌ':Predicate, #1: 1	أَنَّ الْمَحْمِلَ
u'أَنَّ مَحْمُودٌ':Predicate, #1: 1	أَنَّ مَحْمَلَ
u'أَنَّ مَحْمُولٌ':Predicate, #4: 4	أَنَّ مَحْمُودَ
u'أَنَّ مُحِيل':Predicate, #1: 1	أَنَّ الْمَحْمُولَ
u'أَنَّ مُخٌّ':Predicate, #7: 7	أَنَّ الْمُحِيلَ
u'أَنَّ مُخَاطَبٌ':Predicate, #1: 1	أَنَّ مُخَّ
u'أَنَّ مُخَاطِبٌ':Predicate, #10: 10	أَنَّ الْمُخَاطَبَ
u'أَنَّ مُخَاطَبٌ':Predicate, #1: 1	أَنَّ الْمُخَاطِبَ
u'أَنَّ مُخَاطَرَةٌ':Predicate, #3: 3	أَنَّ الْمُخَاطَبِينَ
u'أَنَّ مُخَالَطَةٌ':Predicate, #1: 1	أَنَّ الْمُخَاطَرَةَ
u'أَنَّ مُخَالِفٌ':Predicate, #1: 1	أَنَّ مُخَالَطَةَ
u'أَنَّ مُخَالِفٌ':Predicate, #10: 10	أَنَّ الْمُخَالِفَ
u'أَنَّ مُخَالِفٌ':Predicate, #1: 1	أَنَّ الْمُخَالِفِينَ
u'أَنَّ مُخَالِفٌ':Predicate, #1: 1	أَنَّ مُخَالِفَةَ
u'أَنَّ مُخَالَفَةٌ':Predicate, #3: 3	أَنَّ مُخَالِفَ
u'أَنَّ مُخَالَفَةٌ':Predicate, #15: 15	أَنَّ الْمُخَالَفَةَ
u'أَنَّ مُخْبِرٌ':Predicate, #6: 6	أَنَّ مُخَالَفَةَ
u'أَنَّ مُخْبِرٌ':Predicate, #1: 1	أَنَّ الْمُخْبِرِينَ
u'أَنَّ مُخْتَارٌ':Predicate, #4: 4	أَنَّ الْمُخْبِرَ
u'أَنَّ مُخْتَارٌ':Predicate, #33: 33	أَنَّ الْمُخْتَارَ
u'أَنَّ مُخْتَارٌ':Subject, #3: 3	أَنَّ مُخْتَارَ
u'أَنَّ مُخْتال':Predicate, #1: 1	أَنَّ الْمُخْتَارُ
u'أَنَّ مُخْتَصّ':Predicate, #1: 1	أَنَّ الْمُخْتَالَ
u'أَنَّ مُخْتَلَفٌ':Predicate, #1: 1	أَنَّ الْمُخْتَصَّ
u'أَنَّ مُخَدِّرٌ':Predicate, #3: 3	أَنَّ الْمُخْتَلَفَ
u'أَنَّ مُخَدَّرٌ':Predicate, #1: 1	أَنَّ الْمُخَدِّرَ
u'أَنَّ مُخْرِجٌ':Predicate, #1: 1	أَنَّ الْمُخَدَّرَةَ
u'أَنَّ مُخْرِجٌ':Predicate, #1: 1	أَنَّ الْمُخْرِجَ
u'أَنَّ مَخْرَجٌ':Predicate, #1: 1	أَنَّ مُخْرِجَ
u'أَنَّ مَخْرَجٌ':Predicate, #2: 2	أَنَّ مَخْرَجَ
u'أَنَّ مَخْصُوصٌ':Predicate, #5: 5	أَنَّ الْمَخْرَجَ
u'أَنَّ مُخْطِئٌ':Predicate, #5: 5	أَنَّ الْمَخْصُوصَ
u'أَنَّ مُخَفَّفٌ':Predicate, #4: 4	أَنَّ الْمُخْطِئَ
u'أَنَّ مُخَلِّصٌ':Predicate, #3: 3	أَنَّ الْمُخَفَّفَ
u'أَنَّ مَخْلُوطٌ':Predicate, #2: 2	أَنَّ الْمُخَلِّصَ
u'أَنَّ مُخَنَّث':Predicate, #4: 4	أَنَّ الْمَخْلُوطَ
u'أَنَّ مُخَيَّرٌ':Predicate, #2: 2	أَنَّ الْمُخَنَّثِينَ
u'أَنَّ مُدٌّ':Predicate, #3: 3	أَنَّ الْمُخَيَّرَةَ
u'أَنَّ مَدٌّ':Predicate, #1: 1	أَنَّ الْمُدَّ
u'أَنَّ مَدَارٌ':Predicate, #2: 2	أَنَّ الْمَدَّ
u'أَنَّ مَدَارٌ':Predicate, #1: 1	أَنَّ مَدَارَكَ
u'أَنَّ مَدَارٌ':Predicate, #21: 21	أَنَّ الْمَدَارَ
u'أَنَّ مُدَاهَنَةٌ':Predicate, #9: 9	أَنَّ مَدَارَ
u'أَنَّ مُدَاوَاةٌ':Predicate, #1: 1	أَنَّ الْمُدَاهَنَةَ
u'أَنَّ مُدَاوَمَةٌ':Predicate, #1: 1	أَنَّ مُدَاوَاةَ
u'أَنَّ مُدَاوَمَةٌ':Predicate, #2: 2	أَنَّ مُدَاوَمَةَ
u'أَنَّ مُدَبِّرٌ':Predicate, #4: 4	أَنَّ الْمُدَاوَمَةَ
u'أَنَّ مُدَبَّرٌ':Predicate, #1: 1	أَنَّ مُدَبِّرَ
u'أَنَّ مُدَبَّرٌ':Predicate, #1: 1	أَنَّ مُدَبَّرَةً
u'أَنَّ مُدَبَّرٌ':Predicate, #24: 24	أَنَّ الْمُدَبَّرَ
u'أَنَّ مُدَّةٌ':Predicate, #3: 3	أَنَّ الْمُدَبَّرَةَ
u'أَنَّ مُدَّةٌ':Predicate, #27: 27	أَنَّ الْمُدَّةَ
u'أَنَّ مَدْحٌ':Predicate, #28: 28	أَنَّ مُدَّةَ
u'أَنَّ مَدْخَلٌ':Predicate, #1: 1	أَنَّ مَدْحَ
u'أَنَّ مَدْخُولٌ':Predicate, #1: 1	أَنَّ مَدْخَلَ
u'أَنَّ مَدْخُولٌ':Predicate, #1: 1	أَنَّ مَدْخُولَ
u'أَنَّ مَدْخُولٌ':Predicate, #2: 2	أَنَّ الْمَدْخُولَةَ
u'أَنَّ مدد':Predicate, #3: 3	أَنَّ الْمَدْخُولَ
u'أَنَّ مَدَدٌ':Predicate, #1: 1	أَنَّ الْمَدَدَ
u'أَنَّ مُدَرِّسٌ':Predicate, #1: 1	أَنَّ الْمَدَدَ
u'أَنَّ مُدَرِّسٌ':Predicate, #1: 1	أَنَّ مُدَرِّسَ
u'أَنَّ مَدْرَسَةٌ':Predicate, #4: 4	أَنَّ الْمُدَرِّسَ
u'أَنَّ مُدْرِكٌ':Predicate, #3: 3	أَنَّ الْمَدْرَسَةَ
u'أَنَّ مُدْرِكٌ':Predicate, #2: 2	أَنَّ الْمُدْرِكَ
u'أَنَّ مُدْرَكٌ':Predicate, #2: 2	أَنَّ مُدْرِكَ
u'أَنَّ مَدْعُوٌّ':Predicate, #3: 3	أَنَّ الْمُدْرَكَ
u'أَنَّ مُدَّعِي':Predicate, #1: 1	أَنَّ الْمَدْعُوَّ
u'أَنَّ مُدَّعِي':Predicate, #117: 117	أَنَّ الْمُدَّعِيَ
u'أَنَّ مَدْفُوعٌ':Predicate, #4: 4	أَنَّ مُدَّعِيَ
u'أَنَّ مَدْفُونٌ':Predicate, #11: 11	أَنَّ الْمَدْفُوعَ
u'أَنَّ مَدْلُولٌ':Predicate, #3: 3	أَنَّ الْمَدْفُونَ
u'أَنَّ مُدْمِنٌ':Predicate, #7: 7	أَنَّ مَدْلُولَ
u'أَنَّ مَدَنِيٌّ':Predicate, #1: 1	أَنَّ مُدْمِنَ
u'أَنَّ مَدَنِيٌّ':Predicate, #1: 1	أَنَّ الْمَدَنِيَّ
u'أَنَّ مُدَوَّرٌ':Predicate, #1: 1	أَنَّ الْمَدَنِيَّةَ
u'أَنَّ مُدَوَّنٌ':Predicate, #1: 1	أَنَّ الْمُدَوَّرَ
u'أَنَّ مُدَوَّنَةٌ':Predicate, #2: 2	أَنَّ الْمُدَوَّنَةَ
u'أَنَّ مِدْيَانٌ':Predicate, #2: 2	أَنَّ الْمُدَوَّنَةَ
u'أَنَّ مُدِيرٌ':Predicate, #2: 2	أَنَّ الْمِدْيَانَ
u'أَنَّ مَدِينٌ':Predicate, #3: 3	أَنَّ الْمُدِيرَ
u'أَنَّ مَدِينٌ':Predicate, #6: 6	أَنَّ الْمَدِينَةَ
u'أَنَّ مَدِينَةٌ':Predicate, #9: 9	أَنَّ الْمَدِينَ
u'أَنَّ مَدْيُونٌ':Predicate, #6: 6	أَنَّ الْمَدِينَةَ
u'أَنَّ مُذَاكَرَةٌ':Predicate, #19: 19	أَنَّ الْمَدْيُونَ
u'أَنَّ مَذَاهِبُ':Predicate, #1: 1	أَنَّ مُذَاكَرَةَ
u'أَنَّ مَذْبُوحٌ':Predicate, #2: 2	أَنَّ مَذَاهِبَ
u'أَنَّ مُذَكَّرٌ':Predicate, #1: 1	أَنَّ الْمَذْبُوحَ
u'أَنَّ مَذْكُورٌ':Predicate, #1: 1	أَنَّ الْمُذَكَّرَ
u'أَنَّ مُذْنِبٌ':Predicate, #41: 41	أَنَّ الْمَذْكُورَ
u'أَنَّ مَذْهَبٌ':Predicate, #1: 1	أَنَّ الْمُذْنِبَ
u'أَنَّ مَذْهَبٌ':Predicate, #114: 114	أَنَّ الْمَذْهَبَ
u'أَنَّ مرٌّ':Predicate, #73: 73	أَنَّ مَذْهَبَ
u'أَنَّ مُرابَحَة':Predicate, #2: 2	أَنَّ الْمَرَّةَ
u'أَنَّ مَرَاتِبُ':Predicate, #1: 1	أَنَّ الْمُرَابَحَةَ
u'أَنَّ مَرَاتِبُ':Predicate, #1: 1	أَنَّ الْمَرَاتِبَ
u'أَنَّ مراد':Predicate, #6: 6	أَنَّ مَرَاتِبَ
u'أَنَّ مُرَادٌ':Predicate, #1204: 1204	أَنَّ الْمُرَادَ
u'أَنَّ مراد':Predicate, #1204: 1204	أَنَّ الْمُرَادَ
u'أَنَّ مُرَادٌ':Predicate, #1: 1	أَنَّ الْمرادَ
u'أَنَّ مراد':Predicate, #1: 1	أَنَّ الْمرادَ
u'أَنَّ مُرَادٌ':Predicate, #88: 88	أَنَّ مُرَادَ
u'أَنَّ مراد':Subject, #88: 88	أَنَّ مُرَادَ
u'أَنَّ مُرَادٌ':Subject, #1: 1	أَنَّ مُرَادُهُ
u'أَنَّ مَرَارَةٌ':Predicate, #1: 1	أَنَّ مُرَادُهُ
u'أَنَّ مراسيل':Predicate, #1: 1	أَنَّ مَرَارَةَ
u'أَنَّ مَرَاسِيلُ':Predicate, #1: 1	أَنَّ الْمَرَاسِيلَ
u'أَنَّ مراسيل':Predicate, #1: 1	أَنَّ الْمَرَاسِيلَ
u'أَنَّ مَرَاسِيلُ':Predicate, #1: 1	أَنَّ مَرَاسِيلَ
u'أَنَّ مُرَاعَاةٌ':Predicate, #1: 1	أَنَّ مَرَاسِيلَ
u'أَنَّ مَرَافِقُ':Predicate, #17: 17	أَنَّ مُرَاعَاةَ
u'أَنَّ مُرَافَقَةٌ':Predicate, #1: 1	أَنَّ الْمَرَافِقَ
u'أَنَّ مُرَاهِقٌ':Predicate, #2: 2	أَنَّ الْمُرَافَقَةَ
u'أَنَّ مُرَاهِقٌ':Predicate, #1: 1	أَنَّ الْمُرَاهِقَ
u'أَنَّ مُرَبَّعٌ':Predicate, #2: 2	أَنَّ الْمُرَاهِقَةَ
u'أَنَّ مَرَّةٌ':Predicate, #1: 1	أَنَّ الْمُرَبَّعَةَ
u'أَنَّ مَرْتَبَةٌ':Predicate, #2: 2	أَنَّ الْمَرَّةَ
u'أَنَّ مَرْتَبَةٌ':Predicate, #1: 1	أَنَّ الْمَرْتَبَةَ
u'أَنَّ مُرْتَدٌّ':Predicate, #3: 3	أَنَّ مَرْتَبَةَ
u'أَنَّ مُرْتَدٌّ':Predicate, #22: 22	أَنَّ الْمُرْتَدَّ
u'أَنَّ مُرْتَعِشٌ':Predicate, #4: 4	أَنَّ الْمُرْتَدَّةَ
u'أَنَّ مُرْتَكِبٌ':Predicate, #1: 1	أَنَّ الْمُرْتَعِشَ
u'أَنَّ مُرْتَكِبٌ':Predicate, #1: 1	أَنَّ مُرْتَكِبَ
u'أَنَّ مُرْتَهِنٌ':Predicate, #2: 2	أَنَّ الْمُرْتَكِبَ
u'أَنَّ مُرَجِّحٌ':Predicate, #31: 31	أَنَّ الْمُرْتَهِنَ
u'أَنَّ مُرَجَّحٌ':Predicate, #2: 2	أَنَّ الْمُرَجِّحَ
u'أَنَّ مَرْجِعٌ':Predicate, #4: 4	أَنَّ الْمُرَجَّحَ
u'أَنَّ مَرْجِعٌ':Predicate, #3: 3	أَنَّ مَرْجِعَ
u'أَنَّ مَرْجُوحَة':Predicate, #7: 7	أَنَّ الْمَرْجِعَ
u'أَنَّ مَرْجُوعٌ':Predicate, #1: 1	أَنَّ الْمَرْجُوحِيَّةَ
u'أَنَّ مُرْجِئَةٌ':Predicate, #1: 1	أَنَّ الْمَرْجُوعَ
u'أَنَّ مَرَدَةٌ':Predicate, #1: 1	أَنَّ الْمُرْجِئَةَ
u'أَنَّ مَرْدُودٌ':Predicate, #1: 1	أَنَّ مَرَدَةَ
u'أَنَّ مُرْسِلٌ':Predicate, #4: 4	أَنَّ الْمَرْدُودَ
u'أَنَّ مُرْسَلٌ':Predicate, #3: 3	أَنَّ الْمُرْسِلَ
u'أَنَّ مُرْسَلٌ':Predicate, #4: 4	أَنَّ مُرْسَلَ
u'أَنَّ مَرَضٌ':Predicate, #8: 8	أَنَّ الْمُرْسَلَ
u'أَنَّ مَرَضٌ':Predicate, #18: 18	أَنَّ الْمَرَضَ
u'أَنَّ مُرْضِعٌ':Predicate, #2: 2	أَنَّ مَرَضَ
u'أَنَّ مَرْغُوبٌ':Predicate, #3: 3	أَنَّ الْمُرْضِعَةَ
u'أَنَّ مَرْفِقٌ':Predicate, #1: 1	أَنَّ الْمَرْغُوبَ
u'أَنَّ مَرْفِق':Predicate, #1: 1	أَنَّ الْمَرْفِقَ
u'أَنَّ مِرْفَقٌ':Predicate, #1: 1	أَنَّ الْمَرْفِقَ
u'أَنَّ مَرْفُوض':Predicate, #2: 2	أَنَّ الْمِرْفَقَ
u'أَنَّ مَرْفُوعٌ':Predicate, #1: 1	أَنَّ الْمَرْفُوضَ
u'أَنَّ مَرْقُوق':Predicate, #3: 3	أَنَّ الْمَرْفُوعَ
u'أَنَّ مُرَكَّبٌ':Predicate, #1: 1	أَنَّ الْمَرْقُوقَ
u'أَنَّ مَرْهُونٌ':Predicate, #6: 6	أَنَّ الْمُرَكَّبَ
u'أَنَّ مَرْهُونٌ':Predicate, #1: 1	أَنَّ الْمَرْهُونَةَ
u'أَنَّ مُرُوءةٌ':Predicate, #9: 9	أَنَّ الْمَرْهُونَ
u'أَنَّ مُرُورٌ':Predicate, #2: 2	أَنَّ الْمُرُوءَةَ
u'أَنَّ مُرُورٌ':Predicate, #8: 8	أَنَّ مُرُورَ
u'أَنَّ مَرْوِيّ':Predicate, #9: 9	أَنَّ الْمُرُورَ
u'أَنَّ مُرِيدٌ':Predicate, #6: 6	أَنَّ الْمَرْوِيَّ
u'أَنَّ مَرِيضٌ':Predicate, #3: 3	أَنَّ مُرِيدَ
u'أَنَّ مَرِيضٌ':Predicate, #43: 43	أَنَّ الْمَرِيضَ
u'أَنَّ مُزَاحٌ':Predicate, #5: 5	أَنَّ الْمَرِيضَةَ
u'أَنَّ مِزَاحٌ':Predicate, #1: 1	أَنَّ الْمُزَاحَ
u'أَنَّ مُزَاحَمَةٌ':Predicate, #1: 1	أَنَّ الْمِزَاحَ
u'أَنَّ مُزَارِعٌ':Predicate, #1: 1	أَنَّ الْمُزَاحَمَةَ
u'أَنَّ مَزِيَّةٌ':Predicate, #5: 5	أَنَّ الْمُزَارِعَ
u'أَنَّ مَزِيدٌ':Predicate, #1: 1	أَنَّ مَزِيَّةَ
u'أَنَّ مُزِيل':Predicate, #1: 1	أَنَّ الْمَزِيدَ
u'أَنَّ مَسٌّ':Predicate, #3: 3	أَنَّ الْمُزِيلَ
u'أَنَّ مَسٌّ':Predicate, #6: 6	أَنَّ مَسَّ
u'أَنَّ مُسَابَقَةٌ':Predicate, #7: 7	أَنَّ الْمَسَّ
u'أَنَّ مَسَاجِدُ':Predicate, #4: 4	أَنَّ الْمُسَابَقَةَ
u'أَنَّ مساس':Predicate, #10: 10	أَنَّ الْمَسَاجِدَ
u'أَنَّ مِسَاسٌ':Predicate, #1: 1	أَنَّ مِسَاسَ
u'أَنَّ مَسَافَةٌ':Predicate, #1: 1	أَنَّ مِسَاسَ
u'أَنَّ مَسَافَةٌ':Predicate, #2: 2	أَنَّ الْمَسَافَةَ
u'أَنَّ مُسَافِرٌ':Predicate, #2: 2	أَنَّ مَسَافَةَ
u'أَنَّ مُسَافِرٌ':Predicate, #1: 1	أَنَّ الْمُسَافِرِينَ
u'أَنَّ مُساقاة':Predicate, #25: 25	أَنَّ الْمُسَافِرَ
u'أَنَّ مُسَاكَنَةٌ':Predicate, #6: 6	أَنَّ الْمُسَاقَاةَ
u'أَنَّ مساكين':Predicate, #3: 3	أَنَّ الْمُسَاكَنَةَ
u'أَنَّ مساكين':Predicate, #2: 2	أَنَّ مَسَاكِينَ
u'أَنَّ مَسْأَلَةٌ':Predicate, #3: 3	أَنَّ الْمَسَاكِينَ
u'أَنَّ مَسْأَلَةٌ':Predicate, #105: 105	أَنَّ الْمَسْأَلَةَ
u'أَنَّ مُسَاهَلَةٌ':Predicate, #42: 42	أَنَّ مَسْأَلَةَ
u'أَنَّ مُسَاوَاةٌ':Predicate, #1: 1	أَنَّ الْمُسَاهَلَةَ
u'أَنَّ مَسَائِلُ':Predicate, #4: 4	أَنَّ الْمُسَاوَاةَ
u'أَنَّ مَسَائِلُ':Predicate, #10: 10	أَنَّ مَسَائِلَ
u'أَنَّ مُسَبِّبٌ':Predicate, #11: 11	أَنَّ الْمَسَائِلَ
u'أَنَّ مَسْبُوق':Predicate, #2: 2	أَنَّ الْمُسَبِّبَ
u'أَنَّ مَسْبُوق':Predicate, #26: 26	أَنَّ الْمَسْبُوقَ
u'أَنَّ مُسْتَأْجِرٌ':Predicate, #2: 2	أَنَّ الْمَسْبُوقِينَ
u'أَنَّ مُسْتَبْضِع':Predicate, #47: 47	أَنَّ الْمُسْتَأْجِرَ
u'أَنَّ مُسْتَتِرٌ':Predicate, #1: 1	أَنَّ الْمُسْتَبْضِعَ
u'أَنَّ مُسْتَحَبٌّ':Predicate, #3: 3	أَنَّ الْمُسْتَتِرَ
u'أَنَّ مُسْتَحِقٌّ':Predicate, #21: 21	أَنَّ الْمُسْتَحَبَّ
u'أَنَّ مُسْتَحَقٌّ':Predicate, #17: 17	أَنَّ الْمُسْتَحِقَّ
u'أَنَّ مُسْتَحِقٌّ':Predicate, #20: 20	أَنَّ الْمُسْتَحَقَّ
u'أَنَّ مُسْتَحِيلٌ':Predicate, #9: 9	أَنَّ مُسْتَحِقَّ
u'أَنَّ مُسْتَخْرَجٌ':Predicate, #1: 1	أَنَّ الْمُسْتَحِيلَ
u'أَنَّ مُسْتَدْعِي':Predicate, #1: 1	أَنَّ الْمُسْتَخْرَجَ
u'أَنَّ مُسْتَدَلٌّ':Predicate, #1: 1	أَنَّ الْمُسْتَدْعِيَ
u'أَنَّ مُسْتَرْسِلٌ':Predicate, #1: 1	أَنَّ الْمُسْتَدَلَّ
u'أَنَّ مُسْتَعَارٌ':Predicate, #2: 2	أَنَّ الْمُسْتَرْسِلَ
u'أَنَّ مُسْتَعْمِلٌ':Predicate, #1: 1	أَنَّ الْمُسْتَعَارَ
u'أَنَّ مُسْتَعْمِلٌ':Predicate, #1: 1	أَنَّ مُسْتَعْمِلَ
u'أَنَّ مُسْتَعْمَلٌ':Predicate, #3: 3	أَنَّ الْمُسْتَعْمِلَ
u'أَنَّ مُسْتَعِيرٌ':Predicate, #6: 6	أَنَّ الْمُسْتَعْمَلَ
u'أَنَّ مُسْتَفاد':Predicate, #17: 17	أَنَّ الْمُسْتَعِيرَ
u'أَنَّ مُسْتَفِيضٌ':Predicate, #1: 1	أَنَّ الْمُسْتَفَادَ
u'أَنَّ مُسْتَقْبِلٌ':Predicate, #1: 1	أَنَّ الْمُسْتَفِيضَ
u'أَنَّ مُسْتَقْبَلٌ':Predicate, #1: 1	أَنَّ الْمُسْتَقْبِلَ
u'أَنَّ مُسْتَقَرٌّ':Predicate, #2: 2	أَنَّ الْمُسْتَقْبَلَ
u'أَنَّ مُسْتَقِلٌّ':Predicate, #1: 1	أَنَّ الْمُسْتَقَرَّ
u'أَنَّ مُسْتَكْرِي':Predicate, #1: 1	أَنَّ مُسْتَقِلَّ
u'أَنَّ مُسْتَمِعٌ':Predicate, #1: 1	أَنَّ الْمُسْتَكْرِيَ
u'أَنَّ مُسْتَنِدٌ':Predicate, #2: 2	أَنَّ الْمُسْتَمِعَ
u'أَنَّ مُسْتَنَدٌ':Predicate, #3: 3	أَنَّ الْمُسْتَنِدَ
u'أَنَّ مُسْتَنِيب':Predicate, #5: 5	أَنَّ مُسْتَنَدَ
u'أَنَّ مُسْتَوْدَعٌ':Predicate, #1: 1	أَنَّ الْمُسْتَنِيبَ
u'أَنَّ مَسْتُورٌ':Predicate, #1: 1	أَنَّ الْمُسْتَوْدَعَ
u'أَنَّ مَسْتُورٌ':Predicate, #1: 1	أَنَّ الْمَسْتُورَ
u'أَنَّ مُسْتَوْرِدٌ':Predicate, #1: 1	أَنَّ مَسْتُورَ
u'أَنَّ مُسْتَوِي':Predicate, #1: 1	أَنَّ الْمُسْتَوْرِدَ
u'أَنَّ مَسْجِدٌ':Predicate, #1: 1	أَنَّ مُسْتَوِيَ
u'أَنَّ مَسْجِدٌ':Predicate, #36: 36	أَنَّ الْمَسْجِدَ
u'أَنَّ مَسْجُونٌ':Predicate, #4: 4	أَنَّ مَسْجِدَ
u'أَنَّ مَسْحٌ':Predicate, #1: 1	أَنَّ الْمَسْجُونِينَ
u'أَنَّ مَسْحٌ':Predicate, #13: 13	أَنَّ مَسْحَ
u'أَنَّ مُسِرّ':Predicate, #45: 45	أَنَّ الْمَسْحَ
u'أَنَّ مُسْرِفٌ':Predicate, #1: 1	أَنَّ الْمُسِرَّ
u'أَنَّ مَسْرُوقٌ':Predicate, #2: 2	أَنَّ الْمُسْرِفَ
u'أَنَّ مَسْرُوقٌ':Predicate, #1: 1	أَنَّ مَسْرُوقَ
u'أَنَّ مَسْعُودٌ':Predicate, #4: 4	أَنَّ الْمَسْرُوقَ
u'أَنَّ مِسْكٌ':Predicate, #3: 3	أَنَّ مَسْعُودَ
u'أَنَّ مَسْكَنٌ':Predicate, #2: 2	أَنَّ الْمِسْكَ
u'أَنَّ مَسْكَنَةٌ':Predicate, #5: 5	أَنَّ الْمَسْكَنَ
u'أَنَّ مَسْكُوتٌ':Predicate, #1: 1	أَنَّ مَسْكَنَةَ
u'أَنَّ مِسْكِينٌ':Predicate, #2: 2	أَنَّ الْمَسْكُوتَ
u'أَنَّ مُسَلَّمٌ':Predicate, #9: 9	أَنَّ الْمِسْكِينَ
u'أَنَّ مُسْلِمٌ':Predicate, #2: 2	أَنَّ الْمُسَلَّمَ
u'أَنَّ مُسْلِمٌ':Predicate, #2: 2	أَنَّ مُسْلِمَ
u'أَنَّ مُسْلِمٌ':Predicate, #33: 33	أَنَّ الْمُسْلِمِينَ
u'أَنَّ مُسْلِمٌ':Predicate, #3: 3	أَنَّ الْمُسْلِمَةَ
u'أَنَّ مُسْلِمٌ':Subject, #58: 58	أَنَّ الْمُسْلِمَ
u'أَنَّ مَسْلُوبٌ':Predicate, #1: 1	أَنَّ مُسْلِمُ
u'أَنَّ مُسَمّاة':Predicate, #1: 1	أَنَّ الْمَسْلُوبَ
u'أَنَّ مَسْمُوعٌ':Predicate, #1: 1	أَنَّ الْمُسَمَّاةَ
u'أَنَّ مُسِنٌّ':Predicate, #12: 12	أَنَّ الْمَسْمُوعَ
u'أَنَّ مُسَنّاة':Predicate, #3: 3	أَنَّ الْمُسِنَّةَ
u'أَنَّ مَسْنُونٌ':Predicate, #3: 3	أَنَّ الْمُسَنَّاةَ
u'أَنَّ مَسِيحٌ':Predicate, #6: 6	أَنَّ الْمَسْنُونَ
u'أَنَّ مَسِيلٌ':Predicate, #2: 2	أَنَّ الْمَسِيحَ
u'أَنَّ مُشَابَهَةٌ':Predicate, #1: 1	أَنَّ مَسِيلَ
u'أَنَّ مُشَاحَّةٌ':Predicate, #1: 1	أَنَّ الْمُشَابَهَةَ
u'أَنَّ مُشار':Predicate, #2: 2	أَنَّ الْمُشَاحَّةَ
u'أَنَّ مُشَارِكٌ':Predicate, #3: 3	أَنَّ الْمُشَارَ
u'أَنَّ مُشَارَكَةٌ':Predicate, #1: 1	أَنَّ الْمُشَارِكَ
u'أَنَّ مُشاعٌ':Predicate, #3: 3	أَنَّ الْمُشَارَكَةَ
u'أَنَّ مُشَاهَدٌ':Predicate, #2: 2	أَنَّ الْمُشَاعَ
u'أَنَّ مُشَاهَدَةٌ':Predicate, #3: 3	أَنَّ الْمُشَاهَدَةَ
u'أَنَّ مُشَاوِرٌ':Predicate, #3: 3	أَنَّ الْمُشَاهَدَةَ
u'أَنَّ مُشَاوَرَةٌ':Predicate, #1: 1	أَنَّ الْمُشَاوِرَ
u'أَنَّ مَشَايِخُ':Predicate, #3: 3	أَنَّ الْمُشَاوَرَةَ
u'أَنَّ مَشَايِخُ':Predicate, #23: 23	أَنَّ الْمَشَايِخَ
u'أَنَّ مُشَبَّهٌ':Predicate, #4: 4	أَنَّ مَشَايِخَ
u'أَنَّ مُشْتَرِط':Predicate, #2: 2	أَنَّ الْمُشَبَّهَ
u'أَنَّ مُشْتَرَكٌ':Predicate, #1: 1	أَنَّ الْمُشْتَرِطِينَ
u'أَنَّ مُشْتَرِكٌ':Predicate, #12: 12	أَنَّ الْمُشْتَرَكَ
u'أَنَّ مُشْتَرَكٌ':Subject, #1: 1	أَنَّ الْمُشْتَرِكَ
u'أَنَّ مُشْتَرِي':Predicate, #1: 1	أَنَّ الْمُشْتَرَكُ
u'أَنَّ مُشْتَرِي':Predicate, #212: 212	أَنَّ الْمُشْتَرِيَ
u'أَنَّ مُشْتَغِل':Predicate, #5: 5	أَنَّ مُشْتَرِيَ
u'أَنَّ مُشْتَقٌّ':Predicate, #3: 3	أَنَّ الْمُشْتَغِلَ
u'أَنَّ مُشَدَّدٌ':Subject, #1: 1	أَنَّ الْمُشْتَقَّ
u'أَنَّ مُشَرِّعٌ':Predicate, #1: 1	أَنَّ الْمُشَدَّدَةُ
u'أَنَّ مُشْرِفٌ':Predicate, #1: 1	أَنَّ الْمُشَرِّعَ
u'أَنَّ مُشْرِك':Predicate, #2: 2	أَنَّ الْمُشْرِفَ
u'أَنَّ مُشْرِك':Predicate, #13: 13	أَنَّ الْمُشْرِكِينَ
u'أَنَّ مَشْرُوطٌ':Predicate, #4: 4	أَنَّ الْمُشْرِكَ
u'أَنَّ مَشْرُوعٌ':Predicate, #9: 9	أَنَّ الْمَشْرُوطَ
u'أَنَّ مَشْرُوعِيَّةٌ':Predicate, #12: 12	أَنَّ الْمَشْرُوعَ
u'أَنَّ مُشْطٌ':Predicate, #2: 2	أَنَّ مَشْرُوعِيَّةَ
u'أَنَّ مَشْغُولٌ':Predicate, #1: 1	أَنَّ الْمُشْطَ
u'أَنَّ مَشَقَّةٌ':Predicate, #1: 1	أَنَّ الْمَشْغُولَ
u'أَنَّ مَشَقَّةٌ':Predicate, #1: 1	أَنَّ مَشَقَّةَ
u'أَنَّ مُشْكِلٌ':Predicate, #6: 6	أَنَّ الْمَشَقَّةَ
u'أَنَّ مَشْكُوكٌ':Predicate, #1: 1	أَنَّ الْمُشْكِلَ
u'أَنَّ مُشَمَّسٌ':Predicate, #3: 3	أَنَّ الْمَشْكُوكَ
u'أَنَّ مَشْهُودٌ':Predicate, #1: 1	أَنَّ الْمُشَمَّسَ
u'أَنَّ مَشْهُورٌ':Predicate, #20: 20	أَنَّ الْمَشْهُودَ
u'أَنَّ مَشُورَةٌ':Predicate, #34: 34	أَنَّ الْمَشْهُورَ
u'أَنَّ مَشْيٌ':Predicate, #1: 1	أَنَّ الْمَشُورَةَ
u'أَنَّ مَشْيٌ':Predicate, #2: 2	أَنَّ مَشْيَ
u'أَنَّ مَشِيئَةٌ':Predicate, #8: 8	أَنَّ الْمَشْيَ
u'أَنَّ مَشِيئَةٌ':Predicate, #3: 3	أَنَّ مَشِيئَةَ
u'أَنَّ مُصَابٌ':Predicate, #9: 9	أَنَّ الْمَشِيئَةَ
u'أَنَّ مُصَاحَبَةٌ':Predicate, #2: 2	أَنَّ الْمُصَابَ
u'أَنَّ مَصَاحِفُ':Predicate, #1: 1	أَنَّ مُصَاحَبَةَ
u'أَنَّ مُصَادَرٌ':Predicate, #3: 3	أَنَّ الْمَصَاحِفَ
u'أَنَّ مَصَادِرُ':Predicate, #1: 1	أَنَّ مُصَادَرَةَ
u'أَنَّ مُصَادَرَةٌ':Predicate, #2: 2	أَنَّ الْمَصَادِرَ
u'أَنَّ مَصَارِفُ':Predicate, #1: 1	أَنَّ مُصَادَرَةَ
u'أَنَّ مَصَارِفُ':Predicate, #1: 1	أَنَّ الْمَصَارِفَ
u'أَنَّ مُصَافَحَةٌ':Predicate, #1: 1	أَنَّ مَصَارِفَ
u'أَنَّ مَصَالِحُ':Predicate, #1: 1	أَنَّ مُصَافَحَةَ
u'أَنَّ مَصَالِحُ':Predicate, #10: 10	أَنَّ الْمَصَالِحَ
u'أَنَّ مُصَالِحٌ':Predicate, #1: 1	أَنَّ مَصَالِحَ
u'أَنَّ مُصَالَحَةٌ':Predicate, #5: 5	أَنَّ الْمُصَالِحَ
u'أَنَّ مُصَحِّحٌ':Predicate, #1: 1	أَنَّ مُصَالَحَةَ
u'أَنَّ مُصَحِّحٌ':Predicate, #1: 1	أَنَّ الْمُصَحِّحَةَ
u'أَنَّ مُصَحِّحٌ':Predicate, #2: 2	أَنَّ الْمُصَحِّحِينَ
u'أَنَّ مُصَحِّحٌ':Predicate, #2: 2	أَنَّ مُصَحِّحَ
u'أَنَّ مُصَحَّحٌ':Predicate, #4: 4	أَنَّ الْمُصَحِّحَ
u'أَنَّ مُصْحَفٌ':Predicate, #5: 5	أَنَّ الْمُصَحَّحَ
u'أَنَّ مَصْدَرٌ':Predicate, #3: 3	أَنَّ الْمُصْحَفَ
u'أَنَّ مَصْدَر':Predicate, #15: 15	أَنَّ الْمَصْدَرَ
u'أَنَّ مَصْدَرٌ':Predicate, #1: 1	أَنَّ الْمَصْدَرِيَّةَ
u'أَنَّ مُصَدِّقٌ':Predicate, #1: 1	أَنَّ مَصْدَرَ
u'أَنَّ مُصَدِّقٌ':Predicate, #1: 1	أَنَّ الْمُصَدِّقِينَ
u'أَنَّ مُصَدَّقٌ':Predicate, #4: 4	أَنَّ الْمُصَدِّقَ
u'أَنَّ مِصْرٌ':Predicate, #5: 5	أَنَّ الْمُصَدَّقَ
u'أَنَّ مِصْرٌ':Predicate, #11: 11	أَنَّ الْمِصْرَ
u'أَنَّ مُصَرَّحٌ':Predicate, #1: 1	أَنَّ مِصْرَ
u'أَنَّ مَصْرِفٌ':Predicate, #7: 7	أَنَّ الْمُصَرَّحَ
u'أَنَّ مَصْرُوعٌ':Predicate, #6: 6	أَنَّ مَصْرِفَ
u'أَنَّ مُصْطَلَحٌ':Predicate, #1: 1	أَنَّ الْمَصْرُوعَ
u'أَنَّ مُصَغَّرٌ':Predicate, #1: 1	أَنَّ الْمُصْطَلَحَ
u'أَنَّ مُصْلِحٌ':Predicate, #2: 2	أَنَّ الْمُصَغَّرَ
u'أَنَّ مَصْلَحَةٌ':Predicate, #1: 1	أَنَّ مُصْلِحَ
u'أَنَّ مَصْلَحَةٌ':Predicate, #17: 17	أَنَّ الْمَصْلَحَةَ
u'أَنَّ مُصَنِّفٌ':Predicate, #3: 3	أَنَّ مَصْلَحَةَ
u'أَنَّ مُصَوِّبٌ':Predicate, #125: 125	أَنَّ الْمُصَنِّفَ
u'أَنَّ مَصُوغٌ':Predicate, #1: 1	أَنَّ الْمُصَوِّبَةَ
u'أَنَّ مُصِيبٌ':Predicate, #1: 1	أَنَّ الْمَصُوغَ
u'أَنَّ مُصِيبٌ':Predicate, #26: 26	أَنَّ الْمُصِيبَ
u'أَنَّ مُصِيبَةٌ':Predicate, #2: 2	أَنَّ الْمُصِيبَةَ
u'أَنَّ مَصِيرٌ':Predicate, #2: 2	أَنَّ الْمُصِيبَةَ
u'أَنَّ مُضَارِبٌ':Predicate, #4: 4	أَنَّ الْمَصِيرَ
u'أَنَّ مَضَارِبُ':Predicate, #1: 1	أَنَّ الْمُضَارِبِينَ
u'أَنَّ مُضَارِبٌ':Predicate, #1: 1	أَنَّ مَضَارِبَ
u'أَنَّ مُضَارَبَةٌ':Predicate, #46: 46	أَنَّ الْمُضَارِبَ
u'أَنَّ مُضَارِعٌ':Predicate, #2: 2	أَنَّ الْمُضَارَبَةَ
u'أَنَّ مُضَاعَفٌ':Predicate, #3: 3	أَنَّ الْمُضَارِعَ
u'أَنَّ مُضَاعَفَةٌ':Predicate, #1: 1	أَنَّ الْمُضَاعَفَةَ
u'أَنَّ مُضَافٌ':Predicate, #1: 1	أَنَّ الْمُضَاعَفَةَ
u'أَنَّ مُضَاهَاةٌ':Predicate, #5: 5	أَنَّ الْمُضَافَ
u'أَنَّ مُضِرٌّ':Predicate, #1: 1	أَنَّ مُضَاهَاةَ
u'أَنَّ مِضْرَبٌ':Predicate, #2: 2	أَنَّ الْمُضِرَّ
u'أَنَّ مَضْرُوبٌ':Predicate, #1: 1	أَنَّ الْمِضْرَبَ
u'أَنَّ مَضْرُوبٌ':Predicate, #1: 1	أَنَّ الْمَضْرُوبَ
u'أَنَّ مُضْطَرٌّ':Predicate, #1: 1	أَنَّ الْمَضْرُوبَةَ
u'أَنَّ مَضْغُوط':Predicate, #16: 16	أَنَّ الْمُضْطَرَّ
u'أَنَّ مُضْمَرٌ':Predicate, #2: 2	أَنَّ الْمَضْغُوطَ
u'أَنَّ مَضْمَضَةٌ':Predicate, #3: 3	أَنَّ الْمُضْمَرَ
u'أَنَّ مَضْمُومٌ':Predicate, #6: 6	أَنَّ الْمَضْمَضَةَ
u'أَنَّ مَضْمُونٌ':Predicate, #1: 1	أَنَّ الْمَضْمُومَ
u'أَنَّ مَضْمُونٌ':Predicate, #1: 1	أَنَّ الْمَضْمُونَةَ
u'أَنَّ مَضْمُونٌ':Predicate, #1: 1	أَنَّ مَضْمُونَ
u'أَنَّ مُضِيٌّ':Predicate, #2: 2	أَنَّ الْمَضْمُونَ
u'أَنَّ مُضِيٌّ':Predicate, #2: 2	أَنَّ الْمُضِيَّ
u'أَنَّ مُطَابَقَةٌ':Predicate, #7: 7	أَنَّ مُضِيَّ
u'أَنَّ مُطَالَبٌ':Predicate, #3: 3	أَنَّ الْمُطَابَقَةَ
u'أَنَّ مَطَالِبُ':Predicate, #14: 14	أَنَّ الْمُطَالَبَةَ
u'أَنَّ مُطَالَبٌ':Predicate, #1: 1	أَنَّ الْمَطَالِبَ
u'أَنَّ مُطَالَبٌ':Predicate, #1: 1	أَنَّ الْمُطَالَبَ
u'أَنَّ مُطَالَبَةٌ':Predicate, #3: 3	أَنَّ مُطَالَبَةَ
u'أَنَّ مُطَالَبَةٌ':Predicate, #14: 14	أَنَّ الْمُطَالَبَةَ
u'أَنَّ مَطَالِعُ':Predicate, #3: 3	أَنَّ مُطَالَبَةَ
u'أَنَّ مُطاوَعَة':Predicate, #1: 1	أَنَّ الْمَطَالِعَ
u'أَنَّ مَطْبُوخٌ':Predicate, #1: 1	أَنَّ الْمُطَاوَعَةَ
u'أَنَّ مَطَرٌ':Predicate, #1: 1	أَنَّ الْمَطْبُوخَ
u'أَنَّ مَطَرٌ':Predicate, #1: 1	أَنَّ مَطَرَ
u'أَنَّ مُطَّرِدٌ':Predicate, #4: 4	أَنَّ الْمَطَرَ
u'أَنَّ مَطْعُونٌ':Predicate, #1: 1	أَنَّ الْمُطَّرِدَ
u'أَنَّ مُطَلَّقٌ':Predicate, #3: 3	أَنَّ الْمَطْعُونَ
u'أَنَّ مُطْلِقٌ':Predicate, #17: 17	أَنَّ الْمُطَلَّقَةَ
u'أَنَّ مُطْلَقٌ':Predicate, #1: 1	أَنَّ الْمُطْلِقَ
u'أَنَّ مُطَلَّقٌ':Predicate, #1: 1	أَنَّ الْمُطْلَقَةَ
u'أَنَّ مُطْلَقٌ':Predicate, #1: 1	أَنَّ مُطَلَّقَ
u'أَنَّ مُطْلَقٌ':Predicate, #1: 1	أَنَّ مُطْلَقَةً
u'أَنَّ مُطْلَقٌ':Predicate, #25: 25	أَنَّ الْمُطْلَقَ
u'أَنَّ مَطْلُوبٌ':Predicate, #49: 49	أَنَّ مُطْلَقَ
u'أَنَّ مُطَهَّرٌ':Predicate, #46: 46	أَنَّ الْمَطْلُوبَ
u'أَنَّ مُطَهِّرٌ':Predicate, #1: 1	أَنَّ الْمُطَهَّرِينَ
u'أَنَّ مَطِيَّةٌ':Predicate, #3: 3	أَنَّ الْمُطَهِّرَ
u'أَنَّ مَظَاهِرُ':Predicate, #1: 1	أَنَّ الْمَطِيَّةَ
u'أَنَّ مُظَاهَرَةٌ':Predicate, #1: 1	أَنَّ الْمَظَاهِرَ
u'أَنَّ مَظْرُوفٌ':Predicate, #1: 1	أَنَّ الْمُظَاهَرَةَ
u'أَنَّ مَظْلُومٌ':Predicate, #1: 1	أَنَّ مَظْرُوفَ
u'أَنَّ مَظْنُون':Predicate, #3: 3	أَنَّ الْمَظْلُومَ
u'أَنَّ مُعَادٌ':Predicate, #1: 1	أَنَّ الْمَظْنُونَ
u'أَنَّ مَعَادِنُ':Predicate, #4: 4	أَنَّ الْمُعَادَ
u'أَنَّ مُعَارَضَةٌ':Predicate, #4: 4	أَنَّ الْمَعَادِنَ
u'أَنَّ مَعَارِفُ':Predicate, #7: 7	أَنَّ الْمُعَارَضَةَ
u'أَنَّ مَعَارِيضُ':Predicate, #1: 1	أَنَّ الْمَعَارِفَ
u'أَنَّ مُعَاشَرَةٌ':Predicate, #1: 1	أَنَّ الْمَعَارِيضَ
u'أَنَّ مَعَاصِي':Predicate, #1: 1	أَنَّ مُعَاشَرَةَ
u'أَنَّ مُعاطاة':Predicate, #10: 10	أَنَّ الْمَعَاصِيَ
u'أَنَّ مُعَالِجٌ':Predicate, #1: 1	أَنَّ الْمُعَاطَاةَ
u'أَنَّ مَعَالِمُ':Predicate, #1: 1	أَنَّ الْمُعَالِجَ
u'أَنَّ مُعَامَلَةٌ':Predicate, #1: 1	أَنَّ مَعَالِمَ
u'أَنَّ مُعَامَلَةٌ':Predicate, #3: 3	أَنَّ مُعَامَلَةَ
u'أَنَّ مَعَانِي':Predicate, #5: 5	أَنَّ الْمُعَامَلَةَ
u'أَنَّ مُعَاوَدَةٌ':Predicate, #4: 4	أَنَّ الْمَعَانِيَ
u'أَنَّ مُعَاوَدَةٌ':Predicate, #1: 1	أَنَّ مُعَاوَدَةَ
u'أَنَّ مُعاوِيَة':Predicate, #2: 2	أَنَّ الْمُعَاوَدَةَ
u'أَنَّ مُعَايَنَةٌ':Predicate, #59: 59	أَنَّ مُعَاوِيَةَ
u'أَنَّ مُعَبِّرٌ':Predicate, #2: 2	أَنَّ مُعَايَنَةَ
u'أَنَّ مُعَبَّرٌ':Predicate, #1: 1	أَنَّ مُعَبِّرَكَ
u'أَنَّ مَعْبُودٌ':Predicate, #3: 3	أَنَّ الْمُعَبَّرَ
u'أَنَّ مُعْتَادٌ':Predicate, #1: 1	أَنَّ الْمَعْبُودَ
u'أَنَّ مُعْتَادٌ':Predicate, #1: 1	أَنَّ الْمُعْتَادَةَ
u'أَنَّ مُعْتَادٌ':Predicate, #1: 1	أَنَّ مُعْتَادَ
u'أَنَّ مُعْتَبَرٌ':Predicate, #3: 3	أَنَّ الْمُعْتَادَ
u'أَنَّ مُعْتَدٌّ':Predicate, #182: 182	أَنَّ الْمُعْتَبَرَ
u'أَنَّ مُعْتَدٌّ':Predicate, #1: 1	أَنَّ مُعْتَدَّةَ
u'أَنَّ مُعْتَدٌّ':Predicate, #4: 4	أَنَّ الْمُعْتَدَّ
u'أَنَّ مُعْتَرِضٌ':Predicate, #9: 9	أَنَّ الْمُعْتَدَّةَ
u'أَنَّ مُعْتَزِلٌ':Predicate, #6: 6	أَنَّ الْمُعْتَرِضَ
u'أَنَّ مُعْتَزِلَةٌ':Predicate, #4: 4	أَنَّ الْمُعْتَزِلَةَ
u'أَنَّ مُعْتَقٌ':Predicate, #4: 4	أَنَّ الْمُعْتَزِلَةَ
u'أَنَّ مُعْتَقٌ':Predicate, #1: 1	أَنَّ مُعْتَقَ
u'أَنَّ مُعْتَقٌ':Predicate, #3: 3	أَنَّ الْمُعْتَقَةَ
u'أَنَّ مُعْتَقِدٌ':Predicate, #5: 5	أَنَّ الْمُعْتَقَ
u'أَنَّ مُعْتَمَدٌ':Predicate, #1: 1	أَنَّ الْمُعْتَقِدَ
u'أَنَّ مُعْتَمَدٌ':Predicate, #1: 1	أَنَّ مُعْتَمَدَ
u'أَنَّ مُعْتَمِرٌ':Predicate, #56: 56	أَنَّ الْمُعْتَمَدَ
u'أَنَّ مَعْتُوهٌ':Predicate, #1: 1	أَنَّ الْمُعْتَمِرَ
u'أَنَّ مُعْجَبٌ':Predicate, #3: 3	أَنَّ الْمَعْتُوهَ
u'أَنَّ مُعْجِزٌ':Predicate, #2: 2	أَنَّ الْمُعْجَبَ
u'أَنَّ مُعْجِزَةٌ':Predicate, #2: 2	أَنَّ الْمُعْجِزَةَ
u'أَنَّ مُعَجِّلٌ':Predicate, #2: 2	أَنَّ الْمُعْجِزَةَ
u'أَنَّ مُعَجَّلٌ':Predicate, #1: 1	أَنَّ الْمُعَجِّلَ
u'أَنَّ مُعَجَّلٌ':Predicate, #1: 1	أَنَّ الْمُعَجَّلَةَ
u'أَنَّ مَعْدِنٌ':Predicate, #3: 3	أَنَّ الْمُعَجَّلَ
u'أَنَّ مَعْدُودٌ':Predicate, #3: 3	أَنَّ الْمَعْدِنَ
u'أَنَّ مَعْدُومٌ':Predicate, #1: 1	أَنَّ الْمَعْدُودَ
u'أَنَّ مَعْذُورٌ':Predicate, #5: 5	أَنَّ الْمَعْدُومَ
u'أَنَّ مَعَرَّة':Predicate, #3: 3	أَنَّ الْمَعْذُورَ
u'أَنَّ مُعَرَّفٌ':Predicate, #1: 1	أَنَّ مَعَرَّةَ
u'أَنَّ مَعْرِفَةٌ':Predicate, #2: 2	أَنَّ الْمُعَرَّفَ
u'أَنَّ مَعْرِفَة':Predicate, #19: 19	أَنَّ مَعْرِفَةَ
u'أَنَّ مَعْرِفَةٌ':Predicate, #19: 19	أَنَّ مَعْرِفَةَ
u'أَنَّ مَعْرِفَة':Predicate, #2: 2	أَنَّ الْمَعْرِفَةَ
u'أَنَّ مُعَرَّق':Predicate, #2: 2	أَنَّ الْمَعْرِفَةَ
u'أَنَّ مَعْرَكَةٌ':Predicate, #1: 1	أَنَّ الْمُعَرَّقَ
u'أَنَّ مَعْرُوفٌ':Predicate, #1: 1	أَنَّ الْمَعْرَكَةَ
u'أَنَّ مَعْرُوفٌ':Predicate, #10: 10	أَنَّ الْمَعْرُوفَ
u'أَنَّ مَعْزُولٌ':Predicate, #1: 1	أَنَّ مَعْرُوفَةَ
u'أَنَّ مُعْسِرٌ':Predicate, #2: 2	أَنَّ الْمَعْزُولَ
u'أَنَّ مِعْشار':Predicate, #4: 4	أَنَّ الْمُعْسِرَ
u'أَنَّ مَعْصِيَةٌ':Predicate, #1: 1	أَنَّ مِعْشَارَ
u'أَنَّ مَعْطُوف':Predicate, #5: 5	أَنَّ الْمَعْصِيَةَ
u'أَنَّ مَعْطُوف':Predicate, #1: 1	أَنَّ الْمَعْطُوفَةَ
u'أَنَّ مُعْظَمٌ':Predicate, #4: 4	أَنَّ الْمَعْطُوفَ
u'أَنَّ مَعْفُوٌّ':Predicate, #3: 3	أَنَّ مُعْظَمَ
u'أَنَّ مَعْقِلٌ':Predicate, #2: 2	أَنَّ الْمَعْفُوَّ
u'أَنَّ مَعْقُودٌ':Predicate, #6: 6	أَنَّ مَعْقِلَ
u'أَنَّ مَعْقُودٌ':Predicate, #1: 1	أَنَّ الْمَعْقُودَةَ
u'أَنَّ مَعْقُولٌ':Predicate, #30: 30	أَنَّ الْمَعْقُودَ
u'أَنَّ مُعَلِّقٌ':Predicate, #3: 3	أَنَّ الْمَعْقُولَ
u'أَنَّ مُعَلَّقٌ':Predicate, #1: 1	أَنَّ الْمُعَلِّقَ
u'أَنَّ مُعَلِّلٌ':Predicate, #29: 29	أَنَّ الْمُعَلَّقَ
u'أَنَّ مُعَلِّمٌ':Predicate, #6: 6	أَنَّ الْمُعَلِّلَ
u'أَنَّ مُعَلِّمٌ':Predicate, #1: 1	أَنَّ الْمُعَلِّمِينَ
u'أَنَّ مُعْلَنٌ':Predicate, #2: 2	أَنَّ الْمُعَلِّمَ
u'أَنَّ مَعْلُوفٌ':Predicate, #1: 1	أَنَّ الْمُعْلَنَ
u'أَنَّ مَعْلُولٌ':Predicate, #1: 1	أَنَّ الْمَعْلُوفَةَ
u'أَنَّ مَعْلُومٌ':Predicate, #8: 8	أَنَّ الْمَعْلُولَ
u'أَنَّ مَعْلُوم':Predicate, #1: 1	أَنَّ مَعْلُومَ
u'أَنَّ مَعْلُومٌ':Predicate, #3: 3	أَنَّ مَعْلُومِيَّةَ
u'أَنَّ مَعْلُومَة':Predicate, #6: 6	أَنَّ الْمَعْلُومَ
u'أَنَّ مَعْمُولٌ':Predicate, #3: 3	أَنَّ مَعْلُومِيَّةَ
u'أَنَّ مُعَنْعَن':Predicate, #1: 1	أَنَّ الْمَعْمُولَ
u'أَنَّ مَعْنِيٌّ':Predicate, #1: 1	أَنَّ الْمُعَنْعَنَ
u'أَنَّ مَعْهُودٌ':Predicate, #2: 2	أَنَّ الْمَعْنِيَّ
u'أَنَّ مَعْهُودٌ':Predicate, #1: 1	أَنَّ الْمَعْهُودَةَ
u'أَنَّ مُعَوَّضٌ':Predicate, #4: 4	أَنَّ الْمَعْهُودَ
u'أَنَّ مُعَوَّلٌ':Predicate, #3: 3	أَنَّ الْمُعَوَّضَ
u'أَنَّ مِعْيَارٌ':Predicate, #9: 9	أَنَّ الْمُعَوَّلَ
u'أَنَّ مَعِيبٌ':Predicate, #1: 1	أَنَّ الْمِعْيَارَ
u'أَنَّ مَعِيبٌ':Predicate, #1: 1	أَنَّ الْمَعِيبَ
u'أَنَّ مُعِير':Predicate, #1: 1	أَنَّ الْمَعِيبَةَ
u'أَنَّ مُعِير':Predicate, #13: 13	أَنَّ الْمُعِيرَ
u'أَنَّ مُعِينٌ':Predicate, #1: 1	أَنَّ مُعِيرَ
u'أَنَّ مُعَيَّنٌ':Predicate, #1: 1	أَنَّ الْمُعِينَ
u'أَنَّ مُعَيَّنٌ':Predicate, #2: 2	أَنَّ الْمُعَيَّنَةَ
u'أَنَّ مُغَايَرَةٌ':Predicate, #3: 3	أَنَّ الْمُعَيَّنَ
u'أَنَّ مَغْبُونٌ':Predicate, #1: 1	أَنَّ الْمُغَايَرَةَ
u'أَنَّ مُغْتَسِلٌ':Predicate, #1: 1	أَنَّ الْمَغْبُونَ
u'أَنَّ مَغْرِبٌ':Predicate, #1: 1	أَنَّ الْمُغْتَسِلَ
u'أَنَّ مَغْرُورٌ':Predicate, #2: 2	أَنَّ الْمَغْرِبَ
u'أَنَّ مَغْسُولٌ':Predicate, #5: 5	أَنَّ الْمَغْرُورَ
u'أَنَّ مَغْشُوشٌ':Predicate, #1: 1	أَنَّ الْمَغْسُولَ
u'أَنَّ مَغْصُوب':Predicate, #1: 1	أَنَّ الْمَغْشُوشَ
u'أَنَّ مَغْفِرَةٌ':Predicate, #10: 10	أَنَّ الْمَغْصُوبَ
u'أَنَّ مَغْفُورٌ':Predicate, #2: 2	أَنَّ الْمَغْفِرَةَ
u'أَنَّ مُغَلَّب':Predicate, #1: 1	أَنَّ الْمَغْفُورَ
u'أَنَّ مُغَلَّظ':Predicate, #13: 13	أَنَّ الْمُغَلَّبَ
u'أَنَّ مَغْلُوبٌ':Predicate, #1: 1	أَنَّ الْمُغَلَّظَةَ
u'أَنَّ مُغَيِّرٌ':Predicate, #2: 2	أَنَّ الْمَغْلُوبَ
u'أَنَّ مُفاداة':Predicate, #1: 1	أَنَّ الْمُغَيِّرَ
u'أَنَّ مُفَارَقَةٌ':Predicate, #1: 1	أَنَّ الْمُفَادَاةَ
u'أَنَّ مُفَارَقَةٌ':Predicate, #1: 1	أَنَّ مُفَارَقَةَ
u'أَنَّ مُفَاضَلَةٌ':Predicate, #3: 3	أَنَّ الْمُفَارَقَةَ
u'أَنَّ مُفَاوِضٌ':Predicate, #1: 1	أَنَّ الْمُفَاضَلَةَ
u'أَنَّ مُفَاوَضَةٌ':Predicate, #2: 2	أَنَّ الْمُفَاوِضَ
u'أَنَّ مُفْتِي':Predicate, #3: 3	أَنَّ الْمُفَاوَضَةَ
u'أَنَّ مُفْرَدٌ':Predicate, #20: 20	أَنَّ الْمُفْتِيَ
u'أَنَّ مُفَرِّقٌ':Predicate, #4: 4	أَنَّ الْمُفْرَدَ
u'أَنَّ مَفْرُوضٌ':Predicate, #1: 1	أَنَّ الْمُفَرِّقِينَ
u'أَنَّ مَفْرُوضٌ':Predicate, #2: 2	أَنَّ الْمَفْرُوضَةَ
u'أَنَّ مُفْسِدٌ':Predicate, #7: 7	أَنَّ الْمَفْرُوضَ
u'أَنَّ مَفْسَدَةٌ':Predicate, #9: 9	أَنَّ الْمُفْسِدَ
u'أَنَّ مُفَسَّرٌ':Predicate, #2: 2	أَنَّ مَفْسَدَةَ
u'أَنَّ مُفَسِّرٌ':Predicate, #7: 7	أَنَّ الْمُفَسَّرَ
u'أَنَّ مَفْسُوخ':Predicate, #7: 7	أَنَّ الْمُفَسِّرِينَ
u'أَنَّ مُفَضَّلٌ':Predicate, #2: 2	أَنَّ الْمَفْسُوخَ
u'أَنَّ مُفْطِر':Predicate, #1: 1	أَنَّ الْمُفَضَّلَ
u'أَنَّ مَفْعُولٌ':Predicate, #1: 1	أَنَّ الْمُفْطِرَ
u'أَنَّ مَفْقُودٌ':Predicate, #3: 3	أَنَّ الْمَفْعُولَ
u'أَنَّ مُفْلِسٌ':Predicate, #7: 7	أَنَّ الْمَفْقُودَ
u'أَنَّ مَفْهُومٌ':Predicate, #11: 11	أَنَّ الْمُفْلِسَ
u'أَنَّ مَفْهُومٌ':Predicate, #12: 12	أَنَّ الْمَفْهُومَ
u'أَنَّ مُفَوَّضٌ':Predicate, #25: 25	أَنَّ مَفْهُومَ
u'أَنَّ مُفِيدٌ':Predicate, #3: 3	أَنَّ الْمُفَوَّضَ
u'أَنَّ مُفِيدٌ':Predicate, #2: 2	أَنَّ مُفِيدَ
u'أَنَّ مَقَابِرُ':Predicate, #3: 3	أَنَّ الْمُفِيدَ
u'أَنَّ مُقَابَلٌ':Predicate, #1: 1	أَنَّ الْمَقَابِرَ
u'أَنَّ مُقَابَلٌ':Predicate, #2: 2	أَنَّ الْمُقَابَلَةَ
u'أَنَّ مُقَابَلَةٌ':Predicate, #5: 5	أَنَّ مُقَابَلَةَ
u'أَنَّ مُقَابَلَةٌ':Predicate, #2: 2	أَنَّ الْمُقَابَلَةَ
u'أَنَّ مُقَاتِلٌ':Predicate, #5: 5	أَنَّ مُقَابَلَةَ
u'أَنَّ مُقَاتِلٌ':Predicate, #1: 1	أَنَّ مُقَاتِلَ
u'أَنَّ مَقَادِيرُ':Predicate, #2: 2	أَنَّ الْمُقَاتِلَ
u'أَنَّ مَقَادِيرُ':Predicate, #1: 1	أَنَّ الْمَقَادِيرَ
u'أَنَّ مُقَارَنٌ':Predicate, #2: 2	أَنَّ مَقَادِيرَ
u'أَنَّ مُقَارَنَةٌ':Predicate, #4: 4	أَنَّ الْمُقَارَنَةَ
u'أَنَّ مُقاسِم':Predicate, #4: 4	أَنَّ الْمُقَارَنَةَ
u'أَنَّ مُقَاصَّةٌ':Predicate, #1: 1	أَنَّ الْمُقَاسِمَ
u'أَنَّ مَقَاصِدُ':Predicate, #1: 1	أَنَّ الْمُقَاصَّةَ
u'أَنَّ مَقَاصِدُ':Predicate, #1: 1	أَنَّ مَقَاصِدَ
u'أَنَّ مَقَاعِدُ':Predicate, #5: 5	أَنَّ الْمَقَاصِدَ
u'أَنَّ مَقَالَةٌ':Predicate, #1: 1	أَنَّ مَقَاعِدَ
u'أَنَّ مُقَامٌ':Predicate, #1: 1	أَنَّ مَقَالَةَ
u'أَنَّ مَقَامٌ':Predicate, #2: 2	أَنَّ الْمُقَامَ
u'أَنَّ مُقَايَضَةٌ':Predicate, #4: 4	أَنَّ الْمَقَامَ
u'أَنَّ مُقْبِلٌ':Predicate, #1: 1	أَنَّ الْمُقَايَضَةَ
u'أَنَّ مَقْبُوضٌ':Predicate, #1: 1	أَنَّ الْمُقْبِلَ
u'أَنَّ مَقْبُولٌ':Predicate, #29: 29	أَنَّ الْمَقْبُوضَ
u'أَنَّ مُقْتَرِضٌ':Predicate, #2: 2	أَنَّ الْمَقْبُولَ
u'أَنَّ مُقْتَصِر':Predicate, #7: 7	أَنَّ الْمُقْتَرِضَ
u'أَنَّ مَقْتُولٌ':Predicate, #1: 1	أَنَّ الْمُقْتَصِرَ
u'أَنَّ مِقْدَارٌ':Predicate, #5: 5	أَنَّ الْمَقْتُولَ
u'أَنَّ مِقْدَارٌ':Predicate, #3: 3	أَنَّ الْمِقْدَارَ
u'أَنَّ مِقْدَامٌ':Predicate, #7: 7	أَنَّ مِقْدَارَ
u'أَنَّ مُقَدَّرٌ':Predicate, #1: 1	أَنَّ الْمِقْدَامَ
u'أَنَّ مُقَدِّمٌ':Predicate, #5: 5	أَنَّ الْمُقَدَّرَ
u'أَنَّ مُقَدِّمٌ':Predicate, #1: 1	أَنَّ مُقَدِّمَةَ
u'أَنَّ مُقَدَّمٌ':Predicate, #2: 2	أَنَّ الْمُقَدِّمَةَ
u'أَنَّ مُقَدِّمَةٌ':Predicate, #34: 34	أَنَّ الْمُقَدَّمَ
u'أَنَّ مُقَدِّمَةٌ':Predicate, #1: 1	أَنَّ مُقَدِّمَةَ
u'أَنَّ مَقْدُورٌ':Predicate, #2: 2	أَنَّ الْمُقَدِّمَةَ
u'أَنَّ مَقْذُوفٌ':Predicate, #2: 2	أَنَّ الْمَقْدُورَ
u'أَنَّ مُقَرَّرٌ':Predicate, #5: 5	أَنَّ الْمَقْذُوفَ
u'أَنَّ مُقَرِّرٌ':Predicate, #1: 1	أَنَّ الْمُقَرَّرَ
u'أَنَّ مُقْرِضٌ':Predicate, #1: 1	أَنَّ الْمُقَرِّرَ
u'أَنَّ مَقْرُوءٌ':Predicate, #5: 5	أَنَّ الْمُقْرِضَ
u'أَنَّ مَقْسُومٌ':Predicate, #1: 1	أَنَّ الْمَقْرُوءَ
u'أَنَّ مَقْصِدٌ':Predicate, #4: 4	أَنَّ الْمَقْسُومَ
u'أَنَّ مَقْصُودٌ':Predicate, #2: 2	أَنَّ الْمَقْصِدَ
u'أَنَّ مَقْصُودٌ':Predicate, #177: 177	أَنَّ الْمَقْصُودَ
u'أَنَّ مَقْصُورٌ':Predicate, #18: 18	أَنَّ مَقْصُودَ
u'أَنَّ مَقْصُورَةٌ':Predicate, #1: 1	أَنَّ الْمَقْصُورَةَ
u'أَنَّ مَقْضِيّ':Predicate, #1: 1	أَنَّ الْمَقْصُورَةَ
u'أَنَّ مَقْطَعٌ':Predicate, #6: 6	أَنَّ الْمَقْضِيَّ
u'أَنَّ مَقْطُوعٌ':Predicate, #1: 1	أَنَّ الْمَقْطَعَ
u'أَنَّ مَقْطُوعٌ':Predicate, #4: 4	أَنَّ الْمَقْطُوعَ
u'أَنَّ مُقَلِّدٌ':Predicate, #6: 6	أَنَّ مَقْطُوعَ
u'أَنَّ مُقَلِّدٌ':Predicate, #10: 10	أَنَّ الْمُقَلِّدَ
u'أَنَّ مُقْمِرٌ':Predicate, #2: 2	أَنَّ مُقَلِّدَ
u'أَنَّ مَقُولٌ':Predicate, #1: 1	أَنَّ الْمُقْمِرَ
u'أَنَّ مُقَوِّمٌ':Predicate, #2: 2	أَنَّ الْمَقُولَ
u'أَنَّ مُقَوَّمٌ':Predicate, #1: 1	أَنَّ الْمُقَوِّمَ
u'أَنَّ مُقَيَّدٌ':Predicate, #2: 2	أَنَّ الْمُقَوَّمَ
u'أَنَّ مُقِيمٌ':Predicate, #6: 6	أَنَّ الْمُقَيَّدَ
u'أَنَّ مَكَاتِبُ':Predicate, #7: 7	أَنَّ الْمُقِيمَ
u'أَنَّ مُكَاتَبَةٌ':Predicate, #1: 1	أَنَّ الْمَكَاتِبَ
u'أَنَّ مُكَاتَبَةٌ':Predicate, #10: 10	أَنَّ الْمُكَاتَبَةَ
u'أَنَّ مُكَارِي':Predicate, #1: 1	أَنَّ مُكَاتَبَةَ
u'أَنَّ مَكَاسِبُ':Predicate, #5: 5	أَنَّ الْمُكَارِيَ
u'أَنَّ مُكَافَأَةٌ':Predicate, #1: 1	أَنَّ مَكَاسِبَ
u'أَنَّ مَكَانٌ':Predicate, #1: 1	أَنَّ الْمُكَافَأَةَ
u'أَنَّ مَكَانٌ':Predicate, #5: 5	أَنَّ مَكَانَ
u'أَنَّ مُكْتَرِي':Predicate, #8: 8	أَنَّ الْمَكَانَ
u'أَنَّ مَكْتُوبٌ':Predicate, #4: 4	أَنَّ الْمُكْتَرِيَ
u'أَنَّ مَكْحُول':Predicate, #2: 2	أَنَّ الْمَكْتُوبَ
u'أَنَّ مَكْرٌ':Predicate, #2: 2	أَنَّ مَكْحُولاً
u'أَنَّ مُكْرَهٌ':Predicate, #1: 1	أَنَّ الْمَكْرَ
u'أَنَّ مُكْرَهٌ':Predicate, #2: 2	أَنَّ الْمُكْرَهَةَ
u'أَنَّ مَكْرُوهٌ':Predicate, #30: 30	أَنَّ الْمُكْرَهَ
u'أَنَّ مَكْرُوهٌ':Predicate, #12: 12	أَنَّ الْمَكْرُوهَ
u'أَنَّ مَكَس':Predicate, #1: 1	أَنَّ مَكْرُوهَ
u'أَنَّ مُكَسَّرٌ':Predicate, #1: 1	أَنَّ الْمَكَسَةَ
u'أَنَّ مَكْسُورٌ':Predicate, #1: 1	أَنَّ الْمُكَسَّرَ
u'أَنَّ مَكْسُورٌ':Predicate, #1: 1	أَنَّ الْمَكْسُورَ
u'أَنَّ مَكْشُوفٌ':Predicate, #1: 1	أَنَّ الْمَكْسُورَةَ
u'أَنَّ مَكْفُولٌ':Predicate, #2: 2	أَنَّ الْمَكْشُوفَ
u'أَنَّ مُكَلَّفٌ':Predicate, #9: 9	أَنَّ الْمَكْفُولَ
u'أَنَّ مُكَلَّفٌ':Predicate, #14: 14	أَنَّ الْمُكَلَّفَ
u'أَنَّ مَكِّيّ':Predicate, #2: 2	أَنَّ الْمُكَلَّفِينَ
u'أَنَّ مِكْيَالٌ':Predicate, #25: 25	أَنَّ الْمَكِّيَّ
u'أَنَّ مَكِيلٌ':Predicate, #1: 1	أَنَّ الْمِكْيَالَ
u'أَنَّ مَلأٌ':Predicate, #3: 3	أَنَّ الْمَكِيلَ
u'أَنَّ مُلاَءمَةٌ':Predicate, #1: 1	أَنَّ الْمَلأَ
u'أَنَّ مُلاَبَسَةٌ':Predicate, #1: 1	أَنَّ الْمُلَاءَمَةَ
u'أَنَّ مُلاَحَظَةٌ':Predicate, #1: 1	أَنَّ الْمُلَابَسَةَ
u'أَنَّ مُلاَزَمَةٌ':Predicate, #1: 1	أَنَّ مُلَاحَظَةَ
u'أَنَّ مُلاَقَاةٌ':Predicate, #2: 2	أَنَّ الْمُلَازَمَةَ
u'أَنَّ مَلاَمَةٌ':Predicate, #1: 1	أَنَّ مُلَاقَاةَ
u'أَنَّ مُلاَمَسَةٌ':Predicate, #1: 1	أَنَّ الْمَلَامَةَ
u'أَنَّ مَلاَهِي':Predicate, #4: 4	أَنَّ الْمُلَامَسَةَ
u'أَنَّ مَلاَئِكَةٌ':Predicate, #3: 3	أَنَّ الْمَلَاهِيَ
u'أَنَّ مَلاَئِكَةٌ':Predicate, #20: 20	أَنَّ الْمَلَائِكَةَ
u'أَنَّ مَلاَئِكَةٌ':Predicate, #2: 2	أَنَّ الْمَلاَئِكَةَ
u'أَنَّ مَلْبُوس':Predicate, #4: 4	أَنَّ مَلَائِكَةَ
u'أَنَّ مُلْتَقِط':Predicate, #2: 2	أَنَّ الْمَلْبُوسَ
u'أَنَّ مَلْحَظٌ':Predicate, #15: 15	أَنَّ الْمُلْتَقِطَ
u'أَنَّ مَلْحَظٌ':Predicate, #5: 5	أَنَّ الْمَلْحَظَ
u'أَنَّ مُلْزِمٌ':Predicate, #8: 8	أَنَّ مَلْحَظَ
u'أَنَّ مَلْزُوم':Predicate, #2: 2	أَنَّ الْمُلْزِمَ
u'أَنَّ مَلْزُوم':Predicate, #1: 1	أَنَّ الْمَلْزُومَ
u'أَنَّ مَلْفُوظٌ':Predicate, #1: 1	أَنَّ مَلْزُومَ
u'أَنَّ مَلَقٌ':Predicate, #4: 4	أَنَّ الْمَلْفُوظَ
u'أَنَّ مِلْكٌ':Predicate, #1: 1	أَنَّ الْمَلَقَ
u'أَنَّ مَلِكٌ':Predicate, #137: 137	أَنَّ الْمِلْكَ
u'أَنَّ مِلْكٌ':Predicate, #1: 1	أَنَّ الْمَلِكَ
u'أَنَّ مَلَكٌ':Predicate, #45: 45	أَنَّ مِلْكَ
u'أَنَّ مَلِكٌ':Predicate, #4: 4	أَنَّ مَلَكَ
u'أَنَّ مَلَكٌ':Predicate, #5: 5	أَنَّ مَلِكَ
u'أَنَّ ملل':Predicate, #7: 7	أَنَّ الْمَلَكَ
u'أَنَّ مِلَلٌ':Predicate, #1: 1	أَنَّ الْمِلَلَ
u'أَنَّ مُلُوحَةٌ':Predicate, #1: 1	أَنَّ الْمِلَلَ
u'أَنَّ مُلُوكٌ':Predicate, #1: 1	أَنَّ الْمُلُوحَةَ
u'أَنَّ مَلِيءٌ':Predicate, #2: 2	أَنَّ الْمُلُوكَ
u'أَنَّ مُمَاثَلَةٌ':Predicate, #1: 1	أَنَّ الْمَلِيءَ
u'أَنَّ مُمَاسَّةٌ':Predicate, #12: 12	أَنَّ الْمُمَاثَلَةَ
u'أَنَّ مُمَاسَّةٌ':Predicate, #1: 1	أَنَّ الْمُمَاسَّةَ
u'أَنَّ مُمْتَنِعٌ':Predicate, #2: 2	أَنَّ مُمَاسَّةَ
u'أَنَّ مَمَرٌّ':Predicate, #6: 6	أَنَّ الْمُمْتَنِعَ
u'أَنَّ مُمْسِكٌ':Predicate, #1: 1	أَنَّ مَمَرَّ
u'أَنَّ مَمْسُوس':Predicate, #1: 1	أَنَّ الْمُمْسِكَ
u'أَنَّ مُمْكِنٌ':Predicate, #1: 1	أَنَّ الْمَمْسُوسَةَ
u'أَنَّ مُمْكِن':Predicate, #1: 1	أَنَّ الْمُمْكِنَ
u'أَنَّ مُمَلِّك':Predicate, #1: 1	أَنَّ الْمُمْكِنَ
u'أَنَّ مَمْلُوكٌ':Predicate, #1: 1	أَنَّ الْمُمَلِّكَ
u'أَنَّ مَمْلُوك':Predicate, #14: 14	أَنَّ الْمَمْلُوكَ
u'أَنَّ مَمْلُوكٌ':Predicate, #1: 1	أَنَّ الْمَمْلُوكِيَّةَ
u'أَنَّ مَمْلُوكِيّ':Predicate, #2: 2	أَنَّ الْمَمْلُوكَةَ
u'أَنَّ مَمْنُوعٌ':Predicate, #1: 1	أَنَّ الْمَمْلُوكِيَّةَ
u'أَنَّ مُمَيِّزٌ':Predicate, #7: 7	أَنَّ الْمَمْنُوعَ
u'أَنَّ مَنٌّ':Predicate, #2: 2	أَنَّ الْمُمَيِّزَ
u'أَنَّ مُنَاجَاةٌ':Predicate, #3: 3	أَنَّ الْمَنَّ
u'أَنَّ مُنَادِي':Predicate, #1: 1	أَنَّ مُنَاجَاةَ
u'أَنَّ مُنَادِي':Predicate, #2: 2	أَنَّ مُنَادِيَ
u'أَنَّ مُنَازِعٌ':Predicate, #3: 3	أَنَّ الْمُنَادِيَ
u'أَنَّ مُنَازَعٌ':Predicate, #1: 1	أَنَّ الْمُنَازِعَ
u'أَنَّ مُنَازَعَةٌ':Predicate, #1: 1	أَنَّ الْمُنَازَعَةَ
u'أَنَّ مَنَازِلُ':Predicate, #1: 1	أَنَّ الْمُنَازَعَةَ
u'أَنَّ مُنَاسِبٌ':Predicate, #1: 1	أَنَّ الْمَنَازِلَ
u'أَنَّ مُنَاسَبَةٌ':Predicate, #5: 5	أَنَّ الْمُنَاسِبَ
u'أَنَّ مَنَاطٌ':Predicate, #5: 5	أَنَّ الْمُنَاسَبَةَ
u'أَنَّ مَنَاطٌ':Predicate, #5: 5	أَنَّ الْمَنَاطَ
u'أَنَّ مُنَاظِرٌ':Predicate, #5: 5	أَنَّ مَنَاطَ
u'أَنَّ مُنَاظَرَةٌ':Predicate, #1: 1	أَنَّ الْمُنَاظِرَ
u'أَنَّ مُنَافَسَةٌ':Predicate, #2: 2	أَنَّ الْمُنَاظَرَةَ
u'أَنَّ مَنَافِعُ':Predicate, #1: 1	أَنَّ الْمُنَافَسَةَ
u'أَنَّ مَنَافِعُ':Predicate, #33: 33	أَنَّ الْمَنَافِعَ
u'أَنَّ مُنَافِقٌ':Predicate, #3: 3	أَنَّ مَنَافِعَ
u'أَنَّ مُنَافِقٌ':Predicate, #1: 1	أَنَّ الْمُنَافِقَ
u'أَنَّ مُنَافِي':Predicate, #5: 5	أَنَّ الْمُنَافِقِينَ
u'أَنَّ مُنَاقَشَةٌ':Predicate, #1: 1	أَنَّ مُنَافِيَ
u'أَنَّ مَنَامٌ':Predicate, #1: 1	أَنَّ الْمُنَاقَشَةَ
u'أَنَّ مَنَامٌ':Predicate, #1: 1	أَنَّ الْمَنَامَ
u'أَنَّ مُنْتَشِر':Predicate, #1: 1	أَنَّ مَنَامَ
u'أَنَّ مُنْتَصِبٌ':Predicate, #1: 1	أَنَّ الْمُنْتَشِرَ
u'أَنَّ مُنْتَظِر':Predicate, #1: 1	أَنَّ الْمُنْتَصِبَ
u'أَنَّ مُنَجِّس':Predicate, #1: 1	أَنَّ الْمُنْتَظِرَ
u'أَنَّ مِنْحَةٌ':Predicate, #1: 1	أَنَّ الْمُنَجِّسَ
u'أَنَّ مُنْحَرِفٌ':Predicate, #2: 2	أَنَّ الْمِنْحَةَ
u'أَنَّ مَنْدُوبٌ':Predicate, #1: 1	أَنَّ الْمُنْحَرِفَةَ
u'أَنَّ مَنْذُور':Predicate, #10: 10	أَنَّ الْمَنْدُوبَ
u'أَنَّ مَنْذُور':Predicate, #12: 12	أَنَّ الْمَنْذُورَ
u'أَنَّ مَنْزَعٌ':Predicate, #2: 2	أَنَّ الْمَنْذُورَةَ
u'أَنَّ مَنْزِلٌ':Predicate, #1: 1	أَنَّ مَنْزَعَ
u'أَنَّ مَنْزِلَةٌ':Predicate, #5: 5	أَنَّ الْمَنْزِلَ
u'أَنَّ مَنْزِلَةٌ':Predicate, #1: 1	أَنَّ الْمَنْزِلَةَ
u'أَنَّ مُنْسَلِخٌ':Predicate, #1: 1	أَنَّ مَنْزِلَةَ
u'أَنَّ مَنْسُوبٌ':Predicate, #1: 1	أَنَّ الْمُنْسَلِخَ
u'أَنَّ مَنْسُوجٌ':Predicate, #2: 2	أَنَّ الْمَنْسُوبَ
u'أَنَّ مَنْسُوخٌ':Predicate, #1: 1	أَنَّ الْمَنْسُوجَ
u'أَنَّ مَنْسِيٌّ':Predicate, #1: 1	أَنَّ الْمَنْسُوخَ
u'أَنَّ مَنْسِيٌّ':Predicate, #1: 1	أَنَّ الْمَنْسِيَّةَ
u'أَنَّ مَنْشَأٌ':Predicate, #2: 2	أَنَّ الْمَنْسِيَّ
u'أَنَّ مَنْصِبٌ':Predicate, #3: 3	أَنَّ مَنْشَأَ
u'أَنَّ مَنْصُوبٌ':Predicate, #1: 1	أَنَّ مَنْصِبَ
u'أَنَّ مَنْصُوبٌ':Predicate, #1: 1	أَنَّ مَنْصُوبَ
u'أَنَّ مَنْصُورٌ':Predicate, #3: 3	أَنَّ الْمَنْصُوبَ
u'أَنَّ مَنْصُورٌ':Predicate, #1: 1	أَنَّ مَنْصُورَ
u'أَنَّ مَنْصُوصٌ':Predicate, #2: 2	أَنَّ الْمَنْصُورَ
u'أَنَّ مَنْصُوصٌ':Predicate, #1: 1	أَنَّ الْمَنْصُوصَةَ
u'أَنَّ مَنْصُوصٌ':Subject, #24: 24	أَنَّ الْمَنْصُوصَ
u'أَنَّ مَنْطِقٌ':Predicate, #1: 1	أَنَّ الْمَنْصُوصُ
u'أَنَّ مِنْطَقَةٌ':Predicate, #2: 2	أَنَّ الْمَنْطِقَ
u'أَنَّ مَنْطُوقٌ':Predicate, #2: 2	أَنَّ الْمِنْطَقَةَ
u'أَنَّ مَنْظُورٌ':Predicate, #1: 1	أَنَّ الْمَنْطُوقَ
u'أَنَّ مَنْعٌ':Predicate, #6: 6	أَنَّ الْمَنْظُورَ
u'أَنَّ مَنْعٌ':Predicate, #18: 18	أَنَّ مَنْعَ
u'أَنَّ مَنَعَةٌ':Predicate, #54: 54	أَنَّ الْمَنْعَ
u'أَنَّ مَنْفَذٌ':Predicate, #2: 2	أَنَّ الْمَنَعَةَ
u'أَنَّ مُنْفَرِدٌ':Predicate, #1: 1	أَنَّ الْمَنْفَذَ
u'أَنَّ مُنْفَرِدٌ':Predicate, #19: 19	أَنَّ الْمُنْفَرِدَ
u'أَنَّ مُنْفَصِلٌ':Predicate, #1: 1	أَنَّ الْمُنْفَرِدَةَ
u'أَنَّ مَنْفَعَةٌ':Predicate, #4: 4	أَنَّ الْمُنْفَصِلَ
u'أَنَّ مَنْفَعَةٌ':Predicate, #14: 14	أَنَّ الْمَنْفَعَةَ
u'أَنَّ مَنْفِيٌّ':Predicate, #14: 14	أَنَّ مَنْفَعَةَ
u'أَنَّ مُنْقَطِعٌ':Predicate, #5: 5	أَنَّ الْمَنْفِيَّ
u'أَنَّ مَنْقُولٌ':Predicate, #3: 3	أَنَّ الْمُنْقَطِعَ
u'أَنَّ مَنْقُولٌ':Predicate, #34: 34	أَنَّ الْمَنْقُولَ
u'أَنَّ مُنْكِرٌ':Predicate, #4: 4	أَنَّ مَنْقُولَ
u'أَنَّ مُنَكَّرٌ':Predicate, #1: 1	أَنَّ مُنْكِرَ
u'أَنَّ مُنْكَرٌ':Predicate, #2: 2	أَنَّ الْمُنَكَّرَ
u'أَنَّ مُنْكِرٌ':Predicate, #3: 3	أَنَّ الْمُنْكَرَ
u'أَنَّ مَنْكُوح':Predicate, #8: 8	أَنَّ الْمُنْكِرَ
u'أَنَّ مَنْكُوح':Predicate, #1: 1	أَنَّ مَنْكُوحَةَ
u'أَنَّ مَنْهِيٌّ':Predicate, #7: 7	أَنَّ الْمَنْكُوحَةَ
u'أَنَّ مُنَوَّعٌ':Predicate, #6: 6	أَنَّ الْمَنْهِيَّ
u'أَنَّ مَنِيٌّ':Predicate, #1: 1	أَنَّ الْمُنَوَّعَ
u'أَنَّ مَنِيٌّ':Predicate, #1: 1	أَنَّ مَنِيَّ
u'أَنَّ مَنِيَّةٌ':Predicate, #6: 6	أَنَّ الْمَنِيَّ
u'أَنَّ مُهَاجِرٌ':Predicate, #1: 1	أَنَّ الْمَنِيَّةَ
u'أَنَّ مُهَاجِرٌ':Predicate, #1: 1	أَنَّ الْمُهَاجِرَ
u'أَنَّ مُهَاجِرٌ':Predicate, #1: 1	أَنَّ مُهَاجِرَ
u'أَنَّ مُهْدَر':Predicate, #2: 2	أَنَّ الْمُهَاجِرِينَ
u'أَنَّ مَهْدِيٌّ':Predicate, #1: 1	أَنَّ الْمُهْدَرَ
u'أَنَّ مُهْرٌ':Predicate, #2: 2	أَنَّ الْمَهْدِيَّ
u'أَنَّ مَهْرٌ':Predicate, #1: 1	أَنَّ الْمُهْرَ
u'أَنَّ مَهْرٌ':Predicate, #27: 27	أَنَّ مَهْرَ
u'أَنَّ مِهْرَاسٌ':Predicate, #59: 59	أَنَّ الْمَهْرَ
u'أَنَّ مُهْلَةٌ':Predicate, #1: 1	أَنَّ الْمِهْرَاسَ
u'أَنَّ مُهْمَلٌ':Predicate, #1: 1	أَنَّ الْمُهْلَةَ
u'أَنَّ مَوَاتٌ':Predicate, #3: 3	أَنَّ الْمُهْمَلَ
u'أَنَّ موارد':Predicate, #1: 1	أَنَّ مَوَاتَ
u'أَنَّ مَوَارِدُ':Predicate, #1: 1	أَنَّ الْمَوَارِدَ
u'أَنَّ مَوَاضِعُ':Predicate, #1: 1	أَنَّ الْمَوَارِدَ
u'أَنَّ مَوَاضِعُ':Predicate, #1: 1	أَنَّ الْمَوَاضِعَ
u'أَنَّ مُوَاظَبَةٌ':Predicate, #4: 4	أَنَّ مَوَاضِعَ
u'أَنَّ مُوَاظَبَةٌ':Predicate, #1: 1	أَنَّ مُوَاظَبَةَ
u'أَنَّ مَوَاعِيدُ':Predicate, #8: 8	أَنَّ الْمُوَاظَبَةَ
u'أَنَّ مُوافاة':Predicate, #1: 1	أَنَّ الْمَوَاعِيدَ
u'أَنَّ مُوَافِقٌ':Predicate, #1: 1	أَنَّ الْمُوَافَاةَ
u'أَنَّ مُوَافَقَةٌ':Predicate, #8: 8	أَنَّ الْمُوَافِقَ
u'أَنَّ مُوالاة':Predicate, #1: 1	أَنَّ الْمُوَافَقَةَ
u'أَنَّ مُوالاة':Predicate, #1: 1	أَنَّ مُوَالَاةَ
u'أَنَّ مَوَالِي':Predicate, #8: 8	أَنَّ الْمُوَالَاةَ
u'أَنَّ مَوَالِي':Predicate, #2: 2	أَنَّ الْمَوَالِيَ
u'أَنَّ مَوْتٌ':Predicate, #4: 4	أَنَّ مَوَالِيَ
u'أَنَّ مَوْتٌ':Predicate, #11: 11	أَنَّ مَوْتَ
u'أَنَّ مُؤَثِّرٌ':Predicate, #47: 47	أَنَّ الْمَوْتَ
u'أَنَّ مُوَثَّقٌ':Predicate, #6: 6	أَنَّ الْمُؤَثِّرَ
u'أَنَّ مُوَثِّقٌ':Predicate, #2: 2	أَنَّ الْمُوَثَّقَ
u'أَنَّ مُوجَبٌ':Predicate, #2: 2	أَنَّ الْمُوَثِّقَ
u'أَنَّ مُوجِبٌ':Predicate, #14: 14	أَنَّ مُوجَبَ
u'أَنَّ مُوجِبٌ':Predicate, #25: 25	أَنَّ الْمُوجِبَ
u'أَنَّ مُوجَبٌ':Predicate, #28: 28	أَنَّ مُوجِبَ
u'أَنَّ مُوجَبٌ':Predicate, #4: 4	أَنَّ الْمُوجَبَةَ
u'أَنَّ مُؤَجَّرٌ':Predicate, #9: 9	أَنَّ الْمُوجَبَ
u'أَنَّ مُؤَجِّرٌ':Predicate, #1: 1	أَنَّ الْمُؤَجَّرَةَ
u'أَنَّ مُؤَجَّلٌ':Predicate, #4: 4	أَنَّ الْمُؤَجِّرَ
u'أَنَّ مَوْجُودٌ':Predicate, #2: 2	أَنَّ الْمُؤَجَّلَ
u'أَنَّ مُؤَخَّرٌ':Predicate, #15: 15	أَنَّ الْمَوْجُودَ
u'أَنَّ مُؤَخِّرٌ':Predicate, #1: 1	أَنَّ الْمُؤَخَّرَ
u'أَنَّ مُؤَدّاة':Predicate, #1: 1	أَنَّ الْمُؤَخِّرَ
u'أَنَّ مَوَدَّةٌ':Predicate, #1: 1	أَنَّ الْمُؤَدَّاةَ
u'أَنَّ مُودِعٌ':Predicate, #2: 2	أَنَّ الْمَوَدَّةَ
u'أَنَّ مُودِعٌ':Predicate, #16: 16	أَنَّ الْمُودِعَ
u'أَنَّ مُودَعٌ':Predicate, #1: 1	أَنَّ مُودِعَ
u'أَنَّ مُوَدِّعٌ':Predicate, #25: 25	أَنَّ الْمُودَعَ
u'أَنَّ مُودَعٌ':Predicate, #2: 2	أَنَّ الْمُوَدِّعَ
u'أَنَّ مُؤَذِّنٌ':Predicate, #4: 4	أَنَّ مُودَعَ
u'أَنَّ مُوَرِّث':Predicate, #16: 16	أَنَّ الْمُؤَذِّنَ
u'أَنَّ مُوَرِّث':Predicate, #1: 1	أَنَّ مُوَرِّثَكَ
u'أَنَّ مُؤَرِّخٌ':Predicate, #4: 4	أَنَّ الْمُوَرِّثَ
u'أَنَّ مَوْرِدٌ':Predicate, #1: 1	أَنَّ الْمُؤَرِّخِينَ
u'أَنَّ مَوْرُوثٌ':Predicate, #9: 9	أَنَّ مَوْرِدَ
u'أَنَّ مُوسِرٌ':Predicate, #4: 4	أَنَّ الْمَوْرُوثَ
u'أَنَّ مُوسِرٌ':Predicate, #1: 1	أَنَّ الْمُوسِرِينَ
u'أَنَّ مُوَسَّعٌ':Predicate, #6: 6	أَنَّ الْمُوسِرَ
u'أَنَّ مُوَسْوِسٌ':Predicate, #1: 1	أَنَّ الْمُوَسَّعَ
u'أَنَّ مَوْصُوفٌ':Predicate, #3: 3	أَنَّ الْمُوَسْوِسَ
u'أَنَّ مَوْصُوفٌ':Predicate, #1: 1	أَنَّ الْمَوْصُوفِينَ
u'أَنَّ مَوْصُولٌ':Predicate, #2: 2	أَنَّ الْمَوْصُوفَ
u'أَنَّ مُوصِي':Predicate, #3: 3	أَنَّ الْمَوْصُولَ
u'أَنَّ مَوْضِعٌ':Predicate, #22: 22	أَنَّ الْمُوصِيَ
u'أَنَّ مَوْضِعٌ':Predicate, #20: 20	أَنَّ مَوْضِعَ
u'أَنَّ مَوْضُوعٌ':Predicate, #8: 8	أَنَّ الْمَوْضِعَ
u'أَنَّ مَوْضُوعٌ':Predicate, #16: 16	أَنَّ مَوْضُوعَ
u'أَنَّ مَوْضُوعٌ':Predicate, #1: 1	أَنَّ الْمَوْضُوعَةَ
u'أَنَّ مَوْضُوعَةٌ':Predicate, #4: 4	أَنَّ الْمَوْضُوعَ
u'أَنَّ مُوَقَّتٌ':Predicate, #1: 1	أَنَّ الْمَوْضُوعَةَ
u'أَنَّ مُوَقِّرٌ':Predicate, #2: 2	أَنَّ الْمُوَقَّتَ
u'أَنَّ مُوَقَّعٌ':Predicate, #1: 1	أَنَّ الْمُوَقِّرَ
u'أَنَّ مَوْقِعٌ':Predicate, #1: 1	أَنَّ الْمُوَقَّعَ
u'أَنَّ مَوْقُوذ':Predicate, #1: 1	أَنَّ مَوْقِعَ
u'أَنَّ مَوْقُوفٌ':Predicate, #1: 1	أَنَّ الْمَوْقُوذَةَ
u'أَنَّ مَوْقُوفٌ':Predicate, #1: 1	أَنَّ الْمَوْقُوفَةَ
u'أَنَّ مُؤَكَّدٌ':Predicate, #31: 31	أَنَّ الْمَوْقُوفَ
u'أَنَّ مُؤَكِّدٌ':Predicate, #1: 1	أَنَّ الْمُؤَكَّدَ
u'أَنَّ مُوَكِّلٌ':Predicate, #1: 1	أَنَّ الْمُؤَكِّدَ
u'أَنَّ مَوْلَاةٌ':Predicate, #58: 58	أَنَّ الْمُوَكِّلَ
u'أَنَّ مَوْلَاةٌ':Predicate, #1: 1	أَنَّ مَوْلَاةَ
u'أَنَّ مَوْلِدٌ':Predicate, #1: 1	أَنَّ مَوْلاَةَ
u'آنَ مَوْلِدٌ':Subject, #2: 2	أَنَّ مَوْلِدَ
u'أَنَّ مُؤَلِّفٌ':Predicate, #1: 1	آنَ مَوْلِدُ
u'أَنَّ مُؤَلَّفٌ':Predicate, #16: 16	أَنَّ الْمُؤَلِّفَ
u'أَنَّ مَوْلُودٌ':Predicate, #1: 1	أَنَّ الْمُؤَلَّفَةَ
u'أَنَّ مُؤَمَّلٌ':Predicate, #4: 4	أَنَّ الْمَوْلُودَ
u'أَنَّ مُؤْمِنٌ':Predicate, #1: 1	أَنَّ الْمُؤَمَّلَ
u'أَنَّ مُؤْمِنٌ':Predicate, #11: 11	أَنَّ الْمُؤْمِنَ
u'أَنَّ مُؤَنٌ':Predicate, #8: 8	أَنَّ الْمُؤْمِنِينَ
u'أَنَّ مُؤَنٌ':Predicate, #1: 1	أَنَّ الْمُؤَنَ
u'أَنَّ مَوْهُوبٌ':Predicate, #1: 1	أَنَّ مُؤَنَ
u'أَنَّ مِيَاهٌ':Predicate, #15: 15	أَنَّ الْمَوْهُوبَ
u'أَنَّ مِيَاهٌ':Predicate, #1: 1	أَنَّ مِيَاهَ
u'أَنَّ مَيْتٌ':Predicate, #4: 4	أَنَّ الْمِيَاهَ
u'أَنَّ مَيْتَةٌ':Predicate, #6: 6	أَنَّ الْمَيْتَةَ
u'أَنَّ مِير':Predicate, #6: 6	أَنَّ الْمَيْتَةَ
u'أَنَّ مِيرَاثٌ':Predicate, #1: 1	أَنَّ الْمِيرَةَ
u'أَنَّ مِيرَاثٌ':Predicate, #6: 6	أَنَّ مِيرَاثَ
u'أَنَّ مِيرَة':Predicate, #8: 8	أَنَّ الْمِيرَاثَ
u'أَنَّ مِيزَابٌ':Predicate, #1: 1	أَنَّ الْمِيرَةَ
u'أَنَّ مَيْسَرَةٌ':Predicate, #3: 3	أَنَّ الْمِيزَابَ
u'أَنَّ مَيْسُورٌ':Predicate, #1: 1	أَنَّ مَيْسَرَةَ
u'أَنَّ مِيقَاتٌ':Predicate, #2: 2	أَنَّ الْمَيْسُورَ
u'أَنَّ مِيقَاتٌ':Predicate, #1: 1	أَنَّ الْمِيقَاتَ
u'أَنَّ ميل':Predicate, #5: 5	أَنَّ مِيقَاتَ
u'أَنَّ ميل':Predicate, #1: 1	أَنَّ الْمِيلَ
u'أَنَّ مِيلٌ':Predicate, #1: 1	أَنَّ الْمَيْلَ
u'أَنَّ مَيْلٌ':Predicate, #1: 1	أَنَّ الْمِيلَ
u'أَنَّ ميل':Predicate, #1: 1	أَنَّ الْمَيْلَ
u'أَنَّ مَيْلٌ':Predicate, #4: 4	أَنَّ مَيْلَ
u'أَنَّ مِيمٌ':Predicate, #4: 4	أَنَّ مَيْلَ
u'أَنَّ مَيْمُونٌ':Predicate, #2: 2	أَنَّ الْمِيمَ
u'أَنَّ نَابِتٌ':Predicate, #6: 6	أَنَّ مَيْمُونَةَ
u'أَنَّ نَاجِي':Predicate, #1: 1	أَنَّ النَّابِتَ
u'أَنَّ نَاجِي':Predicate, #1: 1	أَنَّ النَّاجِيَةَ
u'أَنَّ نَادِرٌ':Predicate, #1: 1	أَنَّ نَاجِيَةَ
u'أَنَّ ناذِر':Predicate, #1: 1	أَنَّ نَادِرَ
u'أَنَّ ناذِر':Predicate, #4: 4	أَنَّ نَاذِرَ
u'أَنَّ نَارٌ':Predicate, #8: 8	أَنَّ النَّاذِرَ
u'أَنَّ نَازِعٌ':Predicate, #9: 9	أَنَّ النَّارَ
u'أَنَّ نَازِلٌ':Predicate, #1: 1	أَنَّ النَّازِعَ
u'أَنَّ نَازِلٌ':Predicate, #1: 1	أَنَّ النَّازِلَةَ
u'أَنَّ نَازِلَةٌ':Predicate, #4: 4	أَنَّ النَّازِلَ
u'أَنَّ نَاسٌ':Predicate, #1: 1	أَنَّ النَّازِلَةَ
u'أَنَّ نَاسِخٌ':Predicate, #122: 122	أَنَّ النَّاسَ
u'أَنَّ نَاسِخ':Predicate, #8: 8	أَنَّ النَّاسِخَ
u'أَنَّ ناسِي':Predicate, #8: 8	أَنَّ النَّاسِخَ
u'أَنَّ نَاشِزٌ':Predicate, #7: 7	أَنَّ النَّاسِيَ
u'أَنَّ نَاشِزٌ':Predicate, #1: 1	أَنَّ النَّاشِزَةَ
u'أَنَّ نَاصِيَةٌ':Predicate, #3: 3	أَنَّ النَّاشِزَ
u'أَنَّ نَاطِقٌ':Predicate, #1: 1	أَنَّ النَّاصِيَةَ
u'أَنَّ نَاظِرٌ':Predicate, #2: 2	أَنَّ النَّاطِقَ
u'أَنَّ نَاظِرٌ':Predicate, #18: 18	أَنَّ النَّاظِرَ
u'أَنَّ نَاظِرٌ':Predicate, #1: 1	أَنَّ النَّاظِرِينَ
u'أَنَّ نَاعِمٌ':Predicate, #4: 4	أَنَّ نَاظِرَ
u'أَنَّ نَافِعٌ':Predicate, #1: 1	أَنَّ نَاعِمَ
u'أَنَّ نَافِلَةٌ':Predicate, #13: 13	أَنَّ نَافِعَ
u'أَنَّ نَافِي':Predicate, #4: 4	أَنَّ النَّافِلَةَ
u'أَنَّ نَاقَةٌ':Predicate, #2: 2	أَنَّ النَّافِيَ
u'أَنَّ نَاقَة':Predicate, #1: 1	أَنَّ نَاقَةَ
u'أَنَّ نَاقَةٌ':Predicate, #1: 1	أَنَّ نَاقَةَ
u'أَنَّ نَاقَة':Predicate, #3: 3	أَنَّ النَّاقَةَ
u'أَنَّ نَاقِلٌ':Predicate, #3: 3	أَنَّ النَّاقَةَ
u'أَنَّ نَاقِلٌ':Predicate, #1: 1	أَنَّ النَّاقِلَةَ
u'أَنَّ نَاقِلٌ':Predicate, #2: 2	أَنَّ نَاقِلَ
u'أَنَّ نَامُوسٌ':Predicate, #4: 4	أَنَّ النَّاقِلَ
u'أَنَّ ناوُوس':Predicate, #1: 1	أَنَّ النَّامُوسَ
u'أَنَّ نَائِبٌ':Predicate, #1: 1	أَنَّ النَّاوُوسَ
u'أَنَّ نَائِبٌ':Predicate, #4: 4	أَنَّ نَائِبَ
u'أَنَّ نَائِحٌ':Predicate, #6: 6	أَنَّ النَّائِبَ
u'أَنَّ نَائِمٌ':Predicate, #1: 1	أَنَّ النَّائِحَةَ
u'أَنَّ نَائِي':Predicate, #11: 11	أَنَّ النَّائِمَ
u'أَنَّ نبات':Predicate, #1: 1	أَنَّ النَّائِيَ
u'أَنَّ نَبَاتٌ':Predicate, #3: 3	أَنَّ النَّبَاتَ
u'أَنَّ نَبّاش':Predicate, #3: 3	أَنَّ النَّبَاتَ
u'أَنَّ نَبْذٌ':Predicate, #1: 1	أَنَّ النَّبَّاشَ
u'أَنَّ نَبْذٌ':Predicate, #1: 1	أَنَّ النَّبْذَ
u'أَنَّ نُبُوَّةٌ':Predicate, #1: 1	أَنَّ نَبْذَ
u'أَنَّ نَبِيٌّ':Predicate, #3: 3	أَنَّ النُّبُوَّةَ
u'أَنَّ نَبِيٌّ':Predicate, #2643: 2643	أَنَّ النَّبِيَّ
u'أَنَّ نَبِيذٌ':Predicate, #8: 8	أَنَّ نَبِيَّ
u'أَنَّ نَبِيذٌ':Predicate, #3: 3	أَنَّ نَبِيذَ
u'أَنَّ نَتِيجَةٌ':Predicate, #5: 5	أَنَّ النَّبِيذَ
u'أَنَّ نَجَاسَةٌ':Predicate, #2: 2	أَنَّ نَتِيجَةَ
u'أَنَّ نَجَاسَةٌ':Predicate, #20: 20	أَنَّ نَجَاسَةَ
u'أَنَّ نَجاشِيّ':Predicate, #41: 41	أَنَّ النَّجَاسَةَ
u'أَنَّ نَجْدَةٌ':Predicate, #3: 3	أَنَّ النَّجَاشِيَّ
u'أَنَّ نَجِسٌ':Predicate, #5: 5	أَنَّ نَجْدَةَ
u'أَنَّ نَجِسٌ':Predicate, #1: 1	أَنَّ النَّجِسَ
u'أَنَّ نَجَسٌ':Predicate, #1: 1	أَنَّ النَّجِسَةَ
u'أَنَّ نَجْمٌ':Predicate, #2: 2	أَنَّ النَّجَسَ
u'أَنَّ نُجُومٌ':Predicate, #1: 1	أَنَّ النَّجْمَ
u'أَنَّ نُجُومٌ':Predicate, #1: 1	أَنَّ النُّجُومَ
u'أَنَّ نُحَاةٌ':Predicate, #1: 1	أَنَّ نُجُومَ
u'أَنَّ نُحَاسٌ':Predicate, #2: 2	أَنَّ النُّحَاةَ
u'أَنَّ نَحْتٌ':Predicate, #5: 5	أَنَّ النُّحَاسَ
u'أَنَّ نَحْلٌ':Predicate, #1: 1	أَنَّ نَحْتَ
u'أَنَّ نَحْوٌ':Predicate, #7: 7	أَنَّ النَّحْلَ
u'أَنَّ نَحْوٌ':Predicate, #1: 1	أَنَّ النَّحْوَ
u'أَنَّ نَحْوِيٌّ':Predicate, #38: 38	أَنَّ نَحْوَ
u'أَنَّ نَحِيفٌ':Predicate, #1: 1	أَنَّ النَّحْوِيِّينَ
u'أَنَّ نَخَّاسٌ':Predicate, #1: 1	أَنَّ النَّحِيفَ
u'أَنَّ نُخَامَةٌ':Predicate, #2: 2	أَنَّ النَّخَّاسَ
u'أَنَّ نَخْلٌ':Predicate, #1: 1	أَنَّ النُّخَامَةَ
u'أَنَّ نَخْلٌ':Predicate, #3: 3	أَنَّ نَخْلَ
u'أَنَّ نَخِيلٌ':Predicate, #7: 7	أَنَّ النَّخْلَ
u'أَنَّ نِدَاءٌ':Predicate, #1: 1	أَنَّ النَّخِيلَ
u'أَنَّ نَدْبٌ':Predicate, #7: 7	أَنَّ النِّدَاءَ
u'أَنَّ نَدْبٌ':Predicate, #1: 1	أَنَّ نَدْبَ
u'أَنَّ ندبة':Predicate, #2: 2	أَنَّ النَّدْبَ
u'أَنَّ نُدْبَةٌ':Predicate, #1: 1	أَنَّ نُدْبَةَ
u'أَنَّ نَدَمٌ':Predicate, #1: 1	أَنَّ نُدْبَةَ
u'أَنَّ نِذَارَةٌ':Predicate, #3: 3	أَنَّ النَّدَمَ
u'أَنَّ نذر':Predicate, #1: 1	أَنَّ النِّذَارَةَ
u'أَنَّ نَذْرٌ':Predicate, #53: 53	أَنَّ النَّذْرَ
u'أَنَّ نذر':Predicate, #53: 53	أَنَّ النَّذْرَ
u'أَنَّ نَذْرٌ':Predicate, #7: 7	أَنَّ نَذْرَ
u'أَنَّ نُذُورٌ':Predicate, #7: 7	أَنَّ نَذْرَ
u'أَنَّ نزاع':Predicate, #1: 1	أَنَّ النُّذُورَ
u'أَنَّ نِزَاعٌ':Predicate, #20: 20	أَنَّ النِّزَاعَ
u'أَنَّ نَزْعٌ':Predicate, #20: 20	أَنَّ النِّزَاعَ
u'أَنَّ نَزْعٌ':Predicate, #5: 5	أَنَّ نَزْعَ
u'أَنَّ نُزُولٌ':Predicate, #8: 8	أَنَّ النَّزْعَ
u'أَنَّ نُزُولٌ':Predicate, #4: 4	أَنَّ النُّزُولَ
u'أَنَّ نِساءٌ':Predicate, #7: 7	أَنَّ نُزُولَ
u'أَنَّ نِساءٌ':Predicate, #23: 23	أَنَّ النِّسَاءَ
u'أَنَّ نِساءٌ':Subject, #8: 8	أَنَّ نِسَاءَ
u'أَنَّ نَسَّاجٌ':Predicate, #1: 1	أَنَّ النِّسَاءُ
u'أَنَّ نُسَّاخٌ':Predicate, #1: 1	أَنَّ النَّسَّاجَ
u'أَنَّ نِسَبٌ':Predicate, #1: 1	أَنَّ النُّسَّاخَ
u'أَنَّ نَسَبٌ':Predicate, #1: 1	أَنَّ النِّسَبَ
u'أَنَّ نَسَبٌ':Predicate, #32: 32	أَنَّ النَّسَبَ
u'أَنَّ نِسْبَةٌ':Predicate, #9: 9	أَنَّ نَسَبَ
u'أَنَّ نِسْبَةٌ':Predicate, #10: 10	أَنَّ نِسْبَةَ
u'أَنَّ نِسْبَةٌ':Subject, #7: 7	أَنَّ النِّسْبَةَ
u'أَنَّ نُسَخٌ':Predicate, #1: 1	أَنَّ النِّسْبَةُ
u'أَنَّ نُسَخٌ':Predicate, #2: 2	أَنَّ نُسَخَ
u'أَنَّ نسخة':Predicate, #4: 4	أَنَّ النُّسَخَ
u'أَنَّ نُسْخَةٌ':Predicate, #12: 12	أَنَّ النُّسْخَةَ
u'أَنَّ نسخة':Predicate, #12: 12	أَنَّ النُّسْخَةَ
u'أَنَّ نُسْخَةٌ':Predicate, #2: 2	أَنَّ نُسْخَةَ
u'أَنَّ نُسُكٌ':Predicate, #2: 2	أَنَّ نُسْخَةَ
u'أَنَّ نُسُكٌ':Predicate, #1: 1	أَنَّ نُسُكَ
u'أَنَّ نِسْوَةٌ':Predicate, #4: 4	أَنَّ النُّسُكَ
u'أَنَّ نِسْوَةٌ':Predicate, #1: 1	أَنَّ نِسْوَةَ
u'أَنَّ نِسْيَانٌ':Predicate, #2: 2	أَنَّ النِّسْوَةَ
u'أَنَّ نِسْيَانٌ':Predicate, #18: 18	أَنَّ النِّسْيَانَ
u'أَنَّ نشاء':Predicate, #3: 3	أَنَّ نِسْيَانَ
u'أَنَّ نُشُوزٌ':Predicate, #1: 1	أَنَّ النَّشَاءَ
u'أَنَّ نَصٌّ':Predicate, #3: 3	أَنَّ النُّشُوزَ
u'أَنَّ نَصٌّ':Predicate, #42: 42	أَنَّ النَّصَّ
u'أَنَّ نصاب':Predicate, #4: 4	أَنَّ نَصَّ
u'أَنَّ نِصَابٌ':Predicate, #11: 11	أَنَّ نِصَابَ
u'أَنَّ نصاب':Predicate, #11: 11	أَنَّ نِصَابَ
u'أَنَّ نِصَابٌ':Predicate, #12: 12	أَنَّ النِّصَابَ
u'أَنَّ نصب':Predicate, #12: 12	أَنَّ النِّصَابَ
u'أَنَّ نصب':Predicate, #2: 2	أَنَّ النَّصْبَ
u'أَنَّ نَصْبٌ':Predicate, #2: 2	أَنَّ النُّصُبَ
u'أَنَّ نُصُبٌ':Predicate, #2: 2	أَنَّ النَّصْبَ
u'أَنَّ نصب':Predicate, #2: 2	أَنَّ النُّصُبَ
u'أَنَّ نَصْبٌ':Predicate, #4: 4	أَنَّ نَصْبَ
u'أَنَّ نَصْرٌ':Predicate, #4: 4	أَنَّ نَصْبَ
u'أَنَّ نَصْرٌ':Predicate, #1: 1	أَنَّ نَصْرَ
u'أَنَّ نَصْرَانِيٌّ':Predicate, #3: 3	أَنَّ النَّصْرَ
u'أَنَّ نَصْرَانِيٌّ':Predicate, #10: 10	أَنَّ النَّصْرَانِيَّ
u'أَنَّ نَصْرَانِيٌّ':Predicate, #1: 1	أَنَّ النَّصْرَانِيَّةَ
u'أَنَّ نَصْرَانِيَّةٌ':Predicate, #1: 1	أَنَّ نَصْرَانِيَّةً
u'أَنَّ نصرة':Predicate, #1: 1	أَنَّ النَّصْرَانِيَّةَ
u'أَنَّ نُصْرَةٌ':Predicate, #1: 1	أَنَّ نُصْرَةَ
u'أَنَّ نِصْفٌ':Predicate, #1: 1	أَنَّ نُصْرَةَ
u'أَنَّ نِصْفٌ':Predicate, #21: 21	أَنَّ النِّصْفَ
u'أَنَّ نَصْلٌ':Predicate, #33: 33	أَنَّ نِصْفَ
u'أَنَّ نُصُوصٌ':Predicate, #1: 1	أَنَّ النَّصْلَ
u'أَنَّ نَصِيبٌ':Predicate, #2: 2	أَنَّ النُّصُوصَ
u'أَنَّ نَصِيبٌ':Predicate, #1: 1	أَنَّ النَّصِيبَ
u'أَنَّ نَصِيحٌ':Predicate, #39: 39	أَنَّ نَصِيبَ
u'أَنَّ نَصِيحَةٌ':Predicate, #1: 1	أَنَّ النَّصِيحَةَ
u'أَنَّ نضح':Predicate, #1: 1	أَنَّ النَّصِيحَةَ
u'أَنَّ نَضْحٌ':Predicate, #2: 2	أَنَّ النَّضْحَ
u'أَنَّ نَضِيرٌ':Predicate, #2: 2	أَنَّ النَّضْحَ
u'أَنَّ نُطْفَةٌ':Predicate, #1: 1	أَنَّ النَّضِيرَ
u'أَنَّ نُطْقٌ':Predicate, #1: 1	أَنَّ النُّطْفَةَ
u'أَنَّ نُظَّارٌ':Predicate, #1: 1	أَنَّ النُّطْقَ
u'أَنَّ نظام':Predicate, #1: 1	أَنَّ النُّظَّارَ
u'أَنَّ نِظَامٌ':Predicate, #2: 2	أَنَّ نِظَامَ
u'أَنَّ نَظَرٌ':Predicate, #2: 2	أَنَّ نِظَامَ
u'أَنَّ نَظَرٌ':Predicate, #58: 58	أَنَّ النَّظَرَ
u'أَنَّ نَظْرَةٌ':Predicate, #7: 7	أَنَّ نَظَرَ
u'أَنَّ نَظْمٌ':Predicate, #1: 1	أَنَّ النَّظْرَةَ
u'أَنَّ نَظِيرٌ':Predicate, #3: 3	أَنَّ النَّظْمَ
u'أَنَّ نَعَامَةٌ':Predicate, #1: 1	أَنَّ نَظِيرَ
u'أَنَّ نَعْلٌ':Predicate, #1: 1	أَنَّ النَّعَامَةَ
u'أَنَّ نِعَمٌ':Predicate, #1: 1	أَنَّ نَعْلَ
u'أَنَّ نَعَمٌ':Predicate, #1: 1	أَنَّ النِّعَمَ
u'أَنَّ نُعْمَانُ':Predicate, #2: 2	أَنَّ النَّعَمَ
u'أَنَّ نعمة':Predicate, #4: 4	أَنَّ النُّعْمَانَ
u'أَنَّ نِعْمَةٌ':Predicate, #1: 1	أَنَّ نِعْمَةَ
u'أَنَّ نعمة':Predicate, #1: 1	أَنَّ نِعْمَةَ
u'أَنَّ نِعْمَةٌ':Predicate, #2: 2	أَنَّ النِّعْمَةَ
u'أَنَّ نَفَادٌ':Predicate, #2: 2	أَنَّ النِّعْمَةَ
u'أَنَّ نفاذ':Predicate, #1: 1	أَنَّ النَّفَادَ
u'أَنَّ نَفَاذٌ':Predicate, #2: 2	أَنَّ نَفَاذَ
u'أَنَّ نفاس':Predicate, #2: 2	أَنَّ نَفَاذَ
u'أَنَّ نِفَاسٌ':Predicate, #7: 7	أَنَّ النِّفَاسَ
u'أَنَّ نِفَاقٌ':Predicate, #7: 7	أَنَّ النِّفَاسَ
u'أَنَّ نَفْحَةٌ':Predicate, #4: 4	أَنَّ النِّفَاقَ
u'أَنَّ نَفْخ':Predicate, #2: 2	أَنَّ النَّفْحَةَ
u'أَنَّ نفر':Predicate, #3: 3	أَنَّ النَّفْخَ
u'أَنَّ نَفَرٌ':Predicate, #1: 1	أَنَّ نَفَرَ
u'أَنَّ نَفْسٌ':Predicate, #1: 1	أَنَّ نَفَرَ
u'أَنَّ نَفْسٌ':Predicate, #25: 25	أَنَّ نَفْسَ
u'أَنَّ نُفَسَاءُ':Predicate, #53: 53	أَنَّ النَّفْسَ
u'أَنَّ نَفْضٌ':Predicate, #2: 2	أَنَّ النُّفَسَاءَ
u'أَنَّ نَفْضٌ':Predicate, #1: 1	أَنَّ النَّفْضَ
u'أَنَّ نَفْعٌ':Predicate, #1: 1	أَنَّ نَفْضَ
u'أَنَّ نَفَقَةٌ':Predicate, #1: 1	أَنَّ النَّفْعَ
u'أَنَّ نَفَقَةٌ':Predicate, #44: 44	أَنَّ نَفَقَةَ
u'أَنَّ نَفَلٌ':Predicate, #61: 61	أَنَّ النَّفَقَةَ
u'أَنَّ نَفْلٌ':Predicate, #14: 14	أَنَّ النَّفَلَ
u'أَنَّ نَفَلٌ':Predicate, #1: 1	أَنَّ النَّفْلَ
u'أَنَّ نَفْلٌ':Predicate, #1: 1	أَنَّ نَفَلَ
u'أَنَّ نُفُوذٌ':Predicate, #9: 9	أَنَّ نَفْلَ
u'أَنَّ نُفُوذٌ':Predicate, #1: 1	أَنَّ النُّفُوذَ
u'أَنَّ نُفُوسٌ':Predicate, #2: 2	أَنَّ نُفُوذَ
u'أَنَّ نَفْيٌ':Predicate, #6: 6	أَنَّ النُّفُوسَ
u'أَنَّ نَفْيٌ':Predicate, #26: 26	أَنَّ نَفْيَ
u'أَنَّ نِقَابٌ':Predicate, #27: 27	أَنَّ النَّفْيَ
u'أَنَّ نَقَّادٌ':Predicate, #2: 2	أَنَّ النِّقَابَ
u'أَنَّ نَقْبٌ':Predicate, #1: 1	أَنَّ النَّقَّادَ
u'أَنَّ نَقْدٌ':Predicate, #1: 1	أَنَّ النَّقْبَ
u'أَنَّ نَقْد':Predicate, #1: 1	أَنَّ نَقْدَ
u'أَنَّ نَقْدٌ':Predicate, #1: 1	أَنَّ نَقْدَ
u'أَنَّ نَقْد':Predicate, #6: 6	أَنَّ النَّقْدَ
u'أَنَّ نقرة':Predicate, #6: 6	أَنَّ النَّقْدَ
u'أَنَّ نُقْرَةٌ':Predicate, #2: 2	أَنَّ النُّقْرَةَ
u'أَنَّ نَقْشٌ':Predicate, #2: 2	أَنَّ النُّقْرَةَ
u'أَنَّ نَقْصٌ':Predicate, #2: 2	أَنَّ نَقْشَ
u'أَنَّ نَقْصٌ':Predicate, #12: 12	أَنَّ النَّقْصَ
u'أَنَّ نُقْصَانٌ':Predicate, #6: 6	أَنَّ نَقْصَ
u'أَنَّ نُقْصَانٌ':Predicate, #14: 14	أَنَّ النُّقْصَانَ
u'أَنَّ نَقْضٌ':Predicate, #8: 8	أَنَّ نُقْصَانَ
u'أَنَّ نَقْضٌ':Predicate, #12: 12	أَنَّ النَّقْضَ
u'أَنَّ نقل':Predicate, #7: 7	أَنَّ نَقْضَ
u'أَنَّ نَقْلٌ':Predicate, #10: 10	أَنَّ النَّقْلَ
u'أَنَّ نقل':Predicate, #10: 10	أَنَّ النَّقْلَ
u'أَنَّ نَقْلٌ':Predicate, #13: 13	أَنَّ نَقْلَ
u'أَنَّ نقلة':Predicate, #13: 13	أَنَّ نَقْلَ
u'أَنَّ نُقُودٌ':Predicate, #1: 1	أَنَّ النَّقْلَةَ
u'أَنَّ نَقِيضٌ':Predicate, #7: 7	أَنَّ النُّقُودَ
u'أَنَّ نكاح':Predicate, #3: 3	أَنَّ نَقِيضَ
u'أَنَّ نِكَاحٌ':Predicate, #168: 168	أَنَّ النِّكَاحَ
u'أَنَّ نكاح':Predicate, #168: 168	أَنَّ النِّكَاحَ
u'أَنَّ نِكَاحٌ':Predicate, #2: 2	أَنَّ نِكَاحَهُنَّ
u'أَنَّ نكاح':Predicate, #2: 2	أَنَّ نِكَاحَهُنَّ
u'أَنَّ نِكَاحٌ':Predicate, #42: 42	أَنَّ نِكَاحَ
u'أَنَّ نُكْتَةٌ':Predicate, #42: 42	أَنَّ نِكَاحَ
u'أَنَّ نَكِرٌ':Predicate, #1: 1	أَنَّ نُكْتَةَ
u'أَنَّ نكرة':Predicate, #14: 14	أَنَّ النَّكِرَةَ
u'أَنَّ نَكِرَةٌ':Predicate, #14: 14	أَنَّ النَّكِرَةَ
u'أَنَّ نُكُولٌ':Predicate, #14: 14	أَنَّ النَّكِرَةَ
u'أَنَّ نُكُولٌ':Predicate, #11: 11	أَنَّ النُّكُولَ
u'أَنَّ نَمَاءٌ':Predicate, #1: 1	أَنَّ نُكُولَ
u'أَنَّ نَمَاءٌ':Predicate, #12: 12	أَنَّ النَّمَاءَ
u'أَنَّ نَمَّامٌ':Predicate, #4: 4	أَنَّ نَمَاءَ
u'أَنَّ نَهار':Predicate, #2: 2	أَنَّ النَّمَّامَ
u'أَنَّ نهار':Predicate, #2: 2	أَنَّ النَّهَارِيَّةَ
u'أَنَّ نَهَارٌ':Predicate, #5: 5	أَنَّ النَّهَارَ
u'أَنَّ نَهارِيّ':Predicate, #5: 5	أَنَّ النَّهَارَ
u'أَنَّ نُهْبَةٌ':Predicate, #2: 2	أَنَّ النَّهَارِيَّةَ
u'أَنَّ نَهْرٌ':Predicate, #1: 1	أَنَّ النُّهْبَةَ
u'أَنَّ نَهْيٌ':Predicate, #16: 16	أَنَّ النَّهْرَ
u'أَنَّ نَهْيٌ':Predicate, #125: 125	أَنَّ النَّهْيَ
u'أَنَّ نَوْءٌ':Predicate, #2: 2	أَنَّ نَهْيَ
u'أَنَّ نَوَاجِذُ':Predicate, #6: 6	أَنَّ النَّوْءَ
u'أَنَّ نواحي':Predicate, #1: 1	أَنَّ النَّوَاجِذَ
u'أَنَّ نَوَاحِي':Predicate, #1: 1	أَنَّ نَوَاحِيَ
u'أَنَّ نَوَافِلُ':Predicate, #1: 1	أَنَّ نَوَاحِيَ
u'أَنَّ نواقص':Predicate, #3: 3	أَنَّ النَّوَافِلَ
u'أَنَّ نَوْبَةٌ':Predicate, #3: 3	أَنَّ النَّوَاقِصَ
u'أَنَّ نُورٌ':Predicate, #4: 4	أَنَّ النَّوْبَةَ
u'أَنَّ نَوْعٌ':Predicate, #1: 1	أَنَّ نُورَ
u'أَنَّ نَوْعٌ':Predicate, #1: 1	أَنَّ نَوْعَ
u'أَنَّ نَوْفَلٌ':Predicate, #2: 2	أَنَّ النَّوْعَ
u'أَنَّ نَوْمٌ':Predicate, #1: 1	أَنَّ نَوْفَلَ
u'أَنَّ نَوْمٌ':Predicate, #11: 11	أَنَّ نَوْمَ
u'أَنَّ نَوَوِيٌّ':Predicate, #16: 16	أَنَّ النَّوْمَ
u'أَنَّ نِيَابَةٌ':Predicate, #18: 18	أَنَّ النَّوَوِيَّ
u'أَنَّ نِيَّةٌ':Predicate, #2: 2	أَنَّ النِّيَابَةَ
u'أَنَّ نِيَّةٌ':Predicate, #56: 56	أَنَّ النِّيَّةَ
u'أَنَّ هاء':Predicate, #62: 62	أَنَّ نِيَّةَ
u'إنْهَاءٌ إِعادَةٌ':Added, #3: 3	أَنَّ الْهَاءَ
u'إنْهَاءٌ أَمْرٌ':Added, #1: 1	إنْهَاءِ الْإِعَادَةِ
u'إنْهَاءٌ حاكِمٌ':Added, #1: 1	إنْهَاءَ الْأَمْرِ
u'إنْهَاءٌ حالٌ':Added, #1: 1	إنْهَاءِ الْحَاكِمِ
u'إنْهَاءٌ حُرْمَةٌ':Added, #1: 1	إنْهَاءُ الْحَالِ
u'إنْهَاءٌ حُكْمٌ':Added, #2: 2	إنْهَاءِ الْحُرْمَةِ
u'إنْهَاءٌ حُكْمٌ':Added, #1: 1	إنْهَاءِ الْحُكْمِ
u'إنْهَاءٌ خَبَرٌ':Added, #2: 2	إنْهَاءَ الْحُكْمِ
u'إنْهَاءٌ خَبَر':Added, #1: 1	إنْهَاءُ الْخَبَرِ
u'إنْهَاءٌ خُصُومَةٌ':Added, #1: 1	إنْهَاءُ الْخَبَرِ
u'إنْهَاءٌ شُغُور':Added, #1: 1	إنْهَاءُ الْخُصُومَةِ
u'إنْهَاءٌ صَاحِبٌ':Added, #1: 1	إنْهَاءِ الشُّغُورِ
u'إنْهَاءٌ مِلْكٌ':Added, #1: 1	إنْهَاءَ صَاحِبِ
u'إنْهَاءٌ مُنْكَرٌ':Added, #4: 4	إنْهَاءُ الْمِلْكِ
u'أَنَّ هَادِمٌ':Predicate, #1: 1	إنْهَاءِ الْمُنْكَرِ
u'أَنْهَارٌ إِجَادَةٌ':Added, #1: 1	أَنَّ هَادِمَ
u'أَنْهَارٌ أعاجم':Added, #1: 1	أَنْهَارِ الْإِجَادَةِ
u'أَنَّ هَارِبٌ':Predicate, #1: 1	أَنْهَارِ الْأَعَاجِمِ
u'أَنْهَارٌ جَنَّةٌ':Added, #2: 2	أَنَّ الْهَارِبَ
u'أَنْهَارٌ جَنَّةٌ':Added, #12: 12	أَنْهَارِ الْجَنَّةِ
u'أَنْهَارٌ جَنَّةٌ':Added, #2: 2	أَنْهَارَ الْجَنّةِ
u'أَنْهَارٌ جَنَّةٌ':Added, #4: 4	أَنْهَارُ الْجَنَّةِ
u'أَنْهَارٌ خراج':Added, #5: 5	أَنْهَارَ الْجَنَّةِ
u'أَنْهَارٌ خَرَاجٌ':Added, #1: 1	أَنْهَارِ الْخَرَاجِ
u'أَنْهَارٌ شركاء':Added, #1: 1	أَنْهَارِ الْخَرَاجِ
u'أَنْهَارٌ عَامٌّ':Added, #1: 1	أَنْهَارَ الشُّرَكَاءِ
u'أَنَّ هَازِلٌ':Predicate, #1: 1	أَنْهَارِ الْعَامَّةِ
u'أَنَّ هَاشِمٌ':Predicate, #3: 3	أَنَّ الْهَازِلَ
u'أَنَّ هَالِكٌ':Predicate, #1: 1	أَنَّ الْهَاشِمَةَ
u'أَنَّ هَانِئٌ':Predicate, #1: 1	أَنَّ الْهَالِكَ
u'أَنَّ هَائِمٌ':Predicate, #2: 2	أَنَّ هَانِئَ
u'أَنَّ هِبَةٌ':Predicate, #2: 2	أَنَّ الْهَائِمَ
u'أَنَّ هِبَةٌ':Predicate, #17: 17	أَنَّ هِبَةَ
u'أَنَّ هَتْكٌ':Predicate, #56: 56	أَنَّ الْهِبَةَ
u'أَنَّ هتماء':Predicate, #2: 2	أَنَّ هَتْكَ
u'أَنَّ هِجَاءٌ':Predicate, #1: 1	أَنَّ الْهَتْمَاءَ
u'أَنَّ هجر':Predicate, #1: 1	أَنَّ هِجَاءَ
u'أَنَّ هَجْرٌ':Predicate, #1: 1	أَنَّ الْهَجْرَ
u'أَنَّ هجرة':Predicate, #1: 1	أَنَّ الْهَجْرَ
u'أَنَّ هِجْرَةٌ':Predicate, #3: 3	أَنَّ الْهِجْرَةَ
u'أَنَّ هُجُومٌ':Predicate, #3: 3	أَنَّ الْهِجْرَةَ
u'أَنَّ هَدَايَا':Subject, #1: 1	أَنَّ هُجُومَ
u'أَنَّ هِدَايَةٌ':Predicate, #2: 2	أَنَّ هَدَايَاهُ
u'أَنَّ هُدْبَةٌ':Predicate, #1: 1	أَنَّ الْهِدَايَةَ
u'أَنَّ هَدْمٌ':Predicate, #1: 1	أَنَّ هُدْبَةَ
u'أَنَّ هَدْمٌ':Predicate, #1: 1	أَنَّ الْهَدْمَ
u'أَنَّ هُدْنَةٌ':Predicate, #2: 2	أَنَّ هَدْمَ
u'أَنَّ هُدْهُدٌ':Predicate, #1: 1	أَنَّ الْهُدْنَةَ
u'أَنَّ هَدِيٌّ':Predicate, #1: 1	أَنَّ الْهُدْهُدَ
u'أَنَّ هَدْيٌ':Predicate, #5: 5	أَنَّ الْهَدِيَّةَ
u'أَنَّ هَدْيٌ':Predicate, #5: 5	أَنَّ هَدْيَ
u'أَنَّ هَدِيَّةٌ':Predicate, #6: 6	أَنَّ الْهَدْيَ
u'أَنَّ هِرٌّ':Predicate, #5: 5	أَنَّ الْهَدِيَّةَ
u'أَنَّ هِرٌّ':Predicate, #1: 1	أَنَّ الْهِرَّ
u'أَنَّ هِرٌّ':Predicate, #2: 2	أَنَّ هِرَّةً
u'أَنْهَرَ دَمٌ':Predicate, #7: 7	أَنَّ الْهِرَّةَ
u'أَنَّ هَرِمٌ':Predicate, #30: 30	أَنْهَرَ الدَّمَ
u'أَنَّ هَرِمٌ':Predicate, #1: 1	أَنَّ الْهَرِمَ
u'أَنَّ هُرُوبٌ':Predicate, #1: 1	أَنَّ هَرِمَ
u'أَنَّ هَرَوِيّ':Predicate, #1: 1	أَنَّ الْهُرُوبَ
u'أَنَّ هزال':Predicate, #1: 1	أَنَّ الْهَرَوِيَّ
u'أَنَّ هُزَالٌ':Predicate, #1: 1	أَنَّ الْهُزَالَ
u'أَنَّ هَزْلٌ':Predicate, #1: 1	أَنَّ الْهُزَالَ
u'أَنَّ هَزْلٌ':Predicate, #1: 1	أَنَّ هَزْلَ
u'أَنَّ هشام':Predicate, #5: 5	أَنَّ الْهَزْلَ
u'أَنَّ هِشَامٌ':Predicate, #10: 10	أَنَّ هِشَامَ
u'أَنَّ هلاك':Predicate, #10: 10	أَنَّ هِشَامَ
u'أَنَّ هَلاَكٌ':Predicate, #3: 3	أَنَّ الْهَلَاكَ
u'أَنَّ هلاك':Predicate, #3: 3	أَنَّ الْهَلَاكَ
u'أَنَّ هَلاَكٌ':Predicate, #9: 9	أَنَّ هَلَاكَ
u'أَنَّ هِلاَلٌ':Predicate, #9: 9	أَنَّ هَلَاكَ
u'أَنَّ هِلاَلٌ':Predicate, #10: 10	أَنَّ الْهِلَالَ
u'أَنَّ هِلاَلٌ':Predicate, #2: 2	أَنَّ هِلالَ
u'أَنَّ هِلاَلٌ':Predicate, #3: 3	أَنَّ هِلاَلَ
u'أَنَّ هِلاَلِيَّةٌ':Predicate, #4: 4	أَنَّ هِلَالَ
u'أَنَّ هَمٌّ':Predicate, #1: 1	أَنَّ الْهِلَالِيَّةَ
u'أَنَّ هِمَّةٌ':Predicate, #1: 1	أَنَّ الْهَمَّ
u'أَنَّ هِمَّةٌ':Predicate, #1: 1	أَنَّ الْهِمَّةَ
u'أَنَّ هَمْزٌ':Predicate, #1: 1	أَنَّ هِمَّةَ
u'أَنَّ همزة':Predicate, #1: 1	أَنَّ الْهَمْزَ
u'أَنَّ هَمْزَةٌ':Predicate, #3: 3	أَنَّ الْهَمْزَةَ
u'أَنَّ هِنْدٌ':Predicate, #3: 3	أَنَّ الْهَمْزَةَ
u'أَنْهَى أحَدٌ':Subject, #3: 3	أَنَّ هِنْدَ
u'أَنْهَى تَكْبِير':Predicate, #1: 1	أَنْهَى أَحَدُ
u'أَنَّ هَيْكَلٌ':Predicate, #1: 1	أَنْهَى تَكْبِيرَةَ
u'أَنْهَى كَلاَمٌ':Predicate, #1: 1	أَنَّ الْهَيْكَلَ
u'أَنَّ هَيِّنٌ':Predicate, #3: 3	أَنْهَى الْكَلَامَ
u'أَنْهَى نَاسٌ':Predicate, #1: 1	أَنَّ الْهَيِّنَ
u'أَنَّ هَيْئَةٌ':Predicate, #3: 3	أَنْهَى النَّاسَ
u'أَنَّ هَيْئَةٌ':Predicate, #2: 2	أَنَّ الْهَيْئَةَ
u'أنْوَاءٌ جَوْزَاءُ':Added, #3: 3	أَنَّ هَيْئَةَ
u'أَنْوَاءٌ جَوْزَاءُ':Added, #1: 1	أَنْوَاءِ الْجَوْزَاءِ
u'أنْوَاءٌ نُجُومٌ':Added, #1: 1	أَنْوَاءِ الْجَوْزَاءِ
u'أَنْوَاءٌ نُجُومٌ':Added, #1: 1	أَنْوَاءَ النّجُومِ
u'أَنَّ وَاثِقٌ':Predicate, #1: 1	أَنْوَاءَ النّجُومِ
u'أَنَّ وَاجِبٌ':Predicate, #2: 2	أَنَّ الْوَاثِقَ
u'أَنَّ وَاجِبٌ':Predicate, #1: 1	أَنَّ الْوَاجِبَةَ
u'أَنَّ وَاجِبٌ':Predicate, #200: 200	أَنَّ الْوَاجِبَ
u'أَنَّ وَاجِدٌ':Predicate, #3: 3	أَنَّ وَاجِبَ
u'أَنَّ وَاجِدٌ':Predicate, #1: 1	أَنَّ الْوَاجِدَ
u'أَنَّ واحد':Predicate, #1: 1	أَنَّ وَاجِدَ
u'أَنَّ وَاحِدٌ':Predicate, #33: 33	أَنَّ الْوَاحِدَ
u'أَنَّ واحد':Predicate, #33: 33	أَنَّ الْوَاحِدَ
u'أَنَّ وَاحِدٌ':Predicate, #6: 6	أَنَّ وَاحِدَةً
u'أَنَّ واحد':Predicate, #6: 6	أَنَّ وَاحِدَةً
u'أَنَّ وَاحِدٌ':Predicate, #7: 7	أَنَّ الْوَاحِدَةَ
u'أَنَّ وَادِي':Predicate, #7: 7	أَنَّ الْوَاحِدَةَ
u'أَنَّ وَارِثٌ':Predicate, #1: 1	أَنَّ الْوَادِيَ
u'أَنَّ وَارِثٌ':Predicate, #1: 1	أَنَّ الْوَارِثِينَ
u'أَنَّ وَارِثٌ':Predicate, #37: 37	أَنَّ الْوَارِثَ
u'أَنَّ وَارِدٌ':Predicate, #8: 8	أَنَّ وَارِثَ
u'أَنَّ وَارِدٌ':Predicate, #2: 2	أَنَّ الْوَارِدِينَ
u'أَنَّ وَازِعٌ':Predicate, #3: 3	أَنَّ الْوَارِدَ
u'أَنَّ وَازِعٌ':Predicate, #1: 1	أَنَّ الْوَازِعَ
u'أَنَّ وَاسِطٌ':Predicate, #1: 1	أَنَّ وَازِعَ
u'أَنَّ وَاسِعٌ':Predicate, #4: 4	أَنَّ الْوَاسِطَةَ
u'أَنَّ وَاصِلٌ':Predicate, #3: 3	أَنَّ وَاسِعَ
u'أَنَّ وَاصِلٌ':Predicate, #1: 1	أَنَّ الْوَاصِلَ
u'أَنَّ وَاضِعٌ':Predicate, #1: 1	أَنَّ الْوَاصِلَةَ
u'أَنَّ وَاضِعٌ':Predicate, #3: 3	أَنَّ وَاضِعَ
u'أَنَّ وَاطِئٌ':Predicate, #4: 4	أَنَّ الْوَاضِعَ
u'أَنَّ وَاعِظٌ':Predicate, #1: 1	أَنَّ الْوَاطِئَ
u'أَنَّ وَاقِعٌ':Predicate, #1: 1	أَنَّ الْوَاعِظَ
u'أَنَّ وَاقِعٌ':Predicate, #28: 28	أَنَّ الْوَاقِعَ
u'أَنَّ وَاقِعٌ':Predicate, #2: 2	أَنَّ الْوَاقِعَةَ
u'أَنَّ وَاقِعَةٌ':Predicate, #2: 2	أَنَّ وَاقِعَةَ
u'أَنَّ وَاقِعَةٌ':Predicate, #2: 2	أَنَّ الْوَاقِعَةَ
u'أَنَّ وَاقِفٌ':Predicate, #2: 2	أَنَّ وَاقِعَةَ
u'أَنَّ واقِف':Predicate, #1: 1	أَنَّ الْوَاقِفَةَ
u'أَنَّ وَاقِفٌ':Predicate, #1: 1	أَنَّ الْوَاقِفِيَّةَ
u'أَنَّ وَاقِفٌ':Predicate, #1: 1	أَنَّ الْوَاقِفِينَ
u'أَنَّ وَاقِفٌ':Predicate, #1: 1	أَنَّ وَاقِفَ
u'أَنَّ وَالِدٌ':Predicate, #52: 52	أَنَّ الْوَاقِفَ
u'أَنَّ وَالِدٌ':Predicate, #1: 1	أَنَّ وَالِدَةَ
u'أَنَّ وَالِدٌ':Predicate, #4: 4	أَنَّ الْوَالِدَ
u'أَنَّ وَالِي':Predicate, #5: 5	أَنَّ وَالِدَ
u'أَنَّ وَاهِبٌ':Predicate, #2: 2	أَنَّ الْوَالِيَ
u'أَنَّ وَاهِبٌ':Predicate, #16: 16	أَنَّ الْوَاهِبَ
u'أَنَّ وَبَاءٌ':Predicate, #1: 1	أَنَّ وَاهِبَ
u'أَنَّ وَبَاءٌ':Predicate, #1: 1	أَنَّ وَبَاءَ
u'أَنَّ وبر':Predicate, #3: 3	أَنَّ الْوَبَاءَ
u'أَنَّ وَبَرٌ':Predicate, #1: 1	أَنَّ وَبَرَ
u'أَنَّ وَتْرٌ':Predicate, #1: 1	أَنَّ وَبَرَ
u'أَنَّ وَثَنِيٌّ':Predicate, #1: 1	أَنَّ الْوَتْرَ
u'أَنَّ وَثِيقٌ':Predicate, #2: 2	أَنَّ الْوَثَنِيَّ
u'أَنَّ وُجْدٌ':Predicate, #1: 1	أَنَّ الْوَثِيقَةَ
u'أَنَّ وَجْهٌ':Predicate, #1: 1	أَنَّ الْوُجْدَ
u'أَنَّ وَجْهٌ':Predicate, #15: 15	أَنَّ وَجْهَ
u'أَنَّ وِجْهَةٌ':Predicate, #35: 35	أَنَّ الْوَجْهَ
u'أَنَّ وُجُوبٌ':Predicate, #1: 1	أَنَّ الْوِجْهَةَ
u'أَنَّ وُجُوبٌ':Predicate, #67: 67	أَنَّ الْوُجُوبَ
u'أَنَّ وُجُودٌ':Predicate, #87: 87	أَنَّ وُجُوبَ
u'أَنَّ وُجُودٌ':Predicate, #33: 33	أَنَّ وُجُودَ
u'أَنَّ وُجُودِيٌّ':Predicate, #3: 3	أَنَّ الْوُجُودَ
u'أَنَّ وُجُوهٌ':Predicate, #1: 1	أَنَّ الْوُجُودِيَّ
u'أَنَّ وُجُوهٌ':Predicate, #1: 1	أَنَّ وُجُوهَ
u'أَنَّ وَجِيهٌ':Predicate, #2: 2	أَنَّ الْوُجُوهَ
u'أَنَّ وَحْدَةٌ':Predicate, #1: 1	أَنَّ وَجِيهَ
u'أَنَّ وُحُوشٌ':Predicate, #1: 1	أَنَّ الْوَحْدَةَ
u'أَنَّ وَحْيٌ':Predicate, #1: 1	أَنَّ الْوُحُوشَ
u'أَنَّ وَدِيعٌ':Predicate, #3: 3	أَنَّ الْوَحْيَ
u'أَنَّ وَدِيعٌ':Predicate, #16: 16	أَنَّ الْوَدِيعَةَ
u'أَنَّ وَدِيعَةٌ':Predicate, #1: 1	أَنَّ الْوَدِيعَ
u'أَنَّ وَراء':Predicate, #16: 16	أَنَّ الْوَدِيعَةَ
u'أَنَّ وِرَاثَةٌ':Predicate, #1: 1	أَنَّ وَرَاءَ
u'أَنَّ وَرَثَةٌ':Predicate, #3: 3	أَنَّ الْوِرَاثَةَ
u'أَنَّ وَرَثَةٌ':Predicate, #1: 1	أَنَّ وَرَثَةَ
u'أَنَّ وَرَثَةٌ':Predicate, #1: 1	أَنَّ وَرَثَتَهُنَّ
u'أَنَّ وَرْدٌ':Predicate, #26: 26	أَنَّ الْوَرَثَةَ
u'أَنَّ وَرَعٌ':Predicate, #1: 1	أَنَّ الْوَرْدَ
u'أَنَّ وَرَمٌ':Predicate, #4: 4	أَنَّ الْوَرَعَ
u'أَنَّ وُرُودٌ':Predicate, #1: 1	أَنَّ الْوَرَمَ
u'أَنَّ وُرُودٌ':Predicate, #1: 1	أَنَّ الْوُرُودَ
u'أَنَّ وزان':Predicate, #4: 4	أَنَّ وُرُودَ
u'أَنَّ وَزَغٌ':Predicate, #1: 1	أَنَّ وِزَانَ
u'أَنَّ وَزَغَةٌ':Predicate, #1: 1	أَنَّ الْوَزَغَ
u'أَنَّ وَزْنٌ':Predicate, #1: 1	أَنَّ الْوَزَغَةَ
u'أَنَّ وَزْنٌ':Predicate, #7: 7	أَنَّ الْوَزْنَ
u'أَنَّ وَزِيرٌ':Predicate, #8: 8	أَنَّ وَزْنَ
u'أَنَّ وسط':Predicate, #1: 1	أَنَّ وَزِيرَ
u'أَنَّ وَسَطٌ':Predicate, #5: 5	أَنَّ الْوَسَطَ
u'أَنَّ وَسْمٌ':Predicate, #5: 5	أَنَّ الْوَسَطَ
u'أَنَّ وَسْوَسَةٌ':Predicate, #2: 2	أَنَّ الْوَسْمَ
u'أَنَّ وَسِيلَةٌ':Predicate, #2: 2	أَنَّ الْوَسْوَسَةَ
u'أَنَّ وَشْمٌ':Predicate, #1: 1	أَنَّ الْوَسِيلَةَ
u'أَنَّ وصال':Predicate, #1: 1	أَنَّ الْوَشْمَ
u'أَنَّ وِصَالٌ':Predicate, #2: 2	أَنَّ الْوِصَالَ
u'أَنَّ وِصَايَةٌ':Predicate, #2: 2	أَنَّ الْوِصَالَ
u'أَنَّ وَصْفٌ':Predicate, #8: 8	أَنَّ الْوِصَايَةَ
u'أَنَّ وَصْفٌ':Predicate, #14: 14	أَنَّ وَصْفَ
u'أَنَّ وصل':Predicate, #47: 47	أَنَّ الْوَصْفَ
u'أَنَّ وَصْلٌ':Predicate, #1: 1	أَنَّ وَصْلَ
u'أَنَّ وصل':Predicate, #1: 1	أَنَّ وَصْلَ
u'أَنَّ وَصْلٌ':Predicate, #2: 2	أَنَّ الْوَصْلَ
u'أَنَّ وُصُولٌ':Predicate, #2: 2	أَنَّ الْوَصْلَ
u'أَنَّ وَصِيٌّ':Predicate, #2: 2	أَنَّ الْوُصُولَ
u'أَنَّ وَصِيٌّ':Predicate, #144: 144	أَنَّ الْوَصِيَّةَ
u'أَنَّ وَصِيٌّ':Predicate, #4: 4	أَنَّ وَصِيَّةَ
u'أَنَّ وَصِيٌّ':Predicate, #68: 68	أَنَّ الْوَصِيَّ
u'أَنَّ وَصِيَّةٌ':Predicate, #7: 7	أَنَّ وَصِيَّ
u'أَنَّ وَصِيَّةٌ':Predicate, #144: 144	أَنَّ الْوَصِيَّةَ
u'أَنَّ وَضْعٌ':Predicate, #4: 4	أَنَّ وَصِيَّةَ
u'أَنَّ وَضْعٌ':Predicate, #13: 13	أَنَّ الْوَضْعَ
u'أَنَّ وُضُوءٌ':Predicate, #32: 32	أَنَّ وَضْعَ
u'أَنَّ وُضُوءٌ':Predicate, #1: 1	أَنَّ وُضُوءَ
u'أَنَّ وَضِيعٌ':Predicate, #44: 44	أَنَّ الْوُضُوءَ
u'أَنَّ وَطْءٌ':Predicate, #1: 1	أَنَّ الْوَضِيعَةَ
u'أَنَّ وَطْءٌ':Predicate, #19: 19	أَنَّ وَطْءَ
u'أَنَّ وَطَنٌ':Predicate, #68: 68	أَنَّ الْوَطْءَ
u'أَنَّ وَطَنٌ':Predicate, #3: 3	أَنَّ الْوَطَنَ
u'أَنَّ وَطْوَاطٌ':Predicate, #3: 3	أَنَّ وَطَنَ
u'أَنَّ وَظَائِفُ':Predicate, #1: 1	أَنَّ الْوَطْوَاطَ
u'أَنَّ وَظِيفٌ':Predicate, #1: 1	أَنَّ الْوَظَائِفَ
u'أَنَّ وَظِيفٌ':Predicate, #1: 1	أَنَّ وَظِيفَةَ
u'أَنَّ وَظِيفَةٌ':Predicate, #3: 3	أَنَّ الْوَظِيفَةَ
u'أَنَّ وَظِيفَةٌ':Predicate, #1: 1	أَنَّ وَظِيفَةَ
u'أَنَّ وَعْدٌ':Predicate, #3: 3	أَنَّ الْوَظِيفَةَ
u'أَنَّ وَعْظٌ':Predicate, #1: 1	أَنَّ الْوَعْدَ
u'أَنَّ وَعِيدٌ':Predicate, #1: 1	أَنَّ الْوَعْظَ
u'أَنَّ وَفَاءٌ':Predicate, #5: 5	أَنَّ الْوَعِيدَ
u'أَنَّ وَفَاءٌ':Predicate, #1: 1	أَنَّ وَفَاءَ
u'أَنَّ وَفْدٌ':Predicate, #6: 6	أَنَّ الْوَفَاءَ
u'أَنَّ وقاع':Predicate, #16: 16	أَنَّ وَفْدَ
u'أَنَّ وَقَائِعُ':Predicate, #1: 1	أَنَّ الْوِقَاعَ
u'أَنَّ وَقْتٌ':Predicate, #2: 2	أَنَّ الْوَقَائِعَ
u'أَنَّ وَقْت':Predicate, #25: 25	أَنَّ الْوَقْتَ
u'أَنَّ وَقْتٌ':Predicate, #2: 2	أَنَّ الْوَقْتِيَّةَ
u'أَنَّ وَقْتِيّ':Predicate, #52: 52	أَنَّ وَقْتَ
u'أَنَّ وَقَص':Predicate, #2: 2	أَنَّ الْوَقْتِيَّةَ
u'أَنَّ وَقْف':Predicate, #1: 1	أَنَّ الْوَقَصَ
u'أَنَّ وَقْفٌ':Predicate, #1: 1	أَنَّ الْوَقْفِيَّةَ
u'أَنَّ وَقْفٌ':Predicate, #75: 75	أَنَّ الْوَقْفَ
u'أَنَّ وقفة':Predicate, #8: 8	أَنَّ وَقْفَ
u'أَنَّ وَقْفَةٌ':Predicate, #1: 1	أَنَّ الْوَقْفَةَ
u'أَنَّ وَقْفَة':Predicate, #1: 1	أَنَّ الْوَقْفَةَ
u'أَنَّ وَقْفِيّ':Predicate, #1: 1	أَنَّ الْوَقْفِيَّةَ
u'أَنَّ وَقْفِيَّة':Predicate, #1: 1	أَنَّ الْوَقْفِيَّةَ
u'أَنَّ وُقُوعٌ':Predicate, #1: 1	أَنَّ الْوَقْفِيَّةَ
u'أَنَّ وُقُوعٌ':Predicate, #15: 15	أَنَّ الْوُقُوعَ
u'أَنَّ وُقُوفٌ':Predicate, #15: 15	أَنَّ وُقُوعَ
u'أَنَّ وُقُوفٌ':Predicate, #10: 10	أَنَّ الْوُقُوفَ
u'أَنَّ وَقِيعٌ':Predicate, #3: 3	أَنَّ وُقُوفَ
u'أَنَّ وَقِيعَةٌ':Predicate, #1: 1	أَنَّ الْوَقِيعَةَ
u'أَنَّ وِكَالَةٌ':Predicate, #1: 1	أَنَّ الْوَقِيعَةَ
u'أَنَّ وَكْز':Predicate, #1: 1	أَنَّ الْوِكَالَةَ
u'أَنَّ وَكِيلٌ':Predicate, #1: 1	أَنَّ الْوَكْزَ
u'أَنَّ وَكِيلٌ':Predicate, #12: 12	أَنَّ وَكِيلَ
u'أَنَّ وَلاَءٌ':Predicate, #159: 159	أَنَّ الْوَكِيلَ
u'أَنَّ وَلاَءٌ':Predicate, #14: 14	أَنَّ وَلَاءَ
u'أَنَّ وَلاَءٌ':Predicate, #1: 1	أَنَّ الْوَلاءَ
u'أَنَّ وَلاَءٌ':Predicate, #3: 3	أَنَّ الْوَلاَءَ
u'أَنَّ وُلاَةٌ':Predicate, #40: 40	أَنَّ الْوَلَاءَ
u'أَنَّ وِلاَدَةٌ':Predicate, #2: 2	أَنَّ الْوُلَاةَ
u'أَنَّ وِلاَدَةٌ':Predicate, #4: 4	أَنَّ وِلَادَةَ
u'أَنَّ وَلاَيَةٌ':Predicate, #9: 9	أَنَّ الْوِلَادَةَ
u'أَنَّ وِلاَيَةٌ':Predicate, #1: 1	أَنَّ وَلَايَةَ
u'أَنَّ وِلاَيَةٌ':Predicate, #29: 29	أَنَّ الْوِلَايَةَ
u'أَنَّ ولد':Predicate, #38: 38	أَنَّ وِلَايَةَ
u'أَنَّ وَلَدٌ':Predicate, #132: 132	أَنَّ الْوَلَدَ
u'أَنَّ ولد':Predicate, #132: 132	أَنَّ الْوَلَدَ
u'أَنَّ وَلَدٌ':Predicate, #49: 49	أَنَّ وَلَدَ
u'أَنَّ وَلِيٌّ':Predicate, #49: 49	أَنَّ وَلَدَ
u'أَنَّ وَلِيٌّ':Predicate, #12: 12	أَنَّ وَلِيَّ
u'أَنَّ وَلِيدٌ':Predicate, #61: 61	أَنَّ الْوَلِيَّ
u'أَنَّ وَلِيمَةٌ':Predicate, #19: 19	أَنَّ الْوَلِيدَ
u'أَنَّ وَلِيمَةٌ':Predicate, #1: 1	أَنَّ وَلِيمَةَ
u'أَنَّ وَهْمٌ':Predicate, #5: 5	أَنَّ الْوَلِيمَةَ
u'أَنَّ يَابِسٌ':Predicate, #4: 4	أَنَّ الْوَهْمَ
u'أَنَّ يَأْسٌ':Predicate, #3: 3	أَنَّ الْيَابِسَ
u'أَنَّ يَتِيمٌ':Predicate, #2: 2	أَنَّ الْيَأْسَ
u'أَنَّ يَتِيمٌ':Predicate, #1: 1	أَنَّ الْيَتِيمَةَ
u'أَنَّ يَدٌ':Predicate, #2: 2	أَنَّ الْيَتِيمَ
u'أَنَّ يَدٌ':Predicate, #27: 27	أَنَّ يَدَ
u'أَنَّ يسار':Predicate, #58: 58	أَنَّ الْيَدَ
u'أَنَّ يَسَارٌ':Predicate, #10: 10	أَنَّ الْيَسَارَ
u'أَنَّ يسار':Predicate, #10: 10	أَنَّ الْيَسَارَ
u'أَنَّ يَسَارٌ':Predicate, #3: 3	أَنَّ يَسَارَ
u'أَنَّ يُسْرٌ':Predicate, #3: 3	أَنَّ يَسَارَ
u'أَنَّ يَسِيرٌ':Predicate, #1: 1	أَنَّ الْيُسْرَ
u'أَنَّ يَسِيرٌ':Predicate, #1: 1	أَنَّ يَسِيرَ
u'أَنَّ يَعْقُوبٌ':Predicate, #9: 9	أَنَّ الْيَسِيرَ
u'أَنَّ يَقْظَان':Predicate, #6: 6	أَنَّ يَعْقُوبَ
u'أَنَّ يَقِينٌ':Predicate, #1: 1	أَنَّ الْيَقْظَانَ
u'أَنَّ يَمَانِيٌّ':Predicate, #7: 7	أَنَّ الْيَقِينَ
u'أَنَّ يمن':Predicate, #1: 1	أَنَّ الْيَمَانِيِّينَ
u'أَنَّ يُمْنٌ':Predicate, #1: 1	أَنَّ الْيُمْنَ
u'أَنَّ يَمِينٌ':Predicate, #1: 1	أَنَّ الْيُمْنَ
u'أَنَّ يَمِينٌ':Predicate, #116: 116	أَنَّ الْيَمِينَ
u'أَنَّ يهود':Predicate, #5: 5	أَنَّ يَمِينَ
u'أَنَّ يَهُودٌ':Predicate, #34: 34	أَنَّ الْيَهُودَ
u'أَنَّ يَهُودِيٌّ':Predicate, #34: 34	أَنَّ الْيَهُودَ
u'أَنَّ يَهُودِيٌّ':Predicate, #1: 1	أَنَّ يَهُودِيَّةَ
u'أَنَّ يَهُودِيٌّ':Predicate, #2: 2	أَنَّ الْيَهُودِيَّ
u'أَنَّ يَوْمٌ':Predicate, #5: 5	أَنَّ يَهُودِيَّةً
u'أَنَّ يَوْمٌ':Predicate, #29: 29	أَنَّ يَوْمَ
u'أَهَاجَ رُطوبَةٌ':Predicate, #37: 37	أَنَّ الْيَوْمَ
u'أَهَاجَ فراغ':Subject, #1: 1	أَهَاجَ الرُّطُوبَةَ
u'أَهَاجَ فَرَاغٌ':Subject, #1: 1	أَهَاجَ الْفَرَاغُ
u'أَهَاجَ مرٌّ':Predicate, #1: 1	أَهَاجَ الْفَرَاغُ
u'أَهَاجَ مِرَّةٌ':Predicate, #1: 1	أَهَاجَ الْمِرَّةَ
u'إهَانَةٌ اِسْمٌ':Added, #1: 1	أَهَاجَ الْمِرَّةَ
u'إهَانَةٌ أصل':Added, #1: 1	إهَانَةَ اسْمِ
u'إهَانَةٌ أًصْلٌ':Added, #1: 1	إهَانَةِ أَصْلِهِ
u'إهَانَةٌ خَادِمٌ':Added, #1: 1	إهَانَةِ أَصْلِهِ
u'إهَانَةٌ شَيْطَانٌ':Added, #1: 1	إهَانَةَ الْخَادِمِ
u'إهَانَةٌ صَاحِبٌ':Added, #1: 1	إهَانَةُ الشَّيْطَانِ
u'إهَانَةٌ وَجْهٌ':Added, #2: 2	إهَانَةَ صَاحِبِ
u'أَهَانَ سُلْطَانٌ':Predicate, #1: 1	إهَانَةُ الْوَجْهِ
u'أَهْبَطَ آدَمُ':Predicate, #1: 1	أَهَانَ سُلْطَانَ
u'إهْدَاءٌ بدنة':Added, #1: 1	أَهْبَطَ آدَمَ
u'إهْدَاءٌ تُرْبَةٌ':Added, #1: 1	إهْدَاءُ بَدَنَةٍ
u'إهْدَاءٌ ثَوابٌ':Added, #1: 1	إهْدَاءُ التُّرْبَةِ
u'إهْدَاءٌ ثَوابٌ':Added, #1: 1	إهْدَاءُ الثَّوَابِ
u'إهْدَاءٌ ثَوابٌ':Added, #1: 1	إهْدَاءِ الثَّوَابِ
u'إهْدَاءٌ ثَوابٌ':Added, #1: 1	إهْدَاءَ ثَوَابِ
u'إهْدَاءٌ ثَوْبٌ':Added, #2: 2	إهْدَاءِ ثَوَابِ
u'إهْدَاءٌ ثِيابٌ':Added, #1: 1	إهْدَاءُ الثَّوْبِ
u'إهْدَاءٌ رَسُولٌ':Added, #1: 1	إهْدَاءَ ثِيَابِ
u'إهْدَاءٌ زَوْجَةٌ':Added, #1: 1	إهْدَاءُ الرّسُولِ
u'إهْدَاءٌ طعام':Added, #2: 2	إهْدَاءِ الزَّوْجَةِ
u'إهْدَاءٌ طَعَامٌ':Added, #1: 1	إهْدَاءِ الطَّعَامِ
u'إهْدَاءٌ عَمَلٌ':Added, #1: 1	إهْدَاءِ الطَّعَامِ
u'إهْدَاءٌ قِرَاءةٌ':Added, #1: 1	إهْدَاءِ الْعَمَلِ
u'إهْدَاءٌ قُرَبٌ':Added, #1: 1	إهْدَاءِ الْقِرَاءَةِ
u'إهْدَاءٌ قُرْبٌ':Added, #1: 1	إهْدَاءِ الْقُرَبِ
u'إهْدَاءٌ قُرَبٌ':Added, #1: 1	إهْدَاءِ الْقُرْبِ
u'إهْدَاءٌ قِيمَةٌ':Added, #3: 3	إهْدَاءُ الْقُرَبِ
u'إهْدَاءٌ قِيمَةٌ':Added, #1: 1	إهْدَاءِ الْقِيمَةِ
u'إهْدَاءٌ قِيمَةٌ':Added, #1: 1	إهْدَاءِ قِيمَةِ
u'إهْدَاءٌ مثل':Added, #1: 1	إهْدَاءُ قِيمَتِهِ
u'إهْدَاءٌ مِثْلٌ':Added, #1: 1	إهْدَاءُ مِثْلِ
u'إهْدَاءٌ هَدْيٌ':Added, #1: 1	إهْدَاءُ مِثْلِ
u'إهْدَارٌ آدَمِيٌّ':Added, #1: 1	إهْدَاءِ الْهَدْيِ
u'إهْدَارٌ آدَمِيٌّ':Added, #2: 2	إهْدَارَ آدَمِيَّتِهِ
u'إهْدَارٌ أَشَدُّ':Added, #3: 3	إهْدَارُ آدَمِيَّتِهِ
u'إهْدَارٌ أصل':Added, #1: 1	إهْدَارُ الْأَشَدِّ
u'إهْدَارٌ أصل':Added, #1: 1	إهْدَارُ الْأَصْلِ
u'إهْدَارٌ أًصْلٌ':Added, #1: 1	إهْدَارِ الْأَصْلِ
u'إهْدَارٌ أًصْلٌ':Added, #1: 1	إهْدَارُ الْأَصْلِ
u'إهْدَارٌ اِعْتِبارٌ':Added, #1: 1	إهْدَارِ الْأَصْلِ
u'إهْدَارٌ أَهْلِيٌّ':Added, #1: 1	إهْدَارَ اعْتِبَارِ
u'إهْدَارٌ أَهْلِيٌّ':Added, #1: 1	إهْدَارُ الْأَهْلِيَّةِ
u'إهْدَارٌ أَهْلِيٌّ':Added, #1: 1	إهْدَارِ أَهْلِيَّتِهِ
u'إهْدَارٌ أهْلِيَّةٌ':Added, #4: 4	إهْدَارَ أَهْلِيَّتِهِ
u'إهْدَارٌ أهْلِيَّةٌ':Added, #1: 1	إهْدَارُ الْأَهْلِيَّةِ
u'إهْدَارٌ أهْلِيَّةٌ':Added, #1: 1	إهْدَارِ أَهْلِيَّتِهِ
u'إهْدَارٌ بَعْضٌ':Added, #4: 4	إهْدَارَ أَهْلِيَّتِهِ
u'إهْدَارٌ تَابِعٌ':Added, #1: 1	إهْدَارِ بَعْضِ
u'إهْدَارٌ تَفاوُت':Added, #1: 1	إهْدَارُ التَّابِعِ
u'إهْدَارٌ تَفاوُت':Added, #1: 1	إهْدَارَ التَّفَاوُتِ
u'إهْدَارٌ دَمٌ':Added, #5: 5	إهْدَارِ التَّفَاوُتِ
u'إهْدَارٌ دَمٌ':Added, #1: 1	إهْدَارِ الدَّمِ
u'إهْدَارٌ دَمٌ':Added, #1: 1	إهْدَارُ دَمِهِ
u'إهْدَارٌ شَرْعٌ':Added, #1: 1	إهْدَارِ دَمِهِ
u'إهْدَارٌ صِفَةٌ':Added, #1: 1	إهْدَارِ الشَّرْعِ
u'إهْدَارٌ عِبَارَةٌ':Added, #1: 1	إهْدَارَ صِفَةِ
u'إهْدَارٌ فِعْلٌ':Added, #1: 1	إهْدَارِ عِبَارَتِهِ
u'إهْدَارٌ قَاعِدٌ':Added, #1: 1	إهْدَارِ فِعْلِ
u'إهْدَارٌ قول':Added, #1: 1	إهْدَارِ الْقَاعِدِ
u'إهْدَارٌ قَوْلٌ':Added, #1: 1	إهْدَارِ الْقَوْلِ
u'إهْدَارٌ قِيمَةٌ':Added, #1: 1	إهْدَارِ الْقَوْلِ
u'إهْدَارٌ كَلاَمٌ':Added, #1: 1	إهْدَارِ قِيمَةِ
u'إهْدَارٌ نَدْبٌ':Added, #1: 1	إهْدَارِ كَلَامِ
u'أَهْدَرَ ثَنِيَّةٌ':Predicate, #1: 1	إهْدَارُ النَّدْبِ
u'أَهْدَرَ غير':Predicate, #1: 1	أَهْدَرَ ثَنِيَّةَ
u'أَهْدَرَ غَيْرٌ':Predicate, #1: 1	أَهْدَرَ الْغَيْرَ
u'أَهْدَرَ مُتْعَةٌ':Predicate, #1: 1	أَهْدَرَ الْغَيْرَ
u'أَهْدَرَ نَبِيٌّ':Subject, #1: 1	أَهْدَرَ الْمُتْعَةَ
u'أَهْدَى أَميرٌ':Subject, #2: 2	أَهْدَرَ النَّبِيُّ
u'أَهْدَى بدن':Predicate, #1: 1	أَهْدَى أَمِيرُ
u'أَهْدَى بُدْنٌ':Predicate, #1: 1	أَهْدَى الْبُدْنَ
u'أَهْدَى بَعْضٌ':Subject, #1: 1	أَهْدَى الْبُدْنَ
u'أَهْدَى جَارِي':Predicate, #1: 1	أَهْدَى بَعْضُ
u'أَهْدَى جَمَلٌ':Predicate, #1: 1	أَهْدَى جَارِيَةً
u'أَهْدَى حَرِيرٌ':Predicate, #2: 2	أَهْدَى جَمَلاً
u'أَهْدَى خَمِيص':Predicate, #1: 1	أَهْدَى الْحَرِيرَ
u'أَهْدَى رَجُلٌ':Subject, #1: 1	أَهْدَى الْخَمِيصَةَ
u'أَهْدَى رَجُلٌ':Subject, #1: 1	أَهْدَى الرَّجُلُ
u'أَهْدَى رَسُولٌ':Subject, #3: 3	أَهْدَى رَجُلٌ
u'أَهْدَى سلام':Predicate, #8: 8	أَهْدَى رَسُولُ
u'أَهْدَى سَلاَمٌ':Predicate, #1: 1	أَهْدَى السَّلَامَ
u'أَهْدَى صَاحِبٌ':Subject, #1: 1	أَهْدَى السَّلَامَ
u'أَهْدَى صَعْبٌ':Subject, #1: 1	أَهْدَى صَاحِبُ
u'أَهْدَى عَامٌ':Predicate, #3: 3	أَهْدَى الصَّعْبُ
u'أَهْدَى عُمَرٌ':Subject, #1: 1	أَهْدَى عَامَ
u'أَهْدَى مثل':Predicate, #4: 4	أَهْدَى عُمَرُ
u'أَهْدَى مِثْلٌ':Predicate, #1: 1	أَهْدَى مِثْلَ
u'أَهْدَى مَدِينٌ':Subject, #1: 1	أَهْدَى مِثْلَ
u'أَهْدَى مرٌّ':Predicate, #1: 1	أَهْدَى الْمَدِينُ
u'أَهْدَى مَلِكٌ':Subject, #2: 2	أَهْدَى مَرَّةً
u'أَهْدَى مَلِكٌ':Subject, #1: 1	أَهْدَى مَلِكٌ
u'أَهْدَى نَبِيٌّ':Subject, #4: 4	أَهْدَى مَلِكُ
u'أَهْدَى هَدِيٌّ':Predicate, #1: 1	أَهْدَى النَّبِيُّ
u'أَهْدَى واحد':Subject, #4: 4	أَهْدَى هَدِيَّةً
u'أَهْدَى وَاحِدٌ':Subject, #1: 1	أَهْدَى وَاحِدٌ
u'أَهْدَى يَوْمٌ':Predicate, #1: 1	أَهْدَى وَاحِدٌ
u'إهْرَاقٌ دَمٌ':Added, #2: 2	أَهْدَى يَوْمَ
u'أَهَلَّ بَارِحٌ':Predicate, #1: 1	إهْرَاقِ الدَّمِ
u'أَهَلَّ حاجٌّ':Subject, #1: 1	أَهَلَّ الْبَارِحَةَ
u'أَهَلَّ حَديثٌ':Subject, #1: 1	أَهَلَّ الْحَاجُّ
u'أَهَلَّ رَجُلٌ':Subject, #1: 1	أَهَلَّ الْحَدِيثُ
u'أَهَلَّ رَسُولٌ':Subject, #1: 1	أَهَلَّ الرَّجُلُ
u'أَهَلَّ شَهْرٌ':Subject, #19: 19	أَهَلَّ رَسُولُ
u'أَهَلَّ شَهْرٌ':Subject, #3: 3	أَهَلَّ الشَّهْرُ
u'أَهَلَّ شَوَّالٌ':Subject, #3: 3	أَهَلَّ شَهْرٌ
u'أَهَلَّ كَافِرٌ':Subject, #1: 1	أَهَلَّ شَوَّالٌ
u'أَهْلَكَ بَائِعٌ':Subject, #1: 1	أَهَلَّ كَافِرٌ
u'أَهْلَكَ صدقة':Subject, #1: 1	أَهْلَكَ بَائِعٌ
u'أَهْلَكَ صَدَقَةٌ':Subject, #1: 1	أَهْلَكَ صَدَقَةٌ
u'أَهْلَكَ قَالٌ':Predicate, #1: 1	أَهْلَكَ صَدَقَةٌ
u'أَهْلَكَ مَالِكٌ':Subject, #2: 2	أَهْلَكَ قَالَ
u'أَهْلَكَ نَاسٌ':Predicate, #1: 1	أَهْلَكَ الْمَالِكُ
u'أَهَلَّ لَيْلٌ':Predicate, #2: 2	أَهْلَكَ النَّاسَ
u'أَهَلَّ مَأْمُورٌ':Subject, #1: 1	أَهَلَّ لَيْلَةَ
u'أَهَلَّ نَاسٌ':Subject, #1: 1	أَهَلَّ الْمَأْمُورُ
u'أَهَلَّ نَبِيٌّ':Subject, #2: 2	أَهَلَّ النَّاسُ
u'أَهَلَّ هِلاَلٌ':Subject, #2: 2	أَهَلَّ النَّبِيُّ
u'أَهَلَّ هِلاَلٌ':Subject, #10: 10	أَهَلَّ الْهِلَالُ
u'أَهَلَّ هِلاَلٌ':Subject, #1: 1	أَهَلَّ هِلَالُ
u'إهْمَالٌ أدَب':Added, #2: 2	أَهَلَّ هِلاَلُ
u'إهْمَالٌ أَمْرٌ':Added, #1: 1	إهْمَالُ الْأَدَبِ
u'إهْمَالٌ بَعْضٌ':Added, #1: 1	إهْمَالُ أَمْرِ
u'إهْمَالٌ بَيِّنَةٌ':Added, #1: 1	إهْمَالِ بَعْضِهِ
u'إهْمَالٌ حَديثٌ':Added, #1: 1	إهْمَالِ الْبَيِّنَةِ
u'إهْمَالٌ رَأْسٌ':Added, #1: 1	إهْمَالُ الْحَدِيثِ
u'إهْمَالٌ عَضُدٌ':Added, #1: 1	إهْمَالُ الرَّأْسِ
u'إهْمَالٌ عَمَلٌ':Added, #1: 1	إهْمَالُ عَضُدِ
u'إهْمَالٌ عَيْبٌ':Added, #1: 1	إهْمَالِ الْعَمَلِ
u'إهْمَالٌ فِعْلٌ':Added, #1: 1	إهْمَالُ الْعَيْبِ
u'إهْمَالٌ قَوَانِينُ':Added, #1: 1	إهْمَالُ الْفِعْلَيْنِ
u'إهْمَالٌ كَلاَمٌ':Added, #1: 1	إهْمَالُ قَوَانِينِ
u'إهْمَالٌ لَفْظٌ':Added, #1: 1	إهْمَالِ كَلَامِ
u'إهْمَالٌ لَفْظٌ':Added, #1: 1	إهْمَالِ اللَّفْظِ
u'إهْمَالٌ مَالِكٌ':Added, #1: 1	إهْمَالَ لَفْظِ
u'إهْمَالٌ نقل':Added, #1: 1	إهْمَالِ مَالِكِهِ
u'إهْمَالٌ نَقْلٌ':Added, #1: 1	إهْمَالُ نَقْلِ
u'أَهْمَلَ جَانِبٌ':Predicate, #1: 1	إهْمَالُ نَقْلِ
u'أَهْمَلَ دُعَاءٌ':Predicate, #1: 1	أَهْمَلَ جَانِبَ
u'أَهْمَلَ ذكر':Predicate, #1: 1	أَهْمَلَ الدُّعَاءَ
u'أَهْمَلَ ذِكْرٌ':Predicate, #2: 2	أَهْمَلَ ذِكْرَ
u'أَهْمَلَ صِيَانَةٌ':Predicate, #2: 2	أَهْمَلَ ذِكْرَ
u'أَهْمَلَ مُصَنِّفٌ':Subject, #1: 1	أَهْمَلَ صِيَانَةَ
u'أَهْمَلَ مَوْضِعٌ':Predicate, #1: 1	أَهْمَلَ الْمُصَنِّفُ
u'أَهْمَلَ نَاسٌ':Subject, #1: 1	أَهْمَلَ مَوْضِعَ
u'أَهْوَالٌ آخِرَةٌ':Added, #1: 1	أَهْمَلَ النَّاسُ
u'أَهْوَالٌ يَوْمٌ':Added, #1: 1	أَهْوَالِ الْآخِرَةِ
u'أَهْوَالٌ يَوْمٌ':Added, #1: 1	أَهْوَالَ يَوْمِ
u'أَهْوَى رَسُولٌ':Subject, #2: 2	أَهْوَالِ يَوْمِ
u'أَهْوَى عُرْوَةٌ':Subject, #1: 1	أَهْوَى رَسُولُ
u'أَهْوَى نَحْوٌ':Predicate, #1: 1	أَهْوَى عُرْوَةُ
u'أَوْباشٌ قُرَيْشٌ':Added, #1: 1	أَهْوَى نَحْوَ
u'أَوْبَاشٌ قُرَيْشٌ':Added, #1: 1	أَوْبَاشِ قُرَيْشٍ
u'أَوْتَرَ آخِرُ':Predicate, #1: 1	أَوْبَاشِ قُرَيْشٍ
u'أَوْتَرَ أَذَانٌ':Predicate, #2: 2	أَوْتَرَ آخِرَ
u'أَوْتَرَ أَوَّلُ':Predicate, #1: 1	أَوْتَرَ الْأَذَانَ
u'أَوْتَرَ رَسُولٌ':Subject, #3: 3	أَوْتَرَ أَوَّلَ
u'أَوْتَرَ فلان':Subject, #13: 13	أَوْتَرَ رَسُولُ
u'أَوْتَرَ قنت':Predicate, #1: 1	أَوْتَرَ مُعَاوِيَةُ
u'أَوْتَرَ قَوْسٌ':Predicate, #1: 1	أَوْتَرَ قَنَتَ
u'أَوْتَرَ مُعاوِيَة':Subject, #1: 1	أَوْتَرَ الْقَوْسَ
u'أَوْتَرَ نَبِيٌّ':Subject, #1: 1	أَوْتَرَ مُعَاوِيَةُ
u'أَوْجَاعٌ أَعْصَابٌ':Added, #2: 2	أَوْتَرَ النَّبِيُّ
u'أَوْجَاعٌ جَنْبٌ':Added, #1: 1	أَوْجَاعَ الْأَعْصَابِ
u'أَوْجَاعٌ رحم':Added, #1: 1	أَوْجَاعِ الْجَنْبِ
u'أَوْجَاعٌ رَحِمٌ':Added, #1: 1	أَوْجَاعِ الرَّحِمِ
u'أَوْجَاعٌ رِئَةٌ':Added, #1: 1	أَوْجَاعِ الرَّحِمِ
u'أَوْجَاعٌ ظَهْرٌ':Added, #1: 1	أَوْجَاعِ الرِّئَةِ
u'أَوْجَاعٌ عَصَبٌ':Added, #1: 1	أَوْجَاعِ الظَّهْرِ
u'أَوْجَاعٌ قلب':Added, #2: 2	أَوْجَاعِ الْعَصَبِ
u'أَوْجَاعٌ قَلْبٌ':Added, #2: 2	أَوْجَاعِ الْقَلْبِ
u'أَوْجَاعٌ قَلْب':Added, #2: 2	أَوْجَاعِ الْقَلْبِ
u'أَوْجَاعٌ مَعِدَةٌ':Added, #2: 2	أَوْجَاعِ الْقَلْبِ
u'أَوْجَاعٌ وَرِكٌ':Added, #1: 1	أَوْجَاعِ الْمَعِدَةِ
u'أَوْجَبَ اِبْتِداءٌ':Predicate, #1: 1	أَوْجَاعِ الْوَرِكَيْنِ
u'أَوْجَبَ اِبْنٌ':Subject, #1: 1	أَوْجَبَ ابْتِدَاءَ
u'أَوْجَبَ إِتْيانٌ':Predicate, #3: 3	أَوْجَبَ ابْنُ
u'أَوْجَبَ إِثْمٌ':Predicate, #1: 1	أَوْجَبَ الْإِتْيَانَ
u'أَوْجَبَ إِجْرَاءٌ':Predicate, #1: 1	أَوْجَبَ الْإِثْمَ
u'أَوْجَبَ أحَدٌ':Subject, #1: 1	أَوْجَبَ إجْرَاءَ
u'أَوْجَبَ إِحْرَامٌ':Predicate, #4: 4	أَوْجَبَ أَحَدُ
u'أَوْجَبَ إدْخَالٌ':Predicate, #1: 1	أَوْجَبَ الْإِحْرَامَ
u'أَوْجَبَ أَرْبَعُ':Predicate, #1: 1	أَوْجَبَ إدْخَالَ
u'أَوْجَبَ أَرْبَعَةٌ':Predicate, #1: 1	أَوْجَبَ أَرْبَعَ
u'أَوْجَبَ اِسْتِصْحابٌ':Predicate, #1: 1	أَوْجَبَ أَرْبَعَةَ
u'أَوْجَبَ اِسْتِقْبالٌ':Predicate, #1: 1	أَوْجَبَ اسْتِصْحَابَ
u'أَوْجَبَ إِشْكالٌ':Predicate, #1: 1	أَوْجَبَ اسْتِقْبَالَ
u'أَوْجَبَ أَصْحَابٌ':Subject, #1: 1	أَوْجَبَ الْإِشْكَالَ
u'أَوْجَبَ إضافَةٌ':Predicate, #1: 1	أَوْجَبَ الْأَصْحَابُ
u'أَوْجَبَ إِعادَةٌ':Predicate, #1: 1	أَوْجَبَ إضَافَةَ
u'أَوْجَبَ إِعْتاقٌ':Predicate, #1: 1	أَوْجَبَ الْإِعَادَةَ
u'أَوْجَبَ اِعْتِبارٌ':Predicate, #1: 1	أَوْجَبَ الْإِعْتَاقَ
u'أَوْجَبَ اِعْتِقادٌ':Predicate, #1: 1	أَوْجَبَ اعْتِبَارَ
u'أَوْجَبَ اِعْتِكافٌ':Predicate, #1: 1	أَوْجَبَ اعْتِقَادَ
u'أَوْجَبَ أعْظَمُ':Predicate, #6: 6	أَوْجَبَ اعْتِكَافَ
u'أَوْجَبَ أَكْثَرُ':Predicate, #3: 3	أَوْجَبَ أَعْظَمَ
u'أَوْجَبَ أكل':Predicate, #1: 1	أَوْجَبَ أَكْثَرَ
u'أَوْجَبَ أَكْلٌ':Predicate, #1: 1	أَوْجَبَ الْأَكْلَ
u'أَوْجَبَ أَمْنٌ':Predicate, #1: 1	أَوْجَبَ الْأَكْلَ
u'أَوْجَبَ اِنْتِقاضٌ':Subject, #1: 1	أَوْجَبَ الْأَمْنَ
u'أَوْجَبَ بَائِعٌ':Subject, #1: 1	أَوْجَبَ انْتِقَاضُهُ
u'أَوْجَبَ بَحْثٌ':Predicate, #3: 3	أَوْجَبَ الْبَائِعُ
u'أَوْجَبَ بَراءةٌ':Predicate, #1: 1	أَوْجَبَ الْبَحْثَ
u'أَوْجَبَ بَيَانٌ':Predicate, #1: 1	أَوْجَبَ الْبَرَاءَةَ
u'أَوْجَبَ بَيْعٌ':Predicate, #1: 1	أَوْجَبَ بَيَانَ
u'أَوْجَبَ تَأَبُّدٌ':Predicate, #3: 3	أَوْجَبَ الْبَيْعَ
u'أَوْجَبَ تَتَابُعٌ':Predicate, #1: 1	أَوْجَبَ تَأَبُّدَ
u'أَوْجَبَ تَحَالُفٌ':Predicate, #1: 1	أَوْجَبَ التَّتَابُعَ
u'أَوْجَبَ تَخْصِيصٌ':Predicate, #1: 1	أَوْجَبَ التَّحَالُفَ
u'أَوْجَبَ تَخْفِيفٌ':Predicate, #1: 1	أَوْجَبَ تَخْصِيصَ
u'أَوْجَبَ تُرَابٌ':Predicate, #3: 3	أَوْجَبَ التَّخْفِيفَ
u'أَوْجَبَ تَرْتِيبٌ':Predicate, #1: 1	أَوْجَبَ التُّرَابَ
u'أَوْجَبَ تَصْدِيقٌ':Predicate, #2: 2	أَوْجَبَ التَّرْتِيبَ
u'أَوْجَبَ تَضْحِيَةٌ':Predicate, #1: 1	أَوْجَبَ التَّصْدِيقَ
u'أَوْجَبَ تَعَيُّنٌ':Predicate, #1: 1	أَوْجَبَ التَّضْحِيَةَ
u'أَوْجَبَ تَغْيِيرٌ':Predicate, #2: 2	أَوْجَبَ تَعَيُّنَ
u'أَوْجَبَ تَفْرِقَة':Predicate, #1: 1	أَوْجَبَ تَغْيِيرَ
u'أَوْجَبَ تَقْديرٌ':Predicate, #1: 1	أَوْجَبَ التَّفْرِقَةَ
u'أَوْجَبَ تَقْديمٌ':Predicate, #1: 1	أَوْجَبَ تَقْدِيرَ
u'أَوْجَبَ تَقْليدٌ':Predicate, #2: 2	أَوْجَبَ تَقْدِيمَ
u'أَوْجَبَ تَقْليد':Predicate, #3: 3	أَوْجَبَ تَقْلِيدَ
u'أَوْجَبَ تَقْيِيد':Predicate, #3: 3	أَوْجَبَ تَقْلِيدَ
u'أَوْجَبَ تَكْرارٌ':Predicate, #2: 2	أَوْجَبَ التَّقْيِيدَ
u'أَوْجَبَ تَكْفيرٌ':Predicate, #1: 1	أَوْجَبَ التَّكْرَارَ
u'أَوْجَبَ تَكَلُّمٌ':Predicate, #1: 1	أَوْجَبَ التَّكْفِيرَ
u'أَوْجَبَ تَنجُّسٌ':Predicate, #1: 1	أَوْجَبَ التَّكَلُّمَ
u'أَوْجَبَ تَنْفِيذٌ':Predicate, #1: 1	أَوْجَبَ التَّنَجُّسَ
u'أَوْجَبَ تَوَقُّفٌ':Predicate, #2: 2	أَوْجَبَ تَنْفِيذَ
u'أَوْجَبَ ثَانِي':Predicate, #1: 1	أَوْجَبَ التَّوَقُّفَ
u'أَوْجَبَ ثَانِي':Predicate, #1: 1	أَوْجَبَ الثَّانِيَ
u'أَوْجَبَ ثَانِيَةٌ':Predicate, #1: 1	أَوْجَبَ الثَّانِيَةَ
u'أَوْجَبَ ثِقَةٌ':Predicate, #1: 1	أَوْجَبَ الثَّانِيَةَ
u'أَوْجَبَ ثَلاثُ':Predicate, #1: 1	أَوْجَبَ الثِّقَةَ
u'أَوْجَبَ ثَلاثُ':Predicate, #1: 1	أَوْجَبَ الثَّلَاثَ
u'أَوْجَبَ ثَمانِيَةٌ':Predicate, #2: 2	أَوْجَبَ ثَلَاثَ
u'أَوْجَبَ ثَمَنٌ':Predicate, #1: 1	أَوْجَبَ الثَّمَانِيَةَ
u'أَوْجَبَ جُرْحٌ':Subject, #1: 1	أَوْجَبَ ثَمَنَ
u'أَوْجَبَ جَزَاءٌ':Predicate, #1: 1	أَوْجَبَ الْجُرْحُ
u'أَوْجَبَ جلد':Predicate, #6: 6	أَوْجَبَ الْجَزَاءَ
u'أَوْجَبَ جَلْدٌ':Predicate, #1: 1	أَوْجَبَ الْجَلْدَ
u'أَوْجَبَ جمع':Predicate, #1: 1	أَوْجَبَ الْجَلْدَ
u'أَوْجَبَ جَمْعٌ':Predicate, #2: 2	أَوْجَبَ الْجَمْعَ
u'أَوْجَبَ جَمِيع':Predicate, #2: 2	أَوْجَبَ الْجَمْعَ
u'أَوْجَبَ حَجْرٌ':Predicate, #1: 1	أَوْجَبَ الْجَمِيعَ
u'أَوْجَبَ حَدٌّ':Predicate, #1: 1	أَوْجَبَ الْحَجْرَ
u'أَوْجَبَ حَدٌّ':Predicate, #1: 1	أَوْجَبَ حَدَّ
u'أَوْجَبَ حَرْفٌ':Subject, #3: 3	أَوْجَبَ الْحَدَّ
u'أَوْجَبَ حُرْمَةٌ':Predicate, #1: 1	أَوْجَبَ حَرْفُ
u'أَوْجَبَ حُرْمَةٌ':Predicate, #1: 1	أَوْجَبَ الْحُرْمَةَ
u'أَوْجَبَ حِفْظٌ':Predicate, #1: 1	أَوْجَبَ حُرْمَةَ
u'أَوْجَبَ حَقٌّ':Predicate, #1: 1	أَوْجَبَ حِفْظَ
u'أَوْجَبَ حَقٌّ':Predicate, #1: 1	أَوْجَبَ حَقَّ
u'أَوْجَبَ حُكْمٌ':Predicate, #6: 6	أَوْجَبَ الْحَقَّ
u'أَوْجَبَ حُكْمٌ':Subject, #3: 3	أَوْجَبَ الْحُكْمَ
u'أَوْجَبَ حُكُومَةٌ':Predicate, #1: 1	أَوْجَبَ الْحُكْمُ
u'أَوْجَبَ حِلٌّ':Predicate, #1: 1	أَوْجَبَ حُكُومَةَ
u'أَوْجَبَ حَوامِلُ':Predicate, #2: 2	أَوْجَبَ الْحِلَّ
u'أَوْجَبَ خدمة':Predicate, #2: 2	أَوْجَبَ الْحَوَامِلَ
u'أَوْجَبَ خِدْمَةٌ':Predicate, #1: 1	أَوْجَبَ الْخِدْمَةَ
u'أَوْجَبَ خراج':Predicate, #1: 1	أَوْجَبَ الْخِدْمَةَ
u'أَوْجَبَ خَرَاجٌ':Predicate, #1: 1	أَوْجَبَ الْخَرَاجَ
u'أَوْجَبَ خِلاَفٌ':Predicate, #1: 1	أَوْجَبَ الْخَرَاجَ
u'أَوْجَبَ خُمُسٌ':Predicate, #1: 1	أَوْجَبَ الْخِلَافَ
u'أَوْجَبَ دَليلٌ':Predicate, #6: 6	أَوْجَبَ الْخُمُسَ
u'أَوْجَبَ دَليلٌ':Subject, #1: 1	أَوْجَبَ دَلِيلَ
u'أَوْجَبَ دِيَةٌ':Predicate, #1: 1	أَوْجَبَ الدَّلِيلُ
u'أَوْجَبَ دِيَةٌ':Predicate, #2: 2	أَوْجَبَ دِيَةَ
u'أَوْجَبَ دِينارٌ':Predicate, #5: 5	أَوْجَبَ الدِّيَةَ
u'أَوْجَبَ رُجُوعٌ':Predicate, #1: 1	أَوْجَبَ الدِّينَارَ
u'أَوْجَبَ رَدٌّ':Predicate, #1: 1	أَوْجَبَ رُجُوعَ
u'أَوْجَبَ زَكاةٌ':Predicate, #2: 2	أَوْجَبَ رَدَّ
u'أَوْجَبَ زَوالٌ':Predicate, #4: 4	أَوْجَبَ الزَّكَاةَ
u'أَوْجَبَ زَوْجٌ':Subject, #5: 5	أَوْجَبَ زَوَالَ
u'أَوْجَبَ زِيادَةٌ':Predicate, #1: 1	أَوْجَبَ الزَّوْجُ
u'أَوْجَبَ سَبْعٌ':Predicate, #1: 1	أَوْجَبَ الزِّيَادَةَ
u'أَوْجَبَ سِعَايَةٌ':Predicate, #1: 1	أَوْجَبَ السَّبْعَ
u'أَوْجَبَ سُقُوطٌ':Predicate, #4: 4	أَوْجَبَ السِّعَايَةَ
u'أَوْجَبَ سَقْيٌ':Subject, #5: 5	أَوْجَبَ سُقُوطَ
u'أَوْجَبَ سُنَّةٌ':Predicate, #1: 1	أَوْجَبَ سَقْيُ
u'أَوْجَبَ سَيِّدٌ':Subject, #1: 1	أَوْجَبَ السُّنَّةَ
u'أَوْجَبَ شَاةٌ':Predicate, #1: 1	أَوْجَبَ السَّيِّدُ
u'أَوْجَبَ شَارِعٌ':Subject, #1: 1	أَوْجَبَ الشَّاةَ
u'أَوْجَبَ شُبْهَةٌ':Predicate, #7: 7	أَوْجَبَ الشَّارِعُ
u'أَوْجَبَ شَرْعٌ':Subject, #1: 1	أَوْجَبَ الشُّبْهَةَ
u'أَوْجَبَ شفعة':Predicate, #8: 8	أَوْجَبَ الشَّرْعُ
u'أَوْجَبَ شُفْعَةٌ':Predicate, #1: 1	أَوْجَبَ الشُّفْعَةَ
u'أَوْجَبَ شَهَادَةٌ':Predicate, #1: 1	أَوْجَبَ الشُّفْعَةَ
u'أَوْجَبَ شُهُودٌ':Subject, #1: 1	أَوْجَبَ الشَّهَادَةَ
u'أَوْجَبَ صَلاَةٌ':Predicate, #1: 1	أَوْجَبَ الشُّهُودُ
u'أَوْجَبَ صَلاَةٌ':Predicate, #1: 1	أَوْجَبَ الصَّلَاةَ
u'أَوْجَبَ صَوْمٌ':Predicate, #1: 1	أَوْجَبَ صَلَاةَ
u'أَوْجَبَ صَوْمٌ':Predicate, #2: 2	أَوْجَبَ صَوْمَ
u'أَوْجَبَ ضَمَانٌ':Predicate, #3: 3	أَوْجَبَ الصَّوْمَ
u'أَوْجَبَ ضَمَانٌ':Predicate, #1: 1	أَوْجَبَ ضَمَانَ
u'أَوْجَبَ طَلاَقٌ':Predicate, #9: 9	أَوْجَبَ الضَّمَانَ
u'أَوْجَبَ طَلْحٌ':Subject, #2: 2	أَوْجَبَ الطَّلَاقَ
u'أَوْجَبَ طلحة':Subject, #4: 4	أَوْجَبَ طَلْحَةُ
u'أَوْجَبَ عتق':Predicate, #4: 4	أَوْجَبَ طَلْحَةُ
u'أَوْجَبَ عِتْقٌ':Predicate, #12: 12	أَوْجَبَ الْعِتْقَ
u'أَوْجَبَ عتق':Predicate, #12: 12	أَوْجَبَ الْعِتْقَ
u'أَوْجَبَ عِتْقٌ':Predicate, #2: 2	أَوْجَبَ عِتْقَ
u'أَوْجَبَ عِدَّةٌ':Predicate, #2: 2	أَوْجَبَ عِتْقَ
u'أَوْجَبَ عِدَّةٌ':Predicate, #1: 1	أَوْجَبَ الْعِدَّةَ
u'أَوْجَبَ عَدَمٌ':Predicate, #1: 1	أَوْجَبَ عِدَّةَ
u'أَوْجَبَ عُدُولٌ':Predicate, #3: 3	أَوْجَبَ عَدَمَ
u'أَوْجَبَ عِصْمَةٌ':Predicate, #2: 2	أَوْجَبَ الْعُدُولَ
u'أَوْجَبَ عطف':Predicate, #2: 2	أَوْجَبَ الْعِصْمَةَ
u'أَوْجَبَ عَطْفٌ':Predicate, #1: 1	أَوْجَبَ الْعَطْفَ
u'أَوْجَبَ عَقْدٌ':Predicate, #1: 1	أَوْجَبَ الْعَطْفَ
u'أَوْجَبَ عَقْدٌ':Predicate, #1: 1	أَوْجَبَ عَقْدَ
u'أَوْجَبَ عقر':Predicate, #3: 3	أَوْجَبَ الْعَقْدَ
u'أَوْجَبَ عُقْرٌ':Predicate, #1: 1	أَوْجَبَ الْعُقْرَ
u'أَوْجَبَ عَقْلٌ':Subject, #1: 1	أَوْجَبَ الْعُقْرَ
u'أَوْجَبَ علم':Predicate, #1: 1	أَوْجَبَ الْعَقْلُ
u'أَوْجَبَ عِلْمٌ':Predicate, #1: 1	أَوْجَبَ الْعِلْمَ
u'أَوْجَبَ علم':Predicate, #1: 1	أَوْجَبَ الْعِلْمَ
u'أَوْجَبَ عِلْمٌ':Predicate, #1: 1	أَوْجَبَ عِلْمَ
u'أَوْجَبَ عُمَرٌ':Subject, #1: 1	أَوْجَبَ عِلْمَ
u'أَوْجَبَ عَمَلٌ':Predicate, #1: 1	أَوْجَبَ عُمَرُ
u'أَوْجَبَ غَسْلٌ':Predicate, #2: 2	أَوْجَبَ الْعَمَلَ
u'أَوْجَبَ غُسْلٌ':Predicate, #1: 1	أَوْجَبَ غَسْلَ
u'أَوْجَبَ غُسْلٌ':Predicate, #1: 1	أَوْجَبَ غُسْلَ
u'أَوْجَبَ غفر':Predicate, #5: 5	أَوْجَبَ الْغُسْلَ
u'أَوْجَبَ غَنَمٌ':Predicate, #1: 1	أَوْجَبَ غُفِرَ
u'أَوْجَبَ فِدْيَةٌ':Predicate, #1: 1	أَوْجَبَ الْغَنَمَ
u'أَوْجَبَ فرق':Predicate, #2: 2	أَوْجَبَ الْفِدْيَةَ
u'أَوْجَبَ فَرْقٌ':Predicate, #1: 1	أَوْجَبَ الْفَرْقَ
u'أَوْجَبَ فُرْقَةٌ':Predicate, #1: 1	أَوْجَبَ الْفَرْقَ
u'أَوْجَبَ فساد':Predicate, #1: 1	أَوْجَبَ فُرْقَةَ
u'أَوْجَبَ فَسَادٌ':Predicate, #1: 1	أَوْجَبَ الْفَسَادَ
u'أَوْجَبَ فساد':Predicate, #1: 1	أَوْجَبَ الْفَسَادَ
u'أَوْجَبَ فَسَادٌ':Predicate, #1: 1	أَوْجَبَ فَسَادَ
u'أَوْجَبَ فَصْلٌ':Predicate, #1: 1	أَوْجَبَ فَسَادَ
u'أَوْجَبَ فِعْلٌ':Predicate, #1: 1	أَوْجَبَ الْفَصْلَ
u'أَوْجَبَ فقهاء':Subject, #1: 1	أَوْجَبَ الْفِعْلَ
u'أَوْجَبَ فَقِيرٌ':Subject, #1: 1	أَوْجَبَ الْفُقَهَاءُ
u'أَوْجَبَ فَكٌّ':Predicate, #2: 2	أَوْجَبَ الْفَقِيرُ
u'أَوْجَبَ قِرَاءةٌ':Predicate, #1: 1	أَوْجَبَ فَكَّ
u'أَوْجَبَ قَسام':Predicate, #1: 1	أَوْجَبَ الْقِرَاءَةَ
u'أَوْجَبَ قَسامَة':Predicate, #2: 2	أَوْجَبَ الْقَسَامَةَ
u'أَوْجَبَ قصاص':Predicate, #2: 2	أَوْجَبَ الْقَسَامَةَ
u'أَوْجَبَ قِصَاصٌ':Predicate, #5: 5	أَوْجَبَ الْقِصَاصَ
u'أَوْجَبَ قَطْعٌ':Predicate, #5: 5	أَوْجَبَ الْقِصَاصَ
u'أَوْجَبَ قول':Predicate, #1: 1	أَوْجَبَ الْقَطْعَ
u'أَوْجَبَ قَوْلٌ':Predicate, #1: 1	أَوْجَبَ الْقَوْلَ
u'أَوْجَبَ قول':Subject, #1: 1	أَوْجَبَ الْقَوْلَ
u'أَوْجَبَ قَوْلٌ':Subject, #1: 1	أَوْجَبَ قَوْلُهُ
u'أَوْجَبَ قَوْمٌ':Subject, #1: 1	أَوْجَبَ قَوْلُهُ
u'أَوْجَبَ قِيمَةٌ':Predicate, #1: 1	أَوْجَبَ قَوْمٌ
u'أَوْجَبَ قِيمَةٌ':Predicate, #2: 2	أَوْجَبَ الْقِيمَةَ
u'أَوْجَبَ كِتَابَةٌ':Predicate, #4: 4	أَوْجَبَ قِيمَةَ
u'أَوْجَبَ كَثْرَةٌ':Predicate, #1: 1	أَوْجَبَ كِتَابَةَ
u'أَوْجَبَ كَسْرٌ':Subject, #1: 1	أَوْجَبَ كَثْرَةَ
u'أَوْجَبَ كَفَّارٌ':Predicate, #2: 2	أَوْجَبَ الْكَسْرُ
u'أَوْجَبَ كَفَّارَةٌ':Predicate, #8: 8	أَوْجَبَ الْكَفَّارَةَ
u'أَوْجَبَ كَمَالٌ':Predicate, #8: 8	أَوْجَبَ الْكَفَّارَةَ
u'أَوْجَبَ كَوْنٌ':Predicate, #3: 3	أَوْجَبَ كَمَالَ
u'أَوْجَبَ لعان':Predicate, #2: 2	أَوْجَبَ كَوْنَ
u'أَوْجَبَ مُتْعَةٌ':Predicate, #1: 1	أَوْجَبَ اللِّعَانَ
u'أَوْجَبَ مثل':Predicate, #1: 1	أَوْجَبَ الْمُتْعَةَ
u'أَوْجَبَ مِثْلٌ':Predicate, #1: 1	أَوْجَبَ الْمِثْلَ
u'أَوْجَبَ مثل':Predicate, #1: 1	أَوْجَبَ الْمِثْلَ
u'أَوْجَبَ مِثْلٌ':Predicate, #1: 1	أَوْجَبَ مِثْلَ
u'أَوْجَبَ مَسْحٌ':Predicate, #1: 1	أَوْجَبَ مِثْلَ
u'أَوْجَبَ مُعَيَّنٌ':Predicate, #1: 1	أَوْجَبَ مَسْحَ
u'أَوْجَبَ مُمَاثَلَةٌ':Predicate, #1: 1	أَوْجَبَ الْمُعَيَّنَةَ
u'أَوْجَبَ مَهْرٌ':Predicate, #4: 4	أَوْجَبَ الْمُمَاثَلَةَ
u'أَوْجَبَ مَهْرٌ':Predicate, #2: 2	أَوْجَبَ الْمَهْرَ
u'أَوْجَبَ مُهْلَةٌ':Predicate, #4: 4	أَوْجَبَ مَهْرَ
u'أَوْجَبَ نَارٌ':Predicate, #1: 1	أَوْجَبَ الْمُهْلَةَ
u'أَوْجَبَ نَبِيٌّ':Subject, #2: 2	أَوْجَبَ النَّارَ
u'أَوْجَبَ نَصٌّ':Subject, #2: 2	أَوْجَبَ النَّبِيُّ
u'أَوْجَبَ نِصْفٌ':Predicate, #1: 1	أَوْجَبَ النَّصُّ
u'أَوْجَبَ نِصْفٌ':Predicate, #1: 1	أَوْجَبَ النِّصْفَ
u'أَوْجَبَ نَظَرٌ':Subject, #1: 1	أَوْجَبَ نِصْفَ
u'أَوْجَبَ نَفَقَةٌ':Predicate, #1: 1	أَوْجَبَ النَّظَرُ
u'أَوْجَبَ نَفْيٌ':Predicate, #2: 2	أَوْجَبَ النَّفَقَةَ
u'أَوْجَبَ نُقْصَانٌ':Predicate, #2: 2	أَوْجَبَ نَفْيَ
u'أَوْجَبَ نُقْصَانٌ':Predicate, #13: 13	أَوْجَبَ نُقْصَانَ
u'أَوْجَبَ نَقْضٌ':Predicate, #1: 1	أَوْجَبَ النُّقْصَانَ
u'أَوْجَبَ نكاح':Predicate, #1: 1	أَوْجَبَ نَقْضَ
u'أَوْجَبَ نِكَاحٌ':Predicate, #1: 1	أَوْجَبَ النِّكَاحَ
u'أَوْجَبَ نَهْيٌ':Predicate, #1: 1	أَوْجَبَ النِّكَاحَ
u'أَوْجَبَ نِيَابَةٌ':Predicate, #1: 1	أَوْجَبَ النَّهْيَ
u'أَوْجَبَ هَدْيٌ':Predicate, #1: 1	أَوْجَبَ النِّيَابَةَ
u'أَوْجَبَ واحد':Predicate, #2: 2	أَوْجَبَ الْهَدْيَ
u'أَوْجَبَ وَاحِدٌ':Predicate, #1: 1	أَوْجَبَ وَاحِدَةً
u'أَوْجَبَ وَارِثٌ':Subject, #1: 1	أَوْجَبَ وَاحِدَةً
u'أَوْجَبَ وَصِيٌّ':Predicate, #1: 1	أَوْجَبَ الْوَارِثُ
u'أَوْجَبَ وَصِيَّةٌ':Predicate, #1: 1	أَوْجَبَ الْوَصِيَّةَ
u'أَوْجَبَ وُضُوءٌ':Predicate, #1: 1	أَوْجَبَ الْوَصِيَّةَ
u'أَوْجَبَ وَقْفٌ':Predicate, #6: 6	أَوْجَبَ الْوُضُوءَ
u'أَوْجَدَ أَبٌ':Subject, #1: 1	أَوْجَبَ الْوَقْفَ
u'أَوْجَدَ حُكْمٌ':Predicate, #1: 1	أَوْجَدَ الْأَبُ
u'أَوْجَدَ خلق':Predicate, #1: 1	أَوْجَدَ الْحُكْمَ
u'أَوْجَدَ خَلْقٌ':Predicate, #1: 1	أَوْجَدَ الْخَلْقَ
u'أَوْجَدَ سَائِرٌ':Predicate, #1: 1	أَوْجَدَ الْخَلْقَ
u'أَوْجَدَ صِيغَةٌ':Predicate, #1: 1	أَوْجَدَ سَائِرَ
u'أَوْجَزَ بَعْضٌ':Subject, #1: 1	أَوْجَدَ الصِّيغَةَ
u'أوْجٌ صَحِيحٌ':Added, #1: 1	أَوْجَزَ بَعْضُ
u'أَوْجَعَ قلب':Predicate, #1: 1	أَوْجُهُ الصَّحِيحِ
u'أَوْجَعَ قَلْبٌ':Predicate, #1: 1	أَوْجَعَ قَلْبَكَ
u'أَوْجَعَ قَلْب':Predicate, #1: 1	أَوْجَعَ قَلْبَكَ
u'أوْجٌ مُصَنِّفٌ':Added, #1: 1	أَوْجَعَ قَلْبَكَ
u'أَوْجُهٌ إِبْطَالٌ':Added, #1: 1	أَوْجُهُ الْمُصَنِّفِ
u'أَوْجُهٌ إِثْبَاتٌ':Added, #1: 1	أَوْجُهِ الْإِبْطَالِ
u'أَوْجُهٌ إِحْرَامٌ':Added, #1: 1	أَوْجُهِ الْإِثْبَاتِ
u'أَوْجُهٌ أَرْبَعَةٌ':Added, #1: 1	أَوْجُهِ الْإِحْرَامِ
u'أَوْجُهٌ إلْغَاءٌ':Added, #4: 4	أَوْجُهٍ أَرْبَعَةٍ
u'أَوْجُهٌ بَحْرٌ':Added, #1: 1	أَوْجُهِ الْإِلْغَاءِ
u'أَوْجُهٌ ثَلاثَةٌ':Added, #2: 2	أَوْجُهِ الْبَحْرِ
u'أَوْجُهٌ دُخُولٌ':Added, #7: 7	أَوْجُهٍ ثَلَاثَةٍ
u'أَوْجُهٌ سَبْعَةٌ':Added, #1: 1	أَوْجُهِ دُخُولِ
u'أَوْجُهٌ صَحِيحٌ':Added, #1: 1	أَوْجُهٍ سَبْعَةٍ
u'أَوْجَهَ عرف':Predicate, #1: 1	أَوْجُهُ الصَّحِيحِ
u'أَوْجُهٌ عَمْدٌ':Added, #1: 1	أَوْجَهَ عُرِفَ
u'أَوْجُهٌ فساد':Added, #2: 2	أَوْجُهٍ عَمْدٍ
u'أَوْجُهٌ فَسَادٌ':Added, #1: 1	أَوْجُهِ الْفَسَادِ
u'أَوْجُهٌ كُفَّارٌ':Added, #1: 1	أَوْجُهِ الْفَسَادِ
u'أَوْجُهٌ مُرابَحَة':Added, #1: 1	أَوْجُهَ الْكُفّارِ
u'أَوْجُهٌ مُصَنِّفٌ':Added, #1: 1	أَوْجُهِ الْمُرَابَحَةِ
u'أَوْجُهٌ نُسُكٌ':Added, #1: 1	أَوْجُهُ الْمُصَنِّفِ
u'أَوْحَى شَيْطَانٌ':Subject, #1: 1	أَوْجُهِ النُّسُكِ
u'أَوْحَى شَيْطَانٌ':Subject, #1: 1	أَوْحَى الشَّيْطَانُ
u'أَوْدَعَ أحَدٌ':Subject, #1: 1	أَوْحَى الشّيْطَانُ
u'أَوْدَعَ إِنْسانٌ':Subject, #1: 1	أَوْدَعَ أَحَدُ
u'أَوْدَعَ بَعْضٌ':Predicate, #1: 1	أَوْدَعَ إنْسَانٌ
u'أَوْدَعَ جَارِي':Predicate, #1: 1	أَوْدَعَ بَعْضَ
u'أَوْدَعَ جَارِي':Predicate, #1: 1	أَوْدَعَ الْجَارِيَةَ
u'أَوْدَعَ جَارِيَةٌ':Predicate, #1: 1	أَوْدَعَ جَارِيَةً
u'أَوْدَعَ دَرَاهِمُ':Predicate, #1: 1	أَوْدَعَ الْجَارِيَةَ
u'أَوْدَعَ رَجُلٌ':Subject, #2: 2	أَوْدَعَ دَرَاهِمَ
u'أَوْدَعَ رَجُلٌ':Subject, #1: 1	أَوْدَعَ الرَّجُلُ
u'أَوْدَعَ صَبِيٌّ':Predicate, #9: 9	أَوْدَعَ رَجُلٌ
u'أَوْدَعَ صَبِيٌّ':Subject, #1: 1	أَوْدَعَ الصَّبِيَّ
u'أَوْدَعَ صَبِيٌّ':Subject, #1: 1	أَوْدَعَ الصَّبِيُّ
u'أَوْدَعَ عَامِلٌ':Subject, #2: 2	أَوْدَعَ صَبِيٌّ
u'أَوْدَعَ عَبْدٌ':Subject, #1: 1	أَوْدَعَ عَامِلُ
u'أَوْدَعَ عند':Predicate, #2: 2	أَوْدَعَ الْعَبْدُ
u'أَوْدَعَ غَاصِبٌ':Subject, #23: 23	أَوْدَعَ عِنْدَ
u'أَوْدَعَ غَنِيمَةٌ':Predicate, #1: 1	أَوْدَعَ غَاصِبُ
u'أَوْدَعَ لِصٌّ':Subject, #1: 1	أَوْدَعَ الْغَنِيمَةَ
u'أَوْدَعَ مَالٌ':Predicate, #1: 1	أَوْدَعَ لِصٌّ
u'أَوْدَعَ مَالِكٌ':Subject, #1: 1	أَوْدَعَ مَالَ
u'أَوْدَعَ مرٌّ':Predicate, #1: 1	أَوْدَعَ الْمَالِكُ
u'أَوْدَعَ مَرٌّ':Predicate, #1: 1	أَوْدَعَ الْمَرَّ
u'أَوْدَعَ مُرْتَهِنٌ':Subject, #1: 1	أَوْدَعَ الْمَرَّ
u'أَوْدَعَ مُسْتَعِيرٌ':Subject, #1: 1	أَوْدَعَ الْمُرْتَهِنُ
u'أَوْدَعَ مُسْلِمٌ':Subject, #1: 1	أَوْدَعَ الْمُسْتَعِيرُ
u'أَوْدَعَ مُطْلَقٌ':Subject, #1: 1	أَوْدَعَ مُسْلِمٌ
u'أَوْدَعَ مَغْصُوب':Subject, #1: 1	أَوْدَعَ مُطْلَقُ
u'أَوْدَعَ مِلْكٌ':Predicate, #1: 1	أَوْدَعَ الْمَغْصُوبُ
u'أَوْدَعَ مُودَعٌ':Predicate, #4: 4	أَوْدَعَ مِلْكَ
u'أَوْدَعَ مُودَعٌ':Subject, #1: 1	أَوْدَعَ الْمُودَعَ
u'أَوْدَعَ نصاب':Predicate, #2: 2	أَوْدَعَ الْمُودَعُ
u'أَوْدَعَ نِصَابٌ':Predicate, #1: 1	أَوْدَعَ نِصَابَ
u'أَوْدَعَ وَدِيعٌ':Subject, #1: 1	أَوْدَعَ نِصَابَ
u'أَوْدَى جَلاَبِيبُ':Subject, #1: 1	أَوْدَعَ الْوَدِيعُ
u'أَوْدَى جواد':Subject, #1: 1	أَوْدَى الْجَلَابِيبُ
u'أَوْدَى حالَةٌ':Predicate, #1: 1	أَوْدَى الْجُوَادُ
u'أَوْدَى شَبابٌ':Subject, #1: 1	أَوْدَى حَالَةَ
u'أَوْدَى شَبَابٌ':Subject, #1: 1	أَوْدَى شَبَابُ
u'أَوْدَى ضمار':Subject, #1: 1	أَوْدَى شَبَابُ
u'أَوْرَامٌ آذَانٌ':Added, #2: 2	أَوْدَى ضِمَارٌ
u'أَوْرَامٌ ثَدْيٌ':Added, #1: 1	أَوْرَامِ الْآذَانِ
u'أَوْرَامٌ دِماغٌ':Added, #1: 1	أَوْرَامِ الثَّدْيِ
u'أَوْرَامٌ رحم':Added, #1: 1	أَوْرَامِ الدِّمَاغِ
u'أَوْرَامٌ رَحِمٌ':Added, #1: 1	أَوْرَامَ الرَّحِمِ
u'أَوْرَامٌ سُفْلٌ':Added, #1: 1	أَوْرَامَ الرَّحِمِ
u'أَوْرَامٌ طِحَالٌ':Added, #1: 1	أَوْرَامِ السُّفْلِ
u'أَوْرَثَ أَحْرارٌ':Predicate, #1: 1	أَوْرَامَ الطِّحَالِ
u'أَوْرَثَ خِفٌّ':Predicate, #1: 1	أَوْرَثَ الْأَحْرَارَ
u'أَوْرَثَ خِفَّةٌ':Predicate, #1: 1	أَوْرَثَ الْخِفَّةَ
u'أَوْرَثَ وَجَعٌ':Predicate, #1: 1	أَوْرَثَ الْخِفَّةَ
u'أَوْرَدَ اِبْنٌ':Subject, #1: 1	أَوْرَثَ وَجَعَ
u'أَوْرَدَ إكْرَاهٌ':Predicate, #1: 1	أَوْرَدَ ابْنُ
u'أَوْرَدَ أَمْرٌ':Predicate, #1: 1	أَوْرَدَ الْإِكْرَاهَ
u'أَوْرَدَ بَابٌ':Predicate, #1: 1	أَوْرَدَ الْأَمْرَ
u'أَوْرَدَ بَعْضٌ':Subject, #1: 1	أَوْرَدَ بَابَ
u'أَوْرَدَ جَوَازٌ':Predicate, #1: 1	أَوْرَدَ بَعْضُ
u'أَوْرَدَ حاضِرٌ':Subject, #1: 1	أَوْرَدَ جَوَازَ
u'أَوْرَدَ حَجْرٌ':Predicate, #1: 1	أَوْرَدَ الْحَاضِرُ
u'أَوْرَدَ حَديثٌ':Predicate, #1: 1	أَوْرَدَ الْحَجْرَ
u'أَوْرَدَ حَديثٌ':Predicate, #1: 1	أَوْرَدَ الْحَدِيثَ
u'أَوْرَدَ دَلالَةٌ':Predicate, #2: 2	أَوْرَدَ حَدِيثَ
u'أَوْرَدَ دَليلٌ':Predicate, #1: 1	أَوْرَدَ دَلَالَةَ
u'أَوْرَدَ رَدٌّ':Predicate, #1: 1	أَوْرَدَ دَلِيلَ
u'أَوْرَدَ رِوايَةٌ':Predicate, #1: 1	أَوْرَدَ الرَّدَّ
u'أَوْرَدَ سَامِريٌّ':Subject, #1: 1	أَوْرَدَ رِوَايَةَ
u'أَوْرَدَ سائِل':Subject, #1: 1	أَوْرَدَ السَّامِرِيُّ
u'أَوْرَدَ سَائِلٌ':Subject, #1: 1	أَوْرَدَ السَّائِلُ
u'أَوْرَدَ سِجِلٌّ':Predicate, #1: 1	أَوْرَدَ السَّائِلُ
u'أَوْرَدَ صَاحِبٌ':Subject, #1: 1	أَوْرَدَ السِّجِلَّ
u'أَوْرَدَ صَدْرٌ':Subject, #3: 3	أَوْرَدَ صَاحِبُ
u'أَوْرَدَ عَقْدٌ':Predicate, #1: 1	أَوْرَدَ الصَّدْرُ
u'أَوْرَدَ عَقْدٌ':Predicate, #1: 1	أَوْرَدَ الْعَقْدَ
u'أَوْرَدَ علماء':Subject, #1: 1	أَوْرَدَ عَقْدَ
u'أَوْرَدَ عُلَمَاءُ':Subject, #1: 1	أَوْرَدَ الْعُلَمَاءُ
u'أَوْرَدَ غَصْبٌ':Predicate, #1: 1	أَوْرَدَ الْعُلَمَاءُ
u'أَوْرَدَ فقهاء':Subject, #1: 1	أَوْرَدَ الْغَصْبَ
u'أَوْرَدَ قسمة':Predicate, #1: 1	أَوْرَدَ الْفُقَهَاءُ
u'أَوْرَدَ قِسْمَةٌ':Predicate, #1: 1	أَوْرَدَ الْقِسْمَةَ
u'أَوْرَدَ كِتَابٌ':Predicate, #1: 1	أَوْرَدَ الْقِسْمَةَ
u'أَوْرَدَ كِتَابَةٌ':Predicate, #4: 4	أَوْرَدَ كِتَابَ
u'أَوْرَدَ كَرَاهِيَةٌ':Predicate, #1: 1	أَوْرَدَ الْكِتَابَةَ
u'أَوْرَدَ مَاءٌ':Predicate, #1: 1	أَوْرَدَ الْكَرَاهِيَةَ
u'أَوْرَدَ مَالِكٌ':Subject, #1: 1	أَوْرَدَ الْمَاءَ
u'أَوْرَدَ مَشَايِخُ':Subject, #1: 1	أَوْرَدَ مَالِكٌ
u'أَوْرَدَ مُصَنِّفٌ':Subject, #1: 1	أَوْرَدَ الْمَشَايِخُ
u'أَوْرَدَ مُلْحِدٌ':Subject, #3: 3	أَوْرَدَ الْمُصَنِّفُ
u'أَوْرَدَ نَقْضٌ':Predicate, #1: 1	أَوْرَدَ الْمُلْحِدُ
u'أَوْرَدَ وَطْءٌ':Predicate, #1: 1	أَوْرَدَ النَّقْضَ
u'أَوْرَدَ وَقْفٌ':Predicate, #1: 1	أَوْرَدَ وَطْءَ
u'أَوْرَقَ قَالٌ':Predicate, #6: 6	أَوْرَدَ الْوَقْفَ
u'أوْزَارٌ كفر':Added, #1: 1	أَوْرَقَ قَالَ
u'أَوْزَارٌ كفر':Added, #1: 1	أَوْزَارُ الْكُفْرِ
u'أوْزَارٌ كُفْرٌ':Added, #1: 1	أَوْزَارُ الْكُفْرِ
u'أَوْزَارٌ كُفْرٌ':Added, #1: 1	أَوْزَارُ الْكُفْرِ
u'أوْزَارٌ نَاسٌ':Added, #1: 1	أَوْزَارُ الْكُفْرِ
u'أَوْزَارٌ نَاسٌ':Added, #4: 4	أَوْزَارِ النَّاسِ
u'أَوْزَانٌ كَلاَمٌ':Added, #4: 4	أَوْزَارِ النَّاسِ
u'أَوْسَاخٌ ذُنُوبٌ':Added, #1: 1	أَوْزَانِ كَلَامِ
u'أَوْسَاخٌ نَاسٌ':Added, #1: 1	أَوْسَاخِ الذُّنُوبِ
u'أَوْسَاخٌ نَاسٌ':Added, #16: 16	أَوْسَاخُ النَّاسِ
u'أَوْسَاخٌ نَاسٌ':Added, #1: 1	أَوْسَاخُ النّاسِ
u'أَوْسَاخٌ نَاسٌ':Added, #3: 3	أَوْسَاخَ النَّاسِ
u'أَوْسَعَ كَلاَمٌ':Predicate, #5: 5	أَوْسَاخِ النَّاسِ
u'أَوْسَعَ مَغْفِرَةٌ':Predicate, #1: 1	أَوْسَعَ الْكَلَامَ
u'أَوْسَقَ بِغالٌ':Predicate, #1: 1	أَوْسَعَ الْمَغْفِرَةَ
u'أَوْشَكَ أَسْرَعُ':Predicate, #1: 1	أَوْسَقَ الْبِغَالَ
u'أَوْشَكَ رَجُلٌ':Subject, #1: 1	أَوْشَكَ أَسْرَعَ
u'أَوْشَكَ فَالِجٌ':Subject, #1: 1	أَوْشَكَ الرَّجُلُ
u'أَوْصَافٌ أَثْمانٌ':Added, #1: 1	أَوْشَكَ الْفَالِجُ
u'أَوْصَافٌ أَجْنَاسٌ':Added, #1: 1	أَوْصَافُ أَثْمَانٍ
u'أَوْصَافٌ أصل':Added, #1: 1	أَوْصَافِ الْأَجْنَاسِ
u'أَوْصَافٌ أًصْلٌ':Added, #1: 1	أَوْصَافُ أَصْلِهِ
u'أَوْصَافٌ أصل':Added, #1: 1	أَوْصَافُ أَصْلِهِ
u'أَوْصَافٌ أًصْلٌ':Added, #2: 2	أَوْصَافِ الْأَصْلِ
u'أَوْصَافٌ أهْلٌ':Added, #2: 2	أَوْصَافِ الْأَصْلِ
u'أَوْصَافٌ بِدَعٌ':Added, #1: 1	أَوْصَافِ أَهْلِ
u'أَوْصَافٌ بَعْضٌ':Added, #1: 1	أَوْصَافِ الْبِدَعِ
u'أَوْصَافٌ ثَمَنٌ':Added, #1: 1	أَوْصَافِ بَعْضِ
u'أَوْصَافٌ جَسَدٌ':Added, #1: 1	أَوْصَافِ الثَّمَنِ
u'أَوْصَافٌ جَلاَلٌ':Added, #1: 1	أَوْصَافِ الْجَسَدِ
u'أَوْصَافٌ جَوْزٌ':Added, #1: 1	أَوْصَافِ جَلَالِهِ
u'أَوْصَافٌ حادِثٌ':Added, #1: 1	أَوْصَافِ جَوْزَةِ
u'أَوْصَافٌ حِنْطَةٌ':Added, #1: 1	أَوْصَافِ الْحَادِثِ
u'أَوْصَافٌ حَيَوَانٌ':Added, #1: 1	أَوْصَافَ الْحِنْطَةِ
u'أَوْصَافٌ خلقة':Added, #3: 3	أَوْصَافِ الْحَيَوَانِ
u'أَوْصَافٌ خِلْقَةٌ':Added, #3: 3	أَوْصَافِ خِلْقَتِهِ
u'أَوْصَافٌ خوارج':Added, #3: 3	أَوْصَافِ خِلْقَتِهِ
u'أَوْصَافٌ خَوَارِجُ':Added, #1: 1	أَوْصَافِ الْخَوَارِجِ
u'أَوْصَافٌ خَيْرٌ':Added, #1: 1	أَوْصَافِ الْخَوَارِجِ
u'أَوْصَافٌ دَلالَةٌ':Added, #1: 1	أَوْصَافِ الْخَيْرِ
u'أَوْصَافٌ ذَهَبٌ':Added, #1: 1	أَوْصَافِ الدَّلَالَةِ
u'أَوْصَافٌ رَهْنٌ':Added, #3: 3	أَوْصَافِ الذّهَبِ
u'أَوْصَافٌ سَبْرٌ':Added, #2: 2	أَوْصَافِ الرَّهْنِ
u'أَوْصَافٌ سَبْعٌ':Added, #1: 1	أَوْصَافِ السَّبْرِ
u'أَوْصَافٌ سَلَمٌ':Added, #1: 1	أَوْصَافَ السَّبْعِ
u'أَوْصَافٌ شَارِعٌ':Added, #1: 1	أَوْصَافِ السَّلَمِ
u'أَوْصَافٌ شَهَادَةٌ':Added, #1: 1	أَوْصَافَ الشَّارِعِ
u'أَوْصَافٌ صِبْغٌ':Added, #1: 1	أَوْصَافَ الشَّهَادَةِ
u'أَوْصَافٌ طعام':Added, #1: 1	أَوْصَافُ الصِّبْغِ
u'أَوْصَافٌ طَعَامٌ':Added, #1: 1	أَوْصَافَ الطَّعَامِ
u'أَوْصَافٌ طَلاَقٌ':Added, #1: 1	أَوْصَافَ الطَّعَامِ
u'أَوْصَافٌ عِبَادٌ':Added, #1: 1	أَوْصَافِ الطَّلَاقِ
u'أَوْصَافٌ عَذِرَةٌ':Added, #1: 1	أَوْصَافِ الْعِبَادِ
u'أَوْصَافٌ عِلَّةٌ':Added, #1: 1	أَوْصَافِ الْعَذِرَةِ
u'أَوْصَافٌ عِلَّةٌ':Added, #1: 1	أَوْصَافَ عِلَّةِ
u'أَوْصَافٌ عين':Added, #7: 7	أَوْصَافِ الْعِلَّةِ
u'أَوْصَافٌ عَيْنٌ':Added, #1: 1	أَوْصَافِ الْعَيْنِ
u'أَوْصَافٌ عَيْن':Added, #1: 1	أَوْصَافِ الْعَيْنِ
u'أَوْصَافٌ فضلاء':Added, #1: 1	أَوْصَافِ الْعَيْنِ
u'أَوْصَافٌ فُضَلاَءُ':Added, #1: 1	أَوْصَافِ الْفُضَلَاءِ
u'أَوْصَافٌ كَمَالٌ':Added, #1: 1	أَوْصَافِ الْفُضَلَاءِ
u'أَوْصَافٌ لَفْظٌ':Added, #3: 3	أَوْصَافِ الْكَمَالِ
u'أَوْصَافٌ مَاءٌ':Added, #2: 2	أَوْصَافِ اللَّفْظِ
u'أَوْصَافٌ مَالٌ':Added, #4: 4	أَوْصَافِ الْمَاءِ
u'أَوْصَافٌ مُبْتَدِعٌ':Added, #1: 1	أَوْصَافِ مَالِهِ
u'أَوْصَافٌ مَبِيعٌ':Added, #2: 2	أَوْصَافِ الْمُبْتَدِعَةِ
u'أَوْصَافٌ مَحَلٌّ':Added, #3: 3	أَوْصَافِ الْمَبِيعِ
u'أَوْصَافٌ مَحَلٌّ':Added, #1: 1	أَوْصَافَ الْمَحَلِّ
u'أَوْصَافٌ مَخْلُوقٌ':Added, #2: 2	أَوْصَافِ الْمَحَلِّ
u'أَوْصَافٌ مَدْحٌ':Added, #1: 1	أَوْصَافِ الْمَخْلُوقَاتِ
u'أَوْصَافٌ مُسَلَّمٌ':Added, #1: 1	أَوْصَافِ الْمَدْحِ
u'أَوْصَافٌ مُسَلَّمٌ':Added, #1: 1	أَوْصَافُ الْمُسَلَّمِ
u'أَوْصَافٌ مُضَعَّفٌ':Added, #1: 1	أَوْصَافِ الْمُسَلَّمِ
u'أَوْصَافٌ مَغْصُوب':Added, #1: 1	أَوْصَافِ الْمُضَعَّفِ
u'أَوْصَافٌ نَاسٌ':Added, #1: 1	أَوْصَافِ الْمَغْصُوبِ
u'أَوْصَافٌ نَجَاسَةٌ':Added, #1: 1	أَوْصَافُ النَّاسِ
u'أَوْصَافٌ نَجَاسَةٌ':Added, #1: 1	أَوْصَافَ النَّجَاسَةِ
u'أَوْصَافٌ نِساءٌ':Added, #1: 1	أَوْصَافُ النَّجَاسَةِ
u'أَوْصَافٌ نَصٌّ':Added, #1: 1	أَوْصَافِ النِّسَاءِ
u'أَوْصَافٌ نَعِيمٌ':Added, #1: 1	أَوْصَافِ النَّصِّ
u'أَوْصَافٌ نَقْصٌ':Added, #1: 1	أَوْصَافِ النّعِيمِ
u'أَوْصَافٌ نُقْصَانٌ':Added, #1: 1	أَوْصَافُ نَقْصٍ
u'أَوْصَافٌ نَوْعٌ':Added, #2: 2	أَوْصَافِ النُّقْصَانِ
u'أَوْصَافٌ نِيلٌ':Added, #1: 1	أَوْصَافُ نَوْعِ
u'أَوْصَلَ إيقَاعٌ':Predicate, #1: 1	أَوْصَافِ النِّيلِ
u'أَوْصَلَ تُرَابٌ':Predicate, #1: 1	أَوْصَلَ الْإِيقَاعَ
u'أَوْصَلَ حَجيجٌ':Predicate, #1: 1	أَوْصَلَ التُّرَابَ
u'أَوْصَلَ حَقٌّ':Predicate, #1: 1	أَوْصَلَ الْحَجِيجَ
u'أَوْصَلَ صَبِيٌّ':Subject, #6: 6	أَوْصَلَ الْحَقَّ
u'أَوْصَلَ كِتَابٌ':Predicate, #1: 1	أَوْصَلَ صَبِيٌّ
u'أَوْصَى اِبْنٌ':Subject, #1: 1	أَوْصَلَ الْكِتَابَ
u'أَوْصَى أحَدٌ':Subject, #2: 2	أَوْصَى ابْنُ
u'أَوْصَى بَعْضٌ':Predicate, #2: 2	أَوْصَى أَحَدُ
u'أَوْصَى تَبَرُّعٌ':Subject, #2: 2	أَوْصَى بَعْضَ
u'أَوْصَى جَارٌ':Predicate, #1: 1	أَوْصَى تَبَرُّعٌ
u'أَوْصَى حارِثٌ':Subject, #1: 1	أَوْصَى جَارَ
u'أَوْصَى حَمْز':Subject, #1: 1	أَوْصَى الْحَارِثُ
u'أَوْصَى خَانٌ':Predicate, #1: 1	أَوْصَى حَمْزَةُ
u'أَوْصَى ذِمِّيٌّ':Subject, #1: 1	أَوْصَى خَانَ
u'أَوْصَى ذِمِّيٌّ':Subject, #4: 4	أَوْصَى ذِمِّيٌّ
u'أَوْصَى رَبِيعٌ':Subject, #5: 5	أَوْصَى الذِّمِّيُّ
u'أَوْصَى رَجُلٌ':Subject, #1: 1	أَوْصَى الرَّبِيعُ
u'أَوْصَى رَجُلٌ':Subject, #17: 17	أَوْصَى رَجُلٌ
u'أَوْصَى رَسُولٌ':Subject, #22: 22	أَوْصَى الرَّجُلُ
u'أَوْصَى سَعْدٌ':Subject, #1: 1	أَوْصَى رَسُولُ
u'أَوْصَى شَخْصٌ':Subject, #1: 1	أَوْصَى سَعْدُ
u'أَوْصَى شَخْصٌ':Subject, #1: 1	أَوْصَى الشَّخْصُ
u'أَوْصَى صَبِيٌّ':Subject, #2: 2	أَوْصَى شَخْصٌ
u'أَوْصَى عَبْدٌ':Subject, #1: 1	أَوْصَى الصَّبِيُّ
u'أَوْصَى عَبْدٌ':Subject, #1: 1	أَوْصَى الْعَبْدُ
u'أَوْصَى عند':Predicate, #2: 2	أَوْصَى عَبْدُ
u'أَوْصَى فلان':Subject, #5: 5	أَوْصَى عِنْدَ
u'أَوْصَى فُلاَنٌ':Subject, #1: 1	أَوْصَى حَمْزَةُ
u'أَوْصَى فُلاَنٌ':Subject, #1: 1	أَوْصَى فُلَانٌ
u'أَوْصَى مَالٌ':Subject, #1: 1	أَوْصَى فُلَانُ
u'أَوْصَى مَجْنُونٌ':Subject, #1: 1	أَوْصَى مَالٌ
u'أَوْصَى مَرِيضٌ':Subject, #1: 1	أَوْصَى الْمَجْنُونُ
u'أَوْصَى مُسْلِمٌ':Subject, #2: 2	أَوْصَى الْمَرِيضُ
u'أَوْصَى مُسْلِمٌ':Subject, #2: 2	أَوْصَى الْمُسْلِمُ
u'أَوْصَى مُوَرِّث':Subject, #4: 4	أَوْصَى مُسْلِمٌ
u'أَوْصَى نَبِيٌّ':Subject, #1: 1	أَوْصَى الْمُوَرِّثُ
u'أَوْصَى نَصْرَانِيٌّ':Subject, #1: 1	أَوْصَى النَّبِيُّ
u'أَوْصَى وَاقِفٌ':Subject, #1: 1	أَوْصَى نَصْرَانِيٌّ
u'أَوْصَى وَصِيٌّ':Predicate, #1: 1	أَوْصَى الْوَاقِفُ
u'أَوْصَى وَصِيٌّ':Subject, #1: 1	أَوْصَى وَصِيَّةً
u'أَوْصَى وَلَهٌ':Subject, #1: 1	أَوْصَى الْوَصِيُّ
u'أَوْصَى يَوْمٌ':Predicate, #6: 6	أَوْصَى وَلَهُ
u'أَوْضَاحٌ فِضَّةٌ':Added, #1: 1	أَوْصَى يَوْمَ
u'أَوْضَاعٌ تَصَرُّفٌ':Added, #1: 1	أَوْضَاحَ فِضَّةٍ
u'أَوْضَاعٌ شَرْعٌ':Added, #2: 2	أَوْضَاعِ التَّصَرُّفَاتِ
u'أَوْضَاعٌ شَرِيعَةٌ':Added, #2: 2	أَوْضَاعِ الشَّرْعِ
u'أَوْضَاعٌ لُغَةٌ':Added, #1: 1	أَوْضَاعِ الشَّرِيعَةِ
u'أَوْضَاعٌ مَسَاكِنُ':Added, #2: 2	أَوْضَاعِ اللُّغَةِ
u'أَوْضَاعٌ مَسَائِلُ':Added, #1: 1	أَوْضَاعِ الْمَسَاكِنِ
u'أَوْضَحَ اِبْنٌ':Subject, #1: 1	أَوْضَاعَ الْمَسَائِلِ
u'أَوْضَحَ إمَامٌ':Subject, #2: 2	أَوْضَحَ ابْنُ
u'أَوْضَحَ سَبِيلٌ':Predicate, #2: 2	أَوْضَحَ الْإِمَامُ
u'أَوْضَحَ شَخْصٌ':Subject, #2: 2	أَوْضَحَ السَّبِيلَ
u'أَوْضَحَ عَظْمٌ':Predicate, #1: 1	أَوْضَحَ شَخْصٌ
u'أَوْضَحَ فرق':Predicate, #1: 1	أَوْضَحَ الْعَظْمَ
u'أَوْضَحَ فَرْقٌ':Predicate, #1: 1	أَوْضَحَ الْفَرْقَ
u'أَوْضَحَ قَفَّالٌ':Subject, #1: 1	أَوْضَحَ الْفَرْقَ
u'أَوْضَحَ مُتَلاَحِمٌ':Predicate, #1: 1	أَوْضَحَ الْقَفَّالُ
u'أَوْضَحَ مَحَجَّةٌ':Predicate, #1: 1	أَوْضَحَ مُتَلَاحِمَةً
u'أَوْضَحَ مَسْأَلَةٌ':Predicate, #1: 1	أَوْضَحَ الْمَحَجَّةَ
u'أَوْضَحَ مُصَنِّفٌ':Subject, #1: 1	أَوْضَحَ الْمَسْأَلَةَ
u'أَوْضَحَ مَقَامٌ':Predicate, #1: 1	أَوْضَحَ الْمُصَنِّفُ
u'أَوْضَحَ واحد':Subject, #2: 2	أَوْضَحَ الْمَقَامَ
u'أَوْضَحَ وَاحِدٌ':Subject, #1: 1	أَوْضَحَ وَاحِدٌ
u'أَوْضَحَ وَقْتٌ':Predicate, #1: 1	أَوْضَحَ وَاحِدٌ
u'أَوْطَأَ إِسْلامٌ':Subject, #1: 1	أَوْضَحَ الْوَقْتَ
u'أَوْطَنَ فلان':Predicate, #1: 1	أَوْطَأَ الْإِسْلَامُ
u'أَوْطَنَ كُوفَةٌ':Predicate, #1: 1	أَوْطَنَ مَكَّةَ
u'أَوْعَبَ رَأْسٌ':Predicate, #1: 1	أَوْطَنَ الْكُوفَةَ
u'أَوْعَبَ فَرْضٌ':Predicate, #1: 1	أَوْعَبَ رَأْسَ
u'أَوْعَدَ عَاصِي':Predicate, #1: 1	أَوْعَبَ الْفَرْضَ
u'أَوْعَدَ نَبِيٌّ':Subject, #1: 1	أَوْعَدَ الْعَاصِيَ
u'أَوْغَلَ حَديدَةٌ':Predicate, #2: 2	أَوْعَدَ النَّبِيُّ
u'أَوْغَلَ خَلْقٌ':Subject, #1: 1	أَوْغَلَ الْحَدِيدَةَ
u'أَوْفَرَ ثَمَنٌ':Predicate, #1: 1	أَوْغَلَ خَلْقٌ
u'أَوْفَى بَعْضٌ':Predicate, #1: 1	أَوْفَرَ الثَّمَنَ
u'أَوْفَى ثَلاثُ':Predicate, #5: 5	أَوْفَى بَعْضَ
u'أَوْفَى ثَمَنٌ':Predicate, #1: 1	أَوْفَى ثَلَاثَ
u'أَوْفَى جِوَارٌ':Subject, #1: 1	أَوْفَى الثَّمَنَ
u'أَوْفَى دَيْنٌ':Predicate, #1: 1	أَوْفَى جِوَارُ
u'أَوْفَى صَاحِبٌ':Predicate, #2: 2	أَوْفَى الدَّيْنَ
u'أَوْفَى فُلاَنٌ':Subject, #1: 1	أَوْفَى صَاحِبَ
u'أَوْفَى قَالٌ':Predicate, #1: 1	أَوْفَى فُلَانٌ
u'أَوْفَى مثل':Subject, #27: 27	أَوْفَى قَالَ
u'أَوْفَى مِثْلٌ':Subject, #2: 2	أَوْفَى مِثْلُهُ
u'أَوْفَى مَظْلُومٌ':Predicate, #2: 2	أَوْفَى مِثْلُهُ
u'أَوْفَى نَاسٌ':Subject, #1: 1	أَوْفَى الْمَظْلُومَةَ
u'أَوْقَاتٌ إِجَابَةٌ':Added, #1: 1	أَوْفَى النَّاسُ
u'أَوْقَاتٌ أخْذٌ':Added, #3: 3	أَوْقَاتِ الْإِجَابَةِ
u'أَوْقَاتٌ اِسْتِرَاحَةٌ':Added, #1: 1	أَوْقَاتِ أَخْذِهِ
u'أَوْقَاتٌ أكل':Added, #1: 1	أَوْقَاتِ اسْتِرَاحَةٍ
u'أَوْقَاتٌ أَكْلٌ':Added, #1: 1	أَوْقَاتِ أَكْلِهِ
u'أَوْقَاتٌ إِمْكانٌ':Added, #1: 1	أَوْقَاتِ أَكْلِهِ
u'أَوْقَاتٌ إِمْكانٌ':Added, #12: 12	أَوْقَاتِ الْإِمْكَانِ
u'أَوْقَاتٌ إهْلاَلٌ':Added, #1: 1	أَوْقَاتِ إمْكَانِهِ
u'أَوْقَاتٌ بُخارٌ':Added, #1: 1	أَوْقَاتُ الْإِهْلَالِ
u'أَوْقَاتٌ تَحَقُّقٌ':Added, #1: 1	أَوْقَاتِ الْبُخَارَيْنِ
u'أَوْقَاتٌ تَعْلِيمٌ':Added, #1: 1	أَوْقَاتَ تَحَقُّقِ
u'أَوْقَاتٌ تَلْقِين':Added, #2: 2	أَوْقَاتِ التَّعْلِيمِ
u'أَوْقَاتٌ تَمَكُّنٌ':Added, #1: 1	أَوْقَاتِ التَّلْقِينِ
u'أَوْقَاتٌ تَهَجُّدٌ':Added, #1: 1	أَوْقَاتِ التَّمَكُّنِ
u'أَوْقَاتٌ جَوَازٌ':Added, #1: 1	أَوْقَاتِ التَّهَجُّدِ
u'أَوْقَاتٌ جَوَازٌ':Added, #1: 1	أَوْقَاتُ الْجَوَازِ
u'أَوْقَاتٌ حَيْضٌ':Added, #1: 1	أَوْقَاتِ الْجَوَازِ
u'أَوْقَاتٌ خَاصَّةٌ':Added, #3: 3	أَوْقَاتِ الْحَيْضِ
u'أَوْقَاتٌ خُطَبٌ':Added, #1: 1	أَوْقَاتٍ خَاصَّةٍ
u'أَوْقَاتٌ خَلَوَاتٌ':Added, #1: 1	أَوْقَاتَ الْخُطَبِ
u'أَوْقَاتٌ خَلْوَةٌ':Added, #1: 1	أَوْقَاتَ الْخَلَوَاتِ
u'أَوْقَاتٌ خَلْوَةٌ':Added, #1: 1	أَوْقَاتُ الْخَلْوَةِ
u'أَوْقَاتٌ دُخُولٌ':Added, #1: 1	أَوْقَاتُ خَلْوَةٍ
u'أَوْقَاتٌ دَهْرٌ':Added, #1: 1	أَوْقَاتِ الدُّخُولِ
u'أَوْقَاتٌ رَاحَةٌ':Added, #1: 1	أَوْقَاتِ دَهْرِهِ
u'أَوْقَاتٌ رَغْبَةٌ':Added, #2: 2	أَوْقَاتِ الرَّاحَةِ
u'أَوْقَاتٌ رَمْيٌ':Added, #1: 1	أَوْقَاتِ الرَّغْبَةِ
u'أَوْقَاتٌ رَمْيٌ':Added, #1: 1	أَوْقَاتَ الرَّمْيِ
u'أَوْقَاتٌ زَمانٌ':Added, #1: 1	أَوْقَاتِ الرَّمْيِ
u'أَوْقَاتٌ سَائِرٌ':Added, #1: 1	أَوْقَاتِ الزَّمَانِ
u'أَوْقَاتٌ سِتٌّ':Added, #1: 1	أَوْقَاتِ سَائِرِ
u'أَوْقَاتٌ سِتٌّ':Added, #1: 1	أَوْقَاتُ سِتِّ
u'أَوْقَاتٌ سَقْيٌ':Added, #2: 2	أَوْقَاتِ سِتِّ
u'أَوْقَاتٌ سَنَةٌ':Added, #1: 1	أَوْقَاتِ السَّقْيِ
u'أَوْقَاتٌ سُنَّةٌ':Added, #2: 2	أَوْقَاتِ السَّنَةِ
u'أَوْقَاتٌ سُنَّةٌ':Added, #2: 2	أَوْقَاتَ السُّنَّةِ
u'أَوْقَاتٌ شدائد':Added, #3: 3	أَوْقَاتِ السُّنَّةِ
u'أَوْقَاتٌ صِحَّةٌ':Added, #1: 1	أَوْقَاتِ الشَّدَائِدِ
u'أَوْقَاتٌ صِحَّةٌ':Added, #1: 1	أَوْقَاتُ الصِّحَّةِ
u'أَوْقَاتٌ صِحَّةٌ':Added, #1: 1	أَوْقَاتِ صِحَّتِهِ
u'أَوْقَاتٌ صَلاَةٌ':Added, #2: 2	أَوْقَاتِ الصِّحَّةِ
u'أَوْقَاتٌ صَلاَةٌ':Added, #1: 1	أَوْقَاتِ الصَّلاَةِ
u'أَوْقَاتٌ صَلاَةٌ':Added, #25: 25	أَوْقَاتِ الصَّلَاةِ
u'أَوْقَاتٌ صَلاَةٌ':Added, #2: 2	أَوْقَاتُ الصَّلَاةِ
u'أَوْقَاتٌ صَلَوَاتٌ':Added, #4: 4	أَوْقَاتَ الصَّلَاةِ
u'أَوْقَاتٌ صَلَوَاتٌ':Added, #10: 10	أَوْقَاتِ الصَّلَوَاتِ
u'أَوْقَاتٌ صَلَوَاتٌ':Added, #1: 1	أَوْقَاتَ الصّلَوَاتِ
u'أَوْقَاتٌ صَوْمٌ':Added, #2: 2	أَوْقَاتَ الصَّلَوَاتِ
u'أَوْقَاتٌ طَلاَقٌ':Added, #1: 1	أَوْقَاتُ الصَّوْمِ
u'أَوْقَاتٌ طلب':Added, #1: 1	أَوْقَاتِ طَلَاقِ
u'أَوْقَاتٌ طَلَبٌ':Added, #1: 1	أَوْقَاتِ الطَّلَبِ
u'أَوْقَاتٌ طهر':Added, #1: 1	أَوْقَاتِ الطَّلَبِ
u'أَوْقَاتٌ طهر':Added, #1: 1	أَوْقَاتُ الطُّهْرِ
u'أَوْقَاتٌ طُهْرٌ':Added, #1: 1	أَوْقَاتِ الطُّهْرِ
u'أَوْقَاتٌ طُهْرٌ':Added, #1: 1	أَوْقَاتُ الطُّهْرِ
u'أَوْقَاتٌ ظُهورٌ':Added, #1: 1	أَوْقَاتِ الطُّهْرِ
u'أَوْقَاتٌ عَذَابٌ':Added, #1: 1	أَوْقَاتِ ظُهُورِهِ
u'أَوْقَاتٌ عُمُرٌ':Added, #1: 1	أَوْقَاتَ عَذَابٍ
u'أَوْقَاتٌ غُسْلٌ':Added, #1: 1	أَوْقَاتِ الْعُمُرِ
u'أَوْقَاتٌ غفلة':Added, #1: 1	أَوْقَاتِ الْغُسْلِ
u'أَوْقَاتٌ غَفْلَةٌ':Added, #1: 1	أَوْقَاتِ غَفْلَتِهِ
u'أَوْقَاتٌ فراغ':Added, #1: 1	أَوْقَاتِ غَفْلَتِهِ
u'أَوْقَاتٌ فَرَاغٌ':Added, #1: 1	أَوْقَاتِ الْفَرَاغِ
u'أَوْقَاتٌ فِعْلٌ':Added, #1: 1	أَوْقَاتِ الْفَرَاغِ
u'أَوْقَاتٌ كَرَاهَةٌ':Added, #1: 1	أَوْقَاتِ الْفِعْلِ
u'أَوْقَاتٌ كَرَاهَةٌ':Added, #1: 1	أَوْقَاتَ الْكَرَاهَةِ
u'أَوْقَاتٌ كَرَاهِيَةٌ':Added, #7: 7	أَوْقَاتِ الْكَرَاهَةِ
u'أَوْقَاتٌ لَيْلٌ':Added, #1: 1	أَوْقَاتِ الْكَرَاهِيَةِ
u'أَوْقَاتٌ مُسَافِرٌ':Added, #1: 1	أَوْقَاتِ اللَّيْلِ
u'أَوْقَاتٌ مَقِيلٌ':Added, #1: 1	أَوْقَاتُ الْمُسَافِرِ
u'أَوْقَاتٌ مَكْرُوهَةٌ':Added, #1: 1	أَوْقَاتُ الْمَقِيلِ
u'أَوْقَاتٌ مَوْتٌ':Added, #2: 2	أَوْقَاتٍ مَكْرُوهَةٍ
u'أَوْقَاتٌ نهار':Added, #1: 1	أَوْقَاتِ مَوْتِهِ
u'أَوْقَاتٌ نَهَارٌ':Added, #2: 2	أَوْقَاتِ النَّهَارِ
u'أَوْقَاتٌ نَهْيٌ':Added, #2: 2	أَوْقَاتِ النَّهَارِ
u'أَوْقَاتٌ نَهْيٌ':Added, #13: 13	أَوْقَاتِ النَّهْيِ
u'أَوْقَاتٌ وُضُوءٌ':Added, #4: 4	أَوْقَاتَ النَّهْيِ
u'أَوْقَاتٌ يَوْمٌ':Added, #1: 1	أَوْقَاتِ الْوُضُوءِ
u'أَوْقَافٌ إمَامٌ':Added, #1: 1	أَوْقَاتِ الْيَوْمِ
u'أَوْقَافٌ إمَامَةٌ':Added, #2: 2	أَوْقَافِ الْإِمَامِ
u'أَوْقَافٌ صَحَابَةٌ':Added, #1: 1	أَوْقَافِ الْإِمَامَةِ
u'أَوْقَافٌ قَاهِرٌ':Added, #1: 1	أَوْقَافُ الصَّحَابَةِ
u'أَوْقَافٌ مَدَارِسُ':Added, #1: 1	أَوْقَافِ الْقَاهِرَةِ
u'أَوْقَافٌ مَسَاجِدُ':Added, #1: 1	أَوْقَافِ الْمَدَارِسِ
u'أَوْقَافٌ مَسْجِدٌ':Added, #1: 1	أَوْقَافِ الْمَسَاجِدِ
u'أَوْقَافٌ هِلاَلٌ':Added, #13: 13	أَوْقَافِ الْمَسْجِدِ
u'أَوْقَدَ حَرْبٌ':Predicate, #1: 1	أَوْقَافِ هِلَالٍ
u'أَوْقَدَ رَجُلٌ':Subject, #1: 1	أَوْقَدَ الْحَرْبَ
u'أَوْقَدَ شَجَرٌ':Predicate, #1: 1	أَوْقَدَ رَجُلٌ
u'أَوْقَدَ شَمْعٌ':Predicate, #1: 1	أَوْقَدَ الشَّجَرَ
u'أَوْقَدَ صِبْيَانٌ':Subject, #1: 1	أَوْقَدَ الشّمْعَ
u'أَوْقَدَ مثل':Predicate, #1: 1	أَوْقَدَ الصِّبْيَانُ
u'أَوْقَدَ مِثْلٌ':Predicate, #1: 1	أَوْقَدَ مِثْلَ
u'أَوْقَدَ نَارٌ':Predicate, #1: 1	أَوْقَدَ مِثْلَ
u'أَوْقَعَ إجَارَةٌ':Predicate, #11: 11	أَوْقَدَ النَّارَ
u'أَوْقَعَ أَجْزَاءٌ':Predicate, #1: 1	أَوْقَعَ الْإِجَارَةَ
u'أَوْقَعَ أحَدٌ':Predicate, #1: 1	أَوْقَعَ أَجْزَاءَ
u'أَوْقَعَ إِشْكالٌ':Predicate, #1: 1	أَوْقَعَ أَحَدَ
u'أَوْقَعَ إِعْتاقٌ':Predicate, #1: 1	أَوْقَعَ الْإِشْكَالَ
u'أَوْقَعَ أقَلُّ':Predicate, #1: 1	أَوْقَعَ الْإِعْتَاقَ
u'أَوْقَعَ إمَامٌ':Subject, #1: 1	أَوْقَعَ أَقَلَّ
u'أَوْقَعَ إمَامٌ':Subject, #1: 1	أَوْقَعَ الْإِمَامُ
u'أَوْقَعَ إِنْسانٌ':Subject, #1: 1	أَوْقَعَ إمَامُ
u'أَوْقَعَ بَعْضٌ':Predicate, #1: 1	أَوْقَعَ إنْسَانٌ
u'أَوْقَعَ بَيْنٌ':Predicate, #3: 3	أَوْقَعَ بَعْضَ
u'أَوْقَعَ بَيْنٌ':Predicate, #2: 2	أَوْقَعَ بَيْنَ
u'أَوْقَعَ تَبَرُّعٌ':Predicate, #3: 3	أَوْقَعَ بَيْنَهُنَّ
u'أَوْقَعَ ثَانِي':Predicate, #1: 1	أَوْقَعَ التَّبَرُّعَ
u'أَوْقَعَ ثَانِيَةٌ':Predicate, #3: 3	أَوْقَعَ الثَّانِيَةَ
u'أَوْقَعَ ثَلاثُ':Predicate, #3: 3	أَوْقَعَ الثَّانِيَةَ
u'أَوْقَعَ ثَلاثُ':Predicate, #17: 17	أَوْقَعَ الثَّلَاثَ
u'أَوْقَعَ ثَمَنٌ':Predicate, #1: 1	أَوْقَعَ ثَلَاثَ
u'أَوْقَعَ جَمْعٌ':Subject, #1: 1	أَوْقَعَ الثَّمَنَ
u'أَوْقَعَ رَافِضٌ':Predicate, #1: 1	أَوْقَعَ جَمْعٌ
u'أَوْقَعَ رَافِضَةٌ':Predicate, #1: 1	أَوْقَعَ الرَّافِضَةَ
u'أَوْقَعَ سَوْطٌ':Predicate, #1: 1	أَوْقَعَ الرَّافِضَةَ
u'أَوْقَعَ شَارِحٌ':Predicate, #1: 1	أَوْقَعَ السَّوْطَ
u'أَوْقَعَ صَلاَةٌ':Predicate, #1: 1	أَوْقَعَ الشَّارِحَ
u'أَوْقَعَ صنعة':Subject, #1: 1	أَوْقَعَ الصَّلَاةَ
u'أَوْقَعَ صَنْعَةٌ':Subject, #1: 1	أَوْقَعَ صَنْعَتُهُ
u'أَوْقَعَ طَلاَقٌ':Predicate, #1: 1	أَوْقَعَ صَنْعَتُهُ
u'أَوْقَعَ طواف':Predicate, #36: 36	أَوْقَعَ الطَّلَاقَ
u'أَوْقَعَ طَوَافٌ':Predicate, #1: 1	أَوْقَعَ الطَّوَافَ
u'أَوْقَعَ عتق':Predicate, #1: 1	أَوْقَعَ الطَّوَافَ
u'أَوْقَعَ عِتْقٌ':Predicate, #10: 10	أَوْقَعَ الْعِتْقَ
u'أَوْقَعَ عتق':Predicate, #10: 10	أَوْقَعَ الْعِتْقَ
u'أَوْقَعَ عَقْدٌ':Predicate, #1: 1	أَوْقَعَ عَتَقَ
u'أَوْقَعَ غضب':Predicate, #1: 1	أَوْقَعَ الْعَقْدَ
u'أَوْقَعَ غَضَبٌ':Predicate, #1: 1	أَوْقَعَ الْغَضَبَ
u'أَوْقَعَ قَائِلٌ':Subject, #1: 1	أَوْقَعَ الْغَضَبَ
u'أَوْقَعَ مَحْظُورٌ':Predicate, #1: 1	أَوْقَعَ قَائِلُ
u'أَوْقَعَ مُدَبَّرٌ':Subject, #1: 1	أَوْقَعَ الْمَحْظُورَ
u'أَوْقَعَ مِلْكٌ':Predicate, #1: 1	أَوْقَعَ الْمُدَبَّرُ
u'أَوْقَعَ نَاسٌ':Predicate, #1: 1	أَوْقَعَ مِلْكَ
u'أَوْقَعَ واحد':Predicate, #1: 1	أَوْقَعَ النَّاسَ
u'أَوْقَعَ وَاحِدٌ':Predicate, #3: 3	أَوْقَعَ الْوَاحِدَةَ
u'أَوْقَعَ واحد':Predicate, #3: 3	أَوْقَعَ الْوَاحِدَةَ
u'أَوْقَعَ وَاحِدٌ':Predicate, #5: 5	أَوْقَعَ وَاحِدَةً
u'أَوْقَفَ أرْضٌ':Predicate, #5: 5	أَوْقَعَ وَاحِدَةً
u'أَوْقَفَ إمَامٌ':Subject, #1: 1	أَوْقَفَ الْأَرْضَ
u'أَوْقَفَ دَابَّةٌ':Predicate, #1: 1	أَوْقَفَ الْإِمَامُ
u'أَوْقَفَ رَجُلٌ':Predicate, #2: 2	أَوْقَفَ الدَّابَّةَ
u'أَوْقَفَ رَجُلٌ':Subject, #1: 1	أَوْقَفَ رَجُلاً
u'أَوْقَفَ عَبْدٌ':Subject, #2: 2	أَوْقَفَ الرَّجُلُ
u'أَوْقَفَ عَكْسٌ':Subject, #1: 1	أَوْقَفَ الْعَبْدُ
u'أَوْقَفَ عُمَرٌ':Subject, #1: 1	أَوْقَفَ عَكْسُ
u'أَوَّلَ اِبْنٌ':Subject, #1: 1	أَوْقَفَ عُمَرُ
u'أَوَّلَ آيَةٌ':Predicate, #1: 1	أَوَّلَ ابْنُ
u'أَوَّلَ بَزَّارٌ':Subject, #1: 1	أَوَّلَ الْآيَةَ
u'أَوَّلَ بَعْضٌ':Subject, #1: 1	أَوَّلَ الْبَزَّارُ
u'أَوَّلَ تَمُّوز':Predicate, #2: 2	أَوَّلَ بَعْضُ
u'أَوْلَجَ أحَدٌ':Predicate, #1: 1	أَوَّلَ تَمُّوزَ
u'أَوْلَجَ حَشَفَةٌ':Predicate, #1: 1	أَوْلَجَ أَحَدَ
u'أَوْلَجَ رَجُلٌ':Subject, #3: 3	أَوْلَجَ الْحَشَفَةَ
u'أَوْلَجَ شَيْخٌ':Subject, #6: 6	أَوْلَجَ رَجُلٌ
u'أَوْلَجَ صَبِيٌّ':Subject, #2: 2	أَوْلَجَ الشَّيْخُ
u'أَوْلَجَ غير':Subject, #1: 1	أَوْلَجَ صَبِيٌّ
u'أَوْلَجَ غَيْرٌ':Subject, #1: 1	أَوْلَجَ غَيْرُهُ
u'أَوَّلَ جَمَاعَةٌ':Subject, #1: 1	أَوْلَجَ غَيْرُهُ
u'أَوَّلَ حَنَفِيَّةٌ':Subject, #1: 1	أَوَّلَ جَمَاعَةٌ
u'أَوْلَدَ أَبٌ':Subject, #1: 1	أَوَّلَ الْحَنَفِيَّةُ
u'أَوْلَدَ أحَدٌ':Subject, #1: 1	أَوْلَدَ الْأَبُ
u'أَوْلَدَ أمَةٌ':Predicate, #1: 1	أَوْلَدَ أَحَدُ
u'أَوْلَدَ أمَةٌ':Predicate, #3: 3	أَوْلَدَ الْأَمَةَ
u'أَوْلَدَ بِنْتٌ':Predicate, #6: 6	أَوْلَدَ أَمَةَ
u'أَوْلَدَ جَارِي':Predicate, #1: 1	أَوْلَدَ بِنْتَ
u'أَوْلَدَ حُرٌّ':Subject, #2: 2	أَوْلَدَ جَارِيَةً
u'أَوْلَدَ رَجُلٌ':Subject, #1: 1	أَوْلَدَ حُرٌّ
u'أَوْلَدَ عَبْدٌ':Subject, #1: 1	أَوْلَدَ الرَّجُلُ
u'أَوْلَدَ مُرْتَدٌّ':Subject, #1: 1	أَوْلَدَ عَبْدٌ
u'أَوْلَدَ مُسْلِمٌ':Subject, #1: 1	أَوْلَدَ مُرْتَدٌّ
u'أَوْلَدَ مُكَاتَبَةٌ':Predicate, #1: 1	أَوْلَدَ الْمُسْلِمُ
u'أَوْلَدَ مُكَاتَبَةٌ':Predicate, #1: 1	أَوْلَدَ الْمُكَاتَبَةَ
u'أَوَّلَ رَجُلٌ':Subject, #1: 1	أَوْلَدَ مُكَاتَبَةَ
u'أَوَّلَ رَمَضانُ':Predicate, #1: 1	أَوَّلَ رَجُلٌ
u'أَوَّلَ زائِدٌ':Subject, #4: 4	أَوَّلَ رَمَضَانَ
u'أَوَّلَ شَيْخٌ':Subject, #1: 1	أَوَّلَ زَائِدَةٌ
u'أَوْلٌ صَحَابَةٌ':Added, #1: 1	أَوَّلَ الشَّيْخُ
u'أَوَّلَ طرف':Predicate, #1: 1	أَوْلُ صَحَابَةِ
u'أَوَّلَ طَرَفٌ':Predicate, #1: 1	أَوَّلَ الطَّرَفَ
u'أَوَّلَ عتق':Predicate, #1: 1	أَوَّلَ الطَّرَفَ
u'أَوَّلَ قول':Predicate, #1: 1	أَوَّلَ عَتَقَ
u'أَوَّلَ قَوْلٌ':Predicate, #1: 1	أَوَّلَ قَوْلَ
u'أَوَّلَ كَلاَمٌ':Predicate, #1: 1	أَوَّلَ قَوْلَ
u'أَوَّلَ مرٌّ':Predicate, #1: 1	أَوَّلَ كَلَامَ
u'أَوَّلَ مَسْأَلَةٌ':Predicate, #1: 1	أَوَّلَ مَرَّةً
u'أَوَّلَ مُسْلِمٌ':Predicate, #1: 1	أَوَّلَ الْمَسْأَلَةَ
u'أَوَّلَ مُصَنِّفٌ':Subject, #1: 1	أَوَّلَ الْمُسْلِمِينَ
u'أَوْلَى تُرَابٌ':Subject, #1: 1	أَوَّلَ الْمُصَنِّفُ
u'أَوْلَى تَنْبِيهٌ':Subject, #1: 1	أَوْلَى التُّرَابُ
u'أَوْلَى ثَالِثٌ':Subject, #2: 2	أَوْلَى تَنْبِيهٌ
u'أَوْلَى ثَالِثٌ':Subject, #1: 1	أَوْلَى الثَّالِثُ
u'أَوْلَى ثَامِنٌ':Predicate, #1: 1	أَوْلَى الثَّالِثَةُ
u'أَوْلَى ثَانِي':Predicate, #1: 1	أَوْلَى الثَّامِنَةَ
u'أَوْلَى ثَانِي':Subject, #1: 1	أَوْلَى الثَّانِيَةَ
u'أَوْلَى ثَانِيَةٌ':Predicate, #1: 1	أَوْلَى الثَّانِيَةُ
u'أَوْلَى ثَانِيَةٌ':Subject, #1: 1	أَوْلَى الثَّانِيَةَ
u'أَوْلَى جَارِي':Subject, #1: 1	أَوْلَى الثَّانِيَةُ
u'أَوْلَى جَارِيَةٌ':Subject, #1: 1	أَوْلَى جَارِيَةٌ
u'أَوْلَى جَوَازٌ':Subject, #1: 1	أَوْلَى جَارِيَةٌ
u'أَوْلَى حادِي':Subject, #1: 1	أَوْلَى الْجَوَازُ
u'أَوْلَى حَيَوَانٌ':Subject, #1: 1	أَوْلَى الْحَادِيَةُ
u'أَوْلَى خُبْزٌ':Subject, #1: 1	أَوْلَى الْحَيَوَانُ
u'أَوْلَى خَوْفٌ':Predicate, #1: 1	أَوْلَى الْخُبْزُ
u'أَوْلَى دفع':Predicate, #1: 1	أَوْلَى خَوْفَ
u'أَوْلَى ذكر':Predicate, #1: 1	أَوْلَى دَفَعَ
u'أَوْلَى ذَكَرٌ':Predicate, #1: 1	أَوْلَى ذَكَرَ
u'أَوْلَى سابع':Predicate, #1: 1	أَوْلَى ذَكَرَ
u'أَوْلَى سَابعٌ':Predicate, #1: 1	أَوْلَى السَّابِعَةَ
u'أَوْلَى سابع':Subject, #1: 1	أَوْلَى السَّابِعَةَ
u'أَوْلَى سَابعٌ':Subject, #1: 1	أَوْلَى السَّابِعَةُ
u'أَوْلَى سادس':Predicate, #1: 1	أَوْلَى السَّابِعَةُ
u'أَوْلَى سَادِسٌ':Predicate, #1: 1	أَوْلَى السَّادِسَةَ
u'أَوْلَى سادس':Subject, #1: 1	أَوْلَى السَّادِسَةَ
u'أَوْلَى سَادِسٌ':Subject, #1: 1	أَوْلَى السَّادِسَةُ
u'أَوْلَى سِتٌّ':Predicate, #1: 1	أَوْلَى السَّادِسَةُ
u'أَوْلَى سَواءٌ':Subject, #1: 1	أَوْلَى سِتَّةَ
u'أَوْلَى صَلاَحِيَّةٌ':Subject, #6: 6	أَوْلَى سَوَاءٌ
u'أَوْلَى عَبْدٌ':Subject, #1: 1	أَوْلَى صَلَاحِيَّةُ
u'أَوْلَى عَدَمٌ':Subject, #1: 1	أَوْلَى عَبْدٌ
u'أَوْلَى عِشْرُون':Predicate, #1: 1	أَوْلَى عَدَمُ
u'أَوْلَى عند':Predicate, #1: 1	أَوْلَى الْعِشْرُونَ
u'أَوْلَى غير':Subject, #19: 19	أَوْلَى عِنْدَ
u'أَوْلَى غَيْرٌ':Subject, #1: 1	أَوْلَى غَيْرُهُ
u'أَوْلَى فرق':Subject, #1: 1	أَوْلَى غَيْرُهُ
u'أَوْلَى فَرْقٌ':Subject, #1: 1	أَوْلَى الْفَرْقُ
u'أَوْلَى قَالٌ':Predicate, #1: 1	أَوْلَى الْفَرْقُ
u'أَوْلَى قول':Subject, #49: 49	أَوْلَى قَالَ
u'أَوْلَى قَوْلٌ':Subject, #10: 10	أَوْلَى قَوْلُهُ
u'أَوْلَى قول':Subject, #10: 10	أَوْلَى قَوْلُهُ
u'أَوْلَى قَوْلٌ':Subject, #1: 1	أَوْلَى قَوْلُ
u'أَوْلَى مُتَيَقِّن':Subject, #1: 1	أَوْلَى قَوْلُ
u'أَوْلَى مِثَالٌ':Subject, #1: 1	أَوْلَى الْمُتَيَقِّنُ
u'أَوْلَى مُخَالِفٌ':Subject, #1: 1	أَوْلَى مِثَالُهُ
u'أَوْلَى مَمْنُوعٌ':Subject, #1: 1	أَوْلَى مُخَالِفٌ
u'أَوْلَى وَاقِعٌ':Subject, #1: 1	أَوْلَى مَمْنُوعٌ
u'أَوْلَى وَجْهٌ':Subject, #1: 1	أَوْلَى الْوَاقِعُ
u'أَوْلَى وَلَهٌ':Subject, #2: 2	أَوْلَى وَجْهُ
u'أَوْمَأَ إمَامٌ':Subject, #2: 2	أَوْلَى وَلَهُ
u'أَوْمَأَ شافِعِيّ':Subject, #2: 2	أَوْمَأَ الْإِمَامُ
u'أَوْمَأَ غَايَةٌ':Predicate, #1: 1	أَوْمَأَ الشَّافِعِيُّ
u'أَوْمَأَ فلان':Subject, #2: 2	أَوْمَأَ غَايَةَ
u'أَوْمَأَ قَائِمٌ':Subject, #1: 1	أَوْمَأَ الشَّافِعِيُّ
u'أَوْهَامٌ حَديثٌ':Added, #2: 2	أَوْمَأَ الْقَائِمُ
u'أَوْهَامٌ عَوَامُّ':Added, #1: 1	أَوْهَامِ الْحَدِيثِ
u'أَوْهَامٌ مَالِكٌ':Added, #1: 1	أَوْهَامِ الْعَوَامِّ
u'أَوْهَامٌ نَاسٌ':Added, #1: 1	أَوْهَامِ مَالِكٍ
u'أَوْهَمَ اِقْتِصَارٌ':Subject, #4: 4	أَوْهَامَ النَّاسِ
u'أَوْهَمَ تَعْبِيرٌ':Subject, #1: 1	أَوْهَمَ اقْتِصَارُ
u'أَوْهَمَ رَجُلٌ':Subject, #1: 1	أَوْهَمَ تَعْبِيرُهُ
u'أَوْهَمَ صَدْرٌ':Subject, #1: 1	أَوْهَمَ الرَّجُلُ
u'أَوْهَمَ ظاهِرٌ':Subject, #1: 1	أَوْهَمَ صَدْرُ
u'أَوْهَمَ قَبُولٌ':Predicate, #1: 1	أَوْهَمَ ظَاهِرُهُ
u'أَوْهَمَ قول':Subject, #1: 1	أَوْهَمَ قَبُولَ
u'أَوْهَمَ قَوْلٌ':Subject, #1: 1	أَوْهَمَ قَوْلُ
u'أَوْهَمَ كَلاَمٌ':Subject, #1: 1	أَوْهَمَ قَوْلُ
u'أَوْهَمَ كَلاَمٌ':Subject, #2: 2	أَوْهَمَ كَلَامُ
u'أَوْهَنَ فَضِيلٌ':Predicate, #2: 2	أَوْهَمَ كَلَامُهُ
u'أَوْهَنَ فَضِيلَةٌ':Predicate, #1: 1	أَوْهَنَ فَضِيلَةَ
u'أَوْهَى مُقَارَعَةٌ':Subject, #1: 1	أَوْهَنَ فَضِيلَةَ
u'أَوَى رَجُلٌ':Subject, #2: 2	أَوْهَى مُقَارَعَةُ
u'آوَى ضَالٌّ':Predicate, #1: 1	أَوَى الرَّجُلُ
u'آوَى عَائِشٌ':Predicate, #2: 2	آوَى ضَالَّةً
u'آوَى عَائِشٌ':Subject, #1: 1	آوَى عَائِشَةَ
u'أَوَى فِتْيَةٌ':Subject, #1: 1	آوَى عَائِشَةُ
u'أَيْبَسَ بَحْرٌ':Predicate, #1: 1	أَوَى الْفِتْيَةُ
u'إِيثَارٌ تَرْكٌ':Added, #1: 1	أَيْبَسَ الْبَحْرَ
u'إِيثَارٌ طَاعَةٌ':Added, #1: 1	إِيثَارُ تَرْكِ
u'إِيثَارٌ نَظَرٌ':Added, #2: 2	إِيثَارُ طَاعَتِهِ
u'إِيجَابٌ عمرة':Added, #1: 1	إِيثَارِ نَظَرِ
u'إِيجَابٌ عُمْرَةٌ':Added, #1: 1	إِيجَابِ الْعُمْرَةِ
u'إِيجَابٌ غُسْلٌ':Added, #1: 1	إِيجَابِ الْعُمْرَةِ
u'إِيجَابٌ قِرَاءةٌ':Added, #1: 1	إِيجَابِ الْغُسْلِ
u'إِيجَابٌ قصاص':Added, #1: 1	إِيجَابِ الْقِرَاءَةِ
u'إِيجَابٌ قِصَاصٌ':Added, #2: 2	إِيجَابِ الْقِصَاصِ
u'إِيجَابٌ مَسْحٌ':Added, #2: 2	إِيجَابِ الْقِصَاصِ
u'إِيجَابٌ وُضُوءٌ':Added, #1: 1	إِيجَابِ الْمَسْحِ
u'إيجَازٌ حَذْف':Added, #1: 1	إِيجَابَ الْوُضُوءِ
u'إيجَازٌ دَلالَةٌ':Added, #1: 1	إيجَازِ الْحَذْفِ
u'إيجَازٌ قول':Added, #1: 1	إيجَازُ الدَّلَالَةِ
u'إيجَازٌ قَوْلٌ':Added, #1: 1	إيجَازِ الْقَوْلِ
u'إيجَازٌ كَلاَمٌ':Added, #1: 1	إيجَازِ الْقَوْلِ
u'إيجَازٌ لَفْظٌ':Added, #1: 1	إيجَازُ الْكَلَامِ
u'إيجَازٌ مَحَلٌّ':Added, #2: 2	إيجَازِ اللَّفْظِ
u'أَيَّدَ إمَامٌ':Subject, #1: 1	إيجَازُ مَحَلٍّ
u'أَيَّدَ صِحَّةٌ':Predicate, #1: 1	أَيَّدَ الْإِمَامُ
u'أَيَّدَ كَلاَمٌ':Predicate, #1: 1	أَيَّدَ الصِّحَّةَ
u'إيرَادٌ أَبٌ':Added, #1: 1	أَيَّدَ كَلَامَ
u'إيرَادٌ اِبْنٌ':Added, #1: 1	إيرَادِ الْأَبِ
u'إيرَادٌ إجَارَةٌ':Added, #1: 1	إيرَادِ ابْنِ
u'إيرَادٌ أسْئِلَةٌ':Added, #2: 2	إيرَادُ إجَارَةِ
u'إيرَادٌ أَمْرٌ':Added, #1: 1	إيرَادِ الْأَسْئِلَةِ
u'إيرَادٌ بَيْعٌ':Added, #1: 1	إيرَادُ أَمْرٍ
u'إيرَادٌ بَيْعٌ':Added, #1: 1	إيرَادُ الْبَيْعِ
u'إيرَادٌ تَعْرِيفٌ':Added, #3: 3	إيرَادِ الْبَيْعِ
u'إيرَادٌ جُمْهُورٌ':Added, #1: 1	إيرَادُ التَّعْرِيفِ
u'إيرَادٌ حَديثٌ':Added, #1: 1	إيرَادِ جُمْهُورِ
u'إيرَادٌ حُكْمٌ':Added, #2: 2	إيرَادِ الْحَدِيثِ
u'إيرَادٌ خُرُوجٌ':Added, #1: 1	إيرَادُ الْحُكْمِ
u'إيرَادٌ دَارٌ':Added, #1: 1	إيرَادِ خُرُوجِ
u'إيرَادٌ دفع':Added, #1: 1	إيرَادِ الدَّارِ
u'إيرَادٌ دَفْعٌ':Added, #6: 6	إيرَادِ الدَّفْعِ
u'إيرَادٌ شَارِحٌ':Added, #6: 6	إيرَادِ الدَّفْعِ
u'إيرَادٌ شُبْهَةٌ':Added, #1: 1	إيرَادُ شَارِحِ
u'إيرَادٌ شَرْحٌ':Added, #2: 2	إيرَادِ شُبْهَةٍ
u'إيرَادٌ شَيْخٌ':Added, #1: 1	إيرَادُ الشَّرْحِ
u'إيرَادٌ عَقْدٌ':Added, #1: 1	إيرَادُ الشَّيْخِ
u'إيرَادٌ عَقْدٌ':Added, #16: 16	إيرَادُ الْعَقْدِ
u'إيرَادٌ عَقْدٌ':Added, #1: 1	إيرَادِ الْعَقْدِ
u'إيرَادٌ عَقْدٌ':Added, #1: 1	إيرَادُ عَقْدٍ
u'إيرَادٌ عَقْدٌ':Added, #1: 1	إيرَادِ عَقْدٍ
u'إيرَادٌ عَقْدٌ':Added, #1: 1	إيرَادِ عَقْدِ
u'إيرَادٌ عَقْدٌ':Added, #1: 1	إيرَادِ عَقْدِهِ
u'إيرَادٌ عَقْدٌ':Added, #1: 1	إيرَادُ عَقْدَيْنِ
u'إيرَادٌ عَقْلٌ':Added, #5: 5	إيرَادَ الْعَقْدِ
u'إيرَادٌ غَصْبٌ':Added, #1: 1	إيرَادِ الْعَقْلِ
u'إيرَادٌ فخر':Added, #1: 1	إيرَادُ الْغَصْبِ
u'إيرَادٌ فَخْرٌ':Added, #1: 1	إيرَادُ فَخْرِ
u'إيرَادٌ فرق':Added, #1: 1	إيرَادُ فَخْرِ
u'إيرَادٌ فَرْقٌ':Added, #1: 1	إيرَادِ الْفَرْقِ
u'إيرَادٌ فَصْلٌ':Added, #1: 1	إيرَادِ الْفَرْقِ
u'إيرَادٌ قَرْضٌ':Added, #1: 1	إيرَادِ الْفَصْلِ
u'إيرَادٌ قلب':Added, #1: 1	إيرَادِ الْقَرْضِ
u'إيرَادٌ قَلْبٌ':Added, #1: 1	إيرَادُ الْقَلْبِ
u'إيرَادٌ قَلْب':Added, #1: 1	إيرَادُ الْقَلْبِ
u'إيرَادٌ كِتَابٌ':Added, #1: 1	إيرَادُ الْقَلْبِ
u'إيرَادٌ كِتَابٌ':Added, #3: 3	إيرَادُ كِتَابِ
u'إيرَادٌ كَلاَمٌ':Added, #4: 4	إيرَادِ الْكِتَابِ
u'إيرَادٌ كَلاَمٌ':Added, #1: 1	إيرَادَ كَلَامِ
u'إيرَادٌ مَسْأَلَةٌ':Added, #1: 1	إيرَادِ كَلَامِ
u'إيرَادٌ مُشْتَرَكٌ':Added, #2: 2	إيرَادِ مَسْأَلَةِ
u'إيرَادٌ مُصَنِّفٌ':Added, #1: 1	إيرَادُ الْمُشْتَرَكِ
u'إيرَادٌ مُصَنِّفٌ':Added, #1: 1	إيرَادُ الْمُصَنِّفِ
u'إيرَادٌ مُعْتَرِضٌ':Added, #3: 3	إيرَادِ الْمُصَنِّفِ
u'إيرَادٌ مُقَدَّرٌ':Added, #1: 1	إيرَادَ الْمُعْتَرِضِ
u'إيرَادٌ مُقْنِعٌ':Added, #1: 1	إيرَادٍ مُقَدَّرٍ
u'إيرَادٌ نظائر':Added, #1: 1	إيرَادِ الْمُقْنِعِ
u'إيرَادٌ نَظَرٌ':Added, #1: 1	إيرَادُ النَّظَائِرِ
u'إيرَادٌ نِعَمٌ':Added, #1: 1	إيرَادِ النَّظَرِ
u'إيرَادٌ نَقْضٌ':Added, #1: 1	إيرَادِ النِّعَمِ
u'إيرَادٌ نَقْضٌ':Added, #1: 1	إيرَادَ النَّقْضِ
u'إيرَادٌ نَهْيٌ':Added, #1: 1	إيرَادِ النَّقْضِ
u'إيرَادٌ نَوَافِلُ':Added, #1: 1	إيرَادَ نَهْيِ
u'إيرَادٌ هِبَةٌ':Added, #1: 1	إيرَادُ النَّوَافِلِ
u'أَيِسَ إمَامٌ':Subject, #1: 1	إيرَادَ الْهِبَةِ
u'أَيِسَ خلق':Subject, #1: 1	أَيِسَ الْإِمَامُ
u'أَيِسَ خَلْقٌ':Subject, #1: 1	أَيِسَ الْخَلْقُ
u'أَيْسَرَ أَبٌ':Subject, #1: 1	أَيِسَ الْخَلْقُ
u'أَيْسَرَ أيَّامٌ':Predicate, #2: 2	أَيْسَرَ الْأَبُ
u'أَيْسَرَ أَيَّامٌ':Predicate, #2: 2	أَيْسَرَ أَيَّامَ
u'أَيْسَرَ حالَةٌ':Predicate, #2: 2	أَيْسَرَ أَيَّامَ
u'أَيْسَرَ رَجُلٌ':Subject, #1: 1	أَيْسَرَ حَالَةَ
u'أَيْسَرَ زَارِعٌ':Subject, #1: 1	أَيْسَرَ الرَّجُلُ
u'أَيْسَرَ شَرِيكٌ':Subject, #1: 1	أَيْسَرَ الزَّارِعُ
u'أَيْسَرَ غَاصِبٌ':Subject, #1: 1	أَيْسَرَ شَرِيكُهُ
u'أَيْسَرَ غَرِيمٌ':Subject, #1: 1	أَيْسَرَ الْغَاصِبُ
u'أَيْسَرَ فَقِيرٌ':Subject, #1: 1	أَيْسَرَ غَرِيمُهُ
u'أَيْسَرَ قَالٌ':Predicate, #1: 1	أَيْسَرَ الْفَقِيرُ
u'أَيْسَرَ قَضَاءٌ':Predicate, #1: 1	أَيْسَرَ قَالَ
u'أَيْسَرَ لَيْلٌ':Predicate, #1: 1	أَيْسَرَ قَضَاءَ
u'أَيْسَرَ مُتْلِفٌ':Subject, #2: 2	أَيْسَرَ لَيْلَةَ
u'أَيْسَرَ مَضْمُونٌ':Subject, #1: 1	أَيْسَرَ الْمُتْلِفُ
u'أَيْسَرَ مُعْدِمٌ':Subject, #1: 1	أَيْسَرَ الْمَضْمُونُ
u'أَيْسَرَ مُعْسِرٌ':Subject, #3: 3	أَيْسَرَ الْمُعْدِمُ
u'أَيْسَرَ مُعْسِرٌ':Subject, #2: 2	أَيْسَرَ الْمُعْسِرُ
u'أَيْسَرَ مُوسِرٌ':Subject, #3: 3	أَيْسَرَ مُعْسِرٌ
u'أَيْسَرَ نَفَذٌ':Predicate, #1: 1	أَيْسَرَ الْمُوسِرُ
u'أَيْسَرَ وَارِثٌ':Subject, #1: 1	أَيْسَرَ نَفَذَ
u'أَيْسَرَ وَاطِئٌ':Subject, #1: 1	أَيْسَرَ الْوَارِثُ
u'أَيْسَرَ وَلِيٌّ':Subject, #1: 1	أَيْسَرَ الْوَاطِئُ
u'أَيْسَرَ يَوْمٌ':Predicate, #1: 1	أَيْسَرَ الْوَلِيُّ
u'أَيِسَ شَيْطَانٌ':Subject, #2: 2	أَيْسَرَ يَوْمَ
u'إيصَالٌ ألَمٌ':Added, #1: 1	أَيِسَ الشَّيْطَانُ
u'إيصَالٌ ألَمٌ':Added, #1: 1	إيصَالُ الْأَلَمِ
u'إيصَالٌ ألَمٌ':Added, #2: 2	إيصَالَ الْأَلَمِ
u'إيصَالٌ أمَانَةٌ':Added, #3: 3	إيصَالِ الْأَلَمِ
u'إيصَالٌ بَائِعٌ':Added, #1: 1	إيصَالَ الْأَمَانَةِ
u'إيصَالٌ تُرَابٌ':Added, #1: 1	إيصَالُ الْبَائِعِ
u'إيصَالٌ تُرَابٌ':Added, #1: 1	إيصَالُ التُّرَابِ
u'إيصَالٌ تَرِكَةٌ':Added, #2: 2	إيصَالِ التُّرَابِ
u'إيصَالٌ تَصَوُّرٌ':Added, #1: 1	إيصَالِ التَّرِكَةِ
u'إيصَالٌ ثَمَنٌ':Added, #1: 1	إيصَالِ تَصَوُّرٍ
u'إيصَالٌ ثَوْبٌ':Added, #1: 1	إيصَالُ ثَمَنِهِ
u'إيصَالٌ جمعة':Added, #2: 2	إيصَالُ ثَوْبِهِ
u'إيصَالٌ جُمُعَةٌ':Added, #1: 1	إيصَالِ الْجُمُعَةِ
u'إيصَالٌ حَصَاةٌ':Added, #1: 1	إيصَالِ الْجُمُعَةِ
u'إيصَالٌ حَصىً':Added, #1: 1	إيصَالِ الْحَصَاةِ
u'إيصَالٌ حَصَياتٌ':Added, #1: 1	إيصَالُ الْحَصَيَاتِ
u'إيصَالٌ حَصَيَاتٌ':Added, #1: 1	إيصَالُ الْحَصَيَاتِ
u'إيصَالٌ حَقٌّ':Added, #1: 1	إيصَالُ الْحَصَيَاتِ
u'إيصَالٌ حَقٌّ':Added, #2: 2	إيصَالِ الْحَقِّ
u'إيصَالٌ حَقٌّ':Added, #2: 2	إيصَالُ حَقِّ
u'إيصَالٌ حَقٌّ':Added, #2: 2	إيصَالِ حَقٍّ
u'إيصَالٌ حُقوقٌ':Added, #7: 7	إيصَالُ الْحَقِّ
u'إيصَالٌ حُقُوقٌ':Added, #2: 2	إيصَالُ الْحُقُوقِ
u'إيصَالٌ حُقوقٌ':Added, #2: 2	إيصَالُ الْحُقُوقِ
u'إيصَالٌ حُقُوقٌ':Added, #3: 3	إيصَالِ الْحُقُوقِ
u'إيصَالٌ خَيْرٌ':Added, #3: 3	إيصَالِ الْحُقُوقِ
u'إيصَالٌ خَيْرٌ':Added, #1: 1	إيصَالِ الْخَيْرِ
u'إيصَالٌ خَيْرٌ':Added, #1: 1	إيصَالَ خَيْرٍ
u'إيصَالٌ رَاحَةٌ':Added, #5: 5	إيصَالُ الْخَيْرِ
u'إيصَالٌ شَهَادَةٌ':Added, #1: 1	إيصَالُ الرَّاحَةِ
u'إيصَالٌ شَيْءٌ':Added, #1: 1	إيصَالِ شَهَادَتِهِ
u'إيصَالٌ شَيْءٌ':Added, #1: 1	إيصَالَ شَيْءٍ
u'إيصَالٌ شَيْءٌ':Added, #2: 2	إيصَالِ الشَّيْءِ
u'إيصَالٌ ضَرَرٌ':Added, #3: 3	إيصَالُ الشَّيْءِ
u'إيصَالٌ علم':Added, #1: 1	إيصَالُ الضَّرَرِ
u'إيصَالٌ عِلْمٌ':Added, #1: 1	إيصَالُ الْعِلْمِ
u'إيصَالٌ عين':Added, #1: 1	إيصَالُ الْعِلْمِ
u'إيصَالٌ عين':Added, #1: 1	إيصَالُ عَيْنِ
u'إيصَالٌ عَيْنٌ':Added, #1: 1	إيصَالِ عَيْنِ
u'إيصَالٌ عَيْنٌ':Added, #1: 1	إيصَالُ عَيْنِ
u'إيصَالٌ عَيْن':Added, #1: 1	إيصَالِ عَيْنِ
u'إيصَالٌ عَيْن':Added, #1: 1	إيصَالُ عَيْنِ
u'إيصَالٌ فِعْلٌ':Added, #1: 1	إيصَالِ عَيْنِ
u'إيصَالٌ قَصَصٌ':Added, #1: 1	إيصَالِ الْفِعْلِ
u'إيصَالٌ قِصَصٌ':Added, #1: 1	إيصَالُ قَصَصِ
u'إيصَالٌ مَاءٌ':Added, #1: 1	إيصَالُ قِصَصِ
u'إيصَالٌ مَاءٌ':Added, #18: 18	إيصَالِ الْمَاءِ
u'إيصَالٌ مَاءٌ':Added, #3: 3	إيصَالَ الْمَاءِ
u'إيصَالٌ مَالٌ':Added, #58: 58	إيصَالُ الْمَاءِ
u'إيصَالٌ مَالٌ':Added, #1: 1	إيصَالِ الْمَالِ
u'إيصَالٌ مَالٌ':Added, #1: 1	إيصَالِ مَالٍ
u'إيصَالٌ مُطَهِّرٌ':Added, #2: 2	إيصَالُ الْمَالِ
u'إيصَالٌ مُطَهِّرٌ':Added, #1: 1	إيصَالُ مُطَهِّرٍ
u'إيصَالٌ مُفْطِر':Added, #1: 1	إيصَالِ مُطَهِّرٍ
u'إيصَالٌ مَكْرُوهٌ':Added, #2: 2	إيصَالِ الْمُفْطِرِ
u'إيصَالٌ مَنَافِعُ':Added, #1: 1	إيصَالُ الْمَكْرُوهِ
u'إيصَالٌ مَنْفَعَةٌ':Added, #1: 1	إيصَالِ الْمَنَافِعِ
u'إيصَالٌ مَنْفَعَةٌ':Added, #1: 1	إيصَالَ الْمَنْفَعَةِ
u'إيصَالٌ نِصْفٌ':Added, #1: 1	إيصَالُ مَنْفَعَةِ
u'إيصَالٌ نَفْعٌ':Added, #1: 1	إيصَالُ نِصْفِ
u'إيصَالٌ نَفْعٌ':Added, #1: 1	إيصَالِ النَّفْعِ
u'إيصَالٌ نَفْعٌ':Added, #2: 2	إيصَالَ النَّفْعِ
u'إيصَالٌ نَفَقَةٌ':Added, #2: 2	إيصَالُ النَّفْعِ
u'إيصَالٌ نَوْعٌ':Added, #2: 2	إيصَالِ النَّفَقَةِ
u'إيصَالٌ هَدِيٌّ':Added, #1: 1	إيصَالُ نَوْعٍ
u'إيصَالٌ هَدِيَّةٌ':Added, #1: 1	إيصَالِ الْهَدِيَّةِ
u'إيصَالٌ ولد':Added, #1: 1	إيصَالِ الْهَدِيَّةِ
u'إيصَالٌ وَلَدٌ':Added, #1: 1	إيصَالُ الْوَلَدِ
u'إيصَالٌ يَوْمٌ':Added, #1: 1	إيصَالُ الْوَلَدِ
u'إيقَاعٌ أحَدٌ':Added, #1: 1	إيصَالِ يَوْمٍ
u'إيقَاعٌ أُخْرَى':Added, #2: 2	إيقَاعَ أَحَدِ
u'إيقَاعٌ اِسْمٌ':Added, #1: 1	إيقَاعِ أُخْرَيَيْنِ
u'إيقَاعٌ أصل':Added, #1: 1	إيقَاعِ اسْمِ
u'إيقَاعٌ أًصْلٌ':Added, #1: 1	إيقَاعِ الْأَصْلِ
u'إيقَاعٌ إقالَةٌ':Added, #1: 1	إيقَاعِ الْأَصْلِ
u'إيقَاعٌ أَكْثَرُ':Added, #1: 1	إيقَاعِ الْإِقَالَةِ
u'إيقَاعٌ الْمَرْأَةُ':Added, #1: 1	إيقَاعِ أَكْثَرِ
u'إيقَاعٌ بَائِنٌ':Added, #1: 1	إيقَاعِ الْمَرْأَةِ
u'إيقَاعٌ بَائِنٌ':Added, #1: 1	إيقَاعَ الْبَائِنِ
u'إيقَاعٌ بَعْضٌ':Added, #3: 3	إيقَاعُ الْبَائِنِ
u'إيقَاعٌ بَعْضٌ':Added, #1: 1	إيقَاعِ الْبَعْضِ
u'إيقَاعٌ بَعْضٌ':Added, #1: 1	إيقَاعُ بَعْضِ
u'إيقَاعٌ بَعْضٌ':Added, #1: 1	إيقَاعِ بَعْضِهِ
u'إيقَاعٌ بَيْعٌ':Added, #2: 2	إيقَاعَ بَعْضِ
u'إيقَاعٌ بَيْعٌ':Added, #1: 1	إيقَاعَ الْبَيْعِ
u'إيقَاعٌ تَصَرُّفٌ':Added, #2: 2	إيقَاعُ الْبَيْعِ
u'إيقَاعٌ تَصَرُّفٌ':Added, #1: 1	إيقَاعَ تَصَرُّفٍ
u'إيقَاعٌ تَعْرِيفٌ':Added, #2: 2	إيقَاعُ تَصَرُّفٍ
u'إيقَاعٌ تَوْلِيَةٌ':Added, #1: 1	إيقَاعِ التَّعْرِيفِ
u'إيقَاعٌ ثَالِثٌ':Added, #1: 1	إيقَاعُ التَّوْلِيَةِ
u'إيقَاعٌ ثَالِثٌ':Added, #1: 1	إيقَاعَ الثَّالِثَةِ
u'إيقَاعٌ ثَانِي':Added, #1: 1	إيقَاعِ الثَّالِثَةِ
u'إيقَاعٌ ثَانِي':Added, #2: 2	إيقَاعَ الثَّانِيَةِ
u'إيقَاعٌ ثَانِيَةٌ':Added, #3: 3	إيقَاعِ الثَّانِيَةِ
u'إيقَاعٌ ثَانِيَةٌ':Added, #2: 2	إيقَاعَ الثَّانِيَةِ
u'إيقَاعٌ ثَلاثُ':Added, #3: 3	إيقَاعِ الثَّانِيَةِ
u'إيقَاعٌ ثَلاثُ':Added, #17: 17	إيقَاعِ الثَّلَاثِ
u'إيقَاعٌ ثَلاثُ':Added, #18: 18	إيقَاعَ الثَّلَاثِ
u'إيقَاعٌ جُزْءٌ':Added, #4: 4	إيقَاعُ الثَّلَاثِ
u'إيقَاعٌ جَزَاءٌ':Added, #1: 1	إيقَاعِ جُزْءٍ
u'إيقَاعٌ جَزَاءٌ':Added, #1: 1	إيقَاعُ الْجَزَاءِ
u'إيقَاعٌ جَزَاءٌ':Added, #1: 1	إيقَاعِ الْجَزَاءِ
u'إيقَاعٌ حَجٌّ':Added, #2: 2	إيقَاعَ الْجَزَاءِ
u'إيقَاعٌ حَجْرٌ':Added, #1: 1	إيقَاعُ حَجٍّ
u'إيقَاعٌ حَيْضٌ':Added, #1: 1	إيقَاعُ الْحَجْرِ
u'إيقَاعٌ خَبَرٌ':Added, #1: 1	إيقَاعَ الْحَيْضِ
u'إيقَاعٌ خَبَر':Added, #1: 1	إيقَاعُ الْخَبَرِ
u'إيقَاعٌ رَجُلٌ':Added, #1: 1	إيقَاعُ الْخَبَرِ
u'إيقَاعٌ ركعة':Added, #1: 1	إيقَاعُ رَجُلٍ
u'إيقَاعٌ ركعة':Added, #1: 1	إيقَاعُ الرَّكْعَةِ
u'إيقَاعٌ رَكْعَةٌ':Added, #1: 1	إيقَاعِ الرَّكْعَةِ
u'إيقَاعٌ رَكْعَةٌ':Added, #1: 1	إيقَاعُ الرَّكْعَةِ
u'إيقَاعٌ ركعة':Added, #1: 1	إيقَاعِ الرَّكْعَةِ
u'إيقَاعٌ رَكْعَةٌ':Added, #2: 2	إيقَاعِ رَكْعَةٍ
u'إيقَاعٌ زائِدٌ':Added, #2: 2	إيقَاعِ رَكْعَةٍ
u'إيقَاعٌ زَوْجٌ':Added, #1: 1	إيقَاعِ الزَّائِدِ
u'إيقَاعٌ سلام':Added, #4: 4	إيقَاعُ الزَّوْجِ
u'إيقَاعٌ سَلاَمٌ':Added, #1: 1	إيقَاعِ السَّلَامِ
u'إيقَاعٌ شَهَادَةٌ':Added, #1: 1	إيقَاعِ السَّلَامِ
u'إيقَاعٌ شَيْءٌ':Added, #1: 1	إيقَاعِ الشَّهَادَةِ
u'إيقَاعٌ شَيْءٌ':Added, #1: 1	إيقَاعُ الشَّيْءِ
u'إيقَاعٌ صدق':Added, #1: 1	إيقَاعُ شَيْءٍ
u'إيقَاعٌ صِدْقٌ':Added, #1: 1	إيقَاعُ صِدْقِهِ
u'إيقَاعٌ صِفَةٌ':Added, #1: 1	إيقَاعُ صِدْقِهِ
u'إيقَاعٌ صَلاَةٌ':Added, #1: 1	إيقَاعَ صِفَةِ
u'إيقَاعٌ صَلاَةٌ':Added, #2: 2	إيقَاعُ صَلَاةِ
u'إيقَاعٌ صَلاَةٌ':Added, #3: 3	إيقَاعَ الصَّلَاةِ
u'إيقَاعٌ صَلاَةٌ':Added, #3: 3	إيقَاعُ الصَّلَاةِ
u'إيقَاعٌ صُلْب':Added, #3: 3	إيقَاعِ الصَّلَاةِ
u'إيقَاعٌ صُلْبِيّ':Added, #1: 1	إيقَاعِ الصُّلْبِيَّةِ
u'إيقَاعٌ صَلَوَاتٌ':Added, #1: 1	إيقَاعِ الصُّلْبِيَّةِ
u'إيقَاعٌ ضِدٌّ':Added, #1: 1	إيقَاعِ الصَّلَوَاتِ
u'إيقَاعٌ طَلاَقٌ':Added, #1: 1	إيقَاعِ ضِدِّهِ
u'إيقَاعٌ طَلاَقٌ':Added, #22: 22	إيقَاعُ الطَّلَاقِ
u'إيقَاعٌ طَلاَقٌ':Added, #2: 2	إيقَاعِ طَلَاقِهِ
u'إيقَاعٌ طَلاَقٌ':Added, #32: 32	إيقَاعَ الطَّلَاقِ
u'إيقَاعٌ طَلاَقٌ':Added, #3: 3	إيقَاعَ طَلَاقٍ
u'إيقَاعٌ طَلاَقٌ':Added, #3: 3	إيقَاعُ طَلَاقٍ
u'إيقَاعٌ عِبَادَةٌ':Added, #52: 52	إيقَاعِ الطَّلَاقِ
u'إيقَاعٌ عِبَادَةٌ':Added, #1: 1	إيقَاعُ الْعِبَادَاتِ
u'إيقَاعٌ عتق':Added, #1: 1	إيقَاعِ الْعِبَادَةِ
u'إيقَاعٌ عِتْقٌ':Added, #2: 2	إيقَاعِ الْعِتْقِ
u'إيقَاعٌ عتق':Added, #2: 2	إيقَاعِ الْعِتْقِ
u'إيقَاعٌ عِتْقٌ':Added, #3: 3	إيقَاعُ الْعِتْقِ
u'إيقَاعٌ عتق':Added, #3: 3	إيقَاعُ الْعِتْقِ
u'إيقَاعٌ عِتْقٌ':Added, #7: 7	إيقَاعَ الْعِتْقِ
u'إيقَاعٌ عَدَاوَةٌ':Added, #7: 7	إيقَاعَ الْعِتْقِ
u'إيقَاعٌ عَدَاوَةٌ':Added, #1: 1	إيقَاعَ الْعَدَاوَةِ
u'إيقَاعٌ عَدَاوَةٌ':Added, #2: 2	إيقَاعُ الْعَدَاوَةِ
u'إيقَاعٌ عَقْدٌ':Added, #2: 2	إيقَاعِ الْعَدَاوَةِ
u'إيقَاعٌ علم':Added, #2: 2	إيقَاعُ الْعَقْدِ
u'إيقَاعٌ عِلْمٌ':Added, #2: 2	إيقَاعُ الْعِلْمِ
u'إيقَاعٌ عَمَلٌ':Added, #2: 2	إيقَاعُ الْعِلْمِ
u'إيقَاعٌ غُسْلٌ':Added, #4: 4	إيقَاعِ الْعَمَلِ
u'إيقَاعٌ فتنة':Added, #1: 1	إيقَاعَ الْغُسْلِ
u'إيقَاعٌ فِتْنَةٌ':Added, #1: 1	إيقَاعُ الْفِتْنَةِ
u'إيقَاعٌ فُرْقَةٌ':Added, #1: 1	إيقَاعُ الْفِتْنَةِ
u'إيقَاعٌ فَسْخٌ':Added, #2: 2	إيقَاعُ الْفُرْقَةِ
u'إيقَاعٌ فَسْخٌ':Added, #1: 1	إيقَاعَ الْفَسْخِ
u'إيقَاعٌ فِعْلٌ':Added, #1: 1	إيقَاعُ الْفَسْخِ
u'إيقَاعٌ فِعْلٌ':Added, #2: 2	إيقَاعَ الْفِعْلِ
u'إيقَاعٌ فِعْلٌ':Added, #3: 3	إيقَاعِ الْفِعْلِ
u'إيقَاعٌ فلان':Added, #4: 4	إيقَاعُ الْفِعْلِ
u'إيقَاعٌ قُرْبَةٌ':Added, #1: 1	إيقَاعُ الصَّلَاتَيْنِ
u'إيقَاعٌ قَضَاءٌ':Added, #2: 2	إيقَاعُ الْقُرْبَةِ
u'إيقَاعٌ لَفْظٌ':Added, #1: 1	إيقَاعُ الْقَضَاءِ
u'إيقَاعٌ مُبْتَدَأٌ':Added, #1: 1	إيقَاعُ اللَّفْظِ
u'إيقَاعٌ مُسْتَقْبَلٌ':Added, #1: 1	إيقَاعُ مُبْتَدَأٍ
u'إيقَاعٌ مَطْلُوبٌ':Added, #1: 1	إيقَاعٍ مُسْتَقْبَلٍ
u'إيقَاعٌ مَعْصِيَةٌ':Added, #1: 1	إيقَاعِ الْمَطْلُوبِ
u'إيقَاعٌ مُؤْمِنٌ':Added, #2: 2	إيقَاعِ الْمَعْصِيَةِ
u'إيقَاعٌ نِسْبَةٌ':Added, #1: 1	إيقَاعُ الْمُؤْمِنِ
u'إيقَاعٌ نُسُكٌ':Added, #1: 1	إيقَاعِ النِّسْبَةِ
u'إيقَاعٌ نِصْفٌ':Added, #1: 1	إيقَاعِ نُسُكٍ
u'إيقَاعٌ نِيَّةٌ':Added, #1: 1	إيقَاعِ نِصْفِ
u'إيقَاعٌ نِيَّةٌ':Added, #1: 1	إيقَاعَ النِّيَّةِ
u'إيقَاعٌ هَيْبَةٌ':Added, #3: 3	إيقَاعُ النِّيَّةِ
u'إيقَاعٌ وَاجِبٌ':Added, #1: 1	إيقَاعُ الْهَيْبَةِ
u'إيقَاعٌ واحد':Added, #1: 1	إيقَاعُ الْوَاجِبِ
u'إيقَاعٌ وَاحِدٌ':Added, #1: 1	إيقَاعِ وَاحِدَةٍ
u'إيقَاعٌ واحد':Added, #1: 1	إيقَاعِ وَاحِدَةٍ
u'إيقَاعٌ وَاحِدٌ':Added, #2: 2	إيقَاعُ وَاحِدَةٍ
u'إيقَاعٌ واحد':Added, #2: 2	إيقَاعُ وَاحِدَةٍ
u'إيقَاعٌ وَاحِدٌ':Added, #3: 3	إيقَاعِ الْوَاحِدَةِ
u'إيقَاعٌ واحد':Added, #3: 3	إيقَاعِ الْوَاحِدَةِ
u'إيقَاعٌ وَاحِدٌ':Added, #4: 4	إيقَاعَ الْوَاحِدَةِ
u'إيقَاعٌ وَقْفٌ':Added, #4: 4	إيقَاعَ الْوَاحِدَةِ
u'إيقَاعٌ وَكِيلٌ':Added, #1: 1	إيقَاعُ الْوَقْفِ
u'إيقَاعٌ وَكِيلٌ':Added, #1: 1	إيقَاعِ الْوَكِيلِ
u'إيقَاعٌ يَدٌ':Added, #2: 2	إيقَاعِ وَكِيلِهِ
u'أَيْقَظَ عُقُولٌ':Predicate, #1: 1	إيقَاعِ يَدِهِ
u'أَيْقَظَ نَبِيٌّ':Predicate, #1: 1	أَيْقَظَ الْعُقُولَ
u'أَيْقَنَ مُسَافِرٌ':Subject, #1: 1	أَيْقَظَ النَّبِيَّ
u'إيمَانٌ أحَدٌ':Added, #1: 1	أَيْقَنَ الْمُسَافِرُ
u'إيمَانٌ أنبياء':Added, #1: 1	إيمَانُ أَحَدٍ
u'إيمَانٌ أهْلٌ':Added, #1: 1	إيمَانَ الْأَنْبِيَاءِ
u'إيمَانٌ أهْلٌ':Added, #1: 1	إيمَانَ أَهْلِ
u'إيمَانٌ خلق':Added, #1: 1	إيمَانِ أَهْلِ
u'إيمَانٌ خَلْقٌ':Added, #1: 1	إيمَانُ الْخَلْقِ
u'إيمَانٌ رَجُلٌ':Added, #1: 1	إيمَانُ الْخَلْقِ
u'إيمَانٌ رَقَبَةٌ':Added, #1: 1	إيمَانُ الرَّجُلِ
u'إيمَانٌ شَخْصٌ':Added, #1: 1	إيمَانِ الرَّقَبَةِ
u'إيمَانٌ صَبِيٌّ':Added, #1: 1	إيمَانُ الشَّخْصِ
u'إيمَانٌ عَبْدٌ':Added, #1: 1	إيمَانُ الصَّبِيِّ
u'إيمَانٌ عَبْدٌ':Added, #1: 1	إيمَانَ الْعَبْدِ
u'إيمَانٌ عَبْدٌ':Added, #1: 1	إيمَانِ الْعَبْدِ
u'إيمَانٌ غير':Added, #1: 1	إيمَانُ عَبْدٍ
u'إيمَانٌ غَيْرٌ':Added, #1: 1	إيمَانِ غَيْرِ
u'إيمَانٌ فسقة':Added, #1: 1	إيمَانِ غَيْرِ
u'إيمَانٌ كَافِرٌ':Added, #1: 1	إيمَانُ الْفَسَقَةِ
u'إيمَانٌ كَافِرٌ':Added, #1: 1	إيمَانُ الْكَافِرِ
u'إيمَانٌ مَجْمُوعٌ':Added, #1: 1	إيمَانِ الْكَافِرِ
u'إيمَانٌ مُضْطَرٌّ':Added, #1: 1	إيمَانِ مَجْمُوعِ
u'إيمَانٌ مُقَلِّدٌ':Added, #1: 1	إيمَانَ الْمُضْطَرِّ
u'إيمَانٌ مُقَلِّدٌ':Added, #2: 2	إيمَانَ الْمُقَلِّدِ
u'إيمَانٌ مُقَلِّدٌ':Added, #2: 2	إيمَانِ الْمُقَلِّدِ
u'إيمَانٌ مُوافاة':Added, #3: 3	إيمَانُ الْمُقَلِّدِ
u'إيمَانٌ مُؤْمِنٌ':Added, #1: 1	إيمَانِ الْمُوَافَاةِ
u'إيمَانٌ يَأْسٌ':Added, #1: 1	إيمَانُ الْمُؤْمِنِ
u'إيمَانٌ يَأْسٌ':Added, #1: 1	إيمَانُ الْيَأْسِ
u'إيمَانٌ يَأْسٌ':Added, #1: 1	إيمَانِ الْيَأْسِ
u'إيمَانٌ يَائِسٌ':Added, #1: 1	إيمَانَ يَأْسٍ
u'أَيْمَنَ اِبْنٌ':Predicate, #1: 1	إيمَانُ الْيَائِسِ
u'أَيْمَنَ اِبْنٌ':Subject, #2: 2	أَيْمَنَ ابْنَ
u'أَيْمَنَ بَرَكَةٌ':Subject, #1: 1	أَيْمَنَ ابْنُ
u'أَيْمَنَ حَبَشِيٌّ':Predicate, #1: 1	أَيْمَنَ بَرَكَةٌ
u'أَيْمَنَ غير':Subject, #1: 1	أَيْمَنَ الْحَبَشِيَّةَ
u'أَيْمَنَ غَيْرٌ':Subject, #1: 1	أَيْمَنَ غَيْرُ
u'أَيْمَنَ قَالٌ':Predicate, #1: 1	أَيْمَنَ غَيْرُ
u'أَيْمَنَ مَوْلَاةٌ':Predicate, #5: 5	أَيْمَنَ قَالَ
u'أَيْنٌ حاضِرٌ':Added, #1: 1	أَيْمَنَ مَوْلَاةَ
u'أَيْنَعَ ثَمَرٌ':Subject, #5: 5	أَيْنَ حَاضِرِ
u'بَاءَ أكْبَرُ':Subject, #1: 1	أَيْنَعَ الثَّمَرُ
u'بَاتَ إِفْحَامٌ':Subject, #1: 1	بَاءَ أَكْبَرُ
u'بَاتَ بَارِحٌ':Predicate, #1: 1	بَاتَ إفْحَامُ
u'بَاتَ بَقِيَّةٌ':Predicate, #1: 1	بَاتَ الْبَارِحَةَ
u'بَاتَ خَارِجٌ':Predicate, #1: 1	بَاتَ بَقِيَّةَ
u'بَاتَ رَجُلٌ':Subject, #1: 1	بَاتَ خَارِجَ
u'بَاتَ رَسُولٌ':Subject, #1: 1	بَاتَ رَجُلٌ
u'بَاتَ زَوْجٌ':Subject, #2: 2	بَاتَ رَسُولُ
u'بَاتَ سَلِيمٌ':Subject, #1: 1	بَاتَ الزَّوْجُ
u'بَاتَ شَبْعَان':Subject, #1: 1	بَاتَ السّلِيمُ
u'بَاتَ صَيْدٌ':Subject, #1: 1	بَاتَ شَبْعَانُ
u'بَاتَ عند':Predicate, #1: 1	بَاتَ الصَّيْدُ
u'بَاتَ عند':Predicate, #18: 18	بَاتَ عِنْدَ
u'بَاتَ فُلاَنٌ':Subject, #1: 1	أَبَاتَ عِنْدَ
u'بَاتَ فلان':Subject, #1: 1	بَاتَ فُلَانٌ
u'بَاتَ قَالٌ':Predicate, #1: 1	بَاتَ قَتَادَةُ
u'بَاتَ قَتاد':Subject, #1: 1	بَاتَ قَالَ
u'بَاتَ لَيْلٌ':Predicate, #1: 1	بَاتَ قَتَادَةُ
u'بَاتَ نَبِيٌّ':Subject, #10: 10	بَاتَ لَيْلَةً
u'بَاحَ إِجْرَاءٌ':Predicate, #1: 1	بَاتَ النَّبِيُّ
u'بَاحَ اِسْتِصْباح':Predicate, #2: 2	أَبَاحَ إجْرَاءَ
u'بَاحَ أَشْيَاءٌ':Predicate, #1: 1	أَبَاحَ الاِسْتِصْبَاحَ
u'بَاحَ إقْدَامٌ':Predicate, #1: 1	أَبَاحَ أَشْيَاءَ
u'بَاحَ أكل':Predicate, #2: 2	أَبَاحَ الْإِقْدَامَ
u'بَاحَ أَكْلٌ':Predicate, #2: 2	أَبَاحَ الْأَكْلَ
u'بَاحَ إمَامٌ':Subject, #2: 2	أَبَاحَ الْأَكْلَ
u'بَاحَ أَمْوَالٌ':Predicate, #1: 1	أَبَاحَ الْإِمَامُ
u'بَاحَ تَبَرُّعٌ':Predicate, #1: 1	أَبَاحَ الْأَمْوَالَ
u'بَاحَ تَحَلُّقٌ':Predicate, #1: 1	أَبَاحَ التَّبَرُّعَ
u'بَاحَ تَرْكٌ':Predicate, #1: 1	أَبَاحَ التَّحَلُّقَ
u'بَاحَ تَسْمِيَة':Predicate, #2: 2	أَبَاحَ تَرْكَ
u'بَاحَ تَمْلِيك':Predicate, #1: 1	أَبَاحَ التَّسْمِيَةَ
u'بَاحَ تَيَمُّمٌ':Predicate, #1: 1	أَبَاحَ التَّمْلِيكَ
u'بَاحَ تَيَمُّمٌ':Subject, #1: 1	أَبَاحَ التَّيَمُّمَ
u'بَاحَ تَيَمُّمٌ':Subject, #1: 1	أَبَاحَ تَيَمُّمُهُ
u'بَاحَ ثِمارٌ':Predicate, #2: 2	أَبَاحَ التَّيَمُّمُ
u'بَاحَ جلد':Predicate, #1: 1	أَبَاحَ ثِمَارَ
u'بَاحَ جَلْدٌ':Predicate, #1: 1	أَبَاحَ جَلْدَ
u'بَاحَ جماع':Predicate, #1: 1	أَبَاحَ جَلْدَ
u'بَاحَ جِمَاعٌ':Predicate, #1: 1	أَبَاحَ الْجِمَاعَ
u'بَاحَ جمع':Predicate, #1: 1	أَبَاحَ الْجِمَاعَ
u'بَاحَ جَمْعٌ':Predicate, #1: 1	أَبَاحَ الْجَمْعَ
u'بَاحَ خطبة':Predicate, #1: 1	أَبَاحَ الْجَمْعَ
u'بَاحَ خِطْبَةٌ':Predicate, #1: 1	أَبَاحَ الْخِطْبَةَ
u'بَاحَ دُخُولٌ':Predicate, #1: 1	أَبَاحَ الْخِطْبَةَ
u'بَاحَ ذَرائِعُ':Predicate, #1: 1	أَبَاحَ الدُّخُولَ
u'بَاحَ رَاهِنٌ':Subject, #1: 1	أَبَاحَ الذَّرَائِعَ
u'بَاحَ سُلْطَانٌ':Subject, #1: 1	أَبَاحَ الرَّاهِنُ
u'بَاحَ سُؤَالٌ':Predicate, #3: 3	أَبَاحَ السُّلْطَانُ
u'بَاحَ سَيِّدٌ':Subject, #1: 1	أَبَاحَ السُّؤَالَ
u'بَاحَ شَارِعٌ':Subject, #1: 1	أَبَاحَ السَّيِّدُ
u'بَاحَ شَحْمٌ':Predicate, #1: 1	أَبَاحَ الشَّارِعُ
u'بَاحَ شَرْعٌ':Subject, #1: 1	أَبَاحَ الشَّحْمَ
u'بَاحَ شَيْءٌ':Predicate, #2: 2	أَبَاحَ الشَّرْعُ
u'بَاحَ صَبِيٌّ':Predicate, #1: 1	أَبَاحَ الشَّيْءَ
u'بَاحَ صَيْدٌ':Predicate, #1: 1	أَبَاحَ الصَّبِيَّ
u'بَاحَ طَلاَقٌ':Predicate, #1: 1	أَبَاحَ صَيْدَ
u'بَاحَ فِطْرٌ':Predicate, #1: 1	أَبَاحَ الطَّلاَقَ
u'بَاحَ فَقِيرٌ':Subject, #1: 1	أَبَاحَ الْفِطْرَ
u'بَاحَ قذف':Predicate, #4: 4	أَبَاحَ الْفَقِيرُ
u'بَاحَ قَذْفٌ':Predicate, #1: 1	أَبَاحَ الْقَذْفَ
u'بَاحَ قَصْرٌ':Predicate, #1: 1	أَبَاحَ الْقَذْفَ
u'بَاحَ قَفَّالٌ':Subject, #2: 2	أَبَاحَ الْقَصْرَ
u'بَاحَ قَلِيلٌ':Predicate, #1: 1	أَبَاحَ الْقَفَّالُ
u'بَاحَ لِبَاسٌ':Predicate, #1: 1	أَبَاحَ الْقَلِيلَ
u'بَاحَ مُتْعَةٌ':Predicate, #2: 2	أَبَاحَ لِبَاسَ
u'بَاحَ مَسٌّ':Predicate, #3: 3	أَبَاحَ الْمُتْعَةَ
u'بَاحَ مُسْكِرٌ':Predicate, #1: 1	أَبَاحَ الْمَسَّ
u'بَاحَ مُطَلَّقٌ':Predicate, #3: 3	أَبَاحَ الْمُسْكِرَ
u'بَاحَ نَبِيٌّ':Subject, #1: 1	أَبَاحَ الْمُطَلَّقَةَ
u'بَاحَ نَظَرٌ':Predicate, #2: 2	أَبَاحَ النَّبِيُّ
u'بَاحَ نكاح':Predicate, #1: 1	أَبَاحَ النَّظَرَ
u'بَاحَ نِكَاحٌ':Predicate, #3: 3	أَبَاحَ نِكَاحَ
u'بَاحَ وَطْءٌ':Predicate, #3: 3	أَبَاحَ نِكَاحَ
u'بَادَرَ اِبْنٌ':Subject, #2: 2	أَبَاحَ الْوَطْءَ
u'بَادَرَ أَجْنَبِيٌّ':Subject, #1: 1	بَادَرَ ابْنُ
u'بَادَرَ أحَدٌ':Subject, #2: 2	بَادَرَ أَجْنَبِيٌّ
u'بَادَرَ أهْلٌ':Subject, #2: 2	بَادَرَ أَحَدُ
u'بَادَرَ أَوَّلُ':Subject, #1: 1	بَادَرَ أَهْلُهُ
u'بَادَرَ بَائِعٌ':Subject, #1: 1	بَادَرَ الْأَوَّلُ
u'بَادَرَ بَطَلٌ':Predicate, #2: 2	بَادَرَ الْبَائِعُ
u'بَادَرَ بَعْضٌ':Subject, #1: 1	بَادَرَ بَطَلَ
u'بَادَرَ رَاهِنٌ':Subject, #1: 1	بَادَرَ بَعْضُ
u'بَادَرَ زَوْجٌ':Subject, #1: 1	بَادَرَ الرَّاهِنُ
u'بَادَرَ سَواءٌ':Subject, #1: 1	بَادَرَ الزَّوْجُ
u'بَادَرَ شُهُودٌ':Subject, #1: 1	بَادَرَ سَوَاءٌ
u'بَادَرَ صَاحِبٌ':Subject, #1: 1	بَادَرَ الشُّهُودُ
u'بَادَرَ صَحَابَةٌ':Subject, #1: 1	بَادَرَ صَاحِبُ
u'بَادَرَ عَدْلٌ':Subject, #1: 1	بَادَرَ الصَّحَابَةُ
u'بَادَرَ غفلة':Predicate, #1: 1	بَادَرَ عَدْلٌ
u'بَادَرَ غَفْلَةٌ':Predicate, #1: 1	بَادَرَ غَفْلَةَ
u'بَادَرَ غير':Subject, #1: 1	بَادَرَ غَفْلَةَ
u'بَادَرَ غَيْرٌ':Subject, #1: 1	بَادَرَ الْغَيْرُ
u'بَادَرَ غير':Subject, #1: 1	بَادَرَ الْغَيْرُ
u'بَادَرَ غَيْرٌ':Subject, #1: 1	بَادَرَ غَيْرُ
u'بَادَرَ غير':Subject, #1: 1	بَادَرَ غَيْرُ
u'بَادَرَ غَيْرٌ':Subject, #3: 3	بَادَرَ غَيْرُهُ
u'بَادَرَ مَالِكٌ':Subject, #3: 3	بَادَرَ غَيْرُهُ
u'بَادَرَ مَشْهُودٌ':Subject, #1: 1	بَادَرَ الْمَالِكُ
u'بَادَرَ وَكِيلٌ':Subject, #2: 2	بَادَرَ الْمَشْهُودُ
u'بَادَرَ وَلِيٌّ':Subject, #2: 2	بَادَرَ وَكِيلُهُ
u'بَادَلَ أحَدٌ':Predicate, #2: 2	بَادَرَ الْوَلِيُّ
u'بَادَلَ ذَهَبٌ':Predicate, #1: 1	بَادَلَ أَحَدَ
u'بَادَلَ سِلْعَةٌ':Predicate, #2: 2	بَادَلَ الذَّهَبَ
u'بَادَلَ نَقْدٌ':Predicate, #1: 1	بَادَلَ سِلْعَةَ
u'بَادَلَ نَقْد':Predicate, #1: 1	بَادَلَ النَّقْدَ
u'بَادَى رَسُولٌ':Subject, #1: 1	بَادَلَ النَّقْدَ
u'بَارَ أقَلُّ':Subject, #1: 1	بَادَى رَسُولُ
u'بَارَزَ بَيْنٌ':Predicate, #1: 1	بَارَ أَقَلُّهُ
u'بَارَزَ ثَلاثَةٌ':Subject, #1: 1	بَارَزَ بَيْنَ
u'بَارَزَ عَبْدٌ':Subject, #1: 1	بَارَزَ ثَلَاثَةٌ
u'بَارَزَ عتبة':Predicate, #1: 1	بَارَزَ الْعَبْدُ
u'بَارَزَ فلان':Subject, #1: 1	بَارَزَ عُتْبَةَ
u'بَارَزَ كَافِرٌ':Subject, #2: 2	بَارَزَ عَقِيلُ
u'بَارَزَ مَرْزُبان':Predicate, #2: 2	بَارَزَ كَافِرٌ
u'بَارَزَ مَرْزُبان':Predicate, #1: 1	بَارَزَ الْمَرْزُبَانَ
u'بَارَزَ يَوْمٌ':Predicate, #1: 1	بَارَزَ مَرْزُبَانَ
u'بَارَ عند':Predicate, #2: 2	بَارَزَ يَوْمَ
u'بَارَكَ عند':Predicate, #1: 1	بَارَكَ عِنْدَ
u'بَاشَرَ إِتْلاَفٌ':Predicate, #1: 1	بَارَكَ عِنْدَ
u'بَاشَرَ إِتْلاَفٌ':Predicate, #1: 1	بَاشَرَ إتْلَافَ
u'بَاشَرَ أخْذٌ':Predicate, #2: 2	بَاشَرَ الْإِتْلَافَ
u'بَاشَرَ أخْذٌ':Predicate, #1: 1	بَاشَرَ أَخْذَ
u'بَاشَرَ أَصْحَابٌ':Subject, #1: 1	بَاشَرَ الْأَخْذَ
u'بَاشَرَ إِلْقَاءٌ':Predicate, #1: 1	بَاشَرَ الْأَصْحَابُ
u'بَاشَرَ أمَةٌ':Predicate, #1: 1	بَاشَرَ الْإِلْقَاءَ
u'بَاشَرَ إِهْلاَكٌ':Predicate, #1: 1	بَاشَرَ الْأَمَةَ
u'بَاشَرَ تَصَرُّفٌ':Predicate, #1: 1	بَاشَرَ إهْلَاكَ
u'بَاشَرَ حُرٌّ':Predicate, #4: 4	بَاشَرَ التَّصَرُّفَ
u'بَاشَرَ حَمْلٌ':Predicate, #1: 1	بَاشَرَ حُرَّةً
u'بَاشَرَ دونٌ':Predicate, #1: 1	بَاشَرَ الْحَمْلَ
u'بَاشَرَ رَدٌّ':Predicate, #5: 5	بَاشَرَ دُونَ
u'بَاشَرَ سَبَبٌ':Predicate, #1: 1	بَاشَرَ الرَّدَّ
u'بَاشَرَ سَبَبٌ':Predicate, #5: 5	بَاشَرَ السَّبَبَ
u'بَاشَرَ شَرْطٌ':Predicate, #5: 5	بَاشَرَ سَبَبَ
u'بَاشَرَ شَرْطٌ':Predicate, #1: 1	بَاشَرَ شَرْطَ
u'بَاشَرَ صَلاَةٌ':Predicate, #7: 7	بَاشَرَ الشَّرْطَ
u'بَاشَرَ ضَرْبٌ':Predicate, #1: 1	بَاشَرَ الصَّلَاةَ
u'بَاشَرَ طَبِيبٌ':Subject, #1: 1	بَاشَرَ الضَّرْبَ
u'بَاشَرَ عَبْدٌ':Subject, #1: 1	بَاشَرَ الطَّبِيبُ
u'بَاشَرَ عتق':Predicate, #1: 1	بَاشَرَ الْعَبْدُ
u'بَاشَرَ عِتْقٌ':Predicate, #1: 1	بَاشَرَ الْعِتْقَ
u'بَاشَرَ عتق':Predicate, #1: 1	بَاشَرَ الْعِتْقَ
u'بَاشَرَ عِتْقٌ':Predicate, #1: 1	بَاشَرَ عِتْقَ
u'بَاشَرَ عَقْدٌ':Predicate, #1: 1	بَاشَرَ عِتْقَ
u'بَاشَرَ عُقَلاَءُ':Subject, #11: 11	بَاشَرَ الْعَقْدَ
u'بَاشَرَ عُقُودٌ':Predicate, #1: 1	بَاشَرَ الْعُقَلَاءُ
u'بَاشَرَ غَالِبٌ':Predicate, #1: 1	بَاشَرَ الْعُقُودَ
u'بَاشَرَ غير':Subject, #1: 1	بَاشَرَ غَالِبَ
u'بَاشَرَ غَيْرٌ':Subject, #1: 1	بَاشَرَ غَيْرُ
u'بَاشَرَ فَاسِدٌ':Predicate, #1: 1	بَاشَرَ غَيْرُ
u'بَاشَرَ فِعْلٌ':Predicate, #1: 1	بَاشَرَ الْفَاسِدَ
u'بَاشَرَ فِعْلٌ':Predicate, #1: 1	بَاشَرَ الْفِعْلَ
u'بَاشَرَ قتل':Predicate, #1: 1	بَاشَرَ فِعْلَ
u'بَاشَرَ قَتْلٌ':Predicate, #6: 6	بَاشَرَ الْقَتْلَ
u'بَاشَرَ قَطْعٌ':Predicate, #6: 6	بَاشَرَ الْقَتْلَ
u'بَاشَرَ كِتَابَةٌ':Predicate, #1: 1	بَاشَرَ الْقَطْعَ
u'بَاشَرَ مُحْرِمٌ':Subject, #1: 1	بَاشَرَ الْكِتَابَةَ
u'بَاشَرَ مَشْرُوطٌ':Subject, #1: 1	بَاشَرَ الْمُحْرِمُ
u'بَاشَرَ مُقْرِضٌ':Subject, #1: 1	بَاشَرَ الْمَشْرُوطُ
u'بَاشَرَ مُكَلَّفٌ':Subject, #1: 1	بَاشَرَ الْمُقْرِضُ
u'بَاشَرَ مَوْقُوفٌ':Predicate, #1: 1	بَاشَرَ الْمُكَلَّفُ
u'بَاشَرَ نَافِذٌ':Subject, #3: 3	بَاشَرَ الْمَوْقُوفَ
u'بَاشَرَ نَحْوٌ':Predicate, #1: 1	بَاشَرَ نَافِذٌ
u'بَاشَرَ نقل':Predicate, #1: 1	بَاشَرَ نَحْوَ
u'بَاشَرَ نَقْلٌ':Predicate, #1: 1	بَاشَرَ النَّقْلَ
u'بَاشَرَ نكاح':Predicate, #1: 1	بَاشَرَ النَّقْلَ
u'بَاشَرَ نِكَاحٌ':Predicate, #3: 3	بَاشَرَ النِّكَاحَ
u'بَاشَرَ هِبَةٌ':Predicate, #3: 3	بَاشَرَ النِّكَاحَ
u'بَاشَرَ وَكِيلٌ':Subject, #1: 1	بَاشَرَ الْهِبَةَ
u'بَاشَرَ وَلِيٌّ':Subject, #2: 2	بَاشَرَ الْوَكِيلُ
u'بَاضَ شَيْطَانٌ':Subject, #3: 3	بَاشَرَ الْوَلِيُّ
u'بَاضَ صَيْدٌ':Subject, #1: 1	بَاضَ الشَّيْطَانُ
u'بَاضَ طَيْرٌ':Subject, #1: 1	بَاضَ صَيْدٌ
u'بَاعَ أَبٌ':Subject, #1: 1	بَاضَ الطَّيْرُ
u'بَاعَ أَجْنَبِيٌّ':Subject, #17: 17	بَاعَ الْأَبُ
u'بَاعَ أحَدٌ':Predicate, #1: 1	بَاعَ أَجْنَبِيٌّ
u'بَاعَ أحَدٌ':Subject, #12: 12	بَاعَ أَحَدَ
u'بَاعَ أحَدٌ':Subject, #2: 2	بَاعَ أَحَدٌ
u'بَاعَ أَدْوِيَةٌ':Predicate, #36: 36	بَاعَ أَحَدُ
u'بَاعَ أرْضٌ':Predicate, #1: 1	بَاعَ الْأَدْوِيَةَ
u'بَاعَ أرْضٌ':Predicate, #34: 34	بَاعَ الْأَرْضَ
u'بَاعَ أَسْفَلُ':Subject, #3: 3	بَاعَ أَرْضَ
u'بَاعَ أُسْقُفٌ':Subject, #1: 1	بَاعَ الْأَسْفَلُ
u'بَاعَ أَشْجَارٌ':Predicate, #1: 1	بَاعَ الْأُسْقُفُ
u'بَاعَ أَشْجَارٌ':Predicate, #2: 2	بَاعَ أَشْجَارَ
u'بَاعَ أَشْعَث':Subject, #6: 6	بَاعَ الْأَشْجَارَ
u'بَاعَ أَشْيَاءٌ':Predicate, #1: 1	بَاعَ الأَشْعَثُ
u'بَاعَ أصل':Predicate, #1: 1	بَاعَ أَشْيَاءَ
u'بَاعَ أًصْلٌ':Predicate, #2: 2	بَاعَ الْأَصْلَ
u'بَاعَ أصل':Predicate, #2: 2	بَاعَ الْأَصْلَ
u'بَاعَ أًصْلٌ':Predicate, #3: 3	بَاعَ أَصْلَ
u'بَاعَ أَصيلٌ':Subject, #3: 3	بَاعَ أَصْلَ
u'بَاعَ أكابر':Subject, #2: 2	بَاعَ الْأَصِيلُ
u'بَاعَ أكَّارٌ':Subject, #1: 1	بَاعَ الْأَكَابِرُ
u'بَاعَ ألف':Predicate, #1: 1	بَاعَ الْأَكَّارُ
u'بَاعَ ألْفٌ':Predicate, #2: 2	بَاعَ أَلْفَ
u'بَاعَ أَلْفٌ':Predicate, #2: 2	بَاعَ أَلْفَ
u'بَاعَ أُمٌّ':Predicate, #2: 2	بَاعَ أَلْفَ
u'بَاعَ أُمٌّ':Predicate, #10: 10	بَاعَ أُمَّ
u'بَاعَ إمَامٌ':Subject, #6: 6	بَاعَ الْأُمَّ
u'بَاعَ أمَةٌ':Predicate, #1: 1	بَاعَ الْإِمَامُ
u'بَاعَ آمِرٌ':Subject, #7: 7	بَاعَ الْأَمَةَ
u'بَاعَ أَمينٌ':Subject, #2: 2	بَاعَ الْآمِرُ
u'بَاعَ أَمينٌ':Subject, #3: 3	بَاعَ أَمِينُ
u'بَاعَ إِناءٌ':Predicate, #3: 3	بَاعَ أَمِينُهُ
u'بَاعَ إِنْسانٌ':Subject, #6: 6	بَاعَ إنَاءَ
u'بَاعَ إِنْسانٌ':Subject, #1: 1	بَاعَ إنْسَانٌ
u'بَاعَ أَوْرَاقٌ':Predicate, #2: 2	بَاعَ الْإِنْسَانُ
u'بَاعَ أوْسَطُ':Subject, #3: 3	بَاعَ أَوْرَاقَ
u'بَاعَ أَوَّلُ':Predicate, #2: 2	بَاعَ الْأَوْسَطُ
u'بَاعَ أَوَّلُ':Subject, #3: 3	بَاعَ الْأَوَّلَ
u'بَاعَ باقِي':Predicate, #1: 1	بَاعَ الْأَوَّلُ
u'بَاعَ باقِي':Predicate, #1: 1	بَاعَ بَاقِيَ
u'بَاعَ بَائِعٌ':Subject, #6: 6	بَاعَ الْبَاقِيَ
u'بَاعَ بَذْرٌ':Predicate, #7: 7	بَاعَ الْبَائِعُ
u'بَاعَ بُرٌّ':Predicate, #1: 1	بَاعَ الْبَذْرَ
u'بَاعَ بُرْجٌ':Predicate, #1: 1	بَاعَ الْبُرَّ
u'بَاعَ بِرْذَوْنٌ':Predicate, #1: 1	بَاعَ بُرْجَ
u'بَاعَ بُسْرٌ':Predicate, #1: 1	بَاعَ الْبِرْذَوْنَ
u'بَاعَ بِطِّيخٌ':Predicate, #4: 4	بَاعَ الْبُسْرَ
u'بَاعَ بَعْضٌ':Predicate, #2: 2	بَاعَ الْبِطِّيخَ
u'بَاعَ بَعْضٌ':Predicate, #16: 16	بَاعَ بَعْضَ
u'بَاعَ بَعْضٌ':Subject, #5: 5	بَاعَ الْبَعْضَ
u'بَاعَ بَعْضٌ':Subject, #1: 1	بَاعَ بَعْضٌ
u'بَاعَ بَعيرٌ':Predicate, #3: 3	بَاعَ بَعْضُ
u'بَاعَ بَقَرٌ':Predicate, #1: 1	بَاعَ الْبَعِيرَ
u'بَاعَ بِنَاءٌ':Predicate, #1: 1	بَاعَ بَقَرَةً
u'بَاعَ بِنْتٌ':Predicate, #2: 2	بَاعَ الْبِنَاءَ
u'بَاعَ بِئْرٌ':Predicate, #1: 1	بَاعَ الْبِنْتَ
u'بَاعَ بَيْتٌ':Predicate, #2: 2	بَاعَ بِئْرَ
u'بَاعَ بَيْعٌ':Predicate, #2: 2	بَاعَ الْبَيْتَ
u'بَاعَ بَيْنٌ':Predicate, #2: 2	بَاعَ بَيْعَ
u'بَاعَ تِبْرٌ':Predicate, #1: 1	بَاعَ بَيْنَ
u'بَاعَ تِبْنٌ':Predicate, #1: 1	بَاعَ تِبْرَ
u'بَاعَ تُرَابٌ':Predicate, #2: 2	بَاعَ تِبْنَ
u'بَاعَ تَرِكَةٌ':Predicate, #1: 1	بَاعَ تُرَابَ
u'بَاعَ تَرِكَةٌ':Predicate, #1: 1	بَاعَ تَرِكَةَ
u'بَاعَ تَمْر':Predicate, #3: 3	بَاعَ التَّرِكَةَ
u'بَاعَ ثَالِثٌ':Subject, #1: 1	بَاعَ التَّمْرَ
u'بَاعَ ثَانِي':Predicate, #1: 1	بَاعَ الثَّالِثُ
u'بَاعَ ثَانِي':Predicate, #1: 1	بَاعَ الثَّانِيَةَ
u'بَاعَ ثَانِيَةٌ':Predicate, #2: 2	بَاعَ الثَّانِيَ
u'بَاعَ ثَلاثَةٌ':Predicate, #1: 1	بَاعَ الثَّانِيَةَ
u'بَاعَ ثِمارٌ':Predicate, #1: 1	بَاعَ ثَلَاثَةَ
u'بَاعَ ثَمَرٌ':Predicate, #3: 3	بَاعَ الثِّمَارَ
u'بَاعَ ثَمَرٌ':Predicate, #3: 3	بَاعَ الثَّمَرَ
u'بَاعَ ثَمَرَةٌ':Predicate, #4: 4	بَاعَ ثَمَرَ
u'بَاعَ ثَمَرَةٌ':Predicate, #14: 14	بَاعَ الثَّمَرَةَ
u'بَاعَ ثَوْبٌ':Predicate, #1: 1	بَاعَ ثَمَرَةَ
u'بَاعَ ثَوْبٌ':Predicate, #3: 3	بَاعَ الثَّوْبَ
u'بَاعَ ثِيابٌ':Predicate, #4: 4	بَاعَ ثَوْبَ
u'بَاعَ جَارِي':Predicate, #2: 2	بَاعَ الثِّيَابَ
u'بَاعَ جَارِي':Predicate, #1: 1	بَاعَ جَارِيَةَ
u'بَاعَ جَارِي':Predicate, #59: 59	بَاعَ جَارِيَةً
u'بَاعَ جَارِيَةٌ':Predicate, #9: 9	بَاعَ الْجَارِيَةَ
u'بَاعَ جَارِيَةٌ':Predicate, #1: 1	بَاعَ جَارِيَةَ
u'بَاعَ جَازٌ':Predicate, #9: 9	بَاعَ الْجَارِيَةَ
u'بَاعَ جِدار':Predicate, #15: 15	بَاعَ جَازَ
u'بَاعَ جِذْعٌ':Predicate, #1: 1	بَاعَ الْجِدَارَ
u'بَاعَ جِرَابٌ':Predicate, #1: 1	بَاعَ الْجِذْعَ
u'بَاعَ جلد':Predicate, #1: 1	بَاعَ الْجِرَابَ
u'بَاعَ جِلْدٌ':Predicate, #4: 4	بَاعَ الْجِلْدَ
u'بَاعَ جلد':Predicate, #4: 4	بَاعَ الْجِلْدَ
u'بَاعَ جِلْدٌ':Predicate, #9: 9	بَاعَ جِلْدَ
u'بَاعَ جَمَاعَةٌ':Subject, #9: 9	بَاعَ جِلْدَ
u'بَاعَ جَمَلٌ':Predicate, #1: 1	بَاعَ جَمَاعَةٌ
u'بَاعَ جَمِيع':Predicate, #2: 2	بَاعَ جَمَلاً
u'بَاعَ جِنْسٌ':Predicate, #6: 6	بَاعَ الْجَمِيعَ
u'بَاعَ جَوْزٌ':Predicate, #1: 1	بَاعَ الْجِنْسَ
u'بَاعَ جَيِّدٌ':Predicate, #1: 1	بَاعَ الْجَوْزَ
u'بَاعَ حاكِمٌ':Subject, #1: 1	بَاعَ الْجَيِّدَ
u'بَاعَ حاكِمٌ':Subject, #19: 19	بَاعَ الْحَاكِمُ
u'بَاعَ حالٌ':Predicate, #3: 3	بَاعَ حَاكِمٌ
u'بَاعَ حانوتٌ':Predicate, #1: 1	بَاعَ حَالَ
u'بَاعَ حائِطٌ':Predicate, #1: 1	بَاعَ الْحَانُوتَ
u'بَاعَ حَبٌّ':Predicate, #2: 2	بَاعَ الْحَائِطَ
u'بَاعَ حَدَّادٌ':Subject, #5: 5	بَاعَ حَبَّ
u'بَاعَ حُرٌّ':Predicate, #1: 1	بَاعَ الْحَدَّادُ
u'بَاعَ حُرٌّ':Predicate, #1: 1	بَاعَ الْحُرَّ
u'بَاعَ حِرْصٌ':Predicate, #1: 1	بَاعَ الْحُرَّةَ
u'بَاعَ حَرِيمٌ':Predicate, #1: 1	بَاعَ الْحِرْصَ
u'بَاعَ حِصَّةٌ':Predicate, #2: 2	بَاعَ الْحَرِيمَ
u'بَاعَ حَطَبٌ':Predicate, #2: 2	بَاعَ حِصَّةَ
u'بَاعَ حَكِيمٌ':Subject, #1: 1	بَاعَ الْحَطَبَ
u'بَاعَ حِلْيَةٌ':Predicate, #1: 1	بَاعَ حَكِيمُ
u'بَاعَ حَمَّامٌ':Predicate, #1: 1	بَاعَ حِلْيَةَ
u'بَاعَ حَمْلٌ':Predicate, #1: 1	بَاعَ الْحَمَّامَ
u'بَاعَ حِنْطَةٌ':Predicate, #1: 1	بَاعَ الْحَمْلَ
u'بَاعَ حَيَوَانٌ':Predicate, #8: 8	بَاعَ الْحِنْطَةَ
u'بَاعَ خَادِمٌ':Predicate, #1: 1	بَاعَ الْحَيَوَانَ
u'بَاعَ خَارِجٌ':Predicate, #2: 2	بَاعَ الْخَادِمَ
u'بَاعَ خُبْزٌ':Predicate, #1: 1	بَاعَ الْخَارِجَ
u'بَاعَ خدمة':Predicate, #1: 1	بَاعَ الْخُبْزَ
u'بَاعَ خِدْمَةٌ':Predicate, #3: 3	بَاعَ خِدْمَةَ
u'بَاعَ خَشَبَةٌ':Predicate, #3: 3	بَاعَ خِدْمَةَ
u'بَاعَ خَمْرٌ':Predicate, #3: 3	بَاعَ الْخَشَبَةَ
u'بَاعَ خَمْسٌ':Predicate, #12: 12	بَاعَ الْخَمْرَ
u'بَاعَ خَمْسَةٌ':Predicate, #2: 2	بَاعَ خَمْسَ
u'بَاعَ دَابَّةٌ':Predicate, #1: 1	بَاعَ خَمْسَةَ
u'بَاعَ دَارٌ':Predicate, #2: 2	بَاعَ الدَّابَّةَ
u'بَاعَ دَارٌ':Predicate, #34: 34	بَاعَ الدَّارَ
u'بَاعَ دَرَاهِمُ':Predicate, #8: 8	بَاعَ دَارَ
u'بَاعَ دَرَاهِمُ':Predicate, #1: 1	بَاعَ الدَّرَاهِمَ
u'بَاعَ دِرْهَمٌ':Predicate, #1: 1	بَاعَ دَرَاهِمَ
u'بَاعَ دِرْهَم':Predicate, #4: 4	بَاعَ الدِّرْهَمَ
u'بَاعَ دفع':Predicate, #4: 4	بَاعَ الدِّرْهَمَ
u'بَاعَ دَقيقٌ':Predicate, #1: 1	بَاعَ دَفَعَ
u'بَاعَ دُهْنٌ':Predicate, #1: 1	بَاعَ الدَّقِيقَ
u'بَاعَ دَوَابُّ':Predicate, #1: 1	بَاعَ الدُّهْنَ
u'بَاعَ دُورٌ':Predicate, #1: 1	بَاعَ دَوَابَّ
u'بَاعَ دَيْنٌ':Predicate, #2: 2	بَاعَ دُورَ
u'بَاعَ دِينارٌ':Predicate, #2: 2	بَاعَ الدَّيْنَ
u'بَاعَ ذِمِّيٌّ':Subject, #3: 3	بَاعَ الدِّينَارَ
u'بَاعَ ذِمِّيٌّ':Subject, #3: 3	بَاعَ الذِّمِّيُّ
u'بَاعَ ذَهَبٌ':Predicate, #4: 4	بَاعَ ذِمِّيٌّ
u'بَاعَ رَاحِلٌ':Predicate, #5: 5	بَاعَ الذَّهَبَ
u'بَاعَ رَأْسٌ':Predicate, #1: 1	بَاعَ رَاحِلَةً
u'بَاعَ رَاهِنٌ':Subject, #2: 2	بَاعَ رَأْسَ
u'بَاعَ رَاوِي':Predicate, #17: 17	بَاعَ الرَّاهِنُ
u'بَاعَ رَائِعٌ':Predicate, #1: 1	بَاعَ رَاوِيَةً
u'بَاعَ رَبُّ':Subject, #1: 1	بَاعَ الرَّائِعَةَ
u'بَاعَ رِجَالٌ':Subject, #10: 10	بَاعَ رَبُّ
u'بَاعَ رَجُلٌ':Subject, #1: 1	بَاعَ الرِّجَالُ
u'بَاعَ رَجُلٌ':Subject, #13: 13	بَاعَ الرَّجُلُ
u'بَاعَ رَسُولٌ':Subject, #16: 16	بَاعَ رَجُلٌ
u'بَاعَ رَقَبَةٌ':Predicate, #3: 3	بَاعَ رَسُولُ
u'بَاعَ رَقيقٌ':Predicate, #2: 2	بَاعَ رَقَبَةَ
u'بَاعَ رَقيق':Predicate, #2: 2	بَاعَ الرَّقِيقَ
u'بَاعَ رَهْنٌ':Predicate, #2: 2	بَاعَ الرَّقِيقَ
u'بَاعَ زادٌ':Predicate, #7: 7	بَاعَ الرَّهْنَ
u'بَاعَ زَرْعٌ':Predicate, #1: 1	بَاعَ زَادَ
u'بَاعَ زَعْفَرانٌ':Predicate, #4: 4	بَاعَ الزَّرْعَ
u'بَاعَ زَكاةٌ':Predicate, #1: 1	بَاعَ الزَّعْفَرَانَ
u'بَاعَ زَيْتٌ':Predicate, #1: 1	بَاعَ الزَّكَاةَ
u'بَاعَ زَيْدٌ':Subject, #1: 1	بَاعَ الزَّيْتَ
u'بَاعَ سَاحَةٌ':Predicate, #2: 2	بَاعَ زَيْدٌ
u'بَاعَ سَاكِتٌ':Subject, #1: 1	بَاعَ سَاحَةَ
u'بَاعَ سَائِمَةٌ':Predicate, #1: 1	بَاعَ السَّاكِتُ
u'بَاعَ سُفْلٌ':Predicate, #3: 3	بَاعَ السَّائِمَةَ
u'بَاعَ سُفْلٌ':Predicate, #2: 2	بَاعَ السُّفْلَ
u'بَاعَ سَفِيهٌ':Subject, #2: 2	بَاعَ سُفْلَ
u'بَاعَ سقط':Predicate, #1: 1	بَاعَ السَّفِيهُ
u'بَاعَ سَقَطٌ':Predicate, #1: 1	بَاعَ سَقَطَ
u'بَاعَ سِلاَحٌ':Predicate, #1: 1	بَاعَ سَقَطَ
u'بَاعَ سِلْعَةٌ':Predicate, #3: 3	بَاعَ السِّلَاحَ
u'بَاعَ سِلْعَةٌ':Predicate, #6: 6	بَاعَ السِّلْعَةَ
u'بَاعَ سَلِيمٌ':Predicate, #6: 6	بَاعَ سِلْعَةَ
u'بَاعَ سَمَكٌ':Predicate, #1: 1	بَاعَ السَّلِيمَةَ
u'بَاعَ سَمْنٌ':Predicate, #1: 1	بَاعَ السَّمَكَةَ
u'بَاعَ سَهْلٌ':Predicate, #1: 1	بَاعَ السَّمْنَ
u'بَاعَ سَوائِمُ':Predicate, #1: 1	بَاعَ سَهْلاً
u'بَاعَ سَوَائِمُ':Predicate, #2: 2	بَاعَ السَّوَائِمَ
u'بَاعَ سَيِّدٌ':Subject, #2: 2	بَاعَ السَّوَائِمَ
u'بَاعَ سَيِّدٌ':Subject, #1: 1	بَاعَ سَيِّدُهُ
u'بَاعَ سَيْفٌ':Predicate, #7: 7	بَاعَ السَّيِّدُ
u'بَاعَ شَاةٌ':Predicate, #1: 1	بَاعَ السَّيْفَ
u'بَاعَ شَائِعٌ':Subject, #2: 2	بَاعَ الشَّاةَ
u'بَاعَ شَخْصٌ':Subject, #1: 1	بَاعَ شَائِعٌ
u'بَاعَ شرب':Predicate, #5: 5	بَاعَ شَخْصٌ
u'بَاعَ شِرْبٌ':Predicate, #3: 3	بَاعَ الشِّرْبَ
u'بَاعَ شَرِيكٌ':Subject, #3: 3	بَاعَ الشِّرْبَ
u'بَاعَ شَرِيكٌ':Subject, #1: 1	بَاعَ الشَّرِيكُ
u'بَاعَ شَرِيكٌ':Subject, #1: 1	بَاعَ شَرِيكُ
u'بَاعَ شَعِيرٌ':Predicate, #4: 4	بَاعَ شَرِيكُهُ
u'بَاعَ شفعة':Predicate, #1: 1	بَاعَ الشَّعِيرَ
u'بَاعَ شُفْعَةٌ':Predicate, #1: 1	بَاعَ الشُّفْعَةَ
u'بَاعَ شَفِيعٌ':Subject, #1: 1	بَاعَ الشُّفْعَةَ
u'بَاعَ شَهْرٌ':Subject, #10: 10	بَاعَ الشَّفِيعُ
u'بَاعَ شَيْءٌ':Predicate, #1: 1	بَاعَ شَهْرٌ
u'بَاعَ شَيْءٌ':Subject, #4: 4	بَاعَ الشَّيْءَ
u'بَاعَ صَاحِبٌ':Subject, #1: 1	بَاعَ شَيْءٌ
u'بَاعَ صَاحِبٌ':Subject, #23: 23	بَاعَ صَاحِبُ
u'بَاعَ صَاعٌ':Predicate, #2: 2	بَاعَ صَاحِبُهُ
u'بَاعَ صبرة':Predicate, #2: 2	بَاعَ صَاعَ
u'بَاعَ صُبْرَةٌ':Predicate, #3: 3	بَاعَ الصُّبْرَةَ
u'بَاعَ صبرة':Predicate, #3: 3	بَاعَ الصُّبْرَةَ
u'بَاعَ صُبْرَةٌ':Predicate, #6: 6	بَاعَ صُبْرَةَ
u'بَاعَ صَبِيٌّ':Subject, #6: 6	بَاعَ صُبْرَةَ
u'بَاعَ صَبِيٌّ':Subject, #1: 1	بَاعَ صَبِيٌّ
u'بَاعَ صَيْدٌ':Predicate, #3: 3	بَاعَ الصَّبِيُّ
u'بَاعَ ضَامِنٌ':Subject, #2: 2	بَاعَ الصَّيْدَ
u'بَاعَ ضَيْعَةٌ':Predicate, #1: 1	بَاعَ الضَّامِنُ
u'بَاعَ طَاحُونٌ':Predicate, #1: 1	بَاعَ ضَيْعَةَ
u'بَاعَ طَافِي':Predicate, #1: 1	بَاعَ الطَّاحُونَةَ
u'بَاعَ طَالِبٌ':Predicate, #1: 1	بَاعَ طَافِيَ
u'بَاعَ طَاهِرٌ':Predicate, #1: 1	بَاعَ الطَّالِبَ
u'بَاعَ طَائِفٌ':Predicate, #1: 1	بَاعَ الطَّاهِرَ
u'بَاعَ طعام':Predicate, #1: 1	بَاعَ طَائِفَةً
u'بَاعَ طَعَامٌ':Predicate, #1: 1	بَاعَ طَعَامَ
u'بَاعَ طعام':Predicate, #1: 1	بَاعَ طَعَامَ
u'بَاعَ طَعَامٌ':Predicate, #6: 6	بَاعَ الطَّعَامَ
u'بَاعَ طَلْعٌ':Predicate, #6: 6	بَاعَ الطَّعَامَ
u'بَاعَ طَيْرٌ':Predicate, #1: 1	بَاعَ الطَّلْعَ
u'بَاعَ طَيْلَسَانٌ':Predicate, #2: 2	بَاعَ الطَّيْرَ
u'بَاعَ عَاجِزٌ':Predicate, #2: 2	بَاعَ الطَّيْلَسَانَ
u'بَاعَ عَامِلٌ':Subject, #1: 1	بَاعَ الْعَاجِزَ
u'بَاعَ عَبْدٌ':Predicate, #1: 1	بَاعَ الْعَامِلُ
u'بَاعَ عَبْدٌ':Predicate, #17: 17	بَاعَ عَبْدَ
u'بَاعَ عَبْدٌ':Subject, #53: 53	بَاعَ الْعَبْدَ
u'بَاعَ عَبْدٌ':Subject, #18: 18	بَاعَ الْعَبْدُ
u'بَاعَ عَبْدٌ':Subject, #1: 1	بَاعَ عَبْدُهُ
u'بَاعَ عَبِيدٌ':Predicate, #4: 4	بَاعَ عَبْدُ
u'بَاعَ عَدَاءٌ':Subject, #1: 1	بَاعَ عَبِيدَ
u'بَاعَ عِدْلٌ':Predicate, #1: 1	بَاعَ عَدَاءُ
u'بَاعَ عَدْلٌ':Subject, #3: 3	بَاعَ الْعِدْلَ
u'بَاعَ عَدْلٌ':Subject, #1: 1	بَاعَ عَدْلٌ
u'بَاعَ عَرْصَةٌ':Predicate, #23: 23	بَاعَ الْعَدْلُ
u'بَاعَ عَرَضٌ':Predicate, #1: 1	بَاعَ عَرْصَةَ
u'بَاعَ عَرْضٌ':Predicate, #2: 2	بَاعَ عَرَضَ
u'بَاعَ عَرْضٌ':Predicate, #3: 3	بَاعَ عَرْضَ
u'بَاعَ عُرُوضٌ':Predicate, #5: 5	بَاعَ الْعَرْضَ
u'بَاعَ عَسَلٌ':Predicate, #4: 4	بَاعَ الْعُرُوضَ
u'بَاعَ عُشْرٌ':Predicate, #1: 1	بَاعَ الْعَسَلَ
u'بَاعَ عصبة':Subject, #1: 1	بَاعَ عُشْرَ
u'بَاعَ عَصَبَةٌ':Subject, #1: 1	بَاعَ الْعَصَبَةُ
u'بَاعَ عَقَارٌ':Predicate, #1: 1	بَاعَ الْعَصَبَةُ
u'بَاعَ عَقَارٌ':Predicate, #1: 1	بَاعَ عَقَارَ
u'بَاعَ عَلَفٌ':Predicate, #8: 8	بَاعَ الْعَقَارَ
u'بَاعَ عُلْوٌ':Predicate, #1: 1	بَاعَ الْعَلَفَ
u'بَاعَ عُمَرٌ':Subject, #1: 1	بَاعَ الْعُلْوَ
u'بَاعَ عِنَبٌ':Predicate, #1: 1	بَاعَ عُمَرُ
u'بَاعَ عند':Predicate, #4: 4	بَاعَ الْعِنَبَ
u'بَاعَ عين':Predicate, #2: 2	بَاعَ عِنْدَ
u'بَاعَ عَيْنٌ':Predicate, #11: 11	بَاعَ الْعَيْنَ
u'بَاعَ عَيْن':Predicate, #11: 11	بَاعَ الْعَيْنَ
u'بَاعَ عين':Predicate, #11: 11	بَاعَ الْعَيْنَ
u'بَاعَ عَيْنٌ':Predicate, #1: 1	بَاعَ عَيْنَ
u'بَاعَ عَيْن':Predicate, #1: 1	بَاعَ عَيْنَ
u'بَاعَ غَاصِبٌ':Subject, #1: 1	بَاعَ عَيْنَ
u'بَاعَ غَاصِبٌ':Subject, #1: 1	بَاعَ غَاصِبُ
u'بَاعَ غَائِبٌ':Subject, #8: 8	بَاعَ الْغَاصِبُ
u'بَاعَ غُلاَمٌ':Predicate, #1: 1	بَاعَ الْغَائِبُ
u'بَاعَ غُلاَمٌ':Subject, #1: 1	بَاعَ الْغُلَامَ
u'بَاعَ غُلاَمٌ':Subject, #1: 1	بَاعَ الْغُلَامُ
u'بَاعَ غَلَّةٌ':Predicate, #1: 1	بَاعَ غُلَامٌ
u'بَاعَ غير':Predicate, #1: 1	بَاعَ غَلَّةَ
u'بَاعَ غَيْرٌ':Predicate, #3: 3	بَاعَ غَيْرَ
u'بَاعَ غير':Subject, #3: 3	بَاعَ غَيْرَ
u'بَاعَ غَيْرٌ':Subject, #1: 1	بَاعَ غَيْرُهُ
u'بَاعَ غير':Subject, #1: 1	بَاعَ غَيْرُهُ
u'بَاعَ غَيْرٌ':Subject, #4: 4	بَاعَ غَيْرُ
u'بَاعَ فَدَّانٌ':Predicate, #4: 4	بَاعَ غَيْرُ
u'بَاعَ فِضَّةٌ':Predicate, #2: 2	بَاعَ الْفَدَّانَ
u'بَاعَ فُضُولِيٌّ':Subject, #2: 2	بَاعَ الْفِضَّةَ
u'بَاعَ فُضُولِيٌّ':Subject, #1: 1	بَاعَ الْفُضُولِيُّ
u'بَاعَ فُلاَنٌ':Subject, #4: 4	بَاعَ فُضُولِيٌّ
u'بَاعَ فُلُوسٌ':Predicate, #13: 13	بَاعَ فُلَانٌ
u'بَاعَ فواكه':Predicate, #3: 3	بَاعَ الْفُلُوسَ
u'بَاعَ فَوَاكِهُ':Predicate, #1: 1	بَاعَ فَوَاكِهَ
u'بَاعَ قَتٌّ':Predicate, #1: 1	بَاعَ فَوَاكِهَ
u'بَاعَ قرار':Predicate, #2: 2	بَاعَ الْقَتَّ
u'بَاعَ قَرَارٌ':Predicate, #1: 1	بَاعَ الْقَرَارَ
u'بَاعَ قَصِيلٌ':Predicate, #1: 1	بَاعَ الْقَرَارَ
u'بَاعَ قَصِيلٌ':Subject, #1: 1	بَاعَ قَصِيلَ
u'بَاعَ قطعة':Predicate, #1: 1	بَاعَ قَصِيلٌ
u'بَاعَ قِطْعَةٌ':Predicate, #2: 2	بَاعَ الْقِطْعَةَ
u'بَاعَ قطعة':Predicate, #2: 2	بَاعَ الْقِطْعَةَ
u'بَاعَ قِطْعَةٌ':Predicate, #5: 5	بَاعَ قِطْعَةَ
u'بَاعَ قُطْنٌ':Predicate, #5: 5	بَاعَ قِطْعَةَ
u'بَاعَ قَطِيعٌ':Predicate, #4: 4	بَاعَ الْقُطْنَ
u'بَاعَ قَطِيعٌ':Predicate, #1: 1	بَاعَ الْقَطِيعَ
u'بَاعَ قَفِيز':Predicate, #3: 3	بَاعَ قَطِيعَ
u'بَاعَ قَفِيز':Predicate, #1: 1	بَاعَ الْقَفِيزَ
u'بَاعَ قلب':Predicate, #2: 2	بَاعَ قَفِيزَ
u'بَاعَ قَلْبٌ':Predicate, #6: 6	بَاعَ قَلْبَ
u'بَاعَ قَلْب':Predicate, #6: 6	بَاعَ قَلْبَ
u'بَاعَ قَيِّمٌ':Subject, #6: 6	بَاعَ قَلْبَ
u'بَاعَ كَافِرٌ':Subject, #4: 4	بَاعَ الْقَيِّمُ
u'بَاعَ كَافِرٌ':Subject, #2: 2	بَاعَ كَافِرٌ
u'بَاعَ كرش':Predicate, #3: 3	بَاعَ الْكَافِرُ
u'بَاعَ كَرِشٌ':Predicate, #1: 1	بَاعَ كَرِشَ
u'بَاعَ كَرْمٌ':Predicate, #1: 1	بَاعَ كَرِشَ
u'بَاعَ كِفَّةٌ':Predicate, #4: 4	بَاعَ الْكَرْمَ
u'بَاعَ كَفِيلٌ':Predicate, #1: 1	بَاعَ كِفَّةَ
u'بَاعَ كَفِيلٌ':Subject, #1: 1	بَاعَ الْكَفِيلَ
u'بَاعَ كُنَاسَةٌ':Predicate, #2: 2	بَاعَ الْكَفِيلُ
u'بَاعَ كُوزٌ':Predicate, #1: 1	بَاعَ الْكُنَاسَةَ
u'بَاعَ لبن':Predicate, #1: 1	بَاعَ كُوزَ
u'بَاعَ لَبَنٌ':Predicate, #2: 2	بَاعَ لَبَنَ
u'بَاعَ لَحْمٌ':Predicate, #2: 2	بَاعَ لَبَنَ
u'بَاعَ لَحْمٌ':Predicate, #2: 2	بَاعَ اللَّحْمَ
u'بَاعَ لقطة':Predicate, #5: 5	بَاعَ لَحْمَ
u'بَاعَ لُؤْلُؤَةٌ':Predicate, #1: 1	بَاعَ اللُّقَطَةَ
u'بَاعَ مَاءٌ':Predicate, #1: 1	بَاعَ اللُّؤْلُؤَةَ
u'بَاعَ مَاءٌ':Predicate, #2: 2	بَاعَ مَاءَ
u'بَاعَ مَاشِي':Predicate, #7: 7	بَاعَ الْمَاءَ
u'بَاعَ مَاشِي':Predicate, #2: 2	بَاعَ مَاشِيَةً
u'بَاعَ مَاشِيَةٌ':Predicate, #3: 3	بَاعَ الْمَاشِيَةَ
u'بَاعَ مَالٌ':Predicate, #3: 3	بَاعَ الْمَاشِيَةَ
u'بَاعَ مَالٌ':Predicate, #5: 5	بَاعَ الْمَالَ
u'بَاعَ مَالٌ':Subject, #72: 72	بَاعَ مَالَ
u'بَاعَ مَالِكٌ':Subject, #1: 1	بَاعَ مَالُ
u'بَاعَ مَالِكٌ':Subject, #2: 2	بَاعَ مَالِكُ
u'بَاعَ مَأْمُورٌ':Subject, #5: 5	بَاعَ الْمَالِكُ
u'بَاعَ مُبْتاع':Subject, #2: 2	بَاعَ الْمَأْمُورُ
u'بَاعَ مَبِيعٌ':Predicate, #1: 1	بَاعَ الْمُبْتَاعُ
u'بَاعَ مَبِيعٌ':Predicate, #1: 1	بَاعَ الْمَبِيعَةَ
u'بَاعَ مَتَاعٌ':Predicate, #7: 7	بَاعَ الْمَبِيعَ
u'بَاعَ مَتَاعٌ':Predicate, #2: 2	بَاعَ مَتَاعَ
u'بَاعَ مُجَمَّدٌ':Predicate, #6: 6	بَاعَ الْمَتَاعَ
u'بَاعَ مَجْهُولٌ':Predicate, #1: 1	بَاعَ الْمُجَمَّدَةَ
u'بَاعَ مُحْتَالٌ':Subject, #1: 1	بَاعَ الْمَجْهُولَةَ
u'بَاعَ مَحْجُورٌ':Predicate, #2: 2	بَاعَ الْمُحْتَالُ
u'بَاعَ مُحْرِمٌ':Subject, #1: 1	بَاعَ الْمَحْجُورَ
u'بَاعَ مِحْلَقٌ':Predicate, #3: 3	بَاعَ الْمُحْرِمُ
u'بَاعَ مَحْلُوجٌ':Predicate, #1: 1	بَاعَ الْمِحْلَقَ
u'بَاعَ مُدٌّ':Predicate, #3: 3	بَاعَ الْمَحْلُوجَ
u'بَاعَ مُدَبَّرٌ':Predicate, #2: 2	بَاعَ مُدَّ
u'بَاعَ مُدَبَّرٌ':Subject, #3: 3	بَاعَ الْمُدَبَّرَ
u'بَاعَ مَدْيُونٌ':Predicate, #1: 1	بَاعَ الْمُدَبَّرُ
u'بَاعَ مَدْيُونٌ':Subject, #1: 1	بَاعَ الْمَدْيُونَ
u'بَاعَ مرٌّ':Predicate, #4: 4	بَاعَ الْمَدْيُونُ
u'بَاعَ مُرْتَدٌّ':Subject, #1: 1	بَاعَ مَرَّةً
u'بَاعَ مُرْتَهِنٌ':Subject, #3: 3	بَاعَ الْمُرْتَدُّ
u'بَاعَ مَرْهُونٌ':Predicate, #4: 4	بَاعَ الْمُرْتَهِنُ
u'بَاعَ مَرِيضٌ':Predicate, #2: 2	بَاعَ الْمَرْهُونَ
u'بَاعَ مَرِيضٌ':Subject, #1: 1	بَاعَ الْمَرِيضَ
u'بَاعَ مُزَارِعٌ':Subject, #17: 17	بَاعَ الْمَرِيضُ
u'بَاعَ مُسْتَأْجِرٌ':Predicate, #1: 1	بَاعَ الْمُزَارِعُ
u'بَاعَ مُسْتَأْجِرٌ':Subject, #1: 1	بَاعَ الْمُسْتَأْجِرَ
u'بَاعَ مُسْتَأْجِرٌ':Subject, #1: 1	بَاعَ مُسْتَأْجِرُ
u'بَاعَ مُسْتَعِيرٌ':Subject, #2: 2	بَاعَ الْمُسْتَأْجِرُ
u'بَاعَ مُسْلِمٌ':Subject, #1: 1	بَاعَ الْمُسْتَعِيرُ
u'بَاعَ مُسْلِمٌ':Subject, #2: 2	بَاعَ مُسْلِمٌ
u'بَاعَ مُسَنّاة':Predicate, #6: 6	بَاعَ الْمُسْلِمُ
u'بَاعَ مَشْهُودٌ':Subject, #1: 1	بَاعَ الْمُسَنَّاةَ
u'بَاعَ مُضَارِبٌ':Subject, #1: 1	بَاعَ الْمَشْهُودُ
u'بَاعَ مَطْمُورٌ':Predicate, #18: 18	بَاعَ الْمُضَارِبُ
u'بَاعَ مَعْدُومٌ':Predicate, #1: 1	بَاعَ الْمَطْمُورَةَ
u'بَاعَ مَعِيبٌ':Predicate, #1: 1	بَاعَ الْمَعْدُومَ
u'بَاعَ مَغْصُوب':Predicate, #1: 1	بَاعَ الْمَعِيبَ
u'بَاعَ مَغْصُوب':Subject, #10: 10	بَاعَ الْمَغْصُوبَ
u'بَاعَ مَفَاتِيحُ':Predicate, #2: 2	بَاعَ الْمَغْصُوبُ
u'بَاعَ مُفَاوِضٌ':Subject, #1: 1	بَاعَ مَفَاتِيحَ
u'بَاعَ مِقْدَارٌ':Predicate, #1: 1	بَاعَ الْمُفَاوِضُ
u'بَاعَ مَقْدُورٌ':Predicate, #1: 1	بَاعَ مِقْدَارَ
u'بَاعَ مُقْرِضٌ':Subject, #1: 1	بَاعَ مَقْدُورَ
u'بَاعَ مَقْطُوعٌ':Predicate, #2: 2	بَاعَ الْمُقْرِضُ
u'بَاعَ مَكُّوكٌ':Predicate, #1: 1	بَاعَ مَقْطُوعَ
u'بَاعَ مَكِيلٌ':Predicate, #1: 1	بَاعَ مَكُّوكَ
u'بَاعَ مُلْتَقِط':Subject, #3: 3	بَاعَ الْمَكِيلَ
u'بَاعَ مِلْكٌ':Predicate, #4: 4	بَاعَ الْمُلْتَقِطُ
u'بَاعَ مَمْلُوكٌ':Predicate, #32: 32	بَاعَ مِلْكَ
u'بَاعَ مَمْلُوكٌ':Subject, #1: 1	بَاعَ الْمَمْلُوكَ
u'بَاعَ مَنْقُولٌ':Predicate, #1: 1	بَاعَ الْمَمْلُوكُ
u'بَاعَ مُؤَجِّرٌ':Predicate, #1: 1	بَاعَ الْمَنْقُولَ
u'بَاعَ مُؤَجِّرٌ':Subject, #1: 1	بَاعَ الْمُؤَجِّرَ
u'بَاعَ مَوْجُودٌ':Predicate, #2: 2	بَاعَ الْمُؤَجِّرُ
u'بَاعَ مَوْزُونٌ':Predicate, #1: 1	بَاعَ الْمَوْجُودَ
u'بَاعَ مُوَكَّلٌ':Predicate, #4: 4	بَاعَ الْمَوْزُونَ
u'بَاعَ مُوَكِّلٌ':Subject, #1: 1	بَاعَ الْمُوَكَّلَ
u'بَاعَ مَوْهُوبٌ':Subject, #1: 1	بَاعَ الْمُوَكِّلُ
u'بَاعَ نَاصِبٌ':Subject, #1: 1	بَاعَ الْمَوْهُوبُ
u'بَاعَ نَبِيٌّ':Subject, #1: 1	بَاعَ نَاصِبُ
u'بَاعَ نَخْلٌ':Predicate, #1: 1	بَاعَ النَّبِيُّ
u'بَاعَ نَخْلٌ':Predicate, #3: 3	بَاعَ النَّخْلَ
u'بَاعَ نَخِيلٌ':Predicate, #9: 9	بَاعَ نَخْلاً
u'بَاعَ نصاب':Predicate, #1: 1	بَاعَ النَّخِيلَ
u'بَاعَ نِصَابٌ':Predicate, #2: 2	بَاعَ نِصَابَ
u'بَاعَ نصاب':Predicate, #2: 2	بَاعَ نِصَابَ
u'بَاعَ نِصَابٌ':Predicate, #8: 8	بَاعَ النِّصَابَ
u'بَاعَ نَصْرَانِيٌّ':Subject, #8: 8	بَاعَ النِّصَابَ
u'بَاعَ نِصْفٌ':Predicate, #3: 3	بَاعَ نَصْرَانِيٌّ
u'بَاعَ نِصْفٌ':Predicate, #12: 12	بَاعَ النِّصْفَ
u'بَاعَ نَصِيبٌ':Predicate, #39: 39	بَاعَ نِصْفَ
u'بَاعَ نَعِيمٌ':Predicate, #1: 1	بَاعَ نَصِيبَ
u'بَاعَ نَفَذٌ':Predicate, #1: 1	بَاعَ نَعِيمَ
u'بَاعَ نَفْسٌ':Predicate, #1: 1	بَاعَ نَفَذَ
u'بَاعَ نقرة':Predicate, #5: 5	بَاعَ نَفْسَ
u'بَاعَ نُقْرَةٌ':Predicate, #1: 1	بَاعَ نُقْرَةَ
u'بَاعَ نَهْرٌ':Predicate, #1: 1	بَاعَ نُقْرَةَ
u'بَاعَ واحد':Predicate, #1: 1	بَاعَ النَّهْرَ
u'بَاعَ وَاحِدٌ':Predicate, #1: 1	بَاعَ وَاحِدَةً
u'بَاعَ واحد':Subject, #1: 1	بَاعَ وَاحِدَةً
u'بَاعَ وَاحِدٌ':Subject, #2: 2	بَاعَ وَاحِدٌ
u'بَاعَ وَارِثٌ':Predicate, #2: 2	بَاعَ وَاحِدٌ
u'بَاعَ وَارِثٌ':Subject, #1: 1	بَاعَ وَارِثَ
u'بَاعَ وَاقِفٌ':Subject, #6: 6	بَاعَ الْوَارِثُ
u'بَاعَ وَالِدٌ':Subject, #1: 1	بَاعَ الْوَاقِفُ
u'بَاعَ وَاهِبٌ':Subject, #1: 1	بَاعَ الْوَالِدُ
u'بَاعَ وَجِيزٌ':Predicate, #1: 1	بَاعَ وَاهِبٌ
u'بَاعَ وَدِيعٌ':Predicate, #1: 1	بَاعَ الْوَجِيزَ
u'بَاعَ وَدِيعَةٌ':Predicate, #3: 3	بَاعَ الْوَدِيعَةَ
u'بَاعَ وَرَثَةٌ':Subject, #3: 3	بَاعَ الْوَدِيعَةَ
u'بَاعَ ورق':Predicate, #4: 4	بَاعَ الْوَرَثَةُ
u'بَاعَ وَرَقٌ':Predicate, #1: 1	بَاعَ وَرَقَ
u'بَاعَ وَصِيٌّ':Subject, #1: 1	بَاعَ وَرَقَ
u'بَاعَ وَصِيٌّ':Subject, #20: 20	بَاعَ الْوَصِيُّ
u'بَاعَ وَقْفٌ':Predicate, #4: 4	بَاعَ وَصِيُّهُ
u'بَاعَ وَكِيلٌ':Subject, #4: 4	بَاعَ الْوَقْفَ
u'بَاعَ وَكِيلٌ':Subject, #1: 1	بَاعَ وَكِيلُ
u'بَاعَ وَكِيلٌ':Subject, #1: 1	بَاعَ وَكِيلُهُ
u'بَاعَ وَلاَءٌ':Predicate, #43: 43	بَاعَ الْوَكِيلُ
u'بَاعَ ولد':Predicate, #1: 1	بَاعَ وَلَاءَ
u'بَاعَ وَلَدٌ':Predicate, #4: 4	بَاعَ الْوَلَدَ
u'بَاعَ وَلِيٌّ':Subject, #4: 4	بَاعَ الْوَلَدَ
u'بَاعَ يهود':Subject, #4: 4	بَاعَ الْوَلِيُّ
u'بَاعَ يَهُودٌ':Subject, #1: 1	بَاعَ الْيَهُودُ
u'بَاعَ يَوْمٌ':Predicate, #1: 1	بَاعَ الْيَهُودُ
u'بَالَ اِبْنٌ':Subject, #1: 1	بَاعَ يَوْمَ
u'بَالَ أعْرَابِيٌّ':Subject, #1: 1	بَالَ ابْنُ
u'بَالَ أعْرَابِيٌّ':Subject, #1: 1	بَالَ أَعْرَابِيٌّ
u'بالٌ أَمْرٌ':Added, #1: 1	بَالَ الْأَعْرَابِيُّ
u'بَالٌ أَمْرٌ':Added, #9: 9	وَبَالَ أَمْرِهِ
u'بَالَ إِنْسانٌ':Subject, #9: 9	وَبَالَ أَمْرِهِ
u'بالٌ أَوَّلُ':Added, #2: 2	بَالَ إنْسَانٌ
u'بَالٌ أَوَّلُ':Added, #1: 1	وَبَالِ الْأَوَّلِ
u'بَالَ جَرِيرٌ':Subject, #1: 1	وَبَالِ الْأَوَّلِ
u'بَالَ رَجُلٌ':Subject, #3: 3	بَالَ جَرِيرٌ
u'بَالَ رَسُولٌ':Subject, #1: 1	بَالَ الرَّجُلُ
u'بَالَ سِنَّوْرٌ':Subject, #1: 1	بَالَ رَسُولُ
u'بَالَ شَيْطَانٌ':Subject, #1: 1	بَالَ السِّنَّوْرُ
u'بَالَ عند':Predicate, #4: 4	بَالَ الشَّيْطَانُ
u'بَالَغَ اِبْنٌ':Subject, #1: 1	بَالَ عِنْدَ
u'بَالَغَ إمَامٌ':Subject, #8: 8	بَالَغَ ابْنُ
u'بَالَغَ أئِمَّةٌ':Subject, #1: 1	بَالَغَ إمَامُ
u'بَالَغَ بَرٌّ':Predicate, #1: 1	بَالَغَ الْأَئِمَّةُ
u'بَالَغَ بَعْضٌ':Subject, #1: 1	بَالَغَ بَرَّ
u'بَالَغَ حافِظٌ':Subject, #4: 4	بَالَغَ بَعْضُ
u'بَالَغَ ذَهَبِيٌّ':Subject, #2: 2	بَالَغَ الْحَافِظُ
u'بَالَغَ سائِل':Subject, #1: 1	بَالَغَ الذَّهَبِيُّ
u'بَالَغَ سَائِلٌ':Subject, #1: 1	بَالَغَ السَّائِلُ
u'بَالَغَ غير':Subject, #1: 1	بَالَغَ السَّائِلُ
u'بَالَغَ غَيْرٌ':Subject, #1: 1	بَالَغَ غَيْرُ
u'بَالَغَ غير':Subject, #1: 1	بَالَغَ غَيْرُ
u'بَالَغَ غَيْرٌ':Subject, #1: 1	بَالَغَ غَيْرُهُ
u'بَالَغَ قَوْمٌ':Subject, #1: 1	بَالَغَ غَيْرُهُ
u'بَالَغَ مَالِكٌ':Subject, #2: 2	بَالَغَ قَوْمٌ
u'بَالَغَ مُصَنِّفٌ':Subject, #1: 1	بَالَغَ مَالِكٌ
u'بَالَ قَالٌ':Predicate, #1: 1	بَالَغَ الْمُصَنِّفُ
u'بالٌ كفر':Added, #1: 1	بَالَ قَالَ
u'بَالٌ كفر':Added, #1: 1	وَبَالُ كُفْرِهِ
u'بالٌ كُفْرٌ':Added, #1: 1	وَبَالُ كُفْرِهِ
u'بَالٌ كُفْرٌ':Added, #1: 1	وَبَالُ كُفْرِهِ
u'بالٌ كلاب':Added, #1: 1	وَبَالُ كُفْرِهِ
u'بَالٌ كلاب':Added, #1: 1	وَبَالُ الْكِلَابِ
u'بالٌ كِلاَبٌ':Added, #1: 1	وَبَالُ الْكِلَابِ
u'بَالٌ كِلاَبٌ':Added, #1: 1	وَبَالُ الْكِلَابِ
u'بالٌ مَعْصِيَةٌ':Added, #1: 1	وَبَالُ الْكِلَابِ
u'بَالٌ مَعْصِيَةٌ':Added, #1: 1	وَبَالِ الْمَعْصِيَةِ
u'بَانَ اِتِّضَاحٌ':Subject, #1: 1	وَبَالِ الْمَعْصِيَةِ
u'بَانَ أثَرٌ':Subject, #1: 1	بَانَ اتِّضَاحُ
u'بَانَ اِجْتِهَادٌ':Subject, #1: 1	بَانَ أَثَرُهُ
u'بَانَ أحَدٌ':Subject, #1: 1	بَانَ اجْتِهَادُهُ
u'بَانَ اِسْتِحْقَاقٌ':Subject, #1: 1	بَانَ أَحَدُ
u'بَانَ أعْظَمُ':Predicate, #1: 1	بَانَ اسْتِحْقَاقُ
u'بَانَ إقْرَارٌ':Subject, #1: 1	بَانَ أَعْظَمَ
u'بَانَ أقَلُّ':Predicate, #1: 1	بَانَ إقْرَارُ
u'بَانَ إمَامٌ':Subject, #4: 4	بَانَ أَقَلَّ
u'بَانَ إمَامٌ':Subject, #6: 6	بَانَ إمَامُهُ
u'بَانَ أَمْرٌ':Subject, #8: 8	بَانَ الْإِمَامُ
u'بَانَ أَمْنٌ':Subject, #3: 3	بَانَ الْأَمْرُ
u'بَانَ اِنْدِفاعٌ':Subject, #2: 2	بَانَ أَمْنُ
u'بَانَ اِنْدِفاعٌ':Subject, #1: 1	بَانَ انْدِفَاعُ
u'بَانَ اِنْقِطاعٌ':Subject, #1: 1	بَانَ انْدِفَاعُهُ
u'بَانَ أَوَّلُ':Predicate, #1: 1	بَانَ انْقِطَاعُ
u'بَانَ بُطْلان':Subject, #1: 1	أَبَانَ الْأَوَّلَ
u'بَانَ بَعْضٌ':Subject, #6: 6	بَانَ بُطْلَانُهُ
u'بَانَ بَقاءٌ':Subject, #1: 1	بَانَ بَعْضُ
u'بَانَ بِنْتٌ':Subject, #3: 3	بَانَ بَقَاءُ
u'بَانَ بَيْعٌ':Subject, #3: 3	أَبَانَ بِنْتُ
u'بَانَ تَحْرِيم':Predicate, #1: 1	بَانَ الْبَيْعُ
u'بَانَ تَفْرِيطٌ':Subject, #1: 1	بَانَ تَحْرِيمَةً
u'بَانَ تَلَفٌ':Subject, #1: 1	بَانَ تَفْرِيطُهُ
u'بَانَ ثَمَنٌ':Subject, #1: 1	بَانَ تَلَفُهُ
u'بَانَ جَلٌّ':Predicate, #3: 3	بَانَ الثَّمَنُ
u'بَانَ جَوَابٌ':Subject, #1: 1	أَبَانَ جَلَّ
u'بَانَ جَوَازٌ':Subject, #1: 1	بَانَ الْجَوَابُ
u'بَانَ حَبْسٌ':Subject, #2: 2	بَانَ جَوَازُهُ
u'بَانَ حَدَثٌ':Subject, #1: 1	بَانَ حَبْسُهُ
u'بَانَ حَدَثٌ':Subject, #3: 3	بَانَ حَدَثُ
u'بَانَ حَقٌّ':Subject, #5: 5	بَانَ حَدَثُهُ
u'بَانَ حَمْلٌ':Subject, #2: 2	بَانَ الْحَقُّ
u'بَانَ حِنْثٌ':Subject, #1: 1	بَانَ الْحَمْلُ
u'بَانَ حَيَاةٌ':Subject, #1: 1	بَانَ حِنْثُهُ
u'بَانَ خُرُوجٌ':Subject, #1: 1	بَانَ حَيَاةُ
u'بَانَ خَطَأٌ':Subject, #1: 1	بَانَ خُرُوجُ
u'بَانَ خَطَأٌ':Subject, #1: 1	أَبَانَ خَطَأٌ
u'بَانَ خَطَأٌ':Subject, #1: 1	بَانَ الْخَطَأُ
u'بَانَ خَطَلٌ':Subject, #2: 2	بَانَ خَطَأُ
u'بَانَ خِلاَفٌ':Subject, #1: 1	بَانَ خَطَلُهُ
u'بَانَ خِلاَفٌ':Subject, #27: 27	بَانَ خِلَافُهُ
u'بَانَ خَلَلٌ':Subject, #9: 9	بَانَ خِلَافُ
u'بَانَ خَلِيفَةٌ':Subject, #2: 2	بَانَ الْخَلَلُ
u'بَانَ دونٌ':Predicate, #1: 1	بَانَ خَلِيفَةٌ
u'بَانَ رَأْسٌ':Predicate, #1: 1	بَانَ دُونَ
u'بَانَ رَأْسٌ':Subject, #2: 2	أَبَانَ الرَّأْسَ
u'بَانَ رَأْسٌ':Subject, #1: 1	بَانَ الرَّأْسُ
u'بَانَ رَجُلٌ':Subject, #1: 1	بَانَ رَأْسُهُ
u'بَانَ رَجُلٌ':Subject, #1: 1	أَبَانَ الرَّجُلُ
u'بَانَ زَوالٌ':Subject, #2: 2	أَبَانَ رَجُلٌ
u'بَانَ سَبْقٌ':Subject, #2: 2	بَانَ زَوَالُهُ
u'بَانَ شافِعِيّ':Predicate, #1: 1	بَانَ السَّبْقُ
u'بَانَ شَجَرٌ':Subject, #1: 1	أَبَانَ الشَّافِعِيَّ
u'بَانَ شَرْعٌ':Subject, #1: 1	بَانَ الشَّجَرُ
u'بَانَ شُهُودٌ':Subject, #1: 1	بَانَ الشَّرْعُ
u'بَانَ شَيْءٌ':Subject, #1: 1	بَانَ الشُّهُودُ
u'بَانَ صُبْحٌ':Subject, #1: 1	بَانَ الشَّيْءُ
u'بَانَ صِحَّةٌ':Subject, #1: 1	بَانَ صُبْحٌ
u'بَانَ صِحَّةٌ':Subject, #2: 2	بَانَ صِحَّتُهُ
u'بَانَ صدق':Subject, #7: 7	بَانَ صِحَّةُ
u'بَانَ صِدْقٌ':Subject, #2: 2	بَانَ صِدْقُهُ
u'بَانَ صَغِيرٌ':Predicate, #2: 2	بَانَ صِدْقُهُ
u'بَانَ صَوَابٌ':Subject, #2: 2	أَبَانَ صَغِيرَةً
u'بَانَ صَوَابٌ':Subject, #1: 1	بَانَ الصَّوَابُ
u'بَانَ طَالِبٌ':Subject, #2: 2	بَانَ صَوَابُهُ
u'بَانَ طَائِفٌ':Subject, #1: 1	بَانَ الطَّالِبُ
u'بَانَ طَبَرِيّ':Subject, #1: 1	أَبَانَ طَائِفَةٌ
u'بَانَ طُلُوعٌ':Subject, #1: 1	أَبَانَ الطَّبَرِيُّ
u'بَانَ طهر':Subject, #1: 1	بَانَ الطُّلُوعُ
u'بَانَ طُهْرٌ':Subject, #2: 2	بَانَ الطُّهْرُ
u'بَانَ ظُهورٌ':Subject, #2: 2	بَانَ الطُّهْرُ
u'بَانَ عَبْدٌ':Subject, #1: 1	بَانَ ظُهُورُهُ
u'بَانَ عَبْدٌ':Subject, #1: 1	بَانَ الْعَبْدُ
u'بَانَ عَجْزٌ':Subject, #1: 1	بَانَ عَبْدُهُ
u'بَانَ عجز':Subject, #1: 1	بَانَ عَجْزٌ
u'بَانَ عَجْزٌ':Subject, #1: 1	بَانَ عَجْزُهُ
u'بَانَ عَدَمٌ':Subject, #1: 1	بَانَ عَجْزُهُ
u'بَانَ عَدَمٌ':Subject, #1: 1	بَانَ عَدَمُهُ
u'بَانَ عَصِيرٌ':Subject, #9: 9	بَانَ عَدَمُ
u'بَانَ عَظْمٌ':Subject, #1: 1	بَانَ الْعَصِيرُ
u'بَانَ عَقْدٌ':Subject, #1: 1	بَانَ عَظْمُ
u'بَانَ عِوَضٌ':Subject, #1: 1	بَانَ الْعَقْدُ
u'بَانَ عِوَضٌ':Subject, #1: 1	بَانَ الْعِوَضُ
u'بَانَ عِوَضٌ':Subject, #1: 1	بَانَ عِوَضُ
u'بَانَ عَيْبٌ':Subject, #1: 1	بَانَ عِوَضُهُ
u'بَانَ عَيْبٌ':Subject, #1: 1	بَانَ عَيْبٌ
u'بَانَ عَيْبٌ':Subject, #1: 1	بَانَ عَيْبُ
u'بَانَ غَائِبٌ':Subject, #3: 3	بَانَ الْعَيْبُ
u'بَانَ غَبْنٌ':Subject, #1: 1	بَانَ الْغَائِبُ
u'بَانَ غير':Predicate, #1: 1	بَانَ غَبْنٌ
u'بَانَ غَيْرٌ':Predicate, #2: 2	بَانَ غَيْرَ
u'بَانَ غير':Subject, #2: 2	بَانَ غَيْرَ
u'بَانَ غَيْرٌ':Subject, #1: 1	بَانَ غَيْرُهُ
u'بَانَ فرق':Subject, #1: 1	بَانَ غَيْرُهُ
u'بَانَ فَرْقٌ':Subject, #1: 1	أَبَانَ الْفَرْقُ
u'بَانَ فساد':Subject, #1: 1	أَبَانَ الْفَرْقُ
u'بَانَ فَسَادٌ':Subject, #11: 11	بَانَ فَسَادُ
u'بَانَ فساد':Subject, #11: 11	بَانَ فَسَادُ
u'بَانَ فَسَادٌ':Subject, #8: 8	بَانَ فَسَادُهُ
u'بَانَ فِسْقٌ':Subject, #8: 8	بَانَ فَسَادُهُ
u'بَانَ فِسْقٌ':Subject, #3: 3	بَانَ فِسْقُ
u'بَانَ فَضْلٌ':Subject, #3: 3	بَانَ فِسْقُهُ
u'بَانَ فِقْهٌ':Predicate, #1: 1	بَانَ فَضْلُهُ
u'بَانَ فَقِيرٌ':Subject, #1: 1	أَبَانَ فِقْهَ
u'بَانَ فلان':Predicate, #2: 2	بَانَ الْفَقِيرُ
u'بَانَ فلان':Subject, #1: 1	أَبَانَ الشَّافِعِيَّ
u'بَانَ فَوَاتٌ':Subject, #1: 1	أَبَانَ الطَّبَرِيُّ
u'بَانَ قَابِضٌ':Subject, #2: 2	بَانَ فَوَاتُ
u'بَانَ قَالٌ':Predicate, #1: 1	بَانَ الْقَابِضُ
u'بَانَ قَالٌ':Predicate, #1: 1	أَبَانَ قَالاَ
u'بَانَ قَالٌ':Predicate, #1: 1	بَانَ قَالَ
u'بَانَ قُرَشِيٌّ':Subject, #7: 7	أَبَانَ قَالَ
u'بَانَ كَثِيرٌ':Subject, #1: 1	أَبَانَ الْقُرَشِيُّ
u'بَانَ كذب':Subject, #1: 1	بَانَ الْكَثِيرُ
u'بَانَ كَذِبٌ':Subject, #1: 1	بَانَ كَذِبُ
u'بَانَ كذب':Subject, #1: 1	بَانَ كَذِبُ
u'بَانَ كَذِبٌ':Subject, #2: 2	بَانَ كَذِبُهُ
u'بَانَ كَوْنٌ':Subject, #2: 2	بَانَ كَذِبُهُ
u'بَانَ كَوْنٌ':Subject, #1: 1	بَانَ كَوْنُهُ
u'بَانَ مَالٌ':Subject, #3: 3	بَانَ كَوْنُ
u'بَانَ مَبْنِيٌّ':Subject, #1: 1	بَانَ الْمَالُ
u'بَانَ مَبِيعٌ':Subject, #1: 1	أَبَانَ مَبْنِيٌّ
u'بَانَ مَتْرُوكٌ':Subject, #1: 1	بَانَ الْمَبِيعُ
u'بَانَ مَدْفُوعٌ':Subject, #1: 1	أَبَانَ مَتْرُوكٌ
u'بَانَ مراد':Subject, #1: 1	بَانَ الْمَدْفُوعُ
u'بَانَ مُرَادٌ':Subject, #1: 1	بَانَ الْمُرَادُ
u'بَانَ مُسْتَحَقٌّ':Predicate, #1: 1	بَانَ الْمُرَادُ
u'بَانَ مُسْتَحِقٌّ':Predicate, #1: 1	بَانَ مُسْتَحَقَّ
u'بَانَ مُسْتَحِقٌّ':Subject, #1: 1	بَانَ مُسْتَحِقَّ
u'بَانَ مَظْلُومٌ':Predicate, #1: 1	بَانَ الْمُسْتَحِقُّ
u'بَانَ مُعَجَّلٌ':Subject, #3: 3	أَبَانَ الْمَظْلُومَةَ
u'بَانَ مِلْكٌ':Subject, #2: 2	بَانَ الْمُعَجَّلُ
u'بَانَ مُنْقَطِعٌ':Predicate, #1: 1	بَانَ الْمِلْكُ
u'بَانَ مَهْرٌ':Subject, #1: 1	بَانَ مُنْقَطِعَ
u'بَانَ مَوْتٌ':Subject, #1: 1	بَانَ الْمَهْرُ
u'بَانَ مَوْتٌ':Subject, #1: 1	بَانَ مَوْتُ
u'بَانَ مَوْصُوفٌ':Subject, #5: 5	بَانَ مَوْتُهُ
u'بَانَ نَجَاسَةٌ':Subject, #1: 1	بَانَ الْمَوْصُوفُ
u'بَانَ نَصٌّ':Subject, #1: 1	بَانَ نَجَاسَتُهُ
u'بَانَ نِصْفٌ':Subject, #1: 1	بَانَ النَّصُّ
u'بَانَ نَصِيبٌ':Subject, #1: 1	بَانَ نِصْفُهُ
u'بَانَ نُفُوذٌ':Subject, #1: 1	بَانَ نَصِيبُ
u'بَانَ نَقْدٌ':Subject, #2: 2	بَانَ نُفُوذُهُ
u'بَانَ نَقْد':Subject, #1: 1	بَانَ النَّقْدُ
u'بَانَ نَقْصٌ':Subject, #1: 1	بَانَ النَّقْدُ
u'بَانَ نَقْصٌ':Subject, #1: 1	بَانَ النَّقْصُ
u'بَانَ نَقْصٌ':Subject, #1: 1	بَانَ نَقْصُهُ
u'بَانَ واحد':Predicate, #2: 2	بَانَ نَقْصٌ
u'بَانَ وَاحِدٌ':Predicate, #2: 2	أَبَانَ وَاحِدَةً
u'بَانَ وُجُوبٌ':Subject, #2: 2	أَبَانَ وَاحِدَةً
u'بَانَ وُجُوبٌ':Subject, #1: 1	بَانَ الْوُجُوبُ
u'بَانَ وُجُودٌ':Subject, #1: 1	بَانَ وُجُوبُ
u'بَانَ وُجُودٌ':Subject, #1: 1	بَانَ وُجُودُ
u'بَانَ وُقُوعٌ':Subject, #1: 1	بَانَ وُجُودُهُ
u'بَانَ يَدٌ':Predicate, #1: 1	بَانَ وُقُوعُ
u'بَانَ يسار':Subject, #1: 1	أَبَانَ الْيَدَ
u'بَانَ يَسَارٌ':Subject, #3: 3	بَانَ يَسَارُهُ
u'بَايَعَ اِبْنٌ':Predicate, #3: 3	بَانَ يَسَارُهُ
u'بَايَعَ اِبْنٌ':Subject, #1: 1	بَايَعَ ابْنَ
u'بَايَعَ أَرْبَعَةٌ':Subject, #1: 1	بَايَعَ ابْنُ
u'بَايَعَ المُشْتَرِي':Predicate, #1: 1	بَايَعَ أَرْبَعَةٌ
u'بَايَعَ بَيْعَةٌ':Predicate, #1: 1	بَايَعَ الْمُشْتَرِيَ
u'بَايَعَ خَمْسَةٌ':Subject, #1: 1	بَايَعَ بَيْعَةَ
u'بَايَعَ رَجُلٌ':Predicate, #1: 1	بَايَعَ خَمْسَةٌ
u'بَايَعَ رَجُلٌ':Subject, #3: 3	بَايَعَ رَجُلاً
u'بَايَعَ رَسُولٌ':Predicate, #1: 1	بَايَعَ الرَّجُلُ
u'بَايَعَ رَسُولٌ':Subject, #7: 7	بَايَعَ رَسُولَ
u'بَايَعَ صَحَابَةٌ':Subject, #2: 2	بَايَعَ رَسُولُ
u'بَايَعَ عَبْدٌ':Predicate, #1: 1	بَايَعَ الصَّحَابَةُ
u'بَايَعَ فلان':Predicate, #3: 3	بَايَعَ الْعَبْدَ
u'بَايَعَ فلان':Predicate, #1: 1	بَايَعَ عُثْمَانَ
u'بَايَعَ مُشْتَرِي':Predicate, #2: 2	بَايَعَ مُعَاوِيَةَ
u'بَايَعَ مُعاوِيَة':Predicate, #1: 1	بَايَعَ الْمُشْتَرِيَ
u'بَايَعَ نَاسٌ':Predicate, #2: 2	بَايَعَ مُعَاوِيَةَ
u'بَايَعَ نَاسٌ':Subject, #1: 1	بَايَعَ النَّاسَ
u'بَايَعَ نَبِيٌّ':Predicate, #4: 4	بَايَعَ النَّاسُ
u'بَايَعَ نِساءٌ':Predicate, #2: 2	بَايَعَ النَّبِيَّ
u'بَتَّةٌ واحد':Added, #1: 1	بَايَعَ النِّسَاءَ
u'بَتَّةٌ وَاحِدٌ':Added, #1: 1	بَتَّةٍ وَاحِدَةٍ
u'بَتَّ حُكْمٌ':Predicate, #1: 1	بَتَّةٍ وَاحِدَةٍ
u'بَتَّ حُكْمٌ':Subject, #3: 3	بَتَّ الْحُكْمَ
u'بَتَّ طَلاَقٌ':Predicate, #1: 1	بَتَّ الْحُكْمُ
u'بَتَّ عتق':Predicate, #1: 1	بَتَّ طَلَاقَ
u'بَتَّ عتق':Predicate, #1: 1	بَتَّ عَتَقَ
u'بَتَّ عِتْقٌ':Predicate, #1: 1	بَتَّ عِتْقَ
u'بَحْثٌ آبارٌ':Added, #1: 1	بَتَّ عِتْقَ
u'بَحَثَ اِبْنٌ':Subject, #1: 1	بَحْثِ الْآبَارِ
u'بَحْثٌ اِبْنٌ':Added, #2: 2	بَحَثَ ابْنُ
u'بَحْثٌ اِبْنٌ':Added, #1: 1	بَحْث ابْنِ
u'بَحْثٌ اِبْنٌ':Added, #2: 2	بَحْثِ ابْنِ
u'بَحْثٌ أَحْكَامٌ':Added, #4: 4	بَحْثَ ابْنِ
u'بَحْثٌ اِخْتِلاَفٌ':Added, #1: 1	بَحْثِ أَحْكَامِ
u'بَحْثٌ أَدَاءٌ':Added, #1: 1	بَحْثِ اخْتِلَافِ
u'بَحْثٌ أًصْلٌ':Added, #1: 1	بَحْثِ الْأَدَاءِ
u'بَحْثٌ أصل':Added, #1: 1	بَحْثَ أَصْلٍ
u'بَحْثٌ أصل':Added, #1: 1	بَحْثَ الْأَصْلِ
u'بَحْثٌ أًصْلٌ':Added, #1: 1	بَحْثِ الْأَصْلِ
u'بَحْثٌ أًصْلٌ':Added, #1: 1	بَحْثَ الْأَصْلِ
u'بَحْثٌ إِعادَةٌ':Added, #1: 1	بَحْثِ الْأَصْلِ
u'بَحْثٌ اِعْتِبارٌ':Added, #1: 1	بَحْثِ الْإِعَادَةِ
u'بَحْثٌ أَقْسَامٌ':Added, #2: 2	بَحْثِ اعْتِبَارِ
u'بَحْثٌ إكْرَاهٌ':Added, #1: 1	بَحْثِ الْأَقْسَامِ
u'بَحَثَ أَكْمَلُ':Subject, #1: 1	بَحْثِ الْإِكْرَاهِ
u'بَحْثٌ إمَامٌ':Added, #1: 1	بَحَثَ الْأَكْمَلُ
u'بَحَثَ أَمْرٌ':Predicate, #1: 1	بَحْثَ الْإِمَامِ
u'بَحْثٌ أَمْرٌ':Added, #1: 1	بَحَثَ الْأَمْرَ
u'بَحْثٌ أَمْنٌ':Added, #6: 6	بَحْثِ الْأَمْرِ
u'بَحَثَ اِنْحِلالٌ':Predicate, #1: 1	بَحْثِ الْأَمْنِ
u'بَحْثٌ أوامر':Added, #1: 1	بَحَثَ انْحِلَالَ
u'بَحْثٌ أَوامِرُ':Added, #1: 1	بَحْثِ الْأَوَامِرِ
u'بَحَثَ أَوَّلُ':Predicate, #1: 1	بَحْثِ الْأَوَامِرِ
u'بَحْثٌ إيمَانٌ':Added, #1: 1	بَحَثَ الْأَوَّلَ
u'بَحْثٌ باء':Added, #1: 1	بَحْثِ الْإِيمَانِ
u'بَحَثَ بَحْثٌ':Predicate, #2: 2	بَحْثِ الْبَاءِ
u'بَحَثَ بَعْضٌ':Subject, #1: 1	بَحَثَ الْبَحْثَ
u'بَحْثٌ بَعْضٌ':Added, #6: 6	بَحَثَ بَعْضُ
u'بَحْثٌ تَأْثِيرٌ':Added, #1: 1	بَحْثَ بَعْضِ
u'بَحْثٌ تَثْلِيثٌ':Added, #1: 1	بَحْثِ التَّأْثِيرِ
u'بَحْثٌ تَحْسِين':Added, #1: 1	بَحْثِ تَثْلِيثِ
u'بَحْثٌ تَخْصِيصٌ':Added, #1: 1	بَحْثُ التَّحْسِينِ
u'بَحْثٌ تَرْكٌ':Added, #12: 12	بَحْثِ التَّخْصِيصِ
u'بَحْثٌ تَسْمِيعٌ':Added, #1: 1	بَحْثِ تَرْكِ
u'بَحْثٌ تَقْسِيمٌ':Added, #1: 1	بَحْثِ التَّسْمِيعِ
u'بَحْثٌ تَكْليفٌ':Added, #1: 1	بَحْثِ تَقْسِيمِ
u'بَحْثٌ تَنَازُعٌ':Added, #1: 1	بَحْثِ التَّكْلِيفِ
u'بَحْثٌ تَوْبَةٌ':Added, #1: 1	بَحْثِ التَّنَازُعِ
u'بَحْثٌ ثَوْرٌ':Added, #1: 1	بَحْثِ التَّوْبَةِ
u'بَحْثٌ جُلُوسٌ':Added, #1: 1	بَحْثَ الثّوْرِ
u'بَحَثَ جَمْعٌ':Subject, #1: 1	بَحْثِ الْجُلُوسِ
u'بَحْثٌ جِنَايَةٌ':Added, #1: 1	بَحَثَ جَمْعٌ
u'بَحْثٌ جُنُونٌ':Added, #2: 2	بَحْثِ الْجِنَايَةِ
u'بَحْثٌ جهل':Added, #1: 1	بَحْثِ الْجُنُونِ
u'بَحْثٌ جَهْلٌ':Added, #1: 1	بَحْثِ الْجَهْلِ
u'بَحَثَ جَوَازٌ':Predicate, #1: 1	بَحْثِ الْجَهْلِ
u'بَحْثٌ جَوَازٌ':Added, #1: 1	بَحَثَ الْجَوَازَ
u'بَحَثَ حُرْمَةٌ':Predicate, #1: 1	بَحْثِ جَوَازِ
u'بَحْثٌ حُروفٌ':Added, #1: 1	بَحَثَ الْحُرْمَةَ
u'بَحْثٌ حَضَرٌ':Added, #1: 1	بَحْثِ حُرُوفِ
u'بَحْثٌ حَقِيقٌ':Added, #2: 2	بَحْثِ الْحَضَرِ
u'بَحْثٌ حَقِيقٌ':Added, #1: 1	بَحْثُ الْحَقِيقَةِ
u'بَحْثٌ حَقِيقَةٌ':Added, #4: 4	بَحْثِ الْحَقِيقَةِ
u'بَحْثٌ حَقِيقَةٌ':Added, #1: 1	بَحْثُ الْحَقِيقَةِ
u'بَحَثَ حِلٌّ':Predicate, #4: 4	بَحْثِ الْحَقِيقَةِ
u'بَحْثٌ خاصّ':Added, #1: 1	بَحَثَ الْحِلَّ
u'بَحْثٌ خَمْرٌ':Added, #3: 3	بَحْثِ الْخَاصِّ
u'بَحْثٌ خيار':Added, #1: 1	بَحْثِ الْخَمْرِ
u'بَحْثٌ خِيَارٌ':Added, #1: 1	بَحْثِ خِيَارِ
u'بَحْثٌ دُخُولٌ':Added, #1: 1	بَحْثِ خِيَارِ
u'بَحْثٌ دَلالَةٌ':Added, #1: 1	بَحْثِ الدُّخُولِ
u'بَحْثٌ ذكر':Added, #1: 1	بَحْثِ دَلَالَةِ
u'بَحْثٌ ذِكْرٌ':Added, #1: 1	بَحْثِ الذِّكْرِ
u'بَحْثٌ رَمْيٌ':Added, #1: 1	بَحْثِ الذِّكْرِ
u'بَحْثٌ رَوْضَةٌ':Added, #1: 1	بَحْثِ رَمْيِ
u'بَحْثٌ سَفَرٌ':Added, #1: 1	بَحْثِ الرَّوْضَةِ
u'بَحْثٌ سلام':Added, #1: 1	بَحْثِ السَّفَرِ
u'بَحْثٌ سَلاَمٌ':Added, #1: 1	بَحْثِ السَّلَامِ
u'بَحْثٌ سَيِّدٌ':Added, #1: 1	بَحْثِ السَّلَامِ
u'بَحْثٌ سَيِّدٌ':Added, #1: 1	بَحْثُ السَّيِّدِ
u'بَحْثٌ شَارِحٌ':Added, #1: 1	بَحْثِ السَّيِّدِ
u'بَحْثٌ شَهَادَةٌ':Added, #1: 1	بَحْثِ الشَّارِحِ
u'بَحَثَ شَيْخٌ':Subject, #1: 1	بَحْثِ شَهَادَةِ
u'بَحْثٌ شَيْخٌ':Added, #1: 1	بَحَثَ الشَّيْخُ
u'بَحْثٌ شَيْخٌ':Added, #1: 1	بَحْثُ الشَّيْخِ
u'بَحْثٌ شَيْخٌ':Added, #1: 1	بَحْثِ الشَّيْخِ
u'بَحْثٌ صَاحِبٌ':Added, #1: 1	بَحْثُ الشَّيْخَيْنِ
u'بَحْثٌ صَرِيحٌ':Added, #1: 1	بَحْثَ صَاحِبِ
u'بَحْثٌ صِلَةٌ':Added, #1: 1	بَحْثِ الصَّرِيحِ
u'بَحْثٌ صَوْمٌ':Added, #1: 1	بَحْثِ الصِّلَةِ
u'بَحَثَ طَرْدٌ':Predicate, #1: 1	بَحْثِ الصَّوْمِ
u'بَحْثٌ طَهَارَةٌ':Added, #1: 1	بَحَثَ طَرْدَ
u'بَحْثٌ عَامٌّ':Added, #1: 1	بَحْثِ الطَّهَارَةِ
u'بَحْثٌ عتق':Added, #1: 1	بَحْثِ الْعَامِّ
u'بَحْثٌ عِتْقٌ':Added, #1: 1	بَحْثِ عِتْقِ
u'بَحْثٌ عَزِيمَةٌ':Added, #1: 1	بَحْثِ عِتْقِ
u'بَحَثَ عَفْوٌ':Predicate, #2: 2	بَحْثِ الْعَزِيمَةِ
u'بَحْثٌ عَقْلِيٌّ':Added, #1: 1	بَحَثَ الْعَفْوَ
u'بَحْثٌ عَقِيدَةٌ':Added, #1: 1	بَحْثٍ عَقْلِيٍّ
u'بَحْثٌ عِلَّةٌ':Added, #1: 1	بَحْثِ الْعَقِيدَةِ
u'بَحْثٌ عِلَلٌ':Added, #1: 1	بَحْثِ الْعِلَّةِ
u'بَحْثٌ عُمُومٌ':Added, #2: 2	بَحْثِ الْعِلَلِ
u'بَحْثٌ عَوَارِضُ':Added, #1: 1	بَحْثِ الْعُمُومِ
u'بَحْثٌ غُسْلٌ':Added, #2: 2	بَحْثِ الْعَوَارِضِ
u'بَحْثٌ غِيبَةٌ':Added, #1: 1	بَحْثِ الْغُسْلِ
u'بَحْثٌ فَتْحٌ':Added, #1: 1	بَحْثِ الْغِيبَةِ
u'بَحْثٌ فَرَائِضُ':Added, #1: 1	بَحْثُ الْفَتْحِ
u'بَحَثَ فرق':Predicate, #1: 1	بَحْثِ الْفَرَائِضِ
u'بَحَثَ فَرْقٌ':Predicate, #1: 1	بَحَثَ الْفَرْقَ
u'بَحْثٌ فساد':Added, #1: 1	بَحَثَ الْفَرْقَ
u'بَحْثٌ فَسَادٌ':Added, #1: 1	بَحْثِ فَسَادِ
u'بَحْثٌ فُضُولِيٌّ':Added, #1: 1	بَحْثِ فَسَادِ
u'بَحْثٌ فَقِيرٌ':Added, #1: 1	بَحْثِ الْفُضُولِيِّ
u'بَحْثٌ قدرة':Added, #1: 1	بَحْثِ الْفَقِيرِ
u'بَحْثٌ قُدْرَةٌ':Added, #3: 3	بَحْثِ الْقُدْرَةِ
u'بَحْثٌ قَضَاءٌ':Added, #3: 3	بَحْثِ الْقُدْرَةِ
u'بَحْثٌ قَطْع':Added, #4: 4	بَحْثِ الْقَضَاءِ
u'بَحْثٌ قَطْعَة':Added, #1: 1	بَحْثِ الْقَطْعِيَّةِ
u'بَحْثٌ قَطْعِيّ':Added, #1: 1	بَحْثِ الْقَطْعِيَّةِ
u'بَحْثٌ قَطْعِيَّة':Added, #1: 1	بَحْثِ الْقَطْعِيَّةِ
u'بَحْثٌ قول':Added, #1: 1	بَحْثِ الْقَطْعِيَّةِ
u'بَحْثٌ قَوْلٌ':Added, #1: 1	بَحْثِ قَوْلِهِ
u'بَحْثٌ قِيَاسٌ':Added, #1: 1	بَحْثِ قَوْلِهِ
u'بَحْثٌ قيام':Added, #1: 1	بَحْثِ الْقِيَاسِ
u'بَحْثٌ قِيَامٌ':Added, #1: 1	بَحْثِ الْقِيَامِ
u'بَحْثٌ كبر':Added, #1: 1	بَحْثِ الْقِيَامِ
u'بَحْثٌ كِبْرٌ':Added, #1: 1	بَحْثِ الْكِبْرِ
u'بَحْثٌ كَفَالَةٌ':Added, #1: 1	بَحْثِ الْكِبْرِ
u'بَحْثٌ كَمَالٌ':Added, #1: 1	بَحْثُ الْكَفَالَةِ
u'بَحْثٌ كَوْنٌ':Added, #1: 1	بَحْثِ الْكَمَالِ
u'بَحْثٌ لاَمٌ':Added, #1: 1	بَحْثِ كَوْنِ
u'بَحْثٌ لُغَةٌ':Added, #1: 1	بَحْثِ اللَّامِ
u'بَحْثٌ لَمْسٌ':Added, #1: 1	بَحْثِ اللُّغَاتِ
u'بَحْثٌ مَاءٌ':Added, #1: 1	بَحْثِ اللَّمْسِ
u'بَحْثٌ مُبَاحٌ':Added, #10: 10	بَحْثِ الْمَاءِ
u'بَحْثٌ مَجَازٌ':Added, #1: 1	بَحْثِ الْمُبَاحِ
u'بَحْثٌ مُجْتَهِد':Added, #1: 1	بَحْثِ الْمَجَازِ
u'بَحْثٌ مَجْدٌ':Added, #1: 1	بَحْثُ الْمُجْتَهِدِ
u'بَحْثٌ مُجْمَلٌ':Added, #2: 2	بَحْثِ الْمَجْدِ
u'بَحْثٌ مُجْمَلٌ':Added, #1: 1	بَحْثَ الْمُجْمَلِ
u'بَحْثٌ مُحَاذَاةٌ':Added, #2: 2	بَحْثِ الْمُجْمَلِ
u'بَحَثَ مُحَقِّقٌ':Subject, #1: 1	بَحْثِ الْمُحَاذَاةِ
u'بَحْثٌ مُحَقِّقٌ':Added, #4: 4	بَحَثَ الْمُحَقِّقُ
u'بَحْثٌ مُحَقِّقٌ':Added, #1: 1	بَحْثُ الْمُحَقِّقِ
u'بَحْثٌ مُحَقِّقٌ':Added, #2: 2	بَحْثَ الْمُحَقِّقِ
u'بَحَثَ مَسْأَلَةٌ':Predicate, #2: 2	بَحْثِ الْمُحَقِّقِ
u'بَحْثٌ مَسْأَلَةٌ':Added, #1: 1	بَحَثَ الْمَسْأَلَةَ
u'بَحْثٌ مَسْأَلَةٌ':Added, #6: 6	بَحْثِ مَسْأَلَةِ
u'بَحْثٌ مُسْتَعْمَلٌ':Added, #8: 8	بَحْثِ الْمَسْأَلَةِ
u'بَحْثٌ مُشْتَرَكٌ':Added, #5: 5	بَحْثِ الْمُسْتَعْمَلِ
u'بَحْثٌ مُصَنِّفٌ':Added, #1: 1	بَحْثِ الْمُشْتَرَكِ
u'بَحْثٌ مُصَنِّفٌ':Added, #1: 1	بَحْثَ الْمُصَنِّفِ
u'بَحْثٌ مُصَنِّفٌ':Added, #1: 1	بَحْثُ الْمُصَنِّفِ
u'بَحْثٌ مُطْلَقٌ':Added, #2: 2	بَحْثِ الْمُصَنِّفِ
u'بَحْثٌ مَعْرِفَةٌ':Added, #1: 1	بَحْثِ الْمُطْلَقِ
u'بَحْثٌ مَعْرِفَة':Added, #1: 1	بَحْثُ مَعْرِفَةِ
u'بَحْثٌ مَفَاهِيمُ':Added, #1: 1	بَحْثُ مَعْرِفَةِ
u'بَحْثٌ مَفْهُومٌ':Added, #2: 2	بَحْثِ الْمَفَاهِيمِ
u'بَحْثٌ مَفْهُومٌ':Added, #1: 1	بَحْثِ مَفْهُومِ
u'بَحْثٌ مَنْعٌ':Added, #3: 3	بَحْثِ الْمَفْهُومِ
u'بَحْثٌ مَوْتٌ':Added, #1: 1	بَحْثُ مَنْعِ
u'بَحَثَ مُؤَلِّفٌ':Subject, #1: 1	بَحْثِ الْمَوْتِ
u'بَحْثٌ مُؤَلِّفٌ':Added, #1: 1	بَحَثَ الْمُؤَلِّفُ
u'بَحْثٌ مُؤَلِّفٌ':Added, #1: 1	بَحْثَ الْمُؤَلِّفِ
u'بَحْثٌ مُؤَلِّفٌ':Added, #2: 2	بَحْثُ الْمُؤَلِّفِ
u'بَحْثٌ مِيَاهٌ':Added, #2: 2	بَحْثِ الْمُؤَلِّفِ
u'بَحْثٌ نَدْبٌ':Added, #5: 5	بَحْثِ الْمِيَاهِ
u'بَحْثٌ نَمَاءٌ':Added, #1: 1	بَحْثِ النَّدْبِ
u'بَحْثٌ نَهْيٌ':Added, #1: 1	بَحْثِ النَّمَاءِ
u'بَحْثٌ نَوَوِيٌّ':Added, #3: 3	بَحْثِ النَّهْيِ
u'بَحْثٌ نِيَّةٌ':Added, #1: 1	بَحْثَ النَّوَوِيِّ
u'بَحْثٌ هَزْلٌ':Added, #1: 1	بَحْثِ نِيَّةِ
u'بَحْثٌ وَاجِبٌ':Added, #3: 3	بَحْثِ الْهَزْلِ
u'بَحْثٌ وُقُوفٌ':Added, #1: 1	بَحْثِ الْوَاجِبِ
u'بَخِرَ فَمٌ':Subject, #1: 1	بَحْثِ الْوُقُوفِ
u'بَخَسَ قَوْمٌ':Subject, #1: 1	بَخِرَ الْفَمُ
u'بَخْسٌ كَيْلٌ':Added, #1: 1	بَخَسَ قَوْمٌ
u'بَخَسَ مساكين':Predicate, #1: 1	بَخْسِ الْكَيْلِ
u'بَخْسٌ نَحْوٌ':Added, #1: 1	بَخَسَ الْمَسَاكِينَ
u'بَخِلَ أَبٌ':Subject, #1: 1	بَخْسُ نَحْوِ
u'بُخْلٌ الْمَرْءُ':Added, #1: 1	بَخِلَ الْأَبُ
u'بَخِلَ نَاسٌ':Subject, #1: 1	بُخْلُ الْمَرْءِ
u'بَدَأَ اِبْنٌ':Subject, #1: 1	بَخِلَ النّاسُ
u'بَدَأَ أَجْنَبِيٌّ':Subject, #1: 1	بَدَأَ ابْنُ
u'بَدَا إِرْطَابٌ':Subject, #6: 6	بَدَأَ الْأَجْنَبِيُّ
u'بَدَأَ إِسْلامٌ':Subject, #3: 3	بَدَا الْإِرْطَابُ
u'بَدَا إِصْلاحٌ':Subject, #6: 6	بَدَأَ الْإِسْلَامُ
u'بَدَأَ إمَامٌ':Subject, #1: 1	بَدَا إصْلَاحُ
u'بَدَأَ إِنْسانٌ':Predicate, #4: 4	بَدَأَ الْإِمَامُ
u'بَدَأَ أَوَّلُ':Subject, #1: 1	بَدَأَ الْإِنْسَانَ
u'بَدَأَ بَائِعٌ':Subject, #1: 1	بَدَأَ أَوَّلُ
u'بَدَأَ بَدْرٌ':Subject, #2: 2	بَدَأَ الْبَائِعُ
u'بَدَا بَرٌّ':Subject, #1: 1	بَدَأَ بَدْرُ
u'بَدَأَ بَعْضٌ':Subject, #1: 1	بَدَا الْبَرُّ
u'بَدَا بَيَاضٌ':Subject, #1: 1	بَدَأَ بَعْضُ
u'بَدَا تَرْطِيبٌ':Subject, #2: 2	بَدَا بَيَاضُ
u'بَدَأَ ثَالِثٌ':Subject, #1: 1	بَدَا التَّرْطِيبُ
u'بَدَا ثَمَرٌ':Subject, #1: 1	بَدَأَ الثَّالِثُ
u'بَدَا جَازٌ':Predicate, #1: 1	بَدَا ثَمَرُهُ
u'بَدَأَ جَمَاعَةٌ':Subject, #2: 2	بَدَا جَازَ
u'بَدَأَ حاجِبٌ':Subject, #1: 1	بَدَأَ جَمَاعَةٌ
u'بَدَا حاجِبٌ':Subject, #1: 1	بَدَأَ حَاجِبُ
u'بَدَأَ حاكِمٌ':Subject, #5: 5	بَدَا حَاجِبُ
u'بَدَأَ حَلالٌ':Subject, #1: 1	بَدَأَ الْحَاكِمُ
u'بَدَأَ خلق':Predicate, #1: 1	بَدَأَ الْحَلَالُ
u'بَدَأَ خَلْقٌ':Predicate, #1: 1	بَدَأَ الْخَلْقَ
u'بَدَا خَلَلٌ':Subject, #1: 1	بَدَأَ الْخَلْقَ
u'بَدَا رَأْسٌ':Subject, #1: 1	بَدَا الْخَلَلُ
u'بَدَأَ رَسُولٌ':Subject, #8: 8	بَدَا رَأْسُهُ
u'بَدَأَ زَوْجٌ':Subject, #2: 2	بَدَأَ رَسُولُ
u'بَدَأَ شافِعِيّ':Subject, #11: 11	بَدَأَ الزَّوْجُ
u'بَدَا شِقٌّ':Subject, #1: 1	بَدَأَ الشَّافِعِيُّ
u'بَدَأَ شُهُودٌ':Subject, #1: 1	بَدَا شِقُّهُ
u'بَدَا شَيْءٌ':Subject, #2: 2	بَدَأَ الشُّهُودُ
u'بَدَأَ شَيْخٌ':Subject, #2: 2	بَدَا الشَّيْءُ
u'بَدَا صَلاَحٌ':Subject, #1: 1	بَدَأَ الشَّيْخُ
u'بَدَأَ صَلاَحٌ':Subject, #11: 11	بَدَا صَلَاحُ
u'بَدَا صَلاَحٌ':Subject, #1: 1	بَدَأَ صَلَاحُهُ
u'بَدَا صَلاَحٌ':Subject, #29: 29	بَدَا صَلَاحُهُ
u'بَدَا طَبَقٌ':Subject, #9: 9	بَدَا الصَّلَاحُ
u'بَدَأَ طَلْعٌ':Subject, #1: 1	بَدَا طَبَقُ
u'بَدَا طَمَعٌ':Subject, #1: 1	بَدَأَ الطَّلْعُ
u'بَدَأَ ظُهورٌ':Subject, #2: 2	بَدَا طَمَعٌ
u'بَدَأَ عَبْدٌ':Subject, #1: 1	بَدَأَ ظُهُورُ
u'بَدَا عتق':Subject, #4: 4	بَدَأَ الْعَبْدُ
u'بَدَا عِتْقٌ':Subject, #1: 1	بَدَا الْعِتْقُ
u'بَدَا عَظْمٌ':Subject, #1: 1	بَدَا الْعِتْقُ
u'بَدَا علم':Subject, #2: 2	بَدَا الْعَظْمُ
u'بَدَا عِلْمٌ':Subject, #1: 1	بَدَا عِلْمُ
u'بَدَأَ غُسْلٌ':Subject, #1: 1	بَدَا عِلْمُ
u'بَدَأَ فُضُولِيٌّ':Subject, #3: 3	بَدَأَ الْغُسْلُ
u'بَدَأَ فلان':Subject, #1: 1	بَدَأَ الْفُضُولِيُّ
u'بَدَأَ قَالٌ':Predicate, #1: 1	بَدَأَ الشَّافِعِيُّ
u'بَدَأَ كَافِرٌ':Subject, #1: 1	بَدَأَ قَالَ
u'بَدَأَ كِتَابٌ':Predicate, #1: 1	بَدَأَ الْكَافِرُ
u'بَدَأَ كِتَابٌ':Subject, #2: 2	بَدَأَ الْكِتَابَ
u'بَدَا كَرَمٌ':Subject, #3: 3	بَدَأَ الْكِتَابُ
u'بَدَأَ كُفَّارٌ':Subject, #1: 1	بَدَا كَرَمٌ
u'بَدَا كَوْكَبٌ':Subject, #1: 1	بَدَأَ الْكُفَّارُ
u'بَدَأَ مَاءٌ':Predicate, #1: 1	بَدَا كَوْكَبٌ
u'بَدَأَ مَأْمُورٌ':Subject, #1: 1	بَدَأَ الْمَاءَ
u'بَدَأَ مُحَلِّل':Subject, #1: 1	بَدَأَ الْمَأْمُورُ
u'بَدَأَ مُحَمَّدٌ':Subject, #1: 1	بَدَأَ الْمُحَلِّلُ
u'بَدَا مَسْتُورٌ':Subject, #3: 3	بَدَأَ مُحَمَّدٌ
u'بَدَأَ مُصَنِّفٌ':Subject, #1: 1	بَدَا الْمَسْتُورُ
u'بَدَا نَجْمٌ':Subject, #1: 1	بَدَأَ الْمُصَنِّفُ
u'بَدَا نخلة':Subject, #2: 2	بَدَا نَجْمٌ
u'بَدَا نَخْلَةٌ':Subject, #1: 1	بَدَا نَخْلَةٌ
u'بَدَا نَقْصٌ':Subject, #1: 1	بَدَا نَخْلَةٌ
u'بَدَأَ وَاقِفٌ':Subject, #1: 1	بَدَا نَقْصُهُ
u'بَدَا وَجْهٌ':Subject, #1: 1	بَدَأَ الْوَاقِفُ
u'بَدَأَ يَمِينٌ':Predicate, #1: 1	بَدَا وَجْهُ
u'بَدَرَ أَجْنَبِيٌّ':Subject, #1: 1	بَدَأَ اليَمِينَ
u'بَدْرٌ تمام':Added, #1: 1	بَدَرَ أَجْنَبِيٌّ
u'بَدْرٌ تَمامٌ':Added, #1: 1	بَدْرُ التَّمَامِ
u'بَدَرَ خَصْمٌ':Subject, #1: 1	بَدْرُ التَّمَامِ
u'بَدْرٌ دِينٌ':Added, #1: 1	بَدَرَ الْخَصْمُ
u'بَدْرٌ دَيْنٌ':Added, #19: 19	بَدْرُ الدِّينِ
u'بَدْرٌ دِينٌ':Added, #1: 1	بَدْرُ الدَّيْنِ
u'بَدْرٌ دِينٌ':Added, #2: 2	بَدْرَ الدِّينِ
u'بَدْرٌ طَبْعٌ':Added, #6: 6	بَدْرِ الدِّينِ
u'بَدَرَ فَهْمٌ':Subject, #1: 1	بَدْرُ طَبْعِهِ
u'بَدَلٌ أَبٌ':Added, #1: 1	بَدَرَ الْفَهْمُ
u'بَدَلٌ إبَاحَةٌ':Added, #1: 1	بَدَلَ الْأَبِ
u'بَدَلٌ إبْداءٌ':Added, #1: 1	بَدَلُ إبَاحَةٍ
u'بَدَلٌ إِبِلٌ':Added, #1: 1	بَدَلَ إبْدَاءِ
u'بدّل اِبْنٌ':Subject, #1: 1	بَدَلَ الْإِبِلِ
u'بَدَّلَ اِبْنٌ':Subject, #1: 1	بَدَّلَ ابْنُ
u'بَدَلٌ اِبْنٌ':Added, #1: 1	بَدَّلَ ابْنُ
u'بَدَلٌ اِبْنٌ':Added, #1: 1	بَدَلَ ابْنِ
u'بَدَلٌ أَبْوَابٌ':Added, #1: 1	بَدَلِ ابْنِ
u'بَدَلٌ إِتْلاَفٌ':Added, #1: 1	بَدَلَ أَبْوَابِ
u'بَدَلٌ إجَارَةٌ':Added, #1: 1	بَدَلُ الْإِتْلَافِ
u'بَدَلٌ إجَارَةٌ':Added, #1: 1	بَدَلَ إجَارَةٍ
u'بَدَلٌ إجَازَةٌ':Added, #2: 2	بَدَلُ إجَارَةٍ
u'بَدَلٌ آجُرٌّ':Added, #1: 1	بَدَلَ الْإِجَازَةِ
u'بَدَلٌ أُجْرَةٌ':Added, #1: 1	بَدَلَ الْآجُرِّ
u'بَدَلٌ إِحْرَامٌ':Added, #1: 1	بَدَلُ أُجْرَةِ
u'بَدَلَ أحكم':Predicate, #1: 1	بَدَلَ الْإِحْرَامِ
u'بَدَلٌ أَخٌ':Added, #1: 1	بَدَلَ أَحْكَمَ
u'بَدَلٌ أخْذٌ':Added, #2: 2	بَدَلُ الْأَخِ
u'بَدَلٌ أَخِيرٌ':Added, #1: 1	بَدَلَ الْأَخْذِ
u'بَدَلٌ أَخِيرٌ':Added, #1: 1	بَدَلَ الْأَخِيرِ
u'بَدَلٌ آدَمِيٌّ':Added, #2: 2	بَدَلَ الْأَخِيرَةِ
u'بَدَلٌ آدَمِيٌّ':Added, #1: 1	بَدَلُ آدَمِيٍّ
u'بَدَلٌ أَرْبَعَةٌ':Added, #2: 2	بَدَلُ الْآدَمِيِّ
u'بَدَلٌ إِزَارٌ':Added, #1: 1	بَدَلَ أَرْبَعَةِ
u'بَدَلٌ إِسْلامٌ':Added, #1: 1	بَدَلَ إزَارِهِ
u'بَدَلٌ اِشْتِمالٌ':Added, #1: 1	بَدَلُ الْإِسْلَامِ
u'بَدَلٌ أَشْجَارٌ':Added, #4: 4	بَدَلُ اشْتِمَالٍ
u'بَدَلٌ أَشْخَاصٌ':Added, #1: 1	بَدَلَ الْأَشْجَارِ
u'بَدَلٌ أصل':Added, #1: 1	بَدَلِ الْأَشْخَاصِ
u'بَدَلٌ أًصْلٌ':Added, #1: 1	بَدَلَ الْأَصْلِ
u'بَدَلٌ أَطْرافٌ':Added, #1: 1	بَدَلَ الْأَصْلِ
u'بَدَلٌ أَطْرافٌ':Added, #1: 1	بَدَلُ أَطْرَافِهِ
u'بَدَلٌ أَطْرَافٌ':Added, #1: 1	بَدَلِ أَطْرَافِهِ
u'بَدَلٌ أَطْرَافٌ':Added, #1: 1	بَدَلُ أَطْرَافِهِ
u'بَدَلٌ أَطْرافٌ':Added, #1: 1	بَدَلِ أَطْرَافِهِ
u'بَدَلٌ أَطْرَافٌ':Added, #1: 1	بَدَلَ الْأَطْرَافِ
u'بَدَلٌ أَطْرافٌ':Added, #1: 1	بَدَلَ الْأَطْرَافِ
u'بَدَلٌ أَطْرَافٌ':Added, #2: 2	بَدَلُ الْأَطْرَافِ
u'بَدَلٌ إِعْتاقٌ':Added, #2: 2	بَدَلُ الْأَطْرَافِ
u'بَدَلٌ إعْطَاءٌ':Added, #1: 1	بَدَلَ الْإِعْتَاقِ
u'بَدَلٌ إِفْرَادٌ':Added, #1: 1	بَدَلَ الْإِعْطَاءِ
u'بَدَلَ أكْحَل':Predicate, #1: 1	بَدَلَ الْإِفْرَادِ
u'بَدَلٌ آلةٌ':Added, #1: 1	بَدَلَ أَكْحَلَ
u'بَدَلٌ أُمٌّ':Added, #1: 1	بَدَلَ الْآلَةِ
u'بَدَلٌ أُمٌّ':Added, #1: 1	بَدَلِ الْأُمِّ
u'بَدَلٌ إمَامٌ':Added, #1: 1	بَدَلَ أُمِّهِ
u'بَدَلٌ أمَانٌ':Added, #1: 1	بَدَلَ الْإِمَامِ
u'بَدَلٌ أمَانَةٌ':Added, #1: 1	بَدَلَ الْأَمَانِ
u'بَدَلٌ أَميرٌ':Added, #1: 1	بَدَلَ الْأَمَانَةِ
u'بَدَلٌ إِناءٌ':Added, #1: 1	بَدَلَ الْأَمِيرِ
u'بَدَلٌ إِنْسانٌ':Added, #1: 1	بَدَلَ الْإِنَاءِ
u'بَدَلٌ أَنْقَاضٌ':Added, #1: 1	بَدَلِ الْإِنْسَانِ
u'بَدَلٌ إِنْكارٌ':Added, #1: 1	بَدَلَ أَنْقَاضِهِ
u'بَدَلَ أَوَّلُ':Subject, #1: 1	بَدَلَ إنْكَارِهِ
u'بَدَلٌ أَوَّلُ':Added, #1: 1	بَدَلَ الْأَوَّلُ
u'بَدَلٌ آيَةٌ':Added, #1: 1	بَدَلَ الْأَوَّلِ
u'بَدَلٌ إيمَانٌ':Added, #1: 1	بَدَلَ الْآيَةِ
u'بَدَلَ بَانٌ':Predicate, #1: 1	بَدَلَ إيمَانِهِ
u'بَدَلٌ بتات':Added, #1: 1	بَدَلَ بَانَ
u'بَدَلٌ بَتَاتٌ':Added, #1: 1	بَدَلُ الْبَتَاتِ
u'بَدَلٌ بَدَلٌ':Added, #1: 1	بَدَلُ الْبَتَاتِ
u'بَدَلٌ بِرْكَةٌ':Added, #1: 1	بَدَلُ الْبَدَلِ
u'بَدَلٌ بِضْعٌ':Added, #1: 1	بَدَلَ بِرْكَةٍ
u'بَدَلٌ بِضْعٌ':Added, #1: 1	بَدَلَ الْبِضْعِ
u'بدّل بَعْضٌ':Predicate, #1: 1	بَدَلُ الْبِضْعِ
u'بَدَّلَ بَعْضٌ':Predicate, #1: 1	بَدَّلَ الْبَعْضَ
u'بَدَلٌ بَعْضٌ':Added, #1: 1	بَدَّلَ الْبَعْضَ
u'بَدَلٌ بَعْضٌ':Added, #1: 1	بَدَلَ بَعْضٍ
u'بَدَلٌ بَعْضٌ':Added, #1: 1	بَدَلُ بَعْضِ
u'بَدَلٌ بَعْضٌ':Added, #1: 1	بَدَلِ بَعْضٍ
u'بَدَلٌ بَعْضٌ':Added, #3: 3	بَدَلَ الْبَعْضِ
u'بَدَلٌ بَعْضٌ':Added, #3: 3	بَدَلُ بَعْضٍ
u'بَدَلٌ بَعْضٌ':Added, #4: 4	بَدَلُ الْبَعْضِ
u'بَدَلٌ بَقَرٌ':Added, #4: 4	بَدَلِ الْبَعْضِ
u'بدّل بِنْتٌ':Predicate, #1: 1	بَدَلَ الْبَقَرِ
u'بَدَّلَ بِنْتٌ':Predicate, #2: 2	بَدَّلَ بِنْتَ
u'بَدَلَ بَيْنٌ':Predicate, #2: 2	بَدَّلَ بِنْتَ
u'بَدَلٌ بَيِّنَةٌ':Added, #1: 1	بَدَلَ بَيْنَ
u'بَدَلٌ تالِف':Added, #1: 1	بَدَلَ الْبَيِّنَةِ
u'بَدَلٌ تالِف':Added, #1: 1	بَدَلَ التَّالِفِ
u'بَدَلٌ تَتَابُعٌ':Added, #1: 1	بَدَلُ التَّالِفِ
u'بَدَلٌ تَحِيَّةٌ':Added, #1: 1	بَدَلُ تَتَابُعِهِ
u'بَدَلٌ تَسْبِيحٌ':Added, #1: 1	بَدَلَ التَّحِيَّةِ
u'بَدَلٌ تَعْلِيلٌ':Added, #1: 1	بَدَلَ التَّسْبِيحِ
u'بَدَلٌ تَكْبيرٌ':Added, #1: 1	بَدَلَ التَّعْلِيلِ
u'بَدَلٌ تَمَتُّعٌ':Added, #4: 4	بَدَلَ التَّكْبِيرِ
u'بَدَلٌ تَمْر':Added, #1: 1	بَدَلَ التَّمَتُّعِ
u'بَدَلٌ ثَالِثٌ':Added, #1: 1	بَدَلَ التَّمْرِ
u'بَدَلَ ثَامِنٌ':Predicate, #1: 1	بَدَلَ الثَّالِثَةِ
u'بَدَلٌ ثَمِلٌ':Added, #1: 1	بَدَلَ الثَّامِنَ
u'بَدَلٌ ثَمَنٌ':Added, #1: 1	بَدَلَ الثَّمِلِ
u'بَدَلٌ ثَمَنٌ':Added, #1: 1	بَدَلَ الثَّمَنِ
u'بَدَلٌ ثَمَنٌ':Added, #2: 2	بَدَلُ الثَّمَنِ
u'بَدَلٌ ثِيابٌ':Added, #2: 2	بَدَلِ الثَّمَنِ
u'بَدَلٌ جَابِرٌ':Added, #1: 1	بَدَلُ ثِيَابِ
u'بَدَلٌ جَبْهَةٌ':Added, #1: 1	بَدَلَ جَابِرٍ
u'بَدَلٌ جَذَع':Added, #1: 1	بَدَلُ الْجَبْهَةِ
u'بَدَلٌ جَذَعَة':Added, #2: 2	بَدَلَ الْجَذَعَةِ
u'بَدَلٌ جُزْءٌ':Added, #2: 2	بَدَلَ الْجَذَعَةِ
u'بَدَلٌ جُزْءٌ':Added, #1: 1	بَدَلِ الْجُزْءِ
u'بَدَلٌ جُزْءٌ':Added, #1: 1	بَدَلَ جُزْءٍ
u'بَدَلٌ جُزْءٌ':Added, #3: 3	بَدَلُ الْجُزْءِ
u'بَدَلٌ جَزَاءٌ':Added, #8: 8	بَدَلُ جُزْءٍ
u'بَدَلٌ جِزْيَةٌ':Added, #1: 1	بَدَلِ الْجَزَاءِ
u'بَدَلٌ جلسة':Added, #1: 1	بَدَلُ الْجِزْيَةِ
u'بَدَلٌ جِلْسَةٌ':Added, #1: 1	بَدَلَ الْجِلْسَةِ
u'بَدَلٌ جَمَاعَةٌ':Added, #1: 1	بَدَلَ الْجِلْسَةِ
u'بَدَلٌ جمع':Added, #1: 1	بَدَلَ الْجَمَاعَةِ
u'بَدَلٌ جَمْعٌ':Added, #1: 1	بَدَلَ الْجَمْعِ
u'بَدَلٌ جِنَايَةٌ':Added, #1: 1	بَدَلَ الْجَمْعِ
u'بَدَلٌ جِنَايَةٌ':Added, #1: 1	بَدَلِ الْجِنَايَاتِ
u'بَدَلٌ جِنَايَةٌ':Added, #1: 1	بَدَلَ الْجِنَايَةِ
u'بَدَلٌ جَنِينٌ':Added, #1: 1	بَدَلِ الْجِنَايَةِ
u'بَدَلٌ جَنِينٌ':Added, #1: 1	بَدَلِ الْجَنِينِ
u'بَدَلٌ جَنِينٌ':Added, #1: 1	بَدَلَ جَنِينِ
u'بَدَلٌ جَنِينٌ':Added, #1: 1	بَدَلُ جَنِينِ
u'بَدَلٌ جياد':Added, #4: 4	بَدَلُ الْجَنِينِ
u'بَدَلٌ جِيَادٌ':Added, #1: 1	بَدَلَ الْجِيَادِ
u'بَدَلٌ حاكِمٌ':Added, #1: 1	بَدَلَ الْجِيَادِ
u'بَدَلٌ حالٌ':Added, #1: 1	بَدَلُ الْحَاكِمِ
u'بَدَلٌ حِجَامَةٌ':Added, #1: 1	بَدَلَ الْحَالِ
u'بَدَلٌ حَجَرٌ':Added, #2: 2	بَدَلَ الْحِجَامَةِ
u'بَدَلٌ حَدٌّ':Added, #1: 1	بَدَلَ الْحَجَرِ
u'بَدَلٌ حَديثٌ':Added, #1: 1	بَدَلَ الْحَدِّ
u'بَدَلٌ حَرْفٌ':Added, #1: 1	بَدَلَ الْحَدِيثِ
u'بَدَلٌ حَسَنٌ':Added, #1: 1	بَدَلَ الْحَرْفِ
u'بَدَلٌ حَسَنَةٌ':Added, #1: 1	بَدَلَ الْحَسَنَةِ
u'بَدَلٌ حَطّ':Added, #1: 1	بَدَلَ الْحَسَنَةِ
u'بَدَلٌ حَقٌّ':Added, #1: 1	بَدَلَ الْحَطِّ
u'بَدَلٌ حَقٌّ':Added, #3: 3	بَدَلَ حَقِّهِ
u'بَدَلٌ حَقٌّ':Added, #4: 4	بَدَلِ حَقِّ
u'بدّل حِقَاقٌ':Predicate, #6: 6	بَدَلُ حَقِّهِ
u'بَدَّلَ حِقَاقٌ':Predicate, #1: 1	بَدَّلَ الْحِقَاقَ
u'بدّل حُكْمٌ':Predicate, #1: 1	بَدَّلَ الْحِقَاقَ
u'بَدَّلَ حُكْمٌ':Predicate, #1: 1	بَدَّلَ حُكْمَ
u'بَدَلَ حَمْدٌ':Subject, #1: 1	بَدَّلَ حُكْمَ
u'بدّل حِنَّاءٌ':Predicate, #1: 1	بَدَلَ الْحَمْدُ
u'بَدَّلَ حِنَّاءٌ':Predicate, #1: 1	بَدَّلَ الْحِنَّاءَ
u'بَدَلٌ خَالِدٌ':Added, #1: 1	بَدَّلَ الْحِنَّاءَ
u'بَدَلٌ خُرُوجٌ':Added, #1: 1	بَدَلَ خَالِدٍ
u'بَدَلٌ خُسُوفٌ':Added, #1: 1	بَدَلَ خُرُوجِ
u'بَدَلٌ خُفٌّ':Added, #1: 1	بَدَلُ الْخُسُوفِ
u'بَدَلٌ خُفٌّ':Added, #1: 1	بَدَلَ الْخُفِّ
u'بَدَلٌ خُلْعٌ':Added, #1: 1	بَدَلُ الْخُفِّ
u'بَدَلٌ خَلْعٌ':Added, #16: 16	بَدَلُ الْخُلْعِ
u'بَدَلٌ خُلْعٌ':Added, #1: 1	بَدَلَ الْخَلْعِ
u'بَدَلٌ خُلْعٌ':Added, #1: 1	بَدَلِ خُلْعٍ
u'بَدَلٌ خُلْعٌ':Added, #2: 2	بَدَلَ خُلْعٍ
u'بَدَلٌ خُلْعٌ':Added, #34: 34	بَدَلِ الْخُلْعِ
u'بَدَلٌ خِمَارٌ':Added, #36: 36	بَدَلَ الْخُلْعِ
u'بَدَلٌ خَمِيسٌ':Added, #1: 1	بَدَلَ الْخِمَارِ
u'بَدَلٌ دَارٌ':Added, #1: 1	بَدَلُ خَمِيسٍ
u'بَدَلٌ دَارٌ':Added, #1: 1	بَدَلُ الدَّارِ
u'بَدَلٌ دُبٌّ':Added, #2: 2	بَدَلِ الدَّارِ
u'بَدَلٌ دُبُرٌ':Added, #1: 1	بَدَلَ الدُّبِّ
u'بَدَلٌ دَرَاهِمُ':Added, #1: 1	بَدَلَ الدُّبُرِ
u'بَدَلٌ دَرَاهِمُ':Added, #1: 1	بَدَلِ الدَّرَاهِمِ
u'بَدَلٌ دِرْهَمٌ':Added, #3: 3	بَدَلَ الدَّرَاهِمِ
u'بَدَلٌ دِرْهَم':Added, #1: 1	بَدَلَ الدِّرْهَمِ
u'بَدَلٌ دَمٌ':Added, #1: 1	بَدَلَ الدِّرْهَمِ
u'بَدَلٌ دَمٌ':Added, #1: 1	بَدَلَ دَمِ
u'بَدَلٌ دَمٌ':Added, #1: 1	بَدَلُ دَمِ
u'بَدَلٌ دَمٌ':Added, #2: 2	بَدَلُ دَمِهِ
u'بَدَلٌ دَمٌ':Added, #4: 4	بَدَلُ الدَّمِ
u'بَدَلٌ دَمٌ':Added, #4: 4	بَدَلِ الدَّمِ
u'بَدَلٌ دَهْرٌ':Added, #5: 5	بَدَلَ الدَّمِ
u'بَدَلٌ دَيْنٌ':Added, #1: 1	بَدَلَ الدَّهْرِ
u'بَدَلٌ دَيْنٌ':Added, #1: 1	بَدَلَ الدَّيْنِ
u'بَدَلٌ دِينارٌ':Added, #1: 1	بَدَلِ الدَّيْنِ
u'بَدَلٌ دِينارٌ':Added, #1: 1	بَدَلُ الدِّينَارِ
u'بَدَلٌ ذكر':Added, #2: 2	بَدَلُ دِينَارٍ
u'بَدَلٌ ذَكَرٌ':Added, #1: 1	بَدَلَ الذَّكَرِ
u'بَدَلٌ ذَمٌّ':Added, #1: 1	بَدَلَ الذَّكَرِ
u'بَدَلٌ رجعة':Added, #1: 1	بَدَلَ الذَّمِّ
u'بَدَلٌ رَجْعَةٌ':Added, #1: 1	بَدَلَ الرَّجْعَةِ
u'بَدَلٌ رَجُلٌ':Added, #1: 1	بَدَلَ الرَّجْعَةِ
u'بَدَلٌ رِجْلٌ':Added, #1: 1	بَدَلِ الرَّجُلِ
u'بَدَلٌ رَضيعٌ':Added, #2: 2	بَدَلُ الرِّجْلِ
u'بَدَلٌ رَقَبَةٌ':Added, #1: 1	بَدَلَ الرَّضِيعِ
u'بَدَلٌ رَقَبَةٌ':Added, #2: 2	بَدَلِ الرَّقَبَةِ
u'بَدَلٌ رَقَبَةٌ':Added, #2: 2	بَدَلُ رَقَبَتِهِ
u'بَدَلٌ رَقَبَةٌ':Added, #7: 7	بَدَلُ الرَّقَبَةِ
u'بَدَلٌ رُقْعَةٌ':Added, #9: 9	بَدَلِ رَقَبَتِهِ
u'بَدَلٌ ركعة':Added, #1: 1	بَدَلَ الرُّقْعَةِ
u'بَدَلٌ رَكْعَةٌ':Added, #1: 1	بَدَلَ الرَّكْعَةِ
u'بَدَلٌ رَهْنٌ':Added, #1: 1	بَدَلَ الرَّكْعَةِ
u'بَدَلٌ رَهْنٌ':Added, #1: 1	بَدَلَ الرَّهْنِ
u'بَدَلٌ رَهْنٌ':Added, #2: 2	بَدَلِ الرَّهْنِ
u'بَدَلَ رُؤْيَةٌ':Subject, #7: 7	بَدَلُ الرَّهْنِ
u'بَدَلٌ زائِدٌ':Added, #1: 1	بَدَلَ رُؤْيَةُ
u'بَدَلٌ زَبيبٌ':Added, #1: 1	بَدَلُ الزَّائِدِ
u'بَدَلٌ زِيادَةٌ':Added, #1: 1	بَدَلَ الزَّبِيبِ
u'بَدَلٌ زَيْدٌ':Added, #1: 1	بَدَلِ زِيَادَةِ
u'بَدَلٌ سادس':Added, #1: 1	بَدَلَ زَيْدِ
u'بَدَلٌ سَادِسٌ':Added, #1: 1	بَدَلَ السَّادِسَةِ
u'بَدَلٌ سُجُودٌ':Added, #1: 1	بَدَلَ السَّادِسَةِ
u'بدّل سَرْجٌ':Predicate, #1: 1	بَدَلُ السُّجُودِ
u'بَدَّلَ سَرْجٌ':Predicate, #1: 1	بَدَّلَ السَّرْجَ
u'بَدَلٌ سَعِيدٌ':Added, #1: 1	بَدَّلَ السَّرْجَ
u'بَدَلٌ سَفِينَةٌ':Added, #1: 1	بَدَلَ سَعِيدِ
u'بَدَلٌ سلام':Added, #1: 1	بَدَلِ سَفِينَتِهِ
u'بَدَلٌ سَلاَمٌ':Added, #1: 1	بَدَلَ السَّلَامِ
u'بَدَلٌ سِلْعَةٌ':Added, #1: 1	بَدَلَ السَّلَامِ
u'بَدَلٌ سَلَمٌ':Added, #1: 1	بَدَلُ سِلْعَةِ
u'بَدَلٌ سَلَمٌ':Added, #1: 1	بَدَلُ السَّلَمِ
u'بَدَلٌ سُهَيْلٌ':Added, #2: 2	بَدَلِ السَّلَمِ
u'بَدَلٌ شَاةٌ':Added, #1: 1	بَدَلَ سُهَيْلٍ
u'بَدَلٌ شَاةٌ':Added, #1: 1	بَدَلَ شَاةٍ
u'بَدَلٌ شَاهِدٌ':Added, #2: 2	بَدَلُ شَاةِ
u'بَدَلٌ شِبْلٌ':Added, #1: 1	بَدَلُ الشَّاهِدِ
u'بَدَلٌ شَدَّةٌ':Added, #1: 1	بَدَلُ شِبْلٍ
u'بَدَلٌ شَرْطٌ':Added, #1: 1	بَدَلَ الشَّدَّةِ
u'بَدَلٌ شَرْطٌ':Added, #1: 1	بَدَلَ شَرْطِ
u'بَدَلٌ شَعِيرٌ':Added, #1: 1	بَدَلِ شَرْطٍ
u'بَدَلٌ شَقٌّ':Added, #1: 1	بَدَلَ شَعِيرٍ
u'بَدَلٌ شَهَادَةٌ':Added, #1: 1	بَدَلَ شَقٍّ
u'بَدَلٌ شَيْءٌ':Added, #1: 1	بَدَلَ شَهَادَةِ
u'بَدَلٌ شَيْءٌ':Added, #1: 1	بَدَلَ الشَّيْءِ
u'بَدَلٌ شَيْءٌ':Added, #1: 1	بَدَلُ الشَّيْءِ
u'بَدَلٌ شَيْءٌ':Added, #1: 1	بَدَلَ شَيْءٍ
u'بَدَلٌ صِبْغٌ':Added, #1: 1	بَدَلِ شَيْءٍ
u'بَدَلٌ صَبِيٌّ':Added, #1: 1	بَدَلِ الصِّبْغِ
u'بَدَلٌ صِحَّةٌ':Added, #1: 1	بَدَلَ الصَّبِيِّ
u'بَدَلٌ صَحِيحٌ':Added, #1: 1	بَدَلَ الصِّحَّةِ
u'بَدَلٌ صدقة':Added, #2: 2	بَدَلِ الصَّحِيحَةِ
u'بَدَلٌ صَدَقَةٌ':Added, #1: 1	بَدَلَ الصَّدَقَةِ
u'بَدَلٌ صدقة':Added, #1: 1	بَدَلَ الصَّدَقَةِ
u'بَدَلٌ صَدَقَةٌ':Added, #1: 1	بَدَلَ صَدَقَةٍ
u'بَدَلٌ صَرْفٌ':Added, #1: 1	بَدَلَ صَدَقَةٍ
u'بَدَلٌ صَرْف':Added, #12: 12	بَدَلَ الصَّرْفِ
u'بَدَلٌ صَرْفٌ':Added, #12: 12	بَدَلَ الصَّرْفِ
u'بَدَلٌ صَرْف':Added, #22: 22	بَدَلِ الصَّرْفِ
u'بَدَلٌ صَرْفٌ':Added, #22: 22	بَدَلِ الصَّرْفِ
u'بَدَلٌ صَرْف':Added, #5: 5	بَدَلُ الصَّرْفِ
u'بَدَلٌ صِفَةٌ':Added, #5: 5	بَدَلُ الصَّرْفِ
u'بَدَلٌ صَلاَةٌ':Added, #1: 1	بَدَلُ صِفَةِ
u'بَدَلٌ صلح':Added, #1: 1	بَدَلَ الصَّلَاةِ
u'بَدَلٌ صُلْحٌ':Added, #26: 26	بَدَلُ الصُّلْحِ
u'بَدَلٌ صلح':Added, #26: 26	بَدَلُ الصُّلْحِ
u'بَدَلٌ صُلْحٌ':Added, #33: 33	بَدَلَ الصُّلْحِ
u'بَدَلٌ صُلْحٌ':Added, #33: 33	بَدَلَ الصُّلْحِ
u'بَدَلٌ صلح':Added, #3: 3	بَدَلَ صُلْحٍ
u'بَدَلٌ صُلْحٌ':Added, #52: 52	بَدَلِ الصُّلْحِ
u'بَدَلٌ صَوْمٌ':Added, #52: 52	بَدَلِ الصُّلْحِ
u'بَدَلَ صَيْدٌ':Subject, #2: 2	بَدَلُ الصَّوْمِ
u'بَدَلٌ ضحك':Added, #1: 1	بَدَلَ الصَّيْدُ
u'بَدَلٌ ضَحِكٌ':Added, #1: 1	بَدَلُ الضَّحِكِ
u'بَدَلٌ ضَمَائِرُ':Added, #1: 1	بَدَلُ الضَّحِكِ
u'بَدَلٌ ضَوْءٌ':Added, #1: 1	بَدَلَ ضَمَائِرِ
u'بَدَلٌ طرف':Added, #1: 1	بَدَلِ ضَوْءِ
u'بَدَلٌ طَرَفٌ':Added, #2: 2	بَدَلِ الطَّرَفِ
u'بَدَلٌ طرف':Added, #2: 2	بَدَلِ الطَّرَفِ
u'بَدَلٌ طَرَفٌ':Added, #3: 3	بَدَلَ الطَّرَفِ
u'بدّل طعام':Predicate, #3: 3	بَدَلَ الطَّرَفِ
u'بَدَّلَ طعام':Predicate, #1: 1	بَدَّلَ الطَّعَامَ
u'بدّل طَعَامٌ':Predicate, #1: 1	بَدَّلَ الطَّعَامَ
u'بَدَّلَ طَعَامٌ':Predicate, #1: 1	بَدَّلَ الطَّعَامَ
u'بَدَلٌ طعام':Added, #1: 1	بَدَّلَ الطَّعَامَ
u'بَدَلٌ طعام':Added, #1: 1	بَدَلَ الطَّعَامِ
u'بَدَلٌ طَعَامٌ':Added, #1: 1	بَدَلُ الطَّعَامِ
u'بَدَلٌ طَعَامٌ':Added, #1: 1	بَدَلَ الطَّعَامِ
u'بَدَلٌ طَعَامٌ':Added, #1: 1	بَدَلُ الطَّعَامِ
u'بَدَلٌ طَعْنٌ':Added, #1: 1	بَدَلُ الطَّعَامَيْنِ
u'بَدَلٌ طَلاَقٌ':Added, #1: 1	بَدَلَ الطَّعْنِ
u'بَدَلٌ طَلاَقٌ':Added, #1: 1	بَدَلَ الطَّلَاقِ
u'بَدَلٌ طَهَارَةٌ':Added, #1: 1	بَدَلِ الطَّلَاقِ
u'بَدَلٌ طِينٌ':Added, #1: 1	بَدَلَ طَهَارَةِ
u'بَدَلٌ ظاهِرٌ':Added, #1: 1	بَدَلَ الطِّينِ
u'بَدَلٌ ظاهِرٌ':Added, #1: 1	بَدَلَ الظَّاهِرِ
u'بَدَلَ عَائِشٌ':Predicate, #1: 1	بَدَلِ الظَّاهِرِ
u'بَدَلٌ عَبْدٌ':Added, #1: 1	بَدَلَ عَائِشَةَ
u'بَدَلٌ عَبْدٌ':Added, #1: 1	بَدَلَ عَبْدِ
u'بَدَلٌ عَبْدٌ':Added, #2: 2	بَدَلُ الْعَبْدِ
u'بَدَلٌ عَبْدٌ':Added, #2: 2	بَدَلُ عَبْدِهِ
u'بَدَلٌ عَبْدٌ':Added, #3: 3	بَدَلَ الْعَبْدِ
u'بَدَلٌ عَبْدٌ':Added, #3: 3	بَدَلُ عَبْدٍ
u'بَدَلَ عتاق':Subject, #5: 5	بَدَلِ الْعَبْدِ
u'بَدَلٌ عتاق':Added, #1: 1	بَدَلَ الْعَتَاقُ
u'بَدَلٌ عتق':Added, #1: 1	بَدَلَ الْعَتَاقِ
u'بَدَلٌ عِتْقٌ':Added, #1: 1	بَدَلَ عِتْقِهِ
u'بَدَلٌ عتق':Added, #1: 1	بَدَلَ عِتْقِهِ
u'بَدَلٌ عتق':Added, #2: 2	بَدَلَ الْعِتْقِ
u'بَدَلٌ عِتْقٌ':Added, #2: 2	بَدَلُ الْعِتْقِ
u'بَدَلٌ عِتْقٌ':Added, #2: 2	بَدَلَ الْعِتْقِ
u'بَدَلٌ عتق':Added, #2: 2	بَدَلُ الْعِتْقِ
u'بَدَلٌ عِتْقٌ':Added, #9: 9	بَدَلِ الْعِتْقِ
u'بَدَلٌ عَدَدٌ':Added, #9: 9	بَدَلِ الْعِتْقِ
u'بَدَلٌ عُشْرٌ':Added, #1: 1	بَدَلَ عَدَدِ
u'بَدَلٌ عصبة':Added, #1: 1	بَدَلَ الْعُشْرِ
u'بَدَلٌ عَصَبَةٌ':Added, #1: 1	بَدَلُ الْعَصَبَةِ
u'بَدَلٌ عِصْمَةٌ':Added, #1: 1	بَدَلُ الْعَصَبَةِ
u'بَدَلٌ عُضْوٌ':Added, #1: 1	بَدَلِ الْعِصْمَةِ
u'بَدَلٌ عُضْوٌ':Added, #1: 1	بَدَلُ الْعُضْوِ
u'بَدَلٌ عَطَاءٌ':Added, #2: 2	بَدَلَ الْعُضْوِ
u'بَدَلٌ عَطَاءٌ':Added, #1: 1	بَدَلَ الْعَطَاءِ
u'بَدَلَ عقبة':Predicate, #2: 2	بَدَلَ عَطَاءٍ
u'بَدَلَ عُقْبَةٌ':Predicate, #7: 7	بَدَلَ عُقْبَةَ
u'بَدَلٌ عَقْدٌ':Added, #7: 7	بَدَلَ عُقْبَةَ
u'بَدَلٌ عَقْدٌ':Added, #1: 1	بَدَلِ عَقْدٍ
u'بَدَلَ عَقْرَبٌ':Subject, #2: 2	بَدَلِ الْعَقْدِ
u'بَدَلٌ عَكْسٌ':Added, #1: 1	بَدَلَ الْعَقْرَبُ
u'بَدَلٌ عَلَفٌ':Added, #1: 1	بَدَلَ عَكْسٍ
u'بَدَلٌ علم':Added, #3: 3	بَدَلُ الْعَلَفِ
u'بَدَلٌ عِلْمٌ':Added, #1: 1	بَدَلَ الْعِلْمِ
u'بَدَلٌ عَمَلٌ':Added, #1: 1	بَدَلَ الْعِلْمِ
u'بَدَلٌ عَمَلٌ':Added, #1: 1	بَدَلَ عَمَلِهِ
u'بَدَلٌ عَمَلٌ':Added, #2: 2	بَدَلَ الْعَمَلِ
u'بَدَلٌ عِنَبٌ':Added, #2: 2	بَدَلُ عَمَلِهِ
u'بَدَلَ عند':Predicate, #1: 1	بَدَلَ الْعِنَبِ
u'بَدَلٌ عَنْزٌ':Added, #1: 1	بَدَلَ عِنْدَ
u'بدّل عِوَضٌ':Predicate, #1: 1	بَدَلُ الْعَنْزِ
u'بَدَّلَ عِوَضٌ':Predicate, #1: 1	بَدَّلَ الْعِوَضَ
u'بَدَلٌ عَيْنٌ':Added, #1: 1	بَدَّلَ الْعِوَضَ
u'بَدَلٌ عَيْن':Added, #1: 1	بَدَلَ الْعَيْنَيْنِ
u'بَدَلٌ عين':Added, #1: 1	بَدَلَ الْعَيْنَيْنِ
u'بَدَلٌ عَيْنٌ':Added, #2: 2	بَدَلِ الْعَيْنِ
u'بَدَلٌ عَيْن':Added, #2: 2	بَدَلِ الْعَيْنِ
u'بَدَلٌ عَيْنٌ':Added, #2: 2	بَدَلِ الْعَيْنِ
u'بَدَلٌ عَيْن':Added, #2: 2	بَدَلُ عَيْنٍ
u'بَدَلٌ عين':Added, #2: 2	بَدَلُ عَيْنٍ
u'بَدَلٌ عَيْنٌ':Added, #3: 3	بَدَلَ الْعَيْنِ
u'بَدَلٌ عَيْن':Added, #3: 3	بَدَلَ الْعَيْنِ
u'بَدَلٌ عَيْنٌ':Added, #3: 3	بَدَلَ الْعَيْنِ
u'بَدَلٌ عَيْن':Added, #4: 4	بَدَلَ عَيْنٍ
u'بَدَلٌ عين':Added, #4: 4	بَدَلَ عَيْنٍ
u'بَدَلٌ عَيْنٌ':Added, #7: 7	بَدَلُ الْعَيْنِ
u'بَدَلٌ عَيْن':Added, #7: 7	بَدَلُ الْعَيْنِ
u'بَدَلٌ غُرَابٌ':Added, #7: 7	بَدَلُ الْعَيْنِ
u'بَدَلٌ غِرَاسٌ':Added, #1: 1	بَدَلُ الْغُرَابِ
u'بَدَلٌ غُرَّةٌ':Added, #1: 1	بَدَلَ الْغِرَاسِ
u'بَدَلٌ غُسْلٌ':Added, #1: 1	بَدَلَ الْغُرَّةِ
u'بَدَلٌ غَسْلٌ':Added, #1: 1	بَدَلِ الْغُسْلِ
u'بَدَلٌ غُسْلٌ':Added, #1: 1	بَدَلَ غَسْلِ
u'بَدَلٌ غُسْلٌ':Added, #2: 2	بَدَلَ الْغُسْلِ
u'بَدَلٌ غَصْبٌ':Added, #2: 2	بَدَلُ الْغُسْلِ
u'بَدَلٌ غضب':Added, #1: 1	بَدَلُ غَصْبٍ
u'بَدَلٌ غَضَبٌ':Added, #1: 1	بَدَلَ الْغَضَبِ
u'بَدَلٌ غَلَّةٌ':Added, #1: 1	بَدَلَ الْغَضَبِ
u'بَدَلٌ غَلَطٌ':Added, #1: 1	بَدَلِ الْغَلَّةِ
u'بَدَلٌ غير':Added, #1: 1	بَدَلِ الْغَلَطِ
u'بَدَلٌ غَيْرٌ':Added, #1: 1	بَدَلِ غَيْرِ
u'بَدَلٌ فاء':Added, #1: 1	بَدَلِ غَيْرِ
u'بَدَلٌ فَاتِحٌ':Added, #3: 3	بَدَلَ الْفَاءِ
u'بَدَلٌ فَاتِحَةٌ':Added, #1: 1	بَدَلَ الْفَاتِحَةِ
u'بَدَلٌ فَاسِدٌ':Added, #1: 1	بَدَلَ الْفَاتِحَةِ
u'بَدَلٌ فَخْذٌ':Added, #1: 1	بَدَلَ الْفَاسِدِ
u'بَدَلٌ فرار':Added, #1: 1	بَدَلَ الْفَخْذِ
u'بَدَلٌ فِرَارٌ':Added, #1: 1	بَدَلَ الْفِرَارِ
u'بَدَلٌ فَرْضٌ':Added, #1: 1	بَدَلَ الْفِرَارِ
u'بَدَلَ فساد':Subject, #1: 1	بَدَلُ فَرْضِ
u'بَدَلَ فَسَادٌ':Subject, #1: 1	بَدَلَ الْفَسَادُ
u'بَدَلَ فلان':Predicate, #1: 1	بَدَلَ الْفَسَادُ
u'بَدَلَ فلان':Predicate, #1: 1	بَدَلَ شَبَابَةَ
u'بَدَلٌ فلان':Added, #2: 2	بَدَلَ حَفْصَةَ
u'بَدَلٌ قَافٌ':Added, #1: 1	بَدَلَ بِلَالٍ
u'بَدَلٌ قَبْرٌ':Added, #1: 1	بَدَلُ الْقَافِ
u'بَدَلٌ قتل':Added, #1: 1	بَدَلَ الْقَبْرِ
u'بَدَلٌ قَتْلٌ':Added, #1: 1	بَدَلَ الْقَتْلِ
u'بَدَلَ قَدْرٌ':Predicate, #1: 1	بَدَلَ الْقَتْلِ
u'بَدَلٌ قَدْرٌ':Added, #1: 1	بَدَلَ قَدْرَ
u'بَدَلٌ قُرْء':Added, #2: 2	بَدَلَ قَدْرِ
u'بَدَلٌ قِرَانٌ':Added, #1: 1	بَدَلُ قُرْءٍ
u'بَدَلٌ قُرَشِيٌّ':Added, #1: 1	بَدَلَ الْقِرَانِ
u'بَدَلٌ قَرْضٌ':Added, #1: 1	بَدَلَ الْقُرَشِيِّ
u'بَدَلٌ قَرْضٌ':Added, #1: 1	بَدَلَ الْقَرْضِ
u'بَدَلٌ قَرْضٌ':Added, #1: 1	بَدَلَ قَرْضٍ
u'بَدَلٌ قَرْضٌ':Added, #1: 1	بَدَلُ قَرْضٍ
u'بَدَلٌ قَرْضٌ':Added, #2: 2	بَدَلُ الْقَرْضِ
u'بَدَلٌ قَرْضٌ':Added, #2: 2	بَدَلِ قَرْضٍ
u'بَدَلٌ قصاص':Added, #3: 3	بَدَلِ الْقَرْضِ
u'بَدَلٌ قِصَاصٌ':Added, #1: 1	بَدَلُ الْقِصَاصِ
u'بَدَلٌ قُعُودٌ':Added, #1: 1	بَدَلُ الْقِصَاصِ
u'بَدَلٌ قُلُوبٌ':Added, #1: 1	بَدَلَ الْقُعُودِ
u'بَدَلٌ قُنُوتٌ':Added, #1: 1	بَدَلُ الْقُلُوبِ
u'بَدَلٌ قَوْسٌ':Added, #1: 1	بَدَلِ الْقُنُوتِ
u'بدّل قول':Predicate, #1: 1	بَدَلُ قَوْسِهِ
u'بَدَّلَ قول':Predicate, #1: 1	بَدَّلَ قَوْلَ
u'بدّل قَوْلٌ':Predicate, #1: 1	بَدَّلَ قَوْلَ
u'بَدَّلَ قَوْلٌ':Predicate, #1: 1	بَدَّلَ قَوْلَ
u'بَدَلٌ قول':Added, #1: 1	بَدَّلَ قَوْلَ
u'بَدَلٌ قول':Added, #1: 1	بَدَلَ قَوْلِ
u'بَدَلٌ قَوْلٌ':Added, #1: 1	بَدَلُ قَوْلِ
u'بَدَلٌ قَوْلٌ':Added, #1: 1	بَدَلَ قَوْلِ
u'بَدَلٌ قول':Added, #1: 1	بَدَلُ قَوْلِ
u'بَدَلٌ قَوْلٌ':Added, #43: 43	بَدَلَ قَوْلِهِ
u'بَدَلٌ قول':Added, #43: 43	بَدَلَ قَوْلِهِ
u'بَدَلٌ قَوْلٌ':Added, #5: 5	بَدَلُ قَوْلِهِ
u'بَدَلٌ قَوْمٌ':Added, #5: 5	بَدَلُ قَوْلِهِ
u'بَدَلٌ قيام':Added, #1: 1	بَدَلَ قَوْمِهِ
u'بَدَلٌ قِيَامٌ':Added, #2: 2	بَدَلَ الْقِيَامِ
u'بدّل كبار':Predicate, #2: 2	بَدَلَ الْقِيَامِ
u'بَدَّلَ كبار':Predicate, #1: 1	بَدَّلَ الْكِبَارَ
u'بَدَلٌ كِتَابٌ':Added, #1: 1	بَدَّلَ الْكِبَارَ
u'بَدَلٌ كِتَابٌ':Added, #1: 1	بَدَلَ الْكِتَابِ
u'بَدَلَ كِتَابَةٌ':Predicate, #1: 1	بَدَلَ كِتَابِ
u'بَدَلٌ كِتَابَةٌ':Added, #2: 2	بَدَلَ الْكِتَابَةَ
u'بَدَلٌ كِتَابَةٌ':Added, #120: 120	بَدَلَ الْكِتَابَةِ
u'بَدَلٌ كِتَابَةٌ':Added, #1: 1	بَدَلِ كِتَابَةِ
u'بَدَلٌ كِتَابَةٌ':Added, #230: 230	بَدَلِ الْكِتَابَةِ
u'بَدَلٌ كِتَابَةٌ':Added, #2: 2	بَدَلَ كِتَابَتِهِ
u'بَدَلٌ كُرَاعٌ':Added, #44: 44	بَدَلُ الْكِتَابَةِ
u'بَدَلَ كَرِهٌ':Predicate, #1: 1	بَدَلَ الْكُرَاعِ
u'بَدَلٌ كَسِيرٌ':Added, #1: 1	بَدَلَ كَرِهَ
u'بَدَلٌ كَعْبٌ':Added, #1: 1	بَدَلُ الْكَسِيرِ
u'بَدَلٌ كَعْبٌ':Added, #1: 1	بَدَلَ الْكَعْبَيْنِ
u'بَدَلٌ كَفَّارٌ':Added, #1: 1	بَدَلَ كَعْبٍ
u'بَدَلٌ كَفَّارَةٌ':Added, #1: 1	بَدَلُ الْكَفَّارَةِ
u'بَدَلٌ كَفِيلٌ':Added, #1: 1	بَدَلُ الْكَفَّارَةِ
u'بَدَلٌ كَلِمَةٌ':Added, #1: 1	بَدَلِ الْكَفِيلِ
u'بَدَلٌ لاَمٌ':Added, #1: 1	بَدَلَ الْكَلِمَةِ
u'بَدَلٌ لبس':Added, #3: 3	بَدَلَ اللَّامِ
u'بَدَلٌ لُبْسٌ':Added, #1: 1	بَدَلُ اللُّبْسِ
u'بَدَلٌ لبن':Added, #1: 1	بَدَلُ اللُّبْسِ
u'بَدَلٌ لَبَنٌ':Added, #1: 1	بَدَلِ لَبَنِ
u'بَدَلٌ لبن':Added, #1: 1	بَدَلِ لَبَنِ
u'بَدَلٌ لَبَنٌ':Added, #2: 2	بَدَلُ اللَّبَنِ
u'بَدَلٌ لبن':Added, #2: 2	بَدَلُ اللَّبَنِ
u'بَدَلٌ لَبَنٌ':Added, #3: 3	بَدَلَ اللَّبَنِ
u'بَدَلٌ لِحَافٌ':Added, #3: 3	بَدَلَ اللَّبَنِ
u'بَدَلٌ لَحْظ':Added, #1: 1	بَدَلُ اللِّحَافِ
u'بَدَلٌ لَحْظَة':Added, #1: 1	بَدَلَ اللَّحْظَةِ
u'بَدَلٌ لَحْمٌ':Added, #1: 1	بَدَلَ اللَّحْظَةِ
u'بَدَلٌ لَفْظٌ':Added, #1: 1	بَدَلَ اللَّحْمِ
u'بَدَلٌ لَفْظٌ':Added, #1: 1	بَدَلَ لَفْظِ
u'بَدَلٌ لَفْظَةٌ':Added, #1: 1	بَدَلُ لَفْظٍ
u'بَدَلٌ لَمْسٌ':Added, #1: 1	بَدَلُ اللَّفْظَةِ
u'بَدَلَ لَيْلٌ':Predicate, #1: 1	بَدَلَ اللَّمْسِ
u'بَدَلٌ مَاءٌ':Added, #2: 2	بَدَلَ لَيْلَةً
u'بَدَلٌ مَاءٌ':Added, #2: 2	بَدَلَ الْمَاءِ
u'بدّل مَالٌ':Predicate, #2: 2	بَدَلِ الْمَاءِ
u'بَدَّلَ مَالٌ':Predicate, #1: 1	بَدَّلَ مَالَ
u'بَدَلٌ مَالٌ':Added, #1: 1	بَدَّلَ مَالَ
u'بَدَلٌ مَالٌ':Added, #1: 1	بَدَلِ الْمَالِ
u'بَدَلٌ مَالٌ':Added, #1: 1	بَدَلَ مَالِ
u'بَدَلٌ مَالٌ':Added, #1: 1	بَدَلِ مَالِ
u'بَدَلٌ مَالٌ':Added, #1: 1	بَدَلَ مَالِهِ
u'بَدَلٌ مَالٌ':Added, #2: 2	بَدَلَ الْمَالِ
u'بَدَلٌ مَالٌ':Added, #2: 2	بَدَلِ مَالٍ
u'بَدَلٌ مَالٌ':Added, #2: 2	بَدَلُ مَالِهِ
u'بَدَلٌ مَالٌ':Added, #3: 3	بَدَلُ الْمَالِ
u'بَدَلٌ مَالٌ':Added, #4: 4	بَدَلُ مَالٍ
u'بَدَلٌ مَالِكٌ':Added, #7: 7	بَدَلَ مَالٍ
u'بَدَلٌ مَالِيٌّ':Added, #2: 2	بَدَلَ مَالِكٍ
u'بَدَلٌ مَالِيٌّ':Added, #10: 10	بَدَلُ الْمَالِيَّةِ
u'بَدَلٌ مَائِعٌ':Added, #1: 1	بَدَلُ مَالِيَّةِ
u'بَدَلٌ مُبَاحٌ':Added, #1: 1	بَدَلَ مَائِعٍ
u'بَدَلَ مُبْتاع':Predicate, #1: 1	بَدَلَ الْمُبَاحِ
u'بَدَلٌ مَبِيتٌ':Added, #1: 1	بَدَلَ الْمُبْتَاعَ
u'بَدَلٌ مَبِيعٌ':Added, #2: 2	بَدَلَ الْمَبِيتِ
u'بَدَلٌ مَبِيعٌ':Added, #1: 1	بَدَلَ الْمَبِيعِ
u'بَدَلٌ مُتْعَةٌ':Added, #1: 1	بَدَلُ الْمَبِيعِ
u'بَدَلٌ مثل':Added, #1: 1	بَدَلُ الْمُتْعَةِ
u'بَدَلٌ مِثْلٌ':Added, #1: 1	بَدَلُ الْمِثْلِ
u'بَدَلٌ مَجْنِيٌّ':Added, #1: 1	بَدَلُ الْمِثْلِ
u'بَدَلٌ مَحَلٌّ':Added, #1: 1	بَدَلَ الْمَجْنِيِّ
u'بَدَلٌ مَحَلٌّ':Added, #1: 1	بَدَلِ الْمَحَلِّ
u'بَدَلٌ مَحَلٌّ':Added, #4: 4	بَدَلَ الْمَحَلِّ
u'بَدَلٌ مُحَمَّدٌ':Added, #5: 5	بَدَلُ الْمَحَلِّ
u'بَدَلٌ مَرْدُودٌ':Added, #4: 4	بَدَلَ مُحَمَّدِ
u'بَدَلٌ مَرْهُونٌ':Added, #1: 1	بَدَلُ الْمَرْدُودِ
u'بَدَلٌ مَرْهُونٌ':Added, #1: 1	بَدَلُ الْمَرْهُونِ
u'بَدَلٌ مُرُورٌ':Added, #1: 1	بَدَلِ الْمَرْهُونِ
u'بَدَلٌ مَسْأَلَةٌ':Added, #1: 1	بَدَلَ الْمُرُورِ
u'بَدَلٌ مُسْتَحَقٌّ':Added, #1: 1	بَدَلَ مَسْأَلَةِ
u'بَدَلٌ مُسْتَحَقٌّ':Added, #1: 1	بَدَلَ الْمُسْتَحَقِّ
u'بَدَلٌ مُسْتَحِقٌّ':Added, #1: 1	بَدَلُ الْمُسْتَحَقِّ
u'بَدَلٌ مَسْحٌ':Added, #1: 1	بَدَلُ الْمُسْتَحِقِّ
u'بَدَلٌ مَسْحٌ':Added, #1: 1	بَدَلَ مَسْحٍ
u'بَدَلٌ مَسْحٌ':Added, #2: 2	بَدَلَ مَسْحِهِ
u'بَدَلٌ مِسْكٌ':Added, #3: 3	بَدَلَ الْمَسْحِ
u'بَدَلٌ مُسْلِمٌ':Added, #1: 1	بَدَلَ الْمِسْكِ
u'بَدَلٌ مُشْتَرَكٌ':Added, #1: 1	بَدَلَ الْمُسْلِمِ
u'بَدَلٌ مَشْرِقٌ':Added, #1: 1	بَدَلَ مُشْتَرَكَةٍ
u'بَدَلٌ مَشْرُوعِيَّةٌ':Added, #1: 1	بَدَلَ الْمَشْرِقِ
u'بَدَلٌ مِشْمِشٌ':Added, #1: 1	بَدَلُ الْمَشْرُوعِيَّةِ
u'بَدَلٌ مُضَافٌ':Added, #1: 1	بَدَلَ الْمِشْمِشِ
u'بَدَلٌ مَضْمُونٌ':Added, #1: 1	بَدَلٍ مُضَافٍ
u'بَدَلٌ مُطَابِقٌ':Added, #1: 1	بَدَلِ الْمَضْمُونِ
u'بَدَلٌ مَعَاقِلُ':Added, #1: 1	بَدَلَ مُطَابِقٍ
u'بَدَلٌ مَعْدُومٌ':Added, #1: 1	بَدَلَ الْمَعَاقِلِ
u'بَدَلٌ مَعْقُودٌ':Added, #1: 1	بَدَلَ الْمَعْدُومِ
u'بَدَلٌ مُعَلَّمٌ':Added, #1: 1	بَدَلِ الْمَعْقُودِ
u'بَدَلٌ مَعْلُومٌ':Added, #1: 1	بَدَلَ مُعَلَّمٍ
u'بَدَلٌ مُعَيَّنٌ':Added, #4: 4	بَدَلٍ مَعْلُومٍ
u'بَدَلٌ مَغْصُوب':Added, #1: 1	بَدَلٍ مُعَيَّنٍ
u'بَدَلٌ مَغْصُوب':Added, #2: 2	بَدَلِ الْمَغْصُوبِ
u'بَدَلٌ مَفْرِقٌ':Added, #4: 4	بَدَلَ الْمَغْصُوبِ
u'بَدَلٌ مَفْقُودٌ':Added, #1: 1	بَدَلَ مَفْرِقِ
u'بَدَلٌ مَفْقُودٌ':Added, #1: 1	بَدَلَ الْمَفْقُودِ
u'بَدَلٌ مَقْبَرَةٌ':Added, #1: 1	بَدَلِ الْمَفْقُودِ
u'بَدَلٌ مِلْكٌ':Added, #2: 2	بَدَلَ الْمَقْبَرَةِ
u'بَدَلٌ مِلْكٌ':Added, #10: 10	بَدَلُ مِلْكِهِ
u'بَدَلٌ مِلْكٌ':Added, #1: 1	بَدَلَ الْمِلْكِ
u'بَدَلٌ مِلْكٌ':Added, #2: 2	بَدَلِ مِلْكِهِ
u'بَدَلٌ مِلْكٌ':Added, #4: 4	بَدَلُ مِلْكِ
u'بَدَلٌ مَنَافِعُ':Added, #5: 5	بَدَلَ مِلْكِهِ
u'بَدَلٌ مَنَافِعُ':Added, #2: 2	بَدَلَ الْمَنَافِعِ
u'بَدَلٌ مَنَافِعُ':Added, #2: 2	بَدَلُ الْمَنَافِعِ
u'بَدَلٌ مُنَافِقٌ':Added, #2: 2	بَدَلِ مَنَافِعِ
u'بَدَلٌ مَنْذُور':Added, #1: 1	بَدَلُ الْمُنَافِقِ
u'بَدَلٌ مَنْفَعَةٌ':Added, #1: 1	بَدَلِ الْمَنْذُورَةِ
u'بَدَلٌ مَنْفَعَةٌ':Added, #17: 17	بَدَلُ الْمَنْفَعَةِ
u'بَدَلٌ مَنْفَعَةٌ':Added, #1: 1	بَدَلِ الْمَنْفَعَةِ
u'بَدَلٌ مَنْفَعَةٌ':Added, #1: 1	بَدَلَ مَنْفَعَةٍ
u'بَدَلٌ مَنْفَعَةٌ':Added, #1: 1	بَدَلُ مَنْفَعَةٍ
u'بَدَلٌ مَنْفَعَةٌ':Added, #2: 2	بَدَلُ مَنْفَعَةِ
u'بَدَلٌ مَهْرٌ':Added, #3: 3	بَدَلَ الْمَنْفَعَةِ
u'بَدَلٌ مُؤَجَّلٌ':Added, #1: 1	بَدَلُ الْمَهْرِ
u'بَدَلٌ مُوَحَّدٌ':Added, #1: 1	بَدَلٍ مُؤَجَّلٍ
u'بَدَلٌ مَوْقُوفٌ':Added, #1: 1	بَدَلَ الْمُوَحَّدَةِ
u'بَدَلٌ مَوْقُوفٌ':Added, #1: 1	بَدَلَ الْمَوْقُوفِ
u'بَدَلٌ مِيمٌ':Added, #1: 1	بَدَلِ الْمَوْقُوفِ
u'بَدَلٌ ناسِي':Added, #1: 1	بَدَلَ الْمِيمِ
u'بَدَلٌ نصرة':Added, #1: 1	بَدَلَ النَّاسِيَةِ
u'بَدَلٌ نُصْرَةٌ':Added, #1: 1	بَدَلُ النُّصْرَةِ
u'بَدَلٌ نِصْفٌ':Added, #1: 1	بَدَلُ النُّصْرَةِ
u'بَدَلٌ نِصْفٌ':Added, #1: 1	بَدَلُ النِّصْفِ
u'بَدَلٌ نِصْفٌ':Added, #1: 1	بَدَلُ نِصْفِ
u'بَدَلٌ نِصْفٌ':Added, #2: 2	بَدَلَ نِصْفِ
u'بَدَلٌ نَصْلٌ':Added, #5: 5	بَدَلَ النِّصْفِ
u'بَدَلٌ نَصِيبٌ':Added, #1: 1	بَدَلَ النَّصْلِ
u'بَدَلٌ نَصِيبٌ':Added, #3: 3	بَدَلَ نَصِيبِهِ
u'بَدَلٌ نَفْخ':Added, #3: 3	بَدَلِ نَصِيبِهِ
u'بَدَلٌ نَفْسٌ':Added, #1: 1	بَدَلَ النَّفْخِ
u'بَدَلٌ نَفْسٌ':Added, #12: 12	بَدَلُ نَفْسِهِ
u'بَدَلٌ نَفْسٌ':Added, #15: 15	بَدَلِ النَّفْسِ
u'بَدَلٌ نَفْسٌ':Added, #1: 1	بَدَلَ نَفْسٍ
u'بَدَلٌ نَفْسٌ':Added, #20: 20	بَدَلُ النَّفْسِ
u'بَدَلٌ نَفْسٌ':Added, #2: 2	بَدَلَ النَّفْسِ
u'بَدَلٌ نَفْسٌ':Added, #2: 2	بَدَلَ نَفْسِ
u'بَدَلٌ نَفْسٌ':Added, #3: 3	بَدَلُ نَفْسِ
u'بَدَلٌ نَفْسٌ':Added, #3: 3	بَدَلِ نَفْسِ
u'بَدَلٌ نَفْسٌ':Added, #3: 3	بَدَلَ نَفْسِهِ
u'بَدَلٌ نَفَقَةٌ':Added, #3: 3	بَدَلِ نَفْسِهِ
u'بَدَلٌ نُفُوسٌ':Added, #2: 2	بَدَلَ النَّفَقَةِ
u'بَدَلٌ نقاص':Added, #1: 1	بَدَلِ النُّفُوسِ
u'بَدَلٌ نَقْصٌ':Added, #1: 1	بَدَلِ النِّقَاصِ
u'بَدَلٌ نُقْصَانٌ':Added, #2: 2	بَدَلِ النَّقْصِ
u'بَدَلٌ نُقْصَانٌ':Added, #1: 1	بَدَلُ النُّقْصَانِ
u'بَدَلٌ نَمِرٌ':Added, #1: 1	بَدَلِ النُّقْصَانِ
u'بَدَلٌ نَمِيمٌ':Added, #1: 1	بَدَلُ نَمِرَةٍ
u'بَدَلٌ هَدَفٌ':Added, #1: 1	بَدَلَ النَّمِيمَةِ
u'بَدَلَ هِلاَلٌ':Subject, #1: 1	بَدَلَ الْهَدَفِ
u'بَدَلٌ همزة':Added, #1: 1	بَدَلَ هِلاَلُ
u'بَدَلٌ هَمْزَةٌ':Added, #1: 1	بَدَلَ الْهَمْزَةِ
u'بَدَلٌ وَاجِبٌ':Added, #1: 1	بَدَلَ الْهَمْزَةِ
u'بَدَلٌ وَاجِبٌ':Added, #1: 1	بَدَلُ وَاجِبٍ
u'بَدَلٌ واحد':Added, #3: 3	بَدَلُ الْوَاجِبِ
u'بَدَلٌ وَاحِدٌ':Added, #1: 1	بَدَل الْوَاحِدِ
u'بَدَلٌ واحد':Added, #1: 1	بَدَل الْوَاحِدِ
u'بَدَلٌ وَاحِدٌ':Added, #1: 1	بَدَلٍ وَاحِدٍ
u'بدّل وَجَارٌ':Predicate, #1: 1	بَدَلٍ وَاحِدٍ
u'بَدَّلَ وَجَارٌ':Predicate, #1: 1	بَدَّلَ وَجَارَ
u'بَدَلٌ وَزْنٌ':Added, #1: 1	بَدَّلَ وَجَارَ
u'بَدَلٌ ولد':Added, #1: 1	بَدَلَ الْوَزْنِ
u'بَدَلٌ وَلَدٌ':Added, #1: 1	بَدَلُ الْوَلَدِ
u'بَدَلٌ وَلَدٌ':Added, #1: 1	بَدَلُ الْوَلَدِ
u'بَدَلٌ ولد':Added, #1: 1	بَدَلِ الْوَلَدَيْنِ
u'بَدَلٌ وَلَدٌ':Added, #1: 1	بَدَلُ وَلَدِهِ
u'بَدَلٌ ولد':Added, #1: 1	بَدَلُ وَلَدِهِ
u'بَدَلٌ ولد':Added, #2: 2	بَدَلَ الْوَلَدِ
u'بَدَلٌ وَلَدٌ':Added, #2: 2	بَدَلِ الْوَلَدِ
u'بَدَلٌ وَلَدٌ':Added, #2: 2	بَدَلَ الْوَلَدِ
u'بَدَلٌ وَلِيٌّ':Added, #2: 2	بَدَلِ الْوَلَدِ
u'بدّل يَدٌ':Predicate, #1: 1	بَدَلَ وَلِيِّهِ
u'بَدَّلَ يَدٌ':Predicate, #1: 1	بَدَّلَ الْيَدَ
u'بَدَلٌ يَدٌ':Added, #1: 1	بَدَّلَ الْيَدَ
u'بَدَلٌ يَسِيرٌ':Added, #1: 1	بَدَلُ الْيَدِ
u'بَدَلَ يَعْقُوبٌ':Predicate, #1: 1	بَدَلٍ يَسِيرٍ
u'بَدَلٌ يَوْمٌ':Added, #1: 1	بَدَلَ يَعْقُوبَ
u'بَدَلٌ يَوْمٌ':Added, #1: 1	بَدَلَ الْيَوْمَيْنِ
u'بَدَلٌ يَوْمٌ':Added, #1: 1	بَدَلَ يَوْمِ
u'بَدُنَ رَجُلٌ':Subject, #1: 1	بَدَلُ يَوْمٍ
u'بَذَرَ بَذْرٌ':Predicate, #1: 1	بَدُنَ الرَّجُلُ
u'بَذَرَ مُزَارِعٌ':Subject, #1: 1	بَذَرَ الْبَذْرَ
u'بَذَلَ اِبْنٌ':Subject, #1: 1	بَذَرَ الْمُزَارِعُ
u'بَذْلٌ أُجْرَةٌ':Added, #1: 1	بَذَلَ ابْنُ
u'بَذْلٌ أُجْرَةٌ':Added, #1: 1	بَذْلَ الْأُجْرَةِ
u'بَذْلٌ أُجْرَةٌ':Added, #2: 2	بَذْلِ أُجْرَةِ
u'بَذْلٌ أُجْرَةٌ':Added, #2: 2	بَذْلُ الْأُجْرَةِ
u'بَذْلٌ أَجْنَبِيٌّ':Added, #2: 2	بَذْلِ الْأُجْرَةِ
u'بَذْلٌ أَجِيرٌ':Added, #1: 1	بَذْلِ الْأَجْنَبِيِّ
u'بَذْلٌ أصل':Added, #1: 1	بَذْلِ الْأَجِيرِ
u'بَذْلٌ أًصْلٌ':Added, #1: 1	بَذْلِ الْأَصْلِ
u'بَذْلٌ إِعانَةٌ':Added, #1: 1	بَذْلِ الْأَصْلِ
u'بَذْلٌ آلةٌ':Added, #1: 1	بَذْلُ إعَانَةِ
u'بَذَلَ ألف':Predicate, #1: 1	بَذْلِ آلَةِ
u'بَذَلَ ألْفٌ':Predicate, #2: 2	بَذَلَ الْأَلْفَ
u'بَذَلَ أَلْفٌ':Predicate, #2: 2	بَذَلَ الْأَلْفَ
u'بَذَلَ الْمَرْءُ':Subject, #2: 2	بَذَلَ الْأَلْفَ
u'بَذْلٌ أمَانٌ':Added, #1: 1	بَذَلَ الْمَرْءُ
u'بَذَلَ أُهْبَةٌ':Predicate, #1: 1	بَذْلِ الْأَمَانِ
u'بَذْلٌ أُهْبَةٌ':Added, #1: 1	بَذَلَ الْأُهْبَةَ
u'بَذْلٌ أهْوَنُ':Added, #1: 1	بَذْلُ الْأُهْبَةِ
u'بَذَلَ أَوَّلُ':Predicate, #1: 1	بَذْلَ أَهْوَنِ
u'بَذَلَ بَائِعٌ':Subject, #1: 1	بَذَلَ الْأَوَّلَ
u'بَذْلٌ بَائِعٌ':Added, #1: 1	بَذَلَ الْبَائِعُ
u'بَذْلٌ بِنَاءٌ':Added, #1: 1	بَذْلِ الْبَائِعِ
u'بَذَلَ تَسْلِيمٌ':Predicate, #1: 1	بَذْلُ الْبِنَاءِ
u'بَذْلٌ تَسْلِيمٌ':Added, #4: 4	بَذَلَ تَسْلِيمَ
u'بَذْلٌ تَسْلِيمٌ':Added, #1: 1	بَذْلِ التَّسْلِيمِ
u'بَذْلٌ ثَمَنٌ':Added, #1: 1	بَذْلِ تَسْلِيمٍ
u'بَذْلٌ ثَمَنٌ':Added, #1: 1	بَذْلِ الثَّمَنِ
u'بَذْلٌ ثَمَنٌ':Added, #1: 1	بَذْلُ ثَمَنِ
u'بَذْلٌ جَاهٌ':Added, #1: 1	بَذْلِ ثَمَنِ
u'بَذَلَ جِزْيَةٌ':Predicate, #2: 2	بَذْلُ الْجَاهِ
u'بَذْلٌ جِزْيَةٌ':Added, #6: 6	بَذَلَ الْجِزْيَةَ
u'بَذْلٌ جِزْيَةٌ':Added, #1: 1	بَذْلَ الْجِزْيَةِ
u'بَذْلٌ جِزْيَةٌ':Added, #1: 1	بَذْلُ الْجِزْيَةِ
u'بَذْلٌ جِزْيَةٌ':Added, #1: 1	بَذْلِ جِزْيَةٍ
u'بَذْلٌ جَهْدٌ':Added, #2: 2	بَذْلِ الْجِزْيَةِ
u'بَذْلٌ جُهْدٌ':Added, #1: 1	بَذْلَ الْجَهْدِ
u'بَذْلٌ جُهْدٌ':Added, #1: 1	بَذْلُ الْجُهْدِ
u'بَذْلٌ جَهْدٌ':Added, #1: 1	بَذْلِ الْجُهْدِ
u'بَذْلٌ حالٌ':Added, #2: 2	بَذْلُ الْجَهْدِ
u'بَذَلَ خَطٌّ':Predicate, #1: 1	بَذْلِ الْحَالِ
u'بَذَلَ خَطٌّ':Predicate, #1: 1	بَذَلَ خَطَّ
u'بَذْلٌ دِينٌ':Added, #2: 2	بَذَلَ الْخَطَّ
u'بَذْلٌ دِينارٌ':Added, #2: 2	بَذْلُ الدِّينِ
u'بَذَلَ راغِب':Subject, #1: 1	بَذْلِ الدِّينَارِ
u'بَذَلَ رَبُّ':Subject, #1: 1	بَذَلَ رَاغِبٌ
u'بَذْلٌ روحٌ':Added, #1: 1	بَذَلَ رَبُّ
u'بَذْلٌ زائِدٌ':Added, #1: 1	بَذْلِ الرُّوحِ
u'بَذْلٌ زائِدٌ':Added, #1: 1	بَذْلَ الزَّائِدِ
u'بَذَلَ زَوْجٌ':Subject, #1: 1	بَذْلُ الزَّائِدِ
u'بَذْلٌ زِيادَةٌ':Added, #1: 1	بَذَلَ الزَّوْجُ
u'بَذْلٌ زِيادَةٌ':Added, #1: 1	بَذْلُ الزِّيَادَةِ
u'بَذْلٌ سلام':Added, #2: 2	بَذْلِ الزِّيَادَةِ
u'بَذْلٌ سَلاَمٌ':Added, #1: 1	بَذْلَ السَّلَامِ
u'بَذَلَ سَيِّدٌ':Subject, #1: 1	بَذْلَ السَّلَامِ
u'بَذْلٌ شَطْرٌ':Added, #1: 1	بَذَلَ السَّيِّدُ
u'بَذَلَ صَاحِبٌ':Subject, #1: 1	بَذْلِ شَطْرِ
u'بَذَلَ صداق':Predicate, #2: 2	بَذَلَ صَاحِبُ
u'بَذَلَ صَدَاقٌ':Predicate, #1: 1	بَذَلَ صَدَاقَ
u'بَذْلٌ صداق':Added, #1: 1	بَذَلَ صَدَاقَ
u'بَذْلٌ صَدَاقٌ':Added, #1: 1	بَذْلِ صَدَاقٍ
u'بَذْلٌ صَدَقَةٌ':Added, #1: 1	بَذْلِ صَدَاقٍ
u'بَذْلٌ ضِيَافَةٌ':Added, #1: 1	بَذْلِ الصَّدَقَاتِ
u'بَذْلٌ طَاعَةٌ':Added, #1: 1	بَذْلُ الضِّيَافَةِ
u'بَذْلٌ طَاعَةٌ':Added, #1: 1	بَذْلَ الطَّاعَةِ
u'بَذْلٌ طَاقَةٌ':Added, #2: 2	بَذْلِ الطَّاعَةِ
u'بَذْلٌ طَاقَةٌ':Added, #1: 1	بَذْلِ الطَّاقَةِ
u'بَذْلٌ طرف':Added, #5: 5	بَذْلُ الطَّاقَةِ
u'بَذْلٌ طَرَفٌ':Added, #1: 1	بَذْلِ طَرَفِهِ
u'بَذَلَ طعام':Predicate, #1: 1	بَذْلِ طَرَفِهِ
u'بَذَلَ طَعَامٌ':Predicate, #1: 1	بَذَلَ الطَّعَامَ
u'بَذْلٌ عَطِيَّة':Added, #1: 1	بَذَلَ الطَّعَامَ
u'بَذْلٌ علم':Added, #1: 1	بَذْلِ الْعَطِيّاتِ
u'بَذْلٌ عِلْمٌ':Added, #1: 1	بَذْلِ الْعِلْمِ
u'بَذَلَ عِوَضٌ':Predicate, #1: 1	بَذْلِ الْعِلْمِ
u'بَذْلٌ عِوَضٌ':Added, #3: 3	بَذَلَ الْعِوَضَ
u'بَذْلٌ عِوَضٌ':Added, #1: 1	بَذْلِ الْعِوَضِ
u'بَذْلٌ عِوَضٌ':Added, #1: 1	بَذْلُ عِوَضٍ
u'بَذْلٌ عِوَضٌ':Added, #1: 1	بَذْلِ عِوَضِ
u'بَذْلٌ عِوَضٌ':Added, #2: 2	بَذْلَ الْعِوَضِ
u'بَذْلٌ عين':Added, #7: 7	بَذْلُ الْعِوَضِ
u'بَذْلٌ عين':Added, #1: 1	بَذْلَ الْعَيْنِ
u'بَذْلٌ عَيْنٌ':Added, #1: 1	بَذْلُ الْعَيْنِ
u'بَذْلٌ عَيْنٌ':Added, #1: 1	بَذْلَ الْعَيْنِ
u'بَذْلٌ عَيْن':Added, #1: 1	بَذْلُ الْعَيْنِ
u'بَذْلٌ عَيْن':Added, #1: 1	بَذْلَ الْعَيْنِ
u'بَذَلَ غَاصِبٌ':Subject, #1: 1	بَذْلُ الْعَيْنِ
u'بَذَلَ غرماء':Subject, #1: 1	بَذَلَ الْغَاصِبُ
u'بَذْلٌ فَاضِلٌ':Added, #1: 1	بَذَلَ الْغُرَمَاءُ
u'بَذْلٌ فَاضِلٌ':Added, #2: 2	بَذْلُ فَاضِلِ
u'بَذْلٌ فَاضِلٌ':Added, #3: 3	بَذْلُ فَاضِلِهِ
u'بَذْلٌ فَضْلٌ':Added, #5: 5	بَذْلُ الْفَاضِلِ
u'بَذْلٌ فَضْلٌ':Added, #1: 1	بَذْلُ فَضْلِ
u'بَذْلٌ فَضْلٌ':Added, #3: 3	بَذْلُ الْفَضْلِ
u'بَذَلَ فلان':Subject, #3: 3	بَذْلِ فَضْلِ
u'بَذْلٌ فلان':Added, #1: 1	بَذَلَ رَاغِبٌ
u'بَذَلَ قَاتِلٌ':Subject, #1: 1	بَذْلِ الْعَطِيّاتِ
u'بَذْلٌ قَسْمٌ':Added, #1: 1	بَذَلَ الْقَاتِلُ
u'بَذَلَ قِيمَةٌ':Predicate, #1: 1	بَذْلُ قَسْمٍ
u'بَذْلٌ قِيمَةٌ':Added, #1: 1	بَذَلَ الْقِيمَةَ
u'بَذْلٌ قِيمَةٌ':Added, #1: 1	بَذْلُ الْقِيمَةِ
u'بَذْلٌ قِيمَةٌ':Added, #1: 1	بَذْلِ قِيمَتِهِ
u'بَذْلٌ كَفَنٌ':Added, #3: 3	بَذْلِ الْقِيمَةِ
u'بَذَلَ مَاءٌ':Predicate, #1: 1	بَذْلُ الْكَفَنِ
u'بَذْلٌ مَاءٌ':Added, #1: 1	بَذَلَ الْمَاءَ
u'بَذْلٌ مَاءٌ':Added, #1: 1	بَذْلِ الْمَاءِ
u'بَذْلٌ مَاعُونٌ':Added, #2: 2	بَذْلُ الْمَاءِ
u'بَذَلَ مَالٌ':Predicate, #3: 3	بَذْلِ الْمَاعُونِ
u'بَذْلٌ مَالٌ':Added, #5: 5	بَذَلَ الْمَالَ
u'بَذْلٌ مَالٌ':Added, #11: 11	بَذْلِ مَالٍ
u'بَذْلٌ مَالٌ':Added, #14: 14	بَذْلُ الْمَالِ
u'بَذْلٌ مَالٌ':Added, #1: 1	بَذْلَ الْمَالِ
u'بَذْلٌ مَالٌ':Added, #6: 6	بَذْلُ مَالٍ
u'بَذَلَ مَالِكٌ':Subject, #8: 8	بَذْلِ الْمَالِ
u'بَذَلَ مَالِكٌ':Subject, #1: 1	بَذَلَ الْمَالِكُ
u'بَذَلَ مَالِكٌ':Subject, #1: 1	بَذَلَ مَالِكُ
u'بَذْلٌ مَجْهُودٌ':Added, #1: 1	بَذَلَ مَالِكُهُ
u'بَذْلٌ مَجْهُودٌ':Added, #1: 1	بَذْلَ الْمَجْهُودِ
u'بَذْلٌ مَجْهُودٌ':Added, #2: 2	بَذْلِ الْمَجْهُودِ
u'بَذْلٌ مَعْرُوفٌ':Added, #7: 7	بَذْلُ الْمَجْهُودِ
u'بَذْلٌ مَعْرُوفٌ':Added, #1: 1	بَذْلُ الْمَعْرُوفِ
u'بَذَلَ مُقْتَرِضٌ':Subject, #1: 1	بَذْلِ الْمَعْرُوفِ
u'بَذْلٌ مُقْتَرِضٌ':Added, #1: 1	بَذَلَ الْمُقْتَرِضُ
u'بَذْلٌ مِلْكٌ':Added, #1: 1	بَذْلِ الْمُقْتَرِضِ
u'بَذْلٌ مَنَافِعُ':Added, #1: 1	بَذْلَ مِلْكِهِ
u'بَذْلٌ مَنَافِعُ':Added, #1: 1	بَذْلِ مَنَافِعِ
u'بَذَلَ مَنْفَعَةٌ':Predicate, #2: 2	بَذْلُ الْمَنَافِعِ
u'بَذْلٌ مَوْجُودٌ':Added, #1: 1	بَذَلَ مَنْفَعَةَ
u'بَذْلٌ نَصِيحٌ':Added, #2: 2	بَذْلُ الْمَوْجُودِ
u'بَذْلٌ نَصِيحٌ':Added, #1: 1	بَذْلَ النَّصِيحَةِ
u'بَذْلٌ نَصِيحَةٌ':Added, #1: 1	بَذْلِ النَّصِيحَةِ
u'بَذْلٌ نَصِيحَةٌ':Added, #1: 1	بَذْلَ النَّصِيحَةِ
u'بَذْلٌ نَفْسٌ':Added, #1: 1	بَذْلِ النَّصِيحَةِ
u'بَذْلٌ نُفُوسٌ':Added, #1: 1	بَذْلُ نَفْسِهِ
u'بَذْلٌ نُفُوسٌ':Added, #1: 1	بَذْلُ النُّفُوسِ
u'بَذْلٌ هِمَّةٌ':Added, #2: 2	بَذْلِ النُّفُوسِ
u'بَذَلَ وَاجِبٌ':Predicate, #1: 1	بَذْلِ هِمَّتِهِ
u'بَذَلَ وُسْعٌ':Predicate, #2: 2	بَذَلَ الْوَاجِبَ
u'بَذْلٌ وُسْعٌ':Added, #1: 1	بَذَلَ الْوُسْعَ
u'بَذْلٌ وُسْعٌ':Added, #1: 1	بَذْلِ وُسْعِهِ
u'بَذْلٌ وُسْعٌ':Added, #2: 2	بَذْلُ وُسْعٍ
u'بَذْلٌ وُسْعٌ':Added, #2: 2	بَذْلُ وُسْعِهِ
u'بَذَلَ ولد':Subject, #4: 4	بَذْلُ الْوُسْعِ
u'بَذَلَ وَلَدٌ':Subject, #1: 1	بَذَلَ وَلَدُهُ
u'بَذْلٌ ولد':Added, #1: 1	بَذَلَ وَلَدُهُ
u'بَذْلٌ وَلَدٌ':Added, #2: 2	بَذْلَ الْوَلَدِ
u'بَذْلٌ يسار':Added, #2: 2	بَذْلَ الْوَلَدِ
u'بَذْلٌ يَسَارٌ':Added, #1: 1	بَذْلِ الْيَسَارِ
u'بَذْلٌ يَسِيرٌ':Added, #1: 1	بَذْلِ الْيَسَارِ
u'بَرَأَ أَبٌ':Predicate, #1: 1	بَذْلِ يَسِيرِ
u'بَرَأَ أَجْنَبِيٌّ':Predicate, #1: 1	أَبْرَأَ الْأَبَ
u'بَرَأَ أحَدٌ':Predicate, #1: 1	أَبْرَأَ الْأَجْنَبِيَّ
u'بَرَأَ أَصيلٌ':Predicate, #2: 2	أَبْرَأَ أَحَدَ
u'بَرَأَ المُشْتَرِي':Predicate, #3: 3	أَبْرَأَ الْأَصِيلَ
u'بَرَأَ أَوَّلُ':Predicate, #11: 11	أَبْرَأَ الْمُشْتَرِيَ
u'بَرَأَ أَوْلاَدٌ':Predicate, #1: 1	أَبْرَأَ الْأَوَّلَ
u'بَرَأَ بَائِعٌ':Predicate, #1: 1	أَبْرَأَ أَوْلَادَ
u'بَرَأَ حاضِرٌ':Predicate, #2: 2	أَبْرَأَ الْبَائِعَ
u'بَرَّ أحَدٌ':Subject, #1: 1	أَبْرَأَ الْحَاضِرَ
u'بَرَأَ حَمِيل':Predicate, #1: 1	أَبَرَّ أَحَدُ
u'بَرَأَ دَبَرٌ':Subject, #1: 1	أَبْرَأَ الْحَمِيلَ
u'بَرَأَ دَبَرٌ':Subject, #1: 1	بَرَأَ الدّبَرُ
u'بَرَأَ ذِمَّةٌ':Predicate, #1: 1	بَرَأَ الدَّبَرُ
u'بَرَأَ رَاهِنٌ':Predicate, #2: 2	أَبْرَأَ الذِّمَّةَ
u'بَرَأَ صَاحِبٌ':Predicate, #1: 1	أَبْرَأَ الرَّاهِنَ
u'بَرَأَ ضَامِنٌ':Predicate, #1: 1	أَبْرَأَ صَاحِبَ
u'بَرَأَ عَاقِلٌ':Predicate, #1: 1	أَبْرَأَ الضَّامِنَ
u'بَرَأَ عَاقِلٌ':Predicate, #1: 1	أَبْرَأَ الْعَاقِلَةَ
u'بَرَأَ عَبْدٌ':Predicate, #1: 1	أَبْرَأَ عَاقِلَةَ
u'بَرَأَ غَاصِبٌ':Predicate, #2: 2	أَبْرَأَ الْعَبْدَ
u'بَرَأَ غرماء':Predicate, #2: 2	أَبْرَأَ الْغَاصِبَ
u'بَرَأَ غَرِيمٌ':Predicate, #1: 1	أَبْرَأَ الْغُرَمَاءَ
u'بَرَأَ فَقِيرٌ':Predicate, #2: 2	أَبْرَأَ الْغَرِيمَ
u'بَرَأَ فُلاَنٌ':Predicate, #1: 1	أَبْرَأَ الْفَقِيرَ
u'بَرَأَ قَاتِلٌ':Predicate, #1: 1	أَبْرَأَ فُلَانَ
u'بَرَأَ قَالٌ':Predicate, #1: 1	أَبْرَأَ الْقَاتِلَ
u'بَرَأَ كَفِيلٌ':Predicate, #1: 1	بَرَأَ قَالَ
u'بَرَأَ مُحْتَالٌ':Predicate, #5: 5	أَبْرَأَ الْكَفِيلَ
u'بَرَأَ مُحِيل':Predicate, #2: 2	أَبْرَأَ الْمُحْتَالَ
u'بَرَأَ مَدِينٌ':Predicate, #1: 1	أَبْرَأَ الْمُحِيلَ
u'بَرَأَ مَدْيُونٌ':Predicate, #2: 2	أَبْرَأَ الْمَدِينَ
u'بَرَأَ مُرْتَهِنٌ':Predicate, #4: 4	أَبْرَأَ الْمَدْيُونَ
u'بَرَأَ مُسْتَأْجِرٌ':Predicate, #1: 1	أَبْرَأَ الْمُرْتَهِنَ
u'بَرَأَ مُشْتَرِي':Predicate, #1: 1	أَبْرَأَ الْمُسْتَأْجِرَ
u'بَرَأَ مَطْلُوبٌ':Predicate, #11: 11	أَبْرَأَ الْمُشْتَرِيَ
u'بَرَأَ مَوْضِعٌ':Subject, #1: 1	أَبْرَأَ الْمَطْلُوبَ
u'بَرَأَ وَارِثٌ':Predicate, #1: 1	بَرَأَ مَوْضِعُ
u'بَرَأَ وَكِيلٌ':Predicate, #1: 1	أَبْرَأَ الْوَارِثَ
u'بَرِحَ أرْضٌ':Predicate, #1: 1	أَبْرَأَ الْوَكِيلَ
u'بَرِحَ خَفَاءٌ':Subject, #2: 2	أَبْرَحَ الْأَرْضَ
u'بَرِحَ رَسُولٌ':Subject, #1: 1	بَرِحَ الْخَفَاءُ
u'بَرْدٌ أرْضٌ':Added, #1: 1	بَرِحَ رَسُولُ
u'بَرْدٌ أرْضٌ':Added, #1: 1	بَرْدَ الأَرْضِ
u'بَرْدٌ أَطْرافٌ':Added, #1: 1	بَرْدَ الْأَرْضِ
u'بَرْدٌ أَطْرَافٌ':Added, #1: 1	بَرْدُ الْأَطْرَافِ
u'بَرْدٌ آفاقٌ':Added, #1: 1	بَرْدُ الْأَطْرَافِ
u'بَرْدٌ أنَامِلُ':Added, #1: 1	بَرْدُ الْآفَاقِ
u'بَرْدٌ رَطْبٌ':Added, #1: 1	بَرْدَ أَنَامِلِهِ
u'بَرْدٌ ريحٌ':Added, #1: 1	بَرْدِ الرَّطْبِ
u'بَرُدَ شَيْءٌ':Subject, #1: 1	بَرْدُ رِيحٍ
u'بَرْدٌ عَصَبٌ':Added, #1: 1	بَرُدَ الشَّيْءُ
u'بَرَدَ قَالٌ':Predicate, #1: 1	بَرْدِ الْعَصَبِ
u'بَرْدٌ قطنة':Added, #1: 1	بَرَدَ قَالَ
u'بَرْدٌ قُطْنَةٌ':Added, #1: 1	بَرْدِ الْقُطْنَةِ
u'بَرْدٌ كَفٌّ':Added, #1: 1	بَرْدِ الْقُطْنَةِ
u'بَرْدٌ لِسَانٌ':Added, #1: 1	بَرْدَ كَفٍّ
u'بَرْدٌ لعاب':Added, #5: 5	بَرْدَ لِسَانِهِ
u'بَرْدٌ لُعَابٌ':Added, #1: 1	بَرْدَ لُعَابِهِ
u'بَرَدَ مَاءٌ':Subject, #1: 1	بَرْدَ لُعَابِهِ
u'بَرْدٌ مَاءٌ':Added, #1: 1	بَرَدَ الْمَاءُ
u'بَرْدٌ مَاءٌ':Added, #1: 1	بَرْدَ الْمَاءِ
u'بَرَدَ مُشَمَّسٌ':Subject, #1: 1	بَرْدِ الْمَاءِ
u'بَرْدٌ مَعِدَةٌ':Added, #1: 1	بَرَدَ مُشَمَّسٌ
u'بَرْدٌ هَوَاءٌ':Added, #1: 1	بَرْدِ الْمَعِدَةِ
u'بَرْدٌ وَقْتٌ':Added, #1: 1	بَرْدِ الْهَوَاءِ
u'بَرَزَ بَعْضٌ':Subject, #1: 1	بَرْدِ الْوَقْتِ
u'بَرَزَ شَيْءٌ':Subject, #1: 1	بَرَزَ بَعْضُهُ
u'بَرَزَ ضَمِيرٌ':Subject, #1: 1	بَرَزَ الشَّيْءُ
u'بَرَزَ عَلِيٌّ':Subject, #1: 1	بَرَزَ الضّمِيرُ
u'بَرَزَ فلان':Subject, #1: 1	بَرَزَ عَلِيُّ
u'بَرَزَ مَكِّيّ':Subject, #1: 1	بَرَزَ مَكِّيٌّ
u'بَرَّ زَوْجٌ':Subject, #1: 1	بَرَزَ مَكِّيٌّ
u'بَرَّ سَواءٌ':Subject, #1: 1	بَرَّ الزَّوْجُ
u'برص الْمَرْأَةُ':Added, #1: 1	بَرَّ سَوَاءٌ
u'بَرَصٌ الْمَرْأَةُ':Added, #1: 1	بَرَصِ الْمَرْأَةِ
u'برص رَجُلٌ':Added, #1: 1	بَرَصِ الْمَرْأَةِ
u'بَرَصٌ رَجُلٌ':Added, #1: 1	بَرَصِ الرَّجُلِ
u'بَرَّ عَدَمٌ':Predicate, #1: 1	بَرَصِ الرَّجُلِ
u'بَرَعَ رَجُلٌ':Subject, #1: 1	بَرَّ عَدَمَ
u'بَرَّ عند':Predicate, #1: 1	بَرَعَ الرَّجُلُ
u'بَرَقَ فَجْرٌ':Subject, #1: 1	بَرَّ عِنْدَكَ
u'بَرِمَ بَيْعٌ':Predicate, #3: 3	بَرَقَ الْفَجْرُ
u'بَرَّ مَطْلُوبٌ':Predicate, #1: 1	أَبْرَمَ الْبَيْعَ
u'بَرْهَنَ أحَدٌ':Subject, #1: 1	أَبَرَّ الْمَطْلُوبَ
u'بَرْهَنَ أَوَّلُ':Subject, #1: 1	بَرْهَنَ أَحَدُ
u'بَرْهَنَ أَوْلِيَاءُ':Subject, #2: 2	بَرْهَنَ الْأَوَّلُ
u'بَرْهَنَ بَائِعٌ':Subject, #1: 1	بَرْهَنَ أَوْلِيَاءُ
u'بَرْهَنَ خَارِجٌ':Subject, #6: 6	بَرْهَنَ الْبَائِعُ
u'بَرْهَنَ رَاجِعٌ':Subject, #9: 9	بَرْهَنَ الْخَارِجُ
u'بَرْهَنَ رَجُلٌ':Subject, #2: 2	بَرْهَنَ الرَّاجِعُ
u'بَرْهَنَ شَفِيعٌ':Subject, #1: 1	بَرْهَنَ رَجُلٌ
u'بَرْهَنَ طَالِبٌ':Subject, #2: 2	بَرْهَنَ الشَّفِيعُ
u'بَرْهَنَ عَبْدٌ':Subject, #1: 1	بَرْهَنَ الطَّالِبُ
u'بَرْهَنَ عند':Predicate, #1: 1	بَرْهَنَ الْعَبْدُ
u'بَرْهَنَ غَائِبٌ':Subject, #1: 1	بَرْهَنَ عِنْدَ
u'بَرْهَنَ فُلاَنٌ':Subject, #2: 2	بَرْهَنَ الْغَائِبُ
u'بَرْهَنَ قَاتِلٌ':Subject, #1: 1	بَرْهَنَ فُلَانٌ
u'بَرْهَنَ قَالٌ':Predicate, #1: 1	بَرْهَنَ الْقَاتِلُ
u'بَرْهَنَ مَالِكٌ':Subject, #1: 1	بَرْهَنَ قَالَ
u'بَرْهَنَ مَدْيُونٌ':Subject, #2: 2	بَرْهَنَ الْمَالِكُ
u'بَرْهَنَ مَطْلُوبٌ':Subject, #1: 1	بَرْهَنَ الْمَدْيُونُ
u'بَرْهَنَ مَغْصُوب':Subject, #2: 2	بَرْهَنَ الْمَطْلُوبُ
u'بَرْهَنَ مَقْضِيّ':Subject, #1: 1	بَرْهَنَ الْمَغْصُوبُ
u'بَرْهَنَ مُوَكِّلٌ':Subject, #2: 2	بَرْهَنَ الْمَقْضِيُّ
u'بَرْهَنَ واحد':Subject, #1: 1	بَرْهَنَ الْمُوَكِّلُ
u'بَرْهَنَ وَاحِدٌ':Subject, #1: 1	بَرْهَنَ وَاحِدٌ
u'بَرْهَنَ وَارِثٌ':Subject, #1: 1	بَرْهَنَ وَاحِدٌ
u'بَرْهَنَ وَكِيلٌ':Subject, #3: 3	بَرْهَنَ الْوَارِثُ
u'بَرِئَ أَبٌ':Predicate, #2: 2	بَرْهَنَ الْوَكِيلُ
u'بَرِئَ أَجْنَبِيٌّ':Predicate, #1: 1	أَبْرَأَ الْأَبَ
u'بَرِئَ أحَدٌ':Predicate, #1: 1	أَبْرَأَ الْأَجْنَبِيَّ
u'بَرِئَ أصل':Subject, #2: 2	أَبْرَأَ أَحَدَ
u'بَرِئَ أًصْلٌ':Subject, #1: 1	بَرِئَ الْأَصْلُ
u'بَرِئَ أَصيلٌ':Predicate, #1: 1	بَرِئَ الْأَصْلُ
u'بَرِئَ أَصيلٌ':Subject, #3: 3	أَبْرَأَ الْأَصِيلَ
u'بَرِئَ المُشْتَرِي':Predicate, #13: 13	بَرِئَ الْأَصِيلُ
u'بَرِئَ آمِرٌ':Subject, #11: 11	أَبْرَأَ الْمُشْتَرِيَ
u'بَرِئَ أَوَّلُ':Predicate, #1: 1	بَرِئَ الْآمِرُ
u'بَرِئَ أَوَّلُ':Subject, #1: 1	أَبْرَأَ الْأَوَّلَ
u'بَرِئَ أَوْلاَدٌ':Predicate, #6: 6	بَرِئَ الْأَوَّلُ
u'بَرِئَ بَائِعٌ':Predicate, #1: 1	أَبْرَأَ أَوْلَادَ
u'بَرِئَ بَائِعٌ':Subject, #2: 2	أَبْرَأَ الْبَائِعَ
u'بَرِئَ ثَدْيٌ':Subject, #1: 1	بَرِئَ الْبَائِعُ
u'بَرِئَ جَارِحٌ':Subject, #1: 1	بَرِئَ الثَّدْيُ
u'بَرِئَ جُرْحٌ':Subject, #1: 1	بَرِئَ الْجَارِحُ
u'بَرِئَ جُرْحٌ':Subject, #2: 2	بَرِئَ الْجُرْحُ
u'بَرِئَ حاضِرٌ':Predicate, #3: 3	بَرِئَ جُرْحُهُ
u'بَرِئَ حَمِيل':Predicate, #1: 1	أَبْرَأَ الْحَاضِرَ
u'بَرِئَ حَمِيل':Subject, #1: 1	أَبْرَأَ الْحَمِيلَ
u'بَرِئَ حَمِيل':Subject, #1: 1	بَرِئَ حَمِيلُ
u'بَرِئَ حَيٌّ':Subject, #2: 2	بَرِئَ الْحَمِيلُ
u'بَرِئَ دَافِعٌ':Subject, #1: 1	بَرِئَ حَيٌّ
u'بَرِئَ دونٌ':Predicate, #1: 1	بَرِئَ الدَّافِعُ
u'بَرِئَ ذِمَّةٌ':Predicate, #2: 2	بَرِئَ دُونَ
u'بَرِئَ رَاهِنٌ':Predicate, #2: 2	أَبْرَأَ الذِّمَّةَ
u'بَرِئَ رَاهِنٌ':Subject, #1: 1	أَبْرَأَ الرَّاهِنَ
u'بَرِئَ رَسُولٌ':Subject, #4: 4	بَرِئَ الرَّاهِنُ
u'بَرِئَ رَقيقٌ':Subject, #2: 2	بَرِئَ رَسُولُ
u'بَرِئَ رَقيق':Subject, #1: 1	بَرِئَ الرَّقِيقُ
u'بَرِئَ زَوْجٌ':Subject, #1: 1	بَرِئَ الرَّقِيقُ
u'بَرِئَ سِحْرٌ':Subject, #7: 7	بَرِئَ الزَّوْجُ
u'بَرِئَ سَواءٌ':Subject, #1: 1	بَرِئَ السِّحْرُ
u'بَرِئَ سَيِّدٌ':Subject, #1: 1	بَرِئَ سَوَاءٌ
u'بَرِئَ شَرْحٌ':Subject, #1: 1	بَرِئَ السَّيِّدُ
u'بَرِئَ صَاحِبٌ':Predicate, #1: 1	بَرِئَ شَرْحُ
u'بَرِئَ صَغِيرٌ':Subject, #1: 1	أَبْرَأَ صَاحِبَ
u'بَرِئَ ضَامِنٌ':Predicate, #2: 2	بَرِئَ الصَّغِيرُ
u'بَرِئَ ضَامِنٌ':Subject, #1: 1	أَبْرَأَ الضَّامِنَ
u'بَرِئَ ضَامِنٌ':Subject, #1: 1	بَرِئَ ضَامِنُهُ
u'بَرِئَ عَاقِلٌ':Predicate, #5: 5	بَرِئَ الضَّامِنُ
u'بَرِئَ عَاقِلٌ':Predicate, #1: 1	أَبْرَأَ الْعَاقِلَةَ
u'بَرِئَ عَبْدٌ':Predicate, #1: 1	أَبْرَأَ عَاقِلَةَ
u'بَرِئَ عَبْدٌ':Subject, #2: 2	أَبْرَأَ الْعَبْدَ
u'بَرِئَ عَبْدٌ':Subject, #1: 1	بَرِئَ عَبْدُ
u'بَرِئَ عَظْمٌ':Subject, #4: 4	بَرِئَ الْعَبْدُ
u'بَرِئَ عَلِيلٌ':Subject, #1: 1	بَرِئَ الْعَظْمُ
u'بَرِئَ عَمٌّ':Subject, #1: 1	بَرِئَ الْعَلِيلُ
u'بَرِئَ عند':Predicate, #1: 1	بَرِئَ الْعَمُّ
u'بَرِئَ غَاصِبٌ':Predicate, #7: 7	بَرِئَ عِنْدَ
u'بَرِئَ غَاصِبٌ':Subject, #2: 2	أَبْرَأَ الْغَاصِبَ
u'بَرِئَ غَاصِبٌ':Subject, #11: 11	بَرِئَ الْغَاصِبُ
u'بَرِئَ غرماء':Predicate, #1: 1	بَرِئَ غَاصِبُهُ
u'بَرِئَ غرماء':Subject, #1: 1	أَبْرَأَ الْغُرَمَاءَ
u'بَرِئَ غَرِيمٌ':Predicate, #1: 1	بَرِئَ الْغُرَمَاءُ
u'بَرِئَ غَرِيمٌ':Subject, #2: 2	أَبْرَأَ الْغَرِيمَ
u'بَرِئَ فَرْجٌ':Subject, #6: 6	بَرِئَ الْغَرِيمُ
u'بَرِئَ فَقِيرٌ':Predicate, #1: 1	بَرِئَ الْفَرْجُ
u'بَرِئَ فُلاَنٌ':Predicate, #1: 1	أَبْرَأَ الْفَقِيرَ
u'بَرِئَ فُلاَنٌ':Subject, #1: 1	أَبْرَأَ فُلَانَ
u'بَرِئَ فَلَكٌ':Predicate, #3: 3	بَرِئَ فُلَانٌ
u'بَرِئَ قَاتِلٌ':Predicate, #1: 1	بَرِئَ فَلَكَ
u'بَرِئَ قصاص':Subject, #1: 1	أَبْرَأَ الْقَاتِلَ
u'بَرِئَ قِصَاصٌ':Subject, #1: 1	بَرِئَ الْقِصَاصُ
u'بَرِئَ كَفِيلٌ':Predicate, #1: 1	بَرِئَ الْقِصَاصُ
u'بَرِئَ كَفِيلٌ':Subject, #5: 5	أَبْرَأَ الْكَفِيلَ
u'بَرِئَ كَفِيلٌ':Subject, #1: 1	بَرِئَ كَفِيلُهُ
u'بَرِئَ مَالِكٌ':Subject, #74: 74	بَرِئَ الْكَفِيلُ
u'بَرِئَ مُتَعَلِّمٌ':Subject, #1: 1	بَرِئَ الْمَالِكُ
u'بَرِئَ مَجْرُوحٌ':Subject, #1: 1	بَرِئَ الْمُتَعَلِّمُ
u'بَرِئَ مُحْتَالٌ':Predicate, #1: 1	بَرِئَ الْمَجْرُوحُ
u'بَرِئَ مُحْتَالٌ':Subject, #2: 2	أَبْرَأَ الْمُحْتَالَ
u'بَرِئَ مُحِيل':Predicate, #3: 3	بَرِئَ الْمُحْتَالُ
u'بَرِئَ مُحِيل':Subject, #1: 1	أَبْرَأَ الْمُحِيلَ
u'بَرِئَ مُحِيل':Subject, #10: 10	بَرِئَ الْمُحِيلُ
u'بَرِئَ مَدِينٌ':Predicate, #1: 1	بَرِئَ مُحِيلُهُ
u'بَرِئَ مَدْيُونٌ':Predicate, #2: 2	أَبْرَأَ الْمَدِينَ
u'بَرِئَ مَدْيُونٌ':Subject, #4: 4	أَبْرَأَ الْمَدْيُونَ
u'بَرِئَ مُرْتَهِنٌ':Predicate, #2: 2	بَرِئَ الْمَدْيُونُ
u'بَرِئَ مَرِيضٌ':Subject, #1: 1	أَبْرَأَ الْمُرْتَهِنَ
u'بَرِئَ مُسْتَأْجِرٌ':Predicate, #6: 6	بَرِئَ الْمَرِيضُ
u'بَرِئَ مُسْتَعِيرٌ':Subject, #1: 1	أَبْرَأَ الْمُسْتَأْجِرَ
u'بَرِئَ مُسْلِمٌ':Subject, #1: 1	بَرِئَ الْمُسْتَعِيرُ
u'بَرِئَ مُشْتَرِي':Predicate, #1: 1	بَرِئَ الْمُسْلِمُ
u'بَرِئَ مَضْمُونٌ':Subject, #11: 11	أَبْرَأَ الْمُشْتَرِيَ
u'بَرِئَ مَطْلُوبٌ':Predicate, #1: 1	بَرِئَ الْمَضْمُونُ
u'بَرِئَ مَطْلُوبٌ':Subject, #1: 1	أَبْرَأَ الْمَطْلُوبَ
u'بَرِئَ مُعْتَقٌ':Subject, #11: 11	بَرِئَ الْمَطْلُوبُ
u'بَرِئَ مُفْلِسٌ':Subject, #1: 1	بَرِئَ الْمُعْتَقُ
u'بَرِئَ مَكْفُولٌ':Subject, #1: 1	بَرِئَ الْمُفْلِسُ
u'بَرِئَ مُودِعٌ':Subject, #3: 3	بَرِئَ الْمَكْفُولُ
u'بَرِئَ مُودَعٌ':Subject, #1: 1	بَرِئَ الْمُودِعُ
u'بَرِئَ وَارِثٌ':Predicate, #2: 2	بَرِئَ الْمُودَعُ
u'بَرِئَ وَصِيٌّ':Subject, #1: 1	أَبْرَأَ الْوَارِثَ
u'بَرِئَ وَكِيلٌ':Predicate, #1: 1	بَرِئَ الْوَصِيُّ
u'بَرِئَ وَكِيلٌ':Subject, #1: 1	أَبْرَأَ الْوَكِيلَ
u'بَرِئَ وَلِيٌّ':Subject, #1: 1	بَرِئَ الْوَكِيلُ
u'بَزَغَ فَجْرٌ':Subject, #1: 1	بَرِئَ الْوَلِيُّ
u'بَزَغَ مَاءٌ':Subject, #1: 1	بَزَغَ الْفَجْرُ
u'بَزَقَ رَسُولٌ':Subject, #1: 1	بَزَغَ الْمَاءُ
u'بَزَقَ فَجْرٌ':Subject, #1: 1	بَزَقَ رَسُولُ
u'بَزَلَ نَابٌ':Subject, #1: 1	بَزَقَ الْفَجْرُ
u'بَسَرَ كَرِهٌ':Predicate, #1: 1	بَزَلَ نَابُهُ
u'بسط أَحْوالٌ':Added, #1: 1	بَسَرَ كَرِهَ
u'بسط أحْوَالٌ':Added, #1: 1	بَسْطِ أَحْوَالِهِ
u'بَسْطٌ أَحْوالٌ':Added, #1: 1	بَسْطِ أَحْوَالِهِ
u'بَسْطٌ أحْوَالٌ':Added, #1: 1	بَسْطِ أَحْوَالِهِ
u'بسط أَصابِعُ':Added, #1: 1	بَسْطِ أَحْوَالِهِ
u'بَسْطٌ أَصابِعُ':Added, #1: 1	بَسْطُ الْأَصَابِعِ
u'بسط أَقْدَارٌ':Added, #1: 1	بَسْطُ الْأَصَابِعِ
u'بَسْطٌ أَقْدَارٌ':Added, #1: 1	بَسْطِ الْأَقْدَارِ
u'بَسَطَ إِنْسانٌ':Subject, #1: 1	بَسْطِ الْأَقْدَارِ
u'بَسَطَ بساط':Predicate, #1: 1	بَسَطَ إنْسَانٌ
u'بَسَطَ بِساطٌ':Predicate, #1: 1	بَسَطَ بِسَاطَ
u'بَسَطَ ثَوْبٌ':Predicate, #1: 1	بَسَطَ بِسَاطَ
u'بسط جَوَابٌ':Added, #3: 3	بَسَطَ الثَّوْبَ
u'بَسْطٌ جَوَابٌ':Added, #1: 1	بَسْطِ الْجَوَابِ
u'بسط حَصِيرٌ':Added, #1: 1	بَسْطِ الْجَوَابِ
u'بَسْطٌ حَصِيرٌ':Added, #1: 1	بَسْطَ الْحَصِيرِ
u'بسط حَصِيرٌ':Added, #1: 1	بَسْطَ الْحَصِيرِ
u'بَسْطٌ حَصِيرٌ':Added, #1: 1	بَسْطُ حَصِيرٍ
u'بسط دِرْهَمٌ':Added, #1: 1	بَسْطُ حَصِيرٍ
u'بسط دِرْهَم':Added, #2: 2	بَسْطُ الدِّرْهَمِ
u'بَسْطٌ دِرْهَمٌ':Added, #2: 2	بَسْطُ الدِّرْهَمِ
u'بَسْطٌ دِرْهَم':Added, #2: 2	بَسْطُ الدِّرْهَمِ
u'بَسَطَ رَدٌّ':Predicate, #2: 2	بَسْطُ الدِّرْهَمِ
u'بسط سَبَّابٌ':Added, #1: 1	بَسَطَ الرَّدَّ
u'بَسْطٌ سَبَّابٌ':Added, #1: 1	بَسْطِ السَّبَّابَةِ
u'بسط سَبَّابَةٌ':Added, #1: 1	بَسْطِ السَّبَّابَةِ
u'بَسْطٌ سَبَّابَةٌ':Added, #1: 1	بَسْطِ السَّبَّابَةِ
u'بَسَطَ سُؤَالٌ':Predicate, #1: 1	بَسْطِ السَّبَّابَةِ
u'بسط طَرْفٌ':Added, #1: 1	بَسَطَ السُّؤَالَ
u'بَسْطٌ طَرْفٌ':Added, #1: 1	بَسْطِ طَرْفٍ
u'بسط طُولٌ':Added, #1: 1	بَسْطِ طَرْفٍ
u'بَسْطٌ طُولٌ':Added, #2: 2	بَسْطِ الطُّولِ
u'بسط عِبَارَةٌ':Added, #2: 2	بَسْطِ الطُّولِ
u'بَسْطٌ عِبَارَةٌ':Added, #1: 1	بَسْطُ عِبَارَتِهِ
u'بسط عَدْلٌ':Added, #1: 1	بَسْطُ عِبَارَتِهِ
u'بَسْطٌ عَدْلٌ':Added, #1: 1	بَسْطِ الْعَدْلِ
u'بَسَطَ قول':Predicate, #1: 1	بَسْطِ الْعَدْلِ
u'بَسَطَ قَوْلٌ':Predicate, #1: 1	بَسَطَ الْقَوْلَ
u'بسط قول':Added, #1: 1	بَسَطَ الْقَوْلَ
u'بَسْطٌ قول':Added, #1: 1	بَسْطِ الْقَوْلِ
u'بسط قَوْلٌ':Added, #1: 1	بَسْطِ الْقَوْلِ
u'بَسْطٌ قَوْلٌ':Added, #1: 1	بَسْطِ الْقَوْلِ
u'بسط كَفٌّ':Added, #1: 1	بَسْطِ الْقَوْلِ
u'بَسْطٌ كَفٌّ':Added, #1: 1	بَسْطَ الْكَفَّيْنِ
u'بَسَطَ كَلاَمٌ':Predicate, #1: 1	بَسْطَ الْكَفَّيْنِ
u'بسط كَلاَمٌ':Added, #9: 9	بَسَطَ الْكَلَامَ
u'بَسْطٌ كَلاَمٌ':Added, #5: 5	بَسْطُ الْكَلَامِ
u'بسط كَلاَمٌ':Added, #5: 5	بَسْطُ الْكَلَامِ
u'بَسْطٌ كَلاَمٌ':Added, #6: 6	بَسْطِ الْكَلَامِ
u'بسط مُدَوَّرٌ':Added, #6: 6	بَسْطِ الْكَلَامِ
u'بَسْطٌ مُدَوَّرٌ':Added, #1: 1	بَسْطَ الْمُدَوَّرِ
u'بَسَطَ مَسْأَلَةٌ':Predicate, #1: 1	بَسْطَ الْمُدَوَّرِ
u'بسط مَسَائِلُ':Added, #1: 1	بَسَطَ الْمَسْأَلَةَ
u'بَسْطٌ مَسَائِلُ':Added, #1: 1	بَسْطُ الْمَسَائِلِ
u'بسط مُسَطَّحٌ':Added, #1: 1	بَسْطُ الْمَسَائِلِ
u'بَسْطٌ مُسَطَّحٌ':Added, #2: 2	بَسْطُ الْمُسَطَّحِ
u'بسط مَقَالَةٌ':Added, #2: 2	بَسْطُ الْمُسَطَّحِ
u'بَسْطٌ مَقَالَةٌ':Added, #1: 1	بَسْطُ الْمَقَالَةِ
u'بسط نَظِيرٌ':Added, #1: 1	بَسْطُ الْمَقَالَةِ
u'بَسْطٌ نَظِيرٌ':Added, #1: 1	بَسْطُ نَظِيرِ
u'بسط وَجْهٌ':Added, #1: 1	بَسْطُ نَظِيرِ
u'بَسْطٌ وَجْهٌ':Added, #2: 2	بَسْطُ الْوَجْهِ
u'بسط وُجُوهٌ':Added, #2: 2	بَسْطُ الْوَجْهِ
u'بسط وُجُوهٌ':Added, #1: 1	بَسْطَ الْوُجُوهِ
u'بَسْطٌ وُجُوهٌ':Added, #1: 1	بَسْطُ الْوُجُوهِ
u'بَسْطٌ وُجُوهٌ':Added, #1: 1	بَسْطَ الْوُجُوهِ
u'بسط يَدٌ':Added, #1: 1	بَسْطُ الْوُجُوهِ
u'بسط يَدٌ':Added, #1: 1	بَسْطَ الْيَدِ
u'بَسْطٌ يَدٌ':Added, #1: 1	بَسْطِ الْيَدِ
u'بَسْطٌ يَدٌ':Added, #1: 1	بَسْطَ الْيَدِ
u'بسط يَدٌ':Added, #1: 1	بَسْطِ الْيَدِ
u'بَسْطٌ يَدٌ':Added, #1: 1	بَسْطُ الْيَدَيْنِ
u'بسط يسار':Added, #1: 1	بَسْطُ الْيَدَيْنِ
u'بسط يَسَارٌ':Added, #1: 1	بَسْطِ الْيَسَارِ
u'بَسْطٌ يسار':Added, #1: 1	بَسْطِ الْيَسَارِ
u'بَسْطٌ يَسَارٌ':Added, #1: 1	بَسْطِ الْيَسَارِ
u'بَشَّرَ أَسْماءٌ':Predicate, #1: 1	بَسْطِ الْيَسَارِ
u'بَشَّرَ رَسُولٌ':Subject, #1: 1	بَشَّرَ أَسْمَاءَ
u'بِشْرٌ غِلْمَانٌ':Added, #3: 3	بَشَّرَ رَسُولُ
u'بِشْرٌ نَبِيٌّ':Added, #1: 1	بِشْرِ الْغِلْمَانِ
u'بَصَرٌ أحَدٌ':Added, #1: 1	بِشْرَ النَّبِيِّ
u'بَصَرٌ أمَةٌ':Added, #1: 1	بَصَرِ أَحَدِ
u'بَصَرٌ إِنْسانٌ':Added, #1: 1	بَصَرَ أَمَةٍ
u'بَصَرٌ بَصيرٌ':Added, #1: 1	بَصَرِ الْإِنْسَانِ
u'بَصَرٌ بَصيرَةٌ':Added, #1: 1	بَصَرَ بَصِيرَتِهِ
u'بَصِرَ بَطَلٌ':Predicate, #1: 1	بَصَرَ بَصِيرَتِهِ
u'بَصِرَ بَعْضٌ':Predicate, #1: 1	أَبْصَرَ بَطَلَ
u'بَصَرٌ رَاكِبٌ':Added, #1: 1	أَبْصَرَ بَعْضَ
u'بَصِرَ رَجُلٌ':Predicate, #1: 1	بَصَرِ الرَّاكِبِ
u'بَصَرٌ رَسُولٌ':Added, #5: 5	أَبْصَرَ رَجُلاً
u'بَصَرٌ سَامِعٌ':Added, #1: 1	بَصَرِ رَسُولِ
u'بَصَرٌ سَقِيمٌ':Added, #1: 1	بَصَرِ السَّامِعِ
u'بَصَرٌ سَلِيمٌ':Added, #1: 1	بَصَرُ السَّقِيمَةِ
u'بَصِرَ عِرْفَانٌ':Predicate, #1: 1	بَصَرُ سَلِيمَتِهِ
u'بَصَرٌ قَائِدٌ':Added, #1: 1	أَبْصَرَ الْعِرْفَانَ
u'بَصِرَ قَوْمٌ':Predicate, #2: 2	بَصَرِ الْقَائِدِ
u'بَصِرَ مَاءٌ':Predicate, #1: 1	أَبْصَرَ الْقَوْمَ
u'بَصَرٌ مَارٌّ':Added, #8: 8	أَبْصَرَ الْمَاءَ
u'بَصَرٌ مَضْرُوبٌ':Added, #1: 1	بَصَرُ الْمَارِّ
u'بَصَرٌ مُكْرِهٌ':Added, #1: 1	بَصَرُ الْمَضْرُوبِ
u'بَصِرَ مَوَاقِعُ':Predicate, #3: 3	بَصَرِ الْمُكْرِهِ
u'بَصَرٌ نَاظِرٌ':Added, #1: 1	أَبْصَرَ مَوَاقِعَ
u'بَصِرَ نَبِيٌّ':Predicate, #1: 1	بَصَرَ النَّاظِرِ
u'بَصِرَ هِلاَلٌ':Predicate, #1: 1	أَبْصَرَ النَّبِيَّ
u'بَصِرَ وَجَبٌ':Predicate, #2: 2	أَبْصَرَ الْهِلَالَ
u'بَصَقَ رَسُولٌ':Subject, #1: 1	أَبْصَرَ وَجَبَ
u'بُطْءٌ بُرْء':Added, #1: 1	بَصَقَ رَسُولُ
u'بُطْءٌ بُرْء':Added, #2: 2	بُطْءَ الْبُرْءِ
u'بَطَحَ مَسْجِدٌ':Predicate, #2: 2	بُطْءِ الْبُرْءِ
u'بَطِرَ حَقٌّ':Predicate, #1: 1	بَطَحَ الْمَسْجِدَ
u'بَطْشٌ ثَانِي':Added, #3: 3	بَطِرَ الْحَقَّ
u'بَطْشٌ ثَانِيَةٌ':Added, #1: 1	بَطْشُ الثَّانِيَةِ
u'بَطْشٌ يَدٌ':Added, #1: 1	بَطْشُ الثَّانِيَةِ
u'بَطَلَ إِثْبَاتٌ':Subject, #1: 1	بَطْشَ يَدٍ
u'بَطَلَ أَجَلٌ':Subject, #1: 1	بَطَلَ الْإِثْبَاتُ
u'بَطَلَ إِجْمَاعٌ':Subject, #3: 3	بَطَلَ الْأَجَلُ
u'بَطَلَ أحَدٌ':Subject, #1: 1	بَطَلَ الْإِجْمَاعُ
u'بَطَلَ إِخْبَارٌ':Subject, #1: 1	بَطَلَ أَحَدُ
u'بَطَلَ اِخْتِصَاصٌ':Subject, #1: 1	بَطَلَ الْإِخْبَارُ
u'بَطَلَ اِخْتِيَارٌ':Subject, #1: 1	بَطَلَ اخْتِصَاصُهُ
u'بَطَلَ أخْذٌ':Subject, #1: 1	بَطَلَ اخْتِيَارُهُ
u'بَطَلَ إِذْنٌ':Subject, #1: 1	بَطَلَ الْأَخْذُ
u'بَطَلَ أَرْبَعَةٌ':Subject, #7: 7	بَطَلَ الْإِذْنُ
u'بَطَلَ اِسْتِثْنَاءٌ':Subject, #1: 1	بَطَلَ أَرْبَعَةُ
u'بَطَلَ اِسْتِحْقَاقٌ':Subject, #4: 4	بَطَلَ اسْتِثْنَاءُ
u'بَطَلَ اِسْتِدْلاَلٌ':Subject, #4: 4	بَطَلَ اسْتِحْقَاقُهُ
u'بَطَلَ اِسْتِرْجَاعٌ':Subject, #1: 1	بَطَلَ اسْتِدْلَالُ
u'بَطَلَ اِسْتِقْلالٌ':Subject, #1: 1	بَطَلَ اسْتِرْجَاعُهُ
u'بَطَلَ إِشْراكٌ':Subject, #1: 1	بَطَلَ اسْتِقْلَالُهُ
u'بَطَلَ أصل':Subject, #1: 1	بَطَلَ الْإِشْرَاكُ
u'بَطَلَ أًصْلٌ':Subject, #1: 1	بَطَلَ أَصْلُ
u'بَطَلَ أصل':Subject, #1: 1	بَطَلَ أَصْلُ
u'بَطَلَ أًصْلٌ':Subject, #1: 1	بَطَلَ أَصْلُهُ
u'بَطَلَ أصل':Subject, #1: 1	بَطَلَ أَصْلُهُ
u'بَطَلَ أًصْلٌ':Subject, #2: 2	بَطَلَ الْأَصْلُ
u'بَطَلَ اِعْتِكافٌ':Subject, #2: 2	بَطَلَ الْأَصْلُ
u'بَطَلَ اِقْتِداءٌ':Subject, #26: 26	بَطَلَ اعْتِكَافُهُ
u'بَطَلَ اِقْتِضَاءٌ':Subject, #2: 2	بَطَلَ اقْتِدَاءُ
u'بَطَلَ إقْرَارٌ':Subject, #1: 1	بَطَلَ اقْتِضَاءُ
u'بَطَلَ إقْرَارٌ':Subject, #13: 13	بَطَلَ الْإِقْرَارُ
u'بَطَلَ إقْرَارٌ':Subject, #19: 19	بَطَلَ إقْرَارُهُ
u'بَطَلَ اِكْتِفَاءٌ':Subject, #1: 1	بَطَلَ إقْرَارُ
u'بَطَلَ أمَانٌ':Subject, #1: 1	بَطَلَ اكْتِفَاءُ
u'بَطَلَ أمَانٌ':Subject, #1: 1	بَطَلَ أَمَانُ
u'بَطَلَ أَمْرٌ':Subject, #1: 1	بَطَلَ أَمَانُهُ
u'بَطَلَ أَمْرٌ':Subject, #13: 13	بَطَلَ الْأَمْرُ
u'بَطَلَ اِنْتِسابٌ':Subject, #3: 3	بَطَلَ أَمْرُ
u'بَطَلَ أَوَّلُ':Subject, #2: 2	بَطَلَ انْتِسَابُهُ
u'بَطَلَ إِيجَابٌ':Subject, #5: 5	بَطَلَ الْأَوَّلُ
u'بَطَلَ إيمَانٌ':Subject, #19: 19	بَطَلَ الْإِيجَابُ
u'بَطَلَ بَطَلٌ':Predicate, #1: 1	بَطَلَ إيمَانُهُ
u'بَطَلَ بَعْضٌ':Subject, #1: 1	بَطَلَ بَطَلَ
u'بَطَلَ بَعْضٌ':Subject, #1: 1	بَطَلَ الْبَعْضُ
u'بَطَلَ بِنَاءٌ':Subject, #1: 1	بَطَلَ بَعْضُهُ
u'بَطَلَ بَيَانٌ':Subject, #1: 1	بَطَلَ الْبِنَاءُ
u'بَطَلَ بَيْعٌ':Subject, #1: 1	بَطَلَ بَيَانُهُ
u'بَطَلَ بَيْعٌ':Subject, #153: 153	بَطَلَ الْبَيْعُ
u'بَطَلَ بَيْعٌ':Subject, #2: 2	بَطَلَ بَيْعُهُ
u'بَطَلَ تَأْثِيرٌ':Subject, #3: 3	بَطَلَ بَيْعُ
u'بَطَلَ تَأْخِيرٌ':Subject, #1: 1	بَطَلَ تَأْثِيرُ
u'بَطَلَ تَتَابُعٌ':Subject, #1: 1	بَطَلَ التَّأْخِيرُ
u'بَطَلَ تَخْيِيرٌ':Subject, #1: 1	بَطَلَ تَتَابُعُهُ
u'بَطَلَ تَدْبِيرٌ':Subject, #1: 1	بَطَلَ التَّخْيِيرُ
u'بَطَلَ تَدْبِيرٌ':Subject, #13: 13	بَطَلَ التَّدْبِيرُ
u'بَطَلَ تَدْرِيسٌ':Subject, #1: 1	بَطَلَ تَدْبِيرُهُ
u'بَطَلَ تَسْلِيطٌ':Subject, #1: 1	بَطَلَ التَّدْرِيسُ
u'بَطَلَ تَسْلِيمٌ':Subject, #2: 2	بَطَلَ التَّسْلِيطُ
u'بَطَلَ تَصْدِيقٌ':Subject, #1: 1	بَطَلَ تَسْلِيمُهُ
u'بَطَلَ تَصَرُّفٌ':Subject, #1: 1	بَطَلَ التَّصْدِيقُ
u'بَطَلَ تَعَلُّقٌ':Subject, #2: 2	بَطَلَ تَصَرُّفُهُ
u'بَطَلَ تَعَلُّقٌ':Subject, #1: 1	بَطَلَ التَّعَلُّقُ
u'بَطَلَ تَعْلِيقٌ':Subject, #1: 1	بَطَلَ تَعَلُّقُ
u'بَطَلَ تَعْلِيلٌ':Subject, #5: 5	بَطَلَ التَّعْلِيقُ
u'بَطَلَ تَعْلِيلٌ':Subject, #1: 1	بَطَلَ التَّعْلِيلُ
u'بَطَلَ تَعْلِيمٌ':Subject, #1: 1	بَطَلَ تَعْلِيلُهُ
u'بَطَلَ تَعْمِيمٌ':Subject, #1: 1	بَطَلَ تَعْلِيمُهُ
u'بَطَلَ تَعْوِيلٌ':Subject, #2: 2	بَطَلَ تَعْمِيمُ
u'بَطَلَ تَعْيِينٌ':Subject, #1: 1	بَطَلَ التَّعْوِيلُ
u'بَطَلَ تَفْرِيقٌ':Subject, #1: 1	بَطَلَ التَّعْيِينُ
u'بَطَلَ تَفَكُّرٌ':Subject, #1: 1	بَطَلَ تَفْرِيقُ
u'بَطَلَ تَفْوِيضٌ':Subject, #1: 1	بَطَلَ تَفَكُّرُهُ
u'بَطَلَ تَقَدُّمٌ':Subject, #1: 1	بَطَلَ التَّفْوِيضُ
u'بَطَلَ تَقْليدٌ':Subject, #1: 1	بَطَلَ تَقَدُّمُهُ
u'بَطَلَ تَقْليد':Subject, #1: 1	بَطَلَ التَّقْلِيدُ
u'بَطَلَ تَقَوُّمٌ':Predicate, #1: 1	بَطَلَ التَّقْلِيدُ
u'بَطَلَ تَقْيِيد':Subject, #1: 1	بَطَلَ تَقَوُّمَ
u'بَطَلَ تَقْيِيد':Subject, #1: 1	بَطَلَ التَّقْيِيدُ
u'بَطَلَ تَكاذُبٌ':Subject, #2: 2	بَطَلَ تَقْيِيدُهُ
u'بَطَلَ تَكْفيلٌ':Subject, #3: 3	بَطَلَ التَّكَاذُبُ
u'بَطَلَ تَمَتُّعٌ':Subject, #1: 1	بَطَلَ التَّكْفِيلُ
u'بَطَلَ تَنْزِيلٌ':Subject, #12: 12	بَطَلَ تَمَتُّعُهُ
u'بَطَلَ تَهَيُّؤٌ':Subject, #2: 2	بَطَلَ تَنْزِيلُ
u'بَطَلَ تَوَقُّفٌ':Subject, #1: 1	بَطَلَ تَهَيُّؤُهُ
u'بَطَلَ تَوْكِيلٌ':Subject, #2: 2	بَطَلَ التَّوَقُّفُ
u'بَطَلَ تَوْكِيلٌ':Subject, #1: 1	بَطَلَ تَوْكِيلُهُ
u'بَطَلَ تَيَمُّمٌ':Subject, #8: 8	بَطَلَ التَّوْكِيلُ
u'بَطَلَ تَيَمُّمٌ':Subject, #18: 18	بَطَلَ تَيَمُّمُهُ
u'بَطَلَ تَيَمُّمٌ':Subject, #1: 1	بَطَلَ تَيَمُّمُ
u'بَطَلَ ثَمَنٌ':Subject, #4: 4	بَطَلَ التَّيَمُّمُ
u'بَطَلَ ثَمَن':Subject, #11: 11	بَطَلَ الثَّمَنُ
u'بَطَلَ ثَوابٌ':Subject, #1: 1	بَطَلَ الثَّمَنِيَّةُ
u'بَطَلَ جمع':Subject, #1: 1	بَطَلَ ثَوَابُهُ
u'بَطَلَ جَمْعٌ':Subject, #9: 9	بَطَلَ الْجَمْعُ
u'بَطَلَ جَمِيع':Subject, #9: 9	بَطَلَ الْجَمْعُ
u'بَطَلَ حَبْسٌ':Subject, #7: 7	بَطَلَ الْجَمِيعُ
u'بَطَلَ حَدٌّ':Subject, #2: 2	بَطَلَ الْحَبْسُ
u'بَطَلَ حَدٌّ':Subject, #11: 11	بَطَلَ الْحَدُّ
u'بَطَلَ حِصَّةٌ':Subject, #1: 1	بَطَلَ حَدُّهُ
u'بَطَلَ حَطّ':Subject, #1: 1	بَطَلَ حِصَّةُ
u'بَطَلَ حَقٌّ':Subject, #2: 2	بَطَلَ الْحَطُّ
u'بَطَلَ حَقٌّ':Subject, #2: 2	بَطَلَ حَقٌّ
u'بَطَلَ حَقٌّ':Subject, #36: 36	بَطَلَ حَقُّ
u'بَطَلَ حَقٌّ':Subject, #3: 3	بَطَلَ الْحَقُّ
u'بَطَلَ حُكْمٌ':Subject, #53: 53	بَطَلَ حَقُّهُ
u'بَطَلَ حُكْمٌ':Subject, #1: 1	بَطَلَ حُكْمُهُ
u'بَطَلَ حُكْمٌ':Subject, #20: 20	بَطَلَ حُكْمُ
u'بَطَلَ حَمْلٌ':Subject, #7: 7	بَطَلَ الْحُكْمُ
u'بَطَلَ حَمْلٌ':Subject, #2: 2	بَطَلَ الْحَمْلُ
u'بَطَلَ حَوْزٌ':Subject, #3: 3	بَطَلَ حَمْلُ
u'بَطَلَ حول':Subject, #1: 1	بَطَلَ الْحَوْزُ
u'بَطَلَ حَوْلٌ':Subject, #1: 1	بَطَلَ الْحَوْلُ
u'بَطَلَ حول':Subject, #1: 1	بَطَلَ الْحَوْلُ
u'بَطَلَ حَوْلٌ':Subject, #3: 3	بَطَلَ حَوْلُ
u'بَطَلَ خَبَرٌ':Subject, #3: 3	بَطَلَ حَوْلُ
u'بَطَلَ خَبَر':Subject, #1: 1	بَطَلَ الْخَبَرُ
u'بَطَلَ خَبَرٌ':Subject, #1: 1	بَطَلَ الْخَبَرُ
u'بَطَلَ خَبَر':Subject, #1: 1	بَطَلَ خَبَرُ
u'بَطَلَ خُلْعٌ':Subject, #1: 1	بَطَلَ خَبَرُ
u'بَطَلَ خَلَفٌ':Subject, #8: 8	بَطَلَ الْخُلْعُ
u'بَطَلَ خيار':Subject, #1: 1	بَطَلَ الْخَلَفُ
u'بَطَلَ خِيَارٌ':Subject, #15: 15	بَطَلَ خِيَارُ
u'بَطَلَ خيار':Subject, #15: 15	بَطَلَ خِيَارُ
u'بَطَلَ خِيَارٌ':Subject, #25: 25	بَطَلَ الْخِيَارُ
u'بَطَلَ خيار':Subject, #25: 25	بَطَلَ الْخِيَارُ
u'بَطَلَ خِيَارٌ':Subject, #70: 70	بَطَلَ خِيَارُهُ
u'بَطَلَ دَلالَةٌ':Subject, #70: 70	بَطَلَ خِيَارُهُ
u'بَطَلَ دَمٌ':Subject, #1: 1	بَطَلَ الدَّلَالَةُ
u'بَطَلَ دَمٌ':Subject, #1: 1	بَطَلَ دَمُ
u'بَطَلَ دَيْنٌ':Subject, #6: 6	بَطَلَ الدَّمُ
u'بَطَلَ دَيْنٌ':Subject, #3: 3	بَطَلَ دَيْنُهُ
u'بَطَلَ دَيْنٌ':Subject, #4: 4	بَطَلَ دَيْنُ
u'بَطَلَ ذكر':Subject, #6: 6	بَطَلَ الدَّيْنُ
u'بَطَلَ ذِكْرٌ':Subject, #3: 3	بَطَلَ الذِّكْرُ
u'بَطَلَ رُجُوعٌ':Subject, #3: 3	بَطَلَ الذِّكْرُ
u'بَطَلَ رُجُوعٌ':Subject, #2: 2	بَطَلَ رُجُوعُهُ
u'بَطَلَ رَدٌّ':Subject, #6: 6	بَطَلَ الرُّجُوعُ
u'بَطَلَ رَدٌّ':Subject, #2: 2	بَطَلَ رَدُّهُ
u'بَطَلَ رَمْيٌ':Subject, #4: 4	بَطَلَ الرَّدُّ
u'بَطَلَ رَهْنٌ':Subject, #1: 1	بَطَلَ رَمْيُ
u'بَطَلَ رَهْنٌ':Subject, #1: 1	بَطَلَ رَهْنُهُ
u'بَطَلَ زائِدٌ':Subject, #30: 30	بَطَلَ الرَّهْنُ
u'بَطَلَ زَرْعٌ':Subject, #3: 3	بَطَلَ الزَّائِدُ
u'بَطَلَ زَعْمٌ':Subject, #1: 1	بَطَلَ زَرْعُ
u'بَطَلَ سَبَبٌ':Subject, #1: 1	بَطَلَ زَعْمُهُ
u'بَطَلَ سَحْرٌ':Subject, #1: 1	بَطَلَ السَّبَبُ
u'بَطَلَ سُحْرٌ':Subject, #1: 1	بَطَلَ السّحْرُ
u'بَطَلَ سِحْرٌ':Subject, #1: 1	بَطَلَ السّحْرُ
u'بَطَلَ سَلَمٌ':Subject, #1: 1	بَطَلَ السّحْرُ
u'بَطَلَ سَواءٌ':Subject, #20: 20	بَطَلَ السَّلَمُ
u'بَطَلَ سُؤَالٌ':Subject, #1: 1	بَطَلَ سَوَاءٌ
u'بَطَلَ شِرَاءٌ':Subject, #1: 1	بَطَلَ السُّؤَالُ
u'بَطَلَ شَرْطٌ':Subject, #7: 7	بَطَلَ الشِّرَاءُ
u'بَطَلَ شَرْطٌ':Subject, #1: 1	بَطَلَ شَرْطُ
u'بَطَلَ شَرْطٌ':Subject, #1: 1	بَطَلَ شَرْطُهُ
u'بَطَلَ شُرُوطٌ':Subject, #28: 28	بَطَلَ الشَّرْطُ
u'بَطَلَ شَيْءٌ':Subject, #1: 1	بَطَلَ الشُّرُوطُ
u'بَطَلَ صِحَّةٌ':Subject, #1: 1	بَطَلَ الشَّيْءُ
u'بَطَلَ صداق':Subject, #1: 1	بَطَلَ الصِّحَّةُ
u'بَطَلَ صَدَاقٌ':Subject, #3: 3	بَطَلَ الصَّدَاقُ
u'بَطَلَ صَرْفٌ':Subject, #3: 3	بَطَلَ الصَّدَاقُ
u'بَطَلَ صَرْف':Subject, #27: 27	بَطَلَ الصَّرْفُ
u'بَطَلَ صلح':Subject, #27: 27	بَطَلَ الصَّرْفُ
u'بَطَلَ صُلْحٌ':Subject, #41: 41	بَطَلَ الصُّلْحُ
u'بَطَلَ صَوْمٌ':Subject, #41: 41	بَطَلَ الصُّلْحُ
u'بَطُلَ صَوْمٌ':Subject, #14: 14	بَطَلَ صَوْمُهُ
u'بَطَلَ صِيال':Subject, #1: 1	بَطُلَ صَوْمُهُ
u'بَطَلَ ضَمَانٌ':Subject, #1: 1	بَطَلَ صِيَالُهُ
u'بَطَلَ طعام':Subject, #2: 2	بَطَلَ الضَّمَانُ
u'بَطَلَ طَعَامٌ':Subject, #1: 1	بَطَلَ الطَّعَامُ
u'بَطَلَ طعام':Subject, #1: 1	بَطَلَ الطَّعَامُ
u'بَطَلَ طَعَامٌ':Subject, #1: 1	بَطَلَ طَعَامُهُ
u'بَطَلَ طَلاَقٌ':Subject, #1: 1	بَطَلَ طَعَامُهُ
u'بَطَلَ ظهار':Subject, #3: 3	بَطَلَ الطَّلَاقُ
u'بَطَلَ ظهار':Subject, #3: 3	بَطَلَ الظِّهَارُ
u'بَطَلَ ظُهْرٌ':Subject, #4: 4	بَطَلَ ظِهَارُ
u'بَطَلَ ظُهْرٌ':Subject, #1: 1	بَطَلَ ظُهْرُ
u'بَطَلَ ظُهْرٌ':Subject, #2: 2	بَطَلَ الظُّهْرُ
u'بَطَلَ عَارِضٌ':Subject, #6: 6	بَطَلَ ظُهْرُهُ
u'بَطَلَ عِبَارَةٌ':Subject, #1: 1	بَطَلَ الْعَارِضُ
u'بَطَلَ عتق':Subject, #1: 1	بَطَلَ عِبَارَتُهُ
u'بَطَلَ عِتْقٌ':Subject, #1: 1	بَطَلَ عِتْقُ
u'بَطَلَ عتق':Subject, #1: 1	بَطَلَ عِتْقُ
u'بَطَلَ عِتْقٌ':Subject, #4: 4	بَطَلَ عِتْقُهُ
u'بَطَلَ عتق':Subject, #4: 4	بَطَلَ عِتْقُهُ
u'بَطَلَ عِتْقٌ':Subject, #6: 6	بَطَلَ الْعِتْقُ
u'بَطَلَ عزل':Subject, #6: 6	بَطَلَ الْعِتْقُ
u'بَطَلَ عزل':Subject, #1: 1	بَطَلَ الْعَزْلُ
u'بَطَلَ عَفْوٌ':Subject, #2: 2	بَطَلَ عَزْلُ
u'بَطَلَ عَفْوٌ':Subject, #1: 1	بَطَلَ عَفْوُ
u'بَطَلَ عَقْدٌ':Subject, #2: 2	بَطَلَ الْعَفْوُ
u'بَطَلَ عَقْدٌ':Subject, #114: 114	بَطَلَ الْعَقْدُ
u'بَطَلَ عَمَلٌ':Subject, #2: 2	بَطَلَ عَقْدُ
u'بَطَلَ عَمَلٌ':Subject, #1: 1	بَطَلَ عَمَلُ
u'بَطَلَ عُمُومٌ':Subject, #2: 2	بَطَلَ الْعَمَلُ
u'بَطَلَ عند':Predicate, #1: 1	بَطَلَ عُمُومُ
u'بَطَلَ عَهْدٌ':Subject, #8: 8	بَطَلَ عِنْدَ
u'بَطَلَ عِوَضٌ':Subject, #1: 1	بَطَلَ الْعَهْدُ
u'بَطَلَ فَجْرٌ':Subject, #12: 12	بَطَلَ الْعِوَضُ
u'بَطَلَ فَرْضٌ':Subject, #1: 1	بَطَلَ الْفَجْرُ
u'بَطَلَ فَرْضٌ':Subject, #12: 12	بَطَلَ فَرْضُهُ
u'بَطَلَ فَرْضٌ':Subject, #2: 2	بَطَلَ الْفَرْضُ
u'بَطَلَ فرق':Subject, #9: 9	بَطَلَ فَرْضُ
u'بَطَلَ فَرْقٌ':Subject, #1: 1	بَطَلَ الْفَرْقُ
u'بَطَلَ فُرُوعٌ':Subject, #1: 1	بَطَلَ الْفَرْقُ
u'بَطَلَ فَسْخٌ':Subject, #1: 1	بَطَلَ الْفُرُوعُ
u'بَطَلَ فَضْلٌ':Subject, #3: 3	بَطَلَ الْفَسْخُ
u'بَطَلَ قَالٌ':Predicate, #3: 3	بَطَلَ الْفَضْلُ
u'بَطَلَ قَبْضٌ':Subject, #3: 3	بَطَلَ قَالَ
u'بَطَلَ قَبْضٌ':Subject, #1: 1	بَطَلَ الْقَبْضُ
u'بَطَلَ قَبُولٌ':Subject, #1: 1	بَطَلَ قَبْضُ
u'بَطَلَ قَدْرٌ':Subject, #2: 2	بَطَلَ الْقَبُولُ
u'بَطَلَ قَرْضٌ':Subject, #1: 1	بَطَلَ الْقَدْرُ
u'بَطَلَ قَسْمٌ':Subject, #1: 1	بَطَلَ الْقَرْضُ
u'بَطَلَ قصاص':Subject, #1: 1	بَطَلَ قَسْمُهُ
u'بَطَلَ قِصَاصٌ':Subject, #3: 3	بَطَلَ الْقِصَاصُ
u'بَطَلَ قَصْدٌ':Subject, #3: 3	بَطَلَ الْقِصَاصُ
u'بَطَلَ قَضَاءٌ':Subject, #1: 1	بَطَلَ قَصْدُ
u'بَطَلَ قَضَاءٌ':Subject, #1: 1	بَطَلَ قَضَاءُ
u'بَطَلَ قُعُودٌ':Subject, #4: 4	بَطَلَ الْقَضَاءُ
u'بَطَلَ قلب':Subject, #1: 1	بَطَلَ الْقُعُودُ
u'بَطَلَ قَلْبٌ':Subject, #1: 1	بَطَلَ قَلْبُهُ
u'بَطَلَ قَلْب':Subject, #1: 1	بَطَلَ قَلْبُهُ
u'بَطَلَ قَوَد':Subject, #1: 1	بَطَلَ قَلْبُهُ
u'بَطَلَ قول':Subject, #1: 1	بَطَلَ الْقَوَدُ
u'بَطَلَ قَوْلٌ':Subject, #14: 14	بَطَلَ قَوْلُهُ
u'بَطَلَ قول':Subject, #14: 14	بَطَلَ قَوْلُهُ
u'بَطَلَ قَوْلٌ':Subject, #1: 1	بَطَلَ الْقَوْلُ
u'بَطُلَ قول':Subject, #1: 1	بَطَلَ الْقَوْلُ
u'بَطُلَ قَوْلٌ':Subject, #1: 1	بَطُلَ قَوْلُهُ
u'بَطَلَ قول':Subject, #1: 1	بَطُلَ قَوْلُهُ
u'بَطَلَ قَوْلٌ':Subject, #2: 2	بَطَلَ قَوْلُ
u'بَطَلَ قِيَاسٌ':Subject, #2: 2	بَطَلَ قَوْلُ
u'بَطَلَ قِيَاسٌ':Subject, #1: 1	بَطَلَ قِيَاسُهُ
u'بَطَلَ قِيَاسٌ':Subject, #2: 2	بَطَلَ قِيَاسُ
u'بَطَلَ قيام':Subject, #4: 4	بَطَلَ الْقِيَاسُ
u'بَطَلَ قِيَامٌ':Subject, #1: 1	بَطَلَ قِيَامُهُ
u'بَطَلَ كِتَابٌ':Subject, #1: 1	بَطَلَ قِيَامُهُ
u'بَطَلَ كِتَابٌ':Subject, #1: 1	بَطَلَ كِتَابُهُ
u'بَطَلَ كَلاَمٌ':Subject, #2: 2	بَطَلَ الْكِتَابُ
u'بَطَلَ كَمَالٌ':Subject, #1: 1	بَطَلَ الْكَلَامُ
u'بَطَلَ كَوْنٌ':Subject, #1: 1	بَطَلَ الْكَمَالُ
u'بَطَلَ لبن':Subject, #6: 6	بَطَلَ كَوْنُهُ
u'بَطَلَ لَبَنٌ':Subject, #2: 2	بَطَلَ اللَّبَنُ
u'بَطَلَ لُزُومٌ':Subject, #2: 2	بَطَلَ اللَّبَنُ
u'بَطَلَ لعان':Subject, #1: 1	بَطَلَ لُزُومُهُ
u'بَطَلَ مَالٌ':Subject, #7: 7	بَطَلَ اللِّعَانُ
u'بَطَلَ مُجَرِّبٌ':Subject, #6: 6	بَطَلَ الْمَالُ
u'بَطَلَ مُخَصَّصٌ':Subject, #1: 1	بَطَلَ مُجَرِّبُ
u'بَطَلَ مَذْهَبٌ':Subject, #1: 1	بَطَلَ الْمُخَصَّصُ
u'بَطَلَ مَذْهَبٌ':Subject, #1: 1	بَطَلَ مَذْهَبُ
u'بَطَلَ مُسْتَنِدٌ':Subject, #1: 1	بَطَلَ مَذْهَبُهُ
u'بَطَلَ مَسْحٌ':Subject, #1: 1	بَطَلَ مُسْتَنِدُ
u'بَطَلَ مَسْحٌ':Subject, #3: 3	بَطَلَ مَسْحُهُ
u'بَطَلَ مُطْلَقٌ':Subject, #9: 9	بَطَلَ الْمَسْحُ
u'بَطَلَ مَفْهُومٌ':Subject, #1: 1	بَطَلَ الْمُطْلَقُ
u'بَطَلَ مَقْصُودٌ':Subject, #1: 1	بَطَلَ الْمَفْهُومُ
u'بَطَلَ مِلْكٌ':Subject, #1: 1	بَطَلَ الْمَقْصُودُ
u'بَطَلَ مِلْكٌ':Subject, #2: 2	بَطَلَ الْمِلْكُ
u'بَطَلَ مَنْزَعٌ':Subject, #2: 2	بَطَلَ مِلْكُ
u'بَطَلَ مَهْرٌ':Subject, #1: 1	بَطَلَ مَنْزَعُ
u'بَطَلَ نَدَمٌ':Subject, #1: 1	بَطَلَ الْمَهْرُ
u'بَطَلَ نذر':Subject, #1: 1	بَطَلَ النَّدَمُ
u'بَطَلَ نَذْرٌ':Subject, #2: 2	بَطَلَ نَذْرُهُ
u'بَطَلَ نذر':Subject, #2: 2	بَطَلَ نَذْرُهُ
u'بَطَلَ نَذْرٌ':Subject, #3: 3	بَطَلَ النَّذْرُ
u'بَطَلَ نَسَبٌ':Subject, #3: 3	بَطَلَ النَّذْرُ
u'بَطَلَ نِصْفٌ':Subject, #1: 1	بَطَلَ نَسَبُ
u'بَطَلَ نِصْفٌ':Subject, #3: 3	بَطَلَ النِّصْفُ
u'بَطَلَ نَصِيبٌ':Subject, #3: 3	بَطَلَ نِصْفُ
u'بَطَلَ نَصِيبٌ':Subject, #1: 1	بَطَلَ نَصِيبُ
u'بَطَلَ نَظْمٌ':Subject, #1: 1	بَطَلَ نَصِيبُهُ
u'بَطَلَ نَفْعٌ':Subject, #1: 1	بَطَلَ نَظْمُ
u'بَطَلَ نَفَلٌ':Subject, #1: 1	بَطَلَ نَفْعُهُ
u'بَطَلَ نَفْلٌ':Subject, #1: 1	بَطَلَ النَّفَلُ
u'بَطَلَ نَفْيٌ':Subject, #1: 1	بَطَلَ نَفْلُ
u'بَطَلَ نقل':Subject, #1: 1	بَطَلَ نَفْيُهُ
u'بَطَلَ نَقْلٌ':Subject, #1: 1	بَطَلَ نَقْلُهُ
u'بَطَلَ نكاح':Subject, #1: 1	بَطَلَ نَقْلُهُ
u'بَطَلَ نِكَاحٌ':Subject, #12: 12	بَطَلَ نِكَاحُ
u'بَطَلَ نكاح':Subject, #12: 12	بَطَلَ نِكَاحُ
u'بَطَلَ نِكَاحٌ':Subject, #28: 28	بَطَلَ النِّكَاحُ
u'بَطَلَ وَاجِبٌ':Subject, #28: 28	بَطَلَ النِّكَاحُ
u'بَطَلَ وَجْهٌ':Subject, #1: 1	بَطَلَ الْوَاجِبُ
u'بَطَلَ وُجُوبٌ':Subject, #1: 1	بَطَلَ وَجْهُهُ
u'بَطَلَ وَصْفٌ':Subject, #1: 1	بَطَلَ وُجُوبُ
u'بَطَلَ وَصْفٌ':Subject, #3: 3	بَطَلَ وَصْفُ
u'بَطَلَ وَصِيٌّ':Subject, #5: 5	بَطَلَ الْوَصْفُ
u'بَطَلَ وَصِيَّةٌ':Subject, #1: 1	بَطَلَ الْوَصِيَّةُ
u'بَطَلَ وُضُوءٌ':Subject, #1: 1	بَطَلَ الْوَصِيَّةُ
u'بَطَلَ وُضُوءٌ':Subject, #1: 1	بَطَلَ الْوُضُوءُ
u'بَطَلَ وَطَنٌ':Subject, #4: 4	بَطَلَ وُضُوءُهُ
u'بَطَلَ وَقْتٌ':Subject, #1: 1	بَطَلَ وَطَنُهُ
u'بَطَلَ وَقْفٌ':Subject, #1: 1	بَطَلَ الْوَقْتُ
u'بَطَلَ وَقْفٌ':Subject, #19: 19	بَطَلَ الْوَقْفُ
u'بَطَلَ وِلاَيَةٌ':Subject, #1: 1	بَطَلَ وَقْفُهُ
u'بَطَلَ وَلَهٌ':Subject, #1: 1	بَطَلَ وِلَايَةُ
u'بَطَلَ يَأْسٌ':Subject, #1: 1	بَطَلَ وَلَهُ
u'بَطَلَ يَمِينٌ':Subject, #1: 1	بَطَلَ الْيَأْسُ
u'بَطَنَ خِلاَفٌ':Subject, #2: 2	بَطَلَ الْيَمِينُ
u'بَطَنَ قَالٌ':Predicate, #1: 1	بَطَنَ خِلَافُهُ
u'بَعَثَ أَبٌ':Subject, #2: 2	بَطَنَ قَالَ
u'بَعَثَ اِبْنٌ':Predicate, #2: 2	بَعَثَ الْأَبُ
u'بَعَثَ أحَدٌ':Predicate, #5: 5	بَعَثَ ابْنَ
u'بَعَثَ اللهُ':Subject, #1: 1	بَعَثَ أَحَدَ
u'بَعَثَ أُمٌّ':Predicate, #1: 1	بَعَثَ اللهُ
u'بَعَثَ إمَامٌ':Subject, #3: 3	بَعَثَ أُمَّ
u'بَعَثَ إمَامٌ':Subject, #1: 1	بَعَثَ الإِمَامُ
u'بَعَثَ أَميرٌ':Subject, #5: 5	بَعَثَ الْإِمَامُ
u'بَعَثَ أَميرٌ':Subject, #1: 1	بَعَثَ الْأَمِيرُ
u'بَعَثَ أَمينٌ':Predicate, #2: 2	بَعَثَ أَمِيرُ
u'بَعَثَ أهْلٌ':Subject, #1: 1	بَعَثَ الْأَمِينَ
u'بَعَثَ بَائِعٌ':Subject, #3: 3	بَعَثَ أَهْلُ
u'بَعَثَ بَزَّازٌ':Subject, #1: 1	بَعَثَ الْبَائِعُ
u'بَعَثَ بِشْرٌ':Predicate, #1: 1	بَعَثَ الْبَزَّازُ
u'بَعَثَ بَقَرٌ':Predicate, #1: 1	بَعَثَ بِشْرَ
u'بَعَثَ بَقَرٌ':Predicate, #1: 1	بَعَثَ الْبَقَرَةَ
u'بَعَثَ جَارِي':Predicate, #1: 1	بَعَثَ بَقَرَةً
u'بَعَثَ جِزْيَةٌ':Predicate, #1: 1	بَعَثَ جَارِيَةً
u'بَعَثَ جُنُودٌ':Predicate, #1: 1	بَعَثَ الْجِزْيَةَ
u'بَعَثَ حاكِمٌ':Subject, #1: 1	بَعَثَ الْجُنُودَ
u'بَعَثَ حَكَمٌ':Predicate, #3: 3	بَعَثَ الْحَاكِمُ
u'بَعَثَ خَالِدٌ':Predicate, #1: 1	بَعَثَ الْحَكَمَ
u'بَعَثَ خَالِدٌ':Subject, #4: 4	بَعَثَ خَالِدَ
u'بَعَثَ خُفٌّ':Predicate, #1: 1	بَعَثَ خَالِدُ
u'بَعَثَ خَلِيفَةٌ':Subject, #1: 1	بَعَثَ الْخُفَّ
u'بَعَثَ دَرَاهِمُ':Predicate, #1: 1	بَعَثَ الْخَلِيفَةُ
u'بَعَثَ دَيْنٌ':Predicate, #1: 1	بَعَثَ دَرَاهِمَ
u'بَعَثَ رَجُلٌ':Predicate, #1: 1	بَعَثَ الدَّيْنَ
u'بَعَثَ رَجُلٌ':Subject, #7: 7	بَعَثَ رَجُلاً
u'بَعَثَ رَجُلٌ':Subject, #1: 1	بَعَثَ الرَّجُلُ
u'بَعَثَ رُسُلٌ':Predicate, #3: 3	بَعَثَ رَجُلٌ
u'بَعَثَ رَسُولٌ':Subject, #1: 1	بَعَثَ الرُّسُلَ
u'بَعَثَ زَوْجٌ':Subject, #123: 123	بَعَثَ رَسُولُ
u'بَعَثَ زَيْدٌ':Predicate, #2: 2	بَعَثَ الزَّوْجُ
u'بَعَثَ سَرِيٌّ':Predicate, #4: 4	بَعَثَ زَيْدَ
u'بَعَثَ سَرِيٌّ':Predicate, #1: 1	بَعَثَ سَرِيّةً
u'بَعَثَ سَرِيٌّ':Predicate, #40: 40	بَعَثَ سَرِيَّةً
u'بَعَثَ سَرِيَّةٌ':Predicate, #4: 4	بَعَثَ السَّرِيَّةَ
u'بَعَثَ سُعَاةٌ':Predicate, #4: 4	بَعَثَ السَّرِيَّةَ
u'بَعَثَ سَعِيدٌ':Predicate, #1: 1	بَعَثَ السُّعَاةَ
u'بَعَثَ سُلْطَانٌ':Subject, #1: 1	بَعَثَ سَعِيدَ
u'بَعَثَ شجاع':Predicate, #1: 1	بَعَثَ السُّلْطَانُ
u'بَعَثَ شجَاعٌ':Predicate, #1: 1	بَعَثَ شُجَاعَ
u'بَعَثَ صَاحِبٌ':Predicate, #1: 1	بَعَثَ شُجَاعَ
u'بَعَثَ عَامٌ':Predicate, #1: 1	بَعَثَ صَاحِبَ
u'بَعَثَ عَامِلٌ':Predicate, #1: 1	بَعَثَ عَامَ
u'بَعَثَ عَبْدٌ':Predicate, #1: 1	بَعَثَ عَامِلاً
u'بَعَثَ عَبْدٌ':Predicate, #1: 1	بَعَثَ الْعَبْدَ
u'بَعَثَ عَبْدٌ':Subject, #7: 7	بَعَثَ عَبْدَ
u'بَعَثَ عقبة':Predicate, #2: 2	بَعَثَ عَبْدُ
u'بَعَثَ عُقْبَةٌ':Predicate, #1: 1	بَعَثَ عُقْبَةَ
u'بَعَثَ عَلاءٌ':Predicate, #1: 1	بَعَثَ عُقْبَةَ
u'بَعَثَ عَلِيٌّ':Subject, #2: 2	بَعَثَ الْعَلَاءَ
u'بَعَثَ عُمَرٌ':Predicate, #2: 2	بَعَثَ عَلِيٌّ
u'بَعَثَ عُمَرٌ':Subject, #1: 1	بَعَثَ عُمَرَ
u'بَعَثَ غَائِبٌ':Subject, #9: 9	بَعَثَ عُمَرُ
u'بَعَثَ غَدٌ':Predicate, #1: 1	بَعَثَ الْغَائِبُ
u'بَعَثَ فلان':Predicate, #1: 1	بَعَثَ الْغَدَ
u'بَعَثَ فلان':Predicate, #1: 1	بَعَثَ حُذَيْفَةَ
u'بَعَثَ فلان':Predicate, #1: 1	بَعَثَ مُعَاوِيَةَ
u'بَعَثَ فلان':Subject, #5: 5	بَعَثَ عُثْمَانَ
u'بَعَثَ فلان':Subject, #1: 1	بَعَثَ زِيَادٌ
u'بَعَثَ قَيِّمٌ':Subject, #2: 2	بَعَثَ عُثْمَانُ
u'بَعَثَ كِتَابٌ':Predicate, #1: 1	بَعَثَ الْقَيِّمُ
u'بَعَثَ مُحَمَّدٌ':Predicate, #2: 2	بَعَثَ الْكِتَابَ
u'بَعَثَ مُدِيرٌ':Subject, #1: 1	بَعَثَ مُحَمَّدَ
u'بَعَثَ مُسْتَأْجِرٌ':Subject, #1: 1	بَعَثَ الْمُدِيرُ
u'بَعَثَ مُصَدِّقٌ':Predicate, #1: 1	بَعَثَ الْمُسْتَأْجِرُ
u'بَعَثَ مُعاوِيَة':Predicate, #1: 1	بَعَثَ الْمُصَدِّقِينَ
u'بَعَثَ مَمْلُوكٌ':Predicate, #1: 1	بَعَثَ مُعَاوِيَةَ
u'بَعَثَ مَهْرٌ':Predicate, #1: 1	بَعَثَ الْمَمْلُوكَ
u'بَعَثَ نَائِبٌ':Predicate, #1: 1	بَعَثَ الْمَهْرَ
u'بَعَثَ نَبِيٌّ':Predicate, #1: 1	بَعَثَ النَّائِبَ
u'بَعَثَ نَبِيٌّ':Predicate, #1: 1	بَعَثَ النَّبِيَّ
u'بَعَثَ نَبِيٌّ':Subject, #1: 1	بَعَثَ النَّبِيِّينَ
u'بَعَثَ نَبِيٌّ':Subject, #17: 17	بَعَثَ النَّبِيُّ
u'بَعَثَ نسخة':Predicate, #1: 1	بَعَثَ نَبِيُّ
u'بَعَثَ نُسْخَةٌ':Predicate, #1: 1	بَعَثَ النُّسْخَةَ
u'بَعَثَ نَوْفَلٌ':Subject, #1: 1	بَعَثَ النُّسْخَةَ
u'بَعَثَ هَدِيٌّ':Predicate, #1: 1	بَعَثَ نَوْفَلُ
u'بَعَثَ هَدْيٌ':Predicate, #2: 2	بَعَثَ هَدِيَّةً
u'بَعَثَ وَلِيدٌ':Predicate, #4: 4	بَعَثَ الْهَدْيَ
u'بَعَثَ يَوْمٌ':Predicate, #2: 2	بَعَثَ الْوَلِيدَ
u'بَعُدَ أَبٌ':Subject, #2: 2	بَعَثَ يَوْمَ
u'بَعُدَ اِحْتِمَالٌ':Subject, #1: 1	بَعُدَ الْأَبُ
u'بَعُدَ أَمَلٌ':Subject, #1: 1	بَعُدَ احْتِمَالُهُ
u'بَعُدَ بَعْضٌ':Subject, #1: 1	بَعُدَ أَمَلٌ
u'بَعُدَ بِنَاءٌ':Subject, #1: 1	بَعُدَ بَعْضُ
u'بَعُدَ تَأْخِيرٌ':Subject, #1: 1	بَعُدَ الْبِنَاءُ
u'بَعُدَ تَدْلِيس':Subject, #1: 1	بَعُدَ تَأْخِيرُ
u'بَعُدَ خِلاَفٌ':Subject, #1: 1	بَعُدَ التَّدْلِيسُ
u'بَعُدَ صَفٌّ':Subject, #2: 2	بَعُدَ خِلَافٌ
u'بَعُدَ عَهْدٌ':Subject, #2: 2	بَعُدَ الصَّفُّ
u'بَعُدَ قَارِئٌ':Subject, #3: 3	بَعُدَ عَهْدُهُ
u'بَعُدَ قمر':Subject, #1: 1	بَعُدَ الْقَارِئُ
u'بَعُدَ قَمَرٌ':Subject, #1: 1	بَعُدَ الْقَمَرُ
u'بَعُدَ قول':Subject, #1: 1	بَعُدَ الْقَمَرُ
u'بَعُدَ قَوْلٌ':Subject, #1: 1	بَعُدَ الْقَوْلُ
u'بَعُدَ لِقَاءٌ':Subject, #1: 1	بَعُدَ الْقَوْلُ
u'بَعُدَ مَالِكٌ':Subject, #1: 1	بَعُدَ اللِّقَاءُ
u'بَعُدَ مثل':Subject, #3: 3	بَعُدَ الْمَالِكُ
u'بَعُدَ مِثْلٌ':Subject, #1: 1	بَعُدَ مِثْلُهُ
u'بَعُدَ مَحَلٌّ':Subject, #1: 1	بَعُدَ مِثْلُهُ
u'بَعُدَ مَسْلَكٌ':Subject, #1: 1	بَعُدَ مَحَلُّ
u'بَعُدَ مُقْفَلٌ':Subject, #1: 1	بَعُدَ مَسْلَكُهُ
u'بَعُدَ مَكَانٌ':Subject, #1: 1	بَعُدَ الْمُقْفَلُ
u'بَعُدَ مَنْزِلٌ':Subject, #1: 1	بَعُدَ مَكَانُهُ
u'بَعُدَ مَنْزِلٌ':Subject, #1: 1	بَعُدَ مَنْزِلُ
u'بَعُدَ نَصٌّ':Predicate, #3: 3	بَعُدَ مَنْزِلُهُ
u'بَعُدَ وَضْعٌ':Subject, #1: 1	بَعُدَ نَصَّ
u'بَعُدَ يَوْمٌ':Subject, #1: 1	بَعُدَ الْوَضْعُ
u'بَغَا وَلَهٌ':Subject, #1: 1	بَعُدَ يَوْمٌ
u'بَغْتَةٌ أَجَلٌ':Added, #1: 1	بَغَا وَلَهُ
u'بُغْضٌ الْمَرْأَةُ':Added, #1: 1	بَغْتَةِ الْأَجَلِ
u'بُغْضٌ الْمَرْأَةُ':Added, #1: 1	بُغْضَ الْمَرْأَةِ
u'بُغْضٌ أنصار':Added, #1: 1	بُغْضِ الْمَرْأَةِ
u'بُغْضٌ أَنْصارٌ':Added, #2: 2	بُغْضُ الْأَنْصَارِ
u'بُغْضٌ أَنْصَارٌ':Added, #2: 2	بُغْضُ الْأَنْصَارِ
u'بُغْضٌ رِجَالٌ':Added, #2: 2	بُغْضُ الْأَنْصَارِ
u'بُغْضٌ عَلِيٌّ':Added, #1: 1	بُغْضَ رِجَالٍ
u'بُغْضٌ عَمَلٌ':Added, #1: 1	بُغْضِ عَلِيٍّ
u'بُغْضٌ قَوْمٌ':Added, #1: 1	بُغْضَ الْعَمَلِ
u'بُغْضٌ مَحْسُودٌ':Added, #1: 1	بُغْضُ قَوْمٍ
u'بُغْضٌ نَبِيٌّ':Added, #1: 1	بُغْضُ الْمَحْسُودِ
u'بُغْضٌ نَبِيٌّ':Added, #1: 1	بُغْضَ النَّبِيِّ
u'بُغْيَةٌ مُنْيَةٌ':Added, #1: 1	بُغْضِ النَّبِيِّ
u'بَغَى جَبَلٌ':Subject, #1: 1	بُغْيَةِ الْمُنْيَةِ
u'بَغَى جُرْحٌ':Subject, #2: 2	بَغَى جَبَلٌ
u'بَغَى عَلِيٌّ':Predicate, #2: 2	بَغَى الْجُرْحُ
u'بَقَرَ ذِئْبٌ':Subject, #1: 1	بَغَى عَلِيَّ
u'بَقِيَ اِبْنٌ':Subject, #3: 3	بَقَرَ الذِّئْبُ
u'بَقِيَ أثَرٌ':Subject, #1: 1	بَقِيَ ابْنُ
u'بَقِيَ أثَرٌ':Subject, #2: 2	بَقِيَ أَثَرٌ
u'بَقِيَ أثَرٌ':Subject, #5: 5	بَقِيَ أَثَرُ
u'بَقِيَ أَجْرٌ':Subject, #5: 5	بَقِيَ أَثَرُهُ
u'بَقِيَ أَجَلٌ':Subject, #1: 1	بَقِيَ الْأَجْرُ
u'بَقِيَ اِحْتِمَالٌ':Subject, #1: 1	بَقِيَ الْأَجَلُ
u'بَقِيَ اِحْتِمَالٌ':Subject, #1: 1	بَقِيَ احْتِمَالٌ
u'بَقِيَ أحَدٌ':Predicate, #1: 1	بَقِيَ احْتِمَالُ
u'بَقِيَ أحَدٌ':Subject, #2: 2	بَقِيَ أَحَدَ
u'بَقِيَ أحَدٌ':Subject, #17: 17	بَقِيَ أَحَدٌ
u'بَقِيَ إِحْرَامٌ':Subject, #3: 3	بَقِيَ أَحَدُ
u'بَقِيَ أَخٌ':Subject, #5: 5	بَقِيَ إحْرَامُهُ
u'بَقِيَ أخْذٌ':Subject, #2: 2	بَقِيَ أَخٌ
u'بَقِيَ إِخْوَةٌ':Subject, #1: 1	بَقِيَ أَخْذُ
u'بَقِيَ أَذَانٌ':Subject, #1: 1	بَقِيَ إخْوَةٌ
u'بَقِيَ أَذْرُعٌ':Predicate, #1: 1	بَقِيَ الْأَذَانُ
u'بَقِيَ إِذْنٌ':Subject, #2: 2	أَبْقَى الْأَذْرُعَ
u'بَقِيَ أَرْبَعَةٌ':Subject, #1: 1	بَقِيَ الْإِذْنُ
u'بَقِيَ أَرْغِفَةٌ':Predicate, #4: 4	بَقِيَ أَرْبَعَةٌ
u'بَقِيَ اِسْمٌ':Predicate, #1: 1	أَبْقَى الْأَرْغِفَةَ
u'بَقِيَ اِسْمٌ':Subject, #1: 1	أَبْقَى اسْمَ
u'بَقِيَ أَشَدُّ':Subject, #1: 1	بَقِيَ اسْمُ
u'بَقِيَ إِشْكالٌ':Subject, #1: 1	بَقِيَ أَشَدُّ
u'بَقِيَ إِشْكالٌ':Subject, #3: 3	بَقِيَ إشْكَالٌ
u'بَقِيَ أَشْيَاءٌ':Subject, #5: 5	بَقِيَ الْإِشْكَالُ
u'بَقِيَ أُصْبُعٌ':Subject, #1: 1	بَقِيَ أَشْيَاءُ
u'بَقِيَ أصل':Subject, #2: 2	بَقِيَ أُصْبُعٌ
u'بَقِيَ أًصْلٌ':Subject, #2: 2	بَقِيَ الْأَصْلُ
u'بَقِيَ أصل':Subject, #2: 2	بَقِيَ الْأَصْلُ
u'بَقِيَ أًصْلٌ':Subject, #7: 7	بَقِيَ أَصْلُ
u'بَقِيَ أصل':Subject, #7: 7	بَقِيَ أَصْلُ
u'بَقِيَ أًصْلٌ':Subject, #7: 7	بَقِيَ أَصْلُهُ
u'بَقِيَ اِضْطِرابٌ':Subject, #7: 7	بَقِيَ أَصْلُهُ
u'بَقِيَ اِعْتِبارٌ':Subject, #3: 3	بَقِيَ اضْطِرَابُ
u'بَقِيَ أعْرَابِيٌّ':Subject, #1: 1	بَقِيَ اعْتِبَارُ
u'بَقِيَ أَعَمُّ':Subject, #1: 1	بَقِيَ الْأَعْرَابِيُّ
u'بَقِيَ إقْرَارٌ':Subject, #1: 1	بَقِيَ الْأَعَمُّ
u'بَقِيَ أقَلُّ':Subject, #1: 1	بَقِيَ الْإِقْرَارُ
u'بَقِيَ أَكْثَرُ':Subject, #13: 13	بَقِيَ أَقَلُّ
u'بَقِيَ أَكْثَرُ':Subject, #11: 11	بَقِيَ أَكْثَرُ
u'بَقِيَ أَكْثَرُ':Subject, #2: 2	بَقِيَ أَكْثَرُهُ
u'بَقِيَ ألف':Subject, #2: 2	بَقِيَ الْأَكْثَرُ
u'بَقِيَ ألْفٌ':Subject, #1: 1	بَقِيَ الْأَلْفُ
u'بَقِيَ أَلْفٌ':Subject, #1: 1	بَقِيَ الْأَلْفُ
u'بَقِيَ ألف':Subject, #1: 1	بَقِيَ الْأَلْفُ
u'بَقِيَ ألْفٌ':Subject, #1: 1	بَقِيَ أَلْفُ
u'بَقِيَ أَلْفٌ':Subject, #1: 1	بَقِيَ أَلْفُ
u'بَقِيَ إمَاءٌ':Predicate, #1: 1	بَقِيَ أَلْفُ
u'بَقِيَ إمَامٌ':Subject, #1: 1	أَبْقَى الْإِمَاءَ
u'بَقِيَ إمَامٌ':Subject, #1: 1	بَقِيَ الْإِمَامُ
u'بَقِيَ أمَانٌ':Subject, #1: 1	بَقِيَ إمَامُهُ
u'بَقِيَ أمَانٌ':Subject, #1: 1	بَقِيَ الْأَمَانُ
u'بَقِيَ أَمْرٌ':Subject, #1: 1	بَقِيَ أَمَانُهُ
u'بَقِيَ أَمْرٌ':Subject, #11: 11	بَقِيَ الْأَمْرُ
u'بَقِيَ أَمْرٌ':Subject, #1: 1	بَقِيَ أَمْرٌ
u'بَقِيَ أَوَّلُ':Subject, #1: 1	بَقِيَ أَمْرُهُ
u'بَقِيَ إِيجَابٌ':Subject, #5: 5	بَقِيَ الْأَوَّلُ
u'بَقِيَ بَدَلٌ':Subject, #1: 1	بَقِيَ الْإِيجَابُ
u'بَقِيَ بَعْضٌ':Subject, #1: 1	بَقِيَ الْبَدَلُ
u'بَقِيَ بَعْضٌ':Subject, #12: 12	بَقِيَ بَعْضُ
u'بَقِيَ بِنَاءٌ':Subject, #3: 3	بَقِيَ بَعْضُهُ
u'بَقِيَ بَيْتٌ':Subject, #1: 1	بَقِيَ الْبِنَاءُ
u'بَقِيَ بَيْعٌ':Subject, #2: 2	بَقِيَ بَيْتٌ
u'بَقِيَ بَيْعٌ':Subject, #2: 2	بَقِيَ الْبَيْعُ
u'بَقِيَ بَيْنٌ':Predicate, #2: 2	بَقِيَ بَيْعٌ
u'بَقِيَ بَيْنٌ':Predicate, #13: 13	بَقِيَ بَيْنَ
u'بَقِيَ تَحْرِيمٌ':Subject, #2: 2	بَقِيَ بَيْنَهُنَّ
u'بَقِيَ تَحْرِيمٌ':Subject, #2: 2	بَقِيَ التَّحْرِيمُ
u'بَقِيَ تَخْصِيصٌ':Subject, #2: 2	بَقِيَ تَحْرِيمُ
u'بَقِيَ تَدْبِيرٌ':Subject, #1: 1	بَقِيَ التَّخْصِيصُ
u'بَقِيَ تَرَدُّدٌ':Subject, #1: 1	بَقِيَ تَدْبِيرُهُ
u'بَقِيَ تِسْعَةٌ':Subject, #1: 1	بَقِيَ التَّرَدُّدُ
u'بَقِيَ تَصَادُقٌ':Subject, #1: 1	بَقِيَ تِسْعَةٌ
u'بَقِيَ تَضَمُّنٌ':Subject, #1: 1	بَقِيَ تَصَادُقُ
u'بَقِيَ تَضْمِين':Subject, #1: 1	بَقِيَ التَّضَمُّنُ
u'بَقِيَ تَعْلِيقٌ':Subject, #1: 1	بَقِيَ التَّضْمِينُ
u'بَقِيَ تَعْلِيلٌ':Subject, #1: 1	بَقِيَ التَّعْلِيقُ
u'بَقِيَ تَعَمُّدٌ':Subject, #1: 1	بَقِيَ التَّعْلِيلُ
u'بَقِيَ تَفْرِيقٌ':Subject, #1: 1	بَقِيَ التَّعَمُّدُ
u'بَقِيَ تَقَوُّمٌ':Subject, #4: 4	بَقِيَ تَفْرِيقُ
u'بَقِيَ تَكْليفٌ':Subject, #1: 1	بَقِيَ التَّقَوُّمُ
u'بَقِيَ تمام':Subject, #1: 1	بَقِيَ التَّكْلِيفُ
u'بَقِيَ تَمامٌ':Subject, #2: 2	بَقِيَ تَمَامُهُ
u'بَقِيَ تَيَمُّمٌ':Subject, #2: 2	بَقِيَ تَمَامُهُ
u'بَقِيَ ثَانِي':Predicate, #2: 2	بَقِيَ تَيَمُّمُهُ
u'بَقِيَ ثَانِيَةٌ':Predicate, #2: 2	أَبْقَى الثَّانِيَةَ
u'بَقِيَ ثَلاثُ':Subject, #2: 2	أَبْقَى الثَّانِيَةَ
u'بَقِيَ ثَلاثُ':Subject, #1: 1	بَقِيَ الثَّلَاثُ
u'بَقِيَ ثَلاثَةٌ':Subject, #1: 1	بَقِيَ ثَلَاثُ
u'بَقِيَ ثَلاثَةٌ':Subject, #5: 5	بَقِيَ ثَلَاثَةُ
u'بَقِيَ ثَمانِيَةٌ':Subject, #6: 6	بَقِيَ ثَلَاثَةٌ
u'بَقِيَ ثَمانِيَةٌ':Subject, #1: 1	بَقِيَ ثَمَانِيَةٌ
u'بَقِيَ ثَمَنٌ':Subject, #1: 1	بَقِيَ ثَمَانِيَةُ
u'بَقِيَ ثَوْبٌ':Subject, #4: 4	بَقِيَ الثَّمَنُ
u'بَقِيَ جَازٌ':Predicate, #4: 4	بَقِيَ الثَّوْبُ
u'بَقِيَ جَانِبٌ':Subject, #2: 2	بَقِيَ جَازَ
u'بَقِيَ جِدال':Subject, #1: 1	بَقِيَ الْجَانِبُ
u'بَقِيَ جَرْيٌ':Subject, #1: 1	بَقِيَ الْجِدَالُ
u'بَقِيَ جُزْءٌ':Subject, #2: 2	بَقِيَ جَرْيُ
u'بَقِيَ جهاد':Subject, #2: 2	بَقِيَ جُزْءٌ
u'بَقِيَ جِهَادٌ':Subject, #1: 1	بَقِيَ الْجِهَادُ
u'بَقِيَ جَوَازٌ':Subject, #1: 1	بَقِيَ الْجِهَادُ
u'بَقِيَ جَوَازٌ':Subject, #1: 1	بَقِيَ جَوَازُ
u'بَقِيَ حَجٌّ':Subject, #3: 3	بَقِيَ الْجَوَازُ
u'بَقِيَ حَديثٌ':Predicate, #1: 1	بَقِيَ الْحَجُّ
u'بَقِيَ حِصَّةٌ':Predicate, #1: 1	بَقِيَ الْحَدِيثَ
u'بَقِيَ حَظٌّ':Subject, #1: 1	بَقِيَ حِصَّةَ
u'بَقِيَ حَقٌّ':Subject, #1: 1	بَقِيَ حَظُّهُ
u'بَقِيَ حَقٌّ':Subject, #11: 11	بَقِيَ حَقُّ
u'بَقِيَ حَقٌّ':Subject, #1: 1	بَقِيَ الْحَقُّ
u'بَقِيَ حُكْمٌ':Subject, #4: 4	بَقِيَ حَقُّهُ
u'بَقِيَ حُكْمٌ':Subject, #16: 16	بَقِيَ حُكْمُ
u'بَقِيَ حُكْمٌ':Subject, #1: 1	بَقِيَ حُكْمُهُ
u'بَقِيَ حُكُومَةٌ':Subject, #6: 6	بَقِيَ الْحُكْمُ
u'بَقِيَ حِلٌّ':Subject, #2: 2	بَقِيَ حُكُومَةُ
u'بَقِيَ حِلٌّ':Subject, #1: 1	بَقِيَ الْحِلُّ
u'بَقِيَ حَلاَوَةٌ':Predicate, #1: 1	بَقِيَ حِلُّ
u'بَقِيَ حَمْلٌ':Subject, #1: 1	أَبْقَى حَلَاوَةَ
u'بَقِيَ حول':Subject, #1: 1	بَقِيَ الْحَمْلُ
u'بَقِيَ حَوْلٌ':Subject, #1: 1	بَقِيَ الْحَوْلُ
u'بَقِيَ حول':Subject, #1: 1	بَقِيَ الْحَوْلُ
u'بَقِيَ حَوْلٌ':Subject, #1: 1	بَقِيَ حَوْلُ
u'بَقِيَ حَيَاةٌ':Subject, #1: 1	بَقِيَ حَوْلُ
u'بَقِيَ حَيْضٌ':Subject, #1: 1	بَقِيَ حَيَاةٌ
u'بَقِيَ خِبَاءٌ':Subject, #1: 1	بَقِيَ حَيْضٌ
u'بَقِيَ خراج':Subject, #1: 1	بَقِيَ خِبَاءٌ
u'بَقِيَ خَرَاجٌ':Subject, #1: 1	بَقِيَ الْخَرَاجُ
u'بَقِيَ خَطٌّ':Subject, #1: 1	بَقِيَ الْخَرَاجُ
u'بَقِيَ خُطُوطٌ':Subject, #2: 2	بَقِيَ خَطُّهُ
u'بَقِيَ خِلاَفٌ':Subject, #1: 1	بَقِيَ خُطُوطُ
u'بَقِيَ خُلْعٌ':Subject, #1: 1	بَقِيَ الْخِلَافُ
u'بَقِيَ خَمْسٌ':Subject, #1: 1	بَقِيَ الْخُلْعُ
u'بَقِيَ خُمُسٌ':Subject, #1: 1	بَقِيَ خَمْسُ
u'بَقِيَ خَمْسَةٌ':Predicate, #1: 1	بَقِيَ خُمُسُ
u'بَقِيَ خَمْسَةٌ':Predicate, #1: 1	أَبْقَى الْخَمْسَةَ
u'بَقِيَ خَمْسَةٌ':Subject, #1: 1	بَقِيَ خَمْسَةَ
u'بَقِيَ خَمْسَةٌ':Subject, #10: 10	بَقِيَ خَمْسَةٌ
u'بَقِيَ خيار':Subject, #1: 1	بَقِيَ خَمْسَةُ
u'بَقِيَ خِيَارٌ':Subject, #2: 2	بَقِيَ الْخِيَارُ
u'بَقِيَ خيار':Subject, #2: 2	بَقِيَ الْخِيَارُ
u'بَقِيَ خِيَارٌ':Subject, #4: 4	بَقِيَ خِيَارُ
u'بَقِيَ خيار':Subject, #4: 4	بَقِيَ خِيَارُ
u'بَقِيَ خِيَارٌ':Subject, #8: 8	بَقِيَ خِيَارُهُ
u'بَقِيَ دَارٌ':Subject, #8: 8	بَقِيَ خِيَارُهُ
u'بَقِيَ دِرْهَمٌ':Subject, #1: 1	بَقِيَ الدَّارُ
u'بَقِيَ دِرْهَم':Subject, #3: 3	بَقِيَ دِرْهَمٌ
u'بَقِيَ دَهْرٌ':Subject, #3: 3	بَقِيَ دِرْهَمٌ
u'بَقِيَ دونٌ':Predicate, #1: 1	بَقِيَ الدَّهْرُ
u'بَقِيَ دِيَةٌ':Subject, #8: 8	بَقِيَ دُونَ
u'بَقِيَ دِينٌ':Subject, #4: 4	بَقِيَ الدِّيَةُ
u'بَقِيَ دَيْنٌ':Subject, #1: 1	بَقِيَ دِينُ
u'بَقِيَ ذكر':Subject, #6: 6	بَقِيَ الدَّيْنُ
u'بَقِيَ ذِكْرٌ':Subject, #1: 1	بَقِيَ ذِكْرُ
u'بَقِيَ رَأْسٌ':Predicate, #1: 1	بَقِيَ ذِكْرُ
u'بَقِيَ رَأْسٌ':Subject, #2: 2	بَقِيَ رَأْسَ
u'بَقِيَ رِبْحٌ':Subject, #2: 2	بَقِيَ رَأْسُ
u'بَقِيَ رَسْمٌ':Subject, #1: 1	بَقِيَ رِبْحٌ
u'بَقِيَ رَسُولٌ':Subject, #1: 1	بَقِيَ رَسْمُهُ
u'بَقِيَ رِقٌّ':Subject, #1: 1	بَقِيَ رَسُولُ
u'بَقِيَ رِقٌّ':Subject, #2: 2	بَقِيَ الرِّقُّ
u'بَقِيَ رُكْنٌ':Subject, #2: 2	بَقِيَ رِقُّهُ
u'بَقِيَ رُكْن':Subject, #1: 1	بَقِيَ الرُّكْنُ
u'بَقِيَ رُمْحٌ':Subject, #1: 1	بَقِيَ الرُّكْنُ
u'بَقِيَ رَهْنٌ':Subject, #2: 2	بَقِيَ الرُّمْحُ
u'بَقِيَ روحٌ':Subject, #2: 2	بَقِيَ الرَّهْنُ
u'بَقِيَ ريحٌ':Subject, #1: 1	بَقِيَ رُوحُهُ
u'بَقِيَ زَرْعٌ':Subject, #1: 1	بَقِيَ الرِّيحُ
u'بَقِيَ زَمانٌ':Subject, #1: 1	بَقِيَ الزَّرْعُ
u'بَقِيَ زَمَنٌ':Subject, #1: 1	بَقِيَ زَمَانُ
u'بَقِيَ زَوْجٌ':Subject, #4: 4	بَقِيَ زَمَنٌ
u'بَقِيَ سَائِرٌ':Subject, #1: 1	بَقِيَ الزَّوْجُ
u'بَقِيَ سَبَبٌ':Subject, #1: 1	بَقِيَ سَائِرُ
u'بَقِيَ سَبْعٌ':Subject, #1: 1	بَقِيَ سَبَبٌ
u'بَقِيَ سَبْعَةٌ':Predicate, #2: 2	بَقِيَ سَبْعٌ
u'بَقِيَ سَبْعَةٌ':Subject, #1: 1	بَقِيَ سَبْعَةَ
u'بَقِيَ سِتٌّ':Subject, #2: 2	بَقِيَ سَبْعَةٌ
u'بَقِيَ سِتٌّ':Subject, #2: 2	بَقِيَ سِتَّةٌ
u'بَقِيَ سعر':Subject, #2: 2	بَقِيَ سِتَّةُ
u'بَقِيَ سِعْرٌ':Subject, #1: 1	بَقِيَ السِّعْرُ
u'بَقِيَ سَلَمٌ':Subject, #1: 1	بَقِيَ السِّعْرُ
u'بَقِيَ سِنْخ':Subject, #1: 1	بَقِيَ السَّلَمُ
u'بَقِيَ سَهْمٌ':Subject, #1: 1	بَقِيَ السِّنْخُ
u'بَقِيَ سَهْمٌ':Subject, #1: 1	بَقِيَ السَّهْمُ
u'بَقِيَ سَهْمٌ':Subject, #2: 2	بَقِيَ سَهْمُ
u'بَقِيَ سَوْطٌ':Subject, #4: 4	بَقِيَ سَهْمٌ
u'بَقِيَ شَامِلٌ':Subject, #1: 1	بَقِيَ سَوْطٌ
u'بَقِيَ شَأْنٌ':Subject, #1: 1	بَقِيَ شَامِلٌ
u'بَقِيَ شَجَرٌ':Subject, #4: 4	بَقِيَ الشَّأْنُ
u'بَقِيَ شَرَابٌ':Subject, #1: 1	بَقِيَ الشَّجَرُ
u'بَقِيَ شَرْطٌ':Subject, #4: 4	بَقِيَ شَرَابٌ
u'بَقِيَ شَرْطٌ':Subject, #1: 1	بَقِيَ الشَّرْطُ
u'بَقِيَ شُعاعٌ':Subject, #2: 2	بَقِيَ شَرْطُهُ
u'بَقِيَ شُعَاعٌ':Subject, #1: 1	بَقِيَ الشُّعَاعُ
u'بَقِيَ شَهَادَةٌ':Subject, #1: 1	بَقِيَ الشُّعَاعُ
u'بَقِيَ شَيْءٌ':Subject, #1: 1	بَقِيَ شَهَادَةُ
u'بَقِيَ شَيْءٌ':Subject, #1: 1	بَقِيَ الشَّيْءُ
u'بَقِيَ صَاحِبٌ':Subject, #89: 89	بَقِيَ شَيْءٌ
u'بَقِيَ صَاعٌ':Subject, #1: 1	بَقِيَ صَاحِبُ
u'بَقِيَ صُبْحٌ':Predicate, #5: 5	بَقِيَ صَاعٌ
u'بَقِيَ صدق':Subject, #1: 1	أَبْقَى صُبْحَ
u'بَقِيَ صِدْقٌ':Subject, #1: 1	بَقِيَ صِدْقُ
u'بَقِيَ صَرْفٌ':Subject, #1: 1	بَقِيَ صِدْقُ
u'بَقِيَ صَرْف':Subject, #1: 1	بَقِيَ الصَّرْفُ
u'بَقِيَ صِفَةٌ':Subject, #1: 1	بَقِيَ الصَّرْفُ
u'بَقِيَ صلح':Subject, #1: 1	بَقِيَ صِفَةُ
u'بَقِيَ صُلْحٌ':Subject, #3: 3	بَقِيَ الصُّلْحُ
u'بَقِيَ صِيَامٌ':Subject, #3: 3	بَقِيَ الصُّلْحُ
u'بَقِيَ ضَرَرٌ':Subject, #1: 1	بَقِيَ صِيَامُهُ
u'بَقِيَ ضَمَانٌ':Subject, #1: 1	بَقِيَ الضَّرَرُ
u'بَقِيَ ضَمِنٌ':Predicate, #1: 1	بَقِيَ ضَمَانُ
u'بَقِيَ طرف':Subject, #1: 1	بَقِيَ ضَمِنَ
u'بَقِيَ طَرَفٌ':Subject, #1: 1	بَقِيَ طَرَفُهُ
u'بَقِيَ طَرِيقٌ':Predicate, #1: 1	بَقِيَ طَرَفُهُ
u'بَقِيَ طَلاَقٌ':Subject, #3: 3	أَبْقَى الطَّرِيقَ
u'بَقِيَ طلب':Subject, #1: 1	بَقِيَ الطَّلَاقُ
u'بَقِيَ طَلَبٌ':Subject, #1: 1	بَقِيَ طَلَبُ
u'بَقِيَ طهر':Subject, #1: 1	بَقِيَ طَلَبُ
u'بَقِيَ طُهْرٌ':Subject, #1: 1	بَقِيَ طُهْرُهُ
u'بَقِيَ طهر':Subject, #1: 1	بَقِيَ طُهْرُهُ
u'بَقِيَ طُهْرٌ':Subject, #2: 2	بَقِيَ الطُّهْرُ
u'بَقِيَ طواف':Subject, #2: 2	بَقِيَ الطُّهْرُ
u'بَقِيَ طَوَافٌ':Subject, #1: 1	بَقِيَ الطَّوَافُ
u'بَقِيَ طُولٌ':Predicate, #1: 1	بَقِيَ الطَّوَافُ
u'بَقِيَ طَيْرٌ':Subject, #1: 1	بَقِيَ طُولَ
u'بَقِيَ ظهار':Subject, #1: 1	بَقِيَ الطَّيْرُ
u'بَقِيَ ظهار':Subject, #1: 1	بَقِيَ الظِّهَارُ
u'بَقِيَ عَادٌ':Predicate, #2: 2	بَقِيَ ظِهَارُهُ
u'بَقِيَ عَاشِرٌ':Subject, #2: 2	بَقِيَ عَادَ
u'بَقِيَ ُعَاشِرٌ':Subject, #1: 1	بَقِيَ عَاشِرُ
u'بَقِيَ عَبْدٌ':Subject, #1: 1	بَقِيَ عَاشِرُ
u'بَقِيَ عتق':Subject, #5: 5	بَقِيَ الْعَبْدُ
u'بَقِيَ عِتْقٌ':Subject, #1: 1	بَقِيَ الْعِتْقُ
u'بَقِيَ عَدَدٌ':Subject, #1: 1	بَقِيَ الْعِتْقُ
u'بَقِيَ عَدَدٌ':Subject, #1: 1	بَقِيَ عَدَدٌ
u'بَقِيَ عَدَمٌ':Subject, #3: 3	بَقِيَ الْعَدَدُ
u'بَقِيَ عَشْرٌ':Subject, #1: 1	بَقِيَ عَدَمُ
u'بَقِيَ عِشْرُون':Predicate, #2: 2	بَقِيَ عَشْرُ
u'بَقِيَ عَصْرٌ':Subject, #1: 1	بَقِيَ عِشْرُونَ
u'بَقِيَ عَصِيرٌ':Subject, #1: 1	بَقِيَ الْعَصْرُ
u'بَقِيَ عُضْوٌ':Subject, #1: 1	بَقِيَ الْعَصِيرُ
u'بَقِيَ عَقْدٌ':Subject, #3: 3	بَقِيَ عُضْوٌ
u'بَقِيَ عَقْدٌ':Subject, #15: 15	بَقِيَ الْعَقْدُ
u'بَقِيَ عقدة':Subject, #3: 3	بَقِيَ عَقْدُ
u'بَقِيَ عُقْدَةٌ':Subject, #1: 1	بَقِيَ عُقْدَةُ
u'بَقِيَ عِلَّةٌ':Subject, #1: 1	بَقِيَ عُقْدَةُ
u'بَقِيَ عَمَلٌ':Subject, #1: 1	بَقِيَ الْعِلَّةُ
u'بَقِيَ عَمَلٌ':Subject, #2: 2	بَقِيَ الْعَمَلُ
u'بَقِيَ عُمُومٌ':Subject, #3: 3	بَقِيَ عَمَلُ
u'بَقِيَ عند':Predicate, #4: 4	بَقِيَ الْعُمُومُ
u'بَقِيَ عَهْدٌ':Subject, #12: 12	بَقِيَ عِنْدَ
u'بَقِيَ عِوَضٌ':Subject, #2: 2	بَقِيَ عَهْدُهُ
u'بَقِيَ عين':Predicate, #1: 1	بَقِيَ الْعِوَضُ
u'بَقِيَ عَيْنٌ':Predicate, #1: 1	أَبْقَى الْعَيْنَ
u'بَقِيَ عَيْن':Predicate, #1: 1	أَبْقَى الْعَيْنَ
u'بَقَّى عين':Predicate, #1: 1	أَبْقَى الْعَيْنَ
u'بَقَّى عَيْنٌ':Predicate, #1: 1	بَقَّى الْعَيْنَ
u'بَقَّى عَيْن':Predicate, #1: 1	بَقَّى الْعَيْنَ
u'بَقِيَ عين':Subject, #1: 1	بَقَّى الْعَيْنَ
u'بَقِيَ عَيْنٌ':Subject, #1: 1	بَقِيَ عَيْنُ
u'بَقِيَ عَيْن':Subject, #1: 1	بَقِيَ عَيْنُ
u'بَقِيَ عين':Subject, #1: 1	بَقِيَ عَيْنُ
u'بَقِيَ عَيْنٌ':Subject, #1: 1	بَقِيَ عَيْنُهُ
u'بَقِيَ عَيْن':Subject, #1: 1	بَقِيَ عَيْنُهُ
u'بَقِيَ عين':Subject, #1: 1	بَقِيَ عَيْنُهُ
u'بَقِيَ عَيْنٌ':Subject, #2: 2	بَقِيَ الْعَيْنُ
u'بَقِيَ عَيْن':Subject, #2: 2	بَقِيَ الْعَيْنُ
u'بَقِيَ غَسْلٌ':Subject, #2: 2	بَقِيَ الْعَيْنُ
u'بَقِيَ غفر':Predicate, #1: 1	بَقِيَ غَسْلُ
u'بَقِيَ غَنَمٌ':Subject, #1: 1	بَقِيَ غُفِرَ
u'بَقِيَ غَنِيٌّ':Subject, #1: 1	بَقِيَ الْغَنَمُ
u'بَقِيَ غير':Predicate, #1: 1	بَقِيَ الْغَنِيُّ
u'بَقِيَ غَيْرٌ':Predicate, #1: 1	بَقِيَ غَيْرَ
u'بَقِيَ غير':Subject, #1: 1	بَقِيَ غَيْرَ
u'بَقِيَ غَيْرٌ':Subject, #1: 1	بَقِيَ غَيْرُ
u'بَقِيَ غير':Subject, #1: 1	بَقِيَ غَيْرُ
u'بَقِيَ غَيْرٌ':Subject, #2: 2	بَقِيَ غَيْرُهُ
u'بَقِيَ فَائِدَةٌ':Subject, #2: 2	بَقِيَ غَيْرُهُ
u'بَقِيَ فَرَسٌ':Subject, #1: 1	بَقِيَ فَائِدَةُ
u'بَقِيَ فَرْضٌ':Subject, #3: 3	بَقِيَ فَرَسُهُ
u'بَقِيَ فَضْلٌ':Subject, #1: 1	بَقِيَ الْفَرْضُ
u'بَقِيَ فِعْلٌ':Subject, #3: 3	بَقِيَ فَضْلٌ
u'بَقِيَ فِعْلٌ':Subject, #1: 1	بَقِيَ فِعْلُهُ
u'بَقِيَ فُلاَنٌ':Subject, #4: 4	بَقِيَ الْفِعْلُ
u'بَقِيَ قَالٌ':Predicate, #1: 1	بَقِيَ فُلَانٌ
u'بَقِيَ قَبْضٌ':Subject, #2: 2	بَقِيَ قَالَ
u'بَقِيَ قَدْرٌ':Predicate, #1: 1	بَقِيَ الْقَبْضُ
u'بَقِيَ قَدْرٌ':Subject, #1: 1	أَبْقَى قَدْرَ
u'بَقِيَ قرار':Subject, #10: 10	بَقِيَ قَدْرُ
u'بَقِيَ قَرَارٌ':Subject, #1: 1	بَقِيَ قَرَارُهُ
u'بَقِيَ قِسْمٌ':Subject, #1: 1	بَقِيَ قَرَارُهُ
u'بَقِيَ قعدة':Predicate, #4: 4	بَقِيَ قِسْمٌ
u'بَقِيَ قَعْدَةٌ':Predicate, #2: 2	بَقِيَ الْقَعْدَةَ
u'بَقِيَ قَلِيلٌ':Subject, #2: 2	بَقِيَ الْقَعْدَةَ
u'بَقِيَ قُمَاشٌ':Subject, #1: 1	بَقِيَ الْقَلِيلُ
u'بَقِيَ قَوَد':Subject, #4: 4	بَقِيَ قُمَاشُهُ
u'بَقِيَ قول':Subject, #1: 1	بَقِيَ الْقَوَدُ
u'بَقِيَ قَوْلٌ':Subject, #1: 1	بَقِيَ قَوْلُ
u'بَقِيَ قول':Subject, #1: 1	بَقِيَ قَوْلُ
u'بَقِيَ قَوْلٌ':Subject, #4: 4	بَقِيَ قَوْلُهُ
u'بَقِيَ قيام':Subject, #4: 4	بَقِيَ قَوْلُهُ
u'بَقِيَ قِيَامٌ':Subject, #1: 1	بَقِيَ الْقِيَامُ
u'بَقِيَ قَيْدٌ':Subject, #1: 1	بَقِيَ الْقِيَامُ
u'بَقِيَ قِيمَةٌ':Subject, #2: 2	بَقِيَ الْقَيْدُ
u'بَقِيَ قِيمَةٌ':Subject, #1: 1	بَقِيَ قِيمَةٌ
u'بَقِيَ كُتُبٌ':Predicate, #1: 1	بَقِيَ قِيمَةُ
u'بَقِيَ كِرَاءٌ':Subject, #2: 2	أَبْقَى الْكُتُبَ
u'بَقِيَ كرام':Subject, #2: 2	بَقِيَ كِرَاءُ
u'بَقِيَ كَفِيلٌ':Subject, #1: 1	بَقِيَ الْكِرَامُ
u'بَقِيَ كَلاَمٌ':Predicate, #1: 1	بَقِيَ الْكَفِيلُ
u'بَقِيَ كَلاَمٌ':Subject, #1: 1	أَبْقَى كَلَامَ
u'بَقِيَ كَمَالٌ':Subject, #15: 15	بَقِيَ الْكَلَامُ
u'بَقِيَ كَوْنٌ':Subject, #1: 1	بَقِيَ كَمَالُ
u'بَقِيَ كَيْفِيَّةٌ':Subject, #2: 2	بَقِيَ كَوْنُهُ
u'بَقِيَ لِحَاءٌ':Subject, #1: 1	بَقِيَ كَيْفِيَّةُ
u'بَقِيَ لَحْمٌ':Subject, #2: 2	بَقِيَ اللِّحَاءُ
u'بَقِيَ لعان':Subject, #1: 1	بَقِيَ لَحْمٌ
u'بَقِيَ لَفْظٌ':Subject, #2: 2	بَقِيَ اللِّعَانُ
u'بَقِيَ لَفْظٌ':Subject, #2: 2	بَقِيَ اللَّفْظُ
u'بَقِيَ لمعة':Subject, #3: 3	بَقِيَ لَفْظُ
u'بَقِيَ لَوْنٌ':Subject, #1: 1	بَقِيَ لُمْعَةٌ
u'بَقِيَ لَوْنٌ':Subject, #1: 1	بَقِيَ لَوْنٌ
u'بَقِيَ لَوْنٌ':Subject, #2: 2	بَقِيَ اللَّوْنُ
u'بَقِيَ لَيْلٌ':Subject, #2: 2	بَقِيَ لَوْنُ
u'بَقِيَ لِينٌ':Subject, #1: 1	بَقِيَ اللَّيْلُ
u'بَقِيَ مَالٌ':Subject, #1: 1	بَقِيَ لِينُهُ
u'بَقِيَ مَالٌ':Subject, #1: 1	بَقِيَ مَالُ
u'بَقِيَ مَالٌ':Subject, #2: 2	بَقِيَ مَالُهُ
u'بَقِيَ مَأْمُورٌ':Subject, #5: 5	بَقِيَ الْمَالُ
u'بَقِيَ مَبِيعٌ':Subject, #1: 1	بَقِيَ الْمَأْمُورُ
u'بَقِيَ مَتَاعٌ':Subject, #1: 1	بَقِيَ الْمَبِيعُ
u'بَقِيَ مَتْرُوكٌ':Subject, #1: 1	بَقِيَ مَتَاعُهُ
u'بَقِيَ مُتَعَذِّرٌ':Subject, #1: 1	بَقِيَ مَتْرُوكٌ
u'بَقِيَ مُتَمِّمٌ':Subject, #1: 1	بَقِيَ مُتَعَذِّرٌ
u'بَقِيَ مثل':Subject, #1: 1	بَقِيَ مُتَمِّمُ
u'بَقِيَ مِثْلٌ':Subject, #1: 1	بَقِيَ مِثْلُ
u'بَقِيَ مثل':Subject, #1: 1	بَقِيَ مِثْلُ
u'بَقِيَ مِثْلٌ':Subject, #2: 2	بَقِيَ مِثْلُهُ
u'بَقِيَ مَجَازٌ':Subject, #2: 2	بَقِيَ مِثْلُهُ
u'بَقِيَ مُجْتَهِد':Subject, #1: 1	بَقِيَ الْمَجَازُ
u'بَقِيَ مُجَرَّدٌ':Subject, #1: 1	بَقِيَ مُجْتَهِدٌ
u'بَقِيَ مَجْمُوعٌ':Subject, #10: 10	بَقِيَ مُجَرَّدُ
u'بَقِيَ مَحَلٌّ':Subject, #1: 1	بَقِيَ الْمَجْمُوعُ
u'بَقِيَ مرٌّ':Predicate, #2: 2	بَقِيَ الْمَحَلُّ
u'بَقِيَ مَرَضٌ':Subject, #2: 2	بَقِيَ مَرَّةً
u'بَقِيَ مَرِيضٌ':Subject, #1: 1	بَقِيَ مَرَضٌ
u'بَقِيَ مَسَافَةٌ':Predicate, #2: 2	بَقِيَ الْمَرِيضُ
u'بَقِيَ مَسَافَةٌ':Subject, #1: 1	بَقِيَ مَسَافَةَ
u'بَقِيَ مُسْتَحَقٌّ':Predicate, #2: 2	بَقِيَ مَسَافَةُ
u'بَقِيَ مُسْتَحِقٌّ':Subject, #1: 1	بَقِيَ مُسْتَحَقَّ
u'بَقِيَ مُسْتَعِيرٌ':Subject, #1: 1	بَقِيَ الْمُسْتَحِقُّ
u'بَقِيَ مُشْتَبَهٌ':Subject, #2: 2	بَقِيَ الْمُسْتَعِيرُ
u'بَقِيَ مُطْلَقٌ':Subject, #1: 1	بَقِيَ الْمُشْتَبَهُ
u'بَقِيَ مَعْرِفَةٌ':Subject, #2: 2	بَقِيَ مُطْلَقُ
u'بَقِيَ مَعْرِفَة':Subject, #1: 1	بَقِيَ مَعْرِفَةُ
u'بَقِيَ مُعَلَّقٌ':Subject, #1: 1	بَقِيَ مَعْرِفَةُ
u'بَقِيَ مَقْبُوضٌ':Subject, #1: 1	بَقِيَ الْمُعَلَّقُ
u'بَقِيَ مِقْدَارٌ':Subject, #1: 1	بَقِيَ الْمَقْبُوضُ
u'بَقِيَ مَكَانٌ':Subject, #8: 8	بَقِيَ مِقْدَارُ
u'بَقِيَ مِلْكٌ':Subject, #2: 2	بَقِيَ مَكَانُ
u'بَقِيَ مِلْكٌ':Subject, #1: 1	بَقِيَ الْمِلْكُ
u'بَقِيَ مَهْرٌ':Subject, #7: 7	بَقِيَ مِلْكُهُ
u'بَقِيَ مُؤَجَّلٌ':Subject, #1: 1	بَقِيَ مَهْرٌ
u'بَقِيَ مَوْضِعٌ':Subject, #1: 1	بَقِيَ مُؤَجَّلُهُ
u'بَقِيَ مَوْهُوبٌ':Subject, #1: 1	بَقِيَ مَوْضِعُ
u'بَقِيَ مِيرَاثٌ':Subject, #1: 1	بَقِيَ الْمَوْهُوبُ
u'بَقِيَ مِيزَانٌ':Subject, #7: 7	بَقِيَ مِيرَاثٌ
u'بَقِيَ نَاسٌ':Subject, #1: 1	بَقِيَ الْمِيزَانُ
u'بَقِيَ نُجُومٌ':Subject, #2: 2	بَقِيَ النَّاسُ
u'بَقِيَ نَحْوٌ':Subject, #1: 1	بَقِيَ النُّجُومُ
u'بَقِيَ نزاع':Subject, #1: 1	بَقِيَ نَحْوٌ
u'بَقِيَ نِزَاعٌ':Subject, #1: 1	بَقِيَ النِّزَاعُ
u'بَقِيَ نَصٌّ':Predicate, #1: 1	بَقِيَ النِّزَاعُ
u'بَقِيَ نصاب':Predicate, #1: 1	بَقِيَ نَصَّ
u'بَقِيَ نِصَابٌ':Predicate, #1: 1	أَبْقَى النِّصَابَ
u'بَقِيَ نصاب':Subject, #1: 1	أَبْقَى النِّصَابَ
u'بَقِيَ نِصَابٌ':Subject, #1: 1	بَقِيَ النِّصَابُ
u'بَقِيَ نصاب':Subject, #1: 1	بَقِيَ النِّصَابُ
u'بَقِيَ نِصَابٌ':Subject, #1: 1	بَقِيَ نِصَابٌ
u'بَقِيَ نِصْفٌ':Predicate, #1: 1	بَقِيَ نِصَابٌ
u'بَقِيَ نِصْفٌ':Subject, #1: 1	أَبْقَى نِصْفَ
u'بَقِيَ نِصْفٌ':Subject, #3: 3	بَقِيَ نِصْفُهُ
u'بَقِيَ نِصْفٌ':Subject, #4: 4	بَقِيَ نِصْفُ
u'بَقِيَ نَصْلٌ':Subject, #8: 8	بَقِيَ النِّصْفُ
u'بَقِيَ نَصِيبٌ':Subject, #1: 1	بَقِيَ النَّصْلُ
u'بَقِيَ نَظَرٌ':Subject, #5: 5	بَقِيَ نَصِيبُهُ
u'بَقِيَ نَظَرٌ':Subject, #1: 1	بَقِيَ نَظَرُ
u'بَقِيَ نَقْبٌ':Subject, #2: 2	بَقِيَ النَّظَرُ
u'بَقِيَ نَقْصٌ':Subject, #1: 1	بَقِيَ نَقْبُهُ
u'بَقِيَ نكاح':Subject, #1: 1	بَقِيَ نَقْصٌ
u'بَقِيَ نِكَاحٌ':Subject, #16: 16	بَقِيَ النِّكَاحُ
u'بَقِيَ نكاح':Subject, #16: 16	بَقِيَ النِّكَاحُ
u'بَقِيَ نِكَاحٌ':Subject, #1: 1	بَقِيَ نِكَاحُ
u'بَقِيَ نكاح':Subject, #1: 1	بَقِيَ نِكَاحُ
u'بَقِيَ نِكَاحٌ':Subject, #2: 2	بَقِيَ نِكَاحُهُ
u'بَقِيَ هَدْيٌ':Subject, #2: 2	بَقِيَ نِكَاحُهُ
u'بَقِيَ وَاجِبٌ':Subject, #1: 1	بَقِيَ الْهَدْيُ
u'بَقِيَ واحد':Subject, #3: 3	بَقِيَ الْوَاجِبُ
u'بَقِيَ وَاحِدٌ':Subject, #10: 10	بَقِيَ وَاحِدٌ
u'بَقِيَ واحد':Subject, #10: 10	بَقِيَ وَاحِدٌ
u'بَقِيَ وَاحِدٌ':Subject, #1: 1	بَقِيَ وَاحِدَةٌ
u'بَقِيَ وَارِدٌ':Subject, #1: 1	بَقِيَ وَاحِدَةٌ
u'بَقِيَ وَتَدٌ':Subject, #1: 1	بَقِيَ وَارِدٌ
u'بَقِيَ وَجَبٌ':Predicate, #1: 1	بَقِيَ وَتَدٌ
u'بَقِيَ وَجْهٌ':Subject, #4: 4	بَقِيَ وَجَبَ
u'بَقِيَ وَجْهٌ':Subject, #1: 1	بَقِيَ وَجْهٌ
u'بَقِيَ وُجُوبٌ':Subject, #1: 1	بَقِيَ وَجْهُ
u'بَقِيَ وَزْنٌ':Subject, #1: 1	بَقِيَ الْوُجُوبُ
u'بَقِيَ وَصْفٌ':Subject, #1: 1	بَقِيَ الْوَزْنُ
u'بَقِيَ وَصْفٌ':Subject, #1: 1	بَقِيَ الْوَصْفُ
u'بَقِيَ وَصِيٌّ':Predicate, #1: 1	بَقِيَ وَصْفٌ
u'بَقِيَ وُضُوءٌ':Subject, #1: 1	بَقِيَ وَصِيَّةً
u'بَقِيَ وَفَاءٌ':Subject, #2: 2	بَقِيَ وُضُوءُهُ
u'بَقِيَ وَقْتٌ':Subject, #1: 1	بَقِيَ وَفَاءٌ
u'بَقِيَ وَقْتٌ':Subject, #11: 11	بَقِيَ الْوَقْتُ
u'بَقِيَ وَقْتٌ':Subject, #3: 3	بَقِيَ وَقْتُهُ
u'بَقِيَ وَكِيلٌ':Subject, #4: 4	بَقِيَ وَقْتُ
u'بَقِيَ وَلاَءٌ':Subject, #1: 1	بَقِيَ وَكِيلُهُ
u'بَقِيَ ولد':Subject, #1: 1	بَقِيَ الْوَلَاءُ
u'بَقِيَ وَلَدٌ':Subject, #14: 14	بَقِيَ الْوَلَدُ
u'بَقِيَ وَلَهٌ':Subject, #14: 14	بَقِيَ الْوَلَدُ
u'بَقِيَ يُسْرٌ':Subject, #1: 1	بَقِيَ وَلَهُ
u'بَقِيَ يَسِيرٌ':Subject, #1: 1	بَقِيَ الْيُسْرُ
u'بَقِيَ يَمِينٌ':Subject, #1: 1	بَقِيَ يَسِيرُ
u'بَقِيَ يَوْمٌ':Predicate, #2: 2	بَقِيَ الْيَمِينُ
u'بَقِيَ يَوْمٌ':Subject, #1: 1	أَبْقَى الْيَوْمَ
u'بَكَّرَ مُسَافِرٌ':Subject, #1: 1	بَقِيَ يَوْمٌ
u'بَكَرَ نِساءٌ':Subject, #1: 1	بَكَّرَ الْمُسَافِرُ
u'بَكَى حُرٌّ':Subject, #1: 1	بَكَرَ النّسَاءُ
u'بَكَى رَبِيعَةٌ':Subject, #1: 1	بَكَى الْحُرُّ
u'بَكَى زَمَنٌ':Predicate, #1: 1	بَكَى رَبِيعَةُ
u'بَكَى عُمَرٌ':Subject, #1: 1	بَكَى الزَّمَنَ
u'بَكَى كَعْبٌ':Subject, #1: 1	بَكَى عُمَرُ
u'بَلَّ أرْضٌ':Predicate, #1: 1	بَكَى كَعْبٌ
u'بَلَّةٌ عُضْوٌ':Added, #2: 2	بَلَّ الْأَرْضَ
u'بَلَّةٌ مَاءٌ':Added, #1: 1	بَلَّةَ عُضْوٍ
u'بَلَّةٌ مَاءٌ':Added, #1: 1	بَلَّةَ الْمَاءِ
u'بَلَّ ثَوْبٌ':Predicate, #1: 1	بَلَّةِ الْمَاءِ
u'بَلَّ حِنْطَةٌ':Predicate, #1: 1	بَلَّ الثَّوْبَ
u'بَلَّ خُبْزٌ':Predicate, #1: 1	بَلَّ الْحِنْطَةَ
u'بَلَدَ مُسْلِمٌ':Predicate, #1: 1	بَلَّ الْخُبْزَ
u'بَلَّ دمع':Subject, #2: 2	بَلَدَ الْمُسْلِمِينَ
u'بَلَّ دَمْعٌ':Subject, #1: 1	بَلَّ دَمْعُهُ
u'بَلَّ دُموعٌ':Subject, #1: 1	بَلَّ دَمْعُهُ
u'بَلَعَ حَيَوَانٌ':Subject, #1: 1	بَلَّ دُمُوعُهُ
u'بَلَعَ دَنانيرُ':Predicate, #1: 1	بَلَعَ حَيَوَانُ
u'بَلَعَ مَالٌ':Predicate, #1: 1	بَلَعَ دَنَانِيرَ
u'بَلَغَ اِبْنٌ':Predicate, #5: 5	بَلَعَ مَالَ
u'بَلَغَ اِبْنٌ':Subject, #2: 2	بَلَغَ ابْنَ
u'بَلَغَ اِبْنٌ':Subject, #1: 1	بَلَغَ ابْنُ
u'بَلَغَ أَثْناءُ':Predicate, #2: 2	بَلَغَ ابْنُهُ
u'بَلَغَ أَجَلٌ':Subject, #1: 1	بَلَغَ أَثْنَاءَ
u'بَلَغَ أحَدٌ':Predicate, #1: 1	بَلَغَ الْأَجَلُ
u'بَلَغَ أَرْبَعُ':Predicate, #3: 3	بَلَغَ أَحَدَ
u'بَلَغَ أَرْبَعَةٌ':Predicate, #2: 2	بَلَغَ أَرْبَعَ
u'بَلَغَ أرْضٌ':Predicate, #3: 3	بَلَغَ أَرْبَعَةَ
u'بَلَغَ أَرْطابٌ':Predicate, #1: 1	بَلَغَ الْأَرْضَ
u'بَلَغَ أصل':Predicate, #1: 1	بَلَغَ الْأَرْطَابَ
u'بَلَغَ أًصْلٌ':Predicate, #1: 1	بَلَغَ الْأَصْلَ
u'بَلَغَ أُصولٌ':Predicate, #1: 1	بَلَغَ الْأَصْلَ
u'بَلَغَ أَطْفَالٌ':Subject, #1: 1	بَلَغَ أُصُولَ
u'بَلَغَ أَطْفَالٌ':Subject, #2: 2	بَلَغَ الأَطْفَالُ
u'بَلَغَ أقَلُّ':Predicate, #8: 8	بَلَغَ الْأَطْفَالُ
u'بَلَغَ أقَلُّ':Subject, #2: 2	بَلَغَ أَقَلَّ
u'بَلَغَ أقَلُّ':Subject, #1: 1	بَلَغَ أَقَلُّهُ
u'بَلَغَ أَكْثَرُ':Predicate, #1: 1	بَلَغَ الْأَقَلُّ
u'بَلَغَ ألف':Predicate, #1: 1	بَلَغَ أَكْثَرَ
u'بَلَغَ ألْفٌ':Predicate, #2: 2	بَلَغَ أَلْفَ
u'بَلَغَ أَلْفٌ':Predicate, #2: 2	بَلَغَ أَلْفَ
u'بَلَغَ إمَامٌ':Predicate, #2: 2	بَلَغَ أَلْفَ
u'بَلَغَ إمَامَةٌ':Predicate, #5: 5	بَلَغَ الْإِمَامَ
u'بَلَّغَ أُمَّةٌ':Predicate, #1: 1	بَلَغَ الْإِمَامَةَ
u'بَلَغَ أَمْرٌ':Subject, #1: 1	بَلَّغَ الْأُمَّةَ
u'بَلَغَ أَمْرٌ':Subject, #1: 1	بَلَغَ الأَمْرُ
u'بَلَغَ أهْلٌ':Predicate, #1: 1	بَلَغَ أَمْرُ
u'بَلَغَ أهْلٌ':Subject, #1: 1	بَلَغَ أَهْلَ
u'بَلَغَ أوَانٌ':Predicate, #3: 3	بَلَغَ أَهْلُ
u'بَلَغَ أَوَّلُ':Predicate, #2: 2	بَلَغَ أَوَانَ
u'بَلَغَ أَوَّلُ':Subject, #2: 2	بَلَغَ أَوَّلَ
u'بَلَغَ آيَةٌ':Predicate, #2: 2	بَلَغَ الْأَوَّلُ
u'بَلَغَ بَابٌ':Predicate, #1: 1	بَلَغَ الْآيَةَ
u'بَلَغَ بَابٌ':Predicate, #1: 1	بَلَغَ بَابَ
u'بَلَغَ بِضْعٌ':Predicate, #3: 3	بَلَغَ الْبَابَ
u'بَلَغَ بَطْنٌ':Predicate, #1: 1	بَلَغَ بِضْعَ
u'بَلَغَ بَعْضٌ':Predicate, #4: 4	بَلَغَ بَطْنَ
u'بَلَغَ بَعْضٌ':Subject, #1: 1	بَلَغَ بَعْضَ
u'بَلَغَ بَغْدادُ':Predicate, #1: 1	بَلَغَ بَعْضُهُ
u'بَلَغَ بِكْرٌ':Predicate, #2: 2	بَلَغَ بَغْدَادَ
u'بَلَغَ بِنَاءٌ':Subject, #1: 1	بَلَغَ الْبِكْرَ
u'بَلَغَ بُنْيانٌ':Subject, #1: 1	بَلَغَ الْبِنَاءُ
u'بَلَغَ بِئْرٌ':Predicate, #1: 1	بَلَغَ الْبُنْيَانُ
u'بَلَغَ تَابِعِيٌّ':Subject, #1: 1	بَلَغَ بِئْرَ
u'بَلَغَ تباع':Subject, #2: 2	بَلَغَ التَّابِعِيُّ
u'بَلَغَ تِسْعَةٌ':Predicate, #1: 1	بَلَغَ تُبَاعُ
u'بَلَّغَ تَعْزِير':Predicate, #1: 1	بَلَغَ تِسْعَةَ
u'بَلَغَ تَعْزِير':Subject, #1: 1	بَلَّغَ التَّعْزِيرَ
u'بَلَغَ تَغَافُلٌ':Subject, #1: 1	بَلَغَ التَّعْزِيرُ
u'بَلَغَ تمام':Predicate, #1: 1	بَلَغَ التَّغَافُلُ
u'بَلَغَ تَمامٌ':Predicate, #1: 1	بَلَغَ تَمَامَ
u'بَلَغَ تَوَاتُرٌ':Subject, #1: 1	بَلَغَ تَمَامَ
u'بَلَغَ ثَانِي':Subject, #1: 1	بَلَغَ التَّوَاتُرُ
u'بَلَغَ ثَانِيَةٌ':Subject, #1: 1	بَلَغَ الثَّانِيَةُ
u'بَلَغَ ثَلاثُ':Predicate, #1: 1	بَلَغَ الثَّانِيَةُ
u'بَلَغَ ثَلاثَةٌ':Predicate, #1: 1	بَلَغَ ثَلَاثَ
u'بَلَغَ ثَمانِين':Predicate, #4: 4	بَلَغَ ثَلَاثَةَ
u'بَلَغَ ثَمَرٌ':Subject, #2: 2	بَلَغَ ثَمَانِينَ
u'بَلَغَ ثَمَنٌ':Predicate, #1: 1	بَلَغَ الثَّمَرُ
u'بَلَغَ ثَمَنٌ':Predicate, #1: 1	بَلَغَ الثَّمَنَ
u'بَلَغَ ثَمَنٌ':Subject, #3: 3	بَلَغَ ثَمَنَ
u'بَلَغَ ثَمَنٌ':Subject, #1: 1	بَلَغَ الثَّمَنُ
u'بَلَغَ ثَنِيَّةٌ':Predicate, #1: 1	بَلَغَ ثَمَنُهُ
u'بَلَغَ ثَوْبٌ':Subject, #2: 2	بَلَغَ ثَنِيَّةَ
u'بَلَغَ جَبَلٌ':Predicate, #1: 1	بَلَغَ الثَّوْبُ
u'بَلَغَ جَزَاءٌ':Subject, #1: 1	بَلَغَ الْجَبَلَ
u'بَلَغَ جِمَارٌ':Predicate, #1: 1	بَلَغَ جَزَاءُ
u'بَلَغَ جَمْرَةٌ':Predicate, #2: 2	بَلَغَ الْجِمَارَ
u'بَلَغَ جَمْرَة':Predicate, #1: 1	بَلَغَ الْجَمْرَةَ
u'بَلَغَ جَمِيع':Predicate, #1: 1	بَلَغَ الْجَمْرَةَ
u'بَلَغَ جَهْدٌ':Subject, #1: 1	بَلَغَ الْجَمِيعَ
u'بَلَغَ حاصِلٌ':Subject, #1: 1	بَلَغَ الْجَهْدُ
u'بَلَغَ حاصِلٌ':Subject, #1: 1	بَلَغَ الْحَاصِلُ
u'بَلَغَ حاكِمٌ':Predicate, #1: 1	بَلَغَ حَاصِلُ
u'بَلَغَ حالَةٌ':Predicate, #1: 1	بَلَغَ الْحَاكِمَ
u'بَلَغَ حَبٌّ':Subject, #1: 1	بَلَغَ حَالَةَ
u'بَلَغَ حَبٌّ':Subject, #1: 1	بَلَغَ حَبُّ
u'بَلَغَ حُجْرَةٌ':Predicate, #4: 4	بَلَغَ حَبُّهُ
u'بَلَغَ حُجَزٌ':Predicate, #1: 1	بَلَغَ حُجْرَةَ
u'بَلَغَ حَدٌّ':Predicate, #1: 1	بَلَغَ حُجَزَ
u'بَلَغَ حدب':Subject, #18: 18	بَلَغَ حَدَّ
u'بَلَغَ حَدَبٌ':Subject, #1: 1	بَلَغَ حَدَبُهُ
u'بَلَغَ حَرَمٌ':Predicate, #1: 1	بَلَغَ حَدَبُهُ
u'بَلَغَ حساب':Subject, #7: 7	بَلَغَ الْحَرَمَ
u'بَلَغَ حِسَابٌ':Subject, #2: 2	بَلَغَ الْحِسَابُ
u'بَلَغَ حَصَادٌ':Predicate, #2: 2	بَلَغَ الْحِسَابُ
u'بَلَغَ حِصَّةٌ':Predicate, #1: 1	بَلَغَ الْحَصَادَ
u'بَلَغَ حَظٌّ':Subject, #1: 1	بَلَغَ حِصَّةَ
u'بَلَغَ حِلٌّ':Predicate, #1: 1	بَلَغَ حَظُّهُ
u'بَلَغَ حُلُمٌ':Predicate, #1: 1	بَلَغَ الْحِلَّ
u'بَلَغَ حَمَّالٌ':Subject, #8: 8	بَلَغَ الْحُلُمَ
u'بَلَّغَ حَمَّالٌ':Subject, #1: 1	بَلَغَ الْحَمَّالُ
u'بَلَغَ حِنْثٌ':Predicate, #1: 1	بَلَّغَ الْحَمَّالُ
u'بَلَغَ حَيٌّ':Predicate, #3: 3	بَلَغَ الْحِنْثَ
u'بَلَغَ خَارِجٌ':Subject, #2: 2	بَلَغَ حَيَّ
u'بَلَّغَ خَبَرٌ':Predicate, #2: 2	بَلَغَ الْخَارِجُ
u'بَلَّغَ خَبَر':Predicate, #1: 1	بَلَّغَ الْخَبَرَ
u'بَلَغَ خَبَرٌ':Subject, #1: 1	بَلَّغَ الْخَبَرَ
u'بَلَغَ خَبَر':Subject, #7: 7	بَلَغَ الْخَبَرُ
u'بَلَغَ خَطِيبٌ':Subject, #7: 7	بَلَغَ الْخَبَرُ
u'بَلَغَ خَلْخَالٌ':Subject, #1: 1	بَلَغَ الْخَطِيبُ
u'بَلَغَ خَمْسٌ':Predicate, #3: 3	بَلَغَ الْخَلْخَالُ
u'بَلَغَ خَمْسَةٌ':Predicate, #4: 4	بَلَغَ خَمْسَ
u'بَلَغَ درجة':Predicate, #15: 15	بَلَغَ خَمْسَةَ
u'بَلَغَ دَرَجَةٌ':Predicate, #2: 2	بَلَغَ دَرَجَةَ
u'بَلَغَ دِرْهَمٌ':Predicate, #2: 2	بَلَغَ دَرَجَةَ
u'بَلَغَ دِرْهَم':Predicate, #1: 1	بَلَغَ الدِّرْهَمَ
u'بَلَغَ ذَهَبٌ':Subject, #1: 1	بَلَغَ الدِّرْهَمَ
u'بَلَغَ ذَيْلٌ':Subject, #4: 4	بَلَغَ الذَّهَبُ
u'بَلَغَ رَأْسٌ':Predicate, #1: 1	بَلَغَ الذَّيْلُ
u'بَلَغَ رَأْيٌ':Subject, #2: 2	بَلَغَ رَأْسَ
u'بَلَغَ رُبُعٌ':Predicate, #2: 2	بَلَغَ الرَّأْيُ
u'بَلَغَ رُبْعٌ':Predicate, #1: 1	بَلَغَ رُبُعَ
u'بَلَغَ رُبْعٌ':Predicate, #2: 2	بَلَغَ الرُّبْعَ
u'بَلَغَ رُتْبَةٌ':Predicate, #5: 5	بَلَغَ رُبْعَ
u'بَلَغَ رَجُلٌ':Subject, #2: 2	بَلَغَ رُتْبَةَ
u'بَلَّغَ رِسَالَةٌ':Predicate, #1: 1	بَلَغَ الرَّجُلُ
u'بَلَّغَ رِسَالَةٌ':Predicate, #2: 2	بَلَّغَ رِسَالَةَ
u'بَلَغَ رَسُولٌ':Predicate, #3: 3	بَلَّغَ الرِّسَالَةَ
u'بَلَغَ رَسُولٌ':Subject, #15: 15	بَلَغَ رَسُولَ
u'بَلَغَ رُكْنٌ':Predicate, #5: 5	بَلَغَ رَسُولُ
u'بَلَغَ رُكْن':Predicate, #2: 2	بَلَغَ الرُّكْنَ
u'بَلَغَ رُومٌ':Predicate, #2: 2	بَلَغَ الرُّكْنَ
u'بَلَغَ زائِدٌ':Subject, #1: 1	بَلَغَ الرّومَ
u'بَلَغَ زَرْعٌ':Predicate, #1: 1	بَلَغَ الزَّائِدُ
u'بَلَغَ زَرْعٌ':Subject, #1: 1	بَلَغَ الزَّرْعَ
u'بَلَغَ زُقاقٌ':Predicate, #3: 3	بَلَغَ الزَّرْعُ
u'بَلَغَ زُقَاقٌ':Predicate, #1: 1	بَلَغَ زُقَاقَ
u'بَلَغَ زَوْجٌ':Predicate, #1: 1	بَلَغَ زُقَاقَ
u'بَلَغَ زَوْجٌ':Subject, #2: 2	بَلَغَ الزَّوْجَ
u'بَلَغَ زَيْتونٌ':Subject, #2: 2	بَلَغَ الزَّوْجُ
u'بَلَغَ سَالِكٌ':Subject, #1: 1	بَلَغَ زَيْتُونُهُ
u'بَلَغَ سَبْعٌ':Predicate, #1: 1	بَلَغَ السَّالِكُ
u'بَلَغَ سَبْعٌ':Predicate, #1: 1	بَلَغَ السَّبْعَ
u'بَلَغَ سَبْعَةٌ':Predicate, #9: 9	بَلَغَ سَبْعَ
u'بَلَغَ سِتٌّ':Predicate, #3: 3	بَلَغَ سَبْعَةَ
u'بَلَغَ سِتٌّ':Predicate, #1: 1	بَلَغَ سِتَّ
u'بَلَغَ سجدة':Predicate, #2: 2	بَلَغَ سِتَّةَ
u'بَلَغَ سَجْدَةٌ':Predicate, #6: 6	بَلَغَ السَّجْدَةَ
u'بَلَغَ سَفَرٌ':Subject, #6: 6	بَلَغَ السَّجْدَةَ
u'بَلَغَ سقط':Predicate, #2: 2	بَلَغَ السَّفَرُ
u'بَلَغَ سَقَطٌ':Predicate, #1: 1	بَلَغَ سَقَطَ
u'بَلَغَ سلام':Subject, #1: 1	بَلَغَ سَقَطَ
u'بَلَغَ سَلاَمٌ':Subject, #1: 1	بَلَغَ السَّلَامُ
u'بَلَغَ سُلْطَانٌ':Predicate, #1: 1	بَلَغَ السَّلَامُ
u'بَلَغَ سِنٌّ':Predicate, #1: 1	بَلَغَ السُّلْطَانَ
u'بَلَغَ سِنٌّ':Predicate, #2: 2	بَلَغَ سِنَّ
u'بَلَغَ سِنٌّ':Subject, #3: 3	بَلَغَ السِّنَّ
u'بَلَغَ سُهَيْلٌ':Predicate, #1: 1	بَلَغَ سِنُّهُ
u'بَلَغَ سَواءٌ':Subject, #1: 1	بَلَغَ سُهَيْلَ
u'بَلَغَ سَوْطٌ':Subject, #1: 1	بَلَغَ سَوَاءٌ
u'بَلَغَ شافِعِيّ':Subject, #2: 2	بَلَغَ السَّوْطُ
u'بَلَغَ شَرَابٌ':Subject, #1: 1	بَلَغَ الشَّافِعِيُّ
u'بَلَغَ شِعْبٌ':Predicate, #2: 2	بَلَغَ الشَّرَابُ
u'بَلَغَ شَفِيعٌ':Predicate, #1: 1	بَلَغَ الشِّعْبَ
u'بَلَغَ شَفِيعٌ':Subject, #2: 2	بَلَغَ الشَّفِيعَ
u'بَلَغَ شَهْوَةٌ':Predicate, #3: 3	بَلَغَ الشَّفِيعُ
u'بَلَغَ شَيْطَانٌ':Subject, #1: 1	بَلَغَ الشَّهْوَةَ
u'بَلَغَ صَبْغٌ':Subject, #1: 1	بَلَغَ الشَّيْطَانُ
u'بَلَغَ صَبِيٌّ':Subject, #1: 1	بَلَغَ الصَّبْغُ
u'بَلَغَ صَبِيٌّ':Subject, #54: 54	بَلَغَ الصَّبِيُّ
u'بَلَغَ صِبْيَانٌ':Subject, #5: 5	بَلَغَ صَبِيٌّ
u'بَلَغَ صداق':Subject, #1: 1	بَلَغَ الصِّبْيَانُ
u'بَلَغَ صَدَاقٌ':Subject, #1: 1	بَلَغَ صَدَاقُ
u'بَلَغَ صغار':Subject, #1: 1	بَلَغَ صَدَاقُ
u'بَلَغَ صَغِيرٌ':Subject, #1: 1	بَلَغَ الصِّغَارُ
u'بَلَغَ صَفْرَاء':Predicate, #11: 11	بَلَغَ الصَّغِيرُ
u'بَلَّغَ ضَرْبٌ':Predicate, #1: 1	بَلَغَ الصَّفْرَاءَ
u'بَلَغَ طَالِبٌ':Predicate, #1: 1	بَلَّغَ الضَّرْبَ
u'بَلَغَ طَالِبٌ':Subject, #2: 2	بَلَغَ الطَّالِبَ
u'بَلَغَ طِفْلٌ':Subject, #2: 2	بَلَغَ الطَّالِبُ
u'بَلَغَ طهر':Subject, #1: 1	بَلَغَ الطِّفْلُ
u'بَلَغَ طُهْرٌ':Subject, #3: 3	بَلَغَ الطُّهْرُ
u'بَلَغَ طُولٌ':Subject, #3: 3	بَلَغَ الطُّهْرُ
u'بَلَغَ طُولٌ':Subject, #1: 1	بَلَغَ طُولُ
u'بَلَغَ عَانَةٌ':Predicate, #1: 1	بَلَغَ طُولُهُ
u'بَلَغَ عَائِشٌ':Predicate, #2: 2	بَلَغَ الْعَانَةَ
u'بَلَغَ عَبْدٌ':Subject, #7: 7	بَلَغَ عَائِشَةَ
u'بَلَغَ عتبة':Subject, #4: 4	بَلَغَ الْعَبْدُ
u'بَلَغَ عَدَدٌ':Predicate, #1: 1	بَلَغَ عُتْبَةُ
u'بَلَغَ عَدَدٌ':Subject, #1: 1	بَلَغَ عَدَدَ
u'بَلَغَ عَشْرٌ':Predicate, #2: 2	بَلَغَ عَدَدُ
u'بَلَغَ عُشُرٌ':Predicate, #1: 1	بَلَغَ الْعَشْرَ
u'بَلَغَ عُشْرٌ':Predicate, #1: 1	بَلَغَ الْعُشُرَ
u'بَلَغَ عَشْرٌ':Predicate, #1: 1	بَلَغَ الْعُشْرَ
u'بَلَغَ عَقٌّ':Predicate, #4: 4	بَلَغَ عَشْرَ
u'بَلَغَ عَقِبٌ':Predicate, #1: 1	بَلَغَ عَقَّ
u'بَلَغَ علم':Predicate, #1: 1	بَلَغَ عَقِبَ
u'بَلَغَ عَلَمٌ':Predicate, #1: 1	بَلَغَ الْعَلَمَ
u'بَلَغَ علماء':Subject, #1: 1	بَلَغَ الْعَلَمَ
u'بَلَغَ عُلَمَاءُ':Subject, #1: 1	بَلَغَ الْعُلَمَاءُ
u'بَلَغَ عُمَرٌ':Predicate, #1: 1	بَلَغَ الْعُلَمَاءُ
u'بَلَغَ عُمَرٌ':Subject, #12: 12	بَلَغَ عُمَرَ
u'بَلَغَ عَمَلٌ':Subject, #1: 1	بَلَغَ عُمَرُ
u'بَلَغَ عَنَانٌ':Predicate, #2: 2	بَلَغَ عَمَلُهُ
u'بَلَغَ عند':Predicate, #1: 1	بَلَغَ عَنَانَ
u'بَلَغَ غَايَةٌ':Predicate, #10: 10	بَلَغَ عِنْدَ
u'بَلَغَ غَايَةٌ':Predicate, #1: 1	بَلَغَ غَايَةَ
u'بَلَغَ غَرْغَرَةٌ':Predicate, #5: 5	بَلَغَ الْغَايَةَ
u'بَلَغَ غُلاَمٌ':Subject, #1: 1	بَلَغَ الْغَرْغَرَةَ
u'بَلَغَ غُلاَمٌ':Subject, #2: 2	بَلَغَ غُلَامٌ
u'بَلَغَ غير':Predicate, #8: 8	بَلَغَ الْغُلَامُ
u'بَلَغَ غَيْرٌ':Predicate, #5: 5	بَلَغَ غَيْرَ
u'بَلَغَ فِتْرٌ':Predicate, #5: 5	بَلَغَ غَيْرَ
u'بَلَغَ فِدَاءٌ':Subject, #1: 1	بَلَغَ الْفِتْرَ
u'بَلَغَ فِدَاءٌ':Subject, #1: 1	بَلَغَ الْفِدَاءُ
u'بَلَغَ فلان':Predicate, #1: 1	بَلَغَ فِدَاءُ
u'بَلَغَ فلان':Predicate, #1: 1	بَلَغَ عُثْمَانَ
u'بَلَغَ فلان':Predicate, #1: 1	بَلَغَ عَدْنَانَ
u'بَلَغَ فلان':Predicate, #1: 1	بَلَغَ مُعَاوِيَةَ
u'بَلَغَ فلان':Predicate, #2: 2	بَلَغَ الْمُزْدَلِفَةَ
u'بَلَغَ فلان':Subject, #2: 2	بَلَغَ مَكَّةَ
u'بَلَغَ قَالٌ':Predicate, #1: 1	بَلَغَ الشَّافِعِيُّ
u'بَلَغَ قَدْرٌ':Predicate, #2: 2	بَلَغَ قَالَ
u'بَلَغَ قَدْرٌ':Predicate, #2: 2	بَلَغَ قَدْرَ
u'بَلَغَ قَدْرٌ':Subject, #3: 3	بَلَغَ الْقَدْرَ
u'بَلَغَ قدم':Predicate, #1: 1	بَلَغَ قَدْرُ
u'بَلَغَ قَدَمٌ':Predicate, #1: 1	بَلَغَ الْقَدَمَ
u'بَلَغَ قَذَالٌ':Predicate, #1: 1	بَلَغَ الْقَدَمَ
u'بَلَغَ قَرْقَرَةٌ':Predicate, #2: 2	بَلَغَ الْقَذَالَ
u'بَلَغَ قصاص':Subject, #1: 1	بَلَغَ قَرْقَرَةَ
u'بَلَغَ قِصَاصٌ':Subject, #1: 1	بَلَغَ الْقِصَاصُ
u'بَلَغَ قَصَبٌ':Subject, #1: 1	بَلَغَ الْقِصَاصُ
u'بَلَغَ قِصَّةٌ':Predicate, #1: 1	بَلَغَ الْقَصَبُ
u'بَلَغَ قَفَا':Subject, #1: 1	بَلَغَ قِصَّةَ
u'بَلَغَ قول':Subject, #1: 1	بَلَغَ قَفَاهُ
u'بَلَغَ قَوْلٌ':Subject, #1: 1	بَلَغَ قَوْلُ
u'بَلَغَ قِيَاسٌ':Subject, #1: 1	بَلَغَ قَوْلُ
u'بَلَغَ قِيمَةٌ':Subject, #1: 1	بَلَغَ قِيَاسُ
u'بَلَغَ قِيمَةٌ':Subject, #1: 1	بَلَغَ قِيمَةُ
u'بَلَّغَ كِتَابٌ':Predicate, #1: 1	بَلَغَ قِيمَتُهُ
u'بَلَغَ كِتَابٌ':Subject, #2: 2	بَلَّغَ الْكِتَابَ
u'بَلَغَ كُرَاعٌ':Predicate, #2: 2	بَلَغَ الْكِتَابُ
u'بَلَغَ كَرْمٌ':Subject, #5: 5	بَلَغَ كُرَاعَ
u'بَلَغَ كَسْرٌ':Subject, #1: 1	بَلَغَ الْكَرْمُ
u'بَلَغَ كَعْبٌ':Predicate, #1: 1	بَلَغَ الْكَسْرُ
u'بَلَغَ كُنْهٌ':Predicate, #1: 1	بَلَغَ الْكَعْبَ
u'بَلَغَ كوع':Predicate, #1: 1	بَلَغَ كُنْهَ
u'بَلَغَ كُوعٌ':Predicate, #5: 5	بَلَغَ الْكُوعَ
u'بَلَغَ كُوفَةٌ':Predicate, #5: 5	بَلَغَ الْكُوعَ
u'بَلَغَ كَيْلٌ':Subject, #1: 1	بَلَغَ الْكُوفَةَ
u'بَلَغَ كَيْلٌ':Subject, #1: 1	بَلَغَ كَيْلُ
u'بَلَغَ لَقِيطٌ':Subject, #1: 1	بَلَغَ كَيْلُهُ
u'بَلَغَ لَيْلٌ':Subject, #2: 2	بَلَغَ اللَّقِيطُ
u'بَلَغَ مَاءٌ':Predicate, #1: 1	بَلَغَ اللَّيْلُ
u'بَلَغَ مَاءٌ':Subject, #2: 2	بَلَغَ الْمَاءَ
u'بَلَغَ مَاءٌ':Subject, #1: 1	بَلَغَ مَاءُ
u'بَلَغَ مَأْكُولٌ':Subject, #40: 40	بَلَغَ الْمَاءُ
u'بَلَغَ مَالٌ':Predicate, #1: 1	بَلَغَ الْمَأْكُولُ
u'بَلَغَ مَالٌ':Predicate, #1: 1	بَلَغَ مَالَ
u'بَلَغَ مَالٌ':Subject, #1: 1	بَلَغَ مَالاً
u'بَلَغَ مَالٌ':Subject, #2: 2	بَلَغَ مَالُهُ
u'بَلَغَ مَالٌ':Subject, #3: 3	بَلَغَ الْمَالُ
u'بَلَغَ مَالِكٌ':Predicate, #3: 3	بَلَغَ مَالُ
u'بَلَغَ مَالِكٌ':Subject, #1: 1	بَلَغَ الْمَالِكَ
u'بَلَغَ مَأْمَنٌ':Predicate, #2: 2	بَلَغَ الْمَالِكُ
u'بَلَغَ مَبْلَغٌ':Predicate, #5: 5	بَلَغَ الْمَأْمَنَ
u'بَلَغَ مَتَاعٌ':Subject, #16: 16	بَلَغَ مَبْلَغَ
u'بَلَغَ مُتَمَكِّنٌ':Predicate, #1: 1	بَلَغَ الْمَتَاعُ
u'بَلَغَ مَجْمُوعٌ':Subject, #1: 1	بَلَغَ الْمُتَمَكِّنَ
u'بَلَغَ مَجْمُوعٌ':Subject, #3: 3	بَلَغَ الْمَجْمُوعُ
u'بَلَغَ مَجْهُولٌ':Predicate, #3: 3	بَلَغَ مَجْمُوعُ
u'بَلَغَ مَحْكُومٌ':Subject, #1: 1	بَلَغَ مَجْهُولَ
u'بَلَغَ مُحَمَّدٌ':Subject, #1: 1	بَلَغَ الْمَحْكُومُ
u'بَلَغَ مَخَافَةٌ':Predicate, #1: 1	بَلَغَ مُحَمّدٌ
u'بَلَغَ مَخَافَة':Predicate, #1: 1	بَلَغَ مَخَافَةَ
u'بَلَغَ مُدٌّ':Predicate, #1: 1	بَلَغَ مَخَافَةَ
u'بَلَغَ مُدَّةٌ':Predicate, #6: 6	بَلَغَ مُدَّ
u'بَلَغَ مَدِينٌ':Predicate, #1: 1	بَلَغَ الْمُدَّةَ
u'بَلَغَ مَدِينَةٌ':Predicate, #2: 2	بَلَغَ الْمَدِينَةَ
u'بَلَغَ مَرْتَبَةٌ':Predicate, #2: 2	بَلَغَ الْمَدِينَةَ
u'بَلَغَ مَسَافَةٌ':Predicate, #1: 1	بَلَغَ مَرْتَبَةَ
u'بَلَغَ مُسَافِرٌ':Subject, #2: 2	بَلَغَ مَسَافَةَ
u'بَلَغَ مُسْتَبْضِع':Predicate, #1: 1	بَلَغَ الْمُسَافِرُ
u'بَلَغَ مَسْجِدٌ':Predicate, #1: 1	بَلَغَ الْمُسْتَبْضِعَ
u'بَلَغَ مَسْحٌ':Predicate, #1: 1	بَلَغَ الْمَسْجِدَ
u'بَلَغَ مَشَارِقُ':Predicate, #1: 1	بَلَغَ مَسْحَ
u'بَلَغَ مَضْرُوبٌ':Subject, #2: 2	بَلَغَ مَشَارِقَ
u'بَلَغَ مُعاوِيَة':Predicate, #2: 2	بَلَغَ مَضْرُوبُهُ
u'بَلَغَ مُعَدٌّ':Predicate, #1: 1	بَلَغَ مُعَاوِيَةَ
u'بَلَغَ مَفْعُولٌ':Subject, #1: 1	بَلَغَ مُعَدَّةً
u'بَلَغَ مَقَامٌ':Predicate, #1: 1	بَلَغَ الْمَفْعُولُ
u'بَلَغَ مَقْبَرَةٌ':Predicate, #2: 2	بَلَغَ مَقَامَ
u'بَلَغَ مِقْدَارٌ':Predicate, #1: 1	بَلَغَ الْمَقْبَرَةَ
u'بَلَغَ مِقْدَارٌ':Subject, #2: 2	بَلَغَ مِقْدَارَ
u'بَلَغَ مَقْصُودٌ':Predicate, #1: 1	بَلَغَ مِقْدَارُ
u'بَلَغَ مَكَانٌ':Predicate, #1: 1	بَلَغَ الْمَقْصُودَ
u'بَلَغَ مَكَانٌ':Predicate, #1: 1	بَلَغَ الْمَكَانَ
u'بَلَغَ مُكَلَّفٌ':Subject, #1: 1	بَلَغَ مَكَانَ
u'بَلَغَ مِلْءٌ':Predicate, #1: 1	بَلَغَ الْمُكَلَّفُ
u'بَلَغَ مَلَكٌ':Predicate, #1: 1	بَلَغَ مِلْءَ
u'بَلَغَ مَنْزِلٌ':Predicate, #1: 1	بَلَغَ مَلَكَ
u'بَلَغَ مَنْزِلٌ':Predicate, #1: 1	بَلَغَ مَنْزِلَ
u'بَلَغَ مَهْرٌ':Subject, #4: 4	بَلَغَ الْمَنْزِلَ
u'بَلَغَ مُؤَذِّنٌ':Subject, #1: 1	بَلَغَ الْمَهْرُ
u'بَلَغَ مَوْصِلٌ':Predicate, #3: 3	بَلَغَ الْمُؤَذِّنُ
u'بَلَغَ مَوْضِعٌ':Predicate, #1: 1	بَلَغَ الْمَوْصِلَ
u'بَلَغَ مَوْضِعٌ':Predicate, #2: 2	بَلَغَ الْمَوْضِعَ
u'بَلَغَ مَوْلُودٌ':Subject, #3: 3	بَلَغَ مَوْضِعَ
u'بَلَغَ مِيرَاثٌ':Subject, #1: 1	بَلَغَ الْمَوْلُودُ
u'بَلَغَ مِيقَاتٌ':Predicate, #1: 1	بَلَغَ الْمِيرَاثُ
u'بَلَغَ نَاسٌ':Predicate, #2: 2	بَلَغَ الْمِيقَاتَ
u'بَلَغَ نَاسٌ':Subject, #1: 1	بَلَغَ النَّاسَ
u'بَلَغَ نَائِبٌ':Predicate, #2: 2	بَلَغَ النَّاسُ
u'بَلَغَ نَائِحٌ':Predicate, #2: 2	بَلَغَ النَّائِبَ
u'بَلَّغَ نَبِيٌّ':Predicate, #1: 1	بَلَغَ النَّائِحَةَ
u'بَلَغَ نَبِيٌّ':Predicate, #1: 1	بَلَّغَ النَّبِيَّ
u'بَلَّغَ نَبِيٌّ':Subject, #4: 4	بَلَغَ النَّبِيَّ
u'بَلَغَ نِساءٌ':Subject, #2: 2	بَلَّغَ النَّبِيُّ
u'بَلَغَ نصاب':Predicate, #2: 2	بَلَغَ النِّسَاءُ
u'بَلَغَ نِصَابٌ':Predicate, #1: 1	بَلَغَ نِصَابَ
u'بَلَغَ نصاب':Predicate, #1: 1	بَلَغَ نِصَابَ
u'بَلَغَ نِصَابٌ':Predicate, #2: 2	بَلَغَ النِّصَابَ
u'بَلَغَ نِصْفٌ':Predicate, #2: 2	بَلَغَ النِّصَابَ
u'بَلَغَ نِصْفٌ':Predicate, #2: 2	بَلَغَ النِّصْفَ
u'بَلَغَ نِصْفٌ':Subject, #3: 3	بَلَغَ نِصْفَ
u'بَلَغَ نِصْفٌ':Subject, #1: 1	بَلَغَ النِّصْفُ
u'بَلَغَ نَصِيبٌ':Subject, #1: 1	بَلَغَ نِصْفُ
u'بَلَغَ نَصِيبٌ':Subject, #3: 3	بَلَغَ نَصِيبُ
u'بَلَغَ نَعْلٌ':Subject, #3: 3	بَلَغَ نَصِيبُهُ
u'بَلَغَ نَفْسٌ':Predicate, #1: 1	بَلَغَ النَّعْلُ
u'بَلَغَ نَفْسٌ':Predicate, #1: 1	بَلَغَ النَّفْسَ
u'بَلَغَ نَقْرٌ':Subject, #1: 1	بَلَغَ نَفْسَ
u'بَلَغَ هَدْيٌ':Subject, #2: 2	بَلَغَ النّقْرُ
u'بَلَغَ وَاجِبٌ':Subject, #1: 1	بَلَغَ هَدْيُ
u'بَلَغَ وَجَبٌ':Predicate, #1: 1	بَلَغَ الْوَاجِبُ
u'بَلَغَ وُجُوبٌ':Predicate, #1: 1	بَلَغَ وَجَبَ
u'بَلَغَ ورق':Subject, #1: 1	بَلَغَ الْوُجُوبَ
u'بَلَغَ وَرِقٌ':Subject, #3: 3	بَلَغَ الْوَرِقُ
u'بَلَغَ وَزْنٌ':Predicate, #3: 3	بَلَغَ الْوَرِقُ
u'بَلَغَ وَزْنٌ':Subject, #2: 2	بَلَغَ وَزْنَ
u'بَلَغَ وسط':Predicate, #1: 1	بَلَغَ وَزْنُهُ
u'بَلَغَ وَسَطٌ':Predicate, #1: 1	بَلَغَ وَسَطَ
u'بَلَغَ وَقْتٌ':Predicate, #1: 1	بَلَغَ وَسَطَ
u'بَلَغَ ولد':Subject, #1: 1	بَلَغَ وَقْتَ
u'بَلَغَ وَلَدٌ':Subject, #5: 5	بَلَغَ الْوَلَدُ
u'بَلَغَ يَتِيمٌ':Subject, #5: 5	بَلَغَ الْوَلَدُ
u'بُلُوغٌ إِبِلٌ':Added, #5: 5	بَلَغَ الْيَتِيمُ
u'بُلُوغٌ أَجَلٌ':Added, #1: 1	بُلُوغِ الْإِبِلِ
u'بُلُوغٌ أحَدٌ':Added, #1: 1	بُلُوغُ أَجَلِ
u'بُلُوغٌ آدَمِيٌّ':Added, #1: 1	بُلُوغِ أَحَدِ
u'بُلُوغٌ إِذْنٌ':Added, #1: 1	بُلُوغِ الْآدَمِيِّ
u'بُلُوغٌ أَرَبٌ':Added, #1: 1	بُلُوغِ الْإِذْنِ
u'بُلُوغٌ أقَلُّ':Added, #1: 1	بُلُوغِ الْأَرَبِ
u'بُلُوغٌ الْمَرْأَةُ':Added, #3: 3	بُلُوغِ الْأَقَلِّ
u'بُلُوغٌ الْمَرْأَةُ':Added, #1: 1	بُلُوغَ الْمَرْأَةِ
u'بُلُوغٌ الْمَرْأَةُ':Added, #2: 2	بُلُوغُ الْمَرْأَةِ
u'بُلُوغٌ إمَامٌ':Added, #2: 2	بُلُوغِ الْمَرْأَةِ
u'بُلُوغٌ أُمَّةٌ':Added, #5: 5	بُلُوغِ الْإِمَامِ
u'بُلُوغٌ ثَمَرٌ':Added, #1: 1	بُلُوغِ الْأُمَّةِ
u'بُلُوغٌ ثَمَرَةٌ':Added, #1: 1	بُلُوغُ الثَّمَرِ
u'بُلُوغٌ جِنَايَةٌ':Added, #1: 1	بُلُوغِ الثَّمَرَةِ
u'بُلُوغٌ حَدٌّ':Added, #2: 2	بُلُوغِ الْجِنَايَةِ
u'بُلُوغٌ حَدٌّ':Added, #1: 1	بُلُوغِ الْحَدِّ
u'بُلُوغٌ حَديثٌ':Added, #2: 2	بُلُوغِ حَدِّ
u'بُلُوغٌ حَديثٌ':Added, #1: 1	بُلُوغُ الْحَدِيثِ
u'بُلُوغٌ حَديدَةٌ':Added, #1: 1	بُلُوغَ الْحَدِيثَيْنِ
u'بُلُوغٌ حَصَادٌ':Added, #1: 1	بُلُوغُ الْحَدِيدَةِ
u'بُلُوغٌ حِصَّةٌ':Added, #1: 1	بُلُوغَ الْحَصَادِ
u'بُلُوغٌ حَقٌّ':Added, #2: 2	بُلُوغُ حِصَّتِهِ
u'بُلُوغٌ حقائق':Added, #1: 1	بُلُوغِ حَقِّ
u'بُلُوغٌ حَقَائِقُ':Added, #1: 1	بُلُوغِ حَقَائِقِ
u'بُلُوغٌ حُكُومَةٌ':Added, #1: 1	بُلُوغِ حَقَائِقِ
u'بُلُوغٌ حُلْقُومٌ':Added, #1: 1	بُلُوغِ الْحُكُومَةِ
u'بُلُوغٌ حُلُمٌ':Added, #1: 1	بُلُوغَ الْحُلْقُومِ
u'بُلُوغٌ خَالِصٌ':Added, #1: 1	بُلُوغُ الْحُلُمِ
u'بُلُوغٌ خَبَرٌ':Added, #2: 2	بُلُوغُ خَالِصِ
u'بُلُوغٌ خَبَر':Added, #16: 16	بُلُوغِ الْخَبَرِ
u'بُلُوغٌ خَبَرٌ':Added, #16: 16	بُلُوغِ الْخَبَرِ
u'بُلُوغٌ خَبَرٌ':Added, #1: 1	بُلُوغَ الْخَبَرِ
u'بُلُوغٌ خَبَر':Added, #1: 1	بُلُوغُ الْخَبَرِ
u'بُلُوغٌ خَبَر':Added, #1: 1	بُلُوغَ الْخَبَرِ
u'بُلُوغٌ خَبَرٌ':Added, #1: 1	بُلُوغُ الْخَبَرِ
u'بُلُوغٌ خَبَرٌ':Added, #1: 1	بُلُوغُ خَبَرٍ
u'بُلُوغٌ خَبَرٌ':Added, #1: 1	بُلُوغُ خَبَرِ
u'بُلُوغٌ خَبَرٌ':Added, #1: 1	بُلُوغِ خَبَرٍ
u'بُلُوغٌ خَبَر':Added, #1: 1	بُلُوغِ خَبَرِ
u'بُلُوغٌ خَبَر':Added, #1: 1	بُلُوغُ خَبَرٍ
u'بُلُوغٌ خَبَر':Added, #1: 1	بُلُوغُ خَبَرِ
u'بُلُوغٌ خَبَر':Added, #1: 1	بُلُوغِ خَبَرٍ
u'بُلُوغٌ خَبَرٌ':Added, #1: 1	بُلُوغِ خَبَرِ
u'بُلُوغٌ خَبَر':Added, #1: 1	بُلُوغِ خَبَرِهِ
u'بُلُوغٌ خِطَابٌ':Added, #1: 1	بُلُوغِ خَبَرِهِ
u'بُلُوغٌ خِطَابٌ':Added, #1: 1	بُلُوغِ خِطَابِ
u'بُلُوغٌ خَمْسٌ':Added, #4: 4	بُلُوغِ الْخِطَابِ
u'بُلُوغٌ درجة':Added, #1: 1	بُلُوغُ خَمْسٍ
u'بُلُوغٌ دَرَجَةٌ':Added, #1: 1	بُلُوغَ دَرَجَةِ
u'بُلُوغٌ دَعْوَةٌ':Added, #1: 1	بُلُوغَ دَرَجَةِ
u'بُلُوغٌ ذكر':Added, #5: 5	بُلُوغِ الدَّعْوَةِ
u'بُلُوغٌ ذَكَرٌ':Added, #1: 1	بُلُوغُ الذَّكَرِ
u'بُلُوغٌ رَجُلٌ':Added, #1: 1	بُلُوغُ الذَّكَرِ
u'بُلُوغٌ رَدٌّ':Added, #1: 1	بُلُوغِ الرَّجُلِ
u'بُلُوغٌ رِسَالَةٌ':Added, #2: 2	بُلُوغِ الرَّدِّ
u'بُلُوغٌ رُشْدٌ':Added, #1: 1	بُلُوغِ الرِّسَالَةِ
u'بُلُوغٌ زَرْعٌ':Added, #1: 1	بُلُوغِ الرُّشْدِ
u'بُلُوغٌ زَمَنٌ':Added, #1: 1	بُلُوغِ الزَّرْعِ
u'بُلُوغٌ زَوْجٌ':Added, #1: 1	بُلُوغِ زَمَنِ
u'بُلُوغٌ زَوْجٌ':Added, #1: 1	بُلُوغِ زَوْجٍ
u'بُلُوغٌ زَوْجٌ':Added, #2: 2	بُلُوغِ الزَّوْجِ
u'بُلُوغٌ سَبْعٌ':Added, #3: 3	بُلُوغُ الزَّوْجِ
u'بُلُوغٌ سِنٌّ':Added, #2: 2	بُلُوغِ السَّبْعِ
u'بُلُوغٌ سِنٌّ':Added, #1: 1	بُلُوغَ سِنِّ
u'بُلُوغٌ شَاةٌ':Added, #1: 1	بُلُوغِ سِنِّ
u'بُلُوغٌ شَاةٌ':Added, #1: 1	بُلُوغِ الشَّاةِ
u'بُلُوغٌ شَرْعٌ':Added, #1: 1	بُلُوغِ شَاةِ
u'بُلُوغٌ شكر':Added, #5: 5	بُلُوغِ الشَّرْعِ
u'بُلُوغٌ شُكْرٌ':Added, #1: 1	بُلُوغُ الشُّكْرِ
u'بُلُوغٌ شَهْوَةٌ':Added, #1: 1	بُلُوغُ الشُّكْرِ
u'بُلُوغٌ صَاحِبٌ':Added, #1: 1	بُلُوغِ الشَّهْوَةِ
u'بُلُوغٌ صَبِيٌّ':Added, #1: 1	بُلُوغِ صَاحِبِ
u'بُلُوغٌ صَبِيٌّ':Added, #1: 1	بُلُوغَ الصَّبِيِّ
u'بُلُوغٌ صَبِيٌّ':Added, #1: 1	بُلُوغُ الصَّبِيَّةِ
u'بُلُوغٌ صَبِيٌّ':Added, #1: 1	بُلُوغِ صَبِيَّةٍ
u'بُلُوغٌ صَبِيٌّ':Added, #2: 2	بُلُوغُ الصَّبِيِّ
u'بُلُوغٌ صغار':Added, #7: 7	بُلُوغِ الصَّبِيِّ
u'بُلُوغٌ صغار':Added, #1: 1	بُلُوغَ الصِّغَارِ
u'بُلُوغٌ صغار':Added, #1: 1	بُلُوغُ الصِّغَارِ
u'بُلُوغٌ صَغِيرٌ':Added, #4: 4	بُلُوغِ الصِّغَارِ
u'بُلُوغٌ صَغِيرٌ':Added, #2: 2	بُلُوغُ الصَّغِيرِ
u'بُلُوغٌ صَوْتٌ':Added, #6: 6	بُلُوغِ الصَّغِيرِ
u'بُلُوغٌ صَوْتٌ':Added, #1: 1	بُلُوغَ الصَّوْتِ
u'بُلُوغٌ صَوْتٌ':Added, #1: 1	بُلُوغِ صَوْتِهِ
u'بُلُوغٌ ظِلٌّ':Added, #3: 3	بُلُوغِ الصَّوْتِ
u'بُلُوغٌ عَاقِدٌ':Added, #3: 3	بُلُوغِ الظِّلِّ
u'بُلُوغٌ عَدَدٌ':Added, #1: 1	بُلُوغُ الْعَاقِدِ
u'بُلُوغٌ عَشْرٌ':Added, #2: 2	بُلُوغُ عَدَدِ
u'بُلُوغٌ غَايَةٌ':Added, #2: 2	بُلُوغِ الْعَشْرِ
u'بُلُوغٌ غَايَةٌ':Added, #1: 1	بُلُوغِ الْغَايَةِ
u'بُلُوغٌ غَرَضٌ':Added, #1: 1	بُلُوغِ غَايَةٍ
u'بُلُوغٌ غُلاَمٌ':Added, #3: 3	بُلُوغِ الْغَرَضِ
u'بُلُوغٌ غَلَّةٌ':Added, #5: 5	بُلُوغُ الْغُلَامِ
u'بُلُوغٌ قَاذِفٌ':Added, #1: 1	بُلُوغِ الْغَلَّةِ
u'بُلُوغٌ قَدْرٌ':Added, #1: 1	بُلُوغَ الْقَاذِفِ
u'بُلُوغٌ قُلُوبٌ':Added, #1: 1	بُلُوغِ قَدْرِ
u'بُلُوغٌ قِيمَةٌ':Added, #1: 1	بُلُوغِ الْقُلُوبِ
u'بُلُوغٌ كِتَابٌ':Added, #2: 2	بُلُوغُ قِيمَتِهِ
u'بُلُوغٌ كَدَرٌ':Added, #4: 4	بُلُوغِ الْكِتَابِ
u'بُلُوغٌ مَاءٌ':Added, #1: 1	بُلُوغِ الْكَدَرِ
u'بُلُوغٌ مَالٌ':Added, #2: 2	بُلُوغِ الْمَاءِ
u'بُلُوغٌ مُتَلَذِّذ':Added, #1: 1	بُلُوغُ الْمَالِ
u'بُلُوغٌ مُتَلَذِّذ':Added, #1: 1	بُلُوغُ الْمُتَلَذِّذِ
u'بُلُوغٌ مثل':Added, #1: 1	بُلُوغِ الْمُتَلَذِّذِ
u'بُلُوغٌ مِثْلٌ':Added, #1: 1	بُلُوغِ مِثْلِهِ
u'بُلُوغٌ مَحَلٌّ':Added, #1: 1	بُلُوغِ مِثْلِهِ
u'بُلُوغٌ مراد':Added, #1: 1	بُلُوغِ مَحَلِّهِ
u'بُلُوغٌ مراد':Added, #1: 1	بُلُوغُ الْمُرَادِ
u'بُلُوغٌ مُرَادٌ':Added, #1: 1	بُلُوغِ الْمُرَادِ
u'بُلُوغٌ مُرَادٌ':Added, #1: 1	بُلُوغُ الْمُرَادِ
u'بُلُوغٌ مُصَابٌ':Added, #1: 1	بُلُوغِ الْمُرَادِ
u'بُلُوغٌ مَعْرِفَةٌ':Added, #1: 1	بُلُوغُ مُصَابِ
u'بُلُوغٌ مَعْرِفَة':Added, #1: 1	بُلُوغِ مَعْرِفَةِ
u'بُلُوغٌ مَفْعُولٌ':Added, #1: 1	بُلُوغِ مَعْرِفَةِ
u'بُلُوغٌ مُقَدَّرٌ':Added, #1: 1	بُلُوغُ الْمَفْعُولِ
u'بُلُوغٌ مَقْصِدٌ':Added, #1: 1	بُلُوغِ الْمُقَدَّرِ
u'بُلُوغٌ مُكَلَّفٌ':Added, #1: 1	بُلُوغِ الْمَقْصِدِ
u'بُلُوغٌ نَاسِخٌ':Added, #2: 2	بُلُوغِ الْمُكَلَّفِ
u'بُلُوغٌ نَاسِخ':Added, #4: 4	بُلُوغِ النَّاسِخِ
u'بُلُوغٌ نِدَاءٌ':Added, #4: 4	بُلُوغِ النَّاسِخِ
u'بُلُوغٌ نصاب':Added, #1: 1	بُلُوغَ النِّدَاءِ
u'بُلُوغٌ نِصَابٌ':Added, #4: 4	بُلُوغِ النِّصَابِ
u'بُلُوغٌ نِصْفٌ':Added, #4: 4	بُلُوغِ النِّصَابِ
u'بُلُوغٌ نَفْسٌ':Added, #1: 1	بُلُوغِ النِّصْفِ
u'بُلُوغٌ نكاح':Added, #1: 1	بُلُوغُ النَّفْسِ
u'بُلُوغٌ نكاح':Added, #1: 1	بُلُوغَ النِّكَاحِ
u'بُلُوغٌ نكاح':Added, #1: 1	بُلُوغُ النِّكَاحِ
u'بُلُوغٌ نِكَاحٌ':Added, #1: 1	بُلُوغِ النِّكَاحِ
u'بُلُوغٌ نِكَاحٌ':Added, #1: 1	بُلُوغَ النِّكَاحِ
u'بُلُوغٌ نِكَاحٌ':Added, #1: 1	بُلُوغُ النِّكَاحِ
u'بُلُوغٌ نِهَايَةٌ':Added, #1: 1	بُلُوغِ النِّكَاحِ
u'بُلُوغٌ هَدْيٌ':Added, #1: 1	بُلُوغِ النِّهَايَةِ
u'بُلُوغٌ همزة':Added, #1: 1	بُلُوغِ الْهَدْيِ
u'بُلُوغٌ هَمْزَةٌ':Added, #1: 1	بُلُوغِ هَمْزَةِ
u'بُلُوغٌ واحد':Added, #1: 1	بُلُوغِ هَمْزَةِ
u'بُلُوغٌ وَاحِدٌ':Added, #1: 1	بُلُوغَ الْوَاحِدِ
u'بُلُوغٌ وَارِثٌ':Added, #1: 1	بُلُوغَ الْوَاحِدِ
u'بُلُوغٌ وَاطِئٌ':Added, #1: 1	بُلُوغِ الْوَارِثِ
u'بُلُوغٌ وَقْتٌ':Added, #1: 1	بُلُوغُ الْوَاطِئِ
u'بُلُوغٌ ولد':Added, #1: 1	بُلُوغُ وَقْتِ
u'بُلُوغٌ وَلَدٌ':Added, #3: 3	بُلُوغِ الْوَلَدِ
u'بُلُوغٌ يَتِيمٌ':Added, #3: 3	بُلُوغِ الْوَلَدِ
u'بَلِيَ أَوَّلُ':Subject, #2: 2	بُلُوغِ الْيَتِيمِ
u'بَلِيَ خَشَبٌ':Subject, #1: 1	بَلِيَ الْأَوَّلُ
u'بَلِيَ عَظْمٌ':Subject, #1: 1	بَلِيَ خَشَبُ
u'بَلِيَ قَالٌ':Predicate, #2: 2	بَلِيَ الْعَظْمُ
u'بَلِيَ مُصْحَفٌ':Subject, #1: 1	بَلِيَ قَالَ
u'بَلِيَ مُصْحَفٌ':Subject, #1: 1	بَلِيَ الْمُصْحَفُ
u'بِنَاءٌ اِبْنٌ':Added, #1: 1	بَلِيَ مُصْحَفٌ
u'بِنَاءٌ اِجْتِهَادٌ':Added, #4: 4	بِنَاءِ ابْنِ
u'بِنَاءٌ أحَدٌ':Added, #1: 1	بِنَاءُ اجْتِهَادِهِ
u'بِنَاءٌ إِحْرَامٌ':Added, #1: 1	بِنَاءِ أَحَدِ
u'بِنَاءٌ أَحْكَامٌ':Added, #1: 1	بِنَاءُ إحْرَامِ
u'بِنَاءٌ آخِرُ':Added, #1: 1	بِنَاءُ الْأَحْكَامِ
u'بِنَاءٌ أُخْرَى':Added, #1: 1	بِنَاءُ آخِرِ
u'بِنَاءٌ أرْضٌ':Added, #2: 2	بِنَاءُ الْأُخْرَيَيْنِ
u'بِنَاءٌ أرْضٌ':Added, #1: 1	بِنَاءِ أَرْضٍ
u'بِنَاءٌ أُسٌّ':Added, #1: 1	بِنَاءَ الْأَرْضِ
u'بِنَاءٌ أَسْفَلُ':Added, #1: 1	بِنَاءُ أُسِّهِ
u'بِنَاءٌ أَسْفَلُ':Added, #1: 1	بِنَاءَ الْأَسْفَلِ
u'بِنَاءٌ أَسْفَلُ':Added, #1: 1	بِنَاءُ الْأَسْفَلِ
u'بِنَاءٌ اِسْمٌ':Added, #1: 1	بِنَاءِ الْأَسْفَلِ
u'بِنَاءٌ أَسْوارٌ':Added, #1: 1	بِنَاءِ اسْمِ
u'بِنَاءٌ أصل':Added, #1: 1	بِنَاءِ الْأَسْوَارِ
u'بِنَاءٌ أًصْلٌ':Added, #1: 1	بِنَاءِ أَصْلِهِ
u'بِنَاءٌ أصل':Added, #1: 1	بِنَاءِ أَصْلِهِ
u'بِنَاءٌ أًصْلٌ':Added, #1: 1	بِنَاءُ الْأَصْلِ
u'بِنَاءٌ أَعْمَالٌ':Added, #1: 1	بِنَاءُ الْأَصْلِ
u'بِنَاءٌ أَعْمَالٌ':Added, #1: 1	بِنَاءَ أَعْمَالِ
u'بِنَاءٌ أَفْعَالٌ':Added, #1: 1	بِنَاءُ أَعْمَالِ
u'بِنَاءٌ أَفْعَالٌ':Added, #1: 1	بِنَاءُ أَفْعَالِ
u'بِنَاءٌ إِلْزَامٌ':Added, #1: 1	بِنَاءِ أَفْعَالِ
u'بِنَاءٌ إمَامٌ':Added, #1: 1	بِنَاءُ الْإِلْزَامِ
u'بِنَاءٌ إمَامَةٌ':Added, #1: 1	بِنَاءِ الْإِمَامِ
u'بِنَاءٌ أَمْرٌ':Added, #1: 1	بِنَاءَ الْإِمَامَةِ
u'بِنَاءٌ أَمْرٌ':Added, #1: 1	بِنَاءُ أَمْرٍ
u'بِنَاءٌ أَوَّلُ':Added, #1: 1	بِنَاءِ أَمْرِ
u'بِنَاءٌ أَوَّلُ':Added, #1: 1	بِنَاءَ الْأَوَّلِ
u'بِنَاءٌ أَوَّلُ':Added, #1: 1	بِنَاءِ الْأَوَّلِ
u'بِنَاءٌ إِيجَابٌ':Added, #1: 1	بِنَاءِ أَوّلِ
u'بِنَاءٌ بالُوعَةٌ':Added, #1: 1	بِنَاءُ إيجَابِ
u'بِنَاءٌ بَدَلٌ':Added, #1: 1	بِنَاءُ الْبَالُوعَةِ
u'بِنَاءٌ بَعْضٌ':Added, #1: 1	بِنَاءَ الْبَدَلِ
u'بِنَاءٌ بَعْضٌ':Added, #1: 1	بِنَاءَ بَعْضِ
u'بِنَاءٌ بَيْتٌ':Added, #1: 1	بِنَاءِ بَعْضِ
u'بِنَاءٌ بَيْتٌ':Added, #1: 1	بِنَاءَ الْبَيْتِ
u'بِنَاءٌ بَيْتٌ':Added, #1: 1	بِنَاءُ الْبَيْتِ
u'بِنَاءٌ بَيْتٌ':Added, #1: 1	بِنَاءَ بَيْتٍ
u'بِنَاءٌ بَيْتٌ':Added, #1: 1	بِنَاءِ بَيْتِ
u'بِنَاءٌ بَيْتٌ':Added, #4: 4	بِنَاءِ الْبَيْتِ
u'بِنَاءٌ بَيْعَةٌ':Added, #4: 4	بِنَاءِ بَيْتٍ
u'بِنَاءٌ بِيعَةٌ':Added, #1: 1	بِنَاءِ الْبَيْعَةِ
u'بِنَاءٌ بِيعَةٌ':Added, #2: 2	بِنَاءِ الْبِيعَةِ
u'بِنَاءٌ بُيُوتٌ':Added, #2: 2	بِنَاءُ بِيعَةٍ
u'بِنَاءٌ تَامٌّ':Added, #3: 3	بِنَاءِ بُيُوتِ
u'بِنَاءٌ تَعْرِيضٌ':Added, #1: 1	بِنَاءِ التَّامَّةِ
u'بِنَاءٌ تَنُّورٌ':Added, #1: 1	بِنَاءَ التَّعْرِيضِ
u'بِنَاءٌ جَارٌ':Added, #3: 3	بِنَاءِ التَّنُّورِ
u'بِنَاءٌ جَارٌ':Added, #1: 1	بِنَاءَ جَارٍ
u'بِنَاءٌ جَارٌ':Added, #1: 1	بِنَاءَ جَارِهِ
u'بِنَاءٌ جِدار':Added, #1: 1	بِنَاءِ جَارِهِ
u'بِنَاءٌ جِدار':Added, #1: 1	بِنَاءِ الْجِدَارِ
u'بِنَاءٌ جمعة':Added, #1: 1	بِنَاءَ جِدَارِ
u'بِنَاءٌ جُمُعَةٌ':Added, #1: 1	بِنَاءُ الْجُمُعَةِ
u'بِنَاءٌ جناح':Added, #1: 1	بِنَاءُ الْجُمُعَةِ
u'بِنَاءٌ جَنَاحٌ':Added, #1: 1	بِنَاءِ جَنَاحٍ
u'بِنَاءٌ جَوَابٌ':Added, #1: 1	بِنَاءِ جَنَاحٍ
u'بِنَاءٌ حالٌ':Added, #1: 1	بِنَاءُ الْجَوَابِ
u'بِنَاءٌ حانوتٌ':Added, #1: 1	بِنَاءَ الْحَالِ
u'بِنَاءٌ حائِطٌ':Added, #1: 1	بِنَاءِ الْحَانُوتِ
u'بِنَاءٌ حائِطٌ':Added, #1: 1	بِنَاءُ حَائِطٍ
u'بِنَاءٌ حائِطٌ':Added, #1: 1	بِنَاءِ حَائِطِ
u'بِنَاءٌ حائِطٌ':Added, #1: 1	بِنَاءُ حَائِطِهِ
u'بِنَاءٌ حائِطٌ':Added, #1: 1	بِنَاءِ حَائِطِهِ
u'بِنَاءٌ حائِطٌ':Added, #2: 2	بِنَاءِ الْحَائِطِ
u'بِنَاءٌ حائِطٌ':Added, #3: 3	بِنَاءَ حَائِطٍ
u'بِنَاءٌ حُروفٌ':Added, #4: 4	بِنَاءِ حَائِطٍ
u'بِنَاءٌ حِصْنٌ':Added, #1: 1	بِنَاءَ الْحُرُوفِ
u'بِنَاءٌ حُكْمٌ':Added, #1: 1	بِنَاءِ حِصْنٍ
u'بِنَاءٌ حُكْمٌ':Added, #1: 1	بِنَاءِ الْحُكْمِ
u'بِنَاءٌ حُكْمٌ':Added, #1: 1	بِنَاءُ حُكْمٍ
u'بِنَاءٌ حُكْمٌ':Added, #1: 1	بِنَاءُ حُكْمِ
u'بِنَاءٌ حُكْمٌ':Added, #2: 2	بِنَاءَ الْحُكْمِ
u'بِنَاءٌ حَمَّامٌ':Added, #6: 6	بِنَاءُ الْحُكْمِ
u'بِنَاءٌ حَمَّامٌ':Added, #1: 1	بِنَاءَ الْحَمَّامِ
u'بِنَاءٌ حَمَّامٌ':Added, #1: 1	بِنَاءِ الْحَمَّامِ
u'بِنَاءٌ حول':Added, #3: 3	بِنَاءُ الْحَمَّامِ
u'بِنَاءٌ حَوْلٌ':Added, #1: 1	بِنَاءِ حَوْلِهِ
u'بِنَاءٌ حيطانٌ':Added, #1: 1	بِنَاءِ حَوْلِهِ
u'بِنَاءٌ حيطانٌ':Added, #1: 1	بِنَاءِ حِيطَانِ
u'بِنَاءٌ خِلاَفٌ':Added, #2: 2	بِنَاءِ الْحِيطَانِ
u'بِنَاءٌ خِلاَفٌ':Added, #1: 1	بِنَاءَ الْخِلَافِ
u'بِنَاءٌ خِلاَفٌ':Added, #4: 4	بِنَاءِ الْخِلَافِ
u'بِنَاءٌ دَارٌ':Added, #6: 6	بِنَاءُ الْخِلَافِ
u'بِنَاءٌ دَارٌ':Added, #1: 1	بِنَاءِ دَارَيْنِ
u'بِنَاءٌ دَارٌ':Added, #2: 2	بِنَاءَ دَارٍ
u'بِنَاءٌ دَارٌ':Added, #2: 2	بِنَاءِ دَارِهِ
u'بِنَاءٌ دَارٌ':Added, #3: 3	بِنَاءُ الدَّارِ
u'بِنَاءٌ دَارٌ':Added, #3: 3	بِنَاءِ دَارٍ
u'بِنَاءٌ دَارٌ':Added, #5: 5	بِنَاءَ الدَّارِ
u'بِنَاءٌ دَكَّةٌ':Added, #6: 6	بِنَاءِ الدَّارِ
u'بِنَاءٌ دِكَّةٌ':Added, #1: 1	بِنَاءِ الدَّكَّةِ
u'بِنَاءٌ رباط':Added, #3: 3	بِنَاءِ الدِّكَّةِ
u'بِنَاءٌ رِبَاطٌ':Added, #1: 1	بِنَاءِ الرِّبَاطِ
u'بِنَاءٌ رِبَاطَاتٌ':Added, #1: 1	بِنَاءِ الرِّبَاطِ
u'بِنَاءٌ رَجُلٌ':Added, #1: 1	بِنَاءِ الرِّبَاطَاتِ
u'بِنَاءٌ رَجُلٌ':Added, #1: 1	بِنَاءُ الرَّجُلِ
u'بِنَاءٌ ساباط':Added, #1: 1	بِنَاءِ رَجُلٍ
u'بِنَاءٌ ساباط':Added, #1: 1	بِنَاءِ السَّابَاطِ
u'بِنَاءٌ سَاحَةٌ':Added, #2: 2	بِنَاءِ سَابَاطٍ
u'بِنَاءٌ سَاقِطٌ':Added, #1: 1	بِنَاءَ سَاحَتِهِ
u'بِنَاءٌ سَبِيلٌ':Added, #1: 1	بِنَاءِ السَّاقِطِ
u'بِنَاءٌ سترة':Added, #1: 1	بِنَاءُ السَّبِيلِ
u'بِنَاءٌ سُتْرَةٌ':Added, #2: 2	بِنَاءُ سُتْرَةٍ
u'بِنَاءٌ سِجْنٌ':Added, #2: 2	بِنَاءُ سُتْرَةٍ
u'بِنَاءٌ سُفْلٌ':Added, #1: 1	بِنَاءِ السِّجْنِ
u'بِنَاءٌ سُفْلٌ':Added, #3: 3	بِنَاءُ السُّفْلِ
u'بِنَاءٌ سَقْفٌ':Added, #6: 6	بِنَاءِ السُّفْلِ
u'بِنَاءٌ سَقْفٌ':Added, #1: 1	بِنَاء سَقْفِ
u'بِنَاءٌ سُلَّمٌ':Added, #2: 2	بِنَاءِ السَّقْفِ
u'بِنَاءٌ سُلَّمٌ':Added, #1: 1	بِنَاءَ السُّلَّمِ
u'بِنَاءٌ سورٌ':Added, #1: 1	بِنَاءِ السُّلَّمِ
u'بِنَاءٌ شَفْعٌ':Added, #1: 1	بِنَاءِ سُوَرٍ
u'بِنَاءٌ شَيْءٌ':Added, #1: 1	بِنَاءَ الشَّفْعِ
u'بِنَاءٌ صَاحِبٌ':Added, #1: 1	بِنَاءُ شَيْءٍ
u'بِنَاءٌ صَحِيحٌ':Added, #1: 1	بِنَاءِ صَاحِبِ
u'بِنَاءٌ صَدِيقٌ':Added, #1: 1	بِنَاءِ الصَّحِيحِ
u'بِنَاءٌ صَلاَةٌ':Added, #1: 1	بِنَاءَ صَدِيقِهِ
u'بِنَاءٌ صَلاَةٌ':Added, #1: 1	بِنَاءُ الصَّلَاةِ
u'بِنَاءٌ ضَعِيفٌ':Added, #1: 1	بِنَاءَ صَلَاةِ
u'بِنَاءٌ ضَعِيفٌ':Added, #1: 1	بِنَاءَ الضَّعِيفِ
u'بِنَاءٌ ضَمَانٌ':Added, #4: 4	بِنَاءُ الضَّعِيفِ
u'بِنَاءٌ طَاقٌ':Added, #1: 1	بِنَاءِ الضَّمَانِ
u'بِنَاءٌ طَائِفٌ':Added, #1: 1	بِنَاءُ الطَّاقِ
u'بِنَاءٌ ظُهْرٌ':Added, #1: 1	بِنَاءُ طَائِفَةٍ
u'بِنَاءٌ ظُهْرٌ':Added, #3: 3	بِنَاءُ الظُّهْرِ
u'بِنَاءٌ عَالٌ':Added, #3: 3	بِنَاءِ الظُّهْرِ
u'بِنَاءٌ عَامٌّ':Added, #1: 1	بِنَاءٍ عَالٍ
u'بِنَاءٌ عَامٌّ':Added, #1: 1	بِنَاءِ الْعَامِّ
u'بِنَاءٌ عَدَمٌ':Added, #4: 4	بِنَاءُ الْعَامِّ
u'بِنَاءٌ عَرَبٌ':Added, #1: 1	بِنَاءُ عَدَمِ
u'بِنَاءٌ عَرِيشٌ':Added, #1: 1	بِنَاءَ عَرَبٍ
u'بِنَاءٌ عَقْدٌ':Added, #1: 1	بِنَاءُ الْعَرِيشِ
u'بِنَاءٌ عَقْدٌ':Added, #1: 1	بِنَاءِ الْعَقْدِ
u'بِنَاءٌ عِلَّةٌ':Added, #2: 2	بِنَاءُ الْعَقْدِ
u'بِنَاءٌ عُلُوٌّ':Added, #1: 1	بِنَاءُ عِلَّةٍ
u'بِنَاءٌ عُلْوٌ':Added, #1: 1	بِنَاءِ الْعُلُوِّ
u'بِنَاءٌ عُلُوٌّ':Added, #1: 1	بِنَاءِ الْعُلْوِ
u'بِنَاءٌ عُلْوٌ':Added, #1: 1	بِنَاءِ عُلُوِّهِ
u'بِنَاءٌ عُلْوٌ':Added, #1: 1	بِنَاءَ عُلْوِهِ
u'بِنَاءٌ عمرة':Added, #1: 1	بِنَاءُ عُلْوِهِ
u'بِنَاءٌ عُمْرَةٌ':Added, #1: 1	بِنَاءَ الْعُمْرَةِ
u'بِنَاءٌ غَاصِبٌ':Added, #1: 1	بِنَاءَ الْعُمْرَةِ
u'بِنَاءٌ غَائِبٌ':Added, #1: 1	بِنَاءِ الْغَاصِبِ
u'بِنَاءٌ غير':Added, #1: 1	بِنَاءُ الْغَائِبِ
u'بِنَاءٌ غَيْرٌ':Added, #1: 1	بِنَاءُ غَيْرِ
u'بِنَاءٌ غير':Added, #1: 1	بِنَاءُ غَيْرِ
u'بِنَاءٌ غَيْرٌ':Added, #1: 1	بِنَاءُ غَيْرِهِ
u'بِنَاءٌ غير':Added, #1: 1	بِنَاءُ غَيْرِهِ
u'بِنَاءٌ غَيْرٌ':Added, #2: 2	بِنَاءِ غَيْرِ
u'بِنَاءٌ غير':Added, #2: 2	بِنَاءِ غَيْرِ
u'بِنَاءٌ غَيْرٌ':Added, #3: 3	بِنَاءِ غَيْرِهِ
u'بِنَاءٌ فَاعِلٌ':Added, #3: 3	بِنَاءِ غَيْرِهِ
u'بِنَاءٌ فَاعِلٌ':Added, #1: 1	بِنَاءُ فَاعِلٍ
u'بِنَاءٌ فَذٌّ':Added, #5: 5	بِنَاءِ الْفَاعِلِ
u'بِنَاءٌ فَرْضٌ':Added, #1: 1	بِنَاءِ الْفَذِّ
u'بِنَاءٌ فَرْضٌ':Added, #10: 10	بِنَاءُ الْفَرْضِ
u'بِنَاءٌ فَرْضٌ':Added, #1: 1	بِنَاءَ الْفَرْضِ
u'بِنَاءٌ فَرْضٌ':Added, #1: 1	بِنَاءُ فَرْضٍ
u'بِنَاءٌ فَرْعٌ':Added, #2: 2	بِنَاءِ الْفَرْضِ
u'بِنَاءٌ فِعْلٌ':Added, #1: 1	بِنَاءِ فَرْعٍ
u'بِنَاءٌ فَوْرٌ':Added, #2: 2	بِنَاءُ الْفِعْلِ
u'بِنَاءٌ قَبْرٌ':Added, #1: 1	بِنَاءُ الْفَوْرِ
u'بِنَاءٌ قُبُورٌ':Added, #2: 2	بِنَاءُ الْقَبْرِ
u'بِنَاءٌ قُبُورٌ':Added, #1: 1	بِنَاءُ الْقُبُورِ
u'بِنَاءٌ قُرَيْشٌ':Added, #2: 2	بِنَاءِ الْقُبُورِ
u'بِنَاءٌ قَصْرٌ':Added, #1: 1	بِنَاءِ قُرَيْشٍ
u'بِنَاءٌ قَنَاطِرُ':Added, #1: 1	بِنَاءَ قَصْرٍ
u'بِنَاءٌ قَنَاطِرُ':Added, #2: 2	بِنَاءُ الْقَنَاطِرِ
u'بِنَاءٌ قَنْطَرَةٌ':Added, #2: 2	بِنَاءِ الْقَنَاطِرِ
u'بِنَاءٌ قَنْطَرَةٌ':Added, #1: 1	بِنَاءَ قَنْطَرَةٍ
u'بِنَاءٌ قَنْطَرَةٌ':Added, #1: 1	بِنَاءُ قَنْطَرَةٍ
u'بِنَاءٌ قَنْطَرَةٌ':Added, #1: 1	بِنَاءِ قَنْطَرَةٍ
u'بِنَاءٌ قول':Added, #4: 4	بِنَاءُ الْقَنْطَرَةِ
u'بِنَاءٌ قَوْلٌ':Added, #2: 2	بِنَاءُ قَوْلِهِ
u'بِنَاءٌ قَوِيٌّ':Added, #2: 2	بِنَاءُ قَوْلِهِ
u'بِنَاءٌ قَوِيٌّ':Added, #13: 13	بِنَاءُ الْقَوِيِّ
u'بِنَاءٌ قَوِيٌّ':Added, #3: 3	بِنَاءَ الْقَوِيِّ
u'بِنَاءٌ كعبة':Added, #5: 5	بِنَاءِ الْقَوِيِّ
u'بِنَاءٌ كَعْبَةٌ':Added, #2: 2	بِنَاءُ الْكَعْبَةِ
u'بِنَاءٌ كعبة':Added, #2: 2	بِنَاءُ الْكَعْبَةِ
u'بِنَاءٌ كَعْبَةٌ':Added, #6: 6	بِنَاءِ الْكَعْبَةِ
u'بِنَاءٌ كعبة':Added, #6: 6	بِنَاءِ الْكَعْبَةِ
u'بِنَاءٌ كَعْبَةٌ':Added, #8: 8	بِنَاءَ الْكَعْبَةِ
u'بِنَاءٌ كَلاَمٌ':Added, #8: 8	بِنَاءَ الْكَعْبَةِ
u'بِنَاءٌ كَلاَمٌ':Added, #1: 1	بِنَاءُ الْكَلَامِ
u'بِنَاءٌ كَنِيسَةٌ':Added, #1: 1	بِنَاءُ كَلَامِهِ
u'بِنَاءٌ مَالِكٌ':Added, #1: 1	بِنَاءِ كَنِيسَةٍ
u'بِنَاءٌ مُبَالَغَةٌ':Added, #1: 1	بِنَاءِ الْمَالِكِ
u'بِنَاءٌ مُبَالَغَةٌ':Added, #1: 1	بِنَاءِ الْمُبَالَغَةِ
u'بِنَاءٌ مُبَالَغَةٌ':Added, #1: 1	بِنَاءَ مُبَالَغَةٍ
u'بِنَاءٌ مُتَّسِعٌ':Added, #1: 1	بِنَاءُ مُبَالَغَةٍ
u'بِنَاءٌ مثل':Added, #1: 1	بِنَاءٍ مُتَّسِعٍ
u'بِنَاءٌ مِثْلٌ':Added, #2: 2	بِنَاءَ الْمِثْلِ
u'بِنَاءٌ مُحْدَثٌ':Added, #2: 2	بِنَاءَ الْمِثْلِ
u'بِنَاءٌ مُرابَحَة':Added, #1: 1	بِنَاءٍ مُحْدَثٍ
u'بِنَاءٌ مِرْحَاضٌ':Added, #3: 3	بِنَاءُ الْمُرَابَحَةِ
u'بِنَاءٌ مَسَاجِدُ':Added, #1: 1	بِنَاءِ مِرْحَاضٍ
u'بِنَاءٌ مَسَاجِدُ':Added, #2: 2	بِنَاءُ الْمَسَاجِدِ
u'بِنَاءٌ مَسْأَلَةٌ':Added, #3: 3	بِنَاءِ الْمَسَاجِدِ
u'بِنَاءٌ مَسْأَلَةٌ':Added, #1: 1	بِنَاءَ الْمَسْأَلَةِ
u'بِنَاءٌ مَسْأَلَةٌ':Added, #1: 1	بِنَاءُ الْمَسْأَلَةِ
u'بِنَاءٌ مَسْأَلَةٌ':Added, #1: 1	بِنَاءَ مَسْأَلَةٍ
u'بِنَاءٌ مُسْتَأْجِرٌ':Added, #1: 1	بِنَاءُ مَسْأَلَةِ
u'بِنَاءٌ مُسْتَعِيرٌ':Added, #1: 1	بِنَاءِ الْمُسْتَأْجِرِ
u'بِنَاءٌ مُسْتَعِيرٌ':Added, #1: 1	بِنَاءَ الْمُسْتَعِيرِ
u'بِنَاءٌ مُسْتَقْبَلٌ':Added, #1: 1	بِنَاءِ الْمُسْتَعِيرِ
u'بِنَاءٌ مَسْجِدٌ':Added, #1: 1	بِنَاءُ الْمُسْتَقْبَلِ
u'بِنَاءٌ مَسْجِدٌ':Added, #1: 1	بِنَاءُ مَسْجِدِ
u'بِنَاءٌ مَسْجِدٌ':Added, #1: 1	بِنَاءِ مَسْجِدِ
u'بِنَاءٌ مَسْجِدٌ':Added, #23: 23	بِنَاءِ الْمَسْجِدِ
u'بِنَاءٌ مَسْجِدٌ':Added, #2: 2	بِنَاءَ مَسْجِدٍ
u'بِنَاءٌ مَسْجِدٌ':Added, #3: 3	بِنَاءَ الْمَسْجِدِ
u'بِنَاءٌ مَسْجِدٌ':Added, #5: 5	بِنَاءُ مَسْجِدٍ
u'بِنَاءٌ مَسْجِدٌ':Added, #8: 8	بِنَاءُ الْمَسْجِدِ
u'بِنَاءٌ مُسَقَّف':Added, #9: 9	بِنَاءِ مَسْجِدٍ
u'بِنَاءٌ مُسْلِمٌ':Added, #1: 1	بِنَاءٍ مُسَقَّفٍ
u'بِنَاءٌ مَشْهُورٌ':Added, #2: 2	بِنَاءُ الْمُسْلِمِ
u'بِنَاءٌ مَصَادِرُ':Added, #1: 1	بِنَاءِ مَشْهُورٍ
u'بِنَاءٌ مَعْطُوف':Added, #1: 1	بِنَاءِ الْمَصَادِرِ
u'بِنَاءٌ مَعْلُومٌ':Added, #1: 1	بِنَاءُ الْمَعْطُوفِ
u'بِنَاءٌ مَعْلُومٌ':Added, #1: 1	بِنَاءٍ مَعْلُومٍ
u'بِنَاءٌ مَفْعُولٌ':Added, #1: 1	بِنَاءِ مَعْلُومٍ
u'بِنَاءٌ مَفْعُولٌ':Added, #12: 12	بِنَاءِ الْمَفْعُولِ
u'بِنَاءٌ مَفْقُودٌ':Added, #1: 1	بِنَاءُ الْمَفْعُولِ
u'بِنَاءٌ مُقِيمٌ':Added, #1: 1	بِنَاءٍ مَفْقُودٍ
u'بِنَاءٌ مِلْكٌ':Added, #2: 2	بِنَاءِ مُقِيمٍ
u'بِنَاءٌ مَنَارٌ':Added, #1: 1	بِنَاءَ مِلْكِهِ
u'بِنَاءٌ مَنَارٌ':Added, #1: 1	بِنَاءُ الْمَنَارَةِ
u'بِنَاءٌ مَنَارٌ':Added, #1: 1	بِنَاءِ الْمَنَارَةِ
u'بِنَاءٌ مَنَارٌ':Added, #1: 1	بِنَاءُ مَنَارَةٍ
u'بِنَاءٌ مِنْبَرٌ':Added, #1: 1	بِنَاءُ مَنَارَةِ
u'بِنَاءٌ مِنْبَرٌ':Added, #1: 1	بِنَاءُ مِنْبَرِهِ
u'بِنَاءٌ مَوْجُودٌ':Added, #2: 2	بِنَاءِ الْمِنْبَرِ
u'بِنَاءٌ مَوْجُودٌ':Added, #1: 1	بِنَاءَ الْمَوْجُودِ
u'بِنَاءٌ نَاسٌ':Added, #2: 2	بِنَاءُ الْمَوْجُودِ
u'بِنَاءٌ نَصٌّ':Added, #1: 1	بِنَاءِ النَّاسِ
u'بِنَاءٌ نَفْلٌ':Added, #1: 1	بِنَاءِ النَّصِّ
u'بِنَاءٌ نَفْلٌ':Added, #2: 2	بِنَاءِ النَّفْلِ
u'بِنَاءٌ واحد':Added, #3: 3	بِنَاءُ النَّفْلِ
u'بِنَاءٌ وَاحِدٌ':Added, #1: 1	بِنَاءٍ وَاحِدٍ
u'بِنَاءٌ وَارِثٌ':Added, #1: 1	بِنَاءٍ وَاحِدٍ
u'بِنَاءٌ وسط':Added, #1: 1	بِنَاءِ الْوَارِثِ
u'بِنَاءٌ وَسَطٌ':Added, #1: 1	بِنَاءِ الْوَسَطِ
u'بِنَاءٌ وَقْفٌ':Added, #1: 1	بِنَاءِ الْوَسَطِ
u'بِنَاءٌ وُقُوعٌ':Added, #9: 9	بِنَاءِ الْوَقْفِ
u'بَنَى اِبْنٌ':Subject, #1: 1	بِنَاءِ وُقُوعِهِ
u'بَنَى أَحْكَامٌ':Predicate, #1: 1	بَنَى ابْنُ
u'بَنَى أَصْحَابٌ':Subject, #1: 1	بَنَى الْأَحْكَامَ
u'بَنَى أظهر':Subject, #1: 1	بَنَى الْأَصْحَابُ
u'بَنَى إعْطَاءٌ':Predicate, #1: 1	بَنَى أَظْهَرُ
u'بَنَى إفْرِيقِيٌّ':Predicate, #1: 1	بَنَى الْإِعْطَاءَ
u'بَنَى إمَامٌ':Subject, #1: 1	بَنَى إفْرِيقِيّةَ
u'بَنَى أَمْرٌ':Predicate, #1: 1	بَنَى الْإِمَامُ
u'بَنَى أهْلٌ':Subject, #7: 7	بَنَى الْأَمْرَ
u'بَنَى أَوَّلُ':Subject, #4: 4	بَنَى أَهْلُ
u'بَنَى إيقَاعٌ':Predicate, #1: 1	بَنَى الْأَوَّلُ
u'بَنَى أَيْمَانٌ':Predicate, #1: 1	بَنَى الْإِيقَاعَ
u'بَنَى باقِي':Predicate, #1: 1	بَنَى الْأَيْمَانَ
u'بَنَى بُخَارِيٌّ':Subject, #1: 1	بَنَى الْبَاقِيَ
u'بَنَى بَعْضٌ':Predicate, #1: 1	بَنَى الْبُخَارِيُّ
u'بَنَى بَعْضٌ':Subject, #3: 3	بَنَى بَعْضَ
u'بَنَى بَيْتٌ':Predicate, #2: 2	بَنَى بَعْضُ
u'بَنَى تَرَاوِيحُ':Predicate, #1: 1	بَنَى الْبَيْتَ
u'بَنَى تَعْرِيفٌ':Predicate, #1: 1	بَنَى التَّرَاوِيحَ
u'بَنَى جَازٌ':Predicate, #1: 1	بَنَى التَّعْرِيفَ
u'بَنَى جِدار':Predicate, #1: 1	بَنَى جَازَ
u'بَنَى جِوَارٌ':Predicate, #2: 2	بَنَى الْجِدَارَ
u'بَنَى حارِثٌ':Predicate, #2: 2	بَنَى جِوَارَ
u'بَنَى حاكِمٌ':Subject, #1: 1	بَنَى حَارِثَةَ
u'بَنَى حائِطٌ':Predicate, #1: 1	بَنَى الْحَاكِمُ
u'بَنَى حُكْمٌ':Predicate, #5: 5	بَنَى الْحَائِطَ
u'بَنَى حُكْمٌ':Predicate, #1: 1	بَنَى حُكْمَ
u'بَنَى خِلاَفٌ':Predicate, #2: 2	بَنَى الْحُكْمَ
u'بَنَى دَارٌ':Predicate, #4: 4	بَنَى الْخِلَافَ
u'بَنَى رَبُّ':Subject, #1: 1	بَنَى الدَّارَ
u'بَنَى رباط':Predicate, #3: 3	بَنَى رَبُّ
u'بَنَى رِبَاطٌ':Predicate, #2: 2	بَنَى الرِّبَاطَ
u'بَنَى رَجُلٌ':Subject, #2: 2	بَنَى الرِّبَاطَ
u'بَنَى رَجُلٌ':Subject, #2: 2	بَنَى الرَّجُلُ
u'بَنَى رَسُولٌ':Subject, #7: 7	بَنَى رَجُلٌ
u'بَنَى سُفْلٌ':Predicate, #2: 2	بَنَى رَسُولُ
u'بَنَى شافِعِيّ':Subject, #1: 1	بَنَى السُّفْلَ
u'بَنَى شَرِيكٌ':Subject, #4: 4	بَنَى الشَّافِعِيُّ
u'بَنَى شَفِيعٌ':Subject, #1: 1	بَنَى الشَّرِيكُ
u'بَنَى صَاحِبٌ':Subject, #1: 1	بَنَى الشَّفِيعُ
u'بَنَى ضَعِيفٌ':Predicate, #7: 7	بَنَى صَاحِبُ
u'بَنَى طَائِفٌ':Subject, #1: 1	بَنَى الضَّعِيفَ
u'بَنَى عَامٌّ':Predicate, #2: 2	بَنَى طَائِفَةٌ
u'بَنَى عَرْصَةٌ':Predicate, #1: 1	بَنَى الْعَامَّ
u'بَنَى عُمَرٌ':Predicate, #3: 3	بَنَى الْعَرْصَةَ
u'بَنَى عند':Predicate, #1: 1	بَنَى عُمَرَ
u'بَنَى غَاصِبٌ':Subject, #1: 1	بَنَى عِنْدَ
u'بَنَى غير':Subject, #2: 2	بَنَى الْغَاصِبُ
u'بَنَى غَيْرٌ':Subject, #1: 1	بَنَى غَيْرُ
u'بَنَى فرق':Predicate, #1: 1	بَنَى غَيْرُ
u'بَنَى فَرْقٌ':Predicate, #1: 1	بَنَى الْفَرْقَ
u'بَنَى فقهاء':Subject, #1: 1	بَنَى الْفَرْقَ
u'بَنَى فلان':Predicate, #1: 1	بَنَى الْفُقَهَاءُ
u'بَنَى فلان':Predicate, #1: 1	بَنَى الرَّازِيَّ
u'بَنَى فُلاَنٌ':Subject, #1: 1	بَنَى سَمَرْقَنْدَ
u'بَنَى فلان':Subject, #3: 3	بَنَى فُلَانٌ
u'بَنَى قَوْمٌ':Subject, #4: 4	بَنَى الشَّافِعِيُّ
u'بَنَى قَوِيٌّ':Predicate, #3: 3	بَنَى قَوْمٌ
u'بَنَى كعبة':Predicate, #1: 1	بَنَى الْقَوِيَّ
u'بَنَى كَعْبَةٌ':Predicate, #1: 1	بَنَى الْكَعْبَةَ
u'بَنَى كَلاَمٌ':Predicate, #1: 1	بَنَى الْكَعْبَةَ
u'بَنَى مَالِكٌ':Subject, #2: 2	بَنَى الْكَلَامَ
u'بَنَى مُحَمَّدٌ':Subject, #1: 1	بَنَى مَالِكُ
u'بَنَى مَدِينٌ':Predicate, #1: 1	بَنَى مُحَمَّدٌ
u'بَنَى مَدِينَةٌ':Predicate, #1: 1	بَنَى مَدِينَةَ
u'بَنَى مَسْأَلَةٌ':Predicate, #1: 1	بَنَى مَدِينَةَ
u'بَنَى مَسَائِلُ':Predicate, #2: 2	بَنَى مَسْأَلَةَ
u'بَنَى مُسْتَأْجِرٌ':Subject, #1: 1	بَنَى مَسَائِلَ
u'بَنَى مُسْتَأْجِرٌ':Subject, #1: 1	بَنَى مُسْتَأْجِرٌ
u'بَنَى مَسْجِدٌ':Predicate, #3: 3	بَنَى الْمُسْتَأْجِرُ
u'بَنَى مَسْجِدٌ':Predicate, #4: 4	بَنَى الْمَسْجِدَ
u'بَنَى مُسْلِمٌ':Subject, #6: 6	بَنَى مَسْجِدَ
u'بَنَى مُصَنِّفٌ':Subject, #2: 2	بَنَى مُسْلِمٌ
u'بَنَى مَنْعٌ':Predicate, #1: 1	بَنَى الْمُصَنِّفُ
u'بَنَى مُؤَجِّرٌ':Subject, #1: 1	بَنَى الْمَنْعَ
u'بَنَى نَبِيٌّ':Subject, #2: 2	بَنَى الْمُؤَجِّرُ
u'بَنَى نَفَلٌ':Predicate, #1: 1	بَنَى النَّبِيُّ
u'بَنَى نِيَّةٌ':Predicate, #2: 2	بَنَى النَّفَلَ
u'بَنَى واحد':Subject, #1: 1	بَنَى النِّيَّةَ
u'بَنَى وَاحِدٌ':Subject, #1: 1	بَنَى وَاحِدٌ
u'بَنَى وَارِثٌ':Subject, #1: 1	بَنَى وَاحِدٌ
u'بَنَى وُجُوبٌ':Predicate, #2: 2	بَنَى الْوَارِثُ
u'بَهَاءٌ دِينٌ':Added, #1: 1	بَنَى وُجُوبَ
u'بَهَاءٌ دِينٌ':Added, #1: 1	بَهَاءِ الدِّينِ
u'بَهَاءٌ علم':Added, #8: 8	بَهَاءُ الدِّينِ
u'بَهَاءٌ عِلْمٌ':Added, #1: 1	بَهَاءُ الْعِلْمِ
u'بَهَاءٌ وَجْهٌ':Added, #1: 1	بَهَاءُ الْعِلْمِ
u'بَهْجَةٌ إيمَانٌ':Added, #1: 1	بَهَاءَ الْوَجْهِ
u'بَهْجَةٌ بَيَانٌ':Added, #1: 1	بَهْجَةِ الْإِيمَانِ
u'بَهْجَةٌ مَجَالِسُ':Added, #1: 1	بَهْجَةَ بَيَانِهِ
u'بَهْجَةٌ مَجَالِسُ':Added, #19: 19	بَهْجَةِ الْمَجَالِسِ
u'بَهْجَةٌ مَجَالِسُ':Added, #1: 1	بَهْجَة الْمَجَالِسِ
u'بَهْجَةٌ مُعَوَّلٌ':Added, #4: 4	بَهْجَةُ الْمَجَالِسِ
u'بَهَرَ شمس':Predicate, #1: 1	بَهْجَةُ الْمُعَوَّلِ
u'بَهَرَ شَمْسٌ':Predicate, #1: 1	بَهَرَ الشَّمْسَ
u'بَوَّأَ أمَةٌ':Predicate, #1: 1	بَهَرَ الشَّمْسَ
u'بَوَّبَ بُخَارِيٌّ':Subject, #2: 2	بَوَّأَ الْأَمَةَ
u'بَوَّبَ سَعِيدٌ':Subject, #1: 1	بَوَّبَ الْبُخَارِيُّ
u'بَوَّرَ أرْضٌ':Predicate, #1: 1	بَوَّبَ سَعِيدُ
u'بُؤْسٌ زَمَنٌ':Added, #1: 1	بَوَّرَ أَرْضَ
u'بُؤْسٌ لَبِيبٌ':Added, #1: 1	بُؤْسِ زَمَنِهِ
u'بَوْلٌ إِبِلٌ':Added, #1: 1	بُؤْسُ اللَّبِيبِ
u'بَوْلٌ إِبِلٌ':Added, #1: 1	بَوْلَ الْإِبِلِ
u'بَوْلٌ آدَمِيٌّ':Added, #2: 2	بَوْلِ الْإِبِلِ
u'بَوْلٌ آدَمِيٌّ':Added, #2: 2	بَوْلَ الْآدَمِيِّ
u'بَوْلٌ آدَمِيٌّ':Added, #2: 2	بَوْلِ الْآدَمِيِّ
u'بَوْلٌ آدَمِيٌّ':Added, #3: 3	بَوْلَ آدَمِيٍّ
u'بَوْلٌ أَعْرابٌ':Added, #3: 3	بَوْلُ الْآدَمِيِّ
u'بَوْلٌ أعْرَابِيٌّ':Added, #1: 1	بَوْلِ الْأَعْرَابِ
u'بَوْلٌ إِنْسانٌ':Added, #2: 2	بَوْلِ الْأَعْرَابِيِّ
u'بَوْلٌ بَقَرٌ':Added, #1: 1	بَوْلَ الْإِنْسَانِ
u'بَوْلٌ ثَوْرٌ':Added, #1: 1	بَوْلَ الْبَقَرِ
u'بَوْلٌ جَارِي':Added, #1: 1	بَوْلِ ثَوْرِ
u'بَوْلٌ جَارِي':Added, #1: 1	بَوْلَ جَارِيَةٍ
u'بَوْلٌ جَارِي':Added, #2: 2	بَوْلَ الْجَارِيَةِ
u'بَوْلٌ جَارِي':Added, #4: 4	بَوْلِ الْجَارِيَةِ
u'بَوْلٌ جَارِيَةٌ':Added, #7: 7	بَوْلُ الْجَارِيَةِ
u'بَوْلٌ جَارِيَةٌ':Added, #1: 1	بَوْلَ جَارِيَةٍ
u'بَوْلٌ جَارِيَةٌ':Added, #2: 2	بَوْلَ الْجَارِيَةِ
u'بَوْلٌ جَارِيَةٌ':Added, #4: 4	بَوْلِ الْجَارِيَةِ
u'بَوْلٌ حِمَارٌ':Added, #7: 7	بَوْلُ الْجَارِيَةِ
u'بَوْلٌ حِمَارٌ':Added, #1: 1	بَوْلِ حِمَارٍ
u'بَوْلٌ حَيَوَانٌ':Added, #7: 7	بَوْلِ الْحِمَارِ
u'بَوْلٌ خُفَّاشٌ':Added, #2: 2	بَوْلِ الْحَيَوَانِ
u'بَوْلٌ خُفَّاشٌ':Added, #1: 1	بَوْلَ الْخُفَّاشِ
u'بَوْلٌ خُفَّاشٌ':Added, #1: 1	بَوْلِ الْخُفَّاشِ
u'بَوْلٌ خُفَّاشٌ':Added, #2: 2	بَوْلُ الْخُفَّاشِ
u'بَوْلٌ خَيْلٌ':Added, #2: 2	بَوْلِ خُفَّاشٍ
u'بَوْلٌ دَوَابُّ':Added, #1: 1	بَوْلِ الْخَيْلِ
u'بَوْلٌ دَوَابُّ':Added, #1: 1	بَوْلُ الدَّوَابِّ
u'بَوْلٌ ذكر':Added, #2: 2	بَوْلِ الدَّوَابِّ
u'بَوْلٌ ذكر':Added, #2: 2	بَوْلُ الذَّكَرِ
u'بَوْلٌ ذَكَرٌ':Added, #2: 2	بَوْلِ الذَّكَرِ
u'بَوْلٌ ذَكَرٌ':Added, #2: 2	بَوْلُ الذَّكَرِ
u'بَوْلٌ رَضيعٌ':Added, #2: 2	بَوْلِ الذَّكَرِ
u'بَوْلٌ سَلَسٌ':Added, #3: 3	بَوْلِ الرَّضِيعِ
u'بَوْلٌ سَمَكٌ':Added, #2: 2	بَوْلِ السَّلَسِ
u'بَوْلٌ شَاةٌ':Added, #1: 1	بَوْلَ السَّمَكِ
u'بَوْلٌ شَاةٌ':Added, #2: 2	بَوْلُ الشَّاةِ
u'بَوْلٌ صَبِيٌّ':Added, #2: 2	بَوْلِ الشَّاةِ
u'بَوْلٌ صَبِيٌّ':Added, #1: 1	بَوْل الصَّبِيَّةِ
u'بَوْلٌ صَبِيٌّ':Added, #1: 1	بَوْلُ الصَّبِيَّةِ
u'بَوْلٌ صَبِيٌّ':Added, #1: 1	بَوْلِ الصَّبِيَّةِ
u'بَوْلٌ صَبِيٌّ':Added, #1: 1	بَوْلُ صَبِيٍّ
u'بَوْلٌ صَبِيٌّ':Added, #1: 1	بَوْلِ صَبِيٍّ
u'بَوْلٌ صَغِيرٌ':Added, #3: 3	بَوْلِ الصَّبِيِّ
u'بَوْلٌ صَغِيرٌ':Added, #1: 1	بَوْلَ الصَّغِيرِ
u'بَوْلٌ صَغِيرٌ':Added, #1: 1	بَوْلُ الصَّغِيرِ
u'بَوْلٌ طَائِرٌ':Added, #1: 1	بَوْلُ صَغِيرٍ
u'بَوْلٌ ظَبْيٌ':Added, #1: 1	بَوْلُ طَائِرٍ
u'بَوْلٌ ظَبْيٌ':Added, #2: 2	بَوْلِ الظَّبْيِ
u'بَوْلٌ غُلاَمٌ':Added, #4: 4	بَوْلِ الظَّبْيَةِ
u'بَوْلٌ غُلاَمٌ':Added, #1: 1	بَوْلُ الْغُلامِ
u'بَوْلٌ غُلاَمٌ':Added, #1: 1	بَوْلَ الْغُلَامِ
u'بَوْلٌ غُلاَمٌ':Added, #1: 1	بَوْلُ الْغُلَامِ
u'بَوْلٌ غُلاَمٌ':Added, #1: 1	بَوْلَ غُلَامٍ
u'بَوْلٌ غُلاَمٌ':Added, #4: 4	بَوْلِ الْغُلاَمِ
u'بَوْلٌ غُلاَمٌ':Added, #5: 5	بَوْلُ الْغُلاَمِ
u'بَوْلٌ غَنَمٌ':Added, #6: 6	بَوْلِ الْغُلَامِ
u'بَوْلٌ غير':Added, #1: 1	بَوْلُ الْغَنَمِ
u'بَوْلٌ غَيْرٌ':Added, #1: 1	بَوْلَ غَيْرِ
u'بَوْلٌ غير':Added, #1: 1	بَوْلَ غَيْرِ
u'بَوْلٌ غَيْرٌ':Added, #1: 1	بَوْلِ غَيْرِهِ
u'بَوْلٌ فَأْرٌ':Added, #1: 1	بَوْلِ غَيْرِهِ
u'بَوْلٌ فَأْرٌ':Added, #2: 2	بَوْلِ فَأْرٍ
u'بَوْلٌ فَرَسٌ':Added, #3: 3	بَوْلُ الْفَأْرَةِ
u'بَوْلٌ فَرَسٌ':Added, #1: 1	بَوْلِ فَرَسِ
u'بَوْلٌ كَبِيرٌ':Added, #4: 4	بَوْلُ الْفَرَسِ
u'بَوْلٌ مَأْكُولٌ':Added, #1: 1	بَوْلِ الْكَبِيرِ
u'بَوْلٌ مَأْكُولٌ':Added, #2: 2	بَوْلُ مَأْكُولٍ
u'بَوْلٌ مُبَاحٌ':Added, #4: 4	بَوْلِ الْمَأْكُولِ
u'بَوْلٌ مَكْرُوهٌ':Added, #1: 1	بَوْلِ مُبَاحِ
u'بَوْلٌ مَكْرُوهٌ':Added, #1: 1	بَوْلَ الْمَكْرُوهِ
u'بَوْلٌ نَبِيٌّ':Added, #1: 1	بَوْلُ الْمَكْرُوهِ
u'بَوْلٌ نَبِيٌّ':Added, #1: 1	بَوْلَ النَّبِيِّ
u'بَوْلٌ نَفْسٌ':Added, #1: 1	بَوْلُ النَّبِيِّ
u'بَوْلٌ هِرٌّ':Added, #2: 2	بَوْلَ نَفْسِهِ
u'بَوْلٌ هِرٌّ':Added, #1: 1	بَوْلَ الْهِرَّةِ
u'بَوْلٌ وَطْوَاطٌ':Added, #3: 3	بَوْلُ الْهِرَّةِ
u'بَيَانٌ إبَاحَةٌ':Added, #1: 1	بَوْلُ الْوَطْوَاطِ
u'بَيَانٌ إبَاحَةٌ':Added, #1: 1	بَيَانُ إبَاحَةِ
u'بَيَانٌ أثَرٌ':Added, #1: 1	بَيَانُ الْإِبَاحَةِ
u'بَيَانٌ إجَارَةٌ':Added, #1: 1	بَيَانُ أَثَرِ
u'بَيَانٌ إجَارَةٌ':Added, #1: 1	بَيَانُ إجَارَةِ
u'بَيَانٌ أُجْرَةٌ':Added, #1: 1	بَيَانِ الْإِجَارَةِ
u'بَيَانٌ أَجَلٌ':Added, #1: 1	بَيَانِ الْأُجْرَةِ
u'بَيَانٌ أَجَلٌ':Added, #2: 2	بَيَانُ الْأَجَلِ
u'بَيَانٌ إِجْمَاعٌ':Added, #5: 5	بَيَانِ الْأَجَلِ
u'بَيَانٌ إِجْمَالٌ':Added, #1: 1	بَيَانُ الْإِجْمَاعِ
u'بَيَانٌ أحَدٌ':Added, #1: 1	بَيَان الْإِجْمَالِ
u'بَيَانٌ أحَدٌ':Added, #1: 1	بَيَانُ أَحَدِ
u'بَيَانٌ أَحْكَامٌ':Added, #1: 1	بَيَانِ أَحَدِ
u'بَيَانٌ أَحْكَامٌ':Added, #1: 1	بَيَانَ أَحْكَامِ
u'بَيَانٌ أَحْكَامٌ':Added, #1: 1	بَيَانِ أَحْكَامٍ
u'بَيَانٌ أَحْكَامٌ':Added, #1: 1	بَيَانُ الْأَحْكَامِ
u'بَيَانٌ أَحْكَامٌ':Added, #2: 2	بَيَانُ أَحْكَامِهِ
u'بَيَانٌ أَحْكَامٌ':Added, #2: 2	بَيَانَ الْأَحْكَامِ
u'بَيَانٌ أَحْكَامٌ':Added, #4: 4	بَيَانُ أَحْكَامِ
u'بَيَانٌ أَحْكَامٌ':Added, #51: 51	بَيَانِ أَحْكَامِ
u'بَيَانٌ أَحْكَامٌ':Added, #5: 5	بَيَانِ أَحْكَامِهِ
u'بَيَانٌ أَحْوالٌ':Added, #5: 5	بَيَانِ الْأَحْكَامِ
u'بَيَانٌ أَحْوالٌ':Added, #1: 1	بَيَانُ أَحْوَالِ
u'بَيَانٌ أحْوَالٌ':Added, #1: 1	بَيَانِ أَحْوَالِ
u'بَيَانٌ أحْوَالٌ':Added, #1: 1	بَيَانُ أَحْوَالِ
u'بَيَانٌ اِخْتِصَاصٌ':Added, #1: 1	بَيَانِ أَحْوَالِ
u'بَيَانٌ اِخْتِصَاصٌ':Added, #1: 1	بَيَانُ اخْتِصَاصِهِ
u'بَيَانٌ اِخْتِلاَفٌ':Added, #2: 2	بَيَانُ اخْتِصَاصِ
u'بَيَانٌ اِخْتِلاَفٌ':Added, #1: 1	بَيَانِ الاِخْتِلاَفِ
u'بَيَانٌ اِخْتِلاَفٌ':Added, #2: 2	بَيَانُ اخْتِلَافِ
u'بَيَانٌ آخِرُ':Added, #2: 2	بَيَانِ اخْتِلَافِ
u'بَيَانٌ آخِرُ':Added, #2: 2	بَيَانُ آخِرِ
u'بَيَانٌ إِخْرَاجٌ':Added, #2: 2	بَيَانِ آخِرِ
u'بَيَانٌ أَدَاءٌ':Added, #1: 1	بَيَانَ الْإِخْرَاجِ
u'بَيَانٌ آدابٌ':Added, #1: 1	بَيَانِ الْأَدَاءِ
u'بَيَانٌ آدابٌ':Added, #1: 1	بَيَانُ آدَابِ
u'بَيَانٌ أدَب':Added, #1: 1	بَيَانِ آدَابِ
u'بَيَانٌ إِدْرَاكٌ':Added, #1: 1	بَيَانِ أَدَبِ
u'بَيَانٌ إِذْنٌ':Added, #1: 1	بَيَانِ إدْرَاكِ
u'بَيَانٌ إِذْنٌ':Added, #1: 1	بَيَانِ إذْنِ
u'بَيَانٌ إِرَادَةٌ':Added, #2: 2	بَيَانُ إذْنِ
u'بَيَانٌ إِرَادَةٌ':Added, #1: 1	بَيَانُ إرَادَةِ
u'بَيَانٌ أرْبَابٌ':Added, #2: 2	بَيَانِ الْإِرَادَةِ
u'بَيَانٌ إِرْثٌ':Added, #1: 1	بَيَانِ أَرْبَابِ
u'بَيَانٌ أرْضٌ':Added, #6: 6	بَيَانِ إرْثِ
u'بَيَانٌ أَسْآرٌ':Added, #1: 1	بَيَانُ الْأَرْضِ
u'بَيَانٌ أسْبَابٌ':Added, #1: 1	بَيَانِ الْأَسْآرِ
u'بَيَانٌ أَسْبَابٌ':Added, #1: 1	بَيَانِ أَسْبَابِ
u'بَيَانٌ اِسْتِحْقَاقٌ':Added, #1: 1	بَيَانِ أَسْبَابِ
u'بَيَانٌ اِسْتِحْقَاقٌ':Added, #1: 1	بَيَانُ اسْتِحْقَاقٍ
u'بَيَانٌ اِسْتِعْمالٌ':Added, #1: 1	بَيَانُ اسْتِحْقَاقِ
u'بَيَانٌ إِسْلامٌ':Added, #1: 1	بَيَانِ اسْتِعْمَالِ
u'بَيَانٌ أَسْماءٌ':Added, #1: 1	بَيَانِ الْإِسْلَامِ
u'بَيَانٌ إِسْنادٌ':Added, #1: 1	بَيَانِ الْأَسْمَاءِ
u'بَيَانٌ أسْوَد':Added, #1: 1	بَيَانِ الْإِسْنَادِ
u'بَيَانٌ إشارَة':Added, #1: 1	بَيَانِ الْأَسْوَدِ
u'بَيَانٌ اِشْتِراطٌ':Added, #1: 1	بَيَانُ الْإِشَارَةِ
u'بَيَانٌ اِشْتِراطٌ':Added, #1: 1	بَيَانُ اشْتِرَاطِ
u'بَيَانٌ اِشْتِمالٌ':Added, #1: 1	بَيَانِ اشْتِرَاطِ
u'بَيَانٌ اِشْتِمالٌ':Added, #1: 1	بَيَانَ اشْتِمَالِ
u'بَيَانٌ أَشْهُرٌ':Added, #1: 1	بَيَانُ اشْتِمَالِ
u'بَيَانٌ أَصْحَابٌ':Added, #1: 1	بَيَانِ أَشْهُرِ
u'بَيَانٌ اِصْطِلاحٌ':Added, #1: 1	بَيَانِ أَصْحَابِ
u'بَيَانٌ اِصْطِلاحٌ':Added, #1: 1	بَيَانُ اصْطِلَاحِ
u'بَيَانٌ أًصْلٌ':Added, #1: 1	بَيَانِ اصْطِلَاحِ
u'بَيَانٌ أصل':Added, #1: 1	بَيَانِ أَصْلٍ
u'بَيَانٌ أًصْلٌ':Added, #1: 1	بَيَانُ الْأَصْلِ
u'بَيَانٌ أصل':Added, #1: 1	بَيَانُ الْأَصْلِ
u'بَيَانٌ أًصْلٌ':Added, #2: 2	بَيَانِ الْأَصْلِ
u'بَيَانٌ أصل':Added, #2: 2	بَيَانِ الْأَصْلِ
u'بَيَانٌ أًصْلٌ':Added, #3: 3	بَيَانِ أَصْلِ
u'بَيَانٌ أَصْنَافٌ':Added, #3: 3	بَيَانِ أَصْلِ
u'بَيَانٌ أَصْنَافٌ':Added, #1: 1	بَيَانَ الْأَصْنَافِ
u'بَيَانٌ أَصْنَافٌ':Added, #1: 1	بَيَانُ الْأَصْنَافِ
u'بَيَانٌ أُصولٌ':Added, #2: 2	بَيَانِ الْأَصْنَافِ
u'بَيَانٌ أُصولٌ':Added, #1: 1	بَيَانُ أُصُولِ
u'بَيَانٌ اِعْتِبارٌ':Added, #1: 1	بَيَانِ أُصُولِ
u'بَيَانٌ اِعْتِبارٌ':Added, #1: 1	بَيَانِ اعْتِبَارِ
u'بَيَانٌ أَعْرَاضٌ':Added, #2: 2	بَيَانُ اعْتِبَارِ
u'بَيَانٌ أعْيانٌ':Added, #1: 1	بَيَانُ الْأَعْرَاضِ
u'بَيَانٌ أعْيانٌ':Added, #2: 2	بَيَانَ أَعْيَانِ
u'بَيَانٌ أَعْيَانٌ':Added, #2: 2	بَيَانُ أَعْيَانِ
u'بَيَانٌ أَعْيَانٌ':Added, #2: 2	بَيَانَ أَعْيَانِ
u'بَيَانٌ أعْيانٌ':Added, #2: 2	بَيَانُ أَعْيَانِ
u'بَيَانٌ أَعْيَانٌ':Added, #3: 3	بَيَانِ أَعْيَانِ
u'بَيَانٌ أعْيانٌ':Added, #3: 3	بَيَانِ أَعْيَانِ
u'بَيَانٌ أَعْيَانٌ':Added, #3: 3	بَيَانِ الْأَعْيَانِ
u'بَيَانٌ أفْضَلُ':Added, #3: 3	بَيَانِ الْأَعْيَانِ
u'بَيَانٌ أفْضَلُ':Added, #1: 1	بَيَانِ أَفْضَلِ
u'بَيَانٌ أفْضَلُ':Added, #6: 6	بَيَانِ الْأَفْضَلِ
u'بَيَانٌ أفْضَلِيَّةٌ':Added, #7: 7	بَيَانُ الْأَفْضَلِ
u'بَيَانٌ أفْضَلِيَّةٌ':Added, #1: 1	بَيَانُ الْأَفْضَلِيَّةِ
u'بَيَانٌ أَفْعَالٌ':Added, #1: 1	بَيَانِ الْأَفْضَلِيَّةِ
u'بَيَانٌ أَفْعَالٌ':Added, #1: 1	بَيَانَ أَفْعَالِ
u'بَيَانٌ إقامَةٌ':Added, #1: 1	بَيَانِ الْأَفْعَالِ
u'بَيَانٌ اِقْتِضَاءٌ':Added, #1: 1	بَيَانِ إقَامَةِ
u'بَيَانٌ إقْرَارٌ':Added, #1: 1	بَيَانُ اقْتِضَاءِ
u'بَيَانٌ أَقْسَامٌ':Added, #1: 1	بَيَانُ الْإِقْرَارِ
u'بَيَانٌ أَقْسَامٌ':Added, #1: 1	بَيَانَ أَقْسَامِ
u'بَيَانٌ أَقْسَامٌ':Added, #1: 1	بَيَانِ الْأَقْسَامِ
u'بَيَانٌ أقَلُّ':Added, #4: 4	بَيَانِ أَقْسَامِ
u'بَيَانٌ أَكْثَرُ':Added, #4: 4	بَيَانِ أَقَلِّ
u'بَيَانٌ أَكْمَلُ':Added, #1: 1	بَيَانَ أَكْثَرِ
u'بَيَانٌ ألف':Added, #1: 1	بَيَانَ الْأَكْمَلِ
u'بَيَانٌ ألْفٌ':Added, #1: 1	بَيَانِ الْأَلْفِ
u'بَيَانٌ أَلْفٌ':Added, #1: 1	بَيَانِ الْأَلْفِ
u'بَيَانٌ أَلْفَاظٌ':Added, #1: 1	بَيَانِ الْأَلْفِ
u'بَيَانٌ أَلْفَاظٌ':Added, #1: 1	بَيَانِ الْأَلْفَاظِ
u'بَيَانٌ أَلْفَاظٌ':Added, #1: 1	بَيَانُ أَلْفَاظٍ
u'بَيَانٌ أَلْفَاظٌ':Added, #1: 1	بَيَانُ أَلْفَاظِ
u'بَيَانٌ أَلْفَاظٌ':Added, #2: 2	بَيَانِ أَلْفَاظِ
u'بَيَانٌ أَلْوَانٌ':Added, #4: 4	بَيَانُ الْأَلْفَاظِ
u'بَيَانٌ اِمْتِدَادٌ':Added, #1: 1	بَيَانُ أَلْوَانِهِ
u'بَيَانٌ اِمْتِناعٌ':Added, #1: 1	بَيَانِ امْتِدَادِ
u'بَيَانٌ أَمْثِلَةٌ':Added, #1: 1	بَيَانُ امْتِنَاعِ
u'بَيَانٌ أَمَدٌ':Added, #1: 1	بَيَانِ أَمْثِلَتِهِ
u'بَيَانٌ أَمْرٌ':Added, #1: 1	بَيَانِ أَمَدِ
u'بَيَانٌ أَمْوَالٌ':Added, #1: 1	بَيَانُ الْأَمْرِ
u'بَيَانٌ اِنْتِفاء':Added, #1: 1	بَيَانِ الْأَمْوَالِ
u'بَيَانٌ اِنْتِفاء':Added, #1: 1	بَيَانِ انْتِفَاءِ
u'بَيَانٌ اِنْتِهاءٌ':Added, #2: 2	بَيَانُ انْتِفَاءِ
u'بَيَانٌ أَنْجَاسٌ':Added, #4: 4	بَيَانُ انْتِهَاءِ
u'بَيَانٌ اِنْحِرافٌ':Added, #1: 1	بَيَانِ الْأَنْجَاسِ
u'بَيَانٌ اِنْقِسَامٌ':Added, #1: 1	بَيَانُ انْحِرَافِ
u'بَيَانٌ أَنْوَاعٌ':Added, #1: 1	بَيَانِ انْقِسَامَاتِ
u'بَيَانٌ أَنْوَاعٌ':Added, #11: 11	بَيَانِ أَنْوَاعِ
u'بَيَانٌ أَنْوَاعٌ':Added, #1: 1	بَيَانِ الْأَنْوَاعِ
u'بَيَانٌ أَنْوَاعٌ':Added, #1: 1	بَيَانَ أَنْوَاعِ
u'بَيَانٌ أهْلٌ':Added, #3: 3	بَيَانُ أَنْوَاعِ
u'بَيَانٌ أَهْلِيٌّ':Added, #1: 1	بَيَانِ أَهْلِ
u'بَيَانٌ أهْلِيَّةٌ':Added, #1: 1	بَيَانَ الْأَهْلِيَّةِ
u'بَيَانٌ أَوْجُهٌ':Added, #1: 1	بَيَانَ الْأَهْلِيَّةِ
u'بَيَانٌ أَوْصَافٌ':Added, #1: 1	بَيَانِ أَوْجُهِ
u'بَيَانٌ أَوْقَاتٌ':Added, #1: 1	بَيَانِ أَوْصَافٍ
u'بَيَانٌ أَوَّلُ':Added, #1: 1	بَيَانِ الْأَوْقَاتِ
u'بَيَانٌ أَوَّلُ':Added, #1: 1	بَيَانِ أَوَّلِ
u'بَيَانٌ أَوَّلُ':Added, #2: 2	بَيَانُ الْأَوَّلِ
u'بَيَانٌ أَوْلَوِيٌّ':Added, #2: 2	بَيَانُ أَوَّلِ
u'بَيَانٌ أَوْلِيَاءُ':Added, #6: 6	بَيَانُ الْأَوْلَوِيَّةِ
u'بَيَانٌ أَوْلِيَاءُ':Added, #1: 1	بَيَانَ الْأَوْلِيَاءِ
u'بَيَانٌ آيَةٌ':Added, #4: 4	بَيَانِ الْأَوْلِيَاءِ
u'بَيَانٌ أَيْمَانٌ':Added, #1: 1	بَيَانَ الْآيَةِ
u'بَيَانٌ بَابٌ':Added, #1: 1	بَيَانَ أَيْمَانِ
u'بَيَانٌ بُخْلٌ':Added, #1: 1	بَيَانِ الْبَابِ
u'بَيَانٌ بِدَعٌ':Added, #1: 1	بَيَانَ الْبُخْلِ
u'بَيَانٌ بِدْعَةٌ':Added, #1: 1	بَيَانِ الْبِدَعِ
u'بَيَانٌ بَدَلٌ':Added, #1: 1	بَيَانِ بِدْعَةِ
u'بَيَانٌ بُرْهانٌ':Added, #2: 2	بَيَانِ الْبَدَلِ
u'بَيَانٌ بُرْهَانٌ':Added, #2: 2	بَيَانِ الْبُرْهَانِ
u'بَيَانٌ بَعْضٌ':Added, #2: 2	بَيَانِ الْبُرْهَانِ
u'بَيَانٌ بَعْضٌ':Added, #1: 1	بَيَانُ بَعْضِهِ
u'بَيَانٌ بَقاءٌ':Added, #7: 7	بَيَانِ بَعْضِ
u'بَيَانٌ بَقِيَّةٌ':Added, #1: 1	بَيَانُ بَقَاءِ
u'بَيَانٌ بِنَاءٌ':Added, #1: 1	بَيَانُ بَقِيَّةِ
u'بَيَانٌ بَيْتٌ':Added, #1: 1	بَيَانُ الْبِنَاءِ
u'بَيَانٌ تَأْثِيرٌ':Added, #1: 1	بَيَانُ الْبَيْتِ
u'بَيَانٌ تَأْخِيرٌ':Added, #1: 1	بَيَانُ التَّأْثِيرِ
u'بَيَانٌ تَارِيخٌ':Added, #1: 1	بَيَانُ تَأْخِيرٍ
u'بَيَانٌ تَأْكِيدٌ':Added, #5: 5	بَيَانِ التَّارِيخِ
u'بَيَانٌ تَأْكِيدٌ':Added, #1: 1	بَيَانُ التَّأْكِيدِ
u'بَيَانٌ تَبْدِيلٌ':Added, #1: 1	بَيَانِ تَأْكِيدِ
u'بَيَانٌ تَبْدِيلٌ':Added, #1: 1	بَيَانَ التَّبْدِيلِ
u'بَيَانٌ تَبَرُّعٌ':Added, #1: 1	بَيَانُ تَبْدِيلٍ
u'بَيَانٌ تَجَوُّزٌ':Added, #1: 1	بَيَانِ التَّبَرُّعِ
u'بَيَانٌ تَحْرِيمٌ':Added, #1: 1	بَيَانُ تَجَوُّزِ
u'بَيَانٌ تَحْرِيمٌ':Added, #2: 2	بَيَانِ التَّحْرِيمِ
u'بَيَانٌ تَحَقُّقٌ':Added, #2: 2	بَيَانُ تَحْرِيمِ
u'بَيَانٌ تَحْقِيقٌ':Added, #1: 1	بَيَانُ تَحَقُّقِ
u'بَيَانٌ تَحْقِيقٌ':Added, #1: 1	بَيَانُ تَحْقِيقِ
u'بَيَانٌ تَخْصِيصٌ':Added, #1: 1	بَيَانِ تَحْقِيقٍ
u'بَيَانٌ تَخْصِيصٌ':Added, #1: 1	بَيَانِ تَخْصِيصِ
u'بَيَانٌ تَخْيِيرٌ':Added, #7: 7	بَيَانِ التَّخْصِيصِ
u'بَيَانٌ تَدْبِيرٌ':Added, #1: 1	بَيَانُ التَّخْيِيرِ
u'بَيَانٌ تَرْتِيبٌ':Added, #1: 1	بَيَانِ التَّدْبِيرِ
u'بَيَانٌ تَرْتِيبٌ':Added, #1: 1	بَيَانُ التَّرْتِيبِ
u'بَيَانٌ تَرْتِيبٌ':Added, #1: 1	بَيَانُ تَرْتِيبِ
u'بَيَانٌ تَرْجِيحٌ':Added, #1: 1	بَيَانُ تَرْتِيبِهِ
u'بَيَانٌ تَرَدُّدٌ':Added, #2: 2	بَيَانُ تَرْجِيحِ
u'بَيَانٌ تَرِكَةٌ':Added, #1: 1	بَيَانُ تَرَدُّدِ
u'بَيَانٌ تَرِكَةٌ':Added, #1: 1	بَيَانُ التَّرِكَةِ
u'بَيَانٌ تَرْكِيبٌ':Added, #3: 3	بَيَانِ التَّرِكَةِ
u'بَيَانٌ تَصْحِيحٌ':Added, #1: 1	بَيَانِ تَرْكِيبِ
u'بَيَانٌ تَصَرُّفٌ':Added, #1: 1	بَيَانُ تَصْحِيحِ
u'بَيَانٌ تَصَرُّفٌ':Added, #1: 1	بَيَانِ التَّصَرُّفَاتِ
u'بَيَانٌ تَصَرُّفٌ':Added, #2: 2	بَيَانِ تَصَرُّفَاتِ
u'بَيَانٌ تَصَوُّرٌ':Added, #3: 3	بَيَانِ التَّصَرُّفِ
u'بَيَانٌ تَطْلِيقٌ':Added, #2: 2	بَيَانِ التَّصَوُّرَاتِ
u'بَيَانٌ تَطْهِيرٌ':Added, #1: 1	بَيَانَ التَّطْلِيقَتَيْنِ
u'بَيَانٌ تَعْدَادٌ':Added, #1: 1	بَيَانِ تَطْهِيرِ
u'بَيَانٌ تَعَدُّدٌ':Added, #1: 1	بَيَانِ تَعْدَادِ
u'بَيَانٌ تَعْدِيلٌ':Added, #1: 1	بَيَانُ تَعَدُّدِ
u'بَيَانٌ تَعْرِيفٌ':Added, #1: 1	بَيَانُ التَّعْدِيلِ
u'بَيَانٌ تَعْلِيقٌ':Added, #1: 1	بَيَانِ تَعْرِيفِ
u'بَيَانٌ تَعْلِيقٌ':Added, #1: 1	بَيَانِ التَّعْلِيقِ
u'بَيَانٌ تَعْلِيقٌ':Added, #1: 1	بَيَانَ تَعْلِيقِ
u'بَيَانٌ تَعْلِيلٌ':Added, #1: 1	بَيَانِ تَعْلِيقِهِ
u'بَيَانٌ تَعْلِيلٌ':Added, #1: 1	بَيَانُ التَّعْلِيلِ
u'بَيَانٌ تَعْلِيلٌ':Added, #1: 1	بَيَانِ التَّعْلِيلِ
u'بَيَانٌ تَعْمِيمٌ':Added, #1: 1	بَيَانِ تَعْلِيلِ
u'بَيَانٌ تَغَيُّرٌ':Added, #1: 1	بَيَانُ التَّعْمِيمِ
u'بَيَانٌ تَغْيِيرٌ':Added, #1: 1	بَيَانِ تَغَيُّرِ
u'بَيَانٌ تَغْيِيرٌ':Added, #3: 3	بَيَانَ تَغْيِيرٍ
u'بَيَانٌ تَغْيِيرٌ':Added, #4: 4	بَيَانِ التَّغْيِيرِ
u'بَيَانٌ تَفَاضُلٌ':Added, #5: 5	بَيَانُ تَغْيِيرٍ
u'بَيَانٌ تَفاوُت':Added, #1: 1	بَيَانِ تَفَاضُلِ
u'بَيَانٌ تَفْرِيقٌ':Added, #1: 1	بَيَانُ التَّفَاوُتِ
u'بَيَانٌ تَفْسِيرٌ':Added, #1: 1	بَيَانُ تَفْرِيقِ
u'بَيَانٌ تَفْسِيرٌ':Added, #1: 1	بَيَانُ التَّفْسِيرِ
u'بَيَانٌ تَفْصِيلٌ':Added, #2: 2	بَيَانِ تَفْسِيرِهِ
u'بَيَانٌ تَقادُم':Added, #2: 2	بَيَانِ التَّفْصِيلِ
u'بَيَانٌ تَقَدُّمٌ':Added, #1: 1	بَيَانُ التَّقَادُمِ
u'بَيَانٌ تَقْريرٌ':Added, #1: 1	بَيَانِ تَقَدُّمِهِ
u'بَيَانٌ تَقْريرٌ':Added, #1: 1	بَيَانَ التَّقْرِيرِ
u'بَيَانٌ تَقْريرٌ':Added, #1: 1	بَيَانُ التَّقْرِيرِ
u'بَيَانٌ تَقْريرٌ':Added, #1: 1	بَيَانِ التَّقْرِيرِ
u'بَيَانٌ تَقْسِيمٌ':Added, #1: 1	بَيَانُ تَقْرِيرٍ
u'بَيَانٌ تمام':Added, #1: 1	بَيَانِ التَّقْسِيمِ
u'بَيَانٌ تَمامٌ':Added, #4: 4	بَيَانُ تَمَامِ
u'بَيَانٌ تَمْلِيكٌ':Added, #4: 4	بَيَانُ تَمَامِ
u'بَيَانٌ تَنْجِيزٌ':Added, #2: 2	بَيَانِ تَمْلِيكِ
u'بَيَانٌ تَنْجِيزٌ':Added, #1: 1	بَيَانِ التَّنْجِيزِ
u'بَيَانٌ تَنْوِيعٌ':Added, #1: 1	بَيَانِ تَنْجِيزِ
u'بَيَانٌ تَنْوِيعٌ':Added, #1: 1	بَيَانُ التَّنْوِيعِ
u'بَيَانٌ تَوْفِيقٌ':Added, #1: 1	بَيَانِ تَنْوِيعِهِ
u'بَيَانٌ ثَالِثٌ':Added, #1: 1	بَيَانُ التَّوْفِيقِ
u'بَيَانٌ ثَالِثٌ':Added, #1: 1	بَيَانُ الثَّالِثِ
u'بَيَانٌ ثَالِثٌ':Added, #1: 1	بَيَانَ الثَّالِثَةِ
u'بَيَانٌ ثُبُوتٌ':Added, #1: 1	بَيَانُ الثَّالِثَةِ
u'بَيَانٌ ثُبُوتٌ':Added, #1: 1	بَيَانَ ثُبُوتِ
u'بَيَانٌ ثَلاثُ':Added, #1: 1	بَيَانِ ثُبُوتِ
u'بَيَانٌ ثَلاثَةٌ':Added, #1: 1	بَيَانُ الثَّلَاثِ
u'بَيَانٌ ثَلاثَةٌ':Added, #1: 1	بَيَانُ الثَّلَاثَةِ
u'بَيَانٌ ثَمَرَةٌ':Added, #1: 1	بَيَانِ ثَلَاثَةٍ
u'بَيَانٌ ثَمَرَةٌ':Added, #1: 1	بَيَانِ الثَّمَرَةِ
u'بَيَانٌ ثَمَنٌ':Added, #2: 2	بَيَانُ ثَمَرَةِ
u'بَيَانٌ ثَمَنٌ':Added, #16: 16	بَيَانِ الثَّمَنِ
u'بَيَانٌ ثَمَنٌ':Added, #1: 1	بَيَانُ الثَّمَنِ
u'بَيَانٌ ثَمَنٌ':Added, #2: 2	بَيَانَ الثَّمَنِ
u'بَيَانٌ ثَوابٌ':Added, #3: 3	بَيَانُ ثَمَنِ
u'بَيَانٌ ثَوْبٌ':Added, #1: 1	بَيَانِ الثَّوَابِ
u'بَيَانٌ ثَوْبٌ':Added, #1: 1	بَيَانُ الثَّوْبِ
u'بَيَانٌ جَامِعٌ':Added, #1: 1	بَيَانِ ثَوْبِهِ
u'بَيَانٌ جَائِزٌ':Added, #1: 1	بَيَانِ الْجَامِعِ
u'بَيَانٌ جَزَائِرُ':Added, #1: 1	بَيَانِ الْجَائِزِ
u'بَيَانٌ جمعة':Added, #1: 1	بَيَانِ الْجَزَائِرِ
u'بَيَانٌ جُمُعَةٌ':Added, #1: 1	بَيَانَ الْجُمُعَةِ
u'بَيَانٌ جُمْلَةٌ':Added, #1: 1	بَيَانَ الْجُمُعَةِ
u'بَيَانٌ جِنَايَةٌ':Added, #1: 1	بَيَانُ جُمْلَةِ
u'بَيَانٌ جِنَايَةٌ':Added, #1: 1	بَيَانُ الْجِنَايَةِ
u'بَيَانٌ جِنَايَةٌ':Added, #2: 2	بَيَانِ الْجِنَايَةِ
u'بَيَانٌ جَنَّةٌ':Added, #4: 4	بَيَانِ جِنَايَةِ
u'بَيَانٌ جِنْسٌ':Added, #1: 1	بَيَانِ جَنَّتِهِ
u'بَيَانٌ جِنْسٌ':Added, #1: 1	بَيَانَ جِنْسِ
u'بَيَانٌ جِنْسٌ':Added, #3: 3	بَيَانِ الْجِنْسِ
u'بَيَانٌ جِنْسٌ':Added, #3: 3	بَيَانِ جِنْسِ
u'بَيَانٌ جِنْسٌ':Added, #5: 5	بَيَانِ جِنْسِهِ
u'بَيَانٌ جِنْسٌ':Added, #6: 6	بَيَانُ الْجِنْسِ
u'بَيَانٌ جَهالَة':Added, #6: 6	بَيَانُ جِنْسِ
u'بَيَانٌ جِهَةٌ':Added, #1: 1	بَيَانِ الْجَهَالَةِ
u'بَيَانٌ جِهَةٌ':Added, #1: 1	بَيَانُ الْجِهَةِ
u'بَيَانٌ جِهَةٌ':Added, #1: 1	بَيَانُ جِهَةِ
u'بَيَانٌ جِهَةٌ':Added, #1: 1	بَيَانِ جِهَةٍ
u'بَيَانٌ جِهَةٌ':Added, #2: 2	بَيَانِ جِهَتِهِ
u'بَيَانٌ جِهَةٌ':Added, #3: 3	بَيَانُ جِهَتِهِ
u'بَيَانٌ جِهَةٌ':Added, #6: 6	بَيَانِ جِهَةِ
u'بَيَانٌ جَوَازٌ':Added, #7: 7	بَيَانِ الْجِهَةِ
u'بَيَانٌ جَوَازٌ':Added, #1: 1	بَيَانُ الْجَوَازِ
u'بَيَانٌ جَوَازٌ':Added, #1: 1	بَيَانَ جَوَازِ
u'بَيَانٌ جَوَازٌ':Added, #1: 1	بَيَانُ جَوَازِ
u'بَيَانٌ جَوَازٌ':Added, #2: 2	بَيَانَ الْجَوَازِ
u'بَيَانٌ جَوَازٌ':Added, #3: 3	بَيَانِ جَوَازِ
u'بَيَانٌ حاجَةٌ':Added, #9: 9	بَيَانِ الْجَوَازِ
u'بَيَانٌ حاجَةٌ':Added, #1: 1	بَيَانُ الْحَاجَةِ
u'بَيَانٌ حادِثٌ':Added, #1: 1	بَيَانِ الْحَاجَةِ
u'بَيَانٌ حاصِلٌ':Added, #1: 1	بَيَانِ حَادِثَةٍ
u'بَيَانٌ حاصِلٌ':Added, #1: 1	بَيَانُ حَاصِلِ
u'بَيَانٌ حالٌ':Added, #1: 1	بَيَانِ حَاصِلِ
u'بَيَانٌ حالٌ':Added, #2: 2	بَيَانَ الْحَالِ
u'بَيَانٌ حالٌ':Added, #3: 3	بَيَانِ الْحَالِ
u'بَيَانٌ حالٌ':Added, #4: 4	بَيَانُ حَالِ
u'بَيَانٌ حالٌ':Added, #4: 4	بَيَانِ حَالِ
u'بَيَانٌ حالٌ':Added, #5: 5	بَيَانُ حَالِهِ
u'بَيَانٌ حَجٌّ':Added, #5: 5	بَيَانِ حَالِهِ
u'بَيَانٌ حُجَّة':Added, #1: 1	بَيَانَ الْحَجِّ
u'بَيَانٌ حُجِّيَّة':Added, #1: 1	بَيَانِ حُجِّيَّةِ
u'بَيَانٌ حَدٌّ':Added, #1: 1	بَيَانِ حُجِّيَّةِ
u'بَيَانٌ حَدٌّ':Added, #2: 2	بَيَانِ الْحَدِّ
u'بَيَانٌ حَدٌّ':Added, #3: 3	بَيَانُ حَدِّ
u'بَيَانٌ حُدودٌ':Added, #4: 4	بَيَانِ حَدِّ
u'بَيَانٌ حُدودٌ':Added, #1: 1	بَيَانَ الْحُدُودِ
u'بَيَانٌ حُدودٌ':Added, #1: 1	بَيَانُ حُدُودِهِ
u'بَيَانٌ حُدودٌ':Added, #1: 1	بَيَانِ حُدُودِهِ
u'بَيَانٌ حَرْبٌ':Added, #2: 2	بَيَانِ الْحُدُودِ
u'بَيَانٌ حِرْزٌ':Added, #1: 1	بَيَانَ حَرْبِ
u'بَيَانٌ حُرْمَةٌ':Added, #1: 1	بَيَانِ الْحِرْزِ
u'بَيَانٌ حُرْمَةٌ':Added, #1: 1	بَيَانِ الْحُرْمَةِ
u'بَيَانٌ حَرِيمٌ':Added, #2: 2	بَيَانُ حُرْمَةِ
u'بَيَانٌ حِصَّةٌ':Added, #1: 1	بَيَانِ الْحَرِيمِ
u'بَيَانٌ حَصْرٌ':Added, #1: 1	بَيَانِ حِصَّةِ
u'بَيَانٌ حَصْرٌ':Added, #1: 1	بَيَانِ الْحَصْرِ
u'بَيَانٌ حَصْرٌ':Added, #1: 1	بَيَانَ حَصْرِ
u'بَيَانٌ حَفْرٌ':Added, #1: 1	بَيَانُ حَصْرِ
u'بَيَانٌ حَقٌّ':Added, #1: 1	بَيَانِ الْحَفْرِ
u'بَيَانٌ حَقٌّ':Added, #1: 1	بَيَان الْحَقِّ
u'بَيَانٌ حَقٌّ':Added, #1: 1	بَيَانَ الْحَقِّ
u'بَيَانٌ حَقٌّ':Added, #1: 1	بَيَانُ الْحَقِّ
u'بَيَانٌ حَقٌّ':Added, #1: 1	بَيَانِ الْحَقِّ
u'بَيَانٌ حَقٌّ':Added, #1: 1	بَيَانَ حَقِّ
u'بَيَانٌ حَقٌّ':Added, #1: 1	بَيَانُ حَقِّهِ
u'بَيَانٌ حَقٌّ':Added, #1: 1	بَيَانِ حَقِّهِ
u'بَيَانٌ حقائق':Added, #2: 2	بَيَانِ حَقِّ
u'بَيَانٌ حَقَائِقُ':Added, #1: 1	بَيَانَ الْحَقَائِقِ
u'بَيَانٌ حُقوقٌ':Added, #1: 1	بَيَانَ الْحَقَائِقِ
u'بَيَانٌ حُقُوقٌ':Added, #1: 1	بَيَانِ الْحُقُوقِ
u'بَيَانٌ حَقِيقٌ':Added, #1: 1	بَيَانِ الْحُقُوقِ
u'بَيَانٌ حَقِيقٌ':Added, #1: 1	بَيَانَ الْحَقِيقَةِ
u'بَيَانٌ حَقِيقٌ':Added, #1: 1	بَيَانَ حَقِيقَةِ
u'بَيَانٌ حَقِيقٌ':Added, #1: 1	بَيَانُ حَقِيقَتِهِ
u'بَيَانٌ حَقِيقٌ':Added, #1: 1	بَيَانِ حَقِيقَتِهِ
u'بَيَانٌ حَقِيقٌ':Added, #2: 2	بَيَانُ الْحَقِيقَةِ
u'بَيَانٌ حَقِيقٌ':Added, #2: 2	بَيَانُ حَقِيقَةِ
u'بَيَانٌ حَقِيقَةٌ':Added, #3: 3	بَيَانِ حَقِيقَةِ
u'بَيَانٌ حَقِيقَةٌ':Added, #1: 1	بَيَانَ الْحَقِيقَةِ
u'بَيَانٌ حَقِيقَةٌ':Added, #1: 1	بَيَانَ حَقِيقَةِ
u'بَيَانٌ حَقِيقَةٌ':Added, #1: 1	بَيَانُ حَقِيقَتِهِ
u'بَيَانٌ حَقِيقَةٌ':Added, #1: 1	بَيَانِ حَقِيقَتِهِ
u'بَيَانٌ حَقِيقَةٌ':Added, #2: 2	بَيَانُ الْحَقِيقَةِ
u'بَيَانٌ حَقِيقَةٌ':Added, #2: 2	بَيَانُ حَقِيقَةِ
u'بَيَانٌ حُكْمٌ':Added, #3: 3	بَيَانِ حَقِيقَةِ
u'بَيَانٌ حُكْمٌ':Added, #16: 16	بَيَانُ الْحُكْمِ
u'بَيَانٌ حُكْمٌ':Added, #1: 1	بَيَانُ الْحُكْمَيْنِ
u'بَيَانٌ حُكْمٌ':Added, #1: 1	بَيَانَ حُكْمِهِ
u'بَيَانٌ حُكْمٌ':Added, #25: 25	بَيَانُ حُكْمِ
u'بَيَانٌ حُكْمٌ':Added, #3: 3	بَيَانَ حُكْمٍ
u'بَيَانٌ حُكْمٌ':Added, #3: 3	بَيَانُ حُكْمٍ
u'بَيَانٌ حُكْمٌ':Added, #4: 4	بَيَانُ حُكْمِهِ
u'بَيَانٌ حُكْمٌ':Added, #4: 4	بَيَانِ حُكْمِهِ
u'بَيَانٌ حُكْمٌ':Added, #56: 56	بَيَانِ حُكْمِ
u'بَيَانٌ حُكْمٌ':Added, #5: 5	بَيَانَ الْحُكْمِ
u'بَيَانٌ حُكْمٌ':Added, #6: 6	بَيَانِ الْحُكْمِ
u'بَيَانٌ حكمة':Added, #6: 6	بَيَانَ حُكْمِ
u'بَيَانٌ حكمة':Added, #1: 1	بَيَانُ الْحِكْمَةِ
u'بَيَانٌ حِكْمَةٌ':Added, #1: 1	بَيَانِ الْحِكْمَةِ
u'بَيَانٌ حِكْمَةٌ':Added, #1: 1	بَيَانُ الْحِكْمَةِ
u'بَيَانٌ حكمة':Added, #1: 1	بَيَانِ الْحِكْمَةِ
u'بَيَانٌ حكمة':Added, #1: 1	بَيَانَ حِكْمَةِ
u'بَيَانٌ حِكْمَةٌ':Added, #1: 1	بَيَانُ حِكْمَةِ
u'بَيَانٌ حِكْمَةٌ':Added, #1: 1	بَيَانَ حِكْمَةِ
u'بَيَانٌ حُكُومَةٌ':Added, #1: 1	بَيَانُ حِكْمَةِ
u'بَيَانٌ حِلٌّ':Added, #1: 1	بَيَانِ الْحُكُومَاتِ
u'بَيَانٌ حَلالٌ':Added, #1: 1	بَيَانَ حِلِّ
u'بَيَانٌ حُلُولٌ':Added, #2: 2	بَيَانُ الْحَلَالِ
u'بَيَانٌ حِيلَةٌ':Added, #1: 1	بَيَانُ الْحُلُولِ
u'بَيَانٌ خَامٌ':Added, #2: 2	بَيَانُ الْحِيلَةِ
u'بَيَانٌ خراج':Added, #1: 1	بَيَانِ الْخَامِ
u'بَيَانٌ خَرَاجٌ':Added, #1: 1	بَيَانِ الْخَرَاجِ
u'بَيَانٌ خِطَابٌ':Added, #1: 1	بَيَانِ الْخَرَاجِ
u'بَيَانٌ خَفَاءٌ':Added, #1: 1	بَيَانِ خِطَابِهِ
u'بَيَانٌ خِلاَفٌ':Added, #1: 1	بَيَانِ الْخَفَاءِ
u'بَيَانٌ خِلاَفٌ':Added, #1: 1	بَيَانُ خِلَافِ
u'بَيَانٌ خُلْعٌ':Added, #5: 5	بَيَانُ الْخِلَافِ
u'بَيَانٌ خَلَلٌ':Added, #1: 1	بَيَانُ خُلْعِ
u'بَيَانٌ خَلَلٌ':Added, #1: 1	بَيَانُ الْخَلَلِ
u'بَيَانٌ خَوْفٌ':Added, #1: 1	بَيَانُ خَلَلٍ
u'بَيَانٌ خَيْطٌ':Added, #1: 1	بَيَانُ الْخَوْفِ
u'بَيَانٌ درجة':Added, #1: 1	بَيَانَ الْخَيْطِ
u'بَيَانٌ دَرَجَةٌ':Added, #1: 1	بَيَانُ دَرَجَةِ
u'بَيَانٌ دَلائِلُ':Added, #1: 1	بَيَانُ دَرَجَةِ
u'بَيَانٌ دَليلٌ':Added, #2: 2	بَيَانِ الدَّلَائِلِ
u'بَيَانٌ دَليلٌ':Added, #1: 1	بَيَانِ دَلِيلِهِ
u'بَيَانٌ دَليلٌ':Added, #2: 2	بَيَانِ الدَّلِيلِ
u'بَيَانٌ دَليلٌ':Added, #2: 2	بَيَانِ دَلِيلِ
u'بَيَانٌ دِيَةٌ':Added, #3: 3	بَيَانُ الدَّلِيلِ
u'بَيَانٌ ذكر':Added, #1: 1	بَيَانِ دِيَةِ
u'بَيَانٌ ذِكْرٌ':Added, #1: 1	بَيَانُ ذِكْرِ
u'بَيَانٌ ذكر':Added, #1: 1	بَيَانُ ذِكْرِ
u'بَيَانٌ ذِكْرٌ':Added, #2: 2	بَيَانِ ذِكْرِ
u'بَيَانٌ ذُكورَةٌ':Added, #2: 2	بَيَانِ ذِكْرِ
u'بَيَانٌ رَاجِحٌ':Added, #1: 1	بَيَانِ الذُّكُورَةِ
u'بَيَانٌ رَاجِحٌ':Added, #1: 1	بَيَانَ الرَّاجِحِ
u'بَيَانٌ رَاجِحٌ':Added, #1: 1	بَيَانُ الرَّاجِحِ
u'بَيَانٌ رَأْسٌ':Added, #1: 1	بَيَانِ الرَّاجِحِ
u'بَيَانٌ رُتَبٌ':Added, #1: 1	بَيَانِ رَأْسِ
u'بَيَانٌ رَجْعِيٌّ':Added, #1: 1	بَيَانِ رُتَبِهِ
u'بَيَانٌ رُجُوعٌ':Added, #1: 1	بَيَانِ الرَّجْعِيِّ
u'بَيَانٌ رَحْبَةٌ':Added, #1: 1	بَيَانِ الرُّجُوعِ
u'بَيَانٌ رَدٌّ':Added, #1: 1	بَيَانُ رَحْبَتِهِ
u'بَيَانٌ رَسُولٌ':Added, #1: 1	بَيَانِ الرَّدِّ
u'بَيَانٌ رَسُولٌ':Added, #1: 1	بَيَانُ الرَّسُولِ
u'بَيَانٌ رَفْعٌ':Added, #2: 2	بَيَانُ رَسُولِ
u'بَيَانٌ رِكاز':Added, #1: 1	بَيَانُ رَفْعِ
u'بَيَانٌ رُكْنٌ':Added, #1: 1	بَيَانُ الرِّكَازِ
u'بَيَانٌ رُكْن':Added, #1: 1	بَيَانِ الرُّكْنِ
u'بَيَانٌ رَهْنٌ':Added, #1: 1	بَيَانِ الرُّكْنِ
u'بَيَانٌ رَهْنٌ':Added, #1: 1	بَيَانُ الرَّهْنِ
u'بَيَانٌ زَكاةٌ':Added, #1: 1	بَيَانِ الرَّهْنِ
u'بَيَانٌ زَكاةٌ':Added, #1: 1	بَيَانُ الزَّكَاةِ
u'بَيَانٌ زَمَنٌ':Added, #1: 1	بَيَانُ زَكَاةِ
u'بَيَانٌ زَمَنٌ':Added, #2: 2	بَيَانِ الزَّمَنِ
u'بَيَانٌ سَابِقٌ':Added, #3: 3	بَيَانِ زَمَنِ
u'بَيَانٌ سَاعَةٌ':Added, #1: 1	بَيَانُ السَّابِقِ
u'بَيَانٌ سَائِرٌ':Added, #1: 1	بَيَانِ سَاعَةِ
u'بَيَانٌ سَبَبٌ':Added, #1: 1	بَيَانَ سَائِرِ
u'بَيَانٌ سَبَبٌ':Added, #15: 15	بَيَانِ سَبَبِ
u'بَيَانٌ سَبَبٌ':Added, #1: 1	بَيَانِ سَبَبٍ
u'بَيَانٌ سَبَبٌ':Added, #27: 27	بَيَانِ السَّبَبِ
u'بَيَانٌ سَبَبٌ':Added, #2: 2	بَيَانُ سَبَبِهِ
u'بَيَانٌ سَبَبٌ':Added, #2: 2	بَيَانِ سَبَبِهِ
u'بَيَانٌ سَبَبٌ':Added, #4: 4	بَيَانَ السَّبَبِ
u'بَيَانٌ سَبَبٌ':Added, #6: 6	بَيَانُ سَبَبِ
u'بَيَانٌ سَبْقٌ':Added, #8: 8	بَيَانُ السَّبَبِ
u'بَيَانٌ سَبِيلٌ':Added, #1: 1	بَيَانُ السَّبْقِ
u'بَيَانٌ سَرقَةٌ':Added, #1: 1	بَيَانِ السَّبِيلِ
u'بَيَانٌ سَرِقَةٌ':Added, #1: 1	بَيَانِ السَّرِقَةِ
u'بَيَانٌ سَفَرٌ':Added, #1: 1	بَيَانِ السَّرِقَةِ
u'بَيَانٌ سُنَّةٌ':Added, #1: 1	بَيَانِ السَّفَرِ
u'بَيَانٌ سُنَّةٌ':Added, #1: 1	بَيَانَ السُّنَّةِ
u'بَيَانٌ سُنَّةٌ':Added, #3: 3	بَيَانُ السُّنَّةِ
u'بَيَانٌ سنن':Added, #3: 3	بَيَانِ السُّنَّةِ
u'بَيَانٌ سنن':Added, #1: 1	بَيَانُ السُّنَنِ
u'بَيَانٌ سنن':Added, #1: 1	بَيَانِ السُّنَنِ
u'بَيَانٌ سنن':Added, #1: 1	بَيَانِ سُنَنِ
u'بَيَانٌ سُنِّيٌّ':Added, #1: 1	بَيَانِ سُنَنِهِ
u'بَيَانٌ سُؤَالٌ':Added, #2: 2	بَيَانِ السُّنِّيِّ
u'بَيَانٌ سُؤْرٌ':Added, #1: 1	بَيَانُ سُؤَالٍ
u'بَيَانٌ شَاذَّ':Added, #1: 1	بَيَانِ سُؤْرِهِ
u'بَيَانٌ شَاذّ':Added, #1: 1	بَيَانُ الشَّاذَّةِ
u'بَيَانٌ شَارِعٌ':Added, #1: 1	بَيَانُ الشَّاذَّةِ
u'بَيَانٌ شَاهِدٌ':Added, #1: 1	بَيَانِ الشَّارِعِ
u'بَيَانٌ شَاهِدٌ':Added, #1: 1	بَيَانِ الشَّاهِدَيْنِ
u'بَيَانٌ شَاهِدٌ':Added, #1: 1	بَيَانِ شَاهِدِ
u'بَيَانٌ شَبَهٌ':Added, #2: 2	بَيَانِ الشَّاهِدِ
u'بَيَانٌ شَرَائِطُ':Added, #1: 1	بَيَانُ الشَّبَهِ
u'بَيَانٌ شَرَائِطُ':Added, #1: 1	بَيَانِ الشَّرَائِطِ
u'بَيَانٌ شَرَائِطُ':Added, #1: 1	بَيَانُ شَرَائِطِ
u'بَيَانٌ شَرَائِطُ':Added, #1: 1	بَيَانُ شَرَائِطِهِ
u'بَيَانٌ شَرَائِطُ':Added, #1: 1	بَيَانِ شَرَائِطِهِ
u'بَيَانٌ شَرْطٌ':Added, #3: 3	بَيَانِ شَرَائِطِ
u'بَيَانٌ شَرْطٌ':Added, #1: 1	بَيَانِ الشَّرْطِ
u'بَيَانٌ شَرْطٌ':Added, #1: 1	بَيَانُ شَرْطِهِ
u'بَيَانٌ شَرْطٌ':Added, #3: 3	بَيَانُ شَرْطِ
u'بَيَانٌ شَرْعٌ':Added, #3: 3	بَيَانِ شَرْطِ
u'بَيَانٌ شرف':Added, #3: 3	بَيَانَ الشَّرْعِ
u'بَيَانٌ شرف':Added, #1: 1	بَيَانُ شَرَفِ
u'بَيَانٌ شَرَفٌ':Added, #1: 1	بَيَانِ شَرَفِ
u'بَيَانٌ شَرَفٌ':Added, #1: 1	بَيَانُ شَرَفِ
u'بَيَانٌ شِرْكٌ':Added, #1: 1	بَيَانِ شَرَفِ
u'بَيَانٌ شُرُوطٌ':Added, #1: 1	بَيَانُ الشِّرْكِ
u'بَيَانٌ شُرُوطٌ':Added, #1: 1	بَيَانُ شُرُوطٍ
u'بَيَانٌ شُرُوطٌ':Added, #2: 2	بَيَانِ الشُّرُوطِ
u'بَيَانٌ شَرِيعَةٌ':Added, #4: 4	بَيَانِ شُرُوطِ
u'بَيَانٌ شِفَاءٌ':Added, #1: 1	بَيَانُ الشَّرِيعَةِ
u'بَيَانٌ شَهَادَةٌ':Added, #6: 6	بَيَانَ شِفَاءٍ
u'بَيَانٌ شَيْءٌ':Added, #1: 1	بَيَانُ الشَّهَادَةِ
u'بَيَانٌ صِحَّةٌ':Added, #1: 1	بَيَانُ شَيْءٍ
u'بَيَانٌ صِحَّةٌ':Added, #1: 1	بَيَانِ صِحَّةِ
u'بَيَانٌ صَحِيحٌ':Added, #1: 1	بَيَانِ صِحَّتِهِ
u'بَيَانٌ صَرِيحٌ':Added, #2: 2	بَيَانُ الصَّحِيحِ
u'بَيَانٌ صِغَرٌ':Added, #1: 1	بَيَانُ الصَّرِيحِ
u'بَيَانٌ صِفَةٌ':Added, #1: 1	بَيَانِ الصِّغَرِ
u'بَيَانٌ صِفَةٌ':Added, #1: 1	بَيَانِ صِفَةٍ
u'بَيَانٌ صِفَةٌ':Added, #1: 1	بَيَانَ صِفَتِهِ
u'بَيَانٌ صِفَةٌ':Added, #27: 27	بَيَانِ صِفَةِ
u'بَيَانٌ صِفَةٌ':Added, #2: 2	بَيَانُ صِفَتِهِ
u'بَيَانٌ صِفَةٌ':Added, #2: 2	بَيَانِ صِفَتِهِ
u'بَيَانٌ صِفَةٌ':Added, #3: 3	بَيَانُ الصِّفَةِ
u'بَيَانٌ صِفَةٌ':Added, #4: 4	بَيَانُ صِفَةِ
u'بَيَانٌ صَلاَةٌ':Added, #6: 6	بَيَانِ الصِّفَةِ
u'بَيَانٌ صَلاَةٌ':Added, #1: 1	بَيَانِ صَلَاةٍ
u'بَيَانٌ صَلاَحِيَّةٌ':Added, #3: 3	بَيَانِ الصَّلَاةِ
u'بَيَانٌ صلح':Added, #1: 1	بَيَانَ صَلَاحِيَّتِهِ
u'بَيَانٌ صُلْحٌ':Added, #1: 1	بَيَانُ صُلْحِ
u'بَيَانٌ صَلَوَاتٌ':Added, #1: 1	بَيَانُ صُلْحِ
u'بَيَانٌ صنعة':Added, #1: 1	بَيَانِ الصَّلَوَاتِ
u'بَيَانٌ صَنْعَةٌ':Added, #1: 1	بَيَانَ صَنْعَةِ
u'بَيَانٌ صنعة':Added, #1: 1	بَيَانَ صَنْعَةِ
u'بَيَانٌ صَنْعَةٌ':Added, #1: 1	بَيَانِ صَنْعَتِهِ
u'بَيَانٌ صِنْفٌ':Added, #1: 1	بَيَانِ صَنْعَتِهِ
u'بَيَانٌ صُورٌ':Added, #1: 1	بَيَانِ الصِّنْفِ
u'بَيَانٌ صُورٌ':Added, #1: 1	بَيَانِ صُوَرٍ
u'بَيَانٌ صُوَرٌ':Added, #1: 1	بَيَانِ صُوَرِ
u'بَيَانٌ صُوَرٌ':Added, #1: 1	بَيَانِ صُوَرٍ
u'بَيَانٌ صُورَةٌ':Added, #1: 1	بَيَانِ صُوَرِ
u'بَيَانٌ صُورَةٌ':Added, #1: 1	بَيَانُ صُورَةِ
u'بَيَانٌ صِيغَةٌ':Added, #1: 1	بَيَانِ صُورَةِ
u'بَيَانٌ ضَرْبٌ':Added, #1: 1	بَيَانِ الصِّيغَةِ
u'بَيَانٌ ضُرُوبٌ':Added, #1: 1	بَيَانِ الضَّرْبِ
u'بَيَانٌ ضَرُورَةٌ':Added, #1: 1	بَيَانِ ضُرُوبِ
u'بَيَانٌ ضَرُورَةٌ':Added, #1: 1	بَيَانَ الضَّرُورَةِ
u'بَيَانٌ ضَرُورَةٌ':Added, #1: 1	بَيَانُ الضَّرُورَةِ
u'بَيَانٌ ضَرُورَةٌ':Added, #1: 1	بَيَانَ ضَرُورَةِ
u'بَيَانٌ ضَرُورَةٌ':Added, #1: 1	بَيَانِ ضَرُورَةٍ
u'بَيَانٌ ضَمَانٌ':Added, #2: 2	بَيَانِ الضَّرُورَةِ
u'بَيَانٌ طَاعَةٌ':Added, #1: 1	بَيَانِ الضَّمَانِ
u'بَيَانٌ طَاعُونٌ':Added, #1: 1	بَيَانُ الطَّاعَةِ
u'بَيَانٌ طَالِبٌ':Added, #1: 1	بَيَانِ الطَّاعُونِ
u'بَيَانٌ طُرُقٌ':Added, #1: 1	بَيَانِ الطَّالِبِ
u'بَيَانٌ طُرُقٌ':Added, #1: 1	بَيَانِ الطُّرُقِ
u'بَيَانٌ طُرُقٌ':Added, #1: 1	بَيَانُ طُرُقِ
u'بَيَانٌ طَرِيقٌ':Added, #1: 1	بَيَانِ طُرُقِ
u'بَيَانٌ طَرِيقٌ':Added, #1: 1	بَيَانِ الطَّرِيقِ
u'بَيَانٌ طَرِيقٌ':Added, #1: 1	بَيَانَ طَرِيقِ
u'بَيَانٌ طَلاَقٌ':Added, #1: 1	بَيَانِ طَرِيقِ
u'بَيَانٌ طَلاَقٌ':Added, #1: 1	بَيَانَ الطَّلَاقِ
u'بَيَانٌ طَهَارَةٌ':Added, #2: 2	بَيَانِ طَلَاقِ
u'بَيَانٌ طَهَارَةٌ':Added, #2: 2	بَيَانُ طَهَارَتِهِ
u'بَيَانٌ طَوْعٌ':Added, #3: 3	بَيَانِ طَهَارَةِ
u'بَيَانٌ طُولٌ':Added, #1: 1	بَيَانِ الطَّوْعِ
u'بَيَانٌ طُولٌ':Added, #1: 1	بَيَانُ طُولِ
u'بَيَانٌ طُولٌ':Added, #1: 1	بَيَانِ طُولِهِ
u'بَيَانٌ ظاهِر':Added, #2: 2	بَيَانِ الطُّولِ
u'بَيَانٌ ظاهِرَة':Added, #1: 1	بَيَانِ ظَاهِرِيَّةِ
u'بَيَانٌ ظاهِرِيّ':Added, #1: 1	بَيَانِ ظَاهِرِيَّةِ
u'بَيَانٌ ظُهْرٌ':Added, #1: 1	بَيَانِ ظَاهِرِيَّةِ
u'بَيَانٌ ظُهورٌ':Added, #1: 1	بَيَانِ الظُّهْرِ
u'بَيَانٌ ظُهورٌ':Added, #1: 1	بَيَانُ ظُهُورِهِ
u'بَيَانٌ عَاقِبٌ':Added, #1: 1	بَيَانِ ظُهُورِهِ
u'بَيَانٌ عَاقِبَةٌ':Added, #1: 1	بَيَانُ الْعَاقِبَةِ
u'بَيَانٌ عَامٌّ':Added, #1: 1	بَيَانُ الْعَاقِبَةِ
u'بَيَانٌ عِبَارَةٌ':Added, #1: 1	بَيَانِ الْعَامِّ
u'بَيَانٌ عبرة':Added, #1: 1	بَيَانِ الْعِبَارَةِ
u'بَيَانٌ عِبْرَةٌ':Added, #1: 1	بَيَانُ الْعِبْرَةِ
u'بَيَانٌ عتق':Added, #1: 1	بَيَانُ الْعِبْرَةِ
u'بَيَانٌ عِتْقٌ':Added, #1: 1	بَيَانِ عِتْقِ
u'بَيَانٌ عجز':Added, #1: 1	بَيَانِ عِتْقِ
u'بَيَانٌ عَجْزٌ':Added, #1: 1	بَيَانُ الْعَجْزِ
u'بَيَانٌ عجز':Added, #1: 1	بَيَانُ الْعَجْزِ
u'بَيَانٌ عَجْزٌ':Added, #3: 3	بَيَانُ عَجْزِ
u'بَيَانٌ عَدَالَةٌ':Added, #3: 3	بَيَانُ عَجْزِ
u'بَيَانٌ عِدَّةٌ':Added, #1: 1	بَيَانُ الْعَدَالَةِ
u'بَيَانٌ عِدَّةٌ':Added, #2: 2	بَيَانُ عِدَّةِ
u'بَيَانٌ عَدَدٌ':Added, #3: 3	بَيَانِ عِدَّةِ
u'بَيَانٌ عَدَدٌ':Added, #1: 1	بَيَانَ الْعَدَدِ
u'بَيَانٌ عَدَدٌ':Added, #2: 2	بَيَانُ الْعَدَدِ
u'بَيَانٌ عَدَدٌ':Added, #3: 3	بَيَانِ الْعَدَدِ
u'بَيَانٌ عَدَدٌ':Added, #3: 3	بَيَانُ عَدَدِ
u'بَيَانٌ عَدْلٌ':Added, #5: 5	بَيَانِ عَدَدِ
u'بَيَانٌ عَدَمٌ':Added, #1: 1	بَيَانِ الْعَدْلِ
u'بَيَانٌ عَدَمٌ':Added, #1: 1	بَيَانَ عَدَمِ
u'بَيَانٌ عَدَمٌ':Added, #1: 1	بَيَانُ عَدَمِهِ
u'بَيَانٌ عَدَمٌ':Added, #2: 2	بَيَانِ عَدَمِ
u'بَيَانٌ عُذْرٌ':Added, #3: 3	بَيَانُ عَدَمِ
u'بَيَانٌ عزل':Added, #1: 1	بَيَانِ عُذْرِهِ
u'بَيَانٌ عصبة':Added, #1: 1	بَيَانُ عَزْلِهِ
u'بَيَانٌ عَصَبَةٌ':Added, #1: 1	بَيَانِ الْعَصَبَةِ
u'بَيَانٌ عَفْوٌ':Added, #1: 1	بَيَانِ الْعَصَبَةِ
u'بَيَانٌ عَقْلٌ':Added, #1: 1	بَيَانُ الْعَفْوِ
u'بَيَانٌ عَلاَمَةٌ':Added, #2: 2	بَيَانِ الْعَقْلِ
u'بَيَانٌ عِلَّةٌ':Added, #1: 1	بَيَانِ عَلَامَةِ
u'بَيَانٌ عِلَّةٌ':Added, #1: 1	بَيَانُ الْعِلَّةِ
u'بَيَانٌ عِلَّةٌ':Added, #1: 1	بَيَانُ عِلَّةِ
u'بَيَانٌ عِلَّةٌ':Added, #1: 1	بَيَانِ عِلَّةٍ
u'بَيَانٌ عِلَّةٌ':Added, #1: 1	بَيَانِ عِلَّةِ
u'بَيَانٌ علم':Added, #2: 2	بَيَانَ الْعِلَّةِ
u'بَيَانٌ عِلْمٌ':Added, #1: 1	بَيَانِ عِلْمِ
u'بَيَانٌ علم':Added, #1: 1	بَيَانِ عِلْمِ
u'بَيَانٌ عِلْمٌ':Added, #2: 2	بَيَانِ الْعِلْمِ
u'بَيَانٌ عِلِّيٌّ':Added, #2: 2	بَيَانِ الْعِلْمِ
u'بَيَانٌ عِمَالَةٌ':Added, #1: 1	بَيَانُ عِلِّيَّةِ
u'بَيَانٌ عُمْقٌ':Added, #1: 1	بَيَانِ الْعِمَالَةِ
u'بَيَانٌ عُمْقٌ':Added, #1: 1	بَيَانُ عُمْقِهِ
u'بَيَانٌ عَمَلٌ':Added, #1: 1	بَيَانِ عُمْقِهِ
u'بَيَانٌ عَمَلٌ':Added, #2: 2	بَيَانُ الْعَمَلِ
u'بَيَانٌ عُمُومٌ':Added, #2: 2	بَيَانِ الْعَمَلِ
u'بَيَانٌ عُمُومٌ':Added, #1: 1	بَيَانَ الْعُمُومِ
u'بَيَانٌ عُمُومٌ':Added, #1: 1	بَيَانَ عُمُومِ
u'بَيَانٌ عُمُومٌ':Added, #2: 2	بَيَانُ الْعُمُومِ
u'بَيَانٌ عَوْرَةٌ':Added, #2: 2	بَيَانِ الْعُمُومِ
u'بَيَانٌ عَوْرَةٌ':Added, #1: 1	بَيَانُ الْعَوْرَةِ
u'بَيَانٌ عَيْبٌ':Added, #2: 2	بَيَانُ عَوْرَةِ
u'بَيَانٌ عَيْبٌ':Added, #1: 1	بَيَانِ الْعَيْبِ
u'بَيَانٌ عُيُوبٌ':Added, #1: 1	بَيَانِ عَيْبِهِ
u'بَيَانٌ غَايَةٌ':Added, #1: 1	بَيَانِ الْعُيُوبِ
u'بَيَانٌ غَايَةٌ':Added, #1: 1	بَيَانُ الْغَايَةِ
u'بَيَانٌ غَرَضٌ':Added, #1: 1	بَيَانَ غَايَةِ
u'بَيَانٌ غُرْمٌ':Added, #1: 1	بَيَانِ غَرَضِ
u'بَيَانٌ غَزْلٌ':Added, #1: 1	بَيَانُ الْغُرْمِ
u'بَيَانٌ غُسْلٌ':Added, #1: 1	بَيَانَ الْغَزْلِ
u'بَيَانٌ غُسْلٌ':Added, #1: 1	بَيَانُ الْغُسْلِ
u'بَيَانٌ غَصْبٌ':Added, #1: 1	بَيَانِ غُسْلِهِ
u'بَيَانٌ غَلَطٌ':Added, #1: 1	بَيَانِ الْغَصْبِ
u'بَيَانٌ غَلَطٌ':Added, #1: 1	بَيَانِ الْغَلَطِ
u'بَيَانٌ غَلَطٌ':Added, #1: 1	بَيَانُ غَلَطِ
u'بَيَانٌ غِلَظ':Added, #1: 1	بَيَانِ غَلَطِ
u'بَيَانٌ فَارِقٌ':Added, #1: 1	بَيَانُ الْغِلَظِ
u'بَيَانٌ فَارِقٌ':Added, #1: 1	بَيَانَ الْفَارِقِ
u'بَيَانٌ فَاسِدٌ':Added, #1: 1	بَيَانِ فَارِقٍ
u'بَيَانٌ فَائِدَةٌ':Added, #1: 1	بَيَانِ الْفَاسِدَةِ
u'بَيَانٌ فَائِدَةٌ':Added, #1: 1	بَيَانِ فَائِدَتِهِ
u'بَيَانٌ فَرَائِضُ':Added, #6: 6	بَيَانُ فَائِدَةِ
u'بَيَانٌ فَرْض':Added, #1: 1	بَيَانِ الْفَرَائِضِ
u'بَيَانٌ فَرْضٌ':Added, #1: 1	بَيَانُ الْفَرْضِيَّةِ
u'بَيَانٌ فَرْضٌ':Added, #1: 1	بَيَانِ فَرْضِ
u'بَيَانٌ فَرْضِيّ':Added, #2: 2	بَيَانِ الْفَرْضِ
u'بَيَانٌ فَرْضِيَّة':Added, #1: 1	بَيَانُ الْفَرْضِيَّةِ
u'بَيَانٌ فَرْعٌ':Added, #1: 1	بَيَانُ الْفَرْضِيَّةِ
u'بَيَانٌ فرق':Added, #1: 1	بَيَانُ فَرْعٍ
u'بَيَانٌ فَرْقٌ':Added, #1: 1	بَيَانَ الْفَرْقِ
u'بَيَانٌ فَرْقٌ':Added, #1: 1	بَيَانَ الْفَرْقِ
u'بَيَانٌ فرق':Added, #1: 1	بَيَانِ فَرْقٍ
u'بَيَانٌ فَرْقٌ':Added, #4: 4	بَيَانُ الْفَرْقِ
u'بَيَانٌ فرق':Added, #4: 4	بَيَانُ الْفَرْقِ
u'بَيَانٌ فَرْقٌ':Added, #6: 6	بَيَانِ الْفَرْقِ
u'بَيَانٌ فُرْقَةٌ':Added, #6: 6	بَيَانِ الْفَرْقِ
u'بَيَانٌ فُرُوضٌ':Added, #1: 1	بَيَانَ الْفُرْقَةِ
u'بَيَانٌ فُرُوضٌ':Added, #1: 1	بَيَانِ الْفُرُوضِ
u'بَيَانٌ فساد':Added, #1: 1	بَيَانِ فُرُوضِ
u'بَيَانٌ فَسَادٌ':Added, #1: 1	بَيَانِ الْفَسَادِ
u'بَيَانٌ فساد':Added, #1: 1	بَيَانِ الْفَسَادِ
u'بَيَانٌ فَسَادٌ':Added, #2: 2	بَيَانِ فَسَادِ
u'بَيَانٌ فَصْلٌ':Added, #2: 2	بَيَانِ فَسَادِ
u'بَيَانٌ فِضَّةٌ':Added, #1: 1	بَيَانُ الْفَصْلِ
u'بَيَانٌ فِضَّةٌ':Added, #1: 1	بَيَانَ الْفِضَّةِ
u'بَيَانٌ فَضْلٌ':Added, #1: 1	بَيَانِ الْفِضَّةِ
u'بَيَانٌ فَضْلٌ':Added, #1: 1	بَيَانُ فَضْلِ
u'بَيَانٌ فَضْلٌ':Added, #1: 1	بَيَانُ فَضْلِهِ
u'بَيَانٌ فَضْلٌ':Added, #1: 1	بَيَانِ فَضْلِهِ
u'بَيَانٌ فُضُولِيٌّ':Added, #2: 2	بَيَانِ فَضْلِ
u'بَيَانٌ فَضِيلٌ':Added, #1: 1	بَيَانِ الْفُضُولِيِّ
u'بَيَانٌ فَضِيلَةٌ':Added, #1: 1	بَيَانِ فَضِيلَةِ
u'بَيَانٌ فِعْلٌ':Added, #1: 1	بَيَانِ فَضِيلَةِ
u'بَيَانٌ فِعْلٌ':Added, #1: 1	بَيَانَ فِعْلِ
u'بَيَانٌ فِقْهٌ':Added, #2: 2	بَيَانِ الْفِعْلِ
u'بَيَانٌ فِقْهٌ':Added, #1: 1	بَيَانُ الْفِقْهِ
u'بَيَانٌ فِقْهٌ':Added, #1: 1	بَيَانُ فِقْهِ
u'بَيَانٌ فلان':Added, #2: 2	بَيَانِ الْفِقْهِ
u'بَيَانٌ فُلُوسٌ':Added, #1: 1	بَيَانِ ظَاهِرِيَّةِ
u'بَيَانٌ قَاعِدٌ':Added, #1: 1	بَيَانُ الْفُلُوسِ
u'بَيَانٌ قَبْضٌ':Added, #1: 1	بَيَانُ قَاعِدَتَيْنِ
u'بَيَانٌ قَبْضٌ':Added, #1: 1	بَيَانُ الْقَبْضِ
u'بَيَانٌ قَبُولٌ':Added, #2: 2	بَيَانِ الْقَبْضِ
u'بَيَانٌ قتل':Added, #1: 1	بَيَانُ قَبُولِ
u'بَيَانٌ قَتْلٌ':Added, #1: 1	بَيَانِ الْقَتْلِ
u'بَيَانٌ قَتْلٌ':Added, #1: 1	بَيَانِ الْقَتْلِ
u'بَيَانٌ قَدْرٌ':Added, #3: 3	بَيَانُ قَتْلٍ
u'بَيَانٌ قَدْرٌ':Added, #10: 10	بَيَانُ الْقَدْرِ
u'بَيَانٌ قَدْرٌ':Added, #13: 13	بَيَانِ الْقَدْرِ
u'بَيَانٌ قَدْرٌ':Added, #15: 15	بَيَانُ قَدْرِ
u'بَيَانٌ قَدْرٌ':Added, #1: 1	بَيَانَ قَدْرِ
u'بَيَانٌ قَدْرٌ':Added, #2: 2	بَيَانُ قَدْرِهِ
u'بَيَانٌ قَدْرٌ':Added, #8: 8	بَيَانِ قَدْرِ
u'بَيَانٌ قدم':Added, #8: 8	بَيَانِ قَدْرِهِ
u'بَيَانٌ قِدَمٌ':Added, #1: 1	بَيَانِ قِدَمِ
u'بَيَانٌ قِرَاءةٌ':Added, #1: 1	بَيَانِ قِدَمِ
u'بَيَانٌ قُرْآنٌ':Added, #2: 2	بَيَانِ الْقِرَاءَةِ
u'بَيَانٌ قَرْشٌ':Added, #2: 2	بَيَانُ الْقُرْآنِ
u'بَيَانٌ قَرِينٌ':Added, #1: 1	بَيَانِ الْقَرْشِ
u'بَيَانٌ قِسْمٌ':Added, #1: 1	بَيَانِ الْقَرِينَةِ
u'بَيَانٌ قِسْمٌ':Added, #1: 1	بَيَانِ الْقِسْمِ
u'بَيَانٌ قِسْمٌ':Added, #1: 1	بَيَانَ الْقِسْمَيْنِ
u'بَيَانٌ قَسِيمٌ':Added, #5: 5	بَيَانُ الْقِسْمِ
u'بَيَانٌ قصاص':Added, #1: 1	بَيَانِ قَسِيمِ
u'بَيَانٌ قِصَاصٌ':Added, #3: 3	بَيَانِ الْقِصَاصِ
u'بَيَانٌ قَصْدٌ':Added, #3: 3	بَيَانِ الْقِصَاصِ
u'بَيَانٌ قول':Added, #1: 1	بَيَانُ قَصْدِ
u'بَيَانٌ قول':Added, #1: 1	بَيَانَ الْقَوْلِ
u'بَيَانٌ قَوْلٌ':Added, #1: 1	بَيَانِ الْقَوْلِ
u'بَيَانٌ قَوْلٌ':Added, #1: 1	بَيَانَ الْقَوْلِ
u'بَيَانٌ قول':Added, #1: 1	بَيَانِ الْقَوْلِ
u'بَيَانٌ قَوْلٌ':Added, #1: 1	بَيَانُ قَوْلِهِ
u'بَيَانٌ قول':Added, #1: 1	بَيَانُ قَوْلِهِ
u'بَيَانٌ قَوْلٌ':Added, #2: 2	بَيَانُ قَوْلِ
u'بَيَانٌ قول':Added, #2: 2	بَيَانُ قَوْلِ
u'بَيَانٌ قَوْلٌ':Added, #4: 4	بَيَانِ قَوْلِهِ
u'بَيَانٌ قول':Added, #4: 4	بَيَانِ قَوْلِهِ
u'بَيَانٌ قَوْلٌ':Added, #6: 6	بَيَانِ قَوْلِ
u'بَيَانٌ قِيمَةٌ':Added, #6: 6	بَيَانِ قَوْلِ
u'بَيَانٌ قِيمَةٌ':Added, #1: 1	بَيَانُ قِيمَةِ
u'بَيَانٌ قِيمَةٌ':Added, #1: 1	بَيَانَ قِيمَتِهِ
u'بَيَانٌ قِيمَةٌ':Added, #2: 2	بَيَانُ الْقِيمَةِ
u'بَيَانٌ قِيمَةٌ':Added, #2: 2	بَيَانِ قِيمَةِ
u'بَيَانٌ قِيمَةٌ':Added, #5: 5	بَيَانَ الْقِيمَةِ
u'بَيَانٌ كَامِلٌ':Added, #7: 7	بَيَانِ الْقِيمَةِ
u'بَيَانٌ كبائر':Added, #1: 1	بَيَانِ الْكَامِلِ
u'بَيَانٌ كِتَابٌ':Added, #1: 1	بَيَانِ الْكَبَائِرِ
u'بَيَانٌ كِتَابٌ':Added, #1: 1	بَيَانُ الْكِتَابِ
u'بَيَانٌ كذب':Added, #2: 2	بَيَانِ الْكِتَابِ
u'بَيَانٌ كَذِبٌ':Added, #1: 1	بَيَانِ الْكَذِبِ
u'بَيَانٌ كَرَاهَةٌ':Added, #1: 1	بَيَانِ الْكَذِبِ
u'بَيَانٌ كَرَاهَةٌ':Added, #1: 1	بَيَانُ كَرَاهَةِ
u'بَيَانٌ كَرَاهِيَةٌ':Added, #2: 2	بَيَانِ الْكَرَاهَةِ
u'بَيَانٌ كَفَّارٌ':Added, #1: 1	بَيَانُ كَرَاهِيَةِ
u'بَيَانٌ كَفَّارَةٌ':Added, #1: 1	بَيَانِ الْكَفَّارَةِ
u'بَيَانٌ كَفَالَةٌ':Added, #1: 1	بَيَانِ الْكَفَّارَةِ
u'بَيَانٌ كفر':Added, #1: 1	بَيَانِ الْكَفَالَةِ
u'بَيَانٌ كُفْرٌ':Added, #1: 1	بَيَانِ الْكُفْرِ
u'بَيَانٌ كَفَنٌ':Added, #1: 1	بَيَانِ الْكُفْرِ
u'بَيَانٌ كَلاَمٌ':Added, #1: 1	بَيَانُ كَفَنِ
u'بَيَانٌ كَلِمَةٌ':Added, #1: 1	بَيَانِ كَلَامِ
u'بَيَانٌ كَمَالٌ':Added, #1: 1	بَيَانِ كَلِمَةِ
u'بَيَانٌ كَمِّيٌّ':Added, #1: 1	بَيَانُ كَمَالِ
u'بَيَانٌ كَوْنٌ':Added, #1: 1	بَيَانِ كَمِّيَّتِهِ
u'بَيَانٌ كَوْنٌ':Added, #1: 1	بَيَانِ كَوْنِهِ
u'بَيَانٌ كَوْنٌ':Added, #3: 3	بَيَانِ كَوْنِ
u'بَيَانٌ كَيْفِيَّةٌ':Added, #4: 4	بَيَانُ كَوْنِهِ
u'بَيَانٌ كَيْفِيَّةٌ':Added, #12: 12	بَيَانِ كَيْفِيَّةِ
u'بَيَانٌ كَيْفِيَّةٌ':Added, #1: 1	بَيَانِ الْكَيْفِيَّةِ
u'بَيَانٌ كَيْفِيَّةٌ':Added, #1: 1	بَيَانُ كَيْفِيّةِ
u'بَيَانٌ كَيْفِيَّةٌ':Added, #1: 1	بَيَانَ كَيْفِيَّتِهِ
u'بَيَانٌ كَيْفِيَّةٌ':Added, #3: 3	بَيَانِ كَيْفِيَّتِهِ
u'بَيَانٌ كَيْلٌ':Added, #4: 4	بَيَانُ كَيْفِيَّةِ
u'بَيَانٌ لبس':Added, #1: 1	بَيَانِ الْكَيْلِ
u'بَيَانٌ لُبْسٌ':Added, #1: 1	بَيَانُ اللُّبْسِ
u'بَيَانٌ لُزُومٌ':Added, #1: 1	بَيَانُ اللُّبْسِ
u'بَيَانٌ لُغَةٌ':Added, #2: 2	بَيَانُ اللُّزُومِ
u'بَيَانٌ لَفْظٌ':Added, #1: 1	بَيَانُ لُغَاتِهِ
u'بَيَانٌ لَفْظٌ':Added, #1: 1	بَيَانُ اللَّفْظِ
u'بَيَانٌ لَفْظٌ':Added, #1: 1	بَيَانُ لَفْظٍ
u'بَيَانٌ لَفْظٌ':Added, #1: 1	بَيَانِ لَفْظِ
u'بَيَانٌ لَمّ':Added, #2: 2	بَيَانِ لَفْظٍ
u'بَيَانٌ لَمَّة':Added, #1: 1	بَيَانِ لَمِّيَّةِ
u'بَيَانٌ لَوْنٌ':Added, #1: 1	بَيَانِ لَمِّيَّةِ
u'بَيَانٌ لَوْنٌ':Added, #1: 1	بَيَانُ لَوْنِ
u'بَيَانٌ مَاءٌ':Added, #1: 1	بَيَانِ لَوْنِ
u'بَيَانٌ مَالٌ':Added, #1: 1	بَيَانِ الْمَاءِ
u'بَيَانٌ مَانِعٌ':Added, #1: 1	بَيَانِ الْمَالِ
u'بَيَانٌ مَانِعٌ':Added, #2: 2	بَيَانُ مَانِعٍ
u'بَيَانٌ مَبْلَغٌ':Added, #2: 2	بَيَانِ مَانِعٍ
u'بَيَانٌ مُتَأَخِّرٌ':Added, #1: 1	بَيَانِ الْمَبْلَغِ
u'بَيَانٌ مُتَّصِلٌ':Added, #1: 1	بَيَانٍ مُتَأَخِّرٍ
u'بَيَانٌ مِثْلِيٌّ':Added, #1: 1	بَيَانِ الْمُتَّصِلِ
u'بَيَانٌ مُجَادِلٌ':Added, #1: 1	بَيَانِ الْمِثْلِيَّاتِ
u'بَيَانٌ مَجَازٌ':Added, #1: 1	بَيَانُ الْمُجَادِلَةِ
u'بَيَانٌ مَجَازٌ':Added, #1: 1	بَيَانُ الْمَجَازِ
u'بَيَانٌ مَجَازِيٌّ':Added, #1: 1	بَيَانُ مَجَازٍ
u'بَيَانٌ مُجَرَّدٌ':Added, #1: 1	بَيَانُ مَجَازِيَّةِ
u'بَيَانٌ مَجْمَعٌ':Added, #2: 2	بَيَانُ مُجَرَّدِ
u'بَيَانٌ مُجْمَلٌ':Added, #1: 1	بَيَانِ الْمَجْمَعِ
u'بَيَانٌ مُجْمَلٌ':Added, #16: 16	بَيَانِ الْمُجْمَلِ
u'بَيَانٌ مُجْمَلٌ':Added, #1: 1	بَيَانُ مُجْمَلِ
u'بَيَانٌ مُجْمَلٌ':Added, #1: 1	بَيَانِ مُجْمَلٍ
u'بَيَانٌ مُجْمَلٌ':Added, #3: 3	بَيَانَ الْمُجْمَلِ
u'بَيَانٌ مُحْتَاجٌ':Added, #7: 7	بَيَانُ الْمُجْمَلِ
u'بَيَانٌ مَحَجَّةٌ':Added, #1: 1	بَيَانِ الْمُحْتَاجِ
u'بَيَانٌ مَحْدُودٌ':Added, #1: 1	بَيَانِ الْمَحَجَّةِ
u'بَيَانٌ مُحَرَّمٌ':Added, #1: 1	بَيَانُ الْمَحْدُودِ
u'بَيَانٌ مُحَرَّمٌ':Added, #1: 1	بَيَانُ الْمُحَرَّمِ
u'بَيَانٌ مُحَرَّمٌ':Added, #1: 1	بَيَانَ الْمُحَرَّمَاتِ
u'بَيَانٌ مُحَرَّمٌ':Added, #1: 1	بَيَانُ الْمُحَرَّمَاتِ
u'بَيَانٌ مَحْكُومٌ':Added, #6: 6	بَيَانِ الْمُحَرَّمَاتِ
u'بَيَانٌ مَحَلٌّ':Added, #1: 1	بَيَانُ الْمَحْكُومِ
u'بَيَانٌ مَحَلٌّ':Added, #1: 1	بَيَانُ مَحَلٍّ
u'بَيَانٌ مَحَلٌّ':Added, #2: 2	بَيَانِ الْمَحَلِّ
u'بَيَانٌ مَحَلٌّ':Added, #2: 2	بَيَانِ مَحَلِّهِ
u'بَيَانٌ مَحَلٌّ':Added, #6: 6	بَيَانِ مَحَلِّ
u'بَيَانٌ مَحَلَّةٌ':Added, #7: 7	بَيَانُ مَحَلِّ
u'بَيَانٌ مُخَالَفَةٌ':Added, #1: 1	بَيَانَ الْمَحَلَّةِ
u'بَيَانٌ مُخَالَفَةٌ':Added, #1: 1	بَيَانُ الْمُخَالَفَةِ
u'بَيَانٌ مَخْرَجٌ':Added, #1: 1	بَيَانَ مُخَالَفَتِهِ
u'بَيَانٌ مُخَصَّصٌ':Added, #1: 1	بَيَانُ الْمَخْرَجِ
u'بَيَانٌ مُخَلِّصٌ':Added, #1: 1	بَيَانِ الْمُخَصَّصِ
u'بَيَانٌ مَدَارِكُ':Added, #1: 1	بَيَانِ الْمُخَلِّصِ
u'بَيَانٌ مُدَّةٌ':Added, #1: 1	بَيَانِ الْمَدَارِكِ
u'بَيَانٌ مُدَّةٌ':Added, #13: 13	بَيَانُ الْمُدَّةِ
u'بَيَانٌ مُدَّةٌ':Added, #13: 13	بَيَانِ الْمُدَّةِ
u'بَيَانٌ مُدَّةٌ':Added, #1: 1	بَيَانَ مُدَّةِ
u'بَيَانٌ مُدَّةٌ':Added, #1: 1	بَيَانَ مُدَّتِهِ
u'بَيَانٌ مُدَّةٌ':Added, #3: 3	بَيَانُ مُدَّةِ
u'بَيَانٌ مَذْهَبٌ':Added, #6: 6	بَيَانِ مُدَّةِ
u'بَيَانٌ مراد':Added, #4: 4	بَيَانُ مَذْهَبِ
u'بَيَانٌ مراد':Added, #1: 1	بَيَانَ مُرَادِهِ
u'بَيَانٌ مُرَادٌ':Added, #1: 1	بَيَانُ مُرَادِهِ
u'بَيَانٌ مُرَادٌ':Added, #1: 1	بَيَانَ مُرَادِهِ
u'بَيَانٌ مراد':Added, #1: 1	بَيَانُ مُرَادِهِ
u'بَيَانٌ مُرَادٌ':Added, #3: 3	بَيَانِ الْمُرَادِ
u'بَيَانٌ مراد':Added, #3: 3	بَيَانِ الْمُرَادِ
u'بَيَانٌ مُرَادٌ':Added, #7: 7	بَيَانُ الْمُرَادِ
u'بَيَانٌ مَرَضٌ':Added, #7: 7	بَيَانُ الْمُرَادِ
u'بَيَانٌ مَرَضٌ':Added, #1: 1	بَيَانُ الْمَرَضِ
u'بَيَانٌ مُرَكَّبٌ':Added, #1: 1	بَيَانِ الْمَرَضِ
u'بَيَانٌ مَسَافَةٌ':Added, #1: 1	بَيَانِ الْمُرَكَّبِ
u'بَيَانٌ مَسْأَلَةٌ':Added, #1: 1	بَيَانِ الْمَسَافَةِ
u'بَيَانٌ مَسْأَلَةٌ':Added, #1: 1	بَيَانِ الْمَسْأَلَةِ
u'بَيَانٌ مَسْأَلَةٌ':Added, #1: 1	بَيَانِ مَسْأَلَةٍ
u'بَيَانٌ مَسَائِلُ':Added, #1: 1	بَيَانِ مَسْأَلَةِ
u'بَيَانٌ مَسَائِلُ':Added, #1: 1	بَيَانُ الْمَسَائِلِ
u'بَيَانٌ مَسَائِلُ':Added, #2: 2	بَيَانِ مَسَائِلِهِ
u'بَيَانٌ مَسَائِلُ':Added, #3: 3	بَيَانِ الْمَسَائِلِ
u'بَيَانٌ مُسْتَحَقٌّ':Added, #3: 3	بَيَانِ مَسَائِلِ
u'بَيَانٌ مُسْتَحِقٌّ':Added, #1: 1	بَيَانِ مُسْتَحَقِّ
u'بَيَانٌ مُسْتَقْبَلٌ':Added, #1: 1	بَيَانِ مُسْتَحِقِّ
u'بَيَانٌ مُسْتَنَدٌ':Added, #1: 1	بَيَانِ الْمُسْتَقْبَلِ
u'بَيَانٌ مُسْتَنِدٌ':Added, #1: 1	بَيَانِ مُسْتَنَدٍ
u'بَيَانٌ مُسْتَنَدٌ':Added, #1: 1	بَيَانُ مُسْتَنِدِ
u'بَيَانٌ مُسْتَنَدٌ':Added, #1: 1	بَيَانِ مُسْتَنَدِهِ
u'بَيَانٌ مُسْتَهْلَكٌ':Added, #2: 2	بَيَانُ مُسْتَنَدِهِ
u'بَيَانٌ مَسْحٌ':Added, #1: 1	بَيَانِ الْمُسْتَهْلَكِ
u'بَيَانٌ مَسْنُونٌ':Added, #1: 1	بَيَانِ الْمَسْحِ
u'بَيَانٌ مُشْكِلٌ':Added, #1: 1	بَيَانِ الْمَسْنُونِ
u'بَيَانٌ مُشْكِلٌ':Added, #2: 2	بَيَانَ الْمُشْكِلِ
u'بَيَانٌ مَصَارِفُ':Added, #3: 3	بَيَانِ الْمُشْكِلِ
u'بَيَانٌ مَصَارِفُ':Added, #1: 1	بَيَانِ مَصَارِفِ
u'بَيَانٌ مَصْرِفٌ':Added, #3: 3	بَيَانُ الْمَصَارِفِ
u'بَيَانٌ مَصْرِفٌ':Added, #1: 1	بَيَان مَصْرِفِ
u'بَيَانٌ مُصَرِّفٌ':Added, #1: 1	بَيَانُ مَصْرِفٍ
u'بَيَانٌ مَصْرِفٌ':Added, #1: 1	بَيَانِ مُصَرِّفِ
u'بَيَانٌ مَصْرِفٌ':Added, #1: 1	بَيَانِ مَصْرِفِهِ
u'بَيَانٌ مَصْرِفٌ':Added, #2: 2	بَيَانُ الْمَصْرِفِ
u'بَيَانٌ مَصْرِفٌ':Added, #5: 5	بَيَانِ الْمَصْرِفِ
u'بَيَانٌ مَصْلَحَةٌ':Added, #5: 5	بَيَانِ مَصْرِفِ
u'بَيَانٌ مَصْلَحَةٌ':Added, #1: 1	بَيَانُ الْمَصْلَحَةِ
u'بَيَانٌ مَطَالِبُ':Added, #1: 1	بَيَانِ الْمَصْلَحَةِ
u'بَيَانٌ مِطْلاَقٌ':Added, #1: 1	بَيَانِ الْمَطَالِبِ
u'بَيَانٌ مُطَلَّقٌ':Added, #1: 1	بَيَانُ الْمِطْلَاقِ
u'بَيَانٌ مُطْلَقٌ':Added, #1: 1	بَيَانُ الْمُطَلَّقَةِ
u'بَيَانٌ مُطَلَّقٌ':Added, #1: 1	بَيَانُ مُطْلَقِ
u'بَيَانٌ مَعَادِنُ':Added, #2: 2	بَيَانِ الْمُطَلَّقَةِ
u'بَيَانٌ مُعْتَمَدٌ':Added, #1: 1	بَيَانِ الْمَعَادِنِ
u'بَيَانٌ مَعْدِنٌ':Added, #2: 2	بَيَانِ الْمُعْتَمَدِ
u'بَيَانٌ مَعْدُودٌ':Added, #1: 1	بَيَانِ الْمَعْدِنِ
u'بَيَانٌ مَعْدُومٌ':Added, #1: 1	بَيَانِ الْمَعْدُودِ
u'بَيَانٌ مَعْرِفَةٌ':Added, #1: 1	بَيَانُ الْمَعْدُومِ
u'بَيَانٌ مَعْرِفَة':Added, #2: 2	بَيَانِ مَعْرِفَةِ
u'بَيَانٌ مَعْلُومٌ':Added, #2: 2	بَيَانِ مَعْرِفَةِ
u'بَيَانٌ مَعْمُولٌ':Added, #1: 1	بَيَانِ الْمَعْلُومِ
u'بَيَانٌ مُغَلَّب':Added, #1: 1	بَيَانُ الْمَعْمُولِ
u'بَيَانٌ مَفْرُوضٌ':Added, #1: 1	بَيَانُ الْمُغَلَّبِ
u'بَيَانٌ مُفْسِدٌ':Added, #1: 1	بَيَانِ الْمَفْرُوضَاتِ
u'بَيَانٌ مَفْعُولٌ':Added, #2: 2	بَيَانِ الْمُفْسِدَاتِ
u'بَيَانٌ مَفْهُومٌ':Added, #1: 1	بَيَانِ مَفْعُولِ
u'بَيَانٌ مُقَابِلٌ':Added, #1: 1	بَيَانُ الْمَفْهُومِ
u'بَيَانٌ مَقَادِيرُ':Added, #1: 1	بَيَانِ مُقَابِلِهِ
u'بَيَانٌ مَقَامٌ':Added, #1: 1	بَيَانُ الْمَقَادِيرِ
u'بَيَانٌ مَقَامٌ':Added, #1: 1	بَيَانِ الْمَقَامِ
u'بَيَانٌ مِقْدَارٌ':Added, #2: 2	بَيَانِ مَقَامِ
u'بَيَانٌ مِقْدَارٌ':Added, #1: 1	بَيَانَ الْمِقْدَارِ
u'بَيَانٌ مِقْدَارٌ':Added, #1: 1	بَيَانُ الْمِقْدَارِ
u'بَيَانٌ مِقْدَارٌ':Added, #1: 1	بَيَانُ مِقْدَارِهِ
u'بَيَانٌ مِقْدَارٌ':Added, #2: 2	بَيَانَ مِقْدَارِهِ
u'بَيَانٌ مِقْدَارٌ':Added, #2: 2	بَيَانِ مِقْدَارِهِ
u'بَيَانٌ مِقْدَارٌ':Added, #3: 3	بَيَانِ الْمِقْدَارِ
u'بَيَانٌ مِقْدَارٌ':Added, #3: 3	بَيَانُ مِقْدَارِ
u'بَيَانٌ مُقَدَّرٌ':Added, #6: 6	بَيَانِ مِقْدَارِ
u'بَيَانٌ مكارم':Added, #1: 1	بَيَانُ الْمُقَدَّرِ
u'بَيَانٌ مَكَارِمُ':Added, #1: 1	بَيَانِ مَكَارِمِ
u'بَيَانٌ مَكَانٌ':Added, #1: 1	بَيَانِ مَكَارِمِ
u'بَيَانٌ مَكَانٌ':Added, #11: 11	بَيَانِ مَكَانِ
u'بَيَانٌ مَكَانٌ':Added, #19: 19	بَيَانُ مَكَانِ
u'بَيَانٌ مَكَانٌ':Added, #1: 1	بَيَانُ الْمَكَانِ
u'بَيَانٌ مَكَانٌ':Added, #1: 1	بَيَانَ مَكَانِ
u'بَيَانٌ مَكَانٌ':Added, #1: 1	بَيَانُ مَكَانِهِ
u'بَيَانٌ مَكْرٌ':Added, #2: 2	بَيَانِ الْمَكَانِ
u'بَيَانٌ مَكْرُوهٌ':Added, #1: 1	بَيَانِ الْمَكْرِ
u'بَيَانٌ مَكْرُوهٌ':Added, #1: 1	بَيَانَ الْمَكْرُوهِ
u'بَيَانٌ مَكْرُوهَةٌ':Added, #1: 1	بَيَانِ الْمَكْرُوهَاتِ
u'بَيَانٌ مُلاَزَمَةٌ':Added, #1: 1	بَيَانِ الْمَكْرُوهَاتِ
u'بَيَانٌ مُلاَزَمَةٌ':Added, #1: 1	بَيَانَ الْمُلَازَمَةِ
u'بَيَانٌ مَلْبَنٌ':Added, #2: 2	بَيَانُ الْمُلَازَمَةِ
u'بَيَانٌ مُمَاثَلَةٌ':Added, #1: 1	بَيَانِ الْمَلْبَنِ
u'بَيَانٌ مُنَاسَبَةٌ':Added, #1: 1	بَيَانُ الْمُمَاثَلَةِ
u'بَيَانٌ مُنَاسَبَةٌ':Added, #1: 1	بَيَانُ مُنَاسَبَةِ
u'بَيَانٌ مُنَاسَبَةٌ':Added, #1: 1	بَيَانُ مُنَاسَبَتِهِ
u'بَيَانٌ مَنْزِلَةٌ':Added, #2: 2	بَيَانُ الْمُنَاسَبَةِ
u'بَيَانٌ مَهْرٌ':Added, #1: 1	بَيَانُ مَنْزِلَتِهِ
u'بَيَانٌ مَهْرٌ':Added, #1: 1	بَيَانِ الْمَهْرِ
u'بَيَانٌ مُهُورٌ':Added, #1: 1	بَيَانِ مَهْرِ
u'بَيَانٌ مَوَارِيثُ':Added, #1: 1	بَيَانِ مُهُورِ
u'بَيَانٌ مَوَاضِعُ':Added, #1: 1	بَيَانُ الْمَوَارِيثِ
u'بَيَانٌ مَوَاقِيتُ':Added, #3: 3	بَيَانِ مَوَاضِعِ
u'بَيَانٌ مَوَاقِيتُ':Added, #1: 1	بَيَانِ الْمَوَاقِيتِ
u'بَيَانٌ مُوجَبٌ':Added, #1: 1	بَيَانِ مَوَاقِيتِ
u'بَيَانٌ مُوجِبٌ':Added, #1: 1	بَيَانِ الْمُوجَبِ
u'بَيَانٌ مُوجِبٌ':Added, #1: 1	بَيَانِ الْمُوجِبِ
u'بَيَانٌ مُوجِبٌ':Added, #1: 1	بَيَانِ مُوجِبِ
u'بَيَانٌ مُوجِبٌ':Added, #1: 1	بَيَانِ مُوجِبَاتِ
u'بَيَانٌ مُوَرِّث':Added, #1: 1	بَيَانِ مُوجِبِهِ
u'بَيَانٌ مَوْضِعٌ':Added, #1: 1	بَيَانِ الْمُوَرِّثِ
u'بَيَانٌ مَوْضِعٌ':Added, #1: 1	بَيَانُ الْمَوْضِعِ
u'بَيَانٌ مَوْضِعٌ':Added, #1: 1	بَيَانَ مَوْضِعِ
u'بَيَانٌ مَوْضِعٌ':Added, #2: 2	بَيَانِ الْمَوْضِعِ
u'بَيَانٌ مَوْضِعٌ':Added, #2: 2	بَيَانِ مَوْضِعِ
u'بَيَانٌ مَوْضُوعٌ':Added, #7: 7	بَيَانُ مَوْضِعِ
u'بَيَانٌ مَوْضُوعٌ':Added, #1: 1	بَيَانُ الْمَوْضُوعِ
u'بَيَانٌ مِيَاهٌ':Added, #1: 1	بَيَانِ مَوْضُوعِهِ
u'بَيَانٌ مِيرَاثٌ':Added, #1: 1	بَيَانِ الْمِيَاهِ
u'بَيَانٌ نَاحِي':Added, #2: 2	بَيَانِ مِيرَاثِ
u'بَيَانٌ نَاحِيَةٌ':Added, #1: 1	بَيَانُ النَّاحِيَةِ
u'بَيَانٌ نَبِيٌّ':Added, #1: 1	بَيَانُ النَّاحِيَةِ
u'بَيَانٌ نَبِيٌّ':Added, #1: 1	بَيَانُ النَّبِيِّ
u'بَيَانٌ نَجَاسَةٌ':Added, #1: 1	بَيَانِ النَّبِيِّ
u'بَيَانٌ نَجَاسَةٌ':Added, #1: 1	بَيَانِ النَّجَاسَاتِ
u'بَيَانٌ نَدْبٌ':Added, #6: 6	بَيَانِ النَّجَاسَةِ
u'بَيَانٌ نَدْبٌ':Added, #1: 1	بَيَانِ النَّدْبِ
u'بَيَانٌ نَسَبٌ':Added, #1: 1	بَيَانِ نَدْبِ
u'بَيَانٌ نصب':Added, #1: 1	بَيَانِ نَسَبٍ
u'بَيَانٌ نُصُبٌ':Added, #2: 2	بَيَانُ النُّصُبِ
u'بَيَانٌ نَصِيبٌ':Added, #2: 2	بَيَانُ النُّصُبِ
u'بَيَانٌ نَصِيبٌ':Added, #1: 1	بَيَانُ النَّصِيبِ
u'بَيَانٌ نَصِيبٌ':Added, #1: 1	بَيَانُ نَصِيبِ
u'بَيَانٌ نَصِيبٌ':Added, #2: 2	بَيَانِ نَصِيبِ
u'بَيَانٌ نظائر':Added, #3: 3	بَيَانِ نَصِيبِهِ
u'بَيَانٌ نَفْسٌ':Added, #1: 1	بَيَانُ نَظَائِرِهِ
u'بَيَانٌ نَفْسٌ':Added, #1: 1	بَيَانُ نَفْسِ
u'بَيَانٌ نَفْسٌ':Added, #1: 1	بَيَانَ نَفْسِهِ
u'بَيَانٌ نَفَقَةٌ':Added, #1: 1	بَيَانِ نَفْسِهِ
u'بَيَانٌ نَفَقَةٌ':Added, #3: 3	بَيَانِ النَّفَقَةِ
u'بَيَانٌ نَفَقَةٌ':Added, #3: 3	بَيَانُ نَفَقَةِ
u'بَيَانٌ نَفْيٌ':Added, #4: 4	بَيَانِ نَفَقَةِ
u'بَيَانٌ نُقْصَانٌ':Added, #1: 1	بَيَانِ نَفْيِهِ
u'بَيَانٌ نُقْصَانٌ':Added, #1: 1	بَيَانُ نُقْصَانِ
u'بَيَانٌ نَقْضٌ':Added, #1: 1	بَيَانِ نُقْصَانِ
u'بَيَانٌ نكاح':Added, #1: 1	بَيَانِ نَقْضِ
u'بَيَانٌ نِكَاحٌ':Added, #3: 3	بَيَانِ نِكَاحِ
u'بَيَانٌ نِهَايَةٌ':Added, #3: 3	بَيَانِ نِكَاحِ
u'بَيَانٌ نَوَافِلُ':Added, #1: 1	بَيَانُ النِّهَايَةِ
u'بَيَانٌ نَوْعٌ':Added, #1: 1	بَيَانِ النَّوَافِلِ
u'بَيَانٌ نَوْعٌ':Added, #1: 1	بَيَانَ النَّوْعَيْنِ
u'بَيَانٌ نَوْعٌ':Added, #1: 1	بَيَانَ نَوْعِ
u'بَيَانٌ نَوْعٌ':Added, #1: 1	بَيَانُ نَوْعٍ
u'بَيَانٌ نَوْعٌ':Added, #1: 1	بَيَانُ نَوْعِهِ
u'بَيَانٌ نَوْعٌ':Added, #1: 1	بَيَانِ نَوْعِهِ
u'بَيَانٌ نَوْعٌ':Added, #2: 2	بَيَانُ النَّوْعِ
u'بَيَانٌ نَوْعٌ':Added, #2: 2	بَيَانُ نَوْعِ
u'بَيَانٌ نَوْعٌ':Added, #3: 3	بَيَانَ النَّوْعِ
u'بَيَانٌ نِيَّةٌ':Added, #4: 4	بَيَانِ النَّوْعِ
u'بَيَانٌ نِيَّةٌ':Added, #1: 1	بَيَانِ نِيَّتِهِ
u'بَيَانٌ هَدْيٌ':Added, #2: 2	بَيَانِ النِّيَّةِ
u'بَيَانٌ وَاجِبٌ':Added, #1: 1	بَيَانِ الْهَدْيِ
u'بَيَانٌ وَاجِبٌ':Added, #1: 1	بَيَانَ الْوَاجِبِ
u'بَيَانٌ واحد':Added, #1: 1	بَيَانُ الْوَاجِبَاتِ
u'بَيَانٌ وَاحِدٌ':Added, #1: 1	بَيَانِ وَاحِدٍ
u'بَيَانٌ وَارِثٌ':Added, #1: 1	بَيَانِ وَاحِدٍ
u'بَيَانٌ وَاضِعٌ':Added, #1: 1	بَيَانِ الْوَارِثَاتِ
u'بَيَانٌ وَاقِعٌ':Added, #1: 1	بَيَانِ الْوَاضِعِ
u'بَيَانٌ وَاقِعٌ':Added, #1: 1	بَيَانِ الْوَاقِعِ
u'بَيَانٌ وَاقِعٌ':Added, #1: 1	بَيَانِ الْوَاقِعَةِ
u'بَيَانٌ وَاقِعَةٌ':Added, #2: 2	بَيَانُ الْوَاقِعِ
u'بَيَانٌ وَاقِفٌ':Added, #1: 1	بَيَانِ الْوَاقِعَةِ
u'بَيَانٌ وَجْهٌ':Added, #1: 1	بَيَانُ الْوَاقِفِ
u'بَيَانٌ وَجْهٌ':Added, #1: 1	بَيَانِ الْوَجْهِ
u'بَيَانٌ وَجْهٌ':Added, #1: 1	بَيَانَ وَجْهِ
u'بَيَانٌ وَجْهٌ':Added, #1: 1	بَيَانِ وَجْهٍ
u'بَيَانٌ وَجْهٌ':Added, #2: 2	بَيَانُ الْوَجْهِ
u'بَيَانٌ وَجْهٌ':Added, #2: 2	بَيَانُ وَجْهٍ
u'بَيَانٌ وَجْهٌ':Added, #2: 2	بَيَانِ وَجْهِهِ
u'بَيَانٌ وَجْهٌ':Added, #5: 5	بَيَانُ وَجْهِ
u'بَيَانٌ وُجُوبٌ':Added, #7: 7	بَيَانِ وَجْهِ
u'بَيَانٌ وُجُوبٌ':Added, #1: 1	بَيَانَ وُجُوبِ
u'بَيَانٌ وُجُوبٌ':Added, #1: 1	بَيَانِ وُجُوبِ
u'بَيَانٌ وُجُوبٌ':Added, #1: 1	بَيَانُ وُجُوبِهِ
u'بَيَانٌ وُجُودٌ':Added, #2: 2	بَيَانُ وُجُوبِ
u'بَيَانٌ وُجُوهٌ':Added, #1: 1	بَيَانُ وُجُودِ
u'بَيَانٌ وُجُوهٌ':Added, #1: 1	بَيَانُ وُجُوهِ
u'بَيَانٌ وُرَّاثٌ':Added, #2: 2	بَيَانِ وُجُوهِ
u'بَيَانٌ وَرَثَةٌ':Added, #1: 1	بَيَانِ الْوُرَّاثِ
u'بَيَانٌ وَزْنٌ':Added, #2: 2	بَيَانِ الْوَرَثَةِ
u'بَيَانٌ وَزْنٌ':Added, #2: 2	بَيَانِ الْوَزْنِ
u'بَيَانٌ وَصْفٌ':Added, #4: 4	بَيَانِ وَزْنِهِ
u'بَيَانٌ وَصْفٌ':Added, #3: 3	بَيَانِ الْوَصْفِ
u'بَيَانٌ وَصْفٌ':Added, #3: 3	بَيَانِ وَصْفِهِ
u'بَيَانٌ وَصِيٌّ':Added, #5: 5	بَيَانُ الْوَصْفِ
u'بَيَانٌ وَصِيَّةٌ':Added, #2: 2	بَيَانِ الْوَصِيَّةِ
u'بَيَانٌ وَضْعٌ':Added, #2: 2	بَيَانِ الْوَصِيَّةِ
u'بَيَانٌ وُضُوءٌ':Added, #2: 2	بَيَانُ وَضْعِ
u'بَيَانٌ وطاء':Added, #1: 1	بَيَانِ الْوُضُوءِ
u'بَيَانٌ وِطَاءٌ':Added, #1: 1	بَيَانِ الْوِطَاءِ
u'بَيَانٌ وَقْتٌ':Added, #1: 1	بَيَانِ الْوِطَاءِ
u'بَيَانٌ وَقْتٌ':Added, #15: 15	بَيَانِ وَقْتِ
u'بَيَانٌ وَقْتٌ':Added, #1: 1	بَيَانَ الْوَقْتِ
u'بَيَانٌ وَقْتٌ':Added, #2: 2	بَيَانُ الْوَقْتِ
u'بَيَانٌ وَقْتٌ':Added, #2: 2	بَيَانِ وَقْتِهِ
u'بَيَانٌ وَقْتٌ':Added, #3: 3	بَيَانَ وَقْتِ
u'بَيَانٌ وَقْتٌ':Added, #4: 4	بَيَانُ وَقْتِ
u'بَيَانٌ وُقُوعٌ':Added, #7: 7	بَيَانِ الْوَقْتِ
u'بَيَانٌ وُقُوعٌ':Added, #1: 1	بَيَانِ وُقُوعِ
u'بَيَانٌ وُقُوعٌ':Added, #1: 1	بَيَانُ وُقُوعِهِ
u'بَيَانٌ وِلاَيَةٌ':Added, #1: 1	بَيَانِ وُقُوعِهِ
u'بَيَانٌ وَهَنٌ':Added, #1: 1	بَيَانَ وِلَايَةِ
u'بَيَانٌ يَتِيمٌ':Added, #1: 1	بَيَانَ وَهَنِ
u'بَيَانٌ يَدٌ':Added, #1: 1	بَيَانُ الْيَتِيمِ
u'بَيَانٌ يَمِينٌ':Added, #1: 1	بَيَانِ الْيَدِ
u'بَيَّتَ أهْلٌ':Predicate, #2: 2	بَيَانِ الْيَمِينِ
u'بَيَّتَ صَوْمٌ':Predicate, #1: 1	بَيَّتَ أَهْلَ
u'بَيَّتَ صِيَامٌ':Predicate, #3: 3	بَيَّتَ الصَّوْمَ
u'بَيَّتَ فِطْرٌ':Predicate, #1: 1	بَيَّتَ الصِّيَامَ
u'بَيَّتَ نِيَّةٌ':Predicate, #2: 2	بَيَّتَ الْفِطْرَ
u'بَيَّضَ أسْنَانٌ':Predicate, #3: 3	بَيَّتَ النِّيَّةَ
u'بَيَّضَ فلان':Subject, #1: 1	بَيَّضَ الْأَسْنَانَ
u'بَيْعٌ أَبٌ':Added, #1: 1	بَيَّضَ الْمُنْذِرِيُّ
u'بَيْعٌ أَبٌ':Added, #10: 10	بَيْعُ الْأَبِ
u'بَيْعٌ أَبٌ':Added, #1: 1	بَيْعَ الْأَبِ
u'بَيْعٌ آبارٌ':Added, #5: 5	بَيْعِ الْأَبِ
u'بَيْعٌ آبارٌ':Added, #1: 1	بَيْعُ الْآبَارِ
u'بَيْعٌ إِبِلٌ':Added, #1: 1	بَيْعِ الْآبَارِ
u'بَيْعٌ إِبِلٌ':Added, #1: 1	بَيْعُ الْإِبِلِ
u'بَيْعٌ اِبْنٌ':Added, #1: 1	بَيْعِ الْإِبِلِ
u'بَيْعٌ أَبْوَالٌ':Added, #1: 1	بَيْعِ ابْنِهِ
u'بَيْعٌ أَثْمانٌ':Added, #1: 1	بَيْعُ أَبْوَالِ
u'بَيْعٌ إجَارَةٌ':Added, #1: 1	بَيْعَ الْأَثْمَانِ
u'بَيْعٌ أُجْرَةٌ':Added, #1: 1	بَيْعُ إجَارَةٍ
u'بَيْعٌ أَجْزَاءٌ':Added, #1: 1	بَيْعُ الْأُجْرَةِ
u'بَيْعٌ آجِلٌ':Added, #2: 2	بَيْعُ أَجْزَاءِ
u'بَيْعٌ أَجْنَبِيٌّ':Added, #4: 4	بَيْعُ آجِلٍ
u'بَيْعٌ أَجِنَّةٌ':Added, #2: 2	بَيْعِ الْأَجْنَبِيِّ
u'بَيْعٌ أَجِنَّةٌ':Added, #1: 1	بَيْعُ الْأَجِنَّةِ
u'بَيْعٌ أحَدٌ':Added, #1: 1	بَيْعِ الْأَجِنَّةِ
u'بَيْعٌ أحَدٌ':Added, #1: 1	بَيْعَ أَحَدِ
u'بَيْعٌ أحَدٌ':Added, #6: 6	بَيْعِ أَحَدِ
u'بَيْعٌ أحْمَالٌ':Added, #7: 7	بَيْعُ أَحَدِ
u'بَيْعٌ أَحْمَالٌ':Added, #1: 1	بَيْعُ الْأَحْمَالِ
u'بَيْعٌ أَخٌ':Added, #1: 1	بَيْعُ الْأَحْمَالِ
u'بَيْعٌ أخرَس':Added, #1: 1	بَيْعِ الْأَخِ
u'بَيْعٌ أَرْزَاقٌ':Added, #1: 1	بَيْعُ الْأَخْرَسِ
u'بَيْعٌ أَرْزَاقٌ':Added, #1: 1	بَيْعُ أَرْزَاقِ
u'بَيْعٌ أرْضٌ':Added, #1: 1	بَيْعِ الأَرْزَاقِ
u'بَيْعٌ أرْضٌ':Added, #1: 1	بَيْعَ أَرْضٍ
u'بَيْعٌ أرْضٌ':Added, #1: 1	بَيْعُ أَرْضٍ
u'بَيْعٌ أرْضٌ':Added, #2: 2	بَيْعَ أَرْضِ
u'بَيْعٌ أرْضٌ':Added, #3: 3	بَيْعُ أَرْضِ
u'بَيْعٌ أرْضٌ':Added, #52: 52	بَيْعِ الْأَرْضِ
u'بَيْعٌ أرْضٌ':Added, #7: 7	بَيْعَ الْأَرْضِ
u'بَيْعٌ أَرْطالٌ':Added, #7: 7	بَيْعُ الْأَرْضِ
u'بَيْعٌ أَسَدٌ':Added, #1: 1	بَيْعُ أَرْطَالٍ
u'بَيْعٌ أَسْفَلُ':Added, #1: 1	بَيْعُ الْأَسَدِ
u'بَيْعٌ إِسْلامٌ':Added, #1: 1	بَيْعُ الْأَسْفَلِ
u'بَيْعٌ أَشْجَارٌ':Added, #5: 5	بَيْعَ الْإِسْلَامِ
u'بَيْعٌ أَشْجَارٌ':Added, #1: 1	بَيْعُ أَشْجَارِ
u'بَيْعٌ أَشْجَارٌ':Added, #1: 1	بَيْعُ الْأَشْجَارِ
u'بَيْعٌ أَشْجَارٌ':Added, #2: 2	بَيْعَ الْأَشْجَارِ
u'بَيْعٌ أَشْرِبَةٌ':Added, #2: 2	بَيْعِ الْأَشْجَارِ
u'بَيْعٌ أَشْيَاءٌ':Added, #1: 1	بَيْعُ الْأَشْرِبَةِ
u'بَيْعٌ أصل':Added, #1: 1	بَيْعِ الْأَشْيَاءِ
u'بَيْعٌ أصل':Added, #1: 1	بَيْعُ الْأَصْلِ
u'بَيْعٌ أًصْلٌ':Added, #1: 1	بَيْعِ الْأَصْلِ
u'بَيْعٌ أًصْلٌ':Added, #1: 1	بَيْعُ الْأَصْلِ
u'بَيْعٌ أَصْنَامٌ':Added, #1: 1	بَيْعِ الْأَصْلِ
u'بَيْعٌ أُصولٌ':Added, #2: 2	بَيْعَ الْأَصْنَامِ
u'بَيْعٌ أُصولٌ':Added, #1: 1	بَيْعُ أُصُولِهِ
u'بَيْعٌ أَطْرافٌ':Added, #26: 26	بَيْعِ الْأُصُولِ
u'بَيْعٌ أَطْرَافٌ':Added, #1: 1	بَيْعِ أَطْرَافِ
u'بَيْعٌ أعاجم':Added, #1: 1	بَيْعِ أَطْرَافِ
u'بَيْعٌ أعْيانٌ':Added, #1: 1	بَيْعُ الأَعَاجِمِ
u'بَيْعٌ أَعْيَانٌ':Added, #1: 1	بَيْعَ أَعْيَانِ
u'بَيْعٌ أعْيانٌ':Added, #1: 1	بَيْعَ أَعْيَانِ
u'بَيْعٌ أَعْيَانٌ':Added, #1: 1	بَيْعَ الْأَعْيَانِ
u'بَيْعٌ أعْيانٌ':Added, #1: 1	بَيْعَ الْأَعْيَانِ
u'بَيْعٌ أَعْيَانٌ':Added, #3: 3	بَيْعِ الْأَعْيَانِ
u'بَيْعٌ أعْيانٌ':Added, #3: 3	بَيْعِ الْأَعْيَانِ
u'بَيْعٌ أَعْيَانٌ':Added, #4: 4	بَيْعُ الْأَعْيَانِ
u'بَيْعٌ آلةٌ':Added, #4: 4	بَيْعُ الْأَعْيَانِ
u'بَيْعٌ إِلْقَاءٌ':Added, #2: 2	بَيْعِ آلَةِ
u'بَيْعٌ أُمٌّ':Added, #1: 1	بَيْعُ إلْقَاءِ
u'بَيْعٌ أُمٌّ':Added, #11: 11	بَيْعُ الْأُمِّ
u'بَيْعٌ أُمٌّ':Added, #15: 15	بَيْعِ أُمِّ
u'بَيْعٌ أُمٌّ':Added, #1: 1	بَيْعَ الْأُمِّ
u'بَيْعٌ أُمٌّ':Added, #2: 2	بَيْعُ أُمِّهِ
u'بَيْعٌ أُمٌّ':Added, #3: 3	بَيْعِ الْأُمِّ
u'بَيْعٌ أُمٌّ':Added, #3: 3	بَيْعَ أُمِّ
u'بَيْعٌ إمَامٌ':Added, #8: 8	بَيْعُ أُمِّ
u'بَيْعٌ إمَامٌ':Added, #1: 1	بَيْعُ إمَامٍ
u'بَيْعٌ أمَانَةٌ':Added, #4: 4	بَيْعُ الْإِمَامِ
u'بَيْعٌ أمَةٌ':Added, #2: 2	بَيْعَ الْأَمَانَةِ
u'بَيْعٌ أمَةٌ':Added, #1: 1	بَيْعُ الأَمَةِ
u'بَيْعٌ أمَةٌ':Added, #1: 1	بَيْع الْأَمَةِ
u'بَيْعٌ أمَةٌ':Added, #2: 2	بَيْعِ أَمَتِهِ
u'بَيْعٌ أمَةٌ':Added, #3: 3	بَيْعَ الْأَمَةِ
u'بَيْعٌ أمَةٌ':Added, #3: 3	بَيْعُ الْأَمَةِ
u'بَيْعٌ أمَةٌ':Added, #3: 3	بَيْعُ أَمَةٍ
u'بَيْعٌ أمَةٌ':Added, #3: 3	بَيْعُ أَمَتِهِ
u'بَيْعٌ أَمْتِعَةٌ':Added, #6: 6	بَيْعِ الْأَمَةِ
u'بَيْعٌ آمِرٌ':Added, #1: 1	بَيْعُ أَمْتِعَتِهِ
u'بَيْعٌ أَمْرَد':Added, #1: 1	بَيْعِ الْآمِرِ
u'بَيْعٌ أَمْلاكٌ':Added, #1: 1	بَيْعُ الْأَمْرَدِ
u'بَيْعٌ أَمْلاَكٌ':Added, #1: 1	بَيْعِ أَمْلَاكِ
u'بَيْعٌ أُمَّهَاتٌ':Added, #1: 1	بَيْعِ أَمْلَاكِ
u'بَيْعٌ أُمَّهَاتٌ':Added, #15: 15	بَيْعِ أُمَّهَاتِ
u'بَيْعٌ أُمَّهَاتٌ':Added, #1: 1	بَيْعُ الْأُمَّهَاتِ
u'بَيْعٌ أُمَّهَاتٌ':Added, #2: 2	بَيْعُ أُمَّهَاتِ
u'بَيْعٌ أَمْوَالٌ':Added, #4: 4	بَيْعَ أُمَّهَاتِ
u'بَيْعٌ أَمْوَالٌ':Added, #1: 1	بَيْعَ أَمْوَالِهِ
u'بَيْعٌ أَمْوَالٌ':Added, #1: 1	بَيْعِ أَمْوَالِهِ
u'بَيْعٌ إِناءٌ':Added, #3: 3	بَيْعِ الْأَمْوَالِ
u'بَيْعٌ إِناءٌ':Added, #1: 1	بَيْعِ الْإِنَاءِ
u'بَيْعٌ إِناءٌ':Added, #1: 1	بَيْعِ إنَاءٍ
u'بَيْعٌ إِناءٌ':Added, #1: 1	بَيْعِ إنَاءِ
u'بَيْعٌ اِنْتِهاءٌ':Added, #2: 2	بَيْعُ إنَاءٍ
u'بَيْعٌ إِنْسانٌ':Added, #1: 1	بَيْعُ انْتِهَاءٍ
u'بَيْعٌ أَنْقَاضٌ':Added, #1: 1	بَيْعَ الْإِنْسَانِ
u'بَيْعٌ أَنْقَاضٌ':Added, #1: 1	بَيْعُ أَنْقَاضِ
u'بَيْعٌ أُنْمُوذَجٌ':Added, #1: 1	بَيْعُ أَنْقَاضِهِ
u'بَيْعٌ أَنْوَاعٌ':Added, #2: 2	بَيْعُ الْأُنْمُوذَجِ
u'بَيْعٌ أَنْيَابٌ':Added, #1: 1	بَيْعِ الْأَنْوَاعِ
u'بَيْعٌ آنِيَةٌ':Added, #1: 1	بَيْعَ أَنْيَابِ
u'بَيْعٌ أهْلٌ':Added, #5: 5	بَيْعُ آنِيَةِ
u'بَيْعٌ أَوْقَافٌ':Added, #1: 1	بَيْعُ أَهْلِ
u'بَيْعٌ أَوَّلُ':Added, #1: 1	بَيْعِ الْأَوْقَافِ
u'بَيْعٌ أَوَّلُ':Added, #1: 1	بَيْعَ الْأَوَّلِ
u'بَيْعٌ أَوْلاَدٌ':Added, #1: 1	بَيْعُ الْأَوَّلِ
u'بَيْعٌ بَاذِنْجَانٌ':Added, #1: 1	بَيْعِ أَوْلَادِ
u'بَيْعٌ بَاطِلٌ':Added, #1: 1	بَيْعِ الْبَاذِنْجَانِ
u'بَيْعٌ باقَةٌ':Added, #4: 4	بَيْعٍ بَاطِلٍ
u'بَيْعٌ باقَةٌ':Added, #1: 1	بَيْعُ بَاقِيهِ
u'بَيْعٌ باقِي':Added, #1: 1	بَيْعِ بَاقِيهِ
u'بَيْعٌ باقِي':Added, #1: 1	بَيْعُ بَاقِيهِ
u'بَيْعٌ بالِغٌ':Added, #1: 1	بَيْعِ بَاقِيهِ
u'بَيْعٌ بَائِعٌ':Added, #2: 2	بَيْعُ الْبَالِغِ
u'بَيْعٌ بَائِعٌ':Added, #2: 2	بَيْعُ الْبَائِعِ
u'بَيْعٌ بَتُّ':Added, #2: 2	بَيْعِ الْبَائِعِ
u'بَيْعٌ بَتّ':Added, #1: 1	بَيْعِ الْبَتِّ
u'بَيْعٌ بَتُّ':Added, #1: 1	بَيْعِ الْبَتِّ
u'بَيْعٌ بَتّ':Added, #3: 3	بَيْعَ بَتٍّ
u'بَيْعٌ بَدَلٌ':Added, #3: 3	بَيْعَ بَتٍّ
u'بَيْعٌ بَدَلٌ':Added, #1: 1	بَيْعُ بَدَلِهِ
u'بَيْعٌ بَذْرٌ':Added, #2: 2	بَيْعَ الْبَدَلِ
u'بَيْعٌ بَذْرٌ':Added, #1: 1	بَيْعُ الْبَذْرِ
u'بَيْعٌ بُرٌّ':Added, #1: 1	بَيْعُ بَذْرِ
u'بَيْعٌ بُرٌّ':Added, #1: 1	بَيْعِ الْبُرِّ
u'بَيْعٌ بُرٌّ':Added, #2: 2	بَيْعَ الْبُرِّ
u'بَيْعٌ بَراءةٌ':Added, #6: 6	بَيْعُ الْبُرِّ
u'بَيْعٌ بَراءةٌ':Added, #1: 1	بَيْعُ الْبَرَاءَاتِ
u'بَيْعٌ بَراءةٌ':Added, #1: 1	بَيْعُ الْبَرَاءَةِ
u'بَيْعٌ بَراءةٌ':Added, #2: 2	بَيْعِ الْبَرَاءَةِ
u'بَيْعٌ بُرادَةٌ':Added, #5: 5	بَيْعُ بَرَاءَةٍ
u'بَيْعٌ بَرْبَط':Added, #1: 1	بَيْعُ بُرَادَةِ
u'بَيْعٌ بَرْنامَجٌ':Added, #1: 1	بَيْعُ الْبَرْبَطِ
u'بَيْعٌ بَرْنامَجٌ':Added, #1: 1	بَيْعَ الْبَرْنَامَجِ
u'بَيْعٌ بَرْنامَجٌ':Added, #1: 1	بَيْعُ الْبَرْنَامَجِ
u'بَيْعٌ بَرْنامَجٌ':Added, #1: 1	بَيْعِ الْبَرْنَامَجِ
u'بَيْعٌ بُسْرٌ':Added, #1: 1	بَيْعِ بَرْنَامَجٍ
u'بَيْعٌ بُسْرٌ':Added, #1: 1	بَيْعَ الْبُسْرِ
u'بَيْعٌ بَطْنٌ':Added, #3: 3	بَيْعُ الْبُسْرِ
u'بَيْعٌ بَطْنٌ':Added, #1: 1	بَيْعُ الْبَطْنِ
u'بَيْعٌ بَطْنٌ':Added, #1: 1	بَيْعِ الْبَطْنِ
u'بَيْعٌ بِطِّيخٌ':Added, #1: 1	بَيْعِ بَطْنٍ
u'بَيْعٌ بِطِّيخٌ':Added, #1: 1	بَيْعُ بِطِّيخَةٍ
u'بَيْعٌ بَعْضٌ':Added, #2: 2	بَيْعِ الْبِطِّيخِ
u'بَيْعٌ بَعْضٌ':Added, #13: 13	بَيْعِ بَعْضٍ
u'بَيْعٌ بَعْضٌ':Added, #1: 1	بَيْعُ بَعْضٍ
u'بَيْعٌ بَعْضٌ':Added, #24: 24	بَيْعُ بَعْضِهِ
u'بَيْعٌ بَعْضٌ':Added, #2: 2	بَيْعَ الْبَعْضِ
u'بَيْعٌ بَعْضٌ':Added, #3: 3	بَيْعِ الْبَعْضِ
u'بَيْعٌ بَعْضٌ':Added, #3: 3	بَيْعَ بَعْضِ
u'بَيْعٌ بَعْضٌ':Added, #4: 4	بَيْعِ بَعْضِ
u'بَيْعٌ بَعْضٌ':Added, #7: 7	بَيْعُ الْبَعْضِ
u'بَيْعٌ بَعْضٌ':Added, #8: 8	بَيْعِ بَعْضِهِ
u'بَيْعٌ بَعيرٌ':Added, #9: 9	بَيْعُ بَعْضِ
u'بَيْعٌ بَعيرٌ':Added, #1: 1	بَيْعِ بَعِيرِهِ
u'بَيْعٌ بَغْلٌ':Added, #2: 2	بَيْعِ الْبَعِيرِ
u'بَيْعٌ بَقِيَّةٌ':Added, #1: 1	بَيْعُ الْبَغْلِ
u'بَيْعٌ بِكْرٌ':Added, #1: 1	بَيْعُ بَقِيَّتِهِ
u'بَيْعٌ بَلَحٌ':Added, #1: 1	بَيْعِ بِكْرٍ
u'بَيْعٌ بِنَاءٌ':Added, #1: 1	بَيْعُ الْبَلَحِ
u'بَيْعٌ بِنَاءٌ':Added, #2: 2	بَيْعُ بِنَاءِ
u'بَيْعٌ بِنْتٌ':Added, #3: 3	بَيْعُ الْبِنَاءِ
u'بَيْعٌ بِنْتٌ':Added, #2: 2	بَيْعُ الْبِنْتِ
u'بَيْعٌ بُوقٌ':Added, #2: 2	بَيْعُ الْبِنْتَيْنِ
u'بَيْعٌ بَيْتٌ':Added, #1: 1	بَيْعُ الْبُوقِ
u'بَيْعٌ بَيْتٌ':Added, #1: 1	بَيْعِ بَيْتِ
u'بَيْعٌ بيض':Added, #3: 3	بَيْعِ الْبَيْتِ
u'بَيْعٌ بيض':Added, #1: 1	بَيْعِ بَيْضِ
u'بَيْعٌ بَيْضَةٌ':Added, #4: 4	بَيْعُ الْبَيْضِ
u'بَيْعٌ بَيْضَةٌ':Added, #1: 1	بَيْعُ بَيْضَةِ
u'بَيْعٌ بَيْعٌ':Added, #3: 3	بَيْعُ الْبَيْضَةِ
u'بَيْعٌ تِبْن':Added, #1: 1	بَيْعُ بَيْعَتَيْنِ
u'بَيْعٌ تُرَابٌ':Added, #2: 2	بَيْعِ التِّبْنِ
u'بَيْعٌ تُرَابٌ':Added, #1: 1	بَيْعَ تُرَابِ
u'بَيْعٌ تُرَابٌ':Added, #2: 2	بَيْعِ تُرَابِ
u'بَيْعٌ تَرِكَةٌ':Added, #3: 3	بَيْعُ تُرَابِ
u'بَيْعٌ تَرِكَةٌ':Added, #2: 2	بَيْعَ التَّرِكَةِ
u'بَيْعٌ تَرِكَةٌ':Added, #6: 6	بَيْعِ تَرِكَتِهِ
u'بَيْعٌ تُرْكِيّ':Added, #9: 9	بَيْعِ التَّرِكَةِ
u'بَيْعٌ تَعَاوِيذُ':Added, #1: 1	بَيْعُ التُّرْكِيِّ
u'بَيْعٌ تَعَاوِيذُ':Added, #1: 1	بَيْعُ التَّعَاوِيذِ
u'بَيْعٌ تَعَبُّدٌ':Added, #1: 1	بَيْعِ التَّعَاوِيذِ
u'بَيْعٌ تُفَّاحٌ':Added, #1: 1	بَيْعِ التَّعَبُّدِ
u'بَيْعٌ تُفَّاحَةٌ':Added, #1: 1	بَيْعُ التُّفَّاحِ
u'بَيْعٌ تُفَّاحَةٌ':Added, #1: 1	بَيْعُ التُّفَّاحَةِ
u'بَيْعٌ تَفْرِقَة':Added, #1: 1	بَيْعُ تُفَّاحَةٍ
u'بَيْعٌ تَمْر':Added, #1: 1	بَيْعِ التَّفْرِقَةِ
u'بَيْعٌ تَمْر':Added, #10: 10	بَيْعِ التَّمْرِ
u'بَيْعٌ تَمْرٌ':Added, #15: 15	بَيْعُ التَّمْرِ
u'بَيْعٌ تَمْرٌ':Added, #1: 1	بَيْعَ تَمْرٍ
u'بَيْعٌ تَمْرٌ':Added, #1: 1	بَيْعِ تَمْرٍ
u'بَيْعٌ تَمْرَةٌ':Added, #2: 2	بَيْعُ تَمْرٍ
u'بَيْعٌ تَوْلِيَةٌ':Added, #1: 1	بَيْعَ تَمْرَةٍ
u'بَيْعٌ تينٌ':Added, #1: 1	بَيْعُ التَّوْلِيَةِ
u'بَيْعٌ ثَلاثَةٌ':Added, #1: 1	بَيْعُ التِّينِ
u'بَيْعٌ ثِمارٌ':Added, #1: 1	بَيْعَ الثَّلَاثَةِ
u'بَيْعٌ ثِمارٌ':Added, #1: 1	بَيْع الثِّمَارِ
u'بَيْعٌ ثِمارٌ':Added, #1: 1	بَيْعَ ثِمَارِ
u'بَيْعٌ ثِمارٌ':Added, #28: 28	بَيْعِ الثِّمَارِ
u'بَيْعٌ ثَمَرٌ':Added, #6: 6	بَيْعُ الثِّمَارِ
u'بَيْعٌ ثَمَرٌ':Added, #13: 13	بَيْعُ الثَّمَرِ
u'بَيْعٌ ثَمَرٌ':Added, #1: 1	بَيْعَ الثَّمَرِ
u'بَيْعٌ ثَمَرٌ':Added, #23: 23	بَيْعِ الثَّمَرِ
u'بَيْعٌ ثَمَرٌ':Added, #2: 2	بَيْعِ ثَمَرِ
u'بَيْعٌ ثَمَرَةٌ':Added, #9: 9	بَيْعُ ثَمَرٍ
u'بَيْعٌ ثَمَرَةٌ':Added, #1: 1	بَيْعَ الثَّمَرَةِ
u'بَيْعٌ ثَمَرَةٌ':Added, #1: 1	بَيْعُ ثَمَرَةٍ
u'بَيْعٌ ثَمَرَةٌ':Added, #1: 1	بَيْعُ ثَمَرَةِ
u'بَيْعٌ ثَمَرَةٌ':Added, #1: 1	بَيْعِ ثَمَرَةٍ
u'بَيْعٌ ثَمَرَةٌ':Added, #1: 1	بَيْعِ ثَمَرَةِ
u'بَيْعٌ ثَمَرَةٌ':Added, #23: 23	بَيْعِ الثَّمَرَةِ
u'بَيْعٌ ثَمَنٌ':Added, #6: 6	بَيْعُ الثَّمَرَةِ
u'بَيْعٌ ثَوْبٌ':Added, #2: 2	بَيْعُ الثَّمَنِ
u'بَيْعٌ ثَوْبٌ':Added, #12: 12	بَيْعُ ثَوْبٍ
u'بَيْعٌ ثَوْبٌ':Added, #2: 2	بَيْعَ الثَّوْبِ
u'بَيْعٌ ثَوْبٌ':Added, #3: 3	بَيْعِ ثَوْبٍ
u'بَيْعٌ ثَوْبٌ':Added, #8: 8	بَيْعِ الثَّوْبِ
u'بَيْعٌ ثِيابٌ':Added, #9: 9	بَيْعُ الثَّوْبِ
u'بَيْعٌ ثِيابٌ':Added, #1: 1	بَيْعِ الثِّيَابِ
u'بَيْعٌ جَارِي':Added, #3: 3	بَيْعَ الثِّيَابِ
u'بَيْعٌ جَارِي':Added, #1: 1	بَيْعُ جَارِيَةِ
u'بَيْعٌ جَارِي':Added, #1: 1	بَيْعِ جَارِيَتِهِ
u'بَيْعٌ جَارِي':Added, #2: 2	بَيْعِ جَارِيَةٍ
u'بَيْعٌ جَارِي':Added, #3: 3	بَيْعَ الْجَارِيَةِ
u'بَيْعٌ جَارِي':Added, #3: 3	بَيْعُ الْجَارِيَةِ
u'بَيْعٌ جَارِي':Added, #4: 4	بَيْعُ جَارِيَةٍ
u'بَيْعٌ جَارِيَةٌ':Added, #5: 5	بَيْعِ الْجَارِيَةِ
u'بَيْعٌ جَارِيَةٌ':Added, #1: 1	بَيْعُ جَارِيَةِ
u'بَيْعٌ جَارِيَةٌ':Added, #1: 1	بَيْعِ جَارِيَتِهِ
u'بَيْعٌ جَارِيَةٌ':Added, #2: 2	بَيْعِ جَارِيَةٍ
u'بَيْعٌ جَارِيَةٌ':Added, #3: 3	بَيْعَ الْجَارِيَةِ
u'بَيْعٌ جَارِيَةٌ':Added, #3: 3	بَيْعُ الْجَارِيَةِ
u'بَيْعٌ جَارِيَةٌ':Added, #4: 4	بَيْعُ جَارِيَةٍ
u'بَيْعٌ جَامٌ':Added, #5: 5	بَيْعِ الْجَارِيَةِ
u'بَيْعٌ جَائِزٌ':Added, #1: 1	بَيْعَ الْجَامِ
u'بَيْعٌ جُبّةٌ':Added, #2: 2	بَيْعٍ جَائِزٍ
u'بَيْعٌ جُبّةٌ':Added, #1: 1	بَيْعُ الْجُبَّةِ
u'بَيْعٌ جَحْش':Added, #2: 2	بَيْعِ الْجُبَّةِ
u'بَيْعٌ جِدٌّ':Added, #7: 7	بَيْعُ الْجَحْشِ
u'بَيْعٌ جِدٌّ':Added, #1: 1	بَيْعَ جِدٍّ
u'بَيْعٌ جَديدٌ':Added, #1: 1	بَيْعُ جِدٍّ
u'بَيْعٌ جَديدٌ':Added, #1: 1	بَيْعُ جَدِيدٍ
u'بَيْعٌ جِذْعٌ':Added, #9: 9	بَيْعٍ جَدِيدٍ
u'بَيْعٌ جُزْءٌ':Added, #2: 2	بَيْعُ جِذْعٍ
u'بَيْعٌ جُزْءٌ':Added, #1: 1	بَيْعَ جُزْءِ
u'بَيْعٌ جُزْءٌ':Added, #1: 1	بَيْعُ جُزْءِ
u'بَيْعٌ جُزْءٌ':Added, #2: 2	بَيْعُ الْجُزْءِ
u'بَيْعٌ جُزْءٌ':Added, #2: 2	بَيْعَ جُزْءٍ
u'بَيْعٌ جُزْءٌ':Added, #2: 2	بَيْعُ جُزْءٍ
u'بَيْعٌ جُزْءٌ':Added, #2: 2	بَيْعِ جُزْءٍ
u'بَيْعٌ جُزاف':Added, #3: 3	بَيْعِ الْجُزْءِ
u'بَيْعٌ جَزَرٌ':Added, #1: 1	بَيْعُ الْجُزَافَيْنِ
u'بَيْعٌ جَزَرٌ':Added, #1: 1	بَيْعِ الْجَزَرِ
u'بَيْعٌ جَزُورٌ':Added, #2: 2	بَيْعُ الْجَزَرِ
u'بَيْعٌ جلد':Added, #1: 1	بَيْعُ الْجَزُورِ
u'بَيْعٌ جِلْدٌ':Added, #1: 1	بَيْعِ الْجِلْدِ
u'بَيْعٌ جلد':Added, #1: 1	بَيْعِ الْجِلْدِ
u'بَيْعٌ جِلْدٌ':Added, #1: 1	بَيْعُ جِلْدِهِ
u'بَيْعٌ جلد':Added, #1: 1	بَيْعُ جِلْدِهِ
u'بَيْعٌ جِلْدٌ':Added, #2: 2	بَيْعِ جِلْدِ
u'بَيْعٌ جلد':Added, #2: 2	بَيْعِ جِلْدِ
u'بَيْعٌ جِلْدٌ':Added, #3: 3	بَيْعُ الْجِلْدِ
u'بَيْعٌ جلد':Added, #3: 3	بَيْعُ الْجِلْدِ
u'بَيْعٌ جِلْدٌ':Added, #4: 4	بَيْعُ جِلْدِ
u'بَيْعٌ جُلُودٌ':Added, #4: 4	بَيْعُ جِلْدِ
u'بَيْعٌ جُلُودٌ':Added, #1: 1	بَيْعِ جُلُودِ
u'بَيْعٌ جَمَالٌ':Added, #4: 4	بَيْعُ جُلُودِ
u'بَيْعٌ جِمَالٌ':Added, #1: 1	بَيْعِ الْجَمَالِ
u'بَيْعٌ جَمَدٌ':Added, #1: 1	بَيْعِ الْجِمَالِ
u'بَيْعٌ جَمَلٌ':Added, #1: 1	بَيْعِ الْجَمَدِ
u'بَيْعٌ جُمْلَةٌ':Added, #1: 1	بَيْعَ الْجَمَلِ
u'بَيْعٌ جَمِيع':Added, #1: 1	بَيْعُ جُمْلَتِهِ
u'بَيْعٌ جِنْسٌ':Added, #1: 1	بَيْعَ الْجَمِيعِ
u'بَيْعٌ جِنْسٌ':Added, #1: 1	بَيْعَ الْجِنْسِ
u'بَيْعٌ جِنْسٌ':Added, #1: 1	بَيْعِ الْجِنْسَيْنِ
u'بَيْعٌ جِنْسٌ':Added, #1: 1	بَيْعُ جِنْسِ
u'بَيْعٌ جِنْسٌ':Added, #1: 1	بَيْعِ جِنْسٍ
u'بَيْعٌ جِنْسٌ':Added, #2: 2	بَيْعُ جِنْسٍ
u'بَيْعٌ جَنِينٌ':Added, #6: 6	بَيْعُ الْجِنْسِ
u'بَيْعٌ جَنِينٌ':Added, #1: 1	بَيْعِ الْجَنِينِ
u'بَيْعٌ جواري':Added, #2: 2	بَيْعُ الْجَنِينِ
u'بَيْعٌ جَوَارِي':Added, #1: 1	بَيْعَ جَوَارِيهِ
u'بَيْعٌ جَوْزٌ':Added, #1: 1	بَيْعَ جَوَارِيهِ
u'بَيْعٌ جَوْزٌ':Added, #1: 1	بَيْعَ الْجَوْزِ
u'بَيْعٌ جَوْزٌ':Added, #1: 1	بَيْعِ الْجَوْزِ
u'بَيْعٌ جَيِّدٌ':Added, #3: 3	بَيْعُ الْجَوْزِ
u'بَيْعٌ جَيِّدٌ':Added, #1: 1	بَيْعُ جَيِّدِهِ
u'بَيْعٌ حاضِرٌ':Added, #4: 4	بَيْعُ الْجَيِّدِ
u'بَيْعٌ حاضِرٌ':Added, #2: 2	بَيْعِ حَاضِرِ
u'بَيْعٌ حاضِرٌ':Added, #3: 3	بَيْعُ حَاضِرٍ
u'بَيْعٌ حاضِرٌ':Added, #3: 3	بَيْعِ حَاضِرٍ
u'بَيْعٌ حاضِرٌ':Added, #5: 5	بَيْعُ الْحَاضِرِ
u'بَيْعٌ حاكِمٌ':Added, #7: 7	بَيْعِ الْحَاضِرِ
u'بَيْعٌ حاكِمٌ':Added, #1: 1	بَيْعَ الْحَاكِمِ
u'بَيْعٌ حاكِمٌ':Added, #2: 2	بَيْعُ الْحَاكِمِ
u'بَيْعٌ حاكِمٌ':Added, #2: 2	بَيْعُ حَاكِمٍ
u'بَيْعٌ حامِلٌ':Added, #3: 3	بَيْعِ الْحَاكِمِ
u'بَيْعٌ حامِلٌ':Added, #1: 1	بَيْعَ الْحَامِلِ
u'بَيْعٌ حامِلٌ':Added, #1: 1	بَيْعِ الْحَامِلِ
u'بَيْعٌ حانوتٌ':Added, #3: 3	بَيْعُ الْحَامِلِ
u'بَيْعٌ حانوتٌ':Added, #1: 1	بَيْعِ الْحَانُوتِ
u'بَيْعٌ حائِطٌ':Added, #1: 1	بَيْعِ حَانُوتِهِ
u'بَيْعٌ حَبٌّ':Added, #1: 1	بَيْعَ الْحَائِطِ
u'بَيْعٌ حَبٌّ':Added, #1: 1	بَيْعَ الْحَبِّ
u'بَيْعٌ حَبٌّ':Added, #1: 1	بَيْعُ حَبِّ
u'بَيْعٌ حَبٌّ':Added, #1: 1	بَيْعِ حَبٍّ
u'بَيْعٌ حَبٌّ':Added, #1: 1	بَيْعِ حَبِّ
u'بَيْعٌ حَبٌّ':Added, #1: 1	بَيْعَ حَبَّةٍ
u'بَيْعٌ حَبٌّ':Added, #4: 4	بَيْعُ الْحَبِّ
u'بَيْعٌ حَبٌّ':Added, #5: 5	بَيْعُ حَبٍّ
u'بَيْعٌ حَبَّةٌ':Added, #8: 8	بَيْعِ الْحَبِّ
u'بَيْعٌ حَبْسٌ':Added, #1: 1	بَيْعَ حَبَّةٍ
u'بَيْعٌ حَبَشِيٌّ':Added, #1: 1	بَيْعَ الْحَبْسِ
u'بَيْعٌ حُبوبٌ':Added, #1: 1	بَيْعُ الْحَبَشِيِّ
u'بَيْعٌ حُبوبٌ':Added, #1: 1	بَيْعَ الْحُبُوبِ
u'بَيْعٌ حُبوبٌ':Added, #1: 1	بَيْعُ الْحُبُوبِ
u'بَيْعٌ حَديدٌ':Added, #1: 1	بَيْعِ الْحُبُوبِ
u'بَيْعٌ حَديدٌ':Added, #1: 1	بَيْعُ الْحَدِيدِ
u'بَيْعٌ حُرٌّ':Added, #2: 2	بَيْعَ الْحَدِيدِ
u'بَيْعٌ حُرٌّ':Added, #3: 3	بَيْعَ الْحُرِّ
u'بَيْعٌ حُرٌّ':Added, #5: 5	بَيْعُ الْحُرِّ
u'بَيْعٌ حَرِيرٌ':Added, #6: 6	بَيْعِ الْحُرِّ
u'بَيْعٌ حَرِيرٌ':Added, #1: 1	بَيْعُ حَرِيرٍ
u'بَيْعٌ حَرِيمٌ':Added, #3: 3	بَيْعُ الْحَرِيرِ
u'بَيْعٌ حَشِيشٌ':Added, #1: 1	بَيْعُ حَرِيمِ
u'بَيْعٌ حَصَاةٌ':Added, #1: 1	بَيْعِ الْحَشِيشَةِ
u'بَيْعٌ حَصَاةٌ':Added, #1: 1	بَيْعَ الْحَصَاةِ
u'بَيْعٌ حَصَاةٌ':Added, #1: 1	بَيْعِ حَصَاةٍ
u'بَيْعٌ حِصَّةٌ':Added, #5: 5	بَيْعِ الْحَصَاةِ
u'بَيْعٌ حِصَّةٌ':Added, #1: 1	بَيْعَ الْحِصَّةِ
u'بَيْعٌ حِصَّةٌ':Added, #1: 1	بَيْعَ حِصَّةِ
u'بَيْعٌ حِصَّةٌ':Added, #1: 1	بَيْعُ حِصَّةِ
u'بَيْعٌ حِصَّةٌ':Added, #1: 1	بَيْع حِصَّتِهِ
u'بَيْعٌ حِصَّةٌ':Added, #2: 2	بَيْعُ الْحِصَّةِ
u'بَيْعٌ حِصَّةٌ':Added, #2: 2	بَيْعِ حِصَّةِ
u'بَيْعٌ حِصَّةٌ':Added, #2: 2	بَيْعَ حِصَّتِهِ
u'بَيْعٌ حَظٌّ':Added, #3: 3	بَيْعُ حِصَّتِهِ
u'بَيْعٌ حُظُوظٌ':Added, #1: 1	بَيْعُ حَظِّ
u'بَيْعٌ حَفْنَةٌ':Added, #1: 1	بَيْعَ حُظُوظِ
u'بَيْعٌ حَفْنَةٌ':Added, #1: 1	بَيْعِ الْحَفْنَةِ
u'بَيْعٌ حَفْنَةٌ':Added, #3: 3	بَيْعُ حَفْنَةٍ
u'بَيْعٌ حَقٌّ':Added, #4: 4	بَيْعُ الْحَفْنَةِ
u'بَيْعٌ حَقٌّ':Added, #10: 10	بَيْعِ حَقِّ
u'بَيْعٌ حَقٌّ':Added, #1: 1	بَيْعَ حَقِّ
u'بَيْعٌ حَقٌّ':Added, #1: 1	بَيْعِ حَقِّهِ
u'بَيْعٌ حَلالٌ':Added, #5: 5	بَيْعُ حَقِّ
u'بَيْعٌ حُلِيٌّ':Added, #1: 1	بَيْعُ الْحَلَالِ
u'بَيْعٌ حُلِيٌّ':Added, #1: 1	بَيْعُ الْحُلِيِّ
u'بَيْعٌ حُلِيٌّ':Added, #1: 1	بَيْعِ الْحُلِيِّ
u'بَيْعٌ حَلِيبٌ':Added, #2: 2	بَيْعَ الْحُلِيِّ
u'بَيْعٌ حِلْيَةٌ':Added, #3: 3	بَيْعُ الْحَلِيبِ
u'بَيْعٌ حِمَارٌ':Added, #1: 1	بَيْعِ حِلْيَةٍ
u'بَيْعٌ حَمَامٌ':Added, #3: 3	بَيْعِ الْحِمَارِ
u'بَيْعٌ حَمَامٌ':Added, #1: 1	بَيْعَ الْحَمَامِ
u'بَيْعٌ حَمَّامٌ':Added, #1: 1	بَيْعُ الْحَمَامِ
u'بَيْعٌ حَمَامٌ':Added, #1: 1	بَيْعُ الْحَمَّامِ
u'بَيْعٌ حَمَّامٌ':Added, #1: 1	بَيْعَ الْحَمَامَاتِ
u'بَيْعٌ حَمَامَةٌ':Added, #3: 3	بَيْعِ الْحَمَّامِ
u'بَيْعٌ حَمْلٌ':Added, #1: 1	بَيْعَ الْحَمَامَاتِ
u'بَيْعٌ حَمْلٌ':Added, #2: 2	بَيْعِ الْحَمْلِ
u'بَيْعٌ حِنْطَةٌ':Added, #9: 9	بَيْعُ الْحَمْلِ
u'بَيْعٌ حِنْطَةٌ':Added, #1: 1	بَيْعَ حِنْطَةٍ
u'بَيْعٌ حِنْطَةٌ':Added, #1: 1	بَيْعِ حِنْطَةٍ
u'بَيْعٌ حِنْطَةٌ':Added, #32: 32	بَيْعُ الْحِنْطَةِ
u'بَيْعٌ حِنْطَةٌ':Added, #3: 3	بَيْعَ الْحِنْطَةِ
u'بَيْعٌ حِنْطَةٌ':Added, #3: 3	بَيْعُ حِنْطَةٍ
u'بَيْعٌ حَوانِيتُ':Added, #5: 5	بَيْعِ الْحِنْطَةِ
u'بَيْعٌ حَيٌّ':Added, #1: 1	بَيْعِ الْحَوَانِيتِ
u'بَيْعٌ حَيٌّ':Added, #2: 2	بَيْعُ الْحَيِّ
u'بَيْعٌ حَيَّاتٌ':Added, #2: 2	بَيْعُ الْحَيَّاتِ
u'بَيْعٌ حَيَّةٌ':Added, #2: 2	بَيْعُ الْحَيَّاتِ
u'بَيْعٌ حَيَوَانٌ':Added, #2: 2	بَيْعُ الْحَيَّاتِ
u'بَيْعٌ حَيَوَانٌ':Added, #15: 15	بَيْعِ الْحَيَوَانِ
u'بَيْعٌ حَيَوَانٌ':Added, #1: 1	بَيْعَ الْحَيَوَانِ
u'بَيْعٌ حَيَوَانٌ':Added, #1: 1	بَيْعِ الْحَيَوَانَاتِ
u'بَيْعٌ حَيَوَانٌ':Added, #1: 1	بَيْعِ حَيَوَانِ
u'بَيْعٌ حَيَوَانٌ':Added, #1: 1	بَيْعُ حَيَوَانِهِ
u'بَيْعٌ حَيَوَانٌ':Added, #2: 2	بَيْعُ حَيَوَانٍ
u'بَيْعٌ خَادِمٌ':Added, #4: 4	بَيْعُ الْحَيَوَانِ
u'بَيْعٌ خاصّ':Added, #1: 1	بَيْعَ خَادِمٍ
u'بَيْعٌ خَالِصٌ':Added, #1: 1	بَيْعُ خَاصٍّ
u'بَيْعٌ خَالِصٌ':Added, #1: 1	بَيْعِ خَالِصِهِ
u'بَيْعٌ خَالِصٌ':Added, #2: 2	بَيْعُ الْخَالِصِ
u'بَيْعٌ خُبْزٌ':Added, #4: 4	بَيْعُ الْخَالِصَةِ
u'بَيْعٌ خُبْزٌ':Added, #1: 1	بَيْعُ خُبْزٍ
u'بَيْعٌ خُبْزٌ':Added, #1: 1	بَيْعُ خُبْزِهِ
u'بَيْعٌ خُبْزٌ':Added, #2: 2	بَيْعَ الْخُبْزِ
u'بَيْعٌ خُبْزٌ':Added, #2: 2	بَيْعِ الْخُبْزِ
u'بَيْعٌ خُبْزٌ':Added, #2: 2	بَيْعُ خُبْزِ
u'بَيْعٌ خدمة':Added, #6: 6	بَيْعُ الْخُبْزِ
u'بَيْعٌ خِدْمَةٌ':Added, #1: 1	بَيْعَ الْخِدْمَةِ
u'بَيْعٌ خُرْء':Added, #1: 1	بَيْعَ الْخِدْمَةِ
u'بَيْعٌ خَرِيطَةٌ':Added, #2: 2	بَيْعُ خُرْءِ
u'بَيْعٌ خَشَبٌ':Added, #1: 1	بَيْعِ الْخَرِيطَةِ
u'بَيْعٌ خَشَبٌ':Added, #1: 1	بَيْعِ الْخَشَبِ
u'بَيْعٌ خَشَبَةٌ':Added, #2: 2	بَيْعُ الْخَشَبِ
u'بَيْعٌ خَمْرٌ':Added, #1: 1	بَيْعِ خَشَبَةٍ
u'بَيْعٌ خَمْرٌ':Added, #15: 15	بَيْعُ الْخَمْرِ
u'بَيْعٌ خَمْرٌ':Added, #17: 17	بَيْعَ الْخَمْرِ
u'بَيْعٌ خَمْرٌ':Added, #1: 1	بَيْعِ خَمْرٍ
u'بَيْعٌ خُمُسٌ':Added, #9: 9	بَيْعِ الْخَمْرِ
u'بَيْعٌ خُمْسٌ':Added, #1: 1	بَيْعِ الْخُمُسِ
u'بَيْعٌ خُمْسٌ':Added, #1: 1	بَيْعَ الْخُمْسِ
u'بَيْعٌ خُمْسٌ':Added, #1: 1	بَيْعِ خُمْسِ
u'بَيْعٌ خُمْسٌ':Added, #1: 1	بَيْعَ خُمْسِهِ
u'بَيْعٌ خُمُورٌ':Added, #1: 1	بَيْعُ خُمْسِهِ
u'بَيْعٌ خُمُورٌ':Added, #1: 1	بَيْعَ الْخُمُورِ
u'بَيْعٌ خُمُورٌ':Added, #1: 1	بَيْعُ الْخُمُورِ
u'بَيْعٌ خيار':Added, #3: 3	بَيْعِ الْخُمُورِ
u'بَيْعٌ خِيَارٌ':Added, #13: 13	بَيْعَ الْخِيَارِ
u'بَيْعٌ خيار':Added, #13: 13	بَيْعَ الْخِيَارِ
u'بَيْعٌ خِيَارٌ':Added, #15: 15	بَيْعِ الْخِيَارِ
u'بَيْعٌ خيار':Added, #15: 15	بَيْعِ الْخِيَارِ
u'بَيْعٌ خِيَارٌ':Added, #3: 3	بَيْعُ خِيَارٍ
u'بَيْعٌ خيار':Added, #3: 3	بَيْعُ خِيَارٍ
u'بَيْعٌ خِيَارٌ':Added, #6: 6	بَيْعِ خِيَارٍ
u'بَيْعٌ دَابَّةٌ':Added, #6: 6	بَيْعِ خِيَارٍ
u'بَيْعٌ دَارٌ':Added, #2: 2	بَيْعِ الدَّابَّةِ
u'بَيْعٌ دَارٌ':Added, #1: 1	بَيْعَ دَارِ
u'بَيْعٌ دَارٌ':Added, #1: 1	بَيْعُ دَارِ
u'بَيْعٌ دَارٌ':Added, #1: 1	بَيْعَ دَارِهِ
u'بَيْعٌ دَارٌ':Added, #2: 2	بَيْعُ دَارٍ
u'بَيْعٌ دَارٌ':Added, #3: 3	بَيْعِ دَارِ
u'بَيْعٌ دَارٌ':Added, #4: 4	بَيْعِ دَارٍ
u'بَيْعٌ دَارٌ':Added, #54: 54	بَيْعِ الدَّارِ
u'بَيْعٌ دَارٌ':Added, #5: 5	بَيْعَ الدَّارِ
u'بَيْعٌ دَارٌ':Added, #5: 5	بَيْعِ دَارِهِ
u'بَيْعٌ دَرَاهِمُ':Added, #9: 9	بَيْعُ الدَّارِ
u'بَيْعٌ دَرَاهِمُ':Added, #2: 2	بَيْعِ الدَّرَاهِمِ
u'بَيْعٌ دَرَاهِمُ':Added, #3: 3	بَيْعُ الدَّرَاهِمِ
u'بَيْعٌ دِرْهَمٌ':Added, #8: 8	بَيْعَ الدَّرَاهِمِ
u'بَيْعٌ دِرْهَم':Added, #2: 2	بَيْعَ الدِّرْهَمِ
u'بَيْعٌ دِرْهَمٌ':Added, #2: 2	بَيْعَ الدِّرْهَمِ
u'بَيْعٌ دِرْهَم':Added, #2: 2	بَيْعَ دِرْهَمٍ
u'بَيْعٌ دِرْهَمٌ':Added, #2: 2	بَيْعَ دِرْهَمٍ
u'بَيْعٌ دِرْهَم':Added, #3: 3	بَيْعُ دِرْهَمَيْنِ
u'بَيْعٌ دِرْهَمٌ':Added, #3: 3	بَيْعُ دِرْهَمَيْنِ
u'بَيْعٌ دِرْهَم':Added, #5: 5	بَيْعِ دِرْهَمٍ
u'بَيْعٌ دِرْهَمٌ':Added, #5: 5	بَيْعِ دِرْهَمٍ
u'بَيْعٌ دِرْهَم':Added, #7: 7	بَيْعِ الدِّرْهَمِ
u'بَيْعٌ دِرْهَمٌ':Added, #7: 7	بَيْعِ الدِّرْهَمِ
u'بَيْعٌ دِرْهَم':Added, #7: 7	بَيْعُ دِرْهَمٍ
u'بَيْعٌ دَقيقٌ':Added, #7: 7	بَيْعُ دِرْهَمٍ
u'بَيْعٌ دَقيقٌ':Added, #1: 1	بَيْع الدَّقِيقِ
u'بَيْعٌ دَقيقٌ':Added, #1: 1	بَيْعُ دَقِيقِهِ
u'بَيْعٌ دَقيقٌ':Added, #2: 2	بَيْعِ الدَّقِيقِ
u'بَيْعٌ دَقيقٌ':Added, #2: 2	بَيْعُ دَقِيقٍ
u'بَيْعٌ دَقيقٌ':Added, #3: 3	بَيْعَ الدَّقِيقِ
u'بَيْعٌ دَنانيرُ':Added, #9: 9	بَيْعُ الدَّقِيقِ
u'بَيْعٌ دَنانيرُ':Added, #1: 1	بَيْعِ الدَّنَانِيرِ
u'بَيْعٌ دُهْنٌ':Added, #3: 3	بَيْعُ الدَّنَانِيرِ
u'بَيْعٌ دُهْنٌ':Added, #1: 1	بَيْعُ الدُّهْنِ
u'بَيْعٌ دُهْنٌ':Added, #2: 2	بَيْعِ دُهْنِ
u'بَيْعٌ دَوَابُّ':Added, #3: 3	بَيْعُ دُهْنٍ
u'بَيْعٌ دُودٌ':Added, #2: 2	بَيْعِ الدَّوَابِّ
u'بَيْعٌ دُودٌ':Added, #1: 1	بَيْعَ دُودِ
u'بَيْعٌ دُودٌ':Added, #1: 1	بَيْعِ دُودِ
u'بَيْعٌ دُودَةٌ':Added, #3: 3	بَيْعُ دُودِ
u'بَيْعٌ دُورٌ':Added, #1: 1	بَيْعِ الدُّودَةِ
u'بَيْعٌ دُورٌ':Added, #1: 1	بَيْعُ دُورِ
u'بَيْعٌ دِيكٌ':Added, #4: 4	بَيْعِ دُورِ
u'بَيْعٌ دَيْنٌ':Added, #1: 1	بَيْعِ الدِّيكِ
u'بَيْعٌ دِينٌ':Added, #17: 17	بَيْعُ دَيْنٍ
u'بَيْعٌ دَيْنٌ':Added, #1: 1	بَيْعِ الدِّينِ
u'بَيْعٌ دَيْنٌ':Added, #1: 1	بَيْع الدَّيْنِ
u'بَيْعٌ دَيْنٌ':Added, #1: 1	بَيْعُ دَيْنِ
u'بَيْعٌ دَيْنٌ':Added, #24: 24	بَيْعُ الدَّيْنِ
u'بَيْعٌ دَيْنٌ':Added, #25: 25	بَيْعِ الدَّيْنِ
u'بَيْعٌ دَيْنٌ':Added, #2: 2	بَيْعِ دَيْنِ
u'بَيْعٌ دَيْنٌ':Added, #5: 5	بَيْعَ دَيْنٍ
u'بَيْعٌ دَيْنٌ':Added, #6: 6	بَيْعِ دَيْنٍ
u'بَيْعٌ دِينارٌ':Added, #7: 7	بَيْعَ الدَّيْنِ
u'بَيْعٌ دِينارٌ':Added, #1: 1	بَيْعِ الدِّينَارِ
u'بَيْعٌ ذَبائِحُ':Added, #1: 1	بَيْعَ دِينَارٍ
u'بَيْعٌ ذَبيحٌ':Added, #1: 1	بَيْعُ ذَبَائِحِ
u'بَيْعٌ ذَبيحَةٌ':Added, #1: 1	بَيْعُ ذَبِيحَةِ
u'بَيْعٌ ذِراعٌ':Added, #1: 1	بَيْعُ ذَبِيحَةِ
u'بَيْعٌ ذِراعٌ':Added, #1: 1	بَيْعِ ذِرَاعٍ
u'بَيْعٌ ذُرَةٌ':Added, #5: 5	بَيْعُ ذِرَاعٍ
u'بَيْعٌ ذِمَّةٌ':Added, #1: 1	بَيْعُ الذُّرَةِ
u'بَيْعٌ ذَهَبٌ':Added, #1: 1	بَيْعَ ذِمَّةٍ
u'بَيْعٌ ذَهَبٌ':Added, #1: 1	بَيْعِ الذّهَبِ
u'بَيْعٌ ذَهَبٌ':Added, #1: 1	بَيْعُ ذَهَبٍ
u'بَيْعٌ ذَهَبٌ':Added, #9: 9	بَيْعُ الذَّهَبِ
u'بَيْعٌ ذِئْبٌ':Added, #9: 9	بَيْعِ الذَّهَبِ
u'بَيْعٌ رَاجِعٌ':Added, #1: 1	بَيْعُ الذِّئْبِ
u'بَيْعٌ رَاهِنٌ':Added, #1: 1	بَيْعَ الرَّاجِعِ
u'بَيْعٌ رَاهِنٌ':Added, #2: 2	بَيْعُ الرَّاهِنِ
u'بَيْعٌ رَبُّ':Added, #3: 3	بَيْعَ الرَّاهِنِ
u'بَيْعٌ رَبُّ':Added, #1: 1	بَيْعُ رَبِّهِ
u'بَيْعٌ رِباعٌ':Added, #2: 2	بَيْعِ رَبِّ
u'بَيْعٌ رِبَاعٌ':Added, #2: 2	بَيْعُ رِبَاعِ
u'بَيْعٌ رَبْعٌ':Added, #2: 2	بَيْعُ رِبَاعِ
u'بَيْعٌ رَجُلٌ':Added, #1: 1	بَيْعِ رَبْعِ
u'بَيْعٌ رَجُلٌ':Added, #1: 1	بَيْعَ الرَّجُلِ
u'بَيْعٌ رَجُلٌ':Added, #1: 1	بَيْعِ الرَّجُلِ
u'بَيْعٌ رِطابٌ':Added, #2: 2	بَيْعُ الرَّجُلِ
u'بَيْعٌ رِطابٌ':Added, #1: 1	بَيْعَ الرِّطَابِ
u'بَيْعٌ رِطَابٌ':Added, #1: 1	بَيْعُ الرِّطَابِ
u'بَيْعٌ رِطَابٌ':Added, #1: 1	بَيْعَ الرِّطَابِ
u'بَيْعٌ رُطَبٌ':Added, #1: 1	بَيْعُ الرِّطَابِ
u'بَيْعٌ رُطَبٌ':Added, #17: 17	بَيْعُ الرُّطَبِ
u'بَيْعٌ رَطْبٌ':Added, #20: 20	بَيْعِ الرُّطَبِ
u'بَيْعٌ رُطَبٌ':Added, #2: 2	بَيْعِ الرَّطْبِ
u'بَيْعٌ رُطَبٌ':Added, #2: 2	بَيْعَ الرُّطَبِ
u'بَيْعٌ رَطْبَةٌ':Added, #2: 2	بَيْعُ رُطَبٍ
u'بَيْعٌ رَطْبَةٌ':Added, #1: 1	بَيْعُ الرَّطْبَةِ
u'بَيْعٌ رَطْبَةٌ':Added, #1: 1	بَيْعُ رَطْبَةٍ
u'بَيْعٌ رِطْلٌ':Added, #2: 2	بَيْعِ الرَّطْبَةِ
u'بَيْعٌ رِطْلٌ':Added, #1: 1	بَيْعِ رِطْلِ
u'بَيْعٌ رَغْبَةٌ':Added, #3: 3	بَيْعُ رِطْلِ
u'بَيْعٌ رَغْبَةٌ':Added, #10: 10	بَيْعَ رَغْبَةٍ
u'بَيْعٌ رَقَبَةٌ':Added, #2: 2	بَيْعُ رَغْبَةٍ
u'بَيْعٌ رَقَبَةٌ':Added, #1: 1	بَيْعَ الرَّقَبَةِ
u'بَيْعٌ رَقَبَةٌ':Added, #1: 1	بَيْعِ الرَّقَبَةِ
u'بَيْعٌ رَقَبَةٌ':Added, #1: 1	بَيْعَ رَقَبَةِ
u'بَيْعٌ رَقَبَةٌ':Added, #1: 1	بَيْعِ رَقَبَةِ
u'بَيْعٌ رَقَبَةٌ':Added, #2: 2	بَيْعِ رَقَبَتِهِ
u'بَيْعٌ رَقَبَةٌ':Added, #3: 3	بَيْعَ رَقَبَتِهِ
u'بَيْعٌ رُقْعَةٌ':Added, #4: 4	بَيْعُ رَقَبَةِ
u'بَيْعٌ رَقيقٌ':Added, #1: 1	بَيْعُ رُقْعَةٍ
u'بَيْعٌ رَقيق':Added, #1: 1	بَيْعِ الرَّقِيقِ
u'بَيْعٌ رَقيقٌ':Added, #1: 1	بَيْعِ الرَّقِيقِ
u'بَيْعٌ رَقيقٌ':Added, #1: 1	بَيْعُ رَقِيقٍ
u'بَيْعٌ رَقيق':Added, #1: 1	بَيْعِ رَقِيقٍ
u'بَيْعٌ رَقيق':Added, #1: 1	بَيْعُ رَقِيقٍ
u'بَيْعٌ رَقيقٌ':Added, #1: 1	بَيْعِ رَقِيقٍ
u'بَيْعٌ رَقيق':Added, #3: 3	بَيْعُ الرَّقِيقِ
u'بَيْعٌ رَهْنٌ':Added, #3: 3	بَيْعُ الرَّقِيقِ
u'بَيْعٌ رَهْنٌ':Added, #18: 18	بَيْعِ الرَّهْنِ
u'بَيْعٌ رَهْنٌ':Added, #3: 3	بَيْعَ الرَّهْنِ
u'بَيْعٌ رِيشٌ':Added, #3: 3	بَيْعُ الرَّهْنِ
u'بَيْعٌ زائِدٌ':Added, #1: 1	بَيْعُ رِيشِ
u'بَيْعٌ زُبْدٌ':Added, #2: 2	بَيْعِ الزَّائِدِ
u'بَيْعٌ زَبيبٌ':Added, #2: 2	بَيْعُ الزُّبْدِ
u'بَيْعٌ زَبيبٌ':Added, #1: 1	بَيْعُ الزَّبِيبِ
u'بَيْعٌ زُجاجَةٌ':Added, #3: 3	بَيْعِ الزَّبِيبِ
u'بَيْعٌ زَرْعٌ':Added, #1: 1	بَيْعِ زُجَاجَةٍ
u'بَيْعٌ زَرْعٌ':Added, #11: 11	بَيْعُ الزَّرْعِ
u'بَيْعٌ زَرْعٌ':Added, #1: 1	بَيْعَ الزَّرْعِ
u'بَيْعٌ زَرْعٌ':Added, #1: 1	بَيْعُ زَرْعِهِ
u'بَيْعٌ زَرْعٌ':Added, #3: 3	بَيْعُ زَرْعٍ
u'بَيْعٌ زُنَّارٌ':Added, #7: 7	بَيْعِ الزَّرْعِ
u'بَيْعٌ زَوائِدُ':Added, #1: 1	بَيْعُ الزُّنَّارِ
u'بَيْعٌ زَوْجٌ':Added, #1: 1	بَيْعُ زَوَائِدِ
u'بَيْعٌ زَوْجٌ':Added, #1: 1	بَيْعُ الزَّوْجَيْنِ
u'بَيْعٌ زَوْجَةٌ':Added, #2: 2	بَيْعِ الزَّوْجِ
u'بَيْعٌ زَوْجَةٌ':Added, #1: 1	بَيْعِ الزَّوْجَةِ
u'بَيْعٌ زِيادَةٌ':Added, #1: 1	بَيْعِ زَوْجَتِهِ
u'بَيْعٌ زِيادَةٌ':Added, #1: 1	بَيْعَ الزِّيَادَةِ
u'بَيْعٌ زِيادَةٌ':Added, #1: 1	بَيْعُ الزِّيَادَةِ
u'بَيْعٌ زَيْتٌ':Added, #3: 3	بَيْعِ الزِّيَادَةِ
u'بَيْعٌ زَيْتٌ':Added, #2: 2	بَيْعُ الزَّيْتِ
u'بَيْعٌ زَيْتونٌ':Added, #2: 2	بَيْعِ الزَّيْتِ
u'بَيْعٌ زَيْتونٌ':Added, #1: 1	بَيْعُ زَيْتُونٍ
u'بَيْعٌ زَيْتونٌ':Added, #2: 2	بَيْعِ الزَّيْتُونِ
u'بَيْعٌ زَيْدٌ':Added, #4: 4	بَيْعُ الزَّيْتُونِ
u'بَيْعٌ سَابِقٌ':Added, #1: 1	بَيْعُ زَيْدٍ
u'بَيْعٌ سَاعَةٌ':Added, #2: 2	بَيْعٍ سَابِقٍ
u'بَيْعٌ سَالِمٌ':Added, #2: 2	بَيْعِ سَاعَةٍ
u'بَيْعٌ سَائِرٌ':Added, #1: 1	بَيْعِ سَالِمٍ
u'بَيْعٌ سَائِمَةٌ':Added, #1: 1	بَيْعُ سَائِرِ
u'بَيْعٌ سِباعٌ':Added, #1: 1	بَيْعُ السَّائِمَةِ
u'بَيْعٌ سَرَطَانٌ':Added, #1: 1	بَيْعُ السِّبَاعِ
u'بَيْعٌ سِرْقِين':Added, #2: 2	بَيْعِ السَّرَطَانِ
u'بَيْعٌ سِرْقِين':Added, #1: 1	بَيْعَ السِّرْقِينِ
u'بَيْعٌ سِرْقِين':Added, #1: 1	بَيْعُ سِرْقِينِ
u'بَيْعٌ سَرِيٌّ':Added, #3: 3	بَيْعُ السِّرْقِينِ
u'بَيْعٌ سَرِيَّةٌ':Added, #1: 1	بَيْعِ السَّرِيَّةِ
u'بَيْعٌ سُفْلٌ':Added, #1: 1	بَيْعِ السَّرِيَّةِ
u'بَيْعٌ سَفِيهٌ':Added, #1: 1	بَيْعَ السُّفْلِ
u'بَيْعٌ سَقْفٌ':Added, #1: 1	بَيْعِ السَّفِيهِ
u'بَيْعٌ سَكْرَان':Added, #1: 1	بَيْعُ سَقْفِ
u'بَيْعٌ سِلاَحٌ':Added, #1: 1	بَيْعُ السَّكْرَانِ
u'بَيْعٌ سِلاَحٌ':Added, #12: 12	بَيْعِ السِّلَاحِ
u'بَيْعٌ سِلاَحٌ':Added, #1: 1	بَيْعَ السِّلاَحِ
u'بَيْعٌ سِلاَحٌ':Added, #2: 2	بَيْعِ السِّلاَحِ
u'بَيْعٌ سِلاَحٌ':Added, #2: 2	بَيْعِ سِلَاحٍ
u'بَيْعٌ سُلْطَانٌ':Added, #9: 9	بَيْعُ السِّلَاحِ
u'بَيْعٌ سُلْطَانٌ':Added, #1: 1	بَيْعُ سُلْطَانٍ
u'بَيْعٌ سُلْطَانٌ':Added, #2: 2	بَيْعُ السُّلْطَانِ
u'بَيْعٌ سِلَعٌ':Added, #2: 2	بَيْعِ السُّلْطَانِ
u'بَيْعٌ سِلَعٌ':Added, #1: 1	بَيْعَ السِّلَعِ
u'بَيْعٌ سِلَعٌ':Added, #1: 1	بَيْعُ السِّلَعِ
u'بَيْعٌ سِلَعٌ':Added, #1: 1	بَيْعِ سِلَعِ
u'بَيْعٌ سِلَعٌ':Added, #2: 2	بَيْعِ السِّلَعِ
u'بَيْعٌ سِلْعَةٌ':Added, #2: 2	بَيْعِ سِلَعٍ
u'بَيْعٌ سِلْعَةٌ':Added, #1: 1	بَيْعَ سِلْعَةٍ
u'بَيْعٌ سِلْعَةٌ':Added, #1: 1	بَيْعُ سِلْعَةٍ
u'بَيْعٌ سِلْعَةٌ':Added, #1: 1	بَيْعَ سِلْعَتِهِ
u'بَيْعٌ سِلْعَةٌ':Added, #1: 1	بَيْعِ سِلْعَتِهِ
u'بَيْعٌ سِلْعَةٌ':Added, #2: 2	بَيْعُ السِّلْعَةِ
u'بَيْعٌ سَلَفٌ':Added, #5: 5	بَيْعِ سِلْعَةٍ
u'بَيْعٌ سَلَمٌ':Added, #1: 1	بَيْعِ السَّلَفِ
u'بَيْعٌ سَلَمٌ':Added, #1: 1	بَيْعُ السَّلَمِ
u'بَيْعٌ سِمْسَارٌ':Added, #1: 1	بَيْعِ السَّلَمِ
u'بَيْعٌ سِمْسِمٌ':Added, #1: 1	بَيْعِ السِّمْسَارِ
u'بَيْعٌ سِمْسِمٌ':Added, #2: 2	بَيْعُ السِّمْسِمِ
u'بَيْعٌ سَمَكٌ':Added, #3: 3	بَيْعِ السِّمْسِمِ
u'بَيْعٌ سَمَكٌ':Added, #10: 10	بَيْعُ السَّمَكِ
u'بَيْعٌ سَمَكٌ':Added, #1: 1	بَيْعَ السَّمَكِ
u'بَيْعٌ سَمَكٌ':Added, #1: 1	بَيْعُ سَمَكٍ
u'بَيْعٌ سَمْنٌ':Added, #4: 4	بَيْعِ السَّمَكِ
u'بَيْعٌ سَمْنٌ':Added, #2: 2	بَيْعُ السَّمْنِ
u'بَيْعٌ سَمْنٌ':Added, #2: 2	بَيْعُ سَمْنِ
u'بَيْعٌ سُنْبُلٌ':Added, #5: 5	بَيْعِ السَّمْنِ
u'بَيْعٌ سُنْبُلٌ':Added, #1: 1	بَيْعَ السُّنْبُلِ
u'بَيْعٌ سُنْبُلٌ':Added, #1: 1	بَيْعِ السُّنْبُلَةِ
u'بَيْعٌ سِنَّوْرٌ':Added, #5: 5	بَيْعِ السُّنْبُلِ
u'بَيْعٌ سهام':Added, #1: 1	بَيْعُ السِّنَّوْرِ
u'بَيْعٌ سِهَامٌ':Added, #24: 24	بَيْعِ السِّهَامِ
u'بَيْعٌ سَهْمٌ':Added, #24: 24	بَيْعِ السِّهَامِ
u'بَيْعٌ سَهْمٌ':Added, #1: 1	بَيْعُ سَهْمٍ
u'بَيْعٌ سَوادٌ':Added, #1: 1	بَيْعِ سَهْمٍ
u'بَيْعٌ سَوَاقِطُ':Added, #1: 1	بَيْعَ السَّوَادِ
u'بَيْعٌ سَوِيق':Added, #1: 1	بَيْعُ سَوَاقِطِ
u'بَيْعٌ سَوِيق':Added, #1: 1	بَيْعَ السَّوِيقِ
u'بَيْعٌ سَيِّدٌ':Added, #2: 2	بَيْعُ السَّوِيقِ
u'بَيْعٌ سَيِّدٌ':Added, #1: 1	بَيْعُ السَّيِّدِ
u'بَيْعٌ سَيْفٌ':Added, #2: 2	بَيْعَ السَّيِّدِ
u'بَيْعٌ سُيوفٌ':Added, #1: 1	بَيْعَ السَّيْفِ
u'بَيْعٌ شَاةٌ':Added, #1: 1	بَيْعِ السُّيُوفِ
u'بَيْعٌ شَاةٌ':Added, #1: 1	بَيْعَ الشَّاةِ
u'بَيْعٌ شَاةٌ':Added, #1: 1	بَيْعِ شَاةٍ
u'بَيْعٌ شَاةٌ':Added, #2: 2	بَيْعَ شَاةٍ
u'بَيْعٌ شَاةٌ':Added, #3: 3	بَيْعِ الشَّاةِ
u'بَيْعٌ شاش':Added, #4: 4	بَيْعُ شَاةٍ
u'بَيْعٌ شَائِعٌ':Added, #1: 1	بَيْعِ الشَّاشِ
u'بَيْعٌ شَتْوِيُّ':Added, #1: 1	بَيْعَ الشَّائِعِ
u'بَيْعٌ شَجَرٌ':Added, #1: 1	بَيْعُ الشَّتْوِيِّ
u'بَيْعٌ شَجَرٌ':Added, #1: 1	بَيْعِ شَجَرِ
u'بَيْعٌ شَجَرٌ':Added, #2: 2	بَيْعُ الشَّجَرِ
u'بَيْعٌ شَجَرَةٌ':Added, #7: 7	بَيْعِ الشَّجَرِ
u'بَيْعٌ شَجَرَةٌ':Added, #1: 1	بَيْعُ الشَّجَرَةِ
u'بَيْعٌ شَجَرَةٌ':Added, #1: 1	بَيْعِ شَجَرَةٍ
u'بَيْعٌ شَحْمٌ':Added, #4: 4	بَيْعِ الشَّجَرَةِ
u'بَيْعٌ شِرَاءٌ':Added, #2: 2	بَيْعِ الشَّحْمِ
u'بَيْعٌ شرب':Added, #1: 1	بَيْعُ شِرَاءٍ
u'بَيْعٌ شِرْبٌ':Added, #2: 2	بَيْعَ الشِّرْبِ
u'بَيْعٌ شرب':Added, #2: 2	بَيْعَ الشِّرْبِ
u'بَيْعٌ شِرْبٌ':Added, #4: 4	بَيْعِ الشِّرْبِ
u'بَيْعٌ شرب':Added, #4: 4	بَيْعِ الشِّرْبِ
u'بَيْعٌ شِرْبٌ':Added, #5: 5	بَيْعُ الشِّرْبِ
u'بَيْعٌ شَرْطٌ':Added, #5: 5	بَيْعُ الشِّرْبِ
u'بَيْعٌ شُرُوطٌ':Added, #3: 3	بَيْعُ شَرْطٍ
u'بَيْعٌ شَرِيكٌ':Added, #1: 1	بَيْعِ الشُّرُوطِ
u'بَيْعٌ شَرِيكٌ':Added, #1: 1	بَيْعُ شَرِيكِهِ
u'بَيْعٌ شِطْرَنْجٌ':Added, #2: 2	بَيْعِ الشَّرِيكِ
u'بَيْعٌ شَعْرٌ':Added, #1: 1	بَيْعُ الشِّطْرَنْجِ
u'بَيْعٌ شَعْرٌ':Added, #1: 1	بَيْعَ شَعْرِ
u'بَيْعٌ شُعُورٌ':Added, #3: 3	بَيْعُ شَعْرِ
u'بَيْعٌ شفعة':Added, #4: 4	بَيْعُ شُعُورِ
u'بَيْعٌ شُفْعَةٌ':Added, #1: 1	بَيْعُ الشُّفْعَةِ
u'بَيْعٌ شَفِيعٌ':Added, #1: 1	بَيْعُ الشُّفْعَةِ
u'بَيْعٌ شَيْءٌ':Added, #1: 1	بَيْعُ الشَّفِيعِ
u'بَيْعٌ شَيْءٌ':Added, #18: 18	بَيْعِ شَيْءٍ
u'بَيْعٌ شَيْءٌ':Added, #34: 34	بَيْعُ شَيْءٍ
u'بَيْعٌ شَيْءٌ':Added, #3: 3	بَيْعِ الشَّيْءِ
u'بَيْعٌ شَيْءٌ':Added, #4: 4	بَيْعَ شَيْءٍ
u'بَيْعٌ شِيَاهٌ':Added, #5: 5	بَيْعُ الشَّيْءِ
u'بَيْعٌ شَيْرَجٌ':Added, #1: 1	بَيْعِ الشِّيَاهِ
u'بَيْعٌ صَابُونٌ':Added, #1: 1	بَيْعِ الشَّيْرَجِ
u'بَيْعٌ صَاحِبٌ':Added, #1: 1	بَيْعُ الصَّابُونِ
u'بَيْعٌ صَاحِبٌ':Added, #2: 2	بَيْعَ صَاحِبِهِ
u'بَيْعٌ صَاعٌ':Added, #2: 2	بَيْعِ صَاحِبِهِ
u'بَيْعٌ صَاعٌ':Added, #2: 2	بَيْعَ صَاعٍ
u'بَيْعٌ صَاعٌ':Added, #2: 2	بَيْعُ صَاعٍ
u'بَيْعٌ صَاعٌ':Added, #2: 2	بَيْعِ صَاعَيْنِ
u'بَيْعٌ صبر':Added, #6: 6	بَيْعِ صَاعٍ
u'بَيْعٌ صبرة':Added, #1: 1	بَيْعِ الصُّبَرِ
u'بَيْعٌ صُبْرَةٌ':Added, #15: 15	بَيْعِ الصُّبْرَةِ
u'بَيْعٌ صبرة':Added, #15: 15	بَيْعِ الصُّبْرَةِ
u'بَيْعٌ صبرة':Added, #1: 1	بَيْعِ الصُّبَرَةِ
u'بَيْعٌ صبرة':Added, #1: 1	بَيْعُ صُبْرَةٍ
u'بَيْعٌ صُبْرَةٌ':Added, #1: 1	بَيْعِ صُبْرَةٍ
u'بَيْعٌ صُبْرَةٌ':Added, #1: 1	بَيْعُ صُبْرَةٍ
u'بَيْعٌ صبرة':Added, #1: 1	بَيْعِ صُبْرَةٍ
u'بَيْعٌ صُبْرَةٌ':Added, #2: 2	بَيْعُ الصُّبْرَةِ
u'بَيْعٌ صبرة':Added, #2: 2	بَيْعُ الصُّبْرَةِ
u'بَيْعٌ صُبْرَةٌ':Added, #2: 2	بَيْعِ صُبْرَةِ
u'بَيْعٌ صَبْغٌ':Added, #2: 2	بَيْعِ صُبْرَةِ
u'بَيْعٌ صَبِيٌّ':Added, #1: 1	بَيْعَ الصَّبْغِ
u'بَيْعٌ صَبِيٌّ':Added, #1: 1	بَيْعِ الصَّبِيِّ
u'بَيْعٌ صَبِيٌّ':Added, #1: 1	بَيْعُ صَبِيٍّ
u'بَيْعٌ صَدَقَةٌ':Added, #6: 6	بَيْعُ الصَّبِيِّ
u'بَيْعٌ صَدَقَةٌ':Added, #1: 1	بَيْعُ الصَّدَقَاتِ
u'بَيْعٌ صدقة':Added, #1: 1	بَيْعِ الصَّدَقَاتِ
u'بَيْعٌ صَدَقَةٌ':Added, #2: 2	بَيْعِ الصَّدَقَةِ
u'بَيْعٌ صَرْفٌ':Added, #2: 2	بَيْعِ الصَّدَقَةِ
u'بَيْعٌ صَرْف':Added, #2: 2	بَيْعُ الصَّرْفِ
u'بَيْعٌ صغار':Added, #2: 2	بَيْعُ الصَّرْفِ
u'بَيْعٌ صِفَةٌ':Added, #1: 1	بَيْعُ صِغَارِ
u'بَيْعٌ صَفْقَةٌ':Added, #1: 1	بَيْعَ الصِّفَةِ
u'بَيْعٌ صَكٌّ':Added, #1: 1	بَيْعَ الصَّفْقَةِ
u'بَيْعٌ صَكٌّ':Added, #1: 1	بَيْعُ الصَّكِّ
u'بَيْعٌ صُكُوكٌ':Added, #2: 2	بَيْعِ الصَّكِّ
u'بَيْعٌ صِنْفٌ':Added, #1: 1	بَيْعَ الصُّكُوكِ
u'بَيْعٌ صِنْفٌ':Added, #1: 1	بَيْعُ صِنْفٍ
u'بَيْعٌ صُوفٌ':Added, #1: 1	بَيْعِ صِنْفٍ
u'بَيْعٌ صُوفٌ':Added, #1: 1	بَيْعُ صُوفٍ
u'بَيْعٌ صَيْدٌ':Added, #6: 6	بَيْعِ الصُّوفِ
u'بَيْعٌ صَيْدٌ':Added, #1: 1	بَيْعِ الصَّيْدِ
u'بَيْعٌ صَيْدٌ':Added, #1: 1	بَيْعَ صَيْدِ
u'بَيْعٌ صَيْدٌ':Added, #1: 1	بَيْعِ صَيْدِ
u'بَيْعٌ صَيْدٌ':Added, #4: 4	بَيْعُ صَيْدٍ
u'بَيْعٌ ضراب':Added, #5: 5	بَيْعُ صَيْدِ
u'بَيْعٌ ضراب':Added, #1: 1	بَيْعُ ضِرَابِهِ
u'بَيْعٌ ضَرُورَةٌ':Added, #2: 2	بَيْعِ ضِرَابِ
u'بَيْعٌ ضَمَانٌ':Added, #1: 1	بَيْعِ الضَّرُورَةِ
u'بَيْعٌ ضَيْعَةٌ':Added, #1: 1	بَيْعُ الضَّمَانِ
u'بَيْعٌ ضَيْعَةٌ':Added, #1: 1	بَيْعَ ضَيْعَةٍ
u'بَيْعٌ طَائِرٌ':Added, #1: 1	بَيْعُ ضَيْعَةٍ
u'بَيْعٌ طَرِيقٌ':Added, #1: 1	بَيْعُ طَائِرٍ
u'بَيْعٌ طَرِيقٌ':Added, #1: 1	بَيْعَ الطَّرِيقِ
u'بَيْعٌ طَرِيقٌ':Added, #1: 1	بَيْعِ الطَّرِيقِ
u'بَيْعٌ طَرِيقٌ':Added, #1: 1	بَيْعُ طَرِيقٍ
u'بَيْعٌ طَرِيقٌ':Added, #1: 1	بَيْعِ طَرِيقٍ
u'بَيْعٌ طعام':Added, #3: 3	بَيْعُ الطَّرِيقِ
u'بَيْعٌ طَعَامٌ':Added, #19: 19	بَيْعُ الطَّعَامِ
u'بَيْعٌ طعام':Added, #19: 19	بَيْعُ الطَّعَامِ
u'بَيْعٌ طَعَامٌ':Added, #1: 1	بَيْعِ طَعَامِ
u'بَيْعٌ طعام':Added, #1: 1	بَيْعِ طَعَامِ
u'بَيْعٌ طَعَامٌ':Added, #2: 2	بَيْعَ الطَّعَامِ
u'بَيْعٌ طعام':Added, #2: 2	بَيْعَ الطَّعَامِ
u'بَيْعٌ طَعَامٌ':Added, #2: 2	بَيْعِ طَعَامٍ
u'بَيْعٌ طعام':Added, #2: 2	بَيْعِ طَعَامٍ
u'بَيْعٌ طَعَامٌ':Added, #4: 4	بَيْعُ طَعَامِ
u'بَيْعٌ طعام':Added, #4: 4	بَيْعُ طَعَامِ
u'بَيْعٌ طَعَامٌ':Added, #57: 57	بَيْعِ الطَّعَامِ
u'بَيْعٌ طعام':Added, #57: 57	بَيْعِ الطَّعَامِ
u'بَيْعٌ طَعَامٌ':Added, #5: 5	بَيْعُ طَعَامٍ
u'بَيْعٌ طِفْلٌ':Added, #5: 5	بَيْعُ طَعَامٍ
u'بَيْعٌ طَلْعٌ':Added, #1: 1	بَيْعَ الطِّفْلِ
u'بَيْعٌ طَلْعٌ':Added, #1: 1	بَيْعِ الطَّلْعِ
u'بَيْعٌ طَيْرٌ':Added, #1: 1	بَيْعِ طَلْعٍ
u'بَيْعٌ طَيْرٌ':Added, #2: 2	بَيْعَ الطَّيْرِ
u'بَيْعٌ طَيْرٌ':Added, #5: 5	بَيْعُ طَيْرٍ
u'بَيْعٌ طِينٌ':Added, #7: 7	بَيْعُ الطَّيْرِ
u'بَيْعٌ ظَرْفٌ':Added, #1: 1	بَيْعِ الطِّينِ
u'بَيْعٌ ظَرْفٌ':Added, #1: 1	بَيْعَ الظَّرْفِ
u'بَيْعٌ عَبْدٌ':Added, #1: 1	بَيْعِ الظَّرْفِ
u'بَيْعٌ عَبْدٌ':Added, #12: 12	بَيْعِ عَبْدِهِ
u'بَيْعٌ عَبْدٌ':Added, #18: 18	بَيْعَ الْعَبْدِ
u'بَيْعٌ عَبْدٌ':Added, #1: 1	بَيْعَ عَبْدِ
u'بَيْعٌ عَبْدٌ':Added, #1: 1	بَيْعُ عَبْدِ
u'بَيْعٌ عَبْدٌ':Added, #1: 1	بَيْعَ عَبْدِهِ
u'بَيْعٌ عَبْدٌ':Added, #25: 25	بَيْعُ الْعَبْدِ
u'بَيْعٌ عَبْدٌ':Added, #29: 29	بَيْعِ الْعَبْدِ
u'بَيْعٌ عَبْدٌ':Added, #2: 2	بَيْعَ عَبْدٍ
u'بَيْعٌ عَبْدٌ':Added, #2: 2	بَيْعِ عَبْدِ
u'بَيْعٌ عَبْدٌ':Added, #2: 2	بَيْعُ عَبْدِهِ
u'بَيْعٌ عَبْدٌ':Added, #5: 5	بَيْعِ عَبْدٍ
u'بَيْعٌ عَبِيدٌ':Added, #8: 8	بَيْعُ عَبْدٍ
u'بَيْعٌ عَبِيدٌ':Added, #1: 1	بَيْعِ عَبِيدٍ
u'بَيْعٌ عَدَاءٌ':Added, #2: 2	بَيْعُ عَبِيدِهِ
u'بَيْعٌ عِدَّةٌ':Added, #1: 1	بَيْعُ عَدَاءٍ
u'بَيْعٌ عِدَّةٌ':Added, #1: 1	بَيْعُ الْعِدَّةِ
u'بَيْعٌ عِدَّةٌ':Added, #1: 1	بَيْعِ الْعِدَّةِ
u'بَيْعٌ عَدَدٌ':Added, #1: 1	بَيْعَ عِدَّةٍ
u'بَيْعٌ عَدَدِيٌّ':Added, #1: 1	بَيْعِ عَدَدِ
u'بَيْعٌ عَدْلٌ':Added, #1: 1	بَيْعُ الْعَدَدِيِّ
u'بَيْعٌ عَدْلٌ':Added, #1: 1	بَيْعَ الْعَدْلِ
u'بَيْعٌ عَدْلٌ':Added, #1: 1	بَيْعُ الْعَدْلِ
u'بَيْعٌ عَدْلٌ':Added, #1: 1	بَيْعِ عَدْلٍ
u'بَيْعٌ عَذِرَةٌ':Added, #2: 2	بَيْعِ الْعَدْلِ
u'بَيْعٌ عَذِرَةٌ':Added, #1: 1	بَيْعَ الْعَذِرَةِ
u'بَيْعٌ عَذِرَةٌ':Added, #3: 3	بَيْعِ الْعَذِرَةِ
u'بَيْعٌ عُرْبَانٌ':Added, #5: 5	بَيْعُ الْعَذِرَةِ
u'بَيْعٌ عُرْبَانٌ':Added, #1: 1	بَيْعُ الْعُرْبَانِ
u'بَيْعٌ عُرْبُونٌ':Added, #6: 6	بَيْعِ الْعُرْبَانِ
u'بَيْعٌ عُرْبُونٌ':Added, #3: 3	بَيْعَ الْعُرْبُونِ
u'بَيْعٌ عَرَضٌ':Added, #3: 3	بَيْعِ الْعُرْبُونِ
u'بَيْعٌ عَرْضٌ':Added, #1: 1	بَيْعِ الْعَرَضِ
u'بَيْعٌ عَرْضٌ':Added, #1: 1	بَيْعُ عَرْضٍ
u'بَيْعٌ عَرْضٌ':Added, #3: 3	بَيْعُ عَرْضِهِ
u'بَيْعٌ عَرْضٌ':Added, #4: 4	بَيْعِ الْعَرْضِ
u'بَيْعٌ عَرُوضٌ':Added, #5: 5	بَيْعُ عَرْضِ
u'بَيْعٌ عُرُوضٌ':Added, #1: 1	بَيْعَ الْعَرُوضِ
u'بَيْعٌ عُرُوضٌ':Added, #1: 1	بَيْعَ عُرُوضِهِ
u'بَيْعٌ عُرُوضٌ':Added, #1: 1	بَيْعُ عُرُوضِهِ
u'بَيْعٌ عُرُوضٌ':Added, #3: 3	بَيْعِ الْعُرُوضِ
u'بَيْعٌ عُرُوضٌ':Added, #4: 4	بَيْعُ الْعُرُوضِ
u'بَيْعٌ عَسَلٌ':Added, #6: 6	بَيْعَ الْعُرُوضِ
u'بَيْعٌ عَشْرٌ':Added, #1: 1	بَيْعِ الْعَسَلِ
u'بَيْعٌ عَشْرٌ':Added, #1: 1	بَيْعُ عَشْرِ
u'بَيْعٌ عَصَافِيرُ':Added, #1: 1	بَيْعُ عَشْرَةٍ
u'بَيْعٌ عَصِيرٌ':Added, #1: 1	بَيْعُ الْعَصَافِيرِ
u'بَيْعٌ عَصِيرٌ':Added, #1: 1	بَيْعَ الْعَصِيرِ
u'بَيْعٌ عَصِيرٌ':Added, #1: 1	بَيْعِ عَصِيرٍ
u'بَيْعٌ عَصِيرٌ':Added, #3: 3	بَيْعُ الْعَصِيرِ
u'بَيْعٌ عَطَاءٌ':Added, #5: 5	بَيْعِ الْعَصِيرِ
u'بَيْعٌ عظام':Added, #3: 3	بَيْعُ الْعَطَاءِ
u'بَيْعٌ عِظَامٌ':Added, #1: 1	بَيْعَ عِظَامِ
u'بَيْعٌ عَظْمٌ':Added, #1: 1	بَيْعَ عِظَامِ
u'بَيْعٌ عَفَنٌ':Added, #1: 1	بَيْعُ عَظْمِهِ
u'بَيْعٌ عَقَارٌ':Added, #1: 1	بَيْعَ الْعَفَنِ
u'بَيْعٌ عَقَارٌ':Added, #10: 10	بَيْعِ الْعَقَارِ
u'بَيْعٌ عَقَارٌ':Added, #11: 11	بَيْعَ الْعَقَارِ
u'بَيْعٌ عَقَارٌ':Added, #1: 1	بَيْعَ عَقَارِ
u'بَيْعٌ عَقَارٌ':Added, #1: 1	بَيْعِ عَقَارِهِ
u'بَيْعٌ عَقَارٌ':Added, #21: 21	بَيْعُ الْعَقَارِ
u'بَيْعٌ عَقَارٌ':Added, #2: 2	بَيْعُ عَقَارٍ
u'بَيْعٌ عَقَارٌ':Added, #5: 5	بَيْعِ عَقَارٍ
u'بَيْعٌ عَقَارٌ':Added, #7: 7	بَيْعُ عَقَارِ
u'بَيْعٌ عَقَارٌ':Added, #7: 7	بَيْعِ عَقَارِ
u'بَيْعٌ عَقُورٌ':Added, #8: 8	بَيْعُ عَقَارِهِ
u'بَيْعٌ عَقُورٌ':Added, #1: 1	بَيْعَ الْعَقُورِ
u'بَيْعٌ عَلَقٌ':Added, #1: 1	بَيْعِ الْعَقُورِ
u'بَيْعٌ عَلَق':Added, #1: 1	بَيْعُ الْعَلَقِ
u'بَيْعٌ عَلْقٌ':Added, #1: 1	بَيْعُ الْعَلَقِ
u'بَيْعٌ عَلَقٌ':Added, #1: 1	بَيْعُ عَلْقٍ
u'بَيْعٌ عَلَق':Added, #2: 2	بَيْعِ عَلَقٍ
u'بَيْعٌ عُلْوٌ':Added, #2: 2	بَيْعِ عَلَقٍ
u'بَيْعٌ عِمَارَةٌ':Added, #1: 1	بَيْعُ عُلْوٍ
u'بَيْعٌ عِمَارَةٌ':Added, #3: 3	بَيْعُ الْعِمَارَةِ
u'بَيْعٌ عَمَّةٌ':Added, #5: 5	بَيْعِ الْعِمَارَةِ
u'بَيْعٌ عَمُودٌ':Added, #1: 1	بَيْعُ الْعَمَّةِ
u'بَيْعٌ عِنَبٌ':Added, #1: 1	بَيْعُ عَمُودٍ
u'بَيْعٌ عِنَبٌ':Added, #10: 10	بَيْعِ الْعِنَبِ
u'بَيْعٌ عِنَبٌ':Added, #14: 14	بَيْعُ الْعِنَبِ
u'بَيْعٌ عُهْدَةٌ':Added, #1: 1	بَيْعَ الْعِنَبِ
u'بَيْعٌ عُهْدَةٌ':Added, #1: 1	بَيْعَ الْعُهْدَةِ
u'بَيْعٌ عين':Added, #3: 3	بَيْعِ الْعُهْدَةِ
u'بَيْعٌ عَيْنٌ':Added, #14: 14	بَيْعُ الْعَيْنِ
u'بَيْعٌ عَيْن':Added, #14: 14	بَيْعُ الْعَيْنِ
u'بَيْعٌ عَيْنٌ':Added, #14: 14	بَيْعُ الْعَيْنِ
u'بَيْعٌ عَيْن':Added, #14: 14	بَيْعُ عَيْنٍ
u'بَيْعٌ عَيْنٌ':Added, #14: 14	بَيْعُ عَيْنٍ
u'بَيْعٌ عَيْن':Added, #1: 1	بَيْعُ عَيْنَيْنِ
u'بَيْعٌ عين':Added, #1: 1	بَيْعُ عَيْنَيْنِ
u'بَيْعٌ عَيْنٌ':Added, #22: 22	بَيْعِ الْعَيْنِ
u'بَيْعٌ عَيْن':Added, #22: 22	بَيْعِ الْعَيْنِ
u'بَيْعٌ عين':Added, #22: 22	بَيْعِ الْعَيْنِ
u'بَيْعٌ عَيْنٌ':Added, #3: 3	بَيْعَ الْعَيْنِ
u'بَيْعٌ عَيْن':Added, #3: 3	بَيْعَ الْعَيْنِ
u'بَيْعٌ عَيْنٌ':Added, #3: 3	بَيْعَ الْعَيْنِ
u'بَيْعٌ عَيْن':Added, #4: 4	بَيْعَ عَيْنٍ
u'بَيْعٌ عَيْنٌ':Added, #4: 4	بَيْعَ عَيْنٍ
u'بَيْعٌ عَيْن':Added, #8: 8	بَيْعِ عَيْنٍ
u'بَيْعٌ عَيِّنَةٌ':Added, #8: 8	بَيْعِ عَيْنٍ
u'بَيْعٌ عُيُونٌ':Added, #3: 3	بَيْعِ الْعَيِّنَةِ
u'بَيْعٌ غَاصِبٌ':Added, #1: 1	بَيْعِ الْعُيُونِ
u'بَيْعٌ غَاصِبٌ':Added, #1: 1	بَيْعَ غَاصِبِهِ
u'بَيْعٌ غَاصِبٌ':Added, #3: 3	بَيْعِ الْغَاصِبِ
u'بَيْعٌ غَاصِبٌ':Added, #7: 7	بَيْعَ الْغَاصِبِ
u'بَيْعٌ غانِم':Added, #9: 9	بَيْعُ الْغَاصِبِ
u'بَيْعٌ غانِم':Added, #1: 1	بَيْعَ الْغَانِمِ
u'بَيْعٌ غَائِبٌ':Added, #1: 1	بَيْعِ غَانِمٍ
u'بَيْعٌ غَائِبٌ':Added, #25: 25	بَيْعِ الْغَائِبِ
u'بَيْعٌ غَائِبٌ':Added, #2: 2	بَيْعُ الْغَائِبِ
u'بَيْعٌ غَائِبٌ':Added, #5: 5	بَيْعُ غَائِبٍ
u'بَيْعٌ غَبْنٌ':Added, #6: 6	بَيْعَ الْغَائِبِ
u'بَيْعٌ غَرَرٌ':Added, #1: 1	بَيْعِ الْغَبْنِ
u'بَيْعٌ غَرَرٌ':Added, #1: 1	بَيْعَ الْغَرَرِ
u'بَيْعٌ غَرَرٌ':Added, #40: 40	بَيْعِ الْغَرَرِ
u'بَيْعٌ غرماء':Added, #4: 4	بَيْعُ الْغَرَرِ
u'بَيْعٌ غُزَاةٌ':Added, #2: 2	بَيْعِ الْغُرَمَاءِ
u'بَيْعٌ غَزْلٌ':Added, #1: 1	بَيْعِ الْغُزَاةِ
u'بَيْعٌ غَزْلٌ':Added, #1: 1	بَيْعُ الْغَزْلِ
u'بَيْعٌ غَزْلٌ':Added, #1: 1	بَيْعِ الْغَزْلِ
u'بَيْعٌ غُلاَمٌ':Added, #2: 2	بَيْعُ غَزْلِ
u'بَيْعٌ غُلاَمٌ':Added, #1: 1	بَيْعُ الْغُلَامِ
u'بَيْعٌ غُلاَمٌ':Added, #1: 1	بَيْعِ الْغُلَامِ
u'بَيْعٌ غَلَّةٌ':Added, #1: 1	بَيْعُ غُلَامٍ
u'بَيْعٌ غَلَقٌ':Added, #1: 1	بَيْعُ غَلَّةِ
u'بَيْعٌ غَنَائِمُ':Added, #1: 1	بَيْعِ الْغَلَقِ
u'بَيْعٌ غَنَائِمُ':Added, #3: 3	بَيْعِ الْغَنَائِمِ
u'بَيْعٌ غَنِيمَةٌ':Added, #4: 4	بَيْعُ الْغَنَائِمِ
u'بَيْعٌ غَنِيمَةٌ':Added, #1: 1	بَيْعَ الْغَنِيمَةِ
u'بَيْعٌ غير':Added, #2: 2	بَيْعِ الْغَنِيمَةِ
u'بَيْعٌ غَيْرٌ':Added, #1: 1	بَيْعِ الْغَيْرِ
u'بَيْعٌ غير':Added, #1: 1	بَيْعِ الْغَيْرِ
u'بَيْعٌ غَيْرٌ':Added, #1: 1	بَيْعَ غَيْرِهِ
u'بَيْعٌ غير':Added, #1: 1	بَيْعَ غَيْرِهِ
u'بَيْعٌ غَيْرٌ':Added, #2: 2	بَيْعُ غَيْرِهِ
u'بَيْعٌ غير':Added, #2: 2	بَيْعُ غَيْرِهِ
u'بَيْعٌ غَيْرٌ':Added, #3: 3	بَيْعُ غَيْرِ
u'بَيْعٌ غير':Added, #3: 3	بَيْعُ غَيْرِ
u'بَيْعٌ غَيْرٌ':Added, #5: 5	بَيْعِ غَيْرِ
u'بَيْعٌ غير':Added, #5: 5	بَيْعِ غَيْرِ
u'بَيْعٌ غَيْرٌ':Added, #5: 5	بَيْعِ غَيْرِهِ
u'بَيْعٌ فَاسِدٌ':Added, #5: 5	بَيْعِ غَيْرِهِ
u'بَيْعٌ فَاضِلٌ':Added, #14: 14	بَيْعٍ فَاسِدٍ
u'بَيْعٌ فَاضِلٌ':Added, #1: 1	بَيْعُ الْفَاضِلِ
u'بَيْعٌ فِرَاخٌ':Added, #1: 1	بَيْعِ الْفَاضِلِ
u'بَيْعٌ فِرَاخٌ':Added, #1: 1	بَيْعُ فِرَاخِهِ
u'بَيْعٌ فَرَسٌ':Added, #1: 1	بَيْعِ فِرَاخِهِ
u'بَيْعٌ فَرَسٌ':Added, #1: 1	بَيْعُ فَرَسٍ
u'بَيْعٌ فَصٌّ':Added, #2: 2	بَيْعِ الْفَرَسِ
u'بَيْعٌ فَصٌّ':Added, #1: 1	بَيْعُ فَصِّ
u'بَيْعٌ فَصِيلٌ':Added, #2: 2	بَيْعُ فَصٍّ
u'بَيْعٌ فِضَّةٌ':Added, #1: 1	بَيْعَ الْفَصِيلِ
u'بَيْعٌ فِضَّةٌ':Added, #1: 1	بَيْعِ الْفِضّةِ
u'بَيْعٌ فِضَّةٌ':Added, #1: 1	بَيْعِ الْفِضَّةِ
u'بَيْعٌ فِضَّةٌ':Added, #1: 1	بَيْعَ فِضَّةٍ
u'بَيْعٌ فَضْلٌ':Added, #6: 6	بَيْعُ الْفِضَّةِ
u'بَيْعٌ فُضُولِيٌّ':Added, #8: 8	بَيْعِ فَضْلِ
u'بَيْعٌ فُضُولِيٌّ':Added, #10: 10	بَيْعَ الْفُضُولِيِّ
u'بَيْعٌ فُضُولِيٌّ':Added, #1: 1	بَيْع الْفُضُولِيِّ
u'بَيْعٌ فُضُولِيٌّ':Added, #47: 47	بَيْعِ الْفُضُولِيِّ
u'بَيْعٌ فُقَّاعٌ':Added, #8: 8	بَيْعُ الْفُضُولِيِّ
u'بَيْعٌ فقراء':Added, #1: 1	بَيْعُ الْفُقَّاعِ
u'بَيْعٌ فلان':Added, #3: 3	بَيْعُ الْفُقَرَاءِ
u'بَيْعٌ فلان':Added, #1: 1	بَيْعَ الْغَانِمِ
u'بَيْعٌ فُلاَنٌ':Added, #1: 1	بَيْعِ غَانِمٍ
u'بَيْعٌ فُلاَنٌ':Added, #2: 2	بَيْعُ فُلَانٍ
u'بَيْعٌ فَلْسٌ':Added, #2: 2	بَيْعِ فُلَانٍ
u'بَيْعٌ فَلْسٌ':Added, #1: 1	بَيْعَ فَلْسٍ
u'بَيْعٌ فَلْسٌ':Added, #1: 1	بَيْعِ فَلْسٍ
u'بَيْعٌ فَلْسٌ':Added, #4: 4	بَيْعِ الْفَلْسِ
u'بَيْعٌ فَلْسٌ':Added, #4: 4	بَيْعُ فَلْسٍ
u'بَيْعٌ فُلُوسٌ':Added, #6: 6	بَيْعُ الْفَلْسِ
u'بَيْعٌ فَهْدٌ':Added, #5: 5	بَيْعِ الْفُلُوسِ
u'بَيْعٌ فُهُودٌ':Added, #1: 1	بَيْعُ الْفَهْدِ
u'بَيْعٌ فُولٌ':Added, #1: 1	بَيْعَ الْفُهُودِ
u'بَيْعٌ فِيلٌ':Added, #1: 1	بَيْعِ الْفُولِ
u'بَيْعٌ قَاتِلٌ':Added, #2: 2	بَيْعُ الْفِيلِ
u'بَيْعٌ قِثَّاءٌ':Added, #1: 1	بَيْعُ الْقَاتِلِ
u'بَيْعٌ قَدْرٌ':Added, #1: 1	بَيْعُ الْقِثَّاءِ
u'بَيْعٌ قَدْرٌ':Added, #1: 1	بَيْعُ قَدْرِ
u'بَيْعٌ قَدِيمٌ':Added, #1: 1	بَيْعِ قَدْرِ
u'بَيْعٌ قرار':Added, #1: 1	بَيْعَ الْقَدِيمِ
u'بَيْعٌ قَرَارٌ':Added, #2: 2	بَيْعِ الْقَرَارِ
u'بَيْعٌ قِرْدٌ':Added, #2: 2	بَيْعِ الْقَرَارِ
u'بَيْعٌ قِرْدٌ':Added, #2: 2	بَيْعُ قِرْدٍ
u'بَيْعٌ قِرْدٌ':Added, #3: 3	بَيْعُ الْقِرْدِ
u'بَيْعٌ قِرَدَةٌ':Added, #3: 3	بَيْعِ الْقِرْدِ
u'بَيْعٌ قُرُوضٌ':Added, #2: 2	بَيْعِ الْقِرَدَةِ
u'بَيْعٌ قَرِيبٌ':Added, #1: 1	بَيْعِ الْقُرُوضِ
u'بَيْعٌ قَرْيَةٌ':Added, #1: 1	بَيْعِ الْقَرِيبِ
u'بَيْعٌ قَزٌّ':Added, #1: 1	بَيْعِ الْقَرْيَةِ
u'بَيْعٌ قَصَبٌ':Added, #1: 1	بَيْعُ الْقَزِّ
u'بَيْعٌ قَصَبٌ':Added, #1: 1	بَيْعَ قَصَبِ
u'بَيْعٌ قَصِيلٌ':Added, #2: 2	بَيْعُ قَصَبِ
u'بَيْعٌ قَصِيلٌ':Added, #1: 1	بَيْعَ الْقَصِيلِ
u'بَيْعٌ قطعة':Added, #2: 2	بَيْعُ قَصِيلِ
u'بَيْعٌ قِطْعَةٌ':Added, #1: 1	بَيْعِ قِطْعَةِ
u'بَيْعٌ قُطْنٌ':Added, #1: 1	بَيْعِ قِطْعَةِ
u'بَيْعٌ قُطْنٌ':Added, #1: 1	بَيْعَ الْقُطْنِ
u'بَيْعٌ قُطْنٌ':Added, #1: 1	بَيْعُ الْقُطْنِ
u'بَيْعٌ قُطْنٌ':Added, #1: 1	بَيْعِ الْقُطْنِ
u'بَيْعٌ قَطِيعٌ':Added, #1: 1	بَيْعُ قُطْنِ
u'بَيْعٌ قَفِيز':Added, #1: 1	بَيْعِ الْقَطِيعِ
u'بَيْعٌ قَفِيز':Added, #1: 1	بَيْعِ قَفِيزٍ
u'بَيْعٌ قَفِيز':Added, #2: 2	بَيْعُ قَفِيزٍ
u'بَيْعٌ قِلاَلٌ':Added, #4: 4	بَيْعُ قَفِيزِ
u'بَيْعٌ قَمْحٌ':Added, #1: 1	بَيْعَ قِلَالِ
u'بَيْعٌ قَمْحٌ':Added, #1: 1	بَيْعَ الْقَمْحِ
u'بَيْعٌ قِنٌّ':Added, #2: 2	بَيْعُ الْقَمْحِ
u'بَيْعٌ قِنٌّ':Added, #1: 1	بَيْعَ الْقِنِّ
u'بَيْعٌ قِنٌّ':Added, #1: 1	بَيْعُ الْقِنِّ
u'بَيْعٌ قِنٌّ':Added, #1: 1	بَيْعِ الْقِنِّ
u'بَيْعٌ قِنٌّ':Added, #1: 1	بَيْعُ قِنٍّ
u'بَيْعٌ قوائم':Added, #1: 1	بَيْعُ قِنِّ
u'بَيْعٌ قَوَائِمُ':Added, #1: 1	بَيْعِ الْقَوَائِمِ
u'بَيْعٌ قوائم':Added, #1: 1	بَيْعِ الْقَوَائِمِ
u'بَيْعٌ قوائم':Added, #1: 1	بَيْعَ قَوَائِمِ
u'بَيْعٌ قَوَائِمُ':Added, #1: 1	بَيْعِ قَوَائِمِ
u'بَيْعٌ قَوَائِمُ':Added, #1: 1	بَيْعَ قَوَائِمِ
u'بَيْعٌ قُوتٌ':Added, #1: 1	بَيْعِ قَوَائِمِ
u'بَيْعٌ قَيِّمٌ':Added, #1: 1	بَيْعُ قُوتِهِ
u'بَيْعٌ قَيِّمٌ':Added, #1: 1	بَيْعَ الْقَيِّمِ
u'بَيْعٌ قَيِّمٌ':Added, #1: 1	بَيْعُ الْقَيِّمِ
u'بَيْعٌ كَافِرٌ':Added, #2: 2	بَيْعِ الْقَيِّمِ
u'بَيْعٌ كَافِرٌ':Added, #1: 1	بَيْعُ الْكَافِرِ
u'بَيْعٌ كَبِدٌ':Added, #1: 1	بَيْعِ الْكَافِرِ
u'بَيْعٌ كَبْشٌ':Added, #1: 1	بَيْعُ الْكَبِدِ
u'بَيْعٌ كَبْشٌ':Added, #1: 1	بَيْعَ الْكَبْشِ
u'بَيْعٌ كِتَابٌ':Added, #2: 2	بَيْعُ الْكَبْشِ
u'بَيْعٌ كِتَابَةٌ':Added, #1: 1	بَيْعَ الْكِتَابِ
u'بَيْعٌ كِتَابَةٌ':Added, #1: 1	بَيْعُ كِتَابَةِ
u'بَيْعٌ كِتَابَةٌ':Added, #1: 1	بَيْعِ كِتَابَتِهِ
u'بَيْعٌ كُتُبٌ':Added, #2: 2	بَيْعِ الْكِتَابَةِ
u'بَيْعٌ كُتُبٌ':Added, #1: 1	بَيْعُ الْكُتُبِ
u'بَيْعٌ كُتُبٌ':Added, #1: 1	بَيْعِ الْكُتُبِ
u'بَيْعٌ كُتُبٌ':Added, #2: 2	بَيْعَ كُتُبِ
u'بَيْعٌ كُتُبٌ':Added, #2: 2	بَيْعِ كُتُبِ
u'بَيْعٌ كَثِيرٌ':Added, #3: 3	بَيْعُ كُتُبِهِ
u'بَيْعٌ كَثِيرٌ':Added, #1: 1	بَيْعِ كَثِيرِ
u'بَيْعٌ كُرَاعٌ':Added, #2: 2	بَيْعُ الْكَثِيرِ
u'بَيْعٌ كرش':Added, #1: 1	بَيْعُ الْكُرَاعِ
u'بَيْعٌ كَرِشٌ':Added, #1: 1	بَيْعُ الْكَرِشِ
u'بَيْعٌ كَرْمٌ':Added, #1: 1	بَيْعُ الْكَرِشِ
u'بَيْعٌ كَسْبٌ':Added, #1: 1	بَيْعُ الْكَرْمِ
u'بَيْعٌ كُفَّارٌ':Added, #1: 1	بَيْعِ الْكَسْبِ
u'بَيْعٌ كَلَأٌ':Added, #1: 1	بَيْعِ الْكُفَّارِ
u'بَيْعٌ كَلَأٌ':Added, #1: 1	بَيْعِ الْكَلَأِ
u'بَيْعٌ كلاب':Added, #4: 4	بَيْعُ الْكَلَأِ
u'بَيْعٌ كِلاَبٌ':Added, #1: 1	بَيْعِ الْكِلاَبِ
u'بَيْعٌ كلاب':Added, #1: 1	بَيْعِ الْكِلاَبِ
u'بَيْعٌ كِلاَبٌ':Added, #4: 4	بَيْعِ الْكِلَابِ
u'بَيْعٌ كَلْبٌ':Added, #4: 4	بَيْعِ الْكِلَابِ
u'بَيْعٌ كَلْبٌ':Added, #11: 11	بَيْعُ الْكَلْبِ
u'بَيْعٌ كَلْبٌ':Added, #1: 1	بَيْعِ كَلْبِ
u'بَيْعٌ كَلْبٌ':Added, #4: 4	بَيْعَ الْكَلْبِ
u'بَيْعٌ لُبٌّ':Added, #9: 9	بَيْعِ الْكَلْبِ
u'بَيْعٌ لبن':Added, #1: 1	بَيْعُ اللُّبِّ
u'بَيْعٌ لَبَنٌ':Added, #13: 13	بَيْعُ اللَّبَنِ
u'بَيْعٌ لبن':Added, #13: 13	بَيْعُ اللَّبَنِ
u'بَيْعٌ لَبَنٌ':Added, #16: 16	بَيْعُ لَبَنِ
u'بَيْعٌ لَبَنٌ':Added, #16: 16	بَيْعُ لَبَنِ
u'بَيْعٌ لَبَنٌ':Added, #1: 1	بَيْعُ لَبَنٍ
u'بَيْعٌ لبن':Added, #1: 1	بَيْعِ لَبَنٍ
u'بَيْعٌ لَبَنٌ':Added, #2: 2	بَيْعَ اللَّبَنِ
u'بَيْعٌ لبن':Added, #2: 2	بَيْعَ اللَّبَنِ
u'بَيْعٌ لَبَنٌ':Added, #3: 3	بَيْعِ اللَّبَنِ
u'بَيْعٌ لبن':Added, #3: 3	بَيْعِ اللَّبَنِ
u'بَيْعٌ لَبَنٌ':Added, #5: 5	بَيْعِ لَبَنِ
u'بَيْعٌ لَحْمٌ':Added, #5: 5	بَيْعِ لَبَنِ
u'بَيْعٌ لَحْمٌ':Added, #11: 11	بَيْعُ لَحْمِ
u'بَيْعٌ لَحْمٌ':Added, #1: 1	بَيْعَ اللَّحْمِ
u'بَيْعٌ لَحْمٌ':Added, #24: 24	بَيْعُ اللَّحْمِ
u'بَيْعٌ لَحْمٌ':Added, #29: 29	بَيْعِ اللَّحْمِ
u'بَيْعٌ لَحْمٌ':Added, #3: 3	بَيْعَ لَحْمِ
u'بَيْعٌ لَحْمٌ':Added, #3: 3	بَيْعُ لَحْمِهِ
u'بَيْعٌ لُحُومٌ':Added, #7: 7	بَيْعُ لَحْمٍ
u'بَيْعٌ لُزُومٌ':Added, #2: 2	بَيْعُ لُحُومِ
u'بَيْعٌ لقطة':Added, #1: 1	بَيْعِ اللُّزُومِ
u'بَيْعٌ لُؤْلُؤٌ':Added, #1: 1	بَيْعُ اللُّقَطَةِ
u'بَيْعٌ مَاءٌ':Added, #1: 1	بَيْعُ اللُّؤْلُؤِ
u'بَيْعٌ مَاءٌ':Added, #1: 1	بَيْع مَاءِ
u'بَيْعٌ مَاءٌ':Added, #1: 1	بَيْعُ مَاءٍ
u'بَيْعٌ مَاءٌ':Added, #1: 1	بَيْعِ مَاءِ
u'بَيْعٌ مَاءٌ':Added, #24: 24	بَيْعُ الْمَاءِ
u'بَيْعٌ مَاءٌ':Added, #2: 2	بَيْع الْمَاءِ
u'بَيْعٌ مَاءٌ':Added, #3: 3	بَيْعَ الْمَاءِ
u'بَيْعٌ مَاءٌ':Added, #3: 3	بَيْعُ مَاءِ
u'بَيْعٌ مَاشِي':Added, #46: 46	بَيْعِ الْمَاءِ
u'بَيْعٌ مَاشِيَةٌ':Added, #2: 2	بَيْعِ الْمَاشِيَةِ
u'بَيْعٌ مَأْكُولٌ':Added, #2: 2	بَيْعِ الْمَاشِيَةِ
u'بَيْعٌ مَأْكُولٌ':Added, #1: 1	بَيْعِ الْمَأْكُولِ
u'بَيْعٌ مَأْكُولٌ':Added, #3: 3	بَيْعُ الْمَأْكُولِ
u'بَيْعٌ مَالٌ':Added, #3: 3	بَيْعَ مَأْكُولٍ
u'بَيْعٌ مَالٌ':Added, #11: 11	بَيْعُ مَالِ
u'بَيْعٌ مَالٌ':Added, #12: 12	بَيْعُ مَالِهِ
u'بَيْعٌ مَالٌ':Added, #18: 18	بَيْعِ مَالِهِ
u'بَيْعٌ مَالٌ':Added, #1: 1	بَيْع مَالِ
u'بَيْعٌ مَالٌ':Added, #1: 1	بَيْع مَالِهِ
u'بَيْعٌ مَالٌ':Added, #22: 22	بَيْعِ مَالِ
u'بَيْعٌ مَالٌ':Added, #2: 2	بَيْعِ الْمَالِ
u'بَيْعٌ مَالٌ':Added, #4: 4	بَيْعَ مَالِهِ
u'بَيْعٌ مَالِكٌ':Added, #7: 7	بَيْعَ مَالِ
u'بَيْعٌ مَالِكٌ':Added, #1: 1	بَيْعِ الْمَالِكِ
u'بَيْعٌ مَالِكٌ':Added, #1: 1	بَيْعُ مَالِكٍ
u'بَيْعٌ مَالِكٌ':Added, #1: 1	بَيْعُ مَالِكِ
u'بَيْعٌ مَالِكٌ':Added, #2: 2	بَيْعَ الْمَالِكِ
u'بَيْعٌ مُبَاحٌ':Added, #2: 2	بَيْعُ الْمَالِكِ
u'بَيْعٌ مُبْتاع':Added, #1: 1	بَيْعِ الْمُبَاحَاتِ
u'بَيْعٌ مُبْتَدَأٌ':Added, #1: 1	بَيْعَ الْمُبْتَاعِ
u'بَيْعٌ مَبْرُورٌ':Added, #1: 1	بَيْعٍ مُبْتَدَأٍ
u'بَيْعٌ مُبْهَمٌ':Added, #6: 6	بَيْعٍ مَبْرُورٍ
u'بَيْعٌ مُبْهَمٌ':Added, #1: 1	بَيْعُ الْمُبْهَمِ
u'بَيْعٌ مَبِيعٌ':Added, #1: 1	بَيْعِ الْمُبْهَمِ
u'بَيْعٌ مَبِيعٌ':Added, #1: 1	بَيْعِ مَبِيعٍ
u'بَيْعٌ مَبِيعٌ':Added, #2: 2	بَيْعَ الْمَبِيعِ
u'بَيْعٌ مَبِيعٌ':Added, #6: 6	بَيْعُ الْمَبِيعِ
u'بَيْعٌ مُتَأَخِّرٌ':Added, #6: 6	بَيْعِ الْمَبِيعِ
u'بَيْعٌ مَتَاعٌ':Added, #1: 1	بَيْعٍ مُتَأَخِّرٍ
u'بَيْعٌ مَتَاعٌ':Added, #1: 1	بَيْعَ الْمَتَاعِ
u'بَيْعٌ مَتَاعٌ':Added, #1: 1	بَيْعُ الْمَتَاعِ
u'بَيْعٌ مَتَاعٌ':Added, #1: 1	بَيْعُ مَتَاعِهِ
u'بَيْعٌ مُتَحَتِّم':Added, #2: 2	بَيْعِ مَتَاعِهِ
u'بَيْعٌ مُتَحَجِّرٌ':Added, #1: 1	بَيْعُ الْمُتَحَتِّمِ
u'بَيْعٌ مَتْرُوكٌ':Added, #1: 1	بَيْعُ الْمُتَحَجِّرِ
u'بَيْعٌ مَتْرُوكٌ':Added, #1: 1	بَيْعِ مَتْرُوكِ
u'بَيْعٌ مثل':Added, #4: 4	بَيْعُ مَتْرُوكِ
u'بَيْعٌ مِثْلٌ':Added, #1: 1	بَيْعِ مِثْلِهِ
u'بَيْعٌ مِثْلِيٌّ':Added, #1: 1	بَيْعِ مِثْلِهِ
u'بَيْعٌ مُجَازَفَةٌ':Added, #1: 1	بَيْعُ الْمِثْلِيِّ
u'بَيْعٌ مَجْنُونٌ':Added, #1: 1	بَيْعُ مُجَازَفَةٍ
u'بَيْعٌ مَجْنُونٌ':Added, #1: 1	بَيْعُ مَجْنُونٍ
u'بَيْعٌ مَجْهُولٌ':Added, #2: 2	بَيْعُ الْمَجْنُونِ
u'بَيْعٌ مَجْهُولٌ':Added, #1: 1	بَيْعَ مَجْهُولٍ
u'بَيْعٌ مَجْهُولٌ':Added, #2: 2	بَيْعَ الْمَجْهُولِ
u'بَيْعٌ مَجْهُولٌ':Added, #2: 2	بَيْعُ الْمَجْهُولِ
u'بَيْعٌ مُحاقَلَة':Added, #5: 5	بَيْعُ مَجْهُولٍ
u'بَيْعٌ مُحاقَلَة':Added, #1: 1	بَيْعَ الْمُحَاقَلَةِ
u'بَيْعٌ مُحْرِمٌ':Added, #3: 3	بَيْعُ الْمُحَاقَلَةِ
u'بَيْعٌ مُحْرِمٌ':Added, #1: 1	بَيْعَ الْمُحْرِمِ
u'بَيْعٌ مُحَرَّمٌ':Added, #1: 1	بَيْعِ الْمُحْرِمِ
u'بَيْعٌ مُحْرِمٌ':Added, #1: 1	بَيْعِ الْمُحَرَّمَاتِ
u'بَيْعٌ مِحْلَقٌ':Added, #5: 5	بَيْعُ الْمُحْرِمِ
u'بَيْعٌ مِحْلَقٌ':Added, #1: 1	بَيْعِ الْمِحْلَقِ
u'بَيْعٌ مَخْلُوطٌ':Added, #2: 2	بَيْعُ الْمِحْلَقِ
u'بَيْعٌ مَخِيضٌ':Added, #1: 1	بَيْعُ الْمَخْلُوطِ
u'بَيْعٌ مُدٌّ':Added, #1: 1	بَيْعُ الْمَخِيضِ
u'بَيْعٌ مُدٌّ':Added, #1: 1	بَيْعُ مُدِّ
u'بَيْعٌ مُدَبَّرٌ':Added, #1: 1	بَيْعِ مُدٍّ
u'بَيْعٌ مُدَبَّرٌ':Added, #10: 10	بَيْعُ الْمُدَبَّرِ
u'بَيْعٌ مُدَبَّرٌ':Added, #16: 16	بَيْعِ الْمُدَبَّرِ
u'بَيْعٌ مُدَبَّرٌ':Added, #1: 1	بَيْعِ الْمُدَبَّرَةِ
u'بَيْعٌ مُدَبَّرٌ':Added, #2: 2	بَيْعَ مُدَبَّرِهِ
u'بَيْعٌ مَدَر':Added, #6: 6	بَيْعَ الْمُدَبَّرِ
u'بَيْعٌ مُدَمَّسٌ':Added, #1: 1	بَيْعِ الْمَدَرِ
u'بَيْعٌ مَدِينٌ':Added, #1: 1	بَيْعُ الْمُدَمَّسِ
u'بَيْعٌ مَدْيُونٌ':Added, #1: 1	بَيْعِ الْمَدِينِ
u'بَيْعٌ مَذْبُوحٌ':Added, #1: 1	بَيْعُ الْمَدْيُونِ
u'بَيْعٌ مَذْبُوحٌ':Added, #1: 1	بَيْعُ الْمَذْبُوحِ
u'بَيْعٌ مُرابَحَة':Added, #1: 1	بَيْعِ الْمَذْبُوحَةِ
u'بَيْعٌ مُرابَحَة':Added, #22: 22	بَيْعِ الْمُرَابَحَةِ
u'بَيْعٌ مُرابَحَة':Added, #2: 2	بَيْعَ الْمُرَابَحَةِ
u'بَيْعٌ مُرْتَدٌّ':Added, #4: 4	بَيْعُ الْمُرَابَحَةِ
u'بَيْعٌ مُرْتَهَنٌ':Added, #3: 3	بَيْعُ الْمُرْتَدِّ
u'بَيْعٌ مُرْتَهِنٌ':Added, #1: 1	بَيْعُ الْمُرْتَهَنِ
u'بَيْعٌ مَرْهُونٌ':Added, #2: 2	بَيْعِ الْمُرْتَهِنِ
u'بَيْعٌ مَرْهُونٌ':Added, #15: 15	بَيْعِ الْمَرْهُونِ
u'بَيْعٌ مَرْهُونٌ':Added, #1: 1	بَيْعِ الْمَرْهُونَةِ
u'بَيْعٌ مَرْهُونٌ':Added, #1: 1	بَيْعُ مَرْهُونٍ
u'بَيْعٌ مَرْهُونٌ':Added, #3: 3	بَيْعَ الْمَرْهُونِ
u'بَيْعٌ مَرِيضٌ':Added, #5: 5	بَيْعُ الْمَرْهُونِ
u'بَيْعٌ مَرِيضٌ':Added, #2: 2	بَيْعَ الْمَرِيضِ
u'بَيْعٌ مَرِيضٌ':Added, #2: 2	بَيْعِ الْمَرِيضِ
u'بَيْعٌ مَزَامِيرُ':Added, #6: 6	بَيْعُ الْمَرِيضِ
u'بَيْعٌ مَزَامِيرُ':Added, #1: 1	بَيْعُ الْمَزَامِيرِ
u'بَيْعٌ مُزَايَدَةٌ':Added, #1: 1	بَيْعِ الْمَزَامِيرِ
u'بَيْعٌ مُزَايَدَةٌ':Added, #1: 1	بَيْعُ الْمُزَايَدَةِ
u'بَيْعٌ مُزَرْكَشٌ':Added, #2: 2	بَيْعِ الْمُزَايَدَةِ
u'بَيْعٌ مَسَاكِنُ':Added, #2: 2	بَيْعُ الْمُزَرْكَشِ
u'بَيْعٌ مُسَاوَمَةٌ':Added, #1: 1	بَيْعَ الْمَسَاكِنِ
u'بَيْعٌ مُسَاوَمَةٌ':Added, #1: 1	بَيْعِ مُسَاوَمَةٍ
u'بَيْعٌ مُسْتَأْنَفٌ':Added, #2: 2	بَيْعِ الْمُسَاوَمَةِ
u'بَيْعٌ مُسْتَحِقٌّ':Added, #1: 1	بَيْعٍ مُسْتَأْنَفٍ
u'بَيْعٌ مُسْتَسْلِمٌ':Added, #2: 2	بَيْعِ الْمُسْتَحِقِّ
u'بَيْعٌ مُسْتَعِيرٌ':Added, #2: 2	بَيْعِ الْمُسْتَسْلِمِ
u'بَيْعٌ مُسْتَقْبَلٌ':Added, #1: 1	بَيْعِ الْمُسْتَعِيرِ
u'بَيْعٌ مَسْجِدٌ':Added, #1: 1	بَيْعٍ مُسْتَقْبَلٍ
u'بَيْعٌ مَسْجِدٌ':Added, #1: 1	بَيْعَ الْمَسْجِدِ
u'بَيْعٌ مِسْكٌ':Added, #1: 1	بَيْعِ الْمَسْجِدِ
u'بَيْعٌ مِسْكٌ':Added, #1: 1	بَيْعُ الْمِسْكِ
u'بَيْعٌ مَسْكَنٌ':Added, #1: 1	بَيْعُ مِسْكٍ
u'بَيْعٌ مَسْكَنٌ':Added, #2: 2	بَيْعُ مَسْكَنِ
u'بَيْعٌ مَسْكَنٌ':Added, #2: 2	بَيْعُ مَسْكَنِهِ
u'بَيْعٌ مَسْكَنٌ':Added, #3: 3	بَيْعُ الْمَسْكَنِ
u'بَيْعٌ مِسْكِينٌ':Added, #4: 4	بَيْعِ الْمَسْكَنِ
u'بَيْعٌ مُسْلِمٌ':Added, #1: 1	بَيْعِ الْمِسْكِينِ
u'بَيْعٌ مُسْلِمٌ':Added, #1: 1	بَيْعِ الْمُسْلِمَةِ
u'بَيْعٌ مُسْلِمٌ':Added, #1: 1	بَيْعُ مُسْلِمٍ
u'بَيْعٌ مُسْلِمٌ':Added, #1: 1	بَيْعِ مُسْلِمَيْنِ
u'بَيْعٌ مُسْلِمٌ':Added, #2: 2	بَيْعِ الْمُسْلِمِ
u'بَيْعٌ مُسْلِمٌ':Added, #6: 6	بَيْعُ الْمُسْلِمِ
u'بَيْعٌ مسلوخ':Added, #7: 7	بَيْعَ الْمُسْلِمِ
u'بَيْعٌ مسلوخ':Added, #1: 1	بَيْعُ الْمَسْلُوخِ
u'بَيْعٌ مَسِيلٌ':Added, #1: 1	بَيْعِ مَسْلُوخٍ
u'بَيْعٌ مُشاعٌ':Added, #1: 1	بَيْعُ الْمَسِيلِ
u'بَيْعٌ مُشاعٌ':Added, #1: 1	بَيْعِ الْمُشَاعِ
u'بَيْعٌ مُشَاهَدٌ':Added, #4: 4	بَيْعُ الْمُشَاعِ
u'بَيْعٌ مَشْفُوع':Added, #1: 1	بَيْعُ الْمُشَاهَدِ
u'بَيْعٌ مَشْفُوع':Added, #1: 1	بَيْعِ الْمَشْفُوعِ
u'بَيْعٌ مَصَاحِفُ':Added, #1: 1	بَيْعِ مَشْفُوعٍ
u'بَيْعٌ مَصَاحِفُ':Added, #1: 1	بَيْعَ الْمَصَاحِفِ
u'بَيْعٌ مَصَادِرُ':Added, #7: 7	بَيْعِ الْمَصَاحِفِ
u'بَيْعٌ مُصَادَرٌ':Added, #1: 1	بَيْعِ الْمَصَادِرِ
u'بَيْعٌ مُصَادِرٌ':Added, #1: 1	بَيْعِ الْمُصَادَرِ
u'بَيْعٌ مُصَادَرٌ':Added, #1: 1	بَيْعِ الْمُصَادِرِ
u'بَيْعٌ مُصْحَفٌ':Added, #2: 2	بَيْعُ الْمُصَادَرِ
u'بَيْعٌ مُصْحَفٌ':Added, #1: 1	بَيْعَ مُصْحَفٍ
u'بَيْعٌ مَصْنُوعٌ':Added, #6: 6	بَيْعِ الْمُصْحَفِ
u'بَيْعٌ مَصْنُوعٌ':Added, #1: 1	بَيْعُ الْمَصْنُوعِ
u'بَيْعٌ مَصُوغٌ':Added, #1: 1	بَيْعِ الْمَصْنُوعِ
u'بَيْعٌ مَصُوغٌ':Added, #1: 1	بَيْعُ الْمَصُوغِ
u'بَيْعٌ مُضَارِبٌ':Added, #2: 2	بَيْعَ الْمَصُوغِ
u'بَيْعٌ مُضَارِبٌ':Added, #1: 1	بَيْعَ الْمُضَارِبِ
u'بَيْعٌ مَضَامِينُ':Added, #3: 3	بَيْعِ الْمُضَارِبِ
u'بَيْعٌ مَضَامِينُ':Added, #2: 2	بَيْعُ الْمَضَامِينِ
u'بَيْعٌ مَضْرُوبٌ':Added, #3: 3	بَيْعِ الْمَضَامِينِ
u'بَيْعٌ مَضْرُوبٌ':Added, #1: 1	بَيْعُ الْمَضْرُوبِ
u'بَيْعٌ مُضْطَرٌّ':Added, #2: 2	بَيْعِ الْمَضْرُوبِ
u'بَيْعٌ مُضْطَرٌّ':Added, #1: 1	بَيْعَ الْمُضْطَرِّ
u'بَيْعٌ مُضْطَرٌّ':Added, #3: 3	بَيْعُ الْمُضْطَرِّ
u'بَيْعٌ مَطْعُوم':Added, #6: 6	بَيْعِ الْمُضْطَرِّ
u'بَيْعٌ مُطْلَقٌ':Added, #1: 1	بَيْعُ مَطْعُومٍ
u'بَيْعٌ مَطْوِيٌّ':Added, #1: 1	بَيْعُ الْمُطْلَقِ
u'بَيْعٌ مَعَازِفُ':Added, #1: 1	بَيْعُ الْمَطْوِيِّ
u'بَيْعٌ مُعاطاة':Added, #2: 2	بَيْعُ الْمَعَازِفِ
u'بَيْعٌ مُعاطاة':Added, #3: 3	بَيْعَ الْمُعَاطَاةِ
u'بَيْعٌ مُعاطاة':Added, #3: 3	بَيْعُ مُعَاطَاةٍ
u'بَيْعٌ مُعاطاة':Added, #5: 5	بَيْعُ الْمُعَاطَاةِ
u'بَيْعٌ مُعَامَلَةٌ':Added, #6: 6	بَيْعِ الْمُعَاطَاةِ
u'بَيْعٌ مُعَامَلَةٌ':Added, #1: 1	بَيْعَ الْمُعَامَلَةِ
u'بَيْعٌ مُعْتَقٌ':Added, #2: 2	بَيْعَ مُعَامَلَةٍ
u'بَيْعٌ مَعْتُوهٌ':Added, #1: 1	بَيْعَ مُعْتَقِ
u'بَيْعٌ مَعْتُوهٌ':Added, #1: 1	بَيْعَ الْمَعْتُوهِ
u'بَيْعٌ مُعَجَّلٌ':Added, #1: 1	بَيْعُ الْمَعْتُوهِ
u'بَيْعٌ مَعْجُونٌ':Added, #1: 1	بَيْعٍ مُعَجَّلٍ
u'بَيْعٌ مَعْجُونٌ':Added, #1: 1	بَيْعَ الْمَعْجُونَاتِ
u'بَيْعٌ مَعْدِنٌ':Added, #1: 1	بَيْعُ الْمَعْجُونَاتِ
u'بَيْعٌ مَعْدُومٌ':Added, #1: 1	بَيْعُ الْمَعْدِنِ
u'بَيْعٌ مَعْدُومٌ':Added, #10: 10	بَيْعُ الْمَعْدُومِ
u'بَيْعٌ مَعْدُومٌ':Added, #1: 1	بَيْعِ الْمَعْدُومِ
u'بَيْعٌ مَعْدُومٌ':Added, #2: 2	بَيْعُ مَعْدُومٍ
u'بَيْعٌ مُعْطاة':Added, #3: 3	بَيْعَ الْمَعْدُومِ
u'بَيْعٌ مُعَلَّمٌ':Added, #1: 1	بَيْعُ الْمُعْطَاةِ
u'بَيْعٌ مَعْلُومٌ':Added, #1: 1	بَيْعُ الْمُعَلَّمِ
u'بَيْعٌ مَعْلُومٌ':Added, #1: 1	بَيْعٍ مَعْلُومٍ
u'بَيْعٌ مُعَيَّنٌ':Added, #3: 3	بَيْعُ مَعْلُومٍ
u'بَيْعٌ مُعَيَّنٌ':Added, #1: 1	بَيْعٍ مُعَيَّنٍ
u'بَيْعٌ مُعَيَّنٌ':Added, #1: 1	بَيْعَ مُعَيَّنٍ
u'بَيْعٌ مُعَيَّنٌ':Added, #2: 2	بَيْعَ الْمُعَيَّنِ
u'بَيْعٌ مُعَيَّنٌ':Added, #2: 2	بَيْعُ مُعَيَّنٍ
u'بَيْعٌ مَغَانِمُ':Added, #5: 5	بَيْعِ الْمُعَيَّنِ
u'بَيْعٌ مَغَانِمُ':Added, #2: 2	بَيْعُ الْمَغَانِمِ
u'بَيْعٌ مَغْشُوشٌ':Added, #7: 7	بَيْعِ الْمَغَانِمِ
u'بَيْعٌ مَغْصُوب':Added, #1: 1	بَيْعِ الْمَغْشُوشِ
u'بَيْعٌ مَغْصُوب':Added, #1: 1	بَيْعَ الْمَغْصُوبِ
u'بَيْعٌ مَغْصُوب':Added, #1: 1	بَيْعُ مَغْصُوبٍ
u'بَيْعٌ مَغْصُوب':Added, #2: 2	بَيْعِ الْمَغْصُوبِ
u'بَيْعٌ مُغَنِّي':Added, #6: 6	بَيْعُ الْمَغْصُوبِ
u'بَيْعٌ مُغَنِّي':Added, #1: 1	بَيْعِ الْمُغَنِّيَاتِ
u'بَيْعٌ مَغِيبٌ':Added, #2: 2	بَيْعُ الْمُغَنِّيَاتِ
u'بَيْعٌ مُفَاوِضٌ':Added, #2: 2	بَيْعِ مَغِيبِ
u'بَيْعٌ مُفْسِدٌ':Added, #1: 1	بَيْعُ الْمُفَاوِضِ
u'بَيْعٌ مُقَايَضَةٌ':Added, #1: 1	بَيْعَ الْمُفْسِدِ
u'بَيْعٌ مُقَايَضَةٌ':Added, #1: 1	بَيْعُ الْمُقَايَضَةِ
u'بَيْعٌ مُقَايَضَةٌ':Added, #1: 1	بَيْعِ مُقَايَضَةٍ
u'بَيْعٌ مُقْرِضٌ':Added, #9: 9	بَيْعِ الْمُقَايَضَةِ
u'بَيْعٌ مَقْسُومٌ':Added, #1: 1	بَيْعَ الْمُقْرِضِ
u'بَيْعٌ مَقْلِيٌّ':Added, #1: 1	بَيْعُ مَقْسُومٍ
u'بَيْعٌ مَقْلِيٌّ':Added, #1: 1	بَيْعُ الْمَقْلِيَّةِ
u'بَيْعٌ مُكَاتَبَةٌ':Added, #2: 2	بَيْعِ الْمَقْلِيَّةِ
u'بَيْعٌ مُكَرَّمٌ':Added, #2: 2	بَيْعَ الْمُكَاتَبَةِ
u'بَيْعٌ مُكْرَهٌ':Added, #1: 1	بَيْعِ الْمُكَرَّمِ
u'بَيْعٌ مُكْرَهٌ':Added, #3: 3	بَيْعَ مُكْرَهٍ
u'بَيْعٌ مُكْرَهٌ':Added, #3: 3	بَيْعُ مُكْرَهٍ
u'بَيْعٌ مُكْرَهٌ':Added, #4: 4	بَيْعَ الْمُكْرَهِ
u'بَيْعٌ مُكْرَهٌ':Added, #4: 4	بَيْعِ الْمُكْرَهِ
u'بَيْعٌ مَكِيلٌ':Added, #5: 5	بَيْعُ الْمُكْرَهِ
u'بَيْعٌ مَكِيلٌ':Added, #1: 1	بَيْعَ الْمَكِيلِ
u'بَيْعٌ مَكِيل':Added, #1: 1	بَيْعِ الْمَكِيلِ
u'بَيْعٌ مَكِيلٌ':Added, #1: 1	بَيْعِ الْمَكِيلَيْنِ
u'بَيْعٌ مَكِيلٌ':Added, #1: 1	بَيْعِ مَكِيلٍ
u'بَيْعٌ مَكِيلٌ':Added, #2: 2	بَيْعُ الْمَكِيلِ
u'بَيْعٌ مِلْءٌ':Added, #3: 3	بَيْعُ مَكِيلٍ
u'بَيْعٌ مُلاَمَسَةٌ':Added, #1: 1	بَيْعُ مِلْءِ
u'بَيْعٌ مُلاَمَسَةٌ':Added, #2: 2	بَيْعِ الْمُلاَمَسَةِ
u'بَيْعٌ مُلاَمَسَةٌ':Added, #6: 6	بَيْعُ الْمُلَامَسَةِ
u'بَيْعٌ مُلْتَقِط':Added, #7: 7	بَيْعِ الْمُلَامَسَةِ
u'بَيْعٌ مِلْكٌ':Added, #1: 1	بَيْعِ الْمُلْتَقِطِ
u'بَيْعٌ مِلْكٌ':Added, #1: 1	بَيْعُ الْمِلْكِ
u'بَيْعٌ مِلْكٌ':Added, #1: 1	بَيْعَ مِلْكٍ
u'بَيْعٌ مِلْكٌ':Added, #1: 1	بَيْعُ مِلْكِ
u'بَيْعٌ مِلْكٌ':Added, #1: 1	بَيْعَ مِلْكِهِ
u'بَيْعٌ مِلْكٌ':Added, #2: 2	بَيْعِ مِلْكِ
u'بَيْعٌ مَمَرٌّ':Added, #2: 2	بَيْعِ مِلْكِهِ
u'بَيْعٌ مَمْلُوكٌ':Added, #4: 4	بَيْعِ الْمَمَرِّ
u'بَيْعٌ مُنَابذَةٌ':Added, #1: 1	بَيْعِ الْمَمْلُوكِ
u'بَيْعٌ مَنَازِلُ':Added, #1: 1	بَيْعُ الْمُنَابَذَةِ
u'بَيْعٌ مَنَافِعُ':Added, #1: 1	بَيْعُ مَنَازِلِ
u'بَيْعٌ مَنَافِعُ':Added, #10: 10	بَيْعُ الْمَنَافِعِ
u'بَيْعٌ مَنَافِعُ':Added, #1: 1	بَيْعَ الْمَنَافِعِ
u'بَيْعٌ مَنْزِلٌ':Added, #6: 6	بَيْعِ الْمَنَافِعِ
u'بَيْعٌ مَنْزِلٌ':Added, #1: 1	بَيْعَ الْمَنْزِلِ
u'بَيْعٌ مَنْزِلٌ':Added, #1: 1	بَيْعِ الْمَنْزِلِ
u'بَيْعٌ مَنْزُوعٌ':Added, #1: 1	بَيْعِ مَنْزِلٍ
u'بَيْعٌ مَنْسُوجٌ':Added, #1: 1	بَيْعَ مَنْزُوعِ
u'بَيْعٌ مَنْفَعَةٌ':Added, #1: 1	بَيْعَ الْمَنْسُوجِ
u'بَيْعٌ مَنْفَعَةٌ':Added, #1: 1	بَيْعِ الْمَنْفَعَةِ
u'بَيْعٌ مَنْفَعَةٌ':Added, #2: 2	بَيْعِ مَنْفَعَةِ
u'بَيْعٌ مَنْفَعَةٌ':Added, #3: 3	بَيْعُ مَنْفَعَةِ
u'بَيْعٌ مَنْقُولٌ':Added, #4: 4	بَيْعُ مَنْفَعَةٍ
u'بَيْعٌ مَنْقُولٌ':Added, #1: 1	بَيْعُ مَنْقُولِ
u'بَيْعٌ مَنْقُولٌ':Added, #2: 2	بَيْعُ مَنْقُولِهِ
u'بَيْعٌ مَنْقُولٌ':Added, #5: 5	بَيْعَ الْمَنْقُولِ
u'بَيْعٌ مَنْقُولٌ':Added, #5: 5	بَيْعُ الْمَنْقُولِ
u'بَيْعٌ مُهَانٌ':Added, #6: 6	بَيْعِ الْمَنْقُولِ
u'بَيْعٌ مَهْرٌ':Added, #1: 1	بَيْعِ الْمُهَانِ
u'بَيْعٌ مُهْرٌ':Added, #1: 1	بَيْعِ الْمَهْرِ
u'بَيْعٌ مَوَاتٌ':Added, #1: 1	بَيْعِ الْمُهْرِ
u'بَيْعٌ مَوَاضِعُ':Added, #2: 2	بَيْعُ الْمَوَاتِ
u'بَيْعٌ مُؤَجَّرٌ':Added, #1: 1	بَيْعُ مَوَاضِعِ
u'بَيْعٌ مُؤَجَّرٌ':Added, #1: 1	بَيْعَ الْمُؤَجَّرِ
u'بَيْعٌ مُؤَجِّرٌ':Added, #1: 1	بَيْعِ الْمُؤَجَّرِ
u'بَيْعٌ مُؤَجِّرٌ':Added, #2: 2	بَيْعِ الْمُؤَجِّرِ
u'بَيْعٌ مَوْزُونٌ':Added, #3: 3	بَيْعُ الْمُؤَجِّرِ
u'بَيْعٌ مَوْزُونٌ':Added, #1: 1	بَيْعُ الْمَوْزُونَاتِ
u'بَيْعٌ مَوْزُونٌ':Added, #1: 1	بَيْعِ الْمَوْزُونَاتِ
u'بَيْعٌ مَوْصُوفٌ':Added, #3: 3	بَيْعَ مَوْزُونٍ
u'بَيْعٌ مَوْصُوفٌ':Added, #1: 1	بَيْعُ الْمَوْصُوفِ
u'بَيْعٌ مَوْصُوفٌ':Added, #1: 1	بَيْعِ الْمَوْصُوفِ
u'بَيْعٌ مَوْضِعٌ':Added, #2: 2	بَيْعُ مَوْصُوفٍ
u'بَيْعٌ مَوْقُوفٌ':Added, #1: 1	بَيْعَ مَوْضِعِ
u'بَيْعٌ مُوَكِّلٌ':Added, #2: 2	بَيْعٍ مَوْقُوفٍ
u'بَيْعٌ مُوَكِّلٌ':Added, #1: 1	بَيْعُ الْمُوَكِّلِ
u'بَيْعٌ مُوَكِّلٌ':Added, #2: 2	بَيْعَ الْمُوَكِّلِ
u'بَيْعٌ مَوْهُوبٌ':Added, #2: 2	بَيْعِ الْمُوَكِّلِ
u'بَيْعٌ مِيَاهٌ':Added, #1: 1	بَيْعُ الْمَوْهُوبِ
u'بَيْعٌ مِيَاهٌ':Added, #1: 1	بَيْعَ الْمِيَاهِ
u'بَيْعٌ مَيْتٌ':Added, #1: 1	بَيْعُ الْمِيَاهِ
u'بَيْعٌ مَيْتٌ':Added, #1: 1	بَيْعَ الْمَيْتَةِ
u'بَيْعٌ مَيْتٌ':Added, #1: 1	بَيْعِ الْمَيْتَةِ
u'بَيْعٌ مَيْتَةٌ':Added, #6: 6	بَيْعُ الْمَيْتَةِ
u'بَيْعٌ مَيْتَةٌ':Added, #1: 1	بَيْعَ الْمَيْتَةِ
u'بَيْعٌ مَيْتَةٌ':Added, #1: 1	بَيْعِ الْمَيْتَةِ
u'بَيْعٌ مَيْتَةٌ':Added, #4: 4	بَيْعُ مَيْتَةٍ
u'بَيْعٌ مِيرَاثٌ':Added, #6: 6	بَيْعُ الْمَيْتَةِ
u'بَيْعٌ مِيرَاثٌ':Added, #1: 1	بَيْعُ الْمِيرَاثِ
u'بَيْعٌ مِيرَاثٌ':Added, #1: 1	بَيْعِ مِيرَاثٍ
u'بَيْعٌ نَاسٌ':Added, #2: 2	بَيْعُ مِيرَاثٍ
u'بَيْعٌ نَاسٌ':Added, #1: 1	بَيْعُ النَّاسِ
u'بَيْعٌ نَاسٌ':Added, #2: 2	بَيْعَ النَّاسِ
u'بَيْعٌ نَاقَةٌ':Added, #3: 3	بَيْعِ النَّاسِ
u'بَيْعٌ نَاقَة':Added, #1: 1	بَيْعِ نَاقَةٍ
u'بَيْعٌ نِتَاجٌ':Added, #1: 1	بَيْعِ نَاقَةٍ
u'بَيْعٌ نَجَاسَةٌ':Added, #2: 2	بَيْعُ نِتَاجِ
u'بَيْعٌ نَجَاسَةٌ':Added, #1: 1	بَيْعُ النَّجَاسَةِ
u'بَيْعٌ نَجَاسَةٌ':Added, #1: 1	بَيْعِ النَّجَاسَةِ
u'بَيْعٌ نَجَاسَةٌ':Added, #1: 1	بَيْعِ نَجَاسَةٍ
u'بَيْعٌ نَجِسٌ':Added, #3: 3	بَيْعُ نَجَاسَةٍ
u'بَيْعٌ نَجَسٌ':Added, #1: 1	بَيْعُ النَّجِسِ
u'بَيْعٌ نَجْمٌ':Added, #1: 1	بَيْعُ نَجَسِ
u'بَيْعٌ نُجُومٌ':Added, #1: 1	بَيْعُ نَجْمٍ
u'بَيْعٌ نُجُومٌ':Added, #1: 1	بَيْعُ النُّجُومِ
u'بَيْعٌ نُحَاسٌ':Added, #1: 1	بَيْعِ نُجُومِ
u'بَيْعٌ نَحْلٌ':Added, #1: 1	بَيْعُ نُحَاسٍ
u'بَيْعٌ نَحْلٌ':Added, #10: 10	بَيْعُ النَّحْلِ
u'بَيْعٌ نَحْوٌ':Added, #1: 1	بَيْعِ النَّحْلِ
u'بَيْعٌ نُخَالَةٌ':Added, #5: 5	بَيْعِ نَحْوِ
u'بَيْعٌ نَخْلٌ':Added, #1: 1	بَيْعُ النُّخَالَةِ
u'بَيْعٌ نَخْلٌ':Added, #18: 18	بَيْعِ النَّخْلِ
u'بَيْعٌ نَخْلٌ':Added, #1: 1	بَيْعُ النَّخْلِ
u'بَيْعٌ نخلة':Added, #1: 1	بَيْعُ نَخْلِ
u'بَيْعٌ نَخْلَةٌ':Added, #1: 1	بَيْعِ النَّخْلَةِ
u'بَيْعٌ نَخِيلٌ':Added, #1: 1	بَيْعِ النَّخْلَةِ
u'بَيْعٌ نَرْدٌ':Added, #1: 1	بَيْعَ النَّخِيلِ
u'بَيْعٌ نَرْدٌ':Added, #1: 1	بَيْعِ النَّرْدِ
u'بَيْعٌ نصاب':Added, #2: 2	بَيْعُ النَّرْدِ
u'بَيْعٌ نصاب':Added, #1: 1	بَيْعُ النِّصَابِ
u'بَيْعٌ نِصَابٌ':Added, #1: 1	بَيْعِ النِّصَابِ
u'بَيْعٌ نِصَابٌ':Added, #1: 1	بَيْعُ النِّصَابِ
u'بَيْعٌ نَصْرَانِيٌّ':Added, #1: 1	بَيْعِ النِّصَابِ
u'بَيْعٌ نِصْفٌ':Added, #1: 1	بَيْعِ النَّصْرَانِيِّ
u'بَيْعٌ نِصْفٌ':Added, #1: 1	بَيْعِ النِّصْفَيْنِ
u'بَيْعٌ نِصْفٌ':Added, #1: 1	بَيْعَ نِصْفِهِ
u'بَيْعٌ نِصْفٌ':Added, #1: 1	بَيْعُ نِصْفِهِ
u'بَيْعٌ نِصْفٌ':Added, #2: 2	بَيْعِ نِصْفِهِ
u'بَيْعٌ نِصْفٌ':Added, #3: 3	بَيْعِ النِّصْفِ
u'بَيْعٌ نِصْفٌ':Added, #3: 3	بَيْعَ نِصْفِ
u'بَيْعٌ نِصْفٌ':Added, #4: 4	بَيْعِ نِصْفِ
u'بَيْعٌ نِصْفٌ':Added, #5: 5	بَيْعَ النِّصْفِ
u'بَيْعٌ نِصْفٌ':Added, #5: 5	بَيْعُ النِّصْفِ
u'بَيْعٌ نَصِيبٌ':Added, #7: 7	بَيْعُ نِصْفِ
u'بَيْعٌ نَصِيبٌ':Added, #12: 12	بَيْعُ نَصِيبِهِ
u'بَيْعٌ نَصِيبٌ':Added, #3: 3	بَيْعُ نَصِيبِ
u'بَيْعٌ نَصِيبٌ':Added, #4: 4	بَيْعَ نَصِيبِ
u'بَيْعٌ نَصِيبٌ':Added, #4: 4	بَيْعِ نَصِيبِ
u'بَيْعٌ نَصِيبٌ':Added, #4: 4	بَيْعَ نَصِيبِهِ
u'بَيْعٌ نَعْلٌ':Added, #8: 8	بَيْعِ نَصِيبِهِ
u'بَيْعٌ نَفْسٌ':Added, #1: 1	بَيْعُ نَعْلٍ
u'بَيْعٌ نَفْسٌ':Added, #1: 1	بَيْعُ نَفْسِ
u'بَيْعٌ نَفْسٌ':Added, #1: 1	بَيْعَ نَفْسِهِ
u'بَيْعٌ نَفْسٌ':Added, #1: 1	بَيْعُ نَفْسِهِ
u'بَيْعٌ نَفْسٌ':Added, #2: 2	بَيْعِ نَفْسِ
u'بَيْعٌ نَفَقَةٌ':Added, #4: 4	بَيْعَ نَفْسِ
u'بَيْعٌ نَقْدٌ':Added, #1: 1	بَيْعُ نَفَقَةِ
u'بَيْعٌ نَقْد':Added, #2: 2	بَيْعِ النَّقْدِ
u'بَيْعٌ نَقْدٌ':Added, #2: 2	بَيْعِ النَّقْدِ
u'بَيْعٌ نَقْد':Added, #5: 5	بَيْعُ النَّقْدِ
u'بَيْعٌ نَقْضٌ':Added, #5: 5	بَيْعُ النَّقْدِ
u'بَيْعٌ نَقْضٌ':Added, #1: 1	بَيْعُ النَّقْضِ
u'بَيْعٌ نمر':Added, #1: 1	بَيْعِ نَقْضِ
u'بَيْعٌ نَمِرٌ':Added, #1: 1	بَيْعُ النَّمِرِ
u'بَيْعٌ نَوْعٌ':Added, #1: 1	بَيْعُ النَّمِرِ
u'بَيْعٌ هَازِلٌ':Added, #1: 1	بَيْعُ نَوْعٍ
u'بَيْعٌ هَازِلٌ':Added, #10: 10	بَيْعِ الْهَازِلِ
u'بَيْعٌ هِرٌّ':Added, #3: 3	بَيْعَ الْهَازِلِ
u'بَيْعٌ هِرٌّ':Added, #1: 1	بَيْعِ الْهِرِّ
u'بَيْعٌ هِرٌّ':Added, #1: 1	بَيْعِ الْهِرَّةِ
u'بَيْعٌ هِرٌّ':Added, #2: 2	بَيْعُ الْهِرَّةِ
u'بَيْعٌ هِرٌّ':Added, #2: 2	بَيْعِ هِرٍّ
u'بَيْعٌ هَرَوِيّ':Added, #6: 6	بَيْعُ الْهِرِّ
u'بَيْعٌ هَرَوِيّ':Added, #1: 1	بَيْعُ الْهَرَوِيِّ
u'بَيْعٌ هَزْلٌ':Added, #1: 1	بَيْعِ الْهَرَوِيِّ
u'بَيْعٌ هَزْلٌ':Added, #1: 1	بَيْعُ هَزْلٍ
u'بَيْعٌ هَوَاءٌ':Added, #3: 3	بَيْعَ هَزْلٍ
u'بَيْعٌ هَوَامٌّ':Added, #2: 2	بَيْعُ هَوَاءٍ
u'بَيْعٌ هَوَامٌّ':Added, #1: 1	بَيْعُ الْهَوَامِّ
u'بَيْعٌ واحد':Added, #2: 2	بَيْعُ هَوَامِّ
u'بَيْعٌ وَاحِدٌ':Added, #1: 1	بَيْعَ الْوَاحِدِ
u'بَيْعٌ واحد':Added, #1: 1	بَيْعَ الْوَاحِدِ
u'بَيْعٌ واحد':Added, #2: 2	بَيْعٍ وَاحِدٍ
u'بَيْعٌ وَاحِدٌ':Added, #2: 2	بَيْعُ وَاحِدٍ
u'بَيْعٌ وَاحِدٌ':Added, #2: 2	بَيْعٍ وَاحِدٍ
u'بَيْعٌ واحد':Added, #2: 2	بَيْعُ وَاحِدٍ
u'بَيْعٌ وَاحِدٌ':Added, #6: 6	بَيْعُ الْوَاحِدِ
u'بَيْعٌ وَارِثٌ':Added, #6: 6	بَيْعُ الْوَاحِدِ
u'بَيْعٌ وَارِثٌ':Added, #1: 1	بَيْعُ الْوَارِثِ
u'بَيْعٌ وَاهِبٌ':Added, #1: 1	بَيْعِ الْوَارِثِ
u'بَيْعٌ وَدِيعٌ':Added, #1: 1	بَيْعُ الْوَاهِبِ
u'بَيْعٌ وَدِيعَةٌ':Added, #1: 1	بَيْعِ الْوَدِيعَةِ
u'بَيْعٌ وَرَثَةٌ':Added, #1: 1	بَيْعِ الْوَدِيعَةِ
u'بَيْعٌ وَرْدٌ':Added, #3: 3	بَيْعِ الْوَرَثَةِ
u'بَيْعٌ ورق':Added, #1: 1	بَيْعِ الْوَرْدِ
u'بَيْعٌ وَرَقٌ':Added, #1: 1	بَيْعُ وَرَقِهِ
u'بَيْعٌ ورق':Added, #1: 1	بَيْعُ وَرَقِهِ
u'بَيْعٌ وَرِقٌ':Added, #2: 2	بَيْعِ الْوَرِقِ
u'بَيْعٌ ورق':Added, #2: 2	بَيْعِ الْوَرِقِ
u'بَيْعٌ وَرَقٌ':Added, #2: 2	بَيْعَ وَرَقِ
u'بَيْعٌ وَصِيٌّ':Added, #2: 2	بَيْعَ وَرَقِ
u'بَيْعٌ وَصِيٌّ':Added, #17: 17	بَيْعُ الْوَصِيِّ
u'بَيْعٌ وَصِيٌّ':Added, #1: 1	بَيْعِ الْوَصِيَّةِ
u'بَيْعٌ وَصِيٌّ':Added, #4: 4	بَيْعَ الْوَصِيِّ
u'بَيْعٌ وَصِيَّةٌ':Added, #8: 8	بَيْعِ الْوَصِيِّ
u'بَيْعٌ وَفَاءٌ':Added, #1: 1	بَيْعِ الْوَصِيَّةِ
u'بَيْعٌ وَفَاءٌ':Added, #3: 3	بَيْعَ وَفَاءٍ
u'بَيْعٌ وَفَاءٌ':Added, #4: 4	بَيْعُ الْوَفَاءِ
u'بَيْعٌ وَفَاءٌ':Added, #5: 5	بَيْعِ الْوَفَاءِ
u'بَيْعٌ وَقْفٌ':Added, #7: 7	بَيْعَ الْوَفَاءِ
u'بَيْعٌ وَقْفٌ':Added, #1: 1	بَيْعُ وَقْفٍ
u'بَيْعٌ وَقْفٌ':Added, #2: 2	بَيْعَ الْوَقْفِ
u'بَيْعٌ وَقْفٌ':Added, #2: 2	بَيْعَ وَقْفٍ
u'بَيْعٌ وَقْفٌ':Added, #5: 5	بَيْعُ الْوَقْفِ
u'بَيْعٌ وُقُوفٌ':Added, #9: 9	بَيْعِ الْوَقْفِ
u'بَيْعٌ وَكِيلٌ':Added, #1: 1	بَيْعَ الْوُقُوفِ
u'بَيْعٌ وَكِيلٌ':Added, #14: 14	بَيْعِ الْوَكِيلِ
u'بَيْعٌ وَكِيلٌ':Added, #1: 1	بَيْعُ وَكِيلِهِ
u'بَيْعٌ وَكِيلٌ':Added, #4: 4	بَيْعَ الْوَكِيلِ
u'بَيْعٌ وَلاَءٌ':Added, #7: 7	بَيْعُ الْوَكِيلِ
u'بَيْعٌ وَلاَءٌ':Added, #10: 10	بَيْعِ الْوَلاَءِ
u'بَيْعٌ وَلاَءٌ':Added, #1: 1	بَيْعِ الْوَلاءِ
u'بَيْعٌ وَلاَءٌ':Added, #1: 1	بَيْعُ الْوَلَاءِ
u'بَيْعٌ وَلاَءٌ':Added, #1: 1	بَيْعُ وَلَاءِ
u'بَيْعٌ ولد':Added, #5: 5	بَيْعِ الْوَلَاءِ
u'بَيْعٌ ولد':Added, #1: 1	بَيْعَ الْوَلَدِ
u'بَيْعٌ وَلَدٌ':Added, #1: 1	بَيْعِ الْوَلَدِ
u'بَيْعٌ وَلَدٌ':Added, #1: 1	بَيْعَ الْوَلَدِ
u'بَيْعٌ ولد':Added, #1: 1	بَيْعِ الْوَلَدِ
u'بَيْعٌ وَلَدٌ':Added, #2: 2	بَيْعُ وَلَدِ
u'بَيْعٌ ولد':Added, #2: 2	بَيْعُ وَلَدِ
u'بَيْعٌ وَلَدٌ':Added, #3: 3	بَيْعِ وَلَدِ
u'بَيْعٌ ولد':Added, #3: 3	بَيْعِ وَلَدِ
u'بَيْعٌ وَلَدٌ':Added, #5: 5	بَيْعُ الْوَلَدِ
u'بَيْعٌ وَلِيٌّ':Added, #5: 5	بَيْعُ الْوَلَدِ
u'بَيْعٌ وَلِيٌّ':Added, #1: 1	بَيْعَ الْوَلِيِّ
u'بَيْعٌ وهبة':Added, #4: 4	بَيْعِ الْوَلِيِّ
u'بَيْعٌ يهود':Added, #4: 4	بَيْعٍ وَهِبَةٍ
u'بَيْعٌ يَهُودٌ':Added, #1: 1	بَيْعِ الْيَهُودِ
u'بَيْنٌ أَبٌ':Added, #1: 1	بَيْعِ الْيَهُودِ
u'بَيْنٌ أَبٌ':Added, #38: 38	بَيْنَ الْأَبِ
u'بَيْنٌ إبَاءٌ':Added, #6: 6	بَيْنَ أَبٍ
u'بَيْنٌ آباءٌ':Added, #1: 1	بَيْنَ الْإِبَاءِ
u'بَيْنٌ إبَاحَةٌ':Added, #8: 8	بَيْنَ الْآبَاءِ
u'بَيْنٌ آبارٌ':Added, #5: 5	بَيْنَ الْإِبَاحَةِ
u'بَيْنٌ آبارٌ':Added, #1: 1	بَيْنَ آبَارٍ
u'بَيَّنَ اِبْتِداءٌ':Predicate, #4: 4	بَيْنَ آبَارِ
u'بَيْنٌ اِبْتِداءٌ':Added, #1: 1	بَيَّنَ ابْتِدَاءَ
u'بَيْنٌ أبَدٌ':Added, #6: 6	بَيْنَ ابْتِدَاءِ
u'بَيْنٌ إبْداءٌ':Added, #1: 1	بَيْنَ الْأَبَدِ
u'بَيَّنَ إبدالٌ':Predicate, #1: 1	بَيْنَ إبْدَاءِ
u'بَيْنٌ إِبْطٌ':Added, #1: 1	بَيَّنَ الْإِبْدَالَ
u'بَيْنٌ أَبْعاضٌ':Added, #1: 1	بَيْنَ الْإِبْطِ
u'بَيْنٌ إِبْقَاءٌ':Added, #2: 2	بَيْنَ أَبْعَاضِ
u'بَيْنٌ إِبِلٌ':Added, #1: 1	بَيْنَ إبْقَاءِ
u'بَيْنٌ إِبِلٌ':Added, #1: 1	بَيْنِ الإِبِلِ
u'بَيَّنَ اِبْنٌ':Subject, #3: 3	بَيْنَ الْإِبِلِ
u'بَيْنٌ اِبْنٌ':Added, #2: 2	بَيَّنَ ابْنُ
u'بَيْنٌ اِبْنٌ':Added, #10: 10	بَيْنَ ابْنِهِ
u'بَيْنٌ اِبْنٌ':Added, #15: 15	بَيْنَ ابْنِ
u'بَيْنٌ اِبْنٌ':Added, #1: 1	بَيْن ابْنٍ
u'بَيْنٌ أَبْنَاءٌ':Added, #1: 1	بَيْنَ ابْنٍ
u'بَيْنٌ اِبْنَة':Added, #1: 1	بَيْنَ أَبْنَاءِ
u'بَيْنٌ اِبْنَة':Added, #1: 1	بَيْنَ ابْنَةِ
u'بَيْنٌ أبْنيَةٌ':Added, #1: 1	بَيْنَ ابْنَتِهِ
u'بَيْنٌ أبْنيَةٌ':Added, #2: 2	بَيْنَ أَبْنِيَةِ
u'بَيْنٌ إِبْهَامٌ':Added, #3: 3	بَيْنَ الْأَبْنِيَةِ
u'بَيْنٌ إِبْهَامٌ':Added, #1: 1	بَيْنَ إِبْهَامِ
u'بَيْنٌ إِبْهَامٌ':Added, #1: 1	بَيْنَ إبْهَامِهِ
u'بَيْنٌ إِبْهَامٌ':Added, #1: 1	بَيْنَ الإِبْهَامِ
u'بَيْنٌ اِتِّبَاعٌ':Added, #1: 1	بَيْنَ الْإِبْهَامِ
u'بَيْنٌ اِتِّبَاعٌ':Added, #1: 1	بَيْنَ اتِّبَاعِهِ
u'بَيْنٌ اِتِّحَادٌ':Added, #2: 2	بَيْنَ اتِّبَاعِ
u'بَيْنٌ إِتْلاَفٌ':Added, #1: 1	بَيْنَ اتِّحَادٍ
u'بَيْنٌ إِتْلاَفٌ':Added, #1: 1	بَيْنَ إتْلَافِ
u'بَيْنٌ إتْمَامٌ':Added, #3: 3	بَيْنَ الْإِتْلَافِ
u'بَيْنٌ إِتْيانٌ':Added, #3: 3	بَيْنَ إتْمَامِ
u'بَيْنٌ إِتْيانٌ':Added, #1: 1	بَيْنَ إتْيَانِهِ
u'بَيْنٌ إِتْيانٌ':Added, #2: 2	بَيْن الْإِتْيَانِ
u'بَيْنٌ آثَارٌ':Added, #3: 3	بَيْنَ الْإِتْيَانِ
u'بَيْنٌ إِثْبَاتٌ':Added, #1: 1	بَيْنَ الْآثَارِ
u'بَيْنٌ إِثْبَاتٌ':Added, #2: 2	بَيْنَ إثْبَاتِ
u'بَيْنٌ إِثْبَاتٌ':Added, #2: 2	بَيْنَ الْإِثْبَاتِ
u'بَيْنٌ أَثْلاثٌ':Added, #3: 3	بَيْنَ إثْبَاتَيْنِ
u'بَيْنٌ إِثْمٌ':Added, #1: 1	بَيْنَ الْأَثْلَاثِ
u'بَيْنٌ أَثْناءُ':Added, #1: 1	بَيْنَ الْإِثْمِ
u'بَيْنٌ إجَارَةٌ':Added, #3: 3	بَيْنَ أَثْنَاءِ
u'بَيْنٌ إجَارَةٌ':Added, #1: 1	بَيْن الْإِجَارَةِ
u'بَيْنٌ إجَارَةٌ':Added, #2: 2	بَيْنَ إجَارَةٍ
u'بَيْنٌ إجَارَةٌ':Added, #3: 3	بَيْنَ إجَارَةِ
u'بَيْنٌ إجَازَةٌ':Added, #5: 5	بَيْنَ الْإِجَارَةِ
u'بَيْنٌ إجَازَةٌ':Added, #1: 1	بَيْنَ إجَازَتِهِ
u'بَيْنٌ إجَازَةٌ':Added, #2: 2	بَيْنَ إجَازَةِ
u'بَيْنٌ أجَانِبُ':Added, #9: 9	بَيْنَ الْإِجَازَةِ
u'بَيْنٌ إِجْبَارٌ':Added, #3: 3	بَيْنَ الْأَجَانِبِ
u'بَيْنٌ اِجْتِمَاعٌ':Added, #1: 1	بَيْنَ إجْبَارِهِ
u'بَيْنٌ اِجْتِمَاعٌ':Added, #1: 1	بَيْنَ اجْتِمَاعِهِ
u'بَيْنٌ أَجْرٌ':Added, #2: 2	بَيْنَ اجْتِمَاعِ
u'بَيْنٌ آجُرٌّ':Added, #1: 1	بَيْنَ أَجْرِ
u'بَيْنٌ أَجْرٌ':Added, #1: 1	بَيْنَ الْآجُرِّ
u'بَيْنٌ أجراء':Added, #1: 1	بَيْنَ الْأَجْرِ
u'بَيْنٌ أَجْرَامٌ':Added, #2: 2	بَيْنَ الْأُجَرَاءِ
u'بَيَّنَ أُجْرَةٌ':Predicate, #1: 1	بَيْنَ الْأَجْرَامِ
u'بَيْنٌ أُجْرَةٌ':Added, #1: 1	بَيَّنَ الْأُجْرَةَ
u'بَيْنٌ أُجْرَةٌ':Added, #1: 1	بَيْنَ أُجْرَتِهِ
u'بَيْنٌ أُجْرَةٌ':Added, #1: 1	بَيْنَ الْأُجْرَةِ
u'بَيْنٌ إِجْزَاءٌ':Added, #3: 3	بَيْنَ أُجْرَةِ
u'بَيْنٌ أَجْزَاءٌ':Added, #1: 1	بَيْنَ إجْزَاءِ
u'بَيْنٌ إِجْزَاءٌ':Added, #1: 1	بَيْنَ الْأَجْزَاءِ
u'بَيْنٌ أَجْزَاءٌ':Added, #1: 1	بَيْنَ الْإِجْزَاءِ
u'بَيْنٌ أَجْسَامٌ':Added, #6: 6	بَيْنَ أَجْزَاءِ
u'بَيَّنَ أَجَلٌ':Predicate, #1: 1	بَيْنَ الْأَجْسَامِ
u'بَيْنٌ أَجَلٌ':Added, #2: 2	بَيَّنَ الْأَجَلَ
u'بَيْنٌ إِجْمَاعٌ':Added, #1: 1	بَيْنَ الْأَجَلِ
u'بَيْنٌ إِجْمَاعٌ':Added, #1: 1	بَيْنَ إجْمَاعِ
u'بَيْنٌ إِجْمَاعٌ':Added, #2: 2	بَيْنَ الْإِجْمَاعِ
u'بَيْنٌ إِجْمَالٌ':Added, #2: 2	بَيْنَ الْإِجْمَاعَيْنِ
u'بَيْنٌ أَجْنَاسٌ':Added, #1: 1	بَيْنَ الْإِجْمَالِ
u'بَيْنٌ أَجْنَاسٌ':Added, #1: 1	بَيْنَ أَجْنَاسٍ
u'بَيْنٌ أَجْنَاسٌ':Added, #2: 2	بَيْنَ الْأَجْنَاسِ
u'بَيْنٌ أَجْنَبِيٌّ':Added, #5: 5	بَيْنَ أَجْنَاسِ
u'بَيْنٌ أَجْنَبِيٌّ':Added, #10: 10	بَيْنَ الْأَجْنَبِيِّ
u'بَيْنٌ أَجْنَبِيٌّ':Added, #1: 1	بَيْنَ أَجْنَبِيٍّ
u'بَيْنٌ أَجْنَبِيٌّ':Added, #1: 1	بَيْنَ أَجْنَبِيَّةٍ
u'بَيْنٌ أَجْنَبِيٌّ':Added, #1: 1	بَيْنِ أَجْنَبِيَّةٍ
u'بَيْنٌ أَجْنَبِيٌّ':Added, #2: 2	بَيْنَ الْأَجْنَبِيَّيْنِ
u'بَيْنٌ أَجْنَبِيٌّ':Added, #3: 3	بَيْنَ أَجْنَبِيَّيْنِ
u'بَيْنٌ أَجْنَبِيٌّ':Added, #3: 3	بَيْنَ الْأَجْنَبِيَّاتِ
u'بَيْنٌ أَجِيرٌ':Added, #4: 4	بَيْنَ الْأَجْنَبِيَّةِ
u'بَيْنٌ آحَادٌ':Added, #2: 2	بَيْنَ الْأَجِيرِ
u'بَيْنٌ آحَادٌ':Added, #2: 2	بَيْنَ آحَادِهِ
u'بَيْنٌ أَحادِيثُ':Added, #3: 3	بَيْنَ آحَادِ
u'بَيْنٌ أَحادِيثُ':Added, #14: 14	بَيْنَ الْأَحَادِيثِ
u'بَيْنٌ إِحالَةٌ':Added, #1: 1	بَيْنَ أَحَادِيثِ
u'بَيْنٌ أَحْبابٌ':Added, #1: 1	بَيْنَ إحَالَةِ
u'بَيْنٌ أَحِبَّةٌ':Added, #1: 1	بَيْنَ أَحْبَابِهِ
u'بَيْنٌ اِحْتِمَالٌ':Added, #5: 5	بَيْنَ الْأَحِبَّةِ
u'بَيْنٌ اِحْتِمَالٌ':Added, #1: 1	بَيْنَ احْتِمَالَاتٍ
u'بَيْنٌ أَحْجارٌ':Added, #3: 3	بَيْنَ احْتِمَالِ
u'بَيْنٌ أَحْجارٌ':Added, #1: 1	بَيْنِ أَحْجَارٍ
u'بَيْنٌ أَحْجارٌ':Added, #1: 1	بَيْنَ الْأَحْجَارِ
u'بَيْنٌ أحَدٌ':Added, #2: 2	بَيْنَ أَحْجَارٍ
u'بَيْنٌ أحَدٌ':Added, #5: 5	بَيْنَ أَحَدِ
u'بَيْنٌ إِحْدَاثٌ':Added, #9: 9	بَيْنَ أَحَدٍ
u'بَيْنٌ أَحْرارٌ':Added, #1: 1	بَيْنَ إحْدَاثِ
u'بَيْنٌ أَحْرازٌ':Added, #3: 3	بَيْنَ الْأَحْرَارِ
u'بَيْنٌ إِحْرَامٌ':Added, #1: 1	بَيْنَ الْأَحْرَازِ
u'بَيْنٌ إِحْرَامٌ':Added, #12: 12	بَيْنَ الْإِحْرَامَيْنِ
u'بَيْنٌ إِحْرَامٌ':Added, #1: 1	بَيْنَ الإِحْرَامِ
u'بَيْنٌ إِحْرَامٌ':Added, #3: 3	بَيْنَ إحْرَامَيْنِ
u'بَيْنٌ إِحْرَامٌ':Added, #6: 6	بَيْنَ الْإِحْرَامِ
u'بَيْنٌ أَحْرُفٌ':Added, #9: 9	بَيْنَ إحْرَامِ
u'بَيَّنَ أَحْكَامٌ':Predicate, #1: 1	بَيْنَ الْأَحْرُفِ
u'بَيْنٌ أَحْكَامٌ':Added, #3: 3	بَيَّنَ أَحْكَامَ
u'بَيْنٌ أَحْكَامٌ':Added, #1: 1	بَيْنَ أَحْكَامِ
u'بَيْنٌ أَحْكَامٌ':Added, #1: 1	بَيْنِ الْأَحْكَامِ
u'بَيْنٌ أحْمَالٌ':Added, #3: 3	بَيْنَ الْأَحْكَامِ
u'بَيْنٌ أَحْمَالٌ':Added, #1: 1	بَيْنَ الْأَحْمَالِ
u'بَيْنٌ أَحْوالٌ':Added, #1: 1	بَيْنَ الْأَحْمَالِ
u'بَيْنٌ أحْوَالٌ':Added, #2: 2	بَيْنَ الْأَحْوَالِ
u'بَيْنٌ إِحْيَاءٌ':Added, #2: 2	بَيْنَ الْأَحْوَالِ
u'بَيْنٌ أَحْيَاءٌ':Added, #1: 1	بَيْنَ إحْيَاءِ
u'بَيْنٌ أَخٌ':Added, #1: 1	بَيْنَ الْأَحْيَاءِ
u'بَيْنٌ أَخٌ':Added, #19: 19	بَيْنَ الْأَخِ
u'بَيْنٌ أخْبَارٌ':Added, #3: 3	بَيْنَ الأَخِ
u'بَيْنٌ أَخْبَارٌ':Added, #1: 1	بَيْنَ الأَخْبَارِ
u'بَيْنٌ إِخْبَارٌ':Added, #1: 1	بَيْنَ الأَخْبَارِ
u'بَيْنٌ أخْبَارٌ':Added, #1: 1	بَيْنَ الْإِخْبَارِ
u'بَيْنٌ أَخْبَارٌ':Added, #22: 22	بَيْنَ الْأَخْبَارِ
u'بَيْنٌ أخْبَارٌ':Added, #22: 22	بَيْنَ الْأَخْبَارِ
u'بَيْنٌ أَخْبَارٌ':Added, #2: 2	بَيْنَ أَخْبَارِ
u'بَيْنٌ أُخْتٌ':Added, #2: 2	بَيْنَ أَخْبَارِ
u'بَيْنٌ أُخْتٌ':Added, #13: 13	بَيْنَ أُخْتَيْنِ
u'بَيْنٌ أُخْتٌ':Added, #1: 1	بَيْن أُخْتَيْنِ
u'بَيْنٌ أُخْتٌ':Added, #1: 1	بَيْنَ الأُخْتِ
u'بَيْنٌ أُخْتٌ':Added, #1: 1	بَيْنَ الْأُخْتِ
u'بَيْنٌ أُخْتٌ':Added, #6: 6	بَيْنَ الأُخْتَيْنِ
u'بَيْنٌ اِخْتِصَاصٌ':Added, #93: 93	بَيْنَ الْأُخْتَيْنِ
u'بَيْنٌ اِخْتِصَامٌ':Added, #1: 1	بَيْنَ اخْتِصَاصِ
u'بَيْنٌ اِخْتِلاَفٌ':Added, #1: 1	بَيْنَ اخْتِصَامِهِ
u'بَيَّنَ اِخْتِيَارٌ':Predicate, #3: 3	بَيْنَ اخْتِلَافِ
u'بَيْنٌ أخْذٌ':Added, #1: 1	بَيَّنَ اخْتِيَارَ
u'بَيْنٌ أخْذٌ':Added, #20: 20	بَيْنَ الْأَخْذِ
u'بَيْنٌ أخْذٌ':Added, #25: 25	بَيْنَ أَخْذِ
u'بَيْنٌ آخِرُ':Added, #26: 26	بَيْنَ أَخْذِهِ
u'بَيْنٌ إِخْرَاجٌ':Added, #2: 2	بَيْنَ آخِرِ
u'بَيْنٌ إِخْرَاجٌ':Added, #1: 1	بَيْنَ إخْرَاجِهِ
u'بَيْنٌ إِخْرَاجٌ':Added, #2: 2	بَيْنَ الْإِخْرَاجِ
u'بَيْنٌ آخِرَةٌ':Added, #4: 4	بَيْنَ إخْرَاجِ
u'بَيْنٌ أُخْرَى':Added, #1: 1	بَيْنَ الْآخِرَةِ
u'بَيْنٌ أُخْرَى':Added, #1: 1	بَيْنَ الأُخْرَيَيْنِ
u'بَيْنٌ أَخْضَر':Added, #3: 3	بَيْنَ الْأُخْرَيَيْنِ
u'بَيْنٌ أَخَوَاتٌ':Added, #3: 3	بَيْنَ الْأَخْضَرَيْنِ
u'بَيْنٌ أَخَوَاتٌ':Added, #1: 1	بَيْنَ الأَخَوَاتِ
u'بَيْنٌ إِخْوَةٌ':Added, #2: 2	بَيْنَ الْأَخَوَاتِ
u'بَيْنٌ إِخْوَةٌ':Added, #10: 10	بَيْنَ الْإِخْوَةِ
u'بَيْنٌ أَخِيرٌ':Added, #8: 8	بَيْنَ الإِخْوَةِ
u'بَيْنٌ أَخِيرٌ':Added, #1: 1	بَيْنَ الْأَخِيرِ
u'بَيْنٌ أَخِيرٌ':Added, #1: 1	بَيْنَ الْأَخِيرَتَيْنِ
u'بَيْنٌ أَدَاءٌ':Added, #2: 2	بَيْنَ الْأَخِيرَيْنِ
u'بَيْنٌ أَدَاءٌ':Added, #11: 11	بَيْنَ الْأَدَاءِ
u'بَيْنٌ أَدَاءٌ':Added, #1: 1	بَيْن أَدَاءِ
u'بَيْنٌ أَدَاءٌ':Added, #1: 1	بَيْنَ الْأَدَاءَيْنِ
u'بَيْنٌ أدَب':Added, #9: 9	بَيْنَ أَدَاءِ
u'بَيْنٌ إدْخَالٌ':Added, #1: 1	بَيْنَ الْأَدَبِ
u'بَيْنٌ إدْخَالٌ':Added, #1: 1	بَيْنَ إدْخَالِ
u'بَيْنٌ إِدْرَاكٌ':Added, #1: 1	بَيْنَ إدْخَالِهِ
u'بَيْنٌ إِدْرَاكٌ':Added, #1: 1	بَيْنَ إدْرَاكِ
u'بَيْنٌ آدَمِيٌّ':Added, #1: 1	بَيْنَ إدْرَاكِهِ
u'بَيْنٌ آدَمِيٌّ':Added, #1: 1	بَيْنَ آدَمِيٍّ
u'بَيْنٌ أَدَوَاتٌ':Added, #5: 5	بَيْنَ الْآدَمِيِّ
u'بَيْنٌ أَدَوَاتٌ':Added, #1: 1	بَيْنَ أَدَوَاتِ
u'بَيْنٌ أَذَانٌ':Added, #1: 1	بَيْنَ الْأَدَوَاتِ
u'بَيْنٌ آذَانٌ':Added, #13: 13	بَيْنَ الأَذَانِ
u'بَيْنٌ أَذَانٌ':Added, #1: 1	بَيْنَ آذَانِ
u'بَيْنٌ أَذَانٌ':Added, #1: 1	بَيْنَ أَذَانٍ
u'بَيْنٌ آذَانٌ':Added, #1: 1	بَيْنَ أَذَانَيْنِ
u'بَيْنٌ أَذَانٌ':Added, #1: 1	بَيْنَ الْآذَانِ
u'بَيْنٌ أَذَانٌ':Added, #35: 35	بَيْنَ الْأَذَانِ
u'بَيْنٌ أَذَانٌ':Added, #3: 3	بَيْنَ الْأَذَانَيْنِ
u'بَيْنٌ إِذْنٌ':Added, #7: 7	بَيْنَ أَذَانِ
u'بَيْنٌ إِذْنٌ':Added, #1: 1	بَيْنَ إذْنِ
u'بَيْنٌ إِرَادَةٌ':Added, #2: 2	بَيْنَ الْإِذْنِ
u'بَيْنٌ إِرَادَةٌ':Added, #1: 1	بَيْنَ إرَادَتِهِ
u'بَيْنٌ إِرَادَةٌ':Added, #2: 2	بَيْنَ إرَادَةِ
u'بَيْنٌ إِرَاقَةٌ':Added, #2: 2	بَيْنَ الْإِرَادَةِ
u'بَيْنٌ أرْبَابٌ':Added, #2: 2	بَيْنَ إرَاقَةِ
u'بَيْنٌ أرْبَابٌ':Added, #10: 10	بَيْنَ أَرْبَابِ
u'بَيْنٌ أَرْبَعُ':Added, #2: 2	بَيْنَ أَرْبَابِهِ
u'بَيْنٌ أَرْبَعُ':Added, #12: 12	بَيْنَ الْأَرْبَعِ
u'بَيْنٌ أَرْبَعَةٌ':Added, #1: 1	بَيْنَ أَرْبَعِ
u'بَيْنٌ أَرْبَعَةٌ':Added, #1: 1	بَيْنِ أَرْبَعَةٍ
u'بَيْنٌ أَرْبَعَةٌ':Added, #5: 5	بَيْنَ أَرْبَعَةٍ
u'بَيْنٌ أَرْبَعَةٌ':Added, #6: 6	بَيْنَ الْأَرْبَعَةِ
u'بَيْنٌ اِرْتِفَاعٌ':Added, #9: 9	بَيْنَ أَرْبَعَةِ
u'بَيْنٌ إِرْثٌ':Added, #1: 1	بَيْنَ ارْتِفَاعِ
u'بَيْنٌ إِرْثٌ':Added, #1: 1	بَيْنَ إرْثِ
u'بَيْنٌ إِرْسَالٌ':Added, #3: 3	بَيْنَ الْإِرْثِ
u'بَيْنٌ إِرْسَالٌ':Added, #1: 1	بَيْنَ الْإِرْسَالَيْنِ
u'بَيْنٌ أَرْصادٌ':Added, #4: 4	بَيْنَ الْإِرْسَالِ
u'بَيْنٌ أَرْصَادٌ':Added, #1: 1	بَيْن الْأَرْصَادِ
u'بَيَّنَ أرْضٌ':Predicate, #1: 1	بَيْن الْأَرْصَادِ
u'بَيْنٌ أرْضٌ':Added, #1: 1	بَيَّنَ الْأَرْضَ
u'بَيْنٌ أرْضٌ':Added, #1: 1	بَيْنَ أَرْضِهِ
u'بَيْنٌ أرْضٌ':Added, #1: 1	بَيْن أَرْضَيْنِ
u'بَيْنٌ أرْضٌ':Added, #1: 1	بَيْنَ أَرْضَيْنِ
u'بَيْنٌ أرْضٌ':Added, #1: 1	بَيْنَ الأَرْضِ
u'بَيْنٌ أرْضٌ':Added, #1: 1	بَيْنَ الأَرْضَيْنِ
u'بَيْنٌ أرْضٌ':Added, #21: 21	بَيْنَ الْأَرْضِ
u'بَيْنٌ أرْضٌ':Added, #2: 2	بَيْنَ أَرْضِ
u'بَيَّنَ أَرْكانٌ':Predicate, #3: 3	بَيْنَ الْأَرْضَيْنِ
u'بَيَّنَ أَرْكَانٌ':Predicate, #1: 1	بَيَّنَ أَرْكَانَ
u'بَيْنٌ أَرْكانٌ':Added, #1: 1	بَيَّنَ أَرْكَانَ
u'بَيْنٌ أَرْكَانٌ':Added, #3: 3	بَيْنَ الْأَرْكَانِ
u'بَيْنٌ إِزَارٌ':Added, #3: 3	بَيْنَ الْأَرْكَانِ
u'بَيْنٌ إِزَالَةٌ':Added, #1: 1	بَيْنَ إزَارِ
u'بَيْنٌ إِزَالَةٌ':Added, #1: 1	بَيْنَ إزَالَتِهِ
u'بَيْنٌ أَزْمانٌ':Added, #2: 2	بَيْنَ إزَالَةِ
u'بَيْنٌ أَزْمِنَةٌ':Added, #1: 1	بَيْن أَزْمَانِ
u'بَيْنٌ أَزْواجٌ':Added, #1: 1	بَيْنَ أَزْمِنَةِ
u'بَيْنٌ أَزْواجٌ':Added, #1: 1	بَيْنَ الأَزْوَاجِ
u'بَيْنٌ أَزْواجٌ':Added, #1: 1	بَيْنَ الْأَزْوَاجِ
u'بَيْنٌ أَسَابِيعُ':Added, #5: 5	بَيْنَ أَزْوَاجِهِ
u'بَيْنٌ أَساطِينُ':Added, #1: 1	بَيْنَ الأَسَابِيعِ
u'بَيْنٌ أسَاطِينُ':Added, #2: 2	بَيْنَ الأَسَاطِينِ
u'بَيْنٌ أَساطِينُ':Added, #2: 2	بَيْنَ الأَسَاطِينِ
u'بَيْنٌ أسَاطِينُ':Added, #4: 4	بَيْنَ الْأَسَاطِينِ
u'بَيْنٌ أسْبَابٌ':Added, #4: 4	بَيْنَ الْأَسَاطِينِ
u'بَيْنٌ أَسْبَابٌ':Added, #1: 1	بَيْنَ الْأَسْبَابِ
u'بَيْنٌ أُسْبُوعٌ':Added, #1: 1	بَيْنَ الْأَسْبَابِ
u'بَيْنٌ أُسْبُوعٌ':Added, #1: 1	بَيْنَ الْأُسْبُوعَيْنِ
u'بَيْنٌ اِسْتِثْنَاءٌ':Added, #5: 5	بَيْنَ أُسْبُوعَيْنِ
u'بَيْنٌ اِسْتِحَالَةٌ':Added, #1: 1	بَيْنَ اسْتِثْنَاءِ
u'بَيْنٌ اِسْتِحْضَارٌ':Added, #1: 1	بَيْنَ اسْتِحَالَتِهِ
u'بَيْنٌ اِسْتِحْقَاقٌ':Added, #1: 1	بَيْنَ اسْتِحْضَارِ
u'بَيْنٌ اِسْتِحْقَاقٌ':Added, #1: 1	بَيْن اسْتِحْقَاقِ
u'بَيْنٌ اِسْتِحْقَاقٌ':Added, #1: 1	بَيْنَ اسْتِحْقَاقِهِ
u'بَيْنٌ اِسْتِدَانَةٌ':Added, #3: 3	بَيْنَ اسْتِحْقَاقِ
u'بَيْنٌ اِسْتِرْجَاعٌ':Added, #1: 1	بَيْنَ اسْتِدَانَتِهِ
u'بَيْنٌ اِسْتِعْمالٌ':Added, #1: 1	بَيْنَ اسْتِرْجَاعِهِ
u'بَيْنٌ اِسْتِعْمالٌ':Added, #1: 1	بَيْنَ اسْتِعْمَالِ
u'بَيْنٌ اِسْتِقْبالٌ':Added, #1: 1	بَيْنَ اسْتِعْمَالِهِ
u'بَيْنٌ اِسْتِئْجَارٌ':Added, #1: 1	بَيْنَ اسْتِقْبَالِ
u'بَيْنٌ اِسْتِئْنَافٌ':Added, #2: 2	بَيْنَ اسْتِئْجَارِ
u'بَيْنٌ اِسْتِيلاد':Added, #1: 1	بَيْنَ اسْتِئْنَافِهِ
u'بَيْنٌ أَسَدٌ':Added, #1: 1	بَيْنَ اسْتِيلَادِ
u'بَيْنٌ إِسْرافٌ':Added, #1: 1	بَيْنَ أَسَدٍ
u'بَيْنٌ إِسْفَنْجٌ':Added, #3: 3	بَيْنَ الْإِسْرَافِ
u'بَيْنٌ إِسْقاطٌ':Added, #1: 1	بَيْنَ الْإِسْفَنْجِ
u'بَيْنٌ إِسْقاطٌ':Added, #1: 1	بَيْنَ الْإِسْقَاطِ
u'بَيْنٌ إِسْلامٌ':Added, #1: 1	بَيْنَ الْإِسْقَاطَيْنِ
u'بَيْنٌ إِسْلامٌ':Added, #1: 1	بَيْنَ إِسْلاَمِ
u'بَيْنٌ إِسْلامٌ':Added, #1: 1	بَيْنَ إسْلَامِهِ
u'بَيْنٌ إِسْلامٌ':Added, #2: 2	بَيْنَ إسْلَامٍ
u'بَيْنٌ اِسْمٌ':Added, #6: 6	بَيْنَ الْإِسْلَامِ
u'بَيْنٌ اِسْمٌ':Added, #1: 1	بَيْنَ اسْمِهِ
u'بَيْنٌ اِسْمٌ':Added, #4: 4	بَيْنَ اسْمَيْنِ
u'بَيْنٌ أَسْماءٌ':Added, #6: 6	بَيْنَ اسْمِ
u'بَيْنٌ أَسْماءٌ':Added, #1: 1	بَيْنِ أَسْمَاءِ
u'بَيْنٌ أَسْماءٌ':Added, #3: 3	بَيْنَ الْأَسْمَاءِ
u'بَيْنٌ إِسْنادٌ':Added, #5: 5	بَيْنَ أَسْمَاءِ
u'بَيْنٌ أسْنَانٌ':Added, #1: 1	بَيْنَ إسْنَادِ
u'بَيْنٌ أسْنَانٌ':Added, #15: 15	بَيْنَ الْأَسْنَانِ
u'بَيْنٌ أسْنَانٌ':Added, #1: 1	بَيْن أَسْنَانِ
u'بَيْنٌ أسْنَانٌ':Added, #1: 1	بَيْنَ الأَسْنَانِ
u'بَيْنٌ أسْنَانٌ':Added, #2: 2	بَيْنَ أَسْنَانِ
u'بَيْنٌ أسْنَانٌ':Added, #43: 43	بَيْنَ أَسْنَانِهِ
u'بَيْنٌ أسِنَّةٌ':Added, #9: 9	بَيْنِ أَسْنَانِهِ
u'بَيْنٌ أَسْواطٌ':Added, #2: 2	بَيْنَ الْأَسِنَّةِ
u'بَيْنٌ أسْوَد':Added, #1: 1	بَيْنَ أَسْوَاطِ
u'بَيْنٌ أسْوَد':Added, #1: 1	بَيْنَ أَسْوَدِهِ
u'بَيْنٌ أسْوَد':Added, #1: 1	بَيْنَ أَسْوَدَيْنِ
u'بَيْنٌ أسْئِلَةٌ':Added, #1: 1	بَيْنَ الْأَسْوَدَيْنِ
u'بَيْنٌ أسْئِلَةٌ':Added, #1: 1	بَيْنَ أَسْئِلَةٍ
u'بَيْنٌ أَسيرٌ':Added, #1: 1	بَيْنَ أَسْئِلَةِ
u'بَيْنٌ إشارَة':Added, #2: 2	بَيْنَ الْأَسِيرِ
u'بَيْنٌ إشاعَةٌ':Added, #8: 8	بَيْنَ الْإِشَارَةِ
u'بَيْنٌ إِشْباعٌ':Added, #2: 2	بَيْنَ الْإِشَاعَةِ
u'بَيْنٌ اِشْتِباهٌ':Added, #1: 1	بَيْنَ إشْبَاعِ
u'بَيْنٌ اِشْتِراطٌ':Added, #1: 1	بَيْنَ اشْتِبَاهِ
u'بَيْنٌ أَشْجَارٌ':Added, #1: 1	بَيْنَ اشْتِرَاطِ
u'بَيْنٌ أَشْجَارٌ':Added, #2: 2	بَيْنَ أَشْجَارٍ
u'بَيْنٌ أَشْخَاصٌ':Added, #3: 3	بَيْنَ الْأَشْجَارِ
u'بَيْنٌ أَشَدُّ':Added, #1: 1	بَيْنَ الْأَشْخَاصِ
u'بَيْنٌ أَشْفَاعٌ':Added, #2: 2	بَيْنَ أَشَدِّ
u'بَيْنٌ أَشْفَاعٌ':Added, #1: 1	بَيْنَ أَشْفَاعٍ
u'بَيْنٌ أَشْكَالٌ':Added, #1: 1	بَيْنَ الْأَشْفَاعِ
u'بَيْنٌ أَشْوَاطٌ':Added, #2: 2	بَيْنَ أَشْكَالِهِ
u'بَيْنٌ أَشْوَاطٌ':Added, #1: 1	بَيْنَ أَشْوَاطِهِ
u'بَيْنٌ أَشْيَاءٌ':Added, #1: 1	بَيْنَ الْأَشْوَاطِ
u'بَيْنٌ أَصابِعُ':Added, #15: 15	بَيْنَ الْأَشْيَاءِ
u'بَيْنٌ أَصابِعُ':Added, #12: 12	بَيْنَ أَصَابِعِ
u'بَيْنٌ أَصابِعُ':Added, #13: 13	بَيْنَ الْأَصَابِعِ
u'بَيْنٌ أَصابِعُ':Added, #22: 22	بَيْنِ أَصَابِعِهِ
u'بَيْنٌ أَصابِعُ':Added, #2: 2	بَيْنِ أَصَابِعِ
u'بَيْنٌ أَصابِعُ':Added, #3: 3	بَيْنَ الأَصَابِعِ
u'بَيْنٌ أَصالَةٌ':Added, #46: 46	بَيْنَ أَصَابِعِهِ
u'بَيْنٌ إِصْبَعٌ':Added, #1: 1	بَيْنَ أَصَالَتِهِ
u'بَيْنٌ أُصْبُعٌ':Added, #1: 1	بَيْنَ الْإِصْبَعِ
u'بَيَّنَ أَصْحَابٌ':Subject, #7: 7	بَيْنَ أُصْبُعَيْنِ
u'بَيَّنَ أَصْحَابٌ':Subject, #1: 1	بَيَّنَ أَصْحَابُ
u'بَيْنٌ أَصْحَابٌ':Added, #1: 1	بَيَّنَ أَصْحَابُهُ
u'بَيْنٌ أَصْحَابٌ':Added, #10: 10	بَيْنَ أَصْحَابِ
u'بَيْنٌ أَصْحَابٌ':Added, #26: 26	بَيْنَ أَصْحَابِهِ
u'بَيْنٌ أَصْحَابٌ':Added, #3: 3	بَيْنِ أَصْحَابِهِ
u'بَيْنٌ أَصْحَابٌ':Added, #4: 4	بَيْنِ أَصْحَابِ
u'بَيْنٌ أصْغَرٌ':Added, #54: 54	بَيْنَ الْأَصْحَابِ
u'بَيْنٌ أَصْغَرُ':Added, #2: 2	بَيْنَ الْأَصْغَرِ
u'بَيَّنَ أصل':Subject, #2: 2	بَيْنَ الْأَصْغَرِ
u'بَيَّنَ أًصْلٌ':Subject, #1: 1	بَيَّنَ الْأَصْلُ
u'بَيْنٌ أًصْلٌ':Added, #1: 1	بَيَّنَ الْأَصْلُ
u'بَيْنٌ أًصْلٌ':Added, #23: 23	بَيْنَ أَصْلَيْنِ
u'بَيْنٌ أصل':Added, #2: 2	بَيْن أَصْلَيْنِ
u'بَيْنٌ أًصْلٌ':Added, #4: 4	بَيْنَ أَصْلِ
u'بَيْنٌ أًصْلٌ':Added, #4: 4	بَيْنَ أَصْلٍ
u'بَيْنٌ أصل':Added, #4: 4	بَيْنَ أَصْلِ
u'بَيْنٌ أًصْلٌ':Added, #58: 58	بَيْنَ الْأَصْلِ
u'بَيَّنَ إِصْلاحٌ':Predicate, #58: 58	بَيْنَ الْأَصْلِ
u'بَيْنٌ أَصْلَحُ':Added, #1: 1	بَيَّنَ إصْلَاحَ
u'بَيْنٌ أَصْلِيٌّ':Added, #1: 1	بَيْنَ الْأَصْلَحِ
u'بَيْنٌ أَصْلِيٌّ':Added, #1: 1	بَيْنَ أَصْلِيٍّ
u'بَيْنٌ أَصْلِيٌّ':Added, #1: 1	بَيْنَ أَصْلِيِّ
u'بَيْنٌ أَصَمّ':Added, #5: 5	بَيْنَ الْأَصْلِيِّ
u'بَيْنٌ أَصْنَافٌ':Added, #1: 1	بَيْنَ الْأَصَمِّ
u'بَيْنٌ أَصْنَافٌ':Added, #1: 1	بَيْنَ أَصْنَافِ
u'بَيْنٌ أَصْهَارٌ':Added, #7: 7	بَيْنَ الْأَصْنَافِ
u'بَيْنٌ أُصولٌ':Added, #1: 1	بَيْنَ الْأَصْهَارِ
u'بَيْنٌ أُصولٌ':Added, #1: 1	بَيْنَ أُصُولِ
u'بَيْنٌ أَصيلٌ':Added, #2: 2	بَيْنَ الْأُصُولِ
u'بَيْنٌ إضافَةٌ':Added, #1: 1	بَيْنَ أَصِيلَيْنِ
u'بَيْنٌ أَضْدادٌ':Added, #5: 5	بَيْنَ الْإِضَافَةِ
u'بَيْنٌ أَضْدَادٌ':Added, #1: 1	بَيْنَ الْأَضْدَادِ
u'بَيْنٌ اِضْطِرابٌ':Added, #1: 1	بَيْنَ الْأَضْدَادِ
u'بَيْنٌ أَضْعَافٌ':Added, #1: 1	بَيْنَ اضْطِرَابِ
u'بَيْنٌ أَضْلاَعٌ':Added, #4: 4	بَيْنَ أَضْعَافِ
u'بَيْنٌ إضْمارٌ':Added, #1: 1	بَيْنَ الْأَضْلَاعِ
u'بَيْنٌ إِطارٌ':Added, #2: 2	بَيْنَ الْإِضْمَارِ
u'بَيْنٌ أَطْرافٌ':Added, #1: 1	بَيْنَ إطَارِ
u'بَيْنٌ أَطْرَافٌ':Added, #1: 1	بَيْنِ أَطْرَافِ
u'بَيْنٌ أَطْرافٌ':Added, #1: 1	بَيْنِ أَطْرَافِ
u'بَيْنٌ أَطْرَافٌ':Added, #5: 5	بَيْنَ أَطْرَافِ
u'بَيْنٌ إِطْعامٌ':Added, #5: 5	بَيْنَ أَطْرَافِ
u'بَيْنٌ إِطْعامٌ':Added, #1: 1	بَيْنَ الإِطْعَامِ
u'بَيْنٌ إِطْعامٌ':Added, #3: 3	بَيْنَ إطْعَامِ
u'بَيْنٌ أَطْعِمَةٌ':Added, #6: 6	بَيْنَ الْإِطْعَامِ
u'بَيْنٌ اِطِّلاعٌ':Added, #1: 1	بَيْنَ الْأَطْعِمَةِ
u'بَيْنٌ إِطْلاقٌ':Added, #1: 1	بَيْنَ اطِّلَاعِ
u'بَيْنٌ إِطْلاقٌ':Added, #1: 1	بَيْن إطْلَاقِ
u'بَيْنٌ إِطْلاقٌ':Added, #1: 1	بَيْنَ الْإِطْلَاقِ
u'بَيْنٌ إِطْلاقٌ':Added, #1: 1	بَيْنَ الْإِطْلَاقَيْنِ
u'بَيْنٌ إِطْلاقٌ':Added, #2: 2	بَيْنَ إطْلَاقِهِ
u'بَيْنٌ أَطْهَارٌ':Added, #5: 5	بَيْنَ إطْلَاقِ
u'بَيْنٌ أَظافِرُ':Added, #1: 1	بَيْنَ الْأَطْهَارِ
u'بَيْنٌ إِظْهارٌ':Added, #1: 1	بَيْنِ الْأَظَافِرِ
u'بَيْنٌ أظهر':Added, #1: 1	بَيْنَ إظْهَارِهِ
u'بَيْنٌ أظهر':Added, #1: 1	بَيْنِ أَظْهَرِ
u'بَيْنٌ أظهر':Added, #1: 1	بَيْنِ أَظْهُرِ
u'بَيْنٌ إِعادَةٌ':Added, #6: 6	بَيْنَ أَظْهُرِ
u'بَيْنٌ إِعانَةٌ':Added, #2: 2	بَيْنَ الْإِعَادَةِ
u'بَيْنٌ إِعْتاقٌ':Added, #1: 1	بَيْنَ الْإِعَانَةِ
u'بَيْنٌ إِعْتاقٌ':Added, #1: 1	بَيْنَ إعْتَاقِ
u'بَيْنٌ اِعْتِبارٌ':Added, #6: 6	بَيْنَ الْإِعْتَاقِ
u'بَيْنٌ اِعْتِقادٌ':Added, #3: 3	بَيْنَ اعْتِبَارِ
u'بَيْنٌ أَعْجَميٌّ':Added, #1: 1	بَيْنَ اعْتِقَادِ
u'بَيْنٌ أَعْدَاءٌ':Added, #1: 1	بَيْنَ الْأَعْجَمِيِّ
u'بَيْنٌ أعداد':Added, #2: 2	بَيْنَ أَعْدَاءِ
u'بَيْنٌ أَعْدَادٌ':Added, #1: 1	بَيْنَ أَعْدَادِ
u'بَيْنٌ أعداد':Added, #1: 1	بَيْنَ أَعْدَادِ
u'بَيْنٌ أَعْدَادٌ':Added, #4: 4	بَيْنَ الْأَعْدَادِ
u'بَيْنٌ أَعْذَارٌ':Added, #4: 4	بَيْنَ الْأَعْدَادِ
u'بَيْنٌ إِعْرابٌ':Added, #2: 2	بَيْنَ الْأَعْذَارِ
u'بَيْنٌ إعْرَاضٌ':Added, #1: 1	بَيْنَ إعْرَابٍ
u'بَيْنٌ أَعْضَاءٌ':Added, #1: 1	بَيْنَ الْإِعْرَاضِ
u'بَيْنٌ إعْطَاءٌ':Added, #1: 1	بَيْنَ أَعْضَاءِ
u'بَيْنٌ إعْطَاءٌ':Added, #1: 1	بَيْن إعْطَاءِ
u'بَيْنٌ إعْطَاءٌ':Added, #1: 1	بَيْنَ الْإِعْطَاءِ
u'بَيْنٌ أَعْلاَجٌ':Added, #4: 4	بَيْنَ إعْطَاءِ
u'بَيْنٌ أَعْلاَمٌ':Added, #1: 1	بَيْنَ أَعْلَاجٍ
u'بَيْنٌ أَعَمُّ':Added, #1: 1	بَيْنَ الْأَعْلَامِ
u'بَيْنٌ أَعْمَالٌ':Added, #2: 2	بَيْنَ الْأَعَمِّ
u'بَيْنٌ أعْمَش':Added, #1: 1	بَيْنَ أَعْمَالِ
u'بَيْنٌ أعْمى':Added, #1: 1	بَيْنَ الْأَعْمَشِ
u'بَيْنٌ أعْيانٌ':Added, #2: 2	بَيْنَ الْأَعْمَيَيْنِ
u'بَيْنٌ أعْيانٌ':Added, #1: 1	بَيْنَ أَعْيَانٍ
u'بَيْنٌ أَعْيَانٌ':Added, #1: 1	بَيْنَ أَعْيَانِ
u'بَيْنٌ أَعْيَانٌ':Added, #1: 1	بَيْنَ أَعْيَانٍ
u'بَيْنٌ أعْيانٌ':Added, #1: 1	بَيْنَ أَعْيَانِ
u'بَيْنٌ أَعْيَانٌ':Added, #4: 4	بَيْنَ الْأَعْيَانِ
u'بَيْنٌ اِغْتِفارٌ':Added, #4: 4	بَيْنَ الْأَعْيَانِ
u'بَيْنٌ أَغْرَاضٌ':Added, #1: 1	بَيْن اغْتِفَارِ
u'بَيْنٌ أَغْرَاضٌ':Added, #1: 1	بَيْنَ الْأَغْرَاضِ
u'بَيْنٌ أَغْصَانٌ':Added, #2: 2	بَيْنَ الأَغْرَاضِ
u'بَيْنٌ أَغْنِيَاء':Added, #1: 1	بَيْنَ أَغْصَانِ
u'بَيْنٌ أَغْنِيَاء':Added, #1: 1	بَيْنَ الأَغْنِيَاءِ
u'بَيْنٌ اِفْتِرَاشٌ':Added, #7: 7	بَيْنَ الْأَغْنِيَاءِ
u'بَيْنٌ أَفْخَاذٌ':Added, #1: 1	بَيْنَ افْتِرَاشِ
u'بَيْنٌ أَفْرَادٌ':Added, #1: 1	بَيْنِ أَفْخَاذِ
u'بَيْنٌ إِفْرَادٌ':Added, #1: 1	بَيْنَ أَفْرَادِ
u'بَيْنٌ أَفْرَادٌ':Added, #1: 1	بَيْنَ الْإِفْرَادِ
u'بَيْنٌ أَفْرَادٌ':Added, #2: 2	بَيْنَ أَفْرَادِهِ
u'بَيْنٌ إِفْرَاطٌ':Added, #2: 2	بَيْنَ الْأَفْرَادِ
u'بَيَّنَ أفْضَلُ':Predicate, #1: 1	بَيْنَ إفْرَاطِ
u'بَيَّنَ أفْضَلُ':Predicate, #1: 1	بَيَّنَ أَفْضَلَ
u'بَيْنٌ أفْضَلُ':Added, #2: 2	بَيَّنَ الْأَفْضَلَ
u'بَيْنٌ أفْضَلِيَّةٌ':Added, #2: 2	بَيْنَ أَفْضَلِ
u'بَيْنٌ أَفْعَالٌ':Added, #1: 1	بَيْنَ أَفْضَلِيَّةِ
u'بَيْنٌ أَفْعَالٌ':Added, #1: 1	بَيْنَ أَفْعَالٍ
u'بَيْنٌ أَفْعَالٌ':Added, #1: 1	بَيْنَ أَفْعَالِهِ
u'بَيْنٌ أَفْعَالٌ':Added, #1: 1	بَيْنِ أَفْعَالِهِ
u'بَيْنٌ أقارب':Added, #2: 2	بَيْنَ الْأَفْعَالِ
u'بَيْنٌ إقامَةٌ':Added, #6: 6	بَيْنَ الْأَقَارِبِ
u'بَيْنٌ إقامَةٌ':Added, #1: 1	بَيْنَ إقَامَتِهِ
u'بَيْنٌ إقامَةٌ':Added, #4: 4	بَيْنَ إقَامَةِ
u'بَيْنٌ أَقَاوِيلُ':Added, #7: 7	بَيْنَ الْإِقَامَةِ
u'بَيْنٌ أَقْبِيَةٌ':Added, #1: 1	بَيْنَ الْأَقَاوِيلِ
u'بَيْنٌ اِقْتِران':Added, #1: 1	بَيْنَ الْأَقْبِيَةِ
u'بَيْنٌ أَقْحَافٌ':Added, #1: 1	بَيْنَ اقْتِرَانِ
u'بَيْنٌ أَقْدَامٌ':Added, #1: 1	بَيْنَ أَقْحَافٍ
u'بَيْنٌ إقْرَارٌ':Added, #1: 1	بَيْنَ الْأَقْدَامِ
u'بَيْنٌ إقْرَارٌ':Added, #13: 13	بَيْنَ الْإِقْرَارِ
u'بَيْنٌ إقْرَارٌ':Added, #1: 1	بَيْنَ إقْرَارٍ
u'بَيْنٌ إقْرَارٌ':Added, #2: 2	بَيْنَ إقْرَارِ
u'بَيْنٌ إقْرَارٌ':Added, #2: 2	بَيْنَ إقْرَارِهِ
u'بَيْنٌ أَقْرَانٌ':Added, #2: 2	بَيْنَ الْإِقْرَارَيْنِ
u'بَيْنٌ أقْرَبُ':Added, #1: 1	بَيْنَ أَقْرَانِهِ
u'بَيْنٌ أقْرَع':Added, #1: 1	بَيْن الْأَقْرَبِ
u'بَيْنٌ أقْرَع':Added, #1: 1	بَيْنَ الأَقْرَعِ
u'بَيْنٌ أَقْسَامٌ':Added, #5: 5	بَيْنَ الْأَقْرَعِ
u'بَيْنٌ أَقْسَامٌ':Added, #1: 1	بَيْنَ أَقْسَامِ
u'بَيَّنَ أقَلُّ':Predicate, #2: 2	بَيْنَ الْأَقْسَامِ
u'بَيْنٌ أقَلُّ':Added, #2: 2	بَيَّنَ أَقَلَّ
u'بَيْنٌ أقَلُّ':Added, #11: 11	بَيْنَ الْأَقَلِّ
u'بَيْنٌ أَقْوَالٌ':Added, #1: 1	بَيْنَ أَقَلِّهِ
u'بَيْنٌ أَقْوَالٌ':Added, #2: 2	بَيْنَ أَقْوَالِ
u'بَيْنٌ أَقْوَامٌ':Added, #7: 7	بَيْنَ الْأَقْوَالِ
u'بَيْنٌ أَقْوَامٌ':Added, #1: 1	بَيْنَ الْأَقْوَامِ
u'بَيْنٌ أَقْيِسَةٌ':Added, #4: 4	بَيْنَ أَقْوَامٍ
u'بَيْنٌ أكَّارٌ':Added, #1: 1	بَيْنَ الْأَقْيِسَةِ
u'بَيْنٌ أكْبَرُ':Added, #2: 2	بَيْنَ الْأَكَّارِ
u'بَيَّنَ أَكْثَرُ':Predicate, #2: 2	بَيْنَ الْأَكْبَرِ
u'بَيْنٌ أَكْثَرُ':Added, #1: 1	بَيَّنَ أَكْثَرَ
u'بَيْنٌ أَكْثَرُ':Added, #2: 2	بَيْنَ الْأَكْثَرِ
u'بَيْنٌ إكْرَامٌ':Added, #3: 3	بَيْنَ أَكْثَرِ
u'بَيْنٌ إكْرَاهٌ':Added, #1: 1	بَيْنَ الْإِكْرَامِ
u'بَيْنٌ إكْرَاهٌ':Added, #1: 1	بَيْن الْإِكْرَاهِ
u'بَيْنٌ أكفاء':Added, #6: 6	بَيْنَ الْإِكْرَاهِ
u'بَيْنٌ أَكْفَانٌ':Added, #3: 3	بَيْنَ الْأَكْفَاءِ
u'بَيْنٌ أكل':Added, #2: 2	بَيْنَ أَكْفَانِهِ
u'بَيْنٌ أَكْلٌ':Added, #1: 1	بَيْنَ الأَكْلِ
u'بَيْنٌ أكل':Added, #1: 1	بَيْنَ الأَكْلِ
u'بَيْنٌ أَكْلٌ':Added, #2: 2	بَيْنَ أَكْلِهِ
u'بَيْنٌ أكل':Added, #2: 2	بَيْنَ أَكْلِهِ
u'بَيْنٌ أَكْلٌ':Added, #2: 2	بَيْنَ الْأَكْلِ
u'بَيْنٌ أكل':Added, #2: 2	بَيْنَ الْأَكْلِ
u'بَيْنٌ أَكْلٌ':Added, #3: 3	بَيْنَ أَكْلِ
u'بَيْنٌ اِلْتِزَامٌ':Added, #3: 3	بَيْنَ أَكْلِ
u'بَيْنٌ اِلْتِقَاطٌ':Added, #1: 1	بَيْنَ الْتِزَامٍ
u'بَيْنٌ إِلْزَامٌ':Added, #1: 1	بَيْنَ الْتِقَاطِ
u'بَيْنٌ ألف':Added, #1: 1	بَيْنَ إلْزَامِهِ
u'بَيْنٌ ألف':Added, #1: 1	بَيْنَ الْأَلِفِ
u'بَيْنٌ ألْفٌ':Added, #5: 5	بَيْنَ الْأَلْفِ
u'بَيْنٌ أَلْفٌ':Added, #5: 5	بَيْنَ الْأَلْفِ
u'بَيْنٌ أَلْفَاظٌ':Added, #5: 5	بَيْنَ الْأَلْفِ
u'بَيْنٌ أَلْفَاظٌ':Added, #3: 3	بَيْنَ أَلْفَاظِ
u'بَيْنٌ ألَمٌ':Added, #7: 7	بَيْنَ الْأَلْفَاظِ
u'بَيْنٌ الْمَرْءُ':Added, #1: 1	بَيْنَ الْأَلَمِ
u'بَيْنٌ الْمَرْأَةُ':Added, #13: 13	بَيْنَ الْمَرْءِ
u'بَيْنٌ الْمَرْأَةُ':Added, #1: 1	بَيْن الْمَرْأَةِ
u'بَيْنٌ أَلْوَاحٌ':Added, #51: 51	بَيْنَ الْمَرْأَةِ
u'بَيْنٌ أُمٌّ':Added, #1: 1	بَيْنَ الْأَلْوَاحِ
u'بَيْنٌ أُمٌّ':Added, #1: 1	بَيْنَ الْأُمَّيْنِ
u'بَيْنٌ أُمٌّ':Added, #1: 1	بَيْنَ أُمٍّ
u'بَيْنٌ أُمٌّ':Added, #1: 1	بَيْنَ أُمِّهِ
u'بَيْنٌ أُمٌّ':Added, #2: 2	بَيْنَ الأُمِّ
u'بَيْنٌ أُمٌّ':Added, #38: 38	بَيْنَ الْأُمِّ
u'بَيْنٌ أُمٌّ':Added, #3: 3	بَيْنَ أُمَّيْنِ
u'بَيْنٌ إمَاءٌ':Added, #6: 6	بَيْنَ أُمِّ
u'بَيْنٌ آمال':Added, #1: 1	بَيْنَ الْإِمَاءِ
u'بَيْنٌ إمَامٌ':Added, #1: 1	بَيْنَ الْآمَالِ
u'بَيْنٌ إمَامٌ':Added, #1: 1	بَيْنَ الإِمَامِ
u'بَيْنٌ إمَامٌ':Added, #1: 1	بَيْن الْإِمَامَيْنِ
u'بَيْنٌ إمَامٌ':Added, #53: 53	بَيْنَ الْإِمَامِ
u'بَيْنٌ إمَامَةٌ':Added, #5: 5	بَيْنَ الْإِمَامَيْنِ
u'بَيْنٌ أمَانَةٌ':Added, #1: 1	بَيْنَ الْإِمَامَةِ
u'بَيْنٌ أمَانَةٌ':Added, #1: 1	بَيْنَ الْأَمَانَةِ
u'بَيْنٌ أمَةٌ':Added, #1: 1	بَيْنَ أَمَانَةٍ
u'بَيْنٌ أمَةٌ':Added, #12: 12	بَيْنَ الْأَمَةِ
u'بَيْنٌ أُمَّةٌ':Added, #1: 1	بَيْنَ الأَمَةِ
u'بَيْنٌ أمَةٌ':Added, #1: 1	بَيْنِ الْأُمَّةِ
u'بَيْنٌ أمَةٌ':Added, #1: 1	بَيْن أَمَةٍ
u'بَيْنٌ أمَةٌ':Added, #1: 1	بَيْنَ أَمَةِ
u'بَيْنٌ أُمَّةٌ':Added, #1: 1	بَيْنِ أَمَةٍ
u'بَيْنٌ أُمَّةٌ':Added, #1: 1	بَيْنَ أُمَّتِهِ
u'بَيْنٌ أُمَّةٌ':Added, #22: 22	بَيْنَ الْأُمَّةِ
u'بَيْنٌ أمَةٌ':Added, #2: 2	بَيْنَ أُمَّةٍ
u'بَيْنٌ أَمْتِعَةٌ':Added, #3: 3	بَيْنَ أَمَةٍ
u'بَيْنٌ اِمْتِناعٌ':Added, #1: 1	بَيْنَ أَمْتِعَةِ
u'بَيْنٌ أمثال':Added, #1: 1	بَيْنَ امْتِنَاعِ
u'بَيْنٌ أَمْثَالٌ':Added, #1: 1	بَيْنَ أَمْثَالِ
u'بَيَّنَ أَمْثِلَةٌ':Predicate, #1: 1	بَيْنَ أَمْثَالِ
u'بَيَّنَ أَمْرٌ':Predicate, #1: 1	بَيَّنَ أَمْثِلَةَ
u'بَيْنٌ أَمْرٌ':Added, #3: 3	بَيَّنَ الْأَمْرَ
u'بَيْنٌ أَمْرٌ':Added, #16: 16	بَيْنَ الْأَمْرِ
u'بَيْنٌ أَمْرٌ':Added, #1: 1	بَيْن الْأَمْرَيْنِ
u'بَيْنٌ أَمْرٌ':Added, #1: 1	بَيْنَ أَمْرٍ
u'بَيْنٌ أَمْرٌ':Added, #28: 28	بَيْنَ الْأَمْرَيْنِ
u'بَيْنٌ أَمْرٌ':Added, #35: 35	بَيْنَ أَمْرَيْنِ
u'بَيْنٌ آمِرٌ':Added, #3: 3	بَيْنَ أَمْرِ
u'بَيْنٌ اِمْرَأَةٌ':Added, #4: 4	بَيْنَ الْآمِرِ
u'بَيْنٌ اِمْرَأَةٌ':Added, #12: 12	بَيْنَ امْرَأَةٍ
u'بَيْنٌ اِمْرَأَةٌ':Added, #17: 17	بَيْنَ امْرَأَتِهِ
u'بَيْنٌ أَمْرَد':Added, #5: 5	بَيْنَ امْرَأَةِ
u'بَيْنٌ إِمْساكٌ':Added, #1: 1	بَيْنَ الْأَمْرَدِ
u'بَيْنٌ إِمْساكٌ':Added, #3: 3	بَيْنَ إمْسَاكِهِ
u'بَيْنٌ إِمْضاءٌ':Added, #5: 5	بَيْنَ الْإِمْسَاكِ
u'بَيْنٌ إِمْضاءٌ':Added, #3: 3	بَيْنَ الْإِمْضَاءِ
u'بَيْنٌ إِمْكانٌ':Added, #6: 6	بَيْنَ إمْضَاءِ
u'بَيْنٌ أُمَمٌ':Added, #5: 5	بَيْنَ إمْكَانِ
u'بَيْنٌ أُمَّهَاتٌ':Added, #1: 1	بَيْنِ الْأُمَمِ
u'بَيْنٌ أُمَّهَاتٌ':Added, #1: 1	بَيْنَ الْأُمَّهَاتِ
u'بَيْنٌ أموات':Added, #4: 4	بَيْنَ أُمَّهَاتِ
u'بَيْنٌ أَمْوَالٌ':Added, #1: 1	بَيْنَ أَمْوَاتِ
u'بَيْنٌ أَمْوَالٌ':Added, #1: 1	بَيْنَ أَمْوَالِ
u'بَيْنٌ أَمْوَالٌ':Added, #2: 2	بَيْنَ الأَمْوَالِ
u'بَيْنٌ أُمُورٌ':Added, #3: 3	بَيْنَ الْأَمْوَالِ
u'بَيْنٌ أُمُورٌ':Added, #4: 4	بَيْنَ أُمُورٍ
u'بَيْنٌ أَميرٌ':Added, #9: 9	بَيْنَ الْأُمُورِ
u'بَيْنٌ أُناسٌ':Added, #1: 1	بَيْنَ الْأَمِيرِ
u'بَيْنٌ أَناسِيُّ':Added, #1: 1	بَيْنَ أُنَاسٍ
u'بَيْنٌ أَنامٌ':Added, #1: 1	بَيْنَ الْأَنَاسِيِّ
u'بَيْنٌ أنبياء':Added, #2: 2	بَيْنَ الْأَنَامِ
u'بَيْنٌ أنبياء':Added, #2: 2	بَيْنَ الأَنْبِيَاءِ
u'بَيْنٌ اِنْتِباهٌ':Added, #2: 2	بَيْنَ الْأَنْبِيَاءِ
u'بَيْنٌ اِنْتِظارٌ':Added, #1: 1	بَيْنَ انْتِبَاهِهِ
u'بَيْنٌ أُنْثَى':Added, #1: 1	بَيْنَ انْتِظَارِ
u'بَيْنٌ أُنْثَى':Added, #1: 1	بَيْن أُنْثَيَيْنِ
u'بَيْنٌ أُنْثَى':Added, #2: 2	بَيْنَ الْأُنْثَيَيْنِ
u'بَيْنٌ إِنْزالٌ':Added, #3: 3	بَيْنَ أُنْثَيَيْنِ
u'بَيْنٌ إِنْزالٌ':Added, #1: 1	بَيْنَ الْإِنْزَالِ
u'بَيْنٌ إِنْسٌ':Added, #1: 1	بَيْنَ إنْزَالِهِ
u'بَيْنٌ إِنْسانٌ':Added, #1: 1	بَيْن الْإِنْسِ
u'بَيْنٌ إِنْسِيٌّ':Added, #7: 7	بَيْنَ الْإِنْسَانِ
u'بَيْنٌ إِنْشاءٌ':Added, #1: 1	بَيْنَ الْإِنْسِيِّ
u'بَيْنٌ إِنْشاءٌ':Added, #1: 1	بَيْنَ إنْشَاءِ
u'بَيْنٌ أنصار':Added, #2: 2	بَيْنَ الْإِنْشَاءِ
u'بَيْنٌ أَنْصارٌ':Added, #5: 5	بَيْنَ الْأَنْصَارِ
u'بَيْنٌ أَنْصَارٌ':Added, #5: 5	بَيْنَ الْأَنْصَارِ
u'بَيْنٌ أَنْصِبَاءُ':Added, #5: 5	بَيْنَ الْأَنْصَارِ
u'بَيْنٌ أَنْصِبَاءُ':Added, #1: 1	بَيْنَ الْأَنْصِبَاءِ
u'بَيْنٌ اِنْعِدَامٌ':Added, #1: 1	بَيْنَ أَنْصِبَاءِ
u'بَيْنٌ اِنْعِقَادٌ':Added, #1: 1	بَيْنَ انْعِدَامِ
u'بَيْنٌ أَنْعُمٌ':Added, #2: 2	بَيْنَ انْعِقَادِ
u'بَيْنٌ أَنْفٌ':Added, #1: 1	بَيْنَ أَنْعُمِهِ
u'بَيْنٌ إِنْفاقٌ':Added, #1: 1	بَيْنَ الْأَنْفِ
u'بَيْنٌ اِنْقِطاعٌ':Added, #2: 2	بَيْنَ الْإِنْفَاقِ
u'بَيْنٌ إِنْكارٌ':Added, #1: 1	بَيْنَ انْقِطَاعِهِ
u'بَيَّنَ أَنْوَاعٌ':Predicate, #2: 2	بَيْنَ إنْكَارِ
u'بَيْنٌ أَنْوَاعٌ':Added, #3: 3	بَيَّنَ أَنْوَاعَ
u'بَيْنٌ أَنْوَاعٌ':Added, #1: 1	بَيْنَ أَنْوَاعِهِ
u'بَيْنٌ أَنْوَاعٌ':Added, #2: 2	بَيْنَ الْأَنْوَاعِ
u'بَيْنٌ أَنْيَابٌ':Added, #3: 3	بَيْنَ أَنْوَاعِ
u'بَيْنٌ آنِيَةٌ':Added, #1: 1	بَيْنَ الْأَنْيَابِ
u'بَيَّنَ أهْلٌ':Predicate, #3: 3	بَيْنِ آنِيَةٍ
u'بَيْنٌ أهْلٌ':Added, #1: 1	بَيَّنَ أَهْلَ
u'بَيْنٌ أهْلٌ':Added, #162: 162	بَيْنَ أَهْلِ
u'بَيْنٌ أهْلٌ':Added, #2: 2	بَيْنِ أَهْلِ
u'بَيْنٌ أهْلٌ':Added, #2: 2	بَيْنِ أَهْلِهِ
u'بَيَّنَ أَهْلِيٌّ':Predicate, #4: 4	بَيْنَ أَهْلِهِ
u'بَيْنٌ أَهْلِيٌّ':Added, #1: 1	بَيَّنَ أَهْلِيَّةَ
u'بَيْنٌ أَهْلِيٌّ':Added, #1: 1	بَيْنَ أَهْلِيَّيْنِ
u'بَيَّنَ أهْلِيَّةٌ':Predicate, #2: 2	بَيْنَ الْأَهْلِيِّ
u'بَيْنٌ أوامر':Added, #1: 1	بَيَّنَ أَهْلِيَّةَ
u'بَيْنٌ أَوامِرُ':Added, #2: 2	بَيْنَ الْأَوَامِرِ
u'بَيْنٌ أوَانٌ':Added, #2: 2	بَيْنَ الْأَوَامِرِ
u'بَيْنٌ أوَانٌ':Added, #1: 1	بَيْنَ أَوَانٍ
u'بَيْنٌ أَوْتَارٌ':Added, #1: 1	بَيْنَ أَوَانِ
u'بَيْنٌ أَوْرَاقٌ':Added, #1: 1	بَيْنِ الْأَوْتَارِ
u'بَيْنٌ أَوْرَاقٌ':Added, #1: 1	بَيْنَ الْأَوْرَاقِ
u'بَيْنٌ أَوْسَاطٌ':Added, #1: 1	بَيْنَ أَوْرَاقٍ
u'بَيْنٌ أوْسَطُ':Added, #3: 3	بَيْنَ أَوْسَاطِ
u'بَيْنٌ أوْسَطُ':Added, #1: 1	بَيْنَ أَوْسَطِ
u'بَيْنٌ أَوْصَافٌ':Added, #4: 4	بَيْنَ الْأَوْسَطِ
u'بَيْنٌ أَوْصَافٌ':Added, #1: 1	بَيْنَ الْأَوْصَافِ
u'بَيْنٌ أَوْقَاتٌ':Added, #1: 1	بَيْنِ الْأَوْصَافِ
u'بَيَّنَ أَوَّلُ':Predicate, #1: 1	بَيْنِ الْأَوْقَاتِ
u'بَيَّنَ أَوَّلُ':Subject, #1: 1	بَيَّنَ أَوَّلَ
u'بَيْنٌ أَوَّلُ':Added, #1: 1	بَيَّنَ الْأَوَّلُ
u'بَيْنٌ أَوَّلُ':Added, #1: 1	بَيْن الْأَوَّلَيْنِ
u'بَيْنٌ أَوَّلُ':Added, #2: 2	بَيْنَ أَوَّلِهِ
u'بَيْنٌ أَوَّلُ':Added, #43: 43	بَيْنَ الْأَوَّلِ
u'بَيْنٌ أَوَّلُ':Added, #7: 7	بَيْنَ أَوَّلِ
u'بَيْنٌ أَوْلاَدٌ':Added, #9: 9	بَيْنَ الْأَوَّلَيْنِ
u'بَيْنٌ أَوْلاَدٌ':Added, #14: 14	بَيْنَ أَوْلَادِهِ
u'بَيْنٌ أَوْلاَدٌ':Added, #15: 15	بَيْنَ الْأَوْلَادِ
u'بَيْنٌ أَوْلاَدٌ':Added, #1: 1	بَيْنَ الأَوْلاَدِ
u'بَيْنٌ أَوْلَوِيٌّ':Added, #8: 8	بَيْنَ أَوْلَادِ
u'بَيْنٌ أَوَّلِيٌّ':Added, #1: 1	بَيْنَ أَوْلَوِيَّةِ
u'بَيْنٌ أولى':Added, #1: 1	بَيْنَ الْأَوَّلِيَّيْنِ
u'بَيْنٌ أوْلَى':Added, #1: 1	بَيْنَ الْأَوْلَيَيْنِ
u'بَيْنٌ أولى':Added, #1: 1	بَيْنَ الْأَوْلَيَيْنِ
u'بَيْنٌ أوْلَى':Added, #7: 7	بَيْنَ الْأُولَيَيْنِ
u'بَيْنٌ أَوْلِيَاءُ':Added, #7: 7	بَيْنَ الْأُولَيَيْنِ
u'بَيْنٌ أَوْلِيَاءُ':Added, #4: 4	بَيْنَ الْأَوْلِيَاءِ
u'بَيْنٌ آيٌ':Added, #8: 8	بَيْنَ أَوْلِيَاءِ
u'بَيْنٌ آيٌ':Added, #1: 1	بَيْنِ الْآيِ
u'بَيَّنَ أئِمَّةٌ':Predicate, #1: 1	بَيْنِ آيِ
u'بَيْنٌ أئِمَّةٌ':Added, #1: 1	بَيَّنَ الْأَئِمَّةَ
u'بَيْنٌ أئِمَّةٌ':Added, #1: 1	بَيْنَ الأَئِمَّةِ
u'بَيْنٌ أئِمَّةٌ':Added, #1: 1	بَيْن الْأَئِمَّةِ
u'بَيْنٌ أئِمَّةٌ':Added, #29: 29	بَيْنَ الْأَئِمَّةِ
u'بَيْنٌ أيَّامٌ':Added, #6: 6	بَيْنَ أَئِمَّةِ
u'بَيْنٌ أَيَّامٌ':Added, #2: 2	بَيْنِ الأَيَّامِ
u'بَيْنٌ أيَّامٌ':Added, #2: 2	بَيْنِ الأَيَّامِ
u'بَيْنٌ أيَّامٌ':Added, #3: 3	بَيْنَ الْأَيَّامِ
u'بَيْنٌ أَيَّامٌ':Added, #3: 3	بَيْنِ الْأَيَّامِ
u'بَيْنٌ أَيَّامٌ':Added, #3: 3	بَيْنَ الْأَيَّامِ
u'بَيْنٌ آيَةٌ':Added, #3: 3	بَيْنِ الْأَيَّامِ
u'بَيْنٌ آيَةٌ':Added, #1: 1	بَيْنَ آيَةٍ
u'بَيْنٌ أيتام':Added, #5: 5	بَيْنَ الْآيَةِ
u'بَيْنٌ إِيجَابٌ':Added, #1: 1	بَيْنَ الْأَيْتَامِ
u'بَيْنٌ إِيجَابٌ':Added, #1: 1	بَيْن الْإِيجَابِ
u'بَيْنٌ إِيجَابٌ':Added, #1: 1	بَيْنَ إيجَابِهِ
u'بَيْنٌ إِيجَابٌ':Added, #22: 22	بَيْنَ الْإِيجَابِ
u'بَيْنٌ إِيجَارٌ':Added, #4: 4	بَيْنَ إيجَابِ
u'بَيْنٌ إيقَاعٌ':Added, #1: 1	بَيْن إيجَارِ
u'بَيْنٌ إيقَاعٌ':Added, #1: 1	بَيْنَ إيقَاعِهِ
u'بَيْنٌ إيقَاعٌ':Added, #2: 2	بَيْنَ إيقَاعِ
u'بَيْنٌ أَيْكَةٌ':Added, #3: 3	بَيْنَ الْإِيقَاعِ
u'بَيْنٌ أَيْمَانٌ':Added, #1: 1	بَيْنَ أَيْكَةٍ
u'بَيْنٌ إيمَانٌ':Added, #1: 1	بَيْنِ الْأَيْمَانِ
u'بَيْنٌ إيمَانٌ':Added, #1: 1	بَيْنَ الْإِيمَانَيْنِ
u'بَيْنٌ أَيْمَانٌ':Added, #3: 3	بَيْنَ الْإِيمَانِ
u'بَيْنٌ باء':Added, #4: 4	بَيْنَ الْأَيْمَانِ
u'بَيْنٌ بَابٌ':Added, #5: 5	بَيْنَ الْبَاءِ
u'بَيْنٌ بَابٌ':Added, #1: 1	بَيْنَ بَابِ
u'بَيْنٌ بَابٌ':Added, #1: 1	بَيْنَ بَابِهِ
u'بَيْنٌ بَابٌ':Added, #41: 41	بَيْنَ الْبَابَيْنِ
u'بَيْنٌ بَارٌّ':Added, #6: 6	بَيْنَ الْبَابِ
u'بَيْنٌ بَاطِلٌ':Added, #1: 1	بَيْنَ الْبَارِّ
u'بَيْنٌ باقَةٌ':Added, #6: 6	بَيْنَ الْبَاطِلِ
u'بَيْنٌ باقِي':Added, #2: 2	بَيْنَ الْبَاقِيَاتِ
u'بَيْنٌ باقِي':Added, #1: 1	بَيْنَ الْبَاقِيَةِ
u'بَيْنٌ باقِي':Added, #2: 2	بَيْنَ الْبَاقِيَاتِ
u'بَيْنٌ باقِيَةٌ':Added, #2: 2	بَيْنَ الْبَاقِيَتَيْنِ
u'بَيْنٌ باقِيَةٌ':Added, #1: 1	بَيْنَ الْبَاقِيَةِ
u'بَيْنٌ بالِغٌ':Added, #2: 2	بَيْنَ الْبَاقِيَاتِ
u'بَيْنٌ بالِغٌ':Added, #2: 2	بَيْنَ بَالِغٍ
u'بَيْنٌ بالُوعَةٌ':Added, #3: 3	بَيْنَ الْبَالِغِ
u'بَيْنٌ بَائِعٌ':Added, #2: 2	بَيْنَ الْبَالُوعَةِ
u'بَيْنٌ بَائِعٌ':Added, #1: 1	بَيْنَ بَائِعِهِ
u'بَيْنٌ بَائِنٌ':Added, #29: 29	بَيْنَ الْبَائِعِ
u'بَيْنٌ بتات':Added, #2: 2	بَيْنَ الْبَائِنِ
u'بَيْنٌ بَتَاتٌ':Added, #1: 1	بَيْنَ بَتَاتِ
u'بَيْنٌ بَحْرٌ':Added, #1: 1	بَيْنَ بَتَاتِ
u'بَيَّنَ بُخَارِيٌّ':Subject, #2: 2	بَيْنَ الْبَحْرِ
u'بَيْنٌ بُخْلٌ':Added, #1: 1	بَيَّنَ الْبُخَارِيُّ
u'بَيْنٌ بِدَايَةٌ':Added, #1: 1	بَيْنَ الْبُخْلِ
u'بَيْنٌ بَدْرٌ':Added, #1: 1	بَيْنَ بِدَايَةِ
u'بَيْنٌ بِدْعَةٌ':Added, #2: 2	بَيْنَ بَدْرٍ
u'بَيْنٌ بِدْعَةٌ':Added, #3: 3	بَيْنَ الْبِدْعَةِ
u'بَيْنٌ بَدَلٌ':Added, #4: 4	بَيْنَ بِدْعَةٍ
u'بَيْنٌ بَدَلٌ':Added, #17: 17	بَيْنَ الْبَدَلِ
u'بَيْنٌ بَدَلٌ':Added, #1: 1	بَيْن الْبَدَلِ
u'بَيْنٌ بَدَلٌ':Added, #1: 1	بَيْنَ بَدَلٍ
u'بَيْنٌ بَدَلٌ':Added, #2: 2	بَيْنَ بَدَلِهِ
u'بَيْنٌ بدن':Added, #6: 6	بَيْنَ الْبَدَلَيْنِ
u'بَيْنٌ بَدَنٌ':Added, #4: 4	بَيْنَ بَدَنِهِ
u'بَيْنٌ بدنة':Added, #4: 4	بَيْنَ بَدَنِهِ
u'بَيْنٌ بدنيٌّ':Added, #2: 2	بَيْنَ الْبَدَنَةِ
u'بَيْنٌ بَذْرٌ':Added, #1: 1	بَيْنَ الْبَدَنِيِّ
u'بَيْنٌ بَذْلٌ':Added, #2: 2	بَيْنَ الْبَذْرِ
u'بَيْنٌ بُرٌّ':Added, #2: 2	بَيْنَ بَذْلِ
u'بَيْنٌ بُرٌّ':Added, #1: 1	بَيْنَ الْبُرِّ
u'بَيْنٌ بَرٌّ':Added, #1: 1	بَيْنَ الْبُرَّيْنِ
u'بَيْنٌ بِرٌّ':Added, #3: 3	بَيْنَ الْبَرِّ
u'بَيْنٌ بَراءةٌ':Added, #4: 4	بَيْنَ الْبِرِّ
u'بَيْنٌ بَراغِيثُ':Added, #1: 1	بَيْنَ بَرَاءَةِ
u'بَيْنٌ بُرْدٌ':Added, #1: 1	بَيْنَ الْبَرَاغِيثِ
u'بَيْنٌ بِرْذَوْنٌ':Added, #2: 2	بَيْنَ بُرْدَيْنِ
u'بَيْنٌ بَرَكَةٌ':Added, #1: 1	بَيْنَ الْبِرْذَوْنِ
u'بَيْنٌ بَرِّيٌّ':Added, #1: 1	بَيْنَ بَرَكَةِ
u'بَيْنٌ بِزْرٌ':Added, #1: 1	بَيْنَ الْبَرِّيِّ
u'بَيْنٌ بُسْتان':Added, #1: 1	بَيْنَ الْبِزْرِ
u'بَيْنٌ بِشارَةٌ':Added, #1: 1	بَيْنَ الْبُسْتَانَيْنِ
u'بَيْنٌ بَطْنٌ':Added, #2: 2	بَيْنَ الْبِشَارَةِ
u'بَيْنٌ بَطْنٌ':Added, #1: 1	بَيْنَ الْبَطْنَيْنِ
u'بَيْنٌ بَطْنٌ':Added, #1: 1	بَيْنَ بَطْنِهِ
u'بَيْنٌ بُطونٌ':Added, #5: 5	بَيْنَ الْبَطْنِ
u'بَيْنٌ بَعْثٌ':Added, #4: 4	بَيْنَ الْبُطُونِ
u'بَيْنٌ بَعْثٌ':Added, #1: 1	بَيْنَ الْبَعْثِ
u'بَيْنٌ بَعْثٌ':Added, #1: 1	بَيْنَ الْبَعْثَتَيْنِ
u'بَيْنٌ بُعْدٌ':Added, #1: 1	بَيْنِ بَعْثٍ
u'بَيْنٌ بُعْدٌ':Added, #1: 1	بَيْنَ بُعْدِ
u'بَيْنٌ بَعْضٌ':Added, #2: 2	بَيْنَ الْبُعْدِ
u'بَيْنٌ بَعْضٌ':Added, #1: 1	بَيْنَ بَعْضٍ
u'بَيْنٌ بَعْضٌ':Added, #2: 2	بَيْنَ الْبَعْضِ
u'بَيْنٌ بَعيدٌ':Added, #5: 5	بَيْنَ بَعْضِ
u'بَيْنٌ بَعيدٌ':Added, #1: 1	بَيْنَ الْبَعِيدَةِ
u'بَيْنٌ بَعيرٌ':Added, #2: 2	بَيْنَ الْبَعِيدِ
u'بَيْنٌ بَعيرٌ':Added, #1: 1	بَيْنَ الْبَعِيرِ
u'بَيْنٌ بَغْلٌ':Added, #1: 1	بَيْنَ بَعِيرَيْنِ
u'بَيْنٌ بَقاءٌ':Added, #1: 1	بَيْنَ الْبَغْلِ
u'بَيْنٌ بَقاءٌ':Added, #2: 2	بَيْنَ الْبَقَاءِ
u'بَيْنٌ بَقَرٌ':Added, #5: 5	بَيْنَ بَقَاءِ
u'بَيْنٌ بَقَرٌ':Added, #1: 1	بَيْنَ الْبَقَرِ
u'بَيْنٌ بَقَرٌ':Added, #1: 1	بَيْنَ الْبَقَرَةِ
u'بَيَّنَ بَقِيَّةٌ':Predicate, #1: 1	بَيْنَ بَقَرٍ
u'بَيْنٌ بَقِيَّةٌ':Added, #1: 1	بَيَّنَ بَقِيَّةَ
u'بَيْنٌ بَقِيَّةٌ':Added, #1: 1	بَيْنَ بَقِيَّتِهِ
u'بَيْنٌ بَقِيَّةٌ':Added, #2: 2	بَيْنَ الْبَقِيَّةِ
u'بَيْنٌ بِكْرٌ':Added, #3: 3	بَيْنَ بَقِيَّةِ
u'بَيْنٌ بِكْرٌ':Added, #1: 1	بَيْن الْبِكْرِ
u'بَيْنٌ بِكْرٌ':Added, #1: 1	بَيْنَ بِكْرٍ
u'بَيْنٌ بَلاءٌ':Added, #6: 6	بَيْنَ الْبِكْرِ
u'بَيْنٌ بِلادٌ':Added, #1: 1	بَيْنَ الْبَلَاءَيْنِ
u'بَيْنٌ بَلَدٌ':Added, #1: 1	بَيْنَ بِلَادِ
u'بَيْنٌ بَلَدٌ':Added, #13: 13	بَيْنَ الْبَلَدَيْنِ
u'بَيْنٌ بَلَدٌ':Added, #1: 1	بَيْنَ الْبَلَدِ
u'بَيْنٌ بَلَدٌ':Added, #1: 1	بَيْنَ بَلَدٍ
u'بَيْنٌ بَلَدٌ':Added, #1: 1	بَيْنَ بَلَدِهِ
u'بَيْنٌ بَلْغَم':Added, #1: 1	بَيْنِ بَلَدِهِ
u'بَيْنٌ بله':Added, #1: 1	بَيْنَ الْبَلْغَمِ
u'بَيْنٌ بَلَهٌ':Added, #1: 1	بَيْنَ الْبَلَهِ
u'بَيْنٌ بُلُوغٌ':Added, #1: 1	بَيْنَ الْبَلَهِ
u'بَيْنٌ بِنَاءٌ':Added, #1: 1	بَيْنَ بُلُوغِ
u'بَيْنٌ بِنَاءٌ':Added, #1: 1	بَيْنَ الْبِنَاءَيْنِ
u'بَيْنٌ بِنَاءٌ':Added, #2: 2	بَيْنَ بِنَاءٍ
u'بَيْنٌ بِنَاءٌ':Added, #4: 4	بَيْنَ بِنَاءِ
u'بَيْنٌ بناتٌ':Added, #7: 7	بَيْنَ الْبِنَاءِ
u'بَيْنٌ بِنْتٌ':Added, #2: 2	بَيْنَ بَنَاتِ
u'بَيْنٌ بِنْتٌ':Added, #1: 1	بَيْن الْبِنْتِ
u'بَيْنٌ بِنْتٌ':Added, #1: 1	بَيْنَ الْبِنْتَيْنِ
u'بَيْنٌ بِنْتٌ':Added, #2: 2	بَيْنَ الْبِنْتِ
u'بَيْنٌ بُنْيانٌ':Added, #4: 4	بَيْنَ بِنْتِ
u'بَيْنٌ بَهائِمُ':Added, #2: 2	بَيْنَ الْبُنْيَانِ
u'بَيْنٌ بَهيمٌ':Added, #12: 12	بَيْنَ الْبَهَائِمِ
u'بَيْنٌ بَهِيمَةٌ':Added, #1: 1	بَيْنَ الْبَهِيمَةِ
u'بَيْنٌ بَوْلٌ':Added, #1: 1	بَيْنَ الْبَهِيمَةِ
u'بَيْنٌ بَوْلٌ':Added, #4: 4	بَيْنَ بَوْلِ
u'بَيْنٌ بِئْرٌ':Added, #6: 6	بَيْنَ الْبَوْلِ
u'بَيْنٌ بَيَاضٌ':Added, #2: 2	بَيْنَ الْبِئْرِ
u'بَيْنٌ بَيَاضٌ':Added, #1: 1	بَيْنَ الْبَيَاضِ
u'بَيْنٌ بَيَانٌ':Added, #2: 2	بَيْنَ بَيَاضِ
u'بَيْنٌ بَيَانٌ':Added, #1: 1	بَيْنَ بَيَانِ
u'بَيْنٌ بَيْتٌ':Added, #2: 2	بَيْنَ الْبَيَانِ
u'بَيْنٌ بَيْتٌ':Added, #2: 2	بَيْنَ بَيْتِ
u'بَيْنٌ بَيْتٌ':Added, #3: 3	بَيْنَ الْبَيْتَيْنِ
u'بَيَّنَ بيض':Predicate, #4: 4	بَيْنَ الْبَيْتِ
u'بَيْنٌ بيض':Added, #1: 1	بَيَّنَ بَيْضَ
u'بَيْنٌ بيض':Added, #1: 1	بَيْنَ الْبَيْضِ
u'بَيْنٌ بَيْعٌ':Added, #1: 1	بَيْنَ بَيْضٍ
u'بَيْنٌ بَيْعٌ':Added, #14: 14	بَيْنَ بَيْعٍ
u'بَيْنٌ بَيْعٌ':Added, #1: 1	بَيْنَ الْبَيْعَيْنِ
u'بَيْنٌ بَيْعٌ':Added, #1: 1	بَيْنَ بَيْعَتَيْنِ
u'بَيْنٌ بَيْعٌ':Added, #3: 3	بَيْنَ بَيْعِ
u'بَيْنٌ بَيْعٌ':Added, #51: 51	بَيْنَ الْبَيْعِ
u'بَيْنٌ بِيعَةٌ':Added, #9: 9	بَيْنَ بَيْعِهِ
u'بَيْنٌ بَيِّن':Added, #1: 1	بَيْنَ الْبِيعَةِ
u'بَيْنٌ بَيِّن':Added, #13: 13	بَيْنَ الْبَيِّنَتَيْنِ
u'بَيْنٌ بَيِّنَةٌ':Added, #1: 1	بَيْن الْبَيِّنَتَيْنِ
u'بَيْنٌ بُيُوتٌ':Added, #1: 1	بَيْنَ بَيِّنَةِ
u'بَيْنٌ بيوع':Added, #1: 1	بَيْنَ الْبُيُوتِ
u'بَيْنٌ تَابِعٌ':Added, #1: 1	بَيْنَ الْبُيُوعِ
u'بَيْنٌ تَأْثِيرٌ':Added, #2: 2	بَيْنَ التَّابِعِ
u'بَيْنٌ تَاجٌ':Added, #1: 1	بَيْنَ التَّأْثِيرِ
u'بَيْنٌ تَأْخِيرٌ':Added, #1: 1	بَيْنَ التَّاجِ
u'بَيْنٌ تارِك':Added, #1: 1	بَيْنَ تَأْخِيرِ
u'بَيْنٌ تَارِيخٌ':Added, #1: 1	بَيْنَ التَّارِكِ
u'بَيْنٌ تَاسِعٌ':Added, #1: 1	بَيْنَ تَارِيخِ
u'بَيْنٌ تَأْسِيسٌ':Added, #1: 1	بَيْنَ التَّاسِعَةِ
u'بَيْنٌ تَأَكُّدٌ':Added, #2: 2	بَيْنَ التَّأْسِيسِ
u'بَيْنٌ تَأْكِيدٌ':Added, #1: 1	بَيْنَ تَأَكُّدِ
u'بَيْنٌ تالِف':Added, #3: 3	بَيْنَ التَّأْكِيدِ
u'بَيْنٌ تَائِبٌ':Added, #1: 1	بَيْنَ التَّالِفَةِ
u'بَيْنٌ تَأْيِيدٌ':Added, #1: 1	بَيْنَ التَّائِبِ
u'بَيْنٌ تَبْذِيرٌ':Added, #1: 1	بَيْنَ تَأْيِيدِهِ
u'بَيْنٌ تَبَرُّعٌ':Added, #1: 1	بَيْنَ التَّبْذِيرِ
u'بَيْنٌ تَبَع':Added, #3: 3	بَيْنَ التَّبَرُّعِ
u'بَيْنٌ تَبْعِيض':Added, #1: 1	بَيْنَ التَّبَعِ
u'بَيْنٌ تَبْلِيغٌ':Added, #1: 1	بَيْنَ التَّبْعِيضِ
u'بَيْنٌ تَبْيِين':Added, #1: 1	بَيْنَ تَبْلِيغِ
u'بَيْنٌ تَتَابُعٌ':Added, #2: 2	بَيْنَ التَّبْيِينِ
u'بَيْنٌ تَثْنِيَةٌ':Added, #2: 2	بَيْنَ التَّتَابُعِ
u'بَيْنٌ تُجَّارٌ':Added, #1: 1	بَيْنَ التَّثْنِيَةِ
u'بَيْنٌ تِجَارَةٌ':Added, #8: 8	بَيْنَ التُّجَّارِ
u'بَيْنٌ تَحَرُّزٌ':Added, #1: 1	بَيْنَ التِّجَارَةِ
u'بَيْنٌ تَحْرِيرٌ':Added, #1: 1	بَيْنَ التَّحَرُّزِ
u'بَيْنٌ تَحْرِيك':Added, #1: 1	بَيْنَ التَّحْرِيرِ
u'بَيْنٌ تَحْرِيمٌ':Added, #1: 1	بَيْنَ التَّحْرِيكِ
u'بَيْنٌ تَحْرِيمٌ':Added, #1: 1	بَيْنَ التَّحْرِيمَيْنِ
u'بَيْنٌ تَحْرِيم':Added, #1: 1	بَيْنَ تَحْرِيمٍ
u'بَيْنٌ تَحْرِيمٌ':Added, #2: 2	بَيْنَ التَّحْرِيمَةِ
u'بَيْنٌ تَحْرِيمٌ':Added, #2: 2	بَيْنَ تَحْرِيمِ
u'بَيْنٌ تَحَقُّقٌ':Added, #7: 7	بَيْنَ التَّحْرِيمِ
u'بَيْنٌ تَحْقِيقٌ':Added, #1: 1	بَيْنَ تَحَقُّقِ
u'بَيْنٌ تَحَلُّلٌ':Added, #1: 1	بَيْنَ تَحْقِيقِ
u'بَيْنٌ تَحَلُّلٌ':Added, #1: 1	بَيْنَ التَّحَلُّلِ
u'بَيْنٌ تَحْلِيف':Added, #7: 7	بَيْنَ التَّحَلُّلَيْنِ
u'بَيْنٌ تَحَمُّلٌ':Added, #1: 1	بَيْن التَّحْلِيفِ
u'بَيْنٌ تَخْصِيصٌ':Added, #2: 2	بَيْنَ التَّحَمُّلِ
u'بَيْنٌ تَخْصِيصٌ':Added, #2: 2	بَيْنَ تَخْصِيصِ
u'بَيْنٌ تَخَلُّفٌ':Added, #7: 7	بَيْنَ التَّخْصِيصِ
u'بَيْنٌ تَخَمُّرٌ':Added, #1: 1	بَيْنَ التَّخَلُّفِ
u'بَيْنٌ تَخْيِيرٌ':Added, #1: 1	بَيْنَ التَّخَمُّرِ
u'بَيْنٌ تَدْبِيرٌ':Added, #1: 1	بَيْنَ التَّخْيِيرِ
u'بَيْنٌ تَدْخِين':Added, #6: 6	بَيْنَ التَّدْبِيرِ
u'بَيْنٌ تَذَكُّرٌ':Added, #1: 1	بَيْنَ التَّدْخِينِ
u'بَيْنٌ تَذَكُّرٌ':Added, #1: 1	بَيْنَ تَذَكُّرِهِ
u'بَيْنٌ تُرَابٌ':Added, #3: 3	بَيْنَ التَّذَكُّرِ
u'بَيْنٌ تَرَادُفٌ':Added, #2: 2	بَيْنَ التُّرَابِ
u'بَيْنٌ تَرَاوِيحُ':Added, #1: 1	بَيْنَ التَّرَادُفِ
u'بَيَّنَ تَرْتِيبٌ':Predicate, #5: 5	بَيْنَ التَّرَاوِيحِ
u'بَيْنٌ تَرْتِيبٌ':Added, #2: 2	بَيَّنَ تَرْتِيبَ
u'بَيْنٌ تَرْجَمَةٌ':Added, #2: 2	بَيْنَ تَرْتِيبِ
u'بَيْنٌ تَرْجِيحٌ':Added, #1: 1	بَيْنَ التَّرْجَمَةِ
u'بَيْنٌ تَرْدِيدٌ':Added, #1: 1	بَيْنَ تَرْجِيحِهِ
u'بَيْنٌ تَرْدِيدٌ':Added, #1: 1	بَيْنَ التَّرْدِيدِ
u'بَيْنٌ تَرْكٌ':Added, #1: 1	بَيْنَ تَرْدِيدِ
u'بَيْنٌ تَرْكٌ':Added, #5: 5	بَيْنَ التَّرْكِ
u'بَيْنٌ تَرْكٌ':Added, #5: 5	بَيْنَ تَرْكِهِ
u'بَيْنٌ تَرِكَةٌ':Added, #6: 6	بَيْنَ تَرْكِ
u'بَيْنٌ تَرِكَةٌ':Added, #1: 1	بَيْنَ تَرِكَةِ
u'بَيْنٌ تُرْكِيّ':Added, #7: 7	بَيْنَ التَّرِكَةِ
u'بَيْنٌ تَرْكِيبٌ':Added, #2: 2	بَيْنَ التُّرْكِيِّ
u'بَيْنٌ تَرْوِيحٌ':Added, #1: 1	بَيْنَ تَرْكِيبِ
u'بَيْنٌ تَزْكِيَةٌ':Added, #6: 6	بَيْنَ التَّرْوِيحَتَيْنِ
u'بَيْنٌ تَزَوُّجٌ':Added, #3: 3	بَيْنَ تَزْكِيَةِ
u'بَيْنٌ تَزَوُّجٌ':Added, #1: 1	بَيْنَ التَّزَوُّجِ
u'بَيْنٌ تَزْوِيجٌ':Added, #1: 1	بَيْنَ التَّزَوُّجَيْنِ
u'بَيْنٌ تَزْوِيقٌ':Added, #2: 2	بَيْنَ تَزْوِيجِ
u'بَيْنٌ تَسْبِيحٌ':Added, #1: 1	بَيْنَ التَّزْوِيقِ
u'بَيْنٌ تِسْعَةٌ':Added, #2: 2	بَيْنَ التَّسْبِيحِ
u'بَيْنٌ تَسَلُّمٌ':Added, #1: 1	بَيْنَ تِسْعَةٍ
u'بَيْنٌ تَسْلِيم':Added, #1: 1	بَيْنَ تَسَلُّمِهِ
u'بَيْنٌ تَسْلِيمٌ':Added, #1: 1	بَيْنَ تَسْلِيمَةِ
u'بَيْنٌ تَسْلِيمٌ':Added, #1: 1	بَيْنَ تَسْلِيمِهِ
u'بَيْنٌ تَسْلِيمٌ':Added, #2: 2	بَيْنَ التَّسْلِيمَاتِ
u'بَيْنٌ تَسْلِيمٌ':Added, #2: 2	بَيْنَ تَسْلِيمَاتِ
u'بَيْنٌ تَسْلِيمٌ':Added, #3: 3	بَيْنَ تَسْلِيمِ
u'بَيْنٌ تَسْمِيَة':Added, #6: 6	بَيْنَ التَّسْلِيمِ
u'بَيْنٌ تَسْمِيَة':Added, #1: 1	بَيْنَ التَّسْمِيَةِ
u'بَيْنٌ تَسْمِيعٌ':Added, #4: 4	بَيْنَ تَسْمِيَةِ
u'بَيْنٌ تَسْوِيَةٌ':Added, #1: 1	بَيْنَ التَّسْمِيعِ
u'بَيْنٌ تَشَاغُلٌ':Added, #1: 1	بَيْنَ التَّسْوِيَةِ
u'بَيْنٌ تَشْرِيك':Added, #1: 1	بَيْنَ تَشَاغُلِهِ
u'بَيْنٌ تَشَهُّدٌ':Added, #1: 1	بَيْنَ التَّشْرِيكِ
u'بَيْنٌ تَصْحِيحٌ':Added, #6: 6	بَيْنَ التَّشَهُّدِ
u'بَيْنٌ تَصْحِيحٌ':Added, #1: 1	بَيْنَ تَصْحِيحِهِ
u'بَيْنٌ تَصَدُّقٌ':Added, #2: 2	بَيْنَ تَصْحِيحِ
u'بَيْنٌ تَصْدِيقٌ':Added, #1: 1	بَيْنَ التَّصَدُّقِ
u'بَيْنٌ تَصْدِيقٌ':Added, #1: 1	بَيْنَ تَصْدِيقِ
u'بَيْنٌ تَصَرُّفٌ':Added, #2: 2	بَيْنَ التَّصْدِيقِ
u'بَيْنٌ تَصَرُّفٌ':Added, #1: 1	بَيْنَ تَصَرُّفِ
u'بَيْنٌ تَصْرِيحٌ':Added, #3: 3	بَيْنَ التَّصَرُّفِ
u'بَيْنٌ تَصَوُّرٌ':Added, #3: 3	بَيْنَ التَّصْرِيحِ
u'بَيْنٌ تَصْوِيرٌ':Added, #1: 1	بَيْنَ التَّصَوُّرَاتِ
u'بَيْنٌ تَضْعِيفٌ':Added, #1: 1	بَيْنَ التَّصْوِيرَيْنِ
u'بَيْنٌ تَضْمِينٌ':Added, #1: 1	بَيْنَ التَّضْعِيفِ
u'بَيْنٌ تَضْمِينٌ':Added, #21: 21	بَيْنَ تَضْمِينِ
u'بَيْنٌ تَضْمِين':Added, #3: 3	بَيْنَ تَضْمِينِهِ
u'بَيْنٌ تَضْيِيقٌ':Added, #4: 4	بَيْنَ التَّضْمِينِ
u'بَيْنٌ تَطَرُّقٌ':Added, #1: 1	بَيْنَ التَّضْيِيقِ
u'بَيْنٌ تَطْلِيقٌ':Added, #1: 1	بَيْنَ تَطَرُّقٍ
u'بَيْنٌ تَطْلِيقٌ':Added, #1: 1	بَيْنَ التَّطْلِيقَاتِ
u'بَيْنٌ تَطْلِيقٌ':Added, #1: 1	بَيْنَ تَطْلِيقَتَيْنِ
u'بَيْنٌ تَطْهِيرٌ':Added, #5: 5	بَيْنَ التَّطْلِيقَتَيْنِ
u'بَيْنٌ تَطَوُّعٌ':Added, #1: 1	بَيْنَ تَطْهِيرِ
u'بَيْنٌ تَعَارُضٌ':Added, #2: 2	بَيْنَ التَّطَوُّعِ
u'بَيْنٌ تَعَاقُبٌ':Added, #1: 1	بَيْنَ تَعَارُضِ
u'بَيْنٌ تَعَبُّدٌ':Added, #1: 1	بَيْنَ التَّعَاقُبِ
u'بَيْنٌ تَعْبِيرٌ':Added, #1: 1	بَيْنَ التَّعَبُّدِ
u'بَيْنٌ تَعْبِيرٌ':Added, #1: 1	بَيْنَ التَّعْبِيرِ
u'بَيْنٌ تَعَجُّبٌ':Added, #1: 1	بَيْنَ تَعْبِيرِهِ
u'بَيْنٌ تَعْجِيل':Added, #1: 1	بَيْنَ التَّعَجُّبِ
u'بَيْنٌ تَعَدُّدٌ':Added, #1: 1	بَيْنَ تَعْجِيلِ
u'بَيْنٌ تَعْدِيلٌ':Added, #2: 2	بَيْنَ تَعَدُّدِ
u'بَيْنٌ تَعْرِيفٌ':Added, #2: 2	بَيْنَ التَّعْدِيلِ
u'بَيْنٌ تَعْرِيفٌ':Added, #1: 1	بَيْنَ تَعْرِيفِ
u'بَيْنٌ تَعْزِير':Added, #4: 4	بَيْنَ التَّعْرِيفِ
u'بَيْنٌ تَعْطِيلٌ':Added, #1: 1	بَيْنَ التَّعْزِيرِ
u'بَيْنٌ تَعْطِيلٌ':Added, #1: 1	بَيْنَ تَعْطِيلِ
u'بَيْنٌ تَعْفِيرٌ':Added, #2: 2	بَيْنَ التَّعْطِيلِ
u'بَيْنٌ تَعْقِيبٌ':Added, #1: 1	بَيْنَ التَّعْفِيرِ
u'بَيْنٌ تَعَلُّقٌ':Added, #1: 1	بَيْنَ التَّعْقِيبِ
u'بَيْنٌ تَعْلِيقٌ':Added, #1: 1	بَيْنَ تَعَلُّقِهِ
u'بَيْنٌ تَعْلِيقٌ':Added, #10: 10	بَيْنَ التَّعْلِيقِ
u'بَيْنٌ تَعْلِيقٌ':Added, #3: 3	بَيْن التَّعْلِيقِ
u'بَيْنٌ تَعْلِيلٌ':Added, #3: 3	بَيْنَ تَعْلِيقِ
u'بَيْنٌ تَعْلِيلٌ':Added, #1: 1	بَيْنَ التَّعْلِيلِ
u'بَيْنٌ تَعْيِينٌ':Added, #2: 2	بَيْنَ تَعْلِيلِ
u'بَيْنٌ تَغْطِيَةٌ':Added, #4: 4	بَيْنَ تَعْيِينِ
u'بَيْنٌ تَغَيُّرٌ':Added, #2: 2	بَيْنَ تَغْطِيَةِ
u'بَيْنٌ تَغَيُّرٌ':Added, #1: 1	بَيْنَ تَغَيُّرٍ
u'بَيْنٌ تَغَيُّرٌ':Added, #1: 1	بَيْنَ تَغَيُّرِ
u'بَيْنٌ تَفَاسِيرُ':Added, #2: 2	بَيْنَ التَّغَيُّرِ
u'بَيْنٌ تَفَاضُلٌ':Added, #1: 1	بَيْنِ التَّفَاسِيرِ
u'بَيْنٌ تَفَرُّقٌ':Added, #1: 1	بَيْنَ التَّفَاضُلِ
u'بَيْنٌ تَفْرِقَة':Added, #2: 2	بَيْنَ التَّفَرُّقِ
u'بَيْنٌ تَفْرِيقٌ':Added, #1: 1	بَيْنَ تَفْرِقَةِ
u'بَيْنٌ تَفْسِيرٌ':Added, #1: 1	بَيْنَ التَّفْرِيقِ
u'بَيْنٌ تَفْسِيرٌ':Added, #1: 1	بَيْنَ التَّفْسِيرِ
u'بَيْنٌ تَفْصِيلٌ':Added, #1: 1	بَيْنَ تَفْسِيرٍ
u'بَيْنٌ تَفْوِيضٌ':Added, #1: 1	بَيْنَ التَّفْصِيلِ
u'بَيْنٌ تَفْوِيضٌ':Added, #1: 1	بَيْنَ التَّفْوِيضَيْنِ
u'بَيْنٌ تَفْوِيضٌ':Added, #1: 1	بَيْنَ تَفْوِيضَيْنِ
u'بَيْنٌ تَقَحُّمٌ':Added, #3: 3	بَيْنَ التَّفْوِيضِ
u'بَيْنٌ تَقَدُّمٌ':Added, #1: 1	بَيْنَ التَّقَحُّمِ
u'بَيْنٌ تَقَدُّمٌ':Added, #12: 12	بَيْنَ تَقَدُّمِ
u'بَيْنٌ تَقْديرٌ':Added, #1: 1	بَيْنَ التَّقَدُّمِ
u'بَيْنٌ تَقْديرٌ':Added, #1: 1	بَيْنَ التَّقْدِيرِ
u'بَيْنٌ تَقْديرٌ':Added, #1: 1	بَيْنَ التّقْدِيرَيْنِ
u'بَيْنٌ تَقْديمٌ':Added, #5: 5	بَيْنَ تَقْدِيرِ
u'بَيْنٌ تَقْديمٌ':Added, #3: 3	بَيْنَ التَّقْدِيمِ
u'بَيْنٌ تَقَرُّبٌ':Added, #4: 4	بَيْنَ تَقْدِيمِ
u'بَيْنٌ تَقْصيرٌ':Added, #1: 1	بَيْنَ التَّقَرُّبِ
u'بَيْنٌ تَقْويمٌ':Added, #1: 1	بَيْنَ التَّقْصِيرِ
u'بَيْنٌ تَقْويمٌ':Added, #1: 1	بَيْنَ التَّقْوِيمِ
u'بَيْنٌ تَقْويمٌ':Added, #1: 1	بَيْنَ التَّقْوِيمَيْنِ
u'بَيْنٌ تَكْبيرٌ':Added, #2: 2	بَيْنَ تَقْوِيمِ
u'بَيْنٌ تَكْبيرٌ':Added, #10: 10	بَيْنَ التَّكْبِيرِ
u'بَيْنٌ تَكْبِير':Added, #11: 11	بَيْنَ التَّكْبِيرَاتِ
u'بَيْنٌ تَكْبيرٌ':Added, #1: 1	بَيْنَ التَّكْبِيرَةِ
u'بَيْنٌ تَكْبيرٌ':Added, #1: 1	بَيْن التَّكْبِيرَتَيْنِ
u'بَيْنٌ تَكْبيرٌ':Added, #2: 2	بَيْنَ تَكْبِيرَتَيْنِ
u'بَيْنٌ تَكْبِير':Added, #2: 2	بَيْنَ تَكْبِيرِهِ
u'بَيْنٌ تَكْبيرٌ':Added, #4: 4	بَيْنَ تَكْبِيرَةِ
u'بَيْنٌ تَكْذيبٌ':Added, #5: 5	بَيْنَ التَّكْبِيرَتَيْنِ
u'بَيْنٌ تَكْرارٌ':Added, #1: 1	بَيْنَ تَكْذِيبِ
u'بَيْنٌ تَكْرارٌ':Added, #1: 1	بَيْنَ تَكْرَارِ
u'بَيْنٌ تَكْفيرٌ':Added, #1: 1	بَيْنَ تَكْرَارِهِ
u'بَيَّنَ تَكْليفٌ':Predicate, #2: 2	بَيْنَ التَّكْفِيرِ
u'بَيْنٌ تَكْليفٌ':Added, #1: 1	بَيَّنَ التَّكْلِيفَ
u'بَيْنٌ تِلاوَةٌ':Added, #2: 2	بَيْنَ تَكْلِيفِ
u'بَيْنٌ تَلَبُّسٌ':Added, #1: 1	بَيْنَ التِّلَاوَةِ
u'بَيْنٌ تَلْبيَةٌ':Added, #1: 1	بَيْنَ التَّلَبُّسِ
u'بَيْنٌ تَلْبيدٌ':Added, #1: 1	بَيْنَ التَّلْبِيَةِ
u'بَيْنٌ تَلَفٌ':Added, #1: 1	بَيْنَ التَّلْبِيدِ
u'بَيْنٌ تَلَف':Added, #1: 1	بَيْنَ تَلَفِهِ
u'بَيْنٌ تَلَفُّظٌ':Added, #2: 2	بَيْنَ التَّلَفِ
u'بَيْنٌ تَلَفُّظٌ':Added, #1: 1	بَيْن التَّلَفُّظِ
u'بَيْنٌ تَماسُكٌ':Added, #1: 1	بَيْنَ التَّلَفُّظِ
u'بَيْنٌ تَمَتُّعٌ':Added, #3: 3	بَيْنَ التَّمَاسُكِ
u'بَيْنٌ تَمَتُّعٌ':Added, #1: 1	بَيْنَ التَّمَتُّعِ
u'بَيْنٌ تَمْرٌ':Added, #1: 1	بَيْنِ التَّمَتُّعِ
u'بَيْنٌ تَمْر':Added, #1: 1	بَيْنَ تَمْرِ
u'بَيْنٌ تَمْر':Added, #7: 7	بَيْنَ التَّمْرَتَيْنِ
u'بَيْنٌ تَمَسُّحٌ':Added, #9: 9	بَيْنَ التَّمْرِ
u'بَيْنٌ تَمَكُّنٌ':Added, #1: 1	بَيْنَ التَّمَسُّحِ
u'بَيْنٌ تَمْكِينٌ':Added, #1: 1	بَيْنَ التَّمَكُّنِ
u'بَيْنٌ تَمَلُّكٌ':Added, #1: 1	بَيْنَ تَمْكِينِ
u'بَيْنٌ تَمْلِيك':Added, #2: 2	بَيْنَ تَمَلُّكِهِ
u'بَيْنٌ تَمِيمِيّ':Added, #2: 2	بَيْنَ التَّمْلِيكِ
u'بَيْنٌ تَنَاقُضٌ':Added, #3: 3	بَيْنَ تَمِيمِيٍّ
u'بَيْنٌ تَنَاقُضٌ':Added, #1: 1	بَيْنَ التَّنَاقُضِ
u'بَيْنٌ تَنَاوُلٌ':Added, #1: 1	بَيْنَ تَنَاقُضِ
u'بَيْنٌ تَنجُّسٌ':Added, #1: 1	بَيْنَ تَنَاوُلِ
u'بَيْنٌ تَنْجِيزٌ':Added, #1: 1	بَيْنَ تَنَجُّسِهِ
u'بَيْنٌ تَنْصِيص':Added, #1: 1	بَيْنَ التَّنْجِيزِ
u'بَيْنٌ تَنْوِيرٌ':Added, #1: 1	بَيْنَ التَّنْصِيصِ
u'بَيْنٌ تَهْلِيلٌ':Added, #1: 1	بَيْنَ التَّنْوِيرِ
u'بَيْنٌ تَوَاتُرٌ':Added, #1: 1	بَيْنَ التَّهْلِيلِ
u'بَيْنٌ تَوَاطُؤٌ':Added, #2: 2	بَيْنَ التَّوَاتُرِ
u'بَيْنٌ تَوْأَمٌ':Added, #1: 1	بَيْنَ التَّوَاطُؤِ
u'بَيْنٌ تَوْأَمٌ':Added, #1: 1	بَيْنَ التَّوْأَمَيْنِ
u'بَيْنٌ تَوْبَةٌ':Added, #1: 1	بَيْنَ تَوْأَمَيْنِ
u'بَيْنٌ تَوْبَةٌ':Added, #1: 1	بَيْنَ تَوْبَةِ
u'بَيْنٌ تَوْجِيهٌ':Added, #2: 2	بَيْنَ التَّوْبَةِ
u'بَيْنٌ تَوْحِيدٌ':Added, #1: 1	بَيْنَ التَّوْجِيهَيْنِ
u'بَيْنٌ تَوَقُّفٌ':Added, #1: 1	بَيْنَ التَّوْحِيدِ
u'بَيْنٌ تَوْكِيدٌ':Added, #2: 2	بَيْنَ تَوَقُّفِ
u'بَيْنٌ تَوْكِيلٌ':Added, #1: 1	بَيْنَ تَوْكِيدِ
u'بَيْنٌ تَوْلِيَةٌ':Added, #9: 9	بَيْنَ التَّوْكِيلِ
u'بَيْنٌ تونِسِيّ':Added, #1: 1	بَيْنَ التَّوْلِيَةِ
u'بَيْنٌ تَوَهُّمٌ':Added, #1: 1	بَيْنَ التُّونِسِيِّ
u'بَيْنٌ تَيَمُّمٌ':Added, #1: 1	بَيْنَ تَوَهُّمِ
u'بَيْنٌ تَيَمُّمٌ':Added, #1: 1	بَيْنَ التَّيَمُّمَيْنِ
u'بَيْنٌ تينٌ':Added, #9: 9	بَيْنَ التَّيَمُّمِ
u'بَيْنٌ ثَابِتٌ':Added, #1: 1	بَيْنَ التِّينِ
u'بَيْنٌ ثَابِتٌ':Added, #1: 1	بَيْنَ الثَّابِتَةِ
u'بَيْنٌ ثابتة':Added, #5: 5	بَيْنَ الثَّابِتِ
u'بَيْنٌ ثَالِثٌ':Added, #1: 1	بَيْنَ الثَّابِتَةِ
u'بَيْنٌ ثَالِثٌ':Added, #2: 2	بَيْنَ الثَّالِثِ
u'بَيَّنَ ثَانِي':Predicate, #2: 2	بَيْنَ الثَّالِثَةِ
u'بَيْنٌ ثَانِي':Added, #1: 1	بَيَّنَ الثَّانِيَ
u'بَيْنٌ ثَانِي':Added, #1: 1	بَيْنَ الثَّانِيَيْنِ
u'بَيْنٌ ثَانِيَةٌ':Added, #8: 8	بَيْنَ الثَّانِيَةِ
u'بَيْنٌ ثُبُوتٌ':Added, #8: 8	بَيْنَ الثَّانِيَةِ
u'بَيْنٌ ثُبُوتٌ':Added, #1: 1	بَيْنَ الثُّبُوتَيْنِ
u'بَيْنٌ ثُبُوتٌ':Added, #1: 1	بَيْنَ ثُبُوتَيْنِ
u'بَيْنٌ ثُبُوتٌ':Added, #5: 5	بَيْنَ الثُّبُوتِ
u'بَيْنٌ ثَدْيٌ':Added, #9: 9	بَيْنَ ثُبُوتِ
u'بَيْنٌ ثَغْرٌ':Added, #3: 3	بَيْنَ الثَّدْيِ
u'بَيْنٌ ثِقَةٌ':Added, #1: 1	بَيْنَ الثَّغْرِ
u'بَيْنٌ ثِقَة':Added, #1: 1	بَيْنَ الثِّقَةِ
u'بَيْنٌ ثِقَة':Added, #1: 1	بَيْنِ ثِقَاتٍ
u'بَيْنٌ ثَقِيلٌ':Added, #1: 1	بَيْنِ ثِقَاتِ
u'بَيْنٌ ثَلاثُ':Added, #1: 1	بَيْنَ ثَقِيلَيْنِ
u'بَيْنٌ ثَلاثُ':Added, #1: 1	بَيْنَ ثَلاَثِ
u'بَيْنٌ ثَلاثُ':Added, #33: 33	بَيْنَ الثَّلَاثِ
u'بَيَّنَ ثَلاثَةٌ':Subject, #4: 4	بَيْنَ ثَلَاثِ
u'بَيْنٌ ثَلاثَةٌ':Added, #1: 1	بَيَّنَ ثَلَاثَةٌ
u'بَيْنٌ ثَلاثَةٌ':Added, #1: 1	بَيْنَ الثَّلاَثَةِ
u'بَيْنٌ ثَلاثَةٌ':Added, #1: 1	بَيْنَ ثَلاَثَةٍ
u'بَيْنٌ ثَلاثَةٌ':Added, #1: 1	بَيْنَ ثَلاَثَةِ
u'بَيْنٌ ثَلاثَةٌ':Added, #36: 36	بَيْنَ ثَلَاثَةٍ
u'بَيْنٌ ثَلاثَةٌ':Added, #53: 53	بَيْنَ ثَلَاثَةِ
u'بَيْنٌ ثِمارٌ':Added, #56: 56	بَيْنَ الثَّلَاثَةِ
u'بَيْنٌ ثُمانَ':Added, #1: 1	بَيْنَ الثِّمَارِ
u'بَيْنٌ ثَمَرٌ':Added, #1: 1	بَيْن الثّمَانِ
u'بَيْنٌ ثَمَرٌ':Added, #1: 1	بَيْنَ ثَمَرِ
u'بَيَّنَ ثَمَرَةٌ':Predicate, #5: 5	بَيْنَ الثَّمَرِ
u'بَيْنٌ ثَمَرَةٌ':Added, #1: 1	بَيَّنَ الثَّمَرَةَ
u'بَيَّنَ ثَمَنٌ':Predicate, #1: 1	بَيْنَ الثَّمَرَةِ
u'بَيَّنَ ثَمَنٌ':Predicate, #11: 11	بَيَّنَ الثَّمَنَ
u'بَيْنٌ ثَمَن':Added, #7: 7	بَيَّنَ ثَمَنَ
u'بَيْنٌ ثَمَنٌ':Added, #1: 1	بَيْنَ الثَّمَنِيَّةِ
u'بَيْنٌ ثَمَنٌ':Added, #1: 1	بَيْنَ ثَمَنِ
u'بَيْنٌ ثَمَنٌ':Added, #2: 2	بَيْنَ الثَّمَنَيْنِ
u'بَيْنٌ ثَمَنٌ':Added, #3: 3	بَيْنَ ثَمَنِهِ
u'بَيْنٌ ثَنِيَّةٌ':Added, #6: 6	بَيْنَ الثَّمَنِ
u'بَيْنٌ ثَوابٌ':Added, #1: 1	بَيْنَ ثَنِيَّةٍ
u'بَيَّنَ ثَوْبٌ':Predicate, #1: 1	بَيْنَ ثَوَابِهِ
u'بَيْنٌ ثَوْبٌ':Added, #2: 2	بَيَّنَ الثَّوْبَ
u'بَيْنٌ ثَوْبٌ':Added, #1: 1	بَيْنَ ثَوْبِ
u'بَيْنٌ ثَوْبٌ':Added, #2: 2	بَيْنَ ثَوْبَيْنِ
u'بَيْنٌ ثَوْرٌ':Added, #8: 8	بَيْنَ الثَّوْبِ
u'بَيْنٌ ثِيابٌ':Added, #4: 4	بَيْنَ ثَوْرٍ
u'بَيْنٌ ثِيابٌ':Added, #1: 1	بَيْنَ الثِّيَابِ
u'بَيْنٌ ثَيِّبٌ':Added, #1: 1	بَيْنَ ثِيَابٍ
u'بَيَّنَ جَابِرٌ':Subject, #2: 2	بَيْنَ الثَّيِّبِ
u'بَيْنٌ جَابِي':Added, #2: 2	بَيَّنَ جَابِرُ
u'بَيْنٌ جَابِيَةٌ':Added, #1: 1	بَيْنَ الْجَابِيَةِ
u'بَيْنٌ جَادٌّ':Added, #1: 1	بَيْنَ الْجَابِيَةِ
u'بَيْنٌ جَارٌ':Added, #1: 1	بَيْنَ الْجَادَّتَيْنِ
u'بَيْنٌ جَارٌ':Added, #1: 1	بَيْنَ جَارَتَيْنِ
u'بَيْنٌ جَارِحٌ':Added, #3: 3	بَيْنَ الْجَارَيْنِ
u'بَيْنٌ جَارِحَةٌ':Added, #1: 1	بَيْنَ الْجَارِحَةِ
u'بَيْنٌ جَارِي':Added, #1: 1	بَيْنَ الْجَارِحَةِ
u'بَيْنٌ جَارِي':Added, #1: 1	بَيْنَ جَارِيَتِهِ
u'بَيْنٌ جَارِي':Added, #2: 2	بَيْنَ جَارِيَةٍ
u'بَيْنٌ جَارِي':Added, #3: 3	بَيْنَ جَارِيَتَيْنِ
u'بَيْنٌ جَارِيَةٌ':Added, #5: 5	بَيْنَ الْجَارِيَةِ
u'بَيْنٌ جَارِيَةٌ':Added, #1: 1	بَيْنَ جَارِيَتِهِ
u'بَيْنٌ جَارِيَةٌ':Added, #2: 2	بَيْنَ جَارِيَةٍ
u'بَيَّنَ جَازٌ':Predicate, #5: 5	بَيْنَ الْجَارِيَةِ
u'بَيْنٌ جَازِمٌ':Added, #5: 5	بَيَّنَ جَازَ
u'بَيْنٌ جَالِسٌ':Added, #1: 1	بَيْنَ الْجَازِمِ
u'بَيْنٌ جَامِعٌ':Added, #1: 1	بَيْنَ الْجَالِسِ
u'بَيْنٌ جَانٌّ':Added, #1: 1	بَيْنَ الْجَامِعَيْنِ
u'بَيْنٌ جَانِبٌ':Added, #1: 1	بَيْنَ الْجَانِّ
u'بَيْنٌ جَاهِلٌ':Added, #1: 1	بَيْنَ جَانِبَيْنِ
u'بَيْنٌ جَاهِلِيٌّ':Added, #5: 5	بَيْنَ الْجَاهِلِ
u'بَيْنٌ جَاهِلِيَّةٌ':Added, #1: 1	بَيْنَ جَاهِلِيَّةٍ
u'بَيْنٌ جَائِزٌ':Added, #1: 1	بَيْنَ جَاهِلِيَّةٍ
u'بَيْنٌ جَائِزٌ':Added, #1: 1	بَيْنَ الْجَائِزَةِ
u'بَيْنٌ جَائِزٌ':Added, #2: 2	بَيْنَ الْجَائِزِ
u'بَيْنٌ جَائِزَةٌ':Added, #2: 2	بَيْنَ الْجَائِزَيْنِ
u'بَيْنٌ جُبٌّ':Added, #1: 1	بَيْنَ الْجَائِزَةِ
u'بَيْنٌ جِبَابٌ':Added, #1: 1	بَيْنَ جُبَّتَيْنِ
u'بَيْنٌ جِبَالٌ':Added, #1: 1	بَيْنَ الْجِبَابِ
u'بَيْنٌ جِبَالٌ':Added, #1: 1	بَيْنَ الْجِبَالِ
u'بَيْنٌ جِبَالٌ':Added, #1: 1	بَيْنِ الْجِبَالِ
u'بَيْنٌ جَبْرٌ':Added, #1: 1	بَيْنَ جِبَالِ
u'بَيْنٌ جَبَلٌ':Added, #1: 1	بَيْنَ الْجَبْرِ
u'بَيْنٌ جَبَلٌ':Added, #15: 15	بَيْنَ الْجَبَلَيْنِ
u'بَيْنٌ جَبَلٌ':Added, #18: 18	بَيْنَ جَبَلَيْنِ
u'بَيْنٌ جُحُود':Added, #4: 4	بَيْنَ الْجَبَلِ
u'بَيْنٌ جَدّ':Added, #1: 1	بَيْنَ جُحُودِ
u'بَيْنٌ جِدار':Added, #2: 2	بَيْنَ الْجَدَّتَيْنِ
u'بَيْنٌ جِدال':Added, #1: 1	بَيْنَ الْجِدَارِ
u'بَيْنٌ جَدَاوِلُ':Added, #1: 1	بَيْنَ الْجِدَالِ
u'بَيْنٌ جُدْرَانٌ':Added, #2: 2	بَيْنَ الْجَدَاوِلِ
u'بَيْنٌ جَديدٌ':Added, #2: 2	بَيْنَ الْجُدْرَانِ
u'بَيْنٌ جَدِيدٌ':Added, #2: 2	بَيْنَ الْجَدِيدِ
u'بَيْنٌ جَدِيدٌ':Added, #2: 2	بَيْنَ الْجَدِيدِ
u'بَيْنٌ جَذَعٌ':Added, #2: 2	بَيْنَ الْجَدِيدَةِ
u'بَيْنٌ جَرٌّ':Added, #1: 1	بَيْنَ الْجَذَعِ
u'بَيْنٌ جَرٌّ':Added, #1: 1	بَيْنَ الْجَرِّ
u'بَيْنٌ جِرَاحَاتٌ':Added, #1: 1	بَيْنَ جَرِّ
u'بَيْنٌ جِرَاحَةٌ':Added, #2: 2	بَيْنَ الْجِرَاحَاتِ
u'بَيْنٌ جِرَاحَةٌ':Added, #1: 1	بَيْنَ جِرَاحَةٍ
u'بَيْنٌ جِرَاحَةٌ':Added, #2: 2	بَيْنَ الْجِرَاحَاتِ
u'بَيْنٌ جَرَادٌ':Added, #2: 2	بَيْنَ الْجِرَاحَةِ
u'بَيْنٌ جِرَّةٌ':Added, #1: 1	بَيْنَ الْجَرَادِ
u'بَيْنٌ جُرْحٌ':Added, #1: 1	بَيْنَ جِرَّتِهِ
u'بَيْنٌ جُرْحٌ':Added, #1: 1	بَيْنَ جُرْحٍ
u'بَيْنٌ جُرْفٌ':Added, #4: 4	بَيْنَ الْجُرْحِ
u'بَيْنٌ جَرْيٌ':Added, #1: 1	بَيْنَ الْجُرْفِ
u'بَيْنٌ جَرَيان':Added, #1: 1	بَيْنَ جَرْيِهِ
u'بَيَّنَ جَزَاءٌ':Predicate, #1: 1	بَيْنَ جَرَيَانِ
u'بَيْنٌ جَزَاءٌ':Added, #1: 1	بَيَّنَ جَزَاءَ
u'بَيْنٌ جَزَاءٌ':Added, #1: 1	بَيْنَ جَزَاءِ
u'بَيْنٌ جزع':Added, #3: 3	بَيْنَ الْجَزَاءِ
u'بَيْنٌ جَزْم':Added, #1: 1	بَيْنَ الْجِزْعِ
u'بَيْنٌ جِزْيَةٌ':Added, #1: 1	بَيْنَ الْجَزْمِ
u'بَيْنٌ جَسَدٌ':Added, #1: 1	بَيْنَ الْجِزْيَةِ
u'بَيْنٌ جِسْمٌ':Added, #1: 1	بَيْنَ الْجَسَدِ
u'بَيْنٌ جِعال':Added, #1: 1	بَيْنَ جِسْمَيْنِ
u'بَيْنٌ جفاف':Added, #1: 1	بَيْنَ الْجِعَالَةِ
u'بَيْنٌ جَفَافٌ':Added, #2: 2	بَيْنَ الْجَفَافِ
u'بَيْنٌ جُفُونٌ':Added, #2: 2	بَيْنَ الْجَفَافِ
u'بَيْنٌ جَلاَلَةٌ':Added, #1: 1	بَيْنَ جُفُونِهِ
u'بَيْنٌ جلد':Added, #1: 1	بَيْنَ الْجَلَالَةِ
u'بَيْنٌ جَلْدٌ':Added, #16: 16	بَيْنَ الْجَلْدِ
u'بَيْنٌ جلد':Added, #16: 16	بَيْنَ الْجَلْدِ
u'بَيْنٌ جِلْدٌ':Added, #2: 2	بَيْنَ جِلْدِ
u'بَيْنٌ جَلْدٌ':Added, #2: 2	بَيْنَ جِلْدِ
u'بَيْنٌ جلد':Added, #5: 5	بَيْنَ جَلْدٍ
u'بَيْنٌ جِلْدٌ':Added, #8: 8	بَيْنَ الْجِلْدِ
u'بَيْنٌ جُلُوسٌ':Added, #8: 8	بَيْنَ الْجِلْدِ
u'بَيْنٌ جُلُوسٌ':Added, #1: 1	بَيْنَ جُلُوسٍ
u'بَيْنٌ جُلُوسٌ':Added, #1: 1	بَيْنَ جُلُوسِهِ
u'بَيْنٌ جَلِيٌّ':Added, #2: 2	بَيْنَ الْجُلُوسِ
u'بَيْنٌ جَلِيٌّ':Added, #1: 1	بَيْنَ الْجَلِيَّةِ
u'بَيْنٌ جَمٌّ':Added, #2: 2	بَيْنَ الْجَلِيِّ
u'بَيْنٌ جماد':Added, #2: 2	بَيْنِ الْجَمِّ
u'بَيْنٌ جَمَادٌ':Added, #1: 1	بَيْنَ الْجَمَادِ
u'بَيْنٌ جِمَارٌ':Added, #1: 1	بَيْنَ الْجَمَادِ
u'بَيْنٌ جَمَاعَةٌ':Added, #2: 2	بَيْنَ الْجِمَارِ
u'بَيْنٌ جَمَاعَةٌ':Added, #1: 1	بَيْنِ الْجَمَاعَةِ
u'بَيْنٌ جَمَاعَةٌ':Added, #31: 31	بَيْنَ جَمَاعَةٍ
u'بَيْنٌ جَمْر':Added, #6: 6	بَيْنَ الْجَمَاعَةِ
u'بَيْنٌ جَمْرَةٌ':Added, #2: 2	بَيْنَ الْجَمْرَتَيْنِ
u'بَيْنٌ جَمْرَة':Added, #2: 2	بَيْنَ جَمْرَةِ
u'بَيْنٌ جمع':Added, #2: 2	بَيْنَ جَمْرَةِ
u'بَيْنٌ جَمْعٌ':Added, #1: 1	بَيْنِ الْجَمْعِ
u'بَيْنٌ جَمْعٌ':Added, #1: 1	بَيْنِ الْجَمْعِ
u'بَيْنٌ جمع':Added, #1: 1	بَيْنَ الْجَمْعَيْنِ
u'بَيْنٌ جَمْعٌ':Added, #3: 3	بَيْنَ الْجَمْعِ
u'بَيْنٌ جمع':Added, #3: 3	بَيْنَ الْجَمْعِ
u'بَيْنٌ جَمْعٌ':Added, #6: 6	بَيْنَ جَمْعِ
u'بَيْنٌ جمعة':Added, #6: 6	بَيْنَ جَمْعِ
u'بَيْنٌ جُمُعَةٌ':Added, #17: 17	بَيْنَ الْجُمُعَةِ
u'بَيْنٌ جُمُعَةٌ':Added, #17: 17	بَيْنَ الْجُمُعَةِ
u'بَيْنٌ جَمَلٌ':Added, #1: 1	بَيْنَ الْجُمُعَاتِ
u'بَيْنٌ جَمَلٌ':Added, #1: 1	بَيْنَ الْجَمَلِ
u'بَيْنٌ جُمَلٌ':Added, #1: 1	بَيْنَ جَمَلَيْنِ
u'بَيَّنَ جُمْلَةٌ':Predicate, #2: 2	بَيْنَ الْجُمَلِ
u'بَيَّنَ جُمْلَةٌ':Predicate, #1: 1	بَيَّنَ الْجُمْلَةَ
u'بَيْنٌ جُمْلَةٌ':Added, #1: 1	بَيَّنَ جُمْلَةَ
u'بَيْنٌ جُمْلَةٌ':Added, #1: 1	بَيْنِ الْجُمْلَةِ
u'بَيْنٌ جُمْلَةٌ':Added, #2: 2	بَيْنَ جُمْلَةِ
u'بَيْنٌ جُمْهُورٌ':Added, #3: 3	بَيْنَ الْجُمْلَةِ
u'بَيْنٌ جُمُوعٌ':Added, #2: 2	بَيْنَ الْجُمْهُورِ
u'بَيْنٌ جُمُوعٌ':Added, #1: 1	بَيْنَ الْجُمُوعِ
u'بَيَّنَ جَمِيع':Predicate, #1: 1	بَيْنَ جُمُوعِ
u'بَيْنٌ جَمِيع':Added, #1: 1	بَيَّنَ الْجَمِيعَ
u'بَيْنٌ جَمِيع':Added, #1: 1	بَيْن الْجَمِيعِ
u'بَيْنٌ جِنٌّ':Added, #21: 21	بَيْنَ الْجَمِيعِ
u'بَيْنٌ جَنَابَةٌ':Added, #2: 2	بَيْنَ الْجِنِّ
u'بَيْنٌ جناح':Added, #2: 2	بَيْنَ الْجَنَابَةِ
u'بَيْنٌ جَنَاحٌ':Added, #1: 1	بَيْنَ الْجَنَاحِ
u'بَيْنٌ جَنَاحٌ':Added, #1: 1	بَيْنَ الْجَنَاحِ
u'بَيْنٌ جِنَايَةٌ':Added, #1: 1	بَيْنَ الْجَنَاحَيْنِ
u'بَيْنٌ جِنَايَةٌ':Added, #1: 1	بَيْنَ جِنَايَةِ
u'بَيْنٌ جِنَايَةٌ':Added, #2: 2	بَيْنَ جِنَايَتِهِ
u'بَيْنٌ جَنْبٌ':Added, #6: 6	بَيْنَ الْجِنَايَةِ
u'بَيْنٌ جَنَّةٌ':Added, #1: 1	بَيْنِ جَنْبِ
u'بَيْنٌ جَنَّةٌ':Added, #1: 1	بَيْنَ جَنَّاتٍ
u'بَيْنٌ جُنْدٌ':Added, #7: 7	بَيْنَ الْجَنَّةِ
u'بَيَّنَ جِنْسٌ':Predicate, #1: 1	بَيْنَ الْجُنْدِ
u'بَيَّنَ جِنْسٌ':Predicate, #3: 3	بَيَّنَ جِنْسَ
u'بَيْنٌ جِنْسٌ':Added, #6: 6	بَيَّنَ الْجِنْسَ
u'بَيْنٌ جِنْسٌ':Added, #1: 1	بَيْنَ جِنْسِ
u'بَيْنٌ جِنْسٌ':Added, #1: 1	بَيْن جِنْسَيْنِ
u'بَيْنٌ جِنْسٌ':Added, #2: 2	بَيْنَ جِنْسَيْنِ
u'بَيْنٌ جِنْسٌ':Added, #5: 5	بَيْنَ الْجِنْسَيْنِ
u'بَيْنٌ جُنُونٌ':Added, #6: 6	بَيْنَ الْجِنْسِ
u'بَيْنٌ جُنُونٌ':Added, #1: 1	بَيْنَ الْجُنُونَيْنِ
u'بَيْنٌ جَنِينٌ':Added, #4: 4	بَيْنَ الْجُنُونِ
u'بَيْنٌ جهاد':Added, #2: 2	بَيْنَ الْجَنِينِ
u'بَيْنٌ جِهَادٌ':Added, #1: 1	بَيْنَ الْجِهَادِ
u'بَيْنٌ جُهَّالٌ':Added, #1: 1	بَيْنَ الْجِهَادِ
u'بَيْنٌ جُهَّالٌ':Added, #1: 1	بَيْنَ الْجُهَّالِ
u'بَيْنٌ جَهالَة':Added, #2: 2	بَيْنَ جُهَّالٍ
u'بَيَّنَ جِهَةٌ':Predicate, #1: 1	بَيْنَ جَهَالَةِ
u'بَيَّنَ جِهَةٌ':Predicate, #3: 3	بَيَّنَ الْجِهَةَ
u'بَيْنٌ جهر':Added, #3: 3	بَيَّنَ جِهَةَ
u'بَيْنٌ جَهْرٌ':Added, #1: 1	بَيْن الْجَهْرِ
u'بَيْنٌ جهر':Added, #1: 1	بَيْن الْجَهْرِ
u'بَيْنٌ جَهْرٌ':Added, #22: 22	بَيْنَ الْجَهْرِ
u'بَيْنٌ جهل':Added, #22: 22	بَيْنَ الْجَهْرِ
u'بَيْنٌ جَهْلٌ':Added, #1: 1	بَيْنَ الْجَهْلِ
u'بَيَّنَ جَوَابٌ':Predicate, #1: 1	بَيْنَ الْجَهْلِ
u'بَيْنٌ جَوَابٌ':Added, #1: 1	بَيَّنَ جَوَابَ
u'بَيْنٌ جَوَابٌ':Added, #1: 1	بَيْنَ جَوَابِ
u'بَيْنٌ جَوَابٌ':Added, #2: 2	بَيْنَ الْجَوَابِ
u'بَيْنٌ جِوَارٌ':Added, #3: 3	بَيْنَ الْجَوَابَيْنِ
u'بَيْنٌ جوارح':Added, #1: 1	بَيْنَ الْجِوَارِ
u'بَيْنٌ جَوَارِحُ':Added, #1: 1	بَيْنَ الْجَوَارِحِ
u'بَيْنٌ جَوَازٌ':Added, #1: 1	بَيْنَ الْجَوَارِحِ
u'بَيْنٌ جَوَازٌ':Added, #2: 2	بَيْنَ الْجَوَازِ
u'بَيْنٌ جَوَامِعُ':Added, #8: 8	بَيْنَ جَوَازِ
u'بَيْنٌ جَوَانِحُ':Added, #1: 1	بَيْنَ الْجَوَامِعِ
u'بَيْنٌ جَوَاهِرُ':Added, #2: 2	بَيْنَ الْجَوَانِحِ
u'بَيْنٌ جَوْرٌ':Added, #1: 1	بَيْنَ الْجَوَاهِرِ
u'بَيْنٌ جَوْفٌ':Added, #1: 1	بَيْنَ جَوْرٍ
u'بَيْنٌ جَوْهَرٌ':Added, #1: 1	بَيْنَ الْجَوْفَيْنِ
u'بَيْنٌ جَوْهَرٌ':Added, #1: 1	بَيْنَ جَوْهَرٍ
u'بَيْنٌ جياد':Added, #1: 1	بَيْنَ جَوْهَرَيْنِ
u'بَيْنٌ جِيَادٌ':Added, #1: 1	بَيْنَ الْجِيَادِ
u'بَيْنٌ جَيِّدٌ':Added, #1: 1	بَيْنَ الْجِيَادِ
u'بَيْنٌ جِيرَانٌ':Added, #1: 1	بَيْنَ جَيِّدِ
u'بَيْنٌ جِيرَانٌ':Added, #1: 1	بَيْنَ جِيرَانِهِ
u'بَيْنٌ جِيرَانٌ':Added, #3: 3	بَيْنَ الْجِيرَانِ
u'بَيْنٌ جَيْشٌ':Added, #4: 4	بَيْنَ جِيرَانٍ
u'بَيْنٌ حاء':Added, #3: 3	بَيْنَ الْجَيْشِ
u'بَيْنٌ حاجِبٌ':Added, #1: 1	بَيْنَ الْحَاءِ
u'بَيْنٌ حادِثٌ':Added, #2: 2	بَيْنَ الْحَاجِبَيْنِ
u'بَيْنٌ حاذِقٌ':Added, #1: 1	بَيْنَ الْحَادِثَتَيْنِ
u'بَيْنٌ حارٌّ':Added, #1: 1	بَيْنَ حَاذِقٍ
u'بَيْنٌ حاصِلٌ':Added, #1: 1	بَيْنَ حَارَّيْنِ
u'بَيْنٌ حاصِلٌ':Added, #1: 1	بَيْنَ الْحَاصِلَةِ
u'بَيْنٌ حاضِرٌ':Added, #2: 2	بَيْنَ الْحَاصِلِ
u'بَيْنٌ حاضِرٌ':Added, #1: 1	بَيْنَ الْحَاضِرَةِ
u'بَيْنٌ حاضِرٌ':Added, #1: 1	بَيْنَ الْحَاضِرَتَيْنِ
u'بَيْنٌ حاضِرٌ':Added, #3: 3	بَيْنَ حَاضِرٍ
u'بَيْنٌ حافِرٌ':Added, #7: 7	بَيْنَ الْحَاضِرِ
u'بَيْنٌ حافِظٌ':Added, #1: 1	بَيْنَ الْحَافِرِ
u'بَيْنٌ حاكِمٌ':Added, #1: 1	بَيْنَ الْحَافِظِ
u'بَيْنٌ حالٌ':Added, #7: 7	بَيْنَ الْحَاكِمِ
u'بَيْنٌ حالٌ':Added, #10: 10	بَيْنَ الْحَالَيْنِ
u'بَيْنٌ حالٌ':Added, #1: 1	بَيْنَ حَالَتَيْنِ
u'بَيْنٌ حالٌ':Added, #2: 2	بَيْنَ حَالٍ
u'بَيْنٌ حالٌ':Added, #7: 7	بَيْنَ حَالِ
u'بَيْنٌ حالٌ':Added, #8: 8	بَيْنَ الْحَالِ
u'بَيَّنَ حالَةٌ':Predicate, #9: 9	بَيْنَ الْحَالَتَيْنِ
u'بَيْنٌ حالَةٌ':Added, #1: 1	بَيَّنَ الْحَالَةَ
u'بَيْنٌ حالَةٌ':Added, #13: 13	بَيْنَ حَالَةِ
u'بَيْنٌ حامِلٌ':Added, #2: 2	بَيْنَ حَالَاتِ
u'بَيْنٌ حائِضٌ':Added, #1: 1	بَيْنَ الْحَامِلِ
u'بَيْنٌ حائِطٌ':Added, #2: 2	بَيْنَ الْحَائِضِ
u'بَيْنٌ حَبٌّ':Added, #1: 1	بَيْنَ الْحَائِطِ
u'بَيْنٌ حَبَّةٌ':Added, #1: 1	بَيْنَ حَبَّاتِ
u'بَيْنٌ حَبْسٌ':Added, #1: 1	بَيْنَ حَبَّاتِ
u'بَيْنٌ حَبْسٌ':Added, #1: 1	بَيْنَ حَبْسِهِ
u'بَيَّنَ حَبْلٌ':Predicate, #2: 2	بَيْنَ الْحَبْسِ
u'بَيْنٌ حَبيبٌ':Added, #1: 1	بَيَّنَ الْحَبْلَ
u'بَيْنٌ حَتّ':Added, #1: 1	بَيْنَ حَبِيبِ
u'بَيْنٌ حَتْمٌ':Added, #1: 1	بَيْنَ الْحَتِّ
u'بَيْنٌ حَجٌّ':Added, #5: 5	بَيْنَ الْحَتْمِ
u'بَيْنٌ حَجٌّ':Added, #1: 1	بَيْنَ حَجِّهِ
u'بَيْنٌ حَجٌّ':Added, #2: 2	بَيْنَ حَجٍّ
u'بَيْنٌ حَجٌّ':Added, #2: 2	بَيْنَ حَجِّ
u'بَيْنٌ حَجّ':Added, #48: 48	بَيْنَ الْحَجِّ
u'بَيْنٌ حَجّ':Added, #5: 5	بَيْنَ حَجَّتَيْنِ
u'بَيْنٌ حجاز':Added, #6: 6	بَيْنَ الْحَجَّتَيْنِ
u'بَيْنٌ حجاز':Added, #1: 1	بَيْن الْحِجَازِ
u'بَيْنٌ حُجَّةٌ':Added, #1: 1	بَيْنَ الْحِجَازِ
u'بَيْنٌ حَجْرٌ':Added, #2: 2	بَيْنَ حُجَّةِ
u'بَيْنٌ حِجْرٌ':Added, #1: 1	بَيْنَ الْحَجْرِ
u'بَيْنٌ حَجْرٌ':Added, #1: 1	بَيْنَ الْحِجْرِ
u'بَيْنٌ حَجَرٌ':Added, #1: 1	بَيْنَ حَجْرِ
u'بَيْنٌ حَجَرٌ':Added, #1: 1	بَيْن حَجَرَيْنِ
u'بَيْنٌ حَجَرٌ':Added, #20: 20	بَيْنَ حَجَرَيْنِ
u'بَيْنٌ حَجيجٌ':Added, #4: 4	بَيْنَ الْحَجَرِ
u'بَيَّنَ حَدٌّ':Predicate, #2: 2	بَيْنَ الْحَجِيجِ
u'بَيْنٌ حَدٌّ':Added, #2: 2	بَيَّنَ الْحَدَّ
u'بَيْنٌ حَدٌّ':Added, #2: 2	بَيْنَ حَدِّ
u'بَيْنٌ حَدٌّ':Added, #3: 3	بَيْنَ الْحَدَّيْنِ
u'بَيْنٌ حَدٌّ':Added, #3: 3	بَيْنَ حَدَّيْنِ
u'بَيْنٌ حَدَثٌ':Added, #6: 6	بَيْنَ الْحَدِّ
u'بَيْنٌ حَدَثٌ':Added, #1: 1	بَيْنَ حَدَثِ
u'بَيْنٌ حَدَثٌ':Added, #3: 3	بَيْنَ الْحَدَثِ
u'بَيْنٌ حُدودٌ':Added, #3: 3	بَيْنَ الْحَدَثَيْنِ
u'بَيْنٌ حُدودٌ':Added, #1: 1	بَيْنَ حُدُودِ
u'بَيْنٌ حُدودٌ':Added, #1: 1	بَيْنَ حُدُودِهِ
u'بَيَّنَ حَديثٌ':Subject, #5: 5	بَيْنَ الْحُدُودِ
u'بَيْنٌ حَديثٌ':Added, #1: 1	بَيَّنَ الْحَدِيثُ
u'بَيْنٌ حَديثٌ':Added, #1: 1	بَيْنَ الْحَدِيثِ
u'بَيْنٌ حَديثٌ':Added, #1: 1	بَيْنَ الْحَدِيثَةِ
u'بَيْنٌ حَديثٌ':Added, #1: 1	بَيْن الْحَدِيثَيْنِ
u'بَيْنٌ حَديثٌ':Added, #23: 23	بَيْنَ الْحَدِيثَيْنِ
u'بَيْنٌ حَديثٌ':Added, #2: 2	بَيْنَ حَدِيثِ
u'بَيْنٌ حَذْف':Added, #2: 2	بَيْنَ حَدِيثَيْنِ
u'بَيْنٌ حَرٌّ':Added, #1: 1	بَيْنَ الْحَذْفِ
u'بَيْنٌ حَرٌّ':Added, #1: 1	بَيْنَ الْحَرِّ
u'بَيْنٌ حُرٌّ':Added, #1: 1	بَيْنَ الْحَرّتَيْنِ
u'بَيْنٌ حَرٌّ':Added, #1: 1	بَيْنَ الْحُرَّتَيْنِ
u'بَيْنٌ حَرٌّ':Added, #1: 1	بَيْنَ حَرِّ
u'بَيْنٌ حَرٌّ':Added, #1: 1	بَيْنَ حَرّتَيْنِ
u'بَيْنٌ حُرٌّ':Added, #1: 1	بَيْنَ حَرَّتَيْنِ
u'بَيْنٌ حُرٌّ':Added, #21: 21	بَيْنَ الْحُرَّةِ
u'بَيْنٌ حُرٌّ':Added, #2: 2	بَيْن حُرَّةٍ
u'بَيْنٌ حُرٌّ':Added, #2: 2	بَيْنَ حُرَّةٍ
u'بَيْنٌ حُرٌّ':Added, #33: 33	بَيْنَ حُرٍّ
u'بَيْنٌ حُرٌّ':Added, #3: 3	بَيْنَ حُرَّيْنِ
u'بَيْنٌ حُرٌّ':Added, #41: 41	بَيْنَ الْحُرِّ
u'بَيْنٌ حِراثَةٌ':Added, #9: 9	بَيْنَ الْحُرَّيْنِ
u'بَيْنٌ حرار':Added, #1: 1	بَيْنَ الْحِرَاثَةِ
u'بَيْنٌ حِراسَةٌ':Added, #1: 1	بَيْنَ الْحِرَارِ
u'بَيْنٌ حَرامٌ':Added, #1: 1	بَيْنَ الْحِرَاسَةِ
u'بَيْنٌ حَرامٌ':Added, #3: 3	بَيْنَ حَرَامٍ
u'بَيْنٌ حَرائِرُ':Added, #4: 4	بَيْنَ الْحَرَامِ
u'بَيْنٌ حَرَائِرُ':Added, #3: 3	بَيْنَ الْحَرَائِرِ
u'بَيْنٌ حَرْبٌ':Added, #3: 3	بَيْنَ الْحَرَائِرِ
u'بَيْنٌ حَرْبِيّ':Added, #3: 3	بَيْنَ الْحَرْبِ
u'بَيْنٌ حَرْبِيّ':Added, #2: 2	بَيْنَ الْحَرْبِيَّيْنِ
u'بَيْنٌ حِرْصٌ':Added, #2: 2	بَيْنَ حَرْبِيَّيْنِ
u'بَيْنٌ حَرْفٌ':Added, #1: 1	بَيْنَ الْحِرْصِ
u'بَيْنٌ حَرْفٌ':Added, #2: 2	بَيْنَ الْحَرْفِ
u'بَيْنٌ حَرْفٌ':Added, #3: 3	بَيْنَ الْحَرْفَيْنِ
u'بَيْنٌ حَرَمٌ':Added, #3: 3	بَيْنَ حَرْفِ
u'بَيْنٌ حِرْمَانٌ':Added, #1: 1	بَيْنَ الْحَرَمِ
u'بَيْنٌ حِرْمَانٌ':Added, #1: 1	بَيْنَ الْحِرْمَانِ
u'بَيَّنَ حُرْمَةٌ':Predicate, #1: 1	بَيْن حِرْمَانِ
u'بَيَّنَ حُرْمَةٌ':Predicate, #1: 1	بَيَّنَ الْحُرْمَةَ
u'بَيْنٌ حُرْمَةٌ':Added, #1: 1	بَيَّنَ حُرْمَةَ
u'بَيْنٌ حُرْمَةٌ':Added, #4: 4	بَيْنَ الْحُرْمَةِ
u'بَيْنٌ حُروفٌ':Added, #7: 7	بَيْنَ حُرْمَةِ
u'بَيَّنَ حُرِّيَّةٌ':Predicate, #3: 3	بَيْنَ الْحُرُوفِ
u'بَيْنٌ حُرِّيَّةٌ':Added, #1: 1	بَيَّنَ الْحُرِّيَّةَ
u'بَيْنٌ حِزْبٌ':Added, #4: 4	بَيْنَ الْحُرِّيَّةِ
u'بَيْنٌ حُزْنٌ':Added, #1: 1	بَيْنَ حِزْبَيْنِ
u'بَيْنٌ حِسْبَةٌ':Added, #1: 1	بَيْنَ الْحُزْنِ
u'بَيْنٌ حسد':Added, #2: 2	بَيْنَ الْحِسْبَةِ
u'بَيْنٌ حَسَدٌ':Added, #1: 1	بَيْنَ الْحَسَدِ
u'بَيْنٌ حَسَنٌ':Added, #1: 1	بَيْنَ الْحَسَدِ
u'بَيْنٌ حَسَنٌ':Added, #1: 1	بَيْنَ الْحَسَنَاتِ
u'بَيْنٌ حَسَنٌ':Added, #1: 1	بَيْنَ حَسَنِ
u'بَيْنٌ حُسْنٌ':Added, #1: 1	بَيْنَ حَسَنَتَيْنِ
u'بَيْنٌ حُسْنٌ':Added, #1: 1	بَيْنَ حُسْنِهِ
u'بَيْنٌ حَسَنٌ':Added, #3: 3	بَيْنَ الْحُسْنِ
u'بَيْنٌ حَسْنَاءُ':Added, #6: 6	بَيْنَ الْحَسَنِ
u'بَيْنٌ حَسَنَةٌ':Added, #1: 1	بَيْنَ الْحَسْنَاءِ
u'بَيْنٌ حَسْو':Added, #1: 1	بَيْنَ الْحَسَنَاتِ
u'بَيْنٌ حِسِّيٌّ':Added, #2: 2	بَيْنَ الْحَسْوِ
u'بَيْنٌ حِسِّيٌّ':Added, #2: 2	بَيْنَ الْحِسِّيِّ
u'بَيْنٌ حِشْمَةٌ':Added, #2: 2	بَيْنَ حِسِّيٍّ
u'بَيْنٌ حِصَانٌ':Added, #1: 1	بَيْنَ حِشْمَةٍ
u'بَيَّنَ حِصَّةٌ':Predicate, #2: 2	بَيْنَ حِصَانٍ
u'بَيْنٌ حَصْرٌ':Added, #1: 1	بَيَّنَ حِصَّةَ
u'بَيْنٌ حُصُول':Added, #1: 1	بَيْنَ الْحَصْرِ
u'بَيْنٌ حَضَانَةٌ':Added, #4: 4	بَيْنَ حُصُولِ
u'بَيْنٌ حَضَرٌ':Added, #1: 1	بَيْنَ حَضَانَتِهِ
u'بَيْنٌ حضرة':Added, #4: 4	بَيْنَ الْحَضَرِ
u'بَيْنٌ حَضْرَةٌ':Added, #2: 2	بَيْنَ حَضْرَةِ
u'بَيْنٌ حُضورٌ':Added, #2: 2	بَيْنَ حَضْرَةِ
u'بَيْنٌ حُضُورٌ':Added, #2: 2	بَيْنَ حُضُورِهِ
u'بَيْنٌ حُضورٌ':Added, #2: 2	بَيْنَ حُضُورِهِ
u'بَيْنٌ حُضُورٌ':Added, #3: 3	بَيْنَ الْحُضُورِ
u'بَيْنٌ حُضورٌ':Added, #3: 3	بَيْنَ الْحُضُورِ
u'بَيْنٌ حُضُورٌ':Added, #3: 3	بَيْنَ حُضُورِ
u'بَيْنٌ حَطّ':Added, #3: 3	بَيْنَ حُضُورِ
u'بَيْنٌ حَظْر':Added, #1: 1	بَيْنَ الْحَطِّ
u'بَيْنٌ حِفْظٌ':Added, #17: 17	بَيْنَ الْحَظْرِ
u'بَيْنٌ حَفْنَةٌ':Added, #1: 1	بَيْنَ الْحِفْظِ
u'بَيَّنَ حَقٌّ':Predicate, #1: 1	بَيْنَ حَفْنَةٍ
u'بَيْنٌ حَقٌّ':Added, #2: 2	بَيَّنَ الْحَقَّ
u'بَيْنٌ حَقٌّ':Added, #10: 10	بَيْنَ الْحَقِّ
u'بَيْنٌ حَقٌّ':Added, #1: 1	بَيْنَ حَقَّيْنِ
u'بَيْنٌ حَقٌّ':Added, #30: 30	بَيْنَ الْحَقَّيْنِ
u'بَيْنٌ حقائق':Added, #9: 9	بَيْنَ حَقِّ
u'بَيْنٌ حَقَائِقُ':Added, #1: 1	بَيْنَ الْحَقَائِقِ
u'بَيْنٌ حقائق':Added, #1: 1	بَيْنَ الْحَقَائِقِ
u'بَيْنٌ حَقَائِقُ':Added, #4: 4	بَيْنَ حَقَائِقِ
u'بَيْنٌ حُقوقٌ':Added, #4: 4	بَيْنَ حَقَائِقِ
u'بَيْنٌ حُقُوقٌ':Added, #1: 1	بَيْنَ الْحُقُوقِ
u'بَيْنٌ حُقوقٌ':Added, #1: 1	بَيْنَ الْحُقُوقِ
u'بَيْنٌ حُقُوقٌ':Added, #5: 5	بَيْنَ حُقُوقِ
u'بَيَّنَ حَقِيقٌ':Predicate, #5: 5	بَيْنَ حُقُوقِ
u'بَيْنٌ حَقِيقٌ':Added, #2: 2	بَيَّنَ حَقِيقَةَ
u'بَيْنٌ حَقِيقٌ':Added, #1: 1	بَيْن الْحَقِيقَةِ
u'بَيْنٌ حَقِيقٌ':Added, #1: 1	بَيْنِ الْحَقِيقَةِ
u'بَيْنٌ حَقِيقٌ':Added, #2: 2	بَيْنَ حَقِيقَةِ
u'بَيْنٌ حَقِيقٌ':Added, #3: 3	بَيْنَ الْحَقِيقَتَيْنِ
u'بَيْنٌ حَقِيقٌ':Added, #5: 5	بَيْنَ حَقِيقَتَيْنِ
u'بَيَّنَ حَقِيقَةٌ':Predicate, #84: 84	بَيْنَ الْحَقِيقَةِ
u'بَيْنٌ حَقِيقَةٌ':Added, #2: 2	بَيَّنَ حَقِيقَةَ
u'بَيْنٌ حَقِيقَةٌ':Added, #1: 1	بَيْن الْحَقِيقَةِ
u'بَيْنٌ حَقِيقَةٌ':Added, #1: 1	بَيْنِ الْحَقِيقَةِ
u'بَيْنٌ حَقِيقَةٌ':Added, #1: 1	بَيْنَ حَقِيقَةٍ
u'بَيْنٌ حَقِيقَةٌ':Added, #2: 2	بَيْنَ حَقِيقَةِ
u'بَيْنٌ حَقِيقِيٌّ':Added, #84: 84	بَيْنَ الْحَقِيقَةِ
u'بَيَّنَ حُكْمٌ':Predicate, #6: 6	بَيْنَ الْحَقِيقِيِّ
u'بَيَّنَ حُكْمٌ':Predicate, #12: 12	بَيَّنَ حُكْمَ
u'بَيْنٌ حُكْمٌ':Added, #3: 3	بَيَّنَ الْحُكْمَ
u'بَيْنٌ حُكْمٌ':Added, #15: 15	بَيْنَ الْحُكْمَيْنِ
u'بَيْنٌ حُكْمٌ':Added, #18: 18	بَيْنَ الْحُكْمِ
u'بَيْنٌ حَكَمٌ':Added, #1: 1	بَيْن الْحُكْمِ
u'بَيْنٌ حُكْمٌ':Added, #2: 2	بَيْنَ الْحَكَمِ
u'بَيْنٌ حُكْمٌ':Added, #4: 4	بَيْنَ حُكْمٍ
u'بَيْنٌ حُكْمٌ':Added, #4: 4	بَيْنَ حُكْمَيْنِ
u'بَيَّنَ حِلٌّ':Predicate, #5: 5	بَيْنَ حُكْمِ
u'بَيْنٌ حِلٌّ':Added, #1: 1	بَيَّنَ حِلَّ
u'بَيْنٌ حِلٌّ':Added, #1: 1	بَيْن الْحِلِّ
u'بَيْنٌ حِلٌّ':Added, #1: 1	بَيْنَ حِلٍّ
u'بَيْنٌ حِلٌّ':Added, #21: 21	بَيْنَ الْحِلِّ
u'بَيْنٌ حَلالٌ':Added, #4: 4	بَيْنَ حِلِّ
u'بَيْنٌ حَلالٌ':Added, #1: 1	بَيْن الْحَلَالِ
u'بَيْنٌ حَلالٌ':Added, #1: 1	بَيْنَ الْحَلاَلِ
u'بَيْنٌ حَلالٌ':Added, #1: 1	بَيْنَ حَلَالِهِ
u'بَيْنٌ حَلالٌ':Added, #1: 1	بَيْنَ حَلَالَيْنِ
u'بَيْنٌ حَلالٌ':Added, #6: 6	بَيْنَ حَلَالٍ
u'بَيْنٌ حَلْب':Added, #9: 9	بَيْنَ الْحَلَالِ
u'بَيْنٌ حَلْب':Added, #2: 2	بَيْنَ الْحَلْبَتَيْنِ
u'بَيْنٌ حلفاء':Added, #2: 2	بَيْنَ حَلْبَيْنِ
u'بَيْنٌ حَلْقٌ':Added, #1: 1	بَيْنَ حُلَفَاءِ
u'بَيْنٌ حَلْقَةٌ':Added, #10: 10	بَيْنَ الْحَلْقِ
u'بَيْنٌ حُلْقُومٌ':Added, #2: 2	بَيْنَ الْحَلْقَةِ
u'بَيْنٌ حلْوٌ':Added, #1: 1	بَيْنَ الْحُلْقُومِ
u'بَيْنٌ حُلُولٌ':Added, #1: 1	بَيْنَ حُلْوٍ
u'بَيْنٌ حُلِيٌّ':Added, #1: 1	بَيْنَ الْحُلُولِ
u'بَيْنٌ حُلِيٌّ':Added, #1: 1	بَيْن الْحُلِيِّ
u'بَيْنٌ حُلِيٌّ':Added, #1: 1	بَيْنَ الْحُلِيِّ
u'بَيْنٌ حِمَارٌ':Added, #1: 1	بَيْنَ حُلِيٍّ
u'بَيْنٌ حِمَارٌ':Added, #1: 1	بَيْنَ حِمَارٍ
u'بَيْنٌ حَمَّالٌ':Added, #2: 2	بَيْنَ الْحِمَارِ
u'بَيْنٌ حَمَّامٌ':Added, #1: 1	بَيْنَ الْحَمَّالِ
u'بَيْنٌ حَمْدٌ':Added, #1: 1	بَيْنَ حَمَّامِ
u'بَيْنٌ حمر':Added, #2: 2	بَيْنَ الْحَمْدِ
u'بَيْنٌ حُمُرٌ':Added, #1: 1	بَيْنَ الْحُمُرِ
u'بَيْنٌ حُمْرَةٌ':Added, #1: 1	بَيْنَ الْحُمُرِ
u'بَيْنٌ حُمْرَةٌ':Added, #1: 1	بَيْنَ الْحُمْرَةِ
u'بَيَّنَ حِمْلٌ':Predicate, #2: 2	بَيْنَ حُمْرَةِ
u'بَيْنٌ حَمْلٌ':Added, #1: 1	بَيَّنَ الْحِمْلَ
u'بَيْنٌ حِمْلٌ':Added, #1: 1	بَيْنَ حَمْلِ
u'بَيْنٌ حَمْلٌ':Added, #1: 1	بَيْنَ حِمْلَيْنِ
u'بَيْنٌ حَمْلٌ':Added, #2: 2	بَيْنَ الْحَمْلِ
u'بَيْنٌ حَمِيل':Added, #2: 2	بَيْنَ حَمْلِهِ
u'بَيْنٌ حَمِيمٌ':Added, #1: 1	بَيْنَ الْحَمِيلِ
u'بَيْنٌ حِنْثٌ':Added, #3: 3	بَيْنَ الْحَمِيمِ
u'بَيْنٌ حِنْثٌ':Added, #1: 1	بَيْنَ حِنْثِ
u'بَيْنٌ حِنْطَةٌ':Added, #2: 2	بَيْنَ الْحِنْثِ
u'بَيْنٌ حَنَفِيَّةٌ':Added, #6: 6	بَيْنَ الْحِنْطَةِ
u'بَيْنٌ حَنَفِيَّةٌ':Added, #1: 1	بَيْنَ حَنَفِيَّةِ
u'بَيْنٌ حَنَكٌ':Added, #7: 7	بَيْنَ الْحَنَفِيَّةِ
u'بَيْنٌ حَواجِزُ':Added, #1: 1	بَيْنَ الْحَنَكِ
u'بَيْنٌ حَوَالَةٌ':Added, #1: 1	بَيْنَ الْحَوَاجِزِ
u'بَيْنٌ حَوَالَةٌ':Added, #1: 1	بَيْنَ حَوَالَةِ
u'بَيْنٌ حَوْضٌ':Added, #3: 3	بَيْنَ الْحَوَالَةِ
u'بَيْنٌ حَوْقَلَةٌ':Added, #1: 1	بَيْنَ حَوْضِهِ
u'بَيْنٌ حول':Added, #1: 1	بَيْنَ الْحَوْقَلَةِ
u'بَيْنٌ حَوْلٌ':Added, #1: 1	بَيْنَ الْحَوْلِ
u'بَيْنٌ حَيٌّ':Added, #1: 1	بَيْنَ الْحَوْلِ
u'بَيْنٌ حَيٌّ':Added, #15: 15	بَيْنَ الْحَيِّ
u'بَيْنٌ حَيٌّ':Added, #1: 1	بَيْنَ الْحَيَّةِ
u'بَيْنٌ حَيٌّ':Added, #1: 1	بَيْنَ حَيَّيْنِ
u'بَيْنٌ حَيَاءٌ':Added, #6: 6	بَيْنَ الْحَيَّيْنِ
u'بَيْنٌ حَيَاةٌ':Added, #1: 1	بَيْنَ الْحَيَاءِ
u'بَيْنٌ حَيَاةٌ':Added, #1: 1	بَيْنَ حَيَاةِ
u'بَيْنٌ حَيَّةٌ':Added, #3: 3	بَيْنَ الْحَيَاةِ
u'بَيْنٌ حَيْض':Added, #1: 1	بَيْنَ الْحَيَّةِ
u'بَيْنٌ حَيْض':Added, #18: 18	بَيْنَ الْحَيْضَتَيْنِ
u'بَيْنٌ حَيْض':Added, #1: 1	بَيْنَ الْحَيْضَيْنِ
u'بَيْنٌ حَيْضٌ':Added, #1: 1	بَيْنَ حَيْضَتَيْنِ
u'بَيْنٌ حَيَوَانٌ':Added, #76: 76	بَيْنَ الْحَيْضِ
u'بَيْنٌ حَيَوَانٌ':Added, #1: 1	بَيْنَ الْحَيَوَانَاتِ
u'بَيْنٌ خَادِمٌ':Added, #3: 3	بَيْنَ الْحَيَوَانِ
u'بَيْنٌ خَارِجٌ':Added, #2: 2	بَيْنَ الْخَادِمَةِ
u'بَيْنٌ خَارِجٌ':Added, #1: 1	بَيْنَ الْخَارِجَيْنِ
u'بَيْنٌ خَارِجٌ':Added, #1: 1	بَيْنَ خَارِجٍ
u'بَيْنٌ خَارِجٌ':Added, #1: 1	بَيْنَ خَارِجِ
u'بَيْنٌ خَارِجٌ':Added, #4: 4	بَيْنَ خَارِجَيْنِ
u'بَيْنٌ خاصّ':Added, #6: 6	بَيْنَ الْخَارِجِ
u'بَيْنٌ خاصّ':Added, #1: 1	بَيْنِ الْخَاصِّ
u'بَيْنٌ خَاصَّةٌ':Added, #7: 7	بَيْنَ الْخَاصِّ
u'بَيْنٌ خَاصِرَةٌ':Added, #1: 1	بَيْنَ الْخَاصَّةِ
u'بَيْنٌ خَاصِرَةٌ':Added, #1: 1	بَيْنَ خَاصِرَتِهِ
u'بَيْنٌ خَاطِبٌ':Added, #2: 2	بَيْنَ الْخَاصِرَةِ
u'بَيْنٌ خَافِقٌ':Added, #1: 1	بَيْنَ الْخَاطِبِ
u'بَيْنٌ خَالٌ':Added, #1: 1	بَيْنَ الْخَافِقَيْنِ
u'بَيْنٌ خَالٌ':Added, #1: 1	بَيْنَ الْخَالَيْنِ
u'بَيْنٌ خَالٌ':Added, #1: 1	بَيْنَ خَالَتَيْنِ
u'بَيْنٌ خَالِدٌ':Added, #4: 4	بَيْنَ الْخَالِ
u'بَيْنٌ خَالِدٌ':Added, #1: 1	بَيْنَ خَالِدِ
u'بَيْنٌ خامس':Added, #4: 4	بَيْنَ خَالِدٍ
u'بَيْنٌ خَامِسٌ':Added, #1: 1	بَيْنَ الْخَامِسِ
u'بَيْنٌ خامس':Added, #1: 1	بَيْنَ الْخَامِسِ
u'بَيْنٌ خَامِسٌ':Added, #3: 3	بَيْنَ الْخَامِسَةِ
u'بَيْنٌ خَامِلٌ':Added, #3: 3	بَيْنَ الْخَامِسَةِ
u'بَيْنٌ خان':Added, #2: 2	بَيْنَ الْخَامِلِ
u'بَيْنٌ خانَة':Added, #1: 1	بَيْنَ الْخَانِيَّةِ
u'بَيْنٌ خَائِنٌ':Added, #1: 1	بَيْنَ الْخَانِيَّةِ
u'بَيْنٌ خُبْثٌ':Added, #1: 1	بَيْنَ الْخَائِنِ
u'بَيْنٌ خَبَرٌ':Added, #1: 1	بَيْنَ خُبْثٍ
u'بَيْنٌ خَبَر':Added, #10: 10	بَيْنَ الْخَبَرَيْنِ
u'بَيْنٌ خَبَرٌ':Added, #10: 10	بَيْنَ الْخَبَرَيْنِ
u'بَيْنٌ خَبَر':Added, #6: 6	بَيْنَ الْخَبَرِ
u'بَيْنٌ خَبَرٌ':Added, #6: 6	بَيْنَ الْخَبَرِ
u'بَيْنٌ خَبَر':Added, #7: 7	بَيْنَ خَبَرِ
u'بَيْنٌ خُبْزٌ':Added, #7: 7	بَيْنَ خَبَرِ
u'بَيْنٌ خدمة':Added, #2: 2	بَيْنَ الْخُبْزِ
u'بَيْنٌ خِدْمَةٌ':Added, #1: 1	بَيْنَ الْخِدْمَةِ
u'بَيْنٌ خراج':Added, #1: 1	بَيْنَ الْخِدْمَةِ
u'بَيْنٌ خَرَاجٌ':Added, #1: 1	بَيْنَ الْخَرَاجِ
u'بَيْنٌ خَرِبٌ':Added, #1: 1	بَيْنَ الْخَرَاجِ
u'بَيْنٌ خَرْج':Added, #1: 1	بَيْنَ الْخَرِبَةِ
u'بَيْنٌ خَرَزِ':Added, #1: 1	بَيْنَ الْخَرْجِ
u'بَيْنٌ خَرَز':Added, #1: 1	بَيْنَ خَرَزَتَيْنِ
u'بَيْنٌ خرق':Added, #1: 1	بَيْنَ خَرَزَتَيْنِ
u'بَيْنٌ خَرْقٌ':Added, #2: 2	بَيْنَ الْخَرْقِ
u'بَيْنٌ خُرُوجٌ':Added, #2: 2	بَيْنَ الْخَرْقِ
u'بَيْنٌ خُرُوجٌ':Added, #2: 2	بَيْنَ خُرُوجِ
u'بَيْنٌ خُرُوجٌ':Added, #2: 2	بَيْنَ خُرُوجِهِ
u'بَيْنٌ خَزٌّ':Added, #3: 3	بَيْنَ الْخُرُوجِ
u'بَيْنٌ خسار':Added, #1: 1	بَيْنَ الْخَزِّ
u'بَيْنٌ خُسُوفٌ':Added, #1: 1	بَيْنَ خَسَارِ
u'بَيْنٌ خَشَبٌ':Added, #1: 1	بَيْنَ خُسُوفِ
u'بَيْنٌ خَشَبٌ':Added, #2: 2	بَيْنَ الْخَشَبَاتِ
u'بَيْنٌ خَشَبَةٌ':Added, #3: 3	بَيْنَ الْخَشَبِ
u'بَيْنٌ خِصَالٌ':Added, #2: 2	بَيْنَ الْخَشَبَاتِ
u'بَيْنٌ خِصَالٌ':Added, #1: 1	بَيْنَ خِصَالِ
u'بَيْنٌ خَصْلٌ':Added, #5: 5	بَيْنَ الْخِصَالِ
u'بَيَّنَ خَصْمٌ':Subject, #1: 1	بَيْنَ خَصْلَتَيْنِ
u'بَيْنٌ خَصْمٌ':Added, #2: 2	بَيَّنَ الْخَصْمُ
u'بَيْنٌ خَصْمٌ':Added, #1: 1	بَيْنَ الْخَصْمِ
u'بَيْنٌ خَصْمٌ':Added, #24: 24	بَيْنَ الْخَصْمَيْنِ
u'بَيْنٌ خُصُومٌ':Added, #7: 7	بَيْنَ خَصْمَيْنِ
u'بَيْنٌ خصية':Added, #13: 13	بَيْنَ الْخُصُومِ
u'بَيْنٌ خُصْيَةٌ':Added, #1: 1	بَيْنَ الْخُصْيَةِ
u'بَيْنٌ خُضْرَةٌ':Added, #1: 1	بَيْنَ الْخُصْيَةِ
u'بَيْنٌ خَطٌّ':Added, #2: 2	بَيْنَ الْخُضْرَةِ
u'بَيْنٌ خِطَابٌ':Added, #4: 4	بَيْنَ الْخَطَّيْنِ
u'بَيْنٌ خِطَابٌ':Added, #1: 1	بَيْنَ خِطَابِ
u'بَيْنٌ خطبة':Added, #3: 3	بَيْنَ الْخِطَابَيْنِ
u'بَيْنٌ خُطْبَةٌ':Added, #1: 1	بَيْنَ خُطْبَةِ
u'بَيْنٌ خطبة':Added, #1: 1	بَيْنَ خُطْبَةِ
u'بَيْنٌ خُطْبَةٌ':Added, #5: 5	بَيْنَ الْخُطْبَةِ
u'بَيْنٌ خُطَّةٌ':Added, #5: 5	بَيْنَ الْخُطْبَةِ
u'بَيَّنَ خَطِيبٌ':Subject, #1: 1	بَيْنَ خُطَّةٍ
u'بَيْنٌ خَفِيٌّ':Added, #2: 2	بَيَّنَ الْخَطِيبُ
u'بَيْنٌ خَفِيفٌ':Added, #1: 1	بَيْنَ الْخَفِيَّةِ
u'بَيْنٌ خَلّاب':Added, #1: 1	بَيْنَ الْخَفِيفِ
u'بَيْنٌ خَلاَعَةٌ':Added, #1: 1	بَيْنَ الْخَلَّابَةِ
u'بَيْنٌ خِلاَفٌ':Added, #1: 1	بَيْنَ الْخَلَاعَةِ
u'بَيْنٌ خِلاَفَةٌ':Added, #1: 1	بَيْنَ الْخِلَافَيْنِ
u'بَيْنٌ خِلاَلٌ':Added, #1: 1	بَيْنَ الْخِلَافَةِ
u'بَيْنٌ خلائق':Added, #1: 1	بَيْنَ خِلَالِ
u'بَيْنٌ خَلائِقُ':Added, #1: 1	بَيْنَ الْخَلَائِقِ
u'بَيْنٌ خلط':Added, #1: 1	بَيْنَ الْخَلَائِقِ
u'بَيْنٌ خُلْعٌ':Added, #1: 1	بَيْنَ خَلْطِ
u'بَيْنٌ خَلَفٌ':Added, #2: 2	بَيْنَ الْخُلْعِ
u'بَيْنٌ خُلَفَاءُ':Added, #4: 4	بَيْنَ الْخَلَفِ
u'بَيْنٌ خلق':Added, #2: 2	بَيْنَ الْخُلَفَاءِ
u'بَيْنٌ خلق':Added, #1: 1	بَيْنَ الْخَلِقِ
u'بَيْنٌ خَلْقٌ':Added, #1: 1	بَيْنِ الْخَلْقِ
u'بَيْنٌ خلق':Added, #1: 1	بَيْنِ الْخَلْقِ
u'بَيْنٌ خَلْقٌ':Added, #1: 1	بَيْنَ خَلْقِ
u'بَيْنٌ خَلْقٌ':Added, #1: 1	بَيْنَ خَلْقٍ
u'بَيْنٌ خلق':Added, #1: 1	بَيْنَ خَلْقِ
u'بَيْنٌ خَلْقٌ':Added, #24: 24	بَيْنَ الْخَلْقِ
u'بَيْنٌ خلق':Added, #24: 24	بَيْنَ الْخَلْقِ
u'بَيْنٌ خَلْقٌ':Added, #6: 6	بَيْنَ خَلْقِهِ
u'بَيْنٌ خَلَلٌ':Added, #6: 6	بَيْنَ خَلْقِهِ
u'بَيْنٌ خَلَلٌ':Added, #1: 1	بَيْنَ خَلَلِ
u'بَيْنٌ خَلْوَةٌ':Added, #1: 1	بَيْنِ خَلَلِ
u'بَيْنٌ خَلِيط':Added, #5: 5	بَيْنَ الْخَلْوَةِ
u'بَيْنٌ خَلِيقٌ':Added, #4: 4	بَيْنَ الْخَلِيطَيْنِ
u'بَيْنٌ خَلِيقَةٌ':Added, #1: 1	بَيْنَ الْخَلِيقَةِ
u'بَيْنٌ خَمْرٌ':Added, #1: 1	بَيْنَ الْخَلِيقَةِ
u'بَيْنٌ خَمْرٌ':Added, #1: 1	بَيْنَ الْخَمْرَيْنِ
u'بَيْنٌ خُمُسٌ':Added, #6: 6	بَيْنَ الْخَمْرِ
u'بَيْنٌ خَمْسٌ':Added, #1: 1	بَيْنَ الْخُمُسِ
u'بَيْنٌ خُمُسٌ':Added, #2: 2	بَيْنَ خَمْسِ
u'بَيْنٌ خَمْسٌ':Added, #2: 2	بَيْنَ خُمُسِ
u'بَيْنٌ خَمْسٌ':Added, #4: 4	بَيْنَ خَمْسٍ
u'بَيْنٌ خَمْسَةٌ':Added, #8: 8	بَيْنَ الْخَمْسِ
u'بَيْنٌ خَمْسَةٌ':Added, #12: 12	بَيْنَ خَمْسَةِ
u'بَيْنٌ خَمْسَةٌ':Added, #2: 2	بَيْنَ الْخَمْسَةِ
u'بَيْنٌ خَنْدَقٌ':Added, #7: 7	بَيْنَ خَمْسَةٍ
u'بَيْنٌ خوارج':Added, #1: 1	بَيْنَ الْخَنْدَقِ
u'بَيْنٌ خَوَارِجُ':Added, #2: 2	بَيْنَ الْخَوَارِجِ
u'بَيْنٌ خَوَاصُّ':Added, #2: 2	بَيْنَ الْخَوَارِجِ
u'بَيْنٌ خَوَاصّ':Added, #2: 2	بَيْنَ الْخَوَاصِّ
u'بَيْنٌ خَوْفٌ':Added, #2: 2	بَيْنَ الْخَوَاصِّ
u'بَيْنٌ خَوْفٌ':Added, #2: 2	بَيْنَ الْخَوْفِ
u'بَيْنٌ خيار':Added, #2: 2	بَيْنَ خَوْفِ
u'بَيْنٌ خِيَارٌ':Added, #10: 10	بَيْنَ خِيَارِ
u'بَيْنٌ خيار':Added, #10: 10	بَيْنَ خِيَارِ
u'بَيْنٌ خِيَارٌ':Added, #1: 1	بَيْنَ الْخِيَارِ
u'بَيْنٌ خيار':Added, #1: 1	بَيْنَ الْخِيَارِ
u'بَيْنٌ خِيَارٌ':Added, #1: 1	بَيْنَ خِيَارٍ
u'بَيْنٌ خِيَارٌ':Added, #1: 1	بَيْنَ خِيَارٍ
u'بَيْنٌ خَيْرٌ':Added, #5: 5	بَيْنَ الْخِيَارَاتِ
u'بَيْنٌ خَيْلٌ':Added, #1: 1	بَيْنَ الْخَيْرَيْنِ
u'بَيْنٌ دَابَّةٌ':Added, #24: 24	بَيْنَ الْخَيْلِ
u'بَيْنٌ دَاخِلٌ':Added, #1: 1	بَيْنَ الدَّابَّةِ
u'بَيْنٌ دَاخِلٌ':Added, #1: 1	بَيْنَ الدَّاخِلَةِ
u'بَيْنٌ دَاخِلَةٌ':Added, #3: 3	بَيْنَ الدَّاخِلِ
u'بَيْنٌ دَارٌ':Added, #1: 1	بَيْنَ الدَّاخِلَةِ
u'بَيْنٌ دَارٌ':Added, #10: 10	بَيْنَ الدَّارِ
u'بَيْنٌ دَارٌ':Added, #1: 1	بَيْنَ الدّارَيْنِ
u'بَيْنٌ دَارٌ':Added, #2: 2	بَيْنَ دَارِهِ
u'بَيْنٌ دَارٌ':Added, #3: 3	بَيْنَ دَارٍ
u'بَيْنٌ دَارٌ':Added, #5: 5	بَيْنَ دَارِ
u'بَيْنٌ دَارٌ':Added, #7: 7	بَيْنَ دَارَيْنِ
u'بَيْنٌ دَاعِي':Added, #9: 9	بَيْنَ الدَّارَيْنِ
u'بَيْنٌ دَافِعٌ':Added, #2: 2	بَيْنَ الدَّاعِيَةِ
u'بَيْنٌ دَائِمٌ':Added, #1: 1	بَيْنَ الدَّافِعِ
u'بَيْنٌ دُبُرٌ':Added, #1: 1	بَيْنَ دَائِمٍ
u'بَيْنٌ دَجَاجٌ':Added, #2: 2	بَيْنَ الدُّبُرِ
u'بَيْنٌ دَجاج':Added, #1: 1	بَيْنَ الدَّجَاجِ
u'بَيَّنَ دُخُولٌ':Predicate, #1: 1	بَيْنَ الدَّجَاجَةِ
u'بَيْنٌ دُخُولٌ':Added, #1: 1	بَيَّنَ دُخُولَ
u'بَيْنٌ دُخُولٌ':Added, #1: 1	بَيْنَ الدّخُولِ
u'بَيْنٌ دُخُولٌ':Added, #1: 1	بَيْنَ الدُّخُولَيْنِ
u'بَيْنٌ دُخُولٌ':Added, #1: 1	بَيْنَ دُخُولِهِ
u'بَيْنٌ دُخُولٌ':Added, #1: 1	بَيْنِ دُخُولِهِ
u'بَيْنٌ دُخُولٌ':Added, #4: 4	بَيْنَ الدُّخُولِ
u'بَيْنٌ دَرَاهِمُ':Added, #4: 4	بَيْنَ دُخُولِ
u'بَيْنٌ دَرَجٌ':Added, #5: 5	بَيْنَ الدَّرَاهِمِ
u'بَيْنٌ دِرْهَمٌ':Added, #5: 5	بَيْنَ الدَّرَجَتَيْنِ
u'بَيْنٌ دِرْهَم':Added, #13: 13	بَيْنَ دِرْهَمٍ
u'بَيْنٌ دِرْهَمٌ':Added, #13: 13	بَيْنَ دِرْهَمٍ
u'بَيْنٌ دِرْهَم':Added, #2: 2	بَيْنَ الدِّرْهَمِ
u'بَيْنٌ دُعَاءٌ':Added, #2: 2	بَيْنَ الدِّرْهَمِ
u'بَيْنٌ دَعْوَةٌ':Added, #1: 1	بَيْنَ الدُّعَاءِ
u'بَيْنٌ دَعْوَى':Added, #1: 1	بَيْنَ دَعْوَةِ
u'بَيْنٌ دفع':Added, #2: 2	بَيْنَ الدَّعْوَيَيْنِ
u'بَيْنٌ دَفْعٌ':Added, #10: 10	بَيْنَ دَفْعِ
u'بَيْنٌ دفع':Added, #10: 10	بَيْنَ دَفْعِ
u'بَيْنٌ دَفْعٌ':Added, #1: 1	بَيْن الدَّفْعِ
u'بَيْنٌ دفع':Added, #1: 1	بَيْن الدَّفْعِ
u'بَيْنٌ دَفْعٌ':Added, #5: 5	بَيْنَ دَفْعِهِ
u'بَيْنٌ دفع':Added, #5: 5	بَيْنَ دَفْعِهِ
u'بَيْنٌ دَفْعٌ':Added, #71: 71	بَيْنَ الدَّفْعِ
u'بَيْنٌ دفن':Added, #71: 71	بَيْنَ الدَّفْعِ
u'بَيْنٌ دَقيقٌ':Added, #1: 1	بَيْنَ الدِّفْنِ
u'بَيْنٌ دِكَّةٌ':Added, #1: 1	بَيْنَ الدَّقِيقِ
u'بَيْنٌ دَلالٌ':Added, #1: 1	بَيْنَ الدِّكَّةِ
u'بَيْنٌ دَلالَةٌ':Added, #1: 1	بَيْنَ الدَّلَالَتَيْنِ
u'بَيْنٌ دَلالَةٌ':Added, #3: 3	بَيْنَ الدَّلَالَةِ
u'بَيْنٌ دَلائِلُ':Added, #3: 3	بَيْنَ دَلَالَةِ
u'بَيْنٌ دَلْوٌ':Added, #4: 4	بَيْنَ الدَّلَائِلِ
u'بَيَّنَ دَليلٌ':Predicate, #1: 1	بَيْنَ الدَّلْوِ
u'بَيَّنَ دَليلٌ':Predicate, #1: 1	بَيَّنَ الدَّلِيلَ
u'بَيْنٌ دَليلٌ':Added, #1: 1	بَيَّنَ دَلِيلَ
u'بَيْنٌ دَليلٌ':Added, #21: 21	بَيْنَ الدَّلِيلَيْنِ
u'بَيْنٌ دَليلٌ':Added, #2: 2	بَيْنَ دَلِيلَيْنِ
u'بَيْنٌ دَليلٌ':Added, #3: 3	بَيْنَ دَلِيلِ
u'بَيْنٌ دَمٌ':Added, #8: 8	بَيْنَ الدَّلِيلِ
u'بَيْنٌ دَمٌ':Added, #1: 1	بَيْن الدَّمَيْنِ
u'بَيْنٌ دَمٌ':Added, #3: 3	بَيْنَ دَمَيْنِ
u'بَيْنٌ دَمٌ':Added, #58: 58	بَيْنَ الدَّمَيْنِ
u'بَيْنٌ دِماءٌ':Added, #9: 9	بَيْنَ الدَّمِ
u'بَيْنٌ دِماغٌ':Added, #2: 2	بَيْنَ الدِّمَاءِ
u'بَيْنٌ دَنٌّ':Added, #1: 1	بَيْنَ الدِّمَاغِ
u'بَيْنٌ دَنانيرُ':Added, #1: 1	بَيْنَ دَنَّيْنِ
u'بَيْنٌ دنيء':Added, #2: 2	بَيْنَ الدَّنَانِيرِ
u'بَيْنٌ دَنيءٌ':Added, #1: 1	بَيْنَ الدَّنِيءِ
u'بَيْنٌ دِهْقانٌ':Added, #1: 1	بَيْنَ الدَّنِيءِ
u'بَيْنٌ دُهْنٌ':Added, #1: 1	بَيْنَ الدِّهْقَانِ
u'بَيْنٌ دَواءٌ':Added, #1: 1	بَيْنَ الدُّهْنِ
u'بَيْنٌ دَوَابُّ':Added, #2: 2	بَيْنَ الدَّوَاءِ
u'بَيْنٌ دَوامٌ':Added, #3: 3	بَيْنَ الدَّوَابِّ
u'بَيْنٌ دَوامٌ':Added, #1: 1	بَيْنَ الدَّوَامِ
u'بَيْنٌ دُودَةٌ':Added, #1: 1	بَيْنَ دَوَامِ
u'بَيْنٌ دُورٌ':Added, #1: 1	بَيْنَ الدُّودَةِ
u'بَيْنٌ دونٌ':Added, #2: 2	بَيْنَ الدُّورِ
u'بَيْنٌ دِيانَةٌ':Added, #1: 1	بَيْنَ دُونِ
u'بَيْنٌ دِيَةٌ':Added, #3: 3	بَيْنَ الدِّيَانَةِ
u'بَيْنٌ دِيَةٌ':Added, #2: 2	بَيْنَ الدِّيَةِ
u'بَيْنٌ دِيكٌ':Added, #4: 4	بَيْنَ دِيَةِ
u'بَيَّنَ دَيْنٌ':Predicate, #1: 1	بَيْنَ الدِّيكَيْنِ
u'بَيْنٌ دَيْنٌ':Added, #1: 1	بَيَّنَ الدَّيْنَ
u'بَيْنٌ دَيْنٌ':Added, #12: 12	بَيْنَ الدَّيْنِ
u'بَيْنٌ دَيْنٌ':Added, #1: 1	بَيْنَ دَيْنَيْنِ
u'بَيْنٌ دَيْنٌ':Added, #2: 2	بَيْنَ الدَّيْنَيْنِ
u'بَيْنٌ دِينارٌ':Added, #7: 7	بَيْنَ دَيْنِ
u'بَيْنٌ دِينِيٌّ':Added, #2: 2	بَيْنَ الدِّينَارِ
u'بَيْنٌ دِينِيٌّ':Added, #1: 1	بَيْنَ الدِّينِيَّةِ
u'بَيْنٌ دُيونٌ':Added, #1: 1	بَيْنَ دِينِيٍّ
u'بَيْنٌ دُيونٌ':Added, #3: 3	بَيْنَ الدُّيُونِ
u'بَيْنٌ ذاتِيٌّ':Added, #3: 3	بَيْنَ دُيُونِ
u'بَيَّنَ ذِراعٌ':Predicate, #1: 1	بَيْنَ الذَّاتِيِّ
u'بَيْنٌ ذَرْقٌ':Added, #1: 1	بَيَّنَ الذِّرَاعَ
u'بَيَّنَ ذكر':Predicate, #1: 1	بَيْنَ ذَرْقِ
u'بَيْنٌ ذكر':Added, #1: 1	بَيَّنَ ذُكِرَ
u'بَيْنٌ ذِكْرٌ':Added, #11: 11	بَيْنَ ذِكْرِ
u'بَيْنٌ ذكر':Added, #11: 11	بَيْنَ ذِكْرِ
u'بَيْنٌ ذَكَرٌ':Added, #1: 1	بَيْن ذِكْرِ
u'بَيْنٌ ذِكْرٌ':Added, #1: 1	بَيْنَ ذَكَرٍ
u'بَيْنٌ ذكر':Added, #1: 1	بَيْن ذِكْرِ
u'بَيْنٌ ذِكْرٌ':Added, #1: 1	بَيْنَ ذِكْرِهِ
u'بَيْنٌ ذَكَرٌ':Added, #1: 1	بَيْنَ ذِكْرِهِ
u'بَيْنٌ ذكر':Added, #1: 1	بَيْنَ ذَكَرَيْنِ
u'بَيْنٌ ذَكَرٌ':Added, #30: 30	بَيْنَ الذَّكَرِ
u'بَيْنٌ ذكر':Added, #30: 30	بَيْنَ الذَّكَرِ
u'بَيْنٌ ذِكْرٌ':Added, #4: 4	بَيْنَ الذِّكْرِ
u'بَيْنٌ ذُكورٌ':Added, #4: 4	بَيْنَ الذِّكْرِ
u'بَيْنٌ ذَكِيٌّ':Added, #14: 14	بَيْنَ الذُّكُورِ
u'بَيْنٌ ذُلٌّ':Added, #1: 1	بَيْنَ الذَّكِيَّةِ
u'بَيْنٌ ذِمَّةٌ':Added, #1: 1	بَيْنَ ذُلِّ
u'بَيْنٌ ذِمِّيٌّ':Added, #1: 1	بَيْنَ ذِمَّةٍ
u'بَيْنٌ ذِمِّيٌّ':Added, #2: 2	بَيْنَ الذِّمِّيَّيْنِ
u'بَيْنٌ ذِمِّيٌّ':Added, #3: 3	بَيْنَ ذِمِّيٍّ
u'بَيْنٌ ذِمِّيٌّ':Added, #4: 4	بَيْنَ ذِمِّيَّيْنِ
u'بَيْنٌ ذَهَابٌ':Added, #6: 6	بَيْنَ الذِّمِّيِّ
u'بَيْنٌ ذَهَابٌ':Added, #1: 1	بَيْنَ ذَهَابِ
u'بَيْنٌ ذَهَابٌ':Added, #1: 1	بَيْنَ ذَهَابِهِ
u'بَيْنٌ ذَهَبٌ':Added, #3: 3	بَيْنَ الذَّهَابِ
u'بَيْنٌ ذَهَبٌ':Added, #1: 1	بَيْنَ الذَّهَبِ
u'بَيْنٌ ذِهْنيٌّ':Added, #2: 2	بَيْنَ الذَّهَبَيْنِ
u'بَيْنٌ ذِئابٌ':Added, #1: 1	بَيْنَ الذِّهْنِيِّ
u'بَيْنٌ ذِئْبٌ':Added, #1: 1	بَيْنَ ذِئَابٍ
u'بَيْنٌ راء':Added, #4: 4	بَيْنَ الذِّئْبِ
u'بَيْنٌ رابع':Added, #1: 1	بَيْنَ الرَّاءِ
u'بَيْنٌ رَابِعٌ':Added, #1: 1	بَيْنَ الرَّابِعَةِ
u'بَيْنٌ رابع':Added, #1: 1	بَيْنَ الرَّابِعَةِ
u'بَيْنٌ رَابِعٌ':Added, #2: 2	بَيْنَ الرَّابِعِ
u'بَيْنٌ رَاجِحٌ':Added, #2: 2	بَيْنَ الرَّابِعِ
u'بَيْنٌ رَأْسٌ':Added, #1: 1	بَيْنَ الرَّاجِحِ
u'بَيْنٌ رَأْسٌ':Added, #4: 4	بَيْنَ رَأْسِ
u'بَيْنٌ رَاسِخٌ':Added, #6: 6	بَيْنَ الرَّأْسِ
u'بَيْنٌ رَافِعٌ':Added, #1: 1	بَيْنَ الرَّاسِخِ
u'بَيْنٌ رَاكِبٌ':Added, #2: 2	بَيْنَ رَافِعِ
u'بَيْنٌ رَاكِدٌ':Added, #2: 2	بَيْنَ الرَّاكِبِ
u'بَيْنٌ رَاكِدٌ':Added, #1: 1	بَيْن الرَّاكِدِ
u'بَيْنٌ رَامِي':Added, #2: 2	بَيْنَ الرَّاكِدِ
u'بَيْنٌ رَاهِنٌ':Added, #1: 1	بَيْنَ الرَّامِيَيْنِ
u'بَيْنٌ رَأْيٌ':Added, #6: 6	بَيْنَ الرَّاهِنِ
u'بَيْنٌ رَائِحٌ':Added, #1: 1	بَيْنَ رَأْيَيْنِ
u'بَيْنٌ رَائِحَةٌ':Added, #1: 1	بَيْنَ الرَّائِحَةِ
u'بَيْنٌ رَائِعٌ':Added, #1: 1	بَيْنَ الرَّائِحَةِ
u'بَيْنٌ رَبُّ':Added, #1: 1	بَيْنَ الرَّائِعَةِ
u'بَيْنٌ رَبُّ':Added, #1: 1	بَيْنَ الرَّبِّ
u'بَيْنٌ رِباعٌ':Added, #27: 27	بَيْنَ رَبِّ
u'بَيْنٌ رِبَاعٌ':Added, #2: 2	بَيْنَ الرِّبَاعِ
u'بَيْنٌ رِبْحٌ':Added, #2: 2	بَيْنَ الرِّبَاعِ
u'بَيْنٌ رُبُعٌ':Added, #1: 1	بَيْنَ الرِّبْحِ
u'بَيْنٌ رَجاء':Added, #2: 2	بَيْنَ رُبُعِ
u'بَيْنٌ رَجَاءٌ':Added, #2: 2	بَيْنَ الرَّجَاءِ
u'بَيْنٌ رِجَالٌ':Added, #2: 2	بَيْنَ الرَّجَاءِ
u'بَيْنٌ رِجَالٌ':Added, #1: 1	بَيْن الرِّجَالِ
u'بَيْنٌ رِجَالٌ':Added, #1: 1	بَيْنَ الرّجَالِ
u'بَيْنٌ رِجَالٌ':Added, #45: 45	بَيْنَ الرِّجَالِ
u'بَيْنٌ رَجَبٌ':Added, #9: 9	بَيْنَ رِجَالٍ
u'بَيْنٌ رَجَزٌ':Added, #2: 2	بَيْنَ رَجَبٍ
u'بَيْنٌ رجعة':Added, #1: 1	بَيْنَ الرَّجَزِ
u'بَيْنٌ رَجْعَةٌ':Added, #2: 2	بَيْنَ الرَّجْعَةِ
u'بَيْنٌ رَجْعِيٌّ':Added, #2: 2	بَيْنَ الرَّجْعَةِ
u'بَيْنٌ رَجُلٌ':Added, #3: 3	بَيْنَ الرَّجْعِيِّ
u'بَيْنٌ رَجُلٌ':Added, #1: 1	بَيْنَ الرّجُلِ
u'بَيْنٌ رِجْلٌ':Added, #1: 1	بَيْن رَجُلَيْنِ
u'بَيْنٌ رَجُلٌ':Added, #1: 1	بَيْنَ رِجْلَيْنِ
u'بَيْنٌ رَجُلٌ':Added, #20: 20	بَيْنَ رَجُلٍ
u'بَيْنٌ رَجُلٌ':Added, #2: 2	بَيْنَ الرّجُلَيْنِ
u'بَيْنٌ رَجُلٌ':Added, #2: 2	بَيْنِ رَجُلَيْنِ
u'بَيْنٌ رَجُلٌ':Added, #30: 30	بَيْنَ الرَّجُلَيْنِ
u'بَيْنٌ رِجْلٌ':Added, #372: 372	بَيْنَ رَجُلَيْنِ
u'بَيْنٌ رَجُلٌ':Added, #3: 3	بَيْنَ الرِّجْلَيْنِ
u'بَيْنٌ رَجْمٌ':Added, #46: 46	بَيْنَ الرَّجُلِ
u'بَيْنٌ رَجْمٌ':Added, #1: 1	بَيْنَ رَجْمٍ
u'بَيْنٌ رُجُوعٌ':Added, #2: 2	بَيْنَ الرَّجْمِ
u'بَيْنٌ رُجُوعٌ':Added, #1: 1	بَيْنَ رُجُوعِ
u'بَيْنٌ رُجُوعٌ':Added, #2: 2	بَيْنَ رُجُوعِهِ
u'بَيْنٌ رَحْبَةٌ':Added, #6: 6	بَيْنَ الرُّجُوعِ
u'بَيْنٌ رُخْصَةٌ':Added, #1: 1	بَيْنِ الرَّحْبَةِ
u'بَيْنٌ رَدٌّ':Added, #1: 1	بَيْنَ الرُّخْصَةِ
u'بَيْنٌ رَدٌّ':Added, #13: 13	بَيْنَ الرَّدِّ
u'بَيْنٌ رَدٌّ':Added, #4: 4	بَيْنَ رَدِّ
u'بَيْنٌ رِدَّةٌ':Added, #6: 6	بَيْنَ رَدِّهِ
u'بَيْنٌ رِدَّةٌ':Added, #1: 1	بَيْنَ رِدَّةٍ
u'بَيْنٌ رِدَّةٌ':Added, #2: 2	بَيْنَ الرِّدَّةِ
u'بَيْنٌ رِدَّةٌ':Added, #2: 2	بَيْنَ رِدَّةِ
u'بَيْنٌ رَذِيلٌ':Added, #3: 3	بَيْنَ رِدَّتِهِ
u'بَيْنٌ رِزْقٌ':Added, #2: 2	بَيْنَ رَذِيلَتَيْنِ
u'بَيْنٌ رِسَالَةٌ':Added, #2: 2	بَيْنَ الرِّزْقِ
u'بَيْنٌ رُسْغٌ':Added, #1: 1	بَيْنَ الرِّسَالَةِ
u'بَيَّنَ رَسُولٌ':Subject, #1: 1	بَيْنَ الرُّسْغَيْنِ
u'بَيْنٌ رَسُولٌ':Added, #2: 2	بَيَّنَ رَسُولُ
u'بَيْنٌ رَسُولٌ':Added, #15: 15	بَيْنَ رَسُولِ
u'بَيْنٌ رُشْدٌ':Added, #4: 4	بَيْنَ الرَّسُولِ
u'بَيْنٌ رَشيدٌ':Added, #1: 1	بَيْنَ رُشْدٍ
u'بَيْنٌ رضاع':Added, #1: 1	بَيْنَ الرَّشِيدِ
u'بَيْنٌ رَضيعٌ':Added, #2: 2	بَيْنَ الرَّضَاعِ
u'بَيْنٌ رَضيعٌ':Added, #1: 1	بَيْنَ الرَّضِيعِ
u'بَيْنٌ رَضيعٌ':Added, #1: 1	بَيْنَ الرَّضِيعَتَيْنِ
u'بَيْنٌ رِطابٌ':Added, #2: 2	بَيْنَ الرَّضِيعَيْنِ
u'بَيْنٌ رِطَابٌ':Added, #1: 1	بَيْنَ الرِّطَابِ
u'بَيْنٌ رَطْبٌ':Added, #1: 1	بَيْنَ الرِّطَابِ
u'بَيْنٌ رُطَبٌ':Added, #10: 10	بَيْنَ الرَّطْبِ
u'بَيْنٌ رَطْبٌ':Added, #1: 1	بَيْنَ الرُّطَبِ
u'بَيْنٌ رُطَبٌ':Added, #1: 1	بَيْنَ الرَّطْبَيْنِ
u'بَيْنٌ رَطْبٌ':Added, #1: 1	بَيْنَ رُطَبِ
u'بَيْنٌ رُعاَةٌ':Added, #1: 1	بَيْنَ رَطْبِهِ
u'بَيْنٌ رَعِيَّةٌ':Added, #1: 1	بَيْنَ رُعَاةِ
u'بَيْنٌ رَعِيَّةٌ':Added, #1: 1	بَيْنَ الرَّعِيَّةِ
u'بَيْنٌ رغب':Added, #2: 2	بَيْنَ رَعِيَّتِهِ
u'بَيْنٌ رَغْبَةٌ':Added, #1: 1	بَيْنَ الرَّغَبِ
u'بَيْنٌ رَغْوَةٌ':Added, #1: 1	بَيْنَ رَغْبَةٍ
u'بَيْنٌ رفاق':Added, #1: 1	بَيْنَ الرَّغْوَةِ
u'بَيْنٌ رِفاقٌ':Added, #8: 8	بَيْنَ الرِّفَاقِ
u'بَيْنٌ رَفْعٌ':Added, #8: 8	بَيْنَ الرِّفَاقِ
u'بَيْنٌ رَفْعٌ':Added, #1: 1	بَيْنَ رَفْعِ
u'بَيْنٌ رِفْقٌ':Added, #3: 3	بَيْنَ الرَّفْعِ
u'بَيْنٌ رِقٌّ':Added, #1: 1	بَيْنَ الرّفْقِ
u'بَيْنٌ رِقابٌ':Added, #1: 1	بَيْنَ الرِّقِّ
u'بَيْنٌ رَقَب':Added, #1: 1	بَيْنَ الرِّقَابِ
u'بَيْنٌ رَقَبَة':Added, #1: 1	بَيْنَ الرَّقَبَاتِ
u'بَيْنٌ رَقيقٌ':Added, #1: 1	بَيْنَ الرَّقَبَاتِ
u'بَيْنٌ رَقيق':Added, #1: 1	بَيْنَ الرَّقِيقِ
u'بَيْنٌ رَقيقٌ':Added, #1: 1	بَيْنَ الرَّقِيقِ
u'بَيْنٌ رَقيقٌ':Added, #1: 1	بَيْن رَقِيقَيْنِ
u'بَيْنٌ ركبة':Added, #4: 4	بَيْنَ رَقِيقَيْنِ
u'بَيْنٌ رُكْبَةٌ':Added, #2: 2	بَيْنَ الرُّكْبَةِ
u'بَيْنٌ ركعة':Added, #2: 2	بَيْنَ الرُّكْبَةِ
u'بَيْنٌ رَكْعَةٌ':Added, #1: 1	بَيْنَ رَكْعَةٍ
u'بَيْنٌ ركعة':Added, #1: 1	بَيْنَ رَكْعَةٍ
u'بَيْنٌ رَكْعَةٌ':Added, #3: 3	بَيْنَ الرَّكْعَةِ
u'بَيَّنَ رُكْنٌ':Predicate, #3: 3	بَيْنَ الرَّكْعَةِ
u'بَيَّنَ رُكْن':Predicate, #1: 1	بَيَّنَ الرُّكْنَ
u'بَيْنٌ رُكْنٌ':Added, #1: 1	بَيَّنَ الرُّكْنَ
u'بَيْنٌ رُكْن':Added, #18: 18	بَيْنَ الرُّكْنَيْنِ
u'بَيْنٌ رُكْنٌ':Added, #18: 18	بَيْنَ الرُّكْنَيْنِ
u'بَيْنٌ رُكْن':Added, #1: 1	بَيْنَ الرّكْنَيْنِ
u'بَيْنٌ رُكْنٌ':Added, #1: 1	بَيْنَ الرّكْنَيْنِ
u'بَيْنٌ رُكْن':Added, #26: 26	بَيْنَ الرُّكْنِ
u'بَيْنٌ رُكْنٌ':Added, #26: 26	بَيْنَ الرُّكْنِ
u'بَيْنٌ رُكْن':Added, #2: 2	بَيْنَ الرّكْنِ
u'بَيْنٌ رُكْنٌ':Added, #2: 2	بَيْنَ الرّكْنِ
u'بَيْنٌ رُكْن':Added, #2: 2	بَيْنَ رُكْنَيْنِ
u'بَيْنٌ رُكوبٌ':Added, #2: 2	بَيْنَ رُكْنَيْنِ
u'بَيْنٌ رُكوبٌ':Added, #1: 1	بَيْنَ رُكُوبِ
u'بَيْنٌ رُكوبٌ':Added, #1: 1	بَيْنَ رُكُوبِهِ
u'بَيْنٌ رُكوعٌ':Added, #5: 5	بَيْنَ الرُّكُوبِ
u'بَيْنٌ رُكوعٌ':Added, #14: 14	بَيْنَ الرُّكُوعِ
u'بَيْنٌ رُكوعٌ':Added, #1: 1	بَيْنَ رُكُوعِهِ
u'بَيْنٌ رُمَاةٌ':Added, #2: 2	بَيْنَ رُكُوعٍ
u'بَيْنٌ رَمَلٌ':Added, #1: 1	بَيْنَ الرُّمَاةِ
u'بَيْنٌ رَمْلٌ':Added, #1: 1	بَيْنَ الرَّمَلِ
u'بَيْنٌ رَمْيٌ':Added, #1: 1	بَيْنَ رَمْلِ
u'بَيْنٌ رَمْيٌ':Added, #13: 13	بَيْنَ الرَّمْيِ
u'بَيْنٌ رَمْيٌ':Added, #1: 1	بَيْنَ رَمْيِ
u'بَيْنٌ رَهْنٌ':Added, #4: 4	بَيْنَ رَمْيِهِ
u'بَيْنٌ رَهْنٌ':Added, #1: 1	بَيْنَ الرَّهْنِ
u'بَيْنٌ رَهْنٌ':Added, #1: 1	بَيْنَ رَهْنِ
u'بَيْنٌ رُوَاةٌ':Added, #1: 1	بَيْنَ رَهْنِهِ
u'بَيْنٌ رَواتِبُ':Added, #1: 1	بَيْنَ الرُّوَاةِ
u'بَيْنٌ رَوَاتِبُ':Added, #1: 1	بَيْنَ الرَّوَاتِبِ
u'بَيْنٌ روائح':Added, #1: 1	بَيْنَ الرَّوَاتِبِ
u'بَيْنٌ رَوائِحُ':Added, #4: 4	بَيْنَ الرَّوَائِحِ
u'بَيْنٌ رَوَائِحُ':Added, #4: 4	بَيْنَ الرَّوَائِحِ
u'بَيْنٌ رِواياتٌ':Added, #4: 4	بَيْنَ الرَّوَائِحِ
u'بَيْنٌ رِوايَةٌ':Added, #19: 19	بَيْنَ الرِّوَايَاتِ
u'بَيْنٌ رِوايَةٌ':Added, #1: 1	بَيْنَ رِوَايَتِهِ
u'بَيْنٌ رِوايَةٌ':Added, #6: 6	بَيْنَ الرِّوَايَةِ
u'بَيْنٌ رَوْثٌ':Added, #8: 8	بَيْنَ رِوَايَةِ
u'بَيْنٌ روحٌ':Added, #1: 1	بَيْنَ الرَّوْثِ
u'بَيْنٌ روحٌ':Added, #1: 1	بَيْنَ الرُّوحِ
u'بَيْنٌ رَوْحٌ':Added, #3: 3	بَيْنَ الرّوحِ
u'بَيْنٌ رَوْضَةٌ':Added, #3: 3	بَيْنَ الرّوحِ
u'بَيْنٌ رُومِيٌّ':Added, #3: 3	بَيْنَ رَوْضَةٍ
u'بَيْنٌ رُومِيٌّ':Added, #1: 1	بَيْنَ الرُّومِيَّاتِ
u'بَيْنٌ رُؤْيَةٌ':Added, #1: 1	بَيْنَ الرُّومِيَّةِ
u'بَيْنٌ رُؤْيَةٌ':Added, #1: 1	بَيْنَ رُؤْيَةِ
u'بَيْنٌ رَياحِينُ':Added, #2: 2	بَيْنَ رُؤْيَتِهِ
u'بَيْنٌ رَيْحانٌ':Added, #1: 1	بَيْنَ الرَّيَاحِينِ
u'بَيْنٌ زائِدٌ':Added, #2: 2	بَيْنَ الرَّيْحَانِ
u'بَيْنٌ زَبيبٌ':Added, #1: 1	بَيْنَ الزَّائِدَيْنِ
u'بَيْنٌ زِراعَةٌ':Added, #1: 1	بَيْنَ الزَّبِيبِ
u'بَيْنٌ زَرْعٌ':Added, #1: 1	بَيْنَ زِرَاعَةِ
u'بَيْنٌ زَرْعٌ':Added, #1: 1	بَيْنَ زَرْعِ
u'بَيْنٌ زُروعٌ':Added, #5: 5	بَيْنَ الزَّرْعِ
u'بَيْنٌ زَريعَةٌ':Added, #1: 1	بَيْنَ الزُّرُوعِ
u'بَيْنٌ زَعْفَرانٌ':Added, #1: 1	بَيْنَ زَرِيعَةٍ
u'بَيْنٌ زَكاةٌ':Added, #1: 1	بَيْنَ الزَّعْفَرَانِ
u'بَيْنٌ زَكاةٌ':Added, #1: 1	بَيْنَ زَكَاةِ
u'بَيْنٌ زَمانٌ':Added, #8: 8	بَيْنَ الزَّكَاةِ
u'بَيْنٌ زَمانٌ':Added, #1: 1	بَيْنَ زَمَانَيْنِ
u'بَيْنٌ زَمانٌ':Added, #2: 2	بَيْنَ الزَّمَانَيْنِ
u'بَيْنٌ زَمانٌ':Added, #3: 3	بَيْنَ الزَّمَانِ
u'بَيَّنَ زَمَنٌ':Predicate, #4: 4	بَيْنَ زَمَانِ
u'بَيَّنَ زَمَنٌ':Predicate, #1: 1	بَيَّنَ الزَّمَنَ
u'بَيْنٌ زَمَنٌ':Added, #3: 3	بَيَّنَ زَمَنَ
u'بَيْنٌ زَمَنٌ':Added, #1: 1	بَيْنَ الزَّمَنِ
u'بَيْنٌ زَمَنٌ':Added, #3: 3	بَيْنَ الزَّمَنَيْنِ
u'بَيْنٌ زناة':Added, #3: 3	بَيْنَ زَمَنِ
u'بَيْنٌ زَوالٌ':Added, #1: 1	بَيْنَ الزُّنَاةِ
u'بَيْنٌ زَوالٌ':Added, #1: 1	بَيْنَ زَوَالِهِ
u'بَيَّنَ زَوْجٌ':Subject, #6: 6	بَيْنَ زَوَالِ
u'بَيْنٌ زَوْجٌ':Added, #4: 4	بَيَّنَ الزَّوْجُ
u'بَيْنٌ زَوْجٌ':Added, #1: 1	بَيْن الزَّوْجَيْنِ
u'بَيْنٌ زَوْجٌ':Added, #1: 1	بَيْنَ زَوْجٍ
u'بَيْنٌ زَوْجٌ':Added, #24: 24	بَيْنَ الزَّوْجِ
u'بَيْنٌ زَوْجٌ':Added, #3: 3	بَيْنَ زَوْجِ
u'بَيْنٌ زَوْجٌ':Added, #4: 4	بَيْنَ الزَّوْجَتَيْنِ
u'بَيْنٌ زَوْجٌ':Added, #4: 4	بَيْنَ زَوْجَيْنِ
u'بَيْنٌ زَوْجَةٌ':Added, #89: 89	بَيْنَ الزَّوْجَيْنِ
u'بَيْنٌ زَوْجَةٌ':Added, #11: 11	بَيْنَ الزَّوْجَةِ
u'بَيْنٌ زَوْجَةٌ':Added, #1: 1	بَيْنَ زَوْجَاتِهِ
u'بَيْنٌ زَوْجَةٌ':Added, #1: 1	بَيْنَ زَوْجَةٍ
u'بَيْنٌ زَوْجَةٌ':Added, #1: 1	بَيْن زَوْجَتِهِ
u'بَيْنٌ زَوْجَةٌ':Added, #2: 2	بَيْنَ زَوْجَةِ
u'بَيْنٌ زَوْجَةٌ':Added, #6: 6	بَيْنَ زَوْجَتِهِ
u'بَيْنٌ زَوْجِيٌّ':Added, #9: 9	بَيْنَ الزَّوْجَاتِ
u'بَيْنٌ زَوْجِيٌّ':Added, #1: 1	بَيْنَ زَوْجِيَّتِهِ
u'بَيْنٌ زِيادَةٌ':Added, #2: 2	بَيْنَ الزَّوْجِيَّةِ
u'بَيْنٌ زِيادَةٌ':Added, #1: 1	بَيْنَ زِيَادَةٍ
u'بَيْنٌ زَيْتٌ':Added, #4: 4	بَيْنَ الزِّيَادَةِ
u'بَيْنٌ زَيْتونٌ':Added, #1: 1	بَيْنَ الزَّيْتَيْنِ
u'بَيْنٌ زَيْدٌ':Added, #1: 1	بَيْنَ الزَّيْتُونِ
u'بَيْنٌ زَيْدٌ':Added, #16: 16	بَيْنَ زَيْدٍ
u'بَيْنٌ زَيْدٌ':Added, #1: 1	بَيْنَ زَيدٍ
u'بَيْنٌ زِينَةٌ':Added, #1: 1	بَيْنَ زَيْدِ
u'بَيْنٌ زُيوفٌ':Added, #1: 1	بَيْنَ الزِّينَةِ
u'بَيْنٌ زُيُوفٌ':Added, #1: 1	بَيْنَ الزُّيُوفِ
u'بَيْنٌ سَابِقٌ':Added, #1: 1	بَيْنَ الزُّيُوفِ
u'بَيْنٌ سَاحِرٌ':Added, #2: 2	بَيْنَ السَّابِقِ
u'بَيْنٌ سَارِحٌ':Added, #2: 2	بَيْنَ السَّاحِرِ
u'بَيْنٌ سَارِي':Added, #1: 1	بَيْنَ سَارِحَةِ
u'بَيْنٌ سَارِي':Added, #3: 3	بَيْنَ سَارِيَتَيْنِ
u'بَيْنٌ سَاعِدٌ':Added, #9: 9	بَيْنَ السَّارِيَتَيْنِ
u'بَيْنٌ سَاقٌ':Added, #1: 1	بَيْنَ السَّاعِدِ
u'بَيْنٌ سَاكِتٌ':Added, #3: 3	بَيْنَ السَّاقِ
u'بَيْنٌ سَالِمٌ':Added, #1: 1	بَيْنَ السَّاكِتِ
u'بَيْنٌ سَامِعٌ':Added, #7: 7	بَيْنَ سَالِمٍ
u'بَيْنٌ سَائِرٌ':Added, #1: 1	بَيْنَ السَّامِعِ
u'بَيْنٌ سَائِرٌ':Added, #28: 28	بَيْنِ سَائِرِ
u'بَيَّنَ سائِل':Subject, #9: 9	بَيْنَ سَائِرِ
u'بَيَّنَ سَائِلٌ':Subject, #1: 1	بَيَّنَ السَّائِلُ
u'بَيْنٌ سائِل':Added, #1: 1	بَيَّنَ السَّائِلُ
u'بَيْنٌ سَائِلٌ':Added, #3: 3	بَيْنَ السَّائِلِ
u'بَيْنٌ سَائِمَةٌ':Added, #3: 3	بَيْنَ السَّائِلِ
u'بَيْنٌ سَائِمَةٌ':Added, #1: 1	بَيْنَ السَّائِمَةِ
u'بَيْنٌ سَبٌّ':Added, #4: 4	بَيْنَ سَائِمَةٍ
u'بَيْنٌ سَبَّابٌ':Added, #1: 1	بَيْنَ السَّبِّ
u'بَيْنٌ سَبَّابٌ':Added, #1: 1	بَيْنَ السّبّابَةِ
u'بَيْنٌ سَبَّابَةٌ':Added, #1: 1	بَيْنَ السَّبَّابَةِ
u'بَيْنٌ سَبَّابَةٌ':Added, #1: 1	بَيْنَ السّبّابَةِ
u'بَيَّنَ سَبَبٌ':Predicate, #1: 1	بَيْنَ السَّبَّابَةِ
u'بَيَّنَ سَبَبٌ':Predicate, #5: 5	بَيَّنَ سَبَبَ
u'بَيْنٌ سَبَبٌ':Added, #6: 6	بَيَّنَ السَّبَبَ
u'بَيْنٌ سَبَبٌ':Added, #1: 1	بَيْنَ السّبَبِ
u'بَيْنٌ سَبَبٌ':Added, #1: 1	بَيْنَ سَبَبِهِ
u'بَيْنٌ سَبَبٌ':Added, #3: 3	بَيْنَ سَبَبٍ
u'بَيْنٌ سَبَبٌ':Added, #4: 4	بَيْنَ السَّبَبَيْنِ
u'بَيْنٌ سَبْعٌ':Added, #6: 6	بَيْنَ السَّبَبِ
u'بَيْنٌ سَبْعٌ':Added, #1: 1	بَيْنَ السَّبْعِ
u'بَيْنٌ سَبُعٌ':Added, #2: 2	بَيْنَ سَبْعٍ
u'بَيْنٌ سَبْعَةٌ':Added, #3: 3	بَيْنَ السَّبُعِ
u'بَيْنٌ سَبْعَةٌ':Added, #1: 1	بَيْنَ السَّبْعَةِ
u'بَيْنٌ سَبْكٌ':Added, #1: 1	بَيْنَ سَبْعَةٍ
u'بَيْنٌ سَبْك':Added, #1: 1	بَيْنَ السَّبْكِ
u'بَيْنٌ سَبْكٌ':Added, #1: 1	بَيْنَ السَّبْكَيْنِ
u'بَيَّنَ سَبِيلٌ':Predicate, #2: 2	بَيْنَ سَبْكِهِ
u'بَيْنٌ سَبِيلٌ':Added, #1: 1	بَيَّنَ السَّبِيلَ
u'بَيْنٌ سَبِيلٌ':Added, #1: 1	بَيْنَ سَبِيلِ
u'بَيْنٌ سِتٌّ':Added, #6: 6	بَيْنَ السَّبِيلَيْنِ
u'بَيْنٌ سِتٌّ':Added, #4: 4	بَيْنَ سِتَّةٍ
u'بَيْنٌ سَتْرٌ':Added, #8: 8	بَيْنَ سِتَّةِ
u'بَيْنٌ سَتْرٌ':Added, #1: 1	بَيْنَ سَتْرِ
u'بَيْنٌ سِتْرٌ':Added, #1: 1	بَيْنَ سَتْرِهِ
u'بَيْنٌ سَتْرٌ':Added, #1: 1	بَيْنَ سِتْرِهِ
u'بَيْنٌ سجدة':Added, #4: 4	بَيْنَ السَّتْرِ
u'بَيْنٌ سَجْدَةٌ':Added, #1: 1	بَيْنَ سَجْدَةِ
u'بَيْنٌ سِجْنٌ':Added, #1: 1	بَيْنَ سَجْدَةِ
u'بَيْنٌ سُجُودٌ':Added, #1: 1	بَيْنَ سِجْنِ
u'بَيْنٌ سُجُودٌ':Added, #1: 1	بَيْنَ سُجُودِ
u'بَيْنٌ سَحَابٌ':Added, #3: 3	بَيْنَ السُّجُودِ
u'بَيْنٌ سِحْرٌ':Added, #2: 2	بَيْنَ السَّحَابِ
u'بَيْنٌ سَخْلَة':Added, #2: 2	بَيْنَ السِّحْرِ
u'بَيْنٌ سَدِيسٌ':Added, #1: 1	بَيْنَ السَّخْلَةِ
u'بَيْنٌ سُرَّةٌ':Added, #1: 1	بَيْنَ السّدِيسِ
u'بَيْنٌ سُرَّةٌ':Added, #28: 28	بَيْنَ سُرَّتِهِ
u'بَيْنٌ سُرَّةٌ':Added, #2: 2	بَيْن السُّرَّةِ
u'بَيْنٌ سُرَّةٌ':Added, #2: 2	بَيْنَ سُرَّةٍ
u'بَيْنٌ سُرَّةٌ':Added, #4: 4	بَيْنَ سُرَّةِ
u'بَيَّنَ سَرقَةٌ':Predicate, #82: 82	بَيْنَ السُّرَّةِ
u'بَيَّنَ سَرِقَةٌ':Predicate, #1: 1	بَيَّنَ السَّرِقَةَ
u'بَيْنٌ سَرقَةٌ':Added, #1: 1	بَيَّنَ السَّرِقَةَ
u'بَيْنٌ سَرِقَةٌ':Added, #1: 1	بَيْنَ السَّرِقَةِ
u'بَيْنٌ سَرقَةٌ':Added, #1: 1	بَيْنَ السَّرِقَةِ
u'بَيْنٌ سَرِقَةٌ':Added, #2: 2	بَيْنَ سَرِقَتِهِ
u'بَيْنٌ سَطْحٌ':Added, #2: 2	بَيْنَ سَرِقَتِهِ
u'بَيْنٌ سَطْحٌ':Added, #1: 1	بَيْنَ سَطْحِ
u'بَيْنٌ سَطْرٌ':Added, #1: 1	بَيْن سَطْحِهِ
u'بَيْنٌ سُطُورٌ':Added, #1: 1	بَيْنَ السَّطْرَيْنِ
u'بَيْنٌ سَعَةٌ':Added, #1: 1	بَيْنَ سُطُورِهِ
u'بَيْنٌ سَعْدٌ':Added, #1: 1	بَيْنَ السَّعَةِ
u'بَيْنٌ سَعْدٌ':Added, #1: 1	بَيْنَ سَعْدِ
u'بَيْنٌ سَعِيدٌ':Added, #2: 2	بَيْنَ سَعْدٍ
u'بَيْنٌ سَفَرٌ':Added, #3: 3	بَيْنَ سَعِيدِ
u'بَيْنٌ سَفَرٌ':Added, #1: 1	بَيْن السَّفَرِ
u'بَيْنٌ سَفَرٌ':Added, #1: 1	بَيْنَ سَفَرٍ
u'بَيْنٌ سَفَرٌ':Added, #1: 1	بَيْنَ سَفَرِ
u'بَيْنٌ سُفْلٌ':Added, #6: 6	بَيْنَ السَّفَرِ
u'بَيْنٌ سُفُنٌ':Added, #1: 1	بَيْنَ سُفْلِ
u'بَيْنٌ سَفِيهٌ':Added, #2: 2	بَيْنَ السُّفُنِ
u'بَيْنٌ سُقُوطٌ':Added, #1: 1	بَيْنَ السَّفِيهِ
u'بَيْنٌ سُقُوطٌ':Added, #1: 1	بَيْنَ سُقُوطِهِ
u'بَيْنٌ سَقْيٌ':Added, #3: 3	بَيْنَ سُقُوطِ
u'بَيْنٌ سَقْيٌ':Added, #1: 1	بَيْنَ سَقْيِهِ
u'بَيْنٌ سُكَّانٌ':Added, #3: 3	بَيْنَ سَقْيِ
u'بَيْنٌ سَكْرَان':Added, #2: 2	بَيْنَ السُّكَّانِ
u'بَيْنٌ سَكَنٌ':Added, #1: 1	بَيْنَ السَّكْرَانِ
u'بَيْنٌ سُكُوتٌ':Added, #1: 1	بَيْنَ السَّكَنِ
u'بَيْنٌ سلام':Added, #6: 6	بَيْنَ السُّكُوتِ
u'بَيْنٌ سَلاَمٌ':Added, #2: 2	بَيْنَ سَلَامِهِ
u'بَيْنٌ سلام':Added, #2: 2	بَيْنَ سَلَامِهِ
u'بَيْنٌ سَلاَمٌ':Added, #4: 4	بَيْنَ سَلَامِ
u'بَيْنٌ سلام':Added, #4: 4	بَيْنَ سَلَامِ
u'بَيْنٌ سَلاَمٌ':Added, #6: 6	بَيْنَ السَّلَامِ
u'بَيْنٌ سَلاَمَةٌ':Added, #6: 6	بَيْنَ السَّلَامِ
u'بَيْنٌ سَلْبٌ':Added, #1: 1	بَيْنَ السَّلَامَةِ
u'بَيْنٌ سُلْطَانٌ':Added, #1: 1	بَيْنَ سَلْبِ
u'بَيْنٌ سَلَفٌ':Added, #1: 1	بَيْنَ السُّلْطَانِ
u'بَيْنٌ سَلَفٌ':Added, #1: 1	بَيْنَ سَلَفِ
u'بَيْنٌ سَلَمٌ':Added, #6: 6	بَيْنَ السَّلَفِ
u'بَيْنٌ سَلِيمٌ':Added, #1: 1	بَيْنَ السَّلَمِ
u'بَيْنٌ سَمَاءٌ':Added, #1: 1	بَيْنَ السَّلِيمَيْنِ
u'بَيْنٌ سَمَاءٌ':Added, #10: 10	بَيْنَ السّمَاءِ
u'بَيْنٌ سَمَاءٌ':Added, #2: 2	بَيْن السَّمَاءِ
u'بَيْنٌ سِماط':Added, #46: 46	بَيْنَ السَّمَاءِ
u'بَيْنٌ سَمَّانٌ':Added, #1: 1	بَيْنَ سِمَاطَيْنِ
u'بَيْنٌ سَمْعٌ':Added, #1: 1	بَيْنَ السَّمَّانِ
u'بَيْنٌ سَمَكٌ':Added, #1: 1	بَيْنَ سَمْعِ
u'بَيْنٌ سَمْنٌ':Added, #1: 1	بَيْن السَّمَكِ
u'بَيْنٌ سَمِينٌ':Added, #1: 1	بَيْنَ السَّمْنِ
u'بَيَّنَ سِنٌّ':Predicate, #1: 1	بَيْنَ السَّمِينِ
u'بَيْنٌ سِنٌّ':Added, #1: 1	بَيَّنَ السِّنَّ
u'بَيْنٌ سَنَامٌ':Added, #1: 1	بَيْنَ السِّنِّ
u'بَيْنٌ سُنْبُلٌ':Added, #1: 1	بَيْنَ السَّنَامِ
u'بَيْنٌ سُنَّةٌ':Added, #1: 1	بَيْنَ السُّنْبُلَةِ
u'بَيْنٌ سَنَةٌ':Added, #10: 10	بَيْنَ السُّنَّةِ
u'بَيْنٌ سَنَةٌ':Added, #1: 1	بَيْنَ السَّنَةِ
u'بَيْنٌ سُنَّةٌ':Added, #1: 1	بَيْنَ سَنَةِ
u'بَيْنٌ سُنَّةٌ':Added, #1: 1	بَيْنَ سُنَّةِ
u'بَيْنٌ سنن':Added, #2: 2	بَيْنَ سُنَّةٍ
u'بَيْنٌ سنن':Added, #1: 1	بَيْنَ سُنَنِ
u'بَيْنٌ سهام':Added, #5: 5	بَيْنَ السُّنَنِ
u'بَيْنٌ سِهَامٌ':Added, #4: 4	بَيْنَ سِهَامِ
u'بَيْنٌ سهام':Added, #4: 4	بَيْنَ سِهَامِ
u'بَيْنٌ سِهَامٌ':Added, #6: 6	بَيْنَ السِّهَامِ
u'بَيْنٌ سَهْمٌ':Added, #6: 6	بَيْنَ السِّهَامِ
u'بَيْنٌ سَهْمٌ':Added, #1: 1	بَيْنَ السَّهْمِ
u'بَيْنٌ سَهْوٌ':Added, #1: 1	بَيْنَ سَهْمَيْنِ
u'بَيْنٌ سُوءٌ':Added, #5: 5	بَيْنَ السَّهْوِ
u'بَيْنٌ سَواد':Added, #1: 1	بَيْنَ سُوءِ
u'بَيْنٌ سَوادٌ':Added, #3: 3	بَيْنَ السَّوَادَيْنِ
u'بَيْنٌ سُؤَالٌ':Added, #5: 5	بَيْنَ السَّوَادِ
u'بَيْنٌ سُؤَالٌ':Added, #1: 1	بَيْنَ السُّؤَالِ
u'بَيْنٌ سُؤَالٌ':Added, #1: 1	بَيْنَ السُّؤَالَيْنِ
u'بَيْنٌ سُؤَالٌ':Added, #1: 1	بَيْنَ سُؤَالِ
u'بَيْنٌ سُؤَالٌ':Added, #1: 1	بَيْنَ سُؤَالِهِ
u'بَيْنٌ سَوائِمُ':Added, #1: 1	بَيْنَ سُؤَالَيْنِ
u'بَيْنٌ سَوَائِمُ':Added, #1: 1	بَيْنَ السَّوَائِمِ
u'بَيْنٌ سورٌ':Added, #1: 1	بَيْنَ السَّوَائِمِ
u'بَيْنٌ سورٌ':Added, #1: 1	بَيْنِ السُّورَتَيْنِ
u'بَيْنٌ سورٌ':Added, #1: 1	بَيْنَ سُوَرِهِ
u'بَيْنٌ سورٌ':Added, #2: 2	بَيْنَ السُّورِ
u'بَيْنٌ سورٌ':Added, #2: 2	بَيْنَ سُوَرِ
u'بَيْنٌ سورٌ':Added, #3: 3	بَيْنَ سُوَرٍ
u'بَيْنٌ سورٌ':Added, #4: 4	بَيْنِ السُّوَرِ
u'بَيْنٌ سورٌ':Added, #4: 4	بَيْنَ سُورَتَيْنِ
u'بَيْنٌ سورٌ':Added, #6: 6	بَيْنَ السُّوَرِ
u'بَيْنٌ سُورَةٌ':Added, #7: 7	بَيْنَ السُّورَتَيْنِ
u'بَيْنٌ سُورَةٌ':Added, #1: 1	بَيْنِ السُّورَةِ
u'بَيْنٌ سُورَةٌ':Added, #1: 1	بَيْنَ سُورَةٍ
u'بَيْنٌ سَوْطٌ':Added, #5: 5	بَيْنَ السُّورَةِ
u'بَيْنٌ سَوْطٌ':Added, #2: 2	بَيْنَ سَوْطَيْنِ
u'بَيْنٌ سَوِيق':Added, #4: 4	بَيْنَ السَّوْطَيْنِ
u'بَيْنٌ سِياطٌ':Added, #1: 1	بَيْنَ السَّوِيقِ
u'بَيْنٌ سَيِّدٌ':Added, #1: 1	بَيْنَ السِّيَاطِ
u'بَيْنٌ سَيِّدٌ':Added, #12: 12	بَيْنَ السَّيِّدِ
u'بَيْنٌ سَيْفٌ':Added, #1: 1	بَيْنَ السَّيِّدَيْنِ
u'بَيْنٌ سُيوفٌ':Added, #1: 1	بَيْنَ السَّيْفِ
u'بَيْنٌ سَيِّئٌ':Added, #1: 1	بَيْنَ سُيُوفٍ
u'بَيْنٌ شَابٌّ':Added, #3: 3	بَيْنَ السَّيِّئَتَيْنِ
u'بَيْنٌ شَابٌّ':Added, #1: 1	بَيْنَ شَابٍّ
u'بَيْنٌ شَاةٌ':Added, #4: 4	بَيْنَ الشَّابَّةِ
u'بَيْنٌ شَاةٌ':Added, #1: 1	بَيْنَ الشَّاةِ
u'بَيْنٌ شَارِبٌ':Added, #5: 5	بَيْنَ شَاةٍ
u'بَيَّنَ شَارِعٌ':Subject, #1: 1	بَيْنَ الشَّارِبِ
u'بَيْنٌ شافِع':Added, #2: 2	بَيَّنَ الشَّارِعُ
u'بَيَّنَ شافِعِيّ':Subject, #3: 3	بَيْنَ الشَّافِعِيَّةِ
u'بَيْنٌ شافِعِيّ':Added, #2: 2	بَيَّنَ الشَّافِعِيُّ
u'بَيْنٌ شافِعِيّ':Added, #2: 2	بَيْنَ الشَّافِعِيِّ
u'بَيْنٌ شَاهِدٌ':Added, #3: 3	بَيْنَ الشَّافِعِيَّةِ
u'بَيْنٌ شَاهِدٌ':Added, #1: 1	بَيْنَ الشَّاهِدَةِ
u'بَيْنٌ شَاهِدٌ':Added, #6: 6	بَيْنَ الشَّاهِدِ
u'بَيْنٌ شَاهِدَةٌ':Added, #9: 9	بَيْنَ الشَّاهِدَيْنِ
u'بَيْنٌ شِبْرٌ':Added, #1: 1	بَيْنَ الشَّاهِدَةِ
u'بَيْنٌ شَبَهٌ':Added, #1: 1	بَيْنَ الشِّبْرِ
u'بَيْنٌ شَبَهٌ':Added, #1: 1	بَيْنَ الشَّبَهِ
u'بَيْنٌ شِتَاءٌ':Added, #2: 2	بَيْنَ الشَّبَهَيْنِ
u'بَيْنٌ شجَاعٌ':Added, #4: 4	بَيْنَ الشِّتَاءِ
u'بَيْنٌ شَجَرٌ':Added, #1: 1	بَيْنَ شُجَاعٍ
u'بَيْنٌ شجعان':Added, #3: 3	بَيْنَ الشَّجَرِ
u'بَيْنٌ شُحٌّ':Added, #2: 2	بَيْنَ الشُّجْعَانِ
u'بَيْنٌ شحمة':Added, #1: 1	بَيْنَ الشُّحِّ
u'بَيْنٌ شَحْمَةٌ':Added, #1: 1	بَيْنِ شَحْمَةِ
u'بَيْنٌ شحمة':Added, #1: 1	بَيْنِ شَحْمَةِ
u'بَيْنٌ شَحْمَةٌ':Added, #3: 3	بَيْنَ شَحْمَةِ
u'بَيْنٌ شَخْصٌ':Added, #3: 3	بَيْنَ شَحْمَةِ
u'بَيْنٌ شَخْصٌ':Added, #1: 1	بَيْن الشَّخْصَيْنِ
u'بَيْنٌ شَخْصٌ':Added, #2: 2	بَيْنَ شَخْصٍ
u'بَيْنٌ شَدٌّ':Added, #8: 8	بَيْنَ شَخْصَيْنِ
u'بَيْنٌ شَدِّ':Added, #1: 1	بَيْنَ الشَّدِّ
u'بَيْنٌ شَدّ':Added, #1: 1	بَيْنَ شَدَّيْنِ
u'بَيْنٌ شَرٌّ':Added, #1: 1	بَيْنَ شَدَّيْنِ
u'بَيْنٌ شِرَاءٌ':Added, #2: 2	بَيْنَ الشَّرِّ
u'بَيْنٌ شِرَاءٌ':Added, #1: 1	بَيْن الشِّرَاءِ
u'بَيْنٌ شِرَاءٌ':Added, #1: 1	بَيْنَ شِرَاءِ
u'بَيَّنَ شَرَائِعُ':Predicate, #8: 8	بَيْنَ الشِّرَاءِ
u'بَيْنٌ شَرَائِعُ':Added, #1: 1	بَيَّنَ شَرَائِعَ
u'بَيْنٌ شرب':Added, #1: 1	بَيْنَ الشَّرَائِعِ
u'بَيْنٌ شُرْبٌ':Added, #1: 1	بَيْنَ شُرْبِ
u'بَيْنٌ شرب':Added, #1: 1	بَيْنَ شُرْبِ
u'بَيْنٌ شُرْبٌ':Added, #2: 2	بَيْنَ الشُّرْبِ
u'بَيْنٌ شَرِسٌ':Added, #2: 2	بَيْنَ الشُّرْبِ
u'بَيَّنَ شَرْطٌ':Predicate, #1: 1	بَيْنَ الشَّرِسَةِ
u'بَيَّنَ شَرْطٌ':Predicate, #1: 1	بَيَّنَ الشَّرْطَ
u'بَيْنٌ شَرَطٌ':Added, #3: 3	بَيَّنَ شَرْطَ
u'بَيْنٌ شَرْطٌ':Added, #1: 1	بَيْنَ الشَّرَطِ
u'بَيْنٌ شَرْطٌ':Added, #25: 25	بَيْنَ الشَّرْطِ
u'بَيْنٌ شَرْطٌ':Added, #2: 2	بَيْنَ الشَّرْطَيْنِ
u'بَيْنٌ شَرْطٌ':Added, #3: 3	بَيْنَ شَرْطٍ
u'بَيْنٌ شَرْطٌ':Added, #4: 4	بَيْنَ شَرْطِ
u'بَيَّنَ شَرْعٌ':Subject, #5: 5	بَيْنَ شَرْطَيْنِ
u'بَيْنٌ شَرْعٌ':Added, #1: 1	بَيَّنَ الشَّرْعُ
u'بَيْنٌ شَرْعِيٌّ':Added, #1: 1	بَيْنَ الشَّرْعِ
u'بَيْنٌ شرق':Added, #1: 1	بَيْنَ الشَّرْعِيِّ
u'بَيْنٌ شَرْقٌ':Added, #1: 1	بَيْنَ الشَّرْقِ
u'بَيْنٌ شركاء':Added, #1: 1	بَيْنَ الشَّرْقِ
u'بَيْنٌ شركة':Added, #24: 24	بَيْنَ الشُّرَكَاءِ
u'بَيْنٌ شَرِكَةٌ':Added, #1: 1	بَيْنَ الشَّرِكَةِ
u'بَيْنٌ شَرَهٌ':Added, #1: 1	بَيْنَ الشَّرِكَةِ
u'بَيَّنَ شُرُوطٌ':Predicate, #1: 1	بَيْنَ الشَّرَهِ
u'بَيْنٌ شُرُوطٌ':Added, #1: 1	بَيَّنَ شُرُوطَ
u'بَيْنٌ شُرُوطٌ':Added, #1: 1	بَيْنَ الشُّرُوطِ
u'بَيْنٌ شُرُوعٌ':Added, #1: 1	بَيْنَ شُرُوطِ
u'بَيْنٌ شَرِيعَةٌ':Added, #1: 1	بَيْنَ الشُّرُوعِ
u'بَيْنٌ شَرِيفٌ':Added, #1: 1	بَيْنَ الشَّرِيعَةِ
u'بَيْنٌ شَرِيفٌ':Added, #1: 1	بَيْنَ الشَّرِيفِ
u'بَيْنٌ شَرِيكٌ':Added, #1: 1	بَيْنَ الشَّرِيفَةِ
u'بَيْنٌ شَرِيكٌ':Added, #1: 1	بَيْنَ شَرِيكِ
u'بَيْنٌ شَرِيكٌ':Added, #36: 36	بَيْنَ الشَّرِيكَيْنِ
u'بَيْنٌ شَرِيكٌ':Added, #3: 3	بَيْنَ الشَّرِيكِ
u'بَيْنٌ شَطْرٌ':Added, #54: 54	بَيْنَ شَرِيكَيْنِ
u'بَيْنٌ شَطْرٌ':Added, #1: 1	بَيْنَ الشَّطْرَيْنِ
u'بَيْنٌ شِعَابٌ':Added, #1: 1	بَيْنَ شَطْرِ
u'بَيْنٌ شعار':Added, #1: 1	بَيْنَ شِعَابٍ
u'بَيْنٌ شِعَارٌ':Added, #1: 1	بَيْنَ الشِّعَارِ
u'بَيْنٌ شَعْبِيٌّ':Added, #1: 1	بَيْنَ الشِّعَارِ
u'بَيْنٌ شَعْرٌ':Added, #1: 1	بَيْنَ الشَّعْبِيِّ
u'بَيْنٌ شَعْرٌ':Added, #1: 1	بَيْنَ الشَّعْرِ
u'بَيْنٌ شَعِير':Added, #2: 2	بَيْنَ شَعْرِهِ
u'بَيْنٌ شَفَاعَةٌ':Added, #4: 4	بَيْنَ شَعِيرَتَيْنِ
u'بَيْنٌ شُفْرٌ':Added, #2: 2	بَيْنَ الشَّفَاعَةِ
u'بَيْنٌ شَفْعٌ':Added, #3: 3	بَيْنَ الشُّفْرَيْنِ
u'بَيْنٌ شَفْعٌ':Added, #5: 5	بَيْنَ الشَّفْعَيْنِ
u'بَيْنٌ شفق':Added, #9: 9	بَيْنَ الشَّفْعِ
u'بَيْنٌ شَفَقٌ':Added, #1: 1	بَيْنَ الشَّفَقِ
u'بَيْنٌ شَفِيعٌ':Added, #1: 1	بَيْنَ الشَّفَقِ
u'بَيْنٌ شَكٌّ':Added, #9: 9	بَيْنَ الشَّفِيعِ
u'بَيْنٌ شَكٌّ':Added, #1: 1	بَيْنَ شَكِّهِ
u'بَيَّنَ شكر':Predicate, #8: 8	بَيْنَ الشَّكِّ
u'بَيْنٌ شمس':Added, #1: 1	بَيَّنَ شَكَرَ
u'بَيْنٌ شَمْسٌ':Added, #5: 5	بَيْنَ الشَّمْسِ
u'بَيْنٌ شَهَادَةٌ':Added, #5: 5	بَيْنَ الشَّمْسِ
u'بَيْنٌ شَهَادَةٌ':Added, #18: 18	بَيْنَ الشَّهَادَةِ
u'بَيَّنَ شَهْرٌ':Predicate, #3: 3	بَيْنَ شَهَادَةِ
u'بَيْنٌ شَهْرٌ':Added, #1: 1	بَيَّنَ الشَّهْرَ
u'بَيْنٌ شُهُودٌ':Added, #1: 1	بَيْنَ شَهْرَيْنِ
u'بَيْنٌ شُهُودٌ':Added, #1: 1	بَيْنَ شُهُودِ
u'بَيْنٌ شُهُودٌ':Added, #2: 2	بَيْنَ شُهُودِهِ
u'بَيْنٌ شَهِيدٌ':Added, #9: 9	بَيْنَ الشُّهُودِ
u'بَيْنٌ شَيْءٌ':Added, #2: 2	بَيْنَ الشَّهِيدِ
u'بَيْنٌ شَيْءٌ':Added, #1: 1	بَيْن الشَّيْءِ
u'بَيْنٌ شَيْءٌ':Added, #5: 5	بَيْنَ الشَّيْءِ
u'بَيْنٌ شَيَاطِينُ':Added, #7: 7	بَيْنَ شَيْءٍ
u'بَيْنٌ شَيَاطِينُ':Added, #1: 1	بَيْنِ الشَّيَاطِينِ
u'بَيْنٌ شِيَاهٌ':Added, #3: 3	بَيْنَ الشَّيَاطِينِ
u'بَيَّنَ شَيْخٌ':Subject, #2: 2	بَيْنَ الشِّيَاهِ
u'بَيْنٌ شَيْخٌ':Added, #2: 2	بَيَّنَ الشَّيْخُ
u'بَيْنٌ شَيْخٌ':Added, #1: 1	بَيْنَ شَيْخٍ
u'بَيْنٌ شَيْخٌ':Added, #2: 2	بَيْنَ شَيْخَيْنِ
u'بَيْنٌ شَيْخٌ':Added, #6: 6	بَيْنَ الشَّيْخِ
u'بَيْنٌ شِيمَةٌ':Added, #9: 9	بَيْنَ الشَّيْخَيْنِ
u'بَيْنٌ شُيُوخٌ':Added, #1: 1	بَيْنَ شِيمَتِهِ
u'بَيَّنَ صَاحِبٌ':Subject, #2: 2	بَيْنَ الشُّيُوخِ
u'بَيْنٌ صَاحِبٌ':Added, #2: 2	بَيَّنَ صَاحِبُ
u'بَيْنٌ صَاحِبٌ':Added, #15: 15	بَيْنَ صَاحِبِ
u'بَيْنٌ صَادِرٌ':Added, #5: 5	بَيْنَ الصَّاحِبَيْنِ
u'بَيْنٌ صَادِقٌ':Added, #1: 1	بَيْنَ الصَّادِرِ
u'بَيْنٌ صَاعِقَةٌ':Added, #1: 1	بَيْنَ الصَّادِقِ
u'بَيْنٌ صالِح':Added, #2: 2	بَيْنَ الصَّاعِقَةِ
u'بَيْنٌ صَالِحٌ':Added, #1: 1	بَيْنَ الصَّالِحِيَّةِ
u'بَيْنٌ صَالِح':Added, #1: 1	بَيْنَ صَالِحِ
u'بَيْنٌ صَالِحٌ':Added, #1: 1	بَيْنَ صَالِحِ
u'بَيْنٌ صَالِح':Added, #2: 2	بَيْنَ الصَّالِحِ
u'بَيْنٌ صالِحَة':Added, #2: 2	بَيْنَ الصَّالِحِ
u'بَيْنٌ صُبْحٌ':Added, #1: 1	بَيْنَ الصَّالِحِيَّةِ
u'بَيْنٌ صُبْحٌ':Added, #1: 1	بَيْنَ صُبْحٍ
u'بَيْنٌ صبر':Added, #4: 4	بَيْنَ الصُّبْحِ
u'بَيْنٌ صَبْرٌ':Added, #2: 2	بَيْنَ الصَّبْرِ
u'بَيَّنَ صَبْغٌ':Predicate, #2: 2	بَيْنَ الصَّبْرِ
u'بَيْنٌ صَبِيٌّ':Added, #1: 1	بَيَّنَ الصَّبْغَ
u'بَيْنٌ صَبِيٌّ':Added, #12: 12	بَيْنَ الصَّبِيِّ
u'بَيْنٌ صَبِيٌّ':Added, #1: 1	بَيْن الصَّبِيِّ
u'بَيْنٌ صَبِيٌّ':Added, #1: 1	بَيْنَ صَبِيٍّ
u'بَيْنٌ صَبِيٌّ':Added, #3: 3	بَيْنَ صَبِيَّيْنِ
u'بَيْنٌ صِبْيَانٌ':Added, #4: 4	بَيْنَ الصَّبِيَّيْنِ
u'بَيْنٌ صَحَابَةٌ':Added, #4: 4	بَيْنَ الصِّبْيَانِ
u'بَيْنٌ صَحَابَةٌ':Added, #1: 1	بَيْنَ الصّحَابَةِ
u'بَيْنٌ صَحَابَةٌ':Added, #1: 1	بَيْنِ الصَّحَابَةِ
u'بَيْنٌ صَحَابِيٌّ':Added, #42: 42	بَيْنَ الصَّحَابَةِ
u'بَيْنٌ صَحَابِيٌّ':Added, #1: 1	بَيْنَ الصَّحَابِيِّ
u'بَيْنٌ صحبة':Added, #1: 1	بَيْنَ صَحَابِيٍّ
u'بَيْنٌ صُحْبَةٌ':Added, #1: 1	بَيْنَ صُحْبَةِ
u'بَيْنٌ صِحَّةٌ':Added, #1: 1	بَيْنَ صُحْبَةِ
u'بَيْنٌ صِحَّةٌ':Added, #10: 10	بَيْنَ الصِّحَّةِ
u'بَيَّنَ صَحِيحٌ':Predicate, #9: 9	بَيْنَ صِحَّةِ
u'بَيْنٌ صَحِيحٌ':Added, #1: 1	بَيَّنَ الصَّحِيحَ
u'بَيْنٌ صَحِيحٌ':Added, #14: 14	بَيْنَ الصَّحِيحِ
u'بَيْنٌ صَحِيحٌ':Added, #1: 1	بَيْنَ الصَّحِيحَةِ
u'بَيْنٌ صَحِيحٌ':Added, #1: 1	بَيْنَ صَحِيحَيْنِ
u'بَيْنٌ صداق':Added, #4: 4	بَيْنَ الصَّحِيحَيْنِ
u'بَيْنٌ صَدَاقٌ':Added, #1: 1	بَيْنَ صَدَاقٍ
u'بَيْنٌ صداق':Added, #1: 1	بَيْنَ صَدَاقٍ
u'بَيْنٌ صَدَاقٌ':Added, #7: 7	بَيْنَ الصَّدَاقِ
u'بَيْنٌ صَدْرٌ':Added, #7: 7	بَيْنَ الصَّدَاقِ
u'بَيْنٌ صَدْرٌ':Added, #1: 1	بَيْنَ صَدْرِهِ
u'بَيْنٌ صَدْرٌ':Added, #2: 2	بَيْنَ صَدْرِ
u'بَيْنٌ صُدْغٌ':Added, #3: 3	بَيْنَ الصَّدْرِ
u'بَيْنٌ صدق':Added, #2: 2	بَيْنَ الصُّدْغِ
u'بَيْنٌ صِدْقٌ':Added, #16: 16	بَيْنَ الصِّدْقِ
u'بَيْنٌ صدقة':Added, #16: 16	بَيْنَ الصِّدْقِ
u'بَيْنٌ صَدَقَةٌ':Added, #11: 11	بَيْنَ الصَّدَقَةِ
u'بَيْنٌ صدقة':Added, #11: 11	بَيْنَ الصَّدَقَةِ
u'بَيْنٌ صَدَقَةٌ':Added, #1: 1	بَيْنَ صَدَقَةِ
u'بَيْنٌ صرام':Added, #1: 1	بَيْنَ صَدَقَةِ
u'بَيْنٌ صَرْفٌ':Added, #1: 1	بَيْنَ صِرَامِ
u'بَيْنٌ صَرْف':Added, #1: 1	بَيْن صَرْفِ
u'بَيْنٌ صَرْفٌ':Added, #1: 1	بَيْن صَرْفِ
u'بَيْنٌ صَرْف':Added, #1: 1	بَيْنَ صَرْفِهِ
u'بَيْنٌ صَرْفٌ':Added, #1: 1	بَيْنَ صَرْفِهِ
u'بَيْنٌ صَرْف':Added, #2: 2	بَيْنَ صَرْفِ
u'بَيْنٌ صَرِيحٌ':Added, #2: 2	بَيْنَ صَرْفِ
u'بَيْنٌ صَرِيحٌ':Added, #1: 1	بَيْنَ الصَّرِيحِ
u'بَيْنٌ صَرِيحٌ':Added, #1: 1	بَيْنَ صَرِيحِ
u'بَيْنٌ صغار':Added, #2: 2	بَيْنَ صَرِيحِهِ
u'بَيْنٌ صِغَرٌ':Added, #9: 9	بَيْنَ الصِّغَارِ
u'بَيْنٌ صَغِيرٌ':Added, #1: 1	بَيْنَ الصِّغَرِ
u'بَيْنٌ صَغِيرٌ':Added, #1: 1	بَيْنَ صَغِيرَةٍ
u'بَيْنٌ صَغِيرٌ':Added, #1: 1	بَيْنَ صَغِيرَةِ
u'بَيْنٌ صَغِيرٌ':Added, #22: 22	بَيْنَ الصَّغِيرِ
u'بَيْنٌ صَغِيرٌ':Added, #2: 2	بَيْنَ الصَّغِيرَيْنِ
u'بَيْنٌ صَغِيرٌ':Added, #3: 3	بَيْنَ الصَّغِيرَتَيْنِ
u'بَيْنٌ صَغِيرٌ':Added, #3: 3	بَيْنَ صَغِيرِ
u'بَيْنٌ صَغِيرٌ':Added, #6: 6	بَيْنَ الصَّغِيرَةِ
u'بَيْنٌ صَفٌّ':Added, #6: 6	بَيْنَ صَغِيرٍ
u'بَيْنٌ صَفٌّ':Added, #2: 2	بَيْنَ صَفَّيْنِ
u'بَيْنٌ صَفٌّ':Added, #37: 37	بَيْنَ الصَّفَّيْنِ
u'بَيْنٌ صَفٌّ':Added, #5: 5	بَيْنَ الصَّفِّ
u'بَيْنٌ صَفٌّ':Added, #5: 5	بَيْنَ الصّفّيْنِ
u'بَيْنٌ صِفَاقٌ':Added, #7: 7	بَيْنَ صَفِّ
u'بَيَّنَ صِفَةٌ':Predicate, #1: 1	بَيْنِ صِفَاقٍ
u'بَيَّنَ صِفَةٌ':Predicate, #10: 10	بَيَّنَ صِفَةَ
u'بَيْنٌ صِفَةٌ':Added, #1: 1	بَيَّنَ الصِّفَةَ
u'بَيْنٌ صِفَةٌ':Added, #2: 2	بَيْنَ الصِّفَاتِ
u'بَيْنٌ صِفَةٌ':Added, #2: 2	بَيْنَ صِفَةِ
u'بَيْنٌ صِفَةٌ':Added, #3: 3	بَيْنَ الصِّفَةِ
u'بَيْنٌ صُفْرَةٌ':Added, #3: 3	بَيْنَ صِفَاتِ
u'بَيْنٌ صَفْقَةٌ':Added, #1: 1	بَيْنَ الصُّفْرَةِ
u'بَيْنٌ صُفُوفٌ':Added, #1: 1	بَيْنَ الصَّفْقَةِ
u'بَيْنٌ صُفُوفٌ':Added, #1: 1	بَيْنَ الصّفُوفِ
u'بَيَّنَ صَلاَةٌ':Predicate, #4: 4	بَيْنَ الصُّفُوفِ
u'بَيَّنَ صَلاَةٌ':Predicate, #1: 1	بَيَّنَ الصَّلَاةَ
u'بَيْنٌ صَلاَةٌ':Added, #1: 1	بَيَّنَ صَلَاةَ
u'بَيْنٌ صَلاَةٌ':Added, #16: 16	بَيْنَ صَلَاةِ
u'بَيْنٌ صَلاَةٌ':Added, #26: 26	بَيْنَ الصَّلَاةِ
u'بَيْنٌ صَلاَةٌ':Added, #2: 2	بَيْنَ الصّلَاةِ
u'بَيْنٌ صَلاَةٌ':Added, #3: 3	بَيْنَ صَلاةِ
u'بَيْنٌ صَلاَةٌ':Added, #4: 4	بَيْنَ صَلَاتِهِ
u'بَيْنٌ صَلاَةٌ':Added, #5: 5	بَيْنَ الصَّلاَةِ
u'بَيْنٌ صلْبٌ':Added, #6: 6	بَيْنَ صَلاَةِ
u'بَيْنٌ صلْبٌ':Added, #1: 1	بَيْن الصَّلْبِ
u'بَيْنٌ صلْبٌ':Added, #1: 1	بَيْنَ الصَّلْبِ
u'بَيْنٌ صلْبٌ':Added, #1: 1	بَيْنَ الصُّلْبِ
u'بَيْنٌ صَلْبٌ':Added, #1: 1	بَيْنِ الصُّلْبِ
u'بَيْنٌ صَلْبٌ':Added, #1: 1	بَيْن الصَّلْبِ
u'بَيْنٌ صلْبٌ':Added, #1: 1	بَيْنَ الصَّلْبِ
u'بَيْنٌ صِلَةٌ':Added, #1: 1	بَيْنِ صُلْبِ
u'بَيْنٌ صلح':Added, #1: 1	بَيْنَ الصِّلَةِ
u'بَيْنٌ صُلْحٌ':Added, #3: 3	بَيْنَ الصُّلْحِ
u'بَيْنٌ صَلَوَاتٌ':Added, #3: 3	بَيْنَ الصُّلْحِ
u'بَيْنٌ صَلَوَاتٌ':Added, #1: 1	بَيْنَ صَلَوَاتٍ
u'بَيْنٌ صنعة':Added, #2: 2	بَيْنَ الصَّلَوَاتِ
u'بَيْنٌ صَنْعَةٌ':Added, #1: 1	بَيْنَ الصَّنْعَةِ
u'بَيْنٌ صِنْفٌ':Added, #1: 1	بَيْنَ الصَّنْعَةِ
u'بَيْنٌ صِنْفٌ':Added, #1: 1	بَيْنَ الصِّنْفَيْنِ
u'بَيْنٌ صَنِيعَةٌ':Added, #2: 2	بَيْنَ صِنْفَيْنِ
u'بَيْنٌ صَوَابٌ':Added, #1: 1	بَيْنَ صَنِيعَةٍ
u'بَيْنٌ صَوْتٌ':Added, #1: 1	بَيْنَ الصَّوَابِ
u'بَيْنٌ صُورٌ':Added, #1: 1	بَيْنَ الصَّوْتِ
u'بَيْنٌ صُورٌ':Added, #2: 2	بَيْنَ صُورَتَيْنِ
u'بَيْنٌ صُورٌ':Added, #31: 31	بَيْنَ الصُّورَتَيْنِ
u'بَيْنٌ صُورٌ':Added, #4: 4	بَيْن الصُّورَتَيْنِ
u'بَيْنٌ صُوَرٌ':Added, #5: 5	بَيْنَ الصُّوَرِ
u'بَيْنٌ صُورَةٌ':Added, #5: 5	بَيْنَ الصُّوَرِ
u'بَيْنٌ صُورَةٌ':Added, #1: 1	بَيْنَ صُورَتِهِ
u'بَيْنٌ صُورَةٌ':Added, #2: 2	بَيْنَ الصُّورَةِ
u'بَيْنٌ صُوفٌ':Added, #9: 9	بَيْنَ صُورَةِ
u'بَيْنٌ صُوفِيٌّ':Added, #2: 2	بَيْنَ الصُّوفِ
u'بَيْنٌ صَوْم':Added, #1: 1	بَيْنَ الصُّوفِيِّ
u'بَيْنٌ صَوْم':Added, #1: 1	بَيْنَ الصَّوْمَيْنِ
u'بَيْنٌ صَوْمٌ':Added, #1: 1	بَيْنَ صَوْمَيْنِ
u'بَيْنٌ صَوْمٌ':Added, #24: 24	بَيْنَ الصَّوْمِ
u'بَيْنٌ صِيَامٌ':Added, #7: 7	بَيْنَ صَوْمِ
u'بَيْنٌ صِيَامٌ':Added, #1: 1	بَيْنَ صِيَامِ
u'بَيْنٌ صِيغَةٌ':Added, #2: 2	بَيْنَ الصِّيَامِ
u'بَيْنٌ صِيغَةٌ':Added, #1: 1	بَيْنَ الصِّيغَةِ
u'بَيَّنَ ضَابِطٌ':Predicate, #2: 2	بَيْنَ صِيغَةِ
u'بَيْنٌ ضاد':Added, #1: 1	بَيَّنَ ضَابِطَ
u'بَيْنٌ ضاد':Added, #1: 1	بَيْنَ الضَّادِ
u'بَيْنٌ ضَارِبٌ':Added, #1: 1	بَيْنَ ضَادٍ
u'بَيْنٌ ضَأْنٌ':Added, #1: 1	بَيْنَ الضَّارِبِ
u'بَيْنٌ ضحك':Added, #3: 3	بَيْنَ الضَّأْنِ
u'بَيْنٌ ضَحِكٌ':Added, #1: 1	بَيْنَ ضَحِكِ
u'بَيْنٌ ضِدٌّ':Added, #1: 1	بَيْنَ ضَحِكِ
u'بَيْنٌ ضِدٌّ':Added, #1: 1	بَيْنَ ضِدَّيْنِ
u'بَيْنٌ ضَرٌّ':Added, #20: 20	بَيْنَ الضِّدَّيْنِ
u'بَيْنٌ ضَرٌّ':Added, #1: 1	بَيْنَ الضَّرِّ
u'بَيْنٌ ضَرَائِرُ':Added, #2: 2	بَيْنَ ضَرَّتَيْنِ
u'بَيْنٌ ضَرْبٌ':Added, #2: 2	بَيْنَ الضَّرَائِرِ
u'بَيْنٌ ضَرْبٌ':Added, #3: 3	بَيْنَ الضَّرْبَيْنِ
u'بَيْنٌ ضَرْبٌ':Added, #3: 3	بَيْنَ ضَرْبِ
u'بَيْنٌ ضَرْبٌ':Added, #3: 3	بَيْنَ ضَرْبَيْنِ
u'بَيْنٌ ضربة':Added, #4: 4	بَيْنَ الضَّرْبِ
u'بَيْنٌ ضَرْبَةٌ':Added, #2: 2	بَيْنَ ضَرْبَةٍ
u'بَيْنٌ ضَرَرٌ':Added, #2: 2	بَيْنَ ضَرْبَةٍ
u'بَيْنٌ ضَرَرٌ':Added, #1: 1	بَيْنَ ضَرَرٍ
u'بَيْنٌ ضرس':Added, #7: 7	بَيْنَ الضَّرَرِ
u'بَيْنٌ ضِرْسٌ':Added, #1: 1	بَيْنَ الضِّرْسِ
u'بَيْنٌ ضَرُورَةٌ':Added, #1: 1	بَيْنَ الضِّرْسِ
u'بَيْنٌ ضَعِيفٌ':Added, #2: 2	بَيْنَ الضَّرُورَةِ
u'بَيْنٌ ضَعِيفٌ':Added, #1: 1	بَيْنَ الضَّعِيفِ
u'بَيْنٌ ضَلاَلٌ':Added, #1: 1	بَيْنَ ضَعِيفَيْنِ
u'بَيْنٌ ضُلُوعٌ':Added, #1: 1	بَيْنَ ضَلاَلَتَيْنِ
u'بَيْنٌ ضَمٌّ':Added, #1: 1	بَيْنَ الضُّلُوعِ
u'بَيْنٌ ضَمٌّ':Added, #1: 1	بَيْنَ الضَّمِّ
u'بَيْنٌ ضَمَانٌ':Added, #2: 2	بَيْنَ ضَمِّ
u'بَيْنٌ ضَمَانٌ':Added, #13: 13	بَيْنَ الضَّمَانِ
u'بَيْنٌ ضَمَانٌ':Added, #1: 1	بَيْنَ الضَّمَانَيْنِ
u'بَيْنٌ ضِمْنِيٌّ':Added, #7: 7	بَيْنَ ضَمَانِ
u'بَيْنٌ ضَمِيرٌ':Added, #1: 1	بَيْنَ الضِّمْنِيِّ
u'بَيْنٌ ضَيَاعٌ':Added, #1: 1	بَيْنَ الضَّمِيرِ
u'بَيْنٌ ضِيَافَةٌ':Added, #1: 1	بَيْنَ الضَّيَاعِ
u'بَيْنٌ ضِيقٌ':Added, #1: 1	بَيْنَ الضِّيَافَةِ
u'بَيْنٌ طاء':Added, #1: 1	بَيْنَ ضِيقِ
u'بَيْنٌ طَاعَةٌ':Added, #1: 1	بَيْنَ الطَّاءِ
u'بَيْنٌ طَالِبٌ':Added, #2: 2	بَيْنَ الطَّاعَةِ
u'بَيْنٌ طَالِبٌ':Added, #11: 11	بَيْنَ الطَّالِبِ
u'بَيْنٌ طَالِبٌ':Added, #1: 1	بَيْنَ طَالِبٍ
u'بَيْنٌ طَاهِرٌ':Added, #1: 1	بَيْنَ طَالِبِ
u'بَيْنٌ طَائِفٌ':Added, #2: 2	بَيْنَ الطَّاهِرِ
u'بَيْنٌ طَائِفٌ':Added, #1: 1	بَيْنَ الطَّائِفِ
u'بَيْنٌ طَائِفٌ':Added, #2: 2	بَيْنَ طَائِفَتَيْنِ
u'بَيْنٌ طَبَقٌ':Added, #3: 3	بَيْنَ الطَّائِفَتَيْنِ
u'بَيْنٌ طَبَقَةٌ':Added, #1: 1	بَيْن الطَّبَقَتَيْنِ
u'بَيْنٌ طَبِيعَةٌ':Added, #1: 1	بَيْنَ طَبَقَاتِ
u'بَيْنٌ طَرَفٌ':Added, #1: 1	بَيْنَ الطَّبِيعَةِ
u'بَيْنٌ طرف':Added, #12: 12	بَيْنَ الطَّرَفَيْنِ
u'بَيْنٌ طَرْفٌ':Added, #1: 1	بَيْنَ طَرْفِ
u'بَيْنٌ طرف':Added, #1: 1	بَيْنَ طَرْفِ
u'بَيْنٌ طَرَفٌ':Added, #1: 1	بَيْنَ طَرَفِهِ
u'بَيْنٌ طَرَفٌ':Added, #1: 1	بَيْنَ طَرَفِهِ
u'بَيْنٌ طُرُقٌ':Added, #3: 3	بَيْنَ طَرَفَيْنِ
u'بَيْنٌ طَرِيقٌ':Added, #1: 1	بَيْنَ الطُّرُقِ
u'بَيْنٌ طَرِيقٌ':Added, #1: 1	بَيْنَ طَرِيقِ
u'بَيْنٌ طَرِيقٌ':Added, #3: 3	بَيْنَ الطَّرِيقِ
u'بَيْنٌ طَرِيقٌ':Added, #3: 3	بَيْنَ الطَّرِيقَتَيْنِ
u'بَيْنٌ طعام':Added, #5: 5	بَيْنَ الطَّرِيقَيْنِ
u'بَيْنٌ طَعَامٌ':Added, #1: 1	بَيْنَ طَعَامِهِ
u'بَيْنٌ طعام':Added, #1: 1	بَيْنَ طَعَامِهِ
u'بَيْنٌ طَعَامٌ':Added, #3: 3	بَيْنَ الطَّعَامِ
u'بَيْنٌ طَعَامٌ':Added, #3: 3	بَيْنَ الطَّعَامِ
u'بَيْنٌ طَعَامٌ':Added, #3: 3	بَيْنَ الطَّعَامَيْنِ
u'بَيْنٌ طعنة':Added, #4: 4	بَيْنَ طَعَامَيْنِ
u'بَيْنٌ طَعْنَةٌ':Added, #1: 1	بَيْنِ طَعْنَةٍ
u'بَيْنٌ طُعُومٌ':Added, #1: 1	بَيْنِ طَعْنَةٍ
u'بَيْنٌ طِفْلٌ':Added, #1: 1	بَيْنَ الطُّعُومِ
u'بَيَّنَ طَلاَقٌ':Predicate, #2: 2	بَيْنَ الطِّفْلِ
u'بَيْنٌ طَلاَقٌ':Added, #3: 3	بَيَّنَ الطَّلَاقَ
u'بَيْنٌ طَلاَقٌ':Added, #1: 1	بَيْنَ طَلَاقٍ
u'بَيْنٌ طَلاَقٌ':Added, #1: 1	بَيْنَ طَلَاقِ
u'بَيْنٌ طَلاَقٌ':Added, #1: 1	بَيْنَ طَلَاقِهِ
u'بَيْنٌ طَلاَقٌ':Added, #24: 24	بَيْنَ الطَّلَاقِ
u'بَيْنٌ طَلاَقٌ':Added, #2: 2	بَيْن الطَّلَاقِ
u'بَيْنٌ طلب':Added, #5: 5	بَيْنَ الطَّلَاقَيْنِ
u'بَيْنٌ طَلَبٌ':Added, #1: 1	بَيْن طَلَبِ
u'بَيْنٌ طلب':Added, #1: 1	بَيْن طَلَبِ
u'بَيْنٌ طَلَبٌ':Added, #2: 2	بَيْنَ الطَّلَبِ
u'بَيْنٌ طلب':Added, #2: 2	بَيْنَ الطَّلَبِ
u'بَيْنٌ طَلَبٌ':Added, #2: 2	بَيْنَ طَلَبِ
u'بَيْنٌ طَلَبَةٌ':Added, #2: 2	بَيْنَ طَلَبِ
u'بَيْنٌ طَلَبَةٌ':Added, #1: 1	بَيْنَ الطَّلَبَةِ
u'بَيْنٌ طُلُوعٌ':Added, #2: 2	بَيْنَ طَلَبَةِ
u'بَيْنٌ طَلِيعَةٌ':Added, #15: 15	بَيْنَ طُلُوعِ
u'بَيْنٌ طُمَأْنِينَةٌ':Added, #1: 1	بَيْنَ الطَّلِيعَةِ
u'بَيْنٌ طَهَارَةٌ':Added, #1: 1	بَيْنَ الطُّمَأْنِينَةِ
u'بَيْنٌ طَهَارَةٌ':Added, #1: 1	بَيْنَ الطَّهَارَةِ
u'بَيْنٌ طُهْر':Added, #1: 1	بَيْنَ طَهَارَةِ
u'بَيْنٌ طهر':Added, #6: 6	بَيْنَ طُهْرَيْنِ
u'بَيْنٌ طُهْرٌ':Added, #8: 8	بَيْنَ الطُّهْرِ
u'بَيْنٌ طَهُورٌ':Added, #8: 8	بَيْنَ الطُّهْرِ
u'بَيْنٌ طَوَافٌ':Added, #2: 2	بَيْنَ الطَّهُورَيْنِ
u'بَيْنٌ طواف':Added, #1: 1	بَيْنَ الطَّوَافَيْنِ
u'بَيْنٌ طَوَافٌ':Added, #1: 1	بَيْنَ طَوَافِ
u'بَيْنٌ طواف':Added, #1: 1	بَيْنَ طَوَافِ
u'بَيْنٌ طَوَافٌ':Added, #8: 8	بَيْنَ الطَّوَافِ
u'بَيَّنَ طُولٌ':Predicate, #8: 8	بَيْنَ الطَّوَافِ
u'بَيَّنَ طُولٌ':Predicate, #2: 2	بَيَّنَ طُولَ
u'بَيْنٌ طُولٌ':Added, #5: 5	بَيَّنَ الطُّولَ
u'بَيْنٌ طَوِيلٌ':Added, #10: 10	بَيْنَ طُولِ
u'بَيْنٌ طَوِيلٌ':Added, #1: 1	بَيْنَ الطَّوِيلِ
u'بَيْنٌ طَوِيلٌ':Added, #1: 1	بَيْنَ الطَّوِيلَةِ
u'بَيْنٌ طَوِيلٌ':Added, #1: 1	بَيْنَ طَوِيلِهِ
u'بَيْنٌ طَيٌّ':Added, #2: 2	بَيْنَ طَوِيلِ
u'بَيْنٌ طَيَرَانٌ':Added, #1: 1	بَيْنَ طَيِّ
u'بَيْنٌ ظالِمٌ':Added, #1: 1	بَيْنَ طَيَرَانِهِ
u'بَيْنٌ ظاهِرٌ':Added, #1: 1	بَيْنَ الظَّالِمِ
u'بَيْنٌ ظاهِرٌ':Added, #1: 1	بَيْنَ ظَاهِرِ
u'بَيْنٌ ظَرْفٌ':Added, #5: 5	بَيْنَ الظَّاهِرِ
u'بَيْنٌ ظِلٌّ':Added, #3: 3	بَيْنَ الظَّرْفِ
u'بَيْنٌ ظِلٌّ':Added, #1: 1	بَيْنَ ظِلٍّ
u'بَيْنٌ ظُلْمٌ':Added, #3: 3	بَيْنَ الظِّلِّ
u'بَيْنٌ ظلمة':Added, #1: 1	بَيْنَ ظُلْمِ
u'بَيْنٌ ظَنٌّ':Added, #2: 2	بَيْنَ الظَّلَمَةِ
u'بَيْنٌ ظَنِّيّ':Added, #6: 6	بَيْنَ الظَّنِّ
u'بَيْنٌ ظهار':Added, #1: 1	بَيْنَ ظَنِّيَّيْنِ
u'بَيْنٌ ظِهارَةٌ':Added, #3: 3	بَيْنَ الظِّهَارِ
u'بَيْنٌ ظُهْرٌ':Added, #1: 1	بَيْنَ الظِّهَارَةِ
u'بَيْنٌ ظُهْرٌ':Added, #1: 1	بَيْنَ ظُهْرِ
u'بَيْنٌ ظُهْرٌ':Added, #3: 3	بَيْنَ الظُّهْرَيْنِ
u'بَيْنٌ ظُهْرٌ':Added, #6: 6	بَيْنَ ظُهْرَيْنِ
u'بَيْنٌ ظهرى':Added, #84: 84	بَيْنَ الظُّهْرِ
u'بَيْنٌ ظُهورٌ':Added, #2: 2	بَيْنَ ظَهْرَىِ
u'بَيْنٌ ظُهورٌ':Added, #1: 1	بَيْنَ ظُهُورِ
u'بَيْنٌ ظَواهِرُ':Added, #2: 2	بَيْنَ الظُّهُورِ
u'بَيْنٌ عَاجِزٌ':Added, #1: 1	بَيْنَ الظَّوَاهِرِ
u'بَيْنٌ عَادَةٌ':Added, #1: 1	بَيْنَ الْعَاجِزِ
u'بَيْنٌ عَادَةٌ':Added, #1: 1	بَيْنَ عَادَةٍ
u'بَيْنٌ عَادَةٌ':Added, #1: 1	بَيْن عَادَتِهِ
u'بَيْنٌ عَارِفٌ':Added, #2: 2	بَيْنَ الْعَادَةِ
u'بَيْنٌ عارِيَّةٌ':Added, #3: 3	بَيْنَ الْعَارِفِ
u'بَيْنٌ عَاصِبٌ':Added, #4: 4	بَيْنَ الْعَارِيَّةِ
u'بَيْنٌ عَاطِفٌ':Added, #1: 1	بَيْنَ عَاصِبَيْنِ
u'بَيْنٌ عَاطِفَةٌ':Added, #1: 1	بَيْنَ الْعَاطِفَةِ
u'بَيْنٌ عَاقِدٌ':Added, #1: 1	بَيْنَ الْعَاطِفَةِ
u'بَيْنٌ عَالِمٌ':Added, #3: 3	بَيْنَ الْعَاقِدَيْنِ
u'بَيْنٌ عَالَمٌ':Added, #12: 12	بَيْنَ الْعَالِمِ
u'بَيْنٌ عَامٌّ':Added, #1: 1	بَيْنَ الْعَالَمِ
u'بَيْنٌ عَامٌّ':Added, #15: 15	بَيْنَ الْعَامِّ
u'بَيْنٌ عَامٌّ':Added, #1: 1	بَيْنِ الْعَامِّ
u'بَيْنٌ عَامٌّ':Added, #1: 1	بَيْنَ عَامَّةِ
u'بَيْنٌ عَامِدٌ':Added, #2: 2	بَيْنَ الْعَامَّةِ
u'بَيْنٌ عَامِرٌ':Added, #3: 3	بَيْنَ الْعَامِدِ
u'بَيْنٌ عَامِلٌ':Added, #1: 1	بَيْنَ الْعَامِرَةِ
u'بَيْنٌ عَامِلٌ':Added, #1: 1	بَيْنَ الْعَامِلَةِ
u'بَيْنٌ عَامِّيٌّ':Added, #7: 7	بَيْنَ الْعَامِلِ
u'بَيْنٌ عَبٌّ':Added, #1: 1	بَيْنَ الْعَامِّيِّ
u'بَيْنٌ عِباد':Added, #1: 1	بَيْن الْعَبِّ
u'بَيْنٌ عِبَادٌ':Added, #12: 12	بَيْنَ الْعِبَادَتَيْنِ
u'بَيْنٌ عِباد':Added, #18: 18	بَيْنَ الْعِبَادِ
u'بَيْنٌ عِبَادٌ':Added, #3: 3	بَيْنَ عِبَادَتَيْنِ
u'بَيْنٌ عِبَادَةٌ':Added, #7: 7	بَيْنَ عِبَادِهِ
u'بَيْنٌ عِبَادَةٌ':Added, #11: 11	بَيْنَ الْعِبَادَةِ
u'بَيْنٌ عِبَارَةٌ':Added, #6: 6	بَيْنَ الْعِبَادَاتِ
u'بَيْنٌ عِبَارَةٌ':Added, #1: 1	بَيْنَ الْعِبَارَةِ
u'بَيْنٌ عِبَارَةٌ':Added, #2: 2	بَيْنَ عِبَارَاتِ
u'بَيْنٌ عِبَارَةٌ':Added, #2: 2	بَيْنَ عِبَارَةِ
u'بَيْنٌ عِبَارَةٌ':Added, #2: 2	بَيْنَ عِبَارَتِهِ
u'بَيْنٌ عَبَّاسٌ':Added, #3: 3	بَيْنَ الْعِبَارَاتِ
u'بَيْنٌ عَبَّاسٌ':Added, #1: 1	بَيْنَ عَبَّاسٍ
u'بَيَّنَ عَبْدٌ':Subject, #2: 2	بَيْنَ الْعَبَّاسِ
u'بَيْنٌ عَبْدٌ':Added, #2: 2	بَيَّنَ عَبْدُ
u'بَيْنٌ عَبْدٌ':Added, #14: 14	بَيْنَ عَبْدِ
u'بَيْنٌ عَبْدٌ':Added, #17: 17	بَيْنَ عَبْدٍ
u'بَيْنٌ عَبْدٌ':Added, #19: 19	بَيْنَ الْعَبْدَيْنِ
u'بَيْنٌ عَبْدٌ':Added, #1: 1	بَيْن عَبْدِ
u'بَيْنٌ عَبْدٌ':Added, #21: 21	بَيْنَ عَبْدِهِ
u'بَيْنٌ عَبْدٌ':Added, #2: 2	بَيْنُ الْعَبْدِ
u'بَيْنٌ عَبْدٌ':Added, #58: 58	بَيْنَ الْعَبْدِ
u'بَيْنٌ عَبَدَةٌ':Added, #5: 5	بَيْنَ عَبْدَيْنِ
u'بَيْنٌ عَبِيدٌ':Added, #1: 1	بَيْنَ عَبَدَةِ
u'بَيْنٌ عَبِيدٌ':Added, #1: 1	بَيْنَ عَبِيدٍ
u'بَيْنٌ عتاق':Added, #9: 9	بَيْنَ الْعَبِيدِ
u'بَيْنٌ عتاق':Added, #1: 1	بَيْنَ عِتَاقِ
u'بَيَّنَ عتق':Predicate, #2: 2	بَيْنَ الْعَتَاقِ
u'بَيَّنَ عِتْقٌ':Predicate, #6: 6	بَيَّنَ الْعِتْقَ
u'بَيْنٌ عتق':Added, #6: 6	بَيَّنَ الْعِتْقَ
u'بَيْنٌ عِتْقٌ':Added, #19: 19	بَيْنَ الْعِتْقِ
u'بَيْنٌ عتق':Added, #19: 19	بَيْنَ الْعِتْقِ
u'بَيْنٌ عِتْقٌ':Added, #2: 2	بَيْنَ عِتْقِهِ
u'بَيْنٌ عتق':Added, #2: 2	بَيْنَ عِتْقِهِ
u'بَيْنٌ عِتْقٌ':Added, #4: 4	بَيْنَ عِتْقِ
u'بَيْنٌ عَتِيقٌ':Added, #4: 4	بَيْنَ عِتْقِ
u'بَيْنٌ عُجْبٌ':Added, #4: 4	بَيْنَ الْعَتِيقِ
u'بَيَّنَ عجز':Predicate, #1: 1	بَيْنَ الْعُجْبِ
u'بَيَّنَ عَجْزٌ':Predicate, #1: 1	بَيَّنَ عَجْزَ
u'بَيْنٌ عَجْزٌ':Added, #1: 1	بَيَّنَ عَجْزَ
u'بَيْنٌ عجز':Added, #1: 1	بَيْنَ عَجْزٍ
u'بَيْنٌ عَجْزٌ':Added, #6: 6	بَيْنَ الْعَجْزِ
u'بَيْنٌ عَجَمِيٌّ':Added, #6: 6	بَيْنَ الْعَجْزِ
u'بَيْنٌ عَجُوزٌ':Added, #1: 1	بَيْنَ الْعَجَمِيِّ
u'بَيْنٌ عِدٌّ':Added, #1: 1	بَيْنَ الْعَجُوزِ
u'بَيْنٌ عَدَالَةٌ':Added, #2: 2	بَيْنَ الْعِدَّتَيْنِ
u'بَيْنٌ عَدَاوَةٌ':Added, #2: 2	بَيْنَ الْعَدَالَةِ
u'بَيْنٌ عَدَدٌ':Added, #1: 1	بَيْنَ الْعَدَاوَةِ
u'بَيْنٌ عَدَدٌ':Added, #1: 1	بَيْنَ عَدَدِ
u'بَيْنٌ عَدَدٌ':Added, #2: 2	بَيْنَ الْعَدَدِ
u'بَيْنٌ عَدَدٌ':Added, #2: 2	بَيْنَ عَدَدٍ
u'بَيْنٌ عَدَدٌ':Added, #3: 3	بَيْنَ عَدَدَيْنِ
u'بَيْنٌ عَدْلٌ':Added, #9: 9	بَيْنَ الْعَدَدَيْنِ
u'بَيَّنَ عَدَمٌ':Predicate, #1: 1	بَيْنَ عَدْلِ
u'بَيْنٌ عَدَمٌ':Added, #2: 2	بَيَّنَ عَدَمَ
u'بَيْنٌ عَدَن':Added, #15: 15	بَيْنَ عَدَمِ
u'بَيْنٌ عَدَن':Added, #1: 1	بَيْنَ عَدَنِ
u'بَيْنٌ عَدُوٌّ':Added, #5: 5	بَيْنَ عَدَنٍ
u'بَيْنٌ عَذَابٌ':Added, #1: 1	بَيْنَ الْعَدُوِّ
u'بَيْنٌ عَذَابٌ':Added, #1: 1	بَيْنَ الْعَذَابَيْنِ
u'بَيْنٌ عِذَارٌ':Added, #5: 5	بَيْنَ عَذَابِ
u'بَيْنٌ عِذَارٌ':Added, #1: 1	بَيْنَ الْعِذَارَيْنِ
u'بَيَّنَ عُذْرٌ':Predicate, #8: 8	بَيْنَ الْعِذَارِ
u'بَيْنٌ عُذْرٌ':Added, #3: 3	بَيَّنَ الْعُذْرَ
u'بَيْنٌ عُذُوبَةٌ':Added, #3: 3	بَيْنَ الْعُذْرِ
u'بَيْنٌ عِرَاقٌ':Added, #1: 1	بَيْنَ الْعُذُوبَةِ
u'بَيْنٌ عَرَبٌ':Added, #1: 1	بَيْنَ الْعِرَاقَيْنِ
u'بَيْنٌ عَرَبِيٌّ':Added, #6: 6	بَيْنَ الْعَرَبِ
u'بَيْنٌ عَرَبِيٌّ':Added, #1: 1	بَيْنَ الْعَرَبِيِّ
u'بَيْنٌ عَرَبِيٌّ':Added, #2: 2	بَيْنَ الْعَرَبِيَّةِ
u'بَيْنٌ عَرَبِيٌّ':Added, #2: 2	بَيْنَ عَرَبِيٍّ
u'بَيْنٌ عرج':Added, #2: 2	بَيْنَ عَرَبِيَّةٍ
u'بَيْنٌ عَرْضٌ':Added, #1: 1	بَيْنَ الْعَرْجِ
u'بَيْنٌ عَرْضٌ':Added, #1: 1	بَيْنَ الْعَرْضِ
u'بَيْنٌ عَرْضٌ':Added, #1: 1	بَيْنَ عَرْضِ
u'بَيْنٌ عَرَضِيٌّ':Added, #1: 1	بَيْنَ عَرْضَيْنِ
u'بَيْنٌ عرف':Added, #1: 1	بَيْنَ الْعَرَضِيِّ
u'بَيْنٌ عُرْفٌ':Added, #1: 1	بَيْنَ عُرْفِ
u'بَيْنٌ عَرَفَاتٌ':Added, #1: 1	بَيْنَ عُرْفِ
u'بَيْنٌ عَرَقٌ':Added, #2: 2	بَيْنَ عَرَفَاتٍ
u'بَيْنٌ عَرَقٌ':Added, #1: 1	بَيْنَ عَرَقِهِ
u'بَيْنٌ عُرُوقٌ':Added, #2: 2	بَيْنَ الْعَرَقِ
u'بَيْنٌ عَزْل':Added, #1: 1	بَيْنَ الْعُرُوقِ
u'بَيْنٌ عزل':Added, #1: 1	بَيْنَ الْعَزْلَيْنِ
u'بَيْنٌ عزلة':Added, #1: 1	بَيْنَ عَزْلِ
u'بَيْنٌ عُزْلَةٌ':Added, #1: 1	بَيْنَ الْعُزْلَةِ
u'بَيْنٌ عسر':Added, #1: 1	بَيْنَ الْعُزْلَةِ
u'بَيْنٌ عُسْرٌ':Added, #1: 1	بَيْنَ الْعُسْرِ
u'بَيْنٌ عَسْكَرٌ':Added, #1: 1	بَيْنَ الْعُسْرِ
u'بَيْنٌ عِشَاءٌ':Added, #1: 1	بَيْنَ الْعَسْكَرِ
u'بَيْنٌ عَشَاءٌ':Added, #17: 17	بَيْنَ الْعِشَاءِ
u'بَيْنٌ عَشَائِرُ':Added, #2: 2	بَيْنَ عَشَاءِ
u'بَيْنٌ عَشْرٌ':Added, #1: 1	بَيْنَ الْعَشَائِرِ
u'بَيْنٌ عَشْرٌ':Added, #1: 1	بَيْنَ عَشْرٍ
u'بَيْنٌ عُشْرٌ':Added, #2: 2	بَيْنَ عَشْرِ
u'بَيْنٌ عَشِيرٌ':Added, #5: 5	بَيْنَ الْعُشْرِ
u'بَيْنٌ عَشِيرٌ':Added, #1: 1	بَيْنَ الْعَشِيرَتَيْنِ
u'بَيْنٌ عَشِيرَةٌ':Added, #1: 1	بَيْنَ عَشِيرَتِهِ
u'بَيْنٌ عِصَابَةٌ':Added, #1: 1	بَيْنَ عَشِيرَتِهِ
u'بَيْنٌ عَصَبٌ':Added, #1: 1	بَيْنَ الْعِصَابَةِ
u'بَيْنٌ عصبة':Added, #1: 1	بَيْنَ عَصَبِهِ
u'بَيْنٌ عَصَبَةٌ':Added, #2: 2	بَيْنَ عَصَبَةِ
u'بَيْنٌ عَصْرٌ':Added, #2: 2	بَيْنَ عَصَبَةِ
u'بَيْنٌ عَصْرٌ':Added, #6: 6	بَيْنَ الْعَصْرِ
u'بَيْنٌ عِصْيَانٌ':Added, #6: 6	بَيْنَ عَصْرَيْنِ
u'بَيْنٌ عَصِيرٌ':Added, #1: 1	بَيْنَ الْعِصْيَانِ
u'بَيْنٌ عُضْوٌ':Added, #3: 3	بَيْنَ عَصِيرِ
u'بَيْنٌ عُضْوٌ':Added, #1: 1	بَيْنَ عُضْوِ
u'بَيْنٌ عُضْوٌ':Added, #1: 1	بَيْنَ عُضْوَيْنِ
u'بَيْنٌ عَطَاءٌ':Added, #2: 2	بَيْنَ الْعُضْوِ
u'بَيْنٌ عَطَشٌ':Added, #5: 5	بَيْنَ عَطَاءٍ
u'بَيْنٌ عطف':Added, #1: 1	بَيْنَ الْعَطَشِ
u'بَيْنٌ عَطْفٌ':Added, #5: 5	بَيْنَ الْعَطْفِ
u'بَيْنٌ عَطِيَّةٌ':Added, #5: 5	بَيْنَ الْعَطْفِ
u'بَيْنٌ عَظْمٌ':Added, #1: 1	بَيْنَ الْعَطِيَّةِ
u'بَيْنٌ عَظْمٌ':Added, #1: 1	بَيْنَ عَظْمِ
u'بَيْنٌ عَظِيمٌ':Added, #2: 2	بَيْنَ الْعَظْمِ
u'بَيْنٌ عَظِيم':Added, #1: 1	بَيْنَ الْعَظِيمَةِ
u'بَيْنٌ عِفَّةٌ':Added, #1: 1	بَيْنَ الْعَظِيمَةِ
u'بَيْنٌ عَفْوٌ':Added, #1: 1	بَيْنَ الْعِفَّةِ
u'بَيْنٌ عَفْوٌ':Added, #1: 1	بَيْن الْعَفْوِ
u'بَيْنٌ عَفْوٌ':Added, #1: 1	بَيْنَ عَفْوِ
u'بَيْنٌ عَفِيفٌ':Added, #5: 5	بَيْنَ الْعَفْوِ
u'بَيْنٌ عِقَابٌ':Added, #1: 1	بَيْنَ الْعَفِيفَةِ
u'بَيْنٌ عَقَارٌ':Added, #1: 1	بَيْنَ الْعِقَابَيْنِ
u'بَيْنٌ عَقَائِدُ':Added, #1: 1	بَيْنَ الْعَقَارِ
u'بَيْنٌ عَقِبٌ':Added, #1: 1	بَيْنَ عَقَائِدِ
u'بَيْنٌ عَقْدٌ':Added, #1: 1	بَيْنَ عَقِبِهِ
u'بَيْنٌ عَقْدٌ':Added, #2: 2	بَيْنَ عَقْدٍ
u'بَيْنٌ عَقْدٌ':Added, #2: 2	بَيْنَ عَقْدِ
u'بَيْنٌ عَقْدٌ':Added, #5: 5	بَيْنَ الْعَقْدَيْنِ
u'بَيْنٌ عَقْدٌ':Added, #7: 7	بَيْنَ الْعَقْدِ
u'بَيْنٌ عَقْلٌ':Added, #7: 7	بَيْنَ عَقْدَيْنِ
u'بَيْنٌ عُقَلاَءُ':Added, #3: 3	بَيْنَ الْعَقْلِ
u'بَيْنٌ عَقْلِيٌّ':Added, #5: 5	بَيْنَ الْعُقَلَاءِ
u'بَيْنٌ عُقُوبَةٌ':Added, #2: 2	بَيْنَ الْعَقْلِيِّ
u'بَيْنٌ عُقُوبَةٌ':Added, #2: 2	بَيْنَ الْعُقُوبَةِ
u'بَيْنٌ عُقُودٌ':Added, #2: 2	بَيْنَ عُقُوبَاتٍ
u'بَيْنٌ عُقُودٌ':Added, #1: 1	بَيْنَ عُقُودٍ
u'بَيْنٌ عُقُودٌ':Added, #2: 2	بَيْنَ الْعُقُودِ
u'بَيْنٌ عُقُوقٌ':Added, #3: 3	بَيْنَ عُقُودِ
u'بَيْنٌ عَقِيقَةٌ':Added, #1: 1	بَيْنَ الْعُقُوقِ
u'بَيْنٌ عَكْسٌ':Added, #1: 1	بَيْنَ الْعَقِيقَةِ
u'بَيْنٌ عَلاَمَةٌ':Added, #1: 1	بَيْنَ الْعَكْسِ
u'بَيَّنَ عِلَّةٌ':Predicate, #1: 1	بَيْنَ الْعَلَامَةِ
u'بَيَّنَ عِلَّةٌ':Predicate, #3: 3	بَيَّنَ الْعِلَّةَ
u'بَيْنٌ عِلَّةٌ':Added, #5: 5	بَيَّنَ عِلَّةَ
u'بَيْنٌ عِلَّةٌ':Added, #1: 1	بَيْن الْعِلَّةِ
u'بَيْنٌ عِلَّةٌ':Added, #1: 1	بَيْنَ عِلَّةِ
u'بَيْنٌ عِلْكٌ':Added, #9: 9	بَيْنَ الْعِلَّةِ
u'بَيْنٌ عِلْكٌ':Added, #1: 1	بَيْنَ عِلْكٍ
u'بَيْنٌ عِلَلٌ':Added, #1: 1	بَيْنَ عِلْكِ
u'بَيْنٌ علم':Added, #2: 2	بَيْنَ الْعِلَلِ
u'بَيْنٌ عَلَمٌ':Added, #1: 1	بَيْنَ عَلَمٍ
u'بَيْنٌ علم':Added, #1: 1	بَيْنَ عَلَمٍ
u'بَيْنٌ عِلْمٌ':Added, #20: 20	بَيْنَ الْعِلْمِ
u'بَيْنٌ عَلَمٌ':Added, #20: 20	بَيْنَ الْعِلْمِ
u'بَيْنٌ علم':Added, #2: 2	بَيْنَ عَلَمَيْنِ
u'بَيْنٌ عَلَمٌ':Added, #3: 3	بَيْنَ عَلَمِ
u'بَيْنٌ علم':Added, #3: 3	بَيْنَ عَلَمِ
u'بَيْنٌ عِلْمٌ':Added, #4: 4	بَيْنَ عِلْمِهِ
u'بَيْنٌ علم':Added, #4: 4	بَيْنَ عِلْمِهِ
u'بَيْنٌ عِلْمٌ':Added, #7: 7	بَيْنَ عِلْمِ
u'بَيَّنَ علماء':Subject, #7: 7	بَيْنَ عِلْمِ
u'بَيَّنَ عُلَمَاءُ':Subject, #1: 1	بَيَّنَ عُلَمَاءُ
u'بَيْنٌ علماء':Added, #1: 1	بَيَّنَ عُلَمَاءُ
u'بَيْنٌ عُلَمَاءُ':Added, #100: 100	بَيْنَ الْعُلَمَاءِ
u'بَيْنٌ علماء':Added, #100: 100	بَيْنَ الْعُلَمَاءِ
u'بَيْنٌ عُلَمَاءُ':Added, #1: 1	بَيْنِ الْعُلَمَاءِ
u'بَيْنٌ علماء':Added, #1: 1	بَيْنِ الْعُلَمَاءِ
u'بَيْنٌ عُلَمَاءُ':Added, #1: 1	بَيْن عُلَمَاءِ
u'بَيْنٌ علماء':Added, #1: 1	بَيْن عُلَمَاءِ
u'بَيْنٌ عُلَمَاءُ':Added, #8: 8	بَيْنَ عُلَمَاءِ
u'بَيْنٌ عَلُوفَة':Added, #8: 8	بَيْنَ عُلَمَاءِ
u'بَيَّنَ عَلِيٌّ':Subject, #1: 1	بَيْنَ الْعَلُوفَةِ
u'بَيَّنَ عَلِيٌّ':Subject, #1: 1	بَيَّنَ عَلِيٌّ
u'بَيْنٌ عَلِيٌّ':Added, #1: 1	بَيَّنَ عَلِيُّ
u'بَيْنٌ عَلِيٌّ':Added, #1: 1	بَيْنَ الْعَلِيَّةِ
u'بَيْنٌ عِلِّيٌّ':Added, #1: 1	بَيْنَ عَلِيِّ
u'بَيْنٌ عَلِيٌّ':Added, #1: 1	بَيْنَ عِلِّيَّةِ
u'بَيْنٌ عَمٌّ':Added, #6: 6	بَيْنَ عَلِيٍّ
u'بَيْنٌ عَمٌّ':Added, #1: 1	بَيْنَ الْعَمَّتَيْنِ
u'بَيْنٌ عَمٌّ':Added, #1: 1	بَيْنَ عَمِّهِ
u'بَيْنٌ عَمٌّ':Added, #2: 2	بَيْنَ الْعَمَّيْنِ
u'بَيْنٌ عَمَّاتٌ':Added, #2: 2	بَيْنَ عَمَّتَيْنِ
u'بَيْنٌ عِمَارَةٌ':Added, #1: 1	بَيْنَ الْعَمَّاتِ
u'بَيْنٌ عِمَامَةٌ':Added, #3: 3	بَيْنَ الْعِمَارَةِ
u'بَيْنٌ عَمَّةٌ':Added, #1: 1	بَيْنَ الْعِمَامَةِ
u'بَيْنٌ عَمَّةٌ':Added, #1: 1	بَيْنَ عَمَّةٍ
u'بَيْنٌ عَمَّةٌ':Added, #1: 1	بَيْنَ عَمَّةِ
u'بَيْنٌ عَمْدٌ':Added, #7: 7	بَيْنَ الْعَمَّةِ
u'بَيْنٌ عَمْدٌ':Added, #17: 17	بَيْنَ الْعَمْدِ
u'بَيْنٌ عَمْدٌ':Added, #1: 1	بَيْنَ عَمْدِهِ
u'بَيَّنَ عُمَرٌ':Subject, #3: 3	بَيْنَ عَمْدٍ
u'بَيْنٌ عُمْرَانٌ':Added, #1: 1	بَيَّنَ عُمَرُ
u'بَيْنٌ عمرة':Added, #2: 2	بَيْنَ الْعُمْرَانِ
u'بَيْنٌ عُمْرَةٌ':Added, #9: 9	بَيْنَ الْعُمْرَةِ
u'بَيْنٌ عَمَلٌ':Added, #9: 9	بَيْنَ الْعُمْرَةِ
u'بَيْنٌ عَمَلٌ':Added, #1: 1	بَيْنَ الْعَمَلَيْنِ
u'بَيْنٌ عَمَلٌ':Added, #1: 1	بَيْنَ عَمَلٍ
u'بَيْنٌ عَمَلٌ':Added, #1: 1	بَيْنَ عَمَلِ
u'بَيْنٌ عَمَلٌ':Added, #1: 1	بَيْنَ عَمَلِهِ
u'بَيْنٌ عَمَلَةٌ':Added, #6: 6	بَيْنَ الْعَمَلِ
u'بَيْنٌ عَمُودٌ':Added, #1: 1	بَيْنَ الْعَمَلَةِ
u'بَيْنٌ عَمُودٌ':Added, #1: 1	بَيْنَ عَمُودَيْنِ
u'بَيَّنَ عُمُومٌ':Predicate, #25: 25	بَيْنَ الْعَمُودَيْنِ
u'بَيْنٌ عُمُومٌ':Added, #2: 2	بَيَّنَ عُمُومَ
u'بَيْنٌ عُمُومٌ':Added, #1: 1	بَيْنَ عُمُومٍ
u'بَيْنٌ عُمُومٌ':Added, #4: 4	بَيْنَ عُمُومِ
u'بَيْنٌ عِنَبٌ':Added, #6: 6	بَيْنَ الْعُمُومِ
u'بَيَّنَ عند':Predicate, #5: 5	بَيْنَ الْعِنَبِ
u'بَيْنٌ عَهْدٌ':Added, #1: 1	بَيَّنَ عِنْدَ
u'بَيْنٌ عَهْدٌ':Added, #1: 1	بَيْنَ الْعَهْدِ
u'بَيْنٌ عَوْدٌ':Added, #1: 1	بَيْنَ عَهْدِ
u'بَيْنٌ عَوْدٌ':Added, #1: 1	بَيْنَ عَوْدِ
u'بَيْنٌ عَوْدٌ':Added, #1: 1	بَيْنَ عَوْدِهِ
u'بَيْنٌ عور':Added, #7: 7	بَيْنَ الْعَوْدِ
u'بَيْنٌ عَوَرٌ':Added, #1: 1	بَيْنَ عَوَرٍ
u'بَيْنٌ عَوْرَةٌ':Added, #1: 1	بَيْنَ عَوَرٍ
u'بَيْنٌ عَوْرَةٌ':Added, #1: 1	بَيْنَ عَوْرَتِهِ
u'بَيْنٌ عِوَضٌ':Added, #2: 2	بَيْنَ الْعَوْرَةِ
u'بَيْنٌ عِوَضٌ':Added, #4: 4	بَيْنَ الْعِوَضِ
u'بَيْنٌ عِيَالٌ':Added, #4: 4	بَيْنَ الْعِوَضَيْنِ
u'بَيْنٌ عِيَالٌ':Added, #1: 1	بَيْنَ الْعِيَالِ
u'بَيْنٌ عِيَانٌ':Added, #1: 1	بَيْنِ عِيَالِهِ
u'بَيْنٌ عَيْبٌ':Added, #1: 1	بَيْنَ الْعِيَانِ
u'بَيْنٌ عَيْبٌ':Added, #1: 1	بَيْنِ الْعَيْبِ
u'بَيْنٌ عَيْبٌ':Added, #3: 3	بَيْنِ عَيْبٍ
u'بَيْنٌ عِيدٌ':Added, #6: 6	بَيْنَ الْعَيْبِ
u'بَيْنٌ عِيرٌ':Added, #1: 1	بَيْنَ الْعِيدِ
u'بَيْنٌ عين':Added, #1: 1	بَيْنَ عِيرٍ
u'بَيْنٌ عَيْنٌ':Added, #1: 1	بَيْن الْعَيْنِ
u'بَيْنٌ عَيْن':Added, #1: 1	بَيْن الْعَيْنِ
u'بَيْنٌ عين':Added, #1: 1	بَيْن الْعَيْنِ
u'بَيْنٌ عَيْنٌ':Added, #23: 23	بَيْنَ الْعَيْنِ
u'بَيْنٌ عَيْن':Added, #23: 23	بَيْنَ الْعَيْنِ
u'بَيْنٌ عين':Added, #23: 23	بَيْنَ الْعَيْنِ
u'بَيْنٌ عَيْنٌ':Added, #2: 2	بَيْنَ عَيْنِ
u'بَيْنٌ عَيْن':Added, #2: 2	بَيْنَ عَيْنِ
u'بَيْنٌ عَيْنٌ':Added, #2: 2	بَيْنَ عَيْنِ
u'بَيْنٌ عَيْن':Added, #2: 2	بَيْنَ عَيْنَيْنِ
u'بَيْنٌ عَيْنٌ':Added, #2: 2	بَيْنَ عَيْنَيْنِ
u'بَيْنٌ عَيْن':Added, #4: 4	بَيْنَ الْعَيْنَيْنِ
u'بَيْنٌ عُيُوبٌ':Added, #4: 4	بَيْنَ الْعَيْنَيْنِ
u'بَيْنٌ عُيُونٌ':Added, #4: 4	بَيْنَ عُيُوبِ
u'بَيْنٌ غاسِل':Added, #3: 3	بَيْنَ عُيُونِ
u'بَيْنٌ غَاصِبٌ':Added, #1: 1	بَيْنَ الْغَاسِلِ
u'بَيْنٌ غَالِبٌ':Added, #7: 7	بَيْنَ الْغَاصِبِ
u'بَيْنٌ غَالِبٌ':Added, #1: 1	بَيْنَ غَالِبٍ
u'بَيْنٌ غانِم':Added, #3: 3	بَيْنَ الْغَالِبِ
u'بَيْنٌ غَائِبٌ':Added, #2: 2	بَيْنَ غَانِمٍ
u'بَيْنٌ غَائِبٌ':Added, #1: 1	بَيْنَ غَائِبٍ
u'بَيَّنَ غَايَةٌ':Predicate, #2: 2	بَيْنَ الْغَائِبِ
u'بَيَّنَ غَايَةٌ':Predicate, #1: 1	بَيَّنَ الْغَايَةَ
u'بَيْنٌ غَايَةٌ':Added, #1: 1	بَيَّنَ غَايَةَ
u'بَيْنٌ غَايَةٌ':Added, #1: 1	بَيْنَ غَايَةِ
u'بَيَّنَ غَبَنٌ':Predicate, #3: 3	بَيْنَ الْغَايَةِ
u'بَيْنٌ غَبَنٌ':Added, #1: 1	بَيَّنَ الْغَبَنَ
u'بَيْنٌ غَبِيٌّ':Added, #1: 1	بَيْنَ الْغَبَنِ
u'بَيْنٌ غَدٌ':Added, #1: 1	بَيْنَ الْغَبِيِّ
u'بَيْنٌ غُدْوَةٌ':Added, #1: 1	بَيْنَ الْغَدِ
u'بَيْنٌ غِذَاءٌ':Added, #1: 1	بَيْنَ غُدْوَةٍ
u'بَيَّنَ غَرَضٌ':Predicate, #3: 3	بَيْنَ غِذَاءِ
u'بَيْنٌ غَرَضٌ':Added, #1: 1	بَيَّنَ الْغَرَضَ
u'بَيْنٌ غَرَضٌ':Added, #1: 1	بَيْنَ غَرَضَيْنِ
u'بَيْنٌ غُرْمٌ':Added, #9: 9	بَيْنَ الْغَرَضَيْنِ
u'بَيْنٌ غرماء':Added, #1: 1	بَيْنَ غُرْمِ
u'بَيْنٌ غرماء':Added, #10: 10	بَيْنَ غُرَمَاءِ
u'بَيْنٌ غُرُوبٌ':Added, #33: 33	بَيْنَ الْغُرَمَاءِ
u'بَيْنٌ غُرُوبٌ':Added, #2: 2	بَيْنَ الْغُرُوبِ
u'بَيْنٌ غَرِيمٌ':Added, #3: 3	بَيْنَ غُرُوبِ
u'بَيْنٌ غَرِيمٌ':Added, #2: 2	بَيْنَ الْغَرِيمِ
u'بَيْنٌ غُزَاةٌ':Added, #2: 2	بَيْنَ الْغَرِيمَيْنِ
u'بَيْنٌ غَزْلٌ':Added, #1: 1	بَيْنَ الْغُزَاةِ
u'بَيْنٌ غَزْوٌ':Added, #1: 1	بَيْنَ الْغَزْلِ
u'بَيْنٌ غُسْلٌ':Added, #1: 1	بَيْنَ الْغَزْوِ
u'بَيْنٌ غُسْلٌ':Added, #10: 10	بَيْنَ الْغُسْلِ
u'بَيْنٌ غَسْلٌ':Added, #1: 1	بَيْنَ غُسْلِ
u'بَيْنٌ غَسْلٌ':Added, #4: 4	بَيْنَ غَسْلِ
u'بَيَّنَ غَصْبٌ':Predicate, #5: 5	بَيْنَ الْغَسْلِ
u'بَيْنٌ غُصْنٌ':Added, #1: 1	بَيَّنَ غَصْبَ
u'بَيْنٌ غُصْنٌ':Added, #1: 1	بَيْنَ غُصْنٍ
u'بَيْنٌ غضب':Added, #1: 1	بَيْنَ غُصْنَيْنِ
u'بَيْنٌ غَضَبٌ':Added, #1: 1	بَيْنَ الْغَضَبِ
u'بَيْنٌ غُلاَمٌ':Added, #1: 1	بَيْنَ الْغَضَبِ
u'بَيْنٌ غُلاَمٌ':Added, #1: 1	بَيْنَ الْغُلَامَيْنِ
u'بَيْنٌ غُلاَمٌ':Added, #1: 1	بَيْنَ غُلاَمَيْنِ
u'بَيْنٌ غَلَبَةٌ':Added, #3: 3	بَيْنَ الْغُلَامِ
u'بَيْنٌ غَلَبَةٌ':Added, #1: 1	بَيْنَ غَلَبَتِهِ
u'بَيْنٌ غَلَبَةٌ':Added, #2: 2	بَيْنَ الْغَلَبَةِ
u'بَيْنٌ غَلَطٌ':Added, #3: 3	بَيْنَ غَلَبَةِ
u'بَيْنٌ غُلُوٌّ':Added, #1: 1	بَيْن الْغَلَطِ
u'بَيْنٌ غَنَمٌ':Added, #2: 2	بَيْنَ الْغُلُوِّ
u'بَيْنٌ غَنَمٌ':Added, #1: 1	بَيْنَ الْغَنَمَيْنِ
u'بَيْنٌ غَنَمٌ':Added, #1: 1	بَيْنَ غَنَمِ
u'بَيْنٌ غَنَمٌ':Added, #1: 1	بَيْنَ غَنَمَيْنِ
u'بَيْنٌ غَنِيٌّ':Added, #3: 3	بَيْنَ الْغَنَمِ
u'بَيْنٌ غَنِيٌّ':Added, #2: 2	بَيْنَ غَنِيٍّ
u'بَيْنٌ غَنِيمَةٌ':Added, #8: 8	بَيْنَ الْغَنِيِّ
u'بَيْنٌ غَيْبَةٌ':Added, #1: 1	بَيْنَ الْغَنِيمَةِ
u'بَيْنٌ غِيبَةٌ':Added, #1: 1	بَيْنَ الْغَيْبَةِ
u'بَيْنٌ غَيْبَةٌ':Added, #1: 1	بَيْنَ غِيبَةٍ
u'بَيْنٌ غِيبَةٌ':Added, #1: 1	بَيْنَ غَيْبَتِهِ
u'بَيْنٌ غَيْبَةٌ':Added, #2: 2	بَيْنَ الْغِيبَةِ
u'بَيَّنَ غير':Predicate, #2: 2	بَيْنَ غَيْبَةِ
u'بَيَّنَ غَيْرٌ':Predicate, #2: 2	بَيَّنَ غَيْرَ
u'بَيْنٌ غير':Added, #2: 2	بَيَّنَ غَيْرَ
u'بَيْنٌ غَيْرٌ':Added, #5: 5	بَيْنَ غَيْرِ
u'بَيْنٌ غَيْض':Added, #5: 5	بَيْنَ غَيْرِ
u'بَيْنٌ غَيْل':Added, #1: 1	بَيْنَ غَيْضَتَيْنِ
u'بَيْنٌ غيم':Added, #1: 1	بَيْنَ الْغَيْلِ
u'بَيْنٌ غَيْمٌ':Added, #1: 1	بَيْنَ الْغَيْمِ
u'بَيْنٌ فاء':Added, #1: 1	بَيْنَ الْغَيْمِ
u'بَيْنٌ فَاتِحٌ':Added, #2: 2	بَيْنَ الْفَاءِ
u'بَيْنٌ فَاتِحٌ':Added, #1: 1	بَيْنَ فَاتِحَتِهِ
u'بَيْنٌ فَاتِحَةٌ':Added, #6: 6	بَيْنَ الْفَاتِحَةِ
u'بَيْنٌ فَاتِحَةٌ':Added, #1: 1	بَيْنَ فَاتِحَتِهِ
u'بَيْنٌ فَاجِرٌ':Added, #6: 6	بَيْنَ الْفَاتِحَةِ
u'بَيْنٌ فَاحِشٌ':Added, #1: 1	بَيْنَ الْفَاجِرَةِ
u'بَيْنٌ فَاحِشٌ':Added, #2: 2	بَيْنَ الْفَاحِشَةِ
u'بَيْنٌ فاخِت':Added, #3: 3	بَيْنَ الْفَاحِشِ
u'بَيْنٌ فَأْرٌ':Added, #1: 1	بَيْنَ الْفَاخِتَةِ
u'بَيْنٌ فَارِسٌ':Added, #3: 3	بَيْنَ الْفَأْرَةِ
u'بَيْنٌ فَارِسِيٌّ':Added, #3: 3	بَيْنَ الْفَارِسِ
u'بَيَّنَ فَارِقٌ':Subject, #1: 1	بَيْنَ الْفَارِسِيَّةِ
u'بَيْنٌ فَاسِدٌ':Added, #1: 1	بَيَّنَ الْفَارِقُ
u'بَيْنٌ فَاسِدٌ':Added, #2: 2	بَيْنَ فَاسِدِهِ
u'بَيْنٌ فَاسِقٌ':Added, #5: 5	بَيْنَ الْفَاسِدِ
u'بَيْنٌ فَاضِلٌ':Added, #1: 1	بَيْنَ الْفَاسِقَيْنِ
u'بَيْنٌ فَاضِلٌ':Added, #1: 1	بَيْنَ فَاضِلَيْنِ
u'بَيْنٌ فَاعِلٌ':Added, #2: 2	بَيْنَ الْفَاضِلِ
u'بَيْنٌ فَاكِهٌ':Added, #3: 3	بَيْنَ الْفَاعِلِ
u'بَيْنٌ فَاكِهَةٌ':Added, #1: 1	بَيْنَ الْفَاكِهَةِ
u'بَيْنٌ فَائِدَةٌ':Added, #1: 1	بَيْنَ الْفَاكِهَةِ
u'بَيْنٌ فَتْحٌ':Added, #1: 1	بَيْنَ فَائِدَةِ
u'بَيْنٌ فتنة':Added, #1: 1	بَيْنَ فَتْحِ
u'بَيْنٌ فِتْنَةٌ':Added, #1: 1	بَيْنَ الْفِتْنَةِ
u'بَيْنٌ فَجْر':Added, #1: 1	بَيْنَ الْفِتْنَةِ
u'بَيْنٌ فَجْرٌ':Added, #1: 1	بَيْنَ الْفَجْرَيْنِ
u'بَيْنٌ فَخْذ':Added, #8: 8	بَيْنَ الْفَجْرِ
u'بَيْنٌ فخر':Added, #1: 1	بَيْنَ فَخْذَةِ
u'بَيْنٌ فَخْرٌ':Added, #1: 1	بَيْنَ فَخْرِ
u'بَيْنٌ فِدَاءٌ':Added, #1: 1	بَيْنَ فَخْرِ
u'بَيْنٌ فِدْيَةٌ':Added, #2: 2	بَيْنَ الْفِدَاءِ
u'بَيْنٌ فَذٌّ':Added, #1: 1	بَيْنَ الْفِدْيَةِ
u'بَيْنٌ فِرَاشٌ':Added, #1: 1	بَيْنَ فَذٍّ
u'بَيْنٌ فِرَاشٌ':Added, #1: 1	بَيْنَ الْفِرَاشِ
u'بَيْنٌ فراغ':Added, #5: 5	بَيْنَ الْفِرَاشَيْنِ
u'بَيْنٌ فَرَاغٌ':Added, #1: 1	بَيْنَ الْفَرَاغِ
u'بَيْنٌ فِرَاقٌ':Added, #1: 1	بَيْنَ الْفَرَاغِ
u'بَيْنٌ فِرَاقٌ':Added, #1: 1	بَيْنَ فِرَاقِ
u'بَيْنٌ فَرَائِضُ':Added, #2: 2	بَيْنَ فِرَاقِهِ
u'بَيْنٌ فَرَائِضُ':Added, #11: 11	بَيْنَ الْفَرَائِضِ
u'بَيْنٌ فَرْجٌ':Added, #1: 1	بَيْنَ فَرَائِضِ
u'بَيْنٌ فرد':Added, #1: 1	بَيْنَ فَرْجِهِ
u'بَيْنٌ فَرْدٌ':Added, #1: 1	بَيْنَ الْفَرْدِ
u'بَيْنٌ فَرَسٌ':Added, #1: 1	بَيْنَ الْفَرْدِ
u'بَيْنٌ فَرَسٌ':Added, #1: 1	بَيْنَ الْفَرَسَيْنِ
u'بَيْنٌ فَرَسٌ':Added, #4: 4	بَيْنَ الْفَرَسِ
u'بَيْنٌ فَرْضٌ':Added, #6: 6	بَيْنَ فَرَسَيْنِ
u'بَيْنٌ فَرْضٌ':Added, #10: 10	بَيْنَ فَرْضَيْنِ
u'بَيْنٌ فَرْضٌ':Added, #1: 1	بَيْنَ فَرْضِ
u'بَيْنٌ فَرْضٌ':Added, #2: 2	بَيْن الْفَرْضِ
u'بَيْنٌ فَرْضٌ':Added, #30: 30	بَيْنَ الْفَرْضِ
u'بَيْنٌ فَرْضٌ':Added, #4: 4	بَيْنَ الْفَرْضَيْنِ
u'بَيْنٌ فَرْعٌ':Added, #5: 5	بَيْنَ فَرْضٍ
u'بَيْنٌ فَرْعٌ':Added, #11: 11	بَيْنَ الْفَرْعِ
u'بَيْنٌ فَرْعٌ':Added, #1: 1	بَيْنَ فَرْعِ
u'بَيْنٌ فَرْعٌ':Added, #2: 2	بَيْنَ فَرْعِهِ
u'بَيَّنَ فرق':Predicate, #5: 5	بَيْنَ الْفَرْعَيْنِ
u'بَيَّنَ فَرْقٌ':Predicate, #2: 2	بَيَّنَ الْفَرْقَ
u'بَيْنٌ فرق':Added, #2: 2	بَيَّنَ الْفَرْقَ
u'بَيْنٌ فِرَقٌ':Added, #1: 1	بَيْنَ فِرَقِ
u'بَيْنٌ فرق':Added, #1: 1	بَيْنَ فِرَقِ
u'بَيْنٌ فِرَقٌ':Added, #6: 6	بَيْنَ الْفِرَقِ
u'بَيْنٌ فُرْقَةٌ':Added, #6: 6	بَيْنَ الْفِرَقِ
u'بَيْنٌ فَرْقَدٌ':Added, #1: 1	بَيْنَ الْفُرْقَةِ
u'بَيْنٌ فَرْوٌ':Added, #2: 2	بَيْنَ الْفَرْقَدَيْنِ
u'بَيْنٌ فُرُوضٌ':Added, #2: 2	بَيْنَ الْفَرْوِ
u'بَيْنٌ فُرُوعٌ':Added, #1: 1	بَيْنَ الْفُرُوضِ
u'بَيْنٌ فُرُوعٌ':Added, #1: 1	بَيْنَ فُرُوعِ
u'بَيْنٌ فَرِيضَةٌ':Added, #4: 4	بَيْنَ الْفُرُوعِ
u'بَيْنٌ فَرِيضَةٌ':Added, #1: 1	بَيْنَ فَرِيضَتِهِ
u'بَيْنٌ فَرِيقٌ':Added, #2: 2	بَيْنَ الْفَرِيضَةِ
u'بَيْنٌ فَرِيقٌ':Added, #2: 2	بَيْنَ الْفَرِيقِ
u'بَيْنٌ فساد':Added, #38: 38	بَيْنَ الْفَرِيقَيْنِ
u'بَيْنٌ فَسَادٌ':Added, #2: 2	بَيْنَ الْفَسَادِ
u'بَيْنٌ فساد':Added, #2: 2	بَيْنَ الْفَسَادِ
u'بَيْنٌ فَسَادٌ':Added, #2: 2	بَيْنَ فَسَادِ
u'بَيْنٌ فُسَّاقٌ':Added, #2: 2	بَيْنَ فَسَادِ
u'بَيْنٌ فَسْخٌ':Added, #1: 1	بَيْنَ فُسَّاقٍ
u'بَيْنٌ فَسْخٌ':Added, #1: 1	بَيْنَ فَسْخٍ
u'بَيْنٌ فَسْخٌ':Added, #1: 1	بَيْنَ فَسْخِهِ
u'بَيْنٌ فَسْخٌ':Added, #36: 36	بَيْنَ الْفَسْخِ
u'بَيْنٌ فَصْد':Added, #8: 8	بَيْنَ فَسْخِ
u'بَيْنٌ فَصْلٌ':Added, #1: 1	بَيْنَ الْفَصْدِ
u'بَيْنٌ فَصْلٌ':Added, #19: 19	بَيْنَ الْفَصْلَيْنِ
u'بَيْنٌ فَصْلٌ':Added, #1: 1	بَيْنَ فَصْلِ
u'بَيْنٌ فَصْلٌ':Added, #1: 1	بَيْنَ فَصْلَيْنِ
u'بَيْنٌ فُصُولٌ':Added, #5: 5	بَيْنَ الْفَصْلِ
u'بَيْنٌ فَضْلٌ':Added, #1: 1	بَيْنَ فُصُولٍ
u'بَيْنٌ فَضْلٌ':Added, #1: 1	بَيْنَ فَضْلِ
u'بَيْنٌ فضلاء':Added, #2: 2	بَيْنَ الْفَضْلِ
u'بَيْنٌ فُضَلاَءُ':Added, #1: 1	بَيْنَ فُضَلَاءِ
u'بَيْنٌ فُضُولِيٌّ':Added, #1: 1	بَيْنَ فُضَلَاءِ
u'بَيْنٌ فُضُولِيٌّ':Added, #1: 1	بَيْنَ الْفُضُولِيِّ
u'بَيْنٌ فُضُولِيٌّ':Added, #1: 1	بَيْنَ فُضُولِيٍّ
u'بَيْنٌ فُضُولِيٌّ':Added, #1: 1	بَيْنَ فُضُولِيَّيْنِ
u'بَيْنٌ فَضِيلٌ':Added, #4: 4	بَيْنَ الْفُضُولِيَّيْنِ
u'بَيْنٌ فَضِيلٌ':Added, #1: 1	بَيْنَ فَضِيلَتَيْنِ
u'بَيْنٌ فَضِيلَةٌ':Added, #2: 2	بَيْنَ الْفَضِيلَتَيْنِ
u'بَيْنٌ فطرة':Added, #1: 1	بَيْنَ فَضِيلَةٍ
u'بَيْنٌ فِطْرَةٌ':Added, #1: 1	بَيْنَ الْفِطْرَةِ
u'بَيَّنَ فِعْلٌ':Predicate, #1: 1	بَيْنَ الْفِطْرَةِ
u'بَيْنٌ فِعْلٌ':Added, #1: 1	بَيَّنَ فِعْلَ
u'بَيْنٌ فِعْلٌ':Added, #11: 11	بَيْنَ الْفِعْلَيْنِ
u'بَيْنٌ فِعْلٌ':Added, #1: 1	بَيْنِ فِعْلِهِ
u'بَيْنٌ فِعْلٌ':Added, #22: 22	بَيْنَ الْفِعْلِ
u'بَيْنٌ فِعْلٌ':Added, #2: 2	بَيْنَ فِعْلَيْنِ
u'بَيْنٌ فِعْلٌ':Added, #3: 3	بَيْنَ فِعْلٍ
u'بَيْنٌ فِعْلٌ':Added, #4: 4	بَيْنَ فِعْلِ
u'بَيْنٌ فقراء':Added, #9: 9	بَيْنَ فِعْلِهِ
u'بَيْنٌ فقراء':Added, #1: 1	بَيْن الْفُقَرَاءِ
u'بَيْنٌ فقراء':Added, #3: 3	بَيْنَ الْفُقَرَاءِ
u'بَيْنٌ فِقْهٌ':Added, #3: 3	بَيْنَ فُقَرَاءِ
u'بَيْنٌ فقهاء':Added, #1: 1	بَيْنَ الْفِقْهِ
u'بَيْنٌ فقهاء':Added, #16: 16	بَيْنَ الْفُقَهَاءِ
u'بَيْنٌ فقهاء':Added, #1: 1	بَيْن الْفُقَهَاءِ
u'بَيْنٌ فَقِيرٌ':Added, #4: 4	بَيْنَ فُقَهَاءِ
u'بَيْنٌ فَقِيهٌ':Added, #4: 4	بَيْنَ الْفَقِيرِ
u'بَيْنٌ فَقِيهٌ':Added, #1: 1	بَيْن الْفَقِيهِ
u'بَيْنٌ فِكْرٌ':Added, #1: 1	بَيْنَ الْفَقِيهِ
u'بَيْنٌ فِكْرٌ':Added, #1: 1	بَيْنَ فِكْرٍ
u'بَيْنٌ فِكْرَةٌ':Added, #2: 2	بَيْنَ الْفِكْرِ
u'بَيَّنَ فلان':Subject, #1: 1	بَيْنَ الْفِكْرَةِ
u'بَيْنٌ فلان':Added, #2: 2	بَيَّنَ الشَّافِعِيُّ
u'بَيْنٌ فُلاَنٌ':Added, #19: 19	بَيْنَ صَلَاتَيْنِ
u'بَيْنٌ فلان':Added, #19: 19	بَيْنَ فُلَانٍ
u'بَيْنٌ فلان':Added, #1: 1	بَيْنَ الْخَانِيَّةِ
u'بَيْنٌ فلان':Added, #1: 1	بَيْنَ الصَّالِحِيَّةِ
u'بَيْنٌ فلان':Added, #1: 1	بَيْنِ الصَّلَاتَيْنِ
u'بَيْنٌ فلان':Added, #1: 1	بَيْنَ الْفَجْرَيْنِ
u'بَيْنٌ فلان':Added, #1: 1	بَيْنَ الْمَرْوِيَّيْنِ
u'بَيْنٌ فلان':Added, #1: 1	بَيْنَ الْمُزْدَلِفَةِ
u'بَيْنٌ فلان':Added, #1: 1	بَيْنَ النُّورَةِ
u'بَيْنٌ فلان':Added, #1: 1	بَيْنَ النِّيلَيْنِ
u'بَيْنٌ فلان':Added, #1: 1	بَيْنَ الْهَاشِمِيِّ
u'بَيْنٌ فلان':Added, #1: 1	بَيْنَ بِلَالٍ
u'بَيْنٌ فلان':Added, #1: 1	بَيْنَ رَمَضَانَيْنِ
u'بَيْنٌ فلان':Added, #1: 1	بَيْنَ صَلاَتَيْنِ
u'بَيْنٌ فُلاَنٌ':Added, #1: 1	بَيْنَ عُكَاظٍ
u'بَيْنٌ فُلاَنٌ':Added, #1: 1	بَيْنَ فُلَانِ
u'بَيْنٌ فلان':Added, #1: 1	بَيْنَ فُلاَنٍ
u'بَيْنٌ فلان':Added, #1: 1	بَيْنَ هَمْزَتَيْنِ
u'بَيْنٌ فلان':Added, #22: 22	بَيْنَ الصَّلاَتَيْنِ
u'بَيْنٌ فلان':Added, #2: 2	بَيْنَ الزُّبَيْرِ
u'بَيْنٌ فلان':Added, #2: 2	بَيْنَ الشَّافِعِيِّ
u'بَيْنٌ فلان':Added, #2: 2	بَيْنَ غَانِمٍ
u'بَيْنٌ فلان':Added, #2: 2	بَيْنَ غَزّاتِ
u'بَيْنٌ فلان':Added, #2: 2	بَيْنَ قَيْسٍ
u'بَيْنٌ فلان':Added, #3: 3	بَيْنَ الدِّيَتَيْنِ
u'بَيْنٌ فلان':Added, #3: 3	بَيْنَ الشَّافِعِيَّةِ
u'بَيْنٌ فلان':Added, #3: 3	بَيْنَ تَمِيمِيٍّ
u'بَيْنٌ فلان':Added, #3: 3	بَيْنَ مَكْحُولٍ
u'بَيْنٌ فلان':Added, #4: 4	بَيْنَ الصَّلاتَيْنِ
u'بَيْنٌ فلان':Added, #4: 4	بَيْن الصَّلَاتَيْنِ
u'بَيْنٌ فلان':Added, #4: 4	بَيْنَ الْمَكِّيِّ
u'بَيْنٌ فلان':Added, #6: 6	بَيْنَ الرَّمَضَانَيْنِ
u'بَيْنٌ فَلْقٌ':Added, #87: 87	بَيْنَ الصَّلَاتَيْنِ
u'بَيْنٌ فَمٌ':Added, #1: 1	بَيْنَ الْفَلْقَتَيْنِ
u'بَيْنٌ فَمٌ':Added, #1: 1	بَيْنَ فَمِ
u'بَيْنٌ فَوْق':Added, #2: 2	بَيْنَ الْفَمِ
u'بَيْنٌ فَوْقِيّ':Added, #1: 1	بَيْنَ الْفَوْقِيَّةِ
u'بَيْنٌ فَيْئَةٌ':Added, #1: 1	بَيْنَ الْفَوْقِيَّةِ
u'بَيْنٌ قَاتِلٌ':Added, #2: 2	بَيْنَ الْفَيْئَةِ
u'بَيْنٌ قَاتِلٌ':Added, #1: 1	بَيْنَ قَاتِلٍ
u'بَيْنٌ قَارِئٌ':Added, #5: 5	بَيْنَ الْقَاتِلِ
u'بَيْنٌ قَاضِي':Added, #1: 1	بَيْنَ الْقَارِئِ
u'بَيْنٌ قَاضِي':Added, #2: 2	بَيْنَ الْقَاضِيَيْنِ
u'بَيْنٌ قَاطِعٌ':Added, #4: 4	بَيْنَ قَاضِيَيْنِ
u'بَيْنٌ قَاطِعٌ':Added, #1: 1	بَيْنَ الْقَاطِعِ
u'بَيْنٌ قَاعِدٌ':Added, #1: 1	بَيْنَ قَاطِعِ
u'بَيْنٌ قَاعِدٌ':Added, #1: 1	بَيْن الْقَاعِدَتَيْنِ
u'بَيْنٌ قَاعِدٌ':Added, #1: 1	بَيْنَ قَاعِدَةِ
u'بَيْنٌ قاف':Added, #2: 2	بَيْنَ الْقَاعِدِ
u'بَيْنٌ قَائِلٌ':Added, #1: 1	بَيْنَ الْقَافَةِ
u'بَيْنٌ قَائِلٌ':Added, #1: 1	بَيْنَ الْقَائِلَةِ
u'بَيْنٌ قَائِلٌ':Added, #1: 1	بَيْن قَائِلٍ
u'بَيْنٌ قَائِلٌ':Added, #2: 2	بَيْنَ الْقَائِلِ
u'بَيْنٌ قَائِلَةٌ':Added, #2: 2	بَيْنَ قَائِلَيْنِ
u'بَيْنٌ قَائِمٌ':Added, #1: 1	بَيْنَ الْقَائِلَةِ
u'بَيْنٌ قَائِمٌ':Added, #1: 1	بَيْنَ الْقَائِمَتَيْنِ
u'بَيْنٌ قَائِمٌ':Added, #1: 1	بَيْنَ قَائِمٍ
u'بَيْنٌ قَائِمٌ':Added, #1: 1	بَيْنِ قَائِمٍ
u'بَيْنٌ قَبَائِلُ':Added, #2: 2	بَيْنَ الْقَائِمِ
u'بَيْنٌ قَبَائِلُ':Added, #1: 1	بَيْنَ قَبَائِلِ
u'بَيْنٌ قَبْرٌ':Added, #4: 4	بَيْنَ الْقَبَائِلِ
u'بَيْنٌ قَبْرٌ':Added, #1: 1	بَيْنَ قَبْرِهِ
u'بَيَّنَ قَبْضٌ':Predicate, #2: 2	بَيْنَ الْقَبْرِ
u'بَيْنٌ قَبْضٌ':Added, #1: 1	بَيَّنَ قَبْضَ
u'بَيْنٌ قَبْضٌ':Added, #3: 3	بَيْنَ قَبْضِ
u'بَيْنٌ قُبُلٌ':Added, #8: 8	بَيْنَ الْقَبْضِ
u'بَيْنٌ قِبْلَةٌ':Added, #5: 5	بَيْنَ الْقُبُلِ
u'بَيْنٌ قُبُورٌ':Added, #7: 7	بَيْنَ الْقِبْلَةِ
u'بَيْنٌ قُبُورٌ':Added, #11: 11	بَيْنَ الْقُبُورِ
u'بَيْنٌ قَبُولٌ':Added, #2: 2	بَيْنَ قُبُورِ
u'بَيْنٌ قَبُولٌ':Added, #1: 1	بَيْن قَبُولِهِ
u'بَيْنٌ قَبُولٌ':Added, #2: 2	بَيْنَ الْقَبُولِ
u'بَيْنٌ قَبُولٌ':Added, #2: 2	بَيْنَ قَبُولِهِ
u'بَيْنٌ قَبِيحٌ':Added, #8: 8	بَيْنَ قَبُولِ
u'بَيْنٌ قَبِيل':Added, #1: 1	بَيْنَ قَبِيحَيْنِ
u'بَيْنٌ قَبِيل':Added, #1: 1	بَيْنَ الْقَبِيلَيْنِ
u'بَيْنٌ قَبِيل':Added, #2: 2	بَيْنَ قَبِيلَتَيْنِ
u'بَيْنٌ قَبِيلَةٌ':Added, #5: 5	بَيْنَ الْقَبِيلَتَيْنِ
u'بَيَّنَ قتل':Predicate, #1: 1	بَيْنَ الْقَبِيلَةِ
u'بَيَّنَ قَتْلٌ':Predicate, #1: 1	بَيَّنَ الْقَتْلَ
u'بَيْنٌ قتل':Added, #1: 1	بَيَّنَ الْقَتْلَ
u'بَيْنٌ قَتْلٌ':Added, #15: 15	بَيْنَ الْقَتْلِ
u'بَيْنٌ قتل':Added, #15: 15	بَيْنَ الْقَتْلِ
u'بَيْنٌ قَتْلٌ':Added, #3: 3	بَيْنَ قَتْلِ
u'بَيْنٌ قتل':Added, #3: 3	بَيْنَ قَتْلِ
u'بَيْنٌ قَتْلٌ':Added, #5: 5	بَيْنَ قَتْلِهِ
u'بَيْنٌ قَتِيلٌ':Added, #5: 5	بَيْنَ قَتْلِهِ
u'بَيْنٌ قِحَة':Added, #1: 1	بَيْنَ الْقَتِيلِ
u'بَيَّنَ قَدْرٌ':Predicate, #1: 1	بَيْنَ الْقِحَةِ
u'بَيْنٌ قَدْرٌ':Added, #8: 8	بَيَّنَ قَدْرَ
u'بَيْنٌ قدرة':Added, #1: 1	بَيْنَ الْقَدْرِ
u'بَيْنٌ قُدْرَةٌ':Added, #1: 1	بَيْن قُدْرَتِهِ
u'بَيْنٌ قدرة':Added, #1: 1	بَيْن قُدْرَتِهِ
u'بَيْنٌ قُدْرَةٌ':Added, #2: 2	بَيْنَ قُدْرَتِهِ
u'بَيْنٌ قدم':Added, #2: 2	بَيْنَ قُدْرَتِهِ
u'بَيْنٌ قَدَمٌ':Added, #2: 2	بَيْنَ قَدَمِهِ
u'بَيْنٌ قَدَمٌ':Added, #2: 2	بَيْنَ قَدَمِهِ
u'بَيْنٌ قُدُورٌ':Added, #5: 5	بَيْنَ الْقَدَمَيْنِ
u'بَيْنٌ قُدُومٌ':Added, #1: 1	بَيْنَ الْقُدُورِ
u'بَيْنٌ قُدُومٌ':Added, #1: 1	بَيْنَ قُدُومِ
u'بَيْنٌ قَدِيمٌ':Added, #1: 1	بَيْنَ قُدُومِهِ
u'بَيْنٌ قَدِيمٌ':Added, #1: 1	بَيْنَ قَدِيمِ
u'بَيْنٌ قَدِيمٌ':Added, #2: 2	بَيْنَ الْقَدِيمَةِ
u'بَيْنٌ قذف':Added, #4: 4	بَيْنَ الْقَدِيمِ
u'بَيْنٌ قَذْفٌ':Added, #1: 1	بَيْنَ قَذْفِهِ
u'بَيْنٌ قذف':Added, #1: 1	بَيْنَ قَذْفِهِ
u'بَيْنٌ قَذْفٌ':Added, #2: 2	بَيْنَ الْقَذْفِ
u'بَيْنٌ قُرْء':Added, #2: 2	بَيْنَ الْقَذْفِ
u'بَيْنٌ قِرَاءةٌ':Added, #2: 2	بَيْنَ الْقُرْءِ
u'بَيْنٌ قِرَاءةٌ':Added, #1: 1	بَيْن الْقِرَاءَةِ
u'بَيْنٌ قِرَاءةٌ':Added, #3: 3	بَيْنَ قِرَاءَةِ
u'بَيْنٌ قَرَابَةٌ':Added, #9: 9	بَيْنَ الْقِرَاءَةِ
u'بَيْنٌ قَرَابَةٌ':Added, #2: 2	بَيْنَ الْقَرَابَاتِ
u'بَيْنٌ قراح':Added, #3: 3	بَيْنَ قَرَابَتِهِ
u'بَيْنٌ قَرَاحٌ':Added, #2: 2	بَيْنَ الْقَرَاحِ
u'بَيْنٌ قرار':Added, #2: 2	بَيْنَ الْقَرَاحِ
u'بَيْنٌ قَرَارٌ':Added, #1: 1	بَيْنَ قَرَارٍ
u'بَيْنٌ قرار':Added, #1: 1	بَيْنَ قَرَارٍ
u'بَيْنٌ قَرَارٌ':Added, #2: 2	بَيْنَ الْقَرَارِ
u'بَيْنٌ قراض':Added, #2: 2	بَيْنَ الْقَرَارِ
u'بَيْنٌ قراض':Added, #1: 1	بَيْنَ الْقِرَاضِ
u'بَيْنٌ قُرْآنٌ':Added, #1: 1	بَيْنَ قِرَاضِ
u'بَيْنٌ قِرَانٌ':Added, #1: 1	بَيْن الْقُرْآنِ
u'بَيْنٌ قُرْآنٌ':Added, #2: 2	بَيْنَ الْقِرَانِ
u'بَيْنٌ قُرَبٌ':Added, #3: 3	بَيْنَ الْقُرْآنِ
u'بَيْنٌ قُرْب':Added, #1: 1	بَيْنَ الْقُرَبِ
u'بَيْنٌ قُرْبٌ':Added, #1: 1	بَيْنَ الْقُرْبَتَيْنِ
u'بَيْنٌ قُرْبٌ':Added, #1: 1	بَيْنَ قُرْبِهِ
u'بَيْنٌ قُرْبَةٌ':Added, #2: 2	بَيْنَ الْقُرْبِ
u'بَيْنٌ قُرْبَةٌ':Added, #1: 1	بَيْنَ الْقُرْبَةِ
u'بَيْنٌ قُرَشِيٌّ':Added, #1: 1	بَيْنَ قُرْبَةٍ
u'بَيْنٌ قَرْضٌ':Added, #1: 1	بَيْنَ الْقُرَشِيِّ
u'بَيْنٌ قَرْنٌ':Added, #1: 1	بَيْنَ الْقَرْضِ
u'بَيْنٌ قَرْنٌ':Added, #1: 1	بَيْنَ الْقَرْنِ
u'بَيْنٌ قَرَوِيٌّ':Added, #1: 1	بَيْنَ الْقَرْنَيْنِ
u'بَيْنٌ قَرِيبٌ':Added, #2: 2	بَيْنَ الْقَرَوِيِّ
u'بَيْنٌ قَرْيَةٌ':Added, #8: 8	بَيْنَ الْقَرِيبِ
u'بَيْنٌ قُرَيْشٌ':Added, #1: 1	بَيْنَ قَرْيَةٍ
u'بَيْنٌ قُرَيْشٌ':Added, #17: 17	بَيْنَ قُرَيْشٍ
u'بَيْنٌ قَرِينٌ':Added, #1: 1	بَيْنِ قُرَيْشٍ
u'بَيَّنَ قِسْطٌ':Predicate, #1: 1	بَيْنَ الْقَرِينَةِ
u'بَيْنٌ قَسْمٌ':Added, #2: 2	بَيَّنَ قِسْطَ
u'بَيْنٌ قِسْمٌ':Added, #1: 1	بَيْنَ قَسْمِهِ
u'بَيْنٌ قسمة':Added, #2: 2	بَيْنَ الْقِسْمَيْنِ
u'بَيْنٌ قِسْمَةٌ':Added, #1: 1	بَيْنَ قِسْمَتِهِ
u'بَيْنٌ قسمة':Added, #1: 1	بَيْنَ قِسْمَتِهِ
u'بَيْنٌ قِسْمَةٌ':Added, #9: 9	بَيْنَ الْقِسْمَةِ
u'بَيْنٌ قصار':Added, #9: 9	بَيْنَ الْقِسْمَةِ
u'بَيْنٌ قصاص':Added, #1: 1	بَيْنَ الْقِصَارِ
u'بَيْنٌ قصاص':Added, #1: 1	بَيْن الْقِصَاصِ
u'بَيْنٌ قِصَاصٌ':Added, #1: 1	بَيْنِ الْقِصَاصِ
u'بَيْنٌ قِصَاصٌ':Added, #1: 1	بَيْن الْقِصَاصِ
u'بَيْنٌ قصاص':Added, #1: 1	بَيْنِ الْقِصَاصِ
u'بَيْنٌ قِصَاصٌ':Added, #7: 7	بَيْنَ الْقِصَاصِ
u'بَيَّنَ قَصْدٌ':Predicate, #7: 7	بَيْنَ الْقِصَاصِ
u'بَيْنٌ قَصْدٌ':Added, #1: 1	بَيَّنَ قَصْدَ
u'بَيْنٌ قَصْدٌ':Added, #3: 3	بَيْنَ الْقَصْدِ
u'بَيْنٌ قَصْرٌ':Added, #6: 6	بَيْنَ قَصْدِ
u'بَيْنٌ قَصْرٌ':Added, #1: 1	بَيْنَ الْقَصْرِ
u'بَيْنٌ قَصْرٌ':Added, #1: 1	بَيْن قَصْرِ
u'بَيْنٌ قَصِيرٌ':Added, #1: 1	بَيْنَ قَصْرِ
u'بَيْنٌ قَضَاءٌ':Added, #3: 3	بَيْنَ الْقَصِيرِ
u'بَيْنٌ قَضَاءٌ':Added, #1: 1	بَيْنَ قَضَاءٍ
u'بَيْنٌ قَضَاءٌ':Added, #4: 4	بَيْنَ قَضَاءِ
u'بَيْنٌ قَضِيبٌ':Added, #9: 9	بَيْنَ الْقَضَاءِ
u'بَيْنٌ قَطْع':Added, #2: 2	بَيْنَ الْقَضِيبِ
u'بَيْنٌ قَطْعٌ':Added, #3: 3	بَيْنَ الْقَطْعَيْنِ
u'بَيْنٌ قَطْعٌ':Added, #7: 7	بَيْنَ الْقَطْعِ
u'بَيْنٌ قَطْعِيّ':Added, #7: 7	بَيْنَ قَطْعِ
u'بَيْنٌ قَطْعِيّ':Added, #1: 1	بَيْنَ الْقَطْعِيَّاتِ
u'بَيْنٌ قَطْعِيّ':Added, #1: 1	بَيْنَ الْقَطْعِيَّيْنِ
u'بَيْنٌ قَطْعِيَّة':Added, #1: 1	بَيْنَ قَطْعِيَّيْنِ
u'بَيْنٌ قُطْنٌ':Added, #1: 1	بَيْنَ الْقَطْعِيَّاتِ
u'بَيْنٌ قعدة':Added, #2: 2	بَيْنَ الْقُطْنِ
u'بَيْنٌ قَعْدَةٌ':Added, #2: 2	بَيْنَ الْقَعْدَةِ
u'بَيْنٌ قُعُودٌ':Added, #2: 2	بَيْنَ الْقَعْدَةِ
u'بَيْنٌ قلب':Added, #5: 5	بَيْنَ الْقُعُودِ
u'بَيْنٌ قَلْبٌ':Added, #2: 2	بَيْنَ الْقَلْبِ
u'بَيْنٌ قَلْب':Added, #2: 2	بَيْنَ الْقَلْبِ
u'بَيْنٌ قِلَّةٌ':Added, #2: 2	بَيْنَ الْقَلْبِ
u'بَيْنٌ قُلَّةٌ':Added, #1: 1	بَيْنَ الْقِلَّةِ
u'بَيْنٌ قلعة':Added, #1: 1	بَيْنَ قُلَّةِ
u'بَيْنٌ قَلْعَةٌ':Added, #1: 1	بَيْنَ الْقَلْعَةِ
u'بَيْنٌ قَلَمٌ':Added, #1: 1	بَيْنَ الْقَلْعَةِ
u'بَيْنٌ قُلُوبٌ':Added, #3: 3	بَيْنَ قَلَمَيْنِ
u'بَيْنٌ قَلِيلٌ':Added, #1: 1	بَيْنَ الْقُلُوبِ
u'بَيْنٌ قَلِيلٌ':Added, #12: 12	بَيْنَ قَلِيلِ
u'بَيْنٌ قَلِيلٌ':Added, #53: 53	بَيْنَ الْقَلِيلِ
u'بَيْنٌ قُمَامَةٌ':Added, #6: 6	بَيْنَ قَلِيلِهِ
u'بَيْنٌ قَمْحٌ':Added, #1: 1	بَيْنَ الْقُمَامَاتِ
u'بَيْنٌ قمر':Added, #2: 2	بَيْنَ الْقَمْحِ
u'بَيْنٌ قَمَرٌ':Added, #2: 2	بَيْنَ الْقَمَرِ
u'بَيْنٌ قَمَرِيَّةٌ':Added, #2: 2	بَيْنَ الْقَمَرِ
u'بَيْنٌ قَمِيصٌ':Added, #1: 1	بَيْنَ الْقَمَرِيَّةِ
u'بَيْنٌ قِنٌّ':Added, #1: 1	بَيْنَ قَمِيصَيْنِ
u'بَيْنٌ قِنٌّ':Added, #4: 4	بَيْنَ الْقِنِّ
u'بَيْنٌ قُنُوتٌ':Added, #7: 7	بَيْنَ قِنٍّ
u'بَيْنٌ قَهْقَه':Added, #3: 3	بَيْنَ الْقُنُوتِ
u'بَيْنٌ قَهْقَهَة':Added, #3: 3	بَيْنَ الْقَهْقَهَةِ
u'بَيْنٌ قَوَابِلُ':Added, #3: 3	بَيْنَ الْقَهْقَهَةِ
u'بَيْنٌ قوائم':Added, #1: 1	بَيْنَ الْقَوَابِلِ
u'بَيْنٌ قَوَائِمُ':Added, #1: 1	بَيْنَ قَوَائِمِهِ
u'بَيْنٌ قُوَّةٌ':Added, #1: 1	بَيْنَ قَوَائِمِهِ
u'بَيْنٌ قُوَّة':Added, #2: 2	بَيْنَ قُوَّةِ
u'بَيْنٌ قُوَّةٌ':Added, #2: 2	بَيْنَ قُوَّةِ
u'بَيْنٌ قُوَّة':Added, #5: 5	بَيْنَ الْقُوَّةِ
u'بَيْنٌ قَوَد':Added, #5: 5	بَيْنَ الْقُوَّةِ
u'بَيْنٌ قَوَد':Added, #1: 1	بَيْن الْقَوَدِ
u'بَيْنٌ قَوْسٌ':Added, #1: 1	بَيْنَ الْقَوَدِ
u'بَيَّنَ قول':Subject, #1: 1	بَيْنَ قَوْسٍ
u'بَيَّنَ قَوْلٌ':Subject, #1: 1	بَيَّنَ قَوْلُهُ
u'بَيْنٌ قَوْلٌ':Added, #1: 1	بَيَّنَ قَوْلُهُ
u'بَيْنٌ قول':Added, #1: 1	بَيْنَ قَوْلَيْنِ
u'بَيْنٌ قَوْلٌ':Added, #22: 22	بَيْنَ الْقَوْلِ
u'بَيْنٌ قول':Added, #22: 22	بَيْنَ الْقَوْلِ
u'بَيْنٌ قَوْلٌ':Added, #26: 26	بَيْنَ قَوْلِ
u'بَيْنٌ قَوْلٌ':Added, #26: 26	بَيْنَ قَوْلِ
u'بَيْنٌ قول':Added, #41: 41	بَيْنَ الْقَوْلَيْنِ
u'بَيْنٌ قَوْلٌ':Added, #4: 4	بَيْن قَوْلِهِ
u'بَيْنٌ قول':Added, #4: 4	بَيْن قَوْلِهِ
u'بَيْنٌ قَوْلٌ':Added, #74: 74	بَيْنَ قَوْلِهِ
u'بَيْنٌ قَوْمٌ':Added, #74: 74	بَيْنَ قَوْلِهِ
u'بَيْنٌ قَوْمٌ':Added, #11: 11	بَيْنَ الْقَوْمِ
u'بَيْنٌ قَوْمٌ':Added, #2: 2	بَيْنِ الْقَوْمِ
u'بَيْنٌ قَوْمٌ':Added, #2: 2	بَيْنِ قَوْمِهِ
u'بَيْنٌ قَوْمٌ':Added, #3: 3	بَيْنَ قَوْمِهِ
u'بَيْنٌ قَوِيٌّ':Added, #72: 72	بَيْنَ قَوْمٍ
u'بَيَّنَ قِيَاسٌ':Predicate, #3: 3	بَيْنَ الْقَوِيِّ
u'بَيْنٌ قِيَاسٌ':Added, #1: 1	بَيَّنَ الْقِيَاسَ
u'بَيْنٌ قِيَاسٌ':Added, #1: 1	بَيْنَ قِيَاسٍ
u'بَيْنٌ قِيَاسٌ':Added, #1: 1	بَيْنَ قِيَاسِ
u'بَيْنٌ قِيَاسٌ':Added, #1: 1	بَيْنَ قِيَاسَيْنِ
u'بَيْنٌ قِيَاسٌ':Added, #3: 3	بَيْنَ الْقِيَاسِ
u'بَيْنٌ قيام':Added, #3: 3	بَيْنَ الْقِيَاسَيْنِ
u'بَيْنٌ قِيَامٌ':Added, #10: 10	بَيْنَ الْقِيَامِ
u'بَيْنٌ قيام':Added, #10: 10	بَيْنَ الْقِيَامِ
u'بَيْنٌ قِيَامٌ':Added, #1: 1	بَيْنَ قِيَامِ
u'بَيْنٌ قيام':Added, #1: 1	بَيْنَ قِيَامِ
u'بَيْنٌ قِيَامٌ':Added, #1: 1	بَيْنَ قِيَامِهِ
u'بَيْنٌ قَيْدٌ':Added, #1: 1	بَيْنَ قِيَامِهِ
u'بَيْنٌ قَيْس':Added, #2: 2	بَيْنَ قَيْدَيْنِ
u'بَيَّنَ قِيمَةٌ':Predicate, #2: 2	بَيْنَ قَيْسٍ
u'بَيْنٌ قِيمَةٌ':Added, #1: 1	بَيَّنَ الْقِيمَةَ
u'بَيْنٌ قِيمَةٌ':Added, #28: 28	بَيْنَ قِيمَتِهِ
u'بَيْنٌ قِيمَةٌ':Added, #6: 6	بَيْنَ قِيمَةِ
u'بَيْنٌ قِيمِيّ':Added, #7: 7	بَيْنَ الْقِيمَةِ
u'بَيْنٌ كَافِرٌ':Added, #1: 1	بَيْنَ الْقِيَمِيَّيْنِ
u'بَيْنٌ كَافِرٌ':Added, #1: 1	بَيْنِ الْكَافِرِ
u'بَيْنٌ كَافِرٌ':Added, #1: 1	بَيْنَ كَافِرَةٍ
u'بَيْنٌ كَافِرٌ':Added, #3: 3	بَيْنَ الْكَافِرَيْنِ
u'بَيْنٌ كَافِرٌ':Added, #3: 3	بَيْنَ كَافِرٍ
u'بَيْنٌ كَافِرٌ':Added, #7: 7	بَيْنَ الْكَافِرِ
u'بَيْنٌ كَامِلٌ':Added, #7: 7	بَيْنَ كَافِرَيْنِ
u'بَيْنٌ كَاهِلٌ':Added, #2: 2	بَيْنَ الْكَامِلِ
u'بَيْنٌ كبار':Added, #1: 1	بَيْنَ الْكَاهِلَيْنِ
u'بَيْنٌ كبار':Added, #1: 1	بَيْنَ كِبَارِ
u'بَيْنٌ كبار':Added, #1: 1	بَيْنَ كِبَارِهِ
u'بَيْنٌ كبائر':Added, #3: 3	بَيْنَ الْكِبَارِ
u'بَيْنٌ كَبِدٌ':Added, #1: 1	بَيْنَ الْكَبَائِرِ
u'بَيْنٌ كبر':Added, #1: 1	بَيْنَ الْكَبِدِ
u'بَيْنٌ كِبَرٌ':Added, #1: 1	بَيْنَ الْكِبَرِ
u'بَيْنٌ كبر':Added, #1: 1	بَيْنَ الْكِبَرِ
u'بَيْنٌ كِبْرٌ':Added, #2: 2	بَيْنَ الْكِبْرِ
u'بَيْنٌ كَبْشٌ':Added, #2: 2	بَيْنَ الْكِبْرِ
u'بَيْنٌ كَبِيرٌ':Added, #1: 1	بَيْنَ الْكَبْشَيْنِ
u'بَيْنٌ كَبِيرٌ':Added, #1: 1	بَيْنَ الْكَبِيرَيْنِ
u'بَيْنٌ كَبِيرٌ':Added, #2: 2	بَيْنَ الْكَبِيرِ
u'بَيْنٌ كِتَابٌ':Added, #2: 2	بَيْنَ الْكَبِيرَةِ
u'بَيْنٌ كِتَابٌ':Added, #10: 10	بَيْنَ الْكِتَابِ
u'بَيْنٌ كِتَابٌ':Added, #1: 1	بَيْنَ الْكِتَابَيْنِ
u'بَيْنٌ كِتاب':Added, #2: 2	بَيْنَ الْكِتَابِيَّتَيْنِ
u'بَيْنٌ كِتَابٌ':Added, #3: 3	بَيْنَ الْكِتَابِيَّةِ
u'بَيْنٌ كِتَابَةٌ':Added, #3: 3	بَيْنَ كِتَابِ
u'بَيْنٌ كِتَابَةٌ':Added, #2: 2	بَيْنَ كِتَابَةٍ
u'بَيْنٌ كِتابَة':Added, #3: 3	بَيْنَ الْكِتَابَةِ
u'بَيْنٌ كِتابِيّ':Added, #3: 3	بَيْنَ الْكِتَابِيَّةِ
u'بَيْنٌ كُتُبٌ':Added, #3: 3	بَيْنَ الْكِتَابِيَّةِ
u'بَيْنٌ كَتِفٌ':Added, #2: 2	بَيْنَ الْكُتُبِ
u'بَيْنٌ كَثْرَةٌ':Added, #7: 7	بَيْنَ الْكَتِفَيْنِ
u'بَيْنٌ كَثِيرٌ':Added, #1: 1	بَيْنَ الْكَثْرَةِ
u'بَيْنٌ كَثِيرٌ':Added, #2: 2	بَيْنَ كَثِيرِ
u'بَيْنٌ كذب':Added, #4: 4	بَيْنَ الْكَثِيرِ
u'بَيْنٌ كَذِبٌ':Added, #3: 3	بَيْنَ الْكَذِبِ
u'بَيْنٌ كِرَاءٌ':Added, #3: 3	بَيْنَ الْكَذِبِ
u'بَيْنٌ كَرَامَةٌ':Added, #1: 1	بَيْنَ الْكِرَاءِ
u'بَيْنٌ كَرَاهَةٌ':Added, #1: 1	بَيْنَ الْكَرَامَةِ
u'بَيْنٌ كَرَاهَةٌ':Added, #2: 2	بَيْنَ كَرَاهَةِ
u'بَيْنٌ كَرْع':Added, #3: 3	بَيْنَ الْكَرَاهَةِ
u'بَيْنٌ كَرْمٌ':Added, #1: 1	بَيْنَ الْكَرْعِ
u'بَيْنٌ كَسْبٌ':Added, #1: 1	بَيْنَ كَرْمَيْنِ
u'بَيْنٌ كسرة':Added, #1: 1	بَيْنَ الْكَسْبِ
u'بَيْنٌ كِسْرَةٌ':Added, #1: 1	بَيْنَ الْكِسْرَةِ
u'بَيْنٌ كَعْبٌ':Added, #1: 1	بَيْنَ الْكِسْرَةِ
u'بَيْنٌ كعبة':Added, #1: 1	بَيْنَ الْكَعْبَيْنِ
u'بَيْنٌ كَعْبَةٌ':Added, #3: 3	بَيْنَ الْكَعْبَةِ
u'بَيْنٌ كَفٌّ':Added, #3: 3	بَيْنَ الْكَعْبَةِ
u'بَيْنٌ كُفَّارٌ':Added, #3: 3	بَيْنَ الْكَفِّ
u'بَيْنٌ كَفَّارٌ':Added, #1: 1	بَيْنَ كُفَّارِ
u'بَيْنٌ كَفَّارٌ':Added, #3: 3	بَيْنَ الْكَفَّارَاتِ
u'بَيْنٌ كَفَّارٌ':Added, #5: 5	بَيْنَ كَفَّارَةِ
u'بَيْنٌ كُفَّارٌ':Added, #6: 6	بَيْنَ الْكَفَّارَةِ
u'بَيْنٌ كَفَّارَةٌ':Added, #7: 7	بَيْنَ الْكُفَّارِ
u'بَيْنٌ كَفَّارَةٌ':Added, #3: 3	بَيْنَ الْكَفَّارَاتِ
u'بَيْنٌ كَفَّارَةٌ':Added, #5: 5	بَيْنَ كَفَّارَةِ
u'بَيْنٌ كَفَالَةٌ':Added, #6: 6	بَيْنَ الْكَفَّارَةِ
u'بَيْنٌ كِفَايَةٌ':Added, #5: 5	بَيْنَ الْكَفَالَةِ
u'بَيْنٌ كفر':Added, #1: 1	بَيْنَ الْكِفَايَةِ
u'بَيْنٌ كُفْرٌ':Added, #4: 4	بَيْنَ الْكُفْرِ
u'بَيْنٌ كَفَرَةٌ':Added, #4: 4	بَيْنَ الْكُفْرِ
u'بَيْنٌ كَفِيلٌ':Added, #2: 2	بَيْنَ الْكَفَرَةِ
u'بَيْنٌ كلاب':Added, #3: 3	بَيْنَ الْكَفِيلِ
u'بَيْنٌ كِلاَبٌ':Added, #2: 2	بَيْنَ الْكِلَابِ
u'بَيَّنَ كَلاَمٌ':Predicate, #2: 2	بَيْنَ الْكِلَابِ
u'بَيْنٌ كَلاَمٌ':Added, #2: 2	بَيَّنَ الْكَلَامَ
u'بَيْنٌ كَلام':Added, #27: 27	بَيْنَ كَلَامِ
u'بَيْنٌ كَلام':Added, #2: 2	بَيْن الْكَلَامَيْنِ
u'بَيْنٌ كَلاَمٌ':Added, #37: 37	بَيْنَ الْكَلَامَيْنِ
u'بَيْنٌ كَلاَمٌ':Added, #5: 5	بَيْنَ الْكَلَامِ
u'بَيْنٌ كَلْبٌ':Added, #5: 5	بَيْنَ كَلَامِهِ
u'بَيْنٌ كَلِمَةٌ':Added, #3: 3	بَيْنَ الْكَلْبِ
u'بَيْنٌ كَلِمَةٌ':Added, #11: 11	بَيْنَ كَلِمَاتِ
u'بَيْنٌ كَلِمَةٌ':Added, #1: 1	بَيْنَ الْكَلِمَاتِ
u'بَيْنٌ كَلِمَةٌ':Added, #1: 1	بَيْنَ كَلِمَاتِهِ
u'بَيْنٌ كُلِّيٌّ':Added, #1: 1	بَيْنَ كَلِمَةٍ
u'بَيْنٌ كُلِّيٌّ':Added, #2: 2	بَيْنَ الْكُلِّيِّ
u'بَيْنٌ كُلِّيَّاتٌ':Added, #2: 2	بَيْنَ كُلِّيَّاتِ
u'بَيْنٌ كُلِّيَّةٌ':Added, #2: 2	بَيْنَ كُلِّيَّاتِ
u'بَيْنٌ كَمٌّ':Added, #2: 2	بَيْنَ كُلِّيَّاتِ
u'بَيْنٌ كَمَالٌ':Added, #1: 1	بَيْنَ الْكَمِّ
u'بَيْنٌ كُمَيْتٌ':Added, #1: 1	بَيْنَ كَمَالِ
u'بَيْنٌ كِنَايَةٌ':Added, #1: 1	بَيْنَ الْكُمَيْتِ
u'بَيْنٌ كُنْيَةٌ':Added, #4: 4	بَيْنَ الْكِنَايَةِ
u'بَيْنٌ كواذب':Added, #1: 1	بَيْنَ كُنْيَةِ
u'بَيْنٌ كُورَةٌ':Added, #1: 1	بَيْنَ الْكَوَاذِبِ
u'بَيْنٌ كُوفَةٌ':Added, #1: 1	بَيْنَ الْكُورَةِ
u'بَيْنٌ كُوفِيٌّ':Added, #2: 2	بَيْنَ الْكُوفَةِ
u'بَيْنٌ كُوفِيَّةٌ':Added, #1: 1	بَيْنَ الْكُوفِيَّاتِ
u'بَيَّنَ كَوْنٌ':Predicate, #1: 1	بَيْنَ الْكُوفِيَّاتِ
u'بَيْنٌ كَوْنٌ':Added, #1: 1	بَيَّنَ كَوْنَ
u'بَيْنٌ كَوْنٌ':Added, #108: 108	بَيْنَ كَوْنِ
u'بَيْنٌ كَوْنٌ':Added, #1: 1	بَيْن كَوْنِ
u'بَيْنٌ كَوْنٌ':Added, #2: 2	بَيْن كَوْنِهِ
u'بَيْنٌ كَيْف':Added, #77: 77	بَيْنَ كَوْنِهِ
u'بَيْنٌ كَيْفِيّ':Added, #2: 2	بَيْنَ الْكَيْفِيَّتَيْنِ
u'بَيَّنَ كَيْفِيَّةٌ':Predicate, #2: 2	بَيْنَ الْكَيْفِيَّتَيْنِ
u'بَيْنٌ كَيْفِيَّةٌ':Added, #3: 3	بَيَّنَ كَيْفِيَّةَ
u'بَيَّنَ كَيْلٌ':Predicate, #2: 2	بَيْنَ كَيْفِيَّةِ
u'بَيْنٌ كَيْلٌ':Added, #1: 1	بَيَّنَ كَيْلَ
u'بَيْنٌ كَيْلٌ':Added, #18: 18	بَيْنَ الْكَيْلَيْنِ
u'بَيْنٌ كَيْلٌ':Added, #1: 1	بَيْنَ الْكَيْلِ
u'بَيْنٌ لاب':Added, #1: 1	بَيْنَ كَيْلٍ
u'بَيْنٌ لاب':Added, #1: 1	بَيْنَ اللَّابَتَيْنِ
u'بَيْنٌ لاَحِقٌ':Added, #1: 1	بَيْنَ لاَبَتَيْنِ
u'بَيْنٌ لاَزِمٌ':Added, #1: 1	بَيْنَ اللَّاحِقِ
u'بَيْنٌ لاَمٌ':Added, #2: 2	بَيْنَ اللَّازِمِ
u'بَيْنٌ لاَمٌ':Added, #1: 1	بَيْنَ اللَّامَيْنِ
u'بَيْنٌ لاَمٌ':Added, #2: 2	بَيْنَ لَامِ
u'بَيْنٌ لاَئِقٌ':Added, #3: 3	بَيْنَ اللَّامِ
u'بَيْنٌ لَبَّةٌ':Added, #1: 1	بَيْن اللَّائِقِ
u'بَيْنٌ لبس':Added, #15: 15	بَيْنَ اللَّبَّةِ
u'بَيْنٌ لُبْسٌ':Added, #2: 2	بَيْنَ لُبْسِ
u'بَيْنٌ لبس':Added, #2: 2	بَيْنَ لُبْسِ
u'بَيْنٌ لُبْسٌ':Added, #2: 2	بَيْنَ لُبْسِهِ
u'بَيْنٌ لبس':Added, #2: 2	بَيْنَ لُبْسِهِ
u'بَيْنٌ لُبْسٌ':Added, #3: 3	بَيْنَ اللُّبْسِ
u'بَيْنٌ لبن':Added, #3: 3	بَيْنَ اللُّبْسِ
u'بَيْنٌ لَبِنٌ':Added, #1: 1	بَيْنَ اللَّبِنِ
u'بَيْنٌ لَبَنٌ':Added, #1: 1	بَيْنَ اللَّبِنِ
u'بَيْنٌ لبن':Added, #1: 1	بَيْنَ لَبَنٍ
u'بَيْنٌ لَبَنٌ':Added, #4: 4	بَيْنَ لَبَنِ
u'بَيْنٌ لَبِنَةٌ':Added, #4: 4	بَيْنَ لَبَنِ
u'بَيْنٌ لِثَةٌ':Added, #1: 1	بَيْنَ اللَّبِنَاتِ
u'بَيْنٌ لَحْمٌ':Added, #1: 1	بَيْنَ لِثَةٍ
u'بَيْنٌ لَحْمٌ':Added, #3: 3	بَيْنَ لَحْمِ
u'بَيْنٌ لِحْيَةٌ':Added, #8: 8	بَيْنَ اللَّحْمِ
u'بَيَّنَ لُزُومٌ':Predicate, #1: 1	بَيْنَ اللِّحْيَةِ
u'بَيْنٌ لُزُومٌ':Added, #1: 1	بَيَّنَ لُزُومَ
u'بَيْنٌ لُزُومٌ':Added, #1: 1	بَيْنَ لُزُومِهِ
u'بَيْنٌ لُزُومٌ':Added, #2: 2	بَيْنَ لُزُومِ
u'بَيْنٌ لعان':Added, #3: 3	بَيْنَ اللُّزُومِ
u'بَيْنٌ لعنة':Added, #1: 1	بَيْنَ لِعَانِ
u'بَيْنٌ لَعْنَةٌ':Added, #1: 1	بَيْنَ لَعْنَةِ
u'بَيْنٌ لُغَةٌ':Added, #1: 1	بَيْنَ لَعْنَةِ
u'بَيْنٌ لَغْوٌ':Added, #1: 1	بَيْنَ لُغَةِ
u'بَيْنٌ لُغَوِيٌّ':Added, #1: 1	بَيْنَ اللَّغْوِ
u'بَيْنٌ لفائف':Added, #3: 3	بَيْنَ اللُّغَوِيِّ
u'بَيْنٌ لَفَائِفُ':Added, #1: 1	بَيْنَ اللَّفَائِفِ
u'بَيْنٌ لَفْظٌ':Added, #1: 1	بَيْنَ اللَّفَائِفِ
u'بَيْنٌ لَفْظٌ':Added, #17: 17	بَيْنَ اللَّفْظِ
u'بَيْنٌ لَفْظٌ':Added, #1: 1	بَيْنَ اللّفْظَيْنِ
u'بَيْنٌ لَفْظٌ':Added, #1: 1	بَيْن لَفْظٍ
u'بَيْنٌ لَفْظٌ':Added, #22: 22	بَيْنَ اللَّفْظَيْنِ
u'بَيْنٌ لَقْطٌ':Added, #8: 8	بَيْنَ لَفْظِ
u'بَيْنٌ لقطة':Added, #1: 1	بَيْنَ اللَّقْطِ
u'بَيْنٌ لقطة':Added, #1: 1	بَيْنَ لُقَطَةٍ
u'بَيْنٌ لَقِيطٌ':Added, #1: 1	بَيْنَ لُقَطَةِ
u'بَيْنٌ لَمَّةٌ':Added, #1: 1	بَيْنَ اللَّقِيطِ
u'بَيْنٌ لَمْسٌ':Added, #1: 1	بَيْنَ لَمَّةِ
u'بَيْنٌ لَهَوَاتٌ':Added, #2: 2	بَيْنَ اللَّمْسِ
u'بَيْنٌ لَوْحٌ':Added, #2: 2	بَيْنِ لَهَوَاتِهِ
u'بَيْنٌ لَوْحٌ':Added, #1: 1	بَيْنَ اللّوْحَيْنِ
u'بَيْنٌ لَوْحٌ':Added, #1: 1	بَيْن لَوْحَيْنِ
u'بَيْنٌ لَوْحٌ':Added, #2: 2	بَيْنَ اللَّوْحَيْنِ
u'بَيْنٌ لُؤْلُؤٌ':Added, #4: 4	بَيْنَ لَوْحَيْنِ
u'بَيْنٌ لَوْنٌ':Added, #1: 1	بَيْنَ اللُّؤْلُؤَتَيْنِ
u'بَيْنٌ لَوْنٌ':Added, #1: 1	بَيْنَ اللَّوْنَيْنِ
u'بَيْنٌ لَيْثٌ':Added, #1: 1	بَيْنَ لَوْنَيْنِ
u'بَيْنٌ لَيْلٌ':Added, #3: 3	بَيْنَ اللَّيْثِ
u'بَيْنٌ لَيْلٌ':Added, #1: 1	بَيْنَ اللَّيْلَتَيْنِ
u'بَيْنٌ لَيْلٌ':Added, #1: 1	بَيْنَ لَيْلٍ
u'بَيْنٌ لَيْلٌ':Added, #1: 1	بَيْنَ لَيْلَةٍ
u'بَيْنٌ لِينٌ':Added, #9: 9	بَيْنَ اللَّيْلِ
u'بَيْنٌ مَاءٌ':Added, #1: 1	بَيْنَ اللِّينِ
u'بَيْنٌ مَاءٌ':Added, #16: 16	بَيْنَ الْمَاءِ
u'بَيْنٌ مَاءٌ':Added, #1: 1	بَيْن الْمَاءِ
u'بَيْنٌ مَاسٌّ':Added, #2: 2	بَيْنَ مَاءِ
u'بَيْنٌ مَاسِحٌ':Added, #2: 2	بَيْنَ الْمَاسِّ
u'بَيْنٌ مَاشِي':Added, #1: 1	بَيْنَ الْمَاسِحِ
u'بَيْنٌ مَاشِيَةٌ':Added, #2: 2	بَيْنَ الْمَاشِيَةِ
u'بَيْنٌ مَأْكُولٌ':Added, #2: 2	بَيْنَ الْمَاشِيَةِ
u'بَيْنٌ مَأْكُولٌ':Added, #1: 1	بَيْنَ مَأْكُولَيْنِ
u'بَيْنٌ مَأْكُولٌ':Added, #4: 4	بَيْنَ الْمَأْكُولِ
u'بَيْنٌ مَأْكُولٌ':Added, #4: 4	بَيْنَ مَأْكُولِ
u'بَيَّنَ مَالٌ':Predicate, #5: 5	بَيْنَ مَأْكُولٍ
u'بَيْنٌ مَالٌ':Added, #1: 1	بَيَّنَ الْمَالَ
u'بَيْنٌ مَالٌ':Added, #13: 13	بَيْنَ الْمَالِ
u'بَيْنٌ مَالٌ':Added, #1: 1	بَيْن الْمَالِ
u'بَيْنٌ مَالٌ':Added, #1: 1	بَيْنَ الْمَالَيْنِ
u'بَيْنٌ مَالٌ':Added, #1: 1	بَيْنَ مَالٍ
u'بَيْنٌ مَالٌ':Added, #1: 1	بَيْنَ مَالِهِ
u'بَيْنٌ مَالٌ':Added, #2: 2	بَيْنَ مَالِ
u'بَيَّنَ مَالِكٌ':Subject, #4: 4	بَيْنِ مَالِهِ
u'بَيْنٌ مَالِكٌ':Added, #1: 1	بَيَّنَ مَالِكٌ
u'بَيْنٌ مَالِكٌ':Added, #10: 10	بَيْنَ الْمَالِكِ
u'بَيْنٌ مَالِكٌ':Added, #1: 1	بَيْنَ مَالِكِ
u'بَيْنٌ مَالِكٌ':Added, #2: 2	بَيْنَ الْمَالِكَيْنِ
u'بَيْنٌ مَالِكٌ':Added, #2: 2	بَيْنَ مَالِكٍ
u'بَيْنٌ مالِك':Added, #2: 2	بَيْنَ مَالِكَيْنِ
u'بَيْنٌ مالِكِيّ':Added, #5: 5	بَيْنَ الْمَالِكِيَّةِ
u'بَيْنٌ مَأْلُوفٌ':Added, #5: 5	بَيْنَ الْمَالِكِيَّةِ
u'بَيْنٌ مَالِيٌّ':Added, #1: 1	بَيْنَ الْمَأْلُوفَيْنِ
u'بَيْنٌ مَالِيٌّ':Added, #1: 1	بَيْنَ الْمَالِيِّ
u'بَيْنٌ مَأْمُورٌ':Added, #1: 1	بَيْنَ الْمَالِيَّةِ
u'بَيْنٌ مَأْمُورٌ':Added, #1: 1	بَيْنَ الْمَأْمُورِ
u'بَيْنٌ مَانِعٌ':Added, #1: 1	بَيْنَ الْمَأْمُورَاتِ
u'بَيْنٌ مَائِعٌ':Added, #1: 1	بَيْنَ الْمَانِعِ
u'بَيْنٌ مُبَاحٌ':Added, #4: 4	بَيْنَ الْمَائِعِ
u'بَيْنٌ مُبَاحٌ':Added, #1: 1	بَيْنَ مُبَاحٍ
u'بَيْنٌ مُبَاحٌ':Added, #2: 2	بَيْنَ مُبَاحَيْنِ
u'بَيْنٌ مُبَادَلَةٌ':Added, #6: 6	بَيْنَ الْمُبَاحِ
u'بَيْنٌ مُبَارَكٌ':Added, #1: 1	بَيْنَ الْمُبَادَلَةِ
u'بَيْنٌ مُبَاشَرَةٌ':Added, #1: 1	بَيْنَ مُبَارَكٍ
u'بَيْنٌ مُبَالَغَةٌ':Added, #3: 3	بَيْنَ الْمُبَاشَرَةِ
u'بَيْنٌ مُبْتَدَأٌ':Added, #1: 1	بَيْنَ الْمُبَالَغَةِ
u'بَيْنٌ مُبْتَدَأٌ':Added, #1: 1	بَيْنَ مُبْتَدَأِ
u'بَيْنٌ مُبْتَدِعٌ':Added, #4: 4	بَيْنَ الْمُبْتَدَأِ
u'بَيَّنَ مَبْدَأٌ':Predicate, #1: 1	بَيْنَ الْمُبْتَدِعِ
u'بَيْنٌ مَبَرَّةٌ':Added, #2: 2	بَيَّنَ مَبْدَأَ
u'بَيْنٌ مُبَرِّحٌ':Added, #1: 1	بَيْنَ مَبَرَّةِ
u'بَيْنٌ مُبْطِلٌ':Added, #3: 3	بَيْنَ الْمُبَرِّحِ
u'بَيْنٌ مُبْطِلٌ':Added, #1: 1	بَيْنَ مُبْطِلٍ
u'بَيْنٌ مُبْهَمٌ':Added, #1: 1	بَيْنَ مُبْطِلَيْنِ
u'بَيْنٌ مَبِيعٌ':Added, #1: 1	بَيْنَ الْمُبْهَمِ
u'بَيْنٌ مَبِيعٌ':Added, #1: 1	بَيْنَ مَبِيعٍ
u'بَيْنٌ مُبَيَّنٌ':Added, #8: 8	بَيْنَ الْمَبِيعِ
u'بَيْنٌ مُتَأَهِّلٌ':Added, #1: 1	بَيْنَ الْمُبَيَّنِ
u'بَيْنٌ مُتَبَرِّعٌ':Added, #1: 1	بَيْنَ مُتَأَهِّلَيْنِ
u'بَيْنٌ مُتَبَقِّي':Added, #1: 1	بَيْنَ الْمُتَبَرِّعِ
u'بَيْنٌ مُتَتَابِعٌ':Added, #1: 1	بَيْنَ الْمُتَبَقِّيَةِ
u'بَيْنٌ مُتَجَانِسٌ':Added, #1: 1	بَيْنَ الْمُتَتَابِعَيْنِ
u'بَيْنٌ مُتَّحِدٌ':Added, #1: 1	بَيْنَ الْمُتَجَانِسَيْنِ
u'بَيْنٌ مُتَداعِي':Added, #2: 2	بَيْنَ الْمُتَّحِدِ
u'بَيْنٌ مُتَداعِي':Added, #1: 1	بَيْنَ مُتَدَاعِيَيْنِ
u'بَيْنٌ مَتْرُوكٌ':Added, #4: 4	بَيْنَ الْمُتَدَاعِيَيْنِ
u'بَيْنٌ مَتْرُوكٌ':Added, #1: 1	بَيْنَ الْمَتْرُوكِ
u'بَيْنٌ مُتَسَاقِطٌ':Added, #2: 2	بَيْنَ الْمَتْرُوكَاتِ
u'بَيْنٌ مُتَسَاوِي':Added, #1: 1	بَيْنَ الْمُتَسَاقِطِ
u'بَيْنٌ مُتَسَاوِي':Added, #2: 2	بَيْنَ الْمُتَسَاوِيَيْنِ
u'بَيْنٌ مُتَشَابِهٌ':Added, #3: 3	بَيْنَ مُتَسَاوِيَيْنِ
u'بَيْنٌ مُتَصالِح':Added, #1: 1	بَيْنَ الْمُتَشَابِهَيْنِ
u'بَيْنٌ مُتَصَرِّفٌ':Added, #1: 1	بَيْنَ الْمُتَصَالِحَيْنِ
u'بَيْنٌ مُتَّصِلٌ':Added, #1: 1	بَيْنَ الْمُتَصَرِّفِ
u'بَيْنٌ مُتَصَوِّفٌ':Added, #1: 1	بَيْنَ الْمُتَّصِلِ
u'بَيْنٌ مُتَضادّ':Added, #1: 1	بَيْنَ مُتَصَوِّفَةِ
u'بَيْنٌ مُتَضادّ':Added, #1: 1	بَيْنَ مُتَضَادَّيْنِ
u'بَيْنٌ مُتَطَوِّعٌ':Added, #4: 4	بَيْنَ الْمُتَضَادَّيْنِ
u'بَيْنٌ مُتَعارِض':Added, #1: 1	بَيْنَ الْمُتَطَوِّعِ
u'بَيْنٌ مُتَعَاطِفٌ':Added, #3: 3	بَيْنَ الْمُتَعَارِضَيْنِ
u'بَيْنٌ مُتَعَاقِدٌ':Added, #1: 1	بَيْنَ الْمُتَعَاطِفَيْنِ
u'بَيْنٌ مُتَعامِل':Added, #12: 12	بَيْنَ الْمُتَعَاقِدَيْنِ
u'بَيْنٌ مُتْعَةٌ':Added, #1: 1	بَيْنَ الْمُتَعَامِلَيْنِ
u'بَيْنٌ مُتَعَدِّدٌ':Added, #7: 7	بَيْنَ الْمُتْعَةِ
u'بَيْنٌ مُتَعَلِّقٌ':Added, #1: 1	بَيْنَ مُتَعَدِّدٍ
u'بَيْنٌ مُتَعَوِّد':Added, #1: 1	بَيْنَ مُتَعَلِّقِ
u'بَيْنٌ مُتَغَيِّرٌ':Added, #1: 1	بَيْنَ الْمُتَعَوِّدَةِ
u'بَيْنٌ مُتَفاعِل':Added, #1: 1	بَيْنَ الْمُتَغَيِّرِ
u'بَيْنٌ مُتَفاوِت':Added, #1: 1	بَيْنَ مُتَفَاعِلَيْنِ
u'بَيْنٌ مُتَفاوِض':Added, #1: 1	بَيْنَ الْمُتَفَاوِتِ
u'بَيْنٌ مُتَفَرِّقٌ':Added, #3: 3	بَيْنَ الْمُتَفَاوِضَيْنِ
u'بَيْنٌ مُتَفَرِّقٌ':Added, #1: 1	بَيْنَ الْمُتَفَرِّقِ
u'بَيْنٌ مُتَفَسِّخٌ':Added, #22: 22	بَيْنَ مُتَفَرِّقٍ
u'بَيْنٌ مُتَّفَقٌ':Added, #1: 1	بَيْنَ الْمُتَفَسِّخِ
u'بَيْنٌ مُتَّفِقٌ':Added, #1: 1	بَيْنَ مُتَّفَقٍ
u'بَيْنٌ مُتَقَدِّمٌ':Added, #1: 1	بَيْنَ مُتَّفِقَيْنِ
u'بَيْنٌ مُتَقَدِّمٌ':Added, #1: 1	بَيْنَ الْمُتَقَدِّمَةِ
u'بَيْنٌ مُتَقَطِّعٌ':Added, #3: 3	بَيْنَ الْمُتَقَدِّمِ
u'بَيْنٌ مُتَكَافِئ':Added, #1: 1	بَيْنَ الْمُتَقَطِّعِ
u'بَيْنٌ مُتَكَافِئ':Added, #1: 1	بَيْنَ مُتَكَافِئَيْنِ
u'بَيْنٌ مُتَلاعِن':Added, #3: 3	بَيْنَ الْمُتَكَافِئَيْنِ
u'بَيْنٌ مُتَلاعِن':Added, #11: 11	بَيْنَ الْمُتَلاَعِنَيْنِ
u'بَيْنٌ مُتَمَاثِلٌ':Added, #8: 8	بَيْنَ الْمُتَلَاعِنَيْنِ
u'بَيْنٌ مُتَمَتِّعٌ':Added, #4: 4	بَيْنَ الْمُتَمَاثِلَيْنِ
u'بَيْنٌ مُتَنازَع':Added, #2: 2	بَيْنَ الْمُتَمَتِّعِ
u'بَيْنٌ مُتَنازِع':Added, #1: 1	بَيْنَ الْمُتَنَازَعِ
u'بَيْنٌ مُتَنازِع':Added, #1: 1	بَيْنَ الْمُتَنَازِعَيْنِ
u'بَيْنٌ مُتَنَاقِضٌ':Added, #1: 1	بَيْنَ مُتَنَازِعَيْنِ
u'بَيْنٌ مُتَوَاتِرٌ':Added, #1: 1	بَيْن الْمُتَنَاقِضَاتِ
u'بَيْنٌ مُتَوَاطِئٌ':Added, #3: 3	بَيْنَ الْمُتَوَاتِرِ
u'بَيْنٌ مُتَوَلِّدٌ':Added, #1: 1	بَيْنَ الْمُتَوَاطِئِ
u'بَيْنٌ مِثَالٌ':Added, #1: 1	بَيْنَ الْمُتَوَلِّدَةِ
u'بَيْنٌ مِثَالٌ':Added, #1: 1	بَيْنَ الْمِثَالِ
u'بَيْنٌ مَثَانَةٌ':Added, #1: 1	بَيْنَ الْمِثَالَيْنِ
u'بَيْنٌ مثل':Added, #1: 1	بَيْنَ الْمَثَانَةِ
u'بَيْنٌ مِثْلٌ':Added, #1: 1	بَيْنَ مِثْلِ
u'بَيْنٌ مِثْلٌ':Added, #1: 1	بَيْنَ مِثْلِ
u'بَيْنٌ مثل':Added, #1: 1	بَيْنَ مِثْلَيْنِ
u'بَيْنٌ مِثْلٌ':Added, #2: 2	بَيْنَ الْمِثْلِ
u'بَيْنٌ مِثْلٌ':Added, #2: 2	بَيْنَ الْمِثْلِ
u'بَيْنٌ مِثْلِيٌّ':Added, #2: 2	بَيْنَ الْمِثْلَيْنِ
u'بَيْنٌ مِثْلِيٌّ':Added, #1: 1	بَيْنَ الْمِثْلِيَّاتِ
u'بَيْنٌ مُثْمِر':Added, #4: 4	بَيْنَ الْمِثْلِيِّ
u'بَيْنٌ مُثْمِر':Added, #1: 1	بَيْنَ الْمُثْمِرِ
u'بَيْنٌ مَجَازٌ':Added, #1: 1	بَيْنَ الْمُثْمِرَةِ
u'بَيْنٌ مَجَالِسُ':Added, #2: 2	بَيْنَ الْمَجَازِ
u'بَيْنٌ مُجْبَرٌ':Added, #1: 1	بَيْنَ مَجَالِسِ
u'بَيْنٌ مُجْتَمَعٌ':Added, #1: 1	بَيْنَ الْمُجْبَرَتَيْنِ
u'بَيْنٌ مُجْتَهِد':Added, #2: 2	بَيْنَ مُجْتَمَعٍ
u'بَيْنٌ مُجْتَهِد':Added, #1: 1	بَيْنَ الْمُجْتَهِدِ
u'بَيْنٌ مُجَرَّدٌ':Added, #3: 3	بَيْنَ مُجْتَهِدٍ
u'بَيْنٌ مَجْرُوحٌ':Added, #1: 1	بَيْنَ الْمُجَرَّدِ
u'بَيْنٌ مَجْرُورٌ':Added, #1: 1	بَيْنَ الْمَجْرُوحِ
u'بَيْنٌ مَجْلِسٌ':Added, #1: 1	بَيْنَ الْمَجْرُورِ
u'بَيْنٌ مَجْلِسٌ':Added, #1: 1	بَيْن الْمَجْلِسِ
u'بَيْنٌ مَجْلِسٌ':Added, #2: 2	بَيْنَ مَجْلِسِ
u'بَيْنٌ مُجْمَلٌ':Added, #6: 6	بَيْنَ الْمَجْلِسِ
u'بَيْنٌ مَجْمُوعٌ':Added, #3: 3	بَيْنَ الْمُجْمَلِ
u'بَيْنٌ مَجْنُونٌ':Added, #2: 2	بَيْنَ مَجْمُوعِ
u'بَيْنٌ مَجْنُونٌ':Added, #1: 1	بَيْنَ الْمَجْنُونَةِ
u'بَيْنٌ مَجْنِيٌّ':Added, #2: 2	بَيْنَ الْمَجْنُونِ
u'بَيْنٌ مَجْهُولٌ':Added, #1: 1	بَيْنَ الْمَجْنِيِّ
u'بَيْنٌ مَجُوسٌ':Added, #1: 1	بَيْنَ الْمَجْهُولَةِ
u'بَيْنٌ مَجُوسٌ':Added, #1: 1	بَيْنَ مَجُوسٍ
u'بَيْنٌ مَجُوسِيٌّ':Added, #4: 4	بَيْنَ الْمَجُوسِ
u'بَيْنٌ مَجُوسِيّ':Added, #1: 1	بَيْنَ الْمَجُوسِيِّ
u'بَيْنٌ مَجُوسِيٌّ':Added, #1: 1	بَيْنَ مَجُوسِيَّيْنِ
u'بَيْنٌ مَحَارِمُ':Added, #2: 2	بَيْنَ مَجُوسِيٍّ
u'بَيْنٌ مَحَارِمُ':Added, #10: 10	بَيْنَ الْمَحَارِمِ
u'بَيْنٌ مَحَاسِنُ':Added, #1: 1	بَيْنَ مَحَارِمِهِ
u'بَيْنٌ مَحاوِيج':Added, #1: 1	بَيْنَ الْمَحَاسِنِ
u'بَيْنٌ مَحَبَّةٌ':Added, #1: 1	بَيْنَ الْمَحَاوِيجِ
u'بَيْنٌ مَحَبَّةٌ':Added, #1: 1	بَيْنَ الْمَحَبَّةِ
u'بَيْنٌ مَحْبُوبٌ':Added, #1: 1	بَيْنَ مَحَبَّتِهِ
u'بَيْنٌ مَحْبُوسٌ':Added, #1: 1	بَيْنَ الْمَحْبُوبِ
u'بَيْنٌ مُحْتَالٌ':Added, #1: 1	بَيْنَ الْمَحْبُوسِ
u'بَيْنٌ مُحْدَثٌ':Added, #2: 2	بَيْنَ الْمُحْتَالِ
u'بَيْنٌ مُحْدِثٌ':Added, #1: 1	بَيْنَ الْمُحْدَثِ
u'بَيْنٌ مَحْذُور':Added, #3: 3	بَيْنَ الْمُحْدِثِ
u'بَيْنٌ مَحْذُوفٌ':Added, #1: 1	بَيْنَ الْمَحْذُورَيْنِ
u'بَيْنٌ مِحْرَابٌ':Added, #1: 1	بَيْنَ الْمَحْذُوفِ
u'بَيْنٌ مُحْرِمٌ':Added, #1: 1	بَيْنَ مِحْرَابِ
u'بَيْنٌ مَحْرَمٌ':Added, #1: 1	بَيْنَ الْمُحْرِمِ
u'بَيْنٌ مُحَرَّمٌ':Added, #2: 2	بَيْنَ الْمَحْرَمِ
u'بَيْنٌ مَحْرُوسٌ':Added, #2: 2	بَيْنَ مُحَرَّمَةٍ
u'بَيْنٌ مُحْصَنٌ':Added, #1: 1	بَيْنَ الْمَحْرُوسِ
u'بَيْنٌ مَحْضٌ':Added, #1: 1	بَيْنَ الْمُحْصَنِ
u'بَيْنٌ مَحْظُورٌ':Added, #1: 1	بَيْنَ مَحْضِ
u'بَيْنٌ مُحَقَّقٌ':Added, #1: 1	بَيْنَ مَحْظُورٍ
u'بَيْنٌ مُحَقَّقٌ':Added, #1: 1	بَيْنَ الْمُحَقَّقَةِ
u'بَيْنٌ مُحَكَّمٌ':Added, #2: 2	بَيْنَ الْمُحَقَّقِ
u'بَيْنٌ مَحْكُومٌ':Added, #1: 1	بَيْنَ الْمُحَكَّمِ
u'بَيْنٌ مَحْكُومٌ':Added, #1: 1	بَيْنَ الْمَحْكُومِ
u'بَيَّنَ مَحَلٌّ':Predicate, #1: 1	بَيْنَ مَحْكُومٍ
u'بَيَّنَ مَحَلٌّ':Predicate, #1: 1	بَيَّنَ الْمَحَلَّ
u'بَيْنٌ مَحَلٌّ':Added, #5: 5	بَيَّنَ مَحَلَّ
u'بَيْنٌ مَحَلٌّ':Added, #1: 1	بَيْنَ الْمَحَلَّتَيْنِ
u'بَيْنٌ مَحَلٌّ':Added, #1: 1	بَيْنَ مَحَلَّتَيْنِ
u'بَيْنٌ مَحَلٌّ':Added, #2: 2	بَيْنَ مَحَلٍّ
u'بَيْنٌ مَحَلٌّ':Added, #2: 2	بَيْنَ مَحَلِّ
u'بَيْنٌ مَحَلٌّ':Added, #2: 2	بَيْنَ مَحَلَّيْنِ
u'بَيْنٌ مَحَلَّةٌ':Added, #3: 3	بَيْنَ الْمَحَلَّيْنِ
u'بَيْنٌ مُحَمَّدٌ':Added, #1: 1	بَيْنَ الْمَحَلَّةِ
u'بَيْنٌ مُحَمَّدٌ':Added, #2: 2	بَيْنَ مُحَمّدٍ
u'بَيْنٌ مُحَمَّدٌ':Added, #2: 2	بَيْنَ مُحَمَّدِ
u'بَيْنٌ مَحْمِلٌ':Added, #5: 5	بَيْنَ مُحَمَّدٍ
u'بَيْنٌ مَحْمَلٌ':Added, #1: 1	بَيْنَ الْمَحْمِلِ
u'بَيْنٌ مَحْمِلٌ':Added, #1: 1	بَيْنَ الْمَحْمَلَيْنِ
u'بَيْنٌ مَحْمَلٌ':Added, #1: 1	بَيْنَ الْمَحْمِلَيْنِ
u'بَيْنٌ مَحْمُودٌ':Added, #1: 1	بَيْنَ مَحْمَلَيْنِ
u'بَيْنٌ مَحْمُولٌ':Added, #1: 1	بَيْنَ مَحْمُودٍ
u'بَيْنٌ مُخَاتِلٌ':Added, #3: 3	بَيْنَ الْمَحْمُولِ
u'بَيْنٌ مُخَاطَبٌ':Added, #1: 1	بَيْنَ مُخَاتِلٍ
u'بَيْنٌ مُخَالَطَةٌ':Added, #1: 1	بَيْنَ مُخَاطَبَيْنِ
u'بَيَّنَ مُخْتَارٌ':Predicate, #1: 1	بَيْنَ مُخَالَطَةِ
u'بَيْنٌ مُخْتَارٌ':Added, #1: 1	بَيَّنَ مُخْتَارَ
u'بَيْنٌ مُخْتَلِفٌ':Added, #1: 1	بَيْنَ الْمُخْتَارِ
u'بَيْنٌ مُخْتَلِفٌ':Added, #1: 1	بَيْنَ الْمُخْتَلِفِ
u'بَيْنٌ مُخْتَلِفٌ':Added, #1: 1	بَيْنَ مُخْتَلِفِ
u'بَيْنٌ مُخْتَلِفٌ':Added, #1: 1	بَيْنَ مُخْتَلِفَاتٍ
u'بَيْنٌ مُخْتَلِفٌ':Added, #2: 2	بَيْنَ الْمُخْتَلِفَاتِ
u'بَيْنٌ مُخْتَلِفٌ':Added, #2: 2	بَيْنَ الْمُخْتَلِفَيْنِ
u'بَيَّنَ مَخْرَجٌ':Predicate, #2: 2	بَيْنَ مُخْتَلِفَيْنِ
u'بَيْنٌ مَخْرَجٌ':Added, #1: 1	بَيَّنَ مَخْرَجَ
u'بَيْنٌ مَخْرَجٌ':Added, #1: 1	بَيْنَ الْمَخْرَجَيْنِ
u'بَيْنٌ مَخْرَجٌ':Added, #1: 1	بَيْنَ مَخْرَجٍ
u'بَيْنٌ مُخِيفٌ':Added, #8: 8	بَيْنَ مَخْرَجِ
u'بَيْنٌ مُدٌّ':Added, #1: 1	بَيْنَ الْمُخِيفِ
u'بَيْنٌ مُدٌّ':Added, #1: 1	بَيْنِ الْمُدَّتَيْنِ
u'بَيْنٌ مُدَبِّرٌ':Added, #3: 3	بَيْنَ الْمُدَّتَيْنِ
u'بَيْنٌ مُدَبَّرٌ':Added, #1: 1	بَيْنَ الْمُدَبِّرِ
u'بَيْنٌ مُدَبَّرٌ':Added, #1: 1	بَيْنَ الْمُدَبَّرَيْنِ
u'بَيْنٌ مُدَبَّرٌ':Added, #1: 1	بَيْنَ مُدَبَّرِ
u'بَيَّنَ مُدَّةٌ':Predicate, #7: 7	بَيْنَ الْمُدَبَّرِ
u'بَيْنٌ مُدَّةٌ':Added, #5: 5	بَيَّنَ الْمُدَّةَ
u'بَيْنٌ مُدَّةٌ':Added, #3: 3	بَيْنَ مُدَّةٍ
u'بَيْنٌ مَدْخُولٌ':Added, #5: 5	بَيْنَ الْمُدَّةِ
u'بَيْنٌ مَدْخُولٌ':Added, #2: 2	بَيْنَ الْمَدْخُولَةِ
u'بَيْنٌ مَدْرَسَةٌ':Added, #9: 9	بَيْنَ الْمَدْخُولِ
u'بَيْنٌ مُدْرِكٌ':Added, #1: 1	بَيْنَ الْمَدْرَسَةِ
u'بَيْنٌ مُدْرَكٌ':Added, #1: 1	بَيْنَ الْمُدْرِكِ
u'بَيْنٌ مُدْرِكٌ':Added, #1: 1	بَيْنَ الْمُدْرَكَاتِ
u'بَيْنٌ مُدْرَكَاتٌ':Added, #1: 1	بَيْنَ مُدْرِكِ
u'بَيْنٌ مُدَّعِي':Added, #1: 1	بَيْنَ الْمُدْرَكَاتِ
u'بَيْنٌ مَدْفُونٌ':Added, #5: 5	بَيْنَ الْمُدَّعِيَيْنِ
u'بَيْنٌ مَدْقُوق':Added, #1: 1	بَيْنَ الْمَدْفُونِ
u'بَيْنٌ مَدْلُولٌ':Added, #1: 1	بَيْنَ الْمَدْقُوقِ
u'بَيْنٌ مَدْلُولٌ':Added, #1: 1	بَيْنَ مَدْلُولَيْنِ
u'بَيْنٌ مَدَنِيٌّ':Added, #2: 2	بَيْنَ مَدْلُولِ
u'بَيْنٌ مُدَوَّرٌ':Added, #1: 1	بَيْنَ الْمَدَنِيِّ
u'بَيْنٌ مُدَوَّنٌ':Added, #1: 1	بَيْنَ الْمُدَوَّرَةِ
u'بَيْنٌ مُدَوَّنَةٌ':Added, #1: 1	بَيْنَ الْمُدَوَّنَةِ
u'بَيْنٌ مَدِينٌ':Added, #1: 1	بَيْنَ الْمُدَوَّنَةِ
u'بَيْنٌ مَدِينٌ':Added, #1: 1	بَيْنَ الْمَدِينَتَيْنِ
u'بَيْنٌ مَدِينٌ':Added, #1: 1	بَيْنَ مَدِينَتَيْنِ
u'بَيْنٌ مَدِينَةٌ':Added, #6: 6	بَيْنَ الْمَدِينَةِ
u'بَيْنٌ مَذَاهِبُ':Added, #6: 6	بَيْنَ الْمَدِينَةِ
u'بَيْنٌ مَذْبُوحٌ':Added, #2: 2	بَيْنَ الْمَذَاهِبِ
u'بَيْنٌ مَذْكُورٌ':Added, #1: 1	بَيْنَ الْمَذْبُوحِ
u'بَيْنٌ مَذْكُورٌ':Added, #1: 1	بَيْنَ الْمَذْكُورِ
u'بَيْنٌ مَذْهَبٌ':Added, #2: 2	بَيْنَ الْمَذْكُورَاتِ
u'بَيْنٌ مَذْهَبٌ':Added, #1: 1	بَيْن الْمَذْهَبَيْنِ
u'بَيْنٌ مَذْهَبٌ':Added, #1: 1	بَيْنَ مَذْهَبِ
u'بَيْنٌ مَذْهَبٌ':Added, #1: 1	بَيْنَ مَذْهَبَيْنِ
u'بَيَّنَ مرٌّ':Predicate, #5: 5	بَيْنَ الْمَذْهَبَيْنِ
u'بَيْنٌ مرٌّ':Added, #1: 1	بَيَّنَ مَرَّةً
u'بَيْنٌ مرٌّ':Added, #1: 1	بَيْنَ الْمَرَّةِ
u'بَيْنٌ مَرْء':Added, #3: 3	بَيْنَ الْمَرَّاتِ
u'بَيْنٌ مَرَاتِبُ':Added, #1: 1	بَيْن الْمَرْئِيَّةِ
u'بَيْنٌ مَرَاتِبُ':Added, #1: 1	بَيْنَ الْمَرَاتِبِ
u'بَيْنٌ مُرَاحٌ':Added, #1: 1	بَيْنَ مَرَاتِبِ
u'بَيَّنَ مراد':Predicate, #3: 3	بَيْنَ الْمُرَاحِ
u'بَيَّنَ مُرَادٌ':Predicate, #1: 1	بَيَّنَ مُرَادَ
u'بَيَّنَ مراد':Predicate, #1: 1	بَيَّنَ مُرَادَ
u'بَيَّنَ مُرَادٌ':Predicate, #3: 3	بَيَّنَ الْمُرَادَ
u'بَيْنٌ مراد':Added, #3: 3	بَيَّنَ الْمُرَادَ
u'بَيْنٌ مُرَادٌ':Added, #1: 1	بَيْنَ الْمُرَادِ
u'بَيْنٌ مراد':Added, #1: 1	بَيْنَ الْمُرَادِ
u'بَيْنٌ مُرَادٌ':Added, #1: 1	بَيْنَ مُرَادٍ
u'بَيْنٌ مُرَادٌ':Added, #1: 1	بَيْنَ مُرَادٍ
u'بَيْنٌ مراسيل':Added, #2: 2	بَيْنَ الْمُرَادَيْنِ
u'بَيْنٌ مَرَاسِيلُ':Added, #1: 1	بَيْنَ مَرَاسِيلِ
u'بَيْنٌ مُرَاعَاةٌ':Added, #1: 1	بَيْنَ مَرَاسِيلِ
u'بَيْنٌ مُرَاهِقٌ':Added, #1: 1	بَيْنَ مُرَاعَاةِ
u'بَيْنٌ مُرَاهِقٌ':Added, #1: 1	بَيْنَ الْمُرَاهِقِ
u'بَيْنٌ مَرَّةٌ':Added, #1: 1	بَيْنَ الْمُرَاهِقَةِ
u'بَيْنٌ مَرَّةٌ':Added, #1: 1	بَيْنَ الْمَرَّةِ
u'بَيْنٌ مُرْتَدٌّ':Added, #3: 3	بَيْنَ الْمَرَّاتِ
u'بَيْنٌ مُرْتَدٌّ':Added, #1: 1	بَيْنَ الْمُرْتَدِّ
u'بَيْنٌ مُرْتَزِقٌ':Added, #1: 1	بَيْن مُرْتَدٍّ
u'بَيْنٌ مُرْتَهِنٌ':Added, #1: 1	بَيْنَ مُرْتَزِقَةِ
u'بَيْنٌ مَرْدُودٌ':Added, #3: 3	بَيْنَ الْمُرْتَهِنِ
u'بَيْنٌ مُرْسَلٌ':Added, #1: 1	بَيْنَ الْمَرْدُودِ
u'بَيْنٌ مَرَضٌ':Added, #3: 3	بَيْنَ مُرْسَلِ
u'بَيْنٌ مَرَضٌ':Added, #1: 1	بَيْنَ الْمَرَضِ
u'بَيْنٌ مُرْضِعٌ':Added, #1: 1	بَيْنَ مَرَضِهِ
u'بَيْنٌ مِرْفَقٌ':Added, #4: 4	بَيْنَ الْمُرْضِعَةِ
u'بَيْنٌ مَرْكُوبٌ':Added, #1: 1	بَيْنَ الْمِرْفَقَيْنِ
u'بَيْنٌ مَرْكُوبٌ':Added, #1: 1	بَيْنَ الْمَرْكُوبِ
u'بَيْنٌ مرو':Added, #1: 1	بَيْنَ الْمَرْكُوبَيْنِ
u'بَيْنٌ مَرْوِيّ':Added, #2: 2	بَيْنَ الْمَرْوَتَيْنِ
u'بَيْنٌ مُرِيدٌ':Added, #1: 1	بَيْنَ الْمَرْوِيَّيْنِ
u'بَيْنٌ مَرِيضٌ':Added, #1: 1	بَيْنَ مُرِيدِ
u'بَيْنٌ مَرِيضٌ':Added, #2: 2	بَيْنَ الْمَرِيضَةِ
u'بَيْنٌ مَزاد':Added, #4: 4	بَيْنَ الْمَرِيضِ
u'بَيْنٌ مَزَارِعُ':Added, #3: 3	بَيْنَ مَزَادَتَيْنِ
u'بَيْنٌ مُزَارِعٌ':Added, #1: 1	بَيْنَ الْمَزَارِعِ
u'بَيْنٌ مُزَارِعٌ':Added, #1: 1	بَيْنَ الْمُزَارِعَيْنِ
u'بَيْنٌ مَزَامِيرُ':Added, #6: 6	بَيْنَ الْمُزَارِعِ
u'بَيْنٌ مُزَايَدَةٌ':Added, #1: 1	بَيْنَ الْمَزَامِيرِ
u'بَيْنٌ مَسٌّ':Added, #1: 1	بَيْنَ الْمُزَايَدَةِ
u'بَيْنٌ مَسّ':Added, #1: 1	بَيْنَ الْمَسِّ
u'بَيْنٌ مُسَافِرٌ':Added, #2: 2	بَيْنَ الْمَسَّيْنِ
u'بَيْنٌ مُسَافِرٌ':Added, #11: 11	بَيْنَ الْمُسَافِرِ
u'بَيْنٌ مُساكِن':Added, #2: 2	بَيْنَ مُسَافِرٍ
u'بَيْنٌ مساكين':Added, #2: 2	بَيْنَ الْمُسَاكِنَيْنِ
u'بَيْنٌ مَسْأَلَةٌ':Added, #1: 1	بَيْنَ الْمَسَاكِينِ
u'بَيْنٌ مَسْأَلَةٌ':Added, #2: 2	بَيْنَ الْمَسْأَلَةِ
u'بَيْنٌ مَسْأَلَةٌ':Added, #2: 2	بَيْنَ مَسْأَلَتِهِ
u'بَيْنٌ مَسْأَلَةٌ':Added, #33: 33	بَيْنَ مَسْأَلَةِ
u'بَيْنٌ مُسَاوَاةٌ':Added, #5: 5	بَيْن مَسْأَلَةِ
u'بَيْنٌ مَسَائِلُ':Added, #1: 1	بَيْنَ الْمُسَاوَاةِ
u'بَيْنٌ مَسَائِلُ':Added, #1: 1	بَيْنَ مَسَائِلِ
u'بَيْنٌ مَسَائِلُ':Added, #3: 3	بَيْنَ مَسَائِلِهِ
u'بَيْنٌ مَسْبُوق':Added, #5: 5	بَيْنَ الْمَسَائِلِ
u'بَيْنٌ مُسْتَأْجِرٌ':Added, #1: 1	بَيْنَ الْمَسْبُوقِ
u'بَيْنٌ مُسْتَأْجِرٌ':Added, #1: 1	بَيْنَ مُسْتَأْجِرِ
u'بَيَّنَ مُسْتَحَبٌّ':Predicate, #5: 5	بَيْنَ الْمُسْتَأْجِرِ
u'بَيْنٌ مُسْتَحَبٌّ':Added, #1: 1	بَيَّنَ الْمُسْتَحَبَّ
u'بَيْنٌ مُسْتَحَقٌّ':Added, #3: 3	بَيْنَ الْمُسْتَحَبِّ
u'بَيْنٌ مُسْتَحِقٌّ':Added, #1: 1	بَيْنَ الْمُسْتَحَقِّ
u'بَيْنٌ مُسْتَحِقٌّ':Added, #1: 1	بَيْنَ الْمُسْتَحِقِّ
u'بَيْنٌ مُسْتَعَارٌ':Added, #1: 1	بَيْنَ مُسْتَحِقٍّ
u'بَيْنٌ مُسْتَعْمَلٌ':Added, #1: 1	بَيْنَ الْمُسْتَعَارِ
u'بَيْنٌ مُسْتَعِيرٌ':Added, #2: 2	بَيْنَ الْمُسْتَعْمَلِ
u'بَيْنٌ مُسْتَغْرِقٌ':Added, #3: 3	بَيْنَ الْمُسْتَعِيرِ
u'بَيْنٌ مُسْتَفِيضٌ':Added, #1: 1	بَيْنَ الْمُسْتَغْرِقِ
u'بَيْنٌ مُسْتَقِلٌّ':Added, #1: 1	بَيْنَ الْمُسْتَفِيضِ
u'بَيْنٌ مُسْتنْبِطٌ':Added, #1: 1	بَيْنَ الْمُسْتَقِلِّ
u'بَيَّنَ مُسْتَنَدٌ':Predicate, #1: 1	بَيْنَ مُسْتَنْبِطٍ
u'بَيْنٌ مُسْتَنَدٌ':Added, #1: 1	بَيَّنَ الْمُسْتَنَدَ
u'بَيْنٌ مُسْتَهْزِئٌ':Added, #1: 1	بَيْنَ الْمُسْتَنَدِ
u'بَيْنٌ مُسْتَيْقِظ':Added, #1: 1	بَيْنَ مُسْتَهْزِئٍ
u'بَيْنٌ مَسْجِدٌ':Added, #1: 1	بَيْنَ الْمُسْتَيْقِظِ
u'بَيْنٌ مَسْجِدٌ':Added, #19: 19	بَيْنَ الْمَسْجِدِ
u'بَيْنٌ مَسْح':Added, #4: 4	بَيْنَ الْمَسْجِدَيْنِ
u'بَيْنٌ مَسْحٌ':Added, #1: 1	بَيْنَ الْمَسْحَيْنِ
u'بَيْنٌ مَسْحٌ':Added, #4: 4	بَيْنَ مَسْحِ
u'بَيْنٌ مُسِرّ':Added, #8: 8	بَيْنَ الْمَسْحِ
u'بَيْنٌ مَسْرُورٌ':Added, #1: 1	بَيْنَ الْمُسِرِّ
u'بَيْنٌ مَسْرُوقٌ':Added, #1: 1	بَيْنَ مَسْرُورٍ
u'بَيْنٌ مَسْفُوحٌ':Added, #2: 2	بَيْنَ الْمَسْرُوقِ
u'بَيْنٌ مِسْكٌ':Added, #1: 1	بَيْنَ الْمَسْفُوحِ
u'بَيْنٌ مُسْكِرٌ':Added, #1: 1	بَيْنَ الْمِسْكِ
u'بَيْنٌ مُسْكِرٌ':Added, #1: 1	بَيْنَ الْمُسْكِرَاتِ
u'بَيْنٌ مَسْلَكٌ':Added, #3: 3	بَيْنَ الْمُسْكِرِ
u'بَيْنٌ مَسْلَكٌ':Added, #1: 1	بَيْنَ مَسْلَكِ
u'بَيْنٌ مُسْلِمٌ':Added, #2: 2	بَيْنَ الْمَسْلَكَيْنِ
u'بَيْنٌ مُسْلِمٌ':Added, #1: 1	بَيْن الْمُسْلِمِ
u'بَيْنٌ مُسْلِمٌ':Added, #1: 1	بَيْنَ الْمُسْلِمَيْنِ
u'بَيْنٌ مُسْلِمٌ':Added, #2: 2	بَيْنَ مُسْلِمَةٍ
u'بَيْنٌ مُسْلِمٌ':Added, #30: 30	بَيْنَ مُسْلِمٍ
u'بَيْنٌ مُسْلِمٌ':Added, #3: 3	بَيْنَ الْمُسْلِمَةِ
u'بَيْنٌ مُسْلِمٌ':Added, #55: 55	بَيْنَ الْمُسْلِمِ
u'بَيْنٌ مُسَمَّى':Added, #6: 6	بَيْنَ مُسْلِمَيْنِ
u'بَيَّنَ مُسَهِّلٌ':Predicate, #1: 1	بَيْنَ مُسَمَّيَاتِ
u'بَيْنٌ مُسِيءٌ':Added, #1: 1	بَيَّنَ الْمُسَهِّلَ
u'بَيْنٌ مَسِيرَةٌ':Added, #1: 1	بَيْنَ الْمُسِيءِ
u'بَيْنٌ مُشار':Added, #1: 1	بَيْنَ مَسِيرَةِ
u'بَيْنٌ مُشاعٌ':Added, #1: 1	بَيْنَ الْمُشَارِ
u'بَيْنٌ مَشَاعِرُ':Added, #1: 1	بَيْنَ مُشَاعٍ
u'بَيْنٌ مُشاهَرَة':Added, #1: 1	بَيْنَ الْمَشَاعِرِ
u'بَيْنٌ مَشَايِخُ':Added, #1: 1	بَيْنَ الْمُشَاهَرَةِ
u'بَيْنٌ مَشَايِخُ':Added, #1: 1	بَيْنِ الْمَشَايِخِ
u'بَيْنٌ مَشَايِخُ':Added, #1: 1	بَيْنَ مَشَايِخِ
u'بَيْنٌ مُشَبَّهٌ':Added, #24: 24	بَيْنَ الْمَشَايِخِ
u'بَيْنٌ مُشْتَبِهٌ':Added, #2: 2	بَيْنَ الْمُشَبَّهِ
u'بَيْنٌ مُشْتَرَكٌ':Added, #1: 1	بَيْنَ الْمُشْتَبِهِ
u'بَيْنٌ مُشْتَرِكٌ':Added, #1: 1	بَيْنَ الْمُشْتَرَكَتَيْنِ
u'بَيْنٌ مُشْتَرَكٌ':Added, #1: 1	بَيْنَ مُشْتَرِكَيْنِ
u'بَيْنٌ مُشْتَرِي':Added, #3: 3	بَيْنَ الْمُشْتَرَكِ
u'بَيْنٌ مُشْتَقٌّ':Added, #5: 5	بَيْنَ الْمُشْتَرِيَيْنِ
u'بَيْنٌ مُشَخِّص':Added, #4: 4	بَيْنَ الْمُشْتَقِّ
u'بَيْنٌ مَشْرِقٌ':Added, #1: 1	بَيْنَ الْمُشَخِّصَاتِ
u'بَيْنٌ مَشْرِقِيٌّ':Added, #29: 29	بَيْنَ الْمَشْرِقِ
u'بَيْنٌ مَشْرُوطٌ':Added, #2: 2	بَيْنَ الْمَشْرِقِيِّ
u'بَيْنٌ مَشَقَّةٌ':Added, #1: 1	بَيْنَ الْمَشْرُوطِ
u'بَيْنٌ مَشْهُودٌ':Added, #1: 1	بَيْنَ الْمَشَقَّةِ
u'بَيَّنَ مَشْهُورٌ':Predicate, #6: 6	بَيْنَ الْمَشْهُودِ
u'بَيْنٌ مَشْهُورٌ':Added, #1: 1	بَيَّنَ الْمَشْهُورَ
u'بَيْنٌ مَشْيٌ':Added, #2: 2	بَيْنَ الْمَشْهُورِ
u'بَيْنٌ مَشِيئَةٌ':Added, #2: 2	بَيْنَ الْمَشْيِ
u'بَيْنٌ مَشِيئَةٌ':Added, #1: 1	بَيْنَ مَشِيئَةِ
u'بَيْنٌ مَصٌّ':Added, #2: 2	بَيْنَ الْمَشِيئَةِ
u'بَيَّنَ مَصَارِفُ':Predicate, #2: 2	بَيْنَ الْمَصِّ
u'بَيْنٌ مَصَارِفُ':Added, #1: 1	بَيَّنَ مَصَارِفَ
u'بَيْنٌ مُصَافَحَةٌ':Added, #1: 1	بَيْنَ الْمَصَارِفِ
u'بَيْنٌ مُصَالِحٌ':Added, #1: 1	بَيْنَ الْمُصَافَحَةِ
u'بَيْنٌ مَصَالِحُ':Added, #1: 1	بَيْنَ الْمُصَالِحِ
u'بَيْنٌ مَصْبُوبٌ':Added, #2: 2	بَيْنَ الْمَصَالِحِ
u'بَيَّنَ مَصْبُوغ':Predicate, #1: 1	بَيْنَ الْمَصْبُوبِ
u'بَيْنٌ مَصْبُوغ':Added, #1: 1	بَيَّنَ الْمَصْبُوغَ
u'بَيْنٌ مَصْدَرٌ':Added, #1: 1	بَيْنَ الْمَصْبُوغِ
u'بَيْنٌ مَصْدَرٌ':Added, #1: 1	بَيْنَ مَصْدَرٍ
u'بَيْنٌ مُصَدِّقٌ':Added, #4: 4	بَيْنَ الْمَصْدَرِ
u'بَيَّنَ مِصْرٌ':Predicate, #1: 1	بَيْنَ مُصَدِّقٍ
u'بَيْنٌ مِصْرٌ':Added, #2: 2	بَيَّنَ الْمِصْرَ
u'بَيْنٌ مِصْرٌ':Added, #1: 1	بَيْنَ الْمِصْرِ
u'بَيْنٌ مِصْرٌ':Added, #1: 1	بَيْنَ مِصْرٍ
u'بَيْنٌ مِصْرٌ':Added, #1: 1	بَيْنَ مِصْرِهِ
u'بَيْنٌ مِصْرٌ':Added, #2: 2	بَيْنَ مِصْرَيْنِ
u'بَيْنٌ مِصْرَاعٌ':Added, #6: 6	بَيْنَ الْمِصْرَيْنِ
u'بَيْنٌ مِصْرَاعٌ':Added, #1: 1	بَيْنَ الْمِصْرَاعَيْنِ
u'بَيْنٌ مَصْلَحَةٌ':Added, #2: 2	بَيْنَ مِصْرَاعَيْنِ
u'بَيَّنَ مُصَنِّفٌ':Subject, #1: 1	بَيْنَ الْمَصْلَحَةِ
u'بَيْنٌ مُصِيبٌ':Added, #12: 12	بَيَّنَ الْمُصَنِّفُ
u'بَيْنٌ مَضَاجِعُ':Added, #1: 1	بَيْنَ مُصِيبَتَيْنِ
u'بَيْنٌ مُضَادٌّ':Added, #1: 1	بَيْنَ مَضَاجِعِ
u'بَيْنٌ مَضَارُّ':Added, #1: 1	بَيْنَ مُضَادَّيْنِ
u'بَيْنٌ مُضَارِبٌ':Added, #1: 1	بَيْنَ الْمَضَارِّ
u'بَيْنٌ مُضَارِبٌ':Added, #16: 16	بَيْنَ الْمُضَارِبِ
u'بَيْنٌ مُضَارَبَةٌ':Added, #6: 6	بَيْنَ الْمُضَارِبَيْنِ
u'بَيْنٌ مُضَاضٌ':Added, #2: 2	بَيْنَ الْمُضَارَبَةِ
u'بَيْنٌ مُضَافٌ':Added, #1: 1	بَيْنَ مُضَاضٍ
u'بَيْنٌ مَضْرُوبٌ':Added, #4: 4	بَيْنَ الْمُضَافِ
u'بَيْنٌ مَضْرُوبٌ':Added, #1: 1	بَيْنَ الْمَضْرُوبَةِ
u'بَيْنٌ مُضْطَرٌّ':Added, #2: 2	بَيْنَ مَضْرُوبٍ
u'بَيْنٌ مُضْطَرٌّ':Added, #1: 1	بَيْنَ مُضْطَرٍّ
u'بَيْنٌ مَضْمَضَةٌ':Added, #2: 2	بَيْنَ الْمُضْطَرِّ
u'بَيْنٌ مَضْمَضَةٌ':Added, #11: 11	بَيْنَ الْمَضْمَضَةِ
u'بَيْنٌ مَضْمَضَةٌ':Added, #1: 1	بَيْن الْمَضْمَضَةِ
u'بَيْنٌ مَضْمُونٌ':Added, #1: 1	بَيْنِ الْمَضْمَضَةِ
u'بَيْنٌ مَضْمُونٌ':Added, #1: 1	بَيْنَ مَضْمُونِ
u'بَيْنٌ مَضْمُونٌ':Added, #2: 2	بَيْنَ مَضْمُونِهِ
u'بَيْنٌ مُضِيٌّ':Added, #3: 3	بَيْنَ الْمَضْمُونِ
u'بَيْنٌ مُضِيٌّ':Added, #1: 1	بَيْنَ مُضِيِّ
u'بَيْنٌ مَضِيقٌ':Added, #3: 3	بَيْنَ الْمُضِيِّ
u'بَيْنٌ مُطَابَقَةٌ':Added, #2: 2	بَيْنَ الْمَضِيقِ
u'بَيْنٌ مُطَالَبٌ':Added, #1: 1	بَيْنَ الْمُطَابَقَةِ
u'بَيْنٌ مُطَالَبٌ':Added, #1: 1	بَيْنَ الْمُطَالَبَةِ
u'بَيْنٌ مُطَالَبٌ':Added, #2: 2	بَيْنَ مُطَالَبَتِهِ
u'بَيْنٌ مُطَالَبَةٌ':Added, #3: 3	بَيْنَ مُطَالَبَةِ
u'بَيْنٌ مُطَالَبَةٌ':Added, #1: 1	بَيْنَ الْمُطَالَبَةِ
u'بَيْنٌ مُطَالَبَةٌ':Added, #2: 2	بَيْنَ مُطَالَبَتِهِ
u'بَيْنٌ مَطْبُوخٌ':Added, #3: 3	بَيْنَ مُطَالَبَةِ
u'بَيْنٌ مَطَرٌ':Added, #1: 1	بَيْنَ الْمَطْبُوخَةِ
u'بَيْنٌ مُطْلَقٌ':Added, #1: 1	بَيْنَ مَطَرِ
u'بَيْنٌ مُطْلَقٌ':Added, #10: 10	بَيْنَ الْمُطْلَقِ
u'بَيْنٌ مُطْلَقٌ':Added, #2: 2	بَيْنَ الْمُطْلَقَةِ
u'بَيْنٌ مَظَاهِرُ':Added, #4: 4	بَيْنَ مُطْلَقِ
u'بَيْنٌ مُعَارَضَةٌ':Added, #1: 1	بَيْنَ الْمَظَاهِرِ
u'بَيْنٌ مَعَاشٌ':Added, #1: 1	بَيْنَ مُعَارَضَةٍ
u'بَيْنٌ مُعَامَلَةٌ':Added, #1: 1	بَيْنَ مَعَاشٍ
u'بَيْنٌ مُعَانِدٌ':Added, #1: 1	بَيْنَ الْمُعَامَلَةِ
u'بَيْنٌ مُعَانِدٌ':Added, #1: 1	بَيْنَ مُعَانِدٍ
u'بَيْنٌ مَعَانِي':Added, #2: 2	بَيْنَ الْمُعَانِدِ
u'بَيَّنَ مُعْتَادٌ':Predicate, #1: 1	بَيْنَ مَعَانِيهِ
u'بَيْنٌ مُعْتَدٌّ':Added, #1: 1	بَيَّنَ الْمُعْتَادَ
u'بَيْنٌ مُعْتَدٌّ':Added, #1: 1	بَيْنَ مُعْتَدَّةِ
u'بَيَّنَ مُعْتَرِضٌ':Subject, #2: 2	بَيْنَ الْمُعْتَدَّةِ
u'بَيْنٌ مُعْتَزِلٌ':Added, #1: 1	بَيَّنَ الْمُعْتَرِضُ
u'بَيْنٌ مُعْتَزِلَةٌ':Added, #2: 2	بَيْنَ الْمُعْتَزِلَةِ
u'بَيْنٌ مُعْتَقٌ':Added, #2: 2	بَيْنَ الْمُعْتَزِلَةِ
u'بَيْنٌ مُعْتَقٌ':Added, #2: 2	بَيْنَ الْمُعْتَقَيْنِ
u'بَيْنٌ مُعْتَقَلٌ':Added, #3: 3	بَيْنَ الْمُعْتَقِ
u'بَيْنٌ مُعَدٌّ':Added, #1: 1	بَيْنَ مُعْتَقَلِ
u'بَيْنٌ مَعْدِنٌ':Added, #2: 2	بَيْنَ الْمُعَدِّ
u'بَيْنٌ مَعْدُول':Added, #1: 1	بَيْنَ الْمَعْدِنِ
u'بَيْنٌ مَعْدُول':Added, #1: 1	بَيْن الْمَعْدُولِ
u'بَيْنٌ مَعْدُومٌ':Added, #2: 2	بَيْنَ الْمَعْدُولِ
u'بَيْنٌ مُعَذَّبٌ':Added, #1: 1	بَيْنَ الْمَعْدُومِ
u'بَيْنٌ مُعَذِّبٌ':Added, #1: 1	بَيْنِ مُعَذّبٍ
u'بَيْنٌ مَعْذُورٌ':Added, #1: 1	بَيْنِ مُعَذّبٍ
u'بَيْنٌ مَعْذُورٌ':Added, #2: 2	بَيْن الْمَعْذُورِ
u'بَيْنٌ مُعْرَبٌ':Added, #3: 3	بَيْنَ الْمَعْذُورِ
u'بَيْنٌ مَعَرَّة':Added, #1: 1	بَيْنَ الْمُعْرَبِ
u'بَيْنٌ مُعَرَّفٌ':Added, #1: 1	بَيْنَ مَعَرَّةِ
u'بَيْنٌ مُعَرَّفٌ':Added, #1: 1	بَيْن الْمُعَرَّفِ
u'بَيْنٌ مَعْرِفَةٌ':Added, #4: 4	بَيْنَ الْمُعَرَّفِ
u'بَيْنٌ مَعْرِفَة':Added, #1: 1	بَيْنَ الْمَعْرِفَةِ
u'بَيْنٌ مَعْرِفَةٌ':Added, #1: 1	بَيْنَ الْمَعْرِفَةِ
u'بَيْنٌ مَعْرِفَة':Added, #1: 1	بَيْنَ مَعْرِفَةِ
u'بَيْنٌ مَعْرِفَةٌ':Added, #1: 1	بَيْنَ مَعْرِفَةِ
u'بَيْنٌ مَعْرِفَة':Added, #2: 2	بَيْنَ مَعْرِفَتِهِ
u'بَيْنٌ مَعْرُوفٌ':Added, #2: 2	بَيْنَ مَعْرِفَتِهِ
u'بَيْنٌ مَعْزُولٌ':Added, #1: 1	بَيْنَ مَعْرُوفٍ
u'بَيْنٌ مَعْصُومٌ':Added, #1: 1	بَيْنَ الْمَعْزُولِ
u'بَيْنٌ مَعْصِيَةٌ':Added, #1: 1	بَيْنَ الْمَعْصُومِ
u'بَيْنٌ مَعْصِيَةٌ':Added, #1: 1	بَيْن الْمَعْصِيَةِ
u'بَيْنٌ مَعْطُوف':Added, #2: 2	بَيْنَ الْمَعْصِيَةِ
u'بَيْنٌ مَعْطُوف':Added, #10: 10	بَيْنَ الْمَعْطُوفِ
u'بَيْنٌ مُعَلَّقٌ':Added, #1: 1	بَيْنَ الْمَعْطُوفَيْنِ
u'بَيْنٌ مُعَلِّلٌ':Added, #1: 1	بَيْنَ الْمُعَلَّقِ
u'بَيْنٌ مُعَلَّمٌ':Added, #1: 1	بَيْنَ الْمُعَلِّلِ
u'بَيْنٌ مُعْلِنٌ':Added, #1: 1	بَيْنَ الْمُعَلَّمِ
u'بَيْنٌ مَعْلُوفٌ':Added, #1: 1	بَيْنَ الْمُعْلِنِ
u'بَيْنٌ مَعْلُولٌ':Added, #1: 1	بَيْنَ الْمَعْلُوفَةِ
u'بَيْنٌ مَعْلُومٌ':Added, #1: 1	بَيْنَ الْمَعْلُولِ
u'بَيْنٌ مَعْلُومٌ':Added, #1: 1	بَيْنَ الْمَعْلُومَاتِ
u'بَيْنٌ مَعْلُومٌ':Added, #2: 2	بَيْنَ مَعْلُومٍ
u'بَيْنٌ مَعْنًى':Added, #3: 3	بَيْنَ الْمَعْلُومِ
u'بَيْنٌ مَعْنًى':Added, #12: 12	بَيْنَ مَعْنَيَيْنِ
u'بَيْنٌ مَعْنًى':Added, #1: 1	بَيْن الْمَعْنَيَيْنِ
u'بَيْنٌ مَعِيبٌ':Added, #4: 4	بَيْنَ الْمَعْنَيَيْنِ
u'بَيْنٌ مُعِير':Added, #3: 3	بَيْنَ الْمَعِيبَيْنِ
u'بَيْنٌ مُعِير':Added, #1: 1	بَيْنَ الْمُعِيرِ
u'بَيْنٌ مُعَيَّنٌ':Added, #2: 2	بَيْنَ الْمُعِيرَيْنِ
u'بَيْنٌ مُعَيَّنٌ':Added, #1: 1	بَيْنَ الْمُعَيَّنَاتِ
u'بَيْنٌ مُعَيَّنٌ':Added, #1: 1	بَيْنَ مُعَيَّنَيْنِ
u'بَيْنٌ مَغْرِبٌ':Added, #5: 5	بَيْنَ الْمُعَيَّنِ
u'بَيْنٌ مَغْرِبٌ':Added, #1: 1	بَيْن الْمَغْرِبِ
u'بَيْنٌ مَغْرِبٌ':Added, #1: 1	بَيْنَ الْمَغْرِبَيْنِ
u'بَيْنٌ مَغْسُولٌ':Added, #86: 86	بَيْنَ الْمَغْرِبِ
u'بَيْنٌ مَغْسُولٌ':Added, #1: 1	بَيْنَ الْمَغْسُولَيْنِ
u'بَيْنٌ مَغْصُوب':Added, #2: 2	بَيْنَ مَغْسُولَاتٍ
u'بَيْنٌ مُغَلَّظ':Added, #1: 1	بَيْنَ الْمَغْصُوبَةِ
u'بَيْنٌ مُفَارَقَةٌ':Added, #1: 1	بَيْنَ الْمُغَلَّظَةِ
u'بَيْنٌ مُفَارَقَةٌ':Added, #1: 1	بَيْنَ الْمُفَارَقَةِ
u'بَيْنٌ مَفَاهِيمُ':Added, #1: 1	بَيْنَ مُفَارَقَتِهِ
u'بَيْنٌ مَفْتُوحٌ':Added, #1: 1	بَيْنَ مَفَاهِيمِهِ
u'بَيْنٌ مَفْتُونٌ':Added, #1: 1	بَيْنَ الْمَفْتُوحِ
u'بَيْنٌ مَفْتُونٌ':Added, #1: 1	بَيْنَ مَفْتُونٍ
u'بَيْنٌ مُفْتِي':Added, #1: 1	بَيْنِ مَفْتُونٍ
u'بَيْنٌ مُفْرَدٌ':Added, #1: 1	بَيْنَ مُفْتِيَيْنِ
u'بَيْنٌ مُفْرَدٌ':Added, #1: 1	بَيْنَ الْمُفْرَدَيْنِ
u'بَيْنٌ مُفَرَّقٌ':Added, #2: 2	بَيْنَ مُفْرَدَيْنِ
u'بَيْنٌ مُفْسِدٌ':Added, #2: 2	بَيْنَ مُفَرَّقٍ
u'بَيْنٌ مُفَسَّرٌ':Added, #2: 2	بَيْنَ الْمُفْسِدِ
u'بَيْنٌ مَفْعُولٌ':Added, #1: 1	بَيْنَ الْمُفَسَّرِ
u'بَيْنٌ مَفْعُولٌ':Added, #1: 1	بَيْنَ الْمَفْعُولِ
u'بَيْنٌ مَفْقُودٌ':Added, #1: 1	بَيْنَ مَفْعُولِ
u'بَيْنٌ مُفْلِسٌ':Added, #2: 2	بَيْنَ الْمَفْقُودِ
u'بَيْنٌ مُفْلِسٌ':Added, #1: 1	بَيْن الْمُفْلِسِ
u'بَيَّنَ مَفْهُومٌ':Predicate, #3: 3	بَيْنَ الْمُفْلِسِ
u'بَيْنٌ مَفْهُومٌ':Added, #3: 3	بَيَّنَ مَفْهُومَ
u'بَيْنٌ مَفْهُومٌ':Added, #1: 1	بَيْنَ مَفْهُومَيْنِ
u'بَيْنٌ مَقَابِرُ':Added, #3: 3	بَيْنَ الْمَفْهُومِ
u'بَيْنٌ مَقَابِرُ':Added, #2: 2	بَيْنَ الْمَقَابِرِ
u'بَيْنٌ مقارِنُ':Added, #2: 2	بَيْنَ مَقَابِرِ
u'بَيْنٌ مُقَارِنٌ':Added, #2: 2	بَيْنَ الْمُقَارِنِ
u'بَيْنٌ مُقاسَمَة':Added, #2: 2	بَيْنَ الْمُقَارِنِ
u'بَيْنٌ مُقاسَمَة':Added, #2: 2	بَيْنَ مُقَاسَمَةِ
u'بَيْنٌ مَقَالٌ':Added, #3: 3	بَيْنَ الْمُقَاسَمَةِ
u'بَيْنٌ مَقَالٌ':Added, #1: 1	بَيْن الْمَقَالَتَيْنِ
u'بَيْنٌ مَقَالٌ':Added, #1: 1	بَيْنَ الْمَقَالَتَيْنِ
u'بَيْنٌ مَقَامٌ':Added, #1: 1	بَيْنَ الْمَقَالَيْنِ
u'بَيْنٌ مَقَامٌ':Added, #6: 6	بَيْنَ الْمَقَامَيْنِ
u'بَيْنٌ مُقَامٌ':Added, #7: 7	بَيْنَ الْمَقَامِ
u'بَيْنٌ مُقَايَضَةٌ':Added, #7: 7	بَيْنَ الْمُقَامِ
u'بَيْنٌ مَقْبَرَةٌ':Added, #1: 1	بَيْنَ الْمُقَايَضَةِ
u'بَيْنٌ مَقْبَرَةٌ':Added, #1: 1	بَيْنَ الْمَقْبَرَةِ
u'بَيْنٌ مَقْبُوضٌ':Added, #1: 1	بَيْنَ مَقْبَرَةِ
u'بَيْنٌ مَقْبُولٌ':Added, #4: 4	بَيْنَ الْمَقْبُوضِ
u'بَيْنٌ مَقْتُولٌ':Added, #1: 1	بَيْنَ مَقْبُولٍ
u'بَيَّنَ مِقْدَارٌ':Predicate, #4: 4	بَيْنَ الْمَقْتُولِ
u'بَيْنٌ مِقْدَارٌ':Added, #3: 3	بَيَّنَ مِقْدَارَ
u'بَيْنٌ مِقْدَارٌ':Added, #1: 1	بَيْنَ مِقْدَارِ
u'بَيَّنَ مُقَدَّمٌ':Predicate, #1: 1	بَيْنَ مِقْدَارَيْنِ
u'بَيْنٌ مُقَدِّمٌ':Added, #1: 1	بَيَّنَ الْمُقَدَّمَ
u'بَيْنٌ مُقَدَّمٌ':Added, #1: 1	بَيْنَ الْمُقَدِّمَةِ
u'بَيْنٌ مُقَدِّمَةٌ':Added, #2: 2	بَيْنَ الْمُقَدَّمِ
u'بَيْنٌ مُقِرّ':Added, #1: 1	بَيْنَ الْمُقَدِّمَةِ
u'بَيْنٌ مَقْصِدٌ':Added, #2: 2	بَيْنَ الْمُقِرَّةِ
u'بَيْنٌ مَقْصُودٌ':Added, #1: 1	بَيْنَ الْمَقْصِدَيْنِ
u'بَيْنٌ مَقْطُوعٌ':Added, #1: 1	بَيْنَ الْمَقْصُودَيْنِ
u'بَيْنٌ مَقْعَدٌ':Added, #4: 4	بَيْنَ الْمَقْطُوعِ
u'بَيْنٌ مُقَلِّدٌ':Added, #2: 2	بَيْنَ مَقْعَدِهِ
u'بَيَّنَ مُقَيَّدٌ':Subject, #1: 1	بَيْنَ الْمُقَلِّدِ
u'بَيْنٌ مُقِيمٌ':Added, #1: 1	بَيَّنَ الْمُقَيَّدُ
u'بَيْنٌ مُقِيمٌ':Added, #1: 1	بَيْنَ مُقِيمٍ
u'بَيْنٌ مُكَاتَبَةٌ':Added, #2: 2	بَيْنَ الْمُقِيمِ
u'بَيْنٌ مُكَاتَبَةٌ':Added, #1: 1	بَيْنَ مُكَاتَبَتِهِ
u'بَيَّنَ مَكَانٌ':Predicate, #2: 2	بَيْنَ الْمُكَاتَبَةِ
u'بَيَّنَ مَكَانٌ':Predicate, #1: 1	بَيَّنَ الْمَكَانَ
u'بَيْنٌ مَكَانٌ':Added, #1: 1	بَيَّنَ مَكَانَ
u'بَيْنٌ مَكْتُوبٌ':Added, #3: 3	بَيْنَ الْمَكَانَيْنِ
u'بَيْنٌ مَكْتُوبٌ':Added, #1: 1	بَيْنَ الْمَكْتُوبَةِ
u'بَيْنٌ مَكْتُوبٌ':Added, #1: 1	بَيْنَ الْمَكْتُوبَتَيْنِ
u'بَيْنٌ مُكْثٌ':Added, #1: 1	بَيْنَ مَكْتُوبَتَيْنِ
u'بَيْنٌ مَكْحُول':Added, #1: 1	بَيْنَ مُكْثِهِ
u'بَيْنٌ مُكْرَهٌ':Added, #3: 3	بَيْنَ مَكْحُولٍ
u'بَيْنٌ مُكْرِهٌ':Added, #2: 2	بَيْنَ الْمُكْرَهِ
u'بَيْنٌ مَكْرُوهٌ':Added, #2: 2	بَيْنَ الْمُكْرِهِ
u'بَيْنٌ مَكْرُوهٌ':Added, #1: 1	بَيْنَ الْمَكْرُوهِ
u'بَيْنٌ مَكْسُورٌ':Added, #1: 1	بَيْنَ مَكْرُوهَيْنِ
u'بَيْنٌ مُكَلَّفٌ':Added, #1: 1	بَيْنَ الْمَكْسُورِ
u'بَيْنٌ مُكَلَّفٌ':Added, #1: 1	بَيْنَ الْمُكَلَّفَةِ
u'بَيْنٌ مُكَمِّلٌ':Added, #2: 2	بَيْنَ الْمُكَلَّفِ
u'بَيْنٌ مَكِّيّ':Added, #1: 1	بَيْنَ الْمُكَمِّلِ
u'بَيْنٌ مَكِيلٌ':Added, #4: 4	بَيْنَ الْمَكِّيِّ
u'بَيْنٌ مِلْءٌ':Added, #1: 1	بَيْنَ الْمَكِيلِ
u'بَيْنٌ مَلأٌ':Added, #1: 1	بَيْنَ الْمِلْءِ
u'بَيْنٌ مَلاَئِكَةٌ':Added, #1: 1	بَيْنَ مَلَأَيْنِ
u'بَيْنٌ مُلاَئِمٌ':Added, #2: 2	بَيْنَ الْمَلائِكَةِ
u'بَيْنٌ مَلْبُوس':Added, #1: 1	بَيْنَ الْمُلَائِمِ
u'بَيْنٌ مِلَّةٌ':Added, #1: 1	بَيْنَ مَلْبُوسِ
u'بَيْنٌ مُلْتَقِط':Added, #1: 1	بَيْنَ مِلَّةٍ
u'بَيْنٌ مَلْحَظٌ':Added, #2: 2	بَيْنَ الْمُلْتَقِطِ
u'بَيْنٌ مُلْحَقٌ':Added, #1: 1	بَيْنَ الْمَلْحَظَيْنِ
u'بَيْنٌ مَلْحَمَةٌ':Added, #1: 1	بَيْنَ الْمُلْحَقِ
u'بَيْنٌ مَلْزُوم':Added, #1: 1	بَيْنَ الْمَلْحَمَةِ
u'بَيْنٌ مُلْصَقٌ':Added, #1: 1	بَيْنَ مَلْزُومَيْنِ
u'بَيْنٌ مِلْكٌ':Added, #1: 1	بَيْنَ الْمُلْصَقِ
u'بَيْنٌ مِلْكٌ':Added, #11: 11	بَيْنَ الْمِلْكَيْنِ
u'بَيْنٌ مِلْكٌ':Added, #1: 1	بَيْن الْمِلْكَيْنِ
u'بَيْنٌ مِلْكٌ':Added, #1: 1	بَيْنَ مِلْكِ
u'بَيْنٌ مِلْكٌ':Added, #1: 1	بَيْنَ مِلْكِهِ
u'بَيْنٌ مِلْكٌ':Added, #2: 2	بَيْنَ مِلْكٍ
u'بَيْنٌ مُلُوكٌ':Added, #4: 4	بَيْنَ الْمِلْكِ
u'بَيْنٌ مَلِيءٌ':Added, #1: 1	بَيْنَ الْمُلُوكِ
u'بَيْنٌ مَمَالِيكُ':Added, #1: 1	بَيْنَ مَلِيءِ
u'بَيْنٌ مُمْتَدٌّ':Added, #1: 1	بَيْنَ الْمَمَالِيكِ
u'بَيْنٌ مُمْتَنِعٌ':Added, #2: 2	بَيْنَ الْمُمْتَدِّ
u'بَيْنٌ مَمْدوحٌ':Added, #1: 1	بَيْنَ الْمُمْتَنِعِ
u'بَيْنٌ مُمْكِنٌ':Added, #1: 1	بَيْنَ مَمْدُوحٍ
u'بَيْنٌ مُمْكِن':Added, #1: 1	بَيْنَ الْمُمْكِنِ
u'بَيْنٌ مَمْلُوكٌ':Added, #1: 1	بَيْنَ الْمُمْكِنِ
u'بَيْنٌ مَمْلُوكٌ':Added, #1: 1	بَيْنَ الْمَمْلُوكِ
u'بَيْنٌ مَمْلُوكٌ':Added, #1: 1	بَيْنَ مَمْلُوكِهِ
u'بَيْنٌ مَمْلُوكٌ':Added, #1: 1	بَيْنَ مَمْلُوكَيْنِ
u'بَيْنٌ مَمْلُوكٌ':Added, #2: 2	بَيْنَ الْمَمْلُوكَتَيْنِ
u'بَيْنٌ مُمَيِّزٌ':Added, #2: 2	بَيْنَ الْمَمْلُوكَيْنِ
u'بَيْنٌ مَنٌّ':Added, #3: 3	بَيْنَ الْمُمَيِّزِ
u'بَيْنٌ مَنَابِتُ':Added, #2: 2	بَيْنَ الْمَنِّ
u'بَيْنٌ مُنَادَاةٌ':Added, #1: 1	بَيْنَ مَنَابِتِ
u'بَيْنٌ مُنَاسِبٌ':Added, #1: 1	بَيْنَ الْمُنَادَاةِ
u'بَيْنٌ مُنَاسَبَةٌ':Added, #1: 1	بَيْنَ الْمُنَاسِبِ
u'بَيْنٌ مُنافاة':Added, #1: 1	بَيْنَ الْمُنَاسَبَةِ
u'بَيْنٌ مُنَافَسَةٌ':Added, #1: 1	بَيْنَ مُنَافَاةِ
u'بَيْنٌ مَنَافِعُ':Added, #1: 1	بَيْنَ الْمُنَافَسَةِ
u'بَيْنٌ مَنَافِعُ':Added, #1: 1	بَيْنَ الْمَنَافِعِ
u'بَيْنٌ مَنَاقِلُ':Added, #1: 1	بَيْنَ مَنَافِعِ
u'بَيْنٌ مُناقَلَة':Added, #1: 1	بَيْنَ الْمَنَاقِلِ
u'بَيْنٌ مُناقَلَة':Added, #1: 1	بَيْنَ الْمُنَاقَلَةِ
u'بَيْنٌ مَنَاكِبُ':Added, #1: 1	بَيْنَ مُنَاقَلَةِ
u'بَيْنٌ مِنْبَرٌ':Added, #3: 3	بَيْنَ الْمَنَاكِبِ
u'بَيْنٌ مِنْجَلٌ':Added, #3: 3	بَيْنَ الْمِنْبَرِ
u'بَيْنٌ مَنْدُوبٌ':Added, #1: 1	بَيْنَ الْمِنْجَلَيْنِ
u'بَيْنٌ مَنْذُور':Added, #1: 1	بَيْنَ الْمَنْدُوبِ
u'بَيْنٌ مَنْزِلٌ':Added, #1: 1	بَيْنَ الْمَنْذُورِ
u'بَيْنٌ مَنْزِلٌ':Added, #1: 1	بَيْن الْمَنْزِلَتَيْنِ
u'بَيْنٌ مَنْزِلٌ':Added, #1: 1	بَيْنَ الْمَنْزِلَيْنِ
u'بَيْنٌ مَنْزِلٌ':Added, #1: 1	بَيْنَ مَنْزِلٍ
u'بَيْنٌ مَنْزِلٌ':Added, #2: 2	بَيْنَ الْمَنْزِلِ
u'بَيْنٌ مَنْزِلٌ':Added, #4: 4	بَيْنَ الْمَنْزِلَتَيْنِ
u'بَيْنٌ مَنْسُوبٌ':Added, #4: 4	بَيْنَ مَنْزِلَتَيْنِ
u'بَيْنٌ مَنْصُوصٌ':Added, #1: 1	بَيْنَ مَنْسُوبَيْنِ
u'بَيْنٌ مَنْصُوصٌ':Added, #1: 1	بَيْنَ الْمَنْصُوصِ
u'بَيْنٌ مَنْطُوقٌ':Added, #1: 1	بَيْنَ الْمَنْصُوصَةِ
u'بَيْنٌ مَنْعٌ':Added, #4: 4	بَيْنَ الْمَنْطُوقِ
u'بَيْنٌ مَنْعٌ':Added, #2: 2	بَيْنَ الْمَنْعِ
u'بَيْنٌ مُنْفَرِدٌ':Added, #7: 7	بَيْنَ مَنْعِ
u'بَيْنٌ مُنْفَرِدٌ':Added, #1: 1	بَيْنَ الْمُنْفَرِدِ
u'بَيْنٌ مُنْفَصِلٌ':Added, #1: 1	بَيْنَ الْمُنْفَرِدَتَيْنِ
u'بَيْنٌ مُنْفَصِلٌ':Added, #1: 1	بَيْنَ الْمُنْفَصِلِ
u'بَيْنٌ مَنْفَعَةٌ':Added, #2: 2	بَيْنَ الْمُنْفَصِلَةِ
u'بَيْنٌ مُنْقَطِعٌ':Added, #4: 4	بَيْنَ الْمَنْفَعَةِ
u'بَيْنٌ مَنْقُولٌ':Added, #1: 1	بَيْنِ مُنْقَطِعٍ
u'بَيْنٌ مَنْقُولٌ':Added, #1: 1	بَيْنَ الْمَنْقُولَيْنِ
u'بَيْنٌ مَنْقُولٌ':Added, #2: 2	بَيْنَ الْمَنْقُولَةِ
u'بَيْنٌ مَنْكِبٌ':Added, #3: 3	بَيْنَ الْمَنْقُولِ
u'بَيْنٌ مَنْكِبٌ':Added, #1: 1	بَيْنَ الْمَنْكِبَيْنِ
u'بَيْنٌ مُنْكَرٌ':Added, #3: 3	بَيْنَ الْمَنْكِبِ
u'بَيْنٌ مُنْكِرٌ':Added, #1: 1	بَيْنَ الْمُنْكَرِ
u'بَيْنٌ مُنَكَّرٌ':Added, #1: 1	بَيْنَ الْمُنْكِرِ
u'بَيْنٌ مُنَكَّرٌ':Added, #1: 1	بَيْنَ الْمُنَكَّرَةِ
u'بَيْنٌ مُنَكَّرٌ':Added, #1: 1	بَيْنَ مُنَكَّرِ
u'بَيْنٌ مَنْكُوح':Added, #3: 3	بَيْنَ الْمُنَكَّرِ
u'بَيْنٌ مَنْكُوح':Added, #1: 1	بَيْنَ الْمَنْكُوحَةِ
u'بَيْنٌ مَنْكُوح':Added, #1: 1	بَيْنَ مَنْكُوحَةٍ
u'بَيْنٌ مَنْهِيٌّ':Added, #3: 3	بَيْنَ الْمَنْكُوحَاتِ
u'بَيْنٌ مَنِيٌّ':Added, #1: 1	بَيْنَ الْمَنْهِيِّ
u'بَيْنٌ مَهَارَةٌ':Added, #2: 2	بَيْنَ مَنِيِّ
u'بَيْنٌ مَهْرٌ':Added, #1: 1	بَيْنَ الْمَهَارَةِ
u'بَيْنٌ مَهْرٌ':Added, #2: 2	بَيْنَ مَهْرِ
u'بَيْنٌ مَهْرٌ':Added, #3: 3	بَيْنَ الْمَهْرَيْنِ
u'بَيْنٌ مُهْمَلٌ':Added, #6: 6	بَيْنَ الْمَهْرِ
u'بَيْنٌ مَوَاتٌ':Added, #1: 1	بَيْنَ الْمُهْمَلَتَيْنِ
u'بَيَّنَ مُؤَاخَذَةٌ':Predicate, #1: 1	بَيْنَ مَوَاتِ
u'بَيْنٌ مُؤَاخَذَةٌ':Added, #1: 1	بَيَّنَ الْمُؤَاخَذَةَ
u'بَيْنٌ مَوَاضِعُ':Added, #1: 1	بَيْنَ الْمُؤَاخَذَةِ
u'بَيْنٌ مَوَاقِعُ':Added, #2: 2	بَيْنَ الْمَوَاضِعِ
u'بَيَّنَ مَوَاقِيتُ':Predicate, #2: 2	بَيْنَ مَوَاقِعِ
u'بَيْنٌ مَوَاقِيتُ':Added, #1: 1	بَيَّنَ الْمَوَاقِيتَ
u'بَيْنٌ مَوْتٌ':Added, #4: 4	بَيْنَ الْمَوَاقِيتِ
u'بَيْنٌ مَوْتٌ':Added, #18: 18	بَيْنَ الْمَوْتِ
u'بَيْنٌ مَوْتٌ':Added, #1: 1	بَيْنَ مَوْتِهِ
u'بَيْنٌ مَوْت':Added, #5: 5	بَيْنَ مَوْتِ
u'بَيْنٌ مُوجِبٌ':Added, #9: 9	بَيْنَ الْمَوْتَيْنِ
u'بَيْنٌ مُوجِبٌ':Added, #1: 1	بَيْنَ الْمُوجِبِ
u'بَيْنٌ مُوجِبٌ':Added, #1: 1	بَيْنَ الْمُوجِبَةِ
u'بَيْنٌ مُوجَبٌ':Added, #1: 1	بَيْنَ الْمُوجِبَيْنِ
u'بَيْنٌ مُوجِبٌ':Added, #2: 2	بَيْنَ مُوجَبِ
u'بَيَّنَ مُؤَجِّرٌ':Subject, #3: 3	بَيْنَ مُوجِبِ
u'بَيْنٌ مُؤَجَّلٌ':Added, #1: 1	بَيَّنَ الْمُؤَجِّرُ
u'بَيْنٌ مَوْجُودٌ':Added, #1: 1	بَيْنَ مُؤَجَّلِهِ
u'بَيْنٌ مَوْجُودٌ':Added, #1: 1	بَيْنَ الْمَوْجُودَاتِ
u'بَيْنٌ مَوْجُودٌ':Added, #1: 1	بَيْنَ الْمَوْجُودَيْنِ
u'بَيْنٌ مَوْجُودٌ':Added, #2: 2	بَيْنَ مَوْجُودٍ
u'بَيْنٌ مُوسِرٌ':Added, #7: 7	بَيْنَ الْمَوْجُودِ
u'بَيْنٌ مُوسِرٌ':Added, #13: 13	بَيْنَ الْمُوسِرِ
u'بَيْنٌ مَوْصُوفٌ':Added, #1: 1	بَيْنَ مُوسِرَيْنِ
u'بَيَّنَ مَوْضِعٌ':Predicate, #1: 1	بَيْنَ الْمَوْصُوفِ
u'بَيَّنَ مَوْضِعٌ':Predicate, #1: 1	بَيَّنَ الْمَوْضِعَ
u'بَيْنٌ مَوْضِعٌ':Added, #3: 3	بَيَّنَ مَوْضِعَ
u'بَيْنٌ مَوْضِعٌ':Added, #1: 1	بَيْن الْمَوْضِعِ
u'بَيْنٌ مَوْضِعٌ':Added, #1: 1	بَيْنَ مَوْضِعِ
u'بَيْنٌ مَوْضِعٌ':Added, #2: 2	بَيْن الْمَوْضِعَيْنِ
u'بَيْنٌ مَوْضِعٌ':Added, #2: 2	بَيْنَ مَوْضِعٍ
u'بَيْنٌ مَوْضِعٌ':Added, #3: 3	بَيْنَ الْمَوْضِعِ
u'بَيْنٌ مَوْضُوعٌ':Added, #9: 9	بَيْنَ الْمَوْضِعَيْنِ
u'بَيْنٌ مَوْقُوفٌ':Added, #3: 3	بَيْنَ الْمَوْضُوعِ
u'بَيْنٌ مُؤَكَّدٌ':Added, #4: 4	بَيْنَ الْمَوْقُوفِ
u'بَيْنٌ مُؤَكِّدٌ':Added, #1: 1	بَيْنَ الْمُؤَكَّدِ
u'بَيْنٌ مُؤَكَّدٌ':Added, #1: 1	بَيْنَ الْمُؤَكِّدِ
u'بَيَّنَ مُوَكَّلٌ':Predicate, #1: 1	بَيْنَ الْمُؤَكَّدَتَيْنِ
u'بَيْنٌ مُوَكِّلٌ':Added, #1: 1	بَيَّنَ الْمُوَكَّلَ
u'بَيَّنَ مُؤَلِّفٌ':Subject, #4: 4	بَيْنَ الْمُوَكِّلِ
u'بَيْنٌ مَوْلُودٌ':Added, #3: 3	بَيَّنَ الْمُؤَلِّفُ
u'بَيْنٌ مَوْلًى':Added, #1: 1	بَيْنَ الْمَوْلُودِ
u'بَيْنٌ مُؤْمِنٌ':Added, #14: 14	بَيْنَ الْمَوْلَيَيْنِ
u'بَيْنٌ مُؤْمِنٌ':Added, #1: 1	بَيْنَ الْمُؤْمِنَةِ
u'بَيْنٌ مُؤْمِنٌ':Added, #1: 1	بَيْنَ مُؤْمِنٍ
u'بَيْنٌ مَيْتٌ':Added, #5: 5	بَيْنَ الْمُؤْمِنِ
u'بَيْنٌ مَيْتَةٌ':Added, #2: 2	بَيْنَ الْمَيْتَةِ
u'بَيْنٌ مِيرَاثٌ':Added, #2: 2	بَيْنَ الْمَيْتَةِ
u'بَيْنٌ مِيقَاتٌ':Added, #1: 1	بَيْنَ الْمِيرَاثِ
u'بَيْنٌ مِيقَاتٌ':Added, #1: 1	بَيْنَ الْمِيقَاتَيْنِ
u'بَيْنٌ مِيقَاتٌ':Added, #1: 1	بَيْنَ مِيقَاتَيْنِ
u'بَيْنٌ مِيلٌ':Added, #3: 3	بَيْنَ الْمِيقَاتِ
u'بَيْنٌ مِيلٌ':Added, #18: 18	بَيْنَ الْمِيلَيْنِ
u'بَيْنٌ مَيْمُونٌ':Added, #1: 1	بَيْن الْمِيلَيْنِ
u'بَيْنٌ نَاحِي':Added, #1: 1	بَيْنَ مَيْمُونِ
u'بَيْنٌ نَاحِيَةٌ':Added, #1: 1	بَيْنَ نَاحِيَةِ
u'بَيْنٌ نَارٌ':Added, #1: 1	بَيْنَ نَاحِيَةِ
u'بَيْنٌ نَازِيٌّ':Added, #1: 1	بَيْنَ النَّارِ
u'بَيْنٌ نَازِيَّةٌ':Added, #1: 1	بَيْنَ النّازِيّةِ
u'بَيَّنَ نَاسٌ':Subject, #1: 1	بَيْنَ النّازِيّةِ
u'بَيْنٌ نَاسٌ':Added, #1: 1	بَيَّنَ النَّاسُ
u'بَيْنٌ نَاسٌ':Added, #14: 14	بَيْنَ النّاسِ
u'بَيْنٌ نَاسٌ':Added, #381: 381	بَيْنَ النَّاسِ
u'بَيْنٌ نَاسٌ':Added, #3: 3	بَيْنِ النَّاسِ
u'بَيْنٌ نَاسٌ':Added, #3: 3	بَيْنَ نَاسٍ
u'بَيْنٌ نَاسِخٌ':Added, #5: 5	بَيْن النَّاسِ
u'بَيْنٌ نَاسِخ':Added, #3: 3	بَيْنَ النَّاسِخِ
u'بَيْنٌ نَاشِزٌ':Added, #3: 3	بَيْنَ النَّاسِخِ
u'بَيْنٌ نَاطِقٌ':Added, #1: 1	بَيْنَ النَّاشِزَةِ
u'بَيْنٌ نَاظِرٌ':Added, #1: 1	بَيْنَ النَّاطِقِ
u'بَيْنٌ نَاظِرٌ':Added, #2: 2	بَيْنَ نَاظِرٍ
u'بَيْنٌ نَافِعٌ':Added, #5: 5	بَيْنَ النَّاظِرِ
u'بَيْنٌ نَافِعٌ':Added, #1: 1	بَيْنَ النَّافِعِ
u'بَيْنٌ نَافِلَةٌ':Added, #1: 1	بَيْنَ نَافِعٍ
u'بَيْنٌ نَاقِصٌ':Added, #4: 4	بَيْنَ النَّافِلَةِ
u'بَيْنٌ نَاقِلٌ':Added, #1: 1	بَيْنَ النَّاقِصَةِ
u'بَيْنٌ نَائِمٌ':Added, #1: 1	بَيْنَ نَاقِلِهِ
u'بَيْنٌ نَائِمٌ':Added, #2: 2	بَيْنَ النّائِمِ
u'بَيْنٌ نَبْش':Added, #6: 6	بَيْنَ النَّائِمِ
u'بَيْنٌ نُبُوَّةٌ':Added, #2: 2	بَيْنَ النَّبْشِ
u'بَيَّنَ نَبِيٌّ':Subject, #1: 1	بَيْنَ النُّبُوَّةِ
u'بَيْنٌ نَبِيٌّ':Added, #7: 7	بَيَّنَ النَّبِيُّ
u'بَيْنٌ نَبِيذٌ':Added, #6: 6	بَيْنَ النَّبِيِّ
u'بَيْنٌ نَجَاسَةٌ':Added, #1: 1	بَيْنَ النَّبِيذِ
u'بَيْنٌ نَجَاسَةٌ':Added, #2: 2	بَيْنَ نَجَاسَةٍ
u'بَيْنٌ نَجْدٌ':Added, #4: 4	بَيْنَ النَّجَاسَةِ
u'بَيْنٌ نَجْمٌ':Added, #3: 3	بَيْنَ نَجْدٍ
u'بَيْنٌ نَجْمٌ':Added, #1: 1	بَيْنَ نَجْمَيْنِ
u'بَيْنٌ نُحَاةٌ':Added, #2: 2	بَيْنَ النَّجْمَيْنِ
u'بَيْنٌ نَحْلٌ':Added, #2: 2	بَيْنَ النُّحَاةِ
u'بَيْنٌ نَحْوٌ':Added, #1: 1	بَيْنَ النَّحْلِ
u'بَيْنٌ نَحْوٌ':Added, #1: 1	بَيْن نَحْوِ
u'بَيْنٌ نَحْوِيٌّ':Added, #7: 7	بَيْنَ نَحْوِ
u'بَيْنٌ نَحِيفٌ':Added, #8: 8	بَيْنَ النَّحْوِيِّ
u'بَيْنٌ نَخْلٌ':Added, #2: 2	بَيْنَ النَّحِيفِ
u'بَيْنٌ نَخْلٌ':Added, #1: 1	بَيْن النَّخْلِ
u'بَيْنٌ نَخْلٌ':Added, #2: 2	بَيْنَ نَخْلٍ
u'بَيْنٌ نَخِيلٌ':Added, #4: 4	بَيْنَ النَّخْلِ
u'بَيْنٌ نِدَاءٌ':Added, #1: 1	بَيْنَ النّخِيلِ
u'بَيْنٌ نِدَاءٌ':Added, #1: 1	بَيْنَ نِدَاءِ
u'بَيْنٌ نَدْبٌ':Added, #3: 3	بَيْنَ النِّدَاءِ
u'بَيْنٌ نذر':Added, #1: 1	بَيْنَ نَدْبِ
u'بَيْنٌ نَذْرٌ':Added, #13: 13	بَيْنَ النَّذْرِ
u'بَيْنٌ نذر':Added, #13: 13	بَيْنَ النَّذْرِ
u'بَيْنٌ نَذْرٌ':Added, #2: 2	بَيْنَ نَذْرِ
u'بَيْنٌ نَرْدٌ':Added, #2: 2	بَيْنَ نَذْرِ
u'بَيْنٌ نَزَع':Added, #3: 3	بَيْنَ النَّرْدِ
u'بَيْنٌ نَزْعٌ':Added, #2: 2	بَيْنَ النَّزَعَتَيْنِ
u'بَيْنٌ نَزْع':Added, #2: 2	بَيْنَ نَزْعِ
u'بَيْنٌ نزعة':Added, #4: 4	بَيْنَ النَّزْعَتَيْنِ
u'بَيْنٌ نَزْعَةٌ':Added, #1: 1	بَيْنَ النَّزْعَةِ
u'بَيْنٌ نزعة':Added, #1: 1	بَيْنَ النَّزْعَةِ
u'بَيْنٌ نُزُولٌ':Added, #2: 2	بَيْنَ النَّزَعَةِ
u'بَيْنٌ نُزُولٌ':Added, #1: 1	بَيْنَ النُّزُولِ
u'بَيْنٌ نَسْءٌ':Added, #2: 2	بَيْنَ نُزُولِ
u'بَيْنٌ نِساءٌ':Added, #2: 2	بَيْنَ نَسْءٍ
u'بَيْنٌ نِساءٌ':Added, #1: 1	بَيْنَ النّسَاءِ
u'بَيْنٌ نِساءٌ':Added, #1: 1	بَيْنَ نِسَاءِ
u'بَيْنٌ نِساءٌ':Added, #33: 33	بَيْنَ النِّسَاءِ
u'بَيْنٌ نَسَبٌ':Added, #4: 4	بَيْنَ نِسَاءٍ
u'بَيْنٌ نَسَبٌ':Added, #1: 1	بَيْنَ نَسَبٍ
u'بَيْنٌ نِسْبَةٌ':Added, #2: 2	بَيْنَ النَّسَبِ
u'بَيْنٌ نُسُكٌ':Added, #1: 1	بَيْنَ النِّسْبَةِ
u'بَيْنٌ نُسُكٌ':Added, #1: 1	بَيْن نُسُكَيْنِ
u'بَيْنٌ نِسْوَةٌ':Added, #32: 32	بَيْنَ النُّسُكَيْنِ
u'بَيْنٌ نِسْوَةٌ':Added, #1: 1	بَيْنَ النِّسْوَةِ
u'بَيْنٌ نِسْيَانٌ':Added, #2: 2	بَيْنَ نِسْوَةٍ
u'بَيْنٌ نُشُوزٌ':Added, #8: 8	بَيْنَ النِّسْيَانِ
u'بَيْنٌ نَصٌّ':Added, #1: 1	بَيْنَ النُّشُوزِ
u'بَيْنٌ نَصٌّ':Added, #1: 1	بَيْن النَّصَّيْنِ
u'بَيْنٌ نَصٌّ':Added, #2: 2	بَيْنَ النَّصَّيْنِ
u'بَيْنٌ نَصٌّ':Added, #2: 2	بَيْنَ نَصِّ
u'بَيْنٌ نِصَابٌ':Added, #5: 5	بَيْنَ النَّصِّ
u'بَيْنٌ نصب':Added, #4: 4	بَيْنَ النِّصَابَيْنِ
u'بَيْنٌ نصب':Added, #1: 1	بَيْنَ النَّصْبِ
u'بَيْنٌ نَصْبٌ':Added, #1: 1	بَيْنَ النُّصُبِ
u'بَيْنٌ نُصُبٌ':Added, #1: 1	بَيْنَ النَّصْبِ
u'بَيْنٌ نصب':Added, #1: 1	بَيْنَ النُّصُبِ
u'بَيْنٌ نَصْبٌ':Added, #1: 1	بَيْنَ نَصْبِ
u'بَيْنٌ نَصْرَانِيٌّ':Added, #1: 1	بَيْنَ نَصْبِ
u'بَيْنٌ نَصْرَانِيٌّ':Added, #1: 1	بَيْنَ النَّصْرَانِيِّ
u'بَيْنٌ نِصْفٌ':Added, #1: 1	بَيْنَ نَصْرَانِيَّيْنِ
u'بَيْنٌ نِصْفٌ':Added, #1: 1	بَيْنَ النِّصْفَيْنِ
u'بَيْنٌ نِصْفٌ':Added, #4: 4	بَيْنَ النِّصْفِ
u'بَيْنٌ نُصُوصٌ':Added, #8: 8	بَيْنَ نِصْفِ
u'بَيْنٌ نُصُوصٌ':Added, #1: 1	بَيْنَ النُّصُوصِ
u'بَيَّنَ نَصِيبٌ':Predicate, #2: 2	بَيْنَ نُصُوصِهِ
u'بَيْنٌ نَصِيبٌ':Added, #2: 2	بَيَّنَ نَصِيبَ
u'بَيْنٌ نَصِيبٌ':Added, #3: 3	بَيْنَ نَصِيبِ
u'بَيْنٌ نَصِيبٌ':Added, #3: 3	بَيْنَ نَصِيبِهِ
u'بَيْنٌ نضح':Added, #4: 4	بَيْنَ النَّصِيبَيْنِ
u'بَيْنٌ نَضْحٌ':Added, #1: 1	بَيْنَ النَّضْحِ
u'بَيْنٌ نُظَّارٌ':Added, #1: 1	بَيْنَ النَّضْحِ
u'بَيْنٌ نَظَرٌ':Added, #2: 2	بَيْنَ النُّظَّارِ
u'بَيْنٌ نَظَرٌ':Added, #1: 1	بَيْنَ نَظَرَيْنِ
u'بَيْنٌ نَظَرٌ':Added, #3: 3	بَيْنَ النَّظَرَيْنِ
u'بَيْنٌ نَظَرٌ':Added, #4: 4	بَيْنَ نَظَرِ
u'بَيَّنَ نَظِيرٌ':Predicate, #7: 7	بَيْنَ النَّظَرِ
u'بَيْنٌ نَظِيرٌ':Added, #1: 1	بَيَّنَ نَظِيرَ
u'بَيْنٌ نَعْلٌ':Added, #1: 1	بَيْنَ النَّظِيرَيْنِ
u'بَيْنٌ نَعَمٌ':Added, #1: 1	بَيْنَ النَّعْلِ
u'بَيْنٌ نِعَمٌ':Added, #1: 1	بَيْن النَّعَمِ
u'بَيْنٌ نعمة':Added, #1: 1	بَيْنَ النِّعَمِ
u'بَيْنٌ نِعْمَةٌ':Added, #1: 1	بَيْنَ النِّعْمَةِ
u'بَيْنٌ نعمة':Added, #1: 1	بَيْنَ النِّعْمَةِ
u'بَيْنٌ نِعْمَةٌ':Added, #1: 1	بَيْنَ نِعْمَةٍ
u'بَيْنٌ نَعْيٌ':Added, #1: 1	بَيْنَ نِعْمَةٍ
u'بَيْنٌ نفاس':Added, #1: 1	بَيْنَ النَّعْيِ
u'بَيْنٌ نِفَاسٌ':Added, #4: 4	بَيْنَ النِّفَاسِ
u'بَيْنٌ نَفْخ':Added, #4: 4	بَيْنَ النِّفَاسِ
u'بَيْنٌ نَفْخ':Added, #1: 1	بَيْنَ النَّفْخِ
u'بَيْنٌ نفر':Added, #3: 3	بَيْنَ النَّفْخَتَيْنِ
u'بَيْنٌ نفر':Added, #1: 1	بَيْن النَّفْرِ
u'بَيْنٌ نَفْرٌ':Added, #1: 1	بَيْنَ النَّفْرِ
u'بَيْنٌ نَفْرٌ':Added, #1: 1	بَيْن النَّفْرِ
u'بَيْنٌ نَفَرٌ':Added, #1: 1	بَيْنَ النَّفْرِ
u'بَيْنٌ نَفْسٌ':Added, #1: 1	بَيْنَ نَفَرٍ
u'بَيْنٌ نَفْسٌ':Added, #1: 1	بَيْنَ نَفْسَيْنِ
u'بَيْنٌ نَفْسٌ':Added, #2: 2	بَيْنَ نَفْسِ
u'بَيْنٌ نَفْسٌ':Added, #5: 5	بَيْنَ النَّفْسِ
u'بَيْنٌ نَفْسَانِيٌّ':Added, #5: 5	بَيْنَ نَفْسِهِ
u'بَيْنٌ نَفْعٌ':Added, #1: 1	بَيْنَ النَّفْسَانِيِّ
u'بَيْنٌ نَفْعٌ':Added, #18: 18	بَيْنَ النَّفْعِ
u'بَيْنٌ نَفَقٌ':Added, #1: 1	بَيْنَ نَفْعٍ
u'بَيَّنَ نَفَقَةٌ':Predicate, #1: 1	بَيْنَ نَفَقَتَيْنِ
u'بَيْنٌ نَفَقَةٌ':Added, #1: 1	بَيَّنَ نَفَقَةَ
u'بَيْنٌ نَفَقَةٌ':Added, #8: 8	بَيْنَ النَّفَقَةِ
u'بَيْنٌ نَفْلٌ':Added, #9: 9	بَيْنَ نَفَقَةِ
u'بَيْنٌ نَفْلٌ':Added, #1: 1	بَيْنَ نَفْلٍ
u'بَيْنٌ نُفُوسٌ':Added, #3: 3	بَيْنَ النَّفْلِ
u'بَيْنٌ نَفْيٌ':Added, #1: 1	بَيْنَ النُّفُوسِ
u'بَيْنٌ نَفْيٌ':Added, #1: 1	بَيْنَ نَفْيِهِ
u'بَيْنٌ نَفْيٌ':Added, #22: 22	بَيْنَ النَّفْيِ
u'بَيْنٌ نَفْيٌ':Added, #6: 6	بَيْنَ نَفْيٍ
u'بَيْنٌ نَقْدٌ':Added, #7: 7	بَيْنَ نَفْيِ
u'بَيْنٌ نَقْد':Added, #3: 3	بَيْنَ النَّقْدِ
u'بَيْنٌ نَقْصٌ':Added, #3: 3	بَيْنَ النَّقْدِ
u'بَيْنٌ نُقْصَانٌ':Added, #1: 1	بَيْنَ نَقْصِ
u'بَيْنٌ نَقْضٌ':Added, #1: 1	بَيْنَ النُّقْصَانِ
u'بَيْنٌ نَقْضٌ':Added, #1: 1	بَيْنَ نَقْضِهِ
u'بَيْنٌ نقل':Added, #3: 3	بَيْنَ النَّقْضِ
u'بَيْنٌ نَقْلٌ':Added, #1: 1	بَيْنَ نَقْلِهِ
u'بَيْنٌ نقل':Added, #1: 1	بَيْنَ نَقْلِهِ
u'بَيْنٌ نَقْلٌ':Added, #2: 2	بَيْنَ نَقْلِ
u'بَيْنٌ نَقْلٌ':Added, #2: 2	بَيْنَ نَقْلِ
u'بَيْنٌ نقلة':Added, #3: 3	بَيْنَ النَّقْلَيْنِ
u'بَيْنٌ نقلة':Added, #1: 1	بَيْنَ النَّقْلَةِ
u'بَيْنٌ نَقَلَةٌ':Added, #2: 2	بَيْنَ النَّقَلَةِ
u'بَيْنٌ نُقُودٌ':Added, #2: 2	بَيْنَ النَّقَلَةِ
u'بَيْنٌ نُقُولٌ':Added, #1: 1	بَيْنَ النُّقُودِ
u'بَيْنٌ نَقِيبٌ':Added, #1: 1	بَيْنَ النُّقُولِ
u'بَيْنٌ نَقِيضٌ':Added, #1: 1	بَيْنَ نَقِيبِ
u'بَيْنٌ نَقِيضٌ':Added, #12: 12	بَيْنَ النَّقِيضَيْنِ
u'بَيْنٌ نكاح':Added, #2: 2	بَيْنَ نَقِيضَيْنِ
u'بَيْنٌ نِكَاحٌ':Added, #20: 20	بَيْنَ النِّكَاحِ
u'بَيْنٌ نكاح':Added, #20: 20	بَيْنَ النِّكَاحِ
u'بَيْنٌ نِكَاحٌ':Added, #4: 4	بَيْنَ نِكَاحِ
u'بَيْنٌ نَكِرٌ':Added, #4: 4	بَيْنَ نِكَاحِ
u'بَيْنٌ نكرة':Added, #3: 3	بَيْنَ النَّكِرَةِ
u'بَيْنٌ نَكِرَةٌ':Added, #3: 3	بَيْنَ النَّكِرَةِ
u'بَيْنٌ نُكُولٌ':Added, #3: 3	بَيْنَ النَّكِرَةِ
u'بَيْنٌ نهار':Added, #1: 1	بَيْنَ نُكُولِ
u'بَيْنٌ نَهَارٌ':Added, #1: 1	بَيْنَ النَّهَارِ
u'بَيْنٌ نَهْرٌ':Added, #1: 1	بَيْنَ النَّهَارِ
u'بَيْنٌ نَهْرٌ':Added, #1: 1	بَيْنَ نَهْرٍ
u'بَيْنٌ نَهْرٌ':Added, #1: 1	بَيْنَ نَهْرَيْنِ
u'بَيْنٌ نَهْرٌ':Added, #2: 2	بَيْنَ النَّهْرِ
u'بَيْنٌ نَهْرٌ':Added, #2: 2	بَيْنَ النَّهْرَيْنِ
u'بَيْنٌ نَهْيٌ':Added, #4: 4	بَيْنَ نَهْرِ
u'بَيْنٌ نواحي':Added, #9: 9	بَيْنَ النَّهْيِ
u'بَيْنٌ نَوَاحِي':Added, #2: 2	بَيْنَ نَوَاحِيهِ
u'بَيْنٌ نُور':Added, #2: 2	بَيْنَ نَوَاحِيهِ
u'بَيْنٌ نُورَة':Added, #1: 1	بَيْنَ النُّورَةِ
u'بَيَّنَ نَوْعٌ':Predicate, #1: 1	بَيْنَ النُّورَةِ
u'بَيْنٌ نَوْعٌ':Added, #5: 5	بَيَّنَ النَّوْعَ
u'بَيْنٌ نَوْعٌ':Added, #11: 11	بَيْنَ النَّوْعَيْنِ
u'بَيْنٌ نَوْعٌ':Added, #1: 1	بَيْن نَوْعَيْنِ
u'بَيْنٌ نَوْعٌ':Added, #1: 1	بَيْنَ نَوْعَيْنِ
u'بَيْنٌ نَوْعٌ':Added, #4: 4	بَيْنَ النَّوْعِ
u'بَيْنٌ نَوْمٌ':Added, #4: 4	بَيْنَ نَوْعٍ
u'بَيْنٌ نُونٌ':Added, #1: 1	بَيْنَ النَّوْمِ
u'بَيْنٌ نِيَامٌ':Added, #1: 1	بَيْنَ النّونِ
u'بَيْنٌ نِيَّةٌ':Added, #1: 1	بَيْنَ النِّيَامِ
u'بَيْنٌ نِيَّةٌ':Added, #2: 2	بَيْنَ النِّيَّةِ
u'بَيْنٌ نِيَّةٌ':Added, #2: 2	بَيْنَ نِيَّتِهِ
u'بَيْنٌ نِيل':Added, #5: 5	بَيْنَ نِيَّةِ
u'بَيْنٌ هَاجِسٌ':Added, #1: 1	بَيْنَ النِّيلَيْنِ
u'بَيْنٌ هاشِمِيّ':Added, #1: 1	بَيْنَ الْهَاجِسِ
u'بَيْنٌ هَامَةٌ':Added, #1: 1	بَيْنَ الْهَاشِمِيِّ
u'بَيْنٌ هَبَابٌ':Added, #1: 1	بَيْنَ هَامَتِهِ
u'بَيْنٌ هِبَةٌ':Added, #1: 1	بَيْن الْهَبَابِ
u'بَيْنٌ هِبَةٌ':Added, #14: 14	بَيْنَ الْهِبَةِ
u'بَيْنٌ هِبَةٌ':Added, #1: 1	بَيْن الْهِبَةِ
u'بَيْنٌ هُبُوطٌ':Added, #5: 5	بَيْنَ هِبَةِ
u'بَيْنٌ هُبُوطٌ':Added, #1: 1	بَيْنَ الْهُبُوطِ
u'بَيْنٌ هِدَايَةٌ':Added, #1: 1	بَيْنَ هُبُوطِ
u'بَيْنٌ هَدَفٌ':Added, #1: 1	بَيْنَ الْهِدَايَةِ
u'بَيْنٌ هَدْمٌ':Added, #4: 4	بَيْنَ الْهَدَفَيْنِ
u'بَيْنٌ هَدِيٌّ':Added, #2: 2	بَيْنَ الْهَدْمِ
u'بَيْنٌ هَدْيٌ':Added, #3: 3	بَيْنَ الْهَدِيَّةِ
u'بَيْنٌ هَدِيَّةٌ':Added, #4: 4	بَيْنَ الْهَدْيِ
u'بَيْنٌ هِرٌّ':Added, #3: 3	بَيْنَ الْهَدِيَّةِ
u'بَيْنٌ هَرَوِيّ':Added, #2: 2	بَيْنَ الْهِرَّةِ
u'بَيْنٌ هُزْءٌ':Added, #1: 1	بَيْنَ الْهَرَوِيِّ
u'بَيْنٌ هَزْلٌ':Added, #1: 1	بَيْنَ الْهُزْءِ
u'بَيَّنَ هشام':Subject, #1: 1	بَيْنَ الْهَزْلِ
u'بَيَّنَ هِشَامٌ':Subject, #1: 1	بَيَّنَ هِشَامُ
u'بَيْنٌ هشام':Added, #1: 1	بَيَّنَ هِشَامُ
u'بَيْنٌ هشام':Added, #1: 1	بَيْنَ هِشَامٍ
u'بَيْنٌ هِشَامٌ':Added, #1: 1	بَيْنَ هِشَامِ
u'بَيْنٌ هِشَامٌ':Added, #1: 1	بَيْنَ هِشَامٍ
u'بَيْنٌ هلاك':Added, #1: 1	بَيْنَ هِشَامِ
u'بَيْنٌ هَلاَكٌ':Added, #1: 1	بَيْنَ هَلَاكِ
u'بَيْنٌ هلاك':Added, #1: 1	بَيْنَ هَلَاكِ
u'بَيْنٌ هَلاَكٌ':Added, #2: 2	بَيْنَ الْهَلَاكِ
u'بَيْنٌ هلاك':Added, #2: 2	بَيْنَ الْهَلَاكِ
u'بَيْنٌ هَلاَكٌ':Added, #2: 2	بَيْنَ هَلَاكِهِ
u'بَيْنٌ هِلاَلٌ':Added, #2: 2	بَيْنَ هَلَاكِهِ
u'بَيْنٌ هِلاَلٌ':Added, #1: 1	بَيْنَ هِلَالٍ
u'بَيْنٌ هَمٌّ':Added, #2: 2	بَيْنَ هِلَالِ
u'بَيْنٌ هَمْز':Added, #1: 1	بَيْنَ الْهَمِّ
u'بَيْنٌ همزة':Added, #1: 1	بَيْنَ هَمْزَتَيْنِ
u'بَيْنٌ هَمْزَةٌ':Added, #2: 2	بَيْنَ الْهَمْزَةِ
u'بَيْنٌ وَاجِبٌ':Added, #2: 2	بَيْنَ الْهَمْزَةِ
u'بَيْنٌ وَاجِبٌ':Added, #16: 16	بَيْنَ الْوَاجِبِ
u'بَيْنٌ وَاجِبٌ':Added, #1: 1	بَيْنَ الْوَاجِبَةِ
u'بَيْنٌ وَاجِبٌ':Added, #1: 1	بَيْنَ وَاجِبِ
u'بَيْنٌ وَاجِبٌ':Added, #1: 1	بَيْنَ وَاجِبَيْنِ
u'بَيْنٌ وَاجِبٌ':Added, #5: 5	بَيْنَ الْوَاجِبَيْنِ
u'بَيْنٌ واحد':Added, #8: 8	بَيْنَ وَاجِبٍ
u'بَيْنٌ وَاحِدٌ':Added, #19: 19	بَيْنَ وَاحِدَةٍ
u'بَيْنٌ واحد':Added, #19: 19	بَيْنَ وَاحِدَةٍ
u'بَيْنٌ وَاحِدٌ':Added, #1: 1	بَيْنَ وَاحِدِهِ
u'بَيْنٌ واحد':Added, #1: 1	بَيْنَ وَاحِدِهِ
u'بَيْنٌ وَاحِدٌ':Added, #4: 4	بَيْنَ وَاحِدٍ
u'بَيْنٌ واحد':Added, #4: 4	بَيْنَ وَاحِدٍ
u'بَيْنٌ وَاحِدٌ':Added, #6: 6	بَيْنَ الْوَاحِدِ
u'بَيْنٌ واحد':Added, #6: 6	بَيْنَ الْوَاحِدِ
u'بَيْنٌ وَاحِدٌ':Added, #7: 7	بَيْنَ الْوَاحِدَةِ
u'بَيَّنَ وَارِثٌ':Subject, #7: 7	بَيْنَ الْوَاحِدَةِ
u'بَيْنٌ وَارِثٌ':Added, #1: 1	بَيَّنَ الْوَارِثُ
u'بَيْنٌ وَارِثٌ':Added, #1: 1	بَيْنَ الْوَارِثَيْنِ
u'بَيْنٌ وَارِثٌ':Added, #1: 1	بَيْن وَارِثِ
u'بَيْنٌ وَارِثٌ':Added, #1: 1	بَيْنَ وَارِثِ
u'بَيْنٌ وَارِثٌ':Added, #2: 2	بَيْن الْوَارِثِ
u'بَيْنٌ وَارِدٌ':Added, #6: 6	بَيْنَ الْوَارِثِ
u'بَيْنٌ وَاسِعٌ':Added, #1: 1	بَيْن وَارِدٍ
u'بَيْنٌ وَاطِئٌ':Added, #2: 2	بَيْنَ الْوَاسِعِ
u'بَيَّنَ وَاقِعٌ':Predicate, #5: 5	بَيْنَ الْوَاطِئِ
u'بَيْنٌ وَاقِعٌ':Added, #1: 1	بَيَّنَ الْوَاقِعَ
u'بَيْنٌ وَاقِفٌ':Added, #2: 2	بَيْنَ الْوَاقِعِ
u'بَيْنٌ وَاقِفٌ':Added, #1: 1	بَيْن الْوَاقِفِ
u'بَيْنٌ وَالِدٌ':Added, #1: 1	بَيْنَ الْوَاقِفَيْنِ
u'بَيْنٌ وَالِدٌ':Added, #14: 14	بَيْنَ وَالِدَةٍ
u'بَيْنٌ وَالِدٌ':Added, #2: 2	بَيْنَ وَالِدٍ
u'بَيْنٌ وَالِدٌ':Added, #6: 6	بَيْنَ الْوَالِدِ
u'بَيْنٌ وَالِدٌ':Added, #6: 6	بَيْنَ الْوَالِدَةِ
u'بَيْنٌ وَبَاءٌ':Added, #8: 8	بَيْنَ الْوَالِدَيْنِ
u'بَيْنٌ وَثَنٌ':Added, #1: 1	بَيْنَ الْوَبَاءِ
u'بَيْنٌ وَثَنِيٌّ':Added, #1: 1	بَيْنَ الْوَثَنَيْنِ
u'بَيْنٌ وَثَنِيٌّ':Added, #1: 1	بَيْنَ الْوَثَنِيِّ
u'بَيَّنَ وَجْهٌ':Predicate, #1: 1	بَيْنَ وَثَنِيٍّ
u'بَيْنٌ وَجْهٌ':Added, #4: 4	بَيَّنَ وَجْهَ
u'بَيْنٌ وَجْهٌ':Added, #11: 11	بَيْنَ الْوَجْهَيْنِ
u'بَيْنٌ وَجْهٌ':Added, #2: 2	بَيْنَ وَجْهِهِ
u'بَيْنٌ وُجُوبٌ':Added, #2: 2	بَيْنَ وَجْهَيْنِ
u'بَيْنٌ وُجُوبٌ':Added, #15: 15	بَيْنَ الْوُجُوبِ
u'بَيْنٌ وُجُوبٌ':Added, #1: 1	بَيْنَ وُجُوبٍ
u'بَيْنٌ وُجُودٌ':Added, #5: 5	بَيْنَ وُجُوبِ
u'بَيْنٌ وُجُودٌ':Added, #1: 1	بَيْن وُجُودِ
u'بَيْنٌ وُجُودٌ':Added, #1: 1	بَيْنَ وُجُودِهِ
u'بَيْنٌ وُجُودٌ':Added, #4: 4	بَيْنَ وُجُودِ
u'بَيْنٌ وُجُوهٌ':Added, #6: 6	بَيْنَ الْوُجُودِ
u'بَيْنٌ وُجُوهٌ':Added, #1: 1	بَيْنَ الْوُجُوهِ
u'بَيْنٌ وَجِيهٌ':Added, #9: 9	بَيْنَ وُجُوهِ
u'بَيْنٌ وَحْشِيٌّ':Added, #1: 1	بَيْنَ الْوَجِيهِ
u'بَيْنٌ وَحْشِيٌّ':Added, #4: 4	بَيْنَ الْوَحْشِيِّ
u'بَيْنٌ وَدِيعٌ':Added, #4: 4	بَيْنَ وَحْشِيٍّ
u'بَيْنٌ وَدِيعٌ':Added, #1: 1	بَيْن الْوَدِيعَةِ
u'بَيْنٌ وَدِيعَةٌ':Added, #8: 8	بَيْنَ الْوَدِيعَةِ
u'بَيْنٌ وَدِيعَةٌ':Added, #1: 1	بَيْن الْوَدِيعَةِ
u'بَيْنٌ وَدِيعَةٌ':Added, #2: 2	بَيْنَ وَدِيعَةٍ
u'بَيْنٌ وَرَثَةٌ':Added, #8: 8	بَيْنَ الْوَدِيعَةِ
u'بَيْنٌ وَرَثَةٌ':Added, #14: 14	بَيْنَ وَرَثَةِ
u'بَيْنٌ وَرَثَةٌ':Added, #16: 16	بَيْنَ وَرَثَةٍ
u'بَيْنٌ وَرَثَةٌ':Added, #56: 56	بَيْنَ وَرَثَتِهِ
u'بَيْنٌ وَرْدٌ':Added, #57: 57	بَيْنَ الْوَرَثَةِ
u'بَيْنٌ وَرَعٌ':Added, #1: 1	بَيْنَ الْوَرْدِ
u'بَيْنٌ ورق':Added, #1: 1	بَيْنَ الْوَرَعِ
u'بَيْنٌ وَرَقٌ':Added, #1: 1	بَيْنَ وَرَقِهِ
u'بَيْنٌ ورك':Added, #1: 1	بَيْنَ وَرَقِهِ
u'بَيْنٌ وَرِكٌ':Added, #1: 1	بَيْنَ الْوَرِكِ
u'بَيْنٌ وُرُودٌ':Added, #1: 1	بَيْنَ الْوَرِكِ
u'بَيَّنَ وَزْنٌ':Predicate, #1: 1	بَيْنَ وُرُودِ
u'بَيَّنَ وَزْنٌ':Predicate, #1: 1	بَيَّنَ الْوَزْنَ
u'بَيْنٌ وَزْنٌ':Added, #3: 3	بَيَّنَ وَزْنَ
u'بَيْنٌ وسط':Added, #12: 12	بَيْنَ الْوَزْنَيْنِ
u'بَيْنٌ وَسَطٌ':Added, #1: 1	بَيْنَ الْوَسَطِ
u'بَيْنٌ وَسْوَسَةٌ':Added, #1: 1	بَيْنَ الْوَسَطِ
u'بَيْنٌ وَشَائِجُ':Added, #1: 1	بَيْنَ الْوَسْوَسَةِ
u'بَيْنٌ وَصْفٌ':Added, #1: 1	بَيْنَ وَشَائِجِ
u'بَيْنٌ وَصْفٌ':Added, #1: 1	بَيْنَ وَصْفِ
u'بَيْنٌ وَصْفٌ':Added, #3: 3	بَيْنَ الْوَصْفِ
u'بَيْنٌ وَصِيٌّ':Added, #6: 6	بَيْنَ الْوَصْفَيْنِ
u'بَيْنٌ وَصِيٌّ':Added, #10: 10	بَيْنَ الْوَصِيِّ
u'بَيْنٌ وَصِيٌّ':Added, #17: 17	بَيْنَ الْوَصِيَّةِ
u'بَيْنٌ وَصِيٌّ':Added, #1: 1	بَيْنَ وَصِيَّةِ
u'بَيْنٌ وَصِيٌّ':Added, #1: 1	بَيْنَ وَصِيَّتِهِ
u'بَيْنٌ وَصِيٌّ':Added, #2: 2	بَيْنَ الْوَصِيَّيْنِ
u'بَيْنٌ وَصِيَّةٌ':Added, #5: 5	بَيْنَ الْوَصِيَّتَيْنِ
u'بَيْنٌ وَصِيَّةٌ':Added, #17: 17	بَيْنَ الْوَصِيَّةِ
u'بَيْنٌ وَصِيَّةٌ':Added, #1: 1	بَيْنَ وَصِيَّةِ
u'بَيْنٌ وَضْعٌ':Added, #1: 1	بَيْنَ وَصِيَّتِهِ
u'بَيْنٌ وَضْعٌ':Added, #1: 1	بَيْنَ الْوَضْعَيْنِ
u'بَيْنٌ وُضُوءٌ':Added, #3: 3	بَيْنَ وَضْعِ
u'بَيْنٌ وُضُوء':Added, #11: 11	بَيْنَ الْوُضُوءِ
u'بَيْنٌ وَطْءٌ':Added, #1: 1	بَيْنَ الْوُضُوءَيْنِ
u'بَيْنٌ وَطَنٌ':Added, #4: 4	بَيْنَ الْوَطْءِ
u'بَيْنٌ وَطَنٌ':Added, #1: 1	بَيْنَ الْوَطَنِ
u'بَيْنٌ وَطَنٌ':Added, #1: 1	بَيْنَ الْوَطَنَيْنِ
u'بَيْنٌ وَظَائِفُ':Added, #1: 1	بَيْنَ وَطَنِ
u'بَيْنٌ وَفَاءٌ':Added, #1: 1	بَيْنَ الْوَظَائِفِ
u'بَيْنٌ وفاة':Added, #5: 5	بَيْنَ الْوَفَاءِ
u'بَيْنٌ وَفَاةٌ':Added, #2: 2	بَيْنَ الْوَفَاةِ
u'بَيَّنَ وَقْتٌ':Predicate, #2: 2	بَيْنَ الْوَفَاةِ
u'بَيَّنَ وَقْتٌ':Predicate, #1: 1	بَيَّنَ الْوَقْتَ
u'بَيْنٌ وَقْتٌ':Added, #5: 5	بَيَّنَ وَقْتَ
u'بَيْنٌ وَقْت':Added, #10: 10	بَيْنَ الْوَقْتِ
u'بَيْنٌ وَقْتٌ':Added, #1: 1	بَيْنَ الْوَقْتِيَّةِ
u'بَيْنٌ وَقْتٌ':Added, #3: 3	بَيْنَ وَقْتِ
u'بَيْنٌ وَقْتِيّ':Added, #9: 9	بَيْنَ الْوَقْتَيْنِ
u'بَيْنٌ وَقْفٌ':Added, #1: 1	بَيْنَ الْوَقْتِيَّةِ
u'بَيْنٌ وَقْفٌ':Added, #11: 11	بَيْنَ الْوَقْفِ
u'بَيْنٌ وَقْفٌ':Added, #1: 1	بَيْنَ الْوَقْفَتَيْنِ
u'بَيْنٌ وَقْفٌ':Added, #1: 1	بَيْنَ وَقْفِ
u'بَيْنٌ وَقْفٌ':Added, #1: 1	بَيْنَ وَقْفَيْنِ
u'بَيْنٌ وَقْفٌ':Added, #2: 2	بَيْن الْوَقْفِ
u'بَيْنٌ وُقُوعٌ':Added, #3: 3	بَيْنَ وَقْفٍ
u'بَيْنٌ وُقُوعٌ':Added, #1: 1	بَيْنَ الْوُقُوعِ
u'بَيْنٌ وُقُوعٌ':Added, #3: 3	بَيْنَ وُقُوعِ
u'بَيْنٌ وُقُوفٌ':Added, #4: 4	بَيْنَ وُقُوعِهِ
u'بَيَّنَ وَكِيلٌ':Subject, #2: 2	بَيْنَ الْوُقُوفِ
u'بَيْنٌ وَكِيلٌ':Added, #2: 2	بَيَّنَ الْوَكِيلُ
u'بَيْنٌ وَكِيلٌ':Added, #14: 14	بَيْنَ الْوَكِيلِ
u'بَيْنٌ وَكِيلٌ':Added, #1: 1	بَيْنَ الْوَكِيلَيْنِ
u'بَيْنٌ وَلاَءٌ':Added, #3: 3	بَيْنَ وَكِيلِ
u'بَيْنٌ وِلاء':Added, #1: 1	بَيْنَ الْوَلَاءِ
u'بَيْنٌ وِلاَدَةٌ':Added, #1: 1	بَيْنَ الْوِلَاءَيْنِ
u'بَيْنٌ وِلاَدَةٌ':Added, #1: 1	بَيْنَ الْوِلَادَةِ
u'بَيْنٌ وِلاَيَةٌ':Added, #2: 2	بَيْنَ وِلَادَةِ
u'بَيْنٌ ولد':Added, #1: 1	بَيْنَ وِلَايَتِهِ
u'بَيْنٌ وَلَدٌ':Added, #10: 10	بَيْنَ الْوَلَدِ
u'بَيْنٌ وَلَدٌ':Added, #10: 10	بَيْنَ الْوَلَدِ
u'بَيْنٌ ولد':Added, #15: 15	بَيْنَ الْوَلَدَيْنِ
u'بَيْنٌ وَلَدٌ':Added, #1: 1	بَيْن الْوَلَدِ
u'بَيْنٌ ولد':Added, #1: 1	بَيْن الْوَلَدِ
u'بَيْنٌ وَلَدٌ':Added, #4: 4	بَيْنَ وَلَدِهِ
u'بَيْنٌ ولد':Added, #4: 4	بَيْنَ وَلَدِهِ
u'بَيْنٌ وَلَدٌ':Added, #5: 5	بَيْنَ وَلَدِ
u'بَيْنٌ وُلُوغ':Added, #5: 5	بَيْنَ وَلَدِ
u'بَيْنٌ وُلُوغ':Added, #1: 1	بَيْنَ الْوُلُوغِ
u'بَيَّنَ وَلِيٌّ':Subject, #1: 1	بَيْنَ وُلُوغِ
u'بَيْنٌ وَلِيٌّ':Added, #1: 1	بَيَّنَ الْوَلِيُّ
u'بَيْنٌ وَلِيٌّ':Added, #13: 13	بَيْنَ وَلِيِّ
u'بَيْنٌ يَابِسٌ':Added, #3: 3	بَيْنَ الْوَلِيِّ
u'بَيْنٌ يَدٌ':Added, #1: 1	بَيْنَ الْيَابِسِ
u'بَيْنٌ يَدٌ':Added, #2: 2	بَيْنَ الْيَدِ
u'بَيْنٌ يَدٌ':Added, #3: 3	بَيْنَ يَدِهِ
u'بَيْنٌ يَدٌ':Added, #4: 4	بَيْنَ يَدِ
u'بَيْنٌ يسار':Added, #5: 5	بَيْنَ الْيَدَيْنِ
u'بَيْنٌ يَسَارٌ':Added, #3: 3	بَيْنَ الْيَسَارِ
u'بَيْنٌ يَسِيرٌ':Added, #3: 3	بَيْنَ الْيَسَارِ
u'بَيْنٌ يَسِيرٌ':Added, #1: 1	بَيْنَ يَسِيرٍ
u'بَيْنٌ يَسِيرٌ':Added, #1: 1	بَيْنَ يَسِيرِهِ
u'بَيْنٌ يَسِيرٌ':Added, #2: 2	بَيْنَ يَسِيرِ
u'بَيْنٌ يَقِظٌ':Added, #6: 6	بَيْنَ الْيَسِيرِ
u'بَيْنٌ يَمِينٌ':Added, #1: 1	بَيْنَ يَقِظَتِهِ
u'بَيْنٌ يَمِينٌ':Added, #18: 18	بَيْنَ الْيَمِينِ
u'بَيْنٌ يَمِينٌ':Added, #1: 1	بَيْنَ يَمِينِ
u'بَيْنٌ يَمِينٌ':Added, #1: 1	بَيْنَ يَمِينَيْنِ
u'بَيْنٌ يَمِينٌ':Added, #2: 2	بَيْنَ الْيَمِينَيْنِ
u'بَيْنٌ يهود':Added, #2: 2	بَيْنَ يَمِينِهِ
u'بَيْنٌ يَهُودٌ':Added, #7: 7	بَيْنَ الْيَهُودِ
u'بَيْنٌ يَهُودِيٌّ':Added, #7: 7	بَيْنَ الْيَهُودِ
u'بَيْنٌ يَهُودِيٌّ':Added, #2: 2	بَيْنَ الْيَهُودِيِّ
u'بَيْنٌ يَوْمٌ':Added, #3: 3	بَيْنَ الْيَهُودِيَّةِ
u'بَيْنٌ يَوْمٌ':Added, #1: 1	بَيْنَ يَوْمِ
u'بَيْنٌ يَوْمٌ':Added, #2: 2	بَيْنَ يَوْمٍ
u'بَيْنٌ يَوْمٌ':Added, #3: 3	بَيْنَ الْيَوْمِ
u'بَيْنٌ يَوْمٌ':Added, #4: 4	بَيْنَ الْيَوْمَيْنِ
u'تَابَ أهْلٌ':Subject, #5: 5	بَيْنَ يَوْمَيْنِ
u'تَأَبُّدٌ تَفْرِيقٌ':Added, #1: 1	تَابَ أَهْلُ
u'تَأَبُّدٌ حُرْمَةٌ':Added, #1: 1	تَأَبُّدُ التَّفْرِيقِ
u'تَأَبُّدٌ حُرْمَةٌ':Added, #1: 1	تَأَبُّدَ الْحُرْمَةِ
u'تَأَبُّدٌ حُرْمَةٌ':Added, #1: 1	تَأَبُّدُ الْحُرْمَةِ
u'تَابَ دفع':Predicate, #1: 1	تَأَبُّدِ الْحُرْمَةِ
u'تَأَبَّدَ يَمِينٌ':Subject, #2: 2	تَابَ دُفِعَ
u'تَابَ رَدٌّ':Predicate, #1: 1	تَأَبَّدَ الْيَمِينُ
u'تَابَ زَوْجٌ':Subject, #1: 1	تَابَ رَدَّ
u'تَابَ سَاحِرٌ':Subject, #1: 1	تَابَ الزَّوْجُ
u'تَابَ سقط':Predicate, #1: 1	تَابَ السَّاحِرُ
u'تَابَ سَقَطٌ':Predicate, #2: 2	تَابَ سَقَطَ
u'تَابَ شَاهِدٌ':Subject, #2: 2	تَابَ سَقَطَ
u'تَابَعَ اِبْنٌ':Predicate, #3: 3	تَابَ شَاهِدُ
u'تَابَعَ إمَامٌ':Predicate, #4: 4	تَابَعَ ابْنَ
u'تَابَ عِبَارَةٌ':Subject, #7: 7	تَابَعَ الْإِمَامَ
u'تَابَ عَبْدٌ':Subject, #1: 1	تَابَ عِبَارَةُ
u'تَابَعَ تَأَخُّرٌ':Subject, #1: 1	تَابَ الْعَبْدُ
u'تَابَعَ جَرِيرٌ':Subject, #1: 1	تَابَعَ تَأَخُّرُهُ
u'تَابَعَ حُرٌّ':Predicate, #1: 1	تَابَعَ جَرِيرُ
u'تَابَعَ حَمَّادٌ':Predicate, #1: 1	تَابَعَ الْحُرَّ
u'تَابَعَ شمس':Predicate, #1: 1	تَابَعَ حَمَّادَ
u'تَابَعَ شَمْسٌ':Predicate, #2: 2	تَابَعَ شَمْسَ
u'تَابَعَ شَيْخٌ':Predicate, #2: 2	تَابَعَ شَمْسَ
u'تَابَعَ شَيْخٌ':Subject, #13: 13	تَابَعَ الشَّيْخَ
u'تَابَعَ صَاحِبٌ':Predicate, #1: 1	تَابَعَ الشَّيْخُ
u'تَابَعَ صَالِحٌ':Subject, #8: 8	تَابَعَ صَاحِبَ
u'تَابَعَ صَالِح':Subject, #1: 1	تَابَعَ صَالِحُ
u'تَابَعَ صَفْوَان':Predicate, #1: 1	تَابَعَ صَالِحُ
u'تَابَعَ طَعْنٌ':Predicate, #1: 1	تَابَعَ صَفْوَانَ
u'تَابَعَ عِبَارَةٌ':Predicate, #1: 1	تَابَعَ الطَّعْنَ
u'تَابَعَ عُمَرٌ':Predicate, #2: 2	تَابَعَ عِبَارَةَ
u'تَابَعَ عُمَرٌ':Subject, #1: 1	تَابَعَ عُمَرَ
u'تَابَعَ فلان':Predicate, #1: 1	تَابَعَ عُمَرُ
u'تَابَعَ فلان':Subject, #1: 1	تَابَعَ سُفْيَانَ
u'تَابَعَ قَاضِي':Predicate, #1: 1	تَابَعَ سُفْيَانُ
u'تَابَعَ مَجْدٌ':Predicate, #1: 1	تَابَعَ الْقَاضِيَ
u'تَابَعَ مُحَرَّرٌ':Predicate, #7: 7	تَابَعَ الْمَجْدَ
u'تَابَعَ مُصَنِّفٌ':Predicate, #1: 1	تَابَعَ الْمُحَرَّرَ
u'تَابَعَ مُصَنِّفٌ':Subject, #3: 3	تَابَعَ الْمُصَنِّفَ
u'تَابَعَ مُغْنِي':Predicate, #6: 6	تَابَعَ الْمُصَنِّفُ
u'تَابَعَ مُؤَذِّنٌ':Predicate, #1: 1	تَابَعَ الْمُغْنِيَ
u'تَابَعَ مُؤَلِّفٌ':Subject, #1: 1	تَابَعَ الْمُؤَذِّنَ
u'تَابَ عند':Predicate, #1: 1	تَابَعَ الْمُؤَلِّفُ
u'تَابَ غَاصِبٌ':Subject, #1: 1	تَابَ عِنْدَ
u'تَابَ غُرْمٌ':Subject, #2: 2	تَابَ الْغَاصِبُ
u'تَابَ فَاسِقٌ':Subject, #1: 1	تَابَ غُرْمٌ
u'تَابَ فَاسِقٌ':Subject, #2: 2	تَابَ فَاسِقٌ
u'تَابَ قَاذِفٌ':Subject, #4: 4	تَابَ الْفَاسِقُ
u'تَابَ قَالٌ':Predicate, #3: 3	تَابَ الْقَاذِفُ
u'تَابَ قَوْمٌ':Subject, #2: 2	تَابَ قَالَ
u'تَابَ كَلاَمٌ':Subject, #1: 1	تَابَ قَوْمٌ
u'تَابَ مُبْتَدِعٌ':Subject, #1: 1	تَابَ كَلَامٌ
u'تَابَ مُحَارِبٌ':Subject, #2: 2	تَابَ الْمُبْتَدِعُ
u'تَابَ مَحْدُودٌ':Subject, #1: 1	تَابَ الْمُحَارِبُ
u'تَابَ مُرْتَدٌّ':Subject, #2: 2	تَابَ الْمَحْدُودُ
u'تَابَ مُسْتَحِقٌّ':Subject, #6: 6	تَابَ الْمُرْتَدُّ
u'تَابَ مُؤْمِنٌ':Subject, #1: 1	تَابَ الْمُسْتَحِقُّ
u'تَابَ وثاب':Predicate, #1: 1	تَابَ الْمُؤْمِنُ
u'تَابَ وَلِيٌّ':Subject, #1: 1	تَابَ وَثَابَ
u'تَأْبِيدٌ تَحْرِيمٌ':Added, #2: 2	تَابَ الْوَلِيُّ
u'تَأْبِيدٌ تَحْرِيمٌ':Added, #1: 1	تَأْبِيدُ التَّحْرِيمِ
u'تَأْبِيدٌ تَحْرِيمٌ':Added, #1: 1	تَأْبِيدِ التَّحْرِيمِ
u'تَأْبِيدٌ حُرْمَةٌ':Added, #2: 2	تَأْبِيدَ التَّحْرِيمِ
u'تَأْبِيدٌ حُرْمَةٌ':Added, #1: 1	تَأْبِيدَ الْحُرْمَةِ
u'تَأْبِيدٌ شَرِيعَةٌ':Added, #1: 1	تَأْبِيدِ الْحُرْمَةِ
u'تَأْبِيدٌ مَسْجِدٌ':Added, #1: 1	تَأْبِيدِ شَرِيعَتِهِ
u'تَأْبِيدٌ وَاجِبٌ':Added, #1: 1	تَأْبِيدِ الْمَسْجِدِ
u'تَأَتَّى اِتِّخَاذٌ':Subject, #1: 1	تَأْبِيدَ الْوَاجِبِ
u'تَأَتَّى خِلاَفٌ':Subject, #1: 1	تَأَتَّى اتِّخَاذُ
u'تَأَتِّي خِلاَفٌ':Added, #1: 1	تَأَتَّى الْخِلَافُ
u'تَأَتِّي دفع':Added, #2: 2	تَأَتِّي الْخِلَافِ
u'تَأَتِّي دَفْعٌ':Added, #1: 1	تَأَتِّي الدَّفْعِ
u'تَأَتِّي غَسْلٌ':Added, #1: 1	تَأَتِّي الدَّفْعِ
u'تَأَتِّي قَبْضٌ':Added, #1: 1	تَأَتِّي غَسْلِهِ
u'تَأَتِّي قِيَاسٌ':Added, #1: 1	تَأَتِّي الْقَبْضِ
u'تَأَتِّي كَلاَمٌ':Added, #1: 1	تَأَتِّي الْقِيَاسِ
u'تَأَتَّى مَشْيٌ':Subject, #1: 1	تَأَتِّي كَلَامِ
u'تَأَتِّي مَضْغٌ':Added, #1: 1	تَأَتَّى الْمَشْيُ
u'تَأَتَّى نَظَرٌ':Subject, #1: 1	تَأَتِّي الْمَضْغِ
u'تَأَتَّى وَجَبٌ':Predicate, #1: 1	تَأَتَّى النَّظَرُ
u'تَأَثُّرٌ بَشَرَةٌ':Added, #1: 1	تَأَتَّى وَجَبَ
u'تَأَثَّرَ عَقْدٌ':Subject, #1: 1	تَأَثُّرَ الْبَشَرَةِ
u'تَأْثِيرٌ إجَازَةٌ':Added, #1: 1	تَأَثَّرَ الْعَقْدُ
u'تَأْثِيرٌ أَجْرَامٌ':Added, #1: 1	تَأْثِيرُ إجَازَتِهِ
u'تَأْثِيرٌ أحَدٌ':Added, #1: 1	تَأْثِيرَ الْأَجْرَامِ
u'تَأْثِيرٌ إِذْنٌ':Added, #1: 1	تَأْثِيرِ أَحَدِ
u'تَأْثِيرٌ أصل':Added, #1: 1	تَأْثِيرُ إذْنِ
u'تَأْثِيرٌ أًصْلٌ':Added, #1: 1	تَأْثِيرُ الْأَصْلِ
u'تَأْثِيرٌ إكْرَاهٌ':Added, #1: 1	تَأْثِيرُ الْأَصْلِ
u'تَأْثِيرٌ إكْرَاهٌ':Added, #1: 1	تَأْثِيرَ الْإِكْرَاهِ
u'تَأْثِيرٌ اِنْعِدَامٌ':Added, #2: 2	تَأْثِيرُ الْإِكْرَاهِ
u'تَأْثِيرٌ بَعْضٌ':Added, #1: 1	تَأْثِيرَ انْعِدَامِ
u'تَأْثِيرٌ بُلُوغٌ':Added, #1: 1	تَأْثِيرِ بَعْضِ
u'تَأْثِيرٌ تَعْدِيَة':Added, #1: 1	تَأْثِيرَ الْبُلُوغِ
u'تَأْثِيرٌ تَعْلِيقٌ':Added, #1: 1	تَأْثِيرِ التَّعْدِيَةِ
u'تَأْثِيرٌ تَوَقُّفٌ':Added, #1: 1	تَأْثِيرَ تَعْلِيقِهِ
u'تَأْثِيرٌ جَارِحٌ':Added, #1: 1	تَأْثِيرُ التَّوَقُّفِ
u'تَأْثِيرٌ جُرْحٌ':Added, #1: 1	تَأْثِيرَ الْجَارِحِ
u'تَأْثِيرٌ جِنْسٌ':Added, #2: 2	تَأْثِيرَ الْجُرْحِ
u'تَأْثِيرٌ جِنْسٌ':Added, #1: 1	تَأْثِيرِ الْجِنْسِ
u'تَأْثِيرٌ جِنْسٌ':Added, #2: 2	تَأْثِيرُ الْجِنْسِ
u'تَأْثِيرٌ جِنْسٌ':Added, #2: 2	تَأْثِيرِ جِنْسِ
u'تَأْثِيرٌ جَهالَة':Added, #2: 2	تَأْثِيرُ جِنْسِهِ
u'تَأْثِيرٌ جَوْزٌ':Added, #1: 1	تَأْثِيرِ الْجَهَالَةِ
u'تَأْثِيرٌ خَبَرٌ':Added, #1: 1	تَأْثِيرِ الْجَوْزَةِ
u'تَأْثِيرٌ خَبَرٌ':Added, #1: 1	تَأْثِيرَ خَبَرِ
u'تَأْثِيرٌ خَبَر':Added, #1: 1	تَأْثِيرِ خَبَرِ
u'تَأْثِيرٌ خَبَر':Added, #1: 1	تَأْثِيرَ خَبَرِ
u'تَأْثِيرٌ خُرُوجٌ':Added, #1: 1	تَأْثِيرِ خَبَرِ
u'تَأْثِيرٌ خلط':Added, #1: 1	تَأْثِيرِ خُرُوجِ
u'تَأْثِيرٌ دَارٌ':Added, #1: 1	تَأْثِيرِ الْخَلْطِ
u'تَأْثِيرٌ دِبَاغٌ':Added, #1: 1	تَأْثِيرَ الدَّارِ
u'تَأْثِيرٌ رِقٌّ':Added, #1: 1	تَأْثِيرَ الدِّبَاغِ
u'تَأْثِيرٌ رُكْن':Added, #1: 1	تَأْثِيرِ رِقِّ
u'تَأْثِيرٌ رُكْنِيّ':Added, #1: 1	تَأْثِيرُ الرُّكْنِيَّةِ
u'تَأْثِيرٌ رُؤْيَةٌ':Added, #1: 1	تَأْثِيرُ الرُّكْنِيَّةِ
u'تَأْثِيرٌ زِيادَةٌ':Added, #1: 1	تَأْثِيرَ رُؤْيَةِ
u'تَأْثِيرٌ شَرْطٌ':Added, #2: 2	تَأْثِيرِ الزِّيَادَةِ
u'تَأْثِيرٌ شَرْطٌ':Added, #1: 1	تَأْثِيرُ الشَّرْطِ
u'تَأْثِيرٌ شَقٌّ':Added, #2: 2	تَأْثِيرَ الشَّرْطِ
u'تَأْثِيرٌ شَكٌّ':Added, #1: 1	تَأْثِيرَ الشَّقِّ
u'تَأْثِيرٌ شمس':Added, #1: 1	تَأْثِيرِ الشَّكِّ
u'تَأْثِيرٌ شَمْسٌ':Added, #1: 1	تَأْثِيرِ الشَّمْسِ
u'تَأْثِيرٌ شمس':Added, #1: 1	تَأْثِيرِ الشَّمْسِ
u'تَأْثِيرٌ شَمْسٌ':Added, #2: 2	تَأْثِيرُ الشَّمْسِ
u'تَأْثِيرٌ صِغَرٌ':Added, #2: 2	تَأْثِيرُ الشَّمْسِ
u'تَأْثِيرٌ صَلاَةٌ':Added, #1: 1	تَأْثِيرِ الصِّغَرِ
u'تَأْثِيرٌ ظَنٌّ':Added, #1: 1	تَأْثِيرُ الصَّلَاةِ
u'تَأْثِيرٌ ظهار':Added, #1: 1	تَأْثِيرِ الظَّنِّ
u'تَأْثِيرٌ عتق':Added, #1: 1	تَأْثِيرِ الظِّهَارِ
u'تَأْثِيرٌ عتق':Added, #1: 1	تَأْثِيرُ الْعِتْقِ
u'تَأْثِيرٌ عِتْقٌ':Added, #1: 1	تَأْثِيرِ الْعِتْقِ
u'تَأْثِيرٌ عِتْقٌ':Added, #1: 1	تَأْثِيرُ الْعِتْقِ
u'تَأْثِيرٌ عِدَّةٌ':Added, #1: 1	تَأْثِيرِ الْعِتْقِ
u'تَأْثِيرٌ عرف':Added, #1: 1	تَأْثِيرَ الْعِدَّةِ
u'تَأْثِيرٌ عُرْفٌ':Added, #1: 1	تَأْثِيرِ الْعُرْفِ
u'تَأْثِيرٌ عِلَّةٌ':Added, #1: 1	تَأْثِيرِ الْعُرْفِ
u'تَأْثِيرٌ عِلَّةٌ':Added, #1: 1	تَأْثِيرُ الْعِلَّةِ
u'تَأْثِيرٌ عِلَّةٌ':Added, #2: 2	تَأْثِيرَ الْعِلَّةِ
u'تَأْثِيرٌ عِلَلٌ':Added, #2: 2	تَأْثِيرِ الْعِلَّةِ
u'تَأْثِيرٌ عين':Added, #1: 1	تَأْثِيرَ الْعِلَلِ
u'تَأْثِيرٌ عَيْنٌ':Added, #3: 3	تَأْثِيرُ عَيْنِهِ
u'تَأْثِيرٌ عَيْن':Added, #3: 3	تَأْثِيرُ عَيْنِهِ
u'تَأْثِيرٌ عين':Added, #3: 3	تَأْثِيرُ عَيْنِهِ
u'تَأْثِيرٌ عَيْنٌ':Added, #6: 6	تَأْثِيرِ الْعَيْنِ
u'تَأْثِيرٌ عَيْن':Added, #6: 6	تَأْثِيرِ الْعَيْنِ
u'تَأْثِيرٌ غير':Added, #6: 6	تَأْثِيرِ الْعَيْنِ
u'تَأْثِيرٌ غَيْرٌ':Added, #1: 1	تَأْثِيرِ غَيْرِ
u'تَأْثِيرٌ فَارِقٌ':Added, #1: 1	تَأْثِيرِ غَيْرِ
u'تَأْثِيرٌ فرق':Added, #2: 2	تَأْثِيرِ الْفَارِقِ
u'تَأْثِيرٌ فَرْقٌ':Added, #1: 1	تَأْثِيرِ فَرْقِهِ
u'تَأْثِيرٌ فساد':Added, #1: 1	تَأْثِيرِ فَرْقِهِ
u'تَأْثِيرٌ فَسَادٌ':Added, #1: 1	تَأْثِيرَ الْفَسَادِ
u'تَأْثِيرٌ فلان':Added, #1: 1	تَأْثِيرَ الْفَسَادِ
u'تَأْثِيرٌ قَوَاطِعُ':Added, #1: 1	تَأْثِيرُ الرُّكْنِيَّةِ
u'تَأْثِيرٌ قِيَاسٌ':Added, #1: 1	تَأْثِيرِ الْقَوَاطِعِ
u'تَأْثِيرٌ قَيْدٌ':Added, #1: 1	تَأْثِيرِ قِيَاسِهِ
u'تَأْثِيرٌ قِيمَةٌ':Added, #2: 2	تَأْثِيرِ قَيْدٍ
u'تَأْثِيرٌ كَلاَمٌ':Added, #1: 1	تَأْثِيرَ الْقِيمَةِ
u'تَأْثِيرٌ كَوَاكِبُ':Added, #1: 1	تَأْثِيرُ كَلَامِ
u'تَأْثِيرٌ كَوْنٌ':Added, #2: 2	تَأْثِيرِ الْكَوَاكِبِ
u'تَأْثِيرٌ كَيْلٌ':Added, #1: 1	تَأْثِيرُ كَوْنِ
u'تَأْثِيرٌ مَاءٌ':Added, #1: 1	تَأْثِيرُ الْكَيْلِ
u'تَأْثِيرٌ مثل':Added, #1: 1	تَأْثِيرِ الْمَاءِ
u'تَأْثِيرٌ مِثْلٌ':Added, #1: 1	تَأْثِيرِ الْمِثْلِ
u'تَأْثِيرٌ مُحْتَسِبٌ':Added, #1: 1	تَأْثِيرِ الْمِثْلِ
u'تَأْثِيرٌ مُغَايِرٌ':Added, #1: 1	تَأْثِيرُ الْمُحْتَسِبِ
u'تَأْثِيرٌ مُلاَقَاةٌ':Added, #1: 1	تَأْثِيرٍ مُغَايِرٍ
u'تَأْثِيرٌ مُنْكِرٌ':Added, #1: 1	تَأْثِيرَ مُلَاقَاةِ
u'تَأْثِيرٌ مُوَافَقَةٌ':Added, #1: 1	تَأْثِيرِ الْمُنْكِرِ
u'تَأْثِيرٌ مُؤَثِّرٌ':Added, #1: 1	تَأْثِيرِ مُوَافَقَةِ
u'تَأْثِيرٌ مُؤَثِّرٌ':Added, #1: 1	تَأْثِيرِ الْمُؤَثِّرِ
u'تَأْثِيرٌ مُؤَثِّرٌ':Added, #1: 1	تَأْثِيرِ مُؤَثِّرٍ
u'تَأْثِيرٌ نَارٌ':Added, #5: 5	تَأْثِيرُ الْمُؤَثِّرِ
u'تَأْثِيرٌ نَجَاسَةٌ':Added, #1: 1	تَأْثِيرِ النَّارِ
u'تَأْثِيرٌ نُجُومٌ':Added, #1: 1	تَأْثِيرِ نَجَاسَةٍ
u'تَأْثِيرٌ نذر':Added, #1: 1	تَأْثِيرَ النُّجُومِ
u'تَأْثِيرٌ نَذْرٌ':Added, #1: 1	تَأْثِيرِ النَّذْرِ
u'تَأْثِيرٌ نكاح':Added, #1: 1	تَأْثِيرِ النَّذْرِ
u'تَأْثِيرٌ نِكَاحٌ':Added, #1: 1	تَأْثِيرَ النِّكَاحِ
u'تَأْثِيرٌ نَوْعٌ':Added, #1: 1	تَأْثِيرَ النِّكَاحِ
u'تَأْثِيرٌ نِيَّةٌ':Added, #1: 1	تَأْثِيرُ نَوْعِهِ
u'تَأْثِيرٌ نِيَّةٌ':Added, #1: 1	تَأْثِيرَ النِّيَّةِ
u'تَأْثِيرٌ نِيَّةٌ':Added, #1: 1	تَأْثِيرُ النِّيَّةِ
u'تَأْثِيرٌ نِيَّةٌ':Added, #1: 1	تَأْثِيرَ نِيَّةِ
u'تَأْثِيرٌ نِيَّةٌ':Added, #1: 1	تَأْثِيرِ نِيَّةِ
u'تَأْثِيرٌ هَزْلٌ':Added, #2: 2	تَأْثِيرِ النِّيَّةِ
u'تَأْثِيرٌ وَصْفٌ':Added, #3: 3	تَأْثِيرِ الْهَزْلِ
u'تَأْثِيرٌ وَصْفٌ':Added, #1: 1	تَأْثِيرِ وَصْفِ
u'تَأْثِيرٌ وَصْفٌ':Added, #1: 1	تَأْثِيرَ وَصْفِهِ
u'تَأْثِيرٌ وِلاَدَةٌ':Added, #2: 2	تَأْثِيرِ الْوَصْفِ
u'تَاجَرَ عَامِلٌ':Subject, #1: 1	تَأْثِيرِ الْوِلَادَةِ
u'تَأَجَّلَ جَمِيع':Subject, #1: 1	تَاجَرَ الْعَامِلُ
u'تَأْجِيرٌ أمَةٌ':Added, #1: 1	تَأَجَّلَ الْجَمِيعُ
u'تَأْجِيرٌ نَاظِرٌ':Added, #1: 1	تَأْجِيرُ أَمَتِهِ
u'تَأْجِيلٌ إجَارَةٌ':Added, #1: 1	تَأْجِيرُ النَّاظِرِ
u'تَأْجِيلٌ أُجْرَةٌ':Added, #1: 1	تَأْجِيلَ الْإِجَارَةِ
u'تَأْجِيلٌ أعْيانٌ':Added, #3: 3	تَأْجِيلُ الْأُجْرَةِ
u'تَأْجِيلٌ أعْيانٌ':Added, #1: 1	تَأْجِيلُ الْأَعْيَانِ
u'تَأْجِيلٌ أَعْيَانٌ':Added, #1: 1	تَأْجِيلِ الْأَعْيَانِ
u'تَأْجِيلٌ أَعْيَانٌ':Added, #1: 1	تَأْجِيلُ الْأَعْيَانِ
u'تَأْجِيلٌ إِقْراضٌ':Added, #1: 1	تَأْجِيلِ الْأَعْيَانِ
u'تَأْجِيلٌ ألف':Added, #1: 1	تَأْجِيلَ الْإِقْرَاضِ
u'تَأْجِيلٌ ألْفٌ':Added, #1: 1	تَأْجِيلُ الْأَلْفِ
u'تَأْجِيلٌ أَلْفٌ':Added, #1: 1	تَأْجِيلُ الْأَلْفِ
u'تَأْجِيلٌ الْمَرْأَةُ':Added, #1: 1	تَأْجِيلُ الْأَلْفِ
u'تَأْجِيلٌ أَوَّلُ':Added, #1: 1	تَأْجِيلُ الْمَرْأَةِ
u'تَأْجِيلٌ إيقَاعٌ':Added, #1: 1	تَأْجِيلِ الْأَوَّلِ
u'تَأْجِيلٌ بَدَلٌ':Added, #1: 1	تَأْجِيلَ الْإِيقَاعِ
u'تَأْجِيلٌ بَدَلٌ':Added, #1: 1	تَأْجِيلُ بَدَلِهِ
u'تَأْجِيلٌ بَعْضٌ':Added, #2: 2	تَأْجِيلُ بَدَلِ
u'تَأْجِيلٌ ثَمَنٌ':Added, #1: 1	تَأْجِيلَ الْبَعْضِ
u'تَأْجِيلٌ ثَمَنٌ':Added, #2: 2	تَأْجِيلُ الثَّمَنِ
u'تَأْجِيلٌ ثَمَنٌ':Added, #2: 2	تَأْجِيلِ الثَّمَنِ
u'تَأْجِيلٌ ثَمَنٌ':Added, #3: 3	تَأْجِيلَ الثَّمَنِ
u'تَأْجِيلٌ خَمْسَةٌ':Added, #3: 3	تَأْجِيلُ ثَمَنِ
u'تَأْجِيلٌ دِيَةٌ':Added, #1: 1	تَأْجِيلِ خَمْسَةِ
u'تَأْجِيلٌ دِيَةٌ':Added, #1: 1	تَأْجِيلُ الدِّيَةِ
u'تَأْجِيلٌ دَيْنٌ':Added, #1: 1	تَأْجِيلِ الدِّيَةِ
u'تَأْجِيلٌ دَيْنٌ':Added, #2: 2	تَأْجِيلَ الدَّيْنِ
u'تَأْجِيلٌ دَيْنٌ':Added, #3: 3	تَأْجِيلِ الدَّيْنِ
u'تَأْجِيلٌ دُيونٌ':Added, #4: 4	تَأْجِيلُ الدَّيْنِ
u'تَأْجِيلٌ رَأْسٌ':Added, #1: 1	تَأْجِيلَ الدُّيُونِ
u'تَأْجِيلٌ شَارِعٌ':Added, #1: 1	تَأْجِيلُ رَأْسِ
u'تَأْجِيلٌ شَرِيكٌ':Added, #1: 1	تَأْجِيلِ الشَّارِعِ
u'تَأْجِيلٌ شفعة':Added, #3: 3	تَأْجِيلِ شَرِيكِهِ
u'تَأْجِيلٌ شُفْعَةٌ':Added, #1: 1	تَأْجِيلِ الشُّفْعَةِ
u'تَأْجِيلٌ طعام':Added, #1: 1	تَأْجِيلِ الشُّفْعَةِ
u'تَأْجِيلٌ طَعَامٌ':Added, #1: 1	تَأْجِيلُ الطَّعَامِ
u'تَأْجِيلٌ عارِيَّةٌ':Added, #1: 1	تَأْجِيلُ الطَّعَامِ
u'تَأْجِيلٌ عَقْدٌ':Added, #3: 3	تَأْجِيلِ الْعَارِيَّةِ
u'تَأْجِيلٌ عَمَلٌ':Added, #1: 1	تَأْجِيلُ عَقْدِ
u'تَأْجِيلٌ غير':Added, #1: 1	تَأْجِيلُ الْعَمَلِ
u'تَأْجِيلٌ غَيْرٌ':Added, #1: 1	تَأْجِيلُ غَيْرِ
u'تَأْجِيلٌ قتل':Added, #1: 1	تَأْجِيلُ غَيْرِ
u'تَأْجِيلٌ قَتْلٌ':Added, #1: 1	تَأْجِيلُ الْقَتْلِ
u'تَأْجِيلٌ قَرْضٌ':Added, #1: 1	تَأْجِيلُ الْقَتْلِ
u'تَأْجِيلٌ قَرْضٌ':Added, #1: 1	تَأْجِيلُ الْقَرْضِ
u'تَأْجِيلٌ قُرُوضٌ':Added, #8: 8	تَأْجِيلِ الْقَرْضِ
u'تَأْجِيلٌ قِيمَةٌ':Added, #1: 1	تَأْجِيلِ الْقُرُوضِ
u'تَأْجِيلٌ كِرَاءٌ':Added, #2: 2	تَأْجِيلُ الْقِيمَةِ
u'تَأْجِيلٌ كَفِيلٌ':Added, #1: 1	تَأْجِيلَ الْكِرَاءِ
u'تَأْجِيلٌ مَبِيعٌ':Added, #1: 1	تَأْجِيلُ الْكَفِيلِ
u'تَأْجِيلٌ مَبِيعٌ':Added, #1: 1	تَأْجِيلَ الْمَبِيعِ
u'تَأْجِيلٌ مثل':Added, #2: 2	تَأْجِيلِ الْمَبِيعِ
u'تَأْجِيلٌ مِثْلٌ':Added, #1: 1	تَأْجِيلِ مِثْلِهِ
u'تَأْجِيلٌ مَهْرٌ':Added, #1: 1	تَأْجِيلِ مِثْلِهِ
u'تَأْجِيلٌ مَهْرٌ':Added, #1: 1	تَأْجِيلَ الْمَهْرِ
u'تَأْجِيلٌ وُقُوعٌ':Added, #1: 1	تَأْجِيلِ مَهْرٍ
u'تَأَخُّرٌ أحَدٌ':Added, #1: 1	تَأْجِيلَ الْوُقُوعِ
u'تَأَخُّرٌ إِحْرَامٌ':Added, #2: 2	تَأَخُّرِ أَحَدِ
u'تَأَخُّرٌ إِحْرَامٌ':Added, #1: 1	تَأَخُّرُ إحْرَامِ
u'تَأَخَّرَ إِخْرَاجٌ':Subject, #1: 1	تَأَخُّرَ إحْرَامِهِ
u'تَأَخُّرٌ إِخْرَاجٌ':Added, #1: 1	تَأَخَّرَ الْإِخْرَاجُ
u'تَأَخَّرَ إِخْوَةٌ':Subject, #1: 1	تَأَخُّرَ إخْرَاجِ
u'تَأَخَّرَ أَدَاءٌ':Subject, #1: 1	تَأَخَّرَ إخْوَةٌ
u'تَأَخَّرَ إِدْرَاكٌ':Subject, #1: 1	تَأَخَّرَ الْأَدَاءُ
u'تَأَخَّرَ أَذَانٌ':Subject, #1: 1	تَأَخَّرَ إدْرَاكُ
u'تَأَخُّرٌ إِرْثٌ':Added, #1: 1	تَأَخَّرَ أَذَانُهُ
u'تَأَخَّرَ إِرْضاعٌ':Subject, #1: 1	تَأَخُّرُ الْإِرْثِ
u'تَأَخُّرٌ اِسْتيفاءٌ':Added, #1: 1	تَأَخَّرَ إرْضَاعُ
u'تَأَخَّرَ إِسْلامٌ':Subject, #1: 1	تَأَخُّرِ اسْتِيفَاءِ
u'تَأَخُّرٌ إِسْلامٌ':Added, #3: 3	تَأَخَّرَ إسْلَامُهُ
u'تَأَخُّرٌ إِسْلامٌ':Added, #1: 1	تَأَخُّرِ إسْلَامِهِ
u'تَأَخَّرَ إقامَةٌ':Subject, #1: 1	تَأَخُّرَ الْإِسْلَامِ
u'تَأَخُّرٌ إقْرَارٌ':Added, #1: 1	تَأَخَّرَ إقَامَةُ
u'تَأَخُّرٌ إقْرَارٌ':Added, #1: 1	تَأَخُّرُ الْإِقْرَارِ
u'تَأَخُّرٌ الْمَرْأَةُ':Added, #1: 1	تَأَخُّرِ الْإِقْرَارِ
u'تَأَخَّرَ إمَامٌ':Subject, #1: 1	تَأَخُّرِ الْمَرْأَةِ
u'تَأَخُّرٌ إمَامٌ':Added, #5: 5	تَأَخَّرَ الْإِمَامُ
u'تَأَخَّرَ إِنْزالٌ':Subject, #1: 1	تَأَخُّرُ الْإِمَامِ
u'تَأَخَّرَ اِنْقِطاعٌ':Subject, #1: 1	تَأَخَّرَ الْإِنْزَالُ
u'تَأَخَّرَ أَيْمَنُ':Subject, #2: 2	تَأَخَّرَ انْقِطَاعُ
u'تَأَخَّرَ أَيْمَن':Subject, #1: 1	تَأَخَّرَ الْأَيْمَنُ
u'تَأَخَّرَ بَدَلٌ':Subject, #1: 1	تَأَخَّرَ الْأَيْمَنُ
u'تَأَخَّرَ بَعْضٌ':Subject, #1: 1	تَأَخَّرَ الْبَدَلُ
u'تَأَخَّرَ بَعْضٌ':Subject, #1: 1	تَأَخَّرَ بَعْضُهُ
u'تَأَخَّرَ بِنَاءٌ':Subject, #2: 2	تَأَخَّرَ بَعْضُ
u'تَأَخَّرَ بَيَانٌ':Subject, #1: 1	تَأَخَّرَ الْبِنَاءُ
u'تَأَخُّرٌ بَيَانٌ':Added, #1: 1	تَأَخَّرَ الْبَيَانُ
u'تَأَخُّرٌ بَيَانٌ':Added, #1: 1	تَأَخُّرَ الْبَيَانِ
u'تَأَخَّرَ بَيْعٌ':Subject, #1: 1	تَأَخُّرُ بَيَانِ
u'تَأَخَّرَ تَأْثِيرٌ':Subject, #1: 1	تَأَخَّرَ بَيْعُ
u'تَأَخَّرَ تَارِيخٌ':Subject, #1: 1	تَأَخَّرَ تَأْثِيرُهُ
u'تَأَخُّرٌ تَارِيخٌ':Added, #5: 5	تَأَخَّرَ تَارِيخُ
u'تَأَخَّرَ تَدْبِيرٌ':Subject, #1: 1	تَأَخُّرِ تَارِيخِ
u'تَأَخَّرَ تَسْلِيمٌ':Subject, #2: 2	تَأَخَّرَ التَّدْبِيرُ
u'تَأَخُّرٌ تَسْلِيمٌ':Added, #1: 1	تَأَخَّرَ التَّسْلِيمُ
u'تَأَخُّرٌ تَسْلِيمٌ':Added, #1: 1	تَأَخُّرَ التَّسْلِيمِ
u'تَأَخُّرٌ تَعَدُّدٌ':Added, #1: 1	تَأَخُّرِ التَّسْلِيمِ
u'تَأَخُّرٌ تَعَلُّقٌ':Added, #1: 1	تَأَخُّرِ التَّعَدُّدِ
u'تَأَخَّرَ تَعْلِيقٌ':Subject, #1: 1	تَأَخُّرَ تَعَلُّقِهِ
u'تَأَخَّرَ تَفْوِيضٌ':Subject, #1: 1	تَأَخَّرَ التَّعْلِيقُ
u'تَأَخَّرَ تَقْويمٌ':Subject, #1: 1	تَأَخَّرَ تَفْوِيضُهُ
u'تَأَخَّرَ تَقْويمٌ':Subject, #1: 1	تَأَخَّرَ التَّقْوِيمُ
u'تَأَخَّرَ تَمَكُّنٌ':Subject, #1: 1	تَأَخَّرَ تَقْوِيمُ
u'تَأَخَّرَ تَمَلُّك':Subject, #1: 1	تَأَخَّرَ التَّمَكُّنُ
u'تَأَخَّرَ تَوْرِيث':Subject, #1: 1	تَأَخَّرَ التَّمَلُّكُ
u'تَأَخُّرٌ تَيَمُّمٌ':Added, #2: 2	تَأَخَّرَ تَوْرِيثُهُ
u'تَأَخُّرٌ ثُبُوتٌ':Added, #1: 1	تَأَخُّرِ التَّيَمُّمِ
u'تَأَخُّرٌ ثِمارٌ':Added, #1: 1	تَأَخُّرِ الثُّبُوتِ
u'تَأَخُّرٌ ثِمارٌ':Added, #1: 1	تَأَخُّرَ الثِّمَارِ
u'تَأَخَّرَ ثَمَنٌ':Subject, #1: 1	تَأَخُّرُ الثِّمَارِ
u'تَأَخُّرٌ ثَوْبٌ':Added, #1: 1	تَأَخَّرَ الثَّمَنُ
u'تَأَخَّرَ جَارِحٌ':Subject, #1: 1	تَأَخُّرُ الثَّوْبِ
u'تَأَخَّرَ جَزَاءٌ':Subject, #1: 1	تَأَخَّرَ جَارِحُهُ
u'تَأَخُّرٌ جَوَابٌ':Added, #1: 1	تَأَخَّرَ الْجَزَاءُ
u'تَأَخَّرَ جِيرَانٌ':Subject, #1: 1	تَأَخُّرِ الْجَوَابِ
u'تَأَخَّرَ حَجٌّ':Subject, #1: 1	تَأَخَّرَ الْجِيرَانُ
u'تَأَخُّرٌ حَدَثٌ':Added, #1: 1	تَأَخَّرَ الْحَجُّ
u'تَأَخُّرٌ حَرَكَةٌ':Added, #1: 1	تَأَخُّرِ الْحَدَثِ
u'تَأَخُّرٌ حُصُول':Added, #1: 1	تَأَخُّرِ الْحَرَكَةِ
u'تَأَخُّرٌ حَقٌّ':Added, #1: 1	تَأَخُّرِ حُصُولِ
u'تَأَخُّرٌ حَقٌّ':Added, #1: 1	تَأَخُّرُ حَقِّ
u'تَأَخَّرَ حُكْمٌ':Subject, #2: 2	تَأَخُّرَ حَقِّ
u'تَأَخَّرَ حُكْمٌ':Subject, #1: 1	تَأَخَّرَ حُكْمُهُ
u'تَأَخُّرٌ حُكْمٌ':Added, #2: 2	تَأَخَّرَ الْحُكْمُ
u'تَأَخُّرٌ حُكْمٌ':Added, #1: 1	تَأَخُّرُ الْحُكْمِ
u'تَأَخَّرَ حَيْضٌ':Subject, #3: 3	تَأَخُّرِ الْحُكْمِ
u'تَأَخُّرٌ حَيْضٌ':Added, #1: 1	تَأَخَّرَ الْحَيْضُ
u'تَأَخُّرٌ حَيْضَةٌ':Added, #1: 1	تَأَخُّرَ الْحَيْضِ
u'تَأَخَّرَ خاصّ':Subject, #1: 1	تَأَخُّرَ الْحَيْضَةِ
u'تَأَخَّرَ خَتْمٌ':Subject, #2: 2	تَأَخَّرَ الْخَاصُّ
u'تَأَخَّرَ خُرُوجٌ':Subject, #2: 2	تَأَخَّرَ خَتْمُهُ
u'تَأَخَّرَ خُرُوجٌ':Subject, #1: 1	تَأَخَّرَ خُرُوجُ
u'تَأَخَّرَ دَرْسٌ':Subject, #1: 1	تَأَخَّرَ خُرُوجُهُ
u'تَأَخَّرَ دفع':Subject, #1: 1	تَأَخَّرَ دَرْسُهُ
u'تَأَخَّرَ دَفْعٌ':Subject, #1: 1	تَأَخَّرَ دَفْعُ
u'تَأَخَّرَ دفن':Subject, #1: 1	تَأَخَّرَ دَفْعُ
u'تَأَخَّرَ دَفْنٌ':Subject, #1: 1	تَأَخَّرَ الدَّفْنُ
u'تَأَخَّرَ دَمٌ':Subject, #1: 1	تَأَخَّرَ الدَّفْنُ
u'تَأَخَّرَ دِينارٌ':Subject, #2: 2	تَأَخَّرَ الدَّمُ
u'تَأَخَّرَ ذكر':Subject, #2: 2	تَأَخَّرَ الدِّينَارُ
u'تَأَخَّرَ ذِكْرٌ':Subject, #1: 1	تَأَخَّرَ ذِكْرُهُ
u'تَأَخُّرٌ رُؤْيَةٌ':Added, #1: 1	تَأَخَّرَ ذِكْرُهُ
u'تَأَخَّرَ زادٌ':Predicate, #1: 1	تَأَخُّرُ الرُّؤْيَةِ
u'تَأَخُّرٌ سَبَبٌ':Added, #1: 1	تَأَخَّرَ زَادَ
u'تَأَخَّرَ سُقُوطٌ':Subject, #1: 1	تَأَخُّرِ السَّبَبِ
u'تَأَخَّرَ سلام':Subject, #1: 1	تَأَخَّرَ السُّقُوطُ
u'تَأَخَّرَ سَلاَمٌ':Subject, #1: 1	تَأَخَّرَ سَلَامُهُ
u'تَأَخَّرَ شِرَاءٌ':Subject, #1: 1	تَأَخَّرَ سَلَامُهُ
u'تَأَخُّرٌ شرب':Added, #1: 1	تَأَخَّرَ الشِّرَاءُ
u'تَأَخُّرٌ شُرْبٌ':Added, #1: 1	تَأَخُّرُ الشُّرْبِ
u'تَأَخَّرَ شَرْطٌ':Subject, #1: 1	تَأَخُّرُ الشُّرْبِ
u'تَأَخَّرَ شُرُوعٌ':Subject, #2: 2	تَأَخَّرَ الشَّرْطُ
u'تَأَخَّرَ شَهْرٌ':Subject, #1: 1	تَأَخَّرَ الشُّرُوعُ
u'تَأَخَّرَ صَفٌّ':Subject, #1: 1	تَأَخَّرَ الشَّهْرُ
u'تَأَخُّرٌ صُفُوفٌ':Added, #5: 5	تَأَخَّرَ الصَّفُّ
u'تَأَخُّرٌ طَرَفٌ':Added, #1: 1	تَأَخُّرِ الصُّفُوفِ
u'تَأَخَّرَ طَلاَقٌ':Subject, #1: 1	تَأَخُّرِ الطَّرَفَيْنِ
u'تَأَخُّرٌ طَهَارَةٌ':Added, #3: 3	تَأَخَّرَ الطَّلَاقُ
u'تَأَخَّرَ طواف':Subject, #1: 1	تَأَخُّرِ الطَّهَارَةِ
u'تَأَخَّرَ طَوَافٌ':Subject, #1: 1	تَأَخَّرَ الطَّوَافُ
u'تَأَخَّرَ عَامٌّ':Subject, #1: 1	تَأَخَّرَ الطَّوَافُ
u'تَأَخَّرَ عَامِلٌ':Subject, #1: 1	تَأَخَّرَ الْعَامُّ
u'تَأَخَّرَ عَامِلٌ':Subject, #1: 1	تَأَخَّرَ الْعَامِلُ
u'تَأَخَّرَ عَبْدٌ':Subject, #1: 1	تَأَخَّرَ عَامِلُ
u'تَأَخَّرَ عتق':Predicate, #1: 1	تَأَخَّرَ الْعَبْدُ
u'تَأَخَّرَ عِتْقٌ':Predicate, #1: 1	تَأَخَّرَ الْعِتْقَ
u'تَأَخَّرَ عتق':Subject, #1: 1	تَأَخَّرَ الْعِتْقَ
u'تَأَخَّرَ عِتْقٌ':Subject, #1: 1	تَأَخَّرَ الْعِتْقُ
u'تَأَخَّرَ عتق':Subject, #1: 1	تَأَخَّرَ الْعِتْقُ
u'تَأَخَّرَ عِتْقٌ':Subject, #1: 1	تَأَخَّرَ عِتْقُهُ
u'تَأَخُّرٌ عتق':Added, #1: 1	تَأَخَّرَ عِتْقُهُ
u'تَأَخُّرٌ عِتْقٌ':Added, #1: 1	تَأَخُّرَ الْعِتْقِ
u'تَأَخَّرَ عَطَاءٌ':Subject, #1: 1	تَأَخُّرَ الْعِتْقِ
u'تَأَخُّرٌ عِلَّةٌ':Added, #3: 3	تَأَخَّرَ الْعَطَاءُ
u'تَأَخُّرٌ عِلَّةٌ':Added, #1: 1	تَأَخُّرُ الْعِلَّةِ
u'تَأَخُّرٌ علم':Added, #2: 2	تَأَخُّرِ الْعِلَّةِ
u'تَأَخُّرٌ عِلْمٌ':Added, #1: 1	تَأَخُّرِ الْعِلْمِ
u'تَأَخَّرَ عَمَلٌ':Subject, #1: 1	تَأَخُّرِ الْعِلْمِ
u'تَأَخَّرَ عَمَلٌ':Subject, #1: 1	تَأَخَّرَ عَمَلُ
u'تَأَخُّرٌ عَوْدٌ':Added, #2: 2	تَأَخَّرَ عَمَلُهُ
u'تَأَخُّرٌ غَيْثٌ':Added, #1: 1	تَأَخُّرِ الْعَوْدِ
u'تَأَخُّرٌ غير':Added, #1: 1	تَأَخُّرِ الْغَيْثِ
u'تَأَخُّرٌ غَيْرٌ':Added, #1: 1	تَأَخُّرُ غَيْرِهِ
u'تَأَخَّرَ فراغ':Subject, #1: 1	تَأَخُّرُ غَيْرِهِ
u'تَأَخَّرَ فَرَاغٌ':Subject, #1: 1	تَأَخَّرَ فَرَاغُ
u'تَأَخَّرَ فِعْلٌ':Subject, #1: 1	تَأَخَّرَ فَرَاغُ
u'تَأَخَّرَ فَلًا':Predicate, #1: 1	تَأَخَّرَ فِعْلُهُ
u'تَأَخَّرَ قَالٌ':Predicate, #4: 4	تَأَخَّرَ فَلاَ
u'تَأَخَّرَ قَبْضٌ':Subject, #2: 2	تَأَخَّرَ قَالَ
u'تَأَخَّرَ قَبْضٌ':Subject, #1: 1	تَأَخَّرَ قَبْضُهُ
u'تَأَخَّرَ قَبْضٌ':Subject, #2: 2	تَأَخَّرَ الْقَبْضُ
u'تَأَخَّرَ قَبُولٌ':Subject, #3: 3	تَأَخَّرَ قَبْضُ
u'تَأَخَّرَ قَبُولٌ':Subject, #1: 1	تَأَخَّرَ قَبُولُهُ
u'تَأَخَّرَ قُدُومٌ':Subject, #3: 3	تَأَخَّرَ الْقَبُولُ
u'تَأَخَّرَ قذف':Subject, #1: 1	تَأَخَّرَ قُدُومُهُ
u'تَأَخَّرَ قَذْفٌ':Subject, #1: 1	تَأَخَّرَ الْقَذْفُ
u'تَأَخَّرَ قول':Subject, #1: 1	تَأَخَّرَ الْقَذْفُ
u'تَأَخَّرَ قَوْلٌ':Subject, #2: 2	تَأَخَّرَ الْقَوْلُ
u'تَأَخُّرٌ قول':Added, #2: 2	تَأَخَّرَ الْقَوْلُ
u'تَأَخُّرٌ قَوْلٌ':Added, #1: 1	تَأَخُّرِ الْقَوْلِ
u'تَأَخُّرٌ قَوِيٌّ':Added, #1: 1	تَأَخُّرِ الْقَوْلِ
u'تَأَخَّرَ لُزُومٌ':Subject, #1: 1	تَأَخُّرُ الْقَوِيِّ
u'تَأَخَّرَ لَفْظٌ':Subject, #1: 1	تَأَخَّرَ لُزُومُهُ
u'تَأَخَّرَ مُتَقَدِّمٌ':Subject, #1: 1	تَأَخَّرَ لَفْظُ
u'تَأَخُّرٌ مَشِيئَةٌ':Added, #2: 2	تَأَخَّرَ الْمُتَقَدِّمُ
u'تَأَخُّرٌ مُطَالَبٌ':Added, #1: 1	تَأَخُّرَ الْمَشِيئَةِ
u'تَأَخُّرٌ مُطَالَبَةٌ':Added, #1: 1	تَأَخُّرُ الْمُطَالَبَةِ
u'تَأَخَّرَ مُطْلَقٌ':Subject, #1: 1	تَأَخُّرُ الْمُطَالَبَةِ
u'تَأَخُّرٌ مَقْطُوعٌ':Added, #1: 1	تَأَخَّرَ الْمُطْلَقُ
u'تَأَخَّرَ مُقَيَّدٌ':Subject, #1: 1	تَأَخُّرُ الْمَقْطُوعِ
u'تَأَخَّرَ مِلْكٌ':Subject, #2: 2	تَأَخَّرَ الْمُقَيَّدُ
u'تَأَخُّرٌ مِلْكٌ':Added, #2: 2	تَأَخَّرَ الْمِلْكُ
u'تَأَخُّرٌ مِلْكٌ':Added, #1: 1	تَأَخُّرَ مِلْكِ
u'تَأَخُّرٌ مُوَافِقٌ':Added, #4: 4	تَأَخُّرُ الْمِلْكِ
u'تَأَخَّرَ مَوْتٌ':Subject, #1: 1	تَأَخُّرَ الْمُوَافِقِ
u'تَأَخَّرَ مَوْتٌ':Subject, #1: 1	تَأَخَّرَ الْمَوْتُ
u'تَأَخَّرَ مَوْتٌ':Subject, #1: 1	تَأَخَّرَ مَوْتٌ
u'تَأَخَّرَ مَوْتٌ':Subject, #2: 2	تَأَخَّرَ مَوْتُ
u'تَأَخُّرٌ مَوْتٌ':Added, #3: 3	تَأَخَّرَ مَوْتُهُ
u'تَأَخُّرٌ مَوْتٌ':Added, #1: 1	تَأَخُّرُ مَوْتِهِ
u'تَأَخُّرٌ نَاسِخٌ':Added, #1: 1	تَأَخُّرِ مَوْتِهِ
u'تَأَخُّرٌ نَاسِخ':Added, #1: 1	تَأَخُّرِ النَّاسِخِ
u'تَأَخَّرَ نَجْمٌ':Subject, #1: 1	تَأَخُّرِ النَّاسِخِ
u'تَأَخُّرٌ نُزُولٌ':Added, #1: 1	تَأَخَّرَ نَجْمُهُ
u'تَأَخُّرٌ نَصٌّ':Added, #1: 1	تَأَخُّرُ النُّزُولِ
u'تَأَخَّرَ نَصِيبٌ':Subject, #1: 1	تَأَخُّرُ النَّصِّ
u'تَأَخَّرَ هِلاَلٌ':Subject, #1: 1	تَأَخَّرَ نَصِيبُ
u'تَأَخَّرَ واحد':Subject, #2: 2	تَأَخَّرَ الْهِلَالُ
u'تَأَخَّرَ وَاحِدٌ':Subject, #1: 1	تَأَخَّرَ وَاحِدٌ
u'تَأَخَّرَ وُجُوبٌ':Subject, #1: 1	تَأَخَّرَ وَاحِدٌ
u'تَأَخَّرَ وُجُوبٌ':Subject, #1: 1	تَأَخَّرَ وُجُوبُهُ
u'تَأَخُّرٌ وُجُوبٌ':Added, #3: 3	تَأَخَّرَ وُجُوبُ
u'تَأَخَّرَ وُجُودٌ':Subject, #1: 1	تَأَخُّرَ الْوُجُوبِ
u'تَأَخُّرٌ وُرُودٌ':Added, #1: 1	تَأَخَّرَ وُجُودُ
u'تَأَخَّرَ وزان':Subject, #1: 1	تَأَخُّرَ وُرُودِ
u'تَأَخُّرٌ وَصِيٌّ':Added, #1: 1	تَأَخَّرَ وِزَانُهُ
u'تَأَخُّرٌ وَصِيَّةٌ':Added, #1: 1	تَأَخُّرِ الْوَصِيَّةِ
u'تَأَخَّرَ وُقُوعٌ':Subject, #1: 1	تَأَخُّرِ الْوَصِيَّةِ
u'تَأَخُّرٌ وُقُوعٌ':Added, #2: 2	تَأَخَّرَ الْوُقُوعُ
u'تَأَخَّرَ يَمِينٌ':Subject, #1: 1	تَأَخُّرِ الْوُقُوعِ
u'تَاخَمَ جَزِيرَةٌ':Predicate, #1: 1	تَأَخَّرَ الْيَمِينُ
u'تَأْخِيرٌ اِبْنٌ':Added, #1: 1	تَاخَمَ جَزِيرَةَ
u'تَأْخِيرٌ إِبْهَامٌ':Added, #1: 1	تَأْخِيرَ ابْنِ
u'تَأْخِيرٌ إِبْهَامٌ':Added, #1: 1	تَأْخِيرُ إبْهَامِ
u'تَأْخِيرٌ إِتْيانٌ':Added, #1: 1	تَأْخِيرِ إبْهَامِ
u'تَأْخِيرٌ إجَارَةٌ':Added, #1: 1	تَأْخِيرُ إتْيَانِهِ
u'تَأْخِيرٌ أُجْرَةٌ':Added, #1: 1	تَأْخِيرُ الْإِجَارَةِ
u'تَأْخِيرٌ أُجْرَةٌ':Added, #1: 1	تَأْخِيرُ أُجْرَةِ
u'تَأْخِيرٌ إِحْرَامٌ':Added, #1: 1	تَأْخِيرِ الْأُجْرَةِ
u'تَأْخِيرٌ إِحْرَامٌ':Added, #1: 1	تَأْخِيرُ إحْرَامِ
u'تَأْخِيرٌ إِحْرَامٌ':Added, #1: 1	تَأْخِيرُ إحْرَامِهِ
u'تَأْخِيرٌ إِحْرَامٌ':Added, #5: 5	تَأْخِيرِ الْإِحْرَامِ
u'تَأْخِيرٌ أحْمَالٌ':Added, #6: 6	تَأْخِيرُ الْإِحْرَامِ
u'تَأْخِيرٌ أَحْمَالٌ':Added, #1: 1	تَأْخِيرِ الأَحْمَالِ
u'تَأْخِيرٌ اِخْتِلاَفٌ':Added, #1: 1	تَأْخِيرِ الأَحْمَالِ
u'تَأْخِيرٌ أخْذٌ':Added, #1: 1	تَأْخِيرُ اخْتِلَافِ
u'تَأْخِيرٌ أخْذٌ':Added, #1: 1	تَأْخِيرِ الْأَخْذِ
u'تَأْخِيرٌ أَدَاءٌ':Added, #2: 2	تَأْخِيرُ الْأَخْذِ
u'تَأْخِيرٌ أَدَاءٌ':Added, #1: 1	تَأْخِيرُ الْأَدَاءِ
u'تَأْخِيرٌ أَدَاءٌ':Added, #2: 2	تَأْخِيرَ الْأَدَاءِ
u'تَأْخِيرٌ إِرْسَالٌ':Added, #3: 3	تَأْخِيرِ الْأَدَاءِ
u'تَأْخِيرٌ أَرْكانٌ':Added, #1: 1	تَأْخِيرُ الْإِرْسَالِ
u'تَأْخِيرٌ أَرْكَانٌ':Added, #2: 2	تَأْخِيرِ الْأَرْكَانِ
u'تَأْخِيرٌ أسْبَابٌ':Added, #2: 2	تَأْخِيرِ الْأَرْكَانِ
u'تَأْخِيرٌ أَسْبَابٌ':Added, #1: 1	تَأْخِيرِ أَسْبَابِ
u'تَأْخِيرٌ اِسْتيفاءٌ':Added, #1: 1	تَأْخِيرِ أَسْبَابِ
u'تَأْخِيرٌ إِسْلامٌ':Added, #3: 3	تَأْخِيرِ اسْتِيفَاءِ
u'تَأْخِيرٌ إِسْلامٌ':Added, #1: 1	تَأْخِيرُ إسْلَامٍ
u'تَأْخِيرٌ إِسْلامٌ':Added, #1: 1	تَأْخِيرَ إسْلَامِهِ
u'تَأْخِيرٌ إِسْماعٌ':Added, #1: 1	تَأْخِيرِ الْإِسْلَامِ
u'تَأْخِيرٌ أصل':Added, #2: 2	تَأْخِيرِ إسْمَاعِ
u'تَأْخِيرٌ أًصْلٌ':Added, #1: 1	تَأْخِيرِ الْأَصْلِ
u'تَأْخِيرٌ أصل':Added, #1: 1	تَأْخِيرِ الْأَصْلِ
u'تَأْخِيرٌ أًصْلٌ':Added, #3: 3	تَأْخِيرُ أَصْلِ
u'تَأْخِيرٌ إِصْلاحٌ':Added, #3: 3	تَأْخِيرُ أَصْلِ
u'تَأْخِيرٌ إِفَاضَةٌ':Added, #2: 2	تَأْخِيرِ إصْلَاحِ
u'تَأْخِيرٌ إِفْطارٌ':Added, #1: 1	تَأْخِيرِ الْإِفَاضَةِ
u'تَأْخِيرٌ إقْرَارٌ':Added, #3: 3	تَأْخِيرِ الْإِفْطَارِ
u'تَأْخِيرٌ أقَلُّ':Added, #2: 2	تَأْخِيرِ الْإِقْرَارِ
u'تَأْخِيرٌ أَكْثَرُ':Added, #4: 4	تَأْخِيرِ الْأَقَلِّ
u'تَأْخِيرٌ أَكْثَرُ':Added, #1: 1	تَأْخِيرَ أَكْثَرِ
u'تَأْخِيرٌ أكل':Added, #1: 1	تَأْخِيرِ أَكْثَرِهِ
u'تَأْخِيرٌ أَكْلٌ':Added, #2: 2	تَأْخِيرَ الْأَكْلِ
u'تَأْخِيرٌ الْمَرْأَةُ':Added, #2: 2	تَأْخِيرَ الْأَكْلِ
u'تَأْخِيرٌ أُمٌّ':Added, #1: 1	تَأْخِيرَ الْمَرْأَةِ
u'تَأْخِيرٌ إمَامَةٌ':Added, #1: 1	تَأْخِيرُ أُمِّ
u'تَأْخِيرٌ أمراء':Added, #1: 1	تَأْخِيرِ الْإِمَامَةِ
u'تَأْخِيرٌ إِنْكارٌ':Added, #2: 2	تَأْخِيرِ الْأُمَرَاءِ
u'تَأْخِيرٌ أهْلٌ':Added, #1: 1	تَأْخِيرَ الْإِنْكَارِ
u'تَأْخِيرٌ أئِمَّةٌ':Added, #1: 1	تَأْخِيرَ أَهْلِ
u'تَأْخِيرٌ إيقَاعٌ':Added, #1: 1	تَأْخِيرِ الْأَئِمَّةِ
u'تَأْخِيرٌ بَابٌ':Added, #1: 1	تَأْخِيرَ الْإِيقَاعِ
u'تَأْخِيرٌ بَابٌ':Added, #1: 1	تَأْخِيرِ بَابِ
u'تَأْخِيرٌ بَعْضٌ':Added, #2: 2	تَأْخِيرُ بَابِ
u'تَأْخِيرٌ بَعْضٌ':Added, #1: 1	تَأْخِيرَ الْبَعْضِ
u'تَأْخِيرٌ بَعْضٌ':Added, #1: 1	تَأْخِيرَ بَعْضِ
u'تَأْخِيرٌ بَيَانٌ':Added, #5: 5	تَأْخِيرِ بَعْضِ
u'تَأْخِيرٌ بَيَانٌ':Added, #10: 10	تَأْخِيرَ الْبَيَانِ
u'تَأْخِيرٌ بَيَانٌ':Added, #15: 15	تَأْخِيرُ الْبَيَانِ
u'تَأْخِيرٌ بَيَانٌ':Added, #1: 1	تَأْخِيرِ بَيَانِهِ
u'تَأْخِيرٌ بَيَانٌ':Added, #29: 29	تَأْخِيرِ الْبَيَانِ
u'تَأْخِيرٌ بَيَانٌ':Added, #2: 2	تَأْخِيرَ بَيَانِهِ
u'تَأْخِيرٌ بَيَانٌ':Added, #3: 3	تَأْخِيرُ بَيَانِ
u'تَأْخِيرٌ بَيَانٌ':Added, #4: 4	تَأْخِيرَ بَيَانِ
u'تَأْخِيرٌ بَيْعٌ':Added, #7: 7	تَأْخِيرِ بَيَانِ
u'تَأْخِيرٌ بَيْعٌ':Added, #1: 1	تَأْخِيرِ الْبَيْعِ
u'تَأْخِيرٌ بَيِّنَةٌ':Added, #1: 1	تَأْخِيرِ بَيْعِهِ
u'تَأْخِيرٌ تَبْلِيغٌ':Added, #1: 1	تَأْخِيرِ الْبَيِّنَةِ
u'تَأْخِيرٌ تَبْلِيغٌ':Added, #1: 1	تَأْخِيرِ التَّبْلِيغِ
u'تَأْخِيرٌ تَبْلِيغٌ':Added, #1: 1	تَأْخِيرُ تَبْلِيغِ
u'تَأْخِيرٌ تَجْهِيزٌ':Added, #1: 1	تَأْخِيرِ تَبْلِيغِهِ
u'تَأْخِيرٌ تَحْرِيم':Added, #1: 1	تَأْخِيرُ تَجْهِيزِ
u'تَأْخِيرٌ تَحَلُّلٌ':Added, #1: 1	تَأْخِيرُ التَّحْرِيمَةِ
u'تَأْخِيرٌ تَحَلُّلٌ':Added, #1: 1	تَأْخِيرُ التَّحَلُّلِ
u'تَأْخِيرٌ تَخْصِيصٌ':Added, #1: 1	تَأْخِيرِ التَّحَلُّلِ
u'تَأْخِيرٌ تَرَاوِيحُ':Added, #1: 1	تَأْخِيرِ التَّخْصِيصِ
u'تَأْخِيرٌ تَسْلِيمٌ':Added, #2: 2	تَأْخِيرُ التَّرَاوِيحِ
u'تَأْخِيرٌ تَسْلِيمٌ':Added, #1: 1	تَأْخِيرُ التَّسْلِيمِ
u'تَأْخِيرٌ تَسْلِيمٌ':Added, #2: 2	تَأْخِيرَ التَّسْلِيمِ
u'تَأْخِيرٌ تَسْلِيمٌ':Added, #2: 2	تَأْخِيرَ تَسْلِيمِهِ
u'تَأْخِيرٌ تَشْدِيدٌ':Added, #3: 3	تَأْخِيرِ التَّسْلِيمِ
u'تَأْخِيرٌ تَضْحِيَةٌ':Added, #2: 2	تَأْخِيرِ التَّشْدِيدِ
u'تَأْخِيرٌ تَعْلِيقٌ':Added, #1: 1	تَأْخِيرُ التَّضْحِيَةِ
u'تَأْخِيرٌ تَعَوُّذٌ':Added, #1: 1	تَأْخِيرِ التَّعْلِيقِ
u'تَأْخِيرٌ تَغْرِيبٌ':Added, #1: 1	تَأْخِيرُ التَّعَوُّذِ
u'تَأْخِيرٌ تَفْرِقَة':Added, #1: 1	تَأْخِيرِ التَّغْرِيبِ
u'تَأْخِيرٌ تَكْبيرٌ':Added, #1: 1	تَأْخِيرِ التَّفْرِقَةِ
u'تَأْخِيرٌ تَوْبَةٌ':Added, #1: 1	تَأْخِيرِ تَكْبِيرِ
u'تَأْخِيرٌ تَيَمُّمٌ':Added, #1: 1	تَأْخِيرِ التَّوْبَةِ
u'تَأْخِيرٌ ثَانِي':Added, #2: 2	تَأْخِيرُ التَّيَمُّمِ
u'تَأْخِيرٌ ثَانِي':Added, #1: 1	تَأْخِيرُ الثَّانِيَةِ
u'تَأْخِيرٌ ثَانِيَةٌ':Added, #1: 1	تَأْخِيرِ الثَّانِيَةِ
u'تَأْخِيرٌ ثَانِيَةٌ':Added, #1: 1	تَأْخِيرُ الثَّانِيَةِ
u'تَأْخِيرٌ ثَلاثَةٌ':Added, #1: 1	تَأْخِيرِ الثَّانِيَةِ
u'تَأْخِيرٌ جلد':Added, #1: 1	تَأْخِيرِ الثَّلَاثَةِ
u'تَأْخِيرٌ جَلْدٌ':Added, #1: 1	تَأْخِيرُ الْجَلْدِ
u'تَأْخِيرٌ جماع':Added, #1: 1	تَأْخِيرُ الْجَلْدِ
u'تَأْخِيرٌ جِمَاعٌ':Added, #1: 1	تَأْخِيرُ الْجِمَاعِ
u'تَأْخِيرٌ جهاد':Added, #1: 1	تَأْخِيرُ الْجِمَاعِ
u'تَأْخِيرٌ جِهَادٌ':Added, #2: 2	تَأْخِيرُ الْجِهَادِ
u'تَأْخِيرٌ جَوَابٌ':Added, #2: 2	تَأْخِيرُ الْجِهَادِ
u'تَأْخِيرٌ حاجَةٌ':Added, #1: 1	تَأْخِيرُ الْجَوَابِ
u'تَأْخِيرٌ حامِلٌ':Added, #1: 1	تَأْخِيرِ الْحَاجَةِ
u'تَأْخِيرٌ حَجٌّ':Added, #1: 1	تَأْخِيرُ الْحَامِلِ
u'تَأْخِيرٌ حَجٌّ':Added, #1: 1	تَأْخِيرُ الْحَجِّ
u'تَأْخِيرٌ حَجٌّ':Added, #2: 2	تَأْخِيرَ الْحَجِّ
u'تَأْخِيرٌ حَدٌّ':Added, #4: 4	تَأْخِيرِ الْحَجِّ
u'تَأْخِيرٌ حَدٌّ':Added, #1: 1	تَأْخِيرَ الْحَدِّ
u'تَأْخِيرٌ حَدٌّ':Added, #1: 1	تَأْخِيرُ الْحَدِّ
u'تَأْخِيرٌ حَدٌّ':Added, #1: 1	تَأْخِيرِ الْحَدِّ
u'تَأْخِيرٌ حَديثٌ':Added, #1: 1	تَأْخِيرَ حَدِّ
u'تَأْخِيرٌ حِراثَةٌ':Added, #1: 1	تَأْخِيرِ الْحَدِيثِ
u'تَأْخِيرٌ حَصَاةٌ':Added, #1: 1	تَأْخِيرَ الْحِرَاثَةِ
u'تَأْخِيرٌ حَصَادٌ':Added, #1: 1	تَأْخِيرُ حَصَاةِ
u'تَأْخِيرٌ حُضورٌ':Added, #1: 1	تَأْخِيرَ الْحَصَادِ
u'تَأْخِيرٌ حُضُورٌ':Added, #2: 2	تَأْخِيرُ الْحُضُورِ
u'تَأْخِيرٌ حَقٌّ':Added, #2: 2	تَأْخِيرُ الْحُضُورِ
u'تَأْخِيرٌ حَقٌّ':Added, #1: 1	تَأْخِيرِ الْحَقِّ
u'تَأْخِيرٌ حَقٌّ':Added, #1: 1	تَأْخِيرُ حَقِّ
u'تَأْخِيرٌ حَقٌّ':Added, #1: 1	تَأْخِيرِ حَقِّهِ
u'تَأْخِيرٌ حَقٌّ':Added, #2: 2	تَأْخِيرَ حَقِّ
u'تَأْخِيرٌ حَقٌّ':Added, #2: 2	تَأْخِيرِ حَقِّ
u'تَأْخِيرٌ حَقٌّ':Added, #2: 2	تَأْخِيرُ حَقِّهِ
u'تَأْخِيرٌ حُكْمٌ':Added, #3: 3	تَأْخِيرَ الْحَقِّ
u'تَأْخِيرٌ حُكْمٌ':Added, #1: 1	تَأْخِيرَ حُكْمِ
u'تَأْخِيرٌ حُكْمٌ':Added, #1: 1	تَأْخِيرِ حُكْمِ
u'تَأْخِيرٌ حُكْمٌ':Added, #1: 1	تَأْخِيرَ حُكْمِهِ
u'تَأْخِيرٌ حُكْمٌ':Added, #2: 2	تَأْخِيرِ الْحُكْمِ
u'تَأْخِيرٌ حُكْمٌ':Added, #2: 2	تَأْخِيرِ حُكْمِهِ
u'تَأْخِيرٌ حَلْقٌ':Added, #3: 3	تَأْخِيرُ الْحُكْمِ
u'تَأْخِيرٌ حَلْقٌ':Added, #1: 1	تَأْخِيرُ الْحَلْقِ
u'تَأْخِيرٌ حِنْثٌ':Added, #6: 6	تَأْخِيرِ الْحَلْقِ
u'تَأْخِيرٌ حَيْضٌ':Added, #2: 2	تَأْخِيرِ الْحِنْثِ
u'تَأْخِيرٌ حَيْضٌ':Added, #1: 1	تَأْخِيرَ الْحَيْضِ
u'تَأْخِيرٌ حَيَوَانٌ':Added, #1: 1	تَأْخِيرِ الْحَيْضِ
u'تَأْخِيرٌ خَتْمٌ':Added, #1: 1	تَأْخِيرُ الْحَيَوَانِ
u'تَأْخِيرٌ خُرُوجٌ':Added, #1: 1	تَأْخِيرُ خَتْمِهِ
u'تَأْخِيرٌ خُصُومٌ':Added, #1: 1	تَأْخِيرُ الْخُرُوجِ
u'تَأْخِيرٌ خُصُومَةٌ':Added, #1: 1	تَأْخِيرُ الْخُصُومِ
u'تَأْخِيرٌ خِطَابٌ':Added, #1: 1	تَأْخِيرَ الْخُصُومَةِ
u'تَأْخِيرٌ خِطَابٌ':Added, #1: 1	تَأْخِيرِ الْخِطَابِ
u'تَأْخِيرٌ خِطَابٌ':Added, #1: 1	تَأْخِيرَ خِطَابِ
u'تَأْخِيرٌ دَائِمٌ':Added, #1: 1	تَأْخِيرُ خِطَابِ
u'تَأْخِيرٌ دُعَاءٌ':Added, #1: 1	تَأْخِيرُ دَائِمِ
u'تَأْخِيرٌ دفع':Added, #1: 1	تَأْخِيرُ الدُّعَاءِ
u'تَأْخِيرٌ دَفْعٌ':Added, #2: 2	تَأْخِيرُ الدَّفْعِ
u'تَأْخِيرٌ دفن':Added, #2: 2	تَأْخِيرُ الدَّفْعِ
u'تَأْخِيرٌ دفن':Added, #2: 2	تَأْخِيرُ دَفْنِهِ
u'تَأْخِيرٌ دَفْنٌ':Added, #2: 2	تَأْخِيرِ دَفْنِهِ
u'تَأْخِيرٌ دَفْنٌ':Added, #2: 2	تَأْخِيرُ دَفْنِهِ
u'تَأْخِيرٌ دَيْنٌ':Added, #2: 2	تَأْخِيرِ دَفْنِهِ
u'تَأْخِيرٌ دَيْنٌ':Added, #1: 1	تَأْخِيرَ الدَّيْنِ
u'تَأْخِيرٌ دَيْنٌ':Added, #1: 1	تَأْخِيرِ الدَّيْنِ
u'تَأْخِيرٌ ذكر':Added, #1: 1	تَأْخِيرِ دَيْنٍ
u'تَأْخِيرٌ ذِكْرٌ':Added, #1: 1	تَأْخِيرُ ذِكْرِ
u'تَأْخِيرٌ رَأْسٌ':Added, #1: 1	تَأْخِيرُ ذِكْرِ
u'تَأْخِيرٌ رَأْسٌ':Added, #2: 2	تَأْخِيرِ رَأْسِ
u'تَأْخِيرٌ رَبُّ':Added, #4: 4	تَأْخِيرُ رَأْسِ
u'تَأْخِيرٌ رَبُّ':Added, #1: 1	تَأْخِيرُ رَبِّهِ
u'تَأْخِيرٌ رَجُلٌ':Added, #1: 1	تَأْخِيرِ رَبِّهِ
u'تَأْخِيرٌ رِجْلٌ':Added, #1: 1	تَأْخِيرُ الرَّجُلِ
u'تَأْخِيرٌ رَجْمٌ':Added, #1: 1	تَأْخِيرِ الرِّجْلَيْنِ
u'تَأْخِيرٌ رُجُوعٌ':Added, #2: 2	تَأْخِيرَ الرَّجْمِ
u'تَأْخِيرٌ رَدٌّ':Added, #1: 1	تَأْخِيرَ الرُّجُوعِ
u'تَأْخِيرٌ رُكْنٌ':Added, #3: 3	تَأْخِيرُ الرَّدِّ
u'تَأْخِيرٌ رُكْن':Added, #4: 4	تَأْخِيرِ رُكْنٍ
u'تَأْخِيرٌ رُكوعٌ':Added, #4: 4	تَأْخِيرِ رُكْنٍ
u'تَأْخِيرٌ رَمْيٌ':Added, #1: 1	تَأْخِيرُ الرُّكُوعِ
u'تَأْخِيرٌ رَمْيٌ':Added, #1: 1	تَأْخِيرَ الرَّمْيِ
u'تَأْخِيرٌ رَمْيٌ':Added, #1: 1	تَأْخِيرُ الرَّمْيِ
u'تَأْخِيرٌ رَمْيٌ':Added, #2: 2	تَأْخِيرِ رَمْيِ
u'تَأْخِيرٌ رَمْيٌ':Added, #3: 3	تَأْخِيرُ رَمْيِ
u'تَأْخِيرٌ رُؤْيَةٌ':Added, #4: 4	تَأْخِيرِ الرَّمْيِ
u'تَأْخِيرٌ زَكاةٌ':Added, #1: 1	تَأْخِيرُ الرُّؤْيَةِ
u'تَأْخِيرٌ زَكاةٌ':Added, #1: 1	تَأْخِيرَ الزَّكَاةِ
u'تَأْخِيرٌ زَكاةٌ':Added, #1: 1	تَأْخِيرُ الزَّكَاةِ
u'تَأْخِيرٌ سَبَبٌ':Added, #6: 6	تَأْخِيرِ الزَّكَاةِ
u'تَأْخِيرٌ سَبَبِيَّةٌ':Added, #1: 1	تَأْخِيرُ السَّبَبِ
u'تَأْخِيرٌ سَبْعَةٌ':Added, #6: 6	تَأْخِيرُ السَّبَبِيَّةِ
u'تَأْخِيرٌ سجدة':Added, #1: 1	تَأْخِيرِ السَّبْعَةِ
u'تَأْخِيرٌ سَجْدَةٌ':Added, #1: 1	تَأْخِيرِ سَجْدَةِ
u'تَأْخِيرٌ سجدة':Added, #1: 1	تَأْخِيرِ سَجْدَةِ
u'تَأْخِيرٌ سَجْدَةٌ':Added, #2: 2	تَأْخِيرُ السَّجْدَةِ
u'تَأْخِيرٌ سُجُودٌ':Added, #2: 2	تَأْخِيرُ السَّجْدَةِ
u'تَأْخِيرٌ سُجُودٌ':Added, #1: 1	تَأْخِيرَ السُّجُودِ
u'تَأْخِيرٌ سُجُودٌ':Added, #1: 1	تَأْخِيرُ السُّجُودِ
u'تَأْخِيرٌ سَحُورٌ':Added, #1: 1	تَأْخِيرِ السُّجُودِ
u'تَأْخِيرٌ سُحُورٌ':Added, #1: 1	تَأْخِيرُ السَّحُورِ
u'تَأْخِيرٌ سُحُورٌ':Added, #3: 3	تَأْخِيرُ السُّحُورِ
u'تَأْخِيرٌ سلام':Added, #3: 3	تَأْخِيرِ السُّحُورِ
u'تَأْخِيرٌ سَلاَمٌ':Added, #2: 2	تَأْخِيرُ السَّلَامِ
u'تَأْخِيرٌ سُنَّةٌ':Added, #2: 2	تَأْخِيرُ السَّلَامِ
u'تَأْخِيرٌ سُورَةٌ':Added, #1: 1	تَأْخِيرُ سُنَّةِ
u'تَأْخِيرٌ شَرْطٌ':Added, #1: 1	تَأْخِيرِ السُّورَةِ
u'تَأْخِيرٌ شَرْطٌ':Added, #1: 1	تَأْخِيرَ الشَّرْطِ
u'تَأْخِيرٌ شُرُوعٌ':Added, #1: 1	تَأْخِيرِ الشَّرْطِ
u'تَأْخِيرٌ شُرُوعٌ':Added, #1: 1	تَأْخِيرُ الشُّرُوعِ
u'تَأْخِيرٌ شفعة':Added, #1: 1	تَأْخِيرِ الشُّرُوعِ
u'تَأْخِيرٌ شُفْعَةٌ':Added, #1: 1	تَأْخِيرُ الشُّفْعَةِ
u'تَأْخِيرٌ شَهَادَةٌ':Added, #1: 1	تَأْخِيرُ الشُّفْعَةِ
u'تَأْخِيرٌ شَهَادَةٌ':Added, #1: 1	تَأْخِيرِ الشَّهَادَةِ
u'تَأْخِيرٌ شَهَادَةٌ':Added, #1: 1	تَأْخِيرِ شَهَادَةِ
u'تَأْخِيرٌ شَهْرٌ':Added, #2: 2	تَأْخِيرُ الشَّهَادَةِ
u'تَأْخِيرٌ شَيْءٌ':Added, #1: 1	تَأْخِيرِ شَهْرِ
u'تَأْخِيرٌ صَبِيٌّ':Added, #1: 1	تَأْخِيرُ شَيْءٍ
u'تَأْخِيرٌ صداق':Added, #1: 1	تَأْخِيرِ الصَّبِيِّ
u'تَأْخِيرٌ صَدَاقٌ':Added, #1: 1	تَأْخِيرُ الصَّدَاقِ
u'تَأْخِيرٌ صَرْفٌ':Added, #1: 1	تَأْخِيرُ الصَّدَاقِ
u'تَأْخِيرٌ صَرْف':Added, #2: 2	تَأْخِيرِ صَرْفِ
u'تَأْخِيرٌ صُعُودٌ':Added, #2: 2	تَأْخِيرِ صَرْفِ
u'تَأْخِيرٌ صِفَةٌ':Added, #1: 1	تَأْخِيرِ صُعُودِ
u'تَأْخِيرٌ صَلاَةٌ':Added, #1: 1	تَأْخِيرِ الصِّفَةِ
u'تَأْخِيرٌ صَلاَةٌ':Added, #11: 11	تَأْخِيرِ الصَّلَاةِ
u'تَأْخِيرٌ صَلاَةٌ':Added, #16: 16	تَأْخِيرُ الصَّلَاةِ
u'تَأْخِيرٌ صَلاَةٌ':Added, #1: 1	تَأْخِيرِ الصَّلاَةِ
u'تَأْخِيرٌ صَلاَةٌ':Added, #1: 1	تَأْخِيرِ صَلاةِ
u'تَأْخِيرٌ صَلاَةٌ':Added, #1: 1	تَأْخِيرَ صَلَاةِ
u'تَأْخِيرٌ صَلاَةٌ':Added, #1: 1	تَأْخِيرِ صَلَاةِ
u'تَأْخِيرٌ صَلاَةٌ':Added, #2: 2	تَأْخِيرُ صَلَاةِ
u'تَأْخِيرٌ صَلَوَاتٌ':Added, #7: 7	تَأْخِيرَ الصَّلَاةِ
u'تَأْخِيرٌ صَوَابٌ':Added, #1: 1	تَأْخِيرَ الصَّلَوَاتِ
u'تَأْخِيرٌ صَوْمٌ':Added, #1: 1	تَأْخِيرِ الصَّوَابِ
u'تَأْخِيرٌ صَوْمٌ':Added, #2: 2	تَأْخِيرِ الصَّوْمِ
u'تَأْخِيرٌ طلب':Added, #3: 3	تَأْخِيرُ الصَّوْمِ
u'تَأْخِيرٌ طَلَبٌ':Added, #1: 1	تَأْخِيرُ الطَّلَبِ
u'تَأْخِيرٌ طلب':Added, #1: 1	تَأْخِيرُ الطَّلَبِ
u'تَأْخِيرٌ طَلَبٌ':Added, #1: 1	تَأْخِيرُ طَلَبِ
u'تَأْخِيرٌ طواف':Added, #1: 1	تَأْخِيرُ طَلَبِ
u'تَأْخِيرٌ طواف':Added, #1: 1	تَأْخِيرَ طَوَافِ
u'تَأْخِيرٌ طَوَافٌ':Added, #1: 1	تَأْخِيرُ طَوَافِ
u'تَأْخِيرٌ طَوَافٌ':Added, #1: 1	تَأْخِيرَ طَوَافِ
u'تَأْخِيرٌ طواف':Added, #1: 1	تَأْخِيرُ طَوَافِ
u'تَأْخِيرٌ طَوَافٌ':Added, #2: 2	تَأْخِيرُ الطَّوَافِ
u'تَأْخِيرٌ طواف':Added, #2: 2	تَأْخِيرُ الطَّوَافِ
u'تَأْخِيرٌ طَوَافٌ':Added, #4: 4	تَأْخِيرِ طَوَافِ
u'تَأْخِيرٌ ظُهْرٌ':Added, #4: 4	تَأْخِيرِ طَوَافِ
u'تَأْخِيرٌ ظُهْرٌ':Added, #1: 1	تَأْخِيرُ ظُهْرِ
u'تَأْخِيرٌ ظُهْرٌ':Added, #3: 3	تَأْخِيرَ الظُّهْرِ
u'تَأْخِيرٌ ظُهْرٌ':Added, #3: 3	تَأْخِيرِ الظُّهْرِ
u'تَأْخِيرٌ عَامِلٌ':Added, #8: 8	تَأْخِيرُ الظُّهْرِ
u'تَأْخِيرٌ عِبَادَةٌ':Added, #1: 1	تَأْخِيرِ الْعَامِلِ
u'تَأْخِيرٌ عِبَارَةٌ':Added, #2: 2	تَأْخِيرَ الْعِبَادَةِ
u'تَأْخِيرٌ عَبْدٌ':Added, #1: 1	تَأْخِيرَ الْعِبَارَةِ
u'تَأْخِيرٌ عرف':Added, #2: 2	تَأْخِيرَ عَبْدِ
u'تَأْخِيرٌ عُرْفٌ':Added, #1: 1	تَأْخِيرِ الْعُرْفِ
u'تَأْخِيرٌ عِشَاءٌ':Added, #1: 1	تَأْخِيرِ الْعُرْفِ
u'تَأْخِيرٌ عِشَاءٌ':Added, #2: 2	تَأْخِيرَ الْعِشَاءِ
u'تَأْخِيرٌ عِشَاءٌ':Added, #6: 6	تَأْخِيرِ الْعِشَاءِ
u'تَأْخِيرٌ عَصْرٌ':Added, #7: 7	تَأْخِيرُ الْعِشَاءِ
u'تَأْخِيرٌ عَصْرٌ':Added, #1: 1	تَأْخِيرَ الْعَصْرِ
u'تَأْخِيرٌ عَصْرٌ':Added, #5: 5	تَأْخِيرُ الْعَصْرِ
u'تَأْخِيرٌ عقاب':Added, #7: 7	تَأْخِيرِ الْعَصْرِ
u'تَأْخِيرٌ عِقَابٌ':Added, #1: 1	تَأْخِيرَ الْعِقَابِ
u'تَأْخِيرٌ عَقْدٌ':Added, #1: 1	تَأْخِيرَ الْعِقَابِ
u'تَأْخِيرٌ عِمَارَةٌ':Added, #3: 3	تَأْخِيرِ الْعَقْدِ
u'تَأْخِيرٌ عِمَارَةٌ':Added, #1: 1	تَأْخِيرَ الْعِمَارَةِ
u'تَأْخِيرٌ عمرة':Added, #1: 1	تَأْخِيرِ الْعِمَارَةِ
u'تَأْخِيرٌ عمرة':Added, #2: 2	تَأْخِيرَ الْعُمْرَةِ
u'تَأْخِيرٌ عُمْرَةٌ':Added, #2: 2	تَأْخِيرِ الْعُمْرَةِ
u'تَأْخِيرٌ عُمْرَةٌ':Added, #2: 2	تَأْخِيرَ الْعُمْرَةِ
u'تَأْخِيرٌ عَمَلٌ':Added, #2: 2	تَأْخِيرِ الْعُمْرَةِ
u'تَأْخِيرٌ عَمَلٌ':Added, #1: 1	تَأْخِيرُ الْعَمَلِ
u'تَأْخِيرٌ عَمَلٌ':Added, #1: 1	تَأْخِيرِ الْعَمَلِ
u'تَأْخِيرٌ عَمَلٌ':Added, #1: 1	تَأْخِيرُ عَمَلٍ
u'تَأْخِيرٌ عِيدٌ':Added, #1: 1	تَأْخِيرُ عَمَلِ
u'تَأْخِيرٌ غرماء':Added, #1: 1	تَأْخِيرِ عِيدِ
u'تَأْخِيرٌ غُسْلٌ':Added, #1: 1	تَأْخِيرُ الْغُرَمَاءِ
u'تَأْخِيرٌ غُسْلٌ':Added, #1: 1	تَأْخِيرِ الْغُسْلِ
u'تَأْخِيرٌ غَسْلٌ':Added, #2: 2	تَأْخِيرُ الْغُسْلِ
u'تَأْخِيرٌ غير':Added, #3: 3	تَأْخِيرِ غَسْلِ
u'تَأْخِيرٌ غَيْرٌ':Added, #1: 1	تَأْخِيرُ غَيْرِ
u'تَأْخِيرٌ فَاسِدٌ':Added, #1: 1	تَأْخِيرُ غَيْرِ
u'تَأْخِيرٌ فَجْرٌ':Added, #1: 1	تَأْخِيرِ الْفَاسِدَةِ
u'تَأْخِيرٌ فَجْرٌ':Added, #1: 1	تَأْخِيرِ الْفَجْرِ
u'تَأْخِيرٌ فَرَائِضُ':Added, #4: 4	تَأْخِيرُ الْفَجْرِ
u'تَأْخِيرٌ فَرْضٌ':Added, #1: 1	تَأْخِيرَ الْفَرَائِضِ
u'تَأْخِيرٌ فَرْضٌ':Added, #1: 1	تَأْخِيرَ الْفَرْضِ
u'تَأْخِيرٌ فَرْضٌ':Added, #1: 1	تَأْخِيرِ الْفَرْضِ
u'تَأْخِيرٌ فَرْضٌ':Added, #1: 1	تَأْخِيرُ فَرْضٍ
u'تَأْخِيرٌ فَسْخٌ':Added, #1: 1	تَأْخِيرُ فَرْضِ
u'تَأْخِيرٌ فَسْخٌ':Added, #1: 1	تَأْخِيرُ الْفَسْخِ
u'تَأْخِيرٌ فَصْلٌ':Added, #2: 2	تَأْخِيرَ الْفَسْخِ
u'تَأْخِيرٌ فِطْرٌ':Added, #1: 1	تَأْخِيرِ فَصْلِ
u'تَأْخِيرٌ فِعْلٌ':Added, #5: 5	تَأْخِيرُ الْفِطْرِ
u'تَأْخِيرٌ قَبْضٌ':Added, #1: 1	تَأْخِيرُ فِعْلِهِ
u'تَأْخِيرٌ قَبْضٌ':Added, #1: 1	تَأْخِيرَ الْقَبْضِ
u'تَأْخِيرٌ قَبْضٌ':Added, #1: 1	تَأْخِيرُ الْقَبْضِ
u'تَأْخِيرٌ قَبْضٌ':Added, #1: 1	تَأْخِيرَ قَبْضِ
u'تَأْخِيرٌ قَبْضٌ':Added, #1: 1	تَأْخِيرَ قَبْضِهِ
u'تَأْخِيرٌ قَبْضٌ':Added, #2: 2	تَأْخِيرِ قَبْضِ
u'تَأْخِيرٌ قَبُولٌ':Added, #2: 2	تَأْخِيرُ قَبْضِهِ
u'تَأْخِيرٌ قتل':Added, #1: 1	تَأْخِيرُ الْقَبُولِ
u'تَأْخِيرٌ قَتْلٌ':Added, #1: 1	تَأْخِيرِ الْقَتْلِ
u'تَأْخِيرٌ قَدَمٌ':Added, #1: 1	تَأْخِيرِ الْقَتْلِ
u'تَأْخِيرٌ قذف':Added, #1: 1	تَأْخِيرَ الْقَدَمَيْنِ
u'تَأْخِيرٌ قَذْفٌ':Added, #1: 1	تَأْخِيرِ الْقَذْفِ
u'تَأْخِيرٌ قِرَاءةٌ':Added, #1: 1	تَأْخِيرِ الْقَذْفِ
u'تَأْخِيرٌ قَسام':Added, #1: 1	تَأْخِيرِ الْقِرَاءَةِ
u'تَأْخِيرٌ قَسامَة':Added, #1: 1	تَأْخِيرِ الْقَسَامَةِ
u'تَأْخِيرٌ قسمة':Added, #1: 1	تَأْخِيرِ الْقَسَامَةِ
u'تَأْخِيرٌ قِسْمَةٌ':Added, #1: 1	تَأْخِيرَ قِسْمَةِ
u'تَأْخِيرٌ قصاص':Added, #1: 1	تَأْخِيرَ قِسْمَةِ
u'تَأْخِيرٌ قصاص':Added, #1: 1	تَأْخِيرُ الْقِصَاصِ
u'تَأْخِيرٌ قِصَاصٌ':Added, #1: 1	تَأْخِيرِ الْقِصَاصِ
u'تَأْخِيرٌ قِصَاصٌ':Added, #1: 1	تَأْخِيرُ الْقِصَاصِ
u'تَأْخِيرٌ قَضَاءٌ':Added, #1: 1	تَأْخِيرِ الْقِصَاصِ
u'تَأْخِيرٌ قَضَاءٌ':Added, #1: 1	تَأْخِيرِ الْقَضَاءِ
u'تَأْخِيرٌ قَضَاءٌ':Added, #2: 2	تَأْخِيرَ الْقَضَاءِ
u'تَأْخِيرٌ قَضَاءٌ':Added, #2: 2	تَأْخِيرِ قَضَاءِ
u'تَأْخِيرٌ قَضَاءٌ':Added, #3: 3	تَأْخِيرَ قَضَاءِ
u'تَأْخِيرٌ قَضَاءٌ':Added, #5: 5	تَأْخِيرُ قَضَاءِ
u'تَأْخِيرٌ قَطْعٌ':Added, #6: 6	تَأْخِيرُ الْقَضَاءِ
u'تَأْخِيرٌ قول':Added, #3: 3	تَأْخِيرُ الْقَطْعِ
u'تَأْخِيرٌ قَوْلٌ':Added, #1: 1	تَأْخِيرُ الْقَوْلِ
u'تَأْخِيرٌ قول':Added, #1: 1	تَأْخِيرُ الْقَوْلِ
u'تَأْخِيرٌ قَوْلٌ':Added, #1: 1	تَأْخِيرِ قَوْلِ
u'تَأْخِيرٌ قول':Added, #1: 1	تَأْخِيرِ قَوْلِ
u'تَأْخِيرٌ قَوْلٌ':Added, #1: 1	تَأْخِيرَ قَوْلِهِ
u'تَأْخِيرٌ قول':Added, #1: 1	تَأْخِيرَ قَوْلِهِ
u'تَأْخِيرٌ قَوْلٌ':Added, #3: 3	تَأْخِيرُ قَوْلِهِ
u'تَأْخِيرٌ قِيَاسٌ':Added, #3: 3	تَأْخِيرُ قَوْلِهِ
u'تَأْخِيرٌ قيام':Added, #1: 1	تَأْخِيرِ الْقِيَاسِ
u'تَأْخِيرٌ قيام':Added, #1: 1	تَأْخِيرُ الْقِيَامِ
u'تَأْخِيرٌ قِيَامٌ':Added, #1: 1	تَأْخِيرِ الْقِيَامِ
u'تَأْخِيرٌ قِيَامٌ':Added, #1: 1	تَأْخِيرُ الْقِيَامِ
u'تَأْخِيرٌ كِتَابٌ':Added, #1: 1	تَأْخِيرِ الْقِيَامِ
u'تَأْخِيرٌ كَفَّارٌ':Added, #3: 3	تَأْخِيرُ كِتَابِ
u'تَأْخِيرٌ كَفَّارَةٌ':Added, #1: 1	تَأْخِيرَ الْكَفَّارَةِ
u'تَأْخِيرٌ كَلاَمٌ':Added, #1: 1	تَأْخِيرَ الْكَفَّارَةِ
u'تَأْخِيرٌ كَلاَمٌ':Added, #1: 1	تَأْخِيرَ الْكَلَامِ
u'تَأْخِيرٌ لعان':Added, #1: 1	تَأْخِيرِ الْكَلاَمِ
u'تَأْخِيرٌ لعان':Added, #1: 1	تَأْخِيرَ اللِّعَانِ
u'تَأْخِيرٌ لَفْظَةٌ':Added, #1: 1	تَأْخِيرُ اللِّعَانِ
u'تَأْخِيرٌ مَأْمُورٌ':Added, #1: 1	تَأْخِيرَ لَفْظَةِ
u'تَأْخِيرٌ مُتَيَقِّن':Added, #1: 1	تَأْخِيرَ الْمَأْمُورِ
u'تَأْخِيرٌ مُحَقَّقٌ':Added, #1: 1	تَأْخِيرُ الْمُتَيَقِّنِ
u'تَأْخِيرٌ مَدَنِيٌّ':Added, #1: 1	تَأْخِيرُ الْمُحَقَّقِ
u'تَأْخِيرٌ مَدَنِيٌّ':Added, #1: 1	تَأْخِيرُ الْمَدَنِيِّ
u'تَأْخِيرٌ مَرْتَبَةٌ':Added, #1: 1	تَأْخِيرِ الْمَدَنِيِّ
u'تَأْخِيرٌ مَرَمَّة':Added, #1: 1	تَأْخِيرُ مَرْتَبَةٍ
u'تَأْخِيرٌ مَسْحُورٌ':Added, #2: 2	تَأْخِيرِ الْمَرَمَّةِ
u'تَأْخِيرٌ مَشِيئَةٌ':Added, #1: 1	تَأْخِيرُ الْمَسْحُورِ
u'تَأْخِيرٌ مُضَارِبٌ':Added, #1: 1	تَأْخِيرَ الْمَشِيئَةِ
u'تَأْخِيرٌ مُطَالَبٌ':Added, #1: 1	تَأْخِيرُ الْمُضَارِبِ
u'تَأْخِيرٌ مُطَالَبٌ':Added, #1: 1	تَأْخِيرُ مُطَالَبَةٍ
u'تَأْخِيرٌ مُطَالَبٌ':Added, #1: 1	تَأْخِيرُ مُطَالَبَتِهِ
u'تَأْخِيرٌ مُطَالَبٌ':Added, #2: 2	تَأْخِيرِ الْمُطَالَبَةِ
u'تَأْخِيرٌ مُطَالَبٌ':Added, #3: 3	تَأْخِيرَ الْمُطَالَبَةِ
u'تَأْخِيرٌ مُطَالَبَةٌ':Added, #5: 5	تَأْخِيرُ الْمُطَالَبَةِ
u'تَأْخِيرٌ مُطَالَبَةٌ':Added, #1: 1	تَأْخِيرُ مُطَالَبَةٍ
u'تَأْخِيرٌ مُطَالَبَةٌ':Added, #1: 1	تَأْخِيرُ مُطَالَبَتِهِ
u'تَأْخِيرٌ مُطَالَبَةٌ':Added, #2: 2	تَأْخِيرِ الْمُطَالَبَةِ
u'تَأْخِيرٌ مُطَالَبَةٌ':Added, #3: 3	تَأْخِيرَ الْمُطَالَبَةِ
u'تَأْخِيرٌ مَظْرُوفٌ':Added, #5: 5	تَأْخِيرُ الْمُطَالَبَةِ
u'تَأْخِيرٌ مُعَارَضَةٌ':Added, #1: 1	تَأْخِيرِ الْمَظْرُوفِ
u'تَأْخِيرٌ مُعَرَّفٌ':Added, #1: 1	تَأْخِيرِ الْمُعَارَضَةِ
u'تَأْخِيرٌ مَعْطُوف':Added, #1: 1	تَأْخِيرُ الْمُعَرَّفِ
u'تَأْخِيرٌ مَغْرِبٌ':Added, #1: 1	تَأْخِيرِ الْمَعْطُوفِ
u'تَأْخِيرٌ مَغْرِبٌ':Added, #4: 4	تَأْخِيرَ الْمَغْرِبِ
u'تَأْخِيرٌ مَغْرِبٌ':Added, #8: 8	تَأْخِيرُ الْمَغْرِبِ
u'تَأْخِيرٌ مُقَيَّدٌ':Added, #8: 8	تَأْخِيرِ الْمَغْرِبِ
u'تَأْخِيرٌ مُوَسَّعٌ':Added, #1: 1	تَأْخِيرِ الْمُقَيَّدِ
u'تَأْخِيرٌ نَبِيٌّ':Added, #1: 1	تَأْخِيرُ الْمُوَسَّعِ
u'تَأْخِيرٌ نَبِيٌّ':Added, #1: 1	تَأْخِيرُ النَّبِيِّ
u'تَأْخِيرٌ نَجْمٌ':Added, #1: 1	تَأْخِيرِ النَّبِيِّ
u'تَأْخِيرٌ نُسُكٌ':Added, #1: 1	تَأْخِيرِ نَجْمٍ
u'تَأْخِيرٌ نُسُكٌ':Added, #1: 1	تَأْخِيرَ نُسُكٍ
u'تَأْخِيرٌ نُطْقٌ':Added, #2: 2	تَأْخِيرَ النُّسُكِ
u'تَأْخِيرٌ نفر':Added, #1: 1	تَأْخِيرُ النُّطْقِ
u'تَأْخِيرٌ نَفْرٌ':Added, #1: 1	تَأْخِيرُ النَّفْرِ
u'تَأْخِيرٌ نَفْيٌ':Added, #1: 1	تَأْخِيرُ النَّفْرِ
u'تَأْخِيرٌ نَقْدٌ':Added, #1: 1	تَأْخِيرُ نَفْيِهِ
u'تَأْخِيرٌ نَقْد':Added, #1: 1	تَأْخِيرَ النَّقْدِ
u'تَأْخِيرٌ نَقْدٌ':Added, #1: 1	تَأْخِيرَ النَّقْدِ
u'تَأْخِيرٌ نَقْد':Added, #2: 2	تَأْخِيرُ النَّقْدِ
u'تَأْخِيرٌ نِيَّةٌ':Added, #2: 2	تَأْخِيرُ النَّقْدِ
u'تَأْخِيرٌ نِيَّةٌ':Added, #1: 1	تَأْخِيرِ النِّيَّةِ
u'تَأْخِيرٌ نِيلٌ':Added, #1: 1	تَأْخِيرَ نِيَّةِ
u'تَأْخِيرٌ هجرة':Added, #1: 1	تَأْخِيرِ النِّيلِ
u'تَأْخِيرٌ هِجْرَةٌ':Added, #1: 1	تَأْخِيرِ الْهِجْرَةِ
u'تَأْخِيرٌ هَدْيٌ':Added, #1: 1	تَأْخِيرِ الْهِجْرَةِ
u'تَأْخِيرٌ هَدْيٌ':Added, #1: 1	تَأْخِيرُ الْهَدْيِ
u'تَأْخِيرٌ وَاجِبٌ':Added, #2: 2	تَأْخِيرِ الْهَدْيِ
u'تَأْخِيرٌ وَاجِبٌ':Added, #1: 1	تَأْخِيرِ الْوَاجِبِ
u'تَأْخِيرٌ وَارِثٌ':Added, #2: 2	تَأْخِيرُ الْوَاجِبِ
u'تَأْخِيرٌ وَاقِعٌ':Added, #1: 1	تَأْخِيرُ الْوَارِثِ
u'تَأْخِيرٌ وَجْهٌ':Added, #1: 1	تَأْخِيرِ الْوَاقِعِ
u'تَأْخِيرٌ وُجُوبٌ':Added, #1: 1	تَأْخِيرُ وَجْهِ
u'تَأْخِيرٌ وَرَثَةٌ':Added, #2: 2	تَأْخِيرِ وُجُوبِ
u'تَأْخِيرٌ وَصِيٌّ':Added, #1: 1	تَأْخِيرُ وَرَثَتِهِ
u'تَأْخِيرٌ وَصِيٌّ':Added, #1: 1	تَأْخِيرُ الْوَصِيِّ
u'تَأْخِيرٌ وَصِيَّةٌ':Added, #1: 1	تَأْخِيرُ الْوَصِيَّةِ
u'تَأْخِيرٌ وَطْءٌ':Added, #1: 1	تَأْخِيرُ الْوَصِيَّةِ
u'تَأْخِيرٌ وَقْتٌ':Added, #1: 1	تَأْخِيرُ الْوَطْءِ
u'تَأْخِيرٌ وَقْت':Added, #1: 1	تَأْخِيرُ الْوَقْتِ
u'تَأْخِيرٌ وَقْتٌ':Added, #1: 1	تَأْخِيرِ الْوَقْتِيَّةِ
u'تَأْخِيرٌ وَقْتِيّ':Added, #2: 2	تَأْخِيرَ وَقْتِ
u'تَأْخِيرٌ وُقُوعٌ':Added, #1: 1	تَأْخِيرِ الْوَقْتِيَّةِ
u'تَأْخِيرٌ وُقُوفٌ':Added, #2: 2	تَأْخِيرِ الْوُقُوعِ
u'تَأْخِيرٌ وَكِيلٌ':Added, #1: 1	تَأْخِيرُ الْوُقُوفِ
u'تَأْخِيرٌ يَسِيرٌ':Added, #1: 1	تَأْخِيرُ الْوَكِيلِ
u'تَأْخِيرٌ يَمِينٌ':Added, #1: 1	تَأْخِيرَ الْيَسِيرِ
u'تَأْخِيرٌ يَمِينٌ':Added, #1: 1	تَأْخِيرَ الْيَمِينِ
u'تَأْخِيرٌ يَهُودِيٌّ':Added, #1: 1	تَأْخِيرُ الْيَمِينِ
u'تَأْدِيبٌ اِسْتِصْلاَحٌ':Added, #1: 1	تَأْخِيرُ الْيَهُودِيِّ
u'تَأْدِيبٌ أهْلٌ':Added, #1: 1	تَأْدِيبُ اسْتِصْلَاحٍ
u'تَأْدِيبٌ رَجُلٌ':Added, #1: 1	تَأْدِيبِ أَهْلِ
u'تَأْدِيبٌ رَقيقٌ':Added, #3: 3	تَأْدِيبُ الرَّجُلِ
u'تَأْدِيبٌ رَقيق':Added, #1: 1	تَأْدِيبُ رَقِيقِهِ
u'تَأْدِيبٌ زَجْرٌ':Added, #1: 1	تَأْدِيبُ رَقِيقِهِ
u'تَأْدِيبٌ زَوْجَةٌ':Added, #1: 1	تَأْدِيبَ زَجْرٍ
u'تَأْدِيبٌ سائِل':Added, #1: 1	تَأْدِيبَ زَوْجَتِهِ
u'تَأْدِيبٌ سَائِلٌ':Added, #1: 1	تَأْدِيبُ السَّائِلِ
u'تَأْدِيبٌ ظاهِرٌ':Added, #1: 1	تَأْدِيبُ السَّائِلِ
u'تَأْدِيبٌ فَرَسٌ':Added, #1: 1	تَأْدِيبُ الظَّاهِرِ
u'تَأْدِيبٌ فَرْعٌ':Added, #2: 2	تَأْدِيبُ فَرَسِهِ
u'تَأْدِيبٌ نِساءٌ':Added, #1: 1	تَأْدِيبُ الْفَرْعِ
u'تَأْدِيبٌ ولد':Added, #2: 2	تَأْدِيبِ النِّسَاءِ
u'تَأْدِيبٌ ولد':Added, #1: 1	تَأْدِيبُ الْوَلَدِ
u'تَأْدِيبٌ وَلَدٌ':Added, #1: 1	تَأْدِيبِ الْوَلَدِ
u'تَأْدِيبٌ وَلَدٌ':Added, #1: 1	تَأْدِيبُ الْوَلَدِ
u'تَأْدِيبٌ ولد':Added, #1: 1	تَأْدِيبِ الْوَلَدِ
u'تَأْدِيبٌ وَلَدٌ':Added, #1: 1	تَأْدِيبِ وَلَدِهِ
u'تَأْدِيبٌ يَتِيمٌ':Added, #1: 1	تَأْدِيبِ وَلَدِهِ
u'تَأَسَّى بَعْضٌ':Subject, #1: 1	تَأْدِيبِ الْيَتِيمِ
u'تَأْسِيسٌ أَوَّلُ':Added, #1: 1	تَأَسَّى الْبَعْضُ
u'تَأْسِيسٌ أَوَّلُ':Added, #1: 1	تَأْسِيسِ أَوَّلِ
u'تَأْسِيسٌ بَيْتٌ':Added, #2: 2	تَأْسِيسِ أَوّلِ
u'تَأْسِيسٌ تَقْديسٌ':Added, #1: 1	تَأْسِيسِ بَيْتٍ
u'تَأْسِيسٌ حالٌ':Added, #1: 1	تَأْسِيسِ التَّقْدِيسِ
u'تَأْسِيسٌ شَرْعٌ':Added, #1: 1	تَأْسِيسَ الْحَالِ
u'تَأْسِيسٌ قَاعِدٌ':Added, #1: 1	تَأْسِيسُ شَرْعٍ
u'تَأْسِيسٌ قَاعِدٌ':Added, #1: 1	تَأْسِيسُ الْقَاعِدَةِ
u'تَأْسِيسٌ قَوَاعِدُ':Added, #1: 1	تَأْسِيسِ قَاعِدَةٍ
u'تَأْسِيسٌ مَسْجِدٌ':Added, #1: 1	تَأْسِيسِ الْقَوَاعِدِ
u'تَأْسِيسٌ نظائر':Added, #1: 1	تَأْسِيسَ مَسْجِدِ
u'تَأَكُّدٌ إِحْرَامٌ':Added, #1: 1	تَأْسِيسِ النَّظَائِرِ
u'تَأَكُّدٌ إِحْرَامٌ':Added, #1: 1	تَأَكُّدِ الْإِحْرَامِ
u'تَأَكَّدَ أَمْرٌ':Subject, #2: 2	تَأَكُّدِ إحْرَامِ
u'تَأَكَّدَ اِنْعِقَادٌ':Subject, #3: 3	تَأَكَّدَ أَمْرُهُ
u'تَأَكُّدٌ بَدَلٌ':Added, #1: 1	تَأَكَّدَ انْعِقَادُهُ
u'تَأَكَّدَ تَثَبُّت':Subject, #1: 1	تَأَكُّدِ الْبَدَلِ
u'تَأَكُّدٌ ثُبُوتٌ':Added, #1: 1	تَأَكَّدَ التَّثَبُّتُ
u'تَأَكَّدَ حَجٌّ':Subject, #1: 1	تَأَكُّدَ ثُبُوتِ
u'تَأَكُّدٌ حُرْمَةٌ':Added, #1: 1	تَأَكَّدَ حَجُّهُ
u'تَأَكُّدٌ حُرْمَةٌ':Added, #1: 1	تَأَكُّدِ حُرْمَةِ
u'تَأَكُّدٌ حَقٌّ':Added, #1: 1	تَأَكُّدِ حُرْمَتِهِ
u'تَأَكُّدٌ حَقٌّ':Added, #1: 1	تَأَكُّدِ الْحَقِّ
u'تَأَكُّدٌ حَقٌّ':Added, #3: 3	تَأَكُّدِ حَقِّهِ
u'تَأَكُّدٌ حُكْمٌ':Added, #4: 4	تَأَكُّدِ حَقِّ
u'تَأَكَّدَ دَليلٌ':Subject, #1: 1	تَأَكُّدِ الْحُكْمِ
u'تَأَكَّدَ سَبَبٌ':Subject, #1: 1	تَأَكَّدَ دَلِيلُ
u'تَأَكُّدٌ سِتْرٌ':Added, #1: 1	تَأَكَّدَ سَبَبُهُ
u'تَأَكُّدٌ شفعة':Added, #1: 1	تَأَكُّدِ سِتْرِهِ
u'تَأَكُّدٌ شُفْعَةٌ':Added, #1: 1	تَأَكُّدِ الشُّفْعَةِ
u'تَأَكَّدَ صِفَةٌ':Subject, #1: 1	تَأَكُّدِ الشُّفْعَةِ
u'تَأَكُّدٌ صَوْمٌ':Added, #1: 1	تَأَكَّدَ صِفَةُ
u'تَأَكَّدَ طلب':Subject, #1: 1	تَأَكُّدِ الصَّوْمِ
u'تَأَكَّدَ طَلَبٌ':Subject, #1: 1	تَأَكَّدَ الطَّلَبُ
u'تَأَكَّدَ طلب':Subject, #1: 1	تَأَكَّدَ الطَّلَبُ
u'تَأَكَّدَ طَلَبٌ':Subject, #1: 1	تَأَكَّدَ طَلَبُهُ
u'تَأَكُّدٌ طلب':Added, #1: 1	تَأَكَّدَ طَلَبُهُ
u'تَأَكُّدٌ طَلَبٌ':Added, #1: 1	تَأَكُّدُ طَلَبِهِ
u'تَأَكُّدٌ عَقْدٌ':Added, #1: 1	تَأَكُّدُ طَلَبِهِ
u'تَأَكُّدٌ عَقْدٌ':Added, #1: 1	تَأَكُّدَ الْعَقْدِ
u'تَأَكُّدٌ عُهُودٌ':Added, #4: 4	تَأَكُّدِ الْعَقْدِ
u'تَأَكَّدَ فساد':Subject, #1: 1	تَأَكُّدِ الْعُهُودِ
u'تَأَكَّدَ فَسَادٌ':Subject, #1: 1	تَأَكَّدَ فَسَادُهُ
u'تَأَكَّدَ فساد':Subject, #1: 1	تَأَكَّدَ فَسَادُهُ
u'تَأَكَّدَ فَسَادٌ':Subject, #5: 5	تَأَكَّدَ الْفَسَادُ
u'تَأَكُّدٌ مُرَاعَاةٌ':Added, #5: 5	تَأَكَّدَ الْفَسَادُ
u'تَأَكَّدَ مِلْكٌ':Subject, #1: 1	تَأَكُّدِ مُرَاعَاةِ
u'تَأَكَّدَ مِلْكٌ':Subject, #1: 1	تَأَكَّدَ مِلْكُهُ
u'تَأَكُّدٌ مِلْكٌ':Added, #2: 2	تَأَكَّدَ الْمِلْكُ
u'تَأَكُّدٌ مِلْكٌ':Added, #1: 1	تَأَكُّدُ الْمِلْكِ
u'تَأَكُّدٌ مِلْكٌ':Added, #1: 1	تَأَكُّدِ الْمِلْكِ
u'تَأَكُّدٌ مِلْكٌ':Added, #1: 1	تَأَكُّدُ مِلْكِ
u'تَأَكُّدٌ مِلْكٌ':Added, #1: 1	تَأَكُّدِ مِلْكِهِ
u'تَأَكَّدَ مَهْرٌ':Subject, #3: 3	تَأَكُّدَ الْمِلْكِ
u'تَأَكُّدٌ مَهْرٌ':Added, #1: 1	تَأَكَّدَ الْمَهْرُ
u'تَأَكُّدٌ مَهْرٌ':Added, #2: 2	تَأَكُّدَ الْمَهْرِ
u'تَأَكَّدَ نَدْبٌ':Subject, #2: 2	تَأَكُّدِ الْمَهْرِ
u'تَأَكُّدٌ نَدْبٌ':Added, #1: 1	تَأَكَّدَ نَدْبُ
u'تَأَكُّدٌ نكاح':Added, #1: 1	تَأَكُّدِ نَدْبِ
u'تَأَكُّدٌ نِكَاحٌ':Added, #4: 4	تَأَكُّدِ النِّكَاحِ
u'تَأَكُّدٌ وُجُوبٌ':Added, #4: 4	تَأَكُّدِ النِّكَاحِ
u'تَآكَلَ حاجِزٌ':Subject, #1: 1	تَأَكُّدُ الْوُجُوبِ
u'تَآكَلَ كَفٌّ':Subject, #1: 1	تَآكَلَ الْحَاجِزُ
u'تَأْكِيدٌ إِثْبَاتٌ':Added, #1: 1	تَآكَلَ الْكَفُّ
u'تَأْكِيدٌ إِثْبَاتٌ':Added, #1: 1	تَأْكِيدِ إثْبَاتِ
u'تَأْكِيدٌ أحَدٌ':Added, #1: 1	تَأْكِيدَ الْإِثْبَاتِ
u'تَأْكِيدٌ أَسْماءٌ':Added, #1: 1	تَأْكِيدِ أَحَدِ
u'تَأْكِيدٌ اِعْتِكافٌ':Added, #1: 1	تَأْكِيدِ الْأَسْمَاءِ
u'تَأْكِيدٌ أَفْعَالٌ':Added, #1: 1	تَأْكِيدِ الاِعْتِكَافِ
u'تَأْكِيدٌ أَمْرٌ':Added, #1: 1	تَأْكِيدِ الْأَفْعَالِ
u'تَأْكِيدٌ أَوَّلُ':Added, #1: 1	تَأْكِيدِ أَمْرِهِ
u'تَأْكِيدٌ أَوَّلُ':Added, #2: 2	تَأْكِيدُ الْأَوَّلِ
u'تَأْكِيدٌ أَوَّلُ':Added, #2: 2	تَأْكِيدِ الْأَوَّلِ
u'تَأْكِيدٌ آيَةٌ':Added, #6: 6	تَأْكِيدَ الْأَوَّلِ
u'تَأْكِيدٌ إيقَاعٌ':Added, #1: 1	تَأْكِيدِ الْآيَةِ
u'تَأْكِيدٌ بدن':Added, #1: 1	تَأْكِيدَ الْإِيقَاعِ
u'تَأْكِيدٌ بَدَنٌ':Added, #1: 1	تَأْكِيدُ الْبَدَنِ
u'تَأْكِيدٌ بَيَانٌ':Added, #1: 1	تَأْكِيدُ الْبَدَنِ
u'تَأْكِيدٌ تَأْسِيسٌ':Added, #1: 1	تَأْكِيدِ بَيَانِ
u'تَأْكِيدٌ تَأَهُّبٌ':Added, #1: 1	تَأْكِيدُ تَأْسِيسٍ
u'تَأْكِيدٌ تَحْرِيمٌ':Added, #1: 1	تَأْكِيدِ التَّأَهُّبِ
u'تَأْكِيدٌ تَخْصِيصٌ':Added, #1: 1	تَأْكِيدِ التَّحْرِيمِ
u'تَأْكِيدٌ تَعْمِيمٌ':Added, #1: 1	تَأْكِيدُ التَّخْصِيصِ
u'تَأْكِيدٌ ثَانِي':Added, #1: 1	تَأْكِيدُ التَّعْمِيمِ
u'تَأْكِيدٌ ثَانِيَةٌ':Added, #1: 1	تَأْكِيدَ الثَّانِيَةِ
u'تَأْكِيدٌ حُرْمَةٌ':Added, #1: 1	تَأْكِيدَ الثَّانِيَةِ
u'تَأْكِيدٌ حَقٌّ':Added, #1: 1	تَأْكِيدِ الْحُرْمَةِ
u'تَأْكِيدٌ خَبَرٌ':Added, #1: 1	تَأْكِيدِ حَقِّهِ
u'تَأْكِيدٌ خَبَر':Added, #1: 1	تَأْكِيدِ الْخَبَرِ
u'تَأْكِيدٌ خُرُوجٌ':Added, #1: 1	تَأْكِيدِ الْخَبَرِ
u'تَأْكِيدٌ زاجِرٌ':Added, #1: 1	تَأْكِيدَ خُرُوجِ
u'تَأْكِيدٌ زَجْرٌ':Added, #1: 1	تَأْكِيدَ الزَّاجِرِ
u'تَأْكِيدٌ سَبَبٌ':Added, #1: 1	تَأْكِيدَ الزَّجْرِ
u'تَأْكِيدٌ سُنَّةٌ':Added, #1: 1	تَأْكِيدِ السَّبَبِ
u'تَأْكِيدٌ سِواكٌ':Added, #1: 1	تَأْكِيدِ السُّنَّةِ
u'تَأْكِيدٌ صدق':Added, #3: 3	تَأْكِيدِ السِّوَاكِ
u'تَأْكِيدٌ صِدْقٌ':Added, #1: 1	تَأْكِيدِ الصِّدْقِ
u'تَأْكِيدٌ صَلاَةٌ':Added, #1: 1	تَأْكِيدِ الصِّدْقِ
u'تَأْكِيدٌ صِيَامٌ':Added, #1: 1	تَأْكِيدِ صَلاَةِ
u'تَأْكِيدٌ صِيَغٌ':Added, #1: 1	تَأْكِيدِ الصِّيَامِ
u'تَأْكِيدٌ فَاعِلٌ':Added, #1: 1	تَأْكِيدُ الصِّيَغِ
u'تَأْكِيدٌ فِطْرٌ':Added, #2: 2	تَأْكِيدَ الْفَاعِلِ
u'تَأْكِيدٌ مَجَازٌ':Added, #2: 2	تَأْكِيدِ الْفِطْرِ
u'تَأْكِيدٌ مُسَاوَاةٌ':Added, #1: 1	تَأْكِيدُ الْمَجَازِ
u'تَأْكِيدٌ مَضْمَضَةٌ':Added, #1: 1	تَأْكِيدَ مُسَاوَاةٍ
u'تَأْكِيدٌ مَضْمُونٌ':Added, #2: 2	تَأْكِيدِ الْمَضْمَضَةِ
u'تَأْكِيدٌ مُطْلَقٌ':Added, #1: 1	تَأْكِيدَ مَضْمُونِ
u'تَأْكِيدٌ مَهْرٌ':Added, #1: 1	تَأْكِيدَ مُطْلَقِ
u'تَأْكِيدٌ مَهْرٌ':Added, #1: 1	تَأْكِيدَ الْمَهْرِ
u'تَأْكِيدٌ مَهْرٌ':Added, #1: 1	تَأْكِيدُ الْمَهْرِ
u'تَأْكِيدٌ نَدْبٌ':Added, #1: 1	تَأْكِيدِ الْمَهْرِ
u'تَأْكِيدٌ نَصٌّ':Added, #1: 1	تَأْكِيدُ النَّدْبِ
u'تَأْكِيدٌ نَفْيٌ':Added, #1: 1	تَأْكِيدَ النَّصِّ
u'تَأْكِيدٌ وُجُوبٌ':Added, #1: 1	تَأْكِيدَ النَّفْيِ
u'تَأْكِيدٌ وَعِيدٌ':Added, #1: 1	تَأْكِيدُ الْوُجُوبِ
u'تَأْكِيدٌ يَمِينٌ':Added, #1: 1	تَأْكِيدِ الْوَعِيدِ
u'تَأْكِيدٌ يَمِينٌ':Added, #1: 1	تَأْكِيدَ الْيَمِينِ
u'تَأَلُّبٌ عَرَبٌ':Added, #2: 2	تَأْكِيدِ الْيَمِينِ
u'تَأَلُّفٌ أَعْدَاءٌ':Added, #1: 1	تَأَلُّبُ الْعَرَبِ
u'تَأَلُّفٌ أَعْدَاءٌ':Added, #1: 1	تَأَلُّفُ أَعْدَاءٍ
u'تَأَلُّفٌ أَعْدَاءٌ':Added, #1: 1	تَأَلُّفَ الْأَعْدَاءِ
u'تَأَلُّفٌ أهْلٌ':Added, #1: 1	تَأَلُّفُ الْأَعْدَاءِ
u'تَأَلُّفٌ رَجُلٌ':Added, #1: 1	تَأَلُّفَ أَهْلِهِ
u'تَأْلِيفٌ أشباه':Added, #1: 1	تَأَلُّفَ الرَّجُلِ
u'تَأْلِيفٌ أشْبَاهٌ':Added, #1: 1	تَأْلِيفَ الْأَشْبَاهِ
u'تَأْلِيفٌ أَشْبَاهٌ':Added, #1: 1	تَأْلِيفَ الْأَشْبَاهِ
u'تَأْلِيفٌ أَلْحَانٌ':Added, #1: 1	تَأْلِيفَ الْأَشْبَاهِ
u'تَأْلِيفٌ إمَامٌ':Added, #1: 1	تَأْلِيفُ الْأَلْحَانِ
u'تَأْلِيفٌ جَديدٌ':Added, #1: 1	تَأْلِيفُ الْإِمَامِ
u'تَأْلِيفٌ حافِلٌ':Added, #1: 1	تَأْلِيفٍ جَدِيدٍ
u'تَأْلِيفٌ حَصِيرٌ':Added, #1: 1	تَأْلِيفٍ حَافِلٍ
u'تَأْلِيفٌ رَوْضَةٌ':Added, #1: 1	تَأْلِيفَ حَصِيرِ
u'تَأْلِيفٌ شَرْحٌ':Added, #1: 1	تَأْلِيفِ الرَّوْضَةِ
u'تَأْلِيفٌ شَيْخٌ':Added, #1: 1	تَأْلِيفِ شَرْحِ
u'تَأْلِيفٌ شَيْخٌ':Added, #1: 1	تَأْلِيفُ الشَّيْخِ
u'تَأْلِيفٌ صَوْتٌ':Added, #1: 1	تَأْلِيفُ شَيْخِ
u'تَأْلِيفٌ عَبْدٌ':Added, #1: 1	تَأْلِيفُ صَوْتٍ
u'تَأْلِيفٌ قُرْآنٌ':Added, #1: 1	تَأْلِيفِ عَبْدِ
u'تَأْلِيفٌ قُرْآنٌ':Added, #1: 1	تَأْلِيفَ الْقُرْآنِ
u'تَأْلِيفٌ قُلُوبٌ':Added, #2: 2	تَأْلِيفِ الْقُرْآنِ
u'تَأْلِيفٌ قَوْمٌ':Added, #1: 1	تَأْلِيفُ الْقُلُوبِ
u'تَأْلِيفٌ كَاتِبٌ':Added, #1: 1	تَأْلِيفَ قَوْمِهِ
u'تَأْلِيفٌ كِتَابٌ':Added, #1: 1	تَأْلِيفُ كَاتِبِهِ
u'تَأْلِيفٌ كِتَابٌ':Added, #1: 1	تَأْلِيفِ الْكِتَابِ
u'تَأْلِيفٌ كِتَابٌ':Added, #1: 1	تَأْلِيفَ كِتَابٍ
u'تَأْلِيفٌ كَلِمَةٌ':Added, #2: 2	تَأْلِيفِ كِتَابِ
u'تَأْلِيفٌ كَلِمَةٌ':Added, #1: 1	تَأْلِيفُ الْكَلِمَةِ
u'تَأْلِيفٌ مُحَمَّدٌ':Added, #1: 1	تَأْلِيفِ الْكَلِمَةِ
u'تَأْلِيفٌ مُخْتَصَرٌ':Added, #3: 3	تَأْلِيفِ مُحَمَّدٍ
u'تَأَمَّلَ أَحادِيثُ':Predicate, #1: 1	تَأْلِيفِ الْمُخْتَصَرِ
u'تَأَمَّلَ إِطْباقٌ':Predicate, #1: 1	تَأَمَّلَ الْأَحَادِيثَ
u'تَأَمَّلَ بَاحِثٌ':Subject, #1: 1	تَأَمَّلَ إطْبَاقَ
u'تَأَمَّلَ تَعْلِيلٌ':Predicate, #1: 1	تَأَمَّلَ الْبَاحِثُ
u'تَأَمُّلٌ تَعْلِيلٌ':Added, #1: 1	تَأَمَّلَ تَعْلِيلَ
u'تَأَمُّلٌ جُنُوح':Added, #1: 1	تَأَمُّلِ التَّعْلِيلِ
u'تَأَمُّلٌ حالٌ':Added, #1: 1	تَأَمُّلٍ جُنُوحٍ
u'تَأَمَّلَ حقائق':Predicate, #1: 1	تَأَمُّلِ الْحَالِ
u'تَأَمَّلَ حَقَائِقُ':Predicate, #1: 1	تَأَمَّلَ حَقَائِقَ
u'تَأَمُّلٌ خَطٌّ':Added, #1: 1	تَأَمَّلَ حَقَائِقَ
u'تَأَمَّلَ خَلْفٌ':Predicate, #1: 1	تَأَمُّلِ الْخَطِّ
u'تَأَمَّلَ دقائق':Predicate, #1: 1	تَأَمَّلَ خَلْفَ
u'تَأَمَّلَ دَقائِقُ':Predicate, #1: 1	تَأَمَّلَ دَقَائِقَ
u'تَأَمَّلَ سُورَةٌ':Predicate, #1: 1	تَأَمَّلَ دَقَائِقَ
u'تَأَمُّلٌ صَادِقٌ':Added, #1: 1	تَأَمَّلَ السُّورَةَ
u'تَأَمَّلَ صِيغَةٌ':Predicate, #1: 1	تَأَمُّلٍ صَادِقٍ
u'تَأَمَّلَ طُرُقٌ':Predicate, #1: 1	تَأَمَّلَ صِيغَةَ
u'تَأَمُّلٌ عَاشِقٌ':Added, #1: 1	تَأَمَّلَ طُرُقَ
u'تَأَمُّلٌ عَالِمٌ':Added, #1: 1	تَأَمُّلَ الْعَاشِقِ
u'تَأَمُّلٌ عَالِمٌ':Added, #1: 1	تَأَمُّلِ الْعَالِمِ
u'تَأَمَّلَ عِبَارَةٌ':Predicate, #1: 1	تَأَمُّلَ عَالِمٍ
u'تَأَمُّلٌ عِبَارَةٌ':Added, #1: 1	تَأَمَّلَ عِبَارَةَ
u'تَأَمَّلَ عَقِبٌ':Predicate, #1: 1	تَأَمُّلِ عِبَارَةِ
u'تَأَمَّلَ عواقب':Predicate, #1: 1	تَأَمَّلَ عَقِبَ
u'تَأَمَّلَ عَوَاقِبُ':Predicate, #1: 1	تَأَمَّلَ الْعَوَاقِبَ
u'تَأَمَّلَ غَايَةٌ':Predicate, #1: 1	تَأَمَّلَ الْعَوَاقِبَ
u'تَأَمَّلَ غَشَّاشٌ':Subject, #2: 2	تَأَمَّلَ غَايَةَ
u'تَأَمَّلَ فَقِيهٌ':Subject, #1: 1	تَأَمَّلَ الْغَشَّاشُ
u'تَأَمَّلَ قول':Predicate, #1: 1	تَأَمَّلَ الْفَقِيهُ
u'تَأَمَّلَ قَوْلٌ':Predicate, #1: 1	تَأَمَّلَ قَوْلَ
u'تَأَمُّلٌ قول':Added, #1: 1	تَأَمَّلَ قَوْلَ
u'تَأَمُّلٌ قَوْلٌ':Added, #1: 1	تَأَمُّلِ قَوْلِهِ
u'تَأَمَّلَ كَلاَمٌ':Predicate, #1: 1	تَأَمُّلِ قَوْلِهِ
u'تَأَمُّلٌ كَلاَمٌ':Added, #7: 7	تَأَمَّلَ كَلَامَ
u'تَأَمُّلٌ كَلاَمٌ':Added, #1: 1	تَأَمُّلُ كَلَامِ
u'تَأَمَّلَ لَبِيبٌ':Subject, #1: 1	تَأَمُّلِ كَلَامِهِ
u'تَأَمَّلَ لَفْظٌ':Predicate, #1: 1	تَأَمَّلَ اللَّبِيبُ
u'تَأَمَّلَ مُتَدَيِّنٌ':Subject, #1: 1	تَأَمَّلَ لَفْظَ
u'تَأَمُّلٌ مِثَالٌ':Added, #1: 1	تَأَمَّلَ الْمُتَدَيِّنُ
u'تَأَمَّلَ مَجَازٌ':Subject, #1: 1	تَأَمُّلِ الْمِثَالِ
u'تَأَمَّلَ مَسَائِلُ':Predicate, #1: 1	تَأَمَّلَ مَجَازٌ
u'تَأَمُّلٌ مَضْمُونٌ':Added, #1: 1	تَأَمَّلَ مَسَائِلَ
u'تَأَمُّلٌ وَجْهٌ':Added, #1: 1	تَأَمُّلِ مَضْمُونِ
u'تَأْمِينٌ إمَامٌ':Added, #1: 1	تَأَمُّلِ وَجْهِهِ
u'تَأْمِينٌ إمَامٌ':Added, #1: 1	تَأْمِينِ إمَامِهِ
u'تَأْمِينٌ إمَامٌ':Added, #2: 2	تَأْمِينَ الْإِمَامِ
u'تَأْمِينٌ إمَامٌ':Added, #2: 2	تَأْمِينِ الْإِمَامِ
u'تَأْمِينٌ أهْلٌ':Added, #4: 4	تَأْمِينُ الْإِمَامِ
u'تَأْمِينٌ أهْلٌ':Added, #1: 1	تَأْمِينَ أَهْلِ
u'تَأْمِينٌ فَذٌّ':Added, #1: 1	تَأْمِينُ أَهْلِ
u'تَأْمِينٌ قَارِئٌ':Added, #1: 1	تَأْمِينُ الْفَذِّ
u'تَأْمِينٌ قِرَاءةٌ':Added, #1: 1	تَأْمِينِ الْقَارِئِ
u'تَأْمِينٌ قَوْمٌ':Added, #1: 1	تَأْمِينِ الْقِرَاءَةِ
u'تَأْمِينٌ كَافِرٌ':Added, #1: 1	تَأْمِينَ الْقَوْمِ
u'تَأْمِينٌ مُسَلَّمٌ':Added, #1: 1	تَأْمِينُ الْكَافِرِ
u'تَأْمِينٌ مَلاَئِكَةٌ':Added, #1: 1	تَأْمِينٍ مُسَلَّمٍ
u'تَأْمِينٌ مَلاَئِكَةٌ':Added, #1: 1	تَأْمِينُ الْمَلَائِكَةِ
u'تَأْمِينٌ مَلاَئِكَةٌ':Added, #3: 3	تَأْمِينَ الْمَلاَئِكَةِ
u'تَأْمِينٌ واحد':Added, #4: 4	تَأْمِينَ الْمَلَائِكَةِ
u'تَأْمِينٌ وَاحِدٌ':Added, #1: 1	تَأْمِينُ وَاحِدٍ
u'تَأْمِينٌ يَقِينٌ':Added, #1: 1	تَأْمِينُ وَاحِدٍ
u'تَأَنَّسَ عجز':Predicate, #1: 1	تَأْمِينُ يَقِينٍ
u'تَأْنِيبٌ قُرَيْشٌ':Added, #1: 1	تَأَنَّسَ عَجَزَ
u'تَأَهُّلٌ علم':Added, #1: 1	تَأْنِيبِ قُرَيْشٍ
u'تَأَهُّلٌ عِلْمٌ':Added, #1: 1	تَأَهُّلِ الْعِلْمِ
u'تَأَهَّلَ فُلاَنٌ':Subject, #1: 1	تَأَهُّلِ الْعِلْمِ
u'تَأَهُّلٌ مُحَكَّمٌ':Added, #1: 1	تَأَهَّلَ فُلَانٌ
u'تَأَهَّلَ مُعْتَرِضٌ':Subject, #2: 2	تَأَهُّلِ الْمُحَكَّمِ
u'تَأَهَّلَ نَصٌّ':Predicate, #1: 1	تَأَهَّلَ الْمُعْتَرِضُ
u'تَأَوُّهٌ خَشْيَةٌ':Added, #1: 1	تَأَهَّلَ نَصَّ
u'تَأَيَّدَ أَوَّلُ':Subject, #1: 1	تَأَوُّهِ خَشْيَةٍ
u'تَأَيَّدَ تَحْرِيمٌ':Subject, #1: 1	تَأَيَّدَ الْأَوَّلُ
u'تَأَيَّدَ تَقْيِيد':Subject, #1: 1	تَأَيَّدَ تَحْرِيمُ
u'تَأَيَّدَ جَوَابٌ':Subject, #1: 1	تَأَيَّدَ التَّقْيِيدُ
u'تَأَيَّدَ خَبَرٌ':Subject, #1: 1	تَأَيَّدَ جَوَابُ
u'تَأَيَّدَ خَبَر':Subject, #1: 1	تَأَيَّدَ خَبَرُ
u'تَأَيَّدَ قول':Subject, #1: 1	تَأَيَّدَ خَبَرُ
u'تَأَيَّدَ قَوْلٌ':Subject, #1: 1	تَأَيَّدَ قَوْلُ
u'تَأْيِيدٌ اِبْنٌ':Added, #1: 1	تَأَيَّدَ قَوْلُ
u'تَأْيِيدٌ إِطْلاقٌ':Added, #1: 1	تَأْيِيدُ ابْنِ
u'تَأْيِيدٌ بَحْثٌ':Added, #1: 1	تَأْيِيدُ الْإِطْلَاقِ
u'تَأْيِيدٌ تَحْرِيمٌ':Added, #1: 1	تَأْيِيدِ بَحْثِهِ
u'تَأْيِيدٌ حُكْمٌ':Added, #1: 1	تَأْيِيدَ التَّحْرِيمِ
u'تَأْيِيدٌ عِبَارَةٌ':Added, #1: 1	تَأْيِيدِ الْحُكْمِ
u'تَأْيِيدٌ كَوْنٌ':Added, #1: 1	تَأْيِيدِ عِبَارَةِ
u'تَأْيِيدٌ مَفْسَدَةٌ':Added, #1: 1	تَأْيِيدِ كَوْنِهِ
u'تَأْيِيدٌ نقل':Added, #1: 1	تَأْيِيدِ مَفْسَدَةٍ
u'تَأْيِيدٌ نَقْلٌ':Added, #1: 1	تَأْيِيدِ نَقْلِهِ
u'تَأْيِيدٌ وَقْفٌ':Added, #1: 1	تَأْيِيدِ نَقْلِهِ
u'تَبَادَرَ ذِهْنٌ':Subject, #1: 1	تَأْيِيدِ الْوَقْفِ
u'تَبَادَرَ طلب':Subject, #2: 2	تَبَادَرَ الذِّهْنُ
u'تَبَادَرَ طَلَبٌ':Subject, #1: 1	تَبَادَرَ طَلَبُ
u'تَبَادَرَ مُغَايِرٌ':Subject, #1: 1	تَبَادَرَ طَلَبُ
u'تَبَادُلٌ طَعَامٌ':Added, #1: 1	تَبَادَرَ الْمُغَايِرُ
u'تَبَادَلَ مُعْسِرٌ':Subject, #2: 2	تَبَادُلِ الطَّعَامَيْنِ
u'تَبَادُلٌ مِلْكٌ':Added, #1: 1	تَبَادَلَ الْمُعْسِرُ
u'تَبَارَكَ اِسْمٌ':Subject, #1: 1	تَبَادُلِ الْمِلْكَيْنِ
u'تَبَارَكَ سَائِقٌ':Subject, #4: 4	تَبَارَكَ اسْمُهُ
u'تَبَاشَرَ أَصْحَابٌ':Subject, #1: 1	تَبَارَكَ سَائِقُ
u'تَبَاعَدَ بَطَلٌ':Predicate, #1: 1	تَبَاشَرَ أَصْحَابُ
u'تَبَاعَدَ رِجَالٌ':Subject, #1: 1	تَبَاعَدَ بَطَلَ
u'تَبَاعَدَ عَهْدٌ':Subject, #1: 1	تَبَاعَدَ الرّجَالُ
u'تَبَاعَدَ مَلَكٌ':Subject, #1: 1	تَبَاعَدَ عَهْدُ
u'تَبَاعَدَ وَقْتٌ':Subject, #1: 1	تَبَاعَدَ الْمَلَكُ
u'تَبَاغُضٌ عَدَمٌ':Added, #2: 2	تَبَاعَدَ الْوَقْتُ
u'تَبَاهَى نَاسٌ':Subject, #1: 1	تَبَاغُضُ الْعَدَمِ
u'تَبَايَعَ بَيْعٌ':Subject, #2: 2	تَبَاهَى النَّاسُ
u'تَبَايَعَ كُفَّارٌ':Subject, #1: 1	تَبَايَعَ الْبَيْعُ
u'تَبَايَعَ مُقِيمٌ':Subject, #1: 1	تَبَايَعَ الْكُفَّارُ
u'تَبَايَعَ وَصِيٌّ':Subject, #1: 1	تَبَايَعَ مُقِيمٌ
u'تَبَايُنٌ اِخْتِلاَفٌ':Added, #1: 1	تَبَايَعَ الْوَصِيُّ
u'تَبَايُنٌ أخْلاقٌ':Added, #1: 1	تَبَايُنُ اخْتِلَافِ
u'تَبَايُنٌ أَخْلاَقٌ':Added, #1: 1	تَبَايُنِ الْأَخْلَاقِ
u'تَبَايَنَ أسْنَانٌ':Subject, #1: 1	تَبَايُنِ الْأَخْلَاقِ
u'تَبَايُنٌ أَطْرافٌ':Added, #1: 1	تَبَايَنَ أَسْنَانُ
u'تَبَايُنٌ أَطْرَافٌ':Added, #7: 7	تَبَايُنِ أَطْرَافِهِ
u'تَبَايَنَ أعداد':Subject, #7: 7	تَبَايُنِ أَطْرَافِهِ
u'تَبَايَنَ أَعْدَادٌ':Subject, #1: 1	تَبَايَنَ أَعْدَادُ
u'تَبَايُنٌ أَقْسَامٌ':Added, #1: 1	تَبَايَنَ أَعْدَادُ
u'تَبَايُنٌ أَمْلاكٌ':Added, #1: 1	تَبَايُنِ الْأَقْسَامِ
u'تَبَايُنٌ أَمْلاَكٌ':Added, #1: 1	تَبَايُنَ الْأَمْلَاكِ
u'تَبَايُنٌ ثَلاثَةٌ':Added, #1: 1	تَبَايُنَ الْأَمْلَاكِ
u'تَبَايُنٌ حقائق':Added, #1: 1	تَبَايُنُ الثَّلَاثَةِ
u'تَبَايُنٌ حَقَائِقُ':Added, #1: 1	تَبَايُنَ الْحَقَائِقِ
u'تَبَايُنٌ حَقِيقٌ':Added, #1: 1	تَبَايُنَ الْحَقَائِقِ
u'تَبَايُنٌ دَارٌ':Added, #1: 1	تَبَايُنِ الْحَقِيقَتَيْنِ
u'تَبَايُنٌ دَارٌ':Added, #10: 10	تَبَايُنُ الدَّارَيْنِ
u'تَبَايُنٌ دَارٌ':Added, #1: 1	تَبَايُنِ الدَّارِ
u'تَبَايُنٌ دَارٌ':Added, #6: 6	تَبَايُنَ الدَّارَيْنِ
u'تَبَايُنٌ صُورٌ':Added, #6: 6	تَبَايُنِ الدَّارَيْنِ
u'تَبَايُنٌ طعام':Added, #1: 1	تَبَايُنِ الصُّورَتَيْنِ
u'تَبَايُنٌ طَعَامٌ':Added, #1: 1	تَبَايُنِ طَعَامِ
u'تَبَايُنٌ مَكَانٌ':Added, #1: 1	تَبَايُنِ طَعَامِ
u'تَبَايُنٌ مَنْزِلٌ':Added, #1: 1	تَبَايُنَ الْمَكَانَيْنِ
u'تَبَايَنَ نَاسٌ':Subject, #1: 1	تَبَايُنِ الْمَنْزِلَتَيْنِ
u'تَبَايُنٌ وَقْتٌ':Added, #1: 1	تَبَايَنَ النَّاسُ
u'تَبَايُنٌ وِلاَيَةٌ':Added, #1: 1	تَبَايُنِ الْوَقْتَيْنِ
u'تَبَخَّرَ بَنْدٌ':Subject, #1: 1	تَبَايُنِ الْوِلَايَاتِ
u'تَبَخَّرَ سَاكِنٌ':Subject, #1: 1	تَبَخَّرَ بَنْدٌ
u'تَبَدَّدَ مَاءٌ':Subject, #1: 1	تَبَخَّرَ سَاكِنُهُ
u'تَبَدَّلَ اِجْتِهَادٌ':Subject, #1: 1	تَبَدَّدَ الْمَاءُ
u'تَبَدَّلَ أَمْرٌ':Subject, #1: 1	تَبَدَّلَ اجْتِهَادُهُ
u'تَبَدُّلٌ أَمْلاكٌ':Added, #1: 1	تَبَدَّلَ الْأَمْرُ
u'تَبَدُّلٌ أَمْلاَكٌ':Added, #1: 1	تَبَدُّلِ الْأَمْلَاكِ
u'تَبَدَّلَ حالٌ':Subject, #1: 1	تَبَدُّلِ الْأَمْلَاكِ
u'تَبَدَّلَ حالٌ':Subject, #2: 2	تَبَدَّلَ الْحَالُ
u'تَبَدُّلٌ حالٌ':Added, #6: 6	تَبَدَّلَ حَالُهُ
u'تَبَدُّلٌ حالٌ':Added, #1: 1	تَبَدُّلُ حَالٍ
u'تَبَدَّلَ رَأْيٌ':Subject, #2: 2	تَبَدُّلِ الْحَالِ
u'تَبَدُّلٌ رَأْيٌ':Added, #1: 1	تَبَدَّلَ رَأْيُ
u'تَبَدُّلٌ سَبَبٌ':Added, #1: 1	تَبَدُّلُ الرَّأْيِ
u'تَبَدُّلٌ سَبَبٌ':Added, #1: 1	تَبَدُّلَ السَّبَبِ
u'تَبَدَّلَ صَاحِبٌ':Subject, #2: 2	تَبَدُّلِ السَّبَبِ
u'تَبَدُّلٌ صِفَةٌ':Added, #1: 1	تَبَدَّلَ صَاحِبُ
u'تَبَدُّلٌ صِفَةٌ':Added, #1: 1	تَبَدُّلَ الصِّفَةِ
u'تَبَدُّلٌ صنعة':Added, #1: 1	تَبَدُّلَ صِفَتِهِ
u'تَبَدُّلٌ صَنْعَةٌ':Added, #1: 1	تَبَدُّلِ الصَّنْعَةِ
u'تَبَدَّلَ ظاهِرٌ':Subject, #1: 1	تَبَدُّلِ الصَّنْعَةِ
u'تَبَدُّلٌ عين':Added, #1: 1	تَبَدَّلَ ظَاهِرُ
u'تَبَدُّلٌ عَيْنٌ':Added, #5: 5	تَبَدُّلِ الْعَيْنِ
u'تَبَدُّلٌ عَيْن':Added, #5: 5	تَبَدُّلِ الْعَيْنِ
u'تَبَدَّلَ مَجْلِسٌ':Subject, #5: 5	تَبَدُّلِ الْعَيْنِ
u'تَبَدَّلَ مَجْلِسٌ':Subject, #3: 3	تَبَدَّلَ الْمَجْلِسُ
u'تَبَدُّلٌ مَجْلِسٌ':Added, #7: 7	تَبَدَّلَ مَجْلِسُ
u'تَبَدُّلٌ مَجْلِسٌ':Added, #2: 2	تَبَدُّلِ الْمَجْلِسِ
u'تَبَدَّلَ مَحَلٌّ':Subject, #5: 5	تَبَدُّلُ الْمَجْلِسِ
u'تَبَدَّلَ مَحَلٌّ':Subject, #1: 1	تَبَدَّلَ الْمَحَلُّ
u'تَبَدُّلٌ مَحَلٌّ':Added, #2: 2	تَبَدَّلَ مَحَلُّ
u'تَبَدُّلٌ مَحَلٌّ':Added, #2: 2	تَبَدُّلِ الْمَحَلِّ
u'تَبَدَّلَ مُسْلِمٌ':Predicate, #2: 2	تَبَدُّلُ مَحَلِّ
u'تَبَدُّلٌ مَصْلَحَةٌ':Added, #1: 1	تَبَدَّلَ الْمُسْلِمَةَ
u'تَبَدَّلَ مَكَانٌ':Subject, #1: 1	تَبَدُّلَ الْمَصْلَحَةِ
u'تَبَدَّلَ مِلْكٌ':Subject, #1: 1	تَبَدَّلَ الْمَكَانُ
u'تَبَدُّلٌ مِلْكٌ':Added, #1: 1	تَبَدَّلَ الْمِلْكُ
u'تَبَدُّلٌ مِلْكٌ':Added, #3: 3	تَبَدُّلَ الْمِلْكِ
u'تَبَدُّلٌ مِلْكٌ':Added, #3: 3	تَبَدُّلُ الْمِلْكِ
u'تَبَدُّلٌ هَيْئَةٌ':Added, #3: 3	تَبَدُّلِ الْمِلْكِ
u'تَبَدَّلَ وَاجِبٌ':Subject, #1: 1	تَبَدُّلِ هَيْئَةٍ
u'تَبَدَّى أُقْحُوَانٌ':Subject, #1: 1	تَبَدَّلَ الْوَاجِبُ
u'تَبْدِيلٌ أَخِيرٌ':Added, #1: 1	تَبَدَّى الْأُقْحُوَانُ
u'تَبْدِيلٌ أصل':Added, #1: 1	تَبْدِيلُ الْأَخِيرَيْنِ
u'تَبْدِيلٌ أًصْلٌ':Added, #1: 1	تَبْدِيلُ أَصْلِ
u'تَبْدِيلٌ أَعْمَالٌ':Added, #1: 1	تَبْدِيلُ أَصْلِ
u'تَبْدِيلٌ أَقْوَالٌ':Added, #1: 1	تَبْدِيلُ الْأَعْمَالِ
u'تَبْدِيلٌ أَلْفَاظٌ':Added, #1: 1	تَبْدِيلَ الْأَقْوَالِ
u'تَبْدِيلٌ بَعْضٌ':Added, #1: 1	تَبْدِيلُ أَلْفَاظِ
u'تَبْدِيلٌ بَعْضٌ':Added, #1: 1	تَبْدِيلَ الْبَعْضِ
u'تَبْدِيلٌ بَلاءٌ':Added, #1: 1	تَبْدِيلِ بَعْضِ
u'تَبْدِيلٌ جَمِيع':Added, #1: 1	تَبْدِيلَ الْبَلَاءِ
u'تَبْدِيلٌ جِنْسٌ':Added, #2: 2	تَبْدِيلِ الْجَمِيعِ
u'تَبْدِيلٌ حَجٌّ':Added, #2: 2	تَبْدِيلَ الْجِنْسِ
u'تَبْدِيلٌ حُكْمٌ':Added, #1: 1	تَبْدِيلُ الْحَجِّ
u'تَبْدِيلٌ خلقة':Added, #2: 2	تَبْدِيلُ حُكْمٍ
u'تَبْدِيلٌ خِلْقَةٌ':Added, #1: 1	تَبْدِيلِ خِلْقَتِهِ
u'تَبْدِيلٌ دِينٌ':Added, #1: 1	تَبْدِيلِ خِلْقَتِهِ
u'تَبْدِيلٌ دِينٌ':Added, #1: 1	تَبْدِيلَ الدِّينِ
u'تَبْدِيلٌ سُنَّةٌ':Added, #1: 1	تَبْدِيلَ دِينِ
u'تَبْدِيلٌ سَيِّئٌ':Added, #1: 1	تَبْدِيلُ السُّنَّةِ
u'تَبْدِيلٌ سَيِّئٌ':Added, #1: 1	تَبْدِيلُ السَّيِّئَاتِ
u'تَبْدِيلٌ شَرْطٌ':Added, #1: 1	تَبْدِيلِ السَّيِّئَاتِ
u'تَبْدِيلٌ شَرِيعَةٌ':Added, #2: 2	تَبْدِيلُ شَرْطٍ
u'تَبْدِيلٌ عين':Added, #1: 1	تَبْدِيلِ الشَّرِيعَةِ
u'تَبْدِيلٌ عَيْنٌ':Added, #1: 1	تَبْدِيلِ الْعَيْنِ
u'تَبْدِيلٌ عَيْن':Added, #1: 1	تَبْدِيلِ الْعَيْنِ
u'تَبْدِيلٌ كِتَابٌ':Added, #1: 1	تَبْدِيلِ الْعَيْنِ
u'تَبْدِيلٌ كفر':Added, #1: 1	تَبْدِيلِ الْكِتَابِ
u'تَبْدِيلٌ كُفْرٌ':Added, #1: 1	تَبْدِيلُ الْكُفْرِ
u'تَبْدِيلٌ كَلاَمٌ':Added, #1: 1	تَبْدِيلُ الْكُفْرِ
u'تَبْدِيلٌ لَفْظٌ':Added, #1: 1	تَبْدِيلِ كَلَامِ
u'تَبْدِيلٌ مَحَلٌّ':Added, #1: 1	تَبْدِيلُ اللَّفْظِ
u'تَبْدِيلٌ مَوْضُوعٌ':Added, #1: 1	تَبْدِيلُ مَحَلِّ
u'تَبْدِيلٌ نَسَبٌ':Added, #1: 1	تَبْدِيلِ الْمَوْضُوعِ
u'تَبْدِيلٌ نِسَبٌ':Added, #1: 1	تَبْدِيلَ النّسَبِ
u'تَبْدِيلٌ نَفْسٌ':Added, #1: 1	تَبْدِيلَ النّسَبِ
u'تَبْدِيلٌ نِيَّةٌ':Added, #2: 2	تَبْدِيلِ النَّفْسِ
u'تَبْدِيلٌ وَلاَءٌ':Added, #1: 1	تَبْدِيلِ النِّيَّةِ
u'تَبْدِيلٌ وَلِيٌّ':Added, #1: 1	تَبْدِيلِ الْوَلَاءِ
u'تَبْدِيلٌ وَلِيٌّ':Added, #1: 1	تَبْدِيلَ وَلِيِّ
u'تَبْذِيرٌ مَالٌ':Added, #1: 1	تَبْدِيلُ وَلِيِّ
u'تَبَرَّأَ بَائِعٌ':Subject, #1: 1	تَبْذِيرِ الْمَالِ
u'تَبَرَّأَ شَيْطَانٌ':Subject, #2: 2	تَبَرَّأَ الْبَائِعُ
u'تَبَرُّجٌ جَاهِلِيٌّ':Added, #1: 1	تَبَرَّأَ الشَّيْطَانُ
u'تَبَرُّجٌ جَاهِلِيَّةٌ':Added, #5: 5	تَبَرُّجَ الْجَاهِلِيَّةِ
u'تَبَرُّعٌ أَبٌ':Added, #5: 5	تَبَرُّجَ الْجَاهِلِيَّةِ
u'تَبَرُّعٌ اِبْتِداءٌ':Added, #1: 1	تَبَرُّعِ الْأَبِ
u'تَبَرَّعَ أَجْنَبِيٌّ':Subject, #2: 2	تَبَرُّعُ ابْتِدَاءٍ
u'تَبَرَّعَ أَجْنَبِيٌّ':Subject, #14: 14	تَبَرَّعَ أَجْنَبِيٌّ
u'تَبَرَّعَ أحَدٌ':Subject, #1: 1	تَبَرَّعَ الْأَجْنَبِيُّ
u'تَبَرَّعَ إِنْسانٌ':Subject, #5: 5	تَبَرَّعَ أَحَدٌ
u'تَبَرُّعٌ إِنْسانٌ':Added, #8: 8	تَبَرَّعَ إنْسَانٌ
u'تَبَرَّعَ حاكِمٌ':Subject, #1: 1	تَبَرُّعَ الْإِنْسَانِ
u'تَبَرُّعٌ حَيٌّ':Added, #2: 2	تَبَرَّعَ حَاكِمٌ
u'تَبَرَّعَ رَجُلٌ':Subject, #1: 1	تَبَرُّعُ الْحَيِّ
u'تَبَرَّعَ سَيِّدٌ':Subject, #4: 4	تَبَرَّعَ رَجُلٌ
u'تَبَرَّعَ شَخْصٌ':Subject, #1: 1	تَبَرَّعَ السَّيِّدُ
u'تَبَرَّعَ شركاء':Subject, #1: 1	تَبَرَّعَ شَخْصٌ
u'تَبَرَّعَ غرماء':Subject, #1: 1	تَبَرَّعَ الشُّرَكَاءُ
u'تَبَرَّعَ قَائِدٌ':Subject, #1: 1	تَبَرَّعَ غُرَمَاءُ
u'تَبَرَّعَ مَالِكٌ':Subject, #1: 1	تَبَرَّعَ الْقَائِدُ
u'تَبَرَّعَ مُتَبَرِّعٌ':Subject, #1: 1	تَبَرَّعَ الْمَالِكُ
u'تَبَرُّعٌ مَدِينٌ':Added, #1: 1	تَبَرَّعَ مُتَبَرِّعٌ
u'تَبَرُّعٌ مَدِينٌ':Added, #20: 20	تَبَرُّعِ الْمَدِينِ
u'تَبَرُّعٌ مَدِينٌ':Added, #2: 2	تَبَرُّع الْمَدِينِ
u'تَبَرُّعٌ مَدِينٌ':Added, #2: 2	تَبَرُّعَ الْمَدِينِ
u'تَبَرُّعٌ مَرِيضٌ':Added, #7: 7	تَبَرُّعُ الْمَدِينِ
u'تَبَرُّعٌ مَرِيضٌ':Added, #2: 2	تَبَرُّعَ الْمَرِيضِ
u'تَبَرَّعَ مُسَلَّمٌ':Subject, #4: 4	تَبَرُّعِ الْمَرِيضِ
u'تَبَرَّعَ واحد':Subject, #1: 1	تَبَرَّعَ الْمُسَلَّمُ
u'تَبَرَّعَ وَاحِدٌ':Subject, #1: 1	تَبَرَّعَ وَاحِدٌ
u'تَبَرَّعَ وَارِثٌ':Subject, #1: 1	تَبَرَّعَ وَاحِدٌ
u'تَبَرُّعٌ وَارِثٌ':Added, #6: 6	تَبَرَّعَ الْوَارِثُ
u'تَبَرَّعَ وَرَثَةٌ':Subject, #1: 1	تَبَرُّعُ الْوَارِثِ
u'تَبَرَّعَ وقع':Predicate, #4: 4	تَبَرَّعَ الْوَرَثَةُ
u'تَبَرَّعَ وَلِيٌّ':Subject, #1: 1	تَبَرَّعَ وَقَعَ
u'تَبَرَّكَ مُصَنِّفٌ':Subject, #1: 1	تَبَرَّعَ الْوَلِيُّ
u'تَبَرَّمَ وَلِيٌّ':Subject, #1: 1	تَبَرَّكَ الْمُصَنِّفُ
u'تَبْرِيدٌ جِلْدَةٌ':Added, #4: 4	تَبَرَّمَ الْوَلِيُّ
u'تَبْرِيدٌ مَاءٌ':Added, #1: 1	تَبْرِيدَ جِلْدَتِهِ
u'تَبَسُّطٌ أَبٌ':Added, #1: 1	تَبْرِيدِ الْمَاءِ
u'تَبَسُّطٌ زَوْجٌ':Added, #1: 1	تَبَسُّطِ الْأَبِ
u'تَبَسُّطٌ زَوْجَةٌ':Added, #1: 1	تَبَسُّطُ الزَّوْجِ
u'تَبَسَّمَ تَبَسُّمٌ':Predicate, #1: 1	تَبَسُّطِ الزَّوْجَةِ
u'تَبَسَّمَ قَالٌ':Predicate, #1: 1	تَبَسَّمَ تَبَسُّمَ
u'تَبَسُّمٌ نَبِيٌّ':Added, #1: 1	تَبَسَّمَ قَالَ
u'تَبِعَ اِبْنٌ':Predicate, #1: 1	تَبَسُّمُ النَّبِيِّ
u'تَبِعَ اِبْنٌ':Subject, #4: 4	تَبِعَ ابْنَ
u'تَبِعَ أصل':Predicate, #4: 4	تَبِعَ ابْنُ
u'تَبِعَ أًصْلٌ':Predicate, #1: 1	تَبِعَ الْأَصْلَ
u'تَبِعَ أصل':Subject, #1: 1	تَبِعَ الْأَصْلَ
u'تَبِعَ أًصْلٌ':Subject, #1: 1	تَبِعَ أَصْلُهُ
u'تَبِعَ أُصولٌ':Predicate, #1: 1	تَبِعَ أَصْلُهُ
u'تَبِعَ المُشْتَرِي':Predicate, #1: 1	تَبِعَ الْأُصُولَ
u'تَبِعَ المُشْتَرِي':Predicate, #1: 1	أَتْبَعَ الْمُشْتَرِيَ
u'تَبِعَ أُمٌّ':Predicate, #1: 1	تَبِعَ الْمُشْتَرِيَ
u'تَبِعَ إمَامٌ':Predicate, #1: 1	تَبِعَ الْأُمَّ
u'تَبِعَ إمَامٌ':Predicate, #1: 1	تَبِعَ إمَامَ
u'تَبِعَ إمَامٌ':Subject, #4: 4	تَبِعَ الْإِمَامَ
u'تَبِعَ أَميرٌ':Predicate, #1: 1	تَبِعَ إمَامُ
u'تَبِعَ أَوَّلُ':Predicate, #1: 1	تَبِعَ الْأَمِيرَ
u'تَبِعَ أَوَّلُ':Predicate, #1: 1	أَتْبَعَ الْأَوَّلَ
u'تَبِعَ إيقَاعٌ':Predicate, #1: 1	تَبِعَ الْأَوَّلَ
u'تَبِعَ بَائِعٌ':Predicate, #3: 3	أَتْبَعَ الْإِيقَاعَ
u'تَبِعَ بَيَاضٌ':Subject, #2: 2	أَتْبَعَ الْبَائِعَ
u'تَبِعَ جَانِي':Predicate, #1: 1	تَبِعَ بَيَاضُهُ
u'تَبِعَ خِطَابٌ':Predicate, #1: 1	أَتْبَعَ الْجَانِيَ
u'تَبِعَ خُلْعٌ':Predicate, #1: 1	أَتْبَعَ الْخِطَابَ
u'تَبِعَ زَوْجٌ':Predicate, #1: 1	أَتْبَعَ الْخُلْعَ
u'تَبِعَ شَاةٌ':Predicate, #1: 1	أَتْبَعَ الزَّوْجَ
u'تَبِعَ شافِعِيّ':Predicate, #1: 1	تَبِعَ الشَّاةَ
u'تَبِعَ صَاحِبٌ':Predicate, #2: 2	تَبِعَ الشَّافِعِيَّ
u'تَبِعَ صَاحِبٌ':Predicate, #1: 1	أَتْبَعَ صَاحِبَ
u'تَبِعَ صَاحِبٌ':Subject, #8: 8	تَبِعَ صَاحِبَ
u'تَبِعَ صلح':Predicate, #1: 1	تَبِعَ صَاحِبُ
u'تَبِعَ صُلْحٌ':Predicate, #1: 1	أَتْبَعَ الصُّلْحَ
u'تَبِعَ صَيْدٌ':Predicate, #1: 1	أَتْبَعَ الصُّلْحَ
u'تَبِعَ عَاقِلٌ':Predicate, #2: 2	تَبِعَ الصَّيْدَ
u'تَبِعَ عِبَارَةٌ':Predicate, #1: 1	أَتْبَعَ عَاقِلَةَ
u'تَبِعَ عَبْدٌ':Predicate, #1: 1	تَبِعَ عِبَارَةَ
u'تَبِعَ عَوْرَةٌ':Predicate, #1: 1	تَبِعَ الْعَبْدَ
u'تَبِعَ غَاصِبٌ':Predicate, #1: 1	تَبِعَ عَوْرَةَ
u'تَبِعَ غرماء':Predicate, #1: 1	أَتْبَعَ الْغَاصِبَ
u'تَبِعَ فلان':Predicate, #1: 1	أَتْبَعَ الْغُرَمَاءَ
u'تَبِعَ قَاضِي':Predicate, #2: 2	تَبِعَ الشَّافِعِيَّ
u'تَبِعَ قول':Predicate, #1: 1	تَبِعَ الْقَاضِيَ
u'تَبِعَ قَوْلٌ':Predicate, #1: 1	تَبِعَ قَوْلَ
u'تَبِعَ مُتَأَخِّرٌ':Predicate, #1: 1	تَبِعَ قَوْلَ
u'تَبِعَ مُدَبَّرٌ':Predicate, #1: 1	تَبِعَ الْمُتَأَخِّرِينَ
u'تَبِعَ مُشْتَرِي':Predicate, #1: 1	أَتْبَعَ الْمُدَبَّرَ
u'تَبِعَ مُشْتَرِي':Predicate, #1: 1	أَتْبَعَ الْمُشْتَرِيَ
u'تَبِعَ مُصَنِّفٌ':Subject, #1: 1	تَبِعَ الْمُشْتَرِيَ
u'تَبِعَ مُغْنِي':Predicate, #9: 9	تَبِعَ الْمُصَنِّفُ
u'تَبِعَ وَاطِئٌ':Predicate, #1: 1	تَبِعَ الْمُغْنِيَ
u'تَبِعَ ولد':Subject, #1: 1	أَتْبَعَ الْوَاطِئَ
u'تَبِعَ وَلَدٌ':Subject, #2: 2	تَبِعَ الْوَلَدُ
u'تَبْكِيت مُعْتَرِضٌ':Added, #2: 2	تَبِعَ الْوَلَدُ
u'تَبْلِيغٌ أَحْكَامٌ':Added, #1: 1	تَبْكِيتُ الْمُعْتَرِضِ
u'تَبْلِيغٌ أَحْكَامٌ':Added, #1: 1	تَبْلِيغِ أَحْكَامِ
u'تَبْلِيغٌ أَحْكَامٌ':Added, #1: 1	تَبْلِيغِ الْأَحْكَامِ
u'تَبْلِيغٌ أَمْرٌ':Added, #2: 2	تَبْلِيغُ الْأَحْكَامِ
u'تَبْلِيغٌ اِنْتِقالٌ':Added, #1: 1	تَبْلِيغِ أَمْرِ
u'تَبْلِيغٌ حَقٌّ':Added, #1: 1	تَبْلِيغِ انْتِقَالَاتِ
u'تَبْلِيغٌ حُكْمٌ':Added, #1: 1	تَبْلِيغِ الْحَقِّ
u'تَبْلِيغٌ حُكْمٌ':Added, #1: 1	تَبْلِيغَ الْحُكْمِ
u'تَبْلِيغٌ حُكْمٌ':Added, #1: 1	تَبْلِيغُ الْحُكْمِ
u'تَبْلِيغٌ رِسَالَةٌ':Added, #1: 1	تَبْلِيغِ الْحُكْمِ
u'تَبْلِيغٌ رِسَالَةٌ':Added, #1: 1	تَبْلِيغِ رِسَالاَتِ
u'تَبْلِيغٌ رِسَالَةٌ':Added, #1: 1	تَبْلِيغِ رِسَالَتِهِ
u'تَبْلِيغٌ رِسَالَةٌ':Added, #3: 3	تَبْلِيغُ الرِّسَالَةِ
u'تَبْلِيغٌ صَحَابَةٌ':Added, #6: 6	تَبْلِيغِ الرِّسَالَةِ
u'تَبْلِيغٌ عِبَارَةٌ':Added, #1: 1	تَبْلِيغِ الصَّحَابَةِ
u'تَبْلِيغٌ قُرْآنٌ':Added, #2: 2	تَبْلِيغُ عِبَارَةِ
u'تَبْلِيغٌ قَوْمٌ':Added, #1: 1	تَبْلِيغِ الْقُرْآنِ
u'تَبْلِيغٌ قِيمَةٌ':Added, #1: 1	تَبْلِيغَ الْقَوْمِ
u'تَبْلِيغٌ كِتَابٌ':Added, #1: 1	تَبْلِيغِ قِيمَتِهِ
u'تَبْلِيغٌ كِتَابٌ':Added, #1: 1	تَبْلِيغِ الْكِتَابِ
u'تَبْلِيغٌ كِتَابٌ':Added, #1: 1	تَبْلِيغِ كِتَابِهِ
u'تَبْلِيغٌ مَاءٌ':Added, #2: 2	تَبْلِيغِ كِتَابٍ
u'تَبْلِيغٌ مَاءٌ':Added, #1: 1	تَبْلِيغَ الْمَاءِ
u'تَبْلِيغٌ نَبِيٌّ':Added, #1: 1	تَبْلِيغِ الْمَاءِ
u'تَبْلِيغٌ هَدْيٌ':Added, #1: 1	تَبْلِيغِ النَّبِيِّ
u'تَبَنَّى رَجُلٌ':Predicate, #1: 1	تَبْلِيغِ الْهَدْيِ
u'تَبَنَّى رَسُولٌ':Subject, #2: 2	تَبَنَّى رَجُلاً
u'تَبَنَّى زَيْدٌ':Predicate, #2: 2	تَبَنَّى رَسُولُ
u'تَبَوَّأَ حَديثٌ':Predicate, #2: 2	تَبَنَّى زَيْدَ
u'تَبَوَّأَ دَارٌ':Predicate, #1: 1	تَبَوَّأَ الْحَدِيثَ
u'تَبَيُّنٌ اِتِّساعٌ':Added, #1: 1	تَبَوَّأَ دَارَ
u'تَبَيَّنَ اِتِّصَافٌ':Subject, #1: 1	تَبَيُّنِ اتِّسَاعِهِ
u'تَبَيَّنَ اِسْتِناد':Subject, #1: 1	تَبَيَّنَ اتِّصَافُهُ
u'تَبَيَّنَ اِسْتِهْلاكٌ':Subject, #1: 1	تَبَيَّنَ اسْتِنَادُ
u'تَبَيَّنَ اِطِّلاعٌ':Subject, #1: 1	تَبَيَّنَ اسْتِهْلَاكٌ
u'تَبَيَّنَ أَمْرٌ':Predicate, #1: 1	تَبَيَّنَ اطِّلَاعُ
u'تَبَيَّنَ أَمْرٌ':Subject, #1: 1	تَبَيَّنَ الْأَمْرَ
u'تَبَيَّنَ أَمْرٌ':Subject, #1: 1	تَبَيَّنَ أَمْرُهُ
u'تَبَيَّنَ اِنْتِهاءٌ':Subject, #2: 2	تَبَيَّنَ الْأَمْرُ
u'تَبَيَّنَ اِنْعِدَامٌ':Subject, #1: 1	تَبَيَّنَ انْتِهَاءُ
u'تَبَيَّنَ اِنْفِساخٌ':Subject, #1: 1	تَبَيَّنَ انْعِدَامُ
u'تَبَيَّنَ بَراءةٌ':Subject, #1: 1	تَبَيَّنَ انْفِسَاخُ
u'تَبَيَّنَ بُطْلان':Subject, #3: 3	تَبَيَّنَ بَرَاءَةُ
u'تَبَيَّنَ تَرْجِيحٌ':Subject, #1: 1	تَبَيَّنَ بُطْلَانُهُ
u'تَبَيَّنَ تَفْصِيلٌ':Subject, #1: 1	تَبَيَّنَ التَّرْجِيحُ
u'تَبَيَّنَ تَقَدُّمٌ':Subject, #1: 1	تَبَيَّنَ تَفْصِيلُ
u'تَبَيَّنَ تَنَزُّهٌ':Subject, #3: 3	تَبَيَّنَ تَقَدُّمُ
u'تَبَيَّنَ ثُبُوتٌ':Subject, #1: 1	تَبَيَّنَ تَنَزُّهُهُ
u'تَبَيَّنَ جَازٌ':Predicate, #2: 2	تَبَيَّنَ ثُبُوتُ
u'تَبَيَّنَ حالٌ':Predicate, #1: 1	تَبَيَّنَ جَازَ
u'تَبَيَّنَ حالٌ':Subject, #1: 1	تَبَيَّنَ الْحَالَ
u'تَبَيَّنَ حالٌ':Subject, #1: 1	تَبَيَّنَ حَالُ
u'تَبَيَّنَ حالٌ':Subject, #2: 2	تَبَيَّنَ الْحَالُ
u'تَبَيُّنٌ حالٌ':Added, #2: 2	تَبَيَّنَ حَالُهُ
u'تَبَيَّنَ حَجٌّ':Subject, #3: 3	تَبَيُّنِ الْحَالِ
u'تَبَيَّنَ حَدَثٌ':Subject, #1: 1	تَبَيَّنَ الْحَجُّ
u'تَبَيَّنَ حُدوثٌ':Subject, #1: 1	تَبَيَّنَ حَدَثُهُ
u'تَبَيَّنَ حِسٌّ':Subject, #1: 1	تَبَيَّنَ حُدُوثُهُ
u'تَبَيَّنَ حِصَّةٌ':Predicate, #1: 1	تَبَيَّنَ حِسُّهُ
u'تَبَيَّنَ حَقٌّ':Subject, #1: 1	تَبَيَّنَ حِصَّةَ
u'تَبَيَّنَ حُكْمٌ':Subject, #2: 2	تَبَيَّنَ الْحَقُّ
u'تَبَيَّنَ حمق':Subject, #1: 1	تَبَيَّنَ حُكْمُ
u'تَبَيَّنَ حُمْقٌ':Subject, #1: 1	تَبَيَّنَ حُمْقُهُ
u'تَبَيَّنَ حَمْلٌ':Subject, #1: 1	تَبَيَّنَ حُمْقُهُ
u'تَبَيُّنٌ حَمْلٌ':Added, #1: 1	تَبَيَّنَ الْحَمْلُ
u'تَبَيَّنَ حِنْثٌ':Subject, #1: 1	تَبَيُّنِ الْحَمْلِ
u'تَبَيَّنَ خُرُوجٌ':Subject, #1: 1	تَبَيَّنَ الْحِنْثُ
u'تَبَيَّنَ خَطَأٌ':Predicate, #1: 1	تَبَيَّنَ خُرُوجُ
u'تَبَيَّنَ خَطَأٌ':Predicate, #1: 1	تَبَيَّنَ خَطَأَ
u'تَبَيَّنَ خَطَأٌ':Subject, #3: 3	تَبَيَّنَ الْخَطَأَ
u'تَبَيَّنَ خَطَأٌ':Subject, #3: 3	تَبَيَّنَ خَطَأٌ
u'تَبَيَّنَ خَطَأٌ':Subject, #5: 5	تَبَيَّنَ خَطَأُ
u'تَبَيُّنٌ خَطَأٌ':Added, #8: 8	تَبَيَّنَ الْخَطَأُ
u'تَبَيُّنٌ خَطَأٌ':Added, #1: 1	تَبَيُّن الْخَطَأِ
u'تَبَيَّنَ خِلاَفٌ':Subject, #2: 2	تَبَيُّنِ الْخَطَأِ
u'تَبَيَّنَ خِلاَفٌ':Subject, #2: 2	تَبَيَّنَ خِلَافُ
u'تَبَيَّنَ خلق':Subject, #9: 9	تَبَيَّنَ خِلَافُهُ
u'تَبَيَّنَ خَلْقٌ':Subject, #2: 2	تَبَيَّنَ خَلْقُهُ
u'تَبَيُّنٌ خَيْطٌ':Added, #2: 2	تَبَيَّنَ خَلْقُهُ
u'تَبَيَّنَ دَوامٌ':Subject, #1: 1	تَبَيُّنَ الْخَيْطِ
u'تَبَيَّنَ رُشْدٌ':Subject, #1: 1	تَبَيَّنَ دَوَامُهُ
u'تَبَيَّنَ زِيادَةٌ':Subject, #1: 1	تَبَيَّنَ رُشْدُهُ
u'تَبَيَّنَ سُقُوطٌ':Subject, #1: 1	تَبَيَّنَ زِيَادَةُ
u'تَبَيَّنَ سلام':Subject, #1: 1	تَبَيَّنَ سُقُوطُ
u'تَبَيَّنَ سَلاَمٌ':Subject, #1: 1	تَبَيَّنَ سَلَامُهُ
u'تَبَيَّنَ سَمَاعٌ':Subject, #1: 1	تَبَيَّنَ سَلَامُهُ
u'تَبَيُّنٌ سِمْطٌ':Added, #1: 1	تَبَيَّنَ سَمَاعُهُ
u'تَبَيَّنَ صُبْحٌ':Predicate, #1: 1	تَبَيُّنُ سِمْطِهِ
u'تَبَيَّنَ صُبْحٌ':Subject, #1: 1	تَبَيَّنَ الصُّبْحَ
u'تَبَيَّنَ صِحَّةٌ':Predicate, #1: 1	تَبَيَّنَ الصُّبْحُ
u'تَبَيَّنَ صِحَّةٌ':Subject, #2: 2	تَبَيَّنَ صِحَّةَ
u'تَبَيُّنٌ صِحَّةٌ':Added, #3: 3	تَبَيَّنَ صِحَّةُ
u'تَبَيَّنَ صدق':Subject, #1: 1	تَبَيُّنُ صِحَّةِ
u'تَبَيَّنَ صِدْقٌ':Subject, #2: 2	تَبَيَّنَ صِدْقُهُ
u'تَبَيُّنٌ صِدْقٌ':Added, #2: 2	تَبَيَّنَ صِدْقُهُ
u'تَبَيَّنَ صِفَةٌ':Subject, #1: 1	تَبَيُّنِ صِدْقٍ
u'تَبَيَّنَ ضَرَرٌ':Subject, #1: 1	تَبَيَّنَ صِفَاتُهُ
u'تَبَيُّنٌ ضَرَرٌ':Added, #2: 2	تَبَيَّنَ ضَرَرُهُ
u'تَبَيُّنٌ طَلاَقٌ':Added, #2: 2	تَبَيُّنِ الضَّرَرِ
u'تَبَيُّنٌ طُلُوعٌ':Added, #1: 1	تَبَيُّنِ الطَّلَاقِ
u'تَبَيَّنَ عتق':Subject, #1: 1	تَبَيُّنِ طُلُوعِهِ
u'تَبَيَّنَ عِتْقٌ':Subject, #1: 1	تَبَيَّنَ الْعِتْقُ
u'تَبَيَّنَ عتق':Subject, #1: 1	تَبَيَّنَ الْعِتْقُ
u'تَبَيَّنَ عِتْقٌ':Subject, #2: 2	تَبَيَّنَ عِتْقُهُ
u'تَبَيَّنَ عتق':Subject, #2: 2	تَبَيَّنَ عِتْقُهُ
u'تَبَيَّنَ عِتْقٌ':Subject, #3: 3	تَبَيَّنَ عِتْقُ
u'تَبَيَّنَ عجز':Subject, #3: 3	تَبَيَّنَ عِتْقُ
u'تَبَيَّنَ عَجْزٌ':Subject, #1: 1	تَبَيَّنَ عَجْزُهُ
u'تَبَيَّنَ عَدَمٌ':Predicate, #1: 1	تَبَيَّنَ عَجْزُهُ
u'تَبَيَّنَ عَدَمٌ':Subject, #5: 5	تَبَيَّنَ عَدَمَ
u'تَبَيَّنَ عَدَمٌ':Subject, #10: 10	تَبَيَّنَ عَدَمُ
u'تَبَيُّنٌ عَدَمٌ':Added, #4: 4	تَبَيَّنَ عَدَمُهُ
u'تَبَيَّنَ عُسْرَةٌ':Subject, #2: 2	تَبَيُّنِ عَدَمِ
u'تَبَيَّنَ عناد':Subject, #1: 1	تَبَيَّنَ عُسْرَتُهُ
u'تَبَيَّنَ عِنَادٌ':Subject, #1: 1	تَبَيَّنَ عِنَادُهُ
u'تَبَيَّنَ غَيٌّ':Subject, #1: 1	تَبَيَّنَ عِنَادُهُ
u'تَبَيَّنَ فراغ':Subject, #1: 1	تَبَيَّنَ غَيُّهُ
u'تَبَيَّنَ فَرَاغٌ':Subject, #1: 1	تَبَيَّنَ فَرَاغُ
u'تَبَيُّنٌ فراغ':Added, #1: 1	تَبَيَّنَ فَرَاغُ
u'تَبَيُّنٌ فَرَاغٌ':Added, #1: 1	تَبَيُّنَ فَرَاغِ
u'تَبَيُّنٌ فراغ':Added, #1: 1	تَبَيُّنَ فَرَاغِ
u'تَبَيُّنٌ فَرَاغٌ':Added, #2: 2	تَبَيُّنِ فَرَاغِ
u'تَبَيُّنٌ فراغ':Added, #2: 2	تَبَيُّنِ فَرَاغِ
u'تَبَيُّنٌ فَرَاغٌ':Added, #6: 6	تَبَيُّنُ فَرَاغِ
u'تَبَيَّنَ فرق':Subject, #6: 6	تَبَيُّنُ فَرَاغِ
u'تَبَيَّنَ فَرْقٌ':Subject, #1: 1	تَبَيَّنَ الْفَرْقُ
u'تَبَيَّنَ فساد':Subject, #1: 1	تَبَيَّنَ الْفَرْقُ
u'تَبَيَّنَ فَسَادٌ':Subject, #4: 4	تَبَيَّنَ فَسَادُهُ
u'تَبَيَّنَ فساد':Subject, #4: 4	تَبَيَّنَ فَسَادُهُ
u'تَبَيَّنَ فَسَادٌ':Subject, #8: 8	تَبَيَّنَ فَسَادُ
u'تَبَيُّنٌ فساد':Added, #8: 8	تَبَيَّنَ فَسَادُ
u'تَبَيُّنٌ فَسَادٌ':Added, #4: 4	تَبَيُّنِ فَسَادِ
u'تَبَيَّنَ فَسْخٌ':Subject, #4: 4	تَبَيُّنِ فَسَادِ
u'تَبَيُّنٌ فِسْقٌ':Added, #1: 1	تَبَيَّنَ الْفَسْخُ
u'تَبَيُّنٌ فِسْقٌ':Added, #1: 1	تَبَيُّنِ الْفِسْقِ
u'تَبَيُّنٌ فِسْقٌ':Added, #1: 1	تَبَيُّنَ فِسْقِ
u'تَبَيُّنٌ فِسْقٌ':Added, #1: 1	تَبَيُّنُ فِسْقِ
u'تَبَيَّنَ فَضْلٌ':Subject, #1: 1	تَبَيُّنِ فِسْقِ
u'تَبَيُّنٌ فَضْلٌ':Added, #1: 1	تَبَيَّنَ الْفَضْلُ
u'تَبَيَّنَ قُرْبٌ':Subject, #1: 1	تَبَيُّنِ الْفَضْلِ
u'تَبَيَّنَ قَصْدٌ':Subject, #1: 1	تَبَيَّنَ قُرْبُهُ
u'تَبَيَّنَ قِلَّةٌ':Subject, #1: 1	تَبَيَّنَ قَصْدُهُ
u'تَبَيَّنَ كذب':Subject, #2: 2	تَبَيَّنَ قِلَّةُ
u'تَبَيَّنَ كَذِبٌ':Subject, #5: 5	تَبَيَّنَ كَذِبُهُ
u'تَبَيَّنَ كفر':Predicate, #5: 5	تَبَيَّنَ كَذِبُهُ
u'تَبَيَّنَ كُفْرٌ':Predicate, #1: 1	تَبَيَّنَ الْكُفْرَ
u'تَبَيُّنٌ كفر':Added, #1: 1	تَبَيَّنَ الْكُفْرَ
u'تَبَيُّنٌ كُفْرٌ':Added, #1: 1	تَبَيُّنِ الْكُفْرِ
u'تَبَيَّنَ كَلاَمٌ':Subject, #1: 1	تَبَيُّنِ الْكُفْرِ
u'تَبَيَّنَ كَوْنٌ':Subject, #3: 3	تَبَيَّنَ الْكَلَامُ
u'تَبَيَّنَ كَوْنٌ':Subject, #11: 11	تَبَيَّنَ كَوْنُهُ
u'تَبَيُّنٌ كَوْنٌ':Added, #3: 3	تَبَيَّنَ كَوْنُ
u'تَبَيَّنَ لدد':Subject, #1: 1	تَبَيُّنِ كَوْنِهِ
u'تَبَيَّنَ لَدَدٌ':Subject, #2: 2	تَبَيَّنَ لَدَدُهُ
u'تَبَيَّنَ لَيْلٌ':Subject, #2: 2	تَبَيَّنَ لَدَدُهُ
u'تَبَيَّنَ مَانِعٌ':Subject, #2: 2	تَبَيَّنَ اللَّيْلُ
u'تَبَيَّنَ مَانِعٌ':Subject, #1: 1	تَبَيَّنَ الْمَانِعُ
u'تَبَيُّنٌ مراد':Added, #1: 1	تَبَيَّنَ مَانِعٌ
u'تَبَيُّنٌ مراد':Added, #1: 1	تَبَيُّنَ الْمُرَادِ
u'تَبَيُّنٌ مُرَادٌ':Added, #1: 1	تَبَيُّنِ الْمُرَادِ
u'تَبَيُّنٌ مُرَادٌ':Added, #1: 1	تَبَيُّنَ الْمُرَادِ
u'تَبَيُّنٌ مراد':Added, #1: 1	تَبَيُّنِ الْمُرَادِ
u'تَبَيُّنٌ مُرَادٌ':Added, #1: 1	تَبَيُّنِ مُرَادِ
u'تَبَيُّنٌ مِلْكٌ':Added, #1: 1	تَبَيُّنِ مُرَادِ
u'تَبَيَّنَ مَوْتٌ':Subject, #1: 1	تَبَيُّنِ الْمِلْكِ
u'تَبَيَّنَ نَصٌّ':Subject, #1: 1	تَبَيَّنَ مَوْتُهُ
u'تَبَيَّنَ نَصِيبٌ':Subject, #1: 1	تَبَيَّنَ نَصٌّ
u'تَبَيَّنَ نَفْيٌ':Subject, #1: 1	تَبَيَّنَ نَصِيبُ
u'تَبَيَّنَ وَجْهٌ':Subject, #1: 1	تَبَيَّنَ نَفْيُهُ
u'تَبَيَّنَ وَجْهٌ':Subject, #1: 1	تَبَيَّنَ وَجْهُ
u'تَبَيَّنَ وُجُوبٌ':Subject, #1: 1	تَبَيَّنَ وَجْهُهُ
u'تَبَيَّنَ وُجُودٌ':Subject, #1: 1	تَبَيَّنَ وُجُوبُهُ
u'تَبَيُّنٌ وَقْفٌ':Added, #1: 1	تَبَيَّنَ وُجُودُ
u'تَبَيَّنَ وُقُوعٌ':Predicate, #1: 1	تَبَيُّنِ الْوَقْفِ
u'تَبَيَّنَ وُقُوعٌ':Subject, #1: 1	تَبَيَّنَ وُقُوعَ
u'تَبَيَّنَ وُقُوعٌ':Subject, #1: 1	تَبَيَّنَ وُقُوعُ
u'تَبَيَّنَ وَلاَءٌ':Subject, #5: 5	تَبَيَّنَ وُقُوعُهُ
u'تَتَابُعٌ اِعْتِكافٌ':Added, #1: 1	تَبَيَّنَ الْوَلَاءُ
u'تَتَابُعٌ أَغْيارٌ':Added, #1: 1	تَتَابُعُ اعْتِكَافِهِ
u'تَتَابُعٌ حَرَكَةٌ':Added, #1: 1	تَتَابُعِ الْأَغْيَارِ
u'تَتَابَعَ خَبَرٌ':Subject, #1: 1	تَتَابُعُ حَرَكَةِ
u'تَتَابَعَ خَبَر':Subject, #1: 1	تَتَابَعَ خَبَرُهُ
u'تَتَابُعٌ سَنَةٌ':Added, #1: 1	تَتَابَعَ خَبَرُهُ
u'تَتَابُعٌ سَنَةٌ':Added, #1: 1	تَتَابُعَ السَّنَةِ
u'تَتَابُعٌ صَلاَةٌ':Added, #1: 1	تَتَابُعُ سَنَةٍ
u'تَتَابَعَ صَوْمٌ':Subject, #1: 1	تَتَابُعَ الصَّلَاةِ
u'تَتَابُعٌ صَوْمٌ':Added, #1: 1	تَتَابَعَ الصَّوْمُ
u'تَتَابُعٌ صَوْمٌ':Added, #1: 1	تَتَابُعِ الصَّوْمِ
u'تَتَابُعٌ صَوْمٌ':Added, #1: 1	تَتَابُعَ صَوْمِ
u'تَتَابُعٌ صَوْمٌ':Added, #1: 1	تَتَابُعُ صَوْمٍ
u'تَتَابُعٌ صَوْمٌ':Added, #1: 1	تَتَابُعُ صَوْمِ
u'تَتَابُعٌ صِيَامٌ':Added, #2: 2	تَتَابُعُ الصَّوْمِ
u'تَتَابَعَ طَيِّبٌ':Subject, #1: 1	تَتَابُعِ الصِّيَامِ
u'تَتَابُعٌ مَشْيٌ':Added, #1: 1	تَتَابَعَ طَيِّبُ
u'تَتَابُعٌ مَشْيٌ':Added, #1: 1	تَتَابُعِ الْمَشْيِ
u'تَتَابُعٌ مَصَائِبُ':Added, #4: 4	تَتَابُعُ الْمَشْيِ
u'تَتَابُعٌ مَصَائِبُ':Added, #1: 1	تَتَابُعَ الْمَصَائِبِ
u'تَتَابُعٌ مُكْرَهٌ':Added, #1: 1	تَتَابُعُ الْمَصَائِبِ
u'تَتَابَعَ نَاسٌ':Subject, #2: 2	تَتَابُعُ الْمُكْرَهِ
u'تَتَابُعٌ نذر':Added, #7: 7	تَتَابَعَ النَّاسُ
u'تَتَابُعٌ نَذْرٌ':Added, #1: 1	تَتَابُعِ نَذْرِ
u'تَتَابَعَ وَحْيٌ':Subject, #1: 1	تَتَابُعِ نَذْرِ
u'تَتَبَّعَ آثَارٌ':Predicate, #1: 1	تَتَابَعَ الْوَحْيُ
u'تَتَبَّعَ آثَارٌ':Predicate, #1: 1	تَتَبَّعَ الآثَارَ
u'تَتَبَّعَ أَحادِيثُ':Predicate, #1: 1	تَتَبَّعَ الْآثَارَ
u'تَتَبُّعٌ أَحْكَامٌ':Added, #2: 2	تَتَبَّعَ الْأَحَادِيثَ
u'تَتَبُّعٌ أَحْوالٌ':Added, #1: 1	تَتَبُّعِ أَحْكَامِهِ
u'تَتَبُّعٌ أحْوَالٌ':Added, #1: 1	تَتَبُّعِ أَحْوَالِهِ
u'تَتَبُّعٌ أسْبَابٌ':Added, #1: 1	تَتَبُّعِ أَحْوَالِهِ
u'تَتَبُّعٌ أَسْبَابٌ':Added, #1: 1	تَتَبُّعِ الْأَسْبَابِ
u'تَتَبَّعَ أَفْعَالٌ':Predicate, #1: 1	تَتَبُّعِ الْأَسْبَابِ
u'تَتَبُّعٌ أَلْفَاظٌ':Added, #1: 1	تَتَبَّعَ أَفْعَالَ
u'تَتَبُّعٌ أَمَاكِنُ':Added, #1: 1	تَتَبُّعُ أَلْفَاظِ
u'تَتَبُّعٌ بَوَاطِنُ':Added, #1: 1	تَتَبُّعِ أَمَاكِنِ
u'تَتَبُّعٌ تخاريج':Added, #1: 1	تَتَبُّعُ الْبَوَاطِنِ
u'تَتَبُّعٌ جُزْئِيٌّ':Added, #1: 1	تَتَبُّعِ تَخَارِيجِهِ
u'تَتَبُّعٌ جُزْئِيَّةٌ':Added, #1: 1	تَتَبُّعِ الْجُزْئِيَّاتِ
u'تَتَبُّعٌ حَقٌّ':Added, #1: 1	تَتَبُّعِ الْجُزْئِيَّاتِ
u'تَتَبُّعٌ حقائق':Added, #1: 1	تَتَبُّعُ الْحَقِّ
u'تَتَبُّعٌ حَقَائِقُ':Added, #1: 1	تَتَبُّعُ الْحَقَائِقِ
u'تَتَبُّعٌ حِيَلٌ':Added, #1: 1	تَتَبُّعُ الْحَقَائِقِ
u'تَتَبُّعٌ دَمٌ':Added, #1: 1	تَتَبُّعِ الْحِيَلِ
u'تَتَبَّعَ رُخَصٌ':Predicate, #1: 1	تَتَبُّعِ الدَّمِ
u'تَتَبُّعٌ رُخَصٌ':Added, #1: 1	تَتَبَّعَ الرُّخَصَ
u'تَتَبُّعٌ رُخَصٌ':Added, #3: 3	تَتَبُّعُ الرُّخَصِ
u'تَتَبَّعَ سِيَرٌ':Predicate, #5: 5	تَتَبُّعِ الرُّخَصِ
u'تَتَبَّعَ شافِعِيّ':Subject, #1: 1	تَتَبَّعَ السِّيَرَ
u'تَتَبُّعٌ طُرُقٌ':Added, #1: 1	تَتَبَّعَ الشَّافِعِيُّ
u'تَتَبُّعٌ ظَواهِرُ':Added, #1: 1	تَتَبُّعِ الطُّرُقِ
u'تَتَبَّعَ عَثْرَةٌ':Predicate, #1: 1	تَتَبُّعُ الظَّوَاهِرِ
u'تَتَبُّعٌ عُقَدٌ':Added, #1: 1	تَتَبَّعَ عَثْرَةَ
u'تَتَبُّعٌ عُقُودٌ':Added, #1: 1	تَتَبُّعُ عُقَدِ
u'تَتَبُّعٌ عَوْرَةٌ':Added, #1: 1	تَتَبُّعِ الْعُقُودِ
u'تَتَبُّعٌ عُيُوبٌ':Added, #1: 1	تَتَبُّعِ عَوْرَاتِ
u'تَتَبُّعٌ غُضُونٌ':Added, #1: 1	تَتَبُّعُ عُيُوبِ
u'تَتَبَّعَ فلان':Subject, #1: 1	تَتَبُّعُ غُضُونِهِ
u'تَتَبُّعٌ قَضَاءٌ':Added, #1: 1	تَتَبَّعَ الشَّافِعِيُّ
u'تَتَبَّعَ كَلاَمٌ':Predicate, #1: 1	تَتَبُّعُ قَضَاءِ
u'تَتَبُّعٌ كَلاَمٌ':Added, #2: 2	تَتَبَّعَ كَلَامَ
u'تَتَبُّعٌ مَصَالِحُ':Added, #3: 3	تَتَبُّعِ كَلَامِ
u'تَتَبُّعٌ موارد':Added, #1: 1	تَتَبُّعَ الْمَصَالِحِ
u'تَتَبُّعٌ مَوَارِدُ':Added, #1: 1	تَتَبُّعِ مَوَارِدِ
u'تَتَبُّعٌ وَقَائِعُ':Added, #1: 1	تَتَبُّعِ مَوَارِدِ
u'تَثَاءَبَ ضحك':Predicate, #1: 1	تَتَبُّعُ الْوَقَائِعِ
u'تَثَاءَبَ ضَحِكٌ':Predicate, #2: 2	تَثَاءَبَ ضَحِكَ
u'تَثَبُّتٌ حُرْمَةٌ':Added, #2: 2	تَثَاءَبَ ضَحِكَ
u'تَثَبُّتٌ خَبَرٌ':Added, #2: 2	تَثَبُّتِ الْحُرْمَةِ
u'تَثَبُّتٌ خَبَر':Added, #1: 1	تَثَبُّتِ خَبَرِ
u'تَثَبَّتَ رَسُولٌ':Subject, #1: 1	تَثَبُّتِ خَبَرِ
u'تَثَبُّتٌ سَبَبِيَّةٌ':Added, #1: 1	تَثَبَّتَ رَسُولُ
u'تَثْلِيثٌ باء':Added, #1: 1	تَثَبُّتِ السَّبَبِيَّةِ
u'تَثْلِيثٌ تَكْبيرٌ':Added, #1: 1	تَثْلِيثِ الْبَاءِ
u'تَثْلِيثٌ خُفٌّ':Added, #2: 2	تَثْلِيثَ التَّكْبِيرِ
u'تَثْلِيثٌ رَأْسٌ':Added, #1: 1	تَثْلِيثُ الْخُفِّ
u'تَثْلِيثٌ غَسْلٌ':Added, #1: 1	تَثْلِيثُ الرَّأْسِ
u'تَثْلِيثٌ قسمة':Added, #1: 1	تَثْلِيثِ الْغَسْلِ
u'تَثْلِيثٌ قِسْمَةٌ':Added, #1: 1	تَثْلِيثُ الْقِسْمَةِ
u'تَثْلِيثٌ مَسْحٌ':Added, #1: 1	تَثْلِيثُ الْقِسْمَةِ
u'تَثْلِيثٌ مَسْحٌ':Added, #2: 2	تَثْلِيثُ الْمَسْحِ
u'تَثْلِيثٌ مَسْحٌ':Added, #2: 2	تَثْلِيثِ الْمَسْحِ
u'تَثْلِيثٌ مَغْسُولٌ':Added, #2: 2	تَثْلِيثِ مَسْحِ
u'تَثْلِيثٌ همزة':Added, #2: 2	تَثْلِيثُ مَغْسُولٍ
u'تَثْلِيثٌ همزة':Added, #1: 1	تَثْلِيثُ الْهَمْزَةِ
u'تَثْلِيثٌ هَمْزَةٌ':Added, #1: 1	تَثْلِيثِ الْهَمْزَةِ
u'تَثْلِيثٌ هَمْزَةٌ':Added, #1: 1	تَثْلِيثُ الْهَمْزَةِ
u'تَثْلِيثٌ وَجْهٌ':Added, #1: 1	تَثْلِيثِ الْهَمْزَةِ
u'تَثْلِيثٌ وُضُوءٌ':Added, #1: 1	تَثْلِيثِ الْوَجْهِ
u'تَثْلِيثٌ وُضُوءٌ':Added, #1: 1	تَثْلِيثُ الْوُضُوءِ
u'تَثْنِيَةٌ أَجْنَادٌ':Added, #1: 1	تَثْلِيثِ الْوُضُوءِ
u'تَثْنِيَةٌ أَذَانٌ':Added, #1: 1	تَثْنِيَةُ أَجْنَادٍ
u'تَثْنِيَةٌ أَذَانٌ':Added, #1: 1	تَثْنِيَةَ الأَذَانِ
u'تَثْنِيَةٌ أَذَانٌ':Added, #1: 1	تَثْنِيَةُ الأَذَانِ
u'تَثْنِيَةٌ إقامَةٌ':Added, #2: 2	تَثْنِيَةِ الأَذَانِ
u'تَثْنِيَةٌ إقامَةٌ':Added, #1: 1	تَثْنِيَةُ الإِقَامَةِ
u'تَثْنِيَةٌ إقامَةٌ':Added, #2: 2	تَثْنِيَةِ الإِقَامَةِ
u'تَثْنِيَةٌ بُقْعَةٌ':Added, #2: 2	تَثْنِيَةِ الْإِقَامَةِ
u'تَثْنِيَةٌ جِنْسٌ':Added, #1: 1	تَثْنِيَةِ الْبُقْعَةِ
u'تَثْنِيَةٌ خُرْبَةٌ':Added, #1: 1	تَثْنِيَةَ الْجِنْسَيْنِ
u'تَثْنِيَةٌ خَرَزَةٌ':Added, #1: 1	تَثْنِيَةُ خُرْبَةٍ
u'تَثْنِيَةٌ خَصَفَةٌ':Added, #2: 2	تَثْنِيَةُ خَرَزَةٍ
u'تَثْنِيَةٌ زَكاةٌ':Added, #2: 2	تَثْنِيَةُ خَصَفَةٍ
u'تَثْنِيَةٌ شَمْسٌ':Added, #1: 1	تَثْنِيَةُ الزَّكَاةِ
u'تَثْنِيَةٌ شَيْءٌ':Added, #1: 1	تَثْنِيَةُ شَمْسٍ
u'تَثْنِيَةٌ صُدْغٌ':Added, #1: 1	تَثْنِيَةِ الشَّيْءِ
u'تَثْنِيَةٌ صدقة':Added, #1: 1	تَثْنِيَةُ صُدْغٍ
u'تَثْنِيَةٌ صَدَقَةٌ':Added, #1: 1	تَثْنِيَةُ الصَّدَقَةِ
u'تَثْنِيَةٌ صِفَةٌ':Added, #1: 1	تَثْنِيَةُ الصَّدَقَةِ
u'تَثْنِيَةٌ ضَمِيرٌ':Added, #1: 1	تَثْنِيَةِ الصِّفَةِ
u'تَثْنِيَةٌ عَاصِبٌ':Added, #1: 1	تَثْنِيَةِ الضَّمِيرِ
u'تَثْنِيَةٌ عَضُدٌ':Added, #1: 1	تَثْنِيَةُ عَاصِبٍ
u'تَثْنِيَةٌ عَقْدٌ':Added, #1: 1	تَثْنِيَةُ عَضُدٍ
u'تَثْنِيَةٌ قول':Added, #1: 1	تَثْنِيَةُ الْعَقْدِ
u'تَثْنِيَةٌ قَوْلٌ':Added, #1: 1	تَثْنِيَةِ قَوْلِهِ
u'تَثْنِيَةٌ كَفْءٌ':Added, #1: 1	تَثْنِيَةِ قَوْلِهِ
u'تَثْنِيَةٌ لاب':Added, #1: 1	تَثْنِيَةُ كَفْءٍ
u'تَثْنِيَةٌ مِرْفَقٌ':Added, #1: 1	تَثْنِيَةُ لَابَةٍ
u'تَثْنِيَةٌ مَنْكِبٌ':Added, #1: 1	تَثْنِيَةُ مِرْفَقٍ
u'تَثْنِيَةٌ يَدٌ':Added, #1: 1	تَثْنِيَةُ مَنْكِبٍ
u'تَثْنِيَةٌ يَمِينٌ':Added, #1: 1	تَثْنِيَةُ يَدِهِ
u'تَثْنِيَةٌ يَمِينٌ':Added, #1: 1	تَثْنِيَةُ يَمِينٍ
u'تَجَاذُبٌ خُصُومٌ':Added, #3: 3	تَثْنِيَةِ الْيَمِينِ
u'تَجَاذُبٌ مُتَعارِض':Added, #2: 2	تَجَاذُبِ الْخُصُومِ
u'تَجَاذَبَ مَسْأَلَةٌ':Subject, #1: 1	تَجَاذُبِ مُتَعَارِضَيْنِ
u'تَجَاذَبَ مُوجِبٌ':Subject, #1: 1	تَجَاذَبَ الْمَسْأَلَةُ
u'تِجَارَةٌ أَميرٌ':Added, #1: 1	تَجَاذَبَ مُوجِبُ
u'تِجَارَةٌ أَميرٌ':Added, #1: 1	تِجَارَةَ الأَمِيرِ
u'تِجَارَةٌ خَاصَّةٌ':Added, #1: 1	تِجَارَةُ الْأَمِيرِ
u'تِجَارَةٌ ذِمِّيٌّ':Added, #2: 2	تِجَارَةٍ خَاصَّةٍ
u'تِجَارَةٌ عَبْدٌ':Added, #1: 1	تِجَارَةِ ذِمِّيٍّ
u'تِجَارَةٌ قُرَيْشٌ':Added, #3: 3	تِجَارَةِ الْعَبْدِ
u'تِجَارَةٌ وُلاَةٌ':Added, #2: 2	تِجَارَةِ قُرَيْشٍ
u'تَجَاسَرَ أحَدٌ':Subject, #1: 1	تِجَارَةُ الْوُلَاةِ
u'تَجَافِي بَطْنٌ':Added, #1: 1	تَجَاسَرَ أَحَدٌ
u'تَجَالَسَ قَوْمٌ':Subject, #1: 1	تَجَافِي الْبَطْنِ
u'تَجَاهَرَ نَاسٌ':Subject, #1: 1	تَجَالَسَ قَوْمٌ
u'تَجَاهُلٌ ثَمَنٌ':Added, #1: 1	تَجَاهَرَ النَّاسُ
u'تَجَاهَلَ جَمِيع':Subject, #1: 1	تَجَاهُلُ الثَّمَنِ
u'تَجَاهُلٌ عَارِفٌ':Added, #1: 1	تَجَاهَلَ الْجَمِيعُ
u'تَجَاوَزَ إمَامٌ':Subject, #1: 1	تَجَاهُلُ الْعَارِفِ
u'تَجَاوُزٌ بَارِدٌ':Added, #1: 1	تَجَاوَزَ الْإِمَامُ
u'تَجَاوَزَ حَدٌّ':Predicate, #1: 1	تَجَاوُزُ بَارِدٍ
u'تَجَاوُزٌ حَدٌّ':Added, #1: 1	تَجَاوَزَ الْحَدَّ
u'تَجَاوَزَ دَمٌ':Subject, #2: 2	تَجَاوُزُ الْحَدِّ
u'تَجَاوَزَ ضَمِنٌ':Predicate, #1: 1	تَجَاوَزَ الدَّمُ
u'تَجَاوَزَ عَشْرٌ':Predicate, #1: 1	تَجَاوَزَ ضَمِنَ
u'تَجَاوَزَ فَرْجٌ':Predicate, #1: 1	تَجَاوَزَ عَشْرَ
u'تَجَاوَزَ قَدْرٌ':Predicate, #1: 1	تَجَاوَزَ الْفَرْجَ
u'تَجَاوَزَ قِيمَةٌ':Subject, #2: 2	تَجَاوَزَ قَدْرَ
u'تَجَاوُزٌ مَأْمُورٌ':Added, #1: 1	تَجَاوَزَ قِيمَتُهُ
u'تَجَاوَزَ مُحْرِمٌ':Subject, #1: 1	تَجَاوُزُ الْمَأْمُورِ
u'تَجَاوُزٌ مَسَافَةٌ':Added, #1: 1	تَجَاوَزَ الْمُحْرِمُ
u'تَجَاوَزَ مِقْدَارٌ':Predicate, #1: 1	تَجَاوُزِ الْمَسَافَةِ
u'تَجَاوَزَ مَوْضِعٌ':Predicate, #1: 1	تَجَاوَزَ مِقْدَارَ
u'تَجَاوَزَ مِيقَاتٌ':Predicate, #3: 3	تَجَاوَزَ الْمَوْضِعَ
u'تَجَاوُزٌ مِيقَاتٌ':Added, #2: 2	تَجَاوَزَ الْمِيقَاتَ
u'تَجَاوَزَ نَاقِصٌ':Subject, #1: 1	تَجَاوُزُ الْمِيقَاتِ
u'تَجَاوَزَ واحد':Subject, #1: 1	تَجَاوَزَ النَّاقِصُ
u'تَجَاوَزَ وَاحِدٌ':Subject, #1: 1	تَجَاوَزَ الْوَاحِدُ
u'تَجَبَّنَ لبن':Subject, #1: 1	تَجَاوَزَ الْوَاحِدُ
u'تَجَبَّنَ لَبَنٌ':Subject, #1: 1	تَجَبَّنَ لَبَنُ
u'تَجَدُّدٌ اِحْتِيَاجٌ':Added, #1: 1	تَجَبَّنَ لَبَنُ
u'تَجَدَّدَ اِسْتِحْقَاقٌ':Subject, #1: 1	تَجَدُّدُ احْتِيَاجِهِ
u'تَجَدُّدٌ إِسْلامٌ':Added, #1: 1	تَجَدَّدَ اسْتِحْقَاقُهُ
u'تَجَدُّدٌ إِسْلامٌ':Added, #1: 1	تَجَدُّدُ إسْلَامٍ
u'تَجَدَّدَ أفْضَلُ':Subject, #1: 1	تَجَدُّدَ الْإِسْلَامِ
u'تَجَدُّدٌ أفْضَلِيَّةٌ':Added, #1: 1	تَجَدَّدَ أَفْضَلُ
u'تَجَدُّدٌ أمثال':Added, #1: 1	تَجَدُّدَ الْأَفْضَلِيَّةِ
u'تَجَدُّدٌ أَمْثَالٌ':Added, #1: 1	تَجَدُّدُ الْأَمْثَالِ
u'تَجَدُّدٌ أمثال':Added, #1: 1	تَجَدُّدُ الْأَمْثَالِ
u'تَجَدُّدٌ أَمْثَالٌ':Added, #1: 1	تَجَدُّدُ أَمْثَالِهِ
u'تَجَدُّدٌ أَمْرٌ':Added, #1: 1	تَجَدُّدُ أَمْثَالِهِ
u'تَجَدُّدٌ أيَّامٌ':Added, #1: 1	تَجَدُّدِ أَمْرٍ
u'تَجَدُّدٌ أيَّامٌ':Added, #1: 1	تَجَدُّدَ الْأَيَّامِ
u'تَجَدُّدٌ أَيَّامٌ':Added, #1: 1	تَجَدُّدُ الْأَيَّامِ
u'تَجَدُّدٌ أَيَّامٌ':Added, #1: 1	تَجَدُّدَ الْأَيَّامِ
u'تَجَدُّدٌ تَحْرِيمٌ':Added, #1: 1	تَجَدُّدُ الْأَيَّامِ
u'تَجَدُّدٌ حاجَةٌ':Added, #1: 1	تَجَدُّدُ تَحْرِيمٍ
u'تَجَدُّدٌ حاجَةٌ':Added, #1: 1	تَجَدُّدَ الْحَاجَةِ
u'تَجَدُّدٌ حاجَةٌ':Added, #1: 1	تَجَدُّدُ الْحَاجَةِ
u'تَجَدُّدٌ حُرْمَةٌ':Added, #4: 4	تَجَدُّدِ الْحَاجَةِ
u'تَجَدَّدَ حَظٌّ':Subject, #1: 1	تَجَدُّدِ حُرْمَةِ
u'تَجَدَّدَ حَقٌّ':Subject, #1: 1	تَجَدَّدَ الْحَظُّ
u'تَجَدُّدٌ حَقٌّ':Added, #1: 1	تَجَدَّدَ حَقُّ
u'تَجَدُّدٌ حَقٌّ':Added, #1: 1	تَجَدُّدَ حَقِّ
u'تَجَدُّدٌ حَقٌّ':Added, #1: 1	تَجَدُّدُ حَقِّ
u'تَجَدُّدٌ حِلٌّ':Added, #1: 1	تَجَدُّدِ حَقِّهِ
u'تَجَدُّدٌ حول':Added, #1: 1	تَجَدُّدِ الْحِلِّ
u'تَجَدُّدٌ حَوْلٌ':Added, #1: 1	تَجَدُّدِ الْحَوْلِ
u'تَجَدُّدٌ حَيْضٌ':Added, #1: 1	تَجَدُّدِ الْحَوْلِ
u'تَجَدَّدَ خُشُوعٌ':Subject, #1: 1	تَجَدُّدُ الْحَيْضِ
u'تَجَدَّدَ خيار':Subject, #1: 1	تَجَدَّدَ خُشُوعُهُ
u'تَجَدَّدَ خِيَارٌ':Subject, #1: 1	تَجَدَّدَ الْخِيَارُ
u'تَجَدُّدٌ دَوْرٌ':Added, #1: 1	تَجَدَّدَ الْخِيَارُ
u'تَجَدُّدٌ رَغْبَةٌ':Added, #1: 1	تَجَدُّدَ الدَّوْرِ
u'تَجَدُّدٌ زَمانٌ':Added, #8: 8	تَجَدُّدِ الرَّغْبَةِ
u'تَجَدُّدٌ زَمانٌ':Added, #1: 1	تَجَدُّدُ زَمَانِ
u'تَجَدُّدٌ سَبَبٌ':Added, #2: 2	تَجَدُّدِ الزَّمَانِ
u'تَجَدُّدٌ سَبَبٌ':Added, #1: 1	تَجَدُّدَ السَّبَبِ
u'تَجَدُّدٌ شَرْعٌ':Added, #2: 2	تَجَدُّدِ السَّبَبِ
u'تَجَدُّدٌ صَوْمٌ':Added, #1: 1	تَجَدُّدُ شَرْعٍ
u'تَجَدُّدٌ ضَرَرٌ':Added, #1: 1	تَجَدُّدِ الصَّوْمِ
u'تَجَدُّدٌ طَهَارَةٌ':Added, #1: 1	تَجَدُّدِ ضَرَرٍ
u'تَجَدُّدٌ طهر':Added, #1: 1	تَجَدُّدُ الطَّهَارَةِ
u'تَجَدُّدٌ طُهْرٌ':Added, #1: 1	تَجَدُّدُ الطُّهْرِ
u'تَجَدَّدَ ظهار':Subject, #1: 1	تَجَدُّدُ الطُّهْرِ
u'تَجَدُّدٌ عَقْدٌ':Added, #1: 1	تَجَدَّدَ الظِّهَارُ
u'تَجَدُّدٌ عَقْدٌ':Added, #1: 1	تَجَدُّدِ الْعَقْدِ
u'تَجَدُّدٌ عَيْبٌ':Added, #1: 1	تَجَدُّدُ عَقْدِ
u'تَجَدُّدٌ عَيْنٌ':Added, #1: 1	تَجَدُّدِ الْعَيْبِ
u'تَجَدُّدٌ عَيْن':Added, #1: 1	تَجَدُّدُ عَيْنٍ
u'تَجَدَّدَ فِسْقٌ':Subject, #1: 1	تَجَدُّدُ عَيْنٍ
u'تَجَدُّدٌ قَطِيعٌ':Added, #1: 1	تَجَدَّدَ فِسْقُهُ
u'تَجَدُّدٌ قَطِيعَةٌ':Added, #1: 1	تَجَدُّدُ الْقَطِيعَةِ
u'تَجَدَّدَ مَالٌ':Subject, #1: 1	تَجَدُّدُ الْقَطِيعَةِ
u'تَجَدَّدَ مُسْتَحِقٌّ':Subject, #1: 1	تَجَدَّدَ مَالٌ
u'تَجَدُّدٌ مُسْتَحِقٌّ':Added, #1: 1	تَجَدَّدَ مُسْتَحِقٌّ
u'تَجَدَّدَ مُشْكِلٌ':Subject, #1: 1	تَجَدُّدَ الْمُسْتَحِقِّ
u'تَجَدَّدَ مِلْكٌ':Subject, #1: 1	تَجَدَّدَ مُشْكِلٌ
u'تَجَدَّدَ مِلْكٌ':Subject, #2: 2	تَجَدَّدَ الْمِلْكُ
u'تَجَدُّدٌ مِلْكٌ':Added, #7: 7	تَجَدَّدَ مِلْكُهُ
u'تَجَدُّدٌ مِلْكٌ':Added, #1: 1	تَجَدُّدُ الْمِلْكِ
u'تَجَدُّدٌ مِلْكٌ':Added, #3: 3	تَجَدُّدَ الْمِلْكِ
u'تَجَدُّدٌ نِعَمٌ':Added, #3: 3	تَجَدُّدِ الْمِلْكِ
u'تَجَدُّدٌ نِعَمٌ':Added, #1: 1	تَجَدُّدِ النِّعَمِ
u'تَجَدُّدٌ نعمة':Added, #1: 1	تَجَدُّدِ نِعَمِ
u'تَجَدُّدٌ نِعْمَةٌ':Added, #4: 4	تَجَدُّدِ نِعْمَةٍ
u'تَجَدُّدٌ نُمُوٌّ':Added, #4: 4	تَجَدُّدِ نِعْمَةٍ
u'تَجَدُّدٌ وُجُوبٌ':Added, #1: 1	تَجَدُّدِ النُّمُوِّ
u'تَجَدُّدٌ وَقْتٌ':Added, #1: 1	تَجَدُّدِ وُجُوبِ
u'تَجْدِيدٌ إجَارَةٌ':Added, #1: 1	تَجَدُّدُ الْوَقْتِ
u'تَجْدِيدٌ إجَارَةٌ':Added, #1: 1	تَجْدِيدَ الْإِجَارَةِ
u'تَجْدِيدٌ إِحْرَامٌ':Added, #1: 1	تَجْدِيدِ الْإِجَارَةِ
u'تَجْدِيدٌ إِحْرَامٌ':Added, #1: 1	تَجْدِيدِ إحْرَامٍ
u'تَجْدِيدٌ أَحْكَامٌ':Added, #1: 1	تَجْدِيدِ إحْرَامِ
u'تَجْدِيدٌ أَذَانٌ':Added, #1: 1	تَجْدِيدِ الْأَحْكَامِ
u'تَجْدِيدٌ إِذْنٌ':Added, #1: 1	تَجْدِيدِ أَذَانٍ
u'تَجْدِيدٌ إِذْنٌ':Added, #1: 1	تَجْدِيدَ إذْنِ
u'تَجْدِيدٌ إِذْنٌ':Added, #1: 1	تَجْدِيدُ إذْنٍ
u'تَجْدِيدٌ إِذْنٌ':Added, #1: 1	تَجْدِيدُ إذْنِ
u'تَجْدِيدٌ إِذْنٌ':Added, #1: 1	تَجْدِيدِ إذْنٍ
u'تَجْدِيدٌ إِذْنٌ':Added, #1: 1	تَجْدِيدِ إذْنِ
u'تَجْدِيدٌ إِذْنٌ':Added, #2: 2	تَجْدِيدَ الْإِذْنِ
u'تَجْدِيدٌ إِرْهَابٌ':Added, #2: 2	تَجْدِيدِ الْإِذْنِ
u'تَجْدِيدٌ اِمْتِحَانٌ':Added, #1: 1	تَجْدِيدِ إرْهَابِهِ
u'تَجْدِيدٌ أَمْرٌ':Added, #1: 1	تَجْدِيدِ امْتِحَانٍ
u'تَجْدِيدٌ إيمَانٌ':Added, #1: 1	تَجْدِيدِ أَمْرٍ
u'تَجْدِيدٌ إيمَانٌ':Added, #1: 1	تَجْدِيدُ الْإِيمَانِ
u'تَجْدِيدٌ بَحْثٌ':Added, #1: 1	تَجْدِيدِ إيمَانٍ
u'تَجْدِيدٌ بِنَاءٌ':Added, #1: 1	تَجْدِيدِ الْبَحْثِ
u'تَجْدِيدٌ بِنَاءٌ':Added, #1: 1	تَجْدِيدُ الْبِنَاءِ
u'تَجْدِيدٌ تَسْلِيمٌ':Added, #1: 1	تَجْدِيدِ بِنَاءِ
u'تَجْدِيدٌ تَكْبيرٌ':Added, #1: 1	تَجْدِيدِ التَّسْلِيمِ
u'تَجْدِيدٌ تَلْبيَةٌ':Added, #1: 1	تَجْدِيدِ التَّكْبِيرِ
u'تَجْدِيدٌ تَوْبَةٌ':Added, #1: 1	تَجْدِيدِ التَّلْبِيَةِ
u'تَجْدِيدٌ تَوْكِيلٌ':Added, #2: 2	تَجْدِيدُ التَّوْبَةِ
u'تَجْدِيدٌ تَيَمُّمٌ':Added, #1: 1	تَجْدِيدُ تَوْكِيلِ
u'تَجْدِيدٌ ثَانِي':Added, #2: 2	تَجْدِيدُ التَّيَمُّمِ
u'تَجْدِيدٌ ثَانِيَةٌ':Added, #1: 1	تَجْدِيدِ الثَّانِيَةِ
u'تَجْدِيدٌ حَجْرٌ':Added, #1: 1	تَجْدِيدِ الثَّانِيَةِ
u'تَجْدِيدٌ حُكْمٌ':Added, #1: 1	تَجْدِيدُ الْحَجْرِ
u'تَجْدِيدٌ خيار':Added, #1: 1	تَجْدِيدُ حُكْمٍ
u'تَجْدِيدٌ خِيَارٌ':Added, #1: 1	تَجْدِيدَ الْخِيَارِ
u'تَجْدِيدٌ دَعْوَةٌ':Added, #1: 1	تَجْدِيدَ الْخِيَارِ
u'تَجْدِيدٌ رِسَالَةٌ':Added, #1: 1	تَجْدِيدِ الدَّعْوَةِ
u'تَجْدِيدٌ رُكْنٌ':Added, #1: 1	تَجْدِيدِ الرِّسَالَةِ
u'تَجْدِيدٌ رُكْن':Added, #1: 1	تَجْدِيدِ الرُّكْنِ
u'تَجْدِيدٌ زَخارِفُ':Added, #1: 1	تَجْدِيدِ الرُّكْنِ
u'تَجْدِيدٌ سَبَبٌ':Added, #1: 1	تَجْدِيدَ الزَّخَارِفِ
u'تَجْدِيدٌ سُؤَالٌ':Added, #1: 1	تَجْدِيدِ السَّبَبِ
u'تَجْدِيدٌ سُؤَالٌ':Added, #1: 1	تَجْدِيدِ السُّؤَالِ
u'تَجْدِيدٌ شَرْطٌ':Added, #5: 5	تَجْدِيدُ السُّؤَالِ
u'تَجْدِيدٌ شَرْطٌ':Added, #1: 1	تَجْدِيدَ شَرْطٍ
u'تَجْدِيدٌ صَبِيٌّ':Added, #1: 1	تَجْدِيدُ شَرْطٍ
u'تَجْدِيدٌ صنع':Added, #1: 1	تَجْدِيدِ الصَّبِيِّ
u'تَجْدِيدٌ صُنْعٌ':Added, #1: 1	تَجْدِيدِ صُنْعِهِ
u'تَجْدِيدٌ صنعة':Added, #1: 1	تَجْدِيدِ صُنْعِهِ
u'تَجْدِيدٌ صَنْعَةٌ':Added, #1: 1	تَجْدِيدِ صَنْعَةٍ
u'تَجْدِيدٌ طَلاَقٌ':Added, #1: 1	تَجْدِيدِ صَنْعَةٍ
u'تَجْدِيدٌ طهر':Added, #1: 1	تَجْدِيدِ الطَّلَاقِ
u'تَجْدِيدٌ طُهْرٌ':Added, #1: 1	تَجْدِيدِ الطُّهْرِ
u'تَجْدِيدٌ عَزْمٌ':Added, #1: 1	تَجْدِيدِ الطُّهْرِ
u'تَجْدِيدٌ عِصَابَةٌ':Added, #1: 1	تَجْدِيدَ الْعَزْمِ
u'تَجْدِيدٌ عَقْدٌ':Added, #1: 1	تَجْدِيدِ الْعِصَابَةِ
u'تَجْدِيدٌ عَقْدٌ':Added, #1: 1	تَجْدِيدُ عَقْدِ
u'تَجْدِيدٌ عَقْدٌ':Added, #1: 1	تَجْدِيدِ عَقْدِ
u'تَجْدِيدٌ عَقْدٌ':Added, #2: 2	تَجْدِيدَ الْعَقْدِ
u'تَجْدِيدٌ عَقْدٌ':Added, #3: 3	تَجْدِيدُ الْعَقْدِ
u'تَجْدِيدٌ عَقْدٌ':Added, #8: 8	تَجْدِيدِ الْعَقْدِ
u'تَجْدِيدٌ عَهْدٌ':Added, #8: 8	تَجْدِيدِ عَقْدٍ
u'تَجْدِيدٌ عَهْدٌ':Added, #1: 1	تَجْدِيدُ الْعَهْدِ
u'تَجْدِيدٌ عَهْدٌ':Added, #1: 1	تَجْدِيدَ عَهْدٍ
u'تَجْدِيدٌ عَهْدٌ':Added, #2: 2	تَجْدِيدِ الْعَهْدِ
u'تَجْدِيدٌ عَوْدٌ':Added, #4: 4	تَجْدِيدَ الْعَهْدِ
u'تَجْدِيدٌ فَائِدَةٌ':Added, #1: 1	تَجْدِيدُ الْعَوْدِ
u'تَجْدِيدٌ فِرَاشٌ':Added, #1: 1	تَجْدِيدَ فَائِدَةٍ
u'تَجْدِيدٌ فَرْضٌ':Added, #1: 1	تَجْدِيدُ فِرَاشٍ
u'تَجْدِيدٌ قَبْضٌ':Added, #1: 1	تَجْدِيدُ الْفَرْضِ
u'تَجْدِيدٌ قَبْضٌ':Added, #10: 10	تَجْدِيدِ الْقَبْضِ
u'تَجْدِيدٌ قَبْضٌ':Added, #1: 1	تَجْدِيدُ قَبْضٍ
u'تَجْدِيدٌ قَبْضٌ':Added, #2: 2	تَجْدِيدُ الْقَبْضِ
u'تَجْدِيدٌ قَصْدٌ':Added, #2: 2	تَجْدِيدِ قَبْضٍ
u'تَجْدِيدٌ قَصْدٌ':Added, #1: 1	تَجْدِيدَ الْقَصْدِ
u'تَجْدِيدٌ قَصْدٌ':Added, #1: 1	تَجْدِيدُ الْقَصْدِ
u'تَجْدِيدٌ قَصْدٌ':Added, #1: 1	تَجْدِيدِ قَصْدٍ
u'تَجْدِيدٌ كَلاَمٌ':Added, #2: 2	تَجْدِيدُ قَصْدِ
u'تَجْدِيدٌ مَاءٌ':Added, #1: 1	تَجْدِيدَ الْكَلَامِ
u'تَجْدِيدٌ مَاءٌ':Added, #1: 1	تَجْدِيدَ الْمَاءِ
u'تَجْدِيدٌ مَاءٌ':Added, #1: 1	تَجْدِيدُ مَاءٍ
u'تَجْدِيدٌ مَاءٌ':Added, #3: 3	تَجْدِيدُ الْمَاءِ
u'تَجْدِيدٌ مَسْحٌ':Added, #5: 5	تَجْدِيدِ الْمَاءِ
u'تَجْدِيدٌ مُعَاهَدَةٌ':Added, #1: 1	تَجْدِيدِ مَسْحِهِ
u'تَجْدِيدٌ مِلْكٌ':Added, #1: 1	تَجْدِيدُ الْمُعَاهَدَةِ
u'تَجْدِيدٌ مَنْفَعَةٌ':Added, #3: 3	تَجْدِيدُ مِلْكٍ
u'تَجْدِيدٌ نَدَمٌ':Added, #1: 1	تَجْدِيدِ مَنْفَعَةٍ
u'تَجْدِيدٌ نَظَرٌ':Added, #1: 1	تَجْدِيدُ النَّدَمِ
u'تَجْدِيدٌ نكاح':Added, #1: 1	تَجْدِيدُ النَّظَرِ
u'تَجْدِيدٌ نكاح':Added, #1: 1	تَجْدِيدَ نِكَاحٍ
u'تَجْدِيدٌ نكاح':Added, #1: 1	تَجْدِيدُ نِكَاحِ
u'تَجْدِيدٌ نكاح':Added, #1: 1	تَجْدِيدِ نِكَاحٍ
u'تَجْدِيدٌ نِكَاحٌ':Added, #1: 1	تَجْدِيدِ نِكَاحِ
u'تَجْدِيدٌ نِكَاحٌ':Added, #1: 1	تَجْدِيدَ نِكَاحٍ
u'تَجْدِيدٌ نِكَاحٌ':Added, #1: 1	تَجْدِيدُ نِكَاحِ
u'تَجْدِيدٌ نِكَاحٌ':Added, #1: 1	تَجْدِيدِ نِكَاحٍ
u'تَجْدِيدٌ نكاح':Added, #1: 1	تَجْدِيدِ نِكَاحِ
u'تَجْدِيدٌ نكاح':Added, #3: 3	تَجْدِيدَ النِّكَاحِ
u'تَجْدِيدٌ نِكَاحٌ':Added, #3: 3	تَجْدِيدُ النِّكَاحِ
u'تَجْدِيدٌ نِكَاحٌ':Added, #3: 3	تَجْدِيدَ النِّكَاحِ
u'تَجْدِيدٌ نكاح':Added, #3: 3	تَجْدِيدُ النِّكَاحِ
u'تَجْدِيدٌ نِكَاحٌ':Added, #8: 8	تَجْدِيدِ النِّكَاحِ
u'تَجْدِيدٌ نِيَّةٌ':Added, #8: 8	تَجْدِيدِ النِّكَاحِ
u'تَجْدِيدٌ نِيَّةٌ':Added, #2: 2	تَجْدِيدَ النِّيَّةِ
u'تَجْدِيدٌ نِيَّةٌ':Added, #4: 4	تَجْدِيدُ نِيَّةِ
u'تَجْدِيدٌ نِيَّةٌ':Added, #7: 7	تَجْدِيدُ النِّيَّةِ
u'تَجْدِيدٌ نِيَّةٌ':Added, #7: 7	تَجْدِيدِ النِّيَّةِ
u'تَجْدِيدٌ وَحْيٌ':Added, #7: 7	تَجْدِيدِ نِيَّةٍ
u'تَجْدِيدٌ وَضْعٌ':Added, #1: 1	تَجْدِيدَ وَحْيٍ
u'تَجْدِيدٌ وُضُوءٌ':Added, #1: 1	تَجْدِيدِ الْوَضْعِ
u'تَجْدِيدٌ وُضُوءٌ':Added, #2: 2	تَجْدِيدَ الْوُضُوءِ
u'تَجْدِيدٌ وُضُوءٌ':Added, #4: 4	تَجْدِيدِ وُضُوءٍ
u'تَجْدِيدٌ وُضُوءٌ':Added, #5: 5	تَجْدِيدُ الْوُضُوءِ
u'تَجْدِيدٌ وَقْف':Added, #5: 5	تَجْدِيدِ الْوُضُوءِ
u'تَجْدِيدٌ وَقْف':Added, #1: 1	تَجْدِيدِ الْوَقْفِيَّةِ
u'تَجْدِيدٌ وَقْفَة':Added, #1: 1	تَجْدِيدِ وَقْفِيَّةٍ
u'تَجْدِيدٌ وَقْفَة':Added, #1: 1	تَجْدِيدِ الْوَقْفِيَّةِ
u'تَجْدِيدٌ وَقْفِيّ':Added, #1: 1	تَجْدِيدِ وَقْفِيَّةٍ
u'تَجْدِيدٌ وَقْفِيّ':Added, #1: 1	تَجْدِيدِ الْوَقْفِيَّةِ
u'تَجْدِيدٌ وَقْفِيَّة':Added, #1: 1	تَجْدِيدِ وَقْفِيَّةٍ
u'تَجْدِيدٌ وَقْفِيَّة':Added, #1: 1	تَجْدِيدِ الْوَقْفِيَّةِ
u'تَجْدِيدٌ وِلاَيَةٌ':Added, #1: 1	تَجْدِيدِ وَقْفِيَّةٍ
u'تَجْرِبَةٌ خَطٌّ':Added, #1: 1	تَجْدِيدَ وِلَايَةٍ
u'تَجْرِبَةٌ سَالِفٌ':Added, #2: 2	تَجْرِبَةَ الْخَطِّ
u'تَجْرِبَةٌ مَبِيعٌ':Added, #1: 1	تَجْرِبَةٍ سَالِفَةٍ
u'تَجْرِبَةٌ مَبِيعٌ':Added, #1: 1	تَجْرِبَةَ الْمَبِيعِ
u'تَجْرِبَةٌ مَبِيعٌ':Added, #2: 2	تَجْرِبَةُ الْمَبِيعِ
u'تَجَرَّدَ أَمْرٌ':Subject, #2: 2	تَجْرِبَةِ الْمَبِيعِ
u'تَجَرُّدٌ بَعيرٌ':Added, #1: 1	تَجَرَّدَ الْأَمْرُ
u'تَجَرَّدَ ثَناءٌ':Subject, #1: 1	تَجَرُّدَ الْبَعِيرِ
u'تَجَرَّدَ خُرُوجٌ':Subject, #1: 1	تَجَرَّدَ الثَّنَاءُ
u'تَجَرَّدَ خَوْفٌ':Subject, #1: 1	تَجَرَّدَ خُرُوجُ
u'تَجَرَّدَ دفع':Subject, #1: 1	تَجَرَّدَ الْخَوْفُ
u'تَجَرَّدَ دَفْعٌ':Subject, #1: 1	تَجَرَّدَ دَفْعُهُ
u'تَجَرُّدٌ ذَكَرٌ':Added, #1: 1	تَجَرَّدَ دَفْعُهُ
u'تَجَرُّدٌ رَجُلٌ':Added, #1: 1	تَجَرُّدِ ذَكَرَيْنِ
u'تَجَرَّدَ سَيَلانٌ':Subject, #1: 1	تَجَرُّدِ الرَّجُلِ
u'تَجَرُّدٌ عِيرٌ':Added, #1: 1	تَجَرَّدَ سَيَلَانُ
u'تَجَرُّدٌ عِيرٌ':Added, #1: 1	تَجَرُّدَ الْعِيرِ
u'تَجَرَّدَ قول':Subject, #1: 1	تَجَرُّدَ الْعِيرَيْنِ
u'تَجَرَّدَ قَوْلٌ':Subject, #3: 3	تَجَرَّدَ قَوْلُهُ
u'تَجَرَّدَ كَلاَمٌ':Subject, #3: 3	تَجَرَّدَ قَوْلُهُ
u'تَجَرَّدَ لَفْظٌ':Subject, #1: 1	تَجَرَّدَ كَلَامٌ
u'تَجَرُّدٌ لَفْظٌ':Added, #1: 1	تَجَرَّدَ لَفْظُهُ
u'تَجَرُّدٌ مُشْتَرَكٌ':Added, #1: 1	تَجَرُّدُ اللَّفْظِ
u'تَجَرَّدَ نَظَرٌ':Subject, #1: 1	تَجَرُّدُ الْمُشْتَرَكِ
u'تَجَرُّدٌ نَفْسٌ':Added, #2: 2	تَجَرَّدَ النَّظَرُ
u'تَجَرَّدَ هَتْكٌ':Subject, #1: 1	تَجَرُّدُ النَّفْسِ
u'تَجَرَّدَ وَضْعٌ':Subject, #1: 1	تَجَرَّدَ هَتْكُ
u'تَجَرُّدٌ يَمِينٌ':Added, #1: 1	تَجَرَّدَ الْوَضْعُ
u'تَجَرَّعَ عَبْدٌ':Subject, #1: 1	تَجَرُّدِ يَمِينِهِ
u'تَجَرَّعَ كَأْسٌ':Predicate, #2: 2	تَجَرَّعَ عَبْدٌ
u'تَجْرِيدٌ اِبْنٌ':Added, #1: 1	تَجَرَّعَ كَأْسَ
u'تَجْرِيدٌ اِسْمٌ':Added, #1: 1	تَجْرِيدِ ابْنِ
u'تَجْرِيدٌ تَجْرِيدٌ':Added, #1: 1	تَجْرِيدُ اسْمِ
u'تَجْرِيدٌ تَوْحِيدٌ':Added, #1: 1	تَجْرِيدِ التَّجْرِيدِ
u'تَجْرِيدٌ ذَهَبِيٌّ':Added, #2: 2	تَجْرِيدِ التَّوْحِيدِ
u'تَجْرِيدٌ عِنَايَةٌ':Added, #1: 1	تَجْرِيدُ الذَّهَبِيِّ
u'تَجْرِيدٌ فِكْرٌ':Added, #232: 232	تَجْرِيدِ الْعِنَايَةِ
u'تَجْرِيدٌ قَصْدٌ':Added, #1: 1	تَجْرِيدِ الْفِكْرِ
u'تَجْرِيدٌ قلب':Added, #2: 2	تَجْرِيدِ الْقَصْدِ
u'تَجْرِيدٌ قَلْبٌ':Added, #1: 1	تَجْرِيدُ الْقَلْبِ
u'تَجْرِيدٌ قَلْب':Added, #1: 1	تَجْرِيدُ الْقَلْبِ
u'تَجْرِيدٌ لَفْظٌ':Added, #1: 1	تَجْرِيدُ الْقَلْبِ
u'تَجْرِيدٌ مُعْتَقٌ':Added, #1: 1	تَجْرِيدُ اللَّفْظِ
u'تَجْرِيدٌ نَظَرٌ':Added, #1: 1	تَجْرِيدِ الْمُعْتَقِ
u'تَجَزَّأَ عتق':Subject, #2: 2	تَجْرِيدِ النَّظَرِ
u'تَجَزَّأَ عِتْقٌ':Subject, #1: 1	تَجَزَّأَ الْعِتْقُ
u'تَجْزِيءٌ إِعْتاقٌ':Added, #1: 1	تَجَزَّأَ الْعِتْقُ
u'تَجْزِئَةٌ إِجْمَاعٌ':Added, #1: 1	تَجْزِيءُ الْإِعْتَاقِ
u'تَجْزِئَةٌ أَرِقَّاءُ':Added, #1: 1	تَجْزِئَةُ الْإِجْمَاعِ
u'تَجْزِئَةٌ مَبِيعٌ':Added, #1: 1	تَجْزِئَةِ الْأَرِقَّاءِ
u'تَجْزِيءٌ عتق':Added, #1: 1	تَجْزِئَةُ الْمَبِيعِ
u'تَجْزِيءٌ عِتْقٌ':Added, #1: 1	تَجْزِيءِ الْعِتْقِ
u'تَجَشَّأَ عند':Predicate, #1: 1	تَجْزِيءِ الْعِتْقِ
u'تَجَشُّمٌ دفع':Added, #1: 1	تَجَشَّأَ عِنْدَ
u'تَجَشُّمٌ دَفْعٌ':Added, #1: 1	تَجَشُّمُ دَفْعِ
u'تَجَشَّمَ فَرْعٌ':Subject, #1: 1	تَجَشُّمُ دَفْعِ
u'تَجَعَّدَ شَعْرٌ':Subject, #1: 1	تَجَشَّمَ الْفَرْعُ
u'تَجْفِيفٌ أَشْجَارٌ':Added, #1: 1	تَجَعَّدَ شَعْرُهُ
u'تَجْفِيفٌ أَعْضَاءٌ':Added, #1: 1	تَجْفِيفَ الْأَشْجَارِ
u'تَجْفِيفٌ تَمْر':Added, #1: 1	تَجْفِيفُ الْأَعْضَاءِ
u'تَجْفِيفٌ ثِمارٌ':Added, #1: 1	تَجْفِيفُ التَّمْرِ
u'تَجْفِيفٌ ثَوْبٌ':Added, #1: 1	تَجْفِيفِ الثِّمَارِ
u'تَجْفِيفٌ دِماغٌ':Added, #1: 1	تَجْفِيفُ الثَّوْبِ
u'تَجْفِيفٌ عِنَبٌ':Added, #1: 1	تَجْفِيفِ الدِّمَاغِ
u'تَجْفِيفٌ مَنِيٌّ':Added, #1: 1	تَجْفِيفَ عِنَبٍ
u'تَجْفِيفٌ وَجْهٌ':Added, #2: 2	تَجْفِيفِ الْمَنِيِّ
u'تَجَلَّى رَبُّ':Subject, #1: 1	تَجْفِيفِ الْوَجْهِ
u'تَجَلَّى كُسُوفٌ':Subject, #1: 1	تَجَلَّى رَبُّهُ
u'تَجَمُّلٌ الْمَرْأَةُ':Added, #3: 3	تَجَلَّى الْكُسُوفُ
u'تَجْمِيعٌ إمَامٌ':Added, #1: 1	تَجَمُّلِ الْمَرْأَةِ
u'تَجْمِيعٌ أهْلٌ':Added, #2: 2	تَجْمِيعِ الْإِمَامِ
u'تَجْمِيعٌ خلق':Added, #2: 2	تَجْمِيعُ أَهْلِ
u'تَجْمِيعٌ خَلْقٌ':Added, #1: 1	تَجْمِيعِ الْخَلْقِ
u'تَجَنُّبٌ أجَانِبُ':Added, #1: 1	تَجْمِيعِ الْخَلْقِ
u'تَجَنُّبٌ اِضْطِرابٌ':Added, #1: 1	تَجَنُّبُ الْأَجَانِبِ
u'تَجَنُّبٌ أكل':Added, #1: 1	تَجَنُّبُ اضْطِرَابِ
u'تَجَنُّبٌ أَكْلٌ':Added, #1: 1	تَجَنُّبَ أَكْلِهِ
u'تَجَنُّبٌ أَلْفَاظٌ':Added, #1: 1	تَجَنُّبَ أَكْلِهِ
u'تَجَنُّبٌ يَتِيمٌ':Added, #1: 1	تَجَنُّبِ الْأَلْفَاظِ
u'تَجْنِيدٌ أَجْنَادٌ':Added, #1: 1	تَجَنُّبِ الْيَتِيمِ
u'تَجْهِيزٌ الْمَرْأَةُ':Added, #1: 1	تَجْنِيدِ الْأَجْنَادِ
u'تَجْهِيزٌ أُمٌّ':Added, #1: 1	تَجْهِيزُ الْمَرْأَةِ
u'تَجْهِيزٌ أموات':Added, #1: 1	تَجْهِيزِ أُمِّ
u'تَجْهِيزٌ بناتٌ':Added, #1: 1	تَجْهِيزَ الْأَمْوَاتِ
u'تَجْهِيزٌ جَيْشٌ':Added, #1: 1	تَجْهِيزِ الْبَنَاتِ
u'تَجْهِيزٌ جَيْشٌ':Added, #1: 1	تَجْهِيزِ جَيْشٍ
u'تَجْهِيزٌ جَيْشٌ':Added, #1: 1	تَجْهِيزِ جَيْشِ
u'تَجْهِيزٌ جُيوشٌ':Added, #3: 3	تَجْهِيزِ الْجَيْشِ
u'تَجْهِيزٌ حُرٌّ':Added, #2: 2	تَجْهِيزِ الْجُيُوشِ
u'تَجْهِيزٌ خَادِمٌ':Added, #1: 1	تَجْهِيزِ الْحُرَّةِ
u'تَجْهِيزٌ رَجُلٌ':Added, #1: 1	تَجْهِيزِ الْخَادِمَةِ
u'تَجْهِيزٌ زَوْجَةٌ':Added, #1: 1	تَجْهِيزِ الرَّجُلِ
u'تَجْهِيزٌ زَوْجَةٌ':Added, #2: 2	تَجْهِيزِ الزَّوْجَةِ
u'تَجْهِيزٌ غير':Added, #2: 2	تَجْهِيزِ زَوْجَتِهِ
u'تَجْهِيزٌ غير':Added, #1: 1	تَجْهِيزُ غَيْرِهِ
u'تَجْهِيزٌ غَيْرٌ':Added, #1: 1	تَجْهِيزِ غَيْرِهِ
u'تَجْهِيزٌ غَيْرٌ':Added, #1: 1	تَجْهِيزُ غَيْرِهِ
u'تَجْهِيزٌ قَرِيبٌ':Added, #1: 1	تَجْهِيزِ غَيْرِهِ
u'تَجْهِيزٌ مَالِكٌ':Added, #1: 1	تَجْهِيزِ قَرِيبِهِ
u'تَجْهِيزٌ مُسْلِمٌ':Added, #1: 1	تَجْهِيزِ الْمَالِكِ
u'تَجْهِيزٌ ولد':Added, #1: 1	تَجْهِيزِ الْمُسْلِمِ
u'تَجْهِيزٌ وَلَدٌ':Added, #1: 1	تَجْهِيزُ وَلَدِهِ
u'تَجَوُّزٌ شَارِعٌ':Added, #1: 1	تَجْهِيزُ وَلَدِهِ
u'تَجَوُّزٌ مَجَازٌ':Added, #1: 1	تَجَوُّزِ الشَّارِعِ
u'تَجْوِيدٌ خَطٌّ':Added, #1: 1	تَجَوُّزِ الْمَجَازِ
u'تَجْوِيدٌ خَطٌّ':Added, #1: 1	تَجْوِيدُ الْخَطِّ
u'تَجْوِيدٌ قِرَاءةٌ':Added, #3: 3	تَجْوِيدَ خَطِّهِ
u'تَجْوِيزٌ إِبْقَاءٌ':Added, #1: 1	تَجْوِيدِ قِرَاءَتِهِ
u'تَجْوِيزٌ اِبْنٌ':Added, #1: 1	تَجْوِيزِ إبْقَاءِ
u'تَجْوِيزٌ إجَارَةٌ':Added, #1: 1	تَجْوِيزُ ابْنِ
u'تَجْوِيزٌ إِحْدَاثٌ':Added, #1: 1	تَجْوِيزِ الإِجَارَةِ
u'تَجْوِيزٌ أخْذٌ':Added, #1: 1	تَجْوِيزِ إحْدَاثِ
u'تَجْوِيزٌ أخْذٌ':Added, #1: 1	تَجْوِيزِ أَخْذِ
u'تَجْوِيزٌ إدْخَالٌ':Added, #1: 1	تَجْوِيزِ الْأَخْذِ
u'تَجْوِيزٌ إِرَادَةٌ':Added, #1: 1	تَجْوِيزِ الْإِدْخَالِ
u'تَجْوِيزٌ إِرَادَةٌ':Added, #1: 1	تَجْوِيزُ إرَادَةِ
u'تَجْوِيزٌ اِسْتِخْرَاجٌ':Added, #1: 1	تَجْوِيزِ إرَادَةِ
u'تَجْوِيزٌ اِسْتِعْمالٌ':Added, #1: 1	تَجْوِيزُ اسْتِخْرَاجِ
u'تَجْوِيزٌ اِسْتِواءٌ':Added, #1: 1	تَجْوِيزُ اسْتِعْمَالِهِ
u'تَجْوِيزٌ أصل':Added, #1: 1	تَجْوِيزَ اسْتِوَاءٍ
u'تَجْوِيزٌ أًصْلٌ':Added, #1: 1	تَجْوِيزِ أَصْلِ
u'تَجْوِيزٌ إِضْرابٌ':Added, #1: 1	تَجْوِيزِ أَصْلِ
u'تَجْوِيزٌ إِعْتاقٌ':Added, #1: 1	تَجْوِيزَ الْإِضْرَابِ
u'تَجْوِيزٌ إِفْطارٌ':Added, #1: 1	تَجْوِيزِ الْإِعْتَاقِ
u'تَجْوِيزٌ إقامَةٌ':Added, #2: 2	تَجْوِيزِ الْإِفْطَارِ
u'تَجْوِيزٌ إمَامٌ':Added, #1: 1	تَجْوِيزِ إقَامَةِ
u'تَجْوِيزٌ أَمْرٌ':Added, #1: 1	تَجْوِيزَ الْإِمَامِ
u'تَجْوِيزٌ إِنابَةٌ':Added, #3: 3	تَجْوِيزُ أَمْرَيْنِ
u'تَجْوِيزٌ أهْلٌ':Added, #1: 1	تَجْوِيزُ الْإِنَابَةِ
u'تَجْوِيزٌ بَعْضٌ':Added, #1: 1	تَجْوِيزِ أَهْلِ
u'تَجْوِيزٌ بَعْضٌ':Added, #1: 1	تَجْوِيزِ بَعْضِ
u'تَجْوِيزٌ بَيْعٌ':Added, #1: 1	تَجْوِيزُ بَعْضِهِ
u'تَجْوِيزٌ بَيْعٌ':Added, #1: 1	تَجْوِيزِ الْبَيْعِ
u'تَجْوِيزٌ بَيْعٌ':Added, #1: 1	تَجْوِيزِ بَيْعِهِ
u'تَجْوِيزٌ تَأْخِيرٌ':Added, #3: 3	تَجْوِيزِ بَيْعِ
u'تَجْوِيزٌ تَجَوُّزٌ':Added, #1: 1	تَجْوِيزُ التَّأْخِيرِ
u'تَجْوِيزٌ تَخْصِيصٌ':Added, #1: 1	تَجْوِيزُ التَّجَوُّزِ
u'تَجْوِيزٌ تَخْصِيصٌ':Added, #1: 1	تَجْوِيزُ تَخْصِيصِ
u'تَجْوِيزٌ تَرْكٌ':Added, #1: 1	تَجْوِيزِ تَخْصِيصِ
u'تَجْوِيزٌ تَشَهُّدٌ':Added, #1: 1	تَجْوِيزَ تَرْكِ
u'تَجْوِيزٌ تَضْحِيَةٌ':Added, #1: 1	تَجْوِيزَ التَّشَهُّدِ
u'تَجْوِيزٌ تَعْلِيقٌ':Added, #1: 1	تَجْوِيزُ التَّضْحِيَةِ
u'تَجْوِيزٌ تَقْديمٌ':Added, #2: 2	تَجْوِيزِ تَعْلِيقِ
u'تَجْوِيزٌ ثُبُوتٌ':Added, #1: 1	تَجْوِيزِ تَقْدِيمِ
u'تَجْوِيزٌ جُزْئِيٌّ':Added, #1: 1	تَجْوِيزِ ثُبُوتِ
u'تَجْوِيزٌ جُزْئِيَّةٌ':Added, #1: 1	تَجْوِيزِ جُزْئِيَّتِهِ
u'تَجْوِيزٌ جُلُوسٌ':Added, #1: 1	تَجْوِيزِ جُزْئِيَّتِهِ
u'تَجْوِيزٌ جمع':Added, #1: 1	تَجْوِيزِ الْجُلُوسِ
u'تَجْوِيزٌ جَمْعٌ':Added, #1: 1	تَجْوِيزَ الْجَمْعِ
u'تَجْوِيزٌ جمعة':Added, #1: 1	تَجْوِيزَ الْجَمْعِ
u'تَجْوِيزٌ جُمُعَةٌ':Added, #1: 1	تَجْوِيزَ الْجُمُعَةِ
u'تَجْوِيزٌ حُكْمٌ':Added, #1: 1	تَجْوِيزَ الْجُمُعَةِ
u'تَجْوِيزٌ حَلْوانِيٌّ':Added, #2: 2	تَجْوِيزِ حُكْمِ
u'تَجْوِيزٌ دفع':Added, #1: 1	تَجْوِيزِ الْحَلْوَانِيِّ
u'تَجْوِيزٌ دَفْعٌ':Added, #1: 1	تَجْوِيزُ الدَّفْعِ
u'تَجْوِيزٌ رِبْحٌ':Added, #1: 1	تَجْوِيزُ الدَّفْعِ
u'تَجْوِيزٌ رجعة':Added, #1: 1	تَجْوِيزِ رِبْحِ
u'تَجْوِيزٌ رَجْعَةٌ':Added, #1: 1	تَجْوِيزِ الرَّجْعَةِ
u'تَجْوِيزٌ رَدٌّ':Added, #1: 1	تَجْوِيزِ الرَّجْعَةِ
u'تَجْوِيزٌ رَمْيٌ':Added, #1: 1	تَجْوِيزِ الرَّدِّ
u'تَجْوِيزٌ رِوايَةٌ':Added, #1: 1	تَجْوِيزِ الرَّمْيِ
u'تَجْوِيزٌ زِيادَةٌ':Added, #1: 1	تَجْوِيزِ الرِّوَايَةِ
u'تَجْوِيزٌ سَفَرٌ':Added, #3: 3	تَجْوِيزِ الزِّيَادَةِ
u'تَجْوِيزٌ شُبْهَةٌ':Added, #1: 1	تَجْوِيزِ السَّفَرِ
u'تَجْوِيزٌ شَيْءٌ':Added, #1: 1	تَجْوِيزِ شُبْهَةٍ
u'تَجْوِيزٌ صُدُورٌ':Added, #1: 1	تَجْوِيزُ الشَّيْءِ
u'تَجْوِيزٌ صغائر':Added, #1: 1	تَجْوِيزِ صُدُورِ
u'تَجْوِيزٌ صَغَائِرُ':Added, #1: 1	تَجْوِيزَ الصَّغَائِرِ
u'تَجْوِيزٌ عَدَمٌ':Added, #1: 1	تَجْوِيزَ الصَّغَائِرِ
u'تَجْوِيزٌ عَدَمٌ':Added, #1: 1	تَجْوِيزُ عَدَمِ
u'تَجْوِيزٌ عَقْدٌ':Added, #1: 1	تَجْوِيزِ عَدَمِ
u'تَجْوِيزٌ عَقْدٌ':Added, #1: 1	تَجْوِيزِ الْعَقْدِ
u'تَجْوِيزٌ عَقْلٌ':Added, #1: 1	تَجْوِيزِ عَقْدِ
u'تَجْوِيزٌ غِشَاءٌ':Added, #1: 1	تَجْوِيزِ الْعَقْلِ
u'تَجْوِيزٌ غير':Added, #1: 1	تَجْوِيزُ غِشَاءِ
u'تَجْوِيزٌ غَيْرٌ':Added, #1: 1	تَجْوِيزَ غَيْرِهِ
u'تَجْوِيزٌ غير':Added, #1: 1	تَجْوِيزَ غَيْرِهِ
u'تَجْوِيزٌ غَيْرٌ':Added, #2: 2	تَجْوِيزِ غَيْرِهِ
u'تَجْوِيزٌ فَتْحٌ':Added, #2: 2	تَجْوِيزِ غَيْرِهِ
u'تَجْوِيزٌ فَتْحٌ':Added, #1: 1	تَجْوِيزُ الْفَتْحِ
u'تَجْوِيزٌ فِطْرٌ':Added, #1: 1	تَجْوِيزِ الْفَتْحِ
u'تَجْوِيزٌ فِعْلٌ':Added, #2: 2	تَجْوِيزُ الْفِطْرِ
u'تَجْوِيزٌ فِعْلٌ':Added, #1: 1	تَجْوِيزَ الْفِعْلِ
u'تَجْوِيزٌ فلان':Added, #1: 1	تَجْوِيزُ فِعْلٍ
u'تَجْوِيزٌ قَبُولٌ':Added, #1: 1	تَجْوِيزِ الرَّازِيِّ
u'تَجْوِيزٌ قِيَاسٌ':Added, #1: 1	تَجْوِيزَ قَبُولِ
u'تَجْوِيزٌ كَوْنٌ':Added, #2: 2	تَجْوِيزِ الْقِيَاسِ
u'تَجْوِيزٌ كَوْنٌ':Added, #1: 1	تَجْوِيزَ كَوْنِ
u'تَجْوِيزٌ كَوْنٌ':Added, #2: 2	تَجْوِيزِ كَوْنِ
u'تَجْوِيزٌ كَوْنٌ':Added, #2: 2	تَجْوِيزُ كَوْنِهِ
u'تَجْوِيزٌ لبس':Added, #3: 3	تَجْوِيزُ كَوْنِ
u'تَجْوِيزٌ لُبْسٌ':Added, #1: 1	تَجْوِيزُ لُبْسِ
u'تَجْوِيزٌ مُحَارَبَةٌ':Added, #1: 1	تَجْوِيزُ لُبْسِ
u'تَجْوِيزٌ مُخَالِفٌ':Added, #1: 1	تَجْوِيزِ الْمُحَارَبَةِ
u'تَجْوِيزٌ مُصَنِّفٌ':Added, #1: 1	تَجْوِيزِ الْمُخَالِفِ
u'تَجْوِيزٌ مُضَارَبَةٌ':Added, #1: 1	تَجْوِيزُ الْمُصَنِّفِ
u'تَجْوِيزٌ نقل':Added, #1: 1	تَجْوِيزَ الْمُضَارَبَةِ
u'تَجْوِيزٌ نقل':Added, #1: 1	تَجْوِيزَ النَّقْلِ
u'تَجْوِيزٌ نَقْلٌ':Added, #1: 1	تَجْوِيزُ النَّقْلِ
u'تَجْوِيزٌ نَقْلٌ':Added, #1: 1	تَجْوِيزَ النَّقْلِ
u'تَجْوِيزٌ نَقِيضٌ':Added, #1: 1	تَجْوِيزُ النَّقْلِ
u'تَجْوِيزٌ نَقِيضٌ':Added, #1: 1	تَجْوِيزِ النَّقِيضِ
u'تَجْوِيزٌ نَقِيضٌ':Added, #1: 1	تَجْوِيزُ نَقِيضِهِ
u'تَجْوِيزٌ نَقِيضٌ':Added, #1: 1	تَجْوِيزِ نَقِيضِهِ
u'تَجْوِيزٌ نكاح':Added, #3: 3	تَجْوِيزُ النَّقِيضِ
u'تَجْوِيزٌ نِكَاحٌ':Added, #3: 3	تَجْوِيزِ نِكَاحِ
u'تَجْوِيزٌ نِيَابَةٌ':Added, #3: 3	تَجْوِيزِ نِكَاحِ
u'تَجْوِيزٌ هِبَةٌ':Added, #1: 1	تَجْوِيزَ النِّيَابَةِ
u'تَجْوِيزٌ وَاقِفٌ':Added, #1: 1	تَجْوِيزِ الْهِبَةِ
u'تَجْوِيزٌ وَصِيٌّ':Added, #1: 1	تَجْوِيزَ الْوَاقِفِ
u'تَجْوِيزٌ وَصِيَّةٌ':Added, #2: 2	تَجْوِيزِ الْوَصِيَّةِ
u'تَجْوِيزٌ وُقُوعٌ':Added, #2: 2	تَجْوِيزِ الْوَصِيَّةِ
u'تَجْوِيعٌ نَفْسٌ':Added, #1: 1	تَجْوِيزِ وُقُوعِهِ
u'تَحَارَبَ مُسْلِمٌ':Subject, #1: 1	تَجْوِيعُ النَّفْسِ
u'تَحَاسُدٌ أكفاء':Added, #1: 1	تَحَارَبَ مُسْلِمٌ
u'تَحَاكَمَ إمَامٌ':Subject, #1: 1	تَحَاسُدُ الْأَكْفَاءِ
u'تَحَالُفٌ جَانِبٌ':Added, #1: 1	تَحَاكَمَ الْإِمَامُ
u'تَحَالُفٌ مُوَكِّلٌ':Added, #1: 1	تَحَالُفُ الْجَانِبَيْنِ
u'تَحَالُفٌ مُوَكِّلٌ':Added, #1: 1	تَحَالُفَ الْمُوَكِّلَيْنِ
u'تَحَالُفٌ وَكِيلٌ':Added, #1: 1	تَحَالُفُ الْمُوَكِّلَيْنِ
u'تَحَالُفٌ وَكِيلٌ':Added, #1: 1	تَحَالُفُ الْوَكِيلَيْنِ
u'تَحَامَلَ صَيْدٌ':Subject, #2: 2	تَحَالُفِ الْوَكِيلَيْنِ
u'تَحَامُلٌ يَسِيرٌ':Added, #1: 1	تَحَامَلَ الصَّيْدُ
u'تَحَامَى مَوَاضِعُ':Predicate, #1: 1	تَحَامُلٍ يَسِيرٍ
u'تَحَبُّبٌ ثَمَرٌ':Added, #1: 1	تَحَامَى مَوَاضِعَ
u'تَحَبَّبَ قَصِيلٌ':Subject, #1: 1	تَحَبُّبِ الثَّمَرِ
u'تَحْبِيسٌ أصل':Added, #1: 1	تَحَبَّبَ الْقَصِيلُ
u'تَحْبِيسٌ أًصْلٌ':Added, #1: 1	تَحْبِيسُ الْأَصْلِ
u'تَحْبِيسٌ حَيَوَانٌ':Added, #1: 1	تَحْبِيسُ الْأَصْلِ
u'تَحْبِيسٌ رَقيقٌ':Added, #1: 1	تَحْبِيسُ الْحَيَوَانِ
u'تَحْبِيسٌ رَقيق':Added, #1: 1	تَحْبِيسُ الرَّقِيقِ
u'تَحْبِيسٌ شَيْخٌ':Added, #1: 1	تَحْبِيسُ الرَّقِيقِ
u'تَحْبِيسٌ غير':Added, #1: 1	تَحْبِيسِ الشَّيْخِ
u'تَحْبِيسٌ غَيْرٌ':Added, #1: 1	تَحْبِيسِ غَيْرِ
u'تَحْبِيسٌ مَالِكٌ':Added, #1: 1	تَحْبِيسِ غَيْرِ
u'تَحْبِيسٌ مَسَاجِدُ':Added, #1: 1	تَحْبِيسُ مَالِكٍ
u'تَحْبِيسٌ نبات':Added, #1: 1	تَحْبِيسِ الْمَسَاجِدِ
u'تَحْبِيسٌ نَبَاتٌ':Added, #1: 1	تَحْبِيسُ النَّبَاتِ
u'تَحَتَّمَ بِنَاءٌ':Subject, #1: 1	تَحْبِيسُ النَّبَاتِ
u'تَحَتَّمَ فَسْخٌ':Subject, #1: 1	تَحَتَّمَ الْبِنَاءُ
u'تَحَتُّمٌ فَسْخٌ':Added, #1: 1	تَحَتَّمَ فَسْخُ
u'تَحَتَّمَ قتل':Subject, #1: 1	تَحَتُّمِ فَسْخِ
u'تَحَتَّمَ قَتْلٌ':Subject, #8: 8	تَحَتَّمَ قَتْلُهُ
u'تَحَتُّمٌ قتل':Added, #8: 8	تَحَتَّمَ قَتْلُهُ
u'تَحَتُّمٌ قَتْلٌ':Added, #1: 1	تَحَتُّمَ قَتْلِ
u'تَحَتُّمٌ قتل':Added, #1: 1	تَحَتُّمَ قَتْلِ
u'تَحَتُّمٌ قَتْلٌ':Added, #2: 2	تَحَتُّمِ الْقَتْلِ
u'تَحَتُّمٌ قتل':Added, #2: 2	تَحَتُّمِ الْقَتْلِ
u'تَحَتُّمٌ قَتْلٌ':Added, #4: 4	تَحَتُّمُ الْقَتْلِ
u'تَحَتُّمٌ قتل':Added, #4: 4	تَحَتُّمُ الْقَتْلِ
u'تَحَتُّمٌ قَتْلٌ':Added, #4: 4	تَحَتُّمِ قَتْلِهِ
u'تَحَتُّمٌ قَوَد':Added, #4: 4	تَحَتُّمِ قَتْلِهِ
u'تَحَتُّمٌ قَوَد':Added, #1: 1	تَحَتُّمُ الْقَوَدِ
u'تَحَتَّمَ لبس':Subject, #2: 2	تَحَتُّمِ قَوَدٍ
u'تَحَتَّمَ لُبْسٌ':Subject, #1: 1	تَحَتَّمَ لُبْسُهُ
u'تَحَتُّمٌ مُسَاوَاةٌ':Added, #1: 1	تَحَتَّمَ لُبْسُهُ
u'تَحَتُّمٌ مَنْعٌ':Added, #1: 1	تَحَتُّمِ الْمُسَاوَاةِ
u'تَحَجَّرَ شَخْصٌ':Subject, #1: 1	تَحَتُّمُ مَنْعٍ
u'تَحَجُّرٌ عَاجِزٌ':Added, #1: 1	تَحَجَّرَ الشَّخْصُ
u'تَحَجُّرٌ مَوَاتٌ':Added, #1: 1	تَحَجُّرُ عَاجِزٍ
u'تَحَجُّرٌ مَوَاتٌ':Added, #1: 1	تَحَجُّرُ الْمَوَاتِ
u'تَحْجِيرٌ أرْضٌ':Added, #1: 1	تَحَجُّرَ مَوَاتِ
u'تَحْجِيرٌ مَوْضِعٌ':Added, #1: 1	تَحْجِيرُ الْأَرْضِ
u'تَحَدُّثٌ أَصْحَابٌ':Added, #1: 1	تَحْجِيرِ مَوْضِعِ
u'تَحَدَّثَ شَيْخٌ':Subject, #1: 1	تَحَدُّثِ أَصْحَابِ
u'تَحَدَّثَ نَاسٌ':Subject, #1: 1	تَحَدَّثَ الشَّيْخُ
u'تَحَدُّثٌ نَفْسٌ':Added, #7: 7	تَحَدَّثَ النَّاسُ
u'تَحْدِيدٌ أَجَلٌ':Added, #1: 1	تَحَدُّثُ النَّفْسِ
u'تَحْدِيدٌ آخِرُ':Added, #1: 1	تَحْدِيدُ الْأَجَلِ
u'تَحْدِيدٌ أرْضٌ':Added, #1: 1	تَحْدِيدُ آخِرِ
u'تَحْدِيدٌ إِعادَةٌ':Added, #2: 2	تَحْدِيدُ الْأَرْضِ
u'تَحْدِيدٌ أَوَّلُ':Added, #1: 1	تَحْدِيدُ إعَادَةِ
u'تَحْدِيدٌ بَيْتٌ':Added, #1: 1	تَحْدِيدِ أَوَّلِ
u'تَحْدِيدٌ بَيْعٌ':Added, #1: 1	تَحْدِيدِ الْبَيْتِ
u'تَحْدِيدٌ تَيَمُّمٌ':Added, #1: 1	تَحْدِيدُ الْبَيْعِ
u'تَحْدِيدٌ جُنُونٌ':Added, #1: 1	تَحْدِيدُ التَّيَمُّمِ
u'تَحْدِيدٌ دَارٌ':Added, #1: 1	تَحْدِيدِ الْجُنُونِ
u'تَحْدِيدٌ ركبة':Added, #1: 1	تَحْدِيدَ الدَّارِ
u'تَحْدِيدٌ رُكْبَةٌ':Added, #1: 1	تَحْدِيدَ الرُّكْبَةِ
u'تَحْدِيدٌ رِوايَةٌ':Added, #1: 1	تَحْدِيدَ الرُّكْبَةِ
u'تَحْدِيدٌ سَرِيٌّ':Added, #1: 1	تَحْدِيدِ الرِّوَايَةِ
u'تَحْدِيدٌ سَرِيَّةٌ':Added, #1: 1	تَحْدِيدِ السَّرِيَّةِ
u'تَحْدِيدٌ سُفْلٌ':Added, #1: 1	تَحْدِيدِ السَّرِيَّةِ
u'تَحْدِيدٌ شَارِعٌ':Added, #1: 1	تَحْدِيدُ السُّفْلِ
u'تَحْدِيدٌ شافِعِيّ':Added, #1: 1	تَحْدِيدِ الشَّارِعِ
u'تَحْدِيدٌ شَفْرَةٌ':Added, #1: 1	تَحْدِيدُ الشَّافِعِيِّ
u'تَحْدِيدٌ شَيْءٌ':Added, #1: 1	تَحْدِيدِ الشَّفْرَةِ
u'تَحْدِيدٌ طَائِفٌ':Added, #3: 3	تَحْدِيدُ الشَّيْءِ
u'تَحْدِيدٌ عَامٌ':Added, #1: 1	تَحْدِيدِ الطَّائِفَةِ
u'تَحْدِيدٌ عَدَمٌ':Added, #1: 1	تَحْدِيدُ الْعَامِ
u'تَحْدِيدٌ عَشْرٌ':Added, #1: 1	تَحْدِيدِ الْعَدَمِ
u'تَحْدِيدٌ عَقْدٌ':Added, #1: 1	تَحْدِيدَ عَشْرِ
u'تَحْدِيدٌ عُلْوٌ':Added, #1: 1	تَحْدِيدِ الْعَقْدِ
u'تَحْدِيدٌ عُلُوٌّ':Added, #1: 1	تَحْدِيدِ الْعُلْوِ
u'تَحْدِيدٌ عَمَلٌ':Added, #2: 2	تَحْدِيدِ الْعُلُوِّ
u'تَحْدِيدٌ عَمَلٌ':Added, #1: 1	تَحْدِيدُ الْعَمَلِ
u'تَحْدِيدٌ غَسْلٌ':Added, #1: 1	تَحْدِيدِ الْعَمَلِ
u'تَحْدِيدٌ فَاسِدٌ':Added, #2: 2	تَحْدِيدُ غَسْلِ
u'تَحْدِيدٌ فلان':Added, #1: 1	تَحْدِيدِ الْفَاسِدِ
u'تَحْدِيدٌ قَلِيلٌ':Added, #1: 1	تَحْدِيدُ الشَّافِعِيِّ
u'تَحْدِيدٌ كَثِيرٌ':Added, #1: 1	تَحْدِيدِ الْقَلِيلِ
u'تَحْدِيدٌ مُتَقَدِّمٌ':Added, #2: 2	تَحْدِيدِ الْكَثِيرِ
u'تَحْدِيدٌ مُدَّةٌ':Added, #1: 1	تَحْدِيدِ الْمُتَقَدِّمِ
u'تَحْدِيدٌ مَذْهَبٌ':Added, #1: 1	تَحْدِيدِ الْمُدَّةِ
u'تَحْدِيدٌ مُسْتَأْجِرٌ':Added, #1: 1	تَحْدِيدِ مَذْهَبِ
u'تَحْدِيدٌ مُسْتَثْنَى':Added, #1: 1	تَحْدِيدُ الْمُسْتَأْجِرِ
u'تَحْدِيدٌ مِلْكٌ':Added, #1: 1	تَحْدِيدِ الْمُسْتَثْنَيَاتِ
u'تَحْدِيدٌ مِلْكٌ':Added, #1: 1	تَحْدِيدُ الْمِلْكِ
u'تَحْدِيدٌ نَاحِي':Added, #1: 1	تَحْدِيدُ مِلْكٍ
u'تَحْدِيدٌ نَاحِيَةٌ':Added, #1: 1	تَحْدِيدُ النَّاحِيَةِ
u'تَحْدِيدٌ نصاب':Added, #1: 1	تَحْدِيدُ النَّاحِيَةِ
u'تَحْدِيدٌ نِصَابٌ':Added, #1: 1	تَحْدِيدِ النِّصَابِ
u'تَحْدِيدٌ نصاب':Added, #1: 1	تَحْدِيدِ النِّصَابِ
u'تَحْدِيدٌ نِصَابٌ':Added, #1: 1	تَحْدِيدِ نِصَابِ
u'تَحْدِيدٌ نِصْفٌ':Added, #1: 1	تَحْدِيدِ نِصَابِ
u'تَحْدِيدٌ نِصْفٌ':Added, #1: 1	تَحْدِيدَ النِّصْفِ
u'تَحْدِيدٌ نَصِيبٌ':Added, #1: 1	تَحْدِيدِ نِصْفِ
u'تَحْدِيدٌ نَظَرٌ':Added, #1: 1	تَحْدِيدِ النَّصِيبِ
u'تَحْدِيدٌ نَهْيٌ':Added, #1: 1	تَحْدِيدُ النَّظَرِ
u'تَحْدِيدٌ يَوْمٌ':Added, #1: 1	تَحْدِيدِ النَّهْيِ
u'تَحْدِيقٌ مُتَوَسِّلٌ':Added, #1: 1	تَحْدِيدِ يَوْمٍ
u'تَحْذِيرٌ ثِقَة':Added, #1: 1	تَحْدِيقَ مُتَوَسِّلٍ
u'تَحْذِيرٌ نَاسٌ':Added, #3: 3	تَحْذِيرُ الثِّقَاتِ
u'تَحَرَّجَ صَحَابَةٌ':Subject, #1: 1	تَحْذِيرَ النَّاسِ
u'تَحَرَّجَ نَاسٌ':Subject, #1: 1	تَحَرَّجَ الصَّحَابَةُ
u'تَحَرَّرَ جَوَازٌ':Subject, #1: 1	تَحَرَّجَ النَّاسُ
u'تَحَرَّرَ فلان':Subject, #1: 1	تَحَرَّرَ جَوَازُ
u'تَحَرَّزَ فلان':Subject, #1: 1	تَحَرَّرَ سُفْيَانُ
u'تَحَرَّزَ قِيمَةٌ':Predicate, #1: 1	تَحَرَّزَ سُفْيَانُ
u'تَحَرَّقَ مُسْلِمٌ':Subject, #1: 1	تَحَرَّزَ قِيمَةَ
u'تَحَرُّكٌ أَخْلاَطٌ':Added, #1: 1	تَحَرَّقَ مُسْلِمٌ
u'تَحَرُّكٌ أرْضٌ':Added, #1: 1	تَحَرُّكِ الْأَخْلَاطِ
u'تَحَرُّكٌ آلةٌ':Added, #1: 1	تَحَرُّكُ الْأَرْضِ
u'تَحَرَّكَ بَعيرٌ':Subject, #2: 2	تَحَرُّكُ الْآلَةِ
u'تَحَرَّكَ جَازٌ':Predicate, #1: 1	تَحَرَّكَ الْبَعِيرُ
u'تَحَرُّكٌ دُفٌّ':Added, #1: 1	تَحَرَّكَ جَازَ
u'تَحَرُّكٌ رعن':Added, #1: 1	تَحَرُّكَ الدُّفِّ
u'تَحَرَّكَ زَيْدٌ':Subject, #1: 1	تَحَرُّكِ الرَّعَنِ
u'تَحَرُّكٌ طِبَاعٌ':Added, #1: 1	تَحَرَّكَ زَيْدٌ
u'تَحَرَّكَ طرف':Subject, #1: 1	تَحَرُّكُ الطِّبَاعِ
u'تَحَرَّكَ طَرَفٌ':Subject, #2: 2	تَحَرَّكَ الطَّرَفُ
u'تَحَرَّكَ عَرْشٌ':Subject, #2: 2	تَحَرَّكَ الطَّرَفُ
u'تَحَرُّكٌ عِرْقٌ':Added, #1: 1	تَحَرَّكَ الْعَرْشُ
u'تَحَرَّكَ عُضْوٌ':Subject, #1: 1	تَحَرُّكَ عِرْقٍ
u'تَحَرُّكٌ عُضْوٌ':Added, #1: 1	تَحَرَّكَ عُضْوٌ
u'تَحَرُّكٌ قلب':Added, #1: 1	تَحَرُّكِ عُضْوٍ
u'تَحَرُّكٌ قلب':Added, #1: 1	تَحَرُّكَ الْقَلْبِ
u'تَحَرُّكٌ قَلْبٌ':Added, #1: 1	تَحَرُّكُ الْقَلْبِ
u'تَحَرُّكٌ قَلْبٌ':Added, #1: 1	تَحَرُّكَ الْقَلْبِ
u'تَحَرُّكٌ قَلْب':Added, #1: 1	تَحَرُّكُ الْقَلْبِ
u'تَحَرُّكٌ قَلْب':Added, #1: 1	تَحَرُّكَ الْقَلْبِ
u'تَحَرُّكٌ قلب':Added, #1: 1	تَحَرُّكُ الْقَلْبِ
u'تَحَرُّكٌ قَلْبٌ':Added, #1: 1	تَحَرُّكُ قَلْبِهِ
u'تَحَرُّكٌ قَلْب':Added, #1: 1	تَحَرُّكُ قَلْبِهِ
u'تَحَرَّكَ نَتِنٌ':Subject, #1: 1	تَحَرُّكُ قَلْبِهِ
u'تَحَرَّكَ نَجَسٌ':Subject, #1: 1	تَحَرَّكَ نَتِنُهُ
u'تَحَرَّكَ نَجِسٌ':Subject, #1: 1	تَحَرَّكَ النَّجَسُ
u'تَحَرَّكَ ولد':Subject, #1: 1	تَحَرَّكَ النَّجِسُ
u'تَحَرَّكَ وَلَدٌ':Subject, #1: 1	تَحَرَّكَ الْوَلَدُ
u'تَحَرُّكٌ ولد':Added, #1: 1	تَحَرَّكَ الْوَلَدُ
u'تَحَرُّكٌ وَلَدٌ':Added, #3: 3	تَحَرُّكِ الْوَلَدِ
u'تَحَرُّكٌ يَدٌ':Added, #3: 3	تَحَرُّكِ الْوَلَدِ
u'تَحَرِّي إِخْلاَصٌ':Added, #1: 1	تَحَرُّكَ الْيَدِ
u'تَحَرِّي أهْلٌ':Added, #1: 1	تَحَرِّي الْإِخْلَاصِ
u'تَحَرِّي أَوْقَاتٌ':Added, #1: 1	تَحَرِّي أَهْلِ
u'تَحَرِّي أَوْقَاتٌ':Added, #1: 1	تَحَرِّي أَوْقَاتِ
u'تَحَرَّى جَازٌ':Predicate, #2: 2	تَحَرِّي الْأَوْقَاتِ
u'تَحَرِّي جَوَازٌ':Added, #1: 1	تَحَرَّكَ جَازَ
u'تَحْرِيرٌ اِبْنٌ':Added, #1: 1	تَحَرِّيَ الْجَوَازِ
u'تَحْرِيرٌ أَحْكَامٌ':Added, #1: 1	تَحْرِيرِ ابْنِ
u'تَحْرِيرٌ أَحْكَامٌ':Added, #1: 1	تَحْرِيرُ أَحْكَامِ
u'تَحْرِيرٌ أخرَس':Added, #1: 1	تَحْرِيرِ أَحْكَامِ
u'تَحْرِيرٌ آرَاءٌ':Added, #1: 1	تَحْرِيرُ الْأَخْرَسِ
u'تَحْرِيرٌ أُصولٌ':Added, #1: 1	تَحْرِيرِ الْآرَاءِ
u'تَحْرِيرٌ أُصولٌ':Added, #12: 12	تَحْرِيرِ الْأُصُولِ
u'تَحْرِيرٌ أَقْوَالٌ':Added, #1: 1	تَحْرِيرُ أُصُولِ
u'تَحْرِيرٌ إمَامٌ':Added, #1: 1	تَحْرِيرِ الْأَقْوَالِ
u'تَحْرِيرٌ أُمُورٌ':Added, #1: 1	تَحْرِيرِ الْإِمَامِ
u'تَحْرِيرٌ تَرْتِيبٌ':Added, #1: 1	تَحْرِيرِ أُمُورٍ
u'تَحْرِيرٌ تَصْوِيرٌ':Added, #1: 1	تَحْرِيرُ التَّرْتِيبِ
u'تَحْرِيرٌ تَصْوِيرٌ':Added, #1: 1	تَحْرِيرُ التَّصْوِيرِ
u'تَحْرِيرٌ تَنْبِيه':Added, #1: 1	تَحْرِيرِ تَصْوِيرِهِ
u'تَحَرَّى رَجُلٌ':Subject, #1: 1	تَحْرِيرِ التَّنْبِيهِ
u'تَحْرِيرٌ جَوَابٌ':Added, #1: 1	تَحَرَّى رَجُلٌ
u'تَحْرِيرٌ حُكْمٌ':Added, #2: 2	تَحْرِيرِ الْجَوَابِ
u'تَحْرِيرٌ حُكْمٌ':Added, #1: 1	تَحْرِيرَ الْحُكْمِ
u'تَحْرِيرٌ حَمْلٌ':Added, #1: 1	تَحْرِيرُ حُكْمِ
u'تَحْرِيرٌ دَلالٌ':Added, #1: 1	تَحْرِيرِ الْحَمْلِ
u'تَحْرِيرٌ دَلالَةٌ':Added, #1: 1	تَحْرِيرِ الدَّلَالَاتِ
u'تَحْرِيرٌ دَلائِلُ':Added, #1: 1	تَحْرِيرِ الدَّلَالَاتِ
u'تَحْرِيرٌ رَقَبَةٌ':Added, #1: 1	تَحْرِيرُ الدَّلَائِلِ
u'تَحْرِيرٌ رَقَبَةٌ':Added, #19: 19	تَحْرِيرُ رَقَبَةٍ
u'تَحْرِيرٌ رَقَبَةٌ':Added, #1: 1	تَحْرِيرُ الرَّقَبَةِ
u'تَحْرِيرٌ رَقَبَةٌ':Added, #1: 1	تَحْرِيرِ الرَّقَبَةِ
u'تَحْرِيرٌ رَقَبَةٌ':Added, #1: 1	تَحْرِيرِ رَقَبَتِهِ
u'تَحْرِيرٌ رَقَبَةٌ':Added, #2: 2	تَحْرِيرِ رَقَبَةٍ
u'تَحْرِيرٌ سُؤَالٌ':Added, #3: 3	تَحْرِيرَ الرَّقَبَةِ
u'تَحْرِيرٌ شافِع':Added, #2: 2	تَحْرِيرِ السُّؤَالِ
u'تَحْرِيرٌ شافِعِيّ':Added, #2: 2	تَحْرِيرِ الشَّافِعِيَّةِ
u'تَحْرِيرٌ شَرِيكٌ':Added, #2: 2	تَحْرِيرِ الشَّافِعِيَّةِ
u'تَحْرِيرٌ صَحِيحٌ':Added, #1: 1	تَحْرِيرِ الشَّرِيكِ
u'تَحْرِيرٌ عِبَارَةٌ':Added, #2: 2	تَحْرِيرُ الصَّحِيحِ
u'تَحْرِيرٌ فلان':Added, #1: 1	تَحْرِيرُ الْعِبَارَةِ
u'تَحْرِيرٌ قول':Added, #2: 2	تَحْرِيرِ الشَّافِعِيَّةِ
u'تَحْرِيرٌ قَوْلٌ':Added, #1: 1	تَحْرِيرُ الْقَوْلِ
u'تَحْرِيرٌ قول':Added, #1: 1	تَحْرِيرُ الْقَوْلِ
u'تَحْرِيرٌ قَوْلٌ':Added, #1: 1	تَحْرِيرُ قَوْلِ
u'تَحْرِيرٌ كَلاَمٌ':Added, #1: 1	تَحْرِيرُ قَوْلِ
u'تَحْرِيرٌ مَاءٌ':Added, #1: 1	تَحْرِيرُ كَلَامِهِ
u'تَحْرِيرٌ مُحَقِّقٌ':Added, #1: 1	تَحْرِيرُ مَاءِ
u'تَحْرِيرٌ مَحَلٌّ':Added, #1: 1	تَحْرِيرِ الْمُحَقِّقِ
u'تَحْرِيرٌ مَحَلٌّ':Added, #1: 1	تَحْرِيرُ مَحَلِّ
u'تَحْرِيرٌ مُدَبَّرٌ':Added, #3: 3	تَحْرِيرِ مَحَلِّ
u'تَحْرِيرٌ مَذَاهِبُ':Added, #1: 1	تَحْرِيرُ الْمُدَبَّرِ
u'تَحْرِيرٌ مَذَاهِبُ':Added, #1: 1	تَحْرِيرُ الْمَذَاهِبِ
u'تَحْرِيرٌ مَذْهَبٌ':Added, #5: 5	تَحْرِيرِ الْمَذَاهِبِ
u'تَحْرِيرٌ مَذْهَبٌ':Added, #1: 1	تَحْرِيرِ مَذْهَبِ
u'تَحْرِيرٌ مَذْهَبٌ':Added, #2: 2	تَحْرِيرَ الْمَذْهَبِ
u'تَحْرِيرٌ مَذْهَبٌ':Added, #2: 2	تَحْرِيرُ الْمَذْهَبِ
u'تَحْرِيرٌ مَذْهَبٌ':Added, #2: 2	تَحْرِيرِ الْمَذْهَبِ
u'تَحْرِيرٌ مَسْأَلَةٌ':Added, #5: 5	تَحْرِيرُ مَذْهَبِ
u'تَحْرِيرٌ مَسْأَلَةٌ':Added, #1: 1	تَحْرِيرُ مَسْأَلَةِ
u'تَحْرِيرٌ مَشَقَّةٌ':Added, #2: 2	تَحْرِيرُ الْمَسْأَلَةِ
u'تَحْرِيرٌ مُصَنِّفٌ':Added, #1: 1	تَحْرِيرِ الْمَشَقَّةِ
u'تَحْرِيرٌ مُعْتَرِضٌ':Added, #1: 1	تَحْرِيرِ الْمُصَنِّفِ
u'تَحْرِيرٌ مُعْتَمَدٌ':Added, #1: 1	تَحْرِيرِ الْمُعْتَرِضِ
u'تَحْرِيرٌ مُعْتَمَدٌ':Added, #1: 1	تَحْرِيرُ الْمُعْتَمَدِ
u'تَحْرِيرٌ مَقَالٌ':Added, #1: 1	تَحْرِيرِ الْمُعْتَمَدِ
u'تَحْرِيرٌ مَقَالَةٌ':Added, #2: 2	تَحْرِيرِ الْمَقَالِ
u'تَحْرِيرٌ مَمْلُوكٌ':Added, #1: 1	تَحْرِيرِ مَقَالَةِ
u'تَحْرِيرٌ مَوْضِعٌ':Added, #2: 2	تَحْرِيرُ الْمَمْلُوكِ
u'تَحْرِيرٌ نزاع':Added, #1: 1	تَحْرِيرِ مَوْضِعِ
u'تَحْرِيرٌ نِزَاعٌ':Added, #1: 1	تَحْرِيرُ النِّزَاعِ
u'تَحْرِيرٌ نزاع':Added, #1: 1	تَحْرِيرُ النِّزَاعِ
u'تَحْرِيرٌ نِزَاعٌ':Added, #2: 2	تَحْرِيرِ النِّزَاعِ
u'تَحْرِيرٌ نقل':Added, #2: 2	تَحْرِيرِ النِّزَاعِ
u'تَحْرِيرٌ نقل':Added, #1: 1	تَحْرِيرَ النَّقْلِ
u'تَحْرِيرٌ نَقْلٌ':Added, #1: 1	تَحْرِيرِ النَّقْلِ
u'تَحْرِيرٌ نَقْلٌ':Added, #1: 1	تَحْرِيرَ النَّقْلِ
u'تَحْرِيرٌ نقل':Added, #1: 1	تَحْرِيرِ النَّقْلِ
u'تَحْرِيرٌ نَقْلٌ':Added, #3: 3	تَحْرِيرُ النَّقْلِ
u'تَحْرِيرٌ نُقُولٌ':Added, #3: 3	تَحْرِيرُ النَّقْلِ
u'تَحْرِيرٌ نَوَوِيٌّ':Added, #1: 1	تَحْرِيرَ النُّقُولِ
u'تَحْرِيرٌ يَدٌ':Added, #2: 2	تَحْرِيرِ النَّوَوِيِّ
u'تَحَرَّى زِنَة':Predicate, #1: 1	تَحْرِيرِ الْيَدِ
u'تَحَرَّى سُجُودٌ':Predicate, #1: 1	تَحَرَّى زِنَةَ
u'تَحَرِّي شُرُوعٌ':Added, #1: 1	تَحَرَّى السُّجُودَ
u'تَحَرَّى صدق':Predicate, #1: 1	تَحَرِّيَ الشُّرُوعِ
u'تَحَرَّى صِدْقٌ':Predicate, #3: 3	تَحَرَّى الصِّدْقَ
u'تَحَرَّى صَوَابٌ':Predicate, #3: 3	تَحَرَّى الصِّدْقَ
u'تَحْرِيضٌ رَبُّ':Added, #1: 1	تَحَرَّى الصَّوَابَ
u'تَحْرِيضٌ رَهْطٌ':Added, #1: 1	تَحْرِيضِ رَبِّ
u'تَحْرِيضٌ سَامِعٌ':Added, #1: 1	تَحْرِيضُ الرّهْطِ
u'تَحْرِيضٌ قُرَيْشٌ':Added, #1: 1	تَحْرِيضَ سَامِعٍ
u'تَحْرِيضٌ نَاسٌ':Added, #1: 1	تَحْرِيضِ قُرَيْشٍ
u'تَحْرِيضٌ هِنْدٌ':Added, #1: 1	تَحْرِيضَ النَّاسِ
u'تَحَرِّي طَرِيقٌ':Added, #1: 1	تَحْرِيضُ هِنْدٍ
u'تَحَرَّى فَجْرٌ':Predicate, #1: 1	تَحَرِّي طَرِيقِ
u'تَحَرِّي فَجْرٌ':Added, #1: 1	تَحَرَّى الْفَجْرَ
u'تَحْرِيفٌ جَوَابٌ':Added, #1: 1	تَحَرِّي الْفَجْرِ
u'تَحْرِيفٌ حُكْمٌ':Added, #1: 1	تَحْرِيفِ جَوَابٍ
u'تَحْرِيفٌ رِواياتٌ':Added, #2: 2	تَحْرِيفِ الْحُكْمِ
u'تَحْرِيفٌ كَلِمٌ':Added, #1: 1	تَحْرِيفِ الرِّوَايَاتِ
u'تَحْرِيفٌ كَلِمٌ':Added, #1: 1	تَحْرِيفَ الْكَلِمِ
u'تَحْرِيفٌ نُسَّاخٌ':Added, #3: 3	تَحْرِيفِ الْكَلِمِ
u'تَحْرِيقٌ أَمَاكِنُ':Added, #7: 7	تَحْرِيفِ النُّسَّاخِ
u'تَحَرَّى قِبْلَةٌ':Predicate, #2: 2	تَحْرِيقُ أَمَاكِنِ
u'تَحَرِّي قِبْلَةٌ':Added, #1: 1	تَحَرَّى الْقِبْلَةَ
u'تَحْرِيقٌ بَيْتٌ':Added, #2: 2	تَحَرِّي الْقِبْلَةِ
u'تَحْرِيقٌ ثِيابٌ':Added, #1: 1	تَحْرِيقِ بَيْتِ
u'تَحْرِيقٌ رِجْلٌ':Added, #3: 3	تَحْرِيقُ الثِّيَابِ
u'تَحْرِيقٌ رَحْلٌ':Added, #1: 1	تَحْرِيقَ رِجْلِ
u'تَحْرِيقٌ رَحْلٌ':Added, #1: 1	تَحْرِيقَ رَحْلِ
u'تَحَرِّي قَضَاءٌ':Added, #1: 1	تَحْرِيقُ رَحْلِهِ
u'تَحْرِيقٌ مَتَاعٌ':Added, #1: 1	تَحَرِّي الْقَضَاءِ
u'تَحْرِيقٌ نَحْلٌ':Added, #1: 1	تَحْرِيقُ مَتَاعِ
u'تَحَرَّى قَوْمٌ':Subject, #1: 1	تَحْرِيقُ النَّحْلِ
u'تَحْرِيكٌ أَجْفَانٌ':Added, #1: 1	تَحَرَّى قَوْمٌ
u'تَحْرِيكٌ أَجْفَانٌ':Added, #1: 1	تَحْرِيكُ الْأَجْفَانِ
u'تَحْرِيكٌ آخِرُ':Added, #3: 3	تَحْرِيكِ الْأَجْفَانِ
u'تَحْرِيكٌ أرْضٌ':Added, #2: 2	تَحْرِيكَ آخِرِ
u'تَحْرِيكٌ أَصابِعُ':Added, #1: 1	تَحْرِيكُ الْأَرْضِ
u'تَحْرِيكٌ أُصْبُعٌ':Added, #1: 1	تَحْرِيكِ الْأَصَابِعِ
u'تَحْرِيكٌ إِصْبَعٌ':Added, #1: 1	تَحْرِيكُ الْأُصْبُعِ
u'تَحْرِيكٌ آلةٌ':Added, #1: 1	تَحْرِيكُ الإِصْبَعِ
u'تَحْرِيكٌ بدن':Added, #1: 1	تَحْرِيكُ الْآلَةِ
u'تَحْرِيكٌ بَدَنٌ':Added, #1: 1	تَحْرِيكِ الْبَدَنِ
u'تَحْرِيكٌ بَعْضٌ':Added, #1: 1	تَحْرِيكِ الْبَدَنِ
u'تَحْرِيكٌ جَفْنٌ':Added, #1: 1	تَحْرِيكُ بَعْضِ
u'تَحْرِيكٌ راء':Added, #1: 1	تَحْرِيكِ جَفْنٍ
u'تَحْرِيكٌ راء':Added, #1: 1	تَحْرِيكُ الرَّاءِ
u'تَحْرِيكٌ رَأْسٌ':Added, #1: 1	تَحْرِيكِ الرَّاءِ
u'تَحْرِيكٌ رَجُلٌ':Added, #2: 2	تَحْرِيكُ الرَّأْسِ
u'تَحْرِيكٌ رِجْلٌ':Added, #1: 1	تَحْرِيكُ الرَّجُلِ
u'تَحْرِيكٌ سَاكِنٌ':Added, #1: 1	تَحْرِيكُ الرِّجْلَيْنِ
u'تَحْرِيكٌ سَاكِنٌ':Added, #1: 1	تَحْرِيكُ السَّاكِنِ
u'تَحْرِيكٌ سَبَّابٌ':Added, #1: 1	تَحْرِيكِ السَّاكِنِ
u'تَحْرِيكٌ سَبَّابَةٌ':Added, #2: 2	تَحْرِيكِ السَّبَّابَةِ
u'تَحْرِيكٌ شَهْوَةٌ':Added, #2: 2	تَحْرِيكِ السَّبَّابَةِ
u'تَحْرِيكٌ شَهْوَةٌ':Added, #1: 1	تَحْرِيكِ الشَّهْوَةِ
u'تَحْرِيكٌ شَيْءٌ':Added, #1: 1	تَحْرِيكِ شَهْوَةٍ
u'تَحْرِيكٌ عُضْوٌ':Added, #1: 1	تَحْرِيكُ الشَّيْءِ
u'تَحْرِيكٌ غَاصِبٌ':Added, #2: 2	تَحْرِيكِ عُضْوٍ
u'تَحْرِيكٌ فتنة':Added, #1: 1	تَحْرِيكِ الْغَاصِبِ
u'تَحْرِيكٌ فِتْنَةٌ':Added, #1: 1	تَحْرِيكَ الْفِتْنَةِ
u'تَحْرِيكٌ فتنة':Added, #1: 1	تَحْرِيكَ الْفِتْنَةِ
u'تَحْرِيكٌ فتنة':Added, #1: 1	تَحْرِيكَ فِتْنَةٍ
u'تَحْرِيكٌ فِتْنَةٌ':Added, #1: 1	تَحْرِيكِ فِتْنَةٍ
u'تَحْرِيكٌ فِتْنَةٌ':Added, #1: 1	تَحْرِيكَ فِتْنَةٍ
u'تَحْرِيكٌ قَافٌ':Added, #1: 1	تَحْرِيكِ فِتْنَةٍ
u'تَحْرِيكٌ قُبْلَةٌ':Added, #1: 1	تَحْرِيكِ الْقَافِ
u'تَحْرِيكٌ قُرْطٌ':Added, #1: 1	تَحْرِيكُ الْقُبْلَةِ
u'تَحْرِيكٌ قُلُوبٌ':Added, #2: 2	تَحْرِيكُ الْقُرْطِ
u'تَحْرِيكٌ قَيْءٌ':Added, #1: 1	تَحْرِيكُ الْقُلُوبِ
u'تَحْرِيكٌ كَفٌّ':Added, #1: 1	تَحْرِيكَ الْقَيْءِ
u'تَحْرِيكٌ لِسَانٌ':Added, #1: 1	تَحْرِيكِ الْكَفِّ
u'تَحْرِيكٌ لِسَانٌ':Added, #1: 1	تَحْرِيكَ اللِّسَانِ
u'تَحْرِيكٌ لِسَانٌ':Added, #1: 1	تَحْرِيكِ اللِّسَانِ
u'تَحْرِيكٌ لِسَانٌ':Added, #1: 1	تَحْرِيكُ لِسَانِ
u'تَحْرِيكٌ لِسَانٌ':Added, #1: 1	تَحْرِيكِ لِسَانٍ
u'تَحْرِيكٌ لِسَانٌ':Added, #1: 1	تَحْرِيكِ لِسَانِهِ
u'تَحْرِيكٌ لِسَانٌ':Added, #5: 5	تَحْرِيكُ لِسَانِهِ
u'تَحْرِيكٌ مَاءٌ':Added, #6: 6	تَحْرِيكُ اللِّسَانِ
u'تَحْرِيكٌ مَالٌ':Added, #2: 2	تَحْرِيكِ الْمَاءِ
u'تَحْرِيكٌ نَعْلٌ':Added, #1: 1	تَحْرِيكِ مَالِهِ
u'تَحْرِيكٌ يَدٌ':Added, #1: 1	تَحْرِيكَ النَّعْلِ
u'تَحْرِيكٌ يَدٌ':Added, #1: 1	تَحْرِيكَ الْيَدِ
u'تَحْرِيكٌ يَدٌ':Added, #1: 1	تَحْرِيكُ الْيَدِ
u'تَحْرِيكٌ يَدٌ':Added, #1: 1	تَحْرِيكَ الْيَدَيْنِ
u'تَحْرِيمٌ آبارٌ':Added, #1: 1	تَحْرِيكُ يَدٍ
u'تَحْرِيمٌ اِبْتِداءٌ':Added, #1: 1	تَحْرِيمِ آبَارِ
u'تَحْرِيمٌ إِبِلٌ':Added, #1: 1	تَحْرِيمِ ابْتِدَاءِ
u'تَحْرِيمٌ اِتِّخَاذٌ':Added, #1: 1	تَحْرِيمِ الْإِبِلِ
u'تَحْرِيمٌ اِتِّخَاذٌ':Added, #1: 1	تَحْرِيمِ اتِّخَاذِهِ
u'تَحْرِيمٌ إِتْيانٌ':Added, #2: 2	تَحْرِيمِ اتِّخَاذِ
u'تَحْرِيمٌ أَجْنَبِيٌّ':Added, #1: 1	تَحْرِيمِ إتْيَانِ
u'تَحْرِيمٌ أَجْنَبِيٌّ':Added, #1: 1	تَحْرِيمُ الْأَجْنَبِيَّاتِ
u'تَحْرِيمٌ اِحْتِكَارٌ':Added, #1: 1	تَحْرِيمَ الْأَجْنَبِيَّةِ
u'تَحْرِيمٌ أحَدٌ':Added, #1: 1	تَحْرِيمِ احْتِكَارِ
u'تَحْرِيمٌ أحَدٌ':Added, #1: 1	تَحْرِيمُ أَحَدِ
u'تَحْرِيمٌ أُخْتٌ':Added, #2: 2	تَحْرِيمِ أَحَدِ
u'تَحْرِيمٌ أُخْتٌ':Added, #1: 1	تَحْرِيمُ الْأُخْتِ
u'تَحْرِيمٌ أُخْتٌ':Added, #1: 1	تَحْرِيمِ الْأُخْتِ
u'تَحْرِيمٌ أخْذٌ':Added, #2: 2	تَحْرِيمِ الْأُخْتَيْنِ
u'تَحْرِيمٌ أخْذٌ':Added, #1: 1	تَحْرِيمَ أَخْذِ
u'تَحْرِيمٌ أخْذٌ':Added, #1: 1	تَحْرِيمِ أَخْذِ
u'تَحْرِيمٌ إِخْرَاجٌ':Added, #1: 1	تَحْرِيمُ الْأَخْذِ
u'تَحْرِيمٌ إِخْرَاجٌ':Added, #1: 1	تَحْرِيمُ إخْرَاجِ
u'تَحْرِيمٌ أَدَاءٌ':Added, #1: 1	تَحْرِيمِ الْإِخْرَاجِ
u'تَحْرِيمٌ إدْخَالٌ':Added, #2: 2	تَحْرِيمِ الْأَدَاءِ
u'تَحْرِيمٌ إِذْنٌ':Added, #3: 3	تَحْرِيمَ إدْخَالِ
u'تَحْرِيمٌ أَرْبَعُ':Added, #1: 1	تَحْرِيمِ الْإِذْنِ
u'تَحْرِيمٌ أَرُزٌّ':Added, #1: 1	تَحْرِيمُ الْأَرْبَعِ
u'تَحْرِيمٌ إِرْكَابٌ':Added, #1: 1	تَحْرِيمِ الْأَرُزِّ
u'تَحْرِيمٌ إِرْكَابٌ':Added, #1: 1	تَحْرِيمُ إرْكَابِ
u'تَحْرِيمٌ اِسْتِصْحابٌ':Added, #1: 1	تَحْرِيمِ إرْكَابِ
u'تَحْرِيمٌ اِسْتِعْمالٌ':Added, #1: 1	تَحْرِيمُ اسْتِصْحَابِ
u'تَحْرِيمٌ اِسْتِعْمالٌ':Added, #1: 1	تَحْرِيمِ اسْتِعْمَالِ
u'تَحْرِيمٌ اِسْتِعْمالٌ':Added, #1: 1	تَحْرِيمَ اسْتِعْمَالِهِ
u'تَحْرِيمٌ اِسْتِقْبالٌ':Added, #4: 4	تَحْرِيمُ اسْتِعْمَالِ
u'تَحْرِيمٌ أسْئِلَةٌ':Added, #1: 1	تَحْرِيمِ اسْتِقْبَالِهِ
u'تَحْرِيمٌ إشارَة':Added, #1: 1	تَحْرِيمَ أَسْئِلَةِ
u'تَحْرِيمٌ أًصْلٌ':Added, #1: 1	تَحْرِيمِ الْإِشَارَةِ
u'تَحْرِيمٌ إِضاعَةٌ':Added, #1: 1	تَحْرِيمُ أَصْلٍ
u'تَحْرِيمٌ أطايب':Added, #1: 1	تَحْرِيمِ إضَاعَةِ
u'تَحْرِيمٌ إِطْلاقٌ':Added, #1: 1	تَحْرِيمَ الْأَطَايِبِ
u'تَحْرِيمٌ إِظْهارٌ':Added, #1: 1	تَحْرِيمِ إطْلَاقِ
u'تَحْرِيمٌ إفْتَاءٌ':Added, #1: 1	تَحْرِيمِ إظْهَارِ
u'تَحْرِيمٌ إِفْرَادٌ':Added, #1: 1	تَحْرِيمِ إفْتَاءِ
u'تَحْرِيمٌ إقامَةٌ':Added, #2: 2	تَحْرِيمِ إفْرَادِهِ
u'تَحْرِيمٌ اِقْتِناءٌ':Added, #1: 1	تَحْرِيمِ إقَامَةِ
u'تَحْرِيمٌ إكْثَارٌ':Added, #1: 1	تَحْرِيمُ اقْتِنَاءِ
u'تَحْرِيمٌ أكل':Added, #1: 1	تَحْرِيمُ إكْثَارِ
u'تَحْرِيمٌ أَكْلٌ':Added, #1: 1	تَحْرِيمَ أَكْلِ
u'تَحْرِيمٌ أكل':Added, #1: 1	تَحْرِيمَ أَكْلِ
u'تَحْرِيمٌ أَكْلٌ':Added, #1: 1	تَحْرِيمِ الأَكْلِ
u'تَحْرِيمٌ أكل':Added, #1: 1	تَحْرِيمِ الأَكْلِ
u'تَحْرِيمٌ أَكْلٌ':Added, #2: 2	تَحْرِيمَ أَكْلِهِ
u'تَحْرِيمٌ أكل':Added, #2: 2	تَحْرِيمَ أَكْلِهِ
u'تَحْرِيمٌ أَكْلٌ':Added, #2: 2	تَحْرِيمَ الْأَكْلِ
u'تَحْرِيمٌ أكل':Added, #2: 2	تَحْرِيمَ الْأَكْلِ
u'تَحْرِيمٌ أَكْلٌ':Added, #3: 3	تَحْرِيمِ أَكْلِ
u'تَحْرِيمٌ أكل':Added, #3: 3	تَحْرِيمِ أَكْلِ
u'تَحْرِيمٌ أَكْلٌ':Added, #3: 3	تَحْرِيمِ أَكْلِهِ
u'تَحْرِيمٌ أكل':Added, #3: 3	تَحْرِيمِ أَكْلِهِ
u'تَحْرِيمٌ أَكْلٌ':Added, #4: 4	تَحْرِيمُ الْأَكْلِ
u'تَحْرِيمٌ أكل':Added, #4: 4	تَحْرِيمُ الْأَكْلِ
u'تَحْرِيمٌ أَكْلٌ':Added, #5: 5	تَحْرِيمِ الْأَكْلِ
u'تَحْرِيمٌ إلْبَاسٌ':Added, #5: 5	تَحْرِيمِ الْأَكْلِ
u'تَحْرِيمٌ آلةٌ':Added, #1: 1	تَحْرِيمِ إلْبَاسِ
u'تَحْرِيمٌ الْمَرْأَةُ':Added, #1: 1	تَحْرِيمُ الْآلَةِ
u'تَحْرِيمٌ الْمَرْأَةُ':Added, #1: 1	تَحْرِيمِ الْمَرْأَةِ
u'تَحْرِيمٌ إمَامٌ':Added, #2: 2	تَحْرِيمَ الْمَرْأَةِ
u'تَحْرِيمٌ إمَامٌ':Added, #1: 1	تَحْرِيمِ الْإِمَامِ
u'تَحْرِيمٌ أمَةٌ':Added, #1: 1	تَحْرِيمِ إمَامِهِ
u'تَحْرِيمٌ أُمَّهَاتٌ':Added, #1: 1	تَحْرِيمُ الْأَمَةِ
u'تَحْرِيمٌ أُمَّهَاتٌ':Added, #1: 1	تَحْرِيمَ الأُمَّهَاتِ
u'تَحْرِيمٌ إِناءٌ':Added, #2: 2	تَحْرِيمِ الْأُمَّهَاتِ
u'تَحْرِيمٌ إِناءٌ':Added, #1: 1	تَحْرِيمِ إنَاءٍ
u'تَحْرِيمٌ إِنْقَاذٌ':Added, #2: 2	تَحْرِيمِ الْإِنَاءِ
u'تَحْرِيمٌ أَنْوَاعٌ':Added, #1: 1	تَحْرِيمَ إنْقَاذِ
u'تَحْرِيمٌ أَنْوَاعٌ':Added, #1: 1	تَحْرِيمَ الْأَنْوَاعِ
u'تَحْرِيمٌ أَنْوَاعٌ':Added, #1: 1	تَحْرِيمَ أَنْوَاعِ
u'تَحْرِيمٌ آنِيَةٌ':Added, #1: 1	تَحْرِيمِ أَنْوَاعِ
u'تَحْرِيمٌ إهْدَارٌ':Added, #1: 1	تَحْرِيمُ الْآنِيَةِ
u'تَحْرِيمٌ أهْلٌ':Added, #1: 1	تَحْرِيمِ إهْدَارِهِ
u'تَحْرِيمٌ أهْلٌ':Added, #1: 1	تَحْرِيمُ الْأَهْلِ
u'تَحْرِيمٌ أَوْسَاخٌ':Added, #1: 1	تَحْرِيمِ أَهْلِهِ
u'تَحْرِيمٌ بُرٌّ':Added, #1: 1	تَحْرِيمُ أَوْسَاخِ
u'تَحْرِيمٌ بُصاقٌ':Added, #1: 1	تَحْرِيمِ الْبُرِّ
u'تَحْرِيمٌ بِطانَةٌ':Added, #1: 1	تَحْرِيمُ الْبُصَاقِ
u'تَحْرِيمٌ بِطانَةٌ':Added, #1: 1	تَحْرِيمِ الْبِطَانَةِ
u'تَحْرِيمٌ بَعْضٌ':Added, #1: 1	تَحْرِيمَ بِطَانَةِ
u'تَحْرِيمٌ بَعْضٌ':Added, #1: 1	تَحْرِيمَ بَعْضِ
u'تَحْرِيمٌ بِنَاءٌ':Added, #1: 1	تَحْرِيمِ بَعْضِ
u'تَحْرِيمٌ بِنَاءٌ':Added, #1: 1	تَحْرِيمَ الْبِنَاءِ
u'تَحْرِيمٌ بناتٌ':Added, #2: 2	تَحْرِيمِ الْبِنَاءِ
u'تَحْرِيمٌ بِنْتٌ':Added, #1: 1	تَحْرِيمِ بَنَاتِ
u'تَحْرِيمٌ بِنْتٌ':Added, #1: 1	تَحْرِيمَ بِنْتِ
u'تَحْرِيمٌ بِنْتٌ':Added, #1: 1	تَحْرِيمِ بِنْتِ
u'تَحْرِيمٌ بَوْلٌ':Added, #2: 2	تَحْرِيمِ الْبِنْتِ
u'تَحْرِيمٌ بَيْعٌ':Added, #1: 1	تَحْرِيمُ الْبَوْلِ
u'تَحْرِيمٌ بَيْعٌ':Added, #1: 1	تَحْرِيمَ الْبَيْعِ
u'تَحْرِيمٌ بَيْعٌ':Added, #1: 1	تَحْرِيمِ بَيْعٍ
u'تَحْرِيمٌ بَيْعٌ':Added, #2: 2	تَحْرِيمُ بَيْعِ
u'تَحْرِيمٌ بَيْعٌ':Added, #2: 2	تَحْرِيمِ بَيْعِهِ
u'تَحْرِيمٌ بَيْعٌ':Added, #3: 3	تَحْرِيمِ بَيْعِ
u'تَحْرِيمٌ بيوع':Added, #4: 4	تَحْرِيمِ الْبَيْعِ
u'تَحْرِيمٌ تَأْخِيرٌ':Added, #1: 1	تَحْرِيمِ بُيُوعِ
u'تَحْرِيمٌ تَبَرُّعٌ':Added, #1: 1	تَحْرِيمِ التَّأْخِيرِ
u'تَحْرِيمٌ تِجَارَةٌ':Added, #1: 1	تَحْرِيمَ التَّبَرُّعَاتِ
u'تَحْرِيمٌ تَحْلِيَةٌ':Added, #1: 1	تَحْرِيمِ التِّجَارَةِ
u'تَحْرِيمٌ تَحْلِيف':Added, #1: 1	تَحْرِيمِ تَحْلِيَةِ
u'تَحْرِيمٌ تَرْكٌ':Added, #2: 2	تَحْرِيمِ تَحْلِيفِ
u'تَحْرِيمٌ تَرْكٌ':Added, #1: 1	تَحْرِيمُ تَرْكِهِ
u'تَحْرِيمٌ تَسْعِيرٌ':Added, #2: 2	تَحْرِيمُ التَّرْكِ
u'تَحْرِيمٌ تَشَبُّه':Added, #1: 1	تَحْرِيمِ التَّسْعِيرِ
u'تَحْرِيمٌ تَشْيِيعٌ':Added, #1: 1	تَحْرِيمَ التَّشَبُّهِ
u'تَحْرِيمٌ تَصَدُّقٌ':Added, #1: 1	تَحْرِيمَ تَشْيِيعِ
u'تَحْرِيمٌ تَصْوِيرٌ':Added, #2: 2	تَحْرِيمِ التَّصَدُّقِ
u'تَحْرِيمٌ تَصْوِيرٌ':Added, #1: 1	تَحْرِيمِ تَصْوِيرِهِ
u'تَحْرِيمٌ تَضَمُّخٌ':Added, #2: 2	تَحْرِيمَ التَّصْوِيرِ
u'تَحْرِيمٌ تَعَرُّضٌ':Added, #1: 1	تَحْرِيمِ التَّضَمُّخِ
u'تَحْرِيمٌ تَعْرِيفٌ':Added, #1: 1	تَحْرِيمِ تَعَرُّضٍ
u'تَحْرِيمٌ تَعْلِيقٌ':Added, #1: 1	تَحْرِيمُ التَّعْرِيفِ
u'تَحْرِيمٌ تُفَّاحَةٌ':Added, #1: 1	تَحْرِيمَ تَعْلِيقِ
u'تَحْرِيمٌ تَفَاضُلٌ':Added, #1: 1	تَحْرِيمُ التُّفَّاحَةِ
u'تَحْرِيمٌ تَفَاضُلٌ':Added, #10: 10	تَحْرِيمِ التَّفَاضُلِ
u'تَحْرِيمٌ تَفْرِيقٌ':Added, #1: 1	تَحْرِيمُ التَّفَاضُلِ
u'تَحْرِيمٌ تَفْرِيقٌ':Added, #1: 1	تَحْرِيمَ التَّفْرِيقِ
u'تَحْرِيمٌ تَفْرِيقٌ':Added, #1: 1	تَحْرِيمِ التَّفْرِيقِ
u'تَحْرِيمٌ تَقَدُّمٌ':Added, #2: 2	تَحْرِيمُ التَّفْرِيقِ
u'تَحْرِيمٌ تَقْليدٌ':Added, #1: 1	تَحْرِيمِ تَقَدُّمِ
u'تَحْرِيمٌ تَقْليد':Added, #1: 1	تَحْرِيمِ التَّقْلِيدِ
u'تَحْرِيمٌ تَقْليدٌ':Added, #1: 1	تَحْرِيمِ التَّقْلِيدِ
u'تَحْرِيمٌ تَقْليد':Added, #1: 1	تَحْرِيمِ تَقْلِيدِ
u'تَحْرِيمٌ تَكْرارٌ':Added, #1: 1	تَحْرِيمِ تَقْلِيدِ
u'تَحْرِيمٌ تَكْفينٌ':Added, #3: 3	تَحْرِيمِ تَكْرَارِ
u'تَحْرِيمٌ تَلْبيَةٌ':Added, #1: 1	تَحْرِيمِ تَكْفِينِ
u'تَحْرِيمٌ تَلَفُّظٌ':Added, #1: 1	تَحْرِيمُ تَلْبِيَةِ
u'تَحْرِيمٌ تَلْقيبٌ':Added, #1: 1	تَحْرِيمَ التَّلَفُّظِ
u'تَحْرِيمٌ تَمَتُّعٌ':Added, #1: 1	تَحْرِيمِ تَلْقِيبِ
u'تَحْرِيمٌ تَمَتُّعٌ':Added, #1: 1	تَحْرِيمَ التَّمَتُّعِ
u'تَحْرِيمٌ تَنَاوُلٌ':Added, #2: 2	تَحْرِيمُ التَّمَتُّعِ
u'تَحْرِيمٌ تَنَاوُلٌ':Added, #1: 1	تَحْرِيمِ تَنَاوُلِ
u'تَحْرِيمٌ تَيَمُّمٌ':Added, #1: 1	تَحْرِيمِ تَنَاوُلِهِ
u'تَحْرِيمٌ ثَانِي':Added, #1: 1	تَحْرِيمُ التَّيَمُّمِ
u'تَحْرِيمٌ ثَانِيَةٌ':Added, #2: 2	تَحْرِيمَ الثَّانِيَةِ
u'تَحْرِيمٌ ثَعْلَبٌ':Added, #2: 2	تَحْرِيمَ الثَّانِيَةِ
u'تَحْرِيمٌ ثَمَنٌ':Added, #1: 1	تَحْرِيمُ الثَّعْلَبِ
u'تَحْرِيمٌ جَارِي':Added, #1: 1	تَحْرِيمُ ثَمَنِ
u'تَحْرِيمٌ جَارِيَةٌ':Added, #1: 1	تَحْرِيمَ الْجَارِيَةِ
u'تَحَرَّى مُجْتَهِد':Subject, #1: 1	تَحْرِيمَ الْجَارِيَةِ
u'تَحَرِّي مُجْتَهِد':Added, #1: 1	تَحَرَّى الْمُجْتَهِدُ
u'تَحْرِيمٌ جَلاَلَةٌ':Added, #1: 1	تَحَرِّي الْمُجْتَهِدِ
u'تَحْرِيمٌ جماع':Added, #1: 1	تَحْرِيمَ الْجَلَالَةِ
u'تَحْرِيمٌ جِمَاعٌ':Added, #1: 1	تَحْرِيمُ الْجِمَاعِ
u'تَحْرِيمٌ جماع':Added, #1: 1	تَحْرِيمُ الْجِمَاعِ
u'تَحْرِيمٌ جِمَاعٌ':Added, #3: 3	تَحْرِيمَ الْجِمَاعِ
u'تَحْرِيمٌ جمع':Added, #3: 3	تَحْرِيمَ الْجِمَاعِ
u'تَحْرِيمٌ جَمْعٌ':Added, #10: 10	تَحْرِيمِ الْجَمْعِ
u'تَحْرِيمٌ جمع':Added, #10: 10	تَحْرِيمِ الْجَمْعِ
u'تَحْرِيمٌ جَمْعٌ':Added, #1: 1	تَحْرِيمُ الْجَمْعِ
u'تَحْرِيمٌ جمع':Added, #1: 1	تَحْرِيمُ الْجَمْعِ
u'تَحْرِيمٌ جمع':Added, #1: 1	تَحْرِيمُ جَمْعِ
u'تَحْرِيمٌ جَمْعٌ':Added, #1: 1	تَحْرِيمِ جَمْعِ
u'تَحْرِيمٌ جَمْعٌ':Added, #1: 1	تَحْرِيمُ جَمْعِ
u'تَحْرِيمٌ جمع':Added, #1: 1	تَحْرِيمِ جَمْعِ
u'تَحْرِيمٌ جَمْعٌ':Added, #1: 1	تَحْرِيمُ جَمْعِهِ
u'تَحْرِيمٌ جمع':Added, #1: 1	تَحْرِيمُ جَمْعِهِ
u'تَحْرِيمٌ جَمْعٌ':Added, #4: 4	تَحْرِيمَ الْجَمْعِ
u'تَحْرِيمٌ جمعة':Added, #4: 4	تَحْرِيمَ الْجَمْعِ
u'تَحْرِيمٌ جُمُعَةٌ':Added, #1: 1	تَحْرِيمِ الْجُمُعَةِ
u'تَحْرِيمٌ جَمِيع':Added, #1: 1	تَحْرِيمِ الْجُمُعَةِ
u'تَحْرِيمٌ جَمِيع':Added, #2: 2	تَحْرِيمِ الْجَمِيعِ
u'تَحْرِيمٌ جِنْسٌ':Added, #3: 3	تَحْرِيمُ الْجَمِيعِ
u'تَحْرِيمٌ جِهَةٌ':Added, #1: 1	تَحْرِيمُ الْجِنْسِ
u'تَحْرِيمٌ جَوْزٌ':Added, #1: 1	تَحْرِيمَ جِهَاتِ
u'تَحْرِيمٌ حُرٌّ':Added, #2: 2	تَحْرِيمِ الْجَوْزَةِ
u'تَحْرِيمٌ حَرائِرُ':Added, #1: 1	تَحْرِيمِ الْحُرَّةِ
u'تَحْرِيمٌ حَرَائِرُ':Added, #1: 1	تَحْرِيمِ حَرَائِرِ
u'تَحْرِيمٌ حَرِيرٌ':Added, #1: 1	تَحْرِيمِ حَرَائِرِ
u'تَحْرِيمٌ حسد':Added, #1: 1	تَحْرِيمِ الْحَرِيرِ
u'تَحْرِيمٌ حَسَدٌ':Added, #2: 2	تَحْرِيمِ الْحَسَدِ
u'تَحْرِيمٌ حَشَرَةٌ':Added, #2: 2	تَحْرِيمِ الْحَسَدِ
u'تَحْرِيمٌ حَشْوٌ':Added, #1: 1	تَحْرِيمِ الْحَشَرَاتِ
u'تَحْرِيمٌ حَشِيشٌ':Added, #1: 1	تَحْرِيمَ حَشْوِ
u'تَحْرِيمٌ حَشِيشٌ':Added, #1: 1	تَحْرِيمِ الْحَشِيشِ
u'تَحْرِيمٌ حُضورٌ':Added, #1: 1	تَحْرِيمِ الْحَشِيشَةِ
u'تَحْرِيمٌ حُضُورٌ':Added, #1: 1	تَحْرِيمُ الْحُضُورِ
u'تَحْرِيمٌ حُضورٌ':Added, #1: 1	تَحْرِيمُ الْحُضُورِ
u'تَحْرِيمٌ حُضُورٌ':Added, #1: 1	تَحْرِيمِ حُضُورِ
u'تَحْرِيمٌ حُكْمٌ':Added, #1: 1	تَحْرِيمِ حُضُورِ
u'تَحْرِيمٌ حِلٌّ':Added, #1: 1	تَحْرِيمُ الْحُكْمِ
u'تَحْرِيمٌ حَلالٌ':Added, #1: 1	تَحْرِيمُ الْحِلِّ
u'تَحْرِيمٌ حَلالٌ':Added, #11: 11	تَحْرِيمَ الْحَلَالِ
u'تَحْرِيمٌ حَلالٌ':Added, #20: 20	تَحْرِيمِ الْحَلَالِ
u'تَحْرِيمٌ حَلالٌ':Added, #2: 2	تَحْرِيمُ حَلَالٍ
u'تَحْرِيمٌ حَلالٌ':Added, #2: 2	تَحْرِيمِ حَلَالٍ
u'تَحْرِيمٌ حِلْيَةٌ':Added, #6: 6	تَحْرِيمُ الْحَلَالِ
u'تَحْرِيمٌ حَمَائِلُ':Added, #2: 2	تَحْرِيمِ حِلْيَةِ
u'تَحْرِيمٌ حمر':Added, #1: 1	تَحْرِيمِ الْحَمَائِلِ
u'تَحْرِيمٌ حُمُرٌ':Added, #1: 1	تَحْرِيمِ الْحُمُرِ
u'تَحْرِيمٌ حَمْلٌ':Added, #1: 1	تَحْرِيمِ الْحُمُرِ
u'تَحْرِيمٌ حَمْلٌ':Added, #1: 1	تَحْرِيمُ حَمْلِهِ
u'تَحْرِيمٌ حِنَّاءٌ':Added, #1: 1	تَحْرِيمِ حَمْلِهِ
u'تَحْرِيمٌ حِنَّاءٌ':Added, #1: 1	تَحْرِيمَ الْحِنَّاءِ
u'تَحْرِيمٌ حَيْضٌ':Added, #1: 1	تَحْرِيمِ الْحِنَّاءِ
u'تَحْرِيمٌ حَيَوَانٌ':Added, #1: 1	تَحْرِيمَ الْحَيْضِ
u'تَحْرِيمٌ حَيَوَانٌ':Added, #1: 1	تَحْرِيمُ الْحَيَوَانِ
u'تَحْرِيمٌ حَيَوَانٌ':Added, #1: 1	تَحْرِيمِ حَيَوَانِ
u'تَحْرِيمٌ خداع':Added, #2: 2	تَحْرِيمِ حَيَوَانٍ
u'تَحْرِيمٌ خِدَاعٌ':Added, #2: 2	تَحْرِيمَ الْخِدَاعِ
u'تَحْرِيمٌ خُصُوصِيٌّ':Added, #2: 2	تَحْرِيمَ الْخِدَاعِ
u'تَحْرِيمٌ خِطَابٌ':Added, #1: 1	تَحْرِيمُ الْخُصُوصِيَّاتِ
u'تَحْرِيمٌ خطبة':Added, #1: 1	تَحْرِيمُ خِطَابِ
u'تَحْرِيمٌ خِطْبَةٌ':Added, #1: 1	تَحْرِيمِ الْخِطْبَةِ
u'تَحْرِيمٌ خطبة':Added, #1: 1	تَحْرِيمِ الْخِطْبَةِ
u'تَحْرِيمٌ خِطْبَةٌ':Added, #1: 1	تَحْرِيمُ خِطْبَةِ
u'تَحْرِيمٌ خطبة':Added, #1: 1	تَحْرِيمُ خِطْبَةِ
u'تَحْرِيمٌ خِطْبَةٌ':Added, #2: 2	تَحْرِيمَ الْخِطْبَةِ
u'تَحْرِيمٌ خَلْوَةٌ':Added, #2: 2	تَحْرِيمَ الْخِطْبَةِ
u'تَحْرِيمٌ خَلْوَةٌ':Added, #1: 1	تَحْرِيمُ الْخَلْوَةِ
u'تَحْرِيمٌ خَلِيط':Added, #2: 2	تَحْرِيمِ الْخَلْوَةِ
u'تَحْرِيمٌ خَمْرٌ':Added, #1: 1	تَحْرِيمِ الْخَلِيطَيْنِ
u'تَحْرِيمٌ خَمْرٌ':Added, #1: 1	تَحْرِيمِ خَمْرٍ
u'تَحْرِيمٌ خَمْرٌ':Added, #20: 20	تَحْرِيمُ الْخَمْرِ
u'تَحْرِيمٌ خَمْرٌ':Added, #34: 34	تَحْرِيمِ الْخَمْرِ
u'تَحْرِيمٌ دُخُولٌ':Added, #8: 8	تَحْرِيمَ الْخَمْرِ
u'تَحْرِيمٌ دُخُولٌ':Added, #1: 1	تَحْرِيمُ الدُّخُولِ
u'تَحْرِيمٌ دُخُولٌ':Added, #1: 1	تَحْرِيمُ دُخُولِهِ
u'تَحْرِيمٌ دفن':Added, #2: 2	تَحْرِيمِ دُخُولِهِ
u'تَحْرِيمٌ دَفْنٌ':Added, #1: 1	تَحْرِيمُ الدَّفْنِ
u'تَحْرِيمٌ دَلالَةٌ':Added, #1: 1	تَحْرِيمُ الدَّفْنِ
u'تَحْرِيمٌ دَمٌ':Added, #1: 1	تَحْرِيمُ الدَّلَالَةِ
u'تَحْرِيمٌ دِماءٌ':Added, #1: 1	تَحْرِيمِ الدَّمِ
u'تَحْرِيمٌ ذُبابٌ':Added, #1: 1	تَحْرِيمِ الدِّمَاءِ
u'تَحْرِيمٌ ذُبابٌ':Added, #1: 1	تَحْرِيمُ الذُّبَابِ
u'تَحْرِيمٌ ذَبيحٌ':Added, #1: 1	تَحْرِيمِ الذُّبَابِ
u'تَحْرِيمٌ ذَبيحَةٌ':Added, #1: 1	تَحْرِيمِ ذَبِيحَةِ
u'تَحْرِيمٌ ذَرائِعُ':Added, #1: 1	تَحْرِيمِ ذَبِيحَةِ
u'تَحْرِيمٌ ذَكاةٌ':Added, #1: 1	تَحْرِيمِ الذَّرَائِعِ
u'تَحْرِيمٌ ذَهَبٌ':Added, #1: 1	تَحْرِيمُ الذَّكَاةِ
u'تَحْرِيمٌ ذَهَبٌ':Added, #1: 1	تَحْرِيمَ الذَّهَبِ
u'تَحْرِيمٌ ذَهَبٌ':Added, #1: 1	تَحْرِيمُ الذَّهَبِ
u'تَحْرِيمٌ رَبِيبَةٌ':Added, #2: 2	تَحْرِيمِ الذَّهَبِ
u'تَحْرِيمٌ رَبِيبَةٌ':Added, #2: 2	تَحْرِيمَ الرَّبِيبَةِ
u'تَحْرِيمٌ رجعة':Added, #5: 5	تَحْرِيمِ الرَّبِيبَةِ
u'تَحْرِيمٌ رَجْعَةٌ':Added, #1: 1	تَحْرِيمُ الرَّجْعَةِ
u'تَحْرِيمٌ رَسُولٌ':Added, #1: 1	تَحْرِيمُ الرَّجْعَةِ
u'تَحْرِيمٌ رضاع':Added, #1: 1	تَحْرِيمَ رَسُولِ
u'تَحْرِيمٌ رضاع':Added, #3: 3	تَحْرِيمَ الرَّضَاعِ
u'تَحْرِيمٌ رضعة':Added, #3: 3	تَحْرِيمُ الرَّضَاعِ
u'تَحْرِيمٌ رُكوبٌ':Added, #1: 1	تَحْرِيمُ الرَّضْعَةِ
u'تَحْرِيمٌ رَمْيٌ':Added, #1: 1	تَحْرِيمَ رُكُوبِ
u'تَحْرِيمٌ رهان':Added, #2: 2	تَحْرِيمُ الرَّمْيِ
u'تَحْرِيمٌ رِهانٌ':Added, #1: 1	تَحْرِيمِ الرِّهَانِ
u'تَحْرِيمٌ رَهْنٌ':Added, #1: 1	تَحْرِيمِ الرِّهَانِ
u'تَحْرِيمٌ زَرافَةٌ':Added, #1: 1	تَحْرِيمَ الرَّهْنِ
u'تَحْرِيمٌ زَكاةٌ':Added, #1: 1	تَحْرِيمِ الزَّرَافَةِ
u'تَحْرِيمٌ زَكاةٌ':Added, #1: 1	تَحْرِيمُ الزَّكَاةِ
u'تَحْرِيمٌ زَمانٌ':Added, #1: 1	تَحْرِيمِ الزَّكَاةِ
u'تَحْرِيمٌ زَوْجَةٌ':Added, #1: 1	تَحْرِيمَ الزَّمَانِ
u'تَحْرِيمٌ زَوْجَةٌ':Added, #1: 1	تَحْرِيمَ الزَّوْجَةِ
u'تَحْرِيمٌ زَوْجَةٌ':Added, #1: 1	تَحْرِيمِ زَوْجَاتِ
u'تَحْرِيمٌ زَوْجَةٌ':Added, #1: 1	تَحْرِيمُ زَوْجَاتِهِ
u'تَحْرِيمٌ زَوْجَةٌ':Added, #2: 2	تَحْرِيمِ الزَّوْجَةِ
u'تَحْرِيمٌ زَوْجِيٌّ':Added, #4: 4	تَحْرِيمُ الزَّوْجَةِ
u'تَحْرِيمٌ زِيادَةٌ':Added, #1: 1	تَحْرِيمِ الزَّوْجِيَّةِ
u'تَحْرِيمٌ زِيارَةٌ':Added, #2: 2	تَحْرِيمِ الزِّيَادَةِ
u'تَحْرِيمٌ سَابِقٌ':Added, #1: 1	تَحْرِيمِ الزِّيَارَةِ
u'تَحَرِّي مُسَاوَاةٌ':Added, #1: 1	تَحْرِيمٍ سَابِقٍ
u'تَحْرِيمٌ سَائِرٌ':Added, #1: 1	تَحَرِّي الْمُسَاوَاةِ
u'تَحْرِيمٌ سِباعٌ':Added, #1: 1	تَحْرِيمَ سَائِرِ
u'تَحْرِيمٌ سَبَبٌ':Added, #1: 1	تَحْرِيمِ السِّبَاعِ
u'تَحْرِيمٌ سَبْتٌ':Added, #2: 2	تَحْرِيمِ السَّبَبِ
u'تَحْرِيمٌ سَبْتٌ':Added, #1: 1	تَحْرِيمُ السَّبْتِ
u'تَحْرِيمٌ سَفَرٌ':Added, #2: 2	تَحْرِيمِ السَّبْتِ
u'تَحْرِيمٌ سكر':Added, #2: 2	تَحْرِيمِ السَّفَرِ
u'تَحْرِيمٌ سُكْرٌ':Added, #1: 1	تَحْرِيمِ السُّكْرِ
u'تَحْرِيمٌ سلام':Added, #1: 1	تَحْرِيمِ السُّكْرِ
u'تَحْرِيمٌ سَلاَمٌ':Added, #2: 2	تَحْرِيمِ السَّلَامِ
u'تَحْرِيمٌ سُلْطَانٌ':Added, #2: 2	تَحْرِيمِ السَّلَامِ
u'تَحْرِيمٌ سُلْطَانٌ':Added, #1: 1	تَحْرِيمَ السُّلْطَانِ
u'تَحْرِيمٌ سَمَاعٌ':Added, #1: 1	تَحْرِيمِ السُّلْطَانِ
u'تَحْرِيمٌ سَمِينٌ':Added, #1: 1	تَحْرِيمُ السَّمَاعِ
u'تَحْرِيمٌ سُؤَالٌ':Added, #1: 1	تَحْرِيمُ السَّمِينِ
u'تَحْرِيمٌ شَارِعٌ':Added, #2: 2	تَحْرِيمِ السُّؤَالِ
u'تَحْرِيمٌ شَبّابَة':Added, #1: 1	تَحْرِيمِ الشَّارِعِ
u'تَحْرِيمٌ شَتْمٌ':Added, #1: 1	تَحْرِيمُ الشَّبَّابَةِ
u'تَحْرِيمٌ شَحْمٌ':Added, #1: 1	تَحْرِيمَ الشَّتْمِ
u'تَحْرِيمٌ شِرَاءٌ':Added, #1: 1	تَحْرِيمِ شَحْمِهِ
u'تَحْرِيمٌ شرب':Added, #1: 1	تَحْرِيمِ الشِّرَاءِ
u'تَحْرِيمٌ شُرْبٌ':Added, #1: 1	تَحْرِيمَ شُرْبِ
u'تَحْرِيمٌ شِعْرٌ':Added, #1: 1	تَحْرِيمَ شُرْبِ
u'تَحْرِيمٌ شَيْءٌ':Added, #1: 1	تَحْرِيمُ الشِّعْرِ
u'تَحْرِيمٌ صدقة':Added, #3: 3	تَحْرِيمَ شَيْءٍ
u'تَحْرِيمٌ صدقة':Added, #1: 1	تَحْرِيمَ الصَّدَقَةِ
u'تَحْرِيمٌ صَدَقَةٌ':Added, #1: 1	تَحْرِيمُ الصَّدَقَةِ
u'تَحْرِيمٌ صَدَقَةٌ':Added, #1: 1	تَحْرِيمَ الصَّدَقَةِ
u'تَحْرِيمٌ صدقة':Added, #1: 1	تَحْرِيمُ الصَّدَقَةِ
u'تَحْرِيمٌ صَدَقَةٌ':Added, #1: 1	تَحْرِيمِ صَدَقَةِ
u'تَحْرِيمٌ صدقة':Added, #1: 1	تَحْرِيمِ صَدَقَةِ
u'تَحْرِيمٌ صَدَقَةٌ':Added, #3: 3	تَحْرِيمُ صَدَقَتِهِ
u'تَحْرِيمٌ صدقة':Added, #3: 3	تَحْرِيمُ صَدَقَتِهِ
u'تَحْرِيمٌ صَدَقَةٌ':Added, #4: 4	تَحْرِيمِ الصَّدَقَةِ
u'تَحْرِيمٌ صَرِيرٌ':Added, #4: 4	تَحْرِيمِ الصَّدَقَةِ
u'تَحْرِيمٌ صَرِيرٌ':Added, #1: 1	تَحْرِيمَ الصَّرِيرِ
u'تَحْرِيمٌ صَلاَةٌ':Added, #1: 1	تَحْرِيمُ الصَّرِيرِ
u'تَحْرِيمٌ صَلاَةٌ':Added, #1: 1	تَحْرِيمَ الصَّلَاةِ
u'تَحْرِيمٌ صَلاَةٌ':Added, #4: 4	تَحْرِيمِ الصَّلَاةِ
u'تَحْرِيمٌ صنائع':Added, #5: 5	تَحْرِيمُ الصَّلَاةِ
u'تَحْرِيمٌ صَنَائِعُ':Added, #1: 1	تَحْرِيمِ الصَّنَائِعِ
u'تَحْرِيمٌ صُورٌ':Added, #1: 1	تَحْرِيمِ الصَّنَائِعِ
u'تَحْرِيمٌ صُوَرٌ':Added, #1: 1	تَحْرِيمِ الصُّوَرِ
u'تَحْرِيمٌ صُوفٌ':Added, #1: 1	تَحْرِيمِ الصُّوَرِ
u'تَحْرِيمٌ صَوْمٌ':Added, #1: 1	تَحْرِيمِ الصُّوفِ
u'تَحْرِيمٌ صَوْمٌ':Added, #1: 1	تَحْرِيمُ صَوْمِ
u'تَحْرِيمٌ صَوْمٌ':Added, #1: 1	تَحْرِيمِ صَوْمِ
u'تَحْرِيمٌ صَوْمٌ':Added, #2: 2	تَحْرِيمُ الصَّوْمِ
u'تَحْرِيمٌ صَوْمٌ':Added, #2: 2	تَحْرِيمِ الصَّوْمِ
u'تَحْرِيمٌ صَيْدٌ':Added, #2: 2	تَحْرِيمَ صَوْمِ
u'تَحْرِيمٌ صَيْدٌ':Added, #1: 1	تَحْرِيمِ صَيْدِهِ
u'تَحْرِيمٌ صَيْدٌ':Added, #2: 2	تَحْرِيمَ صَيْدِ
u'تَحْرِيمٌ صَيْدٌ':Added, #2: 2	تَحْرِيمُ صَيْدِ
u'تَحْرِيمٌ صَيْدٌ':Added, #2: 2	تَحْرِيمِ صَيْدِ
u'تَحْرِيمٌ صَيْدٌ':Added, #2: 2	تَحْرِيمُ صَيْدِهِ
u'تَحْرِيمٌ ضَبٌّ':Added, #3: 3	تَحْرِيمَ الصَّيْدِ
u'تَحْرِيمٌ ضِدٌّ':Added, #1: 1	تَحْرِيمِ الضَّبِّ
u'تَحْرِيمٌ ضِدٌّ':Added, #1: 1	تَحْرِيمَ الضِّدِّ
u'تَحْرِيمٌ ضَرْبٌ':Added, #1: 1	تَحْرِيمِ الضِّدِّ
u'تَحْرِيمٌ ضَرْبٌ':Added, #13: 13	تَحْرِيمِ الضَّرْبِ
u'تَحْرِيمٌ ضَرْبٌ':Added, #1: 1	تَحْرِيمَ الضَّرْبِ
u'تَحَرَّى مُضْطَرٌّ':Subject, #1: 1	تَحْرِيمُ الضَّرْبِ
u'تَحْرِيمٌ ضِعْفٌ':Added, #1: 1	تَحَرَّى الْمُضْطَرُّ
u'تَحْرِيمٌ طُبُولٌ':Added, #1: 1	تَحْرِيمُ الضِّعْفِ
u'تَحْرِيمٌ طعام':Added, #1: 1	تَحْرِيمَ طُبُولِ
u'تَحْرِيمٌ طَعَامٌ':Added, #1: 1	تَحْرِيمِ الطَّعَامِ
u'تَحْرِيمٌ طَعْنٌ':Added, #1: 1	تَحْرِيمِ الطَّعَامِ
u'تَحْرِيمٌ طَلاَقٌ':Added, #1: 1	تَحْرِيمِ الطَّعْنِ
u'تَحْرِيمٌ طَلاَقٌ':Added, #1: 1	تَحْرِيمِ طَلَاقِ
u'تَحْرِيمٌ طَلاَقٌ':Added, #2: 2	تَحْرِيمَ الطَّلَاقِ
u'تَحْرِيمٌ طَلاَقٌ':Added, #2: 2	تَحْرِيمُ الطَّلَاقِ
u'تَحْرِيمٌ طَهَارَةٌ':Added, #4: 4	تَحْرِيمِ الطَّلَاقِ
u'تَحْرِيمٌ طواف':Added, #1: 1	تَحْرِيمُ الطَّهَارَةِ
u'تَحْرِيمٌ طَوَافٌ':Added, #2: 2	تَحْرِيمَ الطَّوَافِ
u'تَحْرِيمٌ طَيِّبٌ':Added, #2: 2	تَحْرِيمَ الطَّوَافِ
u'تَحْرِيمٌ طِيبٌ':Added, #1: 1	تَحْرِيمِ طَيِّبَاتِ
u'تَحْرِيمٌ طِيبٌ':Added, #3: 3	تَحْرِيمَ الطِّيبِ
u'تَحْرِيمٌ ظُلْمٌ':Added, #4: 4	تَحْرِيمِ الطِّيبِ
u'تَحْرِيمٌ ظَنٌّ':Added, #1: 1	تَحْرِيمِ الظُّلْمِ
u'تَحْرِيمٌ ظهار':Added, #1: 1	تَحْرِيمِ ظَنِّ
u'تَحْرِيمٌ عَرْجَاء':Added, #1: 1	تَحْرِيمِ الظِّهَارِ
u'تَحْرِيمٌ عَسَلٌ':Added, #1: 1	تَحْرِيمِ الْعَرْجَاءِ
u'تَحْرِيمٌ عَقْدٌ':Added, #1: 1	تَحْرِيمِ الْعَسَلِ
u'تَحْرِيمٌ عَقْرَبٌ':Added, #1: 1	تَحْرِيمَ الْعَقْدِ
u'تَحْرِيمٌ عَلَفٌ':Added, #1: 1	تَحْرِيمِ الْعَقْرَبِ
u'تَحْرِيمٌ عَمَّةٌ':Added, #1: 1	تَحْرِيمُ عَلَفِ
u'تَحْرِيمٌ عمرة':Added, #1: 1	تَحْرِيمُ عَمَّةِ
u'تَحْرِيمٌ عُمْرَةٌ':Added, #2: 2	تَحْرِيمِ الْعُمْرَةِ
u'تَحْرِيمٌ عُودٌ':Added, #2: 2	تَحْرِيمِ الْعُمْرَةِ
u'تَحْرِيمٌ عِوَضٌ':Added, #1: 1	تَحْرِيمِ الْعُودِ
u'تَحْرِيمٌ عِوَضٌ':Added, #1: 1	تَحْرِيمَ الْعِوَضِ
u'تَحْرِيمٌ عين':Added, #1: 1	تَحْرِيمِ الْعِوَضِ
u'تَحْرِيمٌ عين':Added, #1: 1	تَحْرِيمُ الْعَيْنِ
u'تَحْرِيمٌ عَيْنٌ':Added, #1: 1	تَحْرِيمِ الْعَيْنِ
u'تَحْرِيمٌ عَيْنٌ':Added, #1: 1	تَحْرِيمُ الْعَيْنِ
u'تَحْرِيمٌ عَيْن':Added, #1: 1	تَحْرِيمِ الْعَيْنِ
u'تَحْرِيمٌ عَيْن':Added, #1: 1	تَحْرِيمُ الْعَيْنِ
u'تَحْرِيمٌ عين':Added, #1: 1	تَحْرِيمِ الْعَيْنِ
u'تَحْرِيمٌ عَيْنٌ':Added, #1: 1	تَحْرِيمَ عَيْنِ
u'تَحْرِيمٌ عَيْن':Added, #1: 1	تَحْرِيمَ عَيْنِ
u'تَحْرِيمٌ غُرَابٌ':Added, #1: 1	تَحْرِيمَ عَيْنِ
u'تَحْرِيمٌ غَزَلٌ':Added, #1: 1	تَحْرِيمُ غُرَابِ
u'تَحْرِيمٌ غَسْلٌ':Added, #1: 1	تَحْرِيمُ الْغَزَلِ
u'تَحْرِيمٌ غُسْلٌ':Added, #1: 1	تَحْرِيمُ الْغَسْلِ
u'تَحْرِيمٌ غَصْبٌ':Added, #2: 2	تَحْرِيمَ الْغُسْلِ
u'تَحْرِيمٌ غُلُول':Added, #1: 1	تَحْرِيمِ الْغَصْبِ
u'تَحْرِيمٌ غناء':Added, #1: 1	تَحْرِيمُ الْغُلُولِ
u'تَحْرِيمٌ غِنَاءٌ':Added, #1: 1	تَحْرِيمِ الْغِنَاءِ
u'تَحْرِيمٌ غِيبَةٌ':Added, #1: 1	تَحْرِيمِ الْغِنَاءِ
u'تَحْرِيمٌ غِيبَةٌ':Added, #1: 1	تَحْرِيمُ الْغِيبَةِ
u'تَحْرِيمٌ غِيبَةٌ':Added, #1: 1	تَحْرِيمُ غِيبَةِ
u'تَحْرِيمٌ غِيبَةٌ':Added, #1: 1	تَحْرِيمِ غِيبَةِ
u'تَحْرِيمٌ غير':Added, #2: 2	تَحْرِيمِ الْغِيبَةِ
u'تَحْرِيمٌ غَيْرٌ':Added, #1: 1	تَحْرِيمُ غَيْرِ
u'تَحْرِيمٌ غير':Added, #1: 1	تَحْرِيمُ غَيْرِ
u'تَحْرِيمٌ غَيْرٌ':Added, #1: 1	تَحْرِيمَ غَيْرِهِ
u'تَحْرِيمٌ فرار':Added, #1: 1	تَحْرِيمَ غَيْرِهِ
u'تَحْرِيمٌ فِرَارٌ':Added, #1: 1	تَحْرِيمِ الْفِرَارِ
u'تَحْرِيمٌ فِرَاشٌ':Added, #1: 1	تَحْرِيمِ الْفِرَارِ
u'تَحْرِيمٌ فَرْجٌ':Added, #1: 1	تَحْرِيمُ الْفِرَاشِ
u'تَحْرِيمٌ فَرْجٌ':Added, #2: 2	تَحْرِيمِ الْفَرْجِ
u'تَحْرِيمٌ فَرْجٌ':Added, #2: 2	تَحْرِيمَ فَرْجِ
u'تَحْرِيمٌ فَرْجٌ':Added, #3: 3	تَحْرِيمُ الْفَرْجِ
u'تَحْرِيمٌ فِطْرٌ':Added, #8: 8	تَحْرِيمَ الْفَرْجِ
u'تَحْرِيمٌ فِعْلٌ':Added, #1: 1	تَحْرِيمِ الْفِطْرِ
u'تَحْرِيمٌ فِعْلٌ':Added, #1: 1	تَحْرِيمُ فِعْلِهِ
u'تَحْرِيمٌ فِعْلٌ':Added, #3: 3	تَحْرِيمُ الْفِعْلِ
u'تَحْرِيمٌ فُلاَنٌ':Added, #3: 3	تَحْرِيمِ الْفِعْلِ
u'تَحْرِيمٌ قَاتٌ':Added, #1: 1	تَحْرِيمُ فُلَانٍ
u'تَحْرِيمٌ قَاذُورٌ':Added, #1: 1	تَحْرِيمِ الْقَاتِ
u'تَحْرِيمٌ قَاذُورَاتٌ':Added, #1: 1	تَحْرِيمِ الْقَاذُورَاتِ
u'تَحْرِيمٌ قتال':Added, #1: 1	تَحْرِيمِ الْقَاذُورَاتِ
u'تَحْرِيمٌ قِتَالٌ':Added, #1: 1	تَحْرِيمِ الْقِتَالِ
u'تَحْرِيمٌ قتال':Added, #1: 1	تَحْرِيمِ الْقِتَالِ
u'تَحْرِيمٌ قِتَالٌ':Added, #2: 2	تَحْرِيمَ الْقِتَالِ
u'تَحْرِيمٌ قتل':Added, #2: 2	تَحْرِيمَ الْقِتَالِ
u'تَحْرِيمٌ قَتْلٌ':Added, #1: 1	تَحْرِيمَ قَتْلِ
u'تَحْرِيمٌ قتل':Added, #1: 1	تَحْرِيمَ قَتْلِ
u'تَحْرِيمٌ قَتْلٌ':Added, #3: 3	تَحْرِيمِ قَتْلِ
u'تَحْرِيمٌ قتل':Added, #3: 3	تَحْرِيمِ قَتْلِ
u'تَحْرِيمٌ قتل':Added, #4: 4	تَحْرِيمَ الْقَتْلِ
u'تَحْرِيمٌ قَتْلٌ':Added, #4: 4	تَحْرِيمِ الْقَتْلِ
u'تَحْرِيمٌ قَتْلٌ':Added, #4: 4	تَحْرِيمَ الْقَتْلِ
u'تَحْرِيمٌ قُدُومٌ':Added, #4: 4	تَحْرِيمِ الْقَتْلِ
u'تَحْرِيمٌ قذف':Added, #1: 1	تَحْرِيمِ الْقُدُومِ
u'تَحْرِيمٌ قذف':Added, #1: 1	تَحْرِيمُ الْقَذْفِ
u'تَحْرِيمٌ قَذْفٌ':Added, #1: 1	تَحْرِيمِ الْقَذْفِ
u'تَحْرِيمٌ قَذْفٌ':Added, #1: 1	تَحْرِيمُ الْقَذْفِ
u'تَحْرِيمٌ قذف':Added, #1: 1	تَحْرِيمِ الْقَذْفِ
u'تَحْرِيمٌ قَذْفٌ':Added, #1: 1	تَحْرِيمِ قَذْفِ
u'تَحْرِيمٌ قِرَاءةٌ':Added, #1: 1	تَحْرِيمِ قَذْفِ
u'تَحْرِيمٌ قِرَاءةٌ':Added, #1: 1	تَحْرِيمُ الْقِرَاءَةِ
u'تَحْرِيمٌ قُرْآنٌ':Added, #3: 3	تَحْرِيمِ الْقِرَاءَةِ
u'تَحْرِيمٌ قُرْبَانٌ':Added, #1: 1	تَحْرِيمِ الْقُرْآنِ
u'تَحْرِيمٌ قِرْشٌ':Added, #2: 2	تَحْرِيمِ الْقُرْبَانِ
u'تَحْرِيمٌ قَطْعٌ':Added, #1: 1	تَحْرِيمُ الْقِرْشِ
u'تَحْرِيمٌ قُفَّازٌ':Added, #1: 1	تَحْرِيمَ قَطْعِ
u'تَحْرِيمٌ قَلِيلٌ':Added, #1: 1	تَحْرِيمِ الْقُفَّازِ
u'تَحْرِيمٌ قَلِيلٌ':Added, #1: 1	تَحْرِيمَ قَلِيلِ
u'تَحْرِيمٌ قول':Added, #1: 1	تَحْرِيمِ قَلِيلِ
u'تَحْرِيمٌ قَوْلٌ':Added, #1: 1	تَحْرِيمَ الْقَوْلِ
u'تَحْرِيمٌ قول':Added, #1: 1	تَحْرِيمَ الْقَوْلِ
u'تَحْرِيمٌ قَوْلٌ':Added, #1: 1	تَحْرِيمُ قَوْلِهِ
u'تَحْرِيمٌ كَافُورٌ':Added, #1: 1	تَحْرِيمُ قَوْلِهِ
u'تَحْرِيمٌ كَبِيرٌ':Added, #1: 1	تَحْرِيمِ الْكَافُورِ
u'تَحْرِيمٌ كِتَابَةٌ':Added, #1: 1	تَحْرِيمُ الْكَبِيرَتَيْنِ
u'تَحْرِيمٌ كِتَابَةٌ':Added, #1: 1	تَحْرِيمُ كِتَابَةِ
u'تَحْرِيمٌ كِتْمَانٌ':Added, #3: 3	تَحْرِيمِ كِتَابَةِ
u'تَحْرِيمٌ كَثِيرٌ':Added, #1: 1	تَحْرِيمِ الْكِتْمَانِ
u'تَحْرِيمٌ كذب':Added, #1: 1	تَحْرِيمِ الْكَثِيرِ
u'تَحْرِيمٌ كَذِبٌ':Added, #1: 1	تَحْرِيمِ الْكَذِبِ
u'تَحْرِيمٌ كذب':Added, #1: 1	تَحْرِيمِ الْكَذِبِ
u'تَحْرِيمٌ كَذِبٌ':Added, #2: 2	تَحْرِيمَ الْكَذِبِ
u'تَحْرِيمٌ كَشْفٌ':Added, #2: 2	تَحْرِيمَ الْكَذِبِ
u'تَحْرِيمٌ كَلاَمٌ':Added, #1: 1	تَحْرِيمَ كَشْفِ
u'تَحْرِيمٌ كَلاَمٌ':Added, #2: 2	تَحْرِيمُ الْكَلَامِ
u'تَحْرِيمٌ كَلاَمٌ':Added, #2: 2	تَحْرِيمِ الْكَلاَمِ
u'تَحْرِيمٌ كَلاَمٌ':Added, #4: 4	تَحْرِيمَ الْكَلَامِ
u'تَحْرِيمٌ كَنْزٌ':Added, #4: 4	تَحْرِيمِ الْكَلَامِ
u'تَحْرِيمٌ كُوبَة':Added, #1: 1	تَحْرِيمِ الْكَنْزِ
u'تَحْرِيمٌ كُوبَة':Added, #1: 1	تَحْرِيمَ الْكُوبَةِ
u'تَحْرِيمٌ لِبَاسٌ':Added, #2: 2	تَحْرِيمِ الْكُوبَةِ
u'تَحْرِيمٌ لِبَاسٌ':Added, #1: 1	تَحْرِيمِ اللِّبَاسِ
u'تَحْرِيمٌ لبس':Added, #1: 1	تَحْرِيمِ لِبَاسِ
u'تَحْرِيمٌ لُبْسٌ':Added, #1: 1	تَحْرِيمَ اللُّبْسِ
u'تَحْرِيمٌ لبس':Added, #1: 1	تَحْرِيمَ اللُّبْسِ
u'تَحْرِيمٌ لُبْسٌ':Added, #1: 1	تَحْرِيمُ لُبْسِ
u'تَحْرِيمٌ لبس':Added, #1: 1	تَحْرِيمُ لُبْسِ
u'تَحْرِيمٌ لبس':Added, #1: 1	تَحْرِيمُ لُبْسِهِ
u'تَحْرِيمٌ لُبْسٌ':Added, #1: 1	تَحْرِيمِ لُبْسِهِ
u'تَحْرِيمٌ لُبْسٌ':Added, #1: 1	تَحْرِيمُ لُبْسِهِ
u'تَحْرِيمٌ لبس':Added, #1: 1	تَحْرِيمِ لُبْسِهِ
u'تَحْرِيمٌ لُبْسٌ':Added, #3: 3	تَحْرِيمِ لُبْسِ
u'تَحْرِيمٌ لبس':Added, #3: 3	تَحْرِيمِ لُبْسِ
u'تَحْرِيمٌ لُبْسٌ':Added, #3: 3	تَحْرِيمَ لُبْسِهِ
u'تَحْرِيمٌ لبن':Added, #3: 3	تَحْرِيمَ لُبْسِهِ
u'تَحْرِيمٌ لَبَنٌ':Added, #1: 1	تَحْرِيمِ اللَّبَنِ
u'تَحْرِيمٌ لبن':Added, #1: 1	تَحْرِيمِ اللَّبَنِ
u'تَحْرِيمٌ لَبَنٌ':Added, #1: 1	تَحْرِيمِ لَبَنِ
u'تَحْرِيمٌ لَحْمٌ':Added, #1: 1	تَحْرِيمِ لَبَنِ
u'تَحْرِيمٌ لَحْمٌ':Added, #1: 1	تَحْرِيمَ اللَّحْمِ
u'تَحْرِيمٌ لَحْمٌ':Added, #1: 1	تَحْرِيمِ اللَّحْمِ
u'تَحْرِيمٌ لَحْمٌ':Added, #2: 2	تَحْرِيمِ لَحْمِ
u'تَحْرِيمٌ لَحْنٌ':Added, #2: 2	تَحْرِيمِ لَحْمِهِ
u'تَحْرِيمٌ لُحُومٌ':Added, #1: 1	تَحْرِيمِ اللَّحْنِ
u'تَحْرِيمٌ لُحُومٌ':Added, #1: 1	تَحْرِيمَ لُحُومِ
u'تَحْرِيمٌ لعب':Added, #2: 2	تَحْرِيمِ لُحُومِ
u'تَحْرِيمٌ لَعِبٌ':Added, #4: 4	تَحْرِيمِ اللَّعِبِ
u'تَحْرِيمٌ لعب':Added, #4: 4	تَحْرِيمِ اللَّعِبِ
u'تَحْرِيمٌ لَعِبٌ':Added, #6: 6	تَحْرِيمُ اللَّعِبِ
u'تَحْرِيمٌ لعنة':Added, #6: 6	تَحْرِيمُ اللَّعِبِ
u'تَحْرِيمٌ لَعْنَةٌ':Added, #1: 1	تَحْرِيمِ اللَّعْنَةِ
u'تَحْرِيمٌ لَقَبٌ':Added, #1: 1	تَحْرِيمِ اللَّعْنَةِ
u'تَحْرِيمٌ لَمْسٌ':Added, #1: 1	تَحْرِيمِ لَقَبٍ
u'تَحْرِيمٌ لَمْسٌ':Added, #1: 1	تَحْرِيمَ اللَّمْسِ
u'تَحْرِيمٌ مَالٌ':Added, #3: 3	تَحْرِيمُ اللَّمْسِ
u'تَحْرِيمٌ مَالٌ':Added, #2: 2	تَحْرِيمِ الْمَالِ
u'تَحْرِيمٌ مُبَاحٌ':Added, #3: 3	تَحْرِيمِ مَالِ
u'تَحْرِيمٌ مُبَاحٌ':Added, #1: 1	تَحْرِيمُ الْمُبَاحَاتِ
u'تَحْرِيمٌ مُبَاحٌ':Added, #1: 1	تَحْرِيمِ الْمُبَاحَاتِ
u'تَحْرِيمٌ مُبَاحٌ':Added, #2: 2	تَحْرِيمَ الْمُبَاحِ
u'تَحْرِيمٌ مُبَادَرَةٌ':Added, #4: 4	تَحْرِيمُ الْمُبَاحِ
u'تَحْرِيمٌ مُبَارَزَةٌ':Added, #1: 1	تَحْرِيمَ الْمُبَادَرَةِ
u'تَحْرِيمٌ مُبَاشَرَةٌ':Added, #1: 1	تَحْرِيمَ الْمُبَارَزَةِ
u'تَحْرِيمٌ مَبْتُوت':Added, #1: 1	تَحْرِيمِ الْمُبَاشَرَةِ
u'تَحْرِيمٌ مُتَابَعٌ':Added, #1: 1	تَحْرِيمَ الْمَبْتُوتَةِ
u'تَحْرِيمٌ مُتَابَعٌ':Added, #1: 1	تَحْرِيمَ الْمُتَابَعَةِ
u'تَحْرِيمٌ مُتَابَعَةٌ':Added, #2: 2	تَحْرِيمَ مُتَابَعَةِ
u'تَحْرِيمٌ مُتَابَعَةٌ':Added, #1: 1	تَحْرِيمَ الْمُتَابَعَةِ
u'تَحْرِيمٌ مَتْرُوكٌ':Added, #2: 2	تَحْرِيمَ مُتَابَعَةِ
u'تَحْرِيمٌ مثل':Added, #1: 1	تَحْرِيمِ مَتْرُوكِ
u'تَحْرِيمٌ مِثْلٌ':Added, #1: 1	تَحْرِيمِ مِثْلِ
u'تَحْرِيمٌ مُجَاوَزَةٌ':Added, #1: 1	تَحْرِيمِ مِثْلِ
u'تَحْرِيمٌ مُجْمَعٌ':Added, #1: 1	تَحْرِيمِ الْمُجَاوَزَةِ
u'تَحْرِيمٌ مُجْمَعٌ':Added, #1: 1	تَحْرِيمَ الْمُجْمَعِ
u'تَحْرِيمٌ مُحْرِمٌ':Added, #1: 1	تَحْرِيمُ الْمُجْمَعِ
u'تَحْرِيمٌ مُخَالَفَةٌ':Added, #1: 1	تَحْرِيمُ الْمُحْرِمِ
u'تَحْرِيمٌ مُخَالَفَةٌ':Added, #1: 1	تَحْرِيمَ مُخَالَفَةِ
u'تَحْرِيمٌ مَدِينٌ':Added, #1: 1	تَحْرِيمِ مُخَالَفَتِهِ
u'تَحْرِيمٌ مَدِينَةٌ':Added, #2: 2	تَحْرِيمِ الْمَدِينَةِ
u'تَحْرِيمٌ مُرُورٌ':Added, #2: 2	تَحْرِيمِ الْمَدِينَةِ
u'تَحْرِيمٌ مَزَامِيرُ':Added, #1: 1	تَحْرِيمُ الْمُرُورِ
u'تَحْرِيمٌ مَزَامِيرُ':Added, #1: 1	تَحْرِيمَ الْمَزَامِيرِ
u'تَحْرِيمٌ مِزْمَارٌ':Added, #1: 1	تَحْرِيمِ الْمَزَامِيرِ
u'تَحْرِيمٌ مَسٌّ':Added, #1: 1	تَحْرِيمِ الْمِزْمَارِ
u'تَحْرِيمٌ مَسْأَلَةٌ':Added, #1: 1	تَحْرِيمِ الْمَسِّ
u'تَحْرِيمٌ مُسْكِرٌ':Added, #1: 1	تَحْرِيمِ الْمَسْأَلَةِ
u'تَحْرِيمٌ مُسْلِمٌ':Added, #2: 2	تَحْرِيمِ الْمُسْكِرِ
u'تَحْرِيمٌ مُسْلِمٌ':Added, #1: 1	تَحْرِيمِ الْمُسْلِمَاتِ
u'تَحْرِيمٌ مُشْرِك':Added, #1: 1	تَحْرِيمُ الْمُسْلِمَةِ
u'تَحْرِيمٌ مَشْرُوبٌ':Added, #1: 1	تَحْرِيمِ الْمُشْرِكَاتِ
u'تَحْرِيمٌ مَشْيٌ':Added, #1: 1	تَحْرِيمِ الْمَشْرُوبِ
u'تَحْرِيمٌ مُصَافَحَةٌ':Added, #1: 1	تَحْرِيمُ الْمَشْيِ
u'تَحْرِيمٌ مُصَاهَرَةٌ':Added, #1: 1	تَحْرِيمِ الْمُصَافَحَةِ
u'تَحْرِيمٌ مُصَاهَرَةٌ':Added, #10: 10	تَحْرِيمِ الْمُصَاهَرَةِ
u'تَحْرِيمٌ مُصَاهَرَةٌ':Added, #1: 1	تَحْرِيمَ مُصَاهَرَةٍ
u'تَحْرِيمٌ مُصَاهَرَةٌ':Added, #5: 5	تَحْرِيمَ الْمُصَاهَرَةِ
u'تَحْرِيمٌ مَضَارُّ':Added, #7: 7	تَحْرِيمُ الْمُصَاهَرَةِ
u'تَحْرِيمٌ مُطْلَقٌ':Added, #1: 1	تَحْرِيمِ الْمَضَارِّ
u'تَحْرِيمٌ مَعَارِيضُ':Added, #1: 1	تَحْرِيمِ مُطْلَقِ
u'تَحْرِيمٌ مُعَصْفَر':Added, #1: 1	تَحْرِيمِ الْمَعَارِيضِ
u'تَحْرِيمٌ مُقَدِّمٌ':Added, #1: 1	تَحْرِيمُ الْمُعَصْفَرِ
u'تَحْرِيمٌ مُقَدِّمَةٌ':Added, #1: 1	تَحْرِيمَ مُقَدِّمَاتِهِ
u'تَحْرِيمٌ مَكَانٌ':Added, #1: 1	تَحْرِيمَ مُقَدِّمَاتِهِ
u'تَحْرِيمٌ مُكْثٌ':Added, #1: 1	تَحْرِيمُ الْمَكَانِ
u'تَحْرِيمٌ مُكْثٌ':Added, #1: 1	تَحْرِيمِ الْمُكْثِ
u'تَحْرِيمٌ مُكْثٌ':Added, #2: 2	تَحْرِيمَ الْمُكْثِ
u'تَحْرِيمٌ مُلاَبَسَةٌ':Added, #2: 2	تَحْرِيمُ الْمُكْثِ
u'تَحْرِيمٌ مِلْكٌ':Added, #1: 1	تَحْرِيمِ الْمُلَابَسَةِ
u'تَحْرِيمٌ مَنٌّ':Added, #1: 1	تَحْرِيمُ مِلْكِ
u'تَحْرِيمٌ مَنٌّ':Added, #1: 1	تَحْرِيمَ الْمَنِّ
u'تَحْرِيمٌ مَنْعٌ':Added, #1: 1	تَحْرِيمِ الْمَنِّ
u'تَحْرِيمٌ مَنْهِيٌّ':Added, #1: 1	تَحْرِيمُ الْمَنْعِ
u'تَحْرِيمٌ مَوْزُونٌ':Added, #1: 1	تَحْرِيمِ الْمَنْهِيِّ
u'تَحْرِيمٌ مُوَقَّتٌ':Added, #1: 1	تَحْرِيمِ الْمَوْزُونَاتِ
u'تَحْرِيمٌ مَيْتٌ':Added, #2: 2	تَحْرِيمٍ مُوَقَّتٍ
u'تَحْرِيمٌ مَيْتٌ':Added, #1: 1	تَحْرِيمَ الْمَيْتَةِ
u'تَحْرِيمٌ مَيْتٌ':Added, #3: 3	تَحْرِيمُ الْمَيْتَةِ
u'تَحْرِيمٌ مَيْتَةٌ':Added, #7: 7	تَحْرِيمِ الْمَيْتَةِ
u'تَحْرِيمٌ مَيْتَةٌ':Added, #1: 1	تَحْرِيمَ الْمَيْتَةِ
u'تَحْرِيمٌ مَيْتَةٌ':Added, #1: 1	تَحْرِيمُ مَيْتَةٍ
u'تَحْرِيمٌ مَيْتَةٌ':Added, #3: 3	تَحْرِيمُ الْمَيْتَةِ
u'تَحْرِيمٌ نَاسٌ':Added, #7: 7	تَحْرِيمِ الْمَيْتَةِ
u'تَحْرِيمٌ نَبِيذٌ':Added, #1: 1	تَحْرِيمَ النَّاسِ
u'تَحْرِيمٌ نَبِيذٌ':Added, #1: 1	تَحْرِيمَ النَّبِيذِ
u'تَحْرِيمٌ نَبِيذٌ':Added, #1: 1	تَحْرِيمُ النَّبِيذِ
u'تَحْرِيمٌ نَزْعٌ':Added, #7: 7	تَحْرِيمِ النَّبِيذِ
u'تَحْرِيمٌ نِساءٌ':Added, #1: 1	تَحْرِيمُ النَّزْعِ
u'تَحْرِيمٌ نَسَبٌ':Added, #1: 1	تَحْرِيمَ النِّسَاءِ
u'تَحْرِيمٌ نَسَبٌ':Added, #1: 1	تَحْرِيمُ النَّسَبِ
u'تَحْرِيمٌ نَسَبٌ':Added, #1: 1	تَحْرِيمِ النَّسَبِ
u'تَحْرِيمٌ نَصٌّ':Added, #2: 2	تَحْرِيمَ النَّسَبِ
u'تَحْرِيمٌ نَظَرٌ':Added, #1: 1	تَحْرِيمِ النَّصِّ
u'تَحْرِيمٌ نَظَرٌ':Added, #1: 1	تَحْرِيمَ النَّظَرِ
u'تَحْرِيمٌ نَظَرٌ':Added, #1: 1	تَحْرِيمَ نَظَرِ
u'تَحْرِيمٌ نَظَرٌ':Added, #2: 2	تَحْرِيمُ النَّظَرِ
u'تَحْرِيمٌ نَظَرٌ':Added, #2: 2	تَحْرِيمُ نَظَرِ
u'تَحْرِيمٌ نَظَرٌ':Added, #3: 3	تَحْرِيمِ نَظَرِ
u'تَحْرِيمٌ نفاس':Added, #8: 8	تَحْرِيمِ النَّظَرِ
u'تَحْرِيمٌ نِفَاسٌ':Added, #1: 1	تَحْرِيمَ النِّفَاسِ
u'تَحْرِيمٌ نَفْسٌ':Added, #1: 1	تَحْرِيمَ النِّفَاسِ
u'تَحْرِيمٌ نكاح':Added, #2: 2	تَحْرِيمِ نَفْسِهِ
u'تَحْرِيمٌ نِكَاحٌ':Added, #11: 11	تَحْرِيمِ نِكَاحِ
u'تَحْرِيمٌ نكاح':Added, #11: 11	تَحْرِيمِ نِكَاحِ
u'تَحْرِيمٌ نكاح':Added, #1: 1	تَحْرِيمَ نِكَاحِ
u'تَحْرِيمٌ نِكَاحٌ':Added, #1: 1	تَحْرِيمِ نِكَاحٍ
u'تَحْرِيمٌ نِكَاحٌ':Added, #1: 1	تَحْرِيمَ نِكَاحِ
u'تَحْرِيمٌ نكاح':Added, #1: 1	تَحْرِيمِ نِكَاحٍ
u'تَحْرِيمٌ نِكَاحٌ':Added, #3: 3	تَحْرِيمُ نِكَاحِ
u'تَحْرِيمٌ نكاح':Added, #3: 3	تَحْرِيمُ نِكَاحِ
u'تَحْرِيمٌ نِكَاحٌ':Added, #5: 5	تَحْرِيمُ النِّكَاحِ
u'تَحْرِيمٌ نكاح':Added, #5: 5	تَحْرِيمُ النِّكَاحِ
u'تَحْرِيمٌ نِكَاحٌ':Added, #7: 7	تَحْرِيمِ النِّكَاحِ
u'تَحْرِيمٌ نَمِيمٌ':Added, #7: 7	تَحْرِيمِ النِّكَاحِ
u'تَحْرِيمٌ نَوْحٌ':Added, #1: 1	تَحْرِيمِ النَّمِيمَةِ
u'تَحْرِيمٌ هِبَةٌ':Added, #1: 1	تَحْرِيمِ النَّوْحِ
u'تَحْرِيمٌ هِبَةٌ':Added, #1: 1	تَحْرِيمَ الْهِبَةِ
u'تَحْرِيمٌ هِجَاءٌ':Added, #1: 1	تَحْرِيمُ هِبَةِ
u'تَحْرِيمٌ هجر':Added, #1: 1	تَحْرِيمِ الْهِجَاءِ
u'تَحْرِيمٌ هجر':Added, #1: 1	تَحْرِيمُ الْهَجْرِ
u'تَحْرِيمٌ هَجْرٌ':Added, #1: 1	تَحْرِيمِ الْهَجْرِ
u'تَحْرِيمٌ هَجْرٌ':Added, #1: 1	تَحْرِيمُ الْهَجْرِ
u'تَحْرِيمٌ هَجْوٌ':Added, #1: 1	تَحْرِيمِ الْهَجْرِ
u'تَحْرِيمٌ هَدِيٌّ':Added, #1: 1	تَحْرِيمُ هَجْوِهِ
u'تَحْرِيمٌ هَدِيَّةٌ':Added, #1: 1	تَحْرِيمِ الْهَدِيَّةِ
u'تَحْرِيمٌ واحد':Added, #1: 1	تَحْرِيمِ الْهَدِيَّةِ
u'تَحْرِيمٌ وَاحِدٌ':Added, #1: 1	تَحْرِيمُ وَاحِدٍ
u'تَحْرِيمٌ وثبة':Added, #1: 1	تَحْرِيمُ وَاحِدٍ
u'تَحْرِيمٌ وُجُوهٌ':Added, #1: 1	تَحْرِيمُ الْوَثْبَةِ
u'تَحْرِيمٌ وَسَائِلُ':Added, #1: 1	تَحْرِيمَ وُجُوهِ
u'تَحْرِيمٌ وصال':Added, #1: 1	تَحْرِيمَ الْوَسَائِلِ
u'تَحْرِيمٌ وِصَالٌ':Added, #1: 1	تَحْرِيمِ الْوِصَالِ
u'تَحْرِيمٌ وصال':Added, #1: 1	تَحْرِيمِ الْوِصَالِ
u'تَحْرِيمٌ وِصَالٌ':Added, #2: 2	تَحْرِيمَ الْوِصَالِ
u'تَحْرِيمٌ وَضْعٌ':Added, #2: 2	تَحْرِيمَ الْوِصَالِ
u'تَحْرِيمٌ وَطْءٌ':Added, #1: 1	تَحْرِيمُ وَضْعِ
u'تَحْرِيمٌ وَطْءٌ':Added, #16: 16	تَحْرِيمِ الْوَطْءِ
u'تَحْرِيمٌ وَطْءٌ':Added, #5: 5	تَحْرِيمَ الْوَطْءِ
u'تَحْرِيمٌ وَطْءٌ':Added, #6: 6	تَحْرِيمُ الْوَطْءِ
u'تَحْرِيمٌ وَعْدٌ':Added, #6: 6	تَحْرِيمِ وَطْءِ
u'تَحَرَّى مَوْقِفٌ':Predicate, #1: 1	تَحْرِيمِ الْوَعْدِ
u'تَحْرِيمٌ وِلاَدَةٌ':Added, #1: 1	تَحَرَّى مَوْقِفَ
u'تَحْرِيمٌ يَرَاعٌ':Added, #1: 1	تَحْرِيمِ الْوِلَادَةِ
u'تَحْرِيمٌ يَمِينٌ':Added, #1: 1	تَحْرِيمِ الْيَرَاعِ
u'تَحْرِيمٌ يهود':Added, #1: 1	تَحْرِيمَ الْيَمِينِ
u'تَحْرِيمٌ يَهُودٌ':Added, #1: 1	تَحْرِيمِ الْيَهُودِ
u'تَحْرِيمٌ يَوْمٌ':Added, #1: 1	تَحْرِيمِ الْيَهُودِ
u'تَحَرِّي نقرة':Added, #2: 2	تَحْرِيمِ يَوْمِ
u'تَحَرَّى واحد':Subject, #1: 1	تَحَرِّي نَقْرَةِ
u'تَحَرَّى وَاحِدٌ':Subject, #1: 1	تَحَرَّى الْوَاحِدُ
u'تَحَزَّبَ نَاسٌ':Subject, #1: 1	تَحَرَّى الْوَاحِدُ
u'تَحْزِيبٌ قُرْآنٌ':Added, #1: 1	تَحَزَّبَ النَّاسُ
u'تَحْزِينٌ قِرَاءةٌ':Added, #1: 1	تَحْزِيبِ الْقُرْآنِ
u'تَحْزِينٌ واحد':Added, #1: 1	تَحْزِينُ الْقِرَاءَةِ
u'تَحْزِينٌ وَاحِدٌ':Added, #1: 1	تَحْزِينُ الْوَاحِدِ
u'تَحَسُّرٌ نَاسٌ':Added, #1: 1	تَحْزِينُ الْوَاحِدِ
u'تَحْسِينٌ أَجِيرٌ':Added, #1: 1	تَحَسُّرِ النَّاسِ
u'تَحْسِينٌ بَاطن':Added, #1: 1	تَحْسِينِ الْأَجِيرِ
u'تَحْسِينٌ باطِنٌ':Added, #1: 1	تَحْسِينَ الْبَاطِنِ
u'تَحْسِينٌ بِنَاءٌ':Added, #1: 1	تَحْسِينَ الْبَاطِنِ
u'تَحْسِينٌ خَطٌّ':Added, #1: 1	تَحْسِينُ بِنَاءِ
u'تَحْسِينٌ خلق':Added, #2: 2	تَحْسِينِ الْخَطِّ
u'تَحْسِينٌ خُلُقٌ':Added, #1: 1	تَحْسِينُ الْخُلُقِ
u'تَحْسِينٌ خُلُق':Added, #1: 1	تَحْسِينُ الْخُلُقِ
u'تَحْسِينٌ خلقة':Added, #1: 1	تَحْسِينُ الْخُلُقِ
u'تَحْسِينٌ خلقة':Added, #1: 1	تَحْسِينُ الْخِلْقَةِ
u'تَحْسِينٌ خِلْقَةٌ':Added, #1: 1	تَحْسِينِ الْخِلْقَةِ
u'تَحْسِينٌ خِلْقَةٌ':Added, #1: 1	تَحْسِينُ الْخِلْقَةِ
u'تَحْسِينٌ خِيَاطَةٌ':Added, #1: 1	تَحْسِينِ الْخِلْقَةِ
u'تَحْسِينٌ سَمْتٌ':Added, #2: 2	تَحْسِينِ الْخِيَاطَةِ
u'تَحْسِينٌ شَعْرٌ':Added, #1: 1	تَحْسِينُ السَّمْتِ
u'تَحْسِينٌ صَلاَةٌ':Added, #1: 1	تَحْسِينِ الشَّعْرِ
u'تَحْسِينٌ صَوْتٌ':Added, #1: 1	تَحْسِينِ الصَّلاَةِ
u'تَحْسِينٌ صَوْتٌ':Added, #1: 1	تَحْسِينُ الصَّوْتِ
u'تَحْسِينٌ صَوْتٌ':Added, #1: 1	تَحْسِينِ الصَّوْتِ
u'تَحْسِينٌ ظاهِرٌ':Added, #2: 2	تَحْسِينُ صَوْتٍ
u'تَحْسِينٌ ظَنٌّ':Added, #1: 1	تَحْسِينِ الظَّاهِرِ
u'تَحْسِينٌ ظَنٌّ':Added, #1: 1	تَحْسِينَ الظَّنِّ
u'تَحْسِينٌ ظَنٌّ':Added, #1: 1	تَحْسِينَ ظَنٍّ
u'تَحْسِينٌ ظَنٌّ':Added, #1: 1	تَحْسِينُ ظَنٍّ
u'تَحْسِينٌ ظَنٌّ':Added, #4: 4	تَحْسِينُ الظَّنِّ
u'تَحْسِينٌ عَبْدٌ':Added, #5: 5	تَحْسِينِ الظَّنِّ
u'تَحْسِينٌ فُجُورٌ':Added, #1: 1	تَحْسِينِ الْعَبْدِ
u'تَحْسِينٌ فِعْلٌ':Added, #1: 1	تَحْسِينِ الْفُجُورِ
u'تَحْسِينٌ فلان':Added, #1: 1	تَحْسِينُ الْفِعْلِ
u'تَحْسِينٌ قَبْرٌ':Added, #1: 1	تَحْسِينُ التِّرْمِذِيِّ
u'تَحْسِينٌ قَبِيحٌ':Added, #1: 1	تَحْسِينُ الْقَبْرِ
u'تَحْسِينٌ كفر':Added, #1: 1	تَحْسِينِ الْقَبِيحِ
u'تَحْسِينٌ كُفْرٌ':Added, #2: 2	تَحْسِينَ الْكُفْرِ
u'تَحْسِينٌ كَفَنٌ':Added, #2: 2	تَحْسِينَ الْكُفْرِ
u'تَحْسِينٌ كَلاَمٌ':Added, #2: 2	تَحْسِينِ الْكَفَنِ
u'تَحْسِينٌ مِلْكٌ':Added, #2: 2	تَحْسِينُ الْكَلَامِ
u'تَحْسِينٌ نَحْوٌ':Added, #1: 1	تَحْسِينِ الْمِلْكِ
u'تَحْسِينٌ نَحْوٌ':Added, #1: 1	تَحْسِينُ نَحْوِ
u'تَحْسِينٌ نَظْمٌ':Added, #1: 1	تَحْسِينِ نَحْوِ
u'تَحْسِينٌ هَيْئَةٌ':Added, #1: 1	تَحْسِينِ النَّظْمِ
u'تَحْسِينٌ هَيْئَةٌ':Added, #1: 1	تَحْسِينُ هَيْئَةٍ
u'تَحْسِينٌ وَجْهٌ':Added, #2: 2	تَحْسِينُ الْهَيْئَةِ
u'تَحَصُّلٌ بديهيٌّ':Added, #1: 1	تَحْسِينُ وَجْهِ
u'تَحَصُّلٌ بَديهِيٌّ':Added, #1: 1	تَحَصُّلِ الْبَدِيهِيَّاتِ
u'تَحَصُّلٌ حكمة':Added, #1: 1	تَحَصُّلِ الْبَدِيهِيَّاتِ
u'تَحَصُّلٌ حِكْمَةٌ':Added, #1: 1	تَحَصُّلَ الْحِكْمَةِ
u'تَحَصَّلَ شَيْءٌ':Subject, #1: 1	تَحَصُّلَ الْحِكْمَةِ
u'تَحَصُّلٌ شَيْءٌ':Added, #1: 1	تَحَصَّلَ شَيْءٌ
u'تَحْصِيلٌ أحَدٌ':Added, #1: 1	تَحَصُّلِ شَيْءٍ
u'تَحْصِيلٌ أَحْكَامٌ':Added, #2: 2	تَحْصِيلِ أَحَدِ
u'تَحْصِيلٌ أَرْبَاحٌ':Added, #1: 1	تَحْصِيلِ الْأَحْكَامِ
u'تَحْصِيلٌ أَرْكانٌ':Added, #2: 2	تَحْصِيلِ الْأَرْبَاحِ
u'تَحْصِيلٌ أَرْكَانٌ':Added, #1: 1	تَحْصِيلِ الْأَرْكَانِ
u'تَحْصِيلٌ أسْبَابٌ':Added, #1: 1	تَحْصِيلِ الْأَرْكَانِ
u'تَحْصِيلٌ أَسْبَابٌ':Added, #1: 1	تَحْصِيلِ أَسْبَابِ
u'تَحْصِيلٌ إِسْلامٌ':Added, #1: 1	تَحْصِيلِ أَسْبَابِ
u'تَحْصِيلٌ أصل':Added, #1: 1	تَحْصِيلُ الْإِسْلَامِ
u'تَحْصِيلٌ أًصْلٌ':Added, #2: 2	تَحْصِيلُ الْأَصْلِ
u'تَحْصِيلٌ أَعْمَالٌ':Added, #2: 2	تَحْصِيلُ الْأَصْلِ
u'تَحْصِيلٌ أفْضَلُ':Added, #1: 1	تَحْصِيلِ الْأَعْمَالِ
u'تَحْصِيلٌ إقْرَارٌ':Added, #1: 1	تَحْصِيلِ أَفْضَلِ
u'تَحْصِيلٌ إقْرَارٌ':Added, #1: 1	تَحْصِيلَ إقْرَارِ
u'تَحْصِيلٌ أَمْرٌ':Added, #1: 1	تَحْصِيلُ إقْرَارِ
u'تَحْصِيلٌ أَمْرٌ':Added, #1: 1	تَحْصِيلِ أَمْرٍ
u'تَحْصِيلٌ أَمْلاكٌ':Added, #1: 1	تَحْصِيلِ أَمْرِهِ
u'تَحْصِيلٌ أَمْلاَكٌ':Added, #1: 1	تَحْصِيلِ الْأَمْلَاكِ
u'تَحْصِيلٌ آنَاءٌ':Added, #1: 1	تَحْصِيلِ الْأَمْلَاكِ
u'تَحْصِيلٌ بَدَلٌ':Added, #1: 1	تَحْصِيلِ آنَاءِ
u'تَحْصِيلٌ بَدَلٌ':Added, #1: 1	تَحْصِيلِ بَدَلِ
u'تَحْصِيلٌ بديهيٌّ':Added, #2: 2	تَحْصِيلُ بَدَلِهِ
u'تَحْصِيلٌ بَديهِيٌّ':Added, #1: 1	تَحْصِيلِ الْبَدِيهِيَّاتِ
u'تَحْصِيلٌ بَراءةٌ':Added, #1: 1	تَحْصِيلِ الْبَدِيهِيَّاتِ
u'تَحْصِيلٌ بَراءةٌ':Added, #1: 1	تَحْصِيلِ الْبَرَاءَةِ
u'تَحْصِيلٌ بَصيرٌ':Added, #2: 2	تَحْصِيلُ الْبَرَاءَةِ
u'تَحْصِيلٌ بَصيرَةٌ':Added, #2: 2	تَحْصِيلِ الْبَصِيرَةِ
u'تَحْصِيلٌ بَعْضٌ':Added, #2: 2	تَحْصِيلِ الْبَصِيرَةِ
u'تَحْصِيلٌ بَعْضٌ':Added, #1: 1	تَحْصِيلَ بَعْضِ
u'تَحْصِيلٌ بَوْلٌ':Added, #1: 1	تَحْصِيلُ بَعْضِ
u'تَحْصِيلٌ تُرَابٌ':Added, #2: 2	تَحْصِيلُ بَوْلٍ
u'تَحْصِيلٌ ثَمَرَةٌ':Added, #1: 1	تَحْصِيلُ التُّرَابِ
u'تَحْصِيلٌ ثَمَنٌ':Added, #1: 1	تَحْصِيلِ ثَمَرَاتِ
u'تَحْصِيلٌ ثَمَنٌ':Added, #1: 1	تَحْصِيلِ ثَمَنِ
u'تَحْصِيلٌ ثَمَنٌ':Added, #2: 2	تَحْصِيلَ الثَّمَنِ
u'تَحْصِيلٌ ثَمَنٌ':Added, #2: 2	تَحْصِيلُ الثَّمَنِ
u'تَحْصِيلٌ ثَوابٌ':Added, #2: 2	تَحْصِيلِ الثَّمَنِ
u'تَحْصِيلٌ ثَوابٌ':Added, #1: 1	تَحْصِيلُ الثَّوَابِ
u'تَحْصِيلٌ ثَوابٌ':Added, #1: 1	تَحْصِيلِ ثَوَابِ
u'تَحْصِيلٌ ثَوابٌ':Added, #3: 3	تَحْصِيلَ الثَّوَابِ
u'تَحْصِيلٌ ثِيابٌ':Added, #3: 3	تَحْصِيلِ الثَّوَابِ
u'تَحْصِيلٌ جَاهٌ':Added, #1: 1	تَحْصِيلِ الثِّيَابِ
u'تَحْصِيلٌ جُزْءٌ':Added, #1: 1	تَحْصِيلِ الْجَاهِ
u'تَحْصِيلٌ جُزْئِيٌّ':Added, #2: 2	تَحْصِيلِ الْجُزْءِ
u'تَحْصِيلٌ جُزْئِيَّةٌ':Added, #1: 1	تَحْصِيلِ الْجُزْئِيَّاتِ
u'تَحْصِيلٌ جِزْيَةٌ':Added, #1: 1	تَحْصِيلِ الْجُزْئِيَّاتِ
u'تَحْصِيلٌ جَمَّالٌ':Added, #1: 1	تَحْصِيلُ الْجِزْيَةِ
u'تَحْصِيلٌ جمع':Added, #1: 1	تَحْصِيلِ الْجَمَّالَةِ
u'تَحْصِيلٌ جَمْعٌ':Added, #1: 1	تَحْصِيلَ الْجَمْعِ
u'تَحْصِيلٌ جُنْدٌ':Added, #1: 1	تَحْصِيلَ الْجَمْعِ
u'تَحْصِيلٌ حاصِلٌ':Added, #1: 1	تَحْصِيلِ الْجُنْدِ
u'تَحْصِيلٌ حاصِلٌ':Added, #10: 10	تَحْصِيلِ الْحَاصِلِ
u'تَحْصِيلٌ حاصِلٌ':Added, #27: 27	تَحْصِيلُ الْحَاصِلِ
u'تَحْصِيلٌ حَجٌّ':Added, #5: 5	تَحْصِيلَ الْحَاصِلِ
u'تَحْصِيلٌ حَجٌّ':Added, #1: 1	تَحْصِيلَ الْحَجِّ
u'تَحْصِيلٌ حَجٌّ':Added, #1: 1	تَحْصِيلُ الْحَجِّ
u'تَحْصِيلٌ حِجَّةٌ':Added, #1: 1	تَحْصِيلِ حَجِّ
u'تَحْصِيلٌ حَرْفٌ':Added, #1: 1	تَحْصِيلَ حِجَّةٍ
u'تَحْصِيلٌ حُرِّيَّةٌ':Added, #1: 1	تَحْصِيلِ حَرْفٍ
u'تَحْصِيلٌ حُطَامٌ':Added, #2: 2	تَحْصِيلِ الْحُرِّيَّةِ
u'تَحْصِيلٌ حَقٌّ':Added, #1: 1	تَحْصِيلِ الْحُطَامِ
u'تَحْصِيلٌ حَقٌّ':Added, #1: 1	تَحْصِيلَ الْحَقِّ
u'تَحْصِيلٌ حَقٌّ':Added, #1: 1	تَحْصِيلِ الْحَقِّ
u'تَحْصِيلٌ حُكْمٌ':Added, #2: 2	تَحْصِيلُ الْحَقِّ
u'تَحْصِيلٌ حكمة':Added, #3: 3	تَحْصِيلِ حُكْمٍ
u'تَحْصِيلٌ حِكْمَةٌ':Added, #1: 1	تَحْصِيلِ الْحِكْمَةِ
u'تَحْصِيلٌ خَارِجٌ':Added, #1: 1	تَحْصِيلِ الْحِكْمَةِ
u'تَحْصِيلٌ خلاص':Added, #2: 2	تَحْصِيلِ الْخَارِجِ
u'تَحْصِيلٌ خَلاَصٌ':Added, #1: 1	تَحْصِيلُ الْخَلَاصِ
u'تَحْصِيلٌ خَمْرٌ':Added, #1: 1	تَحْصِيلُ الْخَلَاصِ
u'تَحْصِيلٌ خَمْرٌ':Added, #1: 1	تَحْصِيلَ الْخَمْرِ
u'تَحْصِيلٌ خَيْرٌ':Added, #1: 1	تَحْصِيلِ الْخَمْرِ
u'تَحْصِيلٌ دَرَاهِمُ':Added, #1: 1	تَحْصِيلَ خَيْرٍ
u'تَحْصِيلٌ دِرَايَةٌ':Added, #2: 2	تَحْصِيلِ الدَّرَاهِمِ
u'تَحْصِيلٌ دُرْبَةٌ':Added, #1: 1	تَحْصِيلِ الدِّرَايَةِ
u'تَحْصِيلٌ دَرَجَةٌ':Added, #1: 1	تَحْصِيلِ الدُّرْبَةِ
u'تَحْصِيلٌ دِرْهَمٌ':Added, #1: 1	تَحْصِيلَ دَرَجَاتِ
u'تَحْصِيلٌ دِرْهَم':Added, #1: 1	تَحْصِيلِ دِرْهَمٍ
u'تَحْصِيلٌ دُعَاءٌ':Added, #1: 1	تَحْصِيلِ دِرْهَمٍ
u'تَحْصِيلٌ دَلالَةٌ':Added, #1: 1	تَحْصِيلَ الدُّعَاءِ
u'تَحْصِيلٌ دِينارٌ':Added, #1: 1	تَحْصِيلُ الدَّلَالَةِ
u'تَحْصِيلٌ ذكر':Added, #1: 1	تَحْصِيلُ دِينَارٍ
u'تَحْصِيلٌ ذِكْرٌ':Added, #1: 1	تَحْصِيلِ الذِّكْرِ
u'تَحْصِيلٌ رَأْسٌ':Added, #1: 1	تَحْصِيلِ الذِّكْرِ
u'تَحْصِيلٌ رَأْسٌ':Added, #1: 1	تَحْصِيلُ رَأْسِ
u'تَحْصِيلٌ رَأْيٌ':Added, #1: 1	تَحْصِيلِ رَأْسِ
u'تَحْصِيلٌ رِبْحٌ':Added, #1: 1	تَحْصِيلَ رَأْيٍ
u'تَحْصِيلٌ رِبْحٌ':Added, #2: 2	تَحْصِيلِ الرِّبْحِ
u'تَحْصِيلٌ رِبْحٌ':Added, #3: 3	تَحْصِيلَ الرِّبْحِ
u'تَحْصِيلٌ رَقَبَةٌ':Added, #4: 4	تَحْصِيلُ الرِّبْحِ
u'تَحْصِيلٌ ركعة':Added, #1: 1	تَحْصِيلُ رَقَبَةِ
u'تَحْصِيلٌ رَكْعَةٌ':Added, #1: 1	تَحْصِيلُ الرَّكْعَةِ
u'تَحْصِيلٌ زَوْجٌ':Added, #1: 1	تَحْصِيلُ الرَّكْعَةِ
u'تَحْصِيلٌ زِيادَةٌ':Added, #1: 1	تَحْصِيلِ زَوْجٍ
u'تَحْصِيلٌ زِينَةٌ':Added, #1: 1	تَحْصِيلِ زِيَادَةِ
u'تَحْصِيلٌ سَاعَةٌ':Added, #1: 1	تَحْصِيلُ الزِّينَةِ
u'تَحْصِيلٌ سَبَبٌ':Added, #1: 1	تَحْصِيلَ السَّاعَةِ
u'تَحْصِيلٌ سَبَبٌ':Added, #1: 1	تَحْصِيلَ سَبَبِ
u'تَحْصِيلٌ سَبَبٌ':Added, #1: 1	تَحْصِيلُ سَبَبِ
u'تَحْصِيلٌ سَبَبٌ':Added, #1: 1	تَحْصِيلِ سَبَبٍ
u'تَحْصِيلٌ سَبَبٌ':Added, #1: 1	تَحْصِيلِ سَبَبِ
u'تَحْصِيلٌ سَبْقٌ':Added, #2: 2	تَحْصِيلِ السَّبَبِ
u'تَحْصِيلٌ سِتٌّ':Added, #1: 1	تَحْصِيلِ السَّبْقِ
u'تَحْصِيلٌ سترة':Added, #1: 1	تَحْصِيلِ السِّتَّةِ
u'تَحْصِيلٌ سُتْرَةٌ':Added, #1: 1	تَحْصِيلُ السُّتْرَةِ
u'تَحْصِيلٌ سُجُودٌ':Added, #1: 1	تَحْصِيلُ السُّتْرَةِ
u'تَحْصِيلٌ سِلْعَةٌ':Added, #2: 2	تَحْصِيلَ السُّجُودِ
u'تَحْصِيلٌ سِنٌّ':Added, #1: 1	تَحْصِيلَ السِّلْعَةِ
u'تَحْصِيلٌ سُنَّةٌ':Added, #1: 1	تَحْصِيلُ السِّنِّ
u'تَحْصِيلٌ سُنَّةٌ':Added, #1: 1	تَحْصِيلِ سُنَّةِ
u'تَحْصِيلٌ سُنَّةٌ':Added, #2: 2	تَحْصِيلَ السُّنَّةِ
u'تَحْصِيلٌ شَاةٌ':Added, #5: 5	تَحْصِيلِ السُّنَّةِ
u'تَحْصِيلٌ شِرَاءٌ':Added, #1: 1	تَحْصِيلُ الشَّاةِ
u'تَحْصِيلٌ شَرَائِطُ':Added, #1: 1	تَحْصِيلُ شِرَاءِ
u'تَحْصِيلٌ شَرْطٌ':Added, #1: 1	تَحْصِيلِ الشَّرَائِطِ
u'تَحْصِيلٌ شُغْلٌ':Added, #1: 1	تَحْصِيلِ الشَّرْطِ
u'تَحْصِيلٌ شُغْل':Added, #1: 1	تَحْصِيلِ شُغْلٍ
u'تَحْصِيلٌ شَهَوَاتٌ':Added, #1: 1	تَحْصِيلِ شُغْلٍ
u'تَحْصِيلٌ شَهْوَةٌ':Added, #1: 1	تَحْصِيلِ شَهَوَاتِهِ
u'تَحْصِيلٌ شَيْءٌ':Added, #1: 1	تَحْصِيلِ الشَّهْوَةِ
u'تَحْصِيلٌ صِفَةٌ':Added, #2: 2	تَحْصِيلِ شَيْءٍ
u'تَحْصِيلٌ صِفَةٌ':Added, #1: 1	تَحْصِيلُ الصِّفَةِ
u'تَحْصِيلٌ طَاعَةٌ':Added, #2: 2	تَحْصِيلِ صِفَةِ
u'تَحْصِيلٌ طَاعَةٌ':Added, #1: 1	تَحْصِيلُ الطَّاعَةِ
u'تَحْصِيلٌ طُرُقٌ':Added, #1: 1	تَحْصِيلِ طَاعَةٍ
u'تَحْصِيلٌ طَهَارَةٌ':Added, #1: 1	تَحْصِيلِ طُرُقِهِ
u'تَحْصِيلٌ طهر':Added, #3: 3	تَحْصِيلِ الطَّهَارَةِ
u'تَحْصِيلٌ طُهْرٌ':Added, #1: 1	تَحْصِيلُ الطُّهْرِ
u'تَحْصِيلٌ ظَنٌّ':Added, #1: 1	تَحْصِيلُ الطُّهْرِ
u'تَحْصِيلٌ عِبَادَةٌ':Added, #2: 2	تَحْصِيلُ الظَّنِّ
u'تَحْصِيلٌ عَبْدٌ':Added, #2: 2	تَحْصِيلِ الْعِبَادَاتِ
u'تَحْصِيلٌ عتق':Added, #3: 3	تَحْصِيلُ الْعَبْدَيْنِ
u'تَحْصِيلٌ عِتْقٌ':Added, #1: 1	تَحْصِيلَ الْعِتْقِ
u'تَحْصِيلٌ عتق':Added, #1: 1	تَحْصِيلَ الْعِتْقِ
u'تَحْصِيلٌ عِتْقٌ':Added, #2: 2	تَحْصِيلُ الْعِتْقِ
u'تَحْصِيلٌ عتق':Added, #2: 2	تَحْصِيلُ الْعِتْقِ
u'تَحْصِيلٌ عِتْقٌ':Added, #5: 5	تَحْصِيلِ الْعِتْقِ
u'تَحْصِيلٌ عِفَّةٌ':Added, #5: 5	تَحْصِيلِ الْعِتْقِ
u'تَحْصِيلٌ علم':Added, #1: 1	تَحْصِيلُ الْعِفَّةِ
u'تَحْصِيلٌ علم':Added, #1: 1	تَحْصِيلُ عِلْمٍ
u'تَحْصِيلٌ عِلْمٌ':Added, #1: 1	تَحْصِيلِ عِلْمٍ
u'تَحْصِيلٌ عِلْمٌ':Added, #1: 1	تَحْصِيلُ عِلْمٍ
u'تَحْصِيلٌ علم':Added, #1: 1	تَحْصِيلِ عِلْمٍ
u'تَحْصِيلٌ عِلْمٌ':Added, #2: 2	تَحْصِيلُ عِلْمِ
u'تَحْصِيلٌ علم':Added, #2: 2	تَحْصِيلُ عِلْمِ
u'تَحْصِيلٌ علم':Added, #3: 3	تَحْصِيلَ الْعِلْمِ
u'تَحْصِيلٌ عِلْمٌ':Added, #3: 3	تَحْصِيلُ الْعِلْمِ
u'تَحْصِيلٌ عِلْمٌ':Added, #3: 3	تَحْصِيلَ الْعِلْمِ
u'تَحْصِيلٌ علم':Added, #3: 3	تَحْصِيلُ الْعِلْمِ
u'تَحْصِيلٌ عِلْمٌ':Added, #5: 5	تَحْصِيلِ الْعِلْمِ
u'تَحْصِيلٌ عَمَلٌ':Added, #5: 5	تَحْصِيلِ الْعِلْمِ
u'تَحْصِيلٌ عِوَضٌ':Added, #1: 1	تَحْصِيلُ الْعَمَلِ
u'تَحْصِيلٌ عِوَضٌ':Added, #1: 1	تَحْصِيلَ عِوَضٍ
u'تَحْصِيلٌ عين':Added, #2: 2	تَحْصِيلُ الْعِوَضِ
u'تَحْصِيلٌ عَيْنٌ':Added, #1: 1	تَحْصِيلَ الْعَيْنِ
u'تَحْصِيلٌ عَيْن':Added, #1: 1	تَحْصِيلَ الْعَيْنِ
u'تَحْصِيلٌ غَائِبٌ':Added, #1: 1	تَحْصِيلَ الْعَيْنِ
u'تَحْصِيلٌ غَرَضٌ':Added, #1: 1	تَحْصِيلِ الْغَائِبِ
u'تَحْصِيلٌ غَرَضٌ':Added, #1: 1	تَحْصِيلُ الْغَرَضِ
u'تَحْصِيلٌ غَرَضٌ':Added, #1: 1	تَحْصِيلُ غَرَضٍ
u'تَحْصِيلٌ غَرَضٌ':Added, #1: 1	تَحْصِيلِ غَرَضٍ
u'تَحْصِيلٌ غَرَضٌ':Added, #1: 1	تَحْصِيلِ غَرَضِ
u'تَحْصِيلٌ غَرَضٌ':Added, #2: 2	تَحْصِيلُ غَرَضِ
u'تَحْصِيلٌ غَلَّةٌ':Added, #4: 4	تَحْصِيلِ غَرَضِهِ
u'تَحْصِيلٌ فِدَاءٌ':Added, #1: 1	تَحْصِيلِ الْغَلَّةِ
u'تَحْصِيلٌ فَضَائِلُ':Added, #2: 2	تَحْصِيلُ الْفِدَاءِ
u'تَحْصِيلٌ فَضْلٌ':Added, #1: 1	تَحْصِيلِ الْفَضَائِلِ
u'تَحْصِيلٌ فَضِيلٌ':Added, #1: 1	تَحْصِيلِ فَضْلِ
u'تَحْصِيلٌ فَضِيلٌ':Added, #1: 1	تَحْصِيلِ الْفَضِيلَةِ
u'تَحْصِيلٌ فَضِيلٌ':Added, #2: 2	تَحْصِيلُ فَضِيلَةِ
u'تَحْصِيلٌ فَضِيلَةٌ':Added, #2: 2	تَحْصِيلِ فَضِيلَةِ
u'تَحْصِيلٌ فَضِيلَةٌ':Added, #1: 1	تَحْصِيلِ الْفَضِيلَةِ
u'تَحْصِيلٌ فَضِيلَةٌ':Added, #1: 1	تَحْصِيلُ فَضِيلَةٍ
u'تَحْصِيلٌ فَضِيلَةٌ':Added, #1: 1	تَحْصِيلِ فَضِيلَةٍ
u'تَحْصِيلٌ فَضِيلَةٌ':Added, #2: 2	تَحْصِيلُ فَضِيلَةِ
u'تَحْصِيلٌ فِعْلٌ':Added, #2: 2	تَحْصِيلِ فَضِيلَةِ
u'تَحْصِيلٌ فِعْلٌ':Added, #1: 1	تَحْصِيلَ الْفِعْلِ
u'تَحْصِيلٌ فلان':Added, #2: 2	تَحْصِيلُ الْفِعْلِ
u'تَحْصِيلٌ قُرْبَةٌ':Added, #1: 1	تَحْصِيلَ الْجُبْرَانِ
u'تَحْصِيلٌ قُوَّةٌ':Added, #1: 1	تَحْصِيلِ الْقُرْبَةِ
u'تَحْصِيلٌ قُوَّة':Added, #1: 1	تَحْصِيلَ الْقُوَّةِ
u'تَحْصِيلٌ قُوتٌ':Added, #1: 1	تَحْصِيلَ الْقُوَّةِ
u'تَحْصِيلٌ قول':Added, #1: 1	تَحْصِيلِ قُوتِهِ
u'تَحْصِيلٌ قَوْلٌ':Added, #1: 1	تَحْصِيلُ الْقَوْلِ
u'تَحْصِيلٌ قول':Added, #1: 1	تَحْصِيلُ الْقَوْلِ
u'تَحْصِيلٌ قَوْلٌ':Added, #3: 3	تَحْصِيلُ قَوْلِ
u'تَحْصِيلٌ كَافُورٌ':Added, #3: 3	تَحْصِيلُ قَوْلِ
u'تَحْصِيلٌ كَسْبٌ':Added, #2: 2	تَحْصِيلِ الْكَافُورِ
u'تَحْصِيلٌ كَفَّارٌ':Added, #1: 1	تَحْصِيلُ الْكَسْبِ
u'تَحْصِيلٌ كَفَّارَةٌ':Added, #1: 1	تَحْصِيلِ الْكَفَّارَةِ
u'تَحْصِيلٌ كِفَايَةٌ':Added, #1: 1	تَحْصِيلِ الْكَفَّارَةِ
u'تَحْصِيلٌ كَمَالٌ':Added, #1: 1	تَحْصِيلِ كِفَايَةِ
u'تَحْصِيلٌ كَمَالٌ':Added, #1: 1	تَحْصِيلُ الْكَمَالِ
u'تَحْصِيلٌ كَمَالٌ':Added, #1: 1	تَحْصِيلُ كَمَالِ
u'تَحْصِيلٌ لَيْلٌ':Added, #1: 1	تَحْصِيلِ كَمَالِ
u'تَحْصِيلٌ لَيْلٌ':Added, #1: 1	تَحْصِيلَ اللَّيْلَةِ
u'تَحْصِيلٌ مَاءٌ':Added, #1: 1	تَحْصِيلَ لَيْلَةِ
u'تَحْصِيلٌ مَاءٌ':Added, #1: 1	تَحْصِيلَ الْمَاءِ
u'تَحْصِيلٌ مَاءٌ':Added, #1: 1	تَحْصِيلَ مَاءٍ
u'تَحْصِيلٌ مَاءٌ':Added, #1: 1	تَحْصِيلِ مَاءِ
u'تَحْصِيلٌ مَاءٌ':Added, #2: 2	تَحْصِيلُ الْمَاءِ
u'تَحْصِيلٌ مَاءٌ':Added, #2: 2	تَحْصِيلُ مَاءٍ
u'تَحْصِيلٌ مَالٌ':Added, #4: 4	تَحْصِيلِ الْمَاءِ
u'تَحْصِيلٌ مَالٌ':Added, #1: 1	تَحْصِيلَ مَالٍ
u'تَحْصِيلٌ مَالٌ':Added, #1: 1	تَحْصِيلِ مَالٍ
u'تَحْصِيلٌ مَالٌ':Added, #3: 3	تَحْصِيلُ مَالٍ
u'تَحْصِيلٌ مَالٌ':Added, #5: 5	تَحْصِيلِ الْمَالِ
u'تَحْصِيلٌ مَأْمُورٌ':Added, #6: 6	تَحْصِيلُ الْمَالِ
u'تَحْصِيلٌ مَتَاعٌ':Added, #1: 1	تَحْصِيلَ الْمَأْمُورِ
u'تَحْصِيلٌ مُتَوَحِّشٌ':Added, #1: 1	تَحْصِيلُ الْمَتَاعِ
u'تَحْصِيلٌ مثل':Added, #1: 1	تَحْصِيلِ مُتَوَحِّشٍ
u'تَحْصِيلٌ مِثْلٌ':Added, #1: 1	تَحْصِيلِ الْمِثْلِ
u'تَحْصِيلٌ مثل':Added, #1: 1	تَحْصِيلِ الْمِثْلِ
u'تَحْصِيلٌ مِثْلٌ':Added, #1: 1	تَحْصِيلِ مِثْلِ
u'تَحْصِيلٌ مَجْهُولٌ':Added, #1: 1	تَحْصِيلِ مِثْلِ
u'تَحْصِيلٌ مَذْهَبٌ':Added, #1: 1	تَحْصِيلَ مَجْهُولٍ
u'تَحْصِيلٌ مَذْهَبٌ':Added, #3: 3	تَحْصِيلُ الْمَذْهَبِ
u'تَحْصِيلٌ مراد':Added, #3: 3	تَحْصِيلُ مَذْهَبِ
u'تَحْصِيلٌ مُرَادٌ':Added, #1: 1	تَحْصِيلُ مُرَادٍ
u'تَحْصِيلٌ مراد':Added, #1: 1	تَحْصِيلُ مُرَادٍ
u'تَحْصِيلٌ مُرَادٌ':Added, #1: 1	تَحْصِيلِ مُرَادِهِ
u'تَحْصِيلٌ مَرَامٌ':Added, #1: 1	تَحْصِيلِ مُرَادِهِ
u'تَحْصِيلٌ مَسْكَنٌ':Added, #1: 1	تَحْصِيلِ الْمَرَامِ
u'تَحْصِيلٌ مُسَلَّمٌ':Added, #1: 1	تَحْصِيلُ الْمَسْكَنِ
u'تَحْصِيلٌ مَصَالِحُ':Added, #1: 1	تَحْصِيلِ الْمُسَلَّمِ
u'تَحْصِيلٌ مَصَالِحُ':Added, #1: 1	تَحْصِيلَ مَصَالِحِ
u'تَحْصِيلٌ مَصْلَحَةٌ':Added, #1: 1	تَحْصِيلُ مَصَالِحِهِ
u'تَحْصِيلٌ مَصْلَحَةٌ':Added, #1: 1	تَحْصِيلِ مَصْلَحَةِ
u'تَحْصِيلٌ مَصْلَحَةٌ':Added, #1: 1	تَحْصِيلِ مَصْلَحَتِهِ
u'تَحْصِيلٌ مَصْلَحَةٌ':Added, #3: 3	تَحْصِيلُ الْمَصْلَحَةِ
u'تَحْصِيلٌ مَصْلَحَةٌ':Added, #3: 3	تَحْصِيلِ الْمَصْلَحَةِ
u'تَحْصِيلٌ مَطْلُوبٌ':Added, #3: 3	تَحْصِيلَ مَصْلَحَةِ
u'تَحْصِيلٌ مُعَيَّنٌ':Added, #2: 2	تَحْصِيلِ مَطْلُوبِهِ
u'تَحْصِيلٌ مَفْهُومٌ':Added, #1: 1	تَحْصِيلَ الْمُعَيَّنِ
u'تَحْصِيلٌ مُقَدِّمٌ':Added, #1: 1	تَحْصِيلِ الْمَفْهُومِ
u'تَحْصِيلٌ مُقَدِّمَةٌ':Added, #1: 1	تَحْصِيلِ الْمُقَدِّمَةِ
u'تَحْصِيلٌ مَقْصُودٌ':Added, #1: 1	تَحْصِيلِ الْمُقَدِّمَةِ
u'تَحْصِيلٌ مَقْصُودٌ':Added, #12: 12	تَحْصِيلِ الْمَقْصُودِ
u'تَحْصِيلٌ مَقْصُودٌ':Added, #1: 1	تَحْصِيلَ مَقْصُودٍ
u'تَحْصِيلٌ مَقْصُودٌ':Added, #1: 1	تَحْصِيلَ مَقْصُودِ
u'تَحْصِيلٌ مَقْصُودٌ':Added, #2: 2	تَحْصِيلُ الْمَقْصُودِ
u'تَحْصِيلٌ مَقْصُودٌ':Added, #3: 3	تَحْصِيلُ مَقْصُودِ
u'تَحْصِيلٌ مَقْصُودٌ':Added, #3: 3	تَحْصِيلُ مَقْصُودِهِ
u'تَحْصِيلٌ مَقْصُودٌ':Added, #5: 5	تَحْصِيلِ مَقْصُودِ
u'تَحْصِيلٌ مُكَلَّفٌ':Added, #7: 7	تَحْصِيلِ مَقْصُودِهِ
u'تَحْصِيلٌ مِلْكٌ':Added, #1: 1	تَحْصِيلِ الْمُكَلَّفِ
u'تَحْصِيلٌ مِلْكٌ':Added, #1: 1	تَحْصِيلِ الْمِلْكِ
u'تَحْصِيلٌ مِلْكٌ':Added, #1: 1	تَحْصِيلُ مِلْكِ
u'تَحْصِيلٌ مُمَاثَلَةٌ':Added, #2: 2	تَحْصِيلِ مِلْكِ
u'تَحْصِيلٌ مَمَرٌّ':Added, #1: 1	تَحْصِيلِ الْمُمَاثَلَةِ
u'تَحْصِيلٌ مَمَرٌّ':Added, #1: 1	تَحْصِيلَ مَمَرٍّ
u'تَحْصِيلٌ مُنَاظَرَةٌ':Added, #5: 5	تَحْصِيلُ مَمَرٍّ
u'تَحْصِيلٌ مَنَافِعُ':Added, #1: 1	تَحْصِيلِ الْمُنَاظَرَةِ
u'تَحْصِيلٌ مَنْذُور':Added, #1: 1	تَحْصِيلِ الْمَنَافِعِ
u'تَحْصِيلٌ مَنْفَعَةٌ':Added, #1: 1	تَحْصِيلَ الْمَنْذُورِ
u'تَحْصِيلٌ مَنْفَعَةٌ':Added, #1: 1	تَحْصِيلَ مَنْفَعَةِ
u'تَحْصِيلٌ مَنْفَعَةٌ':Added, #1: 1	تَحْصِيلُ مَنْفَعَةٍ
u'تَحْصِيلٌ مَنْفَعَةٌ':Added, #1: 1	تَحْصِيلِ مَنْفَعَةٍ
u'تَحْصِيلٌ مُوجِبٌ':Added, #1: 1	تَحْصِيلُ مَنْفَعَتِهِ
u'تَحْصِيلٌ مُؤَجَّلٌ':Added, #1: 1	تَحْصِيلِ الْمُوجِبِ
u'تَحْصِيلٌ مَوْضِعٌ':Added, #1: 1	تَحْصِيلَ الْمُؤَجَّلِ
u'تَحْصِيلٌ مُوَكَّلٌ':Added, #1: 1	تَحْصِيلِ مَوْضِعِ
u'تَحْصِيلٌ نُسُكٌ':Added, #1: 1	تَحْصِيلَ الْمُوَكَّلِ
u'تَحْصِيلٌ نُسُكٌ':Added, #1: 1	تَحْصِيلُ النُّسُكِ
u'تَحْصِيلٌ نَظَافَةٌ':Added, #1: 1	تَحْصِيلَ نُسُكِ
u'تَحْصِيلٌ نَعْلٌ':Added, #2: 2	تَحْصِيلُ النَّظَافَةِ
u'تَحْصِيلٌ نَفْعٌ':Added, #1: 1	تَحْصِيلِ نَعْلَيْنِ
u'تَحْصِيلٌ نَفَقَةٌ':Added, #1: 1	تَحْصِيلِ نَفْعٍ
u'تَحْصِيلٌ نَفَقَةٌ':Added, #1: 1	تَحْصِيلَ النَّفَقَةِ
u'تَحْصِيلٌ نَفَقَةٌ':Added, #1: 1	تَحْصِيلُ النَّفَقَةِ
u'تَحْصِيلٌ نَفَقَةٌ':Added, #1: 1	تَحْصِيلِ نَفَقَةِ
u'تَحْصِيلٌ نَفَقَةٌ':Added, #2: 2	تَحْصِيلِ النَّفَقَةِ
u'تَحْصِيلٌ نَمَاءٌ':Added, #2: 2	تَحْصِيلِ نَفَقَةٍ
u'تَحْصِيلٌ نِيَّةٌ':Added, #1: 1	تَحْصِيلِ النَّمَاءِ
u'تَحْصِيلٌ وَاجِبٌ':Added, #1: 1	تَحْصِيلَ النِّيَّةِ
u'تَحْصِيلٌ واحد':Added, #2: 2	تَحْصِيلِ الْوَاجِبِ
u'تَحْصِيلٌ وَاحِدٌ':Added, #1: 1	تَحْصِيلِ وَاحِدٍ
u'تَحْصِيلٌ ورق':Added, #1: 1	تَحْصِيلِ وَاحِدٍ
u'تَحْصِيلٌ وَرَقٌ':Added, #1: 1	تَحْصِيلُ وَرَقِ
u'تَحْصِيلٌ وُضُوءٌ':Added, #1: 1	تَحْصِيلُ وَرَقِ
u'تَحْصِيلٌ يَقِينٌ':Added, #1: 1	تَحْصِيلِ الْوُضُوءِ
u'تَحْصِيلٌ يَقِينٌ':Added, #2: 2	تَحْصِيلُ الْيَقِينِ
u'تَحَقَّقَ اِتِّبَاعٌ':Subject, #2: 2	تَحْصِيلِ الْيَقِينِ
u'تَحَقَّقَ اِتِّصَالٌ':Subject, #1: 1	تَحَقَّقَ اتِّبَاعُ
u'تَحَقُّقٌ إِثْمٌ':Added, #1: 1	تَحَقَّقَ اتِّصَالُ
u'تَحَقُّقٌ إِجْمَاعٌ':Added, #1: 1	تَحَقُّقِ إثْمٍ
u'تَحَقُّقٌ إِجْمَاعٌ':Added, #1: 1	تَحَقُّقِ الْإِجْمَاعِ
u'تَحَقَّقَ أحَدٌ':Subject, #3: 3	تَحَقُّقُ الْإِجْمَاعِ
u'تَحَقَّقَ إِحْدَاثٌ':Subject, #2: 2	تَحَقَّقَ أَحَدُ
u'تَحَقُّقٌ أَحْكَامٌ':Added, #1: 1	تَحَقَّقَ إحْدَاثُهُ
u'تَحَقَّقَ اِخْتِصَاصٌ':Subject, #1: 1	تَحَقُّقُ الْأَحْكَامِ
u'تَحَقُّقٌ أخْذٌ':Added, #1: 1	تَحَقَّقَ اخْتِصَاصُهُ
u'تَحَقُّقٌ إِدْرَاكٌ':Added, #1: 1	تَحَقُّقُ أَخْذِ
u'تَحَقُّقٌ إِذْنٌ':Added, #1: 1	تَحَقُّقِ إدْرَاكِ
u'تَحَقُّقٌ إِرَادَةٌ':Added, #1: 1	تَحَقُّقِ الْإِذْنِ
u'تَحَقُّقٌ إِرَادَةٌ':Added, #1: 1	تَحَقُّقِ إرَادَةِ
u'تَحَقُّقٌ اِرْتِكَابٌ':Added, #1: 1	تَحَقُّقِ إرَادَتِهِ
u'تَحَقُّقٌ إِزَالَةٌ':Added, #2: 2	تَحَقُّقِ ارْتِكَابِ
u'تَحَقُّقٌ أسْبَابٌ':Added, #1: 1	تَحَقُّقِ الْإِزَالَةِ
u'تَحَقُّقٌ أَسْبَابٌ':Added, #1: 1	تَحَقُّقِ الْأَسْبَابِ
u'تَحَقَّقَ اِسْتِناد':Subject, #1: 1	تَحَقُّقِ الْأَسْبَابِ
u'تَحَقَّقَ اِسْتيعابٌ':Subject, #1: 1	تَحَقَّقَ اسْتِنَادُهُ
u'تَحَقُّقٌ اِشْتِباهٌ':Added, #1: 1	تَحَقَّقَ اسْتِيعَابُ
u'تَحَقَّقَ إصابَةٌ':Subject, #1: 1	تَحَقُّقِ اشْتِبَاهِ
u'تَحَقُّقٌ إصابَةٌ':Added, #1: 1	تَحَقَّقَ إصَابَةُ
u'تَحَقَّقَ أصل':Subject, #1: 1	تَحَقُّقِ الْإِصَابَةِ
u'تَحَقَّقَ أًصْلٌ':Subject, #1: 1	تَحَقَّقَ أَصْلُ
u'تَحَقُّقٌ أصل':Added, #1: 1	تَحَقَّقَ أَصْلُ
u'تَحَقُّقٌ أًصْلٌ':Added, #1: 1	تَحَقُّقُ أَصْلِ
u'تَحَقُّقٌ أصل':Added, #1: 1	تَحَقُّقُ أَصْلِ
u'تَحَقُّقٌ أًصْلٌ':Added, #2: 2	تَحَقُّقِ الْأَصْلِ
u'تَحَقُّقٌ أصل':Added, #2: 2	تَحَقُّقِ الْأَصْلِ
u'تَحَقُّقٌ أًصْلٌ':Added, #3: 3	تَحَقُّقِ أَصْلِ
u'تَحَقُّقٌ إِفْرَادٌ':Added, #3: 3	تَحَقُّقِ أَصْلِ
u'تَحَقُّقٌ إفْلاَسٌ':Added, #1: 1	تَحَقُّقِ الْإِفْرَادِ
u'تَحَقَّقَ إكْرَاهٌ':Subject, #3: 3	تَحَقُّقِ الْإِفْلَاسِ
u'تَحَقَّقَ إِلْقَاءٌ':Subject, #1: 1	تَحَقَّقَ الْإِكْرَاهُ
u'تَحَقَّقَ أَمْرٌ':Subject, #1: 1	تَحَقَّقَ إلْقَاءُ
u'تَحَقُّقٌ أَمْرٌ':Added, #1: 1	تَحَقَّقَ الْأَمْرُ
u'تَحَقَّقَ إِمْكانٌ':Subject, #1: 1	تَحَقُّقِ الْأَمْرِ
u'تَحَقُّقٌ إِمْكانٌ':Added, #1: 1	تَحَقَّقَ إمْكَانُ
u'تَحَقُّقٌ إِمْكانٌ':Added, #1: 1	تَحَقُّقِ إمْكَانِ
u'تَحَقَّقَ إِنْزالٌ':Subject, #3: 3	تَحَقُّقِ الْإِمْكَانِ
u'تَحَقُّقٌ إِنْزالٌ':Added, #1: 1	تَحَقَّقَ الْإِنْزَالُ
u'تَحَقُّقٌ اِنْقِرَاضٌ':Added, #1: 1	تَحَقُّقِ الْإِنْزَالِ
u'تَحَقَّقَ اِنْقِطاعٌ':Subject, #1: 1	تَحَقُّقِ انْقِرَاضِ
u'تَحَقَّقَ أَوَّلُ':Subject, #1: 1	تَحَقَّقَ انْقِطَاعُ
u'تَحَقُّقٌ بَدَلٌ':Added, #1: 1	تَحَقَّقَ الْأَوَّلُ
u'تَحَقَّقَ بَراءةٌ':Subject, #1: 1	تَحَقُّقِ الْبَدَلِ
u'تَحَقُّقٌ بَراءةٌ':Added, #1: 1	تَحَقَّقَ بَرَاءَةُ
u'تَحَقَّقَ بَصيرٌ':Subject, #2: 2	تَحَقُّقِ الْبَرَاءَةِ
u'تَحَقَّقَ بُلُوغٌ':Subject, #1: 1	تَحَقَّقَ الْبَصِيرُ
u'تَحَقَّقَ بِنَاءٌ':Subject, #1: 1	تَحَقَّقَ بُلُوغُهُ
u'تَحَقُّقٌ بَيْعٌ':Added, #1: 1	تَحَقَّقَ الْبِنَاءُ
u'تَحَقَّقَ بَيْنٌ':Predicate, #1: 1	تَحَقُّقِ بَيْعِهِ
u'تَحَقَّقَ تَبَرُّعٌ':Subject, #1: 1	تَحَقَّقَ بَيْنَ
u'تَحَقُّقٌ تَحْرِيمٌ':Added, #1: 1	تَحَقَّقَ التَّبَرُّعُ
u'تَحَقُّقٌ تَحَيُّل':Added, #1: 1	تَحَقُّقِ التَّحْرِيمِ
u'تَحَقَّقَ تَخَمُّرٌ':Subject, #1: 1	تَحَقُّقِ التَّحَيُّلِ
u'تَحَقَّقَ تَرْجِيحٌ':Subject, #1: 1	تَحَقَّقَ التَّخَمُّرُ
u'تَحَقَّقَ تَرْكٌ':Subject, #1: 1	تَحَقَّقَ التَّرْجِيحُ
u'تَحَقَّقَ تَسْلِيمٌ':Subject, #1: 1	تَحَقَّقَ تَرْكُهُ
u'تَحَقُّقٌ تَسْلِيمٌ':Added, #1: 1	تَحَقَّقَ التَّسْلِيمُ
u'تَحَقَّقَ تَعْلِيقٌ':Subject, #1: 1	تَحَقُّقِ التَّسْلِيمِ
u'تَحَقُّقٌ تَلَذُّذٌ':Added, #1: 1	تَحَقَّقَ التَّعْلِيقُ
u'تَحَقُّقٌ تمام':Added, #1: 1	تَحَقُّقِ التَّلَذُّذِ
u'تَحَقُّقٌ تَمامٌ':Added, #1: 1	تَحَقُّقِ تَمَامِ
u'تَحَقَّقَ تَنَاقُضٌ':Subject, #1: 1	تَحَقُّقِ تَمَامِ
u'تَحَقُّقٌ تَنَاقُضٌ':Added, #1: 1	تَحَقَّقَ التَّنَاقُضُ
u'تَحَقَّقَ ثُبُوتٌ':Subject, #1: 1	تَحَقُّقِ التَّنَاقُضِ
u'تَحَقُّقٌ ثُبُوتٌ':Added, #1: 1	تَحَقَّقَ ثُبُوتُ
u'تَحَقُّقٌ ثُبُوتٌ':Added, #1: 1	تَحَقُّقَ ثُبُوتِ
u'تَحَقُّقٌ ثَمَنٌ':Added, #2: 2	تَحَقُّقُ الثُّبُوتِ
u'تَحَقَّقَ جَازٌ':Predicate, #1: 1	تَحَقُّقَ الثَّمَنِ
u'تَحَقَّقَ جَامِعٌ':Subject, #1: 1	تَحَقَّقَ جَازَ
u'تَحَقُّقٌ جُزْءٌ':Added, #1: 1	تَحَقَّقَ جَامِعٌ
u'تَحَقُّقٌ جُزْءٌ':Added, #1: 1	تَحَقُّقِ الْجُزْءِ
u'تَحَقَّقَ جَمَاعَةٌ':Predicate, #1: 1	تَحَقُّقِ جُزْءٍ
u'تَحَقَّقَ جمع':Subject, #1: 1	تَحَقَّقَ الْجَمَاعَةَ
u'تَحَقَّقَ جَمْعٌ':Subject, #1: 1	تَحَقَّقَ الْجَمْعُ
u'تَحَقُّقٌ جمع':Added, #1: 1	تَحَقَّقَ الْجَمْعُ
u'تَحَقُّقٌ جمع':Added, #1: 1	تَحَقُّقُ الْجَمْعِ
u'تَحَقُّقٌ جَمْعٌ':Added, #1: 1	تَحَقُّقِ الْجَمْعِ
u'تَحَقُّقٌ جَمْعٌ':Added, #1: 1	تَحَقُّقُ الْجَمْعِ
u'تَحَقُّقٌ جِنَايَةٌ':Added, #1: 1	تَحَقُّقِ الْجَمْعِ
u'تَحَقُّقٌ جِنَايَةٌ':Added, #1: 1	تَحَقُّقُ الْجِنَايَةِ
u'تَحَقَّقَ جهل':Subject, #1: 1	تَحَقُّقِ جِنَايَةٍ
u'تَحَقَّقَ جَهْلٌ':Subject, #1: 1	تَحَقَّقَ جَهْلُ
u'تَحَقُّقٌ جَوَابٌ':Added, #1: 1	تَحَقَّقَ جَهْلُ
u'تَحَقَّقَ حاجَةٌ':Predicate, #1: 1	تَحَقُّقِ الْجَوَابِ
u'تَحَقُّقٌ حاجَةٌ':Added, #1: 1	تَحَقَّقَ الْحَاجَةَ
u'تَحَقُّقٌ حاجَةٌ':Added, #1: 1	تَحَقُّقُ الْحَاجَةِ
u'تَحَقُّقٌ حاجَةٌ':Added, #1: 1	تَحَقُّقِ حَاجَةِ
u'تَحَقَّقَ حاكِمٌ':Subject, #9: 9	تَحَقُّقِ الْحَاجَةِ
u'تَحَقُّقٌ حالٌ':Added, #2: 2	تَحَقَّقَ الْحَاكِمُ
u'تَحَقُّقٌ حَدَثٌ':Added, #1: 1	تَحَقُّقِ الْحَالِ
u'تَحَقَّقَ حُدوثٌ':Subject, #1: 1	تَحَقُّقِ الْحَدَثِ
u'تَحَقُّقٌ حُدوثٌ':Added, #1: 1	تَحَقَّقَ حُدُوثُهُ
u'تَحَقَّقَ حَرَجٌ':Subject, #1: 1	تَحَقُّقِ الْحُدُوثِ
u'تَحَقُّقٌ حُرِّيَّةٌ':Added, #1: 1	تَحَقَّقَ الْحَرَجُ
u'تَحَقُّقٌ حِسِّيٌّ':Added, #1: 1	تَحَقُّقِ الْحُرِّيَّةِ
u'تَحَقَّقَ حُصُول':Subject, #1: 1	تَحَقُّقِ الْحِسِّيَّاتِ
u'تَحَقُّقٌ حُصُول':Added, #1: 1	تَحَقَّقَ حُصُولُ
u'تَحَقُّقٌ حَقِيقٌ':Added, #1: 1	تَحَقُّقِ الْحُصُولِ
u'تَحَقُّقٌ حَقِيقَةٌ':Added, #1: 1	تَحَقُّقِ حَقِيقَةِ
u'تَحَقَّقَ حُكْمٌ':Subject, #1: 1	تَحَقُّقِ حَقِيقَةِ
u'تَحَقُّقٌ حُكْمٌ':Added, #1: 1	تَحَقَّقَ الْحُكْمُ
u'تَحَقُّقٌ حُكْمٌ':Added, #1: 1	تَحَقُّقُ الْحُكْمِ
u'تَحَقُّقٌ حُكْمٌ':Added, #1: 1	تَحَقُّقِ حُكْمِ
u'تَحَقُّقٌ حكمة':Added, #3: 3	تَحَقُّقِ الْحُكْمِ
u'تَحَقُّقٌ حِكْمَةٌ':Added, #1: 1	تَحَقُّقِ الْحِكْمَةِ
u'تَحَقُّقٌ حِلٌّ':Added, #1: 1	تَحَقُّقِ الْحِكْمَةِ
u'تَحَقَّقَ حِنْثٌ':Subject, #1: 1	تَحَقُّقَ الْحِلِّ
u'تَحَقَّقَ حِنْثٌ':Subject, #1: 1	تَحَقَّقَ حِنْثُهُ
u'تَحَقُّقٌ حِنْثٌ':Added, #2: 2	تَحَقَّقَ الْحِنْثُ
u'تَحَقُّقٌ حَيَاةٌ':Added, #1: 1	تَحَقُّقِ الْحِنْثِ
u'تَحَقُّقٌ حَيَاةٌ':Added, #1: 1	تَحَقُّقُ الْحَيَاةِ
u'تَحَقُّقٌ حَيَاةٌ':Added, #1: 1	تَحَقُّقَ حَيَاةِ
u'تَحَقُّقٌ حَيَاةٌ':Added, #1: 1	تَحَقُّقُ حَيَاةِ
u'تَحَقَّقَ خاصّ':Subject, #1: 1	تَحَقُّقِ حَيَاتِهِ
u'تَحَقُّقٌ خُبْثٌ':Added, #1: 1	تَحَقَّقَ الْخَاصُّ
u'تَحَقَّقَ خُرُوجٌ':Predicate, #1: 1	تَحَقُّقِ الْخُبْثِ
u'تَحَقَّقَ خُرُوجٌ':Subject, #1: 1	تَحَقَّقَ خُرُوجَ
u'تَحَقَّقَ خُرُوجٌ':Subject, #1: 1	تَحَقَّقَ الْخُرُوجُ
u'تَحَقُّقٌ خُرُوجٌ':Added, #1: 1	تَحَقَّقَ خُرُوجُهُ
u'تَحَقُّقٌ خِطَابٌ':Added, #1: 1	تَحَقُّقَ خُرُوجِ
u'تَحَقَّقَ خِلاَفٌ':Subject, #1: 1	تَحَقُّقِ الْخِطَابِ
u'تَحَقَّقَ خِلاَفٌ':Subject, #1: 1	تَحَقَّقَ الْخِلَافُ
u'تَحَقُّقٌ خِلاَفٌ':Added, #1: 1	تَحَقَّقَ خِلَافُهُ
u'تَحَقَّقَ خَوْفٌ':Subject, #1: 1	تَحَقُّقِ الْخِلَافِ
u'تَحَقُّقٌ دُخُولٌ':Added, #1: 1	تَحَقَّقَ الْخَوْفُ
u'تَحَقُّقٌ دُخُولٌ':Added, #2: 2	تَحَقُّقِ الدُّخُولِ
u'تَحَقَّقَ دفع':Predicate, #4: 4	تَحَقُّقِ دُخُولِ
u'تَحَقُّقٌ دَلالَةٌ':Added, #1: 1	تَحَقَّقَ دُفِعَ
u'تَحَقَّقَ رُجُوعٌ':Subject, #1: 1	تَحَقُّقُ دَلَالَةِ
u'تَحَقَّقَ رشاد':Subject, #1: 1	تَحَقَّقَ رُجُوعُهُ
u'تَحَقَّقَ رَشادٌ':Subject, #1: 1	تَحَقَّقَ رَشَادُهُ
u'تَحَقَّقَ رِضاً':Subject, #1: 1	تَحَقَّقَ رَشَادُهُ
u'تَحَقُّقٌ رِوايَةٌ':Added, #2: 2	تَحَقَّقَ رِضَاهُ
u'تَحَقُّقٌ رُؤْيَةٌ':Added, #1: 1	تَحَقُّقُ رِوَايَةِ
u'تَحَقُّقٌ زَمانٌ':Added, #1: 1	تَحَقُّقِ الرُّؤْيَةِ
u'تَحَقَّقَ زَوالٌ':Subject, #1: 1	تَحَقُّقِ زَمَانِ
u'تَحَقُّقٌ زَوالٌ':Added, #1: 1	تَحَقَّقَ زَوَالُ
u'تَحَقُّقٌ زِيادَةٌ':Added, #1: 1	تَحَقُّقُ الزَّوَالِ
u'تَحَقُّقٌ زِيادَةٌ':Added, #3: 3	تَحَقُّقِ الزِّيَادَةِ
u'تَحَقَّقَ سَبَبٌ':Subject, #3: 3	تَحَقُّقُ زِيَادَةٍ
u'تَحَقَّقَ سَبَبٌ':Subject, #1: 1	تَحَقَّقَ سَبَبُ
u'تَحَقُّقٌ سَبَبٌ':Added, #1: 1	تَحَقَّقَ سَبَبُهُ
u'تَحَقُّقٌ سَبَبٌ':Added, #1: 1	تَحَقُّقُ سَبَبِ
u'تَحَقُّقٌ سَبَبٌ':Added, #1: 1	تَحَقُّقِ سَبَبٍ
u'تَحَقُّقٌ سَبَبٌ':Added, #1: 1	تَحَقُّقِ سَبَبِ
u'تَحَقُّقٌ سَبَبٌ':Added, #1: 1	تَحَقُّقِ سَبَبِهِ
u'تَحَقُّقٌ سَبَبٌ':Added, #2: 2	تَحَقُّقُ السَّبَبِ
u'تَحَقُّقٌ سَبْقٌ':Added, #7: 7	تَحَقُّقِ السَّبَبِ
u'تَحَقُّقٌ سَبْقٌ':Added, #1: 1	تَحَقُّقِ سَبْقِ
u'تَحَقُّقٌ سَرقَةٌ':Added, #1: 1	تَحَقُّقِ سَبْقِهِ
u'تَحَقُّقٌ سَرِقَةٌ':Added, #1: 1	تَحَقُّقُ السَّرِقَةِ
u'تَحَقُّقٌ سَفَرٌ':Added, #1: 1	تَحَقُّقُ السَّرِقَةِ
u'تَحَقَّقَ سَمَاعٌ':Subject, #3: 3	تَحَقُّقِ السَّفَرِ
u'تَحَقُّقٌ شُبْهَةٌ':Added, #2: 2	تَحَقَّقَ سَمَاعُ
u'تَحَقُّقٌ شُبْهَةٌ':Added, #1: 1	تَحَقُّقَ الشُّبْهَةِ
u'تَحَقُّقٌ شُبْهَةٌ':Added, #1: 1	تَحَقُّقِ شُبْهَةٍ
u'تَحَقَّقَ شَرَائِطُ':Subject, #1: 1	تَحَقُّقِ شُبْهَتِهِ
u'تَحَقُّقٌ شَرَائِطُ':Added, #1: 1	تَحَقَّقَ شَرَائِطُ
u'تَحَقَّقَ شَرْطٌ':Subject, #1: 1	تَحَقُّقُ شَرَائِطِ
u'تَحَقَّقَ شَرْطٌ':Subject, #5: 5	تَحَقَّقَ شَرْطُ
u'تَحَقُّقٌ شَرْطٌ':Added, #6: 6	تَحَقَّقَ الشَّرْطُ
u'تَحَقُّقٌ شَرْطٌ':Added, #1: 1	تَحَقُّقَ الشَّرْطِ
u'تَحَقُّقٌ شَرْطٌ':Added, #2: 2	تَحَقُّقِ شَرْطِهِ
u'تَحَقُّقٌ شَرْطٌ':Added, #3: 3	تَحَقُّقِ شَرْطِ
u'تَحَقُّقٌ شرف':Added, #9: 9	تَحَقُّقِ الشَّرْطِ
u'تَحَقُّقٌ شَرَفٌ':Added, #1: 1	تَحَقُّقِ شَرَفِ
u'تَحَقُّقٌ شُرُوطٌ':Added, #1: 1	تَحَقُّقِ شَرَفِ
u'تَحَقُّقٌ شُرُوطٌ':Added, #1: 1	تَحَقُّقِ الشُّرُوطِ
u'تَحَقُّقٌ شَهَادَةٌ':Added, #1: 1	تَحَقُّقِ شُرُوطِهِ
u'تَحَقُّقٌ شَيْءٌ':Added, #1: 1	تَحَقُّقِ الشَّهَادَةِ
u'تَحَقُّقٌ صِفَةٌ':Added, #1: 1	تَحَقُّقِ الشَّيْءِ
u'تَحَقُّقٌ صلح':Added, #1: 1	تَحَقُّقِ الصِّفَةِ
u'تَحَقُّقٌ صُلْحٌ':Added, #2: 2	تَحَقُّقِ الصُّلْحِ
u'تَحَقَّقَ ضَرْبٌ':Subject, #2: 2	تَحَقُّقِ الصُّلْحِ
u'تَحَقُّقٌ ضَرَرٌ':Added, #1: 1	تَحَقَّقَ الضَّرْبُ
u'تَحَقُّقٌ ضَرُورَةٌ':Added, #1: 1	تَحَقُّقِ الضَّرَرِ
u'تَحَقُّقٌ ضَرُورَةٌ':Added, #1: 1	تَحَقُّقِ الضَّرُورَاتِ
u'تَحَقُّقٌ ضَرُورَةٌ':Added, #2: 2	تَحَقُّقِ ضَرُورَةٍ
u'تَحَقُّقٌ طَرِيقٌ':Added, #6: 6	تَحَقُّقِ الضَّرُورَةِ
u'تَحَقُّقٌ طَلاَقٌ':Added, #1: 1	تَحَقُّقِ طَرِيقٍ
u'تَحَقَّقَ طلب':Subject, #2: 2	تَحَقُّقِ الطَّلَاقِ
u'تَحَقَّقَ طَلَبٌ':Subject, #1: 1	تَحَقَّقَ الطَّلَبُ
u'تَحَقُّقٌ طُلُوعٌ':Added, #1: 1	تَحَقَّقَ الطَّلَبُ
u'تَحَقُّقٌ طُلُوعٌ':Added, #1: 1	تَحَقُّقُ طُلُوعِ
u'تَحَقُّقٌ طَهَارَةٌ':Added, #1: 1	تَحَقُّقِ طُلُوعِ
u'تَحَقُّقٌ طَهَارَةٌ':Added, #1: 1	تَحَقُّقَ الطَّهَارَةِ
u'تَحَقُّقٌ ظَفَرٌ':Added, #1: 1	تَحَقُّقِ الطَّهَارَةِ
u'تَحَقَّقَ ظُلْمٌ':Subject, #1: 1	تَحَقُّقُ الظَّفَرِ
u'تَحَقُّقٌ ظَنٌّ':Added, #1: 1	تَحَقَّقَ ظُلْمُ
u'تَحَقَّقَ ظُهورٌ':Subject, #1: 1	تَحَقُّقِ ظَنِّ
u'تَحَقَّقَ عَامٌّ':Subject, #1: 1	تَحَقَّقَ ظُهُورُ
u'تَحَقَّقَ عجز':Subject, #1: 1	تَحَقَّقَ الْعَامُّ
u'تَحَقَّقَ عَجْزٌ':Subject, #10: 10	تَحَقَّقَ الْعَجْزُ
u'تَحَقَّقَ عجز':Subject, #10: 10	تَحَقَّقَ الْعَجْزُ
u'تَحَقَّقَ عَجْزٌ':Subject, #3: 3	تَحَقَّقَ عَجْزُ
u'تَحَقَّقَ عجز':Subject, #3: 3	تَحَقَّقَ عَجْزُ
u'تَحَقَّقَ عَجْزٌ':Subject, #7: 7	تَحَقَّقَ عَجْزُهُ
u'تَحَقُّقٌ عجز':Added, #7: 7	تَحَقَّقَ عَجْزُهُ
u'تَحَقُّقٌ عَجْزٌ':Added, #1: 1	تَحَقُّقِ عَجْزِهِ
u'تَحَقُّقٌ عجز':Added, #1: 1	تَحَقُّقِ عَجْزِهِ
u'تَحَقُّقٌ عَجْزٌ':Added, #5: 5	تَحَقُّقِ الْعَجْزِ
u'تَحَقُّقٌ عَدَدٌ':Added, #5: 5	تَحَقُّقِ الْعَجْزِ
u'تَحَقَّقَ عَدَمٌ':Predicate, #1: 1	تَحَقُّقِ الْعَدَدِ
u'تَحَقَّقَ عَدَمٌ':Subject, #2: 2	تَحَقَّقَ عَدَمَ
u'تَحَقَّقَ عَدَمٌ':Subject, #1: 1	تَحَقَّقَ عَدَمُهُ
u'تَحَقَّقَ عَدَمٌ':Subject, #3: 3	تَحَقَّقَ الْعَدَمُ
u'تَحَقُّقٌ عَدَمٌ':Added, #6: 6	تَحَقَّقَ عَدَمُ
u'تَحَقُّقٌ عَدَمٌ':Added, #1: 1	تَحَقُّقَ عَدَمِهِ
u'تَحَقُّقٌ عَدَمٌ':Added, #2: 2	تَحَقُّقَ عَدَمِ
u'تَحَقُّقٌ عَدَمٌ':Added, #2: 2	تَحَقُّقِ عَدَمِهِ
u'تَحَقَّقَ عُذْرٌ':Subject, #5: 5	تَحَقُّقِ عَدَمِ
u'تَحَقُّقٌ عُذْرٌ':Added, #5: 5	تَحَقَّقَ الْعُذْرُ
u'تَحَقَّقَ عَزْمٌ':Subject, #2: 2	تَحَقُّقِ الْعُذْرِ
u'تَحَقُّقٌ عِصْمَةٌ':Added, #1: 1	تَحَقَّقَ عَزْمُهُ
u'تَحَقَّقَ عِصْيَانٌ':Subject, #1: 1	تَحَقُّقُ الْعِصْمَةِ
u'تَحَقُّقٌ عقاب':Added, #1: 1	تَحَقَّقَ عِصْيَانُ
u'تَحَقُّقٌ عِقَابٌ':Added, #1: 1	تَحَقُّقُ الْعِقَابِ
u'تَحَقُّقٌ عَلاَقَةٌ':Added, #1: 1	تَحَقُّقُ الْعِقَابِ
u'تَحَقُّقٌ عِلَّةٌ':Added, #1: 1	تَحَقُّقِ عَلَاقَةٍ
u'تَحَقُّقٌ عِلَّةٌ':Added, #1: 1	تَحَقُّقَ الْعِلَّةِ
u'تَحَقُّقٌ عَمْد':Added, #2: 2	تَحَقُّقِ الْعِلَّةِ
u'تَحَقُّقٌ عَمْدِيّ':Added, #1: 1	تَحَقُّقَ الْعَمْدِيَّةِ
u'تَحَقُّقٌ عُمُومٌ':Added, #1: 1	تَحَقُّقَ الْعَمْدِيَّةِ
u'تَحَقُّقٌ عُمُومٌ':Added, #1: 1	تَحَقُّق الْعُمُومِ
u'تَحَقَّقَ غُرُوبٌ':Subject, #1: 1	تَحَقُّقَ عُمُومِ
u'تَحَقُّقٌ غُرُوبٌ':Added, #2: 2	تَحَقَّقَ غُرُوبُ
u'تَحَقَّقَ غَصْبٌ':Subject, #1: 1	تَحَقُّقِ الْغُرُوبِ
u'تَحَقُّقٌ غَصْبٌ':Added, #1: 1	تَحَقَّقَ الْغَصْبُ
u'تَحَقُّقٌ غَصْبٌ':Added, #1: 1	تَحَقُّقِ غَصْبٍ
u'تَحَقُّقٌ غفلة':Added, #2: 2	تَحَقُّقِ الْغَصْبِ
u'تَحَقُّقٌ غَفْلَةٌ':Added, #1: 1	تَحَقُّقِ غَفْلَتِهِ
u'تَحَقُّقٌ غيم':Added, #1: 1	تَحَقُّقِ غَفْلَتِهِ
u'تَحَقُّقٌ غَيْمٌ':Added, #1: 1	تَحَقُّقِ الْغَيْمِ
u'تَحَقَّقَ فرق':Subject, #1: 1	تَحَقُّقِ الْغَيْمِ
u'تَحَقَّقَ فَرْقٌ':Subject, #1: 1	تَحَقَّقَ الْفَرْقُ
u'تَحَقَّقَ فساد':Subject, #1: 1	تَحَقَّقَ الْفَرْقُ
u'تَحَقَّقَ فَسَادٌ':Subject, #1: 1	تَحَقَّقَ الْفَسَادُ
u'تَحَقُّقٌ فَضْلٌ':Added, #1: 1	تَحَقَّقَ الْفَسَادُ
u'تَحَقُّقٌ فَضْلٌ':Added, #1: 1	تَحَقُّقُ الْفَضْلِ
u'تَحَقُّقٌ فِعْلٌ':Added, #1: 1	تَحَقُّقِ الْفَضْلِ
u'تَحَقُّقٌ فِعْلٌ':Added, #2: 2	تَحَقُّقِ الْفِعْلِ
u'تَحَقُّقٌ فِعْلٌ':Added, #3: 3	تَحَقُّقِ فِعْلِ
u'تَحَقَّقَ فَوَاتٌ':Subject, #5: 5	تَحَقُّقَ الْفِعْلِ
u'تَحَقُّقٌ فَوَاتٌ':Added, #1: 1	تَحَقَّقَ فَوَاتُ
u'تَحَقَّقَ قَاطِعٌ':Subject, #2: 2	تَحَقُّقُ فَوَاتِ
u'تَحَقَّقَ قَبْضٌ':Subject, #1: 1	تَحَقَّقَ الْقَاطِعُ
u'تَحَقَّقَ قَبُولٌ':Subject, #1: 1	تَحَقَّقَ الْقَبْضُ
u'تَحَقُّقٌ قدرة':Added, #1: 1	تَحَقَّقَ الْقَبُولُ
u'تَحَقُّقٌ قُدْرَةٌ':Added, #2: 2	تَحَقُّقِ الْقُدْرَةِ
u'تَحَقُّقٌ قِرَانٌ':Added, #2: 2	تَحَقُّقِ الْقُدْرَةِ
u'تَحَقَّقَ قَصْدٌ':Subject, #1: 1	تَحَقُّقَ الْقِرَانِ
u'تَحَقُّقٌ قَصْدٌ':Added, #1: 1	تَحَقَّقَ قَصْدُهُ
u'تَحَقَّقَ قُصُورٌ':Subject, #2: 2	تَحَقُّقِ قَصْدِ
u'تَحَقُّقٌ قَطْعٌ':Added, #1: 1	تَحَقَّقَ قُصُورُهُ
u'تَحَقَّقَ قِيَاسٌ':Subject, #1: 1	تَحَقُّقِ الْقَطْعِ
u'تَحَقُّقٌ قِيَاسٌ':Added, #1: 1	تَحَقَّقَ الْقِيَاسُ
u'تَحَقَّقَ كذب':Subject, #1: 1	تَحَقُّقِ الْقِيَاسِ
u'تَحَقَّقَ كَذِبٌ':Subject, #1: 1	تَحَقَّقَ كَذِبُ
u'تَحَقُّقٌ كذب':Added, #1: 1	تَحَقَّقَ كَذِبُ
u'تَحَقُّقٌ كَذِبٌ':Added, #1: 1	تَحَقُّقَ الْكَذِبِ
u'تَحَقُّقٌ كَفَالَةٌ':Added, #1: 1	تَحَقُّقَ الْكَذِبِ
u'تَحَقَّقَ كَوْنٌ':Subject, #1: 1	تَحَقُّقِ كَفَالَتِهِ
u'تَحَقُّقٌ كَوْنٌ':Added, #4: 4	تَحَقَّقَ كَوْنُهُ
u'تَحَقُّقٌ كَوْنٌ':Added, #1: 1	تَحَقُّقِ كَوْنِ
u'تَحَقُّقٌ كَوْنٌ':Added, #1: 1	تَحَقُّقُ كَوْنِهِ
u'تَحَقَّقَ لاَزِمٌ':Subject, #3: 3	تَحَقُّقِ كَوْنِهِ
u'تَحَقُّقٌ لاَزِمٌ':Added, #1: 1	تَحَقَّقَ اللَّازِمُ
u'تَحَقُّقٌ لُزُومٌ':Added, #1: 1	تَحَقُّقِ اللَّازِمِ
u'تَحَقُّقٌ مَأْمُورٌ':Added, #1: 1	تَحَقُّقَ اللُّزُومِ
u'تَحَقُّقٌ مُبَادَلَةٌ':Added, #1: 1	تَحَقُّقُ الْمَأْمُورِ
u'تَحَقَّقَ مثل':Subject, #2: 2	تَحَقُّقُ الْمُبَادَلَةِ
u'تَحَقَّقَ مِثْلٌ':Subject, #1: 1	تَحَقَّقَ مِثْلُهُ
u'تَحَقُّقٌ مُحَاذَاةٌ':Added, #1: 1	تَحَقَّقَ مِثْلُهُ
u'تَحَقُّقٌ مُحَاذَاةٌ':Added, #1: 1	تَحَقُّقَ الْمُحَاذَاةِ
u'تَحَقُّقٌ مُخَالَفَةٌ':Added, #1: 1	تَحَقُّقِ الْمُحَاذَاةِ
u'تَحَقَّقَ مَذْهَبٌ':Subject, #1: 1	تَحَقُّقِ الْمُخَالَفَةِ
u'تَحَقُّقٌ مراد':Added, #1: 1	تَحَقَّقَ مَذْهَبٌ
u'تَحَقُّقٌ مُرَادٌ':Added, #1: 1	تَحَقُّقُ الْمُرَادِ
u'تَحَقُّقٌ مُسَاوَاةٌ':Added, #1: 1	تَحَقُّقُ الْمُرَادِ
u'تَحَقُّقٌ مُسَاوَاةٌ':Added, #1: 1	تَحَقُّقِ مُسَاوَاةٍ
u'تَحَقُّقٌ مُسَاوَاةٌ':Added, #2: 2	تَحَقُّقَ الْمُسَاوَاةِ
u'تَحَقُّقٌ مُسَاوَاةٌ':Added, #2: 2	تَحَقُّقُ الْمُسَاوَاةِ
u'تَحَقَّقَ مُسْلِمٌ':Subject, #2: 2	تَحَقُّقِ الْمُسَاوَاةِ
u'تَحَقُّقٌ مَشْرُوطٌ':Added, #1: 1	تَحَقَّقَ الْمُسْلِمُ
u'تَحَقُّقٌ مَصْلَحَةٌ':Added, #1: 1	تَحَقُّقُ الْمَشْرُوطِ
u'تَحَقُّقٌ مُضِيٌّ':Added, #1: 1	تَحَقُّقِ الْمَصْلَحَةِ
u'تَحَقُّقٌ مُطْلَقٌ':Added, #2: 2	تَحَقُّقِ مُضِيِّ
u'تَحَقُّقٌ مَعْقُودٌ':Added, #1: 1	تَحَقُّقَ الْمُطْلَقِ
u'تَحَقُّقٌ مُعَلَّقٌ':Added, #2: 2	تَحَقُّقِ الْمَعْقُودِ
u'تَحَقُّقٌ مُفَاضَلَةٌ':Added, #1: 1	تَحَقُّقِ الْمُعَلَّقِ
u'تَحَقُّقٌ مَقَاصِدُ':Added, #1: 1	تَحَقُّقِ الْمُفَاضَلَةِ
u'تَحَقُّقٌ مُقْتَضىً':Added, #1: 1	تَحَقُّقِ الْمَقَاصِدِ
u'تَحَقُّقٌ مَقْصُودٌ':Added, #1: 1	تَحَقُّقِ مُقْتَضِيهِ
u'تَحَقُّقٌ مَقْصُودٌ':Added, #1: 1	تَحَقُّقِ الْمَقْصُودِ
u'تَحَقُّقٌ مَقْصُودٌ':Added, #1: 1	تَحَقُّقُ مَقْصُودِ
u'تَحَقُّقٌ مُقَيَّدٌ':Added, #3: 3	تَحَقُّقُ الْمَقْصُودِ
u'تَحَقُّقٌ مُلاَزَمَةٌ':Added, #1: 1	تَحَقُّقُ الْمُقَيَّدِ
u'تَحَقَّقَ مَلْزُوم':Subject, #1: 1	تَحَقُّقِ الْمُلَازَمَةِ
u'تَحَقُّقٌ مَلْزُوم':Added, #3: 3	تَحَقَّقَ الْمَلْزُومُ
u'تَحَقَّقَ مِلْكٌ':Subject, #2: 2	تَحَقُّقِ الْمَلْزُومِ
u'تَحَقُّقٌ مِلْكٌ':Added, #1: 1	تَحَقَّقَ مِلْكُهُ
u'تَحَقُّقٌ مُمَاثَلَةٌ':Added, #2: 2	تَحَقُّقُ الْمِلْكِ
u'تَحَقُّقٌ مُمَاثَلَةٌ':Added, #2: 2	تَحَقُّقُ الْمُمَاثَلَةِ
u'تَحَقُّقٌ مُمَاسَّةٌ':Added, #3: 3	تَحَقُّقِ الْمُمَاثَلَةِ
u'تَحَقُّقٌ مُنَاسَبَةٌ':Added, #1: 1	تَحَقُّقِ مُمَاسَّةِ
u'تَحَقُّقٌ مَنْفَعَةٌ':Added, #1: 1	تَحَقُّقِ الْمُنَاسَبَةِ
u'تَحَقُّقٌ مَنْهِيٌّ':Added, #1: 1	تَحَقُّقِ الْمَنْفَعَةِ
u'تَحَقُّقٌ مَنْهِيٌّ':Added, #1: 1	تَحَقُّقِ الْمَنْهِيِّ
u'تَحَقَّقَ مَوْتٌ':Subject, #2: 2	تَحَقُّقَ الْمَنْهِيِّ
u'تَحَقُّقٌ مَوْتٌ':Added, #2: 2	تَحَقَّقَ مَوْتُهُ
u'تَحَقَّقَ مُوجِبٌ':Subject, #1: 1	تَحَقُّقِ الْمَوْتِ
u'تَحَقُّقٌ مُوجِبٌ':Added, #1: 1	تَحَقَّقَ الْمُوجِبُ
u'تَحَقُّقٌ مُوجِبٌ':Added, #2: 2	تَحَقُّقِ الْمُوجِبِ
u'تَحَقُّقٌ مُوجِبٌ':Added, #2: 2	تَحَقُّقِ مُوجِبِ
u'تَحَقَّقَ نَجَاسَةٌ':Subject, #2: 2	تَحَقُّقِ مُوجِبِهِ
u'تَحَقَّقَ نَجَاسَةٌ':Subject, #1: 1	تَحَقَّقَ النَّجَاسَةُ
u'تَحَقُّقٌ نَجَاسَةٌ':Added, #1: 1	تَحَقَّقَ نَجَاسَتُهُ
u'تَحَقُّقٌ نَجَاسَةٌ':Added, #1: 1	تَحَقُّقِ النَّجَاسَةِ
u'تَحَقُّقٌ نَجَاسَةٌ':Added, #1: 1	تَحَقُّقَ نَجَاسَةِ
u'تَحَقُّقٌ نَجْدَةٌ':Added, #1: 1	تَحَقُّقِ نَجَاسَتِهِ
u'تَحَقُّقٌ نذر':Added, #1: 1	تَحَقُّقِ النَّجْدَةِ
u'تَحَقُّقٌ نَذْرٌ':Added, #1: 1	تَحَقُّقُ النَّذْرِ
u'تَحَقُّقٌ نِسْيَانٌ':Added, #1: 1	تَحَقُّقُ النَّذْرِ
u'تَحَقُّقٌ نصاب':Added, #1: 1	تَحَقُّقِ النِّسْيَانِ
u'تَحَقُّقٌ نِصَابٌ':Added, #1: 1	تَحَقُّقِ النِّصَابِ
u'تَحَقَّقَ نَظَرٌ':Subject, #1: 1	تَحَقُّقِ النِّصَابِ
u'تَحَقُّقٌ نَفْسٌ':Added, #1: 1	تَحَقَّقَ نَظَرٌ
u'تَحَقُّقٌ نَفْعٌ':Added, #1: 1	تَحَقُّقُ النَّفْسِ
u'تَحَقَّقَ نَفْيٌ':Subject, #1: 1	تَحَقُّقَ النَّفْعِ
u'تَحَقَّقَ نَقْضٌ':Subject, #1: 1	تَحَقَّقَ نَفْيُهُ
u'تَحَقَّقَ نَوْمٌ':Predicate, #1: 1	تَحَقَّقَ نَقْضُ
u'تَحَقُّقٌ نَوْمٌ':Added, #1: 1	تَحَقَّقَ النَّوْمَ
u'تَحَقُّقٌ نِيَّةٌ':Added, #1: 1	تَحَقُّقِ النَّوْمِ
u'تَحَقُّقٌ نِيَّةٌ':Added, #1: 1	تَحَقُّقُ نِيَّةِ
u'تَحَقُّقٌ وَاقِعٌ':Added, #1: 1	تَحَقُّقِ نِيَّةِ
u'تَحَقَّقَ وَجَبٌ':Predicate, #1: 1	تَحَقُّقِ الْوَاقِعَاتِ
u'تَحَقَّقَ وُجُوبٌ':Subject, #1: 1	تَحَقَّقَ وَجَبَ
u'تَحَقُّقٌ وُجُوبٌ':Added, #1: 1	تَحَقَّقَ وُجُوبُ
u'تَحَقُّقٌ وُجُوبٌ':Added, #1: 1	تَحَقُّقَ الْوُجُوبِ
u'تَحَقُّقٌ وُجُوبٌ':Added, #1: 1	تَحَقُّقِ وُجُوبِ
u'تَحَقُّقٌ وُجُوبٌ':Added, #1: 1	تَحَقُّقِ وُجُوبِهِ
u'تَحَقُّقٌ وُجُوبٌ':Added, #3: 3	تَحَقُّقِ الْوُجُوبِ
u'تَحَقَّقَ وُجُودٌ':Subject, #4: 4	تَحَقُّقُ الْوُجُوبِ
u'تَحَقَّقَ وُجُودٌ':Subject, #2: 2	تَحَقَّقَ وُجُودُ
u'تَحَقُّقٌ وُجُودٌ':Added, #5: 5	تَحَقَّقَ وُجُودُهُ
u'تَحَقُّقٌ وُجُودٌ':Added, #1: 1	تَحَقُّقُ وُجُودِ
u'تَحَقُّقٌ وُجُودٌ':Added, #1: 1	تَحَقُّقُ وُجُودِهِ
u'تَحَقُّقٌ وُجُودٌ':Added, #2: 2	تَحَقُّقِ وُجُودِ
u'تَحَقَّقَ وَصْفٌ':Subject, #3: 3	تَحَقُّقِ وُجُودِهِ
u'تَحَقُّقٌ وَصْفٌ':Added, #1: 1	تَحَقَّقَ وَصْفُهُ
u'تَحَقُّقٌ وَصْفٌ':Added, #1: 1	تَحَقُّقَ الْوَصْفِ
u'تَحَقُّقٌ وَصْفٌ':Added, #1: 1	تَحَقُّقُ الْوَصْفَيْنِ
u'تَحَقَّقَ وُصُولٌ':Subject, #1: 1	تَحَقُّقِ الْوَصْفَيْنِ
u'تَحَقَّقَ وُصُولٌ':Subject, #1: 1	تَحَقَّقَ الْوُصُولُ
u'تَحَقُّقٌ وَضْعٌ':Added, #2: 2	تَحَقَّقَ وُصُولُ
u'تَحَقُّقٌ وَطْءٌ':Added, #1: 1	تَحَقُّقُ الْوَضْعِ
u'تَحَقَّقَ وَفَاءٌ':Subject, #1: 1	تَحَقُّقَ الْوَطْءِ
u'تَحَقُّقٌ وَقْتٌ':Added, #1: 1	تَحَقَّقَ الْوَفَاءُ
u'تَحَقَّقَ وُقُوعٌ':Subject, #3: 3	تَحَقُّقِ الْوَقْتِ
u'تَحَقُّقٌ وُقُوفٌ':Added, #1: 1	تَحَقَّقَ وُقُوعُهُ
u'تَحَقَّقَ وِلاَدَةٌ':Subject, #1: 1	تَحَقُّقِ الْوُقُوفِ
u'تَحَقُّقٌ وِلاَيَةٌ':Added, #1: 1	تَحَقَّقَ وِلَادَةُ
u'تَحَقَّقَ يَأْسٌ':Subject, #1: 1	تَحَقُّقِ الْوِلَايَةِ
u'تَحَقَّقَ يَأْسٌ':Subject, #1: 1	تَحَقَّقَ يَأْسُهُ
u'تَحَقُّقٌ يَأْسٌ':Added, #3: 3	تَحَقَّقَ الْيَأْسُ
u'تَحَقُّقٌ يَأْسٌ':Added, #1: 1	تَحَقُّقَ الْيَأْسِ
u'تَحَقُّقٌ يَأْسٌ':Added, #1: 1	تَحَقُّقِ الْيَأْسِ
u'تَحْقِيرٌ قَائِلٌ':Added, #2: 2	تَحَقُّقُ الْيَأْسِ
u'تَحْقِيقٌ اِبْنٌ':Added, #2: 2	تَحْقِيرِ قَائِلِهِ
u'تَحْقِيقٌ أَحْكَامٌ':Added, #1: 1	تَحْقِيقُ ابْنِ
u'تَحْقِيقٌ أَذَانٌ':Added, #1: 1	تَحْقِيقِ أَحْكَامِ
u'تَحْقِيقٌ اِسْمٌ':Added, #1: 1	تَحْقِيقِ الْأَذَانِ
u'تَحْقِيقٌ اِسْمٌ':Added, #1: 1	تَحْقِيقُ اسْمِ
u'تَحْقِيقٌ أَمْرٌ':Added, #3: 3	تَحْقِيقِ اسْمِ
u'تَحْقِيقٌ أَمْرٌ':Added, #1: 1	تَحْقِيقِ الْأَمْرِ
u'تَحْقِيقٌ إِمْكانٌ':Added, #2: 2	تَحْقِيقُ الْأَمْرِ
u'تَحْقِيقٌ إِنْكارٌ':Added, #1: 1	تَحْقِيقِ الْإِمْكَانِ
u'تَحْقِيقٌ بَاطِلٌ':Added, #1: 1	تَحْقِيقِ إنْكَارِهِ
u'تَحْقِيقٌ بَحْثٌ':Added, #1: 1	تَحْقِيقَ بَاطِلٍ
u'تَحْقِيقٌ بِرٌّ':Added, #1: 1	تَحْقِيقِ الْبَحْثِ
u'تَحْقِيقٌ بِرٌّ':Added, #1: 1	تَحْقِيقُ الْبِرِّ
u'تَحْقِيقٌ بَيْعٌ':Added, #1: 1	تَحْقِيقِ الْبِرِّ
u'تَحْقِيقٌ بَيْعٌ':Added, #1: 1	تَحْقِيقِ الْبَيْعَيْنِ
u'تَحْقِيقٌ بَيْعٌ':Added, #1: 1	تَحْقِيقِ بَيْعِ
u'تَحْقِيقٌ تَسْوِيَةٌ':Added, #2: 2	تَحْقِيقَ الْبَيْعِ
u'تَحْقِيقٌ تَعْلِيقٌ':Added, #3: 3	تَحْقِيقُ التَّسْوِيَةِ
u'تَحْقِيقٌ تَمْلِيك':Added, #1: 1	تَحْقِيقِ تَعْلِيقِ
u'تَحْقِيقٌ تَنَاقُضٌ':Added, #1: 1	تَحْقِيقُ التَّمْلِيكِ
u'تَحْقِيقٌ تُهْمَةٌ':Added, #1: 1	تَحْقِيقِ التَّنَاقُضِ
u'تَحْقِيقٌ تَوْحِيدٌ':Added, #1: 1	تَحْقِيقِ التُّهْمَةِ
u'تَحْقِيقٌ تَوْحِيدٌ':Added, #1: 1	تَحْقِيقُ التَّوْحِيدِ
u'تَحْقِيقٌ جَهالَة':Added, #1: 1	تَحْقِيقِ التَّوْحِيدِ
u'تَحْقِيقٌ جَوَابٌ':Added, #1: 1	تَحْقِيقَ الْجَهَالَةِ
u'تَحْقِيقٌ حُرْمَةٌ':Added, #1: 1	تَحْقِيقِ جَوَابِ
u'تَحْقِيقٌ حِلٌّ':Added, #1: 1	تَحْقِيقُ الْحُرْمَةِ
u'تَحْقِيقٌ حَيَاةٌ':Added, #1: 1	تَحْقِيقُ الْحِلِّ
u'تَحْقِيقٌ خَبَرٌ':Added, #1: 1	تَحْقِيقُ حَيَاةِ
u'تَحْقِيقٌ خَبَرٌ':Added, #2: 2	تَحْقِيقَ خَبَرٍ
u'تَحْقِيقٌ خَبَرٌ':Added, #2: 2	تَحْقِيقُ خَبَرٍ
u'تَحْقِيقٌ خَبَر':Added, #2: 2	تَحْقِيقِ خَبَرٍ
u'تَحْقِيقٌ خَبَر':Added, #2: 2	تَحْقِيقَ خَبَرٍ
u'تَحْقِيقٌ خَبَر':Added, #2: 2	تَحْقِيقُ خَبَرٍ
u'تَحْقِيقٌ خِلاَفٌ':Added, #2: 2	تَحْقِيقِ خَبَرٍ
u'تَحْقِيقٌ خِلاَفٌ':Added, #1: 1	تَحْقِيقُ الْخِلَافِ
u'تَحْقِيقٌ دَليلٌ':Added, #1: 1	تَحْقِيقِ خِلَافِ
u'تَحْقِيقٌ رُخْصَةٌ':Added, #1: 1	تَحْقِيقِ دَلِيلِ
u'تَحْقِيقٌ رَدٌّ':Added, #2: 2	تَحْقِيقِ الرُّخْصَةِ
u'تَحْقِيقٌ رَوْضٌ':Added, #1: 1	تَحْقِيقُ رَدِّ
u'تَحْقِيقٌ زائِدٌ':Added, #1: 1	تَحْقِيقُ الرّوْضِ
u'تَحْقِيقٌ سَبَبٌ':Added, #1: 1	تَحْقِيقِ الزَّائِدِ
u'تَحْقِيقٌ سَبَبٌ':Added, #1: 1	تَحْقِيقُ السَّبَبِ
u'تَحْقِيقٌ سَبْقٌ':Added, #1: 1	تَحْقِيقِ السَّبَبِ
u'تَحْقِيقٌ سَفَرٌ':Added, #1: 1	تَحْقِيقِ السَّبْقِ
u'تَحْقِيقٌ سُؤَالٌ':Added, #1: 1	تَحْقِيقِ السَّفَرِ
u'تَحْقِيقٌ سُؤْدُدٌ':Added, #1: 1	تَحْقِيقَ السُّؤَالِ
u'تَحْقِيقٌ شَرْطٌ':Added, #1: 1	تَحْقِيقَ السُّؤْدُدِ
u'تَحْقِيقٌ شَرْطٌ':Added, #1: 1	تَحْقِيقُ الشَّرْطِ
u'تَحْقِيقٌ شَرْطٌ':Added, #1: 1	تَحْقِيقِ شَرْطِ
u'تَحْقِيقٌ شَيْءٌ':Added, #3: 3	تَحْقِيقِ الشَّرْطِ
u'تَحْقِيقٌ شَيْءٌ':Added, #1: 1	تَحْقِيقِ شَيْءٍ
u'تَحْقِيقٌ صَاحِبٌ':Added, #3: 3	تَحْقِيقِ الشَّيْءِ
u'تَحْقِيقٌ ضَرْبٌ':Added, #1: 1	تَحْقِيقَ صَاحِبِ
u'تَحْقِيقٌ طلب':Added, #1: 1	تَحْقِيقِ الضَّرْبِ
u'تَحْقِيقٌ طَلَبٌ':Added, #1: 1	تَحْقِيقِ طَلَبِ
u'تَحْقِيقٌ طُلُوعٌ':Added, #1: 1	تَحْقِيقِ طَلَبِ
u'تَحْقِيقٌ ظَنٌّ':Added, #1: 1	تَحْقِيقُ طُلُوعِ
u'تَحْقِيقٌ عَدْلٌ':Added, #1: 1	تَحْقِيقُ ظَنِّهِ
u'تَحْقِيقٌ عُقَلاَءُ':Added, #1: 1	تَحْقِيقِ الْعَدْلِ
u'تَحْقِيقٌ عِلَّةٌ':Added, #1: 1	تَحْقِيقِ الْعُقَلَاءِ
u'تَحْقِيقٌ عِلَّةٌ':Added, #1: 1	تَحْقِيقُ الْعِلَّةِ
u'تَحْقِيقٌ عِلَّةٌ':Added, #1: 1	تَحْقِيقِ الْعِلَّةِ
u'تَحْقِيقٌ عُلُومٌ':Added, #1: 1	تَحْقِيقِ عِلَّةِ
u'تَحْقِيقٌ عَمْدٌ':Added, #2: 2	تَحْقِيقِ الْعُلُومِ
u'تَحْقِيقٌ عَمَلٌ':Added, #1: 1	تَحْقِيقُ الْعَمْدِ
u'تَحْقِيقٌ عُمُومٌ':Added, #1: 1	تَحْقِيقِ عَمَلِ
u'تَحْقِيقٌ غَلَبَةٌ':Added, #1: 1	تَحْقِيقُ الْعُمُومِ
u'تَحْقِيقٌ فرق':Added, #1: 1	تَحْقِيقِ الْغَلَبَةِ
u'تَحْقِيقٌ فَرْقٌ':Added, #1: 1	تَحْقِيقُ الْفَرْقِ
u'تَحْقِيقٌ فَسْخٌ':Added, #1: 1	تَحْقِيقُ الْفَرْقِ
u'تَحْقِيقٌ فَصْلٌ':Added, #1: 1	تَحْقِيقُ الْفَسْخِ
u'تَحْقِيقٌ فِعْلٌ':Added, #1: 1	تَحْقِيقِ فَصْلِ
u'تَحْقِيقٌ فِعْلٌ':Added, #1: 1	تَحْقِيقِ الْفِعْلِ
u'تَحْقِيقٌ فقر':Added, #1: 1	تَحْقِيقِ فِعْلِ
u'تَحْقِيقٌ فَقْرٌ':Added, #1: 1	تَحْقِيقُ الْفَقْرِ
u'تَحْقِيقٌ فقهاء':Added, #1: 1	تَحْقِيقُ الْفَقْرِ
u'تَحْقِيقٌ قَبْضٌ':Added, #1: 1	تَحْقِيقِ الْفُقَهَاءِ
u'تَحْقِيقٌ قتل':Added, #1: 1	تَحْقِيقِ قَبْضِ
u'تَحْقِيقٌ قَتْلٌ':Added, #1: 1	تَحْقِيقِ الْقَتْلِ
u'تَحْقِيقٌ قسمة':Added, #1: 1	تَحْقِيقِ الْقَتْلِ
u'تَحْقِيقٌ قِسْمَةٌ':Added, #1: 1	تَحْقِيقُ الْقِسْمَةِ
u'تَحْقِيقٌ قصاص':Added, #1: 1	تَحْقِيقُ الْقِسْمَةِ
u'تَحْقِيقٌ قِصَاصٌ':Added, #1: 1	تَحْقِيقِ الْقِصَاصِ
u'تَحْقِيقٌ قول':Added, #1: 1	تَحْقِيقِ الْقِصَاصِ
u'تَحْقِيقٌ قَوْلٌ':Added, #1: 1	تَحْقِيقَ قَوْلِ
u'تَحْقِيقٌ قول':Added, #1: 1	تَحْقِيقَ قَوْلِ
u'تَحْقِيقٌ قَوْلٌ':Added, #3: 3	تَحْقِيقُ الْقَوْلِ
u'تَحْقِيقٌ قول':Added, #3: 3	تَحْقِيقُ الْقَوْلِ
u'تَحْقِيقٌ قَوْلٌ':Added, #5: 5	تَحْقِيقِ الْقَوْلِ
u'تَحْقِيقٌ قِيَاسٌ':Added, #5: 5	تَحْقِيقِ الْقَوْلِ
u'تَحْقِيقٌ كَفَالَةٌ':Added, #1: 1	تَحْقِيقُ الْقِيَاسِ
u'تَحْقِيقٌ كَفَالَةٌ':Added, #1: 1	تَحْقِيقَ الْكَفَالَةِ
u'تَحْقِيقٌ كفر':Added, #1: 1	تَحْقِيقُ الْكَفَالَةِ
u'تَحْقِيقٌ كُفْرٌ':Added, #1: 1	تَحْقِيقِ الْكُفْرِ
u'تَحْقِيقٌ كَلاَمٌ':Added, #1: 1	تَحْقِيقِ الْكُفْرِ
u'تَحْقِيقٌ كَلِمَةٌ':Added, #1: 1	تَحْقِيقَ كَلَامِهِ
u'تَحْقِيقٌ مُحَارَبَةٌ':Added, #1: 1	تَحْقِيقِ الْكَلِمَةِ
u'تَحْقِيقٌ مَحْذُوفٌ':Added, #1: 1	تَحْقِيقِ الْمُحَارَبَةِ
u'تَحْقِيقٌ مُدٌّ':Added, #1: 1	تَحْقِيقِ الْمَحْذُوفِ
u'تَحْقِيقٌ مَدْلُولٌ':Added, #1: 1	تَحْقِيقِ الْمُدِّ
u'تَحْقِيقٌ مَذَاهِبُ':Added, #1: 1	تَحْقِيقُ مَدْلُولَاتِ
u'تَحْقِيقٌ مَذْكُورٌ':Added, #1: 1	تَحْقِيقِ الْمَذَاهِبِ
u'تَحْقِيقٌ مَذْهَبٌ':Added, #2: 2	تَحْقِيقُ الْمَذْكُورِ
u'تَحْقِيقٌ مَذْهَبٌ':Added, #1: 1	تَحْقِيقُ الْمَذْهَبِ
u'تَحْقِيقٌ مَذْهَبٌ':Added, #1: 1	تَحْقِيقِ الْمَذْهَبِ
u'تَحْقِيقٌ مراد':Added, #2: 2	تَحْقِيقُ مَذْهَبِ
u'تَحْقِيقٌ مُرَادٌ':Added, #5: 5	تَحْقِيقِ الْمُرَادِ
u'تَحْقِيقٌ مَسْأَلَةٌ':Added, #5: 5	تَحْقِيقِ الْمُرَادِ
u'تَحْقِيقٌ مَسْأَلَةٌ':Added, #1: 1	تَحْقِيقِ الْمَسْأَلَةِ
u'تَحْقِيقٌ مُسَاوَاةٌ':Added, #1: 1	تَحْقِيقُ مَسْأَلَةِ
u'تَحْقِيقٌ مُسَاوَاةٌ':Added, #2: 2	تَحْقِيقِ الْمُسَاوَاةِ
u'تَحْقِيقٌ مَطَالِبُ':Added, #3: 3	تَحْقِيقُ الْمُسَاوَاةِ
u'تَحْقِيقٌ مَطْلُوبٌ':Added, #1: 1	تَحْقِيقِ مَطَالِبِهِ
u'تَحْقِيقٌ مَطْلُوبٌ':Added, #1: 1	تَحْقِيقَ الْمَطْلُوبِ
u'تَحْقِيقٌ مَطْلُوبٌ':Added, #1: 1	تَحْقِيقِ الْمَطْلُوبِ
u'تَحْقِيقٌ مَعْصِيَةٌ':Added, #1: 1	تَحْقِيقِ مَطْلُوبِهِ
u'تَحْقِيقٌ مُقَابَلٌ':Added, #1: 1	تَحْقِيقِ الْمَعْصِيَةِ
u'تَحْقِيقٌ مُقَابَلَةٌ':Added, #1: 1	تَحْقِيقُ مُقَابَلَةِ
u'تَحْقِيقٌ مُقَارَنٌ':Added, #1: 1	تَحْقِيقُ مُقَابَلَةِ
u'تَحْقِيقٌ مُقَارَنَةٌ':Added, #1: 1	تَحْقِيقِ الْمُقَارَنَةِ
u'تَحْقِيقٌ مَقَالَةٌ':Added, #1: 1	تَحْقِيقِ الْمُقَارَنَةِ
u'تَحْقِيقٌ مَقَامٌ':Added, #1: 1	تَحْقِيقِ مَقَالَةِ
u'تَحْقِيقٌ مَقَامٌ':Added, #1: 1	تَحْقِيقَ الْمَقَامِ
u'تَحْقِيقٌ مَقَامٌ':Added, #1: 1	تَحْقِيقُ الْمَقَامِ
u'تَحْقِيقٌ مَقْصُودٌ':Added, #2: 2	تَحْقِيقِ الْمَقَامِ
u'تَحْقِيقٌ مَقْصُودٌ':Added, #1: 1	تَحْقِيقُ مَقْصُودِهِ
u'تَحْقِيقٌ مَقْصُودٌ':Added, #2: 2	تَحْقِيقِ الْمَقْصُودِ
u'تَحْقِيقٌ مِلْكٌ':Added, #2: 2	تَحْقِيقِ مَقْصُودِ
u'تَحْقِيقٌ مُمَاثَلَةٌ':Added, #1: 1	تَحْقِيقِ مِلْكِهِ
u'تَحْقِيقٌ مَنٌّ':Added, #1: 1	تَحْقِيقِ الْمُمَاثَلَةِ
u'تَحْقِيقٌ مَنَاطٌ':Added, #1: 1	تَحْقِيقِ الْمَنِّ
u'تَحْقِيقٌ مَنَاطٌ':Added, #1: 1	تَحْقِيقُ مَنَاطٍ
u'تَحْقِيقٌ مَنَاطٌ':Added, #1: 1	تَحْقِيقُ مَنَاطِ
u'تَحْقِيقٌ مَنَاطٌ':Added, #1: 1	تَحْقِيقِ مَنَاطٍ
u'تَحْقِيقٌ مَنَاطٌ':Added, #1: 1	تَحْقِيقُ مَنَاطِهِ
u'تَحْقِيقٌ مَنَاطٌ':Added, #1: 1	تَحْقِيقِ مَنَاطِهِ
u'تَحْقِيقٌ مَنَاطٌ':Added, #2: 2	تَحْقِيقَ الْمَنَاطِ
u'تَحْقِيقٌ مَنَاطٌ':Added, #3: 3	تَحْقِيقِ الْمَنَاطِ
u'تَحْقِيقٌ مُنَاظَرَةٌ':Added, #7: 7	تَحْقِيقُ الْمَنَاطِ
u'تَحْقِيقٌ مُوالاة':Added, #1: 1	تَحْقِيقِ الْمُنَاظَرَاتِ
u'تَحْقِيقٌ مَوْرِدٌ':Added, #1: 1	تَحْقِيقِ الْمُوَالَاةِ
u'تَحْقِيقٌ نِسْبَةٌ':Added, #1: 1	تَحْقِيقُ مَوْرِدِ
u'تَحْقِيقٌ نَظَرٌ':Added, #1: 1	تَحْقِيقُ نِسْبَتِهِ
u'تَحْقِيقٌ نَظَرٌ':Added, #2: 2	تَحْقِيقُ النَّظَرِ
u'تَحْقِيقٌ نَعِيمٌ':Added, #4: 4	تَحْقِيقِ النَّظَرِ
u'تَحْقِيقٌ نَفْيٌ':Added, #1: 1	تَحْقِيقُ النَّعِيمِ
u'تَحْقِيقٌ نَفْيٌ':Added, #1: 1	تَحْقِيقَ النَّفْيِ
u'تَحْقِيقٌ نَفْيٌ':Added, #1: 1	تَحْقِيقُ النَّفْيِ
u'تَحْقِيقٌ نقل':Added, #1: 1	تَحْقِيقُ نَفْيِ
u'تَحْقِيقٌ نَقْلٌ':Added, #1: 1	تَحْقِيقُ النَّقْلِ
u'تَحْقِيقٌ نَوَوِيٌّ':Added, #1: 1	تَحْقِيقُ النَّقْلِ
u'تَحْقِيقٌ وَاقِعٌ':Added, #1: 1	تَحْقِيقِ النَّوَوِيِّ
u'تَحْقِيقٌ وُجُوبٌ':Added, #1: 1	تَحْقِيقُ الْوَاقِعِ
u'تَحْقِيقٌ وُجُودٌ':Added, #1: 1	تَحْقِيقِ الْوُجُوبِ
u'تَحْقِيقٌ وَصْفٌ':Added, #1: 1	تَحْقِيقِ وُجُودِهِ
u'تَحْقِيقٌ وَعْدٌ':Added, #6: 6	تَحْقِيقِ الْوَصْفِ
u'تَحْقِيقٌ وَعْدٌ':Added, #1: 1	تَحْقِيقَ الْوَعْدِ
u'تَحْقِيقٌ وَعْدٌ':Added, #1: 1	تَحْقِيقُ وَعْدِ
u'تَحْقِيقٌ وَعِيدٌ':Added, #5: 5	تَحْقِيقُ الْوَعْدِ
u'تَحْقِيقٌ وَفَاءٌ':Added, #1: 1	تَحْقِيقُ الْوَعِيدِ
u'تَحْقِيقٌ وفاة':Added, #1: 1	تَحْقِيقَ الْوَفَاءِ
u'تَحْقِيقٌ وَفَاةٌ':Added, #1: 1	تَحْقِيقُ وَفَاةِ
u'تَحْقِيقٌ وُقُوعٌ':Added, #1: 1	تَحْقِيقُ وَفَاةِ
u'تَحْقِيقٌ وِلاَيَةٌ':Added, #1: 1	تَحْقِيقِ وُقُوعِهِ
u'تَحْقِيقٌ يَمِينٌ':Added, #1: 1	تَحْقِيقَ الْوِلَايَةِ
u'تَحَكَّمَ اِبْنٌ':Subject, #1: 1	تَحْقِيقَ الْيَمِينِ
u'تَحَكُّمٌ صَانِعٌ':Added, #1: 1	تَحَكَّمَ ابْنُ
u'تَحَكُّمٌ مُتَسَلِّطٌ':Added, #1: 1	تَحَكُّمَ الصَّانِعِ
u'تَحْكِيمٌ ثَمَنٌ':Added, #1: 1	تَحَكُّمَ الْمُتَسَلِّطِ
u'تَحْكِيمٌ ثَمَنٌ':Added, #1: 1	تَحْكِيمَ الثَّمَنِ
u'تَحْكِيمٌ جَديدٌ':Added, #1: 1	تَحْكِيمِ الثَّمَنِ
u'تَحْكِيمٌ حالٌ':Added, #1: 1	تَحْكِيمٍ جَدِيدٍ
u'تَحْكِيمٌ حالٌ':Added, #2: 2	تَحْكِيمَ الْحَالِ
u'تَحْكِيمٌ حالٌ':Added, #2: 2	تَحْكِيمِ الْحَالِ
u'تَحْكِيمٌ خَصْمٌ':Added, #4: 4	تَحْكِيمُ الْحَالِ
u'تَحْكِيمٌ خوارج':Added, #1: 1	تَحْكِيمِ الْخَصْمِ
u'تَحْكِيمٌ خَوَارِجُ':Added, #1: 1	تَحْكِيمِ الْخَوَارِجِ
u'تَحْكِيمٌ ذِمِّيٌّ':Added, #1: 1	تَحْكِيمِ الْخَوَارِجِ
u'تَحْكِيمٌ رَأْيٌ':Added, #1: 1	تَحْكِيمِ الذِّمِّيِّ
u'تَحْكِيمٌ رِجَالٌ':Added, #2: 2	تَحْكِيمِ الرَّأْيِ
u'تَحْكِيمٌ رِجَالٌ':Added, #1: 1	تَحْكِيمَ الرِّجَالِ
u'تَحْكِيمٌ رَجُلٌ':Added, #1: 1	تَحْكِيمُ الرِّجَالِ
u'تَحْكِيمٌ سَعْدٌ':Added, #1: 1	تَحْكِيمِ الرَّجُلِ
u'تَحْكِيمٌ شَرِيعَةٌ':Added, #1: 1	تَحْكِيمُ سَعْدٍ
u'تَحْكِيمٌ صَبِيٌّ':Added, #1: 1	تَحْكِيمِ الشَّرِيعَةِ
u'تَحْكِيمٌ عَدْلٌ':Added, #1: 1	تَحْكِيمُ الصَّبِيِّ
u'تَحْكِيمٌ عرف':Added, #2: 2	تَحْكِيمُ الْعَدْلِ
u'تَحْكِيمٌ عُرْفٌ':Added, #1: 1	تَحْكِيمُ الْعُرْفِ
u'تَحْكِيمٌ عَقْلٌ':Added, #1: 1	تَحْكِيمُ الْعُرْفِ
u'تَحْكِيمٌ عَقْلٌ':Added, #1: 1	تَحْكِيمَ الْعَقْلِ
u'تَحْكِيمٌ عُقُولٌ':Added, #1: 1	تَحْكِيمُ الْعَقْلِ
u'تَحْكِيمٌ عُقُولٌ':Added, #1: 1	تَحْكِيمُ الْعُقُولِ
u'تَحْكِيمٌ عُقُولٌ':Added, #1: 1	تَحْكِيمِ الْعُقُولِ
u'تَحْكِيمٌ عَلِيٌّ':Added, #1: 1	تَحْكِيمُ عُقُولِ
u'تَحْكِيمٌ عَلِيٌّ':Added, #1: 1	تَحْكِيمُ عَلِيٍّ
u'تَحْكِيمٌ غير':Added, #1: 1	تَحْكِيمِ عَلِيٍّ
u'تَحْكِيمٌ غير':Added, #1: 1	تَحْكِيمُ الْغَيْرِ
u'تَحْكِيمٌ غَيْرٌ':Added, #1: 1	تَحْكِيمِ الْغَيْرِ
u'تَحْكِيمٌ غَيْرٌ':Added, #1: 1	تَحْكِيمُ الْغَيْرِ
u'تَحْكِيمٌ قِيمَةٌ':Added, #1: 1	تَحْكِيمِ الْغَيْرِ
u'تَحْكِيمٌ كَافِرٌ':Added, #1: 1	تَحْكِيمِ قِيمَةِ
u'تَحْكِيمٌ كَافِرٌ':Added, #1: 1	تَحْكِيمُ كَافِرٍ
u'تَحْكِيمٌ مُتْعَةٌ':Added, #5: 5	تَحْكِيمُ الْكَافِرِ
u'تَحْكِيمٌ مُتْعَةٌ':Added, #1: 1	تَحْكِيمُ الْمُتْعَةِ
u'تَحْكِيمٌ مُجْتَهِد':Added, #3: 3	تَحْكِيمِ الْمُتْعَةِ
u'تَحْكِيمٌ مُجْتَهِد':Added, #1: 1	تَحْكِيمُ الْمُجْتَهِدِ
u'تَحْكِيمٌ مُحَكَّمٌ':Added, #1: 1	تَحْكِيمِ الْمُجْتَهِدِ
u'تَحْكِيمٌ مَهْرٌ':Added, #1: 1	تَحْكِيمُ الْمُحَكَّمِ
u'تَحْكِيمٌ مَهْرٌ':Added, #1: 1	تَحْكِيمَ الْمَهْرِ
u'تَحْكِيمٌ مَهْرٌ':Added, #3: 3	تَحْكِيمَ مَهْرِ
u'تَحْكِيمٌ مُوَكِّلٌ':Added, #3: 3	تَحْكِيمِ مَهْرِ
u'تَحْكِيمٌ نَقْدٌ':Added, #1: 1	تَحْكِيمُ الْمُوَكِّلَيْنِ
u'تَحْكِيمٌ نَقْد':Added, #1: 1	تَحْكِيمَ النَّقْدِ
u'تَحَلَّقَ نَاسٌ':Subject, #1: 1	تَحْكِيمَ النَّقْدِ
u'تَحَلُّلٌ أبْخِرَةٌ':Added, #2: 2	تَحَلَّقَ النَّاسُ
u'تَحَلَّلَ إشارَة':Subject, #1: 1	تَحَلُّلَ الْأَبْخِرَةِ
u'تَحَلَّلَ أَصْحَابٌ':Subject, #1: 1	تَحَلَّلَ إشَارَةٌ
u'تَحَلُّلٌ إمَامٌ':Added, #1: 1	تَحَلَّلَ أَصْحَابُهُ
u'تَحَلَّلَ أَوَّلُ':Predicate, #1: 1	تَحَلُّلِ الْإِمَامِ
u'تَحَلُّلٌ بَائِعٌ':Added, #1: 1	تَحَلَّلَ الْأَوَّلَ
u'تَحَلَّلَ تَحَلُّلٌ':Predicate, #1: 1	تَحَلُّلِ الْبَائِعِ
u'تَحَلُّلٌ حاجٌّ':Added, #1: 1	تَحَلَّلَ التَّحَلُّلَ
u'تَحَلُّلٌ حارٌّ':Added, #1: 1	تَحَلُّلَ الْحَاجِّ
u'تَحَلُّلٌ شَيْءٌ':Added, #1: 1	تَحَلُّلِ الْحَارِّ
u'تَحَلَّلَ صَبِيٌّ':Subject, #1: 1	تَحَلُّلُ شَيْءٍ
u'تَحَلَّلَ صَنِيعٌ':Subject, #1: 1	تَحَلَّلَ الصَّبِيُّ
u'تَحَلَّلَ طَلاَقٌ':Subject, #1: 1	تَحَلَّلَ صَنِيعُهُ
u'تَحَلُّلٌ عَبْدٌ':Added, #1: 1	تَحَلَّلَ طَلَاقٌ
u'تَحَلَّلَ عمرة':Predicate, #1: 1	تَحَلُّلِ الْعَبْدِ
u'تَحَلَّلَ عُمْرَةٌ':Predicate, #1: 1	تَحَلَّلَ الْعُمْرَةَ
u'تَحَلَّلَ مَأْمُورٌ':Subject, #1: 1	تَحَلَّلَ الْعُمْرَةَ
u'تَحَلُّلٌ مُحْرِمٌ':Added, #1: 1	تَحَلَّلَ الْمَأْمُورُ
u'تَحَلُّلٌ مَدِينٌ':Added, #2: 2	تَحَلُّلِ الْمُحْرِمِ
u'تَحَلُّلٌ نَبِيٌّ':Added, #1: 1	تَحَلُّلِ الْمَدِينِ
u'تَحَلَّلَ وصل':Predicate, #1: 1	تَحَلُّلِ النَّبِيِّ
u'تَحْلِيَةٌ إجَازَةٌ':Added, #1: 1	تَحَلَّلَ وَصَلَ
u'تَحْلِيَةٌ آلةٌ':Added, #1: 1	تَحْلِيَةُ الْإِجَازَةِ
u'تَحْلِيَةٌ الْمَرْأَةُ':Added, #4: 4	تَحْلِيَةُ آلَةِ
u'تَحْلِيَةٌ دواة':Added, #3: 3	تَحْلِيَةِ الْمَرْأَةِ
u'تَحْلِيَةٌ دَواةٌ':Added, #1: 1	تَحْلِيَةُ دَوَاةٍ
u'تَحْلِيَةٌ دواة':Added, #1: 1	تَحْلِيَةُ دَوَاةٍ
u'تَحْلِيَةٌ دَواةٌ':Added, #2: 2	تَحْلِيَةُ الدَّوَاةِ
u'تَحْلِيَةٌ سَرْجٌ':Added, #2: 2	تَحْلِيَةُ الدَّوَاةِ
u'تَحْلِيَةٌ سَرْجٌ':Added, #1: 1	تَحْلِيَةِ السَّرْجِ
u'تَحْلِيَةٌ سِكِّينٌ':Added, #1: 1	تَحْلِيَةِ سَرْجٍ
u'تَحْلِيَةٌ سِكِّينٌ':Added, #1: 1	تَحْلِيَةُ سِكِّينِ
u'تَحْلِيَةٌ سُيوفٌ':Added, #2: 2	تَحْلِيَةُ السِّكِّينِ
u'تَحْلِيَةٌ شُهُودٌ':Added, #1: 1	تَحْلِيَةَ السُّيُوفِ
u'تَحْلِيَةٌ صَبِيٌّ':Added, #1: 1	تَحْلِيَةَ الشُّهُودِ
u'تَحْلِيَةٌ فِرَاشٌ':Added, #1: 1	تَحْلِيَةِ الصَّبِيِّ
u'تَحْلِيَةٌ قَبِيعَةٌ':Added, #1: 1	تَحْلِيَةُ فِرَاشِهِ
u'تَحْلِيَةٌ قَنَادِيلُ':Added, #1: 1	تَحْلِيَةِ قَبِيعَةِ
u'تَحْلِيَةٌ مَرَاكِبُ':Added, #1: 1	تَحْلِيَةِ الْقَنَادِيلِ
u'تَحْلِيَةٌ مَسْجِدٌ':Added, #1: 1	تَحْلِيَةُ الْمَرَاكِبِ
u'تَحْلِيَةٌ مَسْجِدٌ':Added, #1: 1	تَحْلِيَةُ الْمَسْجِدِ
u'تَحْلِيَةٌ مُصْحَفٌ':Added, #2: 2	تَحْلِيَةُ مَسْجِدٍ
u'تَحْلِيَةٌ مُصْحَفٌ':Added, #1: 1	تَحْلِيَةُ الْمُصْحَفِ
u'تَحَلِّي ذكر':Added, #3: 3	تَحْلِيَةِ الْمُصْحَفِ
u'تَحَلِّي ذَكَرٌ':Added, #1: 1	تَحَلِّي الذَّكَرِ
u'تَحَلَّى رَجُلٌ':Subject, #1: 1	تَحَلِّي الذَّكَرِ
u'تَحْلِيلٌ الْمَرْأَةُ':Added, #2: 2	تَحَلَّى الرَّجُلُ
u'تَحْلِيلٌ الْمَرْأَةُ':Added, #2: 2	تَحْلِيلُ الْمَرْأَةِ
u'تَحْلِيلٌ أمَةٌ':Added, #2: 2	تَحْلِيلِ الْمَرْأَةِ
u'تَحْلِيلٌ أَنْبِذَةٌ':Added, #1: 1	تَحْلِيلِ الْأَمَةِ
u'تَحْلِيلٌ حَجٌّ':Added, #1: 1	تَحْلِيلِ الْأَنْبِذَةِ
u'تَحْلِيلٌ حُجَجٌ':Added, #1: 1	تَحْلِيلِ الْحَجِّ
u'تَحْلِيلٌ حَرامٌ':Added, #1: 1	تَحْلِيلِ الْحُجَجِ
u'تَحْلِيلٌ حَرامٌ':Added, #2: 2	تَحْلِيلُ الْحَرَامِ
u'تَحْلِيلٌ حَرامٌ':Added, #2: 2	تَحْلِيلِ الْحَرَامِ
u'تَحْلِيلٌ حَرامٌ':Added, #2: 2	تَحْلِيلُ حَرَامٍ
u'تَحْلِيلٌ خَمْرٌ':Added, #2: 2	تَحْلِيلِ حَرَامٍ
u'تَحْلِيلٌ دِماءٌ':Added, #1: 1	تَحْلِيلَ الْخَمْرِ
u'تَحْلِيلٌ زَوْجَةٌ':Added, #1: 1	تَحْلِيلُ الدِّمَاءِ
u'تَحْلِيلٌ شَحْمٌ':Added, #1: 1	تَحْلِيلَ الزَّوْجَةِ
u'تَحْلِيلٌ شَرْعٌ':Added, #1: 1	تَحْلِيلِ شَحْمِ
u'تَحْلِيلٌ شِرْعٌ':Added, #1: 1	تَحْلِيلِ الشّرْعِ
u'تَحْلِيلٌ شَيْءٌ':Added, #1: 1	تَحْلِيلِ الشّرْعِ
u'تَحْلِيلٌ صَغِيرٌ':Added, #1: 1	تَحْلِيلَ الشَّيْءِ
u'تَحْلِيلٌ صَغِيرٌ':Added, #1: 1	تَحْلِيلِ الصَّغِيرِ
u'تَحْلِيلٌ صَلاَةٌ':Added, #1: 1	تَحْلِيلِ الصَّغِيرَةِ
u'تَحْلِيلٌ صَيْدٌ':Added, #1: 1	تَحْلِيلِ الصَّلاَةِ
u'تَحْلِيلٌ صَيْدٌ':Added, #1: 1	تَحْلِيلِ الصَّيْدِ
u'تَحْلِيلٌ صَيْدٌ':Added, #1: 1	تَحْلِيلَ صَيْدِ
u'تَحْلِيلٌ عَبْدٌ':Added, #1: 1	تَحْلِيلُ صَيْدِهِ
u'تَحْلِيلٌ عين':Added, #1: 1	تَحْلِيلُ الْعَبْدِ
u'تَحْلِيلٌ عَيْنٌ':Added, #1: 1	تَحْلِيلُ عَيْنِهِ
u'تَحْلِيلٌ عَيْن':Added, #1: 1	تَحْلِيلُ عَيْنِهِ
u'تَحْلِيلٌ غَنَائِمُ':Added, #1: 1	تَحْلِيلُ عَيْنِهِ
u'تَحْلِيلٌ فلان':Added, #1: 1	تَحْلِيلِ الْغَنَائِمِ
u'تَحْلِيلٌ قتال':Added, #1: 1	تَحْلِيلُ الْمَكِّيِّ
u'تَحْلِيلٌ قِتَالٌ':Added, #1: 1	تَحْلِيلِ الْقِتَالِ
u'تَحْلِيلٌ لُحُومٌ':Added, #1: 1	تَحْلِيلِ الْقِتَالِ
u'تَحْلِيلٌ مَالِكٌ':Added, #1: 1	تَحْلِيلَ لُحُومِ
u'تَحْلِيلٌ مُحَرَّمٌ':Added, #1: 1	تَحْلِيلِ الْمَالِكِ
u'تَحْلِيلٌ مُطَلَّقٌ':Added, #1: 1	تَحْلِيلَ الْمُحَرَّمِ
u'تَحْلِيلٌ مَكِّيّ':Added, #1: 1	تَحْلِيلَ الْمُطَلَّقَةِ
u'تَحْلِيلٌ وَطْءٌ':Added, #1: 1	تَحْلِيلُ الْمَكِّيِّ
u'تَحَلِّي نِساءٌ':Added, #1: 1	تَحْلِيلِ الْوَطْءِ
u'تَحَلِّي نِساءٌ':Added, #1: 1	تَحَلِّي النِّسَاءِ
u'تَحَمُّلٌ إِثْمٌ':Added, #1: 1	تَحَلِّيَ النِّسَاءِ
u'تَحَمُّلٌ أخْبَارٌ':Added, #1: 1	تَحَمُّلِ الْإِثْمِ
u'تَحَمُّلٌ أَخْبَارٌ':Added, #1: 1	تَحَمُّلُ الْأَخْبَارِ
u'تَحَمُّلٌ أصل':Added, #1: 1	تَحَمُّلُ الْأَخْبَارِ
u'تَحَمُّلٌ أًصْلٌ':Added, #2: 2	تَحَمُّلِ أَصْلِ
u'تَحَمُّلٌ ألَمٌ':Added, #2: 2	تَحَمُّلِ أَصْلِ
u'تَحَمُّلٌ ألَمٌ':Added, #1: 1	تَحَمُّلَ الْأَلَمِ
u'تَحَمُّلٌ الْمَرْأَةُ':Added, #2: 2	تَحَمُّلِ الْأَلَمِ
u'تَحَمُّلٌ إمَامٌ':Added, #1: 1	تَحَمُّلُ الْمَرْأَةِ
u'تَحَمُّلٌ إمَامٌ':Added, #1: 1	تَحَمُّلُ الْإِمَامِ
u'تَحَمُّلٌ بَدَلٌ':Added, #2: 2	تَحَمُّلِ الْإِمَامِ
u'تَحَمَّلَ بَعْضٌ':Predicate, #1: 1	تَحَمُّلَ بَدَلِ
u'تَحَمَّلَ بَعْضٌ':Subject, #1: 1	تَحَمَّلَ بَعْضَ
u'تَحَمُّلٌ ثَوابٌ':Added, #1: 1	تَحَمَّلَ بَعْضُ
u'تَحَمُّلٌ جَديدٌ':Added, #1: 1	تَحَمُّلُ الثَّوَابِ
u'تَحَمَّلَ جِنَايَةٌ':Predicate, #1: 1	تَحَمُّلٍ جَدِيدٍ
u'تَحَمُّلٌ جِنَايَةٌ':Added, #1: 1	تَحَمَّلَ الْجِنَايَةَ
u'تَحَمُّلٌ جَهالَة':Added, #1: 1	تَحَمُّلِ الْجِنَايَةِ
u'تَحَمُّلٌ حُقوقٌ':Added, #1: 1	تَحَمُّلِ الْجَهَالَةِ
u'تَحَمُّلٌ حُقُوقٌ':Added, #1: 1	تَحَمُّلُ حُقُوقِ
u'تَحَمُّلٌ دِيَةٌ':Added, #1: 1	تَحَمُّلُ حُقُوقِ
u'تَحَمُّلٌ دِيَةٌ':Added, #1: 1	تَحَمُّلَ الدِّيَةِ
u'تَحَمُّلٌ دِيَةٌ':Added, #1: 1	تَحَمُّلُ الدِّيَةِ
u'تَحَمُّلٌ دِيَةٌ':Added, #1: 1	تَحَمُّلِ دِيَةٍ
u'تَحَمُّلٌ دَيْنٌ':Added, #2: 2	تَحَمُّلِ الدِّيَةِ
u'تَحَمُّلٌ ذِمِّيٌّ':Added, #1: 1	تَحَمُّلِ الدَّيْنِ
u'تَحَمُّلٌ رَدٌّ':Added, #1: 1	تَحَمُّلِ الذِّمِّيِّ
u'تَحَمُّلٌ رِوايَةٌ':Added, #1: 1	تَحَمُّلِ الرَّدِّ
u'تَحَمُّلٌ رِوايَةٌ':Added, #1: 1	تَحَمُّلُ الرِّوَايَةِ
u'تَحَمَّلَ زَوْجٌ':Subject, #2: 2	تَحَمُّلِ الرِّوَايَةِ
u'تَحَمُّلٌ زَوْجٌ':Added, #1: 1	تَحَمَّلَ الزَّوْجُ
u'تَحَمُّلٌ زِيادَةٌ':Added, #1: 1	تَحَمُّلِ الزَّوْجِ
u'تَحَمُّلٌ سُوءٌ':Added, #1: 1	تَحَمُّلَ زِيَادَةِ
u'تَحَمَّلَ شَهَادَةٌ':Predicate, #1: 1	تَحَمُّلِ سُوءِ
u'تَحَمُّلٌ شَهَادَةٌ':Added, #5: 5	تَحَمَّلَ الشَّهَادَةَ
u'تَحَمُّلٌ شَهَادَةٌ':Added, #11: 11	تَحَمُّلُ الشَّهَادَةِ
u'تَحَمُّلٌ شَهَادَةٌ':Added, #1: 1	تَحَمُّلُ الشَّهَادَاتِ
u'تَحَمُّلٌ شَهَادَةٌ':Added, #1: 1	تَحَمُّلِ شَهَادَةٍ
u'تَحَمُّلٌ شَهَادَةٌ':Added, #1: 1	تَحَمُّلِ شَهَادَتِهِ
u'تَحَمُّلٌ شَهَادَةٌ':Added, #27: 27	تَحَمُّلِ الشَّهَادَةِ
u'تَحَمَّلَ شُهُودٌ':Subject, #6: 6	تَحَمُّلَ الشَّهَادَةِ
u'تَحَمَّلَ صِيَامٌ':Predicate, #1: 1	تَحَمَّلَ الشُّهُودُ
u'تَحَمَّلَ ضَرَرٌ':Predicate, #2: 2	تَحَمَّلَ الصِّيَامَ
u'تَحَمُّلٌ ضَرَرٌ':Added, #1: 1	تَحَمَّلَ الضَّرَرَ
u'تَحَمُّلٌ ضَرَرٌ':Added, #1: 1	تَحَمُّلُ الضَّرَرِ
u'تَحَمُّلٌ ضَرُورَةٌ':Added, #4: 4	تَحَمُّلِ الضَّرَرِ
u'تَحَمَّلَ ضَمِيرٌ':Predicate, #1: 1	تَحَمُّلَ الضَّرُورَةِ
u'تَحَمُّلٌ ظُلْمٌ':Added, #1: 1	تَحَمَّلَ الضَّمِيرَ
u'تَحَمُّلٌ عَاقِلٌ':Added, #1: 1	تَحَمُّلُ الظُّلْمِ
u'تَحَمُّلٌ عَاقِلٌ':Added, #1: 1	تَحَمُّلَ الْعَاقِلَةِ
u'تَحَمُّلٌ عَبْدٌ':Added, #6: 6	تَحَمُّلِ الْعَاقِلَةِ
u'تَحَمُّلٌ عَقْلٌ':Added, #1: 1	تَحَمُّلِ الْعَبْدِ
u'تَحَمُّلٌ عَقْلٌ':Added, #1: 1	تَحَمُّلِ عَقْلٍ
u'تَحَمُّلٌ عَقْلٌ':Added, #2: 2	تَحَمُّلُ الْعَقْلِ
u'تَحَمُّلٌ عَهْدٌ':Added, #3: 3	تَحَمُّلِ الْعَقْلِ
u'تَحَمُّلٌ غَبَنٌ':Added, #1: 1	تَحَمُّلُ عَهْدِ
u'تَحَمُّلٌ غَبْنٌ':Added, #1: 1	تَحَمُّلُ الْغَبَنِ
u'تَحَمَّلَ غير':Predicate, #1: 1	تَحَمُّلُ الْغَبْنِ
u'تَحَمَّلَ غَيْرٌ':Predicate, #1: 1	تَحَمَّلَ غَيْرَ
u'تَحَمُّلٌ فَاتِحٌ':Added, #1: 1	تَحَمَّلَ غَيْرَ
u'تَحَمُّلٌ فَاتِحَةٌ':Added, #1: 1	تَحَمُّلَ الْفَاتِحَةِ
u'تَحَمُّلٌ فَرْعٌ':Added, #1: 1	تَحَمُّلَ الْفَاتِحَةِ
u'تَحَمُّلٌ فطرة':Added, #1: 1	تَحَمُّلُ الْفَرْعِ
u'تَحَمُّلٌ فِطْرَةٌ':Added, #3: 3	تَحَمُّلِ الْفِطْرَةِ
u'تَحَمُّلٌ قِرَاءةٌ':Added, #3: 3	تَحَمُّلِ الْفِطْرَةِ
u'تَحَمُّلٌ مَتَاعِبُ':Added, #1: 1	تَحَمُّلِ الْقِرَاءَةِ
u'تَحَمُّلٌ مَحْذُور':Added, #1: 1	تَحَمُّلِ الْمَتَاعِبِ
u'تَحَمَّلَ مَرِيضٌ':Subject, #3: 3	تَحَمُّلِ الْمَحْذُورِ
u'تَحَمُّلٌ مُشْتَقٌّ':Added, #1: 1	تَحَمَّلَ الْمَرِيضُ
u'تَحَمَّلَ مَشَقَّةٌ':Predicate, #1: 1	تَحَمُّلَ الْمُشْتَقِّ
u'تَحَمُّلٌ مَشَقَّةٌ':Added, #5: 5	تَحَمَّلَ الْمَشَقَّةَ
u'تَحَمُّلٌ مَشَقَّةٌ':Added, #1: 1	تَحَمُّلَ مَشَقَّةٍ
u'تَحَمُّلٌ مَشَقَّةٌ':Added, #1: 1	تَحَمُّلُ مَشَقَّةِ
u'تَحَمُّلٌ مَشَقَّةٌ':Added, #1: 1	تَحَمُّلِ مَشَقَّةٍ
u'تَحَمُّلٌ مَشَقَّةٌ':Added, #1: 1	تَحَمُّلِ مَشَقَّةِ
u'تَحَمُّلٌ مَفْسَدَةٌ':Added, #3: 3	تَحَمُّلِ الْمَشَقَّةِ
u'تَحَمُّلٌ مَفْسَدَةٌ':Added, #1: 1	تَحَمُّلَ مَفْسَدَةِ
u'تَحَمُّلٌ مِنَنٌ':Added, #1: 1	تَحَمُّلِ مَفْسَدَةِ
u'تَحَمُّلٌ مِنَنٌ':Added, #1: 1	تَحَمُّلُ الْمِنَنِ
u'تَحَمُّلٌ نَاقِصٌ':Added, #2: 2	تَحَمُّلِ الْمِنَنِ
u'تَحَمُّلٌ وَصْفٌ':Added, #1: 1	تَحَمُّلُ نَاقِصٍ
u'تَحَمُّلٌ وَلِيٌّ':Added, #1: 1	تَحَمُّلِ وَصْفِهِ
u'تَحَمُّلٌ وَلِيٌّ':Added, #1: 1	تَحَمُّلُ الْوَلِيِّ
u'تَحْمِيدٌ إمَامٌ':Added, #1: 1	تَحَمُّلِ الْوَلِيِّ
u'تَحْمِيلٌ أصل':Added, #1: 1	تَحْمِيدُ الْإِمَامِ
u'تَحْمِيلٌ أصل':Added, #1: 1	تَحْمِيلَ الْأَصْلِ
u'تَحْمِيلٌ أًصْلٌ':Added, #1: 1	تَحْمِيلِ الْأَصْلِ
u'تَحْمِيلٌ أًصْلٌ':Added, #1: 1	تَحْمِيلَ الْأَصْلِ
u'تَحْمِيلٌ بَعْضٌ':Added, #1: 1	تَحْمِيلِ الْأَصْلِ
u'تَحْمِيلٌ بَقَرٌ':Added, #1: 1	تَحْمِيلِ بَعْضِ
u'تَحْمِيلٌ قَاتِلٌ':Added, #1: 1	تَحْمِيلِ الْبَقَرِ
u'تَحْمِيلٌ نَسَبٌ':Added, #1: 1	تَحْمِيلِ الْقَاتِلِ
u'تَحْمِيلٌ نَسَبٌ':Added, #1: 1	تَحْمِيلِ النَّسَبِ
u'تَحْمِيلٌ نَسَبٌ':Added, #5: 5	تَحْمِيلُ النَّسَبِ
u'تَحَوُّلٌ إمَامَةٌ':Added, #7: 7	تَحْمِيلَ النَّسَبِ
u'تَحَوَّلَ بَدَلٌ':Subject, #1: 1	تَحَوُّلِ الْإِمَامَةِ
u'تَحَوَّلَ ثَلاثَةٌ':Subject, #1: 1	تَحَوَّلَ بَدَلُ
u'تَحَوَّلَ جَمَلٌ':Subject, #1: 1	تَحَوَّلَ ثَلَاثَةٌ
u'تَحَوُّلٌ حَجَرٌ':Added, #1: 1	تَحَوَّلَ الْجَمَلُ
u'تَحَوَّلَ حَقٌّ':Subject, #2: 2	تَحَوُّلُ الْحَجَرِ
u'تَحَوُّلٌ حَقٌّ':Added, #2: 2	تَحَوَّلَ الْحَقُّ
u'تَحَوَّلَ خراج':Subject, #1: 1	تَحَوُّلَ الْحَقِّ
u'تَحَوَّلَ خَرَاجٌ':Subject, #1: 1	تَحَوَّلَ الْخَرَاجُ
u'تَحَوَّلَ خَمْرٌ':Subject, #1: 1	تَحَوَّلَ الْخَرَاجُ
u'تَحَوُّلٌ دَيْنٌ':Added, #1: 1	تَحَوَّلَ الْخَمْرُ
u'تَحَوُّلٌ دَيْنٌ':Added, #1: 1	تَحَوُّلُ الدَّيْنِ
u'تَحَوَّلَ رَاكِبٌ':Subject, #4: 4	تَحَوُّلَ الدَّيْنِ
u'تَحَوَّلَ رَاكِبٌ':Subject, #1: 1	تَحَوَّلَ الرَّاكِبُ
u'تَحَوَّلَ رَأْيٌ':Subject, #1: 1	تَحَوَّلَ رَاكِبُهُ
u'تَحَوَّلَ رَأْيٌ':Subject, #14: 14	تَحَوَّلَ رَأْيُهُ
u'تَحَوَّلَ رَسُولٌ':Subject, #1: 1	تَحَوَّلَ رَأْيُ
u'تَحَوُّلٌ سَنَةٌ':Added, #2: 2	تَحَوَّلَ رَسُولُ
u'تَحَوُّلٌ صَفْقَةٌ':Added, #2: 2	تَحَوُّلِ السَّنَةِ
u'تَحَوَّلَ طِيبٌ':Subject, #1: 1	تَحَوُّلِ الصَّفْقَةِ
u'تَحَوُّلٌ عُشْرٌ':Added, #1: 1	تَحَوَّلَ الطِّيبُ
u'تَحَوَّلَ فَرْضٌ':Subject, #1: 1	تَحَوُّلَ الْعُشْرِ
u'تَحَوَّلَ فَرْضٌ':Subject, #1: 1	تَحَوَّلَ الْفَرْضُ
u'تَحَوَّلَ فُلاَنٌ':Subject, #1: 1	تَحَوَّلَ فَرْضُهُ
u'تَحَوُّلٌ قِبْلَةٌ':Added, #1: 1	تَحَوَّلَ فُلَانٌ
u'تَحَوُّلٌ نَجَاسَةٌ':Added, #1: 1	تَحَوُّلِ الْقِبْلَةِ
u'تَحَوَّلَ نِصْفٌ':Subject, #1: 1	تَحَوُّلِ نَجَاسَةٍ
u'تَحَوَّلَ نَصِيبٌ':Subject, #2: 2	تَحَوَّلَ نِصْفُ
u'تَحَوُّلٌ وَلاَءٌ':Added, #1: 1	تَحَوَّلَ نَصِيبُ
u'تَحَوُّلٌ وِلاَيَةٌ':Added, #1: 1	تَحَوُّلِ الْوَلَاءِ
u'تَحَوَّلَ يَوْمٌ':Predicate, #1: 1	تَحَوُّلِ الْوِلَايَةِ
u'تَحْوِيلٌ آبارٌ':Added, #1: 1	تَحَوَّلَ يَوْمَ
u'تَحْوِيلٌ أَشْيَاءٌ':Added, #1: 1	تَحْوِيلِ آبَارِ
u'تَحْوِيلٌ أَغْصَانٌ':Added, #1: 1	تَحْوِيلُ الْأَشْيَاءِ
u'تَحْوِيلٌ بَابٌ':Added, #2: 2	تَحْوِيلُ أَغْصَانِ
u'تَحْوِيلٌ بَابٌ':Added, #1: 1	تَحْوِيلُ بَابِ
u'تَحْوِيلٌ حَجَرٌ':Added, #1: 1	تَحْوِيلُ بَابِهِ
u'تَحْوِيلٌ حَقٌّ':Added, #1: 1	تَحْوِيلُ الْحَجَرِ
u'تَحْوِيلٌ حُكْمٌ':Added, #1: 1	تَحْوِيلِ الْحَقِّ
u'تَحْوِيلٌ دَيْنٌ':Added, #1: 1	تَحْوِيلُ حُكْمِ
u'تَحْوِيلٌ دَيْنٌ':Added, #2: 2	تَحْوِيلِ الدَّيْنِ
u'تَحْوِيلٌ دِيوانٌ':Added, #4: 4	تَحْوِيلُ الدَّيْنِ
u'تَحْوِيلٌ رِدَاءٌ':Added, #1: 1	تَحْوِيلِ الدِّيوَانِ
u'تَحْوِيلٌ رِدَاءٌ':Added, #1: 1	تَحْوِيلَ الرِّدَاءِ
u'تَحْوِيلٌ رِدَاءٌ':Added, #1: 1	تَحْوِيلُ الرِّدَاءِ
u'تَحْوِيلٌ صَدْرٌ':Added, #6: 6	تَحْوِيلِ الرِّدَاءِ
u'تَحْوِيلٌ صَدْرٌ':Added, #1: 1	تَحْوِيلُ الصَّدْرِ
u'تَحْوِيلٌ صَدْرٌ':Added, #1: 1	تَحْوِيلِ الصَّدْرِ
u'تَحْوِيلٌ صَكٌّ':Added, #1: 1	تَحْوِيلُ صَدْرِهِ
u'تَحْوِيلٌ صَكٌّ':Added, #1: 1	تَحْوِيلِ صَكِّ
u'تَحْوِيلٌ عَبْدٌ':Added, #2: 2	تَحْوِيلِ الصَّكِّ
u'تَحْوِيلٌ عَقْدٌ':Added, #1: 1	تَحْوِيلَ الْعَبْدِ
u'تَحْوِيلٌ قِبْلَةٌ':Added, #2: 2	تَحْوِيلِ الْعَقْدِ
u'تَحْوِيلٌ قِبْلَةٌ':Added, #2: 2	تَحْوِيلَ الْقِبْلَةِ
u'تَحْوِيلٌ مُطَالَبٌ':Added, #5: 5	تَحْوِيلِ الْقِبْلَةِ
u'تَحْوِيلٌ مُطَالَبَةٌ':Added, #1: 1	تَحْوِيلَ الْمُطَالَبَةِ
u'تَحْوِيلٌ مَنْفَذٌ':Added, #1: 1	تَحْوِيلَ الْمُطَالَبَةِ
u'تَحْوِيلٌ نَهْرٌ':Added, #1: 1	تَحْوِيلَ الْمَنْفَذِ
u'تَحْوِيلٌ وَجْهٌ':Added, #1: 1	تَحْوِيلَ النَّهْرِ
u'تَحْوِيلٌ وَجْهٌ':Added, #1: 1	تَحْوِيلَ الْوَجْهِ
u'تَحْوِيلٌ وَجْهٌ':Added, #1: 1	تَحْوِيلُ الْوَجْهِ
u'تَحْوِيلٌ وَجْهٌ':Added, #1: 1	تَحْوِيلَ وَجْهِهِ
u'تَحْوِيلٌ وَجْهٌ':Added, #2: 2	تَحْوِيلِ الْوَجْهِ
u'تَحْوِيلٌ يَدٌ':Added, #3: 3	تَحْوِيلُ وَجْهِهِ
u'تَحْوِيلٌ يَدٌ':Added, #1: 1	تَحْوِيلَ يَدِهِ
u'تَحْوِيلٌ يَمِينٌ':Added, #1: 1	تَحْوِيلُ يَدِهِ
u'تَحْوِيلٌ يَمِينٌ':Added, #1: 1	تَحْوِيلِ الْيَمِينِ
u'تَحِيَّةٌ إِسْلامٌ':Added, #1: 1	تَحْوِيلُ يَمِينٍ
u'تَحِيَّةٌ أموات':Added, #1: 1	تَحِيَّةِ الْإِسْلَامِ
u'تَحِيَّةٌ أهْلٌ':Added, #2: 2	تَحِيَّةِ الْأَمْوَاتِ
u'تَحِيَّةٌ بَيْتٌ':Added, #2: 2	تَحِيَّةُ أَهْلِ
u'تَحِيَّةٌ بَيْتٌ':Added, #2: 2	تَحِيَّةَ الْبَيْتِ
u'تَحِيَّةٌ جَاهِلِيٌّ':Added, #5: 5	تَحِيَّةُ الْبَيْتِ
u'تَحِيَّةٌ جَاهِلِيَّةٌ':Added, #1: 1	تَحِيَّةِ الْجَاهِلِيَّةِ
u'تَحِيَّةٌ حَرَمٌ':Added, #1: 1	تَحِيَّةِ الْجَاهِلِيَّةِ
u'تَحِيَّةٌ ذِمِّيٌّ':Added, #1: 1	تَحِيَّةُ الْحَرَمِ
u'تَحِيَّةٌ رَبُّ':Added, #1: 1	تَحِيَّةُ الذِّمِّيِّ
u'تَحِيَّةٌ رَبُّ':Added, #1: 1	تَحِيَّةُ رَبِّ
u'تَحِيَّةٌ رُؤْيَةٌ':Added, #1: 1	تَحِيَّةِ رَبِّ
u'تَحِيَّةٌ صَلاَةٌ':Added, #1: 1	تَحِيَّةُ الرُّؤْيَةِ
u'تَحِيَّةٌ غَائِبٌ':Added, #1: 1	تَحِيَّةُ صَلَاةِ
u'تَحِيَّةٌ كعبة':Added, #1: 1	تَحِيَّةَ الْغَائِبِ
u'تَحِيَّةٌ كَعْبَةٌ':Added, #1: 1	تَحِيَّةُ الْكَعْبَةِ
u'تَحِيَّةٌ مَجْلِسٌ':Added, #1: 1	تَحِيَّةُ الْكَعْبَةِ
u'تَحِيَّةٌ مَسْجِدٌ':Added, #1: 1	تَحِيَّةِ الْمَجْلِسِ
u'تَحِيَّةٌ مَسْجِدٌ':Added, #18: 18	تَحِيَّةُ الْمَسْجِدِ
u'تَحِيَّةٌ مَسْجِدٌ':Added, #1: 1	تَحِيَّةَ مَسْجِدِ
u'تَحِيَّةٌ مَسْجِدٌ':Added, #1: 1	تَحِيَّةُ مَسْجِدِ
u'تَحِيَّةٌ مَسْجِدٌ':Added, #1: 1	تَحِيَّةِ مَسْجِدٍ
u'تَحِيَّةٌ مَسْجِدٌ':Added, #23: 23	تَحِيَّةَ الْمَسْجِدِ
u'تَحِيَّةٌ مَلاَئِكَةٌ':Added, #32: 32	تَحِيَّةِ الْمَسْجِدِ
u'تَحَيَّرَ أَصْحَابٌ':Subject, #1: 1	تَحِيَّةَ الْمَلَائِكَةِ
u'تَحَيَّرَ مُجْتَهِد':Subject, #1: 1	تَحَيَّرَ الْأَصْحَابُ
u'تَحَيَّرَ مُجْتَهِد':Subject, #1: 1	تَحَيَّرَ الْمُجْتَهِدُ
u'تَحَيَّرَ وَتَرٌ':Predicate, #1: 1	تَحَيَّرَ مُجْتَهِدٌ
u'تَخَاصَمَ شُهُودٌ':Subject, #1: 1	تَحَيَّرَ وَتَرَكَ
u'تَخَالُفٌ طَرِيقٌ':Added, #2: 2	تَخَاصَمَ الشُّهُودُ
u'تَخَالُفٌ لَفْظٌ':Added, #1: 1	تَخَالُفِ الطَّرِيقَيْنِ
u'تَخَبُّطٌ جُنُونٌ':Added, #1: 1	تَخَالُفِ لَفْظِ
u'تَخَبُّطٌ نَفْسٌ':Added, #3: 3	تَخَبُّطِ جُنُونٍ
u'تَخْدِيرٌ بدن':Added, #1: 1	تَخَبُّطِ النَّفْسِ
u'تَخْدِيرٌ بَدَنٌ':Added, #2: 2	تَخْدِيرِ الْبَدَنِ
u'تَخَرُّجٌ رِوايَةٌ':Added, #2: 2	تَخْدِيرِ الْبَدَنِ
u'تَخَرُّجٌ رِوايَةٌ':Added, #1: 1	تَخَرُّجُ رِوَايَةٍ
u'تَخَرَّجَ قَصْرٌ':Subject, #2: 2	تَخَرُّجُ رِوَايَةِ
u'تَخَرَّقَ أَسْفَلُ':Subject, #1: 1	تَخَرَّجَ قَصْرُهُ
u'تَخَرَّقَ أَكْثَرُ':Subject, #1: 1	تَخَرَّقَ الْأَسْفَلُ
u'تَخَرَّقَ ثَوْبٌ':Subject, #2: 2	تَخَرَّقَ أَكْثَرُهُ
u'تَخَرَّقَ ثِيابٌ':Subject, #4: 4	تَخَرَّقَ الثَّوْبُ
u'تَخَرَّقَ خُفٌّ':Subject, #1: 1	تَخَرَّقَ ثِيَابُهُ
u'تَخَرَّقَ خُفٌّ':Subject, #2: 2	تَخَرَّقَ الْخُفُّ
u'تَخَرَّقَ عند':Predicate, #2: 2	تَخَرَّقَ خُفُّهُ
u'تَخَرَّقَ فُسْطَاطٌ':Subject, #2: 2	تَخَرَّقَ عِنْدَ
u'تَخْرِيبٌ بِلادٌ':Added, #1: 1	تَخَرَّقَ الْفُسْطَاطُ
u'تَخْرِيبٌ بِنَاءٌ':Added, #1: 1	تَخْرِيبِ بِلَادِ
u'تَخْرِيبٌ بُنْيانٌ':Added, #1: 1	تَخْرِيبِ بِنَاءٍ
u'تَخْرِيبٌ دَارٌ':Added, #1: 1	تَخْرِيبُ بُنْيَانِ
u'تَخْرِيبٌ ظاهِرٌ':Added, #1: 1	تَخْرِيبِ دَارِ
u'تَخْرِيبٌ ظاهِرٌ':Added, #1: 1	تَخْرِيبِ الظَّاهِرِ
u'تَخْرِيبٌ مَدِينٌ':Added, #1: 1	تَخْرِيبُ ظَاهِرِهِ
u'تَخْرِيبٌ مَدِينَةٌ':Added, #1: 1	تَخْرِيبَ الْمَدِينَةِ
u'تَخْرِيبٌ مُسَنّاة':Added, #1: 1	تَخْرِيبَ الْمَدِينَةِ
u'تَخْرِيبٌ نَهْرٌ':Added, #1: 1	تَخْرِيبَ الْمُسَنَّاةِ
u'تَخْرِيجٌ اِبْنٌ':Added, #2: 2	تَخْرِيبُ النَّهْرِ
u'تَخْرِيجٌ اِبْنٌ':Added, #2: 2	تَخْرِيجَ ابْنِ
u'تَخْرِيجٌ اِبْنٌ':Added, #8: 8	تَخْرِيجُ ابْنِ
u'تَخْرِيجٌ أَحادِيثُ':Added, #9: 9	تَخْرِيجِ ابْنِ
u'تَخْرِيجٌ أَحادِيثُ':Added, #1: 1	تَخْرِيجِ أَحَادِيثِهِ
u'تَخْرِيجٌ أَحادِيثُ':Added, #1: 1	تَخْرِيجِ الْأَحَادِيثِ
u'تَخْرِيجٌ إِطْعامٌ':Added, #22: 22	تَخْرِيجِ أَحَادِيثِ
u'تَخْرِيجٌ أَقَاوِيلُ':Added, #1: 1	تَخْرِيجُ الْإِطْعَامِ
u'تَخْرِيجٌ بَعْضٌ':Added, #1: 1	تَخْرِيجِ أَقَاوِيلِ
u'تَخْرِيجٌ بَعْضٌ':Added, #1: 1	تَخْرِيجُ بَعْضِ
u'تَخْرِيجٌ تَيَمُّمٌ':Added, #1: 1	تَخْرِيجِ بَعْضِ
u'تَخْرِيجٌ ثَوابٌ':Added, #1: 1	تَخْرِيجَ التَّيَمُّمِ
u'تَخْرِيجٌ جِنْسٌ':Added, #1: 1	تَخْرِيجُ الثَّوَابِ
u'تَخْرِيجٌ جَوَازٌ':Added, #1: 1	تَخْرِيجِ جِنْسِ
u'تَخْرِيجٌ حاكِمٌ':Added, #1: 1	تَخْرِيجُ الْجَوَازِ
u'تَخْرِيجٌ حَجٌّ':Added, #1: 1	تَخْرِيجَ الْحَاكِمِ
u'تَخْرِيجٌ حَجْرٌ':Added, #2: 2	تَخْرِيجُ الْحَجِّ
u'تَخْرِيجٌ حَديثٌ':Added, #1: 1	تَخْرِيجُ الْحَجْرِ
u'تَخْرِيجٌ حَديثٌ':Added, #1: 1	تَخْرِيجُ الْحَدِيثِ
u'تَخْرِيجٌ حُكْمٌ':Added, #2: 2	تَخْرِيجُ الْحَدِيثَيْنِ
u'تَخْرِيجٌ حَكِيمٌ':Added, #2: 2	تَخْرِيجُ حُكْمِ
u'تَخْرِيجٌ خِلاَفٌ':Added, #1: 1	تَخْرِيجِ الْحَكِيمِ
u'تَخْرِيجٌ خِلاَفٌ':Added, #1: 1	تَخْرِيجَ الْخِلَافِ
u'تَخْرِيجٌ خِلاَفٌ':Added, #2: 2	تَخْرِيجُ الْخِلَافِ
u'تَخْرِيجٌ دَيْنٌ':Added, #2: 2	تَخْرِيجُ خِلَافٍ
u'تَخْرِيجٌ رِوايَةٌ':Added, #1: 1	تَخْرِيجُ الدَّيْنِ
u'تَخْرِيجٌ رِوايَةٌ':Added, #1: 1	تَخْرِيجِ رِوَايَةٍ
u'تَخْرِيجٌ رِوايَةٌ':Added, #1: 1	تَخْرِيجِ رِوَايَةِ
u'تَخْرِيجٌ رِوايَةٌ':Added, #2: 2	تَخْرِيجَ رِوَايَةٍ
u'تَخْرِيجٌ رِوايَةٌ':Added, #3: 3	تَخْرِيجُ رِوَايَةِ
u'تَخْرِيجٌ سَائِرٌ':Added, #6: 6	تَخْرِيجُ رِوَايَةٍ
u'تَخْرِيجٌ سُؤَالٌ':Added, #1: 1	تَخْرِيجُ سَائِرِ
u'تَخْرِيجٌ صُورَةٌ':Added, #2: 2	تَخْرِيجُ سُؤَالِ
u'تَخْرِيجٌ طَبَرِيّ':Added, #1: 1	تَخْرِيجَ صُورَةِ
u'تَخْرِيجٌ طُرُقٌ':Added, #1: 1	تَخْرِيجِ الطَّبَرِيِّ
u'تَخْرِيجٌ طُرُقٌ':Added, #1: 1	تَخْرِيجَ طُرُقِهِ
u'تَخْرِيجٌ طَرِيقٌ':Added, #3: 3	تَخْرِيجِ طُرُقِهِ
u'تَخْرِيجٌ عقاب':Added, #1: 1	تَخْرِيجِ طَرِيقٍ
u'تَخْرِيجٌ عِقَابٌ':Added, #1: 1	تَخْرِيجُ الْعِقَابِ
u'تَخْرِيجٌ غَلَطٌ':Added, #1: 1	تَخْرِيجُ الْعِقَابِ
u'تَخْرِيجٌ فُرُوعٌ':Added, #1: 1	تَخْرِيجٍ غَلَطٍ
u'تَخْرِيجٌ فَسْخٌ':Added, #1: 1	تَخْرِيجِ الْفُرُوعِ
u'تَخْرِيجٌ فلان':Added, #1: 1	تَخْرِيجُ الْفَسْخِ
u'تَخْرِيجٌ فلان':Added, #1: 1	تَخْرِيجِ الرَّازِيِّ
u'تَخْرِيجٌ فلان':Added, #1: 1	تَخْرِيجِ الطَّبَرِيِّ
u'تَخْرِيجٌ قول':Added, #3: 3	تَخْرِيجُ الرَّازِيِّ
u'تَخْرِيجٌ قَوْلٌ':Added, #1: 1	تَخْرِيجِ الْقَوْلِ
u'تَخْرِيجٌ قَوْلٌ':Added, #1: 1	تَخْرِيجِ الْقَوْلِ
u'تَخْرِيجٌ قول':Added, #1: 1	تَخْرِيجَ الْقَوْلَيْنِ
u'تَخْرِيجٌ قَوْلٌ':Added, #1: 1	تَخْرِيجَ قَوْلِ
u'تَخْرِيجٌ قَوْلٌ':Added, #1: 1	تَخْرِيجَ قَوْلٍ
u'تَخْرِيجٌ قَوْلٌ':Added, #1: 1	تَخْرِيجَ قَوْلِ
u'تَخْرِيجٌ قَوْلٌ':Added, #1: 1	تَخْرِيجَ قَوْلَيْنِ
u'تَخْرِيجٌ قَوْلٌ':Added, #1: 1	تَخْرِيجُ قَوْلَيْنِ
u'تَخْرِيجٌ قول':Added, #2: 2	تَخْرِيجِ قَوْلٍ
u'تَخْرِيجٌ قول':Added, #3: 3	تَخْرِيجُ قَوْلِ
u'تَخْرِيجٌ قَوْلٌ':Added, #3: 3	تَخْرِيجِ قَوْلِ
u'تَخْرِيجٌ قَوْلٌ':Added, #3: 3	تَخْرِيجُ قَوْلِ
u'تَخْرِيجٌ كَلاَمٌ':Added, #3: 3	تَخْرِيجِ قَوْلِ
u'تَخْرِيجٌ كَلاَمٌ':Added, #1: 1	تَخْرِيجُ كَلَامِ
u'تَخْرِيجٌ مَالِكٌ':Added, #4: 4	تَخْرِيجِ كَلَامِ
u'تَخْرِيجٌ مَالِكٌ':Added, #1: 1	تَخْرِيجَ مَالِكٍ
u'تَخْرِيجٌ مَجْدٌ':Added, #1: 1	تَخْرِيجِ مَالِكٍ
u'تَخْرِيجٌ مَجْهُولٌ':Added, #1: 1	تَخْرِيجُ الْمَجْدِ
u'تَخْرِيجٌ مُحَرَّرٌ':Added, #1: 1	تَخْرِيجُ الْمَجْهُولِ
u'تَخْرِيجٌ مُحَمَّدٌ':Added, #1: 1	تَخْرِيجِ الْمُحَرَّرِ
u'تَخْرِيجٌ مُحَمَّدٌ':Added, #1: 1	تَخْرِيجِ مُحَمَّدٍ
u'تَخْرِيجٌ مَسْأَلَةٌ':Added, #3: 3	تَخْرِيجُ مُحَمَّدٍ
u'تَخْرِيجٌ مَسْأَلَةٌ':Added, #1: 1	تَخْرِيجَ مَسْأَلَةٍ
u'تَخْرِيجٌ مَسْأَلَةٌ':Added, #1: 1	تَخْرِيجِ مَسْأَلَةِ
u'تَخْرِيجٌ مَسْأَلَةٌ':Added, #2: 2	تَخْرِيجَ الْمَسْأَلَةِ
u'تَخْرِيجٌ مَسْأَلَةٌ':Added, #2: 2	تَخْرِيجِ الْمَسْأَلَةِ
u'تَخْرِيجٌ مَسَائِلُ':Added, #3: 3	تَخْرِيجُ الْمَسْأَلَةِ
u'تَخْرِيجٌ مَسْحٌ':Added, #4: 4	تَخْرِيجُ الْمَسَائِلِ
u'تَخْرِيجٌ مُسْلِمٌ':Added, #1: 1	تَخْرِيجَ الْمَسْحِ
u'تَخْرِيجٌ مُسْنَدٌ':Added, #1: 1	تَخْرِيجِ مُسْلِمٍ
u'تَخْرِيجٌ مُصَنِّفٌ':Added, #1: 1	تَخْرِيجِ مُسْنَدِ
u'تَخْرِيجٌ مَنَاطٌ':Added, #2: 2	تَخْرِيجِ الْمُصَنِّفِ
u'تَخْرِيجٌ مَنَاطٌ':Added, #1: 1	تَخْرِيجِ مَنَاطٍ
u'تَخْرِيجٌ مَنَاطٌ':Added, #3: 3	تَخْرِيجَ الْمَنَاطِ
u'تَخْرِيجٌ مَنَاطٌ':Added, #3: 3	تَخْرِيجِ الْمَنَاطِ
u'تَخْرِيجٌ مِيرَاثٌ':Added, #6: 6	تَخْرِيجُ الْمَنَاطِ
u'تَخْرِيجٌ وَجْهٌ':Added, #1: 1	تَخْرِيجِ الْمِيرَاثِ
u'تَخْرِيجٌ وَجْهٌ':Added, #3: 3	تَخْرِيجَ وَجْهٍ
u'تَخْرِيجٌ وُجُوبٌ':Added, #4: 4	تَخْرِيجُ وَجْهٍ
u'تَخْرِيقٌ ثَوْبٌ':Added, #2: 2	تَخْرِيجُ وُجُوبِ
u'تَخْرِيقٌ ثِيابٌ':Added, #4: 4	تَخْرِيقِ الثَّوْبِ
u'تَخْرِيقٌ كَفَنٌ':Added, #2: 2	تَخْرِيقِ الثِّيَابِ
u'تَخْشِينٌ قول':Added, #1: 1	تَخْرِيقِ الْكَفَنِ
u'تَخْشِينٌ قَوْلٌ':Added, #1: 1	تَخْشِينُ الْقَوْلِ
u'تَخَصُّصٌ مُتَأَخِّرٌ':Added, #1: 1	تَخْشِينُ الْقَوْلِ
u'تَخْصِيصٌ اِبْنٌ':Added, #1: 1	تَخَصُّصِ الْمُتَأَخِّرِ
u'تَخْصِيصٌ إِتْيانٌ':Added, #1: 1	تَخْصِيصَ ابْنِ
u'تَخْصِيصٌ إِثْمٌ':Added, #1: 1	تَخْصِيصُ الْإِتْيَانِ
u'تَخْصِيصٌ إِجَابَةٌ':Added, #1: 1	تَخْصِيصِ الْإِثْمِ
u'تَخْصِيصٌ إجَازَةٌ':Added, #1: 1	تَخْصِيصُ إجَابَةِ
u'تَخْصِيصٌ إِجْمَاعٌ':Added, #2: 2	تَخْصِيصُ إجَازَةِ
u'تَخْصِيصٌ أحَدٌ':Added, #1: 1	تَخْصِيصَ الْإِجْمَاعِ
u'تَخْصِيصٌ أحَدٌ':Added, #1: 1	تَخْصِيصَ أَحَدٍ
u'تَخْصِيصٌ أحَدٌ':Added, #1: 1	تَخْصِيصَ أَحَدِ
u'تَخْصِيصٌ أحَدٌ':Added, #1: 1	تَخْصِيصِ أَحَدٍ
u'تَخْصِيصٌ أَحْكَامٌ':Added, #2: 2	تَخْصِيصُ أَحَدٍ
u'تَخْصِيصٌ أخْبَارٌ':Added, #1: 1	تَخْصِيصُ أَحْكَامِ
u'تَخْصِيصٌ أَخْبَارٌ':Added, #1: 1	تَخْصِيصِ الْأَخْبَارِ
u'تَخْصِيصٌ أَذَانٌ':Added, #1: 1	تَخْصِيصِ الْأَخْبَارِ
u'تَخْصِيصٌ أَذَانٌ':Added, #1: 1	تَخْصِيصَ الْأَذَانِ
u'تَخْصِيصٌ إِذْنٌ':Added, #1: 1	تَخْصِيصِ الْأَذَانِ
u'تَخْصِيصٌ أَرْبَعَةٌ':Added, #1: 1	تَخْصِيصَ الْإِذْنِ
u'تَخْصِيصٌ أرْضٌ':Added, #1: 1	تَخْصِيصَ الْأَرْبَعَةِ
u'تَخْصِيصٌ اِسْمٌ':Added, #1: 1	تَخْصِيصِ الْأَرْضِ
u'تَخْصِيصٌ اِسْمٌ':Added, #1: 1	تَخْصِيصُ اسْمٍ
u'تَخْصِيصٌ اِسْمٌ':Added, #1: 1	تَخْصِيصُ اسْمِ
u'تَخْصِيصٌ إشارَة':Added, #1: 1	تَخْصِيصِ اسْمِهِ
u'تَخْصِيصٌ أَشْيَاءٌ':Added, #1: 1	تَخْصِيصِ الْإِشَارَةِ
u'تَخْصِيصٌ أصل':Added, #1: 1	تَخْصِيصَ الْأَشْيَاءِ
u'تَخْصِيصٌ أصل':Added, #1: 1	تَخْصِيصَ أَصْلِهِ
u'تَخْصِيصٌ أًصْلٌ':Added, #1: 1	تَخْصِيصِ أَصْلِهِ
u'تَخْصِيصٌ أًصْلٌ':Added, #1: 1	تَخْصِيصَ أَصْلِهِ
u'تَخْصِيصٌ أصل':Added, #1: 1	تَخْصِيصِ أَصْلِهِ
u'تَخْصِيصٌ أًصْلٌ':Added, #2: 2	تَخْصِيصِ الْأَصْلِ
u'تَخْصِيصٌ اِطِّرادٌ':Added, #2: 2	تَخْصِيصِ الْأَصْلِ
u'تَخْصِيصٌ اِقْتِناءٌ':Added, #1: 1	تَخْصِيصُ اطِّرَادِ
u'تَخْصِيصٌ أكْبَرُ':Added, #1: 1	تَخْصِيصِ اقْتِنَاءِ
u'تَخْصِيصٌ إكْرَامٌ':Added, #1: 1	تَخْصِيصُ الْأَكْبَرِ
u'تَخْصِيصٌ الْمَرْأَةُ':Added, #1: 1	تَخْصِيصِ الْإِكْرَامِ
u'تَخْصِيصٌ أُمٌّ':Added, #2: 2	تَخْصِيصِ الْمَرْأَةِ
u'تَخْصِيصٌ إمَامٌ':Added, #1: 1	تَخْصِيصَ الْأُمِّ
u'تَخْصِيصٌ إمَامٌ':Added, #1: 1	تَخْصِيصُ الْإِمَامِ
u'تَخْصِيصٌ إِنْذارٌ':Added, #1: 1	تَخْصِيصِ الْإِمَامِ
u'تَخْصِيصٌ أهْلٌ':Added, #1: 1	تَخْصِيصُ الْإِنْذَارِ
u'تَخْصِيصٌ أهْلٌ':Added, #1: 1	تَخْصِيصَ أَهْلِ
u'تَخْصِيصٌ أهْلٌ':Added, #2: 2	تَخْصِيصُ أَهْلِ
u'تَخْصِيصٌ أَوَّلُ':Added, #3: 3	تَخْصِيصِ أَهْلِ
u'تَخْصِيصٌ أَوَّلُ':Added, #1: 1	تَخْصِيصِ الْأَوَّلِ
u'تَخْصِيصٌ أَوَّلُ':Added, #1: 1	تَخْصِيصُ أَوَّلِ
u'تَخْصِيصٌ أَوَّلُ':Added, #3: 3	تَخْصِيصُ الْأَوَّلِ
u'تَخْصِيصٌ أيَّامٌ':Added, #5: 5	تَخْصِيصَ الْأَوَّلِ
u'تَخْصِيصٌ أَيَّامٌ':Added, #1: 1	تَخْصِيصُ الْأَيَّامِ
u'تَخْصِيصٌ آيَةٌ':Added, #1: 1	تَخْصِيصُ الْأَيَّامِ
u'تَخْصِيصٌ آيَةٌ':Added, #1: 1	تَخْصِيصِ الْآيَةِ
u'تَخْصِيصٌ أَيْمَانٌ':Added, #2: 2	تَخْصِيصِ آيَةِ
u'تَخْصِيصٌ باقَةٌ':Added, #1: 1	تَخْصِيصُ الْأَيْمَانِ
u'تَخْصِيصٌ باقِي':Added, #1: 1	تَخْصِيصُ بَاقِيهِ
u'تَخْصِيصٌ بَطْنٌ':Added, #1: 1	تَخْصِيصُ بَاقِيهِ
u'تَخْصِيصٌ بعثة':Added, #1: 1	تَخْصِيصَ الْبَطْنِ
u'تَخْصِيصٌ بَعْضٌ':Added, #1: 1	تَخْصِيصَ الْبَعْثَةِ
u'تَخْصِيصٌ بَعْضٌ':Added, #3: 3	تَخْصِيصَ بَعْضِ
u'تَخْصِيصٌ بَعْضٌ':Added, #3: 3	تَخْصِيصِ بَعْضِ
u'تَخْصِيصٌ بَعْضٌ':Added, #4: 4	تَخْصِيصِ الْبَعْضِ
u'تَخْصِيصٌ بَعْضٌ':Added, #6: 6	تَخْصِيصُ الْبَعْضِ
u'تَخْصِيصٌ تَصْوِيبٌ':Added, #6: 6	تَخْصِيصُ بَعْضِ
u'تَخْصِيصٌ تَصْوِيرٌ':Added, #1: 1	تَخْصِيصُ التَّصْوِيبِ
u'تَخْصِيصٌ تَضَمُّنٌ':Added, #1: 1	تَخْصِيصُ التَّصْوِيرِ
u'تَخْصِيصٌ تَعْذِيب':Added, #1: 1	تَخْصِيصِ التَّضَمُّنِ
u'تَخْصِيصٌ تَكاليفُ':Added, #1: 1	تَخْصِيصِ التَّعْذِيبِ
u'تَخْصِيصٌ تَكالِيفُ':Added, #1: 1	تَخْصِيصُ التَّكَالِيفِ
u'تَخْصِيصٌ تَكْليفٌ':Added, #1: 1	تَخْصِيصُ التَّكَالِيفِ
u'تَخْصِيصٌ تَنْبِيه':Added, #1: 1	تَخْصِيصِ التَّكْلِيفِ
u'تَخْصِيصٌ تَيَمُّمٌ':Added, #1: 1	تَخْصِيصِ التَّنْبِيهِ
u'تَخْصِيصٌ ثَمَنٌ':Added, #1: 1	تَخْصِيصِ التَّيَمُّمِ
u'تَخْصِيصٌ جَارٌ':Added, #1: 1	تَخْصِيصَ الثَّمَنِ
u'تَخْصِيصٌ جَانِبٌ':Added, #1: 1	تَخْصِيصِ الْجَارِ
u'تَخْصِيصٌ جِدار':Added, #1: 1	تَخْصِيصُ جَانِبِ
u'تَخْصِيصٌ جمع':Added, #1: 1	تَخْصِيصَ الْجِدَارِ
u'تَخْصِيصٌ جمع':Added, #1: 1	تَخْصِيصَ الْجَمْعِ
u'تَخْصِيصٌ جَمْعٌ':Added, #1: 1	تَخْصِيصِ الْجَمْعِ
u'تَخْصِيصٌ جَمْعٌ':Added, #1: 1	تَخْصِيصَ الْجَمْعِ
u'تَخْصِيصٌ جِنْسٌ':Added, #1: 1	تَخْصِيصِ الْجَمْعِ
u'تَخْصِيصٌ جِنْسٌ':Added, #1: 1	تَخْصِيصَ الْجِنْسِ
u'تَخْصِيصٌ جَوَازٌ':Added, #1: 1	تَخْصِيصِ الْجِنْسِ
u'تَخْصِيصٌ جَوَازٌ':Added, #1: 1	تَخْصِيصُ الْجَوَازِ
u'تَخْصِيصٌ جَوَازٌ':Added, #1: 1	تَخْصِيصُ جَوَازِهِ
u'تَخْصِيصٌ حاجَةٌ':Added, #2: 2	تَخْصِيصُ جَوَازِ
u'تَخْصِيصٌ حاكِمٌ':Added, #1: 1	تَخْصِيصُ الْحَاجَةِ
u'تَخْصِيصٌ حالٌ':Added, #1: 1	تَخْصِيصُ الْحَاكِمِ
u'تَخْصِيصٌ حالَةٌ':Added, #1: 1	تَخْصِيصُ حَالٍ
u'تَخْصِيصٌ حائِضٌ':Added, #1: 1	تَخْصِيصِ حَالَةِ
u'تَخْصِيصٌ حَجٌّ':Added, #1: 1	تَخْصِيصِ الْحَائِضِ
u'تَخْصِيصٌ حَديثٌ':Added, #1: 1	تَخْصِيصِ الْحَجِّ
u'تَخْصِيصٌ حَديثٌ':Added, #1: 1	تَخْصِيصُ الْحَدِيثِ
u'تَخْصِيصٌ حَرَمٌ':Added, #3: 3	تَخْصِيصُ حَدِيثِ
u'تَخْصِيصٌ حَقِيقٌ':Added, #1: 1	تَخْصِيصِ الْحَرَمِ
u'تَخْصِيصٌ حَقِيقَةٌ':Added, #1: 1	تَخْصِيصَ الْحَقِيقَةِ
u'تَخْصِيصٌ حُكْمٌ':Added, #1: 1	تَخْصِيصَ الْحَقِيقَةِ
u'تَخْصِيصٌ حُكْمٌ':Added, #1: 1	تَخْصِيصَ الْحُكْمِ
u'تَخْصِيصٌ حُكْمٌ':Added, #1: 1	تَخْصِيصَ حُكْمِ
u'تَخْصِيصٌ حُكْمٌ':Added, #1: 1	تَخْصِيصِ حُكْمٍ
u'تَخْصِيصٌ حُكْمٌ':Added, #2: 2	تَخْصِيصُ الْحُكْمِ
u'تَخْصِيصٌ حكمة':Added, #4: 4	تَخْصِيصِ الْحُكْمِ
u'تَخْصِيصٌ حِكْمَةٌ':Added, #1: 1	تَخْصِيصُ الْحِكْمَةِ
u'تَخْصِيصٌ حَمْدٌ':Added, #1: 1	تَخْصِيصُ الْحِكْمَةِ
u'تَخْصِيصٌ حِنْثٌ':Added, #1: 1	تَخْصِيصِ الْحَمْدِ
u'تَخْصِيصٌ حَيَاةٌ':Added, #1: 1	تَخْصِيصَ الْحِنْثِ
u'تَخْصِيصٌ حِيلَةٌ':Added, #1: 1	تَخْصِيصِ الْحَيَاةِ
u'تَخْصِيصٌ خَبَرٌ':Added, #1: 1	تَخْصِيصَ الْحِيلَةِ
u'تَخْصِيصٌ خَبَرٌ':Added, #1: 1	تَخْصِيصَ خَبَرِ
u'تَخْصِيصٌ خَبَر':Added, #1: 1	تَخْصِيصُ خَبَرِ
u'تَخْصِيصٌ خَبَر':Added, #1: 1	تَخْصِيصَ خَبَرِ
u'تَخْصِيصٌ خِطَابٌ':Added, #1: 1	تَخْصِيصُ خَبَرِ
u'تَخْصِيصٌ خِلاَفٌ':Added, #1: 1	تَخْصِيصِ الْخِطَابِ
u'تَخْصِيصٌ خِلاَفٌ':Added, #3: 3	تَخْصِيصِ الْخِلَافِ
u'تَخْصِيصٌ خِلاَفٌ':Added, #4: 4	تَخْصِيصَ الْخِلَافِ
u'تَخْصِيصٌ خُلْعٌ':Added, #4: 4	تَخْصِيصُ الْخِلَافِ
u'تَخْصِيصٌ خيار':Added, #1: 1	تَخْصِيصُ الْخُلْعِ
u'تَخْصِيصٌ خِيَارٌ':Added, #1: 1	تَخْصِيصُ خِيَارِ
u'تَخْصِيصٌ خَيْلٌ':Added, #1: 1	تَخْصِيصُ خِيَارِ
u'تَخْصِيصٌ دَارٌ':Added, #1: 1	تَخْصِيصُ الْخَيْلِ
u'تَخْصِيصٌ دِبَاغٌ':Added, #1: 1	تَخْصِيصِ الدَّارِ
u'تَخْصِيصٌ دَرَاهِمُ':Added, #1: 1	تَخْصِيصِ الدِّبَاغِ
u'تَخْصِيصٌ دَليلٌ':Added, #1: 1	تَخْصِيصُ الدَّرَاهِمِ
u'تَخْصِيصٌ ذكر':Added, #1: 1	تَخْصِيصُ دَلِيلِ
u'تَخْصِيصٌ ذِكْرٌ':Added, #1: 1	تَخْصِيصِ ذِكْرِ
u'تَخْصِيصٌ رَدٌّ':Added, #1: 1	تَخْصِيصِ ذِكْرِ
u'تَخْصِيصٌ رِوايَةٌ':Added, #1: 1	تَخْصِيصُ رَدِّهِ
u'تَخْصِيصٌ زَمانٌ':Added, #3: 3	تَخْصِيصُ الرِّوَايَةِ
u'تَخْصِيصٌ سَبَبٌ':Added, #1: 1	تَخْصِيصُ الزَّمَانِ
u'تَخْصِيصٌ سَبَبٌ':Added, #1: 1	تَخْصِيصَ السَّبَبِ
u'تَخْصِيصٌ سَبَبٌ':Added, #1: 1	تَخْصِيصُ السَّبَبِ
u'تَخْصِيصٌ سُقُوطٌ':Added, #1: 1	تَخْصِيصِ السَّبَبِ
u'تَخْصِيصٌ سُنَّةٌ':Added, #1: 1	تَخْصِيصِ السُّقُوطِ
u'تَخْصِيصٌ سُنَّةٌ':Added, #1: 1	تَخْصِيصَ السُّنَّةِ
u'تَخْصِيصٌ سُنَّةٌ':Added, #2: 2	تَخْصِيصِ السُّنَّةِ
u'تَخْصِيصٌ شَاةٌ':Added, #4: 4	تَخْصِيصُ السُّنَّةِ
u'تَخْصِيصٌ شَارِعٌ':Added, #1: 1	تَخْصِيصَ الشَّاةِ
u'تَخْصِيصٌ شافِعِيّ':Added, #1: 1	تَخْصِيصَ الشَّارِعِ
u'تَخْصِيصٌ شِرَاءٌ':Added, #1: 1	تَخْصِيصِ الشَّافِعِيِّ
u'تَخْصِيصٌ شَرْعٌ':Added, #1: 1	تَخْصِيصَ الشِّرَاءِ
u'تَخْصِيصٌ شُرُوعٌ':Added, #1: 1	تَخْصِيصِ الشَّرْعِ
u'تَخْصِيصٌ شَيْءٌ':Added, #1: 1	تَخْصِيصِ الشُّرُوعِ
u'تَخْصِيصٌ شَيْءٌ':Added, #4: 4	تَخْصِيصِ الشَّيْءِ
u'تَخْصِيصٌ صِفَةٌ':Added, #7: 7	تَخْصِيصَ الشَّيْءِ
u'تَخْصِيصٌ صِفَةٌ':Added, #1: 1	تَخْصِيصِ الصِّفَةِ
u'تَخْصِيصٌ صَكٌّ':Added, #2: 2	تَخْصِيصُ الصِّفَةِ
u'تَخْصِيصٌ صَلاَةٌ':Added, #1: 1	تَخْصِيصَ الصَّكِّ
u'تَخْصِيصٌ صُورَةٌ':Added, #2: 2	تَخْصِيصُ الصَّلَاةِ
u'تَخْصِيصٌ صَوْمٌ':Added, #1: 1	تَخْصِيصُ صُورَةِ
u'تَخْصِيصٌ صِيَغٌ':Added, #1: 1	تَخْصِيصُ صَوْمِ
u'تَخْصِيصٌ ضلع':Added, #1: 1	تَخْصِيصِ صِيَغِ
u'تَخْصِيصٌ ضَمِيرٌ':Added, #1: 1	تَخْصِيصَ الضِّلَعِ
u'تَخْصِيصٌ طَائِفٌ':Added, #2: 2	تَخْصِيصَ الضَّمِيرِ
u'تَخْصِيصٌ طعام':Added, #1: 1	تَخْصِيصُ طَائِفَةٍ
u'تَخْصِيصٌ طَعَامٌ':Added, #1: 1	تَخْصِيصَ الطَّعَامِ
u'تَخْصِيصٌ طَلاَقٌ':Added, #1: 1	تَخْصِيصَ الطَّعَامِ
u'تَخْصِيصٌ طَهَارَةٌ':Added, #1: 1	تَخْصِيصِ الطَّلَاقِ
u'تَخْصِيصٌ ظاهِرٌ':Added, #1: 1	تَخْصِيصِ الطَّهَارَةِ
u'تَخْصِيصٌ ظاهِرٌ':Added, #1: 1	تَخْصِيصَ الظَّاهِرِ
u'تَخْصِيصٌ ظاهِرٌ':Added, #1: 1	تَخْصِيصُ الظَّاهِرِ
u'تَخْصِيصٌ ظاهِرٌ':Added, #1: 1	تَخْصِيصِ الظَّاهِرِ
u'تَخْصِيصٌ ظَنِّيّ':Added, #1: 1	تَخْصِيصُ ظَاهِرِ
u'تَخْصِيصٌ عَالِمٌ':Added, #1: 1	تَخْصِيصَ الظَّنِّيَّيْنِ
u'تَخْصِيصٌ عَامٌّ':Added, #1: 1	تَخْصِيصِ الْعَالِمِ
u'تَخْصِيصٌ عَامٌّ':Added, #18: 18	تَخْصِيصُ الْعَامِّ
u'تَخْصِيصٌ عَامٌّ':Added, #1: 1	تَخْصِيصَ عَامٍّ
u'تَخْصِيصٌ عَامٌّ':Added, #1: 1	تَخْصِيصُ عَامٍّ
u'تَخْصِيصٌ عَامٌّ':Added, #1: 1	تَخْصِيصِ عَامِّهِ
u'تَخْصِيصٌ عَامٌّ':Added, #26: 26	تَخْصِيصِ الْعَامِّ
u'تَخْصِيصٌ عِبَارَةٌ':Added, #7: 7	تَخْصِيصَ الْعَامِّ
u'تَخْصِيصٌ عَدَمٌ':Added, #1: 1	تَخْصِيصَ الْعِبَارَاتِ
u'تَخْصِيصٌ عَدَمٌ':Added, #1: 1	تَخْصِيصِ عَدَمِ
u'تَخْصِيصٌ عرف':Added, #2: 2	تَخْصِيصُ عَدَمِ
u'تَخْصِيصٌ عرف':Added, #2: 2	تَخْصِيصُ الْعُرْفِ
u'تَخْصِيصٌ عُرْفٌ':Added, #2: 2	تَخْصِيصِ الْعُرْفِ
u'تَخْصِيصٌ عُرْفٌ':Added, #2: 2	تَخْصِيصُ الْعُرْفِ
u'تَخْصِيصٌ عَقْلٌ':Added, #2: 2	تَخْصِيصِ الْعُرْفِ
u'تَخْصِيصٌ عِلَّةٌ':Added, #3: 3	تَخْصِيصِ الْعَقْلِ
u'تَخْصِيصٌ عِلَّةٌ':Added, #14: 14	تَخْصِيصُ الْعِلَّةِ
u'تَخْصِيصٌ عِلَّةٌ':Added, #1: 1	تَخْصِيصَ عِلَّتِهِ
u'تَخْصِيصٌ عِلَّةٌ':Added, #39: 39	تَخْصِيصِ الْعِلَّةِ
u'تَخْصِيصٌ عِلَلٌ':Added, #7: 7	تَخْصِيصَ الْعِلَّةِ
u'تَخْصِيصٌ عِلَلٌ':Added, #2: 2	تَخْصِيصَ الْعِلَلِ
u'تَخْصِيصٌ علم':Added, #8: 8	تَخْصِيصِ الْعِلَلِ
u'تَخْصِيصٌ عِلْمٌ':Added, #1: 1	تَخْصِيصِ الْعِلْمِ
u'تَخْصِيصٌ عَمَلٌ':Added, #1: 1	تَخْصِيصِ الْعِلْمِ
u'تَخْصِيصٌ عُمُومٌ':Added, #1: 1	تَخْصِيصِ عَمَلِهِ
u'تَخْصِيصٌ عُمُومٌ':Added, #12: 12	تَخْصِيصُ عُمُومِ
u'تَخْصِيصٌ عُمُومٌ':Added, #16: 16	تَخْصِيصُ الْعُمُومِ
u'تَخْصِيصٌ عُمُومٌ':Added, #1: 1	تَخْصِيصِ الْعُمُومَاتِ
u'تَخْصِيصٌ عُمُومٌ':Added, #1: 1	تَخْصِيصُ الْعُمُومَيْنِ
u'تَخْصِيصٌ عُمُومٌ':Added, #1: 1	تَخْصِيصَ عُمُومِ
u'تَخْصِيصٌ عُمُومٌ':Added, #1: 1	تَخْصِيصِ عُمُومَاتِ
u'تَخْصِيصٌ عُمُومٌ':Added, #22: 22	تَخْصِيصِ الْعُمُومِ
u'تَخْصِيصٌ عُمُومٌ':Added, #3: 3	تَخْصِيصُ عُمُومٍ
u'تَخْصِيصٌ عُمُومٌ':Added, #3: 3	تَخْصِيصِ عُمُومِ
u'تَخْصِيصٌ عين':Added, #7: 7	تَخْصِيصَ الْعُمُومِ
u'تَخْصِيصٌ عَيْنٌ':Added, #1: 1	تَخْصِيصُ عَيْنِ
u'تَخْصِيصٌ عَيْنٌ':Added, #1: 1	تَخْصِيصُ عَيْنٍ
u'تَخْصِيصٌ عَيْن':Added, #1: 1	تَخْصِيصُ عَيْنِ
u'تَخْصِيصٌ عَيْن':Added, #1: 1	تَخْصِيصُ عَيْنٍ
u'تَخْصِيصٌ عين':Added, #1: 1	تَخْصِيصُ عَيْنِ
u'تَخْصِيصٌ عَيْنٌ':Added, #1: 1	تَخْصِيصُ عَيْنِهِ
u'تَخْصِيصٌ عَيْن':Added, #1: 1	تَخْصِيصُ عَيْنِهِ
u'تَخْصِيصٌ غَزْلٌ':Added, #1: 1	تَخْصِيصُ عَيْنِهِ
u'تَخْصِيصٌ غير':Added, #1: 1	تَخْصِيصِ الْغَزْلِ
u'تَخْصِيصٌ غَيْرٌ':Added, #1: 1	تَخْصِيصِ غَيْرِ
u'تَخْصِيصٌ غير':Added, #1: 1	تَخْصِيصِ غَيْرِ
u'تَخْصِيصٌ غير':Added, #1: 1	تَخْصِيصَ غَيْرِهِ
u'تَخْصِيصٌ غَيْرٌ':Added, #1: 1	تَخْصِيصُ غَيْرِهِ
u'تَخْصِيصٌ غَيْرٌ':Added, #1: 1	تَخْصِيصَ غَيْرِهِ
u'تَخْصِيصٌ فَاعِلٌ':Added, #1: 1	تَخْصِيصُ غَيْرِهِ
u'تَخْصِيصٌ فَرَائِضُ':Added, #1: 1	تَخْصِيصَ الْفَاعِلِ
u'تَخْصِيصٌ فِعْلٌ':Added, #3: 3	تَخْصِيصِ الْفَرَائِضِ
u'تَخْصِيصٌ فلان':Added, #1: 1	تَخْصِيصِ الْفِعْلِ
u'تَخْصِيصٌ فَوَائِدُ':Added, #1: 1	تَخْصِيصِ الشَّافِعِيِّ
u'تَخْصِيصٌ قَاصِرٌ':Added, #1: 1	تَخْصِيصُ الْفَوَائِدِ
u'تَخْصِيصٌ قُرْآنٌ':Added, #1: 1	تَخْصِيصُ الْقَاصِرَةِ
u'تَخْصِيصٌ قُرْآنٌ':Added, #1: 1	تَخْصِيصِ الْقُرْآنِ
u'تَخْصِيصٌ قَرِيبٌ':Added, #3: 3	تَخْصِيصُ الْقُرْآنِ
u'تَخْصِيصٌ قَصْدٌ':Added, #1: 1	تَخْصِيصُ قَرِيبِهِ
u'تَخْصِيصٌ قَطْعٌ':Added, #1: 1	تَخْصِيصُ الْقَصْدِ
u'تَخْصِيصٌ قول':Added, #1: 1	تَخْصِيصِ الْقَطْعِ
u'تَخْصِيصٌ قَوْلٌ':Added, #1: 1	تَخْصِيصِ قَوْلِهِ
u'تَخْصِيصٌ قول':Added, #1: 1	تَخْصِيصِ قَوْلِهِ
u'تَخْصِيصٌ قَوْلٌ':Added, #2: 2	تَخْصِيصُ الْقَوْلِ
u'تَخْصِيصٌ قول':Added, #2: 2	تَخْصِيصُ الْقَوْلِ
u'تَخْصِيصٌ قَوْلٌ':Added, #2: 2	تَخْصِيصُ قَوْلِ
u'تَخْصِيصٌ قول':Added, #2: 2	تَخْصِيصُ قَوْلِ
u'تَخْصِيصٌ قَوْلٌ':Added, #3: 3	تَخْصِيصُ قَوْلِهِ
u'تَخْصِيصٌ قَوْمٌ':Added, #3: 3	تَخْصِيصُ قَوْلِهِ
u'تَخْصِيصٌ قَوْمٌ':Added, #2: 2	تَخْصِيصُ الْقَوْمِ
u'تَخْصِيصٌ قِيَاسٌ':Added, #2: 2	تَخْصِيصُ قَوْمٍ
u'تَخْصِيصٌ قِيَاسٌ':Added, #1: 1	تَخْصِيصُ الْقِيَاسِ
u'تَخْصِيصٌ قِيَاسٌ':Added, #2: 2	تَخْصِيصِ الْقِيَاسِ
u'تَخْصِيصٌ كَافِرٌ':Added, #3: 3	تَخْصِيصَ الْقِيَاسِ
u'تَخْصِيصٌ كَبْشٌ':Added, #1: 1	تَخْصِيصَ كَافِرِ
u'تَخْصِيصٌ كِتَابٌ':Added, #1: 1	تَخْصِيصُ الْكَبْشِ
u'تَخْصِيصٌ كِتَابٌ':Added, #2: 2	تَخْصِيصِ الْكِتَابِ
u'تَخْصِيصٌ كَلاَمٌ':Added, #9: 9	تَخْصِيصُ الْكِتَابِ
u'تَخْصِيصٌ كَلاَمٌ':Added, #1: 1	تَخْصِيصُ الْكَلَامِ
u'تَخْصِيصٌ كَوْنٌ':Added, #1: 1	تَخْصِيصُ كَلَامِ
u'تَخْصِيصٌ لُزُومٌ':Added, #1: 1	تَخْصِيصُ كَوْنِهِ
u'تَخْصِيصٌ لُغَةٌ':Added, #2: 2	تَخْصِيصُ لُزُومِ
u'تَخْصِيصٌ لَفْظٌ':Added, #1: 1	تَخْصِيصِ اللُّغَةِ
u'تَخْصِيصٌ لَفْظٌ':Added, #1: 1	تَخْصِيصَ لَفْظِ
u'تَخْصِيصٌ لَفْظٌ':Added, #1: 1	تَخْصِيصَ لَفْظِهِ
u'تَخْصِيصٌ لَفْظٌ':Added, #2: 2	تَخْصِيصِ لَفْظِ
u'تَخْصِيصٌ لَفْظٌ':Added, #3: 3	تَخْصِيصَ اللَّفْظِ
u'تَخْصِيصٌ لَفْظٌ':Added, #3: 3	تَخْصِيصِ اللَّفْظِ
u'تَخْصِيصٌ لَيْلٌ':Added, #4: 4	تَخْصِيصُ اللَّفْظِ
u'تَخْصِيصٌ لَيْلٌ':Added, #1: 1	تَخْصِيصِ لَيْلَةِ
u'تَخْصِيصٌ مُتْعَةٌ':Added, #4: 4	تَخْصِيصُ لَيْلَةِ
u'تَخْصِيصٌ مُتَوَاتِرٌ':Added, #1: 1	تَخْصِيصُ الْمُتْعَةِ
u'تَخْصِيصٌ مُتَوَاتِرٌ':Added, #1: 1	تَخْصِيصُ الْمُتَوَاتِرِ
u'تَخْصِيصٌ مُتُونٌ':Added, #2: 2	تَخْصِيصِ الْمُتَوَاتِرِ
u'تَخْصِيصٌ مَحَلٌّ':Added, #1: 1	تَخْصِيصَ الْمُتُونِ
u'تَخْصِيصٌ مَحَلٌّ':Added, #1: 1	تَخْصِيصَ مَحَلٍّ
u'تَخْصِيصٌ مَحَلٌّ':Added, #1: 1	تَخْصِيصَ مَحَلِّ
u'تَخْصِيصٌ مُخَلِّصٌ':Added, #2: 2	تَخْصِيصُ مَحَلِّ
u'تَخْصِيصٌ مَذْكُورٌ':Added, #1: 1	تَخْصِيصُ الْمُخَلِّصِ
u'تَخْصِيصٌ مُرْتَدٌّ':Added, #2: 2	تَخْصِيصَ الْمَذْكُورِ
u'تَخْصِيصٌ مَسْأَلَةٌ':Added, #1: 1	تَخْصِيصِ الْمُرْتَدِّ
u'تَخْصِيصٌ مَسْأَلَةٌ':Added, #1: 1	تَخْصِيصَ مَسْأَلَةِ
u'تَخْصِيصٌ مَسْأَلَةٌ':Added, #1: 1	تَخْصِيصُ مَسْأَلَةٍ
u'تَخْصِيصٌ مَسْأَلَةٌ':Added, #2: 2	تَخْصِيصُ الْمَسْأَلَةِ
u'تَخْصِيصٌ مَسْجِدٌ':Added, #3: 3	تَخْصِيصَ الْمَسْأَلَةِ
u'تَخْصِيصٌ مَسْكَنٌ':Added, #1: 1	تَخْصِيصَ الْمَسْجِدِ
u'تَخْصِيصٌ مَسْكَنٌ':Added, #1: 1	تَخْصِيصَ الْمَسْكَنِ
u'تَخْصِيصٌ مَشْرُوطٌ':Added, #1: 1	تَخْصِيصِ الْمَسْكَنِ
u'تَخْصِيصٌ مُطْلَقٌ':Added, #1: 1	تَخْصِيصَ الْمَشْرُوطِ
u'تَخْصِيصٌ مُطْلَقٌ':Added, #1: 1	تَخْصِيصَ الْمُطْلَقِ
u'تَخْصِيصٌ مَظْنُون':Added, #2: 2	تَخْصِيصِ الْمُطْلَقِ
u'تَخْصِيصٌ مَعْدُومٌ':Added, #1: 1	تَخْصِيصِ الْمَظْنُونِ
u'تَخْصِيصٌ مَعْطُوف':Added, #1: 1	تَخْصِيصُ الْمَعْدُومِ
u'تَخْصِيصٌ مَعْطُوف':Added, #1: 1	تَخْصِيصُ الْمَعْطُوفِ
u'تَخْصِيصٌ مَفْعُولٌ':Added, #2: 2	تَخْصِيصَ الْمَعْطُوفِ
u'تَخْصِيصٌ مَفْهُومٌ':Added, #2: 2	تَخْصِيصَ الْمَفْعُولِ
u'تَخْصِيصٌ مَفْهُومٌ':Added, #1: 1	تَخْصِيصُ مَفْهُومِ
u'تَخْصِيصٌ مَفْهُومٌ':Added, #1: 1	تَخْصِيصِ مَفْهُومِ
u'تَخْصِيصٌ مَقْطُوعٌ':Added, #2: 2	تَخْصِيصَ مَفْهُومِ
u'تَخْصِيصٌ مَقْطُوعٌ':Added, #2: 2	تَخْصِيصَ الْمَقْطُوعِ
u'تَخْصِيصٌ مُقَيَّدٌ':Added, #2: 2	تَخْصِيصِ الْمَقْطُوعِ
u'تَخْصِيصٌ مَكَانٌ':Added, #1: 1	تَخْصِيصُ الْمُقَيَّدِ
u'تَخْصِيصٌ مَلْفُوظٌ':Added, #2: 2	تَخْصِيصَ الْمَكَانِ
u'تَخْصِيصٌ مَلَكٌ':Added, #1: 1	تَخْصِيصِ الْمَلْفُوظِ
u'تَخْصِيصٌ مَمَالِيكُ':Added, #1: 1	تَخْصِيصِ الْمَلَكَيْنِ
u'تَخْصِيصٌ مُنَاسَبَةٌ':Added, #1: 1	تَخْصِيصِ الْمَمَالِيكِ
u'تَخْصِيصٌ مَنْعٌ':Added, #1: 1	تَخْصِيصُ الْمُنَاسَبَةِ
u'تَخْصِيصٌ مَنْعٌ':Added, #1: 1	تَخْصِيصَ الْمَنْعِ
u'تَخْصِيصٌ مُؤَكَّدٌ':Added, #1: 1	تَخْصِيصُ الْمَنْعِ
u'تَخْصِيصٌ نَاسٌ':Added, #1: 1	تَخْصِيصُ الْمُؤَكَّدِ
u'تَخْصِيصٌ نَبِيٌّ':Added, #1: 1	تَخْصِيصُ النَّاسِ
u'تَخْصِيصٌ نَجَاسَةٌ':Added, #1: 1	تَخْصِيصِ نَبِيّهِ
u'تَخْصِيصٌ نَصٌّ':Added, #1: 1	تَخْصِيصِ النَّجَاسَةِ
u'تَخْصِيصٌ نَصٌّ':Added, #1: 1	تَخْصِيصُ النَّصِّ
u'تَخْصِيصٌ نَفْسٌ':Added, #3: 3	تَخْصِيصَ النَّصِّ
u'تَخْصِيصٌ نَفْسٌ':Added, #1: 1	تَخْصِيصُ نَفْسِهِ
u'تَخْصِيصٌ نَفْيٌ':Added, #1: 1	تَخْصِيصِ نَفْسِهِ
u'تَخْصِيصٌ نَقْصٌ':Added, #1: 1	تَخْصِيصَ النَّفْيِ
u'تَخْصِيصٌ نقل':Added, #1: 1	تَخْصِيصِ النَّقْصِ
u'تَخْصِيصٌ نَقْلٌ':Added, #1: 1	تَخْصِيصَ النَّقْلِ
u'تَخْصِيصٌ نَهْيٌ':Added, #1: 1	تَخْصِيصَ النَّقْلِ
u'تَخْصِيصٌ نَهْيٌ':Added, #1: 1	تَخْصِيصُ النَّهْيِ
u'تَخْصِيصٌ نِيَّةٌ':Added, #1: 1	تَخْصِيصِ النَّهْيِ
u'تَخْصِيصٌ وَاجِبٌ':Added, #1: 1	تَخْصِيصُ النِّيَّةِ
u'تَخْصِيصٌ واحد':Added, #1: 1	تَخْصِيصِ الْوَاجِبِ
u'تَخْصِيصٌ وَاحِدٌ':Added, #1: 1	تَخْصِيصِ الْوَاحِدِ
u'تَخْصِيصٌ وَارِدٌ':Added, #1: 1	تَخْصِيصِ الْوَاحِدِ
u'تَخْصِيصٌ وَاقِفٌ':Added, #1: 1	تَخْصِيصُ الْوَارِدِ
u'تَخْصِيصٌ وَجْهٌ':Added, #1: 1	تَخْصِيصَ الْوَاقِفِ
u'تَخْصِيصٌ وُجُوبٌ':Added, #1: 1	تَخْصِيصِ الْوَجْهِ
u'تَخْصِيصٌ وُجُودٌ':Added, #1: 1	تَخْصِيصُ وُجُوبِ
u'تَخْصِيصٌ وَسَاطَةٌ':Added, #1: 1	تَخْصِيصُ وُجُودِهِ
u'تَخْصِيصٌ وَصْفٌ':Added, #1: 1	تَخْصِيصِ الْوَسَاطَةِ
u'تَخْصِيصٌ وَصِيٌّ':Added, #1: 1	تَخْصِيصِ الْوَصْفِ
u'تَخْصِيصٌ وَصِيَّةٌ':Added, #1: 1	تَخْصِيصِ الْوَصِيَّةِ
u'تَخْصِيصٌ وُقُوفٌ':Added, #1: 1	تَخْصِيصِ الْوَصِيَّةِ
u'تَخْصِيصٌ وَلِيٌّ':Added, #1: 1	تَخْصِيصِ الْوُقُوفِ
u'تَخْصِيصٌ يَمِينٌ':Added, #1: 1	تَخْصِيصُ الْوَلِيِّ
u'تَخْصِيصٌ يَوْمٌ':Added, #1: 1	تَخْصِيصُ الْيَمِينِ
u'تَخْصِيصٌ يَوْمٌ':Added, #1: 1	تَخْصِيصَ الْيَوْمِ
u'تَخْصِيصٌ يَوْمٌ':Added, #1: 1	تَخْصِيصَ يَوْمٍ
u'تَخَطُّفٌ هَوَامٌّ':Added, #3: 3	تَخْصِيصِ يَوْمِ
u'تَخَطِّي أحَدٌ':Added, #2: 2	تَخَطُّفُ الْهَوَامِّ
u'تَخَطَّى أَرْبَعُ':Predicate, #3: 3	تَخَطِّي أَحَدٍ
u'تَخَطَّى حَلْقَةٌ':Predicate, #1: 1	تَخَطَّى أَرْبَعَ
u'تَخَطَّى رِقابٌ':Predicate, #1: 1	تَخَطَّى حَلْقَةَ
u'تَخَطِّي رِقابٌ':Added, #3: 3	تَخَطَّى رِقَابَ
u'تَخَطِّي رِقابٌ':Added, #3: 3	تَخَطِّي رِقَابِ
u'تَخَطَّى زَرْعٌ':Predicate, #5: 5	تَخَطِّي الرِّقَابِ
u'تَخَطِّي سُؤَالٌ':Added, #1: 1	تَخَطَّى زَرْعَ
u'تَخْطِيطٌ أَعْضَاءٌ':Added, #2: 2	تَخَطِّي السُّؤَالِ
u'تَخَطِّي عَامِلٌ':Added, #1: 1	تَخْطِيطِ الْأَعْضَاءِ
u'تَخْفِيفٌ إبدالٌ':Added, #1: 1	تَخَطِّي الْعَامِلِ
u'تَخْفِيفٌ أثْقَالٌ':Added, #1: 1	تَخْفِيفُ إبْدَالٍ
u'تَخْفِيفٌ إِسْقاطٌ':Added, #1: 1	تَخْفِيفُ الْأَثْقَالِ
u'تَخْفِيفٌ اِقْتِسامٌ':Added, #1: 1	تَخْفِيفُ إسْقَاطٍ
u'تَخْفِيفٌ إكْرَاهٌ':Added, #1: 1	تَخْفِيفِ اقْتِسَامِ
u'تَخْفِيفٌ بدن':Added, #1: 1	تَخْفِيفُ إكْرَاهِ
u'تَخْفِيفٌ بَدَنٌ':Added, #1: 1	تَخْفِيفُ بَدَنِهِ
u'تَخْفِيفٌ بَوْلٌ':Added, #1: 1	تَخْفِيفُ بَدَنِهِ
u'تَخْفِيفٌ تَأْخِيرٌ':Added, #1: 1	تَخْفِيفَ بَوْلِ
u'تَخْفِيفٌ تُرَابٌ':Added, #1: 1	تَخْفِيفُ تَأْخِيرٍ
u'تَخْفِيفٌ تَرْخِيصٌ':Added, #1: 1	تَخْفِيفُ التُّرَابِ
u'تَخْفِيفٌ تَعَوُّذٌ':Added, #1: 1	تَخْفِيفُ تَرْخِيصٍ
u'تَخْفِيفٌ تَغْيِيرٌ':Added, #1: 1	تَخْفِيفُ تَعَوُّذِ
u'تَخْفِيفٌ تَقْديمٌ':Added, #1: 1	تَخْفِيفُ تَغْيِيرٍ
u'تَخْفِيفٌ تَكْليفٌ':Added, #1: 1	تَخْفِيفُ تَقْدِيمٍ
u'تَخْفِيفٌ تَنْقِيصٌ':Added, #1: 1	تَخْفِيفُ التَّكْلِيفِ
u'تَخْفِيفٌ ثَانِي':Added, #1: 1	تَخْفِيفُ تَنْقِيصٍ
u'تَخْفِيفٌ ثَانِيَةٌ':Added, #2: 2	تَخْفِيفُ الثَّانِيَةِ
u'تَخْفِيفٌ ثَوْبٌ':Added, #2: 2	تَخْفِيفُ الثَّانِيَةِ
u'تَخْفِيفٌ جَنَابَةٌ':Added, #1: 1	تَخْفِيفِ ثَوْبٍ
u'تَخْفِيفٌ جَنَابَةٌ':Added, #1: 1	تَخْفِيفَ الْجَنَابَةِ
u'تَخْفِيفٌ جِيم':Added, #1: 1	تَخْفِيفُ الْجَنَابَةِ
u'تَخْفِيفٌ حَدَثٌ':Added, #1: 1	تَخْفِيفِ الْجِيمِ
u'تَخْفِيفٌ حَدَثٌ':Added, #2: 2	تَخْفِيفِ الْحَدَثِ
u'تَخْفِيفٌ حُكْمٌ':Added, #4: 4	تَخْفِيفُ الْحَدَثِ
u'تَخْفِيفٌ حُكْمٌ':Added, #1: 1	تَخْفِيفَ الْحُكْمِ
u'تَخْفِيفٌ رِقٌّ':Added, #1: 1	تَخْفِيفِ حُكْمِ
u'تَخْفِيفٌ زاي':Added, #2: 2	تَخْفِيفَ الرِّقِّ
u'تَخْفِيفٌ سَفِينَةٌ':Added, #2: 2	تَخْفِيفِ الزَّايِ
u'تَخْفِيفٌ سُنَّةٌ':Added, #1: 1	تَخْفِيفِ السَّفِينَةِ
u'تَخْفِيفٌ شُعُورٌ':Added, #1: 1	تَخْفِيفُ سُنَّةِ
u'تَخْفِيفٌ صَلاَةٌ':Added, #1: 1	تَخْفِيفِ الشُّعُورِ
u'تَخْفِيفٌ صَلاَةٌ':Added, #1: 1	تَخْفِيفِ الصَّلَاةِ
u'تَخْفِيفٌ صَلاَةٌ':Added, #1: 1	تَخْفِيفِ الصَّلاَةِ
u'تَخْفِيفٌ عَذَابٌ':Added, #4: 4	تَخْفِيفُ الصَّلَاةِ
u'تَخْفِيفٌ عَذَابٌ':Added, #2: 2	تَخْفِيفُ الْعَذَابِ
u'تَخْفِيفٌ فلان':Added, #2: 2	تَخْفِيفِ الْعَذَابِ
u'تَخْفِيفٌ قُبْلَةٌ':Added, #1: 1	تَخْفِيفِ الْجِيمِ
u'تَخْفِيفٌ قِرَاءةٌ':Added, #1: 1	تَخْفِيفُ الْقُبْلَةِ
u'تَخْفِيفٌ قِرَاءةٌ':Added, #1: 1	تَخْفِيفُ الْقِرَاءَةِ
u'تَخْفِيفٌ لاَمٌ':Added, #5: 5	تَخْفِيفِ الْقِرَاءَةِ
u'تَخْفِيفٌ لِحْيَةٌ':Added, #1: 1	تَخْفِيفِ اللَّامِ
u'تَخْفِيفٌ مُسْتَحَبٌّ':Added, #1: 1	تَخْفِيفُ اللِّحْيَةِ
u'تَخْفِيفٌ مُشَدَّدٌ':Added, #1: 1	تَخْفِيفُ الْمُسْتَحَبِّ
u'تَخْفِيفٌ مَعَرَّة':Added, #1: 1	تَخْفِيفَ الْمُشَدَّدِ
u'تَخْفِيفٌ مَكْرُوهٌ':Added, #1: 1	تَخْفِيفِ مَعَرَّةٍ
u'تَخْفِيفٌ مِيمٌ':Added, #1: 1	تَخْفِيفُ الْمَكْرُوهِ
u'تَخْفِيفٌ نَجَاسَةٌ':Added, #1: 1	تَخْفِيفِ الْمِيمِ
u'تَخْفِيفٌ نَظَرٌ':Added, #3: 3	تَخْفِيفِ النَّجَاسَةِ
u'تَخْفِيفٌ همزة':Added, #1: 1	تَخْفِيفُ النَّظَرِ
u'تَخْفِيفٌ هَمْزَةٌ':Added, #1: 1	تَخْفِيفُ الْهَمْزَةِ
u'تَخْفِيفٌ وَاجِبٌ':Added, #1: 1	تَخْفِيفُ الْهَمْزَةِ
u'تَخَلْخَلَ قلب':Subject, #1: 1	تَخْفِيفِ الْوَاجِبِ
u'تَخَلْخَلَ قَلْبٌ':Subject, #1: 1	تَخَلْخَلَ الْقَلْبُ
u'تَخَلْخَلَ قَلْب':Subject, #1: 1	تَخَلْخَلَ الْقَلْبُ
u'تَخَلُّفٌ أباعد':Added, #1: 1	تَخَلْخَلَ الْقَلْبُ
u'تَخَلَّفَ اِبْنٌ':Subject, #1: 1	تَخَلُّفُ الْأَبَاعِدِ
u'تَخَلُّفٌ آثَارٌ':Added, #1: 1	تَخَلَّفَ ابْنُ
u'تَخَلُّفٌ أثَرٌ':Added, #1: 1	تَخَلُّفِ آثَارِهِ
u'تَخَلَّفَ أَرْبَعُ':Subject, #1: 1	تَخَلُّفِ الْأَثَرِ
u'تَخَلُّفٌ إِرْثٌ':Added, #2: 2	تَخَلَّفَ أَرْبَعُ
u'تَخَلَّفَ إِسْلامٌ':Subject, #1: 1	تَخَلُّفُ الْإِرْثِ
u'تَخَلَّفَ أقَلُّ':Subject, #1: 1	تَخَلَّفَ إسْلَامُهُ
u'تَخَلُّفٌ بَعْضٌ':Added, #1: 1	تَخَلَّفَ أَقَلُّ
u'تَخَلُّفٌ بَعْضٌ':Added, #1: 1	تَخَلُّفُ بَعْضِ
u'تَخَلَّفَ جَمِيع':Subject, #1: 1	تَخَلُّفِ بَعْضِ
u'تَخَلَّفَ حُكْمٌ':Subject, #1: 1	تَخَلَّفَ الْجَمِيعُ
u'تَخَلُّفٌ حُكْمٌ':Added, #6: 6	تَخَلَّفَ الْحُكْمُ
u'تَخَلُّفٌ حُكْمٌ':Added, #1: 1	تَخَلُّفِ حُكْمِهِ
u'تَخَلُّفٌ حُكْمٌ':Added, #3: 3	تَخَلُّفُ الْحُكْمِ
u'تَخَلَّفَ رَجُلٌ':Subject, #8: 8	تَخَلُّفِ الْحُكْمِ
u'تَخَلَّفَ رَسُولٌ':Subject, #1: 1	تَخَلَّفَ رَجُلٌ
u'تَخَلَّفَ سُعَاةٌ':Subject, #4: 4	تَخَلَّفَ رَسُولُ
u'تَخَلَّفَ شَرْطٌ':Subject, #1: 1	تَخَلَّفَ السُّعَاةُ
u'تَخَلُّفٌ شَيْءٌ':Added, #2: 2	تَخَلَّفَ شَرْطٌ
u'تَخَلَّفَ ظَنٌّ':Subject, #1: 1	تَخَلُّفِ الشَّيْءِ
u'تَخَلَّفَ عَبْدٌ':Subject, #1: 1	تَخَلَّفَ ظَنُّهُ
u'تَخَلُّفٌ عِلَّةٌ':Added, #1: 1	تَخَلَّفَ عَبْدٌ
u'تَخَلُّفٌ عِلَّةٌ':Added, #1: 1	تَخَلُّفُ الْعِلَّةِ
u'تَخَلَّفَ عُمْرَانٌ':Subject, #1: 1	تَخَلُّفِ الْعِلَّةِ
u'تَخَلَّفَ قَوْمٌ':Subject, #1: 1	تَخَلَّفَ عُمْرَانُ
u'تَخَلُّفٌ قيام':Added, #1: 1	تَخَلَّفَ قَوْمٌ
u'تَخَلُّفٌ قِيَامٌ':Added, #1: 1	تَخَلُّفِ الْقِيَامِ
u'تَخَلَّفَ كَعْبٌ':Subject, #1: 1	تَخَلُّفِ الْقِيَامِ
u'تَخَلُّفٌ كَعْبٌ':Added, #2: 2	تَخَلَّفَ كَعْبُ
u'تَخَلُّفٌ مَدْلُولٌ':Added, #1: 1	تَخَلُّفَ كَعْبِ
u'تَخَلُّفٌ مَدْلُولٌ':Added, #1: 1	تَخَلُّفِ الْمَدْلُولِ
u'تَخَلَّفَ مراد':Subject, #2: 2	تَخَلُّفُ الْمَدْلُولِ
u'تَخَلَّفَ مُرَادٌ':Subject, #1: 1	تَخَلَّفَ مُرَادُهُ
u'تَخَلُّفٌ مراد':Added, #1: 1	تَخَلَّفَ مُرَادُهُ
u'تَخَلُّفٌ مُرَادٌ':Added, #1: 1	تَخَلُّفَ الْمُرَادِ
u'تَخَلُّفٌ مَعْلُولٌ':Added, #1: 1	تَخَلُّفَ الْمُرَادِ
u'تَخَلُّفٌ مِلْكٌ':Added, #4: 4	تَخَلُّفُ الْمَعْلُولِ
u'تَخَلُّفٌ مُوَافِقٌ':Added, #1: 1	تَخَلُّفِ الْمِلْكِ
u'تَخَلَّفَ نُطْقٌ':Subject, #1: 1	تَخَلُّفِ الْمُوَافِقِ
u'تَخَلَّفَ واحد':Subject, #1: 1	تَخَلَّفَ النُّطْقُ
u'تَخَلَّفَ وَاحِدٌ':Subject, #1: 1	تَخَلَّفَ وَاحِدٌ
u'تَخَلُّفٌ وُجُوبٌ':Added, #1: 1	تَخَلَّفَ وَاحِدٌ
u'تَخَلُّفٌ وَعِيدٌ':Added, #1: 1	تَخَلُّفُ الْوُجُوبِ
u'تَخَلُّقٌ إِنْسانٌ':Added, #1: 1	تَخَلُّفُ الْوَعِيدِ
u'تَخَلُّقٌ غَلَّةٌ':Added, #1: 1	تَخَلُّقُ الْإِنْسَانِ
u'تَخَلُّقٌ مَوْلُودٌ':Added, #1: 1	تَخَلُّقِ الْغَلَّةِ
u'تَخَلَّلَ أَبٌ':Subject, #1: 1	تَخَلُّقُ الْمَوْلُودِ
u'تَخَلُّلٌ اِخْتِيَارٌ':Added, #1: 1	تَخَلَّلَ أَبٌ
u'تَخَلُّلٌ أَصابِعُ':Added, #1: 1	تَخَلُّلِ اخْتِيَارِ
u'تَخَلَّلَ اِطِّلاعٌ':Subject, #1: 1	تَخَلُّلُ أَصَابِعِ
u'تَخَلُّلٌ إِفْطارٌ':Added, #1: 1	تَخَلَّلَ اطِّلَاعٌ
u'تَخَلُّلٌ أُمٌّ':Added, #1: 1	تَخَلُّلِ إفْطَارِ
u'تَخَلُّلٌ إِيجَابٌ':Added, #1: 1	تَخَلُّلَ الْأُمِّ
u'تَخَلَّلَ بَرْء':Subject, #1: 1	تَخَلُّلِ الْإِيجَابِ
u'تَخَلَّلَ بُرْء':Subject, #3: 3	تَخَلَّلَ الْبَرْءُ
u'تَخَلُّلٌ بَرْء':Added, #4: 4	تَخَلَّلَ الْبُرْءُ
u'تَخَلُّلٌ بُرْء':Added, #1: 1	تَخَلُّلِ الْبَرْءِ
u'تَخَلُّلٌ بُرْء':Added, #1: 1	تَخَلُّلُ الْبُرْءِ
u'تَخَلَّلَ بَيْنٌ':Predicate, #5: 5	تَخَلُّلِ الْبُرْءِ
u'تَخَلَّلَ تَزَوُّجٌ':Predicate, #18: 18	تَخَلَّلَ بَيْنَ
u'تَخَلَّلَ تَقَطُّعٌ':Subject, #1: 1	تَخَلَّلَ التَّزَوُّجَ
u'تَخَلَّلَ ثَالِثٌ':Predicate, #1: 1	تَخَلَّلَ تَقَطُّعٌ
u'تَخَلَّلَ ثَالِثٌ':Subject, #1: 1	تَخَلَّلَ الثَّالِثَ
u'تَخَلَّلَ جَزَاءٌ':Subject, #6: 6	تَخَلَّلَ ثَالِثٌ
u'تَخَلَّلَ حَدَثٌ':Subject, #1: 1	تَخَلَّلَ الْجَزَاءُ
u'تَخَلُّلٌ حَدَثٌ':Added, #1: 1	تَخَلَّلَ حَدَثٌ
u'تَخَلُّلٌ حَرْفٌ':Added, #1: 1	تَخَلُّلُ الْحَدَثِ
u'تَخَلُّلٌ حُمْرَةٌ':Added, #1: 1	تَخَلُّلُ حَرْفِ
u'تَخَلُّلٌ حَيْضٌ':Added, #1: 1	تَخَلُّلِ الْحُمْرَةِ
u'تَخَلُّلٌ حَيْضٌ':Added, #1: 1	تَخَلُّلَ الْحَيْضِ
u'تَخَلَّلَ خَمْرٌ':Subject, #1: 1	تَخَلُّلِ حَيْضٍ
u'تَخَلُّلٌ خَمْرٌ':Added, #3: 3	تَخَلَّلَ الْخَمْرُ
u'تَخَلَّلَ ذِكْرٌ':Subject, #2: 2	تَخَلُّلِ الْخَمْرِ
u'تَخَلُّلٌ رجعة':Added, #1: 1	تَخَلَّلَ ذِكْرٌ
u'تَخَلُّلٌ رجعة':Added, #1: 1	تَخَلُّلُ الرَّجْعَةِ
u'تَخَلُّلٌ رَجْعَةٌ':Added, #1: 1	تَخَلُّلِ الرَّجْعَةِ
u'تَخَلُّلٌ رَجْعَةٌ':Added, #1: 1	تَخَلُّلُ الرَّجْعَةِ
u'تَخَلَّلَ رَجُلٌ':Subject, #1: 1	تَخَلُّلِ الرَّجْعَةِ
u'تَخَلُّلٌ رِدَّةٌ':Added, #1: 1	تَخَلَّلَ الرَّجُلُ
u'تَخَلَّلَ زَمَنٌ':Subject, #2: 2	تَخَلُّلُ الرِّدَّةِ
u'تَخَلُّلٌ زَوالٌ':Added, #1: 1	تَخَلَّلَ زَمَنٌ
u'تَخَلُّلٌ سَكَت':Added, #1: 1	تَخَلُّلُ زَوَالِ
u'تَخَلُّلٌ سكتة':Added, #1: 1	تَخَلُّلَ السَّكَتَاتِ
u'تَخَلُّلٌ سَكْتَةٌ':Added, #1: 1	تَخَلُّلُ سَكْتَةٍ
u'تَخَلَّلَ شَرْطٌ':Subject, #1: 1	تَخَلُّلُ سَكْتَةٍ
u'تَخَلُّلٌ صُفْرَةٌ':Added, #1: 1	تَخَلَّلَ الشَّرْطُ
u'تَخَلُّلٌ صَلاَةٌ':Added, #2: 2	تَخَلُّلِ الصُّفْرَةِ
u'تَخَلَّلَ صَوْمٌ':Predicate, #1: 1	تَخَلُّلِ صَلَاةِ
u'تَخَلَّلَ طَلاَقٌ':Subject, #1: 1	تَخَلَّلَ صَوْمَ
u'تَخَلُّلٌ طَلاَقٌ':Added, #1: 1	تَخَلَّلَ الطَّلَاقُ
u'تَخَلَّلَ طهر':Predicate, #1: 1	تَخَلُّلُ الطَّلَاقِ
u'تَخَلَّلَ عَادٌ':Predicate, #3: 3	تَخَلَّلَ طَهُرَ
u'تَخَلُّلٌ عَاطِفٌ':Added, #3: 3	تَخَلَّلَ عَادَ
u'تَخَلَّلَ غَصْبٌ':Subject, #1: 1	تَخَلُّلَ الْعَاطِفِ
u'تَخَلَّلَ غير':Subject, #1: 1	تَخَلَّلَ الْغَصْبُ
u'تَخَلَّلَ غَيْرٌ':Subject, #1: 1	تَخَلَّلَ غَيْرُ
u'تَخَلُّلٌ فَصْلٌ':Added, #1: 1	تَخَلَّلَ غَيْرُ
u'تَخَلُّلٌ فَصْلٌ':Added, #1: 1	تَخَلُّلِ الْفَصْلِ
u'تَخَلَّلَ فِطْرٌ':Subject, #1: 1	تَخَلُّلُ فَصْلٍ
u'تَخَلُّلٌ فِطْرٌ':Added, #1: 1	تَخَلَّلَ الْفِطْرُ
u'تَخَلُّلٌ فِطْرٌ':Added, #1: 1	تَخَلُّلُ فِطْرِهِ
u'تَخَلَّلَ فِعْلٌ':Subject, #2: 2	تَخَلُّلُ الْفِطْرِ
u'تَخَلُّلٌ فِعْلٌ':Added, #1: 1	تَخَلَّلَ فِعْلُ
u'تَخَلُّلٌ قَاطِعٌ':Added, #1: 1	تَخَلُّلَ فِعْلِ
u'تَخَلَّلَ كَلاَمٌ':Subject, #1: 1	تَخَلُّلِ الْقَاطِعِ
u'تَخَلُّلٌ كَلاَمٌ':Added, #2: 2	تَخَلَّلَ كَلَامٌ
u'تَخَلُّلٌ كَلاَمٌ':Added, #1: 1	تَخَلُّلِ الْكَلَامِ
u'تَخَلُّلٌ مُدَّةٌ':Added, #2: 2	تَخَلُّلَ الْكَلَامِ
u'تَخَلُّلٌ نَارٌ':Added, #1: 1	تَخَلُّلِ مُدَّةٍ
u'تَخَلُّلٌ نَحْوٌ':Added, #1: 1	تَخَلُّلَ النَّارِ
u'تَخَلَّلَ نكاح':Subject, #1: 1	تَخَلُّلُ نَحْوِ
u'تَخَلَّلَ نِكَاحٌ':Subject, #1: 1	تَخَلَّلَ النِّكَاحُ
u'تَخَلُّلٌ يَوْمٌ':Added, #1: 1	تَخَلَّلَ النِّكَاحُ
u'تَخْلِيدٌ حَبْسٌ':Added, #1: 1	تَخَلُّلِ يَوْمِ
u'تَخْلِيدٌ قِيمَةٌ':Added, #1: 1	تَخْلِيدِ حَبْسِهِ
u'تَخْلِيدٌ كُفَّارٌ':Added, #1: 1	تَخْلِيدُ الْقِيمَةِ
u'تَخْلِيدٌ كُفَّارٌ':Added, #1: 1	تَخْلِيدِ الْكُفَّارِ
u'تَخْلِيصٌ أحْمَالٌ':Added, #2: 2	تَخْلِيدُ الْكُفَّارِ
u'تَخْلِيصٌ أحْمَالٌ':Added, #1: 1	تَخْلِيص الْأَحْمَالِ
u'تَخْلِيصٌ أَحْمَالٌ':Added, #1: 1	تَخْلِيصِ الْأَحْمَالِ
u'تَخْلِيصٌ أَحْمَالٌ':Added, #1: 1	تَخْلِيص الْأَحْمَالِ
u'تَخْلِيصٌ آدَمِيٌّ':Added, #1: 1	تَخْلِيصِ الْأَحْمَالِ
u'تَخْلِيصٌ بَعْضٌ':Added, #1: 1	تَخْلِيصَ الْآدَمِيِّ
u'تَخْلِيصٌ تَلْخيصٌ':Added, #2: 2	تَخْلِيصُ بَعْضِهِ
u'تَخْلِيصٌ جَوْهَرٌ':Added, #5: 5	تَخْلِيصِ التَّلْخِيصِ
u'تَخْلِيصٌ حَقٌّ':Added, #1: 1	تَخْلِيصُ الْجَوْهَرِ
u'تَخْلِيصٌ حَقٌّ':Added, #1: 1	تَخْلِيصِ حَقِّ
u'تَخْلِيصٌ حَقٌّ':Added, #1: 1	تَخْلِيصِ حَقِّهِ
u'تَخْلِيصٌ حَقٌّ':Added, #2: 2	تَخْلِيصُ الْحَقِّ
u'تَخْلِيصٌ رَقَبَةٌ':Added, #2: 2	تَخْلِيصُ حَقِّ
u'تَخْلِيصٌ رَقَبَةٌ':Added, #1: 1	تَخْلِيصُ رَقَبَةٍ
u'تَخْلِيصٌ رَقَبَةٌ':Added, #1: 1	تَخْلِيصِ رَقَبَةٍ
u'تَخْلِيصٌ رَقَبَةٌ':Added, #2: 2	تَخْلِيصِ رَقَبَتِهِ
u'تَخْلِيصٌ شَخْصٌ':Added, #3: 3	تَخْلِيصُ الرَّقَبَةِ
u'تَخْلِيصٌ شَرِيكٌ':Added, #1: 1	تَخْلِيصُ الشَّخْصِ
u'تَخْلِيصٌ طَرِيقٌ':Added, #1: 1	تَخْلِيصُ شَرِيكِهِ
u'تَخْلِيصٌ ظالِمٌ':Added, #1: 1	تَخْلِيصِ الطَّرِيقَتَيْنِ
u'تَخْلِيصٌ عَبْدٌ':Added, #1: 1	تَخْلِيصِ الظَّالِمِ
u'تَخْلِيصٌ عِصْمَةٌ':Added, #1: 1	تَخْلِيصِ الْعَبْدِ
u'تَخْلِيصٌ عِلَّةٌ':Added, #1: 1	تَخْلِيصَ الْعِصْمَةِ
u'تَخْلِيصٌ قُرْبٌ':Added, #1: 1	تَخْلِيصِ الْعِلَّةِ
u'تَخْلِيصٌ قول':Added, #1: 1	تَخْلِيصَ الْقُرْبِ
u'تَخْلِيصٌ قَوْلٌ':Added, #1: 1	تَخْلِيصَ الْقَوْلِ
u'تَخْلِيصٌ كَسْبٌ':Added, #1: 1	تَخْلِيصَ الْقَوْلِ
u'تَخْلِيصٌ كَلاَمٌ':Added, #1: 1	تَخْلِيصِ كَسْبِهِ
u'تَخْلِيصٌ مَبِيعٌ':Added, #1: 1	تَخْلِيصُ الْكَلَامِ
u'تَخْلِيصٌ مَبِيعٌ':Added, #2: 2	تَخْلِيصِ الْمَبِيعِ
u'تَخْلِيصٌ مَبِيعٌ':Added, #3: 3	تَخْلِيصَ الْمَبِيعِ
u'تَخْلِيصٌ مَتَاعٌ':Added, #3: 3	تَخْلِيصُ الْمَبِيعِ
u'تَخْلِيصٌ مَتَاعٌ':Added, #1: 1	تَخْلِيصَ مَتَاعِ
u'تَخْلِيصٌ مُسْتَهْلَكٌ':Added, #2: 2	تَخْلِيصِ الْمَتَاعِ
u'تَخْلِيصٌ مُسْتَهْلَكٌ':Added, #1: 1	تَخْلِيصَ الْمُسْتَهْلَكِ
u'تَخْلِيصٌ مُسْلِمٌ':Added, #2: 2	تَخْلِيصِ مُسْتَهْلَكٍ
u'تَخْلِيصٌ مَظْلُومٌ':Added, #7: 7	تَخْلِيصَ الْمُسْلِمِ
u'تَخْلِيصٌ مِلْكٌ':Added, #1: 1	تَخْلِيصِ الْمَظْلُومِ
u'تَخْلِيصٌ نَاسٌ':Added, #6: 6	تَخْلِيصِ مِلْكِهِ
u'تَخْلِيصٌ نَفْسٌ':Added, #1: 1	تَخْلِيصِ النَّاسِ
u'تَخْلِيصٌ واحد':Added, #1: 1	تَخْلِيصِ نَفْسِهِ
u'تَخْلِيصٌ وَاحِدٌ':Added, #1: 1	تَخْلِيصِ وَاحِدٍ
u'تَخْلِيصٌ واحد':Added, #1: 1	تَخْلِيصِ وَاحِدٍ
u'تَخْلِيصٌ وَاحِدٌ':Added, #1: 1	تَخْلِيصُ وَاحِدَةٍ
u'تَخْلِيصٌ وَقْتٌ':Added, #1: 1	تَخْلِيصُ وَاحِدَةٍ
u'تَخْلِيصٌ يَدٌ':Added, #2: 2	تَخْلِيصُ الْوَقْتِ
u'تَخْلِيطٌ طَبِيبٌ':Added, #1: 1	تَخْلِيصِ الْيَدِ
u'تَخْلِيطٌ كَلاَمٌ':Added, #1: 1	تَخْلِيطِ الطَّبِيبِ
u'تَخَمَّرَ عَصِيرٌ':Subject, #1: 1	تَخْلِيطُ كَلَامِهِ
u'تَخَمَّرَ عَصِيرٌ':Subject, #1: 1	تَخَمَّرَ عَصِيرُ
u'تَخَمَّرَ عَصِيرٌ':Subject, #2: 2	تَخَمَّرَ عَصِيرٌ
u'تَخَمُّرٌ عَصِيرٌ':Added, #5: 5	تَخَمَّرَ الْعَصِيرُ
u'تَخَمَّرَ مَرْهُونٌ':Subject, #1: 1	تَخَمُّرَ الْعَصِيرِ
u'تَخْمِينٌ قَدْرٌ':Added, #1: 1	تَخَمَّرَ الْمَرْهُونُ
u'تَخْمِينٌ قَدْرٌ':Added, #1: 1	تَخْمِينَ الْقَدْرِ
u'تَخْمِينٌ قَدْرٌ':Added, #1: 1	تَخْمِينُ الْقَدْرِ
u'تَخْمِينٌ قَدْرٌ':Added, #1: 1	تَخْمِينِ الْقَدْرِ
u'تَخْمِينٌ مِقْدَارٌ':Added, #1: 1	تَخْمِينِ قَدْرِ
u'تَخَوُّفٌ طُرُقٌ':Added, #1: 1	تَخْمِينِ مِقْدَارِهِ
u'تَخْوِيفٌ زَوْجَةٌ':Added, #1: 1	تَخَوُّفِ الطُّرُقِ
u'تَخْوِيفٌ غير':Added, #1: 1	تَخْوِيفَ زَوْجَتِهِ
u'تَخْوِيفٌ غَيْرٌ':Added, #1: 1	تَخْوِيفَ غَيْرِهِ
u'تَخْوِيفٌ نَاجِزٌ':Added, #1: 1	تَخْوِيفَ غَيْرِهِ
u'تَخَيُّرٌ اِجْتِهَادٌ':Added, #1: 1	تَخْوِيفٍ نَاجِزٍ
u'تَخَيَّرَ إمَامٌ':Subject, #1: 1	تَخَيُّرَ اجْتِهَادٍ
u'تَخَيَّرَ بَائِعٌ':Subject, #2: 2	تَخَيَّرَ الْإِمَامُ
u'تَخَيَّرَ بَيْنٌ':Predicate, #2: 2	تَخَيَّرَ الْبَائِعُ
u'تَخَيَّرَ دَافِعٌ':Subject, #12: 12	تَخَيَّرَ بَيْنَ
u'تَخَيَّرَ شَرِيكٌ':Subject, #1: 1	تَخَيَّرَ الدَّافِعُ
u'تَخَيَّرَ شَفِيعٌ':Subject, #1: 1	تَخَيَّرَ الشَّرِيكُ
u'تَخَيُّرٌ صَاحِبٌ':Added, #1: 1	تَخَيَّرَ الشَّفِيعُ
u'تَخَيَّرَ عَبْدٌ':Subject, #1: 1	تَخَيُّرِ صَاحِبِ
u'تَخَيَّرَ قَالٌ':Predicate, #1: 1	تَخَيَّرَ الْعَبْدُ
u'تَخَيَّرَ مَالِكٌ':Subject, #1: 1	تَخَيَّرَ قَالَ
u'تَخَيَّرَ مُجْتَهِد':Subject, #1: 1	تَخَيَّرَ الْمَالِكُ
u'تَخَيَّرَ مُسْتَأْجِرٌ':Subject, #2: 2	تَخَيَّرَ الْمُجْتَهِدُ
u'تَخَيَّرَ واحد':Predicate, #2: 2	تَخَيَّرَ الْمُسْتَأْجِرُ
u'تَخَيَّرَ وَاحِدٌ':Predicate, #2: 2	تَخَيَّرَ وَاحِدَةً
u'تَخَيَّرَ وَارِثٌ':Subject, #2: 2	تَخَيَّرَ وَاحِدَةً
u'تَخَيَّرَ وَارِثٌ':Subject, #1: 1	تَخَيَّرَ وَارِثُهُ
u'تَخَيَّرَ وَصِيٌّ':Subject, #2: 2	تَخَيَّرَ الْوَارِثُ
u'تَخَيَّلَ حاذِقٌ':Subject, #1: 1	تَخَيَّرَ الْوَصِيُّ
u'تَخَيَّلَ خِلاَفٌ':Predicate, #1: 1	تَخَيَّلَ حَاذِقٌ
u'تَخَيُّلٌ عَفْوٌ':Added, #1: 1	تَخَيَّلَ خِلَافَ
u'تَخَيُّلٌ عُمُومٌ':Added, #1: 1	تَخَيُّلِ الْعَفْوِ
u'تَخَيُّلٌ لَفْظٌ':Added, #1: 1	تَخَيُّلُ الْعُمُومِ
u'تَخَيَّلَ وَاسِطٌ':Predicate, #1: 1	تَخَيُّلَ اللَّفْظِ
u'تَخَيُّلٌ وَحَدٌ':Added, #1: 1	تَخَيَّلَ وَاسِطَةً
u'تَخْيِيرٌ إمَامٌ':Added, #3: 3	تَخَيُّلِ الْوَحَدَاتِ
u'تَخْيِيرٌ بادِئٌ':Added, #4: 4	تَخْيِيرِ الْإِمَامِ
u'تَخْيِيرٌ تَفْوِيضٌ':Added, #1: 1	تَخْيِيرُ الْبَادِئِ
u'تَخْيِيرٌ ثَمَنٌ':Added, #1: 1	تَخْيِيرُ التَّفْوِيضِ
u'تَخْيِيرٌ ثَيِّبٌ':Added, #1: 1	تَخْيِيرِ الثَّمَنِ
u'تَخْيِيرٌ حاكِمٌ':Added, #2: 2	تَخْيِيرُ الثَّيِّبِ
u'تَخْيِيرٌ رَاهِنٌ':Added, #1: 1	تَخْيِيرُ الْحَاكِمِ
u'تَخْيِيرٌ رَجُلٌ':Added, #1: 1	تَخْيِيرُ الرَّاهِنِ
u'تَخْيِيرٌ زَوْجٌ':Added, #1: 1	تَخْيِيرِ الرَّجُلِ
u'تَخْيِيرٌ زَوْجٌ':Added, #1: 1	تَخْيِيرُ الزَّوْجِ
u'تَخْيِيرٌ شَاهِدٌ':Added, #6: 6	تَخْيِيرِ الزَّوْجِ
u'تَخْيِيرٌ شَرِيكٌ':Added, #1: 1	تَخْيِيرِ الشَّاهِدِ
u'تَخْيِيرٌ شَفِيعٌ':Added, #1: 1	تَخْيِيرِ الشَّرِيكِ
u'تَخْيِيرٌ شَفِيعٌ':Added, #1: 1	تَخْيِيرُ الشَّفِيعِ
u'تَخْيِيرٌ صَبِيٌّ':Added, #1: 1	تَخْيِيرِ الشَّفِيعِ
u'تَخْيِيرٌ عَامِّيٌّ':Added, #1: 1	تَخْيِيرِ الصَّبِيِّ
u'تَخْيِيرٌ عَبْدٌ':Added, #1: 1	تَخْيِيرَ الْعَامِّيِّ
u'تَخْيِيرٌ غُلاَمٌ':Added, #1: 1	تَخْيِيرِ الْعَبْدِ
u'تَخْيِيرٌ فَاعِلٌ':Added, #1: 1	تَخْيِيرُ الْغُلَامِ
u'تَخْيِيرٌ قَادِرٌ':Added, #1: 1	تَخْيِيرُ الْفَاعِلِ
u'تَخْيِيرٌ مَالِكٌ':Added, #1: 1	تَخْيِيرِ الْقَادِرِ
u'تَخْيِيرٌ مَالِكٌ':Added, #1: 1	تَخْيِيرَ الْمَالِكِ
u'تَخْيِيرٌ مَأْمُورٌ':Added, #1: 1	تَخْيِيرِ الْمَالِكِ
u'تَخْيِيرٌ مُصَنِّفٌ':Added, #1: 1	تَخْيِيرُ الْمَأْمُورِ
u'تَخْيِيرٌ مُطْلَقٌ':Added, #1: 1	تَخْيِيرِ الْمُصَنِّفِ
u'تَخْيِيرٌ مُكَلَّفٌ':Added, #2: 2	تَخْيِيرٍ مُطْلَقٍ
u'تَخْيِيرٌ مُؤَجِّرٌ':Added, #1: 1	تَخْيِيرَ الْمُكَلَّفِ
u'تَخْيِيرٌ نَبِيٌّ':Added, #1: 1	تَخْيِيرَ الْمُؤَجِّرِ
u'تَخْيِيرٌ نِساءٌ':Added, #4: 4	تَخْيِيرِ النَّبِيِّ
u'تَخْيِيرٌ نِساءٌ':Added, #1: 1	تَخْيِيرُ النِّسَاءِ
u'تَدَاخُلٌ إِحْرَامٌ':Added, #1: 1	تَخْيِيرِ النِّسَاءِ
u'تَدَاخُلٌ أَعْمَالٌ':Added, #1: 1	تَدَاخُلُ الْإِحْرَامَيْنِ
u'تَدَاخُلٌ بَعْضٌ':Added, #1: 1	تَدَاخُلِ الْأَعْمَالِ
u'تَدَاخَلَ جِنْسٌ':Subject, #1: 1	تَدَاخُلُ بَعْضِ
u'تَدَاخُلٌ حَدَثٌ':Added, #1: 1	تَدَاخَلَ الْجِنْسُ
u'تَدَاخُلٌ حقائق':Added, #1: 1	تَدَاخُلِ الْحَدَثِ
u'تَدَاخُلٌ حَقَائِقُ':Added, #1: 1	تَدَاخُلُ الْحَقَائِقِ
u'تَدَاخُلٌ صِفَةٌ':Added, #1: 1	تَدَاخُلُ الْحَقَائِقِ
u'تَدَاخُلٌ عِدٌّ':Added, #2: 2	تَدَاخُلِ الصِّفَاتِ
u'تَدَاخُلٌ عِدٌّ':Added, #1: 1	تَدَاخُلَ الْعِدَّتَيْنِ
u'تَدَاخُلٌ عِدٌّ':Added, #1: 1	تَدَاخُلِ الْعِدَّتَيْنِ
u'تَدَاخُلٌ غير':Added, #2: 2	تَدَاخُلُ الْعِدَّتَيْنِ
u'تَدَاخُلٌ غَيْرٌ':Added, #1: 1	تَدَاخُلِ غَيْرِ
u'تَدَاخُلٌ فِدْيَةٌ':Added, #1: 1	تَدَاخُلِ غَيْرِ
u'تَدَاخُلٌ لُغَةٌ':Added, #2: 2	تَدَاخُلِ الْفِدْيَةِ
u'تَدَاخَلَ مَهْرٌ':Subject, #1: 1	تَدَاخُلِ اللُّغَاتِ
u'تَدَاخُلٌ نَجَاسَةٌ':Added, #1: 1	تَدَاخَلَ الْمَهْرُ
u'تَدَاخُلٌ وَقْتٌ':Added, #1: 1	تَدَاخُلِ النَّجَاسَةِ
u'تَدَارُكٌ أَخِيرٌ':Added, #1: 1	تَدَاخُلِ الْوَقْتَيْنِ
u'تَدَارُكٌ أصل':Added, #1: 1	تَدَارُكَ الْأَخِيرَةِ
u'تَدَارُكٌ أًصْلٌ':Added, #1: 1	تَدَارُكِ أَصْلِ
u'تَدَارُكٌ إِصْلاحٌ':Added, #1: 1	تَدَارُكِ أَصْلِ
u'تَدَارَكَ اِغْتِرَافٌ':Predicate, #1: 1	تَدَارُكِ إصْلَاحِ
u'تَدَارُكٌ ثَلاثَةٌ':Added, #1: 1	تَدَارَكَ اغْتِرَافَ
u'تَدَارُكٌ حَيَاةٌ':Added, #1: 1	تَدَارُكِ الثَّلَاثَةِ
u'تَدَارُكٌ خَلَلٌ':Added, #1: 1	تَدَارُكُ حَيَاةِ
u'تَدَارُكٌ دفع':Added, #2: 2	تَدَارُكُ الْخَلَلِ
u'تَدَارُكٌ دَفْعٌ':Added, #2: 2	تَدَارُكِ دَفْعِ
u'تَدَارُكٌ عَيْبٌ':Added, #2: 2	تَدَارُكِ دَفْعِ
u'تَدَارُكٌ غَرْفٌ':Added, #1: 1	تَدَارُكُ الْعَيْبِ
u'تَدَارُكٌ غَلَطٌ':Added, #1: 1	تَدَارُكِ الْغَرْفِ
u'تَدَارُكٌ فَارِطٌ':Added, #1: 1	تَدَارُكُ الْغَلَطِ
u'تَدَارَكَ مَتْرُوكٌ':Predicate, #1: 1	تَدَارُكِ الْفَارِطِ
u'تَدَارُكٌ مَتْرُوكٌ':Added, #3: 3	تَدَارَكَ الْمَتْرُوكَ
u'تَدَاعَى أهْلٌ':Subject, #1: 1	تَدَارُكُ الْمَتْرُوكِ
u'تَدَاعَى رَجُلٌ':Subject, #1: 1	تَدَاعَى أَهْلُ
u'تَدَاعَى سَائِرٌ':Subject, #1: 1	تَدَاعَى رَجُلٌ
u'تَدَاعَى سَائِرٌ':Subject, #1: 1	تَدَاعَى سَائِرُ
u'تَدَاعَى ولد':Predicate, #3: 3	تَدَاعَى سَائِرُهُ
u'تَدَاعَى وَلَدٌ':Predicate, #1: 1	تَدَاعَى وَلَدَ
u'تَدَافُعٌ كَلام':Added, #1: 1	تَدَاعَى وَلَدَ
u'تَدَانِي قَدَمٌ':Added, #1: 1	تَدَافُعُ الْكَلَامَيْنِ
u'تَدَاوَلَ نَاسٌ':Subject, #1: 1	تَدَانِي الْقَدَمَيْنِ
u'تَدَبُّرٌ قُرْآنٌ':Added, #1: 1	تَدَاوَلَ النَّاسُ
u'تَدَبَّرَ كَلاَمٌ':Predicate, #1: 1	تَدَبُّرِ الْقُرْآنِ
u'تَدْبِيرٌ أقَالِيمُ':Added, #1: 1	تَدَبَّرَ الْكَلَامَ
u'تَدْبِيرٌ أُمٌّ':Added, #1: 1	تَدْبِيرَ الْأَقَالِيمِ
u'تَدْبِيرٌ أُمَّةٌ':Added, #3: 3	تَدْبِيرِ الْأُمِّ
u'تَدْبِيرٌ أُمَّةٌ':Added, #1: 1	تَدْبِيرَ الْأُمَّةِ
u'تَدْبِيرٌ أُمُورٌ':Added, #1: 1	تَدْبِيرِ الْأُمَّةِ
u'تَدْبِيرٌ أُمُورٌ':Added, #1: 1	تَدْبِيرِ الْأُمُورِ
u'تَدْبِيرٌ أَوَّلُ':Added, #2: 2	تَدْبِيرَ الْأُمُورِ
u'تَدْبِيرٌ بدن':Added, #2: 2	تَدْبِيرِ الْأَوَّلِ
u'تَدْبِيرٌ بَدَنٌ':Added, #1: 1	تَدْبِيرِ الْبَدَنِ
u'تَدْبِيرٌ بَرِّيٌّ':Added, #1: 1	تَدْبِيرِ الْبَدَنِ
u'تَدْبِيرٌ بَرِّيَّةٌ':Added, #1: 1	تَدْبِيرِ الْبَرِّيَّةِ
u'تَدْبِيرٌ جَيْشٌ':Added, #1: 1	تَدْبِيرِ الْبَرِّيَّةِ
u'تَدْبِيرٌ جُيوشٌ':Added, #1: 1	تَدْبِيرِ الْجَيْشِ
u'تَدْبِيرٌ حَرْبٌ':Added, #1: 1	تَدْبِيرِ الْجُيُوشِ
u'تَدْبِيرٌ حَرْبٌ':Added, #1: 1	تَدْبِيرُ الْحَرْبِ
u'تَدْبِيرٌ حُروبٌ':Added, #4: 4	تَدْبِيرِ الْحَرْبِ
u'تَدْبِيرٌ حِلْمٌ':Added, #1: 1	تَدْبِيرُ الْحُرُوبِ
u'تَدْبِيرٌ حَمْلٌ':Added, #1: 1	تَدْبِيرِ الْحِلْمِ
u'تَدْبِيرٌ حَمْلٌ':Added, #1: 1	تَدْبِيرَ الْحَمْلِ
u'تَدْبِيرٌ دَابَّةٌ':Added, #1: 1	تَدْبِيرُ الْحَمْلِ
u'تَدْبِيرٌ رَقَبَةٌ':Added, #1: 1	تَدْبِيرَ الدَّابَّةِ
u'تَدْبِيرٌ سَكْرَان':Added, #2: 2	تَدْبِيرُ رَقَبَةٍ
u'تَدْبِيرٌ صَبِيٌّ':Added, #1: 1	تَدْبِيرُ السَّكْرَانِ
u'تَدْبِيرٌ صَبِيٌّ':Added, #1: 1	تَدْبِيرَ الصَّبِيِّ
u'تَدْبِيرٌ صَبِيٌّ':Added, #1: 1	تَدْبِيرُ الصَّبِيِّ
u'تَدْبِيرٌ صِحَّةٌ':Added, #1: 1	تَدْبِيرُ صَبِيٍّ
u'تَدْبِيرٌ صَحِيحٌ':Added, #1: 1	تَدْبِيرَ الصِّحَّةِ
u'تَدْبِيرٌ عَامِرٌ':Added, #1: 1	تَدْبِيرَ الصَّحِيحِ
u'تَدْبِيرٌ عَبْدٌ':Added, #1: 1	تَدْبِيرُ عَامِرٍ
u'تَدْبِيرٌ عَبْدٌ':Added, #1: 1	تَدْبِيرُ الْعَبْدِ
u'تَدْبِيرٌ غِذَاءٌ':Added, #1: 1	تَدْبِيرِ الْعَبْدِ
u'تَدْبِيرٌ غُلاَمٌ':Added, #1: 1	تَدْبِيرِ الْغِذَاءِ
u'تَدْبِيرٌ فُلاَنٌ':Added, #1: 1	تَدْبِيرُ الْغُلَامِ
u'تَدْبِيرٌ قول':Added, #1: 1	تَدْبِيرِ فُلَانٍ
u'تَدْبِيرٌ قَوْلٌ':Added, #1: 1	تَدْبِيرُ الْقَوْلِ
u'تَدْبِيرٌ كَافِرٌ':Added, #1: 1	تَدْبِيرُ الْقَوْلِ
u'تَدْبِيرٌ كَافِرٌ':Added, #1: 1	تَدْبِيرُ كَافِرٍ
u'تَدْبِيرٌ كَوَاكِبُ':Added, #2: 2	تَدْبِيرُ الْكَافِرِ
u'تَدْبِيرٌ مَحَلَّةٌ':Added, #2: 2	تَدْبِيرِ الْكَوَاكِبِ
u'تَدْبِيرٌ مُدَبَّرٌ':Added, #1: 1	تَدْبِيرَ الْمَحَلَّةِ
u'تَدْبِيرٌ مُدَبَّرٌ':Added, #1: 1	تَدْبِيرَ الْمُدَبَّرِ
u'تَدْبِيرٌ مُدَبِّرٌ':Added, #2: 2	تَدْبِيرِ الْمُدَبَّرِ
u'تَدْبِيرٌ مُدَبَّرٌ':Added, #2: 2	تَدْبِيرِ الْمُدَبِّرِ
u'تَدْبِيرٌ مَشَايِخُ':Added, #3: 3	تَدْبِيرُ الْمُدَبَّرِ
u'تَدْبِيرٌ مُكَاتَبَةٌ':Added, #1: 1	تَدْبِيرِ الْمَشَايِخِ
u'تَدْبِيرٌ مُكْرَهٌ':Added, #1: 1	تَدْبِيرُ الْمُكَاتَبَةِ
u'تَدْبِيرٌ مَنَازِلُ':Added, #1: 1	تَدْبِيرُ الْمُكْرَهِ
u'تَدْبِيرٌ مَنَازِلُ':Added, #1: 1	تَدْبِيرَ الْمَنَازِلِ
u'تَدْبِيرٌ مَوْجُودٌ':Added, #1: 1	تَدْبِيرِ الْمَنَازِلِ
u'تَدْبِيرٌ نَصْرَانِيٌّ':Added, #1: 1	تَدْبِيرٍ مَوْجُودٍ
u'تَدْبِيرٌ نَصِيبٌ':Added, #1: 1	تَدْبِيرُ نَصْرَانِيٍّ
u'تَدْبِيرٌ نُطْفَةٌ':Added, #1: 1	تَدْبِيرَ نَصِيبِهِ
u'تَدْبِيرٌ نَفْسٌ':Added, #1: 1	تَدْبِيرُ النُّطْفَةِ
u'تَدْبِيرٌ واحد':Added, #1: 1	تَدْبِيرِ نَفْسِهِ
u'تَدْبِيرٌ وَاحِدٌ':Added, #1: 1	تَدْبِيرِ وَاحِدٍ
u'تَدَحْرَجَ إِناءٌ':Subject, #1: 1	تَدْبِيرِ وَاحِدٍ
u'تَدْخِينٌ زَنابيرُ':Added, #1: 1	تَدَحْرَجَ إنَاءٌ
u'تَدْخِينٌ زَنابيرُ':Added, #1: 1	تَدْخِينَ الزَّنَابِيرِ
u'تَدَرَّعَ لَيْلٌ':Predicate, #1: 1	تَدْخِينُ الزَّنَابِيرِ
u'تَدْرِيبٌ شَيْخٌ':Added, #1: 1	تَدَرَّعَ اللَّيْلَ
u'تَدْرِيبٌ صَبِيٌّ':Added, #1: 1	تَدْرِيبِ شَيْخِهِ
u'تَدْرِيجٌ نَظَرٌ':Added, #1: 1	تَدْرِيبُ الصَّبِيِّ
u'تَدْرِيسٌ شافِعِيّ':Added, #1: 1	تَدْرِيجُ النَّظَرِ
u'تَدْرِيسٌ علم':Added, #1: 1	تَدْرِيسُ الشَّافِعِيِّ
u'تَدْرِيسٌ عِلْمٌ':Added, #1: 1	تَدْرِيسِ الْعِلْمِ
u'تَدْرِيسٌ فلان':Added, #1: 1	تَدْرِيسِ الْعِلْمِ
u'تَدْرِيسٌ مُعْتَمَدٌ':Added, #1: 1	تَدْرِيسُ الشَّافِعِيِّ
u'تَدَلِّي أَغْصَانٌ':Added, #1: 1	تَدْرِيسُ الْمُعْتَمَدِ
u'تَدَلِّي ثَمَرٌ':Added, #2: 2	تَدَلِّي أَغْصَانِ
u'تَدْوِينٌ أُصولٌ':Added, #1: 1	تَدَلِّي الثَّمَرِ
u'تَدْوِينٌ جَمِيع':Added, #1: 1	تَدْوِينُ أُصُولِ
u'تَدْوِينٌ دَواوينُ':Added, #1: 1	تَدْوِينِ الْجَمِيعِ
u'تَدْوِينٌ دِيوانٌ':Added, #1: 1	تَدْوِينِ الدَّوَاوِينِ
u'تَدْوِينٌ شَرَائِعُ':Added, #1: 1	تَدْوِينِ الدِّيوَانِ
u'تَدْوِينٌ علم':Added, #1: 1	تَدْوِينُ الشَّرَائِعِ
u'تَدْوِينٌ عِلْمٌ':Added, #1: 1	تَدْوِينِ عِلْمِ
u'تَدْوِينٌ فِقْهٌ':Added, #1: 1	تَدْوِينِ عِلْمِ
u'تَدْوِينٌ مَذَاهِبُ':Added, #1: 1	تَدْوِينِ الْفِقْهِ
u'تَدْوِينٌ مَذْهَبٌ':Added, #1: 1	تَدْوِينِ الْمَذَاهِبِ
u'تَذَاكَرَ بَعْضٌ':Subject, #1: 1	تَدْوِينُ مَذْهَبِهِ
u'تَذَاكُرٌ بَعْضٌ':Added, #1: 1	تَذَاكَرَ بَعْضُ
u'تَذَاكَرَ نَاسٌ':Subject, #1: 1	تَذَاكُرَ بَعْضِ
u'تَذْبِيحٌ حِمَارٌ':Added, #1: 1	تَذَاكَرَ النَّاسُ
u'تَذْرِيَةٌ تِبْن':Added, #1: 1	تَذْبِيحَ الْحِمَارِ
u'تَذَكُّرٌ آخِرَةٌ':Added, #1: 1	تَذْرِيَةِ التِّبْنِ
u'تَذَكُّرٌ أمَارَةٌ':Added, #1: 1	تَذَكُّرِ الْآخِرَةِ
u'تَذَكَّرَ إمَامٌ':Subject, #1: 1	تَذَكُّرِ الْأَمَارَةِ
u'تَذَكُّرٌ إمَامٌ':Added, #12: 12	تَذَكَّرَ الْإِمَامُ
u'تَذَكُّرٌ تُرَاثٌ':Added, #1: 1	تَذَكُّرِ الْإِمَامِ
u'تَذَكُّرٌ تَرْتِيبٌ':Added, #1: 1	تَذَكُّرِ تُرَاثِ
u'تَذَكَّرَ تَرْكٌ':Predicate, #1: 1	تَذَكُّرِ التَّرْتِيبِ
u'تَذَكَّرَ تَسْلِيم':Predicate, #3: 3	تَذَكَّرَ تَرْكَ
u'تَذَكَّرَ جَنَابَةٌ':Predicate, #1: 1	تَذَكَّرَ تَسْلِيمَةً
u'تَذَكُّرٌ حادِثٌ':Added, #1: 1	تَذَكَّرَ الْجَنَابَةَ
u'تَذَكُّرٌ حادِثٌ':Added, #1: 1	تَذَكُّرُ الْحَادِثَةِ
u'تَذَكَّرَ حالٌ':Predicate, #1: 1	تَذَكُّرِ الْحَادِثَةِ
u'تَذَكُّرٌ حَدَثٌ':Added, #1: 1	تَذَكَّرَ الْحَالَ
u'تَذَكُّرٌ حَديثٌ':Added, #1: 1	تَذَكُّرِ حَدَثِهِ
u'تَذَكَّرَ خَلِيفَةٌ':Subject, #1: 1	تَذَكُّرِ الْحَدِيثَةِ
u'تَذَكَّرَ رَجُلٌ':Subject, #2: 2	تَذَكَّرَ الْخَلِيفَةُ
u'تَذَكَّرَ سجدة':Predicate, #1: 1	تَذَكَّرَ الرَّجُلُ
u'تَذَكَّرَ سَجْدَةٌ':Predicate, #2: 2	تَذَكَّرَ السَّجْدَةَ
u'تَذَكَّرَ سجدة':Predicate, #2: 2	تَذَكَّرَ السَّجْدَةَ
u'تَذَكَّرَ سَجْدَةٌ':Predicate, #5: 5	تَذَكَّرَ سَجْدَةَ
u'تَذَكُّرٌ شَيْءٌ':Added, #5: 5	تَذَكَّرَ سَجْدَةَ
u'تَذَكُّرٌ صُلْب':Added, #1: 1	تَذَكُّرِ الشَّيْءِ
u'تَذَكُّرٌ صُلْبِيّ':Added, #1: 1	تَذَكُّرِ صُلْبِيَّةٍ
u'تَذَكَّرَ صنعة':Predicate, #1: 1	تَذَكُّرِ صُلْبِيَّةٍ
u'تَذَكَّرَ صَنْعَةٌ':Predicate, #3: 3	تَذَكَّرَ الصَّنْعَةَ
u'تَذَكُّرٌ صنعة':Added, #3: 3	تَذَكَّرَ الصَّنْعَةَ
u'تَذَكُّرٌ صَنْعَةٌ':Added, #1: 1	تَذَكُّرَ الصَّنْعَةِ
u'تَذَكَّرَ ضَمٌّ':Predicate, #1: 1	تَذَكُّرَ الصَّنْعَةِ
u'تَذَكُّرٌ ظَنٌّ':Added, #2: 2	تَذَكَّرَ ضَمَّ
u'تَذَكُّرٌ ظُهْرٌ':Added, #1: 1	تَذَكُّرِ الظَّنِّ
u'تَذَكُّرٌ ظُهْرٌ':Added, #1: 1	تَذَكُّرَ الظُّهْرِ
u'تَذَكُّرٌ ظُهْرٌ':Added, #1: 1	تَذَكُّرُ الظُّهْرِ
u'تَذَكَّرَ عَادٌ':Predicate, #1: 1	تَذَكُّرِ الظُّهْرِ
u'تَذَكَّرَ عِشَاءٌ':Predicate, #3: 3	تَذَكَّرَ عَادَ
u'تَذَكُّرٌ غير':Added, #1: 1	تَذَكَّرَ الْعِشَاءَ
u'تَذَكُّرٌ غَيْرٌ':Added, #1: 1	تَذَكُّرِ غَيْرِ
u'تَذَكَّرَ فَجْرٌ':Predicate, #1: 1	تَذَكُّرِ غَيْرِ
u'تَذَكَّرَ قِرَاءةٌ':Predicate, #2: 2	تَذَكَّرَ الْفَجْرَ
u'تَذَكُّرٌ قَضِيَّةٌ':Added, #1: 1	تَذَكَّرَ قِرَاءَةَ
u'تَذَكَّرَ قُنُوتٌ':Predicate, #1: 1	تَذَكُّرِ الْقَضِيَّةِ
u'تَذَكَّرَ كِتَابَةٌ':Predicate, #2: 2	تَذَكَّرَ الْقُنُوتَ
u'تَذَكَّرَ مَجْلِسٌ':Predicate, #1: 1	تَذَكَّرَ كِتَابَةَ
u'تَذَكُّرٌ مَجْلِسٌ':Added, #1: 1	تَذَكَّرَ الْمَجْلِسَ
u'تَذَكَّرَ مَسْبُوق':Subject, #1: 1	تَذَكُّرُ مَجْلِسِ
u'تَذَكُّرٌ مُصَابٌ':Added, #1: 1	تَذَكَّرَ الْمَسْبُوقُ
u'تَذَكَّرَ مَنْسِيٌّ':Subject, #1: 1	تَذَكُّرُ الْمُصَابِ
u'تَذَكُّرٌ مَوْتٌ':Added, #1: 1	تَذَكَّرَ الْمَنْسِيَّةُ
u'تَذَكُّرٌ مُوجِبٌ':Added, #1: 1	تَذَكُّرِ الْمَوْتِ
u'تَذَكُّرٌ مُوجِبٌ':Added, #2: 2	تَذَكُّرِ الْمُوجِبِ
u'تَذَكَّرَ وَتَرٌ':Predicate, #2: 2	تَذَكُّرِ مُوجِبِ
u'تَذَكَّرَ وَعْدٌ':Predicate, #1: 1	تَذَكَّرَ وَتَرَكَ
u'تَذْكِيَةٌ صَيْدٌ':Added, #1: 1	تَذَكَّرَ وَعْدَ
u'تَذْكِيَةٌ غَاصِبٌ':Added, #1: 1	تَذْكِيَةِ الصَّيْدِ
u'تَذْكِيَةٌ مَقْدُورٌ':Added, #1: 1	تَذْكِيَةُ الْغَاصِبِ
u'تَذْكِيَةٌ هَدْيٌ':Added, #1: 1	تَذْكِيَةِ الْمَقْدُورِ
u'تَرَاءَى نَاسٌ':Subject, #1: 1	تَذْكِيَةِ الْهَدْيِ
u'تَرَاجُعٌ سِتٌّ':Added, #1: 1	تَرَاءَى النَّاسُ
u'تَرَاجَعَ سعر':Subject, #1: 1	تَرَاجُعِ السِّتَّةِ
u'تَرَاجَعَ سِعْرٌ':Subject, #3: 3	تَرَاجَعَ سِعْرُ
u'تَرَاجَعَ سعر':Subject, #3: 3	تَرَاجَعَ سِعْرُ
u'تَرَاجَعَ سِعْرٌ':Subject, #4: 4	تَرَاجَعَ السِّعْرُ
u'تَرَاجَعَ سعر':Subject, #4: 4	تَرَاجَعَ السِّعْرُ
u'تَرَاجَعَ سِعْرٌ':Subject, #5: 5	تَرَاجَعَ سِعْرُهُ
u'تَرَاجُعٌ سعر':Added, #5: 5	تَرَاجَعَ سِعْرُهُ
u'تَرَاجُعٌ سعر':Added, #1: 1	تَرَاجُعَ السِّعْرِ
u'تَرَاجُعٌ سِعْرٌ':Added, #1: 1	تَرَاجُعُ السِّعْرِ
u'تَرَاجُعٌ سِعْرٌ':Added, #1: 1	تَرَاجُعَ السِّعْرِ
u'تَرَاجُعٌ سعر':Added, #1: 1	تَرَاجُعُ السِّعْرِ
u'تَرَاجُعٌ سِعْرٌ':Added, #3: 3	تَرَاجُعِ السِّعْرِ
u'تَرَاجُعٌ قِيمَةٌ':Added, #3: 3	تَرَاجُعِ السِّعْرِ
u'تَرَاخِي إِحْرَامٌ':Added, #1: 1	تَرَاجُعُ قِيمَةِ
u'تَرَاخِي أَحْكَامٌ':Added, #1: 1	تَرَاخِي إحْرَامِهِ
u'تَرَاخَى إِحْيَاءٌ':Subject, #1: 1	تَرَاخِي أَحْكَامِ
u'تَرَاخِي أخْبَارٌ':Added, #2: 2	تَرَاخَى الْإِحْيَاءُ
u'تَرَاخِي أَخْبَارٌ':Added, #1: 1	تَرَاخِي الْأَخْبَارِ
u'تَرَاخَى اِخْتِيَارٌ':Subject, #1: 1	تَرَاخِي الْأَخْبَارِ
u'تَرَاخَى إِخْرَاجٌ':Subject, #1: 1	تَرَاخَى اخْتِيَارُهُ
u'تَرَاخِي بَيَانٌ':Added, #1: 1	تَرَاخَى إخْرَاجُ
u'تَرَاخِي بَيَانٌ':Added, #1: 1	تَرَاخِي بَيَانِ
u'تَرَاخِي تَخْصِيصٌ':Added, #1: 1	تَرَاخِي بَيَانِهِ
u'تَرَاخَى حالَةٌ':Predicate, #1: 1	تَرَاخِي التَّخْصِيصِ
u'تَرَاخَى حُكْمٌ':Subject, #1: 1	تَرَاخَى حَالَةَ
u'تَرَاخِي حُكْمٌ':Added, #2: 2	تَرَاخَى حُكْمُهُ
u'تَرَاخِي حُكْمٌ':Added, #1: 1	تَرَاخِي الْحُكْمِ
u'تَرَاخِي حُكْمٌ':Added, #1: 1	تَرَاخِي حُكْمِ
u'تَرَاخِي رُتْبَةٌ':Added, #3: 3	تَرَاخِي حُكْمِهِ
u'تَرَاخِي رُتْبَةٌ':Added, #1: 1	تَرَاخِي الرُّتْبَةِ
u'تَرَاخَى سَيْرٌ':Subject, #2: 2	تَرَاخِي رُتْبَةِ
u'تَرَاخَى عَمَلٌ':Subject, #2: 2	تَرَاخَى السَّيْرُ
u'تَرَاخِي عَمَلٌ':Added, #3: 3	تَرَاخَى الْعَمَلُ
u'تَرَاخِي عَمَلٌ':Added, #1: 1	تَرَاخِي عَمَلِ
u'تَرَاخَى قَبُولٌ':Subject, #2: 2	تَرَاخِيَ عَمَلِ
u'تَرَاخِي مُخَصَّصٌ':Added, #3: 3	تَرَاخَى الْقَبُولُ
u'تَرَاخَى نَسَبٌ':Subject, #1: 1	تَرَاخِي الْمُخَصَّصِ
u'تَرَاخِي نَظْمٌ':Added, #1: 1	تَرَاخَى النَّسَبُ
u'تَرَاخَى وُقُوعٌ':Subject, #1: 1	تَرَاخِي النَّظْمِ
u'تَرَاخَى وَكِيلٌ':Subject, #1: 1	تَرَاخَى وُقُوعُ
u'تَرَادُفٌ اِسْمٌ':Added, #1: 1	تَرَاخَى الْوَكِيلُ
u'تَرَادُفٌ أَشْيَاءٌ':Added, #1: 1	تَرَادُفِ اسْمَيْنِ
u'تَرَادُفٌ آلاَمٌ':Added, #1: 1	تَرَادُفُ الْأَشْيَاءِ
u'تَرَادُفٌ تَوْفِيقٌ':Added, #2: 2	تَرَادُفِ الْآلَامِ
u'تَرَادُفٌ حَدٌّ':Added, #1: 1	تَرَادُفُ التَّوْفِيقِ
u'تَرَادَفَ دَرَاهِمُ':Subject, #1: 1	تَرَادُفُ الْحَدِّ
u'تَرَادُفٌ رِواياتٌ':Added, #1: 1	تَرَادَفَ الدَّرَاهِمُ
u'تَرَادُفٌ علم':Added, #1: 1	تَرَادُفِ الرِّوَايَاتِ
u'تَرَادُفٌ عِلْمٌ':Added, #1: 1	تَرَادُفَ الْعِلْمِ
u'تَرَادُفٌ مُؤَكِّدٌ':Added, #1: 1	تَرَادُفَ الْعِلْمِ
u'تَرَاضَى أهْلٌ':Subject, #1: 1	تَرَادُفِ الْمُؤَكِّدَاتِ
u'تَرَاضَى طالِبِيّ':Subject, #1: 1	تَرَاضَى أَهْلُ
u'تَرَاضَى نَاسٌ':Subject, #1: 1	تَرَاضَى الطَّالِبِيُّ
u'تَرَاكُمٌ أَشْغالٌ':Added, #3: 3	تَرَاضَى النَّاسُ
u'تَرَاكُمٌ أُمُورٌ':Added, #1: 1	تَرَاكُمِ الْأَشْغَالِ
u'تَرَاكَمَ بَلْغَم':Subject, #1: 1	تَرَاكُمَ الْأُمُورِ
u'تَرَاكُمٌ نَفَقَةٌ':Added, #1: 1	تَرَاكَمَ الْبَلْغَمُ
u'تَرَاكُمٌ وَسَخٌ':Added, #1: 1	تَرَاكُمِ نَفَقَتِهِ
u'تَرَاوَغَ عَبْدٌ':Subject, #1: 1	تَرَاكُمُ الْوَسَخِ
u'تَرَائِي أَهِلَّةٌ':Added, #1: 1	تَرَاوَغَ الْعَبْدُ
u'تَرَائِي أَهِلَّةٌ':Added, #1: 1	تَرَائِي الْأَهِلَّةِ
u'تَرَائِي هِلاَلٌ':Added, #1: 1	تَرَائِيِ الْأَهِلَّةِ
u'تَرِبَ جَنْبٌ':Subject, #2: 2	تَرَائِي الْهِلَالِ
u'تَرِبَ رَجُلٌ':Subject, #2: 2	تَرِبَ جَنْبُهُ
u'تَرَبَّصَ أَرْبَعُ':Predicate, #1: 1	تَرِبَ الرَّجُلُ
u'تَرَبُّصٌ أَرْبَعَةٌ':Added, #1: 1	تَرَبَّصَ أَرْبَعَ
u'تَرَبُّصٌ أَرْبَعَةٌ':Added, #18: 18	تَرَبُّصُ أَرْبَعَةِ
u'تَرَبُّصٌ الْمَرْأَةُ':Added, #1: 1	تَرَبُّصِ أَرْبَعَةِ
u'تَرَبُّصٌ أمَةٌ':Added, #1: 1	تَرَبُّصِ الْمَرْأَةِ
u'تَرَبُّصٌ عُنَّة':Added, #1: 1	تَرَبُّصُ الْأَمَةِ
u'تَرَبُّصٌ غير':Added, #1: 1	تَرَبُّصِ الْعُنَّةِ
u'تَرَبُّصٌ غَيْرٌ':Added, #1: 1	تَرَبُّصُ غَيْرِ
u'تَرَبَّصَ مثل':Predicate, #1: 1	تَرَبُّصُ غَيْرِ
u'تَرَبَّصَ مِثْلٌ':Predicate, #1: 1	تَرَبَّصَ مِثْلَ
u'تَرَبُّعٌ جَالِسٌ':Added, #1: 1	تَرَبَّصَ مِثْلَ
u'تَرَبُّعٌ رَجُلٌ':Added, #2: 2	تَرَبُّعُ الْجَالِسِ
u'تَرْبِيَةٌ ثَمَرٌ':Added, #1: 1	تَرَبُّعِ الرَّجُلِ
u'تَرْبِيَةٌ دُهْنٌ':Added, #1: 1	تَرْبِيَةُ الثَّمَرِ
u'تَرْبِيَةٌ صغار':Added, #1: 1	تَرْبِيَةِ الدُّهْنِ
u'تَرْبِيَةٌ طِفْلٌ':Added, #1: 1	تَرْبِيَةِ الصِّغَارِ
u'تَرْبِيَةٌ كَبِيرٌ':Added, #1: 1	تَرْبِيَةُ الطِّفْلِ
u'تَرْبِيَةٌ هِرٌّ':Added, #1: 1	تَرْبِيَةُ الْكَبِيرِ
u'تَرْبِيَةٌ ولد':Added, #1: 1	تَرْبِيَةُ الْهِرِّ
u'تَرْبِيَةٌ وَلَدٌ':Added, #1: 1	تَرْبِيَةُ الْوَلَدِ
u'تَرْبِيَةٌ ولد':Added, #1: 1	تَرْبِيَةُ الْوَلَدِ
u'تَرْبِيَةٌ وَلَدٌ':Added, #3: 3	تَرْبِيَةِ الْوَلَدِ
u'تَرْبِيعٌ أحَدٌ':Added, #3: 3	تَرْبِيَةِ الْوَلَدِ
u'تَرْبِيعٌ أَقْسَامٌ':Added, #1: 1	تَرْبِيعِ أَحَدِ
u'تَرْبِيعٌ تَكْبيرٌ':Added, #1: 1	تَرْبِيعَ الْأَقْسَامِ
u'تَرْبِيعٌ دَارٌ':Added, #4: 4	تَرْبِيعُ التَّكْبِيرِ
u'تَرْبِيعٌ قُبُورٌ':Added, #1: 1	تَرْبِيعِ الدَّارِ
u'تَرَتَّبَ آثَارٌ':Subject, #3: 3	تَرْبِيعِ الْقُبُورِ
u'تَرَتَّبَ إِثْمٌ':Subject, #1: 1	تَرَتَّبَ آثَارُهُ
u'تَرَتَّبَ أئِمَّةٌ':Subject, #1: 1	تَرَتَّبَ الْإِثْمُ
u'تَرَتَّبَ تَعْزِير':Subject, #1: 1	تَرَتَّبَ الْأَئِمَّةُ
u'تَرَتَّبَ ثَوابٌ':Subject, #1: 1	تَرَتَّبَ التَّعْزِيرُ
u'تَرَتَّبَ حُكْمٌ':Subject, #1: 1	تَرَتَّبَ الثَّوَابُ
u'تَرَتَّبَ حُكْمٌ':Subject, #1: 1	تَرَتَّبَ حُكْمُ
u'تَرَتَّبَ حَلٌّ':Subject, #5: 5	تَرَتَّبَ الْحُكْمُ
u'تَرَتَّبَ سُؤَالٌ':Subject, #1: 1	تَرَتَّبَ حَلُّ
u'تَرَتَّبَ صَرْفٌ':Subject, #2: 2	تَرَتَّبَ سُؤَالُ
u'تَرَتَّبَ صَرْف':Subject, #2: 2	تَرَتَّبَ الصَّرْفُ
u'تَرَتَّبَ عتق':Subject, #2: 2	تَرَتَّبَ الصَّرْفُ
u'تَرَتَّبَ عِتْقٌ':Subject, #1: 1	تَرَتَّبَ الْعِتْقُ
u'تَرَتَّبَ عَدَاوَةٌ':Subject, #1: 1	تَرَتَّبَ الْعِتْقُ
u'تَرَتَّبَ عَقْدٌ':Subject, #1: 1	تَرَتَّبَ الْعَدَاوَةُ
u'تَرَتَّبَ فِعْلٌ':Subject, #1: 1	تَرَتَّبَ الْعَقْدُ
u'تَرَتَّبَ مَوْتٌ':Subject, #1: 1	تَرَتَّبَ الْفِعْلُ
u'تَرْتِيبٌ أَبْوَابٌ':Added, #1: 1	تَرَتَّبَ مَوْتُهُ
u'تَرْتِيبٌ أَبْوَابٌ':Added, #2: 2	تَرْتِيبِ الْأَبْوَابِ
u'تَرْتِيبٌ أَجْوِبَةٌ':Added, #3: 3	تَرْتِيبِ أَبْوَابِ
u'تَرْتِيبٌ أَحْكَامٌ':Added, #1: 1	تَرْتِيبِ الْأَجْوِبَةِ
u'تَرْتِيبٌ أَحْكَامٌ':Added, #1: 1	تَرْتِيبُ أَحْكَامِ
u'تَرْتِيبٌ أَحْكَامٌ':Added, #1: 1	تَرْتِيبِ أَحْكَامِهِ
u'تَرْتِيبٌ أَحْكَامٌ':Added, #1: 1	تَرْتِيبَ الْأَحْكَامِ
u'تَرْتِيبٌ أَحْوالٌ':Added, #1: 1	تَرْتِيبِ الْأَحْكَامِ
u'تَرْتِيبٌ أحْوَالٌ':Added, #1: 1	تَرْتِيبَ أَحْوَالِ
u'تَرْتِيبٌ إِرْثٌ':Added, #1: 1	تَرْتِيبَ أَحْوَالِ
u'تَرْتِيبٌ إِرْثٌ':Added, #1: 1	تَرْتِيبَ الْإِرْثِ
u'تَرْتِيبٌ إِرْضاعٌ':Added, #3: 3	تَرْتِيبِ الْإِرْثِ
u'تَرْتِيبٌ أَرْكانٌ':Added, #1: 1	تَرْتِيبِ إرْضَاعِ
u'تَرْتِيبٌ أَرْكانٌ':Added, #1: 1	تَرْتِيبُ الْأَرْكَانِ
u'تَرْتِيبٌ أَرْكَانٌ':Added, #1: 1	تَرْتِيبِ الْأَرْكَانِ
u'تَرْتِيبٌ أَرْكَانٌ':Added, #1: 1	تَرْتِيبُ الْأَرْكَانِ
u'تَرْتِيبٌ اِسْتِحْقَاقٌ':Added, #1: 1	تَرْتِيبِ الْأَرْكَانِ
u'تَرْتِيبٌ إِسْلامٌ':Added, #1: 1	تَرْتِيبُ اسْتِحْقَاقِ
u'تَرْتِيبٌ أسْئِلَةٌ':Added, #1: 1	تَرْتِيبَ إسْلَامِهِ
u'تَرْتِيبٌ أسْئِلَةٌ':Added, #1: 1	تَرْتِيبَ الْأَسْئِلَةِ
u'تَرْتِيبٌ أسْئِلَةٌ':Added, #1: 1	تَرْتِيبُ الْأَسْئِلَةِ
u'تَرْتِيبٌ اِشْتِراطٌ':Added, #2: 2	تَرْتِيبِ الْأَسْئِلَةِ
u'تَرْتِيبٌ أصل':Added, #1: 1	تَرْتِيبِ اشْتِرَاطِ
u'تَرْتِيبٌ أًصْلٌ':Added, #2: 2	تَرْتِيبِ الْأَصْلِ
u'تَرْتِيبٌ أَعْضَاءٌ':Added, #2: 2	تَرْتِيبِ الْأَصْلِ
u'تَرْتِيبٌ أَعْضَاءٌ':Added, #1: 1	تَرْتِيبِ أَعْضَاءِ
u'تَرْتِيبٌ أَفْرَادٌ':Added, #1: 1	تَرْتِيبِ الْأَعْضَاءِ
u'تَرْتِيبٌ أَفْرَادٌ':Added, #1: 1	تَرْتِيبَ أَفْرَادٍ
u'تَرْتِيبٌ أَفْرَادٌ':Added, #1: 1	تَرْتِيبُ أَفْرَادِ
u'تَرْتِيبٌ أَفْرَادٌ':Added, #1: 1	تَرْتِيبُ الْأَفْرَادِ
u'تَرْتِيبٌ أَفْرَادٌ':Added, #4: 4	تَرْتِيبُ أَفْرَادٍ
u'تَرْتِيبٌ أَفْعَالٌ':Added, #4: 4	تَرْتِيبِ الْأَفْرَادِ
u'تَرْتِيبٌ أَقْسَامٌ':Added, #1: 1	تَرْتِيبَ أَفْعَالِ
u'تَرْتِيبٌ أُمٌّ':Added, #6: 6	تَرْتِيبِ الْأَقْسَامِ
u'تَرْتِيبٌ إمَامٌ':Added, #3: 3	تَرْتِيبِ الْأُمِّ
u'تَرْتِيبٌ إمَامَةٌ':Added, #2: 2	تَرْتِيبِ إمَامِهِ
u'تَرْتِيبٌ أَمْرٌ':Added, #2: 2	تَرْتِيبِ الْإِمَامَةِ
u'تَرْتِيبٌ أَمْرٌ':Added, #1: 1	تَرْتِيبِ الْأَمْرِ
u'تَرْتِيبٌ أُمُورٌ':Added, #1: 1	تَرْتِيبُ أَمْرٍ
u'تَرْتِيبٌ إِنْشاءٌ':Added, #1: 1	تَرْتِيبُ أُمُورٍ
u'تَرْتِيبٌ أَوْضَاعٌ':Added, #1: 1	تَرْتِيبُ إنْشَاءِ
u'تَرْتِيبٌ أَوَّلُ':Added, #1: 1	تَرْتِيبِ أَوْضَاعِ
u'تَرْتِيبٌ أَوَّلُ':Added, #1: 1	تَرْتِيبُ الْأَوَّلِ
u'تَرْتِيبٌ أَوْلاَدٌ':Added, #1: 1	تَرْتِيبِ الْأَوَّلِ
u'تَرْتِيبٌ أَوْلَوِيٌّ':Added, #1: 1	تَرْتِيبُ أَوْلَادِ
u'تَرْتِيبٌ أَوْلِيَاءُ':Added, #1: 1	تَرْتِيبُ أَوْلَوِيَّةٍ
u'تَرْتِيبٌ آيٌ':Added, #4: 4	تَرْتِيبِ الْأَوْلِيَاءِ
u'تَرْتِيبٌ أئِمَّةٌ':Added, #1: 1	تَرْتِيبِ الْآيِ
u'تَرْتِيبٌ آيَةٌ':Added, #1: 1	تَرْتِيبِ الْأَئِمَّةِ
u'تَرْتِيبٌ بَطْنٌ':Added, #1: 1	تَرْتِيبِ الْآيَةِ
u'تَرْتِيبٌ تَشَهُّدٌ':Added, #2: 2	تَرْتِيبُ بَطْنٍ
u'تَرْتِيبٌ تَكْليفٌ':Added, #1: 1	تَرْتِيبُ التَّشَهُّدِ
u'تَرْتِيبٌ ثَلاثَةٌ':Added, #1: 1	تَرْتِيبَ التَّكْلِيفِ
u'تَرْتِيبٌ جَامِعٌ':Added, #1: 1	تَرْتِيبُ الثَّلَاثَةِ
u'تَرْتِيبٌ جَزَاءٌ':Added, #2: 2	تَرْتِيبَ الْجَامِعِ
u'تَرْتِيبٌ جَزَاءٌ':Added, #1: 1	تَرْتِيبِ الْجَزَاءِ
u'تَرْتِيبٌ جُمْلَةٌ':Added, #2: 2	تَرْتِيبَ الْجَزَاءِ
u'تَرْتِيبٌ جُمْلَةٌ':Added, #1: 1	تَرْتِيبَ جُمْلَةٍ
u'تَرْتِيبٌ جَنَائِزُ':Added, #4: 4	تَرْتِيبُ جُمْلَةٍ
u'تَرْتِيبٌ جَيْشٌ':Added, #1: 1	تَرْتِيبِ الْجَنَائِزِ
u'تَرْتِيبٌ جُيوشٌ':Added, #1: 1	تَرْتِيبُ الْجَيْشِ
u'تَرْتِيبٌ حاضِرٌ':Added, #1: 1	تَرْتِيبُ الْجُيُوشِ
u'تَرْتِيبٌ حاضِرٌ':Added, #1: 1	تَرْتِيبُ حَاضِرَتَيْنِ
u'تَرْتِيبٌ حَديثٌ':Added, #3: 3	تَرْتِيبِ حَاضِرَتَيْنِ
u'تَرْتِيبٌ حُرُمَةٌ':Added, #1: 1	تَرْتِيبِ حَدِيثِ
u'تَرْتِيبٌ حُرْمَةٌ':Added, #1: 1	تَرْتِيبِ الْحُرُمَاتِ
u'تَرْتِيبٌ حُكْمٌ':Added, #1: 1	تَرْتِيبِ الْحُرْمَةِ
u'تَرْتِيبٌ حُكْمٌ':Added, #11: 11	تَرْتِيبِ الْحُكْمِ
u'تَرْتِيبٌ حُكْمٌ':Added, #1: 1	تَرْتِيبُ حُكْمٍ
u'تَرْتِيبٌ حُكْمٌ':Added, #1: 1	تَرْتِيبُ حُكْمِ
u'تَرْتِيبٌ حُكْمٌ':Added, #2: 2	تَرْتِيبِ حُكْمٍ
u'تَرْتِيبٌ حُكْمٌ':Added, #4: 4	تَرْتِيبُ الْحُكْمِ
u'تَرْتِيبٌ حَلْقٌ':Added, #6: 6	تَرْتِيبَ الْحُكْمِ
u'تَرْتِيبٌ حَمْدٌ':Added, #1: 1	تَرْتِيبِ الْحَلْقِ
u'تَرْتِيبٌ حَيْضٌ':Added, #1: 1	تَرْتِيبُ الْحَمْدِ
u'تَرْتِيبٌ خَبَرٌ':Added, #1: 1	تَرْتِيبِ الْحَيْضِ
u'تَرْتِيبٌ خَبَر':Added, #1: 1	تَرْتِيبِ الْخَبَرِ
u'تَرْتِيبٌ خُصُومٌ':Added, #1: 1	تَرْتِيبِ الْخَبَرِ
u'تَرْتِيبٌ خُصُومَةٌ':Added, #1: 1	تَرْتِيبُ الْخُصُومِ
u'تَرْتِيبٌ خِلاَفٌ':Added, #1: 1	تَرْتِيبِ الْخُصُومَةِ
u'تَرْتِيبٌ خِيَارٌ':Added, #1: 1	تَرْتِيبِ الْخِلَافِ
u'تَرْتِيبٌ دَرَجَةٌ':Added, #1: 1	تَرْتِيبِ الْخِيَارَاتِ
u'تَرْتِيبٌ دَلائِلُ':Added, #1: 1	تَرْتِيبُ دَرَجَاتِ
u'تَرْتِيبٌ دُورٌ':Added, #1: 1	تَرْتِيبِ الدَّلَائِلِ
u'تَرْتِيبٌ ذكر':Added, #1: 1	تَرْتِيبُ الدُّورِ
u'تَرْتِيبٌ ذِكْرٌ':Added, #1: 1	تَرْتِيبُ ذِكْرِهِ
u'تَرْتِيبٌ رحلة':Added, #1: 1	تَرْتِيبُ ذِكْرِهِ
u'تَرْتِيبٌ رِحْلَةٌ':Added, #4: 4	تَرْتِيبِ الرِّحْلَةِ
u'تَرْتِيبٌ رُكوعٌ':Added, #4: 4	تَرْتِيبِ الرِّحْلَةِ
u'تَرْتِيبٌ زَمانٌ':Added, #1: 1	تَرْتِيبِ الرُّكُوعِ
u'تَرْتِيبٌ زَمانٌ':Added, #1: 1	تَرْتِيبِ الزَّمَانِ
u'تَرْتِيبٌ سُجُودٌ':Added, #1: 1	تَرْتِيبِ زَمَانٍ
u'تَرْتِيبٌ سنن':Added, #1: 1	تَرْتِيبَ السُّجُودِ
u'تَرْتِيبٌ سنن':Added, #1: 1	تَرْتِيبَ السُّنَنِ
u'تَرْتِيبٌ سورٌ':Added, #1: 1	تَرْتِيبُ السُّنَنِ
u'تَرْتِيبٌ سورٌ':Added, #1: 1	تَرْتِيبِ السُّوَرِ
u'تَرْتِيبٌ سورٌ':Added, #2: 2	تَرْتِيبُ السُّوَرِ
u'تَرْتِيبٌ شِيَاهٌ':Added, #4: 4	تَرْتِيبَ السُّوَرِ
u'تَرْتِيبٌ صَلاَةٌ':Added, #1: 1	تَرْتِيبِ الشِّيَاهِ
u'تَرْتِيبٌ صَلاَةٌ':Added, #1: 1	تَرْتِيبُ الصَّلَاةِ
u'تَرْتِيبٌ صَلاَةٌ':Added, #1: 1	تَرْتِيبَ صَلَاتِهِ
u'تَرْتِيبٌ صَلاَةٌ':Added, #2: 2	تَرْتِيبِ الصَّلَاةِ
u'تَرْتِيبٌ صَلاَةٌ':Added, #2: 2	تَرْتِيبَ صَلَاةِ
u'تَرْتِيبٌ صَلَوَاتٌ':Added, #6: 6	تَرْتِيبِ صَلَاةِ
u'تَرْتِيبٌ ضُرُوبٌ':Added, #1: 1	تَرْتِيبِ الصَّلَوَاتِ
u'تَرْتِيبٌ طَبَقَةٌ':Added, #1: 1	تَرْتِيبَ ضُرُوبِ
u'تَرْتِيبٌ طَبَقَةٌ':Added, #1: 1	تَرْتِيبَ الطَّبَقَاتِ
u'تَرْتِيبٌ عتق':Added, #1: 1	تَرْتِيبَ طَبَقَةٍ
u'تَرْتِيبٌ عِتْقٌ':Added, #1: 1	تَرْتِيبِ الْعِتْقِ
u'تَرْتِيبٌ عَصَبَةٌ':Added, #1: 1	تَرْتِيبِ الْعِتْقِ
u'تَرْتِيبٌ عصبة':Added, #1: 1	تَرْتِيبَ الْعَصَبَاتِ
u'تَرْتِيبٌ عَصَبَةٌ':Added, #1: 1	تَرْتِيبَ الْعَصَبَةِ
u'تَرْتِيبٌ عَصَبَةٌ':Added, #1: 1	تَرْتِيبَ الْعَصَبَةِ
u'تَرْتِيبٌ عصبة':Added, #1: 1	تَرْتِيبِ عَصَبَاتِ
u'تَرْتِيبٌ عَصَبَةٌ':Added, #1: 1	تَرْتِيبِ عَصَبَةِ
u'تَرْتِيبٌ عصبة':Added, #1: 1	تَرْتِيبِ عَصَبَةِ
u'تَرْتِيبٌ عَصَبَةٌ':Added, #4: 4	تَرْتِيبِ الْعَصَبَةِ
u'تَرْتِيبٌ عَصَبَةٌ':Added, #4: 4	تَرْتِيبِ الْعَصَبَةِ
u'تَرْتِيبٌ علم':Added, #8: 8	تَرْتِيبِ الْعَصَبَاتِ
u'تَرْتِيبٌ عِلْمٌ':Added, #1: 1	تَرْتِيبَ الْعِلْمِ
u'تَرْتِيبٌ عمرة':Added, #1: 1	تَرْتِيبَ الْعِلْمِ
u'تَرْتِيبٌ عُمْرَةٌ':Added, #2: 2	تَرْتِيبُ الْعُمْرَةِ
u'تَرْتِيبٌ غَايَةٌ':Added, #2: 2	تَرْتِيبُ الْعُمْرَةِ
u'تَرْتِيبٌ غُسْلٌ':Added, #1: 1	تَرْتِيبَ الْغَايَةِ
u'تَرْتِيبٌ غَسْلٌ':Added, #1: 1	تَرْتِيبَ الْغُسْلِ
u'تَرْتِيبٌ فاء':Added, #2: 2	تَرْتِيبَ غَسْلِ
u'تَرْتِيبٌ فَاتِحٌ':Added, #1: 1	تَرْتِيبِ الْفَاءِ
u'تَرْتِيبٌ فَاتِحَةٌ':Added, #1: 1	تَرْتِيبُ الْفَاتِحَةِ
u'تَرْتِيبٌ فَائِدَةٌ':Added, #1: 1	تَرْتِيبُ الْفَاتِحَةِ
u'تَرْتِيبٌ فَرَائِضُ':Added, #1: 1	تَرْتِيبَ فَائِدَةٍ
u'تَرْتِيبٌ فَرْدٌ':Added, #1: 1	تَرْتِيبَ فَرَائِضِ
u'تَرْتِيبٌ فَرْدٌ':Added, #1: 1	تَرْتِيبُ فَرْدٍ
u'تَرْتِيبٌ فِعْلٌ':Added, #2: 2	تَرْتِيبِ فَرْدٍ
u'تَرْتِيبٌ فِقْهٌ':Added, #1: 1	تَرْتِيبِ فِعْلِ
u'تَرْتِيبٌ قَبَائِلُ':Added, #1: 1	تَرْتِيبُ الْفِقْهِ
u'تَرْتِيبٌ قِرَاءةٌ':Added, #1: 1	تَرْتِيبُ الْقَبَائِلِ
u'تَرْتِيبٌ قُرْآنٌ':Added, #1: 1	تَرْتِيبَ قِرَاءَةِ
u'تَرْتِيبٌ قُعُودٌ':Added, #1: 1	تَرْتِيبَ الْقُرْآنِ
u'تَرْتِيبٌ قُوَّةٌ':Added, #1: 1	تَرْتِيبِ الْقُعُودِ
u'تَرْتِيبٌ قُوَّة':Added, #1: 1	تَرْتِيبِ الْقُوَّةِ
u'تَرْتِيبٌ قيام':Added, #1: 1	تَرْتِيبِ الْقُوَّةِ
u'تَرْتِيبٌ قيام':Added, #1: 1	تَرْتِيبُ الْقِيَامِ
u'تَرْتِيبٌ قِيَامٌ':Added, #1: 1	تَرْتِيبِ الْقِيَامِ
u'تَرْتِيبٌ قِيَامٌ':Added, #1: 1	تَرْتِيبُ الْقِيَامِ
u'تَرْتِيبٌ كِتَابٌ':Added, #1: 1	تَرْتِيبِ الْقِيَامِ
u'تَرْتِيبٌ كُتُبٌ':Added, #1: 1	تَرْتِيبَ الْكِتَابِ
u'تَرْتِيبٌ كَنْزٌ':Added, #1: 1	تَرْتِيبِ الْكُتُبِ
u'تَرْتِيبٌ مَاءٌ':Added, #1: 1	تَرْتِيبَ الْكَنْزِ
u'تَرْتِيبٌ مَبْسُوطٌ':Added, #1: 1	تَرْتِيبُ الْمَاءِ
u'تَرْتِيبٌ مَجَالِسُ':Added, #1: 1	تَرْتِيبِ الْمَبْسُوطِ
u'تَرْتِيبٌ مُحَمَّدٌ':Added, #1: 1	تَرْتِيبِ الْمَجَالِسِ
u'تَرْتِيبٌ مَسْنُونٌ':Added, #1: 1	تَرْتِيبَ مُحَمَّدٍ
u'تَرْتِيبٌ مَشَايِخُ':Added, #1: 1	تَرْتِيبُ الْمَسْنُونِ
u'تَرْتِيبٌ مُصْحَفٌ':Added, #1: 1	تَرْتِيبُ الْمَشَايِخِ
u'تَرْتِيبٌ مُصْحَفٌ':Added, #1: 1	تَرْتِيبِ مُصْحَفِ
u'تَرْتِيبٌ مُطَالَبٌ':Added, #7: 7	تَرْتِيبِ الْمُصْحَفِ
u'تَرْتِيبٌ مُطَالَبَةٌ':Added, #1: 1	تَرْتِيبُ مُطَالَبَةِ
u'تَرْتِيبٌ مَعْلُومٌ':Added, #1: 1	تَرْتِيبُ مُطَالَبَةِ
u'تَرْتِيبٌ مُعَيَّنٌ':Added, #1: 1	تَرْتِيبِ الْمَعْلُومَاتِ
u'تَرْتِيبٌ مَقَامٌ':Added, #1: 1	تَرْتِيبٍ مُعَيَّنٍ
u'تَرْتِيبٌ مَقَامٌ':Added, #1: 1	تَرْتِيبَ الْمَقَامِ
u'تَرْتِيبٌ مُقَدِّمٌ':Added, #2: 2	تَرْتِيبِ الْمَقَامِ
u'تَرْتِيبٌ مُقَدِّمٌ':Added, #1: 1	تَرْتِيبِ الْمُقَدِّمَاتِ
u'تَرْتِيبٌ مُقَدِّمٌ':Added, #1: 1	تَرْتِيبَ الْمُقَدِّمَتَيْنِ
u'تَرْتِيبٌ مُقَدِّمَةٌ':Added, #1: 1	تَرْتِيبِ الْمُقَدِّمَتَيْنِ
u'تَرْتِيبٌ مَوْتٌ':Added, #1: 1	تَرْتِيبِ الْمُقَدِّمَاتِ
u'تَرْتِيبٌ مُوجِبٌ':Added, #1: 1	تَرْتِيبُ الْمَوْتِ
u'تَرْتِيبٌ مُوجِبٌ':Added, #1: 1	تَرْتِيبُ مُوجِبِ
u'تَرْتِيبٌ مَوْجُودٌ':Added, #2: 2	تَرْتِيبُ مُوجِبِهِ
u'تَرْتِيبٌ مِيرَاثٌ':Added, #1: 1	تَرْتِيبَ الْمَوْجُودَاتِ
u'تَرْتِيبٌ نَاسٌ':Added, #1: 1	تَرْتِيبِ الْمِيرَاثِ
u'تَرْتِيبٌ نَاسٌ':Added, #1: 1	تَرْتِيبُ النَّاسِ
u'تَرْتِيبٌ نَفْسٌ':Added, #1: 1	تَرْتِيبِ النَّاسِ
u'تَرْتِيبٌ نَفْسٌ':Added, #1: 1	تَرْتِيبَ نَفْسِهِ
u'تَرْتِيبٌ نقل':Added, #5: 5	تَرْتِيبِ نَفْسِهِ
u'تَرْتِيبٌ نَقْلٌ':Added, #1: 1	تَرْتِيبِ النَّقْلِ
u'تَرْتِيبٌ هِدَايَةٌ':Added, #1: 1	تَرْتِيبِ النَّقْلِ
u'تَرْتِيبٌ واحد':Added, #1: 1	تَرْتِيبَ الْهِدَايَةِ
u'تَرْتِيبٌ وَاحِدٌ':Added, #1: 1	تَرْتِيبُ الْوَاحِدِ
u'تَرْتِيبٌ وُجُوهٌ':Added, #1: 1	تَرْتِيبُ الْوَاحِدِ
u'تَرْتِيبٌ وَضْعٌ':Added, #1: 1	تَرْتِيبِ وُجُوهِ
u'تَرْتِيبٌ وُضُوءٌ':Added, #1: 1	تَرْتِيبِ وَضْعِ
u'تَرْتِيبٌ وُضُوءٌ':Added, #1: 1	تَرْتِيبِ الْوُضُوءِ
u'تَرْتِيبٌ وَعِيدٌ':Added, #3: 3	تَرْتِيبَ الْوُضُوءِ
u'تَرْتِيلٌ أَذَانٌ':Added, #1: 1	تَرْتِيبَ الْوَعِيدِ
u'تَرْتِيلٌ أَذَانٌ':Added, #1: 1	تَرْتِيلِ الأَذَانِ
u'تَرْتِيلٌ قِرَاءةٌ':Added, #1: 1	تَرْتِيلُ الْأَذَانِ
u'تَرْتِيلٌ قِرَاءةٌ':Added, #1: 1	تَرْتِيلُ الْقِرَاءَةِ
u'تَرْتِيلٌ قُرْآنٌ':Added, #1: 1	تَرْتِيلِ الْقِرَاءَةِ
u'تَرَجَّحَ اِبْنَة':Subject, #1: 1	تَرْتِيلِ الْقُرْآنِ
u'تَرَجَّحَ اِحْتِمَالٌ':Subject, #1: 1	تَرَجَّحَ ابْنَةُ
u'تَرَجَّحَ أحَدٌ':Subject, #1: 1	تَرَجَّحَ احْتِمَالُ
u'تَرَجَّحَ أَوَّلُ':Subject, #3: 3	تَرَجَّحَ أَحَدُ
u'تَرَجَّحَ بَيْعٌ':Subject, #7: 7	تَرَجَّحَ الْأَوَّلُ
u'تَرَجَّحَ تَقْليدٌ':Subject, #1: 1	تَرَجَّحَ الْبَيْعُ
u'تَرَجَّحَ تَقْليد':Subject, #1: 1	تَرَجَّحَ تَقْلِيدُهُ
u'تَرَجَّحَ جَانِبٌ':Subject, #1: 1	تَرَجَّحَ تَقْلِيدُهُ
u'تَرَجَّحَ جَانِبٌ':Subject, #10: 10	تَرَجَّحَ جَانِبُ
u'تَرَجَّحَ جَانِبٌ':Subject, #1: 1	تَرَجَّحَ الْجَانِبُ
u'تَرَجَّحَ جمع':Subject, #3: 3	تَرَجَّحَ جَانِبُهُ
u'تَرَجَّحَ جَمْعٌ':Subject, #1: 1	تَرَجَّحَ الْجَمْعُ
u'تَرَجَّحَ جِهَةٌ':Subject, #1: 1	تَرَجَّحَ الْجَمْعُ
u'تَرَجَّحَ حِنْثٌ':Subject, #1: 1	تَرَجَّحَ جِهَةُ
u'تَرَجَّحَ دَليلٌ':Subject, #1: 1	تَرَجَّحَ الْحِنْثُ
u'تَرَجَّحَ دَيْنٌ':Subject, #1: 1	تَرَجَّحَ دَلِيلُ
u'تَرَجَّحَ رَدٌّ':Subject, #1: 1	تَرَجَّحَ دَيْنُ
u'تَرَجَّحَ سَابِقٌ':Subject, #2: 2	تَرَجَّحَ الرَّدُّ
u'تَرَجَّحَ صِحَّةٌ':Subject, #1: 1	تَرَجَّحَ السَّابِقُ
u'تَرَجَّحَ صدق':Subject, #1: 1	تَرَجَّحَ صِحَّةُ
u'تَرَجَّحَ صِدْقٌ':Subject, #1: 1	تَرَجَّحَ صِدْقُ
u'تَرَجَّحَ صدق':Subject, #1: 1	تَرَجَّحَ صِدْقُ
u'تَرَجَّحَ صِدْقٌ':Subject, #1: 1	تَرَجَّحَ صِدْقُهُ
u'تَرَجَّحَ ظَنٌّ':Subject, #1: 1	تَرَجَّحَ صِدْقُهُ
u'تَرَجَّحَ ظَنٌّ':Subject, #1: 1	تَرَجَّحَ الظَّنُّ
u'تَرَجَّحَ عَدَمٌ':Subject, #1: 1	تَرَجَّحَ ظَنُّ
u'تَرَجَّحَ عَدَمٌ':Subject, #1: 1	تَرَجَّحَ عَدَمُهُ
u'تَرَجَّحَ عند':Predicate, #2: 2	تَرَجَّحَ عَدَمُ
u'تَرَجَّحَ فَسْخٌ':Subject, #2: 2	تَرَجَّحَ عِنْدَ
u'تَرَجَّحَ فِعْلٌ':Subject, #1: 1	تَرَجَّحَ الْفَسْخُ
u'تَرَجَّحَ قول':Subject, #1: 1	تَرَجَّحَ فِعْلُهُ
u'تَرَجَّحَ قَوْلٌ':Subject, #1: 1	تَرَجَّحَ الْقَوْلُ
u'تَرَجَّحَ قول':Subject, #1: 1	تَرَجَّحَ الْقَوْلُ
u'تَرَجَّحَ قَوْلٌ':Subject, #3: 3	تَرَجَّحَ قَوْلُ
u'تَرَجَّحَ قول':Subject, #3: 3	تَرَجَّحَ قَوْلُ
u'تَرَجَّحَ قَوْلٌ':Subject, #3: 3	تَرَجَّحَ قَوْلُهُ
u'تَرَجَّحَ كَوْنٌ':Subject, #3: 3	تَرَجَّحَ قَوْلُهُ
u'تَرَجَّحَ مَالِكٌ':Subject, #1: 1	تَرَجَّحَ كَوْنُهُ
u'تَرَجَّحَ نَفْيٌ':Subject, #1: 1	تَرَجَّحَ مَالِكٌ
u'تَرَجَّحَ واحد':Subject, #2: 2	تَرَجَّحَ النَّفْيُ
u'تَرَجَّحَ وَاحِدٌ':Subject, #1: 1	تَرَجَّحَ وَاحِدٌ
u'تَرَجَّحَ وَجْهٌ':Subject, #1: 1	تَرَجَّحَ وَاحِدٌ
u'تَرَجَّحَ وُجُودٌ':Subject, #1: 1	تَرَجَّحَ وَجْهُ
u'تَرَجَّحَ يَمِينٌ':Subject, #1: 1	تَرَجَّحَ وُجُودُهُ
u'تَرَجَّلَ يَوْمٌ':Predicate, #1: 1	تَرَجَّحَ الْيَمِينُ
u'تَرْجَمَ اِبْنٌ':Subject, #1: 1	تَرَجَّلَ يَوْمَ
u'تَرْجَمَ بُخَارِيٌّ':Subject, #4: 4	تَرْجَمَ ابْنُ
u'تَرْجَمَ بَعْضٌ':Subject, #2: 2	تَرْجَمَ الْبُخَارِيُّ
u'تَرْجَمَةٌ اِبْنٌ':Added, #1: 1	تَرْجَمَ بَعْضُ
u'تَرْجَمَةٌ اِبْنٌ':Added, #1: 1	تَرْجَمَةِ ابْنِهِ
u'تَرْجَمَةٌ اِبْنٌ':Added, #2: 2	تَرْجَمَةُ ابْنِ
u'تَرْجَمَةٌ أَحْباسٌ':Added, #2: 2	تَرْجَمَةِ ابْنِ
u'تَرْجَمَةٌ أَسَدٌ':Added, #1: 1	تَرْجَمَةِ الْأَحْبَاسِ
u'تَرْجَمَةٌ إِفَاضَةٌ':Added, #1: 1	تَرْجَمَةِ أَسَدِ
u'تَرْجَمَةٌ إمَامٌ':Added, #1: 1	تَرْجَمَةَ إفَاضَةِ
u'تَرْجَمَةٌ إمَامٌ':Added, #1: 1	تَرْجَمَةَ الْإِمَامِ
u'تَرْجَمَةٌ إيرَادٌ':Added, #1: 1	تَرْجَمَةِ الْإِمَامِ
u'تَرْجَمَةٌ بَابٌ':Added, #1: 1	تَرْجَمَةِ إيرَادِ
u'تَرْجَمَةٌ بَابٌ':Added, #1: 1	تَرْجَمَةَ بَابِ
u'تَرْجَمَةٌ بَابٌ':Added, #1: 1	تَرْجَمَةِ بَابٍ
u'تَرْجَمَةٌ بَابٌ':Added, #1: 1	تَرْجَمَةِ بَابِ
u'تَرْجَمَةٌ بَابٌ':Added, #2: 2	تَرْجَمَةَ بَابٍ
u'تَرْجَمَةٌ بُحْتُرِيّ':Added, #7: 7	تَرْجَمَةِ الْبَابِ
u'تَرْجَمَةٌ براءٌ':Added, #1: 1	تَرْجَمَةِ الْبُحْتُرِيِّ
u'تَرْجَمَةٌ براءٌ':Added, #1: 1	تَرْجَمَةُ الْبَرَاءِ
u'تَرْجَمَةٌ بَراءٌ':Added, #1: 1	تَرْجَمَةِ الْبَرَاءِ
u'تَرْجَمَةٌ بَراءٌ':Added, #1: 1	تَرْجَمَةُ الْبَرَاءِ
u'تَرْجَمَةٌ بَعْضٌ':Added, #1: 1	تَرْجَمَةِ الْبَرَاءِ
u'تَرْجَمَةٌ بَيْعٌ':Added, #2: 2	تَرْجَمَةِ بَعْضِ
u'تَرْجَمَةٌ بَيْعٌ':Added, #2: 2	تَرْجَمَةَ بَيْعِ
u'تَرْجَمَةٌ تَحْرِيمٌ':Added, #4: 4	تَرْجَمَةِ بَيْعِ
u'تَرْجَمَةٌ تَعْجِيل':Added, #1: 1	تَرْجَمَةَ تَحْرِيمِ
u'تَرْجَمَةٌ ثَابِتٌ':Added, #1: 1	تَرْجَمَةِ تَعْجِيلِ
u'تَرْجَمَةٌ ثَابِتٌ':Added, #1: 1	تَرْجَمَةِ ثَابِتِ
u'تَرْجَمَةٌ جَامِعٌ':Added, #3: 3	تَرْجَمَةِ ثَابِتٍ
u'تَرْجَمَةٌ جَامِعٌ':Added, #1: 1	تَرْجَمَةَ جَامِعٍ
u'تَرْجَمَةٌ جَامِعٌ':Added, #1: 1	تَرْجَمَةِ جَامِعٍ
u'تَرْجَمَةٌ جَامِعٌ':Added, #2: 2	تَرْجَمَةِ جَامِعِ
u'تَرْجَمَةٌ حارِثٌ':Added, #3: 3	تَرْجَمَةَ جَامِعِ
u'تَرْجَمَةٌ حُجَّةٌ':Added, #2: 2	تَرْجَمَةِ الْحَارِثِ
u'تَرْجَمَةٌ حَرامٌ':Added, #1: 1	تَرْجَمَةِ الْحُجَّةِ
u'تَرْجَمَةٌ حزام':Added, #1: 1	تَرْجَمَةِ حَرَامٍ
u'تَرْجَمَةٌ حِزَامٌ':Added, #1: 1	تَرْجَمَةِ حِزَامِ
u'تَرْجَمَةٌ حَفْصٌ':Added, #1: 1	تَرْجَمَةِ حِزَامِ
u'تَرْجَمَةٌ حَمَّادٌ':Added, #1: 1	تَرْجَمَةِ حَفْصِ
u'تَرْجَمَةٌ خَالِدٌ':Added, #1: 1	تَرْجَمَةِ حَمَّادِ
u'تَرْجَمَةٌ خُلْعٌ':Added, #1: 1	تَرْجَمَةِ خَالِدِ
u'تَرْجَمَةٌ رُجُوعٌ':Added, #1: 1	تَرْجَمَةُ الْخُلْعِ
u'تَرْجَمَةٌ زَيْدٌ':Added, #1: 1	تَرْجَمَةِ الرُّجُوعِ
u'تَرْجَمَةٌ سَعِيدٌ':Added, #1: 1	تَرْجَمَةِ زَيْدٍ
u'تَرْجَمَةٌ سَفِيهٌ':Added, #1: 1	تَرْجَمَةِ سَعِيدِ
u'تَرْجَمَةٌ شافِعِيّ':Added, #1: 1	تَرْجَمَةِ السَّفِيهِ
u'تَرْجَمَةٌ شفعة':Added, #1: 1	تَرْجَمَةِ الشَّافِعِيِّ
u'تَرْجَمَةٌ شُفْعَةٌ':Added, #1: 1	تَرْجَمَةِ الشُّفْعَةِ
u'تَرْجَمَةٌ شَهَادَةٌ':Added, #1: 1	تَرْجَمَةِ الشُّفْعَةِ
u'تَرْجَمَةٌ شَيْخٌ':Added, #1: 1	تَرْجَمَةَ الشَّهَادَةِ
u'تَرْجَمَةٌ صَالِحٌ':Added, #1: 1	تَرْجَمَةِ الشَّيْخِ
u'تَرْجَمَةٌ صَالِح':Added, #1: 1	تَرْجَمَةِ صَالِحٍ
u'تَرْجَمَةٌ صِيَامٌ':Added, #1: 1	تَرْجَمَةِ صَالِحٍ
u'تَرْجَمَةٌ ضرار':Added, #1: 1	تَرْجَمَةِ الصِّيَامِ
u'تَرْجَمَةٌ طَلاَقٌ':Added, #1: 1	تَرْجَمَةِ ضِرَارِ
u'تَرْجَمَةٌ طَلاَقٌ':Added, #1: 1	تَرْجَمَةَ الطَّلَاقِ
u'تَرْجَمَةٌ طَلاَقٌ':Added, #1: 1	تَرْجَمَةُ طَلَاقٍ
u'تَرْجَمَةٌ عَاصِمٌ':Added, #2: 2	تَرْجَمَةِ الطَّلَاقِ
u'تَرْجَمَةٌ عَبَّاسٌ':Added, #1: 1	تَرْجَمَةِ عَاصِمٍ
u'تَرْجَمَةٌ عَبْدٌ':Added, #1: 1	تَرْجَمَةِ الْعَبَّاسِ
u'تَرْجَمَةٌ عَبْدٌ':Added, #15: 15	تَرْجَمَةِ عَبْدِ
u'تَرْجَمَةٌ عَلِيٌّ':Added, #1: 1	تَرْجَمَةُ عَبْدٍ
u'تَرْجَمَةٌ عَلِيٌّ':Added, #4: 4	تَرْجَمَةِ عَلِيٍّ
u'تَرْجَمَةٌ عَوَارِضُ':Added, #4: 4	تَرْجَمَةِ عَلِيِّ
u'تَرْجَمَةٌ فَصْلٌ':Added, #1: 1	تَرْجَمَةِ الْعَوَارِضِ
u'تَرْجَمَةٌ فلان':Added, #1: 1	تَرْجَمَةُ الْفَصْلِ
u'تَرْجَمَةٌ فلان':Added, #1: 1	تَرْجَمَةِ الْبُحْتُرِيِّ
u'تَرْجَمَةٌ فلان':Added, #1: 1	تَرْجَمَةِ الشَّافِعِيِّ
u'تَرْجَمَةٌ فلان':Added, #1: 1	تَرْجَمَةِ جَعْفَرٍ
u'تَرْجَمَةٌ فلان':Added, #1: 1	تَرْجَمَةِ جَعْفَرِ
u'تَرْجَمَةٌ فلان':Added, #1: 1	تَرْجَمَةِ زُهَيْرِ
u'تَرْجَمَةٌ فلان':Added, #1: 1	تَرْجَمَةِ زِيَادٍ
u'تَرْجَمَةٌ قراض':Added, #1: 1	تَرْجَمَةِ عَوْفِ
u'تَرْجَمَةٌ قُرْآنٌ':Added, #1: 1	تَرْجَمَةِ الْقِرَاضِ
u'تَرْجَمَةٌ قُرْآنٌ':Added, #1: 1	تَرْجَمَةَ الْقُرْآنِ
u'تَرْجَمَةٌ قُرْآنٌ':Added, #1: 1	تَرْجَمَةِ الْقُرْآنِ
u'تَرْجَمَةٌ قَسْمٌ':Added, #2: 2	تَرْجَمَةُ الْقُرْآنِ
u'تَرْجَمَةٌ قسمة':Added, #1: 1	تَرْجَمَةِ الْقَسْمِ
u'تَرْجَمَةٌ قِسْمَةٌ':Added, #1: 1	تَرْجَمَةِ الْقِسْمَةِ
u'تَرْجَمَةٌ قَضَاءٌ':Added, #1: 1	تَرْجَمَةِ الْقِسْمَةِ
u'تَرْجَمَةٌ قَضَاءٌ':Added, #1: 1	تَرْجَمَةُ الْقَضَاءِ
u'تَرْجَمَةٌ كَافِرٌ':Added, #2: 2	تَرْجَمَةَ الْقَضَاءِ
u'تَرْجَمَةٌ كَافِرٌ':Added, #1: 1	تَرْجَمَةُ كَافِرٍ
u'تَرْجَمَةٌ كَفِيلٌ':Added, #1: 1	تَرْجَمَةِ كَافِرٍ
u'تَرْجَمَةٌ مُبَشِّرٌ':Added, #1: 1	تَرْجَمَةِ الْكَفِيلِ
u'تَرْجَمَةٌ مُتَداعِي':Added, #1: 1	تَرْجَمَةِ مُبَشِّرِ
u'تَرْجَمَةٌ مُحَمَّدٌ':Added, #1: 1	تَرْجَمَةِ الْمُتَدَاعِيَيْنِ
u'تَرْجَمَةٌ مَسْأَلَةٌ':Added, #18: 18	تَرْجَمَةِ مُحَمَّدِ
u'تَرْجَمَةٌ مَسْأَلَةٌ':Added, #3: 3	تَرْجَمَةَ الْمَسْأَلَةِ
u'تَرْجَمَةٌ مَسْأَلَةٌ':Added, #3: 3	تَرْجَمَةُ الْمَسْأَلَةِ
u'تَرْجَمَةٌ مَسْحٌ':Added, #3: 3	تَرْجَمَةِ الْمَسْأَلَةِ
u'تَرْجَمَةٌ مُصَنِّفٌ':Added, #1: 1	تَرْجَمَةِ الْمَسْحِ
u'تَرْجَمَةٌ مَعْبَدٌ':Added, #1: 1	تَرْجَمَةِ الْمُصَنِّفِ
u'تَرْجَمَةٌ مَفْقُودٌ':Added, #4: 4	تَرْجَمَةِ مَعْبَدِ
u'تَرْجَمَةٌ مِقْدَامٌ':Added, #1: 1	تَرْجَمَةِ الْمَفْقُودِ
u'تَرْجَمَةٌ مُناجَزَة':Added, #1: 1	تَرْجَمَةِ الْمِقْدَامِ
u'تَرْجَمَةٌ مِيزَانٌ':Added, #1: 1	تَرْجَمَةِ الْمُنَاجَزَةِ
u'تَرْجَمَةٌ مَيْمُونٌ':Added, #1: 1	تَرْجَمَةِ مِيزَانٍ
u'تَرْجَمَةٌ نَافِعٌ':Added, #1: 1	تَرْجَمَةِ مَيْمُونٍ
u'تَرْجَمَةٌ نُعْمَانُ':Added, #1: 1	تَرْجَمَةِ نَافِعٍ
u'تَرْجَمَةٌ نكاح':Added, #3: 3	تَرْجَمَةِ النُّعْمَانِ
u'تَرْجَمَةٌ نِكَاحٌ':Added, #1: 1	تَرْجَمَةِ النِّكَاحِ
u'تَرْجَمَةٌ هشام':Added, #1: 1	تَرْجَمَةِ النِّكَاحِ
u'تَرْجَمَةٌ هِشَامٌ':Added, #1: 1	تَرْجَمَةِ هِشَامِ
u'تَرْجَمَةٌ هِلاَلٌ':Added, #1: 1	تَرْجَمَةِ هِشَامِ
u'تَرْجَمَةٌ واحد':Added, #1: 1	تَرْجَمَة هِلَالٍ
u'تَرْجَمَةٌ وَاحِدٌ':Added, #1: 1	تَرْجَمَةُ الْوَاحِدِ
u'تَرْجَمَةٌ واحد':Added, #1: 1	تَرْجَمَةُ الْوَاحِدِ
u'تَرْجَمَةٌ وَاحِدٌ':Added, #1: 1	تَرْجَمَةٍ وَاحِدَةٍ
u'تَرْجَمَةٌ وَصِيٌّ':Added, #1: 1	تَرْجَمَةٍ وَاحِدَةٍ
u'تَرْجَمَةٌ وَصِيَّةٌ':Added, #1: 1	تَرْجَمَةَ وَصِيَّةٍ
u'تَرْجَمَةٌ وَلِيدٌ':Added, #1: 1	تَرْجَمَةَ وَصِيَّةٍ
u'تَرْجَمَ فُلاَنٌ':Subject, #1: 1	تَرْجَمَةِ الْوَلِيدِ
u'تَرْجَمَ مَسْأَلَةٌ':Predicate, #1: 1	تَرْجَمَ فُلَانٌ
u'تَرْجَمَ مُصَنِّفٌ':Subject, #2: 2	تَرْجَمَ الْمَسْأَلَةَ
u'تَرْجِيحٌ إبَاحَةٌ':Added, #2: 2	تَرْجَمَ الْمُصَنِّفُ
u'تَرْجِيحٌ إبَاحَةٌ':Added, #1: 1	تَرْجِيحَ الْإِبَاحَةِ
u'تَرْجِيحٌ اِبْنٌ':Added, #1: 1	تَرْجِيحُ الْإِبَاحَةِ
u'تَرْجِيحٌ اِبْنٌ':Added, #2: 2	تَرْجِيحُ ابْنِ
u'تَرْجِيحٌ اِجْتِهَادٌ':Added, #3: 3	تَرْجِيحِ ابْنِ
u'تَرْجِيحٌ اِجْتِهَادٌ':Added, #1: 1	تَرْجِيحُ اجْتِهَادِ
u'تَرْجِيحٌ إِجْزَاءٌ':Added, #1: 1	تَرْجِيحُ اجْتِهَادِهِ
u'تَرْجِيحٌ إِجْمَالٌ':Added, #2: 2	تَرْجِيحُ الْإِجْزَاءِ
u'تَرْجِيحٌ أحَدٌ':Added, #1: 1	تَرْجِيحُ الْإِجْمَالِ
u'تَرْجِيحٌ أحَدٌ':Added, #11: 11	تَرْجِيحِ أَحَدِ
u'تَرْجِيحٌ أحَدٌ':Added, #1: 1	تَرْجِيحَ أَحَدِ
u'تَرْجِيحٌ أخْبَارٌ':Added, #6: 6	تَرْجِيحُ أَحَدِ
u'تَرْجِيحٌ أَخْبَارٌ':Added, #1: 1	تَرْجِيحِ أَخْبَارِ
u'تَرْجِيحٌ إِخْبَارٌ':Added, #1: 1	تَرْجِيحِ أَخْبَارِ
u'تَرْجِيحٌ أخْبَارٌ':Added, #1: 1	تَرْجِيحُ إخْبَارِ
u'تَرْجِيحٌ أخْبَارٌ':Added, #1: 1	تَرْجِيحُ الْأَخْبَارِ
u'تَرْجِيحٌ أَخْبَارٌ':Added, #1: 1	تَرْجِيحِ الْأَخْبَارِ
u'تَرْجِيحٌ أَخْبَارٌ':Added, #1: 1	تَرْجِيحُ الْأَخْبَارِ
u'تَرْجِيحٌ اِخْتِلاَفٌ':Added, #1: 1	تَرْجِيحِ الْأَخْبَارِ
u'تَرْجِيحٌ أخْذٌ':Added, #1: 1	تَرْجِيحِ اخْتِلَافِ
u'تَرْجِيحٌ أخْذٌ':Added, #1: 1	تَرْجِيحُ أَخْذِ
u'تَرْجِيحٌ اِسْتِحْقَاقٌ':Added, #1: 1	تَرْجِيحُ الْأَخْذِ
u'تَرْجِيحٌ اِشْتِراطٌ':Added, #1: 1	تَرْجِيحُ اسْتِحْقَاقِ
u'تَرْجِيحٌ اِشْتِراطٌ':Added, #1: 1	تَرْجِيحَ اشْتِرَاطِ
u'تَرْجِيحٌ أَصْحَابٌ':Added, #1: 1	تَرْجِيحِ اشْتِرَاطِ
u'تَرْجِيحٌ أصل':Added, #2: 2	تَرْجِيحُ الْأَصْحَابِ
u'تَرْجِيحٌ أًصْلٌ':Added, #2: 2	تَرْجِيحِ الْأَصْلِ
u'تَرْجِيحٌ إِطْلاقٌ':Added, #2: 2	تَرْجِيحِ الْأَصْلِ
u'تَرْجِيحٌ إِطْلاقٌ':Added, #1: 1	تَرْجِيحُ إطْلَاقِ
u'تَرْجِيحٌ إِعْتاقٌ':Added, #2: 2	تَرْجِيحُ الْإِطْلَاقِ
u'تَرْجِيحٌ اِعْتِبارٌ':Added, #1: 1	تَرْجِيحِ الْإِعْتَاقِ
u'تَرْجِيحٌ اِعْتِبارٌ':Added, #1: 1	تَرْجِيحُ اعْتِبَارِهِ
u'تَرْجِيحٌ اِعْتِبارٌ':Added, #2: 2	تَرْجِيحَ اعْتِبَارِ
u'تَرْجِيحٌ أَقْيِسَةٌ':Added, #2: 2	تَرْجِيحِ اعْتِبَارِ
u'تَرْجِيحٌ أَكْثَرُ':Added, #4: 4	تَرْجِيحِ الْأَقْيِسَةِ
u'تَرْجِيحٌ إلْحَاقٌ':Added, #2: 2	تَرْجِيحُ الْأَكْثَرِ
u'تَرْجِيحٌ اِنْفِساخٌ':Added, #1: 1	تَرْجِيحَ إلْحَاقِ
u'تَرْجِيحٌ أَنْوَاعٌ':Added, #1: 1	تَرْجِيحُ انْفِسَاخِهِ
u'تَرْجِيحٌ أَوَّلُ':Added, #1: 1	تَرْجِيحِ أَنْوَاعِ
u'تَرْجِيحٌ أَوَّلُ':Added, #30: 30	تَرْجِيحُ الْأَوَّلِ
u'تَرْجِيحٌ أَوَّلُ':Added, #6: 6	تَرْجِيحَ الْأَوَّلِ
u'تَرْجِيحٌ أَوْلَوِيٌّ':Added, #7: 7	تَرْجِيحِ الْأَوَّلِ
u'تَرْجِيحٌ بَعْضٌ':Added, #1: 1	تَرْجِيحُ أَوْلَوِيَّةِ
u'تَرْجِيحٌ بَعْضٌ':Added, #2: 2	تَرْجِيحُ الْبَعْضِ
u'تَرْجِيحٌ بَعْضٌ':Added, #2: 2	تَرْجِيحِ الْبَعْضِ
u'تَرْجِيحٌ بَعْضٌ':Added, #2: 2	تَرْجِيحُ بَعْضِ
u'تَرْجِيحٌ بَيِّنَةٌ':Added, #2: 2	تَرْجِيحِ بَعْضِ
u'تَرْجِيحٌ بَيِّنَةٌ':Added, #1: 1	تَرْجِيحَ بَيِّنَةِ
u'تَرْجِيحٌ تَابِعٌ':Added, #3: 3	تَرْجِيحِ بَيِّنَةِ
u'تَرْجِيحٌ تَأْثِيرٌ':Added, #1: 1	تَرْجِيحَ التَّابِعِ
u'تَرْجِيحٌ تَحْرِيمٌ':Added, #1: 1	تَرْجِيحَ التَّأْثِيرِ
u'تَرْجِيحٌ تَحْرِيمٌ':Added, #1: 1	تَرْجِيحُ التَّحْرِيمِ
u'تَرْجِيحٌ تَصْدِيقٌ':Added, #1: 1	تَرْجِيحِ التَّحْرِيمِ
u'تَرْجِيحٌ تَصَرُّفٌ':Added, #1: 1	تَرْجِيحِ تَصْدِيقِ
u'تَرْجِيحٌ تَصَرُّفٌ':Added, #1: 1	تَرْجِيحَ تَصَرُّفِ
u'تَرْجِيحٌ تَعْلِيلٌ':Added, #1: 1	تَرْجِيحُ تَصَرُّفِ
u'تَرْجِيحٌ تَغْلِيظٌ':Added, #1: 1	تَرْجِيحُ التَّعْلِيلِ
u'تَرْجِيحٌ تَلْفيقٌ':Added, #1: 1	تَرْجِيحُ التَّغْلِيظِ
u'تَرْجِيحٌ ثَالِثٌ':Added, #1: 1	تَرْجِيحُ التَّلْفِيقِ
u'تَرْجِيحٌ ثَانِي':Added, #1: 1	تَرْجِيحَ الثَّالِثِ
u'تَرْجِيحٌ ثَانِيَةٌ':Added, #1: 1	تَرْجِيحَ الثَّانِيَةِ
u'تَرْجِيحٌ ثَمَن':Added, #1: 1	تَرْجِيحَ الثَّانِيَةِ
u'تَرْجِيحٌ جَانِبٌ':Added, #1: 1	تَرْجِيحِ الثَّمَنِيَّةِ
u'تَرْجِيحٌ جَانِبٌ':Added, #2: 2	تَرْجِيحَ جَانِبِ
u'تَرْجِيحٌ جَانِبٌ':Added, #4: 4	تَرْجِيحُ جَانِبِ
u'تَرْجِيحٌ جَنْبَةٌ':Added, #4: 4	تَرْجِيحِ جَانِبِ
u'تَرْجِيحٌ جِهَةٌ':Added, #1: 1	تَرْجِيحُ جَنْبَةِ
u'تَرْجِيحٌ جَوَازٌ':Added, #1: 1	تَرْجِيحِ جِهَةِ
u'تَرْجِيحٌ جَوَازٌ':Added, #11: 11	تَرْجِيحُ الْجَوَازِ
u'تَرْجِيحٌ جَوَازٌ':Added, #1: 1	تَرْجِيحِ جَوَازِ
u'تَرْجِيحٌ جَوَازٌ':Added, #2: 2	تَرْجِيحِ الْجَوَازِ
u'تَرْجِيحٌ جَوَازٌ':Added, #2: 2	تَرْجِيحُ جَوَازِ
u'تَرْجِيحٌ حَديثٌ':Added, #3: 3	تَرْجِيحَ الْجَوَازِ
u'تَرْجِيحٌ حُرْمَةٌ':Added, #2: 2	تَرْجِيحِ حَدِيثِ
u'تَرْجِيحٌ حُرْمَةٌ':Added, #1: 1	تَرْجِيحَ الْحُرْمَةِ
u'تَرْجِيحٌ حُرْمَةٌ':Added, #1: 1	تَرْجِيحِ الْحُرْمَةِ
u'تَرْجِيحٌ حَقٌّ':Added, #2: 2	تَرْجِيحُ الْحُرْمَةِ
u'تَرْجِيحٌ حَقِيقٌ':Added, #1: 1	تَرْجِيحُ حَقِّ
u'تَرْجِيحٌ حَقِيقَةٌ':Added, #1: 1	تَرْجِيحُ الْحَقِيقَةِ
u'تَرْجِيحٌ حكمة':Added, #1: 1	تَرْجِيحُ الْحَقِيقَةِ
u'تَرْجِيحٌ حِكْمَةٌ':Added, #1: 1	تَرْجِيحَ الْحِكْمَةِ
u'تَرْجِيحٌ حَمْلٌ':Added, #1: 1	تَرْجِيحَ الْحِكْمَةِ
u'تَرْجِيحٌ حِنْثٌ':Added, #1: 1	تَرْجِيحَ حَمْلِ
u'تَرْجِيحٌ خاصّ':Added, #1: 1	تَرْجِيحُ الْحِنْثِ
u'تَرْجِيحٌ خاصّ':Added, #1: 1	تَرْجِيحَ الْخَاصِّ
u'تَرْجِيحٌ خَبَرٌ':Added, #1: 1	تَرْجِيحُ خَاصٍّ
u'تَرْجِيحٌ خَبَر':Added, #3: 3	تَرْجِيحُ الْخَبَرِ
u'تَرْجِيحٌ خِلاَفٌ':Added, #3: 3	تَرْجِيحُ الْخَبَرِ
u'تَرْجِيحٌ خِلاَفٌ':Added, #1: 1	تَرْجِيحَ خِلَافِ
u'تَرْجِيحٌ خِلاَفٌ':Added, #1: 1	تَرْجِيحُ خِلَافِهِ
u'تَرْجِيحٌ دُخُولٌ':Added, #2: 2	تَرْجِيحَ خِلَافِهِ
u'تَرْجِيحٌ دُخُولٌ':Added, #2: 2	تَرْجِيحَ الدُّخُولِ
u'تَرْجِيحٌ دَعْوَةٌ':Added, #2: 2	تَرْجِيحُ الدُّخُولِ
u'تَرْجِيحٌ دَليلٌ':Added, #1: 1	تَرْجِيحُ الدَّعْوَةِ
u'تَرْجِيحٌ دَليلٌ':Added, #1: 1	تَرْجِيحِ الدَّلِيلِ
u'تَرْجِيحٌ دَليلٌ':Added, #1: 1	تَرْجِيحِ الدَّلِيلَيْنِ
u'تَرْجِيحٌ دَليلٌ':Added, #1: 1	تَرْجِيحِ دَلِيلِ
u'تَرْجِيحٌ رابع':Added, #2: 2	تَرْجِيحِ دَلِيلِهِ
u'تَرْجِيحٌ رَابِعٌ':Added, #1: 1	تَرْجِيحِ الرَّابِعِ
u'تَرْجِيحٌ رَاجِحٌ':Added, #1: 1	تَرْجِيحِ الرَّابِعِ
u'تَرْجِيحٌ رُجُوعٌ':Added, #1: 1	تَرْجِيحُ الرَّاجِحِ
u'تَرْجِيحٌ رَدٌّ':Added, #1: 1	تَرْجِيحُ الرُّجُوعِ
u'تَرْجِيحٌ رُوَاةٌ':Added, #1: 1	تَرْجِيحُ الرَّدِّ
u'تَرْجِيحٌ رِوايَةٌ':Added, #1: 1	تَرْجِيحِ الرّوَاةِ
u'تَرْجِيحٌ رِوايَةٌ':Added, #1: 1	تَرْجِيحُ الرِّوَايَةِ
u'تَرْجِيحٌ رِوايَةٌ':Added, #2: 2	تَرْجِيحِ رِوَايَةِ
u'تَرْجِيحٌ رَوْضَةٌ':Added, #4: 4	تَرْجِيحُ رِوَايَةِ
u'تَرْجِيحٌ زَكاةٌ':Added, #2: 2	تَرْجِيحِ الرَّوْضَةِ
u'تَرْجِيحٌ سَبْرٌ':Added, #1: 1	تَرْجِيحِ زَكَاةِ
u'تَرْجِيحٌ سَبْقٌ':Added, #1: 1	تَرْجِيحُ السَّبْرِ
u'تَرْجِيحٌ سُرُوجِيّ':Added, #1: 1	تَرْجِيحِ السَّبْقِ
u'تَرْجِيحٌ سُقُوطٌ':Added, #1: 1	تَرْجِيحُ السُّرُوجِيِّ
u'تَرْجِيحٌ سُقُوطٌ':Added, #1: 1	تَرْجِيحُ السُّقُوطِ
u'تَرْجِيحٌ شَاهِدٌ':Added, #1: 1	تَرْجِيحَ سُقُوطِ
u'تَرْجِيحٌ شَاهِدٌ':Added, #1: 1	تَرْجِيحَ الشَّاهِدِ
u'تَرْجِيحٌ شَرْحٌ':Added, #2: 2	تَرْجِيحُ الشَّاهِدَيْنِ
u'تَرْجِيحٌ شَرْحٌ':Added, #1: 1	تَرْجِيحِ الشَّرْحِ
u'تَرْجِيحٌ شَرْعِيٌّ':Added, #2: 2	تَرْجِيحَ الشَّرْحِ
u'تَرْجِيحٌ شَيْخٌ':Added, #1: 1	تَرْجِيحُ الشَّرْعِيِّ
u'تَرْجِيحٌ شَيْخٌ':Added, #1: 1	تَرْجِيحِ الشَّيْخَيْنِ
u'تَرْجِيحٌ صِحَّةٌ':Added, #2: 2	تَرْجِيحُ الشَّيْخَيْنِ
u'تَرْجِيحٌ صِحَّةٌ':Added, #1: 1	تَرْجِيحَ الصِّحَّةِ
u'تَرْجِيحٌ صِحَّةٌ':Added, #1: 1	تَرْجِيحَ صِحَّةِ
u'تَرْجِيحٌ صِحَّةٌ':Added, #1: 1	تَرْجِيحِ صِحَّةِ
u'تَرْجِيحٌ صِحَّةٌ':Added, #1: 1	تَرْجِيحُ صِحَّتِهِ
u'تَرْجِيحٌ صِحَّةٌ':Added, #1: 1	تَرْجِيحِ صِحَّتِهِ
u'تَرْجِيحٌ صدق':Added, #7: 7	تَرْجِيحُ الصِّحَّةِ
u'تَرْجِيحٌ صِدْقٌ':Added, #1: 1	تَرْجِيحُ الصِّدْقِ
u'تَرْجِيحٌ صَرِيحٌ':Added, #1: 1	تَرْجِيحُ الصِّدْقِ
u'تَرْجِيحٌ صِفَةٌ':Added, #1: 1	تَرْجِيحٍ صَرِيحٍ
u'تَرْجِيحٌ صِيغَةٌ':Added, #1: 1	تَرْجِيحُ الصِّفَةِ
u'تَرْجِيحٌ ضَمَانٌ':Added, #1: 1	تَرْجِيحَ الصِّيغَةِ
u'تَرْجِيحٌ طَرِيقَةٌ':Added, #1: 1	تَرْجِيحُ الضَّمَانِ
u'تَرْجِيحٌ ظاهِرٌ':Added, #1: 1	تَرْجِيحُ الطَّرِيقَةِ
u'تَرْجِيحٌ ظاهِرٌ':Added, #1: 1	تَرْجِيحَ الظَّاهِرِ
u'تَرْجِيحٌ ظَنٌّ':Added, #2: 2	تَرْجِيحِ الظَّاهِرِ
u'تَرْجِيحٌ ظَواهِرُ':Added, #1: 1	تَرْجِيحِ ظَنِّ
u'تَرْجِيحٌ عَدَالَةٌ':Added, #1: 1	تَرْجِيحِ الظَّوَاهِرِ
u'تَرْجِيحٌ عَدَمٌ':Added, #2: 2	تَرْجِيحُ الْعَدَالَةِ
u'تَرْجِيحٌ عَدَمٌ':Added, #27: 27	تَرْجِيحُ عَدَمِ
u'تَرْجِيحٌ عَدَمٌ':Added, #6: 6	تَرْجِيحِ عَدَمِ
u'تَرْجِيحٌ عُشْرٌ':Added, #8: 8	تَرْجِيحَ عَدَمِ
u'تَرْجِيحٌ عُشْرٌ':Added, #1: 1	تَرْجِيحُ الْعُشْرِ
u'تَرْجِيحٌ عَقْلٌ':Added, #1: 1	تَرْجِيحِ الْعُشْرِ
u'تَرْجِيحٌ عِلَلٌ':Added, #2: 2	تَرْجِيحُ الْعَقْلِ
u'تَرْجِيحٌ عِلَلٌ':Added, #1: 1	تَرْجِيحُ الْعِلَلِ
u'تَرْجِيحٌ عِلِّيٌّ':Added, #1: 1	تَرْجِيحِ الْعِلَلِ
u'تَرْجِيحٌ عِنَبٌ':Added, #1: 1	تَرْجِيحِ عِلِّيَّةِ
u'تَرْجِيحٌ عَوْدٌ':Added, #1: 1	تَرْجِيحَ الْعِنَبِ
u'تَرْجِيحٌ عِيدٌ':Added, #1: 1	تَرْجِيحِ عَوْدِهِ
u'تَرْجِيحٌ غَيْبَةٌ':Added, #2: 2	تَرْجِيحُ عِيدِ
u'تَرْجِيحٌ غير':Added, #1: 1	تَرْجِيحُ الْغَيْبَةِ
u'تَرْجِيحٌ غَيْرٌ':Added, #2: 2	تَرْجِيحُ غَيْرِ
u'تَرْجِيحٌ فساد':Added, #2: 2	تَرْجِيحُ غَيْرِ
u'تَرْجِيحٌ فَسَادٌ':Added, #1: 1	تَرْجِيحُ الْفَسَادِ
u'تَرْجِيحٌ فَسْخٌ':Added, #1: 1	تَرْجِيحُ الْفَسَادِ
u'تَرْجِيحٌ فِعْلٌ':Added, #2: 2	تَرْجِيحِ الْفَسْخِ
u'تَرْجِيحٌ فِعْلٌ':Added, #1: 1	تَرْجِيحُ الْفِعْلِ
u'تَرْجِيحٌ قِرَاءةٌ':Added, #2: 2	تَرْجِيحِ الْفِعْلِ
u'تَرْجِيحٌ قُوَّةٌ':Added, #1: 1	تَرْجِيحِ الْقِرَاءَةِ
u'تَرْجِيحٌ قُوَّة':Added, #1: 1	تَرْجِيحَ الْقُوَّةِ
u'تَرْجِيحٌ قول':Added, #1: 1	تَرْجِيحَ الْقُوَّةِ
u'تَرْجِيحٌ قَوْلٌ':Added, #10: 10	تَرْجِيحُ الْقَوْلِ
u'تَرْجِيحٌ قول':Added, #10: 10	تَرْجِيحُ الْقَوْلِ
u'تَرْجِيحٌ قَوْلٌ':Added, #1: 1	تَرْجِيحَ قَوْلِ
u'تَرْجِيحٌ قول':Added, #1: 1	تَرْجِيحَ قَوْلِ
u'تَرْجِيحٌ قَوْلٌ':Added, #1: 1	تَرْجِيحِ قَوْلِهِ
u'تَرْجِيحٌ قول':Added, #1: 1	تَرْجِيحِ قَوْلِهِ
u'تَرْجِيحٌ قَوْلٌ':Added, #2: 2	تَرْجِيحِ الْقَوْلِ
u'تَرْجِيحٌ قول':Added, #2: 2	تَرْجِيحِ الْقَوْلِ
u'تَرْجِيحٌ قَوْلٌ':Added, #3: 3	تَرْجِيحَ الْقَوْلِ
u'تَرْجِيحٌ قول':Added, #3: 3	تَرْجِيحَ الْقَوْلِ
u'تَرْجِيحٌ قَوْلٌ':Added, #5: 5	تَرْجِيحِ قَوْلِ
u'تَرْجِيحٌ قول':Added, #5: 5	تَرْجِيحِ قَوْلِ
u'تَرْجِيحٌ قَوْلٌ':Added, #8: 8	تَرْجِيحُ قَوْلِ
u'تَرْجِيحٌ قِيَاسٌ':Added, #8: 8	تَرْجِيحُ قَوْلِ
u'تَرْجِيحٌ قِيَاسٌ':Added, #3: 3	تَرْجِيحُ الْقِيَاسِ
u'تَرْجِيحٌ كَثْرَةٌ':Added, #3: 3	تَرْجِيحِ الْقِيَاسِ
u'تَرْجِيحٌ كَثْرَةٌ':Added, #1: 1	تَرْجِيحِ الْكَثْرَةِ
u'تَرْجِيحٌ كَرَاهَةٌ':Added, #2: 2	تَرْجِيحُ الْكَثْرَةِ
u'تَرْجِيحٌ كَلاَمٌ':Added, #1: 1	تَرْجِيحُ الْكَرَاهَةِ
u'تَرْجِيحٌ كَوْنٌ':Added, #2: 2	تَرْجِيحِ كَلَامِ
u'تَرْجِيحٌ كَوْنٌ':Added, #1: 1	تَرْجِيحَ كَوْنِ
u'تَرْجِيحٌ كَوْنٌ':Added, #1: 1	تَرْجِيحِ كَوْنِ
u'تَرْجِيحٌ كَوْنٌ':Added, #1: 1	تَرْجِيحَ كَوْنِهِ
u'تَرْجِيحٌ لُزُومٌ':Added, #1: 1	تَرْجِيحِ كَوْنِهِ
u'تَرْجِيحٌ لُزُومٌ':Added, #1: 1	تَرْجِيحُ اللُّزُومِ
u'تَرْجِيحٌ لُغَةٌ':Added, #2: 2	تَرْجِيحِ اللُّزُومِ
u'تَرْجِيحٌ مالِك':Added, #1: 1	تَرْجِيحِ اللُّغَةِ
u'تَرْجِيحٌ مالِكِيّ':Added, #1: 1	تَرْجِيحِ الْمَالِكِيَّةِ
u'تَرْجِيحٌ مُثْبَتٌ':Added, #1: 1	تَرْجِيحِ الْمَالِكِيَّةِ
u'تَرْجِيحٌ مَجَازٌ':Added, #1: 1	تَرْجِيحِ مُثْبَتِ
u'تَرْجِيحٌ مَجَازٌ':Added, #1: 1	تَرْجِيحِ الْمَجَازِ
u'تَرْجِيحٌ مُجْتَهِد':Added, #2: 2	تَرْجِيحُ الْمَجَازِ
u'تَرْجِيحٌ مُحَرَّمٌ':Added, #1: 1	تَرْجِيحُ الْمُجْتَهِدِ
u'تَرْجِيحٌ مُحَرَّمٌ':Added, #1: 1	تَرْجِيحَ الْمُحَرَّمِ
u'تَرْجِيحٌ مُخَالِفٌ':Added, #2: 2	تَرْجِيحُ الْمُحَرَّمِ
u'تَرْجِيحٌ مُخَالِفٌ':Added, #1: 1	تَرْجِيحُ الْمُخَالِفِ
u'تَرْجِيحٌ مَسْحٌ':Added, #1: 1	تَرْجِيحِ الْمُخَالِفِ
u'تَرْجِيحٌ مَشَايِخُ':Added, #2: 2	تَرْجِيحُ الْمَسْحِ
u'تَرْجِيحٌ مُشْتَرَكٌ':Added, #2: 2	تَرْجِيحُ الْمَشَايِخِ
u'تَرْجِيحٌ مَصْلَحَةٌ':Added, #1: 1	تَرْجِيحِ الْمُشْتَرَكِ
u'تَرْجِيحٌ مَصْلَحَةٌ':Added, #1: 1	تَرْجِيحُ الْمَصْلَحَةِ
u'تَرْجِيحٌ مُعارِضٌ':Added, #1: 1	تَرْجِيحِ الْمَصْلَحَةِ
u'تَرْجِيحٌ مَعْنَوِيٌّ':Added, #1: 1	تَرْجِيحِ الْمُعَارِضِ
u'تَرْجِيحٌ مَفْهُومٌ':Added, #1: 1	تَرْجِيحِ الْمَعْنَوِيِّ
u'تَرْجِيحٌ مُقَابِلٌ':Added, #1: 1	تَرْجِيحُ مَفْهُومِ
u'تَرْجِيحٌ مُقَرَّرٌ':Added, #1: 1	تَرْجِيحَ مُقَابِلِهِ
u'تَرْجِيحٌ مُكْرِهٌ':Added, #1: 1	تَرْجِيحُ الْمُقَرَّرِ
u'تَرْجِيحٌ مَنْعٌ':Added, #1: 1	تَرْجِيحِ الْمُكْرِهِ
u'تَرْجِيحٌ مَنْعٌ':Added, #12: 12	تَرْجِيحُ الْمَنْعِ
u'تَرْجِيحٌ مَنْعٌ':Added, #1: 1	تَرْجِيحُ مَنْعِ
u'تَرْجِيحٌ مَوْصُولٌ':Added, #2: 2	تَرْجِيحَ الْمَنْعِ
u'تَرْجِيحٌ نَافِي':Added, #1: 1	تَرْجِيحَ الْمَوْصُولِ
u'تَرْجِيحٌ نَاقِلٌ':Added, #1: 1	تَرْجِيحُ النَّافِيَةِ
u'تَرْجِيحٌ نَاقِلٌ':Added, #1: 1	تَرْجِيحُ النَّاقِلِ
u'تَرْجِيحٌ نَجَاسَةٌ':Added, #1: 1	تَرْجِيحِ النَّاقِلَةِ
u'تَرْجِيحٌ نَصٌّ':Added, #1: 1	تَرْجِيحُ النَّجَاسَةِ
u'تَرْجِيحٌ نَفْلٌ':Added, #1: 1	تَرْجِيحَ النَّصِّ
u'تَرْجِيحٌ نُفُوذٌ':Added, #1: 1	تَرْجِيحَ النَّفْلِ
u'تَرْجِيحٌ نَقْضٌ':Added, #1: 1	تَرْجِيحُ النُّفُوذِ
u'تَرْجِيحٌ نَوْعٌ':Added, #1: 1	تَرْجِيحُ نَقْضِهِ
u'تَرْجِيحٌ واحد':Added, #1: 1	تَرْجِيحِ النَّوْعِ
u'تَرْجِيحٌ واحد':Added, #1: 1	تَرْجِيحَ وَاحِدٍ
u'تَرْجِيحٌ وَاحِدٌ':Added, #1: 1	تَرْجِيحُ وَاحِدٍ
u'تَرْجِيحٌ وَاحِدٌ':Added, #1: 1	تَرْجِيحَ وَاحِدٍ
u'تَرْجِيحٌ وَجْهٌ':Added, #1: 1	تَرْجِيحُ وَاحِدٍ
u'تَرْجِيحٌ وُجُوبٌ':Added, #1: 1	تَرْجِيحُ الْوَجْهِ
u'تَرْجِيحٌ وُجُوبٌ':Added, #1: 1	تَرْجِيحَ الْوُجُوبِ
u'تَرْجِيحٌ وُجُوبٌ':Added, #1: 1	تَرْجِيحِ الْوُجُوبِ
u'تَرْجِيحٌ وُجُوبٌ':Added, #1: 1	تَرْجِيحُ وُجُوبِ
u'تَرْجِيحٌ وُجُوبٌ':Added, #1: 1	تَرْجِيحُ وُجُوبِهِ
u'تَرْجِيحٌ وُجُودٌ':Added, #3: 3	تَرْجِيحُ الْوُجُوبِ
u'تَرْجِيحٌ وَصْفٌ':Added, #1: 1	تَرْجِيحِ الْوُجُودِ
u'تَرْجِيحٌ وفاة':Added, #1: 1	تَرْجِيحَ وَصْفِ
u'تَرْجِيحٌ وَفَاةٌ':Added, #1: 1	تَرْجِيحِ وَفَاتِهِ
u'تَرْجِيحٌ وَقْفٌ':Added, #1: 1	تَرْجِيحِ وَفَاتِهِ
u'تَرْجِيحٌ وُقُوعٌ':Added, #2: 2	تَرْجِيحَ الْوَقْفِ
u'تَرْجِيعٌ أَذَانٌ':Added, #1: 1	تَرْجِيح الْوُقُوعِ
u'تَرْجِيعٌ أَذَانٌ':Added, #1: 1	تَرْجِيعُ الْأَذَانِ
u'تَرْجِيعٌ أَذَانٌ':Added, #1: 1	تَرْجِيعِ الْأَذَانِ
u'تَرَحُّمٌ صَغِيرٌ':Added, #2: 2	تَرْجِيعِ الأَذَانِ
u'تَرْدَادٌ خُصُومٌ':Added, #1: 1	تَرَحُّمِ الصَّغِيرَةِ
u'تَرَدَّدَ اِبْنٌ':Subject, #1: 1	تَرْدَادِ الْخُصُومِ
u'تَرَدَّدَ اِجْتِمَاعٌ':Subject, #1: 1	تَرَدَّدَ ابْنُ
u'تَرَدَّدَ أَصْحَابٌ':Subject, #1: 1	تَرَدَّدَ اجْتِمَاعُ
u'تَرَدُّدٌ أَصْحَابٌ':Added, #4: 4	تَرَدَّدَ الْأَصْحَابُ
u'تَرَدَّدَ أَمْرٌ':Subject, #1: 1	تَرَدُّدِ الْأَصْحَابِ
u'تَرَدُّدٌ أَمْرٌ':Added, #2: 2	تَرَدَّدَ الْأَمْرُ
u'تَرَدَّدَ بَعْضٌ':Subject, #2: 2	تَرَدُّدِ الْأَمْرِ
u'تَرَدَّدَ بَيْنٌ':Predicate, #3: 3	تَرَدَّدَ بَعْضُ
u'تَرَدُّدٌ بَيِّنَةٌ':Added, #42: 42	تَرَدَّدَ بَيْنَ
u'تَرَدَّدَ تَخْصِيصٌ':Subject, #2: 2	تَرَدُّدِ الْبَيِّنَةِ
u'تَرَدُّدٌ تَخْصِيصٌ':Added, #1: 1	تَرَدَّدَ التَّخْصِيصُ
u'تَرَدَّدَ تونِسِيّ':Subject, #1: 1	تَرَدُّدُ التَّخْصِيصِ
u'تَرَدُّدٌ جَوَابٌ':Added, #1: 1	تَرَدَّدَ التُّونِسِيُّ
u'تَرَدَّدَ حُكْمٌ':Subject, #1: 1	تَرَدُّدُ جَوَابٍ
u'تَرَدَّدَ دَمٌ':Subject, #1: 1	تَرَدَّدَ الْحُكْمُ
u'تَرَدُّدٌ ذِهْنٌ':Added, #1: 1	تَرَدَّدَ دَمُهُ
u'تَرَدَّدَ رَأْيٌ':Subject, #1: 1	تَرَدُّدِ الذِّهْنِ
u'تَرَدَّدَ رِيقٌ':Subject, #1: 1	تَرَدَّدَ رَأْيُ
u'تَرَدَّدَ سائِل':Subject, #1: 1	تَرَدَّدَ رِيقُهُ
u'تَرَدَّدَ سَائِلٌ':Subject, #1: 1	تَرَدَّدَ السَّائِلُ
u'تَرَدَّدَ شافِعِيّ':Subject, #1: 1	تَرَدَّدَ السَّائِلُ
u'تَرَدُّدٌ شافِعِيّ':Added, #2: 2	تَرَدَّدَ الشَّافِعِيُّ
u'تَرَدُّدٌ شافِعِيّ':Added, #1: 1	تَرَدُّدَ الشَّافِعِيِّ
u'تَرَدَّدَ شَبَهٌ':Subject, #1: 1	تَرَدُّدُ الشَّافِعِيِّ
u'تَرَدُّدٌ شَيْخٌ':Added, #2: 2	تَرَدَّدَ شَبَهُهُ
u'تَرَدُّدٌ شَيْخٌ':Added, #1: 1	تَرَدُّدُ الشَّيْخِ
u'تَرَدُّدٌ شُيُوخٌ':Added, #1: 1	تَرَدُّدِ الشَّيْخِ
u'تَرَدَّدَ طَلاَقٌ':Subject, #1: 1	تَرَدُّدُ الشُّيُوخِ
u'تَرَدَّدَ طلب':Subject, #1: 1	تَرَدَّدَ الطَّلَاقُ
u'تَرَدَّدَ طَلَبٌ':Subject, #1: 1	تَرَدَّدَ الطَّلَبُ
u'تَرَدُّدٌ عَادَةٌ':Added, #1: 1	تَرَدَّدَ الطَّلَبُ
u'تَرَدَّدَ فَرْعٌ':Subject, #1: 1	تَرَدُّدِ الْعَادَةِ
u'تَرَدُّدٌ فَرْعٌ':Added, #1: 1	تَرَدَّدَ فَرْعٌ
u'تَرَدُّدٌ فقهاء':Added, #1: 1	تَرَدُّدُ الْفَرْعِ
u'تَرَدَّدَ فلان':Subject, #2: 2	تَرَدُّدَ الْفُقَهَاءِ
u'تَرَدُّدٌ فلان':Added, #2: 2	تَرَدَّدَ الشَّافِعِيُّ
u'تَرَدُّدٌ فلان':Added, #1: 1	تَرَدُّدَ الشَّافِعِيِّ
u'تَرَدُّدٌ فلان':Added, #1: 1	تَرَدُّدُ الشَّافِعِيِّ
u'تَرَدَّدَ قول':Subject, #1: 1	تَرَدُّدُ الْمَكِّيِّ
u'تَرَدَّدَ قَوْلٌ':Subject, #1: 1	تَرَدَّدَ قَوْلُ
u'تَرَدَّدَ قول':Subject, #1: 1	تَرَدَّدَ قَوْلُ
u'تَرَدَّدَ قَوْلٌ':Subject, #1: 1	تَرَدَّدَ قَوْلُهُ
u'تَرَدُّدٌ كَافِرٌ':Added, #1: 1	تَرَدَّدَ قَوْلُهُ
u'تَرَدَّدَ لَفْظٌ':Subject, #1: 1	تَرَدُّدِ كَافِرٍ
u'تَرَدَّدَ لَفْظٌ':Subject, #1: 1	تَرَدَّدَ لَفْظٌ
u'تَرَدُّدٌ لَفْظٌ':Added, #4: 4	تَرَدَّدَ اللَّفْظُ
u'تَرَدُّدٌ مَاءٌ':Added, #1: 1	تَرَدُّدَ اللَّفْظِ
u'تَرَدَّدَ مُصَنِّفٌ':Subject, #1: 1	تَرَدُّدِ الْمَاءِ
u'تَرَدَّدَ مَفْهُومٌ':Subject, #1: 1	تَرَدَّدَ الْمُصَنِّفُ
u'تَرَدُّدٌ مَكِّيّ':Added, #1: 1	تَرَدَّدَ الْمَفْهُومُ
u'تَرَدَّدَ نَاسٌ':Subject, #1: 1	تَرَدُّدُ الْمَكِّيِّ
u'تَرَدَّدَ نَصٌّ':Subject, #1: 1	تَرَدَّدَ النَّاسُ
u'تَرَدَّدَ نَظَرٌ':Subject, #1: 1	تَرَدَّدَ نَصُّهُ
u'تَرَدُّدٌ نَظَرٌ':Added, #1: 1	تَرَدَّدَ نَظَرُهُ
u'تَرَدُّدٌ نِيَّةٌ':Added, #1: 1	تَرَدُّدِ النَّظَرِ
u'تَرَدَّى بَعيرٌ':Subject, #1: 1	تَرَدُّدِ النِّيَّةِ
u'تَرْدِيدٌ أَجْرٌ':Added, #2: 2	تَرَدَّى بَعِيرٌ
u'تَرْدِيدٌ أُجْرَةٌ':Added, #1: 1	تَرْدِيدُ الْأَجْرِ
u'تَرْدِيدٌ أُجْرَةٌ':Added, #1: 1	تَرْدِيدُ الْأُجْرَةِ
u'تَرْدِيدٌ أَجِيرٌ':Added, #1: 1	تَرْدِيدِ الْأُجْرَةِ
u'تَرْدِيدٌ سائِل':Added, #1: 1	تَرْدِيدُ الْأَجِيرِ
u'تَرْدِيدٌ سَائِلٌ':Added, #1: 1	تَرْدِيدِ السَّائِلِ
u'تَرْدِيدٌ علم':Added, #1: 1	تَرْدِيدِ السَّائِلِ
u'تَرْدِيدٌ عِلْمٌ':Added, #1: 1	تَرْدِيدُ الْعِلْمِ
u'تَرْدِيدٌ قول':Added, #1: 1	تَرْدِيدُ الْعِلْمِ
u'تَرْدِيدٌ قَوْلٌ':Added, #1: 1	تَرْدِيدُ الْقَوْلِ
u'تَرْدِيدٌ مَاعِزٌ':Added, #1: 1	تَرْدِيدُ الْقَوْلِ
u'تَرَدَّى رَجُلٌ':Subject, #1: 1	تَرْدِيدَ مَاعِزٍ
u'تَرَسَّخَ مَدْحٌ':Subject, #2: 2	تَرَدَّى رَجُلٌ
u'تَرْسِيلٌ أَذَانٌ':Added, #1: 1	تَرَسَّخَ مَدْحُهُ
u'تَرْشِيحٌ اِبْنٌ':Added, #1: 1	تَرْسِيلِ الأَذَانِ
u'تَرَصُّدٌ أَسْواقٌ':Added, #2: 2	تَرْشِيحُ ابْنِ
u'تَرْصِيعٌ مَبَانِي':Added, #1: 1	تَرَصُّدِ الْأَسْوَاقِ
u'تَرَطَّبَ قَالٌ':Predicate, #1: 1	تَرْصِيعِ مَبَانِيهِ
u'تَرَطَّبَ مَتَاعٌ':Subject, #1: 1	تَرَطَّبَ قَالَ
u'تَرَعْرَعَ غُلاَمٌ':Subject, #1: 1	تَرَطَّبَ الْمَتَاعُ
u'تَرَعْرَعَ قَالٌ':Predicate, #1: 1	تَرَعْرَعَ الْغُلَامُ
u'تَرْغِيبٌ سادة':Added, #1: 1	تَرَعْرَعَ قَالَ
u'تَرْغِيبٌ سَادَةٌ':Added, #1: 1	تَرْغِيبُ السَّادَةِ
u'تَرْغِيبٌ غير':Added, #1: 1	تَرْغِيبُ السَّادَةِ
u'تَرْغِيبٌ غَيْرٌ':Added, #1: 1	تَرْغِيبُ الْغَيْرِ
u'تَرْغِيبٌ لبس':Added, #1: 1	تَرْغِيبُ الْغَيْرِ
u'تَرْغِيبٌ لُبْسٌ':Added, #2: 2	تَرْغِيبِ اللُّبْسِ
u'تَرْغِيبٌ مَالِكٌ':Added, #2: 2	تَرْغِيبِ اللُّبْسِ
u'تَرْغِيبٌ نَاسٌ':Added, #1: 1	تَرْغِيبَ الْمَالِكِ
u'تَرْغِيبٌ نَاسٌ':Added, #1: 1	تَرْغِيبَ النَّاسِ
u'تَرْغِيبٌ نَاسٌ':Added, #1: 1	تَرْغِيبُ النَّاسِ
u'تَرَفُّعٌ أَعْمَالٌ':Added, #1: 1	تَرْغِيبِ النَّاسِ
u'تَرْفِيهٌ خَادِمٌ':Added, #1: 1	تَرَفُّعُ الْأَعْمَالِ
u'تَرَقُّبٌ زَوالٌ':Added, #1: 1	تَرْفِيهُ الْخَادِمِ
u'تَرَقُّبٌ شمس':Added, #1: 1	تَرَقُّبُ زَوَالِهِ
u'تَرَقُّبٌ شَمْسٌ':Added, #1: 1	تَرَقُّبُ الشَّمْسِ
u'تَرَقُّبٌ عتق':Added, #1: 1	تَرَقُّبُ الشَّمْسِ
u'تَرَقُّبٌ عِتْقٌ':Added, #1: 1	تَرَقُّبِ عِتْقِهِ
u'تَرَقِّي مَاءٌ':Added, #1: 1	تَرَقُّبِ عِتْقِهِ
u'تَرَكَ أَبٌ':Predicate, #1: 1	تَرَقِّي الْمَاءِ
u'تَرَكَ أَبٌ':Subject, #2: 2	تَرَكَ أَبَ
u'تَرَكَ اِبْنٌ':Predicate, #3: 3	تَرَكَ الْأَبُ
u'تَرَكَ اِبْنٌ':Subject, #15: 15	تَرَكَ ابْنَ
u'تَرَكَ اِبْنٌ':Subject, #1: 1	تَرَكَ ابْنُهُ
u'تَرَكَ اِبْنَة':Predicate, #5: 5	تَرَكَ ابْنُ
u'تَرْكٌ اِتِّبَاعٌ':Added, #13: 13	تَرَكَ ابْنَةَ
u'تَرْكٌ اِتِّخَاذٌ':Added, #1: 1	تَرْكَ اتِّبَاعِ
u'تَرْكٌ إِتْيانٌ':Added, #1: 1	تَرْكُ اتِّخَاذِ
u'تَرْكٌ إِتْيانٌ':Added, #1: 1	تَرْكُ الْإِتْيَانِ
u'تَرْكٌ آثَامٌ':Added, #2: 2	تَرْكِ إِتْيَانِ
u'تَرْكٌ إِجَابَةٌ':Added, #1: 1	تَرْكِ الْآثَامِ
u'تَرْكٌ إِجَابَةٌ':Added, #10: 10	تَرْكُ إجَابَةِ
u'تَرْكٌ إِجَابَةٌ':Added, #1: 1	تَرْكَ إجَابَةِ
u'تَرْكٌ إِجَابَةٌ':Added, #1: 1	تَرْكَ الْإِجَابَةِ
u'تَرْكٌ إِجَابَةٌ':Added, #1: 1	تَرْكُ الْإِجَابَةِ
u'تَرْكٌ إِجْرَاءٌ':Added, #3: 3	تَرْكِ الْإِجَابَةِ
u'تَرْكٌ أُجْرَةٌ':Added, #1: 1	تَرْكِ إِجْرَاءِ
u'تَرْكٌ أَجَلٌ':Added, #2: 2	تَرْكَ الْأُجْرَةِ
u'تَرَكَ إجْلالٌ':Predicate, #1: 1	تَرْكَ أَجَلٍ
u'تَرْكٌ أَحادِيثُ':Added, #1: 1	تَرَكَ إجْلَالَ
u'تَرَكَ أَحِبَّةٌ':Predicate, #1: 1	تَرْكُ الأَحَادِيثِ
u'تَرْكٌ اِحْتِيَاطٌ':Added, #1: 1	تَرَكَ الْأَحِبّةَ
u'تَرْكٌ أحَدٌ':Added, #1: 1	تَرْكَ احْتِيَاطٍ
u'تَرَكَ إِحْرَامٌ':Predicate, #2: 2	تَرْكُ أَحَدِ
u'تَرْكٌ إِحْرَامٌ':Added, #5: 5	تَرَكَ الْإِحْرَامَ
u'تَرْكٌ إِحْرَامٌ':Added, #1: 1	تَرْكِ الْإِحْرَامِ
u'تَرْكٌ إحْسَانٌ':Added, #3: 3	تَرْكُ الْإِحْرَامِ
u'تَرْكٌ إحْسَانٌ':Added, #1: 1	تَرْكَ الْإِحْسَانِ
u'تَرْكٌ إحْسَانٌ':Added, #2: 2	تَرْكُ الْإِحْسَانِ
u'تَرَكَ أَحْسَنُ':Predicate, #2: 2	تَرْكِ الْإِحْسَانِ
u'تَرْكٌ أَحَقُّ':Added, #1: 1	تَرَكَ الْأَحْسَنَ
u'تَرَكَ إِحْيَاءٌ':Predicate, #1: 1	تَرْكُ الْأَحَقِّ
u'تَرَكَ أخْبَارٌ':Predicate, #2: 2	تَرَكَ الْإِحْيَاءَ
u'تَرَكَ أَخْبَارٌ':Predicate, #1: 1	تَرَكَ أَخْبَارَ
u'تَرَكَ إِخْبَارٌ':Predicate, #1: 1	تَرَكَ أَخْبَارَ
u'تَرْكٌ إِخْبَارٌ':Added, #1: 1	تَرَكَ الْإِخْبَارَ
u'تَرَكَ أخْذٌ':Predicate, #1: 1	تَرْكِ الْإِخْبَارِ
u'تَرْكٌ أخْذٌ':Added, #1: 1	تَرَكَ الْأَخْذَ
u'تَرْكٌ أخْذٌ':Added, #1: 1	تَرْكِ أَخْذِ
u'تَرْكٌ أخْذٌ':Added, #1: 1	تَرْكَ الْأَخْذِ
u'تَرْكٌ أخْذٌ':Added, #1: 1	تَرْكُ الْأَخْذِ
u'تَرْكٌ إِخْرَاجٌ':Added, #3: 3	تَرْكِ الْأَخْذِ
u'تَرْكٌ أَخِيرٌ':Added, #1: 1	تَرْكِ إخْرَاجِ
u'تَرَكَ أَدَاءٌ':Predicate, #1: 1	تَرْكِ الْأَخِيرِ
u'تَرْكٌ أَدَاءٌ':Added, #2: 2	تَرَكَ أَدَاءَ
u'تَرْكٌ أَدَاءٌ':Added, #1: 1	تَرْكُ الْأَدَاءِ
u'تَرْكٌ أَدَاءٌ':Added, #2: 2	تَرْكُ أَدَاءِ
u'تَرَكَ آدابٌ':Predicate, #5: 5	تَرْكِ الْأَدَاءِ
u'تَرَكَ أدَب':Predicate, #1: 1	تَرَكَ الْآدَابَ
u'تَرْكٌ أدَب':Added, #1: 1	تَرَكَ الْأَدَبَ
u'تَرْكٌ أدَب':Added, #1: 1	تَرْكُ أَدَبٍ
u'تَرْكٌ إدْخَالٌ':Added, #4: 4	تَرْكُ الْأَدَبِ
u'تَرَكَ أَذَانٌ':Predicate, #1: 1	تَرْكُ إدْخَالِ
u'تَرْكٌ أَذَانٌ':Added, #2: 2	تَرَكَ الْأَذَانَ
u'تَرْكٌ أَذَانٌ':Added, #1: 1	تَرْكَ الأَذَانِ
u'تَرْكٌ أَذَانٌ':Added, #1: 1	تَرْكِ الأَذَانِ
u'تَرْكٌ أَذَانٌ':Added, #1: 1	تَرْكَ الْأَذَانِ
u'تَرْكٌ أَذَانٌ':Added, #2: 2	تَرْكُ الْأَذَانِ
u'تَرْكٌ إِذْلاَلٌ':Added, #5: 5	تَرْكِ الْأَذَانِ
u'تَرَكَ أَرْبَعُ':Predicate, #1: 1	تَرْكَ إذْلَالِ
u'تَرَكَ أَرْبَعُ':Predicate, #2: 2	تَرَكَ الْأَرْبَعَ
u'تَرْكٌ أَرْبَعُ':Added, #5: 5	تَرَكَ أَرْبَعَ
u'تَرَكَ أَرْبَعَةٌ':Predicate, #1: 1	تَرْكِ الْأَرْبَعِ
u'تَرْكٌ إِرْسَالٌ':Added, #2: 2	تَرَكَ أَرْبَعَةَ
u'تَرَكَ أرْضٌ':Predicate, #1: 1	تَرْكِ إرْسَالِهِ
u'تَرْكٌ أَرِقَّاءُ':Added, #2: 2	تَرَكَ الْأَرْضَ
u'تَرْكٌ أَرْكانٌ':Added, #1: 1	تَرْكِ الْأَرِقَّاءِ
u'تَرْكٌ أَرْكَانٌ':Added, #1: 1	تَرْكِ الْأَرْكَانِ
u'تَرْكٌ إِزَالَةٌ':Added, #1: 1	تَرْكِ الْأَرْكَانِ
u'تَرَكَ إِسَاءةٌ':Predicate, #1: 1	تَرْكُ إزَالَتِهِ
u'تَرْكٌ أسْبَابٌ':Added, #1: 1	تَرَكَ إسَاءَةَ
u'تَرْكٌ أَسْبَابٌ':Added, #1: 1	تَرْكِ الْأَسْبَابِ
u'تَرْكٌ اِسْتِعْمالٌ':Added, #1: 1	تَرْكِ الْأَسْبَابِ
u'تَرْكٌ اِسْتِعْمالٌ':Added, #1: 1	تَرْكَ اسْتِعْمَالِ
u'تَرْكٌ اِسْتِعْمالٌ':Added, #1: 1	تَرْكُ اسْتِعْمَالِ
u'تَرَكَ اِسْتِقْبالٌ':Predicate, #2: 2	تَرْكِ اسْتِعْمَالِ
u'تَرْكٌ اِسْتِقْبالٌ':Added, #2: 2	تَرَكَ اسْتِقْبَالَ
u'تَرَكَ اِسْتِلامٌ':Predicate, #1: 1	تَرْكِ اسْتِقْبَالِ
u'تَرْكٌ اِسْتِلامٌ':Added, #2: 2	تَرَكَ اسْتِلاَمَ
u'تَرْكٌ اِسْتيعابٌ':Added, #1: 1	تَرْكُ اسْتِلَامِ
u'تَرْكٌ إِسْرافٌ':Added, #1: 1	تَرْكِ اسْتِيعَابِ
u'تَرْكٌ إِسْلامٌ':Added, #2: 2	تَرْكُ الْإِسْرَافِ
u'تَرْكٌ إِسْلامٌ':Added, #1: 1	تَرْكَ الْإِسْلَامِ
u'تَرْكٌ إِسْلامٌ':Added, #1: 1	تَرْكُ الْإِسْلَامِ
u'تَرْكٌ إِصْرارٌ':Added, #1: 1	تَرْكِ الْإِسْلَامِ
u'تَرْكٌ أًصْلٌ':Added, #1: 1	تَرْكِ الْإِصْرَارِ
u'تَرْكٌ أصل':Added, #1: 1	تَرْكُ أَصْلٍ
u'تَرْكٌ أًصْلٌ':Added, #1: 1	تَرْكِ الْأَصْلِ
u'تَرْكٌ أصل':Added, #1: 1	تَرْكِ الْأَصْلِ
u'تَرْكٌ أًصْلٌ':Added, #2: 2	تَرْكُ الْأَصْلِ
u'تَرْكٌ أصل':Added, #2: 2	تَرْكُ الْأَصْلِ
u'تَرْكٌ أًصْلٌ':Added, #3: 3	تَرْكُ أَصْلِ
u'تَرَكَ إضافَةٌ':Predicate, #3: 3	تَرْكُ أَصْلِ
u'تَرَكَ إِطْعامٌ':Predicate, #2: 2	تَرَكَ الْإِضَافَةَ
u'تَرْكٌ إِطْعامٌ':Added, #1: 1	تَرَكَ الْإِطْعَامَ
u'تَرْكٌ إِطْلاقٌ':Added, #1: 1	تَرْكِ الْإِطْعَامِ
u'تَرْكٌ إِطْلاقٌ':Added, #1: 1	تَرْكَ إطْلَاقِ
u'تَرْكٌ إِظْهارٌ':Added, #2: 2	تَرْكُ إطْلَاقِ
u'تَرْكٌ إِظْهارٌ':Added, #1: 1	تَرْكَ إظْهَارِ
u'تَرَكَ إِعادَةٌ':Predicate, #1: 1	تَرْكُ إظْهَارِ
u'تَرْكٌ إِعادَةٌ':Added, #3: 3	تَرَكَ الْإِعَادَةَ
u'تَرْكٌ اِعْتِبارٌ':Added, #1: 1	تَرْكِ إعَادَتِهِ
u'تَرْكٌ اِعْتِدالٌ':Added, #1: 1	تَرْكُ اعْتِبَارِ
u'تَرَكَ اِعْتِكافٌ':Predicate, #1: 1	تَرْكُ اعْتِدَالٍ
u'تَرَكَ اِعْتِكافٌ':Predicate, #1: 1	تَرَكَ الاِعْتِكَافَ
u'تَرْكٌ إِعْرابٌ':Added, #2: 2	تَرَكَ اعْتِكَافَ
u'تَرْكٌ إعْلاَمٌ':Added, #1: 1	تَرْكُ الْإِعْرَابِ
u'تَرَكَ أَعْمَالٌ':Predicate, #1: 1	تَرْكِ إعْلَامِ
u'تَرْكٌ أَعْمَالٌ':Added, #1: 1	تَرَكَ الْأَعْمَالَ
u'تَرْكٌ أَعْمَالٌ':Added, #1: 1	تَرْكَ أَعْمَالٍ
u'تَرْكٌ أَعْمَالٌ':Added, #1: 1	تَرْكُ أَعْمَالٍ
u'تَرْكٌ أَعْمَالٌ':Added, #1: 1	تَرْكُ أَعْمَالِ
u'تَرْكٌ أَعْمَالٌ':Added, #1: 1	تَرْكَ الْأَعْمَالِ
u'تَرْكٌ أَعْمَالٌ':Added, #1: 1	تَرْكُ الْأَعْمَالِ
u'تَرْكٌ أعْيانٌ':Added, #2: 2	تَرْكِ الْأَعْمَالِ
u'تَرْكٌ أَعْيَانٌ':Added, #1: 1	تَرْكِ الْأَعْيَانِ
u'تَرَكَ أَغْصَانٌ':Predicate, #1: 1	تَرْكِ الْأَعْيَانِ
u'تَرَكَ أفْضَلُ':Subject, #2: 2	تَرَكَ الْأَغْصَانَ
u'تَرْكٌ أفْضَلُ':Added, #1: 1	تَرَكَ الْأَفْضَلُ
u'تَرْكٌ أفْضَلُ':Added, #2: 2	تَرْكُ الْأَفْضَلِ
u'تَرْكٌ إِفْطارٌ':Added, #4: 4	تَرْكِ الْأَفْضَلِ
u'تَرْكٌ إِفْطارٌ':Added, #1: 1	تَرْكُ الْإِفْطَارِ
u'تَرْكٌ أَفْعَالٌ':Added, #4: 4	تَرْكِ الْإِفْطَارِ
u'تَرْكٌ أَفْعَالٌ':Added, #1: 1	تَرْكُ أَفْعَالٍ
u'تَرْكٌ أَفْعَالٌ':Added, #1: 1	تَرْكَ الْأَفْعَالِ
u'تَرَكَ إقامَةٌ':Predicate, #1: 1	تَرْكُ الْأَفْعَالِ
u'تَرْكٌ إقامَةٌ':Added, #3: 3	تَرَكَ الْإِقَامَةَ
u'تَرْكٌ إقامَةٌ':Added, #1: 1	تَرْكِ الْإِقَامَةِ
u'تَرْكٌ إقْدَامٌ':Added, #4: 4	تَرْكِ إقَامَةِ
u'تَرَكَ أقْدَمُونَ':Predicate, #1: 1	تَرْكَ الْإِقْدَامِ
u'تَرْكٌ إِقْراءٌ':Added, #1: 1	تَرَكَ الْأَقْدَمُونَ
u'تَرْكٌ إقْرَارٌ':Added, #2: 2	تَرْكُ الْإِقْرَاءِ
u'تَرْكٌ إقْرَارٌ':Added, #1: 1	تَرْكُ إقْرَارِ
u'تَرَكَ أقْرَبُ':Predicate, #1: 1	تَرْكَ الْإِقْرَارِ
u'تَرَكَ أقَلُّ':Predicate, #3: 3	تَرَكَ الْأَقْرَبَ
u'تَرَكَ أقَلُّ':Predicate, #4: 4	تَرَكَ أَقَلَّ
u'تَرْكٌ أقَلُّ':Added, #5: 5	تَرَكَ الْأَقَلَّ
u'تَرْكٌ أقَلُّ':Added, #1: 1	تَرْكَ الْأَقَلِّ
u'تَرْكٌ أقَلُّ':Added, #2: 2	تَرْكِ أَقَلِّهِ
u'تَرَكَ أكَّارٌ':Subject, #2: 2	تَرْكِ الْأَقَلِّ
u'تَرْكٌ اِكْتِوَاءٌ':Added, #3: 3	تَرَكَ الْأَكَّارُ
u'تَرَكَ أَكْثَرُ':Predicate, #1: 1	تَرْكِ الاِكْتِوَاءِ
u'تَرَكَ أَكْثَرُ':Predicate, #10: 10	تَرَكَ أَكْثَرَ
u'تَرَكَ أَكْثَرُ':Subject, #3: 3	تَرَكَ الْأَكْثَرَ
u'تَرْكٌ أَكْثَرُ':Added, #1: 1	تَرَكَ الْأَكْثَرُ
u'تَرْكٌ أَكْثَرُ':Added, #1: 1	تَرْكَ الْأَكْثَرِ
u'تَرْكٌ أَكْثَرُ':Added, #1: 1	تَرْكُ الْأَكْثَرِ
u'تَرْكٌ إكْرَامٌ':Added, #5: 5	تَرْكِ الْأَكْثَرِ
u'تَرَكَ أكل':Predicate, #1: 1	تَرْكِ الْإِكْرَامِ
u'تَرَكَ أَكْلٌ':Predicate, #2: 2	تَرَكَ أَكْلَ
u'تَرَكَ أكل':Predicate, #2: 2	تَرَكَ أَكْلَ
u'تَرَكَ أَكْلٌ':Predicate, #7: 7	تَرَكَ الْأَكْلَ
u'تَرْكٌ أكل':Added, #7: 7	تَرَكَ الْأَكْلَ
u'تَرْكٌ أَكْلٌ':Added, #11: 11	تَرْكُ الْأَكْلِ
u'تَرْكٌ أكل':Added, #11: 11	تَرْكُ الْأَكْلِ
u'تَرْكٌ أكل':Added, #1: 1	تَرْكُ أَكْلِهِ
u'تَرْكٌ أَكْلٌ':Added, #1: 1	تَرْكِ أَكْلِهِ
u'تَرْكٌ أَكْلٌ':Added, #1: 1	تَرْكُ أَكْلِهِ
u'تَرْكٌ أكل':Added, #1: 1	تَرْكِ أَكْلِهِ
u'تَرْكٌ أَكْلٌ':Added, #1: 1	تَرْكِ الأَكْلِ
u'تَرْكٌ أكل':Added, #1: 1	تَرْكِ الأَكْلِ
u'تَرْكٌ أَكْلٌ':Added, #2: 2	تَرْكُ أَكْلِ
u'تَرْكٌ أكل':Added, #2: 2	تَرْكُ أَكْلِ
u'تَرْكٌ أَكْلٌ':Added, #3: 3	تَرْكِ أَكْلِ
u'تَرْكٌ أكل':Added, #3: 3	تَرْكِ أَكْلِ
u'تَرْكٌ أَكْلٌ':Added, #3: 3	تَرْكِ الْأَكْلِ
u'تَرْكٌ أكل':Added, #3: 3	تَرْكِ الْأَكْلِ
u'تَرْكٌ أَكْلٌ':Added, #6: 6	تَرْكَ الْأَكْلِ
u'تَرَكَ أَكْمَلُ':Predicate, #6: 6	تَرْكَ الْأَكْلِ
u'تَرَكَ أَلْبَابٌ':Predicate, #1: 1	تَرَكَ الْأَكْمَلَ
u'تَرْكٌ اِلْتِزَامٌ':Added, #1: 1	تَرَكَ الْأَلْبَابَ
u'تَرَكَ اِلْتِمَاسٌ':Predicate, #1: 1	تَرْكُ الْتِزَامِ
u'تَرْكٌ إلْحَاقٌ':Added, #1: 1	تَرَكَ الْتِمَاسَ
u'تَرَكَ ألف':Predicate, #1: 1	تَرْكُ إلْحَاقِ
u'تَرَكَ ألْفٌ':Predicate, #1: 1	تَرَكَ أَلْفَ
u'تَرَكَ أَلْفٌ':Predicate, #1: 1	تَرَكَ أَلْفَ
u'تَرَكَ الْمَرْءُ':Subject, #1: 1	تَرَكَ أَلْفَ
u'تَرْكٌ الْمَرْأَةُ':Added, #1: 1	تَرَكَ الْمَرْءُ
u'تَرَكَ أُمٌّ':Predicate, #1: 1	تَرْكِ الْمَرْأَةِ
u'تَرَكَ أُمٌّ':Subject, #5: 5	تَرَكَ أُمَّ
u'تَرَكَ إمَامٌ':Subject, #2: 2	تَرَكَ أُمُّ
u'تَرَكَ إمَامٌ':Subject, #24: 24	تَرَكَ الْإِمَامُ
u'تَرْكٌ إمَامٌ':Added, #6: 6	تَرَكَ إمَامُهُ
u'تَرْكٌ إمَامٌ':Added, #2: 2	تَرْكُ الْإِمَامِ
u'تَرْكٌ إمَامٌ':Added, #2: 2	تَرْكَ إمَامِهِ
u'تَرْكٌ إمَامٌ':Added, #2: 2	تَرْكِ إمَامِهِ
u'تَرْكٌ إمَامَةٌ':Added, #3: 3	تَرْكِ الْإِمَامِ
u'تَرْكٌ اِمْتِثَالٌ':Added, #1: 1	تَرْكُ إمَامَتِهِ
u'تَرْكٌ أَمْتِعَةٌ':Added, #2: 2	تَرْكِ امْتِثَالِ
u'تَرَكَ أَمْرٌ':Predicate, #1: 1	تَرْكُ أَمْتِعَتِهِ
u'تَرْكٌ أَمْرٌ':Added, #2: 2	تَرَكَ الْأَمْرَ
u'تَرْكٌ أَمْرٌ':Added, #1: 1	تَرْكَ الْأَمْرِ
u'تَرْكٌ أَمْرٌ':Added, #1: 1	تَرْكُ أَمْرٍ
u'تَرْكٌ أَمْرٌ':Added, #3: 3	تَرْكُ الْأَمْرِ
u'تَرْكٌ أُمُورٌ':Added, #7: 7	تَرْكِ الْأَمْرِ
u'تَرَكَ أَميرٌ':Subject, #1: 1	تَرْكَ أُمُورٍ
u'تَرَكَ أَميرٌ':Subject, #1: 1	تَرَكَ الْأَمِيرُ
u'تَرْكٌ إِنْسانٌ':Added, #1: 1	تَرَكَ أَمِيرُ
u'تَرَكَ إِنْفاقٌ':Predicate, #1: 1	تَرْكُ الْإِنْسَانِ
u'تَرْكٌ إِنْفاقٌ':Added, #2: 2	تَرَكَ الْإِنْفَاقَ
u'تَرْكٌ إِنْفاقٌ':Added, #2: 2	تَرْكُ الْإِنْفَاقِ
u'تَرْكٌ إِنْفاقٌ':Added, #2: 2	تَرْكِ الْإِنْفَاقِ
u'تَرَكَ إِنْكارٌ':Predicate, #3: 3	تَرْكَ الْإِنْفَاقِ
u'تَرَكَ إِنْكارٌ':Predicate, #1: 1	تَرَكَ إنْكَارَ
u'تَرْكٌ إِنْكارٌ':Added, #3: 3	تَرَكَ الْإِنْكَارَ
u'تَرْكٌ إِنْكارٌ':Added, #1: 1	تَرْكَ إنْكَارِ
u'تَرْكٌ إِنْكارٌ':Added, #1: 1	تَرْكِ إنْكَارِ
u'تَرْكٌ إِنْكارٌ':Added, #1: 1	تَرْكَ إنْكَارِهِ
u'تَرْكٌ إِنْكارٌ':Added, #1: 1	تَرْكُ إنْكَارِهِ
u'تَرْكٌ إِنْكارٌ':Added, #1: 1	تَرْكِ إنْكَارِهِ
u'تَرْكٌ إِنْكارٌ':Added, #1: 1	تَرْكِ إِنْكَارِهِ
u'تَرْكٌ إِنْكارٌ':Added, #2: 2	تَرْكُ الْإِنْكَارِ
u'تَرَكَ أهْلٌ':Subject, #3: 3	تَرْكَ الْإِنْكَارِ
u'تَرْكٌ إهْمَالٌ':Added, #4: 4	تَرَكَ أَهْلُ
u'تَرْكٌ أَوْتَارٌ':Added, #2: 2	تَرْكَ إهْمَالٍ
u'تَرَكَ أَوَّلُ':Predicate, #3: 3	تَرْكُ الْأَوْتَارِ
u'تَرَكَ أَوَّلُ':Subject, #4: 4	تَرَكَ الْأَوَّلَ
u'تَرَكَ آيَةٌ':Predicate, #1: 1	تَرَكَ الْأَوَّلُ
u'تَرْكٌ آيَةٌ':Added, #2: 2	تَرَكَ آيَةَ
u'تَرْكٌ آيَةٌ':Added, #1: 1	تَرْكُ آيَةٍ
u'تَرْكٌ آيَةٌ':Added, #1: 1	تَرْكُ آيَةِ
u'تَرْكٌ إِيجَابٌ':Added, #1: 1	تَرْكِ آيَةِ
u'تَرْكٌ إيمَانٌ':Added, #1: 1	تَرْكُ الْإِيجَابِ
u'تَرَكَ بَابٌ':Predicate, #2: 2	تَرْكِ الْإِيمَانِ
u'تَرَكَ بَابٌ':Predicate, #1: 1	تَرَكَ الْبَابَ
u'تَرْكٌ بَابٌ':Added, #2: 2	تَرَكَ بَابَ
u'تَرْكٌ بَاطِلٌ':Added, #1: 1	تَرْكُ الْبَابِ
u'تَرَكَ بَائِعٌ':Subject, #1: 1	تَرْكِ الْبَاطِلِ
u'تَرْكٌ بَحْثٌ':Added, #2: 2	تَرَكَ الْبَائِعُ
u'تَرَكَّبَ حَقِيقٌ':Subject, #1: 1	تَرْكُ الْبَحْثِ
u'تَرَكَّبَ حَقِيقَةٌ':Subject, #1: 1	تَرَكَّبَ حَقِيقَةُ
u'تَرْكٌ بِدَعٌ':Added, #1: 1	تَرَكَّبَ حَقِيقَةُ
u'تَرْكٌ بِدْعَةٌ':Added, #1: 1	تَرْكُ الْبِدَعِ
u'تَرْكٌ بِدْعَةٌ':Added, #1: 1	تَرْكَ الْبِدْعَةِ
u'تَرْكٌ بَدَلٌ':Added, #1: 1	تَرْكُ الْبِدْعَةِ
u'تَرَكُّبٌ دُيونٌ':Added, #3: 3	تَرْكُ الْبَدَلِ
u'تَرَكَّبَ سَبَبٌ':Subject, #1: 1	تَرَكُّبِ الدُّيُونِ
u'تَرْكٌ بَسْمَلَةٌ':Added, #1: 1	تَرَكَّبَ السَّبَبُ
u'تَرَكُّبٌ شَبَهٌ':Added, #1: 1	تَرْكِ الْبَسْمَلَةِ
u'تَرَكُّبٌ شَيْءٌ':Added, #2: 2	تَرَكُّبَ الشَّبَهَيْنِ
u'تَرَكَ بَعْضٌ':Predicate, #1: 1	تَرَكُّبُ الشَّيْءِ
u'تَرَكَ بَعْضٌ':Predicate, #15: 15	تَرَكَ بَعْضَ
u'تَرْكٌ بَعْضٌ':Added, #1: 1	تَرَكَ الْبَعْضَ
u'تَرْكٌ بَعْضٌ':Added, #1: 1	تَرْكِ الْبَعْضِ
u'تَرْكٌ بَعْضٌ':Added, #1: 1	تَرْكُ بَعْضِهِ
u'تَرْكٌ بَعْضٌ':Added, #2: 2	تَرْكُ الْبَعْضِ
u'تَرْكٌ بَعْضٌ':Added, #2: 2	تَرْكَ بَعْضِ
u'تَرْكٌ بَعْضٌ':Added, #2: 2	تَرْكَ بَعْضِهِ
u'تَرْكٌ بَعْضٌ':Added, #2: 2	تَرْكِ بَعْضِهِ
u'تَرْكٌ بَعْضٌ':Added, #3: 3	تَرْكُ بَعْضِ
u'تَرَكَ بَقَرٌ':Predicate, #3: 3	تَرْكِ بَعْضِ
u'تَرَكَ بَقَرٌ':Predicate, #1: 1	تَرَكَ الْبَقَرَةَ
u'تَرَكَ بَقِيَّةٌ':Predicate, #2: 2	تَرَكَ الْبَقَرَ
u'تَرْكٌ بَقِيَّةٌ':Added, #1: 1	تَرَكَ بَقِيَّةَ
u'تَرَكَّبَ مثل':Subject, #1: 1	تَرْكِ بَقِيَّةٍ
u'تَرَكَّبَ مِثْلٌ':Subject, #1: 1	تَرَكَّبَ مِثْلُهُ
u'تَرْكٌ بِنَاءٌ':Added, #1: 1	تَرَكَّبَ مِثْلُهُ
u'تَرَكَ بِنْتٌ':Predicate, #1: 1	تَرْكَ الْبِنَاءِ
u'تَرَكَ بَيَانٌ':Predicate, #18: 18	تَرَكَ بِنْتَ
u'تَرْكٌ بَيَانٌ':Added, #1: 1	تَرَكَ الْبَيَانَ
u'تَرْكٌ بَيَانٌ':Added, #1: 1	تَرْكُ بَيَانِ
u'تَرْكٌ بَيَانٌ':Added, #1: 1	تَرْكِ بَيَانِ
u'تَرَكَ بَيْتٌ':Predicate, #2: 2	تَرْكَ بَيَانِ
u'تَرَكَ بَيْضاء':Predicate, #1: 1	تَرَكَ الْبَيْتَ
u'تَرْكٌ بَيْعٌ':Added, #1: 1	تَرَكَ بَيْضَاءَ
u'تَرْكٌ بَيْعٌ':Added, #1: 1	تَرْكَ الْبَيْعِ
u'تَرْكٌ بَيْعٌ':Added, #1: 1	تَرْكُ الْبَيْعِ
u'تَرْكٌ بَيْعٌ':Added, #2: 2	تَرْكِ الْبَيْعِ
u'تَرَكَ تاء':Predicate, #2: 2	تَرْكِ بَيْعِهِ
u'تَرْكٌ تاء':Added, #1: 1	تَرَكَ التَّاءَ
u'تَرْكٌ تاء':Added, #1: 1	تَرْكِ التَّاءِ
u'تَرْكٌ تَابِعِيٌّ':Added, #2: 2	تَرْكُ التَّاءِ
u'تَرَكَ تارِك':Subject, #1: 1	تَرْكُ التَّابِعِيِّ
u'تَرَكَ تَبَع':Predicate, #1: 1	تَرَكَ تَارِكٌ
u'تَرَكَ تَبَعِيّ':Predicate, #1: 1	تَرَكَ تَبَعِيَّةَ
u'تَرَكَ تَبَعِيَّة':Predicate, #1: 1	تَرَكَ تَبَعِيَّةَ
u'تَرْكٌ تَبْعِيض':Added, #1: 1	تَرَكَ تَبَعِيَّةَ
u'تَرَكَ تَثَبُّت':Predicate, #2: 2	تَرْكُ التَّبْعِيضِ
u'تَرْكٌ تَثَبُّت':Added, #1: 1	تَرَكَ التَّثَبُّتَ
u'تَرْكٌ تَثْلِيثٌ':Added, #1: 1	تَرْكِ التَّثَبُّتِ
u'تَرْكٌ تِجَارَةٌ':Added, #1: 1	تَرْكُ التَّثْلِيثِ
u'تَرْكٌ تِجَارَةٌ':Added, #2: 2	تَرْكُ التِّجَارَةِ
u'تَرْكٌ تَجْرِيدٌ':Added, #4: 4	تَرْكَ التِّجَارَةِ
u'تَرْكٌ تَحَالُفٌ':Added, #1: 1	تَرْكُ التَّجْرِيدِ
u'تَرْكٌ تَحَدُّثٌ':Added, #1: 1	تَرْكُ التَّحَالُفِ
u'تَرْكٌ تَحْدِيثٌ':Added, #1: 1	تَرْكُ التَّحَدُّثِ
u'تَرْكٌ تَحْصِين':Added, #1: 1	تَرْكَ التَّحْدِيثِ
u'تَرْكٌ تَحَلُّلٌ':Added, #1: 1	تَرْكُ التَّحْصِينِ
u'تَرَكَ تَحْوِيلٌ':Predicate, #1: 1	تَرْكَ التَّحَلُّلِ
u'تَرَكَ تَحْوِيلٌ':Predicate, #1: 1	تَرَكَ التَّحْوِيلَ
u'تَرَكَ تَخْلِيصٌ':Predicate, #1: 1	تَرَكَ تَحْوِيلَ
u'تَرْكٌ تَدَيُّنٌ':Added, #1: 1	تَرَكَ تَخْلِيصَ
u'تَرْكٌ تَدَيُّنٌ':Added, #1: 1	تَرْكِ التَّدَيُّنِ
u'تَرَكَ تَذْكِيَةٌ':Predicate, #1: 1	تَرْكُ تَدَيُّنٍ
u'تَرَكَ تَرْتِيبٌ':Predicate, #2: 2	تَرَكَ التَّذْكِيَةَ
u'تَرَكَ تَرْتِيبٌ':Predicate, #1: 1	تَرَكَ تَرْتِيبَ
u'تَرْكٌ تَرْتِيبٌ':Added, #8: 8	تَرَكَ التَّرْتِيبَ
u'تَرْكٌ تَرْتِيبٌ':Added, #1: 1	تَرْكَ التَّرْتِيبِ
u'تَرْكٌ تَرْتِيبٌ':Added, #1: 1	تَرْكُ تَرْتِيبٍ
u'تَرْكٌ تَرْتِيبٌ':Added, #2: 2	تَرْكُ التَّرْتِيبِ
u'تَرْكٌ تَرْجِيعٌ':Added, #5: 5	تَرْكِ التَّرْتِيبِ
u'تَرَكَ تَرَسُّلٌ':Predicate, #1: 1	تَرْكَ التَّرْجِيعِ
u'تَرْكٌ تَرَفُّعٌ':Added, #1: 1	تَرَكَ التَّرَسُّلَ
u'تَرْكٌ تَرْكٌ':Added, #1: 1	تَرْكُ التَّرَفُّعِ
u'تَرَكَ تَزَوُّجٌ':Predicate, #1: 1	تَرْكِ تَرْكِهِ
u'تَرْكٌ تَزَوُّجٌ':Added, #1: 1	تَرَكَ التَّزَوُّجَ
u'تَرْكٌ تَزَوُّجٌ':Added, #1: 1	تَرْكِ التَّزَوُّجِ
u'تَرْكٌ تَزْوِيجٌ':Added, #2: 2	تَرْكُ التَّزَوُّجِ
u'تَرَكَ تَسْبِيحٌ':Predicate, #1: 1	تَرْكُ تَزْوِيجِهِ
u'تَرَكَ تَسْبِيحٌ':Predicate, #2: 2	تَرَكَ التَّسْبِيحَ
u'تَرْكٌ تَسْبِيحٌ':Added, #2: 2	تَرَكَ تَسْبِيحَ
u'تَرَكَ تَسْمِيَة':Predicate, #1: 1	تَرْكِ التَّسْبِيحِ
u'تَرْكٌ تَسْمِيَة':Added, #19: 19	تَرَكَ التَّسْمِيَةَ
u'تَرْكٌ تَسْمِيَة':Added, #3: 3	تَرْكُ التَّسْمِيَةِ
u'تَرْكٌ تَسْمِيَة':Added, #5: 5	تَرْكَ التَّسْمِيَةِ
u'تَرَكَ تَسْمِيعٌ':Predicate, #9: 9	تَرْكِ التَّسْمِيَةِ
u'تَرْكٌ تَسْوِيَةٌ':Added, #1: 1	تَرَكَ التَّسْمِيعَ
u'تَرَكَ تَشَاغُلٌ':Predicate, #1: 1	تَرْكَ التَّسْوِيَةِ
u'تَرْكٌ تَشَبُّه':Added, #1: 1	تَرَكَ التَّشَاغُلَ
u'تَرَكَ تَشْدِيد':Predicate, #1: 1	تَرْكُ التَّشَبُّهِ
u'تَرَكَ تَشْدِيدٌ':Predicate, #1: 1	تَرَكَ تَشْدِيدَةً
u'تَرَكَ تَشْدِيدٌ':Predicate, #2: 2	تَرَكَ التَّشْدِيدَ
u'تَرْكٌ تَشْدِيدٌ':Added, #2: 2	تَرَكَ تَشْدِيدَ
u'تَرْكٌ تَشْدِيدٌ':Added, #1: 1	تَرْكُ التَّشْدِيدِ
u'تَرْكٌ تَشْمِيسٌ':Added, #2: 2	تَرْكِ التَّشْدِيدِ
u'تَرَكَ تَشَهُّدٌ':Predicate, #1: 1	تَرْكِ التَّشْمِيسِ
u'تَرْكٌ تَشَهُّدٌ':Added, #7: 7	تَرَكَ التَّشَهُّدَ
u'تَرْكٌ تَصْدِيقٌ':Added, #2: 2	تَرْكُ التَّشَهُّدِ
u'تَرْكٌ تَصَرُّفٌ':Added, #1: 1	تَرْكُ التَّصْدِيقِ
u'تَرْكٌ تَصَرُّفٌ':Added, #1: 1	تَرْكُ التَّصَرُّفِ
u'تَرَكَ تَصْرِيحٌ':Predicate, #1: 1	تَرْكُ تَصَرُّفٍ
u'تَرْكٌ تَصْرِيحٌ':Added, #2: 2	تَرَكَ التَّصْرِيحَ
u'تَرْكٌ تَصْنِيفٌ':Added, #1: 1	تَرْكَ التَّصْرِيحِ
u'تَرْكٌ تَضْعِيفٌ':Added, #1: 1	تَرْكَ التَّصْنِيفِ
u'تَرْكٌ تَضْمِين':Added, #1: 1	تَرْكِ تَضْعِيفِ
u'تَرْكٌ تَطْفِيف':Added, #1: 1	تَرْكَ التَّضْمِينِ
u'تَرْكٌ تَطْلِيقٌ':Added, #1: 1	تَرْكِ التَّطْفِيفِ
u'تَرْكٌ تَطَوُّعٌ':Added, #1: 1	تَرْكِ التَّطْلِيقِ
u'تَرْكٌ تَطَوُّعٌ':Added, #1: 1	تَرْكِ التَّطَوُّعِ
u'تَرْكٌ تَطْوِيلٌ':Added, #2: 2	تَرْكُ التَّطَوُّعِ
u'تَرْكٌ تَطْوِيلٌ':Added, #1: 1	تَرْكُ التَّطْوِيلِ
u'تَرْكٌ تَطَيُّرٌ':Added, #1: 1	تَرْكَ تَطْوِيلِهِ
u'تَرْكٌ تَعْجِيل':Added, #1: 1	تَرْكُ التّطَيّرِ
u'تَرْكٌ تَعْجِيل':Added, #1: 1	تَرْكَ التَّعْجِيلِ
u'تَرَكَ تَعْدِيلٌ':Predicate, #1: 1	تَرْكُ التَّعْجِيلِ
u'تَرْكٌ تَعْدِيلٌ':Added, #1: 1	تَرَكَ تَعْدِيلَ
u'تَرْكٌ تَعَرُّضٌ':Added, #1: 1	تَرْكُ التَّعْدِيلِ
u'تَرْكٌ تَعَرُّضٌ':Added, #16: 16	تَرْكُ التَّعَرُّضِ
u'تَرْكٌ تَعَرُّضٌ':Added, #8: 8	تَرْكَ التَّعَرُّضِ
u'تَرَكَ تَعْرِيضٌ':Predicate, #9: 9	تَرْكِ التَّعَرُّضِ
u'تَرَكَ تَعْرِيفٌ':Predicate, #1: 1	تَرَكَ التَّعْرِيضَ
u'تَرَكَ تَعْرِيفٌ':Predicate, #1: 1	تَرَكَ تَعْرِيفَ
u'تَرْكٌ تَعْزِير':Added, #2: 2	تَرَكَ التَّعْرِيفَ
u'تَرَكَ تَعْظِيمٌ':Predicate, #1: 1	تَرْكُ تَعْزِيرٍ
u'تَرْكٌ تَعْظِيمٌ':Added, #1: 1	تَرَكَ التَّعْظِيمَ
u'تَرْكٌ تَعْظِيمٌ':Added, #1: 1	تَرْكِ تَعْظِيمِهِ
u'تَرْكٌ تَعَلُّمٌ':Added, #9: 9	تَرْكِ التَّعْظِيمِ
u'تَرَكَ تَعْلِيقٌ':Predicate, #1: 1	تَرْكُ التَّعَلُّمِ
u'تَرْكٌ تَعْلِيلٌ':Added, #1: 1	تَرَكَ التَّعْلِيقَ
u'تَرْكٌ تَعْلِيمٌ':Added, #1: 1	تَرْكَ تَعْلِيلِ
u'تَرْكٌ تَعَمُّدٌ':Added, #2: 2	تَرْكُ التَّعْلِيمِ
u'تَرْكٌ تَعْمِيرٌ':Added, #1: 1	تَرْكِ التَّعَمُّدِ
u'تَرْكٌ تَعْيِينٌ':Added, #1: 1	تَرْكِ تَعْمِيرِ
u'تَرْكٌ تَغْسِيلٌ':Added, #1: 1	تَرْكِ التَّعْيِينِ
u'تَرْكٌ تَغْطِيَةٌ':Added, #1: 1	تَرْكُ التَّغْسِيلِ
u'تَرْكٌ تَغْطِيَةٌ':Added, #1: 1	تَرْكَ تَغْطِيَةِ
u'تَرْكٌ تَغْطِيَةٌ':Added, #1: 1	تَرْكُ تَغْطِيَةِ
u'تَرْكٌ تَغْلِيظٌ':Added, #2: 2	تَرْكِ تَغْطِيَةِ
u'تَرْكٌ تَفْرِيغٌ':Added, #1: 1	تَرْكِ التَّغْلِيظِ
u'تَرْكٌ تَفْرِيقٌ':Added, #1: 1	تَرْكِ التَّفْرِيغِ
u'تَرَكَ تَفْصِيلٌ':Predicate, #2: 2	تَرْكِ التَّفْرِيقِ
u'تَرْكٌ تَفْضِيلٌ':Added, #1: 1	تَرَكَ التَّفْصِيلَ
u'تَرْكٌ تَقَدُّمٌ':Added, #1: 1	تَرْكِ التّفْضِيلِ
u'تَرْكٌ تَقْصيرٌ':Added, #1: 1	تَرْكَ التَّقَدُّمِ
u'تَرَكَ تَقْليدٌ':Predicate, #1: 1	تَرْكِ التَّقْصِيرِ
u'تَرَكَ تَقْليد':Predicate, #1: 1	تَرَكَ تَقْلِيدَ
u'تَرَكَ تَقْيِيد':Predicate, #1: 1	تَرَكَ تَقْلِيدَ
u'تَرْكٌ تَقْيِيد':Added, #4: 4	تَرَكَ التَّقْيِيدَ
u'تَرْكٌ تَقْيِيد':Added, #1: 1	تَرْكُ التَّقْيِيدِ
u'تَرْكٌ تَقْيِيد':Added, #1: 1	تَرْكِ التَّقْيِيدِ
u'تَرَكَ تَكْبِير':Predicate, #1: 1	تَرْكِ تَقْيِيدِ
u'تَرَكَ تَكْبِير':Predicate, #2: 2	تَرَكَ التَّكْبِيرَةَ
u'تَرَكَ تَكْبيرٌ':Predicate, #2: 2	تَرَكَ تَكْبِيرَةً
u'تَرَكَ تَكْبِير':Predicate, #5: 5	تَرَكَ التَّكْبِيرَ
u'تَرْكٌ تَكْبيرٌ':Added, #7: 7	تَرَكَ تَكْبِيرَةَ
u'تَرْكٌ تَكْبيرٌ':Added, #1: 1	تَرْكَ التَّكْبِيرِ
u'تَرْكٌ تَكْبِير':Added, #1: 1	تَرْكُ التَّكْبِيرِ
u'تَرْكٌ تَكْبِير':Added, #1: 1	تَرْكَ تَكْبِيرَةِ
u'تَرْكٌ تَكْرارٌ':Added, #2: 2	تَرْكُ تَكْبِيرَةِ
u'تَرْكٌ تَكَسُّبٌ':Added, #3: 3	تَرْكُ التَّكْرَارِ
u'تَرْكٌ تَكَشُّفٌ':Added, #1: 1	تَرْكُ التَّكَسُّبِ
u'تَرْكٌ تَكْفيرٌ':Added, #1: 1	تَرْكُ التَّكَشُّفِ
u'تَرْكٌ تَكْفيرٌ':Added, #1: 1	تَرْكُ التَّكْفِيرِ
u'تَرْكٌ تَكْفيرٌ':Added, #1: 1	تَرْكُ تَكْفِيرِ
u'تَرْكٌ تَكَلُّفٌ':Added, #2: 2	تَرْكِ التَّكْفِيرِ
u'تَرْكٌ تَكَلُّفٌ':Added, #1: 1	تَرْكَ التّكَلّفِ
u'تَرْكٌ تَكْليفٌ':Added, #1: 1	تَرْكُ التَّكَلُّفِ
u'تَرَكَ تَلَبُّسٌ':Predicate, #2: 2	تَرْكُ تَكْلِيفِهِ
u'تَرْكٌ تَلَبُّسٌ':Added, #1: 1	تَرَكَ التَّلَبُّسَ
u'تَرَكَ تَلْبيَةٌ':Predicate, #2: 2	تَرْكُ التَّلَبُّسِ
u'تَرْكٌ تَلْبيَةٌ':Added, #6: 6	تَرَكَ التَّلْبِيَةَ
u'تَرْكٌ تَلْبيَةٌ':Added, #1: 1	تَرْكَ التَّلْبِيَةِ
u'تَرْكٌ تَلَفُّظٌ':Added, #2: 2	تَرْكُ التَّلْبِيَةِ
u'تَرْكٌ تَلَفُّظٌ':Added, #1: 1	تَرْكِ التَّلَفُّظِ
u'تَرَكَ تَلْقيحٌ':Predicate, #2: 2	تَرْكُ التَّلَفُّظِ
u'تَرْكٌ تَلْقيحٌ':Added, #1: 1	تَرَكَ تَلْقِيحَ
u'تَرْكٌ تَلَوُّمٌ':Added, #1: 1	تَرْكِ التَّلْقِيحِ
u'تَرْكٌ تَمَتُّعٌ':Added, #1: 1	تَرْكِ التَّلَوُّمِ
u'تَرْكٌ تَناجُز':Added, #1: 1	تَرْكِ التَّمَتُّعِ
u'تَرْكٌ تَنَحْنُحٌ':Added, #1: 1	تَرْكُ التَّنَاجُزِ
u'تَرْكٌ تَنْشِيفٌ':Added, #1: 1	تَرْكِ التَّنَحْنُحِ
u'تَرْكٌ تَنْشِيفٌ':Added, #1: 1	تَرْكَ التَّنْشِيفِ
u'تَرْكٌ تَنْشِيفٌ':Added, #1: 1	تَرْكِ تَنْشِيفِ
u'تَرْكٌ تَنَفُّسٌ':Added, #3: 3	تَرْكُ التَّنْشِيفِ
u'تَرْكٌ تَنَفُّلٌ':Added, #1: 1	تَرْكَ التَّنَفُّسِ
u'تَرْكٌ تَنْوِينٌ':Added, #1: 1	تَرْكُ التَّنَفُّلِ
u'تَرْكٌ تَنْوِينٌ':Added, #1: 1	تَرْكَ التَّنْوِينِ
u'تَرْكٌ تَنْوِينٌ':Added, #1: 1	تَرْكُ التّنْوِينِ
u'تَرْكٌ تَنْوِينٌ':Added, #1: 1	تَرْكُ التَّنْوِينِ
u'تَرْكٌ تَهَجُّدٌ':Added, #1: 1	تَرْكُ تَنْوِينِ
u'تَرَكَ تَوْبَةٌ':Predicate, #1: 1	تَرْكُ تَهَجُّدٍ
u'تَرْكٌ تَوْبَةٌ':Added, #1: 1	تَرَكَ التَّوْبَةَ
u'تَرْكٌ تَوْبَةٌ':Added, #2: 2	تَرْكُ التَّوْبَةِ
u'تَرْكٌ تَوْجِيهٌ':Added, #2: 2	تَرْكِ التَّوْبَةِ
u'تَرْكٌ تَوْحِيدٌ':Added, #1: 1	تَرْكَ تَوْجِيهِ
u'تَرْكٌ تَوْقِيت':Added, #1: 1	تَرْكَ التَّوْحِيدِ
u'تَرَكَ تَيامُنٌ':Predicate, #2: 2	تَرْكِ التَّوْقِيتِ
u'تَرَكَ ثَانِي':Predicate, #1: 1	تَرَكَ التَّيَامُنَ
u'تَرَكَ ثَانِي':Predicate, #1: 1	تَرَكَ الثَّانِيَ
u'تَرَكَ ثَانِيَةٌ':Predicate, #1: 1	تَرَكَ الثَّانِيَةَ
u'تَرَكَ ثَلاثُ':Predicate, #1: 1	تَرَكَ الثَّانِيَةَ
u'تَرْكٌ ثَلاثُ':Added, #25: 25	تَرَكَ ثَلَاثَ
u'تَرْكٌ ثَلاثُ':Added, #1: 1	تَرْكِ الثَّلَاثِ
u'تَرَكَ ثَلاثَةٌ':Predicate, #1: 1	تَرْكَ ثَلَاثِ
u'تَرَكَ ثَلاثَةٌ':Predicate, #15: 15	تَرَكَ ثَلَاثَةَ
u'تَرْكٌ ثِمارٌ':Added, #1: 1	تَرَكَ ثَلاَثَةَ
u'تَرْكٌ ثِمارٌ':Added, #1: 1	تَرْكَ الثِّمَارِ
u'تَرْكٌ ثِمارٌ':Added, #1: 1	تَرْكِ الثِّمَارِ
u'تَرَكَ ثَمانِيَةٌ':Predicate, #4: 4	تَرْكُ الثِّمَارِ
u'تَرْكٌ ثَمَرٌ':Added, #1: 1	تَرَكَ ثَمَانِيَةَ
u'تَرَكَ ثَناءٌ':Predicate, #1: 1	تَرْكِ الثَّمَرِ
u'تَرْكٌ ثَناءٌ':Added, #2: 2	تَرَكَ الثَّنَاءَ
u'تَرَكَ ثَوْبٌ':Predicate, #1: 1	تَرْكِ الثَّنَاءِ
u'تَرَكَ جَارِي':Predicate, #11: 11	تَرَكَ الثَّوْبَ
u'تَرْكٌ جَارِي':Added, #2: 2	تَرَكَ جَارِيَةً
u'تَرْكٌ جَارِيَةٌ':Added, #1: 1	تَرْكَ الْجَارِيَةِ
u'تَرَكَ جَازٌ':Predicate, #1: 1	تَرْكَ الْجَارِيَةِ
u'تَرْكٌ جَبْرٌ':Added, #1: 1	تَرَكَ جَازَ
u'تَرْكٌ جِدٌّ':Added, #1: 1	تَرْكِ الْجَبْرِ
u'تَرْكٌ جِدار':Added, #1: 1	تَرْكُ الْجِدِّ
u'تَرَكَ جِدال':Predicate, #1: 1	تَرْكُ جِدَارِ
u'تَرْكٌ جُزْءٌ':Added, #1: 1	تَرَكَ الْجِدَالَ
u'تَرْكٌ جَزْم':Added, #1: 1	تَرْكُ جُزْءٍ
u'تَرْكٌ جِزْيَةٌ':Added, #1: 1	تَرْكِ الْجَزْمِ
u'تَرَكَ جلد':Predicate, #1: 1	تَرْكِ الْجِزْيَةِ
u'تَرَكَ جِلْدٌ':Predicate, #1: 1	تَرَكَ الْجِلْدَ
u'تَرْكٌ جِلْسَةٌ':Added, #1: 1	تَرَكَ الْجِلْدَ
u'تَرْكٌ جلسة':Added, #1: 1	تَرْكَ الْجِلْسَاتِ
u'تَرْكٌ جِلْسَةٌ':Added, #2: 2	تَرْكَ الْجِلْسَةِ
u'تَرَكَ جُلُوسٌ':Predicate, #2: 2	تَرْكَ الْجِلْسَةِ
u'تَرْكٌ جُلُوسٌ':Added, #3: 3	تَرَكَ الْجُلُوسَ
u'تَرْكٌ جُلُوسٌ':Added, #1: 1	تَرْكِ الْجُلُوسِ
u'تَرَكَ جِمَارٌ':Predicate, #2: 2	تَرْكُ الْجُلُوسِ
u'تَرَكَ جماع':Predicate, #2: 2	تَرَكَ الْجِمَارَ
u'تَرَكَ جِمَاعٌ':Predicate, #1: 1	تَرَكَ جِمَاعَ
u'تَرَكَ جماع':Predicate, #1: 1	تَرَكَ جِمَاعَ
u'تَرَكَ جِمَاعٌ':Predicate, #2: 2	تَرَكَ الْجِمَاعَ
u'تَرْكٌ جماع':Added, #2: 2	تَرَكَ الْجِمَاعَ
u'تَرْكٌ جِمَاعٌ':Added, #1: 1	تَرْكُ الْجِمَاعِ
u'تَرْكٌ جماع':Added, #1: 1	تَرْكُ الْجِمَاعِ
u'تَرْكٌ جِمَاعٌ':Added, #2: 2	تَرْكَ الْجِمَاعِ
u'تَرْكٌ جماع':Added, #2: 2	تَرْكَ الْجِمَاعِ
u'تَرْكٌ جِمَاعٌ':Added, #3: 3	تَرْكِ الْجِمَاعِ
u'تَرَكَ جَمَاعَةٌ':Predicate, #3: 3	تَرْكِ الْجِمَاعِ
u'تَرَكَ جَمَاعَةٌ':Subject, #7: 7	تَرَكَ الْجَمَاعَةَ
u'تَرْكٌ جَمَاعَةٌ':Added, #1: 1	تَرَكَ جَمَاعَةٌ
u'تَرْكٌ جَمَاعَةٌ':Added, #19: 19	تَرْكِ الْجَمَاعَةِ
u'تَرْكٌ جَمَاعَةٌ':Added, #1: 1	تَرْكَ جَمَاعَةٍ
u'تَرْكٌ جَمَاعَةٌ':Added, #1: 1	تَرْكُ جَمَاعَةٍ
u'تَرْكٌ جَمَاعَةٌ':Added, #5: 5	تَرْكَ الْجَمَاعَةِ
u'تَرَكَ جَمْرَةٌ':Predicate, #8: 8	تَرْكُ الْجَمَاعَةِ
u'تَرَكَ جَمْرَة':Predicate, #1: 1	تَرَكَ الْجَمْرَةَ
u'تَرَكَ جَمْرَةٌ':Predicate, #1: 1	تَرَكَ الْجَمْرَةَ
u'تَرَكَ جَمْرَة':Predicate, #2: 2	تَرَكَ جَمْرَةَ
u'تَرْكٌ جمع':Added, #2: 2	تَرَكَ جَمْرَةَ
u'تَرْكٌ جَمْعٌ':Added, #1: 1	تَرْكُ جَمْعِ
u'تَرْكٌ جمع':Added, #1: 1	تَرْكُ جَمْعِ
u'تَرْكٌ جَمْعٌ':Added, #1: 1	تَرْكَ جَمْعِهِ
u'تَرَكَ جمعة':Predicate, #1: 1	تَرْكَ جَمْعِهِ
u'تَرَكَ جمعة':Predicate, #1: 1	تَرَكَ الْجُمْعَةَ
u'تَرَكَ جُمُعَةٌ':Predicate, #23: 23	تَرَكَ الْجُمُعَةَ
u'تَرْكٌ جمعة':Added, #23: 23	تَرَكَ الْجُمُعَةَ
u'تَرْكٌ جُمُعَةٌ':Added, #11: 11	تَرْكَ الْجُمُعَةِ
u'تَرْكٌ جُمُعَةٌ':Added, #11: 11	تَرْكَ الْجُمُعَةِ
u'تَرْكٌ جمعة':Added, #1: 1	تَرْكِ الْجُمُعَاتِ
u'تَرْكٌ جُمُعَةٌ':Added, #21: 21	تَرْكِ الْجُمُعَةِ
u'تَرْكٌ جمعة':Added, #21: 21	تَرْكِ الْجُمُعَةِ
u'تَرْكٌ جُمُعَةٌ':Added, #7: 7	تَرْكُ الْجُمُعَةِ
u'تَرَكَ جَمِيع':Predicate, #7: 7	تَرْكُ الْجُمُعَةِ
u'تَرَكَ جَمِيع':Subject, #2: 2	تَرَكَ الْجَمِيعَ
u'تَرْكٌ جَمِيع':Added, #1: 1	تَرَكَ الْجَمِيعُ
u'تَرْكٌ جَمِيع':Added, #3: 3	تَرْكُ الْجَمِيعِ
u'تَرَكَ جِنَايَةٌ':Predicate, #3: 3	تَرْكِ الْجَمِيعِ
u'تَرْكٌ جِنْسٌ':Added, #1: 1	تَرَكَ الْجِنَايَةَ
u'تَرَكَ جهاد':Predicate, #1: 1	تَرْكِ جِنْسِ
u'تَرَكَ جِهَادٌ':Predicate, #2: 2	تَرَكَ الْجِهَادَ
u'تَرْكٌ جهاد':Added, #2: 2	تَرَكَ الْجِهَادَ
u'تَرْكٌ جِهَادٌ':Added, #1: 1	تَرْكَ الْجِهَادِ
u'تَرْكٌ جهاد':Added, #1: 1	تَرْكَ الْجِهَادِ
u'تَرْكٌ جِهَادٌ':Added, #5: 5	تَرْكِ الْجِهَادِ
u'تَرْكٌ جهاد':Added, #5: 5	تَرْكِ الْجِهَادِ
u'تَرْكٌ جِهَادٌ':Added, #6: 6	تَرْكُ الْجِهَادِ
u'تَرْكٌ جِهَةٌ':Added, #6: 6	تَرْكُ الْجِهَادِ
u'تَرَكَ جهر':Predicate, #2: 2	تَرْكَ جِهَةِ
u'تَرَكَ جَهْرٌ':Predicate, #4: 4	تَرَكَ الْجَهْرَ
u'تَرْكٌ جهر':Added, #4: 4	تَرَكَ الْجَهْرَ
u'تَرْكٌ جَهْرٌ':Added, #2: 2	تَرْكُ الْجَهْرِ
u'تَرْكٌ جهر':Added, #2: 2	تَرْكُ الْجَهْرِ
u'تَرْكٌ جَهْرٌ':Added, #3: 3	تَرْكِ الْجَهْرِ
u'تَرَكَ جَوَابٌ':Predicate, #3: 3	تَرْكِ الْجَهْرِ
u'تَرْكٌ جَوْرٌ':Added, #1: 1	تَرَكَ الْجَوَابَ
u'تَرَكَ حاجَةٌ':Predicate, #1: 1	تَرْكِ الْجَوْرِ
u'تَرْكٌ حاكِمٌ':Added, #1: 1	تَرَكَ الْحَاجَةَ
u'تَرْكٌ حالٌ':Added, #1: 1	تَرْكِ الْحَاكِمِ
u'تَرْكٌ حائِضٌ':Added, #1: 1	تَرْكِ الْحَالِ
u'تَرَكَ حائِكٌ':Subject, #1: 1	تَرْكِ الْحَائِضِ
u'تَرَكَ حَبٌّ':Predicate, #1: 1	تَرَكَ الْحَائِكُ
u'تَرْكٌ حَبْسٌ':Added, #1: 1	تَرَكَ الْحَبَّ
u'تَرَكَ حَجٌّ':Predicate, #1: 1	تَرْكُ الْحَبْسِ
u'تَرْكٌ حَجٌّ':Added, #4: 4	تَرَكَ الْحَجَّ
u'تَرْكٌ حَجٌّ':Added, #1: 1	تَرْكَ الْحَجِّ
u'تَرْكٌ حَجٌّ':Added, #1: 1	تَرْكُ الْحَجِّ
u'تَرْكٌ حِجَامَةٌ':Added, #7: 7	تَرْكِ الْحَجِّ
u'تَرَكَ حَدٌّ':Predicate, #1: 1	تَرْكُ الْحِجَامَةِ
u'تَرَكَ حَديثٌ':Predicate, #1: 1	تَرَكَ الْحَدَّ
u'تَرْكٌ حَديثٌ':Added, #5: 5	تَرَكَ الْحَدِيثَ
u'تَرْكٌ حَديثٌ':Added, #1: 1	تَرْكُ الْحَدِيثِ
u'تَرْكٌ حَديثٌ':Added, #1: 1	تَرْكِ حَدِيثِ
u'تَرْكٌ حِراسَةٌ':Added, #1: 1	تَرْكِ حَدِيثِهِ
u'تَرْكٌ حَرامٌ':Added, #1: 1	تَرْكُ الْحِرَاسَةِ
u'تَرْكٌ حَرامٌ':Added, #14: 14	تَرْكُ الْحَرَامِ
u'تَرْكٌ حَرامٌ':Added, #1: 1	تَرْكَ الْحَرَامِ
u'تَرْكٌ حَرامٌ':Added, #1: 1	تَرْكَ حَرَامٍ
u'تَرْكٌ حَرامٌ':Added, #1: 1	تَرْكِ حَرَامٍ
u'تَرْكٌ حَرامٌ':Added, #8: 8	تَرْكِ الْحَرَامِ
u'تَرْكٌ حِرْفَةٌ':Added, #8: 8	تَرْكُ حَرَامٍ
u'تَرْكٌ حَرَكَةٌ':Added, #1: 1	تَرْكِ الْحِرْفَةِ
u'تَرْكٌ حَرَكَةٌ':Added, #1: 1	تَرْكِ الْحَرَكَاتِ
u'تَرْكٌ حُرْمَةٌ':Added, #1: 1	تَرْكِ الْحَرَكَةِ
u'تَرَكَ حَرِيرٌ':Predicate, #1: 1	تَرْكِ الْحُرْمَةِ
u'تَرْكٌ حسد':Added, #1: 1	تَرَكَ الْحَرِيرَ
u'تَرْكٌ حَسَدٌ':Added, #1: 1	تَرْكُ الْحَسَدِ
u'تَرْكٌ حُسْنٌ':Added, #1: 1	تَرْكُ الْحَسَدِ
u'تَرْكٌ حِشْمَةٌ':Added, #1: 1	تَرْكُ حُسْنِ
u'تَرْكٌ حَصَاةٌ':Added, #1: 1	تَرْكِ الْحِشْمَةِ
u'تَرْكٌ حَصَاةٌ':Added, #1: 1	تَرْكِ الْحَصَاةِ
u'تَرَكَ حُضورٌ':Predicate, #1: 1	تَرْكِ حَصَاةٍ
u'تَرَكَ حُضُورٌ':Predicate, #1: 1	تَرَكَ حُضُورَ
u'تَرْكٌ حُضورٌ':Added, #1: 1	تَرَكَ حُضُورَ
u'تَرْكٌ حُضُورٌ':Added, #1: 1	تَرْكِ الْحُضُورِ
u'تَرْكٌ حُضورٌ':Added, #1: 1	تَرْكِ الْحُضُورِ
u'تَرْكٌ حُضُورٌ':Added, #1: 1	تَرْكِ حُضُورِ
u'تَرْكٌ حَفْرٌ':Added, #1: 1	تَرْكِ حُضُورِ
u'تَرَكَ حِفْظٌ':Predicate, #1: 1	تَرْكِ الْحَفْرِ
u'تَرَكَ حِفْظٌ':Predicate, #2: 2	تَرَكَ حِفْظَ
u'تَرْكٌ حِفْظٌ':Added, #6: 6	تَرَكَ الْحِفْظَ
u'تَرْكٌ حِفْظٌ':Added, #1: 1	تَرْكُ الْحِفْظِ
u'تَرْكٌ حِفْظٌ':Added, #1: 1	تَرْكِ حِفْظِ
u'تَرْكٌ حِفْظٌ':Added, #2: 2	تَرْكُ حِفْظِ
u'تَرَكَ حَقٌّ':Predicate, #3: 3	تَرْكِ الْحِفْظِ
u'تَرْكٌ حَقٌّ':Added, #1: 1	تَرَكَ الْحَقَّ
u'تَرْكٌ حَقٌّ':Added, #1: 1	تَرْكُ حَقِّهِ
u'تَرْكٌ حَقِيقٌ':Added, #3: 3	تَرْكِ حَقِّهِ
u'تَرْكٌ حَقِيقٌ':Added, #1: 1	تَرْكَ الْحَقِيقَةِ
u'تَرْكٌ حَقِيقٌ':Added, #1: 1	تَرْكُ الْحَقِيقَةِ
u'تَرْكٌ حَقِيقَةٌ':Added, #6: 6	تَرْكِ الْحَقِيقَةِ
u'تَرْكٌ حَقِيقَةٌ':Added, #1: 1	تَرْكَ الْحَقِيقَةِ
u'تَرْكٌ حَقِيقَةٌ':Added, #1: 1	تَرْكُ الْحَقِيقَةِ
u'تَرْكٌ حُكْمٌ':Added, #6: 6	تَرْكِ الْحَقِيقَةِ
u'تَرْكٌ حُكْمٌ':Added, #1: 1	تَرْكَ الْحُكْمِ
u'تَرْكٌ حُكْمٌ':Added, #1: 1	تَرْكِ الْحُكْمِ
u'تَرْكٌ حُكْمٌ':Added, #1: 1	تَرْكُ حُكْمِهِ
u'تَرْكٌ حلاب':Added, #3: 3	تَرْكِ حُكْمِ
u'تَرْكٌ حَلالٌ':Added, #1: 1	تَرْكُ الْحِلَابِ
u'تَرَكَ حلب':Predicate, #1: 1	تَرْكَ الْحَلَالِ
u'تَرْكٌ حلب':Added, #1: 1	تَرَكَ حَلْبَ
u'تَرَكَ حَلْقٌ':Predicate, #2: 2	تَرْكُ الْحَلْبِ
u'تَرَكَ حِلْيَةٌ':Predicate, #1: 1	تَرَكَ الْحَلْقَ
u'تَرَكَ حِمَارٌ':Predicate, #1: 1	تَرَكَ الْحِلْيَةَ
u'تَرْكٌ حَمَّامٌ':Added, #1: 1	تَرَكَ الْحِمَارَ
u'تَرْكٌ حَمْدٌ':Added, #2: 2	تَرْكُ الْحَمَّامِ
u'تَرْكٌ حِنَّاءٌ':Added, #1: 1	تَرْكُ الْحَمْدِ
u'تَرَكَ حَيٌّ':Predicate, #2: 2	تَرْكُ حِنَّاءٍ
u'تَرْكٌ حَيَاءٌ':Added, #1: 1	تَرَكَ حَيَّةً
u'تَرَكَ خَارِجٌ':Predicate, #1: 1	تَرْكُ الْحَيَاءِ
u'تَرَكَ خَالٌ':Predicate, #1: 1	تَرَكَ خَارِجَ
u'تَرَكَ خَالٌ':Predicate, #1: 1	تَرَكَ خَالَةَ
u'تَرَكَ خَائِفٌ':Subject, #2: 2	تَرَكَ خَالَةً
u'تَرَكَ خَبَبٌ':Predicate, #1: 1	تَرَكَ الْخَائِفُ
u'تَرْكٌ خَبَرٌ':Added, #1: 1	تَرَكَ الْخَبَبَ
u'تَرْكٌ خَبَر':Added, #1: 1	تَرْكِ الْخَبَرِ
u'تَرْكٌ ختان':Added, #1: 1	تَرْكِ الْخَبَرِ
u'تَرْكٌ ختان':Added, #1: 1	تَرْكُ خِتَانِ
u'تَرْكٌ خِتَانٌ':Added, #1: 1	تَرْكِ خِتَانِ
u'تَرْكٌ خِتَانٌ':Added, #1: 1	تَرْكُ خِتَانِ
u'تَرَكَ خدمة':Predicate, #1: 1	تَرْكِ خِتَانِ
u'تَرَكَ خِدْمَةٌ':Predicate, #2: 2	تَرَكَ خِدْمَةَ
u'تَرَكَ خراج':Predicate, #2: 2	تَرَكَ خِدْمَةَ
u'تَرَكَ خَرَاجٌ':Predicate, #3: 3	تَرَكَ الْخَرَاجَ
u'تَرْكٌ خُشُوعٌ':Added, #3: 3	تَرَكَ الْخَرَاجَ
u'تَرَكَ خَصْمٌ':Subject, #1: 1	تَرْكَ الْخُشُوعِ
u'تَرَكَ خُصُومَةٌ':Predicate, #1: 1	تَرَكَ الْخَصْمُ
u'تَرْكٌ خُصُومَةٌ':Added, #5: 5	تَرَكَ الْخُصُومَةَ
u'تَرْكٌ خُصُومَةٌ':Added, #1: 1	تَرْكِ الْخُصُومَاتِ
u'تَرْكٌ خُصُومَةٌ':Added, #1: 1	تَرْكُ الْخُصُومَةِ
u'تَرْكٌ خَصِيٌّ':Added, #20: 20	تَرْكِ الْخُصُومَةِ
u'تَرْكٌ خِضَابٌ':Added, #1: 1	تَرْكَ الْخَصِيِّ
u'تَرَكَ خِطَابٌ':Predicate, #1: 1	تَرْكُ الْخِضَابِ
u'تَرَكَ خطبة':Predicate, #1: 1	تَرَكَ الْخِطَابَ
u'تَرَكَ خِطْبَةٌ':Predicate, #1: 1	تَرَكَ الْخِطْبَةَ
u'تَرَكَ خطبة':Predicate, #1: 1	تَرَكَ الْخِطْبَةَ
u'تَرَكَ خُطْبَةٌ':Predicate, #5: 5	تَرَكَ الْخُطْبَةَ
u'تَرَكَ خَطِيبٌ':Subject, #5: 5	تَرَكَ الْخُطْبَةَ
u'تَرْكٌ خَطِيئَةٌ':Added, #1: 1	تَرَكَ الْخَطِيبُ
u'تَرَكَ خُفٌّ':Predicate, #1: 1	تَرْكُ الْخَطِيئَةِ
u'تَرَكَ خِلاَفٌ':Predicate, #3: 3	تَرَكَ الْخُفَّ
u'تَرْكٌ خِلاَفٌ':Added, #1: 1	تَرَكَ الْخِلَافَ
u'تَرْكٌ خِلاَفٌ':Added, #1: 1	تَرْكَ خِلَافِ
u'تَرْكٌ خِلاَفٌ':Added, #1: 1	تَرْكِ خِلَافِ
u'تَرْكٌ خِلاَفَةٌ':Added, #2: 2	تَرْكَ الْخِلَافِ
u'تَرْكٌ خِلاَلٌ':Added, #1: 1	تَرْكُ الْخِلَافَةِ
u'تَرْكٌ خَلِيط':Added, #3: 3	تَرْكُ الْخِلَالِ
u'تَرْكٌ خِمَارٌ':Added, #1: 1	تَرْكُ الْخَلِيطَيْنِ
u'تَرَكَ خَمْرٌ':Predicate, #1: 1	تَرْكِ الْخِمَارِ
u'تَرَكَ خَمْسٌ':Predicate, #1: 1	تَرَكَ الْخَمْرَ
u'تَرْكٌ خَمْسٌ':Added, #6: 6	تَرَكَ خَمْسَ
u'تَرَكَ خَمْسَةٌ':Predicate, #1: 1	تَرْكِ الْخَمْسِ
u'تَرَكَ خَنْقٌ':Predicate, #1: 1	تَرَكَ خَمْسَةَ
u'تَرْكٌ خَوَاصُّ':Added, #1: 1	تَرَكَ الْخَنْقَ
u'تَرْكٌ خَوَاصّ':Added, #1: 1	تَرْكِ الْخَوَاصِّ
u'تَرْكٌ خَوْضٌ':Added, #1: 1	تَرْكِ الْخَوَاصِّ
u'تَرْكٌ خِيَاطَةٌ':Added, #1: 1	تَرْكُ الْخَوْضِ
u'تَرَكَ خِيَانَةٌ':Predicate, #1: 1	تَرْكَ الْخِيَاطَةِ
u'تَرْكٌ خَيْرٌ':Added, #2: 2	تَرَكَ الْخِيَانَةَ
u'تَرَكَ دَارٌ':Predicate, #1: 1	تَرْكِ الْخَيْرِ
u'تَرَكَ دُخُولٌ':Predicate, #1: 1	تَرَكَ الدَّارَ
u'تَرْكٌ دُخُولٌ':Added, #1: 1	تَرَكَ الدُّخُولَ
u'تَرْكٌ دُخُولٌ':Added, #1: 1	تَرْكِ الدُّخُولِ
u'تَرْكٌ دُخُولٌ':Added, #2: 2	تَرْكَ الدُّخُولِ
u'تَرْكٌ دَرْء':Added, #2: 2	تَرْكُ دُخُولِهِ
u'تَرَكَ دَرَاهِمُ':Predicate, #1: 1	تَرْكَ الدَّرْءِ
u'تَرْكٌ دُرُوسٌ':Added, #3: 3	تَرَكَ دَرَاهِمَ
u'تَرَكَ دُعَاءٌ':Predicate, #1: 1	تَرْك الدُّرُوسِ
u'تَرْكٌ دُعَاءٌ':Added, #6: 6	تَرَكَ الدُّعَاءَ
u'تَرْكٌ دُعَاءٌ':Added, #1: 1	تَرْكُ الدُّعَاءِ
u'تَرْكٌ دُعَاءٌ':Added, #1: 1	تَرْكِ الدّعَاءِ
u'تَرْكٌ دُعَاءٌ':Added, #1: 1	تَرْكِ دُعَاءِ
u'تَرْكٌ دُعَاءٌ':Added, #2: 2	تَرْكَ الدُّعَاءِ
u'تَرْكٌ دَعْوَةٌ':Added, #2: 2	تَرْكِ الدُّعَاءِ
u'تَرْكٌ دفع':Added, #1: 1	تَرْكُ الدَّعْوَةِ
u'تَرْكٌ دَفْعٌ':Added, #1: 1	تَرْكُ دَفْعِ
u'تَرْكٌ دفع':Added, #1: 1	تَرْكُ دَفْعِ
u'تَرْكٌ دَفْعٌ':Added, #3: 3	تَرْكُ الدَّفْعِ
u'تَرْكٌ دفن':Added, #3: 3	تَرْكُ الدَّفْعِ
u'تَرْكٌ دَفْنٌ':Added, #1: 1	تَرْكِ الدَّفْنِ
u'تَرْكٌ دلك':Added, #1: 1	تَرْكِ الدَّفْنِ
u'تَرْكٌ دَلْكٌ':Added, #1: 1	تَرْكِ الدَّلْكِ
u'تَرَكَ دَليلٌ':Predicate, #1: 1	تَرْكِ الدَّلْكِ
u'تَرْكٌ دَليلٌ':Added, #1: 1	تَرَكَ الدَّلِيلَ
u'تَرْكٌ دَليلٌ':Added, #1: 1	تَرْكِ الدَّلِيلِ
u'تَرْكٌ دَليلٌ':Added, #1: 1	تَرْكَ دَلِيلِ
u'تَرْكٌ دَليلٌ':Added, #1: 1	تَرْكُ دَلِيلِ
u'تَرْكٌ دَليلٌ':Added, #1: 1	تَرْكِ دَلِيلِهِ
u'تَرَكَ دَواءٌ':Predicate, #3: 3	تَرْكُ الدَّلِيلِ
u'تَرْكٌ دَواءٌ':Added, #1: 1	تَرَكَ الدَّوَاءَ
u'تَرْكٌ دَواءٌ':Added, #1: 1	تَرْكَ الدَّوَاءِ
u'تَرَكَ دَوَرانٌ':Predicate, #2: 2	تَرْكُ الدَّوَاءِ
u'تَرَكَ دِينٌ':Predicate, #1: 1	تَرَكَ الدَّوَرَانَ
u'تَرْكٌ دِينٌ':Added, #1: 1	تَرَكَ دِينَ
u'تَرْكٌ دِينٌ':Added, #1: 1	تَرْكُ الدِّينِ
u'تَرْكٌ ذُبابٌ':Added, #1: 1	تَرْكَ دِينِ
u'تَرَكَ ذَكاةٌ':Predicate, #1: 1	تَرْكِ الذُّبَابَةِ
u'تَرَكَ ذكر':Predicate, #1: 1	تَرَكَ ذَكَاةَ
u'تَرَكَ ذكر':Predicate, #1: 1	تَرَكَ ذُكِرَ
u'تَرَكَ ذِكْرٌ':Predicate, #1: 1	تَرَكَ ذِكْرَهُنَّ
u'تَرَكَ ذكر':Predicate, #1: 1	تَرَكَ ذِكْرَهُنَّ
u'تَرَكَ ذِكْرٌ':Predicate, #9: 9	تَرَكَ ذِكْرَ
u'تَرْكٌ ذكر':Added, #9: 9	تَرَكَ ذِكْرَ
u'تَرْكٌ ذكر':Added, #1: 1	تَرْكَ الذِّكْرِ
u'تَرْكٌ ذِكْرٌ':Added, #1: 1	تَرْكُ الذِّكْرِ
u'تَرْكٌ ذِكْرٌ':Added, #1: 1	تَرْكَ الذِّكْرِ
u'تَرْكٌ ذكر':Added, #1: 1	تَرْكُ الذِّكْرِ
u'تَرْكٌ ذِكْرٌ':Added, #1: 1	تَرْكَ ذِكْرِهِ
u'تَرْكٌ ذكر':Added, #1: 1	تَرْكَ ذِكْرِهِ
u'تَرْكٌ ذكر':Added, #2: 2	تَرْكَ ذِكْرِ
u'تَرْكٌ ذِكْرٌ':Added, #2: 2	تَرْكِ ذِكْرِ
u'تَرْكٌ ذِكْرٌ':Added, #2: 2	تَرْكَ ذِكْرِ
u'تَرْكٌ ذكر':Added, #2: 2	تَرْكِ ذِكْرِ
u'تَرْكٌ ذِكْرٌ':Added, #4: 4	تَرْكُ ذِكْرِ
u'تَرْكٌ ذكر':Added, #4: 4	تَرْكُ ذِكْرِ
u'تَرْكٌ ذِكْرٌ':Added, #4: 4	تَرْكِ ذِكْرِهِ
u'تَرْكٌ رَاجِحٌ':Added, #4: 4	تَرْكِ ذِكْرِهِ
u'تَرْكٌ رَاحَةٌ':Added, #1: 1	تَرْكِ الرَّاجِحِ
u'تَرَكَ رَأْسٌ':Predicate, #1: 1	تَرْكَ رَاحَةٍ
u'تَرَكَ رَأْيٌ':Predicate, #1: 1	تَرَكَ رَأْسَ
u'تَرْكٌ رَأْيٌ':Added, #1: 1	تَرَكَ الرَّأْيَ
u'تَرْكٌ رَبْطٌ':Added, #2: 2	تَرْكُ الرَّأْيِ
u'تَرْكٌ رُبُعٌ':Added, #1: 1	تَرْكُ الرَّبْطِ
u'تَرَكَ رَجُلٌ':Subject, #1: 1	تَرْكِ رُبُعِ
u'تَرَكَ رَجُلٌ':Subject, #2: 2	تَرَكَ رَجُلٌ
u'تَرْكٌ رَجْمٌ':Added, #4: 4	تَرَكَ الرَّجُلُ
u'تَرَكَ رُخْصَةٌ':Predicate, #1: 1	تَرْكِ رَجْمِ
u'تَرْكٌ رَدٌّ':Added, #1: 1	تَرَكَ الرُّخْصَةَ
u'تَرْكٌ رَدٌّ':Added, #1: 1	تَرْكِ الرَّدِّ
u'تَرَكَ رَسُولٌ':Subject, #2: 2	تَرْكُ رَدِّ
u'تَرَكَ رَسُولٌ':Subject, #12: 12	تَرَكَ رَسُولُ
u'تَرْكٌ رَسُولٌ':Added, #1: 1	تَرَكَ الرَّسُولُ
u'تَرَكَ رُطَبٌ':Predicate, #1: 1	تَرْكِ الرَّسُولِ
u'تَرَكَ رَطْبَةٌ':Predicate, #1: 1	تَرَكَ الرُّطَبَ
u'تَرْكٌ رِعايَةٌ':Added, #1: 1	تَرَكَ الرَّطْبَةَ
u'تَرْكٌ رِعايَةٌ':Added, #1: 1	تَرْكَ الرِّعَايَةِ
u'تَرَكَ رَفْعٌ':Predicate, #1: 1	تَرْكَ رِعَايَةِ
u'تَرَكَ رَفْعٌ':Predicate, #1: 1	تَرَكَ رَفْعَ
u'تَرْكٌ رَفْعٌ':Added, #3: 3	تَرَكَ الرَّفْعَ
u'تَرْكٌ رَفْعٌ':Added, #1: 1	تَرْكُ رَفْعِ
u'تَرْكٌ رَفْعٌ':Added, #1: 1	تَرْكِ رَفْعِ
u'تَرْكٌ رَفْعٌ':Added, #2: 2	تَرْكُ الرَّفْعِ
u'تَرْكٌ رَفيعٌ':Added, #2: 2	تَرْكِ الرَّفْعِ
u'تَرَكَ رِكابٌ':Predicate, #1: 1	تَرْكُ رَفِيعِ
u'تَرْكٌ ركعة':Added, #1: 1	تَرَكَ الرّكَابَ
u'تَرْكٌ رَكْعَةٌ':Added, #1: 1	تَرْكِ الرَّكْعَةِ
u'تَرْكٌ رُكْنٌ':Added, #1: 1	تَرْكِ الرَّكْعَةِ
u'تَرْكٌ رُكْن':Added, #11: 11	تَرْكَ رُكْنٍ
u'تَرْكٌ رُكْنٌ':Added, #11: 11	تَرْكَ رُكْنٍ
u'تَرْكٌ رُكْن':Added, #14: 14	تَرْكِ رُكْنٍ
u'تَرْكٌ رُكْنٌ':Added, #14: 14	تَرْكِ رُكْنٍ
u'تَرْكٌ رُكْن':Added, #1: 1	تَرْكَ الرُّكْنِ
u'تَرْكٌ رُكْنٌ':Added, #1: 1	تَرْكَ الرُّكْنِ
u'تَرْكٌ رُكْنٌ':Added, #1: 1	تَرْك رُكْنٍ
u'تَرْكٌ رُكْن':Added, #1: 1	تَرْكُ رُكْنٍ
u'تَرْكٌ رُكْن':Added, #1: 1	تَرْك رُكْنٍ
u'تَرْكٌ رُكْنٌ':Added, #1: 1	تَرْكُ رُكْنٍ
u'تَرْكٌ رُكْن':Added, #3: 3	تَرْكِ الرُّكْنِ
u'تَرْكٌ رُكوبٌ':Added, #3: 3	تَرْكِ الرُّكْنِ
u'تَرْكٌ رُكوبٌ':Added, #1: 1	تَرْكَ الرُّكُوبِ
u'تَرَكَ رُكوعٌ':Predicate, #1: 1	تَرْكُ الرُّكُوبِ
u'تَرْكٌ رُكوعٌ':Added, #3: 3	تَرَكَ الرُّكُوعَ
u'تَرَكَ رَمَلٌ':Predicate, #2: 2	تَرْكِ الرُّكُوعِ
u'تَرَكَ رَمَلٌ':Predicate, #1: 1	تَرَكَ رَمَلَ
u'تَرْكٌ رَمَلٌ':Added, #8: 8	تَرَكَ الرَّمَلَ
u'تَرْكٌ رَمَلٌ':Added, #1: 1	تَرْكَ الرَّمَلِ
u'تَرَكَ رَمْيٌ':Predicate, #1: 1	تَرْكُ الرَّمَلِ
u'تَرَكَ رَمْيٌ':Predicate, #23: 23	تَرَكَ رَمْيَ
u'تَرْكٌ رَمْيٌ':Added, #6: 6	تَرَكَ الرَّمْيَ
u'تَرْكٌ رَمْيٌ':Added, #1: 1	تَرْكَ الرَّمْيِ
u'تَرْكٌ رَمْي':Added, #1: 1	تَرْكُ الرَّمْيِ
u'تَرْكٌ رَمْيٌ':Added, #1: 1	تَرْكِ الرَّمْيَيْنِ
u'تَرْكٌ رَمْيٌ':Added, #1: 1	تَرْكُ رَمْيِهِ
u'تَرْكٌ رَمْيٌ':Added, #3: 3	تَرْكِ رَمْيِ
u'تَرْكٌ رَهْنٌ':Added, #7: 7	تَرْكِ الرَّمْيِ
u'تَرَكَ رَواتِبُ':Predicate, #1: 1	تَرْكَ الرَّهْنِ
u'تَرَكَ رَوَاتِبُ':Predicate, #2: 2	تَرَكَ الرَّوَاتِبَ
u'تَرَكَ رِوايَةٌ':Predicate, #2: 2	تَرَكَ الرَّوَاتِبَ
u'تَرَكَ رِوايَةٌ':Predicate, #1: 1	تَرَكَ الرِّوَايَةَ
u'تَرْكٌ رِوايَةٌ':Added, #1: 1	تَرَكَ رِوَايَةَ
u'تَرْكٌ زائِدٌ':Added, #1: 1	تَرْكِ رِوَايَةٍ
u'تَرَكَ زِراعَةٌ':Predicate, #1: 1	تَرْكِ الزَّائِدِ
u'تَرْكٌ زِراعَةٌ':Added, #1: 1	تَرَكَ الزِّرَاعَةَ
u'تَرْكٌ زَرْعٌ':Added, #1: 1	تَرْكُ زِرَاعَةِ
u'تَرْكٌ زَرْعٌ':Added, #1: 1	تَرْكِ الزَّرْعِ
u'تَرَكَ زَكاةٌ':Predicate, #5: 5	تَرْكَ الزَّرْعِ
u'تَرْكٌ زَكاةٌ':Added, #4: 4	تَرَكَ الزَّكَاةَ
u'تَرْكٌ زَكاةٌ':Added, #1: 1	تَرْكُ الزَّكَاةِ
u'تَرْكٌ زَكاةٌ':Added, #2: 2	تَرْكِ الزَّكَاةِ
u'تَرْكٌ زَمانٌ':Added, #2: 2	تَرْكِ زَكَاةٍ
u'تَرْكٌ زَنانيرُ':Added, #1: 1	تَرْكَ زَمَانَيْنِ
u'تَرَكَ زَوْجٌ':Subject, #1: 1	تَرْكِ الزَّنَانِيرِ
u'تَرْكٌ زِيادَةٌ':Added, #2: 2	تَرَكَ الزَّوْجُ
u'تَرْكٌ زِيادَةٌ':Added, #2: 2	تَرْكُ الزِّيَادَةِ
u'تَرَكَ زِيارَةٌ':Predicate, #2: 2	تَرْكِ الزِّيَادَةِ
u'تَرَكَ زَيْدٌ':Subject, #2: 2	تَرَكَ الزِّيَارَةَ
u'تَرَكَ زِينَةٌ':Predicate, #1: 1	تَرَكَ زَيْدُ
u'تَرْكٌ زِينَةٌ':Added, #1: 1	تَرَكَ زِينَةَ
u'تَرْكٌ زِينَةٌ':Added, #1: 1	تَرْكِ الزِّينَةِ
u'تَرَكَ سَارِقٌ':Predicate, #4: 4	تَرْكُ الزِّينَةِ
u'تَرْكٌ سَائِرٌ':Added, #1: 1	تَرَكَ السَّارِقَ
u'تَرْكٌ سَائِرٌ':Added, #1: 1	تَرْكِ سَائِرِ
u'تَرَكَ سائِل':Subject, #3: 3	تَرْكُ سَائِرِ
u'تَرَكَ سَائِلٌ':Subject, #1: 1	تَرَكَ السَّائِلُ
u'تَرَكَ سِبَاحَةٌ':Predicate, #1: 1	تَرَكَ السَّائِلُ
u'تَرْكٌ سَبْعٌ':Added, #1: 1	تَرَكَ السِّبَاحَةَ
u'تَرْكٌ سِتٌّ':Added, #1: 1	تَرْكِ السَّبْعِ
u'تَرْكٌ سَتْرٌ':Added, #1: 1	تَرْكِ السِّتِّ
u'تَرْكٌ سترة':Added, #1: 1	تَرْكِ السَّتْرِ
u'تَرْكٌ سُتْرَةٌ':Added, #1: 1	تَرْكَ السُّتْرَةِ
u'تَرْكٌ سترة':Added, #1: 1	تَرْكَ السُّتْرَةِ
u'تَرْكٌ سُتْرَةٌ':Added, #2: 2	تَرْكِ السُّتْرَةِ
u'تَرْكٌ سَجَّادٌ':Added, #2: 2	تَرْكِ السُّتْرَةِ
u'تَرْكٌ سَجَّادَةٌ':Added, #1: 1	تَرْكُ السَّجَّادَةِ
u'تَرَكَ سجدة':Predicate, #1: 1	تَرْكُ السَّجَّادَةِ
u'تَرَكَ سَجْدَةٌ':Predicate, #2: 2	تَرَكَ سَجْدَةَ
u'تَرَكَ سجدة':Predicate, #2: 2	تَرَكَ سَجْدَةَ
u'تَرَكَ سَجْدَةٌ':Predicate, #6: 6	تَرَكَ السَّجْدَةَ
u'تَرْكٌ سجدة':Added, #6: 6	تَرَكَ السَّجْدَةَ
u'تَرْكٌ سَجْدَةٌ':Added, #1: 1	تَرْكُ سَجْدَةٍ
u'تَرْكٌ سجدة':Added, #1: 1	تَرْكُ سَجْدَةٍ
u'تَرْكٌ سَجْدَةٌ':Added, #2: 2	تَرْكِ سَجْدَةٍ
u'تَرْكٌ سجدة':Added, #2: 2	تَرْكِ سَجْدَةٍ
u'تَرْكٌ سَجْدَةٌ':Added, #3: 3	تَرْكِ السَّجْدَةِ
u'تَرْكٌ سجدة':Added, #3: 3	تَرْكِ السَّجْدَةِ
u'تَرْكٌ سَجْدَةٌ':Added, #5: 5	تَرْكَ سَجْدَةٍ
u'تَرَكَ سُجُودٌ':Predicate, #5: 5	تَرْكَ سَجْدَةٍ
u'تَرَكَ سُجُودٌ':Predicate, #2: 2	تَرَكَ سُجُودَ
u'تَرْكٌ سُجُودٌ':Added, #8: 8	تَرَكَ السُّجُودَ
u'تَرْكٌ سُجُودٌ':Added, #2: 2	تَرْكُ السُّجُودِ
u'تَرْكٌ سُجُودٌ':Added, #5: 5	تَرْكَ السُّجُودِ
u'تَرْكٌ سِرٌّ':Added, #5: 5	تَرْكِ السُّجُودِ
u'تَرْكٌ سِرٌّ':Added, #1: 1	تَرْكُ السِّرِّ
u'تَرْكٌ سِعَايَةٌ':Added, #1: 1	تَرْكِ سِرٍّ
u'تَرَكَ سَفَرٌ':Predicate, #1: 1	تَرْكِ السِّعَايَةِ
u'تَرْكٌ سَفَرٌ':Added, #3: 3	تَرَكَ السَّفَرَ
u'تَرْكٌ سَفَرٌ':Added, #1: 1	تَرْكَ السَّفَرِ
u'تَرْكٌ سَفَرٌ':Added, #1: 1	تَرْكِ سَفَرِهِ
u'تَرْكٌ سَفَرٌ':Added, #2: 2	تَرْكُ السَّفَرِ
u'تَرَكَ سَقْيٌ':Predicate, #4: 4	تَرْكِ السَّفَرِ
u'تَرْكٌ سَقْيٌ':Added, #1: 1	تَرَكَ سَقْيَ
u'تَرْكٌ سَقْيٌ':Added, #1: 1	تَرْكُ السَّقْيِ
u'تَرْكٌ سَقْيٌ':Added, #1: 1	تَرْكِ سَقْيِ
u'تَرْكٌ سَقْيٌ':Added, #2: 2	تَرْكِ السَّقْيِ
u'تَرْكٌ سِلاَحٌ':Added, #2: 2	تَرْكُ سَقْيِ
u'تَرَكَ سلام':Predicate, #1: 1	تَرْكِ السِّلَاحِ
u'تَرَكَ سَلاَمٌ':Predicate, #1: 1	تَرَكَ السَّلَامَ
u'تَرْكٌ سلام':Added, #1: 1	تَرَكَ السَّلَامَ
u'تَرْكٌ سَلاَمٌ':Added, #2: 2	تَرْكِ السَّلَامِ
u'تَرْكٌ سلام':Added, #2: 2	تَرْكِ السَّلَامِ
u'تَرْكٌ سَلاَمٌ':Added, #8: 8	تَرْكُ السَّلَامِ
u'تَرَكَ سُلْطَانٌ':Subject, #8: 8	تَرْكُ السَّلَامِ
u'تَرَكَ سَمْعٌ':Predicate, #2: 2	تَرَكَ السُّلْطَانُ
u'تَرَكَ سِنٌّ':Predicate, #1: 1	تَرَكَ السَّمْعَ
u'تَرَكَ سُنَّةٌ':Predicate, #1: 1	تَرَكَ السِّنَّ
u'تَرَكَ سُنَّةٌ':Predicate, #11: 11	تَرَكَ السُّنَّةَ
u'تَرْكٌ سُنَّةٌ':Added, #6: 6	تَرَكَ سُنَّةَ
u'تَرْكٌ سُنَّةٌ':Added, #11: 11	تَرْكِ السُّنَّةِ
u'تَرْكٌ سُنَّةٌ':Added, #1: 1	تَرْكُ سُنَّةٍ
u'تَرْكٌ سُنَّةٌ':Added, #1: 1	تَرْكُ سُنَّةِ
u'تَرْكٌ سُنَّةٌ':Added, #1: 1	تَرْكِ سُنَّةِ
u'تَرْكٌ سُنَّةٌ':Added, #3: 3	تَرْكَ سُنَّةِ
u'تَرْكٌ سُنَّةٌ':Added, #4: 4	تَرْكَ السُّنَّةِ
u'تَرْكٌ سُنَّةٌ':Added, #5: 5	تَرْكَ سُنَّةٍ
u'تَرْكٌ سُنَّةٌ':Added, #6: 6	تَرْكُ السُّنَّةِ
u'تَرَكَ سنن':Predicate, #8: 8	تَرْكِ سُنَّةٍ
u'تَرَكَ سنن':Predicate, #2: 2	تَرَكَ السُّنَنَ
u'تَرْكٌ سنن':Added, #5: 5	تَرَكَ سُنَنَ
u'تَرْكٌ سنن':Added, #11: 11	تَرْكِ السُّنَنِ
u'تَرْكٌ سنن':Added, #2: 2	تَرْكَ السُّنَنِ
u'تَرْكٌ سنن':Added, #2: 2	تَرْكُ السُّنَنِ
u'تَرَكَ سهام':Predicate, #2: 2	تَرْكِ سُنَنِ
u'تَرَكَ سِهَامٌ':Predicate, #1: 1	تَرَكَ سِهَامَ
u'تَرَكَ سَواءٌ':Subject, #1: 1	تَرَكَ سِهَامَ
u'تَرَكَ سَوادٌ':Predicate, #1: 1	تَرَكَ سَوَاءٌ
u'تَرَكَ سِواكٌ':Predicate, #1: 1	تَرَكَ السَّوَادَ
u'تَرْكٌ سِواكٌ':Added, #1: 1	تَرَكَ السِّوَاكَ
u'تَرْكٌ سُؤَالٌ':Added, #1: 1	تَرْكُ السِّوَاكِ
u'تَرْكٌ سُؤَالٌ':Added, #1: 1	تَرْكُ السُّؤَالِ
u'تَرَكَ سُورَةٌ':Predicate, #1: 1	تَرْكِ السُّؤَالِ
u'تَرَكَ سُورَةٌ':Predicate, #1: 1	تَرَكَ سُورَةَ
u'تَرْكٌ سُورَةٌ':Added, #9: 9	تَرَكَ السُّورَةَ
u'تَرْكٌ سُورَةٌ':Added, #2: 2	تَرْكَ السُّورَةِ
u'تَرَكَ سَيِّدٌ':Subject, #2: 2	تَرْكِ السُّورَةِ
u'تَرَكَ سَيْرٌ':Subject, #1: 1	تَرَكَ السَّيِّدُ
u'تَرْكٌ سَيْرٌ':Added, #1: 1	تَرَكَ السّيْرُ
u'تَرَكَ سَيِّئٌ':Predicate, #2: 2	تَرْكُ السَّيْرِ
u'تَرَكَ شافِعِيّ':Subject, #2: 2	تَرَكَ السَّيِّئَةَ
u'تَرْكٌ شَأْنٌ':Added, #2: 2	تَرَكَ الشَّافِعِيُّ
u'تَرَكَ شُبْهَةٌ':Predicate, #1: 1	تَرْكِ شَأْنِ
u'تَرَكَ شَجَرَةٌ':Predicate, #2: 2	تَرَكَ الشُّبْهَةَ
u'تَرْكٌ شَخْصٌ':Added, #1: 1	تَرَكَ الشَّجَرَةَ
u'تَرْكٌ شَدٌّ':Added, #1: 1	تَرْكُ الشَّخْصِ
u'تَرْكٌ شَدٌّ':Added, #1: 1	تَرْكُ الشَّدِّ
u'تَرَكَ شَدَّةٌ':Predicate, #1: 1	تَرْكِ شَدِّ
u'تَرَكَ شِدَّةٌ':Predicate, #1: 1	تَرَكَ الشَّدَّةَ
u'تَرَكَ شِرَاءٌ':Predicate, #1: 1	تَرَكَ شِدَّةَ
u'تَرْكٌ شِرَاءٌ':Added, #1: 1	تَرَكَ الشِّرَاءَ
u'تَرْكٌ شِرَاءٌ':Added, #1: 1	تَرْكُ الشِّرَاءِ
u'تَرْكٌ شرب':Added, #1: 1	تَرْكِ الشِّرَاءِ
u'تَرْكٌ شرب':Added, #1: 1	تَرْكُ شُرْبِهِ
u'تَرْكٌ شُرْبٌ':Added, #1: 1	تَرْكِ شُرْبِهِ
u'تَرْكٌ شُرْبٌ':Added, #1: 1	تَرْكُ شُرْبِهِ
u'تَرَكَ شَرْطٌ':Predicate, #1: 1	تَرْكِ شُرْبِهِ
u'تَرْكٌ شَرْطٌ':Added, #2: 2	تَرَكَ الشَّرْطَ
u'تَرْكٌ شَرْطٌ':Added, #1: 1	تَرْكِ الشَّرْطِ
u'تَرْكٌ شَرْطٌ':Added, #1: 1	تَرْكُ شَرْطٍ
u'تَرْكٌ شُرُوعٌ':Added, #1: 1	تَرْكِ شَرْطِ
u'تَرَكَ شُعْبَةٌ':Subject, #1: 1	تَرْكُ الشُّرُوعِ
u'تَرْكٌ شَعِيرَةٌ':Added, #1: 1	تَرَكَ شُعْبَةُ
u'تَرْكٌ شَعِيرَة':Added, #1: 1	تَرْكُ شَعِيرَةٍ
u'تَرْكٌ شُغْلٌ':Added, #1: 1	تَرْكُ شَعِيرَةٍ
u'تَرْكٌ شُغْل':Added, #2: 2	تَرْكِ الشُّغْلِ
u'تَرْكٌ شفعة':Added, #2: 2	تَرْكِ الشُّغْلِ
u'تَرْكٌ شُفْعَةٌ':Added, #1: 1	تَرْكِ شُفْعَةٍ
u'تَرَكَ شَفِيعٌ':Subject, #1: 1	تَرْكِ شُفْعَةٍ
u'تَرْكٌ شَفِيعٌ':Added, #4: 4	تَرَكَ الشَّفِيعُ
u'تَرْكٌ شكر':Added, #1: 1	تَرْكُ الشَّفِيعِ
u'تَرْكٌ شُكْرٌ':Added, #1: 1	تَرْكَ شُكْرِ
u'تَرْكٌ شكر':Added, #1: 1	تَرْكَ شُكْرِ
u'تَرْكٌ شكر':Added, #2: 2	تَرْكُ الشُّكْرِ
u'تَرْكٌ شُكْرٌ':Added, #2: 2	تَرْكِ الشُّكْرِ
u'تَرْكٌ شُكْرٌ':Added, #2: 2	تَرْكُ الشُّكْرِ
u'تَرْكٌ شَهَادَةٌ':Added, #2: 2	تَرْكِ الشُّكْرِ
u'تَرْكٌ شَهَادَةٌ':Added, #2: 2	تَرْكُ الشَّهَادَةِ
u'تَرْكٌ شَهَوَاتٌ':Added, #2: 2	تَرْكِ الشَّهَادَةِ
u'تَرْكٌ شَهَوَاتٌ':Added, #1: 1	تَرْكُ الشَّهَوَاتِ
u'تَرْكٌ شُهُودٌ':Added, #3: 3	تَرْكِ الشَّهَوَاتِ
u'تَرْكٌ شَيْءٌ':Added, #1: 1	تَرْكُ شُهُودِ
u'تَرْكٌ شَيْءٌ':Added, #1: 1	تَرْكَ الشَّيْءِ
u'تَرْكٌ شَيْءٌ':Added, #1: 1	تَرْكُ الشَّيْءِ
u'تَرْكٌ شَيْءٌ':Added, #1: 1	تَرْكِ الشَّيْءِ
u'تَرْكٌ شَيْءٌ':Added, #1: 1	تَرْكَ شَيْءٍ
u'تَرْكٌ شَيْءٌ':Added, #3: 3	تَرْكِ شَيْءٍ
u'تَرَكَ شَيْطَانٌ':Subject, #6: 6	تَرْكُ شَيْءٍ
u'تَرَكَ صَاحِبٌ':Subject, #1: 1	تَرَكَ الشَّيْطَانُ
u'تَرْكٌ صحبة':Added, #5: 5	تَرَكَ صَاحِبُ
u'تَرْكٌ صُحْبَةٌ':Added, #1: 1	تَرْكِ صُحْبَةِ
u'تَرْكٌ صدقة':Added, #1: 1	تَرْكِ صُحْبَةِ
u'تَرْكٌ صَدَقَةٌ':Added, #1: 1	تَرْكِ صَدَقَةِ
u'تَرَكَ صَرْفٌ':Predicate, #1: 1	تَرْكِ صَدَقَةِ
u'تَرَكَ صَرْف':Predicate, #1: 1	تَرَكَ صَرْفَ
u'تَرْكٌ صَرْفٌ':Added, #1: 1	تَرَكَ صَرْفَ
u'تَرْكٌ صَرْف':Added, #1: 1	تَرْكُ صَرْفِهِ
u'تَرْكٌ صُعُودٌ':Added, #1: 1	تَرْكُ صَرْفِهِ
u'تَرْكٌ صغائر':Added, #1: 1	تَرْكُ الصُّعُودِ
u'تَرْكٌ صَغَائِرُ':Added, #1: 1	تَرْكِ الصَّغَائِرِ
u'تَرْكٌ صَفٌّ':Added, #1: 1	تَرْكِ الصَّغَائِرِ
u'تَرْكٌ صِفَةٌ':Added, #4: 4	تَرْكِ الصَّفِّ
u'تَرَكَ صَلاَةٌ':Predicate, #1: 1	تَرْكُ الصِّفَةِ
u'تَرَكَ صَلاَةٌ':Predicate, #18: 18	تَرَكَ صَلَاةَ
u'تَرَكَ صَلاَةٌ':Predicate, #2: 2	تَرَكَ صَلاةَ
u'تَرَكَ صَلاَةٌ':Predicate, #3: 3	تَرَكَ صَلاَةَ
u'تَرَكَ صَلاَةٌ':Predicate, #52: 52	تَرَكَ الصَّلاةَ
u'تَرَكَ صَلاَةٌ':Predicate, #58: 58	تَرَكَ الصَّلَاةَ
u'تَرَكَ صَلاَةٌ':Subject, #9: 9	تَرَكَ الصَّلاَةَ
u'تَرْكٌ صَلاَةٌ':Added, #1: 1	تَرَكَ صَلاةُ
u'تَرْكٌ صَلاَةٌ':Added, #13: 13	تَرْكَ الصَّلَاةِ
u'تَرْكٌ صَلاَةٌ':Added, #1: 1	تَرْكُ الصَّلاةِ
u'تَرْكٌ صَلاَةٌ':Added, #1: 1	تَرْكَ صَلَاةِ
u'تَرْكٌ صَلاَةٌ':Added, #27: 27	تَرْكُ الصَّلَاةِ
u'تَرْكٌ صَلاَةٌ':Added, #2: 2	تَرْكُ صَلَاةِ
u'تَرْكٌ صَلاَةٌ':Added, #2: 2	تَرْكِ صَلَاةٍ
u'تَرْكٌ صَلاَةٌ':Added, #2: 2	تَرْكِ صَلَاةِ
u'تَرْكٌ صَلاَةٌ':Added, #45: 45	تَرْكِ الصَّلَاةِ
u'تَرَكَ صِلَةٌ':Predicate, #5: 5	تَرْكُ الصَّلاَةِ
u'تَرْكٌ صَلَوَاتٌ':Added, #1: 1	تَرَكَ الصِّلَةَ
u'تَرَكَ صُورَةٌ':Predicate, #1: 1	تَرْكَ صَلَوَاتٍ
u'تَرْكٌ صُورَةٌ':Added, #1: 1	تَرَكَ صُورَةَ
u'تَرَكَ صَوْمٌ':Predicate, #1: 1	تَرْكُ صُورَةِ
u'تَرَكَ صَوْمٌ':Predicate, #1: 1	تَرَكَ صَوْمَ
u'تَرْكٌ صَوْمٌ':Added, #2: 2	تَرَكَ الصَّوْمَ
u'تَرْكٌ صَوْمٌ':Added, #2: 2	تَرْكَ الصَّوْمِ
u'تَرْكٌ صَوْمٌ':Added, #2: 2	تَرْكُ الصَّوْمِ
u'تَرْكٌ صَوْمٌ':Added, #2: 2	تَرْكُ صَوْمِ
u'تَرْكٌ صَوْمٌ':Added, #3: 3	تَرْكِ الصَّوْمِ
u'تَرَكَ صِيَامٌ':Predicate, #3: 3	تَرْكِ صَوْمِ
u'تَرَكَ صِيَامٌ':Predicate, #1: 1	تَرَكَ صِيَامَ
u'تَرْكٌ صِيَامٌ':Added, #2: 2	تَرَكَ الصِّيَامَ
u'تَرَكَ صِيَانَةٌ':Predicate, #1: 1	تَرْكَ الصِّيَامِ
u'تَرْكٌ ضَبْطٌ':Added, #2: 2	تَرَكَ الصِّيَانَةَ
u'تَرْكٌ ضَحِيَّةٌ':Added, #1: 1	تَرْكُ الضَّبْطِ
u'تَرْكٌ ضِدٌّ':Added, #1: 1	تَرْكِ الضَّحِيَّةِ
u'تَرْكٌ ضِدٌّ':Added, #1: 1	تَرْكُ ضِدِّهِ
u'تَرْكٌ ضِدٌّ':Added, #2: 2	تَرْكِ ضِدِّ
u'تَرَكَ ضَرْبٌ':Predicate, #3: 3	تَرْكِ ضِدِّهِ
u'تَرْكٌ ضَرْبٌ':Added, #2: 2	تَرَكَ الضَّرْبَ
u'تَرْكٌ ضَرْبٌ':Added, #1: 1	تَرْكَ الضَّرْبِ
u'تَرْكٌ ضَرْبٌ':Added, #1: 1	تَرْكُ الضَّرْبِ
u'تَرْكٌ ضَرْبٌ':Added, #1: 1	تَرْكِ الضَّرْبِ
u'تَرْكٌ ضَرَرٌ':Added, #1: 1	تَرْكَ ضَرْبِهِ
u'تَرْكٌ ضَمَانٌ':Added, #1: 1	تَرْكِ الضَّرَرِ
u'تَرْكٌ طَاعَةٌ':Added, #1: 1	تَرْكَ الضَّمَانِ
u'تَرْكٌ طَاعَةٌ':Added, #1: 1	تَرْكُ الطَّاعَاتِ
u'تَرْكٌ طَاعَةٌ':Added, #1: 1	تَرْكِ الطَّاعَاتِ
u'تَرْكٌ طَاعَةٌ':Added, #1: 1	تَرْكَ طَاعَةِ
u'تَرْكٌ طَاعَةٌ':Added, #1: 1	تَرْكُ طَاعَةِ
u'تَرْكٌ طَاعَةٌ':Added, #2: 2	تَرْكِ طَاعَةٍ
u'تَرْكٌ طَاعَةٌ':Added, #4: 4	تَرْكِ طَاعَةِ
u'تَرْكٌ طَاغِي':Added, #5: 5	تَرْكِ الطَّاعَةِ
u'تَرْكٌ طَائِفٌ':Added, #1: 1	تَرْكِ الطّاغِيَةِ
u'تَرْكٌ طَبْخٌ':Added, #2: 2	تَرْكُ الطَّائِفَةِ
u'تَرَكَ طَرِيقٌ':Predicate, #1: 1	تَرْكِ الطَّبْخِ
u'تَرَكَ طعام':Predicate, #1: 1	تَرَكَ طَرِيقَ
u'تَرَكَ طَعَامٌ':Predicate, #2: 2	تَرَكَ الطَّعَامَ
u'تَرْكٌ طعام':Added, #2: 2	تَرَكَ الطَّعَامَ
u'تَرْكٌ طَعَامٌ':Added, #2: 2	تَرْكِ الطَّعَامِ
u'تَرْكٌ طَلاَقٌ':Added, #2: 2	تَرْكِ الطَّعَامِ
u'تَرْكٌ طَلاَقٌ':Added, #1: 1	تَرْكَ الطَّلَاقِ
u'تَرَكَ طلب':Predicate, #1: 1	تَرْكُ الطَّلَاقِ
u'تَرَكَ طَلَبٌ':Predicate, #13: 13	تَرَكَ الطَّلَبَ
u'تَرَكَ طلب':Predicate, #13: 13	تَرَكَ الطَّلَبَ
u'تَرَكَ طَلَبٌ':Predicate, #2: 2	تَرَكَ طَلَبَ
u'تَرْكٌ طلب':Added, #2: 2	تَرَكَ طَلَبَ
u'تَرْكٌ طلب':Added, #1: 1	تَرْكُ الطَّلَبِ
u'تَرْكٌ طَلَبٌ':Added, #1: 1	تَرْكِ الطَّلَبِ
u'تَرْكٌ طَلَبٌ':Added, #1: 1	تَرْكُ الطَّلَبِ
u'تَرْكٌ طلب':Added, #1: 1	تَرْكِ الطَّلَبِ
u'تَرْكٌ طَلَبٌ':Added, #1: 1	تَرْكُ طَلَبِ
u'تَرْكٌ طَمٌّ':Added, #1: 1	تَرْكُ طَلَبِ
u'تَرَكَ طُمَأْنِينَةٌ':Predicate, #1: 1	تَرْكِ الطَّمِّ
u'تَرْكٌ طُمَأْنِينَةٌ':Added, #3: 3	تَرَكَ الطُّمَأْنِينَةَ
u'تَرْكٌ طُمَأْنِينَةٌ':Added, #1: 1	تَرْكُ الطُّمَأْنِينَةِ
u'تَرَكَ طَمَعٌ':Predicate, #1: 1	تَرْكِ الطُّمَأْنِينَةِ
u'تَرَكَ طَهَارَةٌ':Predicate, #1: 1	تَرَكَ الطَّمَعَ
u'تَرْكٌ طَهَارَةٌ':Added, #2: 2	تَرَكَ الطَّهَارَةَ
u'تَرْكٌ طَهَارَةٌ':Added, #1: 1	تَرْكُ طَهَارَةٍ
u'تَرْكٌ طُهْرٌ':Added, #2: 2	تَرْكِ الطَّهَارَةِ
u'تَرَكَ طواف':Predicate, #1: 1	تَرْكُ طُهْرٍ
u'تَرَكَ طَوَافٌ':Predicate, #1: 1	تَرَكَ الطَّوَافَ
u'تَرَكَ طواف':Predicate, #1: 1	تَرَكَ الطَّوَافَ
u'تَرَكَ طَوَافٌ':Predicate, #6: 6	تَرَكَ طَوَافَ
u'تَرْكٌ طواف':Added, #6: 6	تَرَكَ طَوَافَ
u'تَرْكٌ طَوَافٌ':Added, #2: 2	تَرْكَ الطَّوَافِ
u'تَرْكٌ طواف':Added, #2: 2	تَرْكَ الطَّوَافِ
u'تَرْكٌ طَوَافٌ':Added, #2: 2	تَرْكُ طَوَافِ
u'تَرْكٌ طواف':Added, #2: 2	تَرْكُ طَوَافِ
u'تَرْكٌ طَوَافٌ':Added, #3: 3	تَرْكِ الطَّوَافِ
u'تَرْكٌ طواف':Added, #3: 3	تَرْكِ الطَّوَافِ
u'تَرْكٌ طَوَافٌ':Added, #7: 7	تَرْكِ طَوَافِ
u'تَرَكَ طِيبٌ':Predicate, #7: 7	تَرْكِ طَوَافِ
u'تَرْكٌ طِيبٌ':Added, #1: 1	تَرَكَ الطِّيبَ
u'تَرْكٌ طِيبٌ':Added, #1: 1	تَرْكَ الطِّيبِ
u'تَرْكٌ طِيبٌ':Added, #1: 1	تَرْكُ الطِّيبِ
u'تَرْكٌ طِيبٌ':Added, #1: 1	تَرْكُ طِيبٍ
u'تَرْكٌ طِيَرَةٌ':Added, #2: 2	تَرْكِ الطِّيبِ
u'تَرَكَ ظاهِرٌ':Predicate, #1: 1	تَرْكِ الطِّيَرَةِ
u'تَرْكٌ ظُلْمٌ':Added, #1: 1	تَرَكَ الظَّاهِرَ
u'تَرَكَ ظُهْرٌ':Predicate, #1: 1	تَرْكَ الظُّلْمِ
u'تَرَكَ عَادَةٌ':Predicate, #4: 4	تَرَكَ الظُّهْرَ
u'تَرَكَ عَاشُورَاءُ':Predicate, #1: 1	تَرَكَ عَادَةَ
u'تَرَكَ عَالِمٌ':Subject, #1: 1	تَرَكَ عَاشُورَاءَ
u'تَرَكَ عَامِلٌ':Subject, #4: 4	تَرَكَ الْعَالِمُ
u'تَرْكٌ عَامِلٌ':Added, #1: 1	تَرَكَ الْعَامِلُ
u'تَرَكَ عِبَادَةٌ':Predicate, #1: 1	تَرْكُ الْعَامِلِ
u'تَرْكٌ عِبَادَةٌ':Added, #2: 2	تَرَكَ الْعِبَادَةَ
u'تَرْكٌ عِبَادَةٌ':Added, #1: 1	تَرْكِ الْعِبَادَةِ
u'تَرَكَ عَبْدٌ':Predicate, #2: 2	تَرْكِ الْعِبَادَاتِ
u'تَرَكَ عَبْدٌ':Subject, #2: 2	تَرَكَ الْعَبْدَ
u'تَرْكٌ عَبْدٌ':Added, #2: 2	تَرَكَ الْعَبْدُ
u'تَرْكٌ عتاب':Added, #3: 3	تَرْكُ الْعَبْدِ
u'تَرْكٌ عِتَابٌ':Added, #1: 1	تَرْكَ الْعِتَابِ
u'تَرَكَ عُجْبٌ':Predicate, #1: 1	تَرْكَ الْعِتَابِ
u'تَرْكٌ عجلة':Added, #1: 1	تَرَكَ الْعُجْبَ
u'تَرْكٌ عَجَلَةٌ':Added, #2: 2	تَرْكُ الْعَجَلَةِ
u'تَرْكٌ عَدْلٌ':Added, #2: 2	تَرْكُ الْعَجَلَةِ
u'تَرْكٌ عُدُولٌ':Added, #2: 2	تَرْكِ الْعَدْلِ
u'تَرْكٌ عَرُوسٌ':Added, #1: 1	تَرْكَ الْعُدُولِ
u'تَرْكٌ عَزِيمَةٌ':Added, #1: 1	تَرْكُ الْعَرُوسِ
u'تَرْكٌ عَزِيمَةٌ':Added, #1: 1	تَرْكُ الْعَزِيمَةِ
u'تَرْكٌ عَشَاءٌ':Added, #1: 1	تَرْكِ الْعَزِيمَةِ
u'تَرَكَ عُشْرٌ':Predicate, #1: 1	تَرْكُ الْعَشَاءِ
u'تَرَكَ عُشْرٌ':Predicate, #1: 1	تَرَكَ الْعُشْرَ
u'تَرَكَ عَشْرٌ':Predicate, #1: 1	تَرَكَ عُشْرَ
u'تَرْكٌ عُشْرٌ':Added, #2: 2	تَرَكَ عَشْرَ
u'تَرْكٌ عَصَبٌ':Added, #1: 1	تَرْكَ الْعُشْرِ
u'تَرَكَ عَصْرٌ':Predicate, #1: 1	تَرْكِ الْعَصَبِ
u'تَرْكٌ عِصْيَانٌ':Added, #2: 2	تَرَكَ الْعَصْرَ
u'تَرْكٌ عِصْيَانٌ':Added, #1: 1	تَرْكَ عِصْيَانٍ
u'تَرْكٌ عِصْيَانٌ':Added, #1: 1	تَرْكِ عِصْيَانٍ
u'تَرْكٌ عُضْوٌ':Added, #2: 2	تَرْكِ الْعِصْيَانِ
u'تَرْكٌ عطف':Added, #2: 2	تَرْكِ عُضْوٍ
u'تَرْكٌ عَطْفٌ':Added, #1: 1	تَرْكَ الْعَطْفِ
u'تَرْكٌ عقاب':Added, #1: 1	تَرْكَ الْعَطْفِ
u'تَرْكٌ عِقَابٌ':Added, #1: 1	تَرْكِ عِقَابِ
u'تَرَكَ عَقَارٌ':Predicate, #1: 1	تَرْكِ عِقَابِ
u'تَرَكَ عَقْلٌ':Predicate, #1: 1	تَرَكَ عَقَارَ
u'تَرَكَ عِلاَجٌ':Predicate, #1: 1	تَرَكَ الْعَقْلَ
u'تَرَكَ عَلَفٌ':Predicate, #1: 1	تَرَكَ الْعِلَاجَ
u'تَرْكٌ عَلَفٌ':Added, #1: 1	تَرَكَ عَلَفَ
u'تَرْكٌ عَلَفٌ':Added, #1: 1	تَرْكَ الْعَلَفِ
u'تَرَكَ عَمٌّ':Predicate, #1: 1	تَرْكِ عَلَفِ
u'تَرَكَ عِمَارَةٌ':Predicate, #2: 2	تَرَكَ عَمَّ
u'تَرَكَ عِمَارَةٌ':Predicate, #1: 1	تَرَكَ الْعِمَارَةَ
u'تَرْكٌ عِمَارَةٌ':Added, #1: 1	تَرَكَ عِمَارَةَ
u'تَرَكَ عَمَّةٌ':Predicate, #1: 1	تَرْكُ الْعِمَارَةِ
u'تَرْكٌ عمرة':Added, #1: 1	تَرَكَ عَمَّةَ
u'تَرْكٌ عُمْرَةٌ':Added, #1: 1	تَرْكِ الْعُمْرَةِ
u'تَرَكَ عَمَلٌ':Predicate, #1: 1	تَرْكِ الْعُمْرَةِ
u'تَرْكٌ عَمَلٌ':Added, #11: 11	تَرَكَ الْعَمَلَ
u'تَرْكٌ عَمَلٌ':Added, #13: 13	تَرْكَ الْعَمَلِ
u'تَرْكٌ عَمَلٌ':Added, #13: 13	تَرْكِ الْعَمَلِ
u'تَرْكٌ عَمَلٌ':Added, #1: 1	تَرْكَ عَمَلِ
u'تَرْكٌ عَمَلٌ':Added, #1: 1	تَرْكُ عَمَلِ
u'تَرْكٌ عَمَلٌ':Added, #1: 1	تَرْكِ عَمَلٍ
u'تَرْكٌ عَمَلٌ':Added, #1: 1	تَرْكُ عَمَلِهِ
u'تَرْكٌ عُمُومٌ':Added, #21: 21	تَرْكُ الْعَمَلِ
u'تَرْكٌ عُمُومٌ':Added, #1: 1	تَرْكَ الْعُمُومِ
u'تَرْكٌ عُمُومٌ':Added, #1: 1	تَرْكُ الْعُمُومِ
u'تَرَكَ عَوْدٌ':Predicate, #1: 1	تَرْكِ الْعُمُومِ
u'تَرْكٌ عَوْدٌ':Added, #1: 1	تَرَكَ الْعَوْدَ
u'تَرْكٌ عَوْل':Added, #2: 2	تَرْكِ الْعَوْدِ
u'تَرَكَ عِيَادَةٌ':Predicate, #1: 1	تَرْكِ الْعَوْلِ
u'تَرْكٌ عِيَادَةٌ':Added, #2: 2	تَرَكَ الْعِيَادَةَ
u'تَرْكٌ عِيَادَةٌ':Added, #1: 1	تَرْكِ الْعِيَادَةِ
u'تَرْكٌ عين':Added, #2: 2	تَرْكُ عِيَادَةِ
u'تَرْكٌ عَيْنٌ':Added, #1: 1	تَرْكُ الْعَيْنِ
u'تَرْكٌ عَيْن':Added, #1: 1	تَرْكُ الْعَيْنِ
u'تَرَكَ غَدَاءٌ':Predicate, #1: 1	تَرْكُ الْعَيْنِ
u'تَرْكٌ غَدَاءٌ':Added, #1: 1	تَرَكَ الْغَدَاءَ
u'تَرْكٌ غَدَاءٌ':Added, #1: 1	تَرْكَ الْغَدَاءِ
u'تَرْكٌ غَدَاءٌ':Added, #1: 1	تَرْكُ الْغَدَاءِ
u'تَرْكٌ غِذَاءٌ':Added, #4: 4	تَرْكِ الْغَدَاءِ
u'تَرْكٌ غِذَاءٌ':Added, #1: 1	تَرْكَ الْغِذَاءِ
u'تَرْكٌ غَزْوٌ':Added, #1: 1	تَرْكِ الْغِذَاءِ
u'تَرَكَ غُسْلٌ':Predicate, #1: 1	تَرْكُ الْغَزْوِ
u'تَرْكٌ غَسْلٌ':Added, #2: 2	تَرَكَ الْغُسْلَ
u'تَرْكٌ غُسْلٌ':Added, #1: 1	تَرْكُ الْغَسْلِ
u'تَرْكٌ غَسْلٌ':Added, #1: 1	تَرْكِ الْغُسْلِ
u'تَرْكٌ غَسْلٌ':Added, #1: 1	تَرْكَ غَسْلِ
u'تَرْكٌ غَسْلٌ':Added, #1: 1	تَرْكُ غَسْلِ
u'تَرْكٌ غُسْلٌ':Added, #1: 1	تَرْكِ غَسْلِ
u'تَرْكٌ غُسْلٌ':Added, #1: 1	تَرْكِ غُسْلِهِ
u'تَرْكٌ غُسْلٌ':Added, #2: 2	تَرْكُ الْغُسْلِ
u'تَرْكٌ غَسْلٌ':Added, #2: 2	تَرْكَ غُسْلِ
u'تَرْكٌ غُسْلٌ':Added, #2: 2	تَرْكُ غَسْلِهِ
u'تَرْكٌ غَطْسٌ':Added, #3: 3	تَرْكَ الْغُسْلِ
u'تَرْكٌ غُلُول':Added, #1: 1	تَرْكَ غَطْسِهِ
u'تَرَكَ غير':Predicate, #1: 1	تَرْكُ الْغُلُولِ
u'تَرَكَ غَيْرٌ':Predicate, #3: 3	تَرَكَ غَيْرَ
u'تَرْكٌ غير':Added, #3: 3	تَرَكَ غَيْرَ
u'تَرْكٌ غَيْرٌ':Added, #2: 2	تَرْكِ غَيْرِهِ
u'تَرْكٌ غير':Added, #2: 2	تَرْكِ غَيْرِهِ
u'تَرْكٌ غَيْرٌ':Added, #4: 4	تَرْكِ غَيْرِ
u'تَرَكَ فَاتِحٌ':Predicate, #4: 4	تَرْكِ غَيْرِ
u'تَرْكٌ فَاتِحٌ':Added, #10: 10	تَرَكَ الْفَاتِحَةَ
u'تَرْكٌ فَاتِحٌ':Added, #1: 1	تَرْكُ الْفَاتِحَةِ
u'تَرْكٌ فَاتِحٌ':Added, #2: 2	تَرْكَ الْفَاتِحَةِ
u'تَرَكَ فَاتِحَةٌ':Predicate, #2: 2	تَرْكِ الْفَاتِحَةِ
u'تَرْكٌ فَاتِحَةٌ':Added, #10: 10	تَرَكَ الْفَاتِحَةَ
u'تَرْكٌ فَاتِحَةٌ':Added, #1: 1	تَرْكُ الْفَاتِحَةِ
u'تَرْكٌ فَاتِحَةٌ':Added, #2: 2	تَرْكَ الْفَاتِحَةِ
u'تَرَكَ فَاقِدٌ':Subject, #2: 2	تَرْكِ الْفَاتِحَةِ
u'تَرْكٌ فتنة':Added, #1: 1	تَرَكَ فَاقِدُ
u'تَرْكٌ فِتْنَةٌ':Added, #1: 1	تَرْكِ الْفِتْنَةِ
u'تَرَكَ فَجْرٌ':Predicate, #1: 1	تَرْكِ الْفِتْنَةِ
u'تَرَكَ فُرَاتٌ':Predicate, #1: 1	تَرَكَ فَجْرَ
u'تَرَكَ فُرَاتٌ':Subject, #1: 1	تَرَكَ الْفُرَاتَ
u'تَرْكٌ فَرَائِضُ':Added, #2: 2	تَرَكَ الْفُرَاتُ
u'تَرْكٌ فَرَائِضُ':Added, #1: 1	تَرْكِ فَرَائِضِ
u'تَرْكٌ فَرَائِضُ':Added, #2: 2	تَرْكَ الْفَرَائِضِ
u'تَرَكَ فَرْضٌ':Predicate, #6: 6	تَرْكِ الْفَرَائِضِ
u'تَرَكَ فَرْضٌ':Predicate, #5: 5	تَرَكَ الْفَرْضَ
u'تَرْكٌ فَرْضٌ':Added, #8: 8	تَرَكَ فَرْضَ
u'تَرْكٌ فَرْضٌ':Added, #1: 1	تَرْكَ فَرْضِ
u'تَرْكٌ فَرْضٌ':Added, #1: 1	تَرْكُ فَرْضِ
u'تَرْكٌ فَرْضٌ':Added, #1: 1	تَرْكَ فَرْضِهِ
u'تَرْكٌ فَرْضٌ':Added, #3: 3	تَرْكَ الْفَرْضِ
u'تَرْكٌ فَرْضٌ':Added, #3: 3	تَرْكَ فَرْضٍ
u'تَرْكٌ فَرْضٌ':Added, #3: 3	تَرْكُ فَرْضٍ
u'تَرْكٌ فَرْضٌ':Added, #4: 4	تَرْكِ فَرْضِ
u'تَرْكٌ فَرْضٌ':Added, #6: 6	تَرْكِ فَرْضٍ
u'تَرْكٌ فَرْضٌ':Added, #7: 7	تَرْكِ الْفَرْضِ
u'تَرْكٌ فُرُوضٌ':Added, #9: 9	تَرْكُ الْفَرْضِ
u'تَرْكٌ فُرُوضٌ':Added, #1: 1	تَرْكَ الْفُرُوضِ
u'تَرْكٌ فَرِيضَةٌ':Added, #3: 3	تَرْكُ الْفُرُوضِ
u'تَرْكٌ فَرِيضَةٌ':Added, #1: 1	تَرْكِ الْفَرِيضَةِ
u'تَرْكٌ فَرِيضَةٌ':Added, #1: 1	تَرْكُ فَرِيضَةٍ
u'تَرْكٌ فَرِيضَةٌ':Added, #2: 2	تَرْكُ الْفَرِيضَةِ
u'تَرْكٌ فساد':Added, #3: 3	تَرْكِ فَرِيضَةٍ
u'تَرْكٌ فَسَادٌ':Added, #1: 1	تَرْكِ الْفَسَادِ
u'تَرَكَ فَسْخٌ':Predicate, #1: 1	تَرْكِ الْفَسَادِ
u'تَرْكٌ فَسْخٌ':Added, #1: 1	تَرَكَ الْفَسْخَ
u'تَرْكٌ فِسْقٌ':Added, #4: 4	تَرْكَ الْفَسْخِ
u'تَرْكٌ فَضْلٌ':Added, #1: 1	تَرْكِ الْفِسْقِ
u'تَرْكٌ فُضُولٌ':Added, #1: 1	تَرْكُ فَضْلِ
u'تَرْكٌ فُضُولٌ':Added, #1: 1	تَرْكُ فُضُولِ
u'تَرْكٌ فَضِيحَةٌ':Added, #2: 2	تَرْكُ الْفُضُولِ
u'تَرَكَ فَضِيلٌ':Predicate, #1: 1	تَرْكَ الْفَضِيحَةِ
u'تَرْكٌ فَضِيلٌ':Added, #1: 1	تَرَكَ الْفَضِيلَةَ
u'تَرَكَ فَضِيلَةٌ':Predicate, #2: 2	تَرْكُ فَضِيلَةِ
u'تَرْكٌ فَضِيلَةٌ':Added, #1: 1	تَرَكَ الْفَضِيلَةَ
u'تَرْكٌ فَضِيلَةٌ':Added, #1: 1	تَرْكُ فَضِيلَةٍ
u'تَرَكَ فِعْلٌ':Predicate, #2: 2	تَرْكُ فَضِيلَةِ
u'تَرْكٌ فِعْلٌ':Added, #1: 1	تَرَكَ فِعْلَ
u'تَرْكٌ فِعْلٌ':Added, #1: 1	تَرْكَ الْفِعْلِ
u'تَرْكٌ فِعْلٌ':Added, #1: 1	تَرْكِ فِعْلِ
u'تَرْكٌ فِعْلٌ':Added, #2: 2	تَرْكُ فِعْلِ
u'تَرْكٌ فِعْلٌ':Added, #2: 2	تَرْكِ فِعْلٍ
u'تَرْكٌ فِعْلٌ':Added, #5: 5	تَرْكُ الْفِعْلِ
u'تَرَكَ فلان':Subject, #6: 6	تَرْكِ الْفِعْلِ
u'تَرَكَ فلان':Subject, #2: 2	تَرَكَ الشَّافِعِيُّ
u'تَرْكٌ فَيْءٌ':Added, #2: 2	تَرَكَ الْمَكِّيُّ
u'تَرَكَ قَارِئٌ':Subject, #1: 1	تَرْكَ الْفَيْءِ
u'تَرَكَ قَبَاءٌ':Predicate, #3: 3	تَرَكَ الْقَارِئُ
u'تَرْكٌ قِبْلَةٌ':Added, #1: 1	تَرَكَ الْقَبَاءَ
u'تَرْكٌ قَبِيحٌ':Added, #1: 1	تَرْكِ الْقِبْلَةِ
u'تَرَكَ قتال':Predicate, #1: 1	تَرْكُ الْقَبِيحِ
u'تَرَكَ قِتَالٌ':Predicate, #1: 1	تَرَكَ قِتَالَ
u'تَرَكَ قتال':Predicate, #1: 1	تَرَكَ قِتَالَ
u'تَرَكَ قِتَالٌ':Predicate, #3: 3	تَرَكَ الْقِتَالَ
u'تَرْكٌ قتال':Added, #3: 3	تَرَكَ الْقِتَالَ
u'تَرْكٌ قِتَالٌ':Added, #1: 1	تَرْكُ الْقِتَالِ
u'تَرْكٌ قتال':Added, #1: 1	تَرْكُ الْقِتَالِ
u'تَرْكٌ قِتَالٌ':Added, #2: 2	تَرْكَ قِتَالِهِ
u'تَرْكٌ قتال':Added, #2: 2	تَرْكَ قِتَالِهِ
u'تَرْكٌ قِتَالٌ':Added, #3: 3	تَرْكَ الْقِتَالِ
u'تَرْكٌ قتال':Added, #3: 3	تَرْكَ الْقِتَالِ
u'تَرْكٌ قِتَالٌ':Added, #9: 9	تَرْكِ الْقِتَالِ
u'تَرَكَ قتل':Predicate, #9: 9	تَرْكِ الْقِتَالِ
u'تَرَكَ قَتْلٌ':Predicate, #1: 1	تَرَكَ الْقَتْلَ
u'تَرْكٌ قتل':Added, #1: 1	تَرَكَ الْقَتْلَ
u'تَرْكٌ قَتْلٌ':Added, #1: 1	تَرْكِ قَتْلِ
u'تَرْكٌ قتل':Added, #1: 1	تَرْكِ قَتْلِ
u'تَرْكٌ قَتْلٌ':Added, #1: 1	تَرْكُ قَتْلِهِ
u'تَرْكٌ قتل':Added, #1: 1	تَرْكُ قَتْلِهِ
u'تَرْكٌ قَتْلٌ':Added, #2: 2	تَرْكِ الْقَتْلِ
u'تَرْكٌ قذف':Added, #2: 2	تَرْكِ الْقَتْلِ
u'تَرْكٌ قَذْفٌ':Added, #1: 1	تَرْكِ الْقَذْفِ
u'تَرَكَ قِرَاءةٌ':Predicate, #1: 1	تَرْكِ الْقَذْفِ
u'تَرَكَ قِرَاءةٌ':Predicate, #12: 12	تَرَكَ قِرَاءَةَ
u'تَرْكٌ قِرَاءةٌ':Added, #35: 35	تَرَكَ الْقِرَاءَةَ
u'تَرْكٌ قِرَاءةٌ':Added, #10: 10	تَرْكَ الْقِرَاءَةِ
u'تَرْكٌ قِرَاءةٌ':Added, #11: 11	تَرْكِ الْقِرَاءَةِ
u'تَرْكٌ قِرَاءةٌ':Added, #1: 1	تَرْكُ قِرَاءَةِ
u'تَرَكَ قُرْآنٌ':Predicate, #9: 9	تَرْكُ الْقِرَاءَةِ
u'تَرْكٌ قُرْبَانٌ':Added, #1: 1	تَرَكَ الْقُرْآنَ
u'تَرْكٌ قُرْبَةٌ':Added, #1: 1	تَرْكُ الْقُرْبَانِ
u'تَرْكٌ قَرْضٌ':Added, #1: 1	تَرْكِ قُرْبَةٍ
u'تَرْكٌ قسمة':Added, #1: 1	تَرْكِ الْقَرْضِ
u'تَرْكٌ قِسْمَةٌ':Added, #2: 2	تَرْكِ الْقِسْمَةِ
u'تَرْكٌ قصاص':Added, #2: 2	تَرْكِ الْقِسْمَةِ
u'تَرْكٌ قِصَاصٌ':Added, #3: 3	تَرْكُ الْقِصَاصِ
u'تَرْكٌ قَصْدٌ':Added, #3: 3	تَرْكُ الْقِصَاصِ
u'تَرَكَ قَصْرٌ':Predicate, #1: 1	تَرْكَ الْقَصْدِ
u'تَرْكٌ قَضَاءٌ':Added, #1: 1	تَرَكَ الْقَصْرَ
u'تَرْكٌ قَطْعٌ':Added, #3: 3	تَرْكِ الْقَضَاءِ
u'تَرْكٌ قَطْعٌ':Added, #1: 1	تَرْكِ الْقَطْعِ
u'تَرَكَ قعدة':Predicate, #1: 1	تَرْكِ قَطْعِ
u'تَرَكَ قَعْدَةٌ':Predicate, #11: 11	تَرَكَ الْقَعْدَةَ
u'تَرْكٌ قعدة':Added, #11: 11	تَرَكَ الْقَعْدَةَ
u'تَرْكٌ قعدة':Added, #3: 3	تَرْكَ الْقَعْدَةِ
u'تَرْكٌ قَعْدَةٌ':Added, #3: 3	تَرْكُ الْقَعْدَةِ
u'تَرْكٌ قَعْدَةٌ':Added, #3: 3	تَرْكَ الْقَعْدَةِ
u'تَرَكَ قُعُودٌ':Predicate, #3: 3	تَرْكُ الْقَعْدَةِ
u'تَرْكٌ قُعُودٌ':Added, #1: 1	تَرَكَ الْقُعُودَ
u'تَرْكٌ قُعُودٌ':Added, #1: 1	تَرْكَ الْقُعُودِ
u'تَرْكٌ قلب':Added, #1: 1	تَرْكِ الْقُعُودِ
u'تَرَكَ قُنُوتٌ':Predicate, #1: 1	تَرْكُ الْقُلْبِ
u'تَرْكٌ قُنُوتٌ':Added, #5: 5	تَرَكَ الْقُنُوتَ
u'تَرْكٌ قُنُوتٌ':Added, #3: 3	تَرْكَ الْقُنُوتِ
u'تَرْكٌ قَوَد':Added, #4: 4	تَرْكِ الْقُنُوتِ
u'تَرَكَ قول':Predicate, #1: 1	تَرْكِ الْقَوَدِ
u'تَرَكَ قَوْلٌ':Predicate, #1: 1	تَرَكَ الْقَوْلَ
u'تَرْكٌ قول':Added, #1: 1	تَرَكَ الْقَوْلَ
u'تَرْكٌ قَوْلٌ':Added, #1: 1	تَرْكُ الْقَوْلِ
u'تَرْكٌ قول':Added, #1: 1	تَرْكُ الْقَوْلِ
u'تَرْكٌ قول':Added, #1: 1	تَرْكُ قَوْلِ
u'تَرْكٌ قَوْلٌ':Added, #1: 1	تَرْكِ قَوْلِ
u'تَرْكٌ قَوْلٌ':Added, #1: 1	تَرْكُ قَوْلِ
u'تَرْكٌ قول':Added, #1: 1	تَرْكِ قَوْلِ
u'تَرْكٌ قَوْلٌ':Added, #3: 3	تَرْكِ الْقَوْلِ
u'تَرَكَ قَوْمٌ':Subject, #3: 3	تَرْكِ الْقَوْلِ
u'تَرْكٌ قَوْمٌ':Added, #2: 2	تَرَكَ قَوْمٌ
u'تَرَكَ قَوْمَةٌ':Predicate, #1: 1	تَرْكُ قَوْمٍ
u'تَرَكَ قِيَاسٌ':Predicate, #2: 2	تَرَكَ الْقَوْمَةَ
u'تَرْكٌ قِيَاسٌ':Added, #7: 7	تَرَكَ الْقِيَاسَ
u'تَرْكٌ قِيَاسٌ':Added, #1: 1	تَرْكِ الْقِيَاسِ
u'تَرْكٌ قِيَاسٌ':Added, #2: 2	تَرْكَ الْقِيَاسِ
u'تَرَكَ قيام':Predicate, #4: 4	تَرْكُ الْقِيَاسِ
u'تَرَكَ قِيَامٌ':Predicate, #9: 9	تَرَكَ الْقِيَامَ
u'تَرْكٌ قيام':Added, #9: 9	تَرَكَ الْقِيَامَ
u'تَرْكٌ قِيَامٌ':Added, #16: 16	تَرْكُ الْقِيَامِ
u'تَرْكٌ قيام':Added, #16: 16	تَرْكُ الْقِيَامِ
u'تَرْكٌ قيام':Added, #1: 1	تَرْكُ قِيَامِ
u'تَرْكٌ قِيَامٌ':Added, #1: 1	تَرْكِ قِيَامِ
u'تَرْكٌ قِيَامٌ':Added, #1: 1	تَرْكُ قِيَامِ
u'تَرْكٌ قيام':Added, #1: 1	تَرْكِ قِيَامِ
u'تَرْكٌ قِيَامٌ':Added, #5: 5	تَرْكَ الْقِيَامِ
u'تَرْكٌ قيام':Added, #5: 5	تَرْكَ الْقِيَامِ
u'تَرْكٌ قِيَامٌ':Added, #7: 7	تَرْكِ الْقِيَامِ
u'تَرَكَ قَيْدٌ':Predicate, #7: 7	تَرْكِ الْقِيَامِ
u'تَرْكٌ قِيمَةٌ':Added, #1: 1	تَرَكَ قَيْدَ
u'تَرْكٌ كبائر':Added, #1: 1	تَرْكِ قِيمَتِهِ
u'تَرْكٌ كبائر':Added, #2: 2	تَرْكُ الْكَبَائِرِ
u'تَرَكَ كِتَابٌ':Predicate, #2: 2	تَرْكِ الْكَبَائِرِ
u'تَرَكَ كِتَابَةٌ':Predicate, #5: 5	تَرَكَ الْكِتَابَ
u'تَرْكٌ كِتْمَانٌ':Added, #1: 1	تَرَكَ الْكِتَابَةَ
u'تَرْكٌ كَدَرٌ':Added, #1: 1	تَرْكُ الْكِتْمَانِ
u'تَرَكَ كذب':Predicate, #1: 1	تَرْكُ الْكَدَرِ
u'تَرَكَ كَذِبٌ':Predicate, #4: 4	تَرَكَ الْكَذِبَ
u'تَرَكَ كِرْباس':Predicate, #4: 4	تَرَكَ الْكَذِبَ
u'تَرَكَ كَسْبٌ':Predicate, #1: 1	تَرَكَ الْكِرْبَاسَ
u'تَرْكٌ كَسْرٌ':Added, #1: 1	تَرَكَ الْكَسْبَ
u'تَرْكٌ كَسْرٌ':Added, #1: 1	تَرْكُ كَسْرِ
u'تَرْكٌ كَشْفٌ':Added, #3: 3	تَرْكِ الْكَسْرِ
u'تَرَكَ كعبة':Predicate, #1: 1	تَرْكُ كَشْفِ
u'تَرَكَ كَعْبَةٌ':Predicate, #1: 1	تَرَكَ الْكَعْبَةَ
u'تَرْكٌ كَفٌّ':Added, #1: 1	تَرَكَ الْكَعْبَةَ
u'تَرْكٌ كَفَاءةٌ':Added, #1: 1	تَرْكُ الْكَفِّ
u'تَرَكَ كَفَّارٌ':Predicate, #1: 1	تَرْكِ الْكَفَاءَةِ
u'تَرَكَ كَفَّارَةٌ':Predicate, #1: 1	تَرَكَ كَفَّارَةَ
u'تَرْكٌ كَفَالَةٌ':Added, #1: 1	تَرَكَ كَفَّارَةَ
u'تَرَكَ كفر':Predicate, #1: 1	تَرْكِ الْكَفَالَةِ
u'تَرَكَ كُفْرٌ':Predicate, #1: 1	تَرَكَ الْكُفْرَ
u'تَرْكٌ كفر':Added, #1: 1	تَرَكَ الْكُفْرَ
u'تَرْكٌ كُفْرٌ':Added, #1: 1	تَرْكُ الْكُفْرِ
u'تَرَكَ كَلاَمٌ':Predicate, #1: 1	تَرْكُ الْكُفْرِ
u'تَرْكٌ كَلاَمٌ':Added, #2: 2	تَرَكَ الْكَلَامَ
u'تَرْكٌ كَلاَمٌ':Added, #1: 1	تَرْكَ كَلَامِ
u'تَرْكٌ كَلاَمٌ':Added, #1: 1	تَرْكِ كَلَامِ
u'تَرْكٌ كَلاَمٌ':Added, #1: 1	تَرْكَ كَلَامِهِ
u'تَرْكٌ كَلاَمٌ':Added, #1: 1	تَرْكُ كَلَامِهِ
u'تَرْكٌ كَلاَمٌ':Added, #3: 3	تَرْكِ الْكَلَامِ
u'تَرْكٌ كَلاَمٌ':Added, #4: 4	تَرْكَ الْكَلَامِ
u'تَرْكٌ كَمَالٌ':Added, #6: 6	تَرْكُ الْكَلَامِ
u'تَرَكَ لِبَاسٌ':Predicate, #1: 1	تَرْكَ كَمَالٍ
u'تَرَكَ لبس':Predicate, #3: 3	تَرَكَ اللِّبَاسَ
u'تَرَكَ لُبْسٌ':Predicate, #1: 1	تَرَكَ اللُّبْسَ
u'تَرَكَ لبس':Predicate, #1: 1	تَرَكَ اللُّبْسَ
u'تَرَكَ لُبْسٌ':Predicate, #1: 1	تَرَكَ لُبْسَ
u'تَرْكٌ لبس':Added, #1: 1	تَرَكَ لُبْسَ
u'تَرْكٌ لبس':Added, #1: 1	تَرْكُ لُبْسِ
u'تَرْكٌ لُبْسٌ':Added, #1: 1	تَرْكُ لِبْسِ
u'تَرْكٌ لِبْسٌ':Added, #1: 1	تَرْكُ لُبْسِ
u'تَرْكٌ لبس':Added, #1: 1	تَرْكُ لِبْسِ
u'تَرْكٌ لُبْسٌ':Added, #3: 3	تَرْكَ لُبْسِ
u'تَرْكٌ لبن':Added, #3: 3	تَرْكَ لُبْسِ
u'تَرْكٌ لَبَنٌ':Added, #1: 1	تَرْكُ اللَّبَنِ
u'تَرَكَ لُزُومٌ':Predicate, #1: 1	تَرْكُ اللَّبَنِ
u'تَرْكٌ لُطْفٌ':Added, #1: 1	تَرَكَ اللُّزُومَ
u'تَرْكٌ لُطْفٌ':Added, #1: 1	تَرْكَ اللُّطْفِ
u'تَرَكَ لَعْن':Predicate, #1: 1	تَرْكُ اللُّطْفِ
u'تَرْكٌ لَعْن':Added, #2: 2	تَرَكَ اللَّعْنَ
u'تَرَكَ لَفْظٌ':Predicate, #1: 1	تَرْكَ اللَّعْنِ
u'تَرْكٌ لَفْظٌ':Added, #3: 3	تَرَكَ لَفْظَ
u'تَرْكٌ لَفْظٌ':Added, #1: 1	تَرْكِ لَفْظٍ
u'تَرَكَ لَفْظَةٌ':Predicate, #1: 1	تَرْكِ لَفْظِ
u'تَرْكٌ لَفْظَةٌ':Added, #3: 3	تَرَكَ لَفْظَةَ
u'تَرْكٌ لَفْظَةٌ':Added, #1: 1	تَرْكَ لَفْظَةِ
u'تَرْكٌ لُقْمَةٌ':Added, #1: 1	تَرْكُ لَفْظَةِ
u'تَرْكٌ لمعة':Added, #1: 1	تَرْكُ اللُّقْمَةِ
u'تَرَكَ لُؤْلُؤَةٌ':Predicate, #1: 1	تَرْكِ لُمْعَةٍ
u'تَرَكَ لَيْلٌ':Predicate, #1: 1	تَرَكَ اللُّؤْلُؤَةَ
u'تَرْكٌ لَيْلٌ':Added, #1: 1	تَرَكَ لَيْلَةً
u'تَرْكٌ مَاءٌ':Added, #1: 1	تَرْكُ لَيْلَةٍ
u'تَرْكٌ مَاءٌ':Added, #1: 1	تَرْكَ الْمَاءِ
u'تَرْكٌ مَارٌّ':Added, #1: 1	تَرْكُ الْمَاءِ
u'تَرَكَ مَالٌ':Predicate, #1: 1	تَرْكُ مَارٍّ
u'تَرَكَ مَالٌ':Predicate, #18: 18	تَرَكَ مَالاً
u'تَرَكَ مَالٌ':Predicate, #1: 1	تَرَكَ الْمَالَ
u'تَرْكٌ مَالٌ':Added, #1: 1	تَرَكَ مَالاَ
u'تَرَكَ مَالِكٌ':Subject, #1: 1	تَرْكَ الْمَالِ
u'تَرَكَ مَالِكٌ':Subject, #1: 1	تَرَكَ الْمَالِكُ
u'تَرَكَ مَالِكٌ':Subject, #1: 1	تَرَكَ مَالِكُ
u'تَرْكٌ مَالِكٌ':Added, #2: 2	تَرَكَ مَالِكٌ
u'تَرْكٌ مَأْلُوفٌ':Added, #1: 1	تَرْكُ مَالِكٍ
u'تَرَكَ مَأْمُورٌ':Predicate, #1: 1	تَرْكَ مَأْلُوفِهِ
u'تَرْكٌ مَأْمُورٌ':Added, #1: 1	تَرَكَ الْمَأْمُورَ
u'تَرْكٌ مَأْمُورٌ':Added, #11: 11	تَرْكِ مَأْمُورٍ
u'تَرْكٌ مَأْمُورٌ':Added, #2: 2	تَرْكِ الْمَأْمُورَاتِ
u'تَرْكٌ مَأْمُورٌ':Added, #2: 2	تَرْكُ مَأْمُورٍ
u'تَرْكٌ مَأْمُورٌ':Added, #4: 4	تَرْكِ الْمَأْمُورِ
u'تَرَكَ مُبَاحٌ':Predicate, #5: 5	تَرْكُ الْمَأْمُورِ
u'تَرْكٌ مُبَاحٌ':Added, #1: 1	تَرَكَ الْمُبَاحَ
u'تَرْكٌ مُبَاحٌ':Added, #1: 1	تَرْكُ مُبَاحٍ
u'تَرْكٌ مُبَاحٌ':Added, #2: 2	تَرْكِ مُبَاحٍ
u'تَرْكٌ مُبَاهَاةٌ':Added, #5: 5	تَرْكِ الْمُبَاحِ
u'تَرَكَ مُبْتاع':Subject, #1: 1	تَرْكُ الْمُبَاهَاةِ
u'تَرَكَ مُبْتَدِعٌ':Subject, #1: 1	تَرَكَ الْمُبْتَاعُ
u'تَرَكَ مَبِيتٌ':Predicate, #1: 1	تَرَكَ الْمُبْتَدِعُ
u'تَرْكٌ مَبِيتٌ':Added, #6: 6	تَرَكَ الْمَبِيتَ
u'تَرْكٌ مَبِيتٌ':Added, #10: 10	تَرْكِ الْمَبِيتِ
u'تَرْكٌ مَبِيتٌ':Added, #1: 1	تَرْكَ مَبِيتِ
u'تَرْكٌ مَبِيتٌ':Added, #2: 2	تَرْكِ مَبِيتِ
u'تَرْكٌ مَبِيعٌ':Added, #5: 5	تَرْكُ الْمَبِيتِ
u'تَرَكَ مُتَابَعٌ':Predicate, #2: 2	تَرْكُ الْمَبِيعِ
u'تَرَكَ مُتَابَعٌ':Predicate, #2: 2	تَرَكَ مُتَابَعَةَ
u'تَرْكٌ مُتَابَعٌ':Added, #4: 4	تَرَكَ الْمُتَابَعَةَ
u'تَرْكٌ مُتَابَعٌ':Added, #1: 1	تَرْكَ الْمُتَابَعَةِ
u'تَرْكٌ مُتَابَعٌ':Added, #1: 1	تَرْكُ الْمُتَابَعَةِ
u'تَرَكَ مُتَابَعَةٌ':Predicate, #1: 1	تَرْكِ الْمُتَابَعَةِ
u'تَرَكَ مُتَابَعَةٌ':Predicate, #2: 2	تَرَكَ مُتَابَعَةَ
u'تَرْكٌ مُتَابَعَةٌ':Added, #4: 4	تَرَكَ الْمُتَابَعَةَ
u'تَرْكٌ مُتَابَعَةٌ':Added, #1: 1	تَرْكَ الْمُتَابَعَةِ
u'تَرْكٌ مُتَابَعَةٌ':Added, #1: 1	تَرْكُ الْمُتَابَعَةِ
u'تَرَكَ مَتَاعٌ':Predicate, #1: 1	تَرْكِ الْمُتَابَعَةِ
u'تَرْكٌ مُتَشَابِهٌ':Added, #1: 1	تَرَكَ الْمَتَاعَ
u'تَرَكَ مثل':Predicate, #3: 3	تَرْكَ الْمُتَشَابِهِ
u'تَرَكَ مِثْلٌ':Predicate, #2: 2	تَرَكَ مِثْلَكَ
u'تَرْكٌ مثل':Added, #2: 2	تَرَكَ مِثْلَكَ
u'تَرْكٌ مِثْلٌ':Added, #3: 3	تَرْكِ مِثْلِهِ
u'تَرْكٌ مُجَازَاةٌ':Added, #3: 3	تَرْكِ مِثْلِهِ
u'تَرْكٌ مُجَالَسَةٌ':Added, #1: 1	تَرْكَ مُجَازَاةِ
u'تَرَكَ مُجَامَعَةٌ':Predicate, #1: 1	تَرْكِ مُجَالَسَةِ
u'تَرْكٌ مُجَاهَرَةٌ':Added, #1: 1	تَرَكَ الْمُجَامَعَةَ
u'تَرْكٌ مَجْمُوعٌ':Added, #1: 1	تَرْكِ الْمُجَاهَرَةِ
u'تَرْكٌ مَجِيءٌ':Added, #1: 1	تَرْكُ الْمَجْمُوعِ
u'تَرْكٌ مُحَاجَّةٌ':Added, #1: 1	تَرْكِ الْمَجِيءِ
u'تَرْكٌ مُحَرَّمٌ':Added, #1: 1	تَرْكِ الْمُحَاجَّةِ
u'تَرْكٌ مُحَرَّمٌ':Added, #1: 1	تَرْكُ الْمُحَرَّمِ
u'تَرْكٌ مُحَرَّمٌ':Added, #1: 1	تَرْكُ الْمُحَرَّمَاتِ
u'تَرْكٌ مُحَرَّمٌ':Added, #1: 1	تَرْكُ مُحَرَّمٍ
u'تَرْكٌ مُحَرَّمٌ':Added, #1: 1	تَرْكِ مُحَرَّمَاتٍ
u'تَرَكَ مُخَاصَمَةٌ':Predicate, #2: 2	تَرْكِ الْمُحَرَّمِ
u'تَرْكٌ مُخَالَطَةٌ':Added, #2: 2	تَرَكَ الْمُخَاصَمَةَ
u'تَرَكَ مُخَالَفَةٌ':Predicate, #1: 1	تَرْكِ مُخَالَطَةِ
u'تَرْكٌ مَدٌّ':Added, #1: 1	تَرَكَ الْمُخَالَفَةَ
u'تَرْكٌ مُدَاوَاةٌ':Added, #1: 1	تَرْكُ الْمَدِّ
u'تَرْكٌ مُدَاوَاةٌ':Added, #1: 1	تَرْكُ الْمُدَاوَاةِ
u'تَرَكَ مَذْبُوحٌ':Predicate, #1: 1	تَرْكِ مُدَاوَاةٍ
u'تَرَكَ مرٌّ':Predicate, #1: 1	تَرَكَ الْمَذْبُوحَ
u'تَرْكٌ مرٌّ':Added, #1: 1	تَرَكَ مَرَّةً
u'تَرَكَ مِرَاءٌ':Predicate, #1: 1	تَرْكِ مَرَّةٍ
u'تَرْكٌ مِرَاءٌ':Added, #10: 10	تَرَكَ الْمِرَاءَ
u'تَرْكٌ مِرَاءٌ':Added, #1: 1	تَرْكَ الْمِرَاءِ
u'تَرْكٌ مُرَاجَعَةٌ':Added, #1: 1	تَرْكُ الْمِرَاءِ
u'تَرْكٌ مَرَّةٌ':Added, #1: 1	تَرْكِ مُرَاجَعَةِ
u'تَرَكَ مُرْتَهِنٌ':Subject, #1: 1	تَرْكِ مَرَّةٍ
u'تَرْكٌ مَرْحَمَةٌ':Added, #1: 1	تَرَكَ الْمُرْتَهِنُ
u'تَرْكٌ مَرْحَمَةٌ':Added, #1: 1	تَرْكَ الْمَرْحَمَةِ
u'تَرَكَ مُرُوءةٌ':Predicate, #4: 4	تَرْكُ الْمَرْحَمَةِ
u'تَرْكٌ مُرُوءةٌ':Added, #1: 1	تَرَكَ الْمُرُوءَةَ
u'تَرْكٌ مُرُوءةٌ':Added, #1: 1	تَرْكَ الْمُرُوءَةِ
u'تَرْكٌ مُرُوءةٌ':Added, #1: 1	تَرْكُ مُرُوءَةٍ
u'تَرْكٌ مُسَافِرٌ':Added, #7: 7	تَرْكِ الْمُرُوءَةِ
u'تَرْكٌ مُسَاكَنَةٌ':Added, #2: 2	تَرْكَ الْمُسَافِرِ
u'تَرَكَ مَسْأَلَةٌ':Predicate, #1: 1	تَرْكَ الْمُسَاكَنَةِ
u'تَرَكَ مُسْتَأْجِرٌ':Subject, #2: 2	تَرَكَ مَسْأَلَةَ
u'تَرْكٌ مُسْتَحَبٌّ':Added, #1: 1	تَرَكَ الْمُسْتَأْجِرُ
u'تَرْكٌ مُسْتَحَبٌّ':Added, #1: 1	تَرْكَ الْمُسْتَحَبِّ
u'تَرْكٌ مُسْتَحَبٌّ':Added, #2: 2	تَرْكُ الْمُسْتَحَبِّ
u'تَرْكٌ مُسْتَحَبٌّ':Added, #2: 2	تَرْكِ مُسْتَحَبٍّ
u'تَرَكَ مُسْتَحِقٌّ':Subject, #5: 5	تَرْكِ الْمُسْتَحَبِّ
u'تَرَكَ مَسْحٌ':Predicate, #1: 1	تَرَكَ الْمُسْتَحِقُّ
u'تَرَكَ مَسْحٌ':Predicate, #1: 1	تَرَكَ مَسْحَ
u'تَرْكٌ مَسْحٌ':Added, #9: 9	تَرَكَ الْمَسْحَ
u'تَرْكٌ مَسْحٌ':Added, #1: 1	تَرْكُ الْمَسْحِ
u'تَرْكٌ مَسْحٌ':Added, #1: 1	تَرْكِ الْمَسْحِ
u'تَرَكَ مُسْلِمٌ':Subject, #1: 1	تَرْكِ مَسْحِ
u'تَرْكٌ مُسْلِمٌ':Added, #1: 1	تَرَكَ الْمُسْلِمُ
u'تَرَكَ مَسْنُونٌ':Predicate, #1: 1	تَرْكِ مُسْلِمٍ
u'تَرْكٌ مَسْنُونٌ':Added, #1: 1	تَرَكَ الْمَسْنُونَ
u'تَرْكٌ مَسْنُونٌ':Added, #1: 1	تَرْكِ الْمَسْنُونِ
u'تَرَكَ مُسِيءٌ':Predicate, #1: 1	تَرْكِ الْمَسْنُونَاتِ
u'تَرَكَ مُشَبَّهٌ':Predicate, #1: 1	تَرَكَ الْمُسِيءَ
u'تَرْكٌ مَشْرُوطٌ':Added, #1: 1	تَرَكَ الْمُشَبَّهَ
u'تَرَكَ مَشْرُوعٌ':Predicate, #1: 1	تَرْكِ الْمَشْرُوطِ
u'تَرَكَ مَشُورَةٌ':Predicate, #1: 1	تَرَكَ الْمَشْرُوعَ
u'تَرَكَ مَشْيٌ':Predicate, #1: 1	تَرَكَ الْمَشُورَةَ
u'تَرْكٌ مَشْيٌ':Added, #1: 1	تَرَكَ الْمَشْيَ
u'تَرْكٌ مَشْيٌ':Added, #1: 1	تَرْكَ الْمَشْيِ
u'تَرْكٌ مَصْلَحَةٌ':Added, #2: 2	تَرْكُ الْمَشْيِ
u'تَرَكَ مُصَنِّفٌ':Subject, #1: 1	تَرْكُ الْمَصْلَحَةِ
u'تَرْكٌ مُصَنِّفٌ':Added, #10: 10	تَرَكَ الْمُصَنِّفُ
u'تَرْكٌ مُصَنِّفٌ':Added, #1: 1	تَرْكُ الْمُصَنِّفِ
u'تَرْكٌ مُضَاجَعَةٌ':Added, #1: 1	تَرْكِ الْمُصَنِّفِ
u'تَرَكَ مُضَارِبٌ':Subject, #2: 2	تَرْكُ الْمُضَاجَعَةِ
u'تَرْكٌ مُضَايَقَةٌ':Added, #1: 1	تَرَكَ الْمُضَارِبُ
u'تَرَكَ مَضْمَضَةٌ':Predicate, #2: 2	تَرْكِ الْمُضَايَقَةِ
u'تَرْكٌ مَضْمَضَةٌ':Added, #3: 3	تَرَكَ الْمَضْمَضَةَ
u'تَرْكٌ مَضْمَضَةٌ':Added, #1: 1	تَرْكُ الْمَضْمَضَةِ
u'تَرَكَ مُطَالَبٌ':Predicate, #2: 2	تَرْكَ الْمَضْمَضَةِ
u'تَرَكَ مُطَالَبَةٌ':Predicate, #1: 1	تَرَكَ الْمُطَالَبَةَ
u'تَرْكٌ مُعَارَضَةٌ':Added, #1: 1	تَرَكَ الْمُطَالَبَةَ
u'تَرَكَ مُعَامَلَةٌ':Predicate, #1: 1	تَرْكِ الْمُعَارَضَةِ
u'تَرَكَ مُعْتَقٌ':Subject, #1: 1	تَرَكَ الْمُعَامَلَةَ
u'تَرْكٌ مَعْصِيَةٌ':Added, #2: 2	تَرَكَ الْمُعْتَقُ
u'تَرْكٌ مَعْصِيَةٌ':Added, #1: 1	تَرْكَ الْمَعْصِيَةِ
u'تَرْكٌ مَعْصِيَةٌ':Added, #1: 1	تَرْكَ مَعْصِيَةٍ
u'تَرْكٌ مَعْصِيَةٌ':Added, #1: 1	تَرْكُ مَعْصِيَةٍ
u'تَرْكٌ مَعْصِيَةٌ':Added, #2: 2	تَرْكُ الْمَعْصِيَةِ
u'تَرْكٌ مَعْصِيَةٌ':Added, #4: 4	تَرْكِ مَعْصِيَةٍ
u'تَرْكٌ مُعَلَّقٌ':Added, #5: 5	تَرْكِ الْمَعْصِيَةِ
u'تَرَكَ مُعَلِّمٌ':Subject, #1: 1	تَرْكِ الْمُعَلَّقِ
u'تَرْكٌ مَغْصُوب':Added, #1: 1	تَرَكَ الْمُعَلِّمُ
u'تَرْكٌ مَفْرُوضٌ':Added, #1: 1	تَرْكُ الْمَغْصُوبِ
u'تَرْكٌ مَفْرُوضٌ':Added, #1: 1	تَرْكَ الْمَفْرُوضِ
u'تَرْكٌ مَفْهُومٌ':Added, #2: 2	تَرْكِ مَفْرُوضٍ
u'تَرْكٌ مَفْهُومٌ':Added, #1: 1	تَرْكَ الْمَفْهُومِ
u'تَرْكٌ مَفْهُومٌ':Added, #1: 1	تَرْكُ الْمَفْهُومِ
u'تَرْكٌ مُقاسَمَة':Added, #1: 1	تَرْكِ مَفْهُومٍ
u'تَرْكٌ مَقَامٌ':Added, #1: 1	تَرْكَ الْمُقَاسَمَةِ
u'تَرْكٌ مَقَامٌ':Added, #1: 1	تَرْكَ الْمَقَامِ
u'تَرْكٌ مَقَامٌ':Added, #1: 1	تَرْكَ مَقَامِ
u'تَرْكٌ مُقَامٌ':Added, #2: 2	تَرْكِ الْمَقَامِ
u'تَرْكٌ مَقَامٌ':Added, #2: 2	تَرْكِ الْمُقَامِ
u'تَرَكَ مَقْتُولٌ':Subject, #2: 2	تَرْكِ مَقَامِ
u'تَرَكَ مِقْدَارٌ':Predicate, #5: 5	تَرَكَ الْمَقْتُولُ
u'تَرَكَ مَقْذُوفٌ':Subject, #1: 1	تَرَكَ مِقْدَارَ
u'تَرَكَ مَقْطُوعٌ':Predicate, #1: 1	تَرَكَ الْمَقْذُوفُ
u'تَرْكٌ مُكَاتَبَةٌ':Added, #1: 1	تَرَكَ الْمَقْطُوعَ
u'تَرْكٌ مُكَافَأَةٌ':Added, #1: 1	تَرْكِ الْمُكَاتَبَةِ
u'تَرَكَ مَكَانٌ':Predicate, #3: 3	تَرْكُ الْمُكَافَأَةِ
u'تَرَكَ مَكَانٌ':Predicate, #2: 2	تَرَكَ الْمَكَانَ
u'تَرْكٌ مَكَانٌ':Added, #3: 3	تَرَكَ مَكَانَ
u'تَرْكٌ مَكَانٌ':Added, #1: 1	تَرْكِ الْمَكَانِ
u'تَرَكَ مُكْرَهٌ':Subject, #1: 1	تَرْكَ مَكَانَيْنِ
u'تَرْكٌ مَكْرُوهٌ':Added, #1: 1	تَرَكَ الْمُكْرَهُ
u'تَرْكٌ مَكْرُوهٌ':Added, #1: 1	تَرْكِ الْمَكْرُوهِ
u'تَرَكَ مُكَلَّفٌ':Subject, #2: 2	تَرْكَ الْمَكْرُوهِ
u'تَرَكَ مَكِّيّ':Subject, #2: 2	تَرَكَ الْمُكَلَّفُ
u'تَرْكٌ مِكْيَالٌ':Added, #2: 2	تَرَكَ الْمَكِّيُّ
u'تَرَكَ مُلاَزَمَةٌ':Predicate, #1: 1	تَرْكُ الْمِكْيَالِ
u'تَرْكٌ مِلْكٌ':Added, #2: 2	تَرَكَ الْمُلَازَمَةَ
u'تَرَكَ مُنَازَعٌ':Predicate, #1: 1	تَرْكَ مِلْكِهِ
u'تَرْكٌ مُنَازَعٌ':Added, #1: 1	تَرَكَ الْمُنَازَعَةَ
u'تَرْكٌ مُنَازَعٌ':Added, #1: 1	تَرْكَ الْمُنَازَعَةِ
u'تَرْكٌ مُنَازَعٌ':Added, #1: 1	تَرْكُ الْمُنَازَعَةِ
u'تَرَكَ مُنَازَعَةٌ':Predicate, #1: 1	تَرْكِ الْمُنَازَعَةِ
u'تَرْكٌ مُنَازَعَةٌ':Added, #1: 1	تَرَكَ الْمُنَازَعَةَ
u'تَرْكٌ مُنَازَعَةٌ':Added, #1: 1	تَرْكَ الْمُنَازَعَةِ
u'تَرْكٌ مُنَازَعَةٌ':Added, #1: 1	تَرْكُ الْمُنَازَعَةِ
u'تَرَكَ مَنْدُوبٌ':Predicate, #1: 1	تَرْكِ الْمُنَازَعَةِ
u'تَرْكٌ مَنْدُوبٌ':Added, #1: 1	تَرَكَ الْمَنْدُوبَ
u'تَرْكٌ مَنْدُوبٌ':Added, #1: 1	تَرْكَ الْمَنْدُوبِ
u'تَرْكٌ مَنْدُوبٌ':Added, #1: 1	تَرْكُ الْمَنْدُوبِ
u'تَرْكٌ مَنْدُوبٌ':Added, #1: 1	تَرْكِ الْمَنْدُوبِ
u'تَرْكٌ مَنْدُوبٌ':Added, #1: 1	تَرْكَ مَنْدُوبٍ
u'تَرَكَ مَنْسُوخٌ':Predicate, #3: 3	تَرْكِ مَنْدُوبٍ
u'تَرْكٌ مَنْعٌ':Added, #1: 1	تَرَكَ الْمَنْسُوخَ
u'تَرْكٌ مَنْعٌ':Added, #1: 1	تَرْكِ مَنْعِ
u'تَرْكٌ مُنْكَرٌ':Added, #4: 4	تَرْكُ الْمَنْعِ
u'تَرْكٌ مُنْكَرٌ':Added, #1: 1	تَرْكِ الْمُنْكَرِ
u'تَرْكٌ مَنْهِيٌّ':Added, #2: 2	تَرْكُ الْمُنْكَرِ
u'تَرْكٌ مَنْهِيٌّ':Added, #1: 1	تَرْكَ الْمَنْهِيِّ
u'تَرْكٌ مَنْهِيٌّ':Added, #1: 1	تَرْكُ الْمَنْهِيِّ
u'تَرْكٌ مُوَاظَبَةٌ':Added, #3: 3	تَرْكِ الْمَنْهِيِّ
u'تَرَكَ مُوالاة':Predicate, #1: 1	تَرْكِ الْمُوَاظَبَةِ
u'تَرْكٌ مُوالاة':Added, #1: 1	تَرَكَ الْمُوَالَاةَ
u'تَرْكٌ مُوجِبٌ':Added, #2: 2	تَرْكِ الْمُوَالَاةِ
u'تَرَكَ مَوْضِعٌ':Predicate, #1: 1	تَرْكُ مُوجِبِ
u'تَرْكٌ مُؤَكَّدٌ':Added, #6: 6	تَرَكَ مَوْضِعَ
u'تَرَكَ مُؤَلِّفٌ':Subject, #1: 1	تَرْكَ الْمُؤَكَّدَةِ
u'تَرْكٌ مَوْهُوبٌ':Added, #2: 2	تَرَكَ الْمُؤَلِّفُ
u'تَرْكٌ مَوْهُوبٌ':Added, #1: 1	تَرْكَ الْمَوْهُوبِ
u'تَرَكَ مِيقَاتٌ':Predicate, #1: 1	تَرْكُ الْمَوْهُوبِ
u'تَرَكَ مِيقَاتٌ':Predicate, #1: 1	تَرَكَ الْمِيقَاتَ
u'تَرَكَ نَاسٌ':Subject, #1: 1	تَرَكَ مِيقَاتَ
u'تَرْكٌ نَاسٌ':Added, #22: 22	تَرَكَ النَّاسُ
u'تَرْكٌ نَاسٌ':Added, #1: 1	تَرْكُ النَّاسِ
u'تَرَكَ نَبِيٌّ':Subject, #1: 1	تَرْكِ النَّاسِ
u'تَرْكٌ نَبِيٌّ':Added, #4: 4	تَرَكَ النَّبِيُّ
u'تَرْكٌ نَبِيٌّ':Added, #1: 1	تَرْكُ النَّبِيِّ
u'تَرْكٌ نَحْوٌ':Added, #1: 1	تَرْكِ النَّبِيِّ
u'تَرْكٌ نُخَامَةٌ':Added, #4: 4	تَرْكِ نَحْوِ
u'تَرَكَ نَزْعٌ':Predicate, #1: 1	تَرْكِ النُّخَامَةِ
u'تَرْكٌ نَزْعٌ':Added, #1: 1	تَرَكَ النَّزْعَ
u'تَرَكَ نُزُولٌ':Predicate, #1: 1	تَرْكِ النَّزْعِ
u'تَرْكٌ نُزُولٌ':Added, #1: 1	تَرَكَ النُّزُولَ
u'تَرْكٌ نَسَبٌ':Added, #4: 4	تَرْكِ النُّزُولِ
u'تَرْكٌ نَصٌّ':Added, #1: 1	تَرْكِ النَّسَبِ
u'تَرْكٌ نِصْفٌ':Added, #1: 1	تَرْكُ النَّصِّ
u'تَرَكَ نَصِيبٌ':Predicate, #1: 1	تَرْكُ النِّصْفِ
u'تَرْكٌ نَصِيحٌ':Added, #1: 1	تَرَكَ نَصِيبَ
u'تَرْكٌ نَصِيحَةٌ':Added, #1: 1	تَرْكُ النَّصِيحَةِ
u'تَرَكَ نَظَرٌ':Predicate, #1: 1	تَرْكُ النَّصِيحَةِ
u'تَرْكٌ نَظَرٌ':Added, #6: 6	تَرَكَ النَّظَرَ
u'تَرْكٌ نَظَرٌ':Added, #10: 10	تَرْكِ النَّظَرِ
u'تَرْكٌ نَظَرٌ':Added, #11: 11	تَرْكُ النَّظَرِ
u'تَرْكٌ نَعْلٌ':Added, #2: 2	تَرْكَ النَّظَرِ
u'تَرْكٌ نَفْسٌ':Added, #1: 1	تَرْكِ النَّعْلِ
u'تَرَكَ نَفَقَةٌ':Predicate, #2: 2	تَرْكَ النَّفْسِ
u'تَرْكٌ نَفَقَةٌ':Added, #1: 1	تَرَكَ النَّفَقَةَ
u'تَرَكَ نَفَلٌ':Predicate, #2: 2	تَرْكُ النَّفَقَةِ
u'تَرْكٌ نَفْلٌ':Added, #2: 2	تَرَكَ النَّفَلَ
u'تَرْكٌ نَفْلٌ':Added, #1: 1	تَرْكُ نَفْلِ
u'تَرْكٌ نَفْيٌ':Added, #1: 1	تَرْكِ نَفْلٍ
u'تَرْكٌ نَفِيرٌ':Added, #1: 1	تَرْكَ نَفْيِهِ
u'تَرَكَ نَقْدٌ':Predicate, #1: 1	تَرْكِ النَّفِيرِ
u'تَرَكَ نَقْد':Predicate, #2: 2	تَرَكَ النَّقْدَ
u'تَرَكَ نَقْضٌ':Predicate, #2: 2	تَرَكَ النَّقْدَ
u'تَرْكٌ نَقْضٌ':Added, #2: 2	تَرَكَ النَّقْضَ
u'تَرَكَ نقل':Predicate, #1: 1	تَرْكِ النَّقْضِ
u'تَرَكَ نَقْلٌ':Predicate, #1: 1	تَرَكَ النَّقْلَ
u'تَرْكٌ نقل':Added, #1: 1	تَرَكَ النَّقْلَ
u'تَرْكٌ نقل':Added, #1: 1	تَرْكُ نَقْلِ
u'تَرْكٌ نَقْلٌ':Added, #1: 1	تَرْكِ نَقْلِ
u'تَرْكٌ نَقْلٌ':Added, #1: 1	تَرْكُ نَقْلِ
u'تَرَكَ نكاح':Predicate, #1: 1	تَرْكِ نَقْلِ
u'تَرَكَ نِكَاحٌ':Predicate, #2: 2	تَرَكَ نِكَاحَ
u'تَرْكٌ نكاح':Added, #2: 2	تَرَكَ نِكَاحَ
u'تَرْكٌ نِكَاحٌ':Added, #1: 1	تَرْكِ النِّكَاحِ
u'تَرْكٌ نكاح':Added, #1: 1	تَرْكِ النِّكَاحِ
u'تَرْكٌ نِكَاحٌ':Added, #2: 2	تَرْكُ النِّكَاحِ
u'تَرْكٌ نكاح':Added, #2: 2	تَرْكُ النِّكَاحِ
u'تَرْكٌ نِكَاحٌ':Added, #2: 2	تَرْكَ نِكَاحِ
u'تَرْكٌ نَكِيرٌ':Added, #2: 2	تَرْكَ نِكَاحِ
u'تَرْكٌ نِهَايَةٌ':Added, #1: 1	تَرْكُ النَّكِيرِ
u'تَرْكٌ نُهُوضٌ':Added, #1: 1	تَرْكِ نِهَايَةِ
u'تَرْكٌ نَهْيٌ':Added, #1: 1	تَرْكِ النُّهُوضِ
u'تَرْكٌ نَهْيٌ':Added, #2: 2	تَرْكِ النَّهْيِ
u'تَرَكَ نَوَافِلُ':Predicate, #3: 3	تَرْكَ النَّهْيِ
u'تَرْكٌ نَوَافِلُ':Added, #1: 1	تَرَكَ النَّوَافِلَ
u'تَرْكٌ نَوَافِلُ':Added, #1: 1	تَرْكِ النَّوَافِلِ
u'تَرْكٌ نُورٌ':Added, #3: 3	تَرْكُ النَّوَافِلِ
u'تَرْكٌ نَوَرٌ':Added, #1: 1	تَرْكِ النّورِ
u'تَرْكٌ نَوْرٌ':Added, #1: 1	تَرْكِ النّورِ
u'تَرَكَ نِيَّةٌ':Predicate, #1: 1	تَرْكِ النّورِ
u'تَرَكَ نِيَّةٌ':Predicate, #1: 1	تَرَكَ نِيَّةَ
u'تَرْكٌ نِيَّةٌ':Added, #6: 6	تَرَكَ النِّيَّةَ
u'تَرْكٌ نِيَّةٌ':Added, #1: 1	تَرْكَ النِّيَّةِ
u'تَرْكٌ نِيَّةٌ':Added, #2: 2	تَرْكُ النِّيَّةِ
u'تَرْكٌ نِيَّةٌ':Added, #2: 2	تَرْكِ نِيَّةِ
u'تَرْكٌ هاء':Added, #9: 9	تَرْكِ النِّيَّةِ
u'تَرَكَ هجرة':Predicate, #1: 1	تَرْكَ الْهَاءِ
u'تَرَكَ هِجْرَةٌ':Predicate, #1: 1	تَرَكَ الْهِجْرَةَ
u'تَرْكٌ هجرة':Added, #1: 1	تَرَكَ الْهِجْرَةَ
u'تَرْكٌ هِجْرَةٌ':Added, #1: 1	تَرْكِ الْهِجْرَةِ
u'تَرْكٌ هُجُومٌ':Added, #1: 1	تَرْكِ الْهِجْرَةِ
u'تَرْكٌ هَدْمٌ':Added, #1: 1	تَرْكِ الْهُجُومِ
u'تَرَكَ هَرْوَل':Predicate, #1: 1	تَرْكِ الْهَدْمِ
u'تَرَكَ هَرْوَلَة':Predicate, #1: 1	تَرَكَ الْهَرْوَلَةَ
u'تَرَكَ وَاجِبٌ':Predicate, #1: 1	تَرَكَ الْهَرْوَلَةَ
u'تَرْكٌ وَاجِبٌ':Added, #8: 8	تَرَكَ الْوَاجِبَ
u'تَرْكٌ وَاجِبٌ':Added, #11: 11	تَرْكُ الْوَاجِبِ
u'تَرْكٌ وَاجِبٌ':Added, #16: 16	تَرْكِ الْوَاجِبِ
u'تَرْكٌ وَاجِبٌ':Added, #1: 1	تَرْكِ الْوَاجِبَاتِ
u'تَرْكٌ وَاجِبٌ':Added, #1: 1	تَرْكَ وَاجِبٍ
u'تَرْكٌ وَاجِبٌ':Added, #1: 1	تَرْكَ وَاجِبِ
u'تَرْكٌ وَاجِبٌ':Added, #1: 1	تَرْكُ وَاجِبِ
u'تَرْكٌ وَاجِبٌ':Added, #1: 1	تَرْكِ وَاجِبِ
u'تَرْكٌ وَاجِبٌ':Added, #24: 24	تَرْكِ وَاجِبٍ
u'تَرْكٌ وَاجِبٌ':Added, #6: 6	تَرْكَ الْوَاجِبِ
u'تَرَكَ واحد':Predicate, #8: 8	تَرْكُ وَاجِبٍ
u'تَرَكَ وَاحِدٌ':Predicate, #7: 7	تَرَكَ وَاحِدَةً
u'تَرْكٌ واحد':Added, #7: 7	تَرَكَ وَاحِدَةً
u'تَرْكٌ وَاحِدٌ':Added, #1: 1	تَرْكُ وَاحِدٍ
u'تَرْكٌ واحد':Added, #1: 1	تَرْكُ وَاحِدٍ
u'تَرْكٌ واحد':Added, #1: 1	تَرْكُ وَاحِدَةٍ
u'تَرْكٌ وَاحِدٌ':Added, #1: 1	تَرْكِ وَاحِدَةٍ
u'تَرْكٌ وَاحِدٌ':Added, #1: 1	تَرْكُ وَاحِدَةٍ
u'تَرْكٌ واحد':Added, #1: 1	تَرْكِ وَاحِدَةٍ
u'تَرْكٌ وَاحِدٌ':Added, #2: 2	تَرْكِ وَاحِدٍ
u'تَرَكَ وَارِثٌ':Subject, #2: 2	تَرْكِ وَاحِدٍ
u'تَرَكَ وَاضِحٌ':Predicate, #1: 1	تَرَكَ الْوَارِثُ
u'تَرَكَ وَتَدٌ':Predicate, #1: 1	تَرَكَ الْوَاضِحَ
u'تَرَكَ وَتْرٌ':Predicate, #1: 1	تَرَكَ الْوَتَدَ
u'تَرَكَ وَجَبٌ':Predicate, #2: 2	تَرَكَ الْوَتْرَ
u'تَرَكَ وَجْهٌ':Predicate, #1: 1	تَرَكَ وَجَبَ
u'تَرْكٌ وُجُوبٌ':Added, #1: 1	تَرَكَ الْوَجْهَ
u'تَرْكٌ وُجُوبٌ':Added, #1: 1	تَرْكِ الْوُجُوبِ
u'تَرَكَ وَدِيعٌ':Predicate, #1: 1	تَرْكُ وُجُوبِ
u'تَرَكَ وَدِيعَةٌ':Predicate, #2: 2	تَرَكَ الْوَدِيعَةَ
u'تَرْكٌ وَرَثَةٌ':Added, #2: 2	تَرَكَ الْوَدِيعَةَ
u'تَرْكٌ وَزْنٌ':Added, #1: 1	تَرْكَ الْوَرَثَةِ
u'تَرْكٌ وصال':Added, #1: 1	تَرْكِ الْوَزْنِ
u'تَرْكٌ وِصَالٌ':Added, #1: 1	تَرْكُ الْوِصَالِ
u'تَرَكَ وَصْفٌ':Predicate, #1: 1	تَرْكُ الْوِصَالِ
u'تَرْكٌ وَصْفٌ':Added, #1: 1	تَرَكَ الْوَصْفَ
u'تَرْكٌ وَصْفٌ':Added, #1: 1	تَرْكِ الْوَصْفِ
u'تَرْكٌ وَصْفٌ':Added, #1: 1	تَرْكِ وَصْفِ
u'تَرَكَ وصل':Predicate, #1: 1	تَرْكُ وَصْفِهِ
u'تَرَكَ وَصْلٌ':Predicate, #1: 1	تَرَكَ الْوَصْلَ
u'تَرَكَ وَصِيٌّ':Predicate, #1: 1	تَرَكَ الْوَصْلَ
u'تَرَكَ وَصِيٌّ':Predicate, #1: 1	تَرَكَ الْوَصِيَّةَ
u'تَرْكٌ وَصِيٌّ':Added, #2: 2	تَرَكَ وَصِيَّةً
u'تَرْكٌ وَصِيٌّ':Added, #1: 1	تَرْكَ الْوَصِيِّ
u'تَرْكٌ وَصِيٌّ':Added, #1: 1	تَرْكُ الْوَصِيَّةِ
u'تَرَكَ وَصِيَّةٌ':Predicate, #3: 3	تَرْكَ الْوَصِيَّةِ
u'تَرْكٌ وَصِيَّةٌ':Added, #1: 1	تَرَكَ الْوَصِيَّةَ
u'تَرْكٌ وَصِيَّةٌ':Added, #1: 1	تَرْكُ الْوَصِيَّةِ
u'تَرَكَ وَضْعٌ':Predicate, #3: 3	تَرْكَ الْوَصِيَّةِ
u'تَرَكَ وَضْعٌ':Predicate, #1: 1	تَرَكَ الْوَضْعَ
u'تَرْكٌ وَضْعٌ':Added, #2: 2	تَرَكَ وَضْعَ
u'تَرْكٌ وَضْعٌ':Added, #1: 1	تَرْكَ وَضْعِ
u'تَرْكٌ وَضْعٌ':Added, #1: 1	تَرْكِ وَضْعِ
u'تَرَكَ وُضُوءٌ':Predicate, #3: 3	تَرْكَ الْوَضْعِ
u'تَرْكٌ وُضُوءٌ':Added, #3: 3	تَرَكَ الْوُضُوءَ
u'تَرْكٌ وُضُوءٌ':Added, #16: 16	تَرْكِ الْوُضُوءِ
u'تَرْكٌ وُضُوءٌ':Added, #2: 2	تَرْكَ الْوُضُوءِ
u'تَرَكَ وَطْءٌ':Predicate, #5: 5	تَرْكُ الْوُضُوءِ
u'تَرَكَ وَطْءٌ':Predicate, #2: 2	تَرَكَ وَطْءَ
u'تَرْكٌ وَطْءٌ':Added, #5: 5	تَرَكَ الْوَطْءَ
u'تَرْكٌ وَطْءٌ':Added, #1: 1	تَرْكُ الْوَطْءِ
u'تَرْكٌ وَطْءٌ':Added, #24: 24	تَرْكِ الْوَطْءِ
u'تَرْكٌ وَطْءٌ':Added, #2: 2	تَرْكَ الْوَطْءِ
u'تَرْكٌ وَطْءٌ':Added, #2: 2	تَرْكِ وَطْءٍ
u'تَرَكَ وَفَاءٌ':Predicate, #9: 9	تَرْكِ وَطْءِ
u'تَرْكٌ وَفَاءٌ':Added, #1: 1	تَرَكَ الْوَفَاءَ
u'تَرْكٌ وَفَاءٌ':Added, #1: 1	تَرْكِ الْوَفَاءِ
u'تَرْكٌ وَقْتٌ':Added, #2: 2	تَرْكُ الْوَفَاءِ
u'تَرَكَ وُقُوفٌ':Predicate, #2: 2	تَرْكِ الْوَقْتِ
u'تَرْكٌ وُقُوفٌ':Added, #7: 7	تَرَكَ الْوُقُوفَ
u'تَرَكَ وَكِيلٌ':Subject, #2: 2	تَرْكِ الْوُقُوفِ
u'تَرْكٌ وَلاَءٌ':Added, #2: 2	تَرَكَ الْوَكِيلُ
u'تَرَكَ ولد':Predicate, #1: 1	تَرْكَ الْوَلَاءِ
u'تَرَكَ وَلَدٌ':Predicate, #1: 1	تَرَكَ الْوَلَدَ
u'تَرَكَ ولد':Predicate, #1: 1	تَرَكَ الْوَلَدَ
u'تَرَكَ وَلَدٌ':Predicate, #1: 1	تَرَكَ وَلَدَ
u'تَرَكَ ولد':Subject, #1: 1	تَرَكَ وَلَدَ
u'تَرَكَ وَلَدٌ':Subject, #3: 3	تَرَكَ الْوَلَدُ
u'تَرْكٌ وَلَدٌ':Added, #3: 3	تَرَكَ الْوَلَدُ
u'تَرْكٌ ولد':Added, #1: 1	تَرْكَ وَلَدٍ
u'تَرْكٌ وَلَدٌ':Added, #1: 1	تَرْكِ وَلَدِهِ
u'تَرَكَ وَلِيٌّ':Subject, #1: 1	تَرْكِ وَلَدِهِ
u'تَرَكَ وَلِيٌّ':Subject, #2: 2	تَرَكَ وَلِيُّ
u'تَرْكٌ وَلِيٌّ':Added, #6: 6	تَرَكَ الْوَلِيُّ
u'تَرْكِيبٌ أَجْسَامٌ':Added, #1: 1	تَرْكَ الْوَلِيِّ
u'تَرْكِيبٌ إِسْنادٌ':Added, #2: 2	تَرْكِيبِ الْأَجْسَامِ
u'تَرْكِيبٌ أصل':Added, #1: 1	تَرْكِيبَ إسْنَادٍ
u'تَرْكِيبٌ أًصْلٌ':Added, #1: 1	تَرْكِيبَ الْأَصْلِ
u'تَرْكِيبٌ أصل':Added, #1: 1	تَرْكِيبَ الْأَصْلِ
u'تَرْكِيبٌ أًصْلٌ':Added, #4: 4	تَرْكِيبِ الْأَصْلِ
u'تَرْكِيبٌ أَفْعَالٌ':Added, #4: 4	تَرْكِيبِ الْأَصْلِ
u'تَرْكِيبٌ بدن':Added, #1: 1	تَرْكِيبِ أَفْعَالِ
u'تَرْكِيبٌ بَدَنٌ':Added, #1: 1	تَرْكِيبِ الْبَدَنِ
u'تَرْكِيبٌ بَعْضٌ':Added, #1: 1	تَرْكِيبِ الْبَدَنِ
u'تَرْكِيبٌ تَذْكِيَةٌ':Added, #1: 1	تَرْكِيبِ بَعْضِ
u'تَرْكِيبٌ جِسْمٌ':Added, #1: 1	تَرْكِيبِ التَّذْكِيَةِ
u'تَرْكِيبٌ جِسْمٌ':Added, #1: 1	تَرْكِيبَ الْجِسْمِ
u'تَرْكِيبٌ حَدٌّ':Added, #1: 1	تَرْكِيبَ جِسْمٍ
u'تَرْكِيبٌ حَدٌّ':Added, #1: 1	تَرْكِيبَ الْحَدِّ
u'تَرْكِيبٌ حُدودٌ':Added, #3: 3	تَرْكِيبِ الْحَدِّ
u'تَرْكِيبٌ حُروفٌ':Added, #1: 1	تَرْكِيبُ الْحُدُودِ
u'تَرْكِيبٌ حُكْمٌ':Added, #1: 1	تَرْكِيبَ الْحُرُوفِ
u'تَرْكِيبٌ دَليلٌ':Added, #1: 1	تَرْكِيبِ الْحُكْمِ
u'تَرْكِيبٌ شَهْوَةٌ':Added, #2: 2	تَرْكِيبُ الدَّلِيلِ
u'تَرْكِيبٌ شَيْءٌ':Added, #1: 1	تَرْكِيبُ الشَّهْوَةِ
u'تَرْكِيبٌ صِنْفٌ':Added, #1: 1	تَرْكِيبِ الشَّيْءِ
u'تَرْكِيبٌ عِلَّةٌ':Added, #1: 1	تَرْكِيبُ صِنْفَيْنِ
u'تَرْكِيبٌ فَرْعٌ':Added, #2: 2	تَرْكِيبِ الْعِلَّةِ
u'تَرْكِيبٌ فِعْلٌ':Added, #3: 3	تَرْكِيبِ الْفَرْعِ
u'تَرْكِيبٌ قرار':Added, #1: 1	تَرْكِيبِ الْفِعْلِ
u'تَرْكِيبٌ قَرَارٌ':Added, #1: 1	تَرْكِيبَ قَرَارٍ
u'تَرْكِيبٌ قِيَاسٌ':Added, #1: 1	تَرْكِيبَ قَرَارٍ
u'تَرْكِيبٌ كَلاَمٌ':Added, #1: 1	تَرْكِيبِ الْقِيَاسِ
u'تَرْكِيبٌ كَلاَمٌ':Added, #1: 1	تَرْكِيبَ الْكَلَامِ
u'تَرْكِيبٌ لَفْظٌ':Added, #1: 1	تَرْكِيبَ كَلَامِهِ
u'تَرْكِيبٌ لَفْظٌ':Added, #1: 1	تَرْكِيبِ اللَّفْظِ
u'تَرْكِيبٌ لَفْظٌ':Added, #1: 1	تَرْكِيبِ لَفْظٍ
u'تَرْكِيبٌ لَفْظٌ':Added, #1: 1	تَرْكِيبِ لَفْظِ
u'تَرْكِيبٌ مُتَكَلِّمٌ':Added, #2: 2	تَرْكِيبَ لَفْظِ
u'تَرْكِيبٌ مَدَاقٌّ':Added, #1: 1	تَرْكِيبُ مُتَكَلِّمٍ
u'تَرْكِيبٌ مَزْجٌ':Added, #3: 3	تَرْكِيبَ مَدَاقِّ
u'تَرْكِيبٌ مُصَنِّفٌ':Added, #1: 1	تَرْكِيبَ مَزْجٍ
u'تَرْكِيبٌ مُفْرَدٌ':Added, #1: 1	تَرْكِيبِ الْمُصَنِّفِ
u'تَرْكِيبٌ مُقَدَّمٌ':Added, #1: 1	تَرْكِيبِ الْمُفْرَدِ
u'تَرْكِيبٌ مَنْعٌ':Added, #1: 1	تَرْكِيبِ الْمُقَدَّمَاتِ
u'تَرْكِيبٌ واحد':Added, #1: 1	تَرْكِيبِ مَنْعِ
u'تَرْكِيبٌ وَاحِدٌ':Added, #1: 1	تَرْكِيبٍ وَاحِدٍ
u'تَرْكِيبٌ وَصْفٌ':Added, #1: 1	تَرْكِيبٍ وَاحِدٍ
u'تَرَكَ يَسِيرٌ':Predicate, #2: 2	تَرْكِيبِ الْوَصْفِ
u'تَرْكٌ يَسِيرٌ':Added, #1: 1	تَرَكَ الْيَسِيرَ
u'تَرْكٌ يَقِينٌ':Added, #1: 1	تَرْكَ الْيَسِيرِ
u'تَرْكٌ يَقِينٌ':Added, #1: 1	تَرْكَ الْيَقِينِ
u'تَرَكَ يَمِينٌ':Predicate, #1: 1	تَرْكَ يَقِينٍ
u'تَرْكٌ يَوْمٌ':Added, #1: 1	تَرَكَ الْيَمِينَ
u'تَرْمِيمٌ دَارٌ':Added, #1: 1	تَرْكُ الْيَوْمِ
u'تَرْمِيمٌ مَسْجِدٌ':Added, #1: 1	تَرْمِيمِ الدَّارِ
u'تَرَوُّحٌ إمَامٌ':Added, #1: 1	تَرْمِيمَ الْمَسْجِدِ
u'تَرَوَّحَ مَاءٌ':Subject, #1: 1	تَرَوُّحِ الإِمَامِ
u'تَرْوِيحٌ نَفْسٌ':Added, #1: 1	تَرَوَّحَ الْمَاءُ
u'تَزَاحَفَ نَاسٌ':Subject, #1: 1	تَرْوِيحُ النَّفْسِ
u'تَزَاحُمٌ آرَاءٌ':Added, #1: 1	تَزَاحَفَ النّاسُ
u'تَزَاحُمٌ أَوْلِيَاءُ':Added, #2: 2	تَزَاحُمِ الْآرَاءِ
u'تَزَاحُمٌ بَلْغَم':Added, #1: 1	تَزَاحُمِ الْأَوْلِيَاءِ
u'تَزَاحُمٌ جَمَاعَةٌ':Added, #1: 1	تَزَاحُمِ الْبَلْغَمِ
u'تَزَاحُمٌ خُصُومٌ':Added, #1: 1	تَزَاحُمِ جَمَاعَةٍ
u'تَزَاحُمٌ شفعاء':Added, #1: 1	تَزَاحُمِ الْخُصُومِ
u'تَزَايُدٌ آلاَمٌ':Added, #1: 1	تَزَاحُمِ الشُّفَعَاءِ
u'تَزَايُدٌ عُلُومٌ':Added, #1: 1	تَزَايُدُ الْآلَامِ
u'تَزَايُدٌ غير':Added, #1: 1	تَزَايُدِ عُلُومِهِ
u'تَزَايُدٌ غَيْرٌ':Added, #1: 1	تَزَايُدِ غَيْرِ
u'تَزَايُدٌ مُتَعَلِّقٌ':Added, #1: 1	تَزَايُدِ غَيْرِ
u'تَزْكِيَةٌ أَحْباسٌ':Added, #1: 1	تَزَايُدِ الْمُتَعَلِّقَاتِ
u'تَزْكِيَةٌ أًصْلٌ':Added, #1: 1	تَزْكِيَةِ الْأَحْبَاسِ
u'تَزْكِيَةٌ أصل':Added, #1: 1	تَزْكِيَةُ أَصْلٍ
u'تَزْكِيَةٌ أصل':Added, #1: 1	تَزْكِيَةُ الْأَصْلِ
u'تَزْكِيَةٌ أًصْلٌ':Added, #1: 1	تَزْكِيَةِ الْأَصْلِ
u'تَزْكِيَةٌ أًصْلٌ':Added, #1: 1	تَزْكِيَةُ الْأَصْلِ
u'تَزْكِيَةٌ الْمَرْءُ':Added, #1: 1	تَزْكِيَةِ الْأَصْلِ
u'تَزْكِيَةٌ الْمَرْأَةُ':Added, #1: 1	تَزْكِيَةُ الْمَرْءِ
u'تَزْكِيَةٌ الْمَرْأَةُ':Added, #1: 1	تَزْكِيَةُ الْمَرْأَةِ
u'تَزْكِيَةٌ بَيِّنَةٌ':Added, #2: 2	تَزْكِيَةِ الْمَرْأَةِ
u'تَزْكِيَةٌ بَيِّنَةٌ':Added, #1: 1	تَزْكِيَةِ الْبَيِّنَةِ
u'تَزْكِيَةٌ ثَوْبٌ':Added, #1: 1	تَزْكِيَةُ بَيِّنَةِ
u'تَزْكِيَةٌ ذِمِّيٌّ':Added, #1: 1	تَزْكِيَةِ الثَّوْبِ
u'تَزْكِيَةٌ رَاوِي':Added, #2: 2	تَزْكِيَةُ الذِّمِّيِّ
u'تَزْكِيَةٌ سِرٌّ':Added, #1: 1	تَزْكِيَةِ رَاوِيهِ
u'تَزْكِيَةٌ سِرٌّ':Added, #14: 14	تَزْكِيَةِ السِّرِّ
u'تَزْكِيَةٌ سِرٌّ':Added, #2: 2	تَزْكِيَةَ السِّرِّ
u'تَزْكِيَةٌ سِرٌّ':Added, #2: 2	تَزْكِيَةُ سِرٍّ
u'تَزْكِيَةٌ شَاهِدٌ':Added, #6: 6	تَزْكِيَةُ السِّرِّ
u'تَزْكِيَةٌ شَاهِدٌ':Added, #1: 1	تَزْكِيَةِ شَاهِدِ
u'تَزْكِيَةٌ شَاهِدٌ':Added, #1: 1	تَزْكِيَةِ شَاهِدِهِ
u'تَزْكِيَةٌ شَاهِدٌ':Added, #2: 2	تَزْكِيَةُ الشَّاهِدِ
u'تَزْكِيَةٌ شُهُودٌ':Added, #3: 3	تَزْكِيَةِ الشَّاهِدِ
u'تَزْكِيَةٌ شُهُودٌ':Added, #3: 3	تَزْكِيَةَ الشُّهُودِ
u'تَزْكِيَةٌ شُهُودٌ':Added, #3: 3	تَزْكِيَةِ الشُّهُودِ
u'تَزْكِيَةٌ عَبْدٌ':Added, #6: 6	تَزْكِيَةِ شُهُودِ
u'تَزْكِيَةٌ عَبْدٌ':Added, #1: 1	تَزْكِيَةُ الْعَبْدِ
u'تَزْكِيَةٌ عَلاَنِيَةٌ':Added, #1: 1	تَزْكِيَةِ الْعَبْدِ
u'تَزْكِيَةٌ عَلاَنِيَةٌ':Added, #14: 14	تَزْكِيَةِ الْعَلَانِيَةِ
u'تَزْكِيَةٌ عَلاَنِيَةٌ':Added, #6: 6	تَزْكِيَةَ الْعَلَانِيَةِ
u'تَزْكِيَةٌ غير':Added, #9: 9	تَزْكِيَةُ الْعَلَانِيَةِ
u'تَزْكِيَةٌ غَيْرٌ':Added, #1: 1	تَزْكِيَةُ غَيْرِهِ
u'تَزْكِيَةٌ فَاسِقٌ':Added, #1: 1	تَزْكِيَةُ غَيْرِهِ
u'تَزْكِيَةٌ فَاسِقٌ':Added, #1: 1	تَزْكِيَةَ الْفَاسِقِ
u'تَزْكِيَةٌ مَالٌ':Added, #1: 1	تَزْكِيَةِ فَاسِقٍ
u'تَزْكِيَةٌ مَالٌ':Added, #1: 1	تَزْكِيَةِ مَالٍ
u'تَزْكِيَةٌ نَاقِلٌ':Added, #1: 1	تَزْكِيَةِ مَالِهِ
u'تَزْكِيَةٌ نَفْسٌ':Added, #1: 1	تَزْكِيَةُ نَاقِلٍ
u'تَزْكِيَةٌ نَفْسٌ':Added, #1: 1	تَزْكِيَةُ النَّفْسِ
u'تَزْكِيَةٌ نَفْسٌ':Added, #1: 1	تَزْكِيَةَ نَفْسِهِ
u'تَزْكِيَةٌ هَدْيٌ':Added, #4: 4	تَزْكِيَةِ النَّفْسِ
u'تَزْكِيَةٌ وَالِدٌ':Added, #1: 1	تَزْكِيَةِ الْهَدْيِ
u'تَزَلْزُلٌ رُوَاةٌ':Added, #2: 2	تَزْكِيَةُ الْوَالِدِ
u'تَزَنْدَقَ ذِمِّيٌّ':Subject, #1: 1	تَزَلْزُلَ الرُّوَاةِ
u'تَزَهَّدَ خَلْقٌ':Subject, #1: 1	تَزَنْدَقَ ذِمِّيٌّ
u'تَزَوَّجَ أَبٌ':Subject, #2: 2	تَزَهَّدَ خَلْقٌ
u'تَزَوُّجٌ أَبٌ':Added, #1: 1	تَزَوَّجَ الْأَبُ
u'تَزَوَّجَ اِبْنَة':Predicate, #2: 2	تَزَوُّجِ الْأَبِ
u'تَزَوَّجَ أَجْنَبِيٌّ':Predicate, #5: 5	تَزَوَّجَ ابْنَةَ
u'تَزَوَّجَ أَجْنَبِيٌّ':Subject, #1: 1	تَزَوَّجَ الْأَجْنَبِيَّةَ
u'تَزَوَّجَ أَجْوَدُ':Subject, #2: 2	تَزَوَّجَ الْأَجْنَبِيُّ
u'تَزَوَّجَ أحَدٌ':Subject, #1: 1	تَزَوَّجَ أَجْوَدُ
u'تَزَوَّجَ أحَدٌ':Subject, #1: 1	تَزَوَّجَ أَحَدُ
u'تَزَوَّجَ أُخْتٌ':Predicate, #2: 2	تَزَوَّجَ أَحَدٌ
u'تَزَوَّجَ أُخْتٌ':Predicate, #11: 11	تَزَوَّجَ أُخْتَ
u'تَزَوُّجٌ أُخْتٌ':Added, #1: 1	تَزَوَّجَ الْأُخْتَ
u'تَزَوُّجٌ أُخْتٌ':Added, #1: 1	تَزَوُّجُ الْأُخْتِ
u'تَزَوُّجٌ أُخْتٌ':Added, #2: 2	تَزَوُّجُ أُخْتِ
u'تَزَوَّجَ أَرْبَعُ':Predicate, #2: 2	تَزَوُّجِ الْأُخْتِ
u'تَزَوُّجٌ أَرْبَعُ':Added, #6: 6	تَزَوَّجَ أَرْبَعَ
u'تَزَوَّجَ أَسْماءٌ':Predicate, #1: 1	تَزَوُّجُ الْأَرْبَعِ
u'تَزَوَّجَ الْمَرْأَةُ':Predicate, #2: 2	تَزَوَّجَ أَسْمَاءَ
u'تَزَوُّجٌ الْمَرْأَةُ':Added, #7: 7	تَزَوَّجَ الْمَرْأَةَ
u'تَزَوَّجَ أُمٌّ':Predicate, #3: 3	تَزَوُّجِ الْمَرْأَةِ
u'تَزَوَّجَ أُمٌّ':Predicate, #19: 19	تَزَوَّجَ أُمَّ
u'تَزَوُّجٌ أُمٌّ':Added, #6: 6	تَزَوَّجَ الْأُمَّ
u'تَزَوُّجٌ إمَاءٌ':Added, #1: 1	تَزَوُّجُ أُمِّهِ
u'تَزَوَّجَ أمَةٌ':Predicate, #1: 1	تَزَوُّجِ الْإِمَاءِ
u'تَزَوَّجَ أمَةٌ':Predicate, #14: 14	تَزَوَّجَ أَمَةَ
u'تَزَوُّجٌ أمَةٌ':Added, #5: 5	تَزَوَّجَ الْأَمَةَ
u'تَزَوُّجٌ أمَةٌ':Added, #1: 1	تَزَوُّجِ أَمَةِ
u'تَزَوُّجٌ أمَةٌ':Added, #1: 1	تَزَوُّجُ أَمَتِهِ
u'تَزَوُّجٌ أمَةٌ':Added, #2: 2	تَزَوُّجَ الْأَمَةِ
u'تَزَوُّجٌ أمَةٌ':Added, #3: 3	تَزَوُّجُ الْأَمَةِ
u'تَزَوَّجَ اِمْرَأَةٌ':Predicate, #4: 4	تَزَوُّجِ الْأَمَةِ
u'تَزَوُّجٌ اِمْرَأَةٌ':Added, #6: 6	تَزَوَّجَ امْرَأَةَ
u'تَزَوُّجٌ اِمْرَأَةٌ':Added, #1: 1	تَزَوُّجَ امْرَأَةِ
u'تَزَوُّجٌ اِمْرَأَةٌ':Added, #1: 1	تَزَوُّجُ امْرَأَةٍ
u'تَزَوُّجٌ اِمْرَأَةٌ':Added, #1: 1	تَزَوُّجِ امْرَأَةٍ
u'تَزَوَّجَ بالِغٌ':Predicate, #2: 2	تَزَوُّجِ امْرَأَةِ
u'تَزَوَّجَ بَعْضٌ':Predicate, #3: 3	تَزَوَّجَ بَالِغَةً
u'تَزَوَّجَ بِكْرٌ':Predicate, #2: 2	تَزَوَّجَ بَعْضَ
u'تَزَوُّجٌ بِكْرٌ':Added, #4: 4	تَزَوَّجَ الْبِكْرَ
u'تَزَوَّجَ بِنْتٌ':Predicate, #1: 1	تَزَوُّجِ بِكْرٍ
u'تَزَوَّجَ بِنْتٌ':Predicate, #16: 16	تَزَوَّجَ بِنْتَ
u'تَزَوَّجَ تَاسِعٌ':Predicate, #2: 2	تَزَوَّجَ الْبِنْتَ
u'تَزَوَّجَ ثَانِي':Predicate, #2: 2	تَزَوَّجَ التَّاسِعَةَ
u'تَزَوُّجٌ ثَانِي':Added, #3: 3	تَزَوَّجَ الثَّانِيَةَ
u'تَزَوَّجَ ثَانِيَةٌ':Predicate, #1: 1	تَزَوُّجِ الثَّانِيَةِ
u'تَزَوُّجٌ ثَانِيَةٌ':Added, #3: 3	تَزَوَّجَ الثَّانِيَةَ
u'تَزَوَّجَ ثَلاثُ':Predicate, #1: 1	تَزَوُّجِ الثَّانِيَةِ
u'تَزَوَّجَ ثَيِّبٌ':Predicate, #2: 2	تَزَوَّجَ ثَلَاثَ
u'تَزَوَّجَ جَارِي':Predicate, #4: 4	تَزَوَّجَ الثَّيِّبَ
u'تَزَوَّجَ جَارِي':Predicate, #7: 7	تَزَوَّجَ جَارِيَةً
u'تَزَوَّجَ جَارِيَةٌ':Predicate, #7: 7	تَزَوَّجَ جَارِيَةَ
u'تَزَوُّجٌ جمع':Added, #7: 7	تَزَوَّجَ جَارِيَةَ
u'تَزَوُّجٌ جَمْعٌ':Added, #1: 1	تَزَوُّجِ الْجَمْعِ
u'تَزَوَّجَ جِنٌّ':Predicate, #1: 1	تَزَوُّجِ الْجَمْعِ
u'تَزَوَّجَ جِنِّيٌّ':Predicate, #1: 1	تَزَوَّجَ جِنِّيَّةً
u'تَزَوَّجَ حارِثٌ':Subject, #1: 1	تَزَوَّجَ جِنِّيَّةً
u'تَزَوُّجٌ حامِلٌ':Added, #1: 1	تَزَوَّجَ الْحَارِثُ
u'تَزَوَّجَ حُرٌّ':Predicate, #3: 3	تَزَوُّجِ الْحَامِلِ
u'تَزَوَّجَ حُرٌّ':Predicate, #2: 2	تَزَوَّجَ الْحُرَّةَ
u'تَزَوَّجَ حُرٌّ':Subject, #34: 34	تَزَوَّجَ حُرَّةً
u'تَزَوَّجَ حُرٌّ':Subject, #8: 8	تَزَوَّجَ الْحُرُّ
u'تَزَوُّجٌ حُرٌّ':Added, #8: 8	تَزَوَّجَ حُرٌّ
u'تَزَوُّجٌ حُرٌّ':Added, #1: 1	تَزَوُّجِ الْحُرَّةِ
u'تَزَوُّجٌ حَرائِرُ':Added, #2: 2	تَزَوُّجِ الْحُرِّ
u'تَزَوُّجٌ حَرَائِرُ':Added, #1: 1	تَزَوُّجُ الْحَرَائِرِ
u'تَزَوَّجَ حَرْب':Predicate, #1: 1	تَزَوُّجُ الْحَرَائِرِ
u'تَزَوُّجٌ حَرْب':Added, #3: 3	تَزَوَّجَ حَرْبِيَّةً
u'تَزَوَّجَ حَرْبَة':Predicate, #1: 1	تَزَوُّجُ الْحَرْبِيَّةِ
u'تَزَوُّجٌ حَرْبَة':Added, #3: 3	تَزَوَّجَ حَرْبِيَّةً
u'تَزَوَّجَ حَرْبِيّ':Predicate, #1: 1	تَزَوُّجُ الْحَرْبِيَّةِ
u'تَزَوُّجٌ حَرْبِيّ':Added, #3: 3	تَزَوَّجَ حَرْبِيَّةً
u'تَزَوَّجَ حَلِيلَةٌ':Predicate, #1: 1	تَزَوُّجُ الْحَرْبِيَّةِ
u'تَزَوَّجَ حَمَلٌ':Subject, #3: 3	تَزَوَّجَ حَلِيلَةَ
u'تَزَوَّجَ خامس':Predicate, #1: 1	تَزَوَّجَ حَمَلُ
u'تَزَوَّجَ خَامِسٌ':Predicate, #3: 3	تَزَوَّجَ الْخَامِسَةَ
u'تَزَوَّجَ خامس':Predicate, #3: 3	تَزَوَّجَ الْخَامِسَةَ
u'تَزَوَّجَ خَامِسٌ':Predicate, #4: 4	تَزَوَّجَ خَامِسَةً
u'تَزَوَّجَ خَدِيج':Predicate, #4: 4	تَزَوَّجَ خَامِسَةً
u'تَزَوُّجٌ خَسِيسٌ':Added, #1: 1	تَزَوَّجَ خَدِيجَةَ
u'تَزَوَّجَ خَمْسٌ':Predicate, #1: 1	تَزَوُّجِ الْخَسِيسِ
u'تَزَوَّجَ ذِمِّيٌّ':Predicate, #4: 4	تَزَوَّجَ خَمْسَ
u'تَزَوَّجَ ذِمِّيٌّ':Subject, #5: 5	تَزَوَّجَ ذِمِّيَّةً
u'تَزَوَّجَ ذِمِّيٌّ':Subject, #12: 12	تَزَوَّجَ الذِّمِّيُّ
u'تَزَوَّجَ رَجُلٌ':Subject, #7: 7	تَزَوَّجَ ذِمِّيٌّ
u'تَزَوَّجَ رَجُلٌ':Subject, #16: 16	تَزَوَّجَ رَجُلٌ
u'تَزَوُّجٌ رَجُلٌ':Added, #35: 35	تَزَوَّجَ الرَّجُلُ
u'تَزَوَّجَ رَسُولٌ':Subject, #1: 1	تَزَوُّجِ الرَّجُلِ
u'تَزَوُّجٌ رَسُولٌ':Added, #27: 27	تَزَوَّجَ رَسُولُ
u'تَزَوَّجَ رَشيدٌ':Predicate, #1: 1	تَزَوُّجِ رَسُولِ
u'تَزَوُّجٌ زانِي':Added, #1: 1	تَزَوَّجَ رَشِيدَةً
u'تَزَوَّجَ زَوْجَةٌ':Predicate, #1: 1	تَزَوُّجِ الزَّانِيَةِ
u'تَزَوَّجَ زَيْدٌ':Subject, #1: 1	تَزَوَّجَ زَوْجَةَ
u'تَزَوَّجَ زَيْنَبٌ':Predicate, #2: 2	تَزَوَّجَ زَيْدٌ
u'تَزَوَّجَ سَوْداء':Predicate, #4: 4	تَزَوَّجَ زَيْنَبَ
u'تَزَوُّجٌ سَيِّدٌ':Added, #1: 1	تَزَوَّجَ سَوْدَاءَ
u'تَزَوُّجٌ سَيِّدٌ':Added, #1: 1	تَزَوُّجِ السَّيِّدِ
u'تَزَوَّجَ شَيْخٌ':Subject, #1: 1	تَزَوُّجُ السَّيِّدَةِ
u'تَزَوُّجٌ صَابِئٌ':Added, #1: 1	تَزَوَّجَ شَيْخٌ
u'تَزَوُّجٌ صَابِئَةٌ':Added, #1: 1	تَزَوُّجُ الصَّابِئَاتِ
u'تَزَوَّجَ صَبِيٌّ':Predicate, #1: 1	تَزَوُّجُ الصَّابِئَاتِ
u'تَزَوَّجَ صَغِيرٌ':Predicate, #5: 5	تَزَوَّجَ صَبِيَّةً
u'تَزَوَّجَ صَغِيرٌ':Subject, #13: 13	تَزَوَّجَ صَغِيرَةً
u'تَزَوَّجَ صَغِيرٌ':Subject, #1: 1	تَزَوَّجَ صَغِيرٌ
u'تَزَوَّجَ صَفِيٌّ':Predicate, #3: 3	تَزَوَّجَ الصَّغِيرُ
u'تَزَوَّجَ طَالِبٌ':Subject, #3: 3	تَزَوَّجَ صَفِيَّةَ
u'تَزَوَّجَ طائِفِيٌّ':Predicate, #1: 1	تَزَوَّجَ الطَّالِبُ
u'تَزَوَّجَ طَائِفِيَّةٌ':Predicate, #2: 2	تَزَوَّجَ الطَّائِفِيَّةَ
u'تَزَوَّجَ طِفْلٌ':Predicate, #2: 2	تَزَوَّجَ الطَّائِفِيَّةَ
u'تَزَوَّجَ طِفْلٌ':Subject, #1: 1	تَزَوَّجَ طِفْلَةً
u'تَزَوَّجَ طَلْحٌ':Subject, #1: 1	تَزَوَّجَ طِفْلٌ
u'تَزَوَّجَ طلحة':Subject, #3: 3	تَزَوَّجَ طَلْحَةُ
u'تَزَوَّجَ عادِم':Subject, #3: 3	تَزَوَّجَ طَلْحَةُ
u'تَزَوَّجَ عَاشِرٌ':Predicate, #1: 1	تَزَوَّجَ الْعَادِمُ
u'تَزَوَّجَ عَائِشٌ':Predicate, #3: 3	تَزَوَّجَ الْعَاشِرَةَ
u'تَزَوَّجَ عَبْدٌ':Subject, #4: 4	تَزَوَّجَ عَائِشَةَ
u'تَزَوَّجَ عَبْدٌ':Subject, #10: 10	تَزَوَّجَ عَبْدٌ
u'تَزَوَّجَ عَبْدٌ':Subject, #38: 38	تَزَوَّجَ الْعَبْدُ
u'تَزَوَّجَ عَرَبِيٌّ':Predicate, #5: 5	تَزَوَّجَ عَبْدُ
u'تَزَوَّجَ عَرَبِيٌّ':Subject, #1: 1	تَزَوَّجَ عَرَبِيَّةً
u'تَزَوَّجَ عَشْرٌ':Predicate, #2: 2	تَزَوَّجَ عَرَبِيٌّ
u'تَزَوَّجَ عَمٌّ':Subject, #2: 2	تَزَوَّجَ عَشْرَ
u'تَزَوَّجَ عُمَرٌ':Subject, #1: 1	تَزَوَّجَ عَمُّ
u'تَزَوَّجَ عمرة':Predicate, #2: 2	تَزَوَّجَ عُمَرُ
u'تَزَوَّجَ عمرة':Predicate, #1: 1	تَزَوَّجَ عَمْرَةَ
u'تَزَوَّجَ عُمْرَةٌ':Predicate, #2: 2	تَزَوَّجَ عُمْرَةَ
u'تَزَوَّجَ غَرِيبٌ':Subject, #2: 2	تَزَوَّجَ عُمْرَةَ
u'تَزَوَّجَ غير':Predicate, #2: 2	تَزَوَّجَ الْغَرِيبُ
u'تَزَوَّجَ غَيْرٌ':Predicate, #1: 1	تَزَوَّجَ غَيْرَ
u'تَزَوُّجٌ غير':Added, #1: 1	تَزَوَّجَ غَيْرَ
u'تَزَوُّجٌ غَيْرٌ':Added, #1: 1	تَزَوُّجُ غَيْرِ
u'تَزَوَّجَ فَاطِمٌ':Predicate, #1: 1	تَزَوُّجُ غَيْرِ
u'تَزَوُّجٌ فُضُولِيٌّ':Added, #5: 5	تَزَوَّجَ فَاطِمَةَ
u'تَزَوَّجَ فلان':Predicate, #1: 1	تَزَوُّجِ الْفُضُولِيِّ
u'تَزَوَّجَ فلان':Predicate, #1: 1	تَزَوَّجَ بِلْقِيسَ
u'تَزَوَّجَ فلان':Predicate, #1: 1	تَزَوَّجَ خَدِيجَةَ
u'تَزَوَّجَ فلان':Predicate, #2: 2	تَزَوَّجَ الْمَكِّيَّةَ
u'تَزَوَّجَ فُلاَنٌ':Predicate, #2: 2	تَزَوَّجَ مَكِّيَّةً
u'تَزَوَّجَ فلان':Subject, #7: 7	تَزَوَّجَ فُلَانَةَ
u'تَزَوَّجَ فُلاَنٌ':Subject, #1: 1	تَزَوَّجَ عَقِيلٌ
u'تَزَوَّجَ فُلاَنٌ':Subject, #1: 1	تَزَوَّجَ فُلانٌ
u'تَزَوَّجَ فلان':Subject, #1: 1	تَزَوَّجَ فُلاَنٌ
u'تَزَوَّجَ فلان':Subject, #2: 2	تَزَوَّجَ حُذَيْفَةُ
u'تَزَوَّجَ فُلاَنٌ':Subject, #3: 3	تَزَوَّجَ عَقِيلُ
u'تَزَوَّجَ قَالٌ':Predicate, #8: 8	تَزَوَّجَ فُلَانٌ
u'تَزَوَّجَ قُرَشِيٌّ':Predicate, #2: 2	تَزَوَّجَ قَالَ
u'تَزَوَّجَ كَافِرٌ':Subject, #1: 1	تَزَوَّجَ قُرَشِيَّةً
u'تَزَوَّجَ كَافِرٌ':Subject, #1: 1	تَزَوَّجَ كَافِرٌ
u'تَزَوُّجٌ كَبِيرٌ':Added, #5: 5	تَزَوَّجَ الْكَافِرُ
u'تَزَوَّجَ كِتاب':Predicate, #1: 1	تَزَوُّجِ الْكَبِيرَةِ
u'تَزَوَّجَ كِتاب':Predicate, #1: 1	تَزَوَّجَ الْكِتَابِيَّةَ
u'تَزَوَّجَ كِتاب':Predicate, #1: 1	تَزَوَّجَ كِتَابِيَّةَ
u'تَزَوُّجٌ كِتاب':Added, #6: 6	تَزَوَّجَ كِتَابِيَّةً
u'تَزَوَّجَ كِتابَة':Predicate, #3: 3	تَزَوُّجُ الْكِتَابِيَّةِ
u'تَزَوَّجَ كِتابَة':Predicate, #1: 1	تَزَوَّجَ الْكِتَابِيَّةَ
u'تَزَوَّجَ كِتابَة':Predicate, #1: 1	تَزَوَّجَ كِتَابِيَّةَ
u'تَزَوُّجٌ كِتابَة':Added, #6: 6	تَزَوَّجَ كِتَابِيَّةً
u'تَزَوَّجَ كِتابِيّ':Predicate, #3: 3	تَزَوُّجُ الْكِتَابِيَّةِ
u'تَزَوَّجَ كِتابِيّ':Predicate, #1: 1	تَزَوَّجَ الْكِتَابِيَّةَ
u'تَزَوَّجَ كِتابِيّ':Predicate, #1: 1	تَزَوَّجَ كِتَابِيَّةَ
u'تَزَوُّجٌ كِتابِيّ':Added, #6: 6	تَزَوَّجَ كِتَابِيَّةً
u'تَزَوَّجَ مَالِكٌ':Subject, #3: 3	تَزَوُّجُ الْكِتَابِيَّةِ
u'تَزَوَّجَ مَبْتُوت':Predicate, #1: 1	تَزَوَّجَ الْمَالِكُ
u'تَزَوَّجَ مُبَيِّضٌ':Predicate, #1: 1	تَزَوَّجَ مَبْتُوتَةً
u'تَزَوَّجَ مَجْهُولٌ':Predicate, #1: 1	تَزَوَّجَ مُبَيِّضَةً
u'تَزَوَّجَ مَجْهُولٌ':Predicate, #2: 2	تَزَوَّجَ مَجْهُولَةً
u'تَزَوَّجَ مَجُوسِيٌّ':Subject, #2: 2	تَزَوَّجَ مَجْهُولَةَ
u'تَزَوَّجَ مَجُوسِيٌّ':Subject, #4: 4	تَزَوَّجَ مَجُوسِيٌّ
u'تَزَوُّجٌ مَجُوسِيٌّ':Added, #6: 6	تَزَوَّجَ الْمَجُوسِيُّ
u'تَزَوُّجٌ مَجُوسِيَّةٌ':Added, #1: 1	تَزَوُّجَ الْمَجُوسِيِّ
u'تَزَوُّجٌ مَجُوسِيَّةٌ':Added, #1: 1	تَزَوُّجُ الْمَجُوسِيَّاتِ
u'تَزَوَّجَ مَحْجُورٌ':Subject, #1: 1	تَزَوُّجِ الْمَجُوسِيَّةِ
u'تَزَوَّجَ مُحْرِمٌ':Predicate, #1: 1	تَزَوَّجَ الْمَحْجُورُ
u'تَزَوَّجَ مُحَمَّدٌ':Subject, #1: 1	تَزَوَّجَ مُحْرِمَةً
u'تَزَوَّجَ مُحَمَّدٌ':Subject, #1: 1	تَزَوَّجَ مُحَمَّدٌ
u'تَزَوَّجَ مُدَبَّرٌ':Predicate, #1: 1	تَزَوَّجَ مُحَمَّدُ
u'تَزَوَّجَ مُدَبَّرٌ':Subject, #1: 1	تَزَوَّجَ مُدَبَّرَةً
u'تَزَوَّجَ مَرِيضٌ':Subject, #1: 1	تَزَوَّجَ مُدَبَّرٌ
u'تَزَوَّجَ مُسْتَأْجِرٌ':Subject, #3: 3	تَزَوَّجَ الْمَرِيضُ
u'تَزَوَّجَ مُسْتَحْسَنٌ':Predicate, #1: 1	تَزَوَّجَ الْمُسْتَأْجِرُ
u'تَزَوَّجَ مُسْلِمٌ':Predicate, #1: 1	تَزَوَّجَ مُسْتَحْسَنَةً
u'تَزَوَّجَ مُسْلِمٌ':Subject, #4: 4	تَزَوَّجَ مُسْلِمَةً
u'تَزَوَّجَ مُسْلِمٌ':Subject, #10: 10	تَزَوَّجَ الْمُسْلِمُ
u'تَزَوُّجٌ مُسْلِمٌ':Added, #14: 14	تَزَوَّجَ مُسْلِمٌ
u'تَزَوُّجٌ مُسْلِمٌ':Added, #1: 1	تَزَوُّجُ الْمُسْلِمِ
u'تَزَوُّجٌ مُسْلِمٌ':Added, #1: 1	تَزَوُّجُ الْمُسْلِمَةِ
u'تَزَوُّجٌ مَشْرِقِيٌّ':Added, #1: 1	تَزَوُّجُ مُسْلِمٍ
u'تَزَوَّجَ مُضَارِبٌ':Subject, #1: 1	تَزَوُّجِ الْمَشْرِقِيِّ
u'تَزَوُّجٌ مَضْمُومٌ':Added, #1: 1	تَزَوَّجَ الْمُضَارِبُ
u'تَزَوَّجَ مُطَلَّقٌ':Predicate, #1: 1	تَزَوُّجُ الْمَضْمُومَةِ
u'تَزَوَّجَ مُطَلَّقٌ':Predicate, #1: 1	تَزَوَّجَ الْمُطَلَّقَةَ
u'تَزَوَّجَ مُعْتَدٌّ':Predicate, #1: 1	تَزَوَّجَ مُطَلَّقَةً
u'تَزَوَّجَ مُعْتَدٌّ':Predicate, #1: 1	تَزَوَّجَ مُعْتَدَّةً
u'تَزَوَّجَ مُعْتَقٌ':Predicate, #2: 2	تَزَوَّجَ الْمُعْتَدَّةَ
u'تَزَوَّجَ مُعْتَقٌ':Predicate, #1: 1	تَزَوَّجَ الْمُعْتَقَةَ
u'تَزَوَّجَ مُعْتَقٌ':Predicate, #2: 2	تَزَوَّجَ مُعْتَقَةً
u'تَزَوَّجَ مَغْرِبِيٌّ':Predicate, #2: 2	تَزَوَّجَ مُعْتَقَةَ
u'تَزَوُّجٌ مَغْرِبِيٌّ':Added, #1: 1	تَزَوَّجَ مَغْرِبِيَّةً
u'تَزَوَّجَ مَغْرُورٌ':Subject, #1: 1	تَزَوُّجِ الْمَغْرِبِيِّ
u'تَزَوَّجَ مَغْصُوب':Predicate, #1: 1	تَزَوَّجَ الْمَغْرُورُ
u'تَزَوُّجٌ مَفْعُولٌ':Added, #2: 2	تَزَوَّجَ الْمَغْصُوبَةَ
u'تَزَوَّجَ مَكِّيّ':Predicate, #1: 1	تَزَوُّجُ الْمَفْعُولِ
u'تَزَوَّجَ مَكِّيّ':Predicate, #2: 2	تَزَوَّجَ الْمَكِّيَّةَ
u'تَزَوَّجَ مَمْلُوكٌ':Predicate, #2: 2	تَزَوَّجَ مَكِّيَّةً
u'تَزَوَّجَ مَمْلُوكٌ':Predicate, #1: 1	تَزَوَّجَ مَمْلُوكَةً
u'تَزَوَّجَ مَمْلُوكٌ':Subject, #1: 1	تَزَوَّجَ مَمْلُوكَةَ
u'تَزَوَّجَ مَنْكُوح':Predicate, #1: 1	تَزَوَّجَ الْمَمْلُوكُ
u'تَزَوُّجٌ مَنْكُوح':Added, #1: 1	تَزَوَّجَ مَنْكُوحَةَ
u'تَزَوَّجَ مَوْقُوفٌ':Subject, #1: 1	تَزَوُّجِ مَنْكُوحَةِ
u'تَزَوَّجَ مُوَكِّلٌ':Subject, #1: 1	تَزَوَّجَ الْمَوْقُوفُ
u'تَزَوَّجَ مَيْمُونٌ':Predicate, #1: 1	تَزَوَّجَ الْمُوَكِّلُ
u'تَزَوَّجَ نَبِيٌّ':Subject, #13: 13	تَزَوَّجَ مَيْمُونَةَ
u'تَزَوَّجَ نَبِيٌّ':Subject, #1: 1	تَزَوَّجَ نَبِيُّ
u'تَزَوُّجٌ نِساءٌ':Added, #5: 5	تَزَوَّجَ النَّبِيُّ
u'تَزَوَّجَ نَصْرَانِيٌّ':Predicate, #1: 1	تَزَوُّجِ النِّسَاءِ
u'تَزَوَّجَ نَصْرَانِيٌّ':Subject, #7: 7	تَزَوَّجَ نَصْرَانِيَّةً
u'تَزَوَّجَ واحد':Predicate, #2: 2	تَزَوَّجَ النَّصْرَانِيُّ
u'تَزَوَّجَ وَاحِدٌ':Predicate, #1: 1	تَزَوَّجَ الْوَاحِدَةَ
u'تَزَوَّجَ واحد':Predicate, #1: 1	تَزَوَّجَ الْوَاحِدَةَ
u'تَزَوَّجَ وَاحِدٌ':Predicate, #7: 7	تَزَوَّجَ وَاحِدَةً
u'تَزَوُّجٌ واحد':Added, #7: 7	تَزَوَّجَ وَاحِدَةً
u'تَزَوُّجٌ وَاحِدٌ':Added, #1: 1	تَزَوُّجِ الْوَاحِدَةِ
u'تَزَوُّجٌ واحد':Added, #1: 1	تَزَوُّجِ الْوَاحِدَةِ
u'تَزَوُّجٌ وَاحِدٌ':Added, #2: 2	تَزَوُّجٍ وَاحِدٍ
u'تَزَوُّجٌ واحد':Added, #2: 2	تَزَوُّجٍ وَاحِدٍ
u'تَزَوُّجٌ وَاحِدٌ':Added, #2: 2	تَزَوُّجُ وَاحِدَةٍ
u'تَزَوَّجَ وقع':Predicate, #2: 2	تَزَوُّجُ وَاحِدَةٍ
u'تَزَوَّجَ ولائد':Predicate, #1: 1	تَزَوَّجَ وَقَعَ
u'تَزَوُّجٌ ولد':Added, #1: 1	تَزَوَّجَ الْوَلاَئِدَ
u'تَزَوُّجٌ وَلَدٌ':Added, #1: 1	تَزَوُّجُ وَلَدِهِ
u'تَزَوَّجَ يَهُودِيٌّ':Predicate, #1: 1	تَزَوُّجُ وَلَدِهِ
u'تَزَوُّجٌ يَهُودِيٌّ':Added, #5: 5	تَزَوَّجَ يَهُودِيَّةً
u'تَزَوُّدٌ عَامِلٌ':Added, #1: 1	تَزَوُّجُ الْيَهُودِيِّ
u'تَزْوِيجٌ أَبٌ':Added, #1: 1	تَزَوُّدِ الْعَامِلِ
u'تَزْوِيجٌ أَبٌ':Added, #2: 2	تَزْوِيجُ الْأَبِ
u'تَزْوِيجٌ أَبْعَدُ':Added, #6: 6	تَزْوِيجِ الْأَبِ
u'تَزْوِيجٌ أَبْعَدُ':Added, #1: 1	تَزْوِيجُ الْأَبْعَدِ
u'تَزْوِيجٌ اِبْنٌ':Added, #1: 1	تَزْوِيجِ الْأَبْعَدِ
u'تَزْوِيجٌ اِبْنٌ':Added, #1: 1	تَزْوِيجُ ابْنِ
u'تَزْوِيجٌ اِبْنٌ':Added, #1: 1	تَزْوِيجِ ابْنِهِ
u'تَزْوِيجٌ اِبْنَة':Added, #2: 2	تَزْوِيجُ ابْنِهِ
u'تَزْوِيجٌ اِبْنَة':Added, #1: 1	تَزْوِيجُ ابْنَتِهِ
u'تَزْوِيجٌ اِبْنَة':Added, #1: 1	تَزْوِيجِ ابْنَتِهِ
u'تَزْوِيجٌ أَخٌ':Added, #3: 3	تَزْوِيجُ ابْنَةِ
u'تَزْوِيجٌ أَطْفَالٌ':Added, #2: 2	تَزْوِيجِ الْأَخِ
u'تَزْوِيجٌ أَطْفَالٌ':Added, #1: 1	تَزْوِيجَ الْأَطْفَالِ
u'تَزْوِيجٌ الْمَرْأَةُ':Added, #1: 1	تَزْوِيجُ الْأَطْفَالِ
u'تَزْوِيجٌ الْمَرْأَةُ':Added, #2: 2	تَزْوِيجُ الْمَرْأَةِ
u'تَزْوِيجٌ أُمٌّ':Added, #3: 3	تَزْوِيجِ الْمَرْأَةِ
u'تَزْوِيجٌ أُمٌّ':Added, #1: 1	تَزْوِيجَ أُمِّ
u'تَزْوِيجٌ أُمٌّ':Added, #1: 1	تَزْوِيجِ أُمِّ
u'تَزْوِيجٌ أُمٌّ':Added, #1: 1	تَزْوِيجِ أُمِّهِ
u'تَزْوِيجٌ إمَاءٌ':Added, #2: 2	تَزْوِيجِ الْأُمِّ
u'تَزْوِيجٌ إمَاءٌ':Added, #1: 1	تَزْوِيجَ الْإِمَاءِ
u'تَزْوِيجٌ إمَاءٌ':Added, #1: 1	تَزْوِيجُ الْإِمَاءِ
u'تَزْوِيجٌ أمَةٌ':Added, #1: 1	تَزْوِيجِ الْإِمَاءِ
u'تَزْوِيجٌ أمَةٌ':Added, #14: 14	تَزْوِيجُ الْأَمَةِ
u'تَزْوِيجٌ أمَةٌ':Added, #17: 17	تَزْوِيجَ الْأَمَةِ
u'تَزْوِيجٌ أمَةٌ':Added, #19: 19	تَزْوِيجِ الْأَمَةِ
u'تَزْوِيجٌ أمَةٌ':Added, #2: 2	تَزْوِيجَ أَمَةٍ
u'تَزْوِيجٌ أمَةٌ':Added, #3: 3	تَزْوِيجُ أَمَتِهِ
u'تَزْوِيجٌ أمَةٌ':Added, #3: 3	تَزْوِيجِ أَمَتِهِ
u'تَزْوِيجٌ أمَةٌ':Added, #4: 4	تَزْوِيجَ أَمَةِ
u'تَزْوِيجٌ أمَةٌ':Added, #4: 4	تَزْوِيجُ أَمَةِ
u'تَزْوِيجٌ اِمْرَأَةٌ':Added, #7: 7	تَزْوِيجَ أَمَتِهِ
u'تَزْوِيجٌ اِمْرَأَةٌ':Added, #1: 1	تَزْوِيجَ امْرَأَتِهِ
u'تَزْوِيجٌ اِمْرَأَةٌ':Added, #1: 1	تَزْوِيجِ امْرَأَتِهِ
u'تَزْوِيجٌ أُمَّهَاتٌ':Added, #5: 5	تَزْوِيجِ امْرَأَةٍ
u'تَزْوِيجٌ أنبياء':Added, #3: 3	تَزْوِيجِ أُمَّهَاتِ
u'تَزْوِيجٌ أَوْلاَدٌ':Added, #1: 1	تَزْوِيجُ الْأَنْبِيَاءِ
u'تَزْوِيجٌ أَوْلاَدٌ':Added, #1: 1	تَزْوِيجِ أَوْلَادِهِ
u'تَزْوِيجٌ أَوْلِيَاءُ':Added, #2: 2	تَزْوِيجُ أَوْلَادِهِ
u'تَزْوِيجٌ أيِّمٌ':Added, #1: 1	تَزْوِيجِ الْأَوْلِيَاءِ
u'تَزْوِيجٌ بِكْرٌ':Added, #1: 1	تَزْوِيجَ أَيِّمٍ
u'تَزْوِيجٌ بِكْرٌ':Added, #1: 1	تَزْوِيجِ الْبِكْرِ
u'تَزْوِيجٌ بِكْرٌ':Added, #2: 2	تَزْوِيجَ الْبِكْرِ
u'تَزْوِيجٌ بِنْتٌ':Added, #2: 2	تَزْوِيجُ الْبِكْرِ
u'تَزْوِيجٌ بِنْتٌ':Added, #1: 1	تَزْوِيجَ الْبِنْتِ
u'تَزْوِيجٌ بِنْتٌ':Added, #1: 1	تَزْوِيجُ الْبِنْتِ
u'تَزْوِيجٌ بِنْتٌ':Added, #2: 2	تَزْوِيجِ الْبِنْتِ
u'تَزْوِيجٌ بِنْتٌ':Added, #2: 2	تَزْوِيجُ بِنْتِ
u'تَزْوِيجٌ بِنْتٌ':Added, #2: 2	تَزْوِيجِ بِنْتِهِ
u'تَزْوِيجٌ ثَيِّبٌ':Added, #5: 5	تَزْوِيجِ بِنْتِ
u'تَزْوِيجٌ ثَيِّبٌ':Added, #1: 1	تَزْوِيجُ الثَّيِّبِ
u'تَزْوِيجٌ جَارِي':Added, #1: 1	تَزْوِيجِ الثَّيِّبِ
u'تَزْوِيجٌ جَارِيَةٌ':Added, #3: 3	تَزْوِيجُ الْجَارِيَةِ
u'تَزْوِيجٌ جَمِيع':Added, #3: 3	تَزْوِيجُ الْجَارِيَةِ
u'تَزْوِيجٌ جِنٌّ':Added, #1: 1	تَزْوِيجُ الْجَمِيعِ
u'تَزْوِيجٌ حاضِنٌ':Added, #1: 1	تَزْوِيجُ الْجِنِّ
u'تَزْوِيجٌ حاكِمٌ':Added, #1: 1	تَزْوِيجُ الْحَاضِنَةِ
u'تَزْوِيجٌ حاكِمٌ':Added, #1: 1	تَزْوِيجُ حَاكِمٍ
u'تَزْوِيجٌ حُرٌّ':Added, #3: 3	تَزْوِيجَ الْحَاكِمِ
u'تَزْوِيجٌ حُرٌّ':Added, #1: 1	تَزْوِيجُ الْحُرِّ
u'تَزْوِيجٌ خاصّ':Added, #4: 4	تَزْوِيجُ الْحُرَّةِ
u'تَزْوِيجٌ خامس':Added, #1: 1	تَزْوِيجُ الْخَاصِّ
u'تَزْوِيجٌ خَامِسٌ':Added, #1: 1	تَزْوِيجُ الْخَامِسَةِ
u'تَزْوِيجٌ خامس':Added, #1: 1	تَزْوِيجُ الْخَامِسَةِ
u'تَزْوِيجٌ خَامِسٌ':Added, #1: 1	تَزْوِيجُ خَامِسَةٍ
u'تَزْوِيجٌ ذِمِّيٌّ':Added, #1: 1	تَزْوِيجُ خَامِسَةٍ
u'تَزْوِيجٌ ذِمِّيٌّ':Added, #1: 1	تَزْوِيجَ الذِّمِّيَّاتِ
u'تَزْوِيجٌ رَجُلٌ':Added, #1: 1	تَزْوِيجُ الذِّمِّيَّةِ
u'تَزْوِيجٌ رَسُولٌ':Added, #1: 1	تَزْوِيجِ رَجُلٍ
u'تَزْوِيجٌ رَقيقٌ':Added, #2: 2	تَزْوِيجِ رَسُولِ
u'تَزْوِيجٌ رَقيق':Added, #1: 1	تَزْوِيجَ الرَّقِيقِ
u'تَزْوِيجٌ رَقيقٌ':Added, #1: 1	تَزْوِيجَ الرَّقِيقِ
u'تَزْوِيجٌ رَقيق':Added, #2: 2	تَزْوِيجُ رَقِيقِهِ
u'تَزْوِيجٌ رَقيقٌ':Added, #2: 2	تَزْوِيجُ رَقِيقِهِ
u'تَزْوِيجٌ رَقيق':Added, #3: 3	تَزْوِيجِ الرَّقِيقِ
u'تَزْوِيجٌ زَيْدٌ':Added, #3: 3	تَزْوِيجِ الرَّقِيقِ
u'تَزْوِيجٌ سَفِيهٌ':Added, #1: 1	تَزْوِيجِ زَيْدٍ
u'تَزْوِيجٌ سُلْطَانٌ':Added, #2: 2	تَزْوِيجُ السَّفِيهِ
u'تَزْوِيجٌ سَيِّدٌ':Added, #1: 1	تَزْوِيجِ السُّلْطَانِ
u'تَزْوِيجٌ صَابِئٌ':Added, #1: 1	تَزْوِيجَ السَّيِّدِ
u'تَزْوِيجٌ صَابِئَةٌ':Added, #2: 2	تَزْوِيجُ الصَّابِئَاتِ
u'تَزْوِيجٌ صَبِيٌّ':Added, #2: 2	تَزْوِيجُ الصَّابِئَاتِ
u'تَزْوِيجٌ صغار':Added, #1: 1	تَزْوِيجِ صَبِيٍّ
u'تَزْوِيجٌ صغار':Added, #2: 2	تَزْوِيجِ الصِّغَارِ
u'تَزْوِيجٌ صغار':Added, #3: 3	تَزْوِيجُ الصِّغَارِ
u'تَزْوِيجٌ صغائر':Added, #5: 5	تَزْوِيجَ الصِّغَارِ
u'تَزْوِيجٌ صَغَائِرُ':Added, #2: 2	تَزْوِيجِ الصَّغَائِرِ
u'تَزْوِيجٌ صَغِيرٌ':Added, #2: 2	تَزْوِيجِ الصَّغَائِرِ
u'تَزْوِيجٌ صَغِيرٌ':Added, #1: 1	تَزْوِيجُ صَغِيرٍ
u'تَزْوِيجٌ صَغِيرٌ':Added, #1: 1	تَزْوِيجِ صَغِيرٍ
u'تَزْوِيجٌ صَغِيرٌ':Added, #2: 2	تَزْوِيجَ الصَّغِيرِ
u'تَزْوِيجٌ صَغِيرٌ':Added, #2: 2	تَزْوِيجِ الصَّغِيرِ
u'تَزْوِيجٌ صَغِيرٌ':Added, #3: 3	تَزْوِيجَ الصَّغِيرَةِ
u'تَزْوِيجٌ صَغِيرٌ':Added, #3: 3	تَزْوِيجُ الصَّغِيرَةِ
u'تَزْوِيجٌ صَغِيرٌ':Added, #3: 3	تَزْوِيجِ الصَّغِيرَةِ
u'تَزْوِيجٌ صَغِيرٌ':Added, #4: 4	تَزْوِيجُ صَغِيرَةٍ
u'تَزْوِيجٌ طِفْلٌ':Added, #9: 9	تَزْوِيجُ الصَّغِيرِ
u'تَزْوِيجٌ طِفْلٌ':Added, #1: 1	تَزْوِيجَ الطِّفْلِ
u'تَزْوِيجٌ عَامٌّ':Added, #1: 1	تَزْوِيجِ الطِّفْلِ
u'تَزْوِيجٌ عَبْدٌ':Added, #1: 1	تَزْوِيجُ الْعَامِّ
u'تَزْوِيجٌ عَبْدٌ':Added, #11: 11	تَزْوِيجَ الْعَبْدِ
u'تَزْوِيجٌ عَبْدٌ':Added, #1: 1	تَزْوِيجَ عَبْدِ
u'تَزْوِيجٌ عَبْدٌ':Added, #1: 1	تَزْوِيجِ عَبْدِ
u'تَزْوِيجٌ عَبْدٌ':Added, #2: 2	تَزْوِيجُ عَبْدِ
u'تَزْوِيجٌ عَبْدٌ':Added, #2: 2	تَزْوِيجِ عَبْدِهِ
u'تَزْوِيجٌ عَبْدٌ':Added, #3: 3	تَزْوِيجُ عَبْدِهِ
u'تَزْوِيجٌ عَبْدٌ':Added, #8: 8	تَزْوِيجُ الْعَبْدِ
u'تَزْوِيجٌ عَبْدٌ':Added, #9: 9	تَزْوِيجِ الْعَبْدِ
u'تَزْوِيجٌ عَلِيٌّ':Added, #9: 9	تَزْوِيجَ عَبْدِهِ
u'تَزْوِيجٌ غُلاَمٌ':Added, #1: 1	تَزْوِيج عَلِيِّ
u'تَزْوِيجٌ غُلاَمٌ':Added, #1: 1	تَزْوِيجُ الْغُلَامِ
u'تَزْوِيجٌ غير':Added, #1: 1	تَزْوِيجِ الْغُلَامِ
u'تَزْوِيجٌ غير':Added, #1: 1	تَزْوِيجَ الْغَيْرِ
u'تَزْوِيجٌ غَيْرٌ':Added, #1: 1	تَزْوِيجُ الْغَيْرِ
u'تَزْوِيجٌ غَيْرٌ':Added, #1: 1	تَزْوِيجَ الْغَيْرِ
u'تَزْوِيجٌ غير':Added, #1: 1	تَزْوِيجُ الْغَيْرِ
u'تَزْوِيجٌ غَيْرٌ':Added, #4: 4	تَزْوِيجِ غَيْرِ
u'تَزْوِيجٌ فَاسِقٌ':Added, #4: 4	تَزْوِيجِ غَيْرِ
u'تَزْوِيجٌ فَاسِقٌ':Added, #1: 1	تَزْوِيجُ الْفَاسِقِ
u'تَزْوِيجٌ فُضُولِيٌّ':Added, #1: 1	تَزْوِيجِ الْفَاسِقِ
u'تَزْوِيجٌ فَقِيرٌ':Added, #1: 1	تَزْوِيجَ فُضُولِيٍّ
u'تَزْوِيجٌ قَاصِرٌ':Added, #1: 1	تَزْوِيجِ الْفَقِيرِ
u'تَزْوِيجٌ قرائب':Added, #1: 1	تَزْوِيجِ قَاصِرٍ
u'تَزْوِيجٌ مُجْبَرٌ':Added, #1: 1	تَزْوِيجَ الْقَرَائِبِ
u'تَزْوِيجٌ مُجْبَرٌ':Added, #1: 1	تَزْوِيجُ الْمُجْبَرِ
u'تَزْوِيجٌ مُجْبَرٌ':Added, #1: 1	تَزْوِيجِ الْمُجْبَرِ
u'تَزْوِيجٌ مَجْنُونٌ':Added, #1: 1	تَزْوِيجُ الْمُجْبَرَةِ
u'تَزْوِيجٌ مَجْنُونٌ':Added, #3: 3	تَزْوِيجِ الْمَجْنُونَةِ
u'تَزْوِيجٌ مَجْنُونٌ':Added, #3: 3	تَزْوِيجِ مَجْنُونٍ
u'تَزْوِيجٌ مَجُوسِيٌّ':Added, #6: 6	تَزْوِيجُ الْمَجْنُونَةِ
u'تَزْوِيجٌ مَجُوسِيَّةٌ':Added, #1: 1	تَزْوِيجِ الْمَجُوسِيِّ
u'تَزْوِيجٌ مُحْرِمٌ':Added, #2: 2	تَزْوِيجُ الْمَجُوسِيَّاتِ
u'تَزْوِيجٌ مَرِيضٌ':Added, #1: 1	تَزْوِيجُ الْمُحْرِمِ
u'تَزْوِيجٌ مُسْلِمٌ':Added, #1: 1	تَزْوِيجُ الْمَرِيضِ
u'تَزْوِيجٌ مُسْلِمٌ':Added, #1: 1	تَزْوِيجِ الْمُسْلِمِ
u'تَزْوِيجٌ مُعْتَدٌّ':Added, #2: 2	تَزْوِيجَ مُسْلِمٍ
u'تَزْوِيجٌ مُعْتَدٌّ':Added, #1: 1	تَزْوِيجُ الْمُعْتَدَّةِ
u'تَزْوِيجٌ مُعْتَقٌ':Added, #1: 1	تَزْوِيجِ مُعْتَدَّةٍ
u'تَزْوِيجٌ مُعَيَّنٌ':Added, #1: 1	تَزْوِيجِ الْمُعْتَقَةِ
u'تَزْوِيجٌ مَغْصُوب':Added, #1: 1	تَزْوِيجِ مُعَيَّنَةٍ
u'تَزْوِيجٌ مَغْصُوب':Added, #1: 1	تَزْوِيجُ الْمَغْصُوبَةِ
u'تَزْوِيجٌ مَكَاتِبُ':Added, #2: 2	تَزْوِيجِ الْمَغْصُوبَةِ
u'تَزْوِيجٌ مُكَاتَبَةٌ':Added, #1: 1	تَزْوِيجُ الْمَكَاتِبِ
u'تَزْوِيجٌ مُكَاتَبَةٌ':Added, #1: 1	تَزْوِيجُ الْمُكَاتَبَةِ
u'تَزْوِيجٌ مُلْتَقِط':Added, #3: 3	تَزْوِيجِ الْمُكَاتَبَةِ
u'تَزْوِيجٌ مَوْقُوفٌ':Added, #2: 2	تَزْوِيجُ الْمُلْتَقِطِ
u'تَزْوِيجٌ نَبِيٌّ':Added, #1: 1	تَزْوِيجُ الْمَوْقُوفَةِ
u'تَزْوِيجٌ نَفْسٌ':Added, #1: 1	تَزْوِيجِ النَّبِيِّ
u'تَزْوِيجٌ نَفْسٌ':Added, #1: 1	تَزْوِيجِ نَفْسِهِ
u'تَزْوِيجٌ واحد':Added, #2: 2	تَزْوِيجُ نَفْسِهِ
u'تَزْوِيجٌ وَاحِدٌ':Added, #1: 1	تَزْوِيجٍ وَاحِدٍ
u'تَزْوِيجٌ واحد':Added, #1: 1	تَزْوِيجٍ وَاحِدٍ
u'تَزْوِيجٌ وَاحِدٌ':Added, #1: 1	تَزْوِيجَ وَاحِدَةٍ
u'تَزْوِيجٌ وَالِدٌ':Added, #1: 1	تَزْوِيجَ وَاحِدَةٍ
u'تَزْوِيجٌ وَكِيلٌ':Added, #1: 1	تَزْوِيجَ الْوَالِدَيْنِ
u'تَزْوِيجٌ وَكِيلٌ':Added, #1: 1	تَزْوِيجُ الْوَكِيلِ
u'تَزْوِيجٌ ولد':Added, #2: 2	تَزْوِيجِ الْوَكِيلِ
u'تَزْوِيجٌ وَلَدٌ':Added, #1: 1	تَزْوِيجُ الْوَلَدِ
u'تَزْوِيجٌ ولد':Added, #1: 1	تَزْوِيجُ الْوَلَدِ
u'تَزْوِيجٌ وَلَدٌ':Added, #1: 1	تَزْوِيجِ وَلَدِهِ
u'تَزْوِيجٌ وَلِيٌّ':Added, #1: 1	تَزْوِيجِ وَلَدِهِ
u'تَزْوِيجٌ وَلِيٌّ':Added, #1: 1	تَزْوِيجِ وَلِيَّتِهِ
u'تَزْوِيجٌ وَلِيٌّ':Added, #2: 2	تَزْوِيجِ وَلِيٍّ
u'تَزْوِيجٌ وَلِيٌّ':Added, #3: 3	تَزْوِيجُ الْوَلِيِّ
u'تَزْوِيجٌ وَلِيٌّ':Added, #3: 3	تَزْوِيجِ الْوَلِيِّ
u'تَزْوِيجٌ يَتِيمٌ':Added, #3: 3	تَزْوِيجِ الْوَلِيَّيْنِ
u'تَزْوِيدٌ ضَيْفٌ':Added, #1: 1	تَزْوِيجِ الْيَتِيمَةِ
u'تَزْوِيرٌ شَيْءٌ':Added, #1: 1	تَزْوِيدَ الضَّيْفِ
u'تَزْوِيرٌ كَلاَمٌ':Added, #1: 1	تَزْوِيرُ شَيْءٍ
u'تَزْوِيقٌ دَارٌ':Added, #1: 1	تَزْوِيرِ الْكَلَامِ
u'تَزْوِيقٌ كَلاَمٌ':Added, #2: 2	تَزْوِيقَ الدَّارِ
u'تَزْوِيقٌ مَسْجِدٌ':Added, #1: 1	تَزْوِيقُ الْكَلَامِ
u'تَزَيَّا زِيٌّ':Predicate, #1: 1	تَزْوِيقِ الْمَسْجِدِ
u'تَزَيَّنَ قَوْمٌ':Subject, #1: 1	تَزَيَّا زِيَّ
u'تَزْيِينٌ أَبٌ':Added, #1: 1	تَزَيَّنَ الْقَوْمُ
u'تَزْيِينٌ الْمَرْأَةُ':Added, #1: 1	تَزْيِينِ الْأَبِ
u'تَزْيِينٌ بُيُوتٌ':Added, #1: 1	تَزْيِينَ الْمَرْأَةِ
u'تَزْيِينٌ جُدْرَانٌ':Added, #1: 1	تَزْيِينُ الْبُيُوتِ
u'تَزْيِينٌ جُدْرَانٌ':Added, #1: 1	تَزْيِينَ الْجُدْرَانِ
u'تَزْيِينٌ جِمَالٌ':Added, #1: 1	تَزْيِينِ الْجُدْرَانِ
u'تَزْيِينٌ خَارِجٌ':Added, #1: 1	تَزْيِينِ الْجِمَالِ
u'تَزْيِينٌ شَعْرٌ':Added, #1: 1	تَزْيِينَ خَارِجِهِ
u'تَزْيِينٌ ظاهِرٌ':Added, #1: 1	تَزْيِينِ الشَّعْرِ
u'تَزْيِينٌ عَرُوسٌ':Added, #1: 1	تَزْيِينُ ظَاهِرِهِ
u'تَزْيِينٌ مَسَاجِدُ':Added, #1: 1	تَزْيِينَ الْعَرُوسِ
u'تَزْيِينٌ مَعْصِيَةٌ':Added, #1: 1	تَزْيِينَ الْمَسَاجِدِ
u'تَسَابُقٌ فُرْسَانٌ':Added, #1: 1	تَزْيِينِ الْمَعْصِيَةِ
u'تَسَاقُطٌ بَيِّن':Added, #1: 1	تَسَابُقُ الْفُرْسَانِ
u'تَسَاقُطٌ قُرُوشٌ':Added, #1: 1	تَسَاقُطُ الْبَيِّنَتَيْنِ
u'تَسَامَحَ أهْلٌ':Subject, #1: 1	تَسَاقُطِ الْقُرُوشِ
u'تَسَامَحَ علماء':Subject, #1: 1	تَسَامَحَ أَهْلُ
u'تَسَامَحَ عُلَمَاءُ':Subject, #1: 1	تَسَامَحَ الْعُلَمَاءُ
u'تَسَامُحٌ نَاسٌ':Added, #1: 1	تَسَامَحَ الْعُلَمَاءُ
u'تَسَاهُلٌ اِبْنٌ':Added, #1: 1	تَسَامُحِ النَّاسِ
u'تَسَاهَلَ بَعْضٌ':Subject, #1: 1	تَسَاهُلِ ابْنِ
u'تَسَاهُلٌ حاكِمٌ':Added, #1: 1	تَسَاهَلَ بَعْضُ
u'تَسَاهُلٌ غير':Added, #1: 1	تَسَاهُلِ الْحَاكِمِ
u'تَسَاهُلٌ غَيْرٌ':Added, #1: 1	تَسَاهُلِ غَيْرِهِ
u'تَسَاوَى اِبْنٌ':Subject, #1: 1	تَسَاهُلِ غَيْرِهِ
u'تَسَاوِي أَجْزَاءٌ':Added, #1: 1	تَسَاوَى ابْنُ
u'تَسَاوِي أَحْكَامٌ':Added, #4: 4	تَسَاوِي الْأَجْزَاءِ
u'تَسَاوِي أَخٌ':Added, #1: 1	تَسَاوِيَ الْأَحْكَامِ
u'تَسَاوَى إِطْلاقٌ':Subject, #1: 1	تَسَاوِي الْأَخِ
u'تَسَاوِي أَعْنَاقٌ':Added, #1: 1	تَسَاوَى إطْلَاقُ
u'تَسَاوَى أَفْرَادٌ':Subject, #1: 1	تَسَاوِي الْأَعْنَاقِ
u'تَسَاوِي أَقْدَامٌ':Added, #1: 1	تَسَاوَى أَفْرَادُ
u'تَسَاوَى أَمْرٌ':Subject, #1: 1	تَسَاوِي الْأَقْدَامِ
u'تَسَاوِي أَمْرٌ':Added, #1: 1	تَسَاوَى الْأَمْرُ
u'تَسَاوِي أَمْرٌ':Added, #1: 1	تَسَاوِي الْأَمْرِ
u'تَسَاوِي أَنْصِبَاءُ':Added, #3: 3	تَسَاوِي الْأَمْرَيْنِ
u'تَسَاوِي أهْلٌ':Added, #1: 1	تَسَاوِي الْأَنْصِبَاءِ
u'تَسَاوِي بَابٌ':Added, #1: 1	تَسَاوِي أَهْلِ
u'تَسَاوِي بَاعِثٌ':Added, #1: 1	تَسَاوِي الْبَابَيْنِ
u'تَسَاوَى بَيْعٌ':Subject, #1: 1	تَسَاوِي الْبَاعِثِ
u'تَسَاوِي تَأْثِيرٌ':Added, #1: 1	تَسَاوَى الْبَيْعُ
u'تَسَاوَى ثَمَنٌ':Subject, #1: 1	تَسَاوِي التَّأْثِيرِ
u'تَسَاوَى جَرَيان':Subject, #1: 1	تَسَاوَى الثَّمَنُ
u'تَسَاوِي حاجَةٌ':Added, #1: 1	تَسَاوَى الْجَرَيَانُ
u'تَسَاوِي حَرِيرٌ':Added, #1: 1	تَسَاوِي الْحَاجَاتِ
u'تَسَاوِي حُقوقٌ':Added, #1: 1	تَسَاوِي الْحَرِيرِ
u'تَسَاوِي حُقُوقٌ':Added, #1: 1	تَسَاوِي الْحُقُوقِ
u'تَسَاوَى حَقِيقٌ':Subject, #1: 1	تَسَاوِي الْحُقُوقِ
u'تَسَاوَى حَقِيقَةٌ':Subject, #1: 1	تَسَاوَى الْحَقِيقَةُ
u'تَسَاوِي درجة':Added, #1: 1	تَسَاوَى الْحَقِيقَةُ
u'تَسَاوِي دَرَجَةٌ':Added, #1: 1	تَسَاوِي الدَّرَجَةِ
u'تَسَاوِي دَلالَةٌ':Added, #1: 1	تَسَاوِي الدَّرَجَةِ
u'تَسَاوِي دَليلٌ':Added, #1: 1	تَسَاوِي دَلَالَتِهِ
u'تَسَاوِي دَيْنٌ':Added, #1: 1	تَسَاوِي الدَّلِيلِ
u'تَسَاوَى ذكر':Subject, #1: 1	تَسَاوِي الدَّيْنَيْنِ
u'تَسَاوَى ذَكَرٌ':Subject, #1: 1	تَسَاوَى الذَّكَرُ
u'تَسَاوَى ذَهَبٌ':Subject, #1: 1	تَسَاوَى الذَّكَرُ
u'تَسَاوِي رَجُلٌ':Added, #1: 1	تَسَاوَى الذَّهَبُ
u'تَسَاوَى رُكوبٌ':Subject, #1: 1	تَسَاوِي الرَّجُلَيْنِ
u'تَسَاوِي رِواياتٌ':Added, #1: 1	تَسَاوَى رُكُوبُهُ
u'تَسَاوَى سعر':Subject, #1: 1	تَسَاوِي الرِّوَايَاتِ
u'تَسَاوَى سِعْرٌ':Subject, #1: 1	تَسَاوَى سِعْرُ
u'تَسَاوَى شَلَلٌ':Subject, #1: 1	تَسَاوَى سِعْرُ
u'تَسَاوِي صَائِمٌ':Added, #1: 1	تَسَاوَى الشَّلَلُ
u'تَسَاوِي صُورٌ':Added, #1: 1	تَسَاوِي الصَّائِمِ
u'تَسَاوِي طَائِفٌ':Added, #1: 1	تَسَاوِي الصُّورَتَيْنِ
u'تَسَاوَى طَرَفٌ':Subject, #1: 1	تَسَاوِي الطَّائِفَتَيْنِ
u'تَسَاوِي ظَنٌّ':Added, #2: 2	تَسَاوَى طَرَفَاهُ
u'تَسَاوَى عَدَدٌ':Subject, #1: 1	تَسَاوِي الظَّنَّيْنِ
u'تَسَاوِي عَدَدٌ':Added, #2: 2	تَسَاوَى عَدَدُ
u'تَسَاوِي عِيدٌ':Added, #2: 2	تَسَاوِي الْعَدَدَيْنِ
u'تَسَاوِي غَرَضٌ':Added, #1: 1	تَسَاوِي الْعِيدَيْنِ
u'تَسَاوَى فِعْلٌ':Subject, #1: 1	تَسَاوِي الْغَرَضَيْنِ
u'تَسَاوِي فَقْرٌ':Added, #1: 1	تَسَاوَى فِعْلُهُ
u'تَسَاوَى قَمْحٌ':Subject, #1: 1	تَسَاوِي فَقْرٍ
u'تَسَاوِي قِيَاسٌ':Added, #1: 1	تَسَاوَى الْقَمْحُ
u'تَسَاوِي قِيمَةٌ':Added, #1: 1	تَسَاوِي الْقِيَاسَيْنِ
u'تَسَاوِي قِيمَةٌ':Added, #1: 1	تَسَاوِي الْقِيمَةِ
u'تَسَاوَى كِرَاءٌ':Subject, #1: 1	تَسَاوِي قِيمَةِ
u'تَسَاوِي كَيْلٌ':Added, #1: 1	تَسَاوَى الْكِرَاءُ
u'تَسَاوِي لَفْظٌ':Added, #1: 1	تَسَاوِي الْكَيْلِ
u'تَسَاوِي مُتَسَاوِي':Added, #1: 1	تَسَاوِيَ اللَّفْظَيْنِ
u'تَسَاوِي مُتَشَابِهٌ':Added, #1: 1	تَسَاوِي الْمُتَسَاوِيَاتِ
u'تَسَاوِي مُتَعارِض':Added, #1: 1	تَسَاوِيَ الْمُتَشَابِهَيْنِ
u'تَسَاوِي مُتَوَاتِرٌ':Added, #1: 1	تَسَاوِي الْمُتَعَارِضَيْنِ
u'تَسَاوِي مُحَابَاةٌ':Added, #1: 1	تَسَاوِي الْمُتَوَاتِرَيْنِ
u'تَسَاوَى مُخْتَلَفٌ':Subject, #1: 1	تَسَاوِي الْمُحَابَاةِ
u'تَسَاوِي مُقَدَّمٌ':Added, #1: 1	تَسَاوَى الْمُخْتَلَفُ
u'تَسَاوِي نِسْبَةٌ':Added, #1: 1	تَسَاوِي الْمُقَدَّمِ
u'تَسَاوِي وَاجِبٌ':Added, #1: 1	تَسَاوِي نِسْبَةِ
u'تَسَاوِي وَلَدٌ':Added, #1: 1	تَسَاوِيَ الْوَاجِبِ
u'تَسَايَلَ قَوْمٌ':Subject, #1: 1	تَسَاوِي الْوَلَدَيْنِ
u'تَسَبُّبٌ إِخْرَاجٌ':Added, #1: 1	تَسَايَلَ الْقَوْمُ
u'تَسَبَّبَ إِنْسانٌ':Subject, #1: 1	تَسَبُّبَ إخْرَاجِهِ
u'تَسَبَّبَ سَيِّدٌ':Subject, #1: 1	تَسَبَّبَ إنْسَانٌ
u'تَسْبِيحٌ أَغْنِيَاء':Added, #1: 1	تَسَبَّبَ السَّيِّدُ
u'تَسْبِيحٌ بَرْقٌ':Added, #1: 1	تَسْبِيحِ الْأَغْنِيَاءِ
u'تَسْبِيحَةٌ سُجُودٌ':Added, #1: 1	تَسْبِيحَ الْبَرْقِ
u'تَسْبِيحٌ رُكْنٌ':Added, #1: 1	تَسْبِيحَةِ السُّجُودِ
u'تَسْبِيحٌ رُكْن':Added, #1: 1	تَسْبِيحَ رُكْنٍ
u'تَسْبِيحٌ رُكوعٌ':Added, #1: 1	تَسْبِيحَ رُكْنٍ
u'تَسْبِيحٌ رُكوعٌ':Added, #1: 1	تَسْبِيحُ الرُّكُوعِ
u'تَسْبِيحٌ رُكوعٌ':Added, #2: 2	تَسْبِيحُ رُكُوعٍ
u'تَسْبِيحٌ رُكوعٌ':Added, #2: 2	تَسْبِيحِ رُكُوعٍ
u'تَسْبِيحٌ رُكوعٌ':Added, #3: 3	تَسْبِيحِ الرُّكُوعِ
u'تَسْبِيحٌ صَلاَةٌ':Added, #6: 6	تَسْبِيحَ الرُّكُوعِ
u'تَسْبِيحٌ صَلاَةٌ':Added, #1: 1	تَسْبِيحُ الصَّلَاةِ
u'تَسْبِيحٌ مَلاَئِكَةٌ':Added, #1: 1	تَسْبِيحِ الصَّلَاةِ
u'تَسْبِيحٌ مَلاَئِكَةٌ':Added, #1: 1	تَسْبِيحُ الْمَلَائِكَةِ
u'تَسْبِيحٌ مَلاَئِكَةٌ':Added, #1: 1	تَسْبِيحَ مَلَائِكَةِ
u'تَسْبِيعٌ فَمٌ':Added, #1: 1	تَسْبِيحُ مَلَائِكَةِ
u'تَسْبِيعٌ مَخْرَجٌ':Added, #1: 1	تَسْبِيعِ فَمِهِ
u'تَسْبِيلٌ مَاءٌ':Added, #1: 1	تَسْبِيعُ الْمَخْرَجِ
u'تَسْبِيلٌ مَاءٌ':Added, #1: 1	تَسْبِيلُ الْمَاءِ
u'تَسَتُّرٌ حيطانٌ':Added, #1: 1	تَسْبِيلِ مَاءٍ
u'تَسْجِيلٌ أَحْكَامٌ':Added, #2: 2	تَسَتُّرُ الْحِيطَانِ
u'تَسْخِيرٌ جِبَالٌ':Added, #1: 1	تَسْجِيلَ أَحْكَامِهِ
u'تَسْخِيرٌ جَيْشٌ':Added, #1: 1	تَسْخِيرُ الْجِبَالِ
u'تَسْخِيرٌ ريحٌ':Added, #1: 1	تَسْخِيرِ الْجَيْشِ
u'تَسْخِيرٌ قَهْرٌ':Added, #1: 1	تَسْخِيرُ الرِّيحِ
u'تَسْخِينٌ مَاءٌ':Added, #1: 1	تَسْخِيرَ الْقَهْرِ
u'تَسْخِينٌ مَاءٌ':Added, #1: 1	تَسْخِينَ الْمَاءِ
u'تَسْرِيجٌ مَسَاجِدُ':Added, #4: 4	تَسْخِينِ الْمَاءِ
u'تَسْرِيحٌ خَوَاطِرُ':Added, #1: 1	تَسْرِيجِ الْمَسَاجِدِ
u'تَسْرِيحٌ رَأْسٌ':Added, #1: 1	تَسْرِيحِ الْخَوَاطِرِ
u'تَسْرِيحٌ رَأْسٌ':Added, #1: 1	تَسْرِيحِ الرَّأْسِ
u'تَسْرِيحٌ شَعْرٌ':Added, #1: 1	تَسْرِيحَ رَأْسِ
u'تَسْرِيحٌ شَعْرٌ':Added, #1: 1	تَسْرِيحَ الشَّعْرِ
u'تَسْرِيحٌ شَعْرٌ':Added, #1: 1	تَسْرِيحُ شَعْرِ
u'تَسْرِيحٌ شَعْرٌ':Added, #1: 1	تَسْرِيحِ شَعْرِ
u'تَسْرِيحٌ شَعْرٌ':Added, #1: 1	تَسْرِيحِ شَعْرِهِ
u'تَسْرِيحٌ فَاجِرٌ':Added, #2: 2	تَسْرِيحُ الشَّعْرِ
u'تَسْرِيحٌ لِحْيَةٌ':Added, #1: 1	تَسْرِيحُ الْفَاجِرِ
u'تَسْرِيحٌ نَاظِرٌ':Added, #1: 1	تَسْرِيحِ اللِّحْيَةِ
u'تَسْطِيحٌ جَبْهَةٌ':Added, #1: 1	تَسْرِيحُ النَّاظِرِ
u'تَسْطِيرٌ سُؤَالٌ':Added, #2: 2	تَسْطِيحِ الْجَبْهَةِ
u'تَسَعَ حَشَفَةٌ':Subject, #1: 1	تَسْطِيرِ السُّؤَالِ
u'تَسْعِيرٌ إمَامٌ':Added, #1: 1	تَسَعَ حَشَفَتُهُ
u'تَسَفُّلٌ أرْضٌ':Added, #1: 1	تَسْعِيرَ الْإِمَامِ
u'تَسْكِينٌ أَخْلاَطٌ':Added, #1: 1	تَسَفُّلُ الْأَرْضِ
u'تَسْكِينٌ ثَائِرٌ':Added, #1: 1	تَسْكِينِ الْأَخْلَاطِ
u'تَسْكِينٌ جوارح':Added, #1: 1	تَسْكِينُ الثَّائِرَةِ
u'تَسْكِينٌ جَوَارِحُ':Added, #2: 2	تَسْكِينُ الْجَوَارِحِ
u'تَسْكِينٌ دَالٌ':Added, #2: 2	تَسْكِينُ الْجَوَارِحِ
u'تَسْكِينٌ ذال':Added, #1: 1	تَسْكِينِ الدَّالِ
u'تَسْكِينٌ راء':Added, #1: 1	تَسْكِينُ الذَّالِ
u'تَسْكِينٌ روع':Added, #1: 1	تَسْكِينُ الرَّاءِ
u'تَسْكِينٌ رُوعٌ':Added, #1: 1	تَسْكِينِ الرّوْعِ
u'تَسْكِينٌ رَوْعٌ':Added, #1: 1	تَسْكِينِ الرّوْعِ
u'تَسْكِينٌ شَهْوَةٌ':Added, #1: 1	تَسْكِينِ الرّوْعِ
u'تَسْكِينٌ شَيْطَانٌ':Added, #2: 2	تَسْكِينَ الشَّهْوَةِ
u'تَسْكِينٌ صَفْرَاء':Added, #1: 1	تَسْكِينُ الشَّيْطَانِ
u'تَسْكِينٌ طِبَاعٌ':Added, #1: 1	تَسْكِينُ الصَّفْرَاءِ
u'تَسْكِينٌ عَطَشٌ':Added, #1: 1	تَسْكِينِ طِبَاعِهِ
u'تَسْكِينٌ فتنة':Added, #2: 2	تَسْكِينِ الْعَطَشِ
u'تَسْكِينٌ فِتْنَةٌ':Added, #2: 2	تَسْكِينِ الْفِتْنَةِ
u'تَسْكِينٌ قلب':Added, #2: 2	تَسْكِينِ الْفِتْنَةِ
u'تَسْكِينٌ قَلْبٌ':Added, #1: 1	تَسْكِينُ قَلْبِ
u'تَسْكِينٌ قَلْب':Added, #1: 1	تَسْكِينُ قَلْبِ
u'تَسْكِينٌ لاَمٌ':Added, #1: 1	تَسْكِينُ قَلْبِ
u'تَسْكِينٌ مُتَحَرِّكٌ':Added, #1: 1	تَسْكِينَ اللّامِ
u'تَسْكِينٌ مُثَلَّثٌ':Added, #1: 1	تَسْكِينُ الْمُتَحَرِّكِ
u'تَسْكِينٌ نَفْسٌ':Added, #1: 1	تَسْكِينِ الْمُثَلَّثَةِ
u'تَسْكِينٌ نُونٌ':Added, #1: 1	تَسْكِينِ النَّفْسِ
u'تَسْكِينٌ هاء':Added, #1: 1	تَسْكِينُ النُّونِ
u'تَسَلُّطٌ أَبٌ':Added, #1: 1	تَسْكِينُ الْهَاءِ
u'تَسَلُّطٌ أَجْنَبِيٌّ':Added, #1: 1	تَسَلُّطَ الْأَبِ
u'تَسَلَّطَ شَفِيعٌ':Subject, #1: 1	تَسَلُّطِ الْأَجْنَبِيِّ
u'تَسَلُّطٌ شَفِيعٌ':Added, #1: 1	تَسَلَّطَ الشَّفِيعُ
u'تَسَلَّطَ شَيْطَانٌ':Subject, #1: 1	تَسَلُّطَ الشَّفِيعِ
u'تَسَلُّطٌ شَيْطَانٌ':Added, #3: 3	تَسَلَّطَ الشَّيْطَانُ
u'تَسَلَّطَ علم':Subject, #1: 1	تَسَلُّطِ الشَّيْطَانِ
u'تَسَلَّطَ عَلَمٌ':Subject, #1: 1	تَسَلَّطَ عَلَمُ
u'تَسَلُّطٌ غرباء':Added, #1: 1	تَسَلَّطَ عَلَمُ
u'تَسَلَّطَ غير':Subject, #1: 1	تَسَلُّطِ الْغُرَبَاءِ
u'تَسَلَّطَ غَيْرٌ':Subject, #1: 1	تَسَلَّطَ غَيْرُهُ
u'تَسَلُّطٌ غير':Added, #1: 1	تَسَلَّطَ غَيْرُهُ
u'تَسَلُّطٌ غَيْرٌ':Added, #1: 1	تَسَلُّطِ الْغَيْرِ
u'تَسَلُّطٌ كُفَّارٌ':Added, #1: 1	تَسَلُّطِ الْغَيْرِ
u'تَسَلَّطَ مَالِكٌ':Subject, #1: 1	تَسَلُّطِ الْكُفَّارِ
u'تَسَلُّطٌ مَنْعٌ':Added, #1: 1	تَسَلَّطَ الْمَالِكُ
u'تَسَلَّطَ نَفْيٌ':Subject, #1: 1	تَسَلُّطِ الْمَنْعِ
u'تَسَلُّطٌ وَرَثَةٌ':Added, #2: 2	تَسَلَّطَ النَّفْيُ
u'تَسَلَّفَ ثَمانِين':Predicate, #3: 3	تَسَلُّطِ الْوَرَثَةِ
u'تَسَلَّفَ جِيرَانٌ':Subject, #1: 1	تَسَلَّفَ ثَمَانِينَ
u'تَسَلَّفَ دَرَاهِمُ':Predicate, #1: 1	تَسَلَّفَ الْجِيرَانُ
u'تَسَلَّفَ دَنانيرُ':Predicate, #1: 1	تَسَلَّفَ دَرَاهِمَ
u'تَسَلُّفٌ صَاعٌ':Added, #2: 2	تَسَلَّفَ الدَّنَانِيرَ
u'تَسَلَّفَ صدقة':Predicate, #1: 1	تَسَلُّفِ الصَّاعِ
u'تَسَلَّفَ صَدَقَةٌ':Predicate, #2: 2	تَسَلَّفَ صَدَقَةَ
u'تَسَلُّفٌ صدقة':Added, #2: 2	تَسَلَّفَ صَدَقَةَ
u'تَسَلُّفٌ صَدَقَةٌ':Added, #1: 1	تَسَلُّفُ صَدَقَةِ
u'تَسَلَّفَ عَامِلٌ':Subject, #1: 1	تَسَلُّفُ صَدَقَةِ
u'تَسَلَّفَ عَرْضٌ':Predicate, #1: 1	تَسَلَّفَ الْعَامِلُ
u'تَسَلُّفٌ وَصِيٌّ':Added, #1: 1	تَسَلَّفَ الْعَرْضَ
u'تَسَلَّمَ أُجْرَةٌ':Predicate, #1: 1	تَسَلُّفِ الْوَصِيِّ
u'تَسَلَّمَ أرْضٌ':Predicate, #1: 1	تَسَلَّمَ الْأُجْرَةَ
u'تَسَلَّمَ الْمَرْأَةُ':Predicate, #1: 1	تَسَلَّمَ الْأَرْضَ
u'تَسَلَّمَ بَيْتٌ':Predicate, #1: 1	تَسَلَّمَ الْمَرْأَةَ
u'تَسَلُّمٌ ثَمَرَةٌ':Added, #1: 1	تَسَلَّمَ الْبَيْتَ
u'تَسَلُّمٌ ثَمَنٌ':Added, #1: 1	تَسَلُّمِ الثَّمَرَةِ
u'تَسَلُّمٌ جَمَّالٌ':Added, #1: 1	تَسَلُّمِ الثَّمَنِ
u'تَسَلَّمَ دِيوانٌ':Predicate, #1: 1	تَسَلُّمِ الْجَمَّالَةِ
u'تَسَلُّمٌ رَقَبَةٌ':Added, #1: 1	تَسَلَّمَ دِيوَانَ
u'تَسَلُّمٌ زَوْجٌ':Added, #1: 1	تَسَلُّمُ رَقَبَتِهِ
u'تَسَلُّمٌ شَفِيعٌ':Added, #1: 1	تَسَلُّمُ الزَّوْجِ
u'تَسَلُّمٌ عِوَضٌ':Added, #1: 1	تَسَلُّمُ الشَّفِيعِ
u'تَسَلَّمَ عين':Predicate, #1: 1	تَسَلُّمِ الْعِوَضِ
u'تَسَلَّمَ عَيْنٌ':Predicate, #1: 1	تَسَلَّمَ الْعَيْنَ
u'تَسَلَّمَ عَيْن':Predicate, #1: 1	تَسَلَّمَ الْعَيْنَ
u'تَسَلُّمٌ مَالٌ':Added, #1: 1	تَسَلَّمَ الْعَيْنَ
u'تَسَلُّمٌ مَبِيعٌ':Added, #1: 1	تَسَلُّمَ الْمَالِ
u'تَسَلَّمَ مُسْتَأْجِرٌ':Subject, #1: 1	تَسَلُّمِ الْمَبِيعِ
u'تَسَلُّمٌ مَكْفُولٌ':Added, #1: 1	تَسَلَّمَ الْمُسْتَأْجِرُ
u'تَسَلَّمَ نَاظِرٌ':Subject, #1: 1	تَسَلُّمِ الْمَكْفُولِ
u'تَسْلِيَةٌ مَرِيضٌ':Added, #1: 1	تَسَلَّمَ النَّاظِرُ
u'تَسْلِيَةٌ نَفْسٌ':Added, #1: 1	تَسْلِيَةِ الْمَرِيضِ
u'تَسْلِيطٌ إمَامٌ':Added, #1: 1	تَسْلِيَةِ النَّفْسِ
u'تَسْلِيطٌ بَائِعٌ':Added, #1: 1	تَسْلِيطُ الْإِمَامِ
u'تَسْلِيطٌ جِنٌّ':Added, #1: 1	تَسْلِيطِ الْبَائِعِ
u'تَسْلِيطٌ زَوْجٌ':Added, #1: 1	تَسْلِيطِ الْجِنِّ
u'تَسْلِيطٌ شَفِيعٌ':Added, #1: 1	تَسْلِيطُ الزَّوْجِ
u'تَسْلِيطٌ عَامِلٌ':Added, #1: 1	تَسْلِيطُ الشَّفِيعِ
u'تَسْلِيطٌ عَدْلٌ':Added, #1: 1	تَسْلِيطُ الْعَامِلِ
u'تَسْلِيطٌ عَدُوٌّ':Added, #1: 1	تَسْلِيطِ الْعَدْلِ
u'تَسْلِيطٌ غير':Added, #1: 1	تَسْلِيطُ الْعَدُوِّ
u'تَسْلِيطٌ غَيْرٌ':Added, #1: 1	تَسْلِيطِ الْغَيْرِ
u'تَسْلِيطٌ غير':Added, #1: 1	تَسْلِيطِ الْغَيْرِ
u'تَسْلِيطٌ غَيْرٌ':Added, #1: 1	تَسْلِيطَ غَيْرِهِ
u'تَسْلِيطٌ غير':Added, #1: 1	تَسْلِيطَ غَيْرِهِ
u'تَسْلِيطٌ غَيْرٌ':Added, #2: 2	تَسْلِيطُ الْغَيْرِ
u'تَسْلِيطٌ كَافِرٌ':Added, #2: 2	تَسْلِيطُ الْغَيْرِ
u'تَسْلِيطٌ مَالِكٌ':Added, #1: 1	تَسْلِيطِ الْكَافِرِ
u'تَسْلِيطٌ مُمَيَّزٌ':Added, #1: 1	تَسْلِيطِ الْمَالِكِ
u'تَسْلِيطٌ نَبِيٌّ':Added, #1: 1	تَسْلِيطَ الْمُمَيَّزِ
u'تَسْلِيطٌ نَظَرٌ':Added, #1: 1	تَسْلِيطَ النَّبِيِّ
u'تَسْلِيطٌ وَكِيلٌ':Added, #1: 1	تَسْلِيطِ نَظَرِهِ
u'تَسْلِيطٌ وَلِيٌّ':Added, #1: 1	تَسْلِيطِ وَكِيلِ
u'تَسْلِيمٌ أَبٌ':Added, #1: 1	تَسْلِيطَ الْوَلِيِّ
u'تَسْلِيمٌ أَبٌ':Added, #1: 1	تَسْلِيمُ الْأَبِ
u'تَسْلِيمٌ اِبْنٌ':Added, #1: 1	تَسْلِيمِ الْأَبِ
u'تَسْلِيمٌ اِبْنَة':Added, #1: 1	تَسْلِيمَ ابْنِ
u'تَسْلِيمٌ إجَارَةٌ':Added, #1: 1	تَسْلِيمِ ابْنَتِهِ
u'تَسْلِيمٌ أَجْرٌ':Added, #1: 1	تَسْلِيمِ الْإِجَارَةِ
u'تَسْلِيمٌ أُجْرَةٌ':Added, #3: 3	تَسْلِيمِ الْأَجْرِ
u'تَسْلِيمٌ أُجْرَةٌ':Added, #1: 1	تَسْلِيمُ أُجْرَةِ
u'تَسْلِيمٌ أُجْرَةٌ':Added, #2: 2	تَسْلِيمَ الْأُجْرَةِ
u'تَسْلِيمٌ أُجْرَةٌ':Added, #3: 3	تَسْلِيمِ الْأُجْرَةِ
u'تَسْلِيمٌ أَجِيرٌ':Added, #4: 4	تَسْلِيمُ الْأُجْرَةِ
u'تَسْلِيمٌ أحَدٌ':Added, #1: 1	تَسْلِيمِ الْأَجِيرِ
u'تَسْلِيمٌ إِرَادَةٌ':Added, #3: 3	تَسْلِيمُ أَحَدِ
u'تَسْلِيمٌ أرْضٌ':Added, #2: 2	تَسْلِيمِ إرَادَةِ
u'تَسْلِيمٌ اِعْتِمادٌ':Added, #1: 1	تَسْلِيمُ الْأَرْضِ
u'تَسْلِيمٌ ألف':Added, #1: 1	تَسْلِيمِ اعْتِمَادِ
u'تَسْلِيمٌ ألْفٌ':Added, #1: 1	تَسْلِيمِ الْأَلْفِ
u'تَسْلِيمٌ أَلْفٌ':Added, #1: 1	تَسْلِيمِ الْأَلْفِ
u'تَسْلِيمٌ الْمَرْأَةُ':Added, #1: 1	تَسْلِيمِ الْأَلْفِ
u'تَسْلِيمٌ الْمَرْأَةُ':Added, #1: 1	تَسْلِيمَ الْمَرْأَةِ
u'تَسْلِيمٌ الْمَرْأَةُ':Added, #1: 1	تَسْلِيمِ الْمَرْأَةِ
u'تَسْلِيمٌ إمَامٌ':Added, #3: 3	تَسْلِيمُ الْمَرْأَةِ
u'تَسْلِيمٌ إمَامٌ':Added, #1: 1	تَسْلِيمَ الْإِمَامِ
u'تَسْلِيمٌ أمَانَةٌ':Added, #5: 5	تَسْلِيمِ الْإِمَامِ
u'تَسْلِيمٌ أَمْرٌ':Added, #3: 3	تَسْلِيمُ الْأَمَانَةِ
u'تَسْلِيمٌ أَمْرٌ':Added, #1: 1	تَسْلِيمَ الْأَمْرِ
u'تَسْلِيمٌ أَمْوَالٌ':Added, #2: 2	تَسْلِيمُ الْأَمْرِ
u'تَسْلِيمٌ إِناءٌ':Added, #1: 1	تَسْلِيمُ الْأَمْوَالِ
u'تَسْلِيمٌ إِناءٌ':Added, #1: 1	تَسْلِيمُ الْإِنَاءِ
u'تَسْلِيمٌ أَوَّلُ':Added, #1: 1	تَسْلِيمِ الْإِنَاءِ
u'تَسْلِيمٌ إيرَادٌ':Added, #1: 1	تَسْلِيمَ الْأَوَّلِ
u'تَسْلِيمٌ بَائِعٌ':Added, #1: 1	تَسْلِيمُ الْإِيرَادِ
u'تَسْلِيمٌ بَائِعٌ':Added, #1: 1	تَسْلِيمُ الْبَائِعِ
u'تَسْلِيمٌ بَائِعٌ':Added, #1: 1	تَسْلِيمُ بَائِعِ
u'تَسْلِيمٌ بَدَلٌ':Added, #1: 1	تَسْلِيمِ بَائِعٍ
u'تَسْلِيمٌ بَدَلٌ':Added, #10: 10	تَسْلِيمِ الْبَدَلِ
u'تَسْلِيمٌ بَدَلٌ':Added, #1: 1	تَسْلِيمَ بَدَلِ
u'تَسْلِيمٌ بُعْدٌ':Added, #3: 3	تَسْلِيمُ الْبَدَلِ
u'تَسْلِيمٌ بَعْضٌ':Added, #1: 1	تَسْلِيمِ بُعْدِ
u'تَسْلِيمٌ بَعْضٌ':Added, #1: 1	تَسْلِيمَ بَعْضٍ
u'تَسْلِيمٌ بَقَرٌ':Added, #3: 3	تَسْلِيمِ بَعْضِ
u'تَسْلِيمٌ بِئْرٌ':Added, #1: 1	تَسْلِيمَ الْبَقَرَةِ
u'تَسْلِيمٌ بَيْعٌ':Added, #1: 1	تَسْلِيمُ بِئْرِ
u'تَسْلِيمٌ تَأْثِيرٌ':Added, #1: 1	تَسْلِيمُ الْبَيْعِ
u'تَسْلِيمٌ تَحْقِيقٌ':Added, #1: 1	تَسْلِيمِ تَأْثِيرِهِ
u'تَسْلِيمٌ تَحْلِيلٌ':Added, #1: 1	تَسْلِيمَ تَحْقِيقِ
u'تَسْلِيمٌ تَرِكَةٌ':Added, #1: 1	تَسْلِيمَ التَّحْلِيلِ
u'تَسْلِيمٌ تِسْعَةٌ':Added, #1: 1	تَسْلِيمِ التَّرِكَةِ
u'تَسْلِيمٌ تَعْلِيلٌ':Added, #1: 1	تَسْلِيمُ تِسْعَةٍ
u'تَسْلِيمٌ تَفاوُت':Added, #1: 1	تَسْلِيمِ التَّعْلِيلِ
u'تَسْلِيمٌ تَقْليلٌ':Added, #1: 1	تَسْلِيمُ التَّفَاوُتِ
u'تَسْلِيمٌ تمام':Added, #1: 1	تَسْلِيمِ تَقْلِيلِ
u'تَسْلِيمٌ تَمامٌ':Added, #1: 1	تَسْلِيمُ تَمَامِ
u'تَسْلِيمٌ تَوَجُّهٌ':Added, #1: 1	تَسْلِيمُ تَمَامِ
u'تَسْلِيمٌ ثِمارٌ':Added, #1: 1	تَسْلِيمِ تَوَجُّهِ
u'تَسْلِيمٌ ثَمَرَةٌ':Added, #1: 1	تَسْلِيمُ ثِمَارِ
u'تَسْلِيمٌ ثَمَنٌ':Added, #1: 1	تَسْلِيمَ الثَّمَرَةِ
u'تَسْلِيمٌ ثَمَنٌ':Added, #1: 1	تَسْلِيمَ ثَمَنِ
u'تَسْلِيمٌ ثَمَنٌ':Added, #2: 2	تَسْلِيمَ ثَمَنِهِ
u'تَسْلِيمٌ ثَمَنٌ':Added, #35: 35	تَسْلِيمِ الثَّمَنِ
u'تَسْلِيمٌ ثَمَنٌ':Added, #3: 3	تَسْلِيمِ ثَمَنِهِ
u'تَسْلِيمٌ ثَمَنٌ':Added, #6: 6	تَسْلِيمَ الثَّمَنِ
u'تَسْلِيمٌ ثَوْبٌ':Added, #9: 9	تَسْلِيمُ الثَّمَنِ
u'تَسْلِيمٌ ثِيابٌ':Added, #2: 2	تَسْلِيمُ الثَّوْبِ
u'تَسْلِيمٌ ثِيابٌ':Added, #1: 1	تَسْلِيمُ الثِّيَابِ
u'تَسْلِيمٌ جَارِي':Added, #2: 2	تَسْلِيمِ الثِّيَابِ
u'تَسْلِيمٌ جَارِي':Added, #1: 1	تَسْلِيمُ الْجَارِيَةِ
u'تَسْلِيمٌ جَارِيَةٌ':Added, #1: 1	تَسْلِيمِ الْجَارِيَةِ
u'تَسْلِيمٌ جَارِيَةٌ':Added, #1: 1	تَسْلِيمُ الْجَارِيَةِ
u'تَسْلِيمٌ جَديدٌ':Added, #1: 1	تَسْلِيمِ الْجَارِيَةِ
u'تَسْلِيمٌ جُزْءٌ':Added, #1: 1	تَسْلِيمٍ جَدِيدٍ
u'تَسْلِيمٌ جَمَّالٌ':Added, #1: 1	تَسْلِيمَ الْجُزْءِ
u'تَسْلِيمٌ جَمِيع':Added, #1: 1	تَسْلِيمِ الْجَمَّالَةِ
u'تَسْلِيمٌ جَيِّدٌ':Added, #1: 1	تَسْلِيمُ الْجَمِيعِ
u'تَسْلِيمٌ جَيِّدٌ':Added, #1: 1	تَسْلِيمُ الْجَيِّدِ
u'تَسْلِيمٌ حِجارَةٌ':Added, #2: 2	تَسْلِيمِ الْجَيِّدِ
u'تَسْلِيمٌ حُرٌّ':Added, #1: 1	تَسْلِيمَ الْحِجَارَةِ
u'تَسْلِيمٌ حُرٌّ':Added, #1: 1	تَسْلِيمُ الْحُرَّةِ
u'تَسْلِيمٌ حَرائِرُ':Added, #1: 1	تَسْلِيمِ الْحُرَّةِ
u'تَسْلِيمٌ حَرَائِرُ':Added, #1: 1	تَسْلِيمَ الْحَرَائِرِ
u'تَسْلِيمٌ حُرْمَةٌ':Added, #1: 1	تَسْلِيمَ الْحَرَائِرِ
u'تَسْلِيمٌ حزام':Added, #1: 1	تَسْلِيمِ الْحُرْمَةِ
u'تَسْلِيمٌ حِزَامٌ':Added, #1: 1	تَسْلِيمُ الْحِزَامِ
u'تَسْلِيمٌ حَسَنٌ':Added, #1: 1	تَسْلِيمُ الْحِزَامِ
u'تَسْلِيمٌ حِصَّةٌ':Added, #1: 1	تَسْلِيمِ الْحَسَنِ
u'تَسْلِيمٌ حِصَّةٌ':Added, #1: 1	تَسْلِيمُ حِصَّتِهِ
u'تَسْلِيمٌ حِصَّةٌ':Added, #2: 2	تَسْلِيمُ حِصَّةِ
u'تَسْلِيمٌ حَقٌّ':Added, #2: 2	تَسْلِيمِ حِصَّةِ
u'تَسْلِيمٌ حِكَايَةٌ':Added, #1: 1	تَسْلِيمُ الْحَقِّ
u'تَسْلِيمٌ حُكْمٌ':Added, #1: 1	تَسْلِيمِ حِكَايَةِ
u'تَسْلِيمٌ حُكْمٌ':Added, #1: 1	تَسْلِيمَ حُكْمِ
u'تَسْلِيمٌ حُكْمٌ':Added, #1: 1	تَسْلِيمِ حُكْمِ
u'تَسْلِيمٌ خدمة':Added, #3: 3	تَسْلِيمِ الْحُكْمِ
u'تَسْلِيمٌ خِدْمَةٌ':Added, #1: 1	تَسْلِيمِ الْخِدْمَةِ
u'تَسْلِيمٌ خدمة':Added, #1: 1	تَسْلِيمِ الْخِدْمَةِ
u'تَسْلِيمٌ خِدْمَةٌ':Added, #1: 1	تَسْلِيمُ خِدْمَتِهِ
u'تَسْلِيمٌ خَطِيبٌ':Added, #1: 1	تَسْلِيمُ خِدْمَتِهِ
u'تَسْلِيمٌ خَمْرٌ':Added, #1: 1	تَسْلِيمِ الْخَطِيبِ
u'تَسْلِيمٌ خَمْرٌ':Added, #2: 2	تَسْلِيمُ الْخَمْرِ
u'تَسْلِيمٌ دَابَّةٌ':Added, #3: 3	تَسْلِيمِ الْخَمْرِ
u'تَسْلِيمٌ دَابَّةٌ':Added, #1: 1	تَسْلِيمَ الدَّابَّةِ
u'تَسْلِيمٌ دَابَّةٌ':Added, #1: 1	تَسْلِيمِ دَابَّةِ
u'تَسْلِيمٌ دَابَّةٌ':Added, #3: 3	تَسْلِيمُ الدَّابَّةِ
u'تَسْلِيمٌ دَارٌ':Added, #3: 3	تَسْلِيمِ الدَّابَّةِ
u'تَسْلِيمٌ دَارٌ':Added, #1: 1	تَسْلِيمُ دَارٍ
u'تَسْلِيمٌ دَارٌ':Added, #3: 3	تَسْلِيمِ الدَّارِ
u'تَسْلِيمٌ دَارٌ':Added, #5: 5	تَسْلِيمَ الدَّارِ
u'تَسْلِيمٌ دَلالَةٌ':Added, #6: 6	تَسْلِيمُ الدَّارِ
u'تَسْلِيمٌ دَليلٌ':Added, #1: 1	تَسْلِيمِ دَلَالَتِهِ
u'تَسْلِيمٌ دَليلٌ':Added, #1: 1	تَسْلِيمُ الدَّلِيلِ
u'تَسْلِيمٌ دَليلٌ':Added, #1: 1	تَسْلِيمُ دَلِيلِ
u'تَسْلِيمٌ دِيَةٌ':Added, #2: 2	تَسْلِيمِ الدَّلِيلِ
u'تَسْلِيمٌ دِيَةٌ':Added, #1: 1	تَسْلِيمُ الدِّيَةِ
u'تَسْلِيمٌ دَيْنٌ':Added, #2: 2	تَسْلِيمِ الدِّيَةِ
u'تَسْلِيمٌ دَيْنٌ':Added, #1: 1	تَسْلِيمَ الدَّيْنِ
u'تَسْلِيمٌ دِينارٌ':Added, #1: 1	تَسْلِيمِ الدَّيْنِ
u'تَسْلِيمٌ رَأْسٌ':Added, #1: 1	تَسْلِيمُ دِينَارٍ
u'تَسْلِيمٌ رَأْسٌ':Added, #2: 2	تَسْلِيمَ رَأْسِ
u'تَسْلِيمٌ رَأْسٌ':Added, #3: 3	تَسْلِيمِ رَأْسِ
u'تَسْلِيمٌ رَاكِبٌ':Added, #5: 5	تَسْلِيمُ رَأْسِ
u'تَسْلِيمٌ رَاهِنٌ':Added, #1: 1	تَسْلِيمِ الرَّاكِبِ
u'تَسْلِيمٌ رُبْعٌ':Added, #1: 1	تَسْلِيمِ الرَّاهِنِ
u'تَسْلِيمٌ رَسُولٌ':Added, #1: 1	تَسْلِيمِ رُبْعِهِ
u'تَسْلِيمٌ رَقَبَةٌ':Added, #1: 1	تَسْلِيمَ رَسُولِ
u'تَسْلِيمٌ رَقَبَةٌ':Added, #1: 1	تَسْلِيمِ الرَّقَبَةِ
u'تَسْلِيمٌ رَقَبَةٌ':Added, #1: 1	تَسْلِيمَ رَقَبَةِ
u'تَسْلِيمٌ رَهْنٌ':Added, #3: 3	تَسْلِيمَ رَقَبَتِهِ
u'تَسْلِيمٌ رَهْنٌ':Added, #1: 1	تَسْلِيمَ الرَّهْنِ
u'تَسْلِيمٌ زَرْعٌ':Added, #7: 7	تَسْلِيمِ الرَّهْنِ
u'تَسْلِيمٌ زَوْجٌ':Added, #1: 1	تَسْلِيمِ الزَّرْعِ
u'تَسْلِيمٌ زَوْجَةٌ':Added, #1: 1	تَسْلِيمُ الزَّوْجِ
u'تَسْلِيمٌ زَوْجَةٌ':Added, #1: 1	تَسْلِيمَ الزَّوْجَةِ
u'تَسْلِيمٌ زَوْجَةٌ':Added, #1: 1	تَسْلِيمَ زَوْجَتِهِ
u'تَسْلِيمٌ سَاحَةٌ':Added, #2: 2	تَسْلِيمُ الزَّوْجَةِ
u'تَسْلِيمٌ سائِل':Added, #1: 1	تَسْلِيمِ السَّاحَةِ
u'تَسْلِيمٌ سَائِلٌ':Added, #1: 1	تَسْلِيمُ السَّائِلِ
u'تَسْلِيمٌ سِلْعَةٌ':Added, #1: 1	تَسْلِيمُ السَّائِلِ
u'تَسْلِيمٌ شَجَرٌ':Added, #1: 1	تَسْلِيمِ السِّلْعَةِ
u'تَسْلِيمٌ شفعة':Added, #1: 1	تَسْلِيمُ الشَّجَرِ
u'تَسْلِيمٌ شُفْعَةٌ':Added, #10: 10	تَسْلِيمَ الشُّفْعَةِ
u'تَسْلِيمٌ شفعة':Added, #10: 10	تَسْلِيمَ الشُّفْعَةِ
u'تَسْلِيمٌ شُفْعَةٌ':Added, #1: 1	تَسْلِيمَ شُفْعَةِ
u'تَسْلِيمٌ شفعة':Added, #1: 1	تَسْلِيمَ شُفْعَةِ
u'تَسْلِيمٌ شُفْعَةٌ':Added, #1: 1	تَسْلِيمَ شُفْعَتِهِ
u'تَسْلِيمٌ شفعة':Added, #1: 1	تَسْلِيمَ شُفْعَتِهِ
u'تَسْلِيمٌ شُفْعَةٌ':Added, #7: 7	تَسْلِيمُ الشُّفْعَةِ
u'تَسْلِيمٌ شفعة':Added, #7: 7	تَسْلِيمُ الشُّفْعَةِ
u'تَسْلِيمٌ شُفْعَةٌ':Added, #8: 8	تَسْلِيمِ الشُّفْعَةِ
u'تَسْلِيمٌ شَفِيعٌ':Added, #8: 8	تَسْلِيمِ الشُّفْعَةِ
u'تَسْلِيمٌ شَيْءٌ':Added, #1: 1	تَسْلِيمِ الشَّفِيعِ
u'تَسْلِيمٌ شَيْءٌ':Added, #1: 1	تَسْلِيمَ شَيْءٍ
u'تَسْلِيمٌ صِحَّةٌ':Added, #8: 8	تَسْلِيمُ شَيْءٍ
u'تَسْلِيمٌ صِحَّةٌ':Added, #1: 1	تَسْلِيمَ الصِّحَّةِ
u'تَسْلِيمٌ صِحَّةٌ':Added, #1: 1	تَسْلِيمِ الصِّحَّةِ
u'تَسْلِيمٌ صِحَّةٌ':Added, #1: 1	تَسْلِيمِ صِحَّةِ
u'تَسْلِيمٌ صداق':Added, #3: 3	تَسْلِيمِ صِحَّتِهِ
u'تَسْلِيمٌ صَدَاقٌ':Added, #1: 1	تَسْلِيمُ الصَّدَاقِ
u'تَسْلِيمٌ صداق':Added, #1: 1	تَسْلِيمُ الصَّدَاقِ
u'تَسْلِيمٌ صَدَاقٌ':Added, #5: 5	تَسْلِيمِ الصَّدَاقِ
u'تَسْلِيمٌ صَوَابٌ':Added, #5: 5	تَسْلِيمِ الصَّدَاقِ
u'تَسْلِيمٌ صُوفٌ':Added, #1: 1	تَسْلِيمِ الصَّوَابِ
u'تَسْلِيمٌ ضَيْعَةٌ':Added, #2: 2	تَسْلِيمَ الصُّوفِ
u'تَسْلِيمٌ ظاهِرٌ':Added, #1: 1	تَسْلِيمِ الضَّيْعَةِ
u'تَسْلِيمٌ ظُهورٌ':Added, #1: 1	تَسْلِيمِ ظَاهِرِ
u'تَسْلِيمٌ عَبْدٌ':Added, #1: 1	تَسْلِيمِ ظُهُورِ
u'تَسْلِيمٌ عَبْدٌ':Added, #2: 2	تَسْلِيمُ الْعَبْدِ
u'تَسْلِيمٌ عَدَمٌ':Added, #4: 4	تَسْلِيمِ الْعَبْدِ
u'تَسْلِيمٌ عُرُوضٌ':Added, #1: 1	تَسْلِيمِ عَدَمِ
u'تَسْلِيمٌ عُقُولٌ':Added, #1: 1	تَسْلِيمُ الْعُرُوضِ
u'تَسْلِيمٌ عَمَلٌ':Added, #1: 1	تَسْلِيمُ الْعُقُولِ
u'تَسْلِيمٌ عِوَضٌ':Added, #4: 4	تَسْلِيمِ الْعَمَلِ
u'تَسْلِيمٌ عِوَضٌ':Added, #1: 1	تَسْلِيمَ الْعِوَضِ
u'تَسْلِيمٌ عِوَضٌ':Added, #1: 1	تَسْلِيمُ الْعِوَضَيْنِ
u'تَسْلِيمٌ عِوَضٌ':Added, #1: 1	تَسْلِيمُ عِوَضِهِ
u'تَسْلِيمٌ عين':Added, #2: 2	تَسْلِيمُ الْعِوَضِ
u'تَسْلِيمٌ عَيْنٌ':Added, #10: 10	تَسْلِيمِ الْعَيْنِ
u'تَسْلِيمٌ عَيْن':Added, #10: 10	تَسْلِيمِ الْعَيْنِ
u'تَسْلِيمٌ عين':Added, #10: 10	تَسْلِيمِ الْعَيْنِ
u'تَسْلِيمٌ عَيْنٌ':Added, #14: 14	تَسْلِيمُ الْعَيْنِ
u'تَسْلِيمٌ عَيْن':Added, #14: 14	تَسْلِيمُ الْعَيْنِ
u'تَسْلِيمٌ عين':Added, #14: 14	تَسْلِيمُ الْعَيْنِ
u'تَسْلِيمٌ عَيْنٌ':Added, #1: 1	تَسْلِيمِ عَيْنِ
u'تَسْلِيمٌ عَيْنٌ':Added, #1: 1	تَسْلِيمِ عَيْنٍ
u'تَسْلِيمٌ عَيْن':Added, #1: 1	تَسْلِيمِ عَيْنِ
u'تَسْلِيمٌ عَيْن':Added, #1: 1	تَسْلِيمِ عَيْنٍ
u'تَسْلِيمٌ عين':Added, #1: 1	تَسْلِيمِ عَيْنِ
u'تَسْلِيمٌ عَيْنٌ':Added, #2: 2	تَسْلِيمَ عَيْنِ
u'تَسْلِيمٌ عَيْن':Added, #2: 2	تَسْلِيمَ عَيْنِ
u'تَسْلِيمٌ عين':Added, #2: 2	تَسْلِيمَ عَيْنِ
u'تَسْلِيمٌ عَيْنٌ':Added, #3: 3	تَسْلِيمَ الْعَيْنِ
u'تَسْلِيمٌ عَيْن':Added, #3: 3	تَسْلِيمَ الْعَيْنِ
u'تَسْلِيمٌ عين':Added, #3: 3	تَسْلِيمَ الْعَيْنِ
u'تَسْلِيمٌ عَيْنٌ':Added, #3: 3	تَسْلِيمُ عَيْنِ
u'تَسْلِيمٌ عَيْنٌ':Added, #3: 3	تَسْلِيمَ عَيْنٍ
u'تَسْلِيمٌ عَيْن':Added, #3: 3	تَسْلِيمُ عَيْنِ
u'تَسْلِيمٌ عَيْن':Added, #3: 3	تَسْلِيمَ عَيْنٍ
u'تَسْلِيمٌ عين':Added, #3: 3	تَسْلِيمُ عَيْنِ
u'تَسْلِيمٌ عَيْنٌ':Added, #8: 8	تَسْلِيمُ عَيْنِهِ
u'تَسْلِيمٌ عَيْن':Added, #8: 8	تَسْلِيمُ عَيْنِهِ
u'تَسْلِيمٌ غَزَالٌ':Added, #8: 8	تَسْلِيمُ عَيْنِهِ
u'تَسْلِيمٌ غَلَّةٌ':Added, #1: 1	تَسْلِيمُ الْغَزَالَةِ
u'تَسْلِيمٌ غير':Added, #1: 1	تَسْلِيمُ غَلَّتِهِ
u'تَسْلِيمٌ غَيْرٌ':Added, #1: 1	تَسْلِيمَ غَيْرِ
u'تَسْلِيمٌ فَرَسٌ':Added, #1: 1	تَسْلِيمَ غَيْرِ
u'تَسْلِيمٌ فَرْضٌ':Added, #1: 1	تَسْلِيمَ الْفَرَسِ
u'تَسْلِيمٌ فساد':Added, #1: 1	تَسْلِيمِ فَرْضِ
u'تَسْلِيمٌ فَسَادٌ':Added, #1: 1	تَسْلِيمِ فَسَادِ
u'تَسْلِيمٌ قَاعِدٌ':Added, #1: 1	تَسْلِيمِ فَسَادِ
u'تَسْلِيمٌ قَبْضٌ':Added, #1: 1	تَسْلِيمِ قَاعِدَةِ
u'تَسْلِيمٌ قِسْطٌ':Added, #1: 1	تَسْلِيمُ قَبْضِ
u'تَسْلِيمٌ قَفِيز':Added, #2: 2	تَسْلِيمُ قِسْطِهِ
u'تَسْلِيمٌ قَوَد':Added, #1: 1	تَسْلِيمُ قَفِيزٍ
u'تَسْلِيمٌ قِيَاسٌ':Added, #1: 1	تَسْلِيمِ الْقَوَدِ
u'تَسْلِيمٌ قِيمَةٌ':Added, #1: 1	تَسْلِيمِ الْقِيَاسِ
u'تَسْلِيمٌ قِيمَةٌ':Added, #1: 1	تَسْلِيمُ الْقِيمَةِ
u'تَسْلِيمٌ قِيمَةٌ':Added, #2: 2	تَسْلِيمِ الْقِيمَةِ
u'تَسْلِيمٌ كِتَابٌ':Added, #5: 5	تَسْلِيمُ قِيمَتِهِ
u'تَسْلِيمٌ كَوْنٌ':Added, #1: 1	تَسْلِيمُ كِتَابِ
u'تَسْلِيمٌ كَوْنٌ':Added, #4: 4	تَسْلِيمِ كَوْنِ
u'تَسْلِيمٌ لُزُومٌ':Added, #5: 5	تَسْلِيمِ كَوْنِهِ
u'تَسْلِيمٌ مَالٌ':Added, #2: 2	تَسْلِيمِ اللُّزُومِ
u'تَسْلِيمٌ مَالٌ':Added, #1: 1	تَسْلِيمُ الْمَالَيْنِ
u'تَسْلِيمٌ مَالٌ':Added, #1: 1	تَسْلِيمِ مَالٍ
u'تَسْلِيمٌ مَالٌ':Added, #1: 1	تَسْلِيمَ مَالِهِ
u'تَسْلِيمٌ مَالٌ':Added, #1: 1	تَسْلِيمِ مَالِهِ
u'تَسْلِيمٌ مَالٌ':Added, #3: 3	تَسْلِيمَ الْمَالِ
u'تَسْلِيمٌ مَالٌ':Added, #3: 3	تَسْلِيمِ الْمَالِ
u'تَسْلِيمٌ مَالِكٌ':Added, #5: 5	تَسْلِيمُ الْمَالِ
u'تَسْلِيمٌ مَبِيعٌ':Added, #1: 1	تَسْلِيمِ الْمَالِكِ
u'تَسْلِيمٌ مَبِيعٌ':Added, #14: 14	تَسْلِيمَ الْمَبِيعِ
u'تَسْلِيمٌ مَبِيعٌ':Added, #15: 15	تَسْلِيمُ الْمَبِيعِ
u'تَسْلِيمٌ مثل':Added, #38: 38	تَسْلِيمِ الْمَبِيعِ
u'تَسْلِيمٌ مِثْلٌ':Added, #1: 1	تَسْلِيمَ الْمِثْلِ
u'تَسْلِيمٌ مثل':Added, #1: 1	تَسْلِيمَ الْمِثْلِ
u'تَسْلِيمٌ مِثْلٌ':Added, #1: 1	تَسْلِيمِ مِثْلِ
u'تَسْلِيمٌ مثل':Added, #1: 1	تَسْلِيمِ مِثْلِ
u'تَسْلِيمٌ مِثْلٌ':Added, #2: 2	تَسْلِيمُ مِثْلِ
u'تَسْلِيمٌ مَجَازٌ':Added, #2: 2	تَسْلِيمُ مِثْلِ
u'تَسْلِيمٌ مَجْهُولٌ':Added, #1: 1	تَسْلِيمِ الْمَجَازَيْنِ
u'تَسْلِيمٌ مَحَلٌّ':Added, #1: 1	تَسْلِيمِ الْمَجْهُولِ
u'تَسْلِيمٌ مَحَلٌّ':Added, #1: 1	تَسْلِيمُ الْمَحَلِّ
u'تَسْلِيمٌ مُخاصِم':Added, #3: 3	تَسْلِيمَ الْمَحَلِّ
u'تَسْلِيمٌ مَدْلُولٌ':Added, #1: 1	تَسْلِيمِ الْمُخَاصِمِ
u'تَسْلِيمٌ مَرْهُونٌ':Added, #1: 1	تَسْلِيمُ مَدْلُولِ
u'تَسْلِيمٌ مَرِيضٌ':Added, #1: 1	تَسْلِيمِ الْمَرْهُونِ
u'تَسْلِيمٌ مَرِيضٌ':Added, #1: 1	تَسْلِيمُ الْمَرِيضَةِ
u'تَسْلِيمٌ مُسْتَأْجِرٌ':Added, #1: 1	تَسْلِيمِ الْمَرِيضَةِ
u'تَسْلِيمٌ مُسْتَأْجِرٌ':Added, #1: 1	تَسْلِيمُ الْمُسْتَأْجِرِ
u'تَسْلِيمٌ مُسَلَّمٌ':Added, #1: 1	تَسْلِيمِ الْمُسْتَأْجِرِ
u'تَسْلِيمٌ مُسَلَّمٌ':Added, #1: 1	تَسْلِيمُ الْمُسَلَّمِ
u'تَسْلِيمٌ مُشَارَكَةٌ':Added, #1: 1	تَسْلِيمِ الْمُسَلَّمِ
u'تَسْلِيمٌ مُشاعٌ':Added, #1: 1	تَسْلِيمِ الْمُشَارَكَةِ
u'تَسْلِيمٌ مُشاعٌ':Added, #1: 1	تَسْلِيمُ الْمُشَاعِ
u'تَسْلِيمٌ مَطْلُوبٌ':Added, #3: 3	تَسْلِيمَ الْمُشَاعِ
u'تَسْلِيمٌ مَعْقُودٌ':Added, #2: 2	تَسْلِيمُ الْمَطْلُوبِ
u'تَسْلِيمٌ مَعْقُودٌ':Added, #12: 12	تَسْلِيمُ الْمَعْقُودِ
u'تَسْلِيمٌ مَعْقُودٌ':Added, #8: 8	تَسْلِيمَ الْمَعْقُودِ
u'تَسْلِيمٌ مُعَوَّضٌ':Added, #9: 9	تَسْلِيمِ الْمَعْقُودِ
u'تَسْلِيمٌ مُعَوَّضٌ':Added, #1: 1	تَسْلِيمَ الْمُعَوَّضِ
u'تَسْلِيمٌ مُعَيَّنٌ':Added, #1: 1	تَسْلِيمُ الْمُعَوَّضِ
u'تَسْلِيمٌ مِفْتَاحٌ':Added, #1: 1	تَسْلِيمُ الْمُعَيَّنِ
u'تَسْلِيمٌ مِفْتَاحٌ':Added, #3: 3	تَسْلِيمُ الْمِفْتَاحِ
u'تَسْلِيمٌ مَفْرُوضٌ':Added, #4: 4	تَسْلِيمِ مِفْتَاحِ
u'تَسْلِيمٌ مُقَدَّمٌ':Added, #1: 1	تَسْلِيمِ الْمَفْرُوضِ
u'تَسْلِيمٌ مُقَدَّمٌ':Added, #1: 1	تَسْلِيمِ الْمُقَدَّمَتَيْنِ
u'تَسْلِيمٌ مَكْسُورٌ':Added, #1: 1	تَسْلِيمَ مُقَدَّمَاتِ
u'تَسْلِيمٌ مَكْفُولٌ':Added, #1: 1	تَسْلِيمُ الْمَكْسُورِ
u'تَسْلِيمٌ مَكْفُولٌ':Added, #4: 4	تَسْلِيمَ الْمَكْفُولِ
u'تَسْلِيمٌ مِلْكٌ':Added, #6: 6	تَسْلِيمِ الْمَكْفُولِ
u'تَسْلِيمٌ مُمَانَعَةٌ':Added, #2: 2	تَسْلِيمِ مِلْكِ
u'تَسْلِيمٌ مَنَافِعُ':Added, #1: 1	تَسْلِيمِ الْمُمَانَعَةِ
u'تَسْلِيمٌ مَنَافِعُ':Added, #1: 1	تَسْلِيمَ مَنَافِعِهِ
u'تَسْلِيمٌ مَنْذُور':Added, #2: 2	تَسْلِيمِ الْمَنَافِعِ
u'تَسْلِيمٌ مَنْفَعَةٌ':Added, #1: 1	تَسْلِيمُ الْمَنْذُورِ
u'تَسْلِيمٌ مَنْفَعَةٌ':Added, #1: 1	تَسْلِيمُ الْمَنْفَعَةِ
u'تَسْلِيمٌ مَهْرٌ':Added, #7: 7	تَسْلِيمِ الْمَنْفَعَةِ
u'تَسْلِيمٌ مَهْرٌ':Added, #2: 2	تَسْلِيمِ الْمَهْرِ
u'تَسْلِيمٌ مُوجَبٌ':Added, #4: 4	تَسْلِيمُ الْمَهْرِ
u'تَسْلِيمٌ مُؤَجَّلٌ':Added, #1: 1	تَسْلِيمُ مُوجَبِ
u'تَسْلِيمٌ مُؤَذِّنٌ':Added, #1: 1	تَسْلِيمِ الْمُؤَجَّلِ
u'تَسْلِيمٌ مَوْهُوبٌ':Added, #1: 1	تَسْلِيمَ الْمُؤَذِّنِ
u'تَسْلِيمٌ مَوْهُوبٌ':Added, #1: 1	تَسْلِيمُ الْمَوْهُوبِ
u'تَسْلِيمٌ نَصٌّ':Added, #1: 1	تَسْلِيمِ الْمَوْهُوبِ
u'تَسْلِيمٌ نِصْفٌ':Added, #1: 1	تَسْلِيمِ النَّصِّ
u'تَسْلِيمٌ نِصْفٌ':Added, #1: 1	تَسْلِيمُ نِصْفِ
u'تَسْلِيمٌ نِصْفٌ':Added, #1: 1	تَسْلِيمِ نِصْفِ
u'تَسْلِيمٌ نِصْفٌ':Added, #2: 2	تَسْلِيمِ النِّصْفِ
u'تَسْلِيمٌ نَصِيبٌ':Added, #5: 5	تَسْلِيمُ النِّصْفِ
u'تَسْلِيمٌ نَصِيبٌ':Added, #1: 1	تَسْلِيمَ نَصِيبِ
u'تَسْلِيمٌ نَصِيبٌ':Added, #1: 1	تَسْلِيمُ نَصِيبِ
u'تَسْلِيمٌ نَصِيبٌ':Added, #1: 1	تَسْلِيمُ نَصِيبِهِ
u'تَسْلِيمٌ نَصِيبٌ':Added, #1: 1	تَسْلِيمِ نَصِيبِهِ
u'تَسْلِيمٌ نَفْسٌ':Added, #2: 2	تَسْلِيمِ نَصِيبِ
u'تَسْلِيمٌ نَفْسٌ':Added, #10: 10	تَسْلِيمِ النَّفْسِ
u'تَسْلِيمٌ نَفْسٌ':Added, #1: 1	تَسْلِيمِ نَفْسِ
u'تَسْلِيمٌ نَفْسٌ':Added, #1: 1	تَسْلِيمَ نَفْسِهِ
u'تَسْلِيمٌ نَفْسٌ':Added, #4: 4	تَسْلِيمُ النَّفْسِ
u'تَسْلِيمٌ نَفْسٌ':Added, #4: 4	تَسْلِيمُ نَفْسِ
u'تَسْلِيمٌ نَفْسٌ':Added, #5: 5	تَسْلِيمَ النَّفْسِ
u'تَسْلِيمٌ نَفْسٌ':Added, #7: 7	تَسْلِيمُ نَفْسِهِ
u'تَسْلِيمٌ نَفَقَةٌ':Added, #7: 7	تَسْلِيمِ نَفْسِهِ
u'تَسْلِيمٌ نَفَقَةٌ':Added, #1: 1	تَسْلِيمِ النَّفَقَةِ
u'تَسْلِيمٌ نَفَقَةٌ':Added, #1: 1	تَسْلِيمَ نَفَقَةِ
u'تَسْلِيمٌ نَفَقَةٌ':Added, #1: 1	تَسْلِيمِ نَفَقَةِ
u'تَسْلِيمٌ نقل':Added, #6: 6	تَسْلِيمُ النَّفَقَةِ
u'تَسْلِيمٌ نَقْلٌ':Added, #1: 1	تَسْلِيمِ نَقْلِ
u'تَسْلِيمٌ نَقِيضٌ':Added, #1: 1	تَسْلِيمِ نَقْلِ
u'تَسْلِيمٌ نَقِيضٌ':Added, #1: 1	تَسْلِيمُ نَقِيضِ
u'تَسْلِيمٌ نَوْعٌ':Added, #1: 1	تَسْلِيمِ نَقِيضِ
u'تَسْلِيمٌ هِبَةٌ':Added, #4: 4	تَسْلِيمُ نَوْعِهِ
u'تَسْلِيمٌ وَاجِبٌ':Added, #1: 1	تَسْلِيمِ الْهِبَةِ
u'تَسْلِيمٌ وَارِثٌ':Added, #1: 1	تَسْلِيمُ الْوَاجِبِ
u'تَسْلِيمٌ وَجْهٌ':Added, #1: 1	تَسْلِيمِ الْوَارِثِ
u'تَسْلِيمٌ وُجُوبٌ':Added, #1: 1	تَسْلِيمِ الْوَجْهِ
u'تَسْلِيمٌ وُجُوبٌ':Added, #1: 1	تَسْلِيمُ الْوُجُوبِ
u'تَسْلِيمٌ وُجُودٌ':Added, #1: 1	تَسْلِيمِ وُجُوبِ
u'تَسْلِيمٌ وَدِيعٌ':Added, #3: 3	تَسْلِيمِ وُجُودِ
u'تَسْلِيمٌ وَدِيعٌ':Added, #1: 1	تَسْلِيمِ الْوَدِيعَةِ
u'تَسْلِيمٌ وَدِيعٌ':Added, #1: 1	تَسْلِيمَ وَدِيعَتِهِ
u'تَسْلِيمٌ وَدِيعٌ':Added, #1: 1	تَسْلِيمُ وَدِيعَتِهِ
u'تَسْلِيمٌ وَدِيعَةٌ':Added, #2: 2	تَسْلِيمُ الْوَدِيعَةِ
u'تَسْلِيمٌ وَدِيعَةٌ':Added, #1: 1	تَسْلِيمِ الْوَدِيعَةِ
u'تَسْلِيمٌ وَدِيعَةٌ':Added, #1: 1	تَسْلِيمَ وَدِيعَتِهِ
u'تَسْلِيمٌ وَدِيعَةٌ':Added, #1: 1	تَسْلِيمُ وَدِيعَتِهِ
u'تَسْلِيمٌ وُرُودٌ':Added, #2: 2	تَسْلِيمُ الْوَدِيعَةِ
u'تَسْلِيمٌ وُرُودٌ':Added, #1: 1	تَسْلِيمُ الْوُرُودِ
u'تَسْلِيمٌ وسط':Added, #1: 1	تَسْلِيمِ وُرُودِهِ
u'تَسْلِيمٌ وَسَطٌ':Added, #1: 1	تَسْلِيمِ الْوَسَطِ
u'تَسْلِيمٌ وَكِيلٌ':Added, #1: 1	تَسْلِيمِ الْوَسَطِ
u'تَسْلِيمٌ وَكِيلٌ':Added, #2: 2	تَسْلِيمَ الْوَكِيلِ
u'تَسْلِيمٌ وَكِيلٌ':Added, #2: 2	تَسْلِيمِ الْوَكِيلِ
u'تَسْلِيمٌ ولد':Added, #4: 4	تَسْلِيمُ الْوَكِيلِ
u'تَسْلِيمٌ وَلَدٌ':Added, #1: 1	تَسْلِيمُ الْوَلَدِ
u'تَسْلِيمٌ ولد':Added, #1: 1	تَسْلِيمُ الْوَلَدِ
u'تَسْلِيمٌ وَلَدٌ':Added, #2: 2	تَسْلِيمِ الْوَلَدِ
u'تَسْلِيمٌ وَلِيٌّ':Added, #2: 2	تَسْلِيمِ الْوَلَدِ
u'تَسْلِيمٌ وَلِيدٌ':Added, #1: 1	تَسْلِيمُ الْوَلِيِّ
u'تَسْلِيمٌ يَدٌ':Added, #1: 1	تَسْلِيمِ الْوَلِيدِ
u'تَسْلِيمٌ يهود':Added, #1: 1	تَسْلِيمِ الْيَدِ
u'تَسْلِيمٌ يَهُودٌ':Added, #1: 1	تَسْلِيمَ الْيَهُودِ
u'تَسَمُّعٌ بَصيرٌ':Added, #1: 1	تَسْلِيمَ الْيَهُودِ
u'تَسْمِيدٌ أرْضٌ':Added, #1: 1	تَسَمُّعَ الْبَصِيرِ
u'تَسْمِيدٌ أرْضٌ':Added, #1: 1	تَسْمِيدُ أَرْضِهِ
u'تَسْمِيرٌ بَابٌ':Added, #2: 2	تَسْمِيدُ الْأَرْضِ
u'تَسَمَّى رَجُلٌ':Subject, #1: 1	تَسْمِيرِ الْبَابِ
u'تَسْمِيعٌ إمَامٌ':Added, #1: 1	تَسَمَّى الرَّجُلُ
u'تَسَمَّى مَلِكٌ':Predicate, #1: 1	تَسْمِيعِ الْإِمَامِ
u'تَسْمِينٌ بدن':Added, #1: 1	تَسَمَّى مَلِكَ
u'تَسْمِينٌ بَدَنٌ':Added, #1: 1	تَسْمِينَ بَدَنِهِ
u'تَسَهَّلَ وَتَرٌ':Predicate, #1: 1	تَسْمِينَ بَدَنِهِ
u'تَسْهِيلٌ أَبْوَابٌ':Added, #1: 1	تَسَهَّلَ وَتَرَكَ
u'تَسْهِيلٌ أكل':Added, #1: 1	تَسْهِيلُ أَبْوَابِ
u'تَسْهِيلٌ أَكْلٌ':Added, #1: 1	تَسْهِيلُ الْأَكْلِ
u'تَسْهِيلٌ أَمْرٌ':Added, #1: 1	تَسْهِيلُ الْأَكْلِ
u'تَسْهِيلٌ أَمْرٌ':Added, #1: 1	تَسْهِيلُ الْأَمْرِ
u'تَسْهِيلٌ أُمُورٌ':Added, #2: 2	تَسْهِيلَ الْأَمْرِ
u'تَسْهِيلٌ سَبِيلٌ':Added, #1: 1	تَسْهِيلَ الْأُمُورِ
u'تَسْهِيلٌ همزة':Added, #1: 1	تَسْهِيلُ السَّبِيلِ
u'تَسْهِيلٌ همزة':Added, #1: 1	تَسْهِيلُ الْهَمْزَةِ
u'تَسْهِيلٌ هَمْزَةٌ':Added, #1: 1	تَسْهِيلِ الْهَمْزَةِ
u'تَسْهِيلٌ هَمْزَةٌ':Added, #1: 1	تَسْهِيلُ الْهَمْزَةِ
u'تَسَوَّرَ جِدار':Predicate, #1: 1	تَسْهِيلِ الْهَمْزَةِ
u'تَسَوَّرَ حائِطٌ':Predicate, #1: 1	تَسَوَّرَ الْجِدَارَ
u'تَسَوَّرَ مِحْرَابٌ':Predicate, #1: 1	تَسَوَّرَ الْحَائِطَ
u'تَسْوِيَةٌ أَجْزَاءٌ':Added, #1: 1	تَسَوَّرَ الْمِحْرَابَ
u'تَسْوِيَةٌ أرْضٌ':Added, #1: 1	تَسْوِيَةُ الْأَجْزَاءِ
u'تَسْوِيَةٌ أرْضٌ':Added, #12: 12	تَسْوِيَةُ الْأَرْضِ
u'تَسْوِيَةٌ إمَامٌ':Added, #4: 4	تَسْوِيَةَ الْأَرْضِ
u'تَسْوِيَةٌ أُمُورٌ':Added, #1: 1	تَسْوِيَةِ الْإِمَامِ
u'تَسْوِيَةٌ أُمُورٌ':Added, #1: 1	تَسْوِيَةِ الْأُمُورِ
u'تَسْوِيَةٌ أُمُورٌ':Added, #1: 1	تَسْوِيَةِ أُمُورِهِ
u'تَسْوِيَةٌ بَراذِعِيّ':Added, #7: 7	تَسْوِيَةِ أُمُورِ
u'تَسْوِيَةٌ بَيْدَرٌ':Added, #1: 1	تَسْوِيَةَ الْبَرَاذِعِيِّ
u'تَسْوِيَةٌ تُرَابٌ':Added, #1: 1	تَسْوِيَةُ الْبَيْدَرِ
u'تَسْوِيَةٌ جُنُونٌ':Added, #2: 2	تَسْوِيَةِ التُّرَابِ
u'تَسْوِيَةٌ حَجَرٌ':Added, #1: 1	تَسْوِيَةِ الْجُنُونِ
u'تَسْوِيَةٌ حَفْرٌ':Added, #1: 1	تَسْوِيَةِ الْحَجَرِ
u'تَسْوِيَةٌ حُفَرٌ':Added, #1: 1	تَسْوِيَةِ الْحَفْرِ
u'تَسْوِيَةٌ حُفَرٌ':Added, #1: 1	تَسْوِيَةِ حُفَرِ
u'تَسْوِيَةٌ حَفْرٌ':Added, #1: 1	تَسْوِيَةُ حُفَرِهِ
u'تَسْوِيَةٌ حُفَرٌ':Added, #3: 3	تَسْوِيَةَ الْحَفْرِ
u'تَسْوِيَةٌ حَفْرٌ':Added, #4: 4	تَسْوِيَةُ الْحُفَرِ
u'تَسْوِيَةٌ حُكْمٌ':Added, #6: 6	تَسْوِيَةُ الْحَفْرِ
u'تَسْوِيَةٌ رَهْنٌ':Added, #1: 1	تَسْوِيَةُ حُكْمِ
u'تَسْوِيَةٌ شَارِعٌ':Added, #1: 1	تَسْوِيَةِ الرَّهْنِ
u'تَسْوِيَةٌ شَعْرٌ':Added, #1: 1	تَسْوِيَةَ الشَّارِعِ
u'تَسْوِيَةٌ صَاحِبٌ':Added, #1: 1	تَسْوِيَةِ شَعْرٍ
u'تَسْوِيَةٌ صَفٌّ':Added, #1: 1	تَسْوِيَةُ صَاحِبِ
u'تَسْوِيَةٌ صَفٌّ':Added, #1: 1	تَسْوِيَةِ الصَّفِّ
u'تَسْوِيَةٌ صُفُوفٌ':Added, #4: 4	تَسْوِيَةَ الصَّفِّ
u'تَسْوِيَةٌ صُفُوفٌ':Added, #3: 3	تَسْوِيَةَ الصُّفُوفِ
u'تَسْوِيَةٌ صُفُوفٌ':Added, #3: 3	تَسْوِيَةُ الصُّفُوفِ
u'تَسْوِيَةٌ طَلاَقٌ':Added, #5: 5	تَسْوِيَةِ الصُّفُوفِ
u'تَسْوِيَةٌ ظَهْرٌ':Added, #1: 1	تَسْوِيَةِ الطَّلَاقِ
u'تَسْوِيَةٌ فَارِسٌ':Added, #1: 1	تَسْوِيَةِ ظَهْرِهِ
u'تَسْوِيَةٌ فقهاء':Added, #1: 1	تَسْوِيَةُ الْفَارِسِ
u'تَسْوِيَةٌ قَبْرٌ':Added, #1: 1	تَسْوِيَةُ الْفُقَهَاءِ
u'تَسْوِيَةٌ قُبُورٌ':Added, #1: 1	تَسْوِيَةِ الْقَبْرِ
u'تَسْوِيَةٌ قَدَمٌ':Added, #1: 1	تَسْوِيَةِ الْقُبُورِ
u'تَسْوِيَةٌ كَيْلٌ':Added, #1: 1	تَسْوِيَةُ الْقَدَمَيْنِ
u'تَسْوِيَةٌ لبن':Added, #1: 1	تَسْوِيَةِ الْكَيْلِ
u'تَسْوِيَةٌ لَبِنٌ':Added, #1: 1	تَسْوِيَةِ اللَّبِنِ
u'تَسْوِيَةٌ مَالِكٌ':Added, #1: 1	تَسْوِيَةِ اللَّبِنِ
u'تَسْوِيَةٌ مَالِكٌ':Added, #1: 1	تَسْوِيَةِ الْمَالِكِ
u'تَسْوِيَةٌ مُضَافٌ':Added, #1: 1	تَسْوِيَةُ مَالِكٍ
u'تَسْوِيَةٌ مُلْحَقٌ':Added, #1: 1	تَسْوِيَةَ الْمُضَافِ
u'تَسْوِيَةٌ نَاسٌ':Added, #1: 1	تَسْوِيَةُ مُلْحَقٍ
u'تَسْوِيَةٌ نَجَاسَةٌ':Added, #1: 1	تَسْوِيَةِ النَّاسِ
u'تَسْوِيَةٌ نصب':Added, #1: 1	تَسْوِيَةُ النَّجَاسَةِ
u'تَسْوِيَةٌ نُصُبٌ':Added, #4: 4	تَسْوِيَةِ النُّصُبِ
u'تَسْوِيَةٌ وَلِيدٌ':Added, #4: 4	تَسْوِيَةِ النُّصُبِ
u'تَسْوِيدٌ ثِيابٌ':Added, #1: 1	تَسْوِيَةُ الْوَلِيدِ
u'تَسْوِيدٌ حاجِبٌ':Added, #2: 2	تَسْوِيدُ الثِّيَابِ
u'تَسْوِيدٌ خُدُودٌ':Added, #1: 1	تَسْوِيدُ الْحَاجِبِ
u'تَسْوِيدٌ سِنٌّ':Added, #1: 1	تَسْوِيدُ الْخُدُودِ
u'تَسْوِيدٌ سِنٌّ':Added, #1: 1	تَسْوِيدِ سِنٍّ
u'تَسْوِيدٌ كَفٌّ':Added, #3: 3	تَسْوِيدِ السِّنِّ
u'تَسْوِيدٌ وَجْهٌ':Added, #1: 1	تَسْوِيدُ كَفِّ
u'تَسْوِيدٌ وَجْهٌ':Added, #1: 1	تَسْوِيدِ وَجْهِ
u'تَسْوِيدٌ وَجْهٌ':Added, #1: 1	تَسْوِيدِ وَجْهِهِ
u'تَسْوِيدٌ وَجْهٌ':Added, #2: 2	تَسْوِيدَ الْوَجْهِ
u'تَسْوِيدٌ وَجْهٌ':Added, #2: 2	تَسْوِيدُ وَجْهِهِ
u'تَسْوِيدٌ وَجْهٌ':Added, #4: 4	تَسْوِيدِ وَجْهٍ
u'تَسْوِيفٌ أَمَلٌ':Added, #6: 6	تَسْوِيدِ الْوَجْهِ
u'تَسْوِيفٌ أَمَلٌ':Added, #1: 1	تَسْوِيفَ الْأَمَلِ
u'تَسْيِيبٌ أهْلٌ':Added, #1: 1	تَسْوِيفَ أَمَلٍ
u'تَسْيِيبٌ بَهائِمُ':Added, #1: 1	تَسْيِيبِ أَهْلِ
u'تَسْيِيبٌ دَابَّةٌ':Added, #1: 1	تَسْيِيبِ الْبَهَائِمِ
u'تَسْيِيبٌ سَوَائِبُ':Added, #1: 1	تَسْيِيبِ الدَّابَّةِ
u'تَسْيِيبٌ سَوَائِبُ':Added, #1: 1	تَسْيِيبَ السَّوَائِبِ
u'تَسْيِيرٌ أَرْبَعَةٌ':Added, #1: 1	تَسْيِيبُ السَّوَائِبِ
u'تَسْيِيرٌ جِبَالٌ':Added, #1: 1	تَسْيِيرَ أَرْبَعَةِ
u'تَسْيِيرٌ جَيْشٌ':Added, #2: 2	تَسْيِيرِ الْجِبَالِ
u'تَسْيِيرٌ حَجيجٌ':Added, #1: 1	تَسْيِيرِ الْجَيْشِ
u'تَسْيِيرٌ حَجيجٌ':Added, #2: 2	تَسْيِيرِ الْحَجِيجِ
u'تَسْيِيرٌ وَزْنٌ':Added, #3: 3	تَسْيِيرُ الْحَجِيجِ
u'تَسْيِيلٌ دَمٌ':Added, #1: 1	تَسْيِيرِ الْوَزْنِ
u'تَسْيِيلٌ مَاءٌ':Added, #1: 1	تَسْيِيلِ الدَّمِ
u'تَسْيِيلٌ مَاءٌ':Added, #1: 1	تَسْيِيلَ الْمَاءِ
u'تَسْيِيلٌ مَاءٌ':Added, #1: 1	تَسْيِيلُ الْمَاءِ
u'تَشَاءَمَ نَاسٌ':Subject, #5: 5	تَسْيِيلِ الْمَاءِ
u'تَشَابُهٌ أُصْبُعٌ':Added, #1: 1	تَشَاءَمَ النَّاسُ
u'تَشَابُهٌ أصل':Added, #1: 1	تَشَابُهُ أُصْبُعَيْنِ
u'تَشَابُهٌ أًصْلٌ':Added, #1: 1	تَشَابُهَ الْأَصْلِ
u'تَشَابُهٌ فَرْعٌ':Added, #1: 1	تَشَابُهَ الْأَصْلِ
u'تَشَابُهٌ لَفْظٌ':Added, #1: 1	تَشَابُهَ الْفَرْعِ
u'تَشَاتَمَ وَالِدٌ':Subject, #1: 1	تَشَابُهِ اللَّفْظَيْنِ
u'تَشَاجُرٌ زَوْجٌ':Added, #2: 2	تَشَاتَمَ وَالِدٌ
u'تَشَاجَرَ نَاسٌ':Subject, #1: 1	تَشَاجُرِ الزَّوْجَيْنِ
u'تَشَاحَّ أَوْلِيَاءُ':Subject, #1: 1	تَشَاجَرَ النَّاسُ
u'تَشَاحَّ جَمَاعَةٌ':Subject, #1: 1	تَشَاحَّ أَوْلِيَاءُ
u'تَشَاحَّ عَبِيدٌ':Subject, #1: 1	تَشَاحَّ جَمَاعَةٌ
u'تَشَاحَّ نَاسٌ':Subject, #1: 1	تَشَاحَّ الْعَبِيدُ
u'تَشَارَكَ فُلاَنٌ':Subject, #1: 1	تَشَاحَّ النَّاسُ
u'تَشَاغَلَ نَاسٌ':Subject, #1: 1	تَشَارَكَ فُلَانٌ
u'تَشَاكُلٌ لَفْظٌ':Added, #1: 1	تَشَاغَلَ النَّاسُ
u'تَشَاوَرَ قَوْمٌ':Subject, #1: 1	تَشَاكُلِ اللّفْظِ
u'تَشَبَّبَ فُلاَنٌ':Subject, #3: 3	تَشَاوَرَ قَوْمٌ
u'تَشَبُّهٌ رِجَالٌ':Added, #1: 1	تَشَبَّبَ فُلَانٌ
u'تَشَبُّهٌ رِجَالٌ':Added, #1: 1	تَشَبُّهُ الرِّجَالِ
u'تَشَبُّهٌ رَجُلٌ':Added, #4: 4	تَشَبُّهِ الرِّجَالِ
u'تَشَبُّهٌ رَجُلٌ':Added, #1: 1	تَشَبُّهِ الرَّجُلِ
u'تَشَبُّهٌ رَجُلٌ':Added, #2: 2	تَشَبُّهُ الرَّجُلِ
u'تَشَبُّهٌ رَجُلٌ':Added, #2: 2	تَشَبُّهُ رَجُلٍ
u'تَشْبِيهٌ أحَدٌ':Added, #2: 2	تَشَبُّهِ رَجُلٍ
u'تَشْبِيهٌ أصل':Added, #1: 1	تَشْبِيهُ أَحَدِ
u'تَشْبِيهٌ أًصْلٌ':Added, #1: 1	تَشْبِيهِ أَصْلِهِ
u'تَشْبِيهٌ إمَامٌ':Added, #1: 1	تَشْبِيهِ أَصْلِهِ
u'تَشْبِيهٌ اِمْرَأَةٌ':Added, #1: 1	تَشْبِيهِ الْإِمَامِ
u'تَشْبِيهٌ بَاضِعٌ':Added, #1: 1	تَشْبِيهَ امْرَأَتِهِ
u'تَشْبِيهٌ بِدَعٌ':Added, #1: 1	تَشْبِيهُ الْبَاضِعَةِ
u'تَشْبِيهٌ بِلادٌ':Added, #1: 1	تَشْبِيهُ الْبِدَعِ
u'تَشْبِيهٌ تَأْدِيبٌ':Added, #1: 1	تَشْبِيهَ الْبِلَادِ
u'تَشْبِيهٌ حالٌ':Added, #1: 1	تَشْبِيهَ تَأْدِيبِهِ
u'تَشْبِيهٌ حَسَنٌ':Added, #1: 1	تَشْبِيهِ الْحَالِ
u'تَشْبِيهٌ حَضَانَةٌ':Added, #1: 1	تَشْبِيهِ الْحَسَنِ
u'تَشْبِيهٌ حَمْلٌ':Added, #1: 1	تَشْبِيهِ الْحَضَانَةِ
u'تَشْبِيهٌ رُؤْيَةٌ':Added, #1: 1	تَشْبِيهِ حَمْلِ
u'تَشْبِيهٌ زَوْجٌ':Added, #1: 1	تَشْبِيهَ الرُّؤْيَةِ
u'تَشْبِيهٌ زَوْجٌ':Added, #1: 1	تَشْبِيهُ الزَّوْجِ
u'تَشْبِيهٌ زَوْجَةٌ':Added, #1: 1	تَشْبِيهُ زَوْجٍ
u'تَشْبِيهٌ زَوْجَةٌ':Added, #1: 1	تَشْبِيهِ الزَّوْجَةِ
u'تَشْبِيهٌ زَيْدٌ':Added, #3: 3	تَشْبِيهُ الزَّوْجَةِ
u'تَشْبِيهٌ سائِل':Added, #1: 1	تَشْبِيهِ زَيْدِ
u'تَشْبِيهٌ سَائِلٌ':Added, #1: 1	تَشْبِيهِ السَّائِلِ
u'تَشْبِيهٌ شَارِعٌ':Added, #1: 1	تَشْبِيهِ السَّائِلِ
u'تَشْبِيهٌ شَرَائِعُ':Added, #1: 1	تَشْبِيهُ الشَّارِعِ
u'تَشْبِيهٌ شَيْءٌ':Added, #1: 1	تَشْبِيهَ الشَّرَائِعِ
u'تَشْبِيهٌ شَيْءٌ':Added, #1: 1	تَشْبِيهُ الشَّيْءِ
u'تَشْبِيهٌ ضَعِيفٌ':Added, #2: 2	تَشْبِيهَ الشَّيْءِ
u'تَشْبِيهٌ ضَمَانٌ':Added, #1: 1	تَشْبِيهُ الضَّعِيفِ
u'تَشْبِيهٌ طرف':Added, #1: 1	تَشْبِيهِ ضَمَانِ
u'تَشْبِيهٌ طَرَفٌ':Added, #1: 1	تَشْبِيهُ طَرَفِهِ
u'تَشْبِيهٌ طَلاَقٌ':Added, #1: 1	تَشْبِيهُ طَرَفِهِ
u'تَشْبِيهٌ طواف':Added, #2: 2	تَشْبِيهِ الطَّلَاقِ
u'تَشْبِيهٌ طَوَافٌ':Added, #1: 1	تَشْبِيهِ الطَّوَافِ
u'تَشْبِيهٌ طواف':Added, #1: 1	تَشْبِيهِ الطَّوَافِ
u'تَشْبِيهٌ طَوَافٌ':Added, #2: 2	تَشْبِيهُ الطَّوَافِ
u'تَشْبِيهٌ ظَهْرٌ':Added, #2: 2	تَشْبِيهُ الطَّوَافِ
u'تَشْبِيهٌ ظَهْرٌ':Added, #1: 1	تَشْبِيهُ ظَهْرٍ
u'تَشْبِيهٌ عُضْوٌ':Added, #1: 1	تَشْبِيهُ ظَهْرِ
u'تَشْبِيهٌ قَاصِدٌ':Added, #1: 1	تَشْبِيهَ عُضْوٍ
u'تَشْبِيهٌ قَدْرٌ':Added, #1: 1	تَشْبِيهَ قَاصِدِ
u'تَشْبِيهٌ قَضَاءٌ':Added, #1: 1	تَشْبِيهُ الْقَدْرِ
u'تَشْبِيهٌ لِقَاحٌ':Added, #1: 1	تَشْبِيهِ الْقَضَاءِ
u'تَشْبِيهٌ لَيْلٌ':Added, #1: 1	تَشْبِيهِ لِقَاحِ
u'تَشْبِيهٌ مَجْمُوعٌ':Added, #1: 1	تَشْبِيهُ اللَّيْلِ
u'تَشْبِيهٌ مُحَرَّمٌ':Added, #1: 1	تَشْبِيهَ الْمَجْمُوعِ
u'تَشْبِيهٌ مُسْلِمٌ':Added, #1: 1	تَشْبِيهُ الْمُحَرَّمَةِ
u'تَشْبِيهٌ مُصَنِّفٌ':Added, #2: 2	تَشْبِيهُ الْمُسْلِمِ
u'تَشْبِيهٌ مَصْنُوعٌ':Added, #1: 1	تَشْبِيهِ الْمُصَنِّفِ
u'تَشْبِيهٌ مَعْقُولٌ':Added, #1: 1	تَشْبِيهُ الْمَصْنُوعِ
u'تَشْبِيهٌ مَفْسُوخ':Added, #1: 1	تَشْبِيهِ الْمَعْقُولِ
u'تَشْبِيهٌ مَنْكُوح':Added, #1: 1	تَشْبِيهِ الْمَفْسُوخِ
u'تَشْبِيهٌ مُؤْمِنٌ':Added, #2: 2	تَشْبِيهُ الْمَنْكُوحَةِ
u'تَشْبِيهٌ نخلة':Added, #1: 1	تَشْبِيهُ الْمُؤْمِنِ
u'تَشْبِيهٌ نَخْلَةٌ':Added, #1: 1	تَشْبِيهِ النَّخْلَةِ
u'تَشْبِيهٌ نَقْصٌ':Added, #1: 1	تَشْبِيهِ النَّخْلَةِ
u'تَشْبِيهٌ نَوَوِيٌّ':Added, #1: 1	تَشْبِيهِ النَّقْصِ
u'تَشْبِيهٌ وَاجِبٌ':Added, #1: 1	تَشْبِيهِ النَّوَوِيِّ
u'تَشْبِيهٌ وَقْفٌ':Added, #1: 1	تَشْبِيهُ الْوَاجِبِ
u'تَشَتُّتٌ آرَاءٌ':Added, #1: 1	تَشْبِيهِ الْوَقْفِ
u'تَشَتُّتٌ أَمْرٌ':Added, #1: 1	تَشَتُّتِ آرَاءِ
u'تَشَتُّتٌ بالٌ':Added, #1: 1	تَشَتُّتَ أَمْرِ
u'تَشَتُّتٌ بَالٌ':Added, #1: 1	تَشَتُّت الْبَالِ
u'تَشَخُّصٌ حُكْمٌ':Added, #1: 1	تَشَتُّت الْبَالِ
u'تَشَخَّصَ مَدْلُولٌ':Subject, #1: 1	تَشَخُّصَ الْحُكْمِ
u'تَشْخِيصٌ حُدودٌ':Added, #1: 1	تَشَخَّصَ مَدْلُولُهُ
u'تَشْدِيدٌ اِبْنٌ':Added, #1: 1	تَشْخِيصَ الْحُدُودِ
u'تَشْدِيدٌ أهْلٌ':Added, #1: 1	تَشْدِيدُ ابْنِ
u'تَشْدِيدٌ جَلاَلَةٌ':Added, #1: 1	تَشْدِيدَ أَهْلِ
u'تَشْدِيدٌ حَرْفٌ':Added, #1: 1	تَشْدِيدَ الْجَلَالَةِ
u'تَشْدِيدٌ عَقْلٌ':Added, #1: 1	تَشْدِيدِ الْحَرْفِ
u'تَشْدِيدٌ عين':Added, #2: 2	تَشْدِيدُ الْعَقْلِ
u'تَشْدِيدٌ عَيْنٌ':Added, #1: 1	تَشْدِيدُ الْعَيْنِ
u'تَشْدِيدٌ عَيْن':Added, #1: 1	تَشْدِيدُ الْعَيْنِ
u'تَشْدِيدٌ مِيمٌ':Added, #1: 1	تَشْدِيدُ الْعَيْنِ
u'تَشْدِيدٌ مِيمٌ':Added, #1: 1	تَشْدِيدِ الْمِيمِ
u'تَشْدِيدٌ نُونٌ':Added, #2: 2	تَشْدِيدُ الْمِيمِ
u'تَشَرَّفَ أهْلٌ':Subject, #1: 1	تَشْدِيدَ النُّونِ
u'تَشْرِيعٌ أَحْكَامٌ':Added, #1: 1	تَشَرَّفَ أَهْلُ
u'تَشْرِيعٌ أَعْمَالٌ':Added, #1: 1	تَشْرِيعِ الْأَحْكَامِ
u'تَشْرِيعٌ حُكْمٌ':Added, #1: 1	تَشْرِيعِ الْأَعْمَالِ
u'تَشْرِيعٌ عِبَادَةٌ':Added, #1: 1	تَشْرِيعِ حُكْمٍ
u'تَشْرِيقٌ شمس':Added, #1: 1	تَشْرِيعَ الْعِبَادَةِ
u'تَشْرِيقٌ شَمْسٌ':Added, #1: 1	تَشْرِيقِ الشَّمْسِ
u'تَشْرِيقٌ لَحْمٌ':Added, #1: 1	تَشْرِيقِ الشَّمْسِ
u'تَشْرِيقٌ لَحْمٌ':Added, #1: 1	تَشْرِيقَ اللَّحْمِ
u'تَشْرِيكٌ كَفَّارٌ':Added, #1: 1	تَشْرِيقِ اللَّحْمِ
u'تَشْطِيرٌ حَدٌّ':Added, #1: 1	تَشْرِيكُ كَفَّارَتَيْنِ
u'تَشْطِيرٌ صداق':Added, #1: 1	تَشْطِيرِ الْحَدِّ
u'تَشْطِيرٌ صَدَاقٌ':Added, #1: 1	تَشْطِيرَ الصَّدَاقِ
u'تَشْطِيرٌ صداق':Added, #1: 1	تَشْطِيرَ الصَّدَاقِ
u'تَشْطِيرٌ صَدَاقٌ':Added, #4: 4	تَشْطِيرِ الصَّدَاقِ
u'تَشْطِيرٌ مَهْرٌ':Added, #4: 4	تَشْطِيرِ الصَّدَاقِ
u'تَشْطِيرٌ هَدِيٌّ':Added, #1: 1	تَشْطِيرِ الْمَهْرِ
u'تَشْطِيرٌ هَدِيَّةٌ':Added, #1: 1	تَشْطِيرِ هَدِيَّةٍ
u'تَشَعُّثٌ شَعْرٌ':Added, #1: 1	تَشْطِيرِ هَدِيَّةٍ
u'تَشَفِّي صَدْرٌ':Added, #1: 1	تَشَعُّثِ شَعْرٍ
u'تَشَفِّي غَيْظٌ':Added, #2: 2	تَشَفِّي الصَّدْرِ
u'تَشَقَّقَ بَعْضٌ':Subject, #1: 1	تَشَفِّي الْغَيْظِ
u'تَشَقَّقَ بَعْضٌ':Subject, #1: 1	تَشَقَّقَ بَعْضُ
u'تَشَقَّقَ جَوْزٌ':Subject, #1: 1	تَشَقَّقَ بَعْضُهُ
u'تَشَقُّقٌ جَوْزٌ':Added, #2: 2	تَشَقَّقَ جَوْزُهُ
u'تَشَقَّقَ حائِطٌ':Subject, #1: 1	تَشَقُّقِ الْجَوْزِ
u'تَشَقَّقَ طَلْعٌ':Subject, #1: 1	تَشَقَّقَ الْحَائِطُ
u'تَشَقُّقٌ قِشْرٌ':Added, #3: 3	تَشَقَّقَ طَلْعُهُ
u'تَشَقُّقٌ وَرْدٌ':Added, #1: 1	تَشَقُّقُ الْقِشْرِ
u'تَشَقُّقٌ وَرْدٌ':Added, #1: 1	تَشَقُّقِ الْوَرْدِ
u'تَشَقُّقٌ وَرْدٌ':Added, #1: 1	تَشَقُّقُ وَرْدٍ
u'تَشَكَّلَ عند':Predicate, #1: 1	تَشَقُّقِ وَرْدٍ
u'تَشْمِيرٌ كُمٌّ':Added, #1: 1	تَشَكَّلَ عِنْدَ
u'تَشْمِيرٌ كُمٌّ':Added, #1: 1	تَشْمِيرِ الْكُمِّ
u'تَشْمِيسٌ قَزٌّ':Added, #1: 1	تَشْمِيرِ الْكُمَّيْنِ
u'تَشْنِيعٌ خَصْمٌ':Added, #1: 1	تَشْمِيسِ الْقَزِّ
u'تَشْنِيفٌ مَسَامِعُ':Added, #1: 1	تَشْنِيعَ الْخَصْمِ
u'تَشَهُّدٌ اِبْنٌ':Added, #1: 1	تَشْنِيفِ الْمَسَامِعِ
u'تَشَهُّدٌ اِبْنٌ':Added, #6: 6	تَشَهُّدَ ابْنِ
u'تَشَهُّدٌ اِبْنٌ':Added, #7: 7	تَشَهُّدُ ابْنِ
u'تَشَهَّدَ إمَامٌ':Subject, #9: 9	تَشَهُّدِ ابْنِ
u'تَشَهُّدٌ إمَامٌ':Added, #6: 6	تَشَهَّدَ الْإِمَامُ
u'تَشَهَّدَ تَشَهُّدٌ':Predicate, #2: 2	تَشَهُّدِ الْإِمَامِ
u'تَشَهَّدَ تَشَهُّدٌ':Predicate, #1: 1	تَشَهَّدَ تَشَهُّدَ
u'تَشَهُّدٌ جَابِرٌ':Added, #2: 2	تَشَهَّدَ التَّشَهُّدَ
u'تَشَهُّدٌ جمعة':Added, #1: 1	تَشَهُّدُ جَابِرٍ
u'تَشَهُّدٌ جُمُعَةٌ':Added, #1: 1	تَشَهُّدَ الْجُمُعَةِ
u'تَشَهُّدٌ جمعة':Added, #1: 1	تَشَهُّدَ الْجُمُعَةِ
u'تَشَهُّدٌ جُمُعَةٌ':Added, #2: 2	تَشَهُّدِ الْجُمُعَةِ
u'تَشَهُّدٌ حاجَةٌ':Added, #2: 2	تَشَهُّدِ الْجُمُعَةِ
u'تَشَهُّدٌ رَسُولٌ':Added, #1: 1	تَشَهُّدِ الْحَاجَةِ
u'تَشَهُّدٌ سُجُودٌ':Added, #1: 1	تَشَهُّدِ رَسُولِ
u'تَشَهُّدٌ سلام':Added, #1: 1	تَشَهُّدِ سُجُودِ
u'تَشَهُّدٌ سَلاَمٌ':Added, #1: 1	تَشَهُّدِ السَّلَامِ
u'تَشَهُّدٌ صُبْحٌ':Added, #1: 1	تَشَهُّدِ السَّلَامِ
u'تَشَهُّدٌ صَلاَةٌ':Added, #2: 2	تَشَهُّدِ الصُّبْحِ
u'تَشَهُّدٌ صَلاَةٌ':Added, #1: 1	تَشَهُّدِ الصَّلَاةِ
u'تَشَهُّدٌ صَلاَةٌ':Added, #2: 2	تَشَهُّدَ الصَّلاَةِ
u'تَشَهُّدٌ عَارٌ':Added, #2: 2	تَشَهُّدُ الصَّلَاةِ
u'تَشَهَّدَ عَبْدٌ':Subject, #1: 1	تَشَهُّدٍ عَارٍ
u'تَشَهُّدٌ عَبْدٌ':Added, #1: 1	تَشَهَّدَ عَبْدُ
u'تَشَهُّدٌ عَصْرٌ':Added, #2: 2	تَشَهُّدُ عَبْدِ
u'تَشَهَّدَ عَقِيبٌ':Predicate, #1: 1	تَشَهُّدِ الْعَصْرِ
u'تَشَهَّدَ قَالٌ':Predicate, #2: 2	تَشَهَّدَ عَقِيبَ
u'تَشَهُّدٌ قعدة':Added, #3: 3	تَشَهَّدَ قَالَ
u'تَشَهُّدٌ قَعْدَةٌ':Added, #1: 1	تَشَهُّدُ الْقَعْدَةِ
u'تَشَهُّدٌ نَبِيٌّ':Added, #1: 1	تَشَهُّدُ الْقَعْدَةِ
u'تَشَهُّدٌ نَبِيٌّ':Added, #1: 1	تَشَهُّدَ النَّبِيِّ
u'تَشَهُّدٌ نَبِيٌّ':Added, #1: 1	تَشَهُّدُ النَّبِيِّ
u'تَشْهِيرٌ صَاحِبٌ':Added, #3: 3	تَشَهُّدِ النَّبِيِّ
u'تَشْهِيرٌ مَغَارِبَةٌ':Added, #1: 1	تَشْهِيرِ صَاحِبِ
u'تَشَوَّفَ شَارِعٌ':Subject, #1: 1	تَشْهِيرِ الْمَغَارِبَةِ
u'تَشَوُّفٌ شَارِعٌ':Added, #1: 1	تَشَوَّفَ الشَّارِعُ
u'تَشَوُّفٌ شَارِعٌ':Added, #1: 1	تَشَوُّفَ الشَّارِعِ
u'تَشَوُّفٌ شَارِعٌ':Added, #4: 4	تَشَوُّفُ الشَّارِعِ
u'تَشَوُّفٌ فَقِيرٌ':Added, #5: 5	تَشَوُّفِ الشَّارِعِ
u'تَشَوُّفٌ نَفْسٌ':Added, #1: 1	تَشَوُّفُ الْفَقِيرِ
u'تَشَوُّفٌ نُفُوسٌ':Added, #1: 1	تَشَوُّفُ النَّفْسِ
u'تَشَوُّقٌ شَارِعٌ':Added, #1: 1	تَشَوُّفِ النُّفُوسِ
u'تَشْوِيشٌ فِكْرٌ':Added, #1: 1	تَشَوُّقِ الشَّارِعِ
u'تَشْوِيشٌ فِكْرٌ':Added, #1: 1	تَشْوِيشِ الْفِكْرِ
u'تَشْوِيشٌ فِكْرٌ':Added, #2: 2	تَشْوِيشُ الْفِكْرِ
u'تَشْوِيهٌ خلق':Added, #3: 3	تَشْوِيشَ الْفِكْرِ
u'تَشْوِيهٌ خَلْقٌ':Added, #1: 1	تَشْوِيهِ الْخَلْقِ
u'تَشْوِيهٌ خلق':Added, #1: 1	تَشْوِيهِ الْخَلْقِ
u'تَشْوِيهٌ خَلْقٌ':Added, #1: 1	تَشْوِيهِ خَلْقِهِ
u'تَشْوِيهٌ خلقة':Added, #1: 1	تَشْوِيهِ خَلْقِهِ
u'تَشْوِيهٌ خِلْقَةٌ':Added, #1: 1	تَشْوِيهِ الْخِلْقَةِ
u'تَشْوِيهٌ خلقة':Added, #1: 1	تَشْوِيهِ الْخِلْقَةِ
u'تَشْوِيهٌ خِلْقَةٌ':Added, #1: 1	تَشْوِيهِ خِلْقَتِهِ
u'تَشْيِيدٌ دَارٌ':Added, #1: 1	تَشْوِيهِ خِلْقَتِهِ
u'تَشْيِيعٌ أعْمَش':Added, #1: 1	تَشْيِيدِ دَارِهِ
u'تَشْيِيعٌ حاجٌّ':Added, #1: 1	تَشْيِيعِ الْأَعْمَشِ
u'تَشْيِيعٌ غَازٌ':Added, #2: 2	تَشْيِيعِ الْحَاجِّ
u'تَشْيِيعٌ مُسْلِمٌ':Added, #1: 1	تَشْيِيعُ غَازٍ
u'تَصَادُقٌ أحَدٌ':Added, #1: 1	تَشْيِيعِ الْمُسْلِمِ
u'تَصَادَقَ أُمٌّ':Subject, #1: 1	تَصَادُقُ أَحَدِ
u'تَصَادَقَ بَائِعٌ':Subject, #2: 2	تَصَادَقَ الْأُمُّ
u'تَصَادَقَ دَائِنٌ':Subject, #4: 4	تَصَادَقَ الْبَائِعُ
u'تَصَادَقَ رَاهِنٌ':Subject, #1: 1	تَصَادَقَ الدَّائِنُ
u'تَصَادَقَ رَجُلٌ':Subject, #2: 2	تَصَادَقَ الرَّاهِنُ
u'تَصَادَقَ قَاتِلٌ':Subject, #1: 1	تَصَادَقَ الرَّجُلُ
u'تَصَادُقٌ مَجْهُولٌ':Added, #3: 3	تَصَادَقَ الْقَاتِلُ
u'تَصَادَقَ مُحَمَّدٌ':Subject, #1: 1	تَصَادُقِ الْمَجْهُولِ
u'تَصَادُقٌ مُشْتَرَكٌ':Added, #1: 1	تَصَادَقَ مُحَمَّدٌ
u'تَصَادَقَ مُلْتَقِط':Subject, #1: 1	تَصَادُقُ الْمُشْتَرَكِ
u'تَصَادُمٌ آرَاءٌ':Added, #1: 1	تَصَادَقَ الْمُلْتَقِطُ
u'تَصَاعُدٌ أبْخِرَةٌ':Added, #1: 1	تَصَادُمِ الْآرَاءِ
u'تَصَاعُدٌ أبْخِرَةٌ':Added, #1: 1	تَصَاعُدُ أَبْخِرَةٍ
u'تَصَافُحٌ رَجُلٌ':Added, #1: 1	تَصَاعُدِ الْأَبْخِرَةِ
u'تَصَاوُلٌ فَحْلٌ':Added, #1: 1	تَصَافُحُ الرَّجُلَيْنِ
u'تَصَبَّحَ سَبْعٌ':Predicate, #1: 1	تَصَاوُلَ الْفَحْلَيْنِ
u'تَصَحُّحٌ فِعْلٌ':Added, #1: 1	تَصَبَّحَ سَبْعَ
u'تَصْحِيحٌ اِبْنٌ':Added, #1: 1	تَصَحُّحِ فِعْلِ
u'تَصْحِيحٌ اِبْنٌ':Added, #1: 1	تَصْحِيحَ ابْنِ
u'تَصْحِيحٌ إجَازَةٌ':Added, #1: 1	تَصْحِيحُ ابْنِ
u'تَصْحِيحٌ إِجْزَاءٌ':Added, #1: 1	تَصْحِيحِ الْإِجَازَةِ
u'تَصْحِيحٌ أَحادِيثُ':Added, #1: 1	تَصْحِيحُ الْإِجْزَاءِ
u'تَصْحِيحٌ أحَدٌ':Added, #1: 1	تَصْحِيحِ أَحَادِيثِ
u'تَصْحِيحٌ أخْبَارٌ':Added, #1: 1	تَصْحِيحِ أَحَدٍ
u'تَصْحِيحٌ أَخْبَارٌ':Added, #1: 1	تَصْحِيحِ الأَخْبَارِ
u'تَصْحِيحٌ أُسْتَاذٌ':Added, #1: 1	تَصْحِيحِ الأَخْبَارِ
u'تَصْحِيحٌ اِسْتِئْجَارٌ':Added, #2: 2	تَصْحِيحِ الْأُسْتَاذِ
u'تَصْحِيحٌ إِسْلامٌ':Added, #1: 1	تَصْحِيحِ اسْتِئْجَارِ
u'تَصْحِيحٌ أسْئِلَةٌ':Added, #1: 1	تَصْحِيحُ إسْلَامِهِ
u'تَصْحِيحٌ أصل':Added, #1: 1	تَصْحِيحُ الْأَسْئِلَةِ
u'تَصْحِيحٌ أًصْلٌ':Added, #1: 1	تَصْحِيحِ أَصْلِ
u'تَصْحِيحٌ أصل':Added, #1: 1	تَصْحِيحِ أَصْلِ
u'تَصْحِيحٌ أصل':Added, #1: 1	تَصْحِيحَ الْأَصْلِ
u'تَصْحِيحٌ أصل':Added, #1: 1	تَصْحِيحُ الْأَصْلِ
u'تَصْحِيحٌ أًصْلٌ':Added, #1: 1	تَصْحِيحِ الْأَصْلِ
u'تَصْحِيحٌ أًصْلٌ':Added, #1: 1	تَصْحِيحَ الْأَصْلِ
u'تَصْحِيحٌ أًصْلٌ':Added, #1: 1	تَصْحِيحُ الْأَصْلِ
u'تَصْحِيحٌ إِطْلاقٌ':Added, #1: 1	تَصْحِيحِ الْأَصْلِ
u'تَصْحِيحٌ اِعْتِبارٌ':Added, #1: 1	تَصْحِيحُ إطْلَاقِ
u'تَصْحِيحٌ اِعْتِبارٌ':Added, #1: 1	تَصْحِيحُ اعْتِبَارٍ
u'تَصْحِيحٌ اِعْتِبارٌ':Added, #1: 1	تَصْحِيحُ اعْتِبَارِ
u'تَصْحِيحٌ إقْرَارٌ':Added, #1: 1	تَصْحِيحِ اعْتِبَارِ
u'تَصْحِيحٌ إقْرَارٌ':Added, #1: 1	تَصْحِيحُ إقْرَارِهِ
u'تَصْحِيحٌ إقْرَارٌ':Added, #1: 1	تَصْحِيحِ الْإِقْرَارِ
u'تَصْحِيحٌ أَقْسَامٌ':Added, #2: 2	تَصْحِيحَ إقْرَارِهِ
u'تَصْحِيحٌ أَكْثَرُ':Added, #1: 1	تَصْحِيحُ الْأَقْسَامِ
u'تَصْحِيحٌ أَلْفِيَّةٌ':Added, #2: 2	تَصْحِيحَ الْأَكْثَرِ
u'تَصْحِيحٌ إمَامٌ':Added, #1: 1	تَصْحِيحِ أَلْفِيَّةِ
u'تَصْحِيحٌ أُمَّةٌ':Added, #8: 8	تَصْحِيحِ الْإِمَامِ
u'تَصْحِيحٌ أَوَّلُ':Added, #1: 1	تَصْحِيحَ الْأُمَّةِ
u'تَصْحِيحٌ أَوَّلُ':Added, #2: 2	تَصْحِيحَ الْأَوَّلِ
u'تَصْحِيحٌ أَوَّلُ':Added, #2: 2	تَصْحِيحِ الْأَوَّلِ
u'تَصْحِيحٌ إِيجَابٌ':Added, #6: 6	تَصْحِيحُ الْأَوَّلِ
u'تَصْحِيحٌ بَعْضٌ':Added, #1: 1	تَصْحِيحُ إيجَابِ
u'تَصْحِيحٌ بَيْعٌ':Added, #2: 2	تَصْحِيحِ بَعْضِ
u'تَصْحِيحٌ بَيْعٌ':Added, #1: 1	تَصْحِيحَ الْبَيْعِ
u'تَصْحِيحٌ بَيْعٌ':Added, #1: 1	تَصْحِيحُ بَيْعِهِ
u'تَصْحِيحٌ تَأْجِيلٌ':Added, #3: 3	تَصْحِيحُ الْبَيْعِ
u'تَصْحِيحٌ تَحْرِيمٌ':Added, #1: 1	تَصْحِيحُ التَّأْجِيلِ
u'تَصْحِيحٌ تَحْرِيمٌ':Added, #1: 1	تَصْحِيحُ التَّحْرِيمِ
u'تَصْحِيحٌ تَسْمِيَة':Added, #1: 1	تَصْحِيحِ تَحْرِيمِ
u'تَصْحِيحٌ تَسْمِيَة':Added, #1: 1	تَصْحِيحُ التَّسْمِيَةِ
u'تَصْحِيحٌ تَشْطِيرٌ':Added, #2: 2	تَصْحِيحُ تَسْمِيَةِ
u'تَصْحِيحٌ تَصْدِيقٌ':Added, #1: 1	تَصْحِيحَ التَّشْطِيرِ
u'تَصْحِيحٌ تَصَرُّفٌ':Added, #1: 1	تَصْحِيحُ تَصْدِيقِ
u'تَصْحِيحٌ تَصَرُّفٌ':Added, #1: 1	تَصْحِيحُ التَّصَرُّفِ
u'تَصْحِيحٌ تَصَرُّفٌ':Added, #1: 1	تَصْحِيحِ تَصَرُّفِ
u'تَصْحِيحٌ تَصَرُّفٌ':Added, #1: 1	تَصْحِيحَ تَصَرُّفِهِ
u'تَصْحِيحٌ تَعْلِيلٌ':Added, #2: 2	تَصْحِيحِ التَّصَرُّفِ
u'تَصْحِيحٌ تَعْيِينٌ':Added, #1: 1	تَصْحِيحِ التَّعْلِيلِ
u'تَصْحِيحٌ تَقْسِيمٌ':Added, #1: 1	تَصْحِيحُ التَّعْيِينِ
u'تَصْحِيحٌ تَكْريرٌ':Added, #1: 1	تَصْحِيحَ تَقْسِيمِهِ
u'تَصْحِيحٌ تَمْلِيك':Added, #1: 1	تَصْحِيحِ التَّكْرِيرِ
u'تَصْحِيحٌ تَنْبِيه':Added, #1: 1	تَصْحِيحُ التَّمْلِيكِ
u'تَصْحِيحٌ تَنْبِيه':Added, #19: 19	تَصْحِيحِ التَّنْبِيهِ
u'تَصْحِيحٌ تَنْفِيذٌ':Added, #1: 1	تَصْحِيحُ التَّنْبِيهِ
u'تَصْحِيحٌ تَهْذِيبٌ':Added, #1: 1	تَصْحِيحَ التَّنْفِيذِ
u'تَصْحِيحٌ جَمَاعَةٌ':Added, #1: 1	تَصْحِيحِ التَّهْذِيبِ
u'تَصْحِيحٌ جُمْهُورٌ':Added, #1: 1	تَصْحِيحِ جَمَاعَاتٍ
u'تَصْحِيحٌ جَوَازٌ':Added, #1: 1	تَصْحِيحِ الْجُمْهُورِ
u'تَصْحِيحٌ جَوَازٌ':Added, #1: 1	تَصْحِيحَ الْجَوَازِ
u'تَصْحِيحٌ حاكِمٌ':Added, #3: 3	تَصْحِيحُ الْجَوَازِ
u'تَصْحِيحٌ حَجٌّ':Added, #1: 1	تَصْحِيحِ الْحَاكِمِ
u'تَصْحِيحٌ حَديثٌ':Added, #1: 1	تَصْحِيحَ الْحَجِّ
u'تَصْحِيحٌ حُروفٌ':Added, #1: 1	تَصْحِيحِ الْحَدِيثِ
u'تَصْحِيحٌ حُروفٌ':Added, #13: 13	تَصْحِيحُ الْحُرُوفِ
u'تَصْحِيحٌ حُروفٌ':Added, #1: 1	تَصْحِيحِ الْحُرُوفِ
u'تَصْحِيحٌ حساب':Added, #2: 2	تَصْحِيحَ الْحُرُوفِ
u'تَصْحِيحٌ حِسَابٌ':Added, #1: 1	تَصْحِيحَ الْحِسَابِ
u'تَصْحِيحٌ حساب':Added, #1: 1	تَصْحِيحَ الْحِسَابِ
u'تَصْحِيحٌ حِسَابٌ':Added, #1: 1	تَصْحِيحَ حِسَابِ
u'تَصْحِيحٌ حِلٌّ':Added, #1: 1	تَصْحِيحَ حِسَابِ
u'تَصْحِيحٌ حِلٌّ':Added, #1: 1	تَصْحِيحَ الْحِلِّ
u'تَصْحِيحٌ حَيْضٌ':Added, #1: 1	تَصْحِيحُ حِلِّهِ
u'تَصْحِيحٌ خطبة':Added, #1: 1	تَصْحِيحِ الْحَيْضِ
u'تَصْحِيحٌ خُطْبَةٌ':Added, #1: 1	تَصْحِيحِ خُطْبَةِ
u'تَصْحِيحٌ خِلاَفٌ':Added, #1: 1	تَصْحِيحِ خُطْبَةِ
u'تَصْحِيحٌ خِلاَفٌ':Added, #1: 1	تَصْحِيحِ الْخِلَافِ
u'تَصْحِيحٌ خِلاَفٌ':Added, #1: 1	تَصْحِيحُ خِلَافِهِ
u'تَصْحِيحٌ دُخُولٌ':Added, #1: 1	تَصْحِيحِ خِلَافِهِ
u'تَصْحِيحٌ دَعْوَةٌ':Added, #2: 2	تَصْحِيحُ دُخُولِهِ
u'تَصْحِيحٌ دَعْوَةٌ':Added, #1: 1	تَصْحِيحِ الدَّعْوَةِ
u'تَصْحِيحٌ دَعْوَةٌ':Added, #1: 1	تَصْحِيحِ دَعْوَتِهِ
u'تَصْحِيحٌ دَليلٌ':Added, #3: 3	تَصْحِيحِ دَعْوَةِ
u'تَصْحِيحٌ دَوْرٌ':Added, #1: 1	تَصْحِيحُ الدَّلِيلِ
u'تَصْحِيحٌ دَوْرٌ':Added, #1: 1	تَصْحِيحَ الدَّوْرِ
u'تَصْحِيحٌ رِواياتٌ':Added, #6: 6	تَصْحِيحِ الدَّوْرِ
u'تَصْحِيحٌ رِوايَةٌ':Added, #1: 1	تَصْحِيحِ الرِّوَايَاتِ
u'تَصْحِيحٌ زِيادَةٌ':Added, #2: 2	تَصْحِيحِ رِوَايَةِ
u'تَصْحِيحٌ زِيادَةٌ':Added, #1: 1	تَصْحِيحُ زِيَادَةٍ
u'تَصْحِيحٌ سُجُودٌ':Added, #3: 3	تَصْحِيحُ الزِّيَادَةِ
u'تَصْحِيحٌ سِرَاجٌ':Added, #1: 1	تَصْحِيحَ سُجُودِ
u'تَصْحِيحٌ سُقُوطٌ':Added, #1: 1	تَصْحِيحُ السِّرَاجِ
u'تَصْحِيحٌ سُنَّةٌ':Added, #1: 1	تَصْحِيحَ سُقُوطِ
u'تَصْحِيحٌ سُؤَالٌ':Added, #1: 1	تَصْحِيحُ السُّنَّةِ
u'تَصْحِيحٌ شُرُوعٌ':Added, #1: 1	تَصْحِيحِ السُّؤَالِ
u'تَصْحِيحٌ شَهَادَةٌ':Added, #1: 1	تَصْحِيحِ الشُّرُوعِ
u'تَصْحِيحٌ شَهَادَةٌ':Added, #1: 1	تَصْحِيحَ شَهَادَةِ
u'تَصْحِيحٌ شَهَادَةٌ':Added, #1: 1	تَصْحِيحِ شَهَادَةِ
u'تَصْحِيحٌ شَهِيدٌ':Added, #2: 2	تَصْحِيحِ شَهَادَتِهِ
u'تَصْحِيحٌ شَيْخٌ':Added, #1: 1	تَصْحِيحِ الشَّهِيدِ
u'تَصْحِيحٌ شَيْخٌ':Added, #1: 1	تَصْحِيحِ الشَّيْخَيْنِ
u'تَصْحِيحٌ شَيْخٌ':Added, #2: 2	تَصْحِيحَ الشَّيْخَيْنِ
u'تَصْحِيحٌ صِحَّةٌ':Added, #6: 6	تَصْحِيحِ الشَّيْخِ
u'تَصْحِيحٌ صِحَّةٌ':Added, #1: 1	تَصْحِيحِ الصِّحَّةِ
u'تَصْحِيحٌ صِحَّةٌ':Added, #5: 5	تَصْحِيحَ الصِّحَّةِ
u'تَصْحِيحٌ صَحِيحٌ':Added, #6: 6	تَصْحِيحُ الصِّحَّةِ
u'تَصْحِيحٌ صَلاَةٌ':Added, #1: 1	تَصْحِيحُ الصَّحِيحِ
u'تَصْحِيحٌ صلح':Added, #1: 1	تَصْحِيحِ صَلَاتِهِ
u'تَصْحِيحٌ صُلْحٌ':Added, #1: 1	تَصْحِيحِ الصُّلْحِ
u'تَصْحِيحٌ صلح':Added, #1: 1	تَصْحِيحِ الصُّلْحِ
u'تَصْحِيحٌ صُلْحٌ':Added, #2: 2	تَصْحِيحَ الصُّلْحِ
u'تَصْحِيحٌ صَوْمٌ':Added, #2: 2	تَصْحِيحَ الصُّلْحِ
u'تَصْحِيحٌ صَيْدَلانِيّ':Added, #1: 1	تَصْحِيحِ الصَّوْمِ
u'تَصْحِيحٌ ضَمَانٌ':Added, #3: 3	تَصْحِيحِ الصَّيْدَلَانِيِّ
u'تَصْحِيحٌ ضَمَانٌ':Added, #1: 1	تَصْحِيحِ الضَّمَانِ
u'تَصْحِيحٌ ضَمَانٌ':Added, #1: 1	تَصْحِيحُ ضَمَانِهِ
u'تَصْحِيحٌ طَهَارَةٌ':Added, #2: 2	تَصْحِيحَ الضَّمَانِ
u'تَصْحِيحٌ طهر':Added, #2: 2	تَصْحِيحُ طَهَارَتِهِ
u'تَصْحِيحٌ طُهْرٌ':Added, #1: 1	تَصْحِيحِ الطُّهْرِ
u'تَصْحِيحٌ ظَهِير':Added, #1: 1	تَصْحِيحِ الطُّهْرِ
u'تَصْحِيحٌ ظَهِيرَة':Added, #1: 1	تَصْحِيحَ الظَّهِيرِيَّةِ
u'تَصْحِيحٌ عِبَارَةٌ':Added, #1: 1	تَصْحِيحَ الظَّهِيرِيَّةِ
u'تَصْحِيحٌ عِبَارَةٌ':Added, #1: 1	تَصْحِيحُ عِبَارَةِ
u'تَصْحِيحٌ عِبَارَةٌ':Added, #1: 1	تَصْحِيحَ عِبَارَتِهِ
u'تَصْحِيحٌ عتق':Added, #1: 1	تَصْحِيحِ عِبَارَتِهِ
u'تَصْحِيحٌ عِتْقٌ':Added, #1: 1	تَصْحِيحِ عِتْقِهِ
u'تَصْحِيحٌ عَدَمٌ':Added, #1: 1	تَصْحِيحِ عِتْقِهِ
u'تَصْحِيحٌ عَدَمٌ':Added, #3: 3	تَصْحِيحَ عَدَمِ
u'تَصْحِيحٌ عَدَمٌ':Added, #6: 6	تَصْحِيحِ عَدَمِ
u'تَصْحِيحٌ عَقْدٌ':Added, #9: 9	تَصْحِيحُ عَدَمِ
u'تَصْحِيحٌ عَقْدٌ':Added, #1: 1	تَصْحِيحَ عَقْدِ
u'تَصْحِيحٌ عَقْدٌ':Added, #2: 2	تَصْحِيحَ الْعَقْدِ
u'تَصْحِيحٌ عَقْدٌ':Added, #5: 5	تَصْحِيحُ الْعَقْدِ
u'تَصْحِيحٌ عَكْسٌ':Added, #8: 8	تَصْحِيحِ الْعَقْدِ
u'تَصْحِيحٌ عَكْسٌ':Added, #1: 1	تَصْحِيحُ الْعَكْسِ
u'تَصْحِيحٌ عَكْسٌ':Added, #1: 1	تَصْحِيحُ عَكْسِهِ
u'تَصْحِيحٌ عِلَّةٌ':Added, #2: 2	تَصْحِيحَ عَكْسِهِ
u'تَصْحِيحٌ عِلَّةٌ':Added, #1: 1	تَصْحِيحَ الْعِلَّةِ
u'تَصْحِيحٌ عِلَّةٌ':Added, #1: 1	تَصْحِيحُ الْعِلَّةِ
u'تَصْحِيحٌ عِلَّةٌ':Added, #1: 1	تَصْحِيحِ عِلَّتِهِ
u'تَصْحِيحٌ عَمَلٌ':Added, #2: 2	تَصْحِيحِ الْعِلَّةِ
u'تَصْحِيحٌ فخر':Added, #1: 1	تَصْحِيحِ الْعَمَلِ
u'تَصْحِيحٌ فَخْرٌ':Added, #1: 1	تَصْحِيحَ فَخْرِ
u'تَصْحِيحٌ فُرُوعٌ':Added, #1: 1	تَصْحِيحَ فَخْرِ
u'تَصْحِيحٌ فَرِيضَةٌ':Added, #1: 1	تَصْحِيحِ الْفُرُوعِ
u'تَصْحِيحٌ فَرِيضَةٌ':Added, #1: 1	تَصْحِيحَ الْفَرِيضَةِ
u'تَصْحِيحٌ فَسْخٌ':Added, #1: 1	تَصْحِيحِ الْفَرِيضَةِ
u'تَصْحِيحٌ فقهاء':Added, #1: 1	تَصْحِيحِ الْفَسْخِ
u'تَصْحِيحٌ قَبُولٌ':Added, #1: 1	تَصْحِيحَ الْفُقَهَاءِ
u'تَصْحِيحٌ قسمة':Added, #1: 1	تَصْحِيحَ قَبُولِ
u'تَصْحِيحٌ قِسْمَةٌ':Added, #1: 1	تَصْحِيحُ قِسْمَةِ
u'تَصْحِيحٌ قَضَاءٌ':Added, #1: 1	تَصْحِيحُ قِسْمَةِ
u'تَصْحِيحٌ قول':Added, #1: 1	تَصْحِيحِ الْقَضَاءِ
u'تَصْحِيحٌ قول':Added, #1: 1	تَصْحِيحَ الْقَوْلِ
u'تَصْحِيحٌ قَوْلٌ':Added, #1: 1	تَصْحِيحُ الْقَوْلِ
u'تَصْحِيحٌ قَوْلٌ':Added, #1: 1	تَصْحِيحَ الْقَوْلِ
u'تَصْحِيحٌ قول':Added, #1: 1	تَصْحِيحُ الْقَوْلِ
u'تَصْحِيحٌ قول':Added, #1: 1	تَصْحِيحُ قَوْلِهِ
u'تَصْحِيحٌ قَوْلٌ':Added, #1: 1	تَصْحِيحِ قَوْلِهِ
u'تَصْحِيحٌ قَوْلٌ':Added, #1: 1	تَصْحِيحُ قَوْلِهِ
u'تَصْحِيحٌ قول':Added, #1: 1	تَصْحِيحِ قَوْلِهِ
u'تَصْحِيحٌ قَوْلٌ':Added, #2: 2	تَصْحِيحُ قَوْلِ
u'تَصْحِيحٌ قول':Added, #2: 2	تَصْحِيحُ قَوْلِ
u'تَصْحِيحٌ قَوْلٌ':Added, #4: 4	تَصْحِيحِ قَوْلِ
u'تَصْحِيحٌ كِتَابٌ':Added, #4: 4	تَصْحِيحِ قَوْلِ
u'تَصْحِيحٌ كِتَابٌ':Added, #1: 1	تَصْحِيحَ الْكِتَابِ
u'تَصْحِيحٌ كِتَابَةٌ':Added, #1: 1	تَصْحِيحُ الْكِتَابِ
u'تَصْحِيحٌ كَلاَمٌ':Added, #1: 1	تَصْحِيحُ كِتَابَتِهِ
u'تَصْحِيحٌ كَلاَمٌ':Added, #2: 2	تَصْحِيحِ الْكَلَامِ
u'تَصْحِيحٌ كَلاَمٌ':Added, #3: 3	تَصْحِيحَ كَلَامِ
u'تَصْحِيحٌ كَلاَمٌ':Added, #3: 3	تَصْحِيحُ كَلَامِهِ
u'تَصْحِيحٌ كَلاَمٌ':Added, #4: 4	تَصْحِيحُ الْكَلَامِ
u'تَصْحِيحٌ كَوْنٌ':Added, #4: 4	تَصْحِيحِ كَلَامِ
u'تَصْحِيحٌ كَوْنٌ':Added, #1: 1	تَصْحِيحُ كَوْنِ
u'تَصْحِيحٌ لَفْظٌ':Added, #1: 1	تَصْحِيحُ كَوْنِهِ
u'تَصْحِيحٌ لَفْظٌ':Added, #1: 1	تَصْحِيحُ اللَّفْظِ
u'تَصْحِيحٌ لَفْظٌ':Added, #1: 1	تَصْحِيحِ لَفْظٍ
u'تَصْحِيحٌ مَجَازٌ':Added, #7: 7	تَصْحِيحَ اللَّفْظِ
u'تَصْحِيحٌ مَجْمُوعٌ':Added, #1: 1	تَصْحِيحِ الْمَجَازِ
u'تَصْحِيحٌ مُحَرَّرٌ':Added, #1: 1	تَصْحِيحَ الْمَجْمُوعِ
u'تَصْحِيحٌ مُحَرَّرٌ':Added, #153: 153	تَصْحِيحِ الْمُحَرَّرِ
u'تَصْحِيحٌ مُحِيطٌ':Added, #1: 1	تَصْحِيحُ الْمُحَرَّرِ
u'تَصْحِيحٌ مَذْهَبٌ':Added, #1: 1	تَصْحِيحُ الْمُحِيطِ
u'تَصْحِيحٌ مَذْهَبٌ':Added, #1: 1	تَصْحِيحَ الْمَذْهَبِ
u'تَصْحِيحٌ مَسْأَلَةٌ':Added, #2: 2	تَصْحِيحِ مَذْهَبِ
u'تَصْحِيحٌ مَسْأَلَةٌ':Added, #1: 1	تَصْحِيحُ الْمَسْأَلَةِ
u'تَصْحِيحٌ مَسَائِلُ':Added, #1: 1	تَصْحِيحِ مَسْأَلَةِ
u'تَصْحِيحٌ مُقَابِلٌ':Added, #5: 5	تَصْحِيحِ الْمَسَائِلِ
u'تَصْحِيحٌ مَقَالَةٌ':Added, #2: 2	تَصْحِيحَ مُقَابِلِهِ
u'تَصْحِيحٌ مُقْنِعٌ':Added, #1: 1	تَصْحِيحِ مَقَالَتِهِ
u'تَصْحِيحٌ مَنْعٌ':Added, #1: 1	تَصْحِيحِ الْمُقْنِعِ
u'تَصْحِيحٌ مَنْعٌ':Added, #1: 1	تَصْحِيحُ مَنْعِ
u'تَصْحِيحٌ مَنْعٌ':Added, #3: 3	تَصْحِيحُ الْمَنْعِ
u'تَصْحِيحٌ مَنْقُولٌ':Added, #3: 3	تَصْحِيحِ الْمَنْعِ
u'تَصْحِيحٌ مِنْهَاجٌ':Added, #1: 1	تَصْحِيحِ الْمَنْقُولِ
u'تَصْحِيحٌ مُؤَلِّفٌ':Added, #9: 9	تَصْحِيحِ الْمِنْهَاجِ
u'تَصْحِيحٌ نَجَاسَةٌ':Added, #1: 1	تَصْحِيحُ الْمُؤَلِّفِ
u'تَصْحِيحٌ نَسَبٌ':Added, #1: 1	تَصْحِيحُ النَّجَاسَةِ
u'تَصْحِيحٌ نسخة':Added, #1: 1	تَصْحِيحُ النَّسَبِ
u'تَصْحِيحٌ نُسْخَةٌ':Added, #1: 1	تَصْحِيحُ نُسْخَةِ
u'تَصْحِيحٌ نَظْمٌ':Added, #1: 1	تَصْحِيحُ نُسْخَةِ
u'تَصْحِيحٌ نقل':Added, #1: 1	تَصْحِيحِ النَّظْمِ
u'تَصْحِيحٌ نَقْلٌ':Added, #1: 1	تَصْحِيحِ النَّقْلِ
u'تَصْحِيحٌ نقل':Added, #1: 1	تَصْحِيحِ النَّقْلِ
u'تَصْحِيحٌ نَقْلٌ':Added, #2: 2	تَصْحِيحُ النَّقْلِ
u'تَصْحِيحٌ نكاح':Added, #2: 2	تَصْحِيحُ النَّقْلِ
u'تَصْحِيحٌ نِكَاحٌ':Added, #2: 2	تَصْحِيحِ النِّكَاحِ
u'تَصْحِيحٌ نِهَايَةٌ':Added, #2: 2	تَصْحِيحِ النِّكَاحِ
u'تَصْحِيحٌ نَوَوِيٌّ':Added, #2: 2	تَصْحِيحَ النِّهَايَةِ
u'تَصْحِيحٌ نَوَوِيٌّ':Added, #1: 1	تَصْحِيحَ النَّوَوِيِّ
u'تَصْحِيحٌ نَوَوِيٌّ':Added, #3: 3	تَصْحِيحُ النَّوَوِيِّ
u'تَصْحِيحٌ نِيَّةٌ':Added, #3: 3	تَصْحِيحِ النَّوَوِيِّ
u'تَصْحِيحٌ نِيَّةٌ':Added, #1: 1	تَصْحِيحُ النِّيَّةِ
u'تَصْحِيحٌ نِيَّةٌ':Added, #1: 1	تَصْحِيحُ نِيَّتِهِ
u'تَصْحِيحٌ هِدَايَةٌ':Added, #2: 2	تَصْحِيحِ النِّيَّةِ
u'تَصْحِيحٌ هَرَوِيّ':Added, #2: 2	تَصْحِيحِ الْهِدَايَةِ
u'تَصْحِيحٌ وَالِدٌ':Added, #2: 2	تَصْحِيحِ الْهَرَوِيِّ
u'تَصْحِيحٌ وَجْهٌ':Added, #1: 1	تَصْحِيحِ الْوَالِدِ
u'تَصْحِيحٌ وُجُوبٌ':Added, #1: 1	تَصْحِيحِ الْوَجْهِ
u'تَصْحِيحٌ وُجُوبٌ':Added, #1: 1	تَصْحِيحُ الْوُجُوبِ
u'تَصْحِيحٌ وُجُوبٌ':Added, #1: 1	تَصْحِيحَ وُجُوبِ
u'تَصْحِيحٌ وَصِيٌّ':Added, #3: 3	تَصْحِيحُ وُجُوبِ
u'تَصْحِيحٌ وَصِيٌّ':Added, #1: 1	تَصْحِيحَ الْوَصِيَّةِ
u'تَصْحِيحٌ وَصِيٌّ':Added, #1: 1	تَصْحِيحُ الْوَصِيَّةِ
u'تَصْحِيحٌ وَصِيٌّ':Added, #1: 1	تَصْحِيحِ الْوَصِيَّةِ
u'تَصْحِيحٌ وَصِيَّةٌ':Added, #1: 1	تَصْحِيحِ وَصِيَّتِهِ
u'تَصْحِيحٌ وَصِيَّةٌ':Added, #1: 1	تَصْحِيحَ الْوَصِيَّةِ
u'تَصْحِيحٌ وَصِيَّةٌ':Added, #1: 1	تَصْحِيحُ الْوَصِيَّةِ
u'تَصْحِيحٌ وَصِيَّةٌ':Added, #1: 1	تَصْحِيحِ الْوَصِيَّةِ
u'تَصْحِيحٌ وَقْفٌ':Added, #1: 1	تَصْحِيحِ وَصِيَّتِهِ
u'تَصْحِيحٌ وَقْفٌ':Added, #2: 2	تَصْحِيحُ الْوَقْفِ
u'تَصْحِيحٌ وُقُوعٌ':Added, #3: 3	تَصْحِيحَ الْوَقْفِ
u'تَصْحِيحٌ وِلاَيَةٌ':Added, #1: 1	تَصْحِيحِ الْوُقُوعِ
u'تَصْحِيحٌ يَمِينٌ':Added, #1: 1	تَصْحِيحُ وِلَايَةِ
u'تَصْحِيفٌ نُسَّاخٌ':Added, #1: 1	تَصْحِيحُ الْيَمِينِ
u'تَصَدَّعَ بِنَاءٌ':Subject, #1: 1	تَصْحِيفِ النُّسَّاخِ
u'تَصَدَّعَ حول':Predicate, #1: 1	تَصَدَّعَ بِنَاءُ
u'تَصَدَّعَ حَوْلٌ':Predicate, #1: 1	تَصَدَّعَ حَوْلَ
u'تَصَدَّقَ أحَدٌ':Subject, #1: 1	تَصَدَّعَ حَوْلَ
u'تَصَدَّقَ أَخٌ':Subject, #2: 2	تَصَدَّقَ أَحَدٌ
u'تَصَدَّقَ اِشْتِباهٌ':Subject, #1: 1	تَصَدَّقَ الْأَخُ
u'تَصَدَّقَ اِمْرُؤٌ':Subject, #2: 2	تَصَدَّقَ اشْتِبَاهٌ
u'تَصَدَّقَ جَازٌ':Predicate, #1: 1	تَصَدَّقَ امْرُؤٌ
u'تَصَدَّقَ رَجُلٌ':Subject, #1: 1	تَصَدَّقَ جَازَ
u'تَصَدَّقَ رَجُلٌ':Subject, #3: 3	تَصَدَّقَ الرَّجُلُ
u'تَصَدَّقَ شَيْخٌ':Subject, #5: 5	تَصَدَّقَ رَجُلٌ
u'تَصَدَّقَ ضَمِنٌ':Predicate, #1: 1	تَصَدَّقَ الشَّيْخُ
u'تَصَدَّقَ عند':Predicate, #2: 2	تَصَدَّقَ ضَمِنَ
u'تَصَدَّقَ غَاصِبٌ':Subject, #2: 2	تَصَدَّقَ عِنْدَ
u'تَصَدَّقَ فُلاَنٌ':Subject, #2: 2	تَصَدَّقَ الْغَاصِبُ
u'تَصَدَّقَ لَيْلٌ':Predicate, #1: 1	تَصَدَّقَ فُلَانٌ
u'تَصَدَّقَ مَأْمُورٌ':Subject, #2: 2	تَصَدَّقَ اللَّيْلَةَ
u'تَصَدُّقٌ مَدِينٌ':Added, #3: 3	تَصَدَّقَ الْمَأْمُورُ
u'تَصَدَّقَ مَرِيضٌ':Subject, #1: 1	تَصَدُّقِ الْمَدِينِ
u'تَصَدُّقٌ مُلْتَقِط':Added, #1: 1	تَصَدَّقَ الْمَرِيضُ
u'تَصَدُّقٌ مُلْتَقِط':Added, #1: 1	تَصَدُّقُ الْمُلْتَقِطِ
u'تَصَدَّقَ مَوْهُوبٌ':Subject, #1: 1	تَصَدُّقِ الْمُلْتَقِطِ
u'تَصَدَّقَ وَارِثٌ':Subject, #1: 1	تَصَدَّقَ الْمَوْهُوبُ
u'تَصْدِيرٌ حَدٌّ':Added, #1: 1	تَصَدَّقَ الْوَارِثُ
u'تَصْدِيرٌ كِتَابٌ':Added, #1: 1	تَصْدِيرُ حَدِّهِ
u'تَصَدَّى شَيْخٌ':Subject, #1: 1	تَصْدِيرُ كِتَابِ
u'تَصْدِيقٌ أَبٌ':Added, #1: 1	تَصَدَّى الشَّيْخُ
u'تَصْدِيقٌ أَبٌ':Added, #1: 1	تَصْدِيقَ الْأَبِ
u'تَصْدِيقٌ أَبٌ':Added, #1: 1	تَصْدِيقِ الْأَبِ
u'تَصْدِيقٌ أَخٌ':Added, #2: 2	تَصْدِيقُ الْأَبِ
u'تَصْدِيقٌ أَخٌ':Added, #2: 2	تَصْدِيقَ الْأَخِ
u'تَصْدِيقٌ إِخْبَارٌ':Added, #2: 2	تَصْدِيقِ الْأَخِ
u'تَصْدِيقٌ الْمَرْأَةُ':Added, #1: 1	تَصْدِيقِ الْإِخْبَارِ
u'تَصْدِيقٌ الْمَرْأَةُ':Added, #1: 1	تَصْدِيقُ الْمَرْأَةِ
u'تَصْدِيقٌ إمَامٌ':Added, #6: 6	تَصْدِيقِ الْمَرْأَةِ
u'تَصْدِيقٌ إمَامٌ':Added, #1: 1	تَصْدِيقِ الْإِمَامِ
u'تَصْدِيقٌ أمَةٌ':Added, #2: 2	تَصْدِيقُ الْإِمَامِ
u'تَصْدِيقٌ أَمَلٌ':Added, #1: 1	تَصْدِيقِ الْأَمَةِ
u'تَصْدِيقٌ بالِغٌ':Added, #1: 1	تَصْدِيقُ الْأَمَلِ
u'تَصْدِيقٌ بَائِعٌ':Added, #1: 1	تَصْدِيقُ بَالِغٍ
u'تَصْدِيقٌ بَائِعٌ':Added, #4: 4	تَصْدِيقَ الْبَائِعِ
u'تَصْدِيقٌ بَائِعٌ':Added, #5: 5	تَصْدِيقِ الْبَائِعِ
u'تَصْدِيقٌ تُهَمٌ':Added, #6: 6	تَصْدِيقُ الْبَائِعِ
u'تَصْدِيقٌ خَبَرٌ':Added, #1: 1	تَصْدِيقِ التُّهَمِ
u'تَصْدِيقٌ خَبَر':Added, #2: 2	تَصْدِيقُ خَبَرٍ
u'تَصْدِيقٌ خَصْمٌ':Added, #2: 2	تَصْدِيقُ خَبَرٍ
u'تَصْدِيقٌ خَصْمٌ':Added, #1: 1	تَصْدِيقُ الْخَصْمِ
u'تَصْدِيقٌ خَصْمٌ':Added, #2: 2	تَصْدِيقِ الْخَصْمِ
u'تَصْدِيقٌ دَافِعٌ':Added, #3: 3	تَصْدِيقِ خَصْمِهِ
u'تَصْدِيقٌ دَافِعٌ':Added, #1: 1	تَصْدِيقُ الدَّافِعِ
u'تَصْدِيقٌ دَافِعٌ':Added, #1: 1	تَصْدِيقِ دَافِعِهِ
u'تَصْدِيقٌ رَاكِبٌ':Added, #2: 2	تَصْدِيقِ الدَّافِعِ
u'تَصْدِيقٌ رَاهِنٌ':Added, #1: 1	تَصْدِيقِ الرَّاكِبِ
u'تَصْدِيقٌ رَبُّ':Added, #1: 1	تَصْدِيقِ الرَّاهِنِ
u'تَصْدِيقٌ رَبُّ':Added, #1: 1	تَصْدِيقَ رَبِّ
u'تَصْدِيقٌ رَبُّ':Added, #1: 1	تَصْدِيقُ رَبِّ
u'تَصْدِيقٌ رُسُلٌ':Added, #2: 2	تَصْدِيقِ رَبِّ
u'تَصْدِيقٌ رُسُلٌ':Added, #1: 1	تَصْدِيقَ الرُّسُلِ
u'تَصْدِيقٌ رَسُولٌ':Added, #1: 1	تَصْدِيقُ الرُّسُلِ
u'تَصْدِيقٌ زَوْجٌ':Added, #1: 1	تَصْدِيقِ رَسُولِ
u'تَصْدِيقٌ زَوْجٌ':Added, #10: 10	تَصْدِيقِ الزَّوْجِ
u'تَصْدِيقٌ زَوْجٌ':Added, #2: 2	تَصْدِيقَ الزَّوْجِ
u'تَصْدِيقٌ زَوْجَةٌ':Added, #9: 9	تَصْدِيقُ الزَّوْجِ
u'تَصْدِيقٌ سَيِّدٌ':Added, #3: 3	تَصْدِيقُ الزَّوْجَةِ
u'تَصْدِيقٌ سَيِّدٌ':Added, #1: 1	تَصْدِيقَ سَيِّدِهِ
u'تَصْدِيقٌ سَيِّدٌ':Added, #1: 1	تَصْدِيقِ سَيِّدِهِ
u'تَصْدِيقٌ سَيِّدٌ':Added, #2: 2	تَصْدِيقَ السَّيِّدِ
u'تَصْدِيقٌ شَخْصٌ':Added, #2: 2	تَصْدِيقِ السَّيِّدِ
u'تَصْدِيقٌ شُهُودٌ':Added, #1: 1	تَصْدِيقِ الشَّخْصِ
u'تَصْدِيقٌ صَاحِبٌ':Added, #3: 3	تَصْدِيقُ الشُّهُودِ
u'تَصْدِيقٌ عَامِلٌ':Added, #4: 4	تَصْدِيقِ صَاحِبِهِ
u'تَصْدِيقٌ عَامِلٌ':Added, #1: 1	تَصْدِيقَ الْعَامِلِ
u'تَصْدِيقٌ عَامِلٌ':Added, #1: 1	تَصْدِيقُ الْعَامِلِ
u'تَصْدِيقٌ عَبْدٌ':Added, #1: 1	تَصْدِيقِ الْعَامِلِ
u'تَصْدِيقٌ عَبْدٌ':Added, #1: 1	تَصْدِيقُ الْعَبْدِ
u'تَصْدِيقٌ غَاصِبٌ':Added, #4: 4	تَصْدِيقِ الْعَبْدِ
u'تَصْدِيقٌ غَاصِبٌ':Added, #1: 1	تَصْدِيقُ الْغَاصِبِ
u'تَصْدِيقٌ غرماء':Added, #1: 1	تَصْدِيقِ الْغَاصِبِ
u'تَصْدِيقٌ غَرِيمٌ':Added, #1: 1	تَصْدِيقِ غُرَمَاءِ
u'تَصْدِيقٌ غُلاَمٌ':Added, #1: 1	تَصْدِيقِ الْغَرِيمِ
u'تَصْدِيقٌ قَاتِلٌ':Added, #1: 1	تَصْدِيقِ الْغُلَامِ
u'تَصْدِيقٌ قلب':Added, #1: 1	تَصْدِيقُ الْقَاتِلِ
u'تَصْدِيقٌ قَلْبٌ':Added, #1: 1	تَصْدِيقُ الْقَلْبِ
u'تَصْدِيقٌ قَلْب':Added, #1: 1	تَصْدِيقُ الْقَلْبِ
u'تَصْدِيقٌ قلب':Added, #1: 1	تَصْدِيقُ الْقَلْبِ
u'تَصْدِيقٌ قَلْبٌ':Added, #3: 3	تَصْدِيقِ الْقَلْبِ
u'تَصْدِيقٌ قَلْب':Added, #3: 3	تَصْدِيقِ الْقَلْبِ
u'تَصْدِيقٌ قول':Added, #3: 3	تَصْدِيقِ الْقَلْبِ
u'تَصْدِيقٌ قَوْلٌ':Added, #1: 1	تَصْدِيقُ قَوْلِهِ
u'تَصْدِيقٌ كَاهِنٌ':Added, #1: 1	تَصْدِيقُ قَوْلِهِ
u'تَصْدِيقٌ كَفِيلٌ':Added, #1: 1	تَصْدِيقُ الْكَاهِنِ
u'تَصْدِيقٌ كَيْلٌ':Added, #1: 1	تَصْدِيقُ الْكَفِيلِ
u'تَصْدِيقٌ مَالِكٌ':Added, #1: 1	تَصْدِيقِ الْكَيْلِ
u'تَصْدِيقٌ مَالِكٌ':Added, #10: 10	تَصْدِيقُ الْمَالِكِ
u'تَصْدِيقٌ مُجْبِرٌ':Added, #3: 3	تَصْدِيقِ الْمَالِكِ
u'تَصْدِيقٌ مَجْنِيٌّ':Added, #1: 1	تَصْدِيقُ الْمُجْبِرِ
u'تَصْدِيقٌ مُخْبِرٌ':Added, #1: 1	تَصْدِيقُ الْمَجْنِيِّ
u'تَصْدِيقٌ مُخْبِرٌ':Added, #1: 1	تَصْدِيقِ الْمُخْبِرِ
u'تَصْدِيقٌ مَدْحٌ':Added, #1: 1	تَصْدِيقِ مُخْبِرِهِ
u'تَصْدِيقٌ مَدْحٌ':Added, #1: 1	تَصْدِيقِ مَدْحٍ
u'تَصْدِيقٌ مَدْفُوعٌ':Added, #2: 2	تَصْدِيقِ الْمَدْحِ
u'تَصْدِيقٌ مَدْيُونٌ':Added, #1: 1	تَصْدِيقُ الْمَدْفُوعِ
u'تَصْدِيقٌ مُرْتَهِنٌ':Added, #2: 2	تَصْدِيقِ الْمَدْيُونِ
u'تَصْدِيقٌ مُرْتَهِنٌ':Added, #1: 1	تَصْدِيقُ الْمُرْتَهِنِ
u'تَصْدِيقٌ مُسْتَأْجِرٌ':Added, #2: 2	تَصْدِيقِ الْمُرْتَهِنِ
u'تَصْدِيقٌ مُسْلِمٌ':Added, #1: 1	تَصْدِيقِ الْمُسْتَأْجِرِ
u'تَصْدِيقٌ مَقَالٌ':Added, #1: 1	تَصْدِيقُ الْمُسْلِمِ
u'تَصْدِيقٌ مُكَاتَبَةٌ':Added, #1: 1	تَصْدِيقِ الْمَقَالَتَيْنِ
u'تَصْدِيقٌ مَكْفُولٌ':Added, #1: 1	تَصْدِيقِ الْمُكَاتَبَةِ
u'تَصْدِيقٌ مُنْكِرٌ':Added, #1: 1	تَصْدِيقَ الْمَكْفُولِ
u'تَصْدِيقٌ مُنْكِرٌ':Added, #1: 1	تَصْدِيقُ الْمُنْكِرِ
u'تَصْدِيقٌ مُودَعٌ':Added, #1: 1	تَصْدِيقِ الْمُنْكِرِ
u'تَصْدِيقٌ مُؤَذِّنٌ':Added, #1: 1	تَصْدِيقِ الْمُودَعِ
u'تَصْدِيقٌ مُوَكِّلٌ':Added, #1: 1	تَصْدِيقُ الْمُؤَذِّنِ
u'تَصْدِيقٌ مُوَكِّلٌ':Added, #1: 1	تَصْدِيقُ الْمُوَكِّلِ
u'تَصْدِيقٌ نَبِيٌّ':Added, #1: 1	تَصْدِيقِ الْمُوَكِّلِ
u'تَصْدِيقٌ نَبِيٌّ':Added, #1: 1	تَصْدِيقِ النَّبِيِّ
u'تَصْدِيقٌ نَفْسٌ':Added, #1: 1	تَصْدِيقِ نَبِيِّهِ
u'تَصْدِيقٌ نَمَّامٌ':Added, #2: 2	تَصْدِيقُ نَفْسِهِ
u'تَصْدِيقٌ وَارِثٌ':Added, #1: 1	تَصْدِيقِ النَّمَّامِ
u'تَصْدِيقٌ وَارِثٌ':Added, #1: 1	تَصْدِيقُ الْوَارِثِ
u'تَصْدِيقٌ وَالِدٌ':Added, #1: 1	تَصْدِيقُ وَارِثِ
u'تَصْدِيقٌ وَرَثَةٌ':Added, #1: 1	تَصْدِيقُ الْوَالِدِ
u'تَصْدِيقٌ وَرَثَةٌ':Added, #1: 1	تَصْدِيقُ الْوَرَثَةِ
u'تَصْدِيقٌ وَكِيلٌ':Added, #2: 2	تَصْدِيقِ الْوَرَثَةِ
u'تَصْدِيقٌ وَكِيلٌ':Added, #2: 2	تَصْدِيقِ الْوَكِيلِ
u'تَصْدِيقٌ ولد':Added, #6: 6	تَصْدِيقُ الْوَكِيلِ
u'تَصْدِيقٌ وَلَدٌ':Added, #2: 2	تَصْدِيقِ الْوَلَدِ
u'تَصْدِيقٌ وَلِيٌّ':Added, #2: 2	تَصْدِيقِ الْوَلَدِ
u'تَصْدِيقٌ وَلِيٌّ':Added, #1: 1	تَصْدِيقَ الْوَلِيِّ
u'تَصْدِيقٌ وَلِيٌّ':Added, #2: 2	تَصْدِيقُ الْوَلِيِّ
u'تَصَدَّى مُحَقِّقٌ':Subject, #2: 2	تَصْدِيقِ الْوَلِيِّ
u'تَصَدَّى مُعْتَرِضٌ':Subject, #1: 1	تَصَدَّى الْمُحَقِّقُ
u'تَصَدَّى نَظَرٌ':Subject, #1: 1	تَصَدَّى الْمُعْتَرِضُ
u'تَصَرَّفَ أَبٌ':Subject, #1: 1	تَصَدَّى النَّظَرُ
u'تَصَرُّفٌ أَبٌ':Added, #1: 1	تَصَرَّفَ الْأَبُ
u'تَصَرُّفٌ أَبٌ':Added, #2: 2	تَصَرُّفَ الْأَبِ
u'تَصَرُّفٌ أَبٌ':Added, #3: 3	تَصَرُّفِ الْأَبِ
u'تَصَرُّفٌ إِبَانَةٌ':Added, #7: 7	تَصَرُّفُ الْأَبِ
u'تَصَرُّفٌ إِبَانَةٌ':Added, #1: 1	تَصَرُّفُ إبَانَةٍ
u'تَصَرُّفٌ إِبَانَةٌ':Added, #1: 1	تَصَرُّفُ الْإِبَانَةِ
u'تَصَرُّفٌ اِبْنٌ':Added, #3: 3	تَصَرُّفَ الْإِبَانَةِ
u'تَصَرُّفٌ أَجِيرٌ':Added, #1: 1	تَصَرُّفِ ابْنِ
u'تَصَرَّفَ أحَدٌ':Subject, #1: 1	تَصَرُّفِ الْأَجِيرِ
u'تَصَرُّفٌ أحَدٌ':Added, #2: 2	تَصَرَّفَ أَحَدُ
u'تَصَرُّفٌ أحَدٌ':Added, #1: 1	تَصَرُّفَ أَحَدِ
u'تَصَرُّفٌ أحَدٌ':Added, #1: 1	تَصَرُّفُ أَحَدٍ
u'تَصَرُّفٌ أحَدٌ':Added, #1: 1	تَصَرُّفُ أَحَدِ
u'تَصَرُّفٌ أَحْوالٌ':Added, #1: 1	تَصَرُّفِ أَحَدِ
u'تَصَرُّفٌ أحْوَالٌ':Added, #1: 1	تَصَرُّفِ أَحْوَالِهِ
u'تَصَرُّفٌ أَصْحَابٌ':Added, #1: 1	تَصَرُّفِ أَحْوَالِهِ
u'تَصَرُّفٌ أَغْيارٌ':Added, #1: 1	تَصَرُّفِ الْأَصْحَابِ
u'تَصَرُّفٌ اِلْتِزَامٌ':Added, #1: 1	تَصَرُّفِ الْأَغْيَارِ
u'تَصَرُّفٌ الْمَرْءُ':Added, #3: 3	تَصَرُّفُ الْتِزَامٍ
u'تَصَرُّفٌ الْمَرْءُ':Added, #1: 1	تَصَرُّفَ الْمَرْءِ
u'تَصَرُّفٌ الْمَرْءُ':Added, #1: 1	تَصَرُّفِ الْمَرْءِ
u'تَصَرُّفٌ الْمَرْأَةُ':Added, #2: 2	تَصَرُّفُ الْمَرْءِ
u'تَصَرُّفٌ إمَامٌ':Added, #1: 1	تَصَرُّفِ الْمَرْأَةِ
u'تَصَرُّفٌ إمَامٌ':Added, #1: 1	تَصَرُّفَ الْإِمَامِ
u'تَصَرُّفٌ إمَامٌ':Added, #1: 1	تَصَرُّفِ إمَامِ
u'تَصَرُّفٌ إمَامٌ':Added, #2: 2	تَصَرُّفُ الْإِمَامِ
u'تَصَرُّفٌ إمَامَةٌ':Added, #8: 8	تَصَرُّفِ الْإِمَامِ
u'تَصَرُّفٌ أَمينٌ':Added, #1: 1	تَصَرُّفِ الْإِمَامَةِ
u'تَصَرُّفٌ أَمينٌ':Added, #1: 1	تَصَرُّفَ أَمِينِ
u'تَصَرُّفٌ إِنْسانٌ':Added, #1: 1	تَصَرُّفُ أَمِينِهِ
u'تَصَرُّفٌ إِنْسانٌ':Added, #2: 2	تَصَرُّفُ الْإِنْسَانِ
u'تَصَرُّفٌ أهْلٌ':Added, #3: 3	تَصَرُّفَ الْإِنْسَانِ
u'تَصَرُّفٌ أَوَّلُ':Added, #1: 1	تَصَرُّفِ أَهْلِ
u'تَصَرَّفَ بَائِعٌ':Subject, #1: 1	تَصَرُّفُ الْأَوَّلِ
u'تَصَرُّفٌ بَائِعٌ':Added, #6: 6	تَصَرَّفَ الْبَائِعُ
u'تَصَرُّفٌ بَائِعٌ':Added, #10: 10	تَصَرُّفُ الْبَائِعِ
u'تَصَرُّفٌ بَائِعٌ':Added, #1: 1	تَصَرُّفَ الْبَائِعِ
u'تَصَرُّفٌ بَزَّارٌ':Added, #7: 7	تَصَرُّفِ الْبَائِعِ
u'تَصَرُّفٌ بَطْنٌ':Added, #1: 1	تَصَرُّفِ الْبَزَّارِ
u'تَصَرُّفٌ تَعْلِيقٌ':Added, #1: 1	تَصَرُّفَ الْبَطْنِ
u'تَصَرُّفٌ تَفْرِيقٌ':Added, #2: 2	تَصَرُّفِ التَّعْلِيقِ
u'تَصَرُّفٌ تَكْفيرٌ':Added, #1: 1	تَصَرُّفِ التَّفْرِيقِ
u'تَصَرُّفٌ تَمْلِيك':Added, #1: 1	تَصَرُّفِ التَّكْفِيرِ
u'تَصَرُّفٌ تَمْلِيكٌ':Added, #1: 1	تَصَرُّفُ التَّمْلِيكِ
u'تَصَرُّفٌ جِيرَانٌ':Added, #5: 5	تَصَرُّفُ تَمْلِيكٍ
u'تَصَرُّفٌ حاكِمٌ':Added, #2: 2	تَصَرُّفِ الْجِيرَانِ
u'تَصَرُّفٌ حاكِمٌ':Added, #1: 1	تَصَرُّفُ الْحَاكِمِ
u'تَصَرُّفٌ حاكِمٌ':Added, #1: 1	تَصَرُّفِ الْحَاكِمِ
u'تَصَرَّفَ حالٌ':Subject, #4: 4	تَصَرُّفَ الْحَاكِمِ
u'تَصَرُّفٌ حَيٌّ':Added, #1: 1	تَصَرَّفَ حَالُهُ
u'تَصَرُّفٌ ذِمِّيٌّ':Added, #1: 1	تَصَرُّفُ الْحَيِّ
u'تَصَرُّفٌ ذِهْنٌ':Added, #1: 1	تَصَرُّفُ الذِّمِّيِّ
u'تَصَرَّفَ رَاهِنٌ':Subject, #1: 1	تَصَرُّفُ الذِّهْنِ
u'تَصَرُّفٌ رَاهِنٌ':Added, #3: 3	تَصَرَّفَ الرَّاهِنُ
u'تَصَرُّفٌ رَاهِنٌ':Added, #2: 2	تَصَرُّفَ الرَّاهِنِ
u'تَصَرُّفٌ رَاهِنٌ':Added, #3: 3	تَصَرُّفُ الرَّاهِنِ
u'تَصَرُّفٌ رَبُّ':Added, #3: 3	تَصَرُّفِ الرَّاهِنِ
u'تَصَرُّفٌ رِجَالٌ':Added, #2: 2	تَصَرُّفُ رَبِّهِ
u'تَصَرُّفٌ رَجُلٌ':Added, #1: 1	تَصَرُّفِ الرِّجَالِ
u'تَصَرُّفٌ زائِدٌ':Added, #1: 1	تَصَرُّفِ الرَّجُلِ
u'تَصَرُّفٌ زَوْجٌ':Added, #1: 1	تَصَرُّفٍ زَائِدٍ
u'تَصَرُّفٌ زَوْجَةٌ':Added, #3: 3	تَصَرُّفُ الزَّوْجِ
u'تَصَرُّفٌ زَوْجَةٌ':Added, #1: 1	تَصَرُّفَ الزَّوْجَةِ
u'تَصَرُّفٌ سَابِقٌ':Added, #2: 2	تَصَرُّفُ الزَّوْجَةِ
u'تَصَرَّفَ سَفِيهٌ':Subject, #1: 1	تَصَرُّفُ السَّابِقِ
u'تَصَرُّفٌ سَفِيهٌ':Added, #1: 1	تَصَرَّفَ السَّفِيهُ
u'تَصَرُّفٌ سَكْرَان':Added, #2: 2	تَصَرُّفِ السَّفِيهِ
u'تَصَرُّفٌ سَكْرَان':Added, #1: 1	تَصَرُّفُ السَّكْرَانِ
u'تَصَرَّفَ سَيِّدٌ':Subject, #1: 1	تَصَرُّفِ السَّكْرَانِ
u'تَصَرُّفٌ سَيِّدٌ':Added, #2: 2	تَصَرَّفَ السَّيِّدُ
u'تَصَرُّفٌ شَارِحٌ':Added, #3: 3	تَصَرُّفُ السَّيِّدِ
u'تَصَرَّفَ شَارِعٌ':Subject, #1: 1	تَصَرُّفِ الشَّارِحِ
u'تَصَرُّفٌ شافِعِيّ':Added, #1: 1	تَصَرَّفَ الشَّارِعُ
u'تَصَرُّفٌ شَخْصٌ':Added, #1: 1	تَصَرُّفِ الشَّافِعِيِّ
u'تَصَرُّفٌ شَخْصٌ':Added, #1: 1	تَصَرُّفِ الشَّخْصِ
u'تَصَرُّفٌ شَرْعٌ':Added, #2: 2	تَصَرُّفَ الشَّخْصِ
u'تَصَرُّفٌ شَرْعٌ':Added, #1: 1	تَصَرُّفَ الشَّرْعِ
u'تَصَرُّفٌ شَرْعِيٌّ':Added, #1: 1	تَصَرُّفُ الشَّرْعِ
u'تَصَرَّفَ شِرْكٌ':Subject, #1: 1	تَصَرُّفٍ شَرْعِيٍّ
u'تَصَرُّفٌ شَرِيكٌ':Added, #1: 1	تَصَرَّفَ الشِّرْكُ
u'تَصَرُّفٌ شَفِيعٌ':Added, #1: 1	تَصَرُّفَ الشَّرِيكِ
u'تَصَرَّفَ صَبِيٌّ':Subject, #2: 2	تَصَرُّفُ الشَّفِيعِ
u'تَصَرُّفٌ صَبِيٌّ':Added, #1: 1	تَصَرَّفَ الصَّبِيُّ
u'تَصَرُّفٌ صَبِيٌّ':Added, #1: 1	تَصَرُّفَ الصَّبِيِّ
u'تَصَرُّفٌ صَبِيٌّ':Added, #2: 2	تَصَرُّفُ الصَّبِيِّ
u'تَصَرُّفٌ صَبِيٌّ':Added, #2: 2	تَصَرُّفِ الصَّبِيِّ
u'تَصَرُّفٌ صَغِيرٌ':Added, #3: 3	تَصَرُّفُ صَبِيٍّ
u'تَصَرُّفٌ طَلاَقٌ':Added, #3: 3	تَصَرُّفُ الصَّغِيرِ
u'تَصَرُّفٌ عَاقِدٌ':Added, #1: 1	تَصَرُّفِ الطَّلَاقِ
u'تَصَرُّفٌ عَاقِدٌ':Added, #2: 2	تَصَرُّفَ الْعَاقِدِ
u'تَصَرُّفٌ عَاقِدٌ':Added, #2: 2	تَصَرُّفِ الْعَاقِدِ
u'تَصَرُّفٌ عَاقِلٌ':Added, #4: 4	تَصَرُّفُ الْعَاقِدِ
u'تَصَرُّفٌ عَاقِلٌ':Added, #2: 2	تَصَرُّفِ الْعَاقِلِ
u'تَصَرُّفٌ عَامٌّ':Added, #3: 3	تَصَرُّفَ الْعَاقِلِ
u'تَصَرُّفٌ عَامِلٌ':Added, #2: 2	تَصَرُّفٍ عَامٍّ
u'تَصَرُّفٌ عَامِلٌ':Added, #1: 1	تَصَرُّفُ الْعَامِلِ
u'تَصَرَّفَ عَبْدٌ':Subject, #2: 2	تَصَرُّفِ الْعَامِلِ
u'تَصَرُّفٌ عَبْدٌ':Added, #1: 1	تَصَرَّفَ الْعَبْدُ
u'تَصَرُّفٌ عَبْدٌ':Added, #1: 1	تَصَرُّفُ عَبْدٍ
u'تَصَرُّفٌ عَبْدٌ':Added, #2: 2	تَصَرُّفَ الْعَبْدِ
u'تَصَرُّفٌ عَبْدٌ':Added, #5: 5	تَصَرُّفِ الْعَبْدِ
u'تَصَرُّفٌ عُقَلاَءُ':Added, #7: 7	تَصَرُّفُ الْعَبْدِ
u'تَصَرُّفٌ علماء':Added, #2: 2	تَصَرُّفِ الْعُقَلَاءِ
u'تَصَرُّفٌ عُلَمَاءُ':Added, #1: 1	تَصَرُّفِ الْعُلَمَاءِ
u'تَصَرَّفَ غَاصِبٌ':Subject, #1: 1	تَصَرُّفِ الْعُلَمَاءِ
u'تَصَرُّفٌ غَاصِبٌ':Added, #1: 1	تَصَرَّفَ الْغَاصِبُ
u'تَصَرُّفٌ غَاصِبٌ':Added, #1: 1	تَصَرُّفَ الْغَاصِبِ
u'تَصَرُّفٌ غَاصِبٌ':Added, #3: 3	تَصَرُّفِ غَاصِبٍ
u'تَصَرُّفٌ غير':Added, #6: 6	تَصَرُّفِ الْغَاصِبِ
u'تَصَرُّفٌ غَيْرٌ':Added, #1: 1	تَصَرُّفَ غَيْرِهِ
u'تَصَرُّفٌ غير':Added, #1: 1	تَصَرُّفَ غَيْرِهِ
u'تَصَرُّفٌ غَيْرٌ':Added, #2: 2	تَصَرُّفِ الْغَيْرِ
u'تَصَرُّفٌ غير':Added, #2: 2	تَصَرُّفِ الْغَيْرِ
u'تَصَرُّفٌ غَيْرٌ':Added, #2: 2	تَصَرُّفِ غَيْرِ
u'تَصَرُّفٌ غير':Added, #2: 2	تَصَرُّفِ غَيْرِ
u'تَصَرُّفٌ غَيْرٌ':Added, #2: 2	تَصَرُّفُ غَيْرِهِ
u'تَصَرُّفٌ فاسِخ':Added, #2: 2	تَصَرُّفُ غَيْرِهِ
u'تَصَرُّفٌ فَاعِلٌ':Added, #1: 1	تَصَرُّفَ الْفَاسِخِ
u'تَصَرُّفٌ فَسْخٌ':Added, #1: 1	تَصَرُّفُ الْفَاعِلِ
u'تَصَرُّفٌ فُضُولِيٌّ':Added, #2: 2	تَصَرُّفُ الْفَسْخِ
u'تَصَرُّفٌ فُضُولِيٌّ':Added, #18: 18	تَصَرُّفِ الْفُضُولِيِّ
u'تَصَرُّفٌ فُضُولِيٌّ':Added, #3: 3	تَصَرُّفُ الْفُضُولِيِّ
u'تَصَرُّفٌ فقهاء':Added, #4: 4	تَصَرُّفَ الْفُضُولِيِّ
u'تَصَرُّفٌ فَقِيرٌ':Added, #2: 2	تَصَرُّفِ الْفُقَهَاءِ
u'تَصَرُّفٌ فلان':Added, #1: 1	تَصَرُّفُ الْفَقِيرِ
u'تَصَرُّفٌ قَابِضٌ':Added, #1: 1	تَصَرُّفِ الشَّافِعِيِّ
u'تَصَرُّفٌ قَابِضٌ':Added, #1: 1	تَصَرُّفُ الْقَابِضِ
u'تَصَرُّفٌ قضاة':Added, #2: 2	تَصَرُّفِ الْقَابِضِ
u'تَصَرُّفٌ كَفَالَةٌ':Added, #1: 1	تَصَرُّفُ الْقُضَاةِ
u'تَصَرَّفَ كَفِيلٌ':Subject, #1: 1	تَصَرُّفِ الْكَفَالَةِ
u'تَصَرُّفٌ لَفْظِيٌّ':Added, #2: 2	تَصَرَّفَ الْكَفِيلُ
u'تَصَرَّفَ مَالِكٌ':Subject, #1: 1	تَصَرُّفٍ لَفْظِيٍّ
u'تَصَرُّفٌ مَالِكٌ':Added, #2: 2	تَصَرَّفَ الْمَالِكُ
u'تَصَرُّفٌ مَالِكٌ':Added, #2: 2	تَصَرُّفَ مَالِكٍ
u'تَصَرُّفٌ مَالِكٌ':Added, #4: 4	تَصَرُّفَ الْمَالِكِ
u'تَصَرُّفٌ مَالِكٌ':Added, #6: 6	تَصَرُّفُ الْمَالِكِ
u'تَصَرُّفٌ مَالِيٌّ':Added, #6: 6	تَصَرُّفِ الْمَالِكِ
u'تَصَرَّفَ مَأْمُورٌ':Subject, #3: 3	تَصَرُّفٍ مَالِيٍّ
u'تَصَرُّفٌ مَأْمُورٌ':Added, #1: 1	تَصَرَّفَ الْمَأْمُورُ
u'تَصَرُّفٌ مُبْتَدَأٌ':Added, #1: 1	تَصَرُّفُ الْمَأْمُورِ
u'تَصَرُّفٌ مُتَصَرِّفٌ':Added, #1: 1	تَصَرُّفٍ مُبْتَدَأٍ
u'تَصَرُّفٌ مثل':Added, #1: 1	تَصَرُّفَ الْمُتَصَرِّفِ
u'تَصَرُّفٌ مِثْلٌ':Added, #1: 1	تَصَرُّفَ مِثْلِهِ
u'تَصَرُّفٌ مَجْدٌ':Added, #1: 1	تَصَرُّفَ مِثْلِهِ
u'تَصَرُّفٌ مَجْنُونٌ':Added, #1: 1	تَصَرُّفِ الْمَجْدِ
u'تَصَرَّفَ مَحْجُورٌ':Subject, #5: 5	تَصَرُّفُ الْمَجْنُونِ
u'تَصَرُّفٌ مَحْجُورٌ':Added, #1: 1	تَصَرَّفَ الْمَحْجُورُ
u'تَصَرُّفٌ مَحْجُورٌ':Added, #1: 1	تَصَرُّفِ الْمَحْجُورِ
u'تَصَرُّفٌ مَحْجُورٌ':Added, #1: 1	تَصَرُّفُ مَحْجُورٍ
u'تَصَرَّفَ مَحْكُومٌ':Subject, #3: 3	تَصَرُّفَ الْمَحْجُورِ
u'تَصَرُّفٌ مُخْتَارٌ':Added, #1: 1	تَصَرَّفَ الْمَحْكُومُ
u'تَصَرُّفٌ مُدَّةٌ':Added, #1: 1	تَصَرُّفُ الْمُخْتَارِ
u'تَصَرُّفٌ مَدِينٌ':Added, #1: 1	تَصَرُّفُ مُدَّةٍ
u'تَصَرُّفٌ مَدِينٌ':Added, #1: 1	تَصَرُّفُ الْمَدِينِ
u'تَصَرُّفٌ مَدْيُونٌ':Added, #3: 3	تَصَرُّفِ الْمَدِينِ
u'تَصَرُّفٌ مُرْتَدٌّ':Added, #1: 1	تَصَرُّفَ الْمَدْيُونِ
u'تَصَرُّفٌ مُرْتَدٌّ':Added, #1: 1	تَصَرُّفَ الْمُرْتَدِّ
u'تَصَرُّفٌ مُرْتَدٌّ':Added, #2: 2	تَصَرُّفُ الْمُرْتَدِّ
u'تَصَرُّفٌ مَرِيضٌ':Added, #4: 4	تَصَرُّفِ الْمُرْتَدِّ
u'تَصَرُّفٌ مَرِيضٌ':Added, #2: 2	تَصَرُّفُ الْمَرِيضِ
u'تَصَرُّفٌ مَرِيضٌ':Added, #6: 6	تَصَرُّفَ الْمَرِيضِ
u'تَصَرُّفٌ مُسْتَأْجِرٌ':Added, #6: 6	تَصَرُّفِ الْمَرِيضِ
u'تَصَرُّفٌ مُسْتَحِقٌّ':Added, #1: 1	تَصَرُّفِ الْمُسْتَأْجِرِ
u'تَصَرَّفَ مُسْتَعِيرٌ':Subject, #2: 2	تَصَرُّفِ الْمُسْتَحِقِّ
u'تَصَرُّفٌ مُسْلِمٌ':Added, #1: 1	تَصَرَّفَ الْمُسْتَعِيرُ
u'تَصَرُّفٌ مَشْهُودٌ':Added, #1: 1	تَصَرُّفُ الْمُسْلِمِ
u'تَصَرَّفَ مُضَارِبٌ':Subject, #1: 1	تَصَرُّفُ الْمَشْهُودِ
u'تَصَرُّفٌ مُضَارِبٌ':Added, #3: 3	تَصَرَّفَ الْمُضَارِبُ
u'تَصَرُّفٌ مُضَارِبٌ':Added, #1: 1	تَصَرُّفُ الْمُضَارِبِ
u'تَصَرُّفٌ مُضَارِبٌ':Added, #1: 1	تَصَرُّفِ الْمُضَارِبِ
u'تَصَرُّفٌ مُضَافٌ':Added, #1: 1	تَصَرُّفُ مُضَارِبِهِ
u'تَصَرُّفٌ مُضْطَرٌّ':Added, #1: 1	تَصَرُّفٍ مُضَافٍ
u'تَصَرَّفَ مَعْزُولٌ':Subject, #1: 1	تَصَرُّفُ الْمُضْطَرِّ
u'تَصَرُّفٌ مَعْلُومٌ':Added, #1: 1	تَصَرَّفَ الْمَعْزُولُ
u'تَصَرُّفٌ مُعَيَّنٌ':Added, #5: 5	تَصَرُّفٍ مَعْلُومٍ
u'تَصَرُّفٌ مُفْلِسٌ':Added, #2: 2	تَصَرُّفٍ مُعَيَّنٍ
u'تَصَرُّفٌ مُفْلِسٌ':Added, #1: 1	تَصَرُّف الْمُفْلِسِ
u'تَصَرُّفٌ مُفْلِسٌ':Added, #1: 1	تَصَرُّفِ الْمُفْلِسِ
u'تَصَرُّفٌ مُقْتَرِضٌ':Added, #2: 2	تَصَرُّفُ الْمُفْلِسِ
u'تَصَرُّفٌ مُكَلَّفٌ':Added, #1: 1	تَصَرُّفِ الْمُقْتَرِضِ
u'تَصَرُّفٌ مَلاَئِكَةٌ':Added, #1: 1	تَصَرُّفُ مُكَلَّفٍ
u'تَصَرُّفٌ مِلْكٌ':Added, #1: 1	تَصَرُّفِ الْمَلَائِكَةِ
u'تَصَرُّفٌ مَمْلُوكٌ':Added, #1: 1	تَصَرُّفَ الْمِلْكِ
u'تَصَرُّفٌ مُمَيِّزٌ':Added, #3: 3	تَصَرُّفُ مَمْلُوكٍ
u'تَصَرُّفٌ مُمَيِّزٌ':Added, #1: 1	تَصَرُّفُ الْمُمَيِّزِ
u'تَصَرُّفٌ مُمَيِّزٌ':Added, #1: 1	تَصَرُّفُ مُمَيِّزٍ
u'تَصَرُّفٌ مَنْهِيٌّ':Added, #3: 3	تَصَرُّفِ مُمَيِّزٍ
u'تَصَرُّفٌ مُوجِد':Added, #2: 2	تَصَرُّفٍ مَنْهِيٍّ
u'تَصَرَّفَ مُودَعٌ':Subject, #1: 1	تَصَرُّفُ الْمُوجِدِ
u'تَصَرُّفٌ مَوْقُوفٌ':Added, #1: 1	تَصَرَّفَ الْمُودَعُ
u'تَصَرُّفٌ مَوْقُوفٌ':Added, #1: 1	تَصَرُّفَ الْمَوْقُوفِ
u'تَصَرُّفٌ مَوْقُوفٌ':Added, #1: 1	تَصَرُّفُ الْمَوْقُوفِ
u'تَصَرُّفٌ مُوَكِّلٌ':Added, #1: 1	تَصَرُّفِ الْمَوْقُوفِ
u'تَصَرُّفٌ مُوَكِّلٌ':Added, #1: 1	تَصَرُّفُ الْمُوَكِّلِ
u'تَصَرُّفٌ مُوَكِّلٌ':Added, #3: 3	تَصَرُّفَ الْمُوَكِّلِ
u'تَصَرَّفَ مَوْهُوبٌ':Subject, #3: 3	تَصَرُّفِ الْمُوَكِّلِ
u'تَصَرُّفٌ مَوْهُوبٌ':Added, #1: 1	تَصَرَّفَ الْمَوْهُوبُ
u'تَصَرُّفٌ ناذِر':Added, #1: 1	تَصَرُّفُ الْمَوْهُوبِ
u'تَصَرُّفٌ نَاظِرٌ':Added, #1: 1	تَصَرُّفُ النَّاذِرِ
u'تَصَرُّفٌ نَائِبٌ':Added, #1: 1	تَصَرُّفَ النَّاظِرِ
u'تَصَرُّفٌ نَائِبٌ':Added, #1: 1	تَصَرُّفَ النَّائِبِ
u'تَصَرُّفٌ نُسَّاخٌ':Added, #1: 1	تَصَرُّفُ نَائِبِهِ
u'تَصَرَّفَ نَفَذٌ':Predicate, #1: 1	تَصَرُّفِ النُّسَّاخِ
u'تَصَرُّفٌ نَفْسٌ':Added, #1: 1	تَصَرَّفَ نَفَذَ
u'تَصَرُّفٌ نَفْسٌ':Added, #1: 1	تَصَرُّفِ نَفْسِ
u'تَصَرُّفٌ وَاجِبٌ':Added, #1: 1	تَصَرُّفِ نَفْسِهِ
u'تَصَرَّفَ واحد':Subject, #1: 1	تَصَرُّفٍ وَاجِبٍ
u'تَصَرَّفَ وَاحِدٌ':Subject, #1: 1	تَصَرَّفَ وَاحِدٌ
u'تَصَرَّفَ وَارِثٌ':Subject, #1: 1	تَصَرَّفَ وَاحِدٌ
u'تَصَرُّفٌ وَارِثٌ':Added, #1: 1	تَصَرَّفَ الْوَارِثُ
u'تَصَرُّفٌ وَارِثٌ':Added, #1: 1	تَصَرُّفُ الْوَارِثِ
u'تَصَرَّفَ وَاضِعٌ':Subject, #2: 2	تَصَرُّفِ الْوَارِثِ
u'تَصَرُّفٌ وَاقِعٌ':Added, #1: 1	تَصَرَّفَ وَاضِعُهُ
u'تَصَرُّفٌ وَاقِفٌ':Added, #1: 1	تَصَرُّفٍ وَاقِعٍ
u'تَصَرَّفَ وَالِدٌ':Subject, #1: 1	تَصَرُّفِ الْوَاقِفِ
u'تَصَرُّفٌ وَالِدٌ':Added, #1: 1	تَصَرَّفَ الْوَالِدُ
u'تَصَرُّفٌ وَاهِبٌ':Added, #1: 1	تَصَرُّفُ الْوَالِدِ
u'تَصَرُّفٌ وُجُوهٌ':Added, #2: 2	تَصَرُّفَ الْوَاهِبِ
u'تَصَرَّفَ وَرَثَةٌ':Subject, #1: 1	تَصَرُّفِ وُجُوهِ
u'تَصَرُّفٌ وَرَثَةٌ':Added, #2: 2	تَصَرَّفَ الْوَرَثَةُ
u'تَصَرُّفٌ وَرَثَةٌ':Added, #1: 1	تَصَرُّفُ وَرَثَتِهِ
u'تَصَرُّفٌ وَرَثَةٌ':Added, #2: 2	تَصَرُّفَ الْوَرَثَةِ
u'تَصَرُّفٌ وَرَثَةٌ':Added, #2: 2	تَصَرُّفُ الْوَرَثَةِ
u'تَصَرَّفَ وَصِيٌّ':Subject, #2: 2	تَصَرُّفِ الْوَرَثَةِ
u'تَصَرُّفٌ وَصِيٌّ':Added, #1: 1	تَصَرَّفَ الْوَصِيُّ
u'تَصَرُّفٌ وَصِيٌّ':Added, #1: 1	تَصَرُّفِ الْوَصِيِّ
u'تَصَرُّفٌ وَصِيٌّ':Added, #1: 1	تَصَرُّفَ وَصِيِّ
u'تَصَرُّفٌ وَصِيٌّ':Added, #1: 1	تَصَرُّفُ وَصِيِّ
u'تَصَرُّفٌ وَصِيٌّ':Added, #3: 3	تَصَرُّفُ الْوَصِيِّ
u'تَصَرُّفٌ وكلاء':Added, #5: 5	تَصَرُّفَ الْوَصِيِّ
u'تَصَرَّفَ وَكِيلٌ':Subject, #1: 1	تَصَرُّفَ الْوُكَلَاءِ
u'تَصَرُّفٌ وَكِيلٌ':Added, #2: 2	تَصَرَّفَ الْوَكِيلُ
u'تَصَرُّفٌ وَكِيلٌ':Added, #13: 13	تَصَرُّفِ الْوَكِيلِ
u'تَصَرُّفٌ وَكِيلٌ':Added, #1: 1	تَصَرُّفِ الْوَكِيلَيْنِ
u'تَصَرُّفٌ وَكِيلٌ':Added, #3: 3	تَصَرُّفَ الْوَكِيلِ
u'تَصَرُّفٌ وَلِيٌّ':Added, #5: 5	تَصَرُّفُ الْوَكِيلِ
u'تَصَرُّفٌ وَلِيٌّ':Added, #1: 1	تَصَرُّفُ الْوَلِيِّ
u'تَصَرُّفٌ يَدٌ':Added, #5: 5	تَصَرُّفِ الْوَلِيِّ
u'تَصَرُّفٌ يَمِينٌ':Added, #1: 1	تَصَرُّفِ الْيَدَيْنِ
u'تَصَرُّفٌ يَمِينٌ':Added, #1: 1	تَصَرُّفِ الْيَمِينِ
u'تَصَرُّفٌ يَمِينٌ':Added, #2: 2	تَصَرُّفَ يَمِينٍ
u'تَصَرَّمَ قتال':Subject, #7: 7	تَصَرُّفُ يَمِينٍ
u'تَصَرَّمَ قِتَالٌ':Subject, #1: 1	تَصَرَّمَ الْقِتَالُ
u'تَصَرُّمٌ قتال':Added, #1: 1	تَصَرَّمَ الْقِتَالُ
u'تَصَرُّمٌ قِتَالٌ':Added, #1: 1	تَصَرُّمِ الْقِتَالِ
u'تَصْرِيحٌ اِبْنٌ':Added, #1: 1	تَصَرُّمِ الْقِتَالِ
u'تَصْرِيحٌ اِبْنٌ':Added, #1: 1	تَصْرِيحَ ابْنِ
u'تَصْرِيحٌ اِبْنٌ':Added, #1: 1	تَصْرِيحِ ابْنِ
u'تَصْرِيحٌ أَجْنَبِيٌّ':Added, #2: 2	تَصْرِيحُ ابْنِ
u'تَصْرِيحٌ أحَدٌ':Added, #1: 1	تَصْرِيحُ أَجْنَبِيٍّ
u'تَصْرِيحٌ أَصْحَابٌ':Added, #1: 1	تَصْرِيحِ أَحَدٍ
u'تَصْرِيحٌ أَصْحَابٌ':Added, #1: 1	تَصْرِيحَ الْأَصْحَابِ
u'تَصْرِيحٌ أصل':Added, #3: 3	تَصْرِيحُ الْأَصْحَابِ
u'تَصْرِيحٌ أًصْلٌ':Added, #1: 1	تَصْرِيحِ الْأَصْلِ
u'تَصْرِيحٌ إقْرَارٌ':Added, #1: 1	تَصْرِيحِ الْأَصْلِ
u'تَصْرِيحٌ أَمْرٌ':Added, #1: 1	تَصْرِيحُ إقْرَارِهِ
u'تَصْرِيحٌ أئِمَّةٌ':Added, #1: 1	تَصْرِيحُ الْأَمْرِ
u'تَصْرِيحٌ بدائع':Added, #1: 1	تَصْرِيحِ أَئِمَّةِ
u'تَصْرِيحٌ بَعْضٌ':Added, #1: 1	تَصْرِيحُ الْبَدَائِعِ
u'تَصْرِيحٌ ثِقَة':Added, #2: 2	تَصْرِيحِ بَعْضِ
u'تَصْرِيحٌ حاكِمٌ':Added, #1: 1	تَصْرِيحِ الثِّقَاتِ
u'تَصْرِيحٌ حَديثٌ':Added, #1: 1	تَصْرِيحُ الْحَاكِمِ
u'تَصْرِيحٌ دَافِعٌ':Added, #1: 1	تَصْرِيحُ الْحَدِيثِ
u'تَصْرِيحٌ ذَخيرَةٌ':Added, #1: 1	تَصْرِيحِ الدَّافِعِ
u'تَصْرِيحٌ شمس':Added, #1: 1	تَصْرِيحُ الذَّخِيرَةِ
u'تَصْرِيحٌ شَمْسٌ':Added, #1: 1	تَصْرِيحُ شَمْسِ
u'تَصْرِيحٌ شَيْخٌ':Added, #1: 1	تَصْرِيحُ شَمْسِ
u'تَصْرِيحٌ صَاحِبٌ':Added, #2: 2	تَصْرِيحُ الشَّيْخَيْنِ
u'تَصْرِيحٌ صَاحِبٌ':Added, #1: 1	تَصْرِيحُ صَاحِبِ
u'تَصْرِيحٌ عَدَمٌ':Added, #3: 3	تَصْرِيحِ صَاحِبِ
u'تَصْرِيحٌ عَقْدٌ':Added, #1: 1	تَصْرِيحِ عَدَمِ
u'تَصْرِيحٌ مُدَوَّنٌ':Added, #1: 1	تَصْرِيحُ الْعَقْدِ
u'تَصْرِيحٌ مُدَوَّنَةٌ':Added, #1: 1	تَصْرِيحُ الْمُدَوَّنَةِ
u'تَصْرِيحٌ نَظَرٌ':Added, #1: 1	تَصْرِيحُ الْمُدَوَّنَةِ
u'تَصْرِيحٌ وَاقِفٌ':Added, #1: 1	تَصْرِيحُ نَظَرٍ
u'تَصْغِيرٌ أَرْغِفَةٌ':Added, #1: 1	تَصْرِيحِ الْوَاقِفِ
u'تَصْغِيرٌ أَرْغِفَةٌ':Added, #1: 1	تَصْغِيرُ الْأَرْغِفَةِ
u'تَصْغِيرٌ أهْلٌ':Added, #1: 1	تَصْغِيرِ الْأَرْغِفَةِ
u'تَصْغِيرٌ باء':Added, #1: 1	تَصْغِيرُ أَهْلٍ
u'تَصْغِيرٌ تَرْخِيمٌ':Added, #1: 1	تَصْغِيرِ بَاءٍ
u'تَصْغِيرٌ تَرْخِيمٌ':Added, #1: 1	تَصْغِيرُ التّرْخِيمِ
u'تَصْغِيرٌ تَرْخِيمٌ':Added, #3: 3	تَصْغِيرَ التّرْخِيمِ
u'تَصْغِيرٌ حِمَارٌ':Added, #3: 3	تَصْغِيرِ التّرْخِيمِ
u'تَصْغِيرٌ خاب':Added, #1: 1	تَصْغِيرُ حِمَارٍ
u'تَصْغِيرٌ رعن':Added, #1: 1	تَصْغِيرَ خَابٍ
u'تَصْغِيرٌ عَسَل':Added, #1: 1	تَصْغِيرُ رَعْنٍ
u'تَصْغِيرٌ قِرْشٌ':Added, #1: 1	تَصْغِيرُ عَسَلَةٍ
u'تَصْغِيرٌ كِسَرٌ':Added, #1: 1	تَصْغِيرُ الْقِرْشِ
u'تَصْغِيرٌ لُقْمَةٌ':Added, #2: 2	تَصْغِيرِ الْكِسَرِ
u'تَصْغِيرٌ نخلة':Added, #1: 1	تَصْغِيرُ اللُّقْمَةِ
u'تَصْغِيرٌ نَخْلَةٌ':Added, #1: 1	تَصْغِيرُ نَخْلَةٍ
u'تَصْغِيرٌ نَفَلٌ':Added, #1: 1	تَصْغِيرُ نَخْلَةٍ
u'تَصْغِيرٌ هُذْلُول':Added, #1: 1	تَصْغِيرُ نَفَلٍ
u'تَصْغِيرٌ وَفْدٌ':Added, #1: 1	تَصْغِيرَ هُذْلُولٍ
u'تَصَفَّحَ أَحْوالٌ':Predicate, #1: 1	تَصْغِيرُ وَفْدٍ
u'تَصَفَّحَ أحْوَالٌ':Predicate, #1: 1	تَصَفَّحَ أَحْوَالَ
u'تَصَفَّحَ أَفْعَالٌ':Predicate, #1: 1	تَصَفَّحَ أَحْوَالَ
u'تَصَفَّحَ أَقَاوِيلُ':Predicate, #1: 1	تَصَفَّحَ أَفْعَالَ
u'تَصَفُّحٌ أُمُورٌ':Added, #1: 1	تَصَفَّحَ أَقَاوِيلَ
u'تَصَفُّحٌ أُمُورٌ':Added, #1: 1	تَصَفُّحِ الْأُمُورِ
u'تَصَفُّحٌ شُهُودٌ':Added, #1: 1	تَصَفُّحُ أُمُورٍ
u'تَصَفُّحٌ قَوَانِينُ':Added, #1: 1	تَصَفُّحُ شُهُودِهِ
u'تَصَفَّحَ وُجُوهٌ':Predicate, #1: 1	تَصَفُّحِ قَوَانِينِ
u'تَصْفِيَةٌ ثَوْبٌ':Added, #1: 1	تَصَفَّحَ وُجُوهَ
u'تَصْفِيَةٌ حُبوبٌ':Added, #1: 1	تَصْفِيَةُ الثَّوْبِ
u'تَصْفِيَةٌ حِنْطَةٌ':Added, #2: 2	تَصْفِيَةِ الْحُبُوبِ
u'تَصْفِيَةٌ قُلُوبٌ':Added, #1: 1	تَصْفِيَةِ الْحِنْطَةِ
u'تَصْفِيدٌ شَيَاطِينُ':Added, #1: 1	تَصْفِيَةِ الْقُلُوبِ
u'تَصْفِيرٌ وَجْهٌ':Added, #1: 1	تَصْفِيدِ الشَّيَاطِينِ
u'تَصْفِيفٌ شَعْرٌ':Added, #1: 1	تَصْفِيرُ الْوَجْهِ
u'تَصْفِيقٌ الْمَرْأَةُ':Added, #2: 2	تَصْفِيفُ الشَّعْرِ
u'تَصْفِيقٌ الْمَرْأَةُ':Added, #1: 1	تَصْفِيقَ الْمَرْأَةِ
u'تَصْمِيمٌ أصل':Added, #1: 1	تَصْفِيقُ الْمَرْأَةِ
u'تَصْمِيمٌ أًصْلٌ':Added, #1: 1	تَصْمِيمَ الْأَصْلِ
u'تَصْمِيمٌ مُحَمَّدٌ':Added, #1: 1	تَصْمِيمَ الْأَصْلِ
u'تَصْنِيعٌ حَبٌّ':Added, #1: 1	تَصْمِيمِ مُحَمَّدٍ
u'تَصْنِيفٌ إمَامٌ':Added, #1: 1	تَصْنِيعِ الْحَبِّ
u'تَصْنِيفٌ عَلاءٌ':Added, #1: 1	تَصْنِيفُ الإِمَامِ
u'تَصْنِيفٌ فَقِيهٌ':Added, #1: 1	تَصْنِيفِ عَلَاءِ
u'تَصْنِيفٌ كِتَابٌ':Added, #1: 1	تَصْنِيفِ الْفَقِيهِ
u'تَصْنِيفٌ كُتُبٌ':Added, #1: 1	تَصْنِيفِ الْكِتَابِ
u'تَصْنِيفٌ مُحَمَّدٌ':Added, #2: 2	تَصْنِيفُ الْكُتُبِ
u'تَصْنِيفٌ مُحَمَّدٌ':Added, #1: 1	تَصْنِيفِ مُحَمَّدِ
u'تَصْنِيفٌ مُسْتَحْدَثٌ':Added, #2: 2	تَصْنِيفِ مُحَمَّدٍ
u'تَصْنِيفٌ مُفْرَدٌ':Added, #1: 1	تَصْنِيفٍ مُسْتَحْدَثٍ
u'تَصَوُّرٌ اِجْتِمَاعٌ':Added, #1: 1	تَصْنِيفٍ مُفْرَدٍ
u'تَصَوُّرٌ إِجْمَاعٌ':Added, #1: 1	تَصَوُّرِ اجْتِمَاعِ
u'تَصَوُّرٌ أَحْكَامٌ':Added, #1: 1	تَصَوُّرِ الْإِجْمَاعِ
u'تَصَوُّرٌ إِدْرَاكٌ':Added, #1: 1	تَصَوُّرِ أَحْكَامِ
u'تَصَوُّرٌ أَرْبَعَةٌ':Added, #1: 1	تَصَوُّرُ الْإِدْرَاكِ
u'تَصَوُّرٌ اِسْتِعْمالٌ':Added, #1: 1	تَصَوُّرُ أَرْبَعَةٍ
u'تَصَوُّرٌ اِشْتِمالٌ':Added, #1: 1	تَصَوُّرَ اسْتِعْمَالِهِ
u'تَصَوُّرٌ أصل':Added, #1: 1	تَصَوُّرِ اشْتِمَالِ
u'تَصَوُّرٌ أًصْلٌ':Added, #4: 4	تَصَوُّرِ الْأَصْلِ
u'تَصَوُّرٌ إِعْتاقٌ':Added, #4: 4	تَصَوُّرِ الْأَصْلِ
u'تَصَوُّرٌ إعْرَاضٌ':Added, #1: 1	تَصَوُّرَ الْإِعْتَاقِ
u'تَصَوُّرٌ اِقْتِدار':Added, #1: 1	تَصَوُّرِ إعْرَاضِ
u'تَصَوُّرٌ إكْرَاهٌ':Added, #1: 1	تَصَوُّرِ اقْتِدَارِ
u'تَصَوُّرٌ إكْرَاهٌ':Added, #1: 1	تَصَوُّرِ الْإِكْرَاهِ
u'تَصَوَّرَ أَمْرٌ':Predicate, #2: 2	تَصَوُّرُ الْإِكْرَاهِ
u'تَصَوُّرٌ أَمْرٌ':Added, #1: 1	تَصَوَّرَ الْأَمْرَ
u'تَصَوُّرٌ أَمْرٌ':Added, #1: 1	تَصَوُّرَ الْأَمْرِ
u'تَصَوُّرٌ إِنْسانٌ':Added, #1: 1	تَصَوُّرُ الْأَمْرِ
u'تَصَوَّرَ اِنْقِلابٌ':Subject, #1: 1	تَصَوُّرِ الْإِنْسَانِ
u'تَصَوَّرَ اِنْكِسافٌ':Predicate, #1: 1	تَصَوَّرَ انْقِلَابُهُ
u'تَصَوُّرٌ إِيجَابٌ':Added, #1: 1	تَصَوَّرَ انْكِسَافَ
u'تَصَوُّرٌ بِدْعَةٌ':Added, #2: 2	تَصَوُّرَ الْإِيجَابِ
u'تَصَوُّرٌ بَرٌّ':Added, #1: 1	تَصَوُّرِ الْبِدْعَةِ
u'تَصَوُّرٌ بَرٌّ':Added, #2: 2	تَصَوُّرَ الْبَرِّ
u'تَصَوُّرٌ بِرٌّ':Added, #2: 2	تَصَوُّرِ الْبَرِّ
u'تَصَوُّرٌ بِشارَةٌ':Added, #6: 6	تَصَوُّرِ الْبِرِّ
u'تَصَوُّرٌ بَعْضٌ':Added, #1: 1	تَصَوُّرِ الْبِشَارَةِ
u'تَصَوُّرٌ بَيَاضٌ':Added, #1: 1	تَصَوُّرِ بَعْضِهِ
u'تَصَوُّرٌ تَصْدِيقٌ':Added, #1: 1	تَصَوُّرُ الْبَيَاضِ
u'تَصَوُّرٌ تَعَارُضٌ':Added, #1: 1	تَصَوُّرُ التَّصْدِيقِ
u'تَصَوُّرٌ تَعَلُّقٌ':Added, #1: 1	تَصَوُّرِ تَعَارُضِ
u'تَصَوُّرٌ تَعْيِينٌ':Added, #1: 1	تَصَوُّرِ تَعَلُّقِ
u'تَصَوُّرٌ ثُبُوتٌ':Added, #1: 1	تَصَوُّرِ التَّعْيِينِ
u'تَصَوُّرٌ ثُبُوتٌ':Added, #1: 1	تَصَوُّرُ الثُّبُوتِ
u'تَصَوُّرٌ ثُبُوتٌ':Added, #1: 1	تَصَوُّرَ ثُبُوتِ
u'تَصَوُّرٌ ثُبُوتٌ':Added, #1: 1	تَصَوُّرُ ثُبُوتِ
u'تَصَوُّرٌ جمع':Added, #1: 1	تَصَوُّرِ ثُبُوتِ
u'تَصَوُّرٌ جَمْعٌ':Added, #1: 1	تَصَوُّرُ الْجَمْعِ
u'تَصَوُّرٌ جِنَايَةٌ':Added, #1: 1	تَصَوُّرُ الْجَمْعِ
u'تَصَوُّرٌ جِهَةٌ':Added, #2: 2	تَصَوُّرِ الْجِنَايَةِ
u'تَصَوُّرٌ حاصِلٌ':Added, #1: 1	تَصَوُّرُ جِهَةٍ
u'تَصَوُّرٌ حُرٌّ':Added, #1: 1	تَصَوُّرُ الْحَاصِلِ
u'تَصَوَّرَ حَرارَةٌ':Predicate, #1: 1	تَصَوُّرُ الْحُرَّةِ
u'تَصَوُّرٌ حَقِيقٌ':Added, #1: 1	تَصَوَّرَ الْحَرَارَةَ
u'تَصَوُّرٌ حَقِيقٌ':Added, #1: 1	تَصَوُّرِ الْحَقِيقَةِ
u'تَصَوُّرٌ حَقِيقٌ':Added, #1: 1	تَصَوُّرُ حَقِيقَةِ
u'تَصَوُّرٌ حَقِيقَةٌ':Added, #1: 1	تَصَوُّرِ حَقِيقَةِ
u'تَصَوُّرٌ حَقِيقَةٌ':Added, #1: 1	تَصَوُّرِ الْحَقِيقَةِ
u'تَصَوُّرٌ حَقِيقَةٌ':Added, #1: 1	تَصَوُّرُ حَقِيقَةِ
u'تَصَوُّرٌ حُكْمٌ':Added, #1: 1	تَصَوُّرِ حَقِيقَةِ
u'تَصَوُّرٌ حُكْمٌ':Added, #1: 1	تَصَوُّر الْحُكْمِ
u'تَصَوُّرٌ حُكْمٌ':Added, #1: 1	تَصَوُّرُ الْحُكْمِ
u'تَصَوُّرٌ حُكْمٌ':Added, #1: 1	تَصَوُّرُ حُكْمِ
u'تَصَوُّرٌ حِلٌّ':Added, #2: 2	تَصَوُّرِ حُكْمِ
u'تَصَوُّرٌ حُلُولٌ':Added, #1: 1	تَصَوُّرُ حِلِّ
u'تَصَوُّرٌ خِلاَفٌ':Added, #1: 1	تَصَوُّرِ الْحُلُولِ
u'تَصَوُّرٌ دَارٌ':Added, #1: 1	تَصَوُّرِ خِلَافٍ
u'تَصَوَّرَ دَليلٌ':Predicate, #1: 1	تَصَوُّرِ الدَّارِ
u'تَصَوُّرٌ ذَمٌّ':Added, #1: 1	تَصَوَّرَ دَلِيلَ
u'تَصَوُّرٌ رجعة':Added, #1: 1	تَصَوُّرِ الذَّمِّ
u'تَصَوُّرٌ رَجْعَةٌ':Added, #1: 1	تَصَوُّرُ الرَّجْعَةِ
u'تَصَوُّرٌ زِيادَةٌ':Added, #1: 1	تَصَوُّرُ الرَّجْعَةِ
u'تَصَوُّرٌ سَبَبٌ':Added, #2: 2	تَصَوُّرِ الزِّيَادَةِ
u'تَصَوُّرٌ سَبَبِيَّةٌ':Added, #1: 1	تَصَوُّرِ سَبَبِهِ
u'تَصَوُّرٌ سَبْقٌ':Added, #1: 1	تَصَوُّرِ السَّبَبِيَّةِ
u'تَصَوُّرٌ شجَاعٌ':Added, #1: 1	تَصَوُّرِ سَبْقِ
u'تَصَوُّرٌ شَجَاعَةٌ':Added, #1: 1	تَصَوُّرِ الشَّجَاعَةِ
u'تَصَوُّرٌ شرب':Added, #1: 1	تَصَوُّرِ الشَّجَاعَةِ
u'تَصَوُّرٌ شُرْبٌ':Added, #1: 1	تَصَوُّرِ شُرْبِهِ
u'تَصَوُّرٌ شَرْطٌ':Added, #1: 1	تَصَوُّرِ شُرْبِهِ
u'تَصَوُّرٌ شَرْطٌ':Added, #1: 1	تَصَوُّرِ الشَّرْطِ
u'تَصَوُّرٌ شركة':Added, #2: 2	تَصَوُّرِ شَرْطِهِ
u'تَصَوُّرٌ شَرِكَةٌ':Added, #1: 1	تَصَوُّرَ الشَّرِكَةِ
u'تَصَوُّرٌ شَرِيعَةٌ':Added, #1: 1	تَصَوُّرَ الشَّرِكَةِ
u'تَصَوُّرٌ شَيْءٌ':Added, #1: 1	تَصَوُّرُ الشَّرِيعَةِ
u'تَصَوُّرٌ شَيْءٌ':Added, #1: 1	تَصَوُّرُ الشَّيْءِ
u'تَصَوُّرٌ شَيْطَانٌ':Added, #1: 1	تَصَوُّرِ الشَّيْءِ
u'تَصَوُّرٌ صِحَّةٌ':Added, #1: 1	تَصَوُّرِ الشَّيْطَانِ
u'تَصَوُّرٌ صِحَّةٌ':Added, #1: 1	تَصَوُّرَ صِحَّةِ
u'تَصَوُّرٌ صغائر':Added, #2: 2	تَصَوُّرِ صِحَّةِ
u'تَصَوُّرٌ صَغَائِرُ':Added, #1: 1	تَصَوُّرِ الصَّغَائِرِ
u'تَصَوُّرٌ صَلاَةٌ':Added, #1: 1	تَصَوُّرِ الصَّغَائِرِ
u'تَصَوُّرٌ صلح':Added, #1: 1	تَصَوُّرِ الصَّلَاةِ
u'تَصَوُّرٌ صُلْحٌ':Added, #2: 2	تَصَوُّرُ الصُّلْحِ
u'تَصَوُّرٌ صُورَةٌ':Added, #2: 2	تَصَوُّرُ الصُّلْحِ
u'تَصَوَّرَ ضَرْبٌ':Predicate, #1: 1	تَصَوُّرُ الصُّورَةِ
u'تَصَوُّرٌ عِدَّةٌ':Added, #1: 1	تَصَوَّرَ الضَّرْبَ
u'تَصَوُّرٌ عَدَمٌ':Added, #1: 1	تَصَوُّرِ الْعِدَّةِ
u'تَصَوُّرٌ عَكْسٌ':Added, #1: 1	تَصَوُّرِ عَدَمِ
u'تَصَوُّرٌ غَصْبٌ':Added, #1: 1	تَصَوُّرِ عَكْسِ
u'تَصَوُّرٌ غَصْبٌ':Added, #1: 1	تَصَوُّرِ الْغَصْبِ
u'تَصَوُّرٌ فِعْلٌ':Added, #1: 1	تَصَوُّرِ غَصْبِ
u'تَصَوُّرٌ فِعْلٌ':Added, #1: 1	تَصَوُّرَ الْفِعْلِ
u'تَصَوُّرٌ قِلَّةٌ':Added, #1: 1	تَصَوُّرِ الْفِعْلِ
u'تَصَوُّرٌ قِيَاسٌ':Added, #1: 1	تَصَوُّرِ قِلَّةِ
u'تَصَوُّرٌ كَفٌّ':Added, #1: 1	تَصَوُّرِ الْقِيَاسِ
u'تَصَوُّرٌ كَفٌّ':Added, #1: 1	تَصَوُّرِ الْكَفِّ
u'تَصَوُّرٌ كَوْنٌ':Added, #2: 2	تَصَوُّرُ الْكَفِّ
u'تَصَوُّرٌ مَجَازٌ':Added, #1: 1	تَصَوُّرِ كَوْنِهِ
u'تَصَوُّرٌ مَحْدُودٌ':Added, #1: 1	تَصَوُّرِ الْمَجَازِ
u'تَصَوُّرٌ مَحْدُودٌ':Added, #1: 1	تَصَوُّرُ الْمَحْدُودِ
u'تَصَوُّرٌ مَحْكُومٌ':Added, #2: 2	تَصَوُّرِ الْمَحْدُودِ
u'تَصَوُّرٌ مَسْأَلَةٌ':Added, #1: 1	تَصَوُّرُ الْمَحْكُومِ
u'تَصَوُّرٌ مَسَائِلُ':Added, #3: 3	تَصَوُّرُ الْمَسْأَلَةِ
u'تَصَوُّرٌ مُسْتَحِيلٌ':Added, #1: 1	تَصَوُّرِ الْمَسَائِلِ
u'تَصَوُّرٌ مَطْلُوبٌ':Added, #1: 1	تَصَوُّرِ الْمُسْتَحِيلِ
u'تَصَوَّرَ مُعْجَبٌ':Subject, #1: 1	تَصَوُّرَ الْمَطْلُوبِ
u'تَصَوَّرَ مَعْرِفَةٌ':Predicate, #1: 1	تَصَوَّرَ الْمُعْجَبُ
u'تَصَوَّرَ مَعْرِفَة':Predicate, #1: 1	تَصَوَّرَ مَعْرِفَةَ
u'تَصَوُّرٌ مَعْصِيَةٌ':Added, #1: 1	تَصَوَّرَ مَعْرِفَةَ
u'تَصَوُّرٌ مَعْلُومٌ':Added, #1: 1	تَصَوُّرِ الْمَعْصِيَةِ
u'تَصَوُّرٌ مَفْهُومٌ':Added, #1: 1	تَصَوُّرُ الْمَعْلُومِ
u'تَصَوُّرٌ مُكَلَّفٌ':Added, #1: 1	تَصَوُّرُ مَفْهُومَاتٍ
u'تَصَوُّرٌ مَلْزُوم':Added, #1: 1	تَصَوُّرَ الْمُكَلَّفِ
u'تَصَوَّرَ مِلْكٌ':Predicate, #2: 2	تَصَوُّرُ الْمَلْزُومِ
u'تَصَوُّرٌ مِلْكٌ':Added, #1: 1	تَصَوَّرَ مِلْكَ
u'تَصَوُّرٌ مِلْكٌ':Added, #1: 1	تَصَوُّرِ الْمِلْكِ
u'تَصَوُّرٌ مَنْطُوقٌ':Added, #2: 2	تَصَوُّرُ الْمِلْكِ
u'تَصَوُّرٌ مَنْفَعَةٌ':Added, #1: 1	تَصَوُّرَ الْمَنْطُوقِ
u'تَصَوُّرٌ مَنْهِيٌّ':Added, #1: 1	تَصَوُّرِ مَنْفَعَةٍ
u'تَصَوُّرٌ مَوْضُوعٌ':Added, #1: 1	تَصَوُّرَ الْمَنْهِيِّ
u'تَصَوَّرَ نِسْبَةٌ':Predicate, #2: 2	تَصَوُّرِ الْمَوْضُوعِ
u'تَصَوُّرٌ نِسْبَةٌ':Added, #1: 1	تَصَوَّرَ النِّسْبَةَ
u'تَصَوُّرٌ نكاح':Added, #1: 1	تَصَوُّرِ النِّسْبَةِ
u'تَصَوُّرٌ نِكَاحٌ':Added, #1: 1	تَصَوُّرِ نِكَاحِ
u'تَصَوُّرٌ وَاجِبٌ':Added, #1: 1	تَصَوُّرِ نِكَاحِ
u'تَصَوُّرٌ وَاجِبٌ':Added, #1: 1	تَصَوُّرَ الْوَاجِبِ
u'تَصَوَّرَ وُجُودٌ':Subject, #1: 1	تَصَوُّرِ الْوَاجِبِ
u'تَصَوُّرٌ وُجُودٌ':Added, #1: 1	تَصَوَّرَ وُجُودُهُ
u'تَصَوُّرٌ وُجُودٌ':Added, #1: 1	تَصَوُّرُ وُجُودِ
u'تَصَوُّرٌ وُجُودٌ':Added, #1: 1	تَصَوُّرِ وُجُودِ
u'تَصَوُّرٌ وَطْءٌ':Added, #1: 1	تَصَوُّرِ وُجُودِهِ
u'تَصَوَّرَ وُقُوعٌ':Subject, #1: 1	تَصَوُّرِ الْوَطْءِ
u'تَصَوُّرٌ وُقُوعٌ':Added, #1: 1	تَصَوَّرَ وُقُوعُهُ
u'تَصْوِيبٌ اِبْنٌ':Added, #1: 1	تَصَوُّرَ وُقُوعِهِ
u'تَصْوِيبٌ أَقْوَالٌ':Added, #1: 1	تَصْوِيبِ ابْنِ
u'تَصْوِيبٌ إمَامٌ':Added, #1: 1	تَصْوِيبِ أَقْوَالِ
u'تَصْوِيبٌ سَطْحٌ':Added, #1: 1	تَصْوِيبُ إمَامِهِ
u'تَصْوِيبٌ سَطْحٌ':Added, #1: 1	تَصْوِيبُ السَّطْحِ
u'تَصْوِيبٌ صَحَابَةٌ':Added, #1: 1	تَصْوِيبَ سَطْحِ
u'تَصْوِيبٌ مُجْتَهِد':Added, #1: 1	تَصْوِيبَ الصَّحَابَةِ
u'تَصْوِيبٌ نَسَبٌ':Added, #1: 1	تَصْوِيبُ الْمُجْتَهِدَيْنِ
u'تَصْوِيبٌ يهود':Added, #1: 1	تَصْوِيبُ نَسَبٍ
u'تَصْوِيبٌ يَهُودٌ':Added, #1: 1	تَصْوِيبَ الْيَهُودِ
u'تَصْوِيت نَارٌ':Added, #1: 1	تَصْوِيبَ الْيَهُودِ
u'تَصْوِيرٌ اِبْنٌ':Added, #1: 1	تَصْوِيتَ النَّارِ
u'تَصْوِيرٌ إِجْزَاءٌ':Added, #1: 1	تَصْوِيرِ ابْنِ
u'تَصْوِيرٌ أَحْداثٌ':Added, #1: 1	تَصْوِيرُ إجْزَاءِ
u'تَصْوِيرٌ أَحْدَاثٌ':Added, #1: 1	تَصْوِيرَ أَحْدَاثٍ
u'تَصْوِيرٌ إِذْنٌ':Added, #1: 1	تَصْوِيرَ أَحْدَاثٍ
u'تَصْوِيرٌ أصل':Added, #1: 1	تَصْوِيرَ الْإِذْنِ
u'تَصْوِيرٌ أًصْلٌ':Added, #1: 1	تَصْوِيرِ أَصْلِهِ
u'تَصْوِيرٌ أصل':Added, #1: 1	تَصْوِيرِ أَصْلِهِ
u'تَصْوِيرٌ أًصْلٌ':Added, #1: 1	تَصْوِيرِ الْأَصْلِ
u'تَصْوِيرٌ إمَامٌ':Added, #1: 1	تَصْوِيرِ الْأَصْلِ
u'تَصْوِيرٌ أَمْرٌ':Added, #1: 1	تَصْوِيرُ الْإِمَامِ
u'تَصْوِيرٌ اِنْعِقَادٌ':Added, #2: 2	تَصْوِيرُ أَمْرِهِ
u'تَصْوِيرٌ بَاطِلٌ':Added, #1: 1	تَصْوِيرُ انْعِقَادِهِ
u'تَصْوِيرٌ بَعْضٌ':Added, #1: 1	تَصْوِيرُ الْبَاطِلِ
u'تَصْوِيرٌ بَيْعٌ':Added, #1: 1	تَصْوِيرُ بَعْضِ
u'تَصْوِيرٌ تَصَاويرُ':Added, #1: 1	تَصْوِيرُ بَيْعِ
u'تَصْوِيرٌ تَصَاوِيرُ':Added, #1: 1	تَصْوِيرَ التَّصَاوِيرِ
u'تَصْوِيرٌ تَعَارُضٌ':Added, #1: 1	تَصْوِيرَ التَّصَاوِيرِ
u'تَصْوِيرٌ تَكْرارٌ':Added, #1: 1	تَصْوِيرُ التَّعَارُضِ
u'تَصْوِيرٌ تَمَتُّعٌ':Added, #1: 1	تَصْوِيرَ تَكْرَارِ
u'تَصْوِيرٌ ثَانِي':Added, #1: 1	تَصْوِيرِ التَّمَتُّعِ
u'تَصْوِيرٌ ثَانِيَةٌ':Added, #1: 1	تَصْوِيرُ الثَّانِيَةِ
u'تَصْوِيرٌ جهل':Added, #1: 1	تَصْوِيرُ الثَّانِيَةِ
u'تَصْوِيرٌ جَهْلٌ':Added, #1: 1	تَصْوِيرُ الْجَهْلِ
u'تَصْوِيرٌ جَوَازٌ':Added, #1: 1	تَصْوِيرُ الْجَهْلِ
u'تَصْوِيرٌ حقائق':Added, #1: 1	تَصْوِيرِ جَوَازِهِ
u'تَصْوِيرٌ حَقَائِقُ':Added, #1: 1	تَصْوِيرَ الْحَقَائِقِ
u'تَصْوِيرٌ حَيَوَانٌ':Added, #1: 1	تَصْوِيرَ الْحَقَائِقِ
u'تَصْوِيرٌ دَليلٌ':Added, #3: 3	تَصْوِيرُ حَيَوَانٍ
u'تَصْوِيرٌ رُكوعٌ':Added, #1: 1	تَصْوِيرُ الدَّلِيلِ
u'تَصْوِيرٌ شَارِحٌ':Added, #1: 1	تَصْوِيرِ رُكُوعِهِ
u'تَصْوِيرٌ شافِعِيّ':Added, #1: 1	تَصْوِيرُ الشَّارِحِ
u'تَصْوِيرٌ شَجَرٌ':Added, #1: 1	تَصْوِيرِ الشَّافِعِيِّ
u'تَصْوِيرٌ شَيْخٌ':Added, #1: 1	تَصْوِيرُ الشَّجَرِ
u'تَصْوِيرٌ صَدْرٌ':Added, #1: 1	تَصْوِيرِ الشَّيْخَيْنِ
u'تَصْوِيرٌ صُورٌ':Added, #1: 1	تَصْوِيرُ صَدْرِ
u'تَصْوِيرٌ صُوَرٌ':Added, #2: 2	تَصْوِيرُ صُوَرِ
u'تَصْوِيرٌ صُورَةٌ':Added, #2: 2	تَصْوِيرُ صُوَرِ
u'تَصْوِيرٌ عُبَابٌ':Added, #1: 1	تَصْوِيرُ صُورَةِ
u'تَصْوِيرٌ عِبَارَةٌ':Added, #1: 1	تَصْوِيرِ الْعُبَابِ
u'تَصْوِيرٌ فَسْخٌ':Added, #1: 1	تَصْوِيرَ الْعِبَارَةِ
u'تَصْوِيرٌ فلان':Added, #1: 1	تَصْوِيرَ فَسْخِ
u'تَصْوِيرٌ قَبُولٌ':Added, #1: 1	تَصْوِيرِ الشَّافِعِيِّ
u'تَصْوِيرٌ كَفَالَةٌ':Added, #1: 1	تَصْوِيرَ قَبُولِ
u'تَصْوِيرٌ كَفَالَةٌ':Added, #1: 1	تَصْوِيرُ الْكَفَالَةِ
u'تَصْوِيرٌ كَلاَمٌ':Added, #1: 1	تَصْوِيرِ الْكَفَالَةِ
u'تَصْوِيرٌ كَوْنٌ':Added, #1: 1	تَصْوِيرِ كَلَامِهِ
u'تَصْوِيرٌ مُجْتَهِد':Added, #1: 1	تَصْوِيرُ كَوْنِهِ
u'تَصْوِيرٌ مَسْأَلَةٌ':Added, #1: 1	تَصْوِيرِ الْمُجْتَهِدِ
u'تَصْوِيرٌ مَسْأَلَةٌ':Added, #10: 10	تَصْوِيرِ الْمَسْأَلَةِ
u'تَصْوِيرٌ مَسْأَلَةٌ':Added, #12: 12	تَصْوِيرُ الْمَسْأَلَةِ
u'تَصْوِيرٌ مَسْأَلَةٌ':Added, #1: 1	تَصْوِيرُ مَسْأَلَةِ
u'تَصْوِيرٌ مَسْأَلَةٌ':Added, #1: 1	تَصْوِيرِ مَسْأَلَةِ
u'تَصْوِيرٌ مَسَائِلُ':Added, #6: 6	تَصْوِيرَ الْمَسْأَلَةِ
u'تَصْوِيرٌ مَسَائِلُ':Added, #1: 1	تَصْوِيرَ الْمَسَائِلِ
u'تَصْوِيرٌ مَنْعٌ':Added, #1: 1	تَصْوِيرِ الْمَسَائِلِ
u'تَصْوِيرٌ مَوْضِعٌ':Added, #1: 1	تَصْوِيرِ الْمَنْعِ
u'تَصْوِيرٌ هَتْكٌ':Added, #1: 1	تَصْوِيرِ مَوْضِعِ
u'تَصْوِيرٌ واحد':Added, #1: 1	تَصْوِيرِ هَتْكِ
u'تَصْوِيرٌ وَاحِدٌ':Added, #1: 1	تَصْوِيرٍ وَاحِدٍ
u'تَصْوِيرٌ وَضْعٌ':Added, #1: 1	تَصْوِيرٍ وَاحِدٍ
u'تَضَادَّ بَيْنٌ':Predicate, #1: 1	تَصْوِيرَ الْوَضْعِ
u'تَضَاعُفٌ إِثْمٌ':Added, #2: 2	تَضَادَّ بَيْنَ
u'تَضَاعَفَ بِنَاءٌ':Subject, #1: 1	تَضَاعُفَ إِثْمِ
u'تَضَاعُفٌ حَسَنٌ':Added, #1: 1	تَضَاعَفَ الْبِنَاءُ
u'تَضَاعُفٌ حَسَنَةٌ':Added, #1: 1	تَضَاعُفُ الْحَسَنَةِ
u'تَضَاعُفٌ زِيادَةٌ':Added, #1: 1	تَضَاعُفُ الْحَسَنَةِ
u'تَضَاعُفٌ سَيِّئٌ':Added, #1: 1	تَضَاعُفُ زِيَادَةِ
u'تَضَاعُفٌ وَاجِبٌ':Added, #1: 1	تَضَاعُفَ السَّيِّئَاتِ
u'تَضَافُرٌ رِواياتٌ':Added, #1: 1	تَضَاعُفِ الْوَاجِبَاتِ
u'تَضَافَرَ قول':Subject, #1: 1	تَضَافُرُ الرِّوَايَاتِ
u'تَضَافَرَ قَوْلٌ':Subject, #1: 1	تَضَافَرَ قَوْلُهُ
u'تَضَايَقَ جَبَلٌ':Subject, #1: 1	تَضَافَرَ قَوْلُهُ
u'تَضَايُقٌ عِبَادَةٌ':Added, #1: 1	تَضَايَقَ الْجَبَلُ
u'تَضَايُقٌ مَكَانٌ':Added, #1: 1	تَضَايُقِ الْعِبَادَاتِ
u'تَضَايَقَ وَقْتٌ':Subject, #1: 1	تَضَايُقِ الْمَكَانِ
u'تَضَايَقَ وَقْتٌ':Subject, #1: 1	تَضَايَقَ الْوَقْتُ
u'تَضْحِيَةٌ إمَامٌ':Added, #8: 8	تَضَايَقَ وَقْتُ
u'تَضْحِيَةٌ نَبِيٌّ':Added, #1: 1	تَضْحِيَةُ الْإِمَامِ
u'تَضْحِيَةٌ وَلِيٌّ':Added, #1: 1	تَضْحِيَةُ النَّبِيِّ
u'تَضْحِيَةٌ وَلِيٌّ':Added, #1: 1	تَضْحِيَةَ الْوَلِيِّ
u'تَضَرَّرَ أجراء':Subject, #2: 2	تَضْحِيَةُ الْوَلِيِّ
u'تَضَرَّرَ أصل':Subject, #1: 1	تَضَرَّرَ الْأُجَرَاءُ
u'تَضَرَّرَ أًصْلٌ':Subject, #2: 2	تَضَرَّرَ الْأَصْلُ
u'تَضَرُّرٌ إِنْسانٌ':Added, #2: 2	تَضَرَّرَ الْأَصْلُ
u'تَضَرَّرَ بَائِعٌ':Subject, #1: 1	تَضَرُّرَ الْإِنْسَانِ
u'تَضَرُّرٌ بَائِعٌ':Added, #1: 1	تَضَرَّرَ الْبَائِعُ
u'تَضَرُّرٌ بدن':Added, #1: 1	تَضَرُّرُ الْبَائِعِ
u'تَضَرُّرٌ بَدَنٌ':Added, #1: 1	تَضَرُّرِ بَدَنِهِ
u'تَضَرُّرٌ بَعْضٌ':Added, #1: 1	تَضَرُّرِ بَدَنِهِ
u'تَضَرَّرَ جَارٌ':Subject, #3: 3	تَضَرُّرِ بَعْضِ
u'تَضَرُّرٌ جَارٌ':Added, #1: 1	تَضَرَّرَ جَارُهُ
u'تَضَرَّرَ جِيرَانٌ':Subject, #1: 1	تَضَرُّرِ الْجَارِ
u'تَضَرَّرَ حاضِرٌ':Subject, #1: 1	تَضَرَّرَ الْجِيرَانُ
u'تَضَرَّرَ رَبُّ':Subject, #1: 1	تَضَرَّرَ الْحَاضِرُ
u'تَضَرُّرٌ رَفيقٌ':Added, #1: 1	تَضَرَّرَ رَبُّ
u'تَضَرَّرَ سَيِّدٌ':Subject, #1: 1	تَضَرُّرَ رَفِيقِهِ
u'تَضَرُّرٌ سَيِّدٌ':Added, #1: 1	تَضَرَّرَ السَّيِّدُ
u'تَضَرَّرَ شَجَرٌ':Subject, #1: 1	تَضَرُّرُ السَّيِّدِ
u'تَضَرُّرٌ شَخْصٌ':Added, #1: 1	تَضَرَّرَ الشَّجَرُ
u'تَضَرُّرٌ شَرِيكٌ':Added, #1: 1	تَضَرُّرُ الشَّخْصِ
u'تَضَرُّرٌ صَاحِبٌ':Added, #1: 1	تَضَرُّرِ الشَّرِيكِ
u'تَضَرَّرَ صَانِعٌ':Subject, #1: 1	تَضَرُّرَ صَاحِبِ
u'تَضَرَّرَ صَغِيرٌ':Subject, #1: 1	تَضَرَّرَ الصَّانِعُ
u'تَضَرُّرٌ طَالِبٌ':Added, #1: 1	تَضَرَّرَ الصَّغِيرُ
u'تَضَرَّرَ عَامِلٌ':Subject, #1: 1	تَضَرُّرِ الطَّالِبِ
u'تَضَرَّرَ مَالِكٌ':Subject, #1: 1	تَضَرَّرَ الْعَامِلُ
u'تَضَرُّرٌ مَالِكٌ':Added, #3: 3	تَضَرَّرَ الْمَالِكُ
u'تَضَرَّرَ مَحَلٌّ':Subject, #1: 1	تَضَرُّرِ الْمَالِكِ
u'تَضَرَّرَ مُرْتَهِنٌ':Subject, #2: 2	تَضَرَّرَ الْمَحَلُّ
u'تَضَرَّرَ مُسْتَأْجِرٌ':Subject, #1: 1	تَضَرَّرَ الْمُرْتَهِنُ
u'تَضَرُّرٌ مُفْلِسٌ':Added, #2: 2	تَضَرَّرَ الْمُسْتَأْجِرُ
u'تَضَرَّرَ مُلْتَقِط':Subject, #1: 1	تَضَرُّرِ الْمُفْلِسِ
u'تَضَرُّرٌ مَمْلُوكٌ':Added, #1: 1	تَضَرَّرَ الْمُلْتَقِطُ
u'تَضَرَّرَ مُؤَجِّرٌ':Subject, #1: 1	تَضَرُّرُ الْمَمْلُوكِ
u'تَضَرُّرٌ مُؤَجِّرٌ':Added, #1: 1	تَضَرَّرَ الْمُؤَجِّرُ
u'تَضَرُّرٌ وَكِيلٌ':Added, #1: 1	تَضَرُّرُ الْمُؤَجِّرِ
u'تَضَعْضُعٌ حالٌ':Added, #1: 1	تَضَرُّرُ الْوَكِيلِ
u'تَضْعِيفٌ اِبْنٌ':Added, #1: 1	تَضَعْضُعِ الْحَالِ
u'تَضْعِيفٌ اِبْنٌ':Added, #1: 1	تَضْعِيفُ ابْنِ
u'تَضْعِيفٌ أثَرٌ':Added, #1: 1	تَضْعِيفِ ابْنِ
u'تَضْعِيفٌ أَجْرٌ':Added, #1: 1	تَضْعِيفِ الأَثَرِ
u'تَضْعِيفٌ إِجْمَاعٌ':Added, #1: 1	تَضْعِيفُ الأَجْرِ
u'تَضْعِيفٌ أحَدٌ':Added, #1: 1	تَضْعِيفُ الْإِجْمَاعِ
u'تَضْعِيفٌ أحَدٌ':Added, #1: 1	تَضْعِيفِ أَحَدِ
u'تَضْعِيفٌ أَرْبَعَةٌ':Added, #4: 4	تَضْعِيفُ أَحَدِ
u'تَضْعِيفٌ أعداد':Added, #1: 1	تَضْعِيفُ الْأَرْبَعَةِ
u'تَضْعِيفٌ أَعْدَادٌ':Added, #1: 1	تَضْعِيفِ أَعْدَادِ
u'تَضْعِيفٌ تَقْيِيد':Added, #1: 1	تَضْعِيفِ أَعْدَادِ
u'تَضْعِيفٌ ثَمَنٌ':Added, #1: 1	تَضْعِيفَ التَّقْيِيدِ
u'تَضْعِيفٌ حَديثٌ':Added, #2: 2	تَضْعِيفِ الثَّمَنِ
u'تَضْعِيفٌ حَديثٌ':Added, #1: 1	تَضْعِيفُ حَدِيثِ
u'تَضْعِيفٌ حَديثٌ':Added, #1: 1	تَضْعِيفِ حَدِيثِ
u'تَضْعِيفٌ حَديثٌ':Added, #2: 2	تَضْعِيفُ الْحَدِيثِ
u'تَضْعِيفٌ حَسَنٌ':Added, #3: 3	تَضْعِيفِ الْحَدِيثِ
u'تَضْعِيفٌ حَسَنَةٌ':Added, #1: 1	تَضْعِيفِ الْحَسَنَاتِ
u'تَضْعِيفٌ خَبَرٌ':Added, #1: 1	تَضْعِيفِ الْحَسَنَاتِ
u'تَضْعِيفٌ خَبَر':Added, #1: 1	تَضْعِيفُ خَبَرِ
u'تَضْعِيفٌ خَمْسَةٌ':Added, #1: 1	تَضْعِيفُ خَبَرِ
u'تَضْعِيفٌ رَفْعٌ':Added, #1: 1	تَضْعِيفُ الْخَمْسَةِ
u'تَضْعِيفٌ رِوايَةٌ':Added, #1: 1	تَضْعِيفِ الرَّفْعِ
u'تَضْعِيفٌ زَكاةٌ':Added, #1: 1	تَضْعِيفَ رِوَايَتِهِ
u'تَضْعِيفٌ شَيْءٌ':Added, #1: 1	تَضْعِيفُ زَكَاةِ
u'تَضْعِيفٌ صدقة':Added, #1: 1	تَضْعِيفَ الشَّيْءِ
u'تَضْعِيفٌ صَدَقَةٌ':Added, #2: 2	تَضْعِيفِ الصَّدَقَةِ
u'تَضْعِيفٌ صَلاَةٌ':Added, #2: 2	تَضْعِيفِ الصَّدَقَةِ
u'تَضْعِيفٌ ضَمَانٌ':Added, #1: 1	تَضْعِيفِ صَلَاةٍ
u'تَضْعِيفٌ عُشْرٌ':Added, #1: 1	تَضْعِيفِ الضَّمَانِ
u'تَضْعِيفٌ عُشْرٌ':Added, #1: 1	تَضْعِيفُ الْعُشْرِ
u'تَضْعِيفٌ عُشْرٌ':Added, #1: 1	تَضْعِيفِ الْعُشْرِ
u'تَضْعِيفٌ عِنَايَةٌ':Added, #2: 2	تَضْعِيفَ الْعُشْرِ
u'تَضْعِيفٌ غَرَامَةٌ':Added, #1: 1	تَضْعِيفَ الْعِنَايَةِ
u'تَضْعِيفٌ غَرَامَةٌ':Added, #1: 1	تَضْعِيفَ الْغَرَامَةِ
u'تَضْعِيفٌ غَرَامَةٌ':Added, #1: 1	تَضْعِيفُ الْغَرَامَةِ
u'تَضْعِيفٌ فَرْعٌ':Added, #2: 2	تَضْعِيفِ الْغَرَامَةِ
u'تَضْعِيفٌ فِعْلٌ':Added, #1: 1	تَضْعِيفِ الْفَرْعِ
u'تَضْعِيفٌ قول':Added, #1: 1	تَضْعِيفُ الْفِعْلِ
u'تَضْعِيفٌ قَوْلٌ':Added, #1: 1	تَضْعِيفُ الْقَوْلِ
u'تَضْعِيفٌ كَلاَمٌ':Added, #1: 1	تَضْعِيفُ الْقَوْلِ
u'تَضْعِيفٌ كَوْنٌ':Added, #2: 2	تَضْعِيفِ كَلَامِ
u'تَضْعِيفٌ مَرْفُوعٌ':Added, #1: 1	تَضْعِيفِ كَوْنِ
u'تَضْعِيفٌ مُعْتَمَدٌ':Added, #1: 1	تَضْعِيفِ الْمَرْفُوعِ
u'تَضْعِيفٌ نِسْبَةٌ':Added, #1: 1	تَضْعِيفِ مُعْتَمَدِهِ
u'تَضْعِيفٌ نَفَقَةٌ':Added, #1: 1	تَضْعِيفُ نِسْبَةِ
u'تَضْعِيفٌ نقل':Added, #1: 1	تَضْعِيفُ النَّفَقَةِ
u'تَضْعِيفٌ نَقْلٌ':Added, #1: 1	تَضْعِيفُ النَّقْلِ
u'تَضْعِيفٌ نَوَوِيٌّ':Added, #1: 1	تَضْعِيفُ النَّقْلِ
u'تَضْلِيلٌ أَصْحَابٌ':Added, #1: 1	تَضْعِيفِ النَّوَوِيِّ
u'تَضْلِيلٌ أُمَّةٌ':Added, #1: 1	تَضْلِيلُ أَصْحَابِ
u'تَضْلِيلٌ بَعْضٌ':Added, #1: 1	تَضْلِيلِ الْأُمَّةِ
u'تَضْلِيلٌ بَعْضٌ':Added, #1: 1	تَضْلِيلَ بَعْضِ
u'تَضْلِيلٌ فِرْقَةٌ':Added, #1: 1	تَضْلِيلِ بَعْضِ
u'تَضْلِيلٌ مُجْتَهِد':Added, #1: 1	تَضْلِيلِ الْفِرْقَةِ
u'تَضْلِيلٌ مُعْتَزِلٌ':Added, #1: 1	تَضْلِيلِ الْمُجْتَهِدِ
u'تَضْلِيلٌ مُعْتَزِلَةٌ':Added, #1: 1	تَضْلِيلَ الْمُعْتَزِلَةِ
u'تَضَمُّخٌ كعبة':Added, #1: 1	تَضْلِيلَ الْمُعْتَزِلَةِ
u'تَضَمُّخٌ كَعْبَةٌ':Added, #1: 1	تَضَمُّخُ الْكَعْبَةِ
u'تَضَمَّخَ كَلْبٌ':Subject, #1: 1	تَضَمُّخُ الْكَعْبَةِ
u'تَضَمَّنَ إبدالٌ':Subject, #1: 1	تَضَمَّخَ الْكَلْبُ
u'تَضَمَّنَ إِبْطَالٌ':Predicate, #1: 1	تَضَمَّنَ الْإِبْدَالُ
u'تَضَمُّنٌ إِبْطَالٌ':Added, #6: 6	تَضَمَّنَ إبْطَالَ
u'تَضَمَّنَ إِثْبَاتٌ':Predicate, #2: 2	تَضَمُّنُ إبْطَالِ
u'تَضَمَّنَ إِثْبَاتٌ':Subject, #1: 1	تَضَمَّنَ إثْبَاتَ
u'تَضَمَّنَ إِخْبَارٌ':Predicate, #3: 3	تَضَمَّنَ إثْبَاتُهُ
u'تَضَمَّنَ إِذْنٌ':Predicate, #1: 1	تَضَمَّنَ الْإِخْبَارَ
u'تَضَمَّنَ اِرْتِكَابٌ':Subject, #1: 1	تَضَمَّنَ الْإِذْنَ
u'تَضَمُّنٌ اِسْمٌ':Added, #1: 1	تَضَمَّنَ ارْتِكَابُهُ
u'تَضَمَّنَ إِسْنادٌ':Predicate, #1: 1	تَضَمُّنِ اسْمِ
u'تَضَمَّنَ إِسْنادٌ':Subject, #1: 1	تَضَمَّنَ الْإِسْنَادَ
u'تَضَمَّنَ إِشْعارٌ':Predicate, #1: 1	تَضَمَّنَ الْإِسْنَادُ
u'تَضَمَّنَ إِطْلاقٌ':Predicate, #1: 1	تَضَمَّنَ الْإِشْعَارَ
u'تَضَمَّنَ إِظْهارٌ':Predicate, #1: 1	تَضَمَّنَ إطْلَاقَ
u'تَضَمَّنَ إِعادَةٌ':Predicate, #1: 1	تَضَمَّنَ إظْهَارَ
u'تَضَمَّنَ أمَانَةٌ':Predicate, #1: 1	تَضَمَّنَ إعَادَةَ
u'تَضَمَّنَ أهْلٌ':Predicate, #2: 2	تَضَمَّنَ الْأَمَانَةَ
u'تَضَمَّنَ إِيجَابٌ':Predicate, #1: 1	تَضَمَّنَ أَهْلَ
u'تَضَمَّنَ تَأْخِيرٌ':Subject, #1: 1	تَضَمَّنَ إيجَابَ
u'تَضَمَّنَ تِجَارَةٌ':Predicate, #4: 4	تَضَمَّنَ التَّأْخِيرُ
u'تَضَمَّنَ تَعْزِير':Subject, #1: 1	تَضَمَّنَ التِّجَارَةَ
u'تَضَمُّنٌ تَعْلِيقٌ':Added, #1: 1	تَضَمَّنَ التَّعْزِيرُ
u'تَضَمَّنَ تَفْرِيقٌ':Predicate, #1: 1	تَضَمُّنُ التَّعْلِيقِ
u'تَضَمَّنَ تَنْجِيسٌ':Subject, #1: 1	تَضَمَّنَ التَّفْرِيقَ
u'تَضَمَّنَ جَلْبٌ':Predicate, #1: 1	تَضَمَّنَ تَنْجِيسُهُ
u'تَضَمَّنَ حَديثٌ':Subject, #1: 1	تَضَمَّنَ جَلْبَ
u'تَضَمَّنَ حِكَايَةٌ':Predicate, #1: 1	تَضَمَّنَ الْحَدِيثُ
u'تَضَمَّنَ حُكْمٌ':Predicate, #1: 1	تَضَمَّنَ حِكَايَةَ
u'تَضَمَّنَ حُكْمٌ':Subject, #5: 5	تَضَمَّنَ الْحُكْمَ
u'تَضَمَّنَ حُكْمٌ':Subject, #1: 1	تَضَمَّنَ حُكْمُهُ
u'تَضَمُّنٌ حُكْمٌ':Added, #2: 2	تَضَمَّنَ الْحُكْمُ
u'تَضَمُّنٌ حُكْمٌ':Added, #2: 2	تَضَمُّنِ الْحُكْمِ
u'تَضَمَّنَ خِطَابٌ':Predicate, #3: 3	تَضَمُّنُ الْحُكْمِ
u'تَضَمَّنَ خِطَابٌ':Subject, #1: 1	تَضَمَّنَ خِطَابَ
u'تَضَمُّنٌ خُفَرَاءُ':Added, #1: 1	تَضَمَّنَ الْخِطَابُ
u'تَضَمَّنَ دفع':Predicate, #1: 1	تَضَمُّنُ الْخُفَرَاءِ
u'تَضَمَّنَ دَفْعٌ':Predicate, #1: 1	تَضَمَّنَ دَفْعَ
u'تَضَمَّنَ رُجُوعٌ':Subject, #1: 1	تَضَمَّنَ دَفْعَ
u'تَضَمَّنَ رَدٌّ':Subject, #1: 1	تَضَمَّنَ رُجُوعُهُ
u'تَضَمَّنَ رِضاً':Subject, #1: 1	تَضَمَّنَ رَدُّ
u'تَضَمَّنَ رَفْعٌ':Predicate, #1: 1	تَضَمَّنَ رِضَاهُ
u'تَضَمَّنَ سِياقٌ':Subject, #1: 1	تَضَمَّنَ رَفْعَ
u'تَضَمَّنَ شِرَاءٌ':Predicate, #1: 1	تَضَمَّنَ سِيَاقُ
u'تَضَمَّنَ شِرَاءٌ':Subject, #1: 1	تَضَمَّنَ الشِّرَاءَ
u'تَضَمُّنٌ صُنَّاعٌ':Added, #1: 1	تَضَمَّنَ الشِّرَاءُ
u'تَضَمَّنَ عتق':Predicate, #1: 1	تَضَمُّنِ الصُّنَّاعِ
u'تَضَمَّنَ عِتْقٌ':Predicate, #2: 2	تَضَمَّنَ الْعِتْقَ
u'تَضَمَّنَ عتق':Subject, #2: 2	تَضَمَّنَ الْعِتْقَ
u'تَضَمَّنَ عِتْقٌ':Subject, #1: 1	تَضَمَّنَ الْعِتْقُ
u'تَضَمَّنَ عَقْدٌ':Subject, #1: 1	تَضَمَّنَ الْعِتْقُ
u'تَضَمَّنَ عِوَضٌ':Predicate, #1: 1	تَضَمَّنَ الْعَقْدُ
u'تَضَمَّنَ فَرْضٌ':Subject, #1: 1	تَضَمَّنَ الْعِوَضَ
u'تَضَمَّنَ فَوَائِدُ':Predicate, #1: 1	تَضَمَّنَ فَرْضُ
u'تَضَمَّنَ قول':Subject, #2: 2	تَضَمَّنَ فَوَائِدَ
u'تَضَمَّنَ قَوْلٌ':Subject, #1: 1	تَضَمَّنَ قَوْلُهُ
u'تَضَمُّنٌ قول':Added, #1: 1	تَضَمَّنَ قَوْلُهُ
u'تَضَمُّنٌ قَوْلٌ':Added, #1: 1	تَضَمُّنِ قَوْلِهِ
u'تَضَمَّنَ كَلاَمٌ':Subject, #1: 1	تَضَمُّنِ قَوْلِهِ
u'تَضَمَّنَ كَلاَمٌ':Subject, #3: 3	تَضَمَّنَ كَلَامُ
u'تَضَمَّنَ لَفْظٌ':Predicate, #6: 6	تَضَمَّنَ كَلَامُهُ
u'تَضَمَّنَ نَفْيٌ':Predicate, #1: 1	تَضَمَّنَ لَفْظَ
u'تَضَمَّنَ نقل':Predicate, #1: 1	تَضَمَّنَ نَفْيَ
u'تَضَمَّنَ نَقْلٌ':Predicate, #1: 1	تَضَمَّنَ نَقْلَ
u'تَضَمَّنَ هَتْكٌ':Predicate, #1: 1	تَضَمَّنَ نَقْلَ
u'تَضَمُّنٌ وُجُوبٌ':Added, #1: 1	تَضَمَّنَ هَتْكَ
u'تَضْمِينٌ أجراء':Added, #1: 1	تَضَمُّنِ الْوُجُوبِ
u'تَضْمِينٌ أَجْزَاءٌ':Added, #1: 1	تَضْمِينِ الأُجَرَاءِ
u'تَضْمِينٌ أَجِيرٌ':Added, #2: 2	تَضْمِينِ الْأَجْزَاءِ
u'تَضْمِينٌ أَجِيرٌ':Added, #4: 4	تَضْمِينَ الْأَجِيرِ
u'تَضْمِينٌ أحَدٌ':Added, #5: 5	تَضْمِينِ الْأَجِيرِ
u'تَضْمِينٌ إِدَامٌ':Added, #2: 2	تَضْمِينَ أَحَدِ
u'تَضْمِينٌ أُصولٌ':Added, #1: 1	تَضْمِينُ الْإِدَامِ
u'تَضْمِينٌ إِنْسانٌ':Added, #2: 2	تَضْمِينِ الْأُصُولِ
u'تَضْمِينٌ أهْلٌ':Added, #1: 1	تَضْمِينُ الْإِنْسَانِ
u'تَضْمِينٌ أَوَّلُ':Added, #1: 1	تَضْمِينُ الْأَهْلِ
u'تَضْمِينٌ أَوَّلُ':Added, #1: 1	تَضْمِينُ الْأَوَّلِ
u'تَضْمِينٌ أَوَّلُ':Added, #2: 2	تَضْمِينِ الْأَوَّلِ
u'تَضْمِينٌ بَائِعٌ':Added, #6: 6	تَضْمِينَ الْأَوَّلِ
u'تَضْمِينٌ بَائِعٌ':Added, #2: 2	تَضْمِينُ الْبَائِعِ
u'تَضْمِينٌ بَرِيءٌ':Added, #3: 3	تَضْمِينَ الْبَائِعِ
u'تَضْمِينٌ بَعْضٌ':Added, #1: 1	تَضْمِينُ الْبَرِيءِ
u'تَضْمِينٌ حَرْفٌ':Added, #1: 1	تَضْمِينُ بَعْضِ
u'تَضْمِينٌ حِصَّةٌ':Added, #1: 1	تَضْمِينُ الْحَرْفِ
u'تَضْمِينٌ حُكْمٌ':Added, #1: 1	تَضْمِينِ حِصَّتِهِ
u'تَضْمِينٌ حَمْلٌ':Added, #1: 1	تَضْمِينِ الْحُكْمِ
u'تَضْمِينٌ دَافِعٌ':Added, #1: 1	تَضْمِينُ الْحَمْلِ
u'تَضْمِينٌ دَافِعٌ':Added, #1: 1	تَضْمِينَ الدَّافِعِ
u'تَضْمِينٌ دَافِعٌ':Added, #1: 1	تَضْمِينُ الدَّافِعِ
u'تَضْمِينٌ دَيْنٌ':Added, #2: 2	تَضْمِينِ دَافِعِهِ
u'تَضْمِينٌ رَاهِنٌ':Added, #2: 2	تَضْمِينُ الدَّيْنِ
u'تَضْمِينٌ رَاهِنٌ':Added, #1: 1	تَضْمِينَ الرَّاهِنِ
u'تَضْمِينٌ رَبُّ':Added, #1: 1	تَضْمِينُ الرَّاهِنِ
u'تَضْمِينٌ رُبُعٌ':Added, #2: 2	تَضْمِينَ رَبِّ
u'تَضْمِينٌ زَوْجٌ':Added, #1: 1	تَضْمِينَ رُبُعِ
u'تَضْمِينٌ سُلْطَانٌ':Added, #1: 1	تَضْمِينَ الزَّوْجِ
u'تَضْمِينٌ شَاهِدٌ':Added, #1: 1	تَضْمِينِ السُّلْطَانِ
u'تَضْمِينٌ شَاهِدٌ':Added, #1: 1	تَضْمِينَ الشَّاهِدَيْنِ
u'تَضْمِينٌ شَاهِدٌ':Added, #1: 1	تَضْمِينُ الشَّاهِدَيْنِ
u'تَضْمِينٌ شَاهِدٌ':Added, #2: 2	تَضْمِينَ الشَّاهِدِ
u'تَضْمِينٌ شَرِيكٌ':Added, #2: 2	تَضْمِينِ الشَّاهِدَيْنِ
u'تَضْمِينٌ شَرِيكٌ':Added, #1: 1	تَضْمِينُ الشَّرِيكِ
u'تَضْمِينٌ شَرِيكٌ':Added, #2: 2	تَضْمِينَ شَرِيكِهِ
u'تَضْمِينٌ شُهُودٌ':Added, #5: 5	تَضْمِينِ الشَّرِيكِ
u'تَضْمِينٌ شُهُودٌ':Added, #1: 1	تَضْمِينَ الشُّهُودِ
u'تَضْمِينٌ شُهُودٌ':Added, #1: 1	تَضْمِينُ شُهُودِ
u'تَضْمِينٌ شُهُودٌ':Added, #2: 2	تَضْمِينَ شُهُودِ
u'تَضْمِينٌ شَيْءٌ':Added, #4: 4	تَضْمِينِ شُهُودِ
u'تَضْمِينٌ صَاحِبٌ':Added, #1: 1	تَضْمِينِ شَيْءٍ
u'تَضْمِينٌ صَاحِبٌ':Added, #1: 1	تَضْمِينُ صَاحِبِ
u'تَضْمِينٌ صَاحِبٌ':Added, #1: 1	تَضْمِينِ صَاحِبِ
u'تَضْمِينٌ صَانِعٌ':Added, #1: 1	تَضْمِينَ صَاحِبِهِ
u'تَضْمِينٌ صَغِيرٌ':Added, #1: 1	تَضْمِينَ الصَّانِعِ
u'تَضْمِينٌ صَلاَةٌ':Added, #1: 1	تَضْمِينُ الصَّغِيرِ
u'تَضْمِينٌ صُنَّاعٌ':Added, #1: 1	تَضْمِينُ صَلَاةِ
u'تَضْمِينٌ صُنَّاعٌ':Added, #11: 11	تَضْمِينِ الصُّنَّاعِ
u'تَضْمِينٌ صَيْدٌ':Added, #1: 1	تَضْمِينَ الصُّنَّاعِ
u'تَضْمِينٌ عَامِلٌ':Added, #1: 1	تَضْمِينِ الصَّيْدِ
u'تَضْمِينٌ عَبْدٌ':Added, #1: 1	تَضْمِينُ الْعَامِلِ
u'تَضْمِينٌ عُمَّالٌ':Added, #2: 2	تَضْمِينُ الْعَبْدِ
u'تَضْمِينٌ غَاصِبٌ':Added, #1: 1	تَضْمِينُ الْعُمَّالِ
u'تَضْمِينٌ غَاصِبٌ':Added, #1: 1	تَضْمِينُ غَاصِبِ
u'تَضْمِينٌ غَاصِبٌ':Added, #4: 4	تَضْمِينَ الْغَاصِبِ
u'تَضْمِينٌ غَاصِبٌ':Added, #5: 5	تَضْمِينِ الْغَاصِبِ
u'تَضْمِينٌ فِعْلٌ':Added, #8: 8	تَضْمِينُ الْغَاصِبِ
u'تَضْمِينٌ فلان':Added, #1: 1	تَضْمِينِ الْفِعْلِ
u'تَضْمِينٌ قَابِضٌ':Added, #1: 1	تَضْمِينِ الْوَاصِفِ
u'تَضْمِينٌ قَابِضٌ':Added, #2: 2	تَضْمِينَ الْقَابِضِ
u'تَضْمِينٌ قَالِعٌ':Added, #2: 2	تَضْمِينُ الْقَابِضِ
u'تَضْمِينٌ قُرْآنٌ':Added, #1: 1	تَضْمِينَ الْقَالِعِ
u'تَضْمِينٌ قَيِّمٌ':Added, #2: 2	تَضْمِينُ الْقُرْآنِ
u'تَضْمِينٌ قِيمَةٌ':Added, #2: 2	تَضْمِينَ الْقَيِّمِ
u'تَضْمِينٌ قِيمَةٌ':Added, #1: 1	تَضْمِينَ قِيمَةِ
u'تَضْمِينٌ قِيمَةٌ':Added, #1: 1	تَضْمِينِ قِيمَتِهِ
u'تَضْمِينٌ قِيمَةٌ':Added, #3: 3	تَضْمِينَ الْقِيمَةِ
u'تَضْمِينٌ قِيمَةٌ':Added, #3: 3	تَضْمِينُ الْقِيمَةِ
u'تَضْمِينٌ كَلاَمٌ':Added, #3: 3	تَضْمِينِ الْقِيمَةِ
u'تَضْمِينٌ كَلاَمٌ':Added, #1: 1	تَضْمِينُ الْكَلَامِ
u'تَضْمِينٌ كَلْبٌ':Added, #1: 1	تَضْمِينُ كَلَامٍ
u'تَضْمِينٌ مَالِكٌ':Added, #1: 1	تَضْمِينِ الْكَلْبِ
u'تَضْمِينٌ مَالِيٌّ':Added, #1: 1	تَضْمِينُ الْمَالِكِ
u'تَضْمِينٌ مُحْرِقٌ':Added, #1: 1	تَضْمِينِ الْمَالِيَّةِ
u'تَضْمِينٌ مُدَبَّرٌ':Added, #1: 1	تَضْمِينَ الْمُحْرِقِ
u'تَضْمِينٌ مُدَبِّرٌ':Added, #1: 1	تَضْمِينِ الْمُدَبَّرِ
u'تَضْمِينٌ مُدَبِّرٌ':Added, #1: 1	تَضْمِينُ الْمُدَبِّرِ
u'تَضْمِينٌ مُدَبِّرٌ':Added, #1: 1	تَضْمِينِ الْمُدَبِّرِ
u'تَضْمِينٌ مُسْتَأْجِرٌ':Added, #4: 4	تَضْمِينَ الْمُدَبِّرِ
u'تَضْمِينٌ مُسْتَعِيرٌ':Added, #1: 1	تَضْمِينِ الْمُسْتَأْجِرِ
u'تَضْمِينٌ مِسْكِينٌ':Added, #1: 1	تَضْمِينُ الْمُسْتَعِيرِ
u'تَضْمِينٌ مُصَالِحٌ':Added, #1: 1	تَضْمِينَ الْمِسْكِينِ
u'تَضْمِينٌ مُعْتَقٌ':Added, #1: 1	تَضْمِينَ الْمُصَالِحِ
u'تَضْمِينٌ مُقْتَنِي':Added, #2: 2	تَضْمِينُ الْمُعْتَقِ
u'تَضْمِينٌ مُكْرَهٌ':Added, #1: 1	تَضْمِينِ مُقْتَنِيهِ
u'تَضْمِينٌ مُكْرِهٌ':Added, #1: 1	تَضْمِينِ الْمُكْرَهِ
u'تَضْمِينٌ مُكْرِهٌ':Added, #1: 1	تَضْمِينِ الْمُكْرِهِ
u'تَضْمِينٌ مُلْتَقِط':Added, #2: 2	تَضْمِينَ الْمُكْرِهِ
u'تَضْمِينٌ مُلْتَقِط':Added, #1: 1	تَضْمِينُ الْمُلْتَقِطِ
u'تَضْمِينٌ مُودِعٌ':Added, #1: 1	تَضْمِينِ الْمُلْتَقِطِ
u'تَضْمِينٌ مُودِعٌ':Added, #1: 1	تَضْمِينَ الْمُودِعِ
u'تَضْمِينٌ مُودَعٌ':Added, #1: 1	تَضْمِينِ مُودِعِهِ
u'تَضْمِينٌ مُوسِرٌ':Added, #2: 2	تَضْمِينُ الْمُودَعِ
u'تَضْمِينٌ مُوَكِّلٌ':Added, #1: 1	تَضْمِينِ الْمُوسِرِ
u'تَضْمِينٌ نَاظِرٌ':Added, #1: 1	تَضْمِينِ الْمُوَكِّلِ
u'تَضْمِينٌ نِصْفٌ':Added, #1: 1	تَضْمِينُ النَّاظِرِ
u'تَضْمِينٌ نِصْفٌ':Added, #1: 1	تَضْمِينِ النِّصْفِ
u'تَضْمِينٌ نِصْفٌ':Added, #1: 1	تَضْمِينُ نِصْفِ
u'تَضْمِينٌ نَصِيبٌ':Added, #1: 1	تَضْمِينِ نِصْفِ
u'تَضْمِينٌ نَفْسٌ':Added, #1: 1	تَضْمِينُ نَصِيبِهِ
u'تَضْمِينٌ نُقْصَانٌ':Added, #1: 1	تَضْمِينُ نَفْسِهِ
u'تَضْمِينٌ نُقْصَانٌ':Added, #1: 1	تَضْمِينِ النُّقْصَانِ
u'تَضْمِينٌ نُقْصَانٌ':Added, #1: 1	تَضْمِينِ نُقْصَانِهِ
u'تَضْمِينٌ نُقْصَانٌ':Added, #2: 2	تَضْمِينُ نُقْصَانِ
u'تَضْمِينٌ نُقْصَانٌ':Added, #4: 4	تَضْمِينُ النُّقْصَانِ
u'تَضْمِينٌ واصِف':Added, #7: 7	تَضْمِينَ النُّقْصَانِ
u'تَضْمِينٌ وَاضِعٌ':Added, #1: 1	تَضْمِينِ الْوَاصِفِ
u'تَضْمِينٌ وَاقِفٌ':Added, #1: 1	تَضْمِينِ وَاضِعِ
u'تَضْمِينٌ وُجُوبٌ':Added, #1: 1	تَضْمِينَ الْوَاقِفِ
u'تَضْمِينٌ وَكِيلٌ':Added, #1: 1	تَضْمِينِ الْوُجُوبِ
u'تَضْمِينٌ وَكِيلٌ':Added, #1: 1	تَضْمِينَ الْوَكِيلِ
u'تَضْمِينٌ وَكِيلٌ':Added, #1: 1	تَضْمِينُ الْوَكِيلِ
u'تَضْمِينٌ وَكِيلٌ':Added, #1: 1	تَضْمِينِ الْوَكِيلِ
u'تَضْمِينٌ وَلِيٌّ':Added, #1: 1	تَضْمِينِ وَكِيلِ
u'تَضَيَّقَ وَقْتٌ':Subject, #2: 2	تَضْمِينِ الْوَلِيِّ
u'تَضَيُّقٌ وَقْتٌ':Added, #2: 2	تَضَيَّقَ وَقْتُهُ
u'تَضْيِيعٌ أَحْكَامٌ':Added, #1: 1	تَضَيُّقِ الْوَقْتِ
u'تَضْيِيعٌ إمَامٌ':Added, #1: 1	تَضْيِيعِ أَحْكَامِ
u'تَضْيِيعٌ أَمْوَالٌ':Added, #1: 1	تَضْيِيعِ الْإِمَامِ
u'تَضْيِيعٌ حَبٌّ':Added, #1: 1	تَضْيِيعُ الْأَمْوَالِ
u'تَضْيِيعٌ حَدٌّ':Added, #1: 1	تَضْيِيعِ الْحَبِّ
u'تَضْيِيعٌ حِفْظٌ':Added, #1: 1	تَضْيِيعُ الْحَدِّ
u'تَضْيِيعٌ حِفْظٌ':Added, #1: 1	تَضْيِيعَ حِفْظِ
u'تَضْيِيعٌ حَقٌّ':Added, #4: 4	تَضْيِيعُ حِفْظِ
u'تَضْيِيعٌ حُقوقٌ':Added, #1: 1	تَضْيِيعُ حَقِّ
u'تَضْيِيعٌ حُقُوقٌ':Added, #1: 1	تَضْيِيعِ حُقُوقِ
u'تَضْيِيعٌ حُقوقٌ':Added, #1: 1	تَضْيِيعِ حُقُوقِ
u'تَضْيِيعٌ حُقوقٌ':Added, #2: 2	تَضْيِيعَ الْحُقُوقِ
u'تَضْيِيعٌ حُقُوقٌ':Added, #2: 2	تَضْيِيعِ الْحُقُوقِ
u'تَضْيِيعٌ حُقُوقٌ':Added, #2: 2	تَضْيِيعَ الْحُقُوقِ
u'تَضْيِيعٌ حكمة':Added, #2: 2	تَضْيِيعِ الْحُقُوقِ
u'تَضْيِيعٌ حِكْمَةٌ':Added, #1: 1	تَضْيِيعُ حِكْمَةِ
u'تَضْيِيعٌ دِينٌ':Added, #1: 1	تَضْيِيعُ حِكْمَةِ
u'تَضْيِيعٌ زَكاةٌ':Added, #1: 1	تَضْيِيعِ دِينٍ
u'تَضْيِيعٌ زَمانٌ':Added, #1: 1	تَضْيِيعِ الزَّكَاةِ
u'تَضْيِيعٌ زَمانٌ':Added, #1: 1	تَضْيِيعِ الزَّمَانِ
u'تَضْيِيعٌ سَوْطٌ':Added, #1: 1	تَضْيِيعُ زَمَانٍ
u'تَضْيِيعٌ شَرَائِعُ':Added, #2: 2	تَضْيِيعِ السَّوْطِ
u'تَضْيِيعٌ صِفَةٌ':Added, #1: 1	تَضْيِيعِ الشَّرَائِعِ
u'تَضْيِيعٌ صَلاَةٌ':Added, #1: 1	تَضْيِيعُ صِفَةِ
u'تَضْيِيعٌ صَلاَةٌ':Added, #1: 1	تَضْيِيعُ الصَّلَاةِ
u'تَضْيِيعٌ طَلاَقٌ':Added, #4: 4	تَضْيِيعِ صَلَاةِ
u'تَضْيِيعٌ عارِيَّةٌ':Added, #2: 2	تَضْيِيعُ الطَّلَاقِ
u'تَضْيِيعٌ مَاءٌ':Added, #1: 1	تَضْيِيعِ الْعَارِيَّةِ
u'تَضْيِيعٌ مَاءٌ':Added, #1: 1	تَضْيِيعِ الْمَاءِ
u'تَضْيِيعٌ مَالٌ':Added, #2: 2	تَضْيِيعُ الْمَاءِ
u'تَضْيِيعٌ مَالٌ':Added, #1: 1	تَضْيِيعَ الْمَالِ
u'تَضْيِيعٌ مَالٌ':Added, #1: 1	تَضْيِيعُ مَالٍ
u'تَضْيِيعٌ مَالٌ':Added, #1: 1	تَضْيِيعِ مَالِهِ
u'تَضْيِيعٌ مَالٌ':Added, #3: 3	تَضْيِيعُ الْمَالِ
u'تَضْيِيعٌ مَالٌ':Added, #3: 3	تَضْيِيعِ الْمَالِ
u'تَضْيِيعٌ نَسْلٌ':Added, #3: 3	تَضْيِيعَ مَالِ
u'تَضْيِيعٌ نِيَّةٌ':Added, #2: 2	تَضْيِيعُ النَّسْلِ
u'تَضْيِيعٌ ولد':Added, #1: 1	تَضْيِيعُ النِّيَّةِ
u'تَضْيِيعٌ ولد':Added, #1: 1	تَضْيِيعَ الْوَلَدِ
u'تَضْيِيعٌ وَلَدٌ':Added, #1: 1	تَضْيِيعِ الْوَلَدِ
u'تَضْيِيعٌ وَلَدٌ':Added, #1: 1	تَضْيِيعَ الْوَلَدِ
u'تَضْيِيعٌ ولد':Added, #1: 1	تَضْيِيعِ الْوَلَدِ
u'تَضْيِيعٌ وَلَدٌ':Added, #2: 2	تَضْيِيعُ الْوَلَدِ
u'تَضْيِيقٌ أَمْرٌ':Added, #2: 2	تَضْيِيعُ الْوَلَدِ
u'تَضْيِيقٌ أَمْرٌ':Added, #1: 1	تَضْيِيقَ الْأَمْرِ
u'تَضْيِيقٌ سُطُورٌ':Added, #2: 2	تَضْيِيقُ الْأَمْرِ
u'تَضْيِيقٌ طُرُقٌ':Added, #1: 1	تَضْيِيقُ السُّطُورِ
u'تَضْيِيقٌ طَرِيقٌ':Added, #1: 1	تَضْيِيقُ الطُّرُقِ
u'تَضْيِيقٌ فَمٌ':Added, #2: 2	تَضْيِيقِ الطَّرِيقِ
u'تَضْيِيقٌ نُقُودٌ':Added, #1: 1	تَضْيِيقُ فَمِ
u'تَضْيِيقٌ وَقْتٌ':Added, #1: 1	تَضْيِيقُ النُّقُودِ
u'تَضْيِيقٌ وَقْتٌ':Added, #1: 1	تَضْيِيقِ الْوَقْتِ
u'تَطَابَقَ سُؤَالٌ':Subject, #1: 1	تَضْيِيقِ وَقْتِ
u'تَطَابَقَ عرف':Subject, #1: 1	تَطَابَقَ السُّؤَالُ
u'تَطَابَقَ عُرْفٌ':Subject, #1: 1	تَطَابَقَ الْعُرْفُ
u'تَطَابُقٌ لَفْظٌ':Added, #1: 1	تَطَابَقَ الْعُرْفُ
u'تَطَابَقَ نَاسٌ':Subject, #2: 2	تَطَابُقُ اللَّفْظَيْنِ
u'تَطَاوَلَ أَمْرٌ':Subject, #1: 1	تَطَابَقَ النَّاسُ
u'تَطَاوَلَ بَرْدٌ':Subject, #1: 1	تَطَاوَلَ الْأَمْرُ
u'تَطَاوَلَ جُنُونٌ':Subject, #1: 1	تَطَاوَلَ الْبَرْدُ
u'تَطَاوَلَ زَمانٌ':Subject, #1: 1	تَطَاوَلَ الْجُنُونُ
u'تَطَاوُلٌ زَمانٌ':Added, #4: 4	تَطَاوَلَ الزَّمَانُ
u'تَطَاوَلَ زَمَنٌ':Subject, #2: 2	تَطَاوُلِ الزَّمَانِ
u'تَطَاوَلَ زَمَنٌ':Subject, #1: 1	تَطَاوَلَ الزَّمَنُ
u'تَطَاوَلَ عَهْدٌ':Subject, #1: 1	تَطَاوَلَ زَمَنُهُ
u'تَطَاوَلَ فَصْلٌ':Subject, #1: 1	تَطَاوَلَ الْعَهْدُ
u'تَطَاوَلَ فِعْلٌ':Subject, #3: 3	تَطَاوَلَ الْفَصْلُ
u'تَطَاوَلَ لَيْلٌ':Subject, #1: 1	تَطَاوَلَ فِعْلُ
u'تَطَاوُلٌ مُدَّةٌ':Added, #1: 1	تَطَاوَلَ اللّيْلُ
u'تَطَاوَلَ مَرَضٌ':Subject, #7: 7	تَطَاوُلِ الْمُدَّةِ
u'تَطَاوَلَ وَقْتٌ':Subject, #2: 2	تَطَاوَلَ الْمَرَضُ
u'تَطَايُرٌ شَعَرٌ':Added, #1: 1	تَطَاوَلَ وَقْتُهُ
u'تَطَايُرٌ شُعرَاءُ':Added, #1: 1	تَطَايُرَ الشّعَرِ
u'تَطَايُرٌ شُعرَاءُ':Added, #1: 1	تَطَايُر الشّعْرَاءِ
u'تَطَايُرٌ شَعْرَاءُ':Added, #1: 1	تَطَايُرَ الشّعْرَاءِ
u'تَطَايُرٌ شَعْرَاءُ':Added, #1: 1	تَطَايُر الشّعْرَاءِ
u'تَطَايُرٌ صُحُفٌ':Added, #1: 1	تَطَايُرَ الشّعْرَاءِ
u'تَطَايُرٌ صُحُفٌ':Added, #1: 1	تَطَايُرُ الصُّحُفِ
u'تَطَايَرَ قَبْرٌ':Subject, #2: 2	تَطَايُرِ الصُّحُفِ
u'تَطَبَّبَ غير':Subject, #1: 1	تَطَايَرَ قَبْرُهُ
u'تَطَبَّبَ غَيْرٌ':Subject, #1: 1	تَطَبَّبَ غَيْرُ
u'تَطَبُّبٌ مُسْلِمٌ':Added, #1: 1	تَطَبَّبَ غَيْرُ
u'تَطْبِيقٌ أَفْعَالٌ':Added, #1: 1	تَطَبُّبُ الْمُسْلِمِ
u'تَطْبِيقٌ جَوَابٌ':Added, #1: 1	تَطْبِيقِ أَفْعَالِهِ
u'تَطْبِيقٌ صَلاَةٌ':Added, #1: 1	تَطْبِيقُ الْجَوَابِ
u'تَطْبِيقٌ فُرُوعٌ':Added, #1: 1	تَطْبِيقَ الصَّلَاةِ
u'تَطْبِيقٌ وُجُوهٌ':Added, #1: 1	تَطْبِيقُ الْفُرُوعِ
u'تَطَرُّقٌ اِسْتِحْقَاقٌ':Added, #1: 1	تَطْبِيقِ الْوُجُوهِ
u'تَطَرُّقٌ أَلْسِنَةٌ':Added, #1: 1	تَطَرُّقِ اسْتِحْقَاقِ
u'تَطَرُّقٌ أَلْسِنَةٌ':Added, #1: 1	تَطَرُّقُ الْأَلْسِنَةِ
u'تَطَرُّقٌ تَخْصِيصٌ':Added, #1: 1	تَطَرُّقِ الْأَلْسِنَةِ
u'تَطَرُّقٌ تُهْمَةٌ':Added, #2: 2	تَطَرُّقَ التَّخْصِيصِ
u'تَطَرُّقٌ خَطَأٌ':Added, #1: 1	تَطَرُّقِ التُّهْمَةِ
u'تَطَرَّقَ خَلَلٌ':Subject, #1: 1	تَطَرُّقِ الْخَطَأِ
u'تَطَرُّقٌ خَلَلٌ':Added, #1: 1	تَطَرَّقَ الْخَلَلُ
u'تَطَرَّقَ عَدَمٌ':Subject, #1: 1	تَطَرُّقِ الْخَلَلِ
u'تَطَرُّقٌ غَلَطٌ':Added, #1: 1	تَطَرَّقَ عَدَمُ
u'تَطَرَّقَ قِيَاسٌ':Subject, #1: 1	تَطَرُّقِ الْغَلَطِ
u'تَطَرُّقٌ مُحْرِمٌ':Added, #1: 1	تَطَرَّقَ الْقِيَاسُ
u'تَطَرُّقٌ نَدَمٌ':Added, #1: 1	تَطَرُّقُ الْمُحْرِمِ
u'تَطَرَّقَ وَهْنٌ':Subject, #1: 1	تَطَرُّقِ النَّدَمِ
u'تَطْرِيبٌ صَوْتٌ':Added, #1: 1	تَطَرَّقَ الْوَهْنُ
u'تَطْرِيقٌ إِكْمَالٌ':Added, #1: 1	تَطْرِيبِ الصَّوْتِ
u'تَطَلَّبَ حَديثٌ':Predicate, #1: 1	تَطْرِيقِ الْإِكْمَالِ
u'تَطَلُّبٌ غَرَضٌ':Added, #1: 1	تَطَلَّبَ الْحَدِيثَ
u'تَطَلُّبٌ كُفَّارٌ':Added, #1: 1	تَطَلُّبُ الْغَرَضِ
u'تَطَلُّعٌ شَارِعٌ':Added, #1: 1	تَطَلُّبَ الْكُفَّارِ
u'تَطْلِيقٌ اِمْرَأَةٌ':Added, #1: 1	تَطَلُّعِ الشَّارِعِ
u'تَطْلِيقٌ اِمْرَأَةٌ':Added, #1: 1	تَطْلِيقِ امْرَأَةِ
u'تَطْلِيقٌ اِمْرَأَةٌ':Added, #1: 1	تَطْلِيقُ امْرَأَتِهِ
u'تَطْلِيقٌ بَعْضٌ':Added, #1: 1	تَطْلِيقِ امْرَأَتِهِ
u'تَطْلِيقٌ بَعْضٌ':Added, #1: 1	تَطْلِيقَ بَعْضِ
u'تَطْلِيقٌ بناتٌ':Added, #1: 1	تَطْلِيقِ بَعْضِ
u'تَطْلِيقٌ ثَانِي':Added, #1: 1	تَطْلِيقِ بَنَاتِ
u'تَطْلِيقٌ ثَانِيَةٌ':Added, #1: 1	تَطْلِيقُ الثَّانِيَةِ
u'تَطْلِيقٌ حامِلٌ':Added, #1: 1	تَطْلِيقُ الثَّانِيَةِ
u'تَطْلِيقٌ زَوْجٌ':Added, #1: 1	تَطْلِيقِ الْحَامِلِ
u'تَطْلِيقٌ زَوْجٌ':Added, #2: 2	تَطْلِيقِ الزَّوْجِ
u'تَطْلِيقٌ زَوْجَةٌ':Added, #3: 3	تَطْلِيقُ الزَّوْجِ
u'تَطْلِيقٌ زَوْجَةٌ':Added, #1: 1	تَطْلِيقِ زَوْجَةِ
u'تَطْلِيقٌ غَائِبٌ':Added, #2: 2	تَطْلِيقِ زَوْجَتِهِ
u'تَطْلِيقٌ فَاجِرٌ':Added, #1: 1	تَطْلِيقَ الْغَائِبَةِ
u'تَطْلِيقٌ وَكِيلٌ':Added, #1: 1	تَطْلِيقُ الْفَاجِرَةِ
u'تَطْلِيقٌ وَكِيلٌ':Added, #1: 1	تَطْلِيقُ وَكِيلِ
u'تَطَهَّرَ إمَامٌ':Subject, #1: 1	تَطْلِيقُ وَكِيلِهِ
u'تَطَهُّرٌ اِمْرَأَةٌ':Added, #2: 2	تَطَهَّرَ الْإِمَامُ
u'تَطَهَّرَ جَسَدٌ':Subject, #1: 1	تَطَهُّرِ امْرَأَةٍ
u'تَطَهَّرَ رَجُلٌ':Subject, #1: 1	تَطَهَّرَ جَسَدُهُ
u'تَطَهَّرَ قَوْمٌ':Subject, #3: 3	تَطَهَّرَ الرَّجُلُ
u'تَطَهَّرَ مَحَلٌّ':Predicate, #1: 1	تَطَهَّرَ الْقَوْمُ
u'تَطْهِيرٌ آبارٌ':Added, #1: 1	تَطَهَّرَ الْمَحَلَّ
u'تَطْهِيرٌ أَعْضَاءٌ':Added, #1: 1	تَطْهِيرَ الْآبَارِ
u'تَطْهِيرٌ أَعْضَاءٌ':Added, #1: 1	تَطْهِيرُ أَعْضَاءِ
u'تَطْهِيرٌ أعْيانٌ':Added, #3: 3	تَطْهِيرُ الْأَعْضَاءِ
u'تَطْهِيرٌ أَعْيَانٌ':Added, #1: 1	تَطْهِيرِ الْأَعْيَانِ
u'تَطْهِيرٌ أَنْجَاسٌ':Added, #1: 1	تَطْهِيرِ الْأَعْيَانِ
u'تَطْهِيرٌ آنِيَةٌ':Added, #1: 1	تَطْهِيرِ الْأَنْجَاسِ
u'تَطْهِيرٌ بَاطن':Added, #1: 1	تَطْهِيرِ آنِيَةِ
u'تَطْهِيرٌ باطِنٌ':Added, #1: 1	تَطْهِيرُ بَاطِنِ
u'تَطْهِيرٌ بَاطن':Added, #1: 1	تَطْهِيرُ بَاطِنِ
u'تَطْهِيرٌ باطِنٌ':Added, #1: 1	تَطْهِيرِ بَاطِنِهِ
u'تَطْهِيرٌ بدن':Added, #1: 1	تَطْهِيرِ بَاطِنِهِ
u'تَطْهِيرٌ بدن':Added, #1: 1	تَطْهِيرُ الْبَدَنِ
u'تَطْهِيرٌ بَدَنٌ':Added, #1: 1	تَطْهِيرِ الْبَدَنِ
u'تَطْهِيرٌ بَدَنٌ':Added, #1: 1	تَطْهِيرُ الْبَدَنِ
u'تَطْهِيرٌ بَوْلٌ':Added, #1: 1	تَطْهِيرِ الْبَدَنِ
u'تَطْهِيرٌ ثَوْبٌ':Added, #1: 1	تَطْهِيرِ بَوْلِ
u'تَطْهِيرٌ ثَوْبٌ':Added, #2: 2	تَطْهِيرُ الثَّوْبِ
u'تَطْهِيرٌ ثِيابٌ':Added, #6: 6	تَطْهِيرِ الثَّوْبِ
u'تَطْهِيرٌ ثِيابٌ':Added, #1: 1	تَطْهِيرِ ثِيَابِهِ
u'تَطْهِيرٌ جلد':Added, #2: 2	تَطْهِيرَ ثِيَابِهِ
u'تَطْهِيرٌ جِلْدٌ':Added, #1: 1	تَطْهِيرُ جِلْدِ
u'تَطْهِيرٌ حَجَرٌ':Added, #1: 1	تَطْهِيرُ جِلْدِ
u'تَطْهِيرٌ حَقِيقٌ':Added, #2: 2	تَطْهِيرِ الْحَجَرِ
u'تَطْهِيرٌ حَقِيقَةٌ':Added, #1: 1	تَطْهِيرِ الْحَقِيقَةِ
u'تَطْهِيرٌ حَوْضٌ':Added, #1: 1	تَطْهِيرِ الْحَقِيقَةِ
u'تَطْهِيرٌ دَارٌ':Added, #1: 1	تَطْهِيرِ الْحَوْضِ
u'تَطْهِيرٌ ذُنُوبٌ':Added, #2: 2	تَطْهِيرُ دَارِ
u'تَطْهِيرٌ رَجُلٌ':Added, #1: 1	تَطْهِيرُ الذُّنُوبِ
u'تَطْهِيرٌ عُضْوٌ':Added, #1: 1	تَطْهِيرِ الرَّجُلِ
u'تَطْهِيرٌ عُضْوٌ':Added, #1: 1	تَطْهِيرِ عُضْوٍ
u'تَطْهِيرٌ غير':Added, #2: 2	تَطْهِيرِ الْعُضْوِ
u'تَطْهِيرٌ غَيْرٌ':Added, #1: 1	تَطْهِيرِ الْغَيْرِ
u'تَطْهِيرٌ فَمٌ':Added, #1: 1	تَطْهِيرِ الْغَيْرِ
u'تَطْهِيرٌ فَمٌ':Added, #1: 1	تَطْهِيرِ الْفَمِ
u'تَطْهِيرٌ لَحْمٌ':Added, #2: 2	تَطْهِيرُ الْفَمِ
u'تَطْهِيرٌ لَحْمٌ':Added, #1: 1	تَطْهِيرِ اللَّحْمِ
u'تَطْهِيرٌ مَاءٌ':Added, #1: 1	تَطْهِيرِ لَحْمٍ
u'تَطْهِيرٌ مَاءٌ':Added, #1: 1	تَطْهِيرَ الْمَاءِ
u'تَطْهِيرٌ مَاءٌ':Added, #1: 1	تَطْهِيرُ الْمَاءِ
u'تَطْهِيرٌ مَالٌ':Added, #1: 1	تَطْهِيرِ الْمَاءِ
u'تَطْهِيرٌ مَحَلٌّ':Added, #1: 1	تَطْهِيرَ مَالِهِ
u'تَطْهِيرٌ مَحَلٌّ':Added, #1: 1	تَطْهِيرُ الْمَحَلِّ
u'تَطْهِيرٌ مَكَانٌ':Added, #2: 2	تَطْهِيرُ مَحَلِّ
u'تَطْهِيرٌ نَجَاسَةٌ':Added, #1: 1	تَطْهِيرُ الْمَكَانِ
u'تَطْهِيرٌ نَجَاسَةٌ':Added, #1: 1	تَطْهِيرِ النَّجَاسَاتِ
u'تَطْهِيرٌ نَجَاسَةٌ':Added, #3: 3	تَطْهِيرِ النَّجَاسَةِ
u'تَطْهِيرٌ نَفْسٌ':Added, #7: 7	تَطْهِيرُ النَّجَاسَةِ
u'تَطْهِيرٌ وَجْهٌ':Added, #1: 1	تَطْهِيرُ النَّفْسِ
u'تَطَوَّعَ أخرَس':Subject, #1: 1	تَطْهِيرُ الْوَجْهِ
u'تَطَوُّعٌ إمَامٌ':Added, #1: 1	تَطَوَّعَ الْأَخْرَسُ
u'تَطَوَّعَ إِنْسانٌ':Subject, #1: 1	تَطَوُّعُ الْإِمَامِ
u'تَطَوَّعَ أهْلٌ':Subject, #2: 2	تَطَوَّعَ إنْسَانٌ
u'تَطَوُّعٌ بدن':Added, #1: 1	تَطَوَّعَ أَهْلُهُ
u'تَطَوُّعٌ بَدَنٌ':Added, #1: 1	تَطَوُّعَ الْبَدَنِ
u'تَطَوُّعٌ بدن':Added, #1: 1	تَطَوُّعَ الْبَدَنِ
u'تَطَوُّعٌ بَدَنٌ':Added, #2: 2	تَطَوُّعِ الْبَدَنِ
u'تَطَوَّعَ جَازٌ':Predicate, #2: 2	تَطَوُّعِ الْبَدَنِ
u'تَطَوُّعٌ جهاد':Added, #1: 1	تَطَوَّعَ جَازَ
u'تَطَوُّعٌ جِهَادٌ':Added, #1: 1	تَطَوُّعُ الْجِهَادِ
u'تَطَوَّعَ حاجٌّ':Subject, #1: 1	تَطَوُّعُ الْجِهَادِ
u'تَطَوُّعٌ حائِضٌ':Added, #2: 2	تَطَوَّعَ الْحَاجُّ
u'تَطَوُّعٌ حَجٌّ':Added, #2: 2	تَطَوُّعُ حَائِضٍ
u'تَطَوَّعَ رَجُلٌ':Subject, #1: 1	تَطَوُّعِ الْحَجِّ
u'تَطَوُّعٌ رَسُولٌ':Added, #1: 1	تَطَوَّعَ رَجُلٌ
u'تَطَوَّعَ شَخْصٌ':Subject, #2: 2	تَطَوُّعِ رَسُولِ
u'تَطَوُّعٌ صَلاَةٌ':Added, #1: 1	تَطَوَّعَ شَخْصٌ
u'تَطَوُّعٌ صَوْمٌ':Added, #3: 3	تَطَوُّعِ الصَّلَاةِ
u'تَطَوُّعٌ عَابِدٌ':Added, #1: 1	تَطَوُّعِ صَوْمٍ
u'تَطَوَّعَ غَيْرٌ':Subject, #1: 1	تَطَوُّعِ عَابِدٍ
u'تَطَوَّعَ مُتَطَوِّعٌ':Subject, #2: 2	تَطَوَّعَ غَيْرٌ
u'تَطَوُّعٌ مُسَافِرٌ':Added, #2: 2	تَطَوَّعَ مُتَطَوِّعٌ
u'تَطَوُّعٌ نَبِيٌّ':Added, #1: 1	تَطَوُّعِ الْمُسَافِرِ
u'تَطَوُّعٌ نَبِيٌّ':Added, #1: 1	تَطَوُّعُ النَّبِيِّ
u'تَطَوُّعٌ نهار':Added, #1: 1	تَطَوُّعِ النَّبِيِّ
u'تَطَوُّعٌ نَهَارٌ':Added, #1: 1	تَطَوُّعُ النَّهَارِ
u'تَطْوِيلٌ أَرْكانٌ':Added, #1: 1	تَطَوُّعُ النَّهَارِ
u'تَطْوِيلٌ أَرْكَانٌ':Added, #1: 1	تَطْوِيلِ أَرْكَانِ
u'تَطْوِيلٌ إِزَارٌ':Added, #1: 1	تَطْوِيلِ أَرْكَانِ
u'تَطْوِيلٌ أَظْفارٌ':Added, #1: 1	تَطْوِيلَ الْإِزَارِ
u'تَطْوِيلٌ إمَامٌ':Added, #1: 1	تَطْوِيلُ الْأَظْفَارِ
u'تَطْوِيلٌ إمَامٌ':Added, #1: 1	تَطْوِيلِ الْإِمَامِ
u'تَطْوِيلٌ إمَامٌ':Added, #1: 1	تَطْوِيلُ إمَامٍ
u'تَطْوِيلٌ أولى':Added, #1: 1	تَطْوِيلِ إمَامِهِ
u'تَطْوِيلٌ أوْلَى':Added, #1: 1	تَطْوِيلِ الأُولَيَيْنِ
u'تَطْوِيلٌ بَحْثٌ':Added, #1: 1	تَطْوِيلِ الأُولَيَيْنِ
u'تَطْوِيلٌ بَعْضٌ':Added, #1: 1	تَطْوِيلُ الْبَحْثِ
u'تَطْوِيلٌ ثَانِي':Added, #1: 1	تَطْوِيلُ بَعْضِ
u'تَطْوِيلٌ ثَانِي':Added, #2: 2	تَطْوِيلُ الثَّانِيَةِ
u'تَطْوِيلٌ ثَانِيَةٌ':Added, #2: 2	تَطْوِيلِ الثَّانِيَةِ
u'تَطْوِيلٌ ثَانِيَةٌ':Added, #2: 2	تَطْوِيلُ الثَّانِيَةِ
u'تَطْوِيلٌ جلسة':Added, #2: 2	تَطْوِيلِ الثَّانِيَةِ
u'تَطْوِيلٌ جِلْسَةٌ':Added, #1: 1	تَطْوِيلَ جِلْسَةِ
u'تَطْوِيلٌ جلسة':Added, #1: 1	تَطْوِيلَ جِلْسَةِ
u'تَطْوِيلٌ جِلْسَةٌ':Added, #2: 2	تَطْوِيلِ جِلْسَةِ
u'تَطْوِيلٌ حَبْسٌ':Added, #2: 2	تَطْوِيلِ جِلْسَةِ
u'تَطْوِيلٌ ركعة':Added, #1: 1	تَطْوِيلَ الْحَبْسِ
u'تَطْوِيلٌ رَكْعَةٌ':Added, #1: 1	تَطْوِيلَ الرَّكْعَةِ
u'تَطْوِيلٌ ركعة':Added, #1: 1	تَطْوِيلَ الرَّكْعَةِ
u'تَطْوِيلٌ رَكْعَةٌ':Added, #1: 1	تَطْوِيلِ رَكْعَةٍ
u'تَطْوِيلٌ ركعة':Added, #1: 1	تَطْوِيلِ رَكْعَةٍ
u'تَطْوِيلٌ رَكْعَةٌ':Added, #2: 2	تَطْوِيلُ الرَّكْعَةِ
u'تَطْوِيلٌ ركعة':Added, #2: 2	تَطْوِيلُ الرَّكْعَةِ
u'تَطْوِيلٌ رَكْعَةٌ':Added, #3: 3	تَطْوِيلِ الرَّكْعَةِ
u'تَطْوِيلٌ رُكْنٌ':Added, #3: 3	تَطْوِيلِ الرَّكْعَةِ
u'تَطْوِيلٌ رُكْنٌ':Added, #3: 3	تَطْوِيلَ الرُّكْنِ
u'تَطْوِيلٌ رُكْن':Added, #3: 3	تَطْوِيلُ الرُّكْنِ
u'تَطْوِيلٌ رُكْن':Added, #3: 3	تَطْوِيلَ الرُّكْنِ
u'تَطْوِيلٌ رُكْنٌ':Added, #3: 3	تَطْوِيلُ الرُّكْنِ
u'تَطْوِيلٌ رُكْن':Added, #5: 5	تَطْوِيلِ الرُّكْنِ
u'تَطْوِيلٌ رُكْنٌ':Added, #5: 5	تَطْوِيلِ الرُّكْنِ
u'تَطْوِيلٌ رُكْن':Added, #5: 5	تَطْوِيلِ رُكْنٍ
u'تَطْوِيلٌ رُكوعٌ':Added, #5: 5	تَطْوِيلِ رُكْنٍ
u'تَطْوِيلٌ رُكوعٌ':Added, #1: 1	تَطْوِيلُ الرُّكُوعِ
u'تَطْوِيلٌ رَواتِبُ':Added, #2: 2	تَطْوِيلِ الرُّكُوعِ
u'تَطْوِيلٌ رَوَاتِبُ':Added, #1: 1	تَطْوِيلِ الرَّوَاتِبِ
u'تَطْوِيلٌ زائِدٌ':Added, #1: 1	تَطْوِيلِ الرَّوَاتِبِ
u'تَطْوِيلٌ سُجُودٌ':Added, #2: 2	تَطْوِيلٍ زَائِدٍ
u'تَطْوِيلٌ سُجُودٌ':Added, #1: 1	تَطْوِيلَ السُّجُودِ
u'تَطْوِيلٌ سَفَرٌ':Added, #1: 1	تَطْوِيلُ السُّجُودِ
u'تَطْوِيلٌ شَعْرٌ':Added, #1: 1	تَطْوِيلَ السَّفَرِ
u'تَطْوِيلٌ صَلاَةٌ':Added, #1: 1	تَطْوِيلُ الشَّعْرِ
u'تَطْوِيلٌ صَلاَةٌ':Added, #1: 1	تَطْوِيلُ صَلَاةِ
u'تَطْوِيلٌ صَلاَةٌ':Added, #2: 2	تَطْوِيلُ الصَّلَاةِ
u'تَطْوِيلٌ طَرِيقٌ':Added, #2: 2	تَطْوِيلِ الصَّلَاةِ
u'تَطْوِيلٌ عِدَّةٌ':Added, #2: 2	تَطْوِيلَ الطَّرِيقِ
u'تَطْوِيلٌ عِدَّةٌ':Added, #10: 10	تَطْوِيلُ الْعِدَّةِ
u'تَطْوِيلٌ عِدَّةٌ':Added, #1: 1	تَطْوِيلَ عِدَّةٍ
u'تَطْوِيلٌ عِدَّةٌ':Added, #1: 1	تَطْوِيلُ عِدَّةٍ
u'تَطْوِيلٌ عِدَّةٌ':Added, #27: 27	تَطْوِيلِ الْعِدَّةِ
u'تَطْوِيلٌ غُرَّةٌ':Added, #2: 2	تَطْوِيلَ الْعِدَّةِ
u'تَطْوِيلٌ غير':Added, #2: 2	تَطْوِيلُ الْغُرَّةِ
u'تَطْوِيلٌ غَيْرٌ':Added, #1: 1	تَطْوِيلُ غَيْرِ
u'تَطْوِيلٌ قِرَاءةٌ':Added, #1: 1	تَطْوِيلُ غَيْرِ
u'تَطْوِيلٌ قِرَاءةٌ':Added, #1: 1	تَطْوِيلَ الْقِرَاءَةِ
u'تَطْوِيلٌ قِرَاءةٌ':Added, #1: 1	تَطْوِيلِ قِرَاءَةِ
u'تَطْوِيلٌ قِرَاءةٌ':Added, #2: 2	تَطْوِيلَ قِرَاءَتِهِ
u'تَطْوِيلٌ قِرَاءةٌ':Added, #5: 5	تَطْوِيلِ الْقِرَاءَةِ
u'تَطْوِيلٌ قَصِيرٌ':Added, #7: 7	تَطْوِيلُ الْقِرَاءَةِ
u'تَطْوِيلٌ قول':Added, #1: 1	تَطْوِيلَ الْقَصِيرِ
u'تَطْوِيلٌ قَوْلٌ':Added, #1: 1	تَطْوِيلِ الْقَوْلِ
u'تَطْوِيلٌ قيام':Added, #1: 1	تَطْوِيلِ الْقَوْلِ
u'تَطْوِيلٌ قيام':Added, #2: 2	تَطْوِيلُ الْقِيَامِ
u'تَطْوِيلٌ قِيَامٌ':Added, #2: 2	تَطْوِيلِ الْقِيَامِ
u'تَطْوِيلٌ قِيَامٌ':Added, #2: 2	تَطْوِيلُ الْقِيَامِ
u'تَطْوِيلٌ قِيَامٌ':Added, #2: 2	تَطْوِيلِ الْقِيَامِ
u'تَطْوِيلٌ كُمٌّ':Added, #3: 3	تَطْوِيلُ قِيَامٍ
u'تَطْوِيلٌ مَسَافَةٌ':Added, #3: 3	تَطْوِيلُ كُمِّ
u'تَطْوِيلٌ مُكْثٌ':Added, #1: 1	تَطْوِيلَ الْمَسَافَةِ
u'تَطَيَّبَ مُحْرِمٌ':Subject, #1: 1	تَطْوِيلِ مُكْثِهِ
u'تَطَيُّبٌ مُحْرِمٌ':Added, #3: 3	تَطَيَّبَ الْمُحْرِمُ
u'تَطَيَّبَ مرٌّ':Predicate, #1: 1	تَطَيُّبَ الْمُحْرِمِ
u'تَطَيُّبٌ مُصْحَفٌ':Added, #1: 1	تَطَيَّبَ مَرَّةً
u'تَطَيُّبٌ مُصْحَفٌ':Added, #1: 1	تَطَيُّبُ الْمُصْحَفِ
u'تَطَيَّبَ نَفْسٌ':Subject, #1: 1	تَطَيُّبِ الْمُصْحَفِ
u'تَطْيِيبٌ أَمْزِجَةٌ':Added, #1: 1	تَطَيَّبَ النَّفْسُ
u'تَطْيِيبٌ بَعْضٌ':Added, #1: 1	تَطْيِيبَ الْأَمْزِجَةِ
u'تَطْيِيبٌ ثَوْبٌ':Added, #1: 1	تَطْيِيبِ بَعْضِ
u'تَطْيِيبٌ ثَوْبٌ':Added, #1: 1	تَطْيِيبِ ثَوْبِهِ
u'تَطْيِيبٌ خَاطِرٌ':Added, #3: 3	تَطْيِيبُ ثَوْبِهِ
u'تَطْيِيبٌ رَائِحٌ':Added, #1: 1	تَطْيِيبَ خَاطِرِ
u'تَطْيِيبٌ رَائِحَةٌ':Added, #1: 1	تَطْيِيبُ رَائِحَةِ
u'تَطْيِيبٌ رُبْعٌ':Added, #1: 1	تَطْيِيبُ رَائِحَةِ
u'تَطْيِيبٌ عُضْوٌ':Added, #2: 2	تَطْيِيبِ رُبْعِ
u'تَطْيِيبٌ قُلُوبٌ':Added, #2: 2	تَطْيِيبِ الْعُضْوِ
u'تَطْيِيبٌ كعبة':Added, #1: 1	تَطْيِيبُ قُلُوبِ
u'تَطْيِيبٌ كَعْبَةٌ':Added, #1: 1	تَطْيِيبِ الْكَعْبَةِ
u'تَطْيِيبٌ لَحْمٌ':Added, #1: 1	تَطْيِيبِ الْكَعْبَةِ
u'تَطْيِيبٌ لَحْمٌ':Added, #1: 1	تَطْيِيبُ اللَّحْمِ
u'تَطْيِيبٌ مَسْجِدٌ':Added, #1: 1	تَطْيِيبِ اللَّحْمِ
u'تَطْيِيبٌ نَكْهَةٌ':Added, #1: 1	تَطْيِيبِ مَسْجِدِ
u'تَطْيِيرٌ حَمَامٌ':Added, #1: 1	تَطْيِيبِ النَّكْهَةِ
u'تَطْيِينٌ حائِطٌ':Added, #1: 1	تَطْيِيرَ الْحَمَامِ
u'تَطْيِينٌ حائِطٌ':Added, #1: 1	تَطْيِينِ الْحَائِطِ
u'تَطْيِينٌ دَارٌ':Added, #1: 1	تَطْيِينِ حَائِطِهِ
u'تَطْيِينٌ دَارٌ':Added, #1: 1	تَطْيِينَ الدَّارِ
u'تَطْيِينٌ سُطُوحٌ':Added, #2: 2	تَطْيِينِ الدَّارِ
u'تَطْيِينٌ قَبْرٌ':Added, #1: 1	تَطْيِينِ السُّطُوحِ
u'تَطْيِينٌ قُبُورٌ':Added, #1: 1	تَطْيِينَ الْقَبْرِ
u'تَطْيِينٌ قُبُورٌ':Added, #1: 1	تَطْيِينُ الْقُبُورِ
u'تَظَاهُرٌ أخْبَارٌ':Added, #1: 1	تَطْيِينِ الْقُبُورِ
u'تَظَاهُرٌ أَخْبَارٌ':Added, #1: 1	تَظَاهُرُ الْأَخْبَارِ
u'تَظَاهَرَ أهْلٌ':Subject, #1: 1	تَظَاهُرُ الْأَخْبَارِ
u'تَظَاهُرٌ قُرَيْشٌ':Added, #1: 1	تَظَاهَرَ أَهْلُ
u'تَظَاهَرَ نعمة':Predicate, #1: 1	تَظَاهُرِ قُرَيْشٍ
u'تَظَاهَرَ نِعْمَةٌ':Predicate, #1: 1	تَظَاهَرَ نِعْمَةَ
u'تَظَلُّمٌ أرْبَابٌ':Added, #1: 1	تَظَاهَرَ نِعْمَةَ
u'تَظَلُّمٌ الْمَرْأَةُ':Added, #2: 2	تَظَلُّمِ أَرْبَابِهِ
u'تَظَلُّمٌ حاجَةٌ':Added, #1: 1	تَظَلُّمُ الْمَرْأَةِ
u'تَعَادُلٌ أمَارَةٌ':Added, #1: 1	تَظَلُّمَ الْحَاجَاتِ
u'تَعَادُلٌ أمَارَةٌ':Added, #1: 1	تَعَادُلَ الْأَمَارَاتِ
u'تَعَادُلٌ دَليلٌ':Added, #3: 3	تَعَادُلِ الْأَمَارَاتِ
u'تَعَادُلٌ مُرَجِّحٌ':Added, #1: 1	تَعَادُلِ الدَّلِيلَيْنِ
u'تَعَارَضَ إِجْمَاعٌ':Subject, #1: 1	تَعَادُلِ الْمُرَجِّحَيْنِ
u'تَعَارُضٌ إِجْمَاعٌ':Added, #1: 1	تَعَارَضَ الْإِجْمَاعُ
u'تَعَارُضٌ إِجْمَاعٌ':Added, #1: 1	تَعَارُضِ إجْمَاعَيْنِ
u'تَعَارُضٌ إِجْمَاعٌ':Added, #1: 1	تَعَارُضَ الْإِجْمَاعَيْنِ
u'تَعَارُضٌ إِجْمَاعٌ':Added, #1: 1	تَعَارُضُ الْإِجْمَاعَيْنِ
u'تَعَارُضٌ إِجْمَاعٌ':Added, #2: 2	تَعَارُضُ الْإِجْمَاعِ
u'تَعَارُضٌ أخْبَارٌ':Added, #3: 3	تَعَارُضِ الْإِجْمَاعَيْنِ
u'تَعَارُضٌ أَخْبَارٌ':Added, #2: 2	تَعَارُضُ الْأَخْبَارِ
u'تَعَارَضَ إِدْرَاكٌ':Subject, #2: 2	تَعَارُضُ الْأَخْبَارِ
u'تَعَارُضٌ آرَاءٌ':Added, #1: 1	تَعَارَضَ إدْرَاكُ
u'تَعَارَضَ أسْوَد':Subject, #3: 3	تَعَارُضِ الْآرَاءِ
u'تَعَارُضٌ إشارَة':Added, #1: 1	تَعَارَضَ أَسْوَدُ
u'تَعَارُضٌ أشباه':Added, #1: 1	تَعَارُضِ الْإِشَارَةِ
u'تَعَارُضٌ أشْبَاهٌ':Added, #2: 2	تَعَارُضُ الْأَشْبَاهِ
u'تَعَارُضٌ أَشْبَاهٌ':Added, #2: 2	تَعَارُضُ الْأَشْبَاهِ
u'تَعَارَضَ أصل':Subject, #2: 2	تَعَارُضُ الْأَشْبَاهِ
u'تَعَارَضَ أًصْلٌ':Subject, #1: 1	تَعَارَضَ أَصْلُ
u'تَعَارَضَ أصل':Subject, #1: 1	تَعَارَضَ أَصْلُ
u'تَعَارَضَ أًصْلٌ':Subject, #2: 2	تَعَارَضَ الْأَصْلُ
u'تَعَارُضٌ أصل':Added, #2: 2	تَعَارَضَ الْأَصْلُ
u'تَعَارُضٌ أًصْلٌ':Added, #11: 11	تَعَارُضِ الْأَصْلِ
u'تَعَارُضٌ أًصْلٌ':Added, #11: 11	تَعَارُضِ الْأَصْلِ
u'تَعَارُضٌ أًصْلٌ':Added, #1: 1	تَعَارُضِ أَصْلَيْنِ
u'تَعَارُضٌ إضْمارٌ':Added, #3: 3	تَعَارُضِ الْأَصْلَيْنِ
u'تَعَارَضَ أعْلَمُ':Subject, #1: 1	تَعَارُضِ الْإِضْمَارِ
u'تَعَارَضَ إفْتَاءٌ':Subject, #1: 1	تَعَارَضَ أَعْلَمُ
u'تَعَارُضٌ أَقْوَالٌ':Added, #1: 1	تَعَارَضَ إفْتَاءُ
u'تَعَارُضٌ أَقْيِسَةٌ':Added, #1: 1	تَعَارُضَ أَقْوَالِ
u'تَعَارَضَ أَمْرٌ':Subject, #2: 2	تَعَارُضِ الْأَقْيِسَةِ
u'تَعَارَضَ إِمْكانٌ':Subject, #1: 1	تَعَارَضَ الْأَمْرُ
u'تَعَارَضَ أوْثَقُ':Subject, #1: 1	تَعَارَضَ الْإِمْكَانَاتُ
u'تَعَارَضَ بَاعِثٌ':Subject, #1: 1	تَعَارَضَ الْأَوْثَقُ
u'تَعَارَضَ بَوْلٌ':Subject, #1: 1	تَعَارَضَ بَاعِثُ
u'تَعَارَضَ بَوْلٌ':Subject, #1: 1	تَعَارَضَ الْبَوْلُ
u'تَعَارَضَ بَيْنٌ':Predicate, #1: 1	تَعَارَضَ بَوْلٌ
u'تَعَارُضٌ بَيِّن':Added, #1: 1	تَعَارَضَ بَيْنَ
u'تَعَارُضٌ بَيِّن':Added, #1: 1	تَعَارُضَ الْبَيِّنَتَيْنِ
u'تَعَارُضٌ بَيِّنَةٌ':Added, #26: 26	تَعَارُضِ الْبَيِّنَتَيْنِ
u'تَعَارَضَ تَأْكِيدٌ':Subject, #4: 4	تَعَارُضِ الْبَيِّنَاتِ
u'تَعَارُضٌ تَخْصِيصٌ':Added, #1: 1	تَعَارَضَ التَّأْكِيدُ
u'تَعَارَضَ تَصْدِيقٌ':Subject, #1: 1	تَعَارُضِ التَّخْصِيصِ
u'تَعَارُضٌ تَعْلِيقٌ':Added, #2: 2	تَعَارَضَ التَّصْدِيقُ
u'تَعَارَضَ تَكَلُّفٌ':Subject, #1: 1	تَعَارُضُ التَّعْلِيقَيْنِ
u'تَعَارَضَ حَديثٌ':Subject, #1: 1	تَعَارَضَ التَّكَلُّفُ
u'تَعَارَضَ حَديثٌ':Subject, #1: 1	تَعَارَضَ الْحَدِيثُ
u'تَعَارُضٌ حَديثٌ':Added, #1: 1	تَعَارَضَ حَدِيثُ
u'تَعَارَضَ حَقِيقٌ':Subject, #1: 1	تَعَارُض حَدِيثِ
u'تَعَارُضٌ حَقِيقٌ':Added, #1: 1	تَعَارَضَ الْحَقِيقَةُ
u'تَعَارَضَ حَقِيقَةٌ':Subject, #2: 2	تَعَارُضِ الْحَقِيقَةِ
u'تَعَارُضٌ حَقِيقَةٌ':Added, #1: 1	تَعَارَضَ الْحَقِيقَةُ
u'تَعَارَضَ حُكْمٌ':Subject, #2: 2	تَعَارُضِ الْحَقِيقَةِ
u'تَعَارَضَ خاصّ':Subject, #2: 2	تَعَارَضَ حُكْمٌ
u'تَعَارَضَ خَبَرٌ':Subject, #1: 1	تَعَارَضَ الْخَاصُّ
u'تَعَارَضَ خَبَر':Subject, #1: 1	تَعَارَضَ خَبَرُ
u'تَعَارُضٌ خَبَرٌ':Added, #1: 1	تَعَارَضَ خَبَرُ
u'تَعَارُضٌ خَبَر':Added, #1: 1	تَعَارُضِ الْخَبَرِ
u'تَعَارُضٌ خَبَرٌ':Added, #1: 1	تَعَارُضِ الْخَبَرِ
u'تَعَارُضٌ خَبَر':Added, #1: 1	تَعَارُضَ الْخَبَرَيْنِ
u'تَعَارُضٌ خَبَرٌ':Added, #1: 1	تَعَارُضَ الْخَبَرَيْنِ
u'تَعَارُضٌ خَبَر':Added, #1: 1	تَعَارُضِ خَبَرِ
u'تَعَارُضٌ خَبَرٌ':Added, #1: 1	تَعَارُضِ خَبَرِ
u'تَعَارُضٌ خَبَر':Added, #1: 1	تَعَارُضِ خَبَرَيْنِ
u'تَعَارُضٌ خَبَرٌ':Added, #1: 1	تَعَارُضِ خَبَرَيْنِ
u'تَعَارُضٌ خَبَر':Added, #2: 2	تَعَارُضُ الْخَبَرَيْنِ
u'تَعَارُضٌ خَبَرٌ':Added, #2: 2	تَعَارُضُ الْخَبَرَيْنِ
u'تَعَارُضٌ خَبَر':Added, #4: 4	تَعَارُضِ الْخَبَرَيْنِ
u'تَعَارَضَ خَوْفٌ':Subject, #4: 4	تَعَارُضِ الْخَبَرَيْنِ
u'تَعَارَضَ دَلالَةٌ':Subject, #1: 1	تَعَارَضَ خَوْفُ
u'تَعَارُضٌ دَلالَةٌ':Added, #1: 1	تَعَارَضَ دَلَالَةُ
u'تَعَارُضٌ دَلائِلُ':Added, #1: 1	تَعَارُضِ الدَّلَالَةِ
u'تَعَارَضَ دَليلٌ':Subject, #1: 1	تَعَارُضِ الدَّلَائِلِ
u'تَعَارُضٌ دَليلٌ':Added, #1: 1	تَعَارَضَ الدَّلِيلُ
u'تَعَارُضٌ دَليلٌ':Added, #1: 1	تَعَارُضَ الدَّلِيلَيْنِ
u'تَعَارُضٌ دَليلٌ':Added, #1: 1	تَعَارُضُ الدَّلِيلَيْنِ
u'تَعَارُضٌ دَليلٌ':Added, #1: 1	تَعَارُضِ الدَّلِيلَيْنِ
u'تَعَارُضٌ دَليلٌ':Added, #2: 2	تَعَارُضُ دَلِيلِ
u'تَعَارُضٌ رَافِعٌ':Added, #2: 2	تَعَارُضِ دَلِيلِ
u'تَعَارَضَ رَأْيٌ':Subject, #1: 1	تَعَارُضِ الرَّافِعِ
u'تَعَارُضٌ رَفْعٌ':Added, #1: 1	تَعَارَضَ رَأْيُهُ
u'تَعَارَضَ رِوايَةٌ':Subject, #1: 1	تَعَارُضُ الرَّفْعِ
u'تَعَارَضَ سترة':Subject, #1: 1	تَعَارَضَ رِوَايَةُ
u'تَعَارَضَ سُتْرَةٌ':Subject, #1: 1	تَعَارَضَ السُّتْرَةُ
u'تَعَارُضٌ سُنَّةٌ':Added, #1: 1	تَعَارَضَ السُّتْرَةُ
u'تَعَارُضٌ سنن':Added, #2: 2	تَعَارُضُ السُّنَّةِ
u'تَعَارُضٌ شَبَهٌ':Added, #1: 1	تَعَارُضِ السُّنَنِ
u'تَعَارَضَ شِرَاءٌ':Subject, #1: 1	تَعَارُضَ الشَّبَهِ
u'تَعَارُضٌ شَرْطٌ':Added, #1: 1	تَعَارَضَ شِرَاءُ
u'تَعَارَضَ صِدِّيقٌ':Subject, #1: 1	تَعَارُضَ الشَّرْطِ
u'تَعَارَضَ صَلاَةٌ':Subject, #1: 1	تَعَارَضَ الصِّدِّيقُ
u'تَعَارُضٌ ظاهِرٌ':Added, #1: 1	تَعَارَضَ صَلَاةُ
u'تَعَارُضٌ ظاهِرٌ':Added, #1: 1	تَعَارُضِ الظَّاهِرِ
u'تَعَارُضٌ ظَنٌّ':Added, #1: 1	تَعَارُضُ الظَّاهِرَيْنِ
u'تَعَارَضَ عَامٌّ':Subject, #1: 1	تَعَارُضُ ظَنَّيْنِ
u'تَعَارُضٌ عَامٌّ':Added, #1: 1	تَعَارَضَ عَامٌّ
u'تَعَارُضٌ عَامٌّ':Added, #1: 1	تَعَارُضَ الْعَامِّ
u'تَعَارُضٌ عتق':Added, #1: 1	تَعَارُضِ عَامَّيْنِ
u'تَعَارُضٌ عِتْقٌ':Added, #1: 1	تَعَارُضُ عِتْقِ
u'تَعَارَضَ عرف':Subject, #1: 1	تَعَارُضُ عِتْقِ
u'تَعَارَضَ عُرْفٌ':Subject, #1: 1	تَعَارَضَ الْعُرْفُ
u'تَعَارُضٌ عرف':Added, #1: 1	تَعَارَضَ الْعُرْفُ
u'تَعَارُضٌ عُرْفٌ':Added, #1: 1	تَعَارُضُ الْعُرْفِ
u'تَعَارُضٌ عرف':Added, #1: 1	تَعَارُضُ الْعُرْفِ
u'تَعَارُضٌ عُرْفٌ':Added, #3: 3	تَعَارُضِ الْعُرْفِ
u'تَعَارُضٌ عِلَّةٌ':Added, #3: 3	تَعَارُضِ الْعُرْفِ
u'تَعَارُضٌ عِلَّةٌ':Added, #1: 1	تَعَارُضَ الْعِلَّةِ
u'تَعَارَضَ عند':Predicate, #1: 1	تَعَارُضِ الْعِلَّةِ
u'تَعَارَضَ غُسْلٌ':Subject, #1: 1	تَعَارَضَ عِنْدَ
u'تَعَارَضَ فَضِيلٌ':Subject, #1: 1	تَعَارَضَ الْغُسْلُ
u'تَعَارَضَ فَضِيلَةٌ':Subject, #1: 1	تَعَارَضَ فَضِيلَةُ
u'تَعَارُضٌ فِعْلٌ':Added, #1: 1	تَعَارَضَ فَضِيلَةُ
u'تَعَارُضٌ فِعْلٌ':Added, #1: 1	تَعَارُضُ الْفِعْلَيْنِ
u'تَعَارُضٌ فَوَائِدُ':Added, #4: 4	تَعَارُضِ الْفِعْلَيْنِ
u'تَعَارُضٌ قِرَاءةٌ':Added, #1: 1	تَعَارُضُ الْفَوَائِدِ
u'تَعَارَضَ قُرْبٌ':Subject, #1: 1	تَعَارُضِ قِرَاءَةِ
u'تَعَارَضَ قَصْرٌ':Subject, #1: 1	تَعَارَضَ الْقُرْبُ
u'تَعَارُضٌ قَطْعِيّ':Added, #1: 1	تَعَارَضَ الْقَصْرُ
u'تَعَارُضٌ قَطْعِيّ':Added, #1: 1	تَعَارُضَ الْقَطْعِيَّيْنِ
u'تَعَارَضَ قول':Subject, #2: 2	تَعَارُضُ الْقَطْعِيَّيْنِ
u'تَعَارَضَ قَوْلٌ':Subject, #1: 1	تَعَارَضَ الْقَوْلُ
u'تَعَارَضَ قول':Subject, #1: 1	تَعَارَضَ الْقَوْلُ
u'تَعَارَضَ قَوْلٌ':Subject, #1: 1	تَعَارَضَ قَوْلُ
u'تَعَارَضَ قَوْلٌ':Subject, #1: 1	تَعَارَضَ قَوْلٌ
u'تَعَارُضٌ قول':Added, #1: 1	تَعَارَضَ قَوْلُ
u'تَعَارُضٌ قَوْلٌ':Added, #1: 1	تَعَارُضِ الْقَوْلِ
u'تَعَارُضٌ قَوْلٌ':Added, #1: 1	تَعَارُضِ الْقَوْلِ
u'تَعَارُضٌ قَوْلٌ':Added, #1: 1	تَعَارُضُ الْقَوْلَيْنِ
u'تَعَارُضٌ قِيَاسٌ':Added, #1: 1	تَعَارُضِ الْقَوْلَيْنِ
u'تَعَارُضٌ قِيَاسٌ':Added, #1: 1	تَعَارُضُ الْقِيَاسِ
u'تَعَارُضٌ قِيَاسٌ':Added, #1: 1	تَعَارُضِ الْقِيَاسَيْنِ
u'تَعَارَضَ كَلاَمٌ':Subject, #3: 3	تَعَارُضِ الْقِيَاسِ
u'تَعَارَضَ كَلاَمٌ':Subject, #1: 1	تَعَارَضَ كَلَامُ
u'تَعَارُضٌ لَفْظٌ':Added, #2: 2	تَعَارَضَ كَلَامُهُ
u'تَعَارَضَ مَانِعٌ':Subject, #1: 1	تَعَارُضُ اللَّفْظِ
u'تَعَارُضٌ مُتَوَاتِرٌ':Added, #2: 2	تَعَارَضَ الْمَانِعُ
u'تَعَارُضٌ مَجَازٌ':Added, #1: 1	تَعَارُضِ مُتَوَاتِرَيْنِ
u'تَعَارَضَ مُحَرَّمٌ':Subject, #3: 3	تَعَارُضِ الْمَجَازِ
u'تَعَارَضَ مَدْلُولٌ':Subject, #1: 1	تَعَارَضَ الْمُحَرَّمُ
u'تَعَارَضَ مَدْلُولٌ':Subject, #1: 1	تَعَارَضَ الْمَدْلُولُ
u'تَعَارُضٌ مَصَالِحُ':Added, #1: 1	تَعَارَضَ مَدْلُولُ
u'تَعَارُضٌ مَصْلَحَةٌ':Added, #1: 1	تَعَارُضِ الْمَصَالِحِ
u'تَعَارَضَ مَفْسَدَةٌ':Subject, #1: 1	تَعَارُضُ مَصْلَحَةٍ
u'تَعَارُضٌ مُفَسَّرٌ':Added, #1: 1	تَعَارَضَ مَفْسَدَةٌ
u'تَعَارَضَ مَنِيٌّ':Subject, #1: 1	تَعَارُضِ الْمُفَسَّرِ
u'تَعَارَضَ نَحْوٌ':Subject, #1: 1	تَعَارَضَ الْمَنِيُّ
u'تَعَارُضٌ نَصٌّ':Added, #1: 1	تَعَارَضَ نَحْوُ
u'تَعَارُضٌ نَصٌّ':Added, #1: 1	تَعَارُضَ النَّصَّيْنِ
u'تَعَارُضٌ نَصٌّ':Added, #1: 1	تَعَارُضُ النَّصَّيْنِ
u'تَعَارُضٌ نَفْيٌ':Added, #8: 8	تَعَارُضِ النَّصَّيْنِ
u'تَعَارَضَ نقل':Subject, #1: 1	تَعَارُضِ النَّفْيِ
u'تَعَارَضَ نَقْلٌ':Subject, #1: 1	تَعَارَضَ النَّقْلُ
u'تَعَارُضٌ نقل':Added, #1: 1	تَعَارَضَ النَّقْلُ
u'تَعَارُضٌ نَقْلٌ':Added, #1: 1	تَعَارُضِ النَّقْلِ
u'تَعَارُضٌ وَضْعٌ':Added, #1: 1	تَعَارُضِ النَّقْلِ
u'تَعَارَضَ وَقْفٌ':Subject, #1: 1	تَعَارُضِ الْوَضْعِ
u'تَعَارَفَ أهْلٌ':Subject, #1: 1	تَعَارَضَ الْوَقْفُ
u'تَعَارُفٌ أهْلٌ':Added, #5: 5	تَعَارَفَ أَهْلُ
u'تَعَارُفٌ أهْلٌ':Added, #1: 1	تَعَارُفُ أَهْلِ
u'تَعَارُفٌ تَرْكِيبٌ':Added, #2: 2	تَعَارُفِ أَهْلِ
u'تَعَارَفَ فقهاء':Subject, #1: 1	تَعَارُفِ تَرْكِيبِ
u'تَعَارَفَ نَاسٌ':Predicate, #1: 1	تَعَارَفَ الْفُقَهَاءُ
u'تَعَارَفَ نَاسٌ':Subject, #1: 1	تَعَارَفَ النَّاسَ
u'تَعَاضَدَ قُرْآنٌ':Subject, #10: 10	تَعَارَفَ النَّاسُ
u'تَعَاطُفٌ أَرْحَامٌ':Added, #1: 1	تَعَاضَدَ الْقُرْآنُ
u'تَعَاطُفٌ مُفْرَدٌ':Added, #1: 1	تَعَاطُفَ الْأَرْحَامِ
u'تَعَاطِي إِخْبَارٌ':Added, #1: 1	تَعَاطُفُ الْمُفْرَدَاتِ
u'تَعَاطِي أَفْعَالٌ':Added, #1: 1	تَعَاطِي الْإِخْبَارِ
u'تَعَاطِي سَائِرٌ':Added, #1: 1	تَعَاطِي الْأَفْعَالِ
u'تَعَاطِي سَبَبٌ':Added, #1: 1	تَعَاطِي سَائِرِ
u'تَعَاطِي شُبْهَةٌ':Added, #1: 1	تَعَاطِي سَبَبِ
u'تَعَاطِي صَحِيحٌ':Added, #1: 1	تَعَاطِي الشُّبْهَةِ
u'تَعَاطِي صغائر':Added, #1: 1	تَعَاطِي الصَّحِيحِ
u'تَعَاطِي صَغَائِرُ':Added, #1: 1	تَعَاطِي الصَّغَائِرِ
u'تَعَاطِي صُورٌ':Added, #1: 1	تَعَاطِي الصَّغَائِرِ
u'تَعَاطِي صُوَرٌ':Added, #1: 1	تَعَاطِي صُوَرِ
u'تَعَاطِي صَوْمٌ':Added, #1: 1	تَعَاطِي صُوَرِ
u'تَعَاطِي طَيِّبٌ':Added, #1: 1	تَعَاطِي صَوْمٍ
u'تَعَاطِي عِبَادَةٌ':Added, #1: 1	تَعَاطِي الطَّيِّبَاتِ
u'تَعَاطِي عَقْدٌ':Added, #2: 2	تَعَاطِي الْعِبَادَةِ
u'تَعَاطِي عُقُودٌ':Added, #1: 1	تَعَاطِي الْعَقْدِ
u'تَعَاطِي عُقُودٌ':Added, #1: 1	تَعَاطِيَ الْعُقُودِ
u'تَعَاطِي فِسْقٌ':Added, #2: 2	تَعَاطِي الْعُقُودِ
u'تَعَاطَى فِعْلٌ':Predicate, #1: 1	تَعَاطِي الْفِسْقِ
u'تَعَاطِي فِعْلٌ':Added, #1: 1	تَعَاطَى فِعْلَ
u'تَعَاطِي قُرْبَةٌ':Added, #1: 1	تَعَاطِي فِعْلٍ
u'تَعَاطَى قَوَد':Predicate, #1: 1	تَعَاطِي الْقُرْبَةِ
u'تَعَاطَى كَلاَمٌ':Predicate, #1: 1	تَعَاطَى الْقَوَدَ
u'تَعَاطِي لَذَّةٌ':Added, #2: 2	تَعَاطَى الْكَلَامَ
u'تَعَاطِي مُبَاحٌ':Added, #1: 1	تَعَاطِيَ اللَّذَّةِ
u'تَعَاطِي مُبَاحٌ':Added, #1: 1	تَعَاطِي الْمُبَاحَاتِ
u'تَعَاطِي مُحَرَّمٌ':Added, #1: 1	تَعَاطِي مُبَاحَاتٍ
u'تَعَاطَى مُسْلِمٌ':Subject, #1: 1	تَعَاطِي مُحَرَّمِ
u'تَعَاطِي مُصَاوَلَةٌ':Added, #1: 1	تَعَاطَى مُسْلِمٌ
u'تَعَاطِي مُفْطِر':Added, #1: 1	تَعَاطِي الْمُصَاوَلَةِ
u'تَعَاطِي نَجَاسَةٌ':Added, #3: 3	تَعَاطِي الْمُفْطِرِ
u'تَعَاظَمَ فَضْلٌ':Subject, #1: 1	تَعَاطِي النَّجَاسَاتِ
u'تَعَاظُمٌ مَمْدوحٌ':Added, #1: 1	تَعَاظَمَ فَضْلُهُ
u'تَعَاظُمٌ نَفْسٌ':Added, #1: 1	تَعَاظُمِ الْمَمْدُوحِ
u'تَعَافَى بَطَلٌ':Predicate, #1: 1	تَعَاظُمِ نَفْسِهِ
u'تَعَاقُبٌ أَزْمانٌ':Added, #1: 1	تَعَافَى بَطَلَ
u'تَعَاقُبٌ إِسْلامٌ':Added, #1: 1	تَعَاقُبِ الْأَزْمَانِ
u'تَعَاقُبٌ أَوْقَاتٌ':Added, #1: 1	تَعَاقُبِ الْإِسْلَامِ
u'تَعَاقُبٌ أيَّامٌ':Added, #1: 1	تَعَاقُبِ الْأَوْقَاتِ
u'تَعَاقُبٌ أَيَّامٌ':Added, #1: 1	تَعَاقُبَ الْأَيَّامِ
u'تَعَاقُبٌ بَيِّن':Added, #1: 1	تَعَاقُبَ الْأَيَّامِ
u'تَعَاقُبٌ دِماءٌ':Added, #1: 1	تَعَاقُبِ الْبَيِّنَتَيْنِ
u'تَعَاقَدَ بَيْعٌ':Subject, #2: 2	تَعَاقُبِ الدِّمَاءِ
u'تَعَالَى أَبٌ':Subject, #1: 1	تَعَاقَدَ الْبَيْعُ
u'تَعَالَى اِبْتِداءٌ':Predicate, #3: 3	تَعَالَى الْأَبُ
u'تَعَالَى أَبْوَابٌ':Predicate, #1: 1	تَعَالَى ابْتِدَاءَ
u'تَعَالَى اِتِّبَاعٌ':Predicate, #1: 1	تَعَالَى أَبْوَابَ
u'تَعَالَى اِتِّفَاقٌ':Subject, #1: 1	تَعَالَى اتِّبَاعَ
u'تَعَالَى إتْمَامٌ':Predicate, #1: 1	تَعَالَى اتِّفَاقٌ
u'تَعَالَى آثَارٌ':Predicate, #1: 1	تَعَالَى إتْمَامَ
u'تَعَالَى إجَارَةٌ':Subject, #1: 1	تَعَالَى آثَارَ
u'تَعَالَى إجَارَةٌ':Subject, #1: 1	تَعَالَى إجَارَةُ
u'تَعَالَى إجَازَةٌ':Subject, #1: 1	تَعَالَى الْإِجَارَةُ
u'تَعَالَى أَجْرٌ':Subject, #1: 1	تَعَالَى الْإِجَازَةُ
u'تَعَالَى أَجْرٌ':Subject, #1: 1	تَعَالَى الْأَجْرُ
u'تَعَالَى أُجْرَةٌ':Subject, #3: 3	تَعَالَى أَجْرُ
u'تَعَالَى أَجَلٌ':Predicate, #1: 1	تَعَالَى الْأُجْرَةُ
u'تَعَالَى أَجَلٌ':Subject, #1: 1	تَعَالَى الْأَجَلَ
u'تَعَالَى أجْمَع':Predicate, #1: 1	تَعَالَى الْأَجَلُ
u'تَعَالَى أَجِيرٌ':Subject, #1: 1	تَعَالَى أَجْمَعَ
u'تَعَالَى اِحْتِيَاجٌ':Subject, #1: 1	تَعَالَى الْأَجِيرُ
u'تَعَالَى اِحْتِيَاطٌ':Subject, #1: 1	تَعَالَى احْتِيَاجُ
u'تَعَالَى أحَدٌ':Predicate, #1: 1	تَعَالَى احْتِيَاطٌ
u'تَعَالَى أحَدٌ':Subject, #2: 2	تَعَالَى أَحَدَ
u'تَعَالَى إِحْرَامٌ':Subject, #1: 1	تَعَالَى أَحَدُ
u'تَعَالَى إحْسَانٌ':Predicate, #1: 1	تَعَالَى إحْرَامُ
u'تَعَالَى أَحْسَنُ':Subject, #1: 1	تَعَالَى الْإِحْسَانَ
u'تَعَالَى أَحَقُّ':Subject, #2: 2	تَعَالَى أَحْسَنُ
u'تَعَالَى أَحْكَامٌ':Predicate, #3: 3	تَعَالَى أَحَقُّ
u'تَعَالَى إِخْبَارٌ':Predicate, #2: 2	تَعَالَى أَحْكَامَ
u'تَعَالَى أُخْتٌ':Subject, #2: 2	تَعَالَى الْإِخْبَارَ
u'تَعَالَى أخْذٌ':Predicate, #1: 1	تَعَالَى الْأُخْتُ
u'تَعَالَى آخِرُ':Subject, #1: 1	تَعَالَى الْأَخْذَ
u'تَعَالَى آخِرُ':Subject, #1: 1	تَعَالَى آخِرُ
u'تَعَالَى إِخْرَاجٌ':Subject, #4: 4	تَعَالَى الْآخِرُ
u'تَعَالَى إِدْرَاكٌ':Predicate, #1: 1	تَعَالَى إخْرَاجُ
u'تَعَالَى آدَمُ':Predicate, #1: 1	تَعَالَى الْإِدْرَاكَ
u'تَعَالَى أَرْبَعُ':Subject, #4: 4	تَعَالَى آدَمَ
u'تَعَالَى أَرْبَعَةٌ':Subject, #1: 1	تَعَالَى أَرْبَعُ
u'تَعَالَى اِرْتِكَابٌ':Predicate, #1: 1	تَعَالَى أَرْبَعَةُ
u'تَعَالَى أرْضٌ':Predicate, #1: 1	تَعَالَى ارْتِكَابَ
u'تَعَالَى أرْضٌ':Subject, #3: 3	تَعَالَى الْأَرْضَ
u'تَعَالَى أرْضٌ':Subject, #1: 1	تَعَالَى أَرْضٌ
u'تَعَالَى أرْضٌ':Subject, #1: 1	تَعَالَى أَرْضُ
u'تَعَالَى أَزَلِيٌّ':Subject, #1: 1	تَعَالَى الْأَرْضُ
u'تَعَالَى اِسْتِثْنَاءٌ':Subject, #1: 1	تَعَالَى أَزَلِيٌّ
u'تَعَالَى اِسْتِحْسَانٌ':Subject, #1: 1	تَعَالَى اسْتِثْنَاءُ
u'تَعَالَى اِسْمٌ':Subject, #1: 1	تَعَالَى اسْتِحْسَانٌ
u'تَعَالَى أَسْماءٌ':Predicate, #1: 1	تَعَالَى اسْمُهُ
u'تَعَالَى إشارَة':Subject, #1: 1	تَعَالَى الْأَسْمَاءَ
u'تَعَالَى أَشَدُّ':Subject, #2: 2	تَعَالَى إشَارَةٌ
u'تَعَالَى أشْهَرُ':Subject, #2: 2	تَعَالَى أَشَدُّ
u'تَعَالَى أَشْيَاءٌ':Predicate, #1: 1	تَعَالَى أَشْهَرُ
u'تَعَالَى أصل':Predicate, #2: 2	تَعَالَى أَشْيَاءَ
u'تَعَالَى أًصْلٌ':Predicate, #1: 1	تَعَالَى أَصْلَ
u'تَعَالَى أصل':Subject, #1: 1	تَعَالَى أَصْلَ
u'تَعَالَى أًصْلٌ':Subject, #1: 1	تَعَالَى أَصْلُ
u'تَعَالَى أصل':Subject, #1: 1	تَعَالَى أَصْلُ
u'تَعَالَى أًصْلٌ':Subject, #1: 1	تَعَالَى أَصْلُهُ
u'تَعَالَى أصل':Subject, #1: 1	تَعَالَى أَصْلُهُ
u'تَعَالَى أًصْلٌ':Subject, #3: 3	تَعَالَى الْأَصْلُ
u'تَعَالَى إضافَةٌ':Subject, #3: 3	تَعَالَى الْأَصْلُ
u'تَعَالَى إِظْهارٌ':Subject, #1: 1	تَعَالَى الْإِضَافَةُ
u'تَعَالَى أظهر':Predicate, #2: 2	تَعَالَى إظْهَارُ
u'تَعَالَى أظهر':Subject, #1: 1	تَعَالَى أَظْهَرَ
u'تَعَالَى اِعْتِبارٌ':Predicate, #2: 2	تَعَالَى أَظْهَرُ
u'تَعَالَى اِعْتِبارٌ':Subject, #1: 1	تَعَالَى اعْتِبَارَ
u'تَعَالَى أعَزُّ':Predicate, #1: 1	تَعَالَى اعْتِبَارُ
u'تَعَالَى أَعْضَاءٌ':Predicate, #1: 1	تَعَالَى أَعَزَّ
u'تَعَالَى أعْظَمُ':Subject, #1: 1	تَعَالَى أَعْضَاءَ
u'تَعَالَى أعْلَمُ':Predicate, #2: 2	تَعَالَى أَعْظَمُ
u'تَعَالَى أعْلَمُ':Subject, #4: 4	تَعَالَى أَعْلَمَ
u'تَعَالَى أَعَمُّ':Subject, #493: 493	تَعَالَى أَعْلَمُ
u'تَعَالَى أَغْنِيَاء':Predicate, #2: 2	تَعَالَى أَعَمُّ
u'تَعَالَى إِفْرَادٌ':Predicate, #1: 1	تَعَالَى الْأَغْنِيَاءَ
u'تَعَالَى إِفْرَادٌ':Subject, #1: 1	تَعَالَى الْإِفْرَادَ
u'تَعَالَى أفْضَلُ':Subject, #3: 3	تَعَالَى الْإِفْرَادُ
u'تَعَالَى أفْضَلُ':Subject, #1: 1	تَعَالَى أَفْضَلُ
u'تَعَالَى اِقْتِداءٌ':Subject, #4: 4	تَعَالَى الْأَفْضَلُ
u'تَعَالَى إقْرَارٌ':Subject, #1: 1	تَعَالَى اقْتِدَاءُ
u'تَعَالَى إقْرَارٌ':Subject, #2: 2	تَعَالَى إقْرَارُهُ
u'تَعَالَى أقْرَبُ':Subject, #3: 3	تَعَالَى الْإِقْرَارُ
u'تَعَالَى أقَلُّ':Subject, #2: 2	تَعَالَى أَقْرَبُ
u'تَعَالَى أقَلُّ':Subject, #1: 1	تَعَالَى أَقَلُّ
u'تَعَالَى أكْبَرُ':Subject, #1: 1	تَعَالَى أَقَلُّهُ
u'تَعَالَى أَكْثَرُ':Subject, #1: 1	تَعَالَى أَكْبَرُ
u'تَعَالَى أكْرَمُ':Predicate, #3: 3	تَعَالَى أَكْثَرُ
u'تَعَالَى أكْرَمُ':Subject, #1: 1	تَعَالَى أَكْرَمَ
u'تَعَالَى أكل':Predicate, #2: 2	تَعَالَى أَكْرَمُ
u'تَعَالَى أَكْلٌ':Predicate, #1: 1	تَعَالَى الْأَكْلَ
u'تَعَالَى أَكْمَلُ':Predicate, #1: 1	تَعَالَى الْأَكْلَ
u'تَعَالَى إلْحَادٌ':Subject, #1: 1	تَعَالَى أَكْمَلَ
u'تَعَالَى ألف':Predicate, #1: 1	تَعَالَى إلْحَادٌ
u'تَعَالَى ألْفٌ':Predicate, #1: 1	تَعَالَى أَلْفَ
u'تَعَالَى أَلْفٌ':Predicate, #1: 1	تَعَالَى أَلْفَ
u'تَعَالَى ألف':Subject, #1: 1	تَعَالَى أَلْفَ
u'تَعَالَى ألْفٌ':Subject, #1: 1	تَعَالَى أَلْفُ
u'تَعَالَى أَلْفٌ':Subject, #1: 1	تَعَالَى أَلْفُ
u'تَعَالَى ألف':Subject, #1: 1	تَعَالَى أَلْفُ
u'تَعَالَى ألْفٌ':Subject, #3: 3	تَعَالَى الْأَلْفُ
u'تَعَالَى أَلْفٌ':Subject, #3: 3	تَعَالَى الْأَلْفُ
u'تَعَالَى أُمٌّ':Predicate, #3: 3	تَعَالَى الْأَلْفُ
u'تَعَالَى أُمٌّ':Predicate, #1: 1	تَعَالَى الْأُمَّ
u'تَعَالَى أُمٌّ':Subject, #1: 1	تَعَالَى أُمَّ
u'تَعَالَى إمَامٌ':Subject, #1: 1	تَعَالَى الْأُمُّ
u'تَعَالَى أمَةٌ':Subject, #1: 1	تَعَالَى الْإِمَامُ
u'تَعَالَى أَمْرٌ':Predicate, #1: 1	تَعَالَى أَمَةٌ
u'تَعَالَى أَمْرٌ':Predicate, #2: 2	تَعَالَى الْأَمْرَ
u'تَعَالَى أَمْرٌ':Subject, #2: 2	تَعَالَى أَمْرَ
u'تَعَالَى اِمْرَأَةٌ':Subject, #2: 2	تَعَالَى الْأَمْرُ
u'تَعَالَى أَميرٌ':Subject, #3: 3	تَعَالَى امْرَأَةٌ
u'تَعَالَى اِنْتِفاء':Subject, #2: 2	تَعَالَى أَمِيرُ
u'تَعَالَى إِنْسانٌ':Predicate, #1: 1	تَعَالَى انْتِفَاءُ
u'تَعَالَى اِنْعِدَامٌ':Subject, #3: 3	تَعَالَى الْإِنْسَانَ
u'تَعَالَى أَنْوَاعٌ':Predicate, #1: 1	تَعَالَى انْعِدَامُ
u'تَعَالَى أهْلٌ':Predicate, #1: 1	تَعَالَى أَنْوَاعَ
u'تَعَالَى أهْلٌ':Subject, #3: 3	تَعَالَى أَهْلَ
u'تَعَالَى أهْوَنُ':Predicate, #3: 3	تَعَالَى أَهْلُ
u'تَعَالَى أهْوَنُ':Subject, #1: 1	تَعَالَى أَهْوَنَ
u'تَعَالَى أَوْجُهٌ':Predicate, #1: 1	تَعَالَى أَهْوَنُ
u'تَعَالَى أوْسَعُ':Subject, #1: 1	تَعَالَى الْأَوْجُهَ
u'تَعَالَى أَوَّلُ':Predicate, #1: 1	تَعَالَى أَوْسَعُ
u'تَعَالَى أَوَّلُ':Subject, #2: 2	تَعَالَى أَوَّلَ
u'تَعَالَى أَوَّلُ':Subject, #18: 18	تَعَالَى الْأَوَّلُ
u'تَعَالَى أَوْلِيَاءُ':Predicate, #1: 1	تَعَالَى أَوَّلُ
u'تَعَالَى أَوْلِيَاءُ':Subject, #1: 1	تَعَالَى أَوْلِيَاءَ
u'تَعَالَى آيَةٌ':Predicate, #1: 1	تَعَالَى أَوْلِيَاءُ
u'تَعَالَى آيَةٌ':Predicate, #2: 2	تَعَالَى آيَةَ
u'تَعَالَى آيَةٌ':Subject, #8: 8	تَعَالَى الْآيَةَ
u'تَعَالَى بَابٌ':Predicate, #1: 1	تَعَالَى الْآيَةُ
u'تَعَالَى بَابٌ':Subject, #1: 1	تَعَالَى الْبَابَ
u'تَعَالَى بَاطِلٌ':Predicate, #1: 1	تَعَالَى بَابٌ
u'تَعَالَى بَاطِلٌ':Subject, #1: 1	تَعَالَى الْبَاطِلَ
u'تَعَالَى بَاعٌ':Predicate, #4: 4	تَعَالَى بَاطِلٌ
u'تَعَالَى بِدَايَةٌ':Subject, #1: 1	تَعَالَى بَاعَ
u'تَعَالَى بدنيٌّ':Subject, #1: 1	تَعَالَى الْبِدَايَةُ
u'تَعَالَى بَرٌّ':Predicate, #1: 1	تَعَالَى الْبَدَنِيَّةُ
u'تَعَالَى بَراءةٌ':Subject, #1: 1	تَعَالَى بَرَّ
u'تَعَالَى بُرْهانٌ':Subject, #1: 1	تَعَالَى بَرَاءَةُ
u'تَعَالَى بُرْهَانٌ':Subject, #1: 1	تَعَالَى بُرْهَانُ
u'تَعَالَى بَطَلٌ':Predicate, #1: 1	تَعَالَى بُرْهَانُ
u'تَعَالَى بَعْضٌ':Subject, #5: 5	تَعَالَى بَطَلَ
u'تَعَالَى بَقاءٌ':Predicate, #1: 1	تَعَالَى بَعْضُ
u'تَعَالَى بَقِيَّةٌ':Subject, #4: 4	تَعَالَى بَقَاءَ
u'تَعَالَى بِلادٌ':Predicate, #2: 2	تَعَالَى بَقِيَّةُ
u'تَعَالَى بَيَاضٌ':Subject, #1: 1	تَعَالَى الْبِلَادَ
u'تَعَالَى بَيَانٌ':Predicate, #1: 1	تَعَالَى الْبَيَاضُ
u'تَعَالَى بَيَانٌ':Predicate, #1: 1	تَعَالَى الْبَيَانَ
u'تَعَالَى بَيَانٌ':Subject, #2: 2	تَعَالَى بَيَانَ
u'تَعَالَى بَيَانٌ':Subject, #1: 1	تَعَالَى الْبَيَانُ
u'تَعَالَى بَيَانٌ':Subject, #1: 1	تَعَالَى بَيَانٌ
u'تَعَالَى بَيَانٌ':Subject, #1: 1	تَعَالَى بَيَانُهُ
u'تَعَالَى بَيْعٌ':Subject, #2: 2	تَعَالَى بَيَانُ
u'تَعَالَى بَيْعٌ':Subject, #4: 4	تَعَالَى بَيْعُ
u'تَعَالَى بَيْعَةٌ':Predicate, #9: 9	تَعَالَى الْبَيْعُ
u'تَعَالَى بَيْنٌ':Predicate, #1: 1	تَعَالَى بَيْعَةَ
u'تَعَالَى بَيِّنَةٌ':Predicate, #23: 23	تَعَالَى بَيْنَ
u'تَعَالَى بَيِّنَةٌ':Subject, #1: 1	تَعَالَى بَيِّنَةَ
u'تَعَالَى تَأْخِيرٌ':Predicate, #5: 5	تَعَالَى الْبَيِّنَةُ
u'تَعَالَى تَأْخِيرٌ':Subject, #1: 1	تَعَالَى تَأْخِيرَ
u'تَعَالَى تَبْدِيلٌ':Predicate, #1: 1	تَعَالَى التَّأْخِيرُ
u'تَعَالَى تَحْرِيمٌ':Predicate, #1: 1	تَعَالَى تَبْدِيلَ
u'تَعَالَى تَحْرِيم':Subject, #1: 1	تَعَالَى التَّحْرِيمَ
u'تَعَالَى تَحْرِيم':Subject, #1: 1	تَعَالَى التَّحْرِيمَةُ
u'تَعَالَى تَحَلُّلٌ':Subject, #1: 1	تَعَالَى تَحْرِيمَةُ
u'تَعَالَى تَحَمُّلٌ':Subject, #1: 1	تَعَالَى تَحَلُّلُ
u'تَعَالَى تَخارَج':Predicate, #1: 1	تَعَالَى تَحَمُّلُ
u'تَعَالَى تَخْرِيجٌ':Subject, #1: 1	تَعَالَى تَخَارَجَ
u'تَعَالَى تَخْفِيفٌ':Predicate, #1: 1	تَعَالَى التَّخْرِيجُ
u'تَعَالَى تَخْيِيرٌ':Predicate, #1: 1	تَعَالَى التَّخْفِيفَ
u'تَعَالَى تَخْيِيرٌ':Subject, #1: 1	تَعَالَى تَخْيِيرَهُنَّ
u'تَعَالَى تَدَارُكٌ':Subject, #1: 1	تَعَالَى تَخْيِيرُهُ
u'تَعَالَى تَدْبِيرٌ':Subject, #1: 1	تَعَالَى تَدَارُكٌ
u'تَعَالَى تَدْبِيرٌ':Subject, #1: 1	تَعَالَى تَدْبِيرُ
u'تَعَالَى تَرْكٌ':Subject, #2: 2	تَعَالَى التَّدْبِيرُ
u'تَعَالَى تَرْكٌ':Subject, #1: 1	تَعَالَى تَرْكُهُ
u'تَعَالَى تَسْمِيَة':Subject, #2: 2	تَعَالَى تَرْكُ
u'تَعَالَى تَسْوِيَةٌ':Predicate, #1: 1	تَعَالَى التَّسْمِيَةُ
u'تَعَالَى تَسْوِيَةٌ':Subject, #3: 3	تَعَالَى التَّسْوِيَةَ
u'تَعَالَى تَصْدِيقٌ':Predicate, #1: 1	تَعَالَى التَّسْوِيَةُ
u'تَعَالَى تَصْرِيحٌ':Subject, #2: 2	تَعَالَى تَصْدِيقَ
u'تَعَالَى تَعْجِيل':Subject, #1: 1	تَعَالَى التَّصْرِيحُ
u'تَعَالَى تَعْدِيلٌ':Subject, #1: 1	تَعَالَى تَعْجِيلُ
u'تَعَالَى تَعْظِيمٌ':Subject, #1: 1	تَعَالَى التَّعْدِيلُ
u'تَعَالَى تَعْلِيمٌ':Subject, #1: 1	تَعَالَى تَعْظِيمٌ
u'تَعَالَى تَعْوِيضٌ':Subject, #1: 1	تَعَالَى تَعْلِيمُ
u'تَعَالَى تَغْلِيظٌ':Predicate, #1: 1	تَعَالَى تَعْوِيضُهُ
u'تَعَالَى تَفْسِيرٌ':Predicate, #1: 1	تَعَالَى تَغْلِيظَ
u'تَعَالَى تَفْسِيرٌ':Subject, #1: 1	تَعَالَى تَفْسِيرَ
u'تَعَالَى تَفَضُّلٌ':Predicate, #1: 1	تَعَالَى تَفْسِيرُ
u'تَعَالَى تَقْديرٌ':Predicate, #1: 1	تَعَالَى تَفَضّلَ
u'تَعَالَى تَقْديرٌ':Subject, #1: 1	تَعَالَى تَقْدِيرَ
u'تَعَالَى تَقْديمٌ':Predicate, #1: 1	تَعَالَى التَّقْدِيرُ
u'تَعَالَى تَقْديمٌ':Subject, #1: 1	تَعَالَى التَّقْدِيمَ
u'تَعَالَى تَلَذُّذٌ':Subject, #2: 2	تَعَالَى تَقْدِيمُ
u'تَعَالَى تمام':Subject, #1: 1	تَعَالَى التَّلَذُّذُ
u'تَعَالَى تَمامٌ':Subject, #1: 1	تَعَالَى تَمَامُهُ
u'تَعَالَى تمام':Subject, #1: 1	تَعَالَى تَمَامُهُ
u'تَعَالَى تَمامٌ':Subject, #3: 3	تَعَالَى تَمَامُ
u'تَعَالَى تَمَتُّعٌ':Subject, #3: 3	تَعَالَى تَمَامُ
u'تَعَالَى تَنْزِيلٌ':Subject, #1: 1	تَعَالَى التَّمَتُّعُ
u'تَعَالَى تَنْزِيهٌ':Predicate, #1: 1	تَعَالَى تَنْزِيلٌ
u'تَعَالَى تَوابِعُ':Predicate, #1: 1	تَعَالَى تَنْزِيهَ
u'تَعَالَى تَوَابِعُ':Predicate, #1: 1	تَعَالَى تَوَابِعَ
u'تَعَالَى تَوْبَةٌ':Subject, #1: 1	تَعَالَى تَوَابِعَ
u'تَعَالَى تَوَدُّدٌ':Subject, #2: 2	تَعَالَى التَّوْبَةُ
u'تَعَالَى تَوَسُّعٌ':Subject, #2: 2	تَعَالَى التَّوَدُّدُ
u'تَعَالَى تَوْفِيق':Predicate, #1: 1	تَعَالَى تَوَسُّعٌ
u'تَعَالَى تَوْفِيقٌ':Subject, #1: 1	تَعَالَى تَوْفِيقَةَ
u'تَعَالَى تَوْفِيقٌ':Subject, #1: 1	تَعَالَى تَوْفِيقٌ
u'تَعَالَى تَوْقِيت':Subject, #6: 6	تَعَالَى التَّوْفِيقُ
u'تَعَالَى تَوْقِيف':Subject, #2: 2	تَعَالَى التَّوْقِيتُ
u'تَعَالَى تَوْكِيلٌ':Subject, #2: 2	تَعَالَى تَوْقِيفِيَّةٌ
u'تَعَالَى تَيَمُّمٌ':Predicate, #2: 2	تَعَالَى التَّوْكِيلُ
u'تَعَالَى ثَابِتٌ':Subject, #1: 1	تَعَالَى التَّيَمُّمَ
u'تَعَالَى ثَالِثٌ':Subject, #1: 1	تَعَالَى ثَابِتٌ
u'تَعَالَى ثَلاثُ':Predicate, #2: 2	تَعَالَى الثَّالِثُ
u'تَعَالَى ثَلاثُ':Subject, #1: 1	تَعَالَى الثَّلَاثَ
u'تَعَالَى ثَلاثَةٌ':Predicate, #3: 3	تَعَالَى ثَلَاثُ
u'تَعَالَى ثَلاثَةٌ':Subject, #1: 1	تَعَالَى ثَلَاثَةَ
u'تَعَالَى ثَلاثَةٌ':Subject, #1: 1	تَعَالَى الثَّلَاثَةُ
u'تَعَالَى ثَمَرٌ':Predicate, #7: 7	تَعَالَى ثَلَاثَةُ
u'تَعَالَى ثَوْبٌ':Subject, #1: 1	تَعَالَى الثَّمَرَ
u'تَعَالَى ثَوْبٌ':Subject, #1: 1	تَعَالَى الثَّوْبُ
u'تَعَالَى ثَوْبٌ':Subject, #1: 1	تَعَالَى ثَوْبٌ
u'تَعَالَى جَاحِدٌ':Subject, #1: 1	تَعَالَى ثَوْبُ
u'تَعَالَى جَارِي':Subject, #1: 1	تَعَالَى جَاحِدٌ
u'تَعَالَى جَارِيَةٌ':Subject, #1: 1	تَعَالَى الْجَارِيَةُ
u'تَعَالَى جَازٌ':Predicate, #1: 1	تَعَالَى الْجَارِيَةُ
u'تَعَالَى جَائِزٌ':Subject, #9: 9	تَعَالَى جَازَ
u'تَعَالَى جَائِزٌ':Subject, #2: 2	تَعَالَى جَائِزَةٌ
u'تَعَالَى جَائِزَةٌ':Subject, #4: 4	تَعَالَى جَائِزٌ
u'تَعَالَى جِبَالٌ':Predicate, #2: 2	تَعَالَى جَائِزَةٌ
u'تَعَالَى جَبَلٌ':Predicate, #1: 1	تَعَالَى الْجِبَالَ
u'تَعَالَى جُثَّة':Predicate, #1: 1	تَعَالَى جَبَلَكَ
u'تَعَالَى جِدال':Predicate, #1: 1	تَعَالَى الْجُثَّةَ
u'تَعَالَى جَرِيب':Subject, #1: 1	تَعَالَى الْجِدَالَ
u'تَعَالَى جُزْءٌ':Subject, #1: 1	تَعَالَى الْجَرِيبُ
u'تَعَالَى جَزَاءٌ':Subject, #1: 1	تَعَالَى الْجُزْءُ
u'تَعَالَى جَزَاءٌ':Subject, #1: 1	تَعَالَى الْجَزَاءُ
u'تَعَالَى جِسْمٌ':Subject, #1: 1	تَعَالَى جَزَاءُ
u'تَعَالَى جَلٌّ':Predicate, #2: 2	تَعَالَى جِسْمٌ
u'تَعَالَى جَمَاعَةٌ':Subject, #2: 2	تَعَالَى جَلَّ
u'تَعَالَى جناح':Predicate, #1: 1	تَعَالَى الْجَمَاعَةُ
u'تَعَالَى جَنَاحٌ':Predicate, #1: 1	تَعَالَى جَنَاحَ
u'تَعَالَى جَنَّةٌ':Predicate, #1: 1	تَعَالَى جَنَاحَ
u'تَعَالَى جَنَّةٌ':Predicate, #2: 2	تَعَالَى جَنَّةَ
u'تَعَالَى جَنَّةٌ':Subject, #5: 5	تَعَالَى الْجَنَّةَ
u'تَعَالَى جَوَابٌ':Predicate, #1: 1	تَعَالَى الْجَنَّةُ
u'تَعَالَى جَوَابٌ':Subject, #1: 1	تَعَالَى جَوَابَ
u'تَعَالَى جَوَابٌ':Subject, #1: 1	تَعَالَى جَوَابُ
u'تَعَالَى جَوَازٌ':Predicate, #4: 4	تَعَالَى الْجَوَابُ
u'تَعَالَى جُوعٌ':Predicate, #3: 3	تَعَالَى جَوَازَ
u'تَعَالَى حاجٌّ':Subject, #1: 1	تَعَالَى الْجُوعَ
u'تَعَالَى حافِظٌ':Subject, #1: 1	تَعَالَى الْحَاجُّ
u'تَعَالَى حاكِمٌ':Subject, #1: 1	تَعَالَى حَافِظٌ
u'تَعَالَى حالٌ':Predicate, #1: 1	تَعَالَى الْحَاكِمُ
u'تَعَالَى حالٌ':Predicate, #1: 1	تَعَالَى الْحَالَ
u'تَعَالَى حالٌ':Subject, #2: 2	تَعَالَى حَالَ
u'تَعَالَى حَبْسٌ':Subject, #1: 1	تَعَالَى حَالُ
u'تَعَالَى حَجٌّ':Predicate, #1: 1	تَعَالَى حَبْسُ
u'تَعَالَى حَجٌّ':Subject, #1: 1	تَعَالَى الْحَجَّ
u'تَعَالَى حَدٌّ':Predicate, #1: 1	تَعَالَى الْحَجُّ
u'تَعَالَى حَدَثٌ':Predicate, #1: 1	تَعَالَى حَدَّ
u'تَعَالَى حُدوثٌ':Subject, #1: 1	تَعَالَى حَدَثَ
u'تَعَالَى حَديثٌ':Subject, #1: 1	تَعَالَى حُدُوثُ
u'تَعَالَى حَرَجٌ':Predicate, #3: 3	تَعَالَى حَدِيثُ
u'تَعَالَى حُرْمَةٌ':Subject, #2: 2	تَعَالَى الْحَرَجَ
u'تَعَالَى حُروفٌ':Predicate, #1: 1	تَعَالَى حُرْمَةُ
u'تَعَالَى حَسَبٌ':Predicate, #1: 1	تَعَالَى الْحُرُوفَ
u'تَعَالَى حُسْنٌ':Predicate, #2: 2	تَعَالَى حَسَبَ
u'تَعَالَى حَسَنٌ':Subject, #2: 2	تَعَالَى حُسْنَ
u'تَعَالَى حَقٌّ':Predicate, #1: 1	تَعَالَى حَسَنٌ
u'تَعَالَى حُقٌّ':Predicate, #1: 1	تَعَالَى حَقَّ
u'تَعَالَى حَقٌّ':Subject, #1: 1	تَعَالَى حُقَّ
u'تَعَالَى حِكَايَةٌ':Subject, #2: 2	تَعَالَى حَقُّ
u'تَعَالَى حِكَايَةٌ':Subject, #1: 1	تَعَالَى حِكَايَةُ
u'تَعَالَى حُكْمٌ':Predicate, #3: 3	تَعَالَى حِكَايَةٌ
u'تَعَالَى حُكْمٌ':Predicate, #2: 2	تَعَالَى الْحُكْمَ
u'تَعَالَى حَكَمٌ':Predicate, #3: 3	تَعَالَى حُكْمَ
u'تَعَالَى حُكْمٌ':Subject, #6: 6	تَعَالَى حَكَمَ
u'تَعَالَى حُكْمٌ':Subject, #1: 1	تَعَالَى حُكْمُهُ
u'تَعَالَى حُكْمٌ':Subject, #2: 2	تَعَالَى حُكْمٌ
u'تَعَالَى حكمة':Predicate, #2: 2	تَعَالَى حُكْمُ
u'تَعَالَى حِكْمَةٌ':Predicate, #1: 1	تَعَالَى الْحِكْمَةَ
u'تَعَالَى حَلْقٌ':Subject, #1: 1	تَعَالَى الْحِكْمَةَ
u'تَعَالَى حَمَّالٌ':Subject, #3: 3	تَعَالَى الْحَلْقُ
u'تَعَالَى حَمْدٌ':Subject, #1: 1	تَعَالَى الْحَمَّالُ
u'تَعَالَى حُمْرَةٌ':Subject, #10: 10	تَعَالَى الْحَمْدُ
u'تَعَالَى حَمَلٌ':Predicate, #1: 1	تَعَالَى الْحُمْرَةُ
u'تَعَالَى حِمْلٌ':Subject, #1: 1	تَعَالَى حَمَلَ
u'تَعَالَى حول':Subject, #1: 1	تَعَالَى حِمْلُ
u'تَعَالَى حَوْلٌ':Subject, #1: 1	تَعَالَى حَوْلٌ
u'تَعَالَى حَيٌّ':Predicate, #1: 1	تَعَالَى حَوْلٌ
u'تَعَالَى حِيلَةٌ':Subject, #1: 1	تَعَالَى الْحَيَّ
u'تَعَالَى حَيِيٌّ':Subject, #5: 5	تَعَالَى الْحِيلَةُ
u'تَعَالَى خَارِقٌ':Subject, #2: 2	تَعَالَى حَيِيٌّ
u'تَعَالَى خَالِصٌ':Predicate, #1: 1	تَعَالَى خَارِقٌ
u'تَعَالَى خَالِصٌ':Subject, #1: 1	تَعَالَى خَالِصَةً
u'تَعَالَى خَالِقٌ':Predicate, #1: 1	تَعَالَى خَالِصَةٌ
u'تَعَالَى خَالِقٌ':Subject, #1: 1	تَعَالَى خَالِقَ
u'تَعَالَى خَالِقٌ':Subject, #1: 1	تَعَالَى خَالِقٌ
u'تَعَالَى خَالِقٌ':Subject, #1: 1	تَعَالَى خَالِقُهُ
u'تَعَالَى خَبَرٌ':Subject, #3: 3	تَعَالَى خَالِقُ
u'تَعَالَى خَبَر':Subject, #1: 1	تَعَالَى خَبَرٌ
u'تَعَالَى خَبِير':Subject, #1: 1	تَعَالَى خَبَرٌ
u'تَعَالَى خراج':Subject, #1: 1	تَعَالَى الْخَبِيرُ
u'تَعَالَى خَرَاجٌ':Subject, #1: 1	تَعَالَى الْخَرَاجُ
u'تَعَالَى خِطَابٌ':Predicate, #1: 1	تَعَالَى الْخَرَاجُ
u'تَعَالَى خِلاَفٌ':Predicate, #1: 1	تَعَالَى الْخِطَابَ
u'تَعَالَى خِلاَفٌ':Predicate, #1: 1	تَعَالَى الْخِلَافَ
u'تَعَالَى خِلاَفٌ':Subject, #1: 1	تَعَالَى خِلَافَ
u'تَعَالَى خلق':Predicate, #1: 1	تَعَالَى خِلَافُ
u'تَعَالَى خلق':Predicate, #17: 17	تَعَالَى خَلَقَ
u'تَعَالَى خَلْقٌ':Predicate, #1: 1	تَعَالَى الْخَلْقَ
u'تَعَالَى خَلْقٌ':Subject, #1: 1	تَعَالَى الْخَلْقَ
u'تَعَالَى خَمْرٌ':Predicate, #1: 1	تَعَالَى خَلْقٌ
u'تَعَالَى خُمُسٌ':Predicate, #1: 1	تَعَالَى الْخَمْرَ
u'تَعَالَى خَمْسَةٌ':Subject, #1: 1	تَعَالَى الْخُمُسَ
u'تَعَالَى خَمْسَةٌ':Subject, #1: 1	تَعَالَى خَمْسَةٌ
u'تَعَالَى خَوْفٌ':Predicate, #2: 2	تَعَالَى خَمْسَةُ
u'تَعَالَى خيار':Subject, #1: 1	تَعَالَى الْخَوْفَ
u'تَعَالَى خِيَارٌ':Subject, #1: 1	تَعَالَى خِيَارُ
u'تَعَالَى خِيَارٌ':Subject, #1: 1	تَعَالَى خِيَارُ
u'تَعَالَى خيار':Subject, #1: 1	تَعَالَى خِيَارَاتٌ
u'تَعَالَى خِيَارٌ':Subject, #3: 3	تَعَالَى الْخِيَارُ
u'تَعَالَى خَيْرٌ':Subject, #3: 3	تَعَالَى الْخِيَارُ
u'تَعَالَى خَيْلٌ':Subject, #1: 1	تَعَالَى خَيْرٌ
u'تَعَالَى دَاخِلٌ':Subject, #1: 1	تَعَالَى الْخَيْلُ
u'تَعَالَى دَارٌ':Predicate, #1: 1	تَعَالَى الدَّاخِلُ
u'تَعَالَى دَارٌ':Subject, #1: 1	تَعَالَى الدَّارَ
u'تَعَالَى دَارٌ':Subject, #1: 1	تَعَالَى الدَّارُ
u'تَعَالَى دَخَلٌ':Predicate, #3: 3	تَعَالَى دَارٌ
u'تَعَالَى دُخُولٌ':Predicate, #3: 3	تَعَالَى دَخَلَ
u'تَعَالَى دُخُولٌ':Predicate, #1: 1	تَعَالَى الدُّخُولَ
u'تَعَالَى دَرٌّ':Subject, #1: 1	تَعَالَى دُخُولَ
u'تَعَالَى دِرْهَمٌ':Subject, #1: 1	تَعَالَى دَرُّ
u'تَعَالَى دِرْهَم':Subject, #1: 1	تَعَالَى دِرْهَمٌ
u'تَعَالَى دَعْوَةٌ':Subject, #1: 1	تَعَالَى دِرْهَمٌ
u'تَعَالَى دفع':Predicate, #1: 1	تَعَالَى دَعْوَتُهُ
u'تَعَالَى دَلٌّ':Predicate, #2: 2	تَعَالَى دَفَعَ
u'تَعَالَى دَليلٌ':Subject, #1: 1	تَعَالَى دَلَّ
u'تَعَالَى دونٌ':Predicate, #1: 1	تَعَالَى دَلِيلُهُ
u'تَعَالَى دِيَةٌ':Predicate, #13: 13	تَعَالَى دُونَ
u'تَعَالَى دِيَةٌ':Subject, #2: 2	تَعَالَى الدِّيَةَ
u'تَعَالَى دِينٌ':Predicate, #1: 1	تَعَالَى الدِّيَةُ
u'تَعَالَى دِينٌ':Predicate, #1: 1	تَعَالَى الدِّينَ
u'تَعَالَى دَيْنٌ':Subject, #1: 1	تَعَالَى دِينَ
u'تَعَالَى دِينارٌ':Subject, #2: 2	تَعَالَى الدَّيْنُ
u'تَعَالَى ذَكاةٌ':Subject, #1: 1	تَعَالَى الدِّينَارُ
u'تَعَالَى ذكر':Predicate, #1: 1	تَعَالَى الذَّكَاةُ
u'تَعَالَى ذَكَرٌ':Predicate, #1: 1	تَعَالَى الذَّكَرَ
u'تَعَالَى ذكر':Predicate, #1: 1	تَعَالَى الذَّكَرَ
u'تَعَالَى ذكر':Predicate, #1: 1	تَعَالَى ذُكِرَ
u'تَعَالَى ذَكَرٌ':Predicate, #54: 54	تَعَالَى ذَكَرَ
u'تَعَالَى ذكر':Subject, #54: 54	تَعَالَى ذَكَرَ
u'تَعَالَى ذِكْرٌ':Subject, #3: 3	تَعَالَى ذِكْرُهُ
u'تَعَالَى ذكر':Subject, #3: 3	تَعَالَى ذِكْرُهُ
u'تَعَالَى ذِكْرٌ':Subject, #5: 5	تَعَالَى ذِكْرُ
u'تَعَالَى ذَمٌّ':Predicate, #5: 5	تَعَالَى ذِكْرُ
u'تَعَالَى رجعة':Predicate, #1: 1	تَعَالَى ذَمَّ
u'تَعَالَى رَجْعَةٌ':Predicate, #1: 1	تَعَالَى الرَّجْعَةَ
u'تَعَالَى رجعة':Subject, #1: 1	تَعَالَى الرَّجْعَةَ
u'تَعَالَى رَجْعَةٌ':Subject, #2: 2	تَعَالَى الرَّجْعَةُ
u'تَعَالَى رَجُلٌ':Subject, #2: 2	تَعَالَى الرَّجْعَةُ
u'تَعَالَى رُجُوعٌ':Predicate, #118: 118	تَعَالَى رَجُلٌ
u'تَعَالَى رُخْصَةٌ':Predicate, #1: 1	تَعَالَى رُجُوعَ
u'تَعَالَى رُخْصَةٌ':Predicate, #1: 1	تَعَالَى الرّخْصَةَ
u'تَعَالَى رَدٌّ':Predicate, #1: 1	تَعَالَى الرُّخْصَةَ
u'تَعَالَى رَدٌّ':Subject, #1: 1	تَعَالَى رَدَّ
u'تَعَالَى رِزْقٌ':Predicate, #1: 1	تَعَالَى رَدُّ
u'تَعَالَى رَفيعٌ':Subject, #1: 1	تَعَالَى رِزْقَ
u'تَعَالَى رُكَّعٌ':Subject, #1: 1	تَعَالَى الرَّفِيعُ
u'تَعَالَى رَهْنٌ':Predicate, #1: 1	تَعَالَى رُكَّعٌ
u'تَعَالَى رَهْنٌ':Subject, #1: 1	تَعَالَى الرَّهْنَ
u'تَعَالَى رِوايَةٌ':Predicate, #1: 1	تَعَالَى الرَّهْنُ
u'تَعَالَى رِوايَةٌ':Subject, #1: 1	تَعَالَى الرِّوَايَةَ
u'تَعَالَى زاجِرٌ':Subject, #2: 2	تَعَالَى رِوَايَةٌ
u'تَعَالَى زانِي':Predicate, #1: 1	تَعَالَى زَاجِرٌ
u'تَعَالَى زائِدٌ':Predicate, #2: 2	تَعَالَى زَانِيَةً
u'تَعَالَى زائِدٌ':Subject, #1: 1	تَعَالَى زَائِدَةً
u'تَعَالَى زَوْجٌ':Predicate, #1: 1	تَعَالَى زَائِدَةٌ
u'تَعَالَى زِيادَةٌ':Subject, #1: 1	تَعَالَى الزَّوْجَ
u'تَعَالَى زِيادَةٌ':Subject, #1: 1	تَعَالَى الزِّيَادَةُ
u'تَعَالَى زِينَةٌ':Predicate, #1: 1	تَعَالَى زِيَادَةٌ
u'تَعَالَى سَاخِطٌ':Subject, #1: 1	تَعَالَى الزِّينَةَ
u'تَعَالَى سَائِقٌ':Subject, #1: 1	تَعَالَى سَاخِطٌ
u'تَعَالَى سَبَبٌ':Subject, #1: 1	تَعَالَى سَائِقٌ
u'تَعَالَى سِتٌّ':Subject, #1: 1	تَعَالَى السَّبَبُ
u'تَعَالَى سجدة':Predicate, #3: 3	تَعَالَى سِتَّةٌ
u'تَعَالَى سَجْدَةٌ':Predicate, #1: 1	تَعَالَى سَجْدَةَ
u'تَعَالَى سِرٌّ':Predicate, #1: 1	تَعَالَى سَجْدَةَ
u'تَعَالَى سَعَادَةٌ':Predicate, #1: 1	تَعَالَى السِّرَّ
u'تَعَالَى سقط':Predicate, #1: 1	تَعَالَى السَّعَادَةَ
u'تَعَالَى سَقَطٌ':Predicate, #2: 2	تَعَالَى سَقَطَ
u'تَعَالَى سُلْطَانٌ':Subject, #2: 2	تَعَالَى سَقَطَ
u'تَعَالَى سَمٌّ':Subject, #1: 1	تَعَالَى السُّلْطَانُ
u'تَعَالَى سَمَاءٌ':Predicate, #2: 2	تَعَالَى سَمَّاهُ
u'تَعَالَى سَمَاعٌ':Subject, #1: 1	تَعَالَى السّمَاءَ
u'تَعَالَى سَمَاعٌ':Subject, #1: 1	تَعَالَى السَّمَاعُ
u'تَعَالَى سمر':Subject, #1: 1	تَعَالَى سَمَاعُ
u'تَعَالَى سَمَرٌ':Subject, #1: 1	تَعَالَى السَّمَرُ
u'تَعَالَى سَمَكٌ':Predicate, #1: 1	تَعَالَى السَّمَرُ
u'تَعَالَى سُنَّةٌ':Subject, #1: 1	تَعَالَى السَّمَكَ
u'تَعَالَى سَهَرٌ':Predicate, #1: 1	تَعَالَى السُّنَّةُ
u'تَعَالَى سَواءٌ':Subject, #1: 1	تَعَالَى السَّهَرَ
u'تَعَالَى سَوادٌ':Subject, #29: 29	تَعَالَى سَوَاءٌ
u'تَعَالَى سُورَةٌ':Predicate, #1: 1	تَعَالَى السَّوَادُ
u'تَعَالَى سُورَةٌ':Predicate, #1: 1	تَعَالَى السُّورَةَ
u'تَعَالَى شَامِلٌ':Subject, #1: 1	تَعَالَى سُورَةَ
u'تَعَالَى شَرٌّ':Predicate, #1: 1	تَعَالَى شَامِلٌ
u'تَعَالَى شِرَاءٌ':Predicate, #1: 1	تَعَالَى الشَّرَّ
u'تَعَالَى شِرَاءٌ':Subject, #1: 1	تَعَالَى الشِّرَاءَ
u'تَعَالَى شَرَطٌ':Predicate, #1: 1	تَعَالَى الشِّرَاءُ
u'تَعَالَى شَرْطٌ':Subject, #12: 12	تَعَالَى شَرَطَ
u'تَعَالَى شَرْطٌ':Subject, #1: 1	تَعَالَى شَرْطٌ
u'تَعَالَى شَرَعٌ':Predicate, #1: 1	تَعَالَى شَرْطُ
u'تَعَالَى شَعْرَانِيٌّ':Subject, #6: 6	تَعَالَى شَرَعَ
u'تَعَالَى شفعة':Subject, #1: 1	تَعَالَى الشَّعْرَانِيُّ
u'تَعَالَى شُفْعَةٌ':Subject, #2: 2	تَعَالَى الشُّفْعَةُ
u'تَعَالَى شِهَابٌ':Subject, #2: 2	تَعَالَى الشُّفْعَةُ
u'تَعَالَى شَهَادَةٌ':Predicate, #1: 1	تَعَالَى شِهَابُ
u'تَعَالَى شَهَادَةٌ':Predicate, #1: 1	تَعَالَى شَهَادَةَ
u'تَعَالَى شَهَادَةٌ':Subject, #4: 4	تَعَالَى الشَّهَادَةَ
u'تَعَالَى شُهُودٌ':Subject, #3: 3	تَعَالَى الشَّهَادَةُ
u'تَعَالَى شَيْءٌ':Subject, #1: 1	تَعَالَى الشُّهُودُ
u'تَعَالَى شَيْخٌ':Predicate, #4: 4	تَعَالَى شَيْءٌ
u'تَعَالَى شَيْخٌ':Subject, #1: 1	تَعَالَى الشَّيْخَ
u'تَعَالَى صَاحِبٌ':Subject, #1: 1	تَعَالَى الشَّيْخُ
u'تَعَالَى صَاحِبٌ':Subject, #1: 1	تَعَالَى صَاحِبَةُ
u'تَعَالَى صَادِقٌ':Predicate, #2: 2	تَعَالَى صَاحِبُ
u'تَعَالَى صَاعٌ':Subject, #1: 1	تَعَالَى صَادِقَةً
u'تَعَالَى صَالِحٌ':Subject, #1: 1	تَعَالَى صَاعٌ
u'تَعَالَى صَالِح':Subject, #1: 1	تَعَالَى صَالِحَةٌ
u'تَعَالَى صَحَابَةٌ':Predicate, #1: 1	تَعَالَى صَالِحَةٌ
u'تَعَالَى صِحَّةٌ':Predicate, #1: 1	تَعَالَى الصَّحَابَةَ
u'تَعَالَى صِحَّةٌ':Subject, #1: 1	تَعَالَى صِحَّةَ
u'تَعَالَى صِحَّةٌ':Subject, #1: 1	تَعَالَى الصِّحَّةُ
u'تَعَالَى صَحِيحٌ':Subject, #1: 1	تَعَالَى صِحَّةُ
u'تَعَالَى صدق':Predicate, #1: 1	تَعَالَى الصَّحِيحُ
u'تَعَالَى صدقة':Predicate, #2: 2	تَعَالَى صَدَقَ
u'تَعَالَى صَدَقَةٌ':Predicate, #1: 1	تَعَالَى صَدَقَةَ
u'تَعَالَى صدقة':Subject, #1: 1	تَعَالَى صَدَقَةَ
u'تَعَالَى صَدَقَةٌ':Subject, #1: 1	تَعَالَى صَدَقَةٌ
u'تَعَالَى صَرْفٌ':Subject, #1: 1	تَعَالَى صَدَقَةٌ
u'تَعَالَى صَرْف':Subject, #1: 1	تَعَالَى صَرْفُ
u'تَعَالَى صَغِيرٌ':Predicate, #1: 1	تَعَالَى صَرْفُ
u'تَعَالَى صَغِيرٌ':Subject, #1: 1	تَعَالَى صَغِيرَةً
u'تَعَالَى صِفَةٌ':Subject, #1: 1	تَعَالَى صَغِيرُهُ
u'تَعَالَى صِفَةٌ':Subject, #1: 1	تَعَالَى صِفَةٌ
u'تَعَالَى صِفَةٌ':Subject, #1: 1	تَعَالَى صِفَةُ
u'تَعَالَى صَلاَةٌ':Predicate, #1: 1	تَعَالَى صِفَتُهُ
u'تَعَالَى صَلاَةٌ':Predicate, #1: 1	تَعَالَى الصَّلَاةَ
u'تَعَالَى صَلاَةٌ':Subject, #1: 1	تَعَالَى صَلَاةَ
u'تَعَالَى صَلاَةٌ':Subject, #1: 1	تَعَالَى صَلاَةُ
u'تَعَالَى صَلاَةٌ':Subject, #2: 2	تَعَالَى صَلَاتُهُ
u'تَعَالَى صلح':Predicate, #3: 3	تَعَالَى صَلَاةُ
u'تَعَالَى صُلْحٌ':Predicate, #1: 1	تَعَالَى الصُّلْحَ
u'تَعَالَى صلح':Subject, #1: 1	تَعَالَى الصُّلْحَ
u'تَعَالَى صُلْحٌ':Subject, #3: 3	تَعَالَى الصُّلْحُ
u'تَعَالَى صَوَابٌ':Subject, #3: 3	تَعَالَى الصُّلْحُ
u'تَعَالَى صَوَابٌ':Subject, #1: 1	تَعَالَى الصَّوَابُ
u'تَعَالَى صَوْمٌ':Subject, #1: 1	تَعَالَى صَوَابُهُ
u'تَعَالَى صِيَامٌ':Predicate, #1: 1	تَعَالَى الصَّوْمُ
u'تَعَالَى صِيَامٌ':Subject, #1: 1	تَعَالَى الصِّيَامَ
u'تَعَالَى ضَامِنٌ':Subject, #1: 1	تَعَالَى صِيَامُ
u'تَعَالَى ضَرَبٌ':Predicate, #1: 1	تَعَالَى ضَامِنٌ
u'تَعَالَى ضَرُورَةٌ':Subject, #1: 1	تَعَالَى ضَرَبَ
u'تَعَالَى ضَمِنٌ':Predicate, #1: 1	تَعَالَى الضَّرُورَةُ
u'تَعَالَى طَاعَةٌ':Subject, #1: 1	تَعَالَى ضَمِنَ
u'تَعَالَى طَالِبٌ':Subject, #1: 1	تَعَالَى طَاعَةُ
u'تَعَالَى طَالِقٌ':Subject, #1: 1	تَعَالَى الطَّالِبُ
u'تَعَالَى طَبْعٌ':Subject, #1: 1	تَعَالَى طَالِقٌ
u'تَعَالَى طَلاَقٌ':Predicate, #1: 1	تَعَالَى طَبْعُ
u'تَعَالَى طَلاَقٌ':Subject, #2: 2	تَعَالَى الطَّلَاقَ
u'تَعَالَى طلب':Predicate, #2: 2	تَعَالَى الطَّلَاقُ
u'تَعَالَى طَلَبٌ':Predicate, #3: 3	تَعَالَى طَلَبَ
u'تَعَالَى طهر':Subject, #3: 3	تَعَالَى طَلَبَ
u'تَعَالَى طُهْرٌ':Subject, #1: 1	تَعَالَى الطُّهْرُ
u'تَعَالَى طُولٌ':Predicate, #1: 1	تَعَالَى الطُّهْرُ
u'تَعَالَى طَيِّبٌ':Subject, #1: 1	تَعَالَى طُولَ
u'تَعَالَى ظاهِرٌ':Subject, #1: 1	تَعَالَى طَيِّبٌ
u'تَعَالَى ظَفَرٌ':Predicate, #7: 7	تَعَالَى ظَاهِرٌ
u'تَعَالَى ظُلْمٌ':Predicate, #1: 1	تَعَالَى الظَّفَرَ
u'تَعَالَى ظهار':Subject, #1: 1	تَعَالَى الظُّلْمَ
u'تَعَالَى عَادَةٌ':Subject, #1: 1	تَعَالَى ظِهَارُ
u'تَعَالَى عَافِي':Predicate, #1: 1	تَعَالَى الْعَادَةُ
u'تَعَالَى عَافِيَةٌ':Predicate, #1: 1	تَعَالَى الْعَافِيَةَ
u'تَعَالَى عَالِمٌ':Subject, #1: 1	تَعَالَى الْعَافِيَةَ
u'تَعَالَى عَالِمٌ':Subject, #11: 11	تَعَالَى عَالِمٌ
u'تَعَالَى عَامٌّ':Subject, #1: 1	تَعَالَى الْعَالِمُ
u'تَعَالَى عَائِشٌ':Predicate, #1: 1	تَعَالَى عَامَّةُ
u'تَعَالَى عِبَادَةٌ':Subject, #1: 1	تَعَالَى عَائِشَةَ
u'تَعَالَى عَبْدٌ':Predicate, #1: 1	تَعَالَى عِبَادَةٌ
u'تَعَالَى عَبْدٌ':Subject, #1: 1	تَعَالَى الْعَبْدَ
u'تَعَالَى عَبْدٌ':Subject, #3: 3	تَعَالَى الْعَبْدُ
u'تَعَالَى عَبْدٌ':Subject, #3: 3	تَعَالَى عَبْدٌ
u'تَعَالَى عبرة':Predicate, #4: 4	تَعَالَى عَبْدُ
u'تَعَالَى عِبْرَةٌ':Predicate, #1: 1	تَعَالَى الْعِبْرَةَ
u'تَعَالَى عبرة':Subject, #1: 1	تَعَالَى الْعِبْرَةَ
u'تَعَالَى عِبْرَةٌ':Subject, #1: 1	تَعَالَى عِبْرَةٌ
u'تَعَالَى عتق':Predicate, #1: 1	تَعَالَى عِبْرَةٌ
u'تَعَالَى عتق':Subject, #2: 2	تَعَالَى عَتَقَ
u'تَعَالَى عِتْقٌ':Subject, #1: 1	تَعَالَى عِتْقُ
u'تَعَالَى عتق':Subject, #1: 1	تَعَالَى عِتْقُ
u'تَعَالَى عِتْقٌ':Subject, #2: 2	تَعَالَى الْعِتْقُ
u'تَعَالَى عِدَّةٌ':Predicate, #2: 2	تَعَالَى الْعِتْقُ
u'تَعَالَى عِدَّةٌ':Predicate, #1: 1	تَعَالَى الْعِدَّةَ
u'تَعَالَى عَدَدٌ':Predicate, #2: 2	تَعَالَى عِدَّةَ
u'تَعَالَى عَدَدٌ':Subject, #1: 1	تَعَالَى عَدَدَ
u'تَعَالَى عَدَدٌ':Subject, #1: 1	تَعَالَى الْعَدَدُ
u'تَعَالَى عِدْلٌ':Subject, #1: 1	تَعَالَى عَدَدُ
u'تَعَالَى عَدَمٌ':Predicate, #1: 1	تَعَالَى عِدْلُ
u'تَعَالَى عُذْرٌ':Subject, #2: 2	تَعَالَى عَدَمَ
u'تَعَالَى عَرَبٌ':Predicate, #1: 1	تَعَالَى عُذْرٌ
u'تَعَالَى عَرَبِيٌّ':Subject, #1: 1	تَعَالَى الْعَرَبَ
u'تَعَالَى عَرَضٌ':Predicate, #1: 1	تَعَالَى الْعَرَبِيُّ
u'تَعَالَى عرف':Predicate, #1: 1	تَعَالَى عَرَضَ
u'تَعَالَى عَزٌّ':Predicate, #1: 1	تَعَالَى عَرَفَ
u'تَعَالَى عُشْرٌ':Predicate, #7: 7	تَعَالَى عَزَّ
u'تَعَالَى عُشْرٌ':Subject, #1: 1	تَعَالَى الْعُشْرَ
u'تَعَالَى عُشْرٌ':Subject, #2: 2	تَعَالَى الْعُشْرُ
u'تَعَالَى عصم':Predicate, #3: 3	تَعَالَى عُشْرُ
u'تَعَالَى عِصْمَةٌ':Predicate, #1: 1	تَعَالَى عَصَمَ
u'تَعَالَى عطف':Predicate, #1: 1	تَعَالَى الْعِصْمَةَ
u'تَعَالَى عَفَافٌ':Subject, #9: 9	تَعَالَى عَطَفَ
u'تَعَالَى عَقِبٌ':Predicate, #1: 1	تَعَالَى عَفَافُ
u'تَعَالَى عُقُوبَةٌ':Predicate, #4: 4	تَعَالَى عَقِبَ
u'تَعَالَى عَقِيبٌ':Predicate, #1: 1	تَعَالَى عُقُوبَةَ
u'تَعَالَى علم':Predicate, #1: 1	تَعَالَى عَقِيبَ
u'تَعَالَى عِلْمٌ':Predicate, #1: 1	تَعَالَى عِلْمَ
u'تَعَالَى علم':Predicate, #1: 1	تَعَالَى عِلْمَ
u'تَعَالَى عِلْمٌ':Predicate, #2: 2	تَعَالَى الْعِلْمَ
u'تَعَالَى علم':Predicate, #2: 2	تَعَالَى الْعِلْمَ
u'تَعَالَى علم':Subject, #5: 5	تَعَالَى عَلِمَ
u'تَعَالَى عِلْمٌ':Subject, #1: 1	تَعَالَى عِلْمُ
u'تَعَالَى علماء':Predicate, #1: 1	تَعَالَى عِلْمُ
u'تَعَالَى عُلَمَاءُ':Predicate, #1: 1	تَعَالَى الْعُلَمَاءَ
u'تَعَالَى عُمَرٌ':Subject, #1: 1	تَعَالَى الْعُلَمَاءَ
u'تَعَالَى عمرة':Predicate, #1: 1	تَعَالَى عُمَرُ
u'تَعَالَى عُمْرَةٌ':Predicate, #1: 1	تَعَالَى الْعُمْرَةَ
u'تَعَالَى عُمُومٌ':Subject, #1: 1	تَعَالَى الْعُمْرَةَ
u'تَعَالَى عند':Predicate, #1: 1	تَعَالَى عُمُومُ
u'تَعَالَى عُهْدَةٌ':Predicate, #21: 21	تَعَالَى عِنْدَ
u'تَعَالَى عِوَضٌ':Predicate, #1: 1	تَعَالَى الْعُهْدَةَ
u'تَعَالَى غَالِبٌ':Subject, #2: 2	تَعَالَى الْعِوَضَ
u'تَعَالَى غَايَةٌ':Subject, #2: 2	تَعَالَى غَالِبٌ
u'تَعَالَى غَزْوٌ':Subject, #1: 1	تَعَالَى غَايَتُهُ
u'تَعَالَى غَصْبٌ':Subject, #1: 1	تَعَالَى الْغَزْوُ
u'تَعَالَى غُلاَمٌ':Subject, #1: 1	تَعَالَى غَصْبُ
u'تَعَالَى غَلَبَةٌ':Predicate, #1: 1	تَعَالَى الْغُلَامُ
u'تَعَالَى غَنِيٌّ':Subject, #1: 1	تَعَالَى الْغَلَبَةَ
u'تَعَالَى غير':Predicate, #6: 6	تَعَالَى غَنِيٌّ
u'تَعَالَى غَيْرٌ':Predicate, #5: 5	تَعَالَى غَيْرَ
u'تَعَالَى غير':Subject, #5: 5	تَعَالَى غَيْرَ
u'تَعَالَى غَيْرٌ':Subject, #8: 8	تَعَالَى غَيْرُ
u'تَعَالَى فَاسِقٌ':Subject, #8: 8	تَعَالَى غَيْرُ
u'تَعَالَى فَاعِلٌ':Subject, #1: 1	تَعَالَى الْفَاسِقُ
u'تَعَالَى فَرْجٌ':Predicate, #1: 1	تَعَالَى فَاعِلٌ
u'تَعَالَى فَرْضٌ':Predicate, #1: 1	تَعَالَى فَرْجَ
u'تَعَالَى فرق':Predicate, #1: 1	تَعَالَى فَرْضَ
u'تَعَالَى فَرْقٌ':Predicate, #1: 1	تَعَالَى الْفَرْقَ
u'تَعَالَى فرق':Subject, #1: 1	تَعَالَى الْفَرْقَ
u'تَعَالَى فَرْقٌ':Subject, #1: 1	تَعَالَى الْفَرْقُ
u'تَعَالَى فساد':Subject, #1: 1	تَعَالَى الْفَرْقُ
u'تَعَالَى فَسَادٌ':Subject, #1: 1	تَعَالَى فَسَادُ
u'تَعَالَى فَصْلٌ':Subject, #1: 1	تَعَالَى فَسَادُ
u'تَعَالَى فطنة':Predicate, #1: 1	تَعَالَى فَصْلُ
u'تَعَالَى فِطْنَةٌ':Predicate, #1: 1	تَعَالَى فِطْنَةَ
u'تَعَالَى فِعْلٌ':Predicate, #1: 1	تَعَالَى فِطْنَةَ
u'تَعَالَى فِعْلٌ':Predicate, #1: 1	تَعَالَى فِعْلَ
u'تَعَالَى فِعْلٌ':Subject, #2: 2	تَعَالَى الْفِعْلَ
u'تَعَالَى فِعْلٌ':Subject, #1: 1	تَعَالَى الْفِعْلُ
u'تَعَالَى فَقِيرٌ':Subject, #1: 1	تَعَالَى فِعْلُ
u'تَعَالَى فَلًا':Predicate, #1: 1	تَعَالَى الْفَقِيرُ
u'تَعَالَى فلان':Predicate, #1: 1	تَعَالَى فَلاَ
u'تَعَالَى فَوَاتٌ':Subject, #1: 1	تَعَالَى مَكَّةَ
u'تَعَالَى قَادِرٌ':Subject, #2: 2	تَعَالَى فَوَاتُ
u'تَعَالَى قَاسِمٌ':Subject, #8: 8	تَعَالَى قَادِرٌ
u'تَعَالَى قَالٌ':Predicate, #1: 1	تَعَالَى قَاسِمٌ
u'تَعَالَى قَالٌ':Predicate, #2: 2	تَعَالَى قَالاَ
u'تَعَالَى قِبَلٌ':Predicate, #361: 361	تَعَالَى قَالَ
u'تَعَالَى قتل':Subject, #2: 2	تَعَالَى قِبَلَ
u'تَعَالَى قَتْلٌ':Subject, #1: 1	تَعَالَى الْقَتْلُ
u'تَعَالَى قَدْرٌ':Subject, #1: 1	تَعَالَى الْقَتْلُ
u'تَعَالَى قَدِيرٌ':Subject, #1: 1	تَعَالَى قَدْرُ
u'تَعَالَى قذف':Subject, #1: 1	تَعَالَى الْقَدِيرُ
u'تَعَالَى قَذْفٌ':Subject, #1: 1	تَعَالَى قَذْفُ
u'تَعَالَى قُرْبَةٌ':Subject, #1: 1	تَعَالَى قَذْفُ
u'تَعَالَى قَرْضٌ':Subject, #1: 1	تَعَالَى قُرْبَةٌ
u'تَعَالَى قسمة':Subject, #1: 1	تَعَالَى قَرْضُ
u'تَعَالَى قِسْمَةٌ':Subject, #1: 1	تَعَالَى الْقِسْمَةُ
u'تَعَالَى قِصَّةٌ':Predicate, #1: 1	تَعَالَى الْقِسْمَةُ
u'تَعَالَى قِصَّةٌ':Predicate, #1: 1	تَعَالَى الْقِصَّةَ
u'تَعَالَى قَصَرٌ':Predicate, #1: 1	تَعَالَى قِصَّةَ
u'تَعَالَى قَضَاءٌ':Subject, #1: 1	تَعَالَى قَصَرَ
u'تَعَالَى قَطِيعٌ':Predicate, #1: 1	تَعَالَى الْقَضَاءُ
u'تَعَالَى قَطِيعَةٌ':Predicate, #1: 1	تَعَالَى قَطِيعَةَ
u'تَعَالَى قلب':Subject, #1: 1	تَعَالَى قَطِيعَةَ
u'تَعَالَى قَلْبٌ':Subject, #1: 1	تَعَالَى الْقَلْبُ
u'تَعَالَى قَلْب':Subject, #1: 1	تَعَالَى الْقَلْبُ
u'تَعَالَى قُلُوبٌ':Predicate, #1: 1	تَعَالَى الْقَلْبُ
u'تَعَالَى قول':Predicate, #1: 1	تَعَالَى قُلُوبَ
u'تَعَالَى قَوْلٌ':Predicate, #6: 6	تَعَالَى قَوْلَ
u'تَعَالَى قول':Subject, #6: 6	تَعَالَى قَوْلَ
u'تَعَالَى قَوْلٌ':Subject, #15: 15	تَعَالَى الْقَوْلُ
u'تَعَالَى قول':Subject, #15: 15	تَعَالَى الْقَوْلُ
u'تَعَالَى قَوْلٌ':Subject, #2: 2	تَعَالَى قَوْلُ
u'تَعَالَى قَوْلٌ':Subject, #2: 2	تَعَالَى قَوْلُ
u'تَعَالَى قول':Subject, #5: 5	تَعَالَى قَوْلٌ
u'تَعَالَى قَوْلٌ':Subject, #9: 9	تَعَالَى قَوْلُهُ
u'تَعَالَى قَوْمَةٌ':Subject, #9: 9	تَعَالَى قَوْلُهُ
u'تَعَالَى قِيَاسٌ':Predicate, #1: 1	تَعَالَى الْقَوْمَةُ
u'تَعَالَى قِيَاسٌ':Subject, #1: 1	تَعَالَى الْقِيَاسَ
u'تَعَالَى قِيَاسٌ':Subject, #1: 1	تَعَالَى قِيَاسُ
u'تَعَالَى قِيَاسٌ':Subject, #2: 2	تَعَالَى قِيَاسٌ
u'تَعَالَى قِيمَةٌ':Subject, #3: 3	تَعَالَى الْقِيَاسُ
u'تَعَالَى قِيمَةٌ':Subject, #1: 1	تَعَالَى قِيمَتُهُ
u'تَعَالَى كِبْرِيَاءُ':Subject, #2: 2	تَعَالَى قِيمَةُ
u'تَعَالَى كِتَابٌ':Predicate, #1: 1	تَعَالَى الْكِبْرِيَاءُ
u'تَعَالَى كِتَابٌ':Predicate, #1: 1	تَعَالَى الْكِتَابَ
u'تَعَالَى كِتَابٌ':Subject, #1: 1	تَعَالَى كِتَابَ
u'تَعَالَى كِتَابَةٌ':Subject, #1: 1	تَعَالَى كِتَابُهُ
u'تَعَالَى كِتَابَةٌ':Subject, #1: 1	تَعَالَى الْكِتَابَةُ
u'تَعَالَى كَثِيرٌ':Subject, #1: 1	تَعَالَى كِتَابَتُهُ
u'تَعَالَى كَذِبٌ':Subject, #1: 1	تَعَالَى الْكَثِيرُ
u'تَعَالَى كَرِهٌ':Predicate, #1: 1	تَعَالَى كَذِبٌ
u'تَعَالَى كَسْبٌ':Subject, #8: 8	تَعَالَى كَرِهَ
u'تَعَالَى كَسْبٌ':Subject, #1: 1	تَعَالَى الْكَسْبُ
u'تَعَالَى كُفَّارٌ':Predicate, #1: 1	تَعَالَى كَسْبُ
u'تَعَالَى كَفَّارٌ':Subject, #2: 2	تَعَالَى الْكُفَّارَ
u'تَعَالَى كَفَّارَةٌ':Subject, #1: 1	تَعَالَى كَفَّارَةُ
u'تَعَالَى كَفَالَةٌ':Subject, #1: 1	تَعَالَى كَفَّارَةُ
u'تَعَالَى كَلاَمٌ':Predicate, #1: 1	تَعَالَى الْكَفَالَةُ
u'تَعَالَى كَلاَمٌ':Predicate, #1: 1	تَعَالَى الْكَلَامَ
u'تَعَالَى كَلاَمٌ':Subject, #1: 1	تَعَالَى كَلَامَ
u'تَعَالَى كَهْلٌ':Predicate, #1: 1	تَعَالَى كَلَامٌ
u'تَعَالَى كَوْنٌ':Subject, #1: 1	تَعَالَى الْكَهْلَ
u'تَعَالَى لبن':Subject, #1: 1	تَعَالَى كَوْنُ
u'تَعَالَى لَبَنٌ':Subject, #1: 1	تَعَالَى اللَّبَنُ
u'تَعَالَى لَبَّيْكَ':Predicate, #1: 1	تَعَالَى اللَّبَنُ
u'تَعَالَى لَحْمٌ':Predicate, #1: 1	تَعَالَى لَبَّيْكَ
u'تَعَالَى لُؤْلُؤَةٌ':Subject, #2: 2	تَعَالَى لَحْمَ
u'تَعَالَى لَيْلٌ':Predicate, #1: 1	تَعَالَى لُؤْلُؤَةٌ
u'تَعَالَى مَالٌ':Predicate, #1: 1	تَعَالَى لَيْلَةَ
u'تَعَالَى مَالٌ':Subject, #1: 1	تَعَالَى الْمَالَ
u'تَعَالَى مَالِكٌ':Subject, #5: 5	تَعَالَى الْمَالُ
u'تَعَالَى مَالِيٌّ':Predicate, #1: 1	تَعَالَى مَالِكُ
u'تَعَالَى مَأْمُونٌ':Subject, #1: 1	تَعَالَى الْمَالِيَّ
u'تَعَالَى مُبَارَكٌ':Subject, #1: 1	تَعَالَى مَأْمُونٌ
u'تَعَالَى مُبَاشَرَةٌ':Predicate, #1: 1	تَعَالَى مُبَارَكٌ
u'تَعَالَى مَبْنِيٌّ':Subject, #1: 1	تَعَالَى الْمُبَاشَرَةَ
u'تَعَالَى مَبْنِيٌّ':Subject, #1: 1	تَعَالَى مَبْنِيٌّ
u'تَعَالَى مَتَاعٌ':Subject, #4: 4	تَعَالَى مَبْنِيَّةٌ
u'تَعَالَى مُتَّجَهٌ':Subject, #1: 1	تَعَالَى الْمَتَاعُ
u'تَعَالَى مُتَرَدِّدٌ':Subject, #1: 1	تَعَالَى مُتَّجَهٌ
u'تَعَالَى مُتَعَارَفٌ':Subject, #1: 1	تَعَالَى مُتَرَدِّدٌ
u'تَعَالَى مُتْعَةٌ':Subject, #1: 1	تَعَالَى مُتَعَارَفٌ
u'تَعَالَى مُتَعَلِّقٌ':Subject, #1: 1	تَعَالَى الْمُتْعَةُ
u'تَعَالَى مُتَعَلِّقٌ':Subject, #2: 2	تَعَالَى الْمُتَعَلِّقُ
u'تَعَالَى مُتَّفَقٌ':Subject, #4: 4	تَعَالَى مُتَعَلِّقٌ
u'تَعَالَى مُتَقَدِّمٌ':Subject, #1: 1	تَعَالَى مُتَّفَقٌ
u'تَعَالَى مُتَكَلِّمٌ':Subject, #1: 1	تَعَالَى الْمُتَقَدِّمُ
u'تَعَالَى مِثَالٌ':Subject, #2: 2	تَعَالَى مُتَكَلِّمٌ
u'تَعَالَى مثل':Predicate, #1: 1	تَعَالَى مِثَالُهُ
u'تَعَالَى مِثْلٌ':Predicate, #5: 5	تَعَالَى مِثْلَ
u'تَعَالَى مثل':Subject, #5: 5	تَعَالَى مِثْلَ
u'تَعَالَى مِثْلٌ':Subject, #1: 1	تَعَالَى مِثْلُ
u'تَعَالَى مِثْلٌ':Subject, #1: 1	تَعَالَى مِثْلٌ
u'تَعَالَى مُجَانَبَةٌ':Predicate, #1: 1	تَعَالَى مِثْلُ
u'تَعَالَى مُحَابَاةٌ':Subject, #1: 1	تَعَالَى مُجَانَبَةَ
u'تَعَالَى مُحَابَاةٌ':Subject, #1: 1	تَعَالَى الْمُحَابَاةُ
u'تَعَالَى مَحْبُوبٌ':Subject, #1: 1	تَعَالَى مُحَابَاةٌ
u'تَعَالَى مَحْجُوبٌ':Subject, #1: 1	تَعَالَى مَحْبُوبٌ
u'تَعَالَى مَحْجُورٌ':Subject, #1: 1	تَعَالَى مَحْجُوبٌ
u'تَعَالَى مَحْض':Subject, #1: 1	تَعَالَى الْمَحْجُورُ
u'تَعَالَى مَحْظُورٌ':Subject, #1: 1	تَعَالَى الْمَحْضَةُ
u'تَعَالَى مَحَلٌّ':Predicate, #1: 1	تَعَالَى مَحْظُورٌ
u'تَعَالَى مُحَمَّدٌ':Subject, #1: 1	تَعَالَى مَحَلَّ
u'تَعَالَى مَحْمُودٌ':Subject, #1: 1	تَعَالَى مُحَمَّدٌ
u'تَعَالَى مَحْمُولٌ':Subject, #1: 1	تَعَالَى مَحْمُودُ
u'تَعَالَى مُحِيطٌ':Subject, #4: 4	تَعَالَى مَحْمُولٌ
u'تَعَالَى مُخْتَرِعٌ':Predicate, #7: 7	تَعَالَى مُحِيطٌ
u'تَعَالَى مَخْرَجٌ':Subject, #1: 1	تَعَالَى مُخْتَرِعَ
u'تَعَالَى مَخْلُوقٌ':Subject, #1: 1	تَعَالَى الْمَخْرَجُ
u'تَعَالَى مُدَبِّرٌ':Subject, #2: 2	تَعَالَى مَخْلُوقَةٌ
u'تَعَالَى مَذْكُورٌ':Subject, #1: 1	تَعَالَى الْمُدَبِّرُ
u'تَعَالَى مَذْهَبٌ':Predicate, #1: 1	تَعَالَى الْمَذْكُورُ
u'تَعَالَى مرٌّ':Predicate, #1: 1	تَعَالَى مَذْهَبَ
u'تَعَالَى مرٌّ':Predicate, #2: 2	تَعَالَى مَرَّةً
u'تَعَالَى مَرٌّ':Predicate, #8: 8	تَعَالَى مَرَّ
u'تَعَالَى مراد':Predicate, #8: 8	تَعَالَى مَرَّ
u'تَعَالَى مُرَادٌ':Predicate, #1: 1	تَعَالَى الْمُرَادَ
u'تَعَالَى مراد':Subject, #1: 1	تَعَالَى الْمُرَادَ
u'تَعَالَى مُرَادٌ':Subject, #3: 3	تَعَالَى الْمُرَادُ
u'تَعَالَى مَرِيضٌ':Subject, #3: 3	تَعَالَى الْمُرَادُ
u'تَعَالَى مَسْأَلَةٌ':Predicate, #1: 1	تَعَالَى الْمَرِيضُ
u'تَعَالَى مَسْأَلَةٌ':Predicate, #2: 2	تَعَالَى الْمَسْأَلَةَ
u'تَعَالَى مَسَائِلُ':Predicate, #3: 3	تَعَالَى مَسْأَلَةَ
u'تَعَالَى مَسَائِلُ':Predicate, #1: 1	تَعَالَى الْمَسَائِلَ
u'تَعَالَى مَسَائِلُ':Subject, #1: 1	تَعَالَى مَسَائِلَ
u'تَعَالَى مُسْتَأْجِرٌ':Subject, #1: 1	تَعَالَى مَسَائِلُ
u'تَعَالَى مُسْتَحَبٌّ':Subject, #1: 1	تَعَالَى الْمُسْتَأْجِرُ
u'تَعَالَى مُسْتَحَبٌّ':Subject, #1: 1	تَعَالَى الْمُسْتَحَبُّ
u'تَعَالَى مُسْتَقْبِلٌ':Predicate, #1: 1	تَعَالَى مُسْتَحَبٌّ
u'تَعَالَى مُسْتَقِيمٌ':Subject, #2: 2	تَعَالَى مُسْتَقْبِلَ
u'تَعَالَى مُسْتَلْزِمٌ':Subject, #1: 1	تَعَالَى مُسْتَقِيمٌ
u'تَعَالَى مُسْتَمِرٌّ':Subject, #1: 1	تَعَالَى مُسْتَلْزِمٌ
u'تَعَالَى مَسْحٌ':Subject, #1: 1	تَعَالَى الْمُسْتَمِرُّ
u'تَعَالَى مُسْلِمٌ':Predicate, #1: 1	تَعَالَى مَسْحُ
u'تَعَالَى مُسْلِمٌ':Subject, #2: 2	تَعَالَى الْمُسْلِمِينَ
u'تَعَالَى مَشْرُوعٌ':Subject, #2: 2	تَعَالَى مُسْلِمٌ
u'تَعَالَى مُشْكِلٌ':Subject, #1: 1	تَعَالَى مَشْرُوعٌ
u'تَعَالَى مَشْهُورٌ':Subject, #1: 1	تَعَالَى مُشْكِلٌ
u'تَعَالَى مَشْيٌ':Predicate, #1: 1	تَعَالَى مَشْهُورَةٌ
u'تَعَالَى مَصْلَحَةٌ':Predicate, #1: 1	تَعَالَى الْمَشْيَ
u'تَعَالَى مُضَارِبٌ':Subject, #1: 1	تَعَالَى مَصْلَحَةَ
u'تَعَالَى مُضَارَبَةٌ':Subject, #1: 1	تَعَالَى الْمُضَارِبُ
u'تَعَالَى مُضْطَرِبٌ':Subject, #3: 3	تَعَالَى الْمُضَارَبَةُ
u'تَعَالَى مُطَّلِعٌ':Subject, #8: 8	تَعَالَى مُضْطَرِبٌ
u'تَعَالَى مُطْلَقٌ':Predicate, #8: 8	تَعَالَى مُطَّلِعٌ
u'تَعَالَى مَطْلُوبٌ':Subject, #1: 1	تَعَالَى مُطْلَقَ
u'تَعَالَى مُعَامَلَةٌ':Subject, #1: 1	تَعَالَى الْمَطْلُوبُ
u'تَعَالَى مُعْتَبَرٌ':Subject, #1: 1	تَعَالَى الْمُعَامَلَةُ
u'تَعَالَى مُعْتَبَرٌ':Subject, #1: 1	تَعَالَى مُعْتَبَرَةٌ
u'تَعَالَى مُعْتَبَرٌ':Subject, #2: 2	تَعَالَى مُعْتَبَرٌ
u'تَعَالَى مُعَلَّلٌ':Subject, #3: 3	تَعَالَى الْمُعْتَبَرُ
u'تَعَالَى مَعْلُومٌ':Subject, #1: 1	تَعَالَى مُعَلَّلَةٌ
u'تَعَالَى مَعْلُومٌ':Subject, #1: 1	تَعَالَى مَعْلُومٌ
u'تَعَالَى مُعِينٌ':Subject, #1: 1	تَعَالَى مَعْلُومَاتٌ
u'تَعَالَى مَغْفِرَةٌ':Subject, #1: 1	تَعَالَى الْمُعِينُ
u'تَعَالَى مَفْرُوضٌ':Subject, #1: 1	تَعَالَى الْمَغْفِرَةُ
u'تَعَالَى مُقَامٌ':Subject, #1: 1	تَعَالَى الْمَفْرُوضُ
u'تَعَالَى مُقْبِلٌ':Subject, #1: 1	تَعَالَى الْمُقَامُ
u'تَعَالَى مَقْبُولٌ':Predicate, #1: 1	تَعَالَى مُقْبِلٌ
u'تَعَالَى مِقْدَارٌ':Predicate, #1: 1	تَعَالَى مَقْبُولَةً
u'تَعَالَى مُقَدَّرٌ':Subject, #2: 2	تَعَالَى مِقْدَارَ
u'تَعَالَى مَقْرُونٌ':Subject, #1: 1	تَعَالَى مُقَدَّرٌ
u'تَعَالَى مُقَيَّدٌ':Subject, #1: 1	تَعَالَى مَقْرُونٌ
u'تَعَالَى مَكَانٌ':Subject, #1: 1	تَعَالَى مُقَيَّدٌ
u'تَعَالَى مَكْرُوهٌ':Subject, #1: 1	تَعَالَى مَكَانُ
u'تَعَالَى مَكْرُوهٌ':Subject, #1: 1	تَعَالَى مَكْرُوهَةٌ
u'تَعَالَى مَكْرُوهَةٌ':Subject, #2: 2	تَعَالَى مَكْرُوهٌ
u'تَعَالَى مُمْكِنٌ':Subject, #1: 1	تَعَالَى مَكْرُوهَةٌ
u'تَعَالَى مُمْكِن':Subject, #1: 1	تَعَالَى مُمْكِنٌ
u'تَعَالَى مَمْنُوعٌ':Subject, #1: 1	تَعَالَى مُمْكِنٌ
u'تَعَالَى مَنٌّ':Predicate, #1: 1	تَعَالَى مَمْنُوعٌ
u'تَعَالَى مُنَافِقٌ':Predicate, #2: 2	تَعَالَى مَنَّ
u'تَعَالَى مُنَافِي':Subject, #1: 1	تَعَالَى الْمُنَافِقِينَ
u'تَعَالَى مَنْدُوبٌ':Subject, #1: 1	تَعَالَى مُنَافِيَةٌ
u'تَعَالَى مُنَزَّهٌ':Subject, #2: 2	تَعَالَى مَنْدُوبٌ
u'تَعَالَى مُنَزَّهٌ':Subject, #2: 2	تَعَالَى مُنَزَّهَةٌ
u'تَعَالَى مَنْعٌ':Predicate, #7: 7	تَعَالَى مُنَزَّهٌ
u'تَعَالَى مَنْعٌ':Subject, #1: 1	تَعَالَى الْمَنْعَ
u'تَعَالَى مَهْرٌ':Predicate, #1: 1	تَعَالَى مَنْعُ
u'تَعَالَى مَهْرٌ':Subject, #1: 1	تَعَالَى الْمَهْرَ
u'تَعَالَى مَهْرٌ':Subject, #1: 1	تَعَالَى الْمَهْرُ
u'تَعَالَى مُوالاة':Subject, #1: 1	تَعَالَى مَهْرُ
u'تَعَالَى مَوَالِي':Predicate, #1: 1	تَعَالَى الْمُوَالَاةُ
u'تَعَالَى مَوْجُودٌ':Subject, #2: 2	تَعَالَى الْمَوَالِيَ
u'تَعَالَى مَوْجُودٌ':Subject, #1: 1	تَعَالَى مَوْجُودٌ
u'تَعَالَى مُودَعٌ':Subject, #2: 2	تَعَالَى مَوْجُودَةٌ
u'تَعَالَى مُؤَذِّنٌ':Subject, #1: 1	تَعَالَى الْمُودَعُ
u'تَعَالَى مَوْصُوفٌ':Subject, #1: 1	تَعَالَى مُؤَذِّنٌ
u'تَعَالَى مَوْقُوفٌ':Subject, #2: 2	تَعَالَى مَوْصُوفٌ
u'تَعَالَى مُؤْمِنٌ':Predicate, #1: 1	تَعَالَى مَوْقُوفٌ
u'تَعَالَى مُؤَيِّدٌ':Subject, #1: 1	تَعَالَى الْمُؤْمِنِينَ
u'تَعَالَى نَاظِرٌ':Subject, #1: 1	تَعَالَى مُؤَيِّدٌ
u'تَعَالَى نَافِذٌ':Subject, #1: 1	تَعَالَى نَاظِرٌ
u'تَعَالَى نَبِيٌّ':Predicate, #1: 1	تَعَالَى نَافِذٌ
u'تَعَالَى نَجَاسَةٌ':Subject, #1: 1	تَعَالَى النَّبِيَّ
u'تَعَالَى نَحْوٌ':Predicate, #1: 1	تَعَالَى النَّجَاسَةُ
u'تَعَالَى نَحْوٌ':Subject, #2: 2	تَعَالَى نَحْوَ
u'تَعَالَى نِساءٌ':Predicate, #2: 2	تَعَالَى نَحْوُ
u'تَعَالَى نِساءٌ':Predicate, #1: 1	تَعَالَى النِّسَاءَ
u'تَعَالَى نسي':Predicate, #1: 1	تَعَالَى نِسَاءَ
u'تَعَالَى نِسْيَانٌ':Predicate, #1: 1	تَعَالَى نَسِيَ
u'تَعَالَى نَصٌّ':Predicate, #1: 1	تَعَالَى النِّسْيَانَ
u'تَعَالَى نِصْفٌ':Predicate, #8: 8	تَعَالَى نَصَّ
u'تَعَالَى نِصْفٌ':Subject, #2: 2	تَعَالَى نِصْفَ
u'تَعَالَى نَصِيبٌ':Subject, #2: 2	تَعَالَى نِصْفُ
u'تَعَالَى نَظَرٌ':Predicate, #2: 2	تَعَالَى نَصِيبُ
u'تَعَالَى نَظِيرٌ':Subject, #1: 1	تَعَالَى نَظَرَ
u'تَعَالَى نَعْتٌ':Subject, #2: 2	تَعَالَى نَظِيرُ
u'تَعَالَى نفاس':Subject, #1: 1	تَعَالَى النَّعْتُ
u'تَعَالَى نِفَاسٌ':Subject, #1: 1	تَعَالَى النِّفَاسُ
u'تَعَالَى نَفْعٌ':Predicate, #1: 1	تَعَالَى النِّفَاسُ
u'تَعَالَى نَفَقَةٌ':Subject, #2: 2	تَعَالَى النَّفْعَ
u'تَعَالَى نُفُوذٌ':Predicate, #1: 1	تَعَالَى النَّفَقَةُ
u'تَعَالَى نَفْيٌ':Predicate, #1: 1	تَعَالَى نُفُوذَ
u'تَعَالَى نُقْصَانٌ':Predicate, #1: 1	تَعَالَى نَفْيَ
u'تَعَالَى نَقْضٌ':Subject, #2: 2	تَعَالَى النُّقْصَانَ
u'تَعَالَى نقل':Predicate, #1: 1	تَعَالَى نَقْضُ
u'تَعَالَى نَقَلٌ':Predicate, #2: 2	تَعَالَى نَقَلَ
u'تَعَالَى نكاح':Predicate, #2: 2	تَعَالَى نَقَلَ
u'تَعَالَى نِكَاحٌ':Predicate, #2: 2	تَعَالَى النِّكَاحَ
u'تَعَالَى نكاح':Subject, #2: 2	تَعَالَى النِّكَاحَ
u'تَعَالَى نِكَاحٌ':Subject, #3: 3	تَعَالَى النِّكَاحُ
u'تَعَالَى نهار':Subject, #3: 3	تَعَالَى النِّكَاحُ
u'تَعَالَى نَهَارٌ':Subject, #4: 4	تَعَالَى النَّهَارُ
u'تَعَالِي نهار':Added, #4: 4	تَعَالَى النَّهَارُ
u'تَعَالِي نَهَارٌ':Added, #2: 2	تَعَالِي النَّهَارِ
u'تَعَالَى نَهْرٌ':Subject, #2: 2	تَعَالِي النَّهَارِ
u'تَعَالَى نَوْعٌ':Subject, #1: 1	تَعَالَى نَهْرٌ
u'تَعَالَى نِيَابَةٌ':Subject, #1: 1	تَعَالَى نَوْعٌ
u'تَعَالَى هِبَةٌ':Predicate, #1: 1	تَعَالَى النِّيَابَةُ
u'تَعَالَى هِبَةٌ':Subject, #1: 1	تَعَالَى الْهِبَةَ
u'تَعَالَى هِدَايَةٌ':Subject, #1: 1	تَعَالَى هِبَةٌ
u'تَعَالَى هَدْيٌ':Predicate, #1: 1	تَعَالَى الْهِدَايَةُ
u'تَعَالَى وَاجِبٌ':Subject, #1: 1	تَعَالَى الْهَدْيَ
u'تَعَالَى وَاجِبٌ':Subject, #1: 1	تَعَالَى الْوَاجِبُ
u'تَعَالَى واحد':Predicate, #4: 4	تَعَالَى وَاجِبٌ
u'تَعَالَى وَاحِدٌ':Predicate, #3: 3	تَعَالَى وَاحِدَةً
u'تَعَالَى واحد':Subject, #3: 3	تَعَالَى وَاحِدَةً
u'تَعَالَى وَاحِدٌ':Subject, #6: 6	تَعَالَى وَاحِدٌ
u'تَعَالَى وَاضِحٌ':Predicate, #6: 6	تَعَالَى وَاحِدٌ
u'تَعَالَى وَاضِحٌ':Subject, #2: 2	تَعَالَى وَاضِحَةً
u'تَعَالَى وَاقِعٌ':Subject, #1: 1	تَعَالَى وَاضِحٌ
u'تَعَالَى وَجَبٌ':Predicate, #1: 1	تَعَالَى الْوَاقِعُ
u'تَعَالَى وَجْهٌ':Subject, #1: 1	تَعَالَى وَجَبَ
u'تَعَالَى وَجْهٌ':Subject, #1: 1	تَعَالَى وَجْهُهُ
u'تَعَالَى وُجُوبٌ':Predicate, #5: 5	تَعَالَى وَجْهُ
u'تَعَالَى وُجُوبٌ':Subject, #1: 1	تَعَالَى وُجُوبَ
u'تَعَالَى وُجُودٌ':Predicate, #1: 1	تَعَالَى الْوُجُوبُ
u'تَعَالَى وَدِيعٌ':Subject, #1: 1	تَعَالَى الْوُجُودَ
u'تَعَالَى وَدِيعَةٌ':Subject, #1: 1	تَعَالَى الْوَدِيعَةُ
u'تَعَالَى وَراء':Predicate, #1: 1	تَعَالَى الْوَدِيعَةُ
u'تَعَالَى وَرَثَةٌ':Subject, #1: 1	تَعَالَى وَرَاءَ
u'تَعَالَى وِصَايَةٌ':Subject, #1: 1	تَعَالَى وَرَثَةُ
u'تَعَالَى وَصْفٌ':Subject, #1: 1	تَعَالَى الْوِصَايَةُ
u'تَعَالَى وصلة':Subject, #1: 1	تَعَالَى وَصْفٌ
u'تَعَالَى وَصِيٌّ':Subject, #1: 1	تَعَالَى وَصِلَةُ
u'تَعَالَى وَصِيٌّ':Subject, #1: 1	تَعَالَى الْوَصِيُّ
u'تَعَالَى وَصِيٌّ':Subject, #1: 1	تَعَالَى وَصِيُّ
u'تَعَالَى وَصِيٌّ':Subject, #1: 1	تَعَالَى وَصِيَّةٌ
u'تَعَالَى وَصِيَّةٌ':Subject, #2: 2	تَعَالَى الْوَصِيَّةُ
u'تَعَالَى وَصِيَّةٌ':Subject, #1: 1	تَعَالَى وَصِيَّةٌ
u'تَعَالَى وُضُوءٌ':Predicate, #2: 2	تَعَالَى الْوَصِيَّةُ
u'تَعَالَى وَطْءٌ':Subject, #1: 1	تَعَالَى الْوُضُوءَ
u'تَعَالَى وَقْتٌ':Predicate, #1: 1	تَعَالَى الْوَطْءُ
u'تَعَالَى وَقْتٌ':Subject, #3: 3	تَعَالَى وَقْتَ
u'تَعَالَى وَقْتٌ':Subject, #1: 1	تَعَالَى وَقْتُهُ
u'تَعَالَى وَقْفٌ':Subject, #3: 3	تَعَالَى وَقْتُ
u'تَعَالَى وَقْفٌ':Subject, #1: 1	تَعَالَى وَقْفُ
u'تَعَالَى وُقُوعٌ':Subject, #2: 2	تَعَالَى الْوَقْفُ
u'تَعَالَى وَلاَءٌ':Subject, #2: 2	تَعَالَى وُقُوعُهُ
u'تَعَالَى وَلاَيَةٌ':Predicate, #4: 4	تَعَالَى وَلَاءُ
u'تَعَالَى وَلاَيَةٌ':Subject, #1: 1	تَعَالَى الْوَلاَيَةَ
u'تَعَالَى وِلاَيَةٌ':Subject, #1: 1	تَعَالَى الْوَلَايَةُ
u'تَعَالَى ولد':Subject, #1: 1	تَعَالَى الْوِلَايَةُ
u'تَعَالَى وَلَدٌ':Subject, #1: 1	تَعَالَى الْوَلَدُ
u'تَعَالَى وَلَهٌ':Subject, #1: 1	تَعَالَى الْوَلَدُ
u'تَعَالَى وَلِيٌّ':Subject, #7: 7	تَعَالَى وَلَهُ
u'تَعَالَى وَلِيٌّ':Subject, #1: 1	تَعَالَى وَلِيٌّ
u'تَعَالَى وَنِيَّةٌ':Subject, #4: 4	تَعَالَى وَلِيُّ
u'تَعَالَى يُسْرٌ':Predicate, #1: 1	تَعَالَى وَنِيَّةُ
u'تَعَالَى يَمِينٌ':Subject, #1: 1	تَعَالَى الْيُسْرَ
u'تَعَالَى يَمِينٌ':Subject, #1: 1	تَعَالَى الْيَمِينُ
u'تَعَالَى يَمِينٌ':Subject, #1: 1	تَعَالَى يَمِينٌ
u'تَعَالَى يَوْمٌ':Predicate, #2: 2	تَعَالَى يَمِينُهُ
u'تَعَالَى يَوْمٌ':Subject, #21: 21	تَعَالَى يَوْمَ
u'تَعَالَى يَوْمٌ':Subject, #1: 1	تَعَالَى يَوْمٌ
u'تَعَالَى يَوْمٌ':Subject, #2: 2	تَعَالَى الْيَوْمُ
u'تَعَامُلٌ أُمَّةٌ':Added, #2: 2	تَعَالَى يَوْمُ
u'تَعَامُلٌ أهْلٌ':Added, #1: 1	تَعَامُلِ الْأُمَّةِ
u'تَعَامَلَ نَاسٌ':Subject, #1: 1	تَعَامُلُ أَهْلِ
u'تَعَامُلٌ نَاسٌ':Added, #5: 5	تَعَامَلَ النَّاسُ
u'تَعَاهُدٌ أرْضٌ':Added, #4: 4	تَعَامُلُ النَّاسِ
u'تَعَاهُدٌ خَيْلٌ':Added, #2: 2	تَعَاهُدَ الْأَرْضِ
u'تَعَاهُدٌ عَبْدٌ':Added, #1: 1	تَعَاهُدُ خَيْلٍ
u'تَعَاهُدٌ ولد':Added, #1: 1	تَعَاهُدَ الْعَبْدِ
u'تَعَاهُدٌ وَلَدٌ':Added, #1: 1	تَعَاهُدُ وَلَدِهِ
u'تَعَاوُنٌ اِئْتِلاَفٌ':Added, #1: 1	تَعَاهُدُ وَلَدِهِ
u'تَعَاوُنٌ تَفْضِيلٌ':Added, #1: 1	تَعَاوُنُ ائْتِلَافٍ
u'تَعَبٌ بَدَنٌ':Added, #1: 1	تَعَاوُنُ التَّفْضِيلِ
u'تَعَب بَدَنٌ':Added, #2: 2	تَعَبِ بَدَنٍ
u'تَعَبٌ جِسْمٌ':Added, #2: 2	تَعَبِ بَدَنٍ
u'تَعَب جِسْمٌ':Added, #1: 1	تَعَبِ الْجِسْمِ
u'تَعَبُّدٌ إِلْزَامٌ':Added, #1: 1	تَعَبِ الْجِسْمِ
u'تَعَبُّدٌ أُمَّةٌ':Added, #1: 1	تَعَبُّدُ إلْزَامٍ
u'تَعَبُّدٌ جهل':Added, #1: 1	تَعَبُّدِ الْأُمَّةِ
u'تَعَبُّدٌ جَهْلٌ':Added, #1: 1	تَعَبُّدِ الْجَهْلِ
u'تَعَبٌ دَرْسٌ':Added, #1: 1	تَعَبُّدِ الْجَهْلِ
u'تَعَب دَرْسٌ':Added, #1: 1	تَعَبَ الدَّرْسِ
u'تَعَبَّدَ شَابٌّ':Subject, #1: 1	تَعَبَ الدَّرْسِ
u'تَعَبَّدَ صَنَمٌ':Predicate, #1: 1	تَعَبَّدَ الشَّابُّ
u'تَعَبَّدَ عَابِدٌ':Subject, #1: 1	تَعَبَّدَ الصَّنَمَ
u'تَعَبُّدٌ مَحْضٌ':Added, #1: 1	تَعَبَّدَ عَابِدٌ
u'تَعَبُّدٌ مُكَلَّفٌ':Added, #1: 1	تَعَبُّدٍ مَحْضٍ
u'تَعَبَّدَ نَاطِقٌ':Predicate, #1: 1	تَعَبُّدِ الْمُكَلَّفِ
u'تَعَبٌ سَفَرٌ':Added, #1: 1	تَعَبَّدَ النَّاطِقِينَ
u'تَعَب سَفَرٌ':Added, #1: 1	تَعَبِ السَّفَرِ
u'تَعَبٌ صُعُودٌ':Added, #1: 1	تَعَبِ السَّفَرِ
u'تَعَب صُعُودٌ':Added, #1: 1	تَعَبِ الصُّعُودِ
u'تَعَبٌ صَوْمٌ':Added, #1: 1	تَعَبِ الصُّعُودِ
u'تَعَب صَوْمٌ':Added, #1: 1	تَعَبِ صَوْمِ
u'تَعَبٌ قيام':Added, #1: 1	تَعَبِ صَوْمِ
u'تَعَب قيام':Added, #1: 1	تَعَبِ الْقِيَامِ
u'تَعَبٌ قِيَامٌ':Added, #1: 1	تَعَبِ الْقِيَامِ
u'تَعَب قِيَامٌ':Added, #1: 1	تَعَبِ الْقِيَامِ
u'تَعِبَ كرام':Subject, #1: 1	تَعَبِ الْقِيَامِ
u'تَعَبٌ كَسْبٌ':Added, #1: 1	تَعِبَ الْكِرَامُ
u'تَعَب كَسْبٌ':Added, #2: 2	تَعَبُ الْكَسْبِ
u'تَعَبٌ مَشْيٌ':Added, #2: 2	تَعَبُ الْكَسْبِ
u'تَعَب مَشْيٌ':Added, #1: 1	تَعَبِ الْمَشْيِ
u'تَعَبٌ وَالِدٌ':Added, #1: 1	تَعَبِ الْمَشْيِ
u'تَعَب وَالِدٌ':Added, #1: 1	تَعَبِ الْوَالِدَةِ
u'تَعْبِيرٌ اِبْنٌ':Added, #1: 1	تَعَبِ الْوَالِدَةِ
u'تَعْبِيرٌ اِبْنٌ':Added, #1: 1	تَعْبِيرَ ابْنِ
u'تَعْبِيرٌ اِبْنٌ':Added, #1: 1	تَعْبِيرُ ابْنِ
u'تَعْبِيرٌ أَصْحَابٌ':Added, #1: 1	تَعْبِيرِ ابْنِ
u'تَعْبِيرٌ أصل':Added, #2: 2	تَعْبِيرِ الْأَصْحَابِ
u'تَعْبِيرٌ أًصْلٌ':Added, #116: 116	تَعْبِيرِ أَصْلِهِ
u'تَعْبِيرٌ أصل':Added, #116: 116	تَعْبِيرِ أَصْلِهِ
u'تَعْبِيرٌ أًصْلٌ':Added, #1: 1	تَعْبِيرَ أَصْلِهِ
u'تَعْبِيرٌ أصل':Added, #1: 1	تَعْبِيرَ أَصْلِهِ
u'تَعْبِيرٌ أًصْلٌ':Added, #1: 1	تَعْبِيرَ الْأَصْلِ
u'تَعْبِيرٌ أصل':Added, #1: 1	تَعْبِيرَ الْأَصْلِ
u'تَعْبِيرٌ أًصْلٌ':Added, #21: 21	تَعْبِيرِ الْأَصْلِ
u'تَعْبِيرٌ أصل':Added, #21: 21	تَعْبِيرِ الْأَصْلِ
u'تَعْبِيرٌ أًصْلٌ':Added, #2: 2	تَعْبِيرِ أَصْلِ
u'تَعْبِيرٌ أصل':Added, #2: 2	تَعْبِيرِ أَصْلِ
u'تَعْبِيرٌ أًصْلٌ':Added, #2: 2	تَعْبِيرُ الْأَصْلِ
u'تَعْبِيرٌ أصل':Added, #2: 2	تَعْبِيرُ الْأَصْلِ
u'تَعْبِيرٌ أًصْلٌ':Added, #3: 3	تَعْبِيرُ أَصْلِهِ
u'تَعْبِيرٌ بَعْضٌ':Added, #3: 3	تَعْبِيرُ أَصْلِهِ
u'تَعْبِيرٌ تَنْبِيه':Added, #1: 1	تَعْبِيرُ بَعْضِ
u'تَعْبِيرٌ تَنْبِيه':Added, #1: 1	تَعْبِيرُ التَّنْبِيهِ
u'تَعْبِيرٌ تَوْضِيحٌ':Added, #1: 1	تَعْبِيرِ التَّنْبِيهِ
u'تَعْبِيرٌ جَمَاعَةٌ':Added, #1: 1	تَعْبِيرِ التَّوْضِيحِ
u'تَعْبِيرٌ خَبَرٌ':Added, #1: 1	تَعْبِيرِ جَمَاعَةٍ
u'تَعْبِيرٌ خَبَر':Added, #1: 1	تَعْبِيرُ الْخَبَرِ
u'تَعْبِيرٌ رَوْضَةٌ':Added, #1: 1	تَعْبِيرُ الْخَبَرِ
u'تَعْبِيرٌ رَوْضَةٌ':Added, #13: 13	تَعْبِيرِ الرَّوْضَةِ
u'تَعْبِيرٌ رَوْضَةٌ':Added, #2: 2	تَعْبِيرَ الرَّوْضَةِ
u'تَعْبِيرٌ شافِعِيّ':Added, #2: 2	تَعْبِيرُ الرَّوْضَةِ
u'تَعْبِيرٌ شَرْحٌ':Added, #2: 2	تَعْبِيرُ الشَّافِعِيِّ
u'تَعْبِيرٌ شَيْخٌ':Added, #3: 3	تَعْبِيرِ الشَّرْحِ
u'تَعْبِيرٌ شَيْخٌ':Added, #1: 1	تَعْبِيرِ الشَّيْخِ
u'تَعْبِيرٌ شَيْخٌ':Added, #1: 1	تَعْبِيرُ الشَّيْخَيْنِ
u'تَعْبِيرٌ صَاحِبٌ':Added, #2: 2	تَعْبِيرِ الشَّيْخَيْنِ
u'تَعْبِيرٌ صَاحِبٌ':Added, #2: 2	تَعْبِيرُ صَاحِبِ
u'تَعْبِيرٌ غير':Added, #4: 4	تَعْبِيرِ صَاحِبِ
u'تَعْبِيرٌ غَيْرٌ':Added, #1: 1	تَعْبِيرُ غَيْرِهِ
u'تَعْبِيرٌ غير':Added, #1: 1	تَعْبِيرُ غَيْرِهِ
u'تَعْبِيرٌ غَيْرٌ':Added, #2: 2	تَعْبِيرِ غَيْرِهِ
u'تَعْبِيرٌ فلان':Added, #2: 2	تَعْبِيرِ غَيْرِهِ
u'تَعْبِيرٌ قَفَّالٌ':Added, #2: 2	تَعْبِيرُ الشَّافِعِيِّ
u'تَعْبِيرٌ قول':Added, #1: 1	تَعْبِيرِ الْقَفَّالِ
u'تَعْبِيرٌ قَوْلٌ':Added, #1: 1	تَعْبِيرُ قَوْلِ
u'تَعْبِيرٌ مَجْمَعٌ':Added, #1: 1	تَعْبِيرُ قَوْلِ
u'تَعْبِيرٌ مَجْمُوعٌ':Added, #2: 2	تَعْبِيرِ الْمَجْمَعِ
u'تَعْبِيرٌ مُحَرَّرٌ':Added, #1: 1	تَعْبِيرَ الْمَجْمُوعِ
u'تَعْبِيرٌ مُحَقِّقٌ':Added, #1: 1	تَعْبِيرَ الْمُحَرَّرِ
u'تَعْبِيرٌ مُحَمَّدٌ':Added, #1: 1	تَعْبِيرِ الْمُحَقِّقِ
u'تَعْبِيرٌ مُصَنِّفٌ':Added, #1: 1	تَعْبِيرِ مُحَمَّدٍ
u'تَعْبِيرٌ مُصَنِّفٌ':Added, #17: 17	تَعْبِيرُ الْمُصَنِّفِ
u'تَعْبِيرٌ مُصَنِّفٌ':Added, #20: 20	تَعْبِيرِ الْمُصَنِّفِ
u'تَعْبِيرٌ مُعْتَرِضٌ':Added, #5: 5	تَعْبِيرَ الْمُصَنِّفِ
u'تَعْبِيرٌ مِنْهَاجٌ':Added, #1: 1	تَعْبِيرِ الْمُعْتَرِضِ
u'تَعْبِيرٌ مُؤَلِّفٌ':Added, #1: 1	تَعْبِيرِ الْمِنْهَاجِ
u'تَعْبِيرٌ نِهَايَةٌ':Added, #1: 1	تَعْبِيرِ الْمُؤَلِّفِ
u'تَعْبِيرٌ نَهْرٌ':Added, #1: 1	تَعْبِيرَ النِّهَايَةِ
u'تَعْبِيرٌ هِدَايَةٌ':Added, #1: 1	تَعْبِيرُ النَّهْرِ
u'تَعْبِيرٌ واحد':Added, #4: 4	تَعْبِيرِ الْهِدَايَةِ
u'تَعْبِيرٌ وَاحِدٌ':Added, #1: 1	تَعْبِيرٍ وَاحِدٍ
u'تَعْبِيرٌ وَجِيزٌ':Added, #1: 1	تَعْبِيرٍ وَاحِدٍ
u'تَعْبِيسٌ وَجْهٌ':Added, #1: 1	تَعْبِيرُ الْوَجِيزِ
u'تَعَثَّرَ رَجُلٌ':Subject, #1: 1	تَعْبِيسِ وَجْهٍ
u'تَعَجَّبَ بَعْضٌ':Subject, #1: 1	تَعَثَّرَ رَجُلٌ
u'تَعَجُّبٌ صَاحِبٌ':Added, #1: 1	تَعَجَّبَ بَعْضُ
u'تَعَجَّلَ إِدْرَاكٌ':Subject, #1: 1	تَعَجُّبُ صَاحِبِ
u'تَعَجَّلَ أقَلُّ':Predicate, #1: 1	تَعَجَّلَ إدْرَاكُ
u'تَعَجَّلَ بَعْضٌ':Subject, #1: 1	تَعَجَّلَ الْأَقَلَّ
u'تَعَجَّلَ تَنْفِيذٌ':Subject, #1: 1	تَعَجَّلَ الْبَعْضُ
u'تَعَجَّلَ حَرٌّ':Predicate, #1: 1	تَعَجَّلَ تَنْفِيذُ
u'تَعَجَّلَ سُقُوطٌ':Subject, #1: 1	تَعَجَّلَ الْحَرَّ
u'تَعَجَّلَ طَالِبٌ':Subject, #1: 1	تَعَجَّلَ سُقُوطُ
u'تَعَجَّلَ عتق':Predicate, #1: 1	تَعَجَّلَ الطَّالِبُ
u'تَعَجَّلَ عِتْقٌ':Predicate, #1: 1	تَعَجَّلَ الْعِتْقَ
u'تَعَجَّلَ مُسَاوَاةٌ':Subject, #1: 1	تَعَجَّلَ الْعِتْقَ
u'تَعْدَادٌ أَعْضَاءٌ':Added, #1: 1	تَعَجَّلَ مُسَاوَاةُ
u'تَعْدَادٌ أَفْرَادٌ':Added, #2: 2	تَعْدَادِ الْأَعْضَاءِ
u'تَعْدَادٌ أَلْفَاظٌ':Added, #1: 1	تَعْدَادُ الْأَفْرَادِ
u'تَعْدَادٌ أَوْقَاتٌ':Added, #1: 1	تَعْدَادِ الْأَلْفَاظِ
u'تَعْدَادٌ أَوْلِيَاءُ':Added, #1: 1	تَعْدَادِ أَوْقَاتِ
u'تَعْدَادٌ آيٌ':Added, #1: 1	تَعْدَادِ الْأَوْلِيَاءِ
u'تَعْدَادٌ جمعة':Added, #1: 1	تَعْدَادِ الْآيِ
u'تَعْدَادٌ جُمُعَةٌ':Added, #3: 3	تَعْدَادِ الْجُمُعَةِ
u'تَعْدَادٌ رِقابٌ':Added, #3: 3	تَعْدَادِ الْجُمُعَةِ
u'تَعْدَادٌ شَرَائِطُ':Added, #1: 1	تَعْدَادِ الرِّقَابِ
u'تَعْدَادٌ ضَرُورَةٌ':Added, #2: 2	تَعْدَادِ الشَّرَائِطِ
u'تَعْدَادٌ طُرُقٌ':Added, #1: 1	تَعْدَادُ الضَّرُورَةِ
u'تَعْدَادٌ طُرُقٌ':Added, #1: 1	تَعْدَادِ طُرُقِهِ
u'تَعْدَادٌ غير':Added, #3: 3	تَعْدَادِ الطُّرُقِ
u'تَعْدَادٌ غَيْرٌ':Added, #1: 1	تَعْدَادِ غَيْرِ
u'تَعْدَادٌ كبائر':Added, #1: 1	تَعْدَادِ غَيْرِ
u'تَعْدَادٌ كَفَّارٌ':Added, #3: 3	تَعْدَادِ الْكَبَائِرِ
u'تَعْدَادٌ كَفَّارَةٌ':Added, #1: 1	تَعْدَادِ الْكَفَّارَةِ
u'تَعْدَادٌ مَحَاسِنُ':Added, #1: 1	تَعْدَادِ الْكَفَّارَةِ
u'تَعْدَادٌ مَحَلٌّ':Added, #2: 2	تَعْدَادُ الْمَحَاسِنِ
u'تَعْدَادٌ مَسَائِلُ':Added, #1: 1	تَعْدَادِ مَحَلِّ
u'تَعْدَادٌ مُفْرَدٌ':Added, #1: 1	تَعْدَادِ الْمَسَائِلِ
u'تَعْدَادٌ نِعَمٌ':Added, #1: 1	تَعْدَادِ الْمُفْرَدَاتِ
u'تَعَدُّدٌ أَجْرٌ':Added, #1: 1	تَعْدَادِ النِّعَمِ
u'تَعَدُّدٌ إِخْوَةٌ':Added, #1: 1	تَعَدُّدِ أَجْرِ
u'تَعَدُّدٌ أَزْمِنَةٌ':Added, #1: 1	تَعَدُّدِ الْإِخْوَةِ
u'تَعَدُّدٌ أسْبَابٌ':Added, #1: 1	تَعَدُّدِ الْأَزْمِنَةِ
u'تَعَدُّدٌ أَسْبَابٌ':Added, #1: 1	تَعَدُّدُ أَسْبَابِ
u'تَعَدُّدٌ أسْبَابٌ':Added, #1: 1	تَعَدُّدُ أَسْبَابِ
u'تَعَدُّدٌ أَسْبَابٌ':Added, #1: 1	تَعَدُّدِ أَسْبَابِهِ
u'تَعَدُّدٌ أسْبَابٌ':Added, #1: 1	تَعَدُّدِ أَسْبَابِهِ
u'تَعَدُّدٌ أَسْبَابٌ':Added, #1: 1	تَعَدُّدِ الْأَسْبَابِ
u'تَعَدُّدٌ أُصولٌ':Added, #1: 1	تَعَدُّدِ الْأَسْبَابِ
u'تَعَدُّدٌ إضافَةٌ':Added, #4: 4	تَعَدُّدِ الْأُصُولِ
u'تَعَدُّدٌ إضافَةٌ':Added, #1: 1	تَعَدُّدُ الْإِضَافَاتِ
u'تَعَدُّدٌ أَفْرَادٌ':Added, #1: 1	تَعَدُّدَ الْإِضَافَةِ
u'تَعَدُّدٌ أَقْيِسَةٌ':Added, #1: 1	تَعَدُّدُ الْأَفْرَادِ
u'تَعَدُّدٌ أَلْفَاظٌ':Added, #1: 1	تَعَدُّدِ الْأَقْيِسَةِ
u'تَعَدُّدٌ آلِهَةٌ':Added, #1: 1	تَعَدُّدِ الْأَلْفَاظِ
u'تَعَدُّدٌ أمَارَةٌ':Added, #1: 1	تَعَدُّدُ الْآلِهَةِ
u'تَعَدَّدَ إمَامٌ':Subject, #1: 1	تَعَدُّدُ أَمَارَاتٍ
u'تَعَدَّدَ إمَامٌ':Subject, #1: 1	تَعَدَّدَ الْإِمَامُ
u'تَعَدَّدَ إمَامٌ':Subject, #1: 1	تَعَدَّدَ إمَامٌ
u'تَعَدُّدٌ إمَامٌ':Added, #1: 1	تَعَدَّدَ إمَامُ
u'تَعَدُّدٌ إمَامٌ':Added, #1: 1	تَعَدُّدُ الْإِمَامِ
u'تَعَدَّدَ أَمْرٌ':Subject, #1: 1	تَعَدُّدِ إمَامِ
u'تَعَدُّدٌ أموات':Added, #1: 1	تَعَدَّدَ الْأَمْرُ
u'تَعَدُّدٌ أَوْصَافٌ':Added, #1: 1	تَعَدُّدِ الْأَمْوَاتِ
u'تَعَدُّدٌ أَوْصَافٌ':Added, #1: 1	تَعَدُّدِ الْأَوْصَافِ
u'تَعَدُّدٌ أيَّامٌ':Added, #1: 1	تَعَدُّدُ أَوْصَافٍ
u'تَعَدُّدٌ أَيَّامٌ':Added, #1: 1	تَعَدُّدِ الْأَيَّامِ
u'تَعَدَّدَ إِيجَابٌ':Subject, #1: 1	تَعَدُّدِ الْأَيَّامِ
u'تَعَدَّدَ بَائِعٌ':Subject, #3: 3	تَعَدَّدَ الْإِيجَابُ
u'تَعَدُّدٌ بَائِعٌ':Added, #6: 6	تَعَدَّدَ الْبَائِعُ
u'تَعَدُّدٌ بَائِعٌ':Added, #1: 1	تَعَدُّدَ الْبَائِعِ
u'تَعَدُّدٌ بَائِعٌ':Added, #1: 1	تَعَدُّدِ الْبَائِعِ
u'تَعَدَّدَ بَلَدٌ':Subject, #3: 3	تَعَدُّدُ الْبَائِعِ
u'تَعَدَّدَ بِيَعٌ':Predicate, #1: 1	تَعَدَّدَ الْبَلَدُ
u'تَعَدَّدَ بَيْعٌ':Subject, #1: 1	تَعَدَّدَ بِيعَ
u'تَعَدَّدَ بَيْعٌ':Subject, #1: 1	تَعَدَّدَ بَيْعٌ
u'تَعَدُّدٌ بَيْعٌ':Added, #1: 1	تَعَدَّدَ بَيْعُ
u'تَعَدُّدٌ تَفْرِيقٌ':Added, #1: 1	تَعَدُّدِ الْبَيْعِ
u'تَعَدُّدٌ تِلاوَةٌ':Added, #1: 1	تَعَدُّدُ تَفْرِيقِ
u'تَعَدُّدٌ تَيَمُّمٌ':Added, #1: 1	تَعَدُّدَ التِّلَاوَةِ
u'تَعَدُّدٌ ثَمَنٌ':Added, #1: 1	تَعَدُّدِ التَّيَمُّمِ
u'تَعَدُّدٌ ثَمَنٌ':Added, #1: 1	تَعَدُّدَ الثَّمَنِ
u'تَعَدَّدَ جَزَاءٌ':Subject, #2: 2	تَعَدُّدِ الثَّمَنِ
u'تَعَدُّدٌ جَزَاءٌ':Added, #7: 7	تَعَدَّدَ الْجَزَاءُ
u'تَعَدَّدَ جماع':Subject, #1: 1	تَعَدُّدَ الْجَزَاءِ
u'تَعَدَّدَ جِمَاعٌ':Subject, #1: 1	تَعَدَّدَ الْجِمَاعُ
u'تَعَدُّدٌ جَمَاعَةٌ':Added, #1: 1	تَعَدَّدَ الْجِمَاعُ
u'تَعَدُّدٌ جَمَاعَةٌ':Added, #1: 1	تَعَدُّدُ الْجَمَاعَةِ
u'تَعَدُّدٌ جمعة':Added, #2: 2	تَعَدُّدِ الْجَمَاعَاتِ
u'تَعَدُّدٌ جُمُعَةٌ':Added, #1: 1	تَعَدُّدُ الْجُمُعَةِ
u'تَعَدُّدٌ جمعة':Added, #1: 1	تَعَدُّدُ الْجُمُعَةِ
u'تَعَدُّدٌ جُمُعَةٌ':Added, #4: 4	تَعَدُّدِ الْجُمُعَةِ
u'تَعَدُّدٌ جِنَايَةٌ':Added, #4: 4	تَعَدُّدِ الْجُمُعَةِ
u'تَعَدَّدَ جِنْسٌ':Subject, #1: 1	تَعَدُّدُ الْجِنَايَةِ
u'تَعَدَّدَ جِنْسٌ':Subject, #1: 1	تَعَدَّدَ الْجِنْسُ
u'تَعَدُّدٌ جِهَةٌ':Added, #1: 1	تَعَدَّدَ جِنْسُ
u'تَعَدُّدٌ جِهَةٌ':Added, #1: 1	تَعَدُّدَ الْجِهَاتِ
u'تَعَدُّدٌ جِهَةٌ':Added, #1: 1	تَعَدُّدِ الْجِهَاتِ
u'تَعَدُّدٌ جِهَةٌ':Added, #1: 1	تَعَدُّدَ الْجِهَةِ
u'تَعَدُّدٌ جِهَةٌ':Added, #1: 1	تَعَدُّدِ جِهَاتِ
u'تَعَدُّدٌ حَبْسٌ':Added, #1: 1	تَعَدُّدِ جِهَةِ
u'تَعَدَّدَ حَدٌّ':Subject, #1: 1	تَعَدُّدِ حَبْسِهِ
u'تَعَدُّدٌ حَدٌّ':Added, #3: 3	تَعَدَّدَ الْحَدُّ
u'تَعَدَّدَ حَدَثٌ':Subject, #1: 1	تَعَدُّدِ الْحَدَّيْنِ
u'تَعَدُّدٌ حَدَثٌ':Added, #1: 1	تَعَدَّدَ الْحَدَثُ
u'تَعَدَّدَ حُكْمٌ':Subject, #1: 1	تَعَدُّدِ الْحَدَثِ
u'تَعَدُّدٌ حُكْمٌ':Added, #1: 1	تَعَدَّدَ الْحُكْمُ
u'تَعَدُّدٌ حُكْمٌ':Added, #1: 1	تَعَدُّدَ الْحُكْمِ
u'تَعَدُّدٌ حُكْمٌ':Added, #1: 1	تَعَدُّدِ الْحُكْمِ
u'تَعَدُّدٌ حُكْمٌ':Added, #1: 1	تَعَدُّدُ حُكْمِ
u'تَعَدَّدَ خَاطِبٌ':Subject, #1: 1	تَعَدُّدِ حُكْمِ
u'تَعَدَّدَ دونٌ':Predicate, #1: 1	تَعَدَّدَ الْخَاطِبُ
u'تَعَدَّدَ دَيْنٌ':Subject, #1: 1	تَعَدَّدَ دُونَ
u'تَعَدُّدٌ دَيْنٌ':Added, #1: 1	تَعَدَّدَ الدَّيْنُ
u'تَعَدَّدَ ذكر':Subject, #1: 1	تَعَدُّدَ الدَّيْنِ
u'تَعَدَّدَ ذِكْرٌ':Subject, #1: 1	تَعَدَّدَ ذِكْرُهُ
u'تَعَدَّدَ رَاهِنٌ':Subject, #1: 1	تَعَدَّدَ ذِكْرُهُ
u'تَعَدَّدَ زِقٌّ':Subject, #1: 1	تَعَدَّدَ الرَّاهِنُ
u'تَعَدَّدَ زَوْجٌ':Subject, #1: 1	تَعَدَّدَ الزِّقُّ
u'تَعَدُّدٌ زَوْجَةٌ':Added, #1: 1	تَعَدَّدَ الزَّوْجُ
u'تَعَدُّدٌ زَوْجَةٌ':Added, #1: 1	تَعَدُّدُ الزَّوْجَاتِ
u'تَعَدُّدٌ زَوْجَةٌ':Added, #1: 1	تَعَدُّدِ الزَّوْجَاتِ
u'تَعَدُّدٌ سَاعَةٌ':Added, #1: 1	تَعَدُّدَ الزَّوْجَةِ
u'تَعَدَّدَ سَبَبٌ':Subject, #1: 1	تَعَدُّدُ سَاعَةِ
u'تَعَدَّدَ سَبَبٌ':Subject, #1: 1	تَعَدَّدَ سَبَبُهُ
u'تَعَدُّدٌ سَبَبٌ':Added, #6: 6	تَعَدَّدَ سَبَبُ
u'تَعَدُّدٌ سَبَبٌ':Added, #1: 1	تَعَدُّدُ السَّبَبِ
u'تَعَدُّدٌ سَبَبٌ':Added, #2: 2	تَعَدُّدِ السَّبَبِ
u'تَعَدُّدٌ سُلْطَانٌ':Added, #2: 2	تَعَدُّدِ سَبَبِ
u'تَعَدَّدَ سَهْوٌ':Subject, #2: 2	تَعَدُّدُ السُّلْطَانِ
u'تَعَدُّدٌ سُؤَالٌ':Added, #1: 1	تَعَدَّدَ السَّهْوُ
u'تَعَدُّدٌ سُورَةٌ':Added, #1: 1	تَعَدُّدِ السُّؤَالِ
u'تَعَدُّدٌ شَبَهٌ':Added, #1: 1	تَعَدُّدِ السُّورَةِ
u'تَعَدُّدٌ شُبْهَةٌ':Added, #1: 1	تَعَدُّدِ شَبَهِهِ
u'تَعَدُّدٌ شَخْصٌ':Added, #1: 1	تَعَدُّدِ الشُّبْهَةِ
u'تَعَدُّدٌ شَرْطٌ':Added, #3: 3	تَعَدُّدُ الشَّخْصِ
u'تَعَدُّدٌ شَرْطٌ':Added, #1: 1	تَعَدُّدُ الشَّرْطِ
u'تَعَدُّدٌ شَرْطٌ':Added, #1: 1	تَعَدُّدِ الشَّرْطَيْنِ
u'تَعَدَّدَ شركاء':Subject, #7: 7	تَعَدُّدِ الشَّرْطِ
u'تَعَدَّدَ شَفِيعٌ':Subject, #2: 2	تَعَدَّدَ الشُّرَكَاءُ
u'تَعَدَّدَ شَمِلٌ':Predicate, #1: 1	تَعَدَّدَ الشَّفِيعُ
u'تَعَدَّدَ صَفْقَةٌ':Subject, #1: 1	تَعَدَّدَ شَمِلَ
u'تَعَدُّدٌ صَفْقَةٌ':Added, #1: 1	تَعَدَّدَ الصَّفْقَةُ
u'تَعَدُّدٌ صَفْقَةٌ':Added, #10: 10	تَعَدُّدِ الصَّفْقَةِ
u'تَعَدُّدٌ صَفْقَةٌ':Added, #1: 1	تَعَدُّد الصَّفْقَةِ
u'تَعَدُّدٌ صَفْقَةٌ':Added, #1: 1	تَعَدُّدُ الصَّفْقَةِ
u'تَعَدُّدٌ صُورَةٌ':Added, #4: 4	تَعَدُّدَ الصَّفْقَةِ
u'تَعَدُّدٌ طُرُقٌ':Added, #1: 1	تَعَدُّدَ صُورَةِ
u'تَعَدَّدَ طَلاَقٌ':Subject, #1: 1	تَعَدُّدِ طُرُقِ
u'تَعَدُّدٌ طَلاَقٌ':Added, #1: 1	تَعَدَّدَ الطَّلَاقُ
u'تَعَدُّدٌ طَلاَقٌ':Added, #1: 1	تَعَدُّدَ الطَّلَاقِ
u'تَعَدَّدَ طلب':Subject, #4: 4	تَعَدُّدِ الطَّلَاقِ
u'تَعَدَّدَ طَلَبٌ':Subject, #2: 2	تَعَدَّدَ الطَّلَبُ
u'تَعَدَّدَ عَطْشَان':Subject, #2: 2	تَعَدَّدَ الطَّلَبُ
u'تَعَدَّدَ عَقْدٌ':Subject, #1: 1	تَعَدَّدَ الْعَطْشَانُ
u'تَعَدُّدٌ عَقْدٌ':Added, #4: 4	تَعَدَّدَ الْعَقْدُ
u'تَعَدُّدٌ عَقْدٌ':Added, #1: 1	تَعَدُّدَ الْعَقْدِ
u'تَعَدُّدٌ عَقْدٌ':Added, #1: 1	تَعَدُّدُ الْعَقْدِ
u'تَعَدُّدٌ عَلاَمَةٌ':Added, #2: 2	تَعَدُّدِ الْعَقْدِ
u'تَعَدُّدٌ عِلَّةٌ':Added, #1: 1	تَعَدُّدِ الْعَلَامَاتِ
u'تَعَدُّدٌ عِلَلٌ':Added, #1: 1	تَعَدُّدِ الْعِلَّةِ
u'تَعَدُّدٌ عِلَلٌ':Added, #2: 2	تَعَدُّدَ الْعِلَلِ
u'تَعَدُّدٌ عِلَلٌ':Added, #2: 2	تَعَدُّدُ الْعِلَلِ
u'تَعَدُّدٌ عُيُوبٌ':Added, #6: 6	تَعَدُّدِ الْعِلَلِ
u'تَعَدَّدَ فِدَاءٌ':Subject, #1: 1	تَعَدُّدِ الْعُيُوبِ
u'تَعَدُّدٌ فِدْيَةٌ':Added, #2: 2	تَعَدَّدَ الْفِدَاءُ
u'تَعَدُّدٌ فُرُوعٌ':Added, #1: 1	تَعَدُّدِ الْفِدْيَةِ
u'تَعَدُّدٌ فُصُولٌ':Added, #1: 1	تَعَدُّدِ الْفُرُوعِ
u'تَعَدَّدَ فِعْلٌ':Subject, #1: 1	تَعَدُّدُ الْفُصُولِ
u'تَعَدُّدٌ فِعْلٌ':Added, #2: 2	تَعَدَّدَ الْفِعْلُ
u'تَعَدَّدَ فلان':Subject, #1: 1	تَعَدُّدُ الْفِعْلِ
u'تَعَدَّدَ قَاتِلٌ':Subject, #1: 1	تَعَدَّدَ الْجُبْرَانُ
u'تَعَدَّدَ قتل':Subject, #2: 2	تَعَدَّدَ الْقَاتِلُ
u'تَعَدَّدَ قَتْلٌ':Subject, #1: 1	تَعَدَّدَ قَتْلُهُ
u'تَعَدَّدَ قَتِيلٌ':Subject, #1: 1	تَعَدَّدَ قَتْلُهُ
u'تَعَدُّدٌ قدماء':Added, #2: 2	تَعَدَّدَ الْقَتِيلُ
u'تَعَدَّدَ قِرَاءةٌ':Subject, #1: 1	تَعَدُّدِ الْقُدَمَاءِ
u'تَعَدُّدٌ قِصَّةٌ':Added, #1: 1	تَعَدَّدَ قِرَاءَةُ
u'تَعَدُّدٌ قِصَّةٌ':Added, #1: 1	تَعَدُّدَ الْقِصَّةِ
u'تَعَدَّدَ قضاة':Subject, #3: 3	تَعَدُّدِ الْقِصَّةِ
u'تَعَدُّدٌ قِيَاسٌ':Added, #1: 1	تَعَدَّدَ الْقُضَاةُ
u'تَعَدَّدَ كَسْرٌ':Subject, #1: 1	تَعَدُّدُ الْقِيَاسَيْنِ
u'تَعَدَّدَ كَفَّارٌ':Subject, #1: 1	تَعَدَّدَ الْكَسْرُ
u'تَعَدُّدٌ كَفَّارٌ':Added, #1: 1	تَعَدَّدَ الْكَفَّارَةُ
u'تَعَدُّدٌ كَفَّارٌ':Added, #1: 1	تَعَدُّدَ الْكَفَّارَةِ
u'تَعَدَّدَ كَفَّارَةٌ':Subject, #4: 4	تَعَدُّدِ الْكَفَّارَةِ
u'تَعَدُّدٌ كَفَّارَةٌ':Added, #1: 1	تَعَدَّدَ الْكَفَّارَةُ
u'تَعَدُّدٌ كَفَّارَةٌ':Added, #1: 1	تَعَدُّدَ الْكَفَّارَةِ
u'تَعَدُّدٌ كفلاء':Added, #4: 4	تَعَدُّدِ الْكَفَّارَةِ
u'تَعَدَّدَ كَفِيلٌ':Subject, #1: 1	تَعَدُّدُ الْكُفَلَاءِ
u'تَعَدَّدَ كلاب':Subject, #1: 1	تَعَدَّدَ الْكَفِيلُ
u'تَعَدَّدَ كِلاَبٌ':Subject, #1: 1	تَعَدَّدَ الْكِلَابُ
u'تَعَدُّدٌ كَيْلٌ':Added, #1: 1	تَعَدَّدَ الْكِلَابُ
u'تَعَدَّدَ لبس':Subject, #1: 1	تَعَدُّدُ الْكَيْلِ
u'تَعَدَّدَ لُبْسٌ':Subject, #1: 1	تَعَدَّدَ اللُّبْسُ
u'تَعَدُّدٌ لبس':Added, #1: 1	تَعَدَّدَ اللُّبْسُ
u'تَعَدُّدٌ لُبْسٌ':Added, #3: 3	تَعَدُّدِ اللُّبْسِ
u'تَعَدَّدَ مَالِكٌ':Subject, #3: 3	تَعَدُّدِ اللُّبْسِ
u'تَعَدُّدٌ مَالِكٌ':Added, #2: 2	تَعَدَّدَ مَالِكُ
u'تَعَدَّدَ مُبَاشِرٌ':Subject, #2: 2	تَعَدُّدِ الْمَالِكِ
u'تَعَدَّدَ مَبِيعٌ':Subject, #2: 2	تَعَدَّدَ الْمُبَاشِرُ
u'تَعَدُّدٌ مَبِيعٌ':Added, #2: 2	تَعَدَّدَ الْمَبِيعُ
u'تَعَدُّدٌ مَبِيعٌ':Added, #1: 1	تَعَدُّدُ الْمَبِيعِ
u'تَعَدَّدَ مُتَعَلِّمٌ':Subject, #1: 1	تَعَدُّدِ الْمَبِيعِ
u'تَعَدُّدٌ مَجَازٌ':Added, #1: 1	تَعَدَّدَ الْمُتَعَلِّمُ
u'تَعَدُّدٌ مَجَالِسُ':Added, #1: 1	تَعَدُّدِ الْمَجَازَاتِ
u'تَعَدَّدَ مَجْلِسٌ':Subject, #1: 1	تَعَدُّدُ الْمَجَالِسِ
u'تَعَدَّدَ مَجْلِسٌ':Subject, #1: 1	تَعَدَّدَ مَجْلِسٌ
u'تَعَدُّدٌ مَجْلِسٌ':Added, #6: 6	تَعَدَّدَ الْمَجْلِسُ
u'تَعَدَّدَ مَحَلٌّ':Subject, #1: 1	تَعَدُّدِ الْمَجْلِسِ
u'تَعَدَّدَ مَحَلٌّ':Subject, #1: 1	تَعَدَّدَ مَحَلُّ
u'تَعَدُّدٌ مَحَلٌّ':Added, #5: 5	تَعَدَّدَ الْمَحَلُّ
u'تَعَدَّدَ مُسْتَحَقٌّ':Subject, #2: 2	تَعَدُّدِ الْمَحَلِّ
u'تَعَدَّدَ مُسْتَحِقٌّ':Subject, #1: 1	تَعَدَّدَ الْمُسْتَحَقُّ
u'تَعَدُّدٌ مُسْتَحَقٌّ':Added, #2: 2	تَعَدَّدَ الْمُسْتَحِقُّ
u'تَعَدُّدٌ مُسْتَحِقٌّ':Added, #1: 1	تَعَدُّدِ الْمُسْتَحَقِّ
u'تَعَدُّدٌ مُسْتَقِلٌّ':Added, #1: 1	تَعَدُّدِ الْمُسْتَحِقِّ
u'تَعَدَّدَ مَصِيد':Subject, #1: 1	تَعَدُّدُ مُسْتَقِلٍّ
u'تَعَدُّدٌ مُضْمَرٌ':Added, #2: 2	تَعَدَّدَ مَصِيدُهُ
u'تَعَدُّدٌ مُعْتَقٌ':Added, #1: 1	تَعَدُّدِ الْمُضْمَرِ
u'تَعَدَّدَ مُعَيَّنٌ':Subject, #1: 1	تَعَدُّدُ الْمُعْتَقِ
u'تَعَدَّدَ مَقْتُولٌ':Subject, #1: 1	تَعَدَّدَ الْمُعَيَّنُ
u'تَعَدَّدَ مَكَانٌ':Subject, #1: 1	تَعَدَّدَ مَقْتُولُهُ
u'تَعَدُّدٌ مَلاَئِكَةٌ':Added, #1: 1	تَعَدَّدَ مَكَانُ
u'تَعَدُّدٌ مِلْكٌ':Added, #1: 1	تَعَدُّدُ مَلَائِكَةِ
u'تَعَدُّدٌ مَنْكُوح':Added, #1: 1	تَعَدُّدُ الْمِلْكِ
u'تَعَدُّدٌ مَوَانِعُ':Added, #1: 1	تَعَدُّدِ الْمَنْكُوحَاتِ
u'تَعَدَّدَ مُودِعٌ':Subject, #1: 1	تَعَدُّدُ الْمَوَانِعِ
u'تَعَدُّدٌ مَوْضِعٌ':Added, #1: 1	تَعَدَّدَ الْمُودِعُ
u'تَعَدُّدٌ نذر':Added, #1: 1	تَعَدُّدِ الْمَوْضِعِ
u'تَعَدُّدٌ نَذْرٌ':Added, #1: 1	تَعَدُّدَ النَّذْرِ
u'تَعَدُّدٌ نذر':Added, #1: 1	تَعَدُّدَ النَّذْرِ
u'تَعَدُّدٌ نَذْرٌ':Added, #1: 1	تَعَدُّدِ نَذْرِ
u'تَعَدُّدٌ نصاب':Added, #1: 1	تَعَدُّدِ نَذْرِ
u'تَعَدُّدٌ نِصَابٌ':Added, #1: 1	تَعَدُّدِ النِّصَابِ
u'تَعَدُّدٌ نقلة':Added, #1: 1	تَعَدُّدِ النِّصَابِ
u'تَعَدُّدٌ نَقَلَةٌ':Added, #1: 1	تَعَدُّدُ النَّقَلَةِ
u'تَعَدُّدٌ هَاشِمٌ':Added, #1: 1	تَعَدُّدُ النَّقَلَةِ
u'تَعَدَّدَ وَاجِبٌ':Subject, #1: 1	تَعَدُّدِ الْهَاشِمَةِ
u'تَعَدَّدَ وَارِثٌ':Subject, #5: 5	تَعَدَّدَ الْوَاجِبُ
u'تَعَدُّدٌ وَاقِعٌ':Added, #2: 2	تَعَدَّدَ الْوَارِثُ
u'تَعَدُّدٌ وَاقِعٌ':Added, #1: 1	تَعَدُّدِ الْوَاقِعِ
u'تَعَدُّدٌ وَاقِعٌ':Added, #1: 1	تَعَدُّدُ الْوَاقِعَةِ
u'تَعَدُّدٌ وَاقِعَةٌ':Added, #1: 1	تَعَدُّدِ الْوَاقِعَةِ
u'تَعَدُّدٌ وَاقِعَةٌ':Added, #1: 1	تَعَدُّدُ الْوَاقِعَةِ
u'تَعَدَّدَ وَجْهٌ':Subject, #1: 1	تَعَدُّدِ الْوَاقِعَةِ
u'تَعَدُّدٌ وُجُوبٌ':Added, #1: 1	تَعَدَّدَ وَجْهُ
u'تَعَدُّدٌ وُجُوهٌ':Added, #1: 1	تَعَدُّدُ الْوُجُوبِ
u'تَعَدُّدٌ وُجُوهٌ':Added, #1: 1	تَعَدُّدُ وُجُوهِ
u'تَعَدُّدٌ وَصْفٌ':Added, #2: 2	تَعَدُّدَ الْوُجُوهِ
u'تَعَدَّدَ وَضْعٌ':Subject, #1: 1	تَعَدُّدِ الْوَصْفِ
u'تَعَدُّدٌ وَضْعٌ':Added, #1: 1	تَعَدَّدَ الْوَضْعُ
u'تَعَدُّدٌ وَضْعٌ':Added, #1: 1	تَعَدُّدُ الْوَضْعِ
u'تَعَدُّدٌ وَقْتٌ':Added, #1: 1	تَعَدُّدِ الْوَضْعِ
u'تَعَدُّدٌ يَمِينٌ':Added, #1: 1	تَعَدُّدَ وَقْتِ
u'تَعَدِّي أثَرٌ':Added, #1: 1	تَعَدُّدَ الْيَمِينِ
u'تَعَدَّى أحَدٌ':Subject, #1: 1	تَعَدِّي الْأَثَرِ
u'تَعَدِّي أُمِّيٌّ':Added, #1: 1	تَعَدَّى أَحَدٌ
u'تَعَدِّي أُمِّيَّةٌ':Added, #2: 2	تَعَدِّي أُمِّيَّةِ
u'تَعَدَّى أهْلٌ':Subject, #2: 2	تَعَدِّي أُمِّيَّةِ
u'تَعَدِّي أَوَّلُ':Added, #2: 2	تَعَدَّى أَهْلُ
u'تَعَدِّي بَائِعٌ':Added, #3: 3	تَعَدِّي الْأَوَّلِ
u'تَعَدِّي تَرْكٌ':Added, #3: 3	تَعَدِّي الْبَائِعِ
u'تَعَدَّى حافِرٌ':Subject, #1: 1	تَعَدِّي التَّرْكِ
u'تَعَدِّي حَجْرٌ':Added, #1: 1	تَعَدَّى الْحَافِرُ
u'تَعَدِّي حَدٌّ':Added, #1: 1	تَعَدِّي الْحَجْرِ
u'تَعَدَّى حَديثٌ':Predicate, #1: 1	تَعَدِّي الْحَدِّ
u'تَعَدَّى حَقٌّ':Predicate, #1: 1	تَعَدَّى حَدِيثَ
u'تَعَدَّى حُكْمٌ':Predicate, #1: 1	تَعَدَّى الْحَقَّ
u'تَعَدَّى حُكْمٌ':Subject, #1: 1	تَعَدَّى الْحُكْمَ
u'تَعَدِّي حُكْمٌ':Added, #4: 4	تَعَدَّى الْحُكْمُ
u'تَعَدِّي حُكْمٌ':Added, #1: 1	تَعَدِّي الْحُكْمِ
u'تَعَدِّي حُكْمٌ':Added, #1: 1	تَعَدِّيَ الْحُكْمِ
u'تَعَدِّي حُكْمٌ':Added, #1: 1	تَعَدِّي حُكْمِ
u'تَعَدِّي حَلالٌ':Added, #1: 1	تَعَدِّي حُكْمِهِ
u'تَعَدَّى خَارِجٌ':Subject, #1: 1	تَعَدِّي الْحَلَالِ
u'تَعَدِّي خَلَلٌ':Added, #3: 3	تَعَدَّى الْخَارِجُ
u'تَعَدَّى رُتْبَةٌ':Predicate, #1: 1	تَعَدِّي الْخَلَلِ
u'تَعَدِّي زَوْجٌ':Added, #1: 1	تَعَدَّى رُتْبَةَ
u'تَعَدِّي زَوْجَةٌ':Added, #1: 1	تَعَدِّي الزَّوْجِ
u'تَعَدِّي سُقُوطٌ':Added, #1: 1	تَعَدِّي الزَّوْجَةِ
u'تَعَدَّى شَرِيكٌ':Subject, #1: 1	تَعَدِّي سُقُوطِ
u'تَعَدِّي شَيْءٌ':Added, #1: 1	تَعَدَّى الشَّرِيكُ
u'تَعَدَّى شَيْنٌ':Subject, #1: 1	تَعَدِّي الشَّيْءِ
u'تَعَدِّي صَاحِبٌ':Added, #1: 1	تَعَدَّى شَيْنُ
u'تَعَدِّي صَاحِبٌ':Added, #1: 1	تَعَدِّيَ صَاحِبِ
u'تَعَدَّى صَبِيٌّ':Subject, #1: 1	تَعَدِّيَ صَاحِبِهِ
u'تَعَدِّي صِحَّةٌ':Added, #1: 1	تَعَدَّى الصَّبِيُّ
u'تَعَدَّى ضَرَرٌ':Subject, #1: 1	تَعَدِّي الصِّحَّةِ
u'تَعَدَّى ضَرُورَةٌ':Predicate, #2: 2	تَعَدَّى ضَرَرُ
u'تَعَدَّى ضَمِنٌ':Predicate, #1: 1	تَعَدَّى ضَرُورَةَ
u'تَعَدَّى عَامِلٌ':Subject, #8: 8	تَعَدَّى ضَمِنَ
u'تَعَدَّى عَامِلٌ':Subject, #1: 1	تَعَدَّى الْعَامِلُ
u'تَعَدِّي عَامِلٌ':Added, #1: 1	تَعَدَّى عَامِلٌ
u'تَعَدَّى عَدْلٌ':Subject, #1: 1	تَعَدِّي الْعَامِلِ
u'تَعَدِّي عِلَّةٌ':Added, #1: 1	تَعَدَّى الْعَدْلُ
u'تَعَدِّي عِلَلٌ':Added, #1: 1	تَعَدِّي الْعِلَّةِ
u'تَعَدِّي عِلِّيٌّ':Added, #1: 1	تَعَدِّي الْعِلَلِ
u'تَعَدِّي عِلِّيٌّ':Added, #1: 1	تَعَدِّي عِلِّيَّةِ
u'تَعَدِّي غَاصِبٌ':Added, #1: 1	تَعَدِّي عِلِّيَّتِهِ
u'تَعَدَّى فساد':Subject, #2: 2	تَعَدِّي الْغَاصِبِ
u'تَعَدَّى فَسَادٌ':Subject, #1: 1	تَعَدَّى فَسَادُ
u'تَعَدَّى فساد':Subject, #1: 1	تَعَدَّى فَسَادُ
u'تَعَدَّى فَسَادٌ':Subject, #1: 1	تَعَدَّى فَسَادُهُ
u'تَعَدِّي فساد':Added, #1: 1	تَعَدَّى فَسَادُهُ
u'تَعَدِّي فَسَادٌ':Added, #1: 1	تَعَدِّي الْفَسَادِ
u'تَعَدَّى فِعْلٌ':Subject, #1: 1	تَعَدِّي الْفَسَادِ
u'تَعَدِّي فِعْلٌ':Added, #4: 4	تَعَدَّى الْفِعْلُ
u'تَعَدِّي قَاتِلٌ':Added, #2: 2	تَعَدِّي الْفِعْلِ
u'تَعْدِيلٌ أحَدٌ':Added, #1: 1	تَعَدِّيَ الْقَاتِلِ
u'تَعْدِيلٌ أَرْكانٌ':Added, #1: 1	تَعْدِيلَ أَحَدِ
u'تَعْدِيلٌ أَرْكَانٌ':Added, #2: 2	تَعْدِيلِ الْأَرْكَانِ
u'تَعْدِيلٌ أَرْكانٌ':Added, #2: 2	تَعْدِيلِ الْأَرْكَانِ
u'تَعْدِيلٌ أَرْكَانٌ':Added, #3: 3	تَعْدِيلَ الْأَرْكَانِ
u'تَعْدِيلٌ أَرْكانٌ':Added, #3: 3	تَعْدِيلَ الْأَرْكَانِ
u'تَعْدِيلٌ أَرْكَانٌ':Added, #5: 5	تَعْدِيلُ الْأَرْكَانِ
u'تَعْدِيلٌ أُصولٌ':Added, #5: 5	تَعْدِيلُ الْأَرْكَانِ
u'تَعْدِيلٌ الْمَرْأَةُ':Added, #2: 2	تَعْدِيلِ الْأُصُولِ
u'تَعْدِيلٌ الْمَرْأَةُ':Added, #1: 1	تَعْدِيلَ الْمَرْأَةِ
u'تَعْدِيلٌ الْمَرْأَةُ':Added, #1: 1	تَعْدِيلِ الْمَرْأَةِ
u'تَعْدِيلٌ بِنَاءٌ':Added, #5: 5	تَعْدِيلُ الْمَرْأَةِ
u'تَعْدِيلٌ بَيِّنَةٌ':Added, #1: 1	تَعْدِيلَ الْبِنَاءِ
u'تَعْدِيلٌ بَيِّنَةٌ':Added, #1: 1	تَعْدِيلَ الْبَيِّنَةِ
u'تَعْدِيلٌ بَيِّنَةٌ':Added, #1: 1	تَعْدِيلِ الْبَيِّنَةِ
u'تَعْدِيلٌ حاكِمٌ':Added, #1: 1	تَعْدِيلِ بَيِّنَةٍ
u'تَعْدِيلٌ خَصْمٌ':Added, #1: 1	تَعْدِيلُ الْحَاكِمِ
u'تَعْدِيلٌ خَصْمٌ':Added, #2: 2	تَعْدِيلِ الْخَصْمِ
u'تَعْدِيلٌ سِرٌّ':Added, #5: 5	تَعْدِيلُ الْخَصْمِ
u'تَعْدِيلٌ سِرٌّ':Added, #1: 1	تَعْدِيلِ السِّرِّ
u'تَعْدِيلٌ سهام':Added, #5: 5	تَعْدِيلُ السِّرِّ
u'تَعْدِيلٌ سِهَامٌ':Added, #1: 1	تَعْدِيلُ السِّهَامِ
u'تَعْدِيلٌ سَهْمٌ':Added, #1: 1	تَعْدِيلُ السِّهَامِ
u'تَعْدِيلٌ شَاهِدٌ':Added, #1: 1	تَعْدِيلُ السَّهْمِ
u'تَعْدِيلٌ شَاهِدٌ':Added, #1: 1	تَعْدِيلِ الشَّاهِدِ
u'تَعْدِيلٌ شَاهِدٌ':Added, #1: 1	تَعْدِيلُ شَاهِدٍ
u'تَعْدِيلٌ شَهَادَةٌ':Added, #1: 1	تَعْدِيلِ شَاهِدٍ
u'تَعْدِيلٌ شُهُودٌ':Added, #1: 1	تَعْدِيلُ الشَّهَادَةِ
u'تَعْدِيلٌ شُهُودٌ':Added, #1: 1	تَعْدِيلَ الشُّهُودِ
u'تَعْدِيلٌ شُهُودٌ':Added, #1: 1	تَعْدِيلُ الشُّهُودِ
u'تَعْدِيلٌ شُهُودٌ':Added, #1: 1	تَعْدِيلُ شُهُودِ
u'تَعْدِيلٌ صَاعٌ':Added, #3: 3	تَعْدِيلِ الشُّهُودِ
u'تَعْدِيلٌ صِيَامٌ':Added, #1: 1	تَعْدِيلَ الصَّاعِ
u'تَعْدِيلٌ عَبْدٌ':Added, #1: 1	تَعْدِيلِ صِيَامِ
u'تَعْدِيلٌ عَبْدٌ':Added, #1: 1	تَعْدِيلُ الْعَبْدِ
u'تَعْدِيلٌ عَلاَنِيَةٌ':Added, #1: 1	تَعْدِيلِ عَبْدِ
u'تَعْدِيلٌ عَلاَنِيَةٌ':Added, #2: 2	تَعْدِيلُ الْعَلَانِيَةِ
u'تَعْدِيلٌ عَيْنٌ':Added, #3: 3	تَعْدِيلِ الْعَلَانِيَةِ
u'تَعْدِيلٌ عَيْن':Added, #2: 2	تَعْدِيلَ عَيْنٍ
u'تَعْدِيلٌ غير':Added, #2: 2	تَعْدِيلَ عَيْنٍ
u'تَعْدِيلٌ غَيْرٌ':Added, #4: 4	تَعْدِيلِ غَيْرِهِ
u'تَعْدِيلٌ قِرَاءةٌ':Added, #4: 4	تَعْدِيلِ غَيْرِهِ
u'تَعْدِيلٌ كَاتِبٌ':Added, #1: 1	تَعْدِيلُ الْقِرَاءَةِ
u'تَعْدِيلٌ كَافِرٌ':Added, #1: 1	تَعْدِيلُ الْكَاتِبِ
u'تَعْدِيلٌ كُفَّارٌ':Added, #3: 3	تَعْدِيلَ الْكَافِرِ
u'تَعْدِيلٌ مُدٌّ':Added, #1: 1	تَعْدِيلُ الْكُفَّارِ
u'تَعْدِيلٌ مَصَالِحُ':Added, #1: 1	تَعْدِيلَ مُدَّيْنِ
u'تَعْدِيلٌ نِساءٌ':Added, #1: 1	تَعْدِيلِ الْمَصَالِحِ
u'تَعْدِيلٌ نِسْوانٌ':Added, #2: 2	تَعْدِيلُ النِّسَاءِ
u'تَعْدِيلٌ نَظَرٌ':Added, #1: 1	تَعْدِيلِ النِّسْوَانِ
u'تَعْدِيلٌ نَظَرٌ':Added, #1: 1	تَعْدِيلَ النَّظَرِ
u'تَعْدِيلٌ واحد':Added, #2: 2	تَعْدِيلُ النَّظَرِ
u'تَعْدِيلٌ وَاحِدٌ':Added, #1: 1	تَعْدِيلِ وَاحِدٍ
u'تَعْدِيلٌ وَالِدٌ':Added, #1: 1	تَعْدِيلِ وَاحِدٍ
u'تَعْدِيلٌ وَالِدٌ':Added, #1: 1	تَعْدِيلُ الْوَالِدِ
u'تَعَدَّى مَالِكٌ':Subject, #1: 1	تَعْدِيلُ الْوَالِدَيْنِ
u'تَعَدَّى مُرْتَهِنٌ':Subject, #3: 3	تَعَدَّى الْمَالِكُ
u'تَعَدَّى مُسْتَأْجِرٌ':Subject, #6: 6	تَعَدَّى الْمُرْتَهِنُ
u'تَعَدَّى مُسْتَأْجِرٌ':Subject, #1: 1	تَعَدَّى الْمُسْتَأْجِرُ
u'تَعَدِّي مُسْتَأْجِرٌ':Added, #1: 1	تَعَدَّى مُسْتَأْجِرٌ
u'تَعَدِّي مُسْتَحِقٌّ':Added, #1: 1	تَعَدِّي الْمُسْتَأْجِرِ
u'تَعَدِّي مَسْجِدٌ':Added, #1: 1	تَعَدِّيَ الْمُسْتَحِقِّ
u'تَعَدَّى مُضَارِبٌ':Subject, #1: 1	تَعَدِّي الْمَسْجِدِ
u'تَعَدِّي مُضَارِبٌ':Added, #1: 1	تَعَدَّى الْمُضَارِبُ
u'تَعَدَّى مُودَعٌ':Subject, #1: 1	تَعَدِّي الْمُضَارِبِ
u'تَعَدَّى مِيقَاتٌ':Predicate, #6: 6	تَعَدَّى الْمُودَعُ
u'تَعَدِّي مِيقَاتٌ':Added, #4: 4	تَعَدَّى الْمِيقَاتَ
u'تَعَدِّي مِيقَاتٌ':Added, #1: 1	تَعَدِّي مِيقَاتٍ
u'تَعَدِّي نَاسٌ':Added, #2: 2	تَعَدِّي الْمِيقَاتِ
u'تَعَدَّى نَاظِرٌ':Subject, #1: 1	تَعَدِّي النَّاسِ
u'تَعَدِّي نَائِمٌ':Added, #1: 1	تَعَدَّى النَّاظِرُ
u'تَعَدَّى نَفْعٌ':Subject, #1: 1	تَعَدِّي النَّائِمِ
u'تَعَدِّي نَفْعٌ':Added, #3: 3	تَعَدَّى نَفْعُهُ
u'تَعَدَّى نُكُولٌ':Predicate, #2: 2	تَعَدِّي نَفْعِهِ
u'تَعَدَّى وَاضِعٌ':Subject, #1: 1	تَعَدَّى النُّكُولَ
u'تَعَدِّي وَاضِعٌ':Added, #1: 1	تَعَدَّى الْوَاضِعُ
u'تَعَدَّى وَصِيٌّ':Subject, #1: 1	تَعَدِّي وَاضِعِهِ
u'تَعَدَّى وَكِيلٌ':Subject, #1: 1	تَعَدَّى الْوَصِيُّ
u'تَعَدِّي وَكِيلٌ':Added, #2: 2	تَعَدَّى الْوَكِيلُ
u'تَعَدِّي وُلاَةٌ':Added, #1: 1	تَعَدِّيَ الْوَكِيلِ
u'تَعَذَّرَ إِبْقَاءٌ':Subject, #1: 1	تَعَدِّي الْوُلَاةِ
u'تَعَذُّرٌ إِبِلٌ':Added, #1: 1	تَعَذَّرَ إبْقَاءُ
u'تَعَذَّرَ اِتِّخَاذٌ':Subject, #1: 1	تَعَذُّرِ الْإِبِلِ
u'تَعَذَّرَ إتْمَامٌ':Subject, #1: 1	تَعَذَّرَ اتِّخَاذُ
u'تَعَذُّرٌ إتْمَامٌ':Added, #1: 1	تَعَذَّرَ الْإِتْمَامُ
u'تَعَذَّرَ إِتْيانٌ':Subject, #1: 1	تَعَذُّرُ الْإِتْمَامِ
u'تَعَذَّرَ إِثْبَاتٌ':Subject, #1: 1	تَعَذَّرَ الْإِتْيَانُ
u'تَعَذَّرَ إِثْبَاتٌ':Subject, #1: 1	تَعَذَّرَ إثْبَاتٌ
u'تَعَذَّرَ إِثْبَاتٌ':Subject, #5: 5	تَعَذَّرَ إثْبَاتُ
u'تَعَذُّرٌ إِثْبَاتٌ':Added, #5: 5	تَعَذَّرَ إثْبَاتُهُ
u'تَعَذُّرٌ إِثْبَاتٌ':Added, #1: 1	تَعَذُّرُ إثْبَاتِ
u'تَعَذَّرَ إِحالَةٌ':Subject, #1: 1	تَعَذُّرِ إثْبَاتِهِ
u'تَعَذَّرَ أحَدٌ':Subject, #1: 1	تَعَذَّرَ إحَالَةُ
u'تَعَذَّرَ إحْضَارٌ':Subject, #1: 1	تَعَذَّرَ أَحَدُ
u'تَعَذُّرٌ إحْضَارٌ':Added, #7: 7	تَعَذَّرَ إحْضَارُهُ
u'تَعَذُّرٌ إحْضَارٌ':Added, #1: 1	تَعَذُّرِ إحْضَارِ
u'تَعَذُّرٌ إِخْبَارٌ':Added, #1: 1	تَعَذُّرُ إحْضَارِهِ
u'تَعَذَّرَ أخْذٌ':Subject, #1: 1	تَعَذُّرِ الْإِخْبَارِ
u'تَعَذَّرَ أخْذٌ':Subject, #3: 3	تَعَذَّرَ الْأَخْذُ
u'تَعَذَّرَ أخْذٌ':Subject, #5: 5	تَعَذَّرَ أَخْذُ
u'تَعَذُّرٌ أخْذٌ':Added, #5: 5	تَعَذَّرَ أَخْذُهُ
u'تَعَذُّرٌ أخْذٌ':Added, #1: 1	تَعَذُّرُ أَخْذِ
u'تَعَذُّرٌ أخْذٌ':Added, #1: 1	تَعَذُّرِ أَخْذِهِ
u'تَعَذُّرٌ أخْذٌ':Added, #1: 1	تَعَذُّرِ الْأَخْذِ
u'تَعَذَّرَ إِخْرَاجٌ':Subject, #2: 2	تَعَذُّرِ أَخْذِ
u'تَعَذَّرَ إِخْرَاجٌ':Subject, #2: 2	تَعَذَّرَ إخْرَاجُ
u'تَعَذُّرٌ إِخْرَاجٌ':Added, #3: 3	تَعَذَّرَ إخْرَاجُهُ
u'تَعَذُّرٌ أَدَاءٌ':Added, #1: 1	تَعَذُّرِ إخْرَاجِ
u'تَعَذَّرَ إِذْنٌ':Subject, #2: 2	تَعَذُّرُ أَدَاءِ
u'تَعَذَّرَ إِذْنٌ':Subject, #2: 2	تَعَذَّرَ الْإِذْنُ
u'تَعَذَّرَ إِذْنٌ':Subject, #4: 4	تَعَذَّرَ إذْنُ
u'تَعَذُّرٌ إِذْنٌ':Added, #5: 5	تَعَذَّرَ إذْنُهُ
u'تَعَذُّرٌ إِذْنٌ':Added, #1: 1	تَعَذُّرِ إذْنِ
u'تَعَذَّرَ إِرَادَةٌ':Subject, #2: 2	تَعَذُّرِ إذْنِهِ
u'تَعَذَّرَ إِرْسَالٌ':Subject, #1: 1	تَعَذَّرَ إرَادَةُ
u'تَعَذَّرَ إِزَالَةٌ':Subject, #1: 1	تَعَذَّرَ إرْسَالُهُ
u'تَعَذَّرَ اِسْتِدَامَةٌ':Subject, #1: 1	تَعَذَّرَ إزَالَةُ
u'تَعَذَّرَ اِسْتِرْدَادٌ':Subject, #5: 5	تَعَذَّرَ اسْتِدَامَةُ
u'تَعَذَّرَ اِسْتِعْمالٌ':Subject, #1: 1	تَعَذَّرَ اسْتِرْدَادُهُ
u'تَعَذَّرَ اِسْتِفْسارٌ':Subject, #2: 2	تَعَذَّرَ اسْتِعْمَالُ
u'تَعَذَّرَ اِسْتِفْسارٌ':Subject, #1: 1	تَعَذَّرَ اسْتِفْسَارُ
u'تَعَذَّرَ اِسْتيفاءٌ':Subject, #5: 5	تَعَذَّرَ اسْتِفْسَارُهُ
u'تَعَذُّرٌ اِسْتيفاءٌ':Added, #16: 16	تَعَذَّرَ اسْتِيفَاءُ
u'تَعَذُّرٌ اِسْتيفاءٌ':Added, #3: 3	تَعَذُّرَ اسْتِيفَاءِ
u'تَعَذَّرَ إصابَةٌ':Subject, #3: 3	تَعَذُّرِ اسْتِيفَاءِ
u'تَعَذُّرٌ أصل':Added, #2: 2	تَعَذَّرَ إصَابَةُ
u'تَعَذُّرٌ أًصْلٌ':Added, #1: 1	تَعَذُّرِ الْأَصْلِ
u'تَعَذَّرَ إضافَةٌ':Subject, #1: 1	تَعَذُّرِ الْأَصْلِ
u'تَعَذُّرٌ إضافَةٌ':Added, #4: 4	تَعَذَّرَ إضَافَتُهُ
u'تَعَذَّرَ إِطْعامٌ':Subject, #4: 4	تَعَذُّرِ الْإِضَافَةِ
u'تَعَذَّرَ إِظْهارٌ':Subject, #1: 1	تَعَذَّرَ الْإِطْعَامُ
u'تَعَذَّرَ إِعادَةٌ':Subject, #2: 2	تَعَذَّرَ إظْهَارُهُ
u'تَعَذَّرَ إِعْتاقٌ':Subject, #5: 5	تَعَذَّرَ إعَادَةُ
u'تَعَذَّرَ اِعْتِبارٌ':Subject, #2: 2	تَعَذَّرَ الْإِعْتَاقُ
u'تَعَذَّرَ اِعْتِبارٌ':Subject, #12: 12	تَعَذَّرَ اعْتِبَارُ
u'تَعَذُّرٌ اِعْتِبارٌ':Added, #2: 2	تَعَذَّرَ اعْتِبَارُهُ
u'تَعَذُّرٌ اِعْتِبارٌ':Added, #2: 2	تَعَذُّرِ اعْتِبَارِهِ
u'تَعَذُّرٌ إعْمَالٌ':Added, #3: 3	تَعَذُّرِ اعْتِبَارِ
u'تَعَذَّرَ أغْلَبُ':Subject, #1: 1	تَعَذُّرِ إعْمَالِهِ
u'تَعَذَّرَ إقامَةٌ':Subject, #1: 1	تَعَذَّرَ الْأَغْلَبُ
u'تَعَذَّرَ إقامَةٌ':Subject, #1: 1	تَعَذَّرَ إقَامَةُ
u'تَعَذُّرٌ اِقْتِران':Added, #1: 1	تَعَذَّرَ إقَامَتُهُ
u'تَعَذَّرَ إِكْمَالٌ':Subject, #1: 1	تَعَذُّرِ اقْتِرَانِ
u'تَعَذَّرَ إلْحَاقٌ':Subject, #1: 1	تَعَذَّرَ الْإِكْمَالُ
u'تَعَذَّرَ إلْحَاقٌ':Subject, #1: 1	تَعَذَّرَ إلْحَاقُ
u'تَعَذُّرٌ إلْحَاقٌ':Added, #2: 2	تَعَذَّرَ الْإِلْحَاقُ
u'تَعَذَّرَ إِلْزَامٌ':Subject, #1: 1	تَعَذُّرِ إلْحَاقِ
u'تَعَذَّرَ إمَامٌ':Subject, #1: 1	تَعَذَّرَ إلْزَامُ
u'تَعَذَّرَ أَمْثَلُ':Subject, #2: 2	تَعَذَّرَ الْإِمَامُ
u'تَعَذَّرَ أَمْرٌ':Subject, #1: 1	تَعَذَّرَ الْأَمْثَلُ
u'تَعَذُّرٌ إِمْضاءٌ':Added, #3: 3	تَعَذَّرَ الْأَمْرُ
u'تَعَذَّرَ إِمْكانٌ':Subject, #1: 1	تَعَذُّرِ إمْضَاءِ
u'تَعَذُّرٌ إِمْكانٌ':Added, #1: 1	تَعَذَّرَ الْإِمْكَانُ
u'تَعَذَّرَ اِنْتِفاعٌ':Subject, #2: 2	تَعَذُّرِ إمْكَانِ
u'تَعَذَّرَ إِنْفاقٌ':Subject, #1: 1	تَعَذَّرَ انْتِفَاعُهُ
u'تَعَذَّرَ إِنْفاقٌ':Subject, #1: 1	تَعَذَّرَ إنْفَاقُهُ
u'تَعَذَّرَ أَوَّلِيٌّ':Subject, #2: 2	تَعَذَّرَ الْإِنْفَاقُ
u'تَعَذَّرَ إِيجَابٌ':Subject, #1: 1	تَعَذَّرَ الْأَوَّلِيَّةُ
u'تَعَذَّرَ إِيجَابٌ':Subject, #12: 12	تَعَذَّرَ إيجَابُ
u'تَعَذُّرٌ إِيجَابٌ':Added, #1: 1	تَعَذَّرَ إيجَابُهُ
u'تَعَذُّرٌ إِيجَابٌ':Added, #1: 1	تَعَذُّرُ إيجَابٍ
u'تَعَذُّرٌ إِيجَابٌ':Added, #1: 1	تَعَذُّرُ إيجَابِ
u'تَعَذَّرَ إِيجَارٌ':Subject, #2: 2	تَعَذُّرِ إيجَابِ
u'تَعَذَّرَ بَائِعٌ':Subject, #1: 1	تَعَذَّرَ إيجَارُهُ
u'تَعَذَّرَ بِدَايَةٌ':Subject, #1: 1	تَعَذَّرَ الْبَائِعُ
u'تَعَذَّرَ بَدَلٌ':Subject, #1: 1	تَعَذَّرَ الْبِدَايَةُ
u'تَعَذَّرَ بَدَلٌ':Subject, #1: 1	تَعَذَّرَ الْبَدَلُ
u'تَعَذَّرَ بَعْضٌ':Subject, #1: 1	تَعَذَّرَ بَدَلُهُ
u'تَعَذَّرَ بَعْضٌ':Subject, #1: 1	تَعَذَّرَ الْبَعْضُ
u'تَعَذُّرٌ بَعْضٌ':Added, #1: 1	تَعَذَّرَ بَعْضُهُ
u'تَعَذَّرَ بِنَاءٌ':Subject, #1: 1	تَعَذُّرُ الْبَعْضِ
u'تَعَذَّرَ بَيَانٌ':Subject, #2: 2	تَعَذَّرَ الْبِنَاءُ
u'تَعَذَّرَ بَيْتٌ':Subject, #1: 1	تَعَذَّرَ الْبَيَانُ
u'تَعَذُّرٌ بَيْتٌ':Added, #3: 3	تَعَذَّرَ بَيْتُ
u'تَعَذَّرَ بَيْعٌ':Subject, #1: 1	تَعَذُّرِ بَيْتِ
u'تَعَذَّرَ بَيْعٌ':Subject, #1: 1	تَعَذَّرَ بَيْعٌ
u'تَعَذَّرَ بَيْعٌ':Subject, #2: 2	تَعَذَّرَ بَيْعُهُ
u'تَعَذَّرَ بَيْعٌ':Subject, #3: 3	تَعَذَّرَ الْبَيْعُ
u'تَعَذُّرٌ بَيْعٌ':Added, #5: 5	تَعَذَّرَ بَيْعُ
u'تَعَذَّرَ تَبْلِيغٌ':Subject, #1: 1	تَعَذُّرِ الْبَيْعِ
u'تَعَذَّرَ تَجْوِيزٌ':Subject, #2: 2	تَعَذَّرَ تَبْلِيغُهُ
u'تَعَذَّرَ تَحْصِيلٌ':Subject, #1: 1	تَعَذَّرَ تَجْوِيزُهُ
u'تَعَذَّرَ تَحْصِيلٌ':Subject, #1: 1	تَعَذَّرَ تَحْصِيلُهُ
u'تَعَذَّرَ تَحَلُّلٌ':Subject, #3: 3	تَعَذَّرَ تَحْصِيلُ
u'تَعَذَّرَ تَحَمُّلٌ':Subject, #1: 1	تَعَذَّرَ التَّحَلُّلُ
u'تَعَذَّرَ تَرْجِيحٌ':Subject, #1: 1	تَعَذَّرَ التَّحَمُّلُ
u'تَعَذَّرَ تَرْجِيحٌ':Subject, #1: 1	تَعَذَّرَ التَّرْجِيحُ
u'تَعَذَّرَ تَرْجِيحٌ':Subject, #1: 1	تَعَذَّرَ تَرْجِيحٌ
u'تَعَذَّرَ تَزْوِيجٌ':Subject, #1: 1	تَعَذَّرَ تَرْجِيحُهُ
u'تَعَذَّرَ تَسْلِيمٌ':Subject, #2: 2	تَعَذَّرَ تَزْوِيجٌ
u'تَعَذَّرَ تَسْلِيمٌ':Subject, #3: 3	تَعَذَّرَ التَّسْلِيمُ
u'تَعَذَّرَ تَسْلِيمٌ':Subject, #7: 7	تَعَذَّرَ تَسْلِيمُ
u'تَعَذُّرٌ تَسْلِيمٌ':Added, #8: 8	تَعَذَّرَ تَسْلِيمُهُ
u'تَعَذُّرٌ تَسْلِيمٌ':Added, #1: 1	تَعَذُّرِ التَّسْلِيمِ
u'تَعَذُّرٌ تَسْلِيمٌ':Added, #1: 1	تَعَذُّرِ تَسْلِيمِ
u'تَعَذَّرَ تَسْمِيَة':Subject, #2: 2	تَعَذُّرِ تَسْلِيمِهِ
u'تَعَذَّرَ تَسْوِيَةٌ':Subject, #1: 1	تَعَذَّرَ التَّسْمِيَةُ
u'تَعَذَّرَ تَصْحِيحٌ':Subject, #1: 1	تَعَذَّرَ التَّسْوِيَةُ
u'تَعَذَّرَ تَصْحِيحٌ':Subject, #2: 2	تَعَذَّرَ تَصْحِيحُهُ
u'تَعَذَّرَ تَصَرُّفٌ':Subject, #4: 4	تَعَذَّرَ تَصْحِيحُ
u'تَعَذَّرَ تَصَرُّفٌ':Subject, #1: 1	تَعَذَّرَ تَصَرُّفُ
u'تَعَذَّرَ تَضْمِين':Subject, #1: 1	تَعَذَّرَ تَصَرُّفُهُ
u'تَعَذَّرَ تَطْهِيرٌ':Subject, #4: 4	تَعَذَّرَ التَّضْمِينُ
u'تَعَذُّرٌ تَعَادُلٌ':Added, #1: 1	تَعَذَّرَ تَطْهِيرُهُ
u'تَعَذَّرَ تَعْرِيفٌ':Subject, #1: 1	تَعَذُّرِ تَعَادُلِ
u'تَعَذَّرَ تَعَلُّقٌ':Subject, #3: 3	تَعَذَّرَ التَّعْرِيفُ
u'تَعَذَّرَ تَعْلِيمٌ':Subject, #1: 1	تَعَذَّرَ تَعَلُّقُ
u'تَعَذَّرَ تَعْلِيمٌ':Subject, #2: 2	تَعَذَّرَ تَعْلِيمُهُ
u'تَعَذَّرَ تَعْيِينٌ':Subject, #3: 3	تَعَذَّرَ التَّعْلِيمُ
u'تَعَذَّرَ تَغْسِيلٌ':Subject, #1: 1	تَعَذَّرَ التَّعْيِينُ
u'تَعَذَّرَ تَفاوُت':Subject, #1: 1	تَعَذَّرَ التَّغْسِيلُ
u'تَعَذَّرَ تَفْرِيقٌ':Subject, #1: 1	تَعَذَّرَ التَّفَاوُتُ
u'تَعَذَّرَ تَقابُض':Subject, #1: 1	تَعَذَّرَ التَّفْرِيقُ
u'تَعَذَّرَ تَقْديمٌ':Subject, #1: 1	تَعَذَّرَ التَّقَابُضُ
u'تَعَذَّرَ تَقْديمٌ':Subject, #1: 1	تَعَذَّرَ التَّقْدِيمُ
u'تَعَذَّرَ تَقْويمٌ':Subject, #1: 1	تَعَذَّرَ تَقْدِيمُهُ
u'تَعَذَّرَ تَقْويمٌ':Subject, #1: 1	تَعَذَّرَ التَّقْوِيمُ
u'تَعَذُّرٌ تمام':Added, #1: 1	تَعَذَّرَ تَقْوِيمُهُ
u'تَعَذُّرٌ تَمامٌ':Added, #1: 1	تَعَذُّرِ التَّمَامِ
u'تَعَذَّرَ تَمْر':Subject, #1: 1	تَعَذُّرِ التَّمَامِ
u'تَعَذَّرَ تَمَلُّكٌ':Subject, #1: 1	تَعَذَّرَ التَّمْرُ
u'تَعَذُّرٌ تَمَلُّكٌ':Added, #1: 1	تَعَذَّرَ تَمَلُّكُهُ
u'تَعَذَّرَ تَمْلِيك':Subject, #1: 1	تَعَذُّرِ تَمَلُّكِ
u'تَعَذَّرَ تَمْييزٌ':Subject, #1: 1	تَعَذَّرَ التَّمْلِيكُ
u'تَعَذَّرَ تَمْييزٌ':Subject, #2: 2	تَعَذَّرَ تَمْيِيزُ
u'تَعَذَّرَ تَمْييزٌ':Subject, #4: 4	تَعَذَّرَ تَمْيِيزُهُ
u'تَعَذُّرٌ تَمْييزٌ':Added, #6: 6	تَعَذَّرَ التَّمْيِيزُ
u'تَعَذَّرَ تَنَصُّفٌ':Subject, #1: 1	تَعَذُّرِ التَّمْيِيزِ
u'تَعَذَّرَ تَنْصِيفٌ':Subject, #2: 2	تَعَذَّرَ تَنَصُّفُ
u'تَعَذَّرَ تَنْصِيفٌ':Subject, #1: 1	تَعَذَّرَ تَنْصِيفُ
u'تَعَذَّرَ تَنْفِيذٌ':Subject, #1: 1	تَعَذَّرَ تَنْصِيفُهُ
u'تَعَذَّرَ تَنْفِيذٌ':Subject, #1: 1	تَعَذَّرَ تَنْفِيذُهُ
u'تَعَذَّرَ تَوَثُّقٌ':Subject, #2: 2	تَعَذَّرَ تَنْفِيذُ
u'تَعَذَّرَ تَوْزِيعٌ':Subject, #2: 2	تَعَذَّرَ التَّوَثُّقُ
u'تَعَذُّرٌ تَوْفِيقٌ':Added, #1: 1	تَعَذَّرَ التَّوْزِيعُ
u'تَعَذَّرَ ثُبُوتٌ':Subject, #1: 1	تَعَذُّرِ التَّوْفِيقِ
u'تَعَذُّرٌ ثَمَنٌ':Added, #1: 1	تَعَذَّرَ ثُبُوتُ
u'تَعَذُّرٌ جَابِرٌ':Added, #1: 1	تَعَذُّرِ الثَّمَنِ
u'تَعَذَّرَ جَرٌّ':Subject, #1: 1	تَعَذُّرِ الْجَابِرِ
u'تَعَذُّرٌ جماع':Added, #1: 1	تَعَذَّرَ جَرُّهُ
u'تَعَذُّرٌ جِمَاعٌ':Added, #1: 1	تَعَذُّرُ الْجِمَاعِ
u'تَعَذَّرَ جمع':Subject, #1: 1	تَعَذُّرُ الْجِمَاعِ
u'تَعَذَّرَ جَمْعٌ':Subject, #17: 17	تَعَذَّرَ الْجَمْعُ
u'تَعَذُّرٌ جمع':Added, #17: 17	تَعَذَّرَ الْجَمْعُ
u'تَعَذُّرٌ جَمْعٌ':Added, #2: 2	تَعَذُّرُ الْجَمْعِ
u'تَعَذُّرٌ جمع':Added, #2: 2	تَعَذُّرُ الْجَمْعِ
u'تَعَذُّرٌ جَمْعٌ':Added, #7: 7	تَعَذُّرِ الْجَمْعِ
u'تَعَذُّرٌ جِهَةٌ':Added, #7: 7	تَعَذُّرِ الْجَمْعِ
u'تَعَذَّرَ جَوَابٌ':Subject, #1: 1	تَعَذُّرِ جِهَاتِهِ
u'تَعَذَّرَ حاكِمٌ':Subject, #1: 1	تَعَذَّرَ جَوَابُ
u'تَعَذُّرٌ حالٌ':Added, #1: 1	تَعَذَّرَ الْحَاكِمُ
u'تَعَذَّرَ حَجٌّ':Subject, #1: 1	تَعَذُّرِ الْحَالِ
u'تَعَذُّرٌ حَدٌّ':Added, #1: 1	تَعَذَّرَ الْحَجُّ
u'تَعَذُّرٌ حُرٌّ':Added, #1: 1	تَعَذُّرِ الْحَدِّ
u'تَعَذَّرَ حَرْثٌ':Subject, #1: 1	تَعَذُّرِ الْحُرَّةِ
u'تَعَذَّرَ حُصُول':Subject, #2: 2	تَعَذَّرَ الْحَرْثُ
u'تَعَذَّرَ حُصُول':Subject, #1: 1	تَعَذَّرَ حُصُولُ
u'تَعَذُّرٌ حُصُول':Added, #3: 3	تَعَذَّرَ حُصُولُهُ
u'تَعَذَّرَ حُضورٌ':Subject, #1: 1	تَعَذُّرِ حُصُولِ
u'تَعَذَّرَ حُضُورٌ':Subject, #1: 1	تَعَذَّرَ الْحُضُورُ
u'تَعَذَّرَ حُضورٌ':Subject, #1: 1	تَعَذَّرَ الْحُضُورُ
u'تَعَذَّرَ حُضُورٌ':Subject, #1: 1	تَعَذَّرَ حُضُورُ
u'تَعَذَّرَ حُضورٌ':Subject, #1: 1	تَعَذَّرَ حُضُورُ
u'تَعَذَّرَ حُضُورٌ':Subject, #4: 4	تَعَذَّرَ حُضُورُهُ
u'تَعَذُّرٌ حُضورٌ':Added, #4: 4	تَعَذَّرَ حُضُورُهُ
u'تَعَذُّرٌ حُضُورٌ':Added, #1: 1	تَعَذُّرِ حُضُورِ
u'تَعَذُّرٌ حَفْرٌ':Added, #1: 1	تَعَذُّرِ حُضُورِ
u'تَعَذَّرَ حَقٌّ':Subject, #1: 1	تَعَذُّرِ الْحَفْرِ
u'تَعَذُّرٌ حَقِيقٌ':Added, #2: 2	تَعَذَّرَ الْحَقُّ
u'تَعَذُّرٌ حَقِيقَةٌ':Added, #5: 5	تَعَذُّرِ الْحَقِيقَةِ
u'تَعَذَّرَ حَقِيقِيٌّ':Subject, #5: 5	تَعَذُّرِ الْحَقِيقَةِ
u'تَعَذُّرٌ حَقِيقِيٌّ':Added, #1: 1	تَعَذَّرَ الْحَقِيقِيُّ
u'تَعَذُّرٌ حَقِيقِيٌّ':Added, #1: 1	تَعَذُّرَ الْحَقِيقِيِّ
u'تَعَذَّرَ حُكْمٌ':Subject, #2: 2	تَعَذُّرِ الْحَقِيقِيِّ
u'تَعَذَّرَ حَلْقٌ':Subject, #2: 2	تَعَذَّرَ الْحُكْمُ
u'تَعَذَّرَ حَمْلٌ':Subject, #2: 2	تَعَذَّرَ الْحَلْقُ
u'تَعَذَّرَ حَمْلٌ':Subject, #3: 3	تَعَذَّرَ الْحَمْلُ
u'تَعَذَّرَ حَمْلٌ':Subject, #4: 4	تَعَذَّرَ حَمْلُ
u'تَعَذُّرٌ حَمْلٌ':Added, #7: 7	تَعَذَّرَ حَمْلُهُ
u'تَعَذُّرٌ حَمْلٌ':Added, #1: 1	تَعَذُّرِ الْحَمْلِ
u'تَعَذُّرٌ خاصّ':Added, #2: 2	تَعَذُّرِ حَمْلِهِ
u'تَعَذَّرَ خُرُوجٌ':Subject, #1: 1	تَعَذُّرِ الْخَاصِّ
u'تَعَذَّرَ خُرُوجٌ':Subject, #1: 1	تَعَذَّرَ خُرُوجُهُ
u'تَعَذَّرَ خِطَابٌ':Subject, #4: 4	تَعَذَّرَ الْخُرُوجُ
u'تَعَذَّرَ دفع':Subject, #1: 1	تَعَذَّرَ الْخِطَابُ
u'تَعَذَّرَ دَفْعٌ':Subject, #1: 1	تَعَذَّرَ الدَّفْعُ
u'تَعَذَّرَ دفع':Subject, #1: 1	تَعَذَّرَ الدَّفْعُ
u'تَعَذَّرَ دَفْعٌ':Subject, #1: 1	تَعَذَّرَ دَفْعُهُ
u'تَعَذُّرٌ دفع':Added, #1: 1	تَعَذَّرَ دَفْعُهُ
u'تَعَذُّرٌ دَفْعٌ':Added, #4: 4	تَعَذُّرِ الدَّفْعِ
u'تَعَذَّرَ دَمٌ':Subject, #4: 4	تَعَذُّرِ الدَّفْعِ
u'تَعَذَّرَ ذكر':Predicate, #2: 2	تَعَذَّرَ الدَّمُ
u'تَعَذَّرَ ذَكَرٌ':Predicate, #2: 2	تَعَذَّرَ ذَكَرَ
u'تَعَذَّرَ رَبُّ':Subject, #2: 2	تَعَذَّرَ ذَكَرَ
u'تَعَذَّرَ رُجُوعٌ':Subject, #1: 1	تَعَذَّرَ رَبُّ
u'تَعَذَّرَ رُجُوعٌ':Subject, #1: 1	تَعَذَّرَ رُجُوعُهُ
u'تَعَذُّرٌ رُجُوعٌ':Added, #8: 8	تَعَذَّرَ الرُّجُوعُ
u'تَعَذُّرٌ رُجُوعٌ':Added, #1: 1	تَعَذُّرُ الرُّجُوعِ
u'تَعَذُّرٌ رُجُوعٌ':Added, #1: 1	تَعَذُّرِ الرُّجُوعِ
u'تَعَذَّرَ رَدٌّ':Subject, #3: 3	تَعَذُّرِ رُجُوعِهِ
u'تَعَذَّرَ رَدٌّ':Subject, #12: 12	تَعَذَّرَ رَدُّ
u'تَعَذَّرَ رَدٌّ':Subject, #21: 21	تَعَذَّرَ رَدُّهُ
u'تَعَذُّرٌ رَدٌّ':Added, #29: 29	تَعَذَّرَ الرَّدُّ
u'تَعَذُّرٌ رَدٌّ':Added, #1: 1	تَعَذُّرَ الرَّدِّ
u'تَعَذُّرٌ رَدٌّ':Added, #1: 1	تَعَذُّرُ الرَّدِّ
u'تَعَذُّرٌ رَدٌّ':Added, #3: 3	تَعَذُّرِ رَدِّهِ
u'تَعَذُّرٌ رَدٌّ':Added, #5: 5	تَعَذُّرِ رَدِّ
u'تَعَذَّرَ رِزْقٌ':Subject, #7: 7	تَعَذُّرِ الرَّدِّ
u'تَعَذَّرَ رَفْعٌ':Subject, #1: 1	تَعَذَّرَ رِزْقُ
u'تَعَذَّرَ رُكوعٌ':Subject, #2: 2	تَعَذَّرَ رَفْعُهُ
u'تَعَذَّرَ رَمَلٌ':Subject, #3: 3	تَعَذَّرَ الرُّكُوعُ
u'تَعَذُّرٌ رَمَلٌ':Added, #1: 1	تَعَذَّرَ الرَّمَلُ
u'تَعَذَّرَ رَمْيٌ':Subject, #2: 2	تَعَذُّرِ الرَّمَلِ
u'تَعَذَّرَ رُؤْيَةٌ':Subject, #2: 2	تَعَذَّرَ رَمْيُهُ
u'تَعَذَّرَ سَفَرٌ':Subject, #1: 1	تَعَذَّرَ رُؤْيَةُ
u'تَعَذَّرَ سقط':Predicate, #1: 1	تَعَذَّرَ سَفَرُ
u'تَعَذَّرَ سَقَطٌ':Predicate, #1: 1	تَعَذَّرَ سَقَطَ
u'تَعَذَّرَ سَقْيٌ':Subject, #1: 1	تَعَذَّرَ سَقَطَ
u'تَعَذَّرَ سِنٌّ':Subject, #3: 3	تَعَذَّرَ السَّقْيُ
u'تَعَذَّرَ سُؤَالٌ':Subject, #1: 1	تَعَذَّرَ السِّنُّ
u'تَعَذَّرَ سُؤَالٌ':Subject, #1: 1	تَعَذَّرَ السُّؤَالُ
u'تَعَذَّرَ سُؤَالٌ':Subject, #1: 1	تَعَذَّرَ سُؤَالُهُ
u'تَعَذَّرَ شَاهِدٌ':Subject, #2: 2	تَعَذَّرَ سُؤَالُ
u'تَعَذَّرَ شَرْعِيٌّ':Subject, #1: 1	تَعَذَّرَ شَاهِدٌ
u'تَعَذَّرَ شَقٌّ':Subject, #1: 1	تَعَذَّرَ الشَّرْعِيُّ
u'تَعَذَّرَ شُهُودٌ':Subject, #1: 1	تَعَذَّرَ شَقُّ
u'تَعَذَّرَ شَيْءٌ':Subject, #1: 1	تَعَذَّرَ شُهُودُ
u'تَعَذَّرَ صَرْفٌ':Subject, #2: 2	تَعَذَّرَ شَيْءٌ
u'تَعَذَّرَ صَرْف':Subject, #3: 3	تَعَذَّرَ الصَّرْفُ
u'تَعَذَّرَ صَرْفٌ':Subject, #3: 3	تَعَذَّرَ الصَّرْفُ
u'تَعَذَّرَ صَرْف':Subject, #4: 4	تَعَذَّرَ صَرْفُهُ
u'تَعَذُّرٌ صَرْفٌ':Added, #4: 4	تَعَذَّرَ صَرْفُهُ
u'تَعَذُّرٌ صَرْف':Added, #1: 1	تَعَذُّرِ صَرْفِهِ
u'تَعَذَّرَ صُعُودٌ':Subject, #1: 1	تَعَذُّرِ صَرْفِهِ
u'تَعَذُّرٌ صَفْوٌ':Added, #1: 1	تَعَذَّرَ الصُّعُودُ
u'تَعَذُّرٌ صِلَةٌ':Added, #1: 1	تَعَذُّرِ الصَّفْوِ
u'تَعَذَّرَ صَوْمٌ':Subject, #1: 1	تَعَذُّرُ الصِّلَةِ
u'تَعَذَّرَ صِيَانَةٌ':Subject, #1: 1	تَعَذَّرَ الصَّوْمُ
u'تَعَذَّرَ ضَمَانٌ':Subject, #1: 1	تَعَذَّرَ صِيَانَةُ
u'تَعَذَّرَ ضَمِنٌ':Predicate, #2: 2	تَعَذَّرَ الضَّمَانُ
u'تَعَذَّرَ طَلاَقٌ':Subject, #1: 1	تَعَذَّرَ ضَمِنَ
u'تَعَذَّرَ طلب':Subject, #1: 1	تَعَذَّرَ الطَّلَاقُ
u'تَعَذَّرَ طَلَبٌ':Subject, #2: 2	تَعَذَّرَ طَلَبُهُ
u'تَعَذَّرَ طِينٌ':Subject, #2: 2	تَعَذَّرَ طَلَبُهُ
u'تَعَذُّرٌ ظَرْف':Added, #1: 1	تَعَذَّرَ الطِّينُ
u'تَعَذُّرٌ ظَرْفِيّ':Added, #2: 2	تَعَذُّرِ الظَّرْفِيَّةِ
u'تَعَذَّرَ ظَفَرٌ':Subject, #2: 2	تَعَذُّرِ الظَّرْفِيَّةِ
u'تَعَذَّرَ عتق':Predicate, #1: 1	تَعَذَّرَ الظَّفَرُ
u'تَعَذَّرَ عتق':Subject, #2: 2	تَعَذَّرَ عَتَقَ
u'تَعَذَّرَ عِتْقٌ':Subject, #1: 1	تَعَذَّرَ الْعِتْقُ
u'تَعَذُّرٌ عطف':Added, #1: 1	تَعَذَّرَ الْعِتْقُ
u'تَعَذُّرٌ عَطْفٌ':Added, #2: 2	تَعَذُّرِ الْعَطْفِ
u'تَعَذَّرَ عُقُوبَةٌ':Subject, #2: 2	تَعَذُّرِ الْعَطْفِ
u'تَعَذَّرَ علم':Subject, #1: 1	تَعَذَّرَ الْعُقُوبَةُ
u'تَعَذَّرَ عِلْمٌ':Subject, #1: 1	تَعَذَّرَ الْعِلْمُ
u'تَعَذَّرَ علم':Subject, #1: 1	تَعَذَّرَ الْعِلْمُ
u'تَعَذَّرَ عِلْمٌ':Subject, #6: 6	تَعَذَّرَ عِلْمُهُ
u'تَعَذَّرَ عَمَلٌ':Subject, #6: 6	تَعَذَّرَ عِلْمُهُ
u'تَعَذَّرَ عَمَلٌ':Subject, #16: 16	تَعَذَّرَ الْعَمَلُ
u'تَعَذَّرَ عَمَلٌ':Subject, #1: 1	تَعَذَّرَ عَمَلُ
u'تَعَذُّرٌ عَمَلٌ':Added, #1: 1	تَعَذَّرَ عَمَلُهُ
u'تَعَذُّرٌ عَمَلٌ':Added, #1: 1	تَعَذُّرَ الْعَمَلِ
u'تَعَذُّرٌ عَوْدٌ':Added, #3: 3	تَعَذُّرِ الْعَمَلِ
u'تَعَذُّرٌ غَايَةٌ':Added, #1: 1	تَعَذُّرِ عَوْدِهِ
u'تَعَذَّرَ غَرَزٌ':Predicate, #1: 1	تَعَذُّرِ الْغَايَةِ
u'تَعَذَّرَ غَرْزٌ':Subject, #2: 2	تَعَذَّرَ غَرَزَ
u'تَعَذَّرَ غُرْمٌ':Subject, #1: 1	تَعَذَّرَ غَرْزُ
u'تَعَذَّرَ غُسْلٌ':Subject, #2: 2	تَعَذَّرَ الْغُرْمُ
u'تَعَذَّرَ غَسْلٌ':Subject, #2: 2	تَعَذَّرَ غُسْلُ
u'تَعَذَّرَ غُسْلٌ':Subject, #4: 4	تَعَذَّرَ غَسْلُ
u'تَعَذُّرٌ غَسْلٌ':Added, #6: 6	تَعَذَّرَ غُسْلُهُ
u'تَعَذُّرٌ غُسْلٌ':Added, #1: 1	تَعَذُّرِ غَسْلِ
u'تَعَذُّرٌ فَرْضٌ':Added, #1: 1	تَعَذُّرِ غُسْلِهِ
u'تَعَذَّرَ فَسْخٌ':Subject, #2: 2	تَعَذُّرِ الْفَرْضِ
u'تَعَذَّرَ فَسْخٌ':Subject, #2: 2	تَعَذَّرَ فَسْخُ
u'تَعَذُّرٌ فَسْخٌ':Added, #3: 3	تَعَذَّرَ الْفَسْخُ
u'تَعَذُّرٌ فَسْخٌ':Added, #1: 1	تَعَذُّرُ الْفَسْخِ
u'تَعَذَّرَ فِعْلٌ':Subject, #1: 1	تَعَذُّرِ الْفَسْخِ
u'تَعَذَّرَ فِعْلٌ':Subject, #1: 1	تَعَذَّرَ فِعْلُ
u'تَعَذُّرٌ فِعْلٌ':Added, #4: 4	تَعَذَّرَ فِعْلُهُ
u'تَعَذَّرَ فِكَاكٌ':Subject, #1: 1	تَعَذُّرِ فِعْلِ
u'تَعَذُّرٌ فِكَاكٌ':Added, #2: 2	تَعَذَّرَ الْفِكَاكُ
u'تَعَذَّرَ فلان':Subject, #1: 1	تَعَذُّرِ الْفِكَاكِ
u'تَعَذَّرَ فَهْمٌ':Subject, #1: 1	تَعَذَّرَ الْجُبْرَانُ
u'تَعَذُّرٌ فَهْمٌ':Added, #1: 1	تَعَذَّرَ الْفَهْمُ
u'تَعَذَّرَ قَاسِمٌ':Subject, #1: 1	تَعَذُّرِ فَهْمِهِ
u'تَعَذَّرَ قَالٌ':Predicate, #1: 1	تَعَذَّرَ الْقَاسِمُ
u'تَعَذَّرَ قَبْضٌ':Subject, #2: 2	تَعَذَّرَ قَالَ
u'تَعَذَّرَ قَبْضٌ':Subject, #2: 2	تَعَذَّرَ قَبْضُهُ
u'تَعَذَّرَ قَبْضٌ':Subject, #3: 3	تَعَذَّرَ قَبْضُ
u'تَعَذُّرٌ قَبْضٌ':Added, #5: 5	تَعَذَّرَ الْقَبْضُ
u'تَعَذُّرٌ قَبْضٌ':Added, #1: 1	تَعَذُّرُ قَبْضِ
u'تَعَذُّرٌ قَبُولٌ':Added, #1: 1	تَعَذُّرِ قَبْضِ
u'تَعَذَّرَ قتل':Subject, #1: 1	تَعَذُّرَ قَبُولِهِ
u'تَعَذَّرَ قَتْلٌ':Subject, #1: 1	تَعَذَّرَ الْقَتْلُ
u'تَعَذَّرَ قسمة':Subject, #1: 1	تَعَذَّرَ الْقَتْلُ
u'تَعَذَّرَ قِسْمَةٌ':Subject, #1: 1	تَعَذَّرَ قِسْمَةُ
u'تَعَذُّرٌ قسمة':Added, #1: 1	تَعَذَّرَ قِسْمَةُ
u'تَعَذُّرٌ قسمة':Added, #1: 1	تَعَذُّرُ الْقِسْمَةِ
u'تَعَذُّرٌ قِسْمَةٌ':Added, #1: 1	تَعَذُّرِ الْقِسْمَةِ
u'تَعَذُّرٌ قِسْمَةٌ':Added, #1: 1	تَعَذُّرُ الْقِسْمَةِ
u'تَعَذَّرَ قصاص':Subject, #1: 1	تَعَذُّرِ الْقِسْمَةِ
u'تَعَذَّرَ قِصَاصٌ':Subject, #2: 2	تَعَذَّرَ الْقِصَاصُ
u'تَعَذَّرَ قَضَاءٌ':Subject, #2: 2	تَعَذَّرَ الْقِصَاصُ
u'تَعَذُّرٌ قَضَاءٌ':Added, #13: 13	تَعَذَّرَ الْقَضَاءُ
u'تَعَذَّرَ قَطْعٌ':Subject, #1: 1	تَعَذُّرَ الْقَضَاءِ
u'تَعَذَّرَ قَطْعٌ':Subject, #1: 1	تَعَذَّرَ الْقَطْعُ
u'تَعَذَّرَ قُعُودٌ':Subject, #1: 1	تَعَذَّرَ قَطْعُ
u'تَعَذُّرٌ قُعُودٌ':Added, #2: 2	تَعَذَّرَ الْقُعُودُ
u'تَعَذُّرٌ قِيَاسٌ':Added, #1: 1	تَعَذُّرِ الْقُعُودِ
u'تَعَذُّرٌ كَامِلٌ':Added, #1: 1	تَعَذُّرِ قِيَاسِ
u'تَعَذَّرَ كَسْبٌ':Subject, #1: 1	تَعَذُّرِ الْكَامِلِ
u'تَعَذَّرَ كَسْبٌ':Subject, #1: 1	تَعَذَّرَ الْكَسْبُ
u'تَعَذَّرَ كَشْفٌ':Subject, #1: 1	تَعَذَّرَ كَسْبُهُ
u'تَعَذُّرٌ كَمَالٌ':Added, #1: 1	تَعَذَّرَ كَشْفُهُ
u'تَعَذَّرَ كَوْنٌ':Subject, #1: 1	تَعَذُّرِ كَمَالِ
u'تَعَذَّرَ كَوْنٌ':Subject, #1: 1	تَعَذَّرَ كَوْنُ
u'تَعَذَّرَ لَحْدٌ':Subject, #1: 1	تَعَذَّرَ كَوْنُهُ
u'تَعَذَّرَ لعان':Subject, #2: 2	تَعَذَّرَ اللَّحْدُ
u'تَعَذَّرَ مَاءٌ':Subject, #7: 7	تَعَذَّرَ اللِّعَانُ
u'تَعَذُّرٌ مَاءٌ':Added, #1: 1	تَعَذَّرَ الْمَاءُ
u'تَعَذُّرٌ مَاءٌ':Added, #1: 1	تَعَذُّرِ مَاءِ
u'تَعَذَّرَ مُتَّصِلٌ':Subject, #3: 3	تَعَذُّرِ الْمَاءِ
u'تَعَذَّرَ مثل':Subject, #1: 1	تَعَذَّرَ الْمُتَّصِلُ
u'تَعَذَّرَ مِثْلٌ':Subject, #3: 3	تَعَذَّرَ الْمِثْلُ
u'تَعَذُّرٌ مثل':Added, #3: 3	تَعَذَّرَ الْمِثْلُ
u'تَعَذُّرٌ مِثْلٌ':Added, #2: 2	تَعَذُّرِ الْمِثْلِ
u'تَعَذَّرَ مُجْتَهِد':Subject, #2: 2	تَعَذُّرِ الْمِثْلِ
u'تَعَذَّرَ مُخَاطَبٌ':Subject, #1: 1	تَعَذَّرَ الْمُجْتَهِدُ
u'تَعَذَّرَ مُخَاطَبَةٌ':Subject, #1: 1	تَعَذَّرَ مُخَاطَبَتُهُ
u'تَعَذُّرٌ مَدْلُولٌ':Added, #1: 1	تَعَذَّرَ مُخَاطَبَتُهُ
u'تَعَذُّرٌ مُرَاجَعَةٌ':Added, #1: 1	تَعَذُّر الْمَدْلُولَاتِ
u'تَعَذُّرٌ مُرَاجَعَةٌ':Added, #1: 1	تَعَذُّرِ الْمُرَاجَعَةِ
u'تَعَذُّرٌ مُرَاجَعَةٌ':Added, #1: 1	تَعَذُّرِ مُرَاجَعَةِ
u'تَعَذَّرَ مُرَاعَاةٌ':Subject, #2: 2	تَعَذُّرُ الْمُرَاجَعَةِ
u'تَعَذَّرَ مُشَاهَدٌ':Subject, #1: 1	تَعَذَّرَ مُرَاعَاةُ
u'تَعَذَّرَ مُشَاهَدَةٌ':Subject, #3: 3	تَعَذَّرَ مُشَاهَدَةُ
u'تَعَذَّرَ مَشْيٌ':Subject, #3: 3	تَعَذَّرَ مُشَاهَدَةُ
u'تَعَذَّرَ مُطَالَبٌ':Subject, #4: 4	تَعَذَّرَ الْمَشْيُ
u'تَعَذُّرٌ مُطَالَبٌ':Added, #1: 1	تَعَذَّرَ الْمُطَالَبَةُ
u'تَعَذَّرَ مُطَالَبَةٌ':Subject, #1: 1	تَعَذُّرِ الْمُطَالَبَةِ
u'تَعَذُّرٌ مُطَالَبَةٌ':Added, #1: 1	تَعَذَّرَ الْمُطَالَبَةُ
u'تَعَذَّرَ مَعْرِفَةٌ':Subject, #1: 1	تَعَذُّرِ الْمُطَالَبَةِ
u'تَعَذَّرَ مَعْرِفَة':Subject, #1: 1	تَعَذَّرَ مَعْرِفَتُهُ
u'تَعَذَّرَ مَعْرِفَةٌ':Subject, #1: 1	تَعَذَّرَ مَعْرِفَتُهُ
u'تَعَذَّرَ مَعْرِفَة':Subject, #7: 7	تَعَذَّرَ مَعْرِفَةُ
u'تَعَذُّرٌ مَعْرِفَةٌ':Added, #7: 7	تَعَذَّرَ مَعْرِفَةُ
u'تَعَذُّرٌ مَعْرِفَةٌ':Added, #1: 1	تَعَذُّرَ مَعْرِفَةِ
u'تَعَذُّرٌ مَعْرِفَة':Added, #1: 1	تَعَذُّرُ مَعْرِفَةِ
u'تَعَذُّرٌ مَعْرِفَة':Added, #1: 1	تَعَذُّرَ مَعْرِفَةِ
u'تَعَذَّرَ مَقَامٌ':Subject, #1: 1	تَعَذُّرُ مَعْرِفَةِ
u'تَعَذُّرٌ مَقْصُودٌ':Added, #1: 1	تَعَذَّرَ الْمَقَامُ
u'تَعَذَّرَ مِلْكٌ':Subject, #1: 1	تَعَذُّرُ الْمَقْصُودِ
u'تَعَذَّرَ مَنْعٌ':Subject, #1: 1	تَعَذَّرَ مِلْكُ
u'تَعَذَّرَ مُوجِبٌ':Subject, #1: 1	تَعَذَّرَ مَنْعُهُ
u'تَعَذَّرَ نُزُولٌ':Subject, #1: 1	تَعَذَّرَ مُوجِبُ
u'تَعَذُّرٌ نُزُولٌ':Added, #1: 1	تَعَذَّرَ النُّزُولُ
u'تَعَذَّرَ نصب':Subject, #1: 1	تَعَذُّرِ النُّزُولِ
u'تَعَذَّرَ نَصْبٌ':Subject, #1: 1	تَعَذَّرَ النَّصْبُ
u'تَعَذَّرَ نُطْقٌ':Subject, #1: 1	تَعَذَّرَ النَّصْبُ
u'تَعَذَّرَ نُطْقٌ':Subject, #1: 1	تَعَذَّرَ النُّطْقُ
u'تَعَذُّرٌ نَفْسٌ':Added, #1: 1	تَعَذَّرَ نُطْقُهُ
u'تَعَذُّرٌ نَفَقَةٌ':Added, #1: 1	تَعَذُّرِ النَّفْسِ
u'تَعَذُّرٌ نَفَقَةٌ':Added, #1: 1	تَعَذُّرَ النَّفَقَةِ
u'تَعَذَّرَ نَفْيٌ':Subject, #1: 1	تَعَذُّرِ النَّفَقَةِ
u'تَعَذَّرَ نَفْيٌ':Subject, #1: 1	تَعَذَّرَ النَّفْيُ
u'تَعَذَّرَ نقل':Subject, #2: 2	تَعَذَّرَ نَفْيُ
u'تَعَذَّرَ نَقْلٌ':Subject, #1: 1	تَعَذَّرَ النَّقْلُ
u'تَعَذَّرَ نقل':Subject, #1: 1	تَعَذَّرَ النَّقْلُ
u'تَعَذَّرَ نَقْلٌ':Subject, #3: 3	تَعَذَّرَ نَقْلُهُ
u'تَعَذُّرٌ وَاجِبٌ':Added, #3: 3	تَعَذَّرَ نَقْلُهُ
u'تَعَذَّرَ وُجُوبٌ':Subject, #2: 2	تَعَذُّرِ الْوَاجِبِ
u'تَعَذَّرَ وُجُودٌ':Subject, #1: 1	تَعَذَّرَ وُجُوبُهُ
u'تَعَذَّرَ وُجُودٌ':Subject, #1: 1	تَعَذَّرَ وُجُودُ
u'تَعَذُّرٌ وُجُودٌ':Added, #1: 1	تَعَذَّرَ وُجُودُهُ
u'تَعَذَّرَ وصال':Subject, #1: 1	تَعَذُّرِ وُجُودِ
u'تَعَذَّرَ وِصَالٌ':Subject, #1: 1	تَعَذَّرَ الْوِصَالُ
u'تَعَذُّرٌ وصلة':Added, #1: 1	تَعَذَّرَ الْوِصَالُ
u'تَعَذَّرَ وُصُولٌ':Subject, #1: 1	تَعَذُّرِ الْوَصْلَةِ
u'تَعَذَّرَ وُصُولٌ':Subject, #10: 10	تَعَذَّرَ الْوُصُولُ
u'تَعَذَّرَ وُصُولٌ':Subject, #2: 2	تَعَذَّرَ وُصُولُ
u'تَعَذُّرٌ وُصُولٌ':Added, #3: 3	تَعَذَّرَ وُصُولُهُ
u'تَعَذُّرٌ وُصُولٌ':Added, #1: 1	تَعَذُّرَ الْوُصُولِ
u'تَعَذَّرَ وَضْعٌ':Subject, #1: 1	تَعَذُّرِ وُصُولِ
u'تَعَذَّرَ وُضُوءٌ':Subject, #1: 1	تَعَذَّرَ وَضْعُ
u'تَعَذَّرَ وَطْءٌ':Subject, #1: 1	تَعَذَّرَ الْوُضُوءُ
u'تَعَذَّرَ وَطْءٌ':Subject, #3: 3	تَعَذَّرَ وَطْءُ
u'تَعَذَّرَ وَفَاءٌ':Subject, #4: 4	تَعَذَّرَ الْوَطْءُ
u'تَعَذَّرَ وَقْفٌ':Subject, #1: 1	تَعَذَّرَ الْوَفَاءُ
u'تَعَذَّرَ وُقُوعٌ':Subject, #3: 3	تَعَذَّرَ الْوَقْفُ
u'تَعَذَّرَ وُقُوفٌ':Subject, #1: 1	تَعَذَّرَ وُقُوعُ
u'تَعَذُّرٌ وُقُوفٌ':Added, #8: 8	تَعَذَّرَ الْوُقُوفُ
u'تَعَذَّرَ وَكِيلٌ':Subject, #4: 4	تَعَذُّرِ الْوُقُوفِ
u'تَعَذُّرٌ وِلاَيَةٌ':Added, #1: 1	تَعَذَّرَ الْوَكِيلُ
u'تَعَذُّرٌ وَلِيٌّ':Added, #1: 1	تَعَذُّرِ الْوِلَايَةِ
u'تَعَذَّرَ يَمِينٌ':Subject, #1: 1	تَعَذُّرُ وَلِيٍّ
u'تَعَرَّضَ أحَدٌ':Subject, #1: 1	تَعَذَّرَ يَمِينٌ
u'تَعَرُّضٌ أَصْحَابٌ':Added, #2: 2	تَعَرَّضَ أَحَدٌ
u'تَعَرَّضَ بُخَارِيٌّ':Subject, #1: 1	تَعَرُّضَ الْأَصْحَابِ
u'تَعَرُّضٌ بَرِّيٌّ':Added, #1: 1	تَعَرَّضَ الْبُخَارِيُّ
u'تَعَرَّضَ بَعْضٌ':Subject, #2: 2	تَعَرُّضُ بَرِّيٍّ
u'تَعَرُّضٌ بَعْضٌ':Added, #1: 1	تَعَرَّضَ بَعْضُ
u'تَعَرَّضَ جَمَاعَةٌ':Subject, #1: 1	تَعَرُّضَ بَعْضِ
u'تَعَرَّضَ حاكِمٌ':Subject, #1: 1	تَعَرَّضَ جَمَاعَةٌ
u'تَعَرُّضٌ حَواسٌّ':Added, #1: 1	تَعَرَّضَ الْحَاكِمُ
u'تَعَرُّضٌ حَوَاسُّ':Added, #1: 1	تَعَرُّضَ الْحَوَاسِّ
u'تَعَرُّضٌ دَليلٌ':Added, #1: 1	تَعَرُّضَ الْحَوَاسِّ
u'تَعَرَّضَ رَبُّ':Subject, #1: 1	تَعَرُّضِ الدَّلِيلِ
u'تَعَرُّضٌ سَبْرٌ':Added, #1: 1	تَعَرَّضَ رَبُّ
u'تَعَرَّضَ شافِعِيّ':Subject, #1: 1	تَعَرُّضِ السَّبْرِ
u'تَعَرُّضٌ شَاهِدٌ':Added, #2: 2	تَعَرَّضَ الشَّافِعِيُّ
u'تَعَرَّضَ شُهُودٌ':Subject, #1: 1	تَعَرُّضَ الشَّاهِدِ
u'تَعَرُّضٌ شَيْطَانٌ':Added, #1: 1	تَعَرَّضَ الشُّهُودُ
u'تَعَرُّضٌ صَيْدٌ':Added, #1: 1	تَعَرُّضِ الشَّيْطَانِ
u'تَعَرُّضٌ عَقْلٌ':Added, #1: 1	تَعَرُّضَ الصَّيْدِ
u'تَعَرَّضَ عِلْجٌ':Subject, #1: 1	تَعَرُّضِ الْعَقْلِ
u'تَعَرُّضٌ غير':Added, #1: 1	تَعَرَّضَ الْعِلْجُ
u'تَعَرُّضٌ غَيْرٌ':Added, #1: 1	تَعَرُّضَ الْغَيْرِ
u'تَعَرُّضٌ غير':Added, #1: 1	تَعَرُّضَ الْغَيْرِ
u'تَعَرُّضٌ غَيْرٌ':Added, #2: 2	تَعَرُّضِ غَيْرِهِ
u'تَعَرَّضَ فلان':Subject, #2: 2	تَعَرُّضِ غَيْرِهِ
u'تَعَرَّضَ قَوْمٌ':Subject, #2: 2	تَعَرَّضَ الشَّافِعِيُّ
u'تَعَرَّضَ مُصَنِّفٌ':Subject, #1: 1	تَعَرَّضَ قَوْمٌ
u'تَعَرُّضٌ مُصَنِّفٌ':Added, #3: 3	تَعَرَّضَ الْمُصَنِّفُ
u'تَعَرُّضٌ مُصَنِّفٌ':Added, #1: 1	تَعَرُّضُ الْمُصَنِّفِ
u'تَعَرُّضٌ مُعْظَمٌ':Added, #1: 1	تَعَرُّضِ الْمُصَنِّفِ
u'تَعَرُّضٌ مُلُوكٌ':Added, #1: 1	تَعَرُّضِ الْمُعْظَمِ
u'تَعَرُّضٌ نُصُوصٌ':Added, #1: 1	تَعَرُّضِ الْمُلُوكِ
u'تَعَرَّضَ نَوَوِيٌّ':Subject, #1: 1	تَعَرُّضِ النُّصُوصِ
u'تَعَرُّفٌ بَراءةٌ':Added, #1: 1	تَعَرَّضَ النَّوَوِيُّ
u'تَعَرُّفٌ بَراءةٌ':Added, #1: 1	تَعَرُّفُ الْبَرَاءَةِ
u'تَعَرُّفٌ بَراءةٌ':Added, #1: 1	تَعَرُّفِ الْبَرَاءَةِ
u'تَعَرُّفٌ حالٌ':Added, #2: 2	تَعَرُّفُ بَرَاءَةِ
u'تَعَرَّفَ حَدٌّ':Subject, #1: 1	تَعَرُّفِ حَالِهِ
u'تَعَرُّفٌ حُكْمٌ':Added, #1: 1	تَعَرَّفَ حَدُّ
u'تَعَرُّفٌ حُكْمٌ':Added, #1: 1	تَعَرُّفُ الْحُكْمِ
u'تَعَرُّفٌ حُكْمٌ':Added, #1: 1	تَعَرُّفُ حُكْمِ
u'تَعَرُّفٌ شَاةٌ':Added, #1: 1	تَعَرُّفِ حُكْمِ
u'تَعَرُّفٌ صَوَابٌ':Added, #1: 1	تَعَرُّفَ الشَّاةِ
u'تَعَرُّفٌ فراغ':Added, #1: 1	تَعَرُّفُ الصَّوَابِ
u'تَعَرُّفٌ فَرَاغٌ':Added, #1: 1	تَعَرُّفُ الْفَرَاغِ
u'تَعَرُّفٌ قِبْلَةٌ':Added, #1: 1	تَعَرُّفُ الْفَرَاغِ
u'تَعَرُّفٌ قِيمَةٌ':Added, #2: 2	تَعَرُّفِ الْقِبْلَةِ
u'تَعَرَّى أَوَّلُ':Predicate, #1: 1	تَعَرُّفِ الْقِيمَةِ
u'تَعْرِيبٌ عَجَمِيٌّ':Added, #1: 1	تَعَرَّى أَوَّلَ
u'تَعْرِيضٌ اِسْمٌ':Added, #1: 1	تَعْرِيبُ الْعَجَمِيِّ
u'تَعْرِيضٌ جُزْءٌ':Added, #1: 1	تَعْرِيضَ اسْمِ
u'تَعْرِيضٌ جُزْءٌ':Added, #1: 1	تَعْرِيضُ الْجُزْءِ
u'تَعْرِيضٌ جماع':Added, #2: 2	تَعْرِيضِ الْجُزْءِ
u'تَعْرِيضٌ جِمَاعٌ':Added, #1: 1	تَعْرِيضِ الْجِمَاعِ
u'تَعْرِيضٌ حَدٌّ':Added, #1: 1	تَعْرِيضِ الْجِمَاعِ
u'تَعْرِيضٌ حَيَوَانٌ':Added, #1: 1	تَعْرِيضَ الْحَدِّ
u'تَعْرِيضٌ حَيَوَانٌ':Added, #1: 1	تَعْرِيضُ الْحَيَوَانِ
u'تَعْرِيضٌ شَيْءٌ':Added, #2: 2	تَعْرِيضَ الْحَيَوَانِ
u'تَعْرِيضٌ صَوْمٌ':Added, #1: 1	تَعْرِيضُ شَيْءٍ
u'تَعْرِيضٌ صَيْدٌ':Added, #7: 7	تَعْرِيضِ الصَّوْمِ
u'تَعْرِيضٌ فَوَاتٌ':Added, #1: 1	تَعْرِيضَ الصَّيْدِ
u'تَعْرِيضٌ نِساءٌ':Added, #1: 1	تَعْرِيضُ الْفَوَاتِ
u'تَعْرِيضٌ نُطْفَةٌ':Added, #1: 1	تَعْرِيضَ النِّسَاءِ
u'تَعْرِيضٌ ولد':Added, #1: 1	تَعْرِيضِ نُطْفَتِهِ
u'تَعْرِيضٌ وَلَدٌ':Added, #1: 1	تَعْرِيضِ الْوَلَدِ
u'تَعْرِيضٌ ولد':Added, #1: 1	تَعْرِيضِ الْوَلَدِ
u'تَعْرِيضٌ وَلَدٌ':Added, #1: 1	تَعْرِيضُ وَلَدِهِ
u'تَعْرِيضٌ ولد':Added, #1: 1	تَعْرِيضُ وَلَدِهِ
u'تَعْرِيضٌ وَلَدٌ':Added, #2: 2	تَعْرِيضَ وَلَدِهِ
u'تَعْرِيفٌ إبَاحَةٌ':Added, #2: 2	تَعْرِيضَ وَلَدِهِ
u'تَعْرِيفٌ اِبْنٌ':Added, #1: 1	تَعْرِيفُ الْإِبَاحَةِ
u'تَعْرِيفَاتٌ قِيَاسٌ':Added, #2: 2	تَعْرِيفُ ابْنِ
u'تَعْرِيفٌ أَجِيرٌ':Added, #1: 1	تَعْرِيفَاتِ الْقِيَاسِ
u'تَعْرِيفٌ أَجِيرٌ':Added, #1: 1	تَعْرِيفِ الْأَجِيرِ
u'تَعْرِيفٌ أحَدٌ':Added, #2: 2	تَعْرِيفُ الْأَجِيرِ
u'تَعْرِيفٌ أَحْكَامٌ':Added, #1: 1	تَعْرِيفِ أَحَدِ
u'تَعْرِيفٌ إِحْيَاءٌ':Added, #2: 2	تَعْرِيفُ الْأَحْكَامِ
u'تَعْرِيفٌ أَدَاءٌ':Added, #1: 1	تَعْرِيفَ الْإِحْيَاءِ
u'تَعْرِيفٌ أرْضٌ':Added, #1: 1	تَعْرِيفَ الْأَدَاءِ
u'تَعْرِيفٌ اِسْمٌ':Added, #1: 1	تَعْرِيفُ الْأَرْضِ
u'تَعْرِيفٌ أَسْماءٌ':Added, #1: 1	تَعْرِيفَ اسْمِ
u'تَعْرِيفٌ أُصولٌ':Added, #1: 1	تَعْرِيفُ أَسْمَاءِ
u'تَعْرِيفٌ أُصولٌ':Added, #1: 1	تَعْرِيفُ أُصُولِ
u'تَعْرِيفٌ أُصولٌ':Added, #1: 1	تَعْرِيفِ أُصُولِ
u'تَعْرِيفٌ أُصولٌ':Added, #1: 1	تَعْرِيفُ الْأُصُولِ
u'تَعْرِيفٌ إِعادَةٌ':Added, #3: 3	تَعْرِيفِ الْأُصُولِ
u'تَعْرِيفٌ أَعْمَالٌ':Added, #1: 1	تَعْرِيفِ الْإِعَادَةِ
u'تَعْرِيفٌ إمَامٌ':Added, #1: 1	تَعْرِيفِ الْأَعْمَالِ
u'تَعْرِيفٌ إمَامٌ':Added, #1: 1	تَعْرِيفَ الْإِمَامِ
u'تَعْرِيفٌ إمَامَةٌ':Added, #1: 1	تَعْرِيفِ الْإِمَامِ
u'تَعْرِيفٌ أَوَّلُ':Added, #1: 1	تَعْرِيفِ إمَامَةِ
u'تَعْرِيفٌ بَعْضٌ':Added, #1: 1	تَعْرِيفُ الْأَوَّلِ
u'تَعْرِيفٌ بَقِيَّةٌ':Added, #1: 1	تَعْرِيفَ بَعْضِ
u'تَعْرِيفٌ بَيَانٌ':Added, #2: 2	تَعْرِيفَ بَقِيَّةِ
u'تَعْرِيفٌ بَيْعٌ':Added, #1: 1	تَعْرِيفُ الْبَيَانِ
u'تَعْرِيفٌ بَيْعٌ':Added, #1: 1	تَعْرِيفِ الْبَيْعِ
u'تَعْرِيفَةٌ قِيَاسٌ':Added, #2: 2	تَعْرِيفَ الْبَيْعِ
u'تَعْرِيفٌ تَخْصِيصٌ':Added, #1: 1	تَعْرِيفَاتِ الْقِيَاسِ
u'تَعْرِيفٌ تَخْصِيصٌ':Added, #1: 1	تَعْرِيفُ التَّخْصِيصِ
u'تَعْرِيفٌ تَدْلِيس':Added, #2: 2	تَعْرِيفِ التَّخْصِيصِ
u'تَعْرِيفٌ تَرْجِيحٌ':Added, #1: 1	تَعْرِيفِ التَّدْلِيسِ
u'تَعْرِيفٌ تَوْلِيَةٌ':Added, #1: 1	تَعْرِيفِ التَّرْجِيحِ
u'تَعْرِيفٌ ثَلاثُ':Added, #1: 1	تَعْرِيفَ التَّوْلِيَةِ
u'تَعْرِيفٌ جَمَاعَةٌ':Added, #1: 1	تَعْرِيفِ الثَّلَاثِ
u'تَعْرِيفٌ جَمِيع':Added, #1: 1	تَعْرِيفِ جَمَاعَةٍ
u'تَعْرِيفٌ جِنَايَةٌ':Added, #1: 1	تَعْرِيفُ الْجَمِيعِ
u'تَعْرِيفٌ جِنْسٌ':Added, #1: 1	تَعْرِيفِ الْجِنَايَةِ
u'تَعْرِيفٌ جِنْسٌ':Added, #1: 1	تَعْرِيفُ الْجِنْسِ
u'تَعْرِيفٌ جِنْسٌ':Added, #1: 1	تَعْرِيفِ الْجِنْسِ
u'تَعْرِيفٌ جِنْسٌ':Added, #1: 1	تَعْرِيفَ جِنْسٍ
u'تَعْرِيفٌ حاضِرٌ':Added, #6: 6	تَعْرِيفَ الْجِنْسِ
u'تَعْرِيفٌ حاكِمٌ':Added, #1: 1	تَعْرِيفَ الْحَاضِرِ
u'تَعْرِيفٌ حَدٌّ':Added, #1: 1	تَعْرِيفُ الْحَاكِمِ
u'تَعْرِيفٌ حَسَنٌ':Added, #1: 1	تَعْرِيفِ حَدِّ
u'تَعْرِيفٌ حُضورٌ':Added, #1: 1	تَعْرِيفِ الْحَسَنِ
u'تَعْرِيفٌ حُضُورٌ':Added, #1: 1	تَعْرِيفَ الْحُضُورِ
u'تَعْرِيفٌ حَقِيقٌ':Added, #1: 1	تَعْرِيفَ الْحُضُورِ
u'تَعْرِيفٌ حَقِيقٌ':Added, #2: 2	تَعْرِيفَ الْحَقِيقَةِ
u'تَعْرِيفٌ حَقِيقٌ':Added, #3: 3	تَعْرِيفُ الْحَقِيقَةِ
u'تَعْرِيفٌ حَقِيقَةٌ':Added, #3: 3	تَعْرِيفِ الْحَقِيقَةِ
u'تَعْرِيفٌ حَقِيقَةٌ':Added, #2: 2	تَعْرِيفَ الْحَقِيقَةِ
u'تَعْرِيفٌ حَقِيقَةٌ':Added, #3: 3	تَعْرِيفُ الْحَقِيقَةِ
u'تَعْرِيفٌ حَقِيقِيٌّ':Added, #3: 3	تَعْرِيفِ الْحَقِيقَةِ
u'تَعْرِيفٌ حَقِيقِيٌّ':Added, #1: 1	تَعْرِيفَ الْحَقِيقِيِّ
u'تَعْرِيفٌ حُكْمٌ':Added, #1: 1	تَعْرِيفُ الْحَقِيقِيِّ
u'تَعْرِيفٌ حُكْمٌ':Added, #1: 1	تَعْرِيفَ الْحُكْمِ
u'تَعْرِيفٌ حُكْمٌ':Added, #1: 1	تَعْرِيفِ حُكْمِ
u'تَعْرِيفٌ حُكْمٌ':Added, #4: 4	تَعْرِيفُ الْحُكْمِ
u'تَعْرِيفٌ حَنَفِيَّةٌ':Added, #8: 8	تَعْرِيفِ الْحُكْمِ
u'تَعْرِيفٌ حَيْضٌ':Added, #1: 1	تَعْرِيفُ الْحَنَفِيَّةِ
u'تَعْرِيفٌ خاصّ':Added, #1: 1	تَعْرِيفِ الْحَيْضِ
u'تَعْرِيفٌ خاصّ':Added, #1: 1	تَعْرِيفُ الْخَاصِّ
u'تَعْرِيفٌ خَبَرٌ':Added, #1: 1	تَعْرِيفِ الْخَاصِّ
u'تَعْرِيفٌ خَبَر':Added, #1: 1	تَعْرِيفَ الْخَبَرِ
u'تَعْرِيفٌ خَبَرٌ':Added, #1: 1	تَعْرِيفَ الْخَبَرِ
u'تَعْرِيفٌ خَبَر':Added, #2: 2	تَعْرِيفُ الْخَبَرِ
u'تَعْرِيفٌ خَرِبٌ':Added, #2: 2	تَعْرِيفُ الْخَبَرِ
u'تَعْرِيفٌ خَصْمٌ':Added, #2: 2	تَعْرِيفِ الْخَرِبَةِ
u'تَعْرِيفٌ دَليلٌ':Added, #1: 1	تَعْرِيفُ خَصْمِ
u'تَعْرِيفٌ دَليلٌ':Added, #1: 1	تَعْرِيفَ الدَّلِيلِ
u'تَعْرِيفٌ دُيونٌ':Added, #1: 1	تَعْرِيفِ الدَّلِيلِ
u'تَعْرِيفٌ رُخْصَةٌ':Added, #1: 1	تَعْرِيفِ الدُّيُونِ
u'تَعْرِيفٌ رضاع':Added, #1: 1	تَعْرِيفُ الرُّخْصَةِ
u'تَعْرِيفٌ زَكاةٌ':Added, #1: 1	تَعْرِيفِ الرَّضَاعِ
u'تَعْرِيفٌ سَامِعٌ':Added, #1: 1	تَعْرِيفِ الزَّكَاةِ
u'تَعْرِيفٌ سَائِمَةٌ':Added, #1: 1	تَعْرِيفُ السَّامِعِ
u'تَعْرِيفٌ سَبَبٌ':Added, #1: 1	تَعْرِيفِ السَّائِمَةِ
u'تَعْرِيفٌ سَبَبٌ':Added, #1: 1	تَعْرِيفُ السَّبَبِ
u'تَعْرِيفٌ سَفَرٌ':Added, #2: 2	تَعْرِيفِ السَّبَبِ
u'تَعْرِيفٌ سلام':Added, #1: 1	تَعْرِيفِ السَّفَرِ
u'تَعْرِيفٌ سَلاَمٌ':Added, #1: 1	تَعْرِيفُ السَّلَامِ
u'تَعْرِيفٌ سلام':Added, #1: 1	تَعْرِيفُ السَّلَامِ
u'تَعْرِيفٌ سَلاَمٌ':Added, #1: 1	تَعْرِيفِ سَلَامِ
u'تَعْرِيفٌ سُنَّةٌ':Added, #1: 1	تَعْرِيفِ سَلَامِ
u'تَعْرِيفٌ سُنَّةٌ':Added, #1: 1	تَعْرِيفَ السُّنَّةِ
u'تَعْرِيفٌ سَنَةٌ':Added, #1: 1	تَعْرِيفُ السُّنَّةِ
u'تَعْرِيفٌ سَنَةٌ':Added, #1: 1	تَعْرِيفُ سَنَةٍ
u'تَعْرِيفٌ سِياسَةٌ':Added, #1: 1	تَعْرِيفِ سَنَةٍ
u'تَعْرِيفٌ شَارِعٌ':Added, #2: 2	تَعْرِيفَ السِّيَاسَةِ
u'تَعْرِيفٌ شَاهِدٌ':Added, #1: 1	تَعْرِيفِ الشَّارِعِ
u'تَعْرِيفٌ شَخْصٌ':Added, #1: 1	تَعْرِيفُ الشَّاهِدِ
u'تَعْرِيفٌ شَخْصٌ':Added, #1: 1	تَعْرِيفِ الشَّخْصِ
u'تَعْرِيفٌ شَرْطٌ':Added, #1: 1	تَعْرِيفُ شَخْصٍ
u'تَعْرِيفٌ شفعة':Added, #1: 1	تَعْرِيفَ الشَّرْطِ
u'تَعْرِيفٌ شُفْعَةٌ':Added, #1: 1	تَعْرِيفِ الشُّفْعَةِ
u'تَعْرِيفٌ شَكٌّ':Added, #1: 1	تَعْرِيفِ الشُّفْعَةِ
u'تَعْرِيفٌ شَيْءٌ':Added, #1: 1	تَعْرِيفُ الشَّكِّ
u'تَعْرِيفٌ صَاحِبٌ':Added, #3: 3	تَعْرِيفُ الشَّيْءِ
u'تَعْرِيفٌ صَحَابِيٌّ':Added, #1: 1	تَعْرِيفُ صَاحِبِ
u'تَعْرِيفٌ صِحَّةٌ':Added, #1: 1	تَعْرِيفِ الصَّحَابِيِّ
u'تَعْرِيفٌ صَدْرٌ':Added, #1: 1	تَعْرِيفِ الصِّحَّةِ
u'تَعْرِيفٌ صَدَقَةٌ':Added, #1: 1	تَعْرِيفِ صَدْرِ
u'تَعْرِيفٌ صَرِيحٌ':Added, #1: 1	تَعْرِيفُ الصَّدَقَاتِ
u'تَعْرِيفٌ صَرِيحٌ':Added, #1: 1	تَعْرِيفُ الصَّرِيحِ
u'تَعْرِيفٌ صَوْمٌ':Added, #2: 2	تَعْرِيفِ الصَّرِيحِ
u'تَعْرِيفٌ ضَالٌّ':Added, #1: 1	تَعْرِيفِ الصَّوْمِ
u'تَعْرِيفٌ طُرُقٌ':Added, #1: 1	تَعْرِيفِ الضَّالَّةِ
u'تَعْرِيفٌ ظاهِرٌ':Added, #1: 1	تَعْرِيفَ طُرُقِ
u'تَعْرِيفٌ ظُلَّةٌ':Added, #1: 1	تَعْرِيفِ الظَّاهِرِ
u'تَعْرِيفٌ عَاصِبٌ':Added, #1: 1	تَعْرِيفِ الظُّلَّةِ
u'تَعْرِيفٌ عَامٌّ':Added, #1: 1	تَعْرِيفِ الْعَاصِبِ
u'تَعْرِيفٌ عَامٌّ':Added, #1: 1	تَعْرِيفُ الْعَامِّ
u'تَعْرِيفٌ عِبَارَةٌ':Added, #7: 7	تَعْرِيفِ الْعَامِّ
u'تَعْرِيفٌ عَبَثٌ':Added, #1: 1	تَعْرِيفِ الْعِبَارَةِ
u'تَعْرِيفٌ عَبْدٌ':Added, #1: 1	تَعْرِيفِ الْعَبَثِ
u'تَعْرِيفٌ عَدَالَةٌ':Added, #1: 1	تَعْرِيفُ الْعَبْدِ
u'تَعْرِيفٌ عَدْلٌ':Added, #1: 1	تَعْرِيفُ الْعَدَالَةِ
u'تَعْرِيفٌ عرفاء':Added, #1: 1	تَعْرِيفُ عَدْلَيْنِ
u'تَعْرِيفٌ عَقْلٌ':Added, #1: 1	تَعْرِيفِ الْعُرَفَاءِ
u'تَعْرِيفٌ عَقْلٌ':Added, #1: 1	تَعْرِيفُ الْعَقْلِ
u'تَعْرِيفٌ علم':Added, #1: 1	تَعْرِيفِ الْعَقْلِ
u'تَعْرِيفٌ عِلْمٌ':Added, #1: 1	تَعْرِيفَ الْعِلْمِ
u'تَعْرِيفٌ علم':Added, #1: 1	تَعْرِيفَ الْعِلْمِ
u'تَعْرِيفٌ علم':Added, #1: 1	تَعْرِيفِ عِلْمٍ
u'تَعْرِيفٌ عِلْمٌ':Added, #1: 1	تَعْرِيفِ عِلْمِ
u'تَعْرِيفٌ عِلْمٌ':Added, #1: 1	تَعْرِيفِ عِلْمٍ
u'تَعْرِيفٌ علم':Added, #1: 1	تَعْرِيفِ عِلْمِ
u'تَعْرِيفٌ عِلْمٌ':Added, #2: 2	تَعْرِيفِ الْعِلْمِ
u'تَعْرِيفٌ عَهْدٌ':Added, #2: 2	تَعْرِيفِ الْعِلْمِ
u'تَعْرِيفٌ عَهْدٌ':Added, #1: 1	تَعْرِيفَ الْعَهْدِ
u'تَعْرِيفٌ عَهْدٌ':Added, #1: 1	تَعْرِيفُ الْعَهْدِ
u'تَعْرِيفٌ عين':Added, #4: 4	تَعْرِيفِ الْعَهْدِ
u'تَعْرِيفٌ عَيْنٌ':Added, #1: 1	تَعْرِيفَ عَيْنِ
u'تَعْرِيفٌ عَيْن':Added, #1: 1	تَعْرِيفَ عَيْنِ
u'تَعْرِيفٌ غير':Added, #1: 1	تَعْرِيفَ عَيْنِ
u'تَعْرِيفٌ غَيْرٌ':Added, #1: 1	تَعْرِيفُ غَيْرِهِ
u'تَعْرِيفٌ فَاسِدٌ':Added, #1: 1	تَعْرِيفُ غَيْرِهِ
u'تَعْرِيفٌ فُضُولِيٌّ':Added, #1: 1	تَعْرِيفِ الْفَاسِدَةِ
u'تَعْرِيفٌ فِقْهٌ':Added, #1: 1	تَعْرِيفِ الْفُضُولِيِّ
u'تَعْرِيفٌ فلان':Added, #2: 2	تَعْرِيفَ الْفِقْهِ
u'تَعْرِيفٌ فِنَاءٌ':Added, #1: 1	تَعْرِيفُ الدَّانِقِ
u'تَعْرِيفٌ قَدْرٌ':Added, #1: 1	تَعْرِيفُ الْفِنَاءِ
u'تَعْرِيفٌ قُرْآنٌ':Added, #1: 1	تَعْرِيفُ قَدْرِ
u'تَعْرِيفٌ قِيَاسٌ':Added, #1: 1	تَعْرِيفُ الْقُرْآنِ
u'تَعْرِيفٌ كَبِيرٌ':Added, #5: 5	تَعْرِيفِ الْقِيَاسِ
u'تَعْرِيفٌ كَبِيرٌ':Added, #1: 1	تَعْرِيفُ الْكَبِيرَةِ
u'تَعْرِيفٌ كذب':Added, #4: 4	تَعْرِيفِ الْكَبِيرَةِ
u'تَعْرِيفٌ كَذِبٌ':Added, #1: 1	تَعْرِيفُ الْكَذِبِ
u'تَعْرِيفٌ كَفَالَةٌ':Added, #1: 1	تَعْرِيفُ الْكَذِبِ
u'تَعْرِيفٌ كَفَالَةٌ':Added, #1: 1	تَعْرِيفَ الْكَفَالَةِ
u'تَعْرِيفٌ كَلاَمٌ':Added, #1: 1	تَعْرِيفِ الْكَفَالَةِ
u'تَعْرِيفٌ لُغَةٌ':Added, #2: 2	تَعْرِيفِ الْكَلَامِ
u'تَعْرِيفٌ لقطة':Added, #1: 1	تَعْرِيفِ اللُّغَةِ
u'تَعْرِيفٌ لقطة':Added, #1: 1	تَعْرِيفِ لُقَطَةٍ
u'تَعْرِيفٌ لقطة':Added, #1: 1	تَعْرِيفِ لُقَطَتِهِ
u'تَعْرِيفٌ لَقِيطٌ':Added, #5: 5	تَعْرِيفِ اللُّقَطَةِ
u'تَعْرِيفٌ مَاءٌ':Added, #1: 1	تَعْرِيفُ اللَّقِيطِ
u'تَعْرِيفٌ مَالٌ':Added, #1: 1	تَعْرِيفِ الْمَاءِ
u'تَعْرِيفٌ مَانِعٌ':Added, #1: 1	تَعْرِيفَ الْمَالِ
u'تَعْرِيفٌ مُبْتَدَأٌ':Added, #1: 1	تَعْرِيفِ الْمَانِعِ
u'تَعْرِيفٌ مُتَّصِلٌ':Added, #1: 1	تَعْرِيفِ الْمُبْتَدَأِ
u'تَعْرِيفٌ مُتَّفَقٌ':Added, #1: 1	تَعْرِيفَ الْمُتَّصِلِ
u'تَعْرِيفٌ مِثْقَالٌ':Added, #1: 1	تَعْرِيفَ الْمُتَّفَقِ
u'تَعْرِيفٌ مِثْلٌ':Added, #1: 1	تَعْرِيفُ الْمِثْقَالِ
u'تَعْرِيفٌ مُثَلَّثٌ':Added, #1: 1	تَعْرِيفُ الْمِثْلَيْنِ
u'تَعْرِيفٌ مَجَازٌ':Added, #1: 1	تَعْرِيفُ الْمُثَلَّثِ
u'تَعْرِيفٌ مَجَازٌ':Added, #1: 1	تَعْرِيفَ الْمَجَازِ
u'تَعْرِيفٌ مُجْمَلٌ':Added, #1: 1	تَعْرِيفُ الْمَجَازِ
u'تَعْرِيفٌ مُخْتَصَرٌ':Added, #1: 1	تَعْرِيفُ الْمُجْمَلِ
u'تَعْرِيفٌ مُخَصَّصٌ':Added, #1: 1	تَعْرِيفَ الْمُخْتَصَرِ
u'تَعْرِيفٌ مُدَّةٌ':Added, #1: 1	تَعْرِيفُ الْمُخَصَّصِ
u'تَعْرِيفٌ مُرابَحَة':Added, #1: 1	تَعْرِيفِ الْمُدَّةِ
u'تَعْرِيفٌ مُرَكَّبٌ':Added, #1: 1	تَعْرِيفِ الْمُرَابَحَةِ
u'تَعْرِيفٌ مَسْبُوق':Added, #1: 1	تَعْرِيفُ الْمُرَكَّبِ
u'تَعْرِيفٌ مُسْتَفِيضٌ':Added, #1: 1	تَعْرِيفِ الْمَسْبُوقِ
u'تَعْرِيفٌ مَشَايِخُ':Added, #1: 1	تَعْرِيفُ الْمُسْتَفِيضِ
u'تَعْرِيفٌ مُشْتَرَكٌ':Added, #1: 1	تَعْرِيفُ الْمَشَايِخِ
u'تَعْرِيفٌ مُشْتَرَكٌ':Added, #1: 1	تَعْرِيفُ الْمُشْتَرَكِ
u'تَعْرِيفٌ مَصَالِحُ':Added, #1: 1	تَعْرِيفِ الْمُشْتَرَكِ
u'تَعْرِيفٌ مَصْدَرٌ':Added, #1: 1	تَعْرِيفُ الْمَصَالِحِ
u'تَعْرِيفٌ مُصَنِّفٌ':Added, #1: 1	تَعْرِيفَ الْمَصْدَرِ
u'تَعْرِيفٌ مُصَنِّفٌ':Added, #2: 2	تَعْرِيفَ الْمُصَنِّفِ
u'تَعْرِيفٌ مُصَنِّفٌ':Added, #2: 2	تَعْرِيفُ الْمُصَنِّفِ
u'تَعْرِيفٌ مُضْطَرٌّ':Added, #3: 3	تَعْرِيفِ الْمُصَنِّفِ
u'تَعْرِيفٌ مُطْلَقٌ':Added, #1: 1	تَعْرِيفُ الْمُضْطَرِّ
u'تَعْرِيفٌ مُطْلَقٌ':Added, #1: 1	تَعْرِيفُ مُطْلَقِ
u'تَعْرِيفٌ مَعْذُورٌ':Added, #1: 1	تَعْرِيفِ مُطْلَقِ
u'تَعْرِيفٌ مُعَرَّفٌ':Added, #1: 1	تَعْرِيفُ الْمَعْذُورِ
u'تَعْرِيفٌ مُعَرَّفٌ':Added, #1: 1	تَعْرِيفِ الْمُعَرَّفِ
u'تَعْرِيفٌ مَعْرِفَةٌ':Added, #4: 4	تَعْرِيفُ الْمُعَرَّفِ
u'تَعْرِيفٌ مَعْرِفَة':Added, #1: 1	تَعْرِيفَ الْمَعْرِفَةِ
u'تَعْرِيفٌ مُعَيَّنٌ':Added, #1: 1	تَعْرِيفَ الْمَعْرِفَةِ
u'تَعْرِيفٌ مُفْرَدٌ':Added, #1: 1	تَعْرِيفُ مُعَيَّنٍ
u'تَعْرِيفٌ مُفْرَدٌ':Added, #1: 1	تَعْرِيفُ الْمُفْرَدِ
u'تَعْرِيفٌ مَفْهُومٌ':Added, #1: 1	تَعْرِيفِ الْمُفْرَدِ
u'تَعْرِيفٌ مَمْلُوكٌ':Added, #3: 3	تَعْرِيفُ مَفْهُومِ
u'تَعْرِيفٌ مَمْلُوكٌ':Added, #1: 1	تَعْرِيفَ الْمَمْلُوكِ
u'تَعْرِيفٌ مُنازَلَة':Added, #1: 1	تَعْرِيفِ الْمَمْلُوكِ
u'تَعْرِيفٌ مَوَاتٌ':Added, #1: 1	تَعْرِيفُ الْمُنَازَلَةِ
u'تَعْرِيفٌ مَوْتٌ':Added, #1: 1	تَعْرِيفُ الْمَوَاتِ
u'تَعْرِيفٌ نَاسٌ':Added, #2: 2	تَعْرِيفُ الْمَوْتِ
u'تَعْرِيفٌ نَاشِزٌ':Added, #1: 1	تَعْرِيفِ النَّاسِ
u'تَعْرِيفٌ نذر':Added, #1: 1	تَعْرِيفُ النَّاشِزَةِ
u'تَعْرِيفٌ نَذْرٌ':Added, #1: 1	تَعْرِيفِ النَّذْرِ
u'تَعْرِيفٌ نَظَرٌ':Added, #1: 1	تَعْرِيفِ النَّذْرِ
u'تَعْرِيفٌ نَفْسٌ':Added, #1: 1	تَعْرِيفِ النَّظَرِ
u'تَعْرِيفٌ نَفْسَانِيٌّ':Added, #1: 1	تَعْرِيفِ نَفْسِ
u'تَعْرِيفٌ نقل':Added, #1: 1	تَعْرِيفُ النَّفْسَانِيِّ
u'تَعْرِيفٌ نَقْلٌ':Added, #2: 2	تَعْرِيفِ النَّقْلِ
u'تَعْرِيفٌ نَهْيٌ':Added, #2: 2	تَعْرِيفِ النَّقْلِ
u'تَعْرِيفٌ هَدْيٌ':Added, #1: 1	تَعْرِيفِ النَّهْيِ
u'تَعْرِيفٌ واحد':Added, #1: 1	تَعْرِيفُ الْهَدْيِ
u'تَعْرِيفٌ واحد':Added, #1: 1	تَعْرِيفٍ وَاحِدٍ
u'تَعْرِيفٌ وَاحِدٌ':Added, #1: 1	تَعْرِيفِ وَاحِدٍ
u'تَعْرِيفٌ وَاحِدٌ':Added, #1: 1	تَعْرِيفٍ وَاحِدٍ
u'تَعْرِيفٌ وُجُوبٌ':Added, #1: 1	تَعْرِيفِ وَاحِدٍ
u'تَعْزِيَةٌ أهْلٌ':Added, #1: 1	تَعْرِيفِ الْوُجُوبِ
u'تَعْزِيَةٌ أهْلٌ':Added, #2: 2	تَعْزِيَةُ أَهْلِ
u'تَعْزِيَةٌ خضر':Added, #2: 2	تَعْزِيَةِ أَهْلِ
u'تَعْزِيَةٌ خَضِرٌ':Added, #1: 1	تَعْزِيَةِ الْخَضِرِ
u'تَعْزِيَةٌ ذِمِّيٌّ':Added, #1: 1	تَعْزِيَةِ الْخَضِرِ
u'تَعْزِيَةٌ ذِمِّيٌّ':Added, #1: 1	تَعْزِيَةُ الذِّمِّيِّ
u'تَعْزِيَةٌ ذِمِّيٌّ':Added, #1: 1	تَعْزِيَةِ الذِّمِّيِّ
u'تَعْزِيَةٌ رَسُولٌ':Added, #1: 1	تَعْزِيَةِ ذِمِّيٍّ
u'تَعْزِيَةٌ سَيِّدٌ':Added, #2: 2	تَعْزِيَةُ رَسُولِ
u'تَعْزِيَةٌ شَابٌّ':Added, #1: 1	تَعْزِيَةِ السَّيِّدِ
u'تَعْزِيَةٌ كَافِرٌ':Added, #1: 1	تَعْزِيَةِ الشَّابَّةِ
u'تَعْزِيَةٌ كَافِرٌ':Added, #1: 1	تَعْزِيَةِ كَافِرٍ
u'تَعْزِيَةٌ مُسْلِمٌ':Added, #5: 5	تَعْزِيَةِ الْكَافِرِ
u'تَعِسَ أَبْعَدُ':Subject, #6: 6	تَعْزِيَةِ الْمُسْلِمِ
u'تَعَسَّرَ إحْضَارٌ':Subject, #2: 2	تَعِسَ الْأَبْعَدُ
u'تَعَسَّرَ إِزَالَةٌ':Subject, #2: 2	تَعَسَّرَ إحْضَارُهُ
u'تَعَسُّرٌ أصل':Added, #2: 2	تَعَسَّرَ إزَالَتُهُ
u'تَعَسُّرٌ أًصْلٌ':Added, #2: 2	تَعَسُّرِ الْأَصْلِ
u'تَعَسُّرٌ تَجْرِبَةٌ':Added, #2: 2	تَعَسُّرِ الْأَصْلِ
u'تَعَسَّرَ تَحَرُّزٌ':Subject, #1: 1	تَعَسُّرِ التَّجْرِبَةِ
u'تَعَسُّرٌ رُجُوعٌ':Added, #2: 2	تَعَسَّرَ التَّحَرُّزُ
u'تَعَسُّرٌ رَقَبَةٌ':Added, #1: 1	تَعَسُّرِ الرُّجُوعِ
u'تَعَسُّرٌ شَهَادَةٌ':Added, #2: 2	تَعَسُّرِ الرَّقَبَةِ
u'تَعَسَّرَ عَدٌّ':Subject, #1: 1	تَعَسُّرِ شَهَادَةِ
u'تَعَسُّرٌ نَزْعٌ':Added, #1: 1	تَعَسَّرَ عَدُّهُ
u'تَعَسَّرَ وَزْنٌ':Subject, #1: 1	تَعَسُّرُ نَزْعِ
u'تَعِسَ شَيْطَانٌ':Subject, #1: 1	تَعَسَّرَ وَزْنُهُ
u'تَعِسَ عَبْدٌ':Subject, #5: 5	تَعِسَ الشَّيْطَانُ
u'تَعْشِيشٌ صَيْدٌ':Added, #9: 9	تَعِسَ عَبْدُ
u'تَعَشَّى عند':Predicate, #1: 1	تَعْشِيشِ الصَّيْدِ
u'تَعَصُّبٌ فلان':Added, #3: 3	تَعَشَّى عِنْدَ
u'تَعْصِيبٌ اِبْنٌ':Added, #1: 1	تَعَصُّبُ الزَّمَخْشَرِيِّ
u'تَعْصِيبٌ أُخْتٌ':Added, #1: 1	تَعْصِيبِ ابْنِ
u'تَعْصِيبٌ جَسَدٌ':Added, #1: 1	تَعْصِيبَ الْأُخْتِ
u'تَعْصِيبٌ نَسَبٌ':Added, #1: 1	تَعْصِيبُ الْجَسَدِ
u'تَعْصِيبٌ نَسَبٌ':Added, #1: 1	تَعْصِيبٍ نَسَبٍ
u'تَعَطَّلَ إبْصَارٌ':Subject, #1: 1	تَعْصِيبِ نَسَبٍ
u'تَعَطُّلٌ أَكْثَرُ':Added, #1: 1	تَعَطَّلَ الْإِبْصَارُ
u'تَعَطَّلَ اِنْتِفاعٌ':Subject, #1: 1	تَعَطُّلُ أَكْثَرِ
u'تَعَطَّلَ بَيْتٌ':Subject, #1: 1	تَعَطَّلَ انْتِفَاعُهُ
u'تَعَطُّلٌ جهاد':Added, #1: 1	تَعَطَّلَ الْبَيْتُ
u'تَعَطُّلٌ جِهَادٌ':Added, #1: 1	تَعَطُّلَ الْجِهَادِ
u'تَعَطَّلَ حُكْمٌ':Subject, #1: 1	تَعَطُّلَ الْجِهَادِ
u'تَعَطَّلَ رَهْنٌ':Subject, #1: 1	تَعَطَّلَ الْحُكْمُ
u'تَعَطُّلٌ زَرْعٌ':Added, #1: 1	تَعَطَّلَ الرَّهْنُ
u'تَعَطَّلَ شرب':Subject, #2: 2	تَعَطُّلِ الزَّرْعِ
u'تَعَطَّلَ شُرْبٌ':Subject, #1: 1	تَعَطَّلَ شُرْبُ
u'تَعَطَّلَ شرب':Subject, #1: 1	تَعَطَّلَ شُرْبُ
u'تَعَطَّلَ شُرْبٌ':Subject, #1: 1	تَعَطَّلَ شُرْبُهُ
u'تَعَطَّلَ فَرْضٌ':Subject, #1: 1	تَعَطَّلَ شُرْبُهُ
u'تَعَطَّلَ فَرْضٌ':Subject, #1: 1	تَعَطَّلَ الْفَرْضُ
u'تَعَطُّلٌ فَرْضٌ':Added, #1: 1	تَعَطَّلَ فَرْضُ
u'تَعَطُّلٌ فَرْضٌ':Added, #1: 1	تَعَطُّلِ الْفَرْضِ
u'تَعَطَّلَ قَرِيبٌ':Subject, #1: 1	تَعَطُّلِ فَرْضِ
u'تَعَطَّلَ كَسْبٌ':Subject, #1: 1	تَعَطَّلَ الْقَرِيبُ
u'تَعَطَّلَ مَالٌ':Subject, #1: 1	تَعَطَّلَ كَسْبُهُ
u'تَعَطَّلَ مَسْجِدٌ':Subject, #1: 1	تَعَطَّلَ الْمَالُ
u'تَعَطَّلَ مَسْجِدٌ':Subject, #1: 1	تَعَطَّلَ الْمَسْجِدُ
u'تَعَطَّلَ مَشْيٌ':Subject, #3: 3	تَعَطَّلَ مَسْجِدٌ
u'تَعَطَّلَ مَقْصُودٌ':Subject, #1: 1	تَعَطَّلَ مَشْيُهُ
u'تَعَطَّلَ نُطْقٌ':Subject, #1: 1	تَعَطَّلَ الْمَقْصُودُ
u'تَعَطَّلَ نَفْعٌ':Subject, #1: 1	تَعَطَّلَ النُّطْقُ
u'تَعَطَّلَ نَفْعٌ':Subject, #1: 1	تَعَطَّلَ نَفْعُ
u'تَعَطُّلٌ نَفْعٌ':Added, #2: 2	تَعَطَّلَ نَفْعُهُ
u'تَعَطَّلَ وَقْفٌ':Subject, #2: 2	تَعَطُّلُ نَفْعِهِ
u'تَعْطِيشٌ عَسَلٌ':Added, #2: 2	تَعَطَّلَ الْوَقْفُ
u'تَعْطِيلٌ أحَدٌ':Added, #1: 1	تَعْطِيشِ الْعَسَلِ
u'تَعْطِيلٌ أَحْكَامٌ':Added, #1: 1	تَعْطِيلِ أَحَدِ
u'تَعْطِيلٌ أسْبَابٌ':Added, #2: 2	تَعْطِيلِ الْأَحْكَامِ
u'تَعْطِيلٌ أَسْبَابٌ':Added, #1: 1	تَعْطِيلِ أَسْبَابِ
u'تَعْطِيلٌ أَكْثَرُ':Added, #1: 1	تَعْطِيلِ أَسْبَابِ
u'تَعْطِيلٌ أَمْرٌ':Added, #1: 1	تَعْطِيلِ أَكْثَرِ
u'تَعْطِيلٌ أُمُورٌ':Added, #1: 1	تَعْطِيلُ الْأَمْرِ
u'تَعْطِيلٌ جَمَاعَةٌ':Added, #1: 1	تَعْطِيلِ أُمُورِ
u'تَعْطِيلٌ جَمَاعَةٌ':Added, #1: 1	تَعْطِيلُ الْجَمَاعَةِ
u'تَعْطِيلٌ جهاد':Added, #1: 1	تَعْطِيلِ الْجَمَاعَةِ
u'تَعْطِيلٌ جِهَادٌ':Added, #2: 2	تَعْطِيلِ الْجِهَادِ
u'تَعْطِيلٌ حَقٌّ':Added, #2: 2	تَعْطِيلِ الْجِهَادِ
u'تَعْطِيلٌ حَقٌّ':Added, #1: 1	تَعْطِيلِ الْحَقِّ
u'تَعْطِيلٌ حَقٌّ':Added, #1: 1	تَعْطِيلِ حَقٍّ
u'تَعْطِيلٌ حُقوقٌ':Added, #1: 1	تَعْطِيلِ حَقِّ
u'تَعْطِيلٌ حُقُوقٌ':Added, #1: 1	تَعْطِيلُ الْحُقُوقِ
u'تَعْطِيلٌ حُكْمٌ':Added, #1: 1	تَعْطِيلُ الْحُقُوقِ
u'تَعْطِيلٌ دَلالَةٌ':Added, #1: 1	تَعْطِيلِ الْحُكْمِ
u'تَعْطِيلٌ سَبَبٌ':Added, #1: 1	تَعْطِيلُ دَلَالَةِ
u'تَعْطِيلٌ سنن':Added, #1: 1	تَعْطِيلُ السَّبَبِ
u'تَعْطِيلٌ سنن':Added, #2: 2	تَعْطِيلُ السُّنَنِ
u'تَعْطِيلٌ عين':Added, #2: 2	تَعْطِيلِ السُّنَنِ
u'تَعْطِيلٌ عَيْنٌ':Added, #1: 1	تَعْطِيلِ الْعَيْنِ
u'تَعْطِيلٌ عَيْن':Added, #1: 1	تَعْطِيلِ الْعَيْنِ
u'تَعْطِيلٌ فَرْضٌ':Added, #1: 1	تَعْطِيلِ الْعَيْنِ
u'تَعْطِيلٌ قَضَاءٌ':Added, #1: 1	تَعْطِيلَ فَرْضِ
u'تَعْطِيلٌ لَفْظٌ':Added, #1: 1	تَعْطِيلُ الْقَضَاءِ
u'تَعْطِيلٌ مَالٌ':Added, #1: 1	تَعْطِيلِ اللَّفْظِ
u'تَعْطِيلٌ مَسَاجِدُ':Added, #2: 2	تَعْطِيلُ الْمَالِ
u'تَعْطِيلٌ مَسَاجِدُ':Added, #1: 1	تَعْطِيلَ الْمَسَاجِدِ
u'تَعْطِيلٌ مَسْجِدٌ':Added, #2: 2	تَعْطِيلُ الْمَسَاجِدِ
u'تَعْطِيلٌ مَصَالِحُ':Added, #1: 1	تَعْطِيلِ الْمَسْجِدِ
u'تَعْطِيلٌ مَعَاشٌ':Added, #2: 2	تَعْطِيلِ مَصَالِحِ
u'تَعْطِيلٌ مَفْهُومٌ':Added, #1: 1	تَعْطِيلِ الْمَعَاشِ
u'تَعْطِيلٌ مَنَافِعُ':Added, #1: 1	تَعْطِيلِ الْمَفْهُومِ
u'تَعْطِيلٌ مَنَافِعُ':Added, #1: 1	تَعْطِيلِ الْمَنَافِعِ
u'تَعْطِيلٌ مَنْفَعَةٌ':Added, #3: 3	تَعْطِيلِ مَنَافِعِ
u'تَعْطِيلٌ مَنْفَعَةٌ':Added, #1: 1	تَعْطِيلَ الْمَنْفَعَةِ
u'تَعْطِيلٌ مَنْفَعَةٌ':Added, #1: 1	تَعْطِيلِ الْمَنْفَعَةِ
u'تَعْطِيلٌ نَاسٌ':Added, #1: 1	تَعْطِيلِ مَنْفَعَةٍ
u'تَعْطِيلٌ نَصٌّ':Added, #1: 1	تَعْطِيلِ النَّاسِ
u'تَعْطِيلٌ نَصٌّ':Added, #1: 1	تَعْطِيلَ النَّصِّ
u'تَعْطِيلٌ نَصٌّ':Added, #1: 1	تَعْطِيلُ النَّصِّ
u'تَعْطِيلٌ نُصُوصٌ':Added, #1: 1	تَعْطِيلِ النَّصِّ
u'تَعْطِيلٌ نُطْقٌ':Added, #1: 1	تَعْطِيلِ النُّصُوصِ
u'تَعْطِيلٌ واحد':Added, #1: 1	تَعْطِيلِ النُّطْقِ
u'تَعْطِيلٌ وَاحِدٌ':Added, #1: 1	تَعْطِيلِ الْوَاحِدِ
u'تَعْطِيلٌ وَقْفٌ':Added, #1: 1	تَعْطِيلِ الْوَاحِدِ
u'تَعْظِيمٌ أرْبَابٌ':Added, #1: 1	تَعْطِيلِ الْوَقْفِ
u'تَعْظِيمٌ أُسْتَاذٌ':Added, #1: 1	تَعْظِيمَ الْأَرْبَابِ
u'تَعْظِيمٌ اِسْمٌ':Added, #1: 1	تَعْظِيمَ الْأُسْتَاذِ
u'تَعْظِيمٌ اِسْمٌ':Added, #1: 1	تَعْظِيمِ اسْمِهِ
u'تَعْظِيمٌ أَصْنَامٌ':Added, #2: 2	تَعْظِيمَ اسْمِ
u'تَعْظِيمٌ أَمْرٌ':Added, #1: 1	تَعْظِيمَ الْأَصْنَامِ
u'تَعْظِيمٌ أَمْرٌ':Added, #1: 1	تَعْظِيمِ أَمْرِ
u'تَعْظِيمٌ أنبياء':Added, #3: 3	تَعْظِيمُ أَمْرِ
u'تَعْظِيمٌ بَاطن':Added, #1: 1	تَعْظِيمُ الْأَنْبِيَاءِ
u'تَعْظِيمٌ باطِنٌ':Added, #1: 1	تَعْظِيمِ الْبَاطِنِ
u'تَعْظِيمٌ بُقْعَةٌ':Added, #1: 1	تَعْظِيمِ الْبَاطِنِ
u'تَعْظِيمٌ بُقْعَةٌ':Added, #4: 4	تَعْظِيمَ الْبُقْعَةِ
u'تَعْظِيمٌ بُقْعَةٌ':Added, #5: 5	تَعْظِيمِ الْبُقْعَةِ
u'تَعْظِيمٌ بَيْتٌ':Added, #6: 6	تَعْظِيمُ الْبُقْعَةِ
u'تَعْظِيمٌ تَمْييزٌ':Added, #2: 2	تَعْظِيمِ الْبَيْتِ
u'تَعْظِيمٌ حَرَمٌ':Added, #1: 1	تَعْظِيمِ التَّمْيِيزِ
u'تَعْظِيمٌ حُرُمَةٌ':Added, #1: 1	تَعْظِيمَ الْحَرَمِ
u'تَعْظِيمٌ حُرْمَةٌ':Added, #1: 1	تَعْظِيمِ حُرُمَاتِ
u'تَعْظِيمٌ حُرْمَةٌ':Added, #1: 1	تَعْظِيمَ حُرْمَةِ
u'تَعْظِيمٌ حُرْمَةٌ':Added, #1: 1	تَعْظِيمُ حُرْمَةِ
u'تَعْظِيمٌ حُزْنٌ':Added, #2: 2	تَعْظِيمِ حُرْمَةِ
u'تَعْظِيمٌ خطر':Added, #1: 1	تَعْظِيمُ الْحُزْنِ
u'تَعْظِيمٌ خَطَرٌ':Added, #1: 1	تَعْظِيمُ خَطَرِ
u'تَعْظِيمٌ دُخُولٌ':Added, #1: 1	تَعْظِيمُ خَطَرِ
u'تَعْظِيمٌ دَيْنٌ':Added, #1: 1	تَعْظِيمُ دُخُولِ
u'تَعْظِيمٌ ذَنْبٌ':Added, #1: 1	تَعْظِيمِ الدَّيْنِ
u'تَعْظِيمٌ سُلْطَانٌ':Added, #1: 1	تَعْظِيمِ الذَّنْبِ
u'تَعْظِيمٌ شافِعِيّ':Added, #1: 1	تَعْظِيمُ السُّلْطَانِ
u'تَعْظِيمٌ شَرِيعَةٌ':Added, #1: 1	تَعْظِيمِ الشَّافِعِيِّ
u'تَعْظِيمٌ صَحَابَةٌ':Added, #1: 1	تَعْظِيمِ الشَّرِيعَةِ
u'تَعْظِيمٌ صَحَابَةٌ':Added, #1: 1	تَعْظِيمُ الصَّحَابَةِ
u'تَعْظِيمٌ صَنَمٌ':Added, #1: 1	تَعْظِيمِ الصَّحَابَةِ
u'تَعْظِيمٌ صُورَةٌ':Added, #1: 1	تَعْظِيمُ الصَّنَمِ
u'تَعْظِيمٌ طَاعَةٌ':Added, #1: 1	تَعْظِيمُ الصُّورَةِ
u'تَعْظِيمٌ غير':Added, #2: 2	تَعْظِيمُ الطَّاعَاتِ
u'تَعْظِيمٌ غير':Added, #1: 1	تَعْظِيمَ غَيْرِ
u'تَعْظِيمٌ غير':Added, #1: 1	تَعْظِيمُ غَيْرِ
u'تَعْظِيمٌ غَيْرٌ':Added, #1: 1	تَعْظِيمِ غَيْرِ
u'تَعْظِيمٌ غَيْرٌ':Added, #1: 1	تَعْظِيمَ غَيْرِ
u'تَعْظِيمٌ غَيْرٌ':Added, #1: 1	تَعْظِيمُ غَيْرِ
u'تَعْظِيمٌ فلان':Added, #1: 1	تَعْظِيمِ غَيْرِ
u'تَعْظِيمٌ قتال':Added, #1: 1	تَعْظِيمِ الشَّافِعِيِّ
u'تَعْظِيمٌ قِتَالٌ':Added, #1: 1	تَعْظِيمَ الْقِتَالِ
u'تَعْظِيمٌ قَدْرٌ':Added, #1: 1	تَعْظِيمَ الْقِتَالِ
u'تَعْظِيمٌ قَدْرٌ':Added, #1: 1	تَعْظِيمُ قَدْرِ
u'تَعْظِيمٌ قُرْآنٌ':Added, #2: 2	تَعْظِيمِ قَدْرِ
u'تَعْظِيمٌ قُرْآنٌ':Added, #1: 1	تَعْظِيمَ الْقُرْآنِ
u'تَعْظِيمٌ قرائب':Added, #1: 1	تَعْظِيمِ الْقُرْآنِ
u'تَعْظِيمٌ كَافِرٌ':Added, #1: 1	تَعْظِيمُ الْقَرَائِبِ
u'تَعْظِيمٌ كعبة':Added, #1: 1	تَعْظِيمُ الْكَافِرِ
u'تَعْظِيمٌ كَعْبَةٌ':Added, #1: 1	تَعْظِيمِ الْكَعْبَةِ
u'تَعْظِيمٌ مُحَمَّدٌ':Added, #1: 1	تَعْظِيمِ الْكَعْبَةِ
u'تَعْظِيمٌ مَذْبُوحٌ':Added, #1: 1	تَعْظِيمَ مُحَمَّدٍ
u'تَعْظِيمٌ مَسْجِدٌ':Added, #1: 1	تَعْظِيمَ الْمَذْبُوحِ
u'تَعْظِيمٌ مَسْجِدٌ':Added, #1: 1	تَعْظِيمَ الْمَسْجِدِ
u'تَعْظِيمٌ مَسْجِدٌ':Added, #1: 1	تَعْظِيمُ الْمَسْجِدِ
u'تَعْظِيمٌ مُسْلِمٌ':Added, #1: 1	تَعْظِيمِ الْمَسْجِدِ
u'تَعْظِيمٌ مُسْلِمٌ':Added, #1: 1	تَعْظِيمَ الْمُسْلِمِ
u'تَعْظِيمٌ مُصْحَفٌ':Added, #1: 1	تَعْظِيمِ الْمُسْلِمِ
u'تَعْظِيمٌ مُصْحَفٌ':Added, #1: 1	تَعْظِيمُ الْمُصْحَفِ
u'تَعْظِيمٌ مُقَلَّدٌ':Added, #1: 1	تَعْظِيمِ الْمُصْحَفِ
u'تَعْظِيمٌ نَارٌ':Added, #1: 1	تَعْظِيمُ مُقَلَّدِهِ
u'تَعْظِيمٌ نَبِيٌّ':Added, #1: 1	تَعْظِيمَ النَّارِ
u'تَعْظِيمٌ نَيْرُوزٌ':Added, #1: 1	تَعْظِيمَ النَّبِيِّ
u'تَعْظِيمٌ هَدْيٌ':Added, #1: 1	تَعْظِيمِ النَّيْرُوزِ
u'تَعْظِيمٌ هَيْبَةٌ':Added, #1: 1	تَعْظِيمَ الْهَدْيِ
u'تَعْظِيمٌ يَوْمٌ':Added, #1: 1	تَعْظِيمِ هَيْبَتِهِ
u'تَعْظِيمٌ يَوْمٌ':Added, #1: 1	تَعْظِيمَ الْيَوْمِ
u'تَعَفَّنَ طعام':Subject, #1: 1	تَعْظِيمُ يَوْمِ
u'تَعَفَّنَ طَعَامٌ':Subject, #2: 2	تَعَفَّنَ الطَّعَامُ
u'تَعَقَّبَ اِبْنٌ':Predicate, #2: 2	تَعَفَّنَ الطَّعَامُ
u'تَعَقَّبَ اِبْنٌ':Subject, #2: 2	تَعَقَّبَ ابْنَ
u'تَعَقُّبٌ اِبْنٌ':Added, #1: 1	تَعَقَّبَ ابْنُ
u'تَعَقُّبٌ اِبْنٌ':Added, #1: 1	تَعَقُّبُ ابْنِ
u'تَعَقُّبٌ اِبْنٌ':Added, #1: 1	تَعَقُّبِ ابْنِ
u'تَعَقُّبٌ أَفْعَالٌ':Added, #2: 2	تَعَقُّبَ ابْنِ
u'تَعَقَّبَ إقْرَارٌ':Predicate, #1: 1	تَعَقُّبَ أَفْعَالِ
u'تَعَقُّبٌ إقْرَارٌ':Added, #1: 1	تَعَقَّبَ الْإِقْرَارَ
u'تَعَقُّبٌ أُمُورٌ':Added, #2: 2	تَعَقُّبِ الْإِقْرَارِ
u'تَعَقُّبٌ بَعْضٌ':Added, #1: 1	تَعَقُّبِ أُمُورٍ
u'تَعَقَّبَ تَخْرِيجٌ':Predicate, #1: 1	تَعَقُّبَ بَعْضِ
u'تَعَقَّبَ تَقِيٌّ':Subject, #1: 1	تَعَقَّبَ تَخْرِيجَ
u'تَعَقَّبَ جَوَابٌ':Predicate, #1: 1	تَعَقَّبَ تَقِيُّ
u'تَعَقُّبٌ حُكْمٌ':Added, #1: 1	تَعَقَّبَ الْجَوَابَ
u'تَعَقُّبٌ دَليلٌ':Added, #1: 1	تَعَقُّبِ حُكْمِ
u'تَعَقَّبَ شَارِحٌ':Subject, #1: 1	تَعَقُّبِ دَلِيلِهِ
u'تَعَقَّبَ شَرَطٌ':Predicate, #1: 1	تَعَقَّبَ شَارِحُ
u'تَعَقَّبَ شَرْطٌ':Subject, #1: 1	تَعَقَّبَ شَرَطَ
u'تَعَقَّبَ صَاحِبٌ':Subject, #1: 1	تَعَقَّبَ الشَّرْطُ
u'تَعَقُّبٌ صَاحِبٌ':Added, #1: 1	تَعَقَّبَ صَاحِبُ
u'تَعَقَّبَ عَادٌ':Predicate, #1: 1	تَعَقُّبِ صَاحِبِ
u'تَعَقَّبَ عَبْدٌ':Subject, #1: 1	تَعَقَّبَ عَادَ
u'تَعَقُّبٌ عِلَّةٌ':Added, #2: 2	تَعَقَّبَ عَبْدُ
u'تَعَقَّبَ غير':Subject, #1: 1	تَعَقُّبَ الْعِلَّةِ
u'تَعَقَّبَ غَيْرٌ':Subject, #1: 1	تَعَقَّبَ غَيْرُ
u'تَعَقُّبٌ فِعْلٌ':Added, #1: 1	تَعَقَّبَ غَيْرُ
u'تَعَقَّبَ قَاضِي':Predicate, #1: 1	تَعَقُّبُ الْفِعْلِ
u'تَعَقَّبَ كَوْنٌ':Predicate, #1: 1	تَعَقَّبَ الْقَاضِيَ
u'تَعَقَّبَ مُحَقِّقٌ':Subject, #1: 1	تَعَقَّبَ كَوْنَ
u'تَعَقُّبٌ مُشِيرٌ':Added, #1: 1	تَعَقَّبَ الْمُحَقِّقُ
u'تَعَقَّبَ مُصَنِّفٌ':Subject, #1: 1	تَعَقُّبُ الْمُشِيرِ
u'تَعَقَّبَ نَهْرٌ':Predicate, #1: 1	تَعَقَّبَ الْمُصَنِّفُ
u'تَعَقَّبَ نَهْيٌ':Predicate, #1: 1	تَعَقَّبَ النَّهْرَ
u'تَعَقُّبٌ ولد':Added, #1: 1	تَعَقَّبَ النَّهْيَ
u'تَعَقُّبٌ وَلَدٌ':Added, #1: 1	تَعَقُّبِ وَلَدِهِ
u'تَعَقُّلٌ أصل':Added, #1: 1	تَعَقُّبِ وَلَدِهِ
u'تَعَقُّلٌ أًصْلٌ':Added, #1: 1	تَعَقُّلَ الْأَصْلِ
u'تَعَقَّلَ إِنْسانٌ':Subject, #1: 1	تَعَقُّلَ الْأَصْلِ
u'تَعَقُّلٌ حَدٌّ':Added, #1: 1	تَعَقَّلَ الْإِنْسَانُ
u'تَعَقُّلٌ حَقِيقٌ':Added, #1: 1	تَعَقُّلِ الْحَدِّ
u'تَعَقُّلٌ حَقِيقَةٌ':Added, #1: 1	تَعَقُّلُ حَقِيقَةِ
u'تَعَقَّلَ رَجُلٌ':Subject, #1: 1	تَعَقُّلُ حَقِيقَةِ
u'تَعَقُّلٌ شَرْطٌ':Added, #1: 1	تَعَقَّلَ رَجُلٌ
u'تَعَقُّلٌ ضِدٌّ':Added, #1: 1	تَعَقُّلِ الشَّرْطِ
u'تَعَقُّلٌ ضِدٌّ':Added, #2: 2	تَعَقُّلُ الضِّدِّ
u'تَعَقَّلَ عَدَمٌ':Predicate, #2: 2	تَعَقُّلِ الضِّدِّ
u'تَعَقُّلٌ غير':Added, #1: 1	تَعَقَّلَ عَدَمَ
u'تَعَقُّلٌ غَيْرٌ':Added, #2: 2	تَعَقُّلِ الْغَيْرِ
u'تَعَقُّلٌ فَرْقٌ':Added, #2: 2	تَعَقُّلِ الْغَيْرِ
u'تَعَقُّلٌ فِعْلٌ':Added, #1: 1	تَعَقُّلِ فَرْقٍ
u'تَعَقُّلٌ قَاتِلٌ':Added, #1: 1	تَعَقُّلِ الْفِعْلِ
u'تَعَقُّلٌ مَحْدُودٌ':Added, #1: 1	تَعَقُّلِ قَاتِلٍ
u'تَعَقُّلٌ مَحْكُومٌ':Added, #2: 2	تَعَقُّلُ الْمَحْدُودِ
u'تَعَقُّلٌ مَحْكُومٌ':Added, #1: 1	تَعَقُّلُ الْمَحْكُومِ
u'تَعَقُّلٌ مُرَكَّبٌ':Added, #2: 2	تَعَقُّلِ الْمَحْكُومِ
u'تَعَقُّلٌ مُسْتَدَلٌّ':Added, #1: 1	تَعَقُّلِ الْمُرَكَّبِ
u'تَعَقُّلٌ مَشْرُوطٌ':Added, #1: 1	تَعَقُّلُ الْمُسْتَدَلِّ
u'تَعَقَّلَ مَفْهُومٌ':Predicate, #1: 1	تَعَقُّلِ الْمَشْرُوطِ
u'تَعَقُّلٌ مَفْهُومٌ':Added, #1: 1	تَعَقَّلَ مَفْهُومَ
u'تَعَقُّلٌ مُوجِبٌ':Added, #1: 1	تَعَقُّلُ مَفْهُومِ
u'تَعَقُّلٌ وَاضِعٌ':Added, #1: 1	تَعَقُّلِ الْمُوجِبِ
u'تَعْقِيبٌ إقْرَارٌ':Added, #1: 1	تَعَقُّلُ الْوَاضِعِ
u'تَعْقِيبٌ إقْرَارٌ':Added, #1: 1	تَعْقِيبَ الْإِقْرَارِ
u'تَعْقِيبٌ إقْرَارٌ':Added, #2: 2	تَعْقِيبُ الْإِقْرَارِ
u'تَعْقِيبٌ ثَانِي':Added, #4: 4	تَعْقِيبِ الْإِقْرَارِ
u'تَعْقِيبٌ ثَانِيَةٌ':Added, #2: 2	تَعْقِيبِ الثَّانِيَةِ
u'تَعْقِيبٌ جهاد':Added, #2: 2	تَعْقِيبِ الثَّانِيَةِ
u'تَعْقِيبٌ جِهَادٌ':Added, #1: 1	تَعْقِيبَ الْجِهَادِ
u'تَعْقِيبٌ فاء':Added, #1: 1	تَعْقِيبَ الْجِهَادِ
u'تَعْقِيبٌ مُساقاة':Added, #1: 1	تَعْقِيبَ الْفَاءِ
u'تَعَلُّقٌ أَبٌ':Added, #1: 1	تَعْقِيبِ الْمُسَاقَاةِ
u'تَعَلُّقٌ إبَاحَةٌ':Added, #1: 1	تَعَلُّقِ الْأَبِ
u'تَعَلَّقَ أَبْعَدُ':Subject, #1: 1	تَعَلُّقَ الْإِبَاحَةِ
u'تَعَلُّقٌ اِبْنٌ':Added, #1: 1	تَعَلَّقَ الْأَبْعَدُ
u'تَعَلُّقٌ إِثْبَاتٌ':Added, #1: 1	تَعَلُّقِ ابْنِ
u'تَعَلَّقَ إِثْمٌ':Subject, #1: 1	تَعَلُّقُ إثْبَاتِ
u'تَعَلُّقٌ إِثْمٌ':Added, #1: 1	تَعَلَّقَ الْإِثْمُ
u'تَعَلُّقٌ أُجْرَةٌ':Added, #1: 1	تَعَلُّقُ الْإِثْمِ
u'تَعَلُّقٌ إحَاطَةٌ':Added, #1: 1	تَعَلُّقِ الْأُجْرَةِ
u'تَعَلُّقٌ إحَاطَةٌ':Added, #1: 1	تَعَلُّقَ إحَاطَةٍ
u'تَعَلُّقٌ إِحْرَامٌ':Added, #1: 1	تَعَلُّقُ إحَاطَةٍ
u'تَعَلُّقٌ أَحْكَامٌ':Added, #1: 1	تَعَلُّقُ الْإِحْرَامِ
u'تَعَلُّقٌ أَحْكَامٌ':Added, #1: 1	تَعَلُّقُ الْأَحْكَامِ
u'تَعَلُّقٌ أَحْكَامٌ':Added, #2: 2	تَعَلُّقَ الْأَحْكَامِ
u'تَعَلَّقَ إِخْبَارٌ':Subject, #2: 2	تَعَلُّقِ الْأَحْكَامِ
u'تَعَلَّقَ أَخِيرٌ':Subject, #1: 1	تَعَلَّقَ الْإِخْبَارُ
u'تَعَلُّقٌ إِدْرَاكٌ':Added, #1: 1	تَعَلَّقَ الْأَخِيرُ
u'تَعَلُّقٌ إِدْرَاكٌ':Added, #1: 1	تَعَلُّقِ الْإِدْرَاكَاتِ
u'تَعَلُّقٌ إِذْنٌ':Added, #2: 2	تَعَلُّقِ إدْرَاكِ
u'تَعَلُّقٌ إِرَادَةٌ':Added, #1: 1	تَعَلُّقِ إذْنِ
u'تَعَلُّقٌ إِرَادَةٌ':Added, #1: 1	تَعَلُّقِ إرَادَةِ
u'تَعَلُّقٌ إِرَادَةٌ':Added, #1: 1	تَعَلُّقِ إرَادَتِهِ
u'تَعَلُّقٌ اِسْتِحْقَاقٌ':Added, #1: 1	تَعَلُّقِ الْإِرَادَةِ
u'تَعَلُّقٌ اِسْتيفاءٌ':Added, #1: 1	تَعَلُّقُ اسْتِحْقَاقِ
u'تَعَلُّقٌ اِسْتيفاءٌ':Added, #2: 2	تَعَلُّقَ اسْتِيفَاءٍ
u'تَعَلَّقَ أصل':Subject, #3: 3	تَعَلُّقُ اسْتِيفَاءٍ
u'تَعَلَّقَ أًصْلٌ':Subject, #1: 1	تَعَلَّقَ أَصْلُ
u'تَعَلَّقَ أصل':Subject, #1: 1	تَعَلَّقَ أَصْلُ
u'تَعَلَّقَ أًصْلٌ':Subject, #1: 1	تَعَلَّقَ أَصْلُهُ
u'تَعَلَّقَ أصل':Subject, #1: 1	تَعَلَّقَ أَصْلُهُ
u'تَعَلَّقَ أًصْلٌ':Subject, #2: 2	تَعَلَّقَ الْأَصْلُ
u'تَعَلُّقٌ أصل':Added, #2: 2	تَعَلَّقَ الْأَصْلُ
u'تَعَلُّقٌ أًصْلٌ':Added, #1: 1	تَعَلُّقِ أَصْلِ
u'تَعَلُّقٌ أَعْرَاضٌ':Added, #1: 1	تَعَلُّقِ أَصْلِ
u'تَعَلُّقٌ إعْلاَمٌ':Added, #1: 1	تَعَلُّقَ الْأَعْرَاضِ
u'تَعَلُّقٌ إقْرَارٌ':Added, #1: 1	تَعَلُّقُ إعْلَامٍ
u'تَعَلُّقٌ أكل':Added, #1: 1	تَعَلُّقِ الْإِقْرَارِ
u'تَعَلُّقٌ أَكْلٌ':Added, #1: 1	تَعَلُّقِ الْأَكْلِ
u'تَعَلُّقٌ إِلْزَامٌ':Added, #1: 1	تَعَلُّقِ الْأَكْلِ
u'تَعَلَّقَ إمَامٌ':Subject, #1: 1	تَعَلُّقُ إلْزَامٍ
u'تَعَلَّقَ أَمْرٌ':Subject, #1: 1	تَعَلَّقَ إمَامُ
u'تَعَلُّقٌ أَمْرٌ':Added, #4: 4	تَعَلَّقَ الْأَمْرُ
u'تَعَلُّقٌ أَمْرٌ':Added, #10: 10	تَعَلُّقِ الْأَمْرِ
u'تَعَلُّقٌ أَمْرٌ':Added, #1: 1	تَعَلُّقَ الْأَمْرِ
u'تَعَلُّقٌ أَمْرٌ':Added, #1: 1	تَعَلُّقُ أَمْرِ
u'تَعَلُّقٌ أُمومَةٌ':Added, #7: 7	تَعَلُّقُ الْأَمْرِ
u'تَعَلَّقَ إِنْشاءٌ':Subject, #1: 1	تَعَلُّقِ الْأُمُومَةِ
u'تَعَلَّقَ أَوَّلُ':Subject, #1: 1	تَعَلَّقَ الْإِنْشَاءُ
u'تَعَلُّقٌ أَوَّلُ':Added, #10: 10	تَعَلَّقَ الْأَوَّلُ
u'تَعَلُّقٌ أَوَّلُ':Added, #2: 2	تَعَلُّقِ الْأَوَّلِ
u'تَعَلَّقَ أئِمَّةٌ':Subject, #5: 5	تَعَلُّقَ الْأَوَّلِ
u'تَعَلُّقٌ إِيجَابٌ':Added, #1: 1	تَعَلَّقَ الْأَئِمَّةُ
u'تَعَلُّقٌ بالٌ':Added, #1: 1	تَعَلُّقَ إيجَابٍ
u'تَعَلُّقٌ بَالٌ':Added, #1: 1	تَعَلُّقَ الْبَالِ
u'تَعَلُّقٌ بَائِعٌ':Added, #1: 1	تَعَلُّقَ الْبَالِ
u'تَعَلَّقَ بَدَلٌ':Subject, #1: 1	تَعَلُّقَ الْبَائِعِ
u'تَعَلَّقَ بِرٌّ':Subject, #1: 1	تَعَلَّقَ بَدَلُ
u'تَعَلَّقَ بَعْضٌ':Subject, #1: 1	تَعَلَّقَ الْبِرُّ
u'تَعَلَّقَ بَعْضٌ':Subject, #1: 1	تَعَلَّقَ بَعْضُهُ
u'تَعَلُّقٌ بَقاءٌ':Added, #3: 3	تَعَلَّقَ بَعْضُ
u'تَعَلُّقٌ بَقاءٌ':Added, #10: 10	تَعَلُّقُ الْبَقَاءِ
u'تَعَلُّقٌ بَقاءٌ':Added, #1: 1	تَعَلُّقَ الْبَقَاءِ
u'تَعَلُّقٌ بَقاءٌ':Added, #1: 1	تَعَلُّقُ بَقَاءِ
u'تَعَلَّقَ بَليدٌ':Subject, #2: 2	تَعَلُّقِ الْبَقَاءِ
u'تَعَلُّقٌ بِنَاءٌ':Added, #1: 1	تَعَلَّقَ الْبَلِيدُ
u'تَعَلَّقَ تَحْرِيمٌ':Subject, #1: 1	تَعَلُّقُ الْبِنَاءِ
u'تَعَلُّقٌ تَحْرِيمٌ':Added, #6: 6	تَعَلَّقَ التَّحْرِيمُ
u'تَعَلُّقٌ تَحْرِيمٌ':Added, #1: 1	تَعَلُّقُ تَحْرِيمِهِ
u'تَعَلُّقٌ تَدْبِيرٌ':Added, #3: 3	تَعَلُّقِ التَّحْرِيمِ
u'تَعَلَّقَ تَصْدِيقٌ':Subject, #1: 1	تَعَلُّقَ التَّدْبِيرِ
u'تَعَلُّقٌ تَقْريرٌ':Added, #1: 1	تَعَلَّقَ التَّصْدِيقُ
u'تَعَلَّقَ تَكْليفٌ':Subject, #1: 1	تَعَلُّقُ التَّقْرِيرِ
u'تَعَلُّقٌ تَكْليفٌ':Added, #2: 2	تَعَلَّقَ التَّكْلِيفُ
u'تَعَلُّقٌ تَكْليفٌ':Added, #1: 1	تَعَلُّقَ التَّكْلِيفِ
u'تَعَلُّقٌ ثَانِي':Added, #1: 1	تَعَلُّقُ التَّكْلِيفِ
u'تَعَلُّقٌ ثَانِيَةٌ':Added, #4: 4	تَعَلُّقَ الثَّانِيَةِ
u'تَعَلَّقَ ثُبُوتٌ':Subject, #4: 4	تَعَلُّقَ الثَّانِيَةِ
u'تَعَلُّقٌ ثُبُوتٌ':Added, #1: 1	تَعَلَّقَ ثُبُوتُ
u'تَعَلُّقٌ جَارٌ':Added, #1: 1	تَعَلُّقِ ثُبُوتِهِ
u'تَعَلُّقٌ جَارٌ':Added, #1: 1	تَعَلُّقَ الْجَارِ
u'تَعَلُّقٌ جَزَاءٌ':Added, #1: 1	تَعَلُّقِ الْجَارِ
u'تَعَلُّقٌ جَزَاءٌ':Added, #1: 1	تَعَلُّقَ الْجَزَاءِ
u'تَعَلُّقٌ جِنَايَةٌ':Added, #1: 1	تَعَلُّقُ الْجَزَاءِ
u'تَعَلُّقٌ جِنَايَةٌ':Added, #1: 1	تَعَلُّقِ الْجِنَايَةِ
u'تَعَلُّقٌ جِنَايَةٌ':Added, #1: 1	تَعَلُّقَ جِنَايَةٍ
u'تَعَلُّقٌ جِنَايَةٌ':Added, #2: 2	تَعَلُّقُ جِنَايَةٍ
u'تَعَلَّقَ حُرٌّ':Predicate, #5: 5	تَعَلُّقَ الْجِنَايَةِ
u'تَعَلُّقٌ حِرْمَانٌ':Added, #1: 1	تَعَلَّقَ حُرَّ
u'تَعَلُّقٌ حُرِّيَّةٌ':Added, #1: 1	تَعَلُّقِ الْحِرْمَانِ
u'تَعَلَّقَ حَطَبٌ':Subject, #1: 1	تَعَلُّقُ الْحُرِّيَّةِ
u'تَعَلَّقَ حَقٌّ':Subject, #1: 1	تَعَلَّقَ الْحَطَبُ
u'تَعَلَّقَ حَقٌّ':Subject, #12: 12	تَعَلَّقَ حَقُّهُ
u'تَعَلَّقَ حَقٌّ':Subject, #1: 1	تَعَلَّقَ حَقٌّ
u'تَعَلَّقَ حَقٌّ':Subject, #21: 21	تَعَلَّقَ حَقُّ
u'تَعَلُّقٌ حَقٌّ':Added, #5: 5	تَعَلَّقَ الْحَقُّ
u'تَعَلُّقٌ حَقٌّ':Added, #15: 15	تَعَلُّقَ حَقِّ
u'تَعَلُّقٌ حَقٌّ':Added, #1: 1	تَعَلُّقَ حَقٍّ
u'تَعَلُّقٌ حَقٌّ':Added, #22: 22	تَعَلُّقُ حَقِّ
u'تَعَلُّقٌ حَقٌّ':Added, #29: 29	تَعَلُّقِ حَقِّ
u'تَعَلُّقٌ حَقٌّ':Added, #2: 2	تَعَلُّقُ الْحَقِّ
u'تَعَلُّقٌ حَقٌّ':Added, #3: 3	تَعَلُّقِ حَقٍّ
u'تَعَلُّقٌ حَقٌّ':Added, #4: 4	تَعَلُّقَ الْحَقِّ
u'تَعَلُّقٌ حَقٌّ':Added, #7: 7	تَعَلُّقِ حَقِّهِ
u'تَعَلَّقَ حُقوقٌ':Subject, #9: 9	تَعَلُّقِ الْحَقِّ
u'تَعَلَّقَ حُقُوقٌ':Subject, #1: 1	تَعَلَّقَ الْحُقُوقُ
u'تَعَلُّقٌ حُقوقٌ':Added, #1: 1	تَعَلَّقَ الْحُقُوقُ
u'تَعَلُّقٌ حُقُوقٌ':Added, #1: 1	تَعَلُّقُ الْحُقُوقِ
u'تَعَلُّقٌ حُقوقٌ':Added, #1: 1	تَعَلُّقُ الْحُقُوقِ
u'تَعَلُّقٌ حُقوقٌ':Added, #1: 1	تَعَلُّقُ حُقُوقِ
u'تَعَلُّقٌ حُقُوقٌ':Added, #1: 1	تَعَلُّقِ حُقُوقِ
u'تَعَلُّقٌ حُقُوقٌ':Added, #1: 1	تَعَلُّقُ حُقُوقِ
u'تَعَلُّقٌ حُقوقٌ':Added, #1: 1	تَعَلُّقِ حُقُوقِ
u'تَعَلُّقٌ حُقُوقٌ':Added, #2: 2	تَعَلُّقِ الْحُقُوقِ
u'تَعَلَّقَ حُكْمٌ':Subject, #2: 2	تَعَلُّقِ الْحُقُوقِ
u'تَعَلَّقَ حُكْمٌ':Subject, #15: 15	تَعَلَّقَ الْحُكْمُ
u'تَعَلُّقٌ حُكْمٌ':Added, #1: 1	تَعَلَّقَ حُكْمُ
u'تَعَلُّقٌ حُكْمٌ':Added, #16: 16	تَعَلُّقِ الْحُكْمِ
u'تَعَلُّقٌ حُكْمٌ':Added, #1: 1	تَعَلُّقِ حُكْمِ
u'تَعَلُّقٌ حُكْمٌ':Added, #2: 2	تَعَلُّقُ حُكْمِ
u'تَعَلُّقٌ حُكْمٌ':Added, #2: 2	تَعَلُّقِ حُكْمٍ
u'تَعَلُّقٌ حُكْمٌ':Added, #3: 3	تَعَلُّقِ الْحُكْمَيْنِ
u'تَعَلُّقٌ حُكْمٌ':Added, #3: 3	تَعَلُّقِ حُكْمِهِ
u'تَعَلُّقٌ حُكْمٌ':Added, #5: 5	تَعَلُّقَ الْحُكْمِ
u'تَعَلُّقٌ حِلٌّ':Added, #7: 7	تَعَلُّقُ الْحُكْمِ
u'تَعَلُّقٌ حِلٌّ':Added, #1: 1	تَعَلُّقَ الْحِلِّ
u'تَعَلُّقٌ حَلْقٌ':Added, #2: 2	تَعَلُّقِ الْحِلِّ
u'تَعَلَّقَ حِنْثٌ':Subject, #1: 1	تَعَلُّقُ الْحَلْقِ
u'تَعَلُّقٌ حِنْثٌ':Added, #4: 4	تَعَلَّقَ الْحِنْثُ
u'تَعَلُّقٌ حِنْثٌ':Added, #2: 2	تَعَلُّقَ الْحِنْثِ
u'تَعَلُّقٌ خَصْمٌ':Added, #2: 2	تَعَلُّقُ الْحِنْثِ
u'تَعَلَّقَ خِطَابٌ':Subject, #1: 1	تَعَلُّقُ الْخَصْمِ
u'تَعَلُّقٌ خِطَابٌ':Added, #2: 2	تَعَلَّقَ خِطَابُ
u'تَعَلُّقٌ خِطَابٌ':Added, #1: 1	تَعَلُّقِ خِطَابِ
u'تَعَلُّقٌ خِطَابٌ':Added, #2: 2	تَعَلُّقُ الْخِطَابِ
u'تَعَلُّقٌ دَلالَةٌ':Added, #8: 8	تَعَلُّقِ الْخِطَابِ
u'تَعَلُّقٌ دَلالَةٌ':Added, #1: 1	تَعَلُّقَ دَلَالَةٍ
u'تَعَلُّقٌ دَليلٌ':Added, #1: 1	تَعَلُّقُ دَلَالَةٍ
u'تَعَلُّقٌ دَمٌ':Added, #1: 1	تَعَلُّقِ الدَّلِيلِ
u'تَعَلَّقَ دَيْنٌ':Subject, #3: 3	تَعَلُّقُ الدَّمِ
u'تَعَلَّقَ دَيْنٌ':Subject, #1: 1	تَعَلَّقَ دَيْنُهُ
u'تَعَلُّقٌ دَيْنٌ':Added, #7: 7	تَعَلَّقَ الدَّيْنُ
u'تَعَلُّقٌ دَيْنٌ':Added, #11: 11	تَعَلُّقَ الدَّيْنِ
u'تَعَلُّقٌ دَيْنٌ':Added, #1: 1	تَعَلُّقَ دَيْنِ
u'تَعَلُّقٌ دَيْنٌ':Added, #1: 1	تَعَلُّقُ دَيْنِهِ
u'تَعَلُّقٌ دَيْنٌ':Added, #3: 3	تَعَلُّقُ الدَّيْنِ
u'تَعَلُّقٌ دُيونٌ':Added, #7: 7	تَعَلُّقِ الدَّيْنِ
u'تَعَلُّقٌ دُيونٌ':Added, #1: 1	تَعَلُّقُ دُيُونِ
u'تَعَلَّقَ رَافِضٌ':Subject, #1: 1	تَعَلُّقُ دُيُونِهِ
u'تَعَلَّقَ رَافِضَةٌ':Subject, #1: 1	تَعَلَّقَ الرَّافِضَةُ
u'تَعَلَّقَ رَجُلٌ':Subject, #1: 1	تَعَلَّقَ الرَّافِضَةُ
u'تَعَلُّقٌ رُخْصَةٌ':Added, #2: 2	تَعَلَّقَ رَجُلٌ
u'تَعَلُّقٌ رَهْنٌ':Added, #1: 1	تَعَلُّقِ الرُّخْصَةِ
u'تَعَلُّقٌ رَهْنٌ':Added, #1: 1	تَعَلُّقِ الرَّهْنِ
u'تَعَلُّقٌ رَهْنٌ':Added, #1: 1	تَعَلُّقُ رَهْنِهِ
u'تَعَلُّقٌ رَهْنٌ':Added, #2: 2	تَعَلُّقُ الرَّهْنِ
u'تَعَلُّقٌ رَهْنٌ':Added, #3: 3	تَعَلُّقَ الرَّهْنِ
u'تَعَلُّقٌ رَهْنٌ':Added, #3: 3	تَعَلُّقَ رَهْنٍ
u'تَعَلُّقٌ روحٌ':Added, #7: 7	تَعَلُّقُ رَهْنٍ
u'تَعَلُّقٌ روحٌ':Added, #1: 1	تَعَلُّقُ الرُّوحِ
u'تَعَلَّقَ زائِدٌ':Subject, #2: 2	تَعَلُّقِ الرُّوحِ
u'تَعَلُّقٌ زَكاةٌ':Added, #1: 1	تَعَلَّقَ الزَّائِدُ
u'تَعَلُّقٌ زَكاةٌ':Added, #11: 11	تَعَلُّقَ الزَّكَاةِ
u'تَعَلُّقٌ زَكاةٌ':Added, #11: 11	تَعَلُّقِ الزَّكَاةِ
u'تَعَلَّقَ زَوالٌ':Subject, #9: 9	تَعَلُّقُ الزَّكَاةِ
u'تَعَلُّقٌ زَيْدٌ':Added, #2: 2	تَعَلَّقَ زَوَالُهُ
u'تَعَلُّقٌ سَلاَمَةٌ':Added, #1: 1	تَعَلُّقُ زَيْدٍ
u'تَعَلُّقٌ سَمْعٌ':Added, #1: 1	تَعَلُّقَ سَلَامَةِ
u'تَعَلُّقٌ سُؤَالٌ':Added, #1: 1	تَعَلُّقِ السَّمْعِ
u'تَعَلُّقٌ سُؤَالٌ':Added, #1: 1	تَعَلُّقُ السُّؤَالِ
u'تَعَلُّقٌ سَيِّدٌ':Added, #1: 1	تَعَلُّقِ السُّؤَالِ
u'تَعَلُّقٌ شَرْطٌ':Added, #1: 1	تَعَلُّقَ السَّيِّدِ
u'تَعَلُّقٌ شَرْطٌ':Added, #1: 1	تَعَلُّقَ الشَّرْطِ
u'تَعَلُّقٌ شركة':Added, #1: 1	تَعَلُّقِ الشَّرْطِ
u'تَعَلُّقٌ شَرِكَةٌ':Added, #1: 1	تَعَلُّقُ الشَّرِكَةِ
u'تَعَلُّقٌ شركة':Added, #1: 1	تَعَلُّقُ الشَّرِكَةِ
u'تَعَلُّقٌ شَرِكَةٌ':Added, #4: 4	تَعَلُّقَ شَرِكَةٍ
u'تَعَلُّقٌ شركة':Added, #4: 4	تَعَلُّقَ شَرِكَةٍ
u'تَعَلُّقٌ شَرِكَةٌ':Added, #9: 9	تَعَلُّقُ شَرِكَةٍ
u'تَعَلُّقٌ شَيْءٌ':Added, #9: 9	تَعَلُّقُ شَرِكَةٍ
u'تَعَلُّقٌ شَيْءٌ':Added, #1: 1	تَعَلُّقِ الشَّيْءِ
u'تَعَلُّقٌ صِفَةٌ':Added, #1: 1	تَعَلُّقِ شَيْءٍ
u'تَعَلُّقٌ صَلاَةٌ':Added, #1: 1	تَعَلُّقِ صِفَتِهِ
u'تَعَلُّقٌ صَلاَةٌ':Added, #1: 1	تَعَلُّقِ الصَّلَاةِ
u'تَعَلَّقَ ضِدٌّ':Subject, #1: 1	تَعَلُّقِ صَلَاةِ
u'تَعَلُّقٌ ضِدٌّ':Added, #1: 1	تَعَلَّقَ ضِدُّهُ
u'تَعَلَّقَ ضَمَانٌ':Subject, #1: 1	تَعَلُّقُ الضِّدِّ
u'تَعَلُّقٌ ضَمَانٌ':Added, #11: 11	تَعَلَّقَ الضَّمَانُ
u'تَعَلُّقٌ ضَمَانٌ':Added, #1: 1	تَعَلُّقَ الضَّمَانِ
u'تَعَلُّقٌ ضَمَانٌ':Added, #2: 2	تَعَلُّقِ الضَّمَانِ
u'تَعَلُّقٌ ضَمَانٌ':Added, #2: 2	تَعَلُّقُ ضَمَانِ
u'تَعَلَّقَ طَلاَقٌ':Subject, #3: 3	تَعَلُّقُ الضَّمَانِ
u'تَعَلَّقَ طَلاَقٌ':Subject, #10: 10	تَعَلَّقَ الطَّلَاقُ
u'تَعَلَّقَ طَلاَقٌ':Subject, #1: 1	تَعَلَّقَ طَلَاقٌ
u'تَعَلُّقٌ طَلاَقٌ':Added, #1: 1	تَعَلَّقَ طَلَاقُ
u'تَعَلُّقٌ طَلاَقٌ':Added, #1: 1	تَعَلُّقَ الطَّلَاقِ
u'تَعَلُّقٌ طَلاَقٌ':Added, #1: 1	تَعَلُّقُ الطَّلَاقِ
u'تَعَلُّقٌ طلب':Added, #1: 1	تَعَلُّقِ الطَّلَاقِ
u'تَعَلُّقٌ طَلَبٌ':Added, #1: 1	تَعَلُّقُ الطَّلَبِ
u'تَعَلُّقٌ طلب':Added, #1: 1	تَعَلُّقُ الطَّلَبِ
u'تَعَلُّقٌ طَلَبٌ':Added, #2: 2	تَعَلُّقِ الطَّلَبِ
u'تَعَلُّقٌ طَهَارَةٌ':Added, #2: 2	تَعَلُّقِ الطَّلَبِ
u'تَعَلُّقٌ طَهَارَةٌ':Added, #1: 1	تَعَلُّقُ الطَّهَارَةِ
u'تَعَلُّقٌ طَهَارَةٌ':Added, #1: 1	تَعَلُّقِ طَهَارَةِ
u'تَعَلَّقَ ظَنٌّ':Subject, #2: 2	تَعَلُّقِ الطَّهَارَةِ
u'تَعَلُّقٌ عَامِلٌ':Added, #1: 1	تَعَلَّقَ الظَّنُّ
u'تَعَلُّقٌ عِبَادَةٌ':Added, #1: 1	تَعَلُّقُ عَامِلَيْنِ
u'تَعَلُّقٌ عِبَادَةٌ':Added, #1: 1	تَعَلُّقِ الْعِبَادَاتِ
u'تَعَلُّقٌ عِبَادَةٌ':Added, #1: 1	تَعَلُّقَ الْعِبَادَةِ
u'تَعَلُّقٌ عِبَادَةٌ':Added, #1: 1	تَعَلُّقُ الْعِبَادَةِ
u'تَعَلَّقَ عتق':Subject, #1: 1	تَعَلُّقِ الْعِبَادَةِ
u'تَعَلَّقَ عِتْقٌ':Subject, #12: 12	تَعَلَّقَ عِتْقُهُ
u'تَعَلَّقَ عتق':Subject, #12: 12	تَعَلَّقَ عِتْقُهُ
u'تَعَلَّقَ عِتْقٌ':Subject, #1: 1	تَعَلَّقَ الْعِتْقُ
u'تَعَلَّقَ عتق':Subject, #1: 1	تَعَلَّقَ الْعِتْقُ
u'تَعَلَّقَ عِتْقٌ':Subject, #1: 1	تَعَلَّقَ عِتْقُ
u'تَعَلُّقٌ عتق':Added, #1: 1	تَعَلَّقَ عِتْقُ
u'تَعَلُّقٌ عِتْقٌ':Added, #1: 1	تَعَلُّقُ الْعِتْقِ
u'تَعَلُّقٌ عَرَضٌ':Added, #1: 1	تَعَلُّقُ الْعِتْقِ
u'تَعَلُّقٌ عِزٌّ':Added, #1: 1	تَعَلُّقُ الْعَرَضِ
u'تَعَلُّقٌ عِزٌّ':Added, #1: 1	تَعَلُّقِ عِزِّ
u'تَعَلُّقٌ عِزٌّ':Added, #1: 1	تَعَلُّقَ عِزِّهِ
u'تَعَلَّقَ عُشْرٌ':Subject, #1: 1	تَعَلُّقِ عِزِّهِ
u'تَعَلُّقٌ عَشْرٌ':Added, #1: 1	تَعَلَّقَ الْعُشْرُ
u'تَعَلَّقَ عَقْدٌ':Subject, #1: 1	تَعَلُّقِ الْعَشْرِ
u'تَعَلُّقٌ عِلَّةٌ':Added, #5: 5	تَعَلَّقَ الْعَقْدُ
u'تَعَلَّقَ علم':Subject, #1: 1	تَعَلُّقَ الْعِلَّةِ
u'تَعَلَّقَ عِلْمٌ':Subject, #1: 1	تَعَلَّقَ عِلْمُهُ
u'تَعَلَّقَ علم':Subject, #1: 1	تَعَلَّقَ عِلْمُهُ
u'تَعَلَّقَ عِلْمٌ':Subject, #4: 4	تَعَلَّقَ الْعِلْمُ
u'تَعَلُّقٌ علم':Added, #4: 4	تَعَلَّقَ الْعِلْمُ
u'تَعَلُّقٌ علم':Added, #1: 1	تَعَلُّقُ عِلْمِ
u'تَعَلُّقٌ عِلْمٌ':Added, #1: 1	تَعَلُّقِ عِلْمِ
u'تَعَلُّقٌ عِلْمٌ':Added, #1: 1	تَعَلُّقُ عِلْمِ
u'تَعَلُّقٌ علم':Added, #1: 1	تَعَلُّقِ عِلْمِ
u'تَعَلُّقٌ عِلْمٌ':Added, #3: 3	تَعَلُّقُ الْعِلْمِ
u'تَعَلُّقٌ علم':Added, #3: 3	تَعَلُّقُ الْعِلْمِ
u'تَعَلُّقٌ عِلْمٌ':Added, #3: 3	تَعَلُّقِ عِلْمِهِ
u'تَعَلُّقٌ علم':Added, #3: 3	تَعَلُّقِ عِلْمِهِ
u'تَعَلُّقٌ عِلْمٌ':Added, #4: 4	تَعَلُّقَ الْعِلْمِ
u'تَعَلُّقٌ علم':Added, #4: 4	تَعَلُّقَ الْعِلْمِ
u'تَعَلُّقٌ عِلْمٌ':Added, #5: 5	تَعَلُّقِ الْعِلْمِ
u'تَعَلُّقٌ غَرَامَةٌ':Added, #5: 5	تَعَلُّقِ الْعِلْمِ
u'تَعَلَّقَ غَرَضٌ':Subject, #1: 1	تَعَلُّقِ الْغَرَامَةِ
u'تَعَلُّقٌ غَرَضٌ':Added, #1: 1	تَعَلَّقَ الْغَرَضُ
u'تَعَلُّقٌ غَرَضٌ':Added, #1: 1	تَعَلُّقُ الْغَرَضِ
u'تَعَلَّقَ غُرْمٌ':Subject, #1: 1	تَعَلُّقِ الْغَرَضِ
u'تَعَلَّقَ غُرْمٌ':Subject, #1: 1	تَعَلَّقَ الْغُرْمُ
u'تَعَلَّقَ غرماء':Subject, #1: 1	تَعَلَّقَ غُرْمُهُ
u'تَعَلُّقٌ غرماء':Added, #1: 1	تَعَلَّقَ الْغُرَمَاءُ
u'تَعَلُّقٌ غرماء':Added, #1: 1	تَعَلُّقَ الْغُرَمَاءِ
u'تَعَلُّقٌ غُسْلٌ':Added, #1: 1	تَعَلُّقُ غُرَمَاءِ
u'تَعَلُّقٌ غير':Added, #1: 1	تَعَلُّقِ الْغُسْلِ
u'تَعَلُّقٌ غَيْرٌ':Added, #1: 1	تَعَلُّقَ الْغَيْرِ
u'تَعَلُّقٌ غير':Added, #1: 1	تَعَلُّقَ الْغَيْرِ
u'تَعَلُّقٌ غَيْرٌ':Added, #1: 1	تَعَلُّقِ غَيْرِهِ
u'تَعَلَّقَ فَاضِلٌ':Subject, #1: 1	تَعَلُّقِ غَيْرِهِ
u'تَعَلُّقٌ فِدَاءٌ':Added, #1: 1	تَعَلَّقَ الْفَاضِلُ
u'تَعَلَّقَ فَرْضٌ':Subject, #1: 1	تَعَلُّقِ الْفِدَاءِ
u'تَعَلَّقَ فَسْخٌ':Subject, #2: 2	تَعَلَّقَ الْفَرْضُ
u'تَعَلُّقٌ فَسْخٌ':Added, #1: 1	تَعَلَّقَ الْفَسْخُ
u'تَعَلَّقَ فِعْلٌ':Subject, #1: 1	تَعَلُّقُ فَسْخِ
u'تَعَلُّقٌ فِعْلٌ':Added, #1: 1	تَعَلَّقَ الْفِعْلُ
u'تَعَلُّقٌ فِعْلٌ':Added, #1: 1	تَعَلُّقَ الْفِعْلِ
u'تَعَلُّقٌ فِعْلٌ':Added, #1: 1	تَعَلُّقِ الْفِعْلِ
u'تَعَلُّقٌ فِقْهٌ':Added, #1: 1	تَعَلُّقِ فِعْلِ
u'تَعَلَّقَ فلان':Subject, #1: 1	تَعَلُّقِ الْفِقْهِ
u'تَعَلُّقٌ قدرة':Added, #1: 1	تَعَلَّقَ الْجُبْرَانُ
u'تَعَلُّقٌ قُدْرَةٌ':Added, #1: 1	تَعَلُّقَ الْقُدْرَةِ
u'تَعَلُّقٌ قدرة':Added, #1: 1	تَعَلُّقَ الْقُدْرَةِ
u'تَعَلُّقٌ قدرة':Added, #1: 1	تَعَلُّقَ قُدْرَتِهِ
u'تَعَلُّقٌ قدرة':Added, #1: 1	تَعَلُّقُ قُدْرَتِهِ
u'تَعَلُّقٌ قُدْرَةٌ':Added, #1: 1	تَعَلُّقِ قُدْرَتِهِ
u'تَعَلُّقٌ قُدْرَةٌ':Added, #1: 1	تَعَلُّقَ قُدْرَتِهِ
u'تَعَلُّقٌ قُدْرَةٌ':Added, #1: 1	تَعَلُّقُ قُدْرَتِهِ
u'تَعَلُّقٌ قدرة':Added, #1: 1	تَعَلُّقِ قُدْرَتِهِ
u'تَعَلُّقٌ قُدْرَةٌ':Added, #2: 2	تَعَلُّقُ الْقُدْرَةِ
u'تَعَلُّقٌ قدرة':Added, #2: 2	تَعَلُّقُ الْقُدْرَةِ
u'تَعَلُّقٌ قُدْرَةٌ':Added, #3: 3	تَعَلُّقِ الْقُدْرَةِ
u'تَعَلُّقٌ قصاص':Added, #3: 3	تَعَلُّقِ الْقُدْرَةِ
u'تَعَلُّقٌ قِصَاصٌ':Added, #2: 2	تَعَلُّقِ الْقِصَاصِ
u'تَعَلُّقٌ قَضَاءٌ':Added, #2: 2	تَعَلُّقِ الْقِصَاصِ
u'تَعَلُّقٌ قَطْعٌ':Added, #1: 1	تَعَلُّقِ الْقَضَاءِ
u'تَعَلَّقَ قلب':Subject, #1: 1	تَعَلُّقِ الْقَطْعِ
u'تَعَلَّقَ قَلْبٌ':Subject, #2: 2	تَعَلَّقَ قَلْبُهُ
u'تَعَلَّقَ قَلْب':Subject, #2: 2	تَعَلَّقَ قَلْبُهُ
u'تَعَلُّقٌ قلب':Added, #2: 2	تَعَلَّقَ قَلْبُهُ
u'تَعَلُّقٌ قَلْبٌ':Added, #1: 1	تَعَلُّقَ الْقَلْبِ
u'تَعَلُّقٌ قَلْب':Added, #1: 1	تَعَلُّقَ الْقَلْبِ
u'تَعَلُّقٌ قلب':Added, #1: 1	تَعَلُّقَ الْقَلْبِ
u'تَعَلُّقٌ قَلْبٌ':Added, #2: 2	تَعَلُّقُ الْقَلْبِ
u'تَعَلُّقٌ قَلْب':Added, #2: 2	تَعَلُّقُ الْقَلْبِ
u'تَعَلَّقَ قول':Subject, #2: 2	تَعَلُّقُ الْقَلْبِ
u'تَعَلَّقَ قَوْلٌ':Subject, #1: 1	تَعَلَّقَ قَوْلُهُ
u'تَعَلُّقٌ قول':Added, #1: 1	تَعَلَّقَ قَوْلُهُ
u'تَعَلُّقٌ قَوْلٌ':Added, #1: 1	تَعَلُّقِ الْقَوْلِ
u'تَعَلُّقٌ قول':Added, #1: 1	تَعَلُّقِ الْقَوْلِ
u'تَعَلُّقٌ قول':Added, #1: 1	تَعَلُّقُ قَوْلِ
u'تَعَلُّقٌ قَوْلٌ':Added, #1: 1	تَعَلُّقِ قَوْلِ
u'تَعَلُّقٌ قَوْلٌ':Added, #1: 1	تَعَلُّقُ قَوْلِ
u'تَعَلَّقَ قَوْمٌ':Subject, #1: 1	تَعَلُّقِ قَوْلِ
u'تَعَلُّقٌ قِيمَةٌ':Added, #1: 1	تَعَلَّقَ قَوْمٌ
u'تَعَلَّقَ كَلاَمٌ':Subject, #1: 1	تَعَلُّقَ الْقِيمَةِ
u'تَعَلُّقٌ كَلاَمٌ':Added, #1: 1	تَعَلَّقَ كَلَامُ
u'تَعَلُّقٌ كَمَالٌ':Added, #1: 1	تَعَلُّقُ كَلَامِ
u'تَعَلُّقٌ لاَمٌ':Added, #1: 1	تَعَلُّقَ كَمَالِ
u'تَعَلُّقٌ لَفْظٌ':Added, #1: 1	تَعَلُّقِ اللَّامِ
u'تَعَلَّقَ مَالٌ':Subject, #1: 1	تَعَلُّقُ اللَّفْظِ
u'تَعَلُّقٌ مَالٌ':Added, #1: 1	تَعَلَّقَ الْمَالُ
u'تَعَلُّقٌ مَالٌ':Added, #1: 1	تَعَلُّقَ الْمَالِ
u'تَعَلُّقٌ مُبْتَدِعٌ':Added, #1: 1	تَعَلُّقُ مَالٍ
u'تَعَلُّقٌ مَبِيعٌ':Added, #1: 1	تَعَلُّقَ الْمُبْتَدِعَةِ
u'تَعَلُّقٌ مُبَيَّنٌ':Added, #1: 1	تَعَلُّقُ الْمَبِيعِ
u'تَعَلَّقَ مُتَأَخِّرٌ':Subject, #1: 1	تَعَلُّقُ الْمُبَيَّنِ
u'تَعَلُّقٌ مُتَأَخِّرٌ':Added, #1: 1	تَعَلَّقَ الْمُتَأَخِّرُ
u'تَعَلُّقٌ مُدْرِكٌ':Added, #1: 1	تَعَلُّقَ الْمُتَأَخِّرِ
u'تَعَلُّقٌ مَسْأَلَةٌ':Added, #1: 1	تَعَلُّقِ الْمُدْرِكَةِ
u'تَعَلُّقٌ مَسْحٌ':Added, #1: 1	تَعَلُّقِ الْمَسْأَلَةِ
u'تَعَلُّقٌ مَشْرُوطٌ':Added, #1: 1	تَعَلُّقَ الْمَسْحِ
u'تَعَلُّقٌ مَشِيئَةٌ':Added, #1: 1	تَعَلُّقِ الْمَشْرُوطِ
u'تَعَلُّقٌ مَشِيئَةٌ':Added, #1: 1	تَعَلُّقَ الْمَشِيئَةِ
u'تَعَلُّقٌ مَشِيئَةٌ':Added, #1: 1	تَعَلُّقُ الْمَشِيئَةِ
u'تَعَلُّقٌ مُطَالَبٌ':Added, #1: 1	تَعَلُّقِ الْمَشِيئَةِ
u'تَعَلُّقٌ مُطَالَبَةٌ':Added, #1: 1	تَعَلُّقِ مُطَالَبَةٍ
u'تَعَلُّقٌ مَعْطُوف':Added, #1: 1	تَعَلُّقِ مُطَالَبَةٍ
u'تَعَلُّقٌ مَفْعُول':Added, #1: 1	تَعَلُّقِ الْمَعْطُوفِ
u'تَعَلُّقٌ مَقْدُورٌ':Added, #1: 1	تَعَلُّقَ الْمَفْعُولِيَّةِ
u'تَعَلُّقٌ مُكَلَّفٌ':Added, #1: 1	تَعَلُّقُ الْمَقْدُورِ
u'تَعَلُّقٌ مِلْكٌ':Added, #1: 1	تَعَلُّقُ مُكَلَّفٍ
u'تَعَلُّقٌ مَنَاسِكُ':Added, #1: 1	تَعَلُّقُ الْمِلْكِ
u'تَعَلُّقٌ مَنْسُوخٌ':Added, #1: 1	تَعَلُّقُ الْمَنَاسِكِ
u'تَعَلُّقٌ مَنْعٌ':Added, #1: 1	تَعَلُّقُ الْمَنْسُوخِ
u'تَعَلَّقَ مَهْرٌ':Subject, #1: 1	تَعَلُّقِ الْمَنْعِ
u'تَعَلُّقٌ مَهْرٌ':Added, #2: 2	تَعَلَّقَ الْمَهْرُ
u'تَعَلَّقَ نَاسٌ':Subject, #1: 1	تَعَلُّقَ الْمَهْرِ
u'تَعَلَّقَ نذر':Subject, #1: 1	تَعَلَّقَ النَّاسُ
u'تَعَلَّقَ نَذْرٌ':Subject, #1: 1	تَعَلَّقَ النَّذْرُ
u'تَعَلُّقٌ نذر':Added, #1: 1	تَعَلَّقَ النَّذْرُ
u'تَعَلُّقٌ نَذْرٌ':Added, #1: 1	تَعَلُّقِ نَذْرِهِ
u'تَعَلَّقَ نِسْيَانٌ':Subject, #1: 1	تَعَلُّقِ نَذْرِهِ
u'تَعَلَّقَ نَفْعٌ':Subject, #1: 1	تَعَلَّقَ النِّسْيَانُ
u'تَعَلُّقٌ نَفَقَةٌ':Added, #1: 1	تَعَلَّقَ نَفْعُهُ
u'تَعَلُّقٌ نَقِيضٌ':Added, #2: 2	تَعَلُّقِ نَفَقَةِ
u'تَعَلَّقَ نكاح':Subject, #1: 1	تَعَلُّقَ نَقِيضِ
u'تَعَلَّقَ نِكَاحٌ':Subject, #1: 1	تَعَلَّقَ النِّكَاحُ
u'تَعَلَّقَ نَهْيٌ':Subject, #1: 1	تَعَلَّقَ النِّكَاحُ
u'تَعَلُّقٌ نَهْيٌ':Added, #2: 2	تَعَلَّقَ النَّهْيُ
u'تَعَلُّقٌ نَهْيٌ':Added, #1: 1	تَعَلُّقُ النَّهْيِ
u'تَعَلُّقٌ وَاقِفٌ':Added, #2: 2	تَعَلُّقِ النَّهْيِ
u'تَعَلَّقَ وُجُوبٌ':Subject, #1: 1	تَعَلُّقَ الْوَاقِفِ
u'تَعَلَّقَ وُجُوبٌ':Subject, #1: 1	تَعَلَّقَ الْوُجُوبُ
u'تَعَلَّقَ وُجُوبٌ':Subject, #1: 1	تَعَلَّقَ وُجُوبُهُ
u'تَعَلُّقٌ وُجُوبٌ':Added, #3: 3	تَعَلَّقَ وُجُوبُ
u'تَعَلُّقٌ وُجُوبٌ':Added, #2: 2	تَعَلُّقَ الْوُجُوبِ
u'تَعَلُّقٌ وُجُوبٌ':Added, #3: 3	تَعَلُّقِ وُجُوبِ
u'تَعَلُّقٌ وُجُوبٌ':Added, #5: 5	تَعَلُّقُ الْوُجُوبِ
u'تَعَلَّقَ وَدَعٌ':Predicate, #9: 9	تَعَلُّقِ الْوُجُوبِ
u'تَعَلُّقٌ وَصِيٌّ':Added, #1: 1	تَعَلَّقَ وَدَعَةً
u'تَعَلُّقٌ وَصِيٌّ':Added, #1: 1	تَعَلُّقَ الْوَصِيَّةِ
u'تَعَلُّقٌ وَصِيَّةٌ':Added, #1: 1	تَعَلُّقِ الْوَصِيَّةِ
u'تَعَلُّقٌ وَصِيَّةٌ':Added, #1: 1	تَعَلُّقَ الْوَصِيَّةِ
u'تَعَلَّقَ وَضْعٌ':Subject, #1: 1	تَعَلُّقِ الْوَصِيَّةِ
u'تَعَلُّمٌ أَحْكَامٌ':Added, #1: 1	تَعَلَّقَ الْوَضْعُ
u'تَعَلُّمٌ أَحْكَامٌ':Added, #1: 1	تَعَلُّمَ أَحْكَامِ
u'تَعَلُّمٌ أَحْكَامٌ':Added, #1: 1	تَعَلُّمُ الْأَحْكَامِ
u'تَعَلُّمٌ أَحْكَامٌ':Added, #1: 1	تَعَلُّمِ الْأَحْكَامِ
u'تَعَلُّمٌ إِخْرَاجٌ':Added, #2: 2	تَعَلُّمُ أَحْكَامِ
u'تَعَلُّمٌ آدابٌ':Added, #1: 1	تَعَلُّمِ إخْرَاجِ
u'تَعَلُّمٌ آدابٌ':Added, #1: 1	تَعَلُّمِ آدَابِ
u'تَعَلُّمٌ أدَب':Added, #1: 1	تَعَلُّمُ الْآدَابِ
u'تَعَلُّمٌ أُصولٌ':Added, #1: 1	تَعَلُّمِ الْأَدَبِ
u'تَعَلُّمٌ أَعْمَالٌ':Added, #1: 1	تَعَلُّمِ أُصُولِ
u'تَعَلَّمَ أُمِّيٌّ':Subject, #1: 1	تَعَلُّمِ أَعْمَالِ
u'تَعَلَّمَ أَنْسَابٌ':Predicate, #2: 2	تَعَلَّمَ أُمِّيٌّ
u'تَعَلَّمَ بَعْضٌ':Predicate, #2: 2	تَعَلَّمَ أَنْسَابَ
u'تَعَلُّمٌ تَشَهُّدٌ':Added, #1: 1	تَعَلَّمَ بَعْضَ
u'تَعَلُّمٌ تَكْبيرٌ':Added, #1: 1	تَعَلُّمِ التَّشَهُّدِ
u'تَعَلُّمٌ تَكْبِير':Added, #1: 1	تَعَلُّمِ التَّكْبِيرِ
u'تَعَلُّمٌ تمام':Added, #1: 1	تَعَلُّمِ تَكْبِيرَةِ
u'تَعَلُّمٌ تَمامٌ':Added, #1: 1	تَعَلُّمِ تَمَامِ
u'تَعَلُّمٌ جَاهِلٌ':Added, #1: 1	تَعَلُّمِ تَمَامِ
u'تَعَلَّمَ حساب':Predicate, #1: 1	تَعَلُّمُ الْجَاهِلِ
u'تَعَلَّمَ حِسَابٌ':Predicate, #2: 2	تَعَلَّمَ الْحِسَابَ
u'تَعَلَّمَ رَمْيٌ':Predicate, #2: 2	تَعَلَّمَ الْحِسَابَ
u'تَعَلُّمٌ رَمْيٌ':Added, #3: 3	تَعَلَّمَ الرَّمْيَ
u'تَعَلَّمَ سِبَاحَةٌ':Predicate, #1: 1	تَعَلُّمَ الرَّمْيِ
u'تَعَلَّمَ سِحْرٌ':Predicate, #1: 1	تَعَلَّمَ السِّبَاحَةَ
u'تَعَلُّمٌ سِحْرٌ':Added, #1: 1	تَعَلَّمَ السِّحْرَ
u'تَعَلَّمَ سُورَةٌ':Predicate, #1: 1	تَعَلُّمَ السِّحْرِ
u'تَعَلَّمَ شِعْرٌ':Predicate, #4: 4	تَعَلَّمَ السُّورَةَ
u'تَعَلُّمٌ شِعْرٌ':Added, #1: 1	تَعَلَّمَ شِعْرَ
u'تَعَلُّمٌ شَيْءٌ':Added, #1: 1	تَعَلُّمِ الشِّعْرِ
u'تَعَلُّمٌ شَيْءٌ':Added, #1: 1	تَعَلُّمَ شَيْءٍ
u'تَعَلَّمَ صَرْفٌ':Predicate, #1: 1	تَعَلُّمُ شَيْءٍ
u'تَعَلَّمَ صَرْف':Predicate, #2: 2	تَعَلَّمَ صَرْفَ
u'تَعَلُّمٌ صنعة':Added, #2: 2	تَعَلَّمَ صَرْفَ
u'تَعَلُّمٌ صنعة':Added, #1: 1	تَعَلُّمَ الصَّنْعَةِ
u'تَعَلُّمٌ صَنْعَةٌ':Added, #1: 1	تَعَلُّمِ الصَّنْعَةِ
u'تَعَلُّمٌ صَنْعَةٌ':Added, #1: 1	تَعَلُّمَ الصَّنْعَةِ
u'تَعَلُّمٌ صنعة':Added, #1: 1	تَعَلُّمِ الصَّنْعَةِ
u'تَعَلُّمٌ صَنْعَةٌ':Added, #1: 1	تَعَلُّمِ صَنْعَةٍ
u'تَعَلُّمٌ صَوَابٌ':Added, #1: 1	تَعَلُّمِ صَنْعَةٍ
u'تَعَلُّمٌ ظاهِرٌ':Added, #2: 2	تَعَلُّمِ الصَّوَابِ
u'تَعَلُّمٌ ظَواهِرُ':Added, #1: 1	تَعَلُّمُ ظَاهِرِ
u'تَعَلَّمَ عَبْدٌ':Subject, #1: 1	تَعَلُّمُ الظَّوَاهِرِ
u'تَعَلَّمَ عَرَبِيٌّ':Predicate, #1: 1	تَعَلَّمَ الْعَبْدُ
u'تَعَلَّمَ علم':Predicate, #2: 2	تَعَلَّمَ الْعَرَبِيَّةَ
u'تَعَلَّمَ عِلْمٌ':Predicate, #6: 6	تَعَلَّمَ الْعِلْمَ
u'تَعَلُّمٌ علم':Added, #6: 6	تَعَلَّمَ الْعِلْمَ
u'تَعَلُّمٌ عِلْمٌ':Added, #1: 1	تَعَلُّمُ الْعِلْمِ
u'تَعَلُّمٌ علم':Added, #1: 1	تَعَلُّمُ الْعِلْمِ
u'تَعَلُّمٌ عِلْمٌ':Added, #2: 2	تَعَلُّمِ الْعِلْمِ
u'تَعَلُّمٌ علم':Added, #2: 2	تَعَلُّمِ الْعِلْمِ
u'تَعَلُّمٌ علم':Added, #2: 2	تَعَلُّمُ عِلْمِ
u'تَعَلُّمٌ عِلْمٌ':Added, #2: 2	تَعَلُّمِ عِلْمِ
u'تَعَلُّمٌ عِلْمٌ':Added, #2: 2	تَعَلُّمُ عِلْمِ
u'تَعَلُّمٌ علم':Added, #2: 2	تَعَلُّمِ عِلْمِ
u'تَعَلُّمٌ عِلْمٌ':Added, #3: 3	تَعَلُّمَ الْعِلْمِ
u'تَعَلُّمٌ عَمَلٌ':Added, #3: 3	تَعَلُّمَ الْعِلْمِ
u'تَعَلُّمٌ غَزْلٌ':Added, #1: 1	تَعَلُّمِ عَمَلٍ
u'تَعَلَّمَ فَاتِحٌ':Predicate, #1: 1	تَعَلُّمِ الْغَزْلِ
u'تَعَلَّمَ فَاتِحَةٌ':Predicate, #1: 1	تَعَلَّمَ الْفَاتِحَةَ
u'تَعَلَّمَ فَرَائِضُ':Predicate, #1: 1	تَعَلَّمَ الْفَاتِحَةَ
u'تَعَلَّمَ فِقْهٌ':Predicate, #1: 1	تَعَلَّمَ الْفَرَائِضَ
u'تَعَلُّمٌ فِقْهٌ':Added, #1: 1	تَعَلَّمَ الْفِقْهَ
u'تَعَلُّمٌ فِقْهٌ':Added, #1: 1	تَعَلُّمُ الْفِقْهِ
u'تَعَلُّمٌ قِبْلَةٌ':Added, #1: 1	تَعَلُّمِ الْفِقْهِ
u'تَعَلَّمَ قِرَاءةٌ':Predicate, #1: 1	تَعَلُّمُ الْقِبْلَةِ
u'تَعَلَّمَ قُرْآنٌ':Predicate, #1: 1	تَعَلَّمَ الْقِرَاءَةَ
u'تَعَلُّمٌ قُرْآنٌ':Added, #10: 10	تَعَلَّمَ الْقُرْآنَ
u'تَعَلُّمٌ قُرْآنٌ':Added, #2: 2	تَعَلُّمُ الْقُرْآنِ
u'تَعَلُّمٌ كِتَابَةٌ':Added, #6: 6	تَعَلُّمِ الْقُرْآنِ
u'تَعَلُّمٌ كَلاَمٌ':Added, #1: 1	تَعَلُّمَ الْكِتَابَةِ
u'تَعَلُّمٌ كَلْبٌ':Added, #1: 1	تَعَلُّمُ الْكَلَامِ
u'تَعَلَّمَ لُغَةٌ':Predicate, #1: 1	تَعَلُّمِ الْكَلْبِ
u'تَعَلُّمٌ لُغَةٌ':Added, #1: 1	تَعَلَّمَ اللُّغَةَ
u'تَعَلُّمٌ مَسْأَلَةٌ':Added, #1: 1	تَعَلُّمُ اللُّغَةِ
u'تَعَلُّمٌ مَسَائِلُ':Added, #1: 1	تَعَلُّمِ الْمَسْأَلَةِ
u'تَعَلُّمٌ نِساءٌ':Added, #1: 1	تَعَلُّمُ مَسَائِلِ
u'تَعَلُّمٌ ولدان':Added, #1: 1	تَعَلُّمِ النِّسَاءِ
u'تَعْلِيقٌ إبَاحَةٌ':Added, #1: 1	تَعَلُّمِ الْوِلْدَانِ
u'تَعْلِيقٌ إِبَانَةٌ':Added, #1: 1	تَعْلِيقُ الْإِبَاحَةِ
u'تَعْلِيقٌ اِبْتِداءٌ':Added, #1: 1	تَعْلِيقُ الْإِبَانَةِ
u'تَعْلِيقٌ إِبْطَالٌ':Added, #1: 1	تَعْلِيقَ ابْتِدَاءِ
u'تَعْلِيقٌ إِبْطَالٌ':Added, #1: 1	تَعْلِيقُ إبْطَالِ
u'تَعْلِيقٌ إِبْطَالٌ':Added, #1: 1	تَعْلِيقِ إبْطَالِ
u'تَعْلِيقٌ اِبْنٌ':Added, #2: 2	تَعْلِيقُ إبْطَالِهِ
u'تَعْلِيقٌ أُتْرُجٌّ':Added, #8: 8	تَعْلِيقِ ابْنِ
u'تَعْلِيقٌ إِثْمٌ':Added, #1: 1	تَعْلِيقُ الْأُتْرُجِّ
u'تَعْلِيقٌ إِجَابَةٌ':Added, #1: 1	تَعْلِيقَ الْإِثْمِ
u'تَعْلِيقٌ إجَارَةٌ':Added, #1: 1	تَعْلِيقَ الْإِجَابَةِ
u'تَعْلِيقٌ إجَازَةٌ':Added, #1: 1	تَعْلِيقُ الْإِجَارَةِ
u'تَعْلِيقٌ إجَازَةٌ':Added, #1: 1	تَعْلِيقُ إجَازَتِهِ
u'تَعْلِيقٌ أَجْرَاسٌ':Added, #4: 4	تَعْلِيقُ الْإِجَازَةِ
u'تَعْلِيقٌ إِحْرَامٌ':Added, #1: 1	تَعْلِيقِ الأَجْرَاسِ
u'تَعْلِيقٌ أَحْكَامٌ':Added, #1: 1	تَعْلِيقِ الْإِحْرَامِ
u'تَعْلِيقٌ أَحْكَامٌ':Added, #1: 1	تَعْلِيقُ الْأَحْكَامِ
u'تَعْلِيقٌ أَحْكَامٌ':Added, #2: 2	تَعْلِيقَ الْأَحْكَامِ
u'تَعْلِيقٌ اِخْتِيَارٌ':Added, #4: 4	تَعْلِيقِ الْأَحْكَامِ
u'تَعْلِيقٌ إِذْنٌ':Added, #1: 1	تَعْلِيقُ اخْتِيَارِ
u'تَعْلِيقٌ إِرَادَةٌ':Added, #1: 1	تَعْلِيقَ الْإِذْنِ
u'تَعْلِيقٌ اِسْتِحْقَاقٌ':Added, #1: 1	تَعْلِيقَ الْإِرَادَةِ
u'تَعْلِيقٌ إِسْقاطٌ':Added, #1: 1	تَعْلِيقُ اسْتِحْقَاقٍ
u'تَعْلِيقٌ إِسْقاطٌ':Added, #1: 1	تَعْلِيقُ إسْقَاطِهِ
u'تَعْلِيقٌ إِسْقاطٌ':Added, #1: 1	تَعْلِيقَ الْإِسْقَاطِ
u'تَعْلِيقٌ أصل':Added, #2: 2	تَعْلِيقُ الْإِسْقَاطِ
u'تَعْلِيقٌ أًصْلٌ':Added, #1: 1	تَعْلِيقِ الْأَصْلِ
u'تَعْلِيقٌ أصل':Added, #1: 1	تَعْلِيقِ الْأَصْلِ
u'تَعْلِيقٌ أصل':Added, #2: 2	تَعْلِيقَ أَصْلِ
u'تَعْلِيقٌ أًصْلٌ':Added, #2: 2	تَعْلِيقُ أَصْلِ
u'تَعْلِيقٌ أًصْلٌ':Added, #2: 2	تَعْلِيقَ أَصْلِ
u'تَعْلِيقٌ أصل':Added, #2: 2	تَعْلِيقُ أَصْلِ
u'تَعْلِيقٌ أًصْلٌ':Added, #3: 3	تَعْلِيقِ أَصْلِ
u'تَعْلِيقٌ إِطْلاقٌ':Added, #3: 3	تَعْلِيقِ أَصْلِ
u'تَعْلِيقٌ إقالَةٌ':Added, #1: 1	تَعْلِيقَ الْإِطْلَاقَاتِ
u'تَعْلِيقٌ إقْرَارٌ':Added, #4: 4	تَعْلِيقُ الْإِقَالَةِ
u'تَعْلِيقٌ إقْرَارٌ':Added, #1: 1	تَعْلِيقَ الْإِقْرَارِ
u'تَعْلِيقٌ إقْرَارٌ':Added, #3: 3	تَعْلِيقِ الْإِقْرَارِ
u'تَعْلِيقٌ اِلْتِزَامٌ':Added, #4: 4	تَعْلِيقُ الْإِقْرَارِ
u'تَعْلِيقٌ أَلْفَاظٌ':Added, #2: 2	تَعْلِيقُ الْتِزَامِ
u'تَعْلِيقٌ أَمْرٌ':Added, #1: 1	تَعْلِيقَ الْأَلْفَاظِ
u'تَعْلِيقٌ أَمْرٌ':Added, #1: 1	تَعْلِيقَ الْأَمْرِ
u'تَعْلِيقٌ إِنْشاءٌ':Added, #2: 2	تَعْلِيقُ الْأَمْرِ
u'تَعْلِيقٌ أَنْوَارٌ':Added, #1: 1	تَعْلِيقُ إنْشَاءٍ
u'تَعْلِيقٌ إِيجَابٌ':Added, #2: 2	تَعْلِيقِ الْأَنْوَارِ
u'تَعْلِيقٌ إِيجَابٌ':Added, #1: 1	تَعْلِيقِ الْإِيجَابِ
u'تَعْلِيقٌ إِيدَاعٌ':Added, #1: 1	تَعْلِيقَ إيجَابِ
u'تَعْلِيقٌ بَابٌ':Added, #2: 2	تَعْلِيقِ الْإِيدَاعِ
u'تَعْلِيقٌ بَابٌ':Added, #1: 1	تَعْلِيقِ الْبَابِ
u'تَعْلِيقٌ بَائِنٌ':Added, #1: 1	تَعْلِيقِ بَابٍ
u'تَعْلِيقٌ بَراءةٌ':Added, #1: 1	تَعْلِيقَ الْبَائِنِ
u'تَعْلِيقٌ بَراءةٌ':Added, #16: 16	تَعْلِيقُ الْبَرَاءَةِ
u'تَعْلِيقٌ بَراءةٌ':Added, #1: 1	تَعْلِيقُ بَرَاءَةِ
u'تَعْلِيقٌ بَراءةٌ':Added, #1: 1	تَعْلِيقِ بَرَاءَةِ
u'تَعْلِيقٌ بَراءةٌ':Added, #2: 2	تَعْلِيقَ الْبَرَاءَةِ
u'تَعْلِيقٌ بَعْضٌ':Added, #3: 3	تَعْلِيقِ الْبَرَاءَةِ
u'تَعْلِيقٌ بَيْعٌ':Added, #1: 1	تَعْلِيقِ بَعْضِ
u'تَعْلِيقٌ تَأْجِيلٌ':Added, #1: 1	تَعْلِيقُ الْبَيْعِ
u'تَعْلِيقٌ تَخْيِيرٌ':Added, #1: 1	تَعْلِيقُ التَّأْجِيلِ
u'تَعْلِيقٌ تَدْبِيرٌ':Added, #1: 1	تَعْلِيقُ التَّخْيِيرِ
u'تَعْلِيقٌ تَدْبِيرٌ':Added, #1: 1	تَعْلِيقُ التَّدْبِيرِ
u'تَعْلِيقٌ تَسْلِيمٌ':Added, #1: 1	تَعْلِيقِ التَّدْبِيرِ
u'تَعْلِيقٌ تَصَرُّفٌ':Added, #2: 2	تَعْلِيقُ تَسْلِيمِ
u'تَعْلِيقٌ تَصَرُّفٌ':Added, #1: 1	تَعْلِيق تَصَرُّفٍ
u'تَعْلِيقٌ تَصَرُّفٌ':Added, #2: 2	تَعْلِيقُ التَّصَرُّفِ
u'تَعْلِيقٌ تَطْلِيقٌ':Added, #2: 2	تَعْلِيقُ تَصَرُّفٍ
u'تَعْلِيقٌ تَطْلِيقٌ':Added, #1: 1	تَعْلِيقِ التَّطْلِيقِ
u'تَعْلِيقٌ تَعْلِيقٌ':Added, #4: 4	تَعْلِيقُ التَّطْلِيقِ
u'تَعْلِيقٌ تَعْلِيقٌ':Added, #1: 1	تَعْلِيقُ التَّعْلِيقِ
u'تَعْلِيقٌ تَعْوِيذٌ':Added, #3: 3	تَعْلِيقِ التَّعْلِيقِ
u'تَعْلِيقٌ تَفْوِيضٌ':Added, #1: 1	تَعْلِيقُ التَّعْوِيذِ
u'تَعْلِيقٌ تَقْليدٌ':Added, #4: 4	تَعْلِيقُ التَّفْوِيضِ
u'تَعْلِيقٌ تَقْليدٌ':Added, #1: 1	تَعْلِيقُ التَّقْلِيدِ
u'تَعْلِيقٌ تَقْليد':Added, #1: 1	تَعْلِيقِ التَّقْلِيدِ
u'تَعْلِيقٌ تَقْليد':Added, #1: 1	تَعْلِيقُ التَّقْلِيدِ
u'تَعْلِيقٌ تَكْليفٌ':Added, #1: 1	تَعْلِيقِ التَّقْلِيدِ
u'تَعْلِيقٌ تَكْليفٌ':Added, #2: 2	تَعْلِيقُ التَّكْلِيفِ
u'تَعْلِيقٌ تمام':Added, #2: 2	تَعْلِيقِ التَّكْلِيفِ
u'تَعْلِيقٌ تَمامٌ':Added, #1: 1	تَعْلِيقِ تَمَامِ
u'تَعْلِيقٌ تَمَائِمُ':Added, #1: 1	تَعْلِيقِ تَمَامِ
u'تَعْلِيقٌ تَمْلِيك':Added, #1: 1	تَعْلِيقُ التَّمَائِمِ
u'تَعْلِيقٌ تَمْلِيكٌ':Added, #1: 1	تَعْلِيقِ التَّمْلِيكِ
u'تَعْلِيقٌ تَمْلِيك':Added, #2: 2	تَعْلِيقُ التَّمْلِيكَاتِ
u'تَعْلِيقٌ تَمِيمَةٌ':Added, #5: 5	تَعْلِيقُ التَّمْلِيكِ
u'تَعْلِيقٌ تَوْكِيلٌ':Added, #2: 2	تَعْلِيقَ التَّمِيمَةِ
u'تَعْلِيقٌ تَوْكِيلٌ':Added, #2: 2	تَعْلِيقُ تَوْكِيلٍ
u'تَعْلِيقٌ ثَلاثُ':Added, #5: 5	تَعْلِيقُ التَّوْكِيلِ
u'تَعْلِيقٌ ثَلاثُ':Added, #1: 1	تَعْلِيقَ الثَّلَاثِ
u'تَعْلِيقٌ ثَوْبٌ':Added, #3: 3	تَعْلِيقُ الثَّلَاثِ
u'تَعْلِيقٌ جَرَسٌ':Added, #1: 1	تَعْلِيقِ الثَّوْبِ
u'تَعْلِيقٌ جَرَسٌ':Added, #1: 1	تَعْلِيقَ الْجَرَسِ
u'تَعْلِيقٌ جَرَسٌ':Added, #1: 1	تَعْلِيقُ الْجَرَسِ
u'تَعْلِيقٌ جَرَسٌ':Added, #1: 1	تَعْلِيقِ الْجَرَسِ
u'تَعْلِيقٌ جَزَاءٌ':Added, #2: 2	تَعْلِيقُ جَرَسٍ
u'تَعْلِيقٌ حالٌ':Added, #3: 3	تَعْلِيقُ الْجَزَاءِ
u'تَعْلِيقٌ حَجْرٌ':Added, #1: 1	تَعْلِيقَ الْحَالِ
u'تَعْلِيقٌ حُرٌّ':Added, #1: 1	تَعْلِيقُ الْحَجْرِ
u'تَعْلِيقٌ حِرْمَانٌ':Added, #1: 1	تَعْلِيقُ الْحُرِّ
u'تَعْلِيقٌ حُرِّيَّةٌ':Added, #3: 3	تَعْلِيقُ الْحِرْمَانِ
u'تَعْلِيقٌ حُرِّيَّةٌ':Added, #1: 1	تَعْلِيقُ حُرِّيَّةِ
u'تَعْلِيقٌ حُرِّيَّةٌ':Added, #2: 2	تَعْلِيقُ الْحُرِّيَّةِ
u'تَعْلِيقٌ حَرِيرٌ':Added, #2: 2	تَعْلِيقِ الْحُرِّيَّةِ
u'تَعْلِيقٌ حُصُول':Added, #1: 1	تَعْلِيقُ الْحَرِيرِ
u'تَعْلِيقٌ حُكْمٌ':Added, #1: 1	تَعْلِيقُ حُصُولِ
u'تَعْلِيقٌ حُكْمٌ':Added, #1: 1	تَعْلِيقَ حُكْمِ
u'تَعْلِيقٌ حُكْمٌ':Added, #1: 1	تَعْلِيقُ حُكْمٍ
u'تَعْلِيقٌ حُكْمٌ':Added, #24: 24	تَعْلِيقُ الْحُكْمِ
u'تَعْلِيقٌ حُكْمٌ':Added, #5: 5	تَعْلِيقَ الْحُكْمِ
u'تَعْلِيقٌ حَوَالَةٌ':Added, #8: 8	تَعْلِيقِ الْحُكْمِ
u'تَعْلِيقٌ خُبْزٌ':Added, #1: 1	تَعْلِيقُ الْحَوَالَةِ
u'تَعْلِيقٌ خُبْزٌ':Added, #1: 1	تَعْلِيقِ الْخُبْزِ
u'تَعْلِيقٌ خَرَزَةٌ':Added, #2: 2	تَعْلِيقُ الْخُبْزِ
u'تَعْلِيقٌ خُرُوجٌ':Added, #1: 1	تَعْلِيقِ خَرَزَةٍ
u'تَعْلِيقٌ خُصُومَةٌ':Added, #1: 1	تَعْلِيقَ خُرُوجِهِ
u'تَعْلِيقٌ خِطَابٌ':Added, #1: 1	تَعْلِيقِ الْخُصُومَةِ
u'تَعْلِيقٌ خلاص':Added, #1: 1	تَعْلِيقِ خِطَابِ
u'تَعْلِيقٌ خَلاَصٌ':Added, #1: 1	تَعْلِيقُ الْخَلَاصِ
u'تَعْلِيقٌ خِلاَفٌ':Added, #1: 1	تَعْلِيقُ الْخَلَاصِ
u'تَعْلِيقٌ خُلْعٌ':Added, #1: 1	تَعْلِيقِ الْخِلَافِ
u'تَعْلِيقٌ خيار':Added, #1: 1	تَعْلِيقُ الْخُلْعِ
u'تَعْلِيقٌ خِيَارٌ':Added, #1: 1	تَعْلِيقُ خِيَارِ
u'تَعْلِيقٌ دَعْوَةٌ':Added, #1: 1	تَعْلِيقُ خِيَارِ
u'تَعْلِيقٌ دَوْرٌ':Added, #1: 1	تَعْلِيقُ دَعْوَةِ
u'تَعْلِيقٌ دَيْنٌ':Added, #4: 4	تَعْلِيقَ الدَّوْرِ
u'تَعْلِيقٌ رجعة':Added, #1: 1	تَعْلِيقِ الدَّيْنِ
u'تَعْلِيقٌ رَجْعَةٌ':Added, #5: 5	تَعْلِيقُ الرَّجْعَةِ
u'تَعْلِيقٌ رَجُلٌ':Added, #5: 5	تَعْلِيقُ الرَّجْعَةِ
u'تَعْلِيقٌ رُجُوعٌ':Added, #1: 1	تَعْلِيقِ الرَّجُلِ
u'تَعْلِيقٌ رُخْصَةٌ':Added, #1: 1	تَعْلِيقُ الرُّجُوعِ
u'تَعْلِيقٌ رَدٌّ':Added, #2: 2	تَعْلِيقِ الرُّخْصَةِ
u'تَعْلِيقٌ رَدٌّ':Added, #1: 1	تَعْلِيقَ الرَّدِّ
u'تَعْلِيقٌ زَوْجٌ':Added, #2: 2	تَعْلِيقُ الرَّدِّ
u'تَعْلِيقٌ زَوْجٌ':Added, #1: 1	تَعْلِيقَ الزَّوْجِ
u'تَعْلِيقٌ زِيادَةٌ':Added, #1: 1	تَعْلِيقِ الزَّوْجِ
u'تَعْلِيقٌ سَبَبٌ':Added, #1: 1	تَعْلِيقِ الزِّيَادَةِ
u'تَعْلِيقٌ سَبَبٌ':Added, #1: 1	تَعْلِيقَ سَبَبِ
u'تَعْلِيقٌ سُتُورٌ':Added, #2: 2	تَعْلِيقُ سَبَبِ
u'تَعْلِيقٌ سُتُورٌ':Added, #1: 1	تَعْلِيقَ السُّتُورِ
u'تَعْلِيقٌ سَيِّدٌ':Added, #1: 1	تَعْلِيقُ السُّتُورِ
u'تَعْلِيقٌ شرب':Added, #3: 3	تَعْلِيقِ السَّيِّدِ
u'تَعْلِيقٌ شُرْبٌ':Added, #1: 1	تَعْلِيقَ الشُّرْبِ
u'تَعْلِيقٌ شَرْطٌ':Added, #1: 1	تَعْلِيقَ الشُّرْبِ
u'تَعْلِيقٌ شُرُوعٌ':Added, #1: 1	تَعْلِيقُ الشَّرْطِ
u'تَعْلِيقٌ شَيْءٌ':Added, #1: 1	تَعْلِيقُ الشُّرُوعِ
u'تَعْلِيقٌ شَيْءٌ':Added, #1: 1	تَعْلِيقُ الشَّيْءِ
u'تَعْلِيقٌ شَيْءٌ':Added, #1: 1	تَعْلِيقِ الشَّيْءِ
u'تَعْلِيقٌ شَيْءٌ':Added, #1: 1	تَعْلِيقُ شَيْءٍ
u'تَعْلِيقٌ شَيْخٌ':Added, #1: 1	تَعْلِيقِ شَيْءٍ
u'تَعْلِيقٌ صِفَةٌ':Added, #16: 16	تَعْلِيقِ الشَّيْخِ
u'تَعْلِيقٌ ضَمَانٌ':Added, #1: 1	تَعْلِيقُ صِفَةِ
u'تَعْلِيقٌ ضَمَانٌ':Added, #1: 1	تَعْلِيقَ الضَّمَانِ
u'تَعْلِيقٌ ضَمَانٌ':Added, #2: 2	تَعْلِيقِ الضَّمَانِ
u'تَعْلِيقٌ طَلاَقٌ':Added, #3: 3	تَعْلِيقِ ضَمَانٍ
u'تَعْلِيقٌ طَلاَقٌ':Added, #18: 18	تَعْلِيقَ الطَّلَاقِ
u'تَعْلِيقٌ طَلاَقٌ':Added, #18: 18	تَعْلِيقُ الطَّلَاقِ
u'تَعْلِيقٌ طَلاَقٌ':Added, #1: 1	تَعْلِيقُ طَلَاقٍ
u'تَعْلِيقٌ طَلاَقٌ':Added, #1: 1	تَعْلِيقِ طَلَاقٍ
u'تَعْلِيقٌ طَلاَقٌ':Added, #3: 3	تَعْلِيقَ طَلَاقِ
u'تَعْلِيقٌ طَلاَقٌ':Added, #4: 4	تَعْلِيقُ طَلَاقِ
u'تَعْلِيقٌ طَلاَقٌ':Added, #6: 6	تَعْلِيقِ طَلَاقِ
u'تَعْلِيقٌ طَلْعٌ':Added, #70: 70	تَعْلِيقِ الطَّلَاقِ
u'تَعْلِيقٌ طَهَارَةٌ':Added, #3: 3	تَعْلِيقُ طَلْعِ
u'تَعْلِيقٌ طَهَارَةٌ':Added, #1: 1	تَعْلِيقُ الطَّهَارَةِ
u'تَعْلِيقٌ ظهار':Added, #1: 1	تَعْلِيقِ الطَّهَارَةِ
u'تَعْلِيقٌ ظهار':Added, #1: 1	تَعْلِيقَ الظِّهَارِ
u'تَعْلِيقٌ عَبْدٌ':Added, #1: 1	تَعْلِيقِ الظِّهَارِ
u'تَعْلِيقٌ عتاق':Added, #1: 1	تَعْلِيقُ الْعَبْدِ
u'تَعْلِيقٌ عتاق':Added, #1: 1	تَعْلِيقُ الْعَتَاقِ
u'تَعْلِيقٌ عِتْقٌ':Added, #2: 2	تَعْلِيقِ الْعَتَاقِ
u'تَعْلِيقٌ عتق':Added, #10: 10	تَعْلِيقُ عِتْقٍ
u'تَعْلِيقٌ عِتْقٌ':Added, #11: 11	تَعْلِيقَ الْعِتْقِ
u'تَعْلِيقٌ عتق':Added, #11: 11	تَعْلِيقَ الْعِتْقِ
u'تَعْلِيقٌ عِتْقٌ':Added, #15: 15	تَعْلِيقِ الْعِتْقِ
u'تَعْلِيقٌ عتق':Added, #15: 15	تَعْلِيقِ الْعِتْقِ
u'تَعْلِيقٌ عِتْقٌ':Added, #1: 1	تَعْلِيقَ عِتْقِ
u'تَعْلِيقٌ عتق':Added, #1: 1	تَعْلِيقَ عِتْقِ
u'تَعْلِيقٌ عِتْقٌ':Added, #28: 28	تَعْلِيقُ الْعِتْقِ
u'تَعْلِيقٌ عتق':Added, #28: 28	تَعْلِيقُ الْعِتْقِ
u'تَعْلِيقٌ عِتْقٌ':Added, #2: 2	تَعْلِيقِ عِتْقِ
u'تَعْلِيقٌ عِتْقٌ':Added, #2: 2	تَعْلِيقِ عِتْقِ
u'تَعْلِيقٌ عتق':Added, #3: 3	تَعْلِيقِ عِتْقٍ
u'تَعْلِيقٌ عِتْقٌ':Added, #3: 3	تَعْلِيقُ عِتْقِهِ
u'تَعْلِيقٌ عتق':Added, #3: 3	تَعْلِيقُ عِتْقِهِ
u'تَعْلِيقٌ عِتْقٌ':Added, #4: 4	تَعْلِيقُ عِتْقِ
u'تَعْلِيقٌ عتق':Added, #4: 4	تَعْلِيقُ عِتْقِ
u'تَعْلِيقٌ عِتْقٌ':Added, #4: 4	تَعْلِيقِ عِتْقِهِ
u'تَعْلِيقٌ عَدَدٌ':Added, #4: 4	تَعْلِيقِ عِتْقِهِ
u'تَعْلِيقٌ عزل':Added, #1: 1	تَعْلِيقِ عَدَدِ
u'تَعْلِيقٌ عزل':Added, #1: 1	تَعْلِيقَ الْعَزْلِ
u'تَعْلِيقٌ عزل':Added, #1: 1	تَعْلِيقِ عَزْلِ
u'تَعْلِيقٌ عزل':Added, #2: 2	تَعْلِيقِ الْعَزْلِ
u'تَعْلِيقٌ عزل':Added, #2: 2	تَعْلِيقُ عَزْلِ
u'تَعْلِيقٌ علم':Added, #4: 4	تَعْلِيقُ الْعَزْلِ
u'تَعْلِيقٌ عِلْمٌ':Added, #1: 1	تَعْلِيقِ الْعِلْمِ
u'تَعْلِيقٌ عَمَلٌ':Added, #1: 1	تَعْلِيقِ الْعِلْمِ
u'تَعْلِيقٌ غُرَفٌ':Added, #1: 1	تَعْلِيقُ عَمَلٍ
u'تَعْلِيقٌ غرماء':Added, #1: 1	تَعْلِيقُ الْغُرَفِ
u'تَعْلِيقٌ فَسْخٌ':Added, #1: 1	تَعْلِيقِ الْغُرَمَاءِ
u'تَعْلِيقٌ فَسْخٌ':Added, #1: 1	تَعْلِيقُ فَسْخٍ
u'تَعْلِيقٌ فَسْخٌ':Added, #4: 4	تَعْلِيقُ فَسْخِ
u'تَعْلِيقٌ فُضُولِيٌّ':Added, #6: 6	تَعْلِيقُ الْفَسْخِ
u'تَعْلِيقٌ قُرْبَةٌ':Added, #2: 2	تَعْلِيقِ الْفُضُولِيِّ
u'تَعْلِيقٌ قُرْبَةٌ':Added, #1: 1	تَعْلِيقُ الْقُرْبَةِ
u'تَعْلِيقٌ قَسَمٌ':Added, #1: 1	تَعْلِيقُ قُرْبَةٍ
u'تَعْلِيقٌ قَسَمٌ':Added, #1: 1	تَعْلِيقَ الْقَسَمِ
u'تَعْلِيقٌ قصاص':Added, #1: 1	تَعْلِيقُ الْقَسَمِ
u'تَعْلِيقٌ قِصَاصٌ':Added, #1: 1	تَعْلِيقِ الْقِصَاصِ
u'تَعْلِيقٌ قَضَاءٌ':Added, #1: 1	تَعْلِيقِ الْقِصَاصِ
u'تَعْلِيقٌ قَضَاءٌ':Added, #1: 1	تَعْلِيقَ الْقَضَاءِ
u'تَعْلِيقٌ قَضَاءٌ':Added, #1: 1	تَعْلِيقُ الْقَضَاءِ
u'تَعْلِيقٌ قِلاَدَةٌ':Added, #1: 1	تَعْلِيقِ الْقَضَاءِ
u'تَعْلِيقٌ قلب':Added, #1: 1	تَعْلِيقُ قِلَادَةٍ
u'تَعْلِيقٌ قَلْبٌ':Added, #1: 1	تَعْلِيقُ الْقَلْبِ
u'تَعْلِيقٌ قَلْب':Added, #1: 1	تَعْلِيقُ الْقَلْبِ
u'تَعْلِيقٌ قَنَادِيلُ':Added, #1: 1	تَعْلِيقُ الْقَلْبِ
u'تَعْلِيقٌ قَنَادِيلُ':Added, #1: 1	تَعْلِيقُ الْقَنَادِيلِ
u'تَعْلِيقٌ قِنْدِيلٌ':Added, #1: 1	تَعْلِيقِ قَنَادِيلِ
u'تَعْلِيقٌ قِنْدِيلٌ':Added, #1: 1	تَعْلِيقَ الْقِنْدِيلِ
u'تَعْلِيقٌ كِتَابَةٌ':Added, #1: 1	تَعْلِيقِ الْقِنْدِيلِ
u'تَعْلِيقٌ كَفَالَةٌ':Added, #1: 1	تَعْلِيقَ الْكِتَابَةِ
u'تَعْلِيقٌ كَفَالَةٌ':Added, #10: 10	تَعْلِيقُ الْكَفَالَةِ
u'تَعْلِيقٌ كَفَالَةٌ':Added, #4: 4	تَعْلِيقَ الْكَفَالَةِ
u'تَعْلِيقٌ كفر':Added, #4: 4	تَعْلِيقِ الْكَفَالَةِ
u'تَعْلِيقٌ كُفْرٌ':Added, #1: 1	تَعْلِيقَ الْكُفْرِ
u'تَعْلِيقٌ لَفْظٌ':Added, #1: 1	تَعْلِيقَ الْكُفْرِ
u'تَعْلِيقٌ لَفْظٌ':Added, #2: 2	تَعْلِيقُ اللَّفْظِ
u'تَعْلِيقٌ مُحَمَّدٌ':Added, #2: 2	تَعْلِيقُ لَفْظٍ
u'تَعْلِيقٌ مُحَمَّدٌ':Added, #1: 1	تَعْلِيقُ مُحَمَّدٍ
u'تَعْلِيقٌ مَسْأَلَةٌ':Added, #1: 1	تَعْلِيقِ مُحَمَّدٍ
u'تَعْلِيقٌ مَشِيئَةٌ':Added, #1: 1	تَعْلِيقَ مَسْأَلَةِ
u'تَعْلِيقٌ مُصْحَفٌ':Added, #1: 1	تَعْلِيقُ الْمَشِيئَةِ
u'تَعْلِيقٌ مُصَنِّفٌ':Added, #1: 1	تَعْلِيقِ مُصْحَفٍ
u'تَعْلِيقٌ مَضْمُونٌ':Added, #1: 1	تَعْلِيقِ الْمُصَنِّفِ
u'تَعْلِيقٌ مُعْسِرٌ':Added, #1: 1	تَعْلِيقُ مَضْمُونِ
u'تَعْلِيقٌ مَقْطُوعٌ':Added, #1: 1	تَعْلِيقِ الْمُعْسِرِ
u'تَعْلِيقٌ مَقْطُوعَةٌ':Added, #1: 1	تَعْلِيقَ الْمَقْطُوعَةِ
u'تَعْلِيقٌ مَكْرُوهٌ':Added, #1: 1	تَعْلِيقَ الْمَقْطُوعَةِ
u'تَعْلِيقٌ مُكَلَّفٌ':Added, #1: 1	تَعْلِيقِ الْمَكْرُوهِ
u'تَعْلِيقٌ مِلْكٌ':Added, #1: 1	تَعْلِيقُ مُكَلَّفٍ
u'تَعْلِيقٌ مَنْذُور':Added, #2: 2	تَعْلِيقِ الْمِلْكِ
u'تَعْلِيقٌ نذر':Added, #1: 1	تَعْلِيقِ الْمَنْذُورِ
u'تَعْلِيقٌ نَذْرٌ':Added, #1: 1	تَعْلِيقُ النَّذْرِ
u'تَعْلِيقٌ نذر':Added, #1: 1	تَعْلِيقُ النَّذْرِ
u'تَعْلِيقٌ نذر':Added, #2: 2	تَعْلِيقَ النَّذْرِ
u'تَعْلِيقٌ نَذْرٌ':Added, #2: 2	تَعْلِيقِ النَّذْرِ
u'تَعْلِيقٌ نَذْرٌ':Added, #2: 2	تَعْلِيقَ النَّذْرِ
u'تَعْلِيقٌ نِصْفٌ':Added, #2: 2	تَعْلِيقِ النَّذْرِ
u'تَعْلِيقٌ نَفَقَةٌ':Added, #1: 1	تَعْلِيقُ نِصْفِهِ
u'تَعْلِيقٌ نَقْضٌ':Added, #1: 1	تَعْلِيقِ نَفَقَةِ
u'تَعْلِيقٌ نكاح':Added, #2: 2	تَعْلِيقَ النَّقْضِ
u'تَعْلِيقٌ نِكَاحٌ':Added, #4: 4	تَعْلِيقُ النِّكَاحِ
u'تَعْلِيقٌ نِيَّةٌ':Added, #4: 4	تَعْلِيقُ النِّكَاحِ
u'تَعْلِيقٌ هِبَةٌ':Added, #1: 1	تَعْلِيقِ نِيَّةِ
u'تَعْلِيقٌ هِبَةٌ':Added, #1: 1	تَعْلِيقِ الْهِبَةِ
u'تَعْلِيقٌ وُجُوبٌ':Added, #5: 5	تَعْلِيقُ الْهِبَةِ
u'تَعْلِيقٌ وُجُوبٌ':Added, #1: 1	تَعْلِيقُ الْوُجُوبِ
u'تَعْلِيقٌ وُجُوبٌ':Added, #1: 1	تَعْلِيقَ وُجُوبِ
u'تَعْلِيقٌ وَصْفٌ':Added, #1: 1	تَعْلِيقُ وُجُوبِ
u'تَعْلِيقٌ وَصِيٌّ':Added, #1: 1	تَعْلِيقُ وَصْفِ
u'تَعْلِيقٌ وَصِيٌّ':Added, #1: 1	تَعْلِيقُ الْوَصِيَّةِ
u'تَعْلِيقٌ وَصِيٌّ':Added, #2: 2	تَعْلِيقَ الْوَصِيَّةِ
u'تَعْلِيقٌ وَصِيَّةٌ':Added, #4: 4	تَعْلِيقِ الْوَصِيَّةِ
u'تَعْلِيقٌ وَصِيَّةٌ':Added, #1: 1	تَعْلِيقُ الْوَصِيَّةِ
u'تَعْلِيقٌ وَصِيَّةٌ':Added, #2: 2	تَعْلِيقَ الْوَصِيَّةِ
u'تَعْلِيقٌ وَقْفٌ':Added, #4: 4	تَعْلِيقِ الْوَصِيَّةِ
u'تَعْلِيقٌ وَقْفٌ':Added, #1: 1	تَعْلِيقُ الْوَقْفِ
u'تَعْلِيقٌ وِلاَيَةٌ':Added, #2: 2	تَعْلِيقِ وَقْفٍ
u'تَعْلِيقٌ وِلاَيَةٌ':Added, #1: 1	تَعْلِيقِ الْوِلَايَةِ
u'تَعْلِيقٌ يَدٌ':Added, #1: 1	تَعْلِيقُ وِلَايَةِ
u'تَعْلِيقٌ يَدٌ':Added, #1: 1	تَعْلِيقَ يَدِ
u'تَعْلِيقٌ يَدٌ':Added, #1: 1	تَعْلِيقِ يَدِ
u'تَعْلِيقٌ يَدٌ':Added, #2: 2	تَعْلِيقِ الْيَدِ
u'تَعْلِيقٌ يَمِينٌ':Added, #3: 3	تَعْلِيقُ يَدِهِ
u'تَعْلِيلٌ إبَاحَةٌ':Added, #1: 1	تَعْلِيقِ الْيَمِينِ
u'تَعْلِيلٌ اِبْنٌ':Added, #1: 1	تَعْلِيلِ الْإِبَاحَةِ
u'تَعْلِيلٌ اِبْنٌ':Added, #1: 1	تَعْلِيلُ ابْنِ
u'تَعْلِيلٌ إِجْبَارٌ':Added, #2: 2	تَعْلِيلِ ابْنِ
u'تَعْلِيلٌ أَحْكَامٌ':Added, #1: 1	تَعْلِيلُ إجْبَارِهِ
u'تَعْلِيلٌ أَحْكَامٌ':Added, #1: 1	تَعْلِيلَ أَحْكَامِ
u'تَعْلِيلٌ أَحْكَامٌ':Added, #1: 1	تَعْلِيلُ أَحْكَامِهِ
u'تَعْلِيلٌ أَحْكَامٌ':Added, #1: 1	تَعْلِيلِ أَحْكَامِهِ
u'تَعْلِيلٌ أَرْكانٌ':Added, #3: 3	تَعْلِيلِ الْأَحْكَامِ
u'تَعْلِيلٌ أَرْكَانٌ':Added, #1: 1	تَعْلِيلِ الْأَرْكَانِ
u'تَعْلِيلٌ أسْبَابٌ':Added, #1: 1	تَعْلِيلِ الْأَرْكَانِ
u'تَعْلِيلٌ أسْبَابٌ':Added, #1: 1	تَعْلِيلَ الْأَسْبَابِ
u'تَعْلِيلٌ أَسْبَابٌ':Added, #1: 1	تَعْلِيلُ الْأَسْبَابِ
u'تَعْلِيلٌ أَسْبَابٌ':Added, #1: 1	تَعْلِيلَ الْأَسْبَابِ
u'تَعْلِيلٌ أسْبَابٌ':Added, #1: 1	تَعْلِيلُ الْأَسْبَابِ
u'تَعْلِيلٌ أَسْبَابٌ':Added, #2: 2	تَعْلِيلِ الْأَسْبَابِ
u'تَعْلِيلٌ أَصْحَابٌ':Added, #2: 2	تَعْلِيلِ الْأَسْبَابِ
u'تَعْلِيلٌ أَصْحَابٌ':Added, #3: 3	تَعْلِيلَ الْأَصْحَابِ
u'تَعْلِيلٌ أَصْحَابٌ':Added, #3: 3	تَعْلِيلِ الْأَصْحَابِ
u'تَعْلِيلٌ أصل':Added, #7: 7	تَعْلِيلُ الْأَصْحَابِ
u'تَعْلِيلٌ أصل':Added, #1: 1	تَعْلِيلَ الْأَصْلِ
u'تَعْلِيلٌ أًصْلٌ':Added, #1: 1	تَعْلِيلُ الْأَصْلِ
u'تَعْلِيلٌ أًصْلٌ':Added, #1: 1	تَعْلِيلَ الْأَصْلِ
u'تَعْلِيلٌ أصل':Added, #1: 1	تَعْلِيلُ الْأَصْلِ
u'تَعْلِيلٌ أًصْلٌ':Added, #2: 2	تَعْلِيلِ أَصْلِ
u'تَعْلِيلٌ أصل':Added, #2: 2	تَعْلِيلِ أَصْلِ
u'تَعْلِيلٌ أًصْلٌ':Added, #2: 2	تَعْلِيلِ الْأَصْلِ
u'تَعْلِيلٌ أُصولٌ':Added, #2: 2	تَعْلِيلِ الْأَصْلِ
u'تَعْلِيلٌ أَقْوَالٌ':Added, #1: 1	تَعْلِيلُ الْأُصُولِ
u'تَعْلِيلٌ إمَامٌ':Added, #1: 1	تَعْلِيلِ الْأَقْوَالِ
u'تَعْلِيلٌ إمَامٌ':Added, #1: 1	تَعْلِيلَ الْإِمَامِ
u'تَعْلِيلٌ إِمْهالٌ':Added, #3: 3	تَعْلِيلِ الْإِمَامِ
u'تَعْلِيلٌ اِنْتِفاء':Added, #1: 1	تَعْلِيلُ الْإِمْهَالِ
u'تَعْلِيلٌ أَوْجُهٌ':Added, #1: 1	تَعْلِيلِ انْتِفَاءِ
u'تَعْلِيلٌ أَوَّلُ':Added, #1: 1	تَعْلِيلِ الْأَوْجُهِ
u'تَعْلِيلٌ أَوَّلُ':Added, #1: 1	تَعْلِيلَ الْأَوَّلِ
u'تَعْلِيلٌ أَوْلَوِيٌّ':Added, #3: 3	تَعْلِيلِ الْأَوَّلِ
u'تَعْلِيلٌ أَوْلَوِيٌّ':Added, #1: 1	تَعْلِيلُ الْأَوْلَوِيَّةِ
u'تَعْلِيلٌ أئِمَّةٌ':Added, #1: 1	تَعْلِيلِ أَوْلَوِيَّةِ
u'تَعْلِيلٌ إِيجَابٌ':Added, #1: 1	تَعْلِيلِ الْأَئِمَّةِ
u'تَعْلِيلٌ بَعْضٌ':Added, #1: 1	تَعْلِيلِ إيجَابِ
u'تَعْلِيلٌ بِنَاءٌ':Added, #1: 1	تَعْلِيلَ بَعْضِ
u'تَعْلِيلٌ تَحْرِيمٌ':Added, #1: 1	تَعْلِيلِ الْبِنَاءِ
u'تَعْلِيلٌ تَعْمِيمٌ':Added, #1: 1	تَعْلِيلُ التَّحْرِيمِ
u'تَعْلِيلٌ تَقْديمٌ':Added, #1: 1	تَعْلِيلَ التَّعْمِيمِ
u'تَعْلِيلٌ تَنْزِيلٌ':Added, #1: 1	تَعْلِيلِ تَقْدِيمِ
u'تَعْلِيلٌ تَوَقُّفٌ':Added, #1: 1	تَعْلِيلَ تَنْزِيلِ
u'تَعْلِيلٌ ثَالِثٌ':Added, #1: 1	تَعْلِيلِ التَّوَقُّفِ
u'تَعْلِيلٌ ثَانِي':Added, #1: 1	تَعْلِيلِ الثَّالِثِ
u'تَعْلِيلٌ ثَانِي':Added, #1: 1	تَعْلِيلُ الثَّانِيَةِ
u'تَعْلِيلٌ ثَانِيَةٌ':Added, #1: 1	تَعْلِيلِ الثَّانِيَةِ
u'تَعْلِيلٌ ثَانِيَةٌ':Added, #1: 1	تَعْلِيلُ الثَّانِيَةِ
u'تَعْلِيلٌ ثُبُوتٌ':Added, #1: 1	تَعْلِيلِ الثَّانِيَةِ
u'تَعْلِيلٌ ثُبُوتٌ':Added, #1: 1	تَعْلِيلِ الثُّبُوتِ
u'تَعْلِيلٌ جَوَازٌ':Added, #1: 1	تَعْلِيلُ ثُبُوتِ
u'تَعْلِيلٌ جَوَازٌ':Added, #1: 1	تَعْلِيلِ الْجَوَازِ
u'تَعْلِيلٌ جَوَازٌ':Added, #1: 1	تَعْلِيلَ جَوَازِ
u'تَعْلِيلٌ حَدَثٌ':Added, #2: 2	تَعْلِيلِ جَوَازِ
u'تَعْلِيلٌ حُدودٌ':Added, #1: 1	تَعْلِيلِ الْحَدَثِ
u'تَعْلِيلٌ حَديثٌ':Added, #1: 1	تَعْلِيلُ الْحُدُودِ
u'تَعْلِيلٌ حَديثٌ':Added, #1: 1	تَعْلِيلَ الْحَدِيثِ
u'تَعْلِيلٌ حُرْمَةٌ':Added, #1: 1	تَعْلِيلِ الْحَدِيثِ
u'تَعْلِيلٌ حُرْمَةٌ':Added, #1: 1	تَعْلِيلَ حُرْمَةِ
u'تَعْلِيلٌ حُرْمَةٌ':Added, #1: 1	تَعْلِيلِ حُرْمَتِهِ
u'تَعْلِيلٌ حُكْمٌ':Added, #2: 2	تَعْلِيلِ حُرْمَةِ
u'تَعْلِيلٌ حُكْمٌ':Added, #11: 11	تَعْلِيلُ الْحُكْمِ
u'تَعْلِيلٌ حُكْمٌ':Added, #15: 15	تَعْلِيلِ الْحُكْمِ
u'تَعْلِيلٌ حُكْمٌ':Added, #1: 1	تَعْلِيلِ حُكْمٍ
u'تَعْلِيلٌ حُكْمٌ':Added, #1: 1	تَعْلِيلِ حُكْمِ
u'تَعْلِيلٌ حُكْمٌ':Added, #2: 2	تَعْلِيلُ الْحُكْمَيْنِ
u'تَعْلِيلٌ حُكْمٌ':Added, #2: 2	تَعْلِيلُ حُكْمٍ
u'تَعْلِيلٌ حُكْمٌ':Added, #3: 3	تَعْلِيلُ حُكْمِ
u'تَعْلِيلٌ حِلٌّ':Added, #4: 4	تَعْلِيلَ الْحُكْمِ
u'تَعْلِيلٌ حَنَفِيَّةٌ':Added, #1: 1	تَعْلِيلِ حِلِّ
u'تَعْلِيلٌ خَبَرٌ':Added, #1: 1	تَعْلِيلُ الْحَنَفِيَّةِ
u'تَعْلِيلٌ خَبَر':Added, #1: 1	تَعْلِيلَ الْخَبَرِ
u'تَعْلِيلٌ خُلاصَة':Added, #1: 1	تَعْلِيلَ الْخَبَرِ
u'تَعْلِيلٌ دفع':Added, #1: 1	تَعْلِيلِ الْخُلَاصَةِ
u'تَعْلِيلٌ دَفْعٌ':Added, #1: 1	تَعْلِيلُ الدَّفْعِ
u'تَعْلِيلٌ دَليلٌ':Added, #1: 1	تَعْلِيلُ الدَّفْعِ
u'تَعْلِيلٌ ذَخيرَةٌ':Added, #1: 1	تَعْلِيلِ دَلِيلِ
u'تَعْلِيلٌ رَاجِحٌ':Added, #1: 1	تَعْلِيلِ الذَّخِيرَةِ
u'تَعْلِيلٌ رَأْيٌ':Added, #1: 1	تَعْلِيلُ الرَّاجِحِ
u'تَعْلِيلٌ رِجْس':Added, #1: 1	تَعْلِيلُ الرَّأْيِ
u'تَعْلِيلٌ رَدٌّ':Added, #1: 1	تَعْلِيلِ الرِّجْسِيَّةِ
u'تَعْلِيلٌ سِراج':Added, #1: 1	تَعْلِيلِ رَدِّ
u'تَعْلِيلٌ سُقُوطٌ':Added, #1: 1	تَعْلِيلِ السِّرَاجِيَّةِ
u'تَعْلِيلٌ شَارِحٌ':Added, #2: 2	تَعْلِيلِ سُقُوطِ
u'تَعْلِيلٌ شَارِحٌ':Added, #1: 1	تَعْلِيلُ الشَّارِحِ
u'تَعْلِيلٌ شَارِعٌ':Added, #1: 1	تَعْلِيلِ الشَّارِحِ
u'تَعْلِيلٌ شافِعِيّ':Added, #1: 1	تَعْلِيلُ الشَّارِعِ
u'تَعْلِيلٌ شافِعِيّ':Added, #1: 1	تَعْلِيلُ الشَّافِعِيِّ
u'تَعْلِيلٌ شَرِيفٌ':Added, #1: 1	تَعْلِيلِ الشَّافِعِيِّ
u'تَعْلِيلٌ شَيْءٌ':Added, #1: 1	تَعْلِيلِ الشَّرِيفِ
u'تَعْلِيلٌ شَيْءٌ':Added, #1: 1	تَعْلِيلَ شَيْءٍ
u'تَعْلِيلٌ شَيْءٌ':Added, #2: 2	تَعْلِيلُ الشَّيْءِ
u'تَعْلِيلٌ شَيْخٌ':Added, #2: 2	تَعْلِيلِ الشَّيْءِ
u'تَعْلِيلٌ شَيْخٌ':Added, #1: 1	تَعْلِيلِ الشَّيْخَيْنِ
u'تَعْلِيلٌ شَيْخٌ':Added, #2: 2	تَعْلِيلَ الشَّيْخِ
u'تَعْلِيلٌ صَاحِبٌ':Added, #4: 4	تَعْلِيلِ الشَّيْخِ
u'تَعْلِيلٌ صَاحِبٌ':Added, #2: 2	تَعْلِيلُ صَاحِبِ
u'تَعْلِيلٌ صِحَّةٌ':Added, #2: 2	تَعْلِيلِ صَاحِبِ
u'تَعْلِيلٌ ضِدٌّ':Added, #2: 2	تَعْلِيلِ صِحَّةِ
u'تَعْلِيلٌ طَهَارَةٌ':Added, #1: 1	تَعْلِيلِ الضِّدَّيْنِ
u'تَعْلِيلٌ ظاهِرٌ':Added, #1: 1	تَعْلِيلُ الطَّهَارَةِ
u'تَعْلِيلٌ عِدَّةٌ':Added, #1: 1	تَعْلِيلِ ظَاهِرِ
u'تَعْلِيلٌ عَدَمٌ':Added, #1: 1	تَعْلِيلِ عِدَّةِ
u'تَعْلِيلٌ عَدَمٌ':Added, #1: 1	تَعْلِيلِ الْعَدَمِ
u'تَعْلِيلٌ عَدَمٌ':Added, #5: 5	تَعْلِيلُ عَدَمِ
u'تَعْلِيلٌ غير':Added, #8: 8	تَعْلِيلِ عَدَمِ
u'تَعْلِيلٌ غَيْرٌ':Added, #1: 1	تَعْلِيلِ غَيْرِهِ
u'تَعْلِيلٌ فَتْحٌ':Added, #1: 1	تَعْلِيلِ غَيْرِهِ
u'تَعْلِيلٌ فَتْحٌ':Added, #1: 1	تَعْلِيلِ الْفَتْحِ
u'تَعْلِيلٌ فلان':Added, #2: 2	تَعْلِيلَ الْفَتْحِ
u'تَعْلِيلٌ فلان':Added, #1: 1	تَعْلِيلِ السِّرَاجِيَّةِ
u'تَعْلِيلٌ فلان':Added, #1: 1	تَعْلِيلُ الشَّافِعِيِّ
u'تَعْلِيلٌ فَهْمٌ':Added, #1: 1	تَعْلِيلِ الشَّافِعِيِّ
u'تَعْلِيلٌ قَبُولٌ':Added, #1: 1	تَعْلِيلُ فَهْمِ
u'تَعْلِيلٌ قتل':Added, #1: 1	تَعْلِيلَ الْقَبُولِ
u'تَعْلِيلٌ قتل':Added, #1: 1	تَعْلِيلَ قَتْلِ
u'تَعْلِيلٌ قَتْلٌ':Added, #1: 1	تَعْلِيلِ قَتْلِ
u'تَعْلِيلٌ قَتْلٌ':Added, #1: 1	تَعْلِيلَ قَتْلِ
u'تَعْلِيلٌ قِرَاءةٌ':Added, #1: 1	تَعْلِيلِ قَتْلِ
u'تَعْلِيلٌ قَفَّالٌ':Added, #1: 1	تَعْلِيلِ الْقِرَاءَةِ
u'تَعْلِيلٌ قول':Added, #1: 1	تَعْلِيلِ الْقَفَّالِ
u'تَعْلِيلٌ قَوْلٌ':Added, #1: 1	تَعْلِيلِ الْقَوْلِ
u'تَعْلِيلٌ قَوْلٌ':Added, #1: 1	تَعْلِيلِ الْقَوْلِ
u'تَعْلِيلٌ قول':Added, #1: 1	تَعْلِيلِ الْقَوْلَيْنِ
u'تَعْلِيلٌ قَوْلٌ':Added, #1: 1	تَعْلِيلُ قَوْلِ
u'تَعْلِيلٌ قول':Added, #1: 1	تَعْلِيلُ قَوْلِ
u'تَعْلِيلٌ قول':Added, #1: 1	تَعْلِيلَ قَوْلِهِ
u'تَعْلِيلٌ قول':Added, #1: 1	تَعْلِيلُ قَوْلِهِ
u'تَعْلِيلٌ قَوْلٌ':Added, #1: 1	تَعْلِيلِ قَوْلِهِ
u'تَعْلِيلٌ قَوْلٌ':Added, #1: 1	تَعْلِيلَ قَوْلِهِ
u'تَعْلِيلٌ قَوْلٌ':Added, #1: 1	تَعْلِيلُ قَوْلِهِ
u'تَعْلِيلٌ قول':Added, #1: 1	تَعْلِيلِ قَوْلِهِ
u'تَعْلِيلٌ قَوْلٌ':Added, #2: 2	تَعْلِيلَ الْقَوْلِ
u'تَعْلِيلٌ قول':Added, #2: 2	تَعْلِيلَ الْقَوْلِ
u'تَعْلِيلٌ قَوْلٌ':Added, #6: 6	تَعْلِيلِ قَوْلِ
u'تَعْلِيلٌ كِتَابٌ':Added, #6: 6	تَعْلِيلِ قَوْلِ
u'تَعْلِيلٌ كِتَابٌ':Added, #1: 1	تَعْلِيلُ الْكِتَابِ
u'تَعْلِيلٌ كَرَاهَةٌ':Added, #1: 1	تَعْلِيلِ الْكِتَابِ
u'تَعْلِيلٌ كَرَاهَةٌ':Added, #1: 1	تَعْلِيلُ الْكَرَاهَةِ
u'تَعْلِيلٌ كَلاَمٌ':Added, #2: 2	تَعْلِيلِ كَرَاهَةِ
u'تَعْلِيلٌ كَلاَمٌ':Added, #1: 1	تَعْلِيلُ كَلَامِ
u'تَعْلِيلٌ كَوْنٌ':Added, #1: 1	تَعْلِيلِ كَلَامِ
u'تَعْلِيلٌ كَوْنٌ':Added, #1: 1	تَعْلِيلِ كَوْنِ
u'تَعْلِيلٌ لُزُومٌ':Added, #1: 1	تَعْلِيلُ كَوْنِهِ
u'تَعْلِيلٌ مَبْسُوطٌ':Added, #1: 1	تَعْلِيلُ اللُّزُومِ
u'تَعْلِيلٌ مُتَمَاثِلٌ':Added, #1: 1	تَعْلِيلِ الْمَبْسُوطِ
u'تَعْلِيلٌ مُحَمَّدٌ':Added, #1: 1	تَعْلِيلُ الْمُتَمَاثِلَيْنِ
u'تَعْلِيلٌ مُحَمَّدٌ':Added, #1: 1	تَعْلِيلُ مُحَمَّدٍ
u'تَعْلِيلٌ مُحِيطٌ':Added, #3: 3	تَعْلِيلِ مُحَمَّدٍ
u'تَعْلِيلٌ مَذْهَبٌ':Added, #1: 1	تَعْلِيلُ الْمُحِيطِ
u'تَعْلِيلٌ مَسْأَلَةٌ':Added, #1: 1	تَعْلِيلِ مَذْهَبِ
u'تَعْلِيلٌ مَسْأَلَةٌ':Added, #1: 1	تَعْلِيلَ مَسْأَلَةِ
u'تَعْلِيلٌ مَسْأَلَةٌ':Added, #1: 1	تَعْلِيلِ مَسْأَلَةٍ
u'تَعْلِيلٌ مَسْأَلَةٌ':Added, #3: 3	تَعْلِيلِ مَسْأَلَةِ
u'تَعْلِيلٌ مَسْحٌ':Added, #9: 9	تَعْلِيلِ الْمَسْأَلَةِ
u'تَعْلِيلٌ مُصَنِّفٌ':Added, #1: 1	تَعْلِيلِ مَسْحِهِ
u'تَعْلِيلٌ مُصَنِّفٌ':Added, #1: 1	تَعْلِيلُ الْمُصَنِّفِ
u'تَعْلِيلٌ مُصَنِّفٌ':Added, #2: 2	تَعْلِيلَ الْمُصَنِّفِ
u'تَعْلِيلٌ مُعَلِّلٌ':Added, #5: 5	تَعْلِيلِ الْمُصَنِّفِ
u'تَعْلِيلٌ مُعَلِّلٌ':Added, #2: 2	تَعْلِيلَ الْمُعَلِّلِ
u'تَعْلِيلٌ مُعَلِّلٌ':Added, #2: 2	تَعْلِيلُ الْمُعَلِّلِ
u'تَعْلِيلٌ مَقَالَةٌ':Added, #3: 3	تَعْلِيلِ الْمُعَلِّلِ
u'تَعْلِيلٌ مَنْعٌ':Added, #1: 1	تَعْلِيلِ مَقَالَةٍ
u'تَعْلِيلٌ مَنْعٌ':Added, #1: 1	تَعْلِيلَ الْمَنْعِ
u'تَعْلِيلٌ مَنْعٌ':Added, #2: 2	تَعْلِيلِ مَنْعِ
u'تَعْلِيلٌ نَجَاسَةٌ':Added, #3: 3	تَعْلِيلِ الْمَنْعِ
u'تَعْلِيلٌ نَجَاسَةٌ':Added, #1: 1	تَعْلِيلُ النَّجَاسَةِ
u'تَعْلِيلٌ نَصٌّ':Added, #1: 1	تَعْلِيلُ نَجَاسَةِ
u'تَعْلِيلٌ نَفْيٌ':Added, #2: 2	تَعْلِيلُ نَصِّ
u'تَعْلِيلٌ نَقْدٌ':Added, #1: 1	تَعْلِيلِ نَفْيِ
u'تَعْلِيلٌ نَقْد':Added, #1: 1	تَعْلِيلُ النَّقْدَيْنِ
u'تَعْلِيلٌ نَهْيٌ':Added, #1: 1	تَعْلِيلُ النَّقْدَيْنِ
u'تَعْلِيلٌ نَهْيٌ':Added, #1: 1	تَعْلِيلَ النَّهْيِ
u'تَعْلِيلٌ نَوَوِيٌّ':Added, #1: 1	تَعْلِيلِ النَّهْيِ
u'تَعْلِيلٌ هِدَايَةٌ':Added, #1: 1	تَعْلِيلِ النَّوَوِيِّ
u'تَعْلِيلٌ هِدَايَةٌ':Added, #1: 1	تَعْلِيلِ الْهِدَايَةِ
u'تَعْلِيلٌ وَجْهٌ':Added, #2: 2	تَعْلِيلَ الْهِدَايَةِ
u'تَعْلِيلٌ وَجْهٌ':Added, #1: 1	تَعْلِيلُ الْوَجْهِ
u'تَعْلِيلٌ وَجْهٌ':Added, #1: 1	تَعْلِيلِ الْوَجْهَيْنِ
u'تَعْلِيلٌ وَجْهٌ':Added, #1: 1	تَعْلِيلُ وَجْهِ
u'تَعْلِيلٌ وَجْهٌ':Added, #2: 2	تَعْلِيلَ الْوَجْهِ
u'تَعْلِيلٌ وُجُوبٌ':Added, #4: 4	تَعْلِيلِ الْوَجْهِ
u'تَعْلِيلٌ وُجُوبٌ':Added, #1: 1	تَعْلِيلَ الْوُجُوبِ
u'تَعْلِيلٌ وُجُودِيٌّ':Added, #1: 1	تَعْلِيلِ وُجُوبِ
u'تَعْلِيلٌ وِلاَيَةٌ':Added, #1: 1	تَعْلِيلِ الْوُجُودِيِّ
u'تَعْلِيمٌ أَبٌ':Added, #1: 1	تَعْلِيلُ وِلَايَةِ
u'تَعْلِيمٌ اِبْنٌ':Added, #1: 1	تَعْلِيمَ الْأَبِ
u'تَعْلِيمٌ أَبْوَابٌ':Added, #1: 1	تَعْلِيمِ ابْنِهِ
u'تَعْلِيمٌ أَحْكَامٌ':Added, #1: 1	تَعْلِيمَ أَبْوَابٍ
u'تَعْلِيمٌ أَحْكَامٌ':Added, #1: 1	تَعْلِيمَ الْأَحْكَامِ
u'تَعْلِيمٌ أَحْوالٌ':Added, #1: 1	تَعْلِيمِ الْأَحْكَامِ
u'تَعْلِيمٌ أحْوَالٌ':Added, #1: 1	تَعْلِيمُ أَحْوَالِ
u'تَعْلِيمٌ أَسَدٌ':Added, #1: 1	تَعْلِيمُ أَحْوَالِ
u'تَعْلِيمٌ أَصْحَابٌ':Added, #1: 1	تَعْلِيمُ الْأَسَدِ
u'تَعْلِيمٌ أَطْفَالٌ':Added, #1: 1	تَعْلِيمِ أَصْحَابِهِ
u'تَعْلِيمٌ أعْرَابِيٌّ':Added, #1: 1	تَعْلِيمِ الْأَطْفَالِ
u'تَعْلِيمٌ أَعْمَالٌ':Added, #1: 1	تَعْلِيمُ الْأَعْرَابِيِّ
u'تَعْلِيمٌ أَعْمَالٌ':Added, #1: 1	تَعْلِيمِ الْأَعْمَالِ
u'تَعْلِيمٌ أَكْمَلُ':Added, #4: 4	تَعْلِيمِ أَعْمَالِ
u'تَعْلِيمٌ الْمَرْأَةُ':Added, #1: 1	تَعْلِيمِ الْأَكْمَلِ
u'تَعْلِيمٌ أوائل':Added, #1: 1	تَعْلِيمِ الْمَرْأَةِ
u'تَعْلِيمٌ أَوْلاَدٌ':Added, #1: 1	تَعْلِيمَ أَوَائِلِ
u'تَعْلِيمٌ أَوْلاَدٌ':Added, #1: 1	تَعْلِيمُ الْأَوْلَادِ
u'تَعْلِيمٌ أَوْلاَدٌ':Added, #1: 1	تَعْلِيمُ أَوْلَادِ
u'تَعْلِيمٌ تَحْكِيمٌ':Added, #1: 1	تَعْلِيمِ أَوْلَادِ
u'تَعْلِيمٌ جَارِحٌ':Added, #1: 1	تَعْلِيمِ التَّحْكِيمِ
u'تَعْلِيمٌ جَارِحَةٌ':Added, #1: 1	تَعْلِيمِ الْجَارِحَةِ
u'تَعْلِيمٌ جَمَاعَةٌ':Added, #1: 1	تَعْلِيمِ الْجَارِحَةِ
u'تَعْلِيمٌ جَوَازٌ':Added, #1: 1	تَعْلِيمَ الْجَمَاعَةِ
u'تَعْلِيمٌ حائِضٌ':Added, #4: 4	تَعْلِيمِ الْجَوَازِ
u'تَعْلِيمٌ حَديثٌ':Added, #1: 1	تَعْلِيمِ الْحَائِضِ
u'تَعْلِيمٌ حَرْفٌ':Added, #1: 1	تَعْلِيمِ حَدِيثٍ
u'تَعْلِيمٌ حُروفٌ':Added, #1: 1	تَعْلِيمُ الْحَرْفِ
u'تَعْلِيمٌ حُروفٌ':Added, #1: 1	تَعْلِيمِ الْحُرُوفِ
u'تَعْلِيمٌ حُسْنٌ':Added, #2: 2	تَعْلِيمُ الْحُرُوفِ
u'تَعْلِيمٌ حُسْنٌ':Added, #1: 1	تَعْلِيمُ حُسْنِ
u'تَعْلِيمٌ حُكْمٌ':Added, #1: 1	تَعْلِيمِ حُسْنِ
u'تَعْلِيمٌ حَلالٌ':Added, #1: 1	تَعْلِيمِ الْحُكْمِ
u'تَعْلِيمٌ حِيَاكَةٌ':Added, #1: 1	تَعْلِيمِ الْحَلَالِ
u'تَعْلِيمٌ حِيَلٌ':Added, #1: 1	تَعْلِيمَ الْحِيَاكَةِ
u'تَعْلِيمٌ حِيلَةٌ':Added, #2: 2	تَعْلِيمِ الْحِيَلِ
u'تَعْلِيمٌ خَصْمٌ':Added, #1: 1	تَعْلِيمِ الْحِيلَةِ
u'تَعْلِيمٌ خُصُومَةٌ':Added, #1: 1	تَعْلِيمُ الْخَصْمِ
u'تَعْلِيمٌ خَطٌّ':Added, #1: 1	تَعْلِيمَ خُصُومَةٍ
u'تَعْلِيمٌ خلق':Added, #1: 1	تَعْلِيمِ الْخَطِّ
u'تَعْلِيمٌ خَلْقٌ':Added, #1: 1	تَعْلِيمَ الْخَلْقِ
u'تَعْلِيمٌ خَيْرٌ':Added, #1: 1	تَعْلِيمَ الْخَلْقِ
u'تَعْلِيمٌ دُعَاءٌ':Added, #1: 1	تَعْلِيمِ الْخَيْرِ
u'تَعْلِيمٌ دَوْرٌ':Added, #1: 1	تَعْلِيمُ الدُّعَاءِ
u'تَعْلِيمٌ دِينٌ':Added, #1: 1	تَعْلِيمِ الدَّوْرِ
u'تَعْلِيمٌ رَسُولٌ':Added, #1: 1	تَعْلِيمِ الدِّينِ
u'تَعْلِيمٌ رَقيقٌ':Added, #1: 1	تَعْلِيمِ الرّسُولِ
u'تَعْلِيمٌ رَقيق':Added, #1: 1	تَعْلِيمِ الرَّقِيقِ
u'تَعْلِيمٌ رَقيقٌ':Added, #1: 1	تَعْلِيمِ الرَّقِيقِ
u'تَعْلِيمٌ رَقيق':Added, #1: 1	تَعْلِيمَ رَقِيقِهِ
u'تَعْلِيمٌ رَمْيٌ':Added, #1: 1	تَعْلِيمَ رَقِيقِهِ
u'تَعْلِيمٌ زَوْجَةٌ':Added, #1: 1	تَعْلِيمِ الرَّمْيِ
u'تَعْلِيمٌ سِحْرٌ':Added, #1: 1	تَعْلِيمَ زَوْجَتِهِ
u'تَعْلِيمٌ سِواكٌ':Added, #1: 1	تَعْلِيمُ السِّحْرِ
u'تَعْلِيمٌ سُورَةٌ':Added, #1: 1	تَعْلِيمُ السِّوَاكِ
u'تَعْلِيمٌ سُورَةٌ':Added, #1: 1	تَعْلِيمِ سُورَةٍ
u'تَعْلِيمٌ شَاهِدٌ':Added, #5: 5	تَعْلِيمَ سُورَةٍ
u'تَعْلِيمٌ شِعْرٌ':Added, #1: 1	تَعْلِيمُ الشَّاهِدِ
u'تَعْلِيمٌ شَيْءٌ':Added, #2: 2	تَعْلِيمِ الشِّعْرِ
u'تَعْلِيمٌ شَيْءٌ':Added, #1: 1	تَعْلِيمَ الشَّيْءِ
u'تَعْلِيمٌ شَيْءٌ':Added, #1: 1	تَعْلِيمِ شَيْءٍ
u'تَعْلِيمٌ صَبِيٌّ':Added, #2: 2	تَعْلِيمَ شَيْءٍ
u'تَعْلِيمٌ صَبِيٌّ':Added, #1: 1	تَعْلِيمِ الصَّبِيِّ
u'تَعْلِيمٌ صِبْيَانٌ':Added, #2: 2	تَعْلِيمُ الصَّبِيِّ
u'تَعْلِيمٌ صِبْيَانٌ':Added, #1: 1	تَعْلِيمَ الصِّبْيَانِ
u'تَعْلِيمٌ صِبْيَانٌ':Added, #2: 2	تَعْلِيمُ الصِّبْيَانِ
u'تَعْلِيمٌ صغار':Added, #5: 5	تَعْلِيمِ الصِّبْيَانِ
u'تَعْلِيمٌ صَلاَةٌ':Added, #3: 3	تَعْلِيمَ الصِّغَارِ
u'تَعْلِيمٌ صنعة':Added, #1: 1	تَعْلِيمِ الصَّلَاةِ
u'تَعْلِيمٌ صَنْعَةٌ':Added, #1: 1	تَعْلِيمِ صَنْعَةٍ
u'تَعْلِيمٌ صنعة':Added, #1: 1	تَعْلِيمِ صَنْعَةٍ
u'تَعْلِيمٌ صَنْعَةٌ':Added, #2: 2	تَعْلِيمِ الصَّنْعَةِ
u'تَعْلِيمٌ طَلَبَةٌ':Added, #2: 2	تَعْلِيمِ الصَّنْعَةِ
u'تَعْلِيمٌ عَامٌّ':Added, #1: 1	تَعْلِيمَ الطَّلَبَةِ
u'تَعْلِيمٌ عَامِّيٌّ':Added, #1: 1	تَعْلِيمَ عَامَّةِ
u'تَعْلِيمٌ عِبَادٌ':Added, #1: 1	تَعْلِيمُ الْعَامِّيِّ
u'تَعْلِيمٌ عَبْدٌ':Added, #1: 1	تَعْلِيمِ الْعِبَادِ
u'تَعْلِيمٌ عَبْدٌ':Added, #1: 1	تَعْلِيمَ الْعَبْدِ
u'تَعْلِيمٌ عَبْدٌ':Added, #1: 1	تَعْلِيمُ الْعَبْدِ
u'تَعْلِيمٌ عَقَائِدُ':Added, #1: 1	تَعْلِيمَ عَبْدِ
u'تَعْلِيمٌ علم':Added, #2: 2	تَعْلِيمِ الْعَقَائِدِ
u'تَعْلِيمٌ عِلْمٌ':Added, #1: 1	تَعْلِيمَ الْعِلْمِ
u'تَعْلِيمٌ علم':Added, #1: 1	تَعْلِيمَ الْعِلْمِ
u'تَعْلِيمٌ علم':Added, #1: 1	تَعْلِيمِ عِلْمٍ
u'تَعْلِيمٌ عِلْمٌ':Added, #1: 1	تَعْلِيمِ عِلْمِ
u'تَعْلِيمٌ عِلْمٌ':Added, #1: 1	تَعْلِيمِ عِلْمٍ
u'تَعْلِيمٌ علم':Added, #1: 1	تَعْلِيمِ عِلْمِ
u'تَعْلِيمٌ علم':Added, #2: 2	تَعْلِيمُ الْعِلْمِ
u'تَعْلِيمٌ عِلْمٌ':Added, #2: 2	تَعْلِيمِ الْعِلْمِ
u'تَعْلِيمٌ عِلْمٌ':Added, #2: 2	تَعْلِيمُ الْعِلْمِ
u'تَعْلِيمٌ عُلُومٌ':Added, #2: 2	تَعْلِيمِ الْعِلْمِ
u'تَعْلِيمٌ عَمَلٌ':Added, #1: 1	تَعْلِيمِ الْعُلُومِ
u'تَعْلِيمٌ غُلاَمٌ':Added, #1: 1	تَعْلِيمِ عَمَلٍ
u'تَعْلِيمٌ غِنَاءٌ':Added, #1: 1	تَعْلِيمِ الْغُلَامِ
u'تَعْلِيمٌ غير':Added, #1: 1	تَعْلِيمِ غِنَاءٍ
u'تَعْلِيمٌ غَيْرٌ':Added, #1: 1	تَعْلِيمِ غَيْرِهِ
u'تَعْلِيمٌ غير':Added, #1: 1	تَعْلِيمِ غَيْرِهِ
u'تَعْلِيمٌ غَيْرٌ':Added, #2: 2	تَعْلِيمَ الْغَيْرِ
u'تَعْلِيمٌ غير':Added, #2: 2	تَعْلِيمَ الْغَيْرِ
u'تَعْلِيمٌ غَيْرٌ':Added, #2: 2	تَعْلِيمَ غَيْرِهِ
u'تَعْلِيمٌ فَاتِحٌ':Added, #2: 2	تَعْلِيمَ غَيْرِهِ
u'تَعْلِيمٌ فَاتِحَةٌ':Added, #1: 1	تَعْلِيمِ الْفَاتِحَةِ
u'تَعْلِيمٌ فَرَائِضُ':Added, #1: 1	تَعْلِيمِ الْفَاتِحَةِ
u'تَعْلِيمٌ فَرَائِضُ':Added, #1: 1	تَعْلِيمُ الْفَرَائِضِ
u'تَعْلِيمٌ فساد':Added, #1: 1	تَعْلِيمِ الْفَرَائِضِ
u'تَعْلِيمٌ فَسَادٌ':Added, #1: 1	تَعْلِيمُ فَسَادِهِ
u'تَعْلِيمٌ فِقْهٌ':Added, #1: 1	تَعْلِيمُ فَسَادِهِ
u'تَعْلِيمٌ فِقْهٌ':Added, #1: 1	تَعْلِيمَ الْفِقْهِ
u'تَعْلِيمٌ فِقْهٌ':Added, #2: 2	تَعْلِيمَ فِقْهٍ
u'تَعْلِيمٌ فِقْهٌ':Added, #4: 4	تَعْلِيمُ الْفِقْهِ
u'تَعْلِيمٌ فِيلٌ':Added, #4: 4	تَعْلِيمِ الْفِقْهِ
u'تَعْلِيمٌ قَبُولٌ':Added, #2: 2	تَعْلِيمَ الْفِيلِ
u'تَعْلِيمٌ قُرْآنٌ':Added, #1: 1	تَعْلِيمَ قَبُولِهِ
u'تَعْلِيمٌ قُرْآنٌ':Added, #30: 30	تَعْلِيمِ الْقُرْآنِ
u'تَعْلِيمٌ قُرْآنٌ':Added, #3: 3	تَعْلِيمَ قُرْآنٍ
u'تَعْلِيمٌ قُرْآنٌ':Added, #3: 3	تَعْلِيمِ قُرْآنٍ
u'تَعْلِيمٌ قُرْآنٌ':Added, #7: 7	تَعْلِيمَ الْقُرْآنِ
u'تَعْلِيمٌ قَوْمٌ':Added, #7: 7	تَعْلِيمُ الْقُرْآنِ
u'تَعْلِيمٌ كَافِرٌ':Added, #1: 1	تَعْلِيمَ الْقَوْمِ
u'تَعْلِيمٌ كبار':Added, #1: 1	تَعْلِيمُ الْكَافِرِ
u'تَعْلِيمٌ كِتَابٌ':Added, #1: 1	تَعْلِيمِ الْكِبَارِ
u'تَعْلِيمٌ كِتَابٌ':Added, #1: 1	تَعْلِيمُ الْكِتَابِ
u'تَعْلِيمٌ كِتَابَةٌ':Added, #1: 1	تَعْلِيمَ كِتَابِ
u'تَعْلِيمٌ كَلْبٌ':Added, #2: 2	تَعْلِيمُ الْكِتَابَةِ
u'تَعْلِيمٌ كَيْفِيَّةٌ':Added, #1: 1	تَعْلِيمُ الْكَلْبِ
u'تَعْلِيمٌ لُغَةٌ':Added, #1: 1	تَعْلِيمُ كَيْفِيّةِ
u'تَعْلِيمٌ لُغَةٌ':Added, #2: 2	تَعْلِيمَ اللُّغَاتِ
u'تَعْلِيمٌ لَفْظٌ':Added, #2: 2	تَعْلِيمِ اللُّغَةِ
u'تَعْلِيمٌ مُبْتَدِعٌ':Added, #1: 1	تَعْلِيمَ اللَّفْظِ
u'تَعْلِيمٌ مُجَرَّدٌ':Added, #1: 1	تَعْلِيمُ الْمُبْتَدِعِ
u'تَعْلِيمٌ مَحْجُورٌ':Added, #1: 1	تَعْلِيمِ مُجَرَّدِ
u'تَعْلِيمٌ مُحَمَّدٌ':Added, #1: 1	تَعْلِيمِ الْمَحْجُورِ
u'تَعْلِيمٌ مَخْرَجٌ':Added, #1: 1	تَعْلِيمِ مُحَمَّدٍ
u'تَعْلِيمٌ مَنَاسِكُ':Added, #1: 1	تَعْلِيمُ الْمَخْرَجِ
u'تَعْلِيمٌ مَنَاسِكُ':Added, #1: 1	تَعْلِيمُ الْمَنَاسِكِ
u'تَعْلِيمٌ نَاسٌ':Added, #1: 1	تَعْلِيمِ الْمَنَاسِكِ
u'تَعْلِيمٌ نِساءٌ':Added, #2: 2	تَعْلِيمُ النَّاسِ
u'تَعْلِيمٌ نسج':Added, #1: 1	تَعْلِيمِ النِّسَاءِ
u'تَعْلِيمٌ نَسْجٌ':Added, #2: 2	تَعْلِيمِ النَّسْجِ
u'تَعْلِيمٌ نَظْمٌ':Added, #2: 2	تَعْلِيمِ النَّسْجِ
u'تَعْلِيمٌ نَوْحٌ':Added, #1: 1	تَعْلِيمِ نَظْمِهِ
u'تَعْلِيمٌ هِجَاءٌ':Added, #1: 1	تَعْلِيمِ النَّوْحِ
u'تَعْلِيمٌ وُضُوءٌ':Added, #1: 1	تَعْلِيمِ الْهِجَاءِ
u'تَعْلِيمٌ وَقْتٌ':Added, #1: 1	تَعْلِيمُ الْوُضُوءِ
u'تَعْلِيمٌ ولد':Added, #1: 1	تَعْلِيمَ وَقْتِ
u'تَعْلِيمٌ وَلَدٌ':Added, #2: 2	تَعْلِيمُ الْوَلَدِ
u'تَعَمَّدَ أَبٌ':Subject, #2: 2	تَعْلِيمُ الْوَلَدِ
u'تَعَمُّدٌ إِتْيانٌ':Added, #1: 1	تَعَمَّدَ الْأَبُ
u'تَعَمُّدٌ أَجْنَبِيٌّ':Added, #1: 1	تَعَمُّدَ الْإِتْيَانِ
u'تَعَمَّدَ إِخْرَاجٌ':Predicate, #1: 1	تَعَمُّدِ أَجْنَبِيٍّ
u'تَعَمُّدٌ إِخْرَاجٌ':Added, #1: 1	تَعَمَّدَ إخْرَاجَ
u'تَعَمُّدٌ اِسْتِعْمالٌ':Added, #1: 1	تَعَمُّدُ إخْرَاجِهِ
u'تَعَمَّدَ إِفْطارٌ':Predicate, #1: 1	تَعَمُّدِ اسْتِعْمَالِ
u'تَعَمُّدٌ أكل':Added, #1: 1	تَعَمَّدَ الْإِفْطَارَ
u'تَعَمُّدٌ أَكْلٌ':Added, #1: 1	تَعَمُّدِ الْأَكْلِ
u'تَعَمَّدَ إِلْقَاءٌ':Predicate, #1: 1	تَعَمُّدِ الْأَكْلِ
u'تَعَمَّدَ إمَامٌ':Subject, #1: 1	تَعَمَّدَ إلْقَاءَ
u'تَعَمَّدَ إمَامٌ':Subject, #1: 1	تَعَمَّدَ الْإِمَامُ
u'تَعَمَّدَ بَطَلٌ':Predicate, #2: 2	تَعَمَّدَ إمَامٌ
u'تَعَمَّدَ تَأْخِيرٌ':Predicate, #1: 1	تَعَمَّدَ بَطَلَ
u'تَعَمَّدَ تَأْخِيرٌ':Predicate, #1: 1	تَعَمَّدَ تَأْخِيرَ
u'تَعَمُّدٌ تَأْخِيرٌ':Added, #2: 2	تَعَمَّدَ التَّأْخِيرَ
u'تَعَمَّدَ تَرْكٌ':Predicate, #1: 1	تَعَمُّدُ تَأْخِيرِ
u'تَعَمَّدَ تَرْكٌ':Predicate, #1: 1	تَعَمَّدَ التَّرْكَ
u'تَعَمَّدَ تَرْكٌ':Predicate, #1: 1	تَعَمَّدَ تَرْكَهُنَّ
u'تَعَمُّدٌ تَرْكٌ':Added, #7: 7	تَعَمَّدَ تَرْكَ
u'تَعَمَّدَ تَصْغِيرٌ':Predicate, #1: 1	تَعَمُّدُ تَرْكِ
u'تَعَمُّدٌ تَطْوِيلٌ':Added, #1: 1	تَعَمَّدَ التَّصْغِيرَ
u'تَعَمَّدَ تَلَفٌ':Predicate, #1: 1	تَعَمُّدُ تَطْوِيلِ
u'تَعَمُّدٌ تَنْجِيسٌ':Added, #1: 1	تَعَمَّدَ تَلَفَ
u'تَعَمَّدَ جَحْد':Predicate, #1: 1	تَعَمُّدِ تَنْجِيسِ
u'تَعَمَّدَ جَوْرٌ':Predicate, #1: 1	تَعَمَّدَ الْجَحْدَ
u'تَعَمَّدَ حَدَثٌ':Predicate, #2: 2	تَعَمَّدَ الْجَوْرَ
u'تَعَمُّدٌ حَدَثٌ':Added, #5: 5	تَعَمَّدَ الْحَدَثَ
u'تَعَمُّدٌ حَدَثٌ':Added, #1: 1	تَعَمُّدَ الْحَدَثِ
u'تَعَمُّدٌ حَرَجٌ':Added, #1: 1	تَعَمُّدُ الْحَدَثِ
u'تَعَمَّدَ حِيلَةٌ':Predicate, #1: 1	تَعَمُّدِ حَرَجٍ
u'تَعَمَّدَ خامس':Predicate, #2: 2	تَعَمَّدَ الْحِيلَةَ
u'تَعَمَّدَ خَامِسٌ':Predicate, #1: 1	تَعَمَّدَ خَامِسَةً
u'تَعَمَّدَ خُرُوجٌ':Predicate, #1: 1	تَعَمَّدَ خَامِسَةً
u'تَعَمُّدٌ دُخُولٌ':Added, #1: 1	تَعَمَّدَ الْخُرُوجَ
u'تَعَمَّدَ دفع':Predicate, #1: 1	تَعَمُّدُ الدُّخُولِ
u'تَعَمَّدَ دَفْعٌ':Predicate, #1: 1	تَعَمَّدَ الدَّفْعَ
u'تَعَمَّدَ رَجُلٌ':Subject, #1: 1	تَعَمَّدَ الدَّفْعَ
u'تَعَمَّدَ رُكوعٌ':Predicate, #1: 1	تَعَمَّدَ الرَّجُلُ
u'تَعَمُّدٌ رَمْيٌ':Added, #2: 2	تَعَمَّدَ الرُّكُوعَ
u'تَعَمُّدٌ زَلَقٌ':Added, #1: 1	تَعَمُّدَ الرَّمْيِ
u'تَعَمُّدٌ زُورٌ':Added, #1: 1	تَعَمُّدِ الزَّلَقِ
u'تَعَمَّدَ زِيادَةٌ':Predicate, #1: 1	تَعَمُّدِ الزُّورِ
u'تَعَمَّدَ سَبَبٌ':Predicate, #1: 1	تَعَمَّدَ زِيَادَةَ
u'تَعَمَّدَ سَبَبٌ':Predicate, #1: 1	تَعَمَّدَ السَّبَبَ
u'تَعَمَّدَ سَبْقٌ':Predicate, #2: 2	تَعَمَّدَ سَبَبَ
u'تَعَمُّدٌ سَبْقٌ':Added, #2: 2	تَعَمَّدَ السَّبْقَ
u'تَعَمَّدَ سُجُودٌ':Predicate, #1: 1	تَعَمُّدِ السَّبْقِ
u'تَعَمَّدَ سَفَرٌ':Predicate, #1: 1	تَعَمَّدَ السُّجُودَ
u'تَعَمُّدٌ سكر':Added, #1: 1	تَعَمَّدَ السَّفَرَ
u'تَعَمُّدٌ سُكْرٌ':Added, #1: 1	تَعَمُّدُ السُّكْرِ
u'تَعَمَّدَ سُكُوتٌ':Predicate, #1: 1	تَعَمُّدُ السُّكْرِ
u'تَعَمَّدَ سلام':Predicate, #1: 1	تَعَمَّدَ السُّكُوتَ
u'تَعَمَّدَ سَلاَمٌ':Predicate, #1: 1	تَعَمَّدَ السَّلَامَ
u'تَعَمُّدٌ سُؤَالٌ':Added, #1: 1	تَعَمَّدَ السَّلَامَ
u'تَعَمُّدٌ شرب':Added, #1: 1	تَعَمُّدِ سُؤَالِ
u'تَعَمُّدٌ شُرْبٌ':Added, #1: 1	تَعَمُّدَ شُرْبِ
u'تَعَمَّدَ شُرُوعٌ':Predicate, #1: 1	تَعَمُّدَ شُرْبِ
u'تَعَمَّدَ شَهَادَةٌ':Predicate, #1: 1	تَعَمَّدَ الشُّرُوعَ
u'تَعَمَّدَ صَبِيٌّ':Subject, #1: 1	تَعَمَّدَ الشَّهَادَةَ
u'تَعَمَّدَ صَدْمٌ':Predicate, #1: 1	تَعَمَّدَ الصَّبِيُّ
u'تَعَمَّدَ صَلاَةٌ':Predicate, #2: 2	تَعَمَّدَ الصَّدْمَ
u'تَعَمُّدٌ صنائع':Added, #1: 1	تَعَمَّدَ الصَّلَاةَ
u'تَعَمُّدٌ صَنَائِعُ':Added, #1: 1	تَعَمُّدُ الصَّنَائِعِ
u'تَعَمَّدَ ضَرْبٌ':Predicate, #1: 1	تَعَمُّدُ الصَّنَائِعِ
u'تَعَمَّدَ ضَرْبٌ':Predicate, #2: 2	تَعَمَّدَ الضَّرْبَ
u'تَعَمَّدَ طَرْحٌ':Predicate, #3: 3	تَعَمَّدَ ضَرْبَ
u'تَعَمَّدَ ظُلْمٌ':Predicate, #1: 1	تَعَمَّدَ طَرْحَ
u'تَعَمَّدَ غير':Predicate, #3: 3	تَعَمَّدَ الظُّلْمَ
u'تَعَمَّدَ غَيْرٌ':Predicate, #1: 1	تَعَمَّدَ غَيْرَ
u'تَعَمُّدٌ فَاسِدٌ':Added, #1: 1	تَعَمَّدَ غَيْرَ
u'تَعَمَّدَ فَاعِلٌ':Subject, #1: 1	تَعَمُّدُ الْفَاسِدِ
u'تَعَمَّدَ فساد':Predicate, #1: 1	تَعَمَّدَ الْفَاعِلُ
u'تَعَمَّدَ فَسَادٌ':Predicate, #3: 3	تَعَمَّدَ الْفَسَادَ
u'تَعَمُّدٌ فساد':Added, #3: 3	تَعَمَّدَ الْفَسَادَ
u'تَعَمُّدٌ فَسَادٌ':Added, #1: 1	تَعَمُّدِ الْفَسَادِ
u'تَعَمُّدٌ فساد':Added, #1: 1	تَعَمُّدِ الْفَسَادِ
u'تَعَمُّدٌ فَسَادٌ':Added, #3: 3	تَعَمُّدُ الْفَسَادِ
u'تَعَمَّدَ فِطْرٌ':Predicate, #3: 3	تَعَمُّدُ الْفَسَادِ
u'تَعَمَّدَ فِعْلٌ':Predicate, #2: 2	تَعَمَّدَ الْفِطْرَ
u'تَعَمَّدَ قَاتِلٌ':Subject, #1: 1	تَعَمَّدَ فِعْلَ
u'تَعَمَّدَ قتل':Predicate, #1: 1	تَعَمَّدَ الْقَاتِلُ
u'تَعَمَّدَ قَتْلٌ':Predicate, #1: 1	تَعَمَّدَ الْقَتْلَ
u'تَعَمَّدَ قتل':Predicate, #1: 1	تَعَمَّدَ الْقَتْلَ
u'تَعَمَّدَ قَتْلٌ':Predicate, #1: 1	تَعَمَّدَ قَتْلَ
u'تَعَمُّدٌ قِرَاءةٌ':Added, #1: 1	تَعَمَّدَ قَتْلَ
u'تَعَمُّدٌ قِرَاءةٌ':Added, #1: 1	تَعَمُّدَ الْقِرَاءَةِ
u'تَعَمَّدَ قَطْعٌ':Predicate, #1: 1	تَعَمُّدَ قِرَاءَةِ
u'تَعَمُّدٌ قَطْعٌ':Added, #1: 1	تَعَمَّدَ قَطْعَ
u'تَعَمُّدٌ قَطْعٌ':Added, #1: 1	تَعَمُّدِ قَطْعِ
u'تَعَمَّدَ كذب':Predicate, #1: 1	تَعَمُّدِ قَطْعِهِ
u'تَعَمَّدَ كَذِبٌ':Predicate, #4: 4	تَعَمَّدَ الْكَذِبَ
u'تَعَمُّدٌ كذب':Added, #4: 4	تَعَمَّدَ الْكَذِبَ
u'تَعَمُّدٌ كَذِبٌ':Added, #2: 2	تَعَمُّدَ الْكَذِبِ
u'تَعَمُّدٌ كذب':Added, #2: 2	تَعَمُّدَ الْكَذِبِ
u'تَعَمُّدٌ كَذِبٌ':Added, #3: 3	تَعَمُّدُ الْكَذِبِ
u'تَعَمُّدٌ كذب':Added, #3: 3	تَعَمُّدُ الْكَذِبِ
u'تَعَمُّدٌ كَذِبٌ':Added, #5: 5	تَعَمُّدِ الْكَذِبِ
u'تَعَمُّدٌ لَحْنٌ':Added, #5: 5	تَعَمُّدِ الْكَذِبِ
u'تَعَمَّدَ مَارٌّ':Subject, #1: 1	تَعَمُّدُ اللَّحْنِ
u'تَعَمَّدَ مَالِكٌ':Subject, #1: 1	تَعَمَّدَ الْمَارُّ
u'تَعَمَّدَ مُرُورٌ':Predicate, #1: 1	تَعَمَّدَ الْمَالِكُ
u'تَعَمَّدَ مُسَافِرٌ':Subject, #8: 8	تَعَمَّدَ الْمُرُورَ
u'تَعَمَّدَ مُسْلِمٌ':Subject, #1: 1	تَعَمَّدَ الْمُسَافِرُ
u'تَعَمَّدَ مَشْيٌ':Predicate, #1: 1	تَعَمَّدَ الْمُسْلِمُ
u'تَعَمُّدٌ مُفْسِدٌ':Added, #1: 1	تَعَمَّدَ الْمَشْيَ
u'تَعَمُّدٌ مُفْسِدٌ':Added, #1: 1	تَعَمُّدِ الْمُفْسِدِ
u'تَعَمُّدٌ مُفْطِر':Added, #1: 1	تَعَمُّدِ مُفْسِدٍ
u'تَعَمَّدَ مُقَامٌ':Predicate, #1: 1	تَعَمُّدِ الْمُفْطِرِ
u'تَعَمَّدَ مَقْتَلٌ':Predicate, #1: 1	تَعَمَّدَ الْمُقَامَ
u'تَعَمَّدَ مَنْهِيٌّ':Predicate, #1: 1	تَعَمَّدَ الْمَقْتَلَ
u'تَعَمَّدَ نَاظِرٌ':Subject, #1: 1	تَعَمَّدَ الْمَنْهِيَّ
u'تَعَمُّدٌ نَزْعٌ':Added, #1: 1	تَعَمَّدَ النَّاظِرُ
u'تَعَمُّدٌ نُزُولٌ':Added, #1: 1	تَعَمُّدِ النَّزْعِ
u'تَعَمَّدَ نَظَرٌ':Predicate, #1: 1	تَعَمُّدِ نُزُولِ
u'تَعَمُّدٌ نَظَرٌ':Added, #7: 7	تَعَمَّدَ النَّظَرَ
u'تَعَمُّدٌ نَظَرٌ':Added, #1: 1	تَعَمُّدِ النَّظَرِ
u'تَعَمُّدٌ نَظَرٌ':Added, #1: 1	تَعَمُّدَ نَظَرِ
u'تَعَمُّدٌ نَظَرٌ':Added, #1: 1	تَعَمُّدُ نَظَرِ
u'تَعَمَّدَ نَوْمٌ':Predicate, #4: 4	تَعَمُّدُ النَّظَرِ
u'تَعَمَّدَ واحد':Subject, #4: 4	تَعَمَّدَ النَّوْمَ
u'تَعَمَّدَ وَاحِدٌ':Subject, #1: 1	تَعَمَّدَ وَاحِدٌ
u'تَعَمَّدَ يَمِينٌ':Predicate, #1: 1	تَعَمَّدَ وَاحِدٌ
u'تَعْمِيرٌ رُكْنٌ':Added, #1: 1	تَعَمَّدَ الْيَمِينَ
u'تَعْمِيرٌ رُكْن':Added, #1: 1	تَعْمِيرُ الرُّكْنِ
u'تَعْمِيرٌ مُشْتَرَكٌ':Added, #1: 1	تَعْمِيرُ الرُّكْنِ
u'تَعْمِيرٌ وَقْفٌ':Added, #1: 1	تَعْمِيرِ الْمُشْتَرَكِ
u'تَعْمِيقٌ أسَاسٌ':Added, #1: 1	تَعْمِيرِ الْوَقْفِ
u'تَعْمِيقٌ أَسَاسٌ':Added, #1: 1	تَعْمِيقِ الْأَسَاسِ
u'تَعْمِيقٌ بِئْرٌ':Added, #1: 1	تَعْمِيقِ الْأَسَاسِ
u'تَعْمِيقٌ قَبْرٌ':Added, #1: 1	تَعْمِيقِ الْبِئْرِ
u'تَعْمِيقٌ قَبْرٌ':Added, #1: 1	تَعْمِيقَ الْقَبْرِ
u'تَعْمِيقٌ مُرْتَفِعٌ':Added, #2: 2	تَعْمِيقُ الْقَبْرِ
u'تَعْمِيمٌ أبْنيَةٌ':Added, #2: 2	تَعْمِيقِ الْمُرْتَفِعِ
u'تَعْمِيمٌ اِتِّصَافٌ':Added, #1: 1	تَعْمِيمِ أَبْنِيَةِ
u'تَعْمِيمٌ أَحْوالٌ':Added, #1: 1	تَعْمِيمُ اتِّصَافِ
u'تَعْمِيمٌ أحْوَالٌ':Added, #1: 1	تَعْمِيمَ الْأَحْوَالِ
u'تَعْمِيمٌ إِذْنٌ':Added, #1: 1	تَعْمِيمَ الْأَحْوَالِ
u'تَعْمِيمٌ اِسْتِحْقَاقٌ':Added, #1: 1	تَعْمِيمَ الْإِذْنِ
u'تَعْمِيمٌ اِسْمٌ':Added, #1: 1	تَعْمِيمُ اسْتِحْقَاقِ
u'تَعْمِيمٌ أَصْنَافٌ':Added, #1: 1	تَعْمِيمِ اسْمِ
u'تَعْمِيمٌ أَفْعَالٌ':Added, #1: 1	تَعْمِيمُ الْأَصْنَافِ
u'تَعْمِيمٌ أَفْعَالٌ':Added, #1: 1	تَعْمِيمُ الْأَفْعَالِ
u'تَعْمِيمٌ آلةٌ':Added, #3: 3	تَعْمِيمَ الْأَفْعَالِ
u'تَعْمِيمٌ أُمَّةٌ':Added, #1: 1	تَعْمِيمُ الْآلَةِ
u'تَعْمِيمٌ أَوَّلُ':Added, #1: 1	تَعْمِيمِ الأُمَّةِ
u'تَعْمِيمٌ بدن':Added, #1: 1	تَعْمِيمُ الْأَوَّلِ
u'تَعْمِيمٌ بَدَنٌ':Added, #1: 1	تَعْمِيمُ بَدَنِهِ
u'تَعْمِيمٌ بدن':Added, #1: 1	تَعْمِيمُ بَدَنِهِ
u'تَعْمِيمٌ بَدَنٌ':Added, #2: 2	تَعْمِيمُ الْبَدَنِ
u'تَعْمِيمٌ بُقَعٌ':Added, #2: 2	تَعْمِيمُ الْبَدَنِ
u'تَعْمِيمٌ تَحِيَّةٌ':Added, #1: 1	تَعْمِيمُ بُقَعِ
u'تَعْمِيمٌ جَسَدٌ':Added, #1: 1	تَعْمِيمِ التَّحِيَّةِ
u'تَعْمِيمٌ جَسَدٌ':Added, #1: 1	تَعْمِيمُ الْجَسَدِ
u'تَعْمِيمٌ جِنْسٌ':Added, #3: 3	تَعْمِيمِ الْجَسَدِ
u'تَعْمِيمٌ جِهَةٌ':Added, #1: 1	تَعْمِيمَ الْجِنْسِ
u'تَعْمِيمٌ حُكْمٌ':Added, #1: 1	تَعْمِيمِ جِهَاتِ
u'تَعْمِيمٌ حُكْمٌ':Added, #1: 1	تَعْمِيمَ الْحُكْمِ
u'تَعْمِيمٌ حُكْمٌ':Added, #2: 2	تَعْمِيمُ الْحُكْمِ
u'تَعْمِيمٌ خاصّ':Added, #2: 2	تَعْمِيمِ الْحُكْمِ
u'تَعْمِيمٌ خِلاَفٌ':Added, #1: 1	تَعْمِيمِ الْخَاصِّ
u'تَعْمِيمٌ دُعَاءٌ':Added, #1: 1	تَعْمِيمَ الْخِلَافِ
u'تَعْمِيمٌ ذُرِّيَّةٌ':Added, #1: 1	تَعْمِيمِ الدُّعَاءِ
u'تَعْمِيمٌ رَأْسٌ':Added, #1: 1	تَعْمِيمُ ذُرِّيَّةِ
u'تَعْمِيمٌ رَأْسٌ':Added, #1: 1	تَعْمِيمُ الرَّأْسِ
u'تَعْمِيمٌ رِجْلٌ':Added, #1: 1	تَعْمِيمِ الرَّأْسِ
u'تَعْمِيمٌ سُنَّةٌ':Added, #1: 1	تَعْمِيمُ الرِّجْلِ
u'تَعْمِيمٌ شَعْرٌ':Added, #1: 1	تَعْمِيمُ السُّنَّةِ
u'تَعْمِيمٌ ظاهِرٌ':Added, #1: 1	تَعْمِيمُ شَعْرِهِ
u'تَعْمِيمٌ ظاهِرٌ':Added, #1: 1	تَعْمِيمِ الظَّاهِرِ
u'تَعْمِيمٌ غَنَمٌ':Added, #1: 1	تَعْمِيمِ ظَاهِرِ
u'تَعْمِيمٌ فَرِيقٌ':Added, #1: 1	تَعْمِيمِ الْغَنَمِ
u'تَعْمِيمٌ فِعْلٌ':Added, #1: 1	تَعْمِيمُ الْفَرِيقَيْنِ
u'تَعْمِيمٌ فِعْلٌ':Added, #1: 1	تَعْمِيمَ الْفِعْلِ
u'تَعْمِيمٌ قَبِيلَةٌ':Added, #1: 1	تَعْمِيمُ الْفِعْلِ
u'تَعْمِيمٌ قتل':Added, #1: 1	تَعْمِيمُ الْقَبِيلَةِ
u'تَعْمِيمٌ قَتْلٌ':Added, #1: 1	تَعْمِيمَ الْقَتْلِ
u'تَعْمِيمٌ قول':Added, #1: 1	تَعْمِيمَ الْقَتْلِ
u'تَعْمِيمٌ قَوْلٌ':Added, #1: 1	تَعْمِيمُ قَوْلِ
u'تَعْمِيمٌ قول':Added, #1: 1	تَعْمِيمُ قَوْلِ
u'تَعْمِيمٌ قَوْلٌ':Added, #1: 1	تَعْمِيمُ قَوْلِهِ
u'تَعْمِيمٌ قول':Added, #1: 1	تَعْمِيمُ قَوْلِهِ
u'تَعْمِيمٌ قَوْلٌ':Added, #2: 2	تَعْمِيمِ قَوْلِهِ
u'تَعْمِيمٌ مَحَلٌّ':Added, #2: 2	تَعْمِيمِ قَوْلِهِ
u'تَعْمِيمٌ مَسْأَلَةٌ':Added, #1: 1	تَعْمِيمِ الْمَحَلِّ
u'تَعْمِيمٌ مَسْحٌ':Added, #1: 1	تَعْمِيمَ الْمَسْأَلَةِ
u'تَعْمِيمٌ مَسْحٌ':Added, #1: 1	تَعْمِيمِ مَسْحِ
u'تَعْمِيمٌ مُشْتَرَكٌ':Added, #2: 2	تَعْمِيمَ مَسْحِ
u'تَعْمِيمٌ مُشْتَرَكٌ':Added, #1: 1	تَعْمِيمَ الْمُشْتَرَكِ
u'تَعْمِيمٌ مُشْتَقٌّ':Added, #2: 2	تَعْمِيمِ الْمُشْتَرَكِ
u'تَعْمِيمٌ مَشِيئَةٌ':Added, #1: 1	تَعْمِيمُ الْمُشْتَقَّاتِ
u'تَعْمِيمٌ مُوجَبٌ':Added, #1: 1	تَعْمِيمِ الْمَشِيئَةِ
u'تَعْمِيمٌ مَوْقُوفٌ':Added, #1: 1	تَعْمِيمِ مُوجَبِ
u'تَعْمِيمٌ مُوَكِّلٌ':Added, #1: 1	تَعْمِيمُ الْمَوْقُوفِ
u'تَعْمِيمٌ نَصْلٌ':Added, #1: 1	تَعْمِيمَ الْمُوَكِّلِ
u'تَعْمِيمٌ نَفْعٌ':Added, #2: 2	تَعْمِيمُ النَّصْلِ
u'تَعْمِيمٌ نَهْيٌ':Added, #1: 1	تَعْمِيمُ النَّفْعِ
u'تَعْمِيمٌ نَهْيٌ':Added, #1: 1	تَعْمِيمُ النَّهْيِ
u'تَعْمِيمٌ وَاقِعٌ':Added, #1: 1	تَعْمِيمِ النَّهْيِ
u'تَعْمِيمٌ وَجْهٌ':Added, #3: 3	تَعْمِيمُ الْوَاقِعِ
u'تَعْمِيمٌ وَقْتٌ':Added, #1: 1	تَعْمِيمِ الْوَجْهِ
u'تَعْمِيمٌ وَقْتٌ':Added, #1: 1	تَعْمِيمِ الْوَقْتِ
u'تَعْمِيمٌ وَقْتٌ':Added, #2: 2	تَعْمِيمَ الْوَقْتِ
u'تَعْمِيمٌ يَدٌ':Added, #2: 2	تَعْمِيمُ الْوَقْتِ
u'تَعَهُّدٌ أَشْجَارٌ':Added, #1: 1	تَعْمِيمُ الْيَدِ
u'تَعَهُّدٌ أَشْجَارٌ':Added, #1: 1	تَعَهُّدِ أَشْجَارِهِ
u'تَعَهُّدٌ شَجَرَةٌ':Added, #1: 1	تَعَهُّدُ الْأَشْجَارِ
u'تَعَهُّدٌ شَعْرٌ':Added, #1: 1	تَعَهُّدُ الشَّجَرَةِ
u'تَعَهُّدٌ نَفْسٌ':Added, #1: 1	تَعَهُّدُ الشَّعْرِ
u'تَعَهُّدٌ ولد':Added, #1: 1	تَعَهُّدُ نَفْسِهِ
u'تَعَهُّدٌ وَلَدٌ':Added, #1: 1	تَعَهُّدِ الْوَلَدِ
u'تَعَوَّدَ إِنْسانٌ':Subject, #1: 1	تَعَهُّدِ الْوَلَدِ
u'تَعَوَّدَ تِجَارَةٌ':Predicate, #1: 1	تَعَوَّدَ الْإِنْسَانُ
u'تَعَوَّدَ حارٌّ':Predicate, #1: 1	تَعَوَّدَ التِّجَارَةَ
u'تَعَوَّدَ حُضورٌ':Predicate, #1: 1	تَعَوَّدَ الْحَارَّ
u'تَعَوَّدَ حُضُورٌ':Predicate, #1: 1	تَعَوَّدَ حُضُورَ
u'تَعَوَّدَ دونٌ':Predicate, #1: 1	تَعَوَّدَ حُضُورَ
u'تَعَوَّدَ رَدٌّ':Predicate, #1: 1	تَعَوَّدَ دُونَ
u'تَعَوَّدَ سَمَاعٌ':Predicate, #1: 1	تَعَوَّدَ رَدَّ
u'تَعَوَّدَ عَوْدٌ':Predicate, #1: 1	تَعَوَّدَ السَّمَاعَ
u'تَعَوَّدَ قِرَاءةٌ':Predicate, #1: 1	تَعَوَّدَ الْعَوْدَ
u'تَعَوَّذَ عِبَادٌ':Subject, #2: 2	تَعَوَّدَ الْقِرَاءَةَ
u'تَعَوُّذٌ قَارِئٌ':Added, #1: 1	تَعَوَّذَ الْعِبَادُ
u'تَعَوُّذٌ قِرَاءةٌ':Added, #1: 1	تَعَوُّذِ الْقَارِئِ
u'تَعْوِيذٌ سِحْرٌ':Added, #1: 1	تَعَوُّذُ الْقِرَاءَةِ
u'تَعْوِيضٌ أَجْنَبِيٌّ':Added, #1: 1	تَعْوِيذَ السِّحْرِ
u'تَعْوِيضٌ ألف':Added, #1: 1	تَعْوِيضُ الْأَجْنَبِيِّ
u'تَعْوِيضٌ ألف':Added, #1: 1	تَعْوِيضِ الْأَلِفِ
u'تَعْوِيضٌ ألْفٌ':Added, #1: 1	تَعْوِيضِ الْأَلْفِ
u'تَعْوِيضٌ أَلْفٌ':Added, #1: 1	تَعْوِيضِ الْأَلْفِ
u'تَعْوِيضٌ أُنْمُلَةٌ':Added, #1: 1	تَعْوِيضِ الْأَلْفِ
u'تَعْوِيضٌ خَصْمٌ':Added, #1: 1	تَعْوِيضِ الْأُنْمُلَةِ
u'تَعْوِيضٌ سِنٌّ':Added, #1: 1	تَعْوِيضُ الْخَصْمِ
u'تَعْوِيضٌ مُسْلِمٌ':Added, #1: 1	تَعْوِيضُ سِنٍّ
u'تَعْوِيضٌ مَظْلُومٌ':Added, #1: 1	تَعْوِيضُ الْمُسْلِمِ
u'تَعْوِيلٌ أصل':Added, #1: 1	تَعْوِيضَ الْمَظْلُومِ
u'تَعْوِيلٌ أًصْلٌ':Added, #1: 1	تَعْوِيلَ الْأَصْلِ
u'تَعَيَّنَ أَبٌ':Subject, #1: 1	تَعْوِيلَ الْأَصْلِ
u'تَعَيُّنٌ أَبٌ':Added, #1: 1	تَعَيَّنَ الْأَبُ
u'تَعَيَّنَ إِبْقَاءٌ':Subject, #1: 1	تَعَيُّنُ الْأَبِ
u'تَعَيَّنَ إتْمَامٌ':Subject, #1: 1	تَعَيَّنَ الْإِبْقَاءُ
u'تَعَيَّنَ اِجْتِمَاعٌ':Subject, #1: 1	تَعَيَّنَ إتْمَامُهُ
u'تَعَيَّنَ إِجْرَاءٌ':Subject, #1: 1	تَعَيَّنَ اجْتِمَاعُ
u'تَعَيَّنَ إِحالَةٌ':Subject, #1: 1	تَعَيَّنَ إجْرَاءُ
u'تَعَيَّنَ أحَدٌ':Subject, #1: 1	تَعَيَّنَ إحَالَةُ
u'تَعَيَّنَ إِحْرَامٌ':Subject, #1: 1	تَعَيَّنَ أَحَدُ
u'تَعَيَّنَ إِحْرَامٌ':Subject, #3: 3	تَعَيَّنَ إحْرَامُهُ
u'تَعَيَّنَ إِخْبَارٌ':Subject, #3: 3	تَعَيَّنَ الْإِحْرَامُ
u'تَعَيَّنَ أخْذٌ':Subject, #1: 1	تَعَيَّنَ إخْبَارُهُ
u'تَعَيَّنَ أخْذٌ':Subject, #1: 1	تَعَيَّنَ أَخْذُهُ
u'تَعَيُّنٌ أخفُّ':Added, #2: 2	تَعَيَّنَ الْأَخْذُ
u'تَعَيَّنَ أَدَاءٌ':Subject, #1: 1	تَعَيُّنِ الْأَخَفِّ
u'تَعَيُّنٌ إِذْنٌ':Added, #1: 1	تَعَيَّنَ أَدَاءُ
u'تَعَيُّنٌ إِرَادَةٌ':Added, #1: 1	تَعَيُّنِ الْإِذْنِ
u'تَعَيُّنٌ إِرَادَةٌ':Added, #1: 1	تَعَيُّنَ إرَادَةِ
u'تَعَيُّنٌ إِرَادَةٌ':Added, #1: 1	تَعَيُّنَ إرَادَتِهِ
u'تَعَيَّنَ إِرْكَابٌ':Subject, #1: 1	تَعَيُّنِ إرَادَتِهِ
u'تَعَيَّنَ اِسْتِعْمالٌ':Subject, #2: 2	تَعَيَّنَ الْإِرْكَابُ
u'تَعَيَّنَ أَسْفَلُ':Subject, #1: 1	تَعَيَّنَ اسْتِعْمَالُهُ
u'تَعَيَّنَ أصل':Subject, #5: 5	تَعَيَّنَ الْأَسْفَلُ
u'تَعَيَّنَ أًصْلٌ':Subject, #1: 1	تَعَيَّنَ أَصْلُهُ
u'تَعَيُّنٌ أصل':Added, #1: 1	تَعَيَّنَ أَصْلُهُ
u'تَعَيُّنٌ أًصْلٌ':Added, #1: 1	تَعَيُّنِ الْأَصْلِ
u'تَعَيُّنٌ أَصْلَحُ':Added, #1: 1	تَعَيُّنِ الْأَصْلِ
u'تَعَيَّنَ إِطْعامٌ':Subject, #1: 1	تَعَيُّنُ الْأَصْلَحِ
u'تَعَيَّنَ إِعْتاقٌ':Subject, #3: 3	تَعَيَّنَ الْإِطْعَامُ
u'تَعَيَّنَ اِعْتِبارٌ':Subject, #1: 1	تَعَيَّنَ الْإِعْتَاقُ
u'تَعَيَّنَ أغْلَبُ':Subject, #2: 2	تَعَيَّنَ اعْتِبَارُ
u'تَعَيَّنَ أَفْرَادٌ':Subject, #1: 1	تَعَيَّنَ الْأَغْلَبُ
u'تَعَيُّنٌ إِقْراضٌ':Added, #1: 1	تَعَيَّنَ أَفْرَادُ
u'تَعَيَّنَ أقَلُّ':Subject, #1: 1	تَعَيُّنِ الْإِقْرَاضِ
u'تَعَيَّنَ إلْحَاقٌ':Subject, #1: 1	تَعَيَّنَ الْأَقَلُّ
u'تَعَيُّنٌ الْمَرْأَةُ':Added, #1: 1	تَعَيَّنَ إلْحَاقُهُ
u'تَعَيُّنٌ أُمٌّ':Added, #1: 1	تَعَيُّنُ الْمَرْأَةِ
u'تَعَيَّنَ إمَامٌ':Subject, #1: 1	تَعَيُّنِ أُمِّ
u'تَعَيَّنَ إِمْساكٌ':Subject, #1: 1	تَعَيَّنَ إمَامٌ
u'تَعَيَّنَ إِمْكانٌ':Subject, #1: 1	تَعَيَّنَ إمْسَاكُ
u'تَعَيَّنَ اِنْتِقالٌ':Subject, #2: 2	تَعَيَّنَ الْإِمْكَانُ
u'تَعَيَّنَ أَوَّلُ':Subject, #1: 1	تَعَيَّنَ انْتِقَالُ
u'تَعَيَّنَ أَوَّلُ':Subject, #2: 2	تَعَيَّنَ الْأَوَّلُ
u'تَعَيَّنَ بَائِعٌ':Subject, #2: 2	تَعَيَّنَ أَوَّلُ
u'تَعَيُّنٌ بَدَلٌ':Added, #1: 1	تَعَيَّنَ الْبَائِعُ
u'تَعَيَّنَ بَعْضٌ':Subject, #1: 1	تَعَيُّنِ بَدَلِ
u'تَعَيُّنٌ بَعْضٌ':Added, #1: 1	تَعَيَّنَ الْبَعْضُ
u'تَعَيُّنٌ بَعْضٌ':Added, #1: 1	تَعَيُّنُ الْبَعْضِ
u'تَعَيُّنٌ بَعْضٌ':Added, #1: 1	تَعَيُّنِ الْبَعْضِ
u'تَعَيَّنَ بُنْدُقٌ':Subject, #1: 1	تَعَيُّنِ بَعْضِ
u'تَعَيَّنَ بَيْتٌ':Subject, #1: 1	تَعَيَّنَ الْبُنْدُقُ
u'تَعَيَّنَ بَيْعٌ':Subject, #1: 1	تَعَيَّنَ الْبَيْتُ
u'تَعَيُّنٌ بَيْعٌ':Added, #6: 6	تَعَيَّنَ الْبَيْعُ
u'تَعَيُّنٌ بَيْعٌ':Added, #1: 1	تَعَيُّنِ الْبَيْعِ
u'تَعَيَّنَ تَأْخِيرٌ':Subject, #1: 1	تَعَيُّنُ بَيْعِهِ
u'تَعَيُّنٌ تَأْخِيرٌ':Added, #1: 1	تَعَيَّنَ التَّأْخِيرُ
u'تَعَيَّنَ تَحَالُفٌ':Subject, #1: 1	تَعَيُّنِ تَأْخِيرِهِ
u'تَعَيُّنٌ تَحَقُّقٌ':Added, #1: 1	تَعَيَّنَ التَّحَالُفُ
u'تَعَيَّنَ تَرْتِيبٌ':Subject, #1: 1	تَعَيُّنِ تَحَقُّقِهِ
u'تَعَيَّنَ تَرْجِيحٌ':Subject, #1: 1	تَعَيَّنَ التَّرْتِيبُ
u'تَعَيُّنٌ تَرْكٌ':Added, #3: 3	تَعَيَّنَ التَّرْجِيحُ
u'تَعَيَّنَ تَسْرِيحٌ':Subject, #1: 1	تَعَيُّنُ التَّرْكِ
u'تَعَيَّنَ تَسْلِيمٌ':Subject, #3: 3	تَعَيَّنَ التَّسْرِيحُ
u'تَعَيَّنَ تَسْمِيَة':Subject, #1: 1	تَعَيَّنَ التَّسْلِيمُ
u'تَعَيُّنٌ تَضْمِينٌ':Added, #1: 1	تَعَيَّنَ التَّسْمِيَةُ
u'تَعَيَّنَ تَعْدِيلٌ':Subject, #1: 1	تَعَيُّنِ تَضْمِينِ
u'تَعَيَّنَ تَعَلُّقٌ':Subject, #1: 1	تَعَيَّنَ التَّعْدِيلُ
u'تَعَيَّنَ تَعَلُّقٌ':Subject, #1: 1	تَعَيَّنَ تَعَلُّقُهُ
u'تَعَيَّنَ تَفْرِيقٌ':Subject, #2: 2	تَعَيَّنَ التَّعَلُّقُ
u'تَعَيُّنٌ تَفْصِيلٌ':Added, #4: 4	تَعَيَّنَ التَّفْرِيقُ
u'تَعَيَّنَ تَقْصيرٌ':Subject, #1: 1	تَعَيُّنِ التَّفْصِيلِ
u'تَعَيَّنَ تَقْويمٌ':Subject, #2: 2	تَعَيَّنَ التَّقْصِيرُ
u'تَعَيَّنَ تَمْر':Subject, #2: 2	تَعَيَّنَ التَّقْوِيمُ
u'تَعَيَّنَ ثَابِتٌ':Subject, #1: 1	تَعَيَّنَ التَّمْرُ
u'تَعَيُّنٌ ثَابِتٌ':Added, #1: 1	تَعَيَّنَ الثَّابِتُ
u'تَعَيَّنَ ثَالِثٌ':Subject, #1: 1	تَعَيُّنَ الثَّابِتِ
u'تَعَيَّنَ جَازٌ':Predicate, #1: 1	تَعَيَّنَ الثَّالِثُ
u'تَعَيَّنَ جَانِبٌ':Subject, #1: 1	تَعَيَّنَ جَازَ
u'تَعَيُّنٌ جُزْءٌ':Added, #1: 1	تَعَيَّنَ الْجَانِبُ
u'تَعَيُّنٌ جمع':Added, #1: 1	تَعَيُّنِ الْجُزْءِ
u'تَعَيُّنٌ جَمْعٌ':Added, #1: 1	تَعَيُّنِ الْجَمْعِ
u'تَعَيُّنٌ جِنْسٌ':Added, #1: 1	تَعَيُّنِ الْجَمْعِ
u'تَعَيَّنَ جهاد':Subject, #1: 1	تَعَيُّنُ جِنْسِهِ
u'تَعَيَّنَ جِهَادٌ':Subject, #1: 1	تَعَيَّنَ الْجِهَادُ
u'تَعَيَّنَ جِهَةٌ':Subject, #1: 1	تَعَيَّنَ الْجِهَادُ
u'تَعَيَّنَ جِهَةٌ':Subject, #1: 1	تَعَيَّنَ جِهَةٌ
u'تَعَيُّنٌ جِهَةٌ':Added, #1: 1	تَعَيَّنَ جِهَةُ
u'تَعَيُّنٌ جِهَةٌ':Added, #1: 1	تَعَيُّنَ جِهَةِ
u'تَعَيَّنَ جَوَابٌ':Subject, #1: 1	تَعَيُّنُ جِهَةِ
u'تَعَيَّنَ حاضِرٌ':Subject, #2: 2	تَعَيَّنَ الْجَوَابُ
u'تَعَيُّنٌ حاضِرٌ':Added, #1: 1	تَعَيَّنَ الْحَاضِرُ
u'تَعَيَّنَ حانوتٌ':Subject, #1: 1	تَعَيُّنُ الْحَاضِرِ
u'تَعَيُّنٌ حَبْسٌ':Added, #1: 1	تَعَيَّنَ الْحَانُوتُ
u'تَعَيَّنَ حَدَثٌ':Subject, #1: 1	تَعَيُّنِ الْحَبْسِ
u'تَعَيُّنٌ حَدَثٌ':Added, #1: 1	تَعَيَّنَ الْحَدَثُ
u'تَعَيَّنَ حَرامٌ':Subject, #1: 1	تَعَيُّنُ حَدَثٍ
u'تَعَيَّنَ حَسْمٌ':Subject, #1: 1	تَعَيَّنَ الْحَرَامُ
u'تَعَيَّنَ حُصُول':Subject, #1: 1	تَعَيَّنَ حَسْمُ
u'تَعَيَّنَ حَقٌّ':Subject, #1: 1	تَعَيَّنَ الْحُصُولُ
u'تَعَيَّنَ حَقٌّ':Subject, #2: 2	تَعَيَّنَ الْحَقُّ
u'تَعَيَّنَ حَقٌّ':Subject, #7: 7	تَعَيَّنَ حَقُّ
u'تَعَيُّنٌ حَقٌّ':Added, #7: 7	تَعَيَّنَ حَقُّهُ
u'تَعَيُّنٌ حَقٌّ':Added, #1: 1	تَعَيُّنِ الْحَقِّ
u'تَعَيُّنٌ حَقٌّ':Added, #1: 1	تَعَيُّنِ حَقِّ
u'تَعَيُّنٌ حِكَايَةٌ':Added, #4: 4	تَعَيُّنَ حَقِّهِ
u'تَعَيَّنَ حُكْمٌ':Subject, #1: 1	تَعَيُّنِ حِكَايَةِ
u'تَعَيَّنَ حَلْقٌ':Subject, #1: 1	تَعَيَّنَ حُكْمُهُ
u'تَعَيَّنَ حَمْلٌ':Subject, #4: 4	تَعَيَّنَ الْحَلْقُ
u'تَعَيَّنَ حَمْلٌ':Subject, #1: 1	تَعَيَّنَ حَمْلُهُ
u'تَعَيَّنَ حَمْلٌ':Subject, #2: 2	تَعَيَّنَ حَمْلُ
u'تَعَيَّنَ خَارِجٌ':Subject, #3: 3	تَعَيَّنَ الْحَمْلُ
u'تَعَيُّنٌ خَارِجٌ':Added, #2: 2	تَعَيَّنَ الْخَارِجُ
u'تَعَيَّنَ خَالِقٌ':Subject, #1: 1	تَعَيُّنَ الْخَارِجِ
u'تَعَيَّنَ خدمة':Subject, #1: 1	تَعَيَّنَ الْخَالِقُ
u'تَعَيَّنَ خِدْمَةٌ':Subject, #1: 1	تَعَيَّنَ الْخِدْمَةُ
u'تَعَيَّنَ خُرُوجٌ':Subject, #1: 1	تَعَيَّنَ الْخِدْمَةُ
u'تَعَيَّنَ خَطَأٌ':Subject, #3: 3	تَعَيَّنَ خُرُوجُهُ
u'تَعَيُّنٌ دِرْهَمٌ':Added, #1: 1	تَعَيَّنَ الْخَطَأُ
u'تَعَيُّنٌ دِرْهَم':Added, #1: 1	تَعَيُّنِ الدِّرْهَمِ
u'تَعَيُّنٌ دُعَاءٌ':Added, #1: 1	تَعَيُّنِ الدِّرْهَمِ
u'تَعَيَّنَ دَمٌ':Subject, #1: 1	تَعَيُّنِ الدُّعَاءِ
u'تَعَيَّنَ دونٌ':Predicate, #3: 3	تَعَيَّنَ الدَّمُ
u'تَعَيُّنٌ دِينارٌ':Added, #1: 1	تَعَيَّنَ دُونَ
u'تَعَيَّنَ ذكر':Subject, #1: 1	تَعَيُّنُ الدِّينَارِ
u'تَعَيَّنَ ذِكْرٌ':Subject, #1: 1	تَعَيَّنَ ذِكْرُهُ
u'تَعَيَّنَ رَاجِحٌ':Subject, #1: 1	تَعَيَّنَ ذِكْرُهُ
u'تَعَيَّنَ رُجُوعٌ':Subject, #1: 1	تَعَيَّنَ الرَّاجِحُ
u'تَعَيَّنَ رَدٌّ':Subject, #1: 1	تَعَيَّنَ الرُّجُوعُ
u'تَعَيَّنَ رَدٌّ':Subject, #1: 1	تَعَيَّنَ رَدُّهُ
u'تَعَيُّنٌ رَدٌّ':Added, #2: 2	تَعَيَّنَ رَدُّ
u'تَعَيَّنَ رِعايَةٌ':Subject, #1: 1	تَعَيُّنَ رَدِّ
u'تَعَيُّنٌ رِفْقٌ':Added, #2: 2	تَعَيَّنَ رِعَايَةُ
u'تَعَيَّنَ رُكوبٌ':Subject, #1: 1	تَعَيُّنِ الرِّفْقِ
u'تَعَيَّنَ رُكوبٌ':Subject, #2: 2	تَعَيَّنَ الرُّكُوبُ
u'تَعَيُّنٌ رَمْيٌ':Added, #2: 2	تَعَيَّنَ رُكُوبُهُ
u'تَعَيُّنٌ رُؤْيَةٌ':Added, #1: 1	تَعَيُّنِ الرَّمْيِ
u'تَعَيَّنَ زَمانٌ':Subject, #1: 1	تَعَيُّن الرُّؤْيَةِ
u'تَعَيُّنٌ زَمانٌ':Added, #1: 1	تَعَيَّنَ زَمَانُهُ
u'تَعَيُّنٌ زَمَنٌ':Added, #1: 1	تَعَيُّنِ الزَّمَانِ
u'تَعَيَّنَ سَابِقٌ':Subject, #1: 1	تَعَيُّنِ الزَّمَنِ
u'تَعَيُّنٌ سَابِقٌ':Added, #3: 3	تَعَيَّنَ السَّابِقُ
u'تَعَيَّنَ سِتْرٌ':Subject, #1: 1	تَعَيُّنِ السَّابِقِ
u'تَعَيَّنَ سِلاَحٌ':Subject, #1: 1	تَعَيَّنَ سِتْرُ
u'تَعَيَّنَ سَهْمٌ':Subject, #1: 1	تَعَيَّنَ السِّلَاحُ
u'تَعَيَّنَ سَوْطٌ':Subject, #2: 2	تَعَيَّنَ سَهْمُهُ
u'تَعَيَّنَ سَيْفٌ':Subject, #1: 1	تَعَيَّنَ السَّوْطُ
u'تَعَيُّنٌ سَيْفٌ':Added, #1: 1	تَعَيَّنَ السَّيْفُ
u'تَعَيَّنَ شَخْصٌ':Subject, #1: 1	تَعَيُّنُ السَّيْفِ
u'تَعَيُّنٌ شَرْعِيٌّ':Added, #1: 1	تَعَيَّنَ الشَّخْصُ
u'تَعَيُّنٌ شَرِيكٌ':Added, #1: 1	تَعَيُّنِ الشَّرْعِيِّ
u'تَعَيُّنٌ شَهْرٌ':Added, #1: 1	تَعَيُّنَ الشَّرِيكِ
u'تَعَيُّنٌ صبر':Added, #1: 1	تَعَيُّنِ الشَّهْرِ
u'تَعَيُّنٌ صَبْرٌ':Added, #1: 1	تَعَيُّنِ الصَّبْرِ
u'تَعَيَّنَ صَرْفٌ':Subject, #1: 1	تَعَيُّنِ الصَّبْرِ
u'تَعَيَّنَ صَرْف':Subject, #2: 2	تَعَيَّنَ صَرْفُ
u'تَعَيَّنَ صَرْفٌ':Subject, #2: 2	تَعَيَّنَ صَرْفُ
u'تَعَيَّنَ صَرْف':Subject, #3: 3	تَعَيَّنَ الصَّرْفُ
u'تَعَيَّنَ صَرْفٌ':Subject, #3: 3	تَعَيَّنَ الصَّرْفُ
u'تَعَيَّنَ صَرْف':Subject, #5: 5	تَعَيَّنَ صَرْفُهُ
u'تَعَيُّنٌ صِفَةٌ':Added, #5: 5	تَعَيَّنَ صَرْفُهُ
u'تَعَيُّنٌ صَلاَةٌ':Added, #1: 1	تَعَيُّنَ صِفَةِ
u'تَعَيُّنٌ صَلاَةٌ':Added, #1: 1	تَعَيُّنُ الصَّلَاةِ
u'تَعَيَّنَ صُورَةٌ':Subject, #1: 1	تَعَيُّنِ الصَّلَاةِ
u'تَعَيَّنَ صَوْمٌ':Subject, #1: 1	تَعَيَّنَ صُورَةٌ
u'تَعَيُّنٌ صَوْمٌ':Added, #1: 1	تَعَيَّنَ الصَّوْمُ
u'تَعَيَّنَ ضَرْبٌ':Subject, #1: 1	تَعَيُّنَ الصَّوْمِ
u'تَعَيَّنَ ضَمَانٌ':Subject, #1: 1	تَعَيَّنَ الضَّرْبُ
u'تَعَيَّنَ ضَمَانٌ':Subject, #1: 1	تَعَيَّنَ الضَّمَانُ
u'تَعَيُّنٌ طَالِبٌ':Added, #1: 1	تَعَيَّنَ ضَمَانُهُ
u'تَعَيَّنَ طَرِيقٌ':Subject, #1: 1	تَعَيُّنِ طَالِبِهِ
u'تَعَيَّنَ طَرِيقٌ':Subject, #1: 1	تَعَيَّنَ طَرِيقُهُ
u'تَعَيَّنَ طَلاَقٌ':Subject, #2: 2	تَعَيَّنَ طَرِيقُ
u'تَعَيَّنَ طَلاَقٌ':Subject, #1: 1	تَعَيَّنَ طَلَاقُ
u'تَعَيُّنٌ طَهَارَةٌ':Added, #4: 4	تَعَيَّنَ الطَّلَاقُ
u'تَعَيَّنَ طواف':Subject, #1: 1	تَعَيُّنَ الطَّهَارَةِ
u'تَعَيَّنَ طَوَافٌ':Subject, #1: 1	تَعَيَّنَ طَوَافُ
u'تَعَيُّنٌ ظهار':Added, #1: 1	تَعَيَّنَ طَوَافُ
u'تَعَيُّنٌ عَامٌّ':Added, #1: 1	تَعَيُّنُ الظِّهَارِ
u'تَعَيَّنَ عتق':Subject, #1: 1	تَعَيُّنُ الْعَامِّ
u'تَعَيَّنَ عِتْقٌ':Subject, #2: 2	تَعَيَّنَ عِتْقُهُ
u'تَعَيَّنَ عتق':Subject, #2: 2	تَعَيَّنَ عِتْقُهُ
u'تَعَيَّنَ عِتْقٌ':Subject, #6: 6	تَعَيَّنَ الْعِتْقُ
u'تَعَيُّنٌ عتق':Added, #6: 6	تَعَيَّنَ الْعِتْقُ
u'تَعَيُّنٌ عِتْقٌ':Added, #1: 1	تَعَيُّنِ الْعِتْقِ
u'تَعَيُّنٌ عَدَدٌ':Added, #1: 1	تَعَيُّنِ الْعِتْقِ
u'تَعَيَّنَ عَرْضٌ':Subject, #1: 1	تَعَيُّنُ عَدَدِهِ
u'تَعَيَّنَ عزل':Subject, #1: 1	تَعَيَّنَ الْعَرْضُ
u'تَعَيَّنَ عطف':Subject, #2: 2	تَعَيَّنَ عَزْلُهُ
u'تَعَيَّنَ عَطْفٌ':Subject, #1: 1	تَعَيَّنَ الْعَطْفُ
u'تَعَيُّنٌ عَكْسٌ':Added, #1: 1	تَعَيَّنَ الْعَطْفُ
u'تَعَيَّنَ عَمَلٌ':Subject, #1: 1	تَعَيُّنُ الْعَكْسِ
u'تَعَيُّنٌ عَمَلٌ':Added, #2: 2	تَعَيَّنَ الْعَمَلُ
u'تَعَيُّنٌ عَمَلٌ':Added, #2: 2	تَعَيُّنَ الْعَمَلِ
u'تَعَيَّنَ عُمُومٌ':Subject, #2: 2	تَعَيُّنِ الْعَمَلِ
u'تَعَيَّنَ عند':Predicate, #1: 1	تَعَيَّنَ الْعُمُومُ
u'تَعَيَّنَ غُسْلٌ':Subject, #1: 1	تَعَيَّنَ عِنْدَ
u'تَعَيُّنٌ غُسْلٌ':Added, #2: 2	تَعَيَّنَ الْغُسْلُ
u'تَعَيُّنٌ فَاتِحٌ':Added, #1: 1	تَعَيُّنُ الْغُسْلِ
u'تَعَيُّنٌ فَاتِحَةٌ':Added, #1: 1	تَعَيُّنُ الْفَاتِحَةِ
u'تَعَيَّنَ فَاعِلٌ':Subject, #1: 1	تَعَيُّنُ الْفَاتِحَةِ
u'تَعَيَّنَ فَرْضٌ':Subject, #1: 1	تَعَيَّنَ فَاعِلُ
u'تَعَيَّنَ فَرْضٌ':Subject, #1: 1	تَعَيَّنَ الْفَرْضُ
u'تَعَيَّنَ فَرْضٌ':Subject, #1: 1	تَعَيَّنَ فَرْضُ
u'تَعَيُّنٌ فَرْضٌ':Added, #1: 1	تَعَيَّنَ فَرْضُهُ
u'تَعَيَّنَ فِعْلٌ':Subject, #1: 1	تَعَيُّنِ الْفَرْضِ
u'تَعَيَّنَ فِعْلٌ':Subject, #1: 1	تَعَيَّنَ الْفِعْلُ
u'تَعَيَّنَ فِعْلٌ':Subject, #1: 1	تَعَيَّنَ فِعْلُ
u'تَعَيُّنٌ فِعْلٌ':Added, #2: 2	تَعَيَّنَ فِعْلُهُ
u'تَعَيَّنَ قَاتِلٌ':Subject, #1: 1	تَعَيُّنُ الْفِعْلِ
u'تَعَيَّنَ قتال':Subject, #1: 1	تَعَيَّنَ قَاتِلُهُ
u'تَعَيَّنَ قِتَالٌ':Subject, #1: 1	تَعَيَّنَ الْقِتَالُ
u'تَعَيَّنَ قتل':Subject, #1: 1	تَعَيَّنَ الْقِتَالُ
u'تَعَيَّنَ قَتْلٌ':Subject, #1: 1	تَعَيَّنَ قَتْلُ
u'تَعَيَّنَ قتل':Subject, #1: 1	تَعَيَّنَ قَتْلُ
u'تَعَيَّنَ قَتْلٌ':Subject, #2: 2	تَعَيَّنَ الْقَتْلُ
u'تَعَيَّنَ قتل':Subject, #2: 2	تَعَيَّنَ الْقَتْلُ
u'تَعَيَّنَ قَتْلٌ':Subject, #2: 2	تَعَيَّنَ قَتْلُهُ
u'تَعَيُّنٌ قتل':Added, #2: 2	تَعَيَّنَ قَتْلُهُ
u'تَعَيُّنٌ قَتْلٌ':Added, #1: 1	تَعَيُّنِ الْقَتْلِ
u'تَعَيُّنٌ قَدْرٌ':Added, #1: 1	تَعَيُّنِ الْقَتْلِ
u'تَعَيُّنٌ قِرَاءةٌ':Added, #1: 1	تَعَيُّنِ الْقَدْرِ
u'تَعَيُّنٌ قُرْعَةٌ':Added, #1: 1	تَعَيُّنُ الْقِرَاءَةِ
u'تَعَيَّنَ قَضَاءٌ':Subject, #1: 1	تَعَيُّنُ الْقُرْعَةِ
u'تَعَيَّنَ قول':Subject, #1: 1	تَعَيَّنَ قَضَاءُ
u'تَعَيَّنَ قَوْلٌ':Subject, #5: 5	تَعَيَّنَ الْقَوْلُ
u'تَعَيَّنَ قيام':Subject, #5: 5	تَعَيَّنَ الْقَوْلُ
u'تَعَيَّنَ قِيَامٌ':Subject, #1: 1	تَعَيَّنَ الْقِيَامُ
u'تَعَيَّنَ قِيمَةٌ':Subject, #1: 1	تَعَيَّنَ الْقِيَامُ
u'تَعَيُّنٌ قِيمَةٌ':Added, #1: 1	تَعَيَّنَ قِيمَةُ
u'تَعَيَّنَ كَامِلٌ':Subject, #1: 1	تَعَيُّنِ قِيمَتِهِ
u'تَعَيَّنَ كَبْشٌ':Subject, #1: 1	تَعَيَّنَ الْكَامِلُ
u'تَعَيُّنٌ كذب':Added, #2: 2	تَعَيَّنَ كَبْشٌ
u'تَعَيُّنٌ كَذِبٌ':Added, #1: 1	تَعَيُّنُ كَذِبِ
u'تَعَيُّنٌ كذب':Added, #1: 1	تَعَيُّنُ كَذِبِ
u'تَعَيُّنٌ كَذِبٌ':Added, #2: 2	تَعَيُّنُ الْكَذِبِ
u'تَعَيُّنٌ كَفَّارٌ':Added, #2: 2	تَعَيُّنُ الْكَذِبِ
u'تَعَيُّنٌ كَفَّارٌ':Added, #1: 1	تَعَيُّنَ الْكَفَّارَةِ
u'تَعَيُّنٌ كَفَّارَةٌ':Added, #1: 1	تَعَيُّنِ الْكَفَّارَةِ
u'تَعَيُّنٌ كَفَّارَةٌ':Added, #1: 1	تَعَيُّنَ الْكَفَّارَةِ
u'تَعَيَّنَ كَوْنٌ':Predicate, #1: 1	تَعَيُّنِ الْكَفَّارَةِ
u'تَعَيَّنَ كَوْنٌ':Subject, #1: 1	تَعَيَّنَ كَوْنَ
u'تَعَيُّنٌ كَوْنٌ':Added, #3: 3	تَعَيَّنَ كَوْنُهُ
u'تَعَيَّنَ لبس':Subject, #2: 2	تَعَيُّنِ كَوْنِهِ
u'تَعَيَّنَ لُبْسٌ':Subject, #1: 1	تَعَيَّنَ لُبْسُهُ
u'تَعَيُّنٌ لُزُومٌ':Added, #1: 1	تَعَيَّنَ لُبْسُهُ
u'تَعَيُّنٌ لُزُومٌ':Added, #1: 1	تَعَيُّنُ لُزُومِ
u'تَعَيَّنَ مَاءٌ':Subject, #1: 1	تَعَيُّنِ لُزُومِ
u'تَعَيُّنٌ مَاءٌ':Added, #4: 4	تَعَيَّنَ الْمَاءُ
u'تَعَيُّنٌ مَاءٌ':Added, #2: 2	تَعَيُّنُ الْمَاءِ
u'تَعَيَّنَ مَالٌ':Subject, #2: 2	تَعَيُّنِ الْمَاءِ
u'تَعَيُّنٌ مَالٌ':Added, #1: 1	تَعَيَّنَ مَالُهُ
u'تَعَيَّنَ مَالِكٌ':Subject, #2: 2	تَعَيُّنِ الْمَالِ
u'تَعَيَّنَ مَالِكٌ':Subject, #1: 1	تَعَيَّنَ مَالِكُ
u'تَعَيُّنٌ مُبَاحٌ':Added, #1: 1	تَعَيَّنَ مَالِكُهُ
u'تَعَيُّنٌ مَبِيعٌ':Added, #1: 1	تَعَيُّنِ الْمُبَاحِ
u'تَعَيَّنَ مُتَأَخِّرٌ':Subject, #2: 2	تَعَيُّنِ الْمَبِيعِ
u'تَعَيَّنَ مَتْرُوكٌ':Subject, #1: 1	تَعَيَّنَ الْمُتَأَخِّرُ
u'تَعَيَّنَ مثل':Subject, #2: 2	تَعَيَّنَ الْمَتْرُوكُ
u'تَعَيَّنَ مِثْلٌ':Subject, #2: 2	تَعَيَّنَ الْمِثْلُ
u'تَعَيَّنَ مَجَازٌ':Subject, #2: 2	تَعَيَّنَ الْمِثْلُ
u'تَعَيُّنٌ مَجَازِيٌّ':Added, #2: 2	تَعَيَّنَ الْمَجَازُ
u'تَعَيُّنٌ مَحَلٌّ':Added, #1: 1	تَعَيُّنَ الْمَجَازِيِّ
u'تَعَيُّنٌ مَحَلٌّ':Added, #1: 1	تَعَيُّنَ الْمَحَلِّ
u'تَعَيُّنٌ مراد':Added, #1: 1	تَعَيُّنِ الْمَحَلِّ
u'تَعَيُّنٌ مراد':Added, #1: 1	تَعَيُّنُ الْمُرَادِ
u'تَعَيُّنٌ مُرَادٌ':Added, #1: 1	تَعَيُّنِ الْمُرَادِ
u'تَعَيُّنٌ مُرَادٌ':Added, #1: 1	تَعَيُّنُ الْمُرَادِ
u'تَعَيَّنَ مُسْتَحِقٌّ':Subject, #1: 1	تَعَيُّنِ الْمُرَادِ
u'تَعَيُّنٌ مُسْتَحِقٌّ':Added, #2: 2	تَعَيَّنَ الْمُسْتَحِقُّ
u'تَعَيَّنَ مَشْيٌ':Subject, #1: 1	تَعَيُّنِ مُسْتَحِقٍّ
u'تَعَيَّنَ مَصِيرٌ':Subject, #1: 1	تَعَيَّنَ الْمَشْيُ
u'تَعَيَّنَ مُضَارِعٌ':Subject, #3: 3	تَعَيَّنَ الْمَصِيرُ
u'تَعَيُّنٌ مُضَافٌ':Added, #1: 1	تَعَيَّنَ الْمُضَارِعُ
u'تَعَيَّنَ مَطْلُوبٌ':Subject, #1: 1	تَعَيُّنِ الْمُضَافِ
u'تَعَيُّنٌ مَعْلُومٌ':Added, #2: 2	تَعَيَّنَ الْمَطْلُوبُ
u'تَعَيُّنٌ مَعْنَوِيٌّ':Added, #1: 1	تَعَيُّنِ الْمَعْلُومِ
u'تَعَيُّنٌ مُفَاضَلَةٌ':Added, #1: 1	تَعَيُّنَ الْمَعْنَوِيِّ
u'تَعَيَّنَ مَكَانٌ':Subject, #1: 1	تَعَيُّنِ الْمُفَاضَلَةِ
u'تَعَيَّنَ مَكَانٌ':Subject, #1: 1	تَعَيَّنَ الْمَكَانُ
u'تَعَيُّنٌ مَكَانٌ':Added, #5: 5	تَعَيَّنَ مَكَانُ
u'تَعَيُّنٌ مَكَانٌ':Added, #1: 1	تَعَيُّنَ الْمَكَانِ
u'تَعَيُّنٌ مَكِيلٌ':Added, #3: 3	تَعَيُّنِ الْمَكَانِ
u'تَعَيَّنَ مِلْكٌ':Subject, #1: 1	تَعَيُّنَ الْمَكِيلِ
u'تَعَيَّنَ مِلْكٌ':Subject, #1: 1	تَعَيَّنَ الْمِلْكُ
u'تَعَيُّنٌ مَمْنُوعٌ':Added, #3: 3	تَعَيَّنَ مِلْكُهُ
u'تَعَيَّنَ مَنْعٌ':Subject, #1: 1	تَعَيُّنِ الْمَمْنُوعِ
u'تَعَيَّنَ مَنْعٌ':Subject, #1: 1	تَعَيَّنَ الْمَنْعُ
u'تَعَيَّنَ مُوَافَقَةٌ':Subject, #1: 1	تَعَيَّنَ مَنْعُ
u'تَعَيَّنَ مَوْجُودٌ':Subject, #1: 1	تَعَيَّنَ مُوَافَقَةُ
u'تَعَيَّنَ مَوْضِعٌ':Subject, #1: 1	تَعَيَّنَ مَوْجُودٌ
u'تَعَيَّنَ مَوْضِعٌ':Subject, #1: 1	تَعَيَّنَ الْمَوْضِعُ
u'تَعَيُّنٌ مَوْقُوفٌ':Added, #2: 2	تَعَيَّنَ مَوْضِعُ
u'تَعَيُّنٌ مَوْقُوفٌ':Added, #1: 1	تَعَيُّنَ الْمَوْقُوفِ
u'تَعَيُّنٌ مِيقَاتٌ':Added, #1: 1	تَعَيُّنِ الْمَوْقُوفِ
u'تَعَيُّنٌ نَاصِيَةٌ':Added, #1: 1	تَعَيُّنِ مِيقَاتِ
u'تَعَيَّنَ نِسْبَةٌ':Predicate, #1: 1	تَعَيُّنِ النَّاصِيَةِ
u'تَعَيَّنَ نصب':Subject, #1: 1	تَعَيَّنَ نِسْبَةَ
u'تَعَيَّنَ نَصْبٌ':Subject, #1: 1	تَعَيَّنَ نَصْبُهُ
u'تَعَيَّنَ نَصْرٌ':Subject, #1: 1	تَعَيَّنَ نَصْبُهُ
u'تَعَيَّنَ نِصْفٌ':Subject, #1: 1	تَعَيَّنَ نَصْرُهُ
u'تَعَيَّنَ نِصْفٌ':Subject, #1: 1	تَعَيَّنَ نِصْفُ
u'تَعَيَّنَ نَظَرٌ':Subject, #2: 2	تَعَيَّنَ النِّصْفُ
u'تَعَيَّنَ نَقْدٌ':Subject, #3: 3	تَعَيَّنَ النَّظَرُ
u'تَعَيَّنَ نَقْد':Subject, #1: 1	تَعَيَّنَ النَّقْدُ
u'تَعَيُّنٌ نَقْدٌ':Added, #1: 1	تَعَيَّنَ النَّقْدُ
u'تَعَيُّنٌ نَقْد':Added, #1: 1	تَعَيُّنِ النَّقْدِ
u'تَعَيَّنَ نَقْضٌ':Subject, #1: 1	تَعَيُّنِ النَّقْدِ
u'تَعَيَّنَ نقل':Subject, #1: 1	تَعَيَّنَ النَّقْضُ
u'تَعَيَّنَ نَقْلٌ':Subject, #1: 1	تَعَيَّنَ نَقْلُ
u'تَعَيَّنَ نكاح':Subject, #1: 1	تَعَيَّنَ نَقْلُ
u'تَعَيَّنَ نِكَاحٌ':Subject, #1: 1	تَعَيَّنَ النِّكَاحُ
u'تَعَيُّنٌ نَوْعٌ':Added, #1: 1	تَعَيَّنَ النِّكَاحُ
u'تَعَيُّنٌ نَوْعٌ':Added, #1: 1	تَعَيُّنَ النَّوْعِ
u'تَعَيُّنٌ نِيَّةٌ':Added, #1: 1	تَعَيُّنُ النَّوْعِ
u'تَعَيُّنٌ نِيَّةٌ':Added, #1: 1	تَعَيُّنَ النِّيَّةِ
u'تَعَيَّنَ هَالِكٌ':Subject, #1: 1	تَعَيُّنِ النِّيَّةِ
u'تَعَيَّنَ وَاجِبٌ':Subject, #3: 3	تَعَيَّنَ الْهَالِكُ
u'تَعَيَّنَ وَجَبٌ':Predicate, #1: 1	تَعَيَّنَ الْوَاجِبُ
u'تَعَيَّنَ وَجْهٌ':Subject, #1: 1	تَعَيَّنَ وَجَبَ
u'تَعَيَّنَ وُجُوبٌ':Subject, #4: 4	تَعَيَّنَ الْوَجْهُ
u'تَعَيَّنَ وُجُوبٌ':Subject, #1: 1	تَعَيَّنَ وُجُوبُ
u'تَعَيُّنٌ وَزْنٌ':Added, #1: 1	تَعَيَّنَ وُجُوبُهُ
u'تَعَيَّنَ وسط':Subject, #1: 1	تَعَيُّنُ الْوَزْنِ
u'تَعَيَّنَ وَسَطٌ':Subject, #1: 1	تَعَيَّنَ الْوَسَطُ
u'تَعَيَّنَ وَصِيٌّ':Predicate, #1: 1	تَعَيَّنَ الْوَسَطُ
u'تَعَيَّنَ وُضُوءٌ':Subject, #1: 1	تَعَيَّنَ وَصِيَّةً
u'تَعَيُّنٌ وَفَاءٌ':Added, #1: 1	تَعَيَّنَ الْوُضُوءُ
u'تَعَيُّنٌ وَقْتٌ':Added, #2: 2	تَعَيُّنَ الْوَفَاءِ
u'تَعَيُّنٌ وَقْتٌ':Added, #1: 1	تَعَيُّنَ الْوَقْتِ
u'تَعَيُّنٌ وَقْتٌ':Added, #1: 1	تَعَيُّنُ الْوَقْتِ
u'تَعَيَّنَ وُقُوعٌ':Subject, #1: 1	تَعَيُّنِ الْوَقْتِ
u'تَعَيَّنَ وُقُوفٌ':Subject, #1: 1	تَعَيَّنَ وُقُوعُ
u'تَعَيُّنٌ وِلاَدَةٌ':Added, #1: 1	تَعَيَّنَ وُقُوفُهُ
u'تَعَيَّنَ ولد':Subject, #1: 1	تَعَيُّنِ الْوِلَادَةِ
u'تَعَيَّنَ وَلَدٌ':Subject, #3: 3	تَعَيَّنَ الْوَلَدُ
u'تَعَيَّنَ يَوْمٌ':Subject, #3: 3	تَعَيَّنَ الْوَلَدُ
u'تَعْيِيبٌ بَعْضٌ':Added, #1: 1	تَعَيَّنَ يَوْمُ
u'تَعْيِيبٌ عَبْدٌ':Added, #1: 1	تَعْيِيبُ بَعْضِهِ
u'تَعْيِيبٌ غير':Added, #2: 2	تَعْيِيبُ الْعَبْدِ
u'تَعْيِيبٌ غَيْرٌ':Added, #1: 1	تَعْيِيبِ الْغَيْرِ
u'تَعْيِيبٌ غير':Added, #1: 1	تَعْيِيبِ الْغَيْرِ
u'تَعْيِيبٌ غَيْرٌ':Added, #1: 1	تَعْيِيبِ غَيْرِ
u'تَعْيِيبٌ مَالٌ':Added, #1: 1	تَعْيِيبِ غَيْرِ
u'تَعْيِيبٌ مَالٌ':Added, #1: 1	تَعْيِيبُ مَالِ
u'تَعْيِينٌ اِبْتِداءٌ':Added, #2: 2	تَعْيِيبَ مَالِ
u'تَعْيِينٌ أبطال':Added, #1: 1	تَعْيِينُ ابْتِدَاءِ
u'تَعْيِينٌ اِبْنٌ':Added, #1: 1	تَعْيِينِ الْأَبْطَالِ
u'تَعْيِينٌ أَثْمانٌ':Added, #1: 1	تَعْيِينِ ابْنِ
u'تَعْيِينٌ أُجْرَةٌ':Added, #1: 1	تَعْيِينِ الْأَثْمَانِ
u'تَعْيِينٌ أُجْرَةٌ':Added, #1: 1	تَعْيِينِ أُجْرَةِ
u'تَعْيِينٌ أحَدٌ':Added, #1: 1	تَعْيِينِ الْأُجْرَةِ
u'تَعْيِينٌ أحَدٌ':Added, #3: 3	تَعْيِينَ أَحَدِ
u'تَعْيِينٌ أحَدٌ':Added, #6: 6	تَعْيِينُ أَحَدِ
u'تَعْيِينٌ أخفُّ':Added, #9: 9	تَعْيِينِ أَحَدِ
u'تَعْيِينٌ أَدَاءٌ':Added, #1: 1	تَعْيِينَ الْأَخَفِّ
u'تَعْيِينٌ إِرَادَةٌ':Added, #2: 2	تَعْيِينُ الْأَدَاءِ
u'تَعْيِينٌ إِرَاقَةٌ':Added, #3: 3	تَعْيِينِ إرَادَةِ
u'تَعْيِينٌ أقَلُّ':Added, #1: 1	تَعْيِينُ الْإِرَاقَةِ
u'تَعْيِينٌ آلةٌ':Added, #1: 1	تَعْيِينِ الْأَقَلِّ
u'تَعْيِينٌ ألف':Added, #1: 1	تَعْيِينِ الْآلَةِ
u'تَعْيِينٌ ألْفٌ':Added, #1: 1	تَعْيِينُ الْأَلْفِ
u'تَعْيِينٌ أَلْفٌ':Added, #1: 1	تَعْيِينُ الْأَلْفِ
u'تَعْيِينٌ الْمَرْأَةُ':Added, #1: 1	تَعْيِينُ الْأَلْفِ
u'تَعْيِينٌ الْمَرْأَةُ':Added, #1: 1	تَعْيِينَ الْمَرْأَةِ
u'تَعْيِينٌ الْمَرْأَةُ':Added, #1: 1	تَعْيِينِ الْمَرْأَةِ
u'تَعْيِينٌ أُمٌّ':Added, #4: 4	تَعْيِينُ الْمَرْأَةِ
u'تَعْيِينٌ إمَامٌ':Added, #1: 1	تَعْيِينِ الْأُمِّ
u'تَعْيِينٌ إمَامٌ':Added, #1: 1	تَعْيِينَ الْإِمَامِ
u'تَعْيِينٌ إمَامٌ':Added, #2: 2	تَعْيِينُ الْإِمَامِ
u'تَعْيِينٌ أمَةٌ':Added, #2: 2	تَعْيِينِ الْإِمَامِ
u'تَعْيِينٌ إِمْساكٌ':Added, #2: 2	تَعْيِينُ الْأَمَةِ
u'تَعْيِينٌ أَنْصِبَاءُ':Added, #1: 1	تَعْيِينِ إمْسَاكِهِ
u'تَعْيِينٌ أَنْوَاعٌ':Added, #1: 1	تَعْيِينِ الْأَنْصِبَاءِ
u'تَعْيِينٌ أَوْقَاتٌ':Added, #1: 1	تَعْيِينِ أَنْوَاعِ
u'تَعْيِينٌ أَوَّلُ':Added, #3: 3	تَعْيِينِ الْأَوْقَاتِ
u'تَعْيِينٌ أَوَّلُ':Added, #1: 1	تَعْيِينِ الْأَوَّلِ
u'تَعْيِينٌ أَوَّلُ':Added, #1: 1	تَعْيِينِ أَوَّلِ
u'تَعْيِينٌ أولى':Added, #1: 1	تَعْيِينَ أَوَّلِهِ
u'تَعْيِينٌ أولى':Added, #1: 1	تَعْيِينَ الْأُولَيَيْنِ
u'تَعْيِينٌ أوْلَى':Added, #1: 1	تَعْيِينُ الْأُولَيَيْنِ
u'تَعْيِينٌ أوْلَى':Added, #1: 1	تَعْيِينَ الْأُولَيَيْنِ
u'تَعْيِينٌ أولى':Added, #1: 1	تَعْيِينُ الْأُولَيَيْنِ
u'تَعْيِينٌ أوْلَى':Added, #3: 3	تَعْيِينِ الْأُولَيَيْنِ
u'تَعْيِينٌ أيَّامٌ':Added, #3: 3	تَعْيِينِ الْأُولَيَيْنِ
u'تَعْيِينٌ أَيَّامٌ':Added, #1: 1	تَعْيِينِ الْأَيَّامِ
u'تَعْيِينٌ آيَةٌ':Added, #1: 1	تَعْيِينِ الْأَيَّامِ
u'تَعْيِينٌ بَاطِلٌ':Added, #1: 1	تَعْيِينُ الْآيَةِ
u'تَعْيِينٌ بَائِعٌ':Added, #1: 1	تَعْيِينُ الْبَاطِلِ
u'تَعْيِينٌ بَائِعٌ':Added, #1: 1	تَعْيِينَ الْبَائِعِ
u'تَعْيِينٌ بَائِنٌ':Added, #1: 1	تَعْيِينُ الْبَائِعِ
u'تَعْيِينٌ بَدَلٌ':Added, #1: 1	تَعْيِينَ الْبَائِنِ
u'تَعْيِينٌ بَدَلٌ':Added, #1: 1	تَعْيِينُ الْبَدَلِ
u'تَعْيِينٌ بَدَلٌ':Added, #1: 1	تَعْيِينُ بَدَلِ
u'تَعْيِينٌ بشراء':Added, #1: 1	تَعْيِينَ بَدَلِهِ
u'تَعْيِينٌ بَعْضٌ':Added, #1: 1	تَعْيِينٍ بِشِرَاءٍ
u'تَعْيِينٌ بَعْضٌ':Added, #1: 1	تَعْيِينِ الْبَعْضِ
u'تَعْيِينٌ بَعْضٌ':Added, #1: 1	تَعْيِينَ بَعْضِ
u'تَعْيِينٌ بَيْتٌ':Added, #2: 2	تَعْيِينِ بَعْضِ
u'تَعْيِينٌ بَيْعٌ':Added, #1: 1	تَعْيِينِ الْبَيْتِ
u'تَعْيِينٌ تُرَابٌ':Added, #1: 1	تَعْيِينِ الْبَيْعِ
u'تَعْيِينٌ تَفَاضُلٌ':Added, #1: 1	تَعْيِينِ التُّرَابِ
u'تَعْيِينٌ تَمَتُّعٌ':Added, #1: 1	تَعْيِينِ التَّفَاضُلِ
u'تَعْيِينٌ تَوَاتُرٌ':Added, #1: 1	تَعْيِينُ التَّمَتُّعِ
u'تَعْيِينٌ ثَابِتٌ':Added, #1: 1	تَعْيِينَ تَوَاتُرٍ
u'تَعْيِينٌ ثَابِتٌ':Added, #1: 1	تَعْيِينُ الثَّابِتِ
u'تَعْيِينٌ ثابتة':Added, #1: 1	تَعْيِينِ الثَّابِتَةِ
u'تَعْيِينٌ ثَلاثُ':Added, #1: 1	تَعْيِينِ الثَّابِتَةِ
u'تَعْيِينٌ ثَمَنٌ':Added, #1: 1	تَعْيِينِ الثَّلَاثِ
u'تَعْيِينٌ ثَمَنٌ':Added, #1: 1	تَعْيِينِ الثَّمَنَيْنِ
u'تَعْيِينٌ ثَمَنٌ':Added, #1: 1	تَعْيِينَ ثَمَنِ
u'تَعْيِينٌ ثَمَنٌ':Added, #2: 2	تَعْيِينُ الثَّمَنِ
u'تَعْيِينٌ ثَوْبٌ':Added, #3: 3	تَعْيِينُ ثَمَنِهِ
u'تَعْيِينٌ جَارِحٌ':Added, #2: 2	تَعْيِينِ الثَّوْبِ
u'تَعْيِينٌ جُزْءٌ':Added, #1: 1	تَعْيِينِ الْجَارِحِ
u'تَعْيِينٌ جِنْسٌ':Added, #1: 1	تَعْيِينِ جُزْءٍ
u'تَعْيِينٌ جِنْسٌ':Added, #1: 1	تَعْيِينُ الْجِنْسِ
u'تَعْيِينٌ جهاد':Added, #3: 3	تَعْيِينِ الْجِنْسِ
u'تَعْيِينٌ جِهَادٌ':Added, #1: 1	تَعْيِينِ الْجِهَادِ
u'تَعْيِينٌ جِهَةٌ':Added, #1: 1	تَعْيِينِ الْجِهَادِ
u'تَعْيِينٌ جِهَةٌ':Added, #1: 1	تَعْيِينُ الْجِهَةِ
u'تَعْيِينٌ جِهَةٌ':Added, #1: 1	تَعْيِينَ جِهَةِ
u'تَعْيِينٌ جِهَةٌ':Added, #2: 2	تَعْيِينِ جِهَةِ
u'تَعْيِينٌ حافِظٌ':Added, #4: 4	تَعْيِينِ الْجِهَةِ
u'تَعْيِينٌ حَجٌّ':Added, #1: 1	تَعْيِينُ حَافِظِ
u'تَعْيِينٌ حَدَثٌ':Added, #1: 1	تَعْيِينِ الْحَجِّ
u'تَعْيِينٌ حَدَثٌ':Added, #1: 1	تَعْيِينَ الْحَدَثِ
u'تَعْيِينٌ حَرْفٌ':Added, #1: 1	تَعْيِينُ الْحَدَثِ
u'تَعْيِينٌ حَظٌّ':Added, #1: 1	تَعْيِينُ الْحَرْفِ
u'تَعْيِينٌ حُكْمٌ':Added, #1: 1	تَعْيِينِ حَظِّهِ
u'تَعْيِينٌ حِنْثٌ':Added, #1: 1	تَعْيِينُ الْحُكْمِ
u'تَعْيِينٌ حِنْطَةٌ':Added, #2: 2	تَعْيِينِ الْحِنْثِ
u'تَعْيِينٌ حَيٌّ':Added, #1: 1	تَعْيِينِ الْحِنْطَةِ
u'تَعْيِينٌ حَيٌّ':Added, #1: 1	تَعْيِينَ الْحَيَّةِ
u'تَعْيِينٌ حَيَّةٌ':Added, #1: 1	تَعْيِينُ الْحَيَّةِ
u'تَعْيِينٌ حَيَّةٌ':Added, #1: 1	تَعْيِينَ الْحَيَّةِ
u'تَعْيِينٌ حَيَوَانٌ':Added, #1: 1	تَعْيِينُ الْحَيَّةِ
u'تَعْيِينٌ خَادِمٌ':Added, #1: 1	تَعْيِينِ الْحَيَوَانِ
u'تَعْيِينٌ خَارِجٌ':Added, #1: 1	تَعْيِينَ الْخَادِمِ
u'تَعْيِينٌ خُبْزٌ':Added, #1: 1	تَعْيِينِ الْخَارِجَةِ
u'تَعْيِينٌ خدمة':Added, #1: 1	تَعْيِينِ الْخُبْزِ
u'تَعْيِينٌ خِدْمَةٌ':Added, #1: 1	تَعْيِينِ الْخِدْمَةِ
u'تَعْيِينٌ خَصْلَةٌ':Added, #1: 1	تَعْيِينِ الْخِدْمَةِ
u'تَعْيِينٌ خَصْلَةٌ':Added, #1: 1	تَعْيِينُ خَصْلَةٍ
u'تَعْيِينٌ خِلاَفٌ':Added, #1: 1	تَعْيِينِ خَصْلَةٍ
u'تَعْيِينٌ دَرَاهِمُ':Added, #1: 1	تَعْيِينُ خِلَافِ
u'تَعْيِينٌ دفع':Added, #1: 1	تَعْيِينِ الدَّرَاهِمِ
u'تَعْيِينٌ دَفْعٌ':Added, #1: 1	تَعْيِينُ الدَّفْعِ
u'تَعْيِينٌ دَنانيرُ':Added, #1: 1	تَعْيِينُ الدَّفْعِ
u'تَعْيِينٌ دَيْنٌ':Added, #1: 1	تَعْيِينُ الدَّنَانِيرِ
u'تَعْيِينٌ ذَبيحٌ':Added, #1: 1	تَعْيِينِ الدَّيْنِ
u'تَعْيِينٌ ذِراعٌ':Added, #1: 1	تَعْيِينِ الذَّبِيحِ
u'تَعْيِينٌ ذَنْبٌ':Added, #1: 1	تَعْيِينِ الذِّرَاعِ
u'تَعْيِينٌ رَأْسٌ':Added, #1: 1	تَعْيِينُ الذَّنْبِ
u'تَعْيِينٌ راغِب':Added, #4: 4	تَعْيِينُ رَأْسِ
u'تَعْيِينٌ رَاكِبٌ':Added, #1: 1	تَعْيِينِ الرَّاغِبِ
u'تَعْيِينٌ رَاكِبٌ':Added, #1: 1	تَعْيِينِ الرَّاكِبِ
u'تَعْيِينٌ رَجْمٌ':Added, #1: 1	تَعْيِينِ الرَّاكِبَيْنِ
u'تَعْيِينٌ رَضيعٌ':Added, #1: 1	تَعْيِينُ الرَّجْمِ
u'تَعْيِينٌ رِقٌّ':Added, #1: 1	تَعْيِينُ الرَّضِيعِ
u'تَعْيِينٌ رَقيقٌ':Added, #1: 1	تَعْيِينِ الرِّقِّ
u'تَعْيِينٌ رَقيق':Added, #1: 1	تَعْيِينُ رَقِيقِهِ
u'تَعْيِينٌ رُمَاةٌ':Added, #1: 1	تَعْيِينُ رَقِيقِهِ
u'تَعْيِينٌ رَهْنٌ':Added, #1: 1	تَعْيِينُ الرُّمَاةِ
u'تَعْيِينٌ رَواتِبُ':Added, #3: 3	تَعْيِينِ الرَّهْنِ
u'تَعْيِينٌ رَوَاتِبُ':Added, #1: 1	تَعْيِينُ الرَّوَاتِبِ
u'تَعْيِينٌ زِقٌّ':Added, #1: 1	تَعْيِينُ الرَّوَاتِبِ
u'تَعْيِينٌ زَمانٌ':Added, #3: 3	تَعْيِينِ الزِّقِّ
u'تَعْيِينٌ زَمانٌ':Added, #1: 1	تَعْيِينَ الزَّمَانِ
u'تَعْيِينٌ زَمانٌ':Added, #1: 1	تَعْيِينَ زَمَانِ
u'تَعْيِينٌ زَمَنٌ':Added, #2: 2	تَعْيِينِ الزَّمَانِ
u'تَعْيِينٌ زَمَنٌ':Added, #1: 1	تَعْيِينُ الزَّمَنِ
u'تَعْيِينٌ زَمَنٌ':Added, #1: 1	تَعْيِينِ زَمَنٍ
u'تَعْيِينٌ زَوْجٌ':Added, #1: 1	تَعْيِينِ زَمَنِ
u'تَعْيِينٌ زَوْجٌ':Added, #1: 1	تَعْيِينَ الزَّوْجِ
u'تَعْيِينٌ زَوْجٌ':Added, #1: 1	تَعْيِينُ الزَّوْجِ
u'تَعْيِينٌ زَوْجٌ':Added, #1: 1	تَعْيِينِ زَوْجٍ
u'تَعْيِينٌ زَوْجٌ':Added, #2: 2	تَعْيِينِ الزَّوْجِ
u'تَعْيِينٌ زَوْجَةٌ':Added, #2: 2	تَعْيِينُ الزَّوْجَيْنِ
u'تَعْيِينٌ سَبَبٌ':Added, #1: 1	تَعْيِينُ الزَّوْجَةِ
u'تَعْيِينٌ سَبَبٌ':Added, #1: 1	تَعْيِينُ السَّبَبِ
u'تَعْيِينٌ سَبَبٌ':Added, #1: 1	تَعْيِينَ سَبَبِ
u'تَعْيِينٌ سَبَبٌ':Added, #1: 1	تَعْيِينِ سَبَبٍ
u'تَعْيِينٌ سَنَةٌ':Added, #2: 2	تَعْيِينِ السَّبَبِ
u'تَعْيِينٌ سَنَةٌ':Added, #1: 1	تَعْيِينِ السَّنَةِ
u'تَعْيِينٌ سَهْمٌ':Added, #1: 1	تَعْيِينُ سَنَةِ
u'تَعْيِينٌ سورٌ':Added, #1: 1	تَعْيِينُ السَّهْمِ
u'تَعْيِينٌ سُورَةٌ':Added, #1: 1	تَعْيِينِ السُّوَرِ
u'تَعْيِينٌ شَاةٌ':Added, #1: 1	تَعْيِينِ سُورَةٍ
u'تَعْيِينٌ شَاةٌ':Added, #1: 1	تَعْيِينُ الشَّاةِ
u'تَعْيِينٌ شَاةٌ':Added, #1: 1	تَعْيِينِ الشَّاةِ
u'تَعْيِينٌ شَارِعٌ':Added, #3: 3	تَعْيِينَ الشَّاةِ
u'تَعْيِينٌ شَخْصٌ':Added, #1: 1	تَعْيِينُ الشَّارِعِ
u'تَعْيِينٌ شَخْصٌ':Added, #1: 1	تَعْيِينِ الشَّخْصِ
u'تَعْيِينٌ شَخْصٌ':Added, #1: 1	تَعْيِينَ شَخْصٍ
u'تَعْيِينٌ شَرْعٌ':Added, #1: 1	تَعْيِينِ شَخْصٍ
u'تَعْيِينٌ شَفْعٌ':Added, #3: 3	تَعْيِينِ الشَّرْعِ
u'تَعْيِينٌ شُهُودٌ':Added, #1: 1	تَعْيِينَ الشَّفْعِ
u'تَعْيِينٌ شَيْءٌ':Added, #1: 1	تَعْيِينُ الشُّهُودِ
u'تَعْيِينٌ شَيْءٌ':Added, #2: 2	تَعْيِينَ شَيْءٍ
u'تَعْيِينٌ شَيْءٌ':Added, #2: 2	تَعْيِينُ شَيْءٍ
u'تَعْيِينٌ صَاحِبٌ':Added, #4: 4	تَعْيِينِ شَيْءٍ
u'تَعْيِينٌ صَبِيٌّ':Added, #1: 1	تَعْيِينِ صَاحِبِ
u'تَعْيِينٌ صَلاَةٌ':Added, #2: 2	تَعْيِينُ الصَّبِيِّ
u'تَعْيِينٌ صَوْمٌ':Added, #1: 1	تَعْيِينِ الصَّلَاةِ
u'تَعْيِينٌ صَوْمٌ':Added, #1: 1	تَعْيِينَ الصَّوْمِ
u'تَعْيِينٌ صَوْمٌ':Added, #1: 1	تَعْيِينِ الصَّوْمِ
u'تَعْيِينٌ صَيْدٌ':Added, #1: 1	تَعْيِينِ صَوْمِ
u'تَعْيِينٌ صَيْدٌ':Added, #1: 1	تَعْيِينُ الصَّيْدِ
u'تَعْيِينٌ ضَمَانٌ':Added, #2: 2	تَعْيِينَ الصَّيْدِ
u'تَعْيِينٌ طَرِيقٌ':Added, #1: 1	تَعْيِين ضَمَانِ
u'تَعْيِينٌ طَرِيقٌ':Added, #1: 1	تَعْيِينِ الطَّرِيقِ
u'تَعْيِينٌ طَرِيقٌ':Added, #1: 1	تَعْيِينَ طَرِيقِهِ
u'تَعْيِينٌ طَرِيقٌ':Added, #2: 2	تَعْيِينَ الطَّرِيقِ
u'تَعْيِينٌ طَرِيقٌ':Added, #2: 2	تَعْيِينِ طَرِيقٍ
u'تَعْيِينٌ طَلاَقٌ':Added, #2: 2	تَعْيِينُ طَرِيقِهِ
u'تَعْيِينٌ طَلاَقٌ':Added, #1: 1	تَعْيِينَ الطَّلَاقِ
u'تَعْيِينٌ طَلاَقٌ':Added, #1: 1	تَعْيِينُ الطَّلَاقِ
u'تَعْيِينٌ ظُهْرٌ':Added, #2: 2	تَعْيِينِ الطَّلَاقِ
u'تَعْيِينٌ ظُهْرٌ':Added, #2: 2	تَعْيِينُ الظُّهْرِ
u'تَعْيِينٌ عَامِلٌ':Added, #2: 2	تَعْيِينِ الظُّهْرِ
u'تَعْيِينٌ عَامِلٌ':Added, #1: 1	تَعْيِينَ الْعَامِلِ
u'تَعْيِينٌ عَامِلٌ':Added, #1: 1	تَعْيِينُ الْعَامِلِ
u'تَعْيِينٌ عَبْدٌ':Added, #1: 1	تَعْيِينِ الْعَامِلِ
u'تَعْيِينٌ عَبْدٌ':Added, #1: 1	تَعْيِينُ الْعَبْدِ
u'تَعْيِينٌ عتق':Added, #1: 1	تَعْيِينِ الْعَبْدِ
u'تَعْيِينٌ عتق':Added, #1: 1	تَعْيِينُ الْعِتْقِ
u'تَعْيِينٌ عِتْقٌ':Added, #1: 1	تَعْيِينِ الْعِتْقِ
u'تَعْيِينٌ عِتْقٌ':Added, #1: 1	تَعْيِينُ الْعِتْقِ
u'تَعْيِينٌ عتق':Added, #1: 1	تَعْيِينِ الْعِتْقِ
u'تَعْيِينٌ عِتْقٌ':Added, #1: 1	تَعْيِينُ عِتْقِ
u'تَعْيِينٌ عَدَدٌ':Added, #1: 1	تَعْيِينُ عِتْقِ
u'تَعْيِينٌ عَدَدٌ':Added, #2: 2	تَعْيِينُ عَدَدِ
u'تَعْيِينٌ عَشْرٌ':Added, #4: 4	تَعْيِينِ عَدَدٍ
u'تَعْيِينٌ عَقَارٌ':Added, #2: 2	تَعْيِينِ الْعَشْرِ
u'تَعْيِينٌ عَقْدٌ':Added, #1: 1	تَعْيِينِ الْعَقَارِ
u'تَعْيِينٌ عِلَّةٌ':Added, #1: 1	تَعْيِينِ الْعَقْدِ
u'تَعْيِينٌ عِلَّةٌ':Added, #1: 1	تَعْيِينِ عِلَّةٍ
u'تَعْيِينٌ عِلَّةٌ':Added, #2: 2	تَعْيِينِ الْعِلَّةِ
u'تَعْيِينٌ عُلُومٌ':Added, #3: 3	تَعْيِينُ الْعِلَّةِ
u'تَعْيِينٌ عَمَلٌ':Added, #1: 1	تَعْيِينِ الْعُلُومِ
u'تَعْيِينٌ عَهْدٌ':Added, #2: 2	تَعْيِينُ الْعَمَلِ
u'تَعْيِينٌ عَوان':Added, #3: 3	تَعْيِينِ الْعَهْدِ
u'تَعْيِينٌ عِوَضٌ':Added, #1: 1	تَعْيِينِ الْعَوَانِ
u'تَعْيِينٌ عِوَضٌ':Added, #1: 1	تَعْيِينِ الْعِوَضِ
u'تَعْيِينٌ عين':Added, #1: 1	تَعْيِينُ عِوَضِ
u'تَعْيِينٌ عَيْنٌ':Added, #1: 1	تَعْيِينُ الْعَيْنِ
u'تَعْيِينٌ عَيْن':Added, #1: 1	تَعْيِينُ الْعَيْنِ
u'تَعْيِينٌ غَائِبٌ':Added, #1: 1	تَعْيِينُ الْعَيْنِ
u'تَعْيِينٌ غَدٌ':Added, #1: 1	تَعْيِينِ الْغَائِبِ
u'تَعْيِينٌ غُلاَمٌ':Added, #1: 1	تَعْيِينُ الْغَدِ
u'تَعْيِينٌ غَنَمٌ':Added, #1: 1	تَعْيِينُ الْغُلَامِ
u'تَعْيِينٌ غِيبَةٌ':Added, #1: 1	تَعْيِينِ الْغَنَمِ
u'تَعْيِينٌ غير':Added, #1: 1	تَعْيِينُ الْغِيبَةِ
u'تَعْيِينٌ غَيْرٌ':Added, #1: 1	تَعْيِينُ غَيْرِ
u'تَعْيِينٌ فَاتِحٌ':Added, #1: 1	تَعْيِينُ غَيْرِ
u'تَعْيِينٌ فَاتِحٌ':Added, #1: 1	تَعْيِينُ الْفَاتِحَةِ
u'تَعْيِينٌ فَاتِحَةٌ':Added, #3: 3	تَعْيِينِ الْفَاتِحَةِ
u'تَعْيِينٌ فَاتِحَةٌ':Added, #1: 1	تَعْيِينُ الْفَاتِحَةِ
u'تَعْيِينٌ فَائِدَةٌ':Added, #3: 3	تَعْيِينِ الْفَاتِحَةِ
u'تَعْيِينٌ فرد':Added, #1: 1	تَعْيِينِ فَائِدَةٍ
u'تَعْيِينٌ فَرْدٌ':Added, #1: 1	تَعْيِينُ الْفَرْدِ
u'تَعْيِينٌ فَرْضٌ':Added, #1: 1	تَعْيِينُ الْفَرْدِ
u'تَعْيِينٌ فَرْضٌ':Added, #1: 1	تَعْيِينُ الْفَرْضِ
u'تَعْيِينٌ فرق':Added, #1: 1	تَعْيِينِ الْفَرْضِ
u'تَعْيِينٌ فِرَقٌ':Added, #1: 1	تَعْيِينُ الْفِرَقِ
u'تَعْيِينٌ فِرْقَةٌ':Added, #1: 1	تَعْيِينُ الْفِرَقِ
u'تَعْيِينٌ فِرْقَةٌ':Added, #1: 1	تَعْيِينِ الْفِرْقَةِ
u'تَعْيِينٌ فلان':Added, #3: 3	تَعْيِينَ الْفِرْقَةِ
u'تَعْيِينٌ قَارِئٌ':Added, #1: 1	تَعْيِينِ الرَّاغِبِ
u'تَعْيِينٌ قَدْرٌ':Added, #1: 1	تَعْيِينِ الْقَارِئِ
u'تَعْيِينٌ قَدْرٌ':Added, #1: 1	تَعْيِينُ الْقَدْرِ
u'تَعْيِينٌ قَدْرٌ':Added, #1: 1	تَعْيِينُ قَدْرٍ
u'تَعْيِينٌ قُرْء':Added, #1: 1	تَعْيِينِ قَدْرِ
u'تَعْيِينٌ قِرَاءةٌ':Added, #1: 1	تَعْيِينِ الْقُرْءِ
u'تَعْيِينٌ قِرَاءةٌ':Added, #1: 1	تَعْيِينُ قِرَاءَةِ
u'تَعْيِينٌ قِرَاءةٌ':Added, #2: 2	تَعْيِينِ قِرَاءَةِ
u'تَعْيِينٌ قِرَاءةٌ':Added, #3: 3	تَعْيِينَ الْقِرَاءَةِ
u'تَعْيِينٌ قِرَاءةٌ':Added, #4: 4	تَعْيِينُ الْقِرَاءَةِ
u'تَعْيِينٌ قُرْبَةٌ':Added, #4: 4	تَعْيِينِ الْقِرَاءَةِ
u'تَعْيِينٌ قُرْعَةٌ':Added, #1: 1	تَعْيِينِ الْقُرْبَةِ
u'تَعْيِينٌ قَوْسٌ':Added, #1: 1	تَعْيِينَ الْقُرْعَةِ
u'تَعْيِينٌ قَوْسٌ':Added, #1: 1	تَعْيِينُ الْقَوْسِ
u'تَعْيِينٌ قَوْسٌ':Added, #1: 1	تَعْيِينِ الْقَوْسِ
u'تَعْيِينٌ قَوْلٌ':Added, #1: 1	تَعْيِينَ قَوْسَيْنِ
u'تَعْيِينٌ قِيمَةٌ':Added, #1: 1	تَعْيِينُ قَوْلٍ
u'تَعْيِينٌ كَبِيرٌ':Added, #1: 1	تَعْيِينِ قِيمَةٍ
u'تَعْيِينٌ كَرَاهَةٌ':Added, #1: 1	تَعْيِينُ الْكَبِيرِ
u'تَعْيِينٌ كَفَّارٌ':Added, #1: 1	تَعْيِينُ الْكَرَاهَةِ
u'تَعْيِينٌ كَفَّارَةٌ':Added, #3: 3	تَعْيِينُ كَفَّارَةِ
u'تَعْيِينٌ كَفَنٌ':Added, #3: 3	تَعْيِينُ كَفَّارَةِ
u'تَعْيِينٌ كَوْنٌ':Added, #1: 1	تَعْيِينِ الْكَفَنِ
u'تَعْيِينٌ كَوْنٌ':Added, #1: 1	تَعْيِينِ كَوْنِ
u'تَعْيِينٌ لُزُومٌ':Added, #1: 1	تَعْيِينُ كَوْنِهِ
u'تَعْيِينٌ لَفْظٌ':Added, #1: 1	تَعْيِينِ لُزُومِ
u'تَعْيِينٌ لَفْظٌ':Added, #1: 1	تَعْيِينَ لَفْظِ
u'تَعْيِينٌ مَاءٌ':Added, #4: 4	تَعْيِينُ اللَّفْظِ
u'تَعْيِينٌ مَالٌ':Added, #2: 2	تَعْيِينِ الْمَاءِ
u'تَعْيِينٌ مَالٌ':Added, #2: 2	تَعْيِينِ الْمَالِ
u'تَعْيِينٌ مَالِكٌ':Added, #5: 5	تَعْيِينُ الْمَالِ
u'تَعْيِينٌ مَالِكٌ':Added, #1: 1	تَعْيِينُ الْمَالِكِ
u'تَعْيِينٌ مَانِعٌ':Added, #1: 1	تَعْيِينِ مَالِكِهِ
u'تَعْيِينٌ مُبَاحٌ':Added, #1: 1	تَعْيِينُ الْمَانِعِ
u'تَعْيِينٌ مَبْدَأٌ':Added, #1: 1	تَعْيِينِ مُبَاحٍ
u'تَعْيِينٌ مُبْهَمٌ':Added, #1: 1	تَعْيِينِ الْمَبْدَأِ
u'تَعْيِينٌ مَبِيعٌ':Added, #1: 1	تَعْيِينَ الْمُبْهَمِ
u'تَعْيِينٌ مُتَصَرِّفٌ':Added, #6: 6	تَعْيِينِ الْمَبِيعِ
u'تَعْيِينٌ مَجْرُوحٌ':Added, #1: 1	تَعْيِين الْمُتَصَرِّفِ
u'تَعْيِينٌ مَجْهُولٌ':Added, #1: 1	تَعْيِينِ الْمَجْرُوحِ
u'تَعْيِينٌ مَحْذُوفٌ':Added, #1: 1	تَعْيِينِ الْمَجْهُولِ
u'تَعْيِينٌ مَحْرَمٌ':Added, #1: 1	تَعْيِينِ الْمَحْذُوفِ
u'تَعْيِينٌ مَحْكُومٌ':Added, #1: 1	تَعْيِينَ الْمَحْرَمِ
u'تَعْيِينٌ مَحَلٌّ':Added, #1: 1	تَعْيِينِ الْمَحْكُومِ
u'تَعْيِينٌ مَحَلٌّ':Added, #1: 1	تَعْيِينَ الْمَحَلِّ
u'تَعْيِينٌ مَحَلٌّ':Added, #1: 1	تَعْيِينِ الْمَحَلِّ
u'تَعْيِينٌ مَحَلٌّ':Added, #1: 1	تَعْيِينُ مَحَلِّ
u'تَعْيِينٌ مَحَلٌّ':Added, #2: 2	تَعْيِينُ الْمَحَلِّ
u'تَعْيِينٌ مَحَلَّةٌ':Added, #2: 2	تَعْيِينِ مَحَلِّهِ
u'تَعْيِينٌ مُدَّةٌ':Added, #1: 1	تَعْيِينِ الْمَحَلَّةِ
u'تَعْيِينٌ مُدَّةٌ':Added, #1: 1	تَعْيِينُ الْمُدَّةِ
u'تَعْيِينٌ مُدَّةٌ':Added, #1: 1	تَعْيِينُ مُدَّةٍ
u'تَعْيِينٌ مُدَّةٌ':Added, #2: 2	تَعْيِينِ مُدَّةِ
u'تَعْيِينٌ مَدْفُوعٌ':Added, #4: 4	تَعْيِينِ الْمُدَّةِ
u'تَعْيِينٌ مَدْلُولٌ':Added, #1: 1	تَعْيِينُ الْمَدْفُوعِ
u'تَعْيِينٌ مراد':Added, #1: 1	تَعْيِينِ الْمَدْلُولِ
u'تَعْيِينٌ مراد':Added, #1: 1	تَعْيِينُ الْمُرَادِ
u'تَعْيِينٌ مُرَادٌ':Added, #1: 1	تَعْيِينِ الْمُرَادِ
u'تَعْيِينٌ مُرَادٌ':Added, #1: 1	تَعْيِينُ الْمُرَادِ
u'تَعْيِينٌ مَرْكُوبٌ':Added, #1: 1	تَعْيِينِ الْمُرَادِ
u'تَعْيِينٌ مَرْكُوبٌ':Added, #1: 1	تَعْيِينُ الْمَرْكُوبِ
u'تَعْيِينٌ مَسَاجِدُ':Added, #2: 2	تَعْيِينُ الْمَرْكُوبَيْنِ
u'تَعْيِينٌ مساكين':Added, #1: 1	تَعْيِينِ الْمَسَاجِدِ
u'تَعْيِينٌ مساكين':Added, #1: 1	تَعْيِينُ مَسَاكِينِ
u'تَعْيِينٌ مُسْتَحَقٌّ':Added, #1: 1	تَعْيِينِ مَسَاكِينِهِ
u'تَعْيِينٌ مُسْتَحَقٌّ':Added, #1: 1	تَعْيِينَ الْمُسْتَحَقِّ
u'تَعْيِينٌ مُسْتَحَقٌّ':Added, #1: 1	تَعْيِينِ الْمُسْتَحَقِّ
u'تَعْيِينٌ مُسْتَحِقٌّ':Added, #1: 1	تَعْيِينِ مُسْتَحَقٍّ
u'تَعْيِينٌ مُسْتَحِقٌّ':Added, #1: 1	تَعْيِينِ مُسْتَحِقٍّ
u'تَعْيِينٌ مُسْتَحَقٌّ':Added, #1: 1	تَعْيِينِ مُسْتَحِقِّ
u'تَعْيِينٌ مُسْتَحِقٌّ':Added, #2: 2	تَعْيِينُ الْمُسْتَحَقِّ
u'تَعْيِينٌ مُسْتَحِقٌّ':Added, #2: 2	تَعْيِينَ الْمُسْتَحِقِّ
u'تَعْيِينٌ مُسْتَحِقٌّ':Added, #2: 2	تَعْيِينِ مُسْتَحِقِّهِ
u'تَعْيِينٌ مُسْتَعِيرٌ':Added, #3: 3	تَعْيِينُ الْمُسْتَحِقِّ
u'تَعْيِينٌ مَسْجِدٌ':Added, #1: 1	تَعْيِينِ الْمُسْتَعِيرِ
u'تَعْيِينٌ مُشار':Added, #3: 3	تَعْيِينِ الْمَسْجِدِ
u'تَعْيِينٌ مَصَارِفُ':Added, #1: 1	تَعْيِينَ الْمُشَارِ
u'تَعْيِينٌ مَصَارِفُ':Added, #1: 1	تَعْيِينِ الْمَصَارِفِ
u'تَعْيِينٌ مَصْرِفٌ':Added, #2: 2	تَعْيِينُ مَصَارِفِهِ
u'تَعْيِينٌ مَصْرِفٌ':Added, #1: 1	تَعْيِينَ الْمَصْرِفِ
u'تَعْيِينٌ مَصْرِفٌ':Added, #2: 2	تَعْيِينِ مَصْرِفِهِ
u'تَعْيِينٌ مَصْرُوفٌ':Added, #4: 4	تَعْيِينُ مَصْرِفِهِ
u'تَعْيِينٌ مَصْرُوف':Added, #1: 1	تَعْيِينَ الْمَصْرُوفِ
u'تَعْيِينٌ مَصْلَحَةٌ':Added, #1: 1	تَعْيِينَ الْمَصْرُوفِ
u'تَعْيِينٌ مُطَلَّقٌ':Added, #1: 1	تَعْيِينِ مَصْلَحَتِهِ
u'تَعْيِينٌ مُعَارٌ':Added, #1: 1	تَعْيِينِ الْمُطَلَّقَاتِ
u'تَعْيِينٌ مَعْدُودٌ':Added, #1: 1	تَعْيِينُ الْمُعَارِ
u'تَعْيِينٌ مَعْمُولٌ':Added, #1: 1	تَعْيِينِ مَعْدُودٍ
u'تَعْيِينٌ مُعَيَّنٌ':Added, #1: 1	تَعْيِينِ الْمَعْمُولِ
u'تَعْيِينٌ مُفْلِسٌ':Added, #1: 1	تَعْيِينُ الْمُعَيَّنِ
u'تَعْيِينٌ مَقْبُوضٌ':Added, #2: 2	تَعْيِينُ الْمُفْلِسِ
u'تَعْيِينٌ مِقْدَارٌ':Added, #1: 1	تَعْيِينِ الْمَقْبُوضِ
u'تَعْيِينٌ مِقْدَارٌ':Added, #1: 1	تَعْيِينُ مِقْدَارِ
u'تَعْيِينٌ مَقْصُودٌ':Added, #6: 6	تَعْيِينِ الْمِقْدَارِ
u'تَعْيِينٌ مَكَانٌ':Added, #1: 1	تَعْيِينِ مَقْصُودِهِ
u'تَعْيِينٌ مَكَانٌ':Added, #1: 1	تَعْيِينَ مَكَانِ
u'تَعْيِينٌ مَكَانٌ':Added, #2: 2	تَعْيِينَ الْمَكَانِ
u'تَعْيِينٌ مَكَانٌ':Added, #2: 2	تَعْيِينُ مَكَانِ
u'تَعْيِينٌ مَكَانٌ':Added, #2: 2	تَعْيِينِ مَكَانِ
u'تَعْيِينٌ مَكَانٌ':Added, #3: 3	تَعْيِينُ الْمَكَانِ
u'تَعْيِينٌ مُكْرَهٌ':Added, #4: 4	تَعْيِينِ الْمَكَانِ
u'تَعْيِينٌ مُكَلَّفٌ':Added, #2: 2	تَعْيِينِ الْمُكْرَهِ
u'تَعْيِينٌ مِكْيَالٌ':Added, #1: 1	تَعْيِينُ الْمُكَلَّفِ
u'تَعْيِينٌ مِكْيَالٌ':Added, #1: 1	تَعْيِينَ الْمِكْيَالِ
u'تَعْيِينٌ مِلْكٌ':Added, #1: 1	تَعْيِينِ الْمِكْيَالِ
u'تَعْيِينٌ مِلْكٌ':Added, #1: 1	تَعْيِينِ مِلْكِهِ
u'تَعْيِينٌ مَمْلُوكٌ':Added, #2: 2	تَعْيِينِ الْمِلْكِ
u'تَعْيِينٌ مَنْذُور':Added, #1: 1	تَعْيِينِ الْمَمْلُوكِ
u'تَعْيِينٌ مَهْرٌ':Added, #3: 3	تَعْيِينُ الْمَنْذُورِ
u'تَعْيِينٌ مَوَاقِعُ':Added, #1: 1	تَعْيِينِ الْمَهْرِ
u'تَعْيِينٌ مُوجِبٌ':Added, #1: 1	تَعْيِينُ الْمَوَاقِعِ
u'تَعْيِينٌ مَوْصُوفٌ':Added, #1: 1	تَعْيِينِ مُوجِبِهِ
u'تَعْيِينٌ مَوْضِعٌ':Added, #1: 1	تَعْيِينُ الْمَوْصُوفِ
u'تَعْيِينٌ مَوْضِعٌ':Added, #1: 1	تَعْيِينَ مَوْضِعِ
u'تَعْيِينٌ مَوْضِعٌ':Added, #1: 1	تَعْيِينُ مَوْضِعِهِ
u'تَعْيِينٌ مَوْضِعٌ':Added, #2: 2	تَعْيِينِ مَوْضِعٍ
u'تَعْيِينٌ مَوْقِفٌ':Added, #3: 3	تَعْيِينُ الْمَوْضِعِ
u'تَعْيِينٌ مَوْقِفٌ':Added, #1: 1	تَعْيِينُ الْمَوْقِفِ
u'تَعْيِينٌ مَوْقُوفٌ':Added, #1: 1	تَعْيِينِ مَوْقِفِهِ
u'تَعْيِينٌ مَوْقُوفٌ':Added, #2: 2	تَعْيِينُ الْمَوْقُوفِ
u'تَعْيِينٌ مُوَكِّلٌ':Added, #2: 2	تَعْيِينِ الْمَوْقُوفِ
u'تَعْيِينٌ مِيقَاتٌ':Added, #1: 1	تَعْيِينِ مُوَكِّلٍ
u'تَعْيِينٌ نَاسِخٌ':Added, #1: 1	تَعْيِينُ الْمِيقَاتِ
u'تَعْيِينٌ نَاسِخٌ':Added, #1: 1	تَعْيِينُ النَّاسِخِ
u'تَعْيِينٌ نَاسِخ':Added, #1: 1	تَعْيِينِ النَّاسِخِ
u'تَعْيِينٌ نَاسِخ':Added, #1: 1	تَعْيِينُ النَّاسِخِ
u'تَعْيِينٌ نَاقِصٌ':Added, #1: 1	تَعْيِينِ النَّاسِخِ
u'تَعْيِينٌ نَبِيٌّ':Added, #1: 1	تَعْيِينِ النَّاقِصِ
u'تَعْيِينٌ نُسُكٌ':Added, #1: 1	تَعْيِينِ النَّبِيِّ
u'تَعْيِينٌ نَقْدٌ':Added, #3: 3	تَعْيِينُ النُّسُكِ
u'تَعْيِينٌ نَقْد':Added, #1: 1	تَعْيِينُ النَّقْدِ
u'تَعْيِينٌ نَقْدٌ':Added, #1: 1	تَعْيِينُ النَّقْدِ
u'تَعْيِينٌ نَقْد':Added, #2: 2	تَعْيِينِ النَّقْدِ
u'تَعْيِينٌ نُقُودٌ':Added, #2: 2	تَعْيِينِ النَّقْدِ
u'تَعْيِينٌ نهار':Added, #5: 5	تَعْيِينِ النُّقُودِ
u'تَعْيِينٌ نَهَارٌ':Added, #1: 1	تَعْيِينُ النَّهَارِ
u'تَعْيِينٌ نَوْعٌ':Added, #1: 1	تَعْيِينُ النَّهَارِ
u'تَعْيِينٌ نَوْعٌ':Added, #1: 1	تَعْيِينِ النَّوْعِ
u'تَعْيِينٌ نَوْعٌ':Added, #1: 1	تَعْيِينُ نَوْعٍ
u'تَعْيِينٌ نَوْعٌ':Added, #2: 2	تَعْيِينِ نَوْعٍ
u'تَعْيِينٌ نِيَّةٌ':Added, #4: 4	تَعْيِينُ نَوْعِ
u'تَعْيِينٌ نِيَّةٌ':Added, #10: 10	تَعْيِينِ النِّيَّةِ
u'تَعْيِينٌ نِيَّةٌ':Added, #13: 13	تَعْيِينُ النِّيَّةِ
u'تَعْيِينٌ نِيَّةٌ':Added, #1: 1	تَعْيِينُ نِيَّةِ
u'تَعْيِينٌ نِيَّةٌ':Added, #1: 1	تَعْيِينِ نِيَّةِ
u'تَعْيِينٌ نِيَّةٌ':Added, #1: 1	تَعْيِين نِيَّتِهِ
u'تَعْيِينٌ وَاجِبٌ':Added, #4: 4	تَعْيِينَ النِّيَّةِ
u'تَعْيِينٌ وَاجِبٌ':Added, #1: 1	تَعْيِينَ الْوَاجِبِ
u'تَعْيِينٌ وَاجِبٌ':Added, #1: 1	تَعْيِينُ الْوَاجِبِ
u'تَعْيِينٌ واحد':Added, #1: 1	تَعْيِينِ الْوَاجِبِ
u'تَعْيِينٌ وَاحِدٌ':Added, #1: 1	تَعْيِينُ وَاحِدٍ
u'تَعْيِينٌ وَارِثٌ':Added, #1: 1	تَعْيِينُ وَاحِدٍ
u'تَعْيِينٌ وَاقِعٌ':Added, #2: 2	تَعْيِينِ الْوَارِثِ
u'تَعْيِينٌ وَاقِعٌ':Added, #1: 1	تَعْيِينَ الْوَاقِعِ
u'تَعْيِينٌ وَاقِفٌ':Added, #4: 4	تَعْيِينِ الْوَاقِعِ
u'تَعْيِينٌ وَاقِفٌ':Added, #1: 1	تَعْيِينُ الْوَاقِفِ
u'تَعْيِينٌ وَتْرٌ':Added, #1: 1	تَعْيِينِ الْوَاقِفِ
u'تَعْيِينٌ وُجُوبٌ':Added, #1: 1	تَعْيِينُ الْوَتْرِ
u'تَعْيِينٌ وُجُوبٌ':Added, #1: 1	تَعْيِينِ الْوُجُوبِ
u'تَعْيِينٌ وُجُوبٌ':Added, #1: 1	تَعْيِينِ وُجُوبٍ
u'تَعْيِينٌ وُجُوبٌ':Added, #1: 1	تَعْيِينُ وُجُوبِهِ
u'تَعْيِينٌ وَسِيطٌ':Added, #2: 2	تَعْيِينُ الْوُجُوبِ
u'تَعْيِينٌ وَصْفٌ':Added, #1: 1	تَعْيِينَ الْوَسِيطِ
u'تَعْيِينٌ وَصْفٌ':Added, #1: 1	تَعْيِينُ الْوَصْفِ
u'تَعْيِينٌ وَصِيٌّ':Added, #2: 2	تَعْيِينِ الْوَصْفِ
u'تَعْيِينٌ وَصِيٌّ':Added, #1: 1	تَعْيِينَ الْوَصِيِّ
u'تَعْيِينٌ وَصِيٌّ':Added, #1: 1	تَعْيِينُ الْوَصِيِّ
u'تَعْيِينٌ وَصِيَّةٌ':Added, #1: 1	تَعْيِينِ الْوَصِيَّةِ
u'تَعْيِينٌ وَفَاءٌ':Added, #1: 1	تَعْيِينِ الْوَصِيَّةِ
u'تَعْيِينٌ وَقْتٌ':Added, #1: 1	تَعْيِينِ الْوَفَاءِ
u'تَعْيِينٌ وَقْتٌ':Added, #1: 1	تَعْيِينُ الْوَقْتِ
u'تَعْيِينٌ وَقْتٌ':Added, #1: 1	تَعْيِينُ وَقْتٍ
u'تَعْيِينٌ وَقْتٌ':Added, #1: 1	تَعْيِينِ وَقْتِ
u'تَعْيِينٌ وَقْتٌ':Added, #2: 2	تَعْيِينَ الْوَقْتِ
u'تَعْيِينٌ وَكِيلٌ':Added, #6: 6	تَعْيِينِ الْوَقْتِ
u'تَعْيِينٌ وَكِيلٌ':Added, #1: 1	تَعْيِينِ الْوَكِيلِ
u'تَعْيِينٌ ولد':Added, #2: 2	تَعْيِينُ الْوَكِيلِ
u'تَعْيِينٌ وَلَدٌ':Added, #12: 12	تَعْيِينِ الْوَلَدِ
u'تَعْيِينٌ ولد':Added, #12: 12	تَعْيِينِ الْوَلَدِ
u'تَعْيِينٌ ولد':Added, #1: 1	تَعْيِينَ الْوَلَدِ
u'تَعْيِينٌ وَلَدٌ':Added, #1: 1	تَعْيِينُ الْوَلَدِ
u'تَعْيِينٌ وَلَدٌ':Added, #1: 1	تَعْيِينَ الْوَلَدِ
u'تَعْيِينٌ وَلِيٌّ':Added, #1: 1	تَعْيِينُ الْوَلَدِ
u'تَعْيِينٌ يَمِينٌ':Added, #1: 1	تَعْيِينُ الْوَلِيِّ
u'تَعْيِينٌ يَوْمٌ':Added, #3: 3	تَعْيِينُ الْيَمِينِ
u'تَعْيِينٌ يَوْمٌ':Added, #1: 1	تَعْيِينَ الْيَوْمِ
u'تَعْيِينٌ يَوْمٌ':Added, #1: 1	تَعْيِينُ يَوْمِ
u'تَعْيِينٌ يَوْمٌ':Added, #1: 1	تَعْيِينِ يَوْمِ
u'تَعْيِينٌ يَوْمٌ':Added, #2: 2	تَعْيِينُ الْيَوْمِ
u'تَغَافُلٌ أهْلٌ':Added, #2: 2	تَعْيِينِ الْيَوْمِ
u'تَغَايُرٌ أَجْزَاءٌ':Added, #1: 1	تَغَافُلِ أَهْلِ
u'تَغَايُرٌ أَحْوالٌ':Added, #1: 1	تَغَايُرَ الْأَجْزَاءِ
u'تَغَايُرٌ أحْوَالٌ':Added, #1: 1	تَغَايُرِ الْأَحْوَالِ
u'تَغَايُرٌ أَمْزِجَةٌ':Added, #1: 1	تَغَايُرِ الْأَحْوَالِ
u'تَغَايَرَ بِنَاءٌ':Subject, #1: 1	تَغَايُرُ الْأَمْزِجَةِ
u'تَغَايَرَ بَيْنٌ':Predicate, #1: 1	تَغَايَرَ بِنَاءُ
u'تَغَايُرٌ جِنْسٌ':Added, #1: 1	تَغَايَرَ بَيْنَ
u'تَغَايُرٌ فَرْضٌ':Added, #1: 1	تَغَايُرِ الْجِنْسِ
u'تَغَايُرٌ فَرْضٌ':Added, #1: 1	تَغَايُرِ الْفَرْضِ
u'تَغَايُرٌ فساد':Added, #2: 2	تَغَايُرَ الْفَرْضَيْنِ
u'تَغَايُرٌ فَسَادٌ':Added, #1: 1	تَغَايُرِ فَسَادِ
u'تَغَايُرٌ فِعْلٌ':Added, #1: 1	تَغَايُرِ فَسَادِ
u'تَغَايُرٌ فَهْمٌ':Added, #1: 1	تَغَايُرِ الْفِعْلَيْنِ
u'تَغَايُرٌ قَوْلٌ':Added, #1: 1	تَغَايُرُ الْفَهْمَيْنِ
u'تَغَايُرٌ لَفْظٌ':Added, #1: 1	تَغَايُرُ الْقَوْلَيْنِ
u'تَغَايُرٌ مُثَلَّثٌ':Added, #1: 1	تَغَايُرِ اللَّفْظَيْنِ
u'تَغَايُرٌ مَعْنًى':Added, #1: 1	تَغَايُرَ الْمُثَلَّثِ
u'تَغَايَرَ مَوْضُوعٌ':Subject, #1: 1	تَغَايُرِ الْمَعْنَيَيْنِ
u'تَغَايُرٌ وَصْفٌ':Added, #1: 1	تَغَايَرَ مَوْضُوعُ
u'تَغَدَّى عَقِبٌ':Predicate, #1: 1	تَغَايُرُ الْوَصْفَيْنِ
u'تَغَدَّى عند':Predicate, #1: 1	تَغَدَّى عَقِبَ
u'تَغَدَّى مِصْرِيٌّ':Subject, #4: 4	تَغَدَّى عِنْدَ
u'تَغَدَّى يَوْمٌ':Predicate, #1: 1	تَغَدَّى الْمِصْرِيُّ
u'تَغْرِيبٌ حُرٌّ':Added, #1: 1	تَغَدَّى الْيَوْمَ
u'تَغْرِيقٌ أرْضٌ':Added, #1: 1	تَغْرِيبِ الْحُرِّ
u'تَغْرِيقٌ أهْلٌ':Added, #2: 2	تَغْرِيقَ الْأَرْضِ
u'تَغْرِيقٌ بَعْضٌ':Added, #1: 1	تَغْرِيقِ أَهْلِ
u'تَغْرِيقٌ سَفِينَةٌ':Added, #1: 1	تَغْرِيقُ الْبَعْضِ
u'تَغْرِيمٌ أَجْنَبِيٌّ':Added, #1: 1	تَغْرِيقَ السَّفِينَةِ
u'تَغْرِيمٌ بَدَلٌ':Added, #2: 2	تَغْرِيمُ الْأَجْنَبِيِّ
u'تَغْرِيمٌ شَاهِدٌ':Added, #1: 1	تَغْرِيمَ بَدَلِهِ
u'تَغْرِيمٌ عَادِلٌ':Added, #1: 1	تَغْرِيمِ الشَّاهِدِ
u'تَغْرِيمٌ كَاذِبٌ':Added, #1: 1	تَغْرِيمِ الْعَادِلِ
u'تَغْرِيمٌ مَالٌ':Added, #1: 1	تَغْرِيمُ الْكَاذِبِ
u'تَغْرِيمٌ وَكِيلٌ':Added, #1: 1	تَغْرِيمَ مَالٍ
u'تَغْسِيلٌ أَجْنَبِيٌّ':Added, #1: 1	تَغْرِيمُ الْوَكِيلِ
u'تَغْسِيلٌ الْمَرْأَةُ':Added, #2: 2	تَغْسِيلِ الْأَجْنَبِيِّ
u'تَغْسِيلٌ ذكر':Added, #1: 1	تَغْسِيلُ الْمَرْأَةِ
u'تَغْسِيلٌ ذَكَرٌ':Added, #1: 1	تَغْسِيلِ الذَّكَرِ
u'تَغْسِيلٌ ذِمِّيٌّ':Added, #1: 1	تَغْسِيلِ الذَّكَرِ
u'تَغْسِيلٌ رَجُلٌ':Added, #2: 2	تَغْسِيلُ الذِّمِّيَّةِ
u'تَغْسِيلٌ زَوْجَةٌ':Added, #1: 1	تَغْسِيلَ الرَّجُلِ
u'تَغْسِيلٌ زَوْجَةٌ':Added, #1: 1	تَغْسِيلِ الزَّوْجَةِ
u'تَغْسِيلٌ سقط':Added, #1: 1	تَغْسِيلُ زَوْجَتِهِ
u'تَغْسِيلٌ سِقْطٌ':Added, #1: 1	تَغْسِيلُ السِّقْطِ
u'تَغْسِيلٌ سَيِّدٌ':Added, #1: 1	تَغْسِيلُ السِّقْطِ
u'تَغْسِيلٌ شهداء':Added, #1: 1	تَغْسِيلِ السَّيِّدِ
u'تَغْسِيلٌ شَهِيدٌ':Added, #1: 1	تَغْسِيلِ الشُّهَدَاءِ
u'تَغْسِيلٌ صَاحِبٌ':Added, #1: 1	تَغْسِيلِ الشَّهِيدِ
u'تَغْسِيلٌ غير':Added, #2: 2	تَغْسِيلِ صَاحِبِهِ
u'تَغْسِيلٌ غَيْرٌ':Added, #1: 1	تَغْسِيلُ غَيْرِ
u'تَغْسِيلٌ كَافِرٌ':Added, #1: 1	تَغْسِيلُ غَيْرِ
u'تَغْسِيلٌ وَثَنِيٌّ':Added, #1: 1	تَغْسِيلُ الْكَافِرِ
u'تَغَشَّى رَسُولٌ':Predicate, #1: 1	تَغْسِيلَ الْوَثَنِيَّةِ
u'تَغْطِيَةٌ إِناءٌ':Added, #1: 1	تَغَشَّى رَسُولَ
u'تَغْطِيَةٌ إِناءٌ':Added, #1: 1	تَغْطِيَةُ الْإِنَاءِ
u'تَغْطِيَةٌ أَنْفٌ':Added, #1: 1	تَغْطِيَةِ الْإِنَاءِ
u'تَغْطِيَةٌ بَعْضٌ':Added, #2: 2	تَغْطِيَةُ الْأَنْفِ
u'تَغْطِيَةٌ بَعْضٌ':Added, #1: 1	تَغْطِيَةَ بَعْضِ
u'تَغْطِيَةٌ بِئْرٌ':Added, #1: 1	تَغْطِيَةِ بَعْضِ
u'تَغْطِيَةٌ حَقٌّ':Added, #1: 1	تَغْطِيَةِ بِئْرٍ
u'تَغْطِيَةٌ رَأْسٌ':Added, #1: 1	تَغْطِيَةُ الْحَقِّ
u'تَغْطِيَةٌ رَأْسٌ':Added, #17: 17	تَغْطِيَةِ الرَّأْسِ
u'تَغْطِيَةٌ رَأْسٌ':Added, #1: 1	تَغْطِيَةِ رَأْسِ
u'تَغْطِيَةٌ رَأْسٌ':Added, #3: 3	تَغْطِيَةُ الرَّأْسِ
u'تَغْطِيَةٌ رَأْسٌ':Added, #3: 3	تَغْطِيَةُ رَأْسِهِ
u'تَغْطِيَةٌ رَأْسٌ':Added, #4: 4	تَغْطِيَةِ رَأْسِهِ
u'تَغْطِيَةٌ رُبْعٌ':Added, #8: 8	تَغْطِيَةَ الرَّأْسِ
u'تَغْطِيَةٌ رَجُلٌ':Added, #1: 1	تَغْطِيَةُ رُبْعِ
u'تَغْطِيَةٌ رَجُلٌ':Added, #1: 1	تَغْطِيَةُ الرَّجُلِ
u'تَغْطِيَةٌ سَائِرٌ':Added, #2: 2	تَغْطِيَةِ الرَّجُلِ
u'تَغْطِيَةٌ عَقْلٌ':Added, #1: 1	تَغْطِيَةِ سَائِرِ
u'تَغْطِيَةٌ عَقْلٌ':Added, #2: 2	تَغْطِيَةِ الْعَقْلِ
u'تَغْطِيَةٌ عِمَامَةٌ':Added, #4: 4	تَغْطِيَةُ الْعَقْلِ
u'تَغْطِيَةٌ فَمٌ':Added, #1: 1	تَغْطِيَةِ الْعِمَامَةِ
u'تَغْطِيَةٌ فَمٌ':Added, #1: 1	تَغْطِيَةَ الْفَمِ
u'تَغْطِيَةٌ فَمٌ':Added, #1: 1	تَغْطِيَةُ الْفَمِ
u'تَغْطِيَةٌ لِحْيَةٌ':Added, #2: 2	تَغْطِيَةِ الْفَمِ
u'تَغْطِيَةٌ نَعْشٌ':Added, #2: 2	تَغْطِيَةِ اللِّحْيَةِ
u'تَغْطِيَةٌ وَجْهٌ':Added, #1: 1	تَغْطِيَةُ النَّعْشِ
u'تَغْطِيَةٌ وَجِهٌ':Added, #1: 1	تَغْطِيَةَ وَجْهِ
u'تَغْطِيَةٌ وَجْهٌ':Added, #1: 1	تَغْطِيَةِ وَجِهَةِ
u'تَغْطِيَةٌ وَجْهٌ':Added, #1: 1	تَغْطِيَةُ وَجْهِهِ
u'تَغْطِيَةٌ وَجْهٌ':Added, #1: 1	تَغْطِيَةِ وَجْهِهِ
u'تَغْطِيَةٌ وَجْهٌ':Added, #2: 2	تَغْطِيَةَ الْوَجْهِ
u'تَغْطِيَةٌ وَجْهٌ':Added, #6: 6	تَغْطِيَةِ الْوَجْهِ
u'تَغَلَّبَ قَوْمٌ':Subject, #7: 7	تَغْطِيَةُ الْوَجْهِ
u'تَغَلَّبَ مُتَغَلِّب':Subject, #4: 4	تَغَلَّبَ قَوْمٌ
u'تَغْلِيبٌ أحَدٌ':Added, #1: 1	تَغَلَّبَ مُتَغَلِّبٌ
u'تَغْلِيبٌ أشرف':Added, #1: 1	تَغْلِيبُ أَحَدِ
u'تَغْلِيبٌ أَشْرَفُ':Added, #1: 1	تَغْلِيبِ الْأَشْرَفِ
u'تَغْلِيبٌ أَشْيَاءٌ':Added, #1: 1	تَغْلِيبِ الْأَشْرَفِ
u'تَغْلِيبٌ أصل':Added, #1: 1	تَغْلِيبِ الْأَشْيَاءِ
u'تَغْلِيبٌ أًصْلٌ':Added, #1: 1	تَغْلِيبِ الْأَصْلِ
u'تَغْلِيبٌ تَحْرِيمٌ':Added, #1: 1	تَغْلِيبِ الْأَصْلِ
u'تَغْلِيبٌ تَحْرِيمٌ':Added, #1: 1	تَغْلِيبَ التَّحْرِيمِ
u'تَغْلِيبٌ تَحْلِيلٌ':Added, #1: 1	تَغْلِيبِ التَّحْرِيمِ
u'تَغْلِيبٌ جَانِبٌ':Added, #2: 2	تَغْلِيبُ التَّحْلِيلِ
u'تَغْلِيبٌ جِهَةٌ':Added, #2: 2	تَغْلِيبُ جَانِبِ
u'تَغْلِيبٌ جِهَةٌ':Added, #1: 1	تَغْلِيبِ جِهَةِ
u'تَغْلِيبٌ حاجَةٌ':Added, #2: 2	تَغْلِيبُ جِهَةِ
u'تَغْلِيبٌ حالَةٌ':Added, #1: 1	تَغْلِيبُ حَاجَةِ
u'تَغْلِيبٌ حُرْمَةٌ':Added, #1: 1	تَغْلِيبُ حَالَةٍ
u'تَغْلِيبٌ حَظْر':Added, #1: 1	تَغْلِيبِ الْحُرْمَةِ
u'تَغْلِيبٌ حَقٌّ':Added, #2: 2	تَغْلِيبِ الْحَظْرِ
u'تَغْلِيبٌ خِطَابٌ':Added, #6: 6	تَغْلِيبِ حَقِّ
u'تَغْلِيبٌ خَوْفٌ':Added, #1: 1	تَغْلِيبُ الْخِطَابِ
u'تَغْلِيبٌ ذُكورٌ':Added, #3: 3	تَغْلِيبُ خَوْفِهِ
u'تَغْلِيبٌ رَأْيٌ':Added, #1: 1	تَغْلِيبُ الذُّكُورِ
u'تَغْلِيبٌ زَكاةٌ':Added, #1: 1	تَغْلِيبِ رَأْيِهِ
u'تَغْلِيبٌ صَحِيحٌ':Added, #1: 1	تَغْلِيبِ زَكَاةِ
u'تَغْلِيبٌ ظَنٌّ':Added, #1: 1	تَغْلِيبِ الصَّحِيحِ
u'تَغْلِيبٌ غَالِبٌ':Added, #1: 1	تَغْلِيبُ ظَنٍّ
u'تَغْلِيبٌ لَفْظٌ':Added, #1: 1	تَغْلِيبِ الْغَالِبِ
u'تَغْلِيبٌ مَصْلَحَةٌ':Added, #1: 1	تَغْلِيبُ لَفْظِ
u'تَغْلِيبٌ مِلْكٌ':Added, #1: 1	تَغْلِيبُ الْمَصْلَحَةِ
u'تَغْلِيطٌ اِبْنٌ':Added, #1: 1	تَغْلِيبِ مِلْكِ
u'تَغْلِيطٌ خَصْمٌ':Added, #1: 1	تَغْلِيطِ ابْنِ
u'تَغْلِيظٌ إِبِلٌ':Added, #1: 1	تَغْلِيطَ خَصْمِهِ
u'تَغْلِيظٌ إِثْمٌ':Added, #1: 1	تَغْلِيظُ الإِبِلِ
u'تَغْلِيظٌ أَمْرٌ':Added, #1: 1	تَغْلِيظَ الْإِثْمِ
u'تَغْلِيظٌ أئِمَّةٌ':Added, #1: 1	تَغْلِيظِ الْأَمْرِ
u'تَغْلِيظٌ أَيْمَانٌ':Added, #1: 1	تَغْلِيظَ الْأَئِمَّةِ
u'تَغْلِيظٌ أَيْمَانٌ':Added, #1: 1	تَغْلِيظُ الْأَيْمَانِ
u'تَغْلِيظٌ تَحْرِيمٌ':Added, #1: 1	تَغْلِيظِ الْأَيْمَانِ
u'تَغْلِيظٌ تَرْكٌ':Added, #1: 1	تَغْلِيظِ تَحْرِيمِ
u'تَغْلِيظٌ جَرِيمَةٌ':Added, #1: 1	تَغْلِيظَ تَرْكِهِ
u'تَغْلِيظٌ جِنَايَةٌ':Added, #2: 2	تَغْلِيظُ الْجَرِيمَةِ
u'تَغْلِيظٌ دِيَةٌ':Added, #1: 1	تَغْلِيظِ الْجِنَايَاتِ
u'تَغْلِيظٌ دِيَةٌ':Added, #4: 4	تَغْلِيظُ الدِّيَةِ
u'تَغْلِيظٌ عُقُوبَةٌ':Added, #7: 7	تَغْلِيظِ الدِّيَةِ
u'تَغْلِيظٌ قتل':Added, #1: 1	تَغْلِيظُ الْعُقُوبَةِ
u'تَغْلِيظٌ قَتْلٌ':Added, #1: 1	تَغْلِيظِ الْقَتْلِ
u'تَغْلِيظٌ لاَمٌ':Added, #1: 1	تَغْلِيظِ الْقَتْلِ
u'تَغْلِيظٌ يَمِينٌ':Added, #1: 1	تَغْلِيظُ اللَّامِ
u'تَغْلِيظٌ يَمِينٌ':Added, #3: 3	تَغْلِيظِ الْيَمِينِ
u'تَغْلِيقٌ تَعْلِيقٌ':Added, #4: 4	تَغْلِيظُ الْيَمِينِ
u'تَغْمِيضٌ عَيْنٌ':Added, #15: 15	تَغْلِيقِ التَّعْلِيقِ
u'تَغْمِيضٌ عَيْن':Added, #1: 1	تَغْمِيضَ الْعَيْنَيْنِ
u'تَغَنَّى فلان':Subject, #1: 1	تَغْمِيضَ الْعَيْنَيْنِ
u'تَغَيَّبَ جَمَّالٌ':Subject, #1: 1	تَغَنَّى بِلاَلٌ
u'تَغَيُّبٌ رَهْنٌ':Added, #1: 1	تَغَيَّبَ الْجَمَّالُ
u'تَغَيُّبٌ زَوْجٌ':Added, #1: 1	تَغَيُّبَ الرَّهْنِ
u'تَغَيَّبَ طَالِبٌ':Subject, #1: 1	تَغَيُّبِ الزَّوْجِ
u'تَغَيَّبَ مَضْمُونٌ':Subject, #3: 3	تَغَيَّبَ الطَّالِبُ
u'تَغَيَّبَ مَضْمُونٌ':Subject, #1: 1	تَغَيَّبَ الْمَضْمُونُ
u'تَغَيَّرَ اِجْتِهَادٌ':Subject, #2: 2	تَغَيَّبَ مَضْمُونٌ
u'تَغَيَّرَ اِجْتِهَادٌ':Subject, #26: 26	تَغَيَّرَ اجْتِهَادُهُ
u'تَغَيُّرٌ اِجْتِهَادٌ':Added, #7: 7	تَغَيَّرَ اجْتِهَادُ
u'تَغَيُّرٌ اِجْتِهَادٌ':Added, #1: 1	تَغَيُّرَ اجْتِهَادِ
u'تَغَيُّرٌ اِجْتِهَادٌ':Added, #1: 1	تَغَيُّرُ اجْتِهَادِ
u'تَغَيُّرٌ اِجْتِهَادٌ':Added, #1: 1	تَغَيُّرِ اجْتِهَادِ
u'تَغَيَّرَ أحَدٌ':Subject, #4: 4	تَغَيُّرِ اجْتِهَادِهِ
u'تَغَيُّرٌ أحَدٌ':Added, #7: 7	تَغَيَّرَ أَحَدُ
u'تَغَيُّرٌ أحَدٌ':Added, #1: 1	تَغَيُّرُ أَحَدِ
u'تَغَيُّرٌ أخْلاقٌ':Added, #1: 1	تَغَيُّرِ أَحَدِ
u'تَغَيُّرٌ أَخْلاَقٌ':Added, #2: 2	تَغَيُّرِ أَخْلَاقِهِ
u'تَغَيُّرٌ أسْعَارٌ':Added, #2: 2	تَغَيُّرِ أَخْلَاقِهِ
u'تَغَيَّرَ اِسْمٌ':Subject, #1: 1	تَغَيُّرِ الْأَسْعَارِ
u'تَغَيُّرٌ أًصْلٌ':Added, #1: 1	تَغَيَّرَ اسْمُهُ
u'تَغَيُّرٌ أَصْلِيٌّ':Added, #1: 1	تَغَيُّرَ أَصْلٍ
u'تَغَيُّرٌ إِعْرابٌ':Added, #1: 1	تَغَيُّرٍ أَصْلِيٍّ
u'تَغَيَّرَ أَمْرٌ':Subject, #1: 1	تَغَيُّرِ إعْرَابِهِ
u'تَغَيُّرٌ أَنْهُرٌ':Added, #1: 1	تَغَيَّرَ الْأَمْرُ
u'تَغَيَّرَ أهْلٌ':Subject, #1: 1	تَغَيُّرُ أَنْهُرِ
u'تَغَيَّرَ أَوْصَافٌ':Subject, #1: 1	تَغَيَّرَ أَهْلُ
u'تَغَيُّرٌ أَوْصَافٌ':Added, #1: 1	تَغَيَّرَ الْأَوْصَافُ
u'تَغَيَّرَ أَوَّلُ':Subject, #1: 1	تَغَيُّرِ أَوْصَافِهِ
u'تَغَيُّرٌ بَاطن':Added, #1: 1	تَغَيَّرَ الْأَوَّلُ
u'تَغَيُّرٌ باطِنٌ':Added, #1: 1	تَغَيُّرِ الْبَاطِنِ
u'تَغَيَّرَ بدن':Subject, #1: 1	تَغَيُّرِ الْبَاطِنِ
u'تَغَيَّرَ بَدَنٌ':Subject, #1: 1	تَغَيَّرَ بَدَنُهُ
u'تَغَيُّرٌ بدن':Added, #1: 1	تَغَيَّرَ بَدَنُهُ
u'تَغَيُّرٌ بَدَنٌ':Added, #1: 1	تَغَيُّرِ بَدَنِهِ
u'تَغَيَّرَ بُسْرٌ':Subject, #1: 1	تَغَيُّرِ بَدَنِهِ
u'تَغَيَّرَ بَعْضٌ':Subject, #1: 1	تَغَيَّرَ الْبُسْرُ
u'تَغَيَّرَ بَعْضٌ':Subject, #1: 1	تَغَيَّرَ بَعْضُهُ
u'تَغَيُّرٌ تَصَرُّفٌ':Added, #4: 4	تَغَيَّرَ بَعْضُ
u'تَغَيَّرَ ثَمَنٌ':Subject, #1: 1	تَغَيُّرَ تَصَرُّفِهِ
u'تَغَيُّرٌ جلسة':Added, #1: 1	تَغَيَّرَ ثَمَنُهُ
u'تَغَيُّرٌ جِلْسَةٌ':Added, #1: 1	تَغَيُّرَ جِلْسَتِهِ
u'تَغَيَّرَ حالٌ':Subject, #1: 1	تَغَيُّرَ جِلْسَتِهِ
u'تَغَيَّرَ حالٌ':Subject, #2: 2	تَغَيَّرَ الْحَالُ
u'تَغَيَّرَ حالٌ':Subject, #4: 4	تَغَيَّرَ حَالُ
u'تَغَيُّرٌ حالٌ':Added, #9: 9	تَغَيَّرَ حَالُهُ
u'تَغَيُّرٌ حالٌ':Added, #1: 1	تَغَيُّرَ الْحَالِ
u'تَغَيُّرٌ حالٌ':Added, #1: 1	تَغَيُّرُ الْحَالِ
u'تَغَيُّرٌ حالٌ':Added, #1: 1	تَغَيُّرَ حَالِ
u'تَغَيُّرٌ حالٌ':Added, #2: 2	تَغَيُّرِ حَالِ
u'تَغَيُّرٌ حالَةٌ':Added, #4: 4	تَغَيُّرِ الْحَالِ
u'تَغَيُّرٌ حالَةٌ':Added, #1: 1	تَغَيُّرِ الْحَالَاتِ
u'تَغَيُّرٌ حالَةٌ':Added, #1: 1	تَغَيُّرَ حَالَةِ
u'تَغَيَّرَ حُسْنٌ':Subject, #5: 5	تَغَيُّرُ حَالَةٍ
u'تَغَيَّرَ حِفْظٌ':Subject, #1: 1	تَغَيَّرَ حُسْنُ
u'تَغَيَّرَ حُكْمٌ':Subject, #2: 2	تَغَيَّرَ حِفْظُهُ
u'تَغَيَّرَ حُكْمٌ':Subject, #1: 1	تَغَيَّرَ حُكْمُهُ
u'تَغَيَّرَ حُكْمٌ':Subject, #3: 3	تَغَيَّرَ الْحُكْمُ
u'تَغَيُّرٌ حُكْمٌ':Added, #3: 3	تَغَيَّرَ حُكْمُ
u'تَغَيُّرٌ حُكْمٌ':Added, #1: 1	تَغَيُّرَ الْحُكْمِ
u'تَغَيُّرٌ حُكْمٌ':Added, #1: 1	تَغَيُّرُ الْحُكْمِ
u'تَغَيُّرٌ حُكْمٌ':Added, #1: 1	تَغَيُّرِ حُكْمِ
u'تَغَيُّرٌ حَوْضٌ':Added, #1: 1	تَغَيُّرَ حُكْمِهِ
u'تَغَيُّرٌ خَاطِرٌ':Added, #1: 1	تَغَيُّرُ الْحَوْضِ
u'تَغَيُّرٌ خلق':Added, #1: 1	تَغَيُّرِ خَاطِرِهِ
u'تَغَيُّرٌ خُلُقٌ':Added, #1: 1	تَغَيُّرِ خُلُقِهِ
u'تَغَيُّرٌ خُلُق':Added, #1: 1	تَغَيُّرِ خُلُقِهِ
u'تَغَيُّرٌ خلق':Added, #1: 1	تَغَيُّرِ خُلُقِهِ
u'تَغَيُّرٌ خُلُقٌ':Added, #2: 2	تَغَيُّرِ الْخُلُقِ
u'تَغَيُّرٌ خُلُق':Added, #2: 2	تَغَيُّرِ الْخُلُقِ
u'تَغَيُّرٌ خلقة':Added, #2: 2	تَغَيُّرِ الْخُلُقِ
u'تَغَيُّرٌ خِلْقَةٌ':Added, #1: 1	تَغَيُّرِ الْخِلْقَةِ
u'تَغَيُّرٌ دَلالَةٌ':Added, #1: 1	تَغَيُّرِ الْخِلْقَةِ
u'تَغَيَّرَ دِينٌ':Subject, #1: 1	تَغَيُّرِ دَلَالَةِ
u'تَغَيَّرَ دِينٌ':Subject, #1: 1	تَغَيَّرَ الدِّينُ
u'تَغَيَّرَ دَيْنٌ':Subject, #1: 1	تَغَيَّرَ دِينُ
u'تَغَيَّرَ ذِهْنٌ':Subject, #1: 1	تَغَيَّرَ دَيْنٌ
u'تَغَيُّرٌ رَأْيٌ':Added, #1: 1	تَغَيَّرَ ذِهْنُهُ
u'تَغَيُّرٌ رَأْيٌ':Added, #1: 1	تَغَيُّرِ الرَّأْيِ
u'تَغَيُّرٌ رَائِحٌ':Added, #1: 1	تَغَيُّرِ رَأْيِ
u'تَغَيُّرٌ رَائِحٌ':Added, #1: 1	تَغَيُّرِ الرَّائِحَةِ
u'تَغَيُّرٌ رَائِحٌ':Added, #1: 1	تَغَيُّرِ رَائِحَةِ
u'تَغَيُّرٌ رَائِحٌ':Added, #1: 1	تَغَيُّرِ رَائِحَتِهِ
u'تَغَيُّرٌ رَائِحَةٌ':Added, #3: 3	تَغَيُّرُ رَائِحَةِ
u'تَغَيُّرٌ رَائِحَةٌ':Added, #1: 1	تَغَيُّرِ الرَّائِحَةِ
u'تَغَيُّرٌ رَائِحَةٌ':Added, #1: 1	تَغَيُّرِ رَائِحَةِ
u'تَغَيُّرٌ رَائِحَةٌ':Added, #1: 1	تَغَيُّرِ رَائِحَتِهِ
u'تَغَيَّرَ ريحٌ':Subject, #3: 3	تَغَيُّرُ رَائِحَةِ
u'تَغَيُّرٌ ريحٌ':Added, #3: 3	تَغَيَّرَ رِيحُهُ
u'تَغَيُّرٌ ريحٌ':Added, #1: 1	تَغَيُّرَ الرِّيحِ
u'تَغَيُّرٌ ريحٌ':Added, #1: 1	تَغَيُّرُ رِيحِ
u'تَغَيُّرٌ ريحٌ':Added, #1: 1	تَغَيُّرَ رِيحِهِ
u'تَغَيُّرٌ زَكاةٌ':Added, #1: 1	تَغَيُّرُ رِيحِهِ
u'تَغَيَّرَ زَمانٌ':Subject, #1: 1	تَغَيُّرَ الزَّكَاةِ
u'تَغَيَّرَ سعر':Subject, #1: 1	تَغَيَّرَ الزَّمَانُ
u'تَغَيَّرَ سِعْرٌ':Subject, #1: 1	تَغَيَّرَ سِعْرُ
u'تَغَيَّرَ سعر':Subject, #1: 1	تَغَيَّرَ سِعْرُ
u'تَغَيَّرَ سِعْرٌ':Subject, #5: 5	تَغَيَّرَ السِّعْرُ
u'تَغَيُّرٌ سعر':Added, #5: 5	تَغَيَّرَ السِّعْرُ
u'تَغَيُّرٌ سعر':Added, #1: 1	تَغَيُّرُ السِّعْرِ
u'تَغَيُّرٌ سِعْرٌ':Added, #1: 1	تَغَيُّرِ السِّعْرِ
u'تَغَيُّرٌ سِعْرٌ':Added, #1: 1	تَغَيُّرُ السِّعْرِ
u'تَغَيُّرٌ سَلاَطِينُ':Added, #1: 1	تَغَيُّرِ السِّعْرِ
u'تَغَيَّرَ سُوقٌ':Subject, #1: 1	تَغَيُّرِ السَّلاَطِينِ
u'تَغَيُّرٌ سُوقٌ':Added, #2: 2	تَغَيَّرَ سُوقُ
u'تَغَيُّرٌ سُوقٌ':Added, #1: 1	تَغَيُّرَ السُّوقِ
u'تَغَيَّرَ شَرْطٌ':Subject, #2: 2	تَغَيُّرِ سُوقٍ
u'تَغَيُّرٌ شَرْطٌ':Added, #1: 1	تَغَيَّرَ شَرْطُ
u'تَغَيُّرٌ شمس':Added, #1: 1	تَغَيُّرُ شَرْطِ
u'تَغَيُّرٌ شَمْسٌ':Added, #1: 1	تَغَيُّرُ الشَّمْسِ
u'تَغَيُّرٌ شمس':Added, #1: 1	تَغَيُّرُ الشَّمْسِ
u'تَغَيُّرٌ شَمْسٌ':Added, #26: 26	تَغَيُّرِ الشَّمْسِ
u'تَغَيَّرَ شَيْءٌ':Subject, #26: 26	تَغَيُّرِ الشَّمْسِ
u'تَغَيُّرٌ صَرْفٌ':Added, #1: 1	تَغَيَّرَ شَيْءٌ
u'تَغَيُّرٌ صَرْف':Added, #2: 2	تَغَيُّرِ الصَّرْفِ
u'تَغَيَّرَ صِفَةٌ':Subject, #2: 2	تَغَيُّرِ الصَّرْفِ
u'تَغَيُّرٌ صِفَةٌ':Added, #1: 1	تَغَيَّرَ صِفَاتُهُ
u'تَغَيُّرٌ صِفَةٌ':Added, #1: 1	تَغَيُّرَ صِفَةِ
u'تَغَيُّرٌ صِفَةٌ':Added, #1: 1	تَغَيُّرِ صِفَةِ
u'تَغَيُّرٌ صِفَةٌ':Added, #1: 1	تَغَيُّرُ صِفَتِهِ
u'تَغَيَّرَ ضَرُورَةٌ':Subject, #2: 2	تَغَيُّرُ صِفَةِ
u'تَغَيُّرٌ ضَوْءٌ':Added, #1: 1	تَغَيَّرَ ضَرُورَةُ
u'تَغَيُّرٌ ضَوْءٌ':Added, #2: 2	تَغَيُّرُ الضَّوْءِ
u'تَغَيُّرٌ طَاهِرٌ':Added, #3: 3	تَغَيُّرَ الضَّوْءِ
u'تَغَيُّرٌ طَبْعٌ':Added, #1: 1	تَغَيُّرُ الطَّاهِرِ
u'تَغَيَّرَ طَعْمٌ':Subject, #1: 1	تَغَيُّرِ الطَّبْعِ
u'تَغَيَّرَ طَعْمٌ':Subject, #2: 2	تَغَيَّرَ طَعْمُ
u'تَغَيُّرٌ طَعْمٌ':Added, #3: 3	تَغَيَّرَ طَعْمُهُ
u'تَغَيُّرٌ طَعْمٌ':Added, #1: 1	تَغَيُّرَ الطَّعْمِ
u'تَغَيُّرٌ ظاهِرٌ':Added, #1: 1	تَغَيُّرِ الطَّعْمِ
u'تَغَيَّرَ ظَنٌّ':Subject, #1: 1	تَغَيُّرٍ ظَاهِرٍ
u'تَغَيُّرٌ عَامٌّ':Added, #1: 1	تَغَيَّرَ ظَنُّهُ
u'تَغَيُّرٌ عَامِلٌ':Added, #1: 1	تَغَيُّرَ الْعَامِّ
u'تَغَيُّرٌ عِدَّةٌ':Added, #1: 1	تَغَيُّرِ الْعَامِلِ
u'تَغَيُّرٌ عرف':Added, #1: 1	تَغَيُّرِ الْعِدَّةِ
u'تَغَيُّرٌ عُرْفٌ':Added, #3: 3	تَغَيُّرِ الْعُرْفِ
u'تَغَيَّرَ عَزْمٌ':Subject, #3: 3	تَغَيُّرِ الْعُرْفِ
u'تَغَيَّرَ عَقْدٌ':Subject, #1: 1	تَغَيَّرَ عَزْمُهُ
u'تَغَيُّرٌ عَقْدٌ':Added, #1: 1	تَغَيَّرَ عَقْدُهُ
u'تَغَيُّرٌ عَقِيدَةٌ':Added, #2: 2	تَغَيُّرُ الْعَقْدِ
u'تَغَيَّرَ عَمَلٌ':Subject, #1: 1	تَغَيُّرِ الْعَقِيدَةِ
u'تَغَيَّرَ عند':Predicate, #1: 1	تَغَيَّرَ عَمَلٌ
u'تَغَيَّرَ عين':Subject, #2: 2	تَغَيَّرَ عِنْدَ
u'تَغَيَّرَ عَيْنٌ':Subject, #2: 2	تَغَيَّرَ عَيْنُهُ
u'تَغَيَّرَ عَيْن':Subject, #2: 2	تَغَيَّرَ عَيْنُهُ
u'تَغَيُّرٌ غِذَاءٌ':Added, #2: 2	تَغَيَّرَ عَيْنُهُ
u'تَغَيُّرٌ غُلاَمٌ':Added, #2: 2	تَغَيُّرِ الْغِذَاءِ
u'تَغَيَّرَ فَرْضٌ':Subject, #1: 1	تَغَيُّرِ الْغُلَامِ
u'تَغَيَّرَ فَرْضٌ':Subject, #1: 1	تَغَيَّرَ الْفَرْضُ
u'تَغَيُّرٌ فَرْضٌ':Added, #5: 5	تَغَيَّرَ فَرْضُهُ
u'تَغَيُّرٌ فَرْضٌ':Added, #1: 1	تَغَيُّرُ الْفَرْضِ
u'تَغَيُّرٌ فَرْضٌ':Added, #1: 1	تَغَيُّرَ فَرْضِهِ
u'تَغَيَّرَ فَمٌ':Subject, #3: 3	تَغَيُّرِ الْفَرْضِ
u'تَغَيَّرَ فَمٌ':Subject, #1: 1	تَغَيَّرَ الْفَمُ
u'تَغَيَّرَ فَمٌ':Subject, #1: 1	تَغَيَّرَ فَمُ
u'تَغَيُّرٌ فَمٌ':Added, #1: 1	تَغَيَّرَ فَمُهُ
u'تَغَيَّرَ قَالٌ':Predicate, #1: 1	تَغَيُّرَ الْفَمِ
u'تَغَيُّرٌ قُرْصٌ':Added, #1: 1	تَغَيَّرَ قَالَ
u'تَغَيُّرٌ قُرْصٌ':Added, #2: 2	تَغَيُّرَ الْقُرْصِ
u'تَغَيُّرٌ قُلُوبٌ':Added, #4: 4	تَغَيُّرُ الْقُرْصِ
u'تَغَيَّرَ كَثِيرٌ':Subject, #1: 1	تَغَيُّرُ الْقُلُوبِ
u'تَغَيُّرٌ كَلِمَةٌ':Added, #1: 1	تَغَيَّرَ كَثِيرُ
u'تَغَيَّرَ لَوْنٌ':Subject, #1: 1	تَغَيُّرِ كَلِمَاتِهِ
u'تَغَيَّرَ لَوْنٌ':Subject, #1: 1	تَغَيَّرَ اللَّوْنُ
u'تَغَيُّرٌ لَوْنٌ':Added, #8: 8	تَغَيَّرَ لَوْنُهُ
u'تَغَيُّرٌ لَوْنٌ':Added, #1: 1	تَغَيُّرَ اللَّوْنِ
u'تَغَيُّرٌ لَوْنٌ':Added, #1: 1	تَغَيُّرِ اللَّوْنِ
u'تَغَيُّرٌ لَوْنٌ':Added, #1: 1	تَغَيُّرِ لَوْنٍ
u'تَغَيُّرٌ لَوْنٌ':Added, #1: 1	تَغَيُّرِ لَوْنِ
u'تَغَيُّرٌ لَوْنٌ':Added, #1: 1	تَغَيُّرِ لَوْنِهِ
u'تَغَيَّرَ مَاءٌ':Subject, #3: 3	تَغَيُّرُ اللَّوْنِ
u'تَغَيُّرٌ مَاءٌ':Added, #8: 8	تَغَيَّرَ الْمَاءُ
u'تَغَيُّرٌ مَاءٌ':Added, #2: 2	تَغَيُّرَ الْمَاءِ
u'تَغَيُّرٌ مَاءٌ':Added, #4: 4	تَغَيُّرِ الْمَاءِ
u'تَغَيُّرٌ مَبِيعٌ':Added, #7: 7	تَغَيُّرُ الْمَاءِ
u'تَغَيَّرَ مثل':Subject, #2: 2	تَغَيُّرِ الْمَبِيعِ
u'تَغَيَّرَ مِثْلٌ':Subject, #1: 1	تَغَيَّرَ مِثْلُ
u'تَغَيُّرٌ مَحْسُوسٌ':Added, #1: 1	تَغَيَّرَ مِثْلُ
u'تَغَيُّرٌ مَحْسُوسٌ':Added, #1: 1	تَغَيُّرَ الْمَحْسُوسِ
u'تَغَيَّرَ مُسْتَحِقٌّ':Subject, #1: 1	تَغَيُّرُ الْمَحْسُوسِ
u'تَغَيُّرٌ مَطْبُوخٌ':Added, #1: 1	تَغَيَّرَ الْمُسْتَحِقُّ
u'تَغَيُّرٌ مَعِدَةٌ':Added, #2: 2	تَغَيُّرِ الْمَطْبُوخِ
u'تَغَيُّرٌ مَكْتُوبٌ':Added, #1: 1	تَغَيُّرِ الْمَعِدَةِ
u'تَغَيَّرَ مِنْبَرٌ':Subject, #1: 1	تَغَيُّرُ الْمَكْتُوبِ
u'تَغَيَّرَ مُوجِبٌ':Subject, #1: 1	تَغَيَّرَ الْمِنْبَرُ
u'تَغَيُّرٌ مُوجِبٌ':Added, #3: 3	تَغَيَّرَ مُوجِبُ
u'تَغَيُّرٌ مَوْضِعٌ':Added, #1: 1	تَغَيُّرَ مُوجِبِ
u'تَغَيُّرٌ مِيَاهٌ':Added, #1: 1	تَغَيُّرِ مَوْضِعِ
u'تَغَيَّرَ نَاسٌ':Subject, #2: 2	تَغَيُّرِ الْمِيَاهِ
u'تَغَيُّرٌ نَاسٌ':Added, #2: 2	تَغَيَّرَ النَّاسُ
u'تَغَيُّرٌ نَجَسٌ':Added, #1: 1	تَغَيُّرِ النَّاسِ
u'تَغَيَّرَ نَحْوٌ':Subject, #1: 1	تَغَيُّرُ النَّجَسِ
u'تَغَيَّرَ نصاب':Subject, #1: 1	تَغَيَّرَ نَحْوُ
u'تَغَيَّرَ نِصَابٌ':Subject, #1: 1	تَغَيَّرَ النِّصَابُ
u'تَغَيُّرٌ نِعَمٌ':Added, #1: 1	تَغَيَّرَ النِّصَابُ
u'تَغَيُّرٌ نُفُوسٌ':Added, #1: 1	تَغَيُّرِ النِّعَمِ
u'تَغَيَّرَ نَقْدٌ':Subject, #1: 1	تَغَيُّرَ النُّفُوسِ
u'تَغَيَّرَ نَقْد':Subject, #3: 3	تَغَيَّرَ النَّقْدُ
u'تَغَيُّرٌ نَكْهَةٌ':Added, #3: 3	تَغَيَّرَ النَّقْدُ
u'تَغَيُّرٌ نَوْعٌ':Added, #1: 1	تَغَيُّرِ النَّكْهَةِ
u'تَغَيُّرٌ نِيَّةٌ':Added, #1: 1	تَغَيُّرَ النَّوْعِ
u'تَغَيُّرٌ هِبَةٌ':Added, #1: 1	تَغَيُّرُ النِّيَّةِ
u'تَغَيُّرٌ هَيْئَةٌ':Added, #1: 1	تَغَيُّرَ الْهِبَةِ
u'تَغَيُّرٌ هَيْئَةٌ':Added, #1: 1	تَغَيُّرَ الْهَيْئَةِ
u'تَغَيُّرٌ هَيْئَةٌ':Added, #1: 1	تَغَيُّرِ هَيْئَتِهِ
u'تَغَيَّرَ وَجْهٌ':Subject, #2: 2	تَغَيُّرِ الْهَيْئَةِ
u'تَغَيَّرَ وَجْهٌ':Subject, #1: 1	تَغَيَّرَ وَجْهُ
u'تَغَيُّرٌ وَجْهٌ':Added, #3: 3	تَغَيَّرَ وَجْهُهُ
u'تَغَيَّرَ وَصْفٌ':Subject, #1: 1	تَغَيُّرُ الْوَجْهِ
u'تَغَيَّرَ وَصْفٌ':Subject, #1: 1	تَغَيَّرَ وَصْفُهُ
u'تَغَيُّرٌ وَصْفٌ':Added, #2: 2	تَغَيَّرَ وَصْفُ
u'تَغَيُّرٌ وَضْعٌ':Added, #1: 1	تَغَيُّرَ الْوَصْفِ
u'تَغَيُّرٌ وَظِيفٌ':Added, #1: 1	تَغَيُّرُ الْوَضْعِ
u'تَغَيُّرٌ وَظِيفَةٌ':Added, #1: 1	تَغَيُّرِ الْوَظِيفَةِ
u'تَغَيُّرٌ وَلاَءٌ':Added, #1: 1	تَغَيُّرِ الْوَظِيفَةِ
u'تَغَيُّرٌ يَدٌ':Added, #1: 1	تَغَيُّرِ الْوَلَاءِ
u'تَغَيُّرٌ يَسِيرٌ':Added, #1: 1	تَغَيُّرِ الْيَدَيْنِ
u'تَغْيِيبٌ بالِغٌ':Added, #1: 1	تَغَيُّرُ يَسِيرٍ
u'تَغْيِيبٌ حَشَفَةٌ':Added, #1: 1	تَغْيِيبُ الْبَالِغِ
u'تَغْيِيبٌ حَشَفَةٌ':Added, #13: 13	تَغْيِيبُ الْحَشَفَةِ
u'تَغْيِيبٌ حَشَفَةٌ':Added, #1: 1	تَغْيِيبُ حَشَفَتِهِ
u'تَغْيِيبٌ حَشَفَةٌ':Added, #2: 2	تَغْيِيبَ الْحَشَفَةِ
u'تَغْيِيبٌ حَشَفَةٌ':Added, #2: 2	تَغْيِيبُ حَشَفَةِ
u'تَغْيِيبٌ عَقْلٌ':Added, #4: 4	تَغْيِيبِ الْحَشَفَةِ
u'تَغْيِيبٌ قَدْرٌ':Added, #1: 1	تَغْيِيبِ الْعَقْلِ
u'تَغْيِيبٌ لَوْنٌ':Added, #2: 2	تَغْيِيبُ قَدْرِ
u'تَغْيِيبٌ مَالٌ':Added, #1: 1	تَغْيِيبُ لَوْنِ
u'تَغْيِيرٌ أَجْزَاءٌ':Added, #2: 2	تَغْيِيبُ مَالِ
u'تَغْيِيرٌ أَحْكَامٌ':Added, #1: 1	تَغْيِيرِ الْأَجْزَاءِ
u'تَغْيِيرٌ أَحْكَامٌ':Added, #1: 1	تَغْيِيرُ أَحْكَامِهِ
u'تَغْيِيرٌ أرْضٌ':Added, #2: 2	تَغْيِيرِ الْأَحْكَامِ
u'تَغْيِيرٌ اِسْمٌ':Added, #1: 1	تَغْيِيرُ الْأَرْضِ
u'تَغْيِيرٌ اِسْمٌ':Added, #1: 1	تَغْيِيرِ اسْمِ
u'تَغْيِيرٌ إِسْنادٌ':Added, #1: 1	تَغْيِيرِ الاِسْمِ
u'تَغْيِيرٌ أصل':Added, #2: 2	تَغْيِيرُ إسْنَادِ
u'تَغْيِيرٌ أًصْلٌ':Added, #1: 1	تَغْيِيرَ الْأَصْلِ
u'تَغْيِيرٌ إِعْرابٌ':Added, #1: 1	تَغْيِيرَ الْأَصْلِ
u'تَغْيِيرٌ أَلْفَاظٌ':Added, #1: 1	تَغْيِيرَ الْإِعْرَابِ
u'تَغْيِيرٌ أَمْرٌ':Added, #1: 1	تَغْيِيرُ الْأَلْفَاظِ
u'تَغْيِيرٌ أَمْرٌ':Added, #1: 1	تَغْيِيرِ أَمْرٍ
u'تَغْيِيرٌ آيَةٌ':Added, #2: 2	تَغْيِيرَ الْأَمْرِ
u'تَغْيِيرٌ إِيجَابٌ':Added, #1: 1	تَغْيِيرِ الْآيَةِ
u'تَغْيِيرٌ بَابٌ':Added, #1: 1	تَغْيِيرِ إيجَابِ
u'تَغْيِيرٌ بَعْضٌ':Added, #2: 2	تَغْيِيرِ بَابٍ
u'تَغْيِيرٌ بَعْضٌ':Added, #1: 1	تَغْيِيرَ بَعْضِ
u'تَغْيِيرٌ بِنَاءٌ':Added, #1: 1	تَغْيِيرُ بَعْضِ
u'تَغْيِيرٌ بِنَاءٌ':Added, #1: 1	تَغْيِيرَ بِنَاءِ
u'تَغْيِيرٌ بِنْيَةٌ':Added, #2: 2	تَغْيِيرِ بِنَاءِ
u'تَغْيِيرٌ تَأْلِيفٌ':Added, #1: 1	تَغْيِيرِ الْبِنْيَةِ
u'تَغْيِيرٌ تَصَرُّفٌ':Added, #1: 1	تَغْيِيرَ التَّأْلِيفِ
u'تَغْيِيرٌ ثِيابٌ':Added, #2: 2	تَغْيِيرَ تَصَرُّفِهِ
u'تَغْيِيرٌ جِنْسٌ':Added, #1: 1	تَغْيِيرِ ثِيَابِهِ
u'تَغْيِيرٌ حالٌ':Added, #1: 1	تَغْيِيرَ جِنْسِ
u'تَغْيِيرٌ حالٌ':Added, #1: 1	تَغْيِيرِ الْحَالِ
u'تَغْيِيرٌ حالٌ':Added, #1: 1	تَغْيِيرُ حَالٍ
u'تَغْيِيرٌ حَبْسٌ':Added, #2: 2	تَغْيِيرُ حَالِهِ
u'تَغْيِيرٌ حَرَكَةٌ':Added, #1: 1	تَغْيِيرِ الْحَبْسِ
u'تَغْيِيرٌ حُروفٌ':Added, #1: 1	تَغْيِيرُ الْحَرَكَةِ
u'تَغْيِيرٌ حقد':Added, #1: 1	تَغْيِيرُ الْحُرُوفِ
u'تَغْيِيرٌ حِقد':Added, #1: 1	تَغْيِيرَ الْحِقْدِ
u'تَغْيِيرٌ حِقْدٌ':Added, #1: 1	تَغْيِيرَ الْحِقْدِ
u'تَغْيِيرٌ حُقوقٌ':Added, #1: 1	تَغْيِيرَ الْحِقْدِ
u'تَغْيِيرٌ حُقُوقٌ':Added, #1: 1	تَغْيِيرِ الْحُقُوقِ
u'تَغْيِيرٌ حَقِيقٌ':Added, #1: 1	تَغْيِيرِ الْحُقُوقِ
u'تَغْيِيرٌ حَقِيقَةٌ':Added, #1: 1	تَغْيِيرِ الْحَقِيقَةِ
u'تَغْيِيرٌ حُكْمٌ':Added, #1: 1	تَغْيِيرِ الْحَقِيقَةِ
u'تَغْيِيرٌ حُكْمٌ':Added, #1: 1	تَغْيِيرَ الْحُكْمِ
u'تَغْيِيرٌ حُكْمٌ':Added, #1: 1	تَغْيِيرِ الْحُكْمِ
u'تَغْيِيرٌ حُكْمٌ':Added, #1: 1	تَغْيِيرُ حُكْمٍ
u'تَغْيِيرٌ حُكْمٌ':Added, #1: 1	تَغْيِيرِ حُكْمٍ
u'تَغْيِيرٌ حُكْمٌ':Added, #2: 2	تَغْيِيرُ الْحُكْمِ
u'تَغْيِيرٌ حُكْمٌ':Added, #2: 2	تَغْيِيرِ حُكْمِ
u'تَغْيِيرٌ حُكْمٌ':Added, #3: 3	تَغْيِيرَ حُكْمِ
u'تَغْيِيرٌ خلق':Added, #8: 8	تَغْيِيرُ حُكْمِ
u'تَغْيِيرٌ خَلْقٌ':Added, #1: 1	تَغْيِيرُ خَلْقِ
u'تَغْيِيرٌ خلق':Added, #1: 1	تَغْيِيرُ خَلْقِ
u'تَغْيِيرٌ خَلْقٌ':Added, #4: 4	تَغْيِيرِ خَلْقِ
u'تَغْيِيرٌ دِينٌ':Added, #4: 4	تَغْيِيرِ خَلْقِ
u'تَغْيِيرٌ دَيْنٌ':Added, #1: 1	تَغْيِيرِ الدِّينِ
u'تَغْيِيرٌ رِوايَةٌ':Added, #1: 1	تَغْيِيرِ الدَّيْنِ
u'تَغْيِيرٌ زِيٌّ':Added, #1: 1	تَغْيِيرِ الرِّوَايَةِ
u'تَغْيِيرٌ زِيٌّ':Added, #1: 1	تَغْيِيرُ الزِّيِّ
u'تَغْيِيرٌ سَبَبٌ':Added, #1: 1	تَغْيِيرِ زِيِّهِ
u'تَغْيِيرٌ سعر':Added, #1: 1	تَغْيِيرَ سَبَبٍ
u'تَغْيِيرٌ سِعْرٌ':Added, #2: 2	تَغْيِيرَ السِّعْرِ
u'تَغْيِيرٌ شَرْطٌ':Added, #2: 2	تَغْيِيرَ السِّعْرِ
u'تَغْيِيرٌ شَرْطٌ':Added, #1: 1	تَغْيِيرَ شَرْطِ
u'تَغْيِيرٌ شَرْطٌ':Added, #1: 1	تَغْيِيرُ شَرْطِ
u'تَغْيِيرٌ شَرْطٌ':Added, #1: 1	تَغْيِيرِ شَرْطٍ
u'تَغْيِيرٌ شَرْطٌ':Added, #1: 1	تَغْيِيرِ شَرْطِ
u'تَغْيِيرٌ شَرْعٌ':Added, #2: 2	تَغْيِيرَ الشَّرْطِ
u'تَغْيِيرٌ شُرُوطٌ':Added, #2: 2	تَغْيِيرَ الشَّرْعِ
u'تَغْيِيرٌ شعار':Added, #1: 1	تَغْيِيرِ شُرُوطِهِ
u'تَغْيِيرٌ شِعَارٌ':Added, #1: 1	تَغْيِيرُ شِعَارِ
u'تَغْيِيرٌ شَكْلٌ':Added, #1: 1	تَغْيِيرُ شِعَارِ
u'تَغْيِيرٌ شمس':Added, #1: 1	تَغْيِيرِ شَكْلٍ
u'تَغْيِيرٌ شمس':Added, #1: 1	تَغْيِيرَ الشَّمْسِ
u'تَغْيِيرٌ شَمْسٌ':Added, #1: 1	تَغْيِيرِ الشَّمْسِ
u'تَغْيِيرٌ شَمْسٌ':Added, #1: 1	تَغْيِيرَ الشَّمْسِ
u'تَغْيِيرٌ شَيْءٌ':Added, #1: 1	تَغْيِيرِ الشَّمْسِ
u'تَغْيِيرٌ شَيْءٌ':Added, #1: 1	تَغْيِيرِ الشَّيْءِ
u'تَغْيِيرٌ شيب':Added, #4: 4	تَغْيِيرُ شَيْءٍ
u'تَغْيِيرٌ شيب':Added, #2: 2	تَغْيِيرُ الشَّيْبِ
u'تَغْيِيرٌ شَيْبٌ':Added, #2: 2	تَغْيِيرِ الشَّيْبِ
u'تَغْيِيرٌ شَيْبٌ':Added, #2: 2	تَغْيِيرُ الشَّيْبِ
u'تَغْيِيرٌ صِفَةٌ':Added, #2: 2	تَغْيِيرِ الشَّيْبِ
u'تَغْيِيرٌ صِفَةٌ':Added, #1: 1	تَغْيِيرَ الصِّفَةِ
u'تَغْيِيرٌ صِفَةٌ':Added, #1: 1	تَغْيِيرِ صِفَاتِ
u'تَغْيِيرٌ صِفَةٌ':Added, #1: 1	تَغْيِيرُ صِفَةٍ
u'تَغْيِيرٌ صِفَةٌ':Added, #1: 1	تَغْيِيرِ صِفَةِ
u'تَغْيِيرٌ صِفَةٌ':Added, #3: 3	تَغْيِيرِ صِفَاتِهِ
u'تَغْيِيرٌ صَلاَةٌ':Added, #3: 3	تَغْيِيرُ صِفَةِ
u'تَغْيِيرٌ صُورَةٌ':Added, #1: 1	تَغْيِيرَ صَلَاتِهِ
u'تَغْيِيرٌ طَبْعٌ':Added, #2: 2	تَغْيِيرَ صُورَتِهِ
u'تَغْيِيرٌ طَعْمٌ':Added, #1: 1	تَغْيِيرُ الطَّبْعِ
u'تَغْيِيرٌ ظاهِرٌ':Added, #1: 1	تَغْيِيرِ طَعْمِ
u'تَغْيِيرٌ عَادَةٌ':Added, #1: 1	تَغْيِيرٍ ظَاهِرٍ
u'تَغْيِيرٌ عِدَّةٌ':Added, #1: 1	تَغْيِيرُ الْعَادَةِ
u'تَغْيِيرٌ عَدَدٌ':Added, #2: 2	تَغْيِيرِ الْعِدَّةِ
u'تَغْيِيرٌ عَقِيدَةٌ':Added, #1: 1	تَغْيِيرِ عَدَدِ
u'تَغْيِيرٌ عِوَضٌ':Added, #1: 1	تَغْيِيرِ الْعَقِيدَةِ
u'تَغْيِيرٌ عين':Added, #1: 1	تَغْيِيرِ الْعِوَضِ
u'تَغْيِيرٌ عَيْنٌ':Added, #1: 1	تَغْيِيرِ الْعَيْنِ
u'تَغْيِيرٌ عَيْن':Added, #1: 1	تَغْيِيرِ الْعَيْنِ
u'تَغْيِيرٌ غِذَاءٌ':Added, #1: 1	تَغْيِيرِ الْعَيْنِ
u'تَغْيِيرٌ فَرْضٌ':Added, #1: 1	تَغْيِيرِ الْغِذَاءِ
u'تَغْيِيرٌ فَرْضٌ':Added, #1: 1	تَغْيِيرُ الْفَرْضِ
u'تَغْيِيرٌ قَضِيَّةٌ':Added, #2: 2	تَغْيِيرِ الْفَرْضِ
u'تَغْيِيرٌ كِتَابٌ':Added, #1: 1	تَغْيِيرِ قَضِيَّةِ
u'تَغْيِيرٌ كَلاَمٌ':Added, #1: 1	تَغْيِيرُ الْكِتَابِ
u'تَغْيِيرٌ كَلِمَةٌ':Added, #1: 1	تَغْيِيرِ كَلَامِ
u'تَغْيِيرٌ لُغَةٌ':Added, #1: 1	تَغْيِيرِ كَلِمَاتِهِ
u'تَغْيِيرٌ لَفْظٌ':Added, #2: 2	تَغْيِيرُ اللُّغَةِ
u'تَغْيِيرٌ لَفْظٌ':Added, #1: 1	تَغْيِيرَ اللَّفْظِ
u'تَغْيِيرٌ لَفْظٌ':Added, #1: 1	تَغْيِيرِ اللَّفْظِ
u'تَغْيِيرٌ مُشْتَقٌّ':Added, #2: 2	تَغْيِيرِ لَفْظِهِ
u'تَغْيِيرٌ مَشْرُوعٌ':Added, #1: 1	تَغْيِيرِ الْمُشْتَقِّ
u'تَغْيِيرٌ مُصَنِّفٌ':Added, #5: 5	تَغْيِيرُ الْمَشْرُوعِ
u'تَغْيِيرٌ مَعَالِمُ':Added, #1: 1	تَغْيِيرُ الْمُصَنِّفِ
u'تَغْيِيرٌ مَعَالِمُ':Added, #1: 1	تَغْيِيرَ مَعَالِمِ
u'تَغْيِيرٌ مَعَالِمُ':Added, #1: 1	تَغْيِيرِ مَعَالِمِهِ
u'تَغْيِيرٌ مَقَادِيرُ':Added, #4: 4	تَغْيِيرِ مَعَالِمِ
u'تَغْيِيرٌ مُقْتَضَى':Added, #1: 1	تَغْيِيرُ الْمَقَادِيرِ
u'تَغْيِيرٌ مِلَّةٌ':Added, #1: 1	تَغْيِيرِ مُقْتَضَيَاتِ
u'تَغْيِيرٌ مِلْكٌ':Added, #1: 1	تَغْيِيرِ مِلَّةِ
u'تَغْيِيرٌ مَنَارٌ':Added, #1: 1	تَغْيِيرِ مِلْكِهِ
u'تَغْيِيرٌ مُنْكَرٌ':Added, #1: 1	تَغْيِيرُ مَنَارِ
u'تَغْيِيرٌ مُنْكَرٌ':Added, #2: 2	تَغْيِيرُ الْمُنْكَرِ
u'تَغْيِيرٌ مُوجَبٌ':Added, #6: 6	تَغْيِيرِ الْمُنْكَرِ
u'تَغْيِيرٌ مُوجِبٌ':Added, #1: 1	تَغْيِيرُ مُوجَبِ
u'تَغْيِيرٌ مَوْضِعٌ':Added, #1: 1	تَغْيِيرُ مُوجِبِ
u'تَغْيِيرٌ مَوْضُوعٌ':Added, #1: 1	تَغْيِيرُ مَوْضِعِ
u'تَغْيِيرٌ مَوْضُوعٌ':Added, #1: 1	تَغْيِيرَ مَوْضُوعِ
u'تَغْيِيرٌ مَوْضُوعٌ':Added, #1: 1	تَغْيِيرُ مَوْضُوعِ
u'تَغْيِيرٌ مُوَكَّلٌ':Added, #1: 1	تَغْيِيرِ مَوْضُوعِ
u'تَغْيِيرٌ نَظْمٌ':Added, #1: 1	تَغْيِيرُ الْمُوَكَّلِ
u'تَغْيِيرٌ نَظْمٌ':Added, #1: 1	تَغْيِيرُ نَظْمِ
u'تَغْيِيرٌ نَوْعٌ':Added, #1: 1	تَغْيِيرِ نَظْمِ
u'تَغْيِيرٌ نِيَّةٌ':Added, #1: 1	تَغْيِيرَ النَّوْعِ
u'تَغْيِيرٌ نِيَّةٌ':Added, #1: 1	تَغْيِيرِ النِّيَّةِ
u'تَغْيِيرٌ هَيْئَةٌ':Added, #1: 1	تَغْيِيرِ نِيَّتِهِ
u'تَغْيِيرٌ هَيْئَةٌ':Added, #1: 1	تَغْيِيرُ هَيْئَتِهِ
u'تَغْيِيرٌ وَاجِبٌ':Added, #3: 3	تَغْيِيرِ هَيْئَتِهِ
u'تَغْيِيرٌ واحد':Added, #1: 1	تَغْيِيرِ وَاجِبٍ
u'تَغْيِيرٌ وَاحِدٌ':Added, #1: 1	تَغْيِيرَ وَاحِدٍ
u'تَغْيِيرٌ وَصْفٌ':Added, #1: 1	تَغْيِيرَ وَاحِدٍ
u'تَغْيِيرٌ وَصْفٌ':Added, #1: 1	تَغْيِيرِ وَصْفِ
u'تَغْيِيرٌ وَصْفٌ':Added, #1: 1	تَغْيِيرُ وَصْفِهِ
u'تَغْيِيرٌ وَصْفٌ':Added, #1: 1	تَغْيِيرِ وَصْفِهِ
u'تَغْيِيرٌ وَقْفٌ':Added, #3: 3	تَغْيِيرُ وَصْفِ
u'تَغْيِيرٌ وَقْفٌ':Added, #1: 1	تَغْيِيرَ الْوَقْفِ
u'تَغْيِيرٌ وَقْفٌ':Added, #1: 1	تَغْيِيرِ الْوَقْفِ
u'تَغْيِيرٌ يَسِيرٌ':Added, #3: 3	تَغْيِيرُ الْوَقْفِ
u'تَفَاءَلَ رَسُولٌ':Subject, #2: 2	تَغْيِيرٍ يَسِيرٍ
u'تَفَاحَشَ جُذَامٌ':Subject, #1: 1	تَفَاءَلَ رَسُولُ
u'تَفَاحَشَ طُولٌ':Subject, #1: 1	تَفَاحَشَ جُذَامُهُ
u'تَفَاخَرَ ثَابِتٌ':Subject, #1: 1	تَفَاحَشَ طُولُ
u'تَفَاخَرَ جَمَاعَةٌ':Subject, #1: 1	تَفَاخَرَ ثَابِتُ
u'تَفَاخُرٌ مُلُوكٌ':Added, #1: 1	تَفَاخَرَ جَمَاعَةٌ
u'تَفَاخَرَ نَاسٌ':Subject, #1: 1	تَفَاخُرِ الْمُلُوكِ
u'تَفَاسَخَ رَاهِنٌ':Subject, #1: 1	تَفَاخَرَ النَّاسُ
u'تَفَاضُلٌ مَالٌ':Added, #1: 1	تَفَاسَخَ الرَّاهِنُ
u'تَفَاقَدَ قَوْمٌ':Subject, #2: 2	تَفَاضُلِ مَالٍ
u'تَفَاقَدَ مَعْشَرٌ':Subject, #1: 1	تَفَاقَدَ قَوْمٌ
u'تَفَاقَمَ أَمْرٌ':Subject, #1: 1	تَفَاقَدَ مَعْشَرٌ
u'تَفَاقُمٌ أَمْرٌ':Added, #1: 1	تَفَاقَمَ الْأَمْرُ
u'تَفَاقَمَ خَطْبٌ':Subject, #1: 1	تَفَاقُمَ الْأَمْرِ
u'تَفَاقَمَ خَوْفٌ':Subject, #1: 1	تَفَاقَمَ الْخَطْبُ
u'تَفَانَى رِجَالٌ':Subject, #1: 1	تَفَاقَمَ الْخَوْفُ
u'تَفَاوَتَ إِرْثٌ':Subject, #1: 1	تَفَانَى الرِّجَالُ
u'تَفَاوَتَ حُكْمٌ':Subject, #1: 1	تَفَاوَتَ الْإِرْثُ
u'تَفَاوَتَ خراج':Subject, #1: 1	تَفَاوَتَ الْحُكْمُ
u'تَفَاوَتَ خَرَاجٌ':Subject, #1: 1	تَفَاوَتَ الْخَرَاجُ
u'تَفَاوَتَ قَدْرٌ':Subject, #1: 1	تَفَاوَتَ الْخَرَاجُ
u'تَفَاوَتَ مِلْكٌ':Subject, #1: 1	تَفَاوَتَ قَدْرُ
u'تَفَتَّحَ زهر':Subject, #1: 1	تَفَاوَتَ الْمِلْكُ
u'تَفَتَّحَ زَهْرٌ':Subject, #1: 1	تَفَتَّحَ زَهْرُهُ
u'تَفَتَّحَ كِمَامٌ':Subject, #1: 1	تَفَتَّحَ زَهْرُهُ
u'تَفَتُّحٌ وَرْدٌ':Added, #1: 1	تَفَتَّحَ كِمَامُ
u'تَفْتِيرٌ شَهْوَةٌ':Added, #1: 1	تَفَتُّحُ وَرْدٍ
u'تَفْتِيرٌ شَهْوَةٌ':Added, #1: 1	تَفْتِيرَ الشَّهْوَةِ
u'تَفْتِيشٌ أَمْوَالٌ':Added, #2: 2	تَفْتِيرِ الشَّهْوَةِ
u'تَفْتِيشٌ تَمْر':Added, #1: 1	تَفْتِيشِ الْأَمْوَالِ
u'تَفْتِيشٌ دَارٌ':Added, #3: 3	تَفْتِيشِ التَّمْرِ
u'تَفْتِيشٌ غِرَارَةٌ':Added, #1: 1	تَفْتِيشَ دَارِهِ
u'تَفْتِيشٌ كُتُبٌ':Added, #1: 1	تَفْتِيشِ الْغِرَارَةِ
u'تَفْتِيشٌ مَسْكَنٌ':Added, #1: 1	تَفْتِيشِ كُتُبِ
u'تَفَجُّعٌ وَالِدٌ':Added, #1: 1	تَفْتِيشَ مَسْكَنِ
u'تَفْجِيرٌ مَاءٌ':Added, #1: 1	تَفَجُّعِ الْوَالِدَيْنِ
u'تَفَحُّصٌ مُخْطِئٌ':Added, #2: 2	تَفْجِيرِ الْمَاءِ
u'تَفْخِيمٌ صُورٌ':Added, #1: 1	تَفَحُّصُ الْمُخْطِئِ
u'تَفْخِيمٌ صُوَرٌ':Added, #1: 1	تَفْخِيمُ الصُّوَرِ
u'تَفْخِيمٌ صُورَةٌ':Added, #1: 1	تَفْخِيمُ الصُّوَرِ
u'تَفَرَّدَ اِبْنٌ':Subject, #1: 1	تَفْخِيمُ صُورَةِ
u'تَفَرُّدٌ اِبْنٌ':Added, #2: 2	تَفَرَّدَ ابْنُ
u'تَفَرَّدَ أعْمَش':Subject, #1: 1	تَفَرُّدِ ابْنِ
u'تَفَرَّدَ بَعْضٌ':Subject, #1: 1	تَفَرَّدَ الأَعْمَشُ
u'تَفَرَّدَ تَعْزِير':Subject, #1: 1	تَفَرَّدَ بَعْضُ
u'تَفَرُّدٌ ثِقَةٌ':Added, #1: 1	تَفَرَّدَ التَّعْزِيرُ
u'تَفَرَّدَ حَمَّادٌ':Subject, #1: 1	تَفَرُّدَ الثِّقَةِ
u'تَفَرُّدٌ حَنْبَلٌ':Added, #2: 2	تَفَرَّدَ حَمَّادُ
u'تَفَرُّدٌ حَنْبَلٌ':Added, #1: 1	تَفَرُّدُ حَنْبَلٍ
u'تَفَرَّدَ رَجُلٌ':Subject, #1: 1	تَفَرُّدِ حَنْبَلٍ
u'تَفَرُّدٌ عَبْدٌ':Added, #1: 1	تَفَرَّدَ رَجُلٌ
u'تَفَرُّدٌ عَزِيزٌ':Added, #1: 1	تَفَرُّدِ عَبْدِ
u'تَفَرَّدَ عَلاءٌ':Subject, #1: 1	تَفَرُّدِ الْعَزِيزِ
u'تَفَرَّدَ عند':Predicate, #1: 1	تَفَرَّدَ الْعَلَاءُ
u'تَفَرُّدٌ مُتَصَرِّفٌ':Added, #1: 1	تَفَرَّدَ عِنْدَ
u'تَفَرَّدَ مُجالِد':Subject, #1: 1	تَفَرُّدَ الْمُتَصَرِّفِ
u'تَفَرَّدَ مُسْلِمٌ':Subject, #1: 1	تَفَرَّدَ مُجَالِدٌ
u'تَفَرَّدَ واحد':Subject, #1: 1	تَفَرَّدَ مُسْلِمٌ
u'تَفَرَّدَ وَاحِدٌ':Subject, #1: 1	تَفَرَّدَ وَاحِدٌ
u'تَفَرُّدٌ واحد':Added, #1: 1	تَفَرَّدَ وَاحِدٌ
u'تَفَرُّدٌ وَاحِدٌ':Added, #1: 1	تَفَرُّدَ الْوَاحِدِ
u'تَفَرَّدَ وَاقِفٌ':Subject, #1: 1	تَفَرُّدَ الْوَاحِدِ
u'تَفَرُّدٌ وِلاَيَةٌ':Added, #1: 1	تَفَرَّدَ الْوَاقِفُ
u'تَفَرَّدَ وَلِيٌّ':Subject, #1: 1	تَفَرُّدُ الْوِلَايَةِ
u'تَفَرُّعٌ تَوَقُّفٌ':Added, #1: 1	تَفَرَّدَ وَلِيُّ
u'تَفَرُّعٌ خِلاَفٌ':Added, #1: 1	تَفَرُّعُ التَّوَقُّفِ
u'تَفَرُّعٌ عَدَمٌ':Added, #1: 1	تَفَرُّعُ الْخِلَافِ
u'تَفَرُّعٌ عِلَّةٌ':Added, #1: 1	تَفَرُّعَ عَدَمِ
u'تَفَرَّعَ عَوْدٌ':Subject, #1: 1	تَفَرُّعِ الْعِلَّةِ
u'تَفَرَّعَ مَذْهَبٌ':Subject, #1: 1	تَفَرَّعَ عَوْدُهُ
u'تَفَرَّعَ مَسَائِلُ':Subject, #1: 1	تَفَرَّعَ الْمَذْهَبُ
u'تَفَرَّعَ وُقُوعٌ':Subject, #1: 1	تَفَرَّعَ مَسَائِلُ
u'تَفَرُّغٌ زَوْجٌ':Added, #1: 1	تَفَرَّعَ الْوُقُوعُ
u'تَفَرَّغَ قَادِرٌ':Subject, #1: 1	تَفَرُّغِ الزَّوْجِ
u'تَفَرَّغَ قلب':Subject, #1: 1	تَفَرَّغَ قَادِرٌ
u'تَفَرَّغَ قَلْبٌ':Subject, #1: 1	تَفَرَّغَ قَلْبُ
u'تَفَرَّغَ قَلْب':Subject, #1: 1	تَفَرَّغَ قَلْبُ
u'تَفَرُّقٌ أبدانٌ':Added, #1: 1	تَفَرَّغَ قَلْبُ
u'تَفَرُّقٌ أبدانٌ':Added, #1: 1	تَفَرُّقُ الْأَبَدَانِ
u'تَفَرُّقٌ أَجْزَاءٌ':Added, #9: 9	تَفَرُّقَ الْأَبْدَانِ
u'تَفَرُّقٌ أَدَاءٌ':Added, #1: 1	تَفَرُّقَ الْأَجْزَاءِ
u'تَفَرُّقٌ آرَاءٌ':Added, #1: 1	تَفَرُّقِ الْأَدَاءِ
u'تَفَرُّقٌ أَعْمَالٌ':Added, #1: 1	تَفَرُّقِ الْآرَاءِ
u'تَفَرُّقٌ أَفْعَالٌ':Added, #1: 1	تَفَرُّقُ الْأَعْمَالِ
u'تَفَرُّقٌ أَقْوَالٌ':Added, #2: 2	تَفَرُّقُ الْأَفْعَالِ
u'تَفَرُّقٌ أَقْوَالٌ':Added, #2: 2	تَفَرُّقَ الْأَقْوَالِ
u'تَفَرُّقٌ أُمَّةٌ':Added, #2: 2	تَفَرُّقُ الْأَقْوَالِ
u'تَفَرَّقَ أَمْرٌ':Subject, #1: 1	تَفَرُّقِ الْأُمَّةِ
u'تَفَرُّقٌ أَمْرٌ':Added, #1: 1	تَفَرَّقَ أَمْرُهُ
u'تَفَرُّقٌ أهْلٌ':Added, #1: 1	تَفَرُّقَ الْأَمْرِ
u'تَفَرَّقَ بَعْضٌ':Subject, #1: 1	تَفَرُّقِ أَهْلِ
u'تَفَرُّقٌ بُلْدانٌ':Added, #1: 1	تَفَرَّقَ بَعْضُ
u'تَفَرُّقٌ تَسْمِيَة':Added, #1: 1	تَفَرُّقُ الْبُلْدَانِ
u'تَفَرَّقَ تَفَرُّقٌ':Predicate, #1: 1	تَفَرُّقَ التَّسْمِيَةِ
u'تَفَرَّقَ ثَمَنٌ':Subject, #1: 1	تَفَرَّقَ التَّفَرُّقَ
u'تَفَرَّقَ جُنْدٌ':Subject, #2: 2	تَفَرَّقَ الثَّمَنُ
u'تَفَرُّقٌ خَاطِرٌ':Added, #1: 1	تَفَرَّقَ الْجُنْدُ
u'تَفَرُّقٌ صَفْقَةٌ':Added, #1: 1	تَفَرُّقُ خَاطِرِهِ
u'تَفَرُّقٌ صَفْقَةٌ':Added, #1: 1	تَفَرُّقَ الصَّفْقَةِ
u'تَفَرُّقٌ صَفْقَةٌ':Added, #1: 1	تَفَرُّقُ الصَّفْقَةِ
u'تَفَرَّقَ عَدَدٌ':Subject, #1: 1	تَفَرُّقِ الصَّفْقَةِ
u'تَفَرَّقَ عَقِيبٌ':Predicate, #1: 1	تَفَرَّقَ الْعَدَدُ
u'تَفَرُّقٌ علماء':Added, #1: 1	تَفَرَّقَ عَقِيبَ
u'تَفَرُّقٌ عُلَمَاءُ':Added, #1: 1	تَفَرُّقِ الْعُلَمَاءِ
u'تَفَرَّقَ قَوْمٌ':Subject, #1: 1	تَفَرُّقِ الْعُلَمَاءِ
u'تَفَرَّقَ كَلاَمٌ':Subject, #1: 1	تَفَرَّقَ الْقَوْمُ
u'تَفَرُّقٌ كَلِمَةٌ':Added, #1: 1	تَفَرَّقَ كَلَامُهُ
u'تَفَرُّقٌ مَبِيعٌ':Added, #1: 1	تَفَرُّقُ الْكَلِمَةِ
u'تَفَرُّقٌ مُتَعَاقِدٌ':Added, #1: 1	تَفَرُّقِ الْمَبِيعِ
u'تَفَرُّقٌ مَكَانٌ':Added, #2: 2	تَفَرُّقَ الْمُتَعَاقِدَيْنِ
u'تَفَرُّقٌ مِلْكٌ':Added, #1: 1	تَفَرُّقُ الْمَكَانِ
u'تَفَرَّقَ نَاسٌ':Subject, #1: 1	تَفَرُّقَ الْمِلْكِ
u'تَفَرُّقٌ نَاسٌ':Added, #8: 8	تَفَرَّقَ النَّاسُ
u'تَفَرُّقٌ ولد':Added, #1: 1	تَفَرُّقِ النَّاسِ
u'تَفَرُّقٌ وَلَدٌ':Added, #1: 1	تَفَرُّقُ وَلَدِ
u'تَفْرِيجٌ كَرْبٌ':Added, #1: 1	تَفَرُّقُ وَلَدِ
u'تَفْرِيجٌ كَرْبٌ':Added, #1: 1	تَفْرِيجُ الْكَرْبِ
u'تَفْرِيحٌ قلب':Added, #1: 1	تَفْرِيجُ كَرْبِ
u'تَفْرِيحٌ قَلْبٌ':Added, #1: 1	تَفْرِيحِ الْقَلْبِ
u'تَفْرِيحٌ قَلْب':Added, #1: 1	تَفْرِيحِ الْقَلْبِ
u'تَفْرِيطٌ الْمَرْأَةُ':Added, #1: 1	تَفْرِيحِ الْقَلْبِ
u'تَفْرِيطٌ أَوَّلُ':Added, #1: 1	تَفْرِيطِ الْمَرْأَةِ
u'تَفْرِيطٌ حاكِمٌ':Added, #1: 1	تَفْرِيطَ الْأَوَّلِ
u'تَفْرِيطٌ عَبْدٌ':Added, #1: 1	تَفْرِيطِ الْحَاكِمِ
u'تَفْرِيطٌ قَافِلٌ':Added, #1: 1	تَفْرِيطِ الْعَبْدِ
u'تَفْرِيطٌ قَافِلَةٌ':Added, #1: 1	تَفْرِيطِ الْقَافِلَةِ
u'تَفْرِيطٌ مَالِكٌ':Added, #1: 1	تَفْرِيطِ الْقَافِلَةِ
u'تَفْرِيطٌ مَالِكٌ':Added, #1: 1	تَفْرِيطِ الْمَالِكِ
u'تَفْرِيطٌ مُكَلَّفٌ':Added, #2: 2	تَفْرِيطِ مَالِكِ
u'تَفْرِيطٌ وَلِيٌّ':Added, #1: 1	تَفْرِيطُ الْمُكَلَّفِ
u'تَفْرِيغٌ أرْضٌ':Added, #1: 1	تَفْرِيطُ الْوَلِيِّ
u'تَفْرِيغٌ أرْضٌ':Added, #3: 3	تَفْرِيغُ الْأَرْضِ
u'تَفْرِيغٌ أرْضٌ':Added, #3: 3	تَفْرِيغِ الْأَرْضِ
u'تَفْرِيغٌ أُمَّهَاتٌ':Added, #6: 6	تَفْرِيغَ الْأَرْضِ
u'تَفْرِيغٌ بالُوعَةٌ':Added, #1: 1	تَفْرِيغِ الْأُمَّهَاتِ
u'تَفْرِيغٌ بيض':Added, #1: 1	تَفْرِيغُ الْبَالُوعَةِ
u'تَفْرِيغٌ حانوتٌ':Added, #1: 1	تَفْرِيغَ الْبِيضِ
u'تَفْرِيغٌ حِجارَةٌ':Added, #1: 1	تَفْرِيغَ الْحَانُوتِ
u'تَفْرِيغٌ خَلاَءٌ':Added, #2: 2	تَفْرِيغِ الْحِجَارَةِ
u'تَفْرِيغٌ دَارٌ':Added, #1: 1	تَفْرِيغِ الْخَلَاءِ
u'تَفْرِيغٌ دَارٌ':Added, #1: 1	تَفْرِيغَ الدَّارِ
u'تَفْرِيغٌ ذِمَّةٌ':Added, #2: 2	تَفْرِيغُ الدَّارِ
u'تَفْرِيغٌ ذِمَّةٌ':Added, #1: 1	تَفْرِيغَ الذِّمَّةِ
u'تَفْرِيغٌ ذِمَّةٌ':Added, #1: 1	تَفْرِيغَ ذِمَّةِ
u'تَفْرِيغٌ ذِمَّةٌ':Added, #2: 2	تَفْرِيغِ الذِّمَّةِ
u'تَفْرِيغٌ ذِمَّةٌ':Added, #3: 3	تَفْرِيغُ الذِّمَّةِ
u'تَفْرِيغٌ ذِمَّةٌ':Added, #3: 3	تَفْرِيغُ ذِمَّتِهِ
u'تَفْرِيغٌ زَرْعٌ':Added, #8: 8	تَفْرِيغِ ذِمَّتِهِ
u'تَفْرِيغٌ طَرِيقٌ':Added, #1: 1	تَفْرِيغِ الزَّرْعِ
u'تَفْرِيغٌ قلب':Added, #1: 1	تَفْرِيغَ الطَّرِيقِ
u'تَفْرِيغٌ قَلْبٌ':Added, #1: 1	تَفْرِيغَ الْقَلْبِ
u'تَفْرِيغٌ قَلْب':Added, #1: 1	تَفْرِيغَ الْقَلْبِ
u'تَفْرِيغٌ قلب':Added, #1: 1	تَفْرِيغَ الْقَلْبِ
u'تَفْرِيغٌ قَلْبٌ':Added, #2: 2	تَفْرِيغُ الْقَلْبِ
u'تَفْرِيغٌ قَلْب':Added, #2: 2	تَفْرِيغُ الْقَلْبِ
u'تَفْرِيغٌ مَاءٌ':Added, #2: 2	تَفْرِيغُ الْقَلْبِ
u'تَفْرِيغٌ مَسِيلٌ':Added, #1: 1	تَفْرِيغُ الْمَاءِ
u'تَفْرِيغٌ مِلْكٌ':Added, #1: 1	تَفْرِيغَ مَسِيلِ
u'تَفْرِيغٌ مِلْكٌ':Added, #1: 1	تَفْرِيغَ مِلْكِهِ
u'تَفْرِيغٌ مِلْكٌ':Added, #1: 1	تَفْرِيغُ مِلْكِهِ
u'تَفْرِيغٌ نِساءٌ':Added, #2: 2	تَفْرِيغِ مِلْكِهِ
u'تَفْرِيغٌ نَفْسٌ':Added, #1: 1	تَفْرِيغُ النّسَاءِ
u'تَفْرِيغٌ نَفْسٌ':Added, #2: 2	تَفْرِيغُ النَّفْسِ
u'تَفْرِيغٌ نَفْسٌ':Added, #2: 2	تَفْرِيغُ نَفْسِهِ
u'تَفْرِيغٌ هَوَاءٌ':Added, #2: 2	تَفْرِيغِ نَفْسِهِ
u'تَفْرِيقٌ أَجْزَاءٌ':Added, #2: 2	تَفْرِيغُ الْهَوَاءِ
u'تَفْرِيقٌ أَجْزَاءٌ':Added, #10: 10	تَفْرِيقِ الْأَجْزَاءِ
u'تَفْرِيقٌ أحَدٌ':Added, #1: 1	تَفْرِيقَ الْأَجْزَاءِ
u'تَفْرِيقٌ أحَدٌ':Added, #1: 1	تَفْرِيقَ أَحَدِ
u'تَفْرِيقٌ أَحْكَامٌ':Added, #1: 1	تَفْرِيقِ أَحَدِ
u'تَفْرِيقٌ أَعْضَاءٌ':Added, #1: 1	تَفْرِيقِ الْأَحْكَامِ
u'تَفْرِيقٌ أَفْعَالٌ':Added, #1: 1	تَفْرِيقِ أَعْضَاءِ
u'تَفْرِيقٌ أَفْعَالٌ':Added, #1: 1	تَفْرِيقُ أَفْعَالِ
u'تَفْرِيقٌ أَمْوَالٌ':Added, #1: 1	تَفْرِيقِ الْأَفْعَالِ
u'تَفْرِيقٌ إيقَاعٌ':Added, #1: 1	تَفْرِيقُ أَمْوَالِ
u'تَفْرِيقٌ ثَلاثُ':Added, #2: 2	تَفْرِيقُ الْإِيقَاعِ
u'تَفْرِيقٌ ثَمَنٌ':Added, #1: 1	تَفْرِيقُ الثَّلَاثِ
u'تَفْرِيقٌ جمعة':Added, #1: 1	تَفْرِيقِ الثَّمَنِ
u'تَفْرِيقٌ جُمُعَةٌ':Added, #2: 2	تَفْرِيقِ الْجُمُعَةِ
u'تَفْرِيقٌ حاكِمٌ':Added, #2: 2	تَفْرِيقِ الْجُمُعَةِ
u'تَفْرِيقٌ حاكِمٌ':Added, #1: 1	تَفْرِيقِ حَاكِمٍ
u'تَفْرِيقٌ حَديثٌ':Added, #3: 3	تَفْرِيقِ الْحَاكِمِ
u'تَفْرِيقٌ حِصَّةٌ':Added, #1: 1	تَفْرِيقِ الْحَدِيثِ
u'تَفْرِيقٌ حِصَّةٌ':Added, #1: 1	تَفْرِيقَ حِصَّةِ
u'تَفْرِيقٌ حُكْمٌ':Added, #1: 1	تَفْرِيقِ حِصَّةٍ
u'تَفْرِيقٌ حَلْقٌ':Added, #1: 1	تَفْرِيقُ حُكْمٍ
u'تَفْرِيقٌ خُمُسٌ':Added, #1: 1	تَفْرِيقَ الْحَلْقِ
u'تَفْرِيقٌ خُمُسٌ':Added, #1: 1	تَفْرِيقُ الْخُمُسِ
u'تَفْرِيقٌ رَبُّ':Added, #1: 1	تَفْرِيقِ الْخُمُسِ
u'تَفْرِيقٌ زَكاةٌ':Added, #1: 1	تَفْرِيقِ رَبِّ
u'تَفْرِيقٌ زَكاةٌ':Added, #1: 1	تَفْرِيقَ الزَّكَاةِ
u'تَفْرِيقٌ زَكاةٌ':Added, #1: 1	تَفْرِيقُ الزَّكَاةِ
u'تَفْرِيقٌ زَكاةٌ':Added, #1: 1	تَفْرِيقُ زَكَاةِ
u'تَفْرِيقٌ سَاعَةٌ':Added, #2: 2	تَفْرِيقِ الزَّكَاةِ
u'تَفْرِيقٌ شَعْرٌ':Added, #1: 1	تَفْرِيقُ سَاعَاتِهِ
u'تَفْرِيقٌ شَعْرٌ':Added, #1: 1	تَفْرِيقُ الشَّعْرِ
u'تَفْرِيقٌ صدقة':Added, #1: 1	تَفْرِيقُ شَعْرِ
u'تَفْرِيقٌ صَدَقَةٌ':Added, #1: 1	تَفْرِيقِ صَدَقَةِ
u'تَفْرِيقٌ صَفْقَةٌ':Added, #1: 1	تَفْرِيقِ صَدَقَةِ
u'تَفْرِيقٌ صَفْقَةٌ':Added, #142: 142	تَفْرِيقِ الصَّفْقَةِ
u'تَفْرِيقٌ صَفْقَةٌ':Added, #15: 15	تَفْرِيقَ الصَّفْقَةِ
u'تَفْرِيقٌ صَفْقَةٌ':Added, #3: 3	تَفْرِيق الصَّفْقَةِ
u'تَفْرِيقٌ صَوْمٌ':Added, #56: 56	تَفْرِيقُ الصَّفْقَةِ
u'تَفْرِيقٌ ضَرْبٌ':Added, #1: 1	تَفْرِيقِ صَوْمٍ
u'تَفْرِيقٌ طَلاَقٌ':Added, #1: 1	تَفْرِيقُ الضَّرْبِ
u'تَفْرِيقٌ طَلاَقٌ':Added, #2: 2	تَفْرِيقَ الطَّلَاقِ
u'تَفْرِيقٌ عَامِدٌ':Added, #4: 4	تَفْرِيقِ الطَّلَاقِ
u'تَفْرِيقٌ عَقْدٌ':Added, #1: 1	تَفْرِيقِ الْعَامِدِ
u'تَفْرِيقٌ عَقْدٌ':Added, #1: 1	تَفْرِيقَ الْعَقْدِ
u'تَفْرِيقٌ غُسْلٌ':Added, #1: 1	تَفْرِيقُ الْعَقْدِ
u'تَفْرِيقٌ فَاحِشٌ':Added, #1: 1	تَفْرِيقِ الْغُسْلِ
u'تَفْرِيقٌ فطرة':Added, #1: 1	تَفْرِيقٍ فَاحِشٍ
u'تَفْرِيقٌ فِطْرَةٌ':Added, #1: 1	تَفْرِيقَ الْفِطْرَةِ
u'تَفْرِيقٌ فِعْلٌ':Added, #1: 1	تَفْرِيقَ الْفِطْرَةِ
u'تَفْرِيقٌ قَبْضٌ':Added, #1: 1	تَفْرِيقُ الْفِعْلِ
u'تَفْرِيقٌ قَبُولٌ':Added, #1: 1	تَفْرِيقِ الْقَبْضِ
u'تَفْرِيقٌ قِرَاءةٌ':Added, #1: 1	تَفْرِيقِ الْقَبُولِ
u'تَفْرِيقٌ قَسْمٌ':Added, #1: 1	تَفْرِيقَ قِرَاءَةِ
u'تَفْرِيقٌ قَضَاءٌ':Added, #1: 1	تَفْرِيقِ الْقَسْمِ
u'تَفْرِيقٌ كَفَّارٌ':Added, #1: 1	تَفْرِيقُ قَضَاءِ
u'تَفْرِيقٌ كَفَّارَةٌ':Added, #1: 1	تَفْرِيقَ الْكَفَّارَةِ
u'تَفْرِيقٌ مَالٌ':Added, #1: 1	تَفْرِيقَ الْكَفَّارَةِ
u'تَفْرِيقٌ مَالِكٌ':Added, #1: 1	تَفْرِيقِ الْمَالَيْنِ
u'تَفْرِيقٌ مِلْكٌ':Added, #1: 1	تَفْرِيقِ الْمَالِكِ
u'تَفْرِيقٌ مِلْكٌ':Added, #1: 1	تَفْرِيقَ الْمِلْكِ
u'تَفْرِيقٌ مِلْكٌ':Added, #1: 1	تَفْرِيقُ مِلْكِ
u'تَفْرِيقٌ نَحْوٌ':Added, #3: 3	تَفْرِيقُ الْمِلْكِ
u'تَفْرِيقٌ نِيَّةٌ':Added, #1: 1	تَفْرِيقِ نَحْوِ
u'تَفْرِيقٌ نِيَّةٌ':Added, #1: 1	تَفْرِيقَ نِيَّةِ
u'تَفْرِيقٌ نِيَّةٌ':Added, #1: 1	تَفْرِيقِ نِيَّةِ
u'تَفْرِيقٌ نِيَّةٌ':Added, #1: 1	تَفْرِيقُ نِيَّتِهِ
u'تَفْرِيقٌ نِيَّةٌ':Added, #2: 2	تَفْرِيقِ النِّيَّةِ
u'تَفْرِيقٌ وَصِيٌّ':Added, #4: 4	تَفْرِيقُ النِّيَّةِ
u'تَفْرِيقٌ وَصِيَّةٌ':Added, #1: 1	تَفْرِيقُ الْوَصِيَّةِ
u'تَفْرِيقٌ وُضُوءٌ':Added, #1: 1	تَفْرِيقُ الْوَصِيَّةِ
u'تَفْرِيقٌ ولد':Added, #3: 3	تَفْرِيقِ الْوُضُوءِ
u'تَفْرِيقٌ وَلَدٌ':Added, #1: 1	تَفْرِيقِ الْوَلَدِ
u'تَفْرِيقٌ وَلِيٌّ':Added, #1: 1	تَفْرِيقِ الْوَلَدِ
u'تَفْرِيقٌ يَدٌ':Added, #1: 1	تَفْرِيقِ الْوَلِيِّ
u'تَفْرِيقٌ يَدٌ':Added, #1: 1	تَفْرِيقُ الْيَدِ
u'تَفَسَّخَ شَيْءٌ':Subject, #3: 3	تَفْرِيقِ الْيَدِ
u'تَفْسِيرٌ اِبْنٌ':Added, #1: 1	تَفَسَّخَ شَيْءٌ
u'تَفْسِيرٌ اِبْنٌ':Added, #29: 29	تَفْسِيرِ ابْنِ
u'تَفْسِيرٌ أَبْوَابٌ':Added, #47: 47	تَفْسِيرُ ابْنِ
u'تَفْسِيرٌ اِتِّصَالٌ':Added, #1: 1	تَفْسِيرِ أَبْوَابٍ
u'تَفْسِيرٌ إجَارَةٌ':Added, #1: 1	تَفْسِيرُ اتِّصَالِ
u'تَفْسِيرٌ أَجْزَاءٌ':Added, #1: 1	تَفْسِيرِ الْإِجَارَةِ
u'تَفْسِيرٌ إِجْمَاعٌ':Added, #1: 1	تَفْسِيرِ الْأَجْزَاءِ
u'تَفْسِيرٌ إِحْرَازٌ':Added, #1: 1	تَفْسِيرَ إجْمَاعِ
u'تَفْسِيرٌ أحْزَابٌ':Added, #1: 1	تَفْسِيرُ الْإِحْرَازِ
u'تَفْسِيرٌ أحْزَابٌ':Added, #1: 1	تَفْسِيرِ الْأَحْزَابِ
u'تَفْسِيرٌ إِحْصَاءٌ':Added, #8: 8	تَفْسِيرِ الأَحْزَابِ
u'تَفْسِيرٌ إِحْلاَلٌ':Added, #1: 1	تَفْسِيرِ الْإِحْصَاءِ
u'تَفْسِيرٌ أَخَصُّ':Added, #1: 1	تَفْسِيرِ الْإِحْلَالِ
u'تَفْسِيرٌ أَخَصُّ':Added, #1: 1	تَفْسِيرُ الْأَخَصِّ
u'تَفْسِيرٌ أَخْمَاسٌ':Added, #1: 1	تَفْسِيرِ الْأَخَصِّ
u'تَفْسِيرٌ إِدْمَانٌ':Added, #1: 1	تَفْسِيرَ الأَخْمَاسِ
u'تَفْسِيرٌ إِذْنٌ':Added, #1: 1	تَفْسِيرِ الْإِدْمَانِ
u'تَفْسِيرٌ أرْضٌ':Added, #1: 1	تَفْسِيرِ الْإِذْنِ
u'تَفْسِيرٌ إِسْراءٌ':Added, #1: 1	تَفْسِيرِ أَرْضِ
u'تَفْسِيرٌ إِسْقاطٌ':Added, #2: 2	تَفْسِيرِ الإِسْرَاءِ
u'تَفْسِيرٌ أسْنَانٌ':Added, #1: 1	تَفْسِيرِ إسْقَاطِ
u'تَفْسِيرٌ أسْنَانٌ':Added, #1: 1	تَفْسِيرَ أَسْنَانِ
u'تَفْسِيرٌ أَشَدُّ':Added, #1: 1	تَفْسِيرِ أَسْنَانِ
u'تَفْسِيرٌ أَشْرِبَةٌ':Added, #1: 1	تَفْسِيرِ الْأَشَدِّ
u'تَفْسِيرٌ أَصْحَابٌ':Added, #2: 2	تَفْسِيرِ الْأَشْرِبَةِ
u'تَفْسِيرٌ إِصْرارٌ':Added, #1: 1	تَفْسِيرُ الْأَصْحَابِ
u'تَفْسِيرٌ إِصْرارٌ':Added, #1: 1	تَفْسِيرُ الْإِصْرَارِ
u'تَفْسِيرٌ إِطْلاقٌ':Added, #3: 3	تَفْسِيرِ الْإِصْرَارِ
u'تَفْسِيرٌ أَعْرَافٌ':Added, #1: 1	تَفْسِيرَ إطْلَاقِ
u'تَفْسِيرٌ أَعَمُّ':Added, #4: 4	تَفْسِيرِ الأَعْرَافِ
u'تَفْسِيرٌ أَلْسُنٌ':Added, #1: 1	تَفْسِيرِ الْأَعَمِّ
u'تَفْسِيرٌ ألف':Added, #1: 1	تَفْسِيرُ الْأَلْسُنِ
u'تَفْسِيرٌ ألْفٌ':Added, #1: 1	تَفْسِيرَ الْأَلْفِ
u'تَفْسِيرٌ أَلْفٌ':Added, #1: 1	تَفْسِيرَ الْأَلْفِ
u'تَفْسِيرٌ ألف':Added, #1: 1	تَفْسِيرَ الْأَلْفِ
u'تَفْسِيرٌ ألْفٌ':Added, #3: 3	تَفْسِيرِ الْأَلْفِ
u'تَفْسِيرٌ أَلْفٌ':Added, #3: 3	تَفْسِيرِ الْأَلْفِ
u'تَفْسِيرٌ إِلْقَاءٌ':Added, #3: 3	تَفْسِيرِ الْأَلْفِ
u'تَفْسِيرٌ إِلْمَامٌ':Added, #1: 1	تَفْسِيرِ الْإِلْقَاءِ
u'تَفْسِيرٌ إمَامٌ':Added, #1: 1	تَفْسِيرُ الْإِلْمَامِ
u'تَفْسِيرٌ إمَامٌ':Added, #1: 1	تَفْسِيرُ الْإِمَامِ
u'تَفْسِيرٌ اِمْتِحَانٌ':Added, #1: 1	تَفْسِيرِ الْإِمَامِ
u'تَفْسِيرٌ أمثال':Added, #1: 1	تَفْسِيرِ الامْتِحَانِ
u'تَفْسِيرٌ أَمْثَالٌ':Added, #1: 1	تَفْسِيرِ الأَمْثَالِ
u'تَفْسِيرٌ أَمْرٌ':Added, #1: 1	تَفْسِيرِ الأَمْثَالِ
u'تَفْسِيرٌ أَمْرٌ':Added, #1: 1	تَفْسِيرِ الْأَمْرِ
u'تَفْسِيرٌ أَمْرٌ':Added, #1: 1	تَفْسِيرُ أَمْرِ
u'تَفْسِيرٌ أَمْنٌ':Added, #2: 2	تَفْسِيرُ الْأَمْرِ
u'تَفْسِيرٌ آنَاءٌ':Added, #1: 1	تَفْسِيرِ الْأَمْنِ
u'تَفْسِيرٌ أَنْعامٌ':Added, #1: 1	تَفْسِيرِ آنَاءِ
u'تَفْسِيرٌ أَنْعَامٌ':Added, #1: 1	تَفْسِيرِ الأَنْعَامِ
u'تَفْسِيرٌ أَنْفالٌ':Added, #1: 1	تَفْسِيرِ الأَنْعَامِ
u'تَفْسِيرٌ أَنْفَالٌ':Added, #2: 2	تَفْسِيرِ الأَنْفَالِ
u'تَفْسِيرٌ أَنْفَعُ':Added, #2: 2	تَفْسِيرِ الأَنْفَالِ
u'تَفْسِيرٌ أهْلٌ':Added, #1: 1	تَفْسِيرُ الْأَنْفَعِ
u'تَفْسِيرٌ أَوْقَاتٌ':Added, #1: 1	تَفْسِيرُ أَهْلِ
u'تَفْسِيرٌ أَوْقَاتٌ':Added, #1: 1	تَفْسِيرُ الأَوْقَاتِ
u'تَفْسِيرٌ أَوَّلُ':Added, #1: 1	تَفْسِيرِ الأَوْقَاتِ
u'تَفْسِيرٌ أَوَّلُ':Added, #1: 1	تَفْسِيرَ الْأَوَّلِ
u'تَفْسِيرٌ أئِمَّةٌ':Added, #2: 2	تَفْسِيرُ الْأَوَّلِ
u'تَفْسِيرٌ آيَةٌ':Added, #1: 1	تَفْسِيرِ أَئِمَّةِ
u'تَفْسِيرٌ آيَةٌ':Added, #14: 14	تَفْسِيرِ الْآيَةِ
u'تَفْسِيرٌ آيَةٌ':Added, #1: 1	تَفْسِيرُ الْآيَةِ
u'تَفْسِيرٌ آيَةٌ':Added, #1: 1	تَفْسِيرِ آيَةٍ
u'تَفْسِيرٌ إِيدَاعٌ':Added, #1: 1	تَفْسِيرِ آيَةِ
u'تَفْسِيرٌ إيمَانٌ':Added, #1: 1	تَفْسِيرِ الْإِيدَاعِ
u'تَفْسِيرٌ بَاضِعٌ':Added, #3: 3	تَفْسِيرِ الْإِيمَانِ
u'تَفْسِيرٌ بِدْعَةٌ':Added, #3: 3	تَفْسِيرِ الْبَاضِعَةِ
u'تَفْسِيرٌ بَذْلٌ':Added, #1: 1	تَفْسِيرِ الْبِدْعَةِ
u'تَفْسِيرٌ بَعْضٌ':Added, #1: 1	تَفْسِيرُ الْبَذْلِ
u'تَفْسِيرٌ بَعْضٌ':Added, #2: 2	تَفْسِيرُ بَعْضِ
u'تَفْسِيرٌ بُغاةٌ':Added, #3: 3	تَفْسِيرِ بَعْضِ
u'تَفْسِيرٌ بَقَرٌ':Added, #1: 1	تَفْسِيرِ الْبُغَاةِ
u'تَفْسِيرٌ بُلُوغٌ':Added, #9: 9	تَفْسِيرِ الْبَقَرَةِ
u'تَفْسِيرٌ بَيْضاوِيّ':Added, #1: 1	تَفْسِيرِ الْبُلُوغِ
u'تَفْسِيرٌ بَيْعٌ':Added, #2: 2	تَفْسِيرِ الْبَيْضَاوِيِّ
u'تَفْسِيرٌ بَيْعٌ':Added, #1: 1	تَفْسِيرَ بَيْعِ
u'تَفْسِيرٌ بَيِّنَةٌ':Added, #1: 1	تَفْسِيرِ بَيْعِ
u'تَفْسِيرٌ تَابِعِيٌّ':Added, #1: 1	تَفْسِيرِ بَيِّنَةِ
u'تَفْسِيرٌ تَثْنِيَةٌ':Added, #2: 2	تَفْسِيرِ التَّابِعِيِّ
u'تَفْسِيرٌ تَثْنِيَةٌ':Added, #1: 1	تَفْسِيرُ التَّثْنِيَةِ
u'تَفْسِيرٌ تَحَالُفٌ':Added, #1: 1	تَفْسِيرِ التَّثْنِيَةِ
u'تَفْسِيرٌ تَحْرِيمٌ':Added, #2: 2	تَفْسِيرُ التَّحَالُفِ
u'تَفْسِيرٌ تَحْقِيقٌ':Added, #5: 5	تَفْسِيرِ التَّحْرِيمِ
u'تَفْسِيرٌ تَحْكِيمٌ':Added, #1: 1	تَفْسِيرِ التَّحْقِيقِ
u'تَفْسِيرٌ تَحِيَّةٌ':Added, #1: 1	تَفْسِيرُ التَّحْكِيمِ
u'تَفْسِيرٌ تَحِيَّةٌ':Added, #1: 1	تَفْسِيرِ التَّحِيَّاتِ
u'تَفْسِيرٌ تَخْلِيَة':Added, #1: 1	تَفْسِيرُ التَّحِيَّةِ
u'تَفْسِيرٌ تَدْلِيس':Added, #1: 1	تَفْسِيرِ التَّخْلِيَةِ
u'تَفْسِيرٌ تَشْهِيرٌ':Added, #1: 1	تَفْسِيرُ التَّدْلِيسِ
u'تَفْسِيرٌ تَعْرِيضٌ':Added, #1: 1	تَفْسِيرُ التَّشْهِيرِ
u'تَفْسِيرٌ تَعَلُّقٌ':Added, #1: 1	تَفْسِيرِ التَّعْرِيضِ
u'تَفْسِيرٌ تَعْيِينٌ':Added, #1: 1	تَفْسِيرِ تَعَلُّقِ
u'تَفْسِيرٌ تَغَابُنٌ':Added, #1: 1	تَفْسِيرِ التَّعْيِينِ
u'تَفْسِيرٌ تَفْرِيقٌ':Added, #1: 1	تَفْسِيرِ التَّغَابُنِ
u'تَفْسِيرٌ تَقْديمٌ':Added, #1: 1	تَفْسِيرِ التَّفْرِيقِ
u'تَفْسِيرٌ تَقْيِيد':Added, #1: 1	تَفْسِيرَ التَّقْدِيمِ
u'تَفْسِيرٌ تَكْليفٌ':Added, #1: 1	تَفْسِيرَ التَّقْيِيدِ
u'تَفْسِيرٌ تَهْلُكَةٌ':Added, #2: 2	تَفْسِيرِ التَّكْلِيفِ
u'تَفْسِيرٌ تَوَقُّفٌ':Added, #1: 1	تَفْسِيرِ التَّهْلُكَةِ
u'تَفْسِيرٌ ثَمَنٌ':Added, #1: 1	تَفْسِيرُ التَّوَقُّفِ
u'تَفْسِيرٌ ثَوْبٌ':Added, #1: 1	تَفْسِيرَ الثَّمَنِ
u'تَفْسِيرٌ جَابِرٌ':Added, #1: 1	تَفْسِيرِ الثَّوْبِ
u'تَفْسِيرٌ جَائِزٌ':Added, #3: 3	تَفْسِيرَ جَابِرٍ
u'تَفْسِيرٌ جَبْرٌ':Added, #2: 2	تَفْسِيرُ الْجَائِزِ
u'تَفْسِيرٌ جِدال':Added, #3: 3	تَفْسِيرُ الْجَبْرِ
u'تَفْسِيرٌ جِدال':Added, #1: 1	تَفْسِيرَ الْجِدَالِ
u'تَفْسِيرٌ جَذَعٌ':Added, #1: 1	تَفْسِيرِ الْجِدَالِ
u'تَفْسِيرٌ جَمَاعَةٌ':Added, #1: 1	تَفْسِيرِ الْجَذَعِ
u'تَفْسِيرٌ حاقٌّ':Added, #1: 1	تَفْسِيرِ الْجَمَاعَةِ
u'تَفْسِيرٌ حائِلٌ':Added, #3: 3	تَفْسِيرِ الْحَاقَّةِ
u'تَفْسِيرٌ حائِلٌ':Added, #1: 1	تَفْسِيرُ الْحَائِلِ
u'تَفْسِيرٌ حَجٌّ':Added, #1: 1	تَفْسِيرِ الْحَائِلِ
u'تَفْسِيرٌ حَجَرٌ':Added, #12: 12	تَفْسِيرِ الْحَجِّ
u'تَفْسِيرٌ حِجْرٌ':Added, #1: 1	تَفْسِيرِ الْحَجَرِ
u'تَفْسِيرٌ حُجُراتٌ':Added, #2: 2	تَفْسِيرِ الْحِجْرِ
u'تَفْسِيرٌ حَديثٌ':Added, #1: 1	تَفْسِيرِ الْحُجُرَاتِ
u'تَفْسِيرٌ حَديثٌ':Added, #1: 1	تَفْسِيرُ الْحَدِيثِ
u'تَفْسِيرٌ حَديثٌ':Added, #1: 1	تَفْسِيرَ حَدِيثِ
u'تَفْسِيرٌ حَديثٌ':Added, #4: 4	تَفْسِيرِ الْحَدِيثِ
u'تَفْسِيرٌ حَديدٌ':Added, #6: 6	تَفْسِيرِ حَدِيثِ
u'تَفْسِيرٌ حَسَنٌ':Added, #2: 2	تَفْسِيرِ الْحَدِيدِ
u'تَفْسِيرٌ حُسْنٌ':Added, #1: 1	تَفْسِيرُ الْحَسَنِ
u'تَفْسِيرٌ حُسْنٌ':Added, #1: 1	تَفْسِيرِ الْحُسْنِ
u'تَفْسِيرٌ حَسِيبٌ':Added, #1: 1	تَفْسِيرِ حُسْنِ
u'تَفْسِيرٌ حَشْرٌ':Added, #1: 1	تَفْسِيرِ الْحَسِيبِ
u'تَفْسِيرٌ حَقٌّ':Added, #1: 1	تَفْسِيرِ الْحَشْرِ
u'تَفْسِيرٌ حُكْمٌ':Added, #1: 1	تَفْسِيرَ الْحَقِّ
u'تَفْسِيرٌ حُكْمٌ':Added, #1: 1	تَفْسِيرُ الْحُكْمِ
u'تَفْسِيرٌ حكمة':Added, #2: 2	تَفْسِيرِ الْحُكْمِ
u'تَفْسِيرٌ حِكْمَةٌ':Added, #1: 1	تَفْسِيرُ الْحِكْمَةِ
u'تَفْسِيرٌ حُكُومَةٌ':Added, #1: 1	تَفْسِيرُ الْحِكْمَةِ
u'تَفْسِيرٌ حُكُومَةٌ':Added, #1: 1	تَفْسِيرُ حُكُومَةِ
u'تَفْسِيرٌ حُكُومَةٌ':Added, #1: 1	تَفْسِيرِ حُكُومَةِ
u'تَفْسِيرٌ حَلالٌ':Added, #2: 2	تَفْسِيرُ الْحُكُومَةِ
u'تَفْسِيرٌ حَيَاةٌ':Added, #1: 1	تَفْسِيرِ الْحَلَالِ
u'تَفْسِيرٌ خَبَرٌ':Added, #1: 1	تَفْسِيرُ الْحَيَاةِ
u'تَفْسِيرٌ خَبَر':Added, #1: 1	تَفْسِيرِ الْخَبَرِ
u'تَفْسِيرٌ خِطَابٌ':Added, #1: 1	تَفْسِيرِ الْخَبَرِ
u'تَفْسِيرٌ خطر':Added, #1: 1	تَفْسِيرِ الْخِطَابِ
u'تَفْسِيرٌ خَطَرٌ':Added, #1: 1	تَفْسِيرُ الْخَطَرِ
u'تَفْسِيرٌ خلاص':Added, #1: 1	تَفْسِيرُ الْخَطَرِ
u'تَفْسِيرٌ خَلاَصٌ':Added, #1: 1	تَفْسِيرَ الْخَلَاصِ
u'تَفْسِيرٌ خِلْف':Added, #1: 1	تَفْسِيرَ الْخَلَاصِ
u'تَفْسِيرٌ خِلْفَة':Added, #1: 1	تَفْسِيرِ الْخِلْفَةِ
u'تَفْسِيرٌ خُلُوصٌ':Added, #1: 1	تَفْسِيرِ الْخِلْفَةِ
u'تَفْسِيرٌ خَمْرٌ':Added, #1: 1	تَفْسِيرِ الْخُلُوصِ
u'تَفْسِيرٌ دُخَانٌ':Added, #1: 1	تَفْسِيرِ الْخَمْرِ
u'تَفْسِيرٌ دَرَكٌ':Added, #1: 1	تَفْسِيرِ الدُّخَانِ
u'تَفْسِيرٌ دَلالَةٌ':Added, #1: 1	تَفْسِيرُ الدَّرَكِ
u'تَفْسِيرٌ دَلْوٌ':Added, #1: 1	تَفْسِيرِ الدَّلَالَةِ
u'تَفْسِيرٌ دَمٌ':Added, #1: 1	تَفْسِيرِ الدَّلْوِ
u'تَفْسِيرٌ دِيَةٌ':Added, #1: 1	تَفْسِيرُ الدَّمِ
u'تَفْسِيرٌ دِينِيٌّ':Added, #1: 1	تَفْسِيرِ الدِّيَةِ
u'تَفْسِيرٌ ذاتِيٌّ':Added, #1: 1	تَفْسِيرِ الدِّينِيَّةِ
u'تَفْسِيرٌ ذَكاةٌ':Added, #1: 1	تَفْسِيرِ الذَّاتِيِّ
u'تَفْسِيرٌ رُجُوعٌ':Added, #1: 1	تَفْسِيرِ الذَّكَاةِ
u'تَفْسِيرٌ رحمة':Added, #1: 1	تَفْسِيرُ الرُّجُوعِ
u'تَفْسِيرٌ رَحْمَةٌ':Added, #1: 1	تَفْسِيرِ الرَّحْمَةِ
u'تَفْسِيرٌ رَحْمَن':Added, #1: 1	تَفْسِيرِ الرَّحْمَةِ
u'تَفْسِيرٌ رَفَثِ':Added, #1: 1	تَفْسِيرِ الرَّحْمَنِ
u'تَفْسِيرٌ رَفَث':Added, #1: 1	تَفْسِيرِ الرَّفَثِ
u'تَفْسِيرٌ رَهْنٌ':Added, #1: 1	تَفْسِيرِ الرَّفَثِ
u'تَفْسِيرٌ رِوايَةٌ':Added, #1: 1	تَفْسِيرِ الرَّهْنِ
u'تَفْسِيرٌ روحٌ':Added, #1: 1	تَفْسِيرِ الرِّوَايَةِ
u'تَفْسِيرٌ رُومٌ':Added, #1: 1	تَفْسِيرِ الرُّوحِ
u'تَفْسِيرٌ رُؤْيَةٌ':Added, #1: 1	تَفْسِيرِ الرُّومِ
u'تَفْسِيرٌ زَبانِيَةٌ':Added, #1: 1	تَفْسِيرَ الرُّؤْيَةِ
u'تَفْسِيرٌ زَجَّاجٌ':Added, #1: 1	تَفْسِيرِ الزّبَانِيَةِ
u'تَفْسِيرٌ زَكاةٌ':Added, #2: 2	تَفْسِيرِ الزَّجَّاجِ
u'تَفْسِيرٌ زمر':Added, #1: 1	تَفْسِيرُ الزَّكَاةِ
u'تَفْسِيرٌ زمر':Added, #1: 1	تَفْسِيرِ الزُّمَرِ
u'تَفْسِيرٌ زُمَرٌ':Added, #1: 1	تَفْسِيرِ الزُّمُرِ
u'تَفْسِيرٌ زَهْوٌ':Added, #1: 1	تَفْسِيرِ الزُّمَرِ
u'تَفْسِيرٌ سَائِرٌ':Added, #1: 1	تَفْسِيرِ الزَّهْوِ
u'تَفْسِيرٌ سَائِمَةٌ':Added, #1: 1	تَفْسِيرُ سَائِرِ
u'تَفْسِيرٌ سَبْعٌ':Added, #1: 1	تَفْسِيرُ السَّائِمَةِ
u'تَفْسِيرٌ سَبِيلٌ':Added, #1: 1	تَفْسِيرِ السَّبْعِ
u'تَفْسِيرٌ سَبِيلٌ':Added, #1: 1	تَفْسِيرَ السَّبِيلِ
u'تَفْسِيرٌ سَبِيلٌ':Added, #1: 1	تَفْسِيرُ السَّبِيلِ
u'تَفْسِيرٌ سَرقَةٌ':Added, #1: 1	تَفْسِيرِ السَّبِيلِ
u'تَفْسِيرٌ سَرِقَةٌ':Added, #1: 1	تَفْسِيرِ السَّرِقَةِ
u'تَفْسِيرٌ سِعَايَةٌ':Added, #1: 1	تَفْسِيرِ السَّرِقَةِ
u'تَفْسِيرٌ سَعْدٌ':Added, #1: 1	تَفْسِيرِ السِّعَايَةِ
u'تَفْسِيرٌ سَعِيدٌ':Added, #1: 1	تَفْسِيرُ سَعْدٍ
u'تَفْسِيرٌ سُنَّةٌ':Added, #2: 2	تَفْسِيرِ سَعِيدِ
u'تَفْسِيرٌ سُورَةٌ':Added, #2: 2	تَفْسِيرِ السُّنَّةِ
u'تَفْسِيرٌ سُورَةٌ':Added, #1: 1	تَفْسِيرُ سُورَةِ
u'تَفْسِيرٌ شافِعِيّ':Added, #42: 42	تَفْسِيرِ سُورَةِ
u'تَفْسِيرٌ شَرْطٌ':Added, #1: 1	تَفْسِيرِ الشَّافِعِيِّ
u'تَفْسِيرٌ شركة':Added, #1: 1	تَفْسِيرُ شَرْطِ
u'تَفْسِيرٌ شَرِكَةٌ':Added, #1: 1	تَفْسِيرَ شَرِكَةِ
u'تَفْسِيرٌ شَطْرٌ':Added, #1: 1	تَفْسِيرَ شَرِكَةِ
u'تَفْسِيرٌ شِعْرٌ':Added, #1: 1	تَفْسِيرِ الشّطْرِ
u'تَفْسِيرٌ شَيْءٌ':Added, #3: 3	تَفْسِيرِ شِعْرِ
u'تَفْسِيرٌ شَيْخٌ':Added, #1: 1	تَفْسِيرِ شَيْءٍ
u'تَفْسِيرٌ صَاعٌ':Added, #1: 1	تَفْسِيرَ الشَّيْخِ
u'تَفْسِيرٌ صَحَابَةٌ':Added, #1: 1	تَفْسِيرَ الصَّاعِ
u'تَفْسِيرٌ صَحَابِيٌّ':Added, #1: 1	تَفْسِيرِ الصَّحَابَةِ
u'تَفْسِيرٌ صَحَابِيٌّ':Added, #1: 1	تَفْسِيرَ الصَّحَابِيِّ
u'تَفْسِيرٌ صَحَابِيٌّ':Added, #1: 1	تَفْسِيرُ صَحَابِيٍّ
u'تَفْسِيرٌ صَحَابِيٌّ':Added, #2: 2	تَفْسِيرُ الصَّحَابِيِّ
u'تَفْسِيرٌ صِحَّةٌ':Added, #2: 2	تَفْسِيرِ الصَّحَابِيِّ
u'تَفْسِيرٌ صفر':Added, #3: 3	تَفْسِيرِ الصِّحَّةِ
u'تَفْسِيرٌ صَفَرٌ':Added, #1: 1	تَفْسِيرُ الصَّفَرِ
u'تَفْسِيرٌ صُورَةٌ':Added, #1: 1	تَفْسِيرُ الصَّفَرِ
u'تَفْسِيرٌ صَوْمٌ':Added, #1: 1	تَفْسِيرِ الصُّورَةِ
u'تَفْسِيرٌ ضَرْبٌ':Added, #1: 1	تَفْسِيرِ الصَّوْمِ
u'تَفْسِيرٌ ضَرْبٌ':Added, #1: 1	تَفْسِيرُ الضَّرْبِ
u'تَفْسِيرٌ ضِغْثٌ':Added, #1: 1	تَفْسِيرِ الضَّرْبِ
u'تَفْسِيرٌ ضَمَانٌ':Added, #1: 1	تَفْسِيرِ الضِّغْثِ
u'تَفْسِيرٌ ضَمَانٌ':Added, #1: 1	تَفْسِيرُ ضَمَانِ
u'تَفْسِيرٌ ضِيقٌ':Added, #1: 1	تَفْسِيرِ ضَمَانِ
u'تَفْسِيرٌ طَاعُونٌ':Added, #1: 1	تَفْسِيرُ ضِيقِ
u'تَفْسِيرٌ طَبَرِيّ':Added, #1: 1	تَفْسِيرُ الطَّاعُونِ
u'تَفْسِيرٌ طَلاَقٌ':Added, #2: 2	تَفْسِيرِ الطَّبَرِيِّ
u'تَفْسِيرٌ طَلْقٌ':Added, #1: 1	تَفْسِيرِ الطَّلاقِ
u'تَفْسِيرٌ طهر':Added, #1: 1	تَفْسِيرِ الطَّلْقِ
u'تَفْسِيرٌ طُهْرٌ':Added, #1: 1	تَفْسِيرُ الطُّهْرِ
u'تَفْسِيرٌ طُولٌ':Added, #1: 1	تَفْسِيرُ الطُّهْرِ
u'تَفْسِيرٌ طَوِيلٌ':Added, #1: 1	تَفْسِيرُ الطُّولِ
u'تَفْسِيرٌ عارِيَّةٌ':Added, #1: 1	تَفْسِيرِ الطَّوِيلِ
u'تَفْسِيرٌ عَاصِمٌ':Added, #1: 1	تَفْسِيرِ الْعَارِيَّةِ
u'تَفْسِيرٌ عَامٌّ':Added, #1: 1	تَفْسِيرِ عَاصِمِ
u'تَفْسِيرٌ عَبَثٌ':Added, #1: 1	تَفْسِيرِ الْعَامِّ
u'تَفْسِيرٌ عَبْدٌ':Added, #1: 1	تَفْسِيرِ الْعَبَثِ
u'تَفْسِيرٌ عَجَبٌ':Added, #2: 2	تَفْسِيرِ عَبْدِ
u'تَفْسِيرٌ عجز':Added, #1: 1	تَفْسِيرُ الْعَجَبِ
u'تَفْسِيرٌ عَجْزٌ':Added, #1: 1	تَفْسِيرِ الْعَجْزِ
u'تَفْسِيرٌ عَدْلٌ':Added, #1: 1	تَفْسِيرِ الْعَجْزِ
u'تَفْسِيرٌ عَزْمٌ':Added, #3: 3	تَفْسِيرِ الْعَدْلِ
u'تَفْسِيرٌ عَصَبٌ':Added, #1: 1	تَفْسِيرِ الْعَزْمِ
u'تَفْسِيرٌ عفر':Added, #1: 1	تَفْسِيرِ الْعَصَبِ
u'تَفْسِيرٌ عَفَرٌ':Added, #1: 1	تَفْسِيرَ الْعَفَرِ
u'تَفْسِيرٌ عَفْوٌ':Added, #1: 1	تَفْسِيرَ الْعَفَرِ
u'تَفْسِيرٌ عقبة':Added, #1: 1	تَفْسِيرِ الْعَفْوِ
u'تَفْسِيرٌ عَقَبَةٌ':Added, #1: 1	تَفْسِيرِ عَقَبَةِ
u'تَفْسِيرٌ عَقْدٌ':Added, #1: 1	تَفْسِيرِ عَقَبَةِ
u'تَفْسِيرٌ عقر':Added, #1: 1	تَفْسِيرُ الْعَقْدِ
u'تَفْسِيرٌ عُقْرٌ':Added, #2: 2	تَفْسِيرُ الْعُقْرِ
u'تَفْسِيرٌ عَقْلٌ':Added, #2: 2	تَفْسِيرُ الْعُقْرِ
u'تَفْسِيرٌ عِلَّةٌ':Added, #3: 3	تَفْسِيرُ الْعَقْلِ
u'تَفْسِيرٌ علم':Added, #4: 4	تَفْسِيرِ الْعِلَّةِ
u'تَفْسِيرٌ علم':Added, #1: 1	تَفْسِيرُ الْعِلْمِ
u'تَفْسِيرٌ عِلْمٌ':Added, #1: 1	تَفْسِيرِ الْعِلْمِ
u'تَفْسِيرٌ عِلْمٌ':Added, #1: 1	تَفْسِيرُ الْعِلْمِ
u'تَفْسِيرٌ علماء':Added, #1: 1	تَفْسِيرِ الْعِلْمِ
u'تَفْسِيرٌ عُلَمَاءُ':Added, #1: 1	تَفْسِيرُ عُلَمَاءِ
u'تَفْسِيرٌ عمرة':Added, #1: 1	تَفْسِيرُ عُلَمَاءِ
u'تَفْسِيرٌ عُمْرَةٌ':Added, #3: 3	تَفْسِيرُ الْعُمْرَةِ
u'تَفْسِيرٌ عَوْل':Added, #3: 3	تَفْسِيرُ الْعُمْرَةِ
u'تَفْسِيرٌ غَافِرٌ':Added, #1: 1	تَفْسِيرَ الْعَوْلِ
u'تَفْسِيرٌ غَبَنٌ':Added, #1: 1	تَفْسِيرِ غَافِرٍ
u'تَفْسِيرٌ غَبْنٌ':Added, #1: 1	تَفْسِيرِ الْغَبَنِ
u'تَفْسِيرٌ غَرَرٌ':Added, #1: 1	تَفْسِيرِ الْغَبْنِ
u'تَفْسِيرٌ غَرِيبٌ':Added, #1: 1	تَفْسِيرَ الْغَرَرِ
u'تَفْسِيرٌ غَسْلٌ':Added, #1: 1	تَفْسِيرِ غَرِيبِ
u'تَفْسِيرٌ غِشٌّ':Added, #1: 1	تَفْسِيرُ الْغَسْلِ
u'تَفْسِيرٌ غَصْبٌ':Added, #1: 1	تَفْسِيرُ الْغِشِّ
u'تَفْسِيرٌ غِلاَفٌ':Added, #1: 1	تَفْسِيرِ الْغَصْبِ
u'تَفْسِيرٌ غَلَبَةٌ':Added, #1: 1	تَفْسِيرِ الْغِلَافِ
u'تَفْسِيرٌ غَلِيظٌ':Added, #1: 1	تَفْسِيرُ الْغَلَبَةِ
u'تَفْسِيرٌ غِيَارٌ':Added, #1: 1	تَفْسِيرِ الْغَلِيظَةِ
u'تَفْسِيرٌ غِيبَةٌ':Added, #1: 1	تَفْسِيرِ الْغِيَارِ
u'تَفْسِيرٌ غير':Added, #1: 1	تَفْسِيرِ الْغِيبَةِ
u'تَفْسِيرٌ غَيْرٌ':Added, #1: 1	تَفْسِيرُ غَيْرِهِ
u'تَفْسِيرٌ غير':Added, #1: 1	تَفْسِيرُ غَيْرِهِ
u'تَفْسِيرٌ غَيْرٌ':Added, #2: 2	تَفْسِيرِ غَيْرِهِ
u'تَفْسِيرٌ فَاتِحٌ':Added, #2: 2	تَفْسِيرِ غَيْرِهِ
u'تَفْسِيرٌ فَاتِحٌ':Added, #1: 1	تَفْسِيرَ الْفَاتِحَةِ
u'تَفْسِيرٌ فَاتِحَةٌ':Added, #5: 5	تَفْسِيرِ الْفَاتِحَةِ
u'تَفْسِيرٌ فَاتِحَةٌ':Added, #1: 1	تَفْسِيرَ الْفَاتِحَةِ
u'تَفْسِيرٌ فَاحِشٌ':Added, #5: 5	تَفْسِيرِ الْفَاتِحَةِ
u'تَفْسِيرٌ فَاحِشٌ':Added, #1: 1	تَفْسِيرِ الْفَاحِشِ
u'تَفْسِيرٌ فَاطِرٌ':Added, #1: 1	تَفْسِيرِ الْفَاحِشَةِ
u'تَفْسِيرٌ فَتْحٌ':Added, #3: 3	تَفْسِيرِ فَاطِرٍ
u'تَفْسِيرٌ فخر':Added, #1: 1	تَفْسِيرِ الْفَتْحِ
u'تَفْسِيرٌ فَخْرٌ':Added, #2: 2	تَفْسِيرِ الْفَخْرِ
u'تَفْسِيرٌ فَرَائِضُ':Added, #2: 2	تَفْسِيرِ الْفَخْرِ
u'تَفْسِيرٌ فَرْضٌ':Added, #1: 1	تَفْسِيرِ الْفَرَائِضِ
u'تَفْسِيرٌ فرق':Added, #1: 1	تَفْسِيرِ فَرْضِ
u'تَفْسِيرٌ فِرَقٌ':Added, #1: 1	تَفْسِيرِ الْفِرَقِ
u'تَفْسِيرٌ فُرْقَانٌ':Added, #1: 1	تَفْسِيرِ الْفِرَقِ
u'تَفْسِيرٌ فساد':Added, #1: 1	تَفْسِيرِ الْفُرْقَانِ
u'تَفْسِيرٌ فساد':Added, #1: 1	تَفْسِيرَ الْفَسَادِ
u'تَفْسِيرٌ فَسَادٌ':Added, #1: 1	تَفْسِيرِ الْفَسَادِ
u'تَفْسِيرٌ فَسَادٌ':Added, #1: 1	تَفْسِيرَ الْفَسَادِ
u'تَفْسِيرٌ فُضُولٌ':Added, #1: 1	تَفْسِيرِ الْفَسَادِ
u'تَفْسِيرٌ فطرة':Added, #1: 1	تَفْسِيرَ الْفُضُولِ
u'تَفْسِيرٌ فِطْرَةٌ':Added, #1: 1	تَفْسِيرِ الْفِطْرَةِ
u'تَفْسِيرٌ فقهاء':Added, #1: 1	تَفْسِيرِ الْفِطْرَةِ
u'تَفْسِيرٌ فلان':Added, #1: 1	تَفْسِيرَ الْفُقَهَاءِ
u'تَفْسِيرٌ فلان':Added, #1: 1	تَفْسِيرِ الرَّحْمَنِ
u'تَفْسِيرٌ فلان':Added, #1: 1	تَفْسِيرِ الشَّافِعِيِّ
u'تَفْسِيرٌ فلان':Added, #2: 2	تَفْسِيرِ الطَّبَرِيِّ
u'تَفْسِيرٌ قَادِرٌ':Added, #3: 3	تَفْسِيرِ الْقُرْطُبِيِّ
u'تَفْسِيرٌ قَائِمٌ':Added, #1: 1	تَفْسِيرَ الْقَادِرِ
u'تَفْسِيرٌ قَائِمَةٌ':Added, #1: 1	تَفْسِيرِ الْقَائِمَةِ
u'تَفْسِيرٌ قتال':Added, #1: 1	تَفْسِيرِ الْقَائِمَةِ
u'تَفْسِيرٌ قِتَالٌ':Added, #2: 2	تَفْسِيرِ الْقِتَالِ
u'تَفْسِيرٌ قِرَاءةٌ':Added, #2: 2	تَفْسِيرِ الْقِتَالِ
u'تَفْسِيرٌ قَرَابَةٌ':Added, #1: 1	تَفْسِيرَ الْقِرَاءَةِ
u'تَفْسِيرٌ قُرْآنٌ':Added, #2: 2	تَفْسِيرِ الْقَرَابَةِ
u'تَفْسِيرٌ قِرَانٌ':Added, #1: 1	تَفْسِيرَ الْقُرْآنِ
u'تَفْسِيرٌ قُرْآنٌ':Added, #1: 1	تَفْسِيرِ الْقِرَانِ
u'تَفْسِيرٌ قُرْآنٌ':Added, #3: 3	تَفْسِيرُ الْقُرْآنِ
u'تَفْسِيرٌ قُرْطُبِيّ':Added, #3: 3	تَفْسِيرِ الْقُرْآنِ
u'تَفْسِيرٌ قَسام':Added, #3: 3	تَفْسِيرِ الْقُرْطُبِيِّ
u'تَفْسِيرٌ قَسامَة':Added, #1: 1	تَفْسِيرُ الْقَسَامَةِ
u'تَفْسِيرٌ قسمة':Added, #1: 1	تَفْسِيرُ الْقَسَامَةِ
u'تَفْسِيرٌ قِسْمَةٌ':Added, #1: 1	تَفْسِيرُ قِسْمَةِ
u'تَفْسِيرٌ قَصْدٌ':Added, #1: 1	تَفْسِيرُ قِسْمَةِ
u'تَفْسِيرٌ قَصَصٌ':Added, #2: 2	تَفْسِيرُ الْقَصْدِ
u'تَفْسِيرٌ قَصِيدٌ':Added, #1: 1	تَفْسِير الْقَصَصِ
u'تَفْسِيرٌ قَضَاءٌ':Added, #1: 1	تَفْسِيرُ قَصِيدَةِ
u'تَفْسِيرٌ قُعُودٌ':Added, #1: 1	تَفْسِيرَ الْقَضَاءِ
u'تَفْسِيرٌ قمر':Added, #1: 1	تَفْسِيرِ الْقُعُودِ
u'تَفْسِيرٌ قَمَرٌ':Added, #2: 2	تَفْسِيرِ الْقَمَرِ
u'تَفْسِيرٌ قُوَّةٌ':Added, #2: 2	تَفْسِيرِ الْقَمَرِ
u'تَفْسِيرٌ قُوَّة':Added, #1: 1	تَفْسِيرُ الْقُوَّةِ
u'تَفْسِيرٌ قول':Added, #1: 1	تَفْسِيرُ الْقُوَّةِ
u'تَفْسِيرٌ قَوْلٌ':Added, #22: 22	تَفْسِيرِ قَوْلِهِ
u'تَفْسِيرٌ قول':Added, #22: 22	تَفْسِيرِ قَوْلِهِ
u'تَفْسِيرٌ قَوْلٌ':Added, #2: 2	تَفْسِيرُ قَوْلِ
u'تَفْسِيرٌ قول':Added, #2: 2	تَفْسِيرُ قَوْلِ
u'تَفْسِيرٌ قَوْلٌ':Added, #2: 2	تَفْسِيرَ قَوْلِهِ
u'تَفْسِيرٌ قول':Added, #2: 2	تَفْسِيرَ قَوْلِهِ
u'تَفْسِيرٌ قَوْلٌ':Added, #3: 3	تَفْسِيرُ قَوْلِهِ
u'تَفْسِيرٌ قول':Added, #3: 3	تَفْسِيرُ قَوْلِهِ
u'تَفْسِيرٌ قَوْلٌ':Added, #9: 9	تَفْسِيرِ قَوْلِ
u'تَفْسِيرٌ قَوْمٌ':Added, #9: 9	تَفْسِيرِ قَوْلِ
u'تَفْسِيرٌ قيام':Added, #1: 1	تَفْسِيرِ الْقَوْمِ
u'تَفْسِيرٌ قِيَامٌ':Added, #1: 1	تَفْسِيرُ قِيَامِهِ
u'تَفْسِيرٌ قِيَامَةٌ':Added, #1: 1	تَفْسِيرُ قِيَامِهِ
u'تَفْسِيرٌ قِيمَةٌ':Added, #1: 1	تَفْسِيرِ الْقِيَامَةِ
u'تَفْسِيرٌ قِيمَةٌ':Added, #1: 1	تَفْسِيرِ قِيمَةِ
u'تَفْسِيرٌ كبائر':Added, #2: 2	تَفْسِيرِ قِيمَتِهِ
u'تَفْسِيرٌ كَبِيرٌ':Added, #2: 2	تَفْسِيرِ الْكَبَائِرِ
u'تَفْسِيرٌ كِتَابَةٌ':Added, #1: 1	تَفْسِيرِ الْكَبِيرَةِ
u'تَفْسِيرٌ كِتَابَةٌ':Added, #1: 1	تَفْسِيرِ الْكِتَابَةِ
u'تَفْسِيرٌ كَرَاهَةٌ':Added, #4: 4	تَفْسِيرُ الْكِتَابَةِ
u'تَفْسِيرٌ كَرْع':Added, #1: 1	تَفْسِيرِ الْكَرَاهَةِ
u'تَفْسِيرٌ كَعْبٌ':Added, #1: 1	تَفْسِيرَ الْكَرْعِ
u'تَفْسِيرٌ كَلَأٌ':Added, #1: 1	تَفْسِيرَ الْكَعْبِ
u'تَفْسِيرٌ كَلالَةٌ':Added, #1: 1	تَفْسِيرُ الْكَلَأِ
u'تَفْسِيرٌ كَلاَمٌ':Added, #1: 1	تَفْسِيرِ الْكَلاَلَةِ
u'تَفْسِيرٌ كَلاَمٌ':Added, #1: 1	تَفْسِيرَ كَلَامِهِ
u'تَفْسِيرٌ كَلِمَةٌ':Added, #2: 2	تَفْسِيرِ كَلَامِهِ
u'تَفْسِيرٌ كَنْزٌ':Added, #1: 1	تَفْسِيرُ كَلِمَةِ
u'تَفْسِيرٌ كَهْفٌ':Added, #1: 1	تَفْسِيرِ الْكَنْزِ
u'تَفْسِيرٌ كُوبَة':Added, #1: 1	تَفْسِيرِ الْكَهْفِ
u'تَفْسِيرٌ كَوْرٌ':Added, #1: 1	تَفْسِيرَ الْكُوبَةِ
u'تَفْسِيرٌ كَوْسَج':Added, #1: 1	تَفْسِيرَ الْكَوْرِ
u'تَفْسِيرٌ لَغْوٌ':Added, #1: 1	تَفْسِيرِ الْكَوْسَجِ
u'تَفْسِيرٌ لَغْوٌ':Added, #1: 1	تَفْسِيرَ اللَّغْوِ
u'تَفْسِيرٌ لَفْظٌ':Added, #3: 3	تَفْسِيرِ اللَّغْوِ
u'تَفْسِيرٌ لَفْظٌ':Added, #1: 1	تَفْسِيرِ اللَّفْظِ
u'تَفْسِيرٌ مَاعُونٌ':Added, #1: 1	تَفْسِيرَ لَفْظِ
u'تَفْسِيرٌ مَالٌ':Added, #1: 1	تَفْسِيرِ الْمَاعُونِ
u'تَفْسِيرٌ مُبَاحٌ':Added, #1: 1	تَفْسِيرِ مَالِ
u'تَفْسِيرٌ مَبَادِئُ':Added, #1: 1	تَفْسِيرِ الْمُبَاحِ
u'تَفْسِيرٌ مَبْرُورٌ':Added, #1: 1	تَفْسِيرِ الْمَبَادِئِ
u'تَفْسِيرٌ مُبْهَمٌ':Added, #1: 1	تَفْسِيرِ الْمَبْرُورِ
u'تَفْسِيرٌ مُبْهَمٌ':Added, #1: 1	تَفْسِيرُ الْمُبْهَمِ
u'تَفْسِيرٌ مُبْهَمٌ':Added, #1: 1	تَفْسِيرُ مُبْهَمٍ
u'تَفْسِيرٌ مُتَشَابِهٌ':Added, #3: 3	تَفْسِيرِ الْمُبْهَمِ
u'تَفْسِيرٌ مُتَشَابِهٌ':Added, #1: 1	تَفْسِيرُ الْمُتَشَابِهِ
u'تَفْسِيرٌ مَجْلِسٌ':Added, #1: 1	تَفْسِيرِ الْمُتَشَابِهِ
u'تَفْسِيرٌ مُحاقَلَة':Added, #1: 1	تَفْسِيرِ الْمَجْلِسِ
u'تَفْسِيرٌ مَحْرَمٌ':Added, #1: 1	تَفْسِيرِ الْمُحَاقَلَةِ
u'تَفْسِيرٌ مَحْرَمٌ':Added, #1: 1	تَفْسِيرَ الْمَحْرَمِ
u'تَفْسِيرٌ مَحْظُورٌ':Added, #1: 1	تَفْسِيرُ الْمَحْرَمِ
u'تَفْسِيرٌ مُحَمَّدٌ':Added, #1: 1	تَفْسِيرِ الْمَحْظُورِ
u'تَفْسِيرٌ مُحَمَّدٌ':Added, #1: 1	تَفْسِيرُ مُحَمَّدٍ
u'تَفْسِيرٌ مُدَبَّرٌ':Added, #1: 1	تَفْسِيرِ مُحَمَّدٍ
u'تَفْسِيرٌ مُدَّثِّرٌ':Added, #1: 1	تَفْسِيرَ الْمُدَبَّرِ
u'تَفْسِيرٌ مَذْهَبٌ':Added, #3: 3	تَفْسِيرِ الْمُدَّثِّرِ
u'تَفْسِيرٌ مراد':Added, #2: 2	تَفْسِيرِ مَذْهَبِهِ
u'تَفْسِيرٌ مُرَادٌ':Added, #1: 1	تَفْسِيرَ الْمُرَادِ
u'تَفْسِيرٌ مراد':Added, #1: 1	تَفْسِيرَ الْمُرَادِ
u'تَفْسِيرٌ مُرَادٌ':Added, #2: 2	تَفْسِيرُ الْمُرَادِ
u'تَفْسِيرٌ مُرْتَجَلٌ':Added, #2: 2	تَفْسِيرُ الْمُرَادِ
u'تَفْسِيرٌ مَسْأَلَةٌ':Added, #1: 1	تَفْسِيرِ الْمُرْتَجَلِ
u'تَفْسِيرٌ مَسْأَلَةٌ':Added, #1: 1	تَفْسِيرَ الْمَسْأَلَةِ
u'تَفْسِيرٌ مَسْأَلَةٌ':Added, #1: 1	تَفْسِيرِ الْمَسْأَلَةِ
u'تَفْسِيرٌ مُسْتَنْكَرٌ':Added, #2: 2	تَفْسِيرُ الْمَسْأَلَةِ
u'تَفْسِيرٌ مُسَمَّى':Added, #1: 1	تَفْسِيرِ الْمُسْتَنْكَرِ
u'تَفْسِيرٌ مُشْتَرَكٌ':Added, #1: 1	تَفْسِيرِ الْمُسَمَّيَاتِ
u'تَفْسِيرٌ مَشْرُوعٌ':Added, #1: 1	تَفْسِيرِ الْمُشْتَرَكِ
u'تَفْسِيرٌ مِشْفَرٌ':Added, #1: 1	تَفْسِيرِ الْمَشْرُوعِ
u'تَفْسِيرٌ مَشَقَّةٌ':Added, #1: 1	تَفْسِيرُ الْمِشْفَرِ
u'تَفْسِيرٌ مُصَنِّفٌ':Added, #1: 1	تَفْسِيرُ الْمَشَقَّةِ
u'تَفْسِيرٌ مُصَنِّفٌ':Added, #1: 1	تَفْسِيرَ الْمُصَنِّفِ
u'تَفْسِيرٌ مُضَارَبَةٌ':Added, #3: 3	تَفْسِيرِ الْمُصَنِّفِ
u'تَفْسِيرٌ مُطْرِبٌ':Added, #1: 1	تَفْسِيرُ الْمُضَارَبَةِ
u'تَفْسِيرٌ مُقَابَلٌ':Added, #1: 1	تَفْسِيرِ الْمُطْرِبَةِ
u'تَفْسِيرٌ مُقَابَلَةٌ':Added, #1: 1	تَفْسِيرِ الْمُقَابَلَةِ
u'تَفْسِيرٌ مَقَالٌ':Added, #1: 1	تَفْسِيرِ الْمُقَابَلَةِ
u'تَفْسِيرٌ مُلاَزَمَةٌ':Added, #1: 1	تَفْسِيرُ مَقَالِ
u'تَفْسِيرٌ مِلْحَفَةٌ':Added, #1: 1	تَفْسِيرِ الْمُلَازَمَةِ
u'تَفْسِيرٌ مَنْفَعَةٌ':Added, #1: 1	تَفْسِيرِ الْمِلْحَفَةِ
u'تَفْسِيرٌ مَوَاتٌ':Added, #1: 1	تَفْسِيرِ الْمَنْفَعَةِ
u'تَفْسِيرٌ مَوْتٌ':Added, #1: 1	تَفْسِيرِ الْمَوَاتِ
u'تَفْسِيرٌ مُوجِبٌ':Added, #1: 1	تَفْسِيرِ الْمَوْتِ
u'تَفْسِيرٌ مَوْقُوفٌ':Added, #1: 1	تَفْسِيرِ الْمُوجِبَتَيْنِ
u'تَفْسِيرٌ مَوْقُوفٌ':Added, #1: 1	تَفْسِيرَ الْمَوْقُوفِ
u'تَفْسِيرٌ نَافِعٌ':Added, #1: 1	تَفْسِيرُ الْمَوْقُوفِ
u'تَفْسِيرٌ نَبِيٌّ':Added, #2: 2	تَفْسِيرِ نَافِعٍ
u'تَفْسِيرٌ نَبِيٌّ':Added, #1: 1	تَفْسِيرُ النَّبِيِّ
u'تَفْسِيرٌ نَتِيجَةٌ':Added, #3: 3	تَفْسِيرِ النَّبِيِّ
u'تَفْسِيرٌ نَجْمٌ':Added, #1: 1	تَفْسِيرُ نَتِيجَةِ
u'تَفْسِيرٌ نِساءٌ':Added, #1: 1	تَفْسِيرِ النَّجْمِ
u'تَفْسِيرٌ نسمة':Added, #1: 1	تَفْسِيرِ النِّسَاءِ
u'تَفْسِيرٌ نَسَمَةٌ':Added, #1: 1	تَفْسِيرَ النَّسَمَةِ
u'تَفْسِيرٌ نصاب':Added, #1: 1	تَفْسِيرَ النَّسَمَةِ
u'تَفْسِيرٌ نِصَابٌ':Added, #1: 1	تَفْسِيرَ النِّصَابِ
u'تَفْسِيرٌ نَصِيبٌ':Added, #1: 1	تَفْسِيرَ النِّصَابِ
u'تَفْسِيرٌ نَظَرٌ':Added, #1: 1	تَفْسِيرِ نَصِيبِ
u'تَفْسِيرٌ نَفَقَةٌ':Added, #1: 1	تَفْسِيرِ النَّظَرِ
u'تَفْسِيرٌ نَقَّاشٌ':Added, #1: 1	تَفْسِيرِ النَّفَقَةِ
u'تَفْسِيرٌ نُقْصَانٌ':Added, #2: 2	تَفْسِيرِ النّقّاشِ
u'تَفْسِيرٌ نكاح':Added, #1: 1	تَفْسِيرِ النُّقْصَانِ
u'تَفْسِيرٌ نِكَاحٌ':Added, #2: 2	تَفْسِيرِ نِكَاحِ
u'تَفْسِيرٌ نَهْيٌ':Added, #2: 2	تَفْسِيرِ نِكَاحِ
u'تَفْسِيرٌ نوائب':Added, #1: 1	تَفْسِيرُ النَّهْيِ
u'تَفْسِيرٌ نَوَائِبُ':Added, #1: 1	تَفْسِيرَ النَّوَائِبِ
u'تَفْسِيرٌ نُورٌ':Added, #1: 1	تَفْسِيرَ النَّوَائِبِ
u'تَفْسِيرٌ نِيَّةٌ':Added, #2: 2	تَفْسِيرِ النُّورِ
u'تَفْسِيرٌ هِبَةٌ':Added, #1: 1	تَفْسِيرِ النِّيَّةِ
u'تَفْسِيرٌ هَدِيٌّ':Added, #1: 1	تَفْسِيرِ الْهِبَةِ
u'تَفْسِيرٌ هَدِيَّةٌ':Added, #1: 1	تَفْسِيرَ الْهَدِيَّةِ
u'تَفْسِيرٌ همزة':Added, #1: 1	تَفْسِيرَ الْهَدِيَّةِ
u'تَفْسِيرٌ هُودٌ':Added, #1: 1	تَفْسِيرِ الْهُمَزَةِ
u'تَفْسِيرٌ واحد':Added, #3: 3	تَفْسِيرِ هُودٍ
u'تَفْسِيرٌ وَاحِدٌ':Added, #1: 1	تَفْسِيرٍ وَاحِدٍ
u'تَفْسِيرٌ وَاصِلٌ':Added, #1: 1	تَفْسِيرٍ وَاحِدٍ
u'تَفْسِيرٌ وَجْهٌ':Added, #1: 1	تَفْسِيرُ الْوَاصِلَةِ
u'تَفْسِيرٌ وُجُوبٌ':Added, #1: 1	تَفْسِيرُ الْوَجْهِ
u'تَفْسِيرٌ وُجُوبٌ':Added, #1: 1	تَفْسِيرِ الْوُجُوبِ
u'تَفْسِيرٌ وَسْقٌ':Added, #1: 1	تَفْسِيرُ وُجُوبِ
u'تَفْسِيرٌ وَضْعٌ':Added, #1: 1	تَفْسِيرَ الْوَسْقِ
u'تَفْسِيرٌ وَقَاحَةٌ':Added, #1: 1	تَفْسِيرِ الْوَضْعِ
u'تَفْسِيرٌ وَقْفٌ':Added, #1: 1	تَفْسِيرُ الْوَقَاحَةِ
u'تَفْسِيرٌ وَكْز':Added, #1: 1	تَفْسِيرِ الْوَقْفِ
u'تَفْسِيرٌ وَلاَءٌ':Added, #1: 1	تَفْسِيرِ الْوَكْزِ
u'تَفْسِيرٌ وِلاَيَةٌ':Added, #2: 2	تَفْسِيرُ وَلَاءِ
u'تَفْسِيرٌ يَوْمٌ':Added, #1: 1	تَفْسِيرُ الْوِلَايَةِ
u'تَفْصِيلٌ إبَاحَةٌ':Added, #1: 1	تَفْسِيرَ يَوْمِ
u'تَفْصِيلٌ اِبْنٌ':Added, #1: 1	تَفْصِيلِ الْإِبَاحَةِ
u'تَفْصِيلٌ اِبْنٌ':Added, #1: 1	تَفْصِيلَ ابْنِ
u'تَفْصِيلٌ أُجْرَةٌ':Added, #2: 2	تَفْصِيلُ ابْنِ
u'تَفْصِيلٌ أَجْنَبِيٌّ':Added, #1: 1	تَفْصِيلَ الْأُجْرَةِ
u'تَفْصِيلٌ أَحْكَامٌ':Added, #1: 1	تَفْصِيلُ الْأَجْنَبِيِّ
u'تَفْصِيلٌ أَحْكَامٌ':Added, #1: 1	تَفْصِيلَ أَحْكَامِهِ
u'تَفْصِيلٌ أَحْكَامٌ':Added, #1: 1	تَفْصِيلَ الْأَحْكَامِ
u'تَفْصِيلٌ أُصولٌ':Added, #1: 1	تَفْصِيلِ الْأَحْكَامِ
u'تَفْصِيلٌ أَعْضَاءٌ':Added, #1: 1	تَفْصِيلِ الْأُصُولِ
u'تَفْصِيلٌ أَعْمَالٌ':Added, #1: 1	تَفْصِيلُ أَعْضَاءِ
u'تَفْصِيلٌ أَقْسَامٌ':Added, #2: 2	تَفْصِيلِ الْأَعْمَالِ
u'تَفْصِيلٌ إمَامٌ':Added, #1: 1	تَفْصِيلَ الْأَقْسَامِ
u'تَفْصِيلٌ أمثال':Added, #1: 1	تَفْصِيلُ الْإِمَامِ
u'تَفْصِيلٌ أَمْثَالٌ':Added, #1: 1	تَفْصِيلِ أَمْثَالِهِ
u'تَفْصِيلٌ أَمْرٌ':Added, #1: 1	تَفْصِيلِ أَمْثَالِهِ
u'تَفْصِيلٌ إيمَانٌ':Added, #1: 1	تَفْصِيلَ أَمْرِ
u'تَفْصِيلٌ بَيَانٌ':Added, #1: 1	تَفْصِيلِ الْإِيمَانِ
u'تَفْصِيلٌ بَيْعٌ':Added, #2: 2	تَفْصِيلِ بَيَانِهِ
u'تَفْصِيلٌ تَصَرُّفٌ':Added, #1: 1	تَفْصِيلِ بَيْعِهِ
u'تَفْصِيلٌ ثَمَنٌ':Added, #1: 1	تَفْصِيلِ تَصَرُّفَاتِهِ
u'تَفْصِيلٌ ثَمَنٌ':Added, #1: 1	تَفْصِيلِ ثَمَنٍ
u'تَفْصِيلٌ جَامِعٌ':Added, #7: 7	تَفْصِيلَ الثَّمَنِ
u'تَفْصِيلٌ حالٌ':Added, #1: 1	تَفْصِيلِ الْجَامِعِ
u'تَفْصِيلٌ حُكْمٌ':Added, #2: 2	تَفْصِيلِ الْحَالَيْنِ
u'تَفْصِيلٌ ذكر':Added, #1: 1	تَفْصِيلَ الْحُكْمِ
u'تَفْصِيلٌ ذِكْرٌ':Added, #1: 1	تَفْصِيلِ ذِكْرِ
u'تَفْصِيلٌ ذكر':Added, #1: 1	تَفْصِيلِ ذِكْرِ
u'تَفْصِيلٌ ذِكْرٌ':Added, #2: 2	تَفْصِيلِ ذِكْرِهِ
u'تَفْصِيلٌ ذَنْبٌ':Added, #2: 2	تَفْصِيلِ ذِكْرِهِ
u'تَفْصِيلٌ رِجْلٌ':Added, #1: 1	تَفْصِيلَ الذَّنْبِ
u'تَفْصِيلٌ رَدٌّ':Added, #1: 1	تَفْصِيلُ الرِّجْلِ
u'تَفْصِيلٌ زَرْعٌ':Added, #1: 1	تَفْصِيلُ رَدِّ
u'تَفْصِيلٌ زَوالٌ':Added, #1: 1	تَفْصِيلَ الزَّرْعِ
u'تَفْصِيلٌ سَهْوٌ':Added, #1: 1	تَفْصِيلُ زَوَالِهِ
u'تَفْصِيلٌ شَهَادَةٌ':Added, #1: 1	تَفْصِيلِ سَهْوٍ
u'تَفْصِيلٌ شَهَادَةٌ':Added, #1: 1	تَفْصِيلِ الشَّهَادَةِ
u'تَفْصِيلٌ شُهُودٌ':Added, #2: 2	تَفْصِيلُ الشَّهَادَةِ
u'تَفْصِيلٌ ظَهِير':Added, #1: 1	تَفْصِيلُ الشُّهُودِ
u'تَفْصِيلٌ ظَهِيرَة':Added, #1: 1	تَفْصِيلَ الظَّهِيرِيَّةِ
u'تَفْصِيلٌ عتق':Added, #1: 1	تَفْصِيلَ الظَّهِيرِيَّةِ
u'تَفْصِيلٌ عِتْقٌ':Added, #1: 1	تَفْصِيلُ عِتْقِ
u'تَفْصِيلٌ عَدَدٌ':Added, #1: 1	تَفْصِيلُ عِتْقِ
u'تَفْصِيلٌ عَدَدٌ':Added, #1: 1	تَفْصِيلِ الْعَدَدِ
u'تَفْصِيلٌ عَقْدٌ':Added, #2: 2	تَفْصِيلُ الْعَدَدِ
u'تَفْصِيلٌ علم':Added, #1: 1	تَفْصِيلِ عَقْدِ
u'تَفْصِيلٌ عِلْمٌ':Added, #1: 1	تَفْصِيلُ الْعِلْمِ
u'تَفْصِيلٌ عَمَلٌ':Added, #1: 1	تَفْصِيلُ الْعِلْمِ
u'تَفْصِيلٌ فخر':Added, #1: 1	تَفْصِيلُ الْعَمَلِ
u'تَفْصِيلٌ فَخْرٌ':Added, #1: 1	تَفْصِيلُ فَخْرِ
u'تَفْصِيلٌ قَدْرٌ':Added, #1: 1	تَفْصِيلُ فَخْرِ
u'تَفْصِيلٌ كبائر':Added, #1: 1	تَفْصِيلِ قَدْرِ
u'تَفْصِيلٌ مَأْكُولٌ':Added, #4: 4	تَفْصِيلِ الْكَبَائِرِ
u'تَفْصِيلٌ مُتَّصِلٌ':Added, #1: 1	تَفْصِيلِ الْمَأْكُولِ
u'تَفْصِيلٌ مَدْلُولٌ':Added, #1: 1	تَفْصِيلُ الْمُتَّصِلِ
u'تَفْصِيلٌ مَذْكُورٌ':Added, #1: 1	تَفْصِيلَ مَدْلُولِ
u'تَفْصِيلٌ مَذْهَبٌ':Added, #1: 1	تَفْصِيلٍ مَذْكُورٍ
u'تَفْصِيلٌ مَسْأَلَةٌ':Added, #2: 2	تَفْصِيلُ الْمَذْهَبِ
u'تَفْصِيلٌ مَشَايِخُ':Added, #1: 1	تَفْصِيلِ الْمَسْأَلَةِ
u'تَفْصِيلٌ مَعْرُوفٌ':Added, #1: 1	تَفْصِيلِ الْمَشَايِخِ
u'تَفْصِيلٌ نِيَّةٌ':Added, #1: 1	تَفْصِيلٍ مَعْرُوفٍ
u'تَفْصِيلٌ وُجُوبٌ':Added, #1: 1	تَفْصِيلِ النِّيَّةِ
u'تَفْصِيلٌ وُضُوءٌ':Added, #1: 1	تَفْصِيلَ وُجُوبِ
u'تَفَضُّلٌ جُمْلَةٌ':Added, #1: 1	تَفْصِيلُ الْوُضُوءِ
u'تَفْضِيضٌ أَقْدَاحٌ':Added, #1: 1	تَفَضُّلِ الْجُمْلَةِ
u'تَفْضِيضٌ مَصَاحِفُ':Added, #1: 1	تَفْضِيضِ الْأَقْدَاحِ
u'تَفْضِيلٌ أحَدٌ':Added, #1: 1	تَفْضِيضِ الْمَصَاحِفِ
u'تَفْضِيلٌ إِفْرَادٌ':Added, #1: 1	تَفْضِيلُ أَحَدٍ
u'تَفْضِيلٌ إمَاءٌ':Added, #1: 1	تَفْضِيلِ الْإِفْرَادِ
u'تَفْضِيلٌ أَوَّلُ':Added, #1: 1	تَفْضِيلَ الْإِمَاءِ
u'تَفْضِيلٌ آيٌ':Added, #1: 1	تَفْضِيلُ الْأَوَّلِ
u'تَفْضِيلٌ بدنة':Added, #1: 1	تَفْضِيلِ آيِ
u'تَفْضِيلٌ بَشَرٌ':Added, #2: 2	تَفْضِيلَ الْبَدَنَةِ
u'تَفْضِيلٌ بَعْضٌ':Added, #1: 1	تَفْضِيلِ الْبَشَرِ
u'تَفْضِيلٌ بَعْضٌ':Added, #1: 1	تَفْضِيلُ الْبَعْضِ
u'تَفْضِيلٌ بَعْضٌ':Added, #1: 1	تَفْضِيلُ بَعْضٍ
u'تَفْضِيلٌ بَعْضٌ':Added, #1: 1	تَفْضِيلُ بَعْضِ
u'تَفْضِيلٌ بَغْلٌ':Added, #2: 2	تَفْضِيلَ الْبَعْضِ
u'تَفْضِيلٌ تَجْهِيزٌ':Added, #1: 1	تَفْضِيلَ الْبَغْلِ
u'تَفْضِيلٌ تَسْلِيمٌ':Added, #1: 1	تَفْضِيلِ تَجْهِيزِ
u'تَفْضِيلٌ تَمَتُّعٌ':Added, #1: 1	تَفْضِيلِ التَّسْلِيمَتَيْنِ
u'تَفْضِيلٌ تَوَسُّط':Added, #1: 1	تَفْضِيلُ التَّمَتُّعِ
u'تَفْضِيلٌ ثَلاثُ':Added, #2: 2	تَفْضِيلِ التَّوَسُّطِ
u'تَفْضِيلٌ ثَلاثُ':Added, #1: 1	تَفْضِيلُ الثَّلَاثِ
u'تَفْضِيلٌ جَدِيدٌ':Added, #1: 1	تَفْضِيلِ الثَّلَاثِ
u'تَفْضِيلٌ حُرٌّ':Added, #1: 1	تَفْضِيلِ الْجَدِيدَةِ
u'تَفْضِيلٌ حِنْطَةٌ':Added, #1: 1	تَفْضِيلُ الْحُرِّ
u'تَفْضِيلٌ خَالٌ':Added, #2: 2	تَفْضِيلُ الْحِنْطَةِ
u'تَفْضِيلٌ خَوَاصُّ':Added, #1: 1	تَفْضِيلَ الْخَالِ
u'تَفْضِيلٌ خَوَاصّ':Added, #1: 1	تَفْضِيلَ خَوَاصِّ
u'تَفْضِيلٌ خَيْلٌ':Added, #1: 1	تَفْضِيلَ خَوَاصِّ
u'تَفْضِيلٌ ذكر':Added, #1: 1	تَفْضِيلِ الْخَيْلِ
u'تَفْضِيلٌ ذَكَرٌ':Added, #1: 1	تَفْضِيلَ الذَّكَرِ
u'تَفْضِيلٌ ذكر':Added, #1: 1	تَفْضِيلَ الذَّكَرِ
u'تَفْضِيلٌ ذكر':Added, #2: 2	تَفْضِيلُ الذَّكَرِ
u'تَفْضِيلٌ ذَكَرٌ':Added, #2: 2	تَفْضِيلِ الذَّكَرِ
u'تَفْضِيلٌ ذَكَرٌ':Added, #2: 2	تَفْضِيلُ الذَّكَرِ
u'تَفْضِيلٌ رِجَالٌ':Added, #2: 2	تَفْضِيلِ الذَّكَرِ
u'تَفْضِيلٌ رِدَاءٌ':Added, #1: 1	تَفْضِيلِ الرِّجَالِ
u'تَفْضِيلٌ رِسَالَةٌ':Added, #1: 1	تَفْضِيلِ الرِّدَاءِ
u'تَفْضِيلٌ رُسُلٌ':Added, #1: 1	تَفْضِيلُ الرِّسَالَةِ
u'تَفْضِيلٌ رُطَبٌ':Added, #1: 1	تَفْضِيلُ رُسُلِ
u'تَفْضِيلٌ زَرْعٌ':Added, #1: 1	تَفْضِيلُ الرُّطَبِ
u'تَفْضِيلٌ سُفْلٌ':Added, #1: 1	تَفْضِيلِ الزَّرْعِ
u'تَفْضِيلٌ سلام':Added, #3: 3	تَفْضِيلِ السُّفْلِ
u'تَفْضِيلٌ سَلاَمٌ':Added, #1: 1	تَفْضِيلِ السَّلَامِ
u'تَفْضِيلٌ سُنَّةٌ':Added, #1: 1	تَفْضِيلِ السَّلَامِ
u'تَفْضِيلٌ سورٌ':Added, #1: 1	تَفْضِيلِ سُنَّةٍ
u'تَفْضِيلٌ شَاةٌ':Added, #1: 1	تَفْضِيلِ السّوَرِ
u'تَفْضِيلٌ صَحَابَةٌ':Added, #1: 1	تَفْضِيلَ الشَّاةِ
u'تَفْضِيلٌ صدقة':Added, #1: 1	تَفْضِيلِ الصَّحَابَةِ
u'تَفْضِيلٌ صَدَقَةٌ':Added, #2: 2	تَفْضِيلِ صَدَقَةِ
u'تَفْضِيلٌ صَلاَةٌ':Added, #2: 2	تَفْضِيلِ صَدَقَةِ
u'تَفْضِيلٌ صَلاَةٌ':Added, #1: 1	تَفْضِيلُ صَلَاةِ
u'تَفْضِيلٌ طواف':Added, #1: 1	تَفْضِيلِ صَلَاةِ
u'تَفْضِيلٌ طَوَافٌ':Added, #1: 1	تَفْضِيلُ طَوَافِ
u'تَفْضِيلٌ طواف':Added, #1: 1	تَفْضِيلُ طَوَافِ
u'تَفْضِيلٌ طَوَافٌ':Added, #2: 2	تَفْضِيلُ الطَّوَافِ
u'تَفْضِيلٌ طَيْلَسَانٌ':Added, #2: 2	تَفْضِيلُ الطَّوَافِ
u'تَفْضِيلٌ ظُهْرٌ':Added, #1: 1	تَفْضِيلُ الطَّيْلَسَانِ
u'تَفْضِيلٌ عَامٌّ':Added, #2: 2	تَفْضِيلُ الظُّهْرِ
u'تَفْضِيلٌ عُلُومٌ':Added, #1: 1	تَفْضِيلُ الْعَامَّةِ
u'تَفْضِيلٌ عمرة':Added, #1: 1	تَفْضِيلُ عُلُومِ
u'تَفْضِيلٌ عُمْرَةٌ':Added, #1: 1	تَفْضِيلِ الْعُمْرَةِ
u'تَفْضِيلٌ عِنَبٌ':Added, #1: 1	تَفْضِيلِ الْعُمْرَةِ
u'تَفْضِيلٌ عَوَامُّ':Added, #1: 1	تَفْضِيلِ الْعِنَبِ
u'تَفْضِيلٌ غُسْلٌ':Added, #1: 1	تَفْضِيلُ عَوَامِّ
u'تَفْضِيلٌ غَنِيٌّ':Added, #1: 1	تَفْضِيلِ غُسْلِ
u'تَفْضِيلٌ فَارِسٌ':Added, #1: 1	تَفْضِيلِ الْغَنِيِّ
u'تَفْضِيلٌ فَرْضٌ':Added, #1: 1	تَفْضِيلِ الْفَارِسِ
u'تَفْضِيلٌ فَرْضٌ':Added, #1: 1	تَفْضِيلُ فَرْضِ
u'تَفْضِيلٌ فقر':Added, #1: 1	تَفْضِيلِ فَرْضِ
u'تَفْضِيلٌ فَقْرٌ':Added, #1: 1	تَفْضِيلِ الْفَقْرِ
u'تَفْضِيلٌ فَقِيرٌ':Added, #1: 1	تَفْضِيلِ الْفَقْرِ
u'تَفْضِيلٌ قَبَائِلُ':Added, #2: 2	تَفْضِيلِ الْفَقِيرِ
u'تَفْضِيلٌ قِرَاءةٌ':Added, #1: 1	تَفْضِيلِ الْقَبَائِلِ
u'تَفْضِيلٌ قِرَانٌ':Added, #1: 1	تَفْضِيلِ قِرَاءَةِ
u'تَفْضِيلٌ كَلاَمٌ':Added, #1: 1	تَفْضِيلُ الْقِرَانِ
u'تَفْضِيلٌ لِسَانٌ':Added, #1: 1	تَفْضِيلَ الْكَلَامِ
u'تَفْضِيلٌ مُجْمَعٌ':Added, #1: 1	تَفْضِيلِ لِسَانِ
u'تَفْضِيلٌ مَذْهَبٌ':Added, #1: 1	تَفْضِيلَ الْمُجْمَعِ
u'تَفْضِيلٌ مَسَاجِدُ':Added, #1: 1	تَفْضِيلِ مَذْهَبِ
u'تَفْضِيلٌ مَغْرِبٌ':Added, #1: 1	تَفْضِيلِ الْمَسَاجِدِ
u'تَفْضِيلٌ مُفَضَّلٌ':Added, #2: 2	تَفْضِيلُ الْمَغْرِبِ
u'تَفْضِيلٌ مَلاَئِكَةٌ':Added, #1: 1	تَفْضِيلِ الْمُفَضَّلِ
u'تَفْضِيلٌ مَنْدُوبٌ':Added, #1: 1	تَفْضِيلِ الْمَلَائِكَةِ
u'تَفْضِيلٌ نَفْسٌ':Added, #1: 1	تَفْضِيلُ الْمَنْدُوبِ
u'تَفْضِيلٌ نَفْلٌ':Added, #1: 1	تَفْضِيلَ نَفْسِهِ
u'تَفْضِيلٌ نَفِيسٌ':Added, #1: 1	تَفْضِيلُ نَفْلِ
u'تَفْضِيلٌ يَوْمٌ':Added, #1: 1	تَفْضِيلُ النَّفِيسِ
u'تَفْضِيلٌ يَوْمٌ':Added, #1: 1	تَفْضِيلَ يَوْمٍ
u'تَفْضِيلٌ يَوْمٌ':Added, #1: 1	تَفْضِيلُ يَوْمٍ
u'تَفَطَّنَ إمَامٌ':Subject, #1: 1	تَفْضِيلِ يَوْمٍ
u'تَفَطَّنَ بَائِعٌ':Subject, #1: 1	تَفَطَّنَ إمَامُ
u'تَفَطَّنَ مَالِكٌ':Subject, #1: 1	تَفَطَّنَ الْبَائِعُ
u'تَفَطُّنٌ مَالِكٌ':Added, #2: 2	تَفَطَّنَ مَالِكٌ
u'تَفَقُّدٌ أَحْوالٌ':Added, #1: 1	تَفَطُّنِ مَالِكٍ
u'تَفَقُّدٌ أحْوَالٌ':Added, #1: 1	تَفَقُّدِ أَحْوَالِ
u'تَفَقُّدٌ إمَامٌ':Added, #1: 1	تَفَقُّدِ أَحْوَالِ
u'تَفَقُّهٌ شَيْخٌ':Added, #2: 2	تَفَقُّدُ الْإِمَامِ
u'تَفَقُّهٌ شَيْخٌ':Added, #1: 1	تَفَقُّهُ الشَّيْخِ
u'تَفَقُّهٌ عَبْدٌ':Added, #1: 1	تَفَقُّهِ الشَّيْخَيْنِ
u'تَفَقُّهٌ نَوَوِيٌّ':Added, #1: 1	تَفَقُّهِ عَبْدِ
u'تَفْقِيعٌ أَصابِعُ':Added, #1: 1	تَفَقُّهِ النَّوَوِيِّ
u'تَفَكَّرَ إمَامٌ':Subject, #1: 1	تَفْقِيعِ الأَصَابِعِ
u'تَفَكُّرٌ سَاعَةٌ':Added, #1: 1	تَفَكَّرَ الْإِمَامُ
u'تَفَكُّرٌ صَائِمٌ':Added, #3: 3	تَفَكُّرُ سَاعَةٍ
u'تَفَكَّرَ علم':Predicate, #1: 1	تَفَكُّرَ الصَّائِمِ
u'تَفَلُّتٌ قُرْآنٌ':Added, #1: 1	تَفَكَّرَ عَلِمَ
u'تَفَلَ نَبِيٌّ':Subject, #1: 1	تَفَلُّتَ الْقُرْآنِ
u'تَفْلِيسٌ حاكِمٌ':Added, #1: 1	تَفَلَ النَّبِيُّ
u'تَفْلِيسٌ غَائِبٌ':Added, #1: 1	تَفْلِيسُ الْحَاكِمِ
u'تَفْلِيسٌ غَرِيمٌ':Added, #1: 1	تَفْلِيسِ الْغَائِبِ
u'تَفَهَّمَ اِزْداد':Predicate, #1: 1	تَفْلِيسَ الْغَرِيمِ
u'تَفَهُّمٌ قُرْآنٌ':Added, #1: 1	تَفَهَّمَ ازْدَادَ
u'تَفَهُّمٌ كَلاَمٌ':Added, #1: 1	تَفَهُّمِ الْقُرْآنِ
u'تَفَهُّمٌ مَسْأَلَةٌ':Added, #1: 1	تَفَهُّمِ كَلَامِ
u'تَفْهِيمٌ إِرَادَةٌ':Added, #1: 1	تَفَهُّمِ مَسْأَلَةٍ
u'تَفْهِيمٌ إِرَادَةٌ':Added, #1: 1	تَفْهِيمُ إرَادَةِ
u'تَفْهِيمٌ أَصْحَابٌ':Added, #1: 1	تَفْهِيمِ إرَادَةِ
u'تَفْهِيمٌ قُرْآنٌ':Added, #1: 1	تَفْهِيمَ أَصْحَابِهِ
u'تَفْهِيمٌ مُبَالَغَةٌ':Added, #1: 1	تَفْهِيمَ الْقُرْآنِ
u'تَفْهِيمٌ مُبَالَغَةٌ':Added, #1: 1	تَفْهِيم الْمُبَالَغَةِ
u'تَفْهِيمٌ مراد':Added, #1: 1	تَفْهِيمُ الْمُبَالَغَةِ
u'تَفْهِيمٌ مُرَادٌ':Added, #1: 1	تَفْهِيمُ الْمُرَادِ
u'تَفْهِيمٌ مَعْقُولٌ':Added, #1: 1	تَفْهِيمُ الْمُرَادِ
u'تَفَوُّقٌ مِلْكٌ':Added, #1: 1	تَفْهِيمُ الْمَعْقُولِ
u'تَفْوِيضٌ أَبٌ':Added, #2: 2	تَفَوُّقِ الْمِلْكِ
u'تَفْوِيضٌ اِسْتيفاءٌ':Added, #1: 1	تَفْوِيضَ الْأَبِ
u'تَفْوِيضٌ أَصيلٌ':Added, #1: 1	تَفْوِيضِ اسْتِيفَاءِ
u'تَفْوِيضٌ الْمَرْأَةُ':Added, #1: 1	تَفْوِيضِ الْأَصِيلِ
u'تَفْوِيضٌ أَمْرٌ':Added, #1: 1	تَفْوِيضِ الْمَرْأَةِ
u'تَفْوِيضٌ أَمْرٌ':Added, #1: 1	تَفْوِيضَ أَمْرِهِ
u'تَفْوِيضٌ أَمْرٌ':Added, #1: 1	تَفْوِيضُ أَمْرِهِ
u'تَفْوِيضٌ أَمْرٌ':Added, #1: 1	تَفْوِيضِ أَمْرِهِ
u'تَفْوِيضٌ أَمْرٌ':Added, #2: 2	تَفْوِيضِ أَمْرِ
u'تَفْوِيضٌ أَمْرٌ':Added, #3: 3	تَفْوِيضُ الْأَمْرِ
u'تَفْوِيضٌ أَمْرٌ':Added, #3: 3	تَفْوِيضِ الْأَمْرِ
u'تَفْوِيضٌ أُمُورٌ':Added, #4: 4	تَفْوِيضَ الْأَمْرِ
u'تَفْوِيضٌ بَعْضٌ':Added, #1: 1	تَفْوِيضُ الْأُمُورِ
u'تَفْوِيضٌ تَدْرِيسٌ':Added, #1: 1	تَفْوِيضُ بَعْضِ
u'تَفْوِيضٌ تَصَرُّفٌ':Added, #2: 2	تَفْوِيضِ التَّدْرِيسِ
u'تَفْوِيضٌ تَوْكِيلٌ':Added, #3: 3	تَفْوِيضُ التَّصَرُّفِ
u'تَفْوِيضٌ ثَلاثُ':Added, #1: 1	تَفْوِيضُ تَوْكِيلٍ
u'تَفْوِيضٌ حِفْظٌ':Added, #1: 1	تَفْوِيضَ الثَّلَاثِ
u'تَفْوِيضٌ حُكْمٌ':Added, #1: 1	تَفْوِيضُ الْحِفْظِ
u'تَفْوِيضٌ خُلْعٌ':Added, #2: 2	تَفْوِيضِ الْحُكْمِ
u'تَفْوِيضٌ خيار':Added, #1: 1	تَفْوِيضُ الْخُلْعِ
u'تَفْوِيضٌ خِيَارٌ':Added, #1: 1	تَفْوِيضَ الْخِيَارِ
u'تَفْوِيضٌ رَأْيٌ':Added, #1: 1	تَفْوِيضَ الْخِيَارِ
u'تَفْوِيضٌ زَوْجٌ':Added, #1: 1	تَفْوِيضُ الرَّأْيِ
u'تَفْوِيضٌ سَمَاعٌ':Added, #1: 1	تَفْوِيضِ الزَّوْجِ
u'تَفْوِيضٌ شَخْصٌ':Added, #1: 1	تَفْوِيضَ سَمَاعِ
u'تَفْوِيضٌ صِفَةٌ':Added, #2: 2	تَفْوِيضُ شَخْصٍ
u'تَفْوِيضٌ صَلاَةٌ':Added, #1: 1	تَفْوِيضُ الصِّفَةِ
u'تَفْوِيضٌ طَلاَقٌ':Added, #1: 1	تَفْوِيضَ الصَّلَاةِ
u'تَفْوِيضٌ طَلاَقٌ':Added, #13: 13	تَفْوِيضِ الطَّلَاقِ
u'تَفْوِيضٌ طَلاَقٌ':Added, #1: 1	تَفْوِيضَ طَلَاقِ
u'تَفْوِيضٌ طَلاَقٌ':Added, #1: 1	تَفْوِيضُ طَلَاقِ
u'تَفْوِيضٌ طَلاَقٌ':Added, #2: 2	تَفْوِيضُ الطَّلَاقِ
u'تَفْوِيضٌ عتق':Added, #3: 3	تَفْوِيضَ الطَّلَاقِ
u'تَفْوِيضٌ عِتْقٌ':Added, #1: 1	تَفْوِيضُ عِتْقِهِ
u'تَفْوِيضٌ عَدَدٌ':Added, #1: 1	تَفْوِيضُ عِتْقِهِ
u'تَفْوِيضٌ عَدَدٌ':Added, #1: 1	تَفْوِيضُ الْعَدَدِ
u'تَفْوِيضٌ علم':Added, #1: 1	تَفْوِيضِ الْعَدَدِ
u'تَفْوِيضٌ علم':Added, #1: 1	تَفْوِيضَ الْعِلْمِ
u'تَفْوِيضٌ عِلْمٌ':Added, #1: 1	تَفْوِيضُ الْعِلْمِ
u'تَفْوِيضٌ عِلْمٌ':Added, #1: 1	تَفْوِيضَ الْعِلْمِ
u'تَفْوِيضٌ علم':Added, #1: 1	تَفْوِيضُ الْعِلْمِ
u'تَفْوِيضٌ عِلْمٌ':Added, #1: 1	تَفْوِيضُ عِلْمِ
u'تَفْوِيضٌ علم':Added, #1: 1	تَفْوِيضُ عِلْمِ
u'تَفْوِيضٌ عِلْمٌ':Added, #1: 1	تَفْوِيضِ عِلْمِهِ
u'تَفْوِيضٌ قَبُولٌ':Added, #1: 1	تَفْوِيضِ عِلْمِهِ
u'تَفْوِيضٌ مثل':Added, #2: 2	تَفْوِيضِ الْقَبُولِ
u'تَفْوِيضٌ مِثْلٌ':Added, #1: 1	تَفْوِيضُ مِثْلِ
u'تَفْوِيضٌ مَرِيضٌ':Added, #1: 1	تَفْوِيضُ مِثْلِ
u'تَفْوِيضٌ مَشِيئَةٌ':Added, #1: 1	تَفْوِيضَ الْمَرِيضَةِ
u'تَفْوِيضٌ مَعْرِفَةٌ':Added, #2: 2	تَفْوِيضُ الْمَشِيئَةِ
u'تَفْوِيضٌ مَعْرِفَة':Added, #1: 1	تَفْوِيضُ مَعْرِفَةِ
u'تَفْوِيضٌ مُعَيَّنٌ':Added, #1: 1	تَفْوِيضُ مَعْرِفَةِ
u'تَفْوِيضٌ مُكَاتَبَةٌ':Added, #1: 1	تَفْوِيضِ الْمُعَيَّنِ
u'تَفْوِيضٌ مَهْرٌ':Added, #1: 1	تَفْوِيضَ الْمُكَاتَبَةِ
u'تَفْوِيضٌ مَهْرٌ':Added, #1: 1	تَفْوِيضُ الْمَهْرِ
u'تَفْوِيضٌ مَهْرٌ':Added, #2: 2	تَفْوِيضُ مَهْرٍ
u'تَفْوِيضٌ نصب':Added, #3: 3	تَفْوِيضَ مَهْرٍ
u'تَفْوِيضٌ نَصْبٌ':Added, #2: 2	تَفْوِيضُ نَصْبِ
u'تَفْوِيضٌ نِيَّةٌ':Added, #2: 2	تَفْوِيضُ نَصْبِ
u'تَفْوِيضٌ وَصْفٌ':Added, #2: 2	تَفْوِيضُ النِّيَّةِ
u'تَفْوِيضٌ وَلِيٌّ':Added, #1: 1	تَفْوِيضَ وَصْفِ
u'تَقَابُلٌ إِثْبَاتٌ':Added, #1: 1	تَفْوِيضِ الْوَلِيِّ
u'تَقَابُلٌ أًصْلٌ':Added, #1: 1	تَقَابُلُ الْإِثْبَاتِ
u'تَقَابُلٌ أًصْلٌ':Added, #1: 1	تَقَابُلِ أَصْلَيْنِ
u'تَقَابُلٌ أصل':Added, #1: 1	تَقَابُلُ الْأَصْلَيْنِ
u'تَقَابُلٌ أًصْلٌ':Added, #2: 2	تَقَابُلِ الْأَصْلِ
u'تَقَابُلٌ أًصْلٌ':Added, #2: 2	تَقَابُلِ الْأَصْلِ
u'تَقَابَلَ بَائِعٌ':Subject, #4: 4	تَقَابُلِ الْأَصْلَيْنِ
u'تَقَابُلٌ تَضايُف':Added, #1: 1	تَقَابَلَ الْبَائِعُ
u'تَقَابُلٌ حَقٌّ':Added, #3: 3	تَقَابُلَ التَّضَايُفِ
u'تَقَابُلٌ خُبْثٌ':Added, #1: 1	تَقَابُلَ الْحَقِّ
u'تَقَابُلٌ دَليلٌ':Added, #1: 1	تَقَابُلُ الْخُبْثِ
u'تَقَابُلٌ ضِدٌّ':Added, #1: 1	تَقَابُلُ الدَّلِيلَيْنِ
u'تَقَابُلٌ ضِدٌّ':Added, #1: 1	تَقَابُلَ الضِّدَّيْنِ
u'تَقَابَلَ ظاهِرٌ':Subject, #1: 1	تَقَابُلُ الضِّدَّيْنِ
u'تَقَابُلٌ عَامٌّ':Added, #1: 1	تَقَابَلَ ظَاهِرُ
u'تَقَابُلٌ عَدَمٌ':Added, #1: 1	تَقَابُلِ الْعَامِّ
u'تَقَابُلٌ عَدَمٌ':Added, #1: 1	تَقَابُلَ الْعَدَمِ
u'تَقَابَلَ غَرَضٌ':Subject, #2: 2	تَقَابُلُ الْعَدَمِ
u'تَقَابُلٌ نَاسِخٌ':Added, #1: 1	تَقَابَلَ غَرَضُ
u'تَقَابُلٌ نَاسِخ':Added, #1: 1	تَقَابُلَ النَّاسِخِ
u'تَقَاتُلٌ زَيْدٌ':Added, #1: 1	تَقَابُلَ النَّاسِخِ
u'تَقَاتُلٌ قَوْمٌ':Added, #1: 1	تَقَاتُلِ زَيْدٍ
u'تَقَادَمَ إِسْلامٌ':Subject, #1: 1	تَقَاتُلُ الْقَوْمِ
u'تَقَادَمَ زَمانٌ':Subject, #1: 1	تَقَادَمَ إسْلَامُهُ
u'تَقَادَمَ عَهْدٌ':Subject, #5: 5	تَقَادَمَ الزَّمَانُ
u'تَقَادَمَ عَهْدٌ':Subject, #18: 18	تَقَادَمَ الْعَهْدُ
u'تَقَادَمَ مُكْثٌ':Subject, #2: 2	تَقَادَمَ عَهْدُهُ
u'تَقَادَمَ وُجُوبٌ':Subject, #1: 1	تَقَادَمَ مُكْثُ
u'تَقَارُبٌ أَسْواقٌ':Added, #1: 1	تَقَادَمَ وُجُوبُهُ
u'تَقَارَبَ أَمْرٌ':Subject, #1: 1	تَقَارُبُ أَسْوَاقِهِ
u'تَقَارُبٌ أَمْرٌ':Added, #1: 1	تَقَارَبَ أَمْرُ
u'تَقَارُبٌ أَوْصَافٌ':Added, #1: 1	تَقَارُبِ الْأَمْرِ
u'تَقَارُبٌ تَقْطيعٌ':Added, #1: 1	تَقَارُبِ الْأَوْصَافِ
u'تَقَارُبٌ جَوَانِبُ':Added, #1: 1	تَقَارُبِ تَقْطِيعِ
u'تَقَارَبَ خِلاَفٌ':Subject, #1: 1	تَقَارُبِ الْجَوَانِبِ
u'تَقَارُبٌ رَهْنٌ':Added, #1: 1	تَقَارَبَ الْخِلَافُ
u'تَقَارَبَ زَمانٌ':Subject, #1: 1	تَقَارُبِ الرَّهْنِ
u'تَقَارَبَ شَرَج':Subject, #1: 1	تَقَارَبَ زَمَانُ
u'تَقَارَبَ صُبْحٌ':Subject, #1: 1	تَقَارَبَ الشَّرَجُ
u'تَقَارُبٌ صُدُورٌ':Added, #1: 1	تَقَارَبَ الصُّبْحُ
u'تَقَارَبَ غُرُوبٌ':Subject, #1: 1	تَقَارُبُ صُدُورِ
u'تَقَارَبَ فَجْرٌ':Subject, #1: 1	تَقَارَبَ غُرُوبُ
u'تَقَارُبٌ فِعْلٌ':Added, #1: 1	تَقَارَبَ الْفَجْرُ
u'تَقَارُبٌ فلان':Added, #1: 1	تَقَارُبِ الْفِعْلَيْنِ
u'تَقَارُبٌ قُوَّةٌ':Added, #1: 1	تَقَارُبِ الْهَمْزَتَيْنِ
u'تَقَارُبٌ قُوَّة':Added, #1: 1	تَقَارُبِ الْقُوَّةِ
u'تَقَارُبٌ قِيمَةٌ':Added, #1: 1	تَقَارُبِ الْقُوَّةِ
u'تَقَارُبٌ مَطَالِعُ':Added, #1: 1	تَقَارُبِ الْقِيمَةِ
u'تَقَارَبَ نَاسٌ':Subject, #1: 1	تَقَارُبِ الْمَطَالِعِ
u'تَقَارُبٌ هَمْز':Added, #1: 1	تَقَارَبَ النّاسُ
u'تَقَارَنَ حُكْمٌ':Subject, #1: 1	تَقَارُبِ الْهَمْزَتَيْنِ
u'تَقَارُنٌ راء':Added, #2: 2	تَقَارَنَ الْحُكْمُ
u'تَقَارَنَ زَمَنٌ':Subject, #1: 1	تَقَارُنِ رَاءِ
u'تَقَارُنٌ عِوَضٌ':Added, #1: 1	تَقَارَنَ زَمَنُ
u'تَقَاسُمٌ دَيْنٌ':Added, #1: 1	تَقَارُنُ الْعِوَضَيْنِ
u'تَقَاسَمَ شَرِيكٌ':Subject, #2: 2	تَقَاسُمِ دَيْنٍ
u'تَقَاضَى اِبْنٌ':Predicate, #1: 1	تَقَاسَمَ شَرِيكَاهُ
u'تَقَاضَى أُجْرَةٌ':Predicate, #4: 4	تَقَاضَى ابْنَ
u'تَقَاضِي أُجْرَةٌ':Added, #1: 1	تَقَاضَى أُجْرَةَ
u'تَقَاضِي أُجْرَةٌ':Added, #1: 1	تَقَاضِيَ أُجْرَةِ
u'تَقَاضِي أُجْرَةٌ':Added, #1: 1	تَقَاضِي الْأُجْرَةِ
u'تَقَاضِي دَرَاهِمُ':Added, #1: 1	تَقَاضِيَ الْأُجْرَةِ
u'تَقَاضِي دَيْنٌ':Added, #2: 2	تَقَاضِي الدَّرَاهِمِ
u'تَقَاضِي دَيْنٌ':Added, #4: 4	تَقَاضِي دَيْنٍ
u'تَقَاضَى رَجُلٌ':Subject, #6: 6	تَقَاضِي الدَّيْنِ
u'تَقَاضَى رَسُولٌ':Predicate, #1: 1	تَقَاضَى الرَّجُلُ
u'تَقَاضَى مَطْلُوبٌ':Predicate, #2: 2	تَقَاضَى رَسُولَ
u'تَقَاطَرَ طَاهِرٌ':Subject, #1: 1	تَقَاضَى الْمَطْلُوبَ
u'تَقَاطَرَ قَوْمٌ':Subject, #1: 1	تَقَاطَرَ طَاهِرٌ
u'تَقَاطَرَ مَاءٌ':Subject, #1: 1	تَقَاطَرَ الْقَوْمُ
u'تَقَايَلَ مُؤَجِّرٌ':Subject, #2: 2	تَقَاطَرَ الْمَاءُ
u'تَقَبَّلَ أَرْبَعَةٌ':Subject, #1: 1	تَقَايَلَ الْمُؤَجِّرُ
u'تَقَبُّلٌ أَعْمَالٌ':Added, #2: 2	تَقَبَّلَ الْأَرْبَعَةُ
u'تَقَبَّلَ بَعْضٌ':Predicate, #1: 1	تَقَبُّلِ الْأَعْمَالِ
u'تَقَبُّلٌ بَيِّنَةٌ':Added, #2: 2	تَقَبَّلَ بَعْضَ
u'تَقَبَّلَ تِلْميذٌ':Subject, #1: 1	تَقَبُّلِ بَيِّنَتِهِ
u'تَقَبَّلَ جَازٌ':Predicate, #1: 1	تَقَبَّلَ التِّلْمِيذُ
u'تَقَبُّلٌ حَمْلٌ':Added, #1: 1	تَقَبَّلَ جَازَ
u'تَقَبَّلَ رَجُلٌ':Subject, #1: 1	تَقَبُّلُ الْحَمْلِ
u'تَقَبُّلٌ صَاحِبٌ':Added, #1: 1	تَقَبَّلَ الرَّجُلُ
u'تَقَبَّلَ طعام':Predicate, #1: 1	تَقَبُّلِ صَاحِبِهِ
u'تَقَبَّلَ طَعَامٌ':Predicate, #1: 1	تَقَبَّلَ الطَّعَامَ
u'تَقَبُّلٌ عَدَالَةٌ':Added, #1: 1	تَقَبَّلَ الطَّعَامَ
u'تَقَبَّلَ عَمَلٌ':Predicate, #1: 1	تَقَبُّلُ الْعَدَالَةِ
u'تَقَبُّلٌ عَمَلٌ':Added, #1: 1	تَقَبَّلَ الْعَمَلَ
u'تَقَبَّلَ فُلاَنٌ':Subject, #1: 1	تَقَبُّلَ عَمَلٍ
u'تَقَبَّلَ فُلاَنٌ':Subject, #1: 1	تَقَبَّلَ فُلَانُ
u'تَقَبُّلٌ فُلاَنٌ':Added, #2: 2	تَقَبَّلَ فُلَانٌ
u'تَقَبُّلٌ كُتُبٌ':Added, #1: 1	تَقَبُّلُ فُلَانٍ
u'تَقَحَّمَ نَارٌ':Predicate, #1: 1	تَقَبُّلِ كُتُبِ
u'تَقَدَّرَ إِيجَارٌ':Subject, #1: 1	تَقَحَّمَ النَّارَ
u'تَقَدُّرٌ دَرْسٌ':Added, #1: 1	تَقَدَّرَ إيجَارُ
u'تَقَدَّرَ رِزْقٌ':Subject, #1: 1	تَقَدُّرَ دَرْسِهِ
u'تَقَدَّرَ طعام':Subject, #1: 1	تَقَدَّرَ رِزْقُهُ
u'تَقَدَّرَ طَعَامٌ':Subject, #2: 2	تَقَدَّرَ الطَّعَامُ
u'تَقَدُّمٌ إبَاحَةٌ':Added, #2: 2	تَقَدَّرَ الطَّعَامُ
u'تَقَدُّمٌ إِبَانَةٌ':Added, #1: 1	تَقَدُّمِ إبَاحَةِ
u'تَقَدَّمَ اِبْنٌ':Subject, #1: 1	تَقَدُّمِ الْإِبَانَةِ
u'تَقَدَّمَ أثَرٌ':Subject, #1: 1	تَقَدَّمَ ابْنُ
u'تَقَدَّمَ إجَارَةٌ':Subject, #1: 1	تَقَدَّمَ الْأَثَرُ
u'تَقَدَّمَ إِجْزَاءٌ':Subject, #1: 1	تَقَدَّمَ إجَارَةٌ
u'تَقَدَّمَ إِجْمَاعٌ':Subject, #1: 1	تَقَدَّمَ الْإِجْزَاءُ
u'تَقَدُّمٌ إِجْمَاعٌ':Added, #3: 3	تَقَدَّمَ الْإِجْمَاعُ
u'تَقَدُّمٌ إِجْمَالٌ':Added, #2: 2	تَقَدُّمِ الْإِجْمَاعِ
u'تَقَدَّمَ أَجْنَبِيٌّ':Subject, #1: 1	تَقَدُّمِ إجْمَالٍ
u'تَقَدُّمٌ أَجْنَبِيٌّ':Added, #2: 2	تَقَدَّمَ أَجْنَبِيٌّ
u'تَقَدَّمَ اِحْتِمَالٌ':Subject, #1: 1	تَقَدُّمِ الْأَجْنَبِيِّ
u'تَقَدَّمَ أحَدٌ':Subject, #1: 1	تَقَدَّمَ احْتِمَالٌ
u'تَقَدُّمٌ أحَدٌ':Added, #1: 1	تَقَدَّمَ أَحَدٌ
u'تَقَدُّمٌ أحَدٌ':Added, #1: 1	تَقَدُّمِ أَحَدٍ
u'تَقَدَّمَ إِحْرَامٌ':Subject, #2: 2	تَقَدُّمُ أَحَدِ
u'تَقَدَّمَ إِحْرَامٌ':Subject, #1: 1	تَقَدَّمَ إحْرَامُ
u'تَقَدُّمٌ إِحْرَامٌ':Added, #1: 1	تَقَدَّمَ إحْرَامُهُ
u'تَقَدُّمٌ إِحْرَامٌ':Added, #1: 1	تَقَدُّمِ إحْرَامِهِ
u'تَقَدُّمٌ إِحْرَامٌ':Added, #1: 1	تَقَدُّمِ الْإِحْرَامِ
u'تَقَدُّمٌ إِحْرَامٌ':Added, #2: 2	تَقَدُّمَ إحْرَامِ
u'تَقَدَّمَ أَحْكَامٌ':Subject, #3: 3	تَقَدُّمُ إحْرَامِ
u'تَقَدَّمَ أَحْكَامٌ':Subject, #1: 1	تَقَدَّمَ أَحْكَامُ
u'تَقَدُّمٌ أَخٌ':Added, #1: 1	تَقَدَّمَ أَحْكَامُهُ
u'تَقَدَّمَ أَدَاءٌ':Subject, #1: 1	تَقَدُّمُ الْأَخِ
u'تَقَدَّمَ آدَمُ':Predicate, #1: 1	تَقَدَّمَ أَدَاءُ
u'تَقَدَّمَ إِذْنٌ':Subject, #1: 1	تَقَدَّمَ آدَمَ
u'تَقَدُّمٌ إِرَادَةٌ':Added, #2: 2	تَقَدَّمَ الْإِذْنُ
u'تَقَدَّمَ إِرْثٌ':Subject, #1: 1	تَقَدُّمُ إرَادَةِ
u'تَقَدُّمٌ إِرْسَالٌ':Added, #1: 1	تَقَدَّمَ الْإِرْثُ
u'تَقَدَّمَ اِسْتِحْسَانٌ':Subject, #1: 1	تَقَدُّمَ الْإِرْسَالِ
u'تَقَدَّمَ اِسْتِحْقَاقٌ':Subject, #1: 1	تَقَدَّمَ اسْتِحْسَانٌ
u'تَقَدُّمٌ اِسْتِحْقَاقٌ':Added, #1: 1	تَقَدَّمَ اسْتِحْقَاقُ
u'تَقَدَّمَ اِسْتيفاءٌ':Subject, #2: 2	تَقَدُّمُ اسْتِحْقَاقِ
u'تَقَدَّمَ إِسْلامٌ':Subject, #2: 2	تَقَدَّمَ اسْتِيفَاءُ
u'تَقَدَّمَ إِسْلامٌ':Subject, #1: 1	تَقَدَّمَ إسْلَامُ
u'تَقَدَّمَ إِسْلامٌ':Subject, #2: 2	تَقَدَّمَ إِسْلاَمُهُ
u'تَقَدَّمَ إِسْلامٌ':Subject, #2: 2	تَقَدَّمَ الْإِسْلَامُ
u'تَقَدُّمٌ إِسْلامٌ':Added, #6: 6	تَقَدَّمَ إسْلَامُهُ
u'تَقَدُّمٌ إِسْلامٌ':Added, #1: 1	تَقَدُّمُ إسْلَامِ
u'تَقَدُّمٌ إِسْلامٌ':Added, #1: 1	تَقَدُّمِ إسْلَامِ
u'تَقَدُّمٌ إِسْلامٌ':Added, #2: 2	تَقَدُّمَ إسْلَامِهِ
u'تَقَدَّمَ اِسْمٌ':Subject, #2: 2	تَقَدُّمِ الْإِسْلَامِ
u'تَقَدَّمَ أسْوَد':Subject, #1: 1	تَقَدَّمَ اسْمُهُ
u'تَقَدَّمَ اِشْتِراطٌ':Subject, #1: 1	تَقَدَّمَ الْأَسْوَدُ
u'تَقَدَّمَ إِشْعارٌ':Subject, #1: 1	تَقَدَّمَ اشْتِرَاطُ
u'تَقَدَّمَ أَشْيَاءٌ':Subject, #1: 1	تَقَدَّمَ إشْعَارٌ
u'تَقَدُّمٌ أصل':Added, #1: 1	تَقَدَّمَ أَشْيَاءُ
u'تَقَدُّمٌ أصل':Added, #1: 1	تَقَدُّمُ أَصْلِ
u'تَقَدُّمٌ أًصْلٌ':Added, #1: 1	تَقَدُّمِ أَصْلِ
u'تَقَدُّمٌ أًصْلٌ':Added, #1: 1	تَقَدُّمُ أَصْلِ
u'تَقَدَّمَ إِطْلاقٌ':Subject, #1: 1	تَقَدُّمِ أَصْلِ
u'تَقَدَّمَ أظهر':Subject, #2: 2	تَقَدَّمَ إطْلَاقُ
u'تَقَدُّمٌ إِعْتاقٌ':Added, #1: 1	تَقَدَّمَ أَظْهَرُ
u'تَقَدَّمَ اِعْتِبارٌ':Subject, #1: 1	تَقَدُّمَ إعْتَاقِهِ
u'تَقَدَّمَ اِعْتِراضٌ':Subject, #2: 2	تَقَدَّمَ اعْتِبَارُ
u'تَقَدُّمٌ اِفْتِضاض':Added, #1: 1	تَقَدَّمَ اعْتِرَاضُ
u'تَقَدُّمٌ أفْضَلُ':Added, #1: 1	تَقَدُّمُ افْتِضَاضٍ
u'تَقَدَّمَ إقْرَارٌ':Subject, #1: 1	تَقَدُّمِ الْأَفْضَلِ
u'تَقَدُّمٌ إقْرَارٌ':Added, #2: 2	تَقَدَّمَ إقْرَارُهُ
u'تَقَدَّمَ أَقْسَامٌ':Subject, #1: 1	تَقَدُّمِ الْإِقْرَارِ
u'تَقَدَّمَ أَكْثَرُ':Subject, #1: 1	تَقَدَّمَ أَقْسَامُ
u'تَقَدَّمَ أكل':Subject, #2: 2	تَقَدَّمَ أَكْثَرُ
u'تَقَدَّمَ أَكْلٌ':Subject, #1: 1	تَقَدَّمَ أَكْلُ
u'تَقَدَّمَ إلْحَاقٌ':Subject, #1: 1	تَقَدَّمَ أَكْلُ
u'تَقَدُّمٌ إِلْزَامٌ':Added, #1: 1	تَقَدَّمَ الْإِلْحَاقُ
u'تَقَدَّمَ ألف':Subject, #1: 1	تَقَدُّمِ الْإِلْزَامِ
u'تَقَدَّمَ ألْفٌ':Subject, #1: 1	تَقَدَّمَ الْأَلْفُ
u'تَقَدَّمَ أَلْفٌ':Subject, #1: 1	تَقَدَّمَ الْأَلْفُ
u'تَقَدُّمٌ أُمٌّ':Added, #1: 1	تَقَدَّمَ الْأَلْفُ
u'تَقَدُّمٌ أُمٌّ':Added, #1: 1	تَقَدُّمَ أُمِّ
u'تَقَدَّمَ إمَامٌ':Predicate, #1: 1	تَقَدُّمُ أُمِّ
u'تَقَدَّمَ إمَامٌ':Subject, #1: 1	تَقَدَّمَ الْإِمَامَ
u'تَقَدَّمَ إمَامٌ':Subject, #1: 1	تَقَدَّمَ الْإِمَامُ
u'تَقَدُّمٌ إمَامٌ':Added, #1: 1	تَقَدَّمَ إمَامُهُ
u'تَقَدُّمٌ إمَامٌ':Added, #1: 1	تَقَدُّمُ الْإِمَامِ
u'تَقَدَّمَ أمثال':Subject, #7: 7	تَقَدُّمِ الْإِمَامِ
u'تَقَدَّمَ أَمْثَالٌ':Subject, #1: 1	تَقَدَّمَ أَمْثَالُهُ
u'تَقَدَّمَ أَمْرٌ':Subject, #1: 1	تَقَدَّمَ أَمْثَالُهُ
u'تَقَدُّمٌ أَمْرٌ':Added, #2: 2	تَقَدَّمَ الْأَمْرُ
u'تَقَدُّمٌ أَمْرٌ':Added, #1: 1	تَقَدُّمُ الْأَمْرِ
u'تَقَدَّمَ أُمُورٌ':Subject, #2: 2	تَقَدُّمِ الْأَمْرِ
u'تَقَدَّمَ إِنْسانٌ':Subject, #1: 1	تَقَدَّمَ أُمُورٌ
u'تَقَدَّمَ اِنْعِقَادٌ':Subject, #1: 1	تَقَدَّمَ إنْسَانٌ
u'تَقَدُّمٌ إِنْكارٌ':Added, #1: 1	تَقَدَّمَ انْعِقَادُ
u'تَقَدَّمَ أهْلٌ':Subject, #2: 2	تَقَدُّمُ الْإِنْكَارِ
u'تَقَدَّمَ أوائل':Predicate, #2: 2	تَقَدَّمَ أَهْلُ
u'تَقَدَّمَ أَوَّلُ':Predicate, #2: 2	تَقَدَّمَ أَوَائِلَ
u'تَقَدَّمَ أَوَّلُ':Subject, #22: 22	تَقَدَّمَ أَوَّلَ
u'تَقَدَّمَ أَوَّلُ':Subject, #1: 1	تَقَدَّمَ أَوَّلُ
u'تَقَدُّمٌ أَوَّلُ':Added, #2: 2	تَقَدَّمَ الْأَوَّلُ
u'تَقَدُّمٌ أَوَّلُ':Added, #1: 1	تَقَدُّمَ الْأَوَّلِ
u'تَقَدَّمَ أئِمَّةٌ':Subject, #2: 2	تَقَدُّمِ الْأَوَّلِ
u'تَقَدَّمَ آيَةٌ':Predicate, #1: 1	تَقَدَّمَ أَئِمَّةٌ
u'تَقَدَّمَ إِيجَابٌ':Subject, #1: 1	تَقَدَّمَ آيَةَ
u'تَقَدُّمٌ إِيجَابٌ':Added, #3: 3	تَقَدَّمَ الْإِيجَابُ
u'تَقَدُّمٌ إِيجَابٌ':Added, #1: 1	تَقَدُّمُ الْإِيجَابِ
u'تَقَدَّمَ أَيْسَرُ':Subject, #1: 1	تَقَدُّمُ إيجَابٍ
u'تَقَدُّمٌ إيقَاعٌ':Added, #1: 1	تَقَدَّمَ الْأَيْسَرُ
u'تَقَدُّمٌ إيمَانٌ':Added, #1: 1	تَقَدُّمِ الْإِيقَاعِ
u'تَقَدَّمَ بَحْثٌ':Subject, #1: 1	تَقَدُّمِ الْإِيمَانِ
u'تَقَدَّمَ بَحْثٌ':Subject, #1: 1	تَقَدَّمَ بَحْثُ
u'تَقَدَّمَ بَرٌّ':Subject, #4: 4	تَقَدَّمَ الْبَحْثُ
u'تَقَدَّمَ بسط':Subject, #1: 1	تَقَدَّمَ الْبَرُّ
u'تَقَدَّمَ بَسْطٌ':Subject, #2: 2	تَقَدَّمَ بَسْطُهُ
u'تَقَدَّمَ بسط':Subject, #2: 2	تَقَدَّمَ بَسْطُهُ
u'تَقَدَّمَ بَسْطٌ':Subject, #3: 3	تَقَدَّمَ بَسْطُ
u'تَقَدَّمَ بُطْلان':Subject, #3: 3	تَقَدَّمَ بَسْطُ
u'تَقَدَّمَ بَعْضٌ':Subject, #4: 4	تَقَدَّمَ بُطْلَانُهُ
u'تَقَدَّمَ بَعْضٌ':Subject, #6: 6	تَقَدَّمَ بَعْضُ
u'تَقَدُّمٌ بَعْضٌ':Added, #6: 6	تَقَدَّمَ بَعْضُهُ
u'تَقَدُّمٌ بَعْضٌ':Added, #1: 1	تَقَدُّمَ بَعْضِ
u'تَقَدَّمَ بِنَاءٌ':Predicate, #1: 1	تَقَدُّمِ بَعْضِ
u'تَقَدَّمَ بَيَانٌ':Subject, #1: 1	تَقَدَّمَ الْبِنَاءَ
u'تَقَدَّمَ بَيَانٌ':Subject, #144: 144	تَقَدَّمَ بَيَانُهُ
u'تَقَدَّمَ بَيْعٌ':Subject, #43: 43	تَقَدَّمَ بَيَانُ
u'تَقَدَّمَ بَيْعٌ':Subject, #1: 1	تَقَدَّمَ الْبَيْعُ
u'تَقَدَّمَ بَيْعٌ':Subject, #1: 1	تَقَدَّمَ بَيْعٌ
u'تَقَدَّمَ بَيْنٌ':Predicate, #1: 1	تَقَدَّمَ بَيْعُهُ
u'تَقْدِمَةٌ إِسْلامٌ':Added, #4: 4	تَقَدَّمَ بَيْنَ
u'تَقْدِمَةٌ صَغِيرٌ':Added, #1: 1	تَقْدِمَةِ إسْلَامِ
u'تَقْدِمَةٌ نَاسِخٌ':Added, #1: 1	تَقْدِمَةِ الصَّغِيرِ
u'تَقْدِمَةٌ نَاسِخ':Added, #1: 1	تَقْدِمَةَ نَاسِخٍ
u'تَقَدَّمَ تَارِيخٌ':Subject, #1: 1	تَقْدِمَةَ نَاسِخٍ
u'تَقَدُّمٌ تَارِيخٌ':Added, #1: 1	تَقَدَّمَ تَارِيخُ
u'تَقَدُّمٌ تَارِيخٌ':Added, #1: 1	تَقَدُّمِ التَّارِيخِ
u'تَقَدَّمَ تَأْصِيلٌ':Subject, #1: 1	تَقَدُّمُ تَارِيخِهِ
u'تَقَدُّمٌ تَبَع':Added, #1: 1	تَقَدَّمَ تَأْصِيلُهُ
u'تَقَدُّمٌ تَبَع':Added, #1: 1	تَقَدُّمُ التَّبَعِ
u'تَقَدُّمٌ تَبَعِيّ':Added, #1: 1	تَقَدُّمِ تَبَعِيَّةِ
u'تَقَدُّمٌ تَبَعِيَّة':Added, #1: 1	تَقَدُّمِ تَبَعِيَّةِ
u'تَقَدَّمَ تَبْيِين':Subject, #1: 1	تَقَدُّمِ تَبَعِيَّةِ
u'تَقَدَّمَ تَحْرِيرٌ':Subject, #1: 1	تَقَدَّمَ تَبْيِينُهُ
u'تَقَدَّمَ تَحْرِيرٌ':Subject, #1: 1	تَقَدَّمَ تَحْرِيرُ
u'تَقَدُّمٌ تَحَقُّقٌ':Added, #1: 1	تَقَدَّمَ تَحْرِيرُهُ
u'تَقَدَّمَ تَحْقِيقٌ':Subject, #1: 1	تَقَدُّمَ تَحَقُّقِ
u'تَقَدَّمَ تَخْرِيجٌ':Subject, #2: 2	تَقَدَّمَ تَحْقِيقُهُ
u'تَقَدَّمَ تَخْرِيجٌ':Subject, #1: 1	تَقَدَّمَ تَخْرِيجٌ
u'تَقَدَّمَ تَخْرِيجٌ':Subject, #1: 1	تَقَدَّمَ تَخْرِيجُ
u'تَقَدُّمٌ تَخْصِيصٌ':Added, #3: 3	تَقَدَّمَ تَخْرِيجُهُ
u'تَقَدَّمَ تَخْيِيرٌ':Subject, #1: 1	تَقَدُّمُ التَّخْصِيصِ
u'تَقَدَّمَ تَدْبِيرٌ':Subject, #1: 1	تَقَدَّمَ التَّخْيِيرُ
u'تَقَدَّمَ تَرْتِيبٌ':Predicate, #1: 1	تَقَدَّمَ التَّدْبِيرُ
u'تَقَدَّمَ تَرْجِيحٌ':Subject, #1: 1	تَقَدَّمَ تَرْتِيبَ
u'تَقَدَّمَ تَرْشِيحٌ':Subject, #1: 1	تَقَدَّمَ تَرْجِيحُ
u'تَقَدَّمَ تَزْييفٌ':Subject, #1: 1	تَقَدَّمَ تَرْشِيحُ
u'تَقَدَّمَ تَسْطِيرٌ':Subject, #1: 1	تَقَدَّمَ تَزْيِيفُهُ
u'تَقَدَّمَ تَصْحِيحٌ':Subject, #1: 1	تَقَدَّمَ تَسْطِيرُهُ
u'تَقَدَّمَ تَصَرُّفٌ':Subject, #3: 3	تَقَدَّمَ تَصْحِيحُهُ
u'تَقَدَّمَ تَصْرِيحٌ':Subject, #1: 1	تَقَدَّمَ تَصَرُّفُهُ
u'تَقَدَّمَ تَضْعِيفٌ':Subject, #2: 2	تَقَدَّمَ التَّصْرِيحُ
u'تَقَدَّمَ تَعْرِيفٌ':Subject, #1: 1	تَقَدَّمَ تَضْعِيفُهُ
u'تَقَدَّمَ تَعْرِيفٌ':Subject, #1: 1	تَقَدَّمَ تَعْرِيفٌ
u'تَقَدُّمٌ تَعَلُّقٌ':Added, #2: 2	تَقَدَّمَ تَعْرِيفُهُ
u'تَقَدَّمَ تَعْلِيقٌ':Subject, #1: 1	تَقَدُّمِ تَعَلُّقِهِ
u'تَقَدَّمَ تَعْلِيقٌ':Subject, #1: 1	تَقَدَّمَ التَّعْلِيقُ
u'تَقَدُّمٌ تَعْلِيمٌ':Added, #1: 1	تَقَدَّمَ تَعْلِيقُ
u'تَقَدَّمَ تَفَاصِيلُ':Subject, #1: 1	تَقَدُّمِ تَعْلِيمٍ
u'تَقَدَّمَ تَفَاصِيلُ':Subject, #1: 1	تَقَدَّمَ تَفَاصِيلُ
u'تَقَدَّمَ تَفْسِيرٌ':Subject, #1: 1	تَقَدَّمَ تَفَاصِيلُهُ
u'تَقَدَّمَ تَفْسِيرٌ':Subject, #2: 2	تَقَدَّمَ تَفْسِيرُ
u'تَقَدَّمَ تَفْصِيلٌ':Subject, #5: 5	تَقَدَّمَ تَفْسِيرُهُ
u'تَقَدَّمَ تَقْديرٌ':Subject, #1: 1	تَقَدَّمَ تَفْصِيلُهُ
u'تَقَدَّمَ تَقْريرٌ':Subject, #2: 2	تَقَدَّمَ تَقْدِيرُهُ
u'تَقَدَّمَ تَقْسِيمٌ':Subject, #7: 7	تَقَدَّمَ تَقْرِيرُهُ
u'تَقَدَّمَ تَقْليمٌ':Subject, #1: 1	تَقَدَّمَ تَقْسِيمُهُ
u'تَقَدَّمَ تَقْيِيد':Subject, #1: 1	تَقَدَّمَ تَقْلِيمُ
u'تَقَدَّمَ تَكْبيرٌ':Subject, #1: 1	تَقَدَّمَ تَقْيِيدُ
u'تَقَدَّمَ تمام':Subject, #1: 1	تَقَدَّمَ التَّكْبِيرُ
u'تَقَدَّمَ تَمامٌ':Subject, #1: 1	تَقَدَّمَ تَمَامُ
u'تَقَدَّمَ تَمْثيلٌ':Subject, #1: 1	تَقَدَّمَ تَمَامُ
u'تَقَدَّمَ تَمْثيلٌ':Subject, #1: 1	تَقَدَّمَ تَمْثِيلُ
u'تَقَدَّمَ تَنْبِيه':Subject, #1: 1	تَقَدَّمَ تَمْثِيلُهُ
u'تَقَدَّمَ تَنْبِيهٌ':Subject, #13: 13	تَقَدَّمَ التَّنْبِيهُ
u'تَقَدُّمٌ تَوْبَةٌ':Added, #1: 1	تَقَدَّمَ تَنْبِيهٌ
u'تَقَدَّمَ تَوْجِيهٌ':Subject, #1: 1	تَقَدُّمُ التَّوْبَةِ
u'تَقَدُّمٌ ثَانِي':Added, #2: 2	تَقَدَّمَ تَوْجِيهُهُ
u'تَقَدُّمٌ ثَانِيَةٌ':Added, #1: 1	تَقَدُّمُ الثَّانِيَةِ
u'تَقَدُّمٌ ثُبُوتٌ':Added, #1: 1	تَقَدُّمُ الثَّانِيَةِ
u'تَقَدُّمٌ ثُبُوتٌ':Added, #1: 1	تَقَدُّمَ الثُّبُوتِ
u'تَقَدَّمَ ثَلاثَةٌ':Subject, #1: 1	تَقَدُّمِ ثُبُوتِ
u'تَقَدُّمٌ جَارِي':Added, #1: 1	تَقَدَّمَ ثَلَاثَةُ
u'تَقَدُّمٌ جَارِيَةٌ':Added, #1: 1	تَقَدُّمِ الْجَارِيَةِ
u'تَقَدَّمَ جَازٌ':Predicate, #1: 1	تَقَدُّمِ الْجَارِيَةِ
u'تَقَدَّمَ جَائِزٌ':Subject, #3: 3	تَقَدَّمَ جَازَ
u'تَقَدَّمَ جَزَاءٌ':Subject, #1: 1	تَقَدَّمَ جَائِزٌ
u'تَقَدُّمٌ جلد':Added, #1: 1	تَقَدَّمَ الْجَزَاءُ
u'تَقَدُّمٌ جَلْدٌ':Added, #1: 1	تَقَدُّمِ جَلْدِ
u'تَقَدَّمَ جمع':Subject, #1: 1	تَقَدُّمِ جَلْدِ
u'تَقَدَّمَ جَمْعٌ':Subject, #1: 1	تَقَدَّمَ الْجَمْعُ
u'تَقَدُّمٌ جمع':Added, #1: 1	تَقَدَّمَ الْجَمْعُ
u'تَقَدُّمٌ جمع':Added, #1: 1	تَقَدُّمَ الْجَمْعِ
u'تَقَدُّمٌ جَمْعٌ':Added, #1: 1	تَقَدُّمِ الْجَمْعِ
u'تَقَدُّمٌ جَمْعٌ':Added, #1: 1	تَقَدُّمَ الْجَمْعِ
u'تَقَدُّمٌ جَمْعٌ':Added, #1: 1	تَقَدُّمِ الْجَمْعِ
u'تَقَدَّمَ جَمِيع':Subject, #1: 1	تَقَدُّمَ الْجَمْعَيْنِ
u'تَقَدُّمٌ جَمِيع':Added, #1: 1	تَقَدَّمَ الْجَمِيعُ
u'تَقَدُّمٌ جِنَايَةٌ':Added, #1: 1	تَقَدُّمِ الْجَمِيعِ
u'تَقَدَّمَ جَوَابٌ':Subject, #1: 1	تَقَدُّمِ جِنَايَةِ
u'تَقَدَّمَ جَوَابٌ':Subject, #2: 2	تَقَدَّمَ جَوَابُهُ
u'تَقَدَّمَ جَوَازٌ':Subject, #7: 7	تَقَدَّمَ الْجَوَابُ
u'تَقَدَّمَ جَوَازٌ':Subject, #1: 1	تَقَدَّمَ الْجَوَازُ
u'تَقَدَّمَ حالٌ':Predicate, #1: 1	تَقَدَّمَ جَوَازُهُ
u'تَقَدَّمَ حالٌ':Subject, #1: 1	تَقَدَّمَ حَالَ
u'تَقَدَّمَ حالٌ':Subject, #1: 1	تَقَدَّمَ حَالُ
u'تَقَدُّمٌ حَجْرٌ':Added, #1: 1	تَقَدَّمَ حَالُهُ
u'تَقَدَّمَ حَدٌّ':Predicate, #1: 1	تَقَدُّمِ حَجْرٍ
u'تَقَدَّمَ حَديثٌ':Predicate, #1: 1	تَقَدَّمَ حَدَّ
u'تَقَدَّمَ حَديثٌ':Subject, #1: 1	تَقَدَّمَ حَدِيثَ
u'تَقَدَّمَ حَديثٌ':Subject, #15: 15	تَقَدَّمَ حَدِيثُ
u'تَقَدَّمَ حَديثٌ':Subject, #3: 3	تَقَدَّمَ الْحَدِيثُ
u'تَقَدَّمَ حَطَبٌ':Predicate, #3: 3	تَقَدَّمَ حَدِيثُهُ
u'تَقَدُّمٌ حَظْر':Added, #1: 1	تَقَدَّمَ الْحَطَبَ
u'تَقَدُّمٌ حَظْر':Added, #2: 2	تَقَدُّمِ حَظْرٍ
u'تَقَدُّمٌ حَفْرٌ':Added, #3: 3	تَقَدُّمَ الْحَظْرِ
u'تَقَدُّمٌ حُقوقٌ':Added, #1: 1	تَقَدُّمِ الْحَفْرِ
u'تَقَدُّمٌ حُقُوقٌ':Added, #1: 1	تَقَدُّمِ حُقُوقِ
u'تَقَدَّمَ حِكَايَةٌ':Subject, #1: 1	تَقَدُّمِ حُقُوقِ
u'تَقَدَّمَ حُكْمٌ':Predicate, #2: 2	تَقَدَّمَ حِكَايَةُ
u'تَقَدَّمَ حُكْمٌ':Subject, #1: 1	تَقَدَّمَ حُكْمَ
u'تَقَدَّمَ حُكْمٌ':Subject, #22: 22	تَقَدَّمَ حُكْمُ
u'تَقَدَّمَ حُكْمٌ':Subject, #3: 3	تَقَدَّمَ الْحُكْمُ
u'تَقَدُّمٌ حُكْمٌ':Added, #6: 6	تَقَدَّمَ حُكْمُهُ
u'تَقَدُّمٌ حُكْمٌ':Added, #1: 1	تَقَدُّمُ الْحُكْمِ
u'تَقَدُّمٌ حُكْمٌ':Added, #1: 1	تَقَدُّمُ حُكْمِ
u'تَقَدُّمٌ حَمْلٌ':Added, #2: 2	تَقَدُّمَ الْحُكْمِ
u'تَقَدَّمَ حَيْضٌ':Subject, #1: 1	تَقَدُّمَ الْحَمْلِ
u'تَقَدُّمٌ حَيْضٌ':Added, #1: 1	تَقَدَّمَ الْحَيْضُ
u'تَقَدَّمَ خاصّ':Subject, #1: 1	تَقَدُّمَ الْحَيْضِ
u'تَقَدُّمٌ خاصّ':Added, #1: 1	تَقَدَّمَ الْخَاصُّ
u'تَقَدُّمٌ خاصّ':Added, #1: 1	تَقَدُّمَ الْخَاصِّ
u'تَقَدُّمٌ خَبَرٌ':Added, #1: 1	تَقَدُّمُ الْخَاصِّ
u'تَقَدُّمٌ خَبَر':Added, #1: 1	تَقَدُّمَ الْخَبَرِ
u'تَقَدَّمَ خَرَابٌ':Subject, #1: 1	تَقَدُّمَ الْخَبَرِ
u'تَقَدَّمَ خُرُوجٌ':Subject, #2: 2	تَقَدَّمَ خَرَابُهُ
u'تَقَدُّمٌ خُرُوجٌ':Added, #1: 1	تَقَدَّمَ الْخُرُوجُ
u'تَقَدُّمٌ خُصُومَةٌ':Added, #1: 1	تَقَدُّمُ خُرُوجِ
u'تَقَدُّمٌ خطبة':Added, #1: 1	تَقَدُّمَ خُصُومَةٍ
u'تَقَدُّمٌ خُطْبَةٌ':Added, #1: 1	تَقَدُّمُ الْخُطْبَةِ
u'تَقَدُّمٌ خطبة':Added, #1: 1	تَقَدُّمُ الْخُطْبَةِ
u'تَقَدُّمٌ خِطْبَةٌ':Added, #1: 1	تَقَدُّمُ خِطْبَةِ
u'تَقَدَّمَ خِلاَفٌ':Subject, #1: 1	تَقَدُّمُ خِطْبَةِ
u'تَقَدَّمَ خِلاَفٌ':Subject, #2: 2	تَقَدَّمَ خِلَافٌ
u'تَقَدَّمَ خِلاَفٌ':Subject, #3: 3	تَقَدَّمَ خِلَافُهُ
u'تَقَدُّمٌ خُلْعٌ':Added, #9: 9	تَقَدَّمَ الْخِلَافُ
u'تَقَدُّمٌ خُلْعٌ':Added, #1: 1	تَقَدُّمِ الْخُلْعِ
u'تَقَدَّمَ خَيْلٌ':Predicate, #1: 1	تَقَدُّمُ خُلْعٍ
u'تَقَدُّمٌ دَاخِلٌ':Added, #1: 1	تَقَدَّمَ الْخَيْلَ
u'تَقَدَّمَ دُعَاءٌ':Subject, #1: 1	تَقَدُّمِ الدَّاخِلِ
u'تَقَدَّمَ دفع':Subject, #1: 1	تَقَدَّمَ الدُّعَاءُ
u'تَقَدَّمَ دَفْعٌ':Subject, #1: 1	تَقَدَّمَ دَفْعُ
u'تَقَدَّمَ دَلالَةٌ':Subject, #1: 1	تَقَدَّمَ دَفْعُ
u'تَقَدَّمَ دَليلٌ':Subject, #1: 1	تَقَدَّمَ دَلَالَتُهُ
u'تَقَدَّمَ دَليلٌ':Subject, #1: 1	تَقَدَّمَ دَلِيلُ
u'تَقَدَّمَ دَليلٌ':Subject, #3: 3	تَقَدَّمَ الدَّلِيلُ
u'تَقَدَّمَ دَمٌ':Subject, #4: 4	تَقَدَّمَ دَلِيلُهُ
u'تَقَدَّمَ دونٌ':Predicate, #1: 1	تَقَدَّمَ دَمٌ
u'تَقَدَّمَ دَيْنٌ':Subject, #4: 4	تَقَدَّمَ دُونَ
u'تَقَدُّمٌ دَيْنٌ':Added, #1: 1	تَقَدَّمَ دَيْنٌ
u'تَقَدَّمَ ذكر':Predicate, #1: 1	تَقَدُّمَ الدَّيْنِ
u'تَقَدَّمَ ذَكَرٌ':Predicate, #1: 1	تَقَدَّمَ ذَكَرَ
u'تَقَدَّمَ ذكر':Subject, #1: 1	تَقَدَّمَ ذَكَرَ
u'تَقَدَّمَ ذِكْرٌ':Subject, #1: 1	تَقَدَّمَ الذِّكْرُ
u'تَقَدَّمَ ذكر':Subject, #1: 1	تَقَدَّمَ الذِّكْرُ
u'تَقَدَّمَ ذِكْرٌ':Subject, #25: 25	تَقَدَّمَ ذِكْرُ
u'تَقَدَّمَ ذكر':Subject, #25: 25	تَقَدَّمَ ذِكْرُ
u'تَقَدَّمَ ذِكْرٌ':Subject, #97: 97	تَقَدَّمَ ذِكْرُهُ
u'تَقَدُّمٌ ذكر':Added, #97: 97	تَقَدَّمَ ذِكْرُهُ
u'تَقَدُّمٌ ذِكْرٌ':Added, #2: 2	تَقَدُّمِ ذِكْرِ
u'تَقَدُّمٌ ذكر':Added, #2: 2	تَقَدُّمِ ذِكْرِ
u'تَقَدُّمٌ ذِكْرٌ':Added, #2: 2	تَقَدُّمِ ذِكْرِهِ
u'تَقَدُّمٌ ذكر':Added, #2: 2	تَقَدُّمِ ذِكْرِهِ
u'تَقَدُّمٌ ذِكْرٌ':Added, #3: 3	تَقَدُّمُ ذِكْرِ
u'تَقَدَّمَ ذَمٌّ':Subject, #3: 3	تَقَدُّمُ ذِكْرِ
u'تَقَدَّمَ ذَنْبٌ':Subject, #1: 1	تَقَدَّمَ ذَمُّ
u'تَقَدُّمٌ رَاجِحٌ':Added, #1: 1	تَقَدَّمَ ذَنْبٌ
u'تَقَدَّمَ رَأْيٌ':Subject, #1: 1	تَقَدُّمِ الرَّاجِحِ
u'تَقَدُّمٌ رُبْعٌ':Added, #1: 1	تَقَدَّمَ رَأْيُ
u'تَقَدُّمٌ رجعة':Added, #1: 1	تَقَدُّمُ الرُّبْعِ
u'تَقَدُّمٌ رَجْعَةٌ':Added, #2: 2	تَقَدُّمَ الرَّجْعَةِ
u'تَقَدَّمَ رَجُلٌ':Subject, #2: 2	تَقَدُّمَ الرَّجْعَةِ
u'تَقَدُّمٌ رُجُوعٌ':Added, #7: 7	تَقَدَّمَ رَجُلٌ
u'تَقَدَّمَ رَدٌّ':Subject, #1: 1	تَقَدُّمُ رُجُوعِهِ
u'تَقَدَّمَ رَدٌّ':Subject, #1: 1	تَقَدَّمَ الرَّدُّ
u'تَقَدَّمَ رضاع':Subject, #4: 4	تَقَدَّمَ رَدُّهُ
u'تَقَدُّمٌ رُكوعٌ':Added, #1: 1	تَقَدَّمَ رَضَاعُ
u'تَقَدُّمٌ رُكوعٌ':Added, #1: 1	تَقَدُّمَ الرُّكُوعِ
u'تَقَدُّمٌ رَمْيٌ':Added, #3: 3	تَقَدُّمُ الرُّكُوعِ
u'تَقَدَّمَ رِوايَةٌ':Subject, #1: 1	تَقَدُّمِ رَمْيِهِ
u'تَقَدَّمَ رِوايَةٌ':Subject, #1: 1	تَقَدَّمَ رِوَايَةٌ
u'تَقَدُّمٌ رِوايَةٌ':Added, #2: 2	تَقَدَّمَ رِوَايَةُ
u'تَقَدُّمٌ رُؤْيَةٌ':Added, #1: 1	تَقَدُّمُ رِوَايَةِ
u'تَقَدُّمٌ رُؤْيَةٌ':Added, #1: 1	تَقَدُّمُ الرُّؤْيَةِ
u'تَقَدُّمٌ زَمانٌ':Added, #1: 1	تَقَدُّمِ رُؤْيَةِ
u'تَقَدُّمٌ زَمانٌ':Added, #1: 1	تَقَدُّمُ زَمَانِهِ
u'تَقَدَّمَ زَمَنٌ':Predicate, #1: 1	تَقَدُّمِ زَمَانِهِ
u'تَقَدُّمٌ زَوْجٌ':Added, #1: 1	تَقَدَّمَ زَمَنَ
u'تَقَدُّمٌ سَابِقٌ':Added, #1: 1	تَقَدُّمَ زَوْجٍ
u'تَقَدَّمَ سَارِقٌ':Subject, #1: 1	تَقَدُّمُ السَّابِقِ
u'تَقَدَّمَ سَبَبٌ':Subject, #1: 1	تَقَدَّمَ السَّارِقُ
u'تَقَدَّمَ سَبَبٌ':Subject, #2: 2	تَقَدَّمَ سَبَبُ
u'تَقَدُّمٌ سَبَبٌ':Added, #3: 3	تَقَدَّمَ سَبَبُهُ
u'تَقَدُّمٌ سَبَبٌ':Added, #1: 1	تَقَدُّمَ السَّبَبِ
u'تَقَدُّمٌ سَبَبٌ':Added, #1: 1	تَقَدُّمِ سَبَبِ
u'تَقَدُّمٌ سَبَبٌ':Added, #1: 1	تَقَدُّمِ سَبَبِهِ
u'تَقَدُّمٌ سَبَبٌ':Added, #2: 2	تَقَدُّمُ السَّبَبِ
u'تَقَدُّمٌ سُجُودٌ':Added, #6: 6	تَقَدُّمِ السَّبَبِ
u'تَقَدَّمَ سَرْدٌ':Subject, #1: 1	تَقَدُّمِ السُّجُودِ
u'تَقَدُّمٌ سَفَرٌ':Added, #1: 1	تَقَدَّمَ سَرْدُهُ
u'تَقَدُّمٌ سَفَرٌ':Added, #1: 1	تَقَدُّمُ سَفَرٍ
u'تَقَدُّمٌ سَفَرٌ':Added, #2: 2	تَقَدُّمُ السَّفَرِ
u'تَقَدَّمَ سَلْبٌ':Subject, #2: 2	تَقَدُّمِ السَّفَرِ
u'تَقَدَّمَ سَلَمٌ':Subject, #1: 1	تَقَدَّمَ السَّلْبُ
u'تَقَدَّمَ سَمَاعٌ':Subject, #1: 1	تَقَدَّمَ سَلَمُ
u'تَقَدُّمٌ سَمَاعٌ':Added, #1: 1	تَقَدَّمَ سَمَاعُ
u'تَقَدَّمَ سَنَدٌ':Subject, #1: 1	تَقَدُّمُ سَمَاعِ
u'تَقَدَّمَ سَواءٌ':Subject, #1: 1	تَقَدَّمَ سَنَدُ
u'تَقَدُّمٌ سُؤَالٌ':Added, #9: 9	تَقَدَّمَ سَوَاءٌ
u'تَقَدَّمَ شافِعِيّ':Predicate, #3: 3	تَقَدُّمِ سُؤَالٍ
u'تَقَدَّمَ شِدَّةٌ':Subject, #1: 1	تَقَدَّمَ الشَّافِعِيَّ
u'تَقَدَّمَ شِرَاءٌ':Subject, #1: 1	تَقَدَّمَ شِدَّةُ
u'تَقَدُّمٌ شِرَاءٌ':Added, #1: 1	تَقَدَّمَ شِرَاءُ
u'تَقَدُّمٌ شِرَاءٌ':Added, #1: 1	تَقَدُّمِ الشِّرَاءِ
u'تَقَدَّمَ شَرْحٌ':Subject, #1: 1	تَقَدُّمُ شِرَاءِ
u'تَقَدَّمَ شَرْحٌ':Subject, #2: 2	تَقَدَّمَ شَرْحُ
u'تَقَدَّمَ شَرْطٌ':Subject, #5: 5	تَقَدَّمَ شَرْحُهُ
u'تَقَدَّمَ شَرْطٌ':Subject, #1: 1	تَقَدَّمَ شَرْطُ
u'تَقَدُّمٌ شَرْطٌ':Added, #3: 3	تَقَدَّمَ الشَّرْطُ
u'تَقَدُّمٌ شَرْطٌ':Added, #11: 11	تَقَدُّمِ الشَّرْطِ
u'تَقَدُّمٌ شَرْطٌ':Added, #1: 1	تَقَدُّمَ الشَّرْطِ
u'تَقَدُّمٌ شَرْعٌ':Added, #1: 1	تَقَدُّمِ شَرْطِهِ
u'تَقَدَّمَ شُرُوطٌ':Subject, #1: 1	تَقَدُّمِ الشَّرْعِ
u'تَقَدَّمَ شُعُورٌ':Subject, #1: 1	تَقَدَّمَ شُرُوطُ
u'تَقَدَّمَ شَفِيعٌ':Subject, #1: 1	تَقَدَّمَ الشُّعُورُ
u'تَقَدُّمٌ شَفِيعٌ':Added, #5: 5	تَقَدَّمَ الشَّفِيعُ
u'تَقَدَّمَ شَكٌّ':Subject, #2: 2	تَقَدُّمَ الشَّفِيعِ
u'تَقَدُّمٌ شَهَادَةٌ':Added, #1: 1	تَقَدَّمَ شَكٌّ
u'تَقَدُّمٌ شَهَادَةٌ':Added, #1: 1	تَقَدُّمِ شَهَادَةِ
u'تَقَدَّمَ شَيْءٌ':Predicate, #2: 2	تَقَدُّمُ الشَّهَادَةِ
u'تَقَدَّمَ شَيْءٌ':Subject, #1: 1	تَقَدَّمَ الشَّيْءَ
u'تَقَدُّمٌ شَيْءٌ':Added, #2: 2	تَقَدَّمَ شَيْءٌ
u'تَقَدُّمٌ شَيْءٌ':Added, #1: 1	تَقَدُّمَ شَيْءٍ
u'تَقَدُّمٌ صِحَّةٌ':Added, #2: 2	تَقَدُّمِ الشَّيْءِ
u'تَقَدُّمٌ صِحَّةٌ':Added, #1: 1	تَقَدُّمَ الصِّحَّةِ
u'تَقَدَّمَ صَحِيحٌ':Subject, #1: 1	تَقَدُّمِ صِحَّتِهِ
u'تَقَدُّمٌ صدقة':Added, #3: 3	تَقَدَّمَ الصَّحِيحُ
u'تَقَدُّمٌ صَدَقَةٌ':Added, #1: 1	تَقَدُّمَ صَدَقَةِ
u'تَقَدَّمَ صَفٌّ':Subject, #1: 1	تَقَدُّمَ صَدَقَةِ
u'تَقَدُّمٌ صَفٌّ':Added, #5: 5	تَقَدَّمَ الصَّفُّ
u'تَقَدَّمَ صِفَةٌ':Subject, #1: 1	تَقَدُّمِ الصَّفِّ
u'تَقَدُّمٌ صِفَةٌ':Added, #1: 1	تَقَدَّمَ صِفَةُ
u'تَقَدُّمٌ صَلاَةٌ':Added, #1: 1	تَقَدُّمَ الصِّفَةِ
u'تَقَدَّمَ صُورَةٌ':Subject, #1: 1	تَقَدُّمَ صَلَاةِ
u'تَقَدَّمَ ضِدٌّ':Subject, #1: 1	تَقَدَّمَ صُورَةُ
u'تَقَدَّمَ ضَعِيفٌ':Subject, #1: 1	تَقَدَّمَ ضِدُّهُ
u'تَقَدَّمَ ضَمَانٌ':Subject, #4: 4	تَقَدَّمَ الضَّعِيفُ
u'تَقَدَّمَ طَرَفٌ':Subject, #2: 2	تَقَدَّمَ الضَّمَانُ
u'تَقَدَّمَ طُرُقٌ':Subject, #1: 1	تَقَدَّمَ طَرَفٌ
u'تَقَدُّمٌ طَلاَقٌ':Added, #1: 1	تَقَدَّمَ طُرُقٌ
u'تَقَدُّمٌ طَلاَقٌ':Added, #1: 1	تَقَدُّمِ طَلَاقٍ
u'تَقَدُّمٌ طَلاَقٌ':Added, #2: 2	تَقَدُّمَ الطَّلَاقِ
u'تَقَدُّمٌ طلب':Added, #2: 2	تَقَدُّمُ الطَّلَاقِ
u'تَقَدُّمٌ طلب':Added, #1: 1	تَقَدُّمَ الطَّلَبِ
u'تَقَدُّمٌ طَلَبٌ':Added, #1: 1	تَقَدُّمِ الطَّلَبِ
u'تَقَدُّمٌ طَلَبٌ':Added, #1: 1	تَقَدُّمَ الطَّلَبِ
u'تَقَدُّمٌ طَلَبٌ':Added, #1: 1	تَقَدُّمِ الطَّلَبِ
u'تَقَدُّمٌ طَهَارَةٌ':Added, #1: 1	تَقَدُّمُ طَلَبٍ
u'تَقَدُّمٌ طَهَارَةٌ':Added, #1: 1	تَقَدُّمَ الطَّهَارَةِ
u'تَقَدُّمٌ طَهَارَةٌ':Added, #2: 2	تَقَدُّمُ الطَّهَارَةِ
u'تَقَدَّمَ طواف':Subject, #2: 2	تَقَدُّمِ الطَّهَارَةِ
u'تَقَدَّمَ طَوَافٌ':Subject, #1: 1	تَقَدَّمَ الطَّوَافُ
u'تَقَدُّمٌ طواف':Added, #1: 1	تَقَدَّمَ الطَّوَافُ
u'تَقَدُّمٌ طَوَافٌ':Added, #1: 1	تَقَدُّمُ الطَّوَافِ
u'تَقَدُّمٌ طواف':Added, #1: 1	تَقَدُّمُ الطَّوَافِ
u'تَقَدُّمٌ طَوَافٌ':Added, #2: 2	تَقَدُّمِ طَوَافٍ
u'تَقَدَّمَ ظاهِرٌ':Subject, #2: 2	تَقَدُّمِ طَوَافٍ
u'تَقَدُّمٌ ظُلْمٌ':Added, #1: 1	تَقَدَّمَ الظَّاهِرُ
u'تَقَدُّمٌ عَامٌّ':Added, #1: 1	تَقَدُّمِ ظُلْمٍ
u'تَقَدَّمَ عِبَارَةٌ':Subject, #1: 1	تَقَدُّمُ الْعَامِّ
u'تَقَدَّمَ عَبْدٌ':Subject, #1: 1	تَقَدَّمَ عِبَارَةُ
u'تَقَدَّمَ عتق':Subject, #1: 1	تَقَدَّمَ عَبْدُ
u'تَقَدَّمَ عِتْقٌ':Subject, #1: 1	تَقَدَّمَ الْعِتْقُ
u'تَقَدَّمَ عتق':Subject, #1: 1	تَقَدَّمَ الْعِتْقُ
u'تَقَدَّمَ عِتْقٌ':Subject, #1: 1	تَقَدَّمَ عِتْقُ
u'تَقَدُّمٌ عتق':Added, #1: 1	تَقَدَّمَ عِتْقُ
u'تَقَدُّمٌ عِتْقٌ':Added, #1: 1	تَقَدُّمَ الْعِتْقِ
u'تَقَدَّمَ عَدَمٌ':Subject, #1: 1	تَقَدُّمَ الْعِتْقِ
u'تَقَدُّمٌ عِرْفَانٌ':Added, #3: 3	تَقَدَّمَ عَدَمُ
u'تَقَدُّمٌ عَصْرٌ':Added, #1: 1	تَقَدُّمَ الْعِرْفَانِ
u'تَقَدُّمٌ عَقِبٌ':Added, #1: 1	تَقَدُّمَ الْعَصْرِ
u'تَقَدَّمَ عَقْدٌ':Subject, #1: 1	تَقَدُّمَ الْعَقِبِ
u'تَقَدَّمَ عقر':Subject, #1: 1	تَقَدَّمَ الْعَقْدُ
u'تَقَدُّمٌ عِلَّةٌ':Added, #1: 1	تَقَدَّمَ الْعَقْرُ
u'تَقَدُّمٌ عِلَّةٌ':Added, #1: 1	تَقَدُّمَ الْعِلَّةِ
u'تَقَدُّمٌ عِلَّةٌ':Added, #2: 2	تَقَدُّمُ الْعِلَّةِ
u'تَقَدَّمَ علم':Predicate, #3: 3	تَقَدُّمِ الْعِلَّةِ
u'تَقَدُّمٌ علم':Added, #1: 1	تَقَدَّمَ عُلِمَ
u'تَقَدُّمٌ عِلْمٌ':Added, #1: 1	تَقَدُّمَ الْعِلْمِ
u'تَقَدُّمٌ عِمَارَةٌ':Added, #1: 1	تَقَدُّمَ الْعِلْمِ
u'تَقَدُّمٌ عِمَارَةٌ':Added, #1: 1	تَقَدُّمَ عِمَارَةٍ
u'تَقَدُّمٌ عمرة':Added, #1: 1	تَقَدُّمِ عِمَارَةِ
u'تَقَدُّمٌ عُمْرَةٌ':Added, #1: 1	تَقَدُّمِ الْعُمْرَةِ
u'تَقَدَّمَ عَمَلٌ':Subject, #1: 1	تَقَدُّمِ الْعُمْرَةِ
u'تَقَدَّمَ عُمُومٌ':Subject, #1: 1	تَقَدَّمَ الْعَمَلُ
u'تَقَدَّمَ عند':Predicate, #2: 2	تَقَدَّمَ عُمُومُ
u'تَقَدَّمَ عَهْدٌ':Subject, #104: 104	تَقَدَّمَ عِنْدَ
u'تَقَدُّمٌ عَهْدٌ':Added, #1: 1	تَقَدَّمَ عَهْدٌ
u'تَقَدُّمٌ غَايَةٌ':Added, #2: 2	تَقَدُّمِ الْعَهْدِ
u'تَقَدُّمٌ غَسْلٌ':Added, #1: 1	تَقَدُّمَ غَايَتِهِ
u'تَقَدُّمٌ غُسْلٌ':Added, #1: 1	تَقَدُّمِ الْغَسْلِ
u'تَقَدُّمٌ غُسْلٌ':Added, #1: 1	تَقَدُّمُ الْغُسْلِ
u'تَقَدُّمٌ غَنِيٌّ':Added, #1: 1	تَقَدُّمِ غُسْلِهِ
u'تَقَدَّمَ غَنِيمَةٌ':Predicate, #1: 1	تَقَدُّمِ الْغَنِيِّ
u'تَقَدَّمَ غير':Predicate, #1: 1	تَقَدَّمَ الْغَنِيمَةَ
u'تَقَدَّمَ غَيْرٌ':Predicate, #7: 7	تَقَدَّمَ غَيْرَ
u'تَقَدَّمَ غير':Subject, #7: 7	تَقَدَّمَ غَيْرَ
u'تَقَدَّمَ غَيْرٌ':Subject, #4: 4	تَقَدَّمَ غَيْرُهُ
u'تَقَدَّمَ غير':Subject, #4: 4	تَقَدَّمَ غَيْرُهُ
u'تَقَدَّمَ غَيْرٌ':Subject, #6: 6	تَقَدَّمَ غَيْرُ
u'تَقَدُّمٌ غير':Added, #6: 6	تَقَدَّمَ غَيْرُ
u'تَقَدُّمٌ غَيْرٌ':Added, #1: 1	تَقَدُّمَ غَيْرِهِ
u'تَقَدُّمٌ غير':Added, #1: 1	تَقَدُّمَ غَيْرِهِ
u'تَقَدُّمٌ غَيْرٌ':Added, #2: 2	تَقَدُّمُ غَيْرِهِ
u'تَقَدُّمٌ غير':Added, #2: 2	تَقَدُّمُ غَيْرِهِ
u'تَقَدُّمٌ غَيْرٌ':Added, #3: 3	تَقَدُّمِ غَيْرِهِ
u'تَقَدُّمٌ فَاعِلٌ':Added, #3: 3	تَقَدُّمِ غَيْرِهِ
u'تَقَدَّمَ فَرْقٌ':Subject, #1: 1	تَقَدُّمُ الْفَاعِلِ
u'تَقَدَّمَ فرق':Subject, #1: 1	تَقَدَّمَ فَرْقٌ
u'تَقَدَّمَ فَرْقٌ':Subject, #6: 6	تَقَدَّمَ الْفَرْقُ
u'تَقَدَّمَ فساد':Subject, #6: 6	تَقَدَّمَ الْفَرْقُ
u'تَقَدَّمَ فَسَادٌ':Subject, #4: 4	تَقَدَّمَ فَسَادُهُ
u'تَقَدُّمٌ فَسْخٌ':Added, #4: 4	تَقَدَّمَ فَسَادُهُ
u'تَقَدَّمَ فَصْلٌ':Subject, #1: 1	تَقَدُّمِ الْفَسْخِ
u'تَقَدَّمَ فِعْلٌ':Subject, #1: 1	تَقَدَّمَ فَصْلُ
u'تَقَدُّمٌ فِعْلٌ':Added, #3: 3	تَقَدَّمَ الْفِعْلُ
u'تَقَدَّمَ فلان':Predicate, #1: 1	تَقَدُّمُ الْفِعْلِ
u'تَقَدَّمَ فَوَائِدُ':Subject, #1: 1	تَقَدَّمَ الشَّافِعِيَّ
u'تَقَدُّمٌ قَاطِعٌ':Added, #2: 2	تَقَدَّمَ فَوَائِدُ
u'تَقَدَّمَ قَالٌ':Predicate, #1: 1	تَقَدُّمِ قَاطِعِ
u'تَقَدَّمَ قَبْضٌ':Predicate, #33: 33	تَقَدَّمَ قَالَ
u'تَقَدَّمَ قَبُولٌ':Subject, #1: 1	تَقَدَّمَ الْقَبْضَ
u'تَقَدُّمٌ قَبُولٌ':Added, #9: 9	تَقَدَّمَ الْقَبُولُ
u'تَقَدُّمٌ قَبُولٌ':Added, #1: 1	تَقَدُّمَ الْقَبُولِ
u'تَقَدَّمَ قَدْرٌ':Subject, #1: 1	تَقَدُّمِ الْقَبُولِ
u'تَقَدُّمٌ قدرة':Added, #1: 1	تَقَدَّمَ قَدْرُهُ
u'تَقَدُّمٌ قُدْرَةٌ':Added, #1: 1	تَقَدُّمَ الْقُدْرَةِ
u'تَقَدُّمٌ قدرة':Added, #1: 1	تَقَدُّمَ الْقُدْرَةِ
u'تَقَدُّمٌ قدرة':Added, #2: 2	تَقَدُّمُ الْقُدْرَةِ
u'تَقَدُّمٌ قُدْرَةٌ':Added, #2: 2	تَقَدُّمِ الْقُدْرَةِ
u'تَقَدُّمٌ قُدْرَةٌ':Added, #2: 2	تَقَدُّمُ الْقُدْرَةِ
u'تَقَدُّمٌ قُدُومٌ':Added, #2: 2	تَقَدُّمِ الْقُدْرَةِ
u'تَقَدَّمَ قَرْضٌ':Subject, #2: 2	تَقَدُّمِ الْقُدُومِ
u'تَقَدَّمَ قول':Subject, #1: 1	تَقَدَّمَ الْقَرْضُ
u'تَقَدَّمَ قَوْلٌ':Subject, #194: 194	تَقَدَّمَ قَوْلُ
u'تَقَدَّمَ قول':Subject, #194: 194	تَقَدَّمَ قَوْلُ
u'تَقَدَّمَ قَوْلٌ':Subject, #27: 27	تَقَدَّمَ الْقَوْلُ
u'تَقَدَّمَ قول':Subject, #27: 27	تَقَدَّمَ الْقَوْلُ
u'تَقَدَّمَ قَوْلٌ':Subject, #31: 31	تَقَدَّمَ قَوْلُهُ
u'تَقَدُّمٌ قول':Added, #31: 31	تَقَدَّمَ قَوْلُهُ
u'تَقَدُّمٌ قَوْلٌ':Added, #1: 1	تَقَدُّمُ الْقَوْلِ
u'تَقَدُّمٌ قول':Added, #1: 1	تَقَدُّمُ الْقَوْلِ
u'تَقَدُّمٌ قَوْلٌ':Added, #2: 2	تَقَدُّمِ قَوْلِهِ
u'تَقَدُّمٌ قول':Added, #2: 2	تَقَدُّمِ قَوْلِهِ
u'تَقَدُّمٌ قَوْلٌ':Added, #3: 3	تَقَدُّمِ الْقَوْلِ
u'تَقَدُّمٌ قَوْمٌ':Added, #3: 3	تَقَدُّمِ الْقَوْلِ
u'تَقَدَّمَ قَوِيٌّ':Subject, #1: 1	تَقَدُّمَ الْقَوْمِ
u'تَقَدُّمٌ قِيَاسٌ':Added, #1: 1	تَقَدَّمَ الْقَوِيُّ
u'تَقَدَّمَ كَثِيرٌ':Subject, #1: 1	تَقَدُّمُ الْقِيَاسِ
u'تَقَدَّمَ كَرَاهَةٌ':Subject, #1: 1	تَقَدَّمَ الْكَثِيرُ
u'تَقَدَّمَ كَفَّارٌ':Subject, #1: 1	تَقَدَّمَ كَرَاهَةُ
u'تَقَدُّمٌ كَفَّارٌ':Added, #1: 1	تَقَدَّمَ الْكَفَّارَةُ
u'تَقَدُّمٌ كَفَّارٌ':Added, #1: 1	تَقَدُّمُ الْكَفَّارَةِ
u'تَقَدَّمَ كَفَّارَةٌ':Subject, #1: 1	تَقَدُّمِ الْكَفَّارَةِ
u'تَقَدُّمٌ كَفَّارَةٌ':Added, #1: 1	تَقَدَّمَ الْكَفَّارَةُ
u'تَقَدُّمٌ كَفَّارَةٌ':Added, #1: 1	تَقَدُّمُ الْكَفَّارَةِ
u'تَقَدَّمَ كفر':Subject, #1: 1	تَقَدُّمِ الْكَفَّارَةِ
u'تَقَدَّمَ كُفْرٌ':Subject, #3: 3	تَقَدَّمَ كُفْرُهُ
u'تَقَدَّمَ كَلاَمٌ':Subject, #3: 3	تَقَدَّمَ كُفْرُهُ
u'تَقَدَّمَ كَلاَمٌ':Subject, #10: 10	تَقَدَّمَ كَلَامُ
u'تَقَدَّمَ كَلاَمٌ':Subject, #1: 1	تَقَدَّمَ كَلامُ
u'تَقَدَّمَ كَلاَمٌ':Subject, #1: 1	تَقَدَّمَ كَلَامٌ
u'تَقَدَّمَ كَلاَمٌ':Subject, #3: 3	تَقَدَّمَ كَلَامُهُ
u'تَقَدُّمٌ كَلاَمٌ':Added, #52: 52	تَقَدَّمَ الْكَلَامُ
u'تَقَدَّمَ كَيْفِيَّةٌ':Predicate, #1: 1	تَقَدُّمِ كَلَامٍ
u'تَقَدَّمَ لَفْظٌ':Subject, #1: 1	تَقَدَّمَ كَيْفِيَّةَ
u'تَقَدُّمٌ لَفْظٌ':Added, #12: 12	تَقَدَّمَ لَفْظُهُ
u'تَقَدُّمٌ متبوع':Added, #1: 1	تَقَدُّمِ اللَّفْظِ
u'تَقَدَّمَ مثل':Subject, #1: 1	تَقَدُّمُ الْمَتْبُوعِ
u'تَقَدَّمَ مَثَلٌ':Subject, #1: 1	تَقَدَّمَ الْمَثَلُ
u'تَقَدَّمَ مثل':Subject, #1: 1	تَقَدَّمَ الْمَثَلُ
u'تَقَدَّمَ مِثْلٌ':Subject, #3: 3	تَقَدَّمَ مِثْلُ
u'تَقَدَّمَ مثل':Subject, #3: 3	تَقَدَّمَ مِثْلُ
u'تَقَدَّمَ مِثْلٌ':Subject, #6: 6	تَقَدَّمَ مِثْلُهُ
u'تَقَدَّمَ مَجَازٌ':Subject, #6: 6	تَقَدَّمَ مِثْلُهُ
u'تَقَدَّمَ مُحْتَمَلٌ':Subject, #1: 1	تَقَدَّمَ مَجَازٌ
u'تَقَدَّمَ مَحْمُولٌ':Subject, #1: 1	تَقَدَّمَ الْمُحْتَمَلُ
u'تَقَدَّمَ مُخْتَارٌ':Subject, #3: 3	تَقَدَّمَ مَحْمُولٌ
u'تَقَدَّمَ مَذْهَبٌ':Subject, #3: 3	تَقَدَّمَ مُخْتَارُ
u'تَقَدَّمَ مُرْسَلٌ':Predicate, #5: 5	تَقَدَّمَ الْمَذْهَبُ
u'تَقَدَّمَ مَرْفُوعٌ':Subject, #1: 1	تَقَدَّمَ مُرْسَلاً
u'تَقَدَّمَ مَسْأَلَةٌ':Subject, #1: 1	تَقَدَّمَ الْمَرْفُوعُ
u'تَقَدَّمَ مُشار':Subject, #1: 1	تَقَدَّمَ الْمَسْأَلَةُ
u'تَقَدَّمَ مَشْرُوطٌ':Subject, #1: 1	تَقَدَّمَ الْمُشَارُ
u'تَقَدُّمٌ مَشْرُوطٌ':Added, #2: 2	تَقَدَّمَ الْمَشْرُوطُ
u'تَقَدُّمٌ مَشِيئَةٌ':Added, #1: 1	تَقَدُّمُ الْمَشْرُوطِ
u'تَقَدَّمَ مَصْرِفٌ':Subject, #1: 1	تَقَدُّمَ الْمَشِيئَةِ
u'تَقَدَّمَ مُصَنِّفٌ':Predicate, #1: 1	تَقَدَّمَ مَصْرِفُهُ
u'تَقَدَّمَ مُضَافٌ':Subject, #2: 2	تَقَدَّمَ الْمُصَنِّفَ
u'تَقَدُّمٌ مَضْمُونٌ':Added, #1: 1	تَقَدَّمَ الْمُضَافُ
u'تَقَدُّمٌ مُعَرَّفٌ':Added, #1: 1	تَقَدُّمِ مَضْمُونِ
u'تَقَدُّمٌ مَعْلُومٌ':Added, #1: 1	تَقَدُّمِ الْمُعَرَّفِ
u'تَقَدُّمٌ مَعْهُودٌ':Added, #1: 1	تَقَدُّمُ الْمَعْلُومِ
u'تَقَدَّمَ مَفْهُومٌ':Subject, #1: 1	تَقَدُّمِ الْمَعْهُودِ
u'تَقَدَّمَ مِقْدَارٌ':Predicate, #1: 1	تَقَدَّمَ مَفْهُومُهُ
u'تَقَدَّمَ مُقَيَّدٌ':Subject, #1: 1	تَقَدَّمَ مِقْدَارَ
u'تَقَدَّمَ مُكَاتَبَةٌ':Subject, #1: 1	تَقَدَّمَ مُقَيَّدٌ
u'تَقَدَّمَ مِلْكٌ':Subject, #1: 1	تَقَدَّمَ مُكَاتَبَةٌ
u'تَقَدَّمَ مِلْكٌ':Subject, #1: 1	تَقَدَّمَ الْمِلْكُ
u'تَقَدُّمٌ مِلْكٌ':Added, #1: 1	تَقَدَّمَ مِلْكٌ
u'تَقَدُّمٌ مِلْكٌ':Added, #1: 1	تَقَدُّمِ مِلْكٍ
u'تَقَدُّمٌ مِلْكٌ':Added, #1: 1	تَقَدُّمَ مِلْكِهِ
u'تَقَدُّمٌ مِلْكٌ':Added, #6: 6	تَقَدُّمِ الْمِلْكِ
u'تَقَدُّمٌ مِلْكِيَّةٌ':Added, #7: 7	تَقَدُّمَ الْمِلْكِ
u'تَقَدَّمَ مَنْعٌ':Subject, #1: 1	تَقَدُّمِ الْمِلْكِيَّةِ
u'تَقَدُّمٌ مَنْكِبٌ':Added, #2: 2	تَقَدَّمَ مَنْعُ
u'تَقَدَّمَ مَوْتٌ':Predicate, #1: 1	تَقَدُّمَ الْمَنْكِبِ
u'تَقَدَّمَ مَوْتٌ':Subject, #1: 1	تَقَدَّمَ مَوْتَ
u'تَقَدُّمٌ مَوْتٌ':Added, #4: 4	تَقَدَّمَ مَوْتُهُ
u'تَقَدُّمٌ مَوْتٌ':Added, #1: 1	تَقَدُّمِ الْمَوْتِ
u'تَقَدُّمٌ مَوْتٌ':Added, #1: 1	تَقَدُّمَ مَوْتِ
u'تَقَدُّمٌ مُؤَثِّرٌ':Added, #1: 1	تَقَدُّمُ مَوْتِ
u'تَقَدَّمَ مُوجِبٌ':Subject, #1: 1	تَقَدُّمُ الْمُؤَثِّرِ
u'تَقَدَّمَ مُؤَجَّلٌ':Subject, #1: 1	تَقَدَّمَ مُوجِبُهُ
u'تَقَدُّمٌ مَوْقِفٌ':Added, #1: 1	تَقَدَّمَ مُؤَجَّلُ
u'تَقَدَّمَ نَاسٌ':Predicate, #1: 1	تَقَدُّمَ مَوْقِفِ
u'تَقَدُّمٌ نَبِيٌّ':Added, #1: 1	تَقَدَّمَ النَّاسَ
u'تَقَدَّمَ نَحْوٌ':Subject, #1: 1	تَقَدُّمُ النَّبِيِّ
u'تَقَدَّمَ نَحْوٌ':Subject, #1: 1	تَقَدَّمَ نَحْوُهُ
u'تَقَدَّمَ نَصٌّ':Predicate, #2: 2	تَقَدَّمَ نَحْوُ
u'تَقَدَّمَ نَصٌّ':Subject, #1: 1	تَقَدَّمَ نَصَّ
u'تَقَدَّمَ نَصٌّ':Subject, #1: 1	تَقَدَّمَ نَصُّهُ
u'تَقَدَّمَ نَصٌّ':Subject, #24: 24	تَقَدَّمَ النَّصُّ
u'تَقَدَّمَ نَصٌّ':Subject, #2: 2	تَقَدَّمَ نَصٌّ
u'تَقَدُّمٌ نصاب':Added, #511: 511	تَقَدَّمَ نَصُّ
u'تَقَدُّمٌ نِصَابٌ':Added, #2: 2	تَقَدُّمُ نِصَابِ
u'تَقَدَّمَ نِصْفٌ':Subject, #2: 2	تَقَدُّمُ نِصَابِ
u'تَقَدَّمَ نُطْقٌ':Subject, #1: 1	تَقَدَّمَ النِّصْفُ
u'تَقَدُّمٌ نَظَرٌ':Added, #1: 1	تَقَدَّمَ نُطْقُ
u'تَقَدُّمٌ نَظَرٌ':Added, #1: 1	تَقَدُّمِ النَّظَرِ
u'تَقَدَّمَ نَظِيرٌ':Subject, #1: 1	تَقَدُّمِ نَظَرٍ
u'تَقَدَّمَ نَظِيرٌ':Subject, #21: 21	تَقَدَّمَ نَظِيرُهُ
u'تَقَدَّمَ نَفَقَةٌ':Subject, #5: 5	تَقَدَّمَ نَظِيرُ
u'تَقَدَّمَ نَفْيٌ':Subject, #1: 1	تَقَدَّمَ نَفَقَةُ
u'تَقَدُّمٌ نَفْيٌ':Added, #3: 3	تَقَدَّمَ النَّفْيُ
u'تَقَدُّمٌ نَفْيٌ':Added, #1: 1	تَقَدُّمُ نَفْيٍ
u'تَقَدَّمَ نقل':Subject, #2: 2	تَقَدُّمِ النَّفْيِ
u'تَقَدَّمَ نَقْلٌ':Subject, #12: 12	تَقَدَّمَ نَقْلُهُ
u'تَقَدَّمَ نقل':Subject, #12: 12	تَقَدَّمَ نَقْلُهُ
u'تَقَدَّمَ نَقْلٌ':Subject, #29: 29	تَقَدَّمَ نَقْلُ
u'تَقَدَّمَ نقل':Subject, #29: 29	تَقَدَّمَ نَقْلُ
u'تَقَدَّمَ نَقْلٌ':Subject, #5: 5	تَقَدَّمَ النَّقْلُ
u'تَقَدَّمَ نكاح':Subject, #5: 5	تَقَدَّمَ النَّقْلُ
u'تَقَدَّمَ نِكَاحٌ':Subject, #1: 1	تَقَدَّمَ النِّكَاحُ
u'تَقَدَّمَ نكاح':Subject, #1: 1	تَقَدَّمَ النِّكَاحُ
u'تَقَدَّمَ نِكَاحٌ':Subject, #2: 2	تَقَدَّمَ نِكَاحُ
u'تَقَدَّمَ نكاح':Subject, #2: 2	تَقَدَّمَ نِكَاحُ
u'تَقَدَّمَ نِكَاحٌ':Subject, #2: 2	تَقَدَّمَ نِكَاحُهُ
u'تَقَدُّمٌ نُكُولٌ':Added, #2: 2	تَقَدَّمَ نِكَاحُهُ
u'تَقَدُّمٌ نَهْيٌ':Added, #1: 1	تَقَدُّمِ نُكُولٍ
u'تَقَدَّمَ نَوْمٌ':Predicate, #1: 1	تَقَدُّمِ نَهْيٍ
u'تَقَدُّمٌ نِيَّةٌ':Added, #1: 1	تَقَدَّمَ النَّوْمَ
u'تَقَدُّمٌ نِيَّةٌ':Added, #1: 1	تَقَدُّمَ النِّيَّةِ
u'تَقَدُّمٌ نِيَّةٌ':Added, #1: 1	تَقَدُّمِ النِّيَّةِ
u'تَقَدُّمٌ نِيَّةٌ':Added, #2: 2	تَقَدُّمُ النِّيَّةِ
u'تَقَدُّمٌ هَمٌّ':Added, #2: 2	تَقَدُّمُ نِيَّةِ
u'تَقَدَّمَ واحد':Subject, #1: 1	تَقَدُّمِ هَمٍّ
u'تَقَدَّمَ وَاحِدٌ':Subject, #5: 5	تَقَدَّمَ وَاحِدٌ
u'تَقَدُّمٌ واحد':Added, #5: 5	تَقَدَّمَ وَاحِدٌ
u'تَقَدُّمٌ وَاحِدٌ':Added, #1: 1	تَقَدُّمِ وَاحِدٍ
u'تَقَدَّمَ وَجَبٌ':Predicate, #1: 1	تَقَدُّمِ وَاحِدٍ
u'تَقَدَّمَ وَجْهٌ':Subject, #2: 2	تَقَدَّمَ وَجَبَ
u'تَقَدَّمَ وَجْهٌ':Subject, #10: 10	تَقَدَّمَ وَجْهُ
u'تَقَدَّمَ وُجُوبٌ':Subject, #2: 2	تَقَدَّمَ وَجْهُهُ
u'تَقَدَّمَ وُجُوبٌ':Subject, #2: 2	تَقَدَّمَ الْوُجُوبُ
u'تَقَدُّمٌ وُجُوبٌ':Added, #2: 2	تَقَدَّمَ وُجُوبُ
u'تَقَدُّمٌ وُجُوبٌ':Added, #1: 1	تَقَدُّمِ وُجُوبِ
u'تَقَدُّمٌ وُجُوبٌ':Added, #1: 1	تَقَدُّمِ وُجُوبِهِ
u'تَقَدَّمَ وُجُودٌ':Subject, #3: 3	تَقَدُّمِ الْوُجُوبِ
u'تَقَدُّمٌ وَحْيٌ':Added, #1: 1	تَقَدَّمَ وُجُودُهُ
u'تَقَدُّمٌ وَسَائِلُ':Added, #1: 1	تَقَدُّمَ الْوَحْيِ
u'تَقَدَّمَ وَصْفٌ':Subject, #1: 1	تَقَدُّمِ الْوَسَائِلِ
u'تَقَدُّمٌ وَصِيٌّ':Added, #1: 1	تَقَدَّمَ وَصْفٌ
u'تَقَدُّمٌ وَصِيَّةٌ':Added, #1: 1	تَقَدُّمِ الْوَصِيَّةِ
u'تَقَدُّمٌ وُضُوءٌ':Added, #1: 1	تَقَدُّمِ الْوَصِيَّةِ
u'تَقَدَّمَ وَطْءٌ':Subject, #1: 1	تَقَدُّمِ وُضُوءٍ
u'تَقَدَّمَ وَعْدٌ':Subject, #2: 2	تَقَدَّمَ الْوَطْءُ
u'تَقَدُّمٌ وفاة':Added, #6: 6	تَقَدَّمَ الْوَعْدُ
u'تَقَدُّمٌ وَفَاةٌ':Added, #1: 1	تَقَدُّمِ الْوَفَاةِ
u'تَقَدَّمَ وَقْتٌ':Subject, #1: 1	تَقَدُّمِ الْوَفَاةِ
u'تَقَدَّمَ وَقْتٌ':Subject, #1: 1	تَقَدَّمَ وَقْتُ
u'تَقَدُّمٌ وَقْتٌ':Added, #1: 1	تَقَدَّمَ وَقْتُهُ
u'تَقَدَّمَ وَقْفٌ':Subject, #1: 1	تَقَدُّمُ وَقْتِ
u'تَقَدَّمَ وُقُوعٌ':Subject, #1: 1	تَقَدَّمَ وَقْفُ
u'تَقَدُّمٌ وِكَالَةٌ':Added, #1: 1	تَقَدَّمَ وُقُوعُ
u'تَقَدُّمٌ وِلاَدَةٌ':Added, #1: 1	تَقَدُّمِ الْوِكَالَةِ
u'تَقَدُّمٌ ولد':Added, #1: 1	تَقَدُّمَ الْوِلَادَةِ
u'تَقَدُّمٌ وَلَدٌ':Added, #1: 1	تَقَدُّمُ الْوَلَدِ
u'تَقَدُّمٌ ولد':Added, #1: 1	تَقَدُّمُ الْوَلَدِ
u'تَقَدُّمٌ وَلَدٌ':Added, #3: 3	تَقَدُّمَ الْوَلَدِ
u'تَقَدَّمَ وَلَهٌ':Subject, #3: 3	تَقَدُّمَ الْوَلَدِ
u'تَقَدَّمَ وَلِيٌّ':Subject, #1: 1	تَقَدَّمَ وَلَهُ
u'تَقَرَّبَ عِبَادٌ':Subject, #1: 1	تَقَدَّمَ الْوَلِيُّ
u'تَقَرَّبَ عَبْدٌ':Subject, #1: 1	تَقَرَّبَ الْعِبَادُ
u'تَقَرَّرَ إِثْمٌ':Subject, #4: 4	تَقَرَّبَ الْعَبْدُ
u'تَقَرَّرَ إِجْمَاعٌ':Subject, #1: 1	تَقَرَّرَ الْإِثْمُ
u'تَقَرُّرٌ إِجْمَاعٌ':Added, #1: 1	تَقَرَّرَ الْإِجْمَاعُ
u'تَقَرَّرَ اِحْتِبَاسٌ':Subject, #1: 1	تَقَرُّرِ الْإِجْمَاعِ
u'تَقَرَّرَ إِطْلاقٌ':Predicate, #1: 1	تَقَرَّرَ احْتِبَاسُ
u'تَقَرَّرَ اِنْتِشارٌ':Subject, #1: 1	تَقَرَّرَ إطْلَاقَ
u'تَقَرُّرٌ أَهْلِيٌّ':Added, #1: 1	تَقَرَّرَ انْتِشَارُ
u'تَقَرُّرٌ أهْلِيَّةٌ':Added, #1: 1	تَقَرُّرَ الْأَهْلِيَّةِ
u'تَقَرُّرٌ بَدَلٌ':Added, #1: 1	تَقَرُّرَ الْأَهْلِيَّةِ
u'تَقَرُّرٌ بَدَلٌ':Added, #1: 1	تَقَرُّرِ بَدَلِ
u'تَقَرَّرَ بُرْهانٌ':Subject, #3: 3	تَقَرُّرَ الْبَدَلِ
u'تَقَرَّرَ بُرْهَانٌ':Subject, #1: 1	تَقَرَّرَ بُرْهَانُهُ
u'تَقَرَّرَ بَيْنٌ':Predicate, #1: 1	تَقَرَّرَ بُرْهَانُهُ
u'تَقَرَّرَ تَعْلِيقٌ':Subject, #3: 3	تَقَرَّرَ بَيْنَ
u'تَقَرَّرَ ثَمَنٌ':Subject, #1: 1	تَقَرَّرَ تَعْلِيقُهُ
u'تَقَرَّرَ ثَوابٌ':Subject, #1: 1	تَقَرَّرَ الثَّمَنُ
u'تَقَرُّرٌ جِنَايَةٌ':Added, #1: 1	تَقَرَّرَ الثَّوَابُ
u'تَقَرَّرَ جَوَابٌ':Predicate, #1: 1	تَقَرُّرِ الْجِنَايَةِ
u'تَقَرَّرَ جَوَابٌ':Subject, #1: 1	تَقَرَّرَ الْجَوَابَ
u'تَقَرَّرَ جَوَازٌ':Subject, #2: 2	تَقَرَّرَ الْجَوَابُ
u'تَقَرَّرَ جَوَازٌ':Subject, #1: 1	تَقَرَّرَ جَوَازُهُ
u'تَقَرَّرَ حَقٌّ':Subject, #3: 3	تَقَرَّرَ جَوَازُ
u'تَقَرَّرَ حَقٌّ':Subject, #1: 1	تَقَرَّرَ الْحَقُّ
u'تَقَرُّرٌ حَقٌّ':Added, #1: 1	تَقَرَّرَ حَقُّهُ
u'تَقَرَّرَ حُكْمٌ':Subject, #1: 1	تَقَرُّرِ حَقِّهِ
u'تَقَرَّرَ حُكْمٌ':Subject, #2: 2	تَقَرَّرَ حُكْمُ
u'تَقَرُّرٌ حُكْمٌ':Added, #2: 2	تَقَرَّرَ حُكْمُهُ
u'تَقَرَّرَ حكمة':Subject, #1: 1	تَقَرُّرِ حُكْمِهِ
u'تَقَرَّرَ حِكْمَةٌ':Subject, #1: 1	تَقَرَّرَ حِكْمَةُ
u'تَقَرَّرَ خَبَرٌ':Predicate, #1: 1	تَقَرَّرَ حِكْمَةُ
u'تَقَرَّرَ خَبَر':Predicate, #1: 1	تَقَرَّرَ خَبَرَ
u'تَقَرَّرَ خراج':Subject, #1: 1	تَقَرَّرَ خَبَرَ
u'تَقَرَّرَ خَرَاجٌ':Subject, #1: 1	تَقَرَّرَ الْخَرَاجُ
u'تَقَرَّرَ دَمٌ':Subject, #1: 1	تَقَرَّرَ الْخَرَاجُ
u'تَقَرَّرَ دونٌ':Predicate, #1: 1	تَقَرَّرَ الدَّمُ
u'تَقَرُّرٌ دَيْنٌ':Added, #1: 1	تَقَرَّرَ دُونَ
u'تَقَرَّرَ رَأْيٌ':Subject, #1: 1	تَقَرُّرُ الدَّيْنِ
u'تَقَرَّرَ سَبَبٌ':Subject, #1: 1	تَقَرَّرَ رَأْيُ
u'تَقَرَّرَ سَبَبٌ':Subject, #11: 11	تَقَرَّرَ سَبَبُهُ
u'تَقَرَّرَ سَبَبٌ':Subject, #2: 2	تَقَرَّرَ سَبَبُ
u'تَقَرُّرٌ سَبَبٌ':Added, #8: 8	تَقَرَّرَ السَّبَبُ
u'تَقَرُّرٌ سَبَبٌ':Added, #1: 1	تَقَرُّرَ سَبَبِ
u'تَقَرُّرٌ سَبَبٌ':Added, #1: 1	تَقَرُّرِ سَبَبِهِ
u'تَقَرُّرٌ سَبَبٌ':Added, #21: 21	تَقَرُّرِ السَّبَبِ
u'تَقَرُّرٌ سَبَبٌ':Added, #2: 2	تَقَرُّرَ السَّبَبِ
u'تَقَرُّرٌ سَبْقٌ':Added, #3: 3	تَقَرُّرِ سَبَبِ
u'تَقَرُّرٌ سَبْيٌ':Added, #1: 1	تَقَرُّرِ سَبْقِ
u'تَقَرَّرَ شَيْءٌ':Subject, #2: 2	تَقَرُّرِ السَّبْيِ
u'تَقَرَّرَ صِحَّةٌ':Subject, #1: 1	تَقَرَّرَ شَيْءٌ
u'تَقَرَّرَ صداق':Subject, #3: 3	تَقَرَّرَ صِحَّةُ
u'تَقَرَّرَ صَدَاقٌ':Subject, #1: 1	تَقَرَّرَ الصَّدَاقُ
u'تَقَرُّرٌ صداق':Added, #1: 1	تَقَرَّرَ الصَّدَاقُ
u'تَقَرُّرٌ صَدَاقٌ':Added, #1: 1	تَقَرُّرِ الصَّدَاقِ
u'تَقَرُّرٌ صِفَةٌ':Added, #1: 1	تَقَرُّرِ الصَّدَاقِ
u'تَقَرَّرَ ضَمَانٌ':Subject, #1: 1	تَقَرُّرَ صِفَةِ
u'تَقَرُّرٌ ضَمَانٌ':Added, #1: 1	تَقَرَّرَ ضَمَانُ
u'تَقَرُّرٌ ضَمَانٌ':Added, #1: 1	تَقَرُّرَ الضَّمَانِ
u'تَقَرَّرَ ظاهِرٌ':Subject, #3: 3	تَقَرُّرَ ضَمَانِ
u'تَقَرَّرَ ظاهِرَة':Subject, #1: 1	تَقَرَّرَ ظَاهِرَةٌ
u'تَقَرَّرَ عَائِدٌ':Subject, #1: 1	تَقَرَّرَ ظَاهِرَةٌ
u'تَقَرَّرَ عتق':Subject, #1: 1	تَقَرَّرَ عَائِدٌ
u'تَقَرَّرَ عِتْقٌ':Subject, #1: 1	تَقَرَّرَ الْعِتْقُ
u'تَقَرَّرَ عَدَمٌ':Subject, #1: 1	تَقَرَّرَ الْعِتْقُ
u'تَقَرَّرَ عرف':Predicate, #2: 2	تَقَرَّرَ عَدَمُ
u'تَقَرَّرَ عَفْوٌ':Subject, #1: 1	تَقَرَّرَ عُرِفَ
u'تَقَرَّرَ عَقْدٌ':Subject, #1: 1	تَقَرَّرَ عَفْوُهُ
u'تَقَرُّرٌ عَقْدٌ':Added, #1: 1	تَقَرَّرَ الْعَقْدُ
u'تَقَرَّرَ علم':Predicate, #1: 1	تَقَرُّرِ الْعَقْدِ
u'تَقَرَّرَ علم':Predicate, #2: 2	تَقَرَّرَ عَلِمَ
u'تَقَرَّرَ علم':Subject, #77: 77	تَقَرَّرَ عُلِمَ
u'تَقَرَّرَ عِلْمٌ':Subject, #2: 2	تَقَرَّرَ عِلْمُ
u'تَقَرَّرَ عند':Predicate, #2: 2	تَقَرَّرَ عِلْمُ
u'تَقَرَّرَ غير':Predicate, #6: 6	تَقَرَّرَ عِنْدَ
u'تَقَرَّرَ غَيْرٌ':Predicate, #1: 1	تَقَرَّرَ غَيْرَ
u'تَقَرُّرٌ فَرْضٌ':Added, #1: 1	تَقَرَّرَ غَيْرَ
u'تَقَرَّرَ فساد':Subject, #1: 1	تَقَرُّرِ الْفَرْضِ
u'تَقَرَّرَ فَسَادٌ':Subject, #1: 1	تَقَرَّرَ الْفَسَادُ
u'تَقَرَّرَ فساد':Subject, #1: 1	تَقَرَّرَ الْفَسَادُ
u'تَقَرَّرَ فَسَادٌ':Subject, #1: 1	تَقَرَّرَ فَسَادُهُ
u'تَقَرَّرَ قَالٌ':Predicate, #1: 1	تَقَرَّرَ فَسَادُهُ
u'تَقَرَّرَ قول':Subject, #5: 5	تَقَرَّرَ قَالَ
u'تَقَرَّرَ قَوْلٌ':Subject, #5: 5	تَقَرَّرَ قَوْلُ
u'تَقَرَّرَ كَثْرَةٌ':Subject, #5: 5	تَقَرَّرَ قَوْلُ
u'تَقَرَّرَ مَحَلٌّ':Subject, #1: 1	تَقَرَّرَ كَثْرَةُ
u'تَقَرُّرٌ مُفْسِدٌ':Added, #2: 2	تَقَرَّرَ مَحَلُّهُ
u'تَقَرَّرَ مِلْكٌ':Subject, #1: 1	تَقَرُّرِ الْمُفْسِدِ
u'تَقَرَّرَ مِلْكٌ':Subject, #1: 1	تَقَرَّرَ مِلْكُ
u'تَقَرَّرَ مِلْكٌ':Subject, #2: 2	تَقَرَّرَ الْمِلْكُ
u'تَقَرُّرٌ مِلْكٌ':Added, #5: 5	تَقَرَّرَ مِلْكُهُ
u'تَقَرَّرَ مَنْعٌ':Predicate, #2: 2	تَقَرُّرِ الْمِلْكِ
u'تَقَرَّرَ مَنْعٌ':Subject, #1: 1	تَقَرَّرَ مَنْعَ
u'تَقَرَّرَ مَهْرٌ':Subject, #1: 1	تَقَرَّرَ الْمَنْعُ
u'تَقَرُّرٌ مَهْرٌ':Added, #2: 2	تَقَرَّرَ الْمَهْرُ
u'تَقَرَّرَ مَوْتٌ':Subject, #2: 2	تَقَرُّرِ الْمَهْرِ
u'تَقَرُّرٌ مُوجِبٌ':Added, #3: 3	تَقَرَّرَ مَوْتُهُ
u'تَقَرَّرَ نقل':Subject, #1: 1	تَقَرُّرِ الْمُوجِبِ
u'تَقَرَّرَ نَقْلٌ':Subject, #1: 1	تَقَرَّرَ نَقْلُ
u'تَقَرُّرٌ نكاح':Added, #1: 1	تَقَرَّرَ نَقْلُ
u'تَقَرُّرٌ نِكَاحٌ':Added, #1: 1	تَقَرُّرُ نِكَاحٍ
u'تَقَرَّرَ وَجْهٌ':Subject, #1: 1	تَقَرُّرُ نِكَاحٍ
u'تَقَرَّرَ وُجُوبٌ':Subject, #1: 1	تَقَرَّرَ وَجْهُ
u'تَقَرَّرَ وُجُوبٌ':Subject, #1: 1	تَقَرَّرَ وُجُوبُ
u'تَقَرَّرَ وُجُوبٌ':Subject, #1: 1	تَقَرَّرَ وُجُوبُهُ
u'تَقَرُّرٌ وُجُوبٌ':Added, #2: 2	تَقَرَّرَ الْوُجُوبُ
u'تَقَرُّرٌ وُجُودٌ':Added, #5: 5	تَقَرُّرِ الْوُجُوبِ
u'تَقَرُّرٌ وَظِيفٌ':Added, #1: 1	تَقَرُّرِ وُجُودِهِ
u'تَقَرُّرٌ وَظِيفَةٌ':Added, #1: 1	تَقَرُّرِ الْوَظِيفَةِ
u'تَقَسُّمٌ شَيْءٌ':Added, #1: 1	تَقَرُّرِ الْوَظِيفَةِ
u'تَقْسِيمٌ اِبْنٌ':Added, #1: 1	تَقَسُّمُ الشَّيْءِ
u'تَقْسِيمٌ إِجْمَاعٌ':Added, #2: 2	تَقْسِيمِ ابْنِ
u'تَقْسِيمٌ أَشْيَاءٌ':Added, #1: 1	تَقْسِيمَ الْإِجْمَاعِ
u'تَقْسِيمٌ أَفْعَالٌ':Added, #1: 1	تَقْسِيمَ الْأَشْيَاءِ
u'تَقْسِيمٌ أَنْفالٌ':Added, #1: 1	تَقْسِيمُ الْأَفْعَالِ
u'تَقْسِيمٌ أَنْفَالٌ':Added, #1: 1	تَقْسِيمِ الْأَنْفَالِ
u'تَقْسِيمٌ بِدَعٌ':Added, #1: 1	تَقْسِيمِ الْأَنْفَالِ
u'تَقْسِيمٌ ثُبُوتٌ':Added, #1: 1	تَقْسِيمِ الْبِدَعِ
u'تَقْسِيمٌ جَامِعٌ':Added, #1: 1	تَقْسِيمِ الثُّبُوتِ
u'تَقْسِيمٌ جُمْلَةٌ':Added, #1: 1	تَقْسِيمٍ جَامِعٍ
u'تَقْسِيمٌ حُسْنٌ':Added, #1: 1	تَقْسِيمُ جُمْلَةِ
u'تَقْسِيمٌ حَقِيقِيٌّ':Added, #1: 1	تَقْسِيمِ الْحُسْنِ
u'تَقْسِيمٌ حُكْمٌ':Added, #1: 1	تَقْسِيمٍ حَقِيقِيٍّ
u'تَقْسِيمٌ حَنَفِيَّةٌ':Added, #3: 3	تَقْسِيمُ الْحُكْمِ
u'تَقْسِيمٌ خَبَرٌ':Added, #1: 1	تَقْسِيمِ الْحَنَفِيَّةِ
u'تَقْسِيمٌ خَبَر':Added, #1: 1	تَقْسِيمِ خَبَرِ
u'تَقْسِيمٌ دَارٌ':Added, #1: 1	تَقْسِيمِ خَبَرِ
u'تَقْسِيمٌ دَلالَةٌ':Added, #1: 1	تَقْسِيمُ الدَّارِ
u'تَقْسِيمٌ دَلالَةٌ':Added, #1: 1	تَقْسِيمِ دَلَالَةِ
u'تَقْسِيمٌ رُخْصَةٌ':Added, #2: 2	تَقْسِيمِ الدَّلَالَةِ
u'تَقْسِيمٌ رَسُولٌ':Added, #1: 1	تَقْسِيمِ الرُّخْصَةِ
u'تَقْسِيمٌ سَبَبٌ':Added, #1: 1	تَقْسِيمُ الرّسُولِ
u'تَقْسِيمٌ سُؤَالٌ':Added, #1: 1	تَقْسِيمِ السَّبَبِ
u'تَقْسِيمٌ شَيْءٌ':Added, #1: 1	تَقْسِيمُ السُّؤَالِ
u'تَقْسِيمٌ شَيْخٌ':Added, #1: 1	تَقْسِيمِ الشَّيْءِ
u'تَقْسِيمٌ صَاحِبٌ':Added, #1: 1	تَقْسِيمُ الشَّيْخِ
u'تَقْسِيمٌ صَيْرَفِيٌّ':Added, #1: 1	تَقْسِيمُ صَاحِبِ
u'تَقْسِيمٌ صِيَغٌ':Added, #1: 1	تَقْسِيمُ الصَّيْرَفِيِّ
u'تَقْسِيمٌ عِلَّةٌ':Added, #1: 1	تَقْسِيمِ صِيَغِ
u'تَقْسِيمٌ علم':Added, #7: 7	تَقْسِيمِ الْعِلَّةِ
u'تَقْسِيمٌ عِلْمٌ':Added, #1: 1	تَقْسِيمُ الْعِلْمِ
u'تَقْسِيمٌ عُلْوٌ':Added, #1: 1	تَقْسِيمُ الْعِلْمِ
u'تَقْسِيمٌ فلان':Added, #1: 1	تَقْسِيمُ الْعُلْوِ
u'تَقْسِيمٌ فَيْءٌ':Added, #1: 1	تَقْسِيمُ عَوْفٍ
u'تَقْسِيمٌ فَيْءٌ':Added, #1: 1	تَقْسِيمُ الْفَيْءِ
u'تَقْسِيمٌ قِيَاسٌ':Added, #1: 1	تَقْسِيمِ الْفَيْءِ
u'تَقْسِيمٌ كُلِّيٌّ':Added, #1: 1	تَقْسِيمِ الْقِيَاسِ
u'تَقْسِيمٌ لَفْظٌ':Added, #1: 1	تَقْسِيمَ الْكُلِّيِّ
u'تَقْسِيمٌ مَاءٌ':Added, #2: 2	تَقْسِيمُ اللَّفْظِ
u'تَقْسِيمٌ مَالٌ':Added, #1: 1	تَقْسِيمِ الْمَاءِ
u'تَقْسِيمٌ مُتَعَلِّقٌ':Added, #1: 1	تَقْسِيمَ الْمَالِ
u'تَقْسِيمٌ مُكْرَهٌ':Added, #1: 1	تَقْسِيمِ مُتَعَلِّقَاتِ
u'تَقْسِيمٌ مُنَاسَبَةٌ':Added, #1: 1	تَقْسِيمُ الْمُكْرَهِ
u'تَقْسِيمٌ نَجَاسَةٌ':Added, #2: 2	تَقْسِيمُ الْمُنَاسَبَةِ
u'تَقْسِيمٌ نَظْمٌ':Added, #1: 1	تَقْسِيمُ النَّجَاسَاتِ
u'تَقْسِيمٌ وَاجِبٌ':Added, #1: 1	تَقْسِيمُ النَّظْمِ
u'تَقْسِيمٌ وَاجِبٌ':Added, #2: 2	تَقْسِيمُ الْوَاجِبِ
u'تَقَشَّعَ غيم':Subject, #3: 3	تَقْسِيمِ الْوَاجِبِ
u'تَقَشَّعَ غَيْمٌ':Subject, #1: 1	تَقَشَّعَ الْغَيْمُ
u'تَقَشَّفَ سَيِّدٌ':Subject, #1: 1	تَقَشَّعَ الْغَيْمُ
u'تَقَصِّي كُتُبٌ':Added, #1: 1	تَقَشَّفَ السَّيِّدُ
u'تَقَصِّي نَظَرٌ':Added, #1: 1	تَقَصِّي كُتُبِ
u'تَقَضَّى حَرْبٌ':Subject, #2: 2	تَقَصِّي النَّظَرِ
u'تَقَضِّي حَرْبٌ':Added, #1: 1	تَقَضَّى الْحَرْبُ
u'تَقَضِّي فِعْلٌ':Added, #10: 10	تَقَضِّي الْحَرْبِ
u'تَقَضِّي قتال':Added, #1: 1	تَقَضِّي الْفِعْلِ
u'تَقَضِّي قِتَالٌ':Added, #1: 1	تَقَضِّي الْقِتَالِ
u'تَقَضِّي مُدَّةٌ':Added, #1: 1	تَقَضِّي الْقِتَالِ
u'تَقَطَّعَ أحْمَر':Predicate, #2: 2	تَقَضِّي الْمُدَّةِ
u'تَقَطَّعَ جُنُونٌ':Subject, #2: 2	تَقَطَّعَ أَحْمَرَ
u'تَقَطَّعَ جُنُونٌ':Subject, #1: 1	تَقَطَّعَ الْجُنُونُ
u'تَقَطَّعَ حَبْلٌ':Subject, #5: 5	تَقَطَّعَ جُنُونُهُ
u'تَقَطَّعَ حَمْلٌ':Subject, #1: 1	تَقَطَّعَ الْحَبْلُ
u'تَقَطَّعَ خَدٌّ':Subject, #1: 1	تَقَطَّعَ الْحَمْلُ
u'تَقَطَّعَ دَمٌ':Subject, #1: 1	تَقَطَّعَ خَدَّاهُ
u'تَقَطُّعٌ دَمٌ':Added, #2: 2	تَقَطَّعَ الدَّمُ
u'تَقَطَّعَ زَمانٌ':Subject, #1: 1	تَقَطُّعِ الدَّمِ
u'تَقَطُّعٌ صُفُوفٌ':Added, #2: 2	تَقَطَّعَ الزَّمَانُ
u'تَقَطُّعٌ طَاقٌ':Added, #1: 1	تَقَطُّعِ الصُّفُوفِ
u'تَقَطُّعٌ طَاقَةٌ':Added, #1: 1	تَقَطُّعِ الطَّاقَاتِ
u'تَقَطَّعَ طُهْرٌ':Subject, #1: 1	تَقَطُّعِ الطَّاقَاتِ
u'تَقَطَّعَ عند':Predicate, #1: 1	تَقَطَّعَ طُهْرٌ
u'تَقَطَّعَ نَاسٌ':Subject, #1: 1	تَقَطَّعَ عِنْدَ
u'تَقَلُّبٌ أَحْوالٌ':Added, #1: 1	تَقَطَّعَ النَّاسُ
u'تَقَلُّبٌ أَحْوالٌ':Added, #1: 1	تَقَلُّبَ الْأَحْوَالِ
u'تَقَلُّبٌ أحْوَالٌ':Added, #1: 1	تَقَلُّبِ الْأَحْوَالِ
u'تَقَلُّبٌ أحْوَالٌ':Added, #1: 1	تَقَلُّبَ الْأَحْوَالِ
u'تَقَلَّبَ مَعْدُودٌ':Subject, #1: 1	تَقَلُّبِ الْأَحْوَالِ
u'تَقَلَّدَ حِسْبَةٌ':Predicate, #1: 1	تَقَلَّبَ مَعْدُودٌ
u'تَقَلَّدَ سَيْفٌ':Predicate, #1: 1	تَقَلَّدَ حِسْبَةَ
u'تَقَلُّدٌ سَيْفٌ':Added, #1: 1	تَقَلَّدَ السَّيْفَ
u'تَقَلُّدٌ سَيْفٌ':Added, #1: 1	تَقَلُّدُ السَّيْفِ
u'تَقَلُّدٌ سَيْفٌ':Added, #1: 1	تَقَلُّدَ سَيْفِهِ
u'تَقَلَّدَ قَضَاءٌ':Predicate, #1: 1	تَقَلُّدُ سَيْفِهِ
u'تَقَلُّدٌ قَضَاءٌ':Added, #4: 4	تَقَلَّدَ الْقَضَاءَ
u'تَقَلُّدٌ قَضَاءٌ':Added, #1: 1	تَقَلُّدَ الْقَضَاءِ
u'تَقَلُّدٌ قَضَاءٌ':Added, #2: 2	تَقَلُّدِ الْقَضَاءِ
u'تَقَلَّدَ مِنَّةٌ':Predicate, #4: 4	تَقَلُّدُ الْقَضَاءِ
u'تَقَلَّصَ ذكر':Subject, #1: 1	تَقَلَّدَ الْمِنَّةَ
u'تَقَلَّصَ ذَكَرٌ':Subject, #1: 1	تَقَلَّصَ ذَكَرُهُ
u'تَقَلُّصٌ غُرْلَة':Added, #1: 1	تَقَلَّصَ ذَكَرُهُ
u'تَقَلَّعَ عند':Predicate, #1: 1	تَقَلُّصُ الْغُرْلَةِ
u'تَقَهْقُرٌ خَالِدٌ':Added, #1: 1	تَقَلَّعَ عِنْدَ
u'تَقَوَّسَ ظَهْرٌ':Subject, #1: 1	تَقَهْقُرِ خَالِدٍ
u'تَقَوُّمٌ آدَمِيٌّ':Added, #1: 1	تَقَوَّسَ ظَهْرُهُ
u'تَقَوُّمٌ أُمٌّ':Added, #1: 1	تَقَوُّمَ الْآدَمِيِّ
u'تَقَوُّمٌ أُمٌّ':Added, #1: 1	تَقَوُّمَ أُمِّ
u'تَقَوُّمٌ أَمْوَالٌ':Added, #2: 2	تَقَوُّمِ أُمِّ
u'تَقَوُّمٌ عَمَلٌ':Added, #1: 1	تَقَوُّمَ الْأَمْوَالِ
u'تَقَوُّمٌ غير':Added, #4: 4	تَقَوُّمَ عَمَلِهِ
u'تَقَوُّمٌ غَيْرٌ':Added, #1: 1	تَقَوُّمِ غَيْرِهِ
u'تَقَوُّمٌ مَالٌ':Added, #1: 1	تَقَوُّمِ غَيْرِهِ
u'تَقَوُّمٌ مَحَلٌّ':Added, #1: 1	تَقَوُّمُ مَالِهِ
u'تَقَوُّمٌ مَنَافِعُ':Added, #2: 2	تَقَوُّمِ الْمَحَلِّ
u'تَقَوُّمٌ مَنَافِعُ':Added, #1: 1	تَقَوُّمَ الْمَنَافِعِ
u'تَقَوُّمٌ مَنَافِعُ':Added, #1: 1	تَقَوُّمُ الْمَنَافِعِ
u'تَقَوُّمٌ مَنَافِعُ':Added, #1: 1	تَقَوُّمِ الْمَنَافِعِ
u'تَقَوُّمٌ مَنَافِعُ':Added, #2: 2	تَقَوُّمَ مَنَافِعِ
u'تَقَوُّمٌ نَفْسٌ':Added, #2: 2	تَقَوُّمِ مَنَافِعِ
u'تَقَوِّي أحَدٌ':Added, #2: 2	تَقَوُّمَ نَفْسِهِ
u'تَقْوِيَةٌ أحَدٌ':Added, #1: 1	تَقَوِّي أَحَدِ
u'تَقْوِيَةٌ أَعْضَاءٌ':Added, #1: 1	تَقْوِيَةِ أَحَدِ
u'تَقْوِيَةٌ أَوَّلُ':Added, #1: 1	تَقْوِيَةِ الْأَعْضَاءِ
u'تَقْوِيَةٌ دُخُولٌ':Added, #1: 1	تَقْوِيَةَ الْأَوَّلِ
u'تَقْوِيَةٌ دَلالَةٌ':Added, #1: 1	تَقْوِيَةُ دُخُولِهِ
u'تَقْوِيَةٌ دَلالَةٌ':Added, #1: 1	تَقْوِيَةَ الدَّلَالَةِ
u'تَقْوِيَةٌ دَلالَةٌ':Added, #1: 1	تَقْوِيَةِ الدَّلَالَةِ
u'تَقْوِيَةٌ دَليلٌ':Added, #1: 1	تَقْوِيَةَ دَلَالَتِهِ
u'تَقْوِيَةٌ رَهْنٌ':Added, #1: 1	تَقْوِيَةِ الدَّلِيلِ
u'تَقْوِيَةٌ سَنَدٌ':Added, #2: 2	تَقْوِيَةُ الرَّهْنِ
u'تَقْوِيَةٌ عَقْلٌ':Added, #1: 1	تَقْوِيَةِ سَنَدٍ
u'تَقْوِيَةٌ قلب':Added, #1: 1	تَقْوِيَةَ الْعَقْلِ
u'تَقْوِيَةٌ قَلْبٌ':Added, #2: 2	تَقْوِيَةُ الْقَلْبِ
u'تَقْوِيَةٌ قَلْب':Added, #2: 2	تَقْوِيَةُ الْقَلْبِ
u'تَقْوِيَةٌ قول':Added, #2: 2	تَقْوِيَةُ الْقَلْبِ
u'تَقْوِيَةٌ قول':Added, #1: 1	تَقْوِيَةُ الْقَوْلِ
u'تَقْوِيَةٌ قَوْلٌ':Added, #1: 1	تَقْوِيَةِ الْقَوْلِ
u'تَقْوِيَةٌ قَوْلٌ':Added, #1: 1	تَقْوِيَةُ الْقَوْلِ
u'تَقْوِيَةٌ كُفَّارٌ':Added, #1: 1	تَقْوِيَةِ الْقَوْلِ
u'تَقْوِيَةٌ مَدْلُولٌ':Added, #2: 2	تَقْوِيَةَ الْكُفَّارِ
u'تَقْوِيَةٌ مَضْمُونٌ':Added, #2: 2	تَقْوِيَةُ مَدْلُولِ
u'تَقْوِيَةٌ مَعِدَةٌ':Added, #1: 1	تَقْوِيَةُ مَضْمُونِ
u'تَقْوِيَةٌ مَقَالَةٌ':Added, #2: 2	تَقْوِيَةِ الْمَعِدَةِ
u'تَقْوِيَةٌ نُفُوسٌ':Added, #1: 1	تَقْوِيَةِ مَقَالَةِ
u'تَقْوِيَةٌ وَجْهٌ':Added, #1: 1	تَقْوِيَةِ النُّفُوسِ
u'تَقَوَّى جَانِبٌ':Subject, #2: 2	تَقْوِيَةِ الْوَجْهِ
u'تَقَوَّى جَانِبٌ':Subject, #1: 1	تَقَوَّى جَانِبُهُ
u'تَقَوِّي شَيْءٌ':Added, #2: 2	تَقَوَّى جَانِبُ
u'تَقَوَّى قَوْمٌ':Subject, #2: 2	تَقَوِّي الشَّيْءِ
u'تَقَيَّأَ أقَلُّ':Predicate, #1: 1	تَقَوَّى قَوْمٌ
u'تَقَيَّأَ خَمْرٌ':Predicate, #1: 1	تَقَيَّأَ أَقَلَّ
u'تَقَيَّأَ صَبِيٌّ':Subject, #2: 2	تَقَيَّأَ الْخَمْرَ
u'تَقَيَّأَ غير':Predicate, #1: 1	تَقَيَّأَ الصَّبِيُّ
u'تَقَيَّأَ غَيْرٌ':Predicate, #1: 1	تَقَيَّأَ غَيْرَ
u'تَقِيَّةٌ جَوْرٌ':Added, #1: 1	تَقَيَّأَ غَيْرَ
u'تَقِيَّةٌ عَبْدٌ':Added, #1: 1	تَقِيَّةَ جَوْرِ
u'تَقِيٌّ جَوْرٌ':Added, #1: 1	تَقِيَّةُ الْعَبْدِ
u'تَقَيَّدَ تَحْرِيمٌ':Subject, #1: 1	تَقِيَّةَ جَوْرِ
u'تَقَيُّدٌ ركعة':Added, #1: 1	تَقَيَّدَ التَّحْرِيمُ
u'تَقَيُّدٌ رَكْعَةٌ':Added, #1: 1	تَقَيُّدِ الرَّكْعَةِ
u'تَقَيَّدَ رُكوعٌ':Subject, #1: 1	تَقَيُّدِ الرَّكْعَةِ
u'تَقَيُّدٌ صِحَّةٌ':Added, #1: 1	تَقَيَّدَ رُكُوعُهُ
u'تَقَيُّدٌ كَلاَمٌ':Added, #2: 2	تَقَيُّدَ صِحَّةِ
u'تَقَيُّدٌ مُتَقَدِّمٌ':Added, #1: 1	تَقَيُّدُ الْكَلَامِ
u'تَقَيَّدَ يَمِينٌ':Subject, #1: 1	تَقَيُّدِ الْمُتَقَدِّمِ
u'تَقِيٌّ عَبْدٌ':Added, #1: 1	تَقَيَّدَ يَمِينُ
u'تَكَاثَرَ تَشَاجُرٌ':Subject, #1: 1	تَقِيَّةُ الْعَبْدِ
u'تَكَاثَرَ مَاءٌ':Subject, #1: 1	تَكَاثَرَ التَّشَاجُرُ
u'تَكَافَأَ أهْلٌ':Subject, #1: 1	تَكَاثَرَ الْمَاءُ
u'تَكَامَلَ أَوَّلُ':Predicate, #1: 1	تَكَافَأَ أَهْلُ
u'تَكَامَلَ دِينٌ':Subject, #1: 1	تَكَامَلَ أَوَّلَ
u'تَكَامَلَ عَيْبٌ':Subject, #1: 1	تَكَامَلَ الدِّينُ
u'تَكَامَلَ نَاسٌ':Subject, #1: 1	تَكَامَلَ عَيْبُهُ
u'تَكَامَلَ نصاب':Subject, #1: 1	تَكَامَلَ النَّاسُ
u'تَكَامَلَ نِصَابٌ':Subject, #1: 1	تَكَامَلَ نِصَابُ
u'تَكَرُّرٌ إجَارَةٌ':Added, #1: 1	تَكَامَلَ نِصَابُ
u'تَكَرَّرَ إِذْنٌ':Subject, #1: 1	تَكَرُّرِ الْإِجَارَةِ
u'تَكَرُّرٌ إِذْنٌ':Added, #1: 1	تَكَرَّرَ الْإِذْنُ
u'تَكَرُّرٌ أَسَابِيعُ':Added, #1: 1	تَكَرُّرِ الْإِذْنِ
u'تَكَرَّرَ اِسْتِدْلاَلٌ':Subject, #1: 1	تَكَرُّرَ الْأَسَابِيعِ
u'تَكَرَّرَ أَسْرٌ':Subject, #1: 1	تَكَرَّرَ اسْتِدْلَالُ
u'تَكَرُّرٌ أَشْوَاطٌ':Added, #1: 1	تَكَرَّرَ الْأَسْرُ
u'تَكَرَّرَ أَعْوَامٌ':Subject, #1: 1	تَكَرُّرِ الْأَشْوَاطِ
u'تَكَرَّرَ إفْتَاءٌ':Subject, #1: 1	تَكَرَّرَ الْأَعْوَامُ
u'تَكَرَّرَ إفْسَادٌ':Subject, #1: 1	تَكَرَّرَ الْإِفْتَاءُ
u'تَكَرَّرَ إفْسَادٌ':Subject, #1: 1	تَكَرَّرَ إفْسَادُهُ
u'تَكَرَّرَ أَفْعَالٌ':Subject, #1: 1	تَكَرَّرَ الْإِفْسَادُ
u'تَكَرُّرٌ أَمْرٌ':Added, #1: 1	تَكَرَّرَ الْأَفْعَالُ
u'تَكَرَّرَ إيقَاعٌ':Subject, #2: 2	تَكَرُّرِ الْأَمْرِ
u'تَكَرُّرٌ أَيْمَانٌ':Added, #1: 1	تَكَرَّرَ الْإِيقَاعُ
u'تَكَرَّرَ بَيْعٌ':Subject, #1: 1	تَكَرُّرُ الْأَيْمَانِ
u'تَكَرُّرٌ بَيْعٌ':Added, #1: 1	تَكَرَّرَ بَيْعُهُ
u'تَكَرُّرٌ تَصَرُّفٌ':Added, #2: 2	تَكَرُّرِ بَيْعٍ
u'تَكَرَّرَ تَصْفِيقٌ':Subject, #1: 1	تَكَرُّرِ التَّصَرُّفِ
u'تَكَرُّرٌ تَوْلِيَةٌ':Added, #1: 1	تَكَرَّرَ تَصْفِيقُ
u'تَكَرَّرَ جَزَاءٌ':Subject, #1: 1	تَكَرُّرُ التَّوْلِيَةِ
u'تَكَرُّرٌ جَزَاءٌ':Added, #1: 1	تَكَرَّرَ الْجَزَاءُ
u'تَكَرُّرٌ جَزَاءٌ':Added, #1: 1	تَكَرُّرَ الْجَزَاءِ
u'تَكَرُّرٌ جمع':Added, #1: 1	تَكَرُّرُ الْجَزَاءِ
u'تَكَرُّرٌ جَمْعٌ':Added, #1: 1	تَكَرُّرِ الْجَمْعِ
u'تَكَرُّرٌ حَدَثٌ':Added, #1: 1	تَكَرُّرِ الْجَمْعِ
u'تَكَرَّرَ حَرْفٌ':Subject, #1: 1	تَكَرُّرَ الْحَدَثِ
u'تَكَرُّرٌ حُكْمٌ':Added, #1: 1	تَكَرَّرَ حَرْفُ
u'تَكَرَّرَ حَمْدٌ':Subject, #2: 2	تَكَرُّرَ الْحُكْمِ
u'تَكَرَّرَ حَمْلٌ':Subject, #1: 1	تَكَرَّرَ حَمْدُهُ
u'تَكَرُّرٌ حِنْثٌ':Added, #1: 1	تَكَرَّرَ حَمْلُهُ
u'تَكَرُّرٌ حول':Added, #3: 3	تَكَرُّرَ الْحِنْثِ
u'تَكَرُّرٌ حَوْلٌ':Added, #1: 1	تَكَرُّرِ الْحَوْلِ
u'تَكَرُّرٌ حَيْضٌ':Added, #1: 1	تَكَرُّرِ الْحَوْلِ
u'تَكَرَّرَ خُرُوجٌ':Subject, #1: 1	تَكَرُّرِ الْحَيْضِ
u'تَكَرُّرٌ خُرُوجٌ':Added, #1: 1	تَكَرَّرَ خُرُوجُهُ
u'تَكَرَّرَ خِطَابٌ':Subject, #1: 1	تَكَرُّرِ الْخُرُوجِ
u'تَكَرَّرَ دُخُولٌ':Subject, #1: 1	تَكَرَّرَ الْخِطَابُ
u'تَكَرَّرَ دُخُولٌ':Subject, #1: 1	تَكَرَّرَ الدُّخُولُ
u'تَكَرَّرَ دِرْهَمٌ':Subject, #7: 7	تَكَرَّرَ دُخُولُهُ
u'تَكَرَّرَ دِرْهَم':Subject, #1: 1	تَكَرَّرَ الدِّرْهَمُ
u'تَكَرَّرَ دَليلٌ':Subject, #1: 1	تَكَرَّرَ الدِّرْهَمُ
u'تَكَرَّرَ دَمٌ':Subject, #1: 1	تَكَرَّرَ دَلِيلُ
u'تَكَرُّرٌ دَمٌ':Added, #2: 2	تَكَرَّرَ الدَّمُ
u'تَكَرَّرَ دَوَرانٌ':Subject, #1: 1	تَكَرُّرِ الدَّمِ
u'تَكَرَّرَ دونٌ':Predicate, #1: 1	تَكَرَّرَ دَوَرَانُ
u'تَكَرَّرَ ذكر':Subject, #1: 1	تَكَرَّرَ دُونَ
u'تَكَرَّرَ ذِكْرٌ':Subject, #1: 1	تَكَرَّرَ ذِكْرُ
u'تَكَرُّرٌ ذكر':Added, #1: 1	تَكَرَّرَ ذِكْرُ
u'تَكَرُّرٌ ذِكْرٌ':Added, #1: 1	تَكَرُّرِ الذِّكْرِ
u'تَكَرَّرَ ذَنْبٌ':Subject, #1: 1	تَكَرُّرِ الذِّكْرِ
u'تَكَرُّرٌ رَدٌّ':Added, #1: 1	تَكَرَّرَ الذَّنْبُ
u'تَكَرُّرٌ رِدَّةٌ':Added, #1: 1	تَكَرُّرُ الرَّدِّ
u'تَكَرَّرَ رعاف':Subject, #1: 1	تَكَرُّرِ الرِّدَّةِ
u'تَكَرَّرَ رُعافٌ':Subject, #1: 1	تَكَرَّرَ الرُّعَافُ
u'تَكَرَّرَ سَبَبٌ':Subject, #1: 1	تَكَرَّرَ الرُّعَافُ
u'تَكَرُّرٌ سَبَبٌ':Added, #2: 2	تَكَرَّرَ سَبَبُ
u'تَكَرَّرَ سُجُودٌ':Subject, #1: 1	تَكَرُّرِ السَّبَبِ
u'تَكَرَّرَ سُجُودٌ':Subject, #1: 1	تَكَرَّرَ السُّجُودُ
u'تَكَرَّرَ سلام':Subject, #1: 1	تَكَرَّرَ سُجُودُ
u'تَكَرَّرَ سَلاَمٌ':Subject, #1: 1	تَكَرَّرَ السَّلَامُ
u'تَكَرُّرٌ سلام':Added, #1: 1	تَكَرَّرَ السَّلَامُ
u'تَكَرُّرٌ سَلاَمٌ':Added, #1: 1	تَكَرُّرِ السَّلَامِ
u'تَكَرَّرَ سَهْوٌ':Subject, #1: 1	تَكَرُّرِ السَّلَامِ
u'تَكَرَّرَ سُؤَالٌ':Subject, #1: 1	تَكَرَّرَ سَهْوُهُ
u'تَكَرُّرٌ سُؤَالٌ':Added, #1: 1	تَكَرَّرَ سُؤَالُهُ
u'تَكَرَّرَ شرب':Subject, #1: 1	تَكَرُّرِ السُّؤَالِ
u'تَكَرَّرَ شُرْبٌ':Subject, #2: 2	تَكَرَّرَ شُرْبُهُ
u'تَكَرَّرَ شَرْطٌ':Subject, #2: 2	تَكَرَّرَ شُرْبُهُ
u'تَكَرُّرٌ شَرْطٌ':Added, #1: 1	تَكَرَّرَ الشَّرْطُ
u'تَكَرُّرٌ صَلاَةٌ':Added, #1: 1	تَكَرُّرِ الشَّرْطِ
u'تَكَرُّرٌ صِيغَةٌ':Added, #1: 1	تَكَرُّرَ الصَّلَاةِ
u'تَكَرَّرَ طَلاَقٌ':Subject, #1: 1	تَكَرُّرِ صِيغَتِهِ
u'تَكَرُّرٌ طَهَارَةٌ':Added, #1: 1	تَكَرَّرَ الطَّلَاقُ
u'تَكَرَّرَ ظَرْفٌ':Subject, #1: 1	تَكَرُّرِ الطَّهَارَةِ
u'تَكَرَّرَ عُدٌّ':Predicate, #1: 1	تَكَرَّرَ الظَّرْفُ
u'تَكَرَّرَ عُطاس':Subject, #1: 1	تَكَرَّرَ عُدَّ
u'تَكَرَّرَ عَقْدٌ':Subject, #1: 1	تَكَرَّرَ عُطَاسُهُ
u'تَكَرُّرٌ غُلُوٌّ':Added, #1: 1	تَكَرَّرَ عَقْدُهُ
u'تَكَرُّرٌ فِدَاءٌ':Added, #1: 1	تَكَرُّرِ غُلُوِّ
u'تَكَرُّرٌ فِدْيَةٌ':Added, #1: 1	تَكَرُّرِ الْفِدَاءِ
u'تَكَرَّرَ فِعْلٌ':Subject, #1: 1	تَكَرُّرِ الْفِدْيَةِ
u'تَكَرُّرٌ فِعْلٌ':Added, #2: 2	تَكَرَّرَ الْفِعْلُ
u'تَكَرُّرٌ فِعْلٌ':Added, #1: 1	تَكَرُّرُ الْفِعْلِ
u'تَكَرُّرٌ فِعْلٌ':Added, #1: 1	تَكَرُّرِ الْفِعْلِ
u'تَكَرُّرٌ قِرَاءةٌ':Added, #1: 1	تَكَرُّرِ فِعْلِ
u'تَكَرُّرٌ قَضَاءٌ':Added, #1: 1	تَكَرُّرِ الْقِرَاءَةِ
u'تَكَرَّرَ قيام':Subject, #1: 1	تَكَرُّرِ الْقَضَاءِ
u'تَكَرَّرَ قِيَامٌ':Subject, #1: 1	تَكَرَّرَ الْقِيَامُ
u'تَكَرَّرَ قَيْدٌ':Subject, #1: 1	تَكَرَّرَ الْقِيَامُ
u'تَكَرَّرَ كَلاَمٌ':Subject, #1: 1	تَكَرَّرَ قَيْدٌ
u'تَكَرُّرٌ كُلَفٌ':Added, #1: 1	تَكَرَّرَ كَلَامُهُ
u'تَكَرُّرٌ كَلِمَةٌ':Added, #1: 1	تَكَرُّرِ الْكُلَفِ
u'تَكَرُّرٌ لبس':Added, #1: 1	تَكَرُّرَ كَلِمَاتِهِ
u'تَكَرُّرٌ لُبْسٌ':Added, #1: 1	تَكَرُّرَ اللُّبْسِ
u'تَكَرَّرَ لَفْظٌ':Subject, #1: 1	تَكَرُّرَ اللُّبْسِ
u'تَكَرُّرٌ لَفْظٌ':Added, #3: 3	تَكَرَّرَ لَفْظُ
u'تَكَرُّرٌ لَفْظٌ':Added, #1: 1	تَكَرُّرُ اللَّفْظِ
u'تَكَرَّرَ مَأْمُورٌ':Subject, #1: 1	تَكَرُّرِ اللَّفْظِ
u'تَكَرَّرَ مُدٌّ':Subject, #1: 1	تَكَرَّرَ الْمَأْمُورُ
u'تَكَرُّرٌ مَدٌّ':Added, #2: 2	تَكَرَّرَ الْمُدُّ
u'تَكَرُّرٌ مَعْلُولٌ':Added, #1: 1	تَكَرُّرِ الْمَدِّ
u'تَكَرَّرَ مَنْعٌ':Subject, #1: 1	تَكَرُّرِ الْمَعْلُولِ
u'تَكَرَّرَ مَهْرٌ':Subject, #1: 1	تَكَرَّرَ مَنْعُ
u'تَكَرُّرٌ نُزُولٌ':Added, #1: 1	تَكَرَّرَ الْمَهْرُ
u'تَكَرَّرَ نَظَرٌ':Subject, #1: 1	تَكَرُّرَ نُزُولِ
u'تَكَرَّرَ نَفْعٌ':Subject, #2: 2	تَكَرَّرَ نَظَرُهُ
u'تَكَرَّرَ نَقْصٌ':Subject, #1: 1	تَكَرَّرَ النَّفْعُ
u'تَكَرُّرٌ نَهْيٌ':Added, #1: 1	تَكَرَّرَ النَّقْصُ
u'تَكَرُّرٌ نَهْيٌ':Added, #1: 1	تَكَرُّرُ النَّهْيِ
u'تَكَرَّرَ نَوْمٌ':Subject, #1: 1	تَكَرُّرِ النَّهْيِ
u'تَكَرَّرَ وَاجِبٌ':Subject, #2: 2	تَكَرَّرَ نَوْمُهُ
u'تَكَرَّرَ وَاقِعٌ':Subject, #1: 1	تَكَرَّرَ الْوَاجِبُ
u'تَكَرُّرٌ وَاقِعٌ':Added, #1: 1	تَكَرَّرَ الْوَاقِعَةُ
u'تَكَرَّرَ وَاقِعَةٌ':Subject, #3: 3	تَكَرُّرِ الْوَاقِعَةِ
u'تَكَرُّرٌ وَاقِعَةٌ':Added, #1: 1	تَكَرَّرَ الْوَاقِعَةُ
u'تَكَرَّرَ وُجُوبٌ':Subject, #3: 3	تَكَرُّرِ الْوَاقِعَةِ
u'تَكَرُّرٌ وُجُوبٌ':Added, #6: 6	تَكَرَّرَ الْوُجُوبُ
u'تَكَرُّرٌ وُجُوبٌ':Added, #1: 1	تَكَرُّرُ الْوُجُوبِ
u'تَكَرُّرٌ وُجُوبٌ':Added, #1: 1	تَكَرُّرَ وُجُوبِ
u'تَكَرُّرٌ وُجُودٌ':Added, #1: 1	تَكَرُّرُ وُجُوبِ
u'تَكَرُّرٌ وَصْفٌ':Added, #1: 1	تَكَرُّرِ وُجُودِ
u'تَكَرَّرَ وُضُوءٌ':Subject, #1: 1	تَكَرُّرِ وَصْفِهِ
u'تَكَرُّرٌ وُضُوءٌ':Added, #1: 1	تَكَرَّرَ الْوُضُوءُ
u'تَكَرَّرَ وَطْءٌ':Subject, #1: 1	تَكَرُّرُ الْوُضُوءِ
u'تَكَرَّرَ وَطْءٌ':Subject, #2: 2	تَكَرَّرَ وَطْءُ
u'تَكَرَّرَ وُقُوعٌ':Subject, #3: 3	تَكَرَّرَ الْوَطْءُ
u'تَكَرُّرٌ وُقُوعٌ':Added, #1: 1	تَكَرَّرَ وُقُوعُ
u'تَكَرُّرٌ وُقُوعٌ':Added, #1: 1	تَكَرُّرِ وُقُوعِ
u'تَكَرُّهٌ بَذْلٌ':Added, #1: 1	تَكَرُّرُ وُقُوعِهِ
u'تَكَسُّبٌ مَالٌ':Added, #1: 1	تَكَرُّهِ بَذْلِهِ
u'تَكَسَّرَ ثَوْبٌ':Subject, #1: 1	تَكَسُّبِ الْمَالِ
u'تَكَسَّرَ ظُفْرٌ':Subject, #2: 2	تَكَسَّرَ الثَّوْبُ
u'تَكَشُّفٌ أَحْوالٌ':Added, #1: 1	تَكَسَّرَ ظُفْرُ
u'تَكَشُّفٌ أحْوَالٌ':Added, #1: 1	تَكَشُّفِ أَحْوَالِهِ
u'تَكَشُّفٌ الْمَرْأَةُ':Added, #1: 1	تَكَشُّفِ أَحْوَالِهِ
u'تَكَشُّفٌ حالٌ':Added, #1: 1	تَكَشُّفِ الْمَرْأَةِ
u'تَكَفَّلَ بَعْضٌ':Subject, #1: 1	تَكَشُّفِ الْحَالِ
u'تَكَفَّلَ ثَلاثَةٌ':Subject, #1: 1	تَكَفَّلَ بَعْضُ
u'تَكَفَّلَ ثَلاثَةٌ':Subject, #1: 1	تَكَفَّلَ ثَلَاثَةٌ
u'تَكَفَّلَ شَخْصٌ':Subject, #2: 2	تَكَفَّلَ ثَلَاثَةُ
u'تَكَفَّلَ عَبْدٌ':Subject, #1: 1	تَكَفَّلَ شَخْصٌ
u'تَكَفُّلٌ كَافِرٌ':Added, #1: 1	تَكَفَّلَ الْعَبْدُ
u'تَكَفَّلَ كَفِيلٌ':Subject, #1: 1	تَكَفُّلِ الْكَافِرِ
u'تَكَفَّلَ مُتَعَلِّقٌ':Subject, #1: 1	تَكَفَّلَ الْكَفِيلُ
u'تَكَلُّفٌ إبْداءٌ':Added, #1: 1	تَكَفَّلَ مُتَعَلِّقٌ
u'تَكَلَّفَ أحَدٌ':Subject, #1: 1	تَكَلُّفِ إبْدَاءِ
u'تَكَلُّفٌ أَذَانٌ':Added, #1: 1	تَكَلَّفَ أَحَدٌ
u'تَكَلُّفٌ بَحْثٌ':Added, #1: 1	تَكَلُّفُ الأَذَانِ
u'تَكَلَّفَ بَعْضٌ':Subject, #1: 1	تَكَلُّفِ بَحْثٍ
u'تَكَلُّفٌ بَيَانٌ':Added, #1: 1	تَكَلَّفَ بَعْضُ
u'تَكَلُّفٌ تَحَامُلٌ':Added, #1: 1	تَكَلُّفِ بَيَانِ
u'تَكَلُّفٌ تَحْدِيدٌ':Added, #1: 1	تَكَلُّفِ التَّحَامُلِ
u'تَكَلُّفٌ تَخْرِيجٌ':Added, #4: 4	تَكَلُّفِ التَّحْدِيدِ
u'تَكَلُّفٌ تَصْوِيرٌ':Added, #1: 1	تَكَلُّفِ تَخْرِيجِ
u'تَكَلُّفٌ تَقْديمٌ':Added, #1: 1	تَكَلُّفِ تَصْوِيرِهِ
u'تَكَلَّفَ جمع':Predicate, #1: 1	تَكَلُّفِ التَّقْدِيمِ
u'تَكَلَّفَ جَمْعٌ':Predicate, #1: 1	تَكَلَّفَ الْجَمْعَ
u'تَكَلُّفٌ جَوَابٌ':Added, #1: 1	تَكَلَّفَ الْجَمْعَ
u'تَكَلُّفٌ جَوَابٌ':Added, #1: 1	تَكَلُّفِ الْجَوَابِ
u'تَكَلُّفٌ حساب':Added, #1: 1	تَكَلُّفِ جَوَابٍ
u'تَكَلُّفٌ حِسَابٌ':Added, #1: 1	تَكَلُّفِ حِسَابٍ
u'تَكَلُّفٌ حِفْظٌ':Added, #1: 1	تَكَلُّفِ حِسَابٍ
u'تَكَلَّفَ حِلْمٌ':Predicate, #2: 2	تَكَلُّفِ حِفْظِهِ
u'تَكَلَّفَ حَمَاقَةٌ':Predicate, #1: 1	تَكَلَّفَ الْحِلْمَ
u'تَكَلُّفٌ حَمَامٌ':Added, #1: 1	تَكَلَّفَ الْحَمَاقَةَ
u'تَكَلُّفٌ حَمْلٌ':Added, #1: 1	تَكَلُّفِ حَمَامٍ
u'تَكَلَّفَ رَفْعٌ':Predicate, #1: 1	تَكَلُّفِ الْحَمْلِ
u'تَكَلُّفٌ سَبَبٌ':Added, #1: 1	تَكَلَّفَ رَفْعَ
u'تَكَلُّفٌ شَيْءٌ':Added, #1: 1	تَكَلُّفِ سَبَبِ
u'تَكَلَّفَ صَلاَةٌ':Predicate, #1: 1	تَكَلُّفِ الشَّيْءِ
u'تَكَلَّفَ صَوْمٌ':Predicate, #2: 2	تَكَلَّفَ الصَّلَاةَ
u'تَكَلُّفٌ طلب':Added, #1: 1	تَكَلَّفَ الصَّوْمَ
u'تَكَلُّفٌ طَلَبٌ':Added, #1: 1	تَكَلُّفَ طَلَبِهِ
u'تَكَلَّفَ علم':Predicate, #1: 1	تَكَلُّفَ طَلَبِهِ
u'تَكَلَّفَ عِلْمٌ':Predicate, #1: 1	تَكَلَّفَ الْعِلْمَ
u'تَكَلَّفَ غُسْلٌ':Predicate, #1: 1	تَكَلَّفَ الْعِلْمَ
u'تَكَلُّفٌ غَسْلٌ':Added, #1: 1	تَكَلَّفَ الْغُسْلَ
u'تَكَلُّفٌ غير':Added, #1: 1	تَكَلُّفُ الْغَسْلِ
u'تَكَلُّفٌ غَيْرٌ':Added, #1: 1	تَكَلُّفِ غَيْرِهِ
u'تَكَلُّفٌ فرق':Added, #1: 1	تَكَلُّفِ غَيْرِهِ
u'تَكَلُّفٌ فَرْقٌ':Added, #1: 1	تَكَلُّفِ الْفَرْقِ
u'تَكَلُّفٌ قَضَاءٌ':Added, #1: 1	تَكَلُّفِ الْفَرْقِ
u'تَكَلُّفٌ قول':Added, #1: 1	تَكَلُّفُ الْقَضَاءِ
u'تَكَلُّفٌ قَوْلٌ':Added, #1: 1	تَكَلُّفِ الْقَوْلِ
u'تَكَلُّفٌ كِتَابَةٌ':Added, #1: 1	تَكَلُّفِ الْقَوْلِ
u'تَكَلُّفٌ كَشْفٌ':Added, #1: 1	تَكَلُّفِ كِتَابَتِهِ
u'تَكَلُّفٌ كَلاَمٌ':Added, #1: 1	تَكَلُّفُ الْكَشْفِ
u'تَكَلَّفَ مُتَكَلِّفٌ':Subject, #2: 2	تَكَلُّفَ كَلَامٍ
u'تَكَلُّفٌ مَجَازٌ':Added, #1: 1	تَكَلَّفَ مُتَكَلِّفٌ
u'تَكَلَّفَ مَحْرَمٌ':Subject, #1: 1	تَكَلُّفِ الْمَجَازِ
u'تَكَلَّفَ مَرِيضٌ':Subject, #2: 2	تَكَلَّفَ الْمَحْرَمُ
u'تَكَلَّفَ مَشَقَّةٌ':Predicate, #1: 1	تَكَلَّفَ الْمَرِيضُ
u'تَكَلَّفَ مُعْسِرٌ':Subject, #1: 1	تَكَلَّفَ الْمَشَقَّةَ
u'تَكَلَّفَ مُعْسِرٌ':Subject, #1: 1	تَكَلَّفَ الْمُعْسِرُ
u'تَكَلُّفٌ نقل':Added, #1: 1	تَكَلَّفَ مُعْسِرٌ
u'تَكَلُّفٌ نَقْلٌ':Added, #1: 1	تَكَلُّفِ نَقْلِ
u'تَكَلَّفَ وُضُوءٌ':Predicate, #1: 1	تَكَلُّفِ نَقْلِ
u'تَكَلَّمَ اِبْنٌ':Subject, #2: 2	تَكَلَّفَ الْوُضُوءَ
u'تَكَلَّمَ أحَدٌ':Subject, #3: 3	تَكَلَّمَ ابْنُ
u'تَكَلَّمَ أَرْبَعَةٌ':Subject, #1: 1	تَكَلَّمَ أَحَدٌ
u'تَكَلَّمَ أَصْحَابٌ':Subject, #1: 1	تَكَلَّمَ أَرْبَعَةٌ
u'تَكَلَّمَ اِعْتِرافٌ':Subject, #1: 1	تَكَلَّمَ الْأَصْحَابُ
u'تَكَلُّمٌ الْمَرْءُ':Added, #1: 1	تَكَلَّمَ اعْتِرَافُهُ
u'تَكَلَّمَ إمَامٌ':Subject, #1: 1	تَكَلُّمُ الْمَرْءِ
u'تَكَلَّمَ إمَامٌ':Subject, #1: 1	تَكَلَّمَ الإِمَامُ
u'تَكَلَّمَ إمَامٌ':Subject, #1: 1	تَكَلَّمَ إمَامُ
u'تَكَلَّمَ أهْلٌ':Subject, #8: 8	تَكَلَّمَ الْإِمَامُ
u'تَكَلَّمَ بَائِعٌ':Subject, #1: 1	تَكَلَّمَ أَهْلُ
u'تَكَلَّمَ بَعْضٌ':Subject, #1: 1	تَكَلَّمَ الْبَائِعُ
u'تَكَلَّمَ تَامٌّ':Subject, #2: 2	تَكَلَّمَ بَعْضُ
u'تَكَلَّمَ ثَانِي':Predicate, #1: 1	تَكَلَّمَ تَامَّةٌ
u'تَكَلَّمَ ثَانِيَةٌ':Predicate, #1: 1	تَكَلَّمَ الثَّانِيَةَ
u'تَكَلَّمَ ثَلاثَةٌ':Subject, #1: 1	تَكَلَّمَ الثَّانِيَةَ
u'تَكَلَّمَ جَاهِلٌ':Predicate, #1: 1	تَكَلَّمَ ثَلاَثَةٌ
u'تَكَلَّمَ رَاهِبٌ':Subject, #1: 1	تَكَلَّمَ جَاهِلاً
u'تَكَلَّمَ رَجُلٌ':Subject, #1: 1	تَكَلَّمَ الرَّاهِبُ
u'تَكَلَّمَ رَجُلٌ':Subject, #1: 1	تَكَلَّمَ رَجُلٌ
u'تَكَلَّمَ زادٌ':Predicate, #2: 2	تَكَلَّمَ الرَّجُلُ
u'تَكَلَّمَ زَوْجٌ':Subject, #1: 1	تَكَلَّمَ زَادَ
u'تَكَلَّمَ زَيْدٌ':Subject, #3: 3	تَكَلَّمَ الزَّوْجُ
u'تَكَلَّمَ شافِعِيّ':Subject, #1: 1	تَكَلَّمَ زَيْدٌ
u'تَكَلَّمَ صَاحِبٌ':Subject, #1: 1	تَكَلَّمَ الشَّافِعِيُّ
u'تَكَلَّمَ صَحَابَةٌ':Subject, #1: 1	تَكَلَّمَ صَاحِبُ
u'تَكَلَّمَ علا':Subject, #1: 1	تَكَلَّمَ الصَّحَابَةُ
u'تَكَلَّمَ علماء':Subject, #1: 1	تَكَلَّمَ عَلاهُ
u'تَكَلَّمَ عُلَمَاءُ':Subject, #4: 4	تَكَلَّمَ الْعُلَمَاءُ
u'تَكَلَّمَ عند':Predicate, #4: 4	تَكَلَّمَ الْعُلَمَاءُ
u'تَكَلَّمَ غير':Subject, #1: 1	تَكَلَّمَ عِنْدَ
u'تَكَلَّمَ غَيْرٌ':Subject, #1: 1	تَكَلَّمَ غَيْرُ
u'تَكَلَّمَ فَاسِدٌ':Subject, #1: 1	تَكَلَّمَ غَيْرُ
u'تَكَلَّمَ فَصْلٌ':Predicate, #1: 1	تَكَلَّمَ فَاسِدَةٌ
u'تَكَلَّمَ فقهاء':Subject, #1: 1	تَكَلَّمَ فَصْلاً
u'تَكَلَّمَ فَلًا':Predicate, #1: 1	تَكَلَّمَ الْفُقَهَاءُ
u'تَكَلَّمَ فلان':Subject, #1: 1	تَكَلَّمَ فَلاَ
u'تَكَلَّمَ فلان':Subject, #1: 1	تَكَلَّمَ الْحَازِمِيُّ
u'تَكَلَّمَ فُلاَنٌ':Subject, #1: 1	تَكَلَّمَ الشَّافِعِيُّ
u'تَكَلَّمَ قَالٌ':Predicate, #2: 2	تَكَلَّمَ فُلَانٌ
u'تَكَلَّمَ قَوْمٌ':Subject, #1: 1	تَكَلَّمَ قَالَ
u'تَكَلَّمَ كَافِرٌ':Subject, #1: 1	تَكَلَّمَ قَوْمٌ
u'تَكَلَّمَ لاَحِقٌ':Subject, #1: 1	تَكَلَّمَ الْكَافِرُ
u'تَكَلَّمَ مَالِكٌ':Subject, #2: 2	تَكَلَّمَ اللَّاحِقُ
u'تَكَلَّمَ مَشَايِخُ':Subject, #2: 2	تَكَلَّمَ مَالِكٌ
u'تَكَلَّمَ مُصَنِّفٌ':Subject, #4: 4	تَكَلَّمَ الْمَشَايِخُ
u'تَكَلَّمَ مُؤَذِّنٌ':Subject, #21: 21	تَكَلَّمَ الْمُصَنِّفُ
u'تَكَلَّمَ نَاسٌ':Subject, #1: 1	تَكَلَّمَ الْمُؤَذِّنُ
u'تَكَلَّمَ نَبِيٌّ':Subject, #6: 6	تَكَلَّمَ النَّاسُ
u'تَكَلُّمٌ نَبِيٌّ':Added, #2: 2	تَكَلَّمَ النَّبِيُّ
u'تَكَلَّمَ نِساءٌ':Subject, #1: 1	تَكَلُّمِ النَّبِيِّ
u'تَكَلَّمَ نَظْمٌ':Subject, #1: 1	تَكَلَّمَ النِّسَاءُ
u'تَكَلَّمَ واحد':Subject, #1: 1	تَكَلَّمَ نَظْمُ
u'تَكَلَّمَ وَاحِدٌ':Subject, #1: 1	تَكَلَّمَ وَاحِدٌ
u'تَكَلَّمَ واحد':Subject, #1: 1	تَكَلَّمَ وَاحِدٌ
u'تَكَلَّمَ وَاحِدٌ':Subject, #1: 1	تَكَلَّمَ وَاحِدَةٌ
u'تَكَلَّمَ وَاصِلٌ':Subject, #1: 1	تَكَلَّمَ وَاحِدَةٌ
u'تَكَلَّمَ وَاصِلٌ':Subject, #1: 1	تَكَلَّمَ وَاصِلٌ
u'تَكَلَّمَ يَوْمٌ':Predicate, #1: 1	تَكَلَّمَ وَاصِلُ
u'تَكَمَّلَ أُسْبُوعٌ':Predicate, #1: 1	تَكَلَّمَ يَوْمَ
u'تَكَنَّسَ ظَبْيٌ':Subject, #1: 1	تَكَمَّلَ الْأُسْبُوعَ
u'تَكْنِيَة عَبْدٌ':Added, #2: 2	تَكَنَّسَ ظَبْيٌ
u'تَكْنِيَة عَلِيٌّ':Added, #1: 1	تَكْنِيَةِ عَبْدِ
u'تَكْنِيَة كَافِرٌ':Added, #1: 1	تَكْنِيَةُ عَلِيٍّ
u'تَكْنِيَة مُشْرِك':Added, #1: 1	تَكْنِيَةُ الْكَافِرِ
u'تَلَا اِبْنٌ':Subject, #1: 1	تَكْنِيَةِ الْمُشْرِكِ
u'تَلَا إمَامٌ':Subject, #2: 2	تَلَا ابْنُ
u'تَلَا آيَةٌ':Predicate, #4: 4	تَلَا الْإِمَامُ
u'تَلَا ثُلاثِيٌّ':Subject, #20: 20	تَلَا آيَةَ
u'تَلَا ذكر':Predicate, #1: 1	تَلَا ثُلَاثِيٌّ
u'تَلَا ذِكْرٌ':Predicate, #1: 1	تَلَا الذِّكْرَ
u'تَلَا ذكر':Subject, #1: 1	تَلَا الذِّكْرَ
u'تَلَا ذِكْرٌ':Subject, #1: 1	تَلَا الذِّكْرُ
u'تَلَا رَسُولٌ':Subject, #1: 1	تَلَا الذِّكْرُ
u'تَلَاعَبَ قَوْمٌ':Subject, #6: 6	تَلَا رَسُولُ
u'تَلَاعَنَ اِمْرُؤٌ':Subject, #1: 1	تَلَاعَبَ قَوْمٌ
u'تَلَا فَاتِحٌ':Predicate, #1: 1	تَلَاعَنَ امْرُؤُ
u'تَلَا فَاتِحَةٌ':Predicate, #1: 1	تَلَا الْفَاتِحَةَ
u'تَلَا فَرْضٌ':Predicate, #1: 1	تَلَا الْفَاتِحَةَ
u'تَلَافَى مَتْرُوكٌ':Predicate, #1: 1	تَلَا الْفَرْضَ
u'تَلَا قُرْآنٌ':Predicate, #4: 4	تَلَافَى الْمَتْرُوكَ
u'تَلَاقَى جَرَيان':Subject, #2: 2	تَلَا الْقُرْآنَ
u'تَلَا مَالِكٌ':Subject, #1: 1	تَلَاقَى جَرَيَانُهُ
u'تَلَا مُحَمَّدٌ':Subject, #2: 2	تَلَا مَالِكٌ
u'تَلَا مَحْمُولٌ':Subject, #1: 1	تَلَا مُحَمّدٌ
u'تَلَا نَبِيٌّ':Subject, #1: 1	تَلَا مَحْمُولٌ
u'تَلَا يَوْمٌ':Predicate, #1: 1	تَلَا النَّبِيُّ
u'تَلَبُّسٌ شَرِيكٌ':Added, #1: 1	تَلَا يَوْمَ
u'تَلَبُّسٌ ضِدٌّ':Added, #1: 1	تَلَبُّسُ الشَّرِيكَيْنِ
u'تَلَبُّسٌ عَامِلٌ':Added, #1: 1	تَلَبُّسُ ضِدٍّ
u'تَلَبُّسٌ كَثِيرٌ':Added, #2: 2	تَلَبُّسِ الْعَامِلِ
u'تَلَبَّسَ مُتَلَبِّسٌ':Subject, #1: 1	تَلَبُّسِ الْكَثِيرِ
u'تَلَثُّمٌ رَجُلٌ':Added, #1: 1	تَلَبَّسَ الْمُتَلَبِّسُ
u'تَلِدَ أمَةٌ':Subject, #1: 1	تَلَثُّمُ الرَّجُلِ
u'تَلِدَ أمَةٌ':Subject, #1: 1	تَلِدَ أَمَتُهُ
u'تَلِدَ أمَةٌ':Subject, #2: 2	تَلِدَ الأَمَةُ
u'تَلِدَ عتق':Predicate, #4: 4	تَلِدَ الْأَمَةُ
u'تَلِدَ عند':Predicate, #1: 1	تَلِدَ عَتَقَ
u'تَلِدَ عند':Predicate, #1: 1	تَلِدَ عِنْدَ
u'تَلَذَّذَ شَخْصٌ':Subject, #1: 1	تَلِدَ عِنْدَكَ
u'تَلَذَّذَ مَحْسُودٌ':Subject, #1: 1	تَلَذَّذَ الشَّخْصُ
u'تَلَطُّخٌ ثَوْبٌ':Added, #1: 1	تَلَذَّذَ الْمَحْسُودُ
u'تَلَطَّخَ ثِيابٌ':Subject, #1: 1	تَلَطُّخِ ثَوْبِهِ
u'تَلَطُّخٌ ثِيابٌ':Added, #1: 1	تَلَطَّخَ ثِيَابُهُ
u'تَلَطُّخٌ جَسَدٌ':Added, #1: 1	تَلَطُّخِ ثِيَابِهِ
u'تَلَطُّخٌ وَجْهٌ':Added, #1: 1	تَلَطُّخَ جَسَدِهِ
u'تَلَطَّخَ يَدٌ':Subject, #1: 1	تَلَطُّخُ الْوَجْهِ
u'تَلِفَ أحَدٌ':Subject, #1: 1	تَلَطَّخَ يَدُهُ
u'تَلَفٌ أحَدٌ':Added, #3: 3	تَلِفَ أَحَدُ
u'تَلَفٌ أرْضٌ':Added, #2: 2	تَلَفِ أَحَدِ
u'تَلِفَ أَشْيَاءٌ':Predicate, #3: 3	تَلَفِ الْأَرْضِ
u'تَلِفَ أصل':Predicate, #1: 1	أَتْلَفَ أَشْيَاءَ
u'تَلِفَ أًصْلٌ':Predicate, #1: 1	أَتْلَفَ الْأَصْلَ
u'تَلِفَ أَكْثَرُ':Predicate, #1: 1	أَتْلَفَ الْأَصْلَ
u'تَلِفَ آلةٌ':Predicate, #1: 1	أَتْلَفَ الْأَكْثَرَ
u'تَلِفَ ألف':Subject, #2: 2	أَتْلَفَ آلَةَ
u'تَلِفَ ألْفٌ':Subject, #1: 1	تَلِفَ أَلْفُ
u'تَلِفَ أَلْفٌ':Subject, #1: 1	تَلِفَ أَلْفُ
u'تَلَفٌ إِناءٌ':Added, #1: 1	تَلِفَ أَلْفُ
u'تَلَفٌ إِنْسانٌ':Added, #1: 1	تَلَفِ الْإِنَاءِ
u'تَلِفَ بَعْضٌ':Predicate, #1: 1	تَلَفُ الْإِنْسَانِ
u'تَلِفَ بَعْضٌ':Predicate, #2: 2	أَتْلَفَ الْبَعْضَ
u'تَلِفَ بَعْضٌ':Subject, #3: 3	أَتْلَفَ بَعْضَ
u'تَلِفَ بَعْضٌ':Subject, #13: 13	تَلِفَ بَعْضُهُ
u'تَلِفَ بَعْضٌ':Subject, #24: 24	تَلِفَ بَعْضُ
u'تَلَفٌ بَعْضٌ':Added, #2: 2	تَلِفَ الْبَعْضُ
u'تَلَفٌ بَعْضٌ':Added, #1: 1	تَلَفَ بَعْضِ
u'تَلَفٌ بَعْضٌ':Added, #1: 1	تَلَفُ بَعْضِ
u'تَلَفٌ بَعْضٌ':Added, #2: 2	تَلَفِ بَعْضِ
u'تَلَفٌ بَعْضٌ':Added, #2: 2	تَلَفُ بَعْضِهِ
u'تَلِفَ بَعيرٌ':Subject, #3: 3	تَلَفِ الْبَعْضِ
u'تَلِفَ بَقَرٌ':Predicate, #2: 2	تَلِفَ بَعِيرٌ
u'تَلِفَ بيض':Predicate, #1: 1	أَتْلَفَ بَقَرَةً
u'تَلِفَ بيض':Subject, #5: 5	أَتْلَفَ بَيْضَ
u'تَلِفَ تَرَدُّدٌ':Subject, #1: 1	تَلِفَ بَيْضُ
u'تَلَفٌ تَرِكَةٌ':Added, #1: 1	تَلِفَ تَرَدُّدٌ
u'تَلَفٌ تَلَف':Added, #1: 1	تَلَفُ تَرِكَةِ
u'تَلِفَ ثَلاثَةٌ':Subject, #1: 1	تَلَفُ التَّلَفِ
u'تَلِفَ ثِمارٌ':Predicate, #1: 1	تَلِفَ ثَلَاثَةٌ
u'تَلَفٌ ثَمَرَةٌ':Added, #1: 1	أَتْلَفَ الثِّمَارَ
u'تَلِفَ ثَمَنٌ':Predicate, #1: 1	تَلَفِ الثَّمَرَةِ
u'تَلِفَ ثَمَنٌ':Subject, #1: 1	تَلِفَ الثَّمَنَ
u'تَلَفٌ ثَمَنٌ':Added, #3: 3	تَلِفَ الثَّمَنُ
u'تَلَفٌ ثَمَنٌ':Added, #1: 1	تَلَفَ الثَّمَنِ
u'تَلِفَ ثَوْبٌ':Predicate, #3: 3	تَلَفِ الثَّمَنِ
u'تَلِفَ ثَوْبٌ':Subject, #1: 1	أَتْلَفَ الثَّوْبَ
u'تَلِفَ ثَوْبٌ':Subject, #1: 1	تَلِفَ ثَوْبٌ
u'تَلَفٌ ثِيابٌ':Added, #8: 8	تَلِفَ الثَّوْبُ
u'تَلِفَ جِرَابٌ':Predicate, #1: 1	تَلَفِ الثِّيَابِ
u'تَلِفَ جُزْءٌ':Predicate, #1: 1	أَتْلَفَ الْجِرَابَ
u'تَلِفَ جُزْءٌ':Subject, #1: 1	أَتْلَفَ الْجُزْءَ
u'تَلِفَ جلد':Subject, #1: 1	تَلِفَ جُزْءُ
u'تَلِفَ جِلْدٌ':Subject, #1: 1	تَلِفَ الْجِلْدُ
u'تَلِفَ جَمْرٌ':Predicate, #1: 1	تَلِفَ الْجِلْدُ
u'تَلِفَ حالٌ':Predicate, #1: 1	أَتْلَفَ الْجَمْرَ
u'تَلِفَ حَقٌّ':Predicate, #3: 3	تَلِفَ حَالَ
u'تَلَفٌ حُلِيٌّ':Added, #3: 3	أَتْلَفَ حَقَّ
u'تَلَفٌ حَمْلٌ':Added, #1: 1	تَلَفِ الْحُلِيِّ
u'تَلِفَ خَمْرٌ':Predicate, #1: 1	تَلَفِ الْحَمْلِ
u'تَلِفَ خَمْرٌ':Predicate, #1: 1	أَتْلَفَ الْخَمْرَ
u'تَلِفَ خَمْلٌ':Predicate, #1: 1	أَتْلَفَ خَمْرَ
u'تَلِفَ خِنْزِيرٌ':Predicate, #1: 1	أَتْلَفَ خَمْلَ
u'تَلِفَ خَيْلٌ':Predicate, #2: 2	أَتْلَفَ خِنْزِيرَ
u'تَلِفَ دَابَّةٌ':Predicate, #1: 1	أَتْلَفَ الْخَيْلَ
u'تَلَفٌ دَابَّةٌ':Added, #1: 1	أَتْلَفَ الدَّابَّةَ
u'تَلِفَ دونٌ':Predicate, #2: 2	تَلَفَ الدَّابَّةِ
u'تَلِفَ دِيكٌ':Predicate, #1: 1	تَلِفَ دُونَ
u'تَلِفَ دِينارٌ':Subject, #1: 1	أَتْلَفَ دِيكَ
u'تَلَفٌ دِينارٌ':Added, #1: 1	تَلِفَ الدِّينَارُ
u'تَلِفَ رُبْعٌ':Predicate, #1: 1	تَلَفُ الدِّينَارَيْنِ
u'تَلِفَ رَدٌّ':Predicate, #1: 1	أَتْلَفَ رُبْعَ
u'تَلِفَ رَغيفٌ':Subject, #2: 2	تَلِفَ رَدَّ
u'تَلِفَ رِقٌّ':Subject, #2: 2	تَلِفَ الرَّغِيفُ
u'تَلِفَ رَقيقٌ':Subject, #1: 1	تَلِفَ الرِّقُّ
u'تَلِفَ رَقيق':Subject, #1: 1	تَلِفَ رَقِيقُهُ
u'تَلَفٌ رُكَّابٌ':Added, #1: 1	تَلِفَ رَقِيقُهُ
u'تَلِفَ رَهْنٌ':Predicate, #1: 1	تَلَفُ الرُّكَّابِ
u'تَلِفَ رَهْنٌ':Subject, #4: 4	أَتْلَفَ الرَّهْنَ
u'تَلِفَ زادٌ':Subject, #1: 1	تَلِفَ الرَّهْنُ
u'تَلِفَ زَرْعٌ':Subject, #1: 1	تَلِفَ زَادُهُ
u'تَلَفٌ زَرْعٌ':Added, #1: 1	تَلِفَ الزَّرْعُ
u'تَلِفَ سقط':Predicate, #2: 2	تَلَفِ الزَّرْعِ
u'تَلِفَ سَقَطٌ':Predicate, #1: 1	تَلِفَ سَقَطَ
u'تَلِفَ سَقْفٌ':Subject, #1: 1	تَلِفَ سَقَطَ
u'تَلَفٌ سُقُوطٌ':Added, #1: 1	تَلِفَ سَقْفُ
u'تَلَفٌ سِلاَحٌ':Added, #1: 1	تَلَفُ السُّقُوطِ
u'تَلَفٌ سِلَعٌ':Added, #1: 1	تَلَفِ سِلَاحِهِ
u'تَلَفٌ سِلْعَةٌ':Added, #1: 1	تَلَفِ السِّلَعِ
u'تَلَفٌ سِلْعَةٌ':Added, #1: 1	تَلَفَ السِّلْعَةِ
u'تَلَفٌ سَلِيمٌ':Added, #1: 1	تَلَفِ السِّلْعَةِ
u'تَلَفٌ سَلِيمٌ':Added, #2: 2	تَلَفِ السَّلِيمِ
u'تَلِفَ شَاةٌ':Predicate, #4: 4	تَلَفِ السَّلِيمَيْنِ
u'تَلَفٌ شَاةٌ':Added, #2: 2	أَتْلَفَ الشَّاةَ
u'تَلَفٌ شَاةٌ':Added, #1: 1	تَلَفَ الشَّاةِ
u'تَلِفَ شرب':Predicate, #1: 1	تَلَفَ شَاةٍ
u'تَلِفَ شِرْبٌ':Predicate, #4: 4	أَتْلَفَ شِرْبَ
u'تَلِفَ شَيْءٌ':Predicate, #4: 4	أَتْلَفَ شِرْبَ
u'تَلِفَ شَيْءٌ':Subject, #1: 1	أَتْلَفَ شَيْءَ
u'تَلَفٌ شَيْءٌ':Added, #5: 5	تَلِفَ شَيْءٌ
u'تَلَفٌ شَيْءٌ':Added, #1: 1	تَلَفَ شَيْءٍ
u'تَلِفَ صداق':Subject, #1: 1	تَلَفُ شَيْءٍ
u'تَلِفَ صَدَاقٌ':Subject, #1: 1	تَلِفَ الصَّدَاقُ
u'تَلَفٌ صداق':Added, #1: 1	تَلِفَ الصَّدَاقُ
u'تَلَفٌ صَدَاقٌ':Added, #1: 1	تَلَفَ صَدَاقِ
u'تَلَفٌ طَرَفٌ':Added, #1: 1	تَلَفَ صَدَاقِ
u'تَلِفَ طعام':Predicate, #1: 1	تَلَفِ طَرَفٍ
u'تَلِفَ طَعَامٌ':Predicate, #1: 1	أَتْلَفَ الطَّعَامَ
u'تَلِفَ طعام':Subject, #1: 1	أَتْلَفَ الطَّعَامَ
u'تَلِفَ طَعَامٌ':Subject, #2: 2	تَلِفَ الطَّعَامُ
u'تَلَفَّظَ أَسيرٌ':Subject, #2: 2	تَلِفَ الطَّعَامُ
u'تَلَفَّظَ بَائِعٌ':Subject, #1: 1	تَلَفَّظَ الْأَسِيرُ
u'تَلَفُّظٌ بَائِعٌ':Added, #2: 2	تَلَفَّظَ الْبَائِعُ
u'تَلَفَّظَ حالَةٌ':Predicate, #1: 1	تَلَفُّظُ الْبَائِعِ
u'تَلَفُّظٌ زَوْجَةٌ':Added, #1: 1	تَلَفَّظَ حَالَةَ
u'تَلَفَّظَ وَاقِفٌ':Subject, #1: 1	تَلَفُّظُ الزَّوْجَةِ
u'تَلِفَ عَبْدٌ':Predicate, #1: 1	تَلَفَّظَ الْوَاقِفُ
u'تَلِفَ عَبْدٌ':Subject, #1: 1	أَتْلَفَ عَبْدَ
u'تَلِفَ عِشْرُون':Predicate, #5: 5	تَلِفَ الْعَبْدُ
u'تَلِفَ عُضْوٌ':Subject, #2: 2	تَلِفَ عِشْرُونَ
u'تَلَفٌ عُضْوٌ':Added, #1: 1	تَلِفَ الْعُضْوُ
u'تَلَفٌ عُضْوٌ':Added, #1: 1	تَلَفِ الْعُضْوِ
u'تَلَفٌ عُضْوٌ':Added, #1: 1	تَلَفُ عُضْوٍ
u'تَلِفَ عند':Predicate, #4: 4	تَلَفِ عُضْوٍ
u'تَلِفَ عِوَضٌ':Subject, #8: 8	تَلِفَ عِنْدَ
u'تَلَفٌ عين':Added, #1: 1	تَلِفَ الْعِوَضُ
u'تَلَفٌ عَيْنٌ':Added, #2: 2	تَلَفِ الْعَيْنِ
u'تَلَفٌ عَيْن':Added, #2: 2	تَلَفِ الْعَيْنِ
u'تَلِفَ غَائِبٌ':Subject, #2: 2	تَلَفِ الْعَيْنِ
u'تَلَفٌ غَائِبٌ':Added, #1: 1	تَلِفَ الْغَائِبُ
u'تَلَفٌ غَائِبٌ':Added, #1: 1	تَلَفُ الْغَائِبِ
u'تَلِفَ غِذَاءٌ':Predicate, #1: 1	تَلَفِ الْغَائِبِ
u'تَلَفٌ غَلَّةٌ':Added, #1: 1	أَتْلَفَ غِذَاءَ
u'تَلِفَ غير':Predicate, #1: 1	تَلَفَ الْغَلَّةِ
u'تَلِفَ غَيْرٌ':Predicate, #2: 2	أَتْلَفَ غَيْرَ
u'تَلِفَ غير':Subject, #2: 2	أَتْلَفَ غَيْرَ
u'تَلِفَ غَيْرٌ':Subject, #1: 1	تَلِفَ غَيْرُهُ
u'تَلِفَ فِرَاخٌ':Subject, #1: 1	تَلِفَ غَيْرُهُ
u'تَلَفٌ قَائِمٌ':Added, #1: 1	تَلِفَ فِرَاخُهُ
u'تَلَفٌ قَائِمَةٌ':Added, #1: 1	تَلَفِ قَائِمَةٍ
u'تَلِفَ قَدْرٌ':Predicate, #1: 1	تَلَفِ قَائِمَةٍ
u'تَلِفَ قصاص':Predicate, #2: 2	أَتْلَفَ الْقَدْرَ
u'تَلِفَ قِصَاصٌ':Predicate, #1: 1	أَتْلَفَ الْقِصَاصَ
u'تَلِفَ كَامِلٌ':Predicate, #1: 1	أَتْلَفَ الْقِصَاصَ
u'تَلِفَ كَسْبٌ':Predicate, #1: 1	أَتْلَفَ الْكَامِلَ
u'تَلِفَ لبن':Subject, #1: 1	أَتْلَفَ كَسْبَ
u'تَلِفَ لبن':Subject, #2: 2	تَلِفَ اللَّبَنُ
u'تَلِفَ لَبَنٌ':Subject, #2: 2	تَلِفَ اللَّبِنُ
u'تَلِفَ لَبِنٌ':Subject, #2: 2	تَلِفَ اللَّبَنُ
u'تَلِفَ لَحْمٌ':Predicate, #2: 2	تَلِفَ اللَّبِنُ
u'تَلِفَ مَاءٌ':Predicate, #4: 4	أَتْلَفَ لَحْمَ
u'تَلِفَ مَاءٌ':Subject, #1: 1	أَتْلَفَ الْمَاءَ
u'تَلِفَ مَالٌ':Predicate, #1: 1	تَلِفَ مَاءٌ
u'تَلِفَ مَالٌ':Predicate, #24: 24	أَتْلَفَ مَالَ
u'تَلِفَ مَالٌ':Subject, #3: 3	أَتْلَفَ الْمَالَ
u'تَلِفَ مَالٌ':Subject, #2: 2	تَلِفَ مَالٌ
u'تَلِفَ مَالٌ':Subject, #30: 30	تَلِفَ الْمَالُ
u'تَلِفَ مَالٌ':Subject, #3: 3	تَلِفَ مَالُ
u'تَلَفٌ مَالٌ':Added, #3: 3	تَلِفَ مَالُهُ
u'تَلَفٌ مَالٌ':Added, #1: 1	تَلَفُ مَالِهِ
u'تَلَفٌ مَالٌ':Added, #2: 2	تَلَفُ الْمَالِ
u'تَلَفٌ مَالٌ':Added, #2: 2	تَلَفَ مَالٍ
u'تَلَفٌ مَالٌ':Added, #2: 2	تَلَفِ مَالٍ
u'تَلَفٌ مَالٌ':Added, #4: 4	تَلَفَ مَالِهِ
u'تَلَفٌ مَالٌ':Added, #4: 4	تَلَفِ مَالِهِ
u'تَلِفَ مَالِيٌّ':Predicate, #6: 6	تَلَفِ الْمَالِ
u'تَلَفٌ مَالِيٌّ':Added, #1: 1	أَتْلَفَ الْمَالِيَّةَ
u'تَلَفٌ مَائِعٌ':Added, #1: 1	تَلَفِ مَالِيَّةِ
u'تَلِفَ مَبِيعٌ':Predicate, #1: 1	تَلَفِ الْمَائِعِ
u'تَلِفَ مَبِيعٌ':Subject, #8: 8	أَتْلَفَ الْمَبِيعَ
u'تَلَفٌ مَبِيعٌ':Added, #25: 25	تَلِفَ الْمَبِيعُ
u'تَلَفٌ مَبِيعٌ':Added, #12: 12	تَلَفِ الْمَبِيعِ
u'تَلِفَ مَتَاعٌ':Subject, #2: 2	تَلَفُ الْمَبِيعِ
u'تَلِفَ مَتَاعٌ':Subject, #1: 1	تَلِفَ الْمَتَاعُ
u'تَلِفَ مَتْرُوكٌ':Predicate, #1: 1	تَلِفَ مَتَاعُهُ
u'تَلَفٌ مُثَمَّنٌ':Added, #1: 1	أَتْلَفَ مَتْرُوكَ
u'تَلِفَ مَجْرُوحٌ':Subject, #3: 3	تَلَفِ الْمُثَمَّنِ
u'تَلِفَ مَحْمُولٌ':Subject, #1: 1	تَلِفَ الْمَجْرُوحُ
u'تَلَفٌ مَحْمُولٌ':Added, #2: 2	تَلِفَ الْمَحْمُولُ
u'تَلِفَ مَدْفُوعٌ':Subject, #1: 1	تَلَفِ الْمَحْمُولِ
u'تَلَفٌ مَدْفُوعٌ':Added, #2: 2	تَلِفَ الْمَدْفُوعُ
u'تَلِفَ مَدْيُونٌ':Predicate, #1: 1	تَلَفِ الْمَدْفُوعِ
u'تَلِفَ مَرْهُونٌ':Predicate, #1: 1	أَتْلَفَ الْمَدْيُونَ
u'تَلِفَ مَرْهُونٌ':Subject, #2: 2	أَتْلَفَ الْمَرْهُونَ
u'تَلَفٌ مَرْهُونٌ':Added, #2: 2	تَلِفَ الْمَرْهُونُ
u'تَلَفٌ مَرْهُونٌ':Added, #1: 1	تَلَفُ الْمَرْهُونِ
u'تَلِفَ مَسْجِدٌ':Subject, #2: 2	تَلَفَ الْمَرْهُونِ
u'تَلِفَ مَعَازِفُ':Predicate, #1: 1	تَلِفَ الْمَسْجِدُ
u'تَلِفَ مُعَجَّلٌ':Subject, #1: 1	أَتْلَفَ الْمَعَازِفَ
u'تَلِفَ مَعْقُودٌ':Subject, #2: 2	تَلِفَ الْمُعَجَّلُ
u'تَلِفَ مُعَيَّنٌ':Subject, #1: 1	تَلِفَ الْمَعْقُودُ
u'تَلِفَ مَغْصُوب':Subject, #1: 1	تَلِفَ الْمُعَيَّنُ
u'تَلَفٌ مَغْصُوب':Added, #4: 4	تَلِفَ الْمَغْصُوبُ
u'تَلَفٌ مَغْصُوب':Added, #1: 1	تَلَفَ الْمَغْصُوبِ
u'تَلَفٌ مُقَابِلٌ':Added, #3: 3	تَلَفِ الْمَغْصُوبِ
u'تَلِفَ مَقْبُوضٌ':Subject, #1: 1	تَلَفِ مُقَابِلِهِ
u'تَلَفٌ مَقْبُوضٌ':Added, #3: 3	تَلِفَ الْمَقْبُوضُ
u'تَلِفَ مَكْسُورٌ':Subject, #1: 1	تَلَفِ الْمَقْبُوضِ
u'تَلِفَ مِلْكٌ':Predicate, #1: 1	تَلِفَ الْمَكْسُورُ
u'تَلِفَ مَنَافِعُ':Predicate, #5: 5	أَتْلَفَ مِلْكَ
u'تَلِفَ مَنْفَعَةٌ':Predicate, #1: 1	أَتْلَفَ مَنَافِعَ
u'تَلَفٌ مُهْجَةٌ':Added, #1: 1	أَتْلَفَ مَنْفَعَةَ
u'تَلِفَ مَهْرٌ':Subject, #1: 1	تَلَفِ مُهْجَتِهِ
u'تَلَفٌ مَهْرٌ':Added, #1: 1	تَلِفَ الْمَهْرُ
u'تَلِفَ مَوْجُودٌ':Subject, #1: 1	تَلَفِ الْمَهْرِ
u'تَلِفَ مَوْقُوذ':Predicate, #1: 1	تَلِفَ الْمَوْجُودُ
u'تَلَفٌ مَوْلُودٌ':Added, #1: 1	أَتْلَفَ مَوْقُوذَةَ
u'تَلِفَ مَوْهُوبٌ':Subject, #1: 1	تَلَفِ الْمَوْلُودِ
u'تَلَفٌ نَاسٌ':Added, #1: 1	تَلِفَ الْمَوْهُوبُ
u'تَلِفَ نصاب':Predicate, #1: 1	تَلَفَ النَّاسِ
u'تَلِفَ نِصَابٌ':Predicate, #1: 1	أَتْلَفَ نِصَابَ
u'تَلِفَ نصاب':Subject, #1: 1	أَتْلَفَ نِصَابَ
u'تَلِفَ نِصَابٌ':Subject, #9: 9	تَلِفَ النِّصَابُ
u'تَلِفَ نِصْفٌ':Predicate, #9: 9	تَلِفَ النِّصَابُ
u'تَلِفَ نِصْفٌ':Predicate, #1: 1	أَتْلَفَ النِّصْفَ
u'تَلِفَ نِصْفٌ':Subject, #6: 6	أَتْلَفَ نِصْفَ
u'تَلِفَ نَصِيبٌ':Subject, #1: 1	تَلِفَ نِصْفُ
u'تَلِفَ نَفْسٌ':Predicate, #1: 1	تَلِفَ نَصِيبُ
u'تَلَفٌ نَفْسٌ':Added, #2: 2	أَتْلَفَ نَفْسَ
u'تَلَفٌ نَفْسٌ':Added, #1: 1	تَلَفِ نَفْسٍ
u'تَلَفٌ نَفْسٌ':Added, #1: 1	تَلَفُ نَفْسِهِ
u'تَلَفٌ نَفْسٌ':Added, #2: 2	تَلَفَ النَّفْسِ
u'تَلَفٌ نَفْسٌ':Added, #2: 2	تَلَفُ نَفْسٍ
u'تَلَفٌ نَفْسٌ':Added, #2: 2	تَلَفَ نَفْسِهِ
u'تَلَفٌ نَفْسٌ':Added, #2: 2	تَلَفِ نَفْسِهِ
u'تَلَفٌ نَفْسٌ':Added, #3: 3	تَلَفِ النَّفْسِ
u'تَلَفٌ نَفْسٌ':Added, #3: 3	تَلَفَ نَفْسٍ
u'تَلَفٌ نَفَقَةٌ':Added, #5: 5	تَلَفُ النَّفْسِ
u'تَلِفَ نَقْدٌ':Subject, #1: 1	تَلَفَ نَفَقَةِ
u'تَلِفَ نَقْد':Subject, #1: 1	تَلِفَ نَقْدٌ
u'تَلَفٌ نَقْضٌ':Added, #1: 1	تَلِفَ نَقْدٌ
u'تَلَفٌ هِبَةٌ':Added, #1: 1	تَلَفَ النَّقْضِ
u'تَلِفَ وَاقِعٌ':Subject, #1: 1	تَلَفَ الْهِبَةِ
u'تَلِفَ وَتَرٌ':Subject, #1: 1	تَلِفَ الْوَاقِعُ
u'تَلِفَ وَجَبٌ':Predicate, #1: 1	تَلِفَ الْوَتَرُ
u'تَلِفَ وَدِيعٌ':Predicate, #1: 1	تَلِفَ وَجَبَ
u'تَلِفَ وَدِيعٌ':Predicate, #1: 1	أَتْلَفَ وَدِيعَةَ
u'تَلَفٌ وَدِيعٌ':Added, #3: 3	أَتْلَفَ الْوَدِيعَةَ
u'تَلِفَ وَدِيعَةٌ':Predicate, #2: 2	تَلَفَ الْوَدِيعَةِ
u'تَلِفَ وَدِيعَةٌ':Predicate, #1: 1	أَتْلَفَ وَدِيعَةَ
u'تَلَفٌ وَدِيعَةٌ':Added, #3: 3	أَتْلَفَ الْوَدِيعَةَ
u'تَلِفَ وَقْفٌ':Predicate, #2: 2	تَلَفَ الْوَدِيعَةِ
u'تَلِفَ ولد':Predicate, #1: 1	أَتْلَفَ الْوَقْفَ
u'تَلِفَ وَلَدٌ':Predicate, #2: 2	أَتْلَفَ وَلَدَ
u'تَلِفَ ولد':Subject, #2: 2	أَتْلَفَ وَلَدَ
u'تَلِفَ وَلَدٌ':Subject, #1: 1	تَلِفَ الْوَلَدُ
u'تَلِفَ ولد':Subject, #1: 1	تَلِفَ الْوَلَدُ
u'تَلِفَ وَلَدٌ':Subject, #1: 1	تَلِفَ وَلَدُ
u'تَلَقُّطٌ رُخَصٌ':Added, #1: 1	تَلِفَ وَلَدُ
u'تَلَقِّي أُمَّةٌ':Added, #2: 2	تَلَقُّطِ الرُّخَصِ
u'تَلَقِّي أُمَّةٌ':Added, #1: 1	تَلَقِّيَ الْأُمَّةِ
u'تَلَقِّي أُمُورٌ':Added, #6: 6	تَلَقِّي الْأُمَّةِ
u'تَلَقِّي أوامر':Added, #1: 1	تَلَقِّي الْأُمُورِ
u'تَلَقِّي أَوامِرُ':Added, #1: 1	تَلَقِّي أَوَامِرِهِ
u'تَلَقِّي أئِمَّةٌ':Added, #1: 1	تَلَقِّي أَوَامِرِهِ
u'تَلَقِّي أئِمَّةٌ':Added, #1: 1	تَلَقِّي الْأَئِمَّةِ
u'تَلَقِّي بُطونٌ':Added, #1: 1	تَلَقِّي أَئِمَّةِ
u'تَلَقَّى جَزَّارٌ':Subject, #1: 1	تَلَقِّي الْبُطُونِ
u'تَلَقِّي جَلْبٌ':Added, #1: 1	تَلَقَّى الْجَزَّارُ
u'تَلَقِّي حَصْرٌ':Added, #2: 2	تَلَقِّي الْجَلْبِ
u'تَلَقِّي حُكْمٌ':Added, #1: 1	تَلَقِّي الْحَصْرِ
u'تَلَقَّى سِلْعَةٌ':Predicate, #1: 1	تَلَقِّي الْحُكْمِ
u'تَلَقَّى فلان':Predicate, #1: 1	تَلَقَّى السِّلْعَةَ
u'تَلَقَّى قِصَّةٌ':Predicate, #2: 2	تَلَقَّى جَعْفَرَ
u'تَلَقِّي لَوَاحِظُ':Added, #1: 1	تَلَقَّى الْقِصَّةَ
u'تَلَقِّي مَفْهُومٌ':Added, #1: 1	تَلَقِّي اللَّوَاحِظِ
u'تَلَقِّي مَكْرُوهٌ':Added, #1: 1	تَلَقِّي الْمَفْهُومِ
u'تَلَقَّى مِلْكٌ':Predicate, #1: 1	تَلَقِّي الْمَكْرُوهِ
u'تَلَقِّي مِلْكٌ':Added, #5: 5	تَلَقَّى الْمِلْكَ
u'تَلَقِّي مِلْكٌ':Added, #5: 5	تَلَقِّيَ الْمِلْكِ
u'تَلَقَّى وَقْفٌ':Predicate, #6: 6	تَلَقِّي الْمِلْكِ
u'تَلَقِّي وَقْفٌ':Added, #2: 2	تَلَقَّى الْوَقْفَ
u'تَلَقِّي يَدٌ':Added, #1: 1	تَلَقِّيَ الْوَقْفِ
u'تَلَوُّثٌ بدن':Added, #1: 1	تَلَقِّي الْيَدِ
u'تَلَوُّثٌ بَدَنٌ':Added, #1: 1	تَلَوُّثِ بَدَنِهِ
u'تَلَوُّثٌ مَسْجِدٌ':Added, #1: 1	تَلَوُّثِ بَدَنِهِ
u'تَلَوَّنَ وَجْهٌ':Subject, #1: 1	تَلَوُّثَ مَسْجِدٍ
u'تَلَى زِيادَةٌ':Subject, #2: 2	تَلَوَّنَ وَجْهُهُ
u'تَلِيَ مَعَارِفُ':Predicate, #1: 1	تَلَى زِيَادَةٌ
u'تَلْيِينٌ طَبْعٌ':Added, #1: 1	تَلِيَ الْمَعَارِفَ
u'تَلْيِينٌ عَيْشٌ':Added, #1: 1	تَلْيِينُ الطَّبْعِ
u'تَلْيِينٌ كَلاَمٌ':Added, #1: 1	تَلْيِينَ الْعَيْشِ
u'تَلْيِينٌ مَفَاصِلُ':Added, #1: 1	تَلْيِينِ كَلَامِهِ
u'تَلْيِينٌ مَفَاصِلُ':Added, #1: 1	تَلْيِينِ مَفَاصِلِهِ
u'تَمَّ إِثْبَاتٌ':Subject, #2: 2	تَلْيِينُ مَفَاصِلِهِ
u'تَمَاثَلَ عَدَدٌ':Subject, #1: 1	تَمَّ إثْبَاتُ
u'تَمَاثَلَ عَلِيلٌ':Subject, #1: 1	تَمَاثَلَ عَدَدُ
u'تَمَّ أَجْرٌ':Subject, #1: 1	تَمَاثَلَ الْعَلِيلُ
u'تَمَّ أَجَلٌ':Subject, #2: 2	تَمَّ أَجْرُهُ
u'تَمَّ أَجَلٌ':Subject, #1: 1	تَمَّ أَجَلُ
u'تَمَّ أَجَلٌ':Subject, #1: 1	تَمَّ أَجَلُهُ
u'تَمَّ إِحْرَازٌ':Subject, #5: 5	تَمَّ الْأَجَلُ
u'تَمَّ إِحْرَازٌ':Subject, #1: 1	تَمَّ إحْرَازُهُ
u'تَمَّ إِحْرَامٌ':Subject, #2: 2	تَمَّ الْإِحْرَازُ
u'تَمَّ إِحْلاَلٌ':Subject, #1: 1	تَمَّ الْإِحْرَامُ
u'تَمَادَى خِلاَفٌ':Subject, #1: 1	تَمَّ إحْلَالُهُ
u'تَمَادَى قتل':Predicate, #2: 2	تَمَادَى الْخِلَافُ
u'تَمَادَى وَلَهٌ':Subject, #1: 1	تَمَادَى قُتِلَ
u'تَمَّ أَذَانٌ':Predicate, #1: 1	تَمَادَى وَلَهُ
u'تَمَارَى اِبْنٌ':Subject, #1: 1	أَتَمَّ الْأَذَانَ
u'تَمَّ إِزَالَةٌ':Subject, #1: 1	تَمَارَى ابْنُ
u'تَمَّ اِسْتِفْرَاغٌ':Subject, #1: 1	تَمَّ إزَالَةُ
u'تَمَّ إِسْلامٌ':Subject, #1: 1	تَمَّ اسْتِفْرَاغُ
u'تَمَّ اِشْتِراطٌ':Subject, #1: 1	تَمَّ إِسْلاَمُهُ
u'تَمَّ إِطْلاقٌ':Predicate, #1: 1	تَمَّ اشْتِرَاطُ
u'تَمَّ اِعْتِدالٌ':Subject, #1: 1	تَمَّ إطْلَاقَ
u'تَمَّ أَعْمَالٌ':Predicate, #1: 1	تَمَّ اعْتِدَالُهُ
u'تَمَّ أَفْعَالٌ':Predicate, #2: 2	أَتَمَّ أَعْمَالَ
u'تَمَّ إقْرَارٌ':Subject, #1: 1	أَتَمَّ أَفْعَالَ
u'تَمَّ إقْرَارٌ':Subject, #3: 3	تَمَّ إقْرَارُهُ
u'تَمَّ إمَامٌ':Subject, #4: 4	تَمَّ الْإِقْرَارُ
u'تَمَّ أَمْرٌ':Subject, #5: 5	أَتَمَّ الْإِمَامُ
u'تَمَّ أَمْرٌ':Subject, #1: 1	تَمَّ أَمْرٌ
u'تَمَّ أَمْرٌ':Subject, #1: 1	تَمَّ أَمْرُهُ
u'تَمَّ اِنْتِفاعٌ':Subject, #4: 4	تَمَّ الْأَمْرُ
u'تَمَّ أَوَّلُ':Subject, #1: 1	تَمَّ انْتِفَاعُ
u'تَمَّ إِيجَابٌ':Subject, #2: 2	تَمَّ الْأَوَّلُ
u'تَمَّ باقِي':Predicate, #1: 1	تَمَّ الْإِيجَابُ
u'تَمَّ بَقِيَّةٌ':Predicate, #1: 1	أَتَمَّ الْبَاقِيَ
u'تَمَّ بِنَاءٌ':Subject, #3: 3	أَتَمَّ بَقِيَّةَ
u'تَمَّ بَيْعٌ':Subject, #1: 1	تَمَّ الْبِنَاءُ
u'تَمَّ تَبَرُّعٌ':Subject, #62: 62	تَمَّ الْبَيْعُ
u'تَمَّ تَرَاوِيحُ':Predicate, #1: 1	تَمَّ تَبَرُّعُهُ
u'تَمَّ تَشَهُّدٌ':Predicate, #1: 1	أَتَمَّ التَّرَاوِيحَ
u'تَمَّ تَشَهُّدٌ':Subject, #2: 2	أَتَمَّ التَّشَهُّدَ
u'تَمَّ تَصْوِيرٌ':Subject, #2: 2	تَمَّ تَشَهُّدُهُ
u'تَمَّ تَعْبِيرٌ':Subject, #1: 1	تَمَّ تَصْوِيرُهُ
u'تَمَتُّعٌ حاضِرٌ':Added, #1: 1	تَمَّ التَّعْبِيرُ
u'تَمَّ تَعْدِيلٌ':Subject, #1: 1	تَمَتُّعَ حَاضِرِ
u'تَمَتَّعَ رَجُلٌ':Subject, #1: 1	تَمَّ التَّعْدِيلُ
u'تَمَتَّعَ رَسُولٌ':Subject, #1: 1	تَمَتَّعَ الرَّجُلُ
u'تَمَّ تَعْرِيفٌ':Subject, #8: 8	تَمَتَّعَ رَسُولُ
u'تَمَتُّعٌ عَبْدٌ':Added, #1: 1	تَمَّ تَعْرِيفُهُ
u'تَمَتَّعَ غير':Subject, #1: 1	تَمَتُّعِ الْعَبْدِ
u'تَمَتَّعَ غَيْرٌ':Subject, #1: 1	تَمَتَّعَ غَيْرُ
u'تَمَتَّعَ فلان':Subject, #1: 1	تَمَتَّعَ غَيْرُ
u'تَمَتُّعٌ فلان':Added, #1: 1	تَمَتَّعَ الْمَكِّيُّ
u'تَمَّ تَعْلِيقٌ':Subject, #3: 3	تَمَتُّعُ الْمَكِّيِّ
u'تَمَتُّعٌ مُبَاحٌ':Added, #1: 1	تَمَّ التَّعْلِيقُ
u'تَمَتَّعَ مَكِّيّ':Subject, #1: 1	تَمَتُّعٍ مُبَاحٍ
u'تَمَتُّعٌ مَكِّيّ':Added, #1: 1	تَمَتَّعَ الْمَكِّيُّ
u'تَمَتَّعَ نَبِيٌّ':Subject, #3: 3	تَمَتُّعُ الْمَكِّيِّ
u'تَمَتَّعَ نهار':Subject, #3: 3	تَمَتَّعَ النَّبِيُّ
u'تَمَتَّعَ نَهَارٌ':Subject, #1: 1	تَمَتَّعَ النَّهَارُ
u'تَمَتَّعَ وَلَهٌ':Subject, #1: 1	تَمَتَّعَ النَّهَارُ
u'تَمَّ تَقْليدٌ':Subject, #1: 1	تَمَتَّعَ وَلَهُ
u'تَمَّ تَقْليد':Subject, #1: 1	تَمَّ تَقْلِيدُ
u'تَمَّ تَكْبيرٌ':Predicate, #1: 1	تَمَّ تَقْلِيدُ
u'تَمَّ تَمٌّ':Predicate, #2: 2	أَتَمَّ التَّكْبِيرَ
u'تَمْتَمَةٌ لِسَانٌ':Added, #1: 1	أَتَمَّ تَمَّ
u'تَمَثَّلَ أَحْنَف':Subject, #1: 1	تَمْتَمَةُ اللِّسَانِ
u'تَمَّ ثَمَرٌ':Subject, #1: 1	تَمَثَّلَ الْأَحْنَفُ
u'تَمَّ جُزْءٌ':Subject, #1: 1	تَمَّ الثَّمَرُ
u'تَمَّ جماع':Predicate, #3: 3	تَمَّ الْجُزْءُ
u'تَمَّ جِمَاعٌ':Predicate, #1: 1	أَتَمَّ الْجِمَاعَ
u'تَمَّ جمعة':Predicate, #1: 1	أَتَمَّ الْجِمَاعَ
u'تَمَّ جُمُعَةٌ':Predicate, #3: 3	أَتَمَّ الْجُمُعَةَ
u'تَمَّ حَجٌّ':Predicate, #3: 3	أَتَمَّ الْجُمُعَةَ
u'تَمَّ حَجٌّ':Subject, #2: 2	أَتَمَّ الْحَجَّ
u'تَمَّ حَجٌّ':Subject, #2: 2	تَمَّ حَجُّ
u'تَمَّ حُجَّةٌ':Subject, #46: 46	تَمَّ حَجُّهُ
u'تَمَّ حَدٌّ':Subject, #1: 1	تَمَّ الْحُجَّةُ
u'تَمَّ حُضورٌ':Subject, #2: 2	تَمَّ الْحَدُّ
u'تَمَّ حُضُورٌ':Subject, #2: 2	تَمَّ حُضُورُهُ
u'تَمَّ حُكْمٌ':Subject, #2: 2	تَمَّ حُضُورُهُ
u'تَمَّ حُكْمٌ':Subject, #1: 1	تَمَّ الْحُكْمُ
u'تَمَّ حول':Subject, #1: 1	تَمَّ حُكْمٌ
u'تَمَّ حَوْلٌ':Subject, #11: 11	تَمَّ حَوْلُهُ
u'تَمَّ حول':Subject, #11: 11	تَمَّ حَوْلُهُ
u'تَمَّ حَوْلٌ':Subject, #31: 31	تَمَّ حَوْلُ
u'تَمَّ حول':Subject, #31: 31	تَمَّ حَوْلُ
u'تَمَّ حَوْلٌ':Subject, #73: 73	تَمَّ الْحَوْلُ
u'تَمَّ خُرُوجٌ':Subject, #73: 73	تَمَّ الْحَوْلُ
u'تَمَّ خُلْعٌ':Subject, #4: 4	تَمَّ خُرُوجُهُ
u'تَمَّ خلق':Subject, #6: 6	تَمَّ الْخُلْعُ
u'تَمَّ خَلْقٌ':Subject, #12: 12	تَمَّ خَلْقُهُ
u'تَمَّ خَمْسٌ':Predicate, #12: 12	تَمَّ خَلْقُهُ
u'تَمَّ خَمْسٌ':Predicate, #1: 1	أَتَمَّ خَمْسَ
u'تَمَّ دفع':Predicate, #1: 1	تَمَّ خَمْسَ
u'تَمَّ دفن':Subject, #1: 1	تَمَّ دَفَعَ
u'تَمَّ دَفْنٌ':Subject, #1: 1	تَمَّ دَفْنُهُ
u'تَمَّ دَلٌّ':Predicate, #1: 1	تَمَّ دَفْنُهُ
u'تَمَّ دَليلٌ':Predicate, #1: 1	تَمَّ دَلَّ
u'تَمَّ دَليلٌ':Subject, #1: 1	أَتَمَّ الدَّلِيلَ
u'تَمَّ ذَكاةٌ':Predicate, #2: 2	تَمَّ الدَّلِيلُ
u'تَمَّ ذَكاةٌ':Predicate, #1: 1	تَمَّ الذَّكَاةَ
u'تَمَّ رابع':Predicate, #2: 2	أَتَمَّ الذَّكَاةَ
u'تَمَّ رَابِعٌ':Predicate, #1: 1	أَتَمَّ الرَّابِعَةَ
u'تَمْرٌ أَرْبَعُ':Added, #1: 1	أَتَمَّ الرَّابِعَةَ
u'تَمْرٌ بَائِعٌ':Added, #1: 1	تَمْرَ أَرْبَعِ
u'تَمْرٌ بَلَدٌ':Added, #1: 1	تَمْرُ الْبَائِعِ
u'تَمْرٌ جمع':Added, #3: 3	تَمْرِ الْبَلَدِ
u'تَمْرٌ جمع':Added, #1: 1	تَمْرُ الْجَمْعِ
u'تَمْرٌ جَمْعٌ':Added, #1: 1	تَمْرِ الْجَمْعِ
u'تَمْرٌ جَمْعٌ':Added, #1: 1	تَمْرُ الْجَمْعِ
u'تَمْرٌ جمع':Added, #1: 1	تَمْرِ الْجَمْعِ
u'تَمْرٌ جَمْعٌ':Added, #2: 2	تَمْرَ الْجَمْعِ
u'تَمْرٌ حائِطٌ':Added, #2: 2	تَمْرَ الْجَمْعِ
u'تَمْرٌ حجاز':Added, #1: 1	تَمْرِ الْحَائِطِ
u'تَمَرُّدٌ جِنٌّ':Added, #1: 1	تَمْرِ الْحِجَازِ
u'تَمْرٌ دَقَل':Added, #1: 1	تَمَرُّدِ الْجِنِّ
u'تَمْرٌ صدقة':Added, #2: 2	تَمْرٍ دَقَلٍ
u'تَمْرٌ صَدَقَةٌ':Added, #1: 1	تَمْرُ الصَّدَقَةِ
u'تَمْرٌ صدقة':Added, #1: 1	تَمْرُ الصَّدَقَةِ
u'تَمْرٌ صَدَقَةٌ':Added, #9: 9	تَمْرِ الصَّدَقَةِ
u'تَمْرٌ طَيِّبٌ':Added, #9: 9	تَمْرِ الصَّدَقَةِ
u'تَمْرٌ عَجْوَةٌ':Added, #1: 1	تَمْرٍ طَيِّبٍ
u'تَمْرٌ عَجْوَةٌ':Added, #1: 1	تَمْرَ عَجْوَةٍ
u'تَمْرٌ عَجْوَةٌ':Added, #1: 1	تَمْرِ عَجْوَةٍ
u'تَمْرٌ فَارِسِيٌّ':Added, #3: 3	تَمْرٍ عَجْوَةٍ
u'تَمَّ رَفْعٌ':Subject, #3: 3	تَمْرٍ فَارِسِيٍّ
u'تَمَّ رُكْنٌ':Subject, #1: 1	تَمَّ رَفْعُ
u'تَمَّ رُكْن':Subject, #1: 1	تَمَّ الرُّكْنُ
u'تَمَّ رُكوعٌ':Predicate, #1: 1	تَمَّ الرُّكْنُ
u'تَمَّ رُكوعٌ':Subject, #1: 1	أَتَمَّ الرُّكُوعَ
u'تَمْرٌ مَدِينٌ':Added, #5: 5	تَمَّ رُكُوعُهُ
u'تَمْرٌ مَدِينَةٌ':Added, #4: 4	تَمْرِ الْمَدِينَةِ
u'تَمَّ رَمَضانُ':Subject, #4: 4	تَمْرِ الْمَدِينَةِ
u'تَمْرٌ مُعَلَّقٌ':Added, #1: 1	تَمَّ رَمَضَانُ
u'تَمْرٌ مَعْلُومٌ':Added, #2: 2	تَمْرٍ مُعَلَّقٍ
u'تَمْرٌ مَكِيلٌ':Added, #1: 1	تَمْرٍ مَعْلُومٍ
u'تَمَّ رَمْيٌ':Predicate, #1: 1	تَمْرٍ مَكِيلٍ
u'تَمَّ رَمْيٌ':Subject, #1: 1	أَتَمَّ الرَّمْيَ
u'تَمْرٌ نَبِيٌّ':Added, #1: 1	تَمَّ رَمْيُهُ
u'تَمْرٌ نَخْلٌ':Added, #1: 1	تَمْرُ النَّبِيِّ
u'تَمْرٌ نخلة':Added, #1: 1	تَمْرِ النَّخْلِ
u'تَمْرٌ نخلة':Added, #1: 1	تَمْرُ نَخْلَةٍ
u'تَمْرٌ نَخْلَةٌ':Added, #1: 1	تَمْرِ نَخْلَةٍ
u'تَمْرٌ نَخْلَةٌ':Added, #1: 1	تَمْرُ نَخْلَةٍ
u'تَمْرٌ نَخِيلٌ':Added, #1: 1	تَمْرِ نَخْلَةٍ
u'تَمَّ رَهْنٌ':Subject, #1: 1	تَمْرِ النَّخِيلِ
u'تَمَزَّقَ مُلْكٌ':Subject, #3: 3	تَمَّ الرَّهْنُ
u'تَمَّ زَمَنٌ':Subject, #1: 1	تَمَزَّقَ مُلْكُهُ
u'تَمَّ زَوْجٌ':Subject, #1: 1	تَمَّ زَمَنُ
u'تَمَّ سَبَبٌ':Subject, #1: 1	أَتَمَّ الزَّوْجُ
u'تَمَّ سُجُودٌ':Subject, #1: 1	تَمَّ السَّبَبُ
u'تَمَّ سُجُودٌ':Subject, #1: 1	تَمَّ السُّجُودُ
u'تَمَّ سُقُوطٌ':Subject, #5: 5	تَمَّ سُجُودُهُ
u'تَمَسُّكٌ إِسْعادٌ':Added, #1: 1	تَمَّ سُقُوطُ
u'تَمَسَّكَ أَصْحَابٌ':Subject, #1: 1	تَمَسُّكِ الْإِسْعَادِ
u'تَمَسُّكٌ إمَامٌ':Added, #1: 1	تَمَسَّكَ الْأَصْحَابُ
u'تَمَسَّكَ أهْلٌ':Subject, #1: 1	تَمَسُّكُ الْإِمَامِ
u'تَمَسَّكَ بَعْضٌ':Subject, #1: 1	تَمَسَّكَ أَهْلُ
u'تَمَسَّكَ حَنَفِيَّةٌ':Subject, #3: 3	تَمَسَّكَ بَعْضُ
u'تَمَسُّكٌ حَنَفِيَّةٌ':Added, #1: 1	تَمَسَّكَ الْحَنَفِيَّةُ
u'تَمَسَّكَ خَصْمٌ':Subject, #1: 1	تَمَسُّكُ الْحَنَفِيَّةِ
u'تَمَّ سكر':Subject, #1: 1	تَمَسَّكَ الْخَصْمُ
u'تَمَّ سُكْرٌ':Subject, #2: 2	تَمَّ سُكْرُهُ
u'تَمَسَّكَ شافِعِيّ':Subject, #2: 2	تَمَّ سُكْرُهُ
u'تَمَسَّكَ فلان':Subject, #1: 1	تَمَسَّكَ الشَّافِعِيُّ
u'تَمَسَّكَ مُتَمَسِّك':Subject, #1: 1	تَمَسَّكَ الشَّافِعِيُّ
u'تَمَسَّكَ مُخْبِرٌ':Subject, #1: 1	تَمَسَّكَ مُتَمَسِّكٌ
u'تَمَسَّكَ نَاسٌ':Subject, #1: 1	تَمَسَّكَ الْمُخْبِرُ
u'تَمَسُّكٌ نَاسٌ':Added, #1: 1	تَمَسَّكَ النَّاسُ
u'تَمَسْكَنَ رَجُلٌ':Subject, #1: 1	تَمَسُّكِ النَّاسِ
u'تَمَّ سُورَةٌ':Predicate, #1: 1	تَمَسْكَنَ الرَّجُلُ
u'تَمَّ شَرْطٌ':Subject, #1: 1	أَتَمَّ السُّورَةَ
u'تَمَّ شَرْطٌ':Subject, #3: 3	تَمَّ شَرْطُ
u'تَمَّ شَفْعٌ':Predicate, #4: 4	تَمَّ الشَّرْطُ
u'تَمَّ شَهْرٌ':Subject, #1: 1	أَتَمَّ الشَّفْعَ
u'تَمْشِيَةٌ دَابَّةٌ':Added, #4: 4	تَمَّ الشَّهْرُ
u'تَمْشِيَةٌ قول':Added, #1: 1	تَمْشِيَةُ الدَّابَّةِ
u'تَمْشِيَةٌ قَوْلٌ':Added, #1: 1	تَمْشِيَةَ الْقَوْلِ
u'تَمْشِيَةٌ مثل':Added, #1: 1	تَمْشِيَةَ الْقَوْلِ
u'تَمْشِيَةٌ مِثْلٌ':Added, #1: 1	تَمْشِيَةِ مِثْلِ
u'تَمْشِيَةٌ مَذْهَبٌ':Added, #1: 1	تَمْشِيَةِ مِثْلِ
u'تَمَّ صَرْفٌ':Subject, #1: 1	تَمْشِيَةِ مَذْهَبِ
u'تَمَّ صَرْف':Subject, #1: 1	تَمَّ الصَّرْفُ
u'تَمَّ صَلاَةٌ':Predicate, #1: 1	تَمَّ الصَّرْفُ
u'تَمَّ صَلاَةٌ':Predicate, #14: 14	أَتَمَّ الصَّلَاةَ
u'تَمَّ صَلاَةٌ':Predicate, #3: 3	أَتَمَّ صَلَاةَ
u'تَمَّ صلح':Subject, #7: 7	أَتَمَّ الصَّلاَةَ
u'تَمَّ صُلْحٌ':Subject, #8: 8	تَمَّ الصُّلْحُ
u'تَمَّ صَوْمٌ':Predicate, #8: 8	تَمَّ الصُّلْحُ
u'تَمَضْمَضَ صَائِمٌ':Subject, #1: 1	أَتَمَّ الصَّوْمَ
u'تَمَّ طَبْعٌ':Subject, #1: 1	تَمَضْمَضَ الصَّائِمُ
u'تَمَّ طَهَارَةٌ':Predicate, #1: 1	تَمَّ طَبْعُ
u'تَمَّ طواف':Predicate, #1: 1	أَتَمَّ الطَّهَارَةَ
u'تَمَّ طَوَافٌ':Predicate, #1: 1	أَتَمَّ الطَّوَافَ
u'تَمَّ طواف':Subject, #1: 1	أَتَمَّ الطَّوَافَ
u'تَمَّ طَوَافٌ':Subject, #3: 3	تَمَّ طَوَافُهُ
u'تَمَّ ظِلٌّ':Subject, #3: 3	تَمَّ طَوَافُهُ
u'تَمَّ عَبْدٌ':Subject, #1: 1	تَمَّ ظِلُّ
u'تَمَّ عتق':Subject, #1: 1	أَتَمَّ الْعَبْدُ
u'تَمَّ عِتْقٌ':Subject, #1: 1	تَمَّ عِتْقُهُ
u'تَمَّ عَدٌّ':Subject, #1: 1	تَمَّ عِتْقُهُ
u'تَمَّ عَدَدٌ':Subject, #1: 1	تَمَّ الْعَدُّ
u'تَمَّ عَدَدٌ':Subject, #1: 1	تَمَّ عَدَدُ
u'تَمَّ عَصْرٌ':Predicate, #7: 7	تَمَّ الْعَدَدُ
u'تَمَّ عَقْدٌ':Predicate, #1: 1	أَتَمَّ الْعَصْرَ
u'تَمَّ عَقْدٌ':Subject, #1: 1	تَمَّ الْعَقْدَ
u'تَمَّ عَقْدٌ':Subject, #1: 1	تَمَّ عَقْدُهُ
u'تَمَّ عَقْلٌ':Subject, #26: 26	تَمَّ الْعَقْدُ
u'تَمَّ عَقْلٌ':Subject, #1: 1	تَمَّ عَقْلُ
u'تَمَّ عَمَلٌ':Subject, #2: 2	تَمَّ الْعَقْلُ
u'تَمَّ عَمَلٌ':Subject, #1: 1	تَمَّ عَمَلُهُ
u'تَمَّ عند':Predicate, #6: 6	تَمَّ الْعَمَلُ
u'تَمَّ غُلاَمٌ':Subject, #2: 2	تَمَّ عِنْدَ
u'تَمَّ فراغ':Subject, #1: 1	تَمَّ الْغُلَامُ
u'تَمَّ فَرَاغٌ':Subject, #2: 2	تَمَّ فَرَاغُهُ
u'تَمَّ فَرْضٌ':Subject, #2: 2	تَمَّ فَرَاغُهُ
u'تَمَّ فَسْخٌ':Subject, #4: 4	تَمَّ فَرْضُهُ
u'تَمَّ فِعْلٌ':Predicate, #5: 5	تَمَّ الْفَسْخُ
u'تَمَّ فِعْلٌ':Subject, #3: 3	أَتَمَّ الْفِعْلَ
u'تَمَّ فلان':Subject, #1: 1	تَمَّ فِعْلُهُ
u'تَمَّ قَالٌ':Predicate, #1: 1	أَتَمَّ عُثْمَانُ
u'تَمَّ قَالٌ':Predicate, #1: 1	أَتَمَّ قَالَ
u'تَمَّ قَدْرٌ':Subject, #2: 2	تَمَّ قَالَ
u'تَمَّ قِرَاءةٌ':Predicate, #1: 1	تَمَّ قَدْرُ
u'تَمَّ قَضَاءٌ':Predicate, #2: 2	أَتَمَّ الْقِرَاءَةَ
u'تَمَّ قَضَاءٌ':Subject, #1: 1	أَتَمَّ قَضَاءَ
u'تَمَّ كِتَابٌ':Subject, #1: 1	تَمَّ الْقَضَاءُ
u'تَمَّ كِتَابٌ':Subject, #1: 1	تَمَّ كِتَابُ
u'تَمَّ كِرَاءٌ':Subject, #3: 3	تَمَّ الْكِتَابُ
u'تَمَّ كَلاَمٌ':Subject, #1: 1	تَمَّ الْكِرَاءُ
u'تَمَكُّنٌ أَدَاءٌ':Added, #3: 3	تَمَّ الْكَلَامُ
u'تَمَكَّنَ إِسْلامٌ':Subject, #1: 1	تَمَكُّنَ الْأَدَاءِ
u'تَمَكَّنَ إقامَةٌ':Subject, #2: 2	تَمَكَّنَ الْإِسْلَامُ
u'تَمَكُّنٌ إقامَةٌ':Added, #1: 1	تَمَكَّنَ إقَامَةُ
u'تَمَكُّنٌ إقامَةٌ':Added, #1: 1	تَمَكُّنُ إقَامَةِ
u'تَمَكَّنَ إمَامٌ':Subject, #1: 1	تَمَكُّنِ إقَامَةِ
u'تَمَكَّنَ تَغَيُّرٌ':Subject, #1: 1	تَمَكَّنَ الْإِمَامُ
u'تَمَكُّنٌ تُهْمَةٌ':Added, #2: 2	تَمَكَّنَ التَّغَيُّرُ
u'تَمَكَّنَ حُبٌّ':Subject, #1: 1	تَمَكُّنِ تُهْمَةِ
u'تَمَكَّنَ خُبْثٌ':Subject, #1: 1	تَمَكَّنَ حُبُّ
u'تَمَكَّنَ خطر':Subject, #3: 3	تَمَكَّنَ الْخُبْثُ
u'تَمَكَّنَ خَطَرٌ':Subject, #1: 1	تَمَكَّنَ الْخَطَرُ
u'تَمَكَّنَ خَلَلٌ':Subject, #1: 1	تَمَكَّنَ الْخَطَرُ
u'تَمَكُّنٌ خَلَلٌ':Added, #2: 2	تَمَكَّنَ الْخَلَلُ
u'تَمَكُّنٌ خَلَلٌ':Added, #1: 1	تَمَكُّنَ الْخَلَلِ
u'تَمَكُّنٌ خَلَلٌ':Added, #1: 1	تَمَكُّنِ خَلَلٍ
u'تَمَكَّنَ دُخُولٌ':Subject, #3: 3	تَمَكُّنُ الْخَلَلِ
u'تَمَكَّنَ دفع':Predicate, #2: 2	تَمَكَّنَ دُخُولُ
u'تَمَكَّنَ دَفْعٌ':Predicate, #1: 1	تَمَكَّنَ دَفْعَ
u'تَمَكَّنَ دِينٌ':Subject, #1: 1	تَمَكَّنَ دَفْعَ
u'تَمَكَّنَ رَاهِنٌ':Subject, #1: 1	تَمَكَّنَ دِينُ
u'تَمَكُّنٌ رَبُّ':Added, #1: 1	تَمَكَّنَ الرَّاهِنُ
u'تَمَكُّنٌ رِجَالٌ':Added, #1: 1	تَمَكُّنِ رَبِّ
u'تَمَكُّنٌ زَوْجٌ':Added, #1: 1	تَمَكُّنَ الرِّجَالِ
u'تَمَكُّنٌ سَهْوٌ':Added, #1: 1	تَمَكُّنُ الزَّوْجِ
u'تَمَكُّنٌ سَهْوٌ':Added, #1: 1	تَمَكُّنَ السَّهْوِ
u'تَمَكُّنٌ شُبْهَةٌ':Added, #1: 1	تَمَكُّنِ السَّهْوِ
u'تَمَكُّنٌ شُبْهَةٌ':Added, #1: 1	تَمَكُّنِ الشُّبْهَةِ
u'تَمَكَّنَ شَيْطَانٌ':Subject, #1: 1	تَمَكُّنُ شُبْهَةٍ
u'تَمَكُّنٌ صُورَةٌ':Added, #1: 1	تَمَكَّنَ الشَّيْطَانُ
u'تَمَكَّنَ ظالِمٌ':Subject, #1: 1	تَمَكُّنِ الصُّورَةِ
u'تَمَكَّنَ عَامِلٌ':Subject, #1: 1	تَمَكَّنَ الظَّالِمُ
u'تَمَكُّنٌ علم':Added, #1: 1	تَمَكَّنَ الْعَامِلُ
u'تَمَكُّنٌ عِلْمٌ':Added, #1: 1	تَمَكُّنِ الْعِلْمِ
u'تَمَكَّنَ فساد':Subject, #1: 1	تَمَكُّنِ الْعِلْمِ
u'تَمَكَّنَ فَسَادٌ':Subject, #1: 1	تَمَكَّنَ الْفَسَادُ
u'تَمَكُّنٌ فساد':Added, #1: 1	تَمَكَّنَ الْفَسَادُ
u'تَمَكُّنٌ فَسَادٌ':Added, #1: 1	تَمَكُّنِ الْفَسَادِ
u'تَمَكَّنَ فِقْهٌ':Subject, #1: 1	تَمَكُّنِ الْفَسَادِ
u'تَمَكُّنٌ قَاتِلٌ':Added, #1: 1	تَمَكَّنَ الْفِقْهُ
u'تَمَكَّنَ قَالٌ':Predicate, #1: 1	تَمَكُّنَ الْقَاتِلِ
u'تَمَكُّنٌ قدرة':Added, #1: 1	تَمَكَّنَ قَالَ
u'تَمَكُّنٌ قُدْرَةٌ':Added, #1: 1	تَمَكُّنِ قُدْرَةٍ
u'تَمَكُّنٌ كَافِرٌ':Added, #1: 1	تَمَكُّنِ قُدْرَةٍ
u'تَمَكَّنَ مَالِكٌ':Subject, #1: 1	تَمَكُّنَ الْكَافِرِ
u'تَمَكُّنٌ مَالِكٌ':Added, #2: 2	تَمَكَّنَ الْمَالِكُ
u'تَمَكُّنٌ مَالِكٌ':Added, #1: 1	تَمَكُّنَ الْمَالِكِ
u'تَمَكُّنٌ مُحْتَاجٌ':Added, #2: 2	تَمَكُّنِ الْمَالِكِ
u'تَمَكَّنَ مُرْتَهِنٌ':Subject, #1: 1	تَمَكُّنِ الْمُحْتَاجِ
u'تَمَكُّنٌ مُسَافِرٌ':Added, #1: 1	تَمَكَّنَ الْمُرْتَهِنُ
u'تَمَكَّنَ مُسْتَأْجِرٌ':Subject, #1: 1	تَمَكُّنِ الْمُسَافِرِ
u'تَمَكَّنَ مُسْلِمٌ':Subject, #2: 2	تَمَكَّنَ الْمُسْتَأْجِرُ
u'تَمَكُّنٌ مَشْهُودٌ':Added, #1: 1	تَمَكَّنَ الْمُسْلِمُ
u'تَمَكُّنٌ مُعِير':Added, #1: 1	تَمَكُّنِ الْمَشْهُودِ
u'تَمَكُّنٌ مُكَلَّفٌ':Added, #1: 1	تَمَكُّنُ الْمُعِيرِ
u'تَمَكُّنٌ مُنَازَعٌ':Added, #1: 1	تَمَكُّنِ الْمُكَلَّفِ
u'تَمَكُّنٌ مُنَازَعَةٌ':Added, #1: 1	تَمَكُّنَ الْمُنَازَعَةِ
u'تَمَكَّنَ مُوَكَّلٌ':Subject, #1: 1	تَمَكُّنَ الْمُنَازَعَةِ
u'تَمَكَّنَ نَقْصٌ':Subject, #1: 1	تَمَكَّنَ الْمُوَكَّلُ
u'تَمَكَّنَ نَقْصٌ':Subject, #1: 1	تَمَكَّنَ النَّقْصُ
u'تَمَكَّنَ نُقْصَانٌ':Subject, #1: 1	تَمَكَّنَ نَقْصٌ
u'تَمَكَّنَ نُقْصَانٌ':Subject, #4: 4	تَمَكَّنَ النُّقْصَانُ
u'تَمَكُّنٌ نُقْصَانٌ':Added, #5: 5	تَمَكَّنَ نُقْصَانٌ
u'تَمَكُّنٌ نُقْصَانٌ':Added, #1: 1	تَمَكُّنَ نُقْصَانٍ
u'تَمَكَّنَ وَارِثٌ':Subject, #1: 1	تَمَكُّنِ نُقْصَانِ
u'تَمَكُّنٌ وَارِثٌ':Added, #1: 1	تَمَكَّنَ الْوَارِثُ
u'تَمَكُّنٌ وَقْتٌ':Added, #1: 1	تَمَكُّنِ الْوَارِثِ
u'تَمَكَّنَ وَلِيٌّ':Subject, #1: 1	تَمَكُّنِ الْوَقْتِ
u'تَمَكُّنٌ وَلِيٌّ':Added, #1: 1	تَمَكَّنَ الْوَلِيُّ
u'تَمَّ كَوْنٌ':Subject, #1: 1	تَمَكُّنَ الْوَلِيِّ
u'تَمْكِينٌ أَبٌ':Added, #2: 2	تَمَّ كَوْنُ
u'تَمْكِينٌ اِبْنٌ':Added, #2: 2	تَمْكِينُ الْأَبِ
u'تَمْكِينٌ إِحْدَاثٌ':Added, #1: 1	تَمْكِينُ ابْنِهِ
u'تَمْكِينٌ الْمَرْأَةُ':Added, #1: 1	تَمْكِينِ الْإِحْدَاثِ
u'تَمْكِينٌ الْمَرْأَةُ':Added, #1: 1	تَمْكِينُ الْمَرْأَةِ
u'تَمْكِينٌ بَائِعٌ':Added, #1: 1	تَمْكِينِ الْمَرْأَةِ
u'تَمْكِينٌ جَبْهَةٌ':Added, #1: 1	تَمْكِينُ الْبَائِعِ
u'تَمْكِينٌ جَديدٌ':Added, #3: 3	تَمْكِينِ الْجَبْهَةِ
u'تَمْكِينٌ حاضِرٌ':Added, #1: 1	تَمْكِينٍ جَدِيدٍ
u'تَمْكِينٌ حائِضٌ':Added, #1: 1	تَمْكِينِ الْحَاضِرِ
u'تَمْكِينٌ حَلِيلٌ':Added, #1: 1	تَمْكِينُ الْحَائِضِ
u'تَمْكِينٌ خَصْمٌ':Added, #1: 1	تَمْكِين الْحَلِيلِ
u'تَمْكِينٌ زائِغٌ':Added, #1: 1	تَمْكِينُ الْخَصْمِ
u'تَمْكِينٌ زَوْجٌ':Added, #1: 1	تَمْكِينِ زَائِغِ
u'تَمْكِينٌ زَوْجٌ':Added, #1: 1	تَمْكِين الزَّوْجِ
u'تَمْكِينٌ زَوْجٌ':Added, #1: 1	تَمْكِينَ الزَّوْجِ
u'تَمْكِينٌ زَوْجٌ':Added, #1: 1	تَمْكِينُ الزَّوْجِ
u'تَمْكِينٌ شَرِيكٌ':Added, #2: 2	تَمْكِينِ الزَّوْجِ
u'تَمْكِينٌ صَاحِبٌ':Added, #2: 2	تَمْكِينِ الشَّرِيكِ
u'تَمْكِينٌ صَبِيٌّ':Added, #1: 1	تَمْكِينُ صَاحِبِهِ
u'تَمْكِينٌ عَبْدٌ':Added, #1: 1	تَمْكِينُ الصَّبِيِّ
u'تَمْكِينٌ غير':Added, #1: 1	تَمْكِينَ الْعَبْدِ
u'تَمْكِينٌ غَيْرٌ':Added, #1: 1	تَمْكِينُ الْغَيْرِ
u'تَمْكِينٌ غير':Added, #1: 1	تَمْكِينُ الْغَيْرِ
u'تَمْكِينٌ غَيْرٌ':Added, #2: 2	تَمْكِينُ غَيْرِهِ
u'تَمْكِينٌ كَافِرٌ':Added, #2: 2	تَمْكِينُ غَيْرِهِ
u'تَمْكِينٌ كَافِرٌ':Added, #1: 1	تَمْكِينَ الْكَافِرِ
u'تَمْكِينٌ كُفَّارٌ':Added, #1: 1	تَمْكِينِ الْكَافِرِ
u'تَمْكِينٌ كُفَّارٌ':Added, #1: 1	تَمْكِينَ الْكُفَّارِ
u'تَمْكِينٌ مَالٌ':Added, #1: 1	تَمْكِينُ الْكُفَّارِ
u'تَمْكِينٌ مثل':Added, #3: 3	تَمْكِينُ مَالٍ
u'تَمْكِينٌ مِثْلٌ':Added, #1: 1	تَمْكِينُ مِثْلِ
u'تَمْكِينٌ مُحْتَاجٌ':Added, #1: 1	تَمْكِينُ مِثْلِ
u'تَمْكِينٌ مُحْرِمٌ':Added, #1: 1	تَمْكِينِ الْمُحْتَاجِ
u'تَمْكِينٌ مَحْرَمٌ':Added, #1: 1	تَمْكِينُ الْمُحْرِمِ
u'تَمْكِينٌ مُسْلِمٌ':Added, #1: 1	تَمْكِينُ مَحْرَمٍ
u'تَمْكِينٌ مُسْلِمٌ':Added, #1: 1	تَمْكِينُ الْمُسْلِمِ
u'تَمْكِينٌ مُعْتَرِضٌ':Added, #1: 1	تَمْكِينِ الْمُسْلِمِ
u'تَمْكِينٌ مَقْعَدَةٌ':Added, #1: 1	تَمْكِينِ الْمُعْتَرِضِ
u'تَمْكِينٌ نَفْسٌ':Added, #1: 1	تَمْكِينِ الْمَقْعَدَةِ
u'تَمْكِينٌ نَفْسٌ':Added, #1: 1	تَمْكِينُ النَّفْسِ
u'تَمْكِينٌ وَقْتٌ':Added, #1: 1	تَمْكِينِ النَّفْسِ
u'تَمْكِينٌ يَتِيمٌ':Added, #1: 1	تَمْكِينِ الْوَقْتِ
u'تَمَّ لَفْظٌ':Subject, #1: 1	تَمْكِينَ الْيَتِيمِ
u'تَمَلُّكٌ أُجْرَةٌ':Added, #2: 2	تَمَّ لَفْظُ
u'تَمَلُّكٌ أرْضٌ':Added, #1: 1	تَمَلُّكُ الْأُجْرَةِ
u'تَمَلُّكٌ أرْضٌ':Added, #1: 1	تَمَلُّكَ أَرْضِ
u'تَمَلُّكٌ أرْضٌ':Added, #1: 1	تَمَلُّكُ أَرْضِ
u'تَمَلُّكٌ اِسْتِئْنَافٌ':Added, #1: 1	تَمَلُّكِ الْأَرْضِ
u'تَمَلُّكٌ أصل':Added, #1: 1	تَمَلُّكَ اسْتِئْنَافِ
u'تَمَلُّكٌ أًصْلٌ':Added, #1: 1	تَمَلُّكَ الْأَصْلِ
u'تَمَلُّكٌ أعْيانٌ':Added, #1: 1	تَمَلُّكَ الْأَصْلِ
u'تَمَلُّكٌ أَعْيَانٌ':Added, #1: 1	تَمَلُّكَ الْأَعْيَانِ
u'تَمَلُّكٌ الْمَرْءُ':Added, #1: 1	تَمَلُّكَ الْأَعْيَانِ
u'تَمَلُّكٌ إِنْسانٌ':Added, #1: 1	تَمَلُّكِ الْمَرْءِ
u'تَمَلُّكٌ أهْلٌ':Added, #2: 2	تَمَلُّكُ الْإِنْسَانِ
u'تَمَلُّكٌ بَائِعٌ':Added, #1: 1	تَمَلُّكِ أَهْلِ
u'تَمَلُّكٌ بَدَلٌ':Added, #2: 2	تَمَلُّكِ الْبَائِعِ
u'تَمَلُّكٌ بَعْضٌ':Added, #1: 1	تَمَلُّكَ الْبَدَلِ
u'تَمَلُّكٌ بُقْعَةٌ':Added, #1: 1	تَمَلُّك بَعْضِهِ
u'تَمَلُّكٌ تَمْلِيكٌ':Added, #2: 2	تَمَلُّكُ الْبُقْعَةِ
u'تَمَلُّكٌ ثَمَنٌ':Added, #1: 1	تَمَلُّكِ تَمْلِيكِ
u'تَمَلُّكٌ ثَوْبٌ':Added, #1: 1	تَمَلُّكِ الثَّمَنِ
u'تَمَلُّكٌ ثَوْبٌ':Added, #1: 1	تَمَلُّكِ الثَّوْبِ
u'تَمَلُّكٌ جَارِي':Added, #2: 2	تَمَلُّكَ الثَّوْبِ
u'تَمَلُّكٌ جَارِي':Added, #1: 1	تَمَلُّكُ الْجَارِيَةِ
u'تَمَلُّكٌ جَارِي':Added, #1: 1	تَمَلُّكُ جَارِيَتِهِ
u'تَمَلُّكٌ جَارِي':Added, #1: 1	تَمَلُّكِ جَارِيَتِهِ
u'تَمَلُّكٌ جَارِي':Added, #2: 2	تَمَلُّكِ جَارِيَةِ
u'تَمَلُّكٌ جَارِيَةٌ':Added, #3: 3	تَمَلُّكِ الْجَارِيَةِ
u'تَمَلُّكٌ جَارِيَةٌ':Added, #1: 1	تَمَلُّكُ الْجَارِيَةِ
u'تَمَلُّكٌ جَارِيَةٌ':Added, #1: 1	تَمَلُّكُ جَارِيَتِهِ
u'تَمَلُّكٌ جَارِيَةٌ':Added, #1: 1	تَمَلُّكِ جَارِيَتِهِ
u'تَمَلُّكٌ جَارِيَةٌ':Added, #2: 2	تَمَلُّكِ جَارِيَةِ
u'تَمَلُّكٌ جُثَّة':Added, #3: 3	تَمَلُّكِ الْجَارِيَةِ
u'تَمَلُّكٌ جَديدٌ':Added, #1: 1	تَمَلُّكَ الْجُثَّةِ
u'تَمَلُّكٌ خُرُوجٌ':Added, #1: 1	تَمَلُّكٍ جَدِيدٍ
u'تَمَلُّكٌ خَمْرٌ':Added, #1: 1	تَمَلُّكِ خُرُوجِ
u'تَمَلُّكٌ خَمْرٌ':Added, #1: 1	تَمَلُّكَ الْخَمْرِ
u'تَمَلُّكٌ خَمْرٌ':Added, #1: 1	تَمَلُّكُ الْخَمْرِ
u'تَمَلُّكٌ دَارٌ':Added, #1: 1	تَمَلُّكِ الْخَمْرِ
u'تَمَلُّكٌ دَيْنٌ':Added, #1: 1	تَمَلُّكِ الدَّارِ
u'تَمَلُّكٌ دَيْنٌ':Added, #1: 1	تَمَلُّكَ الدَّيْنِ
u'تَمَلُّكٌ رحم':Added, #1: 1	تَمَلُّكُ الدَّيْنِ
u'تَمَلُّكٌ رَحِمٌ':Added, #1: 1	تَمَلُّكُ رَحِمِهِ
u'تَمَلُّكٌ رَقَبَةٌ':Added, #1: 1	تَمَلُّكُ رَحِمِهِ
u'تَمَلَّكَ رَهْنٌ':Predicate, #1: 1	تَمَلُّكِ رَقَبَةِ
u'تَمَلُّكٌ زائِدٌ':Added, #1: 1	تَمَلَّكَ الرَّهْنَ
u'تَمَلُّكٌ سُفْلٌ':Added, #1: 1	تَمَلُّكِ الزَّائِدِ
u'تَمَلُّكٌ سَقْفٌ':Added, #1: 1	تَمَلُّكُ السُّفْلِ
u'تَمَلُّكٌ سَلَبٌ':Added, #1: 1	تَمَلُّكِ السَّقْفِ
u'تَمَلُّكٌ سَهْمٌ':Added, #1: 1	تَمَلُّكِ السَّلَبِ
u'تَمَلُّكٌ شَاةٌ':Added, #1: 1	تَمَلُّكِ السَّهْمِ
u'تَمَلُّكٌ شَطْرٌ':Added, #1: 1	تَمَلُّكِ الشَّاةِ
u'تَمَلُّكٌ شفعة':Added, #1: 1	تَمَلُّكِ شَطْرٍ
u'تَمَلُّكٌ شُفْعَةٌ':Added, #1: 1	تَمَلُّكَ الشُّفْعَةِ
u'تَمَلَّكَ شَفِيعٌ':Subject, #1: 1	تَمَلُّكَ الشُّفْعَةِ
u'تَمَلُّكٌ شَفِيعٌ':Added, #2: 2	تَمَلَّكَ الشَّفِيعُ
u'تَمَلُّكٌ شَيْءٌ':Added, #1: 1	تَمَلُّكِ الشَّفِيعِ
u'تَمَلُّكٌ صِبْغٌ':Added, #1: 1	تَمَلُّكِ الشَّيْءِ
u'تَمَلُّكٌ صَبْغٌ':Added, #1: 1	تَمَلُّكَ الصِّبْغِ
u'تَمَلُّكٌ صدقة':Added, #2: 2	تَمَلُّكُ الصَّبْغِ
u'تَمَلُّكٌ صَدَقَةٌ':Added, #2: 2	تَمَلُّكُ صَدَقَةٍ
u'تَمَلُّكٌ صَيْدٌ':Added, #2: 2	تَمَلُّكُ صَدَقَةٍ
u'تَمَلُّكٌ صَيْدٌ':Added, #1: 1	تَمَلُّكُ الصَّيْدِ
u'تَمَلُّكٌ طعام':Added, #1: 1	تَمَلُّكِ الصَّيْدِ
u'تَمَلُّكٌ طَعَامٌ':Added, #2: 2	تَمَلُّكُ الطَّعَامِ
u'تَمَلَّكَ عَبْدٌ':Predicate, #2: 2	تَمَلُّكُ الطَّعَامِ
u'تَمَلُّكٌ عَبْدٌ':Added, #2: 2	تَمَلَّكَ الْعَبْدَ
u'تَمَلُّكٌ عَصِيرٌ':Added, #1: 1	تَمَلُّكُ الْعَبْدِ
u'تَمَلُّكٌ عَطِيَّةٌ':Added, #1: 1	تَمَلُّكُ الْعَصِيرِ
u'تَمَلَّكَ عَقَارٌ':Predicate, #1: 1	تَمَلُّكُ الْعَطِيَّةِ
u'تَمَلُّكٌ عَقْدٌ':Added, #1: 1	تَمَلَّكَ الْعَقَارَ
u'تَمَلُّكٌ عين':Added, #1: 1	تَمَلُّكِ الْعَقْدِ
u'تَمَلُّكٌ عَيْنٌ':Added, #2: 2	تَمَلُّكُ الْعَيْنِ
u'تَمَلُّكٌ عَيْن':Added, #2: 2	تَمَلُّكُ الْعَيْنِ
u'تَمَلُّكٌ عين':Added, #2: 2	تَمَلُّكُ الْعَيْنِ
u'تَمَلُّكٌ عَيْنٌ':Added, #2: 2	تَمَلُّكِ عَيْنِهِ
u'تَمَلُّكٌ عَيْن':Added, #2: 2	تَمَلُّكِ عَيْنِهِ
u'تَمَلُّكٌ عين':Added, #2: 2	تَمَلُّكِ عَيْنِهِ
u'تَمَلُّكٌ عَيْنٌ':Added, #3: 3	تَمَلُّكِ الْعَيْنِ
u'تَمَلُّكٌ عَيْن':Added, #3: 3	تَمَلُّكِ الْعَيْنِ
u'تَمَلُّكٌ غَاصِبٌ':Added, #3: 3	تَمَلُّكِ الْعَيْنِ
u'تَمَلُّكٌ غير':Added, #1: 1	تَمَلُّكِ الْغَاصِبِ
u'تَمَلُّكٌ غَيْرٌ':Added, #1: 1	تَمَلُّكِ غَيْرِ
u'تَمَلُّكٌ قَرِيبٌ':Added, #1: 1	تَمَلُّكِ غَيْرِ
u'تَمَلُّكٌ قِيمَةٌ':Added, #1: 1	تَمَلُّكُ الْقَرِيبِ
u'تَمَلُّكٌ كُفَّارٌ':Added, #1: 1	تَمَلُّكُ قِيمَةِ
u'تَمَلُّكٌ لقطة':Added, #1: 1	تَمَلُّكِ الْكُفَّارِ
u'تَمَلُّكٌ مَاءٌ':Added, #1: 1	تَمَلُّكُ اللُّقَطَةِ
u'تَمَلُّكٌ مَالٌ':Added, #1: 1	تَمَلُّكِ الْمَاءِ
u'تَمَلُّكٌ مَالٌ':Added, #1: 1	تَمَلُّكَ الْمَالِ
u'تَمَلُّكٌ مَالٌ':Added, #1: 1	تَمَلُّكُ الْمَالِ
u'تَمَلُّكٌ مَالٌ':Added, #2: 2	تَمَلُّكِ الْمَالِ
u'تَمَلُّكٌ مَالٌ':Added, #2: 2	تَمَلُّكَ مَالِ
u'تَمَلُّكٌ مَالٌ':Added, #2: 2	تَمَلُّكُ مَالٍ
u'تَمَلَّكَ مَالِكٌ':Subject, #4: 4	تَمَلُّكِ مَالِ
u'تَمَلُّكٌ مُبَاحٌ':Added, #1: 1	تَمَلَّكَ الْمَالِكُ
u'تَمَلُّكٌ مُبَاحٌ':Added, #1: 1	تَمَلُّكٍ مُبَاحٍ
u'تَمَلُّكٌ مُبَاحٌ':Added, #1: 1	تَمَلُّكِ مُبَاحٍ
u'تَمَلُّكٌ مُبَاحٌ':Added, #2: 2	تَمَلُّكِ الْمُبَاحِ
u'تَمَلُّكٌ مَبِيعٌ':Added, #4: 4	تَمَلُّكِ الْمُبَاحَاتِ
u'تَمَلُّكٌ مُدَبِّرٌ':Added, #1: 1	تَمَلُّكُ الْمَبِيعِ
u'تَمَلُّكٌ مَسْكُونٌ':Added, #1: 1	تَمَلُّكِ الْمُدَبِّرِ
u'تَمَلُّكٌ مَضْمُونٌ':Added, #1: 1	تَمَلُّكِ الْمَسْكُونِ
u'تَمَلُّكٌ مَطْعُوم':Added, #2: 2	تَمَلُّكِ الْمَضْمُونِ
u'تَمَلَّكَ مَغْصُوب':Subject, #1: 1	تَمَلُّكِ الْمَطْعُومِ
u'تَمَلُّكٌ مَنَافِعُ':Added, #1: 1	تَمَلَّكَ الْمَغْصُوبُ
u'تَمَلُّكٌ مَوْقُوفٌ':Added, #1: 1	تَمَلُّكَ مَنَافِعِ
u'تَمَلُّكٌ مُؤْمِنٌ':Added, #1: 1	تَمَلُّكِ الْمَوْقُوفِ
u'تَمَلَّكَ نَصِيبٌ':Predicate, #3: 3	تَمَلُّكِ الْمُؤْمِنَةِ
u'تَمَلُّكٌ نَصِيبٌ':Added, #7: 7	تَمَلَّكَ نَصِيبَ
u'تَمَلُّكٌ وَالِدٌ':Added, #2: 2	تَمَلُّكَ نَصِيبِ
u'تَمَلُّكٌ وُرَّاثٌ':Added, #1: 1	تَمَلُّكُ الْوَالِدِ
u'تَمَلُّكٌ وَقْفٌ':Added, #1: 1	تَمَلُّكَ الْوُرَّاثِ
u'تَمَلُّكٌ ولد':Added, #3: 3	تَمَلُّكِ الْوَقْفِ
u'تَمَلُّكٌ وَلَدٌ':Added, #1: 1	تَمَلُّكِ الْوَلَدِ
u'تَمَلْمُلٌ سَلِيمٌ':Added, #1: 1	تَمَلُّكِ الْوَلَدِ
u'تَمَلَّى رَهْنٌ':Predicate, #1: 1	تَمَلْمُلَ السَّلِيمِ
u'تَمَلَّى عَبْدٌ':Predicate, #1: 1	تَمَلَّكَ الرَّهْنَ
u'تَمَلَّى عَقَارٌ':Predicate, #2: 2	تَمَلَّكَ الْعَبْدَ
u'تَمْلِيكٌ أَجْنَبِيٌّ':Added, #1: 1	تَمَلَّكَ الْعَقَارَ
u'تَمْلِيكٌ أحَدٌ':Added, #1: 1	تَمْلِيكِ الْأَجْنَبِيِّ
u'تَمْلِيكٌ أرْضٌ':Added, #1: 1	تَمْلِيكُ أَحَدٍ
u'تَمْلِيكٌ أعْيانٌ':Added, #1: 1	تَمْلِيكَ أَرْضٍ
u'تَمْلِيكٌ أَعْيَانٌ':Added, #3: 3	تَمْلِيكِ الْأَعْيَانِ
u'تَمْلِيكٌ أَغْنِيَاء':Added, #3: 3	تَمْلِيكِ الْأَعْيَانِ
u'تَمْلِيكٌ أَمْرٌ':Added, #3: 3	تَمْلِيكُ الْأَغْنِيَاءِ
u'تَمْلِيكٌ أَمْرٌ':Added, #1: 1	تَمْلِيكِ الْأَمْرِ
u'تَمْلِيكٌ أَمْوَالٌ':Added, #5: 5	تَمْلِيكُ الْأَمْرِ
u'تَمْلِيكٌ أَمْوَالٌ':Added, #1: 1	تَمْلِيكِ الْأَمْوَالِ
u'تَمْلِيكٌ إِنْسانٌ':Added, #1: 1	تَمْلِيكُ أَمْوَالِ
u'تَمْلِيكٌ أَوْلاَدٌ':Added, #1: 1	تَمْلِيكِ الْإِنْسَانِ
u'تَمْلِيكٌ إيقَاعٌ':Added, #1: 1	تَمْلِيكَ أَوْلَادِهِ
u'تَمْلِيكٌ بَعْضٌ':Added, #1: 1	تَمْلِيكُ الْإِيقَاعِ
u'تَمْلِيكٌ بَعْضٌ':Added, #1: 1	تَمْلِيكُ الْبَعْضِ
u'تَمْلِيكٌ بَعْضٌ':Added, #1: 1	تَمْلِيكَ بَعْضِ
u'تَمْلِيكٌ بُقْعَةٌ':Added, #1: 1	تَمْلِيكُ بَعْضِهِ
u'تَمْلِيكٌ بَهيمٌ':Added, #1: 1	تَمْلِيكُ الْبُقْعَةِ
u'تَمْلِيكٌ بَهيمٌ':Added, #1: 1	تَمْلِيكَ الْبَهِيمَةِ
u'تَمْلِيكٌ بَهِيمَةٌ':Added, #1: 1	تَمْلِيكُ الْبَهِيمَةِ
u'تَمْلِيكٌ بَهِيمَةٌ':Added, #1: 1	تَمْلِيكَ الْبَهِيمَةِ
u'تَمْلِيكٌ تَصَرُّفٌ':Added, #1: 1	تَمْلِيكُ الْبَهِيمَةِ
u'تَمْلِيكٌ تَطْلِيقٌ':Added, #1: 1	تَمْلِيكَ التَّصَرُّفِ
u'تَمْلِيكٌ تَعْلِيقٌ':Added, #2: 2	تَمْلِيكُ التَّطْلِيقِ
u'تَمْلِيكٌ جَارِي':Added, #1: 1	تَمْلِيكُ التَّعْلِيقِ
u'تَمْلِيكٌ جَارِيَةٌ':Added, #1: 1	تَمْلِيكَ الْجَارِيَةِ
u'تَمْلِيكٌ جُزْءٌ':Added, #1: 1	تَمْلِيكَ الْجَارِيَةِ
u'تَمْلِيكٌ حَمْلٌ':Added, #1: 1	تَمْلِيكُ جُزْءٍ
u'تَمْلِيكٌ خَمْرٌ':Added, #1: 1	تَمْلِيكُ الْحَمْلِ
u'تَمْلِيكٌ خَمْرٌ':Added, #2: 2	تَمْلِيكُ الْخَمْرِ
u'تَمْلِيكٌ دَيْنٌ':Added, #8: 8	تَمْلِيكِ الْخَمْرِ
u'تَمْلِيكٌ دَيْنٌ':Added, #16: 16	تَمْلِيكُ الدَّيْنِ
u'تَمْلِيكٌ دَيْنٌ':Added, #2: 2	تَمْلِيكِ الدَّيْنِ
u'تَمْلِيكٌ رِبْحٌ':Added, #8: 8	تَمْلِيكَ الدَّيْنِ
u'تَمْلِيكٌ رُبْعٌ':Added, #1: 1	تَمْلِيكَ الرِّبْحِ
u'تَمْلِيكٌ رَقَبَةٌ':Added, #1: 1	تَمْلِيكُ رُبْعِ
u'تَمْلِيكٌ رَقَبَةٌ':Added, #1: 1	تَمْلِيكَ الرَّقَبَةِ
u'تَمْلِيكٌ رَقَبَةٌ':Added, #1: 1	تَمْلِيكَ رَقَبَةِ
u'تَمْلِيكٌ زائِدٌ':Added, #2: 2	تَمْلِيكِ الرَّقَبَةِ
u'تَمْلِيكٌ زَوْجَةٌ':Added, #1: 1	تَمْلِيكَ الزَّائِدِ
u'تَمْلِيكٌ سَيِّدٌ':Added, #2: 2	تَمْلِيكِ الزَّوْجَةِ
u'تَمْلِيكٌ سَيِّدٌ':Added, #2: 2	تَمْلِيكِ سَيِّدِهِ
u'تَمْلِيكٌ شَرْعِيٌّ':Added, #3: 3	تَمْلِيكِ السَّيِّدِ
u'تَمْلِيكٌ شُمُول':Added, #1: 1	تَمْلِيكٍ شَرْعِيٍّ
u'تَمْلِيكٌ شَيْءٌ':Added, #1: 1	تَمْلِيكُ شُمُولٍ
u'تَمْلِيكٌ شَيْءٌ':Added, #1: 1	تَمْلِيكُ شَيْءٍ
u'تَمْلِيكٌ صَبِيٌّ':Added, #2: 2	تَمْلِيكُ الشَّيْءِ
u'تَمْلِيكٌ صَيْدٌ':Added, #1: 1	تَمْلِيكَ الصَّبِيِّ
u'تَمْلِيكٌ طعام':Added, #1: 1	تَمْلِيكَ الصَّيْدِ
u'تَمْلِيكٌ طعام':Added, #1: 1	تَمْلِيكُ الطَّعَامِ
u'تَمْلِيكٌ طَعَامٌ':Added, #1: 1	تَمْلِيكِ الطَّعَامِ
u'تَمْلِيكٌ طَعَامٌ':Added, #1: 1	تَمْلِيكُ الطَّعَامِ
u'تَمْلِيكٌ طَلاَقٌ':Added, #1: 1	تَمْلِيكِ الطَّعَامِ
u'تَمْلِيكٌ عَبْدٌ':Added, #1: 1	تَمْلِيكَ الطَّلَاقِ
u'تَمْلِيكٌ عَبْدٌ':Added, #1: 1	تَمْلِيكُ الْعَبْدِ
u'تَمْلِيكٌ عَبْدٌ':Added, #2: 2	تَمْلِيكَ الْعَبْدِ
u'تَمْلِيكٌ عين':Added, #3: 3	تَمْلِيكِ الْعَبْدِ
u'تَمْلِيكٌ عَيْنٌ':Added, #10: 10	تَمْلِيكُ الْعَيْنِ
u'تَمْلِيكٌ عَيْن':Added, #10: 10	تَمْلِيكُ الْعَيْنِ
u'تَمْلِيكٌ عين':Added, #10: 10	تَمْلِيكُ الْعَيْنِ
u'تَمْلِيكٌ عَيْنٌ':Added, #1: 1	تَمْلِيكَ عَيْنِ
u'تَمْلِيكٌ عَيْنٌ':Added, #1: 1	تَمْلِيكَ عَيْنٍ
u'تَمْلِيكٌ عَيْن':Added, #1: 1	تَمْلِيكَ عَيْنِ
u'تَمْلِيكٌ عَيْن':Added, #1: 1	تَمْلِيكَ عَيْنٍ
u'تَمْلِيكٌ عين':Added, #1: 1	تَمْلِيكَ عَيْنِ
u'تَمْلِيكٌ عَيْنٌ':Added, #4: 4	تَمْلِيكَ الْعَيْنِ
u'تَمْلِيكٌ عَيْن':Added, #4: 4	تَمْلِيكَ الْعَيْنِ
u'تَمْلِيكٌ عَيْنٌ':Added, #4: 4	تَمْلِيكَ الْعَيْنِ
u'تَمْلِيكٌ عَيْن':Added, #4: 4	تَمْلِيكُ عَيْنٍ
u'تَمْلِيكٌ عين':Added, #4: 4	تَمْلِيكُ عَيْنٍ
u'تَمْلِيكٌ عَيْنٌ':Added, #5: 5	تَمْلِيكِ الْعَيْنِ
u'تَمْلِيكٌ عَيْن':Added, #5: 5	تَمْلِيكِ الْعَيْنِ
u'تَمْلِيكٌ غِلْمَانٌ':Added, #5: 5	تَمْلِيكِ الْعَيْنِ
u'تَمْلِيكٌ غير':Added, #1: 1	تَمْلِيكِ الْغِلْمَانِ
u'تَمْلِيكٌ غَيْرٌ':Added, #1: 1	تَمْلِيكِ غَيْرِهِ
u'تَمْلِيكٌ فِعْلٌ':Added, #1: 1	تَمْلِيكِ غَيْرِهِ
u'تَمْلِيكٌ فِعْلٌ':Added, #1: 1	تَمْلِيكَ فِعْلِ
u'تَمْلِيكٌ فقراء':Added, #2: 2	تَمْلِيكُ الْفِعْلِ
u'تَمْلِيكٌ فَقِيرٌ':Added, #1: 1	تَمْلِيكِ الْفُقَرَاءِ
u'تَمْلِيكٌ قَدْرٌ':Added, #2: 2	تَمْلِيكُ الْفَقِيرِ
u'تَمْلِيكٌ مَالٌ':Added, #1: 1	تَمْلِيكُ قَدْرٍ
u'تَمْلِيكٌ مَالٌ':Added, #12: 12	تَمْلِيكُ الْمَالِ
u'تَمْلِيكٌ مَالٌ':Added, #1: 1	تَمْلِيكَ الْمَالِ
u'تَمْلِيكٌ مَالٌ':Added, #1: 1	تَمْلِيكَ مَالٍ
u'تَمْلِيكٌ مَالٌ':Added, #1: 1	تَمْلِيكِ مَالٍ
u'تَمْلِيكٌ مَالٌ':Added, #3: 3	تَمْلِيكُ مَالٍ
u'تَمْلِيكٌ مَالٌ':Added, #4: 4	تَمْلِيكِ الْمَالِ
u'تَمْلِيكٌ مَالِكٌ':Added, #4: 4	تَمْلِيكِ مَالِهِ
u'تَمْلِيكٌ مَجْهُولٌ':Added, #1: 1	تَمْلِيكِ الْمَالِكِ
u'تَمْلِيكٌ مُحْتَاجٌ':Added, #1: 1	تَمْلِيكَ الْمَجْهُولِ
u'تَمْلِيكٌ مَدٌّ':Added, #1: 1	تَمْلِيكُ مُحْتَاجٍ
u'تَمْلِيكٌ مَدْيُونٌ':Added, #1: 1	تَمْلِيك الْمَدَّيْنِ
u'تَمْلِيكٌ مساكين':Added, #1: 1	تَمْلِيكِ الْمَدْيُونِ
u'تَمْلِيكٌ مُسْلِمٌ':Added, #1: 1	تَمْلِيكِ الْمَسَاكِينِ
u'تَمْلِيكٌ مُطَالَبٌ':Added, #1: 1	تَمْلِيكُ الْمُسْلِمِ
u'تَمْلِيكٌ مُطَالَبٌ':Added, #1: 1	تَمْلِيكَ الْمُطَالَبَةِ
u'تَمْلِيكٌ مُطَالَبٌ':Added, #1: 1	تَمْلِيكِ الْمُطَالَبَةِ
u'تَمْلِيكٌ مُطَالَبَةٌ':Added, #4: 4	تَمْلِيكُ الْمُطَالَبَةِ
u'تَمْلِيكٌ مُطَالَبَةٌ':Added, #1: 1	تَمْلِيكَ الْمُطَالَبَةِ
u'تَمْلِيكٌ مُطَالَبَةٌ':Added, #1: 1	تَمْلِيكِ الْمُطَالَبَةِ
u'تَمْلِيكٌ مَعْدُومٌ':Added, #4: 4	تَمْلِيكُ الْمُطَالَبَةِ
u'تَمْلِيكٌ مَعْدُومٌ':Added, #1: 1	تَمْلِيكَ الْمَعْدُومِ
u'تَمْلِيكٌ مَكْسُورٌ':Added, #3: 3	تَمْلِيكُ الْمَعْدُومِ
u'تَمْلِيكٌ مُلُوكٌ':Added, #1: 1	تَمْلِيكُ الْمَكْسُورِ
u'تَمْلِيكٌ مَنَافِعُ':Added, #1: 1	تَمْلِيكَ الْمُلُوكِ
u'تَمْلِيكٌ مَنَافِعُ':Added, #13: 13	تَمْلِيكِ الْمَنَافِعِ
u'تَمْلِيكٌ مَنَافِعُ':Added, #26: 26	تَمْلِيكُ الْمَنَافِعِ
u'تَمْلِيكٌ مَنْفَعَةٌ':Added, #4: 4	تَمْلِيكَ الْمَنَافِعِ
u'تَمْلِيكٌ مَنْفَعَةٌ':Added, #10: 10	تَمْلِيكُ مَنْفَعَةٍ
u'تَمْلِيكٌ مَنْفَعَةٌ':Added, #1: 1	تَمْلِيكَ مَنْفَعَةٍ
u'تَمْلِيكٌ مَنْفَعَةٌ':Added, #6: 6	تَمْلِيكِ الْمَنْفَعَةِ
u'تَمْلِيكٌ مُؤَجِّرٌ':Added, #8: 8	تَمْلِيكُ الْمَنْفَعَةِ
u'تَمْلِيكٌ مُؤَجِّرٌ':Added, #1: 1	تَمْلِيكَ الْمُؤَجِّرِ
u'تَمْلِيكٌ مَوْقُوفٌ':Added, #1: 1	تَمْلِيكِ الْمُؤَجِّرِ
u'تَمْلِيكٌ نَصِيبٌ':Added, #1: 1	تَمْلِيكِ الْمَوْقُوفِ
u'تَمْلِيكٌ نَصِيبٌ':Added, #1: 1	تَمْلِيكُ نَصِيبِهِ
u'تَمْلِيكٌ نَفْسٌ':Added, #1: 1	تَمْلِيكِ نَصِيبِهِ
u'تَمْلِيكٌ نَفْسٌ':Added, #1: 1	تَمْلِيكُ النَّفْسِ
u'تَمْلِيكٌ هِبَةٌ':Added, #1: 1	تَمْلِيكِ النَّفْسِ
u'تَمْلِيكٌ واحد':Added, #1: 1	تَمْلِيكِ الْهِبَةِ
u'تَمْلِيكٌ وَاحِدٌ':Added, #1: 1	تَمْلِيكُ وَاحِدَةٍ
u'تَمْلِيكٌ وِلاَيَةٌ':Added, #1: 1	تَمْلِيكُ وَاحِدَةٍ
u'تَمَلَّى نَصِيبٌ':Predicate, #2: 2	تَمْلِيكُ وِلَايَةِ
u'تَمَّمَ أَجِيرٌ':Subject, #7: 7	تَمَلَّكَ نَصِيبَ
u'تَمَّ مُتَمَتِّعٌ':Subject, #1: 1	تَمَّمَ أَجِيرُ
u'تَمَّمَ ثَمَنٌ':Predicate, #1: 1	أَتَمَّ الْمُتَمَتِّعُ
u'تَمَّ مراد':Subject, #1: 1	تَمَّمَ الثَّمَنَ
u'تَمَّ مُرَادٌ':Subject, #1: 1	تَمَّ مُرَادُ
u'تَمَّمَ رِسَالَةٌ':Predicate, #1: 1	تَمَّ مُرَادُ
u'تَمَّ مُسَافِرٌ':Subject, #1: 1	تَمَّمَ الرِّسَالَةَ
u'تَمَّ مُسَافِرٌ':Subject, #1: 1	أَتَمَّ مُسَافِرٌ
u'تَمَّ مَسْبُوق':Subject, #2: 2	أَتَمَّ الْمُسَافِرُ
u'تَمَّ مَسْحٌ':Predicate, #1: 1	أَتَمَّ الْمَسْبُوقُ
u'تَمَّ مَسْحٌ':Subject, #11: 11	أَتَمَّ مَسْحَ
u'تَمَّمَ سَرقَةٌ':Predicate, #1: 1	تَمَّ الْمَسْحُ
u'تَمَّمَ سَرِقَةٌ':Predicate, #1: 1	تَمَّمَ السَّرِقَةَ
u'تَمَّمَ ضَمِنٌ':Predicate, #1: 1	تَمَّمَ السَّرِقَةَ
u'تَمَّ مَطْلُوبٌ':Subject, #1: 1	تَمَّمَ ضَمِنَ
u'تَمَّمَ عَمَلٌ':Predicate, #1: 1	تَمَّ مَطْلُوبُهُ
u'تَمَّمَ كَلاَمٌ':Predicate, #1: 1	تَمَّمَ الْعَمَلَ
u'تَمَّ مِلْكٌ':Predicate, #1: 1	تَمَّمَ الْكَلَامَ
u'تَمَّ مُلْكٌ':Subject, #1: 1	تَمَّ الْمِلْكَ
u'تَمَّ مِلْكٌ':Subject, #1: 1	تَمَّ مُلْكُهُ
u'تَمَّ مِلْكٌ':Subject, #3: 3	تَمَّ الْمِلْكُ
u'تَمَّ مَنْعٌ':Subject, #6: 6	تَمَّ مِلْكُهُ
u'تَمَّمَ وَارِثٌ':Subject, #1: 1	تَمَّ مَنْعُ
u'تَمَّ مَوْضِعٌ':Subject, #1: 1	تَمَّمَ الْوَارِثُ
u'تَمَّ نَافِلَةٌ':Predicate, #2: 2	تَمَّ مَوْضِعُ
u'تَمَّ نُسُكٌ':Subject, #3: 3	أَتَمَّ النَّافِلَةَ
u'تَمَّ نَصٌّ':Predicate, #6: 6	تَمَّ نُسُكُهُ
u'تَمَّ نصاب':Predicate, #1: 1	أَتَمَّ نَصَّ
u'تَمَّ نِصَابٌ':Predicate, #1: 1	تَمَّ النِّصَابَ
u'تَمَّ نصاب':Subject, #1: 1	تَمَّ النِّصَابَ
u'تَمَّ نِصَابٌ':Subject, #2: 2	تَمَّ النِّصَابُ
u'تَمَّ نصاب':Subject, #2: 2	تَمَّ النِّصَابُ
u'تَمَّ نِصَابٌ':Subject, #2: 2	تَمَّ نِصَابُ
u'تَمَّ نصاب':Subject, #2: 2	تَمَّ نِصَابُ
u'تَمَّ نِصَابٌ':Subject, #4: 4	تَمَّ نِصَابُهُ
u'تَمَّ نَظَرٌ':Predicate, #4: 4	تَمَّ نِصَابُهُ
u'تَمَّ نَظَرٌ':Subject, #1: 1	أَتَمَّ النَّظَرَ
u'تَمَّ نَظَرٌ':Subject, #1: 1	أَتَمَّ نَظَرُ
u'تَمَّ نَفَذٌ':Predicate, #2: 2	تَمَّ النَّظَرُ
u'تَمَّ نقل':Subject, #1: 1	أَتَمَّ نَفَذَ
u'تَمَّ نَقْلٌ':Subject, #1: 1	تَمَّ نَقْلُ
u'تَمَّ نكاح':Subject, #1: 1	تَمَّ نَقْلُ
u'تَمَّ نِكَاحٌ':Subject, #4: 4	تَمَّ النِّكَاحُ
u'تَمَّ نُكُولٌ':Subject, #4: 4	تَمَّ النِّكَاحُ
u'تَمَّ نُكُولٌ':Subject, #1: 1	تَمَّ نُكُولُ
u'تَمَنَّى حِلٌّ':Predicate, #1: 1	تَمَّ نُكُولُهُ
u'تَمَنَّى رِجَالٌ':Subject, #3: 3	تَمَنَّى حِلَّ
u'تَمَنَّى رَجُلٌ':Subject, #1: 1	تَمَنَّى رِجَالٌ
u'تَمَنَّى زَوالٌ':Predicate, #1: 1	تَمَنَّى الرَّجُلُ
u'تَمَنَّى سَبْقٌ':Predicate, #2: 2	تَمَنَّى زَوَالَ
u'تَمَنَّى شَهَادَةٌ':Predicate, #1: 1	تَمَنَّى سَبْقَ
u'تَمَنَّى قَبُولٌ':Predicate, #2: 2	تَمَنَّى الشَّهَادَةَ
u'تَمَنِّي كفر':Added, #1: 1	تَمَنَّى قَبُولَ
u'تَمَنِّي كُفْرٌ':Added, #1: 1	تَمَنِّي الْكُفْرِ
u'تَمَنِّي لِقَاءٌ':Added, #1: 1	تَمَنِّي الْكُفْرِ
u'تَمَنَّى مثل':Predicate, #1: 1	تَمَنِّي لِقَاءِ
u'تَمَنَّى مِثْلٌ':Predicate, #1: 1	تَمَنَّى مِثْلَ
u'تَمَنِّي مثل':Added, #1: 1	تَمَنَّى مِثْلَ
u'تَمَنِّي مِثْلٌ':Added, #1: 1	تَمَنِّي مِثْلِهِ
u'تَمَنَّى مَوْتٌ':Predicate, #1: 1	تَمَنِّي مِثْلِهِ
u'تَمَنِّي مَوْتٌ':Added, #3: 3	تَمَنَّى الْمَوْتَ
u'تَمَهَّدَ إِسْلامٌ':Subject, #3: 3	تَمَنِّي الْمَوْتِ
u'تَمَهُّدٌ أُصولٌ':Added, #2: 2	تَمَهَّدَ الْإِسْلَامُ
u'تَمْهِيدٌ أُصولٌ':Added, #1: 1	تَمَهُّدِ الْأُصُولِ
u'تَمْهِيدٌ تَحْقِيقٌ':Added, #1: 1	تَمْهِيدَ الْأُصُولِ
u'تَمْهِيدٌ قَاعِدٌ':Added, #1: 1	تَمْهِيدِ تَحْقِيقٍ
u'تَمْهِيدٌ قَاعِدٌ':Added, #1: 1	تَمْهِيدُ قَاعِدَةٍ
u'تَمْهِيدٌ مَسْأَلَةٌ':Added, #1: 1	تَمْهِيدِ قَاعِدَةٍ
u'تَمْهِيدٌ مُقَدِّمٌ':Added, #1: 1	تَمْهِيدُ الْمَسْأَلَةِ
u'تَمْهِيدٌ مُقَدِّمٌ':Added, #1: 1	تَمْهِيدَ مُقَدِّمَةٍ
u'تَمْهِيدٌ مُقَدِّمَةٌ':Added, #1: 1	تَمْهِيدُ مُقَدِّمَةٍ
u'تَمْهِيدٌ مُقَدِّمَةٌ':Added, #1: 1	تَمْهِيدَ مُقَدِّمَةٍ
u'تَمَّ وَجْهٌ':Subject, #1: 1	تَمْهِيدُ مُقَدِّمَةٍ
u'تَمَّ وُجُوبٌ':Subject, #1: 1	تَمَّ وَجْهُهُ
u'تَمَّ وُضُوءٌ':Predicate, #1: 1	تَمَّ الْوُجُوبُ
u'تَمَّ وُضُوءٌ':Subject, #1: 1	أَتَمَّ الْوُضُوءَ
u'تَمَّ وقع':Predicate, #1: 1	تَمَّ وُضُوءُهُ
u'تَمَّ وَقْفٌ':Subject, #2: 2	تَمَّ وَقَعَ
u'تَمَوُّلٌ نَاسٌ':Added, #1: 1	تَمَّ الْوَقْفُ
u'تَمْوِيهٌ أغبياء':Added, #1: 1	تَمَوُّلِ النَّاسِ
u'تَمْوِيهٌ حائِطٌ':Added, #1: 1	تَمْوِيهُ الْأَغْبِيَاءِ
u'تَمْوِيهٌ سَقْفٌ':Added, #1: 1	تَمْوِيهُ حَائِطٍ
u'تَمْوِيهٌ سَقْفٌ':Added, #1: 1	تَمْوِيهُ سَقْفِ
u'تَمْوِيهٌ كَلاَمٌ':Added, #2: 2	تَمْوِيهُ سَقْفٍ
u'تَمَيَّزَ إِخْوَانٌ':Subject, #1: 1	تَمْوِيهِ الْكَلَامِ
u'تَمَيُّزٌ أَمْرٌ':Added, #1: 1	تَمَيَّزَ الْإِخْوَانُ
u'تَمَيَّزَ بَدَلٌ':Subject, #1: 1	تَمَيُّزِ الْأَمْرِ
u'تَمَيَّزَ بَطَلٌ':Predicate, #2: 2	تَمَيَّزَ الْبَدَلُ
u'تَمَيُّزٌ حَقٌّ':Added, #1: 1	تَمَيَّزَ بَطَلَ
u'تَمَيُّزٌ حَقٌّ':Added, #1: 1	تَمَيُّزُ حَقٍّ
u'تَمَيَّزَ حُكْمٌ':Subject, #1: 1	تَمَيُّزِ حَقِّ
u'تَمَيَّزَ خَشَاشٌ':Subject, #1: 1	تَمَيَّزَ حُكْمُهُ
u'تَمَيَّزَ خيار':Subject, #1: 1	تَمَيَّزَ الْخَشَاشُ
u'تَمَيَّزَ خِيَارٌ':Subject, #1: 1	تَمَيَّزَ الْخِيَارُ
u'تَمَيُّزٌ ذاتِيٌّ':Added, #1: 1	تَمَيَّزَ الْخِيَارُ
u'تَمَيَّزَ طعام':Subject, #1: 1	تَمَيُّزُ الذَّاتِيِّ
u'تَمَيَّزَ طَعَامٌ':Subject, #1: 1	تَمَيَّزَ الطَّعَامُ
u'تَمَيُّزٌ فَاضِلٌ':Added, #1: 1	تَمَيَّزَ الطَّعَامُ
u'تَمَيُّزٌ مُحَكَّمٌ':Added, #1: 1	تَمَيُّزِ الْفَاضِلِ
u'تَمَيَّزَ مُسْتَحَقٌّ':Subject, #1: 1	تَمَيُّزَ الْمُحَكَّمِ
u'تَمَيُّزٌ مُسْتَحِقٌّ':Added, #1: 1	تَمَيَّزَ الْمُسْتَحَقُّ
u'تَمَيَّزَ مَسْرُوقٌ':Subject, #2: 2	تَمَيُّزِ الْمُسْتَحِقِّ
u'تَمَيَّزَ مَعْقُودٌ':Subject, #1: 1	تَمَيَّزَ الْمَسْرُوقُ
u'تَمَيَّزَ نَصِيبٌ':Subject, #1: 1	تَمَيَّزَ الْمَعْقُودُ
u'تَمَّ يَسِيرٌ':Subject, #1: 1	تَمَيَّزَ نَصِيبُهُ
u'تَنَاثَرَ بَعْضٌ':Subject, #1: 1	تَمَّ يَسِيرٌ
u'تَنَاثَرَ بَعْضٌ':Subject, #1: 1	تَنَاثَرَ بَعْضُهُ
u'تَنَاثُرٌ تُرَابٌ':Added, #2: 2	تَنَاثَرَ بَعْضُ
u'تَنَاثَرَ شَعْرٌ':Subject, #1: 1	تَنَاثُرُ التُّرَابِ
u'تَنَاثُرٌ شَعْرٌ':Added, #1: 1	تَنَاثَرَ شَعْرُهُ
u'تَنَاثُرٌ شَعْرٌ':Added, #1: 1	تَنَاثُرُ شَعْرِ
u'تَنَاثُرٌ شُعُورٌ':Added, #2: 2	تَنَاثُرِ الشَّعْرِ
u'تَنَاثَرَ شَيْءٌ':Subject, #1: 1	تَنَاثُرِ الشُّعُورِ
u'تَنَاثَرَ طهر':Predicate, #1: 1	تَنَاثَرَ شَيْءٌ
u'تَنَاثَرَ نَظْمٌ':Subject, #1: 1	تَنَاثَرَ طَهُرَ
u'تَنَاثَرَ نُورٌ':Subject, #1: 1	تَنَاثَرَ نَظْمُهُ
u'تَنَاثَرَ نُورٌ':Subject, #1: 1	تَنَاثَرَ نُورٌ
u'تَنَاثَرَ نَوْرٌ':Subject, #1: 1	تَنَاثَرَ نُورُهُ
u'تَنَاثُرٌ نَوْرٌ':Added, #1: 1	تَنَاثَرَ نَوْرُهُ
u'تَنَاثُرٌ نُورٌ':Added, #1: 1	تَنَاثُرِ نَوْرٍ
u'تَنَاثُرٌ نَوْرٌ':Added, #1: 1	تَنَاثُرِ نُورِهِ
u'تَنَازَعَ أَشْيَاخٌ':Subject, #1: 1	تَنَاثُرِ نَوْرِهِ
u'تَنَازَعَ إمَامَةٌ':Predicate, #1: 1	تَنَازَعَ الْأَشْيَاخُ
u'تَنَازَعَ أهْلٌ':Subject, #1: 1	تَنَازَعَ الْإِمَامَةَ
u'تَنَازَعَ أَوْلِيَاءُ':Subject, #4: 4	تَنَازَعَ أَهْلُ
u'تَنَازَعَ بَائِعٌ':Subject, #2: 2	تَنَازَعَ الْأَوْلِيَاءُ
u'تَنَازَعَ بَائِعٌ':Subject, #1: 1	تَنَازَعَ الْبَائِعُ
u'تَنَازَعَ حُرٌّ':Subject, #1: 1	تَنَازَعَ بَائِعُ
u'تَنَازُعٌ خُصُومٌ':Added, #1: 1	تَنَازَعَ حُرٌّ
u'تَنَازَعَ خَيَّاطٌ':Subject, #2: 2	تَنَازُعِ الْخُصُومِ
u'تَنَازَعَ رَبُّ':Subject, #1: 1	تَنَازَعَ الْخَيَّاطُ
u'تَنَازَعَ زَوْجٌ':Subject, #3: 3	تَنَازَعَ رَبُّ
u'تَنَازُعٌ زَوْجٌ':Added, #1: 1	تَنَازَعَ الزَّوْجُ
u'تَنَازَعَ سَعْدٌ':Subject, #1: 1	تَنَازُعِ الزَّوْجَيْنِ
u'تَنَازَعَ سَيِّدٌ':Subject, #1: 1	تَنَازَعَ سَعْدُ
u'تَنَازَعَ شركاء':Subject, #1: 1	تَنَازَعَ السَّيِّدُ
u'تَنَازَعَ صَاحِبٌ':Subject, #4: 4	تَنَازَعَ الشُّرَكَاءُ
u'تَنَازُعٌ صَبِيٌّ':Added, #7: 7	تَنَازَعَ صَاحِبُ
u'تَنَازَعَ علماء':Subject, #1: 1	تَنَازُعَ الصَّبِيِّ
u'تَنَازَعَ عُلَمَاءُ':Subject, #1: 1	تَنَازَعَ الْعُلَمَاءُ
u'تَنَازُعٌ فرق':Added, #1: 1	تَنَازَعَ الْعُلَمَاءُ
u'تَنَازُعٌ فِرَقٌ':Added, #1: 1	تَنَازُعُ الْفِرَقِ
u'تَنَازَعَ فقهاء':Subject, #1: 1	تَنَازُعُ الْفِرَقِ
u'تَنَازَعَ قَوْمٌ':Subject, #3: 3	تَنَازَعَ الْفُقَهَاءُ
u'تَنَازَعَ كَلاَمٌ':Subject, #3: 3	تَنَازَعَ الْقَوْمُ
u'تَنَازَعَ مُسْتَعِيرٌ':Subject, #2: 2	تَنَازَعَ كَلَامُهُ
u'تَنَازَعَ مُعْتَرِضٌ':Subject, #1: 1	تَنَازَعَ مُسْتَعِيرُ
u'تَنَازَعَ مُؤَجِّرٌ':Subject, #1: 1	تَنَازَعَ الْمُعْتَرِضُ
u'تَنَازَعَ نَاسٌ':Subject, #4: 4	تَنَازَعَ الْمُؤَجِّرُ
u'تَنَازَعَ وَدِيعٌ':Predicate, #1: 1	تَنَازَعَ النَّاسُ
u'تَنَازَعَ وَدِيعَةٌ':Predicate, #1: 1	تَنَازَعَ الْوَدِيعَةَ
u'تَنَازُعٌ يهود':Added, #1: 1	تَنَازَعَ الْوَدِيعَةَ
u'تَنَازُعٌ يَهُودٌ':Added, #1: 1	تَنَازُعُ الْيَهُودِ
u'تَنَاسُخٌ أَرْواحٌ':Added, #1: 1	تَنَازُعُ الْيَهُودِ
u'تَنَاسُخٌ قُرُونٌ':Added, #1: 1	تَنَاسُخُ الْأَرْوَاحِ
u'تَنَاسُقٌ ضَمَائِرُ':Added, #1: 1	تَنَاسُخُ الْقُرُونِ
u'تَنَاسَلَ أهْلٌ':Subject, #1: 1	تَنَاسُقُ الضَّمَائِرِ
u'تَنَاشُدٌ أَشْعَارٌ':Added, #1: 1	تَنَاسَلَ أَهْلُ
u'تَنَاشُدٌ أَشْعَارٌ':Added, #1: 1	تَنَاشُدِ أَشْعَارِ
u'تَنَاصَفَ نَاسٌ':Subject, #1: 1	تَنَاشُدِ الأَشْعَارِ
u'تَنَاظُرٌ شافِع':Added, #1: 1	تَنَاصَفَ النَّاسُ
u'تَنَاظَرَ شافِعِيّ':Subject, #1: 1	تَنَاظُرُ الشَّافِعِيَّةِ
u'تَنَاظُرٌ شافِعِيّ':Added, #1: 1	تَنَاظَرَ الشَّافِعِيُّ
u'تَنَاظَرَ فلان':Subject, #1: 1	تَنَاظُرُ الشَّافِعِيَّةِ
u'تَنَاظُرٌ فلان':Added, #1: 1	تَنَاظَرَ الشَّافِعِيُّ
u'تَنَافُرٌ طِبَاعٌ':Added, #1: 1	تَنَاظُرُ الشَّافِعِيَّةِ
u'تَنَافِي اِجْتِمَاعٌ':Added, #1: 1	تَنَافُرِ طِبَاعٍ
u'تَنَافِي أصل':Added, #1: 1	تَنَافِي اجْتِمَاعِ
u'تَنَافِي أًصْلٌ':Added, #2: 2	تَنَافِي أَصْلِهِ
u'تَنَافِي تَضَادٌّ':Added, #2: 2	تَنَافِي أَصْلِهِ
u'تَنَافَى جمع':Subject, #1: 1	تَنَافِيَ التَّضَادِّ
u'تَنَافَى جَمْعٌ':Subject, #1: 1	تَنَافَى الْجَمْعُ
u'تَنَافِي فِعْلٌ':Added, #1: 1	تَنَافَى الْجَمْعُ
u'تَنَافِي قَبُولٌ':Added, #1: 1	تَنَافِي الْفِعْلَيْنِ
u'تَنَافِي لَوَازِمُ':Added, #1: 1	تَنَافِي الْقَبُولَيْنِ
u'تَنَافِي مَقْبُولٌ':Added, #1: 1	تَنَافِيَ اللَّوَازِمِ
u'تَنَافِي مَلْزُوم':Added, #1: 1	تَنَافِي الْمَقْبُولَيْنِ
u'تَنَافِي مَلْزُوم':Added, #1: 1	تَنَافِيَ الْمَلْزُومَاتِ
u'تَنَافِي مَلْزُوم':Added, #1: 1	تَنَافِي الْمَلْزُومَيْنِ
u'تَنَاقُصٌ حسد':Added, #5: 5	تَنَافِي الْمَلْزُومَاتِ
u'تَنَاقُصٌ حَسَدٌ':Added, #1: 1	تَنَاقُصُ الْحَسَدِ
u'تَنَاقُضٌ أَحْكَامٌ':Added, #1: 1	تَنَاقُصُ الْحَسَدِ
u'تَنَاقُضٌ أَحْكَامٌ':Added, #1: 1	تَنَاقُضَ الْأَحْكَامِ
u'تَنَاقُضٌ أخْبَارٌ':Added, #1: 1	تَنَاقُضِ الْأَحْكَامِ
u'تَنَاقُضٌ أَخْبَارٌ':Added, #1: 1	تَنَاقُضُ أَخْبَارِ
u'تَنَاقُضٌ آرَاءٌ':Added, #1: 1	تَنَاقُضُ أَخْبَارِ
u'تَنَاقُضٌ آيَةٌ':Added, #1: 1	تَنَاقُضُ آرَاءِ
u'تَنَاقَضَ بَيْنٌ':Predicate, #1: 1	تَنَاقُضُ آيَةِ
u'تَنَاقُضٌ حَقِيقِيٌّ':Added, #1: 1	تَنَاقَضَ بَيْنَ
u'تَنَاقَضَ حَنَفِيَّةٌ':Subject, #1: 1	تَنَاقُضٍ حَقِيقِيٍّ
u'تَنَاقَضَ خَصْمٌ':Subject, #1: 1	تَنَاقَضَ الْحَنَفِيَّةُ
u'تَنَاقُضٌ شَرْعٌ':Added, #1: 1	تَنَاقَضَ الْخَصْمُ
u'تَنَاقُضٌ كُتُبٌ':Added, #1: 1	تَنَاقُضَ الشَّرْعِ
u'تَنَاقَضَ كَلاَمٌ':Subject, #1: 1	تَنَاقُضِ كُتُبِ
u'تَنَاقَضَ كَلاَمٌ':Subject, #3: 3	تَنَاقَضَ كَلَامُ
u'تَنَاقُضٌ كَلاَمٌ':Added, #6: 6	تَنَاقَضَ كَلَامُهُ
u'تَنَاقَضَ مَذْهَبٌ':Subject, #3: 3	تَنَاقُضُ كَلَامِهِ
u'تَنَاقُضٌ مَذْهَبٌ':Added, #1: 1	تَنَاقَضَ مَذْهَبُ
u'تَنَاقُضٌ مَعْلُومٌ':Added, #1: 1	تَنَاقُضِ مَذْهَبِهِ
u'تَنَاقُضٌ مَعْلُومٌ':Added, #1: 1	تَنَاقُضِ مَعْلُومَيْنِ
u'تَنَاقَضَ وَهْمٌ':Subject, #2: 2	تَنَاقُضِ الْمَعْلُومَيْنِ
u'تَنَاكُحٌ أَحْجارٌ':Added, #1: 1	تَنَاقَضَ وَهْمٌ
u'تَنَاهُدٌ رفاق':Added, #1: 1	تَنَاكُحُ الْأَحْجَارِ
u'تَنَاهُدٌ رِفاقٌ':Added, #1: 1	تَنَاهُدِ الرِّفَاقِ
u'تَنَاهَى اِبْنٌ':Subject, #1: 1	تَنَاهُدِ الرِّفَاقِ
u'تَنَاهِي أَفْرَادٌ':Added, #1: 1	تَنَاهَى ابْنُ
u'تَنَاهَى أكل':Subject, #1: 1	تَنَاهِي أَفْرَادِهِ
u'تَنَاهَى أَكْلٌ':Subject, #1: 1	تَنَاهَى أَكْلُهُ
u'تَنَاهِي أَلْفَاظٌ':Added, #1: 1	تَنَاهَى أَكْلُهُ
u'تَنَاهِي تَمْلِيحٌ':Added, #1: 1	تَنَاهِي الْأَلْفَاظِ
u'تَنَاهَى جفاف':Subject, #1: 1	تَنَاهِي تَمْلِيحِهِ
u'تَنَاهَى جَفَافٌ':Subject, #1: 1	تَنَاهَى جَفَافُهُ
u'تَنَاهِي جفاف':Added, #1: 1	تَنَاهَى جَفَافُهُ
u'تَنَاهِي جَفَافٌ':Added, #3: 3	تَنَاهِي جَفَافِهِ
u'تَنَاهِي خلقة':Added, #3: 3	تَنَاهِي جَفَافِهِ
u'تَنَاهِي خِلْقَةٌ':Added, #1: 1	تَنَاهِي خِلْقَتِهِ
u'تَنَاهِي زَرْعٌ':Added, #1: 1	تَنَاهِي خِلْقَتِهِ
u'تَنَاهَى صِغَرٌ':Subject, #1: 1	تَنَاهِي الزَّرْعِ
u'تَنَاهِي صُفُوفٌ':Added, #1: 1	تَنَاهَى صِغَرُهُ
u'تَنَاهِي طَبْخٌ':Added, #1: 1	تَنَاهِي الصُّفُوفِ
u'تَنَاهَى ظِلٌّ':Subject, #1: 1	تَنَاهِي طَبْخِهِ
u'تَنَاهَى عِظَمٌ':Subject, #1: 1	تَنَاهَى الظِّلُّ
u'تَنَاهَى عِظَمٌ':Subject, #1: 1	تَنَاهَى عِظَمُ
u'تَنَاهِي عِظَمٌ':Added, #2: 2	تَنَاهَى عِظَمُهُ
u'تَنَاهَى عِنَبٌ':Subject, #1: 1	تَنَاهِي عِظَمِهِ
u'تَنَاهِي قِصَرٌ':Added, #1: 1	تَنَاهَى الْعِنَبُ
u'تَنَاهِي مُرَكَّبٌ':Added, #1: 1	تَنَاهِي قِصَرِهِ
u'تَنَاهَى مِلْكٌ':Subject, #1: 1	تَنَاهِي الْمُرَكَّبِ
u'تَنَاهَى نَاسٌ':Subject, #1: 1	تَنَاهَى مِلْكُهُ
u'تَنَاهِي نُصُوصٌ':Added, #1: 1	تَنَاهَى النَّاسُ
u'تَنَاوُلٌ إجَارَةٌ':Added, #1: 1	تَنَاهِي النُّصُوصِ
u'تَنَاوُلٌ أَحْجارٌ':Added, #1: 1	تَنَاوُلِ إجَارَةِ
u'تَنَاوُلٌ إِذْنٌ':Added, #1: 1	تَنَاوُلِ الْأَحْجَارِ
u'تَنَاوُلٌ إِذْنٌ':Added, #1: 1	تَنَاوُلِ إذْنِ
u'تَنَاوُلٌ أرْضٌ':Added, #2: 2	تَنَاوُلِ الْإِذْنِ
u'تَنَاوَلَ اِسْمٌ':Predicate, #1: 1	تَنَاوُلَ الْأَرْضِ
u'تَنَاوَلَ اِسْمٌ':Subject, #2: 2	تَنَاوَلَ اسْمَ
u'تَنَاوُلٌ اِسْمٌ':Added, #1: 1	تَنَاوَلَ اسْمُ
u'تَنَاوَلَ أَشْيَاءٌ':Predicate, #1: 1	تَنَاوُلِ اسْمِ
u'تَنَاوُلٌ أصل':Added, #1: 1	تَنَاوَلَ أَشْيَاءَ
u'تَنَاوُلٌ أًصْلٌ':Added, #1: 1	تَنَاوُلِ الْأَصْلِ
u'تَنَاوُلٌ أَطْرافٌ':Added, #1: 1	تَنَاوُلِ الْأَصْلِ
u'تَنَاوُلٌ أَطْرَافٌ':Added, #1: 1	تَنَاوُلِ الْأَطْرَافِ
u'تَنَاوَلَ إِطْلاقٌ':Subject, #1: 1	تَنَاوُلِ الْأَطْرَافِ
u'تَنَاوَلَ إِعْتاقٌ':Subject, #1: 1	تَنَاوَلَ إطْلَاقُهُ
u'تَنَاوُلٌ أَلْوَانٌ':Added, #1: 1	تَنَاوَلَ الْإِعْتَاقُ
u'تَنَاوُلٌ أُمُورٌ':Added, #1: 1	تَنَاوُلِ الْأَلْوَانِ
u'تَنَاوَلَ أهْلٌ':Subject, #1: 1	تَنَاوُلِ أُمُورِهِ
u'تَنَاوُلٌ أيَّامٌ':Added, #1: 1	تَنَاوَلَ الْأَهْلُ
u'تَنَاوُلٌ أَيَّامٌ':Added, #1: 1	تَنَاوُلِ الْأَيَّامِ
u'تَنَاوُلٌ بُسْرٌ':Added, #1: 1	تَنَاوُلِ الْأَيَّامِ
u'تَنَاوَلَ بَعْضٌ':Predicate, #1: 1	تَنَاوُلِ الْبُسْرِ
u'تَنَاوَلَ بَعْضٌ':Predicate, #1: 1	تَنَاوَلَ الْبَعْضَ
u'تَنَاوُلٌ بَعْضٌ':Added, #1: 1	تَنَاوَلَ بَعْضَ
u'تَنَاوَلَ بِنَاءٌ':Subject, #1: 1	تَنَاوُلُ بَعْضِ
u'تَنَاوُلٌ بِنَاءٌ':Added, #1: 1	تَنَاوَلَ الْبِنَاءُ
u'تَنَاوُلٌ بَنْجٌ':Added, #1: 1	تَنَاوُلُ الْبِنَاءِ
u'تَنَاوُلٌ بيض':Added, #1: 1	تَنَاوُلَ الْبَنْجِ
u'تَنَاوَلَ بَيْعٌ':Predicate, #1: 1	تَنَاوُلِ الْبَيْضِ
u'تَنَاوَلَ بَيْعٌ':Subject, #1: 1	تَنَاوَلَ الْبَيْعَ
u'تَنَاوَلَ تَحْرِيمٌ':Subject, #1: 1	تَنَاوَلَ الْبَيْعُ
u'تَنَاوُلٌ تَحْرِيمٌ':Added, #1: 1	تَنَاوَلَ التَّحْرِيمُ
u'تَنَاوُلٌ تَوْكِيلٌ':Added, #1: 1	تَنَاوُلُ التَّحْرِيمِ
u'تَنَاوَلَ جَانِبٌ':Predicate, #1: 1	تَنَاوُلِ التَّوْكِيلِ
u'تَنَاوُلٌ جلد':Added, #1: 1	تَنَاوَلَ جَانِبَ
u'تَنَاوُلٌ جِلْدٌ':Added, #1: 1	تَنَاوُلُ الْجِلْدِ
u'تَنَاوَلَ حَبٌّ':Predicate, #1: 1	تَنَاوُلُ الْجِلْدِ
u'تَنَاوُلٌ حَرامٌ':Added, #1: 1	تَنَاوَلَ حَبَّةً
u'تَنَاوَلَ حَقِيقٌ':Predicate, #1: 1	تَنَاوُلَ الْحَرَامِ
u'تَنَاوَلَ حَقِيقَةٌ':Predicate, #1: 1	تَنَاوَلَ الْحَقِيقَةَ
u'تَنَاوُلٌ حُكْمٌ':Added, #1: 1	تَنَاوَلَ الْحَقِيقَةَ
u'تَنَاوُلٌ حَمْلٌ':Added, #1: 1	تَنَاوُلِ الْحُكْمِ
u'تَنَاوُلٌ حِيلَةٌ':Added, #1: 1	تَنَاوُلِ الْحَمْلِ
u'تَنَاوُلٌ خُبْزٌ':Added, #1: 1	تَنَاوُلِ الْحِيلَةِ
u'تَنَاوُلٌ خدمة':Added, #1: 1	تَنَاوُلُ الْخُبْزِ
u'تَنَاوُلٌ خِدْمَةٌ':Added, #1: 1	تَنَاوُلُ الْخِدْمَةِ
u'تَنَاوُلٌ خِطَابٌ':Added, #1: 1	تَنَاوُلُ الْخِدْمَةِ
u'تَنَاوُلٌ خِطَابٌ':Added, #1: 1	تَنَاوُلَ الْخِطَابِ
u'تَنَاوُلٌ خُمُسٌ':Added, #2: 2	تَنَاوُلِ الْخِطَابِ
u'تَنَاوُلٌ دَرَاهِمُ':Added, #1: 1	تَنَاوُلُ الْخُمُسِ
u'تَنَاوُلٌ دَليلٌ':Added, #1: 1	تَنَاوُلِ الدَّرَاهِمِ
u'تَنَاوَلَ ذِراعٌ':Predicate, #1: 1	تَنَاوُلُ الدَّلِيلِ
u'تَنَاوَلَ ذُكورٌ':Predicate, #1: 1	تَنَاوَلَ الذّرَاعَ
u'تَنَاوُلٌ رَجُلٌ':Added, #1: 1	تَنَاوَلَ الذُّكُورَ
u'تَنَاوَلَ رَسُولٌ':Subject, #1: 1	تَنَاوُلُ الرَّجُلِ
u'تَنَاوُلٌ رُطَبٌ':Added, #2: 2	تَنَاوَلَ رَسُولُ
u'تَنَاوَلَ رِيشٌ':Predicate, #2: 2	تَنَاوُلِ الرُّطَبِ
u'تَنَاوُلٌ زَوْجَةٌ':Added, #1: 1	تَنَاوَلَ الرِّيشَ
u'تَنَاوَلَ سِتْرٌ':Predicate, #1: 1	تَنَاوُلِ زَوْجَتِهِ
u'تَنَاوَلَ سَرِيرٌ':Predicate, #2: 2	تَنَاوَلَ السِّتْرَ
u'تَنَاوَلَ سِمْسِم':Predicate, #1: 1	تَنَاوَلَ السَّرِيرَ
u'تَنَاوَلَ سَمَكٌ':Predicate, #1: 1	تَنَاوَلَ سِمْسِمَةً
u'تَنَاوَلَ سَمِينٌ':Predicate, #1: 1	تَنَاوَلَ السَّمَكَ
u'تَنَاوَلَ سُنَّةٌ':Predicate, #2: 2	تَنَاوَلَ السَّمِينَ
u'تَنَاوَلَ شَائِعٌ':Predicate, #1: 1	تَنَاوَلَ السُّنَّةَ
u'تَنَاوُلٌ شَيْءٌ':Added, #1: 1	تَنَاوَلَ الشَّائِعَ
u'تَنَاوُلٌ شَيْءٌ':Added, #1: 1	تَنَاوُلِ شَيْءٍ
u'تَنَاوُلٌ شَيْءٌ':Added, #2: 2	تَنَاوُلَ الشَّيْءِ
u'تَنَاوُلٌ صَدْرٌ':Added, #5: 5	تَنَاوُلُ شَيْءٍ
u'تَنَاوَلَ صِفَةٌ':Predicate, #2: 2	تَنَاوُلِ الصَّدْرِ
u'تَنَاوُلٌ صُورَةٌ':Added, #1: 1	تَنَاوَلَ الصِّفَةَ
u'تَنَاوُلٌ صَيْدٌ':Added, #1: 1	تَنَاوُلِ صُورَةِ
u'تَنَاوُلٌ صَيْدٌ':Added, #1: 1	تَنَاوُلُ الصَّيْدِ
u'تَنَاوَلَ ضَمِنٌ':Predicate, #1: 1	تَنَاوُلِ الصَّيْدِ
u'تَنَاوُلٌ طعام':Added, #1: 1	تَنَاوَلَ ضَمِنَ
u'تَنَاوُلٌ طَعَامٌ':Added, #1: 1	تَنَاوُلُ الطَّعَامِ
u'تَنَاوُلٌ طعام':Added, #1: 1	تَنَاوُلُ الطَّعَامِ
u'تَنَاوُلٌ طَعَامٌ':Added, #1: 1	تَنَاوُلِ طَعَامِ
u'تَنَاوُلٌ طعام':Added, #1: 1	تَنَاوُلِ طَعَامِ
u'تَنَاوُلٌ طَعَامٌ':Added, #3: 3	تَنَاوُلِ الطَّعَامِ
u'تَنَاوُلٌ عَامٌّ':Added, #3: 3	تَنَاوُلِ الطَّعَامِ
u'تَنَاوَلَ عَقْدٌ':Subject, #1: 1	تَنَاوُلَ الْعَامِّ
u'تَنَاوَلَ عَقْدٌ':Subject, #1: 1	تَنَاوَلَ الْعَقْدُ
u'تَنَاوُلٌ عَقْدٌ':Added, #1: 1	تَنَاوَلَ عَقْدُهُ
u'تَنَاوَلَ عَلَفٌ':Predicate, #1: 1	تَنَاوُلُ الْعَقْدِ
u'تَنَاوُلٌ عَلَفٌ':Added, #2: 2	تَنَاوَلَ الْعَلَفَ
u'تَنَاوُلٌ عِنَبٌ':Added, #1: 1	تَنَاوُلَ الْعَلَفِ
u'تَنَاوُلٌ غَلَّةٌ':Added, #1: 1	تَنَاوُلِ الْعِنَبِ
u'تَنَاوَلَ فَرْعٌ':Predicate, #1: 1	تَنَاوُلُ الْغَلَّةِ
u'تَنَاوَلَ فلان':Predicate, #1: 1	تَنَاوَلَ الْفَرْعَ
u'تَنَاوَلَ فُلاَنٌ':Subject, #1: 1	تَنَاوَلَ سِمْسِمَةً
u'تَنَاوُلٌ قَاذِفٌ':Added, #2: 2	تَنَاوَلَ فُلَانٌ
u'تَنَاوَلَ قَارُورَةٌ':Predicate, #1: 1	تَنَاوُلِ الْقَاذِفِ
u'تَنَاوُلٌ قَدْرٌ':Added, #1: 1	تَنَاوَلَ الْقَارُورَةَ
u'تَنَاوُلٌ قَدْرٌ':Added, #1: 1	تَنَاوُلَ الْقَدْرِ
u'تَنَاوُلٌ قَدْرٌ':Added, #1: 1	تَنَاوُلِ الْقَدْرِ
u'تَنَاوَلَ قذف':Predicate, #1: 1	تَنَاوُلُ قَدْرِ
u'تَنَاوَلَ قَذْفٌ':Predicate, #1: 1	تَنَاوَلَ الْقَذْفَ
u'تَنَاوَلَ قذف':Subject, #1: 1	تَنَاوَلَ الْقَذْفَ
u'تَنَاوَلَ قَذْفٌ':Subject, #1: 1	تَنَاوَلَ الْقَذْفُ
u'تَنَاوَلَ قول':Subject, #1: 1	تَنَاوَلَ الْقَذْفُ
u'تَنَاوَلَ قَوْلٌ':Subject, #1: 1	تَنَاوَلَ الْقَوْلُ
u'تَنَاوُلٌ كَرَاهَةٌ':Added, #1: 1	تَنَاوَلَ الْقَوْلُ
u'تَنَاوَلَ كَلاَمٌ':Subject, #1: 1	تَنَاوُلِ الْكَرَاهَةِ
u'تَنَاوَلَ كَلاَمٌ':Subject, #1: 1	تَنَاوَلَ الْكَلَامُ
u'تَنَاوُلٌ كَلاَمٌ':Added, #1: 1	تَنَاوَلَ كَلَامُهُ
u'تَنَاوَلَ لَحْمٌ':Predicate, #1: 1	تَنَاوُلِ الْكَلَامِ
u'تَنَاوُلٌ لَحْمٌ':Added, #1: 1	تَنَاوَلَ اللَّحْمَ
u'تَنَاوُلٌ لُحُومٌ':Added, #1: 1	تَنَاوُلِ لَحْمِهِ
u'تَنَاوَلَ لِحْيَةٌ':Predicate, #1: 1	تَنَاوُلُ لُحُومِ
u'تَنَاوُلٌ لَفْظٌ':Added, #1: 1	تَنَاوَلَ لِحْيَةَ
u'تَنَاوُلٌ لَفْظٌ':Added, #2: 2	تَنَاوُلُ اللَّفْظِ
u'تَنَاوُلٌ لَفْظٌ':Added, #2: 2	تَنَاوُلِ لَفْظِ
u'تَنَاوُلٌ مَاءٌ':Added, #4: 4	تَنَاوُلِ اللَّفْظِ
u'تَنَاوُلٌ مَأْكُولٌ':Added, #1: 1	تَنَاوُلُ الْمَاءِ
u'تَنَاوُلٌ مَأْكُولٌ':Added, #1: 1	تَنَاوُلِ الْمَأْكُولِ
u'تَنَاوَلَ مَالٌ':Predicate, #1: 1	تَنَاوُلِ الْمَأْكُولَاتِ
u'تَنَاوُلٌ مَالٌ':Added, #1: 1	تَنَاوَلَ مَالَ
u'تَنَاوُلٌ مَالٌ':Added, #1: 1	تَنَاوُلُ مَالِ
u'تَنَاوُلٌ مَأْمُورٌ':Added, #9: 9	تَنَاوُلِ مَالِ
u'تَنَاوُلٌ مُتَعَاطِفٌ':Added, #1: 1	تَنَاوُلِ الْمَأْمُورِ
u'تَنَاوُلٌ مُحَرَّمٌ':Added, #1: 1	تَنَاوُلِ الْمُتَعَاطِفَيْنِ
u'تَنَاوَلَ مَحْظُورٌ':Predicate, #1: 1	تَنَاوُلِ مُحَرَّمٍ
u'تَنَاوُلٌ مَحْظُورٌ':Added, #3: 3	تَنَاوَلَ مَحْظُورَ
u'تَنَاوَلَ مرٌّ':Predicate, #1: 1	تَنَاوُلِ الْمَحْظُورِ
u'تَنَاوُلٌ مُسْكِرٌ':Added, #1: 1	تَنَاوَلَ مَرَّةً
u'تَنَاوُلٌ مُشْتَبَهٌ':Added, #1: 1	تَنَاوُلُ الْمُسْكِرِ
u'تَنَاوُلٌ مُضِرٌّ':Added, #1: 1	تَنَاوُلِ الْمُشْتَبَهِ
u'تَنَاوُلٌ مُضْطَرٌّ':Added, #1: 1	تَنَاوُلَ الْمُضِرِّ
u'تَنَاوُلٌ مَعْلُومٌ':Added, #1: 1	تَنَاوُلَ الْمُضْطَرِّ
u'تَنَاوُلٌ مُفْطِر':Added, #1: 1	تَنَاوُلُ الْمَعْلُومِ
u'تَنَاوُلٌ مُفْطِر':Added, #1: 1	تَنَاوُلِ الْمُفْطِرِ
u'تَنَاوُلٌ مِقْدَارٌ':Added, #1: 1	تَنَاوُلِ مُفْطِرٍ
u'تَنَاوُلٌ مَنْفَعَةٌ':Added, #2: 2	تَنَاوُلِ مِقْدَارِ
u'تَنَاوُلٌ مَوْقُوذ':Added, #1: 1	تَنَاوُلِ الْمَنْفَعَةِ
u'تَنَاوُلٌ مَيْتٌ':Added, #1: 1	تَنَاوُلِ الْمَوْقُوذَةِ
u'تَنَاوُلٌ مَيْتٌ':Added, #1: 1	تَنَاوُلَ الْمَيْتَةِ
u'تَنَاوُلٌ مَيْتٌ':Added, #2: 2	تَنَاوُلُ الْمَيْتَةِ
u'تَنَاوُلٌ مَيْتَةٌ':Added, #2: 2	تَنَاوُلِ الْمَيْتَةِ
u'تَنَاوُلٌ مَيْتَةٌ':Added, #1: 1	تَنَاوُلَ الْمَيْتَةِ
u'تَنَاوُلٌ مَيْتَةٌ':Added, #2: 2	تَنَاوُلُ الْمَيْتَةِ
u'تَنَاوَلَ نَبِيٌّ':Subject, #2: 2	تَنَاوُلِ الْمَيْتَةِ
u'تَنَاوُلٌ نَجَاسَةٌ':Added, #1: 1	تَنَاوَلَ النَّبِيُّ
u'تَنَاوُلٌ نَجَسٌ':Added, #1: 1	تَنَاوُلُ النَّجَاسَةِ
u'تَنَاوَلَ نِساءٌ':Predicate, #1: 1	تَنَاوُلُ النَّجَسِ
u'تَنَاوُلٌ نَصٌّ':Added, #1: 1	تَنَاوَلَ النّسَاءَ
u'تَنَاوُلٌ نُصُوصٌ':Added, #1: 1	تَنَاوُلِ النَّصِّ
u'تَنَاوُلٌ نَفَقَةٌ':Added, #1: 1	تَنَاوُلِ النُّصُوصِ
u'تَنَاوُلٌ نَفْيٌ':Added, #1: 1	تَنَاوُلِ النَّفَقَةِ
u'تَنَاوُلٌ نكاح':Added, #1: 1	تَنَاوُلِ النَّفْيِ
u'تَنَاوُلٌ نِكَاحٌ':Added, #1: 1	تَنَاوُلِ نِكَاحِ
u'تَنَاوُلٌ نكاح':Added, #1: 1	تَنَاوُلِ نِكَاحِ
u'تَنَاوُلٌ نِكَاحٌ':Added, #2: 2	تَنَاوُلِ النِّكَاحِ
u'تَنَاوُلٌ نَهْيٌ':Added, #2: 2	تَنَاوُلِ النِّكَاحِ
u'تَنَاوَلَ وَقْتٌ':Predicate, #1: 1	تَنَاوُلِ النَّهْيِ
u'تَنَاوُلٌ يَدٌ':Added, #1: 1	تَنَاوَلَ وَقْتَ
u'تَنَاوُلٌ يَسِيرٌ':Added, #1: 1	تَنَاوُلَ الْيَدَيْنِ
u'تَنَاوُلٌ يَسِيرٌ':Added, #1: 1	تَنَاوُلُ الْيَسِيرِ
u'تَنَاوُلٌ يَسِيرٌ':Added, #1: 1	تَنَاوُلِ الْيَسِيرِ
u'تَنَاوَلَ يَمِينٌ':Predicate, #1: 1	تَنَاوُلُ يَسِيرٍ
u'تَنَاوَلَ يَمِينٌ':Subject, #1: 1	تَنَاوَلَ الْيَمِينَ
u'تَنَائِي أَقْطَارٌ':Added, #1: 1	تَنَاوَلَ الْيَمِينُ
u'تَنَائِي دَارٌ':Added, #1: 1	تَنَائِي الْأَقْطَارِ
u'تَنَبَّهَ صَاحِبٌ':Subject, #1: 1	تَنَائِي الدَّارِ
u'تَنَبَّهَ نَائِمٌ':Subject, #1: 1	تَنَبَّهَ صَاحِبُهُ
u'تَنْبِيهٌ أَحْسَنُ':Added, #1: 1	تَنَبَّهَ النَّائِمُ
u'تَنْبِيهٌ إمَامٌ':Added, #1: 1	تَنْبِيهُ أَحْسَنِ
u'تَنْبِيهٌ إمَامٌ':Added, #1: 1	تَنْبِيهِ الإِمَامِ
u'تَنْبِيهٌ إمَامٌ':Added, #1: 1	تَنْبِيهَ الْإِمَامِ
u'تَنْبِيهٌ إمَامٌ':Added, #3: 3	تَنْبِيهُ الْإِمَامِ
u'تَنْبِيهٌ حَديثٌ':Added, #3: 3	تَنْبِيهِ الْإِمَامِ
u'تَنْبِيهٌ خِطَابٌ':Added, #1: 1	تَنْبِيهِ الْحَدِيثِ
u'تَنْبِيهٌ سَمْعٌ':Added, #1: 1	تَنْبِيهَ الْخِطَابِ
u'تَنْبِيهٌ شَارِعٌ':Added, #1: 1	تَنْبِيهَ السَّمْعِ
u'تَنْبِيهٌ شَرْعٌ':Added, #1: 1	تَنْبِيهِ الشَّارِعِ
u'تَنْبِيهٌ صَرِيحٌ':Added, #1: 1	تَنْبِيهِ الشَّرْعِ
u'تَنْبِيهٌ غَبِيٌّ':Added, #1: 1	تَنْبِيهُ صَرِيحِ
u'تَنْبِيهٌ قلب':Added, #3: 3	تَنْبِيهِ الْغَبِيِّ
u'تَنْبِيهٌ قَلْبٌ':Added, #1: 1	تَنْبِيهِ الْقَلْبِ
u'تَنْبِيهٌ قَلْب':Added, #1: 1	تَنْبِيهِ الْقَلْبِ
u'تَنْبِيهٌ كَلاَمٌ':Added, #1: 1	تَنْبِيهِ الْقَلْبِ
u'تَنْبِيهٌ مثل':Added, #1: 1	تَنْبِيهُ الْكَلَامِ
u'تَنْبِيهٌ مِثْلٌ':Added, #1: 1	تَنْبِيهُ مِثْلِ
u'تَنْبِيهٌ مُرْشِدٌ':Added, #1: 1	تَنْبِيهُ مِثْلِ
u'تَنْبِيهٌ وُلاَةٌ':Added, #1: 1	تَنْبِيهُ مُرْشِدٍ
u'تَنْبِيهٌ وُلاَةٌ':Added, #1: 1	تَنْبِيهَ الْوُلَاةِ
u'تَنَجَّزَ أَمْرٌ':Subject, #1: 1	تَنْبِيهُ الْوُلَاةِ
u'تَنَجَّزَ أَوَّلُ':Subject, #1: 1	تَنَجَّزَ الْأَمْرُ
u'تَنَجُّزٌ حاجَةٌ':Added, #1: 1	تَنَجَّزَ الْأَوَّلُ
u'تَنَجُّزٌ حُرِّيَّةٌ':Added, #2: 2	تَنَجُّزِ الْحَاجَةِ
u'تَنَجُّزٌ خِطَابٌ':Added, #1: 1	تَنَجُّزَ الْحُرِّيَّةِ
u'تَنَجَّزَ سَواءٌ':Subject, #1: 1	تَنَجُّزَ الْخِطَابِ
u'تَنَجَّزَ طَلاَقٌ':Subject, #1: 1	تَنَجَّزَ سَوَاءٌ
u'تَنَجَّزَ عتق':Subject, #1: 1	تَنَجَّزَ الطَّلَاقُ
u'تَنَجَّزَ عِتْقٌ':Subject, #1: 1	تَنَجَّزَ الْعِتْقُ
u'تَنَجُّزٌ عتق':Added, #1: 1	تَنَجَّزَ الْعِتْقُ
u'تَنَجُّزٌ عِتْقٌ':Added, #1: 1	تَنَجُّزِ الْعِتْقِ
u'تَنَجَّزَ وقع':Predicate, #1: 1	تَنَجُّزِ الْعِتْقِ
u'تَنَجَّسَ أحَدٌ':Subject, #1: 1	تَنَجَّزَ وَقَعَ
u'تَنَجَّسَ أَسْفَلُ':Predicate, #1: 1	تَنَجَّسَ أَحَدُ
u'تَنَجَّسَ أَسْفَلُ':Subject, #3: 3	تَنَجَّسَ أَسْفَلَ
u'تَنَجَّسَ إِناءٌ':Subject, #1: 1	تَنَجَّسَ أَسْفَلُ
u'تَنَجَّسَ بَاطن':Subject, #3: 3	تَنَجَّسَ الْإِنَاءُ
u'تَنَجَّسَ باطِنٌ':Subject, #1: 1	تَنَجَّسَ بَاطِنُ
u'تَنَجَّسَ بَعْضٌ':Subject, #1: 1	تَنَجَّسَ بَاطِنُ
u'تَنَجَّسَ تَنُّورٌ':Subject, #1: 1	تَنَجَّسَ بَعْضُ
u'تَنَجَّسَ ثَوْبٌ':Subject, #3: 3	تَنَجَّسَ التَّنُّورُ
u'تَنَجَّسَ جَانِبٌ':Subject, #7: 7	تَنَجَّسَ ثَوْبُهُ
u'تَنَجَّسَ حَبٌّ':Subject, #1: 1	تَنَجَّسَ جَانِبَاهُ
u'تَنَجَّسَ حَوْضٌ':Subject, #1: 1	تَنَجَّسَ حَبٌّ
u'تَنَجَّسَ خُبْزٌ':Subject, #2: 2	تَنَجَّسَ الْحَوْضُ
u'تَنَجَّسَ خُفٌّ':Subject, #1: 1	تَنَجَّسَ الْخُبْزُ
u'تَنَجَّسَ رَأْسٌ':Subject, #1: 1	تَنَجَّسَ خُفٌّ
u'تَنَجَّسَ زِئْبَقٌ':Subject, #1: 1	تَنَجَّسَ رَأْسُ
u'تَنَجَّسَ سَواءٌ':Subject, #1: 1	تَنَجَّسَ الزِّئْبَقُ
u'تَنَجَّسَ شَعْرٌ':Subject, #1: 1	تَنَجَّسَ سَوَاءٌ
u'تَنَجَّسَ شَعْرٌ':Subject, #1: 1	تَنَجَّسَ الشَّعْرُ
u'تَنَجَّسَ طَبِيخٌ':Subject, #1: 1	تَنَجَّسَ شَعْرُ
u'تَنَجَّسَ طَرَفٌ':Subject, #1: 1	تَنَجَّسَ الطَّبِيخُ
u'تَنَجَّسَ عَسَلٌ':Subject, #2: 2	تَنَجَّسَ طَرَفٌ
u'تَنَجَّسَ عُضْوٌ':Subject, #2: 2	تَنَجَّسَ الْعَسَلُ
u'تَنَجَّسَ غير':Subject, #1: 1	تَنَجَّسَ الْعُضْوُ
u'تَنَجَّسَ غَيْرٌ':Subject, #1: 1	تَنَجَّسَ غَيْرُ
u'تَنَجَّسَ فَمٌ':Subject, #1: 1	تَنَجَّسَ غَيْرُ
u'تَنَجَّسَ فَمٌ':Subject, #1: 1	تَنَجَّسَ الْفَمُ
u'تَنَجَّسَ فَمٌ':Subject, #1: 1	تَنَجَّسَ فَمُ
u'تَنَجَّسَ مَاءٌ':Subject, #3: 3	تَنَجَّسَ فَمُهُ
u'تَنَجَّسَ مَوْضِعٌ':Subject, #6: 6	تَنَجَّسَ الْمَاءُ
u'تَنَجَّسَ نَحْوٌ':Subject, #1: 1	تَنَجَّسَ مَوْضِعُ
u'تَنَجَّسَ وَجَبٌ':Predicate, #1: 1	تَنَجَّسَ نَحْوُ
u'تَنْجِيزٌ أَدَاءٌ':Added, #1: 1	تَنَجَّسَ وَجَبَ
u'تَنْجِيزٌ إِذْنٌ':Added, #1: 1	تَنْجِيزِ الْأَدَاءِ
u'تَنْجِيزٌ بَراءةٌ':Added, #1: 1	تَنْجِيزَ الْإِذْنِ
u'تَنْجِيزٌ تَكْليفٌ':Added, #2: 2	تَنْجِيزُ الْبَرَاءَةِ
u'تَنْجِيزٌ تَكْليفٌ':Added, #1: 1	تَنْجِيزُ التَّكْلِيفِ
u'تَنْجِيزٌ تَكْليفٌ':Added, #1: 1	تَنْجِيزِ التَّكْلِيفِ
u'تَنْجِيزٌ ثَلاثُ':Added, #2: 2	تَنْجِيزَ التَّكْلِيفِ
u'تَنْجِيزٌ ثَلاثُ':Added, #1: 1	تَنْجِيزَ الثَّلَاثِ
u'تَنْجِيزٌ ثَلاثُ':Added, #1: 1	تَنْجِيزِ الثَّلَاثِ
u'تَنْجِيزٌ حُرِّيَّةٌ':Added, #2: 2	تَنْجِيزُ الثَّلَاثِ
u'تَنْجِيزٌ طَلاَقٌ':Added, #1: 1	تَنْجِيزِ الْحُرِّيَّةِ
u'تَنْجِيزٌ طَلاَقٌ':Added, #1: 1	تَنْجِيزُ طَلَاقِ
u'تَنْجِيزٌ طَلاَقٌ':Added, #2: 2	تَنْجِيزَ الطَّلَاقِ
u'تَنْجِيزٌ طَلاَقٌ':Added, #2: 2	تَنْجِيزُ الطَّلَاقِ
u'تَنْجِيزٌ عَاجِلٌ':Added, #7: 7	تَنْجِيزِ الطَّلَاقِ
u'تَنْجِيزٌ عتق':Added, #1: 1	تَنْجِيزُ الْعَاجِلِ
u'تَنْجِيزٌ عتق':Added, #1: 1	تَنْجِيزُ عِتْقِ
u'تَنْجِيزٌ عِتْقٌ':Added, #1: 1	تَنْجِيزِ عِتْقِ
u'تَنْجِيزٌ عِتْقٌ':Added, #1: 1	تَنْجِيزُ عِتْقِ
u'تَنْجِيزٌ عِتْقٌ':Added, #1: 1	تَنْجِيزِ عِتْقٍ
u'تَنْجِيزٌ عتق':Added, #1: 1	تَنْجِيزِ عِتْقِ
u'تَنْجِيزٌ عِتْقٌ':Added, #1: 1	تَنْجِيزَ عِتْقِهِ
u'تَنْجِيزٌ عتق':Added, #1: 1	تَنْجِيزَ عِتْقِهِ
u'تَنْجِيزٌ عِتْقٌ':Added, #2: 2	تَنْجِيزُ الْعِتْقِ
u'تَنْجِيزٌ عتق':Added, #2: 2	تَنْجِيزُ الْعِتْقِ
u'تَنْجِيزٌ عِتْقٌ':Added, #6: 6	تَنْجِيزَ الْعِتْقِ
u'تَنْجِيزٌ عتق':Added, #6: 6	تَنْجِيزَ الْعِتْقِ
u'تَنْجِيزٌ عِتْقٌ':Added, #7: 7	تَنْجِيزِ الْعِتْقِ
u'تَنْجِيزٌ فِرْقَةٌ':Added, #7: 7	تَنْجِيزِ الْعِتْقِ
u'تَنْجِيسٌ اِسْمٌ':Added, #1: 1	تَنْجِيزِ الْفِرْقَةِ
u'تَنْجِيسٌ اِسْمٌ':Added, #1: 1	تَنْجِيسَ اسْمِ
u'تَنْجِيسٌ بدن':Added, #1: 1	تَنْجِيسِ اسْمِ
u'تَنْجِيسٌ بَدَنٌ':Added, #1: 1	تَنْجِيسِ الْبَدَنِ
u'تَنْجِيسٌ بِئْرٌ':Added, #1: 1	تَنْجِيسِ الْبَدَنِ
u'تَنْجِيسٌ ثِيابٌ':Added, #1: 1	تَنْجِيسَ الْبِئْرِ
u'تَنْجِيسٌ شِرْكٌ':Added, #1: 1	تَنْجِيسِ الثِّيَابِ
u'تَنْجِيسٌ شَيْءٌ':Added, #1: 1	تَنْجِيسِ الشّرْكِ
u'تَنْجِيسٌ صِبْيَانٌ':Added, #1: 1	تَنْجِيسَ شَيْءٍ
u'تَنْجِيسٌ طَاهِرٌ':Added, #1: 1	تَنْجِيسُ الصِّبْيَانِ
u'تَنْجِيسٌ طَاهِرٌ':Added, #1: 1	تَنْجِيسَ الطَّاهِرِ
u'تَنْجِيسٌ فَمٌ':Added, #1: 1	تَنْجِيسُ الطَّاهِرِ
u'تَنْجِيسٌ قَلِيلٌ':Added, #1: 1	تَنْجِيسِ فَمِهِ
u'تَنْجِيسٌ مَاءٌ':Added, #1: 1	تَنْجِيسِ الْقَلِيلِ
u'تَنْجِيسٌ مَاءٌ':Added, #1: 1	تَنْجِيسَ الْمَاءِ
u'تَنْجِيسٌ مَاءٌ':Added, #1: 1	تَنْجِيسُ الْمَاءِ
u'تَنْجِيسٌ مَائِعٌ':Added, #4: 4	تَنْجِيسِ الْمَاءِ
u'تَنْجِيسٌ مَسْجِدٌ':Added, #1: 1	تَنْجِيسِ الْمَائِعَاتِ
u'تَنْجِيسٌ مَسْجِدٌ':Added, #1: 1	تَنْجِيسُ الْمَسْجِدِ
u'تَنْجِيسٌ نَهْرٌ':Added, #1: 1	تَنْجِيسِ الْمَسْجِدِ
u'تَنْجِيسٌ وَزَغٌ':Added, #1: 1	تَنْجِيسِ نَهْرٍ
u'تَنْجِيمٌ دِيَةٌ':Added, #1: 1	تَنْجِيسِ الْوَزَغِ
u'تَنَحْنَحَ إمَامٌ':Subject, #2: 2	تَنْجِيمِ الدِّيَةِ
u'تَنَحْنَحَ إمَامٌ':Subject, #1: 1	تَنَحْنَحَ الْإِمَامُ
u'تَنَحْنَحَ إمَامٌ':Subject, #1: 1	تَنَحْنَحَ إمَامٌ
u'تَنْحِيَةٌ الْمَرْأَةُ':Added, #1: 1	تَنَحْنَحَ إمَامُهُ
u'تَنْحِيَةٌ أَوَّلُ':Added, #1: 1	تَنْحِيَةِ الْمَرْأَةِ
u'تَنَحَّى عَبْدٌ':Subject, #1: 1	تَنْحِيَةِ الْأَوَّلِ
u'تَنَزُّلٌ رحمة':Added, #2: 2	تَنَحَّى عَبْدُ
u'تَنَزُّلٌ رَحْمَةٌ':Added, #1: 1	تَنَزُّلِ الرَّحْمَةِ
u'تَنَزَّلَ مُحَقِّقٌ':Subject, #1: 1	تَنَزُّلِ الرَّحْمَةِ
u'تَنَزَّلَ مُصَنِّفٌ':Subject, #1: 1	تَنَزَّلَ الْمُحَقِّقُ
u'تَنَزَّلَ مُطْلَقٌ':Subject, #1: 1	تَنَزَّلَ الْمُصَنِّفُ
u'تَنَزَّلَ مَنْزِلَةٌ':Predicate, #1: 1	تَنَزَّلَ الْمُطْلَقُ
u'تَنَزُّهٌ عَالِمٌ':Added, #1: 1	تَنَزَّلَ مَنْزِلَةَ
u'تَنْزِيلٌ اِبْنٌ':Added, #1: 1	تَنَزُّهِ الْعَالِمِ
u'تَنْزِيلٌ اِخْتِلاَفٌ':Added, #1: 1	تَنْزِيلِ ابْنِ
u'تَنْزِيلٌ اِخْتِلاَفٌ':Added, #1: 1	تَنْزِيلُ اخْتِلَافِ
u'تَنْزِيلٌ أَشْخَاصٌ':Added, #1: 1	تَنْزِيلِ اخْتِلَافِ
u'تَنْزِيلٌ إِطْلاقٌ':Added, #1: 1	تَنْزِيلِ الْأَشْخَاصِ
u'تَنْزِيلٌ إِطْلاقٌ':Added, #2: 2	تَنْزِيلُ إطْلَاقِ
u'تَنْزِيلٌ إقْرَارٌ':Added, #2: 2	تَنْزِيلُ الْإِطْلَاقِ
u'تَنْزِيلٌ إقْرَارٌ':Added, #1: 1	تَنْزِيلُ إقْرَارِ
u'تَنْزِيلٌ أَقْوَالٌ':Added, #2: 2	تَنْزِيلُ الْإِقْرَارِ
u'تَنْزِيلٌ أَلْفَاظٌ':Added, #1: 1	تَنْزِيلِ الْأَقْوَالِ
u'تَنْزِيلٌ أَلْفَاظٌ':Added, #1: 1	تَنْزِيلِ الْأَلْفَاظِ
u'تَنْزِيلٌ آيَةٌ':Added, #1: 1	تَنْزِيلِ أَلْفَاظِ
u'تَنْزِيلٌ آيَةٌ':Added, #1: 1	تَنْزِيلُ الْآيَةِ
u'تَنْزِيلٌ إِيجَابٌ':Added, #1: 1	تَنْزِيلِ الْآيَةِ
u'تَنْزِيلٌ جُزْئِيٌّ':Added, #1: 1	تَنْزِيلِ إيجَابِ
u'تَنْزِيلٌ جُزْئِيَّةٌ':Added, #1: 1	تَنْزِيلُ الْجُزْئِيَّاتِ
u'تَنْزِيلٌ جِهَةٌ':Added, #1: 1	تَنْزِيلُ الْجُزْئِيَّاتِ
u'تَنْزِيلٌ حادِثٌ':Added, #1: 1	تَنْزِيلَ جِهَاتِ
u'تَنْزِيلٌ دُخُولٌ':Added, #1: 1	تَنْزِيلُ الْحَادِثِ
u'تَنْزِيلٌ دَوامٌ':Added, #1: 1	تَنْزِيلُ الدُّخُولِ
u'تَنْزِيلٌ رَاجِعٌ':Added, #2: 2	تَنْزِيلُ الدَّوَامِ
u'تَنْزِيلٌ رُؤْيَةٌ':Added, #1: 1	تَنْزِيلَ الرَّاجِعِ
u'تَنْزِيلٌ زَعيمٌ':Added, #1: 1	تَنْزِيلُ رُؤْيَةِ
u'تَنْزِيلٌ سجدة':Added, #1: 1	تَنْزِيلُ الزَّعِيمِ
u'تَنْزِيلٌ سَجْدَةٌ':Added, #1: 1	تَنْزِيلُ السَّجْدَةِ
u'تَنْزِيلٌ سَهْمٌ':Added, #1: 1	تَنْزِيلُ السَّجْدَةِ
u'تَنْزِيلٌ طَلَبَةٌ':Added, #1: 1	تَنْزِيلُ السَّهْمِ
u'تَنْزِيلٌ طَلَبَةٌ':Added, #1: 1	تَنْزِيلُ الطَّلَبَةِ
u'تَنْزِيلٌ عَامٌّ':Added, #1: 1	تَنْزِيلِ طَلَبَةٍ
u'تَنْزِيلٌ عَامٌّ':Added, #1: 1	تَنْزِيلُ الْعَامِّ
u'تَنْزِيلٌ عَبْدٌ':Added, #1: 1	تَنْزِيلِ الْعَامِّ
u'تَنْزِيلٌ عَزِيزٌ':Added, #1: 1	تَنْزِيلِ الْعَبْدِ
u'تَنْزِيلٌ عِوَضٌ':Added, #1: 1	تَنْزِيلَ الْعَزِيزِ
u'تَنْزِيلٌ غَيْثٌ':Added, #1: 1	تَنْزِيلِ عِوَضِهِ
u'تَنْزِيلٌ فَرْعٌ':Added, #1: 1	تَنْزِيلُ الْغَيْثِ
u'تَنْزِيلٌ قُبْلَةٌ':Added, #1: 1	تَنْزِيلِ الْفَرْعِ
u'تَنْزِيلٌ قَرَابَةٌ':Added, #1: 1	تَنْزِيلِ الْقُبْلَةِ
u'تَنْزِيلٌ قُرْآنٌ':Added, #1: 1	تَنْزِيلُ الْقَرَابَةِ
u'تَنْزِيلٌ قَوْلٌ':Added, #1: 1	تَنْزِيلِ الْقُرْآنِ
u'تَنْزِيلٌ كِتَابٌ':Added, #1: 1	تَنْزِيلِ الْقَوْلَيْنِ
u'تَنْزِيلٌ كِتَابٌ':Added, #1: 1	تَنْزِيلِ الْكِتَابِ
u'تَنْزِيلٌ كِتَابٌ':Added, #1: 1	تَنْزِيلِ كِتَابِهِ
u'تَنْزِيلٌ كَلاَمٌ':Added, #4: 4	تَنْزِيلُ الْكِتَابِ
u'تَنْزِيلٌ كَلاَمٌ':Added, #1: 1	تَنْزِيلُ الْكَلَامِ
u'تَنْزِيلٌ كَلاَمٌ':Added, #1: 1	تَنْزِيلِ الْكَلَامِ
u'تَنْزِيلٌ كَلاَمٌ':Added, #1: 1	تَنْزِيلِ كَلَامِهِ
u'تَنْزِيلٌ كُلِّيٌّ':Added, #7: 7	تَنْزِيلُ كَلَامِ
u'تَنْزِيلٌ لَفْظٌ':Added, #1: 1	تَنْزِيلُ الْكُلِّيِّ
u'تَنْزِيلٌ لَفْظٌ':Added, #1: 1	تَنْزِيلُ اللَّفْظِ
u'تَنْزِيلٌ مُخَاطَبٌ':Added, #1: 1	تَنْزِيلُ لَفْظِ
u'تَنْزِيلٌ مَذْهَبٌ':Added, #1: 1	تَنْزِيلِ مُخَاطَبٍ
u'تَنْزِيلٌ مَسْخٌ':Added, #1: 1	تَنْزِيلِ مَذْهَبِهِ
u'تَنْزِيلٌ مُطَالَبٌ':Added, #1: 1	تَنْزِيلُ مَسْخِهِ
u'تَنْزِيلٌ مُطَالَبَةٌ':Added, #1: 1	تَنْزِيلِ الْمُطَالَبَةِ
u'تَنْزِيلٌ مُطْلَقٌ':Added, #1: 1	تَنْزِيلِ الْمُطَالَبَةِ
u'تَنْزِيلٌ مُطْلَقٌ':Added, #1: 1	تَنْزِيلِ الْمُطْلَقِ
u'تَنْزِيلٌ مَنْقُولٌ':Added, #1: 1	تَنْزِيلِ مُطْلَقِ
u'تَنْزِيلٌ نَاسٌ':Added, #1: 1	تَنْزِيلَ الْمَنْقُولِ
u'تَنْزِيلٌ نَاظِرٌ':Added, #1: 1	تَنْزِيلِ النَّاسِ
u'تَنْزِيلٌ نَاقِصٌ':Added, #2: 2	تَنْزِيلِ نَاظِرٍ
u'تَنْزِيلٌ نذر':Added, #1: 1	تَنْزِيلِ النَّاقِصِ
u'تَنْزِيلٌ نَذْرٌ':Added, #1: 1	تَنْزِيلُ نَذْرِهِ
u'تَنْزِيلٌ نَصْرٌ':Added, #1: 1	تَنْزِيلُ نَذْرِهِ
u'تَنْزِيلٌ نقل':Added, #1: 1	تَنْزِيلُ نَصْرِ
u'تَنْزِيلٌ نَقْلٌ':Added, #1: 1	تَنْزِيلَ النَّقْلِ
u'تَنْزِيلٌ وَجْهٌ':Added, #1: 1	تَنْزِيلَ النَّقْلِ
u'تَنْزِيلٌ وَصِيٌّ':Added, #1: 1	تَنْزِيلُ الْوَجْهَيْنِ
u'تَنْزِيلٌ وَصِيَّةٌ':Added, #2: 2	تَنْزِيلُ الْوَصِيَّةِ
u'تَنْزِيلٌ وَقَائِعُ':Added, #2: 2	تَنْزِيلُ الْوَصِيَّةِ
u'تَنْزِيلٌ وَقْفٌ':Added, #2: 2	تَنْزِيلَ الْوَقَائِعِ
u'تَنْزِيلٌ يَوْمٌ':Added, #1: 1	تَنْزِيلُ وَقْفِهِ
u'تَنْزِيهٌ أنبياء':Added, #1: 1	تَنْزِيلِ الْيَوْمِ
u'تَنْزِيهٌ حَقٌّ':Added, #1: 1	تَنْزِيهِ الْأَنْبِيَاءِ
u'تَنْزِيهٌ مَاءٌ':Added, #1: 1	تَنْزِيهِ الْحَقِّ
u'تَنْزِيهٌ مُسْتَحَبٌّ':Added, #1: 1	تَنْزِيهُ الْمَاءِ
u'تَنْزِيهٌ مَسْجِدٌ':Added, #1: 1	تَنْزِيهٍ مُسْتَحَبٍّ
u'تَنْزِيهٌ مَسْجِدٌ':Added, #1: 1	تَنْزِيهَ الْمَسْجِدِ
u'تَنْزِيهٌ مَكَانٌ':Added, #4: 4	تَنْزِيهُ الْمَسْجِدِ
u'تَنْزِيهٌ مَوَاضِعُ':Added, #1: 1	تَنْزِيهَ مَكَانِ
u'تَنْزِيهٌ نَبِيٌّ':Added, #1: 1	تَنْزِيهُ مَوَاضِعِ
u'تَنْزِيهٌ نَبِيٌّ':Added, #1: 1	تَنْزِيهُ النَّبِيِّ
u'تَنْزِيهٌ نَوَاظِرُ':Added, #1: 1	تَنْزِيهِ النَّبِيِّ
u'تَنْشِيفٌ أَعْضَاءٌ':Added, #1: 1	تَنْزِيهِ النَّوَاظِرِ
u'تَنْشِيفٌ بدن':Added, #4: 4	تَنْشِيفِ الْأَعْضَاءِ
u'تَنْشِيفٌ بَدَنٌ':Added, #1: 1	تَنْشِيفُ الْبَدَنِ
u'تَنْشِيفٌ مَاءٌ':Added, #1: 1	تَنْشِيفُ الْبَدَنِ
u'تَنَصُّبٌ جَمَلٌ':Added, #1: 1	تَنْشِيفُ الْمَاءِ
u'تَنَصَّرَ مَجُوسِيٌّ':Subject, #1: 1	تَنَصُّبَ الْجَمَلِ
u'تَنَصَّرَ يَهُودِيٌّ':Subject, #1: 1	تَنَصَّرَ الْمَجُوسِيُّ
u'تَنَصَّفَ أصل':Subject, #3: 3	تَنَصَّرَ يَهُودِيٌّ
u'تَنَصَّفَ أًصْلٌ':Subject, #1: 1	تَنَصَّفَ الْأَصْلُ
u'تَنَصُّفٌ أصل':Added, #1: 1	تَنَصَّفَ الْأَصْلُ
u'تَنَصُّفٌ أصل':Added, #1: 1	تَنَصُّفُ الْأَصْلِ
u'تَنَصُّفٌ أًصْلٌ':Added, #1: 1	تَنَصُّفِ الْأَصْلِ
u'تَنَصُّفٌ أًصْلٌ':Added, #1: 1	تَنَصُّفُ الْأَصْلِ
u'تَنَصُّفٌ أصل':Added, #1: 1	تَنَصُّفِ الْأَصْلِ
u'تَنَصُّفٌ أًصْلٌ':Added, #3: 3	تَنَصُّفَ الْأَصْلِ
u'تَنَصَّفَ حَدٌّ':Subject, #3: 3	تَنَصُّفَ الْأَصْلِ
u'تَنَصُّفٌ زِيادَةٌ':Added, #1: 1	تَنَصَّفَ حَدُّهُ
u'تَنَصُّفٌ صداق':Added, #2: 2	تَنَصُّفُ الزِّيَادَةِ
u'تَنَصُّفٌ صَدَاقٌ':Added, #1: 1	تَنَصُّفَ الصَّدَاقِ
u'تَنَصُّفٌ عين':Added, #1: 1	تَنَصُّفَ الصَّدَاقِ
u'تَنَصُّفٌ عَيْنٌ':Added, #1: 1	تَنَصُّفِ الْعَيْنِ
u'تَنَصُّفٌ عَيْن':Added, #1: 1	تَنَصُّفِ الْعَيْنِ
u'تَنَصَّفَ لَيْلٌ':Subject, #1: 1	تَنَصُّفِ الْعَيْنِ
u'تَنَصُّفٌ مَهْرٌ':Added, #1: 1	تَنَصَّفَ اللَّيْلُ
u'تَنَصُّفٌ مَهْرٌ':Added, #1: 1	تَنَصُّفِ الْمَهْرِ
u'تَنَصُّفٌ نعمة':Added, #2: 2	تَنَصُّفُ الْمَهْرِ
u'تَنَصُّفٌ نِعْمَةٌ':Added, #1: 1	تَنَصُّفِ النِّعْمَةِ
u'تَنَصَّلَ علماء':Subject, #1: 1	تَنَصُّفِ النِّعْمَةِ
u'تَنَصَّلَ عُلَمَاءُ':Subject, #1: 1	تَنَصَّلَ الْعُلَمَاءُ
u'تَنْصِيبٌ فَقِيهٌ':Added, #1: 1	تَنَصَّلَ الْعُلَمَاءُ
u'تَنْصِيفٌ أصل':Added, #1: 1	تَنْصِيبُ فَقِيهِ
u'تَنْصِيفٌ أصل':Added, #1: 1	تَنْصِيفُ الْأَصْلِ
u'تَنْصِيفٌ أًصْلٌ':Added, #1: 1	تَنْصِيفِ الْأَصْلِ
u'تَنْصِيفٌ أًصْلٌ':Added, #1: 1	تَنْصِيفُ الْأَصْلِ
u'تَنْصِيفٌ ألف':Added, #1: 1	تَنْصِيفِ الْأَصْلِ
u'تَنْصِيفٌ ألْفٌ':Added, #1: 1	تَنْصِيفُ الْأَلْفِ
u'تَنْصِيفٌ أَلْفٌ':Added, #1: 1	تَنْصِيفُ الْأَلْفِ
u'تَنْصِيفٌ حَدٌّ':Added, #1: 1	تَنْصِيفُ الْأَلْفِ
u'تَنْصِيفٌ حَدٌّ':Added, #1: 1	تَنْصِيفِ الْحَدِّ
u'تَنْصِيفٌ دِيَةٌ':Added, #1: 1	تَنْصِيفِ حَدِّ
u'تَنْصِيفٌ ركعة':Added, #1: 1	تَنْصِيفِ الدِّيَةِ
u'تَنْصِيفٌ رَكْعَةٌ':Added, #2: 2	تَنْصِيفَ الرَّكْعَةِ
u'تَنْصِيفٌ صداق':Added, #2: 2	تَنْصِيفَ الرَّكْعَةِ
u'تَنْصِيفٌ صَدَاقٌ':Added, #1: 1	تَنْصِيفِ الصَّدَاقِ
u'تَنْصِيفٌ صَلاَةٌ':Added, #1: 1	تَنْصِيفِ الصَّدَاقِ
u'تَنْصِيفٌ ظُهْرٌ':Added, #1: 1	تَنْصِيفُ الصَّلَاةِ
u'تَنْصِيفٌ قِيمَةٌ':Added, #1: 1	تَنْصِيفُ الظُّهْرِ
u'تَنْصِيفٌ مُتَعَدِّدٌ':Added, #1: 1	تَنْصِيفِ الْقِيمَةِ
u'تَنْصِيفٌ مَهْرٌ':Added, #1: 1	تَنْصِيفِ الْمُتَعَدِّدِ
u'تَنْصِيفٌ نِعَمٌ':Added, #2: 2	تَنْصِيفِ الْمَهْرِ
u'تَنْصِيفٌ نعمة':Added, #2: 2	تَنْصِيفِ النِّعَمِ
u'تَنْصِيفٌ نِعْمَةٌ':Added, #2: 2	تَنْصِيفِ النِّعْمَةِ
u'تَنْصِيفٌ نَفَقَةٌ':Added, #2: 2	تَنْصِيفِ النِّعْمَةِ
u'تَنْظِيرٌ صَاحِبٌ':Added, #1: 1	تَنْصِيفُ نَفَقَتِهِ
u'تَنْظِيفٌ آلةٌ':Added, #1: 1	تَنْظِيرَ صَاحِبِ
u'تَنْظِيفٌ حَمَّامٌ':Added, #1: 1	تَنْظِيفُ الْآلَةِ
u'تَنْظِيفٌ عَانَةٌ':Added, #2: 2	تَنْظِيفُ الْحَمَّامِ
u'تَنْظِيفٌ مَسَاجِدُ':Added, #1: 1	تَنْظِيفَ الْعَانَةِ
u'تَنْظِيفٌ مَسْجِدٌ':Added, #1: 1	تَنْظِيفِ الْمَسَاجِدِ
u'تَنْظِيفٌ مَكَانٌ':Added, #1: 1	تَنْظِيفَ الْمَسْجِدِ
u'تَنْظِيفٌ نعمة':Added, #1: 1	تَنْظِيفُ الْمَكَانِ
u'تَنْظِيفٌ نِعْمَةٌ':Added, #1: 1	تَنْظِيفِ النِّعْمَةِ
u'تَنْظِيفٌ يَدٌ':Added, #1: 1	تَنْظِيفِ النِّعْمَةِ
u'تَنَعَّمَ سَيِّدٌ':Subject, #1: 1	تَنْظِيفُ الْيَدَيْنِ
u'تَنْعِيمٌ أَرْواحٌ':Added, #1: 1	تَنَعَّمَ السَّيِّدُ
u'تَنَغَّصَ طِيبٌ':Subject, #1: 1	تَنْعِيمِ الْأَرْوَاحِ
u'تَنْغِيصٌ عَيْشٌ':Added, #1: 1	تَنَغَّصَ طِيبُهُ
u'تَنَفُّسٌ أَجَلٌ':Added, #1: 1	تَنْغِيصِ الْعَيْشِ
u'تَنَفَّسَ إمَامٌ':Subject, #1: 1	تَنَفُّسَ الْأَجَلِ
u'تَنَفَّسَ ثَلاثُ':Predicate, #1: 1	تَنَفَّسَ الْإِمَامُ
u'تَنَفَّسَ رحم':Subject, #1: 1	تَنَفَّسَ ثَلاثَ
u'تَنَفَّسَ رَحِمٌ':Subject, #6: 6	تَنَفَّسَ الرَّحِمُ
u'تَنَفُّسٌ رحم':Added, #6: 6	تَنَفَّسَ الرَّحِمُ
u'تَنَفُّسٌ رَحِمٌ':Added, #3: 3	تَنَفُّسِ الرَّحِمِ
u'تَنَفُّسٌ وَعِيٌّ':Added, #3: 3	تَنَفُّسِ الرَّحِمِ
u'تَنَفَّطَ جَسَدٌ':Subject, #2: 2	تَنَفُّسٍ وَعِيٍّ
u'تَنَفُّطٌ يَدٌ':Added, #1: 1	تَنَفَّطَ جَسَدُهُ
u'تَنَفَّلَ رَسُولٌ':Subject, #1: 1	تَنَفُّطُ الْيَدِ
u'تَنْفِيذٌ أَحْكَامٌ':Added, #3: 3	تَنَفَّلَ رَسُولُ
u'تَنْفِيذٌ أَحْكَامٌ':Added, #1: 1	تَنْفِيذَ الْأَحْكَامِ
u'تَنْفِيذٌ أَحْكَامٌ':Added, #1: 1	تَنْفِيذُ الْأَحْكَامِ
u'تَنْفِيذٌ أَحْكَامٌ':Added, #1: 1	تَنْفِيذِ الْأَحْكَامِ
u'تَنْفِيذٌ أمَانَةٌ':Added, #2: 2	تَنْفِيذِ أَحْكَامِهِ
u'تَنْفِيذٌ أَمْرٌ':Added, #1: 1	تَنْفِيذِ الْأَمَانَةِ
u'تَنْفِيذٌ أُمُورٌ':Added, #1: 1	تَنْفِيذُ أَمْرِهِ
u'تَنْفِيذٌ أُمُورٌ':Added, #1: 1	تَنْفِيذَ الْأُمُورِ
u'تَنْفِيذٌ بَعْضٌ':Added, #2: 2	تَنْفِيذِ الْأُمُورِ
u'تَنْفِيذٌ بَيْعٌ':Added, #1: 1	تَنْفِيذِ بَعْضِ
u'تَنْفِيذٌ تَصَرُّفٌ':Added, #2: 2	تَنْفِيذَ الْبَيْعِ
u'تَنْفِيذٌ ثَمَنٌ':Added, #1: 1	تَنْفِيذَ تَصَرُّفِهِ
u'تَنْفِيذٌ حاكِمٌ':Added, #1: 1	تَنْفِيذُ ثَمَنِهِ
u'تَنْفِيذٌ حاكِمٌ':Added, #1: 1	تَنْفِيذَ الْحَاكِمِ
u'تَنْفِيذٌ حُكْمٌ':Added, #1: 1	تَنْفِيذُ الْحَاكِمِ
u'تَنْفِيذٌ حُكْمٌ':Added, #1: 1	تَنْفِيذُ حُكْمِ
u'تَنْفِيذٌ حُكْمٌ':Added, #2: 2	تَنْفِيذَ الْحُكْمِ
u'تَنْفِيذٌ حُكْمٌ':Added, #2: 2	تَنْفِيذِ الْحُكْمِ
u'تَنْفِيذٌ حُكْمٌ':Added, #2: 2	تَنْفِيذِ حُكْمِ
u'تَنْفِيذٌ حُكْمٌ':Added, #3: 3	تَنْفِيذُ حُكْمِهِ
u'تَنْفِيذٌ رُجُوعٌ':Added, #4: 4	تَنْفِيذُ الْحُكْمِ
u'تَنْفِيذٌ سَائِرٌ':Added, #1: 1	تَنْفِيذُ رُجُوعِهِ
u'تَنْفِيذٌ سَلَمٌ':Added, #1: 1	تَنْفِيذُ سَائِرِ
u'تَنْفِيذٌ شَرْطٌ':Added, #1: 1	تَنْفِيذِ السَّلَمِ
u'تَنْفِيذٌ شَرْطٌ':Added, #1: 1	تَنْفِيذَ الشَّرْطِ
u'تَنْفِيذٌ شَهَادَةٌ':Added, #1: 1	تَنْفِيذَ شَرْطِ
u'تَنْفِيذٌ صدقة':Added, #1: 1	تَنْفِيذَ شَهَادَةِ
u'تَنْفِيذٌ صَدَقَةٌ':Added, #1: 1	تَنْفِيذِ الصَّدَقَةِ
u'تَنْفِيذٌ عتق':Added, #1: 1	تَنْفِيذِ الصَّدَقَةِ
u'تَنْفِيذٌ عِتْقٌ':Added, #1: 1	تَنْفِيذَ الْعِتْقِ
u'تَنْفِيذٌ عتق':Added, #1: 1	تَنْفِيذَ الْعِتْقِ
u'تَنْفِيذٌ عتق':Added, #1: 1	تَنْفِيذَ عِتْقِ
u'تَنْفِيذٌ عِتْقٌ':Added, #1: 1	تَنْفِيذِ عِتْقِ
u'تَنْفِيذٌ عِتْقٌ':Added, #1: 1	تَنْفِيذَ عِتْقِ
u'تَنْفِيذٌ عتق':Added, #1: 1	تَنْفِيذِ عِتْقِ
u'تَنْفِيذٌ عِتْقٌ':Added, #2: 2	تَنْفِيذُ الْعِتْقِ
u'تَنْفِيذٌ عَقْدٌ':Added, #2: 2	تَنْفِيذُ الْعِتْقِ
u'تَنْفِيذٌ فِعْلٌ':Added, #2: 2	تَنْفِيذِ الْعَقْدِ
u'تَنْفِيذٌ قَصْدٌ':Added, #1: 1	تَنْفِيذَ الْفِعْلِ
u'تَنْفِيذٌ قول':Added, #2: 2	تَنْفِيذُ قَصْدِهِ
u'تَنْفِيذٌ قَوْلٌ':Added, #1: 1	تَنْفِيذِ قَوْلِهِ
u'تَنْفِيذٌ قول':Added, #1: 1	تَنْفِيذِ قَوْلِهِ
u'تَنْفِيذٌ قَوْلٌ':Added, #3: 3	تَنْفِيذُ قَوْلِ
u'تَنْفِيذٌ قول':Added, #3: 3	تَنْفِيذُ قَوْلِ
u'تَنْفِيذٌ قَوْلٌ':Added, #4: 4	تَنْفِيذُ الْقَوْلِ
u'تَنْفِيذٌ كَفَّارٌ':Added, #4: 4	تَنْفِيذُ الْقَوْلِ
u'تَنْفِيذٌ كَفَّارَةٌ':Added, #2: 2	تَنْفِيذِ الْكَفَّارَاتِ
u'تَنْفِيذٌ مَقَادِيرُ':Added, #2: 2	تَنْفِيذِ الْكَفَّارَاتِ
u'تَنْفِيذٌ نَبْلٌ':Added, #1: 1	تَنْفِيذِ الْمَقَادِيرِ
u'تَنْفِيذٌ نكاح':Added, #1: 1	تَنْفِيذَ النَّبْلِ
u'تَنْفِيذٌ نِكَاحٌ':Added, #1: 1	تَنْفِيذِ النِّكَاحِ
u'تَنْفِيذٌ نكاح':Added, #1: 1	تَنْفِيذِ النِّكَاحِ
u'تَنْفِيذٌ نِكَاحٌ':Added, #1: 1	تَنْفِيذِ نِكَاحِ
u'تَنْفِيذٌ هِبَةٌ':Added, #1: 1	تَنْفِيذِ نِكَاحِ
u'تَنْفِيذٌ وَارِثٌ':Added, #6: 6	تَنْفِيذُ الْهِبَةِ
u'تَنْفِيذٌ وَصِيٌّ':Added, #1: 1	تَنْفِيذَ الْوَارِثِ
u'تَنْفِيذٌ وَصِيٌّ':Added, #10: 10	تَنْفِيذُ الْوَصِيَّةِ
u'تَنْفِيذٌ وَصِيٌّ':Added, #14: 14	تَنْفِيذِ الْوَصِيَّةِ
u'تَنْفِيذٌ وَصِيٌّ':Added, #1: 1	تَنْفِيذِ الْوَصِيِّ
u'تَنْفِيذٌ وَصِيٌّ':Added, #1: 1	تَنْفِيذَ وَصِيَّتِهِ
u'تَنْفِيذٌ وَصِيٌّ':Added, #2: 2	تَنْفِيذَ الْوَصِيَّتَيْنِ
u'تَنْفِيذٌ وَصِيٌّ':Added, #4: 4	تَنْفِيذُ وَصِيَّتِهِ
u'تَنْفِيذٌ وَصِيَّةٌ':Added, #6: 6	تَنْفِيذَ الْوَصِيَّةِ
u'تَنْفِيذٌ وَصِيَّةٌ':Added, #10: 10	تَنْفِيذُ الْوَصِيَّةِ
u'تَنْفِيذٌ وَصِيَّةٌ':Added, #14: 14	تَنْفِيذِ الْوَصِيَّةِ
u'تَنْفِيذٌ وَصِيَّةٌ':Added, #1: 1	تَنْفِيذَ وَصِيَّتِهِ
u'تَنْفِيذٌ وَصِيَّةٌ':Added, #4: 4	تَنْفِيذُ وَصِيَّتِهِ
u'تَنْفِيذٌ يَمِينٌ':Added, #6: 6	تَنْفِيذَ الْوَصِيَّةِ
u'تَنْفِيرٌ جَمَاعَةٌ':Added, #1: 1	تَنْفِيذَ الْيَمِينِ
u'تَنْفِيرٌ حَمَامٌ':Added, #2: 2	تَنْفِيرَ الْجَمَاعَةِ
u'تَنْفِيرٌ صَيْدٌ':Added, #1: 1	تَنْفِيرُ الْحَمَامِ
u'تَنْفِيرٌ صَيْدٌ':Added, #1: 1	تَنْفِيرِ الصَّيْدِ
u'تَنْفِيرٌ صَيْدٌ':Added, #1: 1	تَنْفِيرُ صَيْدِهِ
u'تَنْفِيرٌ صَيْدٌ':Added, #1: 1	تَنْفِيرِ صَيْدِهِ
u'تَنْفِيرٌ قَوْمٌ':Added, #3: 3	تَنْفِيرِ صَيْدِ
u'تَنْفِيرٌ قَوْمٌ':Added, #1: 1	تَنْفِيرُ الْقَوْمِ
u'تَنْفِيضٌ أَصابِعُ':Added, #2: 2	تَنْفِيرِ الْقَوْمِ
u'تَنْفِيلٌ إمَامٌ':Added, #1: 1	تَنْفِيضُ الْأَصَابِعِ
u'تَنْفِيلٌ سَرِيٌّ':Added, #3: 3	تَنْفِيلِ الْإِمَامِ
u'تَنْفِيلٌ سَرِيَّةٌ':Added, #1: 1	تَنْفِيلُ السَّرِيَّةِ
u'تَنَقَّصَ نَبِيٌّ':Predicate, #1: 1	تَنْفِيلُ السَّرِيَّةِ
u'تَنَقُّلٌ عَادَةٌ':Added, #1: 1	تَنَقَّصَ النَّبِيَّ
u'تَنْقِيحٌ أُصولٌ':Added, #1: 1	تَنَقُّلِ الْعَادَةِ
u'تَنْقِيحٌ أَقْوَالٌ':Added, #1: 1	تَنْقِيحِ الْأُصُولِ
u'تَنْقِيحٌ خِلاَفٌ':Added, #5: 5	تَنْقِيحِ الْأَقْوَالِ
u'تَنْقِيحٌ ضَابِطٌ':Added, #1: 1	تَنْقِيحِ الْخِلَافِ
u'تَنْقِيحٌ فلان':Added, #1: 1	تَنْقِيحُ ضَابِطٍ
u'تَنْقِيحٌ قول':Added, #1: 1	تَنْقِيحِ الْحَامِدِيَّةِ
u'تَنْقِيحٌ قَوْلٌ':Added, #1: 1	تَنْقِيحِ قَوْلِ
u'تَنْقِيحٌ لُبَابٌ':Added, #1: 1	تَنْقِيحِ قَوْلِ
u'تَنْقِيحٌ مَحْصُولٌ':Added, #4: 4	تَنْقِيحِ اللُّبَابِ
u'تَنْقِيحٌ مَحَلٌّ':Added, #5: 5	تَنْقِيحِ الْمَحْصُولِ
u'تَنْقِيحٌ مَنَاطٌ':Added, #1: 1	تَنْقِيحُ مَحَلِّ
u'تَنْقِيحٌ مَنَاطٌ':Added, #1: 1	تَنْقِيحُ مَنَاطٍ
u'تَنْقِيحٌ مَنَاطٌ':Added, #1: 1	تَنْقِيحِ مَنَاطِ
u'تَنْقِيحٌ مَنَاطٌ':Added, #2: 2	تَنْقِيحِ الْمَنَاطِ
u'تَنْقِيحٌ مَنَاطٌ':Added, #2: 2	تَنْقِيحَ مَنَاطٍ
u'تَنْقِيحٌ مَنَاطٌ':Added, #5: 5	تَنْقِيحُ الْمَنَاطِ
u'تَنْقِيحٌ وَسِيطٌ':Added, #8: 8	تَنْقِيحَ الْمَنَاطِ
u'تَنْقِيصٌ أَجْرٌ':Added, #3: 3	تَنْقِيحِ الْوَسِيطِ
u'تَنْقِيصٌ أَحْجارٌ':Added, #1: 1	تَنْقِيصِ أَجْرِ
u'تَنْقِيصٌ حَظٌّ':Added, #1: 1	تَنْقِيصِ الْأَحْجَارِ
u'تَنْقِيصٌ شَخْصٌ':Added, #1: 1	تَنْقِيصَ حَظِّ
u'تَنْقِيصٌ صَحَابَةٌ':Added, #1: 1	تَنْقِيصَ شَخْصٍ
u'تَنْقِيصٌ عَدَدٌ':Added, #1: 1	تَنْقِيصِ الصَّحَابَةِ
u'تَنْقِيصٌ عَدَدٌ':Added, #1: 1	تَنْقِيصِ عَدَدِهِ
u'تَنْقِيصٌ قَدْرٌ':Added, #2: 2	تَنْقِيصُ الْعَدَدِ
u'تَنْقِيصٌ قيام':Added, #1: 1	تَنْقِيصُ الْقَدْرِ
u'تَنْقِيصٌ قِيَامٌ':Added, #1: 1	تَنْقِيصُ الْقِيَامِ
u'تَنْقِيصٌ قِيمَةٌ':Added, #1: 1	تَنْقِيصُ الْقِيَامِ
u'تَنْقِيصٌ قِيمَةٌ':Added, #1: 1	تَنْقِيصِ الْقِيمَةِ
u'تَنْقِيصٌ مَالٌ':Added, #1: 1	تَنْقِيصُ قِيمَةِ
u'تَنْقِيصٌ مَذْهَبٌ':Added, #1: 1	تَنْقِيصِ الْمَالِ
u'تَنْقِيصٌ مِقْدَارٌ':Added, #1: 1	تَنْقِيصَ مَذْهَبِ
u'تَنْقِيصٌ وَرَثَةٌ':Added, #1: 1	تَنْقِيصَ مِقْدَارِهِ
u'تَنَكُّبٌ لَفْظٌ':Added, #1: 1	تَنْقِيصِ الْوَرَثَةِ
u'تَنْكِيرٌ سَابِقٌ':Added, #1: 1	تَنَكُّبُ اللَّفْظِ
u'تَنْكِيرٌ سلام':Added, #1: 1	تَنْكِيرٍ سَابِقٍ
u'تَنْكِيرٌ سلام':Added, #1: 1	تَنْكِيرُ السَّلَامِ
u'تَنْكِيرٌ سَلاَمٌ':Added, #1: 1	تَنْكِيرِ السَّلَامِ
u'تَنْكِيرٌ سَلاَمٌ':Added, #1: 1	تَنْكِيرُ السَّلَامِ
u'تَنْكِيرٌ سلام':Added, #1: 1	تَنْكِيرِ السَّلَامِ
u'تَنْكِيرٌ سَلاَمٌ':Added, #1: 1	تَنْكِيرِ سَلَامِ
u'تَنْكِيرٌ صدقة':Added, #1: 1	تَنْكِيرِ سَلَامِ
u'تَنْكِيرٌ صَدَقَةٌ':Added, #1: 1	تَنْكِيرِ صَدَقَةٍ
u'تَنْكِيسٌ رَأْسٌ':Added, #1: 1	تَنْكِيرِ صَدَقَةٍ
u'تَنْكِيسٌ رِدَاءٌ':Added, #1: 1	تَنْكِيسُ الرَّأْسِ
u'تَنْكِيسٌ سنن':Added, #1: 1	تَنْكِيسِ الرِّدَاءِ
u'تَنْكِيسٌ سورٌ':Added, #1: 1	تَنْكِيسِ السُّنَنِ
u'تَنْكِيسٌ فِعْلٌ':Added, #1: 1	تَنْكِيسُ السُّوَرِ
u'تَنْكِيسٌ وُضُوءٌ':Added, #1: 1	تَنْكِيسُ الْفِعْلِ
u'تَنْمِيَةٌ مَالٌ':Added, #1: 1	تَنْكِيسِ الْوُضُوءِ
u'تَنْمِيَةٌ مَالٌ':Added, #1: 1	تَنْمِيَةُ مَالِهِ
u'تَنَوَّعَ جِنْسٌ':Subject, #2: 2	تَنْمِيَةِ الْمَالِ
u'تَنَوَّعَ حالٌ':Subject, #1: 1	تَنَوَّعَ جِنْسُهُ
u'تَنَوُّعٌ سِكَّةٌ':Added, #1: 1	تَنَوَّعَ حَالُهُ
u'تَنَوَّعَ عَيْبٌ':Subject, #1: 1	تَنَوُّعُ سِكَّةٍ
u'تَنَوَّعَ مَحَلٌّ':Subject, #1: 1	تَنَوَّعَ الْعَيْبُ
u'تَنْوِيرٌ أَبْصارٌ':Added, #1: 1	تَنَوَّعَ مَحَلُّ
u'تَنْوِيرٌ بَصائِرُ':Added, #10: 10	تَنْوِيرِ الْأَبْصَارِ
u'تَنْوِيرٌ سَاقٌ':Added, #1: 1	تَنْوِيرِ الْبَصَائِرِ
u'تَنْوِيرٌ مَجْمُوعٌ':Added, #1: 1	تَنْوِيرَ السَّاقِ
u'تَنْوِيعٌ إيقَاعٌ':Added, #1: 1	تَنْوِيرُ الْمَجْمُوعِ
u'تَنْوِيعٌ تِجَارَةٌ':Added, #1: 1	تَنْوِيعِ الْإِيقَاعِ
u'تَنْوِيعٌ جَزَاءٌ':Added, #1: 1	تَنْوِيعِ التِّجَارَةِ
u'تَنْوِيعٌ حَلالٌ':Added, #1: 1	تَنْوِيعِ الْجَزَاءِ
u'تَنْوِيعٌ غِذَاءٌ':Added, #1: 1	تَنْوِيعِ الْحَلَالِ
u'تَنْوِينٌ إلَهٌ':Added, #1: 1	تَنْوِيعِ الْغِذَاءِ
u'تَنْوِينٌ علم':Added, #1: 1	تَنْوِينُ إلَهٍ
u'تَنْوِينٌ عَلَمٌ':Added, #2: 2	تَنْوِينِ الْعَلَمِ
u'تَنْوِينٌ غُرَّةٌ':Added, #2: 2	تَنْوِينِ الْعَلَمِ
u'تَنْوِينٌ نِصْفٌ':Added, #1: 1	تَنْوِينِ غُرَّةٍ
u'تَهَجُّدٌ لَيْلٌ':Added, #1: 1	تَنْوِينَ نِصْفٍ
u'تَهَدَّمَ بِنَاءٌ':Subject, #1: 1	تَهَجُّدَ اللَّيْلِ
u'تَهَدَّمَ بُنْيانٌ':Subject, #1: 1	تَهَدَّمَ الْبِنَاءُ
u'تَهْدِيدٌ الْمَرْأَةُ':Added, #1: 1	تَهَدَّمَ الْبُنْيَانُ
u'تَهْدِيدٌ طَمْس':Added, #1: 1	تَهْدِيدُ الْمَرْأَةِ
u'تَهْدِيدٌ غير':Added, #1: 1	تَهْدِيدُ الطَّمْسِ
u'تَهْدِيدٌ غَيْرٌ':Added, #1: 1	تَهْدِيدِ غَيْرِهِ
u'تَهْدِيدٌ قَادِرٌ':Added, #1: 1	تَهْدِيدِ غَيْرِهِ
u'تَهْذِيبٌ اِبْنٌ':Added, #2: 2	تَهْدِيدِ قَادِرٍ
u'تَهْذِيبٌ آثَارٌ':Added, #1: 1	تَهْذِيبِ ابْنِ
u'تَهْذِيبٌ أَجْوِبَةٌ':Added, #3: 3	تَهْذِيبِ الْآثَارِ
u'تَهْذِيبٌ أَسْماءٌ':Added, #12: 12	تَهْذِيبِ الْأَجْوِبَةِ
u'تَهْذِيبٌ أُصولٌ':Added, #6: 6	تَهْذِيبِ الْأَسْمَاءِ
u'تَهْذِيبٌ ذِئْبٌ':Added, #1: 1	تَهْذِيبَ الْأُصُولِ
u'تَهْذِيبٌ كَمَالٌ':Added, #1: 1	تَهْذِيبُ الذِّئْبِ
u'تَهْذِيبٌ لُغَةٌ':Added, #1: 1	تَهْذِيبِ الْكَمَالِ
u'تَهْذِيبٌ نَفْسٌ':Added, #1: 1	تَهْذِيبِ اللُّغَاتِ
u'تَهْذِيبٌ نَوَوِيٌّ':Added, #1: 1	تَهْذِيبَ نَفْسِهِ
u'تَهْرِيقٌ دَمٌ':Added, #1: 1	تَهْذِيبِ النَّوَوِيِّ
u'تَهَشَّمَ رَأْسٌ':Subject, #1: 1	تَهْرِيقُ الدَّمِ
u'تَهَلُّلٌ وَجْهٌ':Added, #1: 1	تَهَشَّمَ رَأْسُهُ
u'تَهْنِئَةٌ أهْلٌ':Added, #2: 2	تَهَلُّلِ وَجْهِهِ
u'تَهَوَّدَ أصل':Subject, #1: 1	تَهْنِئَةُ أَهْلِ
u'تَهَوَّدَ أًصْلٌ':Subject, #1: 1	تَهَوَّدَ أَصْلُهُ
u'تَهَوَّدَ نَصْرَانِيٌّ':Subject, #1: 1	تَهَوَّدَ أَصْلُهُ
u'تَهْوِينٌ أخفُّ':Added, #4: 4	تَهَوَّدَ نَصْرَانِيٌّ
u'تَهْوِينٌ مُصِيبٌ':Added, #1: 1	تَهْوِينِ أَخَفِّ
u'تَهْوِينٌ مُصِيبَةٌ':Added, #1: 1	تَهْوِينُ الْمُصِيبَةِ
u'تَهَيَّأَ نَاسٌ':Subject, #1: 1	تَهْوِينُ الْمُصِيبَةِ
u'تَهْيِيجٌ شَرٌّ':Added, #2: 2	تَهَيَّأَ النَّاسُ
u'تَهْيِيجٌ فتنة':Added, #3: 3	تَهْيِيجُ الشَّرِّ
u'تَهْيِيجٌ فِتْنَةٌ':Added, #1: 1	تَهْيِيجِ الْفِتْنَةِ
u'تَهْيِيجٌ نُفُوسٌ':Added, #1: 1	تَهْيِيجِ الْفِتْنَةِ
u'تَوَاتُرٌ أخْبَارٌ':Added, #1: 1	تَهْيِيجِ النُّفُوسِ
u'تَوَاتُرٌ أَخْبَارٌ':Added, #2: 2	تَوَاتُرَ الْأَخْبَارِ
u'تَوَاتُرٌ أخْبَارٌ':Added, #2: 2	تَوَاتُرَ الْأَخْبَارِ
u'تَوَاتُرٌ أَخْبَارٌ':Added, #6: 6	تَوَاتُرِ الْأَخْبَارِ
u'تَوَاتُرٌ اِسْتِدْلاَلٌ':Added, #6: 6	تَوَاتُرِ الْأَخْبَارِ
u'تَوَاتَرَ تَعْظِيمٌ':Subject, #1: 1	تَوَاتُرُ اسْتِدْلَالَاتِ
u'تَوَاتُرٌ حَرَكَةٌ':Added, #1: 1	تَوَاتَرَ تَعْظِيمُ
u'تَوَاتَرَ خَبَرٌ':Subject, #1: 1	تَوَاتُرُ حَرَكَاتِهِ
u'تَوَاتَرَ خَبَر':Subject, #3: 3	تَوَاتَرَ الْخَبَرُ
u'تَوَاتُرٌ خَبَرٌ':Added, #3: 3	تَوَاتَرَ الْخَبَرُ
u'تَوَاتُرٌ خَبَرٌ':Added, #1: 1	تَوَاتُرَ الْخَبَرِ
u'تَوَاتُرٌ خَبَرٌ':Added, #1: 1	تَوَاتُرُ الْخَبَرِ
u'تَوَاتُرٌ خَبَر':Added, #1: 1	تَوَاتُرِ الْخَبَرِ
u'تَوَاتُرٌ خَبَر':Added, #1: 1	تَوَاتُرَ الْخَبَرِ
u'تَوَاتُرٌ خَبَر':Added, #1: 1	تَوَاتُرُ الْخَبَرِ
u'تَوَاتُرٌ رِواياتٌ':Added, #1: 1	تَوَاتُرِ الْخَبَرِ
u'تَوَاتُرٌ سَبْعٌ':Added, #1: 1	تَوَاتُرُ الرِّوَايَاتِ
u'تَوَاتُرٌ عَمَلٌ':Added, #1: 1	تَوَاتُرَ السَّبْعِ
u'تَوَاتَرَ فَضْلٌ':Subject, #1: 1	تَوَاتُرُ الْعَمَلِ
u'تَوَاتُرٌ كُفَّارٌ':Added, #1: 1	تَوَاتَرَ الْفَضْلُ
u'تَوَاتَرَ كَوْنٌ':Subject, #1: 1	تَوَاتُرُ الْكُفَّارِ
u'تَوَاتُرٌ كَوْنٌ':Added, #3: 3	تَوَاتَرَ كَوْنُهُ
u'تَوَاتُرٌ مُشْتَرَكٌ':Added, #1: 1	تَوَاتُرُ كَوْنِهِ
u'تَوَاتُرٌ مَشْهُورٌ':Added, #1: 1	تَوَاتُرِ الْمُشْتَرَكِ
u'تَوَاتُرٌ مُنَاقِضٌ':Added, #1: 1	تَوَاتُرِ الْمَشْهُورِ
u'تَوَاتُرٌ مَنْقُولٌ':Added, #1: 1	تَوَاتُرِ مُنَاقِضٍ
u'تَوَاتَرَ نَصٌّ':Subject, #1: 1	تَوَاتُرُ الْمَنْقُولِ
u'تَوَاتَرَ نقل':Subject, #2: 2	تَوَاتَرَ النَّصُّ
u'تَوَاتَرَ نَقْلٌ':Subject, #1: 1	تَوَاتَرَ النَّقْلُ
u'تَوَاتَرَ نقل':Subject, #1: 1	تَوَاتَرَ النَّقْلُ
u'تَوَاتَرَ نَقْلٌ':Subject, #1: 1	تَوَاتَرَ نَقْلُ
u'تَوَارُثٌ فَهْمٌ':Added, #1: 1	تَوَاتَرَ نَقْلُ
u'تَوَارُثٌ كُفَّارٌ':Added, #1: 1	تَوَارُثُ فَهْمِ
u'تَوَارُثٌ كُفَّارٌ':Added, #1: 1	تَوَارُثُ الْكُفَّارِ
u'تَوَارُدٌ إِثْبَاتٌ':Added, #1: 1	تَوَارُثِ الْكُفَّارِ
u'تَوَارُدٌ إِثْبَاتٌ':Added, #1: 1	تَوَارُدُ الْإِثْبَاتِ
u'تَوَارُدٌ أَفْهَامٌ':Added, #1: 1	تَوَارُدِ الْإِثْبَاتِ
u'تَوَارُدٌ أَمْرٌ':Added, #1: 1	تَوَارُدَ الْأَفْهَامِ
u'تَوَارَدَ شُرُوحٌ':Subject, #1: 1	تَوَارُدِ الْأَمْرِ
u'تَوَارَدَ شُعرَاءُ':Subject, #1: 1	تَوَارَدَ شُرُوحُ
u'تَوَارَدَ شُعَرَاءُ':Subject, #1: 1	تَوَارَدَ الشُّعَرَاءُ
u'تَوَارُدٌ عَقْدٌ':Added, #1: 1	تَوَارَدَ الشُّعَرَاءُ
u'تَوَارُدٌ عُقُودٌ':Added, #1: 1	تَوَارُدِ الْعَقْدَيْنِ
u'تَوَارُدٌ عِلَلٌ':Added, #1: 1	تَوَارُدِ الْعُقُودِ
u'تَوَارُدٌ مُطْلَقٌ':Added, #1: 1	تَوَارُدُ الْعِلَلِ
u'تَوَارَدَ مِلْكٌ':Subject, #1: 1	تَوَارُدُ الْمُطْلَقِ
u'تَوَارُدٌ نَفْيٌ':Added, #1: 1	تَوَارَدَ مِلْكُهُ
u'تَوَارَى بَعْضٌ':Subject, #1: 1	تَوَارُدُ النَّفْيِ
u'تَوَارِي حَشَفَةٌ':Added, #2: 2	تَوَارَى بَعْضُ
u'تَوَارَى خَصْمٌ':Subject, #1: 1	تَوَارِي الْحَشَفَةِ
u'تَوَارَى شفق':Subject, #5: 5	تَوَارَى الْخَصْمُ
u'تَوَارَى شَفَقٌ':Subject, #1: 1	تَوَارَى الشَّفَقُ
u'تَوَارِي صَيْدٌ':Added, #1: 1	تَوَارَى الشَّفَقُ
u'تَوَارَى طَالِبٌ':Subject, #1: 1	تَوَارِي الصَّيْدِ
u'تَوَارَى قَاتِلٌ':Subject, #1: 1	تَوَارَى الطَّالِبُ
u'تَوَارَى قَالٌ':Predicate, #1: 1	تَوَارَى الْقَاتِلُ
u'تَوَارَى كَلْبٌ':Subject, #1: 1	تَوَارَى قَالَ
u'تَوَاصَلَ بَذْرٌ':Subject, #1: 1	تَوَارَى الْكَلْبُ
u'تَوَاصَلَ بَذْرٌ':Subject, #1: 1	تَوَاصَلَ بَذْرٌ
u'تَوَاصُلٌ حَرَكَةٌ':Added, #1: 1	تَوَاصَلَ بَذْرُ
u'تَوَاصُلٌ فِعْلٌ':Added, #1: 1	تَوَاصُلِ الْحَرَكَاتِ
u'تَوَاصَلَ كَلاَمٌ':Subject, #5: 5	تَوَاصُلُ الْفِعْلِ
u'تَوَاصَلَ كَلاَمٌ':Subject, #1: 1	تَوَاصَلَ الْكَلَامُ
u'تَوَاصُلٌ كَيْلٌ':Added, #1: 1	تَوَاصَلَ كَلَامُهُ
u'تَوَاضَعَ أحَدٌ':Subject, #1: 1	تَوَاصُلِ الْكَيْلِ
u'تَوَاضَعَ أَكْثَرُ':Predicate, #9: 9	تَوَاضَعَ أَحَدٌ
u'تَوَاضَعَ رَجُلٌ':Subject, #1: 1	تَوَاضَعَ أَكْثَرَ
u'تَوَاضَعَ عَبْدٌ':Subject, #2: 2	تَوَاضَعَ الرَّجُلُ
u'تَوَاضَعَ قَالٌ':Predicate, #1: 1	تَوَاضَعَ الْعَبْدُ
u'تَوَاطَأَ أَوْلِيَاءُ':Subject, #1: 1	تَوَاضَعَ قَالَ
u'تَوَاطَأَ شَخْصٌ':Subject, #1: 1	تَوَاطَأَ أَوْلِيَاءُ
u'تَوَاطَأَ نَاسٌ':Subject, #1: 1	تَوَاطَأَ شَخْصٌ
u'تَوَافُرٌ زواجر':Added, #1: 1	تَوَاطَأَ النَّاسُ
u'تَوَافُرٌ نِعَمٌ':Added, #1: 1	تَوَافُرِ الزَّوَاجِرِ
u'تَوَافُقٌ أُمَّةٌ':Added, #2: 2	تَوَافُرِ النِّعَمِ
u'تَوَافُقٌ إِيجَابٌ':Added, #1: 1	تَوَافُقَ الْأُمَّةِ
u'تَوَافَقَ بَيْنٌ':Predicate, #1: 1	تَوَافُقِ الْإِيجَابِ
u'تَوَافُقٌ كِتَابٌ':Added, #1: 1	تَوَافَقَ بَيْنَ
u'تَوَافَقَ لَفْظٌ':Subject, #2: 2	تَوَافُقَ الْكِتَابِ
u'تَوَافَقَ مَحَلٌّ':Subject, #1: 1	تَوَافَقَ اللَّفْظُ
u'تَوَافُقٌ نَظْمٌ':Added, #1: 1	تَوَافَقَ مَحَلُّ
u'تَوَافُقٌ وَرَثَةٌ':Added, #1: 1	تَوَافُقُ نَظْمِ
u'تَوَافَقَ يَمِينٌ':Subject, #2: 2	تَوَافُقَ الْوَرَثَةِ
u'تَوَاقَفَ نَاسٌ':Subject, #1: 1	تَوَافَقَ يَمِينُهُ
u'تَوالِي أَذَانٌ':Added, #1: 1	تَوَاقَفَ النّاسُ
u'تَوَالِي أَذَانٌ':Added, #1: 1	تَوَالِي أَذَانَيْنِ
u'تَوالِي أَشْوَاطٌ':Added, #1: 1	تَوَالِي أَذَانَيْنِ
u'تَوَالِي أَشْوَاطٌ':Added, #1: 1	تَوَالِيَ الْأَشْوَاطِ
u'تَوالِي أعداد':Added, #1: 1	تَوَالِيَ الْأَشْوَاطِ
u'تَوالِي أَعْدَادٌ':Added, #1: 1	تَوَالِي الْأَعْدَادِ
u'تَوَالِي أعداد':Added, #1: 1	تَوَالِي الْأَعْدَادِ
u'تَوَالِي أَعْدَادٌ':Added, #1: 1	تَوَالِي الْأَعْدَادِ
u'تَوالِي أَفْرَادٌ':Added, #1: 1	تَوَالِي الْأَعْدَادِ
u'تَوَالِي أَفْرَادٌ':Added, #1: 1	تَوَالِي الْأَفْرَادِ
u'تَوالِي أَمْطَارٌ':Added, #1: 1	تَوَالِي الْأَفْرَادِ
u'تَوَالِي أَمْطَارٌ':Added, #1: 1	تَوَالِي الْأَمْطَارِ
u'تَوالِي أيَّامٌ':Added, #1: 1	تَوَالِي الْأَمْطَارِ
u'تَوالِي أَيَّامٌ':Added, #2: 2	تَوَالِي الْأَيَّامِ
u'تَوَالِي أيَّامٌ':Added, #2: 2	تَوَالِي الْأَيَّامِ
u'تَوَالِي أَيَّامٌ':Added, #2: 2	تَوَالِي الْأَيَّامِ
u'تَوَالَى ثَلاثَةٌ':Subject, #2: 2	تَوَالِي الْأَيَّامِ
u'تَوالِي ثَلاثَةٌ':Added, #1: 1	تَوَالَى ثَلَاثَةٌ
u'تَوَالِي ثَلاثَةٌ':Added, #1: 1	تَوَالِي ثَلَاثَةِ
u'تَوالِي خَمْسَةٌ':Added, #1: 1	تَوَالِي ثَلَاثَةِ
u'تَوَالِي خَمْسَةٌ':Added, #1: 1	تَوَالِي خَمْسَةٍ
u'تَوالِي دُهورٌ':Added, #1: 1	تَوَالِي خَمْسَةٍ
u'تَوَالِي دُهورٌ':Added, #1: 1	تَوَالِي الدُّهُورِ
u'تَوالِي زَمانٌ':Added, #1: 1	تَوَالِي الدُّهُورِ
u'تَوَالِي زَمانٌ':Added, #1: 1	تَوَالِي الزَّمَانِ
u'تَوالِي شَرْطٌ':Added, #1: 1	تَوَالِي الزَّمَانِ
u'تَوَالِي شَرْطٌ':Added, #1: 1	تَوَالِي الشَّرْطَيْنِ
u'تَوالِي شَرْطٌ':Added, #1: 1	تَوَالِي الشَّرْطَيْنِ
u'تَوَالِي شَرْطٌ':Added, #1: 1	تَوَالِي شَرْطَيْنِ
u'تَوالِي ضَمَانٌ':Added, #1: 1	تَوَالِي شَرْطَيْنِ
u'تَوَالِي ضَمَانٌ':Added, #1: 1	تَوَالِي الضَّمَانَاتِ
u'تَوالِي ضَمَانٌ':Added, #1: 1	تَوَالِي الضَّمَانَاتِ
u'تَوَالِي ضَمَانٌ':Added, #1: 1	تَوَالِي الضَّمَانَيْنِ
u'تَوالِي ضَمَانَةٌ':Added, #1: 1	تَوَالِي الضَّمَانَيْنِ
u'تَوَالِي ضَمَانَةٌ':Added, #1: 1	تَوَالِي الضَّمَانَاتِ
u'تَوالِي عَدَدٌ':Added, #1: 1	تَوَالِي الضَّمَانَاتِ
u'تَوَالِي عَدَدٌ':Added, #1: 1	تَوَالِي الْعَدَدِ
u'تَوالِي عقاب':Added, #1: 1	تَوَالِي الْعَدَدِ
u'تَوالِي عِقَابٌ':Added, #1: 1	تَوَالِي الْعِقَابِ
u'تَوَالِي عقاب':Added, #1: 1	تَوَالِي الْعِقَابِ
u'تَوَالِي عِقَابٌ':Added, #1: 1	تَوَالِي الْعِقَابِ
u'تَوالِي عَقْدٌ':Added, #1: 1	تَوَالِي الْعِقَابِ
u'تَوَالِي عَقْدٌ':Added, #1: 1	تَوَالِي الْعَقْدَيْنِ
u'تَوَالَى غيم':Subject, #1: 1	تَوَالِي الْعَقْدَيْنِ
u'تَوَالَى غَيْمٌ':Subject, #1: 1	تَوَالَى الْغَيْمُ
u'تَوالِي قَطْع':Added, #1: 1	تَوَالَى الْغَيْمُ
u'تَوَالِي قَطْع':Added, #1: 1	تَوَالِي الْقَطْعَيْنِ
u'تَوالِي مِثْلٌ':Added, #1: 1	تَوَالِي الْقَطْعَيْنِ
u'تَوَالِي مِثْلٌ':Added, #1: 1	تَوَالِي الْمِثْلَيْنِ
u'تَوالِي نِعَمٌ':Added, #1: 1	تَوَالِي الْمِثْلَيْنِ
u'تَوَالِي نِعَمٌ':Added, #1: 1	تَوَالِي النِّعَمِ
u'تَوالِي هَدْمٌ':Added, #1: 1	تَوَالِي النِّعَمِ
u'تَوَالِي هَدْمٌ':Added, #1: 1	تَوَالِي الْهَدْمِ
u'تَوَانَى كَفِيلٌ':Subject, #1: 1	تَوَالِي الْهَدْمِ
u'تَوْبَةٌ أحَدٌ':Added, #1: 1	تَوَانَى الْكَفِيلُ
u'تَوْبَةٌ ثَلاثَةٌ':Added, #2: 2	تَوْبَةُ أَحَدٍ
u'تَوْبَةٌ دَاعِي':Added, #1: 1	تَوْبَةَ الثَّلَاثَةِ
u'تَوْبَةٌ دَاعِي':Added, #1: 1	تَوْبَةَ الدَّاعِيَةِ
u'تَوْبَةٌ رَبِيعٌ':Added, #2: 2	تَوْبَةُ دَاعِيَةٍ
u'تَوْبَةٌ زانِي':Added, #1: 1	تَوْبَةَ الرَّبِيعِ
u'تَوْبَةٌ زِنْديقٌ':Added, #1: 1	تَوْبَةُ الزَّانِيَةِ
u'تَوْبَةٌ زِنْديقٌ':Added, #1: 1	تَوْبَةَ الزِّنْدِيقِ
u'تَوْبَةٌ زِنْديقٌ':Added, #1: 1	تَوْبَةُ زِنْدِيقٍ
u'تَوْبَةٌ زُهَّادٌ':Added, #4: 4	تَوْبَةُ الزِّنْدِيقِ
u'تَوْبَةٌ سَاحِرٌ':Added, #1: 1	تَوْبَةُ الزُّهَّادِ
u'تَوْبَةٌ سَاحِرٌ':Added, #2: 2	تَوْبَةُ السَّاحِرِ
u'تَوْبَةٌ سَارِقٌ':Added, #4: 4	تَوْبَةِ السَّاحِرِ
u'تَوْبَةٌ شَاهِدٌ':Added, #1: 1	تَوْبَةُ السَّارِقِ
u'تَوْبَةٌ عَاجِزٌ':Added, #1: 1	تَوْبَةِ الشَّاهِدِ
u'تَوْبَةٌ عَاجِزٌ':Added, #1: 1	تَوْبَةَ الْعَاجِزِ
u'تَوْبَةٌ عَبْدٌ':Added, #1: 1	تَوْبَةِ الْعَاجِزِ
u'تَوْبَةٌ عَبْدٌ':Added, #1: 1	تَوْبَةَ عَبْدٍ
u'تَوْبَةٌ عَبْدٌ':Added, #2: 2	تَوْبَةَ عَبْدِهِ
u'تَوْبَةٌ غَاصِبٌ':Added, #5: 5	تَوْبَةَ الْعَبْدِ
u'تَوْبَةٌ غير':Added, #1: 1	تَوْبَةِ الْغَاصِبِ
u'تَوْبَةٌ غَيْرٌ':Added, #1: 1	تَوْبَةِ غَيْرِ
u'تَوْبَةٌ غير':Added, #1: 1	تَوْبَةِ غَيْرِ
u'تَوْبَةٌ غير':Added, #1: 1	تَوْبَةَ غَيْرِهِ
u'تَوْبَةٌ غَيْرٌ':Added, #1: 1	تَوْبَةِ غَيْرِهِ
u'تَوْبَةٌ غَيْرٌ':Added, #1: 1	تَوْبَةَ غَيْرِهِ
u'تَوْبَةٌ غير':Added, #1: 1	تَوْبَةِ غَيْرِهِ
u'تَوْبَةٌ غَيْرٌ':Added, #2: 2	تَوْبَةُ غَيْرِ
u'تَوْبَةٌ فَاسِقٌ':Added, #2: 2	تَوْبَةُ غَيْرِ
u'تَوْبَةٌ قَاتِلٌ':Added, #1: 1	تَوْبَةِ الْفَاسِقَةِ
u'تَوْبَةٌ قَاتِلٌ':Added, #1: 1	تَوْبَةُ قَاتِلٍ
u'تَوْبَةٌ قَاتِلٌ':Added, #6: 6	تَوْبَةُ الْقَاتِلِ
u'تَوْبَةٌ قَاذِفٌ':Added, #6: 6	تَوْبَةِ الْقَاتِلِ
u'تَوْبَةٌ قَاذِفٌ':Added, #1: 1	تَوْبَةَ الْقَاذِفِ
u'تَوْبَةٌ قَاذِفٌ':Added, #1: 1	تَوْبَةُ الْقَاذِفِ
u'تَوْبَةٌ كَافِرٌ':Added, #2: 2	تَوْبَةِ الْقَاذِفِ
u'تَوْبَةٌ كَافِرٌ':Added, #1: 1	تَوْبَةُ الْكَافِرِ
u'تَوْبَةٌ كَافِرٌ':Added, #1: 1	تَوْبَةُ كَافِرٍ
u'تَوْبَةٌ كَعْبٌ':Added, #4: 4	تَوْبَةِ الْكَافِرِ
u'تَوْبَةٌ كَعْبٌ':Added, #1: 1	تَوْبَةِ كَعْبٍ
u'تَوْبَةٌ مَاعِزٌ':Added, #2: 2	تَوْبَةِ كَعْبِ
u'تَوْبَةٌ مَالِكٌ':Added, #2: 2	تَوْبَةِ مَاعِزٍ
u'تَوْبَةٌ مُبْتَدِعٌ':Added, #1: 1	تَوْبَةِ مَالِكِ
u'تَوْبَةٌ مُبْتَدِعٌ':Added, #1: 1	تَوْبَةُ الْمُبْتَدِعِ
u'تَوْبَةٌ مُبْتَدِعٌ':Added, #1: 1	تَوْبَةِ الْمُبْتَدِعِ
u'تَوْبَةٌ مُحَارِبٌ':Added, #4: 4	تَوْبَةُ مُبْتَدِعٍ
u'تَوْبَةٌ مُحَارِبٌ':Added, #1: 1	تَوْبَةَ الْمُحَارِبِ
u'تَوْبَةٌ مُرْتَدٌّ':Added, #1: 1	تَوْبَةِ الْمُحَارِبِ
u'تَوْبَةٌ مُسْلِمٌ':Added, #1: 1	تَوْبَةِ الْمُرْتَدِّ
u'تَوْبَةٌ مُصِرٌّ':Added, #1: 1	تَوْبَةِ الْمُسْلِمِ
u'تَوْبَةٌ مُؤْمِنٌ':Added, #1: 1	تَوْبَةِ الْمُصِرِّ
u'تَوْبَةٌ مُؤْمِنٌ':Added, #1: 1	تَوْبَةُ الْمُؤْمِنِ
u'تَوْبَةٌ نَصُوحٌ':Added, #1: 1	تَوْبَةِ الْمُؤْمِنِ
u'تَوْبِيخٌ عَرَبٌ':Added, #1: 1	تَوْبَةَ النَّصُوحِ
u'تَوَثَّقَ حَتْمٌ':Subject, #1: 1	تَوْبِيخُ الْعَرَبِ
u'تَوْثِيقٌ عَاصِمٌ':Added, #1: 1	تَوَثَّقَ حَتْمُهُ
u'تَوَجَّعَ سِنٌّ':Subject, #1: 1	تَوْثِيقِ عَاصِمِ
u'تَوَجُّعٌ عجم':Added, #1: 1	تَوَجَّعَ السِّنُّ
u'تَوَجُّعٌ عَجَمٌ':Added, #1: 1	تَوَجُّعُ الْعَجَمِ
u'تَوَجَّعَ عند':Predicate, #1: 1	تَوَجُّعُ الْعَجَمِ
u'تَوَجَّهَ إِجْزَاءٌ':Subject, #1: 1	تَوَجَّعَ عِنْدَ
u'تَوَجُّهٌ أَدَاءٌ':Added, #4: 4	تَوَجَّهَ الْإِجْزَاءُ
u'تَوَجَّهَ إمَامٌ':Subject, #1: 1	تَوَجُّهِ الْأَدَاءِ
u'تَوَجَّهَ أَمْرٌ':Subject, #2: 2	تَوَجَّهَ الْإِمَامُ
u'تَوَجَّهَ أَمْرٌ':Subject, #1: 1	تَوَجَّهَ الْأَمْرُ
u'تَوَجُّهٌ أَمْرٌ':Added, #1: 1	تَوَجَّهَ أَمْرٌ
u'تَوَجُّهٌ أَمْرٌ':Added, #1: 1	تَوَجُّهَ الْأَمْرِ
u'تَوَجَّهَ إِنْكارٌ':Subject, #3: 3	تَوَجُّهِ الْأَمْرِ
u'تَوَجَّهَ أَيْنٌ':Predicate, #3: 3	تَوَجَّهَ الْإِنْكَارُ
u'تَوَجَّهَ بَيْعٌ':Subject, #1: 1	تَوَجَّهَ أَيْنَ
u'تَوَجَّهَ تَحْرِيمٌ':Subject, #1: 1	تَوَجَّهَ الْبَيْعُ
u'تَوَجَّهَ تَحْرِيمٌ':Subject, #1: 1	تَوَجَّهَ التَّحْرِيمُ
u'تَوَجَّهَ تَخْرِيجٌ':Subject, #1: 1	تَوَجَّهَ تَحْرِيمُهُ
u'تَوَجَّهَ تَكْليفٌ':Subject, #1: 1	تَوَجَّهَ تَخْرِيجٌ
u'تَوَجُّهٌ تَكْليفٌ':Added, #2: 2	تَوَجَّهَ التَّكْلِيفُ
u'تَوَجُّهٌ تَكْليفٌ':Added, #1: 1	تَوَجُّهَ التَّكْلِيفِ
u'تَوَجَّهَ جَوَازٌ':Subject, #1: 1	تَوَجُّهِ التَّكْلِيفِ
u'تَوَجُّهٌ جَيْشٌ':Added, #3: 3	تَوَجَّهَ جَوَازُهُ
u'تَوَجَّهَ حَبْسٌ':Subject, #1: 1	تَوَجُّهِ الْجَيْشِ
u'تَوَجُّهٌ حَدٌّ':Added, #1: 1	تَوَجَّهَ الْحَبْسُ
u'تَوَجَّهَ حُكْمٌ':Subject, #1: 1	تَوَجُّهِ الْحَدِّ
u'تَوَجُّهٌ حَكَمٌ':Added, #1: 1	تَوَجَّهَ الْحُكْمُ
u'تَوَجَّهَ حَمْلٌ':Subject, #1: 1	تَوَجُّهِ الْحَكَمَيْنِ
u'تَوَجُّهٌ خُصُومَةٌ':Added, #2: 2	تَوَجَّهَ حَمْلُ
u'تَوَجَّهَ خَطَأٌ':Subject, #10: 10	تَوَجُّهِ الْخُصُومَةِ
u'تَوَجَّهَ خِطَابٌ':Subject, #1: 1	تَوَجَّهَ الْخَطَأُ
u'تَوَجُّهٌ خِطَابٌ':Added, #3: 3	تَوَجَّهَ الْخِطَابُ
u'تَوَجُّهٌ خِطَابٌ':Added, #12: 12	تَوَجُّهِ الْخِطَابِ
u'تَوَجُّهٌ خِطَابٌ':Added, #1: 1	تَوَجُّهُ الْخِطَابِ
u'تَوَجُّهٌ خِطَابٌ':Added, #1: 1	تَوَجُّهَ خِطَابِ
u'تَوَجُّهٌ خِطَابٌ':Added, #1: 1	تَوَجُّهُ خِطَابِ
u'تَوَجُّهٌ خِطَابٌ':Added, #1: 1	تَوَجُّهِ خِطَابِ
u'تَوَجُّهٌ خَطِيبٌ':Added, #2: 2	تَوَجُّهَ الْخِطَابِ
u'تَوَجَّهَ خِلاَفٌ':Subject, #1: 1	تَوَجُّهِ الْخَطِيبِ
u'تَوَجَّهَ خِلاَفٌ':Subject, #1: 1	تَوَجَّهَ الْخِلَافُ
u'تَوَجُّهٌ ذَمٌّ':Added, #5: 5	تَوَجَّهَ خِلَافٌ
u'تَوَجَّهَ رُجْحانٌ':Subject, #1: 1	تَوَجُّهُ الذَّمِّ
u'تَوَجَّهَ رَسُولٌ':Subject, #1: 1	تَوَجَّهَ رُجْحَانُ
u'تَوَجَّهَ سُؤَالٌ':Subject, #1: 1	تَوَجَّهَ رَسُولُ
u'تَوَجَّهَ شِرَاءٌ':Subject, #1: 1	تَوَجَّهَ سُؤَالُ
u'تَوَجَّهَ صِحَّةٌ':Subject, #1: 1	تَوَجَّهَ الشِّرَاءُ
u'تَوَجُّهٌ صِيغَةٌ':Added, #1: 1	تَوَجَّهَ صِحَّتُهُ
u'تَوَجَّهَ طلب':Subject, #1: 1	تَوَجُّهِ الصِّيغَةِ
u'تَوَجَّهَ طَلَبٌ':Subject, #1: 1	تَوَجَّهَ طَلَبُهُ
u'تَوَجَّهَ طلب':Subject, #1: 1	تَوَجَّهَ طَلَبُهُ
u'تَوَجَّهَ طَلَبٌ':Subject, #2: 2	تَوَجَّهَ الطَّلَبُ
u'تَوَجُّهٌ طلب':Added, #2: 2	تَوَجَّهَ الطَّلَبُ
u'تَوَجُّهٌ طَلَبٌ':Added, #2: 2	تَوَجُّهُ الطَّلَبِ
u'تَوَجَّهَ عتبة':Subject, #2: 2	تَوَجُّهُ الطَّلَبِ
u'تَوَجَّهَ عِرَاقٌ':Predicate, #1: 1	تَوَجَّهَ عُتْبَةُ
u'تَوَجَّهَ عند':Predicate, #1: 1	تَوَجَّهَ الْعِرَاقَ
u'تَوَجُّهٌ عُهْدَةٌ':Added, #1: 1	تَوَجَّهَ عِنْدَ
u'تَوَجَّهَ فَرْضٌ':Subject, #2: 2	تَوَجُّهِ الْعُهْدَةِ
u'تَوَجَّهَ فَرْضٌ':Subject, #1: 1	تَوَجَّهَ الْفَرْضُ
u'تَوَجُّهٌ فَرْضٌ':Added, #1: 1	تَوَجَّهَ فَرْضُ
u'تَوَجُّهٌ فَرْضٌ':Added, #1: 1	تَوَجُّهُ الْفَرْضِ
u'تَوَجُّهٌ فَرْضٌ':Added, #1: 1	تَوَجُّهِ الْفَرْضِ
u'تَوَجَّهَ قَافِلٌ':Predicate, #3: 3	تَوَجُّهَ الْفَرْضِ
u'تَوَجَّهَ قِبَلٌ':Predicate, #1: 1	تَوَجَّهَ قَافِلاً
u'تَوَجُّهٌ قِبْلَةٌ':Added, #1: 1	تَوَجَّهَ قِبَلَ
u'تَوَجَّهَ قَصْدٌ':Subject, #1: 1	تَوَجُّهِ الْقِبْلَةِ
u'تَوَجُّهٌ قَصْدٌ':Added, #1: 1	تَوَجَّهَ الْقَصْدُ
u'تَوَجَّهَ قَضَاءٌ':Subject, #1: 1	تَوَجُّهِ الْقَصْدِ
u'تَوَجُّهٌ قَطْعٌ':Added, #2: 2	تَوَجَّهَ الْقَضَاءُ
u'تَوَجَّهَ قول':Subject, #1: 1	تَوَجُّهِ الْقَطْعِ
u'تَوَجَّهَ قَوْلٌ':Subject, #1: 1	تَوَجَّهَ الْقَوْلُ
u'تَوَجُّهٌ قول':Added, #1: 1	تَوَجَّهَ الْقَوْلُ
u'تَوَجُّهٌ قَوْلٌ':Added, #1: 1	تَوَجُّهُ الْقَوْلِ
u'تَوَجُّهٌ لَوْمٌ':Added, #1: 1	تَوَجُّهُ الْقَوْلِ
u'تَوَجَّهَ مَالٌ':Subject, #1: 1	تَوَجُّهِ اللَّوْمِ
u'تَوَجُّهٌ مَتْرُوكٌ':Added, #1: 1	تَوَجَّهَ الْمَالُ
u'تَوَجَّهَ مُطَالَبٌ':Subject, #1: 1	تَوَجُّهُ الْمَتْرُوكِ
u'تَوَجُّهٌ مُطَالَبٌ':Added, #1: 1	تَوَجَّهَ الْمُطَالَبَةُ
u'تَوَجُّهٌ مُطَالَبٌ':Added, #2: 2	تَوَجُّهَ الْمُطَالَبَةِ
u'تَوَجُّهٌ مُطَالَبٌ':Added, #2: 2	تَوَجُّهُ الْمُطَالَبَةِ
u'تَوَجَّهَ مُطَالَبَةٌ':Subject, #7: 7	تَوَجُّهِ الْمُطَالَبَةِ
u'تَوَجُّهٌ مُطَالَبَةٌ':Added, #1: 1	تَوَجَّهَ الْمُطَالَبَةُ
u'تَوَجُّهٌ مُطَالَبَةٌ':Added, #2: 2	تَوَجُّهَ الْمُطَالَبَةِ
u'تَوَجُّهٌ مُطَالَبَةٌ':Added, #2: 2	تَوَجُّهُ الْمُطَالَبَةِ
u'تَوَجَّهَ مَنْعٌ':Subject, #7: 7	تَوَجُّهِ الْمُطَالَبَةِ
u'تَوَجُّهٌ مَنْعٌ':Added, #1: 1	تَوَجَّهَ الْمَنْعُ
u'تَوَجَّهَ نَحْوٌ':Predicate, #1: 1	تَوَجُّهِ الْمَنْعِ
u'تَوَجُّهٌ نَظَرٌ':Added, #1: 1	تَوَجَّهَ نَحْوَ
u'تَوَجُّهٌ نَفْسٌ':Added, #1: 1	تَوَجُّهِ النَّظَرِ
u'تَوَجَّهَ نَفْيٌ':Subject, #2: 2	تَوَجُّهِ النَّفْسِ
u'تَوَجُّهٌ نَقْضٌ':Added, #1: 1	تَوَجَّهَ النَّفْيُ
u'تَوَجُّهٌ نَقْضٌ':Added, #1: 1	تَوَجُّهُ النَّقْضِ
u'تَوَجَّهَ نَهْيٌ':Subject, #1: 1	تَوَجُّهِ النَّقْضِ
u'تَوَجُّهٌ نَهْيٌ':Added, #1: 1	تَوَجَّهَ النَّهْيُ
u'تَوَجُّهٌ نِيَّةٌ':Added, #2: 2	تَوَجُّهِ النَّهْيِ
u'تَوَجَّهَ هلاك':Subject, #1: 1	تَوَجُّهَ النِّيَّةِ
u'تَوَجَّهَ هَلاَكٌ':Subject, #1: 1	تَوَجَّهَ الْهَلَاكُ
u'تَوَجُّهٌ هلاك':Added, #1: 1	تَوَجَّهَ الْهَلَاكُ
u'تَوَجُّهٌ هَلاَكٌ':Added, #2: 2	تَوَجُّهِ الْهَلَاكِ
u'تَوَجَّهَ وَتَرٌ':Predicate, #2: 2	تَوَجُّهِ الْهَلَاكِ
u'تَوَجَّهَ وُجُوبٌ':Subject, #1: 1	تَوَجَّهَ وَتَرَكَ
u'تَوَجَّهَ وُجُوبٌ':Subject, #1: 1	تَوَجَّهَ الْوُجُوبُ
u'تَوَجَّهَ وُقُوعٌ':Subject, #1: 1	تَوَجَّهَ وُجُوبُ
u'تَوَجَّهَ يَمِينٌ':Subject, #1: 1	تَوَجَّهَ وُقُوعُ
u'تَوَجُّهٌ يَمِينٌ':Added, #1: 1	تَوَجَّهَ الْيَمِينُ
u'تَوَجُّهٌ يَمِينٌ':Added, #1: 1	تَوَجُّهَ الْيَمِينِ
u'تَوَجُّهٌ يَمِينٌ':Added, #1: 1	تَوَجُّهِ يَمِينِ
u'تَوَجُّهٌ يَمِينٌ':Added, #2: 2	تَوَجُّهُ الْيَمِينِ
u'تَوْجِيهٌ اِتِّجَاهٌ':Added, #3: 3	تَوَجُّهِ الْيَمِينِ
u'تَوْجِيهٌ اِحْتِمَالٌ':Added, #1: 1	تَوْجِيهِ اتِّجَاهِهِ
u'تَوْجِيهٌ اِحْتِمَالٌ':Added, #1: 1	تَوْجِيهَ احْتِمَالٍ
u'تَوْجِيهٌ أحَدٌ':Added, #1: 1	تَوْجِيهُ احْتِمَالٍ
u'تَوْجِيهٌ اِخْتِيَارٌ':Added, #1: 1	تَوْجِيهِ أَحَدِ
u'تَوْجِيهٌ أَخِيرٌ':Added, #1: 1	تَوْجِيهِ اخْتِيَارِ
u'تَوْجِيهٌ إِشْكالٌ':Added, #1: 1	تَوْجِيهُ الْأَخِيرِ
u'تَوْجِيهٌ أَصابِعُ':Added, #1: 1	تَوْجِيهُ الْإِشْكَالِ
u'تَوْجِيهٌ أَصابِعُ':Added, #1: 1	تَوْجِيهُ أَصَابِعِ
u'تَوْجِيهٌ أَصابِعُ':Added, #1: 1	تَوْجِيهَ الْأَصَابِعِ
u'تَوْجِيهٌ أَصابِعُ':Added, #1: 1	تَوْجِيهُ الْأَصَابِعِ
u'تَوْجِيهٌ أَصابِعُ':Added, #2: 2	تَوْجِيهَ أَصَابِعِ
u'تَوْجِيهٌ أَصْحَابٌ':Added, #2: 2	تَوْجِيهِ الْأَصَابِعِ
u'تَوْجِيهٌ إِعْرابٌ':Added, #1: 1	تَوْجِيهُ الْأَصْحَابِ
u'تَوْجِيهٌ اِفْتِرَاضٌ':Added, #1: 1	تَوْجِيهُ إعْرَابٍ
u'تَوْجِيهٌ اِفْتِرَاضٌ':Added, #1: 1	تَوْجِيهِ افْتِرَاضِ
u'تَوْجِيهٌ أَقْوَالٌ':Added, #3: 3	تَوْجِيهُ افْتِرَاضِ
u'تَوْجِيهٌ أَقْوَالٌ':Added, #1: 1	تَوْجِيهُ الْأَقْوَالِ
u'تَوْجِيهٌ اِكْتِفَاءٌ':Added, #1: 1	تَوْجِيهِ الْأَقْوَالِ
u'تَوْجِيهٌ إِيجَابٌ':Added, #1: 1	تَوْجِيهِ اكْتِفَاءِ
u'تَوْجِيهٌ أَيْمَانٌ':Added, #1: 1	تَوْجِيهُ إيجَابِ
u'تَوْجِيهٌ تَحْرِيمٌ':Added, #1: 1	تَوْجِيهِ الْأَيْمَانِ
u'تَوْجِيهٌ تَرْكٌ':Added, #1: 1	تَوْجِيهُ تَحْرِيمِ
u'تَوْجِيهٌ تَعْبِيرٌ':Added, #1: 1	تَوْجِيهِ تَرْكِ
u'تَوْجِيهٌ تَعَدُّدٌ':Added, #1: 1	تَوْجِيهِ تَعْبِيرِ
u'تَوْجِيهٌ تَقْديمٌ':Added, #1: 1	تَوْجِيهِ تَعَدُّدِ
u'تَوْجِيهٌ جَوَابٌ':Added, #2: 2	تَوْجِيهِ تَقْدِيمِ
u'تَوْجِيهٌ جَوَازٌ':Added, #1: 1	تَوْجِيهِ الْجَوَابِ
u'تَوْجِيهٌ جَوَازٌ':Added, #1: 1	تَوْجِيهَ الْجَوَازِ
u'تَوْجِيهٌ حُرْمَةٌ':Added, #1: 1	تَوْجِيهِ جَوَازِ
u'تَوْجِيهٌ حَصْرٌ':Added, #1: 1	تَوْجِيهِ حُرْمَةِ
u'تَوْجِيهٌ حُكْمٌ':Added, #1: 1	تَوْجِيهِ الْحَصْرِ
u'تَوْجِيهٌ حُكْمٌ':Added, #1: 1	تَوْجِيهَ الْحُكْمِ
u'تَوْجِيهٌ حُكْمٌ':Added, #1: 1	تَوْجِيهِ الْحُكْمِ
u'تَوْجِيهٌ خِطَابٌ':Added, #2: 2	تَوْجِيهُ الْحُكْمِ
u'تَوْجِيهٌ خِطَابٌ':Added, #1: 1	تَوْجِيهَ الْخِطَابِ
u'تَوْجِيهٌ خِطَابٌ':Added, #1: 1	تَوْجِيهُ الْخِطَابِ
u'تَوْجِيهٌ خِطَابٌ':Added, #1: 1	تَوْجِيهِ الْخِطَابِ
u'تَوْجِيهٌ خِلاَفٌ':Added, #1: 1	تَوْجِيهِ خِطَابِ
u'تَوْجِيهٌ دُعَاءٌ':Added, #2: 2	تَوْجِيهِ خِلَافِهِ
u'تَوْجِيهٌ دفع':Added, #1: 1	تَوْجِيهِ الدُّعَاءِ
u'تَوْجِيهٌ دَفْعٌ':Added, #1: 1	تَوْجِيهِ الدَّفْعِ
u'تَوْجِيهٌ ذَبيحٌ':Added, #1: 1	تَوْجِيهِ الدَّفْعِ
u'تَوْجِيهٌ ذَبيحَةٌ':Added, #2: 2	تَوْجِيهُ الذَّبِيحَةِ
u'تَوْجِيهٌ ذِهْنٌ':Added, #2: 2	تَوْجِيهُ الذَّبِيحَةِ
u'تَوْجِيهٌ ذِهْنٌ':Added, #1: 1	تَوْجِيهُ الذِّهْنِ
u'تَوْجِيهٌ رابع':Added, #1: 1	تَوْجِيهِ الذِّهْنِ
u'تَوْجِيهٌ رابع':Added, #1: 1	تَوْجِيهُ الرَّابِعِ
u'تَوْجِيهٌ رَابِعٌ':Added, #1: 1	تَوْجِيهِ الرَّابِعِ
u'تَوْجِيهٌ رَابِعٌ':Added, #1: 1	تَوْجِيهُ الرَّابِعِ
u'تَوْجِيهٌ رَأْيٌ':Added, #1: 1	تَوْجِيهِ الرَّابِعِ
u'تَوْجِيهٌ رِوايَةٌ':Added, #1: 1	تَوْجِيهِ رَأْيِ
u'تَوْجِيهٌ صَاحِبٌ':Added, #1: 1	تَوْجِيهِ رِوَايَةِ
u'تَوْجِيهٌ صِحَّةٌ':Added, #1: 1	تَوْجِيهُ صَاحِبِ
u'تَوْجِيهٌ ضَمَانٌ':Added, #1: 1	تَوْجِيهُ الصِّحَّةِ
u'تَوْجِيهٌ ظاهِرٌ':Added, #1: 1	تَوْجِيهُ الضَّمَانِ
u'تَوْجِيهٌ عَدَمٌ':Added, #1: 1	تَوْجِيهِ ظَاهِرِ
u'تَوْجِيهٌ عِلَّةٌ':Added, #1: 1	تَوْجِيهَ عَدَمِ
u'تَوْجِيهٌ غير':Added, #1: 1	تَوْجِيهُ الْعِلَّةِ
u'تَوْجِيهٌ غَيْرٌ':Added, #1: 1	تَوْجِيهُ غَيْرِ
u'تَوْجِيهٌ قِرَاءةٌ':Added, #1: 1	تَوْجِيهُ غَيْرِ
u'تَوْجِيهٌ قول':Added, #1: 1	تَوْجِيهِ الْقِرَاءَاتِ
u'تَوْجِيهٌ قول':Added, #1: 1	تَوْجِيهُ قَوْلِ
u'تَوْجِيهٌ قَوْلٌ':Added, #1: 1	تَوْجِيهِ قَوْلِ
u'تَوْجِيهٌ قَوْلٌ':Added, #1: 1	تَوْجِيهُ قَوْلِ
u'تَوْجِيهٌ قول':Added, #1: 1	تَوْجِيهِ قَوْلِ
u'تَوْجِيهٌ قَوْلٌ':Added, #4: 4	تَوْجِيهِ قَوْلِهِ
u'تَوْجِيهٌ كَلاَمٌ':Added, #4: 4	تَوْجِيهِ قَوْلِهِ
u'تَوْجِيهٌ كَلاَمٌ':Added, #1: 1	تَوْجِيهُ كَلَامِهِ
u'تَوْجِيهٌ كَلاَمٌ':Added, #2: 2	تَوْجِيهُ الْكَلَامِ
u'تَوْجِيهٌ كَلاَمٌ':Added, #2: 2	تَوْجِيهِ كَلَامِهِ
u'تَوْجِيهٌ كَلاَمٌ':Added, #4: 4	تَوْجِيهُ كَلَامِ
u'تَوْجِيهٌ كَوْنٌ':Added, #4: 4	تَوْجِيهِ كَلَامِ
u'تَوْجِيهٌ كَوْنٌ':Added, #1: 1	تَوْجِيهُ كَوْنِ
u'تَوْجِيهٌ مَالِكٌ':Added, #1: 1	تَوْجِيهِ كَوْنِ
u'تَوْجِيهٌ مُتَعَدِّدٌ':Added, #1: 1	تَوْجِيهُ مَالِكٍ
u'تَوْجِيهٌ مُتُونٌ':Added, #1: 1	تَوْجِيهُ مُتَعَدِّدٍ
u'تَوْجِيهٌ مَذْهَبٌ':Added, #1: 1	تَوْجِيهِ الْمُتُونِ
u'تَوْجِيهٌ مَسْأَلَةٌ':Added, #2: 2	تَوْجِيهِ الْمَذْهَبِ
u'تَوْجِيهٌ مُصَنِّفٌ':Added, #1: 1	تَوْجِيهِ الْمَسْأَلَةِ
u'تَوْجِيهٌ مُطَالَبٌ':Added, #1: 1	تَوْجِيهَ الْمُصَنِّفِ
u'تَوْجِيهٌ مُطَالَبَةٌ':Added, #1: 1	تَوْجِيهُ مُطَالَبَةِ
u'تَوْجِيهٌ مُعَارَضَةٌ':Added, #1: 1	تَوْجِيهُ مُطَالَبَةِ
u'تَوْجِيهٌ مَنْحُور':Added, #1: 1	تَوْجِيهِ الْمُعَارَضَةِ
u'تَوْجِيهٌ مَنْعٌ':Added, #1: 1	تَوْجِيهُ الْمَنْحُورِ
u'تَوْجِيهٌ نصب':Added, #1: 1	تَوْجِيهُ الْمَنْعِ
u'تَوْجِيهٌ نَصْبٌ':Added, #1: 1	تَوْجِيهِ النَّصْبِ
u'تَوْجِيهٌ وَجْهٌ':Added, #1: 1	تَوْجِيهِ النَّصْبِ
u'تَوْجِيهٌ وَجْهٌ':Added, #1: 1	تَوْجِيهَ الْوَجْهِ
u'تَوْجِيهٌ وُجُوبٌ':Added, #1: 1	تَوْجِيهِ الْوَجْهِ
u'تَوْجِيهٌ يَمِينٌ':Added, #1: 1	تَوْجِيهُ وُجُوبِ
u'تَوَحُّدٌ الْمَرْأَةُ':Added, #1: 1	تَوْجِيهِ الْيَمِينِ
u'تَوَحَّدَ خِطَابٌ':Subject, #1: 1	تَوَحُّدِ الْمَرْأَةِ
u'تَوَحَّشَ إِنْسِيٌّ':Subject, #1: 1	تَوَحَّدَ خِطَابُ
u'تَوَحَّشَ بَقَرٌ':Subject, #1: 1	تَوَحَّشَ إنْسِيٌّ
u'تَوَحُّشٌ مَقْصُودٌ':Added, #1: 1	تَوَحَّشَ بَقَرٌ
u'تَوَحَّلَ صَيْدٌ':Subject, #1: 1	تَوَحُّشَ الْمَقْصُودِ
u'تَوَحَّلَ ظَبْيٌ':Subject, #2: 2	تَوَحَّلَ صَيْدٌ
u'تَوْحِيدٌ اللهُ':Added, #1: 1	تَوَحَّلَ ظَبْيٌ
u'تَوْحِيدٌ إلَهِيٌّ':Added, #2: 2	تَوْحِيدِ اللهِ
u'تَوْحِيدٌ جِنَانٌ':Added, #1: 1	تَوْحِيدَ الْإِلَهِيَّةِ
u'تَوْحِيدٌ حَمْلٌ':Added, #1: 1	تَوْحِيدِ الْجِنَانِ
u'تَوْحِيدٌ رَبُّ':Added, #1: 1	تَوْحِيدُ الْحَمْلِ
u'تَوْحِيدٌ رُبُوبِيٌّ':Added, #1: 1	تَوْحِيدِ الرَّبِّ
u'تَوْحِيدٌ عِبَادٌ':Added, #1: 1	تَوْحِيدُ الرُّبُوبِيَّةِ
u'تَوْحِيدٌ قلب':Added, #1: 1	تَوْحِيدَ الْعِبَادِ
u'تَوْحِيدٌ قَلْبٌ':Added, #1: 1	تَوْحِيدُ الْقَلْبِ
u'تَوْحِيدٌ قَلْب':Added, #1: 1	تَوْحِيدُ الْقَلْبِ
u'تَوْحِيدٌ لِسَانٌ':Added, #1: 1	تَوْحِيدُ الْقَلْبِ
u'تَوَدَّدَ حاطِبٌ':Subject, #1: 1	تَوْحِيدَ اللِّسَانِ
u'تَوَدُّدٌ مُجَرَّدٌ':Added, #1: 1	تَوَدَّدَ حَاطِبٌ
u'تَوْدِيعٌ بَيْتٌ':Added, #1: 1	تَوَدُّدٍ مُجَرَّدٍ
u'تَوْدِيعٌ بَيْتٌ':Added, #1: 1	تَوْدِيعِ الْبَيْتِ
u'تَوَرَّدَ شَجَرٌ':Subject, #2: 2	تَوْدِيعُ الْبَيْتِ
u'تَوَرَّكَ جَازٌ':Predicate, #1: 1	تَوَرَّدَ الشَّجَرُ
u'تَوَرُّكٌ مَسْبُوق':Added, #2: 2	تَوَرَّكَ جَازَ
u'تَوَرَّمَ رَأْسٌ':Subject, #1: 1	تَوَرُّكُ الْمَسْبُوقِ
u'تَوَرَّمَ ظَهْرٌ':Subject, #1: 1	تَوَرَّمَ رَأْسُ
u'تَوْزِيعٌ أُجْرَةٌ':Added, #1: 1	تَوَرَّمَ ظَهْرُ
u'تَوْزِيعٌ أَجْزَاءٌ':Added, #1: 1	تَوْزِيعُ الْأُجْرَةِ
u'تَوْزِيعٌ آحَادٌ':Added, #1: 1	تَوْزِيعِ أَجْزَاءِ
u'تَوْزِيعٌ آحَادٌ':Added, #1: 1	تَوْزِيعَ الْآحَادِ
u'تَوْزِيعٌ أَفْرَادٌ':Added, #1: 1	تَوْزِيعُ الْآحَادِ
u'تَوْزِيعٌ أَفْرَادٌ':Added, #1: 1	تَوْزِيعُ أَفْرَادِ
u'تَوْزِيعٌ ألف':Added, #3: 3	تَوْزِيعِ الْأَفْرَادِ
u'تَوْزِيعٌ ألْفٌ':Added, #2: 2	تَوْزِيعِ الْأَلْفِ
u'تَوْزِيعٌ أَلْفٌ':Added, #2: 2	تَوْزِيعِ الْأَلْفِ
u'تَوْزِيعٌ ثَلاثُ':Added, #2: 2	تَوْزِيعِ الْأَلْفِ
u'تَوْزِيعٌ ثَمانِيَةٌ':Added, #1: 1	تَوْزِيعِ الثَّلَاثِ
u'تَوْزِيعٌ ثَمَنٌ':Added, #1: 1	تَوْزِيعِ الثَّمَانِيَةِ
u'تَوْزِيعٌ ثَمَنٌ':Added, #2: 2	تَوْزِيعَ الثَّمَنِ
u'تَوْزِيعٌ ثَمَنٌ':Added, #2: 2	تَوْزِيعُ الثَّمَنِ
u'تَوْزِيعٌ جُمَلٌ':Added, #2: 2	تَوْزِيعِ الثَّمَنِ
u'تَوْزِيعٌ جُمْلَةٌ':Added, #1: 1	تَوْزِيعِ الْجُمَلِ
u'تَوْزِيعٌ جُمْلَةٌ':Added, #1: 1	تَوْزِيعَ جُمْلَتِهِ
u'تَوْزِيعٌ دِيَةٌ':Added, #9: 9	تَوْزِيعِ الْجُمْلَةِ
u'تَوْزِيعٌ دِيَةٌ':Added, #1: 1	تَوْزِيعُ الدِّيَةِ
u'تَوْزِيعٌ صَدَقَةٌ':Added, #1: 1	تَوْزِيعِ الدِّيَةِ
u'تَوْزِيعٌ طرف':Added, #1: 1	تَوْزِيعُ الصَّدَقَاتِ
u'تَوْزِيعٌ طَرَفٌ':Added, #1: 1	تَوْزِيعَ طَرَفِهِ
u'تَوْزِيعٌ عَزْمٌ':Added, #1: 1	تَوْزِيعَ طَرَفِهِ
u'تَوْزِيعٌ عِوَضٌ':Added, #1: 1	تَوْزِيعِ الْعَزْمِ
u'تَوْزِيعٌ لَحْمٌ':Added, #1: 1	تَوْزِيعَ الْعِوَضِ
u'تَوْزِيعٌ مَجْمُوعٌ':Added, #1: 1	تَوْزِيعِ اللَّحْمِ
u'تَوْزِيعٌ مُفْرَدٌ':Added, #1: 1	تَوْزِيعُ مَجْمُوعِ
u'تَوْزِيعٌ مُفْرَدٌ':Added, #1: 1	تَوْزِيعِ الْمُفْرَدَاتِ
u'تَوْزِيعٌ مُفْرَدٌ':Added, #2: 2	تَوْزِيعُ الْمُفْرَدِ
u'تَوْزِيعٌ وَجْهٌ':Added, #2: 2	تَوْزِيعِ الْمُفْرَدِ
u'تَوَسَّخَ إِلْزَامٌ':Subject, #1: 1	تَوْزِيعُ الْوَجْهَيْنِ
u'تَوَسَّدَ كِتَابٌ':Predicate, #1: 1	تَوَسَّخَ إلْزَامٌ
u'تَوَسَّطَ اِبْنٌ':Subject, #1: 1	تَوَسَّدَ كِتَابَ
u'تَوَسَّطَ بَيْنٌ':Predicate, #1: 1	تَوَسَّطَ ابْنُ
u'تَوَسَّطَ جَزَاءٌ':Subject, #4: 4	تَوَسَّطَ بَيْنَ
u'تَوَسَّطَ شَيْخٌ':Subject, #1: 1	تَوَسَّطَ الْجَزَاءُ
u'تَوَسَّطَ طَرِيقٌ':Predicate, #1: 1	تَوَسَّطَ الشَّيْخُ
u'تَوَسَّطَ مُحَلِّل':Subject, #1: 1	تَوَسَّطَ الطَّرِيقَ
u'تَوَسَّطَ وَصْفٌ':Subject, #1: 1	تَوَسَّطَ الْمُحَلِّلُ
u'تَوَسَّعَ اِبْنٌ':Subject, #1: 1	تَوَسَّطَ الْوَصْفُ
u'تَوَسَّعَ أَصْحَابٌ':Subject, #1: 1	تَوَسَّعَ ابْنُ
u'تَوَسَّعَ أهْلٌ':Subject, #1: 1	تَوَسَّعَ أَصْحَابُهُ
u'تَوَسُّعٌ خلق':Added, #1: 1	تَوَسَّعَ أَهْلُ
u'تَوَسُّعٌ خَلْقٌ':Added, #1: 1	تَوَسُّعِ الْخَلْقِ
u'تَوَسَّعَ نَاسٌ':Subject, #1: 1	تَوَسُّعِ الْخَلْقِ
u'تَوَسَّعَ وَقْتٌ':Subject, #1: 1	تَوَسَّعَ النَّاسُ
u'تَوَسَّعَ وَقْتٌ':Subject, #1: 1	تَوَسَّعَ الْوَقْتُ
u'تَوَسَّمَ خَيْرٌ':Predicate, #1: 1	تَوَسَّعَ وَقْتُهُ
u'تَوْسِيخٌ قلب':Added, #1: 1	تَوَسَّمَ الْخَيْرَ
u'تَوْسِيخٌ قَلْبٌ':Added, #1: 1	تَوْسِيخِ قَلْبِهِ
u'تَوْسِيخٌ قَلْب':Added, #1: 1	تَوْسِيخِ قَلْبِهِ
u'تَوْسِيطٌ حالٌ':Added, #1: 1	تَوْسِيخِ قَلْبِهِ
u'تَوْسِيطٌ سَبَبٌ':Added, #1: 1	تَوْسِيطِ الْحَالِ
u'تَوْسِيطٌ سُنَّةٌ':Added, #1: 1	تَوْسِيطِ السَّبَبِ
u'تَوْسِيطٌ مُقَدِّمٌ':Added, #1: 1	تَوْسِيطُ سُنَّةِ
u'تَوْسِيعٌ أَكْمَامٌ':Added, #1: 1	تَوْسِيطِ مُقَدِّمَتَيْنِ
u'تَوْسِيعٌ حُكْمٌ':Added, #1: 1	تَوْسِيعِ الْأَكْمَامِ
u'تَوْسِيعٌ خِلاَفٌ':Added, #1: 1	تَوْسِيعِ الْحُكْمِ
u'تَوْسِيعٌ فَمٌ':Added, #1: 1	تَوْسِيعِ الْخِلَافِ
u'تَوْسِيعٌ كُمٌّ':Added, #2: 2	تَوْسِيعَ فَمِ
u'تَوْسِيعٌ مَسْجِدٌ':Added, #2: 2	تَوْسِيعُ الْكُمِّ
u'تَوَشْوَشَ قَوْمٌ':Subject, #1: 1	تَوْسِيعِ الْمَسْجِدِ
u'تَوْشِيحٌ تَوْشِيحٌ':Added, #1: 1	تَوَشْوَشَ الْقَوْمُ
u'تَوَصَّلَ زَوْجٌ':Subject, #1: 1	تَوْشِيحِ التَّوْشِيحِ
u'تَوْصِيلٌ غير':Added, #1: 1	تَوَصَّلَ الزَّوْجُ
u'تَوْصِيلٌ غَيْرٌ':Added, #1: 1	تَوْصِيلُ غَيْرِهِ
u'تَوْضِئَةٌ مُحْدِثٌ':Added, #1: 1	تَوْصِيلُ غَيْرِهِ
u'تَوْضِيحٌ اِبْنٌ':Added, #2: 2	تَوْضِئَةِ مُحْدِثٍ
u'تَوْضِيحٌ شَيْءٌ':Added, #1: 1	تَوْضِيحِ ابْنِ
u'تَوْضِيحٌ صَدْرٌ':Added, #1: 1	تَوْضِيحُ الشَّيْءِ
u'تَوْضِيحٌ فرق':Added, #1: 1	تَوْضِيحِ صَدْرِ
u'تَوْضِيحٌ فَرْقٌ':Added, #5: 5	تَوْضِيحُ الْفَرْقِ
u'تَوْضِيحٌ مالِك':Added, #5: 5	تَوْضِيحُ الْفَرْقِ
u'تَوْضِيحٌ مالِكِيّ':Added, #1: 1	تَوْضِيحِ الْمَالِكِيَّةِ
u'تَوْضِيحٌ مِنْهَاجٌ':Added, #1: 1	تَوْضِيحِ الْمَالِكِيَّةِ
u'تَوْضِيعٌ كَلاَمٌ':Added, #1: 1	تَوْضِيحِ الْمِنْهَاجِ
u'تَوَطَّنَ خَمْسَةٌ':Predicate, #1: 1	تَوْضِيعُ كَلَامِ
u'تَوَطَّنَ فلان':Predicate, #1: 1	تَوَطَّنَ خَمْسَةَ
u'تَوَطُّنٌ مَحَلٌّ':Added, #2: 2	تَوَطَّنَ مَكَّةَ
u'تَوْطِيدٌ إِسْلامٌ':Added, #1: 1	تَوَطُّنِ مَحَلٍّ
u'تَوْطِينٌ نَفْسٌ':Added, #1: 1	تَوْطِيدِ الْإِسْلَامِ
u'تَوْظِيفٌ خراج':Added, #1: 1	تَوْطِينِ النَّفْسِ
u'تَوْظِيفٌ خَرَاجٌ':Added, #1: 1	تَوْظِيفُ الْخَرَاجِ
u'تَوْظِيفٌ خراج':Added, #1: 1	تَوْظِيفُ الْخَرَاجِ
u'تَوْظِيفٌ خَرَاجٌ':Added, #1: 1	تَوْظِيفُ خَرَاجٍ
u'تَوْظِيفٌ خراج':Added, #1: 1	تَوْظِيفُ خَرَاجٍ
u'تَوْظِيفٌ خَرَاجٌ':Added, #2: 2	تَوْظِيفِ الْخَرَاجِ
u'تَوْظِيفٌ خراج':Added, #2: 2	تَوْظِيفِ الْخَرَاجِ
u'تَوْظِيفٌ خَرَاجٌ':Added, #3: 3	تَوْظِيفَ الْخَرَاجِ
u'تَوْظِيفٌ عُشْرٌ':Added, #3: 3	تَوْظِيفَ الْخَرَاجِ
u'تَوَعَّدَ شَارِعٌ':Subject, #1: 1	تَوْظِيفِ الْعُشْرِ
u'تَوَفُّرٌ أَصْحَابٌ':Added, #1: 1	تَوَعَّدَ الشَّارِعُ
u'تَوَفُّرٌ جَمَاعَةٌ':Added, #1: 1	تَوَفُّرِ أَصْحَابِ
u'تَوَفُّرٌ حاجَةٌ':Added, #1: 1	تَوَفُّرِ الْجَمَاعَةِ
u'تَوَفُّرٌ زواجر':Added, #2: 2	تَوَفُّرُ الْحَاجَةِ
u'تَوَفُّرٌ شَرَائِطُ':Added, #1: 1	تَوَفُّرِ الزَّوَاجِرِ
u'تَوَفُّرٌ شُرُوطٌ':Added, #1: 1	تَوَفُّرِ شَرَائِطِهِ
u'تَوَفُّرٌ صَحَابَةٌ':Added, #1: 1	تَوَفُّرِ شُرُوطِ
u'تَوَفَّرَ عَمَلٌ':Subject, #1: 1	تَوَفُّرِ الصَّحَابَةِ
u'تَوَفُّرٌ قُوَّةٌ':Added, #1: 1	تَوَفَّرَ عَمَلُهُ
u'تَوَفُّرٌ قُوَّة':Added, #1: 1	تَوَفُّرِ الْقُوَّةِ
u'تَوْفِيَةٌ أَوَّلُ':Added, #1: 1	تَوَفُّرِ الْقُوَّةِ
u'تَوْفِيَةٌ بَعْضٌ':Added, #1: 1	تَوْفِيَةِ الْأَوَّلِ
u'تَوْفِيَةٌ تَكْليفٌ':Added, #1: 1	تَوْفِيَةُ بَعْضِ
u'تَوْفِيَةٌ ثَمَنٌ':Added, #1: 1	تَوْفِيَةِ التَّكْلِيفِ
u'تَوْفِيَةٌ ثَمَنٌ':Added, #1: 1	تَوْفِيَةَ الثَّمَنِ
u'تَوْفِيَةٌ جَزَاءٌ':Added, #1: 1	تَوْفِيَةِ الثَّمَنِ
u'تَوْفِيَةٌ حاكِمٌ':Added, #1: 1	تَوْفِيَةَ الْجَزَاءِ
u'تَوْفِيَةٌ حُرٌّ':Added, #1: 1	تَوْفِيَةِ الْحَاكِمِ
u'تَوْفِيَةٌ حَقٌّ':Added, #1: 1	تَوْفِيَةُ الْحُرَّةِ
u'تَوْفِيَةٌ حَقٌّ':Added, #2: 2	تَوْفِيَةُ الْحَقَّيْنِ
u'تَوْفِيَةٌ حُكْمٌ':Added, #3: 3	تَوْفِيَةُ الْحَقِّ
u'تَوْفِيَةٌ دَيْنٌ':Added, #2: 2	تَوْفِيَةِ حُكْمِ
u'تَوْفِيَةٌ دَيْنٌ':Added, #1: 1	تَوْفِيَةَ الدَّيْنِ
u'تَوْفِيَةٌ صداق':Added, #1: 1	تَوْفِيَةِ الدَّيْنِ
u'تَوْفِيَةٌ صَدَاقٌ':Added, #1: 1	تَوْفِيَةِ الصَّدَاقِ
u'تَوْفِيَةٌ عِوَضٌ':Added, #1: 1	تَوْفِيَةِ الصَّدَاقِ
u'تَوْفِيَةٌ كَيْلٌ':Added, #1: 1	تَوْفِيَةِ الْعِوَضَيْنِ
u'تَوْفِيَةٌ مَحْبُوسٌ':Added, #1: 1	تَوْفِيَةِ كَيْلٍ
u'تَوْفِيَةٌ مَهْرٌ':Added, #1: 1	تَوْفِيَةِ الْمَحْبُوسَةِ
u'تَوْفِيَةٌ نَجْمٌ':Added, #1: 1	تَوْفِيَةِ الْمَهْرِ
u'تَوْفِيرٌ أَظْفارٌ':Added, #1: 1	تَوْفِيَةِ النَّجْمِ
u'تَوْفِيرٌ ثَمَنٌ':Added, #1: 1	تَوْفِيرُ الْأَظْفَارِ
u'تَوْفِيرٌ حَقٌّ':Added, #2: 2	تَوْفِيرِ الثَّمَنِ
u'تَوْفِيرٌ حَقٌّ':Added, #1: 1	تَوْفِيرَ الْحَقَّيْنِ
u'تَوْفِيرٌ خَيْلٌ':Added, #1: 1	تَوْفِيرِ حَقِّهِ
u'تَوْفِيرٌ ريعٌ':Added, #1: 1	تَوْفِيرِ الْخَيْلِ
u'تَوْفِيرٌ رَيْعٌ':Added, #1: 1	تَوْفِيرُ الرَّيْعِ
u'تَوْفِيرٌ شَعَرٌ':Added, #1: 1	تَوْفِيرُ الرَّيْعِ
u'تَوْفِيرٌ غَرَضٌ':Added, #1: 1	تَوْفِيرِ شَعَرِ
u'تَوْفِيرٌ غَرَضٌ':Added, #1: 1	تَوْفِيرِ غَرَضٍ
u'تَوْفِيرٌ مَالٌ':Added, #2: 2	تَوْفِيرُ الْغَرَضِ
u'تَوْفِيرٌ مَنْفَعَةٌ':Added, #1: 1	تَوْفِيرَ مَالِهِ
u'تَوْفِيرٌ مَنْفَعَةٌ':Added, #1: 1	تَوْفِيرَ مَنْفَعَةِ
u'تَوْفِيرٌ نِصْفٌ':Added, #2: 2	تَوْفِيرُ الْمَنْفَعَةِ
u'تَوْفِيرٌ نَظَرٌ':Added, #1: 1	تَوْفِيرُ النِّصْفِ
u'تَوْفِيرٌ نَظَرٌ':Added, #1: 1	تَوْفِيرُ النَّظَرِ
u'تَوْفِيقٌ اِبْنٌ':Added, #3: 3	تَوْفِيرَ النَّظَرِ
u'تَوْفِيقٌ بدائع':Added, #1: 1	تَوْفِيقِ ابْنِ
u'تَوْفِيقٌ جمع':Added, #1: 1	تَوْفِيقُ الْبَدَائِعِ
u'تَوْفِيقٌ جَمْعٌ':Added, #1: 1	تَوْفِيقِ الْجَمْعِ
u'تَوْفِيقٌ عِنَايَةٌ':Added, #1: 1	تَوْفِيقِ الْجَمْعِ
u'تَوْفِيقٌ مُؤَلِّفٌ':Added, #1: 1	تَوْفِيقِ الْعِنَايَةِ
u'تَوَفَّى نَفْسٌ':Predicate, #2: 2	تَوْفِيقِ الْمُؤَلِّفِ
u'تَوَقُّدٌ حُزْنٌ':Added, #2: 2	تَوَفَّى نَفْسَكَ
u'تَوَقُّعٌ إِسْكارٌ':Added, #1: 1	تَوَقُّدِ الْحُزْنِ
u'تَوَقُّعٌ أَمْرٌ':Added, #1: 1	تَوَقُّعِ الْإِسْكَارِ
u'تَوَقُّعٌ بَلاءٌ':Added, #1: 1	تَوَقُّعُ أَمْرٍ
u'تَوَقُّعٌ تَمْييزٌ':Added, #1: 1	تَوَقُّعُ الْبَلَاءِ
u'تَوَقُّعٌ جمع':Added, #1: 1	تَوَقُّعِ التَّمْيِيزِ
u'تَوَقُّعٌ جَمْعٌ':Added, #1: 1	تَوَقُّعُ جَمْعِ
u'تَوَقُّعٌ حُكْمٌ':Added, #1: 1	تَوَقُّعُ جَمْعِ
u'تَوَقُّعٌ حَمْلٌ':Added, #1: 1	تَوَقُّعِ الْحُكْمِ
u'تَوَقُّعٌ حَيْضٌ':Added, #1: 1	تَوَقُّعِ حَمْلِ
u'تَوَقُّعٌ خَلَلٌ':Added, #1: 1	تَوَقُّعِ الْحَيْضِ
u'تَوَقُّعٌ زَوالٌ':Added, #1: 1	تَوَقُّعُ خَلَلٍ
u'تَوَقَّعَ زِيادَةٌ':Predicate, #1: 1	تَوَقُّعَ زَوَالِ
u'تَوَقُّعٌ شِفَاءٌ':Added, #1: 1	تَوَقَّعَ زِيَادَةَ
u'تَوَقَّعَ صَاحِبٌ':Subject, #1: 1	تَوَقُّعِ الشِّفَاءِ
u'تَوَقُّعٌ ضَرَرٌ':Added, #1: 1	تَوَقَّعَ صَاحِبُهُ
u'تَوَقُّعٌ ظَفَرٌ':Added, #1: 1	تَوَقُّعَ الضَّرَرِ
u'تَوَقُّعٌ عَوْدٌ':Added, #1: 1	تَوَقُّعِ ظَفَرٍ
u'تَوَقُّعٌ عَوْدٌ':Added, #1: 1	تَوَقُّعِ الْعَوْدِ
u'تَوَقُّعٌ عَوْدٌ':Added, #1: 1	تَوَقُّعُ عَوْدِ
u'تَوَقُّعٌ عِوَضٌ':Added, #1: 1	تَوَقُّعَ عَوْدِهِ
u'تَوَقُّعٌ عِوَضٌ':Added, #1: 1	تَوَقُّعِ الْعِوَضِ
u'تَوَقُّعٌ غَنِيٌّ':Added, #1: 1	تَوَقُّعِ عِوَضٍ
u'تَوَقَّعَ غَيْثٌ':Predicate, #1: 1	تَوَقُّعَ الْغَنِيِّ
u'تَوَقُّعٌ فتنة':Added, #1: 1	تَوَقَّعَ الْغَيْثَ
u'تَوَقُّعٌ فِتْنَةٌ':Added, #1: 1	تَوَقُّعِ الْفِتْنَةِ
u'تَوَقُّعٌ فساد':Added, #1: 1	تَوَقُّعِ الْفِتْنَةِ
u'تَوَقُّعٌ فَسَادٌ':Added, #2: 2	تَوَقُّعُ الْفَسَادِ
u'تَوَقُّعٌ مَحْصُولٌ':Added, #2: 2	تَوَقُّعُ الْفَسَادِ
u'تَوَقُّعٌ مُكَافَأَةٌ':Added, #1: 1	تَوَقُّعِ مَحْصُولِهِ
u'تَوَقَّعَ مَنْعٌ':Predicate, #1: 1	تَوَقُّعِ مُكَافَأَةٍ
u'تَوَقُّعٌ مَوْتٌ':Added, #1: 1	تَوَقَّعَ الْمَنْعَ
u'تَوَقَّعَ نَبْش':Predicate, #2: 2	تَوَقُّعِ مَوْتِ
u'تَوَقُّعٌ نَفْيٌ':Added, #1: 1	تَوَقَّعَ النَّبْشَ
u'تَوَقَّعَ نَقْصٌ':Predicate, #1: 1	تَوَقُّعِ نَفْيِ
u'تَوَقَّعَ وُصُولٌ':Predicate, #1: 1	تَوَقَّعَ نَقْصَ
u'تَوَقُّعٌ وَعْدٌ':Added, #1: 1	تَوَقَّعَ وُصُولَ
u'تَوَقُّعٌ ولد':Added, #1: 1	تَوَقُّعِ الْوَعْدِ
u'تَوَقُّعٌ وَلَدٌ':Added, #1: 1	تَوَقُّعُ الْوَلَدِ
u'تَوَقَّفَ اِبْنٌ':Subject, #1: 1	تَوَقُّعُ الْوَلَدِ
u'تَوَقُّفٌ اِتِّصَافٌ':Added, #1: 1	تَوَقَّفَ ابْنُ
u'تَوَقَّفَ إِتْيانٌ':Subject, #1: 1	تَوَقُّفُ اتِّصَافِ
u'تَوَقُّفٌ إِثْبَاتٌ':Added, #1: 1	تَوَقَّفَ الْإِتْيَانُ
u'تَوَقُّفٌ إِجْزَاءٌ':Added, #1: 1	تَوَقُّفَ إثْبَاتِ
u'تَوَقُّفٌ أَحْكَامٌ':Added, #1: 1	تَوَقُّفُ الْإِجْزَاءِ
u'تَوَقُّفٌ أَحْكَامٌ':Added, #1: 1	تَوَقُّفَ الْأَحْكَامِ
u'تَوَقُّفٌ أُسْتَاذٌ':Added, #1: 1	تَوَقُّفِ الْأَحْكَامِ
u'تَوَقَّفَ اِسْتِحْقَاقٌ':Subject, #1: 1	تَوَقُّفُ الْأُسْتَاذِ
u'تَوَقُّفٌ اِسْتِحْقَاقٌ':Added, #1: 1	تَوَقَّفَ اسْتِحْقَاقُهُ
u'تَوَقَّفَ اِسْتِناد':Subject, #1: 1	تَوَقُّفُ اسْتِحْقَاقِهِ
u'تَوَقَّفَ أصل':Subject, #1: 1	تَوَقَّفَ اسْتِنَادُ
u'تَوَقَّفَ أًصْلٌ':Subject, #1: 1	تَوَقَّفَ أَصْلُ
u'تَوَقَّفَ إِصْلاحٌ':Subject, #1: 1	تَوَقَّفَ أَصْلُ
u'تَوَقُّفٌ اِعْتِقادٌ':Added, #2: 2	تَوَقَّفَ الْإِصْلَاحُ
u'تَوَقَّفَ إمَامٌ':Subject, #1: 1	تَوَقُّفَ اعْتِقَادِهِ
u'تَوَقُّفٌ أَمْرٌ':Added, #17: 17	تَوَقَّفَ الْإِمَامُ
u'تَوَقُّفٌ أَمْرٌ':Added, #1: 1	تَوَقُّفَ الْأَمْرِ
u'تَوَقَّفَ إِمْساكٌ':Subject, #1: 1	تَوَقُّفُ الْأَمْرِ
u'تَوَقُّفٌ إِمْساكٌ':Added, #1: 1	تَوَقَّفَ الْإِمْسَاكُ
u'تَوَقُّفٌ اِنْصِرافٌ':Added, #1: 1	تَوَقُّفُ الْإِمْسَاكِ
u'تَوَقُّفٌ اِنْعِقَادٌ':Added, #1: 1	تَوَقُّفِ انْصِرَافِ
u'تَوَقُّفٌ أهْلٌ':Added, #1: 1	تَوَقُّفُ انْعِقَادِ
u'تَوَقَّفَ إِيجَابٌ':Subject, #1: 1	تَوَقُّفَ أَهْلِ
u'تَوَقُّفٌ إيصَالٌ':Added, #1: 1	تَوَقَّفَ إيجَابُهُ
u'تَوَقُّفٌ بَحْثٌ':Added, #1: 1	تَوَقُّفِ الْإِيصَالِ
u'تَوَقَّفَ بَعْضٌ':Subject, #1: 1	تَوَقُّفَ الْبَحْثِ
u'تَوَقُّفٌ بَقاءٌ':Added, #2: 2	تَوَقَّفَ بَعْضُ
u'تَوَقَّفَ بَيْعٌ':Subject, #1: 1	تَوَقُّفُ بَقَاءِ
u'تَوَقُّفٌ بَيْعٌ':Added, #1: 1	تَوَقَّفَ الْبَيْعُ
u'تَوَقُّفٌ بَيْعٌ':Added, #1: 1	تَوَقُّفَ الْبَيْعِ
u'تَوَقُّفٌ بَيْعٌ':Added, #1: 1	تَوَقُّفِ بَيْعِ
u'تَوَقُّفٌ تَأْثِيرٌ':Added, #2: 2	تَوَقُّفُ الْبَيْعِ
u'تَوَقُّفٌ تَحْرِيمٌ':Added, #1: 1	تَوَقُّفَ التَّأْثِيرِ
u'تَوَقَّفَ تَحَقُّقٌ':Subject, #1: 1	تَوَقُّفُ التَّحْرِيمِ
u'تَوَقُّفٌ تَحَقُّقٌ':Added, #1: 1	تَوَقَّفَ تَحَقُّقُ
u'تَوَقَّفَ تَحَلُّلٌ':Subject, #1: 1	تَوَقُّفِ تَحَقُّقِهِ
u'تَوَقَّفَ تَحَلُّلٌ':Subject, #1: 1	تَوَقَّفَ التَّحَلُّلُ
u'تَوَقُّفٌ تَحَلُّلٌ':Added, #1: 1	تَوَقَّفَ تَحَلُّلُهُ
u'تَوَقُّفٌ تَسْلِيمٌ':Added, #1: 1	تَوَقُّفِ التَّحَلُّلِ
u'تَوَقَّفَ تَصَرُّفٌ':Subject, #2: 2	تَوَقُّفُ التَّسْلِيمِ
u'تَوَقُّفٌ تَصَرُّفٌ':Added, #1: 1	تَوَقَّفَ تَصَرُّفُهُ
u'تَوَقُّفٌ تَصَرُّفٌ':Added, #1: 1	تَوَقُّفِ التَّصَرُّفَاتِ
u'تَوَقُّفٌ تَصَوُّرٌ':Added, #1: 1	تَوَقُّفِ تَصَرُّفِ
u'تَوَقَّفَ تَكْليفٌ':Subject, #1: 1	تَوَقُّفِ تَصَوُّرِ
u'تَوَقُّفٌ تَكْليفٌ':Added, #1: 1	تَوَقَّفَ التَّكْلِيفُ
u'تَوَقُّفٌ تَكْليفٌ':Added, #1: 1	تَوَقُّفَ التَّكْلِيفِ
u'تَوَقَّفَ تمام':Subject, #1: 1	تَوَقُّفُ التَّكْلِيفِ
u'تَوَقَّفَ تَمامٌ':Subject, #1: 1	تَوَقَّفَ تَمَامُ
u'تَوَقُّفٌ تمام':Added, #1: 1	تَوَقَّفَ تَمَامُ
u'تَوَقُّفٌ تَمامٌ':Added, #1: 1	تَوَقُّفِ التَّمَامِ
u'تَوَقُّفٌ تَوْبَةٌ':Added, #1: 1	تَوَقُّفِ التَّمَامِ
u'تَوَقَّفَ ثُبُوتٌ':Subject, #1: 1	تَوَقُّفِ التَّوْبَةِ
u'تَوَقَّفَ ثُبُوتٌ':Subject, #1: 1	تَوَقَّفَ ثُبُوتُهُ
u'تَوَقُّفٌ ثُبُوتٌ':Added, #2: 2	تَوَقَّفَ ثُبُوتُ
u'تَوَقُّفٌ ثُبُوتٌ':Added, #1: 1	تَوَقُّفَ الثُّبُوتِ
u'تَوَقُّفٌ ثُبُوتٌ':Added, #1: 1	تَوَقُّفُ ثُبُوتِ
u'تَوَقُّفٌ جَزَاءٌ':Added, #2: 2	تَوَقُّفَ ثُبُوتِ
u'تَوَقَّفَ جَمَاعَةٌ':Subject, #1: 1	تَوَقُّفِ الْجَزَاءِ
u'تَوَقَّفَ حَصَادٌ':Subject, #1: 1	تَوَقَّفَ جَمَاعَةٌ
u'تَوَقَّفَ حُكْمٌ':Subject, #1: 1	تَوَقَّفَ حَصَادُهُ
u'تَوَقَّفَ حُكْمٌ':Subject, #1: 1	تَوَقَّفَ حُكْمُ
u'تَوَقَّفَ حُكْمٌ':Subject, #1: 1	تَوَقَّفَ حُكْمُهُ
u'تَوَقُّفٌ حُكْمٌ':Added, #3: 3	تَوَقَّفَ الْحُكْمُ
u'تَوَقُّفٌ حُكْمٌ':Added, #1: 1	تَوَقُّفُ الْحُكْمِ
u'تَوَقُّفٌ حُكْمٌ':Added, #1: 1	تَوَقُّفِ الْحُكْمِ
u'تَوَقُّفٌ حُكْمٌ':Added, #1: 1	تَوَقُّفُ حُكْمٍ
u'تَوَقُّفٌ حُكْمٌ':Added, #1: 1	تَوَقُّفُ حُكْمِ
u'تَوَقُّفٌ حَلٌّ':Added, #1: 1	تَوَقُّفِ حُكْمِهِ
u'تَوَقُّفٌ حِنْثٌ':Added, #1: 1	تَوَقُّفِ حَلِّ
u'تَوَقُّفٌ حَوَالَةٌ':Added, #1: 1	تَوَقُّفِ الْحِنْثِ
u'تَوَقَّفَ خُرُوجٌ':Subject, #1: 1	تَوَقُّفُ الْحَوَالَةِ
u'تَوَقُّفٌ خُرُوجٌ':Added, #1: 1	تَوَقَّفَ الْخُرُوجُ
u'تَوَقَّفَ دفن':Subject, #1: 1	تَوَقُّفِ الْخُرُوجِ
u'تَوَقَّفَ دَفْنٌ':Subject, #1: 1	تَوَقَّفَ الدَّفْنُ
u'تَوَقُّفٌ دَليلٌ':Added, #1: 1	تَوَقَّفَ الدَّفْنُ
u'تَوَقَّفَ رِضاً':Subject, #1: 1	تَوَقُّفَ الدَّلِيلِ
u'تَوَقَّفَ زَوالٌ':Subject, #1: 1	تَوَقَّفَ رِضَاهُ
u'تَوَقُّفٌ سائِل':Added, #1: 1	تَوَقَّفَ زَوَالُ
u'تَوَقُّفٌ سَائِلٌ':Added, #1: 1	تَوَقُّفِ السَّائِلِ
u'تَوَقَّفَ سُقُوطٌ':Subject, #1: 1	تَوَقُّفِ السَّائِلِ
u'تَوَقَّفَ شَهَادَةٌ':Predicate, #1: 1	تَوَقَّفَ سُقُوطُ
u'تَوَقُّفٌ شَهَادَةٌ':Added, #1: 1	تَوَقَّفَ الشَّهَادَةَ
u'تَوَقُّفٌ شَيْءٌ':Added, #1: 1	تَوَقُّفُ الشَّهَادَةِ
u'تَوَقَّفَ شَيْخٌ':Subject, #1: 1	تَوَقُّفُ الشَّيْءِ
u'تَوَقَّفَ صَاحِبٌ':Subject, #1: 1	تَوَقَّفَ الشَّيْخُ
u'تَوَقُّفٌ صَحَابَةٌ':Added, #1: 1	تَوَقَّفَ صَاحِبُ
u'تَوَقَّفَ صِحَّةٌ':Subject, #1: 1	تَوَقُّفِ الصَّحَابَةِ
u'تَوَقُّفٌ صِحَّةٌ':Added, #2: 2	تَوَقَّفَ صِحَّةُ
u'تَوَقُّفٌ صِحَّةٌ':Added, #1: 1	تَوَقُّفُ صِحَّةِ
u'تَوَقُّفٌ صِحَّةٌ':Added, #2: 2	تَوَقُّفَ صِحَّةِ
u'تَوَقَّفَ صدق':Subject, #3: 3	تَوَقُّفِ صِحَّةِ
u'تَوَقَّفَ صِدْقٌ':Subject, #1: 1	تَوَقَّفَ صِدْقُ
u'تَوَقُّفٌ صدق':Added, #1: 1	تَوَقَّفَ صِدْقُ
u'تَوَقُّفٌ صِدْقٌ':Added, #1: 1	تَوَقُّفُ الصِّدْقِ
u'تَوَقَّفَ صلح':Subject, #1: 1	تَوَقُّفُ الصِّدْقِ
u'تَوَقَّفَ صُلْحٌ':Subject, #1: 1	تَوَقَّفَ الصُّلْحُ
u'تَوَقُّفٌ صَوْمٌ':Added, #1: 1	تَوَقَّفَ الصُّلْحُ
u'تَوَقُّفٌ طَلاَقٌ':Added, #1: 1	تَوَقُّفَ الصَّوْمِ
u'تَوَقَّفَ ظَنٌّ':Subject, #1: 1	تَوَقُّفَ طَلَاقِ
u'تَوَقَّفَ ظهار':Subject, #1: 1	تَوَقَّفَ الظَّنُّ
u'تَوَقُّفٌ ظهار':Added, #1: 1	تَوَقَّفَ الظِّهَارُ
u'تَوَقَّفَ عتق':Subject, #1: 1	تَوَقُّفُ الظِّهَارِ
u'تَوَقَّفَ عِتْقٌ':Subject, #1: 1	تَوَقَّفَ الْعِتْقُ
u'تَوَقَّفَ عتق':Subject, #1: 1	تَوَقَّفَ الْعِتْقُ
u'تَوَقَّفَ عِتْقٌ':Subject, #1: 1	تَوَقَّفَ عِتْقُ
u'تَوَقُّفٌ عتق':Added, #1: 1	تَوَقَّفَ عِتْقُ
u'تَوَقُّفٌ عِتْقٌ':Added, #1: 1	تَوَقُّفَ الْعِتْقِ
u'تَوَقُّفٌ عتق':Added, #1: 1	تَوَقُّفَ الْعِتْقِ
u'تَوَقُّفٌ عِتْقٌ':Added, #2: 2	تَوَقُّفِ الْعِتْقِ
u'تَوَقُّفٌ عزل':Added, #2: 2	تَوَقُّفِ الْعِتْقِ
u'تَوَقَّفَ عَقْدٌ':Subject, #1: 1	تَوَقُّفِ الْعَزْلِ
u'تَوَقُّفٌ عَقْدٌ':Added, #3: 3	تَوَقَّفَ الْعَقْدُ
u'تَوَقُّفٌ عَقْدٌ':Added, #1: 1	تَوَقُّفَ الْعَقْدِ
u'تَوَقُّفٌ عَمَلٌ':Added, #1: 1	تَوَقُّفِ الْعَقْدِ
u'تَوَقُّفٌ عِيَادَةٌ':Added, #1: 1	تَوَقُّفِ الْعَمَلِ
u'تَوَقُّفٌ فَسْخٌ':Added, #1: 1	تَوَقُّفُ الْعِيَادَةِ
u'تَوَقُّفٌ فَسْخٌ':Added, #1: 1	تَوَقُّفِ الْفَسْخِ
u'تَوَقُّفٌ فَسْخٌ':Added, #1: 1	تَوَقُّفِ فَسْخِ
u'تَوَقُّفٌ قَدْرٌ':Added, #1: 1	تَوَقُّفِ فَسْخِهِ
u'تَوَقُّفٌ قَطْعٌ':Added, #1: 1	تَوَقُّفَ الْقَدْرِ
u'تَوَقُّفٌ قلب':Added, #2: 2	تَوَقُّفِ الْقَطْعِ
u'تَوَقُّفٌ قَلْبٌ':Added, #1: 1	تَوَقُّفُ الْقَلْبِ
u'تَوَقُّفٌ قَلْب':Added, #1: 1	تَوَقُّفُ الْقَلْبِ
u'تَوَقُّفٌ كَلاَمٌ':Added, #1: 1	تَوَقُّفُ الْقَلْبِ
u'تَوَقُّفٌ مَحْكُومٌ':Added, #1: 1	تَوَقُّفِ الْكَلَامِ
u'تَوَقَّفَ مُحَمَّدٌ':Subject, #1: 1	تَوَقُّفِ الْمَحْكُومِ
u'تَوَقُّفٌ مُطَالَبٌ':Added, #1: 1	تَوَقَّفَ مُحَمَّدٌ
u'تَوَقُّفٌ مُطَالَبَةٌ':Added, #1: 1	تَوَقُّفِ الْمُطَالَبَةِ
u'تَوَقُّفٌ مَطْلُوبٌ':Added, #1: 1	تَوَقُّفِ الْمُطَالَبَةِ
u'تَوَقُّفٌ مُطَهِّرٌ':Added, #1: 1	تَوَقُّفُ الْمَطْلُوبِ
u'تَوَقُّفٌ مَعْرِفَةٌ':Added, #1: 1	تَوَقُّفُ مُطَهِّرٍ
u'تَوَقُّفٌ مَعْرِفَة':Added, #1: 1	تَوَقُّفُ مَعْرِفَةِ
u'تَوَقُّفٌ مَقْصُودٌ':Added, #1: 1	تَوَقُّفُ مَعْرِفَةِ
u'تَوَقَّفَ مِلْكٌ':Subject, #1: 1	تَوَقُّفَ الْمَقْصُودِ
u'تَوَقُّفٌ مِلْكٌ':Added, #3: 3	تَوَقَّفَ الْمِلْكُ
u'تَوَقُّفٌ مِلْكٌ':Added, #1: 1	تَوَقُّفُ الْمِلْكِ
u'تَوَقُّفٌ مِلْكٌ':Added, #1: 1	تَوَقُّفُ مِلْكِهِ
u'تَوَقُّفٌ مُؤَلِّفٌ':Added, #5: 5	تَوَقُّفِ الْمِلْكِ
u'تَوَقُّفٌ نِصْفٌ':Added, #2: 2	تَوَقُّفُ الْمُؤَلِّفِ
u'تَوَقَّفَ نُفُوذٌ':Subject, #1: 1	تَوَقُّفِ النِّصْفِ
u'تَوَقَّفَ نُفُوذٌ':Subject, #2: 2	تَوَقَّفَ نُفُوذُ
u'تَوَقَّفَ نكاح':Subject, #2: 2	تَوَقَّفَ نُفُوذُهُ
u'تَوَقَّفَ نِكَاحٌ':Subject, #2: 2	تَوَقَّفَ نِكَاحُ
u'تَوَقَّفَ نكاح':Subject, #2: 2	تَوَقَّفَ نِكَاحُ
u'تَوَقَّفَ نِكَاحٌ':Subject, #3: 3	تَوَقَّفَ النِّكَاحُ
u'تَوَقُّفٌ نكاح':Added, #3: 3	تَوَقَّفَ النِّكَاحُ
u'تَوَقُّفٌ نِكَاحٌ':Added, #3: 3	تَوَقُّفِ النِّكَاحِ
u'تَوَقَّفَ وُجُوبٌ':Subject, #3: 3	تَوَقُّفِ النِّكَاحِ
u'تَوَقُّفٌ وُجُوبٌ':Added, #2: 2	تَوَقَّفَ وُجُوبُ
u'تَوَقَّفَ وُجُودٌ':Subject, #1: 1	تَوَقُّفُ الْوُجُوبِ
u'تَوَقُّفٌ وُجُودٌ':Added, #5: 5	تَوَقَّفَ وُجُودُهُ
u'تَوَقَّفَ وُصُولٌ':Subject, #1: 1	تَوَقُّفِ الْوُجُودِ
u'تَوَقَّفَ وُقُوعٌ':Subject, #1: 1	تَوَقَّفَ وُصُولُهُ
u'تَوَقَّفَ وُقُوعٌ':Subject, #2: 2	تَوَقَّفَ الْوُقُوعُ
u'تَوَقُّفٌ وُقُوعٌ':Added, #2: 2	تَوَقَّفَ وُقُوعُ
u'تَوَقُّفٌ وُقُوعٌ':Added, #1: 1	تَوَقُّفُ الْوُقُوعِ
u'تَوَقَّفَ وَلاَءٌ':Subject, #1: 1	تَوَقُّفِ وُقُوعِ
u'تَوَقُّفٌ وِلاَدَةٌ':Added, #1: 1	تَوَقَّفَ الْوَلَاءُ
u'تَوَقُّفٌ يَمِينٌ':Added, #1: 1	تَوَقُّفَ الْوِلَادَةِ
u'تَوَقِّي أدناس':Added, #1: 1	تَوَقُّفِ الْيَمِينِ
u'تَوَقِّي أَدْناسٌ':Added, #1: 1	تَوَقِّي الْأَدْنَاسِ
u'تَوَقِّي أَلْفَاظٌ':Added, #1: 1	تَوَقِّي الْأَدْنَاسِ
u'تَوَقَّى أَوْقَاتٌ':Predicate, #1: 1	تَوَقِّي الْأَلْفَاظِ
u'تَوْقِيرٌ أهْلٌ':Added, #1: 1	تَوَقَّى أَوْقَاتَ
u'تَوَقَّى رَجُلٌ':Subject, #2: 2	تَوْقِيرِ أَهْلِ
u'تَوْقِيرٌ جَلاَلٌ':Added, #1: 1	تَوَقَّى رَجُلٌ
u'تَوْقِيرٌ صَاحِبٌ':Added, #1: 1	تَوْقِيرِ جَلَالِ
u'تَوْقِيرٌ قُرْآنٌ':Added, #1: 1	تَوْقِيرَ صَاحِبِ
u'تَوْقِيعٌ وَلِيٌّ':Added, #1: 1	تَوْقِيرِ الْقُرْآنِ
u'تَوْقِيفٌ إمَامٌ':Added, #1: 1	تَوْقِيعِ وَلِيِّ
u'تَوْقِيفٌ بَعْضٌ':Added, #1: 1	تَوْقِيفُ الْإِمَامِ
u'تَوْقِيفٌ ثَابِتٌ':Added, #1: 1	تَوْقِيفُ الْبَعْضِ
u'تَوْقِيفٌ حالٌ':Added, #1: 1	تَوْقِيفٍ ثَابِتٍ
u'تَوْقِيفٌ حُكَّامٌ':Added, #1: 1	تَوْقِيفَ حَالِ
u'تَوْقِيفٌ شَارِعٌ':Added, #6: 6	تَوْقِيفِ الْحُكَّامِ
u'تَوْقِيفٌ شَرْعٌ':Added, #1: 1	تَوْقِيفِ الشَّارِعِ
u'تَوْقِيفٌ لُغَةٌ':Added, #1: 1	تَوْقِيفِ الشَّرْعِ
u'تَوْقِيفٌ مَانِعٌ':Added, #1: 1	تَوْقِيفِ اللُّغَةِ
u'تَوَقِّي كبائر':Added, #1: 1	تَوْقِيفِ مَانِعٍ
u'تَوَقِّي كذب':Added, #2: 2	تَوَقِّي الْكَبَائِرِ
u'تَوَقِّي كَذِبٌ':Added, #1: 1	تَوَقِّي الْكَذِبِ
u'تَوَقِّي لِسَانٌ':Added, #1: 1	تَوَقِّي الْكَذِبِ
u'تَوَقِّي مَقَاتِلُ':Added, #1: 1	تَوَقِّي اللِّسَانِ
u'تَوَقِّي مَكَارِهُ':Added, #1: 1	تَوَقِّي مَقَاتِلِهِ
u'تَوَقِّي مَوَاضِعُ':Added, #1: 1	تَوَقِّي الْمَكَارِهِ
u'تَوَكُّلٌ الْمَرْءُ':Added, #1: 1	تَوَقِّي الْمَوَاضِعِ
u'تَوَكَّلَ رَقيقٌ':Subject, #1: 1	تَوَكُّلِ الْمَرْءِ
u'تَوَكَّلَ رَقيق':Subject, #1: 1	تَوَكَّلَ الرَّقِيقُ
u'تَوَكُّلٌ صَبِيٌّ':Added, #1: 1	تَوَكَّلَ الرَّقِيقُ
u'تَوَكَّلَ عَبْدٌ':Subject, #1: 1	تَوَكُّلَ الصَّبِيِّ
u'تَوَكُّلٌ عَبْدٌ':Added, #1: 1	تَوَكَّلَ الْعَبْدُ
u'تَوَكُّلٌ عَدُوٌّ':Added, #1: 1	تَوَكُّلُ الْعَبْدِ
u'تَوَكُّلٌ مَحْجُورٌ':Added, #1: 1	تَوَكُّلِ الْعَدُوِّ
u'تَوَكُّلٌ مُسْلِمٌ':Added, #1: 1	تَوَكُّلِ الْمَحْجُورِ
u'تَوَكُّلٌ وَكِيلٌ':Added, #1: 1	تَوَكُّلُ الْمُسْلِمِ
u'تَوْكِيدٌ تَحْرِيمٌ':Added, #1: 1	تَوَكُّلِ الْوَكِيلِ
u'تَوْكِيدٌ ثَلاثَةٌ':Added, #1: 1	تَوْكِيدُ التَّحْرِيمِ
u'تَوْكِيدٌ كَلاَمٌ':Added, #1: 1	تَوْكِيدُ ثَلَاثَةٍ
u'تَوْكِيدٌ يَمِينٌ':Added, #1: 1	تَوْكِيدُ الْكَلَامِ
u'تَوْكِيلٌ أَبٌ':Added, #2: 2	تَوْكِيدِ الْيَمِينِ
u'تَوْكِيلٌ أَجْنَبِيٌّ':Added, #1: 1	تَوْكِيلُ الْأَبِ
u'تَوْكِيلٌ الْمَرْأَةُ':Added, #1: 1	تَوْكِيلِ الْأَجْنَبِيِّ
u'تَوْكِيلٌ اِمْرَأَةٌ':Added, #2: 2	تَوْكِيلُ الْمَرْأَةِ
u'تَوْكِيلٌ اِمْرَأَةٌ':Added, #1: 1	تَوْكِيلَ امْرَأَةٍ
u'تَوْكِيلٌ بَائِعٌ':Added, #2: 2	تَوْكِيلُ امْرَأَةٍ
u'تَوْكِيلٌ بَيْعٌ':Added, #1: 1	تَوْكِيلُ بَائِعِهِ
u'تَوْكِيلٌ بَيْعٌ':Added, #1: 1	تَوْكِيلُ بَيْعِ
u'تَوْكِيلٌ ثَالِثٌ':Added, #1: 1	تَوْكِيلِ بَيْعٍ
u'تَوْكِيلٌ حاضِرٌ':Added, #1: 1	تَوْكِيلَ ثَالِثٍ
u'تَوْكِيلٌ حُرٌّ':Added, #2: 2	تَوْكِيلِ الْحَاضِرِ
u'تَوْكِيلٌ دَائِنٌ':Added, #1: 1	تَوْكِيلِ الْحُرِّ
u'تَوْكِيلٌ ذِمِّيٌّ':Added, #1: 1	تَوْكِيلُ الدَّائِنِ
u'تَوْكِيلٌ ذِمِّيٌّ':Added, #1: 1	تَوْكِيلَ الذِّمِّيِّ
u'تَوْكِيلٌ ذِمِّيٌّ':Added, #2: 2	تَوْكِيلِ الذِّمِّيِّ
u'تَوْكِيلٌ ذِمِّيٌّ':Added, #2: 2	تَوْكِيلُ ذِمِّيٍّ
u'تَوْكِيلٌ رَاهِنٌ':Added, #4: 4	تَوْكِيلُ الذِّمِّيِّ
u'تَوْكِيلٌ رَجُلٌ':Added, #2: 2	تَوْكِيلِ الرَّاهِنِ
u'تَوْكِيلٌ رَجُلٌ':Added, #1: 1	تَوْكِيلِ الرَّجُلِ
u'تَوْكِيلٌ رَقيقٌ':Added, #1: 1	تَوْكِيلِ الرَّجُلَيْنِ
u'تَوْكِيلٌ رَقيق':Added, #2: 2	تَوْكِيلُ الرَّقِيقِ
u'تَوْكِيلٌ زَوْجٌ':Added, #2: 2	تَوْكِيلُ الرَّقِيقِ
u'تَوْكِيلٌ زَوْجٌ':Added, #1: 1	تَوْكِيلِ الزَّوْجِ
u'تَوْكِيلٌ زَوْجٌ':Added, #1: 1	تَوْكِيلُ الزَّوْجَيْنِ
u'تَوْكِيلٌ زَوْجٌ':Added, #1: 1	تَوْكِيلُ زَوْجٍ
u'تَوْكِيلٌ زَوْجٌ':Added, #2: 2	تَوْكِيلُ الزَّوْجِ
u'تَوْكِيلٌ زَوْجَةٌ':Added, #2: 2	تَوْكِيلُ زَوْجِ
u'تَوْكِيلٌ زَوْجَةٌ':Added, #1: 1	تَوْكِيلُ الزَّوْجَةِ
u'تَوْكِيلٌ زَيْدٌ':Added, #1: 1	تَوْكِيلِ الزَّوْجَةِ
u'تَوْكِيلٌ سَارِقٌ':Added, #1: 1	تَوْكِيلِ زَيْدٍ
u'تَوْكِيلٌ سَالِمٌ':Added, #1: 1	تَوْكِيلِ السَّارِقِ
u'تَوْكِيلٌ سَفِيهٌ':Added, #1: 1	تَوْكِيلٍ سَالِمٍ
u'تَوْكِيلٌ سَكْرَان':Added, #3: 3	تَوْكِيلُ السَّفِيهِ
u'تَوْكِيلٌ شَخْصٌ':Added, #1: 1	تَوْكِيلُ السَّكْرَانِ
u'تَوْكِيلٌ شِرَاءٌ':Added, #1: 1	تَوْكِيلُ شَخْصٍ
u'تَوْكِيلٌ شَرِيكٌ':Added, #1: 1	تَوْكِيلُ شِرَاءِ
u'تَوْكِيلٌ شَفِيعٌ':Added, #1: 1	تَوْكِيلِ الشَّرِيكِ
u'تَوْكِيلٌ صَبِيٌّ':Added, #1: 1	تَوْكِيلُ الشَّفِيعِ
u'تَوْكِيلٌ صَبِيٌّ':Added, #1: 1	تَوْكِيلِ الصَّبِيِّ
u'تَوْكِيلٌ صَبِيٌّ':Added, #2: 2	تَوْكِيلَ الصَّبِيِّ
u'تَوْكِيلٌ صَبِيٌّ':Added, #2: 2	تَوْكِيلُ صَبِيٍّ
u'تَوْكِيلٌ طَالِبٌ':Added, #4: 4	تَوْكِيلُ الصَّبِيِّ
u'تَوْكِيلٌ عَبْدٌ':Added, #1: 1	تَوْكِيلُ الطَّالِبِ
u'تَوْكِيلٌ عَبْدٌ':Added, #1: 1	تَوْكِيلَ عَبْدِ
u'تَوْكِيلٌ عَبْدٌ':Added, #2: 2	تَوْكِيلُ عَبْدٍ
u'تَوْكِيلٌ عَبْدٌ':Added, #3: 3	تَوْكِيلُ عَبْدِ
u'تَوْكِيلٌ عَبْدٌ':Added, #4: 4	تَوْكِيلِ الْعَبْدِ
u'تَوْكِيلٌ عَدُوٌّ':Added, #6: 6	تَوْكِيلُ الْعَبْدِ
u'تَوْكِيلٌ غَائِبٌ':Added, #1: 1	تَوْكِيلُ عَدُوِّ
u'تَوْكِيلٌ غَرِيمٌ':Added, #1: 1	تَوْكِيلَ الْغَائِبِ
u'تَوْكِيلٌ غَرِيمٌ':Added, #1: 1	تَوْكِيلُ غَرِيمِ
u'تَوْكِيلٌ غَرِيمٌ':Added, #1: 1	تَوْكِيلِ غَرِيمِ
u'تَوْكِيلٌ غَنِيٌّ':Added, #2: 2	تَوْكِيلِ الْغَرِيمِ
u'تَوْكِيلٌ غير':Added, #1: 1	تَوْكِيلِ الْغَنِيِّ
u'تَوْكِيلٌ غَيْرٌ':Added, #1: 1	تَوْكِيلِ غَيْرِهِ
u'تَوْكِيلٌ غير':Added, #1: 1	تَوْكِيلِ غَيْرِهِ
u'تَوْكِيلٌ غَيْرٌ':Added, #2: 2	تَوْكِيلَ غَيْرِهِ
u'تَوْكِيلٌ غير':Added, #2: 2	تَوْكِيلَ غَيْرِهِ
u'تَوْكِيلٌ غَيْرٌ':Added, #4: 4	تَوْكِيلُ غَيْرِ
u'تَوْكِيلٌ غير':Added, #4: 4	تَوْكِيلُ غَيْرِ
u'تَوْكِيلٌ غَيْرٌ':Added, #5: 5	تَوْكِيلُ غَيْرِهِ
u'تَوْكِيلٌ فَاسِقٌ':Added, #5: 5	تَوْكِيلُ غَيْرِهِ
u'تَوْكِيلٌ فَاسِقٌ':Added, #1: 1	تَوْكِيلُ الْفَاسِقِ
u'تَوْكِيلٌ فُلاَنٌ':Added, #7: 7	تَوْكِيلُ فَاسِقٍ
u'تَوْكِيلٌ فُلاَنٌ':Added, #1: 1	تَوْكِيلِ فُلَانٍ
u'تَوْكِيلٌ قَابِضٌ':Added, #3: 3	تَوْكِيلُ فُلَانٍ
u'تَوْكِيلٌ قَيِّمٌ':Added, #1: 1	تَوْكِيلَ الْقَابِضِ
u'تَوْكِيلٌ كَافِرٌ':Added, #1: 1	تَوْكِيلِ الْقَيِّمِ
u'تَوْكِيلٌ كَافِرٌ':Added, #1: 1	تَوْكِيلُ كَافِرٍ
u'تَوْكِيلٌ كَفِيلٌ':Added, #2: 2	تَوْكِيلُ الْكَافِرِ
u'تَوْكِيلٌ كَفِيلٌ':Added, #1: 1	تَوْكِيلَ الْكَفِيلِ
u'تَوْكِيلٌ كَفِيلٌ':Added, #1: 1	تَوْكِيلِ الْكَفِيلِ
u'تَوْكِيلٌ مُجْبِرٌ':Added, #2: 2	تَوْكِيلُ الْكَفِيلِ
u'تَوْكِيلٌ مَجْنُونٌ':Added, #1: 1	تَوْكِيلِ الْمُجْبِرِ
u'تَوْكِيلٌ مَجْهُولٌ':Added, #2: 2	تَوْكِيلُ مَجْنُونٍ
u'تَوْكِيلٌ مَحْجُورٌ':Added, #1: 1	تَوْكِيلِ الْمَجْهُولِ
u'تَوْكِيلٌ مَحْجُورٌ':Added, #1: 1	تَوْكِيلِ الْمَحْجُورِ
u'تَوْكِيلٌ مُحْرِمٌ':Added, #1: 1	تَوْكِيلُ مَحْجُورٍ
u'تَوْكِيلٌ مُحْرِمٌ':Added, #1: 1	تَوْكِيلِ الْمُحْرِمِ
u'تَوْكِيلٌ مُخَدَّرٌ':Added, #2: 2	تَوْكِيلُ الْمُحْرِمِ
u'تَوْكِيلٌ مَدِينٌ':Added, #1: 1	تَوْكِيلِ الْمُخَدَّرَةِ
u'تَوْكِيلٌ مَدْيُونٌ':Added, #1: 1	تَوْكِيلِ الْمَدِينِ
u'تَوْكِيلٌ مُرْتَدٌّ':Added, #1: 1	تَوْكِيلُ الْمَدْيُونِ
u'تَوْكِيلٌ مُرْتَهِنٌ':Added, #3: 3	تَوْكِيلُ الْمُرْتَدِّ
u'تَوْكِيلٌ مُسْلِمٌ':Added, #1: 1	تَوْكِيلُ الْمُرْتَهِنِ
u'تَوْكِيلٌ مُسْلِمٌ':Added, #1: 1	تَوْكِيلِ مُسْلِمٍ
u'تَوْكِيلٌ مُسْلِمٌ':Added, #2: 2	تَوْكِيلِ الْمُسْلِمِ
u'تَوْكِيلٌ مُسْلِمٌ':Added, #2: 2	تَوْكِيلُ مُسْلِمٍ
u'تَوْكِيلٌ مَطْلُوبٌ':Added, #4: 4	تَوْكِيلُ الْمُسْلِمِ
u'تَوْكِيلٌ مُعْسِرٌ':Added, #1: 1	تَوْكِيلُ الْمَطْلُوبِ
u'تَوْكِيلٌ مُفْلِسٌ':Added, #1: 1	تَوْكِيلُ مُعْسِرٍ
u'تَوْكِيلٌ مَقْذُوفٌ':Added, #1: 1	تَوْكِيلُ الْمُفْلِسِ
u'تَوْكِيلٌ مُمَيِّزٌ':Added, #1: 1	تَوْكِيلُ الْمَقْذُوفِ
u'تَوْكِيلٌ مُمَيَّزٌ':Added, #1: 1	تَوْكِيلِ الْمُمَيِّزِ
u'تَوْكِيلٌ مُوسِرٌ':Added, #2: 2	تَوْكِيلِ مُمَيَّزٍ
u'تَوْكِيلٌ مُوَكِّلٌ':Added, #1: 1	تَوْكِيلُ الْمُوسِرِ
u'تَوْكِيلٌ نَصْرَانِيٌّ':Added, #1: 1	تَوْكِيلُ الْمُوَكِّلِ
u'تَوْكِيلٌ واحد':Added, #1: 1	تَوْكِيلُ نَصْرَانِيٍّ
u'تَوْكِيلٌ وَاحِدٌ':Added, #1: 1	تَوْكِيلِ الْوَاحِدِ
u'تَوْكِيلٌ وَصِيٌّ':Added, #1: 1	تَوْكِيلِ الْوَاحِدِ
u'تَوْكِيلٌ وَكِيلٌ':Added, #3: 3	تَوْكِيلِ الْوَصِيِّ
u'تَوْكِيلٌ وَكِيلٌ':Added, #1: 1	تَوْكِيلُ وَكِيلَيْنِ
u'تَوْكِيلٌ وَكِيلٌ':Added, #2: 2	تَوْكِيلَ الْوَكِيلِ
u'تَوْكِيلٌ وَكِيلٌ':Added, #2: 2	تَوْكِيلُ الْوَكِيلِ
u'تَوْكِيلٌ وَلِيٌّ':Added, #8: 8	تَوْكِيلِ الْوَكِيلِ
u'تَوْكِيلٌ وَلِيٌّ':Added, #1: 1	تَوْكِيلُ الْوَلِيِّ
u'تَوَلَّدَ بَيْنٌ':Predicate, #3: 3	تَوْكِيلِ الْوَلِيِّ
u'تَوَلَّدَ ضَرَرٌ':Subject, #10: 10	تَوَلَّدَ بَيْنَ
u'تَوَلُّدٌ طَاهِرٌ':Added, #1: 1	تَوَلَّدَ الضَّرَرُ
u'تَوَلُّدٌ قَمْلٌ':Added, #1: 1	تَوَلُّدِ طَاهِرٍ
u'تَوَلُّدٌ قُمَّلٌ':Added, #1: 1	تَوَلُّدِ الْقَمْلِ
u'تَوَلُّدٌ كبر':Added, #1: 1	تَوَلُّدِ الْقُمَّلِ
u'تَوَلُّدٌ كِبْرٌ':Added, #1: 1	تَوَلُّدُ الْكِبْرِ
u'تَوَلَّدَ مَوْتٌ':Subject, #1: 1	تَوَلُّدُ الْكِبْرِ
u'تَوَلَّدَ هلاك':Subject, #1: 1	تَوَلَّدَ الْمَوْتُ
u'تَوَلَّدَ هَلاَكٌ':Subject, #1: 1	تَوَلَّدَ الْهَلَاكُ
u'تَوَلُّدٌ هلاك':Added, #1: 1	تَوَلَّدَ الْهَلَاكُ
u'تَوَلُّدٌ هَلاَكٌ':Added, #1: 1	تَوَلُّدُ الْهَلَاكِ
u'تَوَلُّعٌ مَعِدَةٌ':Added, #1: 1	تَوَلُّدُ الْهَلَاكِ
u'تَوَلَّى أَبٌ':Subject, #1: 1	تَوَلُّعُ الْمَعِدَةِ
u'تَوَلَّى أحَدٌ':Subject, #2: 2	تَوَلَّى الْأَبُ
u'تَوَلَّى أَدَاءٌ':Predicate, #1: 1	تَوَلَّى أَحَدُ
u'تَوَلَّى إفْكٌ':Predicate, #1: 1	تَوَلَّى الْأَدَاءَ
u'تَوَلَّى إمَامٌ':Subject, #1: 1	تَوَلَّى الْإِفْكَ
u'تَوَلِّي إمَامَةٌ':Added, #3: 3	تَوَلَّى إمَامٌ
u'تَوَلَّى أَمْرٌ':Predicate, #1: 1	تَوَلِّي الْإِمَامَةِ
u'تَوَلَّى آمِرٌ':Subject, #1: 1	تَوَلَّى الْأَمْرَ
u'تَوَلِّي إِنْسانٌ':Added, #2: 2	تَوَلَّى الْآمِرُ
u'تَوَلَّى بَعْضٌ':Subject, #1: 1	تَوَلِّي الْإِنْسَانِ
u'تَوَلَّى بَيَانٌ':Predicate, #1: 1	تَوَلَّى بَعْضُ
u'تَوَلَّى بَيْعٌ':Predicate, #4: 4	تَوَلَّى بَيَانَ
u'تَوَلَّى بَيْعٌ':Predicate, #1: 1	تَوَلَّى بَيْعَ
u'تَوْلِيَةٌ إمَارَةٌ':Added, #2: 2	تَوَلَّى الْبَيْعَ
u'تَوْلِيَةٌ إمَامٌ':Added, #1: 1	تَوْلِيَةُ الْإِمَارَةِ
u'تَوْلِيَةٌ إمَامٌ':Added, #1: 1	تَوْلِيَةِ الإِمَامِ
u'تَوْلِيَةٌ إمَامٌ':Added, #1: 1	تَوْلِيَةِ الْإِمَامِ
u'تَوْلِيَةٌ أَمْثَلُ':Added, #1: 1	تَوْلِيَةُ إمَامٍ
u'تَوْلِيَةٌ أهْلٌ':Added, #1: 1	تَوْلِيَةُ الْأَمْثَلِ
u'تَوْلِيَةٌ أئِمَّةٌ':Added, #1: 1	تَوْلِيَةِ أَهْلِ
u'تَوْلِيَةٌ بَيْعٌ':Added, #2: 2	تَوْلِيَةِ الْأَئِمَّةِ
u'تَوْلِيَةٌ بَيْعٌ':Added, #1: 1	تَوْلِيَةِ الْبَيْعِ
u'تَوْلِيَةٌ جَاهِلٌ':Added, #1: 1	تَوْلِيَةِ بَيْعِ
u'تَوْلِيَةٌ جَائِرٌ':Added, #1: 1	تَوْلِيَةَ الْجَاهِلِ
u'تَوْلِيَةٌ حاكِمٌ':Added, #1: 1	تَوْلِيَةُ جَائِرٍ
u'تَوْلِيَةٌ حاكِمٌ':Added, #1: 1	تَوْلِيَةَ الْحَاكِمِ
u'تَوْلِيَةٌ حَرِيصٌ':Added, #1: 1	تَوْلِيَةُ حَاكِمَيْنِ
u'تَوْلِيَةٌ حُكْمٌ':Added, #2: 2	تَوْلِيَةُ الْحَرِيصِ
u'تَوْلِيَةٌ خَائِنٌ':Added, #2: 2	تَوْلِيَةِ الْحُكْمِ
u'تَوْلِيَةٌ خَصْمٌ':Added, #1: 1	تَوْلِيَةُ الْخَائِنِ
u'تَوْلِيَةٌ دَمٌ':Added, #1: 1	تَوْلِيَةُ الْخَصْمَيْنِ
u'تَوْلِيَةٌ سُلْطَانٌ':Added, #1: 1	تَوْلِيَةِ الدَّمِ
u'تَوْلِيَةٌ شَخْصٌ':Added, #1: 1	تَوْلِيَةُ السُّلْطَانِ
u'تَوْلِيَةٌ طَالِبٌ':Added, #1: 1	تَوْلِيَةِ شَخْصٍ
u'تَوْلِيَةٌ عَاجِزٌ':Added, #1: 1	تَوْلِيَةُ الطَّالِبِ
u'تَوْلِيَةٌ عَاقِدٌ':Added, #1: 1	تَوْلِيَةُ الْعَاجِزِ
u'تَوْلِيَةٌ عَدْلٌ':Added, #1: 1	تَوْلِيَةِ الْعَاقِدِ
u'تَوْلِيَةٌ عَهْدٌ':Added, #1: 1	تَوْلِيَةِ عَدْلٍ
u'تَوْلِيَةٌ غير':Added, #1: 1	تَوْلِيَةِ الْعَهْدِ
u'تَوْلِيَةٌ غَيْرٌ':Added, #1: 1	تَوْلِيَةُ غَيْرِ
u'تَوْلِيَةٌ غير':Added, #1: 1	تَوْلِيَةُ غَيْرِ
u'تَوْلِيَةٌ غَيْرٌ':Added, #1: 1	تَوْلِيَةُ غَيْرِهِ
u'تَوْلِيَةٌ غير':Added, #1: 1	تَوْلِيَةُ غَيْرِهِ
u'تَوْلِيَةٌ غَيْرٌ':Added, #4: 4	تَوْلِيَةِ غَيْرِهِ
u'تَوْلِيَةٌ فَاسِقٌ':Added, #4: 4	تَوْلِيَةِ غَيْرِهِ
u'تَوْلِيَةٌ فَاسِقٌ':Added, #1: 1	تَوْلِيَةِ الْفَاسِقِ
u'تَوْلِيَةٌ فَاسِقٌ':Added, #1: 1	تَوْلِيَةُ فَاسِقٍ
u'تَوْلِيَةٌ قَاضِي':Added, #3: 3	تَوْلِيَةُ الْفَاسِقِ
u'تَوْلِيَةٌ قَاضِي':Added, #1: 1	تَوْلِيَةَ قَاضِيَيْنِ
u'تَوْلِيَةٌ قَضَاءٌ':Added, #4: 4	تَوْلِيَةُ قَاضِيَيْنِ
u'تَوْلِيَةٌ قَضَاءٌ':Added, #1: 1	تَوْلِيَةَ الْقَضَاءِ
u'تَوْلِيَةٌ قَضَاءٌ':Added, #2: 2	تَوْلِيَةُ الْقَضَاءِ
u'تَوْلِيَةٌ قضاة':Added, #6: 6	تَوْلِيَةِ الْقَضَاءِ
u'تَوْلِيَةٌ كَافِرٌ':Added, #1: 1	تَوْلِيَةِ الْقُضَاةِ
u'تَوْلِيَةٌ مُزَارِعٌ':Added, #3: 3	تَوْلِيَةُ كَافِرٍ
u'تَوْلِيَةٌ مَسَاجِدُ':Added, #1: 1	تَوْلِيَةِ الْمُزَارِعِ
u'تَوْلِيَةٌ مُقَلِّدٌ':Added, #1: 1	تَوْلِيَةُ الْمَسَاجِدِ
u'تَوْلِيَةٌ نَاظِرٌ':Added, #3: 3	تَوْلِيَةُ الْمُقَلِّدِ
u'تَوْلِيَةٌ نَاظِرٌ':Added, #1: 1	تَوْلِيَةِ النَّاظِرِ
u'تَوْلِيَةٌ نَظَرٌ':Added, #2: 2	تَوْلِيَةُ نَاظِرٍ
u'تَوْلِيَةٌ نعمة':Added, #1: 1	تَوْلِيَةَ النَّظَرِ
u'تَوْلِيَةٌ نِعْمَةٌ':Added, #1: 1	تَوْلِيَةَ النِّعْمَةِ
u'تَوْلِيَةٌ واحد':Added, #1: 1	تَوْلِيَةَ النِّعْمَةِ
u'تَوْلِيَةٌ وَاحِدٌ':Added, #1: 1	تَوْلِيَةِ وَاحِدٍ
u'تَوْلِيَةٌ وَقْفٌ':Added, #1: 1	تَوْلِيَةِ وَاحِدٍ
u'تَوْلِيَةٌ يهود':Added, #1: 1	تَوْلِيَةَ الْوَقْفِ
u'تَوْلِيَةٌ يَهُودٌ':Added, #1: 1	تَوْلِيَةِ الْيَهُودِ
u'تَوَلَّى تَدْرِيسٌ':Predicate, #1: 1	تَوْلِيَةِ الْيَهُودِ
u'تَوَلَّى حاكِمٌ':Subject, #1: 1	تَوَلَّى التَّدْرِيسَ
u'تَوَلَّى حِفْظٌ':Predicate, #1: 1	تَوَلَّى الْحَاكِمُ
u'تَوَلَّى حُكْمٌ':Predicate, #1: 1	تَوَلَّى حِفْظَ
u'تَوَلِّي حُكْمٌ':Added, #1: 1	تَوَلَّى الْحُكْمَ
u'تَوَلَّى حَمْلٌ':Predicate, #1: 1	تَوَلِّي الْحُكْمِ
u'تَوَلَّى خطبة':Predicate, #1: 1	تَوَلَّى الْحَمْلَ
u'تَوَلَّى خُطْبَةٌ':Predicate, #1: 1	تَوَلَّى الْخُطْبَةَ
u'تَوَلَّى خِلاَفَةٌ':Predicate, #1: 1	تَوَلَّى الْخُطْبَةَ
u'تَوَلَّى دَرْسٌ':Predicate, #1: 1	تَوَلَّى الْخِلَافَةَ
u'تَوَلَّى رَبُّ':Subject, #1: 1	تَوَلَّى دَرْسَ
u'تَوَلَّى رَدٌّ':Predicate, #1: 1	تَوَلَّى رَبُّ
u'تَوَلَّى زِراعَةٌ':Predicate, #1: 1	تَوَلَّى رَدَّ
u'تَوَلَّى سَرَاةٌ':Subject, #1: 1	تَوَلَّى الزِّرَاعَةَ
u'تَوَلِّي سَيِّدٌ':Added, #1: 1	تَوَلَّى سَرَاةُ
u'تَوَلَّى شِبْهٌ':Predicate, #1: 1	تَوَلِّي السَّيِّدِ
u'تَوَلَّى شِرَاءٌ':Predicate, #2: 2	تَوَلَّى شِبْهَ
u'تَوَلَّى شَرْعٌ':Subject, #1: 1	تَوَلَّى الشِّرَاءَ
u'تَوَلَّى شَرِيكٌ':Subject, #2: 2	تَوَلَّى الشَّرْعُ
u'تَوَلَّى صَلاَةٌ':Predicate, #1: 1	تَوَلَّى شَرِيكُهُ
u'تَوَلِّي صَلاَةٌ':Added, #1: 1	تَوَلَّى صَلَاةَ
u'تَوَلِّي طَرَفٌ':Added, #1: 1	تَوَلِّي الصَّلَاةِ
u'تَوَلَّى عَقْدٌ':Predicate, #7: 7	تَوَلِّي الطَّرَفَيْنِ
u'تَوَلَّى عَقْدٌ':Predicate, #1: 1	تَوَلَّى عَقْدَ
u'تَوَلَّى عُمَرٌ':Subject, #3: 3	تَوَلَّى الْعَقْدَ
u'تَوَلَّى عَمَلٌ':Predicate, #2: 2	تَوَلَّى عُمَرُ
u'تَوَلَّى عين':Predicate, #1: 1	تَوَلَّى الْعَمَلَ
u'تَوَلَّى عَيْنٌ':Predicate, #1: 1	تَوَلَّى الْعَيْنَ
u'تَوَلَّى عَيْن':Predicate, #1: 1	تَوَلَّى الْعَيْنَ
u'تَوَلَّى غير':Predicate, #1: 1	تَوَلَّى الْعَيْنَ
u'تَوَلَّى غَيْرٌ':Predicate, #13: 13	تَوَلَّى غَيْرَ
u'تَوَلَّى غير':Subject, #13: 13	تَوَلَّى غَيْرَ
u'تَوَلَّى غَيْرٌ':Subject, #1: 1	تَوَلَّى غَيْرُ
u'تَوَلَّى قَاسِمٌ':Subject, #1: 1	تَوَلَّى غَيْرُ
u'تَوَلَّى قَالٌ':Predicate, #1: 1	تَوَلَّى الْقَاسِمُ
u'تَوَلَّى قَبْضٌ':Predicate, #2: 2	تَوَلَّى قَالَ
u'تَوَلَّى قَبُولٌ':Predicate, #1: 1	تَوَلَّى قَبْضَ
u'تَوَلَّى قَبُولٌ':Subject, #1: 1	تَوَلَّى قَبُولَ
u'تَوَلَّى قِرَاءةٌ':Predicate, #1: 1	تَوَلَّى قَبُولُ
u'تَوَلَّى قسمة':Predicate, #1: 1	تَوَلَّى الْقِرَاءَةَ
u'تَوَلَّى قِسْمَةٌ':Predicate, #2: 2	تَوَلَّى قِسْمَةَ
u'تَوَلَّى قَضَاءٌ':Predicate, #2: 2	تَوَلَّى قِسْمَةَ
u'تَوَلِّي قَضَاءٌ':Added, #7: 7	تَوَلَّى الْقَضَاءَ
u'تَوَلَّى قَطْعٌ':Predicate, #1: 1	تَوَلِّي الْقَضَاءِ
u'تَوَلَّى مَالٌ':Subject, #2: 2	تَوَلَّى الْقَطْعَ
u'تَوَلَّى مَالِكٌ':Subject, #1: 1	تَوَلَّى الْمَالُ
u'تَوَلَّى مُبَاشَرَةٌ':Predicate, #1: 1	تَوَلَّى الْمَالِكُ
u'تَوَلَّى نَاظِرٌ':Subject, #1: 1	تَوَلَّى مُبَاشَرَةَ
u'تَوَلَّى نَظَرٌ':Predicate, #2: 2	تَوَلَّى النَّاظِرُ
u'تَوَلَّى نكاح':Predicate, #2: 2	تَوَلَّى النَّظَرَ
u'تَوَلَّى نِكَاحٌ':Predicate, #3: 3	تَوَلَّى نِكَاحَ
u'تَوَلَّى هشام':Subject, #3: 3	تَوَلَّى نِكَاحَ
u'تَوَلَّى هِشَامٌ':Subject, #1: 1	تَوَلَّى هِشَامُ
u'تَوَلَّى واحد':Subject, #1: 1	تَوَلَّى هِشَامُ
u'تَوَلَّى وَاحِدٌ':Subject, #1: 1	تَوَلَّى وَاحِدٌ
u'تَوَلِّي واحد':Added, #1: 1	تَوَلَّى وَاحِدٌ
u'تَوَلِّي وَاحِدٌ':Added, #1: 1	تَوَلِّي الْوَاحِدِ
u'تَوَلَّى وِصَايَةٌ':Predicate, #1: 1	تَوَلِّي الْوَاحِدِ
u'تَوَلَّى وَضْعٌ':Predicate, #1: 1	تَوَلَّى وِصَايَةَ
u'تَوَلَّى وَقْفٌ':Predicate, #1: 1	تَوَلَّى وَضْعَ
u'تَوَلَّى وِلاَيَةٌ':Predicate, #1: 1	تَوَلَّى الْوَقْفَ
u'تَوَهُّمٌ إبَاحَةٌ':Added, #1: 1	تَوَلَّى وِلَايَةَ
u'تَوَهُّمٌ إِبْطَالٌ':Added, #1: 1	تَوَهُّمُ الْإِبَاحَةِ
u'تَوَهُّمٌ اِخْتِلاَفٌ':Added, #1: 1	تَوَهُّمُ الْإِبْطَالِ
u'تَوَهُّمٌ إِرَادَةٌ':Added, #1: 1	تَوَهُّمُ اخْتِلَافِ
u'تَوَهُّمٌ اِشْتِغالٌ':Added, #2: 2	تَوَهُّمِ إرَادَةِ
u'تَوَهُّمٌ اِعْتِقادٌ':Added, #1: 1	تَوَهُّمِ اشْتِغَالِ
u'تَوَهُّمٌ إفَادَةٌ':Added, #1: 1	تَوَهُّمِ اعْتِقَادِ
u'تَوَهُّمٌ أَقْوَامٌ':Added, #1: 1	تَوَهُّمُ إفَادَتِهِ
u'تَوَهُّمٌ إمَامٌ':Added, #1: 1	تَوَهُّمِ أَقْوَامٍ
u'تَوَهُّمٌ بَرٌّ':Added, #1: 1	تَوَهُّمُ إمَامِ
u'تَوَهُّمٌ بِرٌّ':Added, #1: 1	تَوَهُّمِ الْبَرِّ
u'تَوَهَّمَ بُرْء':Predicate, #1: 1	تَوَهُّمِ الْبِرِّ
u'تَوَهَّمَ بَعْضٌ':Subject, #1: 1	تَوَهَّمَ الْبُرْءَ
u'تَوَهَّمَ بَعْضٌ':Subject, #13: 13	تَوَهَّمَ بَعْضُ
u'تَوَهُّمٌ بَقاءٌ':Added, #1: 1	تَوَهَّمَ بَعْضٌ
u'تَوَهُّمٌ تَأْدِيبٌ':Added, #1: 1	تَوَهُّمُ بَقَاءِ
u'تَوَهُّمٌ تَجَوُّزٌ':Added, #1: 1	تَوَهُّمَ التَّأْدِيبِ
u'تَوَهُّمٌ تَجَوُّزٌ':Added, #1: 1	تَوَهُّمَ التَّجَوُّزِ
u'تَوَهُّمٌ تَحَقُّقٌ':Added, #1: 1	تَوَهُّمُ التَّجَوُّزِ
u'تَوَهَّمَ تَفْصِيلٌ':Predicate, #1: 1	تَوَهُّمِ تَحَقُّقِهِ
u'تَوَهُّمٌ تَقْيِيد':Added, #1: 1	تَوَهَّمَ التَّفْصِيلَ
u'تَوَهُّمٌ تَقْيِيد':Added, #1: 1	تَوَهُّمُ التَّقْيِيدِ
u'تَوَهُّمٌ تَكْرارٌ':Added, #1: 1	تَوَهُّمُ تَقْيِيدِ
u'تَوَهُّمٌ تَلْبيسٌ':Added, #1: 1	تَوَهُّمَ التَّكْرَارِ
u'تَوَهُّمٌ تَمَلُّكٌ':Added, #1: 1	تَوَهُّمَ التَّلْبِيسِ
u'تَوَهُّمٌ تَنَاقُضٌ':Added, #1: 1	تَوَهُّمِ تَمَلُّكِهِ
u'تَوَهُّمٌ جَرَيان':Added, #1: 1	تَوَهُّمُ التَّنَاقُضِ
u'تَوَهُّمٌ جَوَازٌ':Added, #1: 1	تَوَهُّمِ جَرَيَانِ
u'تَوَهُّمٌ حَمْلٌ':Added, #1: 1	تَوَهُّمِ جَوَازِ
u'تَوَهُّمٌ خَطَأٌ':Added, #1: 1	تَوَهُّمِ حَمْلِ
u'تَوَهُّمٌ دُخُولٌ':Added, #1: 1	تَوَهُّمُ الْخَطَأِ
u'تَوَهُّمٌ دُخُولٌ':Added, #1: 1	تَوَهُّمُ الدُّخُولِ
u'تَوَهُّمٌ دُخُولٌ':Added, #1: 1	تَوَهُّمِ دُخُولِ
u'تَوَهُّمٌ زِيادَةٌ':Added, #2: 2	تَوَهُّمِ الدُّخُولِ
u'تَوَهَّمَ شَارِحٌ':Subject, #1: 1	تَوَهُّمِ زِيَادَةٍ
u'تَوَهُّمٌ شُغْلٌ':Added, #1: 1	تَوَهَّمَ الشَّارِحُ
u'تَوَهُّمٌ شُغْل':Added, #1: 1	تَوَهُّمُ الشُّغْلِ
u'تَوَهُّمٌ شُغْلٌ':Added, #1: 1	تَوَهُّمُ الشُّغْلِ
u'تَوَهُّمٌ شُغْل':Added, #3: 3	تَوَهُّمِ الشُّغْلِ
u'تَوَهُّمٌ صدق':Added, #3: 3	تَوَهُّمِ الشُّغْلِ
u'تَوَهُّمٌ صِدْقٌ':Added, #1: 1	تَوَهُّمِ الصِّدْقِ
u'تَوَهُّمٌ صدق':Added, #1: 1	تَوَهُّمِ الصِّدْقِ
u'تَوَهُّمٌ صِدْقٌ':Added, #2: 2	تَوَهُّمُ الصِّدْقِ
u'تَوَهُّمٌ ضَرَرٌ':Added, #2: 2	تَوَهُّمُ الصِّدْقِ
u'تَوَهَّمَ ضعفاء':Subject, #1: 1	تَوَهُّمُ الضَّرَرِ
u'تَوَهُّمٌ ضَيَاعٌ':Added, #1: 1	تَوَهَّمَ ضُعَفَاءُ
u'تَوَهُّمٌ طلب':Added, #1: 1	تَوَهُّمَ الضَّيَاعِ
u'تَوَهُّمٌ طَلَبٌ':Added, #1: 1	تَوَهُّمِ طَلَبِ
u'تَوَهُّمٌ ظُهورٌ':Added, #1: 1	تَوَهُّمِ طَلَبِ
u'تَوَهُّمٌ ظُهورٌ':Added, #1: 1	تَوَهُّمِ الظُّهُورِ
u'تَوَهَّمَ عَدَمٌ':Predicate, #1: 1	تَوَهُّمِ ظُهُورِهِ
u'تَوَهُّمٌ عَدَمٌ':Added, #2: 2	تَوَهَّمَ عَدَمَ
u'تَوَهُّمٌ عَدَمٌ':Added, #1: 1	تَوَهُّمَ عَدَمِ
u'تَوَهُّمٌ عطف':Added, #1: 1	تَوَهُّمِ عَدَمِ
u'تَوَهُّمٌ عَطْفٌ':Added, #1: 1	تَوَهُّمِ عَطْفِ
u'تَوَهَّمَ عَفْوٌ':Predicate, #1: 1	تَوَهُّمِ عَطْفِ
u'تَوَهُّمٌ عَوْدٌ':Added, #1: 1	تَوَهَّمَ الْعَفْوَ
u'تَوَهُّمٌ عَوْدٌ':Added, #1: 1	تَوَهُّمِ الْعَوْدِ
u'تَوَهُّمٌ قَبُولٌ':Added, #1: 1	تَوَهُّمُ عَوْدِ
u'تَوَهُّمٌ قتل':Added, #1: 1	تَوَهُّمِ قَبُولِ
u'تَوَهُّمٌ قَتْلٌ':Added, #1: 1	تَوَهُّمَ قَتْلِ
u'تَوَهُّمٌ قدرة':Added, #1: 1	تَوَهُّمَ قَتْلِ
u'تَوَهُّمٌ قُدْرَةٌ':Added, #1: 1	تَوَهُّمَ الْقُدْرَةِ
u'تَوَهُّمٌ قِلَّةٌ':Added, #1: 1	تَوَهُّمَ الْقُدْرَةِ
u'تَوَهَّمَ قَوْمٌ':Subject, #1: 1	تَوَهُّمَ قِلَّةِ
u'تَوَهُّمٌ كَوْنٌ':Added, #4: 4	تَوَهَّمَ قَوْمٌ
u'تَوَهُّمٌ كَوْنٌ':Added, #1: 1	تَوَهُّمُ كَوْنِهِ
u'تَوَهُّمٌ كَوْنٌ':Added, #1: 1	تَوَهُّمِ كَوْنِهِ
u'تَوَهُّمٌ لُزُومٌ':Added, #3: 3	تَوَهُّمِ كَوْنِ
u'تَوَهُّمٌ مَاءٌ':Added, #1: 1	تَوَهُّمُ لُزُومِ
u'تَوَهُّمٌ مثل':Added, #2: 2	تَوَهُّمِ الْمَاءِ
u'تَوَهُّمٌ مِثْلٌ':Added, #1: 1	تَوَهُّمِ مِثْلِ
u'تَوَهُّمٌ مَجَازٌ':Added, #1: 1	تَوَهُّمِ مِثْلِ
u'تَوَهَّمَ مُخَاطَبٌ':Subject, #1: 1	تَوَهُّمِ الْمَجَازِ
u'تَوَهُّمٌ مُخَالَفَةٌ':Added, #2: 2	تَوَهَّمَ الْمُخَاطَبُ
u'تَوَهُّمٌ مُصَادَفَةٌ':Added, #1: 1	تَوَهُّمَ الْمُخَالَفَةِ
u'تَوَهُّمٌ مُعَاوَدَةٌ':Added, #1: 1	تَوَهُّمِ مُصَادَفَةِ
u'تَوَهُّمٌ مُعَاوَدَةٌ':Added, #1: 1	تَوَهُّمُ مُعَاوَدَةِ
u'تَوَهَّمَ مَقْدِسِيٌّ':Predicate, #1: 1	تَوَهُّمِ مُعَاوَدَةِ
u'تَوَهُّمٌ نَجَاسَةٌ':Added, #1: 1	تَوَهَّمَ الْمَقْدِسِيَّ
u'تَوَهُّمٌ نزاع':Added, #2: 2	تَوَهُّمِ النَّجَاسَةِ
u'تَوَهُّمٌ نِزَاعٌ':Added, #1: 1	تَوَهُّمُ نِزَاعٍ
u'تَوَهُّمٌ نشاط':Added, #1: 1	تَوَهُّمُ نِزَاعٍ
u'تَوَهُّمٌ نَشَاطٌ':Added, #1: 1	تَوَهُّمُ نَشَاطٍ
u'تَوَهُّمٌ نُقْصَانٌ':Added, #1: 1	تَوَهُّمُ نَشَاطٍ
u'تَوَهَّمَ وُجُوبٌ':Predicate, #1: 1	تَوَهُّمِ النُّقْصَانِ
u'تَوَهُّمٌ وُجُوبٌ':Added, #1: 1	تَوَهَّمَ وُجُوبَ
u'تَوَهُّمٌ وُجُوبٌ':Added, #1: 1	تَوَهُّمُ الْوُجُوبِ
u'تَوَهَّمَ وُجُودٌ':Predicate, #1: 1	تَوَهُّمِ وُجُوبِ
u'تَوَهُّمٌ وُجُودٌ':Added, #1: 1	تَوَهَّمَ وُجُودَ
u'تَوَهُّمٌ وُجُودٌ':Added, #1: 1	تَوَهُّمِ وُجُودِ
u'تَوَهُّمٌ وُقُوعٌ':Added, #3: 3	تَوَهُّمِ الْوُجُودِ
u'تَوَهُّمٌ وُقُوعٌ':Added, #1: 1	تَوَهُّمَ الْوُقُوعِ
u'تَوَهُّنٌ خَبَرٌ':Added, #1: 1	تَوَهُّمِ الْوُقُوعِ
u'تَوَهُّنٌ خَبَر':Added, #1: 1	تَوَهُّنِ خَبَرِ
u'تَوِيَ بَعْضٌ':Subject, #1: 1	تَوَهُّنِ خَبَرِ
u'تَوِيَ ثَمَنٌ':Subject, #1: 1	تَوِيَ بَعْضُ
u'تَوِيَ حَقٌّ':Subject, #2: 2	تَوِيَ الثَّمَنُ
u'تَوِيَ دَيْنٌ':Subject, #1: 1	تَوِيَ حَقُّهُ
u'تَوِيَ رَأْسٌ':Subject, #1: 1	تَوِيَ الدَّيْنُ
u'تَوِيَ مَالٌ':Subject, #1: 1	تَوِيَ رَأْسُ
u'تَوِيَ مَالٌ':Subject, #1: 1	تَوِيَ مَالُ
u'تَوِيَ مَقْبُوضٌ':Subject, #4: 4	تَوِيَ الْمَالُ
u'تَوِيَ نَصِيبٌ':Subject, #1: 1	تَوِيَ الْمَقْبُوضُ
u'تَيَسَّرَ إحْضَارٌ':Subject, #1: 1	تَوِيَ نَصِيبُهُ
u'تَيَسَّرَ أخْذٌ':Subject, #1: 1	تَيَسَّرَ إحْضَارُ
u'تَيَسُّرٌ أَدَاءٌ':Added, #1: 1	تَيَسَّرَ أَخْذُهُ
u'تَيَسَّرَ إِصْلاحٌ':Subject, #1: 1	تَيَسُّرَ الْأَدَاءِ
u'تَيَسَّرَ إعْلاَمٌ':Subject, #1: 1	تَيَسَّرَ الْإِصْلَاحُ
u'تَيَسَّرَ إِفْرَادٌ':Subject, #1: 1	تَيَسَّرَ إعْلَامُهُ
u'تَيَسُّرٌ أَمْرٌ':Added, #1: 1	تَيَسَّرَ الْإِفْرَادُ
u'تَيَسَّرَ بَيْعٌ':Subject, #1: 1	تَيَسُّرُ أَمْرِ
u'تَيَسُّرٌ بَيْعٌ':Added, #1: 1	تَيَسَّرَ بَيْعُهُ
u'تَيَسُّرٌ بَيِّنَةٌ':Added, #1: 1	تَيَسُّرِ الْبَيْعِ
u'تَيَسَّرَ تَأْلِيفٌ':Subject, #1: 1	تَيَسُّرِ الْبَيِّنَةِ
u'تَيَسَّرَ تَحْصِيلٌ':Subject, #1: 1	تَيَسَّرَ تَأْلِيفُهُ
u'تَيَسُّرٌ تَدَارُكٌ':Added, #1: 1	تَيَسَّرَ تَحْصِيلُهُ
u'تَيَسُّرٌ تَصَوُّرٌ':Added, #2: 2	تَيَسُّرِ تَدَارُكِ
u'تَيَسُّرٌ تَغْلِيبٌ':Added, #2: 2	تَيَسُّرِ التَّصَوُّرِ
u'تَيَسَّرَ تَكَلُّمٌ':Subject, #1: 1	تَيَسُّرُ تَغْلِيبِ
u'تَيَسَّرَ تَكْميلٌ':Subject, #1: 1	تَيَسَّرَ التَّكَلُّمُ
u'تَيَسَّرَ ثُبُوتٌ':Subject, #1: 1	تَيَسَّرَ تَكْمِيلُ
u'تَيَسَّرَ جمع':Subject, #1: 1	تَيَسَّرَ ثُبُوتُ
u'تَيَسَّرَ جَمْعٌ':Subject, #2: 2	تَيَسَّرَ جَمْعُهُ
u'تَيَسَّرَ حُضورٌ':Subject, #2: 2	تَيَسَّرَ جَمْعُهُ
u'تَيَسَّرَ حُضُورٌ':Subject, #1: 1	تَيَسَّرَ حُضُورُهُ
u'تَيَسَّرَ ذكر':Subject, #1: 1	تَيَسَّرَ حُضُورُهُ
u'تَيَسَّرَ ذِكْرٌ':Subject, #1: 1	تَيَسَّرَ ذِكْرُهُ
u'تَيَسُّرٌ سُؤَالٌ':Added, #1: 1	تَيَسَّرَ ذِكْرُهُ
u'تَيَسُّرٌ شِرَاءٌ':Added, #1: 1	تَيَسُّر السُّؤَالِ
u'تَيَسُّرٌ عَمَلٌ':Added, #1: 1	تَيَسُّرِ شِرَاءِ
u'تَيَسَّرَ عُمُومٌ':Subject, #1: 1	تَيَسُّرِ الْعَمَلِ
u'تَيَسُّرٌ غُسْلٌ':Added, #1: 1	تَيَسَّرَ الْعُمُومُ
u'تَيَسَّرَ فَلَكٌ':Predicate, #1: 1	تَيَسُّرِ الْغُسْلِ
u'تَيَسَّرَ قَالٌ':Predicate, #1: 1	تَيَسَّرَ فَلَكَ
u'تَيَسُّرٌ كَسْبٌ':Added, #2: 2	تَيَسَّرَ قَالَ
u'تَيَسُّرٌ نَزْعٌ':Added, #1: 1	تَيَسُّرِ الْكَسْبِ
u'تَيَسَّرَ نَظَرٌ':Subject, #1: 1	تَيَسُّرِ النَّزْعِ
u'تَيَسَّرَ هَدْمٌ':Subject, #2: 2	تَيَسَّرَ النَّظَرُ
u'تَيَسُّرٌ وُصُولٌ':Added, #1: 1	تَيَسَّرَ هَدْمُ
u'تَيَقُّظٌ حارِسٌ':Added, #1: 1	تَيَسُّرِ الْوُصُولِ
u'تَيَقَّنَ إِتْيانٌ':Subject, #1: 1	تَيَقُّظِ الْحَارِسِ
u'تَيَقُّنٌ إِتْيانٌ':Added, #1: 1	تَيَقَّنَ الْإِتْيَانُ
u'تَيَقَّنَ إِحْرَامٌ':Predicate, #1: 1	تَيَقُّنِ إتْيَانِ
u'تَيَقَّنَ إقامَةٌ':Predicate, #1: 1	تَيَقَّنَ الْإِحْرَامَ
u'تَيَقُّنٌ أُمُورٌ':Added, #1: 1	تَيَقَّنَ الْإِقَامَةَ
u'تَيَقَّنَ إِنْزالٌ':Predicate, #1: 1	تَيَقُّنِ أُمُورٍ
u'تَيَقُّنٌ إِنْزالٌ':Added, #2: 2	تَيَقَّنَ الْإِنْزَالَ
u'تَيَقَّنَ تَحْرِيمٌ':Predicate, #1: 1	تَيَقُّنِ الْإِنْزَالِ
u'تَيَقُّنٌ تَحْرِيمٌ':Added, #2: 2	تَيَقَّنَ التَّحْرِيمَ
u'تَيَقُّنٌ تَرْكٌ':Added, #1: 1	تَيَقُّنِ تَحْرِيمِ
u'تَيَقُّنٌ تَرْكٌ':Added, #1: 1	تَيَقُّنِ التَّرْكِ
u'تَيَقُّنٌ تَرْكٌ':Added, #1: 1	تَيَقُّنُ تَرْكِ
u'تَيَقُّنٌ تَفَاضُلٌ':Added, #1: 1	تَيَقُّنِ تَرْكٍ
u'تَيَقُّنٌ ثُبُوتٌ':Added, #1: 1	تَيَقُّنِ التَّفَاضُلِ
u'تَيَقَّنَ جَمَاعَةٌ':Predicate, #1: 1	تَيَقُّنِ ثُبُوتِ
u'تَيَقَّنَ حاجَةٌ':Predicate, #2: 2	تَيَقَّنَ الْجَمَاعَةَ
u'تَيَقَّنَ حاكِمٌ':Subject, #1: 1	تَيَقَّنَ الْحَاجَةَ
u'تَيَقَّنَ حالٌ':Predicate, #1: 1	تَيَقَّنَ الْحَاكِمُ
u'تَيَقَّنَ حَدَثٌ':Predicate, #1: 1	تَيَقَّنَ حَالَ
u'تَيَقُّنٌ حَدَثٌ':Added, #7: 7	تَيَقَّنَ الْحَدَثَ
u'تَيَقُّنٌ حَدَثٌ':Added, #1: 1	تَيَقُّنُ الْحَدَثِ
u'تَيَقَّنَ حُصُول':Predicate, #1: 1	تَيَقُّنِ الْحَدَثِ
u'تَيَقَّنَ حُلُمٌ':Predicate, #2: 2	تَيَقَّنَ حُصُولَ
u'تَيَقَّنَ حِنْثٌ':Predicate, #1: 1	تَيَقَّنَ الْحُلُمَ
u'تَيَقُّنٌ حَيَاةٌ':Added, #1: 1	تَيَقَّنَ الْحِنْثَ
u'تَيَقُّنٌ حَيَاةٌ':Added, #1: 1	تَيَقُّنَ الْحَيَاةِ
u'تَيَقَّنَ خُرُوجٌ':Predicate, #1: 1	تَيَقُّنِ حَيَاتِهِ
u'تَيَقَّنَ خَطَأٌ':Predicate, #1: 1	تَيَقَّنَ خُرُوجَ
u'تَيَقَّنَ خِلاَفٌ':Predicate, #5: 5	تَيَقَّنَ الْخَطَأَ
u'تَيَقَّنَ زَوالٌ':Predicate, #2: 2	تَيَقَّنَ خِلَافَ
u'تَيَقَّنَ سَبَبٌ':Predicate, #1: 1	تَيَقَّنَ زَوَالَ
u'تَيَقُّنٌ سَبَبٌ':Added, #2: 2	تَيَقَّنَ سَبَبَ
u'تَيَقَّنَ سَلاَمَةٌ':Predicate, #2: 2	تَيَقُّنَ سَبَبِ
u'تَيَقُّنٌ سَلاَمَةٌ':Added, #1: 1	تَيَقَّنَ سَلَامَةَ
u'تَيَقُّنٌ شَكٌّ':Added, #1: 1	تَيَقُّنِ سَلَامَةِ
u'تَيَقَّنَ صدق':Predicate, #1: 1	تَيَقُّنِ الشَّكِّ
u'تَيَقَّنَ صِدْقٌ':Predicate, #1: 1	تَيَقَّنَ صِدْقَ
u'تَيَقَّنَ صَوَابٌ':Predicate, #1: 1	تَيَقَّنَ صِدْقَ
u'تَيَقَّنَ صَوْتٌ':Predicate, #4: 4	تَيَقَّنَ صَوَابَ
u'تَيَقُّنٌ طُلُوعٌ':Added, #1: 1	تَيَقَّنَ الصَّوْتَ
u'تَيَقَّنَ طَهَارَةٌ':Predicate, #1: 1	تَيَقُّنَ الطُّلُوعِ
u'تَيَقُّنٌ طَهَارَةٌ':Added, #14: 14	تَيَقَّنَ الطَّهَارَةَ
u'تَيَقُّنٌ طَهَارَةٌ':Added, #1: 1	تَيَقُّنَ الطَّهَارَةِ
u'تَيَقُّنٌ طَهَارَةٌ':Added, #2: 2	تَيَقُّنُ الطَّهَارَةِ
u'تَيَقَّنَ طهر':Predicate, #2: 2	تَيَقُّنِ الطَّهَارَةِ
u'تَيَقَّنَ طُهْرٌ':Predicate, #1: 1	تَيَقَّنَ طُهْرَ
u'تَيَقُّنٌ عجز':Added, #1: 1	تَيَقَّنَ طُهْرَ
u'تَيَقُّنٌ عَجْزٌ':Added, #1: 1	تَيَقُّنِ الْعَجْزِ
u'تَيَقَّنَ عَدَمٌ':Predicate, #1: 1	تَيَقُّنِ الْعَجْزِ
u'تَيَقُّنٌ عَدَمٌ':Added, #2: 2	تَيَقَّنَ عَدَمَ
u'تَيَقُّنٌ عَدَمٌ':Added, #1: 1	تَيَقُّنِ عَدَمِ
u'تَيَقُّنٌ عَقْدٌ':Added, #1: 1	تَيَقُّنِ عَدَمِهِ
u'تَيَقُّنٌ عِلَّةٌ':Added, #1: 1	تَيَقُّنِ الْعَقْدِ
u'تَيَقُّنٌ عُلُوقٌ':Added, #1: 1	تَيَقُّنِ الْعِلَّةِ
u'تَيَقَّنَ غُرُوبٌ':Predicate, #1: 1	تَيَقُّنِ الْعُلُوقِ
u'تَيَقُّنٌ غُرُوبٌ':Added, #1: 1	تَيَقَّنَ غُرُوبَ
u'تَيَقُّنٌ غَلَطٌ':Added, #2: 2	تَيَقُّنِ الْغُرُوبِ
u'تَيَقَّنَ فراغ':Predicate, #1: 1	تَيَقُّنِ الْغَلَطِ
u'تَيَقَّنَ فَرَاغٌ':Predicate, #1: 1	تَيَقَّنَ فَرَاغَ
u'تَيَقَّنَ فِعْلٌ':Predicate, #1: 1	تَيَقَّنَ فَرَاغَ
u'تَيَقَّنَ فِعْلٌ':Predicate, #1: 1	تَيَقَّنَ الْفِعْلَ
u'تَيَقَّنَ قِرَاءةٌ':Predicate, #1: 1	تَيَقَّنَ فِعْلَ
u'تَيَقُّنٌ كَوْنٌ':Added, #1: 1	تَيَقَّنَ قِرَاءَةَ
u'تَيَقُّنٌ كَوْنٌ':Added, #1: 1	تَيَقُّنُ كَوْنِهِ
u'تَيَقَّنَ مَاءٌ':Predicate, #2: 2	تَيَقُّنِ كَوْنِهِ
u'تَيَقَّنَ مُخَالَفَةٌ':Predicate, #2: 2	تَيَقَّنَ الْمَاءَ
u'تَيَقَّنَ مُضِيٌّ':Subject, #1: 1	تَيَقَّنَ مُخَالَفَةَ
u'تَيَقُّنٌ مُلاَقَاةٌ':Added, #1: 1	تَيَقَّنَ مُضِيُّهُ
u'تَيَقُّنٌ مِلْكٌ':Added, #1: 1	تَيَقُّنَ مُلَاقَاةِ
u'تَيَقَّنَ مَوْتٌ':Subject, #1: 1	تَيَقُّنِ مِلْكِهِ
u'تَيَقُّنٌ مَوْتٌ':Added, #1: 1	تَيَقَّنَ الْمَوْتُ
u'تَيَقُّنٌ نَجَاسَةٌ':Added, #1: 1	تَيَقُّنَ مَوْتِهِ
u'تَيَقُّنٌ نَجَاسَةٌ':Added, #3: 3	تَيَقُّنُ النَّجَاسَةِ
u'تَيَقَّنَ نِسْيَانٌ':Predicate, #3: 3	تَيَقُّنِ النَّجَاسَةِ
u'تَيَقَّنَ نِسْيَانٌ':Subject, #1: 1	تَيَقَّنَ نِسْيَانَ
u'تَيَقُّنٌ نَقْصٌ':Added, #1: 1	تَيَقَّنَ نِسْيَانُهُ
u'تَيَقَّنَ نَوْمٌ':Predicate, #2: 2	تَيَقُّنِ النَّقْصِ
u'تَيَقُّنٌ هلاك':Added, #1: 1	تَيَقَّنَ النَّوْمَ
u'تَيَقُّنٌ هَلاَكٌ':Added, #1: 1	تَيَقُّنِ الْهَلَاكِ
u'تَيَقَّنَ وَجَبٌ':Predicate, #1: 1	تَيَقُّنِ الْهَلَاكِ
u'تَيَقُّنٌ وَجْهٌ':Added, #1: 1	تَيَقَّنَ وَجَبَ
u'تَيَقَّنَ وُجُودٌ':Predicate, #1: 1	تَيَقُّنِ الْوَجْهِ
u'تَيَقُّنٌ وُجُودٌ':Added, #2: 2	تَيَقَّنَ وُجُودَ
u'تَيَقُّنٌ وُجُودٌ':Added, #1: 1	تَيَقُّنِ وُجُودِهِ
u'تَيَقُّنٌ وُصُولٌ':Added, #5: 5	تَيَقُّنِ وُجُودِ
u'تَيَقَّنَ وُضُوءٌ':Predicate, #1: 1	تَيَقُّنِ وُصُولِ
u'تَيَقَّنَ وُقُوعٌ':Predicate, #2: 2	تَيَقَّنَ الْوُضُوءَ
u'تَيَمَّمَ اِبْنٌ':Subject, #2: 2	تَيَقَّنَ وُقُوعَ
u'تَيَمُّمٌ أَرْبَعَةٌ':Added, #1: 1	تَيَمَّمَ ابْنُ
u'تَيَمَّمَ إِعادَةٌ':Subject, #1: 1	تَيَمُّمُ الْأَرْبَعَةِ
u'تَيَمَّمَ أَوَّلُ':Predicate, #1: 1	تَيَمَّمَ إعَادَةُ
u'تَيَمُّمٌ أَوَّلُ':Added, #3: 3	تَيَمَّمَ أَوَّلَ
u'تَيَمَّمَ جَازٌ':Predicate, #2: 2	تَيَمُّمِ الْأَوَّلِ
u'تَيَمُّمٌ جَنَابَةٌ':Added, #1: 1	تَيَمَّمَ جَازَ
u'تَيَمُّمٌ حائِضٌ':Added, #1: 1	تَيَمُّمُ الْجَنَابَةِ
u'تَيَمُّمٌ حَدَثٌ':Added, #2: 2	تَيَمُّمِ الْحَائِضِ
u'تَيَمُّمٌ حَدَثٌ':Added, #1: 1	تَيَمُّمِ حَدَثٍ
u'تَيَمُّمٌ حَيْضٌ':Added, #2: 2	تَيَمُّمِ الْحَدَثِ
u'تَيَمَّمَ خَارِجٌ':Predicate, #2: 2	تَيَمُّمِ الْحَيْضِ
u'تَيَمُّمٌ دَائِمٌ':Added, #1: 1	تَيَمَّمَ خَارِجَ
u'تَيَمَّمَ رَجُلٌ':Subject, #2: 2	تَيَمُّمِ دَائِمِ
u'تَيَمَّمَ رَسُولٌ':Subject, #1: 1	تَيَمَّمَ رَجُلٌ
u'تَيَمُّمٌ رَسُولٌ':Added, #2: 2	تَيَمَّمَ رَسُولُ
u'تَيَمَّمَ سَواءٌ':Subject, #1: 1	تَيَمُّمَ رَسُولِ
u'تَيَمَّمَ صَبِيٌّ':Subject, #2: 2	تَيَمَّمَ سَوَاءٌ
u'تَيَمَّمَ ضَرَبٌ':Predicate, #4: 4	تَيَمَّمَ صَبِيٌّ
u'تَيَمُّمٌ عُرْيَانٌ':Added, #1: 1	تَيَمَّمَ ضَرَبَ
u'تَيَمُّمٌ غير':Added, #1: 1	تَيَمُّمُ الْعُرْيَانِ
u'تَيَمُّمٌ غَيْرٌ':Added, #1: 1	تَيَمُّمِ غَيْرِهِ
u'تَيَمَّمَ كَافِرٌ':Subject, #1: 1	تَيَمُّمِ غَيْرِهِ
u'تَيَمَّمَ كَافِرٌ':Subject, #1: 1	تَيَمَّمَ الْكَافِرُ
u'تَيَمُّمٌ كَافِرٌ':Added, #1: 1	تَيَمَّمَ كَافِرٌ
u'تَيَمُّمٌ كَافِرٌ':Added, #1: 1	تَيَمُّمَ الْكَافِرِ
u'تَيَمُّمٌ مَارٌّ':Added, #2: 2	تَيَمُّمُ كَافِرٍ
u'تَيَمُّمٌ مُحْدِثٌ':Added, #1: 1	تَيَمُّمِ الْمَارِّ
u'تَيَمُّمٌ مَرِيضٌ':Added, #1: 1	تَيَمُّمُ الْمُحْدِثِ
u'تَيَمَّمَ مُسَافِرٌ':Subject, #1: 1	تَيَمُّمِ الْمَرِيضِ
u'تَيَمَّمَ مُسْلِمٌ':Subject, #2: 2	تَيَمَّمَ الْمُسَافِرُ
u'تَيَمَّمَ مُسْلِمٌ':Subject, #2: 2	تَيَمَّمَ مُسْلِمٌ
u'تَيَمُّمٌ نَائِمٌ':Added, #4: 4	تَيَمَّمَ الْمُسْلِمُ
u'تَيَمَّمَ نَصْرَانِيٌّ':Subject, #1: 1	تَيَمُّمِ النَّائِمِ
u'تَيَمَّمَ واحد':Subject, #2: 2	تَيَمَّمَ نَصْرَانِيٌّ
u'تَيَمَّمَ وَاحِدٌ':Subject, #1: 1	تَيَمَّمَ وَاحِدٌ
u'تَيَمُّمٌ وَجْهٌ':Added, #1: 1	تَيَمَّمَ وَاحِدٌ
u'تَيَمُّمٌ وَجْهٌ':Added, #1: 1	تَيَمُّمَ الْوَجْهِ
u'تَيَمَّمَ وسط':Predicate, #1: 1	تَيَمُّمِ وَجْهِهِ
u'تَيَمَّمَ وَسَطٌ':Predicate, #2: 2	تَيَمَّمَ وَسَطَ
u'تِيهٌ ضَلاَلَةٌ':Added, #2: 2	تَيَمَّمَ وَسَطَ
u'تِيهٌ مُلُوكٌ':Added, #1: 1	تِيهِ الضَّلَالَةِ
u'تِيهٌ وِلاَيَةٌ':Added, #1: 1	تِيهُ الْمُلُوكِ
u'ثَابَرَ سَلَفٌ':Subject, #1: 1	تِيهِ الْوِلَايَةِ
u'ثَابَ قِيمَةٌ':Predicate, #1: 1	ثَابَرَ السَّلَفُ
u'ثَارَ إِعْجابٌ':Subject, #3: 3	أَثَابَ الْقِيمَةَ
u'ثَأْرٌ جُرْحٌ':Added, #1: 1	ثَارَ الْإِعْجَابُ
u'ثَارَ حَرْبٌ':Predicate, #1: 1	ثَأْرِ جُرْحٍ
u'ثَارَ حسد':Subject, #1: 1	أَثَارَ الْحَرْبَ
u'ثَارَ حَسَدٌ':Subject, #1: 1	ثَارَ الْحَسَدُ
u'ثَارَ خِلاَفٌ':Subject, #1: 1	ثَارَ الْحَسَدُ
u'ثَارَ رَجُلٌ':Subject, #1: 1	ثَارَ الْخِلَافُ
u'ثَارَ غضب':Subject, #1: 1	أَثَارَ الرَّجُلُ
u'ثَارَ غَضَبٌ':Subject, #1: 1	ثَارَ غَضَبُهُ
u'ثَبَتَ إبَاحَةٌ':Subject, #1: 1	ثَارَ غَضَبُهُ
u'ثَبَتَ اِبْنٌ':Subject, #1: 1	ثَبَتَ إبَاحَتُهُ
u'ثَبَتَ اِتِّحَادٌ':Subject, #1: 1	ثَبَتَ ابْنُ
u'ثَبَتَ إِتْلاَفٌ':Subject, #1: 1	ثَبَتَ اتِّحَادُ
u'ثَبَتَ أثَرٌ':Subject, #1: 1	ثَبَتَ الْإِتْلَافُ
u'ثَبَتَ إجَارَةٌ':Subject, #1: 1	ثَبَتَ أَثَرُهُ
u'ثَبَتَ إِجْبَارٌ':Subject, #2: 2	ثَبَتَ إجَارَتُهُ
u'ثَبَتَ أَجَلٌ':Subject, #1: 1	ثَبَتَ الْإِجْبَارُ
u'ثَبَتَ إِجْمَاعٌ':Subject, #6: 6	ثَبَتَ الْأَجَلُ
u'ثَبَتَ أحَدٌ':Subject, #6: 6	ثَبَتَ الْإِجْمَاعُ
u'ثَبَتَ أَحْكَامٌ':Subject, #2: 2	ثَبَتَ أَحَدُ
u'ثَبَتَ اِخْتِصَاصٌ':Subject, #1: 1	ثَبَتَ أَحْكَامُ
u'ثَبَتَ أخْذٌ':Subject, #2: 2	ثَبَتَ اخْتِصَاصُهُ
u'ثَبَتَ أَدَاءٌ':Subject, #2: 2	ثَبَتَ أَخْذُ
u'ثَبَتَ إِذْنٌ':Subject, #1: 1	ثَبَتَ الْأَدَاءُ
u'ثَبَتَ أَرْبَعَةٌ':Subject, #2: 2	ثَبَتَ الْإِذْنُ
u'ثَبَتَ إِرْثٌ':Subject, #1: 1	ثَبَتَ أَرْبَعَةُ
u'ثَبَتَ اِسْتِحْقَاقٌ':Subject, #1: 1	ثَبَتَ الْإِرْثُ
u'ثَبَتَ اِسْتِحْقَاقٌ':Subject, #1: 1	ثَبَتَ اسْتِحْقَاقُهُ
u'ثَبَتَ اِسْتِرْدَادٌ':Subject, #3: 3	ثَبَتَ اسْتِحْقَاقُ
u'ثَبَتَ اِسْتِعْمالٌ':Subject, #1: 1	ثَبَتَ اسْتِرْدَادُهُ
u'ثَبَتَ اِسْتِقْلالٌ':Subject, #1: 1	ثَبَتَ اسْتِعْمَالُ
u'ثَبَتَ اِسْتِئْجَارٌ':Subject, #1: 1	ثَبَتَ اسْتِقْلَالُهُ
u'ثَبَتَ اِسْتِيلاد':Subject, #1: 1	ثَبَتَ اسْتِئْجَارُ
u'ثَبَتَ إِسْلامٌ':Subject, #1: 1	ثَبَتَ اسْتِيلَادُ
u'ثَبَتَ اِسْمٌ':Subject, #1: 1	ثَبَتَ الْإِسْلَامُ
u'ثَبَتَ أَسْماءٌ':Subject, #1: 1	ثَبَتَ اسْمُهُ
u'ثَبَتَ اِشْتِراطٌ':Subject, #1: 1	ثَبَتَ أَسْمَاءٌ
u'ثَبَتَ اِشْتِغالٌ':Subject, #3: 3	ثَبَتَ اشْتِرَاطُ
u'ثَبَتَ أَصْحَابٌ':Subject, #3: 3	ثَبَتَ اشْتِغَالُ
u'ثَبَتَ أصل':Subject, #1: 1	ثَبَتَ أَصْحَابُهُ
u'ثَبَتَ أًصْلٌ':Subject, #1: 1	ثَبَتَ أَصْلُهُ
u'ثَبَتَ أصل':Subject, #1: 1	ثَبَتَ أَصْلُهُ
u'ثَبَتَ أًصْلٌ':Subject, #5: 5	ثَبَتَ أَصْلُ
u'ثَبَتَ أصل':Subject, #5: 5	ثَبَتَ أَصْلُ
u'ثَبَتَ أًصْلٌ':Subject, #7: 7	ثَبَتَ الْأَصْلُ
u'ثَبَتَ أُصولٌ':Subject, #7: 7	ثَبَتَ الْأَصْلُ
u'ثَبَتَ إِطْلاقٌ':Subject, #1: 1	ثَبَتَ أُصُولٌ
u'ثَبَتَ إِطْلاقٌ':Subject, #1: 1	ثَبَتَ إطْلَاقُ
u'ثَبَتَ إِطْلاقٌ':Subject, #1: 1	ثَبَتَ إطْلَاقُهُ
u'ثَبَتَ اِعْتِبارٌ':Subject, #3: 3	ثَبَتَ الْإِطْلَاقُ
u'ثَبَتَ اِعْتِبارٌ':Subject, #2: 2	ثَبَتَ اعْتِبَارُهُ
u'ثَبَتَ اِعْتِراضٌ':Subject, #8: 8	ثَبَتَ اعْتِبَارُ
u'ثَبَتَ اِفْتِقَارٌ':Subject, #1: 1	ثَبَتَ اعْتِرَاضُهُ
u'ثَبَتَ أفْضَلِيَّةٌ':Subject, #1: 1	ثَبَتَ افْتِقَارُ
u'ثَبَتَ إفْلاَسٌ':Subject, #1: 1	ثَبَتَ أَفْضَلِيَّتُهُ
u'ثَبَتَ إفْلاَسٌ':Subject, #1: 1	ثَبَتَ إفْلَاسُهُ
u'ثَبَتَ إقْرَارٌ':Subject, #1: 1	ثَبَتَ الْإِفْلَاسُ
u'ثَبَتَ إقْرَارٌ':Subject, #1: 1	ثَبَتَ إقْرَارُهُ
u'ثَبَتَ إقْرَارٌ':Subject, #2: 2	ثَبَتَ الْإِقْرَارُ
u'ثَبَتَ أقَلُّ':Subject, #3: 3	ثَبَتَ إقْرَارُ
u'ثَبَتَ أَكْثَرُ':Subject, #5: 5	ثَبَتَ الْأَقَلُّ
u'ثَبَتَ إكْرَاهٌ':Subject, #1: 1	ثَبَتَ أَكْثَرُ
u'ثَبَتَ إلْبَاسٌ':Subject, #1: 1	ثَبَتَ إكْرَاهُهُ
u'ثَبَتَ ألف':Subject, #1: 1	ثَبَتَ الْإِلْبَاسُ
u'ثَبَتَ ألْفٌ':Subject, #2: 2	ثَبَتَ الْأَلْفُ
u'ثَبَتَ أَلْفٌ':Subject, #2: 2	ثَبَتَ الْأَلْفُ
u'ثَبَتَ إِلْقَاءٌ':Subject, #2: 2	ثَبَتَ الْأَلْفُ
u'ثَبَتَ أمَانٌ':Subject, #1: 1	ثَبَتَ إلْقَاءُ
u'ثَبَتَ اِمْتِناعٌ':Subject, #1: 1	ثَبَتَ الْأَمَانُ
u'ثَبَتَ اِمْتِناعٌ':Subject, #1: 1	ثَبَتَ امْتِنَاعُهُ
u'ثَبَتَ أَمْرٌ':Subject, #3: 3	ثَبَتَ امْتِنَاعُ
u'ثَبَتَ أَمْرٌ':Subject, #5: 5	ثَبَتَ أَمْرُهُ
u'ثَبَتَ إِمْكانٌ':Subject, #6: 6	ثَبَتَ الْأَمْرُ
u'ثَبَتَ أَمْنٌ':Subject, #1: 1	ثَبَتَ إمْكَانُ
u'ثَبَتَ اِنْتِساخٌ':Subject, #1: 1	ثَبَتَ أَمْنُ
u'ثَبَتَ اِنْتِفاء':Subject, #2: 2	ثَبَتَ انْتِسَاخُهُ
u'ثَبَتَ اِنْحِرافٌ':Subject, #1: 1	ثَبَتَ انْتِفَاءُ
u'ثَبَتَ اِنْحِصارٌ':Subject, #1: 1	ثَبَتَ انْحِرَافُ
u'ثَبَتَ اِنْعِقَادٌ':Subject, #1: 1	ثَبَتَ انْحِصَارُ
u'ثَبَتَ أَهْلِيٌّ':Subject, #2: 2	ثَبَتَ انْعِقَادُ
u'ثَبَتَ أهْلِيَّةٌ':Subject, #1: 1	ثَبَتَ الْأَهْلِيَّةُ
u'ثَبَتَ أَوَّلُ':Subject, #1: 1	ثَبَتَ الْأَهْلِيَّةُ
u'ثَبَتَ إِيجَابٌ':Subject, #3: 3	ثَبَتَ الْأَوَّلُ
u'ثَبَتَ إِيدَاعٌ':Subject, #1: 1	ثَبَتَ إيجَابُهُ
u'ثَبَتَ إيمَانٌ':Subject, #1: 1	ثَبَتَ الْإِيدَاعُ
u'ثَبَتَ بُطْلان':Subject, #1: 1	ثَبَتَ إيمَانُهُ
u'ثَبَتَ بَقاءٌ':Subject, #1: 1	ثَبَتَ بُطْلَانُهُ
u'ثَبَتَ بَوْلٌ':Subject, #3: 3	ثَبَتَ بَقَاءُ
u'ثَبَتَ بَيَانٌ':Subject, #2: 2	ثَبَتَ الْبَوْلُ
u'ثَبَتَ بَيْعٌ':Subject, #1: 1	ثَبَتَ بَيَانُ
u'ثَبَتَ بَيْعٌ':Subject, #1: 1	ثَبَتَ بَيْعُهُ
u'ثَبَتَ بَيْنٌ':Predicate, #7: 7	ثَبَتَ الْبَيْعُ
u'ثَبَتَ بَيِّنَةٌ':Subject, #2: 2	ثَبَتَ بَيْنَ
u'ثَبَتَ تَأْجِيلٌ':Subject, #1: 1	ثَبَتَ بَيِّنَةُ
u'ثَبَتَ تَأْخِيرٌ':Subject, #1: 1	ثَبَتَ التَّأْجِيلُ
u'ثَبَتَ تَجْزِيءٌ':Subject, #1: 1	ثَبَتَ التَّأْخِيرُ
u'ثَبَتَ تَحْبِيسٌ':Subject, #1: 1	ثَبَتَ التَّجْزِيءُ
u'ثَبَتَ تَحْرِيضٌ':Subject, #1: 1	ثَبَتَ تَحْبِيسُهُ
u'ثَبَتَ تَحْرِيفٌ':Subject, #1: 1	ثَبَتَ تَحْرِيضٌ
u'ثَبَتَ تَحْرِيمٌ':Subject, #2: 2	ثَبَتَ تَحْرِيفُ
u'ثَبَتَ تَحْرِيمٌ':Subject, #1: 1	ثَبَتَ تَحْرِيمٌ
u'ثَبَتَ تَحْرِيمٌ':Subject, #2: 2	ثَبَتَ تَحْرِيمُهُ
u'ثَبَتَ تَحْرِيمٌ':Subject, #5: 5	ثَبَتَ التَّحْرِيمُ
u'ثَبَتَ تَحَقُّقٌ':Subject, #5: 5	ثَبَتَ تَحْرِيمُ
u'ثَبَتَ تَحْلِيلٌ':Subject, #1: 1	ثَبَتَ تَحَقُّقُ
u'ثَبَتَ تَحْوِيلٌ':Subject, #1: 1	ثَبَتَ تَحْلِيلُ
u'ثَبَتَ تَخْصِيصٌ':Subject, #1: 1	ثَبَتَ تَحْوِيلُ
u'ثَبَتَ تَخْفِيفٌ':Subject, #1: 1	ثَبَتَ تَخْصِيصُ
u'ثَبَتَ تَخْيِيرٌ':Subject, #1: 1	ثَبَتَ تَخْفِيفٌ
u'ثَبَتَ تَدَافُعٌ':Subject, #2: 2	ثَبَتَ التَّخْيِيرُ
u'ثَبَتَ تَدْبِيرٌ':Subject, #1: 1	ثَبَتَ التَّدَافُعُ
u'ثَبَتَ تَرَاجُعٌ':Subject, #2: 2	ثَبَتَ التَّدْبِيرُ
u'ثَبَتَ تَرْتِيبٌ':Subject, #1: 1	ثَبَتَ التَّرَاجُعُ
u'ثَبَتَ تَصْحِيحٌ':Subject, #3: 3	ثَبَتَ التَّرْتِيبُ
u'ثَبَتَ تَصَرُّفٌ':Subject, #1: 1	ثَبَتَ تَصْحِيحُهُ
u'ثَبَتَ تَعَارُضٌ':Subject, #1: 1	ثَبَتَ تَصَرُّفُ
u'ثَبَتَ تَعَذُّرٌ':Subject, #2: 2	ثَبَتَ التَّعَارُضُ
u'ثَبَتَ تَعَلُّقٌ':Subject, #1: 1	ثَبَتَ التَّعَذُّرُ
u'ثَبَتَ تَعَلُّقٌ':Subject, #1: 1	ثَبَتَ التَّعَلُّقُ
u'ثَبَتَ تَعَلُّقٌ':Subject, #1: 1	ثَبَتَ تَعَلُّقُ
u'ثَبَتَ تَفاوُت':Subject, #1: 1	ثَبَتَ تَعَلُّقُهُ
u'ثَبَتَ تَفْوِيضٌ':Subject, #1: 1	ثَبَتَ التَّفَاوُتُ
u'ثَبَتَ تَقَدُّمٌ':Subject, #1: 1	ثَبَتَ التَّفْوِيضُ
u'ثَبَتَ تَقْديمٌ':Subject, #1: 1	ثَبَتَ تَقَدُّمُ
u'ثَبَتَ تَقْيِيد':Subject, #1: 1	ثَبَتَ تَقْدِيمُ
u'ثَبَتَ تَكْليفٌ':Subject, #1: 1	ثَبَتَ التَّقْيِيدُ
u'ثَبَتَ تَلازُم':Subject, #2: 2	ثَبَتَ التَّكْلِيفُ
u'ثَبَتَ تَلَف':Subject, #1: 1	ثَبَتَ التَّلَازُمُ
u'ثَبَتَ تَمَرُّدٌ':Subject, #1: 1	ثَبَتَ التَّلَفُ
u'ثَبَتَ تَمْلِيك':Subject, #2: 2	ثَبَتَ تَمَرُّدُهُ
u'ثَبَتَ تَنَاقُضٌ':Subject, #2: 2	ثَبَتَ التَّمْلِيكُ
u'ثَبَتَ تَنَزُّه':Subject, #1: 1	ثَبَتَ التَّنَاقُضُ
u'ثَبَتَ تَنْصِيفٌ':Subject, #1: 1	ثَبَتَ التَّنَزُّهُ
u'ثَبَتَ تُهْمَةٌ':Subject, #1: 1	ثَبَتَ التَّنْصِيفُ
u'ثَبَتَ تَوَارُثٌ':Subject, #1: 1	ثَبَتَ التُّهْمَةُ
u'ثَبَتَ تَوَجُّهٌ':Subject, #1: 1	ثَبَتَ التَّوَارُثُ
u'ثَبَتَ تَوْفِيقٌ':Subject, #1: 1	ثَبَتَ التَّوَجُّهُ
u'ثَبَتَ تَوَقُّفٌ':Subject, #1: 1	ثَبَتَ التَّوْفِيقُ
u'ثَبَتَ تَوَقُّفٌ':Subject, #1: 1	ثَبَتَ التَّوَقُّفُ
u'ثَبَتَ ثُبُوتٌ':Predicate, #1: 1	ثَبَتَ تَوَقُّفٌ
u'ثَبَتَ جُحُود':Subject, #1: 1	ثَبَتَ ثُبُوتَ
u'ثَبَتَ جَرٌّ':Subject, #1: 1	ثَبَتَ جُحُودُهُ
u'ثَبَتَ جُرْحٌ':Subject, #1: 1	ثَبَتَ جَرُّ
u'ثَبَتَ جُزْئِيٌّ':Subject, #1: 1	ثَبَتَ الْجُرْحُ
u'ثَبَتَ جَمِيع':Subject, #1: 1	ثَبَتَ جُزْئِيٌّ
u'ثَبَتَ جَوَازٌ':Subject, #2: 2	ثَبَتَ الْجَمِيعُ
u'ثَبَتَ جَوَازٌ':Subject, #2: 2	ثَبَتَ الْجَوَازُ
u'ثَبَتَ جَوَازٌ':Subject, #4: 4	ثَبَتَ جَوَازُهُ
u'ثَبَتَ حادِثٌ':Subject, #9: 9	ثَبَتَ جَوَازُ
u'ثَبَتَ حالٌ':Subject, #1: 1	ثَبَتَ الْحَادِثُ
u'ثَبَتَ حَجْرٌ':Subject, #1: 1	ثَبَتَ حَالُ
u'ثَبَتَ حَجْرٌ':Subject, #2: 2	ثَبَتَ الْحَجْرُ
u'ثَبَتَ حَدٌّ':Subject, #3: 3	ثَبَتَ حَجْرُهُ
u'ثَبَتَ حَدٌّ':Subject, #2: 2	ثَبَتَ الْحَدُّ
u'ثَبَتَ حَدَثٌ':Subject, #2: 2	ثَبَتَ حَدُّ
u'ثَبَتَ حَديثٌ':Subject, #1: 1	ثَبَتَ الْحَدَثُ
u'ثَبَتَ حَديثٌ':Subject, #1: 1	ثَبَتَ حَدِيثُهُ
u'ثَبَتَ حَديثٌ':Subject, #6: 6	ثَبَتَ الْحَدِيثُ
u'ثَبَتَ حَرَجٌ':Subject, #6: 6	ثَبَتَ حَدِيثُ
u'ثَبَتَ حُرْمَةٌ':Subject, #1: 1	ثَبَتَ الْحَرَجُ
u'ثَبَتَ حُرْمَةٌ':Subject, #1: 1	ثَبَتَ حُرْمَتُهُ
u'ثَبَتَ حُرِّيَّةٌ':Subject, #2: 2	ثَبَتَ حُرْمَةُ
u'ثَبَتَ حُرِّيَّةٌ':Subject, #1: 1	ثَبَتَ حُرِّيَّتُهُ
u'ثَبَتَ حُضورٌ':Subject, #4: 4	ثَبَتَ حُرِّيَّةُ
u'ثَبَتَ حُضُورٌ':Subject, #1: 1	ثَبَتَ حُضُورُ
u'ثَبَتَ حَظٌّ':Subject, #1: 1	ثَبَتَ حُضُورُ
u'ثَبَتَ حَقٌّ':Predicate, #1: 1	ثَبَتَ حَظُّهُ
u'ثَبَتَ حَقٌّ':Subject, #1: 1	ثَبَتَ الْحَقَّ
u'ثَبَتَ حَقٌّ':Subject, #23: 23	ثَبَتَ حَقُّ
u'ثَبَتَ حَقٌّ':Subject, #32: 32	ثَبَتَ الْحَقُّ
u'ثَبَتَ حَقِيقٌ':Subject, #9: 9	ثَبَتَ حَقُّهُ
u'ثَبَتَ حَقِيقَةٌ':Subject, #1: 1	ثَبَتَ حَقِيقَتُهُ
u'ثَبَتَ حُكْمٌ':Subject, #1: 1	ثَبَتَ حَقِيقَتُهُ
u'ثَبَتَ حُكْمٌ':Subject, #15: 15	ثَبَتَ حُكْمُهُ
u'ثَبَتَ حُكْمٌ':Subject, #26: 26	ثَبَتَ حُكْمُ
u'ثَبَتَ حُكْمٌ':Subject, #32: 32	ثَبَتَ الْحُكْمُ
u'ثَبَتَ حِلٌّ':Subject, #6: 6	ثَبَتَ حُكْمٌ
u'ثَبَتَ حَمْلٌ':Subject, #3: 3	ثَبَتَ الْحِلُّ
u'ثَبَتَ حِنْثٌ':Subject, #1: 1	ثَبَتَ الْحَمْلُ
u'ثَبَتَ حَيْضَةٌ':Subject, #1: 1	ثَبَتَ حِنْثُ
u'ثَبَتَ خَالِقٌ':Subject, #1: 1	ثَبَتَ حَيْضَةُ
u'ثَبَتَ خُبْثٌ':Subject, #1: 1	ثَبَتَ الْخَالِقُ
u'ثَبَتَ خَبَرٌ':Subject, #1: 1	ثَبَتَ خُبْثُهُ
u'ثَبَتَ خَبَر':Subject, #1: 1	ثَبَتَ خَبَرُ
u'ثَبَتَ خَبَرٌ':Subject, #1: 1	ثَبَتَ خَبَرُ
u'ثَبَتَ خَبَر':Subject, #3: 3	ثَبَتَ الْخَبَرُ
u'ثَبَتَ خُرُوجٌ':Subject, #3: 3	ثَبَتَ الْخَبَرُ
u'ثَبَتَ خِلاَفٌ':Subject, #1: 1	ثَبَتَ خُرُوجُهُ
u'ثَبَتَ خِلاَفٌ':Subject, #3: 3	ثَبَتَ الْخِلَافُ
u'ثَبَتَ خيار':Subject, #3: 3	ثَبَتَ خِلَافُهُ
u'ثَبَتَ خِيَارٌ':Subject, #1: 1	ثَبَتَ خِيَارٌ
u'ثَبَتَ خيار':Subject, #1: 1	ثَبَتَ خِيَارٌ
u'ثَبَتَ خِيَارٌ':Subject, #1: 1	ثَبَتَ خِيَارُهُ
u'ثَبَتَ خيار':Subject, #1: 1	ثَبَتَ خِيَارُهُ
u'ثَبَتَ خِيَارٌ':Subject, #29: 29	ثَبَتَ الْخِيَارُ
u'ثَبَتَ خيار':Subject, #29: 29	ثَبَتَ الْخِيَارُ
u'ثَبَتَ خِيَارٌ':Subject, #3: 3	ثَبَتَ خِيَارُ
u'ثَبَتَ دُخُولٌ':Subject, #3: 3	ثَبَتَ خِيَارُ
u'ثَبَتَ دفع':Subject, #2: 2	ثَبَتَ دُخُولُ
u'ثَبَتَ دَفْعٌ':Subject, #1: 1	ثَبَتَ الدَّفْعُ
u'ثَبَتَ دَلالَةٌ':Subject, #1: 1	ثَبَتَ الدَّفْعُ
u'ثَبَتَ دَلالَةٌ':Subject, #1: 1	ثَبَتَ دَلَالَةُ
u'ثَبَتَ دَمٌ':Subject, #2: 2	ثَبَتَ دَلاَلَةٌ
u'ثَبَتَ دَيْنٌ':Subject, #1: 1	ثَبَتَ الدَّمُ
u'ثَبَتَ دَيْنٌ':Subject, #17: 17	ثَبَتَ الدَّيْنُ
u'ثَبَتَ دَيْنٌ':Subject, #3: 3	ثَبَتَ دَيْنُهُ
u'ثَبَتَ دِينارٌ':Subject, #4: 4	ثَبَتَ دَيْنٌ
u'ثَبَتَ ذكر':Subject, #1: 1	ثَبَتَ الدِّينَارُ
u'ثَبَتَ ذِكْرٌ':Subject, #1: 1	ثَبَتَ ذِكْرُهُ
u'ثَبَتَ ذَمٌّ':Subject, #1: 1	ثَبَتَ ذِكْرُهُ
u'ثَبَتَ رَاجِحٌ':Subject, #2: 2	ثَبَتَ ذَمُّ
u'ثَبَتَ رُجْحانٌ':Subject, #1: 1	ثَبَتَ الرَّاجِحُ
u'ثَبَتَ رُجُوعٌ':Subject, #2: 2	ثَبَتَ رُجْحَانُ
u'ثَبَتَ رُجُوعٌ':Subject, #12: 12	ثَبَتَ الرُّجُوعُ
u'ثَبَتَ رُجُوعٌ':Subject, #3: 3	ثَبَتَ رُجُوعُ
u'ثَبَتَ رُشْدٌ':Subject, #3: 3	ثَبَتَ رُجُوعُهُ
u'ثَبَتَ رُشْدٌ':Subject, #1: 1	ثَبَتَ رُشْدُ
u'ثَبَتَ رضاع':Subject, #1: 1	ثَبَتَ رُشْدُهُ
u'ثَبَتَ رَفْعٌ':Subject, #1: 1	ثَبَتَ الرَّضَاعُ
u'ثَبَتَ رِقٌّ':Subject, #1: 1	ثَبَتَ رَفْعُ
u'ثَبَتَ رَمَضانُ':Subject, #1: 1	ثَبَتَ الرِّقُّ
u'ثَبَتَ رَهْنٌ':Subject, #4: 4	ثَبَتَ رَمَضَانُ
u'ثَبَتَ رَهْنٌ':Subject, #1: 1	ثَبَتَ رَهْنُ
u'ثَبَتَ رُؤْيَةٌ':Subject, #3: 3	ثَبَتَ الرَّهْنُ
u'ثَبَتَ زَوالٌ':Subject, #1: 1	ثَبَتَ رُؤْيَتُهُ
u'ثَبَتَ زُورٌ':Subject, #1: 1	ثَبَتَ زَوَالُ
u'ثَبَتَ سَبَبٌ':Subject, #1: 1	ثَبَتَ زُورُ
u'ثَبَتَ سَبَبٌ':Subject, #1: 1	ثَبَتَ سَبَبُ
u'ثَبَتَ سَبْقٌ':Subject, #1: 1	ثَبَتَ سَبَبُهُ
u'ثَبَتَ سَدَادٌ':Subject, #1: 1	ثَبَتَ سَبْقُ
u'ثَبَتَ سَمَاعٌ':Subject, #1: 1	ثَبَتَ السَّدَادُ
u'ثَبَتَ سَنَدٌ':Subject, #1: 1	ثَبَتَ سَمَاعُهُ
u'ثَبَتَ شافِعِيّ':Subject, #1: 1	ثَبَتَ سَنَدُهُ
u'ثَبَتَ شَبَهٌ':Subject, #1: 1	ثَبَتَ الشَّافِعِيُّ
u'ثَبَتَ شُبْهَةٌ':Subject, #1: 1	ثَبَتَ شَبَهُهُ
u'ثَبَتَ شُبْهَةٌ':Subject, #1: 1	ثَبَتَ شُبْهَتُهُ
u'ثَبَتَ شِرَاءٌ':Subject, #2: 2	ثَبَتَ شُبْهَةُ
u'ثَبَتَ شَرْطٌ':Subject, #5: 5	ثَبَتَ الشِّرَاءُ
u'ثَبَتَ شَرْطٌ':Subject, #1: 1	ثَبَتَ الشَّرْطُ
u'ثَبَتَ شَرْعٌ':Subject, #3: 3	ثَبَتَ شَرْطُ
u'ثَبَتَ شرف':Subject, #2: 2	ثَبَتَ الشَّرْعُ
u'ثَبَتَ شَرَفٌ':Subject, #1: 1	ثَبَتَ شَرَفُهُ
u'ثَبَّتَ شَعْرٌ':Predicate, #1: 1	ثَبَتَ شَرَفُهُ
u'ثَبَتَ شُمُول':Subject, #1: 1	ثَبَّتَ شَعْرَ
u'ثَبَتَ شُمُول':Subject, #1: 1	ثَبَتَ شُمُولُ
u'ثَبَتَ شَهَادَةٌ':Subject, #1: 1	ثَبَتَ شُمُولُهُ
u'ثَبَتَ شهرة':Subject, #1: 1	ثَبَتَ الشَّهَادَةُ
u'ثَبَتَ شُهْرَةٌ':Subject, #1: 1	ثَبَتَ الشُّهْرَةُ
u'ثَبَتَ صِحَّةٌ':Subject, #1: 1	ثَبَتَ الشُّهْرَةُ
u'ثَبَتَ صدق':Subject, #1: 1	ثَبَتَ صِحَّةُ
u'ثَبَتَ صِدْقٌ':Subject, #4: 4	ثَبَتَ صِدْقُهُ
u'ثَبَتَ صِغَرٌ':Subject, #4: 4	ثَبَتَ صِدْقُهُ
u'ثَبَتَ صَوْمٌ':Subject, #1: 1	ثَبَتَ الصِّغَرُ
u'ثَبَتَ صِيَامٌ':Subject, #2: 2	ثَبَتَ الصَّوْمُ
u'ثَبَتَ ضِدٌّ':Subject, #1: 1	ثَبَتَ صِيَامُ
u'ثَبَتَ ضَرْبٌ':Subject, #1: 1	ثَبَتَ ضِدُّهُ
u'ثَبَتَ ضَرَرٌ':Subject, #1: 1	ثَبَتَ ضَرْبُهُ
u'ثَبَتَ ضَرُورَةٌ':Predicate, #1: 1	ثَبَتَ الضَّرَرُ
u'ثَبَتَ ضَرُورَةٌ':Subject, #6: 6	ثَبَتَ ضَرُورَةَ
u'ثَبَتَ ضَمَانٌ':Subject, #1: 1	ثَبَتَ ضَرُورَةُ
u'ثَبَتَ ضَيَاعٌ':Subject, #3: 3	ثَبَتَ الضَّمَانُ
u'ثَبَتَ طَلاَقٌ':Subject, #1: 1	ثَبَتَ ضَيَاعُهُ
u'ثَبَتَ طلب':Subject, #2: 2	ثَبَتَ الطَّلَاقُ
u'ثَبَتَ طَلَبٌ':Subject, #1: 1	ثَبَتَ طَلَبُهُ
u'ثَبَتَ طلب':Subject, #1: 1	ثَبَتَ طَلَبُهُ
u'ثَبَتَ طَلَبٌ':Subject, #2: 2	ثَبَتَ الطَّلَبُ
u'ثَبَتَ ظهار':Subject, #2: 2	ثَبَتَ الطَّلَبُ
u'ثَبَتَ عَامٌّ':Subject, #1: 1	ثَبَتَ الظِّهَارُ
u'ثَبَتَ عَبْدٌ':Subject, #1: 1	ثَبَتَ عَامٌّ
u'ثَبَتَ عتق':Predicate, #1: 1	ثَبَتَ الْعَبْدُ
u'ثَبَتَ عتق':Subject, #2: 2	ثَبَتَ عَتَقَ
u'ثَبَتَ عِتْقٌ':Subject, #15: 15	ثَبَتَ الْعِتْقُ
u'ثَبَتَ عتق':Subject, #15: 15	ثَبَتَ الْعِتْقُ
u'ثَبَتَ عِتْقٌ':Subject, #1: 1	ثَبَتَ عِتْقُ
u'ثَبَتَ عتق':Subject, #1: 1	ثَبَتَ عِتْقُ
u'ثَبَتَ عِتْقٌ':Subject, #2: 2	ثَبَتَ عِتْقُهُ
u'ثَبَتَ عجز':Subject, #2: 2	ثَبَتَ عِتْقُهُ
u'ثَبَتَ عَجْزٌ':Subject, #2: 2	ثَبَتَ الْعَجْزُ
u'ثَبَتَ عجز':Subject, #2: 2	ثَبَتَ الْعَجْزُ
u'ثَبَتَ عَجْزٌ':Subject, #2: 2	ثَبَتَ عَجْزُهُ
u'ثَبَتَ عَدَالَةٌ':Subject, #2: 2	ثَبَتَ عَجْزُهُ
u'ثَبَتَ عَدَمٌ':Subject, #1: 1	ثَبَتَ الْعَدَالَةُ
u'ثَبَتَ عَدَمٌ':Subject, #13: 13	ثَبَتَ عَدَمُ
u'ثَبَتَ عُذْرٌ':Subject, #4: 4	ثَبَتَ عَدَمُهُ
u'ثَبَتَ عزل':Subject, #2: 2	ثَبَتَ الْعُذْرُ
u'ثَبَتَ عُسْرَةٌ':Subject, #1: 1	ثَبَتَ الْعَزْلُ
u'ثَبَتَ عِصْمَةٌ':Subject, #1: 1	ثَبَتَ عُسْرَتُهُ
u'ثَبَتَ عَفْوٌ':Subject, #2: 2	ثَبَتَ عِصْمَةُ
u'ثَبَتَ عَفْوٌ':Subject, #2: 2	ثَبَتَ الْعَفْوُ
u'ثَبَتَ عَقْدٌ':Subject, #2: 2	ثَبَتَ عَفْوُ
u'ثَبَتَ عِلَّةٌ':Subject, #1: 1	ثَبَتَ الْعَقْدُ
u'ثَبَتَ عِلَّةٌ':Subject, #1: 1	ثَبَتَ الْعِلَّةُ
u'ثَبَتَ علم':Subject, #1: 1	ثَبَتَ عِلَّتُهُ
u'ثَبَتَ عِلْمٌ':Subject, #1: 1	ثَبَتَ الْعِلْمُ
u'ثَبَتَ علم':Subject, #1: 1	ثَبَتَ الْعِلْمُ
u'ثَبَتَ عِلْمٌ':Subject, #1: 1	ثَبَتَ عِلْمُهُ
u'ثَبَتَ عِلِّيٌّ':Subject, #1: 1	ثَبَتَ عِلْمُهُ
u'ثَبَتَ عِلِّيٌّ':Subject, #2: 2	ثَبَتَ عِلِّيَّتُهُ
u'ثَبَتَ عُمُومٌ':Subject, #3: 3	ثَبَتَ عِلِّيَّةُ
u'ثَبَتَ عُمُومٌ':Subject, #1: 1	ثَبَتَ عُمُومُهُ
u'ثَبَتَ عند':Predicate, #2: 2	ثَبَتَ الْعُمُومُ
u'ثَبَتَ عند':Predicate, #1: 1	ثَبَتَ عِنْدَكَ
u'ثَبَتَ عَوْدٌ':Subject, #34: 34	ثَبَتَ عِنْدَ
u'ثَبَتَ عِوَضٌ':Subject, #1: 1	ثَبَتَ عَوْدُهُ
u'ثَبَتَ عَيْبٌ':Subject, #2: 2	ثَبَتَ الْعِوَضُ
u'ثَبَتَ غُرْمٌ':Subject, #5: 5	ثَبَتَ الْعَيْبُ
u'ثَبَتَ غُرُورٌ':Subject, #2: 2	ثَبَتَ الْغُرْمُ
u'ثَبَتَ غَصْبٌ':Subject, #2: 2	ثَبَتَ غُرُورُ
u'ثَبَتَ غَصْبٌ':Subject, #2: 2	ثَبَتَ غَصْبُهُ
u'ثَبَتَ غَلَطٌ':Subject, #6: 6	ثَبَتَ الْغَصْبُ
u'ثَبَتَ غير':Predicate, #4: 4	ثَبَتَ الْغَلَطُ
u'ثَبَتَ غَيْرٌ':Predicate, #1: 1	ثَبَتَ غَيْرَ
u'ثَبَتَ غير':Subject, #1: 1	ثَبَتَ غَيْرَ
u'ثَبَتَ غَيْرٌ':Subject, #1: 1	ثَبَتَ غَيْرُ
u'ثَبَتَ فِرَاشٌ':Subject, #1: 1	ثَبَتَ غَيْرُ
u'ثَبَتَ فِرَاشٌ':Subject, #1: 1	ثَبَتَ الْفِرَاشُ
u'ثَبَتَ فَرْدٌ':Subject, #1: 1	ثَبَتَ فِرَاشُ
u'ثَبَتَ فَرْعٌ':Subject, #2: 2	ثَبَتَ فَرْدٌ
u'ثَبَتَ فَرْعٌ':Subject, #1: 1	ثَبَتَ فَرْعُهُ
u'ثَبَتَ فرق':Subject, #3: 3	ثَبَتَ الْفَرْعُ
u'ثَبَتَ فَرْقٌ':Subject, #1: 1	ثَبَتَ الْفَرْقُ
u'ثَبَّتَ فُرُوعٌ':Predicate, #1: 1	ثَبَتَ الْفَرْقُ
u'ثَبَتَ فساد':Subject, #1: 1	ثَبَّتَ فُرُوعَ
u'ثَبَتَ فَسَادٌ':Subject, #2: 2	ثَبَتَ فَسَادُ
u'ثَبَتَ فَسْخٌ':Subject, #2: 2	ثَبَتَ فَسَادُ
u'ثَبَتَ فِسْقٌ':Subject, #5: 5	ثَبَتَ الْفَسْخُ
u'ثَبَتَ فَضْلٌ':Subject, #5: 5	ثَبَتَ فِسْقُهُ
u'ثَبَتَ فَضْلٌ':Subject, #1: 1	ثَبَتَ الْفَضْلُ
u'ثَبَتَ فِعْلٌ':Subject, #1: 1	ثَبَتَ فَضْلُهُ
u'ثَبَتَ فَقْدٌ':Subject, #6: 6	ثَبَتَ فِعْلُهُ
u'ثَبَتَ فلان':Subject, #1: 1	ثَبَتَ فَقْدُ
u'ثَبَتَ قَالٌ':Predicate, #1: 1	ثَبَتَ الشَّافِعِيُّ
u'ثَبَتَ قِبَلٌ':Predicate, #3: 3	ثَبَتَ قَالَ
u'ثَبَتَ قتل':Subject, #1: 1	ثَبَتَ قِبَلَ
u'ثَبَتَ قَتْلٌ':Subject, #2: 2	ثَبَتَ قَتْلُهُ
u'ثَبَتَ قتل':Subject, #2: 2	ثَبَتَ قَتْلُهُ
u'ثَبَتَ قَتْلٌ':Subject, #8: 8	ثَبَتَ الْقَتْلُ
u'ثَبَتَ قَدْرٌ':Subject, #8: 8	ثَبَتَ الْقَتْلُ
u'ثَبَتَ قَدْرٌ':Subject, #1: 1	ثَبَتَ قَدْرٌ
u'ثَبَتَ قدم':Subject, #1: 1	ثَبَتَ قَدْرُ
u'ثَبَتَ قِدَمٌ':Subject, #2: 2	ثَبَتَ قِدَمُهُ
u'ثَبَتَ قذف':Subject, #2: 2	ثَبَتَ قِدَمُهُ
u'ثَبَتَ قَذْفٌ':Subject, #1: 1	ثَبَتَ الْقَذْفُ
u'ثَبَتَ قرائن':Subject, #1: 1	ثَبَتَ الْقَذْفُ
u'ثَبَتَ قِسْمٌ':Subject, #1: 1	ثَبَتَ قَرَائِنُ
u'ثَبَتَ قصاص':Subject, #1: 1	ثَبَتَ قِسْمٌ
u'ثَبَتَ قِصَاصٌ':Subject, #1: 1	ثَبَتَ الْقِصَاصُ
u'ثَبَتَ قُصُورٌ':Subject, #1: 1	ثَبَتَ الْقِصَاصُ
u'ثَبَتَ قَطْعٌ':Subject, #1: 1	ثَبَتَ قُصُورُ
u'ثَبَتَ قَلَمٌ':Subject, #1: 1	ثَبَتَ الْقَطْعُ
u'ثَبَتَ قول':Subject, #1: 1	ثَبَتَ الْقَلَمُ
u'ثَبَتَ قَوْلٌ':Subject, #1: 1	ثَبَتَ الْقَوْلُ
u'ثَبَتَ قَوْلٌ':Subject, #1: 1	ثَبَتَ الْقَوْلُ
u'ثَبَتَ قول':Subject, #1: 1	ثَبَتَ قَوْلٌ
u'ثَبَتَ قَوْلٌ':Subject, #2: 2	ثَبَتَ قَوْلُ
u'ثَبَتَ قول':Subject, #2: 2	ثَبَتَ قَوْلُ
u'ثَبَتَ قَوْلٌ':Subject, #7: 7	ثَبَتَ قَوْلُهُ
u'ثَبَتَ كَامِلٌ':Subject, #7: 7	ثَبَتَ قَوْلُهُ
u'ثَبَتَ كِتَابٌ':Subject, #1: 1	ثَبَتَ كَامِلٌ
u'ثَبَتَ كذب':Subject, #2: 2	ثَبَتَ الْكِتَابُ
u'ثَبَتَ كَذِبٌ':Subject, #1: 1	ثَبَتَ كَذِبُ
u'ثَبَتَ كَرَاهِيَةٌ':Subject, #1: 1	ثَبَتَ كَذِبُ
u'ثَبَتَ كفر':Subject, #1: 1	ثَبَتَ كَرَاهِيَةُ
u'ثَبَتَ كُفْرٌ':Subject, #2: 2	ثَبَتَ كُفْرُهُ
u'ثَبَتَ كَمَالٌ':Subject, #2: 2	ثَبَتَ كُفْرُهُ
u'ثَبَتَ كَوْنٌ':Subject, #1: 1	ثَبَتَ كَمَالُ
u'ثَبَتَ كَوْنٌ':Subject, #15: 15	ثَبَتَ كَوْنُهُ
u'ثَبَتَ كِيسٌ':Subject, #2: 2	ثَبَتَ كَوْنُ
u'ثَبَتَ كَيْلٌ':Subject, #1: 1	ثَبَتَ الْكِيسُ
u'ثَبَتَ لحاق':Subject, #2: 2	ثَبَتَ كَيْلُهُ
u'ثَبَتَ لِحَاقٌ':Subject, #1: 1	ثَبَتَ اللِّحَاقُ
u'ثَبَتَ لحاق':Subject, #1: 1	ثَبَتَ اللِّحَاقُ
u'ثَبَتَ لِحَاقٌ':Subject, #1: 1	ثَبَتَ لِحَاقُهُ
u'ثَبَتَ لُزُومٌ':Subject, #1: 1	ثَبَتَ لِحَاقُهُ
u'ثَبَتَ لعان':Subject, #2: 2	ثَبَتَ لُزُومُ
u'ثَبَتَ لَفْظٌ':Subject, #1: 1	ثَبَتَ اللِّعَانُ
u'ثَبَتَ مَالٌ':Subject, #1: 1	ثَبَتَ اللَّفْظُ
u'ثَبَتَ مَالِكٌ':Subject, #12: 12	ثَبَتَ الْمَالُ
u'ثَبَتَ مَبْلَغٌ':Subject, #1: 1	ثَبَتَ مَالِكٌ
u'ثَبَتَ مُتَضَمِّن':Subject, #1: 1	ثَبَتَ مَبْلَغُهُ
u'ثَبَتَ مُتَّفَقٌ':Subject, #1: 1	ثَبَتَ الْمُتَضَمِّنُ
u'ثَبَتَ مُتَّفَقٌ':Subject, #1: 1	ثَبَتَ الْمُتَّفَقُ
u'ثَبَتَ مُتَكَلَّمٌ':Subject, #1: 1	ثَبَتَ مُتَّفَقٌ
u'ثَبَتَ مثل':Subject, #1: 1	ثَبَتَ الْمُتَكَلَّمُ
u'ثَبَتَ مِثْلٌ':Subject, #4: 4	ثَبَتَ مِثْلُ
u'ثَبَتَ مَذْهَبٌ':Subject, #4: 4	ثَبَتَ مِثْلُ
u'ثَبَتَ مُسَاوَاةٌ':Subject, #1: 1	ثَبَتَ مَذْهَبُهُ
u'ثَبَتَ مَسْحٌ':Subject, #1: 1	ثَبَتَ الْمُسَاوَاةُ
u'ثَبَتَ مَسْحٌ':Subject, #1: 1	ثَبَتَ مَسْحُهُ
u'ثَبَتَ مَشْهُودٌ':Subject, #2: 2	ثَبَتَ مَسْحُ
u'ثَبَتَ مُطْلَقٌ':Subject, #2: 2	ثَبَتَ الْمَشْهُودُ
u'ثَبَتَ مَطْلُوبٌ':Subject, #4: 4	ثَبَتَ مُطْلَقُ
u'ثَبَتَ مَطْلُوبٌ':Subject, #1: 1	ثَبَتَ الْمَطْلُوبُ
u'ثَبَتَ مُعَلَّقٌ':Subject, #1: 1	ثَبَتَ مَطْلُوبُهُ
u'ثَبَتَ مَفْهُومٌ':Subject, #1: 1	ثَبَتَ الْمُعَلَّقُ
u'ثَبَتَ مِقْدَارٌ':Subject, #1: 1	ثَبَتَ الْمَفْهُومُ
u'ثَبَتَ مَكْتُوبٌ':Subject, #1: 1	ثَبَتَ مِقْدَارٌ
u'ثَبَتَ مَلِكٌ':Subject, #1: 1	ثَبَتَ الْمَكْتُوبُ
u'ثَبَتَ مُلْكٌ':Subject, #1: 1	ثَبَتَ الْمَلِكُ
u'ثَبَتَ مِلْكٌ':Subject, #2: 2	ثَبَتَ مُلْكُهُ
u'ثَبَتَ مِلْكٌ':Subject, #50: 50	ثَبَتَ الْمِلْكُ
u'ثَبَتَ مِلْكٌ':Subject, #6: 6	ثَبَتَ مِلْكُهُ
u'ثَبَتَ مَنَاطٌ':Subject, #9: 9	ثَبَتَ مِلْكُ
u'ثَبَتَ مَهْرٌ':Subject, #2: 2	ثَبَتَ مَنَاطُ
u'ثَبَتَ مَوْتٌ':Subject, #2: 2	ثَبَتَ الْمَهْرُ
u'ثَبَتَ مَوْتٌ':Subject, #2: 2	ثَبَتَ مَوْتُهُ
u'ثَبَتَ مُوجَبٌ':Subject, #5: 5	ثَبَتَ الْمَوْتُ
u'ثَبَتَ مُوجِبٌ':Subject, #1: 1	ثَبَتَ مُوجَبُهُ
u'ثَبَتَ مُوجِبٌ':Subject, #1: 1	ثَبَتَ مُوجِبُهُ
u'ثَبَتَ مَوْهُوبٌ':Subject, #5: 5	ثَبَتَ مُوجِبُ
u'ثَبَتَ مِيرَاثٌ':Subject, #1: 1	ثَبَتَ الْمَوْهُوبُ
u'ثَبَتَ نَبِيٌّ':Subject, #1: 1	ثَبَتَ الْمِيرَاثُ
u'ثَبَتَ نَزَلٌ':Predicate, #1: 1	ثَبَتَ النَّبِيُّ
u'ثَبَتَ نَسَبٌ':Subject, #1: 1	ثَبَتَ نَزَلَ
u'ثَبَّتَ نَسَبٌ':Subject, #150: 150	ثَبَتَ نَسَبُهُ
u'ثَبَتَ نَسَبٌ':Subject, #1: 1	ثَبَّتَ النَّسَبُ
u'ثَبَتَ نَسَبٌ':Subject, #47: 47	ثَبَتَ نَسَبُ
u'ثَبَتَ نِسْبَةٌ':Subject, #90: 90	ثَبَتَ النَّسَبُ
u'ثَبَتَ نَصٌّ':Subject, #1: 1	ثَبَتَ نِسْبَةٌ
u'ثَبَتَ نِصْفٌ':Subject, #2: 2	ثَبَتَ نَصُّ
u'ثَبَتَ نِصْفٌ':Subject, #1: 1	ثَبَتَ نِصْفُهُ
u'ثَبَتَ نِصْفٌ':Subject, #3: 3	ثَبَتَ نِصْفُ
u'ثَبَتَ نَفْيٌ':Subject, #5: 5	ثَبَتَ النِّصْفُ
u'ثَبَتَ نَفْيٌ':Subject, #1: 1	ثَبَتَ النَّفْيُ
u'ثَبَتَ نَقْدٌ':Subject, #1: 1	ثَبَتَ نَفْيُ
u'ثَبَتَ نَقْد':Subject, #4: 4	ثَبَتَ نَقْدُ
u'ثَبَتَ نَقْصٌ':Subject, #4: 4	ثَبَتَ نَقْدُ
u'ثَبَتَ نَقْضٌ':Subject, #1: 1	ثَبَتَ نَقْصُهُ
u'ثَبَتَ نقل':Subject, #1: 1	ثَبَتَ النَّقْضُ
u'ثَبَتَ نَقْلٌ':Subject, #1: 1	ثَبَتَ النَّقْلُ
u'ثَبَتَ نَقْلٌ':Subject, #1: 1	ثَبَتَ النَّقْلُ
u'ثَبَتَ نقل':Subject, #1: 1	ثَبَتَ نَقْلٌ
u'ثَبَتَ نَقْلٌ':Subject, #1: 1	ثَبَتَ نَقْلُهُ
u'ثَبَتَ نَقِيضٌ':Subject, #1: 1	ثَبَتَ نَقْلُهُ
u'ثَبَتَ نكاح':Subject, #1: 1	ثَبَتَ نَقِيضُ
u'ثَبَتَ نِكَاحٌ':Subject, #18: 18	ثَبَتَ النِّكَاحُ
u'ثَبَتَ نكاح':Subject, #18: 18	ثَبَتَ النِّكَاحُ
u'ثَبَتَ نِكَاحٌ':Subject, #3: 3	ثَبَتَ نِكَاحُهُ
u'ثَبَتَ نكاح':Subject, #3: 3	ثَبَتَ نِكَاحُهُ
u'ثَبَتَ نِكَاحٌ':Subject, #4: 4	ثَبَتَ نِكَاحُ
u'ثَبَتَ نَهْيٌ':Subject, #4: 4	ثَبَتَ نِكَاحُ
u'ثَبَتَ نَهْيٌ':Subject, #1: 1	ثَبَتَ نَهْيٌ
u'ثَبَتَ نَهْيٌ':Subject, #1: 1	ثَبَتَ نَهْيُ
u'ثَبَتَ نَوْعٌ':Subject, #3: 3	ثَبَتَ النَّهْيُ
u'ثَبَتَ هلاك':Subject, #1: 1	ثَبَتَ نَوْعُ
u'ثَبَتَ هَلاَكٌ':Subject, #1: 1	ثَبَتَ هَلَاكُ
u'ثَبَتَ هِلاَلٌ':Subject, #1: 1	ثَبَتَ هَلَاكُ
u'ثَبَتَ هِلاَلٌ':Subject, #1: 1	ثَبَتَ هِلَالُ
u'ثَبَتَ وَجَبٌ':Predicate, #2: 2	ثَبَتَ الْهِلَالُ
u'ثَبَتَ وَجْهٌ':Subject, #1: 1	ثَبَتَ وَجَبَ
u'ثَبَتَ وُجُوبٌ':Subject, #1: 1	ثَبَتَ وَجْهُ
u'ثَبَتَ وُجُوبٌ':Subject, #13: 13	ثَبَتَ وُجُوبُ
u'ثَبَتَ وُجُوبٌ':Subject, #5: 5	ثَبَتَ الْوُجُوبُ
u'ثَبَتَ وُجُودٌ':Subject, #9: 9	ثَبَتَ وُجُوبُهُ
u'ثَبَتَ وُجُودٌ':Subject, #1: 1	ثَبَتَ الْوُجُودُ
u'ثَبَتَ وِرَاثَةٌ':Subject, #2: 2	ثَبَتَ وُجُودُ
u'ثَبَتَ وُرُودٌ':Subject, #1: 1	ثَبَتَ وِرَاثَةُ
u'ثَبَتَ وَزْنٌ':Subject, #1: 1	ثَبَتَ وُرُودُهُ
u'ثَبَتَ وَصْفٌ':Subject, #2: 2	ثَبَتَ وَزْنُهُ
u'ثَبَتَ وُصُولٌ':Subject, #1: 1	ثَبَتَ الْوَصْفُ
u'ثَبَتَ وَصِيٌّ':Subject, #3: 3	ثَبَتَ وُصُولُ
u'ثَبَتَ وَصِيَّةٌ':Subject, #1: 1	ثَبَتَ الْوَصِيَّةُ
u'ثَبَتَ وَضْعٌ':Subject, #1: 1	ثَبَتَ الْوَصِيَّةُ
u'ثَبَتَ وُضُوءٌ':Subject, #1: 1	ثَبَتَ وَضْعُ
u'ثَبَتَ وَطْءٌ':Subject, #1: 1	ثَبَتَ الْوُضُوءُ
u'ثَبَتَ وَفَاءٌ':Subject, #4: 4	ثَبَتَ الْوَطْءُ
u'ثَبَتَ وَقْفٌ':Subject, #1: 1	ثَبَتَ الْوَفَاءُ
u'ثَبَتَ وَقْف':Subject, #1: 1	ثَبَتَ وَقْفُهُ
u'ثَبَتَ وَقْفٌ':Subject, #1: 1	ثَبَتَ وَقْفِيَّةُ
u'ثَبَتَ وَقْفَة':Subject, #7: 7	ثَبَتَ الْوَقْفُ
u'ثَبَتَ وَقْفِيّ':Subject, #1: 1	ثَبَتَ وَقْفِيَّةُ
u'ثَبَتَ وَقْفِيَّة':Subject, #1: 1	ثَبَتَ وَقْفِيَّةُ
u'ثَبَتَ وُقُوعٌ':Subject, #1: 1	ثَبَتَ وَقْفِيَّةُ
u'ثَبَتَ وُقُوعٌ':Subject, #1: 1	ثَبَتَ وُقُوعُ
u'ثَبَتَ وَلاَءٌ':Subject, #1: 1	ثَبَتَ وُقُوعُهُ
u'ثَبَتَ وِلاَدَةٌ':Subject, #6: 6	ثَبَتَ الْوَلَاءُ
u'ثَبَتَ وِلاَيَةٌ':Subject, #1: 1	ثَبَتَ الْوِلَادَةُ
u'ثَبَتَ وِلاَيَةٌ':Subject, #1: 1	ثَبَتَ الْوِلَايَةُ
u'ثَبَتَ يُتْمٌ':Subject, #2: 2	ثَبَتَ وِلَايَةُ
u'ثَبَتَ يُتْمٌ':Subject, #1: 1	ثَبَتَ يُتْمُ
u'ثَبَتَ يَدٌ':Subject, #1: 1	ثَبَتَ يُتْمُهُ
u'ثَبَتَ يَدٌ':Subject, #1: 1	ثَبَتَ الْيَدُ
u'ثَبَتَ يسار':Subject, #1: 1	ثَبَتَ يَدُ
u'ثَبَتَ يَسَارٌ':Subject, #1: 1	ثَبَتَ الْيَسَارُ
u'ثَبَتَ يَمِينٌ':Subject, #1: 1	ثَبَتَ الْيَسَارُ
u'ثَبَتَ يَوْمٌ':Subject, #1: 1	ثَبَتَ الْيَمِينُ
u'ثُبُوتٌ إبَاحَةٌ':Added, #2: 2	ثَبَتَ يَوْمُ
u'ثُبُوتٌ إبَاحَةٌ':Added, #1: 1	ثُبُوتُ الْإِبَاحَةِ
u'ثُبُوتٌ أُبُوَّةٌ':Added, #2: 2	ثُبُوتِ الْإِبَاحَةِ
u'ثُبُوتٌ اِتِّصَافٌ':Added, #1: 1	ثُبُوتِ الْأُبُوَّةِ
u'ثُبُوتٌ أثَرٌ':Added, #1: 1	ثُبُوتِ اتِّصَافِ
u'ثُبُوتٌ إجَارَةٌ':Added, #2: 2	ثُبُوتُ الْأَثَرِ
u'ثُبُوتٌ أَجْرٌ':Added, #1: 1	ثُبُوتِ الْإِجَارَةِ
u'ثُبُوتٌ أَجْرٌ':Added, #1: 1	ثُبُوتَ الْأَجْرِ
u'ثُبُوتٌ أُجْرَةٌ':Added, #2: 2	ثُبُوتُ الْأَجْرِ
u'ثُبُوتٌ أَجْزَاءٌ':Added, #1: 1	ثُبُوتِ الْأُجْرَةِ
u'ثُبُوتٌ أَجْزَاءٌ':Added, #1: 1	ثُبُوتَ أَجْزَاءِ
u'ثُبُوتٌ أَجْزَاءٌ':Added, #1: 1	ثُبُوتُ أَجْزَاءِ
u'ثُبُوتٌ إِجْزَاءٌ':Added, #1: 1	ثُبُوتِ أَجْزَاءِ
u'ثُبُوتٌ أَجَلٌ':Added, #1: 1	ثُبُوتِ الْإِجْزَاءِ
u'ثُبُوتٌ إِجْمَاعٌ':Added, #1: 1	ثُبُوتِ الْأَجَلِ
u'ثُبُوتٌ إِجْمَاعٌ':Added, #1: 1	ثُبُوتُ الْإِجْمَاعِ
u'ثُبُوتٌ إِجْمَالٌ':Added, #4: 4	ثُبُوتِ الْإِجْمَاعِ
u'ثُبُوتٌ اِحْتِمَالٌ':Added, #1: 1	ثُبُوتِ الْإِجْمَالِ
u'ثُبُوتٌ أحَدٌ':Added, #1: 1	ثُبُوتَ احْتِمَالَيْنِ
u'ثُبُوتٌ أحَدٌ':Added, #1: 1	ثُبُوتُ أَحَدِ
u'ثُبُوتٌ أحَدٌ':Added, #1: 1	ثُبُوتِ أَحَدِ
u'ثُبُوتٌ أَحْكَامٌ':Added, #3: 3	ثُبُوتَ أَحَدِ
u'ثُبُوتٌ أَحْكَامٌ':Added, #1: 1	ثُبُوتُ أَحْكَامٍ
u'ثُبُوتٌ أَحْكَامٌ':Added, #1: 1	ثُبُوتُ الْأَحْكَامِ
u'ثُبُوتٌ أَحْكَامٌ':Added, #3: 3	ثُبُوتِ أَحْكَامِ
u'ثُبُوتٌ أَحْوالٌ':Added, #6: 6	ثُبُوتِ الْأَحْكَامِ
u'ثُبُوتٌ أحْوَالٌ':Added, #1: 1	ثُبُوتِ الْأَحْوَالِ
u'ثُبُوتٌ إِدْرَاكٌ':Added, #1: 1	ثُبُوتِ الْأَحْوَالِ
u'ثُبُوتٌ أَذَانٌ':Added, #1: 1	ثُبُوتَ الْإِدْرَاكَاتِ
u'ثُبُوتٌ إِذْنٌ':Added, #1: 1	ثُبُوتِ الْأَذَانِ
u'ثُبُوتٌ إِذْنٌ':Added, #1: 1	ثُبُوتَ الْإِذْنِ
u'ثُبُوتٌ أَرْبَعُ':Added, #2: 2	ثُبُوتِ الْإِذْنِ
u'ثُبُوتٌ إِرْثٌ':Added, #1: 1	ثُبُوتِ الْأَرْبَعِ
u'ثُبُوتٌ إِرْثٌ':Added, #2: 2	ثُبُوتُ الْإِرْثِ
u'ثُبُوتٌ أَرْكانٌ':Added, #4: 4	ثُبُوتِ الْإِرْثِ
u'ثُبُوتٌ أَرْكَانٌ':Added, #1: 1	ثُبُوتِ أَرْكَانِ
u'ثُبُوتٌ أَزْمِنَةٌ':Added, #1: 1	ثُبُوتِ أَرْكَانِ
u'ثُبُوتٌ إِسَاءةٌ':Added, #1: 1	ثُبُوتِ الْأَزْمِنَةِ
u'ثُبُوتٌ اِسْتِحْقَاقٌ':Added, #1: 1	ثُبُوتِ الْإِسَاءَةِ
u'ثُبُوتٌ اِسْتِحْقَاقٌ':Added, #1: 1	ثُبُوتَ اسْتِحْقَاقِ
u'ثُبُوتٌ اِسْتِخْلاَصٌ':Added, #1: 1	ثُبُوتِ اسْتِحْقَاقِهِ
u'ثُبُوتٌ اِسْتِعْمالٌ':Added, #1: 1	ثُبُوتُ اسْتِخْلَاصِ
u'ثُبُوتٌ اِسْتِقْلالٌ':Added, #1: 1	ثُبُوتُ اسْتِعْمَالِ
u'ثُبُوتٌ اِسْتِمْرارٌ':Added, #1: 1	ثُبُوتِ اسْتِقْلَالِهِ
u'ثُبُوتٌ اِسْتيفاءٌ':Added, #1: 1	ثُبُوتِ اسْتِمْرَارِ
u'ثُبُوتٌ اِسْتِيلاد':Added, #1: 1	ثُبُوتِ اسْتِيفَاءِ
u'ثُبُوتٌ اِسْتِيلاد':Added, #1: 1	ثُبُوتُ اسْتِيلَادِ
u'ثُبُوتٌ إِسْلامٌ':Added, #1: 1	ثُبُوتِ اسْتِيلَادِ
u'ثُبُوتٌ اِسْمٌ':Added, #2: 2	ثُبُوتِ إسْلَامِهِ
u'ثُبُوتٌ أَسْماءٌ':Added, #1: 1	ثُبُوتِ اسْمِ
u'ثُبُوتٌ أصل':Added, #1: 1	ثُبُوتِ الْأَسْمَاءِ
u'ثُبُوتٌ أصل':Added, #1: 1	ثُبُوتَ أَصْلِ
u'ثُبُوتٌ أًصْلٌ':Added, #1: 1	ثُبُوتُ أَصْلِ
u'ثُبُوتٌ أًصْلٌ':Added, #1: 1	ثُبُوتَ أَصْلِ
u'ثُبُوتٌ أصل':Added, #1: 1	ثُبُوتُ أَصْلِ
u'ثُبُوتٌ أصل':Added, #1: 1	ثُبُوتَ أَصْلِهِ
u'ثُبُوتٌ أًصْلٌ':Added, #1: 1	ثُبُوتِ أَصْلِهِ
u'ثُبُوتٌ أًصْلٌ':Added, #1: 1	ثُبُوتَ أَصْلِهِ
u'ثُبُوتٌ أصل':Added, #1: 1	ثُبُوتِ أَصْلِهِ
u'ثُبُوتٌ أًصْلٌ':Added, #1: 1	ثُبُوتُ الْأَصْلِ
u'ثُبُوتٌ أصل':Added, #1: 1	ثُبُوتُ الْأَصْلِ
u'ثُبُوتٌ أًصْلٌ':Added, #4: 4	ثُبُوتِ الْأَصْلِ
u'ثُبُوتٌ أصل':Added, #4: 4	ثُبُوتِ الْأَصْلِ
u'ثُبُوتٌ أًصْلٌ':Added, #7: 7	ثُبُوتِ أَصْلِ
u'ثُبُوتٌ إِعْتاقٌ':Added, #7: 7	ثُبُوتِ أَصْلِ
u'ثُبُوتٌ إِعْتاقٌ':Added, #1: 1	ثُبُوتِ إعْتَاقِهِ
u'ثُبُوتٌ اِعْتِبارٌ':Added, #1: 1	ثُبُوتِ الْإِعْتَاقِ
u'ثُبُوتٌ اِعْتِبارٌ':Added, #1: 1	ثُبُوتِ اعْتِبَارِهِ
u'ثُبُوتٌ أَعَمُّ':Added, #6: 6	ثُبُوتِ اعْتِبَارِ
u'ثُبُوتٌ إفَادَةٌ':Added, #1: 1	ثُبُوتِ الْأَعَمِّ
u'ثُبُوتٌ اِقْتِصاص':Added, #1: 1	ثُبُوتَ إفَادَةِ
u'ثُبُوتٌ إقْرَارٌ':Added, #1: 1	ثُبُوتِ اقْتِصَاصِ
u'ثُبُوتٌ إقْرَارٌ':Added, #1: 1	ثُبُوتِ الْإِقْرَارِ
u'ثُبُوتٌ إِلْزَامٌ':Added, #3: 3	ثُبُوتُ الْإِقْرَارِ
u'ثُبُوتٌ إِلْزَامٌ':Added, #1: 1	ثُبُوتَ الْإِلْزَامِ
u'ثُبُوتٌ ألف':Added, #1: 1	ثُبُوتُ الْإِلْزَامِ
u'ثُبُوتٌ ألف':Added, #1: 1	ثُبُوتَ الْأَلْفِ
u'ثُبُوتٌ ألف':Added, #1: 1	ثُبُوتُ الْأَلْفِ
u'ثُبُوتٌ ألْفٌ':Added, #1: 1	ثُبُوتِ الْأَلْفِ
u'ثُبُوتٌ ألْفٌ':Added, #1: 1	ثُبُوتَ الْأَلْفِ
u'ثُبُوتٌ ألْفٌ':Added, #1: 1	ثُبُوتُ الْأَلْفِ
u'ثُبُوتٌ أَلْفٌ':Added, #1: 1	ثُبُوتِ الْأَلْفِ
u'ثُبُوتٌ أَلْفٌ':Added, #1: 1	ثُبُوتَ الْأَلْفِ
u'ثُبُوتٌ أَلْفٌ':Added, #1: 1	ثُبُوتُ الْأَلْفِ
u'ثُبُوتٌ إمَامَةٌ':Added, #1: 1	ثُبُوتِ الْأَلْفِ
u'ثُبُوتٌ إمَامَةٌ':Added, #1: 1	ثُبُوتِ إمَامَةِ
u'ثُبُوتٌ إمَامَةٌ':Added, #1: 1	ثُبُوتِ إمَامَتِهِ
u'ثُبُوتٌ اِمْتِناعٌ':Added, #2: 2	ثُبُوتِ الْإِمَامَةِ
u'ثُبُوتٌ أَمْرٌ':Added, #1: 1	ثُبُوتِ امْتِنَاعِهِ
u'ثُبُوتٌ أَمْرٌ':Added, #1: 1	ثُبُوتُ أَمْرٍ
u'ثُبُوتٌ أَمْنٌ':Added, #1: 1	ثُبُوتِ أَمْرٍ
u'ثُبُوتٌ أُمومَةٌ':Added, #1: 1	ثُبُوتُ الْأَمْنِ
u'ثُبُوتٌ أُمومَةٌ':Added, #1: 1	ثُبُوتُ الْأُمُومَةِ
u'ثُبُوتٌ أُمومَةٌ':Added, #1: 1	ثُبُوتِ الْأُمُومَةِ
u'ثُبُوتٌ أُمِّيٌّ':Added, #1: 1	ثُبُوتِ أُمُومَةِ
u'ثُبُوتٌ أُمِّيٌّ':Added, #1: 1	ثُبُوتَ أُمِّيَّةِ
u'ثُبُوتٌ أُمِّيٌّ':Added, #1: 1	ثُبُوتُ أُمِّيَّةِ
u'ثُبُوتٌ أُمِّيَّةٌ':Added, #3: 3	ثُبُوتِ أُمِّيَّةِ
u'ثُبُوتٌ أُمِّيَّةٌ':Added, #1: 1	ثُبُوتَ أُمِّيَّةِ
u'ثُبُوتٌ أُمِّيَّةٌ':Added, #1: 1	ثُبُوتُ أُمِّيَّةِ
u'ثُبُوتٌ أَهْلِيٌّ':Added, #3: 3	ثُبُوتِ أُمِّيَّةِ
u'ثُبُوتٌ أَهْلِيٌّ':Added, #1: 1	ثُبُوتُ أَهْلِيَّةِ
u'ثُبُوتٌ أَهْلِيٌّ':Added, #1: 1	ثُبُوتِ أَهْلِيَّةِ
u'ثُبُوتٌ أَهْلِيٌّ':Added, #2: 2	ثُبُوتُ الْأَهْلِيَّةِ
u'ثُبُوتٌ أهْلِيَّةٌ':Added, #4: 4	ثُبُوتِ الْأَهْلِيَّةِ
u'ثُبُوتٌ أهْلِيَّةٌ':Added, #1: 1	ثُبُوتُ أَهْلِيَّةِ
u'ثُبُوتٌ أهْلِيَّةٌ':Added, #1: 1	ثُبُوتِ أَهْلِيَّةِ
u'ثُبُوتٌ أهْلِيَّةٌ':Added, #2: 2	ثُبُوتُ الْأَهْلِيَّةِ
u'ثُبُوتٌ أَوَّلُ':Added, #4: 4	ثُبُوتِ الْأَهْلِيَّةِ
u'ثُبُوتٌ أَوْلَوِيٌّ':Added, #1: 1	ثُبُوتُ الْأَوَّلَيْنِ
u'ثُبُوتٌ إِيجَابٌ':Added, #1: 1	ثُبُوتِ الْأَوْلَوِيَّةِ
u'ثُبُوتٌ إِيدَاعٌ':Added, #2: 2	ثُبُوتِ الْإِيجَابِ
u'ثُبُوتٌ إيمَانٌ':Added, #1: 1	ثُبُوتِ الْإِيدَاعِ
u'ثُبُوتٌ بَدَل':Added, #3: 3	ثُبُوتِ الْإِيمَانِ
u'ثُبُوتٌ بَدَلِيَّة':Added, #1: 1	ثُبُوتِ الْبَدَلِيَّةِ
u'ثُبُوتٌ بَعْضٌ':Added, #1: 1	ثُبُوتِ الْبَدَلِيَّةِ
u'ثُبُوتٌ بَعْضٌ':Added, #1: 1	ثُبُوتُ الْبَعْضِ
u'ثُبُوتٌ بَعْضٌ':Added, #1: 1	ثُبُوتُ بَعْضِ
u'ثُبُوتٌ بَقِيَّةٌ':Added, #1: 1	ثُبُوتِ بَعْضِ
u'ثُبُوتٌ بُلُوغٌ':Added, #1: 1	ثُبُوتُ بَقِيَّةِ
u'ثُبُوتٌ بِنْت':Added, #1: 1	ثُبُوتِ بُلُوغِهِ
u'ثُبُوتٌ بُنُوَّة':Added, #1: 1	ثُبُوتُ الْبِنْتِيَّةِ
u'ثُبُوتٌ بُنُوَّة':Added, #1: 1	ثُبُوتُ الْبُنُوَّةِ
u'ثُبُوتٌ بَيَانٌ':Added, #3: 3	ثُبُوتِ الْبُنُوَّةِ
u'ثُبُوتٌ بَيْعٌ':Added, #1: 1	ثُبُوتَ الْبَيَانِ
u'ثُبُوتٌ تَأْثِيرٌ':Added, #3: 3	ثُبُوتِ الْبَيْعِ
u'ثُبُوتٌ تَحَالُفٌ':Added, #2: 2	ثُبُوتُ تَأْثِيرِ
u'ثُبُوتٌ تَحْرِيرٌ':Added, #1: 1	ثُبُوتُ التَّحَالُفِ
u'ثُبُوتٌ تَحْرِيمٌ':Added, #1: 1	ثُبُوتَ التَّحْرِيرِ
u'ثُبُوتٌ تَحْرِيمٌ':Added, #1: 1	ثُبُوتُ التَّحْرِيمِ
u'ثُبُوتٌ تَحْرِيمٌ':Added, #2: 2	ثُبُوتُ تَحْرِيمِ
u'ثُبُوتٌ تَخْفِيفٌ':Added, #3: 3	ثُبُوتِ التَّحْرِيمِ
u'ثُبُوتٌ تَخْيِيرٌ':Added, #1: 1	ثُبُوتِ التَّخْفِيفِ
u'ثُبُوتٌ تَسْمِيَة':Added, #1: 1	ثُبُوتِ التَّخْيِيرِ
u'ثُبُوتٌ تَصْحِيحٌ':Added, #1: 1	ثُبُوتِ التَّسْمِيَةِ
u'ثُبُوتٌ تَعَادُلٌ':Added, #1: 1	ثُبُوتِ تَصْحِيحِهِ
u'ثُبُوتٌ تَعَدُّدٌ':Added, #1: 1	ثُبُوتِ تَعَادُلِ
u'ثُبُوتٌ تَعْزِير':Added, #1: 1	ثُبُوتِ التَّعَدُّدِ
u'ثُبُوتٌ تَعَلُّقٌ':Added, #1: 1	ثُبُوتِ التَّعْزِيرِ
u'ثُبُوتٌ تَعْلِيلٌ':Added, #1: 1	ثُبُوتِ التَّعَلُّقِ
u'ثُبُوتٌ تَغْرِير':Added, #1: 1	ثُبُوتِ تَعْلِيلِ
u'ثُبُوتٌ تَفْرِقَة':Added, #1: 1	ثُبُوتِ التَّغْرِيرِ
u'ثُبُوتٌ تَقْديرٌ':Added, #1: 1	ثُبُوتِ التَّفْرِقَةِ
u'ثُبُوتٌ تَقْيِيد':Added, #1: 1	ثُبُوتِ التَّقْدِيرِ
u'ثُبُوتٌ تَكْليفٌ':Added, #1: 1	ثُبُوتِ تَقْيِيدِ
u'ثُبُوتٌ تَلازُم':Added, #1: 1	ثُبُوتِ التَّكْلِيفِ
u'ثُبُوتٌ تَمْلِيك':Added, #3: 3	ثُبُوتُ التَّلَازُمِ
u'ثُبُوتٌ تَنْزِيه':Added, #1: 1	ثُبُوتِ التَّمْلِيكِ
u'ثُبُوتٌ تَنَفُّلٌ':Added, #1: 1	ثُبُوتَ التَّنْزِيهِيَّةِ
u'ثُبُوتٌ تَوَجُّهٌ':Added, #1: 1	ثُبُوتِ التَّنَفُّلِ
u'ثُبُوتٌ تَوْكِيلٌ':Added, #1: 1	ثُبُوتَ التَّوَجُّهِ
u'ثُبُوتٌ ثَالِثٌ':Added, #3: 3	ثُبُوتِ التَّوْكِيلِ
u'ثُبُوتٌ ثَلاثَةٌ':Added, #1: 1	ثُبُوتِ الثَّالِثِ
u'ثُبُوتٌ ثَلاثَةٌ':Added, #1: 1	ثُبُوتِ ثَلَاثَةِ
u'ثُبُوتٌ ثَمَنٌ':Added, #2: 2	ثُبُوتِ الثَّلَاثَةِ
u'ثُبُوتٌ ثَمَنٌ':Added, #1: 1	ثُبُوتَ الثَّمَنِ
u'ثُبُوتٌ ثَوابٌ':Added, #1: 1	ثُبُوتُ ثَمَنِ
u'ثُبُوتٌ ثِيابٌ':Added, #1: 1	ثُبُوتِ ثَوَابٍ
u'ثُبُوتٌ جَائِحٌ':Added, #1: 1	ثُبُوتِ الثِّيَابِ
u'ثُبُوتٌ جاَئِحَةٌ':Added, #1: 1	ثُبُوتَ الْجَائِحَةِ
u'ثُبُوتٌ جَزَاءٌ':Added, #1: 1	ثُبُوتَ الْجَائِحَةِ
u'ثُبُوتٌ جُمْلَةٌ':Added, #1: 1	ثُبُوتُ الْجَزَاءِ
u'ثُبُوتٌ جِنَايَةٌ':Added, #1: 1	ثُبُوتِ جُمْلَتِهِ
u'ثُبُوتٌ جِنْسٌ':Added, #1: 1	ثُبُوتُ الْجِنَايَةِ
u'ثُبُوتٌ جِنْسٌ':Added, #1: 1	ثُبُوتُ الْجِنْسِ
u'ثُبُوتٌ جِنْسٌ':Added, #1: 1	ثُبُوتِ الْجِنْسِ
u'ثُبُوتٌ جهر':Added, #3: 3	ثُبُوتِ جِنْسِهِ
u'ثُبُوتٌ جَهْرٌ':Added, #1: 1	ثُبُوتِ الْجَهْرِ
u'ثُبُوتٌ جَوَازٌ':Added, #1: 1	ثُبُوتِ الْجَهْرِ
u'ثُبُوتٌ جَوَازٌ':Added, #1: 1	ثُبُوتَ الْجَوَازِ
u'ثُبُوتٌ حاجَةٌ':Added, #1: 1	ثُبُوتُ جَوَازِ
u'ثُبُوتٌ حاجَةٌ':Added, #1: 1	ثُبُوتِ الْحَاجَةِ
u'ثُبُوتٌ حالٌ':Added, #1: 1	ثُبُوتِ حَاجَةٍ
u'ثُبُوتٌ حُجَّةٌ':Added, #2: 2	ثُبُوتِ الْحَالِ
u'ثُبُوتٌ حُجَّة':Added, #1: 1	ثُبُوتُ الْحُجَّةِ
u'ثُبُوتٌ حُجَّةٌ':Added, #1: 1	ثُبُوتِ الْحُجِّيَّةِ
u'ثُبُوتٌ حُجَّة':Added, #1: 1	ثُبُوتُ حُجَّةِ
u'ثُبُوتٌ حَجْرٌ':Added, #1: 1	ثُبُوتُ حُجِّيَّةِ
u'ثُبُوتٌ حُجِّيَّة':Added, #2: 2	ثُبُوتِ الْحَجْرِ
u'ثُبُوتٌ حُجِّيَّة':Added, #1: 1	ثُبُوتِ الْحُجِّيَّةِ
u'ثُبُوتٌ حَدٌّ':Added, #1: 1	ثُبُوتُ حُجِّيَّةِ
u'ثُبُوتٌ حَدٌّ':Added, #10: 10	ثُبُوتِ الْحَدِّ
u'ثُبُوتٌ حَدٌّ':Added, #1: 1	ثُبُوتَ الْحَدِّ
u'ثُبُوتٌ حَدٌّ':Added, #1: 1	ثُبُوتِ حَدِّ
u'ثُبُوتٌ حَدٌّ':Added, #1: 1	ثُبُوتُ حَدَّيْنِ
u'ثُبُوتٌ حَدَثٌ':Added, #2: 2	ثُبُوتُ الْحَدِّ
u'ثُبُوتٌ حُدوثٌ':Added, #1: 1	ثُبُوتَ الْحَدَثِ
u'ثُبُوتٌ حُدودٌ':Added, #1: 1	ثُبُوتِ الْحُدُوثِ
u'ثُبُوتٌ حَديثٌ':Added, #1: 1	ثُبُوتِ الْحُدُودِ
u'ثُبُوتٌ حَديثٌ':Added, #2: 2	ثُبُوتِ الْحَدِيثَيْنِ
u'ثُبُوتٌ حُرْمَةٌ':Added, #6: 6	ثُبُوتِ الْحَدِيثِ
u'ثُبُوتٌ حُرْمَةٌ':Added, #14: 14	ثُبُوتَ الْحُرْمَةِ
u'ثُبُوتٌ حُرْمَةٌ':Added, #1: 1	ثُبُوتَ حُرْمَةٍ
u'ثُبُوتٌ حُرْمَةٌ':Added, #27: 27	ثُبُوتِ الْحُرْمَةِ
u'ثُبُوتٌ حُرْمَةٌ':Added, #3: 3	ثُبُوتَ حُرْمَةِ
u'ثُبُوتٌ حُرْمَةٌ':Added, #4: 4	ثُبُوتُ حُرْمَةِ
u'ثُبُوتٌ حُرْمَةٌ':Added, #5: 5	ثُبُوتِ حُرْمَةِ
u'ثُبُوتٌ حُرِّيَّةٌ':Added, #9: 9	ثُبُوتُ الْحُرْمَةِ
u'ثُبُوتٌ حُرِّيَّةٌ':Added, #1: 1	ثُبُوتِ الْحُرِّيَّةِ
u'ثُبُوتٌ حُرِّيَّةٌ':Added, #1: 1	ثُبُوتَ حُرِّيَّةِ
u'ثُبُوتٌ حُرِّيَّةٌ':Added, #3: 3	ثُبُوتُ الْحُرِّيَّةِ
u'ثُبُوتٌ حُرِّيَّةٌ':Added, #3: 3	ثُبُوتِ حُرِّيَّةِ
u'ثُبُوتٌ حِسِّيٌّ':Added, #6: 6	ثُبُوتَ الْحُرِّيَّةِ
u'ثُبُوتٌ حَصْرٌ':Added, #1: 1	ثُبُوتَ الْحِسِّيِّ
u'ثُبُوتٌ حَضَانَةٌ':Added, #1: 1	ثُبُوتِ حَصْرِ
u'ثُبُوتٌ حَضَانَةٌ':Added, #1: 1	ثُبُوتِ الْحَضَانَةِ
u'ثُبُوتٌ حَظٌّ':Added, #2: 2	ثُبُوتُ الْحَضَانَةِ
u'ثُبُوتٌ حَفْرٌ':Added, #1: 1	ثُبُوتِ الْحَظِّ
u'ثُبُوتٌ حَقٌّ':Added, #1: 1	ثُبُوتُ الْحَفْرِ
u'ثُبُوتٌ حَقٌّ':Added, #14: 14	ثُبُوتُ حَقِّ
u'ثُبُوتٌ حَقٌّ':Added, #19: 19	ثُبُوتِ حَقِّ
u'ثُبُوتٌ حَقٌّ':Added, #1: 1	ثُبُوتَ حَقٍّ
u'ثُبُوتٌ حَقٌّ':Added, #1: 1	ثُبُوتَ حَقِّهِ
u'ثُبُوتٌ حَقٌّ':Added, #20: 20	ثُبُوتَ حَقِّ
u'ثُبُوتٌ حَقٌّ':Added, #2: 2	ثُبُوتِ حَقٍّ
u'ثُبُوتٌ حَقٌّ':Added, #39: 39	ثُبُوتِ الْحَقِّ
u'ثُبُوتٌ حَقٌّ':Added, #4: 4	ثُبُوتِ الْحَقَّيْنِ
u'ثُبُوتٌ حَقٌّ':Added, #7: 7	ثُبُوتُ الْحَقِّ
u'ثُبُوتٌ حَقٌّ':Added, #7: 7	ثُبُوتِ حَقِّهِ
u'ثُبُوتٌ حُقوقٌ':Added, #9: 9	ثُبُوتَ الْحَقِّ
u'ثُبُوتٌ حُقُوقٌ':Added, #1: 1	ثُبُوتِ الْحُقُوقِ
u'ثُبُوتٌ حَقِيقٌ':Added, #1: 1	ثُبُوتِ الْحُقُوقِ
u'ثُبُوتٌ حَقِيقٌ':Added, #1: 1	ثُبُوتَ الْحَقِيقَةِ
u'ثُبُوتٌ حَقِيقٌ':Added, #1: 1	ثُبُوتُ حَقِيقَةِ
u'ثُبُوتٌ حَقِيقَةٌ':Added, #1: 1	ثُبُوتِ حَقِيقَةِ
u'ثُبُوتٌ حَقِيقَةٌ':Added, #1: 1	ثُبُوتَ الْحَقِيقَةِ
u'ثُبُوتٌ حَقِيقَةٌ':Added, #1: 1	ثُبُوتُ حَقِيقَةِ
u'ثُبُوتٌ حَقِيقِيٌّ':Added, #1: 1	ثُبُوتِ حَقِيقَةِ
u'ثُبُوتٌ حِكَايَةٌ':Added, #1: 1	ثُبُوتِ الْحَقِيقِيِّ
u'ثُبُوتٌ حُكْمٌ':Added, #1: 1	ثُبُوتِ الْحِكَايَةِ
u'ثُبُوتٌ حُكْمٌ':Added, #1: 1	ثُبُوتٍ حُكْمٍ
u'ثُبُوتٌ حُكْمٌ':Added, #24: 24	ثُبُوتِ حُكْمِ
u'ثُبُوتٌ حُكْمٌ':Added, #2: 2	ثُبُوتَ حُكْمِهِ
u'ثُبُوتٌ حُكْمٌ':Added, #34: 34	ثُبُوتَ الْحُكْمِ
u'ثُبُوتٌ حُكْمٌ':Added, #38: 38	ثُبُوتُ الْحُكْمِ
u'ثُبُوتٌ حُكْمٌ':Added, #3: 3	ثُبُوتِ حُكْمٍ
u'ثُبُوتٌ حُكْمٌ':Added, #4: 4	ثُبُوتُ حُكْمِهِ
u'ثُبُوتٌ حُكْمٌ':Added, #69: 69	ثُبُوتِ الْحُكْمِ
u'ثُبُوتٌ حُكْمٌ':Added, #6: 6	ثُبُوتُ حُكْمِ
u'ثُبُوتٌ حُكْمٌ':Added, #7: 7	ثُبُوتَ حُكْمِ
u'ثُبُوتٌ حِلٌّ':Added, #9: 9	ثُبُوتِ حُكْمِهِ
u'ثُبُوتٌ حِلٌّ':Added, #1: 1	ثُبُوتِ الْحِلِّ
u'ثُبُوتٌ حِلٌّ':Added, #1: 1	ثُبُوتِ حِلِّ
u'ثُبُوتٌ حِلٌّ':Added, #2: 2	ثُبُوتَ الْحِلِّ
u'ثُبُوتٌ حَمْلٌ':Added, #3: 3	ثُبُوتُ الْحِلِّ
u'ثُبُوتٌ حَوَالَةٌ':Added, #1: 1	ثُبُوتِ الْحَمْلِ
u'ثُبُوتٌ حِيازَة':Added, #1: 1	ثُبُوتُ الْحَوَالَةِ
u'ثُبُوتٌ حَيْضٌ':Added, #1: 1	ثُبُوتُ الْحِيَازَةِ
u'ثُبُوتٌ حَيْضٌ':Added, #1: 1	ثُبُوتِ الْحَيْضِ
u'ثُبُوتٌ خَبَرٌ':Added, #1: 1	ثُبُوتُ حَيْضِ
u'ثُبُوتٌ خَبَر':Added, #1: 1	ثُبُوتُ الْخَبَرِ
u'ثُبُوتٌ خَبَرٌ':Added, #1: 1	ثُبُوتُ الْخَبَرِ
u'ثُبُوتٌ خَبَر':Added, #1: 1	ثُبُوتِ خَبَرِ
u'ثُبُوتٌ خَبَرٌ':Added, #1: 1	ثُبُوتِ خَبَرِ
u'ثُبُوتٌ خَبَر':Added, #5: 5	ثُبُوتِ الْخَبَرِ
u'ثُبُوتٌ خَرَابٌ':Added, #5: 5	ثُبُوتِ الْخَبَرِ
u'ثُبُوتٌ خراج':Added, #1: 1	ثُبُوتِ خَرَابِ
u'ثُبُوتٌ خَرَاجٌ':Added, #1: 1	ثُبُوتَ الْخَرَاجِ
u'ثُبُوتٌ خَطٌّ':Added, #1: 1	ثُبُوتَ الْخَرَاجِ
u'ثُبُوتٌ خِطَابٌ':Added, #1: 1	ثُبُوتُ الْخَطِّ
u'ثُبُوتٌ خِطَابٌ':Added, #1: 1	ثُبُوتِ الْخِطَابِ
u'ثُبُوتٌ خِلاَفٌ':Added, #1: 1	ثُبُوتِ خِطَابِ
u'ثُبُوتٌ خِلاَفٌ':Added, #2: 2	ثُبُوتُ الْخِلَافِ
u'ثُبُوتٌ خِلاَفٌ':Added, #2: 2	ثُبُوتِ الْخِلَافِ
u'ثُبُوتٌ خَلْفٌ':Added, #6: 6	ثُبُوتَ الْخِلَافِ
u'ثُبُوتٌ خَلْفِيٌّ':Added, #1: 1	ثُبُوتُ خَلْفِهِ
u'ثُبُوتٌ خَلَلٌ':Added, #1: 1	ثُبُوتِ الْخَلْفِيَّةِ
u'ثُبُوتٌ خَمْرِيٌّ':Added, #1: 1	ثُبُوتِ خَلَلٍ
u'ثُبُوتٌ خيار':Added, #1: 1	ثُبُوتَ الْخَمْرِيَّةِ
u'ثُبُوتٌ خِيَارٌ':Added, #10: 10	ثُبُوتِ خِيَارِ
u'ثُبُوتٌ خِيَارٌ':Added, #10: 10	ثُبُوتِ خِيَارِ
u'ثُبُوتٌ خيار':Added, #1: 1	ثُبُوتِ الْخِيَارَيْنِ
u'ثُبُوتٌ خِيَارٌ':Added, #1: 1	ثُبُوتَ خِيَارِ
u'ثُبُوتٌ خيار':Added, #1: 1	ثُبُوتَ خِيَارِ
u'ثُبُوتٌ خِيَارٌ':Added, #27: 27	ثُبُوتَ الْخِيَارِ
u'ثُبُوتٌ خيار':Added, #27: 27	ثُبُوتَ الْخِيَارِ
u'ثُبُوتٌ خِيَارٌ':Added, #34: 34	ثُبُوتُ الْخِيَارِ
u'ثُبُوتٌ خيار':Added, #34: 34	ثُبُوتُ الْخِيَارِ
u'ثُبُوتٌ خِيَارٌ':Added, #3: 3	ثُبُوتُ خِيَارِ
u'ثُبُوتٌ خيار':Added, #3: 3	ثُبُوتُ خِيَارِ
u'ثُبُوتٌ خِيَارٌ':Added, #50: 50	ثُبُوتِ الْخِيَارِ
u'ثُبُوتٌ خِيرَةٌ':Added, #50: 50	ثُبُوتِ الْخِيَارِ
u'ثُبُوتٌ دَلالَةٌ':Added, #1: 1	ثُبُوتُ الْخِيرَةِ
u'ثُبُوتٌ دَلالَةٌ':Added, #1: 1	ثُبُوتِ الدَّلَالَةِ
u'ثُبُوتٌ دَليلٌ':Added, #3: 3	ثُبُوتِ دَلَالَةِ
u'ثُبُوتٌ دَليلٌ':Added, #1: 1	ثُبُوتِ الدَّلِيلِ
u'ثُبُوتٌ دَمٌ':Added, #1: 1	ثُبُوتَ دَلِيلِ
u'ثُبُوتٌ دِيَةٌ':Added, #1: 1	ثُبُوتِ الدَّمِ
u'ثُبُوتٌ دَيْنٌ':Added, #2: 2	ثُبُوتُ الدِّيَةِ
u'ثُبُوتٌ دَيْنٌ':Added, #11: 11	ثُبُوتِ الدَّيْنِ
u'ثُبُوتٌ دِينٌ':Added, #1: 1	ثُبُوتَ الدَّيْنِ
u'ثُبُوتٌ دَيْنٌ':Added, #1: 1	ثُبُوتَ دِينَيْنِ
u'ثُبُوتٌ دَيْنٌ':Added, #2: 2	ثُبُوتِ دَيْنٍ
u'ثُبُوتٌ ذَمٌّ':Added, #3: 3	ثُبُوتُ الدَّيْنِ
u'ثُبُوتٌ ذِمَّةٌ':Added, #1: 1	ثُبُوتِ الذَّمِّ
u'ثُبُوتٌ رَاجِحٌ':Added, #2: 2	ثُبُوتُ الذِّمَّةِ
u'ثُبُوتٌ رجعة':Added, #1: 1	ثُبُوتَ الرَّاجِحِ
u'ثُبُوتٌ رَجْعَةٌ':Added, #1: 1	ثُبُوتَ الرَّجْعَةِ
u'ثُبُوتٌ رجعة':Added, #1: 1	ثُبُوتَ الرَّجْعَةِ
u'ثُبُوتٌ رَجْعَةٌ':Added, #4: 4	ثُبُوتُ الرَّجْعَةِ
u'ثُبُوتٌ رجعة':Added, #4: 4	ثُبُوتُ الرَّجْعَةِ
u'ثُبُوتٌ رَجْعَةٌ':Added, #6: 6	ثُبُوتِ الرَّجْعَةِ
u'ثُبُوتٌ رَجْعِيٌّ':Added, #6: 6	ثُبُوتِ الرَّجْعَةِ
u'ثُبُوتٌ رَجْمٌ':Added, #1: 1	ثُبُوتُ الرَّجْعِيِّ
u'ثُبُوتٌ رُجُوعٌ':Added, #1: 1	ثُبُوتَ الرَّجْمِ
u'ثُبُوتٌ رُجُوعٌ':Added, #1: 1	ثُبُوتَ الرُّجُوعِ
u'ثُبُوتٌ رُجُوعٌ':Added, #1: 1	ثُبُوتُ الرُّجُوعِ
u'ثُبُوتٌ رُخَصٌ':Added, #1: 1	ثُبُوتِ الرُّجُوعِ
u'ثُبُوتٌ رُخَصٌ':Added, #1: 1	ثُبُوتِ الرُّخَصِ
u'ثُبُوتٌ رَدٌّ':Added, #1: 1	ثُبُوتُ رُخَصِهِ
u'ثُبُوتٌ رَدٌّ':Added, #1: 1	ثُبُوتُ رَدٍّ
u'ثُبُوتٌ رَدٌّ':Added, #1: 1	ثُبُوتِ رَدِّ
u'ثُبُوتٌ رَدٌّ':Added, #2: 2	ثُبُوتَ الرَّدِّ
u'ثُبُوتٌ رِدَّةٌ':Added, #4: 4	ثُبُوتِ الرَّدِّ
u'ثُبُوتٌ رُشْدٌ':Added, #1: 1	ثُبُوتُ الرِّدَّةِ
u'ثُبُوتٌ رضاع':Added, #1: 1	ثُبُوتِ رُشْدِهِ
u'ثُبُوتٌ رَفْعٌ':Added, #1: 1	ثُبُوتِ الرَّضَاعِ
u'ثُبُوتٌ رِقٌّ':Added, #1: 1	ثُبُوتِ رَفْعِ
u'ثُبُوتٌ رِقٌّ':Added, #1: 1	ثُبُوتُ الرِّقِّ
u'ثُبُوتٌ رِقٌّ':Added, #1: 1	ثُبُوتِ رِقِّهِ
u'ثُبُوتٌ رَمَضانِيّ':Added, #3: 3	ثُبُوتِ الرِّقِّ
u'ثُبُوتٌ رَهْن':Added, #1: 1	ثُبُوتِ الرَّمَضَانِيَّةِ
u'ثُبُوتٌ رَهْنِيَّة':Added, #1: 1	ثُبُوتِ الرَّهْنِيَّةِ
u'ثُبُوتٌ رَهينٌ':Added, #1: 1	ثُبُوتِ الرَّهْنِيَّةِ
u'ثُبُوتٌ رَهينَةٌ':Added, #1: 1	ثُبُوتِ الرَّهِينَةِ
u'ثُبُوتٌ رِوايَةٌ':Added, #1: 1	ثُبُوتِ الرَّهِينَةِ
u'ثُبُوتٌ رِوايَةٌ':Added, #1: 1	ثُبُوتُ رِوَايَةِ
u'ثُبُوتٌ رُؤْيَةٌ':Added, #2: 2	ثُبُوتِ الرِّوَايَةِ
u'ثُبُوتٌ رُؤْيَةٌ':Added, #1: 1	ثُبُوتِ الرُّؤْيَةِ
u'ثُبُوتٌ رُؤْيَةٌ':Added, #1: 1	ثُبُوتِ رُؤْيَةِ
u'ثُبُوتٌ زَوالٌ':Added, #2: 2	ثُبُوتِ رُؤْيَتِهِ
u'ثُبُوتٌ زَوْجِيٌّ':Added, #1: 1	ثُبُوتُ زَوَالِ
u'ثُبُوتٌ زِيادَةٌ':Added, #1: 1	ثُبُوتِ الزَّوْجِيَّةِ
u'ثُبُوتٌ زِيادَةٌ':Added, #1: 1	ثُبُوتُ زِيَادَةِ
u'ثُبُوتٌ زِيادَةٌ':Added, #3: 3	ثُبُوتَ الزِّيَادَةِ
u'ثُبُوتٌ سَبَبٌ':Added, #3: 3	ثُبُوتِ الزِّيَادَةِ
u'ثُبُوتٌ سَبَبٌ':Added, #1: 1	ثُبُوتَ السَّبَبِ
u'ثُبُوتٌ سَبَبٌ':Added, #1: 1	ثُبُوتَ سَبَبِ
u'ثُبُوتٌ سَبَبٌ':Added, #1: 1	ثُبُوتَ سَبَبِهِ
u'ثُبُوتٌ سَبَبٌ':Added, #3: 3	ثُبُوتِ سَبَبِهِ
u'ثُبُوتٌ سَبَبٌ':Added, #4: 4	ثُبُوتِ سَبَبِ
u'ثُبُوتٌ سَبَبِيَّةٌ':Added, #6: 6	ثُبُوتِ السَّبَبِ
u'ثُبُوتٌ سَرقَةٌ':Added, #2: 2	ثُبُوتِ السَّبَبِيَّةِ
u'ثُبُوتٌ سَرِقَةٌ':Added, #1: 1	ثُبُوتُ السَّرِقَةِ
u'ثُبُوتٌ سَرقَةٌ':Added, #1: 1	ثُبُوتُ السَّرِقَةِ
u'ثُبُوتٌ سَرِقَةٌ':Added, #2: 2	ثُبُوتِ السَّرِقَةِ
u'ثُبُوتٌ سَرقَةٌ':Added, #2: 2	ثُبُوتِ السَّرِقَةِ
u'ثُبُوتٌ سَرِقَةٌ':Added, #3: 3	ثُبُوتَ السَّرِقَةِ
u'ثُبُوتٌ سُلْطَةٌ':Added, #3: 3	ثُبُوتَ السَّرِقَةِ
u'ثُبُوتٌ سَمَاعٌ':Added, #1: 1	ثُبُوتُ سُلْطَتِهِ
u'ثُبُوتٌ سَمَاعٌ':Added, #1: 1	ثُبُوتِ السَّمَاعِ
u'ثُبُوتٌ سَمَاعٌ':Added, #1: 1	ثُبُوتِ سَمَاعِ
u'ثُبُوتٌ سُنَّةٌ':Added, #1: 1	ثُبُوتُ سَمَاعِهِ
u'ثُبُوتٌ سُنَّةٌ':Added, #1: 1	ثُبُوتِ السُّنَّةِ
u'ثُبُوتٌ شرب':Added, #1: 1	ثُبُوتِ سُنَّةِ
u'ثُبُوتٌ شُرْبٌ':Added, #1: 1	ثُبُوتُ شُرْبِهِ
u'ثُبُوتٌ شَرْطٌ':Added, #1: 1	ثُبُوتُ شُرْبِهِ
u'ثُبُوتٌ شَرْعٌ':Added, #3: 3	ثُبُوتِ الشَّرْطِ
u'ثُبُوتٌ شَرْعِيٌّ':Added, #4: 4	ثُبُوتِ الشَّرْعِ
u'ثُبُوتٌ شركة':Added, #1: 1	ثُبُوتِ شَرْعِيَّتِهِ
u'ثُبُوتٌ شَرِكَةٌ':Added, #5: 5	ثُبُوتِ الشَّرِكَةِ
u'ثُبُوتٌ شُرُوطٌ':Added, #5: 5	ثُبُوتِ الشَّرِكَةِ
u'ثُبُوتٌ شفعة':Added, #1: 1	ثُبُوتِ شُرُوطِهِ
u'ثُبُوتٌ شُفْعَةٌ':Added, #11: 11	ثُبُوتِ الشُّفْعَةِ
u'ثُبُوتٌ شفعة':Added, #11: 11	ثُبُوتِ الشُّفْعَةِ
u'ثُبُوتٌ شُفْعَةٌ':Added, #12: 12	ثُبُوتُ الشُّفْعَةِ
u'ثُبُوتٌ شفعة':Added, #12: 12	ثُبُوتُ الشُّفْعَةِ
u'ثُبُوتٌ شفعة':Added, #1: 1	ثُبُوتِ الشَّفْعَةِ
u'ثُبُوتٌ شُفْعَةٌ':Added, #5: 5	ثُبُوتَ الشُّفْعَةِ
u'ثُبُوتٌ شَهَادَةٌ':Added, #5: 5	ثُبُوتَ الشُّفْعَةِ
u'ثُبُوتٌ شَهَادَةٌ':Added, #1: 1	ثُبُوتُ شَهَادَةٍ
u'ثُبُوتٌ شَهْرٌ':Added, #4: 4	ثُبُوتِ الشَّهَادَةِ
u'ثُبُوتٌ شَوَّالٌ':Added, #4: 4	ثُبُوتِ الشَّهْرِ
u'ثُبُوتٌ شَيْءٌ':Added, #1: 1	ثُبُوتِ شَوَّالٍ
u'ثُبُوتٌ شَيْءٌ':Added, #1: 1	ثُبُوتُ شَيْءٍ
u'ثُبُوتٌ شَيْءٌ':Added, #2: 2	ثُبُوتَ الشَّيْءِ
u'ثُبُوتٌ شَيْءٌ':Added, #2: 2	ثُبُوتُ الشَّيْءِ
u'ثُبُوتٌ شَيْءٌ':Added, #3: 3	ثُبُوتِ الشَّيْءِ
u'ثُبُوتٌ صحبة':Added, #5: 5	ثُبُوتِ شَيْءٍ
u'ثُبُوتٌ صُحْبَةٌ':Added, #1: 1	ثُبُوتِ الصُّحْبَةِ
u'ثُبُوتٌ صِحَّةٌ':Added, #1: 1	ثُبُوتِ الصُّحْبَةِ
u'ثُبُوتٌ صِحَّةٌ':Added, #1: 1	ثُبُوتِ صِحَّةِ
u'ثُبُوتٌ صِحَّةٌ':Added, #2: 2	ثُبُوتُ الصِّحَّةِ
u'ثُبُوتٌ صداق':Added, #2: 2	ثُبُوتَ صِحَّةِ
u'ثُبُوتٌ صَدَاقٌ':Added, #1: 1	ثُبُوتِ الصَّدَاقِ
u'ثُبُوتٌ صدق':Added, #1: 1	ثُبُوتِ الصَّدَاقِ
u'ثُبُوتٌ صِدْقٌ':Added, #1: 1	ثُبُوتِ الصِّدْقِ
u'ثُبُوتٌ صدق':Added, #1: 1	ثُبُوتِ الصِّدْقِ
u'ثُبُوتٌ صِدْقٌ':Added, #1: 1	ثُبُوتِ صِدْقِ
u'ثُبُوتٌ صُدُورٌ':Added, #1: 1	ثُبُوتِ صِدْقِ
u'ثُبُوتٌ صَغِيرٌ':Added, #1: 1	ثُبُوتُ صُدُورِ
u'ثُبُوتٌ صِفَةٌ':Added, #1: 1	ثُبُوتِ الصَّغِيرَةِ
u'ثُبُوتٌ صِفَةٌ':Added, #1: 1	ثُبُوتِ الصِّفَةِ
u'ثُبُوتٌ صِفَةٌ':Added, #2: 2	ثُبُوتِ الصِّفَاتِ
u'ثُبُوتٌ صِفَةٌ':Added, #2: 2	ثُبُوتَ صِفَةِ
u'ثُبُوتٌ صَلاَةٌ':Added, #4: 4	ثُبُوتِ صِفَةِ
u'ثُبُوتٌ صَوْمٌ':Added, #1: 1	ثُبُوتِ صَلاَةِ
u'ثُبُوتٌ صَوْمٌ':Added, #1: 1	ثُبُوتَ الصَّوْمِ
u'ثُبُوتٌ صِيَامٌ':Added, #1: 1	ثُبُوتِ الصَّوْمِ
u'ثُبُوتٌ صِيغَةٌ':Added, #1: 1	ثُبُوتَ الصِّيَامِ
u'ثُبُوتٌ ضِدٌّ':Added, #1: 1	ثُبُوتِ صِيغَةِ
u'ثُبُوتٌ ضِدٌّ':Added, #1: 1	ثُبُوتِ الضِّدَّيْنِ
u'ثُبُوتٌ ضَرْبٌ':Added, #3: 3	ثُبُوتِ ضِدِّ
u'ثُبُوتٌ طَاعَةٌ':Added, #2: 2	ثُبُوتِ الضَّرْبِ
u'ثُبُوتٌ طعام':Added, #1: 1	ثُبُوتُ الطَّاعَةِ
u'ثُبُوتٌ طَعَامٌ':Added, #1: 1	ثُبُوتُ الطَّعَامِ
u'ثُبُوتٌ طَعْنٌ':Added, #1: 1	ثُبُوتُ الطَّعَامِ
u'ثُبُوتٌ طَلاَقٌ':Added, #1: 1	ثُبُوتُ الطَّعْنِ
u'ثُبُوتٌ طَلاَقٌ':Added, #1: 1	ثُبُوتَ طَلَاقٍ
u'ثُبُوتٌ طَلاَقٌ':Added, #1: 1	ثُبُوتِ طَلَاقِهِ
u'ثُبُوتٌ طلب':Added, #2: 2	ثُبُوتِ الطَّلَاقِ
u'ثُبُوتٌ طَلَبٌ':Added, #1: 1	ثُبُوتَ طَلَبِ
u'ثُبُوتٌ طَهَارَةٌ':Added, #1: 1	ثُبُوتَ طَلَبِ
u'ثُبُوتٌ طَوْعٌ':Added, #1: 1	ثُبُوتِ الطَّهَارَةِ
u'ثُبُوتٌ ظَنٌّ':Added, #1: 1	ثُبُوتِ الطَّوْعِ
u'ثُبُوتٌ ظُهورٌ':Added, #1: 1	ثُبُوتَ ظَنِّ
u'ثُبُوتٌ عَادَةٌ':Added, #1: 1	ثُبُوتُ الظُّهُورِ
u'ثُبُوتٌ عَادَةٌ':Added, #1: 1	ثُبُوتِ عَادَةِ
u'ثُبُوتٌ عَادَةٌ':Added, #2: 2	ثُبُوتُ الْعَادَةِ
u'ثُبُوتٌ عتق':Added, #7: 7	ثُبُوتِ الْعَادَةِ
u'ثُبُوتٌ عِتْقٌ':Added, #14: 14	ثُبُوتِ الْعِتْقِ
u'ثُبُوتٌ عتق':Added, #14: 14	ثُبُوتِ الْعِتْقِ
u'ثُبُوتٌ عِتْقٌ':Added, #1: 1	ثُبُوتُ الْعِتْقِ
u'ثُبُوتٌ عتق':Added, #1: 1	ثُبُوتُ الْعِتْقِ
u'ثُبُوتٌ عِتْقٌ':Added, #6: 6	ثُبُوتَ الْعِتْقِ
u'ثُبُوتٌ عَدَالَةٌ':Added, #6: 6	ثُبُوتَ الْعِتْقِ
u'ثُبُوتٌ عَدَالَةٌ':Added, #1: 1	ثُبُوتَ الْعَدَالَةِ
u'ثُبُوتٌ عَدَالَةٌ':Added, #1: 1	ثُبُوتُ عَدَالَةِ
u'ثُبُوتٌ عَدَالَةٌ':Added, #1: 1	ثُبُوتِ عَدَالَةِ
u'ثُبُوتٌ عَدَالَةٌ':Added, #4: 4	ثُبُوتِ عَدَالَتِهِ
u'ثُبُوتٌ عِدَّةٌ':Added, #7: 7	ثُبُوتِ الْعَدَالَةِ
u'ثُبُوتٌ عَدَمٌ':Added, #2: 2	ثُبُوتِ الْعِدَّةِ
u'ثُبُوتٌ عُذْرٌ':Added, #1: 1	ثُبُوتَ عَدَمِ
u'ثُبُوتٌ عُذْرٌ':Added, #1: 1	ثُبُوتَ الْعُذْرِ
u'ثُبُوتٌ عِصْمَةٌ':Added, #2: 2	ثُبُوتِ الْعُذْرِ
u'ثُبُوتٌ عِصْمَةٌ':Added, #1: 1	ثُبُوتُ الْعِصْمَةِ
u'ثُبُوتٌ عَقْدٌ':Added, #2: 2	ثُبُوتِ الْعِصْمَةِ
u'ثُبُوتٌ عَقْدٌ':Added, #1: 1	ثُبُوتُ الْعَقْدِ
u'ثُبُوتٌ عَقْلٌ':Added, #2: 2	ثُبُوتَ الْعَقْدِ
u'ثُبُوتٌ عِلاَقَةٌ':Added, #1: 1	ثُبُوتُ الْعَقْلِ
u'ثُبُوتٌ عِلَّةٌ':Added, #1: 1	ثُبُوتُ عِلَاقَةٍ
u'ثُبُوتٌ عِلَّةٌ':Added, #1: 1	ثُبُوتِ الْعِلَّةِ
u'ثُبُوتٌ عِلَّةٌ':Added, #1: 1	ثُبُوتِ عِلَّتِهِ
u'ثُبُوتٌ عِلَّةٌ':Added, #2: 2	ثُبُوتَ الْعِلَّةِ
u'ثُبُوتٌ علم':Added, #4: 4	ثُبُوتُ الْعِلَّةِ
u'ثُبُوتٌ علم':Added, #1: 1	ثُبُوتُ الْعِلْمِ
u'ثُبُوتٌ عِلْمٌ':Added, #1: 1	ثُبُوتِ الْعِلْمِ
u'ثُبُوتٌ عِلْمٌ':Added, #1: 1	ثُبُوتُ الْعِلْمِ
u'ثُبُوتٌ عَلِيٌّ':Added, #1: 1	ثُبُوتِ الْعِلْمِ
u'ثُبُوتٌ عِلِّيٌّ':Added, #1: 1	ثُبُوتِ الْعَلِيَّةِ
u'ثُبُوتٌ عِلِّيٌّ':Added, #1: 1	ثُبُوتُ الْعِلِّيَّةِ
u'ثُبُوتٌ عِلِّيٌّ':Added, #1: 1	ثُبُوتَ عِلِّيَّةِ
u'ثُبُوتٌ عِلِّيٌّ':Added, #1: 1	ثُبُوتُ عِلِّيَّةِ
u'ثُبُوتٌ عَمَلٌ':Added, #3: 3	ثُبُوتِ الْعِلِّيَّةِ
u'ثُبُوتٌ عَمَلٌ':Added, #1: 1	ثُبُوتِ الْعَمَلِ
u'ثُبُوتٌ عُمُومٌ':Added, #1: 1	ثُبُوتِ عَمَلٍ
u'ثُبُوتٌ عُمُومٌ':Added, #1: 1	ثُبُوتِ عُمُومِهِ
u'ثُبُوتٌ عُنَّة':Added, #3: 3	ثُبُوتِ الْعُمُومِ
u'ثُبُوتٌ عِوَضٌ':Added, #1: 1	ثُبُوتِ الْعُنَّةِ
u'ثُبُوتٌ عِوَضٌ':Added, #1: 1	ثُبُوتَ الْعِوَضِ
u'ثُبُوتٌ عِوَضٌ':Added, #1: 1	ثُبُوتِ الْعِوَضِ
u'ثُبُوتٌ عِوَضٌ':Added, #1: 1	ثُبُوتَ الْعِوَضَيْنِ
u'ثُبُوتٌ عَيْبٌ':Added, #1: 1	ثُبُوتِ عِوَضٍ
u'ثُبُوتٌ عَيْبٌ':Added, #2: 2	ثُبُوتُ الْعَيْبِ
u'ثُبُوتٌ عين':Added, #2: 2	ثُبُوتِ الْعَيْبِ
u'ثُبُوتٌ عَيْنٌ':Added, #1: 1	ثُبُوتِ الْعَيْنِ
u'ثُبُوتٌ عَيْن':Added, #1: 1	ثُبُوتِ الْعَيْنِ
u'ثُبُوتٌ عين':Added, #1: 1	ثُبُوتِ الْعَيْنِ
u'ثُبُوتٌ عَيْنٌ':Added, #1: 1	ثُبُوتِ عَيْنِهِ
u'ثُبُوتٌ عَيْن':Added, #1: 1	ثُبُوتِ عَيْنِهِ
u'ثُبُوتٌ غير':Added, #1: 1	ثُبُوتِ عَيْنِهِ
u'ثُبُوتٌ غَيْرٌ':Added, #1: 1	ثُبُوتِ غَيْرِ
u'ثُبُوتٌ غير':Added, #1: 1	ثُبُوتِ غَيْرِ
u'ثُبُوتٌ غَيْرٌ':Added, #1: 1	ثُبُوتِ غَيْرِهِ
u'ثُبُوتٌ فِرَاشٌ':Added, #1: 1	ثُبُوتِ غَيْرِهِ
u'ثُبُوتٌ فرد':Added, #2: 2	ثُبُوتِ الْفِرَاشِ
u'ثُبُوتٌ فَرْدٌ':Added, #1: 1	ثُبُوتُ الْفَرْدِ
u'ثُبُوتٌ فَرْضٌ':Added, #1: 1	ثُبُوتُ الْفَرْدِ
u'ثُبُوتٌ فَرْعٌ':Added, #1: 1	ثُبُوتَ فَرْضٍ
u'ثُبُوتٌ فَرْعٌ':Added, #1: 1	ثُبُوتُ فَرْعِهِ
u'ثُبُوتٌ فرق':Added, #2: 2	ثُبُوتِ الْفَرْعِ
u'ثُبُوتٌ فَرْقٌ':Added, #1: 1	ثُبُوتَ الْفَرْقِ
u'ثُبُوتٌ فساد':Added, #1: 1	ثُبُوتَ الْفَرْقِ
u'ثُبُوتٌ فَسَادٌ':Added, #1: 1	ثُبُوتُ الْفَسَادِ
u'ثُبُوتٌ فَسْخٌ':Added, #1: 1	ثُبُوتُ الْفَسَادِ
u'ثُبُوتٌ فَسْخٌ':Added, #1: 1	ثُبُوتُ الْفَسْخِ
u'ثُبُوتٌ فَسْخٌ':Added, #2: 2	ثُبُوتَ الْفَسْخِ
u'ثُبُوتٌ فِطْرٌ':Added, #3: 3	ثُبُوتِ الْفَسْخِ
u'ثُبُوتٌ فِعْلٌ':Added, #1: 1	ثُبُوتَ الْفِطْرِ
u'ثُبُوتٌ فِعْلٌ':Added, #1: 1	ثُبُوتُ الْفِعْلِ
u'ثُبُوتٌ فلان':Added, #1: 1	ثُبُوتِ فِعْلِهِ
u'ثُبُوتٌ قُبْحٌ':Added, #1: 1	ثُبُوتِ الرَّمَضَانِيَّةِ
u'ثُبُوتٌ قَبْضٌ':Added, #1: 1	ثُبُوتُ الْقُبْحِ
u'ثُبُوتٌ قَبُولٌ':Added, #1: 1	ثُبُوتُ قَبْضِهِ
u'ثُبُوتٌ قتل':Added, #1: 1	ثُبُوتُ الْقَبُولِ
u'ثُبُوتٌ قتل':Added, #1: 1	ثُبُوتَ الْقَتْلِ
u'ثُبُوتٌ قَتْلٌ':Added, #1: 1	ثُبُوتُ الْقَتْلِ
u'ثُبُوتٌ قَتْلٌ':Added, #1: 1	ثُبُوتَ الْقَتْلِ
u'ثُبُوتٌ قتل':Added, #1: 1	ثُبُوتُ الْقَتْلِ
u'ثُبُوتٌ قَتْلٌ':Added, #1: 1	ثُبُوتِ قَتْلِهِ
u'ثُبُوتٌ قتل':Added, #1: 1	ثُبُوتِ قَتْلِهِ
u'ثُبُوتٌ قَتْلٌ':Added, #7: 7	ثُبُوتِ الْقَتْلِ
u'ثُبُوتٌ قدرة':Added, #7: 7	ثُبُوتِ الْقَتْلِ
u'ثُبُوتٌ قُدْرَةٌ':Added, #1: 1	ثُبُوتِ الْقُدْرَةِ
u'ثُبُوتٌ قذف':Added, #1: 1	ثُبُوتِ الْقُدْرَةِ
u'ثُبُوتٌ قَذْفٌ':Added, #2: 2	ثُبُوتِ الْقَذْفِ
u'ثُبُوتٌ قَرْضٌ':Added, #2: 2	ثُبُوتِ الْقَذْفِ
u'ثُبُوتٌ قَسام':Added, #1: 1	ثُبُوتَ الْقَرْضِ
u'ثُبُوتٌ قَسامَة':Added, #1: 1	ثُبُوتُ الْقَسَامَةِ
u'ثُبُوتٌ قصاص':Added, #1: 1	ثُبُوتُ الْقَسَامَةِ
u'ثُبُوتٌ قِصَاصٌ':Added, #3: 3	ثُبُوتِ الْقِصَاصِ
u'ثُبُوتٌ قصاص':Added, #3: 3	ثُبُوتِ الْقِصَاصِ
u'ثُبُوتٌ قِصَاصٌ':Added, #4: 4	ثُبُوتَ الْقِصَاصِ
u'ثُبُوتٌ قَضَاءٌ':Added, #4: 4	ثُبُوتَ الْقِصَاصِ
u'ثُبُوتٌ قَضَاءٌ':Added, #1: 1	ثُبُوتَ الْقَضَاءِ
u'ثُبُوتٌ قَطْعٌ':Added, #1: 1	ثُبُوتُ الْقَضَاءِ
u'ثُبُوتٌ قَطْعٌ':Added, #1: 1	ثُبُوتَ الْقَطْعِ
u'ثُبُوتٌ قَطْعٌ':Added, #1: 1	ثُبُوتِ الْقَطْعِ
u'ثُبُوتٌ قُوَّةٌ':Added, #2: 2	ثُبُوتُ الْقَطْعِ
u'ثُبُوتٌ قُوَّة':Added, #1: 1	ثُبُوتُ قُوَّةٍ
u'ثُبُوتٌ قَوَد':Added, #1: 1	ثُبُوتُ قُوَّةٍ
u'ثُبُوتٌ قول':Added, #1: 1	ثُبُوتِ الْقَوَدِ
u'ثُبُوتٌ قَوْلٌ':Added, #1: 1	ثُبُوتِ الْقَوْلِ
u'ثُبُوتٌ قول':Added, #1: 1	ثُبُوتِ الْقَوْلِ
u'ثُبُوتٌ قَوْلٌ':Added, #1: 1	ثُبُوتِ قَوْلِ
u'ثُبُوتٌ قول':Added, #1: 1	ثُبُوتِ قَوْلِ
u'ثُبُوتٌ قَوْلٌ':Added, #1: 1	ثُبُوتُ قَوْلِهِ
u'ثُبُوتٌ قول':Added, #1: 1	ثُبُوتُ قَوْلِهِ
u'ثُبُوتٌ قَوْلٌ':Added, #3: 3	ثُبُوتِ قَوْلِهِ
u'ثُبُوتٌ قِيَاسٌ':Added, #3: 3	ثُبُوتِ قَوْلِهِ
u'ثُبُوتٌ قيام':Added, #1: 1	ثُبُوتِ الْقِيَاسِ
u'ثُبُوتٌ قِيَامٌ':Added, #1: 1	ثُبُوتِ الْقِيَامِ
u'ثُبُوتٌ قِيمَةٌ':Added, #1: 1	ثُبُوتِ الْقِيَامِ
u'ثُبُوتٌ كِتَابٌ':Added, #1: 1	ثُبُوتِ الْقِيمَةِ
u'ثُبُوتٌ كِتَابَةٌ':Added, #1: 1	ثُبُوتِ الْكِتَابِ
u'ثُبُوتٌ كِتَابَةٌ':Added, #1: 1	ثُبُوتَ الْكِتَابَةِ
u'ثُبُوتٌ كِتَابَةٌ':Added, #1: 1	ثُبُوتُ الْكِتَابَةِ
u'ثُبُوتٌ كَثْرَةٌ':Added, #3: 3	ثُبُوتِ الْكِتَابَةِ
u'ثُبُوتٌ كَرَاهَةٌ':Added, #1: 1	ثُبُوتِ الْكَثْرَةِ
u'ثُبُوتٌ كَرَاهَةٌ':Added, #1: 1	ثُبُوتِ الْكَرَاهَةِ
u'ثُبُوتٌ كَرَاهَةٌ':Added, #1: 1	ثُبُوتُ كَرَاهَتِهِ
u'ثُبُوتٌ كَرَاهَةٌ':Added, #2: 2	ثُبُوتَ الْكَرَاهَةِ
u'ثُبُوتٌ كَعْبٌ':Added, #4: 4	ثُبُوتُ الْكَرَاهَةِ
u'ثُبُوتٌ كفر':Added, #1: 1	ثُبُوتَ الْكَعْبِ
u'ثُبُوتٌ كُفْرٌ':Added, #1: 1	ثُبُوتِ الْكُفْرِ
u'ثُبُوتٌ كَوْنٌ':Added, #1: 1	ثُبُوتِ الْكُفْرِ
u'ثُبُوتٌ لاَزِمٌ':Added, #4: 4	ثُبُوتِ كَوْنِ
u'ثُبُوتٌ لعان':Added, #1: 1	ثُبُوتِ اللَّازِمِ
u'ثُبُوتٌ لُغَةٌ':Added, #1: 1	ثُبُوتُ اللِّعَانِ
u'ثُبُوتٌ لُغَةٌ':Added, #2: 2	ثُبُوتُ اللُّغَةِ
u'ثُبُوتٌ لَفْظٌ':Added, #2: 2	ثُبُوتِ اللُّغَةِ
u'ثُبُوتٌ لَفْظٌ':Added, #1: 1	ثُبُوتِ لَفْظٍ
u'ثُبُوتٌ لِقَاءٌ':Added, #1: 1	ثُبُوتَ لَفْظِهِ
u'ثُبُوتٌ مَالٌ':Added, #1: 1	ثُبُوتِ اللِّقَاءِ
u'ثُبُوتٌ مَالٌ':Added, #1: 1	ثُبُوتَ الْمَالِ
u'ثُبُوتٌ مَالٌ':Added, #1: 1	ثُبُوتِ مَالٍ
u'ثُبُوتٌ مَالٌ':Added, #1: 1	ثُبُوتِ مَالِ
u'ثُبُوتٌ مَالٌ':Added, #2: 2	ثُبُوتُ الْمَالِ
u'ثُبُوتٌ مالِك':Added, #8: 8	ثُبُوتِ الْمَالِ
u'ثُبُوتٌ مالِك':Added, #1: 1	ثُبُوتِ الْمَالِكِيَّةِ
u'ثُبُوتٌ مالِك':Added, #1: 1	ثُبُوتِ مَالِكِيَّةِ
u'ثُبُوتٌ مالِك':Added, #2: 2	ثُبُوتُ الْمَالِكِيَّةِ
u'ثُبُوتٌ مالِكِيّ':Added, #5: 5	ثُبُوتَ الْمَالِكِيَّةِ
u'ثُبُوتٌ مالِكِيّ':Added, #1: 1	ثُبُوتِ الْمَالِكِيَّةِ
u'ثُبُوتٌ مالِكِيّ':Added, #1: 1	ثُبُوتِ مَالِكِيَّةِ
u'ثُبُوتٌ مالِكِيّ':Added, #2: 2	ثُبُوتُ الْمَالِكِيَّةِ
u'ثُبُوتٌ مُبَاشَرَةٌ':Added, #5: 5	ثُبُوتَ الْمَالِكِيَّةِ
u'ثُبُوتٌ مِثَالٌ':Added, #1: 1	ثُبُوتُ مُبَاشَرَةِ
u'ثُبُوتٌ مثل':Added, #1: 1	ثُبُوتُ مِثَالِ
u'ثُبُوتٌ مِثْلٌ':Added, #1: 1	ثُبُوتُ الْمِثْلِ
u'ثُبُوتٌ مثل':Added, #1: 1	ثُبُوتُ الْمِثْلِ
u'ثُبُوتٌ مثل':Added, #1: 1	ثُبُوتُ مِثْلِ
u'ثُبُوتٌ مِثْلٌ':Added, #1: 1	ثُبُوتِ مِثْلِ
u'ثُبُوتٌ مِثْلٌ':Added, #1: 1	ثُبُوتَ مِثْلٍ
u'ثُبُوتٌ مِثْلٌ':Added, #1: 1	ثُبُوتُ مِثْلِ
u'ثُبُوتٌ مثل':Added, #1: 1	ثُبُوتِ مِثْلِ
u'ثُبُوتٌ مثل':Added, #1: 1	ثُبُوتَ مِثْلِهِ
u'ثُبُوتٌ مِثْلٌ':Added, #1: 1	ثُبُوتِ مِثْلِهِ
u'ثُبُوتٌ مِثْلٌ':Added, #1: 1	ثُبُوتَ مِثْلِهِ
u'ثُبُوتٌ مَجَازِيٌّ':Added, #1: 1	ثُبُوتِ مِثْلِهِ
u'ثُبُوتٌ مُجَرَّدٌ':Added, #1: 1	ثُبُوتِ الْمَجَازِيَّةِ
u'ثُبُوتٌ مُجَرَّدٌ':Added, #1: 1	ثُبُوتِ مُجَرَّدٍ
u'ثُبُوتٌ مَحْرَم':Added, #1: 1	ثُبُوتِ مُجَرَّدِ
u'ثُبُوتٌ مَحْرَمَة':Added, #5: 5	ثُبُوتِ الْمَحْرَمِيَّةِ
u'ثُبُوتٌ مَحْكُومٌ':Added, #5: 5	ثُبُوتِ الْمَحْرَمِيَّةِ
u'ثُبُوتٌ مَحَلِّيٌّ':Added, #2: 2	ثُبُوتِ الْمَحْكُومِ
u'ثُبُوتٌ مَحَلِّيَّةٌ':Added, #1: 1	ثُبُوتِ الْمَحَلِّيَّةِ
u'ثُبُوتٌ مَدْلُولٌ':Added, #1: 1	ثُبُوتِ الْمَحَلِّيَّةِ
u'ثُبُوتٌ مَدْلُولٌ':Added, #1: 1	ثُبُوتَ الْمَدْلُولِ
u'ثُبُوتٌ مَدْلُولٌ':Added, #1: 1	ثُبُوتُ مَدْلُولِهِ
u'ثُبُوتٌ مَذْهَبٌ':Added, #2: 2	ثُبُوتِ الْمَدْلُولِ
u'ثُبُوتٌ مَذْهَبٌ':Added, #1: 1	ثُبُوتِ مَذْهَبٍ
u'ثُبُوتٌ مَسْأَلَةٌ':Added, #2: 2	ثُبُوتُ مَذْهَبٍ
u'ثُبُوتٌ مُسَاوَاةٌ':Added, #1: 1	ثُبُوتِ مَسْأَلَةِ
u'ثُبُوتٌ مُسَاوَاةٌ':Added, #1: 1	ثُبُوتَ الْمُسَاوَاةِ
u'ثُبُوتٌ مَسْحٌ':Added, #3: 3	ثُبُوتِ الْمُسَاوَاةِ
u'ثُبُوتٌ مُسَوِّغٌ':Added, #1: 1	ثُبُوتُ مَسْحِ
u'ثُبُوتٌ مُشَارَكَةٌ':Added, #1: 1	ثُبُوتِ مُسَوِّغَاتِهِ
u'ثُبُوتٌ مَشْرُوطٌ':Added, #1: 1	ثُبُوتَ الْمُشَارَكَةِ
u'ثُبُوتٌ مَصْلَحَةٌ':Added, #1: 1	ثُبُوتُ الْمَشْرُوطِ
u'ثُبُوتٌ مَصْلَحَةٌ':Added, #1: 1	ثُبُوتِ الْمَصْلَحَةِ
u'ثُبُوتٌ مَضْمُونٌ':Added, #1: 1	ثُبُوتِ مَصْلَحَةِ
u'ثُبُوتٌ مُطَالَبٌ':Added, #1: 1	ثُبُوتِ مَضْمُونِ
u'ثُبُوتٌ مُطَالَبٌ':Added, #1: 1	ثُبُوتَ الْمُطَالَبَةِ
u'ثُبُوتٌ مُطَالَبٌ':Added, #1: 1	ثُبُوتِ الْمُطَالَبَةِ
u'ثُبُوتٌ مُطَالَبَةٌ':Added, #1: 1	ثُبُوتُ مُطَالَبَةِ
u'ثُبُوتٌ مُطَالَبَةٌ':Added, #1: 1	ثُبُوتَ الْمُطَالَبَةِ
u'ثُبُوتٌ مُطَالَبَةٌ':Added, #1: 1	ثُبُوتِ الْمُطَالَبَةِ
u'ثُبُوتٌ مَطْلُوبٌ':Added, #1: 1	ثُبُوتُ مُطَالَبَةِ
u'ثُبُوتٌ مَطْلُوبٌ':Added, #1: 1	ثُبُوتَ الْمَطْلُوبِ
u'ثُبُوتٌ مُعارِضٌ':Added, #3: 3	ثُبُوتِ الْمَطْلُوبِ
u'ثُبُوتٌ مُعَارَضَةٌ':Added, #1: 1	ثُبُوتِ مُعَارِضٍ
u'ثُبُوتٌ مُعْجِزٌ':Added, #1: 1	ثُبُوتِ الْمُعَارَضَةِ
u'ثُبُوتٌ مُعْجِزَةٌ':Added, #1: 1	ثُبُوتِ الْمُعْجِزَةِ
u'ثُبُوتٌ مَعْرُوفٌ':Added, #1: 1	ثُبُوتِ الْمُعْجِزَةِ
u'ثُبُوتٌ مُعَلَّقٌ':Added, #1: 1	ثُبُوتِ الْمَعْرُوفِ
u'ثُبُوتٌ مُغَايِرٌ':Added, #1: 1	ثُبُوتِ الْمُعَلَّقِ
u'ثُبُوتٌ مُقَدِّمٌ':Added, #1: 1	ثُبُوتِ مُغَايِرٍ
u'ثُبُوتٌ مُقَدِّمٌ':Added, #1: 1	ثُبُوتِ الْمُقَدِّمَاتِ
u'ثُبُوتٌ مُقَدِّمَةٌ':Added, #1: 1	ثُبُوتِ الْمُقَدِّمَةِ
u'ثُبُوتٌ مُقَدِّمَةٌ':Added, #1: 1	ثُبُوتِ الْمُقَدِّمَاتِ
u'ثُبُوتٌ مَكْرُوهٌ':Added, #1: 1	ثُبُوتِ الْمُقَدِّمَةِ
u'ثُبُوتٌ مُلاَزَمَةٌ':Added, #1: 1	ثُبُوتُ الْمَكْرُوهِ
u'ثُبُوتٌ مُلاَقَاةٌ':Added, #2: 2	ثُبُوتُ الْمُلَازَمَةِ
u'ثُبُوتٌ مَلْزُوم':Added, #1: 1	ثُبُوتِ مُلَاقَاتِهِ
u'ثُبُوتٌ مَلْزُوم':Added, #1: 1	ثُبُوتِ مَلْزُومٍ
u'ثُبُوتٌ مِلْكٌ':Added, #2: 2	ثُبُوتِ الْمَلْزُومِ
u'ثُبُوتٌ مِلْكٌ':Added, #11: 11	ثُبُوتِ مِلْكِ
u'ثُبُوتٌ مِلْكٌ':Added, #1: 1	ثُبُوتُ مِلْكِهِ
u'ثُبُوتٌ مِلْكٌ':Added, #21: 21	ثُبُوتَ الْمِلْكِ
u'ثُبُوتٌ مِلْكٌ':Added, #3: 3	ثُبُوتُ مِلْكِ
u'ثُبُوتٌ مِلْكٌ':Added, #48: 48	ثُبُوتُ الْمِلْكِ
u'ثُبُوتٌ مِلْكٌ':Added, #4: 4	ثُبُوتَ مِلْكِ
u'ثُبُوتٌ مِلْكٌ':Added, #4: 4	ثُبُوتِ مِلْكٍ
u'ثُبُوتٌ مِلْكٌ':Added, #57: 57	ثُبُوتِ الْمِلْكِ
u'ثُبُوتٌ مِلْكٌ':Added, #5: 5	ثُبُوتَ مِلْكِهِ
u'ثُبُوتٌ مَنْزِلَةٌ':Added, #9: 9	ثُبُوتِ مِلْكِهِ
u'ثُبُوتٌ مَهْرٌ':Added, #1: 1	ثُبُوتِ الْمَنْزِلَةِ
u'ثُبُوتٌ مَهْرٌ':Added, #1: 1	ثُبُوتِ مَهْرِ
u'ثُبُوتٌ مُوَاظَبَةٌ':Added, #4: 4	ثُبُوتِ الْمَهْرِ
u'ثُبُوتٌ مَوْتٌ':Added, #2: 2	ثُبُوتِ الْمُوَاظَبَةِ
u'ثُبُوتٌ مَوْتٌ':Added, #1: 1	ثُبُوتُ الْمَوْتِ
u'ثُبُوتٌ مَوْتٌ':Added, #2: 2	ثُبُوتِ الْمَوْتِ
u'ثُبُوتٌ مُؤَثِّرٌ':Added, #2: 2	ثُبُوتِ مَوْتِهِ
u'ثُبُوتٌ مُوجَبٌ':Added, #2: 2	ثُبُوتِ الْمُؤَثِّرِ
u'ثُبُوتٌ مُوجِبٌ':Added, #1: 1	ثُبُوتَ مُوجَبِ
u'ثُبُوتٌ مُوجِبٌ':Added, #1: 1	ثُبُوتَ مُوجِبِ
u'ثُبُوتٌ مُوجِبٌ':Added, #1: 1	ثُبُوتِ مُوجِبِ
u'ثُبُوتٌ مِيرَاثٌ':Added, #1: 1	ثُبُوتِ مُوجِبِهِ
u'ثُبُوتٌ نَاسِخٌ':Added, #1: 1	ثُبُوتَ الْمِيرَاثِ
u'ثُبُوتٌ نَاسِخ':Added, #2: 2	ثُبُوتِ نَاسِخٍ
u'ثُبُوتٌ نُبُوَّةٌ':Added, #2: 2	ثُبُوتِ نَاسِخٍ
u'ثُبُوتٌ نُبُوَّةٌ':Added, #1: 1	ثُبُوتِ النُّبُوَّةِ
u'ثُبُوتٌ نَجَاسَةٌ':Added, #1: 1	ثُبُوتَ نُبُوَّةِ
u'ثُبُوتٌ نَحْوٌ':Added, #2: 2	ثُبُوتِ النَّجَاسَةِ
u'ثُبُوتٌ نَسَبٌ':Added, #1: 1	ثُبُوتُ نَحْوِ
u'ثُبُوتٌ نَسَبٌ':Added, #12: 12	ثُبُوتِ نَسَبِهِ
u'ثُبُوتٌ نَسَبٌ':Added, #17: 17	ثُبُوتِ نَسَبِ
u'ثُبُوتٌ نَسَبٌ':Added, #1: 1	ثُبُوتُ نَسَبٍ
u'ثُبُوتٌ نَسَبٌ':Added, #1: 1	ثُبُوتِ نَسَبٍ
u'ثُبُوتٌ نَسَبٌ':Added, #20: 20	ثُبُوتَ النَّسَبِ
u'ثُبُوتٌ نَسَبٌ':Added, #24: 24	ثُبُوتُ النَّسَبِ
u'ثُبُوتٌ نَسَبٌ':Added, #2: 2	ثُبُوتَ نَسَبِهِ
u'ثُبُوتٌ نَسَبٌ':Added, #4: 4	ثُبُوتُ نَسَبِهِ
u'ثُبُوتٌ نَسَبٌ':Added, #68: 68	ثُبُوتِ النَّسَبِ
u'ثُبُوتٌ نِسْبَةٌ':Added, #7: 7	ثُبُوتُ نَسَبِ
u'ثُبُوتٌ نِسْبَةٌ':Added, #1: 1	ثُبُوتَ النِّسْبَةِ
u'ثُبُوتٌ نَصٌّ':Added, #1: 1	ثُبُوتِ النِّسْبَةِ
u'ثُبُوتٌ نَصٌّ':Added, #1: 1	ثُبُوتَ النَّصِّ
u'ثُبُوتٌ نِصْفٌ':Added, #1: 1	ثُبُوتِ النَّصِّ
u'ثُبُوتٌ نُطْقٌ':Added, #1: 1	ثُبُوتِ النِّصْفِ
u'ثُبُوتٌ نَظَرٌ':Added, #1: 1	ثُبُوتَ نُطْقِهِ
u'ثُبُوتٌ نَظَرٌ':Added, #1: 1	ثُبُوتَ النَّظَرِ
u'ثُبُوتٌ نَفْسٌ':Added, #1: 1	ثُبُوتَ نَظَرٍ
u'ثُبُوتٌ نَفْسٌ':Added, #1: 1	ثُبُوتِ نَفْسِ
u'ثُبُوتٌ نَفْسِيٌّ':Added, #2: 2	ثُبُوتَ نَفْسِ
u'ثُبُوتٌ نَفَقَةٌ':Added, #1: 1	ثُبُوتُ النَّفْسِيِّ
u'ثُبُوتٌ نقل':Added, #1: 1	ثُبُوتُ نَفَقَةِ
u'ثُبُوتٌ نَقْلٌ':Added, #1: 1	ثُبُوتِ النَّقْلِ
u'ثُبُوتٌ نقل':Added, #1: 1	ثُبُوتِ النَّقْلِ
u'ثُبُوتٌ نَقْلٌ':Added, #1: 1	ثُبُوتِ نَقْلِ
u'ثُبُوتٌ نَقِيضٌ':Added, #1: 1	ثُبُوتِ نَقْلِ
u'ثُبُوتٌ نَقِيضٌ':Added, #1: 1	ثُبُوتُ النَّقِيضِ
u'ثُبُوتٌ نَقِيضٌ':Added, #1: 1	ثُبُوتِ النَّقِيضِ
u'ثُبُوتٌ نَقِيضٌ':Added, #1: 1	ثُبُوتَ نَقِيضِ
u'ثُبُوتٌ نَقِيضٌ':Added, #1: 1	ثُبُوتِ نَقِيضِ
u'ثُبُوتٌ نَقِيضٌ':Added, #2: 2	ثُبُوتَ النَّقِيضِ
u'ثُبُوتٌ نكاح':Added, #2: 2	ثُبُوتِ نَقِيضِهِ
u'ثُبُوتٌ نِكَاحٌ':Added, #1: 1	ثُبُوتَ النِّكَاحِ
u'ثُبُوتٌ نكاح':Added, #1: 1	ثُبُوتَ النِّكَاحِ
u'ثُبُوتٌ نِكَاحٌ':Added, #3: 3	ثُبُوتِ النِّكَاحِ
u'ثُبُوتٌ نَهْيٌ':Added, #3: 3	ثُبُوتِ النِّكَاحِ
u'ثُبُوتٌ نَهْيٌ':Added, #1: 1	ثُبُوتَ النَّهْيِ
u'ثُبُوتٌ نَهْيٌ':Added, #1: 1	ثُبُوتِ النَّهْيِ
u'ثُبُوتٌ هِبَةٌ':Added, #3: 3	ثُبُوتِ نَهْيٍ
u'ثُبُوتٌ هِلاَلٌ':Added, #1: 1	ثُبُوتِ الْهِبَةِ
u'ثُبُوتٌ وَاجِبٌ':Added, #2: 2	ثُبُوتِ هِلَالِ
u'ثُبُوتٌ واحد':Added, #1: 1	ثُبُوتِ الْوَاجِبِ
u'ثُبُوتٌ وَاحِدٌ':Added, #1: 1	ثُبُوتُ الْوَاحِدِ
u'ثُبُوتٌ وَاسِطٌ':Added, #1: 1	ثُبُوتُ الْوَاحِدِ
u'ثُبُوتٌ وَجْهٌ':Added, #1: 1	ثُبُوتِ الْوَاسِطَةِ
u'ثُبُوتٌ وُجُوبٌ':Added, #3: 3	ثُبُوتِ الْوَجْهِ
u'ثُبُوتٌ وُجُوبٌ':Added, #1: 1	ثُبُوتَ وُجُوبِ
u'ثُبُوتٌ وُجُوبٌ':Added, #1: 1	ثُبُوتُ وُجُوبِ
u'ثُبُوتٌ وُجُوبٌ':Added, #1: 1	ثُبُوتِ وُجُوبِ
u'ثُبُوتٌ وُجُوبٌ':Added, #1: 1	ثُبُوتُ وُجُوبِهِ
u'ثُبُوتٌ وُجُوبٌ':Added, #1: 1	ثُبُوتِ وُجُوبِهِ
u'ثُبُوتٌ وُجُوبٌ':Added, #3: 3	ثُبُوتَ الْوُجُوبِ
u'ثُبُوتٌ وُجُوبٌ':Added, #3: 3	ثُبُوتِ الْوُجُوبِ
u'ثُبُوتٌ وُجُودٌ':Added, #6: 6	ثُبُوتُ الْوُجُوبِ
u'ثُبُوتٌ وُجُودٌ':Added, #1: 1	ثُبُوتُ الْوُجُودِ
u'ثُبُوتٌ وُجُودٌ':Added, #1: 1	ثُبُوتُ وُجُودِ
u'ثُبُوتٌ وَصْفٌ':Added, #1: 1	ثُبُوتِ وُجُودِهِ
u'ثُبُوتٌ وَصْفٌ':Added, #1: 1	ثُبُوتُ الْوَصْفِ
u'ثُبُوتٌ وَصْفٌ':Added, #1: 1	ثُبُوتِ وَصْفِ
u'ثُبُوتٌ وَصِيٌّ':Added, #4: 4	ثُبُوتِ الْوَصْفِ
u'ثُبُوتٌ وَصِيَّةٌ':Added, #2: 2	ثُبُوتِ الْوَصِيَّةِ
u'ثُبُوتٌ وَطْءٌ':Added, #2: 2	ثُبُوتِ الْوَصِيَّةِ
u'ثُبُوتٌ وَقْفٌ':Added, #1: 1	ثُبُوتَ الْوَطْءِ
u'ثُبُوتٌ وَقْفٌ':Added, #1: 1	ثُبُوتَ الْوَقْفِ
u'ثُبُوتٌ وُقُوعٌ':Added, #1: 1	ثُبُوتِ الْوَقْفِ
u'ثُبُوتٌ وُقُوعٌ':Added, #1: 1	ثُبُوتُ وُقُوعِ
u'ثُبُوتٌ وِكَالَةٌ':Added, #1: 1	ثُبُوتِ وُقُوعِ
u'ثُبُوتٌ وَلاَءٌ':Added, #1: 1	ثُبُوتِ الْوِكَالَةِ
u'ثُبُوتٌ وَلاَءٌ':Added, #10: 10	ثُبُوتَ الْوَلَاءِ
u'ثُبُوتٌ وَلاَءٌ':Added, #13: 13	ثُبُوتِ الْوَلَاءِ
u'ثُبُوتٌ وَلاَءٌ':Added, #2: 2	ثُبُوتِ الْوَلاَءِ
u'ثُبُوتٌ وِلاَدَةٌ':Added, #3: 3	ثُبُوتُ الْوَلَاءِ
u'ثُبُوتٌ وِلاَيَةٌ':Added, #2: 2	ثُبُوتِ الْوِلَادَةِ
u'ثُبُوتٌ وِلاَيَةٌ':Added, #1: 1	ثُبُوتُ وِلاَيَةِ
u'ثُبُوتٌ وِلاَيَةٌ':Added, #1: 1	ثُبُوتَ وِلَايَتِهِ
u'ثُبُوتٌ وِلاَيَةٌ':Added, #3: 3	ثُبُوتِ وِلَايَتِهِ
u'ثُبُوتٌ وِلاَيَةٌ':Added, #5: 5	ثُبُوتَ وِلَايَةِ
u'ثُبُوتٌ وِلاَيَةٌ':Added, #6: 6	ثُبُوتَ الْوِلَايَةِ
u'ثُبُوتٌ وِلاَيَةٌ':Added, #6: 6	ثُبُوتُ الْوِلَايَةِ
u'ثُبُوتٌ وِلاَيَةٌ':Added, #6: 6	ثُبُوتِ الْوِلَايَةِ
u'ثُبُوتٌ وِلاَيَةٌ':Added, #7: 7	ثُبُوتُ وِلَايَةِ
u'ثُبُوتٌ يُتْمٌ':Added, #9: 9	ثُبُوتِ وِلَايَةِ
u'ثُبُوتٌ يُتْمٌ':Added, #1: 1	ثُبُوتِ الْيُتْمِ
u'ثُبُوتٌ يَدٌ':Added, #1: 1	ثُبُوتُ يُتْمِهِ
u'ثُبُوتٌ يَدٌ':Added, #15: 15	ثُبُوتُ يَدِ
u'ثُبُوتٌ يَدٌ':Added, #19: 19	ثُبُوتِ الْيَدِ
u'ثُبُوتٌ يَدٌ':Added, #1: 1	ثُبُوتَ يَدِ
u'ثُبُوتٌ يَدٌ':Added, #1: 1	ثُبُوتِ يَدٍ
u'ثُبُوتٌ يَدٌ':Added, #1: 1	ثُبُوتَ يَدِهِ
u'ثُبُوتٌ يَدٌ':Added, #1: 1	ثُبُوتُ يَدِهِ
u'ثُبُوتٌ يَدٌ':Added, #4: 4	ثُبُوتِ يَدِ
u'ثُبُوتٌ يَدٌ':Added, #5: 5	ثُبُوتِ يَدِهِ
u'ثُبُوتٌ يسار':Added, #6: 6	ثُبُوتَ الْيَدِ
u'ثُبُوتٌ يَسَارٌ':Added, #1: 1	ثُبُوتِ الْيَسَارِ
u'ثَخُنَ دَيْنٌ':Subject, #1: 1	ثُبُوتِ الْيَسَارِ
u'ثَخُنَ مَاءٌ':Subject, #1: 1	ثَخُنَ دَيْنُهُ
u'ثَرْثَرَ رَجُلٌ':Subject, #1: 1	ثَخُنَ الْمَاءُ
u'ثِقَافٌ حَجْرٌ':Added, #1: 1	ثَرْثَرَ الرَّجُلُ
u'ثَقْبٌ إِبْرَةٌ':Added, #1: 1	ثِقَافِ الْحَجْرِ
u'ثَقْبٌ آذَانٌ':Added, #1: 1	ثَقْبِ إبْرَةٍ
u'ثَقْبٌ بَوْلٌ':Added, #1: 1	ثَقْبِ آذَانِ
u'ثَقْبٌ بَيْتٌ':Added, #1: 1	ثَقْبِ الْبَوْلِ
u'ثَقْبٌ شَيْءٌ':Added, #1: 1	ثَقْبُ الْبَيْتِ
u'ثَقْبٌ فَأْرٌ':Added, #1: 1	ثَقْبُ شَيْءٍ
u'ثَقْبٌ كرش':Added, #1: 1	ثَقْبُ الْفَأْرَةِ
u'ثَقْبٌ كَرِشٌ':Added, #1: 1	ثَقْبُ الْكَرِشِ
u'ثَقَبَ كَيٌّ':Subject, #1: 1	ثَقْبُ الْكَرِشِ
u'ثَقْبٌ لُؤْلُؤٌ':Added, #1: 1	ثَقَبَ الْكَيُّ
u'ثَقْبٌ واحد':Added, #2: 2	ثَقْبِ اللُّؤْلُؤِ
u'ثَقْبٌ وَاحِدٌ':Added, #1: 1	ثَقْبٍ وَاحِدٍ
u'ثِقَةٌ أهْلٌ':Added, #1: 1	ثَقْبٍ وَاحِدٍ
u'ثِقَةٌ ثَبْتٌ':Added, #1: 1	ثِقَةِ أَهْلِ
u'ثِقَةٌ حاذِقٌ':Added, #1: 1	ثِقَةٍ ثَبْتٍ
u'ثِقَةٌ حافِظٌ':Added, #1: 1	ثِقَةٍ حَاذِقٍ
u'ثِقَةٌ حُجَّةٌ':Added, #1: 1	ثِقَةٍ حَافِظٍ
u'ثِقَةٌ دِينٌ':Added, #1: 1	ثِقَةٍ حُجَّةٍ
u'ثِقَةٌ رِجَالٌ':Added, #2: 2	ثِقَةُ الدِّينِ
u'ثِقَةٌ سَاقِطٌ':Added, #2: 2	ثِقَةِ رِجَالِهِ
u'ثِقَةٌ طَبِيبٌ':Added, #2: 2	ثِقَةَ السَّاقِطِ
u'ثِقَةٌ عَارِفٌ':Added, #1: 1	ثِقَةٍ طَبِيبٍ
u'ثِقَةٌ عَالِمٌ':Added, #5: 5	ثِقَةٍ عَارِفٍ
u'ثِقَةٌ عَدْلٌ':Added, #1: 1	ثِقَةٍ عَالِمٍ
u'ثِقَةٌ قَادِرٌ':Added, #1: 1	ثِقَةٍ عَدْلٍ
u'ثِقَةٌ مَأْمُونٌ':Added, #1: 1	ثِقَةٍ قَادِرٍ
u'ثِقَةٌ مَأْمُونٌ':Added, #2: 2	ثِقَةٍ مَأْمُونَةٍ
u'ثِقَةٌ مُتْقِنٌ':Added, #3: 3	ثِقَةٍ مَأْمُونٍ
u'ثِقَةٌ مُعْتَمَدٌ':Added, #2: 2	ثِقَةٍ مُتْقِنٍ
u'ثِقَةٌ مَعْرُوفٌ':Added, #1: 1	ثِقَةٍ مُعْتَمَدٍ
u'ثِقَةٌ نسخة':Added, #1: 1	ثِقَةٍ مَعْرُوفٍ
u'ثِقَةٌ نُسْخَةٌ':Added, #1: 1	ثِقَةَ النُّسْخَةِ
u'ثَقُلَ بُكاءٌ':Subject, #1: 1	ثِقَةَ النُّسْخَةِ
u'ثَقُلَ رَسُولٌ':Subject, #1: 1	ثَقُلَ بُكَاءُ
u'ثَقُلَ لِسَانٌ':Subject, #7: 7	ثَقُلَ رَسُولُ
u'ثَقُلَ مَاءٌ':Subject, #1: 1	ثَقُلَ لِسَانُهُ
u'ثَقُلَ مَعْقِلٌ':Subject, #1: 1	ثَقُلَ الْمَاءُ
u'ثَقُلَ نَبِيٌّ':Subject, #1: 1	ثَقُلَ مَعْقِلُ
u'ثُقُوبٌ جَديدٌ':Added, #1: 1	ثَقُلَ النَّبِيُّ
u'ثُقُوبٌ جَدِيدٌ':Added, #2: 2	ثُقُوبَ الْجَدِيدِ
u'ثُقُوبٌ حَجَرٌ':Added, #2: 2	ثُقُوبَ الْجَدِيدِ
u'ثَلْجٌ سَطْحٌ':Added, #1: 1	ثُقُوبِ حَجَرِ
u'ثَلَجَ صَدْرٌ':Subject, #2: 2	ثَلْجِ السَّطْحِ
u'ثَلْجٌ صُدُورٌ':Added, #1: 1	ثَلَجَ صَدْرُهُ
u'ثَلْجٌ يَقِينٌ':Added, #1: 1	ثَلْجِ الصّدُورِ
u'ثَلْمٌ عَرْضٌ':Added, #2: 2	ثَلْجِ الْيَقِينِ
u'ثَلْمٌ عِرْضٌ':Added, #1: 1	ثَلْمُ الْعَرْضِ
u'ثَمَّ أثَرٌ':Subject, #1: 1	ثَلْمِ الْعِرْضِ
u'ثَمَّ أحَدٌ':Subject, #1: 1	ثَمَّ أَثَرٌ
u'ثَمَّ إحْضَارٌ':Subject, #4: 4	ثَمَّ أَحَدٌ
u'ثَمَّ إِخْرَاجٌ':Subject, #1: 1	ثَمَّ الْإِحْضَارُ
u'ثَمَّ أَرْبَعَةٌ':Subject, #1: 1	ثَمَّ الْإِخْرَاجُ
u'ثَمَّ اِسْمٌ':Subject, #1: 1	ثَمَّ أَرْبَعَةُ
u'ثَمَّ إِشْغالٌ':Subject, #2: 2	ثَمَّ اسْمُ
u'ثَمَّ أًصْلٌ':Subject, #1: 1	ثَمَّ إشْغَالُ
u'ثَمَّ إِعانَةٌ':Subject, #2: 2	ثَمَّ أَصْلٌ
u'ثَمَّ أعْرَفُ':Subject, #1: 1	ثَمَّ إعَانَتُهُ
u'ثَمَّ أعْرَف':Subject, #1: 1	ثَمَّ أَعْرَفُ
u'ثَمَّ إعْطَاءٌ':Predicate, #1: 1	ثَمَّ أَعْرَفُ
u'ثَمَّ إفْسَادٌ':Subject, #1: 1	ثَمَّ إعْطَاءَ
u'ثَمَّ أفْضَلُ':Subject, #1: 1	ثَمَّ إفْسَادٌ
u'ثَمَّ أَكْثَرُ':Predicate, #2: 2	ثَمَّ أَفْضَلُ
u'ثَمَّ أَكْثَرُ':Subject, #1: 1	ثَمَّ أَكْثَرَ
u'ثَمَّ أَمْثَلُ':Subject, #1: 1	ثَمَّ أَكْثَرُ
u'ثَمَّ اِمْرَأَةٌ':Subject, #3: 3	ثَمَّ الْأَمْثَلُ
u'ثَمَّ إيقَاعٌ':Subject, #1: 1	ثَمَّ امْرَأَةٌ
u'ثَمَّ بَاعٌ':Predicate, #1: 1	ثَمَّ إيقَاعُ
u'ثَمَّ باقِي':Subject, #1: 1	ثَمَّ بَاعَ
u'ثَمَّ باقِيَةٌ':Subject, #2: 2	ثَمَّ بَاقِيَةٌ
u'ثَمَّ بِدْعَةٌ':Subject, #2: 2	ثَمَّ بَاقِيَةٌ
u'ثَمَّ بَراءةٌ':Predicate, #1: 1	ثَمَّ بِدْعَةٌ
u'ثَمَّ بَطَلٌ':Predicate, #1: 1	ثَمَّ بَرَاءَةَ
u'ثَمَّ بَعْضٌ':Predicate, #1: 1	ثَمَّ بَطَلَ
u'ثَمَّ بَقاءٌ':Subject, #1: 1	ثَمَّ بَعْضَ
u'ثَمَّ بَيَانٌ':Subject, #1: 1	ثَمَّ بَقَاءُ
u'ثَمَّ بَيَانٌ':Subject, #1: 1	ثَمَّ الْبَيَانُ
u'ثَمَّ بَيْتٌ':Subject, #2: 2	ثَمَّ بَيَانُ
u'ثَمَّ بَيْنٌ':Predicate, #1: 1	ثَمَّ بَيْتُ
u'ثَمَّ بَيِّنَةٌ':Subject, #1: 1	ثَمَّ بَيْنَ
u'ثَمَّ تَحْقِيقٌ':Subject, #1: 1	ثَمَّ بَيِّنَةٌ
u'ثَمَّ تَخْلِيصٌ':Subject, #1: 1	ثَمَّ تَحْقِيقٌ
u'ثَمَّ تُرَابٌ':Subject, #2: 2	ثَمَّ تَخْلِيصُ
u'ثَمَّ تَرْكٌ':Subject, #1: 1	ثَمَّ تُرَابٌ
u'ثَمَّ تَرِكَةٌ':Subject, #1: 1	ثَمَّ تَرْكُ
u'ثَمَّ تَزْكِيَةٌ':Subject, #1: 1	ثَمَّ تَرِكَةٌ
u'ثَمَّ تَعِبٌ':Predicate, #3: 3	ثَمَّ تَزْكِيَةٌ
u'ثَمَّ تَفْرِيقٌ':Subject, #1: 1	ثَمَّ تَعِبَ
u'ثَمَّ تَفْصِيلٌ':Subject, #2: 2	ثَمَّ تَفْرِيقٌ
u'ثَمَّ تَقْديمٌ':Subject, #1: 1	ثَمَّ تَفْصِيلٌ
u'ثَمَّ تَقْصيرٌ':Subject, #1: 1	ثَمَّ التَّقْدِيمُ
u'ثَمَّ تَلَبُّسٌ':Subject, #2: 2	ثَمَّ تَقْصِيرٌ
u'ثَمَّ تَمْييزٌ':Subject, #1: 1	ثَمَّ تَلَبُّسٌ
u'ثَمَّ تَنَاقُضٌ':Subject, #1: 1	ثَمَّ التَّمْيِيزُ
u'ثَمَّ تُهْمَةٌ':Subject, #1: 1	ثَمَّ تَنَاقُضٌ
u'ثَمَّ تُهْمَةٌ':Subject, #1: 1	ثَمَّ تُهْمَةُ
u'ثَمَّ ثَابِتٌ':Subject, #2: 2	ثَمَّ تُهْمَةٌ
u'ثَمَّ ثَالِثٌ':Subject, #1: 1	ثَمَّ ثَابِتٌ
u'ثَمَّ ثُبُوتٌ':Subject, #2: 2	ثَمَّ ثَالِثٌ
u'ثَمَّ ثَمَرٌ':Subject, #1: 1	ثَمَّ ثُبُوتُ
u'ثَمَّ جَازٌ':Predicate, #1: 1	ثَمَّ ثَمَرٌ
u'ثَمَّ جَاهِلٌ':Subject, #8: 8	ثَمَّ جَازَ
u'ثَمَّ جَبَلٌ':Subject, #1: 1	ثَمَّ جَاهِلٌ
u'ثَمَّ جَمَاعَةٌ':Subject, #1: 1	ثَمَّ جَبَلٌ
u'ثَمَّ جمع':Subject, #1: 1	ثَمَّ جَمَاعَةٌ
u'ثَمَّ جَمْعٌ':Subject, #1: 1	ثَمَّ الْجَمْعُ
u'ثَمَّ جِهَةٌ':Subject, #1: 1	ثَمَّ الْجَمْعُ
u'ثَمَّ جَوَابٌ':Subject, #2: 2	ثَمَّ الْجِهَةُ
u'ثَمَّ جَوَابٌ':Subject, #1: 1	ثَمَّ جَوَابٌ
u'ثَمَّ جَوَازٌ':Predicate, #1: 1	ثَمَّ جَوَابُهُ
u'ثَمَّ حاجَةٌ':Subject, #2: 2	ثَمَّ جَوَازَ
u'ثَمَّ حاكِمٌ':Subject, #18: 18	ثَمَّ حَاجَةٌ
u'ثَمَّ حائِلٌ':Subject, #4: 4	ثَمَّ حَاكِمٌ
u'ثَمَّ حَذْف':Subject, #1: 1	ثَمَّ حَائِلٌ
u'ثَمَّ حَرْفٌ':Subject, #1: 1	ثَمَّ حَذْفٌ
u'ثَمَّ حُرْمَةٌ':Subject, #1: 1	ثَمَّ حَرْفُ
u'ثَمَّ حُرْمَةٌ':Subject, #1: 1	ثَمَّ حُرْمَةٌ
u'ثَمَّ حَصَلٌ':Predicate, #1: 1	ثَمَّ حُرْمَةُ
u'ثَمَّ حُكْمٌ':Predicate, #1: 1	ثَمَّ حَصَلَ
u'ثَمَّ حُكْمٌ':Subject, #1: 1	ثَمَّ حُكْمَ
u'ثَمَّ خَادِمٌ':Subject, #1: 1	ثَمَّ حُكْمُ
u'ثَمَّ خُصٌّ':Predicate, #1: 1	ثَمَّ خَادِمٌ
u'ثَمَّ خِلاَفٌ':Subject, #1: 1	ثَمَّ خُصَّ
u'ثَمَّ خِلاَفٌ':Subject, #1: 1	ثَمَّ الْخِلَافُ
u'ثَمَّ خَوَاصُّ':Subject, #1: 1	ثَمَّ خِلَافٌ
u'ثَمَّ خَوَاصّ':Subject, #1: 1	ثَمَّ خَوَاصُّ
u'ثَمَّ دَافِعٌ':Subject, #1: 1	ثَمَّ خَوَاصُّ
u'ثَمَّ دَنانيرُ':Predicate, #1: 1	ثَمَّ دَافِعٌ
u'ثَمَّ دَيْنٌ':Subject, #1: 1	ثَمَّ دَنَانِيرَ
u'ثَمَّ دِينارٌ':Subject, #2: 2	ثَمَّ دَيْنٌ
u'ثَمَّ ذاتِيٌّ':Subject, #4: 4	ثَمَّ دِينَارٌ
u'ثَمَّ ذكر':Predicate, #1: 1	ثَمَّ ذَاتِيَّةٌ
u'ثَمَّ ذَكَرٌ':Predicate, #3: 3	ثَمَّ ذَكَرَ
u'ثَمَّ رِبْحٌ':Subject, #3: 3	ثَمَّ ذَكَرَ
u'ثَمَّ رِبْحٌ':Subject, #1: 1	ثَمَّ رِبْحٌ
u'ثَمَّ رُخْصَةٌ':Subject, #2: 2	ثَمَّ الرِّبْحُ
u'ثَمَّ رَدٌّ':Subject, #1: 1	ثَمَّ رُخْصَةٌ
u'ثَمَّ رَدٌّ':Subject, #1: 1	ثَمَّ الرَّدُّ
u'ثَمَّ رُطوبَةٌ':Subject, #1: 1	ثَمَّ رَدُّهُ
u'ثَمَّ ركب':Predicate, #2: 2	ثَمَّ رُطُوبَةٌ
u'ثَمَّ رَهْنٌ':Subject, #1: 1	ثَمَّ رَكِبَ
u'ثَمَّ زادٌ':Predicate, #2: 2	ثَمَّ رَهْنٌ
u'ثَمَّ زِحامٌ':Subject, #1: 1	ثَمَّ زَادَ
u'ثَمَّ زَحْمَةٌ':Subject, #2: 2	ثَمَّ زِحَامٌ
u'ثَمَّ زَوْجَةٌ':Subject, #2: 2	ثَمَّ زَحْمَةٌ
u'ثَمَّ زِيادَةٌ':Subject, #3: 3	ثَمَّ الزَّوْجَةُ
u'ثَمَّ سَبَبٌ':Subject, #1: 1	ثَمَّ زِيَادَةٌ
u'ثَمَّ سَبْقٌ':Subject, #3: 3	ثَمَّ سَبَبٌ
u'ثَمَّ سَبْكٌ':Subject, #1: 1	ثَمَّ سَبْقٌ
u'ثَمَّ سَفِيرٌ':Subject, #1: 1	ثَمَّ سَبْكٌ
u'ثَمَّ سُقُوطٌ':Subject, #1: 1	ثَمَّ سَفِيرٌ
u'ثَمَّ سُكُونٌ':Subject, #1: 1	ثَمَّ سُقُوطُ
u'ثَمَّ سلام':Subject, #1: 1	ثَمَّ السُّكُونُ
u'ثَمَّ سَلاَمٌ':Subject, #1: 1	ثَمَّ السَّلَامُ
u'ثَمَّ سُلْطَانٌ':Subject, #1: 1	ثَمَّ السَّلَامُ
u'ثَمَّ سَمٌّ':Subject, #1: 1	ثَمَّ سُلْطَانٌ
u'ثَمَّ سَواءٌ':Subject, #1: 1	ثَمَّ سَمَّاهُ
u'ثَمَّ شَاخِصٌ':Subject, #1: 1	ثَمَّ سَوَاءٌ
u'ثَمَّ شَرْطٌ':Subject, #1: 1	ثَمَّ شَاخِصٌ
u'ثَمَّ شُهُودٌ':Subject, #1: 1	ثَمَّ شَرْطٌ
u'ثَمَّ شَيْءٌ':Subject, #1: 1	ثَمَّ شُهُودٌ
u'ثَمَّ صَرِيحٌ':Subject, #4: 4	ثَمَّ شَيْءٌ
u'ثَمَّ صِفَةٌ':Subject, #1: 1	ثَمَّ صَرِيحٌ
u'ثَمَّ صُورَةٌ':Subject, #1: 1	ثَمَّ صِفَةٌ
u'ثَمَّ ضَرَرٌ':Subject, #1: 1	ثَمَّ صُورَةٌ
u'ثَمَّ ضَرُورَةٌ':Subject, #1: 1	ثَمَّ ضَرَرٌ
u'ثَمَّ طَرِيقٌ':Subject, #5: 5	ثَمَّ ضَرُورَةٌ
u'ثَمَّ طلب':Predicate, #1: 1	ثَمَّ طَرِيقٌ
u'ثَمَّ طَلَبٌ':Predicate, #1: 1	ثَمَّ طَلَبَ
u'ثَمَّ ظاهِرٌ':Subject, #1: 1	ثَمَّ طَلَبَ
u'ثَمَّ ظاهِرٌ':Subject, #1: 1	ثَمَّ الظَّاهِرُ
u'ثَمَّ عَادٌ':Predicate, #1: 1	ثَمَّ ظَاهِرٌ
u'ثَمَّ عَادَةٌ':Subject, #1: 1	ثَمَّ عَادَ
u'ثَمَّ عَامٌّ':Subject, #5: 5	ثَمَّ عَادَةٌ
u'ثَمَّ عتق':Subject, #1: 1	ثَمَّ عَامٌّ
u'ثَمَّ عِتْقٌ':Subject, #1: 1	ثَمَّ الْعِتْقُ
u'ثَمَّ عَدَاوَةٌ':Subject, #1: 1	ثَمَّ الْعِتْقُ
u'ثَمَّ عَدَدٌ':Subject, #2: 2	ثَمَّ عَدَاوَةٌ
u'ثَمَّ عَدْلٌ':Subject, #1: 1	ثَمَّ عَدَدُ
u'ثَمَّ عَدَمٌ':Predicate, #1: 1	ثَمَّ عَدْلٌ
u'ثَمَّ عُدْوَانٌ':Subject, #1: 1	ثَمَّ عَدَمَ
u'ثَمَّ عُذْرٌ':Subject, #1: 1	ثَمَّ عُدْوَانٌ
u'ثَمَّ عَرَضٌ':Predicate, #6: 6	ثَمَّ عُذْرٌ
u'ثَمَّ عرف':Subject, #1: 1	ثَمَّ عَرَضَ
u'ثَمَّ عُرْفٌ':Subject, #3: 3	ثَمَّ عُرْفٌ
u'ثَمَّ عَكْسٌ':Subject, #3: 3	ثَمَّ عُرْفٌ
u'ثَمَّ عَلاَقَةٌ':Subject, #1: 1	ثَمَّ عَكْسُ
u'ثَمَّ عِلَّةٌ':Subject, #2: 2	ثَمَّ عَلَاقَةٌ
u'ثَمَّ علم':Predicate, #1: 1	ثَمَّ عِلَّةٌ
u'ثَمَّ عُلْوٌ':Subject, #1: 1	ثَمَّ عُلِمَ
u'ثَمَّ عَمَلٌ':Subject, #1: 1	ثَمَّ عُلْوٌ
u'ثَمَّ عند':Predicate, #1: 1	ثَمَّ عَمَلٌ
u'ثَمَّ غَالِبٌ':Subject, #1: 1	ثَمَّ عِنْدَ
u'ثَمَّ غرائر':Subject, #1: 1	ثَمَّ غَالِبٌ
u'ثَمَّ غَرَائِرُ':Subject, #1: 1	ثَمَّ غَرَائِرُ
u'ثَمَّ غلب':Predicate, #1: 1	ثَمَّ غَرَائِرُ
u'ثَمَّ غير':Subject, #3: 3	ثَمَّ غَلَبَ
u'ثَمَّ غَيْرٌ':Subject, #2: 2	ثَمَّ غَيْرُ
u'ثَمَّ غير':Subject, #2: 2	ثَمَّ غَيْرُ
u'ثَمَّ غَيْرٌ':Subject, #9: 9	ثَمَّ غَيْرُهُ
u'ثَمَّ فَائِدَةٌ':Subject, #9: 9	ثَمَّ غَيْرُهُ
u'ثَمَّ فرق':Subject, #1: 1	ثَمَّ فَائِدَةٌ
u'ثَمَّ فَرْقٌ':Subject, #1: 1	ثَمَّ الْفَرْقُ
u'ثَمَّ فَرْقٌ':Subject, #1: 1	ثَمَّ الْفَرْقُ
u'ثَمَّ فَسْخٌ':Subject, #2: 2	ثَمَّ فَرْقٌ
u'ثَمَّ فَصٌّ':Subject, #1: 1	ثَمَّ الْفَسْخُ
u'ثَمَّ فَيْءٌ':Subject, #1: 1	ثَمَّ فَصٌّ
u'ثَمَّ قَالٌ':Predicate, #1: 1	ثَمَّ فَيْءٌ
u'ثَمَّ قِرَاءةٌ':Predicate, #166: 166	ثَمَّ قَالَ
u'ثَمَّ قَرْضٌ':Subject, #1: 1	ثَمَّ قِرَاءَةَ
u'ثَمَّ قَسَمٌ':Subject, #1: 1	ثَمَّ قَرْضٌ
u'ثَمَّ قِسْمٌ':Subject, #1: 1	ثَمَّ قَسَمٌ
u'ثَمَّ قَطْرَةٌ':Subject, #2: 2	ثَمَّ قِسْمٌ
u'ثَمَّ قَطْعٌ':Subject, #1: 1	ثَمَّ قَطْرَةٌ
u'ثَمَّ قَلِيلٌ':Subject, #2: 2	ثَمَّ الْقَطْعُ
u'ثَمَّ قَوَاسِمُ':Subject, #1: 1	ثَمَّ قَلِيلُ
u'ثَمَّ قول':Predicate, #1: 1	ثَمَّ قَوَاسِمُ
u'ثَمَّ قَوْلٌ':Predicate, #1: 1	ثَمَّ الْقَوْلَ
u'ثَمَّ قول':Subject, #1: 1	ثَمَّ الْقَوْلَ
u'ثَمَّ قَوْلٌ':Subject, #1: 1	ثَمَّ قَوْلُهُ
u'ثَمَّ قَوْلٌ':Subject, #1: 1	ثَمَّ قَوْلُهُ
u'ثَمَّ قِيَاسٌ':Subject, #2: 2	ثَمَّ قَوْلٌ
u'ثَمَّ قيام':Subject, #1: 1	ثَمَّ قِيَاسٌ
u'ثَمَّ قِيَامٌ':Subject, #1: 1	ثَمَّ قِيَامُ
u'ثَمَّ كَرِهٌ':Predicate, #1: 1	ثَمَّ قِيَامُ
u'ثَمَّ كِنَايَةٌ':Subject, #1: 1	ثَمَّ كَرِهَ
u'ثَمَّ لاَزِمٌ':Subject, #1: 1	ثَمَّ كِنَايَةٌ
u'ثَمَّ لاَزِمَة':Subject, #1: 1	ثَمَّ لَازِمَةٌ
u'ثَمَّ لَطْخٌ':Subject, #1: 1	ثَمَّ لَازِمَةٌ
u'ثَمِلَ قَوْمٌ':Subject, #2: 2	ثَمَّ لَطْخٌ
u'ثَمَّ لَوْمٌ':Subject, #1: 1	ثَمِلَ الْقَوْمُ
u'ثَمَّ مَاءٌ':Subject, #1: 1	ثَمَّ لَوْمٌ
u'ثَمَّ مَالٌ':Predicate, #1: 1	ثَمَّ مَاءٌ
u'ثَمَّ مَالٌ':Subject, #1: 1	ثَمَّ مَالَ
u'ثَمَّ مَالِيٌّ':Subject, #5: 5	ثَمَّ مَالٌ
u'ثَمَّ مَانِعٌ':Subject, #1: 1	ثَمَّ مَالِيَّةُ
u'ثَمَّ مُبَالَغَةٌ':Subject, #6: 6	ثَمَّ مَانِعٌ
u'ثَمَّ مَبِيعٌ':Subject, #1: 1	ثَمَّ الْمُبَالَغَةُ
u'ثَمَّ مُتَبَرِّعٌ':Subject, #1: 1	ثَمَّ مَبِيعٌ
u'ثَمَّ مُتْعَةٌ':Subject, #1: 1	ثَمَّ مُتَبَرِّعٌ
u'ثَمَّ مُتَعَلِّقٌ':Subject, #1: 1	ثَمَّ مُتْعَةُ
u'ثَمَّ مُتَمَكِّنٌ':Subject, #1: 1	ثَمَّ مُتَعَلِّقَةٌ
u'ثَمَّ مَحَارِمُ':Subject, #1: 1	ثَمَّ مُتَمَكِّنٌ
u'ثَمَّ مَحْرَمٌ':Subject, #2: 2	ثَمَّ مَحَارِمُ
u'ثَمَّ مَحَلٌّ':Subject, #1: 1	ثَمَّ مَحْرَمٌ
u'ثَمَّ مَحَلٌّ':Subject, #1: 1	ثَمَّ مَحَلُّ
u'ثَمَّ مَحْمُولٌ':Subject, #1: 1	ثَمَّ مَحَلُّهُ
u'ثَمَّ مرٌّ':Predicate, #1: 1	ثَمَّ مَحْمُولَةٌ
u'ثَمَّ مَرٌّ':Predicate, #1: 1	ثَمَّ مَرَّ
u'ثَمَّ مراد':Subject, #1: 1	ثَمَّ مَرَّ
u'ثَمَّ مُرَادٌ':Subject, #2: 2	ثَمَّ مُرَادٌ
u'ثَمَّ مُرْضِعٌ':Subject, #2: 2	ثَمَّ مُرَادٌ
u'ثَمَّ مُزَاحَمَةٌ':Subject, #1: 1	ثَمَّ مُرْضِعَةٌ
u'ثَمَّ مَزِيدٌ':Subject, #1: 1	ثَمَّ مُزَاحَمَةٌ
u'ثَمَّ مُسْتَحِقٌّ':Subject, #2: 2	ثَمَّ مَزِيدُ
u'ثَمَّ مَسْجِدٌ':Subject, #1: 1	ثَمَّ مُسْتَحِقٌّ
u'ثَمَّ مُسْلِمٌ':Subject, #1: 1	ثَمَّ مَسْجِدٌ
u'ثَمَّ مَشَقَّةٌ':Subject, #1: 1	ثَمَّ مُسْلِمٌ
u'ثَمَّ مَشْيٌ':Subject, #1: 1	ثَمَّ مَشَقَّةٌ
u'ثَمَّ مُصَرِّحٌ':Subject, #1: 1	ثَمَّ الْمَشْيُ
u'ثَمَّ مَصْرِفٌ':Subject, #1: 1	ثَمَّ مُصَرِّحٌ
u'ثَمَّ مُصِيبٌ':Subject, #2: 2	ثَمَّ مَصْرِفٌ
u'ثَمَّ مُصِيبَةٌ':Subject, #1: 1	ثَمَّ مُصِيبَةٌ
u'ثَمَّ مُعارِضٌ':Subject, #1: 1	ثَمَّ مُصِيبَةٌ
u'ثَمَّ مُعَاوَنَةٌ':Predicate, #2: 2	ثَمَّ مُعَارِضٌ
u'ثَمَّ مُعْتَبَرٌ':Subject, #1: 1	ثَمَّ مُعَاوَنَةَ
u'ثَمَّ مَعْرِضٌ':Subject, #1: 1	ثَمَّ الْمُعْتَبَرُ
u'ثَمَّ مَعْصِيَةٌ':Subject, #1: 1	ثَمَّ مَعْرِضُ
u'ثَمَّ مُعَلَّقٌ':Subject, #1: 1	ثَمَّ مَعْصِيَةٌ
u'ثَمَّ مَعْهُودٌ':Subject, #1: 1	ثَمَّ مُعَلَّقٌ
u'ثَمَّ مُعَيَّنٌ':Subject, #3: 3	ثَمَّ مَعْهُودٌ
u'ثَمَّ مَفْعُولٌ':Subject, #1: 1	ثَمَّ الْمُعَيَّنُ
u'ثَمَّ مُقَدَّمٌ':Subject, #1: 1	ثَمَّ مَفْعُولٌ
u'ثَمَّ مُقَصِّرٌ':Subject, #1: 1	ثَمَّ مُقَدَّمَةٌ
u'ثَمَّ مَقْصُودٌ':Subject, #1: 1	ثَمَّ مُقَصِّرٌ
u'ثَمَّ مِلَّةٌ':Subject, #1: 1	ثَمَّ مَقْصُودٌ
u'ثَمَّ مِلْكٌ':Subject, #1: 1	ثَمَّ مِلَّةٌ
u'ثَمَّ مُمْكِنٌ':Subject, #1: 1	ثَمَّ مِلْكٌ
u'ثَمَّ مُمْكِن':Subject, #1: 1	ثَمَّ مُمْكِنٌ
u'ثَمَّ مُمْكِنٌ':Subject, #1: 1	ثَمَّ مُمْكِنٌ
u'ثَمَّ مُنَاسَبَةٌ':Subject, #1: 1	ثَمَّ مُمْكِنَةٌ
u'ثَمَّ مَنَافِعُ':Subject, #1: 1	ثَمَّ مُنَاسَبَةٌ
u'ثَمَّ مَنْعٌ':Subject, #1: 1	ثَمَّ مَنَافِعُ
u'ثَمَّ مَنْفَذٌ':Subject, #1: 1	ثَمَّ مَنْعُ
u'ثَمَّ مَنْفِيٌّ':Subject, #1: 1	ثَمَّ مَنْفَذٌ
u'ثَمَّ مُوَافَقَةٌ':Subject, #1: 1	ثَمَّ مَنْفِيٌّ
u'ثَمَّ مَوْجُودٌ':Subject, #1: 1	ثَمَّ مُوَافَقَةٌ
u'ثَمَّ مُؤَلَّفٌ':Subject, #1: 1	ثَمَّ مَوْجُودٌ
u'ثَمَّ نِساءٌ':Subject, #1: 1	ثَمَّ مُؤَلَّفَةٌ
u'ثَمَّ نَسَبٌ':Predicate, #1: 1	ثَمَّ نِسَاءٌ
u'ثَمَّ نسج':Predicate, #1: 1	ثَمَّ نَسَبَ
u'ثَمَّ نَشَأٌ':Predicate, #1: 1	ثَمَّ نَسَجَ
u'ثَمَّ نَصٌّ':Predicate, #2: 2	ثَمَّ نَشَأَ
u'ثَمَّ نَصٌّ':Subject, #1: 1	ثَمَّ نَصَّ
u'ثَمَّ نَظَرٌ':Predicate, #4: 4	ثَمَّ نَصٌّ
u'ثَمَّ نَظَرٌ':Predicate, #1: 1	ثَمَّ النَّظَرَ
u'ثَمَنَ غَزْلٌ':Predicate, #1: 1	ثَمَّ نَظَرَ
u'ثَمَّ نفر':Predicate, #1: 1	ثَمَنَ الْغَزْلَ
u'ثَمَّ نَفَرٌ':Predicate, #2: 2	ثَمَّ نَفَرَ
u'ثَمَّ نَفْسٌ':Subject, #2: 2	ثَمَّ نَفَرَ
u'ثَمَّ نقل':Predicate, #1: 1	ثَمَّ نَفْسُ
u'ثَمَّ نَقَلٌ':Predicate, #3: 3	ثَمَّ نَقَلَ
u'ثَمَّ نَقْلٌ':Subject, #3: 3	ثَمَّ نَقَلَ
u'ثَمَّ نكاح':Subject, #1: 1	ثَمَّ نَقْلٌ
u'ثَمَّ نِكَاحٌ':Subject, #1: 1	ثَمَّ نِكَاحٌ
u'ثَمَنَ مَعْلُومٌ':Subject, #1: 1	ثَمَّ نِكَاحٌ
u'ثَمَّ نِيَّةٌ':Subject, #3: 3	ثَمَنَ مَعْلُومٌ
u'ثَمَّ هَامَةٌ':Subject, #1: 1	ثَمَّ نِيَّةٌ
u'ثَمَّ وَاجِبٌ':Predicate, #1: 1	ثَمَّ هَامَةٌ
u'ثَمَّ وَاجِبٌ':Subject, #1: 1	ثَمَّ الْوَاجِبَ
u'ثَمَّ واحد':Subject, #1: 1	ثَمَّ الْوَاجِبُ
u'ثَمَّ وَاحِدٌ':Subject, #2: 2	ثَمَّ وَاحِدَةٌ
u'ثَمَّ وَارِثٌ':Subject, #2: 2	ثَمَّ وَاحِدَةٌ
u'ثَمَّ وَاعِظٌ':Subject, #4: 4	ثَمَّ وَارِثٌ
u'ثَمَّ وَجَبٌ':Predicate, #1: 1	ثَمَّ وَاعِظٌ
u'ثَمَّ وَجْهٌ':Subject, #6: 6	ثَمَّ وَجَبَ
u'ثَمَّ وُجُودٌ':Subject, #1: 1	ثَمَّ وَجْهُ
u'ثَمَّ وَرَقَةٌ':Subject, #2: 2	ثَمَّ وُجُودُ
u'ثَمَّ وَصْفٌ':Subject, #1: 1	ثَمَّ وَرَقَةٌ
u'ثَمَّ وَصِيٌّ':Subject, #1: 1	ثَمَّ وَصْفٌ
u'ثَمَّ وقع':Predicate, #2: 2	ثَمَّ وَصِيٌّ
u'ثَمَّ وَقْفٌ':Subject, #4: 4	ثَمَّ وَقَعَ
u'ثَمَّ وَلَدٌ':Subject, #1: 1	ثَمَّ وَقْفٌ
u'ثَنَّى أَوَّلُ':Predicate, #5: 5	ثَمَّ وَلَدٌ
u'ثَنَّى بَعْضٌ':Subject, #1: 1	ثَنَّى الْأَوَّلَ
u'ثَنَّى تَوْصِيَةٌ':Predicate, #1: 1	ثَنَّى بَعْضُ
u'ثَنَّى حُكْمٌ':Predicate, #1: 1	ثَنَّى التَّوْصِيَةَ
u'ثَنَّى ضَمِيرٌ':Predicate, #1: 1	ثَنَّى الْحُكْمَ
u'ثَنَى فَرَسٌ':Subject, #1: 1	ثَنَّى الضَّمِيرَ
u'ثَنَّى لَفْظٌ':Predicate, #1: 1	ثَنَى الْفَرَسُ
u'ثَنَّى مُحْرِمٌ':Subject, #1: 1	ثَنَّى اللَّفْظَ
u'ثَنَّى مُصَنِّفٌ':Subject, #1: 1	ثَنَّى الْمُحْرِمُ
u'ثَنَّى مُؤَذِّنٌ':Subject, #1: 1	ثَنَّى الْمُصَنِّفُ
u'ثَنَّى وَاجِبٌ':Predicate, #1: 1	ثَنَّى الْمُؤَذِّنُ
u'ثَوَّبَ اِبْنٌ':Subject, #1: 1	ثَنَّى الْوَاجِبَ
u'ثَوَّبَ مُؤَذِّنٌ':Subject, #1: 1	ثَوَّبَ ابْنُ
u'ثَوَرَانٌ حُمْرَةٌ':Added, #1: 1	ثَوَّبَ الْمُؤَذِّنُ
u'ثَوَرَانٌ شَهْوَةٌ':Added, #1: 1	ثَوَرَان حُمْرَتِهِ
u'ثَوَرَانٌ طِبَاعٌ':Added, #5: 5	ثَوَرَانَ الشَّهْوَةِ
u'ثَوَى بَيْنٌ':Predicate, #1: 1	ثَوَرَانُ الطِّبَاعِ
u'ثَوَى يَوْمٌ':Predicate, #1: 1	ثَوَى بَيْنَ
u'جَاءَ أَبٌ':Subject, #1: 1	ثَوَى يَوْمَ
u'جَاءَ اِبْنٌ':Predicate, #1: 1	جَاءَ الْأَبُ
u'جَاءَ اِبْنٌ':Subject, #4: 4	جَاءَ ابْنَ
u'جَاءَ اِبْنٌ':Subject, #2: 2	جَاءَ ابْنُهُ
u'جَاءَ أثَرٌ':Subject, #7: 7	جَاءَ ابْنُ
u'جَاءَ أثَرٌ':Subject, #3: 3	جَاءَ أَثَرٌ
u'جَاءَ إِجْبَارٌ':Subject, #9: 9	جَاءَ الْأَثَرُ
u'جَاءَ أَجَلٌ':Subject, #1: 1	جَاءَ الْإِجْبَارُ
u'جَاءَ أَجَلٌ':Subject, #1: 1	جَاءَ أَجَلُ
u'جَاءَ أَجَلٌ':Subject, #1: 1	جَاءَ أَجَلُهُ
u'جَاءَ أَجَلٌ':Subject, #1: 1	جَاءَ الأَجَلُ
u'جَاءَ أَجْنَبِيٌّ':Subject, #1: 1	جَاءَ الْأَجَلُ
u'جَاءَ أحَدٌ':Subject, #2: 2	جَاءَ أَجْنَبِيٌّ
u'جَاءَ أحَدٌ':Subject, #41: 41	جَاءَ أَحَدٌ
u'جَاءَ اِخْتِلاَفٌ':Subject, #6: 6	جَاءَ أَحَدُ
u'جَاءَ اِخْتِيَارٌ':Subject, #1: 1	جَاءَ اخْتِلَافٌ
u'جَاءَ آخِرُ':Predicate, #1: 1	جَاءَ اخْتِيَارُ
u'جَاءَ آخِرُ':Subject, #2: 2	جَاءَ آخِرَ
u'جَاءَ إِذْنٌ':Subject, #1: 1	جَاءَ آخِرُ
u'جَاءَ أَرْبَعَةٌ':Subject, #1: 1	جَاءَ الْإِذْنُ
u'جَاءَ أَساقِفَةٌ':Subject, #3: 3	جَاءَ أَرْبَعَةٌ
u'جَاءَ اِسْتِعْمالٌ':Subject, #1: 1	جَاءَ الْأَسَاقِفَةُ
u'جَاءَ أَسَدٌ':Subject, #2: 2	جَاءَ اسْتِعْمَالُهُ
u'جَاءَ إِسْلامٌ':Subject, #1: 1	جَاءَ الْأَسَدُ
u'جَاءَ إِسْلامٌ':Subject, #14: 14	جَاءَ الْإِسْلَامُ
u'جَاءَ إِسْلامٌ':Subject, #1: 1	جَاءَ الإِسْلامُ
u'جَاءَ أَشْعَث':Predicate, #4: 4	جَاءَ الإِسْلاَمُ
u'جَاءَ إِشْكالٌ':Subject, #2: 2	جَاءَ أَشْعَثَ
u'جَاءَ أَصْحَابٌ':Subject, #2: 2	جَاءَ الْإِشْكَالُ
u'جَاءَ أَصْحَابٌ':Subject, #1: 1	جَاءَ أَصْحَابُهُ
u'جَاءَ أصل':Subject, #2: 2	جَاءَ أَصْحَابُ
u'جَاءَ أًصْلٌ':Subject, #1: 1	جَاءَ الْأَصْلُ
u'جَاءَ أُصولٌ':Subject, #1: 1	جَاءَ الْأَصْلُ
u'جَاءَ أَعْدَاءٌ':Subject, #3: 3	جَاءَ الْأُصُولُ
u'جَاءَ أَعْرابٌ':Subject, #1: 1	جَاءَ أَعْدَاءُ
u'جَاءَ أعْرَابِيٌّ':Subject, #1: 1	جَاءَ الأَعْرَابُ
u'جَاءَ إعْصَارٌ':Subject, #14: 14	جَاءَ أَعْرَابِيٌّ
u'جَاءَ أَكْثَرُ':Predicate, #1: 1	جَاءَ إعْصَارٌ
u'جَاءَ أكل':Predicate, #1: 1	جَاءَ أَكْثَرَ
u'جَاءَ إمَامٌ':Subject, #1: 1	جَاءَ أَكَلَ
u'جَاءَ أَمْرٌ':Subject, #7: 7	جَاءَ الْإِمَامُ
u'جَاءَ أَمْرٌ':Subject, #1: 1	جَاءَ أَمْرٌ
u'جَاءَ أَمْرٌ':Subject, #2: 2	جَاءَ أَمْرُ
u'جَاءَ أَميرٌ':Subject, #4: 4	جَاءَ الْأَمْرُ
u'جَاءَ أُناسٌ':Subject, #1: 1	جَاءَ الْأَمِيرُ
u'جَاءَ إِنْسانٌ':Subject, #1: 1	جَاءَ أُنَاسٌ
u'جَاءَ إِنْسانٌ':Subject, #18: 18	جَاءَ إنْسَانٌ
u'جَاءَ أنصار':Predicate, #2: 2	جَاءَ إِنْسَانٌ
u'جَاءَ أَنْصارٌ':Predicate, #1: 1	جَاءَ الْأَنْصَارَ
u'جَاءَ أَنْصَارٌ':Predicate, #1: 1	جَاءَ الْأَنْصَارَ
u'جَاءَ أهْلٌ':Subject, #1: 1	جَاءَ الْأَنْصَارَ
u'جَاءَ أهْلٌ':Subject, #1: 1	جَاءَ أَهْلُهُ
u'جَاءَ أوَانٌ':Subject, #3: 3	جَاءَ أَهْلُ
u'جَاءَ أوَانٌ':Subject, #17: 17	جَاءَ أَوَانُ
u'جَاءَ أَوَّلُ':Subject, #3: 3	جَاءَ أَوَانُهُ
u'جَاءَ أَوَّلُ':Subject, #1: 1	جَاءَ الأَوَّلُ
u'جَاءَ أَوَّلُ':Subject, #1: 1	جَاءَ أَوَّلُ
u'جَاءَ أَوْلِيَاءُ':Subject, #4: 4	جَاءَ الْأَوَّلُ
u'جَاءَ أيَّامٌ':Predicate, #1: 1	جَاءَ أَوْلِيَاءُ
u'جَاءَ أَيَّامٌ':Predicate, #3: 3	جَاءَ أَيَّامَ
u'جَاءَ بَائِعٌ':Subject, #3: 3	جَاءَ أَيَّامَ
u'جَاءَ بَائِعٌ':Subject, #1: 1	جَاءَ بَائِعُ
u'جَاءَ بَائِعٌ':Subject, #2: 2	جَاءَ بَائِعُهُ
u'جَاءَ بَرْدٌ':Subject, #5: 5	جَاءَ الْبَائِعُ
u'جَاءَ بُسْتانٌ':Subject, #1: 1	جَاءَ الْبَرْدُ
u'جَاءَ بَشيرٌ':Subject, #1: 1	جَاءَ بُسْتَانُ
u'جَاءَ بَعْضٌ':Subject, #5: 5	جَاءَ بَشِيرُ
u'جَاءَ بُنْيانٌ':Subject, #3: 3	جَاءَ بَعْضُ
u'جَاءَ بَيَانٌ':Subject, #1: 1	جَاءَ بُنْيَانُهُ
u'جَاءَ بَيَانٌ':Subject, #1: 1	جَاءَ بَيَانُ
u'جَاءَ بَيْتٌ':Predicate, #2: 2	جَاءَ الْبَيَانُ
u'جَاءَ بَيْتٌ':Predicate, #1: 1	جَاءَ بَيْتَ
u'جَاءَ تَأْكِيدٌ':Subject, #6: 6	جَاءَ الْبَيْتَ
u'جَاءَ تَحَالُفٌ':Subject, #1: 1	جَاءَ التَّأْكِيدُ
u'جَاءَ تَحْرِيضٌ':Subject, #1: 1	جَاءَ التَّحَالُفُ
u'جَاءَ تَرْتِيبٌ':Subject, #1: 1	جَاءَ التَّحْرِيضُ
u'جَاءَ تَرْغِيبٌ':Subject, #1: 1	جَاءَ التَّرْتِيبُ
u'جَاءَ تَسْمِيَة':Subject, #1: 1	جَاءَ تَرْغِيبٌ
u'جَاءَ تَسْمِيَة':Subject, #1: 1	جَاءَ تَسْمِيَتُهُ
u'جَاءَ تَصْرِيحٌ':Subject, #2: 2	جَاءَ تَسْمِيَةُ
u'جَاءَ تَفاوُت':Subject, #1: 1	جَاءَ التَّصْرِيحُ
u'جَاءَ تَفْسِيرٌ':Subject, #1: 1	جَاءَ التَّفَاوُتُ
u'جَاءَ تَفْصِيلٌ':Subject, #1: 1	جَاءَ التَّفْسِيرُ
u'جَاءَ تَقْديرٌ':Subject, #1: 1	جَاءَ التَّفْصِيلُ
u'جَاءَ تَقْصيرٌ':Subject, #1: 1	جَاءَ التَّقْدِيرُ
u'جَاءَ تَقْيِيد':Subject, #1: 1	جَاءَ التَّقْصِيرُ
u'جَاءَ تَلْفيقٌ':Subject, #1: 1	جَاءَ تَقْيِيدُهُ
u'جَاءَ تَنَاقُضٌ':Subject, #1: 1	جَاءَ تَلْفِيقُ
u'جَاءَ تَنْبِيه':Subject, #1: 1	جَاءَ التَّنَاقُضُ
u'جَاءَ ثَابِتٌ':Subject, #1: 1	جَاءَ التَّنْبِيهُ
u'جَاءَ ثَابِتٌ':Subject, #1: 1	جَاءَ ثَابِتٌ
u'جَاءَ ثَالِثٌ':Subject, #2: 2	جَاءَ ثَابِتُ
u'جَاءَ ثَالِثٌ':Subject, #4: 4	جَاءَ الثَّالِثُ
u'جَاءَ ثَامِنٌ':Subject, #4: 4	جَاءَ ثَالِثٌ
u'جَاءَ ثَبْتٌ':Subject, #1: 1	جَاءَ الثَّامِنُ
u'جَاءَ ثَعْلَبٌ':Subject, #1: 1	جَاءَ الثَّبْتُ
u'جَاءَ ثَلاثُ':Predicate, #1: 1	جَاءَ ثَعْلَبٌ
u'جَاءَ ثَلاثَةٌ':Subject, #1: 1	جَاءَ ثَلَاثَ
u'جَاءَ ثَلاثَةٌ':Subject, #2: 2	جَاءَ ثَلَاثَةُ
u'جَاءَ جَابِرٌ':Subject, #4: 4	جَاءَ ثَلاَثَةُ
u'جَاءَ جَازٌ':Predicate, #1: 1	جَاءَ جَابِرُ
u'جَاءَ جَبَّارٌ':Subject, #1: 1	جَاءَ جَازَ
u'جَاءَ جَمَاعَةٌ':Subject, #1: 1	جَاءَ جَبَّارُ
u'جَاءَ جمع':Subject, #1: 1	جَاءَ جَمَاعَةٌ
u'جَاءَ جَمْعٌ':Subject, #1: 1	جَاءَ الْجَمْعُ
u'جَاءَ جمعة':Predicate, #1: 1	جَاءَ الْجَمْعُ
u'جَاءَ جُمُعَةٌ':Predicate, #1: 1	جَاءَ الْجُمُعَةَ
u'جَاءَ جهل':Subject, #1: 1	جَاءَ الْجُمُعَةَ
u'جَاءَ جَهْلٌ':Subject, #1: 1	جَاءَ الْجَهْلُ
u'جَاءَ جَيْشٌ':Subject, #1: 1	جَاءَ الْجَهْلُ
u'جَاءَ حاجِبٌ':Subject, #1: 1	جَاءَ جَيْشٌ
u'جَاءَ حارِثٌ':Subject, #1: 1	جَاءَ حَاجِبُهُ
u'جَاءَ حاطِبٌ':Subject, #1: 1	جَاءَ الْحَارِثُ
u'جَاءَ حاكِمٌ':Subject, #1: 1	جَاءَ حَاطِبٌ
u'جَاءَ حائِكٌ':Subject, #2: 2	جَاءَ حَاكِمٌ
u'جَاءَ حَبْرٌ':Subject, #1: 1	جَاءَ الْحَائِكُ
u'جَاءَ حَجٌّ':Subject, #2: 2	جَاءَ حَبْرٌ
u'جَاءَ حَديثٌ':Subject, #1: 1	جَاءَ الْحَجُّ
u'جَاءَ حَرْفٌ':Subject, #10: 10	جَاءَ الْحَدِيثُ
u'جَاءَ حَسَنٌ':Subject, #1: 1	جَاءَ حَرْفُ
u'جَاءَ حِشْمَةٌ':Subject, #3: 3	جَاءَ الْحَسَنُ
u'جَاءَ حَقٌّ':Subject, #1: 1	جَاءَ الْحِشْمَةُ
u'جَاءَ حَقٌّ':Subject, #1: 1	جَاءَ حَقُّ
u'جَاءَ حَكِيمٌ':Subject, #3: 3	جَاءَ الْحَقُّ
u'جَاءَ حَلالٌ':Subject, #1: 1	جَاءَ الْحَكِيمُ
u'جَاءَ حَمْز':Subject, #1: 1	جَاءَ الْحَلَالُ
u'جَاءَ حَنْبَلٌ':Subject, #1: 1	جَاءَ حَمْزَةُ
u'جَاءَ حول':Subject, #1: 1	جَاءَ حَنْبَلٌ
u'جَاءَ حَوْلٌ':Subject, #2: 2	جَاءَ الْحَوْلُ
u'جَاءَ خَادِمٌ':Subject, #2: 2	جَاءَ الْحَوْلُ
u'جَاءَ خَارِجٌ':Predicate, #1: 1	جَاءَ خَادِمُ
u'جَاءَ خَالِدٌ':Subject, #1: 1	جَاءَ خَارِجَ
u'جَاءَ خَبَرٌ':Subject, #1: 1	جَاءَ خَالِدُ
u'جَاءَ خَبَر':Subject, #1: 1	جَاءَ خَبَرٌ
u'جَاءَ خَبَرٌ':Subject, #1: 1	جَاءَ خَبَرٌ
u'جَاءَ خَبَر':Subject, #3: 3	جَاءَ خَبَرُ
u'جَاءَ خَبَرٌ':Subject, #3: 3	جَاءَ خَبَرُ
u'جَاءَ خَبَر':Subject, #6: 6	جَاءَ الْخَبَرُ
u'جَاءَ خِذْلاَنٌ':Subject, #6: 6	جَاءَ الْخَبَرُ
u'جَاءَ خِطَابٌ':Subject, #1: 1	جَاءَ الْخِذْلَانُ
u'جَاءَ خِلاَفٌ':Subject, #1: 1	جَاءَ الْخِطَابُ
u'جَاءَ خَمِيسٌ':Subject, #9: 9	جَاءَ الْخِلَافُ
u'جَاءَ خَوْفٌ':Subject, #1: 1	جَاءَ الْخَمِيسُ
u'جَاءَ خَيَّاطٌ':Subject, #1: 1	جَاءَ الْخَوْفُ
u'جَاءَ خَيَالٌ':Subject, #1: 1	جَاءَ الْخَيَّاطُ
u'جَاءَ دَاخِلٌ':Subject, #1: 1	جَاءَ الْخَيَالُ
u'جَاءَ دَافِعٌ':Subject, #1: 1	جَاءَ الدَّاخِلُ
u'جَاءَ دَخَلٌ':Predicate, #1: 1	جَاءَ الدَّافِعُ
u'جَاءَ دُعَاءٌ':Subject, #1: 1	جَاءَ دَخَلَ
u'جَاءَ دَليلٌ':Subject, #1: 1	جَاءَ الدُّعَاءُ
u'جَاءَ دَمٌ':Subject, #1: 1	جَاءَ دَلِيلُ
u'جَاءَ دَوْرٌ':Subject, #2: 2	جَاءَ الدَّمُ
u'جَاءَ ذكر':Subject, #1: 1	جَاءَ الدَّوْرُ
u'جَاءَ ذِكْرٌ':Subject, #10: 10	جَاءَ ذِكْرُ
u'جَاءَ ذَكَرٌ':Subject, #10: 10	جَاءَ ذِكْرُ
u'جَاءَ ذكر':Subject, #1: 1	جَاءَ ذَكَرٌ
u'جَاءَ ذِكْرٌ':Subject, #6: 6	جَاءَ ذِكْرُهُ
u'جَاءَ ذِمِّيٌّ':Subject, #6: 6	جَاءَ ذِكْرُهُ
u'جَاءَ ذِئْبٌ':Subject, #1: 1	جَاءَ ذِمِّيٌّ
u'جَاءَ رَأْسٌ':Subject, #1: 1	جَاءَ الذِّئْبُ
u'جَاءَ رَافِعٌ':Subject, #53: 53	جَاءَ رَأْسُ
u'جَاءَ رَاكِبٌ':Subject, #1: 1	جَاءَ رَافِعُ
u'جَاءَ رَاهِنٌ':Subject, #1: 1	جَاءَ رَاكِبٌ
u'جَاءَ رَبُّ':Subject, #2: 2	جَاءَ الرَّاهِنُ
u'جَاءَ رَبُّ':Subject, #2: 2	جَاءَ رَبُّهُ
u'جَاءَ رِجَالٌ':Subject, #4: 4	جَاءَ رَبُّ
u'جَاءَ رَجَبٌ':Subject, #1: 1	جَاءَ رِجَالٌ
u'جَاءَ رَجُلٌ':Subject, #1: 1	جَاءَ رَجَبٌ
u'جَاءَ رَجُلٌ':Subject, #1: 1	جَاءَ الرّجُلُ
u'جَاءَ رَجُلٌ':Subject, #398: 398	جَاءَ رَجُلٌ
u'جَاءَ رَسُولٌ':Predicate, #9: 9	جَاءَ الرَّجُلُ
u'جَاءَ رَسُولٌ':Subject, #7: 7	جَاءَ رَسُولَ
u'جَاءَ رَسُولٌ':Subject, #1: 1	جَاءَ رَسُولُهُ
u'جَاءَ رَسُولٌ':Subject, #27: 27	جَاءَ رَسُولُ
u'جَاءَ رَكْبٌ':Subject, #2: 2	جَاءَ الرَّسُولُ
u'جَاءَ رَمَضانُ':Subject, #1: 1	جَاءَ رَكْبٌ
u'جَاءَ رَمَضانُ':Subject, #18: 18	جَاءَ رَمَضَانُ
u'جَاءَ زَارِعٌ':Subject, #1: 1	جَاءَ الرَّمَضَانُ
u'جَاءَ زَمانٌ':Subject, #1: 1	جَاءَ الزَّارِعُ
u'جَاءَ زَمَنٌ':Subject, #4: 4	جَاءَ زَمَانُ
u'جَاءَ زِنْديقٌ':Subject, #1: 1	جَاءَ الزَّمَنُ
u'جَاءَ زَوْجٌ':Subject, #1: 1	جَاءَ الزِّنْدِيقُ
u'جَاءَ زَيْدٌ':Subject, #4: 4	جَاءَ الزَّوْجُ
u'جَاءَ زَيْدٌ':Subject, #2: 2	جَاءَ زَيْدُ
u'جَاءَ سائِل':Subject, #45: 45	جَاءَ زَيْدٌ
u'جَاءَ سَائِلٌ':Subject, #1: 1	جَاءَ السَّائِلُ
u'جَاءَ سائِل':Subject, #1: 1	جَاءَ السَّائِلُ
u'جَاءَ سَائِلٌ':Subject, #2: 2	جَاءَ سَائِلٌ
u'جَاءَ سَعْدٌ':Subject, #2: 2	جَاءَ سَائِلٌ
u'جَاءَ سَمَاعٌ':Subject, #3: 3	جَاءَ سَعْدٌ
u'جَاءَ سَنَدٌ':Subject, #1: 1	جَاءَ السَّمَاعُ
u'جَاءَ سَهْلٌ':Subject, #1: 1	جَاءَ السَّنَدُ
u'جَاءَ سُهَيْلٌ':Subject, #2: 2	جَاءَ سَهْلُ
u'جَاءَ سُهَيْلٌ':Subject, #1: 1	جَاءَ سُهَيْلٌ
u'جَاءَ سُوقٌ':Predicate, #3: 3	جَاءَ سُهَيْلُ
u'جَاءَ سُوقٌ':Predicate, #1: 1	جَاءَ السُّوقَ
u'جَاءَ سَيِّدٌ':Subject, #1: 1	جَاءَ سُوقَ
u'جَاءَ سَيِّدٌ':Subject, #3: 3	جَاءَ السَّيِّدُ
u'جَاءَ سَيْل':Subject, #6: 6	جَاءَ سَيِّدُهُ
u'جَاءَ سَيْل':Subject, #1: 1	جَاءَ السَّيْلُ
u'جَاءَ شَابٌّ':Subject, #2: 2	جَاءَ سَيْلٌ
u'جَاءَ شافِعِيّ':Subject, #1: 1	جَاءَ شَابٌّ
u'جَاءَ شَبابٌ':Subject, #1: 1	جَاءَ الشَّافِعِيُّ
u'جَاءَ شَبَابٌ':Subject, #1: 1	جَاءَ الشَّبَابُ
u'جَاءَ شِتَاءٌ':Subject, #1: 1	جَاءَ الشَّبَابُ
u'جَاءَ شَخْصٌ':Subject, #2: 2	جَاءَ الشِّتَاءُ
u'جَاءَ شَرٌّ':Subject, #1: 1	جَاءَ شَخْصٌ
u'جَاءَ شَرْطٌ':Subject, #1: 1	جَاءَ شَرُّهُ
u'جَاءَ شَرْعٌ':Subject, #3: 3	جَاءَ الشَّرْطُ
u'جَاءَ شَرِيكٌ':Subject, #11: 11	جَاءَ الشَّرْعُ
u'جَاءَ شَفِيعٌ':Subject, #2: 2	جَاءَ شَرِيكُهُ
u'جَاءَ شَفِيعٌ':Subject, #1: 1	جَاءَ شَفِيعُ
u'جَاءَ شَهْرٌ':Subject, #20: 20	جَاءَ الشَّفِيعُ
u'جَاءَ شَهْرٌ':Subject, #1: 1	جَاءَ شَهْرٌ
u'جَاءَ شَهْرٌ':Subject, #2: 2	جَاءَ الشَّهْرُ
u'جَاءَ شُهُودٌ':Subject, #6: 6	جَاءَ شَهْرُ
u'جَاءَ شُهُودٌ':Subject, #2: 2	جَاءَ الشُّهُودُ
u'جَاءَ شَيْءٌ':Subject, #2: 2	جَاءَ شُهُودُ
u'جَاءَ شَيْءٌ':Subject, #1: 1	جَاءَ الشَّيْءُ
u'جَاءَ شَيْخٌ':Subject, #1: 1	جَاءَ شَيْءٌ
u'جَاءَ شَيْخٌ':Subject, #1: 1	جَاءَ شَيْخٌ
u'جَاءَ شَيْطَانٌ':Subject, #3: 3	جَاءَ الشَّيْخُ
u'جَاءَ صَاحِبٌ':Subject, #1: 1	جَاءَ الشَّيْطَانُ
u'جَاءَ صَاحِبٌ':Subject, #21: 21	جَاءَ صَاحِبُ
u'جَاءَ صَرِيحٌ':Subject, #9: 9	جَاءَ صَاحِبُهُ
u'جَاءَ صَهْبَاء':Predicate, #3: 3	جَاءَ الصَّرِيحُ
u'جَاءَ صَيْفٌ':Subject, #1: 1	جَاءَ الصّهْبَاءَ
u'جَاءَ ضَرَرٌ':Subject, #4: 4	جَاءَ الصَّيْفُ
u'جَاءَ ضَرُورَةٌ':Predicate, #1: 1	جَاءَ الضَّرَرُ
u'جَاءَ ضَيْفٌ':Subject, #2: 2	جَاءَ ضَرُورَةَ
u'جَاءَ ضَيْفٌ':Subject, #1: 1	جَاءَ الضَّيْفُ
u'جَاءَ طَالِبٌ':Subject, #1: 1	جَاءَ ضَيْفٌ
u'جَاءَ طَالِبٌ':Subject, #1: 1	جَاءَ طَالِبُهُ
u'جَاءَ طَائِرٌ':Subject, #2: 2	جَاءَ الطَّالِبُ
u'جَاءَ طَلْقٌ':Subject, #1: 1	جَاءَ طَائِرٌ
u'جَاءَ طَمَعٌ':Subject, #1: 1	جَاءَ طَلْقٌ
u'جَاءَ طُوفَانٌ':Subject, #1: 1	جَاءَ الطَّمَعُ
u'جَاءَ ظَنٌّ':Subject, #1: 1	جَاءَ الطّوفَانُ
u'جَاءَ عَائِشٌ':Predicate, #1: 1	جَاءَ ظَنُّهُ
u'جَاءَ عَبْدٌ':Predicate, #3: 3	جَاءَ عَائِشَةَ
u'جَاءَ عَبْدٌ':Subject, #1: 1	جَاءَ عَبْدَ
u'جَاءَ عَبْدٌ':Subject, #14: 14	جَاءَ عَبْدُ
u'جَاءَ عَبْدٌ':Subject, #3: 3	جَاءَ عَبْدٌ
u'جَاءَ عتبة':Predicate, #4: 4	جَاءَ الْعَبْدُ
u'جَاءَ عَتَبَةٌ':Predicate, #1: 1	جَاءَ عَتَبَةَ
u'جَاءَ عتق':Subject, #1: 1	جَاءَ عَتَبَةَ
u'جَاءَ عِتْقٌ':Subject, #2: 2	جَاءَ الْعِتْقُ
u'جَاءَ عجز':Subject, #2: 2	جَاءَ الْعِتْقُ
u'جَاءَ عَجْزٌ':Subject, #4: 4	جَاءَ الْعَجْزُ
u'جَاءَ عُذْرٌ':Subject, #4: 4	جَاءَ الْعَجْزُ
u'جَاءَ عرفة':Predicate, #3: 3	جَاءَ الْعُذْرُ
u'جَاءَ عُرْوَةٌ':Subject, #1: 1	جَاءَ عَرَفَةَ
u'جَاءَ عسر':Subject, #1: 1	جَاءَ عُرْوَةُ
u'جَاءَ عُسْرٌ':Subject, #1: 1	جَاءَ الْعُسْرُ
u'جَاءَ عَسْكَرٌ':Subject, #1: 1	جَاءَ الْعُسْرُ
u'جَاءَ عَشْرٌ':Subject, #1: 1	جَاءَ عَسْكَرٌ
u'جَاءَ عَقْلٌ':Subject, #1: 1	جَاءَ عَشْرٌ
u'جَاءَ عَلِيٌّ':Subject, #1: 1	جَاءَ الْعَقْلُ
u'جَاءَ عَلِيٌّ':Subject, #1: 1	جَاءَ عَلِيُّ
u'جَاءَ عَمٌّ':Subject, #7: 7	جَاءَ عَلِيٌّ
u'جَاءَ عُمَرٌ':Subject, #2: 2	جَاءَ عَمُّهُ
u'جَاءَ عُمْرَانٌ':Predicate, #9: 9	جَاءَ عُمَرُ
u'جَاءَ عُمُومٌ':Subject, #1: 1	جَاءَ الْعُمْرَانَ
u'جَاءَ عِنَبٌ':Subject, #1: 1	جَاءَ عُمُومُهُ
u'جَاءَ عند':Predicate, #1: 1	جَاءَ الْعِنَبُ
u'جَاءَ عِيدٌ':Subject, #5: 5	جَاءَ عِنْدَ
u'جَاءَ غَاصِبٌ':Subject, #1: 1	جَاءَ الْعِيدُ
u'جَاءَ غَائِبٌ':Subject, #3: 3	جَاءَ الْغَاصِبُ
u'جَاءَ غَدٌ':Subject, #10: 10	جَاءَ الْغَائِبُ
u'جَاءَ غَدٌ':Subject, #113: 113	جَاءَ غَدٌ
u'جَاءَ غرماء':Subject, #46: 46	جَاءَ الْغَدُ
u'جَاءَ غَرِيبٌ':Subject, #7: 7	جَاءَ الْغُرَمَاءُ
u'جَاءَ غَرِيمٌ':Subject, #1: 1	جَاءَ الْغَرِيبُ
u'جَاءَ غُلاَمٌ':Subject, #5: 5	جَاءَ الْغَرِيمُ
u'جَاءَ غُلاَمٌ':Subject, #1: 1	جَاءَ غُلَامٌ
u'جَاءَ غُلاَمٌ':Subject, #1: 1	جَاءَ غُلاَمٌ
u'جَاءَ غُلاَمٌ':Subject, #2: 2	جَاءَ غُلامٌ
u'جَاءَ غير':Predicate, #2: 2	جَاءَ غُلامُ
u'جَاءَ غَيْرٌ':Predicate, #2: 2	جَاءَ غَيْرَ
u'جَاءَ غير':Subject, #2: 2	جَاءَ غَيْرَ
u'جَاءَ غَيْرٌ':Subject, #1: 1	جَاءَ غَيْرُ
u'جَاءَ غير':Subject, #1: 1	جَاءَ غَيْرُ
u'جَاءَ غَيْرٌ':Subject, #3: 3	جَاءَ غَيْرُهُ
u'جَاءَ فَارِسٌ':Subject, #3: 3	جَاءَ غَيْرُهُ
u'جَاءَ فَرْجٌ':Subject, #1: 1	جَاءَ فَارِسُ
u'جَاءَ فَرَجٌ':Subject, #1: 1	جَاءَ الْفَرْجُ
u'جَاءَ فَرَجٌ':Subject, #1: 1	جَاءَ فَرَجٌ
u'جَاءَ فُرُوعٌ':Subject, #4: 4	جَاءَ الْفَرَجُ
u'جَاءَ فساد':Subject, #3: 3	جَاءَ الْفُرُوعُ
u'جَاءَ فَسَادٌ':Subject, #1: 1	جَاءَ الْفَسَادُ
u'جَاءَ فُضُولِيٌّ':Subject, #1: 1	جَاءَ الْفَسَادُ
u'جَاءَ فِعْلٌ':Subject, #2: 2	جَاءَ فُضُولِيٌّ
u'جَاءَ فقراء':Subject, #1: 1	جَاءَ الْفِعْلُ
u'جَاءَ فِقْهٌ':Subject, #2: 2	جَاءَ الْفُقَرَاءُ
u'جَاءَ فلان':Predicate, #2: 2	جَاءَ الْفِقْهُ
u'جَاءَ فلان':Predicate, #1: 1	جَاءَ مُزْدَلِفَةَ
u'جَاءَ فُلاَنٌ':Subject, #2: 2	جَاءَ الْمُزْدَلِفَةَ
u'جَاءَ فلان':Subject, #16: 16	جَاءَ فُلَانٌ
u'جَاءَ فلان':Subject, #1: 1	جَاءَ الزّبَيْرُ
u'جَاءَ فلان':Subject, #1: 1	جَاءَ الشَّافِعِيُّ
u'جَاءَ فلان':Subject, #1: 1	جَاءَ بِلالٌ
u'جَاءَ فلان':Subject, #1: 1	جَاءَ بِلاَلُ
u'جَاءَ فلان':Subject, #1: 1	جَاءَ جُبَيْرُ
u'جَاءَ فلان':Subject, #1: 1	جَاءَ حَمْزَةُ
u'جَاءَ فلان':Subject, #1: 1	جَاءَ رِفَاعَةُ
u'جَاءَ فلان':Subject, #1: 1	جَاءَ زُهَيْرٌ
u'جَاءَ فلان':Subject, #1: 1	جَاءَ زِيَادٌ
u'جَاءَ فلان':Subject, #1: 1	جَاءَ سُفْيَانُ
u'جَاءَ فلان':Subject, #1: 1	جَاءَ مُعَاوِيَةُ
u'جَاءَ فلان':Subject, #2: 2	جَاءَ بِلَالٌ
u'جَاءَ فلان':Subject, #4: 4	جَاءَ بِلاَلٌ
u'جَاءَ قَاذِفٌ':Subject, #8: 8	جَاءَ عُثْمَانُ
u'جَاءَ قَاطِعٌ':Subject, #1: 1	جَاءَ الْقَاذِفُ
u'جَاءَ قَالٌ':Predicate, #1: 1	جَاءَ الْقَاطِعُ
u'جَاءَ قتال':Subject, #15: 15	جَاءَ قَالَ
u'جَاءَ قِتَالٌ':Subject, #5: 5	جَاءَ الْقِتَالُ
u'جَاءَ قتل':Subject, #5: 5	جَاءَ الْقِتَالُ
u'جَاءَ قَتْلٌ':Subject, #1: 1	جَاءَ الْقَتْلُ
u'جَاءَ قَدَرٌ':Subject, #1: 1	جَاءَ الْقَتْلُ
u'جَاءَ قُرْآنٌ':Subject, #1: 1	جَاءَ الْقَدَرُ
u'جَاءَ قَهْرَمان':Subject, #5: 5	جَاءَ الْقُرْآنُ
u'جَاءَ قول':Subject, #1: 1	جَاءَ قَهْرَمَانٌ
u'جَاءَ قَوْلٌ':Subject, #1: 1	جَاءَ الْقَوْلُ
u'جَاءَ قول':Subject, #1: 1	جَاءَ الْقَوْلُ
u'جَاءَ قَوْلٌ':Subject, #7: 7	جَاءَ قَوْلُهُ
u'جَاءَ قَوْمٌ':Predicate, #7: 7	جَاءَ قَوْلُهُ
u'جَاءَ قَوْمٌ':Subject, #1: 1	جَاءَ الْقَوْمَ
u'جَاءَ قَوْمٌ':Subject, #10: 10	جَاءَ الْقَوْمُ
u'جَاءَ قَوْمٌ':Subject, #1: 1	جَاءَ قَوْمُ
u'جَاءَ قَيْصَرٌ':Predicate, #5: 5	جَاءَ قَوْمٌ
u'جَاءَ كِتَابٌ':Subject, #2: 2	جَاءَ قَيْصَرَ
u'جَاءَ كِتَابٌ':Subject, #3: 3	جَاءَ كِتَابُ
u'جَاءَ كِتَابٌ':Subject, #4: 4	جَاءَ كِتَابٌ
u'جَاءَ كُفَّارٌ':Subject, #5: 5	جَاءَ الْكِتَابُ
u'جَاءَ كَفِيلٌ':Subject, #2: 2	جَاءَ كُفَّارُ
u'جَاءَ كَلاَمٌ':Subject, #1: 1	جَاءَ الْكَفِيلُ
u'جَاءَ كَلاَمٌ':Subject, #1: 1	جَاءَ الْكَلَامُ
u'جَاءَ كَنْزٌ':Subject, #1: 1	جَاءَ كَلَامُ
u'جَاءَ لَفْظٌ':Subject, #1: 1	جَاءَ كَنْزُهُ
u'جَاءَ لَفْظٌ':Subject, #1: 1	جَاءَ اللَّفْظُ
u'جَاءَ لَيْثٌ':Subject, #1: 1	جَاءَ لَفْظُ
u'جَاءَ لَيْلٌ':Subject, #1: 1	جَاءَ اللَّيْثُ
u'جَاءَ لَيْلٌ':Subject, #1: 1	جَاءَ اللّيْلُ
u'جَاءَ مَاءٌ':Subject, #4: 4	جَاءَ اللَّيْلُ
u'جَاءَ مَاعِزٌ':Subject, #3: 3	جَاءَ الْمَاءُ
u'جَاءَ مَاعِزٌ':Subject, #2: 2	جَاءَ مَاعِزٌ
u'جَاءَ مَالٌ':Subject, #8: 8	جَاءَ مَاعِزُ
u'جَاءَ مَالٌ':Subject, #1: 1	جَاءَ مَالُ
u'جَاءَ مَالِكٌ':Subject, #2: 2	جَاءَ مَالٌ
u'جَاءَ مَالِكٌ':Subject, #1: 1	جَاءَ مَالِكُ
u'جَاءَ مُبِيحٌ':Subject, #6: 6	جَاءَ الْمَالِكُ
u'جَاءَ مُتَبَرِّعٌ':Subject, #1: 1	جَاءَ الْمُبِيحُ
u'جَاءَ مثل':Subject, #1: 1	جَاءَ مُتَبَرِّعٌ
u'جَاءَ مَثَلٌ':Subject, #1: 1	جَاءَ الْمَثَلُ
u'جَاءَ مثل':Subject, #1: 1	جَاءَ الْمَثَلُ
u'جَاءَ مِثْلٌ':Subject, #2: 2	جَاءَ مِثْلُهُ
u'جَاءَ مثل':Subject, #2: 2	جَاءَ مِثْلُهُ
u'جَاءَ مِثْلٌ':Subject, #5: 5	جَاءَ مِثْلُ
u'جَاءَ مَجَازٌ':Subject, #5: 5	جَاءَ مِثْلُ
u'جَاءَ مَجِيءٌ':Predicate, #1: 1	جَاءَ الْمَجَازُ
u'جَاءَ مَحْبُوسٌ':Subject, #2: 2	جَاءَ مَجِيءَ
u'جَاءَ مُحَلِّل':Subject, #1: 1	جَاءَ الْمَحْبُوسُ
u'جَاءَ مُحَمَّدٌ':Subject, #1: 1	جَاءَ الْمُحَلِّلُ
u'جَاءَ مُدَّةٌ':Subject, #8: 8	جَاءَ مُحَمَّدٌ
u'جَاءَ مدد':Subject, #1: 1	جَاءَ مُدَّةُ
u'جَاءَ مَدَدٌ':Subject, #1: 1	جَاءَ مَدَدٌ
u'جَاءَ مَدِينٌ':Predicate, #1: 1	جَاءَ مَدَدٌ
u'جَاءَ مَدِينَةٌ':Predicate, #2: 2	جَاءَ الْمَدِينَةَ
u'جَاءَ مُرْتَدٌّ':Subject, #2: 2	جَاءَ الْمَدِينَةَ
u'جَاءَ مُرْتَهِنٌ':Subject, #4: 4	جَاءَ الْمُرْتَدُّ
u'جَاءَ مُرْسَلٌ':Predicate, #5: 5	جَاءَ الْمُرْتَهِنُ
u'جَاءَ مُزَارِعٌ':Subject, #2: 2	جَاءَ مُرْسَلاً
u'جَاءَ مُزَيِّنٌ':Subject, #1: 1	جَاءَ الْمُزَارِعُ
u'جَاءَ مُسْتَأْجِرٌ':Subject, #1: 1	جَاءَ الْمُزَيِّنُ
u'جَاءَ مُسْتَحِقٌّ':Subject, #3: 3	جَاءَ الْمُسْتَأْجِرُ
u'جَاءَ مَسْجِدٌ':Predicate, #12: 12	جَاءَ مُسْتَحِقٌّ
u'جَاءَ مُسْلِمٌ':Subject, #1: 1	جَاءَ الْمَسْجِدَ
u'جَاءَ مُسْلِمٌ':Subject, #1: 1	جَاءَ الْمُسْلِمُ
u'جَاءَ مُسْلِمٌ':Subject, #1: 1	جَاءَ مُسْلِمٌ
u'جَاءَ مَشْهُودٌ':Subject, #1: 1	جَاءَ مُسْلِمُ
u'جَاءَ مَصْدَرٌ':Subject, #7: 7	جَاءَ الْمَشْهُودُ
u'جَاءَ مُصَدِّقٌ':Subject, #1: 1	جَاءَ الْمَصْدَرُ
u'جَاءَ مُضَارِبٌ':Subject, #1: 1	جَاءَ الْمُصَدِّقُ
u'جَاءَ مَضْرُوبٌ':Subject, #2: 2	جَاءَ الْمُضَارِبُ
u'جَاءَ مَطَرٌ':Subject, #2: 2	جَاءَ الْمَضْرُوبُ
u'جَاءَ مَطْلُوبٌ':Subject, #11: 11	جَاءَ الْمَطَرُ
u'جَاءَ مُعاوِيَة':Subject, #1: 1	جَاءَ الْمَطْلُوبُ
u'جَاءَ مَعْطُوف':Subject, #1: 1	جَاءَ مُعَاوِيَةُ
u'جَاءَ مَعْقُولٌ':Subject, #1: 1	جَاءَ مَعْطُوفٌ
u'جَاءَ مَغْصُوب':Subject, #1: 1	جَاءَ الْمَعْقُولُ
u'جَاءَ مَفْقُودٌ':Subject, #4: 4	جَاءَ الْمَغْصُوبُ
u'جَاءَ مُقَدَّمٌ':Subject, #1: 1	جَاءَ الْمَفْقُودُ
u'جَاءَ مَقْذُوفٌ':Subject, #1: 1	جَاءَ الْمُقَدَّمُ
u'جَاءَ مَقَرٌّ':Subject, #2: 2	جَاءَ الْمَقْذُوفُ
u'جَاءَ مُلْتَقِط':Subject, #2: 2	جَاءَ الْمَقَرُّ
u'جَاءَ مَمْلُوكٌ':Subject, #1: 1	جَاءَ الْمُلْتَقِطُ
u'جَاءَ مَنْصُوبٌ':Subject, #1: 1	جَاءَ الْمَمْلُوكُ
u'جَاءَ مَنْعٌ':Subject, #1: 1	جَاءَ مَنْصُوبٌ
u'جَاءَ مَوّار':Subject, #1: 1	جَاءَ الْمَنْعُ
u'جَاءَ مَوْتٌ':Subject, #2: 2	جَاءَ مَوّارُهُ
u'جَاءَ مَوْتٌ':Subject, #1: 1	جَاءَ مَوْتُ
u'جَاءَ مُودِعٌ':Subject, #6: 6	جَاءَ الْمَوْتُ
u'جَاءَ مُؤَذِّنٌ':Subject, #3: 3	جَاءَ الْمُودِعُ
u'جَاءَ مَوْسِمٌ':Predicate, #1: 1	جَاءَ الْمُؤَذِّنُ
u'جَاءَ مَوْضِعٌ':Subject, #1: 1	جَاءَ الْمَوْسِمَ
u'جَاءَ مُوَكِّلٌ':Subject, #2: 2	جَاءَ مَوْضِعُ
u'جَاءَ مُؤْمِنٌ':Subject, #6: 6	جَاءَ الْمُوَكِّلُ
u'جَاءَ مِيرَاثٌ':Subject, #1: 1	جَاءَ الْمُؤْمِنَاتُ
u'جَاءَ نَاسٌ':Predicate, #2: 2	جَاءَ الْمِيرَاثُ
u'جَاءَ نَاسٌ':Subject, #1: 1	جَاءَ النَّاسَ
u'جَاءَ نَاسٌ':Subject, #4: 4	جَاءَ النَّاسُ
u'جَاءَ نَافِعٌ':Subject, #4: 4	جَاءَ نَاسٌ
u'جَاءَ نَبِيٌّ':Predicate, #1: 1	جَاءَ نَافِعُ
u'جَاءَ نَبِيٌّ':Subject, #2: 2	جَاءَ النَّبِيَّ
u'جَاءَ نَبِيٌّ':Subject, #10: 10	جَاءَ النَّبِيُّ
u'جَاءَ نِسْوَةٌ':Subject, #1: 1	جَاءَ نَبِيُّ
u'جَاءَ نُشُوزٌ':Subject, #1: 1	جَاءَ نِسْوَةٌ
u'جَاءَ نَصٌّ':Subject, #1: 1	جَاءَ النُّشُوزُ
u'جَاءَ نَصْرٌ':Subject, #3: 3	جَاءَ النَّصُّ
u'جَاءَ نَصْرَانِيٌّ':Subject, #23: 23	جَاءَ نَصْرُ
u'جَاءَ نَعْيٌ':Subject, #1: 1	جَاءَ نَصْرَانِيٌّ
u'جَاءَ نَفَرٌ':Subject, #6: 6	جَاءَ نَعْيُ
u'جَاءَ نُفُوذٌ':Subject, #3: 3	جَاءَ نَفَرٌ
u'جَاءَ نَفِيرٌ':Subject, #1: 1	جَاءَ النُّفُوذُ
u'جَاءَ نهار':Subject, #2: 2	جَاءَ النَّفِيرُ
u'جَاءَ نَهَارٌ':Subject, #2: 2	جَاءَ النَّهَارُ
u'جَاءَ نَهْيٌ':Subject, #2: 2	جَاءَ النَّهَارُ
u'جَاءَ هِلاَلٌ':Subject, #5: 5	جَاءَ النَّهْيُ
u'جَاءَ هِلاَلٌ':Subject, #1: 1	جَاءَ الْهِلَالُ
u'جَاءَ هِلاَلٌ':Subject, #1: 1	جَاءَ هِلَالُ
u'جَاءَ هِلاَلٌ':Subject, #1: 1	جَاءَ هِلاَلٌ
u'جَاءَ هِلاَلٌ':Subject, #2: 2	جَاءَ هِلَالٌ
u'جَاءَ واحد':Predicate, #2: 2	جَاءَ هِلاَلُ
u'جَاءَ وَاحِدٌ':Predicate, #1: 1	جَاءَ وَاحِدَةً
u'جَاءَ واحد':Subject, #1: 1	جَاءَ وَاحِدَةً
u'جَاءَ وَاحِدٌ':Subject, #1: 1	جَاءَ وَاحِدٌ
u'جَاءَ وَارِثٌ':Subject, #1: 1	جَاءَ وَاحِدٌ
u'جَاءَ وَارِثٌ':Subject, #1: 1	جَاءَ الْوَارِثُ
u'جَاءَ وَحْيٌ':Subject, #3: 3	جَاءَ وَارِثٌ
u'جَاءَ وَصْفٌ':Subject, #1: 1	جَاءَ الْوَحْيُ
u'جَاءَ وَعْدٌ':Subject, #1: 1	جَاءَ وَصْفُهُ
u'جَاءَ وَعْدٌ':Subject, #1: 1	جَاءَ وَعْدُ
u'جَاءَ وَعِيدٌ':Subject, #1: 1	جَاءَ وَعْدُهُ
u'جَاءَ وَفْدٌ':Subject, #5: 5	جَاءَ الْوَعِيدُ
u'جَاءَ وَقْتٌ':Predicate, #4: 4	جَاءَ وَفْدُ
u'جَاءَ وَقْتٌ':Subject, #4: 4	جَاءَ وَقْتَ
u'جَاءَ وَقْتٌ':Subject, #1: 1	جَاءَ وَقْتُهُ
u'جَاءَ وَقْتٌ':Subject, #30: 30	جَاءَ وَقْتُ
u'جَاءَ وَكِيلٌ':Subject, #8: 8	جَاءَ الْوَقْتُ
u'جَاءَ ولد':Subject, #1: 1	جَاءَ الْوَكِيلُ
u'جَاءَ وَلَدٌ':Subject, #1: 1	جَاءَ وَلَدُ
u'جَاءَ ولد':Subject, #1: 1	جَاءَ وَلَدُ
u'جَاءَ وَلَدٌ':Subject, #1: 1	جَاءَ وَلَدُهُ
u'جَاءَ ولد':Subject, #1: 1	جَاءَ وَلَدُهُ
u'جَاءَ وَلَدٌ':Subject, #5: 5	جَاءَ الْوَلَدُ
u'جَاءَ وَلِيٌّ':Subject, #5: 5	جَاءَ الْوَلَدُ
u'جَاءَ وَلِيٌّ':Subject, #1: 1	جَاءَ وَلِيُّهُ
u'جَاءَ وَلِيٌّ':Subject, #3: 3	جَاءَ وَلِيُّ
u'جَاءَ يهود':Subject, #5: 5	جَاءَ الْوَلِيُّ
u'جَاءَ يَهُودٌ':Subject, #1: 1	جَاءَ الْيَهُودُ
u'جَاءَ يَهُودِيٌّ':Subject, #1: 1	جَاءَ الْيَهُودُ
u'جَاءَ يَوْمٌ':Predicate, #1: 1	جَاءَ يَهُودِيٌّ
u'جَاءَ يَوْمٌ':Predicate, #1: 1	جَاءَ الْيَوْمَ
u'جَاءَ يَوْمٌ':Subject, #44: 44	جَاءَ يَوْمَ
u'جَاءَ يَوْمٌ':Subject, #1: 1	جَاءَ الْيَوْمُ
u'جَاءَ يَوْمٌ':Subject, #23: 23	جَاءَ يَوْمُ
u'جَابَ اِبْنٌ':Subject, #8: 8	جَاءَ يَوْمٌ
u'جَابَ إجَارَةٌ':Subject, #19: 19	أَجَابَ ابْنُ
u'جَابَ أُسْتَاذٌ':Subject, #1: 1	أَجَابَ إجَارَةُ
u'جَابَ أَصْحَابٌ':Subject, #2: 2	أَجَابَ الْأُسْتَاذُ
u'جَابَ أصل':Subject, #1: 1	أَجَابَ الْأَصْحَابُ
u'جَابَ أًصْلٌ':Subject, #2: 2	أَجَابَ الْأَصْلُ
u'جَابَ إمَامٌ':Subject, #2: 2	أَجَابَ الْأَصْلُ
u'جَابَ إمَامٌ':Subject, #1: 1	أَجَابَ إمَامُ
u'جَابَ أَميرٌ':Predicate, #4: 4	أَجَابَ الْإِمَامُ
u'جَابَ أَوَّلُ':Subject, #1: 1	أَجَابَ أَمِيرَ
u'جَابَ بَعْضٌ':Subject, #6: 6	أَجَابَ الْأَوَّلُ
u'جَابَ بَعْضٌ':Subject, #14: 14	أَجَابَ بَعْضُ
u'جَابَ تَعَلُّمٌ':Subject, #1: 1	أَجَابَ بَعْضٌ
u'جَابَ تَقْريرٌ':Predicate, #1: 1	أَجَابَ تَعَلُّمُ
u'جَابَ جَمَاعَةٌ':Subject, #1: 1	أَجَابَ التَّقْرِيرَ
u'جَابَ جَمَالٌ':Subject, #1: 1	أَجَابَ جَمَاعَةٌ
u'جَابَ جُمْهُورٌ':Subject, #1: 1	أَجَابَ جَمَالُ
u'جَابَ جُمْهُورٌ':Subject, #1: 1	أَجَابَ الْجُمْهُورُ
u'جَابَ جَمِيع':Subject, #1: 1	أَجَابَ جُمْهُورُ
u'جَابَ جَوَابٌ':Predicate, #2: 2	أَجَابَ الْجَمِيعُ
u'جَابَ حارِثٌ':Subject, #1: 1	أَجَابَ جَوَابَ
u'جَابَ حَجيجٌ':Subject, #1: 1	أَجَابَ الْحَارِثُ
u'جَابَ دَاعِي':Predicate, #1: 1	أَجَابَ الْحَجِيجُ
u'جَابَ رَسُولٌ':Predicate, #2: 2	أَجَابَ دَاعِيَ
u'جَابَ رَمْلِيٌّ':Subject, #1: 1	أَجَابَ الرَّسُولَ
u'جَابَ زُفَرٌ':Subject, #1: 1	أَجَابَ الرَّمْلِيُّ
u'جَابَ سَابِقٌ':Predicate, #1: 1	أَجَابَ زُفَرُ
u'جَابَ سَفِيهٌ':Predicate, #1: 1	أَجَابَ السَّابِقَ
u'جَابَ سُؤَالٌ':Predicate, #1: 1	أَجَابَ السَّفِيهَةَ
u'جَابَ سَيِّدٌ':Subject, #1: 1	أَجَابَ السُّؤَالَ
u'جَابَ شَارِحٌ':Subject, #1: 1	أَجَابَ السَّيِّدُ
u'جَابَ شافِعِيّ':Subject, #1: 1	أَجَابَ الشَّارِحُ
u'جَابَ شَرِيفٌ':Subject, #2: 2	أَجَابَ الشَّافِعِيُّ
u'جَابَ شمس':Subject, #1: 1	أَجَابَ الشَّرِيفُ
u'جَابَ شَمْسٌ':Subject, #1: 1	أَجَابَ الشَّمْسُ
u'جَابَ شمس':Subject, #1: 1	أَجَابَ الشَّمْسُ
u'جَابَ شَمْسٌ':Subject, #2: 2	أَجَابَ شَمْسُ
u'جَابَ شَيْخٌ':Subject, #2: 2	أَجَابَ شَمْسُ
u'جَابَ شَيْخٌ':Subject, #2: 2	أَجَابَ شَيْخُ
u'جَابَ صَاحِبٌ':Subject, #6: 6	أَجَابَ الشَّيْخُ
u'جَابَ عَالِمٌ':Subject, #3: 3	أَجَابَ صَاحِبُ
u'جَابَ عَلاءٌ':Subject, #2: 2	أَجَابَ الْعَالِمُ
u'جَابَ علم':Predicate, #1: 1	أَجَابَ عَلَاءُ
u'جَابَ علماء':Subject, #3: 3	أَجَابَ عُلِمَ
u'جَابَ عُلَمَاءُ':Subject, #1: 1	أَجَابَ الْعُلَمَاءُ
u'جَابَ عَلِيٌّ':Subject, #1: 1	أَجَابَ الْعُلَمَاءُ
u'جَابَ عِمَادٌ':Subject, #1: 1	أَجَابَ عَلِيٌّ
u'جَابَ عُمَرٌ':Subject, #3: 3	أَجَابَ الْعِمَادُ
u'جَابَ غير':Subject, #1: 1	أَجَابَ عُمَرُ
u'جَابَ غَيْرٌ':Subject, #2: 2	أَجَابَ غَيْرُ
u'جَابَ فَقِيهٌ':Subject, #2: 2	أَجَابَ غَيْرُ
u'جَابَ فَلاَةٌ':Predicate, #1: 1	أَجَابَ الْفَقِيهُ
u'جَابَ فلان':Subject, #1: 1	جَابَ الْفَلَاةَ
u'جَابَ فلان':Subject, #1: 1	أَجَابَ عُثْمَانُ
u'جَابَ قَفَّالٌ':Subject, #2: 2	أَجَابَ الشَّافِعِيُّ
u'جَابَ قول':Subject, #1: 1	أَجَابَ الْقَفَّالُ
u'جَابَ قَوْلٌ':Subject, #1: 1	أَجَابَ الْقَوْلُ
u'جَابَ كَلاَمٌ':Predicate, #1: 1	أَجَابَ الْقَوْلُ
u'جَابَ مُحِبٌّ':Subject, #1: 1	أَجَابَ كَلَامَ
u'جَابَ مُحَقِّقٌ':Subject, #1: 1	أَجَابَ الْمُحِبُّ
u'جَابَ مَحَلِّيٌّ':Subject, #1: 1	أَجَابَ الْمُحَقِّقُ
u'جَابَ مُحَمَّدٌ':Subject, #1: 1	أَجَابَ الْمَحَلِّيُّ
u'جَابَ مَذْهَبٌ':Subject, #1: 1	أَجَابَ مُحَمَّدٌ
u'جَابَ مرٌّ':Predicate, #1: 1	أَجَابَ مَذْهَبُ
u'جَابَ مَشَايِخُ':Subject, #3: 3	أَجَابَ مَرَّةً
u'جَابَ مُصَنِّفٌ':Subject, #2: 2	أَجَابَ الْمَشَايِخُ
u'جَابَ مُقْتَرِحٌ':Subject, #22: 22	أَجَابَ الْمُصَنِّفُ
u'جَابَ مُؤَذِّنٌ':Predicate, #1: 1	أَجَابَ الْمُقْتَرِحُ
u'جَابَ مُؤَذِّنٌ':Subject, #1: 1	أَجَابَ الْمُؤَذِّنَ
u'جَابَ مُؤَلِّفٌ':Subject, #1: 1	أَجَابَ الْمُؤَذِّنُ
u'جَابَ نَاصِرٌ':Subject, #1: 1	أَجَابَ الْمُؤَلِّفُ
u'جَابَ نَبِيٌّ':Predicate, #1: 1	أَجَابَ النَّاصِرُ
u'جَابَ نَوَوِيٌّ':Subject, #2: 2	أَجَابَ النَّبِيَّ
u'جَابَ وَلِيٌّ':Subject, #3: 3	أَجَابَ النَّوَوِيُّ
u'جَابَ وَلِيٌّ':Subject, #1: 1	أَجَابَ وَلِيُّ
u'جَادَ اِبْنٌ':Subject, #2: 2	أَجَابَ الْوَلِيُّ
u'جَادَ حِفْظٌ':Subject, #1: 1	أَجَادَ ابْنُ
u'جَادَ هضم':Subject, #1: 1	جَادَ حِفْظُهُ
u'جَادَ هَضْمٌ':Subject, #1: 1	جَادَ هَضْمُهُ
u'جَارَ أَصْحَابٌ':Predicate, #1: 1	جَادَ هَضْمُهُ
u'جَارَ أَميرٌ':Subject, #1: 1	أَجَارَ أَصْحَابَ
u'جَارَ حُكْمٌ':Subject, #1: 1	جَارَ الْأَمِيرُ
u'جَارَ حُكْمٌ':Subject, #1: 1	جَارَ حُكْمُ
u'جَارَ رَجُلٌ':Subject, #1: 1	جَارَ حُكْمُهُ
u'جَارَ سُلْطَانٌ':Subject, #1: 1	أَجَارَ رَجُلٌ
u'جَارَ قَوْمٌ':Subject, #1: 1	جَارَ سُلْطَانُ
u'جَارَ لَطِيم':Predicate, #1: 1	جَارَ قَوْمٌ
u'جَازَ أَبٌ':Subject, #2: 2	أَجَارَ لَطِيمَةً
u'جَازَ اِبْتِداءٌ':Subject, #2: 2	أَجَازَ الْأَبُ
u'جَازَ إبدالٌ':Subject, #1: 1	جَازَ ابْتِدَاءٌ
u'جَازَ إِبْطَالٌ':Subject, #1: 1	جَازَ إبْدَالُهُ
u'جَازَ إِبْقَاءٌ':Subject, #1: 1	جَازَ إبْطَالُ
u'جَازَ اِبْنٌ':Subject, #1: 1	جَازَ إبْقَاءُ
u'جَازَ اِبْنٌ':Subject, #14: 14	أَجَازَ ابْنُ
u'جَازَ اِتِّخَاذٌ':Subject, #2: 2	أَجَازَ ابْنٌ
u'جَازَ اِتِّفَاقٌ':Subject, #1: 1	جَازَ اتِّخَاذُهُ
u'جَازَ إِتْلاَفٌ':Subject, #1: 1	جَازَ اتِّفَاقُ
u'جَازَ إِتْلاَفٌ':Subject, #1: 1	جَازَ إتْلَافُهُ
u'جَازَ إِثْبَاتٌ':Subject, #2: 2	جَازَ إتْلَافُ
u'جَازَ إجَارَةٌ':Predicate, #2: 2	جَازَ إثْبَاتُ
u'جَازَ إجَارَةٌ':Subject, #3: 3	أَجَازَ الْإِجَارَةَ
u'جَازَ إجَارَةٌ':Subject, #1: 1	جَازَ إجَارَةُ
u'جَازَ إِجْمَاعٌ':Subject, #1: 1	جَازَ إجَارَتُهُ
u'جَازَ إِجْهَازٌ':Subject, #2: 2	جَازَ الْإِجْمَاعُ
u'جَازَ أحَدٌ':Predicate, #1: 1	جَازَ الْإِجْهَازُ
u'جَازَ أحَدٌ':Subject, #1: 1	أَجَازَ أَحَدَ
u'جَازَ أحَدٌ':Subject, #1: 1	أَجَازَ أَحَدٌ
u'جَازَ إِحْرَازٌ':Subject, #1: 1	أَجَازَ أَحَدُ
u'جَازَ إِحْرَامٌ':Subject, #1: 1	جَازَ إحْرَازُهُ
u'جَازَ أَحْكَامٌ':Subject, #3: 3	جَازَ إحْرَامُهُ
u'جَازَ إِحْلاَلٌ':Subject, #1: 1	جَازَ أَحْكَامُهُ
u'جَازَ أخْذٌ':Predicate, #1: 1	جَازَ الْإِحْلَالُ
u'جَازَ أخْذٌ':Subject, #1: 1	أَجَازَ أَخْذَ
u'جَازَ أخْذٌ':Subject, #10: 10	جَازَ أَخْذُهُ
u'جَازَ أخْذٌ':Subject, #9: 9	جَازَ أَخْذُ
u'جَازَ إِخْرَاجٌ':Subject, #9: 9	جَازَ الْأَخْذُ
u'جَازَ إِخْرَاجٌ':Subject, #4: 4	جَازَ إخْرَاجُ
u'جَازَ أَدَاءٌ':Subject, #4: 4	جَازَ إخْرَاجُهُ
u'جَازَ أَدَاءٌ':Subject, #3: 3	جَازَ الْأَدَاءُ
u'جَازَ إدْخَالٌ':Subject, #7: 7	جَازَ أَدَاءُ
u'جَازَ إدْخَالٌ':Subject, #1: 1	جَازَ إدْخَالُهُ
u'جَازَ أَذَانٌ':Subject, #2: 2	جَازَ إدْخَالُ
u'جَازَ إِذْنٌ':Subject, #1: 1	جَازَ الْأَذَانُ
u'جَازَ إِذْنٌ':Subject, #1: 1	جَازَ إذْنُ
u'جَازَ إِذْنٌ':Subject, #1: 1	جَازَ إذْنُهُ
u'جَازَ إِرَادَةٌ':Subject, #2: 2	جَازَ الْإِذْنُ
u'جَازَ اِرْتِفَاعٌ':Subject, #1: 1	جَازَ إرَادَةُ
u'جَازَ اِرْتِكَابٌ':Subject, #1: 1	جَازَ ارْتِفَاعُهُ
u'جَازَ اِسْتِبْدَالٌ':Subject, #1: 1	جَازَ ارْتِكَابُ
u'جَازَ اِسْتِبْقَاءٌ':Subject, #1: 1	جَازَ اسْتِبْدَالُهُ
u'جَازَ اِسْتِرْجَاعٌ':Subject, #1: 1	جَازَ اسْتِبْقَاءُ
u'جَازَ اِسْتِعارَةٌ':Predicate, #1: 1	جَازَ اسْتِرْجَاعُهُ
u'جَازَ اِسْتِعْمالٌ':Subject, #1: 1	جَازَ اسْتِعَارَةَ
u'جَازَ اِسْتِعْمالٌ':Subject, #22: 22	جَازَ اسْتِعْمَالُهُ
u'جَازَ اِسْتِقْراض':Subject, #3: 3	جَازَ اسْتِعْمَالُ
u'جَازَ اِسْتِماعٌ':Subject, #1: 1	جَازَ اسْتِقْرَاضُهُ
u'جَازَ اِسْتِمْرارٌ':Subject, #1: 1	جَازَ اسْتِمَاعُ
u'جَازَ اِسْتِناد':Subject, #2: 2	جَازَ اسْتِمْرَارُهُ
u'جَازَ اِسْتِئْجَارٌ':Subject, #1: 1	جَازَ اسْتِنَادُ
u'جَازَ اِسْتيفاءٌ':Subject, #2: 2	جَازَ اسْتِئْجَارُ
u'جَازَ إِسْقاطٌ':Subject, #1: 1	جَازَ اسْتِيفَاءُ
u'جَازَ إِسْقاطٌ':Subject, #1: 1	جَازَ إسْقَاطُ
u'جَازَ إِسْكانٌ':Subject, #4: 4	جَازَ إسْقَاطُهُ
u'جَازَ اِشْتِراطٌ':Subject, #1: 1	جَازَ إسْكَانُ
u'جَازَ أَشْهَب':Subject, #4: 4	جَازَ اشْتِرَاطُ
u'جَازَ إِطْعامٌ':Subject, #1: 1	أَجَازَ أَشْهَبُ
u'جَازَ إِطْلاقٌ':Subject, #1: 1	جَازَ الْإِطْعَامُ
u'جَازَ إِطْلاقٌ':Subject, #1: 1	جَازَ إطْلَاقُ
u'جَازَ إِطْلاقٌ':Subject, #2: 2	جَازَ الْإِطْلَاقُ
u'جَازَ إِظْهارٌ':Subject, #4: 4	جَازَ إطْلَاقُهُ
u'جَازَ إِعارَةٌ':Subject, #1: 1	جَازَ إظْهَارُ
u'جَازَ إِعارَةٌ':Subject, #1: 1	جَازَ إعَارَةُ
u'جَازَ إِعْتاقٌ':Subject, #1: 1	جَازَ إعَارَتُهُ
u'جَازَ إِعْتاقٌ':Subject, #1: 1	جَازَ الْإِعْتَاقُ
u'جَازَ إِعْتاقٌ':Subject, #4: 4	جَازَ إعْتَاقُ
u'جَازَ اِعْتِبارٌ':Subject, #5: 5	جَازَ إعْتَاقُهُ
u'جَازَ اِعْتِمادٌ':Subject, #1: 1	جَازَ اعْتِبَارُهُ
u'جَازَ إِعْرابٌ':Subject, #2: 2	جَازَ اعْتِمَادُ
u'جَازَ إعْرَاضٌ':Subject, #2: 2	جَازَ إعْرَابُهُ
u'جَازَ إعْطَاءٌ':Subject, #1: 1	جَازَ الْإِعْرَاضُ
u'جَازَ اِغْتِنَامٌ':Subject, #2: 2	جَازَ إعْطَاءُ
u'جَازَ إِفْرَادٌ':Subject, #2: 2	جَازَ اغْتِنَامُهُ
u'جَازَ إِفْرَادٌ':Subject, #2: 2	جَازَ الْإِفْرَادُ
u'جَازَ إقامَةٌ':Subject, #3: 3	جَازَ إفْرَادُ
u'جَازَ اِقْتِسامٌ':Subject, #4: 4	جَازَ إقَامَةُ
u'جَازَ إقْدَامٌ':Subject, #2: 2	جَازَ اقْتِسَامُ
u'جَازَ إقْرَارٌ':Subject, #1: 1	جَازَ الْإِقْدَامُ
u'جَازَ إقْرَارٌ':Subject, #2: 2	جَازَ إقْرَارُ
u'جَازَ إقْرَارٌ':Subject, #32: 32	جَازَ إقْرَارُهُ
u'جَازَ إِقْراضٌ':Subject, #3: 3	جَازَ الْإِقْرَارُ
u'جَازَ إقْطَاعٌ':Subject, #1: 1	جَازَ إقْرَاضُهُ
u'جَازَ أَكْثَرُ':Subject, #1: 1	جَازَ إقْطَاعُهُ
u'جَازَ إكْرَاهٌ':Subject, #1: 1	جَازَ الْأَكْثَرُ
u'جَازَ أكل':Predicate, #1: 1	جَازَ الْإِكْرَاهُ
u'جَازَ أَكْلٌ':Predicate, #1: 1	أَجَازَ أَكْلَ
u'جَازَ أكل':Subject, #1: 1	أَجَازَ أَكْلَ
u'جَازَ أَكْلٌ':Subject, #5: 5	جَازَ أَكْلُهُ
u'جَازَ أكل':Subject, #5: 5	جَازَ أَكْلُهُ
u'جَازَ أَكْلٌ':Subject, #7: 7	جَازَ أَكْلُ
u'جَازَ أكل':Subject, #7: 7	جَازَ أَكْلُ
u'جَازَ أَكْلٌ':Subject, #8: 8	جَازَ الْأَكْلُ
u'جَازَ اِلْتِزَامٌ':Subject, #8: 8	جَازَ الْأَكْلُ
u'جَازَ اِلْتِقَاطٌ':Subject, #1: 1	جَازَ الْتِزَامُ
u'جَازَ إلْحَاقٌ':Subject, #1: 1	جَازَ الْتِقَاطُ
u'جَازَ إلْحَاقٌ':Subject, #1: 1	جَازَ إلْحَاقُ
u'جَازَ إِلْزَامٌ':Subject, #2: 2	جَازَ إلْحَاقُهُ
u'جَازَ اللَّهُمَّ':Predicate, #1: 1	جَازَ إلْزَامُ
u'جَازَ إمَامٌ':Subject, #1: 1	جَازَ اللَّهُمَّ
u'جَازَ إمَامَةٌ':Subject, #2: 2	أَجَازَ الْإِمَامُ
u'جَازَ أمَانٌ':Predicate, #1: 1	جَازَ إمَامَةُ
u'جَازَ أمَانٌ':Subject, #1: 1	أَجَازَ أَمَانَ
u'جَازَ أَمْس':Predicate, #1: 1	جَازَ أَمَانُهُ
u'جَازَ إِمْضاءٌ':Subject, #1: 1	جَازَ أَمْسَكَ
u'جَازَ اِنْتِظارٌ':Subject, #1: 1	جَازَ إمْضَاءُ
u'جَازَ اِنْتِفاء':Subject, #3: 3	جَازَ انْتِظَارُهُ
u'جَازَ اِنْتِفاعٌ':Subject, #1: 1	جَازَ انْتِفَاءُ
u'جَازَ اِنْصِرافٌ':Subject, #1: 1	جَازَ انْتِفَاعُ
u'جَازَ اِنْقِطاعٌ':Subject, #1: 1	جَازَ انْصِرَافُهُ
u'جَازَ اِنْقِطاعٌ':Subject, #1: 1	جَازَ انْقِطَاعُ
u'جَازَ أَوْدِيَةٌ':Predicate, #1: 1	جَازَ انْقِطَاعُهُ
u'جَازَ أَوْدِيَةٌ':Predicate, #1: 1	أَجَازَ الأَوْدِيَةَ
u'جَازَ أَوَّلُ':Predicate, #1: 1	جَازَ الأَوْدِيَةَ
u'جَازَ أَوَّلُ':Subject, #1: 1	أَجَازَ الْأَوَّلَ
u'جَازَ أَوَّلُ':Subject, #2: 2	أَجَازَ الْأَوَّلُ
u'جَازَ أَوَّلِيٌّ':Subject, #5: 5	جَازَ الْأَوَّلُ
u'جَازَ إِيجَابٌ':Subject, #1: 1	جَازَ أَوَّلِيَّةُ
u'جَازَ إِيجَارٌ':Subject, #2: 2	جَازَ إيجَابُ
u'جَازَ إِيجَارٌ':Subject, #1: 1	جَازَ إيجَارُهُ
u'جَازَ إِيدَاعٌ':Subject, #2: 2	جَازَ الْإِيجَارُ
u'جَازَ إيرَادٌ':Subject, #2: 2	جَازَ إيدَاعُهُ
u'جَازَ بَائِعٌ':Subject, #3: 3	جَازَ إيرَادُ
u'جَازَ بَتَّةٌ':Predicate, #11: 11	أَجَازَ الْبَائِعُ
u'جَازَ بَحْرٌ':Predicate, #1: 1	جَازَ الْبَتّةَ
u'جَازَ بَدَلٌ':Predicate, #1: 1	أَجَازَ الْبَحْرَ
u'جَازَ بَذْلٌ':Subject, #1: 1	أَجَازَ الْبَدَلَ
u'جَازَ بَطَلٌ':Predicate, #1: 1	جَازَ بَذْلُ
u'جَازَ بعثة':Subject, #1: 1	أَجَازَ بَطَلَ
u'جَازَ بَعْضٌ':Predicate, #1: 1	جَازَ بَعْثَةُ
u'جَازَ بَعْضٌ':Predicate, #1: 1	أَجَازَ الْبَعْضَ
u'جَازَ بَعْضٌ':Subject, #1: 1	أَجَازَ بَعْضَ
u'جَازَ بَعْضٌ':Subject, #1: 1	أَجَازَ بَعْضُ
u'جَازَ بَعْضٌ':Subject, #2: 2	أَجَازَ بَعْضٌ
u'جَازَ بَقاءٌ':Subject, #3: 3	أَجَازَ الْبَعْضُ
u'جَازَ بَقِيَّةٌ':Subject, #2: 2	جَازَ بَقَاءُ
u'جَازَ بِنَاءٌ':Predicate, #2: 2	أَجَازَ بَقِيَّةُ
u'جَازَ بِنَاءٌ':Subject, #1: 1	أَجَازَ الْبِنَاءَ
u'جَازَ بِنَاءٌ':Subject, #5: 5	جَازَ بِنَاءُ
u'جَازَ بَيات':Predicate, #6: 6	جَازَ الْبِنَاءُ
u'جَازَ بَيْعٌ':Predicate, #1: 1	أَجَازَ الْبَيَاتَ
u'جَازَ بَيْعٌ':Predicate, #12: 12	أَجَازَ بَيْعَ
u'جَازَ بَيْعٌ':Subject, #62: 62	أَجَازَ الْبَيْعَ
u'جَازَ بَيْعٌ':Subject, #130: 130	جَازَ بَيْعُهُ
u'جَازَ بَيْعٌ':Subject, #262: 262	جَازَ الْبَيْعُ
u'جَازَ بَيْنٌ':Predicate, #48: 48	جَازَ بَيْعُ
u'جَازَ بَيِّنَةٌ':Predicate, #1: 1	جَازَ بَيْنَ
u'جَازَ تَأْجِيلٌ':Subject, #1: 1	أَجَازَ بَيِّنَةَ
u'جَازَ تَأْجِيلٌ':Subject, #2: 2	جَازَ التَّأْجِيلُ
u'جَازَ تَأْجِيلٌ':Subject, #2: 2	جَازَ تَأْجِيلُ
u'جَازَ تَأَخُّرٌ':Subject, #2: 2	جَازَ تَأْجِيلُهُ
u'جَازَ تَأْخِيرٌ':Predicate, #1: 1	جَازَ تَأَخُّرُهُ
u'جَازَ تَأْخِيرٌ':Subject, #3: 3	أَجَازَ تَأْخِيرَ
u'جَازَ تَأْخِيرٌ':Subject, #1: 1	جَازَ تَأْخِيرُهُ
u'جَازَ تَأْخِيرٌ':Subject, #7: 7	جَازَ تَأْخِيرُ
u'جَازَ تَأْكِيدٌ':Subject, #9: 9	جَازَ التَّأْخِيرُ
u'جَازَ تَبْدِيلٌ':Subject, #1: 1	جَازَ تَأْكِيدُ
u'جَازَ تَبَرُّعٌ':Subject, #1: 1	جَازَ تَبْدِيلُهُ
u'جَازَ تَبَسُّطٌ':Subject, #1: 1	جَازَ التَّبَرُّعُ
u'جَازَ تَبْعِيض':Subject, #1: 1	جَازَ التَّبَسُّطُ
u'جَازَ تَثْنِيَةٌ':Predicate, #1: 1	جَازَ تَبْعِيضُ
u'جَازَ تَحْكِيمٌ':Subject, #1: 1	أَجَازَ التّثْنِيَةَ
u'جَازَ تَحَلُّلٌ':Subject, #1: 1	جَازَ التَّحْكِيمُ
u'جَازَ تَخْصِيصٌ':Predicate, #3: 3	جَازَ التَّحَلُّلُ
u'جَازَ تَخْصِيصٌ':Predicate, #1: 1	أَجَازَ التَّخْصِيصَ
u'جَازَ تَخْصِيصٌ':Subject, #3: 3	أَجَازَ تَخْصِيصَ
u'جَازَ تَخْصِيصٌ':Subject, #10: 10	جَازَ التَّخْصِيصُ
u'جَازَ تَخْصِيصٌ':Subject, #8: 8	جَازَ تَخْصِيصُهُ
u'جَازَ تَخَلُّفٌ':Subject, #9: 9	جَازَ تَخْصِيصُ
u'جَازَ تَخَلُّفٌ':Subject, #1: 1	جَازَ التَّخَلُّفُ
u'جَازَ تَدَاخُلٌ':Subject, #2: 2	جَازَ تَخَلُّفُ
u'جَازَ تَدْبِيرٌ':Subject, #1: 1	جَازَ التَّدَاخُلُ
u'جَازَ تَدْبِيرٌ':Subject, #1: 1	جَازَ تَدْبِيرُ
u'جَازَ تَرْكٌ':Subject, #2: 2	جَازَ تَدْبِيرُهُ
u'جَازَ تَرْكٌ':Subject, #15: 15	جَازَ تَرْكُهُ
u'جَازَ تَرْكٌ':Subject, #1: 1	جَازَ التَّرْكُ
u'جَازَ تَرْكِيبٌ':Predicate, #4: 4	جَازَ تَرْكُ
u'جَازَ تَزَوُّجٌ':Subject, #1: 1	أَجَازَ التَّرْكِيبَ
u'جَازَ تَزَوُّجٌ':Subject, #2: 2	جَازَ التَّزَوُّجُ
u'جَازَ تَزْوِيجٌ':Subject, #3: 3	جَازَ تَزَوُّجُ
u'جَازَ تَزْوِيجٌ':Subject, #1: 1	جَازَ تَزْوِيجُ
u'جَازَ تَزْوِيجٌ':Subject, #1: 1	جَازَ تَزْوِيجُهُ
u'جَازَ تَسْبِيحٌ':Predicate, #2: 2	جَازَ التَّزْوِيجُ
u'جَازَ تَسْلِيمٌ':Subject, #1: 1	أَجَازَ التَّسْبِيحَ
u'جَازَ تَسْلِيمٌ':Subject, #1: 1	جَازَ تَسْلِيمُهُ
u'جَازَ تَسْلِيمٌ':Subject, #2: 2	جَازَ تَسْلِيمُ
u'جَازَ تَسْمِيَة':Subject, #4: 4	جَازَ التَّسْلِيمُ
u'جَازَ تَسْمِيَة':Subject, #1: 1	جَازَ تَسْمِيَتُهُ
u'جَازَ تَصَدُّقٌ':Subject, #2: 2	جَازَ تَسْمِيَةُ
u'جَازَ تَصَرُّفٌ':Subject, #6: 6	جَازَ التَّصَدُّقُ
u'جَازَ تَصَرُّفٌ':Subject, #12: 12	جَازَ التَّصَرُّفُ
u'جَازَ تَصَرُّفٌ':Subject, #20: 20	جَازَ تَصَرُّفُهُ
u'جَازَ تَصْرِيحٌ':Subject, #2: 2	جَازَ تَصَرُّفُ
u'جَازَ تَصْغِيرٌ':Subject, #1: 1	جَازَ التَّصْرِيحُ
u'جَازَ تَطْهِيرٌ':Subject, #1: 1	جَازَ تَصْغِيرُهُ
u'جَازَ تَطَوُّعٌ':Subject, #1: 1	جَازَ التَّطْهِيرُ
u'جَازَ تَطْوِيلٌ':Subject, #1: 1	جَازَ التَّطَوُّعُ
u'جَازَ تَطْيِيرٌ':Subject, #1: 1	جَازَ تَطْوِيلُ
u'جَازَ تَعَبُّدٌ':Subject, #1: 1	جَازَ التَّطْيِيرُ
u'جَازَ تَعْجِيل':Subject, #1: 1	جَازَ التَّعَبُّدُ
u'جَازَ تَعْجِيل':Subject, #4: 4	جَازَ التَّعْجِيلُ
u'جَازَ تَعَدُّدٌ':Subject, #4: 4	جَازَ تَعْجِيلُ
u'جَازَ تَعَدُّدٌ':Subject, #1: 1	جَازَ التَّعَدُّدُ
u'جَازَ تَعَرُّضٌ':Subject, #2: 2	جَازَ تَعَدُّدُ
u'جَازَ تَعْرِيبٌ':Subject, #1: 1	جَازَ التَّعَرُّضُ
u'جَازَ تَعْرِيضٌ':Subject, #1: 1	جَازَ تَعْرِيبُ
u'جَازَ تَعْزِير':Subject, #1: 1	جَازَ التَّعْرِيضُ
u'جَازَ تَعْزِير':Subject, #1: 1	جَازَ تَعْزِيرُ
u'جَازَ تَعَلُّقٌ':Predicate, #1: 1	جَازَ تَعْزِيرُهُ
u'جَازَ تَعْلِيقٌ':Subject, #1: 1	أَجَازَ التَّعَلُّقَ
u'جَازَ تَعْلِيقٌ':Subject, #2: 2	جَازَ التَّعْلِيقُ
u'جَازَ تَعْلِيقٌ':Subject, #2: 2	جَازَ تَعْلِيقُ
u'جَازَ تَعْلِيلٌ':Subject, #2: 2	جَازَ تَعْلِيقُهُ
u'جَازَ تَعْلِيلٌ':Subject, #1: 1	جَازَ تَعْلِيلُ
u'جَازَ تَعْلِيلٌ':Subject, #1: 1	جَازَ تَعْلِيلُهُ
u'جَازَ تَعْلِيمٌ':Subject, #5: 5	جَازَ التَّعْلِيلُ
u'جَازَ تَعْوِيلٌ':Subject, #1: 1	جَازَ تَعْلِيمُهُ
u'جَازَ تَغْطِيَةٌ':Subject, #1: 1	جَازَ التَّعْوِيلُ
u'جَازَ تَغْيِيرٌ':Subject, #2: 2	جَازَ تَغْطِيَةُ
u'جَازَ تَفَاضُلٌ':Subject, #1: 1	جَازَ التَّغْيِيرُ
u'جَازَ تَفَاضُلٌ':Subject, #1: 1	جَازَ تَفَاضُلُهُ
u'جَازَ تَفاوُت':Subject, #9: 9	جَازَ التَّفَاضُلُ
u'جَازَ تَفَرُّقٌ':Subject, #1: 1	جَازَ التَّفَاوُتُ
u'جَازَ تَفْرِيع':Subject, #3: 3	جَازَ التَّفَرُّقُ
u'جَازَ تَفْرِيقٌ':Subject, #1: 1	جَازَ تَفْرِيعُهُ
u'جَازَ تَفْرِيقٌ':Subject, #3: 3	جَازَ تَفْرِيقُهُ
u'جَازَ تَفْسِيرٌ':Subject, #5: 5	جَازَ التَّفْرِيقُ
u'جَازَ تَفْصِيلٌ':Subject, #1: 1	جَازَ تَفْسِيرُهُ
u'جَازَ تَفْضِيلٌ':Subject, #4: 4	جَازَ التَّفْصِيلُ
u'جَازَ تَفْضِيلٌ':Subject, #1: 1	جَازَ التَّفْضِيلُ
u'جَازَ تَفْوِيضٌ':Subject, #1: 1	جَازَ تَفْضِيلُ
u'جَازَ تَقَدُّمٌ':Subject, #1: 1	جَازَ التَّفْوِيضُ
u'جَازَ تَقْديرٌ':Subject, #1: 1	جَازَ تَقَدُّمُ
u'جَازَ تَقْديمٌ':Subject, #1: 1	جَازَ تَقْدِيرُهُ
u'جَازَ تَقْديمٌ':Subject, #3: 3	جَازَ التَّقْدِيمُ
u'جَازَ تَقْديمٌ':Subject, #4: 4	جَازَ تَقْدِيمُهُ
u'جَازَ تَقَرُّبٌ':Subject, #8: 8	جَازَ تَقْدِيمُ
u'جَازَ تَقْريرٌ':Subject, #1: 1	جَازَ التَّقَرُّبُ
u'جَازَ تَقْريرٌ':Subject, #1: 1	جَازَ تَقْرِيرُ
u'جَازَ تَقْليبٌ':Predicate, #1: 1	جَازَ تَقْرِيرُهُ
u'جَازَ تَقْليبٌ':Subject, #1: 1	أَجَازَ تَقْلِيبَ
u'جَازَ تَقْليبٌ':Subject, #1: 1	جَازَ تَقْلِيبُ
u'جَازَ تَقْليدٌ':Subject, #2: 2	جَازَ التَّقْلِيبُ
u'جَازَ تَقْليد':Subject, #1: 1	جَازَ التَّقْلِيدُ
u'جَازَ تَقْليدٌ':Subject, #1: 1	جَازَ التَّقْلِيدُ
u'جَازَ تَقْليد':Subject, #1: 1	جَازَ تَقْلِيدُ
u'جَازَ تَقْليدٌ':Subject, #1: 1	جَازَ تَقْلِيدُ
u'جَازَ تَقْليد':Subject, #8: 8	جَازَ تَقْلِيدُهُ
u'جَازَ تَقْيِيد':Subject, #8: 8	جَازَ تَقْلِيدُهُ
u'جَازَ تَكَشُّفٌ':Subject, #1: 1	جَازَ تَقْيِيدُ
u'جَازَ تَكْفيرٌ':Subject, #1: 1	جَازَ التَّكَشُّفُ
u'جَازَ تَكْفيرٌ':Subject, #1: 1	جَازَ التَّكْفِيرُ
u'جَازَ تَكْليفٌ':Predicate, #1: 1	جَازَ تَكْفِيرُهُ
u'جَازَ تَكْليفٌ':Predicate, #1: 1	أَجَازَ التَّكْلِيفَ
u'جَازَ تَكْميلٌ':Subject, #1: 1	أَجَازَ تَكْلِيفَ
u'جَازَ تَمْلِيك':Subject, #1: 1	جَازَ التَّكْمِيلُ
u'جَازَ تَمْلِيكٌ':Subject, #1: 1	جَازَ التَّمْلِيكُ
u'جَازَ تَنَاكُحٌ':Subject, #1: 1	جَازَ تَمْلِيكُهُ
u'جَازَ تَنَاوُلٌ':Subject, #1: 1	جَازَ التَّنَاكُحُ
u'جَازَ تَنَفُّلٌ':Subject, #2: 2	جَازَ تَنَاوُلُ
u'جَازَ تَنْفِيذٌ':Subject, #2: 2	جَازَ التَّنَفُّلُ
u'جَازَ تَنْفِيلٌ':Subject, #1: 1	جَازَ تَنْفِيذُهُ
u'جَازَ تَوَضُّؤٌ':Subject, #2: 2	جَازَ التَّنْفِيلُ
u'جَازَ تَوَقُّفٌ':Subject, #1: 1	جَازَ التَّوَضُّؤُ
u'جَازَ تَوَكُّلٌ':Predicate, #3: 3	جَازَ التَّوَقُّفُ
u'جَازَ تَوْكِيلٌ':Subject, #1: 1	أَجَازَ التَّوَكُّلَ
u'جَازَ تَوْكِيلٌ':Subject, #3: 3	جَازَ التَّوْكِيلُ
u'جَازَ تَيَمُّمٌ':Subject, #4: 4	جَازَ تَوْكِيلُهُ
u'جَازَ تَيَمُّمٌ':Subject, #10: 10	جَازَ التَّيَمُّمُ
u'جَازَ ثَالِثٌ':Subject, #3: 3	جَازَ تَيَمُّمُهُ
u'جَازَ ثَانِي':Predicate, #1: 1	جَازَ الثَّالِثُ
u'جَازَ ثَانِيَةٌ':Predicate, #1: 1	جَازَ الثَّانِيَةَ
u'جَازَ ثَلاثَةٌ':Subject, #1: 1	جَازَ الثَّانِيَةَ
u'جَازَ جَازٌ':Predicate, #1: 1	جَازَ ثَلَاثَةُ
u'جَازَ جَازٌ':Predicate, #18: 18	أَجَازَ جَازَ
u'جَازَ جُزْءٌ':Predicate, #1: 1	جَازَ جَازَ
u'جَازَ جُلُوسٌ':Subject, #1: 1	أَجَازَ الْجُزْءَ
u'جَازَ جُلُوسٌ':Subject, #1: 1	جَازَ الْجُلُوسُ
u'جَازَ جمع':Subject, #2: 2	جَازَ جُلُوسُهُ
u'جَازَ جَمْعٌ':Subject, #8: 8	جَازَ الْجَمْعُ
u'جَازَ جناح':Subject, #8: 8	جَازَ الْجَمْعُ
u'جَازَ جَنَاحٌ':Subject, #1: 1	جَازَ الْجَنَاحُ
u'جَازَ جِوَارٌ':Predicate, #1: 1	جَازَ الْجَنَاحُ
u'جَازَ حاكِمٌ':Subject, #1: 1	أَجَازَ جِوَارَ
u'جَازَ حالٌ':Predicate, #1: 1	أَجَازَ الْحَاكِمُ
u'جَازَ حَبْسٌ':Subject, #1: 1	أَجَازَ حَالَ
u'جَازَ حَجٌّ':Subject, #4: 4	جَازَ حَبْسُهُ
u'جَازَ حَجٌّ':Subject, #2: 2	جَازَ الْحَجُّ
u'جَازَ حَجْرٌ':Subject, #2: 2	جَازَ حَجُّهُ
u'جَازَ حَجْرٌ':Subject, #1: 1	جَازَ الْحَجْرُ
u'جَازَ حُدوثٌ':Subject, #1: 1	جَازَ حَجْرُهُ
u'جَازَ حَرْقٌ':Subject, #2: 2	جَازَ حُدُوثُ
u'جَازَ حُضورٌ':Subject, #1: 1	جَازَ حَرْقُهُ
u'جَازَ حُضُورٌ':Subject, #1: 1	جَازَ الْحُضُورُ
u'جَازَ حَطّ':Subject, #1: 1	جَازَ الْحُضُورُ
u'جَازَ حَفْرٌ':Subject, #2: 2	جَازَ الْحَطُّ
u'جَازَ حَفْرٌ':Subject, #1: 1	جَازَ الْحَفْرُ
u'جَازَ حُكْمٌ':Predicate, #1: 1	جَازَ حَفْرُ
u'جَازَ حُكْمٌ':Subject, #2: 2	أَجَازَ حُكْمَ
u'جَازَ حُكْمٌ':Subject, #10: 10	جَازَ الْحُكْمُ
u'جَازَ حَمْلٌ':Predicate, #4: 4	جَازَ حُكْمُهُ
u'جَازَ حَمْلٌ':Subject, #1: 1	أَجَازَ حَمْلَ
u'جَازَ حَمْلٌ':Subject, #1: 1	جَازَ حَمْلُهُ
u'جَازَ خراج':Predicate, #3: 3	جَازَ حَمْلُ
u'جَازَ خَرَاجٌ':Predicate, #1: 1	أَجَازَ الْخَرَاجَ
u'جَازَ خُرُوجٌ':Subject, #1: 1	أَجَازَ الْخَرَاجَ
u'جَازَ خُرُوجٌ':Subject, #2: 2	جَازَ خُرُوجُهُ
u'جَازَ خِطَابٌ':Subject, #5: 5	جَازَ الْخُرُوجُ
u'جَازَ خِلاَفٌ':Subject, #1: 1	جَازَ الْخِطَابُ
u'جَازَ خِلاَفٌ':Subject, #1: 1	جَازَ خِلَافُ
u'جَازَ خُلْعٌ':Subject, #1: 1	جَازَ خِلَافُهُ
u'جَازَ خَلْعٌ':Subject, #10: 10	جَازَ الْخُلْعُ
u'جَازَ خيار':Predicate, #2: 2	جَازَ الْخَلْعُ
u'جَازَ خِيَارٌ':Predicate, #5: 5	أَجَازَ الْخِيَارَ
u'جَازَ دَارٌ':Subject, #5: 5	أَجَازَ الْخِيَارَ
u'جَازَ دُخُولٌ':Subject, #1: 1	جَازَ دَارٌ
u'جَازَ دُخُولٌ':Subject, #2: 2	جَازَ دُخُولُ
u'جَازَ دفع':Subject, #3: 3	جَازَ الدُّخُولُ
u'جَازَ دَفْعٌ':Subject, #14: 14	جَازَ الدَّفْعُ
u'جَازَ دفع':Subject, #14: 14	جَازَ الدَّفْعُ
u'جَازَ دَفْعٌ':Subject, #5: 5	جَازَ دَفْعُهُ
u'جَازَ دفع':Subject, #5: 5	جَازَ دَفْعُهُ
u'جَازَ دَفْعٌ':Subject, #6: 6	جَازَ دَفْعُ
u'جَازَ دفن':Subject, #6: 6	جَازَ دَفْعُ
u'جَازَ دَفْنٌ':Subject, #2: 2	جَازَ الدَّفْنُ
u'جَازَ دفن':Subject, #2: 2	جَازَ الدَّفْنُ
u'جَازَ دَفْنٌ':Subject, #3: 3	جَازَ دَفْنُ
u'جَازَ دَقيقٌ':Subject, #3: 3	جَازَ دَفْنُ
u'جَازَ دَقيقٌ':Subject, #1: 1	جَازَ الدَّقِيقُ
u'جَازَ ذَكاةٌ':Predicate, #1: 1	جَازَ دَقِيقٌ
u'جَازَ ذكر':Predicate, #1: 1	أَجَازَ ذَكَاةَ
u'جَازَ ذَكَرٌ':Predicate, #1: 1	جَازَ ذَكَرَ
u'جَازَ ذكر':Subject, #1: 1	جَازَ ذَكَرَ
u'جَازَ ذِكْرٌ':Subject, #1: 1	جَازَ ذِكْرُ
u'جَازَ ذكر':Subject, #1: 1	جَازَ ذِكْرُ
u'جَازَ ذِكْرٌ':Subject, #2: 2	جَازَ ذِكْرُهُ
u'جَازَ رَاهِنٌ':Subject, #2: 2	جَازَ ذِكْرُهُ
u'جَازَ رَبُّ':Subject, #3: 3	أَجَازَ الرَّاهِنُ
u'جَازَ رُبُعٌ':Subject, #6: 6	أَجَازَ رَبُّ
u'جَازَ رُجْحانٌ':Subject, #1: 1	أَجَازَ الرُّبُعُ
u'جَازَ رَجُلٌ':Subject, #1: 1	جَازَ الرُّجْحَانُ
u'جَازَ رَجُلٌ':Subject, #1: 1	أَجَازَ الرَّجُلُ
u'جَازَ رُجُوعٌ':Subject, #1: 1	جَازَ رَجُلٌ
u'جَازَ رُجُوعٌ':Subject, #1: 1	جَازَ رُجُوعُهُ
u'جَازَ رَدٌّ':Predicate, #7: 7	جَازَ الرُّجُوعُ
u'جَازَ رَدٌّ':Subject, #1: 1	أَجَازَ الرَّدَّ
u'جَازَ رَدٌّ':Subject, #1: 1	جَازَ رَدُّ
u'جَازَ رَدٌّ':Subject, #1: 1	جَازَ رَدُّهُ
u'جَازَ رَسُولٌ':Subject, #3: 3	جَازَ الرَّدُّ
u'جَازَ رَفْضٌ':Subject, #7: 7	أَجَازَ رَسُولُ
u'جَازَ رَفْعٌ':Subject, #1: 1	جَازَ رَفْضُ
u'جَازَ رُكوبٌ':Subject, #2: 2	جَازَ رَفْعُهُ
u'جَازَ رَمْيٌ':Subject, #1: 1	جَازَ الرُّكُوبُ
u'جَازَ رَمْيٌ':Subject, #2: 2	جَازَ رَمْيُ
u'جَازَ رَهْنٌ':Predicate, #3: 3	جَازَ الرَّمْيُ
u'جَازَ رَهْنٌ':Subject, #1: 1	أَجَازَ الرَّهْنَ
u'جَازَ رَهْنٌ':Subject, #17: 17	جَازَ الرَّهْنُ
u'جَازَ رَهْنٌ':Subject, #2: 2	جَازَ رَهْنُ
u'جَازَ رِوايَةٌ':Predicate, #3: 3	جَازَ رَهْنُهُ
u'جَازَ رُؤْيَةٌ':Subject, #2: 2	أَجَازَ الرِّوَايَةَ
u'جَازَ زَوْجٌ':Subject, #1: 1	جَازَ رُؤْيَةُ
u'جَازَ زِيادَةٌ':Subject, #15: 15	أَجَازَ الزَّوْجُ
u'جَازَ سَاعَةٌ':Predicate, #2: 2	جَازَ الزِّيَادَةُ
u'جَازَ سَائِرٌ':Subject, #1: 1	جَازَ السَّاعَةَ
u'جَازَ سَبْيٌ':Subject, #1: 1	أَجَازَ سَائِرُ
u'جَازَ سُجُودٌ':Subject, #1: 1	جَازَ سَبْيُهُ
u'جَازَ سَفَرٌ':Subject, #1: 1	جَازَ السُّجُودُ
u'جَازَ سقط':Predicate, #2: 2	جَازَ السَّفَرُ
u'جَازَ سَقَطٌ':Predicate, #1: 1	أَجَازَ سَقَطَ
u'جَازَ سَقْيٌ':Subject, #1: 1	أَجَازَ سَقَطَ
u'جَازَ سَلَفٌ':Subject, #1: 1	جَازَ سَقْيُ
u'جَازَ سَلَمٌ':Predicate, #1: 1	أَجَازَ سَلَفُ
u'جَازَ سَلَمٌ':Subject, #2: 2	أَجَازَ السَّلَمَ
u'جَازَ سَمَاعٌ':Subject, #15: 15	جَازَ السَّلَمُ
u'جَازَ سَواءٌ':Subject, #1: 1	جَازَ سَمَاعُ
u'جَازَ سَيِّدٌ':Subject, #26: 26	جَازَ سَوَاءٌ
u'جَازَ شافِعِيّ':Subject, #3: 3	أَجَازَ السَّيِّدُ
u'جَازَ شِرَاءٌ':Predicate, #1: 1	أَجَازَ الشَّافِعِيُّ
u'جَازَ شِرَاءٌ':Subject, #1: 1	أَجَازَ الشِّرَاءَ
u'جَازَ شِرَاءٌ':Subject, #19: 19	جَازَ الشِّرَاءُ
u'جَازَ شرب':Subject, #6: 6	جَازَ شِرَاءُ
u'جَازَ شُرْبٌ':Subject, #1: 1	جَازَ الشُّرْبُ
u'جَازَ شَرْطٌ':Predicate, #1: 1	جَازَ الشُّرْبُ
u'جَازَ شَرْطٌ':Predicate, #1: 1	أَجَازَ الشَّرْطَ
u'جَازَ شَرَطٌ':Predicate, #1: 1	أَجَازَ شَرْطَ
u'جَازَ شَرْطٌ':Subject, #1: 1	جَازَ شَرَطَ
u'جَازَ شَرْطٌ':Subject, #2: 2	جَازَ الشَّرْطُ
u'جَازَ شَرْطٌ':Subject, #2: 2	جَازَ شَرْطُهُ
u'جَازَ شَرْعٌ':Subject, #3: 3	جَازَ شَرْطُ
u'جَازَ شُرُوعٌ':Subject, #1: 1	أَجَازَ الشَّرْعُ
u'جَازَ شَرِيكٌ':Subject, #1: 1	جَازَ شُرُوعُهُ
u'جَازَ شَرِيكٌ':Subject, #2: 2	أَجَازَ الشَّرِيكُ
u'جَازَ شَفِيعٌ':Subject, #4: 4	أَجَازَ شَرِيكُهُ
u'جَازَ شَكٌّ':Subject, #2: 2	أَجَازَ الشَّفِيعُ
u'جَازَ شَهَادَةٌ':Predicate, #1: 1	جَازَ الشَّكُّ
u'جَازَ شَهَادَةٌ':Subject, #23: 23	أَجَازَ شَهَادَةَ
u'جَازَ شَهَادَةٌ':Subject, #1: 1	أَجَازَ شَهَادَةُ
u'جَازَ شَيْخٌ':Subject, #1: 1	جَازَ شَهَادَةُ
u'جَازَ صَاحِبٌ':Subject, #1: 1	أَجَازَ الشَّيْخُ
u'جَازَ صَاحِبٌ':Subject, #5: 5	أَجَازَ صَاحِبُهُ
u'جَازَ صَبِيٌّ':Subject, #7: 7	أَجَازَ صَاحِبُ
u'جَازَ صَحَابَةٌ':Subject, #1: 1	أَجَازَ الصَّبِيُّ
u'جَازَ صدقة':Predicate, #1: 1	أَجَازَ الصَّحَابَةُ
u'جَازَ صَدَقَةٌ':Predicate, #1: 1	أَجَازَ الصَّدَقَةَ
u'جَازَ صَرْفٌ':Subject, #1: 1	أَجَازَ الصَّدَقَةَ
u'جَازَ صَرْف':Subject, #11: 11	جَازَ صَرْفُ
u'جَازَ صَرْفٌ':Subject, #11: 11	جَازَ صَرْفُ
u'جَازَ صَرْف':Subject, #3: 3	جَازَ صَرْفُهُ
u'جَازَ صَرْفٌ':Subject, #3: 3	جَازَ صَرْفُهُ
u'جَازَ صَرْف':Subject, #5: 5	جَازَ الصَّرْفُ
u'جَازَ صَلاَةٌ':Predicate, #5: 5	جَازَ الصَّرْفُ
u'جَازَ صَلاَةٌ':Subject, #1: 1	أَجَازَ الصَّلَاةَ
u'جَازَ صَلاَةٌ':Subject, #1: 1	جَازَ الصَّلَاةُ
u'جَازَ صلح':Predicate, #5: 5	جَازَ صَلَاةُ
u'جَازَ صُلْحٌ':Predicate, #2: 2	أَجَازَ الصُّلْحَ
u'جَازَ صلح':Subject, #2: 2	أَجَازَ الصُّلْحَ
u'جَازَ صُلْحٌ':Subject, #3: 3	جَازَ صُلْحُ
u'جَازَ صلح':Subject, #3: 3	جَازَ صُلْحُ
u'جَازَ صُلْحٌ':Subject, #3: 3	جَازَ صُلْحُهُ
u'جَازَ صلح':Subject, #3: 3	جَازَ صُلْحُهُ
u'جَازَ صُلْحٌ':Subject, #59: 59	جَازَ الصُّلْحُ
u'جَازَ صَنِيعٌ':Predicate, #59: 59	جَازَ الصُّلْحُ
u'جَازَ صَوْمٌ':Predicate, #2: 2	أَجَازَ صَنِيعَ
u'جَازَ صَوْمٌ':Subject, #2: 2	أَجَازَ صَوْمَ
u'جَازَ صَوْمٌ':Subject, #1: 1	جَازَ صَوْمُ
u'جَازَ صَوْمٌ':Subject, #4: 4	جَازَ الصَّوْمُ
u'جَازَ صَيْدٌ':Subject, #8: 8	جَازَ صَوْمُهُ
u'جَازَ ضحك':Predicate, #1: 1	جَازَ الصَّيْدُ
u'جَازَ ضَحِكٌ':Predicate, #1: 1	أَجَازَ الضَّحِكَ
u'جَازَ ضَرْبٌ':Predicate, #1: 1	أَجَازَ الضَّحِكَ
u'جَازَ ضَرْبٌ':Subject, #2: 2	أَجَازَ ضَرْبَ
u'جَازَ ضَمٌّ':Subject, #1: 1	جَازَ ضَرْبُ
u'جَازَ ضَمَانٌ':Subject, #1: 1	جَازَ ضَمُّ
u'جَازَ طَالِبٌ':Subject, #1: 1	جَازَ ضَمَانُهُ
u'جَازَ طُعْمٌ':Subject, #2: 2	أَجَازَ الطَّالِبُ
u'جَازَ طَلاَقٌ':Predicate, #1: 1	جَازَ الطُّعْمُ
u'جَازَ طَلاَقٌ':Subject, #1: 1	أَجَازَ الطَّلاَقَ
u'جَازَ طَلاَقٌ':Subject, #1: 1	جَازَ طَلَاقُ
u'جَازَ طَلاَقٌ':Subject, #2: 2	جَازَ طَلاَقُهُ
u'جَازَ طواف':Subject, #3: 3	جَازَ طَلَاقُهُ
u'جَازَ طَوَافٌ':Subject, #6: 6	جَازَ طَوَافُهُ
u'جَازَ ظاهِرٌ':Subject, #6: 6	جَازَ طَوَافُهُ
u'جَازَ ظَنٌّ':Subject, #1: 1	جَازَ ظَاهِرُهُ
u'جَازَ عَامِلٌ':Subject, #1: 1	جَازَ ظَنُّهُ
u'جَازَ عَبْدٌ':Subject, #1: 1	أَجَازَ الْعَامِلُ
u'جَازَ عَبْدٌ':Subject, #1: 1	أَجَازَ عَبْدُ
u'جَازَ عتق':Predicate, #4: 4	أَجَازَ الْعَبْدُ
u'جَازَ عِتْقٌ':Predicate, #2: 2	أَجَازَ عِتْقَ
u'جَازَ عتق':Subject, #2: 2	أَجَازَ عِتْقَ
u'جَازَ عِتْقٌ':Subject, #18: 18	جَازَ الْعِتْقُ
u'جَازَ عتق':Subject, #18: 18	جَازَ الْعِتْقُ
u'جَازَ عِتْقٌ':Subject, #29: 29	جَازَ عِتْقُهُ
u'جَازَ عتق':Subject, #29: 29	جَازَ عِتْقُهُ
u'جَازَ عِتْقٌ':Subject, #6: 6	جَازَ عِتْقُ
u'جَازَ عزل':Subject, #6: 6	جَازَ عِتْقُ
u'جَازَ عطف':Subject, #3: 3	جَازَ عَزْلُهُ
u'جَازَ عَطْفٌ':Subject, #1: 1	جَازَ الْعَطْفُ
u'جَازَ عَفْوٌ':Subject, #1: 1	جَازَ الْعَطْفُ
u'جَازَ عَفْوٌ':Subject, #1: 1	جَازَ الْعَفْوُ
u'جَازَ عَقْدٌ':Predicate, #4: 4	جَازَ عَفْوُهُ
u'جَازَ عَقْدٌ':Predicate, #2: 2	أَجَازَ عَقْدَ
u'جَازَ عَقْدٌ':Subject, #8: 8	أَجَازَ الْعَقْدَ
u'جَازَ عَقْدٌ':Subject, #1: 1	جَازَ عَقْدٌ
u'جَازَ عَقْدٌ':Subject, #1: 1	جَازَ عَقْدُهُ
u'جَازَ عَكْسٌ':Subject, #29: 29	جَازَ الْعَقْدُ
u'جَازَ عَلاءٌ':Subject, #2: 2	جَازَ عَكْسُهُ
u'جَازَ علماء':Subject, #1: 1	جَازَ الْعَلَاءُ
u'جَازَ عُلَمَاءُ':Subject, #2: 2	أَجَازَ الْعُلَمَاءُ
u'جَازَ عَمٌّ':Subject, #2: 2	أَجَازَ الْعُلَمَاءُ
u'جَازَ عُمَرٌ':Subject, #1: 1	أَجَازَ الْعَمُّ
u'جَازَ عَمَلٌ':Subject, #1: 1	أَجَازَ عُمَرُ
u'جَازَ عند':Predicate, #1: 1	جَازَ الْعَمَلُ
u'جَازَ عند':Predicate, #148: 148	جَازَ عِنْدَ
u'جَازَ عَوْدٌ':Subject, #1: 1	أَجَازَ عِنْدَ
u'جَازَ عِوَضٌ':Subject, #1: 1	جَازَ عَوْدُ
u'جَازَ غَائِبٌ':Subject, #1: 1	جَازَ الْعِوَضُ
u'جَازَ غرماء':Subject, #2: 2	أَجَازَ الْغَائِبُ
u'جَازَ غَرِيمٌ':Subject, #4: 4	أَجَازَ الْغُرَمَاءُ
u'جَازَ غُسْلٌ':Subject, #1: 1	أَجَازَ غَرِيمُ
u'جَازَ غَسْلٌ':Subject, #1: 1	جَازَ الْغُسْلُ
u'جَازَ غُسْلٌ':Subject, #1: 1	جَازَ غَسْلُهُ
u'جَازَ غير':Subject, #1: 1	جَازَ غُسْلُهُ
u'جَازَ غَيْرٌ':Subject, #1: 1	أَجَازَ الْغَيْرُ
u'جَازَ غير':Subject, #1: 1	أَجَازَ الْغَيْرُ
u'جَازَ غَيْرٌ':Subject, #1: 1	أَجَازَ غَيْرُهُ
u'جَازَ غير':Subject, #1: 1	أَجَازَ غَيْرُهُ
u'جَازَ غَيْرٌ':Subject, #1: 1	جَازَ غَيْرُهُ
u'جَازَ فَتْحٌ':Subject, #1: 1	جَازَ غَيْرُهُ
u'جَازَ فَجْرٌ':Subject, #1: 1	جَازَ الْفَتْحُ
u'جَازَ فِدَاءٌ':Subject, #1: 1	جَازَ الْفَجْرُ
u'جَازَ فرار':Subject, #1: 1	جَازَ الْفِدَاءُ
u'جَازَ فِرَارٌ':Subject, #2: 2	جَازَ الْفِرَارُ
u'جَازَ فَسْخٌ':Predicate, #2: 2	جَازَ الْفِرَارُ
u'جَازَ فَسْخٌ':Subject, #1: 1	أَجَازَ الْفَسْخَ
u'جَازَ فَسْخٌ':Subject, #1: 1	جَازَ فَسْخُ
u'جَازَ فَضْلٌ':Subject, #5: 5	جَازَ الْفَسْخُ
u'جَازَ فِطْرٌ':Subject, #1: 1	جَازَ الْفَضْلُ
u'جَازَ فِطْرٌ':Subject, #1: 1	جَازَ فِطْرُهُ
u'جَازَ فِعْلٌ':Subject, #2: 2	جَازَ الْفِطْرُ
u'جَازَ فِعْلٌ':Subject, #2: 2	جَازَ فِعْلُ
u'جَازَ فقهاء':Subject, #9: 9	جَازَ فِعْلُهُ
u'جَازَ فلان':Subject, #1: 1	أَجَازَ الْفُقَهَاءُ
u'جَازَ فُلاَنٌ':Subject, #1: 1	أَجَازَ الشَّافِعِيُّ
u'جَازَ فلان':Subject, #1: 1	أَجَازَ فُلَانٌ
u'جَازَ قَالٌ':Predicate, #1: 1	جَازَ جُبْرَانٌ
u'جَازَ قَالٌ':Predicate, #1: 1	أَجَازَ قَالَ
u'جَازَ قَبْضٌ':Subject, #28: 28	جَازَ قَالَ
u'جَازَ قَبْضٌ':Subject, #4: 4	جَازَ الْقَبْضُ
u'جَازَ قَبْضٌ':Subject, #7: 7	جَازَ قَبْضُ
u'جَازَ قَبُولٌ':Subject, #8: 8	جَازَ قَبْضُهُ
u'جَازَ قَبُولٌ':Subject, #2: 2	جَازَ قَبُولُهُ
u'جَازَ قتل':Subject, #6: 6	جَازَ قَبُولُ
u'جَازَ قَتْلٌ':Subject, #1: 1	جَازَ قَتْلُ
u'جَازَ قتل':Subject, #1: 1	جَازَ قَتْلُ
u'جَازَ قَتْلٌ':Subject, #3: 3	جَازَ قَتْلُهُ
u'جَازَ قذف':Subject, #3: 3	جَازَ قَتْلُهُ
u'جَازَ قَذْفٌ':Subject, #1: 1	جَازَ قَذْفُهُ
u'جَازَ قِرَاءةٌ':Subject, #1: 1	جَازَ قَذْفُهُ
u'جَازَ قَرْضٌ':Subject, #1: 1	جَازَ قِرَاءَتُهُ
u'جَازَ قَسْمٌ':Subject, #5: 5	جَازَ قَرْضُهُ
u'جَازَ قسمة':Predicate, #2: 2	جَازَ قَسْمُهُ
u'جَازَ قِسْمَةٌ':Predicate, #1: 1	أَجَازَ قِسْمَةَ
u'جَازَ قسمة':Predicate, #1: 1	أَجَازَ قِسْمَةَ
u'جَازَ قِسْمَةٌ':Predicate, #3: 3	أَجَازَ الْقِسْمَةَ
u'جَازَ قسمة':Subject, #3: 3	أَجَازَ الْقِسْمَةَ
u'جَازَ قِسْمَةٌ':Subject, #1: 1	جَازَ قِسْمَتُهُ
u'جَازَ قَصْرٌ':Subject, #1: 1	جَازَ قِسْمَتُهُ
u'جَازَ قَضَاءٌ':Predicate, #2: 2	جَازَ الْقَصْرُ
u'جَازَ قَضَاءٌ':Predicate, #1: 1	أَجَازَ الْقَضَاءَ
u'جَازَ قَضَاءٌ':Subject, #1: 1	أَجَازَ قَضَاءَ
u'جَازَ قَضَاءٌ':Subject, #3: 3	جَازَ قَضَاءُ
u'جَازَ قَطْعٌ':Subject, #6: 6	جَازَ الْقَضَاءُ
u'جَازَ قلب':Subject, #2: 2	جَازَ قَطْعُهُ
u'جَازَ قَلْبٌ':Subject, #1: 1	جَازَ قَلْبُهُ
u'جَازَ قَلْب':Subject, #1: 1	جَازَ قَلْبُهُ
u'جَازَ قَمْحٌ':Predicate, #1: 1	جَازَ قَلْبُهُ
u'جَازَ قَمْحٌ':Subject, #1: 1	أَجَازَ الْقَمْحَ
u'جَازَ قول':Subject, #1: 1	جَازَ قَمْحٌ
u'جَازَ قَوْلٌ':Subject, #1: 1	جَازَ الْقَوْلُ
u'جَازَ قول':Subject, #1: 1	جَازَ الْقَوْلُ
u'جَازَ قَوْلٌ':Subject, #5: 5	جَازَ قَوْلُهُ
u'جَازَ قَوْمٌ':Subject, #5: 5	جَازَ قَوْلُهُ
u'جَازَ قِيَاسٌ':Subject, #2: 2	أَجَازَ قَوْمٌ
u'جَازَ قيام':Subject, #9: 9	جَازَ الْقِيَاسُ
u'جَازَ قِيَامٌ':Subject, #2: 2	جَازَ قِيَامُ
u'جَازَ قَيْدٌ':Subject, #2: 2	جَازَ قِيَامُ
u'جَازَ قِيمَةٌ':Predicate, #1: 1	جَازَ قَيْدُ
u'جَازَ كِتَابٌ':Subject, #1: 1	أَجَازَ الْقِيمَةَ
u'جَازَ كِتَابَةٌ':Predicate, #1: 1	جَازَ كِتَابُ
u'جَازَ كذب':Predicate, #6: 6	أَجَازَ الْكِتَابَةَ
u'جَازَ كَذِبٌ':Predicate, #1: 1	أَجَازَ الْكَذِبَ
u'جَازَ كذب':Subject, #1: 1	أَجَازَ الْكَذِبَ
u'جَازَ كَذِبٌ':Subject, #1: 1	جَازَ الْكَذِبُ
u'جَازَ كذب':Subject, #1: 1	جَازَ الْكَذِبُ
u'جَازَ كَذِبٌ':Subject, #2: 2	جَازَ كَذِبُهُ
u'جَازَ كِرَاءٌ':Predicate, #2: 2	جَازَ كَذِبُهُ
u'جَازَ كِرَاءٌ':Predicate, #1: 1	أَجَازَ كِرَاءَ
u'جَازَ كِرَاءٌ':Subject, #2: 2	أَجَازَ الْكِرَاءَ
u'جَازَ كَفَالَةٌ':Predicate, #1: 1	جَازَ كِرَاءُ
u'جَازَ كَلاَمٌ':Predicate, #1: 1	أَجَازَ الْكَفَالَةَ
u'جَازَ كَلاَمٌ':Subject, #4: 4	أَجَازَ الْكَلَامَ
u'جَازَ كَوْنٌ':Subject, #1: 1	جَازَ الْكَلَامُ
u'جَازَ كَوْنٌ':Subject, #3: 3	جَازَ كَوْنُ
u'جَازَ لِبَاسٌ':Subject, #5: 5	جَازَ كَوْنُهُ
u'جَازَ لبس':Predicate, #1: 1	جَازَ لِبَاسُ
u'جَازَ لُبْسٌ':Predicate, #1: 1	أَجَازَ لُبْسَ
u'جَازَ لبس':Subject, #1: 1	أَجَازَ لُبْسَ
u'جَازَ لُبْسٌ':Subject, #1: 1	جَازَ اللُّبْسُ
u'جَازَ لبس':Subject, #1: 1	جَازَ اللُّبْسُ
u'جَازَ لُبْسٌ':Subject, #1: 1	جَازَ لُبْسُهُ
u'جَازَ لعب':Predicate, #1: 1	جَازَ لُبْسُهُ
u'جَازَ لَعِبٌ':Predicate, #1: 1	أَجَازَ اللَّعِبَ
u'جَازَ لعب':Subject, #1: 1	أَجَازَ اللَّعِبَ
u'جَازَ لَعِبٌ':Subject, #1: 1	جَازَ اللَّعِبُ
u'جَازَ مَالِكٌ':Subject, #1: 1	جَازَ اللَّعِبُ
u'جَازَ مَالِكٌ':Subject, #1: 1	أَجَازَ مَالِكُهُ
u'جَازَ مَالِكٌ':Subject, #23: 23	أَجَازَ مَالِكٌ
u'جَازَ مَأْمُورٌ':Subject, #25: 25	أَجَازَ الْمَالِكُ
u'جَازَ مثل':Subject, #1: 1	أَجَازَ الْمَأْمُورُ
u'جَازَ مِثْلٌ':Subject, #2: 2	جَازَ مِثْلُهُ
u'جَازَ مَجَازٌ':Subject, #2: 2	جَازَ مِثْلُهُ
u'جَازَ مُجْبِرٌ':Subject, #1: 1	جَازَ الْمَجَازُ
u'جَازَ مُخَالَفَةٌ':Subject, #2: 2	أَجَازَ مُجْبِرٌ
u'جَازَ مَدْحٌ':Subject, #1: 1	جَازَ مُخَالَفَةُ
u'جَازَ مَذْكُورٌ':Subject, #1: 1	جَازَ مَدْحُ
u'جَازَ مُرَاجَعَةٌ':Predicate, #1: 1	جَازَ مَذْكُورَةٌ
u'جَازَ مُرَاعَاةٌ':Subject, #2: 2	أَجَازَ مُرَاجَعَةَ
u'جَازَ مُرْتَهِنٌ':Subject, #1: 1	جَازَ مُرَاعَاةُ
u'جَازَ مُرُورٌ':Subject, #12: 12	أَجَازَ الْمُرْتَهِنُ
u'جَازَ مَرِيضٌ':Subject, #1: 1	جَازَ الْمُرُورُ
u'جَازَ مُزَارِعٌ':Subject, #2: 2	أَجَازَ الْمَرِيضُ
u'جَازَ مَسٌّ':Subject, #7: 7	أَجَازَ الْمُزَارِعُ
u'جَازَ مَسٌّ':Subject, #1: 1	جَازَ الْمَسُّ
u'جَازَ مُسْتَأْجِرٌ':Subject, #2: 2	جَازَ مَسُّهُ
u'جَازَ مُسْتَحِقٌّ':Predicate, #4: 4	أَجَازَ الْمُسْتَأْجِرُ
u'جَازَ مُسْتَحِقٌّ':Subject, #1: 1	أَجَازَ الْمُسْتَحِقَّ
u'جَازَ مُسْتَحَقٌّ':Subject, #19: 19	أَجَازَ الْمُسْتَحِقُّ
u'جَازَ مُسْتَحِقٌّ':Subject, #1: 1	أَجَازَ الْمُسْتَحَقُّ
u'جَازَ مَسْجِدٌ':Predicate, #1: 1	أَجَازَ مُسْتَحِقُّ
u'جَازَ مَسْجِدٌ':Subject, #1: 1	أَجَازَ الْمَسْجِدَ
u'جَازَ مَسْحٌ':Predicate, #2: 2	جَازَ الْمَسْجِدُ
u'جَازَ مَسْحٌ':Subject, #1: 1	أَجَازَ الْمَسْحَ
u'جَازَ مَسْحٌ':Subject, #1: 1	جَازَ مَسْحُ
u'جَازَ مَسْحٌ':Subject, #1: 1	جَازَ مَسْحُهُ
u'جَازَ مُسَلَّمٌ':Subject, #39: 39	جَازَ الْمَسْحُ
u'جَازَ مُشَارَكَةٌ':Subject, #1: 1	جَازَ الْمُسَلَّمُ
u'جَازَ مُشْكِلٌ':Subject, #1: 1	جَازَ مُشَارَكَةُ
u'جَازَ مَشْيٌ':Subject, #1: 1	جَازَ مُشْكِلٌ
u'جَازَ مَشْيٌ':Subject, #1: 1	جَازَ الْمَشْيُ
u'جَازَ مَطْلُوبٌ':Subject, #1: 1	جَازَ مَشْيُهُ
u'جَازَ مُعَامَلَةٌ':Predicate, #1: 1	أَجَازَ الْمَطْلُوبُ
u'جَازَ مَعْدُومٌ':Predicate, #1: 1	أَجَازَ الْمُعَامَلَةَ
u'جَازَ مَغْصُوب':Subject, #1: 1	أَجَازَ الْمَعْدُومَ
u'جَازَ مَفْرُوشٌ':Predicate, #1: 1	أَجَازَ الْمَغْصُوبُ
u'جَازَ مَفْهُومٌ':Predicate, #1: 1	جَازَ مَفْرُوشَةً
u'جَازَ مُكَاتَبَةٌ':Predicate, #1: 1	أَجَازَ الْمَفْهُومَ
u'جَازَ مَكَانٌ':Predicate, #1: 1	أَجَازَ الْمُكَاتَبَةَ
u'جَازَ مَكَانٌ':Subject, #1: 1	جَازَ الْمَكَانَ
u'جَازَ مُكْرِهٌ':Subject, #1: 1	جَازَ الْمَكَانُ
u'جَازَ مَلِكٌ':Subject, #1: 1	أَجَازَ الْمُكْرِهُ
u'جَازَ مَنٌّ':Subject, #1: 1	أَجَازَ مَلِكُ
u'جَازَ مَنْعٌ':Subject, #1: 1	جَازَ الْمَنُّ
u'جَازَ مَوْقُوفٌ':Predicate, #2: 2	جَازَ الْمَنْعُ
u'جَازَ مُوَكِّلٌ':Subject, #1: 1	أَجَازَ الْمَوْقُوفَ
u'جَازَ نَبْذٌ':Subject, #4: 4	أَجَازَ الْمُوَكِّلُ
u'جَازَ نَحْوٌ':Subject, #1: 1	جَازَ نَبْذُهُ
u'جَازَ نخلة':Subject, #1: 1	جَازَ نَحْوُ
u'جَازَ نَخْلَةٌ':Subject, #1: 1	جَازَ نَخْلَةٌ
u'جَازَ نذر':Subject, #1: 1	جَازَ نَخْلَةٌ
u'جَازَ نَذْرٌ':Subject, #1: 1	جَازَ النَّذْرُ
u'جَازَ نَصٌّ':Predicate, #1: 1	جَازَ النَّذْرُ
u'جَازَ نصب':Subject, #5: 5	جَازَ نَصَّ
u'جَازَ نَصْبٌ':Subject, #1: 1	جَازَ النّصْبُ
u'جَازَ نُصْبٌ':Subject, #1: 1	جَازَ النّصْبُ
u'جَازَ نِصْفٌ':Predicate, #1: 1	جَازَ النّصْبُ
u'جَازَ نِصْفٌ':Subject, #1: 1	أَجَازَ النِّصْفَ
u'جَازَ نُطْقٌ':Subject, #1: 1	جَازَ نِصْفُ
u'جَازَ نَظَرٌ':Predicate, #1: 1	جَازَ النّطْقُ
u'جَازَ نَظَرٌ':Predicate, #1: 1	أَجَازَ النَّظَرَ
u'جَازَ نَظَرٌ':Subject, #1: 1	جَازَ نَظَرَ
u'جَازَ نَظَرٌ':Subject, #3: 3	جَازَ نَظَرُهُ
u'جَازَ نَفَذٌ':Predicate, #6: 6	جَازَ النَّظَرُ
u'جَازَ نَفَلٌ':Subject, #3: 3	أَجَازَ نَفَذَ
u'جَازَ نَفْلٌ':Subject, #1: 1	جَازَ النَّفَلُ
u'جَازَ نَفْيٌ':Subject, #3: 3	جَازَ نَفْلُ
u'جَازَ نَقْدٌ':Subject, #4: 4	جَازَ نَفْيُهُ
u'جَازَ نَقْد':Subject, #2: 2	جَازَ النَّقْدُ
u'جَازَ نَقْدٌ':Subject, #2: 2	جَازَ النَّقْدُ
u'جَازَ نَقْد':Subject, #2: 2	جَازَ نَقْدُ
u'جَازَ نَقْشٌ':Subject, #2: 2	جَازَ نَقْدُ
u'جَازَ نُقْصَانٌ':Subject, #1: 1	جَازَ النَّقْشُ
u'جَازَ نَقْضٌ':Subject, #1: 1	جَازَ النُّقْصَانُ
u'جَازَ نَقْضٌ':Subject, #1: 1	جَازَ نَقْضُ
u'جَازَ نَقْضٌ':Subject, #2: 2	جَازَ النَّقْضُ
u'جَازَ نقل':Predicate, #5: 5	جَازَ نَقْضُهُ
u'جَازَ نَقَلٌ':Predicate, #1: 1	جَازَ نَقَلَ
u'جَازَ نقل':Subject, #1: 1	جَازَ نَقَلَ
u'جَازَ نَقْلٌ':Subject, #2: 2	جَازَ نَقْلُهُ
u'جَازَ نقل':Subject, #2: 2	جَازَ نَقْلُهُ
u'جَازَ نَقْلٌ':Subject, #5: 5	جَازَ النَّقْلُ
u'جَازَ نقل':Subject, #5: 5	جَازَ النَّقْلُ
u'جَازَ نَقْلٌ':Subject, #6: 6	جَازَ نَقْلُ
u'جَازَ نكاح':Predicate, #6: 6	جَازَ نَقْلُ
u'جَازَ نِكَاحٌ':Predicate, #10: 10	أَجَازَ نِكَاحَ
u'جَازَ نكاح':Predicate, #10: 10	أَجَازَ نِكَاحَ
u'جَازَ نِكَاحٌ':Predicate, #1: 1	أَجَازَ نِكَاحَهُنَّ
u'جَازَ نكاح':Predicate, #1: 1	أَجَازَ نِكَاحَهُنَّ
u'جَازَ نِكَاحٌ':Predicate, #4: 4	أَجَازَ النِّكَاحَ
u'جَازَ نكاح':Subject, #4: 4	أَجَازَ النِّكَاحَ
u'جَازَ نِكَاحٌ':Subject, #36: 36	جَازَ نِكَاحُ
u'جَازَ نكاح':Subject, #36: 36	جَازَ نِكَاحُ
u'جَازَ نِكَاحٌ':Subject, #8: 8	جَازَ نِكَاحُهُ
u'جَازَ نكاح':Subject, #8: 8	جَازَ نِكَاحُهُ
u'جَازَ نِكَاحٌ':Subject, #94: 94	جَازَ النِّكَاحُ
u'جَازَ نَهْيٌ':Subject, #94: 94	جَازَ النِّكَاحُ
u'جَازَ نِيَّةٌ':Subject, #2: 2	جَازَ نَهْيُهُ
u'جَازَ هِبَةٌ':Predicate, #2: 2	جَازَ نِيَّتُهُ
u'جَازَ هِبَةٌ':Subject, #1: 1	أَجَازَ هِبَةَ
u'جَازَ هِبَةٌ':Subject, #2: 2	جَازَ هِبَةُ
u'جَازَ هجر':Subject, #2: 2	جَازَ هِبَتُهُ
u'جَازَ هَجْرٌ':Subject, #1: 1	جَازَ هَجْرُهُ
u'جَازَ واحد':Subject, #1: 1	جَازَ هَجْرُهُ
u'جَازَ وَاحِدٌ':Subject, #2: 2	أَجَازَ وَاحِدٌ
u'جَازَ وَادِي':Predicate, #2: 2	أَجَازَ وَاحِدٌ
u'جَازَ وَارِثٌ':Predicate, #1: 1	أَجَازَ الْوَادِيَ
u'جَازَ وَارِثٌ':Subject, #1: 1	أَجَازَ الْوَارِثَ
u'جَازَ وَارِثٌ':Subject, #1: 1	أَجَازَ وَارِثٌ
u'جَازَ وَارِثٌ':Subject, #2: 2	أَجَازَ وَارِثُهُ
u'جَازَ وَجَبٌ':Predicate, #9: 9	أَجَازَ الْوَارِثُ
u'جَازَ وَجَبٌ':Predicate, #1: 1	أَجَازَ وَجَبَ
u'جَازَ وُجُوبٌ':Subject, #8: 8	جَازَ وَجَبَ
u'جَازَ وَرَثَةٌ':Subject, #1: 1	جَازَ وُجُوبُهُ
u'جَازَ وُرُودٌ':Subject, #7: 7	أَجَازَ الْوَرَثَةُ
u'جَازَ وَسْمٌ':Subject, #1: 1	جَازَ وُرُودُ
u'جَازَ وَصِيٌّ':Predicate, #1: 1	جَازَ الْوَسْمُ
u'جَازَ وَصِيٌّ':Predicate, #2: 2	أَجَازَ الْوَصِيَّةَ
u'جَازَ وَصِيٌّ':Subject, #7: 7	أَجَازَ وَصِيَّةَ
u'جَازَ وَصِيَّةٌ':Predicate, #2: 2	أَجَازَ الْوَصِيُّ
u'جَازَ وَصِيَّةٌ':Predicate, #2: 2	أَجَازَ الْوَصِيَّةَ
u'جَازَ وَضْعٌ':Subject, #7: 7	أَجَازَ وَصِيَّةَ
u'جَازَ وَضْعٌ':Subject, #1: 1	جَازَ وَضْعُهُ
u'جَازَ وُضُوءٌ':Subject, #2: 2	جَازَ الْوَضْعُ
u'جَازَ وُضُوءٌ':Subject, #28: 28	جَازَ الْوُضُوءُ
u'جَازَ وُضُوءٌ':Subject, #2: 2	جَازَ وُضُوءُ
u'جَازَ وَطْءٌ':Subject, #3: 3	جَازَ وُضُوءُهُ
u'جَازَ وَطْءٌ':Subject, #3: 3	جَازَ وَطْءُ
u'جَازَ وَقْفٌ':Predicate, #4: 4	جَازَ الْوَطْءُ
u'جَازَ وَقْفٌ':Subject, #2: 2	أَجَازَ وَقْفَ
u'جَازَ وَقْفٌ':Subject, #1: 1	جَازَ وَقْفُ
u'جَازَ وُقُوعٌ':Subject, #22: 22	جَازَ الْوَقْفُ
u'جَازَ وُقُوعٌ':Subject, #1: 1	جَازَ وُقُوعُ
u'جَازَ وَكِيلٌ':Subject, #1: 1	جَازَ وُقُوعُهُ
u'جَازَ وَكِيلٌ':Subject, #1: 1	أَجَازَ الْوَكِيلُ
u'جَازَ وَلَهٌ':Subject, #1: 1	جَازَ الْوَكِيلُ
u'جَازَ وَلِيٌّ':Subject, #27: 27	جَازَ وَلَهُ
u'جَازَ وَلِيٌّ':Subject, #1: 1	أَجَازَ وَلِيُّهُ
u'جَاسَ خِلاَلٌ':Predicate, #4: 4	أَجَازَ الْوَلِيُّ
u'جَأْشٌ نَافِرٌ':Added, #1: 1	جَاسَ خِلَالَ
u'جَاعَ رَسُولٌ':Predicate, #1: 1	جَأْشٍ نَافِرٍ
u'جَاعَ قَوْمٌ':Subject, #1: 1	أَجَاعَ رَسُولَ
u'جَاعَ نَاسٌ':Subject, #1: 1	جَاعَ الْقَوْمُ
u'جَافَى بَيْنٌ':Predicate, #2: 2	جَاعَ النَّاسُ
u'جَالَسَ إمَامٌ':Predicate, #2: 2	جَافَى بَيْنَ
u'جَالَسَ سفهاء':Predicate, #1: 1	جَالَسَ الْإِمَامَ
u'جَالَسَ صَاحِبٌ':Predicate, #1: 1	جَالَسَ السُّفَهَاءَ
u'جَالَ فَرَسٌ':Subject, #3: 3	جَالَسَ صَاحِبَ
u'جَامَعَ اِبْنٌ':Subject, #1: 1	جَالَ فَرَسٌ
u'جَامَعَ أَجْنَبِيٌّ':Predicate, #2: 2	جَامَعَ ابْنُ
u'جَامَعَ أُمٌّ':Predicate, #1: 1	جَامَعَ الْأَجْنَبِيَّةَ
u'جَامَعَ بَاعِثٌ':Predicate, #1: 1	جَامَعَ أُمَّ
u'جَامَعَ بَعْضٌ':Predicate, #1: 1	جَامَعَ الْبَاعِثَ
u'جَامَعَ بَيْنٌ':Predicate, #1: 1	جَامَعَ بَعْضَهُنَّ
u'جَامَعَ حاجٌّ':Subject, #1: 1	جَامَعَ بَيْنَ
u'جَامَعَ حَديثٌ':Predicate, #1: 1	جَامَعَ الْحَاجُّ
u'جَامَعَ دونٌ':Predicate, #1: 1	جَامَعَ حَدِيثَ
u'جَامَعَ رَجُلٌ':Subject, #7: 7	جَامَعَ دُونَ
u'جَامَعَ زَوْجٌ':Subject, #10: 10	جَامَعَ الرَّجُلُ
u'جَامَعَ سَوْداء':Predicate, #1: 1	جَامَعَ الزَّوْجُ
u'جَامَعَ صَبِيٌّ':Predicate, #1: 1	جَامَعَ سَوْدَاءَ
u'جَامَعَ صَبِيٌّ':Subject, #1: 1	جَامَعَ صَبِيَّةً
u'جَامَعَ صَغِيرٌ':Predicate, #1: 1	جَامَعَ الصَّبِيُّ
u'جَامَعَ عمرة':Predicate, #4: 4	جَامَعَ صَغِيرَةً
u'جَامَعَ غير':Predicate, #1: 1	جَامَعَ عَمْرَةَ
u'جَامَعَ غَيْرٌ':Predicate, #3: 3	جَامَعَ غَيْرَ
u'جَامَعَ لَيْلٌ':Predicate, #3: 3	جَامَعَ غَيْرَ
u'جَامَعَ مَجْنُونٌ':Subject, #1: 1	جَامَعَ لَيْلَةَ
u'جَامَعَ مُحْرِمٌ':Predicate, #1: 1	جَامَعَ مَجْنُونٌ
u'جَامَعَ مُحْرِمٌ':Subject, #1: 1	جَامَعَ الْمُحْرِمَةَ
u'جَامَعَ مرٌّ':Predicate, #1: 1	جَامَعَ الْمُحْرِمُ
u'جَامَعَ مُشْرِك':Predicate, #6: 6	جَامَعَ مَرَّةً
u'جَامَعَ مُعْتَمِرٌ':Subject, #1: 1	جَامَعَ الْمُشْرِكَ
u'جَامَعَ مَمْلُوكٌ':Predicate, #4: 4	جَامَعَ الْمُعْتَمِرُ
u'جَامَعَ مَنْكُوح':Predicate, #1: 1	جَامَعَ الْمَمْلُوكَةَ
u'جَامَعَ نِساءٌ':Predicate, #1: 1	جَامَعَ الْمَنْكُوحَةَ
u'جَانَبَ كذب':Predicate, #2: 2	جَامَعَ النِّسَاءَ
u'جَانَبَ كَذِبٌ':Predicate, #1: 1	جَانَبَ الْكَذِبَ
u'جَانَبَ مُرْتَهِنٌ':Predicate, #1: 1	جَانَبَ الْكَذِبَ
u'جَاهَدَ مُشْرِك':Predicate, #1: 1	جَانَبَ الْمُرْتَهِنَ
u'جَاهَرَ رَجُلٌ':Subject, #3: 3	جَاهَدَ الْمُشْرِكِينَ
u'جَاهِلِيَّةٌ عَرَبٌ':Added, #1: 1	جَاهَرَ رَجُلٌ
u'جَاهِلِيٌّ عَرَبٌ':Added, #1: 1	جَاهِلِيَّةِ الْعَرَبِ
u'جَاوَرَ جَارٌ':Predicate, #1: 1	جَاهِلِيَّةِ الْعَرَبِ
u'جَاوَرَ فَأْرٌ':Predicate, #1: 1	جَاوَرَ جَارَ
u'جَاوَرَ نَارٌ':Predicate, #3: 3	جَاوَرَ الْفَأْرَةَ
u'جَاوَرَ نَجِسٌ':Predicate, #1: 1	جَاوَرَ النَّارَ
u'جَاوَزَ أُجْرَةٌ':Predicate, #1: 1	جَاوَرَ النَّجِسَ
u'جَاوَزَ أُجْرَةٌ':Subject, #2: 2	جَاوَزَ أُجْرَةَ
u'جَاوَزَ أحَدٌ':Subject, #1: 1	جَاوَزَ أُجْرَةٌ
u'جَاوَزَ آخِرُ':Predicate, #2: 2	جَاوَزَ أَحَدٌ
u'جَاوَزَ أَرْبَعَةٌ':Predicate, #2: 2	جَاوَزَ آخِرَ
u'جَاوَزَ أرْضٌ':Predicate, #3: 3	جَاوَزَ أَرْبَعَةَ
u'جَاوَزَ أسْوَد':Subject, #3: 3	جَاوَزَ أَرْضَ
u'جَاوَزَ أَكْثَرُ':Predicate, #1: 1	جَاوَزَ الْأَسْوَدُ
u'جَاوَزَ أَكْثَرُ':Predicate, #1: 1	جَاوَزَ الْأَكْثَرَ
u'جَاوَزَ الْمَرْءُ':Subject, #3: 3	جَاوَزَ أَكْثَرَ
u'جَاوَزَ أهْلٌ':Subject, #1: 1	جَاوَزَ الْمَرْءُ
u'جَاوَزَ أَوَّلُ':Predicate, #1: 1	جَاوَزَ أَهْلُ
u'جَاوَزَ بَحْرٌ':Predicate, #1: 1	جَاوَزَ أَوَّلَ
u'جَاوَزَ بُيُوتٌ':Predicate, #1: 1	جَاوَزَ الْبَحْرَ
u'جَاوَزَ بُيُوتٌ':Predicate, #1: 1	جَاوَزَ الْبُيُوتَ
u'جَاوَزَ تَقَطُّعٌ':Subject, #3: 3	جَاوَزَ بُيُوتَ
u'جَاوَزَ تَمْييزٌ':Subject, #1: 1	جَاوَزَ التَّقَطُّعُ
u'جَاوَزَ تَوَسُّط':Predicate, #1: 1	جَاوَزَ التَّمْيِيزُ
u'جَاوَزَ ثَلاثُ':Predicate, #1: 1	جَاوَزَ التَّوَسُّطَ
u'جَاوَزَ ثَلاثَةٌ':Predicate, #1: 1	جَاوَزَ الثَّلَاثَ
u'جَاوَزَ حَدٌّ':Predicate, #2: 2	جَاوَزَ ثَلَاثَةَ
u'جَاوَزَ حَدٌّ':Predicate, #2: 2	جَاوَزَ حَدَّ
u'جَاوَزَ حَرامٌ':Subject, #5: 5	جَاوَزَ الْحَدَّ
u'جَاوَزَ حَرَمٌ':Predicate, #1: 1	جَاوَزَ الْحَرَامُ
u'جَاوَزَ حَرِيمٌ':Predicate, #2: 2	جَاوَزَ الْحَرَمَ
u'جَاوَزَ حَرِيمٌ':Predicate, #1: 1	جَاوَزَ الْحَرِيمَ
u'جَاوَزَ حُلُمٌ':Predicate, #1: 1	جَاوَزَ حَرِيمَ
u'جَاوَزَ ختان':Subject, #1: 1	جَاوَزَ الْحُلُمَ
u'جَاوَزَ خِتَانٌ':Subject, #6: 6	جَاوَزَ الْخِتَانُ
u'جَاوَزَ خَمْسَةٌ':Predicate, #6: 6	جَاوَزَ الْخِتَانُ
u'جَاوَزَ خَمْسَةٌ':Predicate, #12: 12	جَاوَزَ خَمْسَةَ
u'جَاوَزَ دَرْبٌ':Predicate, #4: 4	جَاوَزَ الْخَمْسَةَ
u'جَاوَزَ دَمٌ':Predicate, #2: 2	جَاوَزَ الدَّرْبَ
u'جَاوَزَ دَمٌ':Subject, #1: 1	جَاوَزَ الدَّمَ
u'جَاوَزَ سَمْعٌ':Subject, #5: 5	جَاوَزَ الدَّمُ
u'جَاوَزَ سَنَةٌ':Predicate, #1: 1	جَاوَزَ سَمْعُهُ
u'جَاوَزَ سَوادٌ':Predicate, #2: 2	جَاوَزَ السَّنَةَ
u'جَاوَزَ صَبِيٌّ':Subject, #1: 1	جَاوَزَ السَّوَادَ
u'جَاوَزَ صُفُوفٌ':Predicate, #1: 1	جَاوَزَ الصَّبِيُّ
u'جَاوَزَ طُولٌ':Subject, #4: 4	جَاوَزَ الصُّفُوفَ
u'جَاوَزَ ظاهِرٌ':Predicate, #1: 1	جَاوَزَ طُولُ
u'جَاوَزَ ظِلٌّ':Subject, #1: 1	جَاوَزَ الظَّاهِرَ
u'جَاوَزَ عَادَةٌ':Predicate, #1: 1	جَاوَزَ ظِلُّ
u'جَاوَزَ عَبْدٌ':Subject, #7: 7	جَاوَزَ الْعَادَةَ
u'جَاوَزَ عَشْرٌ':Predicate, #2: 2	جَاوَزَ الْعَبْدُ
u'جَاوَزَ عَقِبٌ':Subject, #3: 3	جَاوَزَ الْعَشْرَ
u'جَاوَزَ عُمَرٌ':Subject, #1: 1	جَاوَزَ الْعَقِبُ
u'جَاوَزَ عُمْرَانٌ':Predicate, #1: 1	جَاوَزَ عُمَرُ
u'جَاوَزَ عُمْرَانٌ':Predicate, #1: 1	جَاوَزَ الْعُمْرَانَ
u'جَاوَزَ فَأْرٌ':Predicate, #3: 3	جَاوَزَ عُمْرَانَ
u'جَاوَزَ فلان':Predicate, #4: 4	جَاوَزَ الْفَأْرَةَ
u'جَاوَزَ فُوَّهَةٌ':Predicate, #2: 2	جَاوَزَ الْمُزْدَلِفَةَ
u'جَاوَزَ قَارِئٌ':Subject, #1: 1	جَاوَزَ فُوَّهَةَ
u'جَاوَزَ قَدْرٌ':Predicate, #2: 2	جَاوَزَ الْقَارِئُ
u'جَاوَزَ لبس':Predicate, #3: 3	جَاوَزَ قَدْرَ
u'جَاوَزَ مُتَعَارَفٌ':Predicate, #1: 1	جَاوَزَ لَبِسَ
u'جَاوَزَ مَجْمُوعٌ':Predicate, #1: 1	جَاوَزَ الْمُتَعَارَفَ
u'جَاوَزَ مَحْمُولٌ':Predicate, #1: 1	جَاوَزَ مَجْمُوعَ
u'جَاوَزَ مَخْرَجٌ':Predicate, #1: 1	جَاوَزَ الْمَحْمُولَ
u'جَاوَزَ مُدَّةٌ':Predicate, #1: 1	جَاوَزَ الْمَخْرَجَ
u'جَاوَزَ مُسَافِرٌ':Subject, #1: 1	جَاوَزَ الْمُدَّةَ
u'جَاوَزَ مُسْتَأْجِرٌ':Subject, #1: 1	جَاوَزَ الْمُسَافِرُ
u'جَاوَزَ مُسْتَعِيرٌ':Subject, #1: 1	جَاوَزَ الْمُسْتَأْجِرُ
u'جَاوَزَ مُعْتَادٌ':Predicate, #1: 1	جَاوَزَ الْمُسْتَعِيرُ
u'جَاوَزَ مَغَارِبُ':Predicate, #2: 2	جَاوَزَ الْمُعْتَادَ
u'جَاوَزَ مَكَانٌ':Predicate, #1: 1	جَاوَزَ الْمَغَارِبَ
u'جَاوَزَ مَوَاقِيتُ':Predicate, #3: 3	جَاوَزَ الْمَكَانَ
u'جَاوَزَ مَوْضِعٌ':Predicate, #2: 2	جَاوَزَ الْمَوَاقِيتَ
u'جَاوَزَ مَوْضِعٌ':Subject, #6: 6	جَاوَزَ مَوْضِعَ
u'جَاوَزَ مِيقَاتٌ':Predicate, #1: 1	جَاوَزَ مَوْضِعُ
u'جَاوَزَ نَجَاسَةٌ':Predicate, #72: 72	جَاوَزَ الْمِيقَاتَ
u'جَاوَزَ نَجَسٌ':Subject, #1: 1	جَاوَزَ النَّجَاسَةَ
u'جَاوَزَ نِصْفٌ':Predicate, #1: 1	جَاوَزَ النَّجَسُ
u'جَاوَزَ نعمة':Predicate, #1: 1	جَاوَزَ نِصْفَ
u'جَاوَزَ نِعْمَةٌ':Predicate, #1: 1	جَاوَزَ النِّعْمَةَ
u'جَاوَزَ نكاح':Predicate, #1: 1	جَاوَزَ النِّعْمَةَ
u'جَاوَزَ نِكَاحٌ':Predicate, #1: 1	جَاوَزَ نِكَاحَ
u'جَاوَزَ وَقْتٌ':Predicate, #1: 1	جَاوَزَ نِكَاحَ
u'جَاوَزَ يَوْمٌ':Predicate, #4: 4	جَاوَزَ الْوَقْتَ
u'جِبَايَةٌ أَمْوَالٌ':Added, #1: 1	جَاوَزَ الْيَوْمَ
u'جِبَايَةٌ جِزْيَةٌ':Added, #1: 1	جِبَايَةَ أَمْوَالِهِ
u'جِبَايَةٌ خراج':Added, #1: 1	جِبَايَةِ الْجِزْيَةِ
u'جِبَايَةٌ خراج':Added, #1: 1	جِبَايَةَ الْخَرَاجِ
u'جِبَايَةٌ خَرَاجٌ':Added, #1: 1	جِبَايَةِ الْخَرَاجِ
u'جِبَايَةٌ خَرَاجٌ':Added, #1: 1	جِبَايَةَ الْخَرَاجِ
u'جِبَايَةٌ خراج':Added, #1: 1	جِبَايَةِ الْخَرَاجِ
u'جِبَايَةٌ خَرَاجٌ':Added, #4: 4	جِبَايَةُ الْخَرَاجِ
u'جِبَايَةٌ دَارٌ':Added, #4: 4	جِبَايَةُ الْخَرَاجِ
u'جِبَايَةٌ دِرْهَمٌ':Added, #1: 1	جِبَايَةَ دَارِهِ
u'جِبَايَةٌ دِرْهَم':Added, #1: 1	جِبَايَةِ دِرْهَمٍ
u'جِبَايَةٌ زَكاةٌ':Added, #1: 1	جِبَايَةِ دِرْهَمٍ
u'جِبَايَةٌ فَيْءٌ':Added, #1: 1	جِبَايَةُ الزَّكَاةِ
u'جِبَايَةٌ مَخَازِنُ':Added, #1: 1	جِبَايَةُ الْفَيْءِ
u'جِبَايَةٌ مُكُوسٌ':Added, #1: 1	جِبَايَةِ الْمَخَازِنِ
u'جِبَايَةٌ يمن':Added, #1: 1	جِبَايَةُ الْمُكُوسِ
u'جِبَايَةٌ يَمَنُ':Added, #1: 1	جِبَايَةِ الْيَمَنِ
u'جَبَّ ذكر':Predicate, #1: 1	جِبَايَةِ الْيَمَنِ
u'جَبَّ ذَكَرٌ':Predicate, #2: 2	جَبَّ الذَّكَرَ
u'جَبْرٌ أَبٌ':Added, #2: 2	جَبَّ الذَّكَرَ
u'جَبْرٌ اِبْنَة':Added, #3: 3	جَبْرِ الْأَبِ
u'جَبْرٌ اِبْنَة':Added, #1: 1	جَبْرُ ابْنَتِهِ
u'جَبْرٌ اِنْتِهاكٌ':Added, #1: 1	جَبْرِ ابْنَتِهِ
u'جَبْرٌ بَعْضٌ':Added, #1: 1	جَبْرُ انْتِهَاكِ
u'جَبْرٌ بناتٌ':Added, #1: 1	جَبْرُ بَعْضِ
u'جَبْرٌ تَرْكٌ':Added, #1: 1	جَبْرُ بَنَاتِهِ
u'جَبْرٌ تَرْكٌ':Added, #1: 1	جَبْرِ تَرْكِ
u'جَبْرٌ جُلُوسٌ':Added, #1: 1	جَبْرِ تَرْكِهِ
u'جَبْرٌ حالٌ':Added, #1: 1	جَبْرُ الْجُلُوسِ
u'جَبْرٌ حُرٌّ':Added, #1: 1	جَبْرُ الْحَالِ
u'جَبْرٌ حِصَّةٌ':Added, #1: 1	جَبْرَ الْحُرَّةِ
u'جَبْرٌ خُسْر':Added, #1: 1	جَبْرُ حِصَّةِ
u'جَبْرٌ خُسْران':Added, #1: 1	جَبْرُ الْخُسْرِ
u'جَبْرٌ خَلَلٌ':Added, #1: 1	جَبْرَ خُسْرَانٍ
u'جَبْرٌ خَلَلٌ':Added, #1: 1	جَبْرِ الْخَلَلِ
u'جَبْرٌ ذكر':Added, #2: 2	جَبْرَ الْخَلَلِ
u'جَبْرٌ ذَكَرٌ':Added, #1: 1	جَبْرُ الذَّكَرِ
u'جَبْرٌ رَأْسٌ':Added, #1: 1	جَبْرُ الذَّكَرِ
u'جَبْرٌ رَاهِنٌ':Added, #1: 1	جَبْرِ رَأْسِ
u'جَبْرٌ رَقيقٌ':Added, #1: 1	جَبْرِ الرَّاهِنِ
u'جَبْرٌ رَقيقٌ':Added, #1: 1	جَبْرُ الرَّقِيقِ
u'جَبْرٌ رَقيق':Added, #1: 1	جَبْرِ الرَّقِيقِ
u'جَبْرٌ رَقيق':Added, #1: 1	جَبْرُ الرَّقِيقِ
u'جَبَرَ زِيادَةٌ':Predicate, #1: 1	جَبْرِ الرَّقِيقِ
u'جَبْرٌ سَيِّدٌ':Added, #2: 2	جَبَرَ زِيَادَةَ
u'جَبْرٌ صَاحِبٌ':Added, #1: 1	جَبْرُ السَّيِّدِ
u'جَبَرَ صِفَةٌ':Predicate, #1: 1	جَبْرِ صَاحِبِ
u'جَبْرٌ صَلاَةٌ':Added, #1: 1	جَبَرَ صِفَةَ
u'جَبْرٌ صَلاَةٌ':Added, #1: 1	جَبْرِ الصَّلَاةِ
u'جَبْرٌ عَامِلٌ':Added, #1: 1	جَبْرَ صَلَاةِ
u'جَبْرٌ عَامِلٌ':Added, #1: 1	جَبْرُ الْعَامِلِ
u'جَبْرٌ عَبْدٌ':Added, #1: 1	جَبْرِ عَامِلٍ
u'جَبْرٌ عَدْلٌ':Added, #1: 1	جَبْرُ الْعَبْدِ
u'جَبَرَ عصبة':Predicate, #1: 1	جَبْرِ الْعَدْلِ
u'جَبَرَ عَصَبَةٌ':Predicate, #1: 1	جَبَرَ عَصَبَةَ
u'جَبْرٌ غَاصِبٌ':Added, #1: 1	جَبَرَ عَصَبَةَ
u'جَبْرٌ قَطْعٌ':Added, #2: 2	جَبْرُ الْغَاصِبِ
u'جَبَرَ قلب':Predicate, #1: 1	جَبْرِ الْقَطْعِ
u'جَبَرَ قَلْبٌ':Predicate, #1: 1	جَبَرَ قَلْبَ
u'جَبَرَ قَلْب':Predicate, #1: 1	جَبَرَ قَلْبَ
u'جَبْرٌ قلب':Added, #1: 1	جَبَرَ قَلْبَ
u'جَبْرٌ قَلْبٌ':Added, #1: 1	جَبْرُ الْقَلْبِ
u'جَبْرٌ قَلْب':Added, #1: 1	جَبْرُ الْقَلْبِ
u'جَبَرَ كَسْرٌ':Predicate, #1: 1	جَبْرُ الْقَلْبِ
u'جَبْرٌ كَسْرٌ':Added, #1: 1	جَبَرَ الْكَسْرَ
u'جَبْرٌ مَجْنُونٌ':Added, #2: 2	جَبْرِ الْكَسْرِ
u'جَبْرٌ مَجْنُونٌ':Added, #1: 1	جَبْرُ الْمَجْنُونِ
u'جَبْرٌ مُدَبَّرٌ':Added, #1: 1	جَبْرِ الْمَجْنُونَةِ
u'جَبْرٌ مُزَارِعٌ':Added, #1: 1	جَبْرُ الْمُدَبَّرِ
u'جَبْرٌ مَلِكٌ':Added, #1: 1	جَبْرِ الْمُزَارِعِ
u'جَبَرَ نَاسٌ':Predicate, #1: 1	جَبْرٍ مَلِكٍ
u'جَبْرٌ نُقْصَانٌ':Added, #2: 2	جَبَرَ النَّاسَ
u'جَبْرٌ نُقْصَانٌ':Added, #1: 1	جَبْرُ النُّقْصَانِ
u'جَبْرٌ هَتْكٌ':Added, #2: 2	جَبْرِ نُقْصَانِ
u'جَبْرٌ واحد':Added, #1: 1	جَبْرُ هَتْكِ
u'جَبْرٌ وَاحِدٌ':Added, #1: 1	جَبْرِ وَاحِدٍ
u'جَبْرٌ وَالِدٌ':Added, #1: 1	جَبْرِ وَاحِدٍ
u'جَبْرٌ وَضِيعٌ':Added, #1: 1	جَبْرَ وَالِدِ
u'جَبَى خراج':Predicate, #1: 1	جَبْرُ الْوَضِيعَةِ
u'جَبَى خَرَاجٌ':Predicate, #1: 1	جَبَى الْخَرَاجَ
u'جَثَمَ جَوْهَرٌ':Subject, #1: 1	جَبَى الْخَرَاجَ
u'جَدَّ ثَمَرَةٌ':Predicate, #1: 1	جَثَمَ جَوْهَرٌ
u'جَدَّدَ إجَارَةٌ':Predicate, #4: 4	جَدَّ الثَّمَرَةَ
u'جَدَّدَ إِحْرَامٌ':Predicate, #1: 1	جَدَّدَ الْإِجَارَةَ
u'جَدَّدَ إِخْرَاجٌ':Predicate, #2: 2	جَدَّدَ الْإِحْرَامَ
u'جَدَّدَ إيقَاعٌ':Predicate, #2: 2	جَدَّدَ الْإِخْرَاجَ
u'جَدَّدَ بَائِعٌ':Subject, #1: 1	جَدَّدَ الْإِيقَاعَ
u'جَدَّدَ بِنَاءٌ':Predicate, #1: 1	جَدَّدَ الْبَائِعُ
u'جَدَّدَ بَيْعٌ':Predicate, #1: 1	جَدَّدَ بِنَاءَ
u'جَدَّدَ تَلْبيَةٌ':Predicate, #2: 2	جَدَّدَ الْبَيْعَ
u'جَدَّدَ دَعْوَةٌ':Predicate, #3: 3	جَدَّدَ التَّلْبِيَةَ
u'جَدَّدَ رَاهِنٌ':Subject, #4: 4	جَدَّدَ الدَّعْوَةَ
u'جَدَّدَ صَبِيٌّ':Subject, #1: 1	جَدَّدَ الرَّاهِنُ
u'جَدَّدَ عَقْدٌ':Predicate, #4: 4	جَدَّدَ الصَّبِيُّ
u'جَدَّدَ عَقْدٌ':Predicate, #2: 2	جَدَّدَ عَقْدَ
u'جَدَّدَ كِتَابَةٌ':Predicate, #3: 3	جَدَّدَ الْعَقْدَ
u'جَدَّدَ مَأْمُورٌ':Subject, #1: 1	جَدَّدَ الْكِتَابَةَ
u'جَدَّدَ مُتَوَكِّلٌ':Subject, #1: 1	جَدَّدَ الْمَأْمُورُ
u'جَدَّدَ مُحْدِثٌ':Subject, #1: 1	جَدَّدَ الْمُتَوَكِّلُ
u'جَدَّدَ مَهْرٌ':Predicate, #1: 1	جَدَّدَ مُحْدِثٌ
u'جَدَّدَ مُؤَجِّرٌ':Subject, #1: 1	جَدَّدَ الْمَهْرَ
u'جَدَّدَ مُودِعٌ':Subject, #1: 1	جَدَّدَ الْمُؤَجِّرُ
u'جَدَّدَ نكاح':Predicate, #1: 1	جَدَّدَ الْمُودِعُ
u'جَدَّدَ نِكَاحٌ':Predicate, #12: 12	جَدَّدَ النِّكَاحَ
u'جَدَّدَ نكاح':Predicate, #12: 12	جَدَّدَ النِّكَاحَ
u'جَدَّدَ نِكَاحٌ':Predicate, #3: 3	جَدَّدَ نِكَاحَ
u'جَدَّدَ نِيَّةٌ':Predicate, #3: 3	جَدَّدَ نِكَاحَ
u'جَدَّدَ وُضُوءٌ':Predicate, #1: 1	جَدَّدَ النِّيَّةَ
u'جَدَّ سَيْرٌ':Predicate, #5: 5	جَدَّدَ الْوُضُوءَ
u'جَدَّ سَيْرٌ':Subject, #1: 1	جَدَّ السَّيْرَ
u'جَدَّ شَيْءٌ':Subject, #2: 2	جَدَّ السَّيْرُ
u'جَدَّ طَلْحٌ':Predicate, #1: 1	جَدَّ الشَّيْءُ
u'جَدَّ طلحة':Predicate, #1: 1	جَدَّ طَلْحَةَ
u'جَدَّ فلان':Predicate, #1: 1	جَدَّ طَلْحَةَ
u'جَدَّ مُعاوِيَة':Predicate, #2: 2	جَدَّ مُعَاوِيَةَ
u'جَدَّ مَلاَئِكَةٌ':Subject, #2: 2	جَدَّ مُعَاوِيَةَ
u'جَدَّ نَاسٌ':Subject, #1: 1	جَدَّ الْمَلَائِكَةُ
u'جَدَّ نَظَرٌ':Predicate, #1: 1	جَدَّ النَّاسُ
u'جَدَّ يَسِيرٌ':Subject, #1: 1	جَدَّ النَّظَرَ
u'جَذَبَ الْمَرْأَةُ':Predicate, #1: 1	جَدَّ الْيَسِيرُ
u'جَذَبَ أَوَّلُ':Subject, #1: 1	جَذَبَ الْمَرْأَةَ
u'جَذْبٌ أَوَّلُ':Added, #3: 3	جَذَبَ الْأَوَّلُ
u'جَذَّ بَائِعٌ':Subject, #1: 1	جَذْبِ الْأَوَّلِ
u'جَذَبَ ثَالِثٌ':Subject, #1: 1	جَذَّ الْبَائِعُ
u'جَذَبَ ثَانِي':Predicate, #2: 2	جَذَبَ الثَّالِثُ
u'جَذْبٌ دَمٌ':Added, #1: 1	جَذَبَ الثَّانِيَ
u'جَذْبٌ رَجُلٌ':Added, #1: 1	جَذْبُ الدَّمِ
u'جَذْبٌ مَاءٌ':Added, #1: 1	جَذْبَ رَجُلٍ
u'جَذَّ ثَمَرٌ':Predicate, #5: 5	جَذْبُ الْمَاءِ
u'جَذَّ رَأْسٌ':Predicate, #1: 1	جَذَّ الثَّمَرَ
u'جَرَّ أَبٌ':Subject, #1: 1	جَذَّ الرَّأْسَ
u'جراح اِبْنٌ':Added, #5: 5	جَرَّ الْأَبُ
u'جِرَاحٌ اِبْنٌ':Added, #1: 1	جِرَاحُ ابْنِهِ
u'جِرَاحَاتٌ بدن':Added, #1: 1	جِرَاحُ ابْنِهِ
u'جِرَاحَاتٌ بَدَنٌ':Added, #1: 1	جِرَاحَاتِ الْبَدَنِ
u'جِرَاحَاتٌ جَسَدٌ':Added, #1: 1	جِرَاحَاتِ الْبَدَنِ
u'جِرَاحَاتٌ رِجَالٌ':Added, #1: 1	جِرَاحَاتِ الْجَسَدِ
u'جِرَاحَاتٌ رِجَالٌ':Added, #1: 1	جِرَاحَاتِ الرِّجَالِ
u'جِرَاحَاتٌ رِدَّةٌ':Added, #2: 2	جِرَاحَاتُ الرِّجَالِ
u'جِرَاحَاتٌ رَقيقٌ':Added, #1: 1	جِرَاحَاتِ الرِّدَّةِ
u'جِرَاحَاتٌ رَقيق':Added, #1: 1	جِرَاحَاتِ الرَّقِيقِ
u'جِرَاحَاتٌ سُفْلٌ':Added, #1: 1	جِرَاحَاتِ الرَّقِيقِ
u'جِرَاحَاتٌ عَصَبٌ':Added, #1: 1	جِرَاحَاتِ السُّفْلِ
u'جِرَاحَاتٌ مُسْلِمٌ':Added, #1: 1	جِرَاحَاتِ الْعَصَبِ
u'جِرَاحَاتٌ نِساءٌ':Added, #1: 1	جِرَاحَاتِ الْمُسْلِمِ
u'جراح الْمَرْأَةُ':Added, #2: 2	جِرَاحَاتُ النِّسَاءِ
u'جِرَاحٌ الْمَرْأَةُ':Added, #2: 2	جِرَاحِ الْمَرْأَةِ
u'جِرَاحَةٌ بدن':Added, #2: 2	جِرَاحِ الْمَرْأَةِ
u'جِرَاحَةٌ بَدَنٌ':Added, #1: 1	جِرَاحَاتِ الْبَدَنِ
u'جِرَاحَةٌ جَسَدٌ':Added, #1: 1	جِرَاحَاتِ الْبَدَنِ
u'جِرَاحَةٌ رِجَالٌ':Added, #1: 1	جِرَاحَاتِ الْجَسَدِ
u'جِرَاحَةٌ رِجَالٌ':Added, #1: 1	جِرَاحَاتِ الرِّجَالِ
u'جِرَاحَةٌ رِدَّةٌ':Added, #2: 2	جِرَاحَاتُ الرِّجَالِ
u'جِرَاحَةٌ رَقيقٌ':Added, #1: 1	جِرَاحَاتِ الرِّدَّةِ
u'جِرَاحَةٌ رَقيق':Added, #1: 1	جِرَاحَاتِ الرَّقِيقِ
u'جِرَاحَةٌ سُفْلٌ':Added, #1: 1	جِرَاحَاتِ الرَّقِيقِ
u'جِرَاحَةٌ عَصَبٌ':Added, #1: 1	جِرَاحَاتِ السُّفْلِ
u'جِرَاحَةٌ مُسْلِمٌ':Added, #1: 1	جِرَاحَاتِ الْعَصَبِ
u'جِرَاحَةٌ نِساءٌ':Added, #1: 1	جِرَاحَاتِ الْمُسْلِمِ
u'جراح جَسَدٌ':Added, #2: 2	جِرَاحَاتُ النِّسَاءِ
u'جِرَاحٌ جَسَدٌ':Added, #3: 3	جِرَاحُ الْجَسَدِ
u'جراح جَسَدٌ':Added, #3: 3	جِرَاحُ الْجَسَدِ
u'جِرَاحٌ جَسَدٌ':Added, #5: 5	جِرَاحِ الْجَسَدِ
u'جراح حَرٌّ':Added, #5: 5	جِرَاحِ الْجَسَدِ
u'جِرَاحٌ حَرٌّ':Added, #1: 1	جِرَاحُ الْحَرِّ
u'جراح خَطَأٌ':Added, #1: 1	جِرَاحُ الْحَرِّ
u'جِرَاحٌ خَطَأٌ':Added, #2: 2	جِرَاحِ الْخَطَأِ
u'جراح ذكر':Added, #2: 2	جِرَاحِ الْخَطَأِ
u'جِرَاحٌ ذكر':Added, #1: 1	جِرَاحِ الذَّكَرِ
u'جراح ذَكَرٌ':Added, #1: 1	جِرَاحِ الذَّكَرِ
u'جِرَاحٌ ذَكَرٌ':Added, #1: 1	جِرَاحِ الذَّكَرِ
u'جراح رِجَالٌ':Added, #1: 1	جِرَاحِ الذَّكَرِ
u'جِرَاحٌ رِجَالٌ':Added, #1: 1	جِرَاحَ الرِّجَالِ
u'جراح رَجُلٌ':Added, #1: 1	جِرَاحَ الرِّجَالِ
u'جِرَاحٌ رَجُلٌ':Added, #1: 1	جِرَاحِ الرَّجُلِ
u'جراح عَبْدٌ':Added, #1: 1	جِرَاحِ الرَّجُلِ
u'جراح عَبْدٌ':Added, #1: 1	جِرَاحُ الْعَبْدِ
u'جِرَاحٌ عَبْدٌ':Added, #1: 1	جِرَاحِ الْعَبْدِ
u'جِرَاحٌ عَبْدٌ':Added, #1: 1	جِرَاحُ الْعَبْدِ
u'جراح عَبْدٌ':Added, #1: 1	جِرَاحِ الْعَبْدِ
u'جِرَاحٌ عَبْدٌ':Added, #4: 4	جِرَاحَ الْعَبْدِ
u'جراح عَمْدٌ':Added, #4: 4	جِرَاحَ الْعَبْدِ
u'جِرَاحٌ عَمْدٌ':Added, #1: 1	جِرَاحُ الْعَمْدِ
u'جراح عَمْدٌ':Added, #1: 1	جِرَاحُ الْعَمْدِ
u'جِرَاحٌ عَمْدٌ':Added, #2: 2	جِرَاحَ الْعَمْدِ
u'جراح عَمْدٌ':Added, #2: 2	جِرَاحَ الْعَمْدِ
u'جِرَاحٌ عَمْدٌ':Added, #7: 7	جِرَاحِ الْعَمْدِ
u'جراح غير':Added, #7: 7	جِرَاحِ الْعَمْدِ
u'جراح غَيْرٌ':Added, #1: 1	جِرَاحِ غَيْرِ
u'جِرَاحٌ غير':Added, #1: 1	جِرَاحِ غَيْرِ
u'جِرَاحٌ غَيْرٌ':Added, #1: 1	جِرَاحِ غَيْرِ
u'جَرَّبَ أَحْوالٌ':Predicate, #1: 1	جِرَاحِ غَيْرِ
u'جَرَّبَ أحْوَالٌ':Predicate, #1: 1	جَرَّبَ أَحْوَالَ
u'جَرَّبَ أُمُورٌ':Predicate, #1: 1	جَرَّبَ أَحْوَالَ
u'جَرَّبَ دَهْرٌ':Predicate, #1: 1	جَرَّبَ الْأُمُورَ
u'جَرَّبَ رَسُولٌ':Subject, #1: 1	جَرَّبَ الدَّهْرَ
u'جَرَّ ثَالِثٌ':Predicate, #1: 1	جَرَّبَ رَسُولُ
u'جَرَّ ثَانِي':Predicate, #3: 3	جَرَّ الثَّالِثَ
u'جَرْجَرَ فَحْلٌ':Subject, #1: 1	جَرَّ الثَّانِيَ
u'جُرْحٌ إِبْرَةٌ':Added, #2: 2	جَرْجَرَ الْفَحْلُ
u'جَرَحَ اِبْنٌ':Subject, #1: 1	جُرْحِ إبْرَةٍ
u'جَرَحَ أَخٌ':Subject, #1: 1	جَرَحَ ابْنُ
u'جُرْحٌ إِسْلامٌ':Added, #1: 1	جَرَحَ أَخٌ
u'جُرْحٌ أُصْبُعٌ':Added, #2: 2	جُرْحِ الْإِسْلَامِ
u'جَرَحَ المُشْتَرِي':Predicate, #1: 1	جُرْحَ أُصْبُعِهِ
u'جَرَحَ إِنْسانٌ':Subject, #1: 1	جَرَحَ الْمُشْتَرِيَ
u'جَرَحَ أَوَّلُ':Subject, #2: 2	جَرَحَ إنْسَانٌ
u'جُرْحٌ أَوَّلُ':Added, #1: 1	جَرَحَ الْأَوَّلُ
u'جُرْحٌ أَوَّلُ':Added, #1: 1	جُرْحُ الْأَوَّلِ
u'جَرَحَ بَهيمٌ':Predicate, #1: 1	جُرْحِ الْأَوَّلِ
u'جَرَحَ بَهِيمَةٌ':Predicate, #1: 1	جَرَحَ بَهِيمَةَ
u'جَرَحَ بَيِّنَةٌ':Predicate, #1: 1	جَرَحَ بَهِيمَةَ
u'جُرْحٌ بَيِّنَةٌ':Added, #1: 1	جَرَحَ الْبَيِّنَةَ
u'جَرَحَ ثَلاثَةٌ':Subject, #1: 1	جُرْحَ الْبَيِّنَةِ
u'جَرَحَ جَارِحٌ':Subject, #1: 1	جَرَحَ ثَلَاثَةٌ
u'جُرْحٌ جَارِحٌ':Added, #1: 1	جَرَحَ الْجَارِحُ
u'جُرْحٌ جَارِي':Added, #1: 1	جُرْحِ الْجَارِحِ
u'جُرْحٌ جَارِيَةٌ':Added, #1: 1	جُرْحُ الْجَارِيَةِ
u'جَرَحَ جِرَاحَةٌ':Predicate, #1: 1	جُرْحُ الْجَارِيَةِ
u'جَرَحَ حُرٌّ':Predicate, #1: 1	جَرَحَ الْجِرَاحَةَ
u'جَرَحَ حُرٌّ':Subject, #1: 1	جَرَحَ الْحُرَّ
u'جَرَحَ حَلٌّ':Predicate, #1: 1	جَرَحَ حُرٌّ
u'جَرَحَ حَلالٌ':Subject, #1: 1	جَرَحَ حَلَّ
u'جُرْحٌ حَلالٌ':Added, #1: 1	جَرَحَ الْحَلَالُ
u'جُرْحٌ حَيَوَانٌ':Added, #1: 1	جُرْحُ الْحَلَالِ
u'جُرْحٌ حَيَوَانٌ':Added, #1: 1	جُرْحِ حَيَوَانٍ
u'جَرَحَ خَصْمٌ':Subject, #5: 5	جُرْحَ حَيَوَانٍ
u'جَرَحَ ذِمِّيٌّ':Subject, #1: 1	جَرَحَ الْخَصْمُ
u'جُرْحٌ رَأْسٌ':Added, #3: 3	جَرَحَ ذِمِّيٌّ
u'جُرْحٌ رِجَالٌ':Added, #1: 1	جُرْحُ الرَّأْسِ
u'جَرَحَ رَجُلٌ':Predicate, #1: 1	جُرْحَ الرِّجَالِ
u'جَرَحَ رَجُلٌ':Predicate, #1: 1	جَرَحَ الرَّجُلَ
u'جَرَحَ رَجُلٌ':Subject, #1: 1	جَرَحَ رَجُلاً
u'جَرَحَ رَجُلٌ':Subject, #2: 2	جَرَحَ رَجُلٌ
u'جُرْحٌ رَجُلٌ':Added, #6: 6	جَرَحَ الرَّجُلُ
u'جُرْحٌ رِدَّةٌ':Added, #1: 1	جُرْحَ الرَّجُلِ
u'جُرْحٌ رَسُولٌ':Added, #1: 1	جُرْحَ الرِّدَّةِ
u'جُرْحٌ سَابِقٌ':Added, #1: 1	جُرْحِ رَسُولِ
u'جُرْحٌ سائِل':Added, #1: 1	جُرْحُ السَّابِقِ
u'جُرْحٌ سَائِلٌ':Added, #2: 2	جُرْحٍ سَائِلٍ
u'جَرَحَ سَبُعٌ':Subject, #2: 2	جُرْحٍ سَائِلٍ
u'جَرَحَ سَبُعٌ':Subject, #1: 1	جَرَحَ السَّبُعُ
u'جَرَحَ سَهْمٌ':Subject, #1: 1	جَرَحَ سَبُعٌ
u'جَرَحَ شَاةٌ':Predicate, #1: 1	جَرَحَ السَّهْمُ
u'جَرَحَ شَخْصٌ':Subject, #1: 1	جَرَحَ شَاةَ
u'جَرَحَ شَهَادَةٌ':Predicate, #3: 3	جَرَحَ شَخْصٌ
u'جَرَحَ صَيْدٌ':Predicate, #1: 1	جَرَحَ شَهَادَةَ
u'جَرَحَ صَيْدٌ':Predicate, #2: 2	جَرَحَ صَيْدَ
u'جُرْحٌ صَيْدٌ':Added, #5: 5	جَرَحَ الصَّيْدَ
u'جَرَحَ ظَهْرٌ':Predicate, #1: 1	جُرْحُ الصَّيْدِ
u'جَرَحَ عَبْدٌ':Predicate, #2: 2	جَرَحَ ظَهْرَ
u'جَرَحَ عَبْدٌ':Predicate, #1: 1	جَرَحَ الْعَبْدَ
u'جَرَحَ عَبْدٌ':Subject, #4: 4	جَرَحَ عَبْدَ
u'جَرَحَ عَبْدٌ':Subject, #3: 3	جَرَحَ الْعَبْدُ
u'جُرْحٌ عجماء':Added, #4: 4	جَرَحَ عَبْدٌ
u'جُرْحٌ عَجْمَاءُ':Added, #4: 4	جُرْحُ الْعَجْمَاءِ
u'جُرْحٌ عَمْدٌ':Added, #4: 4	جُرْحُ الْعَجْمَاءِ
u'جُرْحٌ عَمْدٌ':Added, #1: 1	جُرْحُ عَمْدٍ
u'جُرْحٌ عَمْدٌ':Added, #1: 1	جُرْحِ عَمْدٍ
u'جُرْحٌ فُلاَنٌ':Added, #2: 2	جُرْحِ الْعَمْدِ
u'جُرْحٌ كفر':Added, #1: 1	جُرْحِ فُلَانٍ
u'جُرْحٌ كُفْرٌ':Added, #1: 1	جُرْحِ الْكُفْرِ
u'جَرَحَ مُحْرِمٌ':Subject, #1: 1	جُرْحِ الْكُفْرِ
u'جَرَحَ مُرْتَدٌّ':Subject, #3: 3	جَرَحَ الْمُحْرِمُ
u'جَرَحَ مُسْلِمٌ':Subject, #1: 1	جَرَحَ مُرْتَدٌّ
u'جَرَحَ مُشْتَرِي':Predicate, #4: 4	جَرَحَ مُسْلِمٌ
u'جُرْحٌ مُوجِبٌ':Added, #1: 1	جَرَحَ الْمُشْتَرِيَ
u'جُرْحٌ نَبِيٌّ':Added, #1: 1	جُرْحٍ مُوجِبٍ
u'جُرْحٌ نِساءٌ':Added, #1: 1	جُرْحِ النَّبِيِّ
u'جَرَحَ واحد':Subject, #1: 1	جُرْحِ نِسَاءِ
u'جَرَحَ وَاحِدٌ':Subject, #2: 2	جَرَحَ وَاحِدٌ
u'جُرْحٌ واحد':Added, #2: 2	جَرَحَ وَاحِدٌ
u'جُرْحٌ واحد':Added, #1: 1	جُرْحٍ وَاحِدٍ
u'جُرْحٌ وَاحِدٌ':Added, #1: 1	جُرْحَ وَاحِدٍ
u'جُرْحٌ وَاحِدٌ':Added, #1: 1	جُرْحٍ وَاحِدٍ
u'جَرَّ خِطَامٌ':Predicate, #1: 1	جُرْحَ وَاحِدٍ
u'جَرَّدَ جَارِي':Predicate, #1: 1	جَرَّ خِطَامَ
u'جَرَّدَ قَصْدٌ':Predicate, #2: 2	جَرَّدَ جَارِيَةً
u'جرد وَجْهٌ':Added, #1: 1	جَرَّدَ الْقَصْدَ
u'جَرْدٌ وَجْهٌ':Added, #1: 1	جَرْدُ الْوَجْهِ
u'جَرَّ سَيْل':Subject, #1: 1	جَرْدُ الْوَجْهِ
u'جَرَّ ظُلْمٌ':Predicate, #2: 2	جَرَّ السَّيْلُ
u'جَرُمَ بِنَاءٌ':Subject, #2: 2	جَرَّ الظُّلْمَ
u'جَرَمَ جلد':Predicate, #1: 1	جَرُمَ الْبِنَاءُ
u'جَرَمَ جَلَدٌ':Predicate, #1: 1	جَرَمَ جَلَدَ
u'جَرَمَ ذكر':Predicate, #1: 1	جَرَمَ جَلَدَ
u'جَرَمَ ذَكَرٌ':Predicate, #1: 1	جَرَمَ ذَكَرَ
u'جَرَمَ قَالٌ':Predicate, #1: 1	جَرَمَ ذَكَرَ
u'جَرَّ مَنْفَعَةٌ':Predicate, #4: 4	جَرَمَ قَالَ
u'جَرَّ وَلاَءٌ':Predicate, #1: 1	جَرَّ الْمَنْفَعَةَ
u'جَرَّ وَلاَءٌ':Predicate, #20: 20	جَرَّ وَلَاءَ
u'جَرَّ وَلاَءٌ':Predicate, #3: 3	جَرَّ الْوَلاَءَ
u'جَرَّ وَلاَءٌ':Subject, #4: 4	جَرَّ الْوَلَاءَ
u'جَرَى اِبْنٌ':Subject, #1: 1	جَرَّ وَلَاءُ
u'جَرَى إِرْثٌ':Subject, #17: 17	جَرَى ابْنُ
u'جَرَى أَصْحَابٌ':Subject, #1: 1	جَرَى الْإِرْثُ
u'جَرَى أصل':Subject, #2: 2	جَرَى الْأَصْحَابُ
u'جَرَى أًصْلٌ':Subject, #1: 1	جَرَى الْأَصْلُ
u'جَرَى إمَامٌ':Subject, #1: 1	جَرَى الْأَصْلُ
u'جَرَى إمَامٌ':Subject, #1: 1	جَرَى الْإِمَامُ
u'جَرَى أَمْرٌ':Subject, #1: 1	جَرَى إمَامُ
u'جَرَى أَمْرٌ':Subject, #1: 1	جَرَى أَمْرٌ
u'جَرَى أَمْرٌ':Subject, #1: 1	جَرَى أَمْرُ
u'جَرَى بَعْضٌ':Subject, #2: 2	جَرَى الْأَمْرُ
u'جَرَى بَيْعٌ':Subject, #2: 2	جَرَى بَعْضُ
u'جَرَى بَيْنٌ':Predicate, #5: 5	جَرَى الْبَيْعُ
u'جَرَى تَبَسُّطٌ':Subject, #31: 31	جَرَى بَيْنَ
u'جَرَى تَحَالُفٌ':Subject, #1: 1	جَرَى التَّبَسُّطُ
u'جَرَى تَخْفِيفٌ':Subject, #3: 3	جَرَى التَّحَالُفُ
u'جَرَى تَرْجِيحٌ':Subject, #2: 2	جَرَى التَّخْفِيفُ
u'جَرَى تَرَدُّدٌ':Subject, #1: 1	جَرَى التَّرْجِيحُ
u'جَرْيٌ تَعَارُضٌ':Added, #1: 1	جَرَى التَّرَدُّدُ
u'جَرَى تَعَارُفٌ':Subject, #1: 1	جَرْيِ التَّعَارُضِ
u'جَرَى تَعَامُلٌ':Subject, #8: 8	جَرَى التَّعَارُفُ
u'جَرَى تَفْصِيلٌ':Subject, #3: 3	جَرَى التَّعَامُلُ
u'جَرَى تَقابُض':Subject, #1: 1	جَرَى التَّفْصِيلُ
u'جَرَى تَقْديرٌ':Subject, #2: 2	جَرَى التَّقَابُضُ
u'جَرَى تَوَارُثٌ':Subject, #2: 2	جَرَى التَّقْدِيرُ
u'جَرْيٌ تَوَارُثٌ':Added, #15: 15	جَرَى التَّوَارُثُ
u'جَرَى جلد':Subject, #1: 1	جَرْيُ التَّوَارُثِ
u'جَرَى جَلْدٌ':Subject, #1: 1	جَرَى الْجَلْدُ
u'جَرَى جَمَاعَةٌ':Subject, #1: 1	جَرَى الْجَلْدُ
u'جَرَى جَمْعٌ':Subject, #4: 4	جَرَى جَمَاعَةٌ
u'جَرَى جُمْهُورٌ':Subject, #3: 3	جَرَى جَمْعٌ
u'جَرَى حَدَثٌ':Subject, #1: 1	جَرَى الْجُمْهُورُ
u'جَرَى حَديثٌ':Subject, #1: 1	جَرَى حَدَثُهُ
u'جَرَى حُكْمٌ':Subject, #1: 1	جَرَى الْحَدِيثُ
u'جَرَى حُكْمٌ':Subject, #1: 1	جَرَى حُكْمُ
u'جَرَى حَنَفِيَّةٌ':Subject, #8: 8	جَرَى الْحُكْمُ
u'جَرَى خِلاَفٌ':Subject, #1: 1	جَرَى الْحَنَفِيَّةُ
u'جَرَى خِلاَفٌ':Subject, #22: 22	جَرَى خِلَافٌ
u'جَرَى خُلْعٌ':Subject, #6: 6	جَرَى الْخِلَافُ
u'جَرَى خُلَفَاءُ':Subject, #3: 3	جَرَى الْخُلْعُ
u'جَرَى دَمٌ':Subject, #1: 1	جَرَى الْخُلَفَاءُ
u'جَرَى ذكر':Subject, #1: 1	جَرَى الدَّمُ
u'جَرَى ذِكْرٌ':Subject, #2: 2	جَرَى ذِكْرُ
u'جَرَى رَسْمٌ':Subject, #2: 2	جَرَى ذِكْرُ
u'جَرَى رَسْمٌ':Subject, #3: 3	جَرَى رَسْمُ
u'جَرَى رِقٌّ':Subject, #8: 8	جَرَى الرَّسْمُ
u'جَرْيٌ رِوايَةٌ':Added, #1: 1	جَرَى رِقٌّ
u'جَرَى رِيقٌ':Subject, #1: 1	جَرْيِ الرِّوَايَةِ
u'جَرْيٌ رِيقٌ':Added, #2: 2	جَرَى رِيقُهُ
u'جَرَى زَجْرٌ':Subject, #1: 1	جَرْيُ الرِّيقِ
u'جَرَى سَبَبٌ':Subject, #1: 1	جَرَى الزَّجْرُ
u'جَرَى سَبَبٌ':Subject, #1: 1	جَرَى السَّبَبُ
u'جَرَى سَبَبٌ':Subject, #1: 1	جَرَى سَبَبُهُ
u'جَرْيٌ سَفِينَةٌ':Added, #6: 6	جَرَى سَبَبُ
u'جَرْيٌ سَفِينَةٌ':Added, #1: 1	جَرْيِ السَّفِينَةِ
u'جَرَى سنن':Subject, #2: 2	جَرْيُ السَّفِينَةِ
u'جَرَى شَارِحٌ':Subject, #1: 1	جَرَى سُنَنُ
u'جَرَى شافِعِيّ':Subject, #2: 2	جَرَى الشَّارِحُ
u'جَرَى شَيْءٌ':Subject, #1: 1	جَرَى الشَّافِعِيُّ
u'جَرَى شَيْخٌ':Subject, #1: 1	جَرَى شَيْءٌ
u'جَرَى شَيْطَانٌ':Subject, #3: 3	جَرَى الشَّيْخُ
u'جَرَى صَاحِبٌ':Subject, #1: 1	جَرَى الشَّيْطَانُ
u'جَرَى صَدْرٌ':Subject, #5: 5	جَرَى صَاحِبُ
u'جَرَى صَفِيٌّ':Subject, #1: 1	جَرَى صَدْرُ
u'جَرَى صلح':Subject, #1: 1	جَرَى الصَّفِيُّ
u'جَرَى صُلْحٌ':Subject, #1: 1	جَرَى الصُّلْحُ
u'جَرَى طَلاَقٌ':Subject, #1: 1	جَرَى الصُّلْحُ
u'جَرَى طهر':Predicate, #1: 1	جَرَى طَلَاقٌ
u'جَرْيٌ عَادَةٌ':Added, #1: 1	جَرَى طَهُرَ
u'جَرَى عرف':Subject, #2: 2	جَرْيِ الْعَادَةِ
u'جَرَى عُرْفٌ':Subject, #20: 20	جَرَى الْعُرْفُ
u'جَرَى عَقِبٌ':Predicate, #20: 20	جَرَى الْعُرْفُ
u'جَرَى عَقْدٌ':Subject, #1: 1	جَرَى عَقِبَ
u'جَرَى عَقْدٌ':Subject, #2: 2	جَرَى الْعَقْدُ
u'جَرَى عَمَلٌ':Subject, #2: 2	جَرَى عَقْدٌ
u'جَرَى عُمُومٌ':Subject, #14: 14	جَرَى الْعَمَلُ
u'جَرَى عند':Predicate, #1: 1	جَرَى عُمُومُهُ
u'جَرَى عِيرٌ':Subject, #1: 1	جَرَى عِنْدَ
u'جَرَى فَارِقٌ':Subject, #1: 1	جَرَى عِيرٌ
u'جَرْيٌ فَرَسٌ':Added, #1: 1	جَرَى الْفَارِقُ
u'جَرَى فساد':Subject, #1: 1	جَرْيَ الْفَرَسِ
u'جَرَى فَسَادٌ':Subject, #1: 1	جَرَى الْفَسَادُ
u'جَرَى فَسْخٌ':Subject, #1: 1	جَرَى الْفَسَادُ
u'جَرَى فلان':Subject, #3: 3	جَرَى الْفَسْخُ
u'جَرَى فلان':Subject, #1: 1	جَرَى الْبَيْهَقِيُّ
u'جَرَى فُلاَنٌ':Subject, #1: 1	جَرَى الشَّافِعِيُّ
u'جَرَى قَبْضٌ':Subject, #1: 1	جَرَى فُلَانٌ
u'جَرَى قتال':Subject, #1: 1	جَرَى الْقَبْضُ
u'جَرَى قِتَالٌ':Subject, #1: 1	جَرَى قِتَالٌ
u'جَرَى قِرَاءةٌ':Subject, #1: 1	جَرَى قِتَالٌ
u'جَرَى قصاص':Subject, #1: 1	جَرَى قِرَاءَةُ
u'جَرَى قِصَاصٌ':Subject, #4: 4	جَرَى الْقِصَاصُ
u'جَرَى قَضَاءٌ':Subject, #4: 4	جَرَى الْقِصَاصُ
u'جَرْيٌ قَضَاءٌ':Added, #1: 1	جَرَى الْقَضَاءُ
u'جَرَى قَلَمٌ':Subject, #1: 1	جَرْيِ قَضَاءِ
u'جَرَى قَلَمٌ':Subject, #1: 1	جَرَى الْقَلَمُ
u'جَرْيٌ قَوَاعِدُ':Added, #1: 1	جَرَى قَلَمُ
u'جَرَى قِيَاسٌ':Subject, #1: 1	جَرْيِ الْقَوَاعِدِ
u'جَرَى كَلاَمٌ':Subject, #2: 2	جَرَى الْقِيَاسُ
u'جَرَى لِسَانٌ':Subject, #2: 2	جَرَى كَلَامُ
u'جَرَى لعان':Subject, #1: 1	جَرَى اللِّسَانُ
u'جَرْيٌ لَعْن':Added, #3: 3	جَرَى اللِّعَانُ
u'جَرَى لَفْظٌ':Subject, #1: 1	جَرْيِ اللَّعْنِ
u'جَرَى مَاءٌ':Subject, #2: 2	جَرَى لَفْظُ
u'جَرَى مَاءٌ':Subject, #19: 19	جَرَى الْمَاءُ
u'جَرْيٌ مَاءٌ':Added, #2: 2	جَرَى مَاءُ
u'جَرْيٌ مَاءٌ':Added, #1: 1	جَرْيَ الْمَاءِ
u'جَرْيٌ مَاءٌ':Added, #3: 3	جَرْيُ الْمَاءِ
u'جَرِيمَةٌ شَارِبٌ':Added, #3: 3	جَرْيِ الْمَاءِ
u'جَرِيمَةٌ شرب':Added, #1: 1	جَرِيمَةَ الشَّارِبِ
u'جَرِيمَةٌ شُرْبٌ':Added, #1: 1	جَرِيمَةَ الشُّرْبِ
u'جَرِيمَةٌ شرب':Added, #1: 1	جَرِيمَةَ الشُّرْبِ
u'جَرِيمَةٌ شُرْبٌ':Added, #1: 1	جَرِيمَةِ شُرْبِ
u'جَرِيمَةٌ قَاذِفٌ':Added, #1: 1	جَرِيمَةِ شُرْبِ
u'جَرِيمَةٌ قذف':Added, #1: 1	جَرِيمَةِ الْقَاذِفِ
u'جَرِيمَةٌ قَذْفٌ':Added, #1: 1	جَرِيمَةُ الْقَذْفِ
u'جَرِيمَةٌ قذف':Added, #1: 1	جَرِيمَةُ الْقَذْفِ
u'جَرِيمَةٌ قَذْفٌ':Added, #2: 2	جَرِيمَةِ الْقَذْفِ
u'جَرِيمَةٌ مُغَلَّظ':Added, #2: 2	جَرِيمَةِ الْقَذْفِ
u'جَرِيمَةٌ واحد':Added, #1: 1	جَرِيمَةٍ مُغَلَّظَةٍ
u'جَرِيمَةٌ وَاحِدٌ':Added, #1: 1	جَرِيمَةٍ وَاحِدَةٍ
u'جَرَى مثل':Subject, #1: 1	جَرِيمَةٍ وَاحِدَةٍ
u'جَرَى مِثْلٌ':Subject, #1: 1	جَرَى مِثْلُهُ
u'جَرَى مثل':Subject, #1: 1	جَرَى مِثْلُهُ
u'جَرَى مَثَلٌ':Subject, #3: 3	جَرَى الْمَثَلُ
u'جَرَى مُصَنِّفٌ':Subject, #3: 3	جَرَى الْمَثَلُ
u'جَرَى مِيزَابٌ':Subject, #14: 14	جَرَى الْمُصَنِّفُ
u'جَرَى نَاسٌ':Subject, #3: 3	جَرَى الْمِيزَابُ
u'جَرَى نَبْش':Subject, #3: 3	جَرَى النَّاسُ
u'جَرَى نزاع':Subject, #1: 1	جَرَى النَّبْشُ
u'جَرَى نِزَاعٌ':Subject, #1: 1	جَرَى نِزَاعٌ
u'جَرَى نَظِيرٌ':Subject, #1: 1	جَرَى نِزَاعٌ
u'جَرَى نَهْرٌ':Subject, #1: 1	جَرَى نَظِيرُ
u'جَرَى نَوَوِيٌّ':Subject, #3: 3	جَرَى النَّهْرُ
u'جَرَى وَجْهٌ':Subject, #1: 1	جَرَى النَّوَوِيُّ
u'جَرَى وُجُودٌ':Subject, #1: 1	جَرَى وَجْهٌ
u'جَرَى وَقْفٌ':Subject, #1: 1	جَرَى وُجُودُهُ
u'جَرَى يَعْفُورٌ':Subject, #1: 1	جَرَى الْوَقْفُ
u'جَزَاءٌ إِثْمٌ':Added, #1: 1	جَرَى الْيَعْفُورُ
u'جَزَاءٌ اِحْتِبَاسٌ':Added, #1: 1	جَزَاءَ إثْمٍ
u'جَزَاءٌ إِحْرَامٌ':Added, #1: 1	جَزَاءُ احْتِبَاسٍ
u'جَزَاءٌ إِحْرَامٌ':Added, #1: 1	جَزَاءُ الْإِحْرَامِ
u'جَزَاءٌ إحْسَانٌ':Added, #2: 2	جَزَاءِ الْإِحْرَامِ
u'جَزَاءٌ اِرْتِكَابٌ':Added, #4: 4	جَزَاءُ الْإِحْسَانِ
u'جَزَاءٌ أَعْمَالٌ':Added, #1: 1	جَزَاءَ ارْتِكَابِ
u'جَزَاءٌ أَفْعَالٌ':Added, #1: 1	جَزَاءُ الْأَعْمَالِ
u'جَزَاءٌ أُمٌّ':Added, #1: 1	جَزَاءَ الْأَفْعَالِ
u'جَزَاءٌ تَعْرِيضٌ':Added, #1: 1	جَزَاءِ أُمِّهِ
u'جَزَاءٌ تَقْصيرٌ':Added, #1: 1	جَزَاءَ تَعْرِيضِهِ
u'جَزَاءٌ ثَالِثٌ':Added, #1: 1	جَزَاءُ التَّقْصِيرِ
u'جَزَاءٌ ثَعْلَبٌ':Added, #1: 1	جَزَاءِ الثَّالِثَةِ
u'جَزَاءٌ جِنَايَةٌ':Added, #1: 1	جَزَاءِ الثَّعْلَبِ
u'جَزَاءٌ جِنَايَةٌ':Added, #1: 1	جَزَاءُ الْجِنَايَةِ
u'جَزَاءٌ جَنِينٌ':Added, #1: 1	جَزَاءُ جِنَايَتِهِ
u'جَزَاءٌ جَوَابٌ':Added, #1: 1	جَزَاءَ الْجَنِينِ
u'جَزَاءٌ حَسَنٌ':Added, #1: 1	جَزَاءِ الْجَوَابِ
u'جَزَاءٌ حَسَنٌ':Added, #1: 1	جَزَاءُ الْحَسَنَاتِ
u'جَزَاءٌ حَسَنَةٌ':Added, #1: 1	جَزَاءٍ حَسَنٍ
u'جَزَاءٌ حَمَامٌ':Added, #1: 1	جَزَاءُ الْحَسَنَاتِ
u'جَزَاءٌ حِنْثٌ':Added, #1: 1	جَزَاءِ الْحَمَامِ
u'جَزَاءٌ خدمة':Added, #1: 1	جَزَاءُ الْحِنْثِ
u'جَزَاءٌ خِدْمَةٌ':Added, #1: 1	جَزَاءَ خِدْمَتِهِ
u'جَزَاءٌ خَيْرٌ':Added, #1: 1	جَزَاءَ خِدْمَتِهِ
u'جَزَاءٌ خَيْرٌ':Added, #1: 1	جَزَاءَ الْخَيْرِ
u'جَزَاءٌ ذَنْبٌ':Added, #1: 1	جَزَاءُ الْخَيْرِ
u'جَزَاءٌ رَجُلٌ':Added, #1: 1	جَزَاءَ الذَّنْبِ
u'جَزَاءٌ رِدَّةٌ':Added, #1: 1	جَزَاءِ رَجُلٍ
u'جَزَاءٌ سَارِقٌ':Added, #1: 1	جَزَاءُ الرِّدَّةِ
u'جَزَاءٌ سَلَفٌ':Added, #1: 1	جَزَاءُ السَّارِقِ
u'جَزَاءٌ سَيِّئٌ':Added, #4: 4	جَزَاءُ السَّلَفِ
u'جَزَاءٌ سَيِّئٌ':Added, #1: 1	جَزَاءُ السَّيِّئَةِ
u'جَزَاءٌ شَرْطٌ':Added, #1: 1	جَزَاءِ السَّيِّئَةِ
u'جَزَاءٌ شَرْطٌ':Added, #1: 1	جَزَاءَ شَرْطٍ
u'جَزَاءٌ شَرْطٌ':Added, #1: 1	جَزَاءُ شَرْطٍ
u'جَزَاءٌ شَرْطٌ':Added, #1: 1	جَزَاءَ شَرْطِهِ
u'جَزَاءٌ شَرْطٌ':Added, #2: 2	جَزَاءِ الشَّرْطِ
u'جَزَاءٌ شَرْطٌ':Added, #3: 3	جَزَاءُ الشَّرْطِ
u'جَزَاءٌ شكر':Added, #4: 4	جَزَاءَ الشَّرْطِ
u'جَزَاءٌ شُكْرٌ':Added, #2: 2	جَزَاءَ شُكْرِ
u'جَزَاءٌ صَحَابَةٌ':Added, #2: 2	جَزَاءَ شُكْرِ
u'جَزَاءٌ صَيْدٌ':Added, #1: 1	جَزَاءِ الصَّحَابَةِ
u'جَزَاءٌ صَيْدٌ':Added, #11: 11	جَزَاءَ الصَّيْدِ
u'جَزَاءٌ صَيْدٌ':Added, #1: 1	جَزَاء الصَّيْدِ
u'جَزَاءٌ صَيْدٌ':Added, #1: 1	جَزَاءِ صَيْدِ
u'جَزَاءٌ صَيْدٌ':Added, #24: 24	جَزَاءُ الصَّيْدِ
u'جَزَاءٌ صَيْدٌ':Added, #2: 2	جَزَاءُ صَيْدِ
u'جَزَاءٌ صَيْدٌ':Added, #4: 4	جَزَاءَ صَيْدِ
u'جَزَاءٌ صَيْدٌ':Added, #6: 6	جَزَاءِ صَيْدٍ
u'جَزَاءٌ صَيْدٌ':Added, #7: 7	جَزَاءَ صَيْدٍ
u'جَزَاءٌ طَلاَقٌ':Added, #82: 82	جَزَاءِ الصَّيْدِ
u'جَزَاءٌ طَيْرٌ':Added, #4: 4	جَزَاءِ الطَّلَاقِ
u'جَزَاءٌ ظُلْمٌ':Added, #1: 1	جَزَاءِ الطَّيْرِ
u'جَزَاءٌ عِصْيَانٌ':Added, #12: 12	جَزَاءُ الظُّلْمِ
u'جَزَاءٌ عمرة':Added, #1: 1	جَزَاءُ الْعِصْيَانِ
u'جَزَاءٌ عُمْرَةٌ':Added, #1: 1	جَزَاءَ الْعُمْرَةِ
u'جَزَاءٌ عَمَلٌ':Added, #1: 1	جَزَاءَ الْعُمْرَةِ
u'جَزَاءٌ غير':Added, #1: 1	جَزَاءَ عَمَلِهِ
u'جَزَاءٌ غَيْرٌ':Added, #1: 1	جَزَاءُ غَيْرِ
u'جَزَاءٌ فِعْلٌ':Added, #1: 1	جَزَاءُ غَيْرِ
u'جَزَاءٌ فِعْلٌ':Added, #1: 1	جَزَاءُ فِعْلٍ
u'جَزَاءٌ فِعْلٌ':Added, #2: 2	جَزَاءُ فِعْلِهِ
u'جَزَاءٌ فِعْلٌ':Added, #3: 3	جَزَاءِ الْفِعْلِ
u'جَزَاءٌ فِعْلٌ':Added, #4: 4	جَزَاءَ الْفِعْلِ
u'جَزَاءٌ فلان':Added, #6: 6	جَزَاءُ الْفِعْلِ
u'جَزَاءٌ فِيلٌ':Added, #2: 2	جَزَاءَ سِنِمّارِ
u'جَزَاءٌ قَتْلٌ':Added, #1: 1	جَزَاءِ الْفِيلِ
u'جَزَاءٌ قتل':Added, #1: 1	جَزَاءَ قَتْلٍ
u'جَزَاءٌ قَتْلٌ':Added, #1: 1	جَزَاءُ قَتْلِهِ
u'جَزَاءٌ قتل':Added, #1: 1	جَزَاءُ قَتْلِهِ
u'جَزَاءٌ قَتْلٌ':Added, #2: 2	جَزَاءَ الْقَتْلِ
u'جَزَاءٌ قتل':Added, #2: 2	جَزَاءَ الْقَتْلِ
u'جَزَاءٌ قَتْلٌ':Added, #3: 3	جَزَاءُ الْقَتْلِ
u'جَزَاءٌ قَوْمٌ':Added, #3: 3	جَزَاءُ الْقَتْلِ
u'جَزَاءٌ كَامِلٌ':Added, #1: 1	جَزَاءِ قَوْمٍ
u'جَزَاءٌ كفر':Added, #2: 2	جَزَاءٍ كَامِلٍ
u'جَزَاءٌ كُفْرٌ':Added, #2: 2	جَزَاءُ الْكُفْرِ
u'جَزَاءٌ كَلاَمٌ':Added, #2: 2	جَزَاءُ الْكُفْرِ
u'جَزَاءٌ مُبَاشَرَةٌ':Added, #1: 1	جَزَاءَ الْكَلَامِ
u'جَزَاءٌ مُبَاشَرَةٌ':Added, #1: 1	جَزَاءِ الْمُبَاشَرَةِ
u'جَزَاءٌ مُبَاشَرَةٌ':Added, #1: 1	جَزَاءَ مُبَاشَرَةِ
u'جَزَاءٌ مُتَأَخِّرٌ':Added, #3: 3	جَزَاءُ الْمُبَاشَرَةِ
u'جَزَاءٌ مثل':Added, #1: 1	جَزَاءٍ مُتَأَخِّرٍ
u'جَزَاءٌ مِثْلٌ':Added, #1: 1	جَزَاءَ الْمِثْلِ
u'جَزَاءٌ مثل':Added, #1: 1	جَزَاءَ الْمِثْلِ
u'جَزَاءٌ مِثْلٌ':Added, #2: 2	جَزَاءُ مِثْلِ
u'جَزَاءٌ مثل':Added, #2: 2	جَزَاءُ مِثْلِ
u'جَزَاءٌ مِثْلٌ':Added, #5: 5	جَزَاءُ مِثْلِهِ
u'جَزَاءٌ مِثْلِيٌّ':Added, #5: 5	جَزَاءُ مِثْلِهِ
u'جَزَاءٌ مُحَارَبَةٌ':Added, #1: 1	جَزَاءِ الْمِثْلِيِّ
u'جَزَاءٌ مُحَارَبَةٌ':Added, #1: 1	جَزَاءَ الْمُحَارَبَةِ
u'جَزَاءٌ مَحَلٌّ':Added, #1: 1	جَزَاءُ الْمُحَارَبَةِ
u'جَزَاءٌ مُرْتَدٌّ':Added, #4: 4	جَزَاءُ الْمَحَلِّ
u'جَزَاءٌ مَصْدَرٌ':Added, #1: 1	جَزَاءُ الْمُرْتَدِّ
u'جَزَاءٌ مَعْطُوف':Added, #1: 1	جَزَاءَ الْمَصْدَرِ
u'جَزَاءٌ مَقْتُولٌ':Added, #1: 1	جَزَاءٍ مَعْطُوفٍ
u'جَزَاءٌ مَقْتُولٌ':Added, #1: 1	جَزَاءَ الْمَقْتُولِ
u'جَزَاءٌ مُمَاطَلَةٌ':Added, #1: 1	جَزَاءُ الْمَقْتُولِ
u'جَزَاءٌ واحد':Added, #4: 4	جَزَاءُ الْمُمَاطَلَةِ
u'جَزَاءٌ واحد':Added, #1: 1	جَزَاءٍ وَاحِدٍ
u'جَزَاءٌ وَاحِدٌ':Added, #1: 1	جَزَاءُ وَاحِدٍ
u'جَزَاءٌ وَاحِدٌ':Added, #1: 1	جَزَاءٍ وَاحِدٍ
u'جَزَاءٌ وبر':Added, #1: 1	جَزَاءُ وَاحِدٍ
u'جَزَاءٌ وَبْرٌ':Added, #1: 1	جَزَاءِ الْوَبْرِ
u'جَزَاءٌ ولد':Added, #1: 1	جَزَاءِ الْوَبْرِ
u'جَزَاءٌ وَلَدٌ':Added, #2: 2	جَزَاءُ الْوَلَدِ
u'جَزَاءٌ يَمِينٌ':Added, #2: 2	جَزَاءُ الْوَلَدِ
u'جَزَاءٌ يَمِينٌ':Added, #1: 1	جَزَاءِ الْيَمِينِ
u'جَزَأَ أَمْرٌ':Predicate, #2: 2	جَزَاءَ الْيَمِينِ
u'جَزَّأَ عَبِيدٌ':Predicate, #1: 1	جَزَأَ الْأَمْرَ
u'جَزَالَةٌ قول':Added, #2: 2	جَزَّأَ الْعَبِيدَ
u'جَزَالَةٌ قَوْلٌ':Added, #1: 1	جَزَالَةَ الْقَوْلِ
u'جَزَالَةٌ كَلاَمٌ':Added, #1: 1	جَزَالَةَ الْقَوْلِ
u'جَزَّأَ مَقْسُومٌ':Subject, #1: 1	جَزَالَةِ كَلَامِ
u'جَزَّ ثِمارٌ':Predicate, #1: 1	جَزَّأَ الْمَقْسُومُ
u'جَزْرٌ حَيَوَانٌ':Added, #1: 1	جَزَّ الثِّمَارَ
u'جَزَّ صُوفٌ':Predicate, #1: 1	جَزْرِ الْحَيَوَانِ
u'جَزَّ صُوفٌ':Predicate, #2: 2	جَزَّ الصُّوفَ
u'جَزَّ عَانَةٌ':Predicate, #5: 5	جَزَّ صُوفَ
u'جزع خَزْرَجٌ':Added, #1: 1	جَزَّ عَانَةَ
u'جَزَعٌ خَزْرَجٌ':Added, #1: 1	جَزَعَ الْخَزْرَجِ
u'جَزِعَ مِدَادٌ':Subject, #1: 1	جَزَعَ الْخَزْرَجِ
u'جَزَّ عُمَرٌ':Subject, #1: 1	جَزِعَ الْمِدَادُ
u'جزع نِساءٌ':Added, #1: 1	جَزَّ عُمَرُ
u'جَزَعٌ نِساءٌ':Added, #1: 1	جَزَعُ النِّسَاءِ
u'جَزَلَ رَأْيٌ':Subject, #1: 1	جَزَعُ النِّسَاءِ
u'جَزَمَ اِبْنٌ':Subject, #1: 1	جَزَلَ رَأْيُهُ
u'جَزَمَ أُسْتَاذٌ':Subject, #67: 67	جَزَمَ ابْنُ
u'جَزَمَ أَصْحَابٌ':Subject, #4: 4	جَزَمَ الْأُسْتَاذُ
u'جَزَمَ أَصْحَابٌ':Subject, #1: 1	جَزَمَ أَصْحَابُ
u'جَزَمَ أصل':Subject, #3: 3	جَزَمَ الْأَصْحَابُ
u'جَزَمَ أًصْلٌ':Subject, #8: 8	جَزَمَ الْأَصْلُ
u'جَزَمَ أَكْثَرُ':Subject, #8: 8	جَزَمَ الْأَصْلُ
u'جَزَّ مَالِكٌ':Subject, #1: 1	جَزَمَ الْأَكْثَرُ
u'جَزَمَ إمَامٌ':Subject, #1: 1	جَزَّ الْمَالِكُ
u'جَزَمَ إمَامٌ':Subject, #1: 1	جَزَمَ إمَامُ
u'جَزَمَ أئِمَّةٌ':Subject, #7: 7	جَزَمَ الْإِمَامُ
u'جَزَمَ بُخَارِيٌّ':Subject, #1: 1	جَزَمَ الْأَئِمَّةُ
u'جَزَمَ بُرْهانٌ':Subject, #2: 2	جَزَمَ الْبُخَارِيُّ
u'جَزَمَ بُرْهَانٌ':Subject, #1: 1	جَزَمَ الْبُرْهَانُ
u'جَزَمَ بَزَّارٌ':Subject, #1: 1	جَزَمَ الْبُرْهَانُ
u'جَزَمَ بَعْضٌ':Subject, #1: 1	جَزَمَ الْبَزَّارُ
u'جَزَمَ بَيْضاوِيّ':Subject, #6: 6	جَزَمَ بَعْضُ
u'جَزَمَ جَمَاعَةٌ':Subject, #1: 1	جَزَمَ الْبَيْضَاوِيُّ
u'جَزَمَ جَمْعٌ':Subject, #2: 2	جَزَمَ جَمَاعَةٌ
u'جَزَمَ جُمْهُورٌ':Subject, #2: 2	جَزَمَ جَمْعٌ
u'جَزَمَ جَوْهَرِيٌّ':Subject, #1: 1	جَزَمَ الْجُمْهُورُ
u'جَزَمَ حاكِمٌ':Subject, #2: 2	جَزَمَ الْجَوْهَرِيُّ
u'جَزَمَ حَلْوانِيٌّ':Subject, #1: 1	جَزَمَ الْحَاكِمُ
u'جَزَمَ خلائق':Subject, #1: 1	جَزَمَ الْحَلْوَانِيُّ
u'جَزَمَ خَلائِقُ':Subject, #1: 1	جَزَمَ خَلَائِقُ
u'جَزَمَ سُرُوجِيّ':Subject, #1: 1	جَزَمَ خَلَائِقُ
u'جَزَمَ سَلَفٌ':Subject, #1: 1	جَزَمَ السُّرُوجِيُّ
u'جَزَمَ شَارِحٌ':Subject, #1: 1	جَزَمَ السَّلَفُ
u'جَزَمَ شافِعِيّ':Subject, #5: 5	جَزَمَ الشَّارِحُ
u'جَزَمَ شُهُودٌ':Subject, #3: 3	جَزَمَ الشَّافِعِيُّ
u'جَزَمَ شَيْخٌ':Subject, #1: 1	جَزَمَ الشُّهُودُ
u'جَزَمَ صَاحِبٌ':Subject, #12: 12	جَزَمَ الشَّيْخُ
u'جَزَمَ صَيْرَفِيٌّ':Subject, #51: 51	جَزَمَ صَاحِبُ
u'جَزَمَ طَبَرِيّ':Subject, #1: 1	جَزَمَ الصَّيْرَفِيُّ
u'جَزَمَ عَبْدٌ':Subject, #3: 3	جَزَمَ الطَّبَرِيُّ
u'جَزَمَ غير':Subject, #1: 1	جَزَمَ عَبْدُ
u'جَزَمَ غَيْرٌ':Subject, #2: 2	جَزَمَ غَيْرُهُ
u'جَزَمَ فلان':Predicate, #2: 2	جَزَمَ غَيْرُهُ
u'جَزَمَ فلان':Subject, #1: 1	جَزَمَ الرَّازِيَّ
u'جَزَمَ فلان':Subject, #1: 1	جَزَمَ الْحَارِثِيُّ
u'جَزَمَ فلان':Subject, #3: 3	جَزَمَ الْبَيْهَقِيُّ
u'جَزَمَ فلان':Subject, #3: 3	جَزَمَ الشَّافِعِيُّ
u'جَزَمَ قَفَّالٌ':Subject, #3: 3	جَزَمَ الطَّبَرِيُّ
u'جَزَمَ قول':Predicate, #7: 7	جَزَمَ الْقَفَّالُ
u'جَزَمَ قَوْلٌ':Predicate, #1: 1	جَزَمَ الْقَوْلَ
u'جَزَمَ مَجْدٌ':Subject, #1: 1	جَزَمَ الْقَوْلَ
u'جَزَمَ مُحِبٌّ':Subject, #1: 1	جَزَمَ الْمَجْدُ
u'جَزَمَ مُحَقِّقٌ':Subject, #2: 2	جَزَمَ الْمُحِبُّ
u'جَزَمَ مَحْمُولٌ':Subject, #1: 1	جَزَمَ الْمُحَقِّقُ
u'جَزَمَ مُسْتَوْعِبٌ':Subject, #1: 1	جَزَمَ مَحْمُولٌ
u'جَزَمَ مُصَنِّفٌ':Subject, #1: 1	جَزَمَ الْمُسْتَوْعِبُ
u'جَزَمَ مِنْهَاجٌ':Subject, #24: 24	جَزَمَ الْمُصَنِّفُ
u'جَزَمَ نُقَّادٌ':Subject, #5: 5	جَزَمَ الْمِنْهَاجُ
u'جَزَمَ نَوَوِيٌّ':Subject, #1: 1	جَزَمَ النُّقَّادُ
u'جَزَمَ وَالِدٌ':Subject, #11: 11	جَزَمَ النَّوَوِيُّ
u'جَزَى أعْظَمُ':Predicate, #1: 1	جَزَمَ الْوَالِدُ
u'جَزَى رَبُّ':Subject, #1: 1	جَزَى أَعْظَمَ
u'جَزَى عِبَادٌ':Predicate, #2: 2	جَزَى رَبّهُ
u'جَزَى نَاسٌ':Predicate, #1: 1	جَزَى الْعِبَادَ
u'جَصَّصَ دَارٌ':Predicate, #1: 1	جَزَى النَّاسَ
u'جَعَلَ اِبْتِداءٌ':Predicate, #3: 3	جَصَّصَ الدَّارَ
u'جَعَلَ إبْلِيسُ':Subject, #1: 1	جَعَلَ ابْتِدَاءَ
u'جَعَلَ اِبْنٌ':Predicate, #1: 1	جَعَلَ إِبْلِيسُ
u'جَعَلَ اِبْنٌ':Subject, #2: 2	جَعَلَ ابْنَ
u'جَعَلَ إِبْهَامٌ':Predicate, #9: 9	جَعَلَ ابْنُ
u'جَعَلَ اِتِّبَاعٌ':Predicate, #1: 1	جَعَلَ الْإِبْهَامَ
u'جَعَلَ اِتِّفَاقٌ':Predicate, #1: 1	جَعَلَ اتِّبَاعَ
u'جَعَلَ إِثْمٌ':Predicate, #1: 1	جَعَلَ اتِّفَاقَ
u'جَعَلَ إجَازَةٌ':Predicate, #2: 2	جَعَلَ الْإِثْمَ
u'جَعَلَ أَجْرٌ':Predicate, #1: 1	جَعَلَ الْإِجَازَةَ
u'جَعَلَ أَجْرٌ':Predicate, #1: 1	جَعَلَ الْأَجْرَ
u'جَعَلَ أُجْرَةٌ':Predicate, #2: 2	جَعَلَ أَجْرَ
u'جَعَلَ أُجْرَةٌ':Predicate, #1: 1	جَعَلَ أُجْرَةَ
u'جَعَلَ إِجْزَاءٌ':Predicate, #5: 5	جَعَلَ الْأُجْرَةَ
u'جَعَلَ أَجَلٌ':Predicate, #1: 1	جَعَلَ الْإِجْزَاءَ
u'جَعَلَ أَجَلٌ':Predicate, #1: 1	جَعَلَ أَجَلَ
u'جَعَلَ أحَدٌ':Predicate, #3: 3	جَعَلَ الْأَجَلَ
u'جَعَلَ أحَدٌ':Subject, #7: 7	جَعَلَ أَحَدَ
u'جَعَلَ إِحْرَامٌ':Predicate, #1: 1	جَعَلَ أَحَدُ
u'جَعَلَ اِخْتِيَارٌ':Predicate, #1: 1	جَعَلَ الْإِحْرَامَ
u'جَعَلَ أخْذٌ':Predicate, #2: 2	جَعَلَ اخْتِيَارَ
u'جَعَلَ آخِرُ':Predicate, #1: 1	جَعَلَ الْأَخْذَ
u'جَعَلَ إِخْرَاجٌ':Predicate, #1: 1	جَعَلَ آخِرَ
u'جَعَلَ آخِرَةٌ':Predicate, #1: 1	جَعَلَ الْإِخْرَاجَ
u'جَعَلَ إِخْلاَصٌ':Predicate, #1: 1	جَعَلَ الْآخِرَةَ
u'جَعَلَ أَدَاءٌ':Predicate, #1: 1	جَعَلَ الْإِخْلَاصَ
u'جَعَلَ أَذَانٌ':Predicate, #4: 4	جَعَلَ أَدَاءَ
u'جَعَلَ أَذَانٌ':Predicate, #1: 1	جَعَلَ أَذَانَ
u'جَعَلَ أَرْبَعَةٌ':Predicate, #4: 4	جَعَلَ الْأَذَانَ
u'جَعَلَ إِرْثٌ':Predicate, #2: 2	جَعَلَ أَرْبَعَةَ
u'جَعَلَ إِرْسَالٌ':Predicate, #2: 2	جَعَلَ الْإِرْثَ
u'جَعَلَ أرْضٌ':Predicate, #1: 1	جَعَلَ الْإِرْسَالَ
u'جَعَلَ أسْبَابٌ':Predicate, #3: 3	جَعَلَ الْأَرْضَ
u'جَعَلَ أَسْبَابٌ':Predicate, #1: 1	جَعَلَ أَسْبَابَ
u'جَعَلَ اِسْتيفاءٌ':Predicate, #1: 1	جَعَلَ أَسْبَابَ
u'جَعَلَ إِسْفارٌ':Predicate, #1: 1	جَعَلَ اسْتِيفَاءَ
u'جَعَلَ أَسْفَلُ':Predicate, #1: 1	جَعَلَ الْإِسْفَارَ
u'جَعَلَ إِسْلامٌ':Predicate, #1: 1	جَعَلَ أَسْفَلَ
u'جَعَلَ اِسْمٌ':Predicate, #1: 1	جَعَلَ الْإِسْلَامَ
u'جَعَلَ إشارَة':Predicate, #1: 1	جَعَلَ اسْمَ
u'جَعَلَ أشْبَهُ':Predicate, #1: 1	جَعَلَ الْإِشَارَةَ
u'جَعَلَ أَشْهُرٌ':Predicate, #1: 1	جَعَلَ الْأَشْبَهَ
u'جَعَلَ أَصابِعُ':Predicate, #2: 2	جَعَلَ الْأَشْهُرَ
u'جَعَلَ أَصْحَابٌ':Subject, #1: 1	جَعَلَ الْأَصَابِعَ
u'جَعَلَ أَصْحَابٌ':Subject, #1: 1	جَعَلَ أَصْحَابُ
u'جَعَلَ اِعْتِرافٌ':Predicate, #2: 2	جَعَلَ الْأَصْحَابُ
u'جَعَلَ إعْلاَمٌ':Predicate, #1: 1	جَعَلَ اعْتِرَافَ
u'جَعَلَ أَعْمَالٌ':Predicate, #1: 1	جَعَلَ إِعْلاَمَ
u'جَعَلَ اِفْتِرَاقٌ':Predicate, #1: 1	جَعَلَ الْأَعْمَالَ
u'جَعَلَ إقامَةٌ':Predicate, #1: 1	جَعَلَ افْتِرَاقَ
u'جَعَلَ إقْرَارٌ':Predicate, #4: 4	جَعَلَ الْإِقَامَةَ
u'جَعَلَ أَقْسَامٌ':Predicate, #1: 1	جَعَلَ الْإِقْرَارَ
u'جَعَلَ أَقْسَامٌ':Predicate, #1: 1	جَعَلَ أَقْسَامَ
u'جَعَلَ أقَلُّ':Predicate, #1: 1	جَعَلَ الْأَقْسَامَ
u'جَعَلَ أقَلُّ':Predicate, #1: 1	جَعَلَ أَقَلَّ
u'جَعَلَ إكْرَامٌ':Predicate, #3: 3	جَعَلَ الْأَقَلَّ
u'جَعَلَ إكْرَاهٌ':Predicate, #1: 1	جَعَلَ الْإِكْرَامَ
u'جَعَلَ أكل':Predicate, #1: 1	جَعَلَ الْإِكْرَاهَ
u'جَعَلَ أَكْلٌ':Predicate, #1: 1	جَعَلَ أَكْلَ
u'جَعَلَ اِلْتِزَامٌ':Predicate, #1: 1	جَعَلَ أَكْلَ
u'جَعَلَ ألف':Predicate, #1: 1	جَعَلَ الْتِزَامَ
u'جَعَلَ ألف':Predicate, #1: 1	جَعَلَ الْأَلِفَ
u'جَعَلَ ألْفٌ':Predicate, #2: 2	جَعَلَ الْأَلْفَ
u'جَعَلَ أَلْفٌ':Predicate, #2: 2	جَعَلَ الْأَلْفَ
u'جَعَلَ إِلْمَامٌ':Predicate, #2: 2	جَعَلَ الْأَلْفَ
u'جَعَلَ الْمَرْأَةُ':Predicate, #1: 1	جَعَلَ إلْمَامَ
u'جَعَلَ إلْهَامٌ':Predicate, #1: 1	جَعَلَ الْمَرْأَةَ
u'جَعَلَ أُمٌّ':Predicate, #1: 1	جَعَلَ الْإِلْهَامَ
u'جَعَلَ إمَامٌ':Subject, #3: 3	جَعَلَ الْأُمَّ
u'جَعَلَ إمَامٌ':Subject, #14: 14	جَعَلَ الْإِمَامُ
u'جَعَلَ أمَةٌ':Predicate, #1: 1	جَعَلَ إمَامُ
u'جَعَلَ أَمْرٌ':Predicate, #1: 1	جَعَلَ الْأَمَةَ
u'جَعَلَ أَمْرٌ':Predicate, #15: 15	جَعَلَ الْأَمْرَ
u'جَعَلَ أَمْرٌ':Predicate, #1: 1	جَعَلَ الأَمْرَ
u'جَعَلَ إِمْكانٌ':Predicate, #38: 38	جَعَلَ أَمْرَ
u'جَعَلَ إِنْسانٌ':Predicate, #1: 1	جَعَلَ إمْكَانَ
u'جَعَلَ إِنْفاقٌ':Predicate, #1: 1	جَعَلَ الْإِنْسَانَ
u'جَعَلَ اِنْقِرَاضٌ':Predicate, #1: 1	جَعَلَ الْإِنْفَاقَ
u'جَعَلَ أَنْوَاعٌ':Predicate, #2: 2	جَعَلَ انْقِرَاضَ
u'جَعَلَ أهْلٌ':Predicate, #1: 1	جَعَلَ أَنْوَاعَ
u'جَعَلَ أهْلٌ':Subject, #1: 1	جَعَلَ أَهْلَ
u'جَعَلَ أَهِلَّةٌ':Predicate, #3: 3	جَعَلَ أَهْلُ
u'جَعَلَ أَهِلَّةٌ':Subject, #1: 1	جَعَلَ الأَهِلَّةَ
u'جَعَلَ أَوْسَاطٌ':Predicate, #1: 1	جَعَلَ الأَهِلَّةُ
u'جَعَلَ أَوَّلُ':Predicate, #1: 1	جَعَلَ أَوْسَاطَ
u'جَعَلَ أَوَّلُ':Predicate, #1: 1	جَعَلَ أَوَّلَ
u'جَعَلَ أَوَّلُ':Predicate, #2: 2	جَعَلَ الأَوَّلَ
u'جَعَلَ أيَّامٌ':Predicate, #4: 4	جَعَلَ الْأَوَّلَ
u'جَعَلَ أَيَّامٌ':Predicate, #1: 1	جَعَلَ الْأَيَّامَ
u'جَعَلَ إِيجَابٌ':Predicate, #1: 1	جَعَلَ الْأَيَّامَ
u'جَعَلَ إيمَانٌ':Predicate, #2: 2	جَعَلَ إيجَابَ
u'جَعَلَ بَابٌ':Predicate, #1: 1	جَعَلَ الإِيمَانَ
u'جَعَلَ بَاطن':Predicate, #1: 1	جَعَلَ بَابَ
u'جَعَلَ باطِنٌ':Predicate, #3: 3	جَعَلَ بَاطِنَ
u'جَعَلَ باقِي':Predicate, #3: 3	جَعَلَ بَاطِنَ
u'جَعَلَ بَائِعٌ':Subject, #1: 1	جَعَلَ الْبَاقِيَ
u'جَعَلَ بِدَايَةٌ':Predicate, #2: 2	جَعَلَ الْبَائِعُ
u'جَعَلَ بَدَلٌ':Predicate, #1: 1	جَعَلَ الْبِدَايَةَ
u'جَعَلَ بَراءةٌ':Predicate, #3: 3	جَعَلَ بَدَلَ
u'جَعَلَ بِطانَةٌ':Predicate, #1: 1	جَعَلَ الْبَرَاءَةَ
u'جَعَلَ بَطْنٌ':Predicate, #1: 1	جَعَلَ بِطَانَةَ
u'جَعَلَ بَعْد':Predicate, #1: 1	جَعَلَ بَطْنَ
u'جَعَلَ بَعْضٌ':Predicate, #1: 1	جَعَلَ الْبَعْدِيَّةَ
u'جَعَلَ بَعْضٌ':Subject, #9: 9	جَعَلَ بَعْضَ
u'جَعَلَ بَقاءٌ':Predicate, #6: 6	جَعَلَ بَعْضُ
u'جَعَلَ بُقْعَةٌ':Predicate, #1: 1	جَعَلَ بَقَاءَ
u'جَعَلَ بِنَاءٌ':Predicate, #1: 1	جَعَلَ الْبُقْعَةَ
u'جَعَلَ بناتٌ':Predicate, #1: 1	جَعَلَ الْبِنَاءَ
u'جَعَلَ بِئْرٌ':Predicate, #1: 1	جَعَلَ بَنَاتَ
u'جَعَلَ بَيَاضٌ':Predicate, #1: 1	جَعَلَ الْبِئْرَ
u'جَعَلَ بَيْتٌ':Predicate, #1: 1	جَعَلَ الْبَيَاضَ
u'جَعَلَ بَيْعٌ':Predicate, #2: 2	جَعَلَ الْبَيْتَ
u'جَعَلَ بَيْعٌ':Predicate, #1: 1	جَعَلَ بَيْعَ
u'جَعَلَ بَيْنٌ':Predicate, #4: 4	جَعَلَ الْبَيْعَ
u'جَعَلَ بُيُوتٌ':Predicate, #1: 1	جَعَلَ بَيْنَ
u'جَعَلَ تَأْخِيرٌ':Predicate, #1: 1	جَعَلَ الْبُيُوتَ
u'جَعَلَ تالِف':Predicate, #2: 2	جَعَلَ تَأْخِيرَ
u'جَعَلَ تَأْلِيفٌ':Predicate, #1: 1	جَعَلَ التَّالِفَ
u'جَعَلَ تَجَدُّدٌ':Predicate, #2: 2	جَعَلَ التَّأْلِيفَ
u'جَعَلَ تَحْجِيرٌ':Predicate, #1: 1	جَعَلَ تَجَدُّدَ
u'جَعَلَ تَحْرِيرٌ':Predicate, #1: 1	جَعَلَ التَّحْجِيرَ
u'جَعَلَ تَدْبِيرٌ':Predicate, #1: 1	جَعَلَ التَّحْرِيرَ
u'جَعَلَ تُرَابٌ':Predicate, #2: 2	جَعَلَ التَّدْبِيرَ
u'جَعَلَ تَرْكٌ':Predicate, #1: 1	جَعَلَ التُّرَابَ
u'جَعَلَ تَزْوِيجٌ':Predicate, #1: 1	جَعَلَ تَرْكَ
u'جَعَلَ تَسْبِيحٌ':Predicate, #1: 1	جَعَلَ التَّزْوِيجَ
u'جَعَلَ تَسْمِيَة':Predicate, #1: 1	جَعَلَ التَّسْبِيحَ
u'جَعَلَ تَشَفِّي':Predicate, #1: 1	جَعَلَ التَّسْمِيَةَ
u'جَعَلَ تَصْحِيحٌ':Predicate, #1: 1	جَعَلَ التَّشَفِّيَ
u'جَعَلَ تَصْدِيقٌ':Predicate, #1: 1	جَعَلَ التَّصْحِيحَ
u'جَعَلَ تَضْحِيَةٌ':Predicate, #1: 1	جَعَلَ التَّصْدِيقَ
u'جَعَلَ تَطْلِيقٌ':Predicate, #1: 1	جَعَلَ تَضْحِيَةَ
u'جَعَلَ تَعْلِيلٌ':Predicate, #1: 1	جَعَلَ التَّطْلِيقَ
u'جَعَلَ تَعْلِيمٌ':Predicate, #1: 1	جَعَلَ التَّعْلِيلَ
u'جَعَلَ تَعْيِينٌ':Predicate, #1: 1	جَعَلَ التَّعْلِيمَ
u'جَعَلَ تَغْرِيقٌ':Predicate, #1: 1	جَعَلَ التَّعْيِينَ
u'جَعَلَ تَفْرِيقٌ':Predicate, #1: 1	جَعَلَ تَغْرِيقَ
u'جَعَلَ تَقْديرٌ':Predicate, #1: 1	جَعَلَ التَّفْرِيقَ
u'جَعَلَ تَكْبيرٌ':Predicate, #2: 2	جَعَلَ التَّقْدِيرَ
u'جَعَلَ تَكْرارٌ':Predicate, #1: 1	جَعَلَ التَّكْبِيرَ
u'جَعَلَ تَكْليفٌ':Predicate, #1: 1	جَعَلَ التَّكْرَارَ
u'جَعَلَ تَلَف':Predicate, #3: 3	جَعَلَ التَّكْلِيفَ
u'جَعَلَ تمام':Predicate, #1: 1	جَعَلَ التَّلَفَ
u'جَعَلَ تَمامٌ':Predicate, #2: 2	جَعَلَ تَمَامَ
u'جَعَلَ تَمَتُّعٌ':Predicate, #2: 2	جَعَلَ تَمَامَ
u'جَعَلَ تَمَصُّرٌ':Predicate, #1: 1	جَعَلَ التَّمَتُّعَ
u'جَعَلَ تَنْبِيه':Predicate, #1: 1	جَعَلَ تَمَصُّرَ
u'جَعَلَ تَنْفِيذٌ':Predicate, #1: 1	جَعَلَ التَّنْبِيهَ
u'جَعَلَ تَوَجُّهٌ':Predicate, #1: 1	جَعَلَ تَنْفِيذَ
u'جَعَلَ تَوْلِيَةٌ':Predicate, #1: 1	جَعَلَ التَّوَجُّهَ
u'جَعَلَ تَيَمُّمٌ':Predicate, #1: 1	جَعَلَ التَّوْلِيَةَ
u'جَعَلَ ثَانِي':Predicate, #3: 3	جَعَلَ التَّيَمُّمَ
u'جَعَلَ ثَانِي':Predicate, #2: 2	جَعَلَ الثَّانِيَ
u'جَعَلَ ثَانِيَةٌ':Predicate, #2: 2	جَعَلَ الثَّانِيَةَ
u'جَعَلَ ثَلاثُ':Predicate, #2: 2	جَعَلَ الثَّانِيَةَ
u'جَعَلَ ثَلاثُ':Predicate, #1: 1	جَعَلَ الثَّلاَثَ
u'جَعَلَ ثَلاثَةٌ':Predicate, #2: 2	جَعَلَ الثَّلَاثَ
u'جَعَلَ ثَلاثَةٌ':Predicate, #2: 2	جَعَلَ الثَّلَاثَةَ
u'جَعَلَ ثَمَرَةٌ':Predicate, #2: 2	جَعَلَ ثَلَاثَةَ
u'جَعَلَ ثَمَنٌ':Predicate, #1: 1	جَعَلَ الثَّمَرَةَ
u'جَعَلَ ثَمَنٌ':Predicate, #1: 1	جَعَلَ ثَمَنَ
u'جَعَلَ ثَوابٌ':Predicate, #2: 2	جَعَلَ الثَّمَنَ
u'جَعَلَ ثَوابٌ':Predicate, #1: 1	جَعَلَ ثَوَابَ
u'جَعَلَ ثَوْبٌ':Predicate, #2: 2	جَعَلَ الثَّوَابَ
u'جَعَلَ ثِيابٌ':Predicate, #2: 2	جَعَلَ الثَّوْبَ
u'جَعَلَ جَابِرٌ':Predicate, #1: 1	جَعَلَ ثِيَابَ
u'جَعَلَ جَارِي':Predicate, #1: 1	جَعَلَ الْجَابِرَ
u'جَعَلَ جَارِيَةٌ':Predicate, #1: 1	جَعَلَ الْجَارِيَةَ
u'جَعَلَ جَانِبٌ':Predicate, #1: 1	جَعَلَ الْجَارِيَةَ
u'جَعَلَ جَاهِلٌ':Predicate, #2: 2	جَعَلَ الْجَانِبَ
u'جَعَلَ جُحُود':Predicate, #1: 1	جَعَلَ الْجَاهِلَ
u'جَعَلَ جَزَاءٌ':Predicate, #1: 1	جَعَلَ الْجُحُودَ
u'جَعَلَ جَزَاءٌ':Predicate, #1: 1	جَعَلَ جَزَاءَ
u'جَعَلَ جلد':Predicate, #2: 2	جَعَلَ الْجَزَاءَ
u'جَعَلَ جِلْدٌ':Predicate, #1: 1	جَعَلَ الْجِلْدَ
u'جَعَلَ جلد':Predicate, #1: 1	جَعَلَ الْجِلْدَ
u'جَعَلَ جَلْدٌ':Predicate, #4: 4	جَعَلَ الْجَلْدَ
u'جَعَلَ جُلُوسٌ':Predicate, #4: 4	جَعَلَ الْجَلْدَ
u'جَعَلَ جمعة':Predicate, #1: 1	جَعَلَ جُلُوسَ
u'جَعَلَ جُمُعَةٌ':Predicate, #2: 2	جَعَلَ الْجُمُعَةَ
u'جَعَلَ جُمْلَةٌ':Predicate, #2: 2	جَعَلَ الْجُمُعَةَ
u'جَعَلَ جِنْسٌ':Predicate, #1: 1	جَعَلَ الْجُمْلَةَ
u'جَعَلَ جَوَابٌ':Predicate, #1: 1	جَعَلَ جِنْسَ
u'جَعَلَ جَوَابٌ':Predicate, #1: 1	جَعَلَ جَوَابَ
u'جَعَلَ حاكِمٌ':Subject, #2: 2	جَعَلَ الْجَوَابَ
u'جَعَلَ حالٌ':Predicate, #1: 1	جَعَلَ حَاكِمٌ
u'جَعَلَ حَبْلٌ':Predicate, #1: 1	جَعَلَ الْحَالَ
u'جَعَلَ حَجٌّ':Predicate, #1: 1	جَعَلَ الْحَبْلَ
u'جَعَلَ حَجٌّ':Subject, #2: 2	جَعَلَ الْحَجَّ
u'جَعَلَ حَجَرٌ':Predicate, #1: 1	جَعَلَ الْحَجُّ
u'جَعَلَ حَدٌّ':Predicate, #2: 2	جَعَلَ الْحَجَرَ
u'جَعَلَ حَدٌّ':Predicate, #1: 1	جَعَلَ الْحَدَّ
u'جَعَلَ حَرَمٌ':Predicate, #1: 1	جَعَلَ حَدَّ
u'جَعَلَ حُرْمَةٌ':Predicate, #1: 1	جَعَلَ الْحَرَمَ
u'جَعَلَ حُرِّيَّةٌ':Predicate, #1: 1	جَعَلَ حُرْمَةَ
u'جَعَلَ حَرِيرٌ':Predicate, #1: 1	جَعَلَ الْحُرِّيَّةَ
u'جَعَلَ حَرِيمٌ':Predicate, #1: 1	جَعَلَ الْحَرِيرَ
u'جَعَلَ حَسَنٌ':Predicate, #2: 2	جَعَلَ الْحَرِيمَ
u'جَعَلَ حَسَنَةٌ':Predicate, #2: 2	جَعَلَ الْحَسَنَةَ
u'جَعَلَ حَصْرٌ':Predicate, #2: 2	جَعَلَ الْحَسَنَةَ
u'جَعَلَ حَصِيرٌ':Predicate, #1: 1	جَعَلَ الْحَصْرَ
u'جَعَلَ حُضورٌ':Predicate, #1: 1	جَعَلَ الْحَصِيرَ
u'جَعَلَ حُضُورٌ':Predicate, #1: 1	جَعَلَ الْحُضُورَ
u'جَعَلَ حَقٌّ':Predicate, #1: 1	جَعَلَ الْحُضُورَ
u'جَعَلَ حُكْمٌ':Predicate, #5: 5	جَعَلَ الْحَقَّ
u'جَعَلَ حُكْمٌ':Predicate, #2: 2	جَعَلَ الْحُكْمَ
u'جَعَلَ حكماء':Subject, #2: 2	جَعَلَ حُكْمَ
u'جَعَلَ حَلْقٌ':Predicate, #1: 1	جَعَلَ الْحُكَمَاءُ
u'جَعَلَ حِمَارٌ':Predicate, #1: 1	جَعَلَ الْحَلْقَ
u'جَعَلَ حَمْلٌ':Predicate, #1: 1	جَعَلَ حِمَارَ
u'جَعَلَ حَمْلٌ':Predicate, #1: 1	جَعَلَ الْحَمْلَ
u'جَعَلَ حِنْطَةٌ':Predicate, #1: 1	جَعَلَ حَمْلَ
u'جَعَلَ حَنَفِيَّةٌ':Subject, #3: 3	جَعَلَ الْحِنْطَةَ
u'جَعَلَ حَوْلِيٌّ':Subject, #1: 1	جَعَلَ الْحَنَفِيَّةُ
u'جَعَلَ خاصّ':Predicate, #1: 1	جَعَلَ الْحَوْلِيُّ
u'جَعَلَ خاصّ':Subject, #1: 1	جَعَلَ الْخَاصَّ
u'جَعَلَ خَافِقٌ':Predicate, #1: 1	جَعَلَ خَاصٌّ
u'جَعَلَ خَانٌ':Predicate, #1: 1	جَعَلَ الْخَافِقَ
u'جَعَلَ خَبَرٌ':Predicate, #1: 1	جَعَلَ الْخَانَ
u'جَعَلَ خَبَر':Predicate, #1: 1	جَعَلَ الْخَبَرَ
u'جَعَلَ خُبْزٌ':Predicate, #1: 1	جَعَلَ الْخَبَرَ
u'جَعَلَ خدمة':Predicate, #2: 2	جَعَلَ الْخُبْزَ
u'جَعَلَ خِدْمَةٌ':Predicate, #2: 2	جَعَلَ الْخِدْمَةَ
u'جَعَلَ خَرَابٌ':Predicate, #2: 2	جَعَلَ الْخِدْمَةَ
u'جَعَلَ خراج':Predicate, #1: 1	جَعَلَ الْخَرَابَ
u'جَعَلَ خَرَاجٌ':Predicate, #1: 1	جَعَلَ خَرَاجَ
u'جَعَلَ خراج':Predicate, #1: 1	جَعَلَ خَرَاجَ
u'جَعَلَ خَرَاجٌ':Predicate, #5: 5	جَعَلَ الْخَرَاجَ
u'جَعَلَ خُفٌّ':Predicate, #5: 5	جَعَلَ الْخَرَاجَ
u'جَعَلَ خِلاَفٌ':Predicate, #1: 1	جَعَلَ الْخُفَّ
u'جَعَلَ خِلاَفَةٌ':Predicate, #8: 8	جَعَلَ الْخِلَافَ
u'جَعَلَ خُلْعٌ':Predicate, #1: 1	جَعَلَ الْخِلَافَةَ
u'جَعَلَ خُمُسٌ':Predicate, #2: 2	جَعَلَ الْخُلْعَ
u'جَعَلَ خَمْسٌ':Predicate, #1: 1	جَعَلَ الْخُمُسَ
u'جَعَلَ خَنَازِيرُ':Predicate, #2: 2	جَعَلَ الْخَمْسَ
u'جَعَلَ خِنْزِيرٌ':Predicate, #1: 1	جَعَلَ الْخَنَازِيرَ
u'جَعَلَ خِنْصَرٌ':Predicate, #1: 1	جَعَلَ الْخِنْزِيرَ
u'جَعَلَ خوارج':Predicate, #1: 1	جَعَلَ الْخِنْصَرَ
u'جَعَلَ خَوَارِجُ':Predicate, #1: 1	جَعَلَ الْخَوَارِجَ
u'جَعَلَ خيار':Predicate, #1: 1	جَعَلَ الْخَوَارِجَ
u'جَعَلَ خِيَارٌ':Predicate, #6: 6	جَعَلَ الْخِيَارَ
u'جَعَلَ خَيْرٌ':Predicate, #6: 6	جَعَلَ الْخِيَارَ
u'جَعَلَ خِيرَةٌ':Predicate, #1: 1	جَعَلَ الْخَيْرَ
u'جَعَلَ دَابَّةٌ':Predicate, #2: 2	جَعَلَ الْخِيَرَةَ
u'جَعَلَ دَارٌ':Predicate, #1: 1	جَعَلَ الدَّابَّةَ
u'جَعَلَ دَامِغٌ':Predicate, #3: 3	جَعَلَ الدَّارَ
u'جَعَلَ دُخُولٌ':Predicate, #1: 1	جَعَلَ الدَّامِغَةَ
u'جَعَلَ دُخُولٌ':Predicate, #2: 2	جَعَلَ الدُّخُولَ
u'جَعَلَ دَرَاهِمُ':Predicate, #2: 2	جَعَلَ دُخُولَ
u'جَعَلَ درجة':Predicate, #4: 4	جَعَلَ دَرَاهِمَ
u'جَعَلَ دَرَجَةٌ':Predicate, #1: 1	جَعَلَ دَرَجَةَ
u'جَعَلَ دِرْهَمٌ':Predicate, #1: 1	جَعَلَ دَرَجَةَ
u'جَعَلَ دِرْهَم':Predicate, #3: 3	جَعَلَ الدِّرْهَمَ
u'جَعَلَ دُعَاءٌ':Predicate, #3: 3	جَعَلَ الدِّرْهَمَ
u'جَعَلَ دُعَاءٌ':Predicate, #1: 1	جَعَلَ الدُّعَاءَ
u'جَعَلَ دَلالَةٌ':Predicate, #1: 1	جَعَلَ دُعَاءَ
u'جَعَلَ دَليلٌ':Predicate, #1: 1	جَعَلَ الدَّلَالَةَ
u'جَعَلَ دَمٌ':Predicate, #1: 1	جَعَلَ دَلِيلَ
u'جَعَلَ دَنانيرُ':Predicate, #1: 1	جَعَلَ الدَّمَ
u'جَعَلَ دَواءٌ':Predicate, #2: 2	جَعَلَ الدَّنَانِيرَ
u'جَعَلَ دَوامٌ':Predicate, #1: 1	جَعَلَ الدَّوَاءَ
u'جَعَلَ دَوامٌ':Predicate, #1: 1	جَعَلَ الدّوَامَ
u'جَعَلَ دِيَةٌ':Predicate, #1: 1	جَعَلَ الدَّوَامَ
u'جَعَلَ دِيَةٌ':Predicate, #2: 2	جَعَلَ الدّيَةَ
u'جَعَلَ دِيَةٌ':Predicate, #3: 3	جَعَلَ دِيَةَ
u'جَعَلَ دِينٌ':Predicate, #8: 8	جَعَلَ الدِّيَةَ
u'جَعَلَ دَيْنٌ':Predicate, #1: 1	جَعَلَ الدِّينَ
u'جَعَلَ دِيوانٌ':Predicate, #9: 9	جَعَلَ الدَّيْنَ
u'جَعَلَ ذَبيحٌ':Predicate, #1: 1	جَعَلَ الدِّيوَانَ
u'جَعَلَ ذَبيحَةٌ':Predicate, #1: 1	جَعَلَ ذَبِيحَةَ
u'جَعَلَ ذكر':Predicate, #1: 1	جَعَلَ ذَبِيحَةَ
u'جَعَلَ ذِكْرٌ':Predicate, #4: 4	جَعَلَ ذِكْرَ
u'جَعَلَ ذِمِّيٌّ':Subject, #4: 4	جَعَلَ ذِكْرَ
u'جَعَلَ ذِمِّيٌّ':Subject, #1: 1	جَعَلَ ذِمِّيٌّ
u'جَعَلَ ذَوْبٌ':Predicate, #2: 2	جَعَلَ الذِّمِّيُّ
u'جَعَلَ رَأْسٌ':Predicate, #1: 1	جَعَلَ الذَّوْبَ
u'جَعَلَ رَأْيٌ':Predicate, #4: 4	جَعَلَ رَأْسَ
u'جَعَلَ رَبُّ':Subject, #1: 1	جَعَلَ الرَّأْيَ
u'جَعَلَ رِبْحٌ':Predicate, #2: 2	جَعَلَ رَبُّ
u'جَعَلَ ربطة':Predicate, #2: 2	جَعَلَ الرِّبْحَ
u'جَعَلَ رَبْطَةٌ':Predicate, #1: 1	جَعَلَ الرَّبْطَةَ
u'جَعَلَ رُبُعٌ':Predicate, #1: 1	جَعَلَ الرَّبْطَةَ
u'جَعَلَ رَجُلٌ':Subject, #2: 2	جَعَلَ رُبُعَ
u'جَعَلَ رَجُلٌ':Subject, #12: 12	جَعَلَ الرَّجُلُ
u'جَعَلَ رَجُلٌ':Subject, #1: 1	جَعَلَ الرّجُلُ
u'جَعَلَ رُخْصَةٌ':Predicate, #3: 3	جَعَلَ رَجُلٌ
u'جَعَلَ رِدَّةٌ':Predicate, #1: 1	جَعَلَ رُخْصَةَ
u'جَعَلَ رِدْفٌ':Predicate, #1: 1	جَعَلَ الرِّدَّةَ
u'جَعَلَ رِزْقٌ':Predicate, #1: 1	جَعَلَ الرّدْفَ
u'جَعَلَ رَسُولٌ':Subject, #1: 1	جَعَلَ رِزْقَ
u'جَعَلَ رَفْعٌ':Predicate, #36: 36	جَعَلَ رَسُولُ
u'جَعَلَ رَقيقٌ':Predicate, #1: 1	جَعَلَ الرّفْعَ
u'جَعَلَ رَقيق':Predicate, #1: 1	جَعَلَ الرَّقِيقَ
u'جَعَلَ رُكوبٌ':Predicate, #1: 1	جَعَلَ الرَّقِيقَ
u'جَعَلَ رهان':Predicate, #1: 1	جَعَلَ الرُّكُوبَ
u'جَعَلَ رِهانٌ':Predicate, #1: 1	جَعَلَ الرِّهَانَ
u'جَعَلَ رَهْنٌ':Predicate, #1: 1	جَعَلَ الرِّهَانَ
u'جَعَلَ رِوايَةٌ':Predicate, #2: 2	جَعَلَ الرَّهْنَ
u'جَعَلَ رُؤْيَةٌ':Predicate, #1: 1	جَعَلَ الرِّوَايَةَ
u'جَعَلَ رَيْحانٌ':Predicate, #1: 1	جَعَلَ رُؤْيَةَ
u'جَعَلَ ريعٌ':Predicate, #1: 1	جَعَلَ الرَّيْحَانَ
u'جَعَلَ رِيقٌ':Predicate, #1: 1	جَعَلَ رِيعَ
u'جَعَلَ زائِدٌ':Predicate, #1: 1	جَعَلَ الرِّيقَ
u'جَعَلَ زَرْعٌ':Predicate, #1: 1	جَعَلَ الزَّائِدَ
u'جَعَلَ زَكاةٌ':Predicate, #3: 3	جَعَلَ الزَّرْعَ
u'جَعَلَ زَمانٌ':Predicate, #2: 2	جَعَلَ الزَّكَاةَ
u'جَعَلَ زَوالٌ':Predicate, #1: 1	جَعَلَ الزَّمَانَ
u'جَعَلَ زَوالٌ':Predicate, #1: 1	جَعَلَ الزَّوَالَ
u'جَعَلَ زَوْجٌ':Predicate, #1: 1	جَعَلَ زَوَالَ
u'جَعَلَ زَوْجٌ':Subject, #1: 1	جَعَلَ الزَّوْجَ
u'جَعَلَ زِيادَةٌ':Predicate, #2: 2	جَعَلَ الزَّوْجُ
u'جَعَلَ زَيْدٌ':Predicate, #3: 3	جَعَلَ الزِّيَادَةَ
u'جَعَلَ زَيْدٌ':Subject, #1: 1	جَعَلَ زَيْدَ
u'جَعَلَ زَيْنَبٌ':Predicate, #1: 1	جَعَلَ زَيْدٌ
u'جَعَلَ سَاحَةٌ':Predicate, #1: 1	جَعَلَ زَيْنَبَ
u'جَعَلَ سَامِريٌّ':Subject, #1: 1	جَعَلَ سَاحَةَ
u'جَعَلَ سَائِمَةٌ':Predicate, #1: 1	جَعَلَ السَّامِرِيُّ
u'جَعَلَ سَبَبٌ':Predicate, #3: 3	جَعَلَ السَّائِمَةَ
u'جَعَلَ سَبْعٌ':Predicate, #2: 2	جَعَلَ السَّبَبَ
u'جَعَلَ سَتْرٌ':Predicate, #1: 1	جَعَلَ سَبْعَ
u'جَعَلَ سَدٌّ':Predicate, #1: 1	جَعَلَ السَّتْرَ
u'جَعَلَ سِرْقِين':Predicate, #1: 1	جَعَلَ سَدَّ
u'جَعَلَ سَطْحٌ':Predicate, #1: 1	جَعَلَ السِّرْقِينَ
u'جَعَلَ سَعْدٌ':Predicate, #1: 1	جَعَلَ السَّطْحَ
u'جَعَلَ سَفَرٌ':Predicate, #1: 1	جَعَلَ سَعْدَ
u'جَعَلَ سُفْلٌ':Predicate, #1: 1	جَعَلَ السَّفَرَ
u'جَعَلَ سُفْلٌ':Predicate, #1: 1	جَعَلَ السُّفْلَ
u'جَعَلَ سِقَايَةٌ':Predicate, #1: 1	جَعَلَ سُفْلَ
u'جَعَلَ سُكُوتٌ':Predicate, #3: 3	جَعَلَ السِّقَايَةَ
u'جَعَلَ سلام':Predicate, #2: 2	جَعَلَ السُّكُوتَ
u'جَعَلَ سَلاَمٌ':Predicate, #1: 1	جَعَلَ سَلَامَ
u'جَعَلَ سِلْسلَةٌ':Predicate, #1: 1	جَعَلَ سَلَامَ
u'جَعَلَ سَمْعٌ':Predicate, #1: 1	جَعَلَ السِّلْسِلَةَ
u'جَعَلَ سُنَّةٌ':Predicate, #1: 1	جَعَلَ السَّمْعَ
u'جَعَلَ سَنَدٌ':Subject, #2: 2	جَعَلَ السُّنَّةَ
u'جَعَلَ سَهْمٌ':Predicate, #1: 1	جَعَلَ سَنَدٌ
u'جَعَلَ سُوقٌ':Predicate, #1: 1	جَعَلَ السَّهْمَ
u'جَعَلَ سَيِّدٌ':Subject, #1: 1	جَعَلَ السُّوقَ
u'جَعَلَ شَاةٌ':Predicate, #1: 1	جَعَلَ السَّيِّدُ
u'جَعَلَ شَارِعٌ':Subject, #2: 2	جَعَلَ الشَّاةَ
u'جَعَلَ شافِعِيّ':Subject, #9: 9	جَعَلَ الشَّارِعُ
u'جَعَلَ شَجَرَةٌ':Predicate, #5: 5	جَعَلَ الشَّافِعِيُّ
u'جَعَلَ شِرَاءٌ':Predicate, #1: 1	جَعَلَ الشَّجَرَةَ
u'جَعَلَ شِرَاءٌ':Predicate, #1: 1	جَعَلَ الشِّرَاءَ
u'جَعَلَ شَرَائِطُ':Predicate, #2: 2	جَعَلَ شِرَاءَ
u'جَعَلَ شَرْطٌ':Predicate, #2: 2	جَعَلَ الشَّرَائِطَ
u'جَعَلَ شَرْطٌ':Predicate, #15: 15	جَعَلَ الشَّرْطَ
u'جَعَلَ شَرْعٌ':Subject, #16: 16	جَعَلَ شَرْطَ
u'جَعَلَ شعار':Predicate, #7: 7	جَعَلَ الشَّرْعُ
u'جَعَلَ شِعَارٌ':Predicate, #2: 2	جَعَلَ شِعَارَ
u'جَعَلَ شمس':Predicate, #2: 2	جَعَلَ شِعَارَ
u'جَعَلَ شمس':Predicate, #1: 1	جَعَلَ الشّمْسَ
u'جَعَلَ شَمْسٌ':Predicate, #1: 1	جَعَلَ الشَّمْسَ
u'جَعَلَ شَمْسٌ':Predicate, #1: 1	جَعَلَ الشّمْسَ
u'جَعَلَ شمس':Subject, #1: 1	جَعَلَ الشَّمْسَ
u'جَعَلَ شَمْسٌ':Subject, #1: 1	جَعَلَ شَمْسُ
u'جَعَلَ شَهْرٌ':Predicate, #1: 1	جَعَلَ شَمْسُ
u'جَعَلَ شُهُودٌ':Predicate, #2: 2	جَعَلَ الشَّهْرَ
u'جَعَلَ شَيْءٌ':Predicate, #1: 1	جَعَلَ شُهُودَ
u'جَعَلَ شَيْخٌ':Subject, #2: 2	جَعَلَ الشَّيْءَ
u'جَعَلَ صَاحِبٌ':Predicate, #3: 3	جَعَلَ الشَّيْخُ
u'جَعَلَ صَاحِبٌ':Subject, #1: 1	جَعَلَ صَاحِبَ
u'جَعَلَ صَاحِبٌ':Subject, #1: 1	جَعَلَ صَاحِبُهُ
u'جَعَلَ صِحَّةٌ':Predicate, #7: 7	جَعَلَ صَاحِبُ
u'جَعَلَ صداق':Predicate, #1: 1	جَعَلَ صِحَّةَ
u'جَعَلَ صَدَاقٌ':Predicate, #2: 2	جَعَلَ الصَّدَاقَ
u'جَعَلَ صَدَاقَةٌ':Predicate, #2: 2	جَعَلَ الصَّدَاقَ
u'جَعَلَ صدقة':Predicate, #1: 1	جَعَلَ الصَّدَاقَةَ
u'جَعَلَ صَدَقَةٌ':Predicate, #3: 3	جَعَلَ الصَّدَقَةَ
u'جَعَلَ صَلاَةٌ':Predicate, #3: 3	جَعَلَ الصَّدَقَةَ
u'جَعَلَ صُنْدُوقٌ':Predicate, #2: 2	جَعَلَ الصَّلَاةَ
u'جَعَلَ صُورَةٌ':Predicate, #1: 1	جَعَلَ الصُّنْدُوقَ
u'جَعَلَ صُورَةٌ':Predicate, #1: 1	جَعَلَ الصُّورَةَ
u'جَعَلَ صَوْمٌ':Predicate, #1: 1	جَعَلَ صُورَةَ
u'جَعَلَ ضَمَانٌ':Predicate, #2: 2	جَعَلَ الصَّوْمَ
u'جَعَلَ ضَوْءٌ':Predicate, #1: 1	جَعَلَ الضَّمَانَ
u'جَعَلَ ضِيَافَةٌ':Predicate, #1: 1	جَعَلَ الضَّوْءَ
u'جَعَلَ طَائِفٌ':Predicate, #2: 2	جَعَلَ الضِّيَافَةَ
u'جَعَلَ طَائِفٌ':Subject, #1: 1	جَعَلَ طَائِفَةً
u'جَعَلَ طرف':Predicate, #1: 1	جَعَلَ طَائِفَةٌ
u'جَعَلَ طَرَفٌ':Predicate, #1: 1	جَعَلَ طَرَفَ
u'جَعَلَ طَرِيدٌ':Predicate, #1: 1	جَعَلَ طَرَفَ
u'جَعَلَ طَرِيقٌ':Predicate, #1: 1	جَعَلَ الطّرِيدَ
u'جَعَلَ طَرِيقٌ':Predicate, #1: 1	جَعَلَ الطَّرِيقَ
u'جَعَلَ طَلاَقٌ':Predicate, #1: 1	جَعَلَ طَرِيقَ
u'جَعَلَ طَلاَقٌ':Predicate, #1: 1	جَعَلَ الطَّلَاقَ
u'جَعَلَ طُلُوعٌ':Predicate, #2: 2	جَعَلَ طَلَاقَ
u'جَعَلَ طَهَارَةٌ':Predicate, #1: 1	جَعَلَ طُلُوعَ
u'جَعَلَ طُولٌ':Predicate, #1: 1	جَعَلَ الطَّهَارَةَ
u'جَعَلَ طَوْلٌ':Predicate, #1: 1	جَعَلَ طُولَ
u'جَعَلَ طَيْرٌ':Predicate, #1: 1	جَعَلَ طَوْلَ
u'جَعَلَ طِيَرَةٌ':Predicate, #1: 1	جَعَلَ الطَّيْرَ
u'جَعَلَ ظاهِرٌ':Predicate, #1: 1	جَعَلَ الطِّيَرَةَ
u'جَعَلَ ظَنٌّ':Predicate, #3: 3	جَعَلَ ظَاهِرَ
u'جَعَلَ ظَنٌّ':Predicate, #1: 1	جَعَلَ الظَّنَّ
u'جَعَلَ ظهار':Predicate, #4: 4	جَعَلَ ظَنَّ
u'جَعَلَ ظُهْرٌ':Predicate, #1: 1	جَعَلَ الظِّهَارَ
u'جَعَلَ ظَهْرٌ':Predicate, #1: 1	جَعَلَ الظُّهْرَ
u'جَعَلَ ظُهورٌ':Predicate, #4: 4	جَعَلَ ظَهْرَ
u'جَعَلَ عَادَةٌ':Predicate, #1: 1	جَعَلَ ظُهُورَ
u'جَعَلَ عَاقِدٌ':Predicate, #1: 1	جَعَلَ الْعَادَةَ
u'جَعَلَ عَالِمٌ':Predicate, #1: 1	جَعَلَ الْعَاقِدَ
u'جَعَلَ عَبْدٌ':Predicate, #1: 1	جَعَلَ الْعَالِمَ
u'جَعَلَ عَبْدٌ':Subject, #4: 4	جَعَلَ الْعَبْدَ
u'جَعَلَ عَبْدٌ':Subject, #1: 1	جَعَلَ الْعَبْدُ
u'جَعَلَ عَبِيدٌ':Predicate, #1: 1	جَعَلَ عَبْدُ
u'جَعَلَ عتق':Predicate, #1: 1	جَعَلَ الْعَبِيدَ
u'جَعَلَ عِتْقٌ':Predicate, #1: 1	جَعَلَ الْعِتْقَ
u'جَعَلَ عتق':Predicate, #1: 1	جَعَلَ الْعِتْقَ
u'جَعَلَ عِتْقٌ':Predicate, #4: 4	جَعَلَ عِتْقَ
u'جَعَلَ عَجُوزٌ':Predicate, #4: 4	جَعَلَ عِتْقَ
u'جَعَلَ عِدَّةٌ':Predicate, #1: 1	جَعَلَ الْعَجُوزَ
u'جَعَلَ عَدَدٌ':Predicate, #3: 3	جَعَلَ عِدَّةَ
u'جَعَلَ عَدَمٌ':Predicate, #1: 1	جَعَلَ عَدَدَ
u'جَعَلَ عُدْوَانٌ':Predicate, #6: 6	جَعَلَ عَدَمَ
u'جَعَلَ عِذَارٌ':Predicate, #1: 1	جَعَلَ الْعُدْوَانَ
u'جَعَلَ عَرَبٌ':Predicate, #1: 1	جَعَلَ الْعِذَارَ
u'جَعَلَ عَرْضٌ':Predicate, #1: 1	جَعَلَ الْعَرَبَ
u'جَعَلَ عُرُوضٌ':Predicate, #1: 1	جَعَلَ عَرْضَ
u'جَعَلَ عُشْرٌ':Predicate, #1: 1	جَعَلَ الْعُرُوضَ
u'جَعَلَ عطف':Predicate, #4: 4	جَعَلَ الْعُشْرَ
u'جَعَلَ عَطْفٌ':Predicate, #1: 1	جَعَلَ الْعَطْفَ
u'جَعَلَ عَقْدٌ':Predicate, #1: 1	جَعَلَ الْعَطْفَ
u'جَعَلَ عَقْلٌ':Predicate, #2: 2	جَعَلَ الْعَقْدَ
u'جَعَلَ عَقْلٌ':Predicate, #1: 1	جَعَلَ عَقْلَ
u'جَعَلَ عَلاَمَةٌ':Predicate, #4: 4	جَعَلَ الْعَقْلَ
u'جَعَلَ عِلَّةٌ':Predicate, #1: 1	جَعَلَ عَلَامَةَ
u'جَعَلَ عِلَّةٌ':Predicate, #3: 3	جَعَلَ عِلَّةَ
u'جَعَلَ علم':Predicate, #5: 5	جَعَلَ الْعِلَّةَ
u'جَعَلَ عِلْمٌ':Predicate, #1: 1	جَعَلَ الْعِلْمَ
u'جَعَلَ علماء':Subject, #1: 1	جَعَلَ الْعِلْمَ
u'جَعَلَ عُلَمَاءُ':Subject, #2: 2	جَعَلَ الْعُلَمَاءُ
u'جَعَلَ عُلُوٌّ':Predicate, #2: 2	جَعَلَ الْعُلَمَاءُ
u'جَعَلَ عُلْوٌ':Predicate, #1: 1	جَعَلَ عُلُوَّ
u'جَعَلَ عِمَارَةٌ':Predicate, #1: 1	جَعَلَ عُلْوَ
u'جَعَلَ عَمَّةٌ':Predicate, #1: 1	جَعَلَ عِمَارَةَ
u'جَعَلَ عُمَرٌ':Subject, #1: 1	جَعَلَ الْعَمَّةَ
u'جَعَلَ عمرة':Predicate, #5: 5	جَعَلَ عُمَرُ
u'جَعَلَ عُمْرَةٌ':Predicate, #1: 1	جَعَلَ الْعُمْرَةَ
u'جَعَلَ عِنَبٌ':Predicate, #1: 1	جَعَلَ الْعُمْرَةَ
u'جَعَلَ عند':Predicate, #1: 1	جَعَلَ الْعِنَبَ
u'جَعَلَ عَهْدٌ':Predicate, #2: 2	جَعَلَ عِنْدَ
u'جَعَلَ عَوَامُّ':Predicate, #1: 1	جَعَلَ الْعَهْدَ
u'جَعَلَ عَوْدٌ':Predicate, #1: 1	جَعَلَ عَوَامَّ
u'جَعَلَ عِوَضٌ':Predicate, #1: 1	جَعَلَ الْعَوْدَ
u'جَعَلَ عين':Predicate, #1: 1	جَعَلَ الْعِوَضَ
u'جَعَلَ عَيْنٌ':Predicate, #2: 2	جَعَلَ الْعَيْنَ
u'جَعَلَ عَيْن':Predicate, #2: 2	جَعَلَ الْعَيْنَ
u'جَعَلَ عين':Predicate, #2: 2	جَعَلَ الْعَيْنَ
u'جَعَلَ عَيْنٌ':Predicate, #3: 3	جَعَلَ عَيْنَ
u'جَعَلَ عَيْن':Predicate, #3: 3	جَعَلَ عَيْنَ
u'جَعَلَ غَالِبٌ':Predicate, #3: 3	جَعَلَ عَيْنَ
u'جَعَلَ غَايَةٌ':Predicate, #1: 1	جَعَلَ الْغَالِبَ
u'جَعَلَ غَايَةٌ':Predicate, #1: 1	جَعَلَ الْغَايَةَ
u'جَعَلَ غَدٌ':Predicate, #3: 3	جَعَلَ غَايَةَ
u'جَعَلَ غَصْبٌ':Predicate, #1: 1	جَعَلَ الْغَدَ
u'جَعَلَ غَلَبَةٌ':Predicate, #1: 1	جَعَلَ الْغَصْبَ
u'جَعَلَ غَلَّةٌ':Predicate, #1: 1	جَعَلَ غَلَبَةَ
u'جَعَلَ غَلَّةٌ':Predicate, #3: 3	جَعَلَ الْغَلَّةَ
u'جَعَلَ غناء':Predicate, #3: 3	جَعَلَ غَلَّةَ
u'جَعَلَ غِنَاءٌ':Predicate, #1: 1	جَعَلَ الْغِنَاءَ
u'جَعَلَ غير':Predicate, #1: 1	جَعَلَ الْغِنَاءَ
u'جَعَلَ غَيْرٌ':Predicate, #1: 1	جَعَلَ غَيْرَ
u'جَعَلَ غير':Predicate, #1: 1	جَعَلَ غَيْرَ
u'جَعَلَ غَيْرٌ':Predicate, #2: 2	جَعَلَ الْغَيْرَ
u'جَعَلَ فَاحِشٌ':Predicate, #2: 2	جَعَلَ الْغَيْرَ
u'جَعَلَ فَاصِلٌ':Predicate, #1: 1	جَعَلَ الْفَاحِشَةَ
u'جَعَلَ فَائِدَةٌ':Predicate, #1: 1	جَعَلَ الْفَاصِلَ
u'جَعَلَ فَتْحٌ':Predicate, #1: 1	جَعَلَ فَائِدَةَ
u'جَعَلَ فِدَاءٌ':Predicate, #1: 1	جَعَلَ فَتْحَ
u'جَعَلَ فِرْدَوْسٌ':Predicate, #1: 1	جَعَلَ فِدَاءَ
u'جَعَلَ فَرْعٌ':Predicate, #1: 1	جَعَلَ الْفِرْدَوْسَ
u'جَعَلَ فُرُوعٌ':Predicate, #2: 2	جَعَلَ الْفَرْعَ
u'جَعَلَ فَصَاحَةٌ':Predicate, #1: 1	جَعَلَ الْفُرُوعَ
u'جَعَلَ فِضَّةٌ':Predicate, #1: 1	جَعَلَ فَصَاحَةَ
u'جَعَلَ فَضْلٌ':Predicate, #1: 1	جَعَلَ الْفِضَّةَ
u'جَعَلَ فِعْلٌ':Predicate, #2: 2	جَعَلَ الْفَضْلَ
u'جَعَلَ فلان':Subject, #5: 5	جَعَلَ فِعْلَ
u'جَعَلَ فُلاَنٌ':Subject, #1: 1	جَعَلَ مُعَاوِيَةُ
u'جَعَلَ فلان':Subject, #4: 4	جَعَلَ فُلَانٌ
u'جَعَلَ فُلُوسٌ':Predicate, #5: 5	جَعَلَ الشَّافِعِيُّ
u'جَعَلَ قَاضِي':Predicate, #1: 1	جَعَلَ الْفُلُوسَ
u'جَعَلَ قَائِلٌ':Predicate, #2: 2	جَعَلَ الْقَاضِيَ
u'جَعَلَ قُبَالَةٌ':Predicate, #1: 1	جَعَلَ قَائِلَ
u'جَعَلَ قُبْحٌ':Predicate, #2: 2	جَعَلَ قُبَالَةَ
u'جَعَلَ قَبْضٌ':Predicate, #1: 1	جَعَلَ الْقُبْحَ
u'جَعَلَ قِبْلَةٌ':Predicate, #2: 2	جَعَلَ الْقَبْضَ
u'جَعَلَ قَبُولٌ':Predicate, #3: 3	جَعَلَ الْقِبْلَةَ
u'جَعَلَ قَبِيحٌ':Predicate, #3: 3	جَعَلَ الْقَبُولَ
u'جَعَلَ قتل':Predicate, #1: 1	جَعَلَ قَبِيحَ
u'جَعَلَ قَتْلٌ':Predicate, #1: 1	جَعَلَ الْقَتْلَ
u'جَعَلَ قَتِيلٌ':Predicate, #1: 1	جَعَلَ الْقَتْلَ
u'جَعَلَ قَدْرٌ':Predicate, #1: 1	جَعَلَ قَتِيلَ
u'جَعَلَ قدرة':Predicate, #1: 1	جَعَلَ قَدْرَ
u'جَعَلَ قُدْرَةٌ':Predicate, #1: 1	جَعَلَ الْقُدْرَةَ
u'جَعَلَ قِرَاءةٌ':Predicate, #1: 1	جَعَلَ الْقُدْرَةَ
u'جَعَلَ قُرْبَةٌ':Predicate, #1: 1	جَعَلَ قِرَاءَةَ
u'جَعَلَ قَزٌّ':Predicate, #1: 1	جَعَلَ الْقُرْبَةَ
u'جَعَلَ قَسام':Predicate, #1: 1	جَعَلَ الْقَزَّ
u'جَعَلَ قَسامَة':Predicate, #1: 1	جَعَلَ الْقَسَامَةَ
u'جَعَلَ قصاص':Predicate, #1: 1	جَعَلَ الْقَسَامَةَ
u'جَعَلَ قِصَاصٌ':Predicate, #4: 4	جَعَلَ الْقِصَاصَ
u'جَعَلَ قِصَّةٌ':Predicate, #4: 4	جَعَلَ الْقِصَاصَ
u'جَعَلَ قَطِيعٌ':Predicate, #1: 1	جَعَلَ الْقِصَّةَ
u'جَعَلَ قَطِيعَةٌ':Predicate, #1: 1	جَعَلَ قَطِيعَةَ
u'جَعَلَ قعدة':Predicate, #1: 1	جَعَلَ قَطِيعَةَ
u'جَعَلَ قَعْدَةٌ':Predicate, #1: 1	جَعَلَ الْقَعْدَةَ
u'جَعَلَ قَلِيلٌ':Predicate, #1: 1	جَعَلَ الْقَعْدَةَ
u'جَعَلَ قَوَاعِدُ':Predicate, #1: 1	جَعَلَ الْقَلِيلَ
u'جَعَلَ قوائم':Predicate, #1: 1	جَعَلَ الْقَوَاعِدَ
u'جَعَلَ قَوَائِمُ':Predicate, #1: 1	جَعَلَ قَوَائِمَ
u'جَعَلَ قول':Predicate, #1: 1	جَعَلَ قَوَائِمَ
u'جَعَلَ قَوْلٌ':Predicate, #5: 5	جَعَلَ قَوْلَ
u'جَعَلَ قول':Predicate, #5: 5	جَعَلَ قَوْلَ
u'جَعَلَ قَوْلٌ':Predicate, #7: 7	جَعَلَ الْقَوْلَ
u'جَعَلَ قِيَاسٌ':Predicate, #7: 7	جَعَلَ الْقَوْلَ
u'جَعَلَ قيام':Predicate, #1: 1	جَعَلَ الْقِيَاسَ
u'جَعَلَ قِيَامٌ':Predicate, #1: 1	جَعَلَ الْقِيَامَ
u'جَعَلَ قِيمَةٌ':Predicate, #1: 1	جَعَلَ الْقِيَامَ
u'جَعَلَ قِيمَةٌ':Predicate, #1: 1	جَعَلَ قِيمَةَ
u'جَعَلَ كِتَابٌ':Predicate, #3: 3	جَعَلَ الْقِيمَةَ
u'جَعَلَ كِتَابٌ':Predicate, #1: 1	جَعَلَ الْكِتَابَ
u'جَعَلَ كِتَابَةٌ':Predicate, #1: 1	جَعَلَ كِتَابَ
u'جَعَلَ كَثْرَةٌ':Predicate, #1: 1	جَعَلَ الْكِتَابَةَ
u'جَعَلَ كَرَاهَةٌ':Predicate, #1: 1	جَعَلَ كَثْرَةَ
u'جَعَلَ كَسْبٌ':Predicate, #1: 1	جَعَلَ الْكَرَاهَةَ
u'جَعَلَ كُسُوفٌ':Predicate, #1: 1	جَعَلَ الْكَسْبَ
u'جَعَلَ كَعْبٌ':Predicate, #2: 2	جَعَلَ الْكُسُوفَ
u'جَعَلَ كَفَّارٌ':Predicate, #1: 1	جَعَلَ الْكَعْبَ
u'جَعَلَ كَفَّارَةٌ':Predicate, #1: 1	جَعَلَ الْكَفَّارَةَ
u'جَعَلَ كفر':Predicate, #1: 1	جَعَلَ الْكَفَّارَةَ
u'جَعَلَ كُفْرٌ':Predicate, #2: 2	جَعَلَ الْكُفْرَ
u'جَعَلَ كَلاَمٌ':Predicate, #2: 2	جَعَلَ الْكُفْرَ
u'جَعَلَ كَلاَمٌ':Predicate, #2: 2	جَعَلَ الْكَلَامَ
u'جَعَلَ كَلِمَةٌ':Predicate, #2: 2	جَعَلَ كَلَامَ
u'جَعَلَ لاَمٌ':Predicate, #2: 2	جَعَلَ كَلِمَةَ
u'جَعَلَ لِبَاسٌ':Predicate, #1: 1	جَعَلَ اللَّامَ
u'جَعَلَ لبن':Predicate, #1: 1	جَعَلَ لِبَاسَ
u'جَعَلَ لَبَنٌ':Predicate, #1: 1	جَعَلَ لَبَنَ
u'جَعَلَ لبن':Predicate, #1: 1	جَعَلَ لَبَنَ
u'جَعَلَ لَبَنٌ':Predicate, #3: 3	جَعَلَ اللَّبَنَ
u'جَعَلَ لَحْمٌ':Predicate, #3: 3	جَعَلَ اللَّبَنَ
u'جَعَلَ لَفْظٌ':Predicate, #1: 1	جَعَلَ اللَّحْمَ
u'جَعَلَ لُؤْلُؤٌ':Predicate, #2: 2	جَعَلَ اللَّفْظَ
u'جَعَلَ لَيْلٌ':Predicate, #1: 1	جَعَلَ اللُّؤْلُؤَ
u'جَعَلَ مَاءٌ':Predicate, #6: 6	جَعَلَ اللَّيْلَ
u'جَعَلَ مَاءٌ':Predicate, #1: 1	جَعَلَ مَاءَ
u'جَعَلَ مَاشِي':Predicate, #3: 3	جَعَلَ الْمَاءَ
u'جَعَلَ مَاشِيَةٌ':Predicate, #2: 2	جَعَلَ الْمَاشِيَةَ
u'جَعَلَ مَالٌ':Predicate, #2: 2	جَعَلَ الْمَاشِيَةَ
u'جَعَلَ مَالِكٌ':Subject, #6: 6	جَعَلَ الْمَالَ
u'جَعَلَ مَالِكٌ':Subject, #2: 2	جَعَلَ الْمَالِكُ
u'جَعَلَ مُبْتاع':Subject, #2: 2	جَعَلَ مَالِكٌ
u'جَعَلَ مُبِيحٌ':Predicate, #1: 1	جَعَلَ الْمُبْتَاعُ
u'جَعَلَ مُتَأَخِّرٌ':Predicate, #1: 1	جَعَلَ الْمُبِيحَ
u'جَعَلَ مَتَاعٌ':Predicate, #1: 1	جَعَلَ الْمُتَأَخِّرَ
u'جَعَلَ مُتَعَدِّدٌ':Predicate, #1: 1	جَعَلَ الْمَتَاعَ
u'جَعَلَ مُتَقَدِّمٌ':Predicate, #1: 1	جَعَلَ الْمُتَعَدِّدَ
u'جَعَلَ مُتَلاَحِمٌ':Predicate, #1: 1	جَعَلَ الْمُتَقَدِّمَ
u'جَعَلَ مثل':Predicate, #2: 2	جَعَلَ الْمُتَلَاحِمَةَ
u'جَعَلَ مِثْلٌ':Predicate, #1: 1	جَعَلَ الْمِثْلَ
u'جَعَلَ مثل':Predicate, #1: 1	جَعَلَ الْمِثْلَ
u'جَعَلَ مِثْلٌ':Predicate, #2: 2	جَعَلَ مِثْلَ
u'جَعَلَ مُجَرَّدٌ':Predicate, #2: 2	جَعَلَ مِثْلَ
u'جَعَلَ مَجْمُوعٌ':Predicate, #1: 1	جَعَلَ مُجَرَّدَ
u'جَعَلَ مَجِيءٌ':Predicate, #1: 1	جَعَلَ مَجْمُوعَ
u'جَعَلَ مَحَلٌّ':Predicate, #1: 1	جَعَلَ مَجِيءَ
u'جَعَلَ مُحَمَّدٌ':Subject, #6: 6	جَعَلَ مَحَلَّ
u'جَعَلَ مَحْمُولٌ':Predicate, #6: 6	جَعَلَ مُحَمَّدٌ
u'جَعَلَ مُخَاطَبٌ':Predicate, #1: 1	جَعَلَ الْمَحْمُولَ
u'جَعَلَ مَخْلُوطٌ':Predicate, #1: 1	جَعَلَ الْمُخَاطَبِينَ
u'جَعَلَ مُدَبَّرٌ':Predicate, #1: 1	جَعَلَ الْمَخْلُوطَ
u'جَعَلَ مُدَّةٌ':Predicate, #1: 1	جَعَلَ الْمُدَبَّرَ
u'جَعَلَ مَذْكُورٌ':Predicate, #2: 2	جَعَلَ مُدَّةَ
u'جَعَلَ مَذْهَبٌ':Predicate, #3: 3	جَعَلَ الْمَذْكُورَ
u'جَعَلَ مراد':Predicate, #2: 2	جَعَلَ الْمَذْهَبَ
u'جَعَلَ مُرَادٌ':Predicate, #1: 1	جَعَلَ الْمُرَادَ
u'جَعَلَ مَرْتَبَةٌ':Predicate, #1: 1	جَعَلَ الْمُرَادَ
u'جَعَلَ مَزَارِعُ':Predicate, #1: 1	جَعَلَ مَرْتَبَةَ
u'جَعَلَ مَسَاجِدُ':Predicate, #1: 1	جَعَلَ مَزَارِعَ
u'جَعَلَ مَسَافَةٌ':Predicate, #3: 3	جَعَلَ الْمَسَاجِدَ
u'جَعَلَ مَسَاكِنُ':Predicate, #2: 2	جَعَلَ الْمَسَافَةَ
u'جَعَلَ مَسْأَلَةٌ':Predicate, #2: 2	جَعَلَ الْمَسَاكِنَ
u'جَعَلَ مَسْأَلَةٌ':Predicate, #15: 15	جَعَلَ الْمَسْأَلَةَ
u'جَعَلَ مُسْتَأْجِرٌ':Predicate, #3: 3	جَعَلَ مَسْأَلَةَ
u'جَعَلَ مُسْتَأْجِرٌ':Subject, #1: 1	جَعَلَ الْمُسْتَأْجِرَ
u'جَعَلَ مُسْتَهْلَكٌ':Predicate, #1: 1	جَعَلَ الْمُسْتَأْجِرُ
u'جَعَلَ مَسْحٌ':Predicate, #1: 1	جَعَلَ الْمُسْتَهْلَكَ
u'جَعَلَ مُسْلِمٌ':Subject, #2: 2	جَعَلَ الْمَسْحَ
u'جَعَلَ مَشْرُوطٌ':Predicate, #2: 2	جَعَلَ مُسْلِمٌ
u'جَعَلَ مَشِيئَةٌ':Predicate, #1: 1	جَعَلَ الْمَشْرُوطَ
u'جَعَلَ مِصْبَاحٌ':Predicate, #1: 1	جَعَلَ الْمَشِيئَةَ
u'جَعَلَ مُصْحَفٌ':Predicate, #1: 1	جَعَلَ الْمِصْبَاحَ
u'جَعَلَ مَصْرِفٌ':Predicate, #3: 3	جَعَلَ الْمُصْحَفَ
u'جَعَلَ مُصَنِّفٌ':Subject, #2: 2	جَعَلَ مَصْرِفَ
u'جَعَلَ مَضْجَعٌ':Predicate, #14: 14	جَعَلَ الْمُصَنِّفُ
u'جَعَلَ مَضْمَضَةٌ':Predicate, #1: 1	جَعَلَ الْمَضْجَعَ
u'جَعَلَ مَطَرٌ':Predicate, #1: 1	جَعَلَ الْمَضْمَضَةَ
u'جَعَلَ مَطْلُوبٌ':Predicate, #1: 1	جَعَلَ الْمَطَرَ
u'جَعَلَ مُعاوِيَة':Subject, #1: 1	جَعَلَ الْمَطْلُوبَ
u'جَعَلَ مُعَجَّلٌ':Predicate, #1: 1	جَعَلَ مُعَاوِيَةُ
u'جَعَلَ مَعْدِنٌ':Predicate, #1: 1	جَعَلَ الْمُعَجَّلَةَ
u'جَعَلَ مَعْطُوف':Subject, #2: 2	جَعَلَ الْمَعْدِنَ
u'جَعَلَ مُعَلِّلٌ':Subject, #1: 1	جَعَلَ مَعْطُوفٌ
u'جَعَلَ مُعَوَّلٌ':Predicate, #1: 1	جَعَلَ الْمُعَلِّلُ
u'جَعَلَ مَغْصُوب':Predicate, #1: 1	جَعَلَ الْمُعَوَّلَ
u'جَعَلَ مَفَاوِزُ':Predicate, #1: 1	جَعَلَ الْمَغْصُوبَ
u'جَعَلَ مُفْسِدٌ':Predicate, #1: 1	جَعَلَ الْمَفَاوِزَ
u'جَعَلَ مَفْعُولٌ':Predicate, #1: 1	جَعَلَ الْمُفْسِدَ
u'جَعَلَ مِقْدَارٌ':Predicate, #1: 1	جَعَلَ مَفْعُولَ
u'جَعَلَ مُقْرِضٌ':Subject, #1: 1	جَعَلَ مِقْدَارَ
u'جَعَلَ مكارم':Predicate, #1: 1	جَعَلَ الْمُقْرِضُ
u'جَعَلَ مَكَارِمُ':Predicate, #1: 1	جَعَلَ مَكَارِمَ
u'جَعَلَ مَكَانٌ':Predicate, #1: 1	جَعَلَ مَكَارِمَ
u'جَعَلَ مَلاَئِكَةٌ':Predicate, #8: 8	جَعَلَ مَكَانَ
u'جَعَلَ ملح':Predicate, #1: 1	جَعَلَ الْمَلَائِكَةَ
u'جَعَلَ مِلْحٌ':Predicate, #1: 1	جَعَلَ الْمِلْحَ
u'جَعَلَ مِلْكٌ':Predicate, #1: 1	جَعَلَ الْمِلْحَ
u'جَعَلَ مَنَاطٌ':Predicate, #1: 1	جَعَلَ مِلْكَ
u'جَعَلَ مَنَاطٌ':Predicate, #1: 1	جَعَلَ الْمَنَاطَ
u'جَعَلَ مَنْزِلٌ':Predicate, #4: 4	جَعَلَ مَنَاطَ
u'جَعَلَ مَنْعٌ':Predicate, #1: 1	جَعَلَ الْمَنْزِلَ
u'جَعَلَ مَنْفَعَةٌ':Predicate, #1: 1	جَعَلَ الْمَنْعَ
u'جَعَلَ مَنْقُولٌ':Predicate, #1: 1	جَعَلَ مَنْفَعَةَ
u'جَعَلَ مَهْرٌ':Predicate, #2: 2	جَعَلَ الْمَنْقُولَ
u'جَعَلَ مُواعَدَة':Predicate, #1: 1	جَعَلَ مَهْرَ
u'جَعَلَ مُوجَبٌ':Predicate, #1: 1	جَعَلَ الْمُوَاعَدَةَ
u'جَعَلَ مُؤَذِّنٌ':Predicate, #1: 1	جَعَلَ مُوجَبَ
u'جَعَلَ مَوْرُوثٌ':Predicate, #1: 1	جَعَلَ الْمُؤَذِّنَ
u'جَعَلَ مَوْضِعٌ':Predicate, #2: 2	جَعَلَ الْمَوْرُوثَ
u'جَعَلَ مَوْضُوعٌ':Predicate, #1: 1	جَعَلَ مَوْضِعَ
u'جَعَلَ مَوْقُوذ':Predicate, #1: 1	جَعَلَ الْمَوْضُوعَ
u'جَعَلَ مُؤَلِّفٌ':Subject, #1: 1	جَعَلَ الْمَوْقُوذَةَ
u'جَعَلَ مُؤْمِنٌ':Predicate, #3: 3	جَعَلَ الْمُؤَلِّفُ
u'جَعَلَ مِيرَاثٌ':Predicate, #2: 2	جَعَلَ الْمُؤْمِنِينَ
u'جَعَلَ مِيرَاثٌ':Predicate, #1: 1	جَعَلَ مِيرَاثَ
u'جَعَلَ نَاسٌ':Predicate, #2: 2	جَعَلَ الْمِيرَاثَ
u'جَعَلَ نَاسٌ':Subject, #3: 3	جَعَلَ النَّاسَ
u'جَعَلَ ناسِي':Predicate, #2: 2	جَعَلَ النَّاسُ
u'جَعَلَ نَاظِرٌ':Predicate, #1: 1	جَعَلَ النَّاسِيَ
u'جَعَلَ نَائِمٌ':Predicate, #1: 1	جَعَلَ النَّاظِرَ
u'جَعَلَ نَبِيٌّ':Subject, #3: 3	جَعَلَ النَّائِمَ
u'جَعَلَ نَجَاسَةٌ':Predicate, #7: 7	جَعَلَ النَّبِيُّ
u'جَعَلَ نُجُومٌ':Predicate, #1: 1	جَعَلَ النَّجَاسَةَ
u'جَعَلَ نُحَاةٌ':Subject, #1: 1	جَعَلَ النُّجُومَ
u'جَعَلَ نِسْيَانٌ':Predicate, #2: 2	جَعَلَ النُّحَاةُ
u'جَعَلَ نِصْفٌ':Predicate, #1: 1	جَعَلَ النِّسْيَانَ
u'جَعَلَ نِصْفٌ':Predicate, #1: 1	جَعَلَ النِّصْفَ
u'جَعَلَ نَصِيبٌ':Predicate, #7: 7	جَعَلَ نِصْفَ
u'جَعَلَ نَظَرٌ':Predicate, #3: 3	جَعَلَ نَصِيبَ
u'جَعَلَ نَظَرٌ':Predicate, #12: 12	جَعَلَ النَّظَرَ
u'جَعَلَ نَفْسٌ':Predicate, #2: 2	جَعَلَ نَظَرَ
u'جَعَلَ نَفَقَةٌ':Predicate, #4: 4	جَعَلَ نَفْسَ
u'جَعَلَ نَقِيضٌ':Predicate, #1: 1	جَعَلَ نَفَقَةَ
u'جَعَلَ نكاح':Predicate, #2: 2	جَعَلَ نَقِيضَ
u'جَعَلَ نِكَاحٌ':Predicate, #1: 1	جَعَلَ النِّكَاحَ
u'جَعَلَ نُكُولٌ':Predicate, #1: 1	جَعَلَ النِّكَاحَ
u'جَعَلَ نَوَوِيٌّ':Subject, #2: 2	جَعَلَ النُّكُولَ
u'جَعَلَ نِيَّةٌ':Predicate, #1: 1	جَعَلَ النَّوَوِيُّ
u'جَعَلَ نِيَّةٌ':Predicate, #1: 1	جَعَلَ النِّيَّةَ
u'جَعَلَ نَيْرُوزٌ':Predicate, #1: 1	جَعَلَ نِيَّةَ
u'جَعَلَ هِدَايَةٌ':Predicate, #1: 1	جَعَلَ النَّيْرُوزَ
u'جَعَلَ هُدْهُدٌ':Predicate, #1: 1	جَعَلَ الْهِدَايَةَ
u'جَعَلَ وَاجِبٌ':Predicate, #1: 1	جَعَلَ الْهُدْهُدَ
u'جَعَلَ واحد':Predicate, #2: 2	جَعَلَ الْوَاجِبَ
u'جَعَلَ وَاحِدٌ':Predicate, #1: 1	جَعَلَ الْوَاحِدَ
u'جَعَلَ واحد':Predicate, #1: 1	جَعَلَ الْوَاحِدَ
u'جَعَلَ وَاحِدٌ':Predicate, #1: 1	جَعَلَ الْوَاحِدَةَ
u'جَعَلَ واحد':Subject, #1: 1	جَعَلَ الْوَاحِدَةَ
u'جَعَلَ وَاحِدٌ':Subject, #1: 1	جَعَلَ وَاحِدٌ
u'جَعَلَ وَارِثٌ':Predicate, #1: 1	جَعَلَ وَاحِدٌ
u'جَعَلَ وَاقِفٌ':Subject, #2: 2	جَعَلَ الْوَارِثَ
u'جَعَلَ وُجُوبٌ':Predicate, #17: 17	جَعَلَ الْوَاقِفُ
u'جَعَلَ وُجُوبٌ':Predicate, #1: 1	جَعَلَ وُجُوبَ
u'جَعَلَ وُجُودٌ':Predicate, #2: 2	جَعَلَ الْوُجُوبَ
u'جَعَلَ وُجُوهٌ':Predicate, #2: 2	جَعَلَ وُجُودَ
u'جَعَلَ وِزْرٌ':Predicate, #1: 1	جَعَلَ وُجُوهَ
u'جَعَلَ وِزْر':Predicate, #1: 1	جَعَلَ الْوِزْرَ
u'جَعَلَ وسط':Predicate, #1: 1	جَعَلَ الْوِزْرَ
u'جَعَلَ وَسَطٌ':Predicate, #3: 3	جَعَلَ وَسَطَ
u'جَعَلَ وِصَايَةٌ':Predicate, #3: 3	جَعَلَ وَسَطَ
u'جَعَلَ وَصْفٌ':Predicate, #1: 1	جَعَلَ الْوِصَايَةَ
u'جَعَلَ وَصِيٌّ':Predicate, #1: 1	جَعَلَ وَصْفَ
u'جَعَلَ وَصِيٌّ':Subject, #3: 3	جَعَلَ الْوَصِيَّةَ
u'جَعَلَ وَصِيَّةٌ':Predicate, #1: 1	جَعَلَ الْوَصِيُّ
u'جَعَلَ وَطْءٌ':Predicate, #3: 3	جَعَلَ الْوَصِيَّةَ
u'جَعَلَ وَطْءٌ':Predicate, #1: 1	جَعَلَ الْوَطْءَ
u'جَعَلَ وَقْتٌ':Predicate, #1: 1	جَعَلَ وَطْءَ
u'جَعَلَ وَقْتٌ':Predicate, #2: 2	جَعَلَ الْوَقْتَ
u'جَعَلَ وَقْفٌ':Predicate, #4: 4	جَعَلَ وَقْتَ
u'جَعَلَ وُقُوعٌ':Predicate, #2: 2	جَعَلَ الْوَقْفَ
u'جَعَلَ وَلاَءٌ':Predicate, #1: 1	جَعَلَ الْوُقُوعَ
u'جَعَلَ وِلاَيَةٌ':Predicate, #1: 1	جَعَلَ وَلَاءَ
u'جَعَلَ وِلاَيَةٌ':Predicate, #10: 10	جَعَلَ الْوِلَايَةَ
u'جَعَلَ وَلَد':Predicate, #9: 9	جَعَلَ وِلَايَةَ
u'جَعَلَ ولد':Predicate, #1: 1	جَعَلَ الْوَلَدِيَّةَ
u'جَعَلَ وَلَدٌ':Predicate, #6: 6	جَعَلَ الْوَلَدَ
u'جَعَلَ يَدٌ':Predicate, #6: 6	جَعَلَ الْوَلَدَ
u'جَعَلَ يَمِينٌ':Predicate, #1: 1	جَعَلَ الْيَدَ
u'جَعَلَ يَمِينٌ':Predicate, #1: 1	جَعَلَ يَمِينَ
u'جَعَلَ يَوْمٌ':Predicate, #3: 3	جَعَلَ الْيَمِينَ
u'جَعَلَ يَوْمٌ':Predicate, #1: 1	جَعَلَ يَوْمَ
u'جَفَاءٌ أَحَقُّ':Added, #3: 3	جَعَلَ الْيَوْمَ
u'جَفَاءٌ قول':Added, #1: 1	جَفَاءَ الْأَحَقِّ
u'جَفَاءٌ قَوْلٌ':Added, #1: 1	جَفَاءِ الْقَوْلِ
u'جَفَّ أَسْفَلُ':Subject, #1: 1	جَفَاءِ الْقَوْلِ
u'جَفَّ أصل':Subject, #1: 1	جَفَّ أَسْفَلُهُ
u'جَفَّ أًصْلٌ':Subject, #1: 1	جَفَّ أَصْلُهُ
u'جفاف أرْضٌ':Added, #1: 1	جَفَّ أَصْلُهُ
u'جَفَافٌ أرْضٌ':Added, #1: 1	جَفَافِ الْأَرْضِ
u'جفاف أَعْضَاءٌ':Added, #1: 1	جَفَافِ الْأَرْضِ
u'جَفَافٌ أَعْضَاءٌ':Added, #1: 1	جَفَافُ أَعْضَاءٍ
u'جفاف أَوَّلُ':Added, #1: 1	جَفَافُ أَعْضَاءٍ
u'جَفَافٌ أَوَّلُ':Added, #1: 1	جَفَافِ الْأَوَّلِ
u'جفاف عُضْوٌ':Added, #1: 1	جَفَافِ الْأَوَّلِ
u'جَفَافٌ عُضْوٌ':Added, #1: 1	جَفَافِ الْعُضْوِ
u'جفاف عُضْوٌ':Added, #1: 1	جَفَافِ الْعُضْوِ
u'جَفَافٌ عُضْوٌ':Added, #1: 1	جَفَافُ عُضْوٍ
u'جفاف لبن':Added, #1: 1	جَفَافُ عُضْوٍ
u'جَفَافٌ لبن':Added, #1: 1	جَفَافِ لَبَنِهِ
u'جفاف لَبَنٌ':Added, #1: 1	جَفَافِ لَبَنِهِ
u'جَفَافٌ لَبَنٌ':Added, #1: 1	جَفَافِ لَبَنِهِ
u'جفاف نَجَاسَةٌ':Added, #1: 1	جَفَافِ لَبَنِهِ
u'جَفَافٌ نَجَاسَةٌ':Added, #1: 1	جَفَافِ النَّجَاسَةِ
u'جفاف نَجَاسَةٌ':Added, #1: 1	جَفَافِ النَّجَاسَةِ
u'جَفَافٌ نَجَاسَةٌ':Added, #3: 3	جَفَافِ نَجَاسَةٍ
u'جفاف نِيلٌ':Added, #3: 3	جَفَافِ نَجَاسَةٍ
u'جَفَافٌ نِيلٌ':Added, #1: 1	جَفَافِ النِّيلِ
u'جَفَّ أَوَّلُ':Subject, #1: 1	جَفَافِ النِّيلِ
u'جَفَا وَلَدٌ':Subject, #1: 1	جَفَّ الْأَوَّلُ
u'جَفَّ بَوْلٌ':Subject, #1: 1	جَفَا وَلَدٌ
u'جَفَّ ثَوْبٌ':Subject, #1: 1	جَفَّ بَوْلُهُ
u'جَفَّ جَانِبٌ':Subject, #1: 1	جَفَّ الثَّوْبُ
u'جَفَّ دَمٌ':Subject, #1: 1	جَفَّ جَانِبُ
u'جَفَرَ جَنْبٌ':Subject, #1: 1	جَفَّ الدَّمُ
u'جَفَّ شَجَرٌ':Subject, #1: 1	جَفَرَ جَنْبَاهُ
u'جَفَّ عند':Predicate, #2: 2	جَفَّ شَجَرُ
u'جَفَّفَ زَيْدٌ':Subject, #1: 1	جَفَّ عِنْدَ
u'جَفَّفَ عَلِيٌّ':Subject, #1: 1	جَفَّفَ زَيْدٌ
u'جَفَّفَ عِنَبٌ':Predicate, #1: 1	جَفَّفَ عَلِيٌّ
u'جَفَّفَ فلان':Subject, #1: 1	جَفَّفَ الْعِنَبَ
u'جَفَّفَ مَنِيٌّ':Predicate, #3: 3	جَفَّفَ جَعْفَرٌ
u'جَفَّ قَلَمٌ':Subject, #1: 1	جَفَّفَ الْمَنِيَّ
u'جَفَّ وُضُوءٌ':Subject, #3: 3	جَفَّ الْقَلَمُ
u'جَفَّ وُضُوءٌ':Subject, #1: 1	جَفَّ الْوُضُوءُ
u'جَلَا أهْلٌ':Subject, #2: 2	جَفَّ وُضُوءُهُ
u'جَلَا سُلْطَانٌ':Subject, #2: 2	جَلَا أَهْلُ
u'جَلَّ اِسْمٌ':Subject, #1: 1	جَلَا السُّلْطَانُ
u'جَلَا ظلمة':Predicate, #3: 3	جَلَّ اسْمُهُ
u'جَلَا ظُلْمَةٌ':Predicate, #1: 1	جَلَا ظُلْمَةَ
u'جَلَّ اِمْرَأَةٌ':Predicate, #1: 1	جَلَا ظُلْمَةَ
u'جِلْبَابٌ بَاطِلٌ':Added, #1: 1	أَجَلَّ امْرَأَةَ
u'جِلْبَابٌ حَيَاءٌ':Added, #1: 1	جِلْبَابَ الْبَاطِلِ
u'جِلْبَابٌ حَيَاءٌ':Added, #1: 1	جِلْبَابِ الْحَيَاءِ
u'جِلْبَابٌ مَسْكَنَةٌ':Added, #6: 6	جِلْبَابَ الْحَيَاءِ
u'جَلَبَ بَلْغَم':Predicate, #2: 2	جِلْبَابُ الْمَسْكَنَةِ
u'جَلَبَ حُكْمٌ':Subject, #1: 1	جَلَبَ الْبَلْغَمَ
u'جَلْبٌ سُوءٌ':Added, #1: 1	جَلَبَ الْحُكْمُ
u'جَلَبَ شَيْءٌ':Predicate, #1: 1	جَلْبُ السُّوءِ
u'جَلْبٌ صِحَّةٌ':Added, #1: 1	جَلَبَ الشَّيْءَ
u'جَلَبَ صَيْدٌ':Predicate, #1: 1	جَلْبِ الصِّحَّةِ
u'جَلْبٌ كَافِرٌ':Added, #1: 1	جَلَبَ الصَّيْدَ
u'جَلْبٌ مَالٌ':Added, #1: 1	جَلْبِ كَافِرٍ
u'جَلْبٌ مَحَبَّةٌ':Added, #1: 1	جَلْبُ مَالٍ
u'جَلْبٌ مَصَالِحُ':Added, #1: 1	جَلْبُ الْمَحَبَّةِ
u'جَلْبٌ مَصْلَحَةٌ':Added, #8: 8	جَلْبِ الْمَصَالِحِ
u'جَلْبٌ مَصْلَحَةٌ':Added, #1: 1	جَلْبَ مَصْلَحَةٍ
u'جَلْبٌ مَصْلَحَةٌ':Added, #1: 1	جَلْبُ مَصْلَحَةٍ
u'جَلْبٌ مَصْلَحَةٌ':Added, #1: 1	جَلْبِ مَصْلَحَةٍ
u'جَلْبٌ مَنَافِعُ':Added, #2: 2	جَلْبِ الْمَصْلَحَةِ
u'جَلْبٌ مَنْفَعَةٌ':Added, #3: 3	جَلْبِ الْمَنَافِعِ
u'جَلْبٌ مَنْفَعَةٌ':Added, #1: 1	جَلْبِ الْمَنْفَعَةِ
u'جَلْبٌ نَافِعٌ':Added, #2: 2	جَلْبُ مَنْفَعَةٍ
u'جَلْبٌ نَفْعٌ':Added, #1: 1	جَلْبِ نَافِعٍ
u'جَلْبٌ نَفْعٌ':Added, #1: 1	جَلْبَ نَفْعٍ
u'جَلْبٌ نَفْعٌ':Added, #1: 1	جَلْبُ نَفْعٍ
u'جَلْبٌ نَفْعٌ':Added, #2: 2	جَلْبِ نَفْعِ
u'جَلَّ جَلاَلٌ':Subject, #7: 7	جَلْبِ نَفْعٍ
u'جَلَّ جَلاَلٌ':Subject, #13: 13	جَلَّ جَلَالُهُ
u'جَلَّ جَلاَلٌ':Subject, #1: 1	جَلَّ جَلاَلُهُ
u'جَلَدَ اِبْنٌ':Subject, #2: 2	جَلَّ جَلالُهُ
u'جلد اِبْنٌ':Added, #1: 1	جَلَدَ ابْنُ
u'جِلْدٌ اِبْنٌ':Added, #1: 1	جِلْدَ ابْنِ
u'جلد اِبْنَة':Added, #1: 1	جِلْدَ ابْنِ
u'جَلْدٌ اِبْنَة':Added, #1: 1	جَلْدِ ابْنَةِ
u'جلد آدَمِيٌّ':Added, #1: 1	جَلْدِ ابْنَةِ
u'جلد آدَمِيٌّ':Added, #1: 1	جِلْدَ آدَمِيٍّ
u'جِلْدٌ آدَمِيٌّ':Added, #1: 1	جِلْدِ آدَمِيٍّ
u'جِلْدٌ آدَمِيٌّ':Added, #1: 1	جِلْدَ آدَمِيٍّ
u'جلد آدَمِيٌّ':Added, #1: 1	جِلْدِ آدَمِيٍّ
u'جِلْدٌ آدَمِيٌّ':Added, #1: 1	جِلْدَ الْآدَمِيِّ
u'جلد آدَمِيٌّ':Added, #1: 1	جِلْدَ الْآدَمِيِّ
u'جلد آدَمِيٌّ':Added, #4: 4	جِلْدُ الْآدَمِيِّ
u'جِلْدٌ آدَمِيٌّ':Added, #4: 4	جِلْدِ الْآدَمِيِّ
u'جِلْدٌ آدَمِيٌّ':Added, #4: 4	جِلْدُ الْآدَمِيِّ
u'جلد إِنْسانٌ':Added, #4: 4	جِلْدِ الْآدَمِيِّ
u'جلد إِنْسانٌ':Added, #1: 1	جِلْدَ الْإِنْسَانِ
u'جِلْدٌ إِنْسانٌ':Added, #1: 1	جِلْدِ الْإِنْسَانِ
u'جِلْدٌ إِنْسانٌ':Added, #1: 1	جِلْدَ الْإِنْسَانِ
u'جلد إِنْسانٌ':Added, #1: 1	جِلْدِ الْإِنْسَانِ
u'جِلْدٌ إِنْسانٌ':Added, #2: 2	جِلْدُ الْإِنْسَانِ
u'جلد بَعيرٌ':Added, #2: 2	جِلْدُ الْإِنْسَانِ
u'جِلْدٌ بَعيرٌ':Added, #1: 1	جِلْدِ بَعِيرٍ
u'جلد بَعيرٌ':Added, #1: 1	جِلْدِ بَعِيرٍ
u'جِلْدٌ بَعيرٌ':Added, #6: 6	جِلْدُ بَعِيرٍ
u'جلد بَقَرٌ':Added, #6: 6	جِلْدُ بَعِيرٍ
u'جِلْدٌ بَقَرٌ':Added, #1: 1	جِلْدِ الْبَقَرَةِ
u'جلد بَقَرٌ':Added, #1: 1	جِلْدِ الْبَقَرَةِ
u'جِلْدٌ بَقَرٌ':Added, #1: 1	جِلْدِ بَقَرٍ
u'جلد بِكْرٌ':Added, #1: 1	جِلْدِ بَقَرٍ
u'جَلَدٌ بِكْرٌ':Added, #1: 1	جَلَدَ بِكْرَيْنِ
u'جلد بِكْرٌ':Added, #1: 1	جَلَدَ بِكْرَيْنِ
u'جَلْدٌ بِكْرٌ':Added, #2: 2	جَلْدَ الْبِكْرِ
u'جلد تَعْزِير':Added, #2: 2	جَلْدَ الْبِكْرِ
u'جَلْدٌ تَعْزِير':Added, #1: 1	جَلْدَ تَعْزِيرٍ
u'جلد ثَابِتٌ':Added, #1: 1	جَلْدَ تَعْزِيرٍ
u'جَلْدٌ ثَابِتٌ':Added, #1: 1	جَلْدِ الثَّابِتِ
u'جلد ثَعَالِبُ':Added, #1: 1	جَلْدِ الثَّابِتِ
u'جِلْدٌ ثَعَالِبُ':Added, #1: 1	جِلْدِ الثَّعَالِبِ
u'جلد ثَعْلَبٌ':Added, #1: 1	جِلْدِ الثَّعَالِبِ
u'جِلْدٌ ثَعْلَبٌ':Added, #2: 2	جِلْدِ ثَعْلَبٍ
u'جلد ثَعْلَبٌ':Added, #2: 2	جِلْدِ ثَعْلَبٍ
u'جِلْدٌ ثَعْلَبٌ':Added, #3: 3	جِلْدِ الثَّعْلَبِ
u'جَلَدَ ثَلاثَةٌ':Predicate, #3: 3	جِلْدِ الثَّعْلَبِ
u'جَلَدَ ثَلاثَةٌ':Predicate, #1: 1	جَلَدَ الثَّلاَثَةَ
u'جَلَدَ ثَمانِين':Predicate, #3: 3	جَلَدَ الثَّلَاثَةَ
u'جلد ثَوْرٌ':Added, #6: 6	جَلَدَ ثَمَانِينَ
u'جِلْدٌ ثَوْرٌ':Added, #2: 2	جِلْدِ الثَّوْرِ
u'جلد ثَوْرٌ':Added, #2: 2	جِلْدِ الثَّوْرِ
u'جِلْدٌ ثَوْرٌ':Added, #3: 3	جِلْدِ ثَوْرٍ
u'جلد ثَيِّبٌ':Added, #3: 3	جِلْدِ ثَوْرٍ
u'جَلْدٌ ثَيِّبٌ':Added, #1: 1	جَلْدَ الثَّيِّبِ
u'جلد حامِلٌ':Added, #1: 1	جَلْدَ الثَّيِّبِ
u'جَلْدٌ حامِلٌ':Added, #1: 1	جَلْدِ الْحَامِلِ
u'جلد حامِلٌ':Added, #1: 1	جَلْدِ الْحَامِلِ
u'جَلْدٌ حامِلٌ':Added, #1: 1	جَلْدِ حَامِلٍ
u'جلد حِمَارٌ':Added, #1: 1	جَلْدِ حَامِلٍ
u'جِلْدٌ حِمَارٌ':Added, #3: 3	جِلْدِ حِمَارٍ
u'جلد حُوتٌ':Added, #3: 3	جِلْدِ حِمَارٍ
u'جِلْدٌ حُوتٌ':Added, #1: 1	جِلْدُ حُوتٍ
u'جلد حَيٌّ':Added, #1: 1	جِلْدُ حُوتٍ
u'جِلْدٌ حَيٌّ':Added, #1: 1	جِلْدِ الْحَيَّةِ
u'جلد حَيٌّ':Added, #1: 1	جِلْدِ الْحَيَّةِ
u'جِلْدٌ حَيٌّ':Added, #3: 3	جِلْدُ الْحَيَّةِ
u'جلد حَيَّةٌ':Added, #3: 3	جِلْدُ الْحَيَّةِ
u'جِلْدٌ حَيَّةٌ':Added, #1: 1	جِلْدِ الْحَيَّةِ
u'جلد حَيَّةٌ':Added, #1: 1	جِلْدِ الْحَيَّةِ
u'جِلْدٌ حَيَّةٌ':Added, #3: 3	جِلْدُ الْحَيَّةِ
u'جلد حَيَوَانٌ':Added, #3: 3	جِلْدُ الْحَيَّةِ
u'جِلْدٌ حَيَوَانٌ':Added, #1: 1	جِلْدِ الْحَيَوَانِ
u'جلد حَيَوَانٌ':Added, #1: 1	جِلْدِ الْحَيَوَانِ
u'جِلْدٌ حَيَوَانٌ':Added, #1: 1	جِلْدِ حَيَوَانٍ
u'جلد حَيَوَانٌ':Added, #1: 1	جِلْدِ حَيَوَانٍ
u'جِلْدٌ حَيَوَانٌ':Added, #2: 2	جِلْدُ حَيَوَانٍ
u'جلد خَمْرٌ':Added, #2: 2	جِلْدُ حَيَوَانٍ
u'جَلْدٌ خَمْرٌ':Added, #1: 1	جَلْدِ الْخَمْرِ
u'جلد خِنْزِيرٌ':Added, #1: 1	جَلْدِ الْخَمْرِ
u'جِلْدٌ خِنْزِيرٌ':Added, #1: 1	جِلْدُ خِنْزِيرٍ
u'جلد خِنْزِيرٌ':Added, #1: 1	جِلْدُ خِنْزِيرٍ
u'جِلْدٌ خِنْزِيرٌ':Added, #2: 2	جِلْدَ خِنْزِيرٍ
u'جلد خِنْزِيرٌ':Added, #2: 2	جِلْدَ خِنْزِيرٍ
u'جِلْدٌ خِنْزِيرٌ':Added, #6: 6	جِلْدُ الْخِنْزِيرِ
u'جلد خِنْزِيرٌ':Added, #6: 6	جِلْدُ الْخِنْزِيرِ
u'جِلْدٌ خِنْزِيرٌ':Added, #7: 7	جِلْدِ الْخِنْزِيرِ
u'جلد خِنْزِيرٌ':Added, #7: 7	جِلْدِ الْخِنْزِيرِ
u'جِلْدٌ خِنْزِيرٌ':Added, #9: 9	جِلْدَ الْخِنْزِيرِ
u'جلد ذَكِيٌّ':Added, #9: 9	جِلْدَ الْخِنْزِيرِ
u'جِلْدٌ ذَكِيٌّ':Added, #1: 1	جِلْدِ ذَكِيٍّ
u'جِلْدٌ ذَكِيٌّ':Added, #1: 1	جِلْدِ ذَكِيٍّ
u'جلد رَأْسٌ':Added, #2: 2	جِلْدٍ ذَكِيٍّ
u'جِلْدٌ رَأْسٌ':Added, #1: 1	جِلْدِ الرَّأْسِ
u'جَلَدَ رَجُلٌ':Predicate, #1: 1	جِلْدِ الرَّأْسِ
u'جلد رَجُلٌ':Added, #2: 2	جَلَدَ رَجُلاً
u'جِلْدٌ رَجُلٌ':Added, #1: 1	جِلْدُ الرّجُلِ
u'جَلَدَ رَسُولٌ':Subject, #1: 1	جِلْدُ الرّجُلِ
u'جِلْدٌ رَقيقٌ':Added, #3: 3	جَلَدَ رَسُولُ
u'جِلْدٌ رَقيق':Added, #1: 1	جِلْدٍ رَقِيقٍ
u'جلد زانِي':Added, #1: 1	جِلْدٍ رَقِيقٍ
u'جَلْدٌ زانِي':Added, #1: 1	جَلْدُ الزَّانِيَيْنِ
u'جلد سَبُعٌ':Added, #1: 1	جَلْدُ الزَّانِيَيْنِ
u'جِلْدٌ سَبُعٌ':Added, #3: 3	جِلْدِ سَبُعٍ
u'جلد سَمَكٌ':Added, #3: 3	جِلْدِ سَبُعٍ
u'جلد سَمَكٌ':Added, #1: 1	جِلْدَ السَّمَكِ
u'جِلْدٌ سَمَكٌ':Added, #1: 1	جِلْدُ السَّمَكِ
u'جِلْدٌ سَمَكٌ':Added, #1: 1	جِلْدَ السَّمَكِ
u'جلد سَمَكٌ':Added, #1: 1	جِلْدُ السَّمَكِ
u'جِلْدٌ سَمَكٌ':Added, #2: 2	جِلْدُ سَمَكٍ
u'جلد شَاةٌ':Added, #2: 2	جِلْدُ سَمَكٍ
u'جِلْدٌ شَاةٌ':Added, #1: 1	جِلْدَ الشَّاةِ
u'جلد شَاةٌ':Added, #1: 1	جِلْدَ الشَّاةِ
u'جلد شَاةٌ':Added, #1: 1	جِلْدَ شَاةِ
u'جلد شَاةٌ':Added, #1: 1	جِلْدِ شَاةٍ
u'جِلْدٌ شَاةٌ':Added, #1: 1	جِلْدِ شَاةِ
u'جِلْدٌ شَاةٌ':Added, #1: 1	جِلْدَ شَاةِ
u'جِلْدٌ شَاةٌ':Added, #1: 1	جِلْدِ شَاةٍ
u'جلد شَاةٌ':Added, #1: 1	جِلْدِ شَاةِ
u'جِلْدٌ شَاةٌ':Added, #2: 2	جِلْدِ الشَّاةِ
u'جلد شَارِبٌ':Added, #2: 2	جِلْدِ الشَّاةِ
u'جَلْدٌ شَارِبٌ':Added, #1: 1	جَلْدِ شَارِبِ
u'جلد صغار':Added, #1: 1	جَلْدِ شَارِبِ
u'جِلْدٌ صغار':Added, #1: 1	جِلْدَ الصِّغَارِ
u'جلد ضَحِيَّةٌ':Added, #1: 1	جِلْدَ الصِّغَارِ
u'جِلْدٌ ضَحِيَّةٌ':Added, #1: 1	جِلْدَ ضَحِيَّتِهِ
u'جِلْدٌ طَاهِرٌ':Added, #1: 1	جِلْدَ ضَحِيَّتِهِ
u'جلد طَيْرٌ':Added, #1: 1	جِلْدٍ طَاهِرٍ
u'جِلْدٌ طَيْرٌ':Added, #1: 1	جِلْدِ الطَّيْرِ
u'جلد عَبْدٌ':Added, #1: 1	جِلْدِ الطَّيْرِ
u'جَلْدٌ عَبْدٌ':Added, #1: 1	جَلْدِ الْعَبْدِ
u'جلد عَبْدٌ':Added, #1: 1	جَلْدِ الْعَبْدِ
u'جَلْدٌ عَبْدٌ':Added, #2: 2	جَلْدَ الْعَبْدِ
u'جلد عَقْلٌ':Added, #2: 2	جَلْدَ الْعَبْدِ
u'جَلْدٌ عَقْلٌ':Added, #1: 1	جَلْدُ الْعَقْلِ
u'جَلَدَ عُمَرٌ':Subject, #1: 1	جَلْدُ الْعَقْلِ
u'جلد غَنَمٌ':Added, #7: 7	جَلَدَ عُمَرُ
u'جِلْدٌ غَنَمٌ':Added, #1: 1	جِلْدِ الْغَنَمِ
u'جلد غير':Added, #1: 1	جِلْدِ الْغَنَمِ
u'جلد غير':Added, #1: 1	جِلْدَ غَيْرِ
u'جلد غَيْرٌ':Added, #1: 1	جِلْدُ غَيْرِ
u'جلد غَيْرٌ':Added, #1: 1	جِلْدَ غَيْرِ
u'جِلْدٌ غير':Added, #1: 1	جِلْدُ غَيْرِ
u'جِلْدٌ غير':Added, #1: 1	جِلْدَ غَيْرِ
u'جِلْدٌ غَيْرٌ':Added, #1: 1	جِلْدُ غَيْرِ
u'جِلْدٌ غَيْرٌ':Added, #1: 1	جِلْدَ غَيْرِ
u'جلد فَرَسٌ':Added, #1: 1	جِلْدُ غَيْرِ
u'جِلْدٌ فَرَسٌ':Added, #1: 1	جِلْدِ الْفَرَسِ
u'جَلَدَ فلان':Subject, #1: 1	جِلْدِ الْفَرَسِ
u'جلد فِيلٌ':Added, #3: 3	جَلَدَ عُثْمَانُ
u'جِلْدٌ فِيلٌ':Added, #1: 1	جِلْدُ الْفِيلِ
u'جلد قَاذِفٌ':Added, #1: 1	جِلْدُ الْفِيلِ
u'جَلْدٌ قَاذِفٌ':Added, #1: 1	جَلْدِ الْقَاذِفِ
u'جلد قذف':Added, #1: 1	جَلْدِ الْقَاذِفِ
u'جَلْدٌ قذف':Added, #1: 1	جَلْدُ الْقَذْفِ
u'جلد قَذْفٌ':Added, #1: 1	جَلْدُ الْقَذْفِ
u'جَلْدٌ قَذْفٌ':Added, #1: 1	جَلْدُ الْقَذْفِ
u'جلد قَمْلَةٌ':Added, #1: 1	جَلْدُ الْقَذْفِ
u'جِلْدٌ قَمْلَةٌ':Added, #1: 1	جِلْدُ الْقَمْلَةِ
u'جلد قَوِيٌّ':Added, #1: 1	جِلْدُ الْقَمْلَةِ
u'جَلَدٌ قَوِيٌّ':Added, #1: 1	جَلَدَ الْقَوِيِّ
u'جلد كَافِرٌ':Added, #1: 1	جَلَدَ الْقَوِيِّ
u'جِلْدٌ كَافِرٌ':Added, #1: 1	جِلْدِ الْكَافِرِ
u'جلد كِتَابٌ':Added, #1: 1	جِلْدِ الْكَافِرِ
u'جِلْدٌ كِتَابٌ':Added, #1: 1	جِلْدَ كِتَابٍ
u'جلد كَلْبٌ':Added, #1: 1	جِلْدَ كِتَابٍ
u'جِلْدٌ كَلْبٌ':Added, #13: 13	جِلْدِ الْكَلْبِ
u'جلد كَلْبٌ':Added, #13: 13	جِلْدِ الْكَلْبِ
u'جلد كَلْبٌ':Added, #2: 2	جِلْدَ كَلْبٍ
u'جِلْدٌ كَلْبٌ':Added, #2: 2	جِلْدُ كَلْبٍ
u'جِلْدٌ كَلْبٌ':Added, #2: 2	جِلْدَ كَلْبٍ
u'جلد كَلْبٌ':Added, #2: 2	جِلْدُ كَلْبٍ
u'جِلْدٌ كَلْبٌ':Added, #3: 3	جِلْدِ كَلْبٍ
u'جلد كَلْبٌ':Added, #3: 3	جِلْدِ كَلْبٍ
u'جِلْدٌ كَلْبٌ':Added, #4: 4	جِلْدَ الْكَلْبِ
u'جلد كَلْبٌ':Added, #4: 4	جِلْدَ الْكَلْبِ
u'جِلْدٌ كَلْبٌ':Added, #8: 8	جِلْدُ الْكَلْبِ
u'جلد مَاءٌ':Added, #8: 8	جِلْدُ الْكَلْبِ
u'جِلْدٌ مَاءٌ':Added, #1: 1	جِلْدُ مَاءٍ
u'جلد مَأْكُولٌ':Added, #1: 1	جِلْدُ مَاءٍ
u'جِلْدٌ مَأْكُولٌ':Added, #1: 1	جِلْدِ مَأْكُولٍ
u'جلد مَأْكُولٌ':Added, #1: 1	جِلْدِ مَأْكُولٍ
u'جِلْدٌ مَأْكُولٌ':Added, #2: 2	جِلْدِ الْمَأْكُولِ
u'جِلْدٌ مُخْتَلَفٌ':Added, #2: 2	جِلْدِ الْمَأْكُولِ
u'جِلْدٌ مَدْبُوغٌ':Added, #1: 1	جِلْدٍ مُخْتَلَفٍ
u'جلد مَرَارَةٌ':Added, #5: 5	جِلْدٍ مَدْبُوغٍ
u'جِلْدٌ مَرَارَةٌ':Added, #1: 1	جِلْدُ مَرَارَةِ
u'جلد مُصْحَفٌ':Added, #1: 1	جِلْدُ مَرَارَةِ
u'جِلْدٌ مُصْحَفٌ':Added, #1: 1	جِلْدِ الْمُصْحَفِ
u'جلد مَكْرُوهٌ':Added, #1: 1	جِلْدِ الْمُصْحَفِ
u'جِلْدٌ مَكْرُوهٌ':Added, #1: 1	جِلْدُ مَكْرُوهِ
u'جلد مَيْتٌ':Added, #1: 1	جِلْدُ مَكْرُوهِ
u'جِلْدٌ مَيْتٌ':Added, #10: 10	جِلْدَ الْمَيْتَةِ
u'جلد مَيْتٌ':Added, #10: 10	جِلْدَ الْمَيْتَةِ
u'جِلْدٌ مَيْتٌ':Added, #12: 12	جِلْدُ الْمَيْتَةِ
u'جلد مَيْتٌ':Added, #12: 12	جِلْدُ الْمَيْتَةِ
u'جِلْدٌ مَيْتٌ':Added, #21: 21	جِلْدِ الْمَيْتَةِ
u'جلد مَيْتَةٌ':Added, #21: 21	جِلْدِ الْمَيْتَةِ
u'جِلْدٌ مَيْتَةٌ':Added, #10: 10	جِلْدَ الْمَيْتَةِ
u'جلد مَيْتَةٌ':Added, #10: 10	جِلْدَ الْمَيْتَةِ
u'جِلْدٌ مَيْتَةٌ':Added, #12: 12	جِلْدُ الْمَيْتَةِ
u'جلد مَيْتَةٌ':Added, #12: 12	جِلْدُ الْمَيْتَةِ
u'جِلْدٌ مَيْتَةٌ':Added, #14: 14	جِلْدِ مَيْتَةٍ
u'جلد مَيْتَةٌ':Added, #14: 14	جِلْدِ مَيْتَةٍ
u'جِلْدٌ مَيْتَةٌ':Added, #21: 21	جِلْدِ الْمَيْتَةِ
u'جلد مَيْتَةٌ':Added, #21: 21	جِلْدِ الْمَيْتَةِ
u'جِلْدٌ مَيْتَةٌ':Added, #25: 25	جِلْدَ مَيْتَةٍ
u'جلد مَيْتَةٌ':Added, #25: 25	جِلْدَ مَيْتَةٍ
u'جِلْدٌ مَيْتَةٌ':Added, #3: 3	جِلْدُ مَيْتَةٍ
u'جَلَدَ نَبِيٌّ':Subject, #3: 3	جِلْدُ مَيْتَةٍ
u'جلد نَحِيزَةٌ':Added, #5: 5	جَلَدَ النَّبِيُّ
u'جَلْدٌ نَحِيزَةٌ':Added, #1: 1	جَلْدُ النّحِيزَةِ
u'جلد نَحِيزَةٌ':Added, #1: 1	جَلْدُ النّحِيزَةِ
u'جَلْدٌ نَحِيزَةٌ':Added, #2: 2	جَلْدِ النّحِيزَةِ
u'جلد نُمُورٌ':Added, #2: 2	جَلْدِ النّحِيزَةِ
u'جِلْدٌ نُمُورٌ':Added, #1: 1	جِلْدِ النُّمُورِ
u'جلد وَاجِبٌ':Added, #1: 1	جِلْدِ النُّمُورِ
u'جِلْدٌ وَاجِبٌ':Added, #1: 1	جِلْدُ الْوَاجِبِ
u'جِلْدٌ واحد':Added, #1: 1	جِلْدُ الْوَاجِبِ
u'جِلْدٌ وَاحِدٌ':Added, #1: 1	جِلْدٍ وَاحِدٍ
u'جلد وَجْهٌ':Added, #1: 1	جِلْدٍ وَاحِدٍ
u'جِلْدٌ وَجْهٌ':Added, #1: 1	جِلْدُ الْوَجْهِ
u'جلد وَجْهٌ':Added, #1: 1	جِلْدُ الْوَجْهِ
u'جِلْدٌ وَجْهٌ':Added, #1: 1	جِلْدَ وَجْهِهِ
u'جلد ورك':Added, #1: 1	جِلْدَ وَجْهِهِ
u'جِلْدٌ ورك':Added, #1: 1	جِلْدَ الْوَرِكِ
u'جلد وَرِكٌ':Added, #1: 1	جِلْدَ الْوَرِكِ
u'جِلْدٌ وَرِكٌ':Added, #1: 1	جِلْدَ الْوَرِكِ
u'جَلَدَ وَلِيدٌ':Predicate, #1: 1	جِلْدَ الْوَرِكِ
u'جلد وَلِيدٌ':Added, #1: 1	جَلَدَ الْوَلِيدَ
u'جَلْدٌ وَلِيدٌ':Added, #2: 2	جَلْدِ الْوَلِيدِ
u'جَلَّ ذكر':Subject, #2: 2	جَلْدِ الْوَلِيدِ
u'جَلَّ ذِكْرٌ':Subject, #11: 11	جَلَّ ذِكْرُهُ
u'جَلَسَ إمَامٌ':Subject, #11: 11	جَلَّ ذِكْرُهُ
u'جَلَسَ إمَامٌ':Subject, #10: 10	جَلَسَ الْإِمَامُ
u'جَلَسَ إمَامٌ':Subject, #4: 4	جَلَسَ إمَامُهُ
u'جَلَسَ أنبياء':Subject, #5: 5	جَلَسَ الإِمَامُ
u'جَلَسَ بَيْنٌ':Predicate, #1: 1	جَلَسَ الْأَنْبِيَاءُ
u'جلسة اِسْتِرَاحَةٌ':Added, #15: 15	جَلَسَ بَيْنَ
u'جَلْسَةٌ اِسْتِرَاحَةٌ':Added, #1: 1	جَلْسَةِ الاِسْتِرَاحَةِ
u'جَلَسَ تَامٌّ':Subject, #1: 1	جَلْسَةِ الاِسْتِرَاحَةِ
u'جَلَسَ ثَقِيلٌ':Subject, #2: 2	جَلَسَ تَامَّةٌ
u'جَلَسَ جَازٌ':Predicate, #1: 1	جَلَسَ الثَّقِيلُ
u'جَلَسَ جلسة':Predicate, #1: 1	جَلَسَ جَازَ
u'جَلَسَ جِلْسَةٌ':Predicate, #1: 1	جَلَسَ الْجِلْسَةَ
u'جَلَسَ جلسة':Predicate, #1: 1	جَلَسَ الْجِلْسَةَ
u'جَلَسَ جِلْسَةٌ':Predicate, #1: 1	جَلَسَ جِلْسَةَ
u'جَلَسَ جَمَاعَةٌ':Subject, #1: 1	جَلَسَ جِلْسَةَ
u'جَلَسَ حارِثٌ':Subject, #1: 1	جَلَسَ جَمَاعَةٌ
u'جَلَسَ حاكِمٌ':Subject, #1: 1	جَلَسَ الْحَارِثُ
u'جَلَسَ حَديثٌ':Predicate, #2: 2	جَلَسَ الْحَاكِمُ
u'جَلَسَ خُصُومٌ':Subject, #1: 1	جَلَسَ الْحَدِيثَ
u'جَلَسَ خَطِيبٌ':Subject, #1: 1	جَلَسَ الْخُصُومُ
u'جَلَسَ خَلْفٌ':Predicate, #1: 1	جَلَسَ الْخَطِيبُ
u'جَلَسَ دَاخِلٌ':Predicate, #1: 1	جَلَسَ خَلْفَ
u'جَلَسَ رَجُلٌ':Subject, #1: 1	جَلَسَ دَاخِلَ
u'جَلَسَ رَجُلٌ':Subject, #5: 5	جَلَسَ الرَّجُلُ
u'جَلَسَ رَسُولٌ':Subject, #5: 5	جَلَسَ رَجُلٌ
u'جَلَسَ زادٌ':Predicate, #16: 16	جَلَسَ رَسُولُ
u'جَلَسَ شَقٌّ':Predicate, #1: 1	جَلَسَ زَادَ
u'جَلَسَ شُهُودٌ':Subject, #1: 1	جَلَسَ شَقَّ
u'جَلَسَ صَبِيٌّ':Subject, #1: 1	جَلَسَ الشُّهُودُ
u'جَلَسَ عَقِيبٌ':Predicate, #1: 1	جَلَسَ الصَّبِيُّ
u'جَلَسَ عَلِيٌّ':Subject, #2: 2	جَلَسَ عَقِيبَ
u'جَلَسَ عُمَرٌ':Subject, #1: 1	جَلَسَ عَلِيٌّ
u'جَلَسَ عند':Predicate, #1: 1	جَلَسَ عُمَرُ
u'جَلَسَ غير':Predicate, #7: 7	جَلَسَ عِنْدَ
u'جَلَسَ غَيْرٌ':Predicate, #1: 1	جَلَسَ غَيْرَ
u'جَلَسَ غير':Subject, #1: 1	جَلَسَ غَيْرَ
u'جَلَسَ غَيْرٌ':Subject, #1: 1	جَلَسَ غَيْرُ
u'جَلَسَ غير':Subject, #1: 1	جَلَسَ غَيْرُ
u'جَلَسَ غَيْرٌ':Subject, #1: 1	جَلَسَ غَيْرُهُ
u'جَلَسَ فلان':Subject, #1: 1	جَلَسَ غَيْرُهُ
u'جَلَسَ فلان':Subject, #2: 2	جَلَسَ عُثْمَانُ
u'جَلَسَ قادِح':Subject, #2: 2	جَلَسَ مُعَاوِيَةُ
u'جَلَسَ قَوْمٌ':Subject, #1: 1	جَلَسَ قَادِحُ
u'جَلَسَ مَالٌ':Predicate, #4: 4	جَلَسَ قَوْمٌ
u'جَلَسَ مَأْمُونٌ':Subject, #1: 1	جَلَسَ مَالَ
u'جَلَسَ مَجْلِسٌ':Predicate, #1: 1	جَلَسَ الْمَأْمُونُ
u'جَلَسَ مَحْبُوسٌ':Subject, #3: 3	جَلَسَ مَجْلِسَ
u'جَلَسَ مُسْتَقْبِلٌ':Predicate, #1: 1	جَلَسَ الْمَحْبُوسُ
u'جَلَسَ مُسْتَمِعٌ':Subject, #3: 3	جَلَسَ مُسْتَقْبِلَ
u'جَلَسَ مُعاوِيَة':Subject, #1: 1	جَلَسَ الْمُسْتَمِعُ
u'جَلَسَ مُعَلِّمٌ':Subject, #2: 2	جَلَسَ مُعَاوِيَةُ
u'جَلَسَ مِقْدَارٌ':Predicate, #1: 1	جَلَسَ الْمُعَلِّمُ
u'جَلَسَ نَاسٌ':Subject, #2: 2	جَلَسَ مِقْدَارَ
u'جَلَسَ وسط':Predicate, #2: 2	جَلَسَ النَّاسُ
u'جَلَسَ وَسَطٌ':Predicate, #2: 2	جَلَسَ وَسَطَ
u'جَلَسَ وسط':Predicate, #2: 2	جَلَسَ وَسَطَ
u'جَلَّ قَائِلٌ':Subject, #3: 3	جَلَسَ وَسْطَ
u'جَلَّ قَدْرٌ':Subject, #1: 1	جَلَّ قَائِلُهُ
u'جَلَّلَ رَسُولٌ':Subject, #2: 2	جَلَّ قَدْرُهُ
u'جُلُوسٌ آخِرُ':Added, #2: 2	جَلَّلَ رَسُولُ
u'جُلُوسٌ أشراف':Added, #2: 2	جُلُوسِ آخِرِ
u'جُلُوسٌ أَشْرَافٌ':Added, #1: 1	جُلُوسِ أَشْرَافِ
u'جُلُوسٌ الْمَرْءُ':Added, #1: 1	جُلُوسِ أَشْرَافِ
u'جُلُوسٌ الْمَرْأَةُ':Added, #1: 1	جُلُوسِ الْمَرْءِ
u'جُلُوسٌ إمَامٌ':Added, #2: 2	جُلُوسَ الْمَرْأَةِ
u'جُلُوسٌ إمَامٌ':Added, #1: 1	جُلُوسِ الإِمَامِ
u'جُلُوسٌ إمَامٌ':Added, #1: 1	جُلُوسَ الْإِمَامِ
u'جُلُوسٌ إمَامٌ':Added, #3: 3	جُلُوسُ الْإِمَامِ
u'جُلُوسٌ أمثال':Added, #6: 6	جُلُوسِ الْإِمَامِ
u'جُلُوسٌ أَمْثَالٌ':Added, #2: 2	جُلُوسِ أَمْثَالِهِ
u'جُلُوسٌ إِنْسانٌ':Added, #2: 2	جُلُوسِ أَمْثَالِهِ
u'جُلُوسٌ أهْلٌ':Added, #1: 1	جُلُوسُ الإِنْسَانِ
u'جُلُوسٌ بَاعَةٌ':Added, #1: 1	جُلُوسِ أَهْلِ
u'جُلُوسٌ تَشَهُّدٌ':Added, #1: 1	جُلُوسِ بَاعَةٍ
u'جُلُوسٌ تَشَهُّدٌ':Added, #1: 1	جُلُوسُ التَّشَهُّدِ
u'جُلُوسٌ ثَيِّبٌ':Added, #3: 3	جُلُوسِ التَّشَهُّدِ
u'جُلُوسٌ جَالِسٌ':Added, #1: 1	جُلُوسِ الثَّيِّبِ
u'جُلُوسٌ جَبَابِرَةٌ':Added, #1: 1	جُلُوسِ الْجَالِسِ
u'جُلُوسٌ جُفَاةٌ':Added, #2: 2	جُلُوسُ الْجَبَابِرَةِ
u'جُلُوسٌ حَمَّامِيٌّ':Added, #1: 1	جُلُوسُ الْجُفَاةِ
u'جُلُوسٌ خَطِيبٌ':Added, #1: 1	جُلُوسِ الْحَمَّامِيِّ
u'جُلُوسٌ خَطِيبٌ':Added, #2: 2	جُلُوسَ الْخَطِيبِ
u'جُلُوسٌ رِجَالٌ':Added, #7: 7	جُلُوسِ الْخَطِيبِ
u'جُلُوسٌ رَجُلٌ':Added, #2: 2	جُلُوسَ الرِّجَالِ
u'جُلُوسٌ رَجُلٌ':Added, #1: 1	جُلُوسِ الرَّجُلِ
u'جُلُوسٌ رُكْنٌ':Added, #3: 3	جُلُوسُ الرَّجُلِ
u'جُلُوسٌ رُكْن':Added, #1: 1	جُلُوس الرُّكْنِ
u'جُلُوسٌ سلام':Added, #1: 1	جُلُوس الرُّكْنِ
u'جُلُوسٌ سَلاَمٌ':Added, #1: 1	جُلُوسِ السَّلَامِ
u'جُلُوسٌ شَيْخٌ':Added, #1: 1	جُلُوسِ السَّلَامِ
u'جُلُوسٌ صَلاَةٌ':Added, #1: 1	جُلُوسِ الشَّيْخِ
u'جُلُوسٌ ضَيْفٌ':Added, #1: 1	جُلُوسِ الصَّلَاةِ
u'جُلُوسٌ عَالِمٌ':Added, #1: 1	جُلُوسِ الضَّيْفِ
u'جُلُوسٌ علماء':Added, #1: 1	جُلُوسُ الْعَالِمِ
u'جُلُوسٌ عُلَمَاءُ':Added, #2: 2	جُلُوسُ الْعُلَمَاءِ
u'جُلُوسٌ غير':Added, #2: 2	جُلُوسُ الْعُلَمَاءِ
u'جُلُوسٌ غَيْرٌ':Added, #1: 1	جُلُوسِ غَيْرِهِ
u'جُلُوسٌ فطرة':Added, #1: 1	جُلُوسِ غَيْرِهِ
u'جُلُوسٌ فِطْرَةٌ':Added, #1: 1	جُلُوسُ الْفِطْرَةِ
u'جُلُوسٌ قُرْفُصَاءُ':Added, #1: 1	جُلُوسُ الْفِطْرَةِ
u'جُلُوسٌ مثل':Added, #1: 1	جُلُوسِ الْقُرْفُصَاءِ
u'جُلُوسٌ مِثْلٌ':Added, #2: 2	جُلُوسِ مِثْلِهِ
u'جُلُوسٌ مَسْبُوق':Added, #2: 2	جُلُوسِ مِثْلِهِ
u'جُلُوسٌ نَبِيٌّ':Added, #1: 1	جُلُوسُ الْمَسْبُوقِ
u'جَلِيَ أهْلٌ':Predicate, #1: 1	جُلُوسِ النَّبِيِّ
u'جَلِيَ بَدَلٌ':Predicate, #2: 2	أَجْلَى أَهْلَ
u'جَلِيَ عند':Predicate, #1: 1	أَجْلَى بَدَلَ
u'جَلِيَ يهود':Predicate, #2: 2	أَجْلَى عِنْدَ
u'جَلِيَ يَهُودٌ':Predicate, #8: 8	أَجْلَى الْيَهُودَ
u'جماع إِثْمٌ':Added, #8: 8	أَجْلَى الْيَهُودَ
u'جِمَاعٌ إِثْمٌ':Added, #1: 1	جِمَاعُ الْإِثْمِ
u'جماع أَجِيرٌ':Added, #1: 1	جِمَاعُ الْإِثْمِ
u'جِمَاعٌ أَجِيرٌ':Added, #1: 1	جِمَاعُ الْأَجِيرِ
u'جماع أُخْتٌ':Added, #1: 1	جِمَاعُ الْأَجِيرِ
u'جِمَاعٌ أُخْتٌ':Added, #1: 1	جِمَاعِ الأُخْتَيْنِ
u'جماع أعْرَابِيٌّ':Added, #1: 1	جِمَاعِ الأُخْتَيْنِ
u'جِمَاعٌ أعْرَابِيٌّ':Added, #1: 1	جِمَاعِ الْأَعْرَابِيِّ
u'جماع اِمْرَأَةٌ':Added, #1: 1	جِمَاعِ الْأَعْرَابِيِّ
u'جِمَاعٌ اِمْرَأَةٌ':Added, #1: 1	جِمَاعِ امْرَأَةٍ
u'جماع اِمْرَأَةٌ':Added, #1: 1	جِمَاعِ امْرَأَةٍ
u'جِمَاعٌ اِمْرَأَةٌ':Added, #1: 1	جِمَاعِ امْرَأَتِهِ
u'جماع أُمُورٌ':Added, #1: 1	جِمَاعِ امْرَأَتِهِ
u'جِمَاعٌ أُمُورٌ':Added, #1: 1	جِمَاعَ الْأُمُورِ
u'جماع أهْلٌ':Added, #1: 1	جِمَاعَ الْأُمُورِ
u'جِمَاعٌ أهْلٌ':Added, #1: 1	جِمَاعُ أَهْلِ
u'جماع أهْلٌ':Added, #1: 1	جِمَاعُ أَهْلِ
u'جِمَاعٌ أهْلٌ':Added, #1: 1	جِمَاعِ أَهْلِهِ
u'جماع بالِغٌ':Added, #1: 1	جِمَاعِ أَهْلِهِ
u'جِمَاعٌ بالِغٌ':Added, #1: 1	جِمَاعُ الْبَالِغِ
u'جماع بِكْرٌ':Added, #1: 1	جِمَاعُ الْبَالِغِ
u'جماع بِكْرٌ':Added, #1: 1	جِمَاعَ الْبِكْرِ
u'جِمَاعٌ بِكْرٌ':Added, #1: 1	جِمَاعِ الْبِكْرِ
u'جِمَاعٌ بِكْرٌ':Added, #1: 1	جِمَاعَ الْبِكْرِ
u'جماع بَهيمٌ':Added, #1: 1	جِمَاعِ الْبِكْرِ
u'جِمَاعٌ بَهيمٌ':Added, #1: 1	جِمَاعَ الْبَهِيمَةِ
u'جماع بَهِيمَةٌ':Added, #1: 1	جِمَاعَ الْبَهِيمَةِ
u'جِمَاعٌ بَهِيمَةٌ':Added, #1: 1	جِمَاعَ الْبَهِيمَةِ
u'جماع حائِضٌ':Added, #1: 1	جِمَاعَ الْبَهِيمَةِ
u'جِمَاعٌ حائِضٌ':Added, #1: 1	جِمَاعُ الْحَائِضِ
u'جماع خَيْرٌ':Added, #1: 1	جِمَاعُ الْحَائِضِ
u'جِمَاعٌ خَيْرٌ':Added, #1: 1	جِمَاعُ الْخَيْرِ
u'جماع زَوْجَةٌ':Added, #1: 1	جِمَاعُ الْخَيْرِ
u'جِمَاعٌ زَوْجَةٌ':Added, #1: 1	جِمَاعَ زَوْجَتِهِ
u'جماع زَوْجَةٌ':Added, #1: 1	جِمَاعَ زَوْجَتِهِ
u'جِمَاعٌ زَوْجَةٌ':Added, #2: 2	جِمَاعِ زَوْجَتِهِ
u'جماع سُوءٌ':Added, #2: 2	جِمَاعِ زَوْجَتِهِ
u'جِمَاعٌ سُوءٌ':Added, #4: 4	جِمَاعَ سُوءٍ
u'جماع شِرْكٌ':Added, #4: 4	جِمَاعَ سُوءٍ
u'جِمَاعٌ شِرْكٌ':Added, #1: 1	جِمَاعَ الشِّرْكِ
u'جماع صَبِيٌّ':Added, #1: 1	جِمَاعَ الشِّرْكِ
u'جِمَاعٌ صَبِيٌّ':Added, #1: 1	جِمَاعِ الصَّبِيِّ
u'جماع صَحِيحٌ':Added, #1: 1	جِمَاعِ الصَّبِيِّ
u'جِمَاعٌ صَحِيحٌ':Added, #1: 1	جِمَاعِ الصَّحِيحِ
u'جماع علم':Added, #1: 1	جِمَاعِ الصَّحِيحِ
u'جِمَاعٌ علم':Added, #1: 1	جِمَاعِ الْعِلْمِ
u'جماع عِلْمٌ':Added, #1: 1	جِمَاعِ الْعِلْمِ
u'جِمَاعٌ عِلْمٌ':Added, #1: 1	جِمَاعِ الْعِلْمِ
u'جماع غير':Added, #1: 1	جِمَاعِ الْعِلْمِ
u'جماع غَيْرٌ':Added, #1: 1	جِمَاعِ غَيْرِ
u'جِمَاعٌ غير':Added, #1: 1	جِمَاعِ غَيْرِ
u'جِمَاعٌ غَيْرٌ':Added, #1: 1	جِمَاعِ غَيْرِ
u'جماع قُرَيْشٌ':Added, #1: 1	جِمَاعِ غَيْرِ
u'جِمَاعٌ قُرَيْشٌ':Added, #1: 1	جِمَاعُ قُرَيْشٍ
u'جماع كِتَابٌ':Added, #1: 1	جِمَاعُ قُرَيْشٍ
u'جِمَاعٌ كِتَابٌ':Added, #1: 1	جِمَاعِ كِتَابِ
u'جماع مَجْنُونٌ':Added, #1: 1	جِمَاعِ كِتَابِ
u'جِمَاعٌ مَجْنُونٌ':Added, #1: 1	جِمَاعُ الْمَجْنُونَةِ
u'جماع مَخْتُونٌ':Added, #1: 1	جِمَاعُ الْمَجْنُونَةِ
u'جِمَاعٌ مَخْتُونٌ':Added, #1: 1	جِمَاعُ الْمَخْتُونَةِ
u'جماع مُفْسِدٌ':Added, #1: 1	جِمَاعُ الْمَخْتُونَةِ
u'جِمَاعٌ مُفْسِدٌ':Added, #1: 1	جِمَاعٍ مُفْسِدٍ
u'جماع مَنْكُوح':Added, #1: 1	جِمَاعٍ مُفْسِدٍ
u'جِمَاعٌ مَنْكُوح':Added, #1: 1	جِمَاعَ الْمَنْكُوحَةِ
u'جماع مُؤَخِّرٌ':Added, #1: 1	جِمَاعَ الْمَنْكُوحَةِ
u'جِمَاعٌ مُؤَخِّرٌ':Added, #1: 1	جِمَاعُ مُؤَخِّرِ
u'جماع نَائِمٌ':Added, #1: 1	جِمَاعُ مُؤَخِّرِ
u'جِمَاعٌ نَائِمٌ':Added, #1: 1	جِمَاعِ النَّائِمَةِ
u'جماع نِساءٌ':Added, #1: 1	جِمَاعِ النَّائِمَةِ
u'جِمَاعٌ نِساءٌ':Added, #2: 2	جِمَاعِ النِّسَاءِ
u'جماع نِسْوانٌ':Added, #2: 2	جِمَاعِ النِّسَاءِ
u'جِمَاعٌ نِسْوانٌ':Added, #1: 1	جِمَاعُ النِّسْوَانِ
u'جماع نهار':Added, #1: 1	جِمَاعُ النِّسْوَانِ
u'جِمَاعٌ نهار':Added, #1: 1	جِمَاعُ نَهَارِ
u'جماع نَهَارٌ':Added, #1: 1	جِمَاعُ نَهَارِ
u'جِمَاعٌ نَهَارٌ':Added, #1: 1	جِمَاعُ نَهَارِ
u'جماع ولدان':Added, #1: 1	جِمَاعُ نَهَارِ
u'جماع ولدان':Added, #1: 1	جِمَاعُ الْوِلْدَانِ
u'جِمَاعٌ ولدان':Added, #1: 1	جِمَاعِ الْوِلْدَانِ
u'جِمَاعٌ ولدان':Added, #1: 1	جِمَاعُ الْوِلْدَانِ
u'جَمَالٌ أخْلاقٌ':Added, #1: 1	جِمَاعِ الْوِلْدَانِ
u'جَمَالٌ أَخْلاَقٌ':Added, #1: 1	جَمَالُ الْأَخْلَاقِ
u'جَمَالٌ آدَمِيٌّ':Added, #1: 1	جَمَالُ الْأَخْلَاقِ
u'جَمَالٌ إِسْلامٌ':Added, #1: 1	جَمَالَ الْآدَمِيِّ
u'جَمَالٌ إِسْلامٌ':Added, #1: 1	جَمَالِ الْإِسْلَامِ
u'جَمَالٌ أَفْعَالٌ':Added, #5: 5	جَمَالُ الْإِسْلَامِ
u'جَمَالٌ الْمَرْأَةُ':Added, #1: 1	جَمَالُ الْأَفْعَالِ
u'جَمَالٌ الْمَرْأَةُ':Added, #1: 1	جَمَالَ الْمَرْأَةِ
u'جَمَالٌ اِمْرَأَةٌ':Added, #2: 2	جَمَالِ الْمَرْأَةِ
u'جَمَالٌ حَقٌّ':Added, #1: 1	جَمَالِ امْرَأَةٍ
u'جَمَالٌ خلقة':Added, #1: 1	جَمَالِ الْحَقِّ
u'جَمَالٌ خلقة':Added, #1: 1	جَمَالُ الْخِلْقَةِ
u'جَمَالٌ خِلْقَةٌ':Added, #1: 1	جَمَالِ الْخِلْقَةِ
u'جَمَالٌ خِلْقَةٌ':Added, #1: 1	جَمَالُ الْخِلْقَةِ
u'جَمَالٌ دِينٌ':Added, #1: 1	جَمَالِ الْخِلْقَةِ
u'جَمَالٌ دِينٌ':Added, #45: 45	جَمَالُ الدِّينِ
u'جَمَالٌ دِينٌ':Added, #5: 5	جَمَالَ الدِّينِ
u'جَمَالٌ رِجَالٌ':Added, #8: 8	جَمَالِ الدِّينِ
u'جَمَالٌ رَجُلٌ':Added, #1: 1	جَمَالِ رِجَالِ
u'جَمَالٌ رَجُلٌ':Added, #1: 1	جَمَالِ الرَّجُلِ
u'جَمَالٌ عَمٌّ':Added, #2: 2	جَمَالُ الرَّجُلِ
u'جَمَالٌ نُوقٌ':Added, #1: 1	جَمَالُ عَمِّ
u'جَمَالٌ هَيْئَةٌ':Added, #1: 1	جَمَالٍ نُوقٍ
u'جَمَحَ فَرَسٌ':Subject, #1: 1	جَمَالَ هَيْئَةٍ
u'جَمَحَ مَاءٌ':Predicate, #2: 2	جَمَحَ الْفَرَسُ
u'جَمْدٌ بَحْرٌ':Added, #1: 1	جَمَحَ الْمَاءَ
u'جَمَدَ حَوْضٌ':Subject, #1: 1	جَمْدِ الْبَحْرِ
u'جَمَدَ لبن':Subject, #1: 1	جَمَدَ حَوْضٌ
u'جَمَدَ لَبَنٌ':Subject, #1: 1	جَمَدَ اللَّبَنُ
u'جَمَدَ مَاءٌ':Subject, #1: 1	جَمَدَ اللَّبَنُ
u'جَمَدَ مَاءٌ':Subject, #1: 1	جَمَدَ مَاءُ
u'جمع أَبْزَارٌ':Added, #2: 2	جَمَدَ الْمَاءُ
u'جَمْعٌ أَبْزَارٌ':Added, #1: 1	جَمْعُ أَبْزَارٍ
u'جَمَعَ اِبْنٌ':Subject, #1: 1	جَمْعُ أَبْزَارٍ
u'جمع اِبْنٌ':Added, #6: 6	جَمَعَ ابْنُ
u'جَمْعٌ اِبْنٌ':Added, #1: 1	جَمْعَ ابْنِ
u'جمع اِبْنٌ':Added, #1: 1	جَمْعَ ابْنِ
u'جَمْعٌ اِبْنٌ':Added, #2: 2	جَمْعُ ابْنٍ
u'جمع اِجْتِمَاعٌ':Added, #2: 2	جَمْعُ ابْنٍ
u'جَمْعٌ اِجْتِمَاعٌ':Added, #1: 1	جَمْعُ اجْتِمَاعٍ
u'جمع أَجْزَاءٌ':Added, #1: 1	جَمْعُ اجْتِمَاعٍ
u'جَمْعٌ أَجْزَاءٌ':Added, #2: 2	جَمْعِ الْأَجْزَاءِ
u'جمع أَجَلٌ':Added, #2: 2	جَمْعِ الْأَجْزَاءِ
u'جَمْعٌ أَجَلٌ':Added, #1: 1	جَمْعُ أَجَلٍ
u'جمع آحَادٌ':Added, #1: 1	جَمْعُ أَجَلٍ
u'جَمْعٌ آحَادٌ':Added, #2: 2	جَمْعُ الْآحَادِ
u'جَمَعَ أَحادِيثُ':Predicate, #2: 2	جَمْعُ الْآحَادِ
u'جَمَعَ أَحْكَامٌ':Predicate, #1: 1	جَمَعَ أَحَادِيثَ
u'جمع أَخٌ':Added, #1: 1	جَمَعَ أَحْكَامَ
u'جَمْعٌ أَخٌ':Added, #1: 1	جَمْعُ أَخٍ
u'جمع أُخْتٌ':Added, #1: 1	جَمْعُ أَخٍ
u'جَمْعٌ أُخْتٌ':Added, #2: 2	جَمْعُ أُخْتٍ
u'جمع أَدَاءٌ':Added, #2: 2	جَمْعُ أُخْتٍ
u'جَمْعٌ أَدَاءٌ':Added, #1: 1	جَمْعِ أَدَاءِ
u'جمع أدَب':Added, #1: 1	جَمْعِ أَدَاءِ
u'جَمْعٌ أدَب':Added, #2: 2	جَمْعُ أَدَبٍ
u'جمع أَدِيمٌ':Added, #2: 2	جَمْعُ أَدَبٍ
u'جَمْعٌ أَدِيمٌ':Added, #1: 1	جَمْعُ أَدِيمٍ
u'جَمَعَ أَرْبَعَةٌ':Predicate, #1: 1	جَمْعُ أَدِيمٍ
u'جَمَعَ أرْضٌ':Predicate, #1: 1	جَمَعَ أَرْبَعَةَ
u'جمع أَزْواجٌ':Added, #1: 1	جَمَعَ الْأَرْضَ
u'جَمْعٌ أَزْواجٌ':Added, #1: 1	جَمْعِ الْأَزْوَاجِ
u'جَمَعَ أَزْوادٌ':Predicate, #1: 1	جَمْعِ الْأَزْوَاجِ
u'جمع أَزْوادٌ':Added, #1: 1	جَمَعَ أَزْوَادَ
u'جَمْعٌ أَزْوادٌ':Added, #1: 1	جَمْعِ الْأَزْوَادِ
u'جمع أَسَدٌ':Added, #1: 1	جَمْعِ الْأَزْوَادِ
u'جَمْعٌ أَسَدٌ':Added, #1: 1	جَمْعَ أَسَدٍ
u'جمع اِسْمٌ':Added, #1: 1	جَمْعَ أَسَدٍ
u'جَمْعٌ اِسْمٌ':Added, #1: 1	جَمْعُ اسْمٍ
u'جَمَعَ أَسْواطٌ':Predicate, #1: 1	جَمْعُ اسْمٍ
u'جمع أَشْتَاتٌ':Added, #2: 2	جَمَعَ الْأَسْوَاطَ
u'جَمْعٌ أَشْتَاتٌ':Added, #1: 1	جَمْعِ أَشْتَاتِ
u'جَمَعَ أصدقاء':Predicate, #1: 1	جَمْعِ أَشْتَاتِ
u'جمع أصل':Added, #1: 1	جَمَعَ الْأَصْدِقَاءَ
u'جمع أًصْلٌ':Added, #1: 1	جَمْعِ الْأَصْلِ
u'جَمْعٌ أصل':Added, #1: 1	جَمْعِ الْأَصْلِ
u'جَمْعٌ أًصْلٌ':Added, #1: 1	جَمْعِ الْأَصْلِ
u'جمع أًصْلٌ':Added, #1: 1	جَمْعِ الْأَصْلِ
u'جَمْعٌ أًصْلٌ':Added, #4: 4	جَمْعُ أَصْلٍ
u'جمع أُصولٌ':Added, #4: 4	جَمْعُ أَصْلٍ
u'جَمْعٌ أُصولٌ':Added, #1: 1	جَمْعَ الْأُصُولِ
u'جمع أَعْدَاءٌ':Added, #1: 1	جَمْعَ الْأُصُولِ
u'جَمْعٌ أَعْدَاءٌ':Added, #1: 1	جَمْعُ أَعْدَاءٍ
u'جمع إِفْرَادٌ':Added, #1: 1	جَمْعُ أَعْدَاءٍ
u'جَمْعٌ إِفْرَادٌ':Added, #1: 1	جَمْعِ الْإِفْرَادِ
u'جمع أَفْعَالٌ':Added, #1: 1	جَمْعِ الْإِفْرَادِ
u'جَمْعٌ أَفْعَالٌ':Added, #1: 1	جَمْعُ أَفْعَالٍ
u'جمع أقارب':Added, #1: 1	جَمْعُ أَفْعَالٍ
u'جَمْعٌ أقارب':Added, #2: 2	جَمْعُ الْأَقَارِبِ
u'جَمَعَ إقامَةٌ':Predicate, #2: 2	جَمْعُ الْأَقَارِبِ
u'جَمَعَ إقامَةٌ':Predicate, #1: 1	أَجْمَعَ الإِقَامَةَ
u'جمع إقامَةٌ':Added, #3: 3	أَجْمَعَ إِقَامَةَ
u'جَمْعٌ إقامَةٌ':Added, #1: 1	جَمْعِ الْإِقَامَةِ
u'جَمَعَ أَقْوَالٌ':Predicate, #1: 1	جَمْعِ الْإِقَامَةِ
u'جمع أَقْوَالٌ':Added, #1: 1	جَمَعَ الْأَقْوَالَ
u'جَمْعٌ أَقْوَالٌ':Added, #1: 1	جَمْعُ أَقْوَالٍ
u'جمع أَكَمَةٌ':Added, #1: 1	جَمْعُ أَقْوَالٍ
u'جَمْعٌ أَكَمَةٌ':Added, #1: 1	جَمْعُ أَكَمَةٍ
u'جمع الْمَرْأَةُ':Added, #1: 1	جَمْعُ أَكَمَةٍ
u'جَمْعٌ الْمَرْأَةُ':Added, #1: 1	جَمْعِ الْمَرْأَةِ
u'جمع أُمٌّ':Added, #1: 1	جَمْعِ الْمَرْأَةِ
u'جَمْعٌ أُمٌّ':Added, #1: 1	جَمْعُ أُمٍّ
u'جمع إمَاءٌ':Added, #1: 1	جَمْعُ أُمٍّ
u'جَمْعٌ إمَاءٌ':Added, #1: 1	جَمْعِ الْإِمَاءِ
u'جَمَعَ إمَامٌ':Subject, #1: 1	جَمْعِ الْإِمَاءِ
u'جمع إمَامٌ':Added, #4: 4	جَمَعَ الْإِمَامُ
u'جَمْعٌ إمَامٌ':Added, #1: 1	جَمْعِ الْإِمَامِ
u'جمع إمَامٌ':Added, #1: 1	جَمْعِ الْإِمَامِ
u'جَمْعٌ إمَامٌ':Added, #1: 1	جَمْعُ إمَامٍ
u'جمع أمَةٌ':Added, #1: 1	جَمْعُ إمَامٍ
u'جَمْعٌ أمَةٌ':Added, #1: 1	جَمْعُ الْأَمَةِ
u'جمع أُمَّةٌ':Added, #1: 1	جَمْعُ الْأَمَةِ
u'جَمْعٌ أُمَّةٌ':Added, #1: 1	جَمْعُ أُمَّةٍ
u'جمع آمِرٌ':Added, #1: 1	جَمْعُ أُمَّةٍ
u'جمع أَمْرٌ':Added, #1: 1	جَمْعُ آمِرٍ
u'جمع أَمْرٌ':Added, #1: 1	جَمْعُ أَمْرٍ
u'جَمْعٌ آمِرٌ':Added, #1: 1	جَمْعِ أَمْرٍ
u'جَمْعٌ أَمْرٌ':Added, #1: 1	جَمْعُ آمِرٍ
u'جَمْعٌ أَمْرٌ':Added, #1: 1	جَمْعُ أَمْرٍ
u'جمع أَمْرٌ':Added, #1: 1	جَمْعِ أَمْرٍ
u'جَمْعٌ أَمْرٌ':Added, #2: 2	جَمْعَ أَمْرٍ
u'جَمَعَ أمراء':Predicate, #2: 2	جَمْعَ أَمْرٍ
u'جمع اِمْرَأَةٌ':Added, #1: 1	جَمَعَ الأُمَرَاءَ
u'جَمْعٌ اِمْرَأَةٌ':Added, #1: 1	جَمْعُ امْرَأَةٍ
u'جمع آمِنٌ':Added, #1: 1	جَمْعُ امْرَأَةٍ
u'جَمْعٌ آمِنٌ':Added, #1: 1	جَمْعَ آمِنٍ
u'جمع أموات':Added, #1: 1	جَمْعَ آمِنٍ
u'جمع أموات':Added, #1: 1	جَمْعُ الْأَمْوَاتِ
u'جَمْعٌ أموات':Added, #1: 1	جَمْعِ الْأَمْوَاتِ
u'جَمْعٌ أموات':Added, #1: 1	جَمْعُ الْأَمْوَاتِ
u'جمع أَمْوَالٌ':Added, #1: 1	جَمْعِ الْأَمْوَاتِ
u'جمع أَمْوَالٌ':Added, #1: 1	جَمْعَ الْأَمْوَالِ
u'جَمْعٌ أَمْوَالٌ':Added, #1: 1	جَمْعِ الْأَمْوَالِ
u'جَمْعٌ أَمْوَالٌ':Added, #1: 1	جَمْعَ الْأَمْوَالِ
u'جَمَعَ أَميرٌ':Subject, #1: 1	جَمْعِ الْأَمْوَالِ
u'جمع إِناءٌ':Added, #1: 1	جَمَعَ أَمِيرُ
u'جَمْعٌ إِناءٌ':Added, #1: 1	جَمْعُ إنَاءٍ
u'جَمَعَ أهْلٌ':Predicate, #1: 1	جَمْعُ إنَاءٍ
u'جَمَعَ أهْلٌ':Subject, #3: 3	جَمَعَ أَهْلَ
u'جَمَعَ أهْلٌ':Subject, #1: 1	جَمَعَ أَهْلُهُ
u'جمع أهْلٌ':Added, #2: 2	جَمَعَ أَهْلُ
u'جَمْعٌ أهْلٌ':Added, #1: 1	جَمْعُ أَهْلِ
u'جَمَعَ أَهْلِيٌّ':Predicate, #1: 1	جَمْعُ أَهْلِ
u'جَمَعَ أهْلِيَّةٌ':Predicate, #1: 1	جَمَعَ أَهْلِيَّةَ
u'جَمَعَ أوداج':Predicate, #1: 1	جَمَعَ أَهْلِيَّةَ
u'جَمَعَ أَوْلاَدٌ':Predicate, #1: 1	جَمَعَ الْأَوْدَاجَ
u'جمع أئِمَّةٌ':Added, #1: 1	جَمَعَ الْأَوْلَادَ
u'جَمْعٌ أئِمَّةٌ':Added, #1: 1	جَمْعُ أَئِمَّةٍ
u'جمع آيَةٌ':Added, #1: 1	جَمْعُ أَئِمَّةٍ
u'جَمْعٌ آيَةٌ':Added, #1: 1	جَمْعُ آيَةٍ
u'جَمَعَ إيمَانٌ':Predicate, #1: 1	جَمْعُ آيَةٍ
u'جمع بَائِرٌ':Added, #1: 1	جَمَعَ الإِيمَانَ
u'جَمْعٌ بَائِرٌ':Added, #1: 1	جَمْعُ بَائِرٍ
u'جمع بَائِعٌ':Added, #1: 1	جَمْعُ بَائِرٍ
u'جَمْعٌ بَائِعٌ':Added, #1: 1	جَمْعِ الْبَائِعِ
u'جمع بَائِعٌ':Added, #1: 1	جَمْعِ الْبَائِعِ
u'جَمْعٌ بَائِعٌ':Added, #1: 1	جَمْعُ بَائِعٍ
u'جمع بُحُورٌ':Added, #1: 1	جَمْعُ بَائِعٍ
u'جَمْعٌ بُحُورٌ':Added, #1: 1	جَمْعُ بُحُورٍ
u'جَمَعَ بُخَارِيٌّ':Subject, #1: 1	جَمْعُ بُحُورٍ
u'جمع بدنة':Added, #1: 1	جَمَعَ الْبُخَارِيُّ
u'جَمْعٌ بدنة':Added, #1: 1	جَمْعُ بَدَنَةٍ
u'جمع بِرْذَوْنٌ':Added, #1: 1	جَمْعُ بَدَنَةٍ
u'جَمْعٌ بِرْذَوْنٌ':Added, #1: 1	جَمْعُ بِرْذَوْنٍ
u'جمع بُرْمَةٌ':Added, #1: 1	جَمْعُ بِرْذَوْنٍ
u'جَمْعٌ بُرْمَةٌ':Added, #1: 1	جَمْعُ بُرْمَةٍ
u'جمع بَريدٌ':Added, #1: 1	جَمْعُ بُرْمَةٍ
u'جَمْعٌ بَريدٌ':Added, #1: 1	جَمْعُ بَرِيدٍ
u'جمع بصرة':Added, #1: 1	جَمْعُ بَرِيدٍ
u'جَمْعٌ بصرة':Added, #1: 1	جَمْعُ بَصْرَةٍ
u'جمع بَصيرَةٌ':Added, #1: 1	جَمْعُ بَصْرَةٍ
u'جَمْعٌ بَصيرَةٌ':Added, #1: 1	جَمْعَ بَصِيرَةٍ
u'جَمَعَ بَعْضٌ':Predicate, #1: 1	جَمْعَ بَصِيرَةٍ
u'جَمَعَ بَعْضٌ':Subject, #1: 1	جَمَعَ بَعْضَ
u'جمع بُغاث':Added, #4: 4	جَمَعَ بَعْضُ
u'جَمْعٌ بُغاث':Added, #1: 1	جَمْعُ بُغَاثَةٍ
u'جمع بِنْتٌ':Added, #1: 1	جَمْعُ بُغَاثَةٍ
u'جَمْعٌ بِنْتٌ':Added, #1: 1	جَمْعُ بِنْتٍ
u'جمع بِنْيَةٌ':Added, #1: 1	جَمْعُ بِنْتٍ
u'جَمْعٌ بِنْيَةٌ':Added, #1: 1	جَمْعُ بِنْيَةٍ
u'جمع بُهْلُولٌ':Added, #1: 1	جَمْعُ بِنْيَةٍ
u'جَمْعٌ بُهْلُولٌ':Added, #1: 1	جَمْعُ بُهْلُولٍ
u'جمع بَهِيمَةٌ':Added, #1: 1	جَمْعُ بُهْلُولٍ
u'جَمْعٌ بَهِيمَةٌ':Added, #1: 1	جَمْعُ بَهِيمَةٍ
u'جَمَعَ بَيَانٌ':Predicate, #1: 1	جَمْعُ بَهِيمَةٍ
u'جمع بَيْعٌ':Added, #1: 1	جَمَعَ بَيَانَ
u'جَمْعٌ بَيْعٌ':Added, #1: 1	جَمْعُ بَيْعَتَيْنِ
u'جمع بَيْعٌ':Added, #1: 1	جَمْعُ بَيْعَتَيْنِ
u'جَمْعٌ بَيْعٌ':Added, #2: 2	جَمْعُ الْبَيْعِ
u'جمع بَيْعٌ':Added, #2: 2	جَمْعُ الْبَيْعِ
u'جَمْعٌ بَيْعٌ':Added, #3: 3	جَمْعُ بَيْعٍ
u'جمع بِيعَةٌ':Added, #3: 3	جَمْعُ بَيْعٍ
u'جَمْعٌ بِيعَةٌ':Added, #1: 1	جَمْعُ بِيعَةٍ
u'جَمَعَ بَيْنٌ':Predicate, #1: 1	جَمْعُ بِيعَةٍ
u'جَمَعَ بَيْنٌ':Predicate, #364: 364	جَمَعَ بَيْنَ
u'جمع تَابِعِيٌّ':Added, #3: 3	أَجْمَعَ بَيْنَ
u'جَمْعٌ تَابِعِيٌّ':Added, #1: 1	جَمْعُ تَابِعِيٍّ
u'جمع تَاجِرٌ':Added, #1: 1	جَمْعُ تَابِعِيٍّ
u'جَمْعٌ تَاجِرٌ':Added, #1: 1	جَمْعِ تَاجِرٍ
u'جمع تَاجِرٌ':Added, #1: 1	جَمْعِ تَاجِرٍ
u'جَمْعٌ تَاجِرٌ':Added, #2: 2	جَمْعُ تَاجِرٍ
u'جمع تَأْخِيرٌ':Added, #2: 2	جَمْعُ تَاجِرٍ
u'جَمْعٌ تَأْخِيرٌ':Added, #2: 2	جَمْعُ تَأْخِيرٍ
u'جمع تَأْخِيرٌ':Added, #2: 2	جَمْعُ تَأْخِيرٍ
u'جَمْعٌ تَأْخِيرٌ':Added, #4: 4	جَمْعِ التَّأْخِيرِ
u'جمع تَأْخِيرٌ':Added, #4: 4	جَمْعِ التَّأْخِيرِ
u'جَمْعٌ تَأْخِيرٌ':Added, #5: 5	جَمْعَ التَّأْخِيرِ
u'جمع تَأْخِيرٌ':Added, #5: 5	جَمْعَ التَّأْخِيرِ
u'جَمْعٌ تَأْخِيرٌ':Added, #7: 7	جَمْعُ التَّأْخِيرِ
u'جمع تَأْخِيرٌ':Added, #7: 7	جَمْعُ التَّأْخِيرِ
u'جَمْعٌ تَأْخِيرٌ':Added, #7: 7	جَمْعَ تَأْخِيرٍ
u'جمع تَحْرِيمٌ':Added, #7: 7	جَمْعَ تَأْخِيرٍ
u'جَمْعٌ تَحْرِيمٌ':Added, #1: 1	جَمْعُ تَحْرِيمِ
u'جمع تَحِيَّةٌ':Added, #1: 1	جَمْعُ تَحْرِيمِ
u'جَمْعٌ تَحِيَّةٌ':Added, #1: 1	جَمْعُ تَحِيَّةٍ
u'جمع تُرَابٌ':Added, #1: 1	جَمْعُ تَحِيَّةٍ
u'جَمْعٌ تُرَابٌ':Added, #1: 1	جَمْعُ التُّرَابِ
u'جمع تُرَابٌ':Added, #1: 1	جَمْعُ التُّرَابِ
u'جمع تُرَابٌ':Added, #1: 1	جَمْعُ تُرَابٍ
u'جَمْعٌ تُرَابٌ':Added, #1: 1	جَمْعِ تُرَابٍ
u'جَمْعٌ تُرَابٌ':Added, #1: 1	جَمْعُ تُرَابٍ
u'جمع تُرَابٌ':Added, #1: 1	جَمْعِ تُرَابٍ
u'جَمْعٌ تُرَابٌ':Added, #2: 2	جَمْعِ التُّرَابِ
u'جمع تَرِكَةٌ':Added, #2: 2	جَمْعِ التُّرَابِ
u'جَمْعٌ تَرِكَةٌ':Added, #2: 2	جَمْعُ تَرِكَةٍ
u'جمع تُرْكِيّ':Added, #2: 2	جَمْعُ تَرِكَةٍ
u'جَمْعٌ تُرْكِيّ':Added, #2: 2	جَمْعُ التُّرْكِيِّ
u'جمع تَرْوِيحَةٌ':Added, #2: 2	جَمْعُ التُّرْكِيِّ
u'جمع تَرْوِيحَة':Added, #1: 1	جَمْعُ تَرْوِيحَةٍ
u'جَمْعٌ تَرْوِيحَةٌ':Added, #1: 1	جَمْعُ تَرْوِيحَةٍ
u'جَمْعٌ تَرْوِيحَة':Added, #1: 1	جَمْعُ تَرْوِيحَةٍ
u'جمع تَسْمِيَة':Added, #1: 1	جَمْعُ تَرْوِيحَةٍ
u'جَمْعٌ تَسْمِيَة':Added, #1: 1	جَمْعُ تَسْمِيَةٍ
u'جمع تَصْحِيحٌ':Added, #1: 1	جَمْعُ تَسْمِيَةٍ
u'جَمْعٌ تَصْحِيحٌ':Added, #1: 1	جَمْعُ تَصْحِيحٍ
u'جمع تَصْحِيحٌ':Added, #1: 1	جَمْعُ تَصْحِيحٍ
u'جَمْعٌ تَصْحِيحٌ':Added, #2: 2	جَمْعَ تَصْحِيحٍ
u'جمع تَقْديمٌ':Added, #2: 2	جَمْعَ تَصْحِيحٍ
u'جَمْعٌ تَقْديمٌ':Added, #12: 12	جَمْعِ التَّقْدِيمِ
u'جمع تَقْديمٌ':Added, #12: 12	جَمْعِ التَّقْدِيمِ
u'جَمْعٌ تَقْديمٌ':Added, #1: 1	جَمْعِ تَقْدِيمٍ
u'جمع تَقْديمٌ':Added, #1: 1	جَمْعِ تَقْدِيمٍ
u'جَمْعٌ تَقْديمٌ':Added, #2: 2	جَمْعَ التَّقْدِيمِ
u'جمع تَقْديمٌ':Added, #2: 2	جَمْعَ التَّقْدِيمِ
u'جَمْعٌ تَقْديمٌ':Added, #4: 4	جَمْعُ تَقْدِيمٍ
u'جمع تَقْديمٌ':Added, #4: 4	جَمْعُ تَقْدِيمٍ
u'جَمْعٌ تَقْديمٌ':Added, #5: 5	جَمْعَ تَقْدِيمٍ
u'جمع تَقْديمٌ':Added, #5: 5	جَمْعَ تَقْدِيمٍ
u'جَمْعٌ تَقْديمٌ':Added, #8: 8	جَمْعُ التَّقْدِيمِ
u'جَمَعَ تَقِيٌّ':Subject, #8: 8	جَمْعُ التَّقْدِيمِ
u'جمع تَكْسيرٌ':Added, #1: 1	جَمَعَ التَّقِيُّ
u'جَمْعٌ تَكْسيرٌ':Added, #1: 1	جَمْعَ التَّكْسِيرِ
u'جمع تَكْسيرٌ':Added, #1: 1	جَمْعَ التَّكْسِيرِ
u'جَمْعٌ تَكْسيرٌ':Added, #1: 1	جَمْعَ تَكْسِيرٍ
u'جمع تَكْسيرٌ':Added, #1: 1	جَمْعَ تَكْسِيرٍ
u'جَمْعٌ تَكْسيرٌ':Added, #3: 3	جَمْعِ التَّكْسِيرِ
u'جمع تِمْثالٌ':Added, #3: 3	جَمْعِ التَّكْسِيرِ
u'جَمْعٌ تِمْثالٌ':Added, #1: 1	جَمْعُ تِمْثَالٍ
u'جمع تَمْر':Added, #1: 1	جَمْعُ تِمْثَالٍ
u'جَمْعٌ تَمْر':Added, #1: 1	جَمْعِ التَّمْرِ
u'جمع تَمْر':Added, #1: 1	جَمْعِ التَّمْرِ
u'جَمْعٌ تَمْر':Added, #1: 1	جَمْعُ التَّمْرَتَيْنِ
u'جمع تَمْرَةٌ':Added, #1: 1	جَمْعُ التَّمْرَتَيْنِ
u'جَمْعٌ تَمْرَةٌ':Added, #1: 1	جَمْعُ تَمْرَةٍ
u'جمع تَمِيمَةٌ':Added, #1: 1	جَمْعُ تَمْرَةٍ
u'جمع تَمِيمَةٌ':Added, #1: 1	جَمْعُ تَمِيمَةٍ
u'جَمْعٌ تَمِيمَةٌ':Added, #1: 1	جَمْعِ تَمِيمَةٍ
u'جَمْعٌ تَمِيمَةٌ':Added, #1: 1	جَمْعُ تَمِيمَةٍ
u'جمع تِنْبال':Added, #1: 1	جَمْعِ تَمِيمَةٍ
u'جَمْعٌ تِنْبال':Added, #1: 1	جَمْعُ تِنْبَالٍ
u'جَمَعَ تَنْبِيه':Predicate, #1: 1	جَمْعُ تِنْبَالٍ
u'جمع تَهْويلٌ':Added, #1: 1	جَمَعَ التَّنْبِيهَ
u'جَمْعٌ تَهْويلٌ':Added, #1: 1	جَمْعُ تَهْوِيلٍ
u'جمع ثَانِي':Added, #1: 1	جَمْعُ تَهْوِيلٍ
u'جَمْعٌ ثَانِي':Added, #1: 1	جَمْعُ الثَّانِيَةِ
u'جمع ثَانِيَةٌ':Added, #1: 1	جَمْعُ الثَّانِيَةِ
u'جَمْعٌ ثَانِيَةٌ':Added, #1: 1	جَمْعُ الثَّانِيَةِ
u'جمع ثَدْيٌ':Added, #1: 1	جَمْعُ الثَّانِيَةِ
u'جَمْعٌ ثَدْيٌ':Added, #1: 1	جَمْعِ ثَدْيٍ
u'جمع ثَغْرٌ':Added, #1: 1	جَمْعِ ثَدْيٍ
u'جَمْعٌ ثَغْرٌ':Added, #4: 4	جَمْعُ ثَغْرٍ
u'جَمَعَ ثَلاثُ':Predicate, #4: 4	جَمْعُ ثَغْرٍ
u'جمع ثَلاثُ':Added, #1: 1	جَمَعَ الثَّلَاثَ
u'جَمْعٌ ثَلاثُ':Added, #1: 1	جَمْعُ الثَّلَاثِ
u'جمع ثَلاثُ':Added, #1: 1	جَمْعُ الثَّلَاثِ
u'جَمْعٌ ثَلاثُ':Added, #1: 1	جَمْعُ ثَلَاثِ
u'جمع ثَلاثُ':Added, #1: 1	جَمْعُ ثَلَاثِ
u'جَمْعٌ ثَلاثُ':Added, #2: 2	جَمْعَ الثَّلَاثِ
u'جمع ثَلاثُ':Added, #2: 2	جَمْعَ الثَّلَاثِ
u'جَمْعٌ ثَلاثُ':Added, #4: 4	جَمْعِ الثَّلَاثِ
u'جمع ثَلاثَةٌ':Added, #4: 4	جَمْعِ الثَّلَاثِ
u'جَمْعٌ ثَلاثَةٌ':Added, #1: 1	جَمْعَ الثَّلَاثَةِ
u'جمع ثَمَرٌ':Added, #1: 1	جَمْعَ الثَّلَاثَةِ
u'جَمْعٌ ثَمَرٌ':Added, #1: 1	جَمْعُ ثَمَرٍ
u'جمع ثَمَرَةٌ':Added, #1: 1	جَمْعُ ثَمَرٍ
u'جَمْعٌ ثَمَرَةٌ':Added, #1: 1	جَمْعُ الثَّمَرَةِ
u'جمع ثَمَرَةٌ':Added, #1: 1	جَمْعُ الثَّمَرَةِ
u'جَمْعٌ ثَمَرَةٌ':Added, #1: 1	جَمْعُ ثَمَرَةٍ
u'جَمَعَ ثَمَنٌ':Predicate, #1: 1	جَمْعُ ثَمَرَةٍ
u'جمع ثَوْرٌ':Added, #1: 1	جَمَعَ الثَّمَنَ
u'جَمْعٌ ثَوْرٌ':Added, #1: 1	جَمْعُ ثَوْرٍ
u'جمع ثِيابٌ':Added, #1: 1	جَمْعُ ثَوْرٍ
u'جَمْعٌ ثِيابٌ':Added, #1: 1	جَمْعُ الثِّيَابِ
u'جمع جَابِي':Added, #1: 1	جَمْعُ الثِّيَابِ
u'جَمْعٌ جَابِي':Added, #2: 2	جَمْعُ جَابِيَةٍ
u'جمع جَابِيَةٌ':Added, #2: 2	جَمْعُ جَابِيَةٍ
u'جَمْعٌ جَابِيَةٌ':Added, #2: 2	جَمْعُ جَابِيَةٍ
u'جَمَعَ جَازٌ':Predicate, #2: 2	جَمْعُ جَابِيَةٍ
u'جمع جَالِسٌ':Added, #1: 1	جَمَعَ جَازَ
u'جَمْعٌ جَالِسٌ':Added, #1: 1	جَمْعُ جَالِسٍ
u'جمع جَامِعٌ':Added, #1: 1	جَمْعُ جَالِسٍ
u'جَمْعٌ جَامِعٌ':Added, #1: 1	جَمْعَ الْجَامِعِ
u'جمع جَائِحٌ':Added, #1: 1	جَمْعَ الْجَامِعِ
u'جَمْعٌ جَائِحٌ':Added, #1: 1	جَمْعُ جَائِحَةٍ
u'جمع جاَئِحَةٌ':Added, #1: 1	جَمْعُ جَائِحَةٍ
u'جَمْعٌ جاَئِحَةٌ':Added, #1: 1	جَمْعُ جَائِحَةٍ
u'جمع جَبِيرَة':Added, #1: 1	جَمْعُ جَائِحَةٍ
u'جَمْعٌ جَبِيرَة':Added, #1: 1	جَمْعُ جَبِيرَةٍ
u'جمع جُحْر':Added, #1: 1	جَمْعُ جَبِيرَةٍ
u'جَمْعٌ جُحْر':Added, #1: 1	جَمْعُ جُحْرٍ
u'جمع جِدار':Added, #1: 1	جَمْعُ جُحْرٍ
u'جَمْعٌ جِدار':Added, #1: 1	جَمْعُ جِدَارٍ
u'جمع جُدْجُدٌ':Added, #1: 1	جَمْعُ جِدَارٍ
u'جَمْعٌ جُدْجُدٌ':Added, #1: 1	جَمْعُ جُدْجُدٍ
u'جمع جَدْرٌ':Added, #1: 1	جَمْعُ جُدْجُدٍ
u'جَمْعٌ جَدْرٌ':Added, #2: 2	جَمْعُ جَدْرٍ
u'جمع جَرَادَةٌ':Added, #2: 2	جَمْعُ جَدْرٍ
u'جَمْعٌ جَرَادَةٌ':Added, #1: 1	جَمْعُ جَرَادَةٍ
u'جمع جُرَذٌ':Added, #1: 1	جَمْعُ جَرَادَةٍ
u'جَمْعٌ جُرَذٌ':Added, #1: 1	جَمْعُ جُرَذٍ
u'جمع جُرْزَة':Added, #1: 1	جَمْعُ جُرَذٍ
u'جَمْعٌ جُرْزَة':Added, #1: 1	جَمْعُ جُرْزَةٍ
u'جمع جُرْن':Added, #1: 1	جَمْعُ جُرْزَةٍ
u'جَمْعٌ جُرْن':Added, #1: 1	جَمْعُ جُرْنٍ
u'جمع جَرِيب':Added, #1: 1	جَمْعُ جُرْنٍ
u'جَمْعٌ جَرِيب':Added, #1: 1	جَمْعُ جَرِيبٍ
u'جمع جُزْءٌ':Added, #1: 1	جَمْعُ جَرِيبٍ
u'جَمْعٌ جُزْءٌ':Added, #1: 1	جَمْعُ جُزْءٍ
u'جمع جَسَدٌ':Added, #1: 1	جَمْعُ جُزْءٍ
u'جَمْعٌ جَسَدٌ':Added, #1: 1	جَمْعِ الْجَسَدِ
u'جمع جَلٌّ':Added, #1: 1	جَمْعِ الْجَسَدِ
u'جَمْعٌ جَلٌّ':Added, #1: 1	جَمْعُ الْجَلِّ
u'جَمْعٌ جَمٌّ':Added, #1: 1	جَمْعُ الْجَلِّ
u'جَمَعَ جَمَاعَةٌ':Predicate, #1: 1	جَمْعٍ جَمٍّ
u'جَمَعَ جَمَاعَةٌ':Subject, #1: 1	جَمَعَ الْجَمَاعَةَ
u'جمع جَمَاعَةٌ':Added, #1: 1	جَمَعَ جَمَاعَةٌ
u'جَمْعٌ جَمَاعَةٌ':Added, #1: 1	جَمْعِ جَمَاعَةٍ
u'جمع جَمْرَةٌ':Added, #1: 1	جَمْعِ جَمَاعَةٍ
u'جمع جَمْرَة':Added, #1: 1	جَمْعُ جَمْرَةٍ
u'جَمْعٌ جَمْرَةٌ':Added, #1: 1	جَمْعُ جَمْرَةٍ
u'جَمْعٌ جَمْرَة':Added, #1: 1	جَمْعُ جَمْرَةٍ
u'جمع جمع':Added, #1: 1	جَمْعُ جَمْرَةٍ
u'جَمْعٌ جمع':Added, #1: 1	جَمْعَ الْجَمْعِ
u'جمع جَمْعٌ':Added, #1: 1	جَمْعَ الْجَمْعِ
u'جَمْعٌ جَمْعٌ':Added, #1: 1	جَمْعَ الْجَمْعِ
u'جمع جمع':Added, #1: 1	جَمْعَ الْجَمْعِ
u'جَمْعٌ جمع':Added, #1: 1	جَمْعُ جَمْعِ
u'جمع جَمْعٌ':Added, #1: 1	جَمْعُ جَمْعِ
u'جَمْعٌ جَمْعٌ':Added, #1: 1	جَمْعُ جَمْعِ
u'جمع جمع':Added, #1: 1	جَمْعُ جَمْعِ
u'جَمْعٌ جمع':Added, #1: 1	جَمْعُ جَمْعِهِ
u'جمع جَمْعٌ':Added, #1: 1	جَمْعُ جَمْعِهِ
u'جَمْعٌ جَمْعٌ':Added, #1: 1	جَمْعُ جَمْعِهِ
u'جمع جمع':Added, #1: 1	جَمْعُ جَمْعِهِ
u'جَمْعٌ جمع':Added, #2: 2	جَمْعَ جَمْعِ
u'جمع جَمْعٌ':Added, #2: 2	جَمْعَ جَمْعِ
u'جَمْعٌ جَمْعٌ':Added, #2: 2	جَمْعَ جَمْعِ
u'جمع جمع':Added, #2: 2	جَمْعَ جَمْعِ
u'جَمْعٌ جمع':Added, #3: 3	جَمْعِ الْجَمْعِ
u'جمع جَمْعٌ':Added, #3: 3	جَمْعِ الْجَمْعِ
u'جَمْعٌ جَمْعٌ':Added, #3: 3	جَمْعِ الْجَمْعِ
u'جمع جمع':Added, #3: 3	جَمْعِ الْجَمْعِ
u'جَمْعٌ جمع':Added, #5: 5	جَمْعُ الْجَمْعِ
u'جمع جَمْعٌ':Added, #5: 5	جَمْعُ الْجَمْعِ
u'جَمْعٌ جَمْعٌ':Added, #5: 5	جَمْعُ الْجَمْعِ
u'جمع جمعة':Added, #5: 5	جَمْعُ الْجَمْعِ
u'جَمْعٌ جمعة':Added, #1: 1	جَمْعُ الْجُمُعَةِ
u'جمع جُمُعَةٌ':Added, #1: 1	جَمْعُ الْجُمُعَةِ
u'جَمْعٌ جُمُعَةٌ':Added, #1: 1	جَمْعُ الْجُمُعَةِ
u'جمع جمعة':Added, #1: 1	جَمْعُ الْجُمُعَةِ
u'جَمْعٌ جمعة':Added, #2: 2	جَمْعُ جُمُعَةٍ
u'جمع جُمُعَةٌ':Added, #2: 2	جَمْعُ جُمُعَةٍ
u'جَمْعٌ جُمُعَةٌ':Added, #2: 2	جَمْعُ جُمُعَةٍ
u'جمع جَمَلٌ':Added, #2: 2	جَمْعُ جُمُعَةٍ
u'جَمْعٌ جَمَلٌ':Added, #1: 1	جَمْعُ جَمَلٍ
u'جمع جُمْلَةٌ':Added, #1: 1	جَمْعُ جَمَلٍ
u'جَمْعٌ جُمْلَةٌ':Added, #1: 1	جَمْعُ جُمْلَةٍ
u'جَمَعَ جَمِيع':Predicate, #1: 1	جَمْعُ جُمْلَةٍ
u'جمع جَنَازَةٌ':Added, #2: 2	جَمَعَ الْجَمِيعَ
u'جَمْعٌ جَنَازَةٌ':Added, #1: 1	جَمْعُ جَنَازَةٍ
u'جمع جَنَائِزُ':Added, #1: 1	جَمْعُ جَنَازَةٍ
u'جَمْعٌ جَنَائِزُ':Added, #1: 1	جَمْعَ الْجَنَائِزِ
u'جمع جِنَايَةٌ':Added, #1: 1	جَمْعَ الْجَنَائِزِ
u'جَمْعٌ جِنَايَةٌ':Added, #2: 2	جَمْعُ جِنَايَةٍ
u'جمع جَنِينٌ':Added, #2: 2	جَمْعُ جِنَايَةٍ
u'جَمْعٌ جَنِينٌ':Added, #1: 1	جَمْعُ الْجَنِينِ
u'جَمَعَ جَوَابٌ':Subject, #1: 1	جَمْعُ الْجَنِينِ
u'جمع جَوَامِعُ':Added, #1: 1	جَمَعَ جَوَابُهُ
u'جَمْعٌ جَوَامِعُ':Added, #1: 1	جَمْع الْجَوَامِعِ
u'جمع جَوَامِعُ':Added, #1: 1	جَمْع الْجَوَامِعِ
u'جَمْعٌ جَوَامِعُ':Added, #38: 38	جَمْعِ الْجَوَامِعِ
u'جمع جَوْزَل':Added, #38: 38	جَمْعِ الْجَوَامِعِ
u'جَمْعٌ جَوْزَل':Added, #1: 1	جَمْعُ جَوْزَلٍ
u'جمع جِيدٌ':Added, #1: 1	جَمْعُ جَوْزَلٍ
u'جَمْعٌ جِيدٌ':Added, #1: 1	جَمْعُ جِيدٍ
u'جمع حابِلٌ':Added, #1: 1	جَمْعُ جِيدٍ
u'جَمْعٌ حابِلٌ':Added, #1: 1	جَمْعَ حَابِلَةٍ
u'جمع حابِلَةٌ':Added, #1: 1	جَمْعَ حَابِلَةٍ
u'جَمْعٌ حابِلَةٌ':Added, #1: 1	جَمْعَ حَابِلَةٍ
u'جمع حارٌّ':Added, #1: 1	جَمْعَ حَابِلَةٍ
u'جَمْعٌ حارٌّ':Added, #1: 1	جَمْعَ الْحَارِّ
u'جمع حاسَّةٌ':Added, #1: 1	جَمْعَ الْحَارِّ
u'جَمْعٌ حاسَّةٌ':Added, #1: 1	جَمْعُ حَاسَّةٍ
u'جمع حاشِيَةٌ':Added, #1: 1	جَمْعُ حَاسَّةٍ
u'جَمْعٌ حاشِيَةٌ':Added, #1: 1	جَمْعُ حَاشِيَةِ
u'جمع حاطِبٌ':Added, #1: 1	جَمْعُ حَاشِيَةِ
u'جَمْعٌ حاطِبٌ':Added, #1: 1	جَمْعُ حَاطِبٍ
u'جمع حافِظٌ':Added, #1: 1	جَمْعُ حَاطِبٍ
u'جَمْعٌ حافِظٌ':Added, #1: 1	جَمْعُ حَافِظٍ
u'جمع حائِكٌ':Added, #1: 1	جَمْعُ حَافِظٍ
u'جَمْعٌ حائِكٌ':Added, #1: 1	جَمْعُ حَائِكٍ
u'جمع حائِلٌ':Added, #1: 1	جَمْعُ حَائِكٍ
u'جَمْعٌ حائِلٌ':Added, #2: 2	جَمْعُ حَائِلٍ
u'جمع حُبٌّ':Added, #2: 2	جَمْعُ حَائِلٍ
u'جَمْعٌ حُبٌّ':Added, #1: 1	جَمْعُ حُبٍّ
u'جمع حِبْرٌ':Added, #1: 1	جَمْعُ حُبٍّ
u'جَمْعٌ حِبْرٌ':Added, #1: 1	جَمْعُ حِبْرٍ
u'جَمَعَ حَجٌّ':Predicate, #1: 1	جَمْعُ حِبْرٍ
u'جمع حَجٌّ':Added, #4: 4	جَمَعَ الْحَجَّ
u'جَمْعٌ حَجٌّ':Added, #1: 1	جَمْعَ الْحَجِّ
u'جَمَعَ حِجارَةٌ':Predicate, #1: 1	جَمْعَ الْحَجِّ
u'جمع حجزة':Added, #1: 1	جَمَعَ الْحِجَارَةَ
u'جَمْعٌ حجزة':Added, #1: 1	جَمْعُ حُجْزَةٍ
u'جمع حُجْزَةٌ':Added, #1: 1	جَمْعُ حُجْزَةٍ
u'جَمْعٌ حُجْزَةٌ':Added, #1: 1	جَمْعُ حُجْزَةٍ
u'جمع حَجَلٌ':Added, #1: 1	جَمْعُ حُجْزَةٍ
u'جَمْعٌ حَجَلٌ':Added, #2: 2	جَمْعُ حَجَلَةٍ
u'جمع حَجَلَةٌ':Added, #2: 2	جَمْعُ حَجَلَةٍ
u'جَمْعٌ حَجَلَةٌ':Added, #2: 2	جَمْعُ حَجَلَةٍ
u'جمع حَدٌّ':Added, #2: 2	جَمْعُ حَجَلَةٍ
u'جَمْعٌ حَدٌّ':Added, #2: 2	جَمْعُ حَدٍّ
u'جمع حَدَثٌ':Added, #2: 2	جَمْعُ حَدٍّ
u'جَمْعٌ حَدَثٌ':Added, #2: 2	جَمْعُ حَدَثٍ
u'جمع حِدْج':Added, #2: 2	جَمْعُ حَدَثٍ
u'جَمْعٌ حِدْج':Added, #1: 1	جَمْعُ حِدْجٍ
u'جمع حَدَج':Added, #1: 1	جَمْعُ حِدْجٍ
u'جَمْعٌ حَدَج':Added, #1: 1	جَمْعُ حَدَجَةٍ
u'جَمَعَ حَديثٌ':Subject, #1: 1	جَمْعُ حَدَجَةٍ
u'جمع حَديثٌ':Added, #1: 1	جَمَعَ الْحَدِيثُ
u'جَمْعٌ حَديثٌ':Added, #1: 1	جَمْعُ حَدِيثٍ
u'جَمَعَ حُرٌّ':Subject, #1: 1	جَمْعُ حَدِيثٍ
u'جَمَعَ حُرٌّ':Subject, #1: 1	جَمَعَ الْحُرُّ
u'جمع حُرٌّ':Added, #1: 1	جَمَعَ حُرٌّ
u'جَمْعٌ حُرٌّ':Added, #1: 1	جَمْعِ الْحُرَّتَيْنِ
u'جمع حُرٌّ':Added, #1: 1	جَمْعِ الْحُرَّتَيْنِ
u'جَمْعٌ حُرٌّ':Added, #1: 1	جَمْعُ حُرٍّ
u'جمع حَرامٌ':Added, #1: 1	جَمْعُ حُرٍّ
u'جَمْعٌ حَرامٌ':Added, #2: 2	جَمْعُ حَرَامٍ
u'جَمَعَ حُروفٌ':Predicate, #2: 2	جَمْعُ حَرَامٍ
u'جمع حُروفٌ':Added, #2: 2	جَمَعَ الْحُرُوفَ
u'جَمْعٌ حُروفٌ':Added, #5: 5	جَمْعُ الْحُرُوفِ
u'جمع حُرِّيَّةٌ':Added, #5: 5	جَمْعُ الْحُرُوفِ
u'جَمْعٌ حُرِّيَّةٌ':Added, #1: 1	جَمْعُ حُرِّيَّةِ
u'جمع حُرِّيَّةٌ':Added, #1: 1	جَمْعُ حُرِّيَّةِ
u'جَمْعٌ حُرِّيَّةٌ':Added, #3: 3	جَمْعُ الْحُرِّيَّةِ
u'جمع حَزَرِ':Added, #3: 3	جَمْعُ الْحُرِّيَّةِ
u'جمع حَزْر':Added, #1: 1	جَمْعُ حَزَرَةٍ
u'جَمْعٌ حَزَرِ':Added, #1: 1	جَمْعُ حَزْرَةٍ
u'جَمْعٌ حَزْر':Added, #1: 1	جَمْعُ حَزَرَةٍ
u'جمع حَزْنٌ':Added, #1: 1	جَمْعُ حَزْرَةٍ
u'جَمْعٌ حَزْنٌ':Added, #1: 1	جَمْعُ حَزْنٍ
u'جمع حَسَنٌ':Added, #1: 1	جَمْعُ حَزْنٍ
u'جَمْعٌ حَسَنٌ':Added, #1: 1	جَمْعُ حَسَنَةٍ
u'جمع حَسَنَةٌ':Added, #1: 1	جَمْعُ حَسَنَةٍ
u'جَمْعٌ حَسَنَةٌ':Added, #1: 1	جَمْعُ حَسَنَةٍ
u'جمع حَصِيدٌ':Added, #1: 1	جَمْعُ حَسَنَةٍ
u'جَمْعٌ حَصِيدٌ':Added, #1: 1	جَمْعُ حَصِيدٍ
u'جمع حَصِيدَةٌ':Added, #1: 1	جَمْعُ حَصِيدٍ
u'جَمْعٌ حَصِيدَةٌ':Added, #1: 1	جَمْعُ حَصِيدَةٍ
u'جمع حَصِيرٌ':Added, #1: 1	جَمْعُ حَصِيدَةٍ
u'جَمْعٌ حَصِيرٌ':Added, #1: 1	جَمْعُ الْحَصِيرِ
u'جمع حَقٌّ':Added, #1: 1	جَمْعُ الْحَصِيرِ
u'جَمْعٌ حَقٌّ':Added, #1: 1	جَمْعُ حَقِّ
u'جمع حَقٌّ':Added, #1: 1	جَمْعُ حَقِّ
u'جَمْعٌ حَقٌّ':Added, #2: 2	جَمْعُ حَقٍّ
u'جمع حَقْلَةٌ':Added, #2: 2	جَمْعُ حَقٍّ
u'جمع حَقْلَةٌ':Added, #1: 1	جَمْعُ حَقْلَةٍ
u'جَمْعٌ حَقْلَةٌ':Added, #1: 1	جَمْعِ حَقْلَةٍ
u'جَمْعٌ حَقْلَةٌ':Added, #1: 1	جَمْعُ حَقْلَةٍ
u'جمع حَقِيقٌ':Added, #1: 1	جَمْعِ حَقْلَةٍ
u'جَمْعٌ حَقِيقٌ':Added, #2: 2	جَمْعَ الْحَقِيقَةِ
u'جمع حَقِيقَةٌ':Added, #2: 2	جَمْعَ الْحَقِيقَةِ
u'جَمْعٌ حَقِيقَةٌ':Added, #1: 1	جَمْعَ حَقِيقَةٍ
u'جمع حَقِيقَةٌ':Added, #1: 1	جَمْعَ حَقِيقَةٍ
u'جَمْعٌ حَقِيقَةٌ':Added, #2: 2	جَمْعَ الْحَقِيقَةِ
u'جمع حكمة':Added, #2: 2	جَمْعَ الْحَقِيقَةِ
u'جَمْعٌ حكمة':Added, #1: 1	جَمْعُ حِكْمَةٍ
u'جمع حِكْمَةٌ':Added, #1: 1	جَمْعُ حِكْمَةٍ
u'جَمْعٌ حِكْمَةٌ':Added, #1: 1	جَمْعُ حِكْمَةٍ
u'جمع حِلْسٌ':Added, #1: 1	جَمْعُ حِكْمَةٍ
u'جَمْعٌ حِلْسٌ':Added, #1: 1	جَمْعُ حِلْسٍ
u'جمع حُلُمٌ':Added, #1: 1	جَمْعُ حِلْسٍ
u'جَمْعٌ حُلُمٌ':Added, #1: 1	جَمْعُ الْحُلُمِ
u'جمع حُلْمٌ':Added, #1: 1	جَمْعُ الْحُلُمِ
u'جمع حِلْمٌ':Added, #1: 1	جَمْعُ حُلْمٍ
u'جَمْعٌ حُلْمٌ':Added, #1: 1	جَمْعُ حِلْمٍ
u'جَمْعٌ حِلْمٌ':Added, #1: 1	جَمْعُ حُلْمٍ
u'جمع حَلَمَةٌ':Added, #1: 1	جَمْعُ حِلْمٍ
u'جَمْعٌ حَلَمَةٌ':Added, #1: 1	جَمْعُ حَلَمَةٍ
u'جمع حَلْيٌ':Added, #1: 1	جَمْعُ حَلَمَةٍ
u'جَمْعٌ حَلْيٌ':Added, #3: 3	جَمْعُ حَلْيٍ
u'جمع حِلْيَةٌ':Added, #3: 3	جَمْعُ حَلْيٍ
u'جَمْعٌ حِلْيَةٌ':Added, #1: 1	جَمْعُ حِلْيَةِ
u'جمع حَلِيلَةٌ':Added, #1: 1	جَمْعُ حِلْيَةِ
u'جَمْعٌ حَلِيلَةٌ':Added, #1: 1	جَمْعُ حَلِيلَةٍ
u'جمع حِمَارٌ':Added, #1: 1	جَمْعُ حَلِيلَةٍ
u'جَمْعٌ حِمَارٌ':Added, #1: 1	جَمْعُ حِمَارٍ
u'جمع حِمَالَةٌ':Added, #1: 1	جَمْعُ حِمَارٍ
u'جَمْعٌ حِمَالَةٌ':Added, #1: 1	جَمْعُ حِمَالَةٍ
u'جمع حَمَلٌ':Added, #1: 1	جَمْعُ حِمَالَةٍ
u'جَمْعٌ حَمَلٌ':Added, #1: 1	جَمْعُ حَمَلٍ
u'جمع حَمَلٌ':Added, #1: 1	جَمْعُ حَمَلٍ
u'جَمْعٌ حَمَلٌ':Added, #2: 2	جَمْعُ الْحَمَلِ
u'جمع حُمَمٌ':Added, #2: 2	جَمْعُ الْحَمَلِ
u'جَمْعٌ حُمَمٌ':Added, #1: 1	جَمْعُ حُمَمَةٍ
u'جمع حَوْصَلٌ':Added, #1: 1	جَمْعُ حُمَمَةٍ
u'جَمْعٌ حَوْصَلٌ':Added, #1: 1	جَمْعُ حَوْصَلَةٍ
u'جمع حَيْضَةٌ':Added, #1: 1	جَمْعُ حَوْصَلَةٍ
u'جَمْعٌ حَيْضَةٌ':Added, #1: 1	جَمْعُ حَيْضَةٍ
u'جمع خَاطِرٌ':Added, #1: 1	جَمْعُ حَيْضَةٍ
u'جَمْعٌ خَاطِرٌ':Added, #1: 1	جَمْعُ الْخَاطِرِ
u'جمع خَالٌ':Added, #1: 1	جَمْعُ الْخَاطِرِ
u'جَمْعٌ خَالٌ':Added, #1: 1	جَمْعُ خَالٍ
u'جمع خَالٌ':Added, #1: 1	جَمْعُ خَالٍ
u'جَمْعٌ خَالٌ':Added, #1: 1	جَمْعُ خَالَةٍ
u'جمع خَائِفٌ':Added, #1: 1	جَمْعُ خَالَةٍ
u'جمع خَائِفٌ':Added, #1: 1	جَمْعُ الْخَائِفِ
u'جَمْعٌ خَائِفٌ':Added, #1: 1	جَمْعِ الْخَائِفِ
u'جَمْعٌ خَائِفٌ':Added, #1: 1	جَمْعُ الْخَائِفِ
u'جمع خِبَاءٌ':Added, #1: 1	جَمْعِ الْخَائِفِ
u'جَمْعٌ خِبَاءٌ':Added, #1: 1	جَمْعُ خِبَاءٍ
u'جمع خبائث':Added, #1: 1	جَمْعُ خِبَاءٍ
u'جَمْعٌ خبائث':Added, #1: 1	جَمْعِ الْخَبَائِثِ
u'جمع خَبَائِثُ':Added, #1: 1	جَمْعِ الْخَبَائِثِ
u'جَمْعٌ خَبَائِثُ':Added, #1: 1	جَمْعِ الْخَبَائِثِ
u'جمع خَبَرٌ':Added, #1: 1	جَمْعِ الْخَبَائِثِ
u'جمع خَبَر':Added, #1: 1	جَمْعِ الْخَبَرِ
u'جَمْعٌ خَبَرٌ':Added, #1: 1	جَمْعِ الْخَبَرِ
u'جَمْعٌ خَبَر':Added, #1: 1	جَمْعِ الْخَبَرِ
u'جمع خَبِيث':Added, #1: 1	جَمْعِ الْخَبَرِ
u'جَمْعٌ خَبِيث':Added, #1: 1	جَمْعُ الْخَبِيثِ
u'جمع خَبِيث':Added, #1: 1	جَمْعُ الْخَبِيثِ
u'جَمْعٌ خَبِيث':Added, #1: 1	جَمْعُ خَبِيثِ
u'جمع خَبِيث':Added, #1: 1	جَمْعُ خَبِيثِ
u'جَمْعٌ خَبِيث':Added, #2: 2	جَمْعُ الْخَبِيثَةِ
u'جمع خِدْرٌ':Added, #2: 2	جَمْعُ الْخَبِيثَةِ
u'جَمْعٌ خِدْرٌ':Added, #1: 1	جَمْعُ خِدْرٍ
u'جَمَعَ خُرُوجٌ':Predicate, #1: 1	جَمْعُ خِدْرٍ
u'جمع خُرُوقٌ':Added, #1: 1	أَجْمَعَ الْخُرُوجَ
u'جَمْعٌ خُرُوقٌ':Added, #1: 1	جَمْعِ الْخُرُوقِ
u'جمع خَرِيطَةٌ':Added, #1: 1	جَمْعِ الْخُرُوقِ
u'جَمْعٌ خَرِيطَةٌ':Added, #1: 1	جَمْعُ خَرِيطَةٍ
u'جمع خَصِيٌّ':Added, #1: 1	جَمْعُ خَرِيطَةٍ
u'جَمْعٌ خَصِيٌّ':Added, #2: 2	جَمْعُ خَصِيٍّ
u'جمع خِصِّيص':Added, #2: 2	جَمْعُ خَصِيٍّ
u'جَمْعٌ خِصِّيص':Added, #1: 1	جَمْعُ خِصِّيصَةٍ
u'جمع خِلاَفٌ':Added, #1: 1	جَمْعُ خِصِّيصَةٍ
u'جَمْعٌ خِلاَفٌ':Added, #2: 2	جَمْعِ الْخِلَافِ
u'جمع خَلِيفَةٌ':Added, #2: 2	جَمْعِ الْخِلَافِ
u'جَمْعٌ خَلِيفَةٌ':Added, #1: 1	جَمْعُ خَلِيفَةٍ
u'جمع خَلِيقَةٌ':Added, #1: 1	جَمْعُ خَلِيفَةٍ
u'جَمْعٌ خَلِيقَةٌ':Added, #1: 1	جَمْعُ خَلِيقَةٍ
u'جَمَعَ خَوْفٌ':Predicate, #1: 1	جَمْعُ خَلِيقَةٍ
u'جَمَعَ خَيْرٌ':Predicate, #1: 1	جَمَعَ خَوْفَ
u'جمع خَيْشُومٌ':Added, #1: 1	أَجْمَعَ الْخَيْرَ
u'جَمْعٌ خَيْشُومٌ':Added, #1: 1	جَمْعُ خَيْشُومٍ
u'جمع دِثَارٌ':Added, #1: 1	جَمْعُ خَيْشُومٍ
u'جَمْعٌ دِثَارٌ':Added, #1: 1	جَمْعُ دِثَارٍ
u'جمع دَجاج':Added, #1: 1	جَمْعُ دِثَارٍ
u'جَمْعٌ دَجاج':Added, #1: 1	جَمْعُ دَجَاجَةٍ
u'جمع دَرَاهِمُ':Added, #1: 1	جَمْعُ دَجَاجَةٍ
u'جَمْعٌ دَرَاهِمُ':Added, #1: 1	جَمْعَ الدَّرَاهِمِ
u'جمع دَفْتَرٌ':Added, #1: 1	جَمْعَ الدَّرَاهِمِ
u'جَمْعٌ دَفْتَرٌ':Added, #1: 1	جَمْعُ دَفْتَرٍ
u'جمع دُمْيَةٌ':Added, #1: 1	جَمْعُ دَفْتَرٍ
u'جَمْعٌ دُمْيَةٌ':Added, #1: 1	جَمْعُ دُمْيَةٍ
u'جمع دُولابٌ':Added, #1: 1	جَمْعُ دُمْيَةٍ
u'جَمْعٌ دُولابٌ':Added, #1: 1	جَمْعُ دُولَابٍ
u'جَمَعَ دونٌ':Predicate, #1: 1	جَمْعُ دُولَابٍ
u'جمع دِيَةٌ':Added, #1: 1	جَمَعَ دُونَ
u'جَمْعٌ دِيَةٌ':Added, #1: 1	جَمْعَ الدِّيَةِ
u'جمع دِيَةٌ':Added, #1: 1	جَمْعَ الدِّيَةِ
u'جَمْعٌ دِيَةٌ':Added, #1: 1	جَمْعُ دِيَةٍ
u'جمع دِينٌ':Added, #1: 1	جَمْعُ دِيَةٍ
u'جَمْعٌ دِينٌ':Added, #1: 1	جَمْعُ دِينٍ
u'جمع دينَةٌ':Added, #1: 1	جَمْعُ دِينٍ
u'جَمْعٌ دينَةٌ':Added, #1: 1	جَمْعُ دِينَةٍ
u'جمع ذَبيحَةٌ':Added, #1: 1	جَمْعُ دِينَةٍ
u'جَمْعٌ ذَبيحَةٌ':Added, #6: 6	جَمْعُ ذَبِيحَةٍ
u'جمع ذَفيفٌ':Added, #6: 6	جَمْعُ ذَبِيحَةٍ
u'جَمْعٌ ذَفيفٌ':Added, #1: 1	جَمْعُ ذَفِيفٍ
u'جمع ذكر':Added, #1: 1	جَمْعُ ذَفِيفٍ
u'جَمْعٌ ذكر':Added, #1: 1	جَمْعُ الذَّكَرِ
u'جمع ذَكَرٌ':Added, #1: 1	جَمْعُ الذَّكَرِ
u'جَمْعٌ ذَكَرٌ':Added, #1: 1	جَمْعُ الذَّكَرِ
u'جمع ذكرة':Added, #1: 1	جَمْعُ الذَّكَرِ
u'جَمْعٌ ذكرة':Added, #1: 1	جَمْعُ ذِكْرَةٍ
u'جمع ذُكورٌ':Added, #1: 1	جَمْعُ ذِكْرَةٍ
u'جَمْعٌ ذُكورٌ':Added, #1: 1	جَمْعُ الذُّكُورِ
u'جمع ذُكورٌ':Added, #1: 1	جَمْعُ الذُّكُورِ
u'جَمْعٌ ذُكورٌ':Added, #3: 3	جَمْعَ الذُّكُورِ
u'جمع ذُهُوبٌ':Added, #3: 3	جَمْعَ الذُّكُورِ
u'جمع ذُهُوبٌ':Added, #1: 1	جَمْعُ الذُّهُوبِ
u'جَمْعٌ ذُهُوبٌ':Added, #1: 1	جَمْعِ الذُّهُوبِ
u'جَمْعٌ ذُهُوبٌ':Added, #1: 1	جَمْعُ الذُّهُوبِ
u'جمع ذُؤابَةٌ':Added, #1: 1	جَمْعِ الذُّهُوبِ
u'جَمْعٌ ذُؤابَةٌ':Added, #1: 1	جَمْعُ ذُؤَابَةٍ
u'جمع رَاشِدٌ':Added, #1: 1	جَمْعُ ذُؤَابَةٍ
u'جَمْعٌ رَاشِدٌ':Added, #1: 1	جَمْعُ رَاشِدٍ
u'جمع رَاكِبٌ':Added, #1: 1	جَمْعُ رَاشِدٍ
u'جَمْعٌ رَاكِبٌ':Added, #1: 1	جَمْعِ رَاكِبٍ
u'جمع رَاكِبٌ':Added, #1: 1	جَمْعِ رَاكِبٍ
u'جَمْعٌ رَاكِبٌ':Added, #4: 4	جَمْعُ رَاكِبٍ
u'جمع رَبِيئَةٌ':Added, #4: 4	جَمْعُ رَاكِبٍ
u'جَمْعٌ رَبِيئَةٌ':Added, #1: 1	جَمْعِ رَبِيئَةٍ
u'جمع رَتْق':Added, #1: 1	جَمْعِ رَبِيئَةٍ
u'جَمْعٌ رَتْق':Added, #1: 1	جَمْعُ رَتْقَةٍ
u'جمع رَتِيمَة':Added, #1: 1	جَمْعُ رَتْقَةٍ
u'جَمْعٌ رَتِيمَة':Added, #1: 1	جَمْعُ رَتِيمَةٍ
u'جمع رِجَالٌ':Added, #1: 1	جَمْعُ رَتِيمَةٍ
u'جمع رِجَالٌ':Added, #1: 1	جَمْعَ الرِّجَالِ
u'جمع رِجَالٌ':Added, #1: 1	جَمْعُ الرِّجَالِ
u'جَمْعٌ رِجَالٌ':Added, #1: 1	جَمْعِ الرِّجَالِ
u'جَمْعٌ رِجَالٌ':Added, #1: 1	جَمْعَ الرِّجَالِ
u'جَمْعٌ رِجَالٌ':Added, #1: 1	جَمْعُ الرِّجَالِ
u'جَمَعَ رَجُلٌ':Subject, #1: 1	جَمْعِ الرِّجَالِ
u'جمع رَجُلٌ':Added, #4: 4	جَمَعَ رَجُلٌ
u'جمع رَجْلٌ':Added, #1: 1	جَمْعِ الرَّجُلِ
u'جمع رِجْلٌ':Added, #1: 1	جَمْعُ الرّجْلِ
u'جَمْعٌ رَجُلٌ':Added, #1: 1	جَمْعُ الرّجْلِ
u'جَمْعٌ رَجْلٌ':Added, #1: 1	جَمْعِ الرَّجُلِ
u'جَمْعٌ رِجْلٌ':Added, #1: 1	جَمْعُ الرّجْلِ
u'جمع رَجُلٌ':Added, #1: 1	جَمْعُ الرّجْلِ
u'جمع رَجُلٌ':Added, #1: 1	جَمْعُ رَجُلٍ
u'جَمْعٌ رَجُلٌ':Added, #1: 1	جَمْعِ رَجُلٍ
u'جَمْعٌ رَجُلٌ':Added, #1: 1	جَمْعُ رَجُلٍ
u'جَمْعٌ رِجْلٌ':Added, #1: 1	جَمْعِ رَجُلٍ
u'جمع رَجُلٌ':Added, #1: 1	جَمْعٍ رِجْلٍ
u'جَمْعٌ رَجُلٌ':Added, #4: 4	جَمْعِ الرَّجُلَيْنِ
u'جمع رجلة':Added, #4: 4	جَمْعِ الرَّجُلَيْنِ
u'جَمْعٌ رجلة':Added, #1: 1	جَمْعُ رَجْلَةٍ
u'جمع رَجَمٌ':Added, #1: 1	جَمْعُ رَجْلَةٍ
u'جَمْعٌ رَجَمٌ':Added, #1: 1	جَمْعُ رَجَمٍ
u'جمع رُجْمَةٌ':Added, #1: 1	جَمْعُ رَجَمٍ
u'جَمْعٌ رُجْمَةٌ':Added, #1: 1	جَمْعُ رُجْمَةٍ
u'جمع رحم':Added, #1: 1	جَمْعُ رُجْمَةٍ
u'جَمْعٌ رحم':Added, #1: 1	جَمْعِ الرَّحِمِ
u'جمع رَحِمٌ':Added, #1: 1	جَمْعِ الرَّحِمِ
u'جَمْعٌ رَحِمٌ':Added, #1: 1	جَمْعِ الرَّحِمِ
u'جمع رَحِمٌ':Added, #1: 1	جَمْعِ الرَّحِمِ
u'جَمْعٌ رَحِمٌ':Added, #1: 1	جَمْعُ رَحِمٍ
u'جمع رُخْصَةٌ':Added, #1: 1	جَمْعُ رَحِمٍ
u'جَمْعٌ رُخْصَةٌ':Added, #1: 1	جَمْعُ رُخْصَةٍ
u'جمع رِسَالَةٌ':Added, #1: 1	جَمْعُ رُخْصَةٍ
u'جَمْعٌ رِسَالَةٌ':Added, #1: 1	جَمْعِ الرِّسَالَةِ
u'جَمَعَ رَسُولٌ':Subject, #1: 1	جَمْعِ الرِّسَالَةِ
u'جمع رشق':Added, #21: 21	جَمَعَ رَسُولُ
u'جَمْعٌ رشق':Added, #1: 1	جَمْعُ رَشْقٍ
u'جَمَعَ رَشيدٌ':Subject, #1: 1	جَمْعُ رَشْقٍ
u'جمع رَطْبَةٌ':Added, #1: 1	جَمَعَ الرَّشِيدُ
u'جَمْعٌ رَطْبَةٌ':Added, #2: 2	جَمْعُ رَطْبَةٍ
u'جمع رَغيبَةٌ':Added, #2: 2	جَمْعُ رَطْبَةٍ
u'جَمْعٌ رَغيبَةٌ':Added, #2: 2	جَمْعُ رَغِيبَةٍ
u'جمع رَغيفٌ':Added, #2: 2	جَمْعُ رَغِيبَةٍ
u'جَمْعٌ رَغيفٌ':Added, #1: 1	جَمْعُ رَغِيفٍ
u'جمع رفقة':Added, #1: 1	جَمْعُ رَغِيفٍ
u'جَمْعٌ رفقة':Added, #1: 1	جَمْعُ رُفْقَةٍ
u'جمع رُفْقَةٌ':Added, #1: 1	جَمْعُ رُفْقَةٍ
u'جَمْعٌ رُفْقَةٌ':Added, #1: 1	جَمْعُ رُفْقَةٍ
u'جمع رِقَّةٌ':Added, #1: 1	جَمْعُ رُفْقَةٍ
u'جَمْعٌ رِقَّةٌ':Added, #1: 1	جَمْعِ الرّقّةِ
u'جمع رُقْعَةٌ':Added, #1: 1	جَمْعِ الرّقّةِ
u'جَمْعٌ رُقْعَةٌ':Added, #1: 1	جَمْعُ رُقْعَةٍ
u'جمع رُقْيَةٌ':Added, #1: 1	جَمْعُ رُقْعَةٍ
u'جَمْعٌ رُقْيَةٌ':Added, #2: 2	جَمْعُ رُقْيَةٍ
u'جمع رَهْنٌ':Added, #2: 2	جَمْعُ رُقْيَةٍ
u'جَمْعٌ رَهْنٌ':Added, #4: 4	جَمْعُ رَهْنٍ
u'جمع روحٌ':Added, #4: 4	جَمْعُ رَهْنٍ
u'جَمْعٌ روحٌ':Added, #1: 1	جَمْعُ رُوحٍ
u'جمع رَوْضَةٌ':Added, #1: 1	جَمْعُ رُوحٍ
u'جَمْعٌ رَوْضَةٌ':Added, #1: 1	جَمْعُ رَوْضَةٍ
u'جمع رُومِيٌّ':Added, #1: 1	جَمْعُ رَوْضَةٍ
u'جَمْعٌ رُومِيٌّ':Added, #2: 2	جَمْعُ الرُّومِيِّ
u'جمع رِيشَةٌ':Added, #2: 2	جَمْعُ الرُّومِيِّ
u'جَمْعٌ رِيشَةٌ':Added, #1: 1	جَمْعُ الرِّيشَةِ
u'جمع زائِدٌ':Added, #1: 1	جَمْعُ الرِّيشَةِ
u'جَمْعٌ زائِدٌ':Added, #2: 2	جَمْعُ زَائِدَةٍ
u'جمع زُجٌّ':Added, #2: 2	جَمْعُ زَائِدَةٍ
u'جَمْعٌ زُجٌّ':Added, #1: 1	جَمْعُ زُجٍّ
u'جمع زَريعَةٌ':Added, #1: 1	جَمْعُ زُجٍّ
u'جَمْعٌ زَريعَةٌ':Added, #1: 1	جَمْعُ زَرِيعَةٍ
u'جَمَعَ زَلَلٌ':Predicate, #1: 1	جَمْعُ زَرِيعَةٍ
u'جمع زِمامٌ':Added, #3: 3	جَمَعَ زَلَلَ
u'جَمْعٌ زِمامٌ':Added, #1: 1	جَمْعُ زِمَامٍ
u'جَمَعَ زَنابيرُ':Predicate, #1: 1	جَمْعُ زِمَامٍ
u'جَمَعَ زَوْجٌ':Subject, #1: 1	جَمَعَ الزَّنَابِيرَ
u'جمع زَوْجَةٌ':Added, #2: 2	جَمَعَ الزَّوْجُ
u'جَمْعٌ زَوْجَةٌ':Added, #1: 1	جَمْعِ الزَّوْجَةِ
u'جَمَعَ زَيْدٌ':Subject, #1: 1	جَمْعِ الزَّوْجَةِ
u'جَمَعَ زِينَةٌ':Predicate, #1: 1	جَمَعَ زَيْدٌ
u'جمع سَاحَةٌ':Added, #1: 1	جَمَعَ الزِّينَةَ
u'جَمْعٌ سَاحَةٌ':Added, #1: 1	جَمْعُ سَاحَةٍ
u'جمع سَارِبٌ':Added, #1: 1	جَمْعُ سَاحَةٍ
u'جَمْعٌ سَارِبٌ':Added, #1: 1	جَمْعُ سَارِبٍ
u'جَمَعَ سَارِقٌ':Subject, #1: 1	جَمْعُ سَارِبٍ
u'جمع سَافِرٌ':Added, #1: 1	جَمَعَ السَّارِقُ
u'جَمْعٌ سَافِرٌ':Added, #1: 1	جَمْعُ سَافِرٍ
u'جمع سَاقٌ':Added, #1: 1	جَمْعُ سَافِرٍ
u'جَمْعٌ سَاقٌ':Added, #1: 1	جَمْعُ سَاقٍ
u'جمع سَاقِي':Added, #1: 1	جَمْعُ سَاقٍ
u'جَمْعٌ سَاقِي':Added, #1: 1	جَمْعُ السَّاقِيَةِ
u'جمع سَاقِي':Added, #1: 1	جَمْعُ السَّاقِيَةِ
u'جَمْعٌ سَاقِي':Added, #1: 1	جَمْعُ سَاقِيَةٍ
u'جمع سَاقِيَةٌ':Added, #1: 1	جَمْعُ سَاقِيَةٍ
u'جَمْعٌ سَاقِيَةٌ':Added, #1: 1	جَمْعُ السَّاقِيَةِ
u'جمع سَاقِيَةٌ':Added, #1: 1	جَمْعُ السَّاقِيَةِ
u'جَمْعٌ سَاقِيَةٌ':Added, #1: 1	جَمْعُ سَاقِيَةٍ
u'جمع سَامِرٌ':Added, #1: 1	جَمْعُ سَاقِيَةٍ
u'جَمْعٌ سَامِرٌ':Added, #1: 1	جَمْعُ سَامِرٍ
u'جَمَعَ سائِل':Subject, #1: 1	جَمْعُ سَامِرٍ
u'جَمَعَ سَائِلٌ':Subject, #1: 1	جَمَعَ السَّائِلُ
u'جمع سَائِمَةٌ':Added, #1: 1	جَمَعَ السَّائِلُ
u'جَمْعٌ سَائِمَةٌ':Added, #2: 2	جَمْعُ سَائِمَةٍ
u'جمع سَبَبٌ':Added, #2: 2	جَمْعُ سَائِمَةٍ
u'جَمْعٌ سَبَبٌ':Added, #1: 1	جَمْعُ سَبَبٍ
u'جمع سَبْتٌ':Added, #1: 1	جَمْعُ سَبَبٍ
u'جَمْعٌ سَبْتٌ':Added, #1: 1	جَمْعُ السَّبْتِ
u'جَمَعَ سَبْعٌ':Predicate, #1: 1	جَمْعُ السَّبْتِ
u'جمع سَبُعٌ':Added, #1: 1	جَمَعَ سَبْعَ
u'جَمْعٌ سَبُعٌ':Added, #1: 1	جَمْعُ سَبُعٍ
u'جَمَعَ سَبْعَةٌ':Predicate, #1: 1	جَمْعُ سَبُعٍ
u'جمع سَبِيلٌ':Added, #1: 1	جَمَعَ سَبْعَةَ
u'جَمْعٌ سَبِيلٌ':Added, #1: 1	جَمْعُ سَبِيلٍ
u'جمع سِجِلٌّ':Added, #1: 1	جَمْعُ سَبِيلٍ
u'جَمْعٌ سِجِلٌّ':Added, #1: 1	جَمْعُ سِجِلٍّ
u'جَمَعَ سِجْنٌ':Subject, #1: 1	جَمْعُ سِجِلٍّ
u'جمع سَحابَةٌ':Added, #1: 1	جَمَعَ السِّجْنُ
u'جَمْعٌ سَحابَةٌ':Added, #1: 1	جَمْعُ سَحَابَةٍ
u'جمع سَحَرٌ':Added, #1: 1	جَمْعُ سَحَابَةٍ
u'جَمْعٌ سَحَرٌ':Added, #1: 1	جَمْعُ سَحَرٍ
u'جمع سَرَاةٌ':Added, #1: 1	جَمْعُ سَحَرٍ
u'جَمْعٌ سَرَاةٌ':Added, #1: 1	جَمْعِ سَرَاةٍ
u'جمع سَرَبٌ':Added, #1: 1	جَمْعِ سَرَاةٍ
u'جَمْعٌ سَرَبٌ':Added, #1: 1	جَمْعُ سَرَبٍ
u'جمع سِرْحان':Added, #1: 1	جَمْعُ سَرَبٍ
u'جَمْعٌ سِرْحان':Added, #1: 1	جَمْعُ سِرْحَانٍ
u'جمع سَرِيٌّ':Added, #1: 1	جَمْعُ سِرْحَانٍ
u'جَمْعٌ سَرِيٌّ':Added, #1: 1	جَمْعُ السَّرِيِّ
u'جمع سَرِيرٌ':Added, #1: 1	جَمْعُ السَّرِيِّ
u'جَمْعٌ سَرِيرٌ':Added, #2: 2	جَمْعُ سَرِيرٍ
u'جمع سَفَرٌ':Added, #2: 2	جَمْعُ سَرِيرٍ
u'جَمْعٌ سَفَرٌ':Added, #3: 3	جَمْعِ السَّفَرِ
u'جمع سلاب':Added, #3: 3	جَمْعِ السَّفَرِ
u'جَمْعٌ سلاب':Added, #1: 1	جَمْعُ سِلَابٍ
u'جمع سِلاَبٌ':Added, #1: 1	جَمْعُ سِلَابٍ
u'جَمْعٌ سِلاَبٌ':Added, #1: 1	جَمْعُ سِلَابٍ
u'جمع سَلاَمَةٌ':Added, #1: 1	جَمْعُ سِلَابٍ
u'جَمْعٌ سَلاَمَةٌ':Added, #1: 1	جَمْعِ السَّلَامَةِ
u'جمع سَلاَمَةٌ':Added, #1: 1	جَمْعِ السَّلَامَةِ
u'جَمْعٌ سَلاَمَةٌ':Added, #1: 1	جَمْعِ سَلَامَةٍ
u'جمع سَلاَمَةٌ':Added, #1: 1	جَمْعِ سَلَامَةٍ
u'جَمْعٌ سَلاَمَةٌ':Added, #2: 2	جَمْعُ السَّلَامَةِ
u'جمع سَلاَمَةٌ':Added, #2: 2	جَمْعُ السَّلَامَةِ
u'جَمْعٌ سَلاَمَةٌ':Added, #3: 3	جَمْعَ السَّلَامَةِ
u'جمع سَمٌّ':Added, #3: 3	جَمْعَ السَّلَامَةِ
u'جَمْعٌ سَمٌّ':Added, #1: 1	جَمْعُ سَمٍّ
u'جمع سَمَاءٌ':Added, #1: 1	جَمْعُ سَمٍّ
u'جَمْعٌ سَمَاءٌ':Added, #1: 1	جَمْعِ السّمَاءِ
u'جَمَعَ سَمَكٌ':Predicate, #1: 1	جَمْعِ السّمَاءِ
u'جمع سُنَّةٌ':Added, #1: 1	جَمَعَ السَّمَكَ
u'جمع سُنَّةٌ':Added, #1: 1	جَمْعُ سُنَّةٍ
u'جَمْعٌ سُنَّةٌ':Added, #1: 1	جَمْعُ سُنَّةِ
u'جَمْعٌ سُنَّةٌ':Added, #1: 1	جَمْعُ سُنَّةٍ
u'جمع سَنَةٌ':Added, #1: 1	جَمْعُ سُنَّةِ
u'جَمْعٌ سَنَةٌ':Added, #2: 2	جَمْعُ سَنَةٍ
u'جَمَعَ سنن':Predicate, #2: 2	جَمْعُ سَنَةٍ
u'جمع سَهْمٌ':Added, #2: 2	جَمَعَ السُّنَنَ
u'جَمْعٌ سَهْمٌ':Added, #1: 1	جَمْعُ سَهْمٍ
u'جَمَعَ سورٌ':Subject, #1: 1	جَمْعُ سَهْمٍ
u'جمع سورٌ':Added, #1: 1	جَمَعَ السُّورُ
u'جَمْعٌ سورٌ':Added, #1: 1	جَمْعِ سُوَرٍ
u'جمع سورٌ':Added, #1: 1	جَمْعِ سُوَرٍ
u'جَمْعٌ سورٌ':Added, #1: 1	جَمْعُ سُورَتَيْنِ
u'جمع سُورَةٌ':Added, #1: 1	جَمْعُ سُورَتَيْنِ
u'جَمْعٌ سُورَةٌ':Added, #1: 1	جَمْعُ سُورَةٍ
u'جَمَعَ سَيْرٌ':Predicate, #1: 1	جَمْعُ سُورَةٍ
u'جمع سيرَةٌ':Added, #1: 1	أَجْمَعَ السّيْرَ
u'جَمْعٌ سيرَةٌ':Added, #5: 5	جَمْعُ سِيرَةٍ
u'جمع شَارِدٌ':Added, #5: 5	جَمْعُ سِيرَةٍ
u'جَمْعٌ شَارِدٌ':Added, #1: 1	جَمْعُ شَارِدَةٍ
u'جَمَعَ شَارِعٌ':Subject, #1: 1	جَمْعُ شَارِدَةٍ
u'جَمَعَ شَاعِر':Subject, #1: 1	جَمَعَ الشَّارِعُ
u'جَمَعَ شافِعِيّ':Subject, #1: 1	جَمَعَ الشّاعِرُ
u'جمع شَتِيتٌ':Added, #1: 1	جَمَعَ الشَّافِعِيُّ
u'جَمْعٌ شَتِيتٌ':Added, #2: 2	جَمْعُ شَتِيتٍ
u'جَمَعَ شجَاعٌ':Predicate, #2: 2	جَمْعُ شَتِيتٍ
u'جَمَعَ شَجَاعَةٌ':Predicate, #1: 1	جَمَعَ الشَّجَاعَةَ
u'جمع شَجَّةٌ':Added, #1: 1	جَمَعَ الشَّجَاعَةَ
u'جَمْعٌ شَجَّةٌ':Added, #1: 1	جَمْعُ شَجَّةٍ
u'جمع شَرَابٌ':Added, #1: 1	جَمْعُ شَجَّةٍ
u'جَمْعٌ شَرَابٌ':Added, #4: 4	جَمْعُ شَرَابٍ
u'جمع شراك':Added, #4: 4	جَمْعُ شَرَابٍ
u'جَمْعٌ شراك':Added, #1: 1	جَمْعُ شِرَاكٍ
u'جمع شِرَاكٌ':Added, #1: 1	جَمْعُ شِرَاكٍ
u'جَمْعٌ شِرَاكٌ':Added, #1: 1	جَمْعُ شِرَاكٍ
u'جمع شَرَج':Added, #1: 1	جَمْعُ شِرَاكٍ
u'جَمْعٌ شَرَج':Added, #1: 1	جَمْعُ شَرَجَةٍ
u'جمع شَرْطٌ':Added, #1: 1	جَمْعُ شَرَجَةٍ
u'جَمْعٌ شَرْطٌ':Added, #4: 4	جَمْعُ شَرْطٍ
u'جمع شُرْطِيٌّ':Added, #4: 4	جَمْعُ شَرْطٍ
u'جَمْعٌ شُرْطِيٌّ':Added, #1: 1	جَمْعُ شُرْطِيٍّ
u'جمع شرف':Added, #1: 1	جَمْعُ شُرْطِيٍّ
u'جَمْعٌ شرف':Added, #1: 1	جَمْعُ شَرَفٍ
u'جمع شَرَفٌ':Added, #1: 1	جَمْعُ شَرَفٍ
u'جَمْعٌ شَرَفٌ':Added, #1: 1	جَمْعُ شَرَفٍ
u'جمع شُرْفَةٌ':Added, #1: 1	جَمْعُ شَرَفٍ
u'جَمْعٌ شُرْفَةٌ':Added, #1: 1	جَمْعُ شُرْفَةٍ
u'جمع شركة':Added, #1: 1	جَمْعُ شُرْفَةٍ
u'جَمْعٌ شركة':Added, #1: 1	جَمْعُ شِرْكَةٍ
u'جمع شِرْكَةٌ':Added, #1: 1	جَمْعُ شِرْكَةٍ
u'جَمْعٌ شِرْكَةٌ':Added, #1: 1	جَمْعُ شِرْكَةٍ
u'جَمَعَ شُرُوطٌ':Predicate, #1: 1	جَمْعُ شِرْكَةٍ
u'جمع شَرِيطَةٌ':Added, #1: 1	جَمَعَ الشُّرُوطَ
u'جَمْعٌ شَرِيطَةٌ':Added, #1: 1	جَمْعُ شَرِيطَةٍ
u'جمع شَرِيعَةٌ':Added, #1: 1	جَمْعُ شَرِيطَةٍ
u'جَمْعٌ شَرِيعَةٌ':Added, #2: 2	جَمْعُ شَرِيعَةٍ
u'جمع شَعْبٌ':Added, #2: 2	جَمْعُ شَرِيعَةٍ
u'جَمْعٌ شَعْبٌ':Added, #1: 1	جَمْعُ شَعْبٍ
u'جمع شَعْرٌ':Added, #1: 1	جَمْعُ شَعْبٍ
u'جَمْعٌ شَعْرٌ':Added, #2: 2	جَمْعُ الشَّعْرِ
u'جمع شَعِيرَةٌ':Added, #2: 2	جَمْعُ الشَّعْرِ
u'جمع شَعِيرَة':Added, #2: 2	جَمْعُ شَعِيرَةٍ
u'جَمْعٌ شَعِيرَةٌ':Added, #2: 2	جَمْعُ شَعِيرَةٍ
u'جَمْعٌ شَعِيرَة':Added, #2: 2	جَمْعُ شَعِيرَةٍ
u'جمع شُفْرٌ':Added, #2: 2	جَمْعُ شَعِيرَةٍ
u'جَمْعٌ شُفْرٌ':Added, #1: 1	جَمْعُ شُفْرٍ
u'جمع شَكْلٌ':Added, #1: 1	جَمْعُ شُفْرٍ
u'جَمْعٌ شَكْلٌ':Added, #1: 1	جَمْعُ شَكْلٍ
u'جمع شَهَادَةٌ':Added, #1: 1	جَمْعُ شَكْلٍ
u'جَمْعٌ شَهَادَةٌ':Added, #1: 1	جَمْعُ شَهَادَةٍ
u'جمع شَهِيدٌ':Added, #1: 1	جَمْعُ شَهَادَةٍ
u'جَمْعٌ شَهِيدٌ':Added, #2: 2	جَمْعِ الشَّهِيدِ
u'جمع شَوْطٌ':Added, #2: 2	جَمْعِ الشَّهِيدِ
u'جَمْعٌ شَوْطٌ':Added, #1: 1	جَمْعُ شَوْطٍ
u'جَمَعَ شَيْخٌ':Subject, #1: 1	جَمْعُ شَوْطٍ
u'جمع شَيْخٌ':Added, #2: 2	جَمَعَ الشَّيْخُ
u'جَمْعٌ شَيْخٌ':Added, #1: 1	جَمْعِ الشَّيْخِ
u'جَمَعَ صَاحِبٌ':Subject, #1: 1	جَمْعِ الشَّيْخِ
u'جمع صَاحِبٌ':Added, #2: 2	جَمَعَ صَاحِبُ
u'جَمْعٌ صَاحِبٌ':Added, #1: 1	جَمْعُ صَاحِبٍ
u'جمع صَاعٌ':Added, #1: 1	جَمْعُ صَاحِبٍ
u'جَمْعٌ صَاعٌ':Added, #1: 1	جَمْعُ صَاعٍ
u'جمع صَافِي':Added, #1: 1	جَمْعُ صَاعٍ
u'جَمْعٌ صَافِي':Added, #1: 1	جَمْعُ صَافِيَةٍ
u'جمع صَانِعٌ':Added, #1: 1	جَمْعُ صَافِيَةٍ
u'جَمْعٌ صَانِعٌ':Added, #1: 1	جَمْعُ صَانِعٍ
u'جمع صَائِغٌ':Added, #1: 1	جَمْعُ صَانِعٍ
u'جَمْعٌ صَائِغٌ':Added, #1: 1	جَمْعُ صَائِغٍ
u'جمع صَائِمٌ':Added, #1: 1	جَمْعُ صَائِغٍ
u'جمع صَائِمٌ':Added, #1: 1	جَمْعُ صَائِمٍ
u'جَمْعٌ صَائِمٌ':Added, #1: 1	جَمْعِ صَائِمٍ
u'جَمْعٌ صَائِمٌ':Added, #1: 1	جَمْعُ صَائِمٍ
u'جمع صَبَب':Added, #1: 1	جَمْعِ صَائِمٍ
u'جَمْعٌ صَبَب':Added, #1: 1	جَمْعُ صَبَبٍ
u'جَمَعَ صَحَابَةٌ':Predicate, #1: 1	جَمْعُ صَبَبٍ
u'جمع صَحَابَةٌ':Added, #2: 2	جَمَعَ الصَّحَابَةَ
u'جَمْعٌ صَحَابَةٌ':Added, #1: 1	جَمْعِ الصَّحَابَةِ
u'جمع صَحْبٌ':Added, #1: 1	جَمْعِ الصَّحَابَةِ
u'جَمْعٌ صَحْبٌ':Added, #1: 1	جَمْعُ صَحْبٍ
u'جمع صِحَّةٌ':Added, #1: 1	جَمْعُ صَحْبٍ
u'جَمْعٌ صِحَّةٌ':Added, #1: 1	جَمْعِ الصِّحَّةِ
u'جمع صَحِيحٌ':Added, #1: 1	جَمْعِ الصِّحَّةِ
u'جَمْعٌ صَحِيحٌ':Added, #1: 1	جَمْعِ الصَّحِيحَيْنِ
u'جمع صَحِيفَةٌ':Added, #1: 1	جَمْعِ الصَّحِيحَيْنِ
u'جَمْعٌ صَحِيفَةٌ':Added, #2: 2	جَمْعُ صَحِيفَةٍ
u'جمع صَدَأٌ':Added, #2: 2	جَمْعُ صَحِيفَةٍ
u'جَمْعٌ صَدَأٌ':Added, #1: 1	جَمْعُ صَدَأِ
u'جمع صَدَقَةٌ':Added, #1: 1	جَمْعُ صَدَأِ
u'جَمْعٌ صَدَقَةٌ':Added, #1: 1	جَمْعِ الصَّدَقَاتِ
u'جمع صدقة':Added, #1: 1	جَمْعِ الصَّدَقَاتِ
u'جَمْعٌ صدقة':Added, #1: 1	جَمْعِ الصَّدَقَةِ
u'جمع صَدَقَةٌ':Added, #1: 1	جَمْعِ الصَّدَقَةِ
u'جَمْعٌ صَدَقَةٌ':Added, #1: 1	جَمْعِ الصَّدَقَةِ
u'جمع صدقة':Added, #1: 1	جَمْعِ الصَّدَقَةِ
u'جَمْعٌ صدقة':Added, #1: 1	جَمْعِ صَدَقَةِ
u'جمع صَدَقَةٌ':Added, #1: 1	جَمْعِ صَدَقَةِ
u'جَمْعٌ صَدَقَةٌ':Added, #1: 1	جَمْعِ صَدَقَةِ
u'جمع صَغِيرٌ':Added, #1: 1	جَمْعِ صَدَقَةِ
u'جَمْعٌ صَغِيرٌ':Added, #1: 1	جَمْعُ صَغِيرَةٍ
u'جمع صِفَةٌ':Added, #1: 1	جَمْعُ صَغِيرَةٍ
u'جَمْعٌ صِفَةٌ':Added, #1: 1	جَمْعُ صِفَةٍ
u'جمع صَفْحٌ':Added, #1: 1	جَمْعُ صِفَةٍ
u'جَمْعٌ صَفْحٌ':Added, #1: 1	جَمْعُ صَفْحٍ
u'جمع صُقْعٌ':Added, #1: 1	جَمْعُ صَفْحٍ
u'جَمْعٌ صُقْعٌ':Added, #1: 1	جَمْعُ صُقْعٍ
u'جمع صَلاَةٌ':Added, #1: 1	جَمْعُ صُقْعٍ
u'جَمْعٌ صَلاَةٌ':Added, #1: 1	جَمْعِ الصَّلَاةِ
u'جمع صِلَةٌ':Added, #1: 1	جَمْعِ الصَّلَاةِ
u'جَمْعٌ صِلَةٌ':Added, #1: 1	جَمْعُ صِلَةٍ
u'جمع صَمْدٌ':Added, #1: 1	جَمْعُ صِلَةٍ
u'جَمْعٌ صَمْدٌ':Added, #1: 1	جَمْعُ صَمْدٍ
u'جمع صَنْجٌ':Added, #1: 1	جَمْعُ صَمْدٍ
u'جَمْعٌ صَنْجٌ':Added, #1: 1	جَمْعُ صَنْجٍ
u'جمع صَنْج':Added, #1: 1	جَمْعُ صَنْجٍ
u'جَمْعٌ صَنْج':Added, #2: 2	جَمْعُ صَنْجَةٍ
u'جمع صَوْتٌ':Added, #2: 2	جَمْعُ صَنْجَةٍ
u'جَمْعٌ صَوْتٌ':Added, #1: 1	جَمْعُ الصَّوْتِ
u'جمع صَوْتٌ':Added, #1: 1	جَمْعُ الصَّوْتِ
u'جَمْعٌ صَوْتٌ':Added, #2: 2	جَمْعِ الصَّوْتِ
u'جمع صُورٌ':Added, #2: 2	جَمْعِ الصَّوْتِ
u'جمع صُوَرٌ':Added, #1: 1	جَمْعُ صُورٍ
u'جَمْعٌ صُورٌ':Added, #1: 1	جَمْعُ صُورٍ
u'جَمْعٌ صُوَرٌ':Added, #1: 1	جَمْعُ صُورٍ
u'جَمَعَ صِيَامٌ':Predicate, #1: 1	جَمْعُ صُورٍ
u'جمع ضَاحِي':Added, #1: 1	أَجْمَعَ الصِّيَامَ
u'جَمْعٌ ضَاحِي':Added, #1: 1	جَمْعُ ضَاحِيَةٍ
u'جمع ضَاحِيَة':Added, #1: 1	جَمْعُ ضَاحِيَةٍ
u'جَمْعٌ ضَاحِيَة':Added, #1: 1	جَمْعُ ضَاحِيَةٍ
u'جمع ضَارِبٌ':Added, #1: 1	جَمْعُ ضَاحِيَةٍ
u'جَمْعٌ ضَارِبٌ':Added, #1: 1	جَمْعِ ضَارِبَةٍ
u'جمع ضَائِنٌ':Added, #1: 1	جَمْعِ ضَارِبَةٍ
u'جَمْعٌ ضَائِنٌ':Added, #1: 1	جَمْعُ ضَائِنٍ
u'جمع ضَبَّةٌ':Added, #1: 1	جَمْعُ ضَائِنٍ
u'جَمْعٌ ضَبَّةٌ':Added, #1: 1	جَمْعُ ضَبَّةٍ
u'جمع ضَحِيَّةٌ':Added, #1: 1	جَمْعُ ضَبَّةٍ
u'جَمْعٌ ضَحِيَّةٌ':Added, #2: 2	جَمْعُ ضَحِيَّةٍ
u'جمع ضِدٌّ':Added, #2: 2	جَمْعُ ضَحِيَّةٍ
u'جَمْعٌ ضِدٌّ':Added, #1: 1	جَمْعِ الضِّدَّيْنِ
u'جمع ضَرِيبَةٌ':Added, #1: 1	جَمْعِ الضِّدَّيْنِ
u'جَمْعٌ ضَرِيبَةٌ':Added, #1: 1	جَمْعَ ضَرِيبَةٍ
u'جَمَعَ ضِعْفٌ':Predicate, #1: 1	جَمْعَ ضَرِيبَةٍ
u'جمع ضِعْفٌ':Added, #1: 1	جَمَعَ الضّعْفَ
u'جَمْعٌ ضِعْفٌ':Added, #1: 1	جَمْعُ ضِعْفٍ
u'جمع ضِفْدَعٌ':Added, #1: 1	جَمْعُ ضِعْفٍ
u'جَمْعٌ ضِفْدَعٌ':Added, #1: 1	جَمْعُ ضِفْدَعٍ
u'جمع ضَوْج':Added, #1: 1	جَمْعُ ضِفْدَعٍ
u'جَمْعٌ ضَوْج':Added, #1: 1	جَمْعُ ضَوْجٍ
u'جمع طارِمَة':Added, #1: 1	جَمْعُ ضَوْجٍ
u'جَمْعٌ طارِمَة':Added, #1: 1	جَمْعُ طَارِمَةٍ
u'جمع طَاغِي':Added, #1: 1	جَمْعُ طَارِمَةٍ
u'جَمْعٌ طَاغِي':Added, #1: 1	جَمْعُ طَاغِيَةٍ
u'جمع طَائِرٌ':Added, #1: 1	جَمْعُ طَاغِيَةٍ
u'جَمْعٌ طَائِرٌ':Added, #1: 1	جَمْعُ طَائِرٍ
u'جمع طَائِفٌ':Added, #1: 1	جَمْعُ طَائِرٍ
u'جَمْعٌ طَائِفٌ':Added, #1: 1	جَمْعَ طَائِفَةٍ
u'جمع طَبّ':Added, #1: 1	جَمْعَ طَائِفَةٍ
u'جَمْعٌ طَبّ':Added, #1: 1	جَمْعُ طَبّةٍ
u'جمع طِبَابَةٌ':Added, #1: 1	جَمْعُ طَبّةٍ
u'جَمْعٌ طِبَابَةٌ':Added, #1: 1	جَمْعُ طِبَابَةٍ
u'جمع طُرُقٌ':Added, #1: 1	جَمْعُ طِبَابَةٍ
u'جَمْعٌ طُرُقٌ':Added, #1: 1	جَمْعَ طُرُقِ
u'جمع طَسٌّ':Added, #1: 1	جَمْعَ طُرُقِ
u'جَمْعٌ طَسٌّ':Added, #1: 1	جَمْعُ طَسٍّ
u'جَمَعَ طَلاَقٌ':Predicate, #1: 1	جَمْعُ طَسٍّ
u'جمع طِنْجِيرٌ':Added, #1: 1	جَمَعَ الطَّلَاقَ
u'جَمْعٌ طِنْجِيرٌ':Added, #1: 1	جَمْعُ طِنْجِيرٍ
u'جمع ظاهِرٌ':Added, #1: 1	جَمْعُ طِنْجِيرٍ
u'جَمْعٌ ظاهِرٌ':Added, #1: 1	جَمْعِ ظَاهِرِ
u'جمع ظُلَّةٌ':Added, #1: 1	جَمْعِ ظَاهِرِ
u'جَمْعٌ ظُلَّةٌ':Added, #1: 1	جَمْعُ ظُلّةٍ
u'جَمَعَ ظُهْرٌ':Predicate, #1: 1	جَمْعُ ظُلّةٍ
u'جمع ظُهْرٌ':Added, #2: 2	جَمَعَ الظُّهْرَ
u'جَمْعٌ ظُهْرٌ':Added, #1: 1	جَمْعِ الظُّهْرَيْنِ
u'جمع ظُهْرٌ':Added, #1: 1	جَمْعِ الظُّهْرَيْنِ
u'جَمْعٌ ظُهْرٌ':Added, #2: 2	جَمْعُ الظُّهْرَيْنِ
u'جمع عَاتِقٌ':Added, #2: 2	جَمْعُ الظُّهْرَيْنِ
u'جَمْعٌ عَاتِقٌ':Added, #1: 1	جَمْعُ عَاتِقٍ
u'جمع عَارِضٌ':Added, #1: 1	جَمْعُ عَاتِقٍ
u'جَمْعٌ عَارِضٌ':Added, #1: 1	جَمْعُ عَارِضٍ
u'جمع عَارِضٌ':Added, #1: 1	جَمْعُ عَارِضٍ
u'جَمْعٌ عَارِضٌ':Added, #1: 1	جَمْعُ عَارِضَةٍ
u'جمع عَاصِبٌ':Added, #1: 1	جَمْعُ عَارِضَةٍ
u'جَمْعٌ عَاصِبٌ':Added, #1: 1	جَمْعُ عَاصِبٍ
u'جمع عَافِي':Added, #1: 1	جَمْعُ عَاصِبٍ
u'جَمْعٌ عَافِي':Added, #1: 1	جَمْعُ عَافِيَةٍ
u'جمع عَافِيَةٌ':Added, #1: 1	جَمْعُ عَافِيَةٍ
u'جَمْعٌ عَافِيَةٌ':Added, #1: 1	جَمْعُ عَافِيَةٍ
u'جمع عَاقِلٌ':Added, #1: 1	جَمْعُ عَافِيَةٍ
u'جَمْعٌ عَاقِلٌ':Added, #1: 1	جَمْعُ الْعَاقِلَةِ
u'جمع عَالَمٌ':Added, #1: 1	جَمْعُ الْعَاقِلَةِ
u'جمع عَالِمٌ':Added, #1: 1	جَمْعُ عَالَمٍ
u'جَمْعٌ عَالَمٌ':Added, #1: 1	جَمْعُ عَالِمٍ
u'جَمْعٌ عَالِمٌ':Added, #1: 1	جَمْعُ عَالَمٍ
u'جمع عَامِرٌ':Added, #1: 1	جَمْعُ عَالِمٍ
u'جَمْعٌ عَامِرٌ':Added, #1: 1	جَمْعُ عَامِرٍ
u'جمع عَامِلٌ':Added, #1: 1	جَمْعُ عَامِرٍ
u'جَمْعٌ عَامِلٌ':Added, #1: 1	جَمْعُ عَامِلٍ
u'جمع عانِي':Added, #1: 1	جَمْعُ عَامِلٍ
u'جَمْعٌ عانِي':Added, #1: 1	جَمْعُ عَانِيَةٍ
u'جَمَعَ عَبْدٌ':Subject, #1: 1	جَمْعُ عَانِيَةٍ
u'جَمَعَ عَبْدٌ':Subject, #1: 1	جَمَعَ عَبْدٌ
u'جمع عَبْدٌ':Added, #2: 2	جَمَعَ عَبْدُ
u'جَمْعٌ عَبْدٌ':Added, #1: 1	جَمْعُ عَبْدٍ
u'جمع عَبْدٌ':Added, #1: 1	جَمْعُ عَبْدٍ
u'جَمْعٌ عَبْدٌ':Added, #2: 2	جَمْعِ عَبْدٍ
u'جمع عَتَدٌ':Added, #2: 2	جَمْعِ عَبْدٍ
u'جَمْعٌ عَتَدٌ':Added, #1: 1	جَمْعُ عَتَدٍ
u'جمع عِجْلٌ':Added, #1: 1	جَمْعُ عَتَدٍ
u'جَمْعٌ عِجْلٌ':Added, #1: 1	جَمْعُ عِجْلٍ
u'جمع عَجَمِيٌّ':Added, #1: 1	جَمْعُ عِجْلٍ
u'جَمْعٌ عَجَمِيٌّ':Added, #1: 1	جَمْعُ الْعَجَمِيِّ
u'جمع عُجُولٌ':Added, #1: 1	جَمْعُ الْعَجَمِيِّ
u'جَمْعٌ عُجُولٌ':Added, #2: 2	جَمْعُ عُجُولٍ
u'جمع عِدَّةٌ':Added, #2: 2	جَمْعُ عُجُولٍ
u'جَمْعٌ عِدَّةٌ':Added, #2: 2	جَمْعُ عِدَّةٍ
u'جمع عَدَدٌ':Added, #2: 2	جَمْعُ عِدَّةٍ
u'جَمْعٌ عَدَدٌ':Added, #1: 1	جَمْعُ الْعَدَدِ
u'جمع عَدَدٌ':Added, #1: 1	جَمْعُ الْعَدَدِ
u'جَمْعٌ عَدَدٌ':Added, #1: 1	جَمْعُ عَدَدٍ
u'جمع عَدَدٌ':Added, #1: 1	جَمْعُ عَدَدٍ
u'جَمْعٌ عَدَدٌ':Added, #2: 2	جَمْعِ الْعَدَدِ
u'جمع عَدْلٌ':Added, #2: 2	جَمْعِ الْعَدَدِ
u'جَمْعٌ عَدْلٌ':Added, #1: 1	جَمْعُ عَدْلٍ
u'جمع عِذْقٌ':Added, #1: 1	جَمْعُ عَدْلٍ
u'جَمْعٌ عِذْقٌ':Added, #1: 1	جَمْعُ عِذْقٍ
u'جمع عَذْقٌ':Added, #1: 1	جَمْعُ عِذْقٍ
u'جَمْعٌ عَذْقٌ':Added, #2: 2	جَمْعُ عَذْقٍ
u'جمع عَرَبَةٌ':Added, #2: 2	جَمْعُ عَذْقٍ
u'جَمْعٌ عَرَبَةٌ':Added, #1: 1	جَمْعُ عَرَبَةٍ
u'جمع عَرَبِيٌّ':Added, #1: 1	جَمْعُ عَرَبَةٍ
u'جَمْعٌ عَرَبِيٌّ':Added, #2: 2	جَمْعُ عَرَبِيٍّ
u'جمع عَرَضٌ':Added, #2: 2	جَمْعُ عَرَبِيٍّ
u'جمع عِرْضٌ':Added, #1: 1	جَمْعُ عَرَضٍ
u'جَمْعٌ عَرَضٌ':Added, #1: 1	جَمْعُ عِرْضٍ
u'جَمْعٌ عِرْضٌ':Added, #1: 1	جَمْعُ عَرَضٍ
u'جمع عَرْضٌ':Added, #1: 1	جَمْعُ عِرْضٍ
u'جَمْعٌ عَرْضٌ':Added, #2: 2	جَمْعُ عَرْضٍ
u'جمع عَزا':Added, #2: 2	جَمْعُ عَرْضٍ
u'جَمْعٌ عَزا':Added, #1: 1	جَمْعُ عَزَاةٍ
u'جمع عزب':Added, #1: 1	جَمْعُ عَزَاةٍ
u'جَمْعٌ عزب':Added, #1: 1	جَمْعُ عَزَبٍ
u'جمع عَزَبٌ':Added, #1: 1	جَمْعُ عَزَبٍ
u'جَمْعٌ عَزَبٌ':Added, #1: 1	جَمْعُ عَزَبٍ
u'جمع عَزِيمَةٌ':Added, #1: 1	جَمْعُ عَزَبٍ
u'جَمْعٌ عَزِيمَةٌ':Added, #1: 1	جَمْعِ الْعَزِيمَةِ
u'جمع عَزِيمَةٌ':Added, #1: 1	جَمْعِ الْعَزِيمَةِ
u'جَمْعٌ عَزِيمَةٌ':Added, #1: 1	جَمْعُ عَزِيمَةٍ
u'جمع عِشَاءٌ':Added, #1: 1	جَمْعُ عَزِيمَةٍ
u'جَمْعٌ عِشَاءٌ':Added, #1: 1	جَمْعِ الْعِشَاءِ
u'جَمَعَ عَصَافِيرُ':Predicate, #1: 1	جَمْعِ الْعِشَاءِ
u'جمع عَصْرٌ':Added, #2: 2	جَمَعَ الْعَصَافِيرَ
u'جَمْعٌ عَصْرٌ':Added, #2: 2	جَمْعُ الْعَصْرِ
u'جمع عِصْمَةٌ':Added, #2: 2	جَمْعُ الْعَصْرِ
u'جَمْعٌ عِصْمَةٌ':Added, #1: 1	جَمْعُ عِصْمَةٍ
u'جمع عَضُدٌ':Added, #1: 1	جَمْعُ عِصْمَةٍ
u'جَمْعٌ عَضُدٌ':Added, #1: 1	جَمْعُ عَضُدٍ
u'جمع عَطِيَّةٌ':Added, #1: 1	جَمْعُ عَضُدٍ
u'جَمْعٌ عَطِيَّةٌ':Added, #1: 1	جَمْعُ عَطِيَّةٍ
u'جَمْعٌ عَظِيم':Added, #1: 1	جَمْعُ عَطِيَّةٍ
u'جمع عقبة':Added, #1: 1	جَمْعٍ عَظِيمٍ
u'جَمْعٌ عقبة':Added, #2: 2	جَمْعُ عَقَبَةٍ
u'جمع عَقَبَةٌ':Added, #2: 2	جَمْعُ عَقَبَةٍ
u'جَمْعٌ عَقَبَةٌ':Added, #2: 2	جَمْعُ عَقَبَةٍ
u'جمع عَقْدٌ':Added, #2: 2	جَمْعُ عَقَبَةٍ
u'جَمْعٌ عَقْدٌ':Added, #1: 1	جَمْعُ عَقْدٍ
u'جمع عَقِيقَةٌ':Added, #1: 1	جَمْعُ عَقْدٍ
u'جَمْعٌ عَقِيقَةٌ':Added, #1: 1	جَمْعُ عَقِيقَةٍ
u'جمع عِلْجٌ':Added, #1: 1	جَمْعُ عَقِيقَةٍ
u'جَمْعٌ عِلْجٌ':Added, #1: 1	جَمْعُ عِلْجٍ
u'جمع عَلَفٌ':Added, #1: 1	جَمْعُ عِلْجٍ
u'جَمْعٌ عَلَفٌ':Added, #1: 1	جَمْعُ عَلَفٍ
u'جَمَعَ علم':Predicate, #1: 1	جَمْعُ عَلَفٍ
u'جَمَعَ عِلْمٌ':Predicate, #1: 1	جَمَعَ الْعِلْمَ
u'جَمَعَ علماء':Predicate, #1: 1	جَمَعَ الْعِلْمَ
u'جَمَعَ عُلَمَاءُ':Predicate, #1: 1	جَمَعَ الْعُلَمَاءَ
u'جمع عُلُومٌ':Added, #1: 1	جَمَعَ الْعُلَمَاءَ
u'جَمْعٌ عُلُومٌ':Added, #5: 5	جَمْعِ الْعُلُومِ
u'جَمَعَ عُمَارَةٌ':Subject, #5: 5	جَمْعِ الْعُلُومِ
u'جمع عِمَامَةٌ':Added, #1: 1	جَمَعَ عُمَارَةُ
u'جَمْعٌ عِمَامَةٌ':Added, #1: 1	جَمْعَ الْعِمَامَةِ
u'جمع عَمَّةٌ':Added, #1: 1	جَمْعَ الْعِمَامَةِ
u'جَمْعٌ عَمَّةٌ':Added, #1: 1	جَمْعُ عَمَّةٍ
u'جَمَعَ عُمَرٌ':Subject, #1: 1	جَمْعُ عَمَّةٍ
u'جَمَعَ عمرة':Predicate, #4: 4	جَمَعَ عُمَرُ
u'جَمَعَ عُمْرَةٌ':Predicate, #1: 1	أَجْمَعَ الْعُمْرَةَ
u'جَمَعَ عند':Predicate, #1: 1	أَجْمَعَ الْعُمْرَةَ
u'جمع عَوْدٌ':Added, #1: 1	جَمَعَ عِنْدَ
u'جَمْعٌ عَوْدٌ':Added, #1: 1	جَمْعَ الْعَوْدِ
u'جمع عُودٌ':Added, #1: 1	جَمْعَ الْعَوْدِ
u'جَمْعٌ عُودٌ':Added, #2: 2	جَمْعُ عُودٍ
u'جمع عِيدٌ':Added, #2: 2	جَمْعُ عُودٍ
u'جَمْعٌ عِيدٌ':Added, #1: 1	جَمْعِ الْعِيدِ
u'جمع عِيدٌ':Added, #1: 1	جَمْعِ الْعِيدِ
u'جَمْعٌ عِيدٌ':Added, #2: 2	جَمْعِ عِيدٍ
u'جمع غَابِرٌ':Added, #2: 2	جَمْعِ عِيدٍ
u'جَمْعٌ غَابِرٌ':Added, #1: 1	جَمْعُ غَابِرٍ
u'جمع غَضَارَةٌ':Added, #1: 1	جَمْعُ غَابِرٍ
u'جَمْعٌ غَضَارَةٌ':Added, #1: 1	جَمْعُ غَضَارَةٍ
u'جَمَعَ غَلَّةٌ':Predicate, #1: 1	جَمْعُ غَضَارَةٍ
u'جمع غَلَّةٌ':Added, #1: 1	جَمَعَ الْغَلَّةَ
u'جَمْعٌ غَلَّةٌ':Added, #1: 1	جَمْعُ الْغَلَّةِ
u'جمع غَلَّةٌ':Added, #1: 1	جَمْعُ الْغَلَّةِ
u'جَمْعٌ غَلَّةٌ':Added, #1: 1	جَمْعِ غَلَّاتِ
u'جمع غَلَقٌ':Added, #1: 1	جَمْعِ غَلَّاتِ
u'جَمْعٌ غَلَقٌ':Added, #1: 1	جَمْعُ غَلَقٍ
u'جَمَعَ غَنَمٌ':Predicate, #1: 1	جَمْعُ غَلَقٍ
u'جمع غَنِيمَةٌ':Added, #1: 1	جَمَعَ الْغَنَمَ
u'جَمْعٌ غَنِيمَةٌ':Added, #1: 1	جَمْعَ الْغَنِيمَةِ
u'جمع غَنِيمَةٌ':Added, #1: 1	جَمْعَ الْغَنِيمَةِ
u'جَمْعٌ غَنِيمَةٌ':Added, #1: 1	جَمْعُ غَنِيمَةٍ
u'جمع غَيْبٌ':Added, #1: 1	جَمْعُ غَنِيمَةٍ
u'جَمْعٌ غَيْبٌ':Added, #1: 1	جَمْعُ غَيْبٍ
u'جَمَعَ غير':Predicate, #1: 1	جَمْعُ غَيْبٍ
u'جَمَعَ غَيْرٌ':Predicate, #1: 1	جَمَعَ غَيْرَ
u'جَمَعَ غير':Subject, #1: 1	جَمَعَ غَيْرَ
u'جَمَعَ غَيْرٌ':Subject, #2: 2	جَمَعَ غَيْرُهُ
u'جمع غير':Added, #2: 2	جَمَعَ غَيْرُهُ
u'جمع غَيْرٌ':Added, #1: 1	جَمْعِ غَيْرِهِ
u'جَمْعٌ غير':Added, #1: 1	جَمْعِ غَيْرِهِ
u'جَمْعٌ غَيْرٌ':Added, #1: 1	جَمْعِ غَيْرِهِ
u'جمع فَاعِلٌ':Added, #1: 1	جَمْعِ غَيْرِهِ
u'جَمْعٌ فَاعِلٌ':Added, #1: 1	جَمْعِ فَاعِلٍ
u'جمع فَاعِلٌ':Added, #1: 1	جَمْعِ فَاعِلٍ
u'جَمْعٌ فَاعِلٌ':Added, #2: 2	جَمْعُ فَاعِلٍ
u'جمع فَجٌّ':Added, #2: 2	جَمْعُ فَاعِلٍ
u'جَمْعٌ فَجٌّ':Added, #1: 1	جَمْعُ الْفَجِّ
u'جمع فَرْضٌ':Added, #1: 1	جَمْعُ الْفَجِّ
u'جَمْعٌ فَرْضٌ':Added, #1: 1	جَمْعُ فَرْضٍ
u'جَمَعَ فَرْعٌ':Subject, #1: 1	جَمْعُ فَرْضٍ
u'جمع فَرْعٌ':Added, #1: 1	جَمَعَ الْفَرْعُ
u'جَمْعٌ فَرْعٌ':Added, #1: 1	جَمْعُ فَرْعٍ
u'جمع فَرِيصَةٌ':Added, #1: 1	جَمْعُ فَرْعٍ
u'جَمْعٌ فَرِيصَةٌ':Added, #1: 1	جَمْعُ فَرِيصَةٍ
u'جمع فَرِيضَةٌ':Added, #1: 1	جَمْعُ فَرِيصَةٍ
u'جَمْعٌ فَرِيضَةٌ':Added, #9: 9	جَمْعُ فَرِيضَةٍ
u'جمع فَصِيلٌ':Added, #9: 9	جَمْعُ فَرِيضَةٍ
u'جَمْعٌ فَصِيلٌ':Added, #1: 1	جَمْعُ الْفَصِيلِ
u'جمع فَصِيلٌ':Added, #1: 1	جَمْعُ الْفَصِيلِ
u'جَمْعٌ فَصِيلٌ':Added, #3: 3	جَمْعُ فَصِيلٍ
u'جمع فَضْلٌ':Added, #3: 3	جَمْعُ فَصِيلٍ
u'جَمْعٌ فَضْلٌ':Added, #1: 1	جَمْعِ الْفَضْلِ
u'جمع فَضْلٌ':Added, #1: 1	جَمْعِ الْفَضْلِ
u'جَمْعٌ فَضْلٌ':Added, #3: 3	جَمْعُ فَضْلٍ
u'جمع فَقَارَةٌ':Added, #3: 3	جَمْعُ فَضْلٍ
u'جَمْعٌ فَقَارَةٌ':Added, #1: 1	جَمْعُ فَقَارَةٍ
u'جمع فِقْرَةٌ':Added, #1: 1	جَمْعُ فَقَارَةٍ
u'جَمْعٌ فِقْرَةٌ':Added, #1: 1	جَمْعُ فِقْرَةٍ
u'جَمَعَ فِقْهٌ':Predicate, #1: 1	جَمْعُ فِقْرَةٍ
u'جَمَعَ فلان':Subject, #1: 1	جَمَعَ فِقْهَ
u'جَمَعَ فلان':Subject, #1: 1	جَمَعَ الْبَيْهَقِيُّ
u'جَمَعَ فلان':Subject, #1: 1	جَمَعَ الشَّافِعِيُّ
u'جَمَعَ فلان':Subject, #1: 1	جَمَعَ الْمُنْذِرِيُّ
u'جَمَعَ فلان':Subject, #1: 1	جَمَعَ عُثْمَانُ
u'جمع فلان':Added, #2: 2	جَمَعَ هَارُونُ
u'جَمْعٌ فلان':Added, #1: 1	جَمْعُ الصَّلاَتَيْنِ
u'جمع فلان':Added, #1: 1	جَمْعُ الصَّلاَتَيْنِ
u'جَمْعٌ فلان':Added, #1: 1	جَمْعِ الْمُزْدَلِفَةِ
u'جمع فلان':Added, #1: 1	جَمْعِ الْمُزْدَلِفَةِ
u'جَمْعٌ فلان':Added, #1: 1	جَمْعُ سِرْحَانٍ
u'جمع فلان':Added, #1: 1	جَمْعُ سِرْحَانٍ
u'جَمْعٌ فلان':Added, #2: 2	جَمْعِ الصَّلَاتَيْنِ
u'جمع فِلْقَةٌ':Added, #2: 2	جَمْعِ الصَّلَاتَيْنِ
u'جَمْعٌ فِلْقَةٌ':Added, #1: 1	جَمْعُ فِلْقَةٍ
u'جمع فَنٌّ':Added, #1: 1	جَمْعُ فِلْقَةٍ
u'جَمْعٌ فَنٌّ':Added, #1: 1	جَمْعُ فَنٍّ
u'جمع فِنْجَانٌ':Added, #1: 1	جَمْعُ فَنٍّ
u'جَمْعٌ فِنْجَانٌ':Added, #1: 1	جَمْعُ فِنْجَانٍ
u'جمع فُؤَادٌ':Added, #1: 1	جَمْعُ فِنْجَانٍ
u'جَمْعٌ فُؤَادٌ':Added, #1: 1	جَمْعُ فُؤَادٍ
u'جمع قَاعِدٌ':Added, #1: 1	جَمْعُ فُؤَادٍ
u'جَمْعٌ قَاعِدٌ':Added, #1: 1	جَمْعُ قَاعِدٍ
u'جمع قَائِمٌ':Added, #1: 1	جَمْعُ قَاعِدٍ
u'جَمْعٌ قَائِمٌ':Added, #3: 3	جَمْعُ قَائِمٍ
u'جمع قُبَّةٌ':Added, #3: 3	جَمْعُ قَائِمٍ
u'جَمْعٌ قُبَّةٌ':Added, #1: 1	جَمْعُ قُبَّةٍ
u'جمع قِبْطِيٌّ':Added, #1: 1	جَمْعُ قُبَّةٍ
u'جَمْعٌ قِبْطِيٌّ':Added, #1: 1	جَمْعُ قِبْطِيَّةٍ
u'جمع قَبِيلٌ':Added, #1: 1	جَمْعُ قِبْطِيَّةٍ
u'جَمْعٌ قَبِيلٌ':Added, #1: 1	جَمْعُ قَبِيلٍ
u'جمع قَدْرٌ':Added, #1: 1	جَمْعُ قَبِيلٍ
u'جَمْعٌ قَدْرٌ':Added, #1: 1	جَمْعَ قَدْرٍ
u'جمع قَدُومٌ':Added, #1: 1	جَمْعَ قَدْرٍ
u'جَمْعٌ قَدُومٌ':Added, #1: 1	جَمْعُ قَدُومٍ
u'جمع قُرْء':Added, #1: 1	جَمْعُ قَدُومٍ
u'جَمْعٌ قُرْء':Added, #1: 1	جَمْعِ الْقُرْءِ
u'جمع قُرْء':Added, #1: 1	جَمْعِ الْقُرْءِ
u'جَمْعٌ قُرْء':Added, #1: 1	جَمْعُ قُرْءٍ
u'جَمَعَ قُرْآنٌ':Predicate, #1: 1	جَمْعُ قُرْءٍ
u'جمع قُرْآنٌ':Added, #7: 7	جَمَعَ الْقُرْآنَ
u'جَمْعٌ قُرْآنٌ':Added, #1: 1	جَمْعُ الْقُرْآنِ
u'جمع قُرْآنٌ':Added, #1: 1	جَمْعُ الْقُرْآنِ
u'جَمْعٌ قُرْآنٌ':Added, #3: 3	جَمْعِ الْقُرْآنِ
u'جمع قصرة':Added, #3: 3	جَمْعِ الْقُرْآنِ
u'جَمْعٌ قصرة':Added, #1: 1	جَمْعُ قَصَرَةٍ
u'جمع قَصَرَةٌ':Added, #1: 1	جَمْعُ قَصَرَةٍ
u'جَمْعٌ قَصَرَةٌ':Added, #1: 1	جَمْعُ قَصَرَةٍ
u'جمع قصمة':Added, #1: 1	جَمْعُ قَصَرَةٍ
u'جَمْعٌ قصمة':Added, #1: 1	جَمْعُ قَصِمَةٍ
u'جمع قَضَاءٌ':Added, #1: 1	جَمْعُ قَصِمَةٍ
u'جَمْعٌ قَضَاءٌ':Added, #2: 2	جَمْعُ قَضَاءٍ
u'جمع قَطَاةٌ':Added, #2: 2	جَمْعُ قَضَاءٍ
u'جَمْعٌ قَطَاةٌ':Added, #1: 1	جَمْعُ قَطَاةٍ
u'جَمَعَ قُعُودٌ':Predicate, #1: 1	جَمْعُ قَطَاةٍ
u'جمع قَفِيز':Added, #1: 1	أَجْمَعَ الْقُعُودَ
u'جَمْعٌ قَفِيز':Added, #1: 1	جَمْعُ قَفِيزٍ
u'جمع قَلْبٌ':Added, #1: 1	جَمْعُ قَفِيزٍ
u'جمع قَلْب':Added, #2: 2	جَمْعُ قَلْبٍ
u'جَمْعٌ قَلْبٌ':Added, #2: 2	جَمْعُ قَلْبٍ
u'جَمْعٌ قَلْب':Added, #2: 2	جَمْعُ قَلْبٍ
u'جمع قِلَّةٌ':Added, #2: 2	جَمْعُ قَلْبٍ
u'جَمْعٌ قِلَّةٌ':Added, #13: 13	جَمْعِ الْقِلَّةِ
u'جمع قِلَّةٌ':Added, #13: 13	جَمْعِ الْقِلَّةِ
u'جَمْعٌ قِلَّةٌ':Added, #3: 3	جَمْعُ قِلَّةٍ
u'جمع قِلَّةٌ':Added, #3: 3	جَمْعُ قِلَّةٍ
u'جَمْعٌ قِلَّةٌ':Added, #4: 4	جَمْعُ الْقِلَّةِ
u'جمع قِلَّةٌ':Added, #4: 4	جَمْعُ الْقِلَّةِ
u'جَمْعٌ قِلَّةٌ':Added, #4: 4	جَمْعَ قِلَّةٍ
u'جمع قِلَّةٌ':Added, #4: 4	جَمْعَ قِلَّةٍ
u'جَمْعٌ قِلَّةٌ':Added, #5: 5	جَمْعَ الْقِلَّةِ
u'جمع قَلَنْسُوَةٌ':Added, #5: 5	جَمْعَ الْقِلَّةِ
u'جَمْعٌ قَلَنْسُوَةٌ':Added, #1: 1	جَمْعُ قَلَنْسُوَةٍ
u'جمع قِمَاطٌ':Added, #1: 1	جَمْعُ قَلَنْسُوَةٍ
u'جَمْعٌ قِمَاطٌ':Added, #2: 2	جَمْعُ قِمَاطٍ
u'جمع قِمْعٌ':Added, #2: 2	جَمْعُ قِمَاطٍ
u'جَمْعٌ قِمْعٌ':Added, #1: 1	جَمْعُ قِمْعٍ
u'جمع قَمِيصٌ':Added, #1: 1	جَمْعُ قِمْعٍ
u'جَمْعٌ قَمِيصٌ':Added, #1: 1	جَمْعُ قَمِيصٍ
u'جمع قَنَاةٌ':Added, #1: 1	جَمْعُ قَمِيصٍ
u'جَمْعٌ قَنَاةٌ':Added, #2: 2	جَمْعُ قَنَاةٍ
u'جمع قُوَّةٌ':Added, #2: 2	جَمْعُ قَنَاةٍ
u'جمع قُوَّة':Added, #1: 1	جَمْعِ الْقُوَّةِ
u'جَمْعٌ قُوَّةٌ':Added, #1: 1	جَمْعِ الْقُوَّةِ
u'جَمْعٌ قُوَّة':Added, #1: 1	جَمْعِ الْقُوَّةِ
u'جمع قول':Added, #1: 1	جَمْعِ الْقُوَّةِ
u'جَمْعٌ قول':Added, #1: 1	جَمْعُ الْقَوْلِ
u'جمع قَوْلٌ':Added, #1: 1	جَمْعُ الْقَوْلِ
u'جَمْعٌ قَوْلٌ':Added, #1: 1	جَمْعُ الْقَوْلِ
u'جَمَعَ قَوْمٌ':Subject, #1: 1	جَمْعُ الْقَوْلِ
u'جمع قَيْنَةٌ':Added, #3: 3	جَمَعَ قَوْمٌ
u'جَمْعٌ قَيْنَةٌ':Added, #1: 1	جَمْعُ قَيْنَةٍ
u'جمع كَاتِبٌ':Added, #1: 1	جَمْعُ قَيْنَةٍ
u'جَمْعٌ كَاتِبٌ':Added, #1: 1	جَمْعُ كَاتِبٍ
u'جمع كَافِرٌ':Added, #1: 1	جَمْعُ كَاتِبٍ
u'جَمْعٌ كَافِرٌ':Added, #1: 1	جَمْعُ كَافِرٍ
u'جمع كَافِرٌ':Added, #1: 1	جَمْعُ كَافِرٍ
u'جَمْعٌ كَافِرٌ':Added, #3: 3	جَمْعُ كَافِرَةٍ
u'جمع كَالِبٌ':Added, #3: 3	جَمْعُ كَافِرَةٍ
u'جَمْعٌ كَالِبٌ':Added, #1: 1	جَمْعُ كَالِبٍ
u'جمع كَبَرٌ':Added, #1: 1	جَمْعُ كَالِبٍ
u'جَمْعٌ كَبَرٌ':Added, #1: 1	جَمْعُ كَبَرٍ
u'جَمَعَ كُتُبٌ':Predicate, #1: 1	جَمْعُ كَبَرٍ
u'جمع كَثْرَةٌ':Added, #1: 1	جَمَعَ كُتُبَ
u'جَمْعٌ كَثْرَةٌ':Added, #11: 11	جَمْعِ الْكَثْرَةِ
u'جمع كَثْرَةٌ':Added, #11: 11	جَمْعِ الْكَثْرَةِ
u'جَمْعٌ كَثْرَةٌ':Added, #3: 3	جَمْعُ الْكَثْرَةِ
u'جمع كَثْرَةٌ':Added, #3: 3	جَمْعُ الْكَثْرَةِ
u'جَمْعٌ كَثْرَةٌ':Added, #3: 3	جَمْعَ كَثْرَةٍ
u'جمع كَثْرَةٌ':Added, #3: 3	جَمْعَ كَثْرَةٍ
u'جَمْعٌ كَثْرَةٌ':Added, #4: 4	جَمْعَ الْكَثْرَةِ
u'جمع كَثْرَةٌ':Added, #4: 4	جَمْعَ الْكَثْرَةِ
u'جَمْعٌ كَثْرَةٌ':Added, #4: 4	جَمْعُ كَثْرَةٍ
u'جمع كُرَاعٌ':Added, #4: 4	جَمْعُ كَثْرَةٍ
u'جَمْعٌ كُرَاعٌ':Added, #2: 2	جَمْعُ كُرَاعٍ
u'جمع كعاب':Added, #2: 2	جَمْعُ كُرَاعٍ
u'جَمْعٌ كعاب':Added, #1: 1	جَمْعُ الْكِعَابِ
u'جمع كِعَابٌ':Added, #1: 1	جَمْعُ الْكِعَابِ
u'جَمْعٌ كِعَابٌ':Added, #1: 1	جَمْعُ الْكِعَابِ
u'جمع كَفٌّ':Added, #1: 1	جَمْعُ الْكِعَابِ
u'جَمْعٌ كَفٌّ':Added, #1: 1	جَمْعِ الْكَفِّ
u'جمع كِفَايَةٌ':Added, #1: 1	جَمْعِ الْكَفِّ
u'جَمْعٌ كِفَايَةٌ':Added, #1: 1	جَمْعِ الْكِفَايَةِ
u'جَمَعَ كَلاَمٌ':Predicate, #1: 1	جَمْعِ الْكِفَايَةِ
u'جَمَعَ كَلاَمٌ':Subject, #4: 4	جَمَعَ كَلَامَ
u'جمع كَلاَمٌ':Added, #1: 1	جَمَعَ كَلَامُ
u'جَمْعٌ كَلاَمٌ':Added, #5: 5	جَمْعُ كَلَامِ
u'جمع كَلْبٌ':Added, #5: 5	جَمْعُ كَلَامِ
u'جمع كَلْبٌ':Added, #1: 1	جَمْعُ كَلْبٍ
u'جَمْعٌ كَلْبٌ':Added, #1: 1	جَمْعِ كَلْبٍ
u'جَمْعٌ كَلْبٌ':Added, #1: 1	جَمْعُ كَلْبٍ
u'جمع كَلِمَةٌ':Added, #1: 1	جَمْعِ كَلْبٍ
u'جَمْعٌ كَلِمَةٌ':Added, #1: 1	جَمْعُ كَلِمَةٍ
u'جمع كِمَامٌ':Added, #1: 1	جَمْعُ كَلِمَةٍ
u'جَمْعٌ كِمَامٌ':Added, #2: 2	جَمْعُ كِمَامَةٍ
u'جَمَعَ كُنَاسَةٌ':Predicate, #2: 2	جَمْعُ كِمَامَةٍ
u'جمع كُوبٌ':Added, #3: 3	جَمَعَ الْكُنَاسَةَ
u'جَمْعٌ كُوبٌ':Added, #1: 1	جَمْعُ كُوبٍ
u'جمع لاب':Added, #1: 1	جَمْعُ كُوبٍ
u'جَمْعٌ لاب':Added, #1: 1	جَمْعُ لَابَةٍ
u'جَمَعَ لِبَاسٌ':Predicate, #1: 1	جَمْعُ لَابَةٍ
u'جمع لِسَانٌ':Added, #3: 3	جَمَعَ اللِّبَاسَ
u'جَمْعٌ لِسَانٌ':Added, #2: 2	جَمْعُ لِسَانٍ
u'جمع لِصٌّ':Added, #2: 2	جَمْعُ لِسَانٍ
u'جَمْعٌ لِصٌّ':Added, #1: 1	جَمْعُ لِصٍّ
u'جمع لَفْظٌ':Added, #1: 1	جَمْعُ لِصٍّ
u'جَمْعٌ لَفْظٌ':Added, #1: 1	جَمْعِ لَفْظٍ
u'جمع لهاة':Added, #1: 1	جَمْعِ لَفْظٍ
u'جمع لهاة':Added, #1: 1	جَمْعَ لَهَاةٍ
u'جَمْعٌ لهاة':Added, #1: 1	جَمْعُ لَهَاةٍ
u'جَمْعٌ لهاة':Added, #1: 1	جَمْعَ لَهَاةٍ
u'جمع لَهَاةٌ':Added, #1: 1	جَمْعُ لَهَاةٍ
u'جمع لَهَاةٌ':Added, #1: 1	جَمْعَ لَهَاةٍ
u'جَمْعٌ لَهَاةٌ':Added, #1: 1	جَمْعُ لَهَاةٍ
u'جَمْعٌ لَهَاةٌ':Added, #1: 1	جَمْعَ لَهَاةٍ
u'جَمَعَ مَاءٌ':Predicate, #1: 1	جَمْعُ لَهَاةٍ
u'جمع مَاءٌ':Added, #6: 6	جَمَعَ الْمَاءَ
u'جَمْعٌ مَاءٌ':Added, #1: 1	جَمْعِ الْمَاءِ
u'جمع مَاءٌ':Added, #1: 1	جَمْعِ الْمَاءِ
u'جَمْعٌ مَاءٌ':Added, #4: 4	جَمْعُ مَاءٍ
u'جمع مَاشِي':Added, #4: 4	جَمْعُ مَاءٍ
u'جَمْعٌ مَاشِي':Added, #2: 2	جَمْعُ مَاشِيَةٍ
u'جمع مَاشِيَةٌ':Added, #2: 2	جَمْعُ مَاشِيَةٍ
u'جَمْعٌ مَاشِيَةٌ':Added, #2: 2	جَمْعُ مَاشِيَةٍ
u'جَمَعَ مَالٌ':Predicate, #2: 2	جَمْعُ مَاشِيَةٍ
u'جمع مَالٌ':Added, #5: 5	جَمَعَ الْمَالَ
u'جَمْعٌ مَالٌ':Added, #10: 10	جَمْعِ الْمَالِ
u'جمع مَالٌ':Added, #10: 10	جَمْعِ الْمَالِ
u'جمع مَالٌ':Added, #1: 1	جَمْعَ مَالٍ
u'جمع مَالٌ':Added, #1: 1	جَمْعُ مَالٍ
u'جَمْعٌ مَالٌ':Added, #1: 1	جَمْعِ مَالٍ
u'جَمْعٌ مَالٌ':Added, #1: 1	جَمْعَ مَالٍ
u'جَمْعٌ مَالٌ':Added, #1: 1	جَمْعُ مَالٍ
u'جمع مَالٌ':Added, #1: 1	جَمْعِ مَالٍ
u'جَمْعٌ مَالٌ':Added, #1: 1	جَمْعِ مَالِهِ
u'جمع مَالٌ':Added, #1: 1	جَمْعِ مَالِهِ
u'جَمْعٌ مَالٌ':Added, #5: 5	جَمْعُ الْمَالِ
u'جمع مَبْدَأٌ':Added, #5: 5	جَمْعُ الْمَالِ
u'جَمْعٌ مَبْدَأٌ':Added, #1: 1	جَمْعُ مَبْدَأٍ
u'جَمَعَ مَبْسُوطٌ':Predicate, #1: 1	جَمْعُ مَبْدَأٍ
u'جَمَعَ مَتَاعٌ':Predicate, #2: 2	جَمَعَ الْمَبْسُوطَ
u'جمع مُتَجَانِسٌ':Added, #1: 1	جَمَعَ الْمَتَاعَ
u'جَمْعٌ مُتَجَانِسٌ':Added, #1: 1	جَمْعُ الْمُتَجَانِسَةِ
u'جَمَعَ مُتَفَرِّقٌ':Predicate, #1: 1	جَمْعُ الْمُتَجَانِسَةِ
u'جمع مُتَفَرِّقٌ':Added, #1: 1	جَمَعَ الْمُتَفَرِّقَ
u'جَمْعٌ مُتَفَرِّقٌ':Added, #1: 1	جَمْعُ الْمُتَفَرِّقِ
u'جمع مُتَفَرِّقٌ':Added, #1: 1	جَمْعُ الْمُتَفَرِّقِ
u'جَمْعٌ مُتَفَرِّقٌ':Added, #5: 5	جَمْعِ الْمُتَفَرِّقَاتِ
u'جمع مِجْمَرٌ':Added, #5: 5	جَمْعِ الْمُتَفَرِّقَاتِ
u'جَمْعٌ مِجْمَرٌ':Added, #2: 2	جَمْعُ مِجْمَرٍ
u'جمع مَحَافِلُ':Added, #2: 2	جَمْعُ مِجْمَرٍ
u'جَمْعٌ مَحَافِلُ':Added, #1: 1	جَمْعُ الْمَحَافِلِ
u'جمع مِحْجَمٌ':Added, #1: 1	جَمْعُ الْمَحَافِلِ
u'جَمْعٌ مِحْجَمٌ':Added, #1: 1	جَمْعُ مِحْجَمٍ
u'جَمَعَ مُحَرَّرٌ':Subject, #1: 1	جَمْعُ مِحْجَمٍ
u'جمع مَحَشٌّ':Added, #1: 1	جَمَعَ الْمُحَرَّرُ
u'جمع مِحَشٌّ':Added, #1: 1	جَمْعُ مَحَشَّةٍ
u'جَمْعٌ مَحَشٌّ':Added, #1: 1	جَمْعُ مِحَشَّةٍ
u'جَمْعٌ مِحَشٌّ':Added, #1: 1	جَمْعُ مَحَشَّةٍ
u'جمع مَحْضَرٌ':Added, #1: 1	جَمْعُ مِحَشَّةٍ
u'جَمْعٌ مَحْضَرٌ':Added, #1: 1	جَمْعُ مَحْضَرٍ
u'جَمَعَ مُحَمَّدٌ':Subject, #1: 1	جَمْعُ مَحْضَرٍ
u'جمع مُحَمَّدٌ':Added, #1: 1	جَمَعَ مُحَمَّدٌ
u'جَمْعٌ مُحَمَّدٌ':Added, #1: 1	جَمْعِ مُحَمَّدٍ
u'جمع مُخَاطَبٌ':Added, #1: 1	جَمْعِ مُحَمَّدٍ
u'جَمْعٌ مُخَاطَبٌ':Added, #1: 1	جَمْع الْمُخَاطَبِ
u'جمع مُخْتَلِطٌ':Added, #1: 1	جَمْع الْمُخَاطَبِ
u'جَمْعٌ مُخْتَلِطٌ':Added, #2: 2	جَمْعُ الْمُخْتَلِطِ
u'جمع مَخْتُومٌ':Added, #2: 2	جَمْعُ الْمُخْتَلِطِ
u'جَمْعٌ مَخْتُومٌ':Added, #1: 1	جَمْعُ مَخْتُومٍ
u'جمع مُخَنَّث':Added, #1: 1	جَمْعُ مَخْتُومٍ
u'جَمْعٌ مُخَنَّث':Added, #1: 1	جَمْعُ مُخَنَّثٍ
u'جمع مِداد':Added, #1: 1	جَمْعُ مُخَنَّثٍ
u'جَمْعٌ مِداد':Added, #1: 1	جَمْعُ مِدَادَةٍ
u'جمع مِدْوَسٌ':Added, #1: 1	جَمْعُ مِدَادَةٍ
u'جَمْعٌ مِدْوَسٌ':Added, #1: 1	جَمْعُ مِدْوَسٍ
u'جمع مُذَكَّرٌ':Added, #1: 1	جَمْعُ مِدْوَسٍ
u'جَمْعٌ مُذَكَّرٌ':Added, #2: 2	جَمْعَ مُذَكَّرٍ
u'جمع مُذَكَّرٌ':Added, #2: 2	جَمْعَ مُذَكَّرٍ
u'جَمْعٌ مُذَكَّرٌ':Added, #3: 3	جَمْعَ الْمُذَكَّرِ
u'جمع مُذَكَّرٌ':Added, #3: 3	جَمْعَ الْمُذَكَّرِ
u'جَمْعٌ مُذَكَّرٌ':Added, #4: 4	جَمْعُ الْمُذَكَّرِ
u'جمع مُذَكَّرٌ':Added, #4: 4	جَمْعُ الْمُذَكَّرِ
u'جَمْعٌ مُذَكَّرٌ':Added, #9: 9	جَمْعِ الْمُذَكَّرِ
u'جَمَعَ مَذْهَبٌ':Predicate, #9: 9	جَمْعِ الْمُذَكَّرِ
u'جمع مراد':Added, #1: 1	جَمَعَ الْمَذْهَبَ
u'جَمْعٌ مراد':Added, #1: 1	جَمْعُ مُرَادٍ
u'جمع مُرَادٌ':Added, #1: 1	جَمْعُ مُرَادٍ
u'جَمْعٌ مُرَادٌ':Added, #1: 1	جَمْعُ مُرَادٍ
u'جمع مُرَاعَاةٌ':Added, #1: 1	جَمْعُ مُرَادٍ
u'جَمْعٌ مُرَاعَاةٌ':Added, #1: 1	جَمْعُ مُرَاعَاةِ
u'جمع مَرَافِقُ':Added, #1: 1	جَمْعُ مُرَاعَاةِ
u'جَمْعٌ مَرَافِقُ':Added, #1: 1	جَمْعِ الْمَرَافِقِ
u'جمع مُرْضِعٌ':Added, #1: 1	جَمْعِ الْمَرَافِقِ
u'جَمْعٌ مُرْضِعٌ':Added, #1: 1	جَمْعُ مُرْضِعٍ
u'جمع مِرْفَقٌ':Added, #1: 1	جَمْعُ مُرْضِعٍ
u'جَمْعٌ مِرْفَقٌ':Added, #1: 1	جَمْعُ مِرْفَقٍ
u'جمع مِرْوَدٌ':Added, #1: 1	جَمْعُ مِرْفَقٍ
u'جَمْعٌ مِرْوَدٌ':Added, #1: 1	جَمْعَ مِرْوَدٍ
u'جَمَعَ مَرِيضٌ':Subject, #1: 1	جَمْعَ مِرْوَدٍ
u'جمع مَسَاءةٌ':Added, #1: 1	جَمَعَ الْمَرِيضُ
u'جَمْعٌ مَسَاءةٌ':Added, #1: 1	جَمْعُ مَسَاءَةٍ
u'جمع مُسَافِرٌ':Added, #1: 1	جَمْعُ مَسَاءَةٍ
u'جمع مُسَافِرٌ':Added, #1: 1	جَمْعَ الْمُسَافِرِ
u'جَمْعٌ مُسَافِرٌ':Added, #1: 1	جَمْعِ الْمُسَافِرِ
u'جَمْعٌ مُسَافِرٌ':Added, #1: 1	جَمْعَ الْمُسَافِرِ
u'جمع مُسَافِرٌ':Added, #1: 1	جَمْعِ الْمُسَافِرِ
u'جَمْعٌ مُسَافِرٌ':Added, #1: 1	جَمْعُ مُسَافِرٍ
u'جَمَعَ مَسْأَلَةٌ':Predicate, #1: 1	جَمْعُ مُسَافِرٍ
u'جمع مَسْأَلَةٌ':Added, #1: 1	جَمَعَ مَسْأَلَةَ
u'جَمْعٌ مَسْأَلَةٌ':Added, #2: 2	جَمْعُ مَسْأَلَةٍ
u'جمع مَسَائِلُ':Added, #2: 2	جَمْعُ مَسْأَلَةٍ
u'جَمْعٌ مَسَائِلُ':Added, #1: 1	جَمْعُ الْمَسَائِلِ
u'جمع مَسَائِلُ':Added, #1: 1	جَمْعُ الْمَسَائِلِ
u'جَمْعٌ مَسَائِلُ':Added, #1: 1	جَمْعُ مَسَائِلِ
u'جمع مُسْتَعْمَلٌ':Added, #1: 1	جَمْعُ مَسَائِلِ
u'جَمْعٌ مُسْتَعْمَلٌ':Added, #1: 1	جَمْعَ الْمُسْتَعْمَلِ
u'جمع مَسْجِدٌ':Added, #1: 1	جَمْعَ الْمُسْتَعْمَلِ
u'جَمْعٌ مَسْجِدٌ':Added, #1: 1	جَمْعُ مَسْجِدٍ
u'جمع مِسْحَاةٌ':Added, #1: 1	جَمْعُ مَسْجِدٍ
u'جَمْعٌ مِسْحَاةٌ':Added, #1: 1	جَمْعِ مِسْحَاةٍ
u'جمع مِسْحَلٌ':Added, #1: 1	جَمْعِ مِسْحَاةٍ
u'جَمْعٌ مِسْحَلٌ':Added, #1: 1	جَمْعُ مِسْحَلٍ
u'جَمَعَ مَشَايِخُ':Subject, #1: 1	جَمْعُ مِسْحَلٍ
u'جمع مُشْتَرَكٌ':Added, #1: 1	جَمَعَ الْمَشَايِخُ
u'جَمْعٌ مُشْتَرَكٌ':Added, #1: 1	جَمْعِ الْمُشْتَرَكَتَيْنِ
u'جمع مِشْجَبٌ':Added, #1: 1	جَمْعِ الْمُشْتَرَكَتَيْنِ
u'جَمْعٌ مِشْجَبٌ':Added, #1: 1	جَمْعُ مِشْجَبٍ
u'جمع مُصْحَفٌ':Added, #1: 1	جَمْعُ مِشْجَبٍ
u'جَمْعٌ مُصْحَفٌ':Added, #1: 1	جَمْعِ الْمُصْحَفِ
u'جمع مُصْحَفٌ':Added, #1: 1	جَمْعِ الْمُصْحَفِ
u'جَمْعٌ مُصْحَفٌ':Added, #2: 2	جَمْعُ الْمُصْحَفِ
u'جَمَعَ مُصَنِّفٌ':Subject, #2: 2	جَمْعُ الْمُصْحَفِ
u'جمع مُصَنِّفٌ':Added, #3: 3	جَمَعَ الْمُصَنِّفُ
u'جَمْعٌ مُصَنِّفٌ':Added, #1: 1	جَمْعُ الْمُصَنِّفِ
u'جمع مُصَنِّفٌ':Added, #1: 1	جَمْعُ الْمُصَنِّفِ
u'جَمْعٌ مُصَنِّفٌ':Added, #2: 2	جَمْعِ الْمُصَنِّفِ
u'جمع مَضْجَعٌ':Added, #2: 2	جَمْعِ الْمُصَنِّفِ
u'جَمْعٌ مَضْجَعٌ':Added, #2: 2	جَمْعُ مَضْجَعٍ
u'جمع مَضْمُونٌ':Added, #2: 2	جَمْعُ مَضْجَعٍ
u'جَمْعٌ مَضْمُونٌ':Added, #1: 1	جَمْعُ مَضْمُونَةٍ
u'جمع مَضْمُونٌ':Added, #1: 1	جَمْعُ مَضْمُونَةٍ
u'جَمْعٌ مَضْمُونٌ':Added, #2: 2	جَمْعُ مَضْمُونٍ
u'جمع مَطَرٌ':Added, #2: 2	جَمْعُ مَضْمُونٍ
u'جَمْعٌ مَطَرٌ':Added, #10: 10	جَمْعِ الْمَطَرِ
u'جمع مَطَرٌ':Added, #10: 10	جَمْعِ الْمَطَرِ
u'جَمْعٌ مَطَرٌ':Added, #1: 1	جَمْعَ الْمَطَرِ
u'جمع مَطْلِعٌ':Added, #1: 1	جَمْعَ الْمَطَرِ
u'جَمْعٌ مَطْلِعٌ':Added, #1: 1	جَمْعُ مَطْلِعٍ
u'جمع مِعْزَفٌ':Added, #1: 1	جَمْعُ مَطْلِعٍ
u'جَمْعٌ مِعْزَفٌ':Added, #1: 1	جَمْعُ مِعْزَفٍ
u'جمع مِعْزَفٌ':Added, #1: 1	جَمْعُ مِعْزَفٍ
u'جَمْعٌ مِعْزَفٌ':Added, #1: 1	جَمْعُ مِعْزَفَةٍ
u'جمع مَعْقِل':Added, #1: 1	جَمْعُ مِعْزَفَةٍ
u'جَمْعٌ مَعْقِل':Added, #1: 1	جَمْعُ مَعْقِلَةٍ
u'جمع مِعْلاَقٌ':Added, #1: 1	جَمْعُ مَعْقِلَةٍ
u'جَمْعٌ مِعْلاَقٌ':Added, #1: 1	جَمْعُ مِعْلَاقٍ
u'جمع مَعْلَمٌ':Added, #1: 1	جَمْعُ مِعْلَاقٍ
u'جَمْعٌ مَعْلَمٌ':Added, #2: 2	جَمْعُ مَعْلَمٍ
u'جَمَعَ مَغْرِبٌ':Predicate, #2: 2	جَمْعُ مَعْلَمٍ
u'جمع مَغْرِبٌ':Added, #3: 3	جَمَعَ الْمَغْرِبَ
u'جَمْعٌ مَغْرِبٌ':Added, #2: 2	جَمْعِ الْمَغْرِبِ
u'جمع مَغْزاة':Added, #2: 2	جَمْعِ الْمَغْرِبِ
u'جَمْعٌ مَغْزاة':Added, #2: 2	جَمْعُ الْمَغْزَاةِ
u'جمع مَفَازَة':Added, #2: 2	جَمْعُ الْمَغْزَاةِ
u'جَمْعٌ مَفَازَة':Added, #1: 1	جَمْعُ مَفَازَةٍ
u'جمع مُفَرَّقٌ':Added, #1: 1	جَمْعُ مَفَازَةٍ
u'جَمْعٌ مُفَرَّقٌ':Added, #3: 3	جَمْعِ الْمُفَرَّقِ
u'جَمَعَ مَقَامٌ':Predicate, #3: 3	جَمْعِ الْمُفَرَّقِ
u'جَمَعَ مُقَامٌ':Predicate, #1: 1	أَجْمَعَ الْمَقَامَ
u'جمع مَقَامَةٌ':Added, #1: 1	جَمَعَ مُقَامَ
u'جَمْعٌ مَقَامَةٌ':Added, #1: 1	جَمْعُ مَقَامَةٍ
u'جمع مَقْتَلٌ':Added, #1: 1	جَمْعُ مَقَامَةٍ
u'جَمْعٌ مَقْتَلٌ':Added, #1: 1	جَمْعُ مَقْتَلٍ
u'جمع مِقْدَارٌ':Added, #1: 1	جَمْعُ مَقْتَلٍ
u'جَمْعٌ مِقْدَارٌ':Added, #1: 1	جَمْعُ مِقْدَارٍ
u'جَمْعٌ مَقْرُونٌ':Added, #1: 1	جَمْعُ مِقْدَارٍ
u'جمع مِقْوَلٌ':Added, #1: 1	جَمْعٍ مَقْرُونٍ
u'جَمْعٌ مِقْوَلٌ':Added, #1: 1	جَمْعُ مِقْوَلٍ
u'جمع مَكَانٌ':Added, #1: 1	جَمْعُ مِقْوَلٍ
u'جَمْعٌ مَكَانٌ':Added, #1: 1	جَمْعُ مَكَانٍ
u'جَمَعَ مَلأٌ':Predicate, #1: 1	جَمْعُ مَكَانٍ
u'جَمَعَ مُلْكٌ':Predicate, #1: 1	جَمَعَ مَلَأَ
u'جمع مَلَكٌ':Added, #2: 2	جَمَعَ مُلْكَ
u'جَمْعٌ مَلَكٌ':Added, #2: 2	جَمْعُ مَلَكٍ
u'جمع مِمْخَضَةٌ':Added, #2: 2	جَمْعُ مَلَكٍ
u'جَمْعٌ مِمْخَضَةٌ':Added, #1: 1	جَمْعُ مِمْخَضَةٍ
u'جمع مَنٌّ':Added, #1: 1	جَمْعُ مِمْخَضَةٍ
u'جَمْعٌ مَنٌّ':Added, #2: 2	جَمْعُ مَنٍّ
u'جمع مَنَارٌ':Added, #2: 2	جَمْعُ مَنٍّ
u'جَمْعٌ مَنَارٌ':Added, #1: 1	جَمْعُ مَنَارَةٍ
u'جَمَعَ مَنَافِعُ':Predicate, #1: 1	جَمْعُ مَنَارَةٍ
u'جمع مَنَافِعُ':Added, #1: 1	جَمَعَ الْمَنَافِعَ
u'جَمْعٌ مَنَافِعُ':Added, #2: 2	جَمْعُ الْمَنَافِعِ
u'جمع مِنْجَلٌ':Added, #2: 2	جَمْعُ الْمَنَافِعِ
u'جَمْعٌ مِنْجَلٌ':Added, #1: 1	جَمْعُ مِنْجَلٍ
u'جَمَعَ مَنْزِلٌ':Predicate, #1: 1	جَمْعُ مِنْجَلٍ
u'جَمَعَ مَنْزِلٌ':Subject, #2: 2	جَمَعَ الْمَنْزِلَ
u'جمع مُهِمٌّ':Added, #1: 1	جَمَعَ الْمَنْزِلُ
u'جَمْعٌ مُهِمٌّ':Added, #1: 1	جَمْعَ الْمُهِمِّ
u'جمع مَوْرِدٌ':Added, #1: 1	جَمْعَ الْمُهِمِّ
u'جَمْعٌ مَوْرِدٌ':Added, #1: 1	جَمْعُ الْمَوْرِدِ
u'جمع مُؤَنَّثٌ':Added, #1: 1	جَمْعُ الْمَوْرِدِ
u'جمع مُؤَنَّثٌ':Added, #1: 1	جَمْعَ الْمُؤَنَّثِ
u'جَمْعٌ مُؤَنَّثٌ':Added, #1: 1	جَمْعِ الْمُؤَنَّثِ
u'جَمْعٌ مُؤَنَّثٌ':Added, #1: 1	جَمْعَ الْمُؤَنَّثِ
u'جمع مُؤَنَّثٌ':Added, #1: 1	جَمْعِ الْمُؤَنَّثِ
u'جَمْعٌ مُؤَنَّثٌ':Added, #1: 1	جَمْعِ مُؤَنَّثٍ
u'جمع مَوْهِبَةٌ':Added, #1: 1	جَمْعِ مُؤَنَّثٍ
u'جَمْعٌ مَوْهِبَةٌ':Added, #1: 1	جَمْعُ مَوْهِبَةٍ
u'جمع مَيْسُورٌ':Added, #1: 1	جَمْعُ مَوْهِبَةٍ
u'جَمْعٌ مَيْسُورٌ':Added, #1: 1	جَمْعُ الْمَيْسُورِ
u'جمع مِيقَاتٌ':Added, #1: 1	جَمْعُ الْمَيْسُورِ
u'جَمْعٌ مِيقَاتٌ':Added, #2: 2	جَمْعُ مِيقَاتٍ
u'جمع مَيْمَنَةٌ':Added, #2: 2	جَمْعُ مِيقَاتٍ
u'جَمْعٌ مَيْمَنَةٌ':Added, #1: 1	جَمْعُ مَيْمَنَةٍ
u'جَمَعَ نَارٌ':Predicate, #1: 1	جَمْعُ مَيْمَنَةٍ
u'جَمَعَ نَاسٌ':Predicate, #1: 1	جَمَعَ النَّارَ
u'جَمَعَ نَاسٌ':Predicate, #11: 11	جَمَعَ النَّاسَ
u'جَمَعَ نَاسٌ':Predicate, #1: 1	أَجْمَعَ النَّاسَ
u'جَمَعَ نَاسٌ':Subject, #1: 1	جَمَعَ النّاسَ
u'جَمَّعَ نَاسٌ':Subject, #1: 1	جَمَعَ النّاسُ
u'جمع نَاسٌ':Added, #1: 1	جَمَّعَ النَّاسُ
u'جَمْعٌ نَاسٌ':Added, #1: 1	جَمْعَ النَّاسِ
u'جمع نَاسٌ':Added, #1: 1	جَمْعَ النَّاسِ
u'جمع نَاسٌ':Added, #3: 3	جَمْعُ النَّاسِ
u'جَمْعٌ نَاسٌ':Added, #3: 3	جَمْعِ النَّاسِ
u'جَمْعٌ نَاسٌ':Added, #3: 3	جَمْعُ النَّاسِ
u'جمع نَاصِرٌ':Added, #3: 3	جَمْعِ النَّاسِ
u'جَمْعٌ نَاصِرٌ':Added, #1: 1	جَمْعُ نَاصِرٍ
u'جمع ناعُور':Added, #1: 1	جَمْعُ نَاصِرٍ
u'جَمْعٌ ناعُور':Added, #1: 1	جَمْعُ نَاعُورٍ
u'جمع نَافِرٌ':Added, #1: 1	جَمْعُ نَاعُورٍ
u'جَمْعٌ نَافِرٌ':Added, #1: 1	جَمْعُ نَافِرٍ
u'جمع نَافِلَةٌ':Added, #1: 1	جَمْعُ نَافِرٍ
u'جَمْعٌ نَافِلَةٌ':Added, #1: 1	جَمْعُ نَافِلَةٍ
u'جمع نَاقَةٌ':Added, #1: 1	جَمْعُ نَافِلَةٍ
u'جمع نَاقَة':Added, #1: 1	جَمْعُ نَاقَةٍ
u'جَمْعٌ نَاقَةٌ':Added, #1: 1	جَمْعُ نَاقَةٍ
u'جَمْعٌ نَاقَة':Added, #1: 1	جَمْعُ نَاقَةٍ
u'جَمَعَ نَائِبٌ':Subject, #1: 1	جَمْعُ نَاقَةٍ
u'جَمَعَ نَبِيٌّ':Subject, #2: 2	جَمَعَ نَائِبُهُ
u'جمع نَجَسٌ':Added, #3: 3	جَمَعَ النَّبِيُّ
u'جَمْعٌ نَجَسٌ':Added, #3: 3	جَمْعُ نَجَسٍ
u'جمع نُجُومٌ':Added, #3: 3	جَمْعُ نَجَسٍ
u'جَمْعٌ نُجُومٌ':Added, #1: 1	جَمْعُ النُّجُومِ
u'جمع نَحْوٌ':Added, #1: 1	جَمْعُ النُّجُومِ
u'جَمْعٌ نَحْوٌ':Added, #1: 1	جَمْعُ نَحْوِ
u'جمع نَذْرٌ':Added, #1: 1	جَمْعُ نَحْوِ
u'جَمْعٌ نَذْرٌ':Added, #1: 1	جَمْعُ نَذْرٍ
u'جمع نُزُلٌ':Added, #1: 1	جَمْعُ نَذْرٍ
u'جَمْعٌ نُزُلٌ':Added, #1: 1	جَمْعُ نُزُلٍ
u'جَمَعَ نِساءٌ':Predicate, #1: 1	جَمْعُ نُزُلٍ
u'جمع نَسَبٌ':Added, #1: 1	جَمَعَ نِسَاءَ
u'جَمْعٌ نَسَبٌ':Added, #1: 1	جَمْعُ نَسَبٍ
u'جمع نُسُكٌ':Added, #1: 1	جَمْعُ نَسَبٍ
u'جَمْعٌ نُسُكٌ':Added, #1: 1	جَمْعُ النُّسُكِ
u'جمع نِسْوَةٌ':Added, #1: 1	جَمْعُ النُّسُكِ
u'جَمْعٌ نِسْوَةٌ':Added, #1: 1	جَمْعِ نِسْوَةٍ
u'جمع نَسِيبٌ':Added, #1: 1	جَمْعِ نِسْوَةٍ
u'جَمْعٌ نَسِيبٌ':Added, #1: 1	جَمْعُ النَّسِيبِ
u'جمع نصاب':Added, #1: 1	جَمْعُ النَّسِيبِ
u'جَمْعٌ نصاب':Added, #1: 1	جَمْعِ النِّصَابِ
u'جمع نِصَابٌ':Added, #1: 1	جَمْعِ النِّصَابِ
u'جَمْعٌ نِصَابٌ':Added, #1: 1	جَمْعِ النِّصَابِ
u'جمع نصبة':Added, #1: 1	جَمْعِ النِّصَابِ
u'جَمْعٌ نصبة':Added, #1: 1	جَمْعُ نَصْبَةٍ
u'جمع نَصْبَةٌ':Added, #1: 1	جَمْعُ نَصْبَةٍ
u'جَمْعٌ نَصْبَةٌ':Added, #1: 1	جَمْعُ نَصْبَةٍ
u'جَمَعَ نَصِيبٌ':Predicate, #1: 1	جَمْعُ نَصْبَةٍ
u'جمع نَصِيبٌ':Added, #1: 1	جَمَعَ نَصِيبَ
u'جَمْعٌ نَصِيبٌ':Added, #1: 1	جَمْعُ النَّصِيبِ
u'جمع نَصِيبٌ':Added, #1: 1	جَمْعُ النَّصِيبِ
u'جَمْعٌ نَصِيبٌ':Added, #1: 1	جَمْعُ نَصِيبِ
u'جمع نَصِيبٌ':Added, #1: 1	جَمْعُ نَصِيبِ
u'جَمْعٌ نَصِيبٌ':Added, #2: 2	جَمْعِ النَّصِيبِ
u'جمع نَصِيبٌ':Added, #2: 2	جَمْعِ النَّصِيبِ
u'جَمْعٌ نَصِيبٌ':Added, #2: 2	جَمْعُ نَصِيبٍ
u'جمع نَعَامَةٌ':Added, #2: 2	جَمْعُ نَصِيبٍ
u'جَمْعٌ نَعَامَةٌ':Added, #1: 1	جَمْعُ نَعَامَةٍ
u'جَمَعَ نَفْعٌ':Predicate, #1: 1	جَمْعُ نَعَامَةٍ
u'جمع نَفَقَةٌ':Added, #1: 1	جَمَعَ نَفْعَ
u'جَمْعٌ نَفَقَةٌ':Added, #1: 1	جَمْعُ نَفَقَةٍ
u'جمع نَقِيضٌ':Added, #1: 1	جَمْعُ نَفَقَةٍ
u'جَمْعٌ نَقِيضٌ':Added, #1: 1	جَمْعِ النَّقِيضَيْنِ
u'جمع نكاح':Added, #1: 1	جَمْعِ النَّقِيضَيْنِ
u'جَمْعٌ نكاح':Added, #1: 1	جَمْعِ النِّكَاحِ
u'جمع نِكَاحٌ':Added, #1: 1	جَمْعِ النِّكَاحِ
u'جَمْعٌ نِكَاحٌ':Added, #1: 1	جَمْعِ النِّكَاحِ
u'جمع نَكِرٌ':Added, #1: 1	جَمْعِ النِّكَاحِ
u'جَمْعٌ نَكِرٌ':Added, #1: 1	جَمْعِ النَّكِرَةِ
u'جمع نكرة':Added, #1: 1	جَمْعِ النَّكِرَةِ
u'جَمْعٌ نكرة':Added, #1: 1	جَمْعِ النَّكِرَةِ
u'جمع نَكِرَةٌ':Added, #1: 1	جَمْعِ النَّكِرَةِ
u'جَمْعٌ نَكِرَةٌ':Added, #1: 1	جَمْعِ النَّكِرَةِ
u'جمع نمر':Added, #1: 1	جَمْعِ النَّكِرَةِ
u'جَمْعٌ نمر':Added, #1: 1	جَمْعُ نَمِرٍ
u'جمع نَمِرٌ':Added, #1: 1	جَمْعُ نَمِرٍ
u'جَمْعٌ نَمِرٌ':Added, #1: 1	جَمْعُ نَمِرٍ
u'جمع نَمِرٌ':Added, #1: 1	جَمْعُ نَمِرٍ
u'جَمْعٌ نَمِرٌ':Added, #1: 1	جَمْعُ نَمِرَةٍ
u'جمع نَهْرٌ':Added, #1: 1	جَمْعُ نَمِرَةٍ
u'جَمْعٌ نَهْرٌ':Added, #1: 1	جَمْعُ نَهْرٍ
u'جمع نُهْيَةٌ':Added, #1: 1	جَمْعُ نَهْرٍ
u'جَمْعٌ نُهْيَةٌ':Added, #3: 3	جَمْعُ نُهْيَةٍ
u'جمع نَوَازِلُ':Added, #3: 3	جَمْعُ نُهْيَةٍ
u'جَمْعٌ نَوَازِلُ':Added, #1: 1	جَمْعِ النَّوَازِلِ
u'جَمَعَ نَوَوِيٌّ':Subject, #1: 1	جَمْعِ النَّوَازِلِ
u'جمع هَائِدٌ':Added, #2: 2	جَمَعَ النَّوَوِيُّ
u'جَمْعٌ هَائِدٌ':Added, #1: 1	جَمْعُ هَائِدٍ
u'جمع هِمَّةٌ':Added, #1: 1	جَمْعُ هَائِدٍ
u'جَمْعٌ هِمَّةٌ':Added, #1: 1	جَمْعُ الْهِمَّةِ
u'جمع هِمَّةٌ':Added, #1: 1	جَمْعُ الْهِمَّةِ
u'جَمْعٌ هِمَّةٌ':Added, #1: 1	جَمْعُ هِمَّةٍ
u'جمع واحد':Added, #1: 1	جَمْعُ هِمَّةٍ
u'جَمْعٌ واحد':Added, #1: 1	جَمْعِ الْوَاحِدِ
u'جمع وَاحِدٌ':Added, #1: 1	جَمْعِ الْوَاحِدِ
u'جَمْعٌ وَاحِدٌ':Added, #1: 1	جَمْعِ الْوَاحِدِ
u'جمع واحد':Added, #1: 1	جَمْعِ الْوَاحِدِ
u'جمع واحد':Added, #1: 1	جَمْعَ وَاحِدٍ
u'جمع واحد':Added, #1: 1	جَمْعُ وَاحِدٍ
u'جَمْعٌ واحد':Added, #1: 1	جَمْعِ وَاحِدٍ
u'جَمْعٌ واحد':Added, #1: 1	جَمْعَ وَاحِدٍ
u'جَمْعٌ واحد':Added, #1: 1	جَمْعُ وَاحِدٍ
u'جمع وَاحِدٌ':Added, #1: 1	جَمْعِ وَاحِدٍ
u'جمع وَاحِدٌ':Added, #1: 1	جَمْعَ وَاحِدٍ
u'جمع وَاحِدٌ':Added, #1: 1	جَمْعُ وَاحِدٍ
u'جَمْعٌ وَاحِدٌ':Added, #1: 1	جَمْعِ وَاحِدٍ
u'جَمْعٌ وَاحِدٌ':Added, #1: 1	جَمْعَ وَاحِدٍ
u'جَمْعٌ وَاحِدٌ':Added, #1: 1	جَمْعُ وَاحِدٍ
u'جمع واحد':Added, #1: 1	جَمْعِ وَاحِدٍ
u'جَمْعٌ واحد':Added, #1: 1	جَمْعُ وَاحِدَةٍ
u'جمع وَاحِدٌ':Added, #1: 1	جَمْعُ وَاحِدَةٍ
u'جَمْعٌ وَاحِدٌ':Added, #1: 1	جَمْعُ وَاحِدَةٍ
u'جمع وَتَرٌ':Added, #1: 1	جَمْعُ وَاحِدَةٍ
u'جَمْعٌ وَتَرٌ':Added, #1: 1	جَمْعَ وَتَرٍ
u'جمع وَثَلٌ':Added, #1: 1	جَمْعَ وَتَرٍ
u'جَمْعٌ وَثَلٌ':Added, #1: 1	جَمْعُ وَثَلٍ
u'جَمَعَ وَجْهٌ':Predicate, #1: 1	جَمْعُ وَثَلٍ
u'جمع وُجُوهٌ':Added, #1: 1	جَمَعَ وَجْهَ
u'جَمْعٌ وُجُوهٌ':Added, #1: 1	جَمْعِ وُجُوهِ
u'جمع وَدَجٌ':Added, #1: 1	جَمْعِ وُجُوهِ
u'جَمْعٌ وَدَجٌ':Added, #1: 1	جَمْعُ وَدَجٍ
u'جمع وَدَعٌ':Added, #1: 1	جَمْعُ وَدَجٍ
u'جَمْعٌ وَدَعٌ':Added, #1: 1	جَمْعُ وَدَعَةٍ
u'جمع ودعة':Added, #1: 1	جَمْعُ وَدَعَةٍ
u'جَمْعٌ ودعة':Added, #1: 1	جَمْعُ وَدَعَةٍ
u'جمع وَدِيعَةٌ':Added, #1: 1	جَمْعُ وَدَعَةٍ
u'جَمْعٌ وَدِيعَةٌ':Added, #1: 1	جَمْعُ وَدِيعَةٍ
u'جمع وَدِيقَة':Added, #1: 1	جَمْعُ وَدِيعَةٍ
u'جَمْعٌ وَدِيقَة':Added, #1: 1	جَمْعُ وَدِيقَةٍ
u'جمع وَرْطَةٌ':Added, #1: 1	جَمْعُ وَدِيقَةٍ
u'جَمْعٌ وَرْطَةٌ':Added, #1: 1	جَمْعُ وَرْطَةٍ
u'جَمَعَ وسط':Predicate, #1: 1	جَمْعُ وَرْطَةٍ
u'جمع وَسَطٌ':Added, #1: 1	جَمَعَ وَسْطَ
u'جَمْعٌ وَسَطٌ':Added, #1: 1	جَمْعُ وَسَطٍ
u'جمع وَسْقٌ':Added, #1: 1	جَمْعُ وَسَطٍ
u'جَمْعٌ وَسْقٌ':Added, #1: 1	جَمْعُ وَسْقٍ
u'جمع وَصِيٌّ':Added, #1: 1	جَمْعُ وَسْقٍ
u'جَمْعٌ وَصِيٌّ':Added, #2: 2	جَمْعُ وَصِيَّةٍ
u'جمع وَصِيَّةٌ':Added, #2: 2	جَمْعُ وَصِيَّةٍ
u'جَمْعٌ وَصِيَّةٌ':Added, #2: 2	جَمْعُ وَصِيَّةٍ
u'جَمَعَ وُضُوءٌ':Predicate, #2: 2	جَمْعُ وَصِيَّةٍ
u'جَمَعَ وَقْتٌ':Predicate, #1: 1	جَمَعَ الْوُضُوءَ
u'جمع وَقْتٌ':Added, #2: 2	جَمَعَ وَقْتَ
u'جَمْعٌ وَقْتٌ':Added, #1: 1	جَمْعِ الْوَقْتِ
u'جمع وَقْتٌ':Added, #1: 1	جَمْعِ الْوَقْتِ
u'جَمْعٌ وَقْتٌ':Added, #1: 1	جَمْعُ وَقْتٍ
u'جمع ولد':Added, #1: 1	جَمْعُ وَقْتٍ
u'جَمْعٌ ولد':Added, #1: 1	جَمْعَ الْوَلَدِ
u'جمع وَلَدٌ':Added, #1: 1	جَمْعَ الْوَلَدِ
u'جَمْعٌ وَلَدٌ':Added, #1: 1	جَمْعَ الْوَلَدِ
u'جمع وَلِيٌّ':Added, #1: 1	جَمْعَ الْوَلَدِ
u'جَمْعٌ وَلِيٌّ':Added, #3: 3	جَمْعُ وَلِيٍّ
u'جمع يَانِعٌ':Added, #3: 3	جَمْعُ وَلِيٍّ
u'جَمْعٌ يَانِعٌ':Added, #1: 1	جَمْعُ يَانِعٍ
u'جمع يَدٌ':Added, #1: 1	جَمْعُ يَانِعٍ
u'جَمْعٌ يَدٌ':Added, #1: 1	جَمْعُ الْيَدَيْنِ
u'جمع يَرَاعٌ':Added, #1: 1	جَمْعُ الْيَدَيْنِ
u'جَمْعٌ يَرَاعٌ':Added, #1: 1	جَمْعُ يَرَاعَةٍ
u'جمع يَعْفُورٌ':Added, #1: 1	جَمْعُ يَرَاعَةٍ
u'جَمْعٌ يَعْفُورٌ':Added, #1: 1	جَمْعُ يَعْفُورٍ
u'جَمَعَ يَعْقُوبٌ':Subject, #1: 1	جَمْعُ يَعْفُورٍ
u'جمع يَمِينٌ':Added, #1: 1	جَمَعَ يَعْقُوبُ
u'جَمْعٌ يَمِينٌ':Added, #10: 10	جَمْعُ يَمِينٍ
u'جمع يَمِينٌ':Added, #10: 10	جَمْعُ يَمِينٍ
u'جَمْعٌ يَمِينٌ':Added, #2: 2	جَمْعُ الْيَمِينِ
u'جَمَعَ يهود':Predicate, #2: 2	جَمْعُ الْيَمِينِ
u'جَمَعَ يَهُودٌ':Predicate, #1: 1	جَمَعَ الْيَهُودَ
u'جَمَعَ يَوْمٌ':Predicate, #1: 1	جَمَعَ الْيَهُودَ
u'جُمُودٌ مَاءٌ':Added, #1: 1	جَمَعَ يَوْمَ
u'جُمُوعٌ أهْلٌ':Added, #1: 1	جُمُودِ الْمَاءِ
u'جُمُوعٌ تَكْسيرٌ':Added, #3: 3	جُمُوعِ أَهْلِ
u'جُمُوعٌ تَكْسيرٌ':Added, #1: 1	جُمُوعَ التَّكْسِيرِ
u'جُمُوعٌ رِجَالٌ':Added, #1: 1	جُمُوعِ التَّكْسِيرِ
u'جُمُوعٌ رِجَالٌ':Added, #1: 1	جُمُوعُ الرِّجَالِ
u'جُمُوعٌ رُومٌ':Added, #1: 1	جُمُوعِ الرِّجَالِ
u'جُمُوعٌ قِلَّةٌ':Added, #1: 1	جُمُوعَ الرُّومِ
u'جُمُوعٌ قِلَّةٌ':Added, #2: 2	جُمُوعِ الْقِلَّةِ
u'جُمُوعٌ كَثْرَةٌ':Added, #3: 3	جُمُوعَ الْقِلَّةِ
u'جُمُوعٌ كَثْرَةٌ':Added, #1: 1	جُمُوعُ الْكَثْرَةِ
u'جَنَابَةٌ أَعْضَاءٌ':Added, #1: 1	جُمُوعِ الْكَثْرَةِ
u'جَنَابَةٌ جماع':Added, #2: 2	جَنَابَةُ أَعْضَاءِ
u'جَنَابَةٌ جِمَاعٌ':Added, #1: 1	جَنَابَةَ الْجِمَاعِ
u'جَنَابَةٌ ذِمِّيٌّ':Added, #1: 1	جَنَابَةَ الْجِمَاعِ
u'جِنَايَةٌ أَبٌ':Added, #1: 1	جَنَابَةِ الذِّمِّيَّةِ
u'جِنَايَةٌ أَجْنَبِيٌّ':Added, #1: 1	جِنَايَةُ الْأَبِ
u'جِنَايَةٌ أحَدٌ':Added, #4: 4	جِنَايَةِ الْأَجْنَبِيِّ
u'جِنَايَةٌ أحَدٌ':Added, #1: 1	جِنَايَةَ أَحَدٍ
u'جِنَايَةٌ أحَدٌ':Added, #1: 1	جِنَايَةُ أَحَدِ
u'جِنَايَةٌ أَصْحَابٌ':Added, #2: 2	جِنَايَةِ أَحَدٍ
u'جِنَايَةٌ إفْسَادٌ':Added, #1: 1	جِنَايَةُ أَصْحَابِهِ
u'جِنَايَةٌ إفْسَادٌ':Added, #1: 1	جِنَايَةُ إفْسَادِ
u'جِنَايَةٌ إِفْطارٌ':Added, #1: 1	جِنَايَةُ الْإِفْسَادِ
u'جِنَايَةٌ الْمَرْءُ':Added, #1: 1	جِنَايَةُ الْإِفْطَارِ
u'جِنَايَةٌ أُمٌّ':Added, #4: 4	جِنَايَةَ الْمَرْءِ
u'جِنَايَةٌ أُمٌّ':Added, #1: 1	جِنَايَةِ الْأُمِّ
u'جِنَايَةٌ أُمٌّ':Added, #1: 1	جِنَايَةَ أُمِّ
u'جِنَايَةٌ أُمٌّ':Added, #1: 1	جِنَايَةِ أُمِّهِ
u'جِنَايَةٌ أُمٌّ':Added, #2: 2	جِنَايَةُ أُمِّ
u'جِنَايَةٌ أمَةٌ':Added, #5: 5	جِنَايَةِ أُمِّ
u'جِنَايَةٌ إِنْسانٌ':Added, #1: 1	جِنَايَةِ الْأَمَةِ
u'جِنَايَةٌ إِنْسانٌ':Added, #1: 1	جِنَايَةَ الْإِنْسَانِ
u'جِنَايَةٌ إِنْسانٌ':Added, #1: 1	جِنَايَةُ الْإِنْسَانِ
u'جِنَايَةٌ أَوَّلُ':Added, #4: 4	جِنَايَةِ الْإِنْسَانِ
u'جِنَايَةٌ بَائِعٌ':Added, #1: 1	جِنَايَةُ الْأَوَّلِ
u'جِنَايَةٌ بَائِعٌ':Added, #1: 1	جِنَايَةُ الْبَائِعِ
u'جِنَايَةٌ بَائِعٌ':Added, #2: 2	جِنَايَةَ الْبَائِعِ
u'جِنَايَةٌ بَصَرٌ':Added, #6: 6	جِنَايَةِ الْبَائِعِ
u'جِنَايَةٌ بِنْتٌ':Added, #1: 1	جِنَايَةُ الْبَصَرِ
u'جِنَايَةٌ بِنْتٌ':Added, #1: 1	جِنَايَةُ الْبِنْتِ
u'جِنَايَةٌ بَهائِمُ':Added, #1: 1	جِنَايَةِ الْبِنْتِ
u'جِنَايَةٌ بَهيمٌ':Added, #1: 1	جِنَايَةِ الْبَهَائِمِ
u'جِنَايَةٌ بَهيمٌ':Added, #4: 4	جِنَايَةَ الْبَهِيمَةِ
u'جِنَايَةٌ بَهِيمَةٌ':Added, #8: 8	جِنَايَةِ الْبَهِيمَةِ
u'جِنَايَةٌ بَهِيمَةٌ':Added, #4: 4	جِنَايَةَ الْبَهِيمَةِ
u'جِنَايَةٌ تَامٌّ':Added, #8: 8	جِنَايَةِ الْبَهِيمَةِ
u'جِنَايَةٌ جماع':Added, #1: 1	جِنَايَةٍ تَامَّةٍ
u'جِنَايَةٌ جِمَاعٌ':Added, #1: 1	جِنَايَةِ الْجِمَاعِ
u'جِنَايَةٌ جَمِيع':Added, #1: 1	جِنَايَةِ الْجِمَاعِ
u'جِنَايَةٌ حائِطٌ':Added, #1: 1	جِنَايَةَ الْجَمِيعِ
u'جِنَايَةٌ حُرٌّ':Added, #1: 1	جِنَايَةِ الْحَائِطِ
u'جِنَايَةٌ حُرٌّ':Added, #3: 3	جِنَايَةُ الْحُرِّ
u'جِنَايَةٌ حَفْرٌ':Added, #7: 7	جِنَايَةِ الْحُرِّ
u'جِنَايَةٌ حَفْرٌ':Added, #1: 1	جِنَايَةِ حَفْرِهِ
u'جِنَايَةٌ حَلْقٌ':Added, #2: 2	جِنَايَةِ الْحَفْرِ
u'جِنَايَةٌ خَطَأٌ':Added, #1: 1	جِنَايَةَ الْحَلْقِ
u'جِنَايَةٌ خَطَأٌ':Added, #1: 1	جِنَايَةِ خَطَأٍ
u'جِنَايَةٌ خَطَأٌ':Added, #2: 2	جِنَايَةُ الْخَطَأِ
u'جِنَايَةٌ خَطَأٌ':Added, #3: 3	جِنَايَةَ الْخَطَأِ
u'جِنَايَةٌ خَطَأٌ':Added, #4: 4	جِنَايَةَ خَطَأٍ
u'جِنَايَةٌ دَابَّةٌ':Added, #5: 5	جِنَايَةِ الْخَطَأِ
u'جِنَايَةٌ دَابَّةٌ':Added, #1: 1	جِنَايَةِ الدَّابَّةِ
u'جِنَايَةٌ دَابَّةٌ':Added, #1: 1	جِنَايَةُ دَابَّتِهِ
u'جِنَايَةٌ رَاهِنٌ':Added, #2: 2	جِنَايَةَ الدَّابَّةِ
u'جِنَايَةٌ رَقيقٌ':Added, #1: 1	جِنَايَةَ الرَّاهِنِ
u'جِنَايَةٌ رَقيق':Added, #1: 1	جِنَايَةِ رَقِيقِ
u'جِنَايَةٌ رَقيقٌ':Added, #1: 1	جِنَايَةِ رَقِيقِ
u'جِنَايَةٌ رَقيق':Added, #3: 3	جِنَايَةُ الرَّقِيقِ
u'جِنَايَةٌ رَقيقٌ':Added, #3: 3	جِنَايَةُ الرَّقِيقِ
u'جِنَايَةٌ رَقيق':Added, #5: 5	جِنَايَةِ الرَّقِيقِ
u'جِنَايَةٌ رَهْنٌ':Added, #5: 5	جِنَايَةِ الرَّقِيقِ
u'جِنَايَةٌ رَهْنٌ':Added, #2: 2	جِنَايَةَ الرَّهْنِ
u'جِنَايَةٌ رَهْنٌ':Added, #5: 5	جِنَايَةُ الرَّهْنِ
u'جِنَايَةٌ زَوْجٌ':Added, #6: 6	جِنَايَةِ الرَّهْنِ
u'جِنَايَةٌ سَرقَةٌ':Added, #1: 1	جِنَايَةِ الزَّوْجِ
u'جِنَايَةٌ سَرِقَةٌ':Added, #1: 1	جِنَايَةُ السَّرِقَةِ
u'جِنَايَةٌ شَخْصٌ':Added, #1: 1	جِنَايَةُ السَّرِقَةِ
u'جِنَايَةٌ شرب':Added, #1: 1	جِنَايَةِ الشَّخْصِ
u'جِنَايَةٌ شُرْبٌ':Added, #1: 1	جِنَايَةَ الشُّرْبِ
u'جِنَايَةٌ شَرْعِيٌّ':Added, #1: 1	جِنَايَةَ الشُّرْبِ
u'جِنَايَةٌ ضَارِبٌ':Added, #3: 3	جِنَايَةٍ شَرْعِيَّةٍ
u'جِنَايَةٌ طِيبٌ':Added, #1: 1	جِنَايَةُ الضَّارِبِ
u'جِنَايَةٌ عَائِدٌ':Added, #1: 1	جِنَايَةَ الطِّيبِ
u'جِنَايَةٌ عَبْدٌ':Added, #1: 1	جِنَايَةَ الْعَائِدِ
u'جِنَايَةٌ عَبْدٌ':Added, #12: 12	جِنَايَةَ الْعَبْدِ
u'جِنَايَةٌ عَبْدٌ':Added, #12: 12	جِنَايَةُ الْعَبْدِ
u'جِنَايَةٌ عَبْدٌ':Added, #1: 1	جِنَايَةَ عَبْدٍ
u'جِنَايَةٌ عَبْدٌ':Added, #1: 1	جِنَايَةَ عَبْدِ
u'جِنَايَةٌ عَبْدٌ':Added, #1: 1	جِنَايَةُ عَبْدِ
u'جِنَايَةٌ عَبْدٌ':Added, #1: 1	جِنَايَةَ عَبْدِهِ
u'جِنَايَةٌ عَبْدٌ':Added, #21: 21	جِنَايَةِ الْعَبْدِ
u'جِنَايَةٌ عَبْدٌ':Added, #2: 2	جِنَايَةُ عَبْدٍ
u'جِنَايَةٌ عَبْدٌ':Added, #4: 4	جِنَايَةِ عَبْدِهِ
u'جِنَايَةٌ عَبِيدٌ':Added, #5: 5	جِنَايَةِ عَبْدِ
u'جِنَايَةٌ عجماء':Added, #1: 1	جِنَايَةَ الْعَبِيدِ
u'جِنَايَةٌ عَجْمَاءُ':Added, #2: 2	جِنَايَةَ الْعَجْمَاءِ
u'جِنَايَةٌ عَدَمٌ':Added, #2: 2	جِنَايَةَ الْعَجْمَاءِ
u'جِنَايَةٌ عَمْدٌ':Added, #1: 1	جِنَايَةُ عَدَمِ
u'جِنَايَةٌ عَمْدٌ':Added, #1: 1	جِنَايَةُ الْعَمْدِ
u'جِنَايَةٌ عَمْدٌ':Added, #2: 2	جِنَايَةُ عَمْدٍ
u'جِنَايَةٌ عَمْدٌ':Added, #3: 3	جِنَايَةِ عَمْدٍ
u'جِنَايَةٌ غَاصِبٌ':Added, #9: 9	جِنَايَةِ الْعَمْدِ
u'جِنَايَةٌ غُلاَمٌ':Added, #1: 1	جِنَايَةِ الْغَاصِبِ
u'جِنَايَةٌ غير':Added, #1: 1	جِنَايَةِ الْغُلاَمِ
u'جِنَايَةٌ غير':Added, #1: 1	جِنَايَةَ غَيْرِ
u'جِنَايَةٌ غَيْرٌ':Added, #1: 1	جِنَايَةُ غَيْرِ
u'جِنَايَةٌ غَيْرٌ':Added, #1: 1	جِنَايَةَ غَيْرِ
u'جِنَايَةٌ غير':Added, #1: 1	جِنَايَةُ غَيْرِ
u'جِنَايَةٌ غَيْرٌ':Added, #2: 2	جِنَايَةُ الْغَيْرِ
u'جِنَايَةٌ غير':Added, #2: 2	جِنَايَةُ الْغَيْرِ
u'جِنَايَةٌ غَيْرٌ':Added, #2: 2	جِنَايَةِ غَيْرِ
u'جِنَايَةٌ غير':Added, #2: 2	جِنَايَةِ غَيْرِ
u'جِنَايَةٌ غَيْرٌ':Added, #2: 2	جِنَايَةِ غَيْرِهِ
u'جِنَايَةٌ فَارِغٌ':Added, #2: 2	جِنَايَةِ غَيْرِهِ
u'جِنَايَةٌ فَارِغٌ':Added, #1: 1	جِنَايَةِ الْفَارِغِ
u'جِنَايَةٌ فراغ':Added, #2: 2	جِنَايَةُ الْفَارِغِ
u'جِنَايَةٌ فَرَاغٌ':Added, #1: 1	جِنَايَةَ الْفَرَاغِ
u'جِنَايَةٌ فِعْلٌ':Added, #1: 1	جِنَايَةَ الْفَرَاغِ
u'جِنَايَةٌ فِعْلٌ':Added, #1: 1	جِنَايَةَ الْفِعْلِ
u'جِنَايَةٌ فِعْلٌ':Added, #1: 1	جِنَايَةُ الْفِعْلِ
u'جِنَايَةٌ قتل':Added, #1: 1	جِنَايَةِ الْفِعْلِ
u'جِنَايَةٌ قَتْلٌ':Added, #3: 3	جِنَايَةِ الْقَتْلِ
u'جِنَايَةٌ قَذْفٌ':Added, #3: 3	جِنَايَةِ الْقَتْلِ
u'جِنَايَةٌ مَالِكٌ':Added, #2: 2	جِنَايَةُ قَذْفٍ
u'جِنَايَةٌ مُبْتَدِئٌ':Added, #2: 2	جِنَايَةِ الْمَالِكِ
u'جِنَايَةٌ مَبِيعٌ':Added, #1: 1	جِنَايَةِ الْمُبْتَدِئِ
u'جِنَايَةٌ مُتَعَلِّقٌ':Added, #1: 1	جِنَايَةِ الْمَبِيعِ
u'جِنَايَةٌ مُحْرِمٌ':Added, #1: 1	جِنَايَةٍ مُتَعَلِّقَةٍ
u'جِنَايَةٌ مُحْرِمٌ':Added, #1: 1	جِنَايَةُ الْمُحْرِمِ
u'جِنَايَةٌ مَحْض':Added, #1: 1	جِنَايَةِ الْمُحْرِمِ
u'جِنَايَةٌ مُدَبَّرٌ':Added, #1: 1	جِنَايَةٍ مَحْضَةٍ
u'جِنَايَةٌ مُدَبَّرٌ':Added, #14: 14	جِنَايَةِ الْمُدَبَّرِ
u'جِنَايَةٌ مُدَبَّرٌ':Added, #3: 3	جِنَايَةَ الْمُدَبَّرِ
u'جِنَايَةٌ مُرْتَهِنٌ':Added, #3: 3	جِنَايَةُ الْمُدَبَّرِ
u'جِنَايَةٌ مَرْهُونٌ':Added, #1: 1	جِنَايَةُ الْمُرْتَهِنِ
u'جِنَايَةٌ مَرْهُونٌ':Added, #1: 1	جِنَايَةَ الْمَرْهُونِ
u'جِنَايَةٌ مَشْغُولٌ':Added, #1: 1	جِنَايَةِ الْمَرْهُونِ
u'جِنَايَةٌ مَشْغُولٌ':Added, #1: 1	جِنَايَةَ الْمَشْغُولِ
u'جِنَايَةٌ مَضْمُونٌ':Added, #1: 1	جِنَايَةِ الْمَشْغُولِ
u'جِنَايَةٌ مُعْتَقٌ':Added, #2: 2	جِنَايَةٍ مَضْمُونَةٍ
u'جِنَايَةٌ مَعْقُودٌ':Added, #1: 1	جِنَايَةِ الْمُعْتَقِ
u'جِنَايَةٌ مَغْصُوب':Added, #2: 2	جِنَايَةِ الْمَعْقُودِ
u'جِنَايَةٌ مَغْصُوب':Added, #1: 1	جِنَايَةُ الْمَغْصُوبِ
u'جِنَايَةٌ مَغْصُوب':Added, #2: 2	جِنَايَةِ الْمَغْصُوبِ
u'جِنَايَةٌ مُفْلِسٌ':Added, #4: 4	جِنَايَةَ الْمَغْصُوبِ
u'جِنَايَةٌ مَمَالِيكُ':Added, #1: 1	جِنَايَةِ الْمُفْلِسِ
u'جِنَايَةٌ مَمْلُوكٌ':Added, #1: 1	جِنَايَةِ الْمَمَالِيكِ
u'جِنَايَةٌ مَمْلُوكٌ':Added, #11: 11	جِنَايَةِ الْمَمْلُوكِ
u'جِنَايَةٌ مَمْلُوكٌ':Added, #1: 1	جِنَايَةَ الْمَمْلُوكِ
u'جِنَايَةٌ مَمْلُوكٌ':Added, #2: 2	جِنَايَةُ مَمْلُوكٍ
u'جِنَايَةٌ نَفْسٌ':Added, #4: 4	جِنَايَةُ الْمَمْلُوكِ
u'جِنَايَةٌ نَفْسٌ':Added, #1: 1	جِنَايَةَ نَفْسٍ
u'جِنَايَةٌ نَفْسٌ':Added, #1: 1	جِنَايَةِ نَفْسِهِ
u'جِنَايَةٌ واحد':Added, #2: 2	جِنَايَةُ النَّفْسِ
u'جِنَايَةٌ وَاحِدٌ':Added, #1: 1	جِنَايَةٍ وَاحِدَةٍ
u'جِنَايَةٌ ولد':Added, #1: 1	جِنَايَةٍ وَاحِدَةٍ
u'جِنَايَةٌ ولد':Added, #1: 1	جِنَايَةَ الْوَلَدِ
u'جِنَايَةٌ ولد':Added, #1: 1	جِنَايَةُ الْوَلَدِ
u'جِنَايَةٌ وَلَدٌ':Added, #1: 1	جِنَايَةِ الْوَلَدِ
u'جِنَايَةٌ وَلَدٌ':Added, #1: 1	جِنَايَةَ الْوَلَدِ
u'جِنَايَةٌ وَلَدٌ':Added, #1: 1	جِنَايَةُ الْوَلَدِ
u'جِنَايَةٌ ولد':Added, #1: 1	جِنَايَةِ الْوَلَدِ
u'جِنَايَةٌ ولد':Added, #2: 2	جِنَايَةَ وَلَدِ
u'جِنَايَةٌ وَلَدٌ':Added, #2: 2	جِنَايَةِ وَلَدِ
u'جِنَايَةٌ وَلَدٌ':Added, #2: 2	جِنَايَةَ وَلَدِ
u'جِنَايَةٌ يَدٌ':Added, #2: 2	جِنَايَةِ وَلَدِ
u'جِنَايَةٌ يَدٌ':Added, #1: 1	جِنَايَةَ يَدِهِ
u'جِنَايَةٌ يَدٌ':Added, #1: 1	جِنَايَةُ يَدِهِ
u'جَنَبَ قَالٌ':Predicate, #1: 1	جِنَايَةِ يَدِهِ
u'جَنَحَ اِبْنٌ':Subject, #1: 1	جَنَبَ قَالَ
u'جَنَحَ بَائِعٌ':Subject, #1: 1	جَنَحَ ابْنُ
u'جَنَحَ لَيْلٌ':Subject, #1: 1	جَنَحَ الْبَائِعُ
u'جَنَحَ مُحَقِّقٌ':Subject, #1: 1	جَنَحَ اللَّيْلُ
u'جَنَحَ مُؤَلِّفٌ':Subject, #2: 2	جَنَحَ الْمُحَقِّقُ
u'جَنَّ ظَلامٌ':Subject, #1: 1	جَنَحَ الْمُؤَلِّفُ
u'جَنَّ لَيْلٌ':Subject, #1: 1	جَنَّ الظَّلَامُ
u'جَنَّ لَيْلٌ':Subject, #1: 1	جَنَّ لَيْلٌ
u'جُنُونٌ أحَدٌ':Added, #2: 2	جَنَّ اللَّيْلُ
u'جُنُونٌ رَجُلٌ':Added, #1: 1	جُنُونُ أَحَدِ
u'جُنُونٌ زَوْجٌ':Added, #2: 2	جُنُونِ الرَّجُلِ
u'جُنُونٌ زَوْجٌ':Added, #1: 1	جُنُونِ الزَّوْجِ
u'جُنُونٌ عَاقِدٌ':Added, #2: 2	جُنُونُ الزَّوْجِ
u'جُنُونٌ عَبْدٌ':Added, #1: 1	جُنُونِ الْعَاقِدِ
u'جُنُونٌ كَافِرٌ':Added, #1: 1	جُنُونَ الْعَبْدِ
u'جُنُونٌ مُرْتَدٌّ':Added, #1: 1	جُنُونُ الْكَافِرِ
u'جُنُونٌ مُطْبِقٌ':Added, #1: 1	جُنُونِ الْمُرْتَدِّ
u'جُنُونٌ مُعِير':Added, #1: 1	جُنُونٍ مُطْبِقٍ
u'جُنُونٌ وَاهِبٌ':Added, #1: 1	جُنُونِ الْمُعِيرِ
u'جُنُونٌ وَلِيٌّ':Added, #2: 2	جُنُونُ الْوَاهِبِ
u'جَنَى أَبٌ':Subject, #2: 2	جُنُونَ الْوَلِيِّ
u'جَنَى اِبْنٌ':Subject, #1: 1	جَنَى الْأَبُ
u'جَنَى اِبْنٌ':Subject, #2: 2	جَنَى ابْنُ
u'جَنَى أَجْنَبِيٌّ':Subject, #4: 4	جَنَى ابْنُهُ
u'جَنَى أَجْنَبِيٌّ':Subject, #1: 1	جَنَى أَجْنَبِيٌّ
u'جَنَى أحَدٌ':Subject, #1: 1	جَنَى الْأَجْنَبِيُّ
u'جَنَى أَسْفَلُ':Predicate, #2: 2	جَنَى أَحَدٌ
u'جَنَى أَسْفَلُ':Subject, #1: 1	جَنَى الْأَسْفَلَ
u'جَنَى إِنْسانٌ':Subject, #3: 3	جَنَى الْأَسْفَلُ
u'جَنَى أَوَّلُ':Predicate, #4: 4	جَنَى إنْسَانٌ
u'جَنَى بَائِعٌ':Subject, #1: 1	جَنَى أَوَّلَ
u'جَنَى بَائِعٌ':Subject, #1: 1	جَنَى بَائِعٌ
u'جَنَى بَعْضٌ':Subject, #2: 2	جَنَى الْبَائِعُ
u'جَنَى بِيَعٌ':Predicate, #1: 1	جَنَى بَعْضُ
u'جَنَى ثَانِي':Predicate, #1: 1	جَنَى بِيعَ
u'جَنَى ثَانِيَةٌ':Predicate, #1: 1	جَنَى الثَّانِيَةَ
u'جَنَى ثَمَرٌ':Predicate, #1: 1	جَنَى الثَّانِيَةَ
u'جَنَى جِنَايَةٌ':Predicate, #1: 1	جَنَى الثَّمَرَ
u'جَنَى حُرٌّ':Subject, #2: 2	جَنَى جِنَايَةَ
u'جَنَى حُرٌّ':Subject, #2: 2	جَنَى حُرٌّ
u'جَنَى رَجُلٌ':Subject, #5: 5	جَنَى الْحُرُّ
u'جَنَى رَجُلٌ':Subject, #1: 1	جَنَى الرَّجُلُ
u'جَنَى رَهْنٌ':Subject, #1: 1	جَنَى رَجُلٌ
u'جَنَى سَيِّدٌ':Subject, #7: 7	جَنَى الرَّهْنُ
u'جَنَى صَغِيرٌ':Subject, #2: 2	جَنَى السَّيِّدُ
u'جَنَى عَامِلٌ':Subject, #1: 1	جَنَى صَغِيرٌ
u'جَنَى عَبْدٌ':Subject, #1: 1	جَنَى الْعَامِلُ
u'جَنَى عَبْدٌ':Subject, #10: 10	جَنَى عَبْدٌ
u'جَنَى عَبْدٌ':Subject, #4: 4	جَنَى عَبْدُ
u'جَنَى عَبْدٌ':Subject, #53: 53	جَنَى الْعَبْدُ
u'جَنَى عند':Predicate, #5: 5	جَنَى عَبْدُهُ
u'جَنَى غَاصِبٌ':Subject, #12: 12	جَنَى عِنْدَ
u'جَنَى غير':Subject, #1: 1	جَنَى الْغَاصِبُ
u'جَنَى غَيْرٌ':Subject, #1: 1	جَنَى غَيْرُ
u'جَنَى قَاتِلٌ':Subject, #1: 1	جَنَى غَيْرُ
u'جَنَى قِنٌّ':Subject, #1: 1	جَنَى الْقَاتِلُ
u'جَنَى لَقِيطٌ':Subject, #1: 1	جَنَى الْقِنُّ
u'جَنَى مَبِيعٌ':Subject, #1: 1	جَنَى اللَّقِيطُ
u'جَنَى مُدَبَّرٌ':Subject, #1: 1	جَنَى الْمَبِيعُ
u'جَنَى مُدَبَّرٌ':Subject, #2: 2	جَنَى مُدَبَّرٌ
u'جَنَى مَرْهُونٌ':Subject, #8: 8	جَنَى الْمُدَبَّرُ
u'جَنَى مَرْهُونٌ':Subject, #1: 1	جَنَى الْمَرْهُونُ
u'جَنَى مُسْلِمٌ':Subject, #1: 1	جَنَى الْمَرْهُونَةُ
u'جَنَى مَغْصُوب':Predicate, #1: 1	جَنَى مُسْلِمٌ
u'جَنَى مَغْصُوب':Subject, #1: 1	جَنَى الْمَغْصُوبَ
u'جَنَى مَمْلُوكٌ':Subject, #3: 3	جَنَى الْمَغْصُوبُ
u'جَنَى مَوْقُوفٌ':Subject, #5: 5	جَنَى الْمَمْلُوكُ
u'جَنَى نِصْفٌ':Predicate, #1: 1	جَنَى الْمَوْقُوفُ
u'جَنَى وَقْفٌ':Subject, #1: 1	جَنَى نِصْفَ
u'جَنَى ولد':Subject, #2: 2	جَنَى الْوَقْفُ
u'جَنَى وَلَدٌ':Subject, #11: 11	جَنَى الْوَلَدُ
u'جَنَى ولد':Subject, #11: 11	جَنَى الْوَلَدُ
u'جَنَى وَلَدٌ':Subject, #1: 1	جَنَى وَلَدُ
u'جَنَى ولد':Subject, #1: 1	جَنَى وَلَدُ
u'جَنَى وَلَدٌ':Subject, #1: 1	جَنَى وَلَدُهُ
u'جهاد أَعْدَاءٌ':Added, #1: 1	جَنَى وَلَدُهُ
u'جِهَادٌ أَعْدَاءٌ':Added, #1: 1	جِهَادِ أَعْدَاءِ
u'جهاد أهْلٌ':Added, #1: 1	جِهَادِ أَعْدَاءِ
u'جهاد أهْلٌ':Added, #1: 1	جِهَادُ أَهْلِ
u'جِهَادٌ أهْلٌ':Added, #1: 1	جِهَادِ أَهْلِ
u'جِهَادٌ أهْلٌ':Added, #1: 1	جِهَادُ أَهْلِ
u'جهاد أهْلٌ':Added, #1: 1	جِهَادِ أَهْلِ
u'جِهَادٌ أهْلٌ':Added, #1: 1	جِهَادَ أَهْلِهِ
u'جهاد تَطَوُّعٌ':Added, #1: 1	جِهَادَ أَهْلِهِ
u'جِهَادٌ تَطَوُّعٌ':Added, #1: 1	جِهَادِ التَّطَوُّعِ
u'جهاد دَافِعٌ':Added, #1: 1	جِهَادِ التَّطَوُّعِ
u'جِهَادٌ دَافِعٌ':Added, #1: 1	جِهَادُ الدَّافِعِ
u'جهاد دُرٌّ':Added, #1: 1	جِهَادُ الدَّافِعِ
u'جِهَادٌ دُرٌّ':Added, #1: 1	جِهَادِ الدُّرِّ
u'جهاد ضَرُورَةٌ':Added, #1: 1	جِهَادِ الدُّرِّ
u'جِهَادٌ ضَرُورَةٌ':Added, #1: 1	جِهَادُ ضَرُورَةٍ
u'جهاد عَدُوٌّ':Added, #1: 1	جِهَادُ ضَرُورَةٍ
u'جِهَادٌ عَدُوٌّ':Added, #1: 1	جِهَادِ عَدُوّهِ
u'جهاد عَدُوٌّ':Added, #1: 1	جِهَادِ عَدُوّهِ
u'جِهَادٌ عَدُوٌّ':Added, #2: 2	جِهَادِ عَدُوِّهِ
u'جهاد قَوْمٌ':Added, #2: 2	جِهَادِ عَدُوِّهِ
u'جِهَادٌ قَوْمٌ':Added, #1: 1	جِهَادِ الْقَوْمِ
u'جهاد كَبِيرٌ':Added, #1: 1	جِهَادِ الْقَوْمِ
u'جِهَادٌ كَبِيرٌ':Added, #5: 5	جِهَادُ الْكَبِيرِ
u'جهاد كُفَّارٌ':Added, #5: 5	جِهَادُ الْكَبِيرِ
u'جِهَادٌ كُفَّارٌ':Added, #2: 2	جِهَادِ الْكُفَّارِ
u'جهاد نَفْسٌ':Added, #2: 2	جِهَادِ الْكُفَّارِ
u'جِهَادٌ نَفْسٌ':Added, #1: 1	جِهَادِ نَفْسِهِ
u'جهاد نَفْسٌ':Added, #1: 1	جِهَادِ نَفْسِهِ
u'جِهَادٌ نَفْسٌ':Added, #3: 3	جِهَادُ النَّفْسِ
u'جَهْدٌ بَلاءٌ':Added, #3: 3	جِهَادُ النَّفْسِ
u'جَهْدٌ خُصُومَةٌ':Added, #2: 2	جَهْدِ الْبَلَاءِ
u'جَهَدَ مُسْلِمٌ':Predicate, #1: 1	جَهْدَ الْخُصُومَةِ
u'جَهْدٌ مُضْطَرٌّ':Added, #1: 1	جَهَدَ الْمُسْلِمِينَ
u'جَهْدٌ مُقِلٌّ':Added, #1: 1	جَهْدُ الْمُضْطَرِّ
u'جَهْدٌ مُقِلٌّ':Added, #1: 1	جَهْدَ الْمُقِلِّ
u'جَهِدَ نَاسٌ':Subject, #1: 1	جَهْدُ الْمُقِلِّ
u'جَهَرَ إمَامٌ':Subject, #1: 1	جَهِدَ النَّاسُ
u'جهر إمَامٌ':Added, #9: 9	جَهَرَ الْإِمَامُ
u'جَهْرٌ إمَامٌ':Added, #1: 1	جَهْرُ إمَامٍ
u'جهر إمَامٌ':Added, #1: 1	جَهْرُ إمَامٍ
u'جَهْرٌ إمَامٌ':Added, #2: 2	جَهْرِ إمَامِهِ
u'جهر إمَامٌ':Added, #2: 2	جَهْرِ إمَامِهِ
u'جَهْرٌ إمَامٌ':Added, #3: 3	جَهْرِ الإِمَامِ
u'جهر إمَامٌ':Added, #3: 3	جَهْرِ الإِمَامِ
u'جَهْرٌ إمَامٌ':Added, #7: 7	جَهْرِ الْإِمَامِ
u'جهر رَجُلٌ':Added, #7: 7	جَهْرِ الْإِمَامِ
u'جَهْرٌ رَجُلٌ':Added, #1: 1	جَهْرِ الرَّجُلِ
u'جَهَرَ رَسُولٌ':Subject, #1: 1	جَهْرِ الرَّجُلِ
u'جهر صَلاَةٌ':Added, #2: 2	جَهَرَ رَسُولُ
u'جَهْرٌ صَلاَةٌ':Added, #1: 1	جَهْرِ الصَّلَاةِ
u'جَهَرَ عُمَرٌ':Subject, #1: 1	جَهْرِ الصَّلَاةِ
u'جهر غير':Added, #1: 1	جَهَرَ عُمَرُ
u'جهر غَيْرٌ':Added, #1: 1	جَهْرُ غَيْرِهِ
u'جَهْرٌ غير':Added, #1: 1	جَهْرُ غَيْرِهِ
u'جَهْرٌ غَيْرٌ':Added, #1: 1	جَهْرُ غَيْرِهِ
u'جَهَرَ قَالٌ':Predicate, #1: 1	جَهْرُ غَيْرِهِ
u'جهر قِرَاءةٌ':Added, #1: 1	جَهَرَ قَالَ
u'جَهْرٌ قِرَاءةٌ':Added, #1: 1	جَهْرِ الْقِرَاءَةِ
u'جهر قول':Added, #1: 1	جَهْرِ الْقِرَاءَةِ
u'جَهْرٌ قول':Added, #1: 1	جَهْرِ الْقَوْلِ
u'جهر قَوْلٌ':Added, #1: 1	جَهْرِ الْقَوْلِ
u'جَهْرٌ قَوْلٌ':Added, #1: 1	جَهْرِ الْقَوْلِ
u'جهر قَوْمٌ':Added, #1: 1	جَهْرِ الْقَوْلِ
u'جَهْرٌ قَوْمٌ':Added, #1: 1	جَهْرُ الْقَوْمِ
u'جَهَرَ مِقْدَارٌ':Predicate, #1: 1	جَهْرُ الْقَوْمِ
u'جَهَرَ مُنْفَرِدٌ':Subject, #1: 1	جَهَرَ مِقْدَارَ
u'جهر مُنْفَرِدٌ':Added, #2: 2	جَهَرَ الْمُنْفَرِدُ
u'جهر مُنْفَرِدٌ':Added, #1: 1	جَهْرَ الْمُنْفَرِدِ
u'جَهْرٌ مُنْفَرِدٌ':Added, #1: 1	جَهْرِ الْمُنْفَرِدِ
u'جَهْرٌ مُنْفَرِدٌ':Added, #1: 1	جَهْرَ الْمُنْفَرِدِ
u'جَهَرَ نَبِيٌّ':Subject, #1: 1	جَهْرِ الْمُنْفَرِدِ
u'جَهَّزَ جَيْشٌ':Predicate, #1: 1	جَهَرَ النَّبِيُّ
u'جَهَّزَ رَسُولٌ':Subject, #1: 1	جَهَّزَ جَيْشَ
u'جَهَّزَ صِنْفٌ':Predicate, #2: 2	جَهَّزَ رَسُولُ
u'جَهَّزَ عُمَرٌ':Subject, #1: 1	جَهَّزَ الصِّنْفَ
u'جَهَّزَ وَصِيٌّ':Subject, #1: 1	جَهَّزَ عُمَرُ
u'جَهِلَ إِبْطَالٌ':Predicate, #1: 1	جَهَّزَ الْوَصِيُّ
u'جَهِلَ إجَارَةٌ':Predicate, #1: 1	جَهِلَ الْإِبْطَالَ
u'جهل أَجَلٌ':Added, #1: 1	جَهِلَ الْإِجَارَةَ
u'جَهْلٌ أَجَلٌ':Added, #1: 1	جَهْلُ الْأَجَلِ
u'جَهِلَ أَجِيرٌ':Subject, #1: 1	جَهْلُ الْأَجَلِ
u'جَهِلَ أَحادِيثُ':Predicate, #1: 1	جَهِلَ الْأَجِيرُ
u'جَهِلَ أَحْجارٌ':Predicate, #1: 1	جَهِلَ أَحَادِيثَ
u'جهل أحَدٌ':Added, #1: 1	جَهِلَ الْأَحْجَارَ
u'جَهْلٌ أحَدٌ':Added, #1: 1	جَهْلُ أَحَدِ
u'جَهِلَ إِحْرَامٌ':Predicate, #1: 1	جَهْلُ أَحَدِ
u'جَهِلَ أَحْكَامٌ':Predicate, #1: 1	جَهِلَ إحْرَامَ
u'جَهِلَ اِخْتِصَاصٌ':Predicate, #1: 1	جَهِلَ أَحْكَامَ
u'جهل أرْبَابٌ':Added, #1: 1	جَهِلَ اخْتِصَاصَ
u'جَهْلٌ أرْبَابٌ':Added, #2: 2	جَهْلِ أَرْبَابِهِ
u'جهل إِسْلامٌ':Added, #2: 2	جَهْلِ أَرْبَابِهِ
u'جَهْلٌ إِسْلامٌ':Added, #1: 1	جَهْلَ الْإِسْلَامِ
u'جهل أصل':Added, #1: 1	جَهْلَ الْإِسْلَامِ
u'جهل أًصْلٌ':Added, #1: 1	جَهْلِ أَصْلِ
u'جَهْلٌ أصل':Added, #1: 1	جَهْلِ أَصْلِ
u'جَهْلٌ أًصْلٌ':Added, #1: 1	جَهْلِ أَصْلِ
u'جهل إِعْدادٌ':Added, #1: 1	جَهْلِ أَصْلِ
u'جَهْلٌ إِعْدادٌ':Added, #1: 1	جَهْلِ الْإِعْدَادِ
u'جَهِلَ إفْلاَسٌ':Predicate, #1: 1	جَهْلِ الْإِعْدَادِ
u'جَهِلَ إقامَةٌ':Predicate, #1: 1	جَهِلَ الْإِفْلَاسَ
u'جهل أَكْثَرُ':Added, #2: 2	جَهِلَ الْإِقَامَةَ
u'جَهْلٌ أَكْثَرُ':Added, #1: 1	جَهْلُ أَكْثَرِ
u'جهل الْمَرْأَةُ':Added, #1: 1	جَهْلُ أَكْثَرِ
u'جَهْلٌ الْمَرْأَةُ':Added, #1: 1	جَهْلُ الْمَرْأَةِ
u'جَهِلَ إمَامٌ':Subject, #1: 1	جَهْلُ الْمَرْأَةِ
u'جهل إمَامٌ':Added, #4: 4	جَهِلَ الْإِمَامُ
u'جَهْلٌ إمَامٌ':Added, #1: 1	جَهْلُ الْإِمَامِ
u'جهل إمَامٌ':Added, #1: 1	جَهْلُ الْإِمَامِ
u'جَهْلٌ إمَامٌ':Added, #1: 1	جَهْلِ إمَامٍ
u'جَهِلَ أَمْرٌ':Predicate, #1: 1	جَهْلِ إمَامٍ
u'جَهِلَ آمِرٌ':Subject, #6: 6	جَهِلَ أَمْرَ
u'جَهِلَ إِمْساكٌ':Predicate, #2: 2	جَهِلَ الْآمِرُ
u'جهل إِنْسانٌ':Added, #1: 1	جَهِلَ الْإِمْسَاكَ
u'جهل إِنْسانٌ':Added, #1: 1	جَهْلَ الْإِنْسَانِ
u'جَهْلٌ إِنْسانٌ':Added, #1: 1	جَهْلُ الْإِنْسَانِ
u'جَهْلٌ إِنْسانٌ':Added, #1: 1	جَهْلَ الْإِنْسَانِ
u'جَهِلَ بَائِعٌ':Subject, #1: 1	جَهْلُ الْإِنْسَانِ
u'جَهِلَ بَعْضٌ':Subject, #3: 3	جَهِلَ الْبَائِعُ
u'جهل بَعْضٌ':Added, #1: 1	جَهِلَ بَعْضُ
u'جَهْلٌ بَعْضٌ':Added, #1: 1	جَهْلِ بَعْضِ
u'جهل بَعْضٌ':Added, #1: 1	جَهْلِ بَعْضِ
u'جَهْلٌ بَعْضٌ':Added, #1: 1	جَهْلِ بَعْضِهِ
u'جهل بَعْضٌ':Added, #1: 1	جَهْلِ بَعْضِهِ
u'جَهْلٌ بَعْضٌ':Added, #2: 2	جَهْلُ بَعْضِ
u'جَهِلَ بِئْرٌ':Predicate, #2: 2	جَهْلُ بَعْضِ
u'جَهِلَ تَارِيخٌ':Predicate, #1: 1	جَهِلَ الْبِئْرَ
u'جهل تَارِيخٌ':Added, #3: 3	جَهِلَ التَّارِيخَ
u'جَهْلٌ تَارِيخٌ':Added, #2: 2	جَهْلِ التَّارِيخِ
u'جَهِلَ تَحْرِيم':Predicate, #2: 2	جَهْلِ التَّارِيخِ
u'جَهِلَ تَحْرِيمٌ':Predicate, #1: 1	جَهِلَ تَحْرِيمَةً
u'جَهِلَ تَحْرِيمٌ':Predicate, #4: 4	جَهِلَ التَّحْرِيمَ
u'جهل تَحْرِيمٌ':Added, #7: 7	جَهِلَ تَحْرِيمَ
u'جهل تَحْرِيمٌ':Added, #1: 1	جَهْلُ تَحْرِيمِ
u'جَهْلٌ تَحْرِيمٌ':Added, #1: 1	جَهْلِ تَحْرِيمِ
u'جَهْلٌ تَحْرِيمٌ':Added, #1: 1	جَهْلُ تَحْرِيمِ
u'جهل تَحْرِيمٌ':Added, #1: 1	جَهْلِ تَحْرِيمِ
u'جَهْلٌ تَحْرِيمٌ':Added, #1: 1	جَهْلِ تَحْرِيمِهِ
u'جَهِلَ تَشْطِيرٌ':Predicate, #1: 1	جَهْلِ تَحْرِيمِهِ
u'جَهِلَ تَعَاقُبٌ':Predicate, #1: 1	جَهِلَ التَّشْطِيرَ
u'جهل تَقَدُّمٌ':Added, #1: 1	جَهِلَ التَّعَاقُبَ
u'جَهْلٌ تَقَدُّمٌ':Added, #1: 1	جَهْلُ التَّقَدُّمِ
u'جَهِلَ تَوَحُّشٌ':Predicate, #1: 1	جَهْلُ التَّقَدُّمِ
u'جَهِلَ ثَمَنٌ':Predicate, #1: 1	جَهِلَ تَوَحُّشَ
u'جهل ثَمَنٌ':Added, #1: 1	جَهِلَ الثَّمَنَ
u'جَهْلٌ ثَمَنٌ':Added, #1: 1	جَهْلِ الثَّمَنِ
u'جَهِلَ جَازٌ':Predicate, #1: 1	جَهْلِ الثَّمَنِ
u'جهل جَاهِلٌ':Added, #2: 2	جَهِلَ جَازَ
u'جَهْلٌ جَاهِلٌ':Added, #1: 1	جَهْلَ جَاهِلٍ
u'جهل جَاهِلٌ':Added, #1: 1	جَهْلَ جَاهِلٍ
u'جَهْلٌ جَاهِلٌ':Added, #2: 2	جَهْلَ الْجَاهِلِ
u'جَهِلَ جِهَةٌ':Predicate, #2: 2	جَهْلَ الْجَاهِلِ
u'جَهِلَ جَوَازٌ':Predicate, #1: 1	جَهِلَ جِهَةَ
u'جهل حاكِمٌ':Added, #1: 1	جَهِلَ جَوَازَ
u'جَهْلٌ حاكِمٌ':Added, #2: 2	جَهْلِ الْحَاكِمِ
u'جَهِلَ حالٌ':Predicate, #2: 2	جَهْلِ الْحَاكِمِ
u'جَهِلَ حالٌ':Predicate, #11: 11	جَهِلَ الْحَالَ
u'جهل حالٌ':Added, #6: 6	جَهِلَ حَالَ
u'جَهْلٌ حالٌ':Added, #2: 2	جَهْلِ الْحَالِ
u'جهل حالٌ':Added, #2: 2	جَهْلِ الْحَالِ
u'جَهْلٌ حالٌ':Added, #2: 2	جَهْلِ حَالِهِ
u'جَهِلَ حالِق':Subject, #2: 2	جَهْلِ حَالِهِ
u'جَهِلَ حَدَثٌ':Predicate, #1: 1	جَهِلَ الْحَالِقُ
u'جَهِلَ حَدَثٌ':Predicate, #1: 1	جَهِلَ الْحَدَثَ
u'جهل حُرِّيَّةٌ':Added, #2: 2	جَهِلَ حَدَثَ
u'جَهْلٌ حُرِّيَّةٌ':Added, #3: 3	جَهْلِ حُرِّيَّتِهِ
u'جَهِلَ حَقٌّ':Predicate, #3: 3	جَهْلِ حُرِّيَّتِهِ
u'جَهِلَ حَقِيقٌ':Predicate, #1: 1	جَهِلَ الْحَقَّ
u'جَهِلَ حَقِيقَةٌ':Predicate, #1: 1	جَهِلَ حَقِيقَةَ
u'جَهِلَ حُكْمٌ':Predicate, #1: 1	جَهِلَ حَقِيقَةَ
u'جَهِلَ حَمْلٌ':Predicate, #2: 2	جَهِلَ حُكْمَ
u'جَهِلَ خِرَاطَةٌ':Predicate, #1: 1	جَهِلَ الْحَمْلَ
u'جَهِلَ خُرُوجٌ':Predicate, #1: 1	جَهِلَ الْخِرَاطَةَ
u'جَهِلَ خُصُومٌ':Predicate, #1: 1	جَهِلَ خُرُوجَ
u'جَهِلَ دونٌ':Predicate, #1: 1	جَهِلَ الْخُصُومَ
u'جهل رَاكِبٌ':Added, #1: 1	جَهِلَ دُونَ
u'جَهْلٌ رَاكِبٌ':Added, #3: 3	جَهْلُ الرَّاكِبِ
u'جَهِلَ رَبُّ':Subject, #3: 3	جَهْلُ الرَّاكِبِ
u'جَهِلَ رَدٌّ':Predicate, #3: 3	جَهِلَ رَبُّهُ
u'جَهِلَ رَدٌّ':Predicate, #1: 1	جَهِلَ الرَّدَّ
u'جهل رَدٌّ':Added, #1: 1	جَهِلَ رَدَّ
u'جَهْلٌ رَدٌّ':Added, #1: 1	جَهْلَ الرَّدِّ
u'جهل رَدٌّ':Added, #1: 1	جَهْلَ الرَّدِّ
u'جَهْلٌ رَدٌّ':Added, #2: 2	جَهْلِ الرَّدِّ
u'جهل زَمَنٌ':Added, #2: 2	جَهْلِ الرَّدِّ
u'جَهْلٌ زَمَنٌ':Added, #1: 1	جَهْلِ زَمَنِ
u'جهل زَوْجٌ':Added, #1: 1	جَهْلِ زَمَنِ
u'جَهْلٌ زَوْجٌ':Added, #2: 2	جَهْلِ الزَّوْجِ
u'جَهِلَ سَابِقٌ':Predicate, #2: 2	جَهْلِ الزَّوْجِ
u'جهل سائِل':Added, #1: 1	جَهِلَ السَّابِقَ
u'جهل سائِل':Added, #1: 1	جَهْلُ السَّائِلِ
u'جهل سَائِلٌ':Added, #1: 1	جَهْلِ السَّائِلِ
u'جهل سَائِلٌ':Added, #1: 1	جَهْلُ السَّائِلِ
u'جَهْلٌ سائِل':Added, #1: 1	جَهْلِ السَّائِلِ
u'جَهْلٌ سائِل':Added, #1: 1	جَهْلُ السَّائِلِ
u'جَهْلٌ سَائِلٌ':Added, #1: 1	جَهْلِ السَّائِلِ
u'جَهْلٌ سَائِلٌ':Added, #1: 1	جَهْلُ السَّائِلِ
u'جَهِلَ سَبَبٌ':Predicate, #1: 1	جَهْلِ السَّائِلِ
u'جَهِلَ سَبَبٌ':Predicate, #1: 1	جَهِلَ السَّبَبَ
u'جَهِلَ سَبْقٌ':Predicate, #2: 2	جَهِلَ سَبَبَ
u'جهل سَبْقٌ':Added, #1: 1	جَهِلَ السَّبْقَ
u'جَهْلٌ سَبْقٌ':Added, #1: 1	جَهْلِ السَّبْقِ
u'جهل سَبْقٌ':Added, #1: 1	جَهْلِ السَّبْقِ
u'جَهْلٌ سَبْقٌ':Added, #1: 1	جَهْلِ سَبْقِهِ
u'جَهِلَ سَمْتٌ':Predicate, #1: 1	جَهْلِ سَبْقِهِ
u'جَهِلَ سُوقٌ':Predicate, #1: 1	جَهِلَ السَّمْتَ
u'جَهِلَ شركة':Predicate, #1: 1	جَهِلَ السُّوقَ
u'جَهِلَ شَرِكَةٌ':Predicate, #1: 1	جَهِلَ الشَّرِكَةَ
u'جَهِلَ شُهُودٌ':Subject, #1: 1	جَهِلَ الشَّرِكَةَ
u'جهل شُهُودٌ':Added, #1: 1	جَهِلَ الشُّهُودُ
u'جَهْلٌ شُهُودٌ':Added, #2: 2	جَهْلُ الشُّهُودِ
u'جهل صَاحِبٌ':Added, #2: 2	جَهْلُ الشُّهُودِ
u'جَهْلٌ صَاحِبٌ':Added, #1: 1	جَهْلِ الصَّاحِبِ
u'جهل صَبِيٌّ':Added, #1: 1	جَهْلِ الصَّاحِبِ
u'جَهْلٌ صَبِيٌّ':Added, #1: 1	جَهْلُ الصَّبِيِّ
u'جهل صَغِيرٌ':Added, #1: 1	جَهْلُ الصَّبِيِّ
u'جَهْلٌ صَغِيرٌ':Added, #1: 1	جَهْلُ الصَّغِيرِ
u'جهل صِفَةٌ':Added, #1: 1	جَهْلُ الصَّغِيرِ
u'جَهْلٌ صِفَةٌ':Added, #1: 1	جَهْلِ الصِّفَةِ
u'جَهِلَ ضَرَرٌ':Predicate, #1: 1	جَهْلِ الصِّفَةِ
u'جَهِلَ ضَمِنٌ':Predicate, #1: 1	جَهِلَ ضَرَرَ
u'جهل عَاقِدٌ':Added, #1: 1	جَهِلَ ضَمِنَ
u'جَهْلٌ عَاقِدٌ':Added, #2: 2	جَهْلُ الْعَاقِدَيْنِ
u'جَهِلَ عَبْدٌ':Subject, #2: 2	جَهْلُ الْعَاقِدَيْنِ
u'جَهِلَ عَدَدٌ':Predicate, #1: 1	جَهِلَ الْعَبْدُ
u'جهل عَرَبٌ':Added, #1: 1	جَهِلَ عَدَدَهُنَّ
u'جَهْلٌ عَرَبٌ':Added, #1: 1	جَهْلَ الْعَرَبِ
u'جَهِلَ عَرَبِيٌّ':Predicate, #1: 1	جَهْلَ الْعَرَبِ
u'جَهِلَ عزل':Predicate, #1: 1	جَهِلَ الْعَرَبِيَّةَ
u'جَهِلَ علم':Predicate, #1: 1	جَهِلَ الْعَزْلَ
u'جَهِلَ عِلْمٌ':Predicate, #1: 1	جَهِلَ الْعِلْمَ
u'جَهِلَ عند':Predicate, #1: 1	جَهِلَ الْعِلْمَ
u'جَهِلَ عين':Predicate, #6: 6	جَهِلَ عِنْدَ
u'جَهِلَ عَيْنٌ':Predicate, #3: 3	جَهِلَ عَيْنَ
u'جَهِلَ عَيْن':Predicate, #3: 3	جَهِلَ عَيْنَ
u'جهل عين':Added, #3: 3	جَهِلَ عَيْنَ
u'جهل عَيْنٌ':Added, #1: 1	جَهْلِ عَيْنِهِ
u'جهل عَيْن':Added, #1: 1	جَهْلِ عَيْنِهِ
u'جَهْلٌ عين':Added, #1: 1	جَهْلِ عَيْنِهِ
u'جَهْلٌ عَيْنٌ':Added, #1: 1	جَهْلِ عَيْنِهِ
u'جَهْلٌ عَيْن':Added, #1: 1	جَهْلِ عَيْنِهِ
u'جَهِلَ غَبْنٌ':Predicate, #1: 1	جَهْلِ عَيْنِهِ
u'جَهِلَ غَصْبٌ':Predicate, #1: 1	جَهِلَ الْغَبْنَ
u'جَهِلَ فساد':Predicate, #1: 1	جَهِلَ الْغَصْبَ
u'جَهِلَ فَسَادٌ':Predicate, #1: 1	جَهِلَ الْفَسَادَ
u'جَهِلَ فساد':Predicate, #1: 1	جَهِلَ الْفَسَادَ
u'جَهِلَ فَسَادٌ':Predicate, #1: 1	جَهِلَ فَسَادَ
u'جَهِلَ فساد':Subject, #1: 1	جَهِلَ فَسَادَ
u'جَهِلَ فَسَادٌ':Subject, #1: 1	جَهِلَ فَسَادُ
u'جَهِلَ فِطْرٌ':Predicate, #1: 1	جَهِلَ فَسَادُ
u'جهل فقهاء':Added, #1: 1	جَهِلَ الْفِطْرَ
u'جَهْلٌ فقهاء':Added, #1: 1	جَهْلُ الْفُقَهَاءِ
u'جَهِلَ فَلًا':Predicate, #1: 1	جَهْلُ الْفُقَهَاءِ
u'جَهِلَ قَاتِلٌ':Subject, #1: 1	جَهِلَ فَلاَ
u'جَهِلَ قَالٌ':Predicate, #2: 2	جَهِلَ الْقَاتِلُ
u'جَهِلَ قَبْرٌ':Predicate, #1: 1	جَهِلَ قَالَ
u'جَهِلَ قِبْلَةٌ':Predicate, #1: 1	جَهِلَ الْقَبْرَ
u'جَهِلَ قَدْرٌ':Predicate, #1: 1	جَهِلَ الْقِبْلَةَ
u'جَهِلَ قَدْرٌ':Predicate, #1: 1	جَهِلَ الْقَدْرَ
u'جهل قَدْرٌ':Added, #8: 8	جَهِلَ قَدْرَ
u'جَهْلٌ قَدْرٌ':Added, #1: 1	جَهْلِ الْقَدْرِ
u'جهل قَدْرٌ':Added, #1: 1	جَهْلِ الْقَدْرِ
u'جَهْلٌ قَدْرٌ':Added, #1: 1	جَهْلُ قَدْرِهِ
u'جهل قَدْرٌ':Added, #1: 1	جَهْلُ قَدْرِهِ
u'جَهْلٌ قَدْرٌ':Added, #2: 2	جَهْلِ قَدْرِ
u'جَهِلَ قَوْمٌ':Subject, #2: 2	جَهْلِ قَدْرِ
u'جَهِلَ قِيَاسٌ':Predicate, #1: 1	جَهِلَ قَوْمٌ
u'جهل قِيمَةٌ':Added, #1: 1	جَهِلَ الْقِيَاسَ
u'جَهْلٌ قِيمَةٌ':Added, #1: 1	جَهْلَ قِيمَةِ
u'جهل كَافِرٌ':Added, #1: 1	جَهْلَ قِيمَةِ
u'جَهْلٌ كَافِرٌ':Added, #1: 1	جَهْلُ الْكَافِرِ
u'جَهِلَ كَوْنٌ':Predicate, #1: 1	جَهْلُ الْكَافِرِ
u'جهل كَوْنٌ':Added, #3: 3	جَهِلَ كَوْنَ
u'جَهْلٌ كَوْنٌ':Added, #2: 2	جَهْلِ كَوْنِهِ
u'جَهِلَ مَاءٌ':Predicate, #2: 2	جَهْلِ كَوْنِهِ
u'جَهِلَ مَالِكٌ':Predicate, #2: 2	جَهِلَ الْمَاءَ
u'جَهِلَ مَالِكٌ':Subject, #1: 1	جَهِلَ الْمَالِكَ
u'جَهِلَ مَالِكٌ':Subject, #1: 1	جَهِلَ الْمَالِكُ
u'جهل مَالِكٌ':Added, #1: 1	جَهِلَ مَالِكُهُ
u'جَهْلٌ مَالِكٌ':Added, #1: 1	جَهْلُ مَالِكِهِ
u'جَهِلَ مَأْمُورٌ':Subject, #1: 1	جَهْلُ مَالِكِهِ
u'جَهِلَ مَانِعٌ':Predicate, #1: 1	جَهِلَ الْمَأْمُورُ
u'جهل مُبْتَدِعٌ':Added, #1: 1	جَهِلَ الْمَانِعَ
u'جَهْلٌ مُبْتَدِعٌ':Added, #1: 1	جَهْلِ الْمُبْتَدِعَةِ
u'جهل مُبْرِئٌ':Added, #1: 1	جَهْلِ الْمُبْتَدِعَةِ
u'جَهْلٌ مُبْرِئٌ':Added, #1: 1	جَهْلِ الْمُبْرِئِ
u'جهل مَبِيعٌ':Added, #1: 1	جَهْلِ الْمُبْرِئِ
u'جَهْلٌ مَبِيعٌ':Added, #1: 1	جَهْلِ الْمَبِيعِ
u'جهل مُتَأَخِّرٌ':Added, #1: 1	جَهْلِ الْمَبِيعِ
u'جَهْلٌ مُتَأَخِّرٌ':Added, #2: 2	جَهْلِ الْمُتَأَخِّرِ
u'جهل مُتَكَلِّمٌ':Added, #2: 2	جَهْلِ الْمُتَأَخِّرِ
u'جَهْلٌ مُتَكَلِّمٌ':Added, #2: 2	جَهْلِ الْمُتَكَلِّمِ
u'جَهِلَ مثل':Subject, #2: 2	جَهْلِ الْمُتَكَلِّمِ
u'جَهِلَ مِثْلٌ':Subject, #1: 1	جَهِلَ مِثْلُهُ
u'جهل مُدَّةٌ':Added, #1: 1	جَهِلَ مِثْلُهُ
u'جَهْلٌ مُدَّةٌ':Added, #1: 1	جَهْلِ مُدَّةِ
u'جَهِلَ مُرْسِلٌ':Subject, #1: 1	جَهْلِ مُدَّةِ
u'جَهِلَ مَرَضٌ':Predicate, #1: 1	جَهِلَ مُرْسِلُهُ
u'جهل مَرَضٌ':Added, #1: 1	جَهِلَ مَرَضَ
u'جَهْلٌ مَرَضٌ':Added, #3: 3	جَهْلَ الْمَرَضِ
u'جَهِلَ مُسْتَأْجِرٌ':Subject, #3: 3	جَهْلَ الْمَرَضِ
u'جَهِلَ مُسْتَحِقٌّ':Subject, #1: 1	جَهِلَ الْمُسْتَأْجِرُ
u'جَهِلَ مَشْرُوطٌ':Subject, #1: 1	جَهِلَ مُسْتَحِقُّ
u'جَهِلَ مَعَانِي':Predicate, #1: 1	جَهِلَ الْمَشْرُوطُ
u'جَهِلَ مِقْدَارٌ':Predicate, #1: 1	جَهِلَ مَعَانِيَ
u'جَهِلَ مِقْدَارٌ':Predicate, #1: 1	جَهِلَ الْمِقْدَارَ
u'جَهِلَ مَكَانٌ':Predicate, #1: 1	جَهِلَ مِقْدَارَ
u'جهل مِلْكٌ':Added, #1: 1	جَهِلَ مَكَانَ
u'جَهْلٌ مِلْكٌ':Added, #1: 1	جَهْلَ مِلْكِ
u'جَهِلَ مَوَاقِعُ':Predicate, #1: 1	جَهْلَ مِلْكِ
u'جَهِلَ مَوْضِعٌ':Predicate, #1: 1	جَهِلَ مَوَاقِعَ
u'جَهِلَ مُوَكِّلٌ':Subject, #1: 1	جَهِلَ مَوْضِعَ
u'جهل مُوَكِّلٌ':Added, #1: 1	جَهِلَ الْمُوَكِّلُ
u'جَهْلٌ مُوَكِّلٌ':Added, #2: 2	جَهْلِ الْمُوَكِّلِ
u'جَهِلَ نَاسٌ':Subject, #2: 2	جَهْلِ الْمُوَكِّلِ
u'جَهِلَ نَجَاسَةٌ':Predicate, #1: 1	جَهِلَ النَّاسُ
u'جهل نَسَبٌ':Added, #1: 1	جَهِلَ نَجَاسَةَ
u'جَهْلٌ نَسَبٌ':Added, #1: 1	جَهْلِ نَسَبِ
u'جهل نَفْسٌ':Added, #1: 1	جَهْلِ نَسَبِ
u'جَهْلٌ نَفْسٌ':Added, #1: 1	جَهْلِ نَفْسِهِ
u'جَهِلَ نَهْيٌ':Predicate, #1: 1	جَهْلِ نَفْسِهِ
u'جهل نِيَّةٌ':Added, #5: 5	جَهِلَ النَّهْيَ
u'جَهْلٌ نِيَّةٌ':Added, #1: 1	جَهْلِ نِيَّةِ
u'جَهِلَ وُجُوبٌ':Predicate, #1: 1	جَهْلِ نِيَّةِ
u'جهل وُجُوبٌ':Added, #9: 9	جَهِلَ وُجُوبَ
u'جَهْلٌ وُجُوبٌ':Added, #1: 1	جَهْلَ وُجُوبِ
u'جَهِلَ وُجُودٌ':Predicate, #1: 1	جَهْلَ وُجُوبِ
u'جَهِلَ وَرَثَةٌ':Subject, #2: 2	جَهِلَ وُجُودَ
u'جَهِلَ وَزْنٌ':Predicate, #3: 3	جَهِلَ الْوَرَثَةُ
u'جهل وَزْنٌ':Added, #2: 2	جَهِلَ وَزْنَ
u'جَهْلٌ وَزْنٌ':Added, #1: 1	جَهْلِ وَزْنِهِ
u'جَهِلَ وَصِيٌّ':Predicate, #1: 1	جَهْلِ وَزْنِهِ
u'جَهِلَ وَصِيَّةٌ':Predicate, #2: 2	جَهِلَ الْوَصِيَّةَ
u'جَهِلَ وَقْتٌ':Predicate, #2: 2	جَهِلَ الْوَصِيَّةَ
u'جهل يسار':Added, #3: 3	جَهِلَ وَقْتَ
u'جهل يَسَارٌ':Added, #1: 1	جَهْل يَسَارِهِ
u'جَهْلٌ يسار':Added, #1: 1	جَهْل يَسَارِهِ
u'جَهْلٌ يَسَارٌ':Added, #1: 1	جَهْل يَسَارِهِ
u'جِوَارٌ اِبْنٌ':Added, #1: 1	جَهْل يَسَارِهِ
u'جِوَارٌ اِبْنٌ':Added, #1: 1	جِوَارَ ابْنِ
u'جِوَارٌ الْمَرْأَةُ':Added, #1: 1	جِوَارِ ابْنِ
u'جِوَارٌ بَابٌ':Added, #1: 1	جِوَارُ الْمَرْأَةِ
u'جِوَارٌ بَيْتٌ':Added, #1: 1	جِوَارَ بَابِ
u'جِوَارٌ جَامِعٌ':Added, #1: 1	جِوَارِ بَيْتِهِ
u'جِوَارٌ حَضَرٌ':Added, #2: 2	جِوَارَ جَامِعِ
u'جِوَارٌ رَبُّ':Added, #1: 1	جِوَارِ حَضَرٍ
u'جِوَارٌ رَجُلٌ':Added, #3: 3	جِوَارِ رَبِّ
u'جِوَارٌ رُجُوعٌ':Added, #1: 1	جِوَارِ رَجُلٍ
u'جِوَارٌ سَعْدٌ':Added, #1: 1	جِوَارِ الرُّجُوعِ
u'جِوَارٌ سَفِيهٌ':Added, #1: 1	جِوَارِ سَعْدٍ
u'جِوَارٌ سَفِيهٌ':Added, #1: 1	جِوَارَ السَّفِيهِ
u'جِوَارٌ شَفِيعٌ':Added, #1: 1	جِوَارِ سَفِيهِ
u'جِوَارٌ عَبْدٌ':Added, #2: 2	جِوَارَ الشَّفِيعِ
u'جِوَارٌ قَوْمٌ':Added, #1: 1	جِوَارُ الْعَبْدِ
u'جِوَارٌ قَوْمٌ':Added, #1: 1	جِوَارَ الْقَوْمِ
u'جِوَارٌ قَوْمٌ':Added, #1: 1	جِوَارَ قَوْمٍ
u'جِوَارٌ مَسْجِدٌ':Added, #2: 2	جِوَارِ قَوْمٍ
u'جِوَارٌ مَقْبَرَةٌ':Added, #1: 1	جِوَارَ مَسْجِدٍ
u'جِوَارٌ نِعَمٌ':Added, #2: 2	جِوَارِ مَقْبَرَةٍ
u'جِوَارٌ هشام':Added, #1: 1	جِوَارَ نِعَمِ
u'جِوَارٌ هِشَامٌ':Added, #1: 1	جِوَارُ هِشَامِ
u'جَوَازٌ إبَاحَةٌ':Added, #1: 1	جِوَارُ هِشَامِ
u'جَوَازٌ اِبْتِداءٌ':Added, #1: 1	جَوَازِ الْإِبَاحَةِ
u'جَوَازٌ اِبْتِداءٌ':Added, #1: 1	جَوَازِ ابْتِدَاءِ
u'جَوَازٌ اِبْتِيَاعٌ':Added, #1: 1	جَوَازِ الاِبْتِدَاءِ
u'جَوَازٌ إبْداءٌ':Added, #1: 1	جَوَازِ ابْتِيَاعِ
u'جَوَازٌ إبدالٌ':Added, #1: 1	جَوَازِ إبْدَاءِ
u'جَوَازٌ إبدالٌ':Added, #1: 1	جَوَازِ إبْدَالِهِ
u'جَوَازٌ إبدالٌ':Added, #2: 2	جَوَازِ الْإِبْدَالِ
u'جَوَازٌ إِبْطَالٌ':Added, #5: 5	جَوَازِ إبْدَالِ
u'جَوَازٌ إِبْطَالٌ':Added, #1: 1	جَوَازِ إبْطَالِ
u'جَوَازٌ إِبْقَاءٌ':Added, #1: 1	جَوَازِ الْإِبْطَالِ
u'جَوَازٌ اِتِّبَاعٌ':Added, #1: 1	جَوَازِ إبْقَاءِ
u'جَوَازٌ اِتِّبَاعٌ':Added, #1: 1	جَوَازُ اتِّبَاعِ
u'جَوَازٌ اِتِّبَاعٌ':Added, #1: 1	جَوَازِ اتِّبَاعِ
u'جَوَازٌ اِتِّحَادٌ':Added, #2: 2	جَوَازُ اتِّبَاعِهِ
u'جَوَازٌ اِتِّخَاذٌ':Added, #2: 2	جَوَازِ اتِّحَادِ
u'جَوَازٌ اِتِّخَاذٌ':Added, #1: 1	جَوَازَ اتِّخَاذِ
u'جَوَازٌ اِتِّخَاذٌ':Added, #1: 1	جَوَازُ اتِّخَاذِ
u'جَوَازٌ اِتِّخَاذٌ':Added, #1: 1	جَوَازِ اتِّخَاذِهِ
u'جَوَازٌ إِتْيانٌ':Added, #4: 4	جَوَازِ اتِّخَاذِ
u'جَوَازٌ إِتْيانٌ':Added, #1: 1	جَوَازِ إتْيَانِهِ
u'جَوَازٌ أثقل':Added, #1: 1	جَوَازِ الْإِتْيَانِ
u'جَوَازٌ إِجَابَةٌ':Added, #1: 1	جَوَازِ الْأَثْقَلِ
u'جَوَازٌ إِجَابَةٌ':Added, #1: 1	جَوَازِ إجَابَتِهِ
u'جَوَازٌ إجَارَةٌ':Added, #1: 1	جَوَازُ الْإِجَابَةِ
u'جَوَازٌ إجَارَةٌ':Added, #1: 1	جَوَازَ إجَارَتِهِ
u'جَوَازٌ إجَارَةٌ':Added, #1: 1	جَوَازُ إجَارَتِهِ
u'جَوَازٌ إجَارَةٌ':Added, #1: 1	جَوَازِ الإِجَارَةِ
u'جَوَازٌ إجَارَةٌ':Added, #2: 2	جَوَازَ إجَارَةِ
u'جَوَازٌ إجَارَةٌ':Added, #3: 3	جَوَازُ إجَارَةِ
u'جَوَازٌ إجَارَةٌ':Added, #3: 3	جَوَازِ إجَارَةِ
u'جَوَازٌ إجَارَةٌ':Added, #3: 3	جَوَازِ إجَارَتِهِ
u'جَوَازٌ إجَارَةٌ':Added, #4: 4	جَوَازَ الْإِجَارَةِ
u'جَوَازٌ إجَارَةٌ':Added, #4: 4	جَوَازُ الْإِجَارَةِ
u'جَوَازٌ إجَازَةٌ':Added, #7: 7	جَوَازِ الْإِجَارَةِ
u'جَوَازٌ اِجْتِمَاعٌ':Added, #1: 1	جَوَازِ إجَازَتِهِ
u'جَوَازٌ اِجْتِمَاعٌ':Added, #1: 1	جَوَازُ اجْتِمَاعِ
u'جَوَازٌ اِجْتِمَاعٌ':Added, #2: 2	جَوَازَ اجْتِمَاعِ
u'جَوَازٌ اِجْتِهَادٌ':Added, #2: 2	جَوَازِ اجْتِمَاعِ
u'جَوَازٌ اِجْتِهَادٌ':Added, #1: 1	جَوَازِ اجْتِهَادِ
u'جَوَازٌ إِجْرَاءٌ':Added, #2: 2	جَوَازِ اجْتِهَادِهِ
u'جَوَازٌ أُجْرَةٌ':Added, #1: 1	جَوَازِ إجْرَاءِ
u'جَوَازٌ إِجْلاَءٌ':Added, #1: 1	جَوَازِ الْأُجْرَةِ
u'جَوَازٌ إِجْمَاعٌ':Added, #1: 1	جَوَازَ إجْلَاءِ
u'جَوَازٌ إِجْمَاعٌ':Added, #1: 1	جَوَازَ الْإِجْمَاعِ
u'جَوَازٌ إِجْمَاعٌ':Added, #1: 1	جَوَازُ الْإِجْمَاعِ
u'جَوَازٌ إِجْمَالٌ':Added, #1: 1	جَوَازِ الْإِجْمَاعِ
u'جَوَازٌ اِحْتِجَاجٌ':Added, #1: 1	جَوَازِ الْإِجْمَالِ
u'جَوَازٌ اِحْتِجَاجٌ':Added, #1: 1	جَوَازِ الاحْتِجَاجِ
u'جَوَازٌ إِحْدَاثٌ':Added, #1: 1	جَوَازِ الاِحْتِجَاجِ
u'جَوَازٌ إِحْدَاثٌ':Added, #1: 1	جَوَازِ الْإِحْدَاثِ
u'جَوَازٌ إِحْرَاقٌ':Added, #2: 2	جَوَازِ إحْدَاثِ
u'جَوَازٌ إِحْرَامٌ':Added, #1: 1	جَوَازِ إحْرَاقِ
u'جَوَازٌ إِحْرَامٌ':Added, #1: 1	جَوَازِ إحْرَامٍ
u'جَوَازٌ إِحْرَامٌ':Added, #1: 1	جَوَازُ إحْرَامِهِ
u'جَوَازٌ إِحْرَامٌ':Added, #2: 2	جَوَازِ الْإِحْرَامِ
u'جَوَازٌ إحْضَارٌ':Added, #3: 3	جَوَازُ الْإِحْرَامِ
u'جَوَازٌ إِحْلاَفٌ':Added, #1: 1	جَوَازُ إحْضَارِ
u'جَوَازٌ إِحْيَاءٌ':Added, #2: 2	جَوَازِ إحْلَافِهِ
u'جَوَازٌ إِخْبَارٌ':Added, #1: 1	جَوَازِ الْإِحْيَاءِ
u'جَوَازٌ إِخْبَارٌ':Added, #1: 1	جَوَازَ إخْبَارِ
u'جَوَازٌ إِخْبَارٌ':Added, #1: 1	جَوَازِ إخْبَارِ
u'جَوَازٌ اِخْتِصَارٌ':Added, #2: 2	جَوَازِ الْإِخْبَارِ
u'جَوَازٌ اِخْتِصَاصٌ':Added, #1: 1	جَوَازُ اخْتِصَارِهِ
u'جَوَازٌ اِخْتِيَارٌ':Added, #1: 1	جَوَازِ اخْتِصَاصِ
u'جَوَازٌ أخْذٌ':Added, #1: 1	جَوَازُ اخْتِيَارِ
u'جَوَازٌ أخْذٌ':Added, #13: 13	جَوَازُ الْأَخْذِ
u'جَوَازٌ أخْذٌ':Added, #14: 14	جَوَازِ الْأَخْذِ
u'جَوَازٌ أخْذٌ':Added, #1: 1	جَوَازِ أَخْذٍ
u'جَوَازٌ أخْذٌ':Added, #1: 1	جَوَازُ أَخْذِهِ
u'جَوَازٌ أخْذٌ':Added, #1: 1	جَوَازِ الأَخْذِ
u'جَوَازٌ أخْذٌ':Added, #24: 24	جَوَازِ أَخْذِ
u'جَوَازٌ أخْذٌ':Added, #2: 2	جَوَازَ أَخْذِهِ
u'جَوَازٌ أخْذٌ':Added, #4: 4	جَوَازَ أَخْذِ
u'جَوَازٌ أخْذٌ':Added, #5: 5	جَوَازِ أَخْذِهِ
u'جَوَازٌ أخْذٌ':Added, #6: 6	جَوَازَ الْأَخْذِ
u'جَوَازٌ إِخْرَاجٌ':Added, #7: 7	جَوَازُ أَخْذِ
u'جَوَازٌ إِخْرَاجٌ':Added, #10: 10	جَوَازِ إخْرَاجِ
u'جَوَازٌ إِخْرَاجٌ':Added, #1: 1	جَوَازُ الْإِخْرَاجِ
u'جَوَازٌ إِخْرَاجٌ':Added, #2: 2	جَوَازَ إخْرَاجِ
u'جَوَازٌ إِخْرَاجٌ':Added, #2: 2	جَوَازِ الْإِخْرَاجِ
u'جَوَازٌ إِخْرَاجٌ':Added, #3: 3	جَوَازُ إخْرَاجِ
u'جَوَازٌ إِخْرَاجٌ':Added, #3: 3	جَوَازِ إخْرَاجِهِ
u'جَوَازٌ إِخْفَاءٌ':Added, #4: 4	جَوَازَ الْإِخْرَاجِ
u'جَوَازٌ أَدَاءٌ':Added, #1: 1	جَوَازُ إخْفَاءِ
u'جَوَازٌ أَدَاءٌ':Added, #1: 1	جَوَازُ أَدَاءِ
u'جَوَازٌ أَدَاءٌ':Added, #1: 1	جَوَازَ الْأَدَاءِ
u'جَوَازٌ أَدَاءٌ':Added, #2: 2	جَوَازِ أَدَاءِ
u'جَوَازٌ أَدَاءٌ':Added, #3: 3	جَوَازَ أَدَاءِ
u'جَوَازٌ أدَب':Added, #8: 8	جَوَازِ الْأَدَاءِ
u'جَوَازٌ اِدِّخارٌ':Added, #1: 1	جَوَازُ الْأَدَبِ
u'جَوَازٌ إدْخَالٌ':Added, #1: 1	جَوَازُ ادِّخَارِ
u'جَوَازٌ إدْخَالٌ':Added, #1: 1	جَوَازُ إدْخَالِ
u'جَوَازٌ أَذَانٌ':Added, #1: 1	جَوَازِ إدْخَالِ
u'جَوَازٌ أَذَانٌ':Added, #1: 1	جَوَازُ أَذَانِ
u'جَوَازٌ إِذْنٌ':Added, #1: 1	جَوَازِ الْأَذَانِ
u'جَوَازٌ إِذْنٌ':Added, #1: 1	جَوَازُ إذْنِ
u'جَوَازٌ إِذْنٌ':Added, #1: 1	جَوَازِ إذْنِ
u'جَوَازٌ إِرَادَةٌ':Added, #1: 1	جَوَازُ الْإِذْنِ
u'جَوَازٌ أَرْبَعُ':Added, #3: 3	جَوَازُ إرَادَةِ
u'جَوَازٌ إِرْسَالٌ':Added, #1: 1	جَوَازِ الْأَرْبَعِ
u'جَوَازٌ إِرْسَالٌ':Added, #1: 1	جَوَازُ إرْسَالِهِ
u'جَوَازٌ إِرْضاعٌ':Added, #2: 2	جَوَازِ إرْسَالِ
u'جَوَازٌ إِزَالَةٌ':Added, #1: 1	جَوَازِ الْإِرْضَاعِ
u'جَوَازٌ إِزَالَةٌ':Added, #1: 1	جَوَازُ إزَالَةِ
u'جَوَازٌ إِزَالَةٌ':Added, #1: 1	جَوَازُ إزَالَتِهِ
u'جَوَازٌ إِسَارٌ':Added, #2: 2	جَوَازِ إزَالَةِ
u'جَوَازٌ اِسْتِبَاحَةٌ':Added, #1: 1	جَوَازِ الْإِسَارِ
u'جَوَازٌ اِسْتِبَاحَةٌ':Added, #1: 1	جَوَازَ اسْتِبَاحَةِ
u'جَوَازٌ اِسْتِبَاحَةٌ':Added, #1: 1	جَوَازُ اسْتِبَاحَةِ
u'جَوَازٌ اِسْتِتْباع':Added, #1: 1	جَوَازِ اسْتِبَاحَةِ
u'جَوَازٌ اِسْتِثْنَاءٌ':Added, #1: 1	جَوَازِ اسْتِتْبَاعِ
u'جَوَازٌ اِسْتِثْنَاءٌ':Added, #1: 1	جَوَازُ اسْتِثْنَاءِ
u'جَوَازٌ اِسْتِخْدامٌ':Added, #2: 2	جَوَازِ اسْتِثْنَاءِ
u'جَوَازٌ اِسْتِرْجَاعٌ':Added, #2: 2	جَوَازِ اسْتِخْدَامِهِ
u'جَوَازٌ اِسْتِصْحابٌ':Added, #1: 1	جَوَازِ اسْتِرْجَاعِ
u'جَوَازٌ اِسْتِعارَةٌ':Added, #1: 1	جَوَازَ اسْتِصْحَابِ
u'جَوَازٌ اِسْتِعارَةٌ':Added, #1: 1	جَوَازِ اسْتِعَارَةِ
u'جَوَازٌ اِسْتِعْمالٌ':Added, #2: 2	جَوَازُ اسْتِعَارَةِ
u'جَوَازٌ اِسْتِعْمالٌ':Added, #1: 1	جَوَازَ اسْتِعْمَالِهِ
u'جَوَازٌ اِسْتِعْمالٌ':Added, #2: 2	جَوَازُ اسْتِعْمَالِهِ
u'جَوَازٌ اِسْتِعْمالٌ':Added, #6: 6	جَوَازُ اسْتِعْمَالِ
u'جَوَازٌ اِسْتِعْمالٌ':Added, #7: 7	جَوَازِ اسْتِعْمَالِ
u'جَوَازٌ اِسْتِفْتاءٌ':Added, #7: 7	جَوَازِ اسْتِعْمَالِهِ
u'جَوَازٌ اِسْتِقْبالٌ':Added, #1: 1	جَوَازُ اسْتِفْتَاءِ
u'جَوَازٌ اِسْتِقْراض':Added, #1: 1	جَوَازَ اسْتِقْبَالِهِ
u'جَوَازٌ اِسْتِقْلالٌ':Added, #1: 1	جَوَازِ الاِسْتِقْرَاضِ
u'جَوَازٌ اِسْتِمْتاعٌ':Added, #1: 1	جَوَازُ اسْتِقْلَالِهِ
u'جَوَازٌ اِسْتِمْرارٌ':Added, #1: 1	جَوَازُ اسْتِمْتَاعِهِ
u'جَوَازٌ اِسْتِنابَة':Added, #1: 1	جَوَازِ اسْتِمْرَارِ
u'جَوَازٌ اِسْتِناد':Added, #1: 1	جَوَازِ اسْتِنَابَةِ
u'جَوَازٌ اِسْتِواءٌ':Added, #1: 1	جَوَازُ اسْتِنَادِ
u'جَوَازٌ اِسْتِئْجَارٌ':Added, #1: 1	جَوَازِ اسْتِوَاءِ
u'جَوَازٌ اِسْتِئْجَارٌ':Added, #1: 1	جَوَازَ اسْتِئْجَارِ
u'جَوَازٌ اِسْتِئْجَارٌ':Added, #1: 1	جَوَازُ اسْتِئْجَارِهِ
u'جَوَازٌ اِسْتِئْجَارٌ':Added, #1: 1	جَوَازِ اسْتِئْجَارِهِ
u'جَوَازٌ اِسْتيفاءٌ':Added, #3: 3	جَوَازِ اسْتِئْجَارِ
u'جَوَازٌ اِسْتيفاءٌ':Added, #1: 1	جَوَازِ اسْتِيفَاءِ
u'جَوَازٌ إِسْقاطٌ':Added, #3: 3	جَوَازَ اسْتِيفَاءِ
u'جَوَازٌ إِسْلامٌ':Added, #1: 1	جَوَازِ إسْقَاطِهِ
u'جَوَازٌ إِسْنادٌ':Added, #1: 1	جَوَازَ إسْلَامِ
u'جَوَازٌ إشارَة':Added, #1: 1	جَوَازَ إسْنَادِ
u'جَوَازٌ اِشْتِباهٌ':Added, #1: 1	جَوَازُ الْإِشَارَةِ
u'جَوَازٌ اِشْتِراطٌ':Added, #1: 1	جَوَازِ اشْتِبَاهِ
u'جَوَازٌ اِشْتِراطٌ':Added, #1: 1	جَوَازِ اشْتِرَاطِهِ
u'جَوَازٌ اِشْتِراطٌ':Added, #2: 2	جَوَازِ اشْتِرَاطِ
u'جَوَازٌ اِشْتِراكٌ':Added, #6: 6	جَوَازُ اشْتِرَاطِ
u'جَوَازٌ اِشْتِقاقٌ':Added, #1: 1	جَوَازِ اشْتِرَاكِ
u'جَوَازٌ إِشْراعٌ':Added, #2: 2	جَوَازُ اشْتِقَاقِ
u'جَوَازٌ إِشْراعٌ':Added, #1: 1	جَوَازُ الْإِشْرَاعِ
u'جَوَازٌ إصْباحٌ':Added, #1: 1	جَوَازِ الْإِشْرَاعِ
u'جَوَازٌ اِصْطِيادٌ':Added, #1: 1	جَوَازِ الْإِصْبَاحِ
u'جَوَازٌ أصل':Added, #1: 1	جَوَازِ اصْطِيَادِهِ
u'جَوَازٌ أصل':Added, #1: 1	جَوَازَ أَصْلِ
u'جَوَازٌ أصل':Added, #1: 1	جَوَازُ أَصْلِ
u'جَوَازٌ أًصْلٌ':Added, #1: 1	جَوَازِ أَصْلِ
u'جَوَازٌ أًصْلٌ':Added, #1: 1	جَوَازَ أَصْلِ
u'جَوَازٌ أًصْلٌ':Added, #1: 1	جَوَازُ أَصْلِ
u'جَوَازٌ إِصْلاحٌ':Added, #1: 1	جَوَازِ أَصْلِ
u'جَوَازٌ إضافَةٌ':Added, #1: 1	جَوَاز إصْلَاحِ
u'جَوَازٌ إضافَةٌ':Added, #1: 1	جَوَازُ إضَافَةِ
u'جَوَازٌ إضافَةٌ':Added, #1: 1	جَوَازِ إضَافَةِ
u'جَوَازٌ إضافَةٌ':Added, #1: 1	جَوَازُ إضَافَتِهِ
u'جَوَازٌ إِضْرابٌ':Added, #2: 2	جَوَازِ إضَافَتِهِ
u'جَوَازٌ إِطالَةٌ':Added, #1: 1	جَوَازِ الْإِضْرَابِ
u'جَوَازٌ إِطْعامٌ':Added, #1: 1	جَوَازَ إطَالَتِهِ
u'جَوَازٌ إِطْعامٌ':Added, #1: 1	جَوَازِ إطْعَامِ
u'جَوَازٌ إِطْلاقٌ':Added, #1: 1	جَوَازُ الْإِطْعَامِ
u'جَوَازٌ إِطْلاقٌ':Added, #1: 1	جَوَازُ إطْلَاقِ
u'جَوَازٌ إِطْلاقٌ':Added, #1: 1	جَوَازُ إطْلَاقِهِ
u'جَوَازٌ إِطْلاقٌ':Added, #1: 1	جَوَازِ إطْلَاقِهِ
u'جَوَازٌ إِطْلاقٌ':Added, #1: 1	جَوَازَ الْإِطْلَاقِ
u'جَوَازٌ إِطْلاقٌ':Added, #1: 1	جَوَازُ الْإِطْلَاقِ
u'جَوَازٌ إِطْلاقٌ':Added, #1: 1	جَوَازِ الْإِطْلَاقِ
u'جَوَازٌ إِطْلاقٌ':Added, #4: 4	جَوَازَ إطْلَاقِ
u'جَوَازٌ إِعادَةٌ':Added, #6: 6	جَوَازِ إطْلَاقِ
u'جَوَازٌ إِعادَةٌ':Added, #1: 1	جَوَازَ إعَادَةِ
u'جَوَازٌ إِعادَةٌ':Added, #1: 1	جَوَازُ إعَادَةِ
u'جَوَازٌ إِعارَةٌ':Added, #1: 1	جَوَازِ الْإِعَادَةِ
u'جَوَازٌ إِعارَةٌ':Added, #1: 1	جَوَازَ إعَارَةِ
u'جَوَازٌ إِعارَةٌ':Added, #1: 1	جَوَازُ الْإِعَارَةِ
u'جَوَازٌ إِعارَةٌ':Added, #2: 2	جَوَازُ إعَارَةِ
u'جَوَازٌ إِعارَةٌ':Added, #2: 2	جَوَازَ الْإِعَارَةِ
u'جَوَازٌ إِعانَةٌ':Added, #5: 5	جَوَازِ إعَارَةِ
u'جَوَازٌ إِعْتاقٌ':Added, #1: 1	جَوَازَ الْإِعَانَةِ
u'جَوَازٌ اِعْتِبارٌ':Added, #3: 3	جَوَازِ إعْتَاقِ
u'جَوَازٌ اِعْتِدادٌ':Added, #1: 1	جَوَازُ اعْتِبَارِ
u'جَوَازٌ اِعْتِمادٌ':Added, #1: 1	جَوَازُ اعْتِدَادِ
u'جَوَازٌ إعْرَاضٌ':Added, #2: 2	جَوَازُ اعْتِمَادِهِ
u'جَوَازٌ إعْطَاءٌ':Added, #1: 1	جَوَازِ الْإِعْرَاضِ
u'جَوَازٌ إعْطَاءٌ':Added, #1: 1	جَوَازَ إعْطَاءِ
u'جَوَازٌ إعْلاَمٌ':Added, #5: 5	جَوَازُ إعْطَاءِ
u'جَوَازٌ إفْتَاءٌ':Added, #1: 1	جَوَازَ إعْلَامِ
u'جَوَازٌ إفْتَاءٌ':Added, #1: 1	جَوَازِ إفْتَاءِ
u'جَوَازٌ إِفْرَادٌ':Added, #2: 2	جَوَازِ الْإِفْتَاءِ
u'جَوَازٌ إفْسَادٌ':Added, #1: 1	جَوَازِ إفْرَادِهِ
u'جَوَازٌ إِفْطارٌ':Added, #1: 1	جَوَازِ إفْسَادِ
u'جَوَازٌ إِفْطارٌ':Added, #1: 1	جَوَازَ الْإِفْطَارِ
u'جَوَازٌ أَفْعَالٌ':Added, #3: 3	جَوَازِ الْإِفْطَارِ
u'جَوَازٌ أَفْعَالٌ':Added, #1: 1	جَوَازِ أَفْعَالِهِ
u'جَوَازٌ أَفْعَالٌ':Added, #1: 1	جَوَازُ الْأَفْعَالِ
u'جَوَازٌ إقالَةٌ':Added, #1: 1	جَوَازِ الْأَفْعَالِ
u'جَوَازٌ إقالَةٌ':Added, #1: 1	جَوَازُ إقَالَةِ
u'جَوَازٌ إقالَةٌ':Added, #1: 1	جَوَازِ الْإِقَالَةِ
u'جَوَازٌ إقامَةٌ':Added, #4: 4	جَوَازُ الْإِقَالَةِ
u'جَوَازٌ إقامَةٌ':Added, #1: 1	جَوَازَ إقَامَةِ
u'جَوَازٌ إقامَةٌ':Added, #1: 1	جَوَازَ إقَامَتِهِ
u'جَوَازٌ إقامَةٌ':Added, #2: 2	جَوَازِ إقَامَةِ
u'جَوَازٌ إقامَةٌ':Added, #2: 2	جَوَازُ إقَامَتِهِ
u'جَوَازٌ اِقْتِداءٌ':Added, #3: 3	جَوَازُ إقَامَةِ
u'جَوَازٌ اِقْتِداءٌ':Added, #2: 2	جَوَازَ اقْتِدَاءِ
u'جَوَازٌ اِقْتِداءٌ':Added, #3: 3	جَوَازُ اقْتِدَاءِ
u'جَوَازٌ اِقْتِرَاضٌ':Added, #6: 6	جَوَازِ اقْتِدَاءِ
u'جَوَازٌ اِقْتِران':Added, #2: 2	جَوَازَ اقْتِرَاضِهِ
u'جَوَازٌ اِقْتِصَارٌ':Added, #1: 1	جَوَازَ اقْتِرَانِ
u'جَوَازٌ اِقْتِصَارٌ':Added, #1: 1	جَوَازِ اقْتِصَارِهِ
u'جَوَازٌ اِقْتِضَاءٌ':Added, #3: 3	جَوَازِ الاِقْتِصَارِ
u'جَوَازٌ اِقْتِناءٌ':Added, #3: 3	جَوَازِ اقْتِضَاءِ
u'جَوَازٌ إقْدَامٌ':Added, #2: 2	جَوَازِ اقْتِنَاءِ
u'جَوَازٌ إقْدَامٌ':Added, #1: 1	جَوَازِ إقْدَامِ
u'جَوَازٌ إقْدَامٌ':Added, #1: 1	جَوَازَ إقْدَامِهِ
u'جَوَازٌ إقْدَامٌ':Added, #1: 1	جَوَازَ الْإِقْدَامِ
u'جَوَازٌ إقْدَامٌ':Added, #1: 1	جَوَازِ الْإِقْدَامِ
u'جَوَازٌ إقْرَارٌ':Added, #6: 6	جَوَازُ الْإِقْدَامِ
u'جَوَازٌ إقْرَارٌ':Added, #1: 1	جَوَازُ إقْرَارِ
u'جَوَازٌ إقْرَارٌ':Added, #1: 1	جَوَازِ الْإِقْرَارِ
u'جَوَازٌ إقْرَارٌ':Added, #25: 25	جَوَازِ إقْرَارِهِ
u'جَوَازٌ إقْرَارٌ':Added, #3: 3	جَوَازِ إقْرَارِ
u'جَوَازٌ إِقْراضٌ':Added, #3: 3	جَوَازُ الْإِقْرَارِ
u'جَوَازٌ إِقْراضٌ':Added, #1: 1	جَوَازَ الْإِقْرَاضِ
u'جَوَازٌ إِقْراضٌ':Added, #2: 2	جَوَازِ إقْرَاضِ
u'جَوَازٌ إقْطَاعٌ':Added, #2: 2	جَوَازِ إقْرَاضِهِ
u'جَوَازٌ أقَلُّ':Added, #2: 2	جَوَازِ الْإِقْطَاعِ
u'جَوَازٌ اِكْتِسَابٌ':Added, #1: 1	جَوَازِ الْأَقَلِّ
u'جَوَازٌ أَكْثَرُ':Added, #1: 1	جَوَازِ الاِكْتِسَابِ
u'جَوَازٌ أكل':Added, #1: 1	جَوَازِ الْأَكْثَرِ
u'جَوَازٌ أَكْلٌ':Added, #11: 11	جَوَازِ أَكْلِ
u'جَوَازٌ أكل':Added, #11: 11	جَوَازِ أَكْلِ
u'جَوَازٌ أَكْلٌ':Added, #13: 13	جَوَازِ أَكْلِهِ
u'جَوَازٌ أكل':Added, #13: 13	جَوَازِ أَكْلِهِ
u'جَوَازٌ أَكْلٌ':Added, #1: 1	جَوَازُ الأَكْلِ
u'جَوَازٌ أكل':Added, #1: 1	جَوَازُ الأَكْلِ
u'جَوَازٌ أَكْلٌ':Added, #2: 2	جَوَازِ الأَكْلِ
u'جَوَازٌ أكل':Added, #2: 2	جَوَازِ الأَكْلِ
u'جَوَازٌ أَكْلٌ':Added, #4: 4	جَوَازَ الْأَكْلِ
u'جَوَازٌ أكل':Added, #4: 4	جَوَازَ الْأَكْلِ
u'جَوَازٌ أَكْلٌ':Added, #5: 5	جَوَازُ أَكْلِ
u'جَوَازٌ أكل':Added, #5: 5	جَوَازُ أَكْلِ
u'جَوَازٌ أَكْلٌ':Added, #5: 5	جَوَازُ أَكْلِهِ
u'جَوَازٌ أكل':Added, #5: 5	جَوَازُ أَكْلِهِ
u'جَوَازٌ أكل':Added, #9: 9	جَوَازُ الْأَكْلِ
u'جَوَازٌ أَكْلٌ':Added, #9: 9	جَوَازِ الْأَكْلِ
u'جَوَازٌ أَكْلٌ':Added, #9: 9	جَوَازُ الْأَكْلِ
u'جَوَازٌ اِلْتِقَاطٌ':Added, #9: 9	جَوَازِ الْأَكْلِ
u'جَوَازٌ اِلْتِقَاطٌ':Added, #1: 1	جَوَازُ الْتِقَاطِ
u'جَوَازٌ اِلْتِقَاطٌ':Added, #1: 1	جَوَازِ الْتِقَاطِ
u'جَوَازٌ إلْحَاقٌ':Added, #1: 1	جَوَازَ الْتِقَاطِهِ
u'جَوَازٌ إلْحَاقٌ':Added, #1: 1	جَوَازَ إلْحَاقِ
u'جَوَازٌ إِلْزَامٌ':Added, #1: 1	جَوَازِ إلْحَاقِهِ
u'جَوَازٌ إمَامَةٌ':Added, #1: 1	جَوَازَ إلْزَامِهِ
u'جَوَازٌ إمَامَةٌ':Added, #1: 1	جَوَازِ إمَامَتِهِ
u'جَوَازٌ إمَامَةٌ':Added, #1: 1	جَوَازِ إِمَامَتِهِ
u'جَوَازٌ إمَامَةٌ':Added, #2: 2	جَوَازِ إمَامَةِ
u'جَوَازٌ أمَانٌ':Added, #4: 4	جَوَازُ إمَامَةِ
u'جَوَازٌ أمَانٌ':Added, #1: 1	جَوَازِ أَمَانِ
u'جَوَازٌ أَمْرٌ':Added, #2: 2	جَوَازِ الْأَمَانِ
u'جَوَازٌ أَمْرٌ':Added, #1: 1	جَوَازِ الْأَمْرِ
u'جَوَازٌ أَمْرٌ':Added, #1: 1	جَوَازَ الأَمْرَيْنِ
u'جَوَازٌ أَمْرٌ':Added, #1: 1	جَوَازُ أَمْرِ
u'جَوَازٌ أَمْرٌ':Added, #2: 2	جَوَازِ الْأَمْرَيْنِ
u'جَوَازٌ إِمْساكٌ':Added, #4: 4	جَوَازُ الْأَمْرَيْنِ
u'جَوَازٌ إِمْساكٌ':Added, #1: 1	جَوَازِ إمْسَاكِهِ
u'جَوَازٌ إِمْضاءٌ':Added, #2: 2	جَوَازِ إمْسَاكِ
u'جَوَازٌ أَمْنٌ':Added, #1: 1	جَوَازَ إمْضَاءِ
u'جَوَازٌ إِنابَةٌ':Added, #1: 1	جَوَازَ الْأَمْنِ
u'جَوَازٌ اِنْتِزاعٌ':Added, #1: 1	جَوَازَ الْإِنَابَةِ
u'جَوَازٌ اِنْتِصارٌ':Added, #1: 1	جَوَازِ انْتِزَاعِ
u'جَوَازٌ اِنْتِفاعٌ':Added, #1: 1	جَوَازِ الاِنْتِصَارِ
u'جَوَازٌ اِنْتِقالٌ':Added, #1: 1	جَوَازِ انْتِفَاعِ
u'جَوَازٌ اِنْصِرافٌ':Added, #1: 1	جَوَازِ انْتِقَالِ
u'جَوَازٌ اِنْعِقَادٌ':Added, #1: 1	جَوَازِ الاِنْصِرَافِ
u'جَوَازٌ اِنْعِقَادٌ':Added, #1: 1	جَوَازَ انْعِقَادِ
u'جَوَازٌ اِنْعِقَادٌ':Added, #1: 1	جَوَازِ انْعِقَادِ
u'جَوَازٌ اِنْفِرادٌ':Added, #1: 1	جَوَازِ انْعِقَادِهِ
u'جَوَازٌ اِنْفِرادٌ':Added, #1: 1	جَوَازُ انْفِرَادِهِ
u'جَوَازٌ اِنْفِرادٌ':Added, #1: 1	جَوَازِ انْفِرَادِهِ
u'جَوَازٌ اِنْفِرادٌ':Added, #2: 2	جَوَازُ انْفِرَادِ
u'جَوَازٌ اِنْفِكاكٌ':Added, #2: 2	جَوَازِ انْفِرَادِ
u'جَوَازٌ إِنْكارٌ':Added, #1: 1	جَوَازِ انْفِكَاكِ
u'جَوَازٌ إِنْكارٌ':Added, #1: 1	جَوَازَ الْإِنْكَارِ
u'جَوَازٌ اِنْهِزَامٌ':Added, #2: 2	جَوَازُ الْإِنْكَارِ
u'جَوَازٌ إهْدَاءٌ':Added, #1: 1	جَوَازِ انْهِزَامِهِ
u'جَوَازٌ إهْدَاءٌ':Added, #1: 1	جَوَازُ الْإِهْدَاءِ
u'جَوَازٌ أَوَّلُ':Added, #1: 1	جَوَازِ إهْدَاءِ
u'جَوَازٌ أَوَّلُ':Added, #1: 1	جَوَازُ الْأَوَّلِ
u'جَوَازٌ إِيثَارٌ':Added, #1: 1	جَوَازِ الْأَوَّلِ
u'جَوَازٌ إِيجَابٌ':Added, #3: 3	جَوَازِ الْإِيثَارِ
u'جَوَازٌ إِيجَارٌ':Added, #1: 1	جَوَازَ الْإِيجَابِ
u'جَوَازٌ إِيدَاعٌ':Added, #1: 1	جَوَازِ إيجَارِ
u'جَوَازٌ إِيدَاعٌ':Added, #1: 1	جَوَازُ الْإِيدَاعِ
u'جَوَازٌ إِيدَاعٌ':Added, #1: 1	جَوَازِ الْإِيدَاعِ
u'جَوَازٌ إِيدَاعٌ':Added, #1: 1	جَوَازُ إيدَاعِ
u'جَوَازٌ إِيدَاعٌ':Added, #2: 2	جَوَازِ إيدَاعِ
u'جَوَازٌ إيرَادٌ':Added, #2: 2	جَوَازَ إيدَاعِهِ
u'جَوَازٌ إيقَاعٌ':Added, #1: 1	جَوَازَ إيرَادِ
u'جَوَازٌ إيقَاعٌ':Added, #1: 1	جَوَازُ إيقَاعِ
u'جَوَازٌ إِيهَامٌ':Added, #2: 2	جَوَازِ الْإِيقَاعِ
u'جَوَازٌ بَدْءٌ':Added, #1: 1	جَوَازِ الْإِيهَامِ
u'جَوَازٌ بَدَلٌ':Added, #1: 1	جَوَازُ الْبَدْءِ
u'جَوَازٌ بَدَلٌ':Added, #1: 1	جَوَازِ بَدَلِ
u'جَوَازٌ بَذْلٌ':Added, #3: 3	جَوَازِ الْبَدَلِ
u'جَوَازٌ بَذْلٌ':Added, #1: 1	جَوَازُ بَذْلِ
u'جَوَازٌ براز':Added, #1: 1	جَوَازِ بَذْلِهِ
u'جَوَازٌ بِرازٌ':Added, #1: 1	جَوَازِ الْبِرَازِ
u'جَوَازٌ بُصاقٌ':Added, #1: 1	جَوَازِ الْبِرَازِ
u'جَوَازٌ بعثة':Added, #1: 1	جَوَازُ الْبُصَاقِ
u'جَوَازٌ بَعْضٌ':Added, #1: 1	جَوَازَ بَعْثَةِ
u'جَوَازٌ بُكاءٌ':Added, #1: 1	جَوَازُ الْبَعْضِ
u'جَوَازٌ بُلُوغٌ':Added, #1: 1	جَوَازِ الْبُكَاءِ
u'جَوَازٌ بِنَاءٌ':Added, #1: 1	جَوَازُ بُلُوغِ
u'جَوَازٌ بِنَاءٌ':Added, #1: 1	جَوَازَ الْبِنَاءِ
u'جَوَازٌ بِنَاءٌ':Added, #3: 3	جَوَازُ بِنَاءِ
u'جَوَازٌ بِنَاءٌ':Added, #4: 4	جَوَازُ الْبِنَاءِ
u'جَوَازٌ بِنَاءٌ':Added, #4: 4	جَوَازِ بِنَاءِ
u'جَوَازٌ بَوْلٌ':Added, #8: 8	جَوَازِ الْبِنَاءِ
u'جَوَازٌ بَيات':Added, #1: 1	جَوَازُ الْبَوْلِ
u'جَوَازٌ بَيْعٌ':Added, #1: 1	جَوَازِ الْبَيَاتِ
u'جَوَازٌ بَيْعٌ':Added, #16: 16	جَوَازُ بَيْعِهِ
u'جَوَازٌ بَيْعٌ':Added, #19: 19	جَوَازَ بَيْعِ
u'جَوَازٌ بَيْعٌ':Added, #22: 22	جَوَازَ الْبَيْعِ
u'جَوَازٌ بَيْعٌ':Added, #22: 22	جَوَازُ الْبَيْعِ
u'جَوَازٌ بَيْعٌ':Added, #25: 25	جَوَازُ بَيْعِ
u'جَوَازٌ بَيْعٌ':Added, #2: 2	جَوَازِ بَيْعٍ
u'جَوَازٌ بَيْعٌ':Added, #43: 43	جَوَازِ بَيْعِهِ
u'جَوَازٌ بَيْعٌ':Added, #44: 44	جَوَازِ الْبَيْعِ
u'جَوَازٌ بَيْعٌ':Added, #80: 80	جَوَازِ بَيْعِ
u'جَوَازٌ تَأْجِيلٌ':Added, #8: 8	جَوَازَ بَيْعِهِ
u'جَوَازٌ تَأَخُّرٌ':Added, #1: 1	جَوَازِ تَأْجِيلِهِ
u'جَوَازٌ تَأْخِيرٌ':Added, #1: 1	جَوَازَ التَّأَخُّرِ
u'جَوَازٌ تَأْخِيرٌ':Added, #11: 11	جَوَازِ تَأْخِيرِ
u'جَوَازٌ تَأْخِيرٌ':Added, #16: 16	جَوَازِ التَّأْخِيرِ
u'جَوَازٌ تَأْخِيرٌ':Added, #1: 1	جَوَازِ تَأْخِيرِهِ
u'جَوَازٌ تَأْخِيرٌ':Added, #2: 2	جَوَازَ التَّأْخِيرِ
u'جَوَازٌ تَأْخِيرٌ':Added, #2: 2	جَوَازَ تَأْخِيرِ
u'جَوَازٌ تَأْخِيرٌ':Added, #5: 5	جَوَازُ التَّأْخِيرِ
u'جَوَازٌ تَأْدِيبٌ':Added, #9: 9	جَوَازُ تَأْخِيرِ
u'جَوَازٌ تَبَادُلٌ':Added, #1: 1	جَوَازَ تَأْدِيبِ
u'جَوَازٌ تَبْدِيلٌ':Added, #1: 1	جَوَازُ التَّبَادُلِ
u'جَوَازٌ تَبْدِيلٌ':Added, #1: 1	جَوَازَ تَبْدِيلِ
u'جَوَازٌ تَبْعِيض':Added, #1: 1	جَوَازُ تَبْدِيلِ
u'جَوَازٌ تَبْعِيض':Added, #1: 1	جَوَازِ التَّبْعِيضِ
u'جَوَازٌ تَتَبُّعٌ':Added, #2: 2	جَوَازِ تَبْعِيضِ
u'جَوَازٌ تَثْنِيَةٌ':Added, #3: 3	جَوَازِ تَتَبُّعِ
u'جَوَازٌ تِجَارَةٌ':Added, #1: 1	جَوَازَ تَثْنِيَةِ
u'جَوَازٌ تَجْدِيدٌ':Added, #2: 2	جَوَازِ التِّجَارَةِ
u'جَوَازٌ تَجَزُّؤٌ':Added, #1: 1	جَوَازِ تَجْدِيدِ
u'جَوَازٌ تَجَزُّؤٌ':Added, #1: 1	جَوَازِ التَّجَزُّؤِ
u'جَوَازٌ تَجَزُّؤٌ':Added, #1: 1	جَوَازُ تَجَزُّؤِ
u'جَوَازٌ تَجَوُّزٌ':Added, #1: 1	جَوَازِ تَجَزُّؤِ
u'جَوَازٌ تَجَوُّزٌ':Added, #1: 1	جَوَازُ التَّجَوُّزِ
u'جَوَازٌ تَحَالُفٌ':Added, #1: 1	جَوَازِ التَّجَوُّزِ
u'جَوَازٌ تَحْبِيسٌ':Added, #2: 2	جَوَازُ التَّحَالُفِ
u'جَوَازٌ تَحْرِيمٌ':Added, #1: 1	جَوَازِ التَّحْبِيسِ
u'جَوَازٌ تَحْصِيلٌ':Added, #1: 1	جَوَازُ تَحْرِيمِ
u'جَوَازٌ تَحَقُّقٌ':Added, #1: 1	جَوَازُ تَحْصِيلِ
u'جَوَازٌ تَحْكِيمٌ':Added, #2: 2	جَوَازَ التَّحَقُّقِ
u'جَوَازٌ تَحْكِيمٌ':Added, #2: 2	جَوَازُ التَّحْكِيمِ
u'جَوَازٌ تَحْكِيمٌ':Added, #2: 2	جَوَازَ تَحْكِيمِ
u'جَوَازٌ تَحْكِيمٌ':Added, #2: 2	جَوَازِ تَحْكِيمِ
u'جَوَازٌ تَحَلُّلٌ':Added, #4: 4	جَوَازِ التَّحْكِيمِ
u'جَوَازٌ تَحَلُّلٌ':Added, #1: 1	جَوَازَ التَّحَلُّلِ
u'جَوَازٌ تَحَلُّلٌ':Added, #1: 1	جَوَازُ التَّحَلُّلِ
u'جَوَازٌ تَحَلُّلٌ':Added, #1: 1	جَوَازِ التَّحَلُّلِ
u'جَوَازٌ تَحْلِيَةٌ':Added, #2: 2	جَوَازِ تَحَلُّلِ
u'جَوَازٌ تَحْلِيَةٌ':Added, #1: 1	جَوَازِ التَّحْلِيَةِ
u'جَوَازٌ تَحْلِيَةٌ':Added, #1: 1	جَوَازَ تَحْلِيَةِ
u'جَوَازٌ تَحْلِيَةٌ':Added, #1: 1	جَوَازُ تَحْلِيَةِ
u'جَوَازٌ تَحْلِيف':Added, #2: 2	جَوَازِ تَحْلِيَةِ
u'جَوَازٌ تَحْلِيف':Added, #1: 1	جَوَازِ التَّحْلِيفِ
u'جَوَازٌ تَحْلِيلٌ':Added, #1: 1	جَوَازِ تَحْلِيفِ
u'جَوَازٌ تَحْلِيلٌ':Added, #1: 1	جَوَازِ تَحْلِيلِ
u'جَوَازٌ تَحْلِيلٌ':Added, #1: 1	جَوَازَ تَحْلِيلِهِ
u'جَوَازٌ تَحَمُّلٌ':Added, #1: 1	جَوَازِ تَحْلِيلِهِ
u'جَوَازٌ تَحَمُّلٌ':Added, #1: 1	جَوَازَ التَّحَمُّلِ
u'جَوَازٌ تَحَمُّلٌ':Added, #1: 1	جَوَازِ التَّحَمُّلِ
u'جَوَازٌ تَخارُج':Added, #2: 2	جَوَازِ تَحَمُّلِ
u'جَوَازٌ تَخْصِيصٌ':Added, #1: 1	جَوَازِ التَّخَارُجِ
u'جَوَازٌ تَخْصِيصٌ':Added, #12: 12	جَوَازِ تَخْصِيصِ
u'جَوَازٌ تَخْصِيصٌ':Added, #1: 1	جَوَازِ تَخْصِيصِهِ
u'جَوَازٌ تَخْصِيصٌ':Added, #2: 2	جَوَازَ تَخْصِيصِ
u'جَوَازٌ تَخْصِيصٌ':Added, #2: 2	جَوَازُ تَخْصِيصِ
u'جَوَازٌ تَخْصِيصٌ':Added, #3: 3	جَوَازَ التَّخْصِيصِ
u'جَوَازٌ تَخْصِيصٌ':Added, #5: 5	جَوَازُ التَّخْصِيصِ
u'جَوَازٌ تَخْفِيفٌ':Added, #7: 7	جَوَازِ التَّخْصِيصِ
u'جَوَازٌ تَخَلُّفٌ':Added, #1: 1	جَوَازُ تَخْفِيفِ
u'جَوَازٌ تَخَلُّفٌ':Added, #1: 1	جَوَازَ التَّخَلُّفِ
u'جَوَازٌ تَخَيُّلٌ':Added, #1: 1	جَوَازُ التَّخَلُّفِ
u'جَوَازٌ تَخْيِيرٌ':Added, #1: 1	جَوَازِ التَّخَيُّلِ
u'جَوَازٌ تَدَاخُلٌ':Added, #2: 2	جَوَازِ التَّخْيِيرِ
u'جَوَازٌ تَدْرِيجٌ':Added, #1: 1	جَوَازَ التَّدَاخُلِ
u'جَوَازٌ تَرْكٌ':Added, #2: 2	جَوَازِ التَّدْرِيجِ
u'جَوَازٌ تَرْكٌ':Added, #13: 13	جَوَازِ التَّرْكِ
u'جَوَازٌ تَرْكٌ':Added, #2: 2	جَوَازَ تَرْكِهِ
u'جَوَازٌ تَرْكٌ':Added, #3: 3	جَوَازَ تَرْكِ
u'جَوَازٌ تَرْكٌ':Added, #4: 4	جَوَازُ التَّرْكِ
u'جَوَازٌ تَرْكٌ':Added, #4: 4	جَوَازِ تَرْكِهِ
u'جَوَازٌ تَرْكٌ':Added, #5: 5	جَوَازُ تَرْكِ
u'جَوَازٌ تَرْكٌ':Added, #5: 5	جَوَازُ تَرْكِهِ
u'جَوَازٌ تَرْكٌ':Added, #6: 6	جَوَازِ تَرْكِ
u'جَوَازٌ تَرْكِيبٌ':Added, #8: 8	جَوَازَ التَّرْكِ
u'جَوَازٌ تَزَوُّجٌ':Added, #2: 2	جَوَازِ التَّرْكِيبِ
u'جَوَازٌ تَزَوُّجٌ':Added, #1: 1	جَوَازِ التَّزَوُّجِ
u'جَوَازٌ تَزَوُّجٌ':Added, #1: 1	جَوَازُ تَزَوُّجِ
u'جَوَازٌ تَزْوِيجٌ':Added, #2: 2	جَوَازِ تَزَوُّجِ
u'جَوَازٌ تَزْوِيجٌ':Added, #1: 1	جَوَازُ تَزْوِيجِهِ
u'جَوَازٌ تَزْوِيجٌ':Added, #1: 1	جَوَازِ تَزْوِيجِهِ
u'جَوَازٌ تَزْوِيجٌ':Added, #3: 3	جَوَازُ تَزْوِيجِ
u'جَوَازٌ تَسْعِيرٌ':Added, #3: 3	جَوَازِ تَزْوِيجِ
u'جَوَازٌ تَسْعِيرٌ':Added, #1: 1	جَوَازَ التَّسْعِيرِ
u'جَوَازٌ تَسْكِينٌ':Added, #1: 1	جَوَازِ التَّسْعِيرِ
u'جَوَازٌ تَسَلُّفٌ':Added, #1: 1	جَوَازَ تَسْكِينِ
u'جَوَازٌ تَسْلِيمٌ':Added, #1: 1	جَوَازِ التَّسَلُّفِ
u'جَوَازٌ تَسْلِيمٌ':Added, #1: 1	جَوَازَ تَسْلِيمِ
u'جَوَازٌ تَسْمِيَة':Added, #1: 1	جَوَازِ تَسْلِيمِ
u'جَوَازٌ تَسْوِيَةٌ':Added, #1: 1	جَوَازَ التَّسْمِيَةِ
u'جَوَازٌ تَسْوِيدٌ':Added, #1: 1	جَوَازِ التَّسْوِيَةِ
u'جَوَازٌ تَصَدُّقٌ':Added, #1: 1	جَوَازِ تَسْوِيدِ
u'جَوَازٌ تَصَدُّقٌ':Added, #1: 1	جَوَازَ التَّصَدُّقِ
u'جَوَازٌ تَصَدُّقٌ':Added, #2: 2	جَوَازُ التَّصَدُّقِ
u'جَوَازٌ تَصْدِيقٌ':Added, #2: 2	جَوَازِ التَّصَدُّقِ
u'جَوَازٌ تَصْدِيقٌ':Added, #1: 1	جَوَازِ تَصْدِيقِ
u'جَوَازٌ تَصَرُّفٌ':Added, #2: 2	جَوَازَ التَّصْدِيقِ
u'جَوَازٌ تَصَرُّفٌ':Added, #12: 12	جَوَازَ التَّصَرُّفِ
u'جَوَازٌ تَصَرُّفٌ':Added, #14: 14	جَوَازِ التَّصَرُّفِ
u'جَوَازٌ تَصَرُّفٌ':Added, #1: 1	جَوَازُ تَصَرُّفِهِ
u'جَوَازٌ تَصَرُّفٌ':Added, #2: 2	جَوَازُ التَّصَرُّفَاتِ
u'جَوَازٌ تَصَرُّفٌ':Added, #2: 2	جَوَازِ تَصَرُّفَاتِهِ
u'جَوَازٌ تَصَرُّفٌ':Added, #4: 4	جَوَازِ تَصَرُّفِ
u'جَوَازٌ تَصَرُّفٌ':Added, #5: 5	جَوَازُ التَّصَرُّفِ
u'جَوَازٌ تَصْرِيحٌ':Added, #5: 5	جَوَازِ تَصَرُّفِهِ
u'جَوَازٌ تَصْوِيت':Added, #1: 1	جَوَازِ التَّصْرِيحِ
u'جَوَازٌ تَضْحِيَةٌ':Added, #1: 1	جَوَازِ التَّصْوِيتِ
u'جَوَازٌ تَضْحِيَةٌ':Added, #4: 4	جَوَازِ التَّضْحِيَةِ
u'جَوَازٌ تَضْمِين':Added, #7: 7	جَوَازَ التَّضْحِيَةِ
u'جَوَازٌ تَضْمِينٌ':Added, #1: 1	جَوَازِ التَّضْمِينِ
u'جَوَازٌ تَضْمِينٌ':Added, #2: 2	جَوَازِ تَضْمِينِ
u'جَوَازٌ تَضْيِيقٌ':Added, #2: 2	جَوَازِ تَضْمِينِهِ
u'جَوَازٌ تَطَرُّقٌ':Added, #2: 2	جَوَازَ تَضْيِيقِ
u'جَوَازٌ تَطْلِيقٌ':Added, #1: 1	جَوَازِ التَّطَرُّقِ
u'جَوَازٌ تَطَهُّرٌ':Added, #1: 1	جَوَازَ تَطْلِيقِ
u'جَوَازٌ تَطْهِيرٌ':Added, #1: 1	جَوَازِ تَطَهُّرِ
u'جَوَازٌ تَطْهِيرٌ':Added, #1: 1	جَوَازُ التَّطْهِيرِ
u'جَوَازٌ تَطْهِيرٌ':Added, #1: 1	جَوَازِ تَطْهِيرِ
u'جَوَازٌ تَطَوُّعٌ':Added, #2: 2	جَوَازِ التَّطْهِيرِ
u'جَوَازٌ تَطَوُّعٌ':Added, #2: 2	جَوَازَ التَّطَوُّعِ
u'جَوَازٌ تَطْوِيلٌ':Added, #2: 2	جَوَازِ التَّطَوُّعِ
u'جَوَازٌ تَطْوِيلٌ':Added, #1: 1	جَوَازَ تَطْوِيلِ
u'جَوَازٌ تَطْوِيلٌ':Added, #1: 1	جَوَازُ تَطْوِيلِ
u'جَوَازٌ تَطْوِيلٌ':Added, #1: 1	جَوَازِ تَطْوِيلِ
u'جَوَازٌ تَعَاظُمٌ':Added, #1: 1	جَوَازَ تَطْوِيلِهِ
u'جَوَازٌ تَعَامُلٌ':Added, #1: 1	جَوَازِ التَّعَاظُمِ
u'جَوَازٌ تَعَبُّدٌ':Added, #2: 2	جَوَازِ التَّعَامُلِ
u'جَوَازٌ تَعْجِيل':Added, #1: 1	جَوَازِ التَّعَبُّدِ
u'جَوَازٌ تَعْجِيل':Added, #13: 13	جَوَازِ التَّعْجِيلِ
u'جَوَازٌ تَعْجِيل':Added, #1: 1	جَوَازَ تَعْجِيلِ
u'جَوَازٌ تَعْجِيل':Added, #2: 2	جَوَازُ التَّعْجِيلِ
u'جَوَازٌ تَعْجِيل':Added, #3: 3	جَوَازَ التَّعْجِيلِ
u'جَوَازٌ تَعْجِيل':Added, #4: 4	جَوَازُ تَعْجِيلِ
u'جَوَازٌ تَعَدُّدٌ':Added, #4: 4	جَوَازِ تَعْجِيلِ
u'جَوَازٌ تَعَدُّدٌ':Added, #1: 1	جَوَازُ التَّعَدُّدِ
u'جَوَازٌ تَعَدُّدٌ':Added, #2: 2	جَوَازَ التَّعَدُّدِ
u'جَوَازٌ تَعَدُّدٌ':Added, #2: 2	جَوَازُ تَعَدُّدِ
u'جَوَازٌ تَعَدُّدٌ':Added, #3: 3	جَوَازِ تَعَدُّدِ
u'جَوَازٌ تَعَدِّي':Added, #8: 8	جَوَازِ التَّعَدُّدِ
u'جَوَازٌ تَعْذِيب':Added, #1: 1	جَوَازِ التَّعَدِّيَةِ
u'جَوَازٌ تَعَرُّضٌ':Added, #1: 1	جَوَازِ تَعْذِيبِ
u'جَوَازٌ تَعْرِيضٌ':Added, #1: 1	جَوَازُ التَّعَرُّضِ
u'جَوَازٌ تَعْرِيضٌ':Added, #1: 1	جَوَازُ التَّعْرِيضِ
u'جَوَازٌ تَعْزِيَةٌ':Added, #1: 1	جَوَازِ التَّعْرِيضِ
u'جَوَازٌ تَعْزِير':Added, #1: 1	جَوَازُ التَّعْزِيَةِ
u'جَوَازٌ تَعْزِير':Added, #1: 1	جَوَاز التَّعْزِيرِ
u'جَوَازٌ تَعَلُّقٌ':Added, #1: 1	جَوَازَ التَّعْزِيرِ
u'جَوَازٌ تَعَلُّقٌ':Added, #1: 1	جَوَازُ التَّعَلُّقِ
u'جَوَازٌ تَعَلُّمٌ':Added, #1: 1	جَوَازَ تَعَلُّقِ
u'جَوَازٌ تَعْلِيقٌ':Added, #1: 1	جَوَازِ تَعَلُّمِ
u'جَوَازٌ تَعْلِيقٌ':Added, #1: 1	جَوَازَ تَعْلِيقِ
u'جَوَازٌ تَعْلِيلٌ':Added, #2: 2	جَوَازِ التَّعْلِيقِ
u'جَوَازٌ تَعْلِيلٌ':Added, #11: 11	جَوَازِ التَّعْلِيلِ
u'جَوَازٌ تَعْلِيلٌ':Added, #1: 1	جَوَازُ التَّعْلِيلِ
u'جَوَازٌ تَعْلِيلٌ':Added, #2: 2	جَوَازَ التَّعْلِيلِ
u'جَوَازٌ تَعْلِيلٌ':Added, #2: 2	جَوَازُ تَعْلِيلِ
u'جَوَازٌ تَعْلِيمٌ':Added, #5: 5	جَوَازِ تَعْلِيلِ
u'جَوَازٌ تَعْوِيضٌ':Added, #1: 1	جَوَازَ التَّعْلِيمِ
u'جَوَازٌ تَغْسِيلٌ':Added, #1: 1	جَوَازُ تَعْوِيضِ
u'جَوَازٌ تَغْطِيَةٌ':Added, #1: 1	جَوَازُ تَغْسِيلِ
u'جَوَازٌ تَغَيُّرٌ':Added, #1: 1	جَوَازُ تَغْطِيَةِ
u'جَوَازٌ تَغْيِيبٌ':Added, #1: 1	جَوَازِ تَغَيُّرِهِ
u'جَوَازٌ تَغْيِيرٌ':Added, #1: 1	جَوَازَ التَّغْيِيبِ
u'جَوَازٌ تَغْيِيرٌ':Added, #1: 1	جَوَازُ التَّغْيِيرِ
u'جَوَازٌ تَغْيِيرٌ':Added, #1: 1	جَوَازِ تَغْيِيرِ
u'جَوَازٌ تَغْيِيرٌ':Added, #2: 2	جَوَازَ التَّغْيِيرِ
u'جَوَازٌ تَفَاضُلٌ':Added, #2: 2	جَوَازُ تَغْيِيرِ
u'جَوَازٌ تَفَاضُلٌ':Added, #1: 1	جَوَازَ التَّفَاضُلِ
u'جَوَازٌ تَفَرُّدٌ':Added, #1: 1	جَوَازِ التَّفَاضُلِ
u'جَوَازٌ تَفْرِقَة':Added, #1: 1	جَوَازِ تَفَرُّدِهِ
u'جَوَازٌ تَفْرِقَة':Added, #1: 1	جَوَازِ التَّفْرِقَةِ
u'جَوَازٌ تَفْرِقَة':Added, #1: 1	جَوَازُ تَفْرِقَةِ
u'جَوَازٌ تَفْرِيقٌ':Added, #2: 2	جَوَازِ تَفْرِقَةِ
u'جَوَازٌ تَفْرِيقٌ':Added, #1: 1	جَوَازُ تَفْرِيقِ
u'جَوَازٌ تَفْرِيقٌ':Added, #2: 2	جَوَازَ التَّفْرِيقِ
u'جَوَازٌ تَفْرِيقٌ':Added, #4: 4	جَوَازُ التَّفْرِيقِ
u'جَوَازٌ تَفْرِيقٌ':Added, #4: 4	جَوَازِ تَفْرِيقِ
u'جَوَازٌ تَفْسِيرٌ':Added, #8: 8	جَوَازِ التَّفْرِيقِ
u'جَوَازٌ تَفْضِيلٌ':Added, #2: 2	جَوَازِ تَفْسِيرِ
u'جَوَازٌ تَفْضِيلٌ':Added, #1: 1	جَوَازُ التّفْضِيلِ
u'جَوَازٌ تَفْضِيلٌ':Added, #1: 1	جَوَازُ التَّفْضِيلِ
u'جَوَازٌ تَفْضِيلٌ':Added, #1: 1	جَوَازِ التَّفْضِيلِ
u'جَوَازٌ تَفْضِيلٌ':Added, #1: 1	جَوَازُ تَفْضِيلِ
u'جَوَازٌ تَفْلِيسٌ':Added, #2: 2	جَوَازِ تَفْضِيلِهِ
u'جَوَازٌ تَفْوِيضٌ':Added, #1: 1	جَوَازِ تَفْلِيسِهِ
u'جَوَازٌ تَفْوِيضٌ':Added, #1: 1	جَوَازُ التَّفْوِيضِ
u'جَوَازٌ تَفْوِيضٌ':Added, #1: 1	جَوَازُ تَفْوِيضِهِ
u'جَوَازٌ تَقَدُّمٌ':Added, #2: 2	جَوَازُ تَفْوِيضِ
u'جَوَازٌ تَقْديرٌ':Added, #1: 1	جَوَازُ تَقَدُّمِ
u'جَوَازٌ تَقْديمٌ':Added, #2: 2	جَوَازُ التَّقْدِيرِ
u'جَوَازٌ تَقْديمٌ':Added, #1: 1	جَوَازَ تَقْدِيمِهِ
u'جَوَازٌ تَقْديمٌ':Added, #1: 1	جَوَازِ تَقْدِيمِهِ
u'جَوَازٌ تَقْديمٌ':Added, #2: 2	جَوَازُ تَقْدِيمِ
u'جَوَازٌ تَقْديمٌ':Added, #2: 2	جَوَازُ تَقْدِيمِهِ
u'جَوَازٌ تَقْديمٌ':Added, #4: 4	جَوَازَ تَقْدِيمِ
u'جَوَازٌ تَقْديمٌ':Added, #4: 4	جَوَازِ تَقْدِيمِ
u'جَوَازٌ تَقَرُّبٌ':Added, #5: 5	جَوَازِ التَّقْدِيمِ
u'جَوَازٌ تَقْريرٌ':Added, #1: 1	جَوَازِ التَّقَرُّبِ
u'جَوَازٌ تَقْسيطٌ':Added, #1: 1	جَوَازُ التَّقْرِيرِ
u'جَوَازٌ تَقْصيرٌ':Added, #1: 1	جَوَازِ التَّقْسِيطِ
u'جَوَازٌ تَقَلُّدٌ':Added, #1: 1	جَوَازَ التَّقْصِيرِ
u'جَوَازٌ تَقَلُّدٌ':Added, #1: 1	جَوَازَ التَّقَلُّدِ
u'جَوَازٌ تَقْليدٌ':Added, #1: 1	جَوَازِ التَّقَلُّدِ
u'جَوَازٌ تَقْليد':Added, #11: 11	جَوَازِ تَقْلِيدِ
u'جَوَازٌ تَقْليدٌ':Added, #11: 11	جَوَازِ تَقْلِيدِ
u'جَوَازٌ تَقْليد':Added, #1: 1	جَوَازَ التَّقْلِيدِ
u'جَوَازٌ تَقْليدٌ':Added, #1: 1	جَوَازَ التَّقْلِيدِ
u'جَوَازٌ تَقْليد':Added, #4: 4	جَوَازُ التَّقْلِيدِ
u'جَوَازٌ تَقْليدٌ':Added, #4: 4	جَوَازُ التَّقْلِيدِ
u'جَوَازٌ تَقْليد':Added, #4: 4	جَوَازَ تَقْلِيدِ
u'جَوَازٌ تَقْليدٌ':Added, #4: 4	جَوَازَ تَقْلِيدِ
u'جَوَازٌ تَقْليد':Added, #6: 6	جَوَازِ تَقْلِيدِهِ
u'جَوَازٌ تَقْليدٌ':Added, #6: 6	جَوَازِ تَقْلِيدِهِ
u'جَوَازٌ تَقْليد':Added, #7: 7	جَوَازُ تَقْلِيدِ
u'جَوَازٌ تَقْليدٌ':Added, #7: 7	جَوَازُ تَقْلِيدِ
u'جَوَازٌ تَقْليد':Added, #9: 9	جَوَازِ التَّقْلِيدِ
u'جَوَازٌ تَقْليمٌ':Added, #9: 9	جَوَازِ التَّقْلِيدِ
u'جَوَازٌ تَكْفيرٌ':Added, #1: 1	جَوَازُ التَّقْلِيمِ
u'جَوَازٌ تَكْفيرٌ':Added, #1: 1	جَوَازُ تَكْفِيرِهِ
u'جَوَازٌ تَكْفيرٌ':Added, #2: 2	جَوَازَ التَّكْفِيرِ
u'جَوَازٌ تَكْفيرٌ':Added, #2: 2	جَوَازُ التَّكْفِيرِ
u'جَوَازٌ تَكْفيرٌ':Added, #2: 2	جَوَازَ تَكْفِيرِهِ
u'جَوَازٌ تَكْفيلٌ':Added, #6: 6	جَوَازِ التَّكْفِيرِ
u'جَوَازٌ تَكْفيلٌ':Added, #1: 1	جَوَازُ التَّكْفِيلِ
u'جَوَازٌ تَكْفينٌ':Added, #1: 1	جَوَازِ التَّكْفِيلِ
u'جَوَازٌ تَكْفينٌ':Added, #1: 1	جَوَازِ تَكْفِينِ
u'جَوَازٌ تَكَلُّمٌ':Added, #2: 2	جَوَازُ تَكْفِينِ
u'جَوَازٌ تَكْليفٌ':Added, #1: 1	جَوَازَ التَّكَلُّمِ
u'جَوَازٌ تَكْليفٌ':Added, #1: 1	جَوَازَ التَّكْلِيفِ
u'جَوَازٌ تَكْليفٌ':Added, #1: 1	جَوَازُ تَكْلِيفِهِ
u'جَوَازٌ تَكْليفٌ':Added, #4: 4	جَوَازُ تَكْلِيفِ
u'جَوَازٌ تَكْليفٌ':Added, #5: 5	جَوَازِ تَكْلِيفِ
u'جَوَازٌ تَكْنِيَة':Added, #7: 7	جَوَازِ التَّكْلِيفِ
u'جَوَازٌ تِلاوَةٌ':Added, #1: 1	جَوَازِ تَكْنِيَةِ
u'جَوَازٌ تِلاوَةٌ':Added, #1: 1	جَوَازُ تِلَاوَةٍ
u'جَوَازٌ تَلَذُّذٌ':Added, #1: 1	جَوَازِ تِلَاوَةِ
u'جَوَازٌ تَلَذُّذٌ':Added, #1: 1	جَوَازِ التَّلَذُّذِ
u'جَوَازٌ تَلَذُّذٌ':Added, #1: 1	جَوَازُ تَلَذُّذِهِ
u'جَوَازٌ تَلَفُّظٌ':Added, #1: 1	جَوَازِ تَلَذُّذِهِ
u'جَوَازٌ تَلْقينٌ':Added, #1: 1	جَوَازُ التَّلَفُّظِ
u'جَوَازٌ تَماثُلٌ':Added, #1: 1	جَوَازِ تَلْقِينِ
u'جَوَازٌ تَمَتُّعٌ':Added, #1: 1	جَوَازُ التَّمَاثُلِ
u'جَوَازٌ تَمَتُّعٌ':Added, #1: 1	جَوَازُ التَّمَتُّعِ
u'جَوَازٌ تَمْر':Added, #1: 1	جَوَازِ التَّمَتُّعِ
u'جَوَازٌ تَمْكِينٌ':Added, #1: 1	جَوَازِ التَّمْرِ
u'جَوَازٌ تَمَلُّك':Added, #1: 1	جَوَازِ تَمْكِينِ
u'جَوَازٌ تَمَلُّكٌ':Added, #1: 1	جَوَازِ التَّمَلُّكِ
u'جَوَازٌ تَمْلِيكٌ':Added, #2: 2	جَوَازَ تَمَلُّكِهِ
u'جَوَازٌ تَمْلِيكٌ':Added, #1: 1	جَوَازُ تَمْلِيكِ
u'جَوَازٌ تَمْلِيكٌ':Added, #1: 1	جَوَازِ تَمْلِيكِ
u'جَوَازٌ تَنَاوُلٌ':Added, #1: 1	جَوَازِ تَمْلِيكِهِ
u'جَوَازٌ تَنَحْنُحٌ':Added, #1: 1	جَوَازِ تَنَاوُلِ
u'جَوَازٌ تَنَفُّلٌ':Added, #1: 1	جَوَازُ التَّنَحْنُحِ
u'جَوَازٌ تَنَفُّلٌ':Added, #2: 2	جَوَازُ التَّنَفُّلِ
u'جَوَازٌ تَنْفِيلٌ':Added, #3: 3	جَوَازِ التَّنَفُّلِ
u'جَوَازٌ تَنْفِيلٌ':Added, #1: 1	جَوَازُ التَّنْفِيلِ
u'جَوَازٌ تَنْكِيرٌ':Added, #1: 1	جَوَازِ تَنْفِيلِ
u'جَوَازٌ تَنْكِيرٌ':Added, #1: 1	جَوَازَ التَّنْكِيرِ
u'جَوَازٌ تَوَجُّهٌ':Added, #1: 1	جَوَازِ تَنْكِيرِ
u'جَوَازٌ تَوَجُّهٌ':Added, #2: 2	جَوَازِ التَّوَجُّهِ
u'جَوَازٌ تَوَصُّلٌ':Added, #3: 3	جَوَازَ التَّوَجُّهِ
u'جَوَازٌ تَوَضُّؤٌ':Added, #1: 1	جَوَازُ التَّوَصُّلِ
u'جَوَازٌ تَوَضُّؤٌ':Added, #1: 1	جَوَازُ التَّوَضُّؤِ
u'جَوَازٌ تَوَضُّؤٌ':Added, #2: 2	جَوَازَ التَّوَضُّؤِ
u'جَوَازٌ تَوَقُّفٌ':Added, #4: 4	جَوَازِ التَّوَضُّؤِ
u'جَوَازٌ تَوْكِيلٌ':Added, #1: 1	جَوَازِ التَّوَقُّفِ
u'جَوَازٌ تَوْكِيلٌ':Added, #11: 11	جَوَازِ التَّوْكِيلِ
u'جَوَازٌ تَوْكِيلٌ':Added, #1: 1	جَوَازِ تَوْكِيلِ
u'جَوَازٌ تَوْكِيلٌ':Added, #2: 2	جَوَازُ تَوْكِيلِ
u'جَوَازٌ تَوْكِيلٌ':Added, #4: 4	جَوَازَ التَّوْكِيلِ
u'جَوَازٌ تَوْكِيلٌ':Added, #5: 5	جَوَازُ التَّوْكِيلِ
u'جَوَازٌ تَوْلِيَةٌ':Added, #8: 8	جَوَازِ تَوْكِيلِهِ
u'جَوَازٌ تَوْلِيَةٌ':Added, #1: 1	جَوَازُ التَّوْلِيَةِ
u'جَوَازٌ تَوْلِيَةٌ':Added, #1: 1	جَوَازِ تَوْلِيَةِ
u'جَوَازٌ تَيَمُّمٌ':Added, #1: 1	جَوَازُ تَوْلِيَتِهِ
u'جَوَازٌ تَيَمُّمٌ':Added, #12: 12	جَوَازَ التَّيَمُّمِ
u'جَوَازٌ تَيَمُّمٌ':Added, #15: 15	جَوَازُ التَّيَمُّمِ
u'جَوَازٌ ثَالِثٌ':Added, #18: 18	جَوَازِ التَّيَمُّمِ
u'جَوَازٌ ثَانِي':Added, #1: 1	جَوَازُ الثَّالِثِ
u'جَوَازٌ ثَانِيَةٌ':Added, #1: 1	جَوَازُ الثَّانِيَةِ
u'جَوَازٌ ثُبُوتٌ':Added, #1: 1	جَوَازُ الثَّانِيَةِ
u'جَوَازٌ ثُبُوتٌ':Added, #1: 1	جَوَازِ الثُّبُوتِ
u'جَوَازٌ ثَقْبٌ':Added, #2: 2	جَوَازِ ثُبُوتِ
u'جَوَازٌ ثَلاثُ':Added, #1: 1	جَوَازِ ثَقْبِ
u'جَوَازٌ ثَلاثَةٌ':Added, #1: 1	جَوَازِ الثَّلَاثِ
u'جَوَازٌ جَبْرٌ':Added, #1: 1	جَوَازُ الثَّلَاثَةِ
u'جَوَازٌ جَبْرٌ':Added, #1: 1	جَوَازُ جَبْرِ
u'جَوَازٌ جَذْبٌ':Added, #2: 2	جَوَازُ جَبْرِهِ
u'جَوَازٌ جَذَعٌ':Added, #1: 1	جَوَازِ جَذْبِهِ
u'جَوَازٌ جَذَعٌ':Added, #1: 1	جَوَازُ الْجَذَعِ
u'جَوَازٌ جَذَعٌ':Added, #1: 1	جَوَازِ الْجَذَعِ
u'جَوَازٌ جُعَلٌ':Added, #2: 2	جَوَازَ الْجَذَعِ
u'جَوَازٌ جُلُوسٌ':Added, #1: 1	جَوَازِ الْجُعَلِ
u'جَوَازٌ جُلُوسٌ':Added, #1: 1	جَوَازِ جُلُوسِهِ
u'جَوَازٌ جمع':Added, #2: 2	جَوَازِ الْجُلُوسِ
u'جَوَازٌ جَمْعٌ':Added, #12: 12	جَوَازُ الْجَمْعِ
u'جَوَازٌ جمع':Added, #12: 12	جَوَازُ الْجَمْعِ
u'جَوَازٌ جَمْعٌ':Added, #13: 13	جَوَازَ الْجَمْعِ
u'جَوَازٌ جمع':Added, #13: 13	جَوَازَ الْجَمْعِ
u'جَوَازٌ جَمْعٌ':Added, #19: 19	جَوَازِ الْجَمْعِ
u'جَوَازٌ جمع':Added, #19: 19	جَوَازِ الْجَمْعِ
u'جَوَازٌ جَمْعٌ':Added, #1: 1	جَوَازَ جَمْعِ
u'جَوَازٌ جمع':Added, #1: 1	جَوَازَ جَمْعِ
u'جَوَازٌ جَمْعٌ':Added, #3: 3	جَوَازُ جَمْعِ
u'جَوَازٌ جمع':Added, #3: 3	جَوَازُ جَمْعِ
u'جَوَازٌ جَمْعٌ':Added, #6: 6	جَوَازِ جَمْعِ
u'جَوَازٌ جمعة':Added, #6: 6	جَوَازِ جَمْعِ
u'جَوَازٌ جُمُعَةٌ':Added, #2: 2	جَوَازِ الْجُمُعَةِ
u'جَوَازٌ جَمِيع':Added, #2: 2	جَوَازِ الْجُمُعَةِ
u'جَوَازٌ جَمِيع':Added, #2: 2	جَوَازَ الْجَمِيعِ
u'جَوَازٌ جهاد':Added, #2: 2	جَوَازِ الْجَمِيعِ
u'جَوَازٌ جِهَادٌ':Added, #1: 1	جَوَازِ الْجِهَادِ
u'جَوَازٌ حَبْسٌ':Added, #1: 1	جَوَازِ الْجِهَادِ
u'جَوَازٌ حَبْسٌ':Added, #1: 1	جَوَازِ الْحَبْسِ
u'جَوَازٌ حَبْسٌ':Added, #1: 1	جَوَازِ حَبْسِ
u'جَوَازٌ حَجٌّ':Added, #3: 3	جَوَازِ حَبْسِهِ
u'جَوَازٌ حَجٌّ':Added, #1: 1	جَوَازُ الْحَجِّ
u'جَوَازٌ حَجٌّ':Added, #1: 1	جَوَازِ الْحَجِّ
u'جَوَازٌ حَجٌّ':Added, #1: 1	جَوَازَ حَجِّ
u'جَوَازٌ حَجٌّ':Added, #1: 1	جَوَازِ حَجِّ
u'جَوَازٌ حَجٌّ':Added, #1: 1	جَوَازُ حَجِّهِ
u'جَوَازٌ حَجَرٌ':Added, #2: 2	جَوَازِ حَجِّهِ
u'جَوَازٌ حَجْرٌ':Added, #1: 1	جَوَازِ الْحَجَرِ
u'جَوَازٌ حَدٌّ':Added, #2: 2	جَوَازِ الْحَجْرِ
u'جَوَازٌ حُسْنٌ':Added, #1: 1	جَوَازِ حَدِّ
u'جَوَازٌ حِصَارٌ':Added, #1: 1	جَوَازُ حُسْنِهِ
u'جَوَازٌ حُصُرٌ':Added, #1: 1	جَوَازُ حِصَارِ
u'جَوَازٌ حُصُول':Added, #1: 1	جَوَازِ حُصُرِ
u'جَوَازٌ حُصُول':Added, #1: 1	جَوَازَ حُصُولِ
u'جَوَازٌ حَظْر':Added, #1: 1	جَوَازِ حُصُولِ
u'جَوَازٌ حَفْرٌ':Added, #1: 1	جَوَازِ الْحَظْرِ
u'جَوَازٌ حَقِيقِيٌّ':Added, #1: 1	جَوَازِ حَفْرِ
u'جَوَازٌ حِكَايَةٌ':Added, #1: 1	جَوَازِ الْحَقِيقِيِّ
u'جَوَازٌ حِكَايَةٌ':Added, #1: 1	جَوَازَ حِكَايَةِ
u'جَوَازٌ حُكْمٌ':Added, #1: 1	جَوَازِ حِكَايَتِهِ
u'جَوَازٌ حُكْمٌ':Added, #10: 10	جَوَازِ الْحُكْمِ
u'جَوَازٌ حُكْمٌ':Added, #1: 1	جَوَازَ الْحُكْمِ
u'جَوَازٌ حُكْمٌ':Added, #1: 1	جَوَازُ حُكْمِ
u'جَوَازٌ حُكْمٌ':Added, #1: 1	جَوَازَ حُكْمِهِ
u'جَوَازٌ حُكْمٌ':Added, #1: 1	جَوَازُ حُكْمِهِ
u'جَوَازٌ حُكْمٌ':Added, #2: 2	جَوَازُ الْحُكْمِ
u'جَوَازٌ حِلٌّ':Added, #3: 3	جَوَازِ حُكْمِهِ
u'جَوَازٌ حَلْقٌ':Added, #1: 1	جَوَازِ حِلِّهِ
u'جَوَازٌ حَلْقٌ':Added, #1: 1	جَوَازُ حَلْقِ
u'جَوَازٌ حَلْقَةٌ':Added, #2: 2	جَوَازِ الْحَلْقِ
u'جَوَازٌ حَلْقَةٌ':Added, #1: 1	جَوَازُ الْحَلْقَةِ
u'جَوَازٌ حَمْلٌ':Added, #1: 1	جَوَازِ الْحَلْقَةِ
u'جَوَازٌ حَمْلٌ':Added, #1: 1	جَوَازِ الْحَمْلِ
u'جَوَازٌ حَمْلٌ':Added, #1: 1	جَوَازَ حَمْلِ
u'جَوَازٌ حَمْلٌ':Added, #1: 1	جَوَازِ حَمْلِ
u'جَوَازٌ حَوَالَةٌ':Added, #1: 1	جَوَازِ حَمْلِهِ
u'جَوَازٌ حَوَالَةٌ':Added, #1: 1	جَوَازَ الْحَوَالَةِ
u'جَوَازٌ حَوَالَةٌ':Added, #1: 1	جَوَازُ الْحَوَالَةِ
u'جَوَازٌ حِيَلٌ':Added, #3: 3	جَوَازِ الْحَوَالَةِ
u'جَوَازٌ حِيلَةٌ':Added, #1: 1	جَوَازِ الْحِيَلِ
u'جَوَازٌ ختان':Added, #2: 2	جَوَازِ الْحِيلَةِ
u'جَوَازٌ خِتَانٌ':Added, #1: 1	جَوَازِ الْخِتَانِ
u'جَوَازٌ خَتْمٌ':Added, #1: 1	جَوَازِ الْخِتَانِ
u'جَوَازٌ خدمة':Added, #1: 1	جَوَازِ خَتْمِ
u'جَوَازٌ خِدْمَةٌ':Added, #1: 1	جَوَازَ خِدْمَةِ
u'جَوَازٌ خَرَزٌ':Added, #1: 1	جَوَازَ خِدْمَةِ
u'جَوَازٌ خُرُوجٌ':Added, #1: 1	جَوَازِ الْخَرَزِ
u'جَوَازٌ خُرُوجٌ':Added, #1: 1	جَوَازَ الْخُرُوجِ
u'جَوَازٌ خُرُوجٌ':Added, #1: 1	جَوَازُ خُرُوجِ
u'جَوَازٌ خُرُوجٌ':Added, #1: 1	جَوَازَ خُرُوجِهِ
u'جَوَازٌ خُرُوجٌ':Added, #2: 2	جَوَازُ الْخُرُوجِ
u'جَوَازٌ خُرُوجٌ':Added, #3: 3	جَوَازِ خُرُوجِ
u'جَوَازٌ خُرُوجٌ':Added, #3: 3	جَوَازِ خُرُوجِهِ
u'جَوَازٌ خَصِيٌّ':Added, #8: 8	جَوَازِ الْخُرُوجِ
u'جَوَازٌ خَطَأٌ':Added, #1: 1	جَوَازُ الْخَصِيِّ
u'جَوَازٌ خِطَابٌ':Added, #2: 2	جَوَازِ الْخَطَأِ
u'جَوَازٌ خِطَابٌ':Added, #1: 1	جَوَازَ الْخِطَابِ
u'جَوَازٌ خِطَابٌ':Added, #1: 1	جَوَازُ الْخِطَابِ
u'جَوَازٌ خطبة':Added, #2: 2	جَوَازُ خِطَابِ
u'جَوَازٌ خِطْبَةٌ':Added, #1: 1	جَوَازُ الْخِطْبَةِ
u'جَوَازٌ خِلاَفٌ':Added, #1: 1	جَوَازُ الْخِطْبَةِ
u'جَوَازٌ خِلاَفٌ':Added, #1: 1	جَوَازِ خِلَافِهِ
u'جَوَازٌ خلط':Added, #3: 3	جَوَازِ الْخِلَافِ
u'جَوَازٌ خُلْعٌ':Added, #2: 2	جَوَازِ خَلْطِ
u'جَوَازٌ خُلْعٌ':Added, #1: 1	جَوَازَ الْخُلْعِ
u'جَوَازٌ خُلْعٌ':Added, #1: 1	جَوَازُ الْخُلْعِ
u'جَوَازٌ خُلْعٌ':Added, #1: 1	جَوَازُ خُلْعِ
u'جَوَازٌ خُلْعٌ':Added, #1: 1	جَوَازِ خُلْعِ
u'جَوَازٌ خَلْفٌ':Added, #4: 4	جَوَازِ الْخُلْعِ
u'جَوَازٌ خَلَفٌ':Added, #1: 1	جَوَازِ الْخَلْفِ
u'جَوَازٌ خَلْوَةٌ':Added, #2: 2	جَوَازِ الْخَلَفِ
u'جَوَازٌ خَلْوَةٌ':Added, #1: 1	جَوَازُ الْخَلْوَةِ
u'جَوَازٌ خَمْسَةٌ':Added, #2: 2	جَوَازُ خَلْوَةِ
u'جَوَازٌ خَوْضٌ':Added, #2: 2	جَوَازِ الْخَمْسَةِ
u'جَوَازٌ دُخُولٌ':Added, #1: 1	جَوَازِ الْخَوْضِ
u'جَوَازٌ دُخُولٌ':Added, #1: 1	جَوَازُ دُخُولِ
u'جَوَازٌ دُخُولٌ':Added, #2: 2	جَوَازِ الدُّخُولِ
u'جَوَازٌ دُخُولٌ':Added, #3: 3	جَوَازُ الدُّخُولِ
u'جَوَازٌ دُخُولٌ':Added, #5: 5	جَوَازَ دُخُولِ
u'جَوَازٌ دُخُولٌ':Added, #5: 5	جَوَازُ دُخُولِهِ
u'جَوَازٌ دُعَاءٌ':Added, #6: 6	جَوَازِ دُخُولِ
u'جَوَازٌ دُعَاءٌ':Added, #12: 12	جَوَازِ الدُّعَاءِ
u'جَوَازٌ دُعَاءٌ':Added, #1: 1	جَوَازَ الدُّعَاءِ
u'جَوَازٌ دفع':Added, #4: 4	جَوَازُ الدُّعَاءِ
u'جَوَازٌ دَفْعٌ':Added, #13: 13	جَوَازِ الدَّفْعِ
u'جَوَازٌ دفع':Added, #13: 13	جَوَازِ الدَّفْعِ
u'جَوَازٌ دَفْعٌ':Added, #1: 1	جَوَاز الدَّفْعِ
u'جَوَازٌ دفع':Added, #1: 1	جَوَاز الدَّفْعِ
u'جَوَازٌ دَفْعٌ':Added, #1: 1	جَوَازَ دَفْعِ
u'جَوَازٌ دفع':Added, #1: 1	جَوَازَ دَفْعِ
u'جَوَازٌ دَفْعٌ':Added, #1: 1	جَوَازَ دَفْعِهِ
u'جَوَازٌ دفع':Added, #1: 1	جَوَازَ دَفْعِهِ
u'جَوَازٌ دَفْعٌ':Added, #2: 2	جَوَازِ دَفْعِهِ
u'جَوَازٌ دفع':Added, #2: 2	جَوَازِ دَفْعِهِ
u'جَوَازٌ دَفْعٌ':Added, #3: 3	جَوَازُ دَفْعِهِ
u'جَوَازٌ دفع':Added, #3: 3	جَوَازُ دَفْعِهِ
u'جَوَازٌ دَفْعٌ':Added, #4: 4	جَوَازُ دَفْعِ
u'جَوَازٌ دفع':Added, #4: 4	جَوَازُ دَفْعِ
u'جَوَازٌ دَفْعٌ':Added, #8: 8	جَوَازُ الدَّفْعِ
u'جَوَازٌ دفع':Added, #8: 8	جَوَازُ الدَّفْعِ
u'جَوَازٌ دَفْعٌ':Added, #8: 8	جَوَازِ دَفْعِ
u'جَوَازٌ دَوْس':Added, #8: 8	جَوَازِ دَفْعِ
u'جَوَازٌ ذكر':Added, #1: 1	جَوَازُ الدَّوْسِ
u'جَوَازٌ ذِكْرٌ':Added, #1: 1	جَوَازَ ذِكْرِ
u'جَوَازٌ ذكر':Added, #1: 1	جَوَازَ ذِكْرِ
u'جَوَازٌ ذَكَرٌ':Added, #2: 2	جَوَازِ الذَّكَرِ
u'جَوَازٌ ذكر':Added, #2: 2	جَوَازِ الذَّكَرِ
u'جَوَازٌ ذِكْرٌ':Added, #4: 4	جَوَازِ ذِكْرِ
u'جَوَازٌ رجعة':Added, #4: 4	جَوَازِ ذِكْرِ
u'جَوَازٌ رجعة':Added, #1: 1	جَوَازَ الرَّجْعَةِ
u'جَوَازٌ رَجْعَةٌ':Added, #1: 1	جَوَازُ الرَّجْعَةِ
u'جَوَازٌ رَجْعَةٌ':Added, #1: 1	جَوَازَ الرَّجْعَةِ
u'جَوَازٌ رجعة':Added, #1: 1	جَوَازُ الرَّجْعَةِ
u'جَوَازٌ رَجْعَةٌ':Added, #4: 4	جَوَازِ الرَّجْعَةِ
u'جَوَازٌ رُجُوعٌ':Added, #4: 4	جَوَازِ الرَّجْعَةِ
u'جَوَازٌ رُجُوعٌ':Added, #1: 1	جَوَازَ رُجُوعِ
u'جَوَازٌ رُجُوعٌ':Added, #2: 2	جَوَازُ رُجُوعِ
u'جَوَازٌ رُجُوعٌ':Added, #2: 2	جَوَازِ رُجُوعِ
u'جَوَازٌ رُجُوعٌ':Added, #3: 3	جَوَازَ الرُّجُوعِ
u'جَوَازٌ رُجُوعٌ':Added, #7: 7	جَوَازُ الرُّجُوعِ
u'جَوَازٌ رُخَصٌ':Added, #8: 8	جَوَازِ الرُّجُوعِ
u'جَوَازٌ رُخْصَةٌ':Added, #1: 1	جَوَازِ الرُّخَصِ
u'جَوَازٌ رَدٌّ':Added, #1: 1	جَوَازِ الرُّخْصَةِ
u'جَوَازٌ رَدٌّ':Added, #1: 1	جَوَازَ الرَّدِّ
u'جَوَازٌ رَدٌّ':Added, #1: 1	جَوَازَ رَدِّ
u'جَوَازٌ رَدٌّ':Added, #1: 1	جَوَازِ رَدِّ
u'جَوَازٌ رَدٌّ':Added, #2: 2	جَوَازُ رَدِّ
u'جَوَازٌ رَدٌّ':Added, #2: 2	جَوَازُ رَدِّهِ
u'جَوَازٌ رَدٌّ':Added, #2: 2	جَوَازِ رَدِّهِ
u'جَوَازٌ رَدٌّ':Added, #5: 5	جَوَازُ الرَّدِّ
u'جَوَازٌ رِزْقٌ':Added, #7: 7	جَوَازِ الرَّدِّ
u'جَوَازٌ رَعْيٌ':Added, #1: 1	جَوَازِ الرِّزْقِ
u'جَوَازٌ رَعْيٌ':Added, #1: 1	جَوَازِ رَعْيِ
u'جَوَازٌ رَفْعٌ':Added, #2: 2	جَوَازِ الرَّعْيِ
u'جَوَازٌ رَفْعٌ':Added, #1: 1	جَوَازُ الرَّفْعِ
u'جَوَازٌ رَفْعٌ':Added, #1: 1	جَوَازُ رَفْعِ
u'جَوَازٌ رَفْعٌ':Added, #1: 1	جَوَازِ رَفْعِ
u'جَوَازٌ رَفْعٌ':Added, #2: 2	جَوَازِ الرَّفْعِ
u'جَوَازٌ ركض':Added, #2: 2	جَوَازِ رَفْعِهِ
u'جَوَازٌ رَكْضٌ':Added, #1: 1	جَوَازِ الرَّكْضِ
u'جَوَازٌ رُكوبٌ':Added, #1: 1	جَوَازِ الرَّكْضِ
u'جَوَازٌ رُكوبٌ':Added, #1: 1	جَوَازَ الرُّكُوبِ
u'جَوَازٌ رُكوبٌ':Added, #1: 1	جَوَازُ رُكُوبِ
u'جَوَازٌ رُكوبٌ':Added, #2: 2	جَوَازِ رُكُوبِهِ
u'جَوَازٌ رَمْيٌ':Added, #4: 4	جَوَازِ رُكُوبِ
u'جَوَازٌ رَمْيٌ':Added, #1: 1	جَوَازُ رَمْيِ
u'جَوَازٌ رَمْيٌ':Added, #1: 1	جَوَازَ رَمْيِهِ
u'جَوَازٌ رَمْيٌ':Added, #1: 1	جَوَازِ رَمْيِهِ
u'جَوَازٌ رَمْيٌ':Added, #2: 2	جَوَازَ الرَّمْيِ
u'جَوَازٌ رَمْيٌ':Added, #2: 2	جَوَازِ رَمْيِ
u'جَوَازٌ رَمْيٌ':Added, #3: 3	جَوَازِ الرَّمْيِ
u'جَوَازٌ رهان':Added, #4: 4	جَوَازُ الرَّمْيِ
u'جَوَازٌ رِهانٌ':Added, #1: 1	جَوَازُ الرِّهَانِ
u'جَوَازٌ رَهْنٌ':Added, #1: 1	جَوَازُ الرِّهَانِ
u'جَوَازٌ رَهْنٌ':Added, #1: 1	جَوَازَ رَهْنِ
u'جَوَازٌ رَهْنٌ':Added, #1: 1	جَوَازَ رَهْنِهِ
u'جَوَازٌ رَهْنٌ':Added, #1: 1	جَوَازُ رَهْنِهِ
u'جَوَازٌ رَهْنٌ':Added, #2: 2	جَوَازُ رَهْنِ
u'جَوَازٌ رَهْنٌ':Added, #2: 2	جَوَازِ رَهْنِ
u'جَوَازٌ رَهْنٌ':Added, #2: 2	جَوَازِ رَهْنِهِ
u'جَوَازٌ رَهْنٌ':Added, #3: 3	جَوَازُ الرَّهْنِ
u'جَوَازٌ رَهْنٌ':Added, #4: 4	جَوَازَ الرَّهْنِ
u'جَوَازٌ رِوايَةٌ':Added, #9: 9	جَوَازِ الرَّهْنِ
u'جَوَازٌ رِوايَةٌ':Added, #1: 1	جَوَازُ رِوَايَةِ
u'جَوَازٌ رِوايَةٌ':Added, #2: 2	جَوَازِ رِوَايَةِ
u'جَوَازٌ رِوايَةٌ':Added, #4: 4	جَوَازُ الرِّوَايَةِ
u'جَوَازٌ رُؤْيَةٌ':Added, #5: 5	جَوَازِ الرِّوَايَةِ
u'جَوَازٌ زمر':Added, #1: 1	جَوَازُ رُؤْيَتِهِ
u'جَوَازٌ زَمْرٌ':Added, #1: 1	جَوَازَ الزَّمْرِ
u'جَوَازٌ زَوالٌ':Added, #1: 1	جَوَازَ الزَّمْرِ
u'جَوَازٌ زِيادَةٌ':Added, #1: 1	جَوَازِ زَوَالِ
u'جَوَازٌ زِيادَةٌ':Added, #1: 1	جَوَازَ زِيَادَةِ
u'جَوَازٌ زِيادَةٌ':Added, #1: 1	جَوَازُ زِيَادَةِ
u'جَوَازٌ زِيادَةٌ':Added, #3: 3	جَوَازُ الزِّيَادَةِ
u'جَوَازٌ زِينَةٌ':Added, #7: 7	جَوَازِ الزِّيَادَةِ
u'جَوَازٌ سَبٌّ':Added, #1: 1	جَوَازِ الزِّينَةِ
u'جَوَازٌ سَبْقٌ':Added, #1: 1	جَوَازُ السَّبِّ
u'جَوَازٌ سَجْنٌ':Added, #1: 1	جَوَازُ السَّبْقِ
u'جَوَازٌ سُجُودٌ':Added, #1: 1	جَوَازِ السَّجْنِ
u'جَوَازٌ سُجُودٌ':Added, #1: 1	جَوَازَ السُّجُودِ
u'جَوَازٌ سَدٌّ':Added, #2: 2	جَوَازِ السُّجُودِ
u'جَوَازٌ سُرُورٌ':Added, #1: 1	جَوَازِ سَدِّ
u'جَوَازٌ سَفَرٌ':Added, #1: 1	جَوَازُ السّرُورِ
u'جَوَازٌ سَفَرٌ':Added, #1: 1	جَوَازَ السَّفَرِ
u'جَوَازٌ سَفَرٌ':Added, #1: 1	جَوَازُ سَفَرِهِ
u'جَوَازٌ سَفَرٌ':Added, #2: 2	جَوَازُ السَّفَرِ
u'جَوَازٌ سَفَرٌ':Added, #2: 2	جَوَازِ سَفَرِهِ
u'جَوَازٌ سُقُوطٌ':Added, #7: 7	جَوَازِ السَّفَرِ
u'جَوَازٌ سُقُوطٌ':Added, #1: 1	جَوَازُ سُقُوطِ
u'جَوَازٌ سَقْيٌ':Added, #1: 1	جَوَازِ سُقُوطِ
u'جَوَازٌ سُكُوتٌ':Added, #1: 1	جَوَازَ سَقْيِهِ
u'جَوَازٌ سلام':Added, #1: 1	جَوَازِ السُّكُوتِ
u'جَوَازٌ سَلاَمٌ':Added, #1: 1	جَوَازُ السَّلَامِ
u'جَوَازٌ سَلَفٌ':Added, #1: 1	جَوَازُ السَّلَامِ
u'جَوَازٌ سَلَمٌ':Added, #1: 1	جَوَازِ السَّلَفِ
u'جَوَازٌ سَلَمٌ':Added, #17: 17	جَوَازِ السَّلَمِ
u'جَوَازٌ سَلَمٌ':Added, #1: 1	جَوَازَ السَّلَمِ
u'جَوَازٌ سَلَمٌ':Added, #1: 1	جَوَازُ سَلَمِ
u'جَوَازٌ سَمَاعٌ':Added, #8: 8	جَوَازُ السَّلَمِ
u'جَوَازٌ سَمَاعٌ':Added, #1: 1	جَوَازِ سَمَاعِ
u'جَوَازٌ سَهْوٌ':Added, #2: 2	جَوَازِ سَمَاعِهِ
u'جَوَازٌ سُؤَالٌ':Added, #1: 1	جَوَازُ السَّهْوِ
u'جَوَازٌ سُؤَالٌ':Added, #1: 1	جَوَازِ السُّؤَالِ
u'جَوَازٌ شِبَعٌ':Added, #1: 1	جَوَازُ سُؤَالِ
u'جَوَازٌ شِبَعٌ':Added, #1: 1	جَوَازُ الشِّبَعِ
u'جَوَازٌ شِبَعٌ':Added, #1: 1	جَوَازِ شِبَعِهِ
u'جَوَازٌ شُبْهَةٌ':Added, #2: 2	جَوَازِ الشِّبَعِ
u'جَوَازٌ شِرَاءٌ':Added, #1: 1	جَوَازَ شُبْهَةٍ
u'جَوَازٌ شِرَاءٌ':Added, #1: 1	جَوَازُ الشِّرَاءِ
u'جَوَازٌ شِرَاءٌ':Added, #3: 3	جَوَازِ الشِّرَاءِ
u'جَوَازٌ شِرَاءٌ':Added, #3: 3	جَوَازُ شِرَاءِ
u'جَوَازٌ شرب':Added, #6: 6	جَوَازِ شِرَاءِ
u'جَوَازٌ شرب':Added, #1: 1	جَوَازَ الشُّرْبِ
u'جَوَازٌ شُرْبٌ':Added, #1: 1	جَوَازِ الشُّرْبِ
u'جَوَازٌ شُرْبٌ':Added, #1: 1	جَوَازَ الشُّرْبِ
u'جَوَازٌ شرب':Added, #1: 1	جَوَازِ الشُّرْبِ
u'جَوَازٌ شُرْبٌ':Added, #1: 1	جَوَازُ شُرْبِ
u'جَوَازٌ شرب':Added, #1: 1	جَوَازُ شُرْبِ
u'جَوَازٌ شُرْبٌ':Added, #1: 1	جَوَازَ شُرْبِهِ
u'جَوَازٌ شَرْطٌ':Added, #1: 1	جَوَازَ شُرْبِهِ
u'جَوَازٌ شَرْطٌ':Added, #1: 1	جَوَازَ شَرْطِهِ
u'جَوَازٌ شَرْطٌ':Added, #2: 2	جَوَازِ الشَّرْطِ
u'جَوَازٌ شَرْطٌ':Added, #2: 2	جَوَازِ شَرْطِ
u'جَوَازٌ شركة':Added, #3: 3	جَوَازُ شَرْطِ
u'جَوَازٌ شَرِكَةٌ':Added, #1: 1	جَوَازُ الشَّرِكَةِ
u'جَوَازٌ شركة':Added, #1: 1	جَوَازُ الشَّرِكَةِ
u'جَوَازٌ شِرْكَةٌ':Added, #2: 2	جَوَازُ الشِّرْكَةِ
u'جَوَازٌ شركة':Added, #2: 2	جَوَازُ الشِّرْكَةِ
u'جَوَازٌ شَرِكَةٌ':Added, #6: 6	جَوَازِ الشَّرِكَةِ
u'جَوَازٌ شَفَاعَةٌ':Added, #6: 6	جَوَازِ الشَّرِكَةِ
u'جَوَازٌ شَفَاعَةٌ':Added, #1: 1	جَوَازُ الشَّفَاعَةِ
u'جَوَازٌ شَهَادَةٌ':Added, #1: 1	جَوَازِ الشَّفَاعَةِ
u'جَوَازٌ شَهَادَةٌ':Added, #1: 1	جَوَازِ شَهَادَتِهِ
u'جَوَازٌ شَهَادَةٌ':Added, #2: 2	جَوَازُ الشَّهَادَةِ
u'جَوَازٌ شَهَادَةٌ':Added, #3: 3	جَوَازَ الشَّهَادَةِ
u'جَوَازٌ شَهَادَةٌ':Added, #3: 3	جَوَازِ شَهَادَةِ
u'جَوَازٌ شَهَادَةٌ':Added, #4: 4	جَوَازَ شَهَادَةِ
u'جَوَازٌ شَهَادَةٌ':Added, #4: 4	جَوَازُ شَهَادَةِ
u'جَوَازٌ شَيْءٌ':Added, #8: 8	جَوَازِ الشَّهَادَةِ
u'جَوَازٌ شَيْءٌ':Added, #1: 1	جَوَازُ الشَّيْءِ
u'جَوَازٌ صِحَّةٌ':Added, #2: 2	جَوَازِ الشَّيْءِ
u'جَوَازٌ صِحَّةٌ':Added, #1: 1	جَوَازَ صِحَّةِ
u'جَوَازٌ صداق':Added, #1: 1	جَوَازِ صِحَّتِهِ
u'جَوَازٌ صَدَاقٌ':Added, #1: 1	جَوَازِ الصَّدَاقِ
u'جَوَازٌ صداق':Added, #1: 1	جَوَازِ الصَّدَاقِ
u'جَوَازٌ صَدَاقٌ':Added, #2: 2	جَوَازُ الصَّدَاقِ
u'جَوَازٌ صدق':Added, #2: 2	جَوَازُ الصَّدَاقِ
u'جَوَازٌ صِدْقٌ':Added, #1: 1	جَوَازِ صِدْقِهِ
u'جَوَازٌ صدقة':Added, #1: 1	جَوَازِ صِدْقِهِ
u'جَوَازٌ صدقة':Added, #1: 1	جَوَازَ الصَّدَقَةِ
u'جَوَازٌ صَدَقَةٌ':Added, #1: 1	جَوَازُ الصَّدَقَةِ
u'جَوَازٌ صَدَقَةٌ':Added, #1: 1	جَوَازَ الصَّدَقَةِ
u'جَوَازٌ صدقة':Added, #1: 1	جَوَازُ الصَّدَقَةِ
u'جَوَازٌ صَدَقَةٌ':Added, #2: 2	جَوَازِ الصَّدَقَةِ
u'جَوَازٌ صُدُورٌ':Added, #2: 2	جَوَازِ الصَّدَقَةِ
u'جَوَازٌ صُدُورٌ':Added, #1: 1	جَوَازَ صُدُورِ
u'جَوَازٌ صُدُورٌ':Added, #1: 1	جَوَازُ صُدُورِ
u'جَوَازٌ صُدُورٌ':Added, #1: 1	جَوَازِ صُدُورِ
u'جَوَازٌ صِرَاطٌ':Added, #1: 1	جَوَازِ صُدُورِهِ
u'جَوَازٌ صَرْفٌ':Added, #1: 1	جَوَازِ الصِّرَاطِ
u'جَوَازٌ صَرْفٌ':Added, #1: 1	جَوَازَ صَرْفِ
u'جَوَازٌ صَرْف':Added, #1: 1	جَوَازِ صَرْفِ
u'جَوَازٌ صَرْف':Added, #1: 1	جَوَازَ صَرْفِ
u'جَوَازٌ صَرْفٌ':Added, #1: 1	جَوَازِ صَرْفِ
u'جَوَازٌ صَرْف':Added, #2: 2	جَوَازَ الصَّرْفِ
u'جَوَازٌ صَرْفٌ':Added, #2: 2	جَوَازَ الصَّرْفِ
u'جَوَازٌ صَرْف':Added, #2: 2	جَوَازُ صَرْفِ
u'جَوَازٌ صَرْفٌ':Added, #2: 2	جَوَازُ صَرْفِ
u'جَوَازٌ صَرْف':Added, #3: 3	جَوَازِ الصَّرْفِ
u'جَوَازٌ صَرْفٌ':Added, #3: 3	جَوَازِ الصَّرْفِ
u'جَوَازٌ صَرْفٌ':Added, #3: 3	جَوَازُ صَرْفِهِ
u'جَوَازٌ صَرْف':Added, #3: 3	جَوَازِ صَرْفِهِ
u'جَوَازٌ صَرْف':Added, #3: 3	جَوَازُ صَرْفِهِ
u'جَوَازٌ صَرْفٌ':Added, #3: 3	جَوَازِ صَرْفِهِ
u'جَوَازٌ صَرْف':Added, #5: 5	جَوَازُ الصَّرْفِ
u'جَوَازٌ صُعُودٌ':Added, #5: 5	جَوَازُ الصَّرْفِ
u'جَوَازٌ صَفٌّ':Added, #1: 1	جَوَازَ الصُّعُودِ
u'جَوَازٌ صَلاَةٌ':Added, #1: 1	جَوَازِ الصَّفِّ
u'جَوَازٌ صَلاَةٌ':Added, #12: 12	جَوَازُ الصَّلَاةِ
u'جَوَازٌ صَلاَةٌ':Added, #1: 1	جَوَازِ الصَّلاَةِ
u'جَوَازٌ صَلاَةٌ':Added, #1: 1	جَوَازُ صَلَاةِ
u'جَوَازٌ صَلاَةٌ':Added, #1: 1	جَوَازَ صَلَاتِهِ
u'جَوَازٌ صَلاَةٌ':Added, #20: 20	جَوَازِ صَلَاةِ
u'جَوَازٌ صَلاَةٌ':Added, #46: 46	جَوَازِ الصَّلَاةِ
u'جَوَازٌ صَلاَةٌ':Added, #58: 58	جَوَازَ الصَّلَاةِ
u'جَوَازٌ صَلاَةٌ':Added, #5: 5	جَوَازَ صَلَاةِ
u'جَوَازٌ صِلَةٌ':Added, #6: 6	جَوَازِ صَلَاتِهِ
u'جَوَازٌ صلح':Added, #1: 1	جَوَازُ صِلَةِ
u'جَوَازٌ صُلْحٌ':Added, #1: 1	جَوَازِ صُلْحِ
u'جَوَازٌ صلح':Added, #1: 1	جَوَازِ صُلْحِ
u'جَوَازٌ صلح':Added, #4: 4	جَوَازَ الصُّلْحِ
u'جَوَازٌ صُلْحٌ':Added, #4: 4	جَوَازِ الصُّلْحِ
u'جَوَازٌ صُلْحٌ':Added, #4: 4	جَوَازَ الصُّلْحِ
u'جَوَازٌ صَلَوَاتٌ':Added, #4: 4	جَوَازِ الصُّلْحِ
u'جَوَازٌ صنعة':Added, #1: 1	جَوَازِ الصَّلَوَاتِ
u'جَوَازٌ صَنْعَةٌ':Added, #1: 1	جَوَازُ الصَّنْعَةِ
u'جَوَازٌ صَوْمٌ':Added, #1: 1	جَوَازُ الصَّنْعَةِ
u'جَوَازٌ صَوْمٌ':Added, #1: 1	جَوَازَ الصَّوْمِ
u'جَوَازٌ صَوْمٌ':Added, #1: 1	جَوَازُ الصَّوْمِ
u'جَوَازٌ صَوْمٌ':Added, #2: 2	جَوَازَ صَوْمِ
u'جَوَازٌ صَوْمٌ':Added, #2: 2	جَوَازُ صَوْمِهِ
u'جَوَازٌ صَوْمٌ':Added, #6: 6	جَوَازِ الصَّوْمِ
u'جَوَازٌ صِيَامٌ':Added, #6: 6	جَوَازِ صَوْمِ
u'جَوَازٌ صَيْدٌ':Added, #1: 1	جَوَازَ الصِّيَامِ
u'جَوَازٌ ضَرْبٌ':Added, #1: 1	جَوَازَ صَيْدِ
u'جَوَازٌ ضَرْبٌ':Added, #1: 1	جَوَازِ الضَّرْبِ
u'جَوَازٌ ضَرْبٌ':Added, #1: 1	جَوَازُ ضَرْبِ
u'جَوَازٌ ضَرْبٌ':Added, #1: 1	جَوَازُ ضَرْبِهِ
u'جَوَازٌ ضَرْبٌ':Added, #1: 1	جَوَازِ ضَرْبِهِ
u'جَوَازٌ ضَمٌّ':Added, #4: 4	جَوَازِ ضَرْبِ
u'جَوَازٌ ضَمَانٌ':Added, #1: 1	جَوَازِ ضَمِّ
u'جَوَازٌ ضَمَانٌ':Added, #1: 1	جَوَازَ الضَّمَانِ
u'جَوَازٌ ضَمِيرٌ':Added, #1: 1	جَوَازُ الضَّمَانِ
u'جَوَازٌ طِبٌّ':Added, #1: 1	جَوَازِ الضَّمِيرِ
u'جَوَازٌ طَلاَقٌ':Added, #1: 1	جَوَازِ الطِّبِّ
u'جَوَازٌ طلب':Added, #1: 1	جَوَازِ الطَّلَاقِ
u'جَوَازٌ طَلَبٌ':Added, #1: 1	جَوَازِ طَلَبِ
u'جَوَازٌ طلب':Added, #1: 1	جَوَازِ طَلَبِ
u'جَوَازٌ طَلَبٌ':Added, #2: 2	جَوَازُ الطَّلَبِ
u'جَوَازٌ طلب':Added, #2: 2	جَوَازُ الطَّلَبِ
u'جَوَازٌ طَلَبٌ':Added, #4: 4	جَوَازُ طَلَبِ
u'جَوَازٌ طُلُوعٌ':Added, #4: 4	جَوَازُ طَلَبِ
u'جَوَازٌ طَهَارَةٌ':Added, #1: 1	جَوَازِ طُلُوعِ
u'جَوَازٌ طَهَارَةٌ':Added, #1: 1	جَوَازُ الطَّهَارَةِ
u'جَوَازٌ طَهَارَةٌ':Added, #1: 1	جَوَازِ طَهَارَةِ
u'جَوَازٌ طواف':Added, #5: 5	جَوَازِ الطَّهَارَةِ
u'جَوَازٌ طَوَافٌ':Added, #1: 1	جَوَازَ الطَّوَافِ
u'جَوَازٌ طواف':Added, #1: 1	جَوَازَ الطَّوَافِ
u'جَوَازٌ طَوَافٌ':Added, #1: 1	جَوَازِ طَوَافِهِ
u'جَوَازٌ طواف':Added, #1: 1	جَوَازِ طَوَافِهِ
u'جَوَازٌ طَوَافٌ':Added, #2: 2	جَوَازِ الطَّوَافِ
u'جَوَازٌ ظهار':Added, #2: 2	جَوَازِ الطَّوَافِ
u'جَوَازٌ عارِيَّةٌ':Added, #1: 1	جَوَازِ الظِّهَارِ
u'جَوَازٌ عِبَادَةٌ':Added, #1: 1	جَوَازِ الْعَارِيَّةِ
u'جَوَازٌ عُبُورٌ':Added, #1: 1	جَوَازَ الْعِبَادَةِ
u'جَوَازٌ عتق':Added, #1: 1	جَوَازِ الْعُبُورِ
u'جَوَازٌ عِتْقٌ':Added, #1: 1	جَوَازِ عِتْقِ
u'جَوَازٌ عتق':Added, #1: 1	جَوَازِ عِتْقِ
u'جَوَازٌ عِتْقٌ':Added, #1: 1	جَوَازُ عِتْقِهِ
u'جَوَازٌ عتق':Added, #1: 1	جَوَازُ عِتْقِهِ
u'جَوَازٌ عِتْقٌ':Added, #2: 2	جَوَازَ الْعِتْقِ
u'جَوَازٌ عتق':Added, #2: 2	جَوَازَ الْعِتْقِ
u'جَوَازٌ عِتْقٌ':Added, #2: 2	جَوَازُ عِتْقِ
u'جَوَازٌ عتق':Added, #2: 2	جَوَازُ عِتْقِ
u'جَوَازٌ عِتْقٌ':Added, #3: 3	جَوَازِ عِتْقِهِ
u'جَوَازٌ عَجِينٌ':Added, #3: 3	جَوَازِ عِتْقِهِ
u'جَوَازٌ عَدَدٌ':Added, #1: 1	جَوَازِ الْعَجِينِ
u'جَوَازٌ عَدَمٌ':Added, #1: 1	جَوَازَ عَدَدٍ
u'جَوَازٌ عَدَمٌ':Added, #1: 1	جَوَازُ عَدَمِ
u'جَوَازٌ عُدُولٌ':Added, #2: 2	جَوَازِ عَدَمِ
u'جَوَازٌ عُرُوضٌ':Added, #1: 1	جَوَازِ عُدُولِهِ
u'جَوَازٌ عزل':Added, #1: 1	جَوَازُ عُرُوضِ
u'جَوَازٌ عزل':Added, #1: 1	جَوَازَ عَزْلِ
u'جَوَازٌ عزل':Added, #1: 1	جَوَازُ عَزْلِ
u'جَوَازٌ عزل':Added, #1: 1	جَوَازَ عَزْلِهِ
u'جَوَازٌ عزل':Added, #1: 1	جَوَازِ عَزْلِهِ
u'جَوَازٌ عزل':Added, #2: 2	جَوَازُ الْعَزْلِ
u'جَوَازٌ عزل':Added, #2: 2	جَوَازِ الْعَزْلِ
u'جَوَازٌ عِشَاءٌ':Added, #2: 2	جَوَازِ عَزْلِ
u'جَوَازٌ عَصْرٌ':Added, #1: 1	جَوَازُ الْعِشَاءِ
u'جَوَازٌ عَصْرٌ':Added, #1: 1	جَوَازِ الْعَصْرِ
u'جَوَازٌ عطف':Added, #2: 2	جَوَازَ الْعَصْرِ
u'جَوَازٌ عطف':Added, #1: 1	جَوَازَ الْعَطْفِ
u'جَوَازٌ عَطْفٌ':Added, #1: 1	جَوَازُ الْعَطْفِ
u'جَوَازٌ عَطْفٌ':Added, #1: 1	جَوَازَ الْعَطْفِ
u'جَوَازٌ عَفْوٌ':Added, #1: 1	جَوَازُ الْعَطْفِ
u'جَوَازٌ عَفْوٌ':Added, #1: 1	جَوَازَ الْعَفْوِ
u'جَوَازٌ عَفْوٌ':Added, #1: 1	جَوَازُ عَفْوِ
u'جَوَازٌ عَفْوٌ':Added, #2: 2	جَوَازِ عَفْوِ
u'جَوَازٌ عَقْدٌ':Added, #5: 5	جَوَازِ الْعَفْوِ
u'جَوَازٌ عَقْدٌ':Added, #11: 11	جَوَازِ الْعَقْدِ
u'جَوَازٌ عَقْدٌ':Added, #1: 1	جَوَازَ عَقْدِ
u'جَوَازٌ عَقْدٌ':Added, #1: 1	جَوَازُ عَقْدِ
u'جَوَازٌ عَقْدٌ':Added, #2: 2	جَوَازَ الْعَقْدِ
u'جَوَازٌ عَقْدٌ':Added, #3: 3	جَوَازُ الْعَقْدِ
u'جَوَازٌ عُقُوبَةٌ':Added, #3: 3	جَوَازِ عَقْدِ
u'جَوَازٌ عُقُودٌ':Added, #1: 1	جَوَازُ الْعُقُوبَةِ
u'جَوَازٌ عَكْسٌ':Added, #1: 1	جَوَازُ الْعُقُودِ
u'جَوَازٌ عَكْسٌ':Added, #1: 1	جَوَازُ الْعَكْسِ
u'جَوَازٌ عَكْسٌ':Added, #1: 1	جَوَازُ عَكْسِهِ
u'جَوَازٌ عِلاَجٌ':Added, #2: 2	جَوَازِ عَكْسِهِ
u'جَوَازٌ علم':Added, #1: 1	جَوَازِ عِلَاجِهِ
u'جَوَازٌ عِلْمٌ':Added, #1: 1	جَوَازِ الْعِلْمِ
u'جَوَازٌ عمرة':Added, #1: 1	جَوَازِ الْعِلْمِ
u'جَوَازٌ عُمْرَةٌ':Added, #3: 3	جَوَازِ الْعُمْرَةِ
u'جَوَازٌ عَمَلٌ':Added, #3: 3	جَوَازِ الْعُمْرَةِ
u'جَوَازٌ عَمَلٌ':Added, #18: 18	جَوَازِ الْعَمَلِ
u'جَوَازٌ عَمَلٌ':Added, #1: 1	جَوَازُ عَمَلِ
u'جَوَازٌ عَمَلٌ':Added, #2: 2	جَوَازِ عَمَلِ
u'جَوَازٌ عَمَلٌ':Added, #3: 3	جَوَازَ الْعَمَلِ
u'جَوَازٌ عُمُومٌ':Added, #4: 4	جَوَازُ الْعَمَلِ
u'جَوَازٌ عُمُومٌ':Added, #1: 1	جَوَازَ عُمُومِ
u'جَوَازٌ عمياء':Added, #2: 2	جَوَازِ عُمُومِ
u'جَوَازٌ عَوْدٌ':Added, #1: 1	جَوَازِ الْعَمْيَاءِ
u'جَوَازٌ غَرْسٌ':Added, #1: 1	جَوَازِ الْعَوْدِ
u'جَوَازٌ غَسْلٌ':Added, #2: 2	جَوَازِ غَرْسِ
u'جَوَازٌ غَسْلٌ':Added, #1: 1	جَوَازَ الْغَسْلِ
u'جَوَازٌ غُسْلٌ':Added, #1: 1	جَوَازُ غَسْلِ
u'جَوَازٌ غُسْلٌ':Added, #1: 1	جَوَازِ غُسْلِ
u'جَوَازٌ غُسْلٌ':Added, #2: 2	جَوَازُ الْغُسْلِ
u'جَوَازٌ غُسْلٌ':Added, #2: 2	جَوَازُ غُسْلِ
u'جَوَازٌ غَلَطٌ':Added, #4: 4	جَوَازِ الْغُسْلِ
u'جَوَازٌ غِيبَةٌ':Added, #1: 1	جَوَازَ الْغَلَطِ
u'جَوَازٌ غِيبَةٌ':Added, #1: 1	جَوَازِ غِيبَةِ
u'جَوَازٌ فَتْحٌ':Added, #2: 2	جَوَازُ غِيبَةِ
u'جَوَازٌ فَتْحٌ':Added, #1: 1	جَوَازُ الْفَتْحِ
u'جَوَازٌ فَتْحٌ':Added, #1: 1	جَوَازِ فَتْحِ
u'جَوَازٌ فَتْحٌ':Added, #2: 2	جَوَازَ الْفَتْحِ
u'جَوَازٌ فَتْحٌ':Added, #2: 2	جَوَازُ فَتْحِ
u'جَوَازٌ فُتُورٌ':Added, #3: 3	جَوَازِ الْفَتْحِ
u'جَوَازٌ فرار':Added, #1: 1	جَوَازِ فُتُورِ
u'جَوَازٌ فرار':Added, #1: 1	جَوَازُ الْفِرَارِ
u'جَوَازٌ فِرَارٌ':Added, #1: 1	جَوَازِ الْفِرَارِ
u'جَوَازٌ فِرَارٌ':Added, #1: 1	جَوَازُ الْفِرَارِ
u'جَوَازٌ فَرْضٌ':Added, #1: 1	جَوَازِ الْفِرَارِ
u'جَوَازٌ فَرْضٌ':Added, #1: 1	جَوَازِ فَرْضِ
u'جَوَازٌ فَرْضٌ':Added, #1: 1	جَوَازِ فَرْضِهِ
u'جَوَازٌ فُرْقَةٌ':Added, #2: 2	جَوَازِ الْفَرْضِ
u'جَوَازٌ فَرْكٌ':Added, #1: 1	جَوَازِ الْفُرْقَةِ
u'جَوَازٌ فَسْخٌ':Added, #1: 1	جَوَازِ فَرْكِ
u'جَوَازٌ فَسْخٌ':Added, #1: 1	جَوَازُ الْفَسْخِ
u'جَوَازٌ فَسْخٌ':Added, #1: 1	جَوَازَ فَسْخِ
u'جَوَازٌ فَسْخٌ':Added, #1: 1	جَوَازِ فَسْخِ
u'جَوَازٌ فَسْخٌ':Added, #4: 4	جَوَازَ الْفَسْخِ
u'جَوَازٌ فَصْلٌ':Added, #6: 6	جَوَازِ الْفَسْخِ
u'جَوَازٌ فَصْلٌ':Added, #1: 1	جَوَازُ الْفَصْلِ
u'جَوَازٌ فَصْلٌ':Added, #1: 1	جَوَازُ فَصْلِ
u'جَوَازٌ فِطْرٌ':Added, #2: 2	جَوَازِ الْفَصْلِ
u'جَوَازٌ فِطْرٌ':Added, #12: 12	جَوَازِ الْفِطْرِ
u'جَوَازٌ فِعْلٌ':Added, #3: 3	جَوَازَ الْفِطْرِ
u'جَوَازٌ فِعْلٌ':Added, #10: 10	جَوَازِ الْفِعْلِ
u'جَوَازٌ فِعْلٌ':Added, #1: 1	جَوَازَ الْفِعْلَيْنِ
u'جَوَازٌ فِعْلٌ':Added, #1: 1	جَوَازَ فِعْلِ
u'جَوَازٌ فِعْلٌ':Added, #1: 1	جَوَازِ فِعْلِهِ
u'جَوَازٌ فِعْلٌ':Added, #2: 2	جَوَازِ فِعْلِ
u'جَوَازٌ فِعْلٌ':Added, #3: 3	جَوَازَ فِعْلِهِ
u'جَوَازٌ فِعْلٌ':Added, #3: 3	جَوَازُ فِعْلِهِ
u'جَوَازٌ فِعْلٌ':Added, #5: 5	جَوَازُ فِعْلِ
u'جَوَازٌ فِعْلٌ':Added, #6: 6	جَوَازَ الْفِعْلِ
u'جَوَازٌ فَيْءٌ':Added, #7: 7	جَوَازُ الْفِعْلِ
u'جَوَازٌ قَبْضٌ':Added, #1: 1	جَوَازِ الْفَيْءِ
u'جَوَازٌ قَبْضٌ':Added, #1: 1	جَوَازَ قَبْضِ
u'جَوَازٌ قَبْضٌ':Added, #1: 1	جَوَازُ قَبْضِ
u'جَوَازٌ قُبْلَةٌ':Added, #2: 2	جَوَازِ قَبْضِ
u'جَوَازٌ قَبُولٌ':Added, #3: 3	جَوَازِ الْقُبْلَةِ
u'جَوَازٌ قَبُولٌ':Added, #1: 1	جَوَازِ الْقَبُولِ
u'جَوَازٌ قتال':Added, #1: 1	جَوَازِ قَبُولِ
u'جَوَازٌ قتال':Added, #1: 1	جَوَازُ قِتَالِ
u'جَوَازٌ قِتَالٌ':Added, #1: 1	جَوَازِ قِتَالِ
u'جَوَازٌ قِتَالٌ':Added, #1: 1	جَوَازُ قِتَالِ
u'جَوَازٌ قتال':Added, #1: 1	جَوَازِ قِتَالِ
u'جَوَازٌ قِتَالٌ':Added, #1: 1	جَوَازُ قِتَالِهِ
u'جَوَازٌ قتال':Added, #1: 1	جَوَازُ قِتَالِهِ
u'جَوَازٌ قِتَالٌ':Added, #5: 5	جَوَازِ الْقِتَالِ
u'جَوَازٌ قتل':Added, #5: 5	جَوَازِ الْقِتَالِ
u'جَوَازٌ قَتْلٌ':Added, #13: 13	جَوَازِ قَتْلِ
u'جَوَازٌ قتل':Added, #13: 13	جَوَازِ قَتْلِ
u'جَوَازٌ قَتْلٌ':Added, #1: 1	جَوَازِ الْقَتْلِ
u'جَوَازٌ قتل':Added, #1: 1	جَوَازِ الْقَتْلِ
u'جَوَازٌ قَتْلٌ':Added, #1: 1	جَوَازُ قَتْلِ
u'جَوَازٌ قتل':Added, #1: 1	جَوَازُ قَتْلِ
u'جَوَازٌ قَتْلٌ':Added, #2: 2	جَوَازُ الْقَتْلِ
u'جَوَازٌ قتل':Added, #2: 2	جَوَازُ الْقَتْلِ
u'جَوَازٌ قَتْلٌ':Added, #2: 2	جَوَازَ قَتْلِهِ
u'جَوَازٌ قتل':Added, #2: 2	جَوَازَ قَتْلِهِ
u'جَوَازٌ قَتْلٌ':Added, #3: 3	جَوَازِ قَتْلِهِ
u'جَوَازٌ قتل':Added, #3: 3	جَوَازِ قَتْلِهِ
u'جَوَازٌ قَتْلٌ':Added, #4: 4	جَوَازَ قَتْلِ
u'جَوَازٌ قتل':Added, #4: 4	جَوَازَ قَتْلِ
u'جَوَازٌ قَتْلٌ':Added, #7: 7	جَوَازُ قَتْلِهِ
u'جَوَازٌ قِرَاءةٌ':Added, #7: 7	جَوَازُ قَتْلِهِ
u'جَوَازٌ قِرَاءةٌ':Added, #1: 1	جَوَازَ قِرَاءَةِ
u'جَوَازٌ قِرَاءةٌ':Added, #2: 2	جَوَازِ قِرَاءَتِهِ
u'جَوَازٌ قِرَاءةٌ':Added, #4: 4	جَوَازِ الْقِرَاءَةِ
u'جَوَازٌ قِرَاءةٌ':Added, #4: 4	جَوَازُ قِرَاءَةِ
u'جَوَازٌ قراض':Added, #4: 4	جَوَازِ قِرَاءَةِ
u'جَوَازٌ قراض':Added, #1: 1	جَوَازُ الْقِرَاضِ
u'جَوَازٌ قِرَانٌ':Added, #1: 1	جَوَازِ الْقِرَاضِ
u'جَوَازٌ قَرْضٌ':Added, #2: 2	جَوَازِ الْقِرَانِ
u'جَوَازٌ قَرْضٌ':Added, #1: 1	جَوَازَ قَرْضِ
u'جَوَازٌ قَرْضٌ':Added, #1: 1	جَوَازُ قَرْضِ
u'جَوَازٌ قَرْضٌ':Added, #1: 1	جَوَازُ قَرْضِهِ
u'جَوَازٌ قَرْضٌ':Added, #1: 1	جَوَازِ قَرْضِهِ
u'جَوَازٌ قُرْعَةٌ':Added, #3: 3	جَوَازِ قَرْضِ
u'جَوَازٌ قَسام':Added, #1: 1	جَوَازِ الْقُرْعَةِ
u'جَوَازٌ قَسامَة':Added, #1: 1	جَوَازِ الْقَسَامَةِ
u'جَوَازٌ قَسْمٌ':Added, #1: 1	جَوَازِ الْقَسَامَةِ
u'جَوَازٌ قسمة':Added, #2: 2	جَوَازِ الْقَسْمِ
u'جَوَازٌ قِسْمَةٌ':Added, #1: 1	جَوَازُ قِسْمَةِ
u'جَوَازٌ قسمة':Added, #1: 1	جَوَازُ قِسْمَةِ
u'جَوَازٌ قِسْمَةٌ':Added, #2: 2	جَوَازُ الْقِسْمَةِ
u'جَوَازٌ قسمة':Added, #2: 2	جَوَازُ الْقِسْمَةِ
u'جَوَازٌ قِسْمَةٌ':Added, #2: 2	جَوَازِ قِسْمَتِهِ
u'جَوَازٌ قسمة':Added, #2: 2	جَوَازِ قِسْمَتِهِ
u'جَوَازٌ قِسْمَةٌ':Added, #3: 3	جَوَازِ قِسْمَةِ
u'جَوَازٌ قسمة':Added, #3: 3	جَوَازِ قِسْمَةِ
u'جَوَازٌ قِسْمَةٌ':Added, #7: 7	جَوَازِ الْقِسْمَةِ
u'جَوَازٌ قصاص':Added, #7: 7	جَوَازِ الْقِسْمَةِ
u'جَوَازٌ قِصَاصٌ':Added, #1: 1	جَوَازَ الْقِصَاصِ
u'جَوَازٌ قصاص':Added, #1: 1	جَوَازَ الْقِصَاصِ
u'جَوَازٌ قِصَاصٌ':Added, #2: 2	جَوَازُ الْقِصَاصِ
u'جَوَازٌ قَصْرٌ':Added, #2: 2	جَوَازُ الْقِصَاصِ
u'جَوَازٌ قَصْرٌ':Added, #1: 1	جَوَازَ قَصْرِ
u'جَوَازٌ قَصْرٌ':Added, #1: 1	جَوَازِ قَصْرِ
u'جَوَازٌ قَصْرٌ':Added, #1: 1	جَوَازِ قَصْرِهِ
u'جَوَازٌ قَصْرٌ':Added, #3: 3	جَوَازَ الْقَصْرِ
u'جَوَازٌ قَصْرٌ':Added, #6: 6	جَوَازُ الْقَصْرِ
u'جَوَازٌ قَضَاءٌ':Added, #9: 9	جَوَازِ الْقَصْرِ
u'جَوَازٌ قَضَاءٌ':Added, #12: 12	جَوَازِ الْقَضَاءِ
u'جَوَازٌ قَضَاءٌ':Added, #1: 1	جَوَازَ الْقَضَاءِ
u'جَوَازٌ قَضَاءٌ':Added, #1: 1	جَوَازُ قَضَاءِ
u'جَوَازٌ قَضَاءٌ':Added, #2: 2	جَوَازَ قَضَاءِ
u'جَوَازٌ قَطْعٌ':Added, #4: 4	جَوَازِ قَضَاءِ
u'جَوَازٌ قَطْعٌ':Added, #1: 1	جَوَازُ الْقَطْعِ
u'جَوَازٌ قَطْعٌ':Added, #1: 1	جَوَازِ قَطْعِهِ
u'جَوَازٌ قَطْعٌ':Added, #2: 2	جَوَازَ قَطْعِ
u'جَوَازٌ قَطْعٌ':Added, #3: 3	جَوَازِ الْقَطْعِ
u'جَوَازٌ قُعُودٌ':Added, #4: 4	جَوَازِ قَطْعِ
u'جَوَازٌ قُعُودٌ':Added, #1: 1	جَوَازُ الْقُعُودِ
u'جَوَازٌ قلب':Added, #1: 1	جَوَازِ الْقُعُودِ
u'جَوَازٌ قلب':Added, #1: 1	جَوَازَ قَلْبِ
u'جَوَازٌ قَلْبٌ':Added, #1: 1	جَوَازُ قَلْبِ
u'جَوَازٌ قَلْبٌ':Added, #1: 1	جَوَازَ قَلْبِ
u'جَوَازٌ قَلْب':Added, #1: 1	جَوَازُ قَلْبِ
u'جَوَازٌ قَلْب':Added, #1: 1	جَوَازَ قَلْبِ
u'جَوَازٌ قلب':Added, #1: 1	جَوَازُ قَلْبِ
u'جَوَازٌ قَلْبٌ':Added, #2: 2	جَوَازِ قَلْبِ
u'جَوَازٌ قَلْب':Added, #2: 2	جَوَازِ قَلْبِ
u'جَوَازٌ قلى':Added, #2: 2	جَوَازِ قَلْبِ
u'جَوَازٌ قَلِيلٌ':Added, #1: 1	جَوَازِ قَلْيِهِ
u'جَوَازٌ قول':Added, #1: 1	جَوَازَ قَلِيلِ
u'جَوَازٌ قَوْلٌ':Added, #1: 1	جَوَازِ الْقَوْلِ
u'جَوَازٌ قول':Added, #1: 1	جَوَازِ الْقَوْلِ
u'جَوَازٌ قَوْلٌ':Added, #2: 2	جَوَازِ قَوْلِ
u'جَوَازٌ قِيَاسٌ':Added, #2: 2	جَوَازِ قَوْلِ
u'جَوَازٌ قِيَاسٌ':Added, #1: 1	جَوَازَ الْقِيَاسِ
u'جَوَازٌ قِيَاسٌ':Added, #1: 1	جَوَازُ قِيَاسِ
u'جَوَازٌ قِيَاسٌ':Added, #7: 7	جَوَازُ الْقِيَاسِ
u'جَوَازٌ قيام':Added, #8: 8	جَوَازِ الْقِيَاسِ
u'جَوَازٌ قِيَامٌ':Added, #1: 1	جَوَازُ قِيَامِ
u'جَوَازٌ قيام':Added, #1: 1	جَوَازُ قِيَامِ
u'جَوَازٌ قِيَامٌ':Added, #1: 1	جَوَازُ قِيَامِهِ
u'جَوَازٌ قيام':Added, #1: 1	جَوَازُ قِيَامِهِ
u'جَوَازٌ قِيَامٌ':Added, #2: 2	جَوَازُ الْقِيَامِ
u'جَوَازٌ كَافِرٌ':Added, #2: 2	جَوَازُ الْقِيَامِ
u'جَوَازٌ كِتَابٌ':Added, #1: 1	جَوَازُ الْكَافِرَةِ
u'جَوَازٌ كِتَابٌ':Added, #1: 1	جَوَازِ الْكِتَابِ
u'جَوَازٌ كِتَابَةٌ':Added, #1: 1	جَوَازِ كِتَابِ
u'جَوَازٌ كِتَابَةٌ':Added, #1: 1	جَوَازَ الْكِتَابَةِ
u'جَوَازٌ كِتَابَةٌ':Added, #1: 1	جَوَازُ الْكِتَابَةِ
u'جَوَازٌ كِتَابَةٌ':Added, #1: 1	جَوَازِ كِتَابَةِ
u'جَوَازٌ كِتَابَةٌ':Added, #1: 1	جَوَازُ كِتَابَتِهِ
u'جَوَازٌ كَثْرَةٌ':Added, #3: 3	جَوَازِ الْكِتَابَةِ
u'جَوَازٌ كَرْع':Added, #1: 1	جَوَازُ كَثْرَةِ
u'جَوَازٌ كَسْرٌ':Added, #1: 1	جَوَازُ الْكَرْعِ
u'جَوَازٌ كَسْرٌ':Added, #1: 1	جَوَازِ الْكَسْرِ
u'جَوَازٌ كَشْفٌ':Added, #1: 1	جَوَازِ كَسْرِ
u'جَوَازٌ كَفٌّ':Added, #1: 1	جَوَازِ كَشْفِ
u'جَوَازٌ كَفَالَةٌ':Added, #1: 1	جَوَازُ كَفِّ
u'جَوَازٌ كَفَالَةٌ':Added, #1: 1	جَوَازَ الْكَفَالَةِ
u'جَوَازٌ كَفَالَةٌ':Added, #2: 2	جَوَازُ الْكَفَالَةِ
u'جَوَازٌ كِفَايَةٌ':Added, #4: 4	جَوَازِ الْكَفَالَةِ
u'جَوَازٌ كِنَايَةٌ':Added, #1: 1	جَوَازِ الْكِفَايَةِ
u'جَوَازٌ كَوْنٌ':Added, #1: 1	جَوَازِ الْكِنَايَةِ
u'جَوَازٌ كَوْنٌ':Added, #12: 12	جَوَازِ كَوْنِهِ
u'جَوَازٌ كَوْنٌ':Added, #13: 13	جَوَازِ كَوْنِ
u'جَوَازٌ كَوْنٌ':Added, #1: 1	جَوَازَ كَوْنِ
u'جَوَازٌ كَوْنٌ':Added, #3: 3	جَوَازُ كَوْنِ
u'جَوَازٌ كَيْلٌ':Added, #3: 3	جَوَازُ كَوْنِهِ
u'جَوَازٌ لِبَاسٌ':Added, #1: 1	جَوَازَ كَيْلِ
u'جَوَازٌ لِبَاسٌ':Added, #1: 1	جَوَازُ لِبَاسِ
u'جَوَازٌ لِبَاسٌ':Added, #1: 1	جَوَازِ لِبَاسِ
u'جَوَازٌ لبس':Added, #1: 1	جَوَازِ لِبَاسِهِ
u'جَوَازٌ لُبْسٌ':Added, #1: 1	جَوَازَ اللُّبْسِ
u'جَوَازٌ لبس':Added, #1: 1	جَوَازَ اللُّبْسِ
u'جَوَازٌ لُبْسٌ':Added, #1: 1	جَوَازِ لُبْسِهِ
u'جَوَازٌ لبس':Added, #1: 1	جَوَازِ لُبْسِهِ
u'جَوَازٌ لُبْسٌ':Added, #2: 2	جَوَازِ اللُّبْسِ
u'جَوَازٌ لبس':Added, #2: 2	جَوَازِ اللُّبْسِ
u'جَوَازٌ لُبْسٌ':Added, #2: 2	جَوَازِ لُبْسِ
u'جَوَازٌ لبس':Added, #2: 2	جَوَازِ لُبْسِ
u'جَوَازٌ لُبْسٌ':Added, #3: 3	جَوَازُ لُبْسِهِ
u'جَوَازٌ لبس':Added, #3: 3	جَوَازُ لُبْسِهِ
u'جَوَازٌ لُبْسٌ':Added, #5: 5	جَوَازُ لُبْسِ
u'جَوَازٌ لطخ':Added, #5: 5	جَوَازُ لُبْسِ
u'جَوَازٌ لَطْخٌ':Added, #1: 1	جَوَازَ لَطْخِ
u'جَوَازٌ لعان':Added, #1: 1	جَوَازَ لَطْخِ
u'جَوَازٌ لعب':Added, #1: 1	جَوَازِ اللِّعَانِ
u'جَوَازٌ لعب':Added, #1: 1	جَوَازُ اللَّعِبِ
u'جَوَازٌ لَعِبٌ':Added, #1: 1	جَوَازِ اللَّعِبِ
u'جَوَازٌ لَعِبٌ':Added, #1: 1	جَوَازُ اللَّعِبِ
u'جَوَازٌ لَعْن':Added, #1: 1	جَوَازِ اللَّعِبِ
u'جَوَازٌ لعنة':Added, #1: 1	جَوَازَ اللَّعْنِ
u'جَوَازٌ لَعْنَةٌ':Added, #1: 1	جَوَازِ اللَّعْنَةِ
u'جَوَازٌ لعنة':Added, #1: 1	جَوَازِ اللَّعْنَةِ
u'جَوَازٌ لَعْنَةٌ':Added, #2: 2	جَوَازِ لَعْنَةِ
u'جَوَازٌ لَفْظٌ':Added, #2: 2	جَوَازِ لَعْنَةِ
u'جَوَازٌ لَفْظَةٌ':Added, #1: 1	جَوَازِ اللّفْظَيْنِ
u'جَوَازٌ مَاءٌ':Added, #1: 1	جَوَازُ اللَّفْظَةِ
u'جَوَازٌ مَانِعٌ':Added, #1: 1	جَوَازَ الْمَاءِ
u'جَوَازٌ مُبَادَرَةٌ':Added, #1: 1	جَوَازِ الْمَانِعِ
u'جَوَازٌ مُبَاشَرَةٌ':Added, #2: 2	جَوَازُ مُبَادَرَةِ
u'جَوَازٌ مُبَاشَرَةٌ':Added, #1: 1	جَوَازِ الْمُبَاشَرَةِ
u'جَوَازٌ مُبَايَعَةٌ':Added, #1: 1	جَوَازُ مُبَاشَرَةِ
u'جَوَازٌ مَبِيتٌ':Added, #2: 2	جَوَازِ مُبَايَعَةِ
u'جَوَازٌ مُتَابَعٌ':Added, #1: 1	جَوَازِ مَبِيتِ
u'جَوَازٌ مُتَابَعٌ':Added, #1: 1	جَوَازَ الْمُتَابَعَةِ
u'جَوَازٌ مُتَابَعَةٌ':Added, #2: 2	جَوَازِ الْمُتَابَعَةِ
u'جَوَازٌ مُتَابَعَةٌ':Added, #1: 1	جَوَازَ الْمُتَابَعَةِ
u'جَوَازٌ مُتْعَةٌ':Added, #2: 2	جَوَازِ الْمُتَابَعَةِ
u'جَوَازٌ مثل':Added, #1: 1	جَوَازِ الْمُتْعَةِ
u'جَوَازٌ مِثْلٌ':Added, #3: 3	جَوَازُ مِثْلِ
u'جَوَازٌ مُجَامَعَةٌ':Added, #3: 3	جَوَازُ مِثْلِ
u'جَوَازٌ مُجَاوَزَةٌ':Added, #1: 1	جَوَازَ الْمُجَامَعَةِ
u'جَوَازٌ مَجْهُولٌ':Added, #1: 1	جَوَازِ مُجَاوَزَتِهِ
u'جَوَازٌ مَجِيءٌ':Added, #1: 1	جَوَازِ الْمَجْهُولَاتِ
u'جَوَازٌ مُحَابَاةٌ':Added, #1: 1	جَوَازَ مَجِيءِ
u'جَوَازٌ مُحَادَثَةٌ':Added, #1: 1	جَوَازُ الْمُحَابَاةِ
u'جَوَازٌ مُحَاشَاةٌ':Added, #1: 1	جَوَازِ مُحَادَثَةِ
u'جَوَازٌ مُخَابَرَةٌ':Added, #1: 1	جَوَازُ الْمُحَاشَاةِ
u'جَوَازٌ مُخَاصَمَةٌ':Added, #1: 1	جَوَازِ الْمُخَابَرَةِ
u'جَوَازٌ مُخَالَفَةٌ':Added, #1: 1	جَوَازِ الْمُخَاصَمَةِ
u'جَوَازٌ مُرابَحَة':Added, #3: 3	جَوَازِ الْمُخَالَفَةِ
u'جَوَازٌ مُراهَنَة':Added, #1: 1	جَوَازِ الْمُرَابَحَةِ
u'جَوَازٌ مُرُورٌ':Added, #2: 2	جَوَازُ الْمُرَاهَنَةِ
u'جَوَازٌ مَزْجٌ':Added, #1: 1	جَوَازُ الْمُرُورِ
u'جَوَازٌ مَسٌّ':Added, #1: 1	جَوَازِ الْمَزْجِ
u'جَوَازٌ مَسٌّ':Added, #1: 1	جَوَازِ الْمَسِّ
u'جَوَازٌ مَسٌّ':Added, #1: 1	جَوَازَ مَسِّ
u'جَوَازٌ مَسٌّ':Added, #1: 1	جَوَازِ مَسِّ
u'جَوَازٌ مَسٌّ':Added, #1: 1	جَوَازُ مَسِّهِ
u'جَوَازٌ مُسَابَقَةٌ':Added, #2: 2	جَوَازُ مَسِّ
u'جَوَازٌ مُساقاة':Added, #1: 1	جَوَازُ الْمُسَابَقَةِ
u'جَوَازٌ مُسَاوَاةٌ':Added, #1: 1	جَوَازُ الْمُسَاقَاةِ
u'جَوَازٌ مَسْحٌ':Added, #2: 2	جَوَازِ الْمُسَاوَاةِ
u'جَوَازٌ مَسْحٌ':Added, #13: 13	جَوَازُ الْمَسْحِ
u'جَوَازٌ مَسْحٌ':Added, #14: 14	جَوَازَ الْمَسْحِ
u'جَوَازٌ مَسْحٌ':Added, #1: 1	جَوَازَ مَسْحِ
u'جَوَازٌ مَسْحٌ':Added, #1: 1	جَوَازِ مَسْحِ
u'جَوَازٌ مَسْحٌ':Added, #27: 27	جَوَازِ الْمَسْحِ
u'جَوَازٌ مَسْحٌ':Added, #2: 2	جَوَازُ مَسْحِ
u'جَوَازٌ مُسَلَّمٌ':Added, #4: 4	جَوَازِ مَسْحِهِ
u'جَوَازٌ مُشْتَرَكٌ':Added, #1: 1	جَوَازُ الْمُسَلَّمِ
u'جَوَازٌ مَشْرُوطٌ':Added, #1: 1	جَوَازُ الْمُشْتَرَكِ
u'جَوَازٌ مَشْيٌ':Added, #1: 1	جَوَازِ مَشْرُوطٍ
u'جَوَازٌ مُصَالَحَةٌ':Added, #1: 1	جَوَازُ مَشْيِ
u'جَوَازٌ مُصَالَحَةٌ':Added, #1: 1	جَوَازَ الْمُصَالَحَةِ
u'جَوَازٌ مَصَبٌّ':Added, #3: 3	جَوَازُ الْمُصَالَحَةِ
u'جَوَازٌ مَصْبُوغ':Added, #1: 1	جَوَازِ مَصَبِّ
u'جَوَازٌ مُطَالَبٌ':Added, #1: 1	جَوَازُ الْمَصْبُوغِ
u'جَوَازٌ مُطَالَبَةٌ':Added, #1: 1	جَوَازِ مُطَالَبَةِ
u'جَوَازٌ مُطْلَقٌ':Added, #1: 1	جَوَازِ مُطَالَبَةِ
u'جَوَازٌ مُعَارَضَةٌ':Added, #1: 1	جَوَازِ مُطْلَقِ
u'جَوَازٌ مُعَارَضَةٌ':Added, #1: 1	جَوَازِ الْمُعَارَضَةِ
u'جَوَازٌ مُعَاشَرَةٌ':Added, #1: 1	جَوَازَ مُعَارَضَةِ
u'جَوَازٌ مُعاطاة':Added, #2: 2	جَوَازَ مُعَاشَرَةِ
u'جَوَازٌ مُعَامَلَةٌ':Added, #1: 1	جَوَازِ الْمُعَاطَاةِ
u'جَوَازٌ مُعَامَلَةٌ':Added, #1: 1	جَوَازِ مُعَامَلَةِ
u'جَوَازٌ مُعَامَلَةٌ':Added, #1: 1	جَوَازُ مُعَامَلَتِهِ
u'جَوَازٌ مُعَامَلَةٌ':Added, #1: 1	جَوَازِ مُعَامَلَتِهِ
u'جَوَازٌ مُعَامَلَةٌ':Added, #2: 2	جَوَازُ مُعَامَلَةِ
u'جَوَازٌ مُعانَقَة':Added, #5: 5	جَوَازِ الْمُعَامَلَةِ
u'جَوَازٌ مَغْرِبٌ':Added, #1: 1	جَوَازِ الْمُعَانَقَةِ
u'جَوَازٌ مُفَارَقَةٌ':Added, #1: 1	جَوَازِ الْمَغْرِبِ
u'جَوَازٌ مُفَاضَلَةٌ':Added, #3: 3	جَوَازِ الْمُفَارَقَةِ
u'جَوَازٌ مُقَدَّمٌ':Added, #1: 1	جَوَازَ الْمُفَاضَلَةِ
u'جَوَازٌ مُكَاتَبَةٌ':Added, #1: 1	جَوَازُ الْمُقَدَّمِ
u'جَوَازٌ مُكَاتَبَةٌ':Added, #1: 1	جَوَازَ الْمُكَاتَبَةِ
u'جَوَازٌ مُناقَلَة':Added, #1: 1	جَوَازِ الْمُكَاتَبَةِ
u'جَوَازٌ مَنْعٌ':Added, #2: 2	جَوَازِ الْمُنَاقَلَةِ
u'جَوَازٌ مَنْعٌ':Added, #1: 1	جَوَازَ الْمَنْعِ
u'جَوَازٌ مَنْعٌ':Added, #1: 1	جَوَازِ الْمَنْعِ
u'جَوَازٌ مَنْعٌ':Added, #1: 1	جَوَازَ مَنْعِهِ
u'جَوَازٌ مَنْعٌ':Added, #2: 2	جَوَازُ الْمَنْعِ
u'جَوَازٌ مَنْعٌ':Added, #2: 2	جَوَازُ مَنْعِ
u'جَوَازٌ مَنْعٌ':Added, #2: 2	جَوَازِ مَنْعِ
u'جَوَازٌ مَنْهِيٌّ':Added, #2: 2	جَوَازُ مَنْعِهِ
u'جَوَازٌ مُهَادَنَةٌ':Added, #1: 1	جَوَازَ الْمَنْهِيِّ
u'جَوَازٌ مُوالاة':Added, #1: 1	جَوَازُ الْمُهَادَنَةِ
u'جَوَازٌ مُؤَخَّرٌ':Added, #1: 1	جَوَازِ الْمُوَالَاةِ
u'جَوَازٌ مُؤْمِنٌ':Added, #1: 1	جَوَازَ الْمُؤَخَّرِ
u'جَوَازٌ نَافِلَةٌ':Added, #1: 1	جَوَازَ الْمُؤْمِنَةِ
u'جَوَازٌ نَبْذٌ':Added, #2: 2	جَوَازِ النَّافِلَةِ
u'جَوَازٌ نَحْرٌ':Added, #2: 2	جَوَازِ النَّبْذِ
u'جَوَازٌ نَحْرٌ':Added, #1: 1	جَوَازُ النَّحْرِ
u'جَوَازٌ نذر':Added, #1: 1	جَوَازِ النَّحْرِ
u'جَوَازٌ نَذْرٌ':Added, #1: 1	جَوَازِ نَذْرِ
u'جَوَازٌ نذر':Added, #1: 1	جَوَازِ نَذْرِ
u'جَوَازٌ نَذْرٌ':Added, #2: 2	جَوَازِ النَّذْرِ
u'جَوَازٌ نَزْعٌ':Added, #2: 2	جَوَازِ النَّذْرِ
u'جَوَازٌ نُزُولٌ':Added, #2: 2	جَوَازِ نَزْعِ
u'جَوَازٌ نِسْبَةٌ':Added, #2: 2	جَوَازِ النُّزُولِ
u'جَوَازٌ نِسْيَانٌ':Added, #2: 2	جَوَازِ نِسْبَتِهِ
u'جَوَازٌ نصب':Added, #1: 1	جَوَازِ النِّسْيَانِ
u'جَوَازٌ نَصْبٌ':Added, #1: 1	جَوَازَ النَّصْبِ
u'جَوَازٌ نصب':Added, #1: 1	جَوَازَ النَّصْبِ
u'جَوَازٌ نصب':Added, #1: 1	جَوَازُ نَصْبِ
u'جَوَازٌ نَصْبٌ':Added, #1: 1	جَوَازِ نَصْبِ
u'جَوَازٌ نَصْبٌ':Added, #1: 1	جَوَازُ نَصْبِ
u'جَوَازٌ نِصْفٌ':Added, #1: 1	جَوَازِ نَصْبِ
u'جَوَازٌ نضح':Added, #1: 1	جَوَازِ نِصْفِ
u'جَوَازٌ نَضْحٌ':Added, #1: 1	جَوَازِ نَضْحِهِ
u'جَوَازٌ نَظَرٌ':Added, #1: 1	جَوَازِ نَضْحِهِ
u'جَوَازٌ نَظَرٌ':Added, #15: 15	جَوَازِ النَّظَرِ
u'جَوَازٌ نَظَرٌ':Added, #1: 1	جَوَازَ نَظَرِ
u'جَوَازٌ نَظَرٌ':Added, #1: 1	جَوَازُ نَظَرِ
u'جَوَازٌ نَظَرٌ':Added, #1: 1	جَوَازِ نَظَرِهِ
u'جَوَازٌ نَظَرٌ':Added, #3: 3	جَوَازُ النَّظَرِ
u'جَوَازٌ نَظَرٌ':Added, #5: 5	جَوَازَ النَّظَرِ
u'جَوَازٌ نفر':Added, #5: 5	جَوَازِ نَظَرِ
u'جَوَازٌ نفر':Added, #1: 1	جَوَازَ النَّفْرِ
u'جَوَازٌ نَفْرٌ':Added, #1: 1	جَوَازِ النَّفْرِ
u'جَوَازٌ نَفْرٌ':Added, #1: 1	جَوَازَ النَّفْرِ
u'جَوَازٌ نَفْلٌ':Added, #1: 1	جَوَازِ النَّفْرِ
u'جَوَازٌ نَفْيٌ':Added, #3: 3	جَوَازِ النَّفْلِ
u'جَوَازٌ نَفْيٌ':Added, #1: 1	جَوَازِ النَّفْيِ
u'جَوَازٌ نِقَابٌ':Added, #1: 1	جَوَازِ نَفْيِهِ
u'جَوَازٌ نَقَائِصُ':Added, #1: 1	جَوَازِ نِقَابِ
u'جَوَازٌ نَقْدٌ':Added, #1: 1	جَوَازِ النّقَائِصِ
u'جَوَازٌ نَقْد':Added, #1: 1	جَوَازَ النَّقْدِ
u'جَوَازٌ نَقْدٌ':Added, #1: 1	جَوَازَ النَّقْدِ
u'جَوَازٌ نَقْد':Added, #3: 3	جَوَازِ النَّقْدِ
u'جَوَازٌ نُقْصَانٌ':Added, #3: 3	جَوَازِ النَّقْدِ
u'جَوَازٌ نُقْصَانٌ':Added, #1: 1	جَوَازُ النُّقْصَانِ
u'جَوَازٌ نَقْضٌ':Added, #3: 3	جَوَازِ النُّقْصَانِ
u'جَوَازٌ نَقْضٌ':Added, #1: 1	جَوَازِ النَّقْضِ
u'جَوَازٌ نَقْضٌ':Added, #1: 1	جَوَازُ نَقْضِهِ
u'جَوَازٌ نَقْضٌ':Added, #1: 1	جَوَازِ نَقْضِهِ
u'جَوَازٌ نقل':Added, #2: 2	جَوَازُ النَّقْضِ
u'جَوَازٌ نَقْلٌ':Added, #1: 1	جَوَازُ النَّقْلِ
u'جَوَازٌ نقل':Added, #1: 1	جَوَازُ النَّقْلِ
u'جَوَازٌ نَقْلٌ':Added, #1: 1	جَوَازُ نَقْلِ
u'جَوَازٌ نقل':Added, #1: 1	جَوَازُ نَقْلِ
u'جَوَازٌ نَقْلٌ':Added, #1: 1	جَوَازُ نَقْلِهِ
u'جَوَازٌ نقل':Added, #1: 1	جَوَازُ نَقْلِهِ
u'جَوَازٌ نَقْلٌ':Added, #2: 2	جَوَازَ النَّقْلِ
u'جَوَازٌ نقل':Added, #2: 2	جَوَازَ النَّقْلِ
u'جَوَازٌ نَقْلٌ':Added, #2: 2	جَوَازِ نَقْلِهِ
u'جَوَازٌ نقل':Added, #2: 2	جَوَازِ نَقْلِهِ
u'جَوَازٌ نَقْلٌ':Added, #3: 3	جَوَازَ نَقْلِ
u'جَوَازٌ نقل':Added, #3: 3	جَوَازَ نَقْلِ
u'جَوَازٌ نَقْلٌ':Added, #4: 4	جَوَازِ نَقْلِ
u'جَوَازٌ نقل':Added, #4: 4	جَوَازِ نَقْلِ
u'جَوَازٌ نَقْلٌ':Added, #9: 9	جَوَازِ النَّقْلِ
u'جَوَازٌ نكاح':Added, #9: 9	جَوَازِ النَّقْلِ
u'جَوَازٌ نِكَاحٌ':Added, #11: 11	جَوَازِ النِّكَاحِ
u'جَوَازٌ نكاح':Added, #11: 11	جَوَازِ النِّكَاحِ
u'جَوَازٌ نِكَاحٌ':Added, #18: 18	جَوَازِ نِكَاحِ
u'جَوَازٌ نكاح':Added, #18: 18	جَوَازِ نِكَاحِ
u'جَوَازٌ نِكَاحٌ':Added, #6: 6	جَوَازُ النِّكَاحِ
u'جَوَازٌ نكاح':Added, #6: 6	جَوَازُ النِّكَاحِ
u'جَوَازٌ نِكَاحٌ':Added, #6: 6	جَوَازُ نِكَاحِ
u'جَوَازٌ نكاح':Added, #6: 6	جَوَازُ نِكَاحِ
u'جَوَازٌ نِكَاحٌ':Added, #7: 7	جَوَازَ النِّكَاحِ
u'جَوَازٌ نكاح':Added, #7: 7	جَوَازَ النِّكَاحِ
u'جَوَازٌ نِكَاحٌ':Added, #7: 7	جَوَازَ نِكَاحِ
u'جَوَازٌ نِيَابَةٌ':Added, #7: 7	جَوَازَ نِكَاحِ
u'جَوَازٌ نِيَابَةٌ':Added, #1: 1	جَوَازُ النِّيَابَةِ
u'جَوَازٌ نِيَّةٌ':Added, #4: 4	جَوَازِ النِّيَابَةِ
u'جَوَازٌ نِيَّةٌ':Added, #1: 1	جَوَازُ النِّيَّةِ
u'جَوَازٌ نِيَّةٌ':Added, #1: 1	جَوَازُ نِيَّةِ
u'جَوَازٌ نِيَّةٌ':Added, #2: 2	جَوَازِ نِيَّةِ
u'جَوَازٌ هِبَةٌ':Added, #3: 3	جَوَازِ النِّيَّةِ
u'جَوَازٌ هِبَةٌ':Added, #2: 2	جَوَازَ الْهِبَةِ
u'جَوَازٌ هِبَةٌ':Added, #2: 2	جَوَازَ هِبَةِ
u'جَوَازٌ هِبَةٌ':Added, #2: 2	جَوَازُ هِبَةِ
u'جَوَازٌ هِبَةٌ':Added, #4: 4	جَوَازِ هِبَةِ
u'جَوَازٌ هجر':Added, #7: 7	جَوَازِ الْهِبَةِ
u'جَوَازٌ هجر':Added, #1: 1	جَوَازَ الْهَجْرِ
u'جَوَازٌ هَجْرٌ':Added, #1: 1	جَوَازِ الْهَجْرِ
u'جَوَازٌ هَجْرٌ':Added, #1: 1	جَوَازَ الْهَجْرِ
u'جَوَازٌ هَجْوٌ':Added, #1: 1	جَوَازِ الْهَجْرِ
u'جَوَازٌ هَجْوٌ':Added, #1: 1	جَوَازِ الْهَجْوِ
u'جَوَازٌ هَجْوٌ':Added, #1: 1	جَوَازُ هَجْوِ
u'جَوَازٌ هَدِيٌّ':Added, #2: 2	جَوَازَ هَجْوِ
u'جَوَازٌ هَدِيَّةٌ':Added, #1: 1	جَوَازُ هَدِيَّةِ
u'جَوَازٌ واحد':Added, #1: 1	جَوَازُ هَدِيَّةِ
u'جَوَازٌ وَاحِدٌ':Added, #1: 1	جَوَازِ وَاحِدٍ
u'جَوَازٌ وَجْهٌ':Added, #1: 1	جَوَازِ وَاحِدٍ
u'جَوَازٌ وَجْهٌ':Added, #1: 1	جَوَازِ الْوَجْهِ
u'جَوَازٌ وُجُوبٌ':Added, #1: 1	جَوَازِ الْوَجْهَيْنِ
u'جَوَازٌ وُجُودٌ':Added, #1: 1	جَوَازِ وُجُوبِهِ
u'جَوَازٌ وُجُودٌ':Added, #1: 1	جَوَازُ وُجُودِهِ
u'جَوَازٌ وُجُودٌ':Added, #2: 2	جَوَازِ وُجُودِهِ
u'جَوَازٌ وُجُودٌ':Added, #3: 3	جَوَازُ وُجُودِ
u'جَوَازٌ وُرُودٌ':Added, #6: 6	جَوَازِ وُجُودِ
u'جَوَازٌ وُرُودٌ':Added, #1: 1	جَوَازِ وُرُودِ
u'جَوَازٌ وَسْمٌ':Added, #4: 4	جَوَازُ وُرُودِ
u'جَوَازٌ وَصْفٌ':Added, #1: 1	جَوَازِ الْوَسْمِ
u'جَوَازٌ وَصِيٌّ':Added, #1: 1	جَوَازُ وَصْفِ
u'جَوَازٌ وَصِيٌّ':Added, #1: 1	جَوَازَ وَصِيَّتِهِ
u'جَوَازٌ وَصِيٌّ':Added, #2: 2	جَوَازَ الْوَصِيَّةِ
u'جَوَازٌ وَصِيٌّ':Added, #3: 3	جَوَازُ الْوَصِيَّةِ
u'جَوَازٌ وَصِيَّةٌ':Added, #7: 7	جَوَازِ الْوَصِيَّةِ
u'جَوَازٌ وَصِيَّةٌ':Added, #1: 1	جَوَازَ وَصِيَّتِهِ
u'جَوَازٌ وَصِيَّةٌ':Added, #2: 2	جَوَازَ الْوَصِيَّةِ
u'جَوَازٌ وَصِيَّةٌ':Added, #3: 3	جَوَازُ الْوَصِيَّةِ
u'جَوَازٌ وَضْعٌ':Added, #7: 7	جَوَازِ الْوَصِيَّةِ
u'جَوَازٌ وَضْعٌ':Added, #1: 1	جَوَازُ وَضْعِهِ
u'جَوَازٌ وُضُوءٌ':Added, #2: 2	جَوَازِ وَضْعِ
u'جَوَازٌ وُضُوءٌ':Added, #13: 13	جَوَازِ الْوُضُوءِ
u'جَوَازٌ وُضُوءٌ':Added, #1: 1	جَوَازَ الْوُضُوءِ
u'جَوَازٌ وُضُوءٌ':Added, #1: 1	جَوَازِ وُضُوءِ
u'جَوَازٌ وَطْءٌ':Added, #2: 2	جَوَازُ الْوُضُوءِ
u'جَوَازٌ وَطْءٌ':Added, #1: 1	جَوَازَ الْوَطْءِ
u'جَوَازٌ وَطْءٌ':Added, #1: 1	جَوَازُ وَطْءِ
u'جَوَازٌ وَطْءٌ':Added, #2: 2	جَوَازُ الْوَطْءِ
u'جَوَازٌ وَطْءٌ':Added, #2: 2	جَوَازَ وَطْءِ
u'جَوَازٌ وَطْءٌ':Added, #3: 3	جَوَازِ الْوَطْءِ
u'جَوَازٌ وَعْظٌ':Added, #6: 6	جَوَازِ وَطْءِ
u'جَوَازٌ وَقْفٌ':Added, #1: 1	جَوَازِ الْوَعْظِ
u'جَوَازٌ وَقْفٌ':Added, #1: 1	جَوَازَ وَقْفِ
u'جَوَازٌ وَقْفٌ':Added, #2: 2	جَوَازُ الْوَقْفِ
u'جَوَازٌ وَقْفٌ':Added, #3: 3	جَوَازِ الْوَقْفِ
u'جَوَازٌ وَقْفٌ':Added, #3: 3	جَوَازِ وَقْفِ
u'جَوَازٌ وَقْفٌ':Added, #4: 4	جَوَازُ وَقْفِ
u'جَوَازٌ وُقُوعٌ':Added, #5: 5	جَوَازَ الْوَقْفِ
u'جَوَازٌ وُقُوعٌ':Added, #1: 1	جَوَازِ وُقُوعِ
u'جَوَازٌ وُقُوعٌ':Added, #1: 1	جَوَازَ وُقُوعِهِ
u'جَوَازٌ وُقُوعٌ':Added, #1: 1	جَوَازُ وُقُوعِهِ
u'جَوَازٌ وُقُوفٌ':Added, #2: 2	جَوَازَ وُقُوعِ
u'جَوَازٌ وِلاَيَةٌ':Added, #1: 1	جَوَازِ وُقُوفِ
u'جَوَازٌ وِلاَيَةٌ':Added, #1: 1	جَوَازِ الْوِلَايَةِ
u'جَوَازٌ يَسِيرٌ':Added, #1: 1	جَوَازَ وِلَايَتِهِ
u'جَوَازٌ يَمِينٌ':Added, #1: 1	جَوَازِ يَسِيرِ
u'جواف حَبٌّ':Added, #1: 1	جَوَازِ الْيَمِينِ
u'جواف حَبَّةٌ':Added, #1: 1	أَجْوَافُ حَبَّاتِ
u'جواف طَيْرٌ':Added, #1: 1	أَجْوَافُ حَبَّاتِ
u'جواف طُيُورٌ':Added, #6: 6	أَجْوَافِ طَيْرٍ
u'جواف مِيَاهٌ':Added, #3: 3	أَجْوَافِ طُيُورٍ
u'جَوْدَةٌ إِبْرِيقٌ':Added, #1: 1	أَجْوَافَ الْمِيَاهِ
u'جَوْدَةٌ تِبْر':Added, #1: 1	جَوْدَةِ الْإِبْرِيقِ
u'جَوْدَةٌ تِبْر':Added, #1: 1	جَوْدَةُ التِّبْرِ
u'جَوْدَةٌ ثَمَنٌ':Added, #1: 1	جَوْدَةِ التِّبْرِ
u'جَوْدَةٌ ثَوْبٌ':Added, #1: 1	جَوْدَةَ الثَّمَنِ
u'جَوْدَةٌ خَارِجٌ':Added, #2: 2	جَوْدَةَ ثَوْبِهِ
u'جَوْدَةٌ رَمْيٌ':Added, #1: 1	جَوْدَةِ الْخَارِجِ
u'جَوْدَةٌ رَمْيٌ':Added, #1: 1	جَوْدَةُ الرَّمْيِ
u'جَوْدَةٌ فِرَاسَةٌ':Added, #2: 2	جَوْدَةِ الرَّمْيِ
u'جَوْدَةٌ فَهْمٌ':Added, #1: 1	جَوْدَةُ الْفِرَاسَةِ
u'جَوْدَةٌ قِرَاءةٌ':Added, #1: 1	جَوْدَةِ الْفَهْمِ
u'جَوْدَةٌ قَرِيحٌ':Added, #1: 1	جَوْدَةِ الْقِرَاءَةِ
u'جَوْدَةٌ قَرِيحَةٌ':Added, #1: 1	جَوْدَةِ الْقَرِيحَتَيْنِ
u'جَوْدَةٌ كَفَنٌ':Added, #1: 1	جَوْدَةُ الْقَرِيحَةِ
u'جَوْدَةٌ مَاءٌ':Added, #1: 1	جَوْدَةُ الْكَفَنِ
u'جَوْدَةٌ مَوَاهِبُ':Added, #1: 1	جَوْدَةُ الْمَاءِ
u'جَوَّدَ عَبْدٌ':Subject, #1: 1	جَوْدَةِ الْمَوَاهِبِ
u'جَوَّدَ مَالِكٌ':Subject, #1: 1	جَوَّدَ عَبْدُ
u'جَوْرٌ إمَامٌ':Added, #1: 1	جَوَّدَ مَالِكُ
u'جَوْرٌ أمراء':Added, #1: 1	جَوْرُ الْإِمَامِ
u'جَوْرٌ أئِمَّةٌ':Added, #1: 1	جَوْرُ الْأُمَرَاءِ
u'جَوْرٌ جَائِرٌ':Added, #1: 1	جَوْرِ الْأَئِمَّةِ
u'جَوْرٌ حاكِمٌ':Added, #2: 2	جَوْرُ جَائِرٍ
u'جَوْرٌ حُكَّامٌ':Added, #1: 1	جَوْرَ الْحَاكِمِ
u'جَوْرٌ سَاعَةٌ':Added, #1: 1	جَوْرَ الْحُكَّامِ
u'جَوْرٌ صَاحِبٌ':Added, #1: 1	جَوْرُ سَاعَةٍ
u'جَوْرٌ عَامِلٌ':Added, #1: 1	جَوْرَ صَاحِبِهِ
u'جَوْرٌ عُمَّالٌ':Added, #1: 1	جَوْرِ الْعَامِلِ
u'جَوْرٌ قَاسِمٌ':Added, #1: 1	جَوْرُ الْعُمَّالِ
u'جَوْرٌ وُلاَةٌ':Added, #1: 1	جَوْرُ الْقَاسِمِ
u'جَوَّزَ اِبْنٌ':Subject, #2: 2	جَوْرِ الْوُلَاةِ
u'جَوَّزَ اِتِّخَاذٌ':Predicate, #3: 3	جَوَّزَ ابْنُ
u'جَوَّزَ أخْذٌ':Predicate, #1: 1	جَوَّزَ اتِّخَاذَ
u'جَوَّزَ إِخْرَاجٌ':Predicate, #2: 2	جَوَّزَ أَخْذَ
u'جَوَّزَ اِسْتِثْنَاءٌ':Predicate, #1: 1	جَوَّزَ إخْرَاجَ
u'جَوَّزَ اِسْتِئْجَارٌ':Predicate, #1: 1	جَوَّزَ اسْتِثْنَاءَ
u'جَوَّزَ أَصْحَابٌ':Subject, #1: 1	جَوَّزَ اسْتِئْجَارَ
u'جَوَّزَ إعْطَاءٌ':Predicate, #2: 2	جَوَّزَ الْأَصْحَابُ
u'جَوَّزَ اِقْتِداءٌ':Predicate, #2: 2	جَوَّزَ الْإِعْطَاءَ
u'جَوَّزَ أَكْثَرُ':Predicate, #3: 3	جَوَّزَ اقْتِدَاءَ
u'جَوَّزَ أَكْثَرُ':Subject, #1: 1	جَوَّزَ الْأَكْثَرَ
u'جَوَّزَ أكل':Predicate, #1: 1	جَوَّزَ أَكْثَرُ
u'جَوَّزَ أَكْلٌ':Predicate, #3: 3	جَوَّزَ الْأَكْلَ
u'جَوَّزَ إمَامٌ':Subject, #3: 3	جَوَّزَ الْأَكْلَ
u'جَوَّزَ أَمْرٌ':Predicate, #1: 1	جَوَّزَ الْإِمَامُ
u'جَوَّزَ إِمْعانٌ':Predicate, #1: 1	جَوَّزَ أَمْرَ
u'جَوَّزَ أهْلٌ':Subject, #1: 1	جَوَّزَ الْإِمْعَانَ
u'جَوَّزَ بعثة':Predicate, #1: 1	جَوَّزَ أَهْلُ
u'جَوَّزَ بَعْضٌ':Subject, #1: 1	جَوَّزَ بَعْثَةَ
u'جَوَّزَ بِنَاءٌ':Predicate, #1: 1	جَوَّزَ بَعْضُ
u'جَوَّزَ بِنَاءٌ':Predicate, #1: 1	جَوَّزَ الْبِنَاءَ
u'جَوَّزَ بَيْعٌ':Predicate, #1: 1	جَوَّزَ بِنَاءَ
u'جَوَّزَ تَخْصِيصٌ':Predicate, #7: 7	جَوَّزَ بَيْعَ
u'جَوَّزَ تَخْصِيصٌ':Predicate, #1: 1	جَوَّزَ التَّخْصِيصَ
u'جَوَّزَ تَصْرِيحٌ':Predicate, #2: 2	جَوَّزَ تَخْصِيصَ
u'جَوَّزَ تَعْلِيقٌ':Predicate, #2: 2	جَوَّزَ التَّصْرِيحَ
u'جَوَّزَ تَعْلِيلٌ':Predicate, #1: 1	جَوَّزَ تَعْلِيقَ
u'جَوَّزَ تَغَنِّي':Predicate, #2: 2	جَوَّزَ التَّعْلِيلَ
u'جَوَّزَ تَغْيِيرٌ':Predicate, #1: 1	جَوَّزَ التَّغَنِّيَ
u'جَوَّزَ تَقْليدٌ':Predicate, #1: 1	جَوَّزَ التَّغْيِيرَ
u'جَوَّزَ تَقْليد':Predicate, #2: 2	جَوَّزَ تَقْلِيدَ
u'جَوَّزَ تَنَجُّزٌ':Predicate, #2: 2	جَوَّزَ تَقْلِيدَ
u'جَوَّزَ تَيَمُّمٌ':Predicate, #1: 1	جَوَّزَ تَنَجُّزَ
u'جَوَّزَ تَيَمُّمٌ':Subject, #1: 1	جَوَّزَ التَّيَمُّمَ
u'جَوَّزَ جمع':Predicate, #1: 1	جَوَّزَ التَّيَمُّمُ
u'جَوَّزَ جَمْعٌ':Predicate, #2: 2	جَوَّزَ الْجَمْعَ
u'جَوَّزَ جُمْهُورٌ':Subject, #2: 2	جَوَّزَ الْجَمْعَ
u'جَوَّزَ دفع':Predicate, #3: 3	جَوَّزَ جُمْهُورُ
u'جَوَّزَ دَفْعٌ':Predicate, #1: 1	جَوَّزَ الدَّفْعَ
u'جَوَّزَ زِيادَةٌ':Predicate, #1: 1	جَوَّزَ الدَّفْعَ
u'جَوَّزَ سَبْيٌ':Predicate, #4: 4	جَوَّزَ الزِّيَادَةَ
u'جَوَّزَ سَلَمٌ':Predicate, #1: 1	جَوَّزَ السَّبْيَ
u'جَوَّزَ سَيِّدٌ':Subject, #1: 1	جَوَّزَ السَّلَمَ
u'جَوَّزَ شافِعِيّ':Subject, #1: 1	جَوَّزَ السَّيِّدُ
u'جَوَّزَ شَرْطٌ':Predicate, #4: 4	جَوَّزَ الشَّافِعِيُّ
u'جَوَّزَ شَرْعٌ':Predicate, #1: 1	جَوَّزَ الشَّرْطَ
u'جَوَّزَ شَرْعٌ':Subject, #1: 1	جَوَّزَ الشَّرْعَ
u'جَوَّزَ صَرْفٌ':Predicate, #2: 2	جَوَّزَ الشَّرْعُ
u'جَوَّزَ صَرْف':Predicate, #1: 1	جَوَّزَ الصَّرْفَ
u'جَوَّزَ صَرِيحٌ':Predicate, #1: 1	جَوَّزَ الصَّرْفَ
u'جَوَّزَ صَلاَةٌ':Predicate, #1: 1	جَوَّزَ الصَّرِيحَ
u'جَوَّزَ صَلاَةٌ':Predicate, #1: 1	جَوَّزَ الصَّلاَةَ
u'جَوَّزَ صلح':Predicate, #2: 2	جَوَّزَ الصَّلَاةَ
u'جَوَّزَ صُلْحٌ':Predicate, #1: 1	جَوَّزَ صُلْحَ
u'جَوَّزَ ضَمَانٌ':Predicate, #1: 1	جَوَّزَ صُلْحَ
u'جَوَّزَ عَقْدٌ':Predicate, #1: 1	جَوَّزَ ضَمَانَ
u'جَوَّزَ علماء':Subject, #1: 1	جَوَّزَ الْعَقْدَ
u'جَوَّزَ عُلَمَاءُ':Subject, #1: 1	جَوَّزَ الْعُلَمَاءُ
u'جَوَّزَ عَلِيٌّ':Subject, #1: 1	جَوَّزَ الْعُلَمَاءُ
u'جَوَّزَ عَمَلٌ':Predicate, #1: 1	جَوَّزَ عَلِيٌّ
u'جَوَّزَ غَسْلٌ':Predicate, #1: 1	جَوَّزَ الْعَمَلَ
u'جَوَّزَ فُرُوعٌ':Predicate, #1: 1	جَوَّزَ غَسْلَ
u'جَوَّزَ فلان':Subject, #1: 1	جَوَّزَ الْفُرُوعَ
u'جَوَّزَ قتال':Predicate, #4: 4	جَوَّزَ الشَّافِعِيُّ
u'جَوَّزَ قِتَالٌ':Predicate, #2: 2	جَوَّزَ الْقِتَالَ
u'جَوَّزَ قُدُومٌ':Predicate, #2: 2	جَوَّزَ الْقِتَالَ
u'جَوَّزَ قِرَاءةٌ':Predicate, #1: 1	جَوَّزَ الْقُدُومَ
u'جَوَّزَ قَوْمٌ':Subject, #1: 1	جَوَّزَ الْقِرَاءَةَ
u'جَوَّزَ قَوْمٌ':Subject, #1: 1	جَوَّزَ الْقَوْمُ
u'جَوَّزَ لعنة':Predicate, #1: 1	جَوَّزَ قَوْمٌ
u'جَوَّزَ لَعْنَةٌ':Predicate, #2: 2	جَوَّزَ لَعْنَةَ
u'جَوَّزَ مَالِكٌ':Subject, #2: 2	جَوَّزَ لَعْنَةَ
u'جَوَّزَ مَبِيعٌ':Predicate, #2: 2	جَوَّزَ مَالِكٌ
u'جَوَّزَ مَسٌّ':Predicate, #1: 1	جَوَّزَ الْمَبِيعَ
u'جَوَّزَ مَسْحٌ':Predicate, #1: 1	جَوَّزَ مَسَّ
u'جَوَّزَ مُقَاصَّةٌ':Predicate, #1: 1	جَوَّزَ الْمَسْحَ
u'جَوَّزَ مُناقَلَة':Predicate, #1: 1	جَوَّزَ الْمُقَاصَّةَ
u'جَوَّزَ نَبِيٌّ':Subject, #1: 1	جَوَّزَ الْمُنَاقَلَةَ
u'جَوَّزَ نَظَرٌ':Predicate, #1: 1	جَوَّزَ النَّبِيُّ
u'جَوَّزَ نُقْصَانٌ':Predicate, #1: 1	جَوَّزَ النَّظَرَ
u'جَوَّزَ نكاح':Predicate, #2: 2	جَوَّزَ النُّقْصَانَ
u'جَوَّزَ نِكَاحٌ':Predicate, #1: 1	جَوَّزَ النِّكَاحَ
u'جَوَّزَ نكاح':Predicate, #1: 1	جَوَّزَ النِّكَاحَ
u'جَوَّزَ نِكَاحٌ':Predicate, #1: 1	جَوَّزَ نِكَاحَ
u'جَوَّزَ وُجُودٌ':Predicate, #1: 1	جَوَّزَ نِكَاحَ
u'جَوَّزَ وَصِيٌّ':Predicate, #1: 1	جَوَّزَ وُجُودَ
u'جَوَّزَ وَصِيَّةٌ':Predicate, #1: 1	جَوَّزَ وَصِيَّةَ
u'جوف اِبْنٌ':Added, #1: 1	جَوَّزَ وَصِيَّةَ
u'جَوْفٌ اِبْنٌ':Added, #3: 3	جَوْفَ ابْنِ
u'جوف أرْضٌ':Added, #3: 3	جَوْفَ ابْنِ
u'جَوْفٌ أرْضٌ':Added, #1: 1	جَوْفِ الْأَرْضِ
u'جوف الْمَرْأَةُ':Added, #1: 1	جَوْفِ الْأَرْضِ
u'جَوْفٌ الْمَرْأَةُ':Added, #1: 1	جَوْفِ الْمَرْأَةِ
u'جوف إِنْسانٌ':Added, #1: 1	جَوْفِ الْمَرْأَةِ
u'جَوْفٌ إِنْسانٌ':Added, #1: 1	جَوْفِ الْإِنْسَانِ
u'جوف بَحْرٌ':Added, #1: 1	جَوْفِ الْإِنْسَانِ
u'جَوْفٌ بَحْرٌ':Added, #1: 1	جَوْفِ الْبَحْرِ
u'جوف بدن':Added, #1: 1	جَوْفِ الْبَحْرِ
u'جَوْفٌ بدن':Added, #1: 1	جَوْفِ الْبَدَنِ
u'جوف بَدَنٌ':Added, #1: 1	جَوْفِ الْبَدَنِ
u'جَوْفٌ بَدَنٌ':Added, #1: 1	جَوْفِ الْبَدَنِ
u'جوف بَطْنٌ':Added, #1: 1	جَوْفِ الْبَدَنِ
u'جَوْفٌ بَطْنٌ':Added, #3: 3	جَوْفِ الْبَطْنِ
u'جوف بِطِّيخٌ':Added, #3: 3	جَوْفِ الْبَطْنِ
u'جَوْفٌ بِطِّيخٌ':Added, #1: 1	جَوْفِ الْبِطِّيخِ
u'جوف بَيْتٌ':Added, #1: 1	جَوْفِ الْبِطِّيخِ
u'جوف بَيْتٌ':Added, #1: 1	جَوْفِ بَيْتٍ
u'جَوْفٌ بَيْتٌ':Added, #1: 1	جَوْفِ بَيْتِ
u'جَوْفٌ بَيْتٌ':Added, #1: 1	جَوْفِ بَيْتٍ
u'جوف حِجْرٌ':Added, #1: 1	جَوْفِ بَيْتِ
u'جَوْفٌ حِجْرٌ':Added, #3: 3	جَوْفِ الْحِجْرِ
u'جوف حَطِيم':Added, #3: 3	جَوْفِ الْحِجْرِ
u'جَوْفٌ حَطِيم':Added, #1: 1	جَوْفِ الْحَطِيمِ
u'جوف حَيٌّ':Added, #1: 1	جَوْفِ الْحَطِيمِ
u'جَوْفٌ حَيٌّ':Added, #1: 1	جَوْفِ الْحَيِّ
u'جوف حَيَوَانٌ':Added, #1: 1	جَوْفِ الْحَيِّ
u'جَوْفٌ حَيَوَانٌ':Added, #1: 1	جَوْفِ حَيَوَانٍ
u'جوف دِماغٌ':Added, #1: 1	جَوْفِ حَيَوَانٍ
u'جَوْفٌ دِماغٌ':Added, #3: 3	جَوْفِ الدِّمَاغِ
u'جوف دُورٌ':Added, #3: 3	جَوْفِ الدِّمَاغِ
u'جَوْفٌ دُورٌ':Added, #1: 1	جَوْفِ الدُّورِ
u'جوف رَأْسٌ':Added, #1: 1	جَوْفِ الدُّورِ
u'جَوْفٌ رَأْسٌ':Added, #3: 3	جَوْفِ الرَّأْسِ
u'جوف رَجُلٌ':Added, #3: 3	جَوْفِ الرَّأْسِ
u'جَوْفٌ رَجُلٌ':Added, #1: 1	جَوْفُ الرَّجُلِ
u'جوف رَجُلٌ':Added, #1: 1	جَوْفُ الرَّجُلِ
u'جَوْفٌ رَجُلٌ':Added, #1: 1	جَوْفُ رَجُلٍ
u'جوف رَحْلٌ':Added, #1: 1	جَوْفُ رَجُلٍ
u'جَوْفٌ رَحْلٌ':Added, #2: 2	جَوْفِ رَحْلِهِ
u'جوف رَضيعٌ':Added, #2: 2	جَوْفِ رَحْلِهِ
u'جَوْفٌ رَضيعٌ':Added, #4: 4	جَوْفِ الرَّضِيعِ
u'جوف سَمَاءٌ':Added, #4: 4	جَوْفِ الرَّضِيعِ
u'جَوْفٌ سَمَاءٌ':Added, #1: 1	جَوْفِ السَّمَاءِ
u'جوف سَمَكٌ':Added, #1: 1	جَوْفِ السَّمَاءِ
u'جَوْفٌ سَمَكٌ':Added, #1: 1	جَوْفِ سَمَكَةٍ
u'جوف سَمَكٌ':Added, #1: 1	جَوْفِ سَمَكَةٍ
u'جَوْفٌ سَمَكٌ':Added, #2: 2	جَوْفِ السَّمَكِ
u'جوف شَاةٌ':Added, #2: 2	جَوْفِ السَّمَكِ
u'جَوْفٌ شَاةٌ':Added, #1: 1	جَوْفَ الشَّاةِ
u'جوف صَائِمٌ':Added, #1: 1	جَوْفَ الشَّاةِ
u'جَوْفٌ صَائِمٌ':Added, #2: 2	جَوْفِ الصَّائِمِ
u'جوف صَغِيرٌ':Added, #2: 2	جَوْفِ الصَّائِمِ
u'جَوْفٌ صَغِيرٌ':Added, #1: 1	جَوْفِ الصَّغِيرِ
u'جوف صَغِيرٌ':Added, #1: 1	جَوْفِ الصَّغِيرِ
u'جَوْفٌ صَغِيرٌ':Added, #2: 2	جَوْفِ الصَّغِيرَةِ
u'جوف صَنَمٌ':Added, #2: 2	جَوْفِ الصَّغِيرَةِ
u'جَوْفٌ صَنَمٌ':Added, #1: 1	جَوْفِ الصّنَمِ
u'جوف ضمار':Added, #1: 1	جَوْفِ الصّنَمِ
u'جَوْفٌ ضمار':Added, #1: 1	جَوْفِ ضَمَارِ
u'جوف طَائِرٌ':Added, #1: 1	جَوْفِ ضَمَارِ
u'جَوْفٌ طَائِرٌ':Added, #1: 1	جَوْفِ طَائِرٍ
u'جوف طِفْلٌ':Added, #1: 1	جَوْفِ طَائِرٍ
u'جَوْفٌ طِفْلٌ':Added, #1: 1	جَوْفِ الطِّفْلِ
u'جوف طِفْلٌ':Added, #1: 1	جَوْفِ الطِّفْلِ
u'جَوْفٌ طِفْلٌ':Added, #1: 1	جَوْفِ طِفْلٍ
u'جوف طَلْعٌ':Added, #1: 1	جَوْفِ طِفْلٍ
u'جَوْفٌ طَلْعٌ':Added, #1: 1	جَوْفِ الطَّلْعِ
u'جوف طَيْرٌ':Added, #1: 1	جَوْفِ الطَّلْعِ
u'جَوْفٌ طَيْرٌ':Added, #3: 3	جَوْفِ طَيْرٍ
u'جوف عَبْدٌ':Added, #3: 3	جَوْفِ طَيْرٍ
u'جَوْفٌ عَبْدٌ':Added, #1: 1	جَوْفِ عَبْدٍ
u'جوف عجل':Added, #1: 1	جَوْفِ عَبْدٍ
u'جَوْفٌ عجل':Added, #1: 1	جَوْفِ الْعِجْلِ
u'جوف عِجْلٌ':Added, #1: 1	جَوْفِ الْعِجْلِ
u'جَوْفٌ عِجْلٌ':Added, #1: 1	جَوْفِ الْعِجْلِ
u'جوف عَظْمٌ':Added, #1: 1	جَوْفِ الْعِجْلِ
u'جَوْفٌ عَظْمٌ':Added, #2: 2	جَوْفِ عَظْمِ
u'جوف عين':Added, #2: 2	جَوْفِ عَظْمِ
u'جوف عَيْنٌ':Added, #1: 1	جَوْفِ الْعَيْنِ
u'جوف عَيْن':Added, #1: 1	جَوْفِ الْعَيْنِ
u'جَوْفٌ عين':Added, #1: 1	جَوْفِ الْعَيْنِ
u'جَوْفٌ عَيْنٌ':Added, #1: 1	جَوْفِ الْعَيْنِ
u'جَوْفٌ عَيْن':Added, #1: 1	جَوْفِ الْعَيْنِ
u'جوف قَاهِرٌ':Added, #1: 1	جَوْفِ الْعَيْنِ
u'جَوْفٌ قَاهِرٌ':Added, #1: 1	جَوْفِ الْقَاهِرَةِ
u'جوف قَبْرٌ':Added, #1: 1	جَوْفِ الْقَاهِرَةِ
u'جَوْفٌ قَبْرٌ':Added, #1: 1	جَوْفِ الْقَبْرِ
u'جوف قلب':Added, #1: 1	جَوْفِ الْقَبْرِ
u'جَوْفٌ قلب':Added, #1: 1	جَوْفِ قَلْبِهِ
u'جوف قَلْبٌ':Added, #1: 1	جَوْفِ قَلْبِهِ
u'جوف قَلْب':Added, #1: 1	جَوْفِ قَلْبِهِ
u'جَوْفٌ قَلْبٌ':Added, #1: 1	جَوْفِ قَلْبِهِ
u'جَوْفٌ قَلْب':Added, #1: 1	جَوْفِ قَلْبِهِ
u'جوف كُرْسِيٌّ':Added, #1: 1	جَوْفِ قَلْبِهِ
u'جَوْفٌ كُرْسِيٌّ':Added, #2: 2	جَوْفِ الْكُرْسِيِّ
u'جوف كعبة':Added, #2: 2	جَوْفِ الْكُرْسِيِّ
u'جَوْفٌ كعبة':Added, #32: 32	جَوْفِ الْكَعْبَةِ
u'جوف كَعْبَةٌ':Added, #32: 32	جَوْفِ الْكَعْبَةِ
u'جَوْفٌ كَعْبَةٌ':Added, #32: 32	جَوْفِ الْكَعْبَةِ
u'جوف لَيْلٌ':Added, #32: 32	جَوْفِ الْكَعْبَةِ
u'جوف لَيْلٌ':Added, #1: 1	جَوْفَ اللَّيْلِ
u'جَوْفٌ لَيْلٌ':Added, #1: 1	جَوْفُ اللّيْلِ
u'جَوْفٌ لَيْلٌ':Added, #1: 1	جَوْفَ اللَّيْلِ
u'جوف لَيْلٌ':Added, #1: 1	جَوْفُ اللّيْلِ
u'جَوْفٌ لَيْلٌ':Added, #1: 1	جَوْفِ لَيْلَةِ
u'جوف لَيْلٌ':Added, #1: 1	جَوْفِ لَيْلَةِ
u'جَوْفٌ لَيْلٌ':Added, #30: 30	جَوْفِ اللَّيْلِ
u'جوف لَيْلٌ':Added, #30: 30	جَوْفِ اللَّيْلِ
u'جَوْفٌ لَيْلٌ':Added, #7: 7	جَوْفِ اللّيْلِ
u'جوف لَيْلٌ':Added, #7: 7	جَوْفِ اللّيْلِ
u'جَوْفٌ لَيْلٌ':Added, #9: 9	جَوْفُ اللَّيْلِ
u'جوف مَاءٌ':Added, #9: 9	جَوْفُ اللَّيْلِ
u'جَوْفٌ مَاءٌ':Added, #1: 1	جَوْفِ الْمَاءِ
u'جوف مَأْكُولٌ':Added, #1: 1	جَوْفِ الْمَاءِ
u'جَوْفٌ مَأْكُولٌ':Added, #1: 1	جَوْفِ مَأْكُولٍ
u'جوف مُدُنٌ':Added, #1: 1	جَوْفِ مَأْكُولٍ
u'جَوْفٌ مُدُنٌ':Added, #1: 1	جَوْفِ الْمُدُنِ
u'جوف مَدِينٌ':Added, #1: 1	جَوْفِ الْمُدُنِ
u'جَوْفٌ مَدِينٌ':Added, #1: 1	جَوْفِ الْمَدِينَةِ
u'جوف مَدِينَةٌ':Added, #1: 1	جَوْفِ الْمَدِينَةِ
u'جَوْفٌ مَدِينَةٌ':Added, #1: 1	جَوْفِ الْمَدِينَةِ
u'جوف مَسْجِدٌ':Added, #1: 1	جَوْفِ الْمَدِينَةِ
u'جَوْفٌ مَسْجِدٌ':Added, #3: 3	جَوْفِ الْمَسْجِدِ
u'جوف مِصْرٌ':Added, #3: 3	جَوْفِ الْمَسْجِدِ
u'جَوْفٌ مِصْرٌ':Added, #3: 3	جَوْفِ الْمِصْرِ
u'جوف مَلَكٌ':Added, #3: 3	جَوْفِ الْمِصْرِ
u'جَوْفٌ مَلَكٌ':Added, #1: 1	جَوْفِ الْمَلَكِ
u'جوف نَبِيٌّ':Added, #1: 1	جَوْفِ الْمَلَكِ
u'جَوْفٌ نَبِيٌّ':Added, #1: 1	جَوْفُ النَّبِيِّ
u'جوف نَحْوٌ':Added, #1: 1	جَوْفُ النَّبِيِّ
u'جَوْفٌ نَحْوٌ':Added, #1: 1	جَوْفِ نَحْوِ
u'جوف نَفْسٌ':Added, #1: 1	جَوْفِ نَحْوِ
u'جَوْفٌ نَفْسٌ':Added, #1: 1	جَوْفِ نَفْسِهِ
u'حَابَى أَجْنَبِيٌّ':Predicate, #1: 1	جَوْفِ نَفْسِهِ
u'حَابَى عَبْدٌ':Predicate, #4: 4	حَابَى الْأَجْنَبِيَّ
u'حَابَى عَبْدٌ':Subject, #3: 3	حَابَى الْعَبْدَ
u'حَابَى وَارِثٌ':Predicate, #1: 1	حَابَى الْعَبْدُ
u'حَابَى وَارِثٌ':Subject, #1: 1	حَابَى الْوَارِثَ
u'حَاجَّ بَقِيَّةٌ':Predicate, #1: 1	حَابَى الْوَارِثُ
u'حَادَثَ الْمَرْأَةُ':Predicate, #2: 2	حَاجَّ بَقِيَّةَ
u'حَاذَى أَصابِعُ':Predicate, #1: 1	حَادَثَ الْمَرْأَةَ
u'حَاذَى أقْرَبُ':Predicate, #1: 1	حَاذَى الْأَصَابِعَ
u'حَاذَى أقْرَبُ':Predicate, #1: 1	حَاذَى أَقْرَبَ
u'حَاذَى بَعْضٌ':Predicate, #1: 1	حَاذَى الْأَقْرَبَ
u'حَاذَى حَجَرٌ':Predicate, #1: 1	حَاذَى بَعْضَ
u'حَاذَى ختان':Subject, #7: 7	حَاذَى الْحَجَرَ
u'حَاذَى خِتَانٌ':Subject, #1: 1	حَاذَى خِتَانُهُ
u'حَاذَى خَشَبَةٌ':Predicate, #1: 1	حَاذَى خِتَانُهُ
u'حَاذَى دَارٌ':Predicate, #1: 1	حَاذَى الْخَشَبَةَ
u'حَاذَى رَسُولٌ':Subject, #1: 1	حَاذَى دَارَ
u'حَاذَى رُكْنٌ':Predicate, #1: 1	حَاذَى رَسُولُ
u'حَاذَى رُكْن':Predicate, #2: 2	حَاذَى الرُّكْنَ
u'حَاذَى عَمَلٌ':Predicate, #2: 2	حَاذَى الرُّكْنَ
u'حَاذَى عين':Predicate, #1: 1	حَاذَى الْعَمَلَ
u'حَاذَى عَيْنٌ':Predicate, #1: 1	حَاذَى الْعَيْنَ
u'حَاذَى عَيْن':Predicate, #1: 1	حَاذَى الْعَيْنَ
u'حَاذَى قَرْنٌ':Subject, #1: 1	حَاذَى الْعَيْنَ
u'حَاذَى كَفٌّ':Subject, #1: 1	حَاذَى قَرْنُهُ
u'حَاذَى مَحَلٌّ':Predicate, #1: 1	حَاذَى كَفَّاهُ
u'حَاذَى مُقَدَّمٌ':Predicate, #3: 3	حَاذَى مَحَلَّ
u'حَاذَى مَوَاقِيتُ':Predicate, #1: 1	حَاذَى مُقَدَّمَ
u'حَاذَى مِيقَاتٌ':Predicate, #1: 1	حَاذَى الْمَوَاقِيتَ
u'حَاذَى نِصْفٌ':Subject, #1: 1	حَاذَى الْمِيقَاتَ
u'حَارَبَ أهْلٌ':Predicate, #1: 1	حَاذَى نِصْفُهُ
u'حَارَبَ ذِمِّيٌّ':Subject, #1: 1	حَارَبَ أَهْلَ
u'حَارَبَ رَسُولٌ':Subject, #1: 1	حَارَبَ الذِّمِّيُّ
u'حَارَبَ مَجُوسٌ':Predicate, #1: 1	حَارَبَ رَسُولُ
u'حَارَبَ مرٌّ':Predicate, #1: 1	حَارَبَ الْمَجُوسَ
u'حَارَ فِكْرٌ':Subject, #1: 1	حَارَبَ مَرَّةً
u'حَازَ أَجْنَبِيٌّ':Subject, #1: 1	حَارَ الْفِكْرُ
u'حَازَ إمَامٌ':Subject, #3: 3	حَازَ أَجْنَبِيٌّ
u'حَازَ أَوَّلُ':Subject, #1: 1	حَازَ الْإِمَامُ
u'حَازَ بِئْرٌ':Predicate, #1: 1	حَازَ الْأَوَّلُ
u'حَازَ ثَلاثُ':Predicate, #1: 1	حَازَ الْبِئْرَ
u'حَازَ ثَوابٌ':Subject, #1: 1	حَازَ ثَلَاثَ
u'حَازَ حَبْسٌ':Subject, #1: 1	حَازَ ثَوَابُهُ
u'حَازَ رُتْبَةٌ':Predicate, #1: 1	حَازَ الْحَبْسُ
u'حَازَ شَخْصٌ':Subject, #1: 1	حَازَ الرُّتْبَةَ
u'حَازَ فَضْلٌ':Predicate, #1: 1	حَازَ شَخْصٌ
u'حَازَ فَضِيلٌ':Predicate, #2: 2	حَازَ فَضْلَ
u'حَازَ فَضِيلٌ':Predicate, #1: 1	حَازَ الْفَضِيلَةَ
u'حَازَ فَضِيلَةٌ':Predicate, #1: 1	حَازَ فَضِيلَةَ
u'حَازَ فَضِيلَةٌ':Predicate, #1: 1	حَازَ الْفَضِيلَةَ
u'حَازَ مِيرَاثٌ':Predicate, #1: 1	حَازَ فَضِيلَةَ
u'حَازَ نِصْفٌ':Predicate, #1: 1	حَازَ الْمِيرَاثَ
u'حَازَ نِهَايَةٌ':Predicate, #1: 1	حَازَ النِّصْفَ
u'حَاسَبَ مُرْتَهِنٌ':Predicate, #1: 1	حَازَ النِّهَايَةَ
u'حَاشَ جِنٌّ':Predicate, #1: 1	حَاسَبَ الْمُرْتَهِنَ
u'حَاصَرَ إمَامٌ':Subject, #1: 1	حَاشَ الْجِنَّ
u'حَاصَرَ أهْلٌ':Predicate, #3: 3	حَاصَرَ الْإِمَامُ
u'حَاصَرَ رَسُولٌ':Subject, #4: 4	حَاصَرَ أَهْلَ
u'حَاصَرَ طَائِفٌ':Predicate, #3: 3	حَاصَرَ رَسُولُ
u'حَاصَرَ عَدُوٌّ':Subject, #5: 5	حَاصَرَ الطَّائِفَ
u'حَاصَرَ قَوْمٌ':Subject, #2: 2	حَاصَرَ الْعَدُوُّ
u'حَاصَرَ مَدِينٌ':Predicate, #1: 1	حَاصَرَ قَوْمٌ
u'حَاصَرَ مَدِينَةٌ':Predicate, #1: 1	حَاصَرَ مَدِينَةَ
u'حَاصَرَ مِصْرٌ':Predicate, #1: 1	حَاصَرَ مَدِينَةَ
u'حَاطَ إِحْيَاءٌ':Subject, #1: 1	حَاصَرَ مِصْرَ
u'حَاطَ جَيْشٌ':Subject, #3: 3	أَحَاطَ الْإِحْيَاءُ
u'حَاطَ حَرْقٌ':Subject, #2: 2	أَحَاطَ الْجَيْشُ
u'حَاطَ دَمٌ':Subject, #1: 1	أَحَاطَ الْحَرْقُ
u'حَاطَ دَيْنٌ':Predicate, #2: 2	أَحَاطَ الدَّمُ
u'حَاطَ دَيْنٌ':Subject, #1: 1	أَحَاطَ الدَّيْنَ
u'حَاطَ دَيْنٌ':Subject, #16: 16	أَحَاطَ الدَّيْنُ
u'حَاطَ ضَمِنٌ':Predicate, #2: 2	أَحَاطَ دَيْنُهُ
u'حَاطَ عَدُوٌّ':Subject, #1: 1	أَحَاطَ ضَمِنَ
u'حَاطَ علم':Subject, #5: 5	أَحَاطَ الْعَدُوُّ
u'حَاطَ عِلْمٌ':Subject, #2: 2	أَحَاطَ عِلْمُ
u'حَاطَ علم':Subject, #2: 2	أَحَاطَ عِلْمُ
u'حَاطَ عِلْمٌ':Subject, #3: 3	أَحَاطَ عِلْمُهُ
u'حَاطَ كُفَّارٌ':Subject, #3: 3	أَحَاطَ عِلْمُهُ
u'حَافَظَ علماء':Subject, #2: 2	أَحَاطَ الْكُفَّارُ
u'حَافَظَ عُلَمَاءُ':Subject, #1: 1	حَافَظَ الْعُلَمَاءُ
u'حَافَ قَدَرٌ':Subject, #1: 1	حَافَظَ الْعُلَمَاءُ
u'حَاكَ شَيْءٌ':Subject, #1: 1	حَافَ الْقَدَرُ
u'حَاكَمَ عَامِلٌ':Predicate, #1: 1	حَاكَ شَيْءٌ
u'حَاكَى هَجْوٌ':Predicate, #1: 1	حَاكَمَ الْعَامِلَ
u'حَالَ اِبْنٌ':Subject, #1: 1	حَاكَى الْهَجْوَ
u'حَالَ أَجَلٌ':Subject, #1: 1	أَحَالَ ابْنُ
u'حَالَ أحَدٌ':Predicate, #1: 1	حَالَ أَجَلُ
u'حَالَ أحَدٌ':Subject, #1: 1	أَحَالَ أَحَدَ
u'حَالَ أرْضٌ':Subject, #1: 1	أَحَالَ أَحَدُ
u'حَالَ أَصيلٌ':Subject, #1: 1	حَالَ الْأَرْضُ
u'حَالَ بَائِعٌ':Predicate, #1: 1	أَحَالَ الْأَصِيلُ
u'حَالَ بَائِعٌ':Subject, #2: 2	أَحَالَ الْبَائِعَ
u'حَالَ بَائِعٌ':Subject, #11: 11	أَحَالَ الْبَائِعُ
u'حَالَ بَقاءٌ':Predicate, #1: 1	أَحَالَ بَائِعٌ
u'حَالَ بَقِيَّةٌ':Subject, #1: 1	حَالَ بَقَاءَ
u'حَالَ بَيْتٌ':Subject, #1: 1	حَالَ بَقِيَّةُ
u'حَالَ بَيْنٌ':Predicate, #1: 1	حَالَ الْبَيْتُ
u'حَالَ تَعْلِيقٌ':Subject, #14: 14	حَالَ بَيْنَ
u'حَالَ حسد':Subject, #1: 1	حَالَ التَّعْلِيقُ
u'حَالَ حَسَدٌ':Subject, #1: 1	حَالَ الْحَسَدُ
u'حَالَ حُقوقٌ':Predicate, #1: 1	حَالَ الْحَسَدُ
u'حَالَ حُقُوقٌ':Predicate, #1: 1	أَحَالَ حُقُوقَ
u'حَالَ حول':Subject, #1: 1	أَحَالَ حُقُوقَ
u'حَالَ حَوْلٌ':Subject, #3: 3	حَالَ حَوْلُهُ
u'حَالَ حول':Subject, #3: 3	حَالَ حَوْلُهُ
u'حَالَ حَوْلٌ':Subject, #70: 70	حَالَ الْحَوْلُ
u'حَالَ حول':Subject, #70: 70	حَالَ الْحَوْلُ
u'حَالَ حَوْلٌ':Subject, #9: 9	حَالَ حَوْلُ
u'حَالَ حَيَوَانٌ':Subject, #9: 9	حَالَ حَوْلُ
u'حَالَ خَوْفٌ':Subject, #1: 1	حَالَ حَيَوَانٌ
u'حَالَ دَائِنٌ':Predicate, #1: 1	حَالَ الْخَوْفُ
u'حَالَ دَائِنٌ':Subject, #2: 2	أَحَالَ الدَّائِنَ
u'حَالَ دَرَاهِمُ':Predicate, #1: 1	أَحَالَ دَائِنُهُ
u'حَالَ دونٌ':Predicate, #1: 1	أَحَالَ الدَّرَاهِمَ
u'حَالَ رَاهِنٌ':Subject, #4: 4	حَالَ دُونَ
u'حَالَ رَبُّ':Subject, #6: 6	أَحَالَ الرَّاهِنُ
u'حَالَ رَجُلٌ':Subject, #4: 4	أَحَالَ رَبُّ
u'حَالَ زَوْجٌ':Subject, #2: 2	أَحَالَ الرَّجُلُ
u'حَالَ سَاكِتٌ':Predicate, #3: 3	أَحَالَ الزَّوْجُ
u'حَالَ سلام':Subject, #2: 2	أَحَالَ السَّاكِتَ
u'حَالَ سَلاَمٌ':Subject, #1: 1	حَالَ السَّلَامُ
u'حَالَ سَمَاعٌ':Predicate, #1: 1	حَالَ السَّلَامُ
u'حَالَ سُوقٌ':Subject, #1: 1	أَحَالَ سَمَاعَ
u'حَالَ سَيِّدٌ':Subject, #2: 2	حَالَ سُوقُهُ
u'حَالَ شَرِيكٌ':Subject, #1: 1	أَحَالَ سَيِّدُهُ
u'حَالَ صَاحِبٌ':Subject, #1: 1	أَحَالَ الشَّرِيكُ
u'حَالَ طَالِبٌ':Predicate, #2: 2	أَحَالَ صَاحِبُ
u'حَالَ طَالِبٌ':Subject, #4: 4	أَحَالَ الطَّالِبَ
u'حَالَ عَدَمٌ':Predicate, #4: 4	أَحَالَ الطَّالِبُ
u'حَالَ عَهْدٌ':Subject, #1: 1	أَحَالَ عَدَمَ
u'حَالَ غَرِيمٌ':Subject, #1: 1	حَالَ عَهْدُ
u'حَالَفَ بَيْنٌ':Predicate, #2: 2	أَحَالَ الْغَرِيمُ
u'حَالَفَ رَسُولٌ':Subject, #1: 1	حَالَفَ بَيْنَ
u'حَالَ فَقِيرٌ':Predicate, #2: 2	حَالَفَ رَسُولُ
u'حَالَفَ نَبِيٌّ':Subject, #1: 1	أَحَالَ الْفَقِيرَ
u'حَالَ قمر':Subject, #1: 1	حَالَفَ النَّبِيُّ
u'حَالَ قَمَرٌ':Subject, #1: 1	حَالَ الْقَمَرُ
u'حَالَ كَفِيلٌ':Subject, #1: 1	حَالَ الْقَمَرُ
u'حَالَ لَوْنٌ':Subject, #3: 3	أَحَالَ الْكَفِيلُ
u'حَالَ مُتَأَهِّبٌ':Predicate, #1: 1	حَالَ لَوْنُهُ
u'حَالَ مُحْتَالٌ':Predicate, #1: 1	حَالَ الْمُتَأَهِّبِينَ
u'حَالَ مُحِيل':Subject, #1: 1	أَحَالَ الْمُحْتَالَ
u'حَالَ مُدْرِكٌ':Subject, #1: 1	أَحَالَ الْمُحِيلُ
u'حَالَ مَدْيُونٌ':Predicate, #1: 1	أَحَالَ الْمُدْرِكُ
u'حَالَ مَدْيُونٌ':Subject, #1: 1	أَحَالَ الْمَدْيُونَ
u'حَالَ مُرْتَهِنٌ':Predicate, #2: 2	أَحَالَ الْمَدْيُونُ
u'حَالَ مُرْتَهِنٌ':Subject, #2: 2	أَحَالَ الْمُرْتَهِنَ
u'حَالَ مَرِيضٌ':Predicate, #4: 4	أَحَالَ الْمُرْتَهِنُ
u'حَالَ مَسْأَلَةٌ':Predicate, #1: 1	أَحَالَ الْمَرِيضَ
u'حَالَ مُسْلِمٌ':Subject, #1: 1	أَحَالَ الْمَسْأَلَةَ
u'حَالَ مُشْرِك':Predicate, #1: 1	أَحَالَ الْمُسْلِمُ
u'حَالَ مُصَنِّفٌ':Subject, #1: 1	حَالَ الْمُشْرِكِينَ
u'حَالَ مُطْلَقٌ':Predicate, #2: 2	أَحَالَ الْمُصَنِّفُ
u'حَالَ مَطْلُوبٌ':Subject, #1: 1	أَحَالَ مُطْلَقَةً
u'حَالَ مَفْعُولٌ':Subject, #3: 3	أَحَالَ الْمَطْلُوبُ
u'حَالَ مَكْفُولٌ':Predicate, #1: 1	حَالَ مَفْعُولٌ
u'حَالَ مُوَكِّلٌ':Subject, #2: 2	أَحَالَ الْمَكْفُولَ
u'حَالَ مُؤَلِّفٌ':Subject, #1: 1	أَحَالَ الْمُوَكِّلُ
u'حَالَ مُؤَنٌ':Predicate, #1: 1	أَحَالَ الْمُؤَلِّفُ
u'حَالَ نَاظِرٌ':Subject, #1: 1	أَحَالَ الْمُؤَنَ
u'حَالَ وَكِيلٌ':Subject, #1: 1	أَحَالَ النَّاظِرُ
u'حَامَ حول':Predicate, #1: 1	أَحَالَ الْوَكِيلُ
u'حَامَ حَوْلٌ':Predicate, #11: 11	حَامَ حَوْلَ
u'حَانَ رحلة':Subject, #11: 11	حَامَ حَوْلَ
u'حَانَ رِحْلَةٌ':Subject, #1: 1	حَانَ رِحْلَتُهُ
u'حَانَ رَواحٌ':Subject, #1: 1	حَانَ رِحْلَتُهُ
u'حَانَ مَصْرَعٌ':Subject, #1: 1	حَانَ الرَّوَاحُ
u'حَانَ وَقْتٌ':Subject, #1: 1	حَانَ مَصْرَعُهُ
u'حَاوَلَ اِبْنٌ':Subject, #1: 1	حَانَ وَقْتُ
u'حَاوَلَ آدَمُ':Predicate, #1: 1	حَاوَلَ ابْنُ
u'حَاوَلَ إِنْشاءٌ':Predicate, #1: 1	حَاوَلَ آدَمَ
u'حَاوَلَ تَخْرِيجٌ':Predicate, #1: 1	حَاوَلَ إنْشَاءَ
u'حَاوَلَ تَشْبِيهٌ':Predicate, #2: 2	حَاوَلَ تَخْرِيجَ
u'حَاوَلَ جمع':Predicate, #1: 1	حَاوَلَ تَشْبِيهَ
u'حَاوَلَ جَمْعٌ':Predicate, #1: 1	حَاوَلَ الْجَمْعَ
u'حَاوَلَ شَيْخٌ':Subject, #1: 1	حَاوَلَ الْجَمْعَ
u'حَاوَلَ شَيْطَانٌ':Subject, #1: 1	حَاوَلَ الشَّيْخُ
u'حَاوَلَ طَيٌّ':Predicate, #1: 1	حَاوَلَ الشَّيْطَانُ
u'حَاوَلَ مُحاوِل':Subject, #1: 1	حَاوَلَ طَيَّ
u'حَبَّ أخْذٌ':Predicate, #1: 1	حَاوَلَ مُحَاوِلٌ
u'حَبَا سَبُعٌ':Subject, #1: 1	أَحَبَّ أَخْذَ
u'حَبَّ اِمْرُؤٌ':Subject, #1: 1	حَبَا سَبُعٌ
u'حَبَّ إِنْسانٌ':Subject, #1: 1	أَحَبَّ امْرُؤٌ
u'حَبَّ أنصار':Predicate, #1: 1	أَحَبَّ الْإِنْسَانُ
u'حَبَّ أَنْصارٌ':Predicate, #6: 6	أَحَبَّ الأَنْصَارَ
u'حَبَّ أَنْصَارٌ':Predicate, #6: 6	أَحَبَّ الأَنْصَارَ
u'حَبَّ أَوْلِيَاءُ':Subject, #6: 6	أَحَبَّ الأَنْصَارَ
u'حَبَّ بَائِعٌ':Subject, #1: 1	أَحَبَّ الْأَوْلِيَاءُ
u'حَبَّ بَعْضٌ':Subject, #2: 2	أَحَبَّ الْبَائِعُ
u'حَبَّ بَقاءٌ':Predicate, #1: 1	أَحَبَّ بَعْضُ
u'حَبَّ بَيْنٌ':Predicate, #1: 1	أَحَبَّ الْبَقَاءَ
u'حَبَّ جَازٌ':Predicate, #1: 1	أَحَبَّ بَيْنَ
u'حَبَّ جَائِزٌ':Subject, #2: 2	أَحَبَّ جَازَ
u'حَبَّ حالٌ':Predicate, #1: 1	أَحَبَّ جَائِزٌ
u'حَبَّ حَديثٌ':Predicate, #1: 1	أَحَبَّ حَالَ
u'حَبَّ دنيا':Subject, #1: 1	أَحَبَّ الْحَدِيثَ
u'حَبَّ دُنْيا':Subject, #2: 2	أَحَبَّ دُنْيَاهُ
u'حَبَّ رَجُلٌ':Subject, #2: 2	أَحَبَّ دُنْيَاهُ
u'حَبَّ زَوْجٌ':Subject, #2: 2	أَحَبَّ الرَّجُلُ
u'حَبَسَ أَبٌ':Predicate, #2: 2	أَحَبَّ الزَّوْجُ
u'حَبْسٌ أَبٌ':Added, #1: 1	حَبَسَ الْأَبَ
u'حَبْسٌ أَبٌ':Added, #1: 1	حَبْسُ الْأَبِ
u'حَبَسَ اِبْنٌ':Subject, #1: 1	حَبْسِ الْأَبِ
u'حَبَّسَ أحَدٌ':Subject, #1: 1	حَبَسَ ابْنُ
u'حَبْسٌ أحَدٌ':Added, #1: 1	حَبَّسَ أَحَدُ
u'حَبَسَ أصل':Predicate, #1: 1	حَبْسُ أَحَدٍ
u'حَبَسَ أًصْلٌ':Predicate, #1: 1	حَبَسَ الْأَصْلَ
u'حَبْسٌ أصل':Added, #1: 1	حَبَسَ الْأَصْلَ
u'حَبْسٌ أًصْلٌ':Added, #1: 1	حَبْسِ أَصْلِ
u'حَبْسٌ أصل':Added, #1: 1	حَبْسِ أَصْلِ
u'حَبْسٌ أًصْلٌ':Added, #1: 1	حَبْسُ الْأَصْلِ
u'حَبْسٌ أصل':Added, #1: 1	حَبْسُ الْأَصْلِ
u'حَبْسٌ أًصْلٌ':Added, #2: 2	حَبْسُ أَصْلِهِ
u'حَبْسٌ أصل':Added, #2: 2	حَبْسُ أَصْلِهِ
u'حَبْسٌ أًصْلٌ':Added, #2: 2	حَبْسِ الْأَصْلِ
u'حَبْسٌ أَصيلٌ':Added, #2: 2	حَبْسِ الْأَصْلِ
u'حَبْسٌ أَصيلٌ':Added, #1: 1	حَبْسِ الْأَصِيلِ
u'حَبْسٌ أَقْوَاتٌ':Added, #4: 4	حَبْسُ الْأَصِيلِ
u'حَبْسٌ الْمَرْأَةُ':Added, #1: 1	حَبْسُ الْأَقْوَاتِ
u'حَبْسٌ الْمَرْأَةُ':Added, #1: 1	حَبْسُ الْمَرْأَةِ
u'حَبْسٌ أُمٌّ':Added, #4: 4	حَبْسِ الْمَرْأَةِ
u'حَبْسٌ أُمٌّ':Added, #1: 1	حَبْسُ الْأُمِّ
u'حَبَسَ إمَامٌ':Subject, #1: 1	حَبْسُ أُمِّهِ
u'حَبْسٌ إمَامٌ':Added, #1: 1	حَبَسَ الْإِمَامُ
u'حَبْسٌ إمَامٌ':Added, #1: 1	حَبْسُ الإِمَامِ
u'حَبْسٌ أمَةٌ':Added, #2: 2	حَبْسِ الْإِمَامِ
u'حَبَسَ أهْلٌ':Subject, #1: 1	حَبْسُ أَمَةٍ
u'حَبْسٌ أهْلٌ':Added, #1: 1	حَبَسَ أَهْلُ
u'حَبْسٌ بَائِعٌ':Added, #1: 1	حَبْسِ أَهْلِ
u'حَبْسٌ بَقِيَّةٌ':Added, #3: 3	حَبْسِ الْبَائِعِ
u'حَبْسٌ بَيْعٌ':Added, #2: 2	حَبْسِ الْبَقِيَّةِ
u'حَبَّ سَتْرٌ':Predicate, #1: 1	حَبْسِ الْبَيْعِ
u'حَبْسٌ تَعْزِير':Added, #1: 1	أَحَبَّ السَّتْرَ
u'حَبْسٌ تَلَوُّمٌ':Added, #2: 2	حَبْسُ التَّعْزِيرِ
u'حَبْسٌ تَلَوُّمٌ':Added, #1: 1	حَبْسُ التَّلَوُّمِ
u'حَبَسَ ثَمَنٌ':Predicate, #1: 1	حَبْسُ تَلَوُّمٍ
u'حَبْسٌ ثَمَنٌ':Added, #1: 1	حَبَسَ الثَّمَنَ
u'حَبْسٌ ثَمَنٌ':Added, #1: 1	حَبْسُ الثَّمَنِ
u'حَبْسٌ جَارِي':Added, #2: 2	حَبْسَ الثَّمَنِ
u'حَبْسٌ جَارِيَةٌ':Added, #1: 1	حَبْسِ الْجَارِيَةِ
u'حَبْسٌ جَرَائِمُ':Added, #1: 1	حَبْسِ الْجَارِيَةِ
u'حَبْسٌ جُزْءٌ':Added, #2: 2	حَبْسِ الْجَرَائِمِ
u'حَبْسٌ جلد':Added, #1: 1	حَبْسَ جُزْءٍ
u'حَبْسٌ جِلْدٌ':Added, #1: 1	حَبْسَ الْجِلْدِ
u'حَبْسٌ حاكِمٌ':Added, #1: 1	حَبْسَ الْجِلْدِ
u'حَبْسٌ حُرٌّ':Added, #1: 1	حَبْسُ الْحَاكِمِ
u'حَبْسٌ حِصَّةٌ':Added, #1: 1	حَبْسِ الْحُرِّ
u'حَبْسٌ حَقٌّ':Added, #1: 1	حَبْسِ حِصَّةِ
u'حَبَسَ حَمَّالٌ':Subject, #1: 1	حَبْسِ حَقِّهِ
u'حَبْسٌ حَيَوَانٌ':Added, #1: 1	حَبَسَ الْحَمَّالُ
u'حَبَسَ دَابَّةٌ':Predicate, #1: 1	حَبْسَ الْحَيَوَانِ
u'حَبْسٌ دَابَّةٌ':Added, #3: 3	حَبَسَ الدَّابَّةَ
u'حَبَسَ دَارٌ':Predicate, #1: 1	حَبْسِ الدَّابَّةِ
u'حَبْسٌ دَارٌ':Added, #1: 1	حَبَسَ الدَّارَ
u'حَبْسٌ دَيْنٌ':Added, #5: 5	حَبْسُ الدَّارِ
u'حَبَسَ ذِمِّيٌّ':Subject, #1: 1	حَبْسِ دَيْنِهِ
u'حَبَسَ ذِمِّيٌّ':Subject, #1: 1	حَبَسَ الذِّمِّيُّ
u'حَبَسَ رَجُلٌ':Predicate, #1: 1	حَبَسَ ذِمِّيٌّ
u'حَبَسَ رَجُلٌ':Predicate, #1: 1	حَبَسَ الرَّجُلَ
u'حَبَسَ رَجُلٌ':Subject, #2: 2	حَبَسَ رَجُلاً
u'حَبْسٌ رَجُلٌ':Added, #1: 1	حَبَسَ رَجُلٌ
u'حَبْسٌ رَجُلٌ':Added, #1: 1	حَبْسَ الرَّجُلِ
u'حَبَسَ رَسُولٌ':Subject, #1: 1	حَبْسِ الرَّجُلِ
u'حَبْسٌ رُقْعَةٌ':Added, #1: 1	حَبَسَ رَسُولُ
u'حَبْسٌ رَهْنٌ':Added, #2: 2	حَبْسُ الرُّقْعَةِ
u'حَبْسٌ رَهْنٌ':Added, #1: 1	حَبْسُ الرَّهْنِ
u'حَبْسٌ رَهْنٌ':Added, #1: 1	حَبْسُ رَهْنٍ
u'حَبْسٌ رَهْنٌ':Added, #2: 2	حَبْسَ الرَّهْنِ
u'حَبْسٌ رُومٌ':Added, #2: 2	حَبْسِ الرَّهْنِ
u'حَبْسٌ ريحٌ':Added, #1: 1	حَبْسُ الرّومِ
u'حَبْسٌ ريحٌ':Added, #1: 1	حَبْسَ الرِّيحِ
u'حَبَسَ زَوْجٌ':Subject, #1: 1	حَبْسُ الرِّيحِ
u'حَبْسٌ زَوْجٌ':Added, #1: 1	حَبَسَ الزَّوْجُ
u'حَبْسٌ زَوْجٌ':Added, #1: 1	حَبْسَ الزَّوْجِ
u'حَبْسٌ زَوْجَةٌ':Added, #2: 2	حَبْسِ الزَّوْجِ
u'حَبَسَ سَائِمَةٌ':Predicate, #1: 1	حَبْسَ الزَّوْجَاتِ
u'حَبْسٌ سَبِيلٌ':Added, #4: 4	حَبَسَ السَّائِمَةَ
u'حَبْسٌ سُلْطَانٌ':Added, #1: 1	حَبْسِ السَّبِيلِ
u'حَبْسٌ سِلْعَةٌ':Added, #1: 1	حَبْسُ السُّلْطَانِ
u'حَبَسَ سَمَاءٌ':Predicate, #1: 1	حَبْسُ السِّلْعَةِ
u'حَبْسٌ سَنَةٌ':Added, #1: 1	حَبَسَ السَّمَاءَ
u'حَبْسٌ سَيِّدٌ':Added, #2: 2	حَبْسُ سَنَةٍ
u'حَبْسٌ شَارِبٌ':Added, #2: 2	حَبْسُ السَّيِّدِ
u'حَبْسٌ شَخْصٌ':Added, #1: 1	حَبْسِ الشَّارِبِ
u'حَبْسٌ شَرْعٌ':Added, #1: 1	حَبْسُ الشَّخْصِ
u'حَبَسَ شمس':Predicate, #2: 2	حَبْسِ الشَّرْعِ
u'حَبَسَ شَمْسٌ':Predicate, #1: 1	حَبَسَ الشَّمْسَ
u'حَبْسٌ شَيْءٌ':Added, #1: 1	حَبَسَ الشَّمْسَ
u'حَبْسٌ شَيْءٌ':Added, #1: 1	حَبْسُ شَيْءٍ
u'حَبَسَ صَانِعٌ':Subject, #3: 3	حَبْسُ الشَّيْءِ
u'حَبْسٌ صَانِعٌ':Added, #1: 1	حَبَسَ الصَّانِعُ
u'حَبْسٌ صداق':Added, #1: 1	حَبْسِ الصَّانِعِ
u'حَبْسٌ صَدَاقٌ':Added, #1: 1	حَبْسِ الصَّدَاقِ
u'حَبْسٌ صداق':Added, #1: 1	حَبْسِ الصَّدَاقِ
u'حَبْسٌ صَدَاقٌ':Added, #1: 1	حَبْسَ صَدَاقِ
u'حَبْسٌ صدقة':Added, #1: 1	حَبْسَ صَدَاقِ
u'حَبْسٌ صَدَقَةٌ':Added, #1: 1	حَبْسُ صَدَقَةٍ
u'حَبْسٌ ضَيِّقٌ':Added, #1: 1	حَبْسُ صَدَقَةٍ
u'حَبَسَ طَالِبٌ':Subject, #1: 1	حَبْسٍ ضَيِّقٍ
u'حَبَسَ طَاهِرٌ':Predicate, #1: 1	حَبَسَ الطَّالِبُ
u'حَبْسٌ طَيْرٌ':Added, #1: 1	حَبَسَ الطَّاهِرَ
u'حَبْسٌ طَيْرٌ':Added, #1: 1	حَبْسُ الطَّيْرِ
u'حَبْسٌ ظالِمٌ':Added, #2: 2	حَبْسُ طَيْرٍ
u'حَبْسٌ عَاجِزٌ':Added, #1: 1	حَبْسٍ ظَالِمٍ
u'حَبْسٌ عَبْدٌ':Added, #1: 1	حَبْسُ الْعَاجِزِ
u'حَبْسٌ عَقَارٌ':Added, #1: 1	حَبْسُ الْعَبْدِ
u'حَبَسَ عَقْلٌ':Predicate, #1: 1	حَبْسِ الْعَقَارِ
u'حَبْسٌ عَقْلٌ':Added, #1: 1	حَبَسَ الْعَقْلَ
u'حَبَسَ عُمَرٌ':Subject, #1: 1	حَبْسِ الْعَقْلِ
u'حَبَسَ عِنَبٌ':Predicate, #1: 1	حَبَسَ عُمَرُ
u'حَبَسَ عند':Predicate, #1: 1	حَبَسَ الْعِنَبَ
u'حَبْسٌ عِوَضٌ':Added, #1: 1	حَبَسَ عِنْدَ
u'حَبَسَ عين':Predicate, #1: 1	حَبْسُ عِوَضِهِ
u'حَبَسَ عَيْنٌ':Predicate, #3: 3	حَبَسَ الْعَيْنَ
u'حَبَسَ عَيْن':Predicate, #3: 3	حَبَسَ الْعَيْنَ
u'حَبْسٌ عين':Added, #3: 3	حَبَسَ الْعَيْنَ
u'حَبْسٌ عَيْنٌ':Added, #17: 17	حَبْسُ الْعَيْنِ
u'حَبْسٌ عَيْن':Added, #17: 17	حَبْسُ الْعَيْنِ
u'حَبْسٌ عين':Added, #17: 17	حَبْسُ الْعَيْنِ
u'حَبْسٌ عَيْنٌ':Added, #1: 1	حَبْسَ الْعَيْنِ
u'حَبْسٌ عَيْن':Added, #1: 1	حَبْسَ الْعَيْنِ
u'حَبْسٌ عين':Added, #1: 1	حَبْسَ الْعَيْنِ
u'حَبْسٌ عَيْنٌ':Added, #1: 1	حَبْسُ عَيْنِ
u'حَبْسٌ عَيْن':Added, #1: 1	حَبْسُ عَيْنِ
u'حَبْسٌ عين':Added, #1: 1	حَبْسُ عَيْنِ
u'حَبْسٌ عَيْنٌ':Added, #3: 3	حَبْسِ الْعَيْنِ
u'حَبْسٌ عَيْن':Added, #3: 3	حَبْسِ الْعَيْنِ
u'حَبْسٌ غَاصِبٌ':Added, #3: 3	حَبْسِ الْعَيْنِ
u'حَبَسَ غَرِيمٌ':Subject, #1: 1	حَبْسُ الْغَاصِبِ
u'حَبْسٌ غَرِيمٌ':Added, #1: 1	حَبَسَ غَرِيمُهُ
u'حَبْسٌ غَرِيمٌ':Added, #2: 2	حَبْسُ الْغَرِيمِ
u'حَبْسٌ غَرِيمٌ':Added, #2: 2	حَبْسِ الْغَرِيمِ
u'حَبَسَ غَلَّةٌ':Predicate, #4: 4	حَبْسَ غَرِيمِهِ
u'حَبْسٌ غَلَّةٌ':Added, #1: 1	حَبَسَ غَلَّةَ
u'حَبْسٌ غير':Added, #1: 1	حَبْسُ غَلَّةِ
u'حَبْسٌ غَيْرٌ':Added, #1: 1	حَبْسِ غَيْرِهِ
u'حَبْسٌ فِيلٌ':Added, #1: 1	حَبْسِ غَيْرِهِ
u'حَبْسٌ قَاتِلٌ':Added, #1: 1	حَبْسُ الْفِيلِ
u'حَبَسَ قَاذِفٌ':Predicate, #1: 1	حَبْسِ الْقَاتِلِ
u'حَبْسٌ قَاذِفٌ':Added, #1: 1	حَبَسَ الْقَاذِفَ
u'حَبَسَ قَاضِي':Predicate, #1: 1	حَبْسَ الْقَاذِفِ
u'حَبَسَ قَاضِي':Predicate, #1: 1	حَبَسَ الْقَاضِيَ
u'حَبَسَ قِيمَةٌ':Predicate, #1: 1	حَبَسَ قَاضِيَ
u'حَبْسٌ قِيمَةٌ':Added, #1: 1	حَبَسَ الْقِيمَةَ
u'حَبْسٌ كِتَابٌ':Added, #1: 1	حَبْسُ الْقِيمَةِ
u'حَبْسٌ كُرَاعٌ':Added, #1: 1	حَبْسِ الْكِتَابِ
u'حَبَسَ كَفِيلٌ':Subject, #2: 2	حَبْسُ الْكُرَاعِ
u'حَبْسٌ كَفِيلٌ':Added, #2: 2	حَبَسَ الْكَفِيلُ
u'حَبْسٌ كَفِيلٌ':Added, #1: 1	حَبْسَ الْكَفِيلِ
u'حَبْسٌ كَفِيلٌ':Added, #2: 2	حَبْسُ الْكَفِيلِ
u'حَبَسَ كَلْبٌ':Predicate, #4: 4	حَبْسِ الْكَفِيلِ
u'حَبْسٌ لبن':Added, #1: 1	حَبَسَ الْكَلْبَ
u'حَبْسٌ لَبَنٌ':Added, #1: 1	حَبْسُ اللَّبَنِ
u'حَبْسٌ لُصُوصٌ':Added, #1: 1	حَبْسُ اللَّبَنِ
u'حَبَسَ مَاءٌ':Predicate, #1: 1	حَبْسِ اللُّصُوصِ
u'حَبْسٌ مَاءٌ':Added, #1: 1	حَبَسَ الْمَاءَ
u'حَبْسٌ مَاءٌ':Added, #2: 2	حَبْسُ الْمَاءِ
u'حَبْسٌ مَالٌ':Added, #2: 2	حَبْسِ الْمَاءِ
u'حَبْسٌ مَالٌ':Added, #2: 2	حَبْسُ مَالٍ
u'حَبَسَ مَالِكٌ':Subject, #2: 2	حَبْسُ مَالِهِ
u'حَبَسَ مَالِكٌ':Subject, #1: 1	حَبَسَ الْمَالِكُ
u'حَبَسَ مَبِيعٌ':Predicate, #1: 1	حَبَسَ مَالِكٌ
u'حَبْسٌ مَبِيعٌ':Added, #1: 1	حَبَسَ الْمَبِيعَ
u'حَبْسٌ مَبِيعٌ':Added, #17: 17	حَبْسِ الْمَبِيعِ
u'حَبْسٌ مَبِيعٌ':Added, #20: 20	حَبْسُ الْمَبِيعِ
u'حَبَسَ مُتَزَوِّجٌ':Predicate, #8: 8	حَبْسَ الْمَبِيعِ
u'حَبْسٌ مثل':Added, #1: 1	حَبَسَ الْمُتَزَوِّجَةَ
u'حَبْسٌ مِثْلٌ':Added, #1: 1	حَبْسِ مِثْلِ
u'حَبْسٌ مُحْرِمٌ':Added, #1: 1	حَبْسِ مِثْلِ
u'حَبْسٌ مَدَارِسُ':Added, #1: 1	حَبْسِ الْمُحْرِمِ
u'حَبْسٌ مُدَوَّنٌ':Added, #2: 2	حَبْسِ الْمَدَارِسِ
u'حَبْسٌ مُدَوَّنَةٌ':Added, #1: 1	حَبْسِ الْمُدَوَّنَةِ
u'حَبَسَ مَدْيُونٌ':Predicate, #1: 1	حَبْسِ الْمُدَوَّنَةِ
u'حَبْسٌ مُسْتَأْجِرٌ':Added, #1: 1	حَبَسَ الْمَدْيُونَ
u'حَبْسٌ مَسْجِدٌ':Added, #1: 1	حَبْسُ الْمُسْتَأْجِرِ
u'حَبْسٌ مَسْكَنٌ':Added, #2: 2	حَبْسِ مَسْجِدٍ
u'حَبَسَ مُسْلِمٌ':Subject, #1: 1	حَبْسِ الْمَسْكَنِ
u'حَبْسٌ مُسْلِمٌ':Added, #1: 1	حَبَسَ مُسْلِمٌ
u'حَبَسَ مَشْهُودٌ':Predicate, #1: 1	حَبْسِ الْمُسْلِمِ
u'حَبْسٌ مَشْهُودٌ':Added, #1: 1	حَبَسَ الْمَشْهُودَ
u'حَبَسَ مُصْحَفٌ':Predicate, #1: 1	حَبْسَ الْمَشْهُودِ
u'حَبْسٌ مَطَرٌ':Added, #1: 1	حَبَسَ الْمُصْحَفَ
u'حَبْسٌ مُعْتَدٌّ':Added, #2: 2	حَبْسُ الْمَطَرِ
u'حَبْسٌ مُعْسِرٌ':Added, #1: 1	حَبْسُ الْمُعْتَدَّةِ
u'حَبْسٌ مَقْبُوضٌ':Added, #1: 1	حَبْسُ مُعْسِرٍ
u'حَبْسٌ مِلْكٌ':Added, #1: 1	حَبْسُ الْمَقْبُوضِ
u'حَبْسٌ مُمْتَنِعٌ':Added, #2: 2	حَبْسِ الْمِلْكِ
u'حَبْسٌ مَمْلُوكٌ':Added, #1: 1	حَبْسَ الْمُمْتَنِعِ
u'حَبْسٌ مَنَافِعُ':Added, #2: 2	حَبْسُ الْمَمْلُوكِ
u'حَبَسَ مُؤَجِّرٌ':Subject, #2: 2	حَبْسُ الْمَنَافِعِ
u'حَبَسَ مُودَعٌ':Subject, #1: 1	حَبَسَ الْمُؤَجِّرُ
u'حَبْسٌ مُوسِرٌ':Added, #1: 1	حَبَسَ الْمُودَعُ
u'حَبْسٌ مُوسِرٌ':Added, #1: 1	حَبْسَ الْمُوسِرِ
u'حَبَسَ نَبِيٌّ':Subject, #1: 1	حَبْسُ الْمُوسِرِ
u'حَبْسٌ نَحْوٌ':Added, #3: 3	حَبَسَ النَّبِيُّ
u'حَبْسٌ نَخْلٌ':Added, #1: 1	حَبْسِ نَحْوِ
u'حَبْسٌ نَفْسٌ':Added, #1: 1	حَبْسِ النَّخْلِ
u'حَبْسٌ نَفْسٌ':Added, #1: 1	حَبْسِ النَّفْسِ
u'حَبْسٌ نَفْسٌ':Added, #1: 1	حَبْسَ نَفْسِهِ
u'حَبْسٌ نَفْسٌ':Added, #1: 1	حَبْسُ نَفْسِهِ
u'حَبْسٌ نَفْسٌ':Added, #1: 1	حَبْسِ نَفْسِهِ
u'حَبَسَ نَقْدٌ':Predicate, #3: 3	حَبْسُ النَّفْسِ
u'حَبَسَ نَقْد':Predicate, #1: 1	حَبَسَ نَقْدَ
u'حَبْسٌ نكاح':Added, #1: 1	حَبَسَ نَقْدَ
u'حَبْسٌ نِكَاحٌ':Added, #1: 1	حَبْسَ النِّكَاحِ
u'حَبْسٌ هِرٌّ':Added, #1: 1	حَبْسَ النِّكَاحِ
u'حَبْسٌ وَالِدٌ':Added, #1: 1	حَبْسُ الْهِرِّ
u'حَبْسٌ وَدِيعٌ':Added, #2: 2	حَبْسِ الْوَالِدِ
u'حَبْسٌ وَدِيعَةٌ':Added, #1: 1	حَبْسِ وَدِيعَةِ
u'حَبْسٌ وَدِيعَةٌ':Added, #1: 1	حَبْسِ وَدِيعَةٍ
u'حَبَسَ وَصِيٌّ':Subject, #1: 1	حَبْسِ وَدِيعَةِ
u'حَبْسٌ وَكِيلٌ':Added, #1: 1	حَبَسَ الْوَصِيُّ
u'حَبْسٌ وَكِيلٌ':Added, #1: 1	حَبْسَ الْوَكِيلِ
u'حَبْسٌ ولد':Added, #1: 1	حَبْسُ الْوَكِيلِ
u'حَبْسٌ وَلَدٌ':Added, #1: 1	حَبْسِ وَلَدِهِ
u'حَبْسٌ ولد':Added, #1: 1	حَبْسِ وَلَدِهِ
u'حَبْسٌ وَلَدٌ':Added, #2: 2	حَبْسُ الْوَلَدِ
u'حَبَسَ وَهَلٌ':Predicate, #2: 2	حَبْسُ الْوَلَدِ
u'حَبْسٌ يَوْمٌ':Added, #1: 1	حَبَسَ وَهَلَكَ
u'حَبَّ شكر':Predicate, #5: 5	حَبْسِ يَوْمٍ
u'حَبَّ شُكْرٌ':Predicate, #1: 1	أَحَبَّ الشُّكْرَ
u'حَبَّ شهرة':Predicate, #1: 1	أَحَبَّ الشُّكْرَ
u'حَبَّ شُهْرَةٌ':Predicate, #1: 1	أَحَبَّ الشُّهْرَةَ
u'حَبِطَ أَجْرٌ':Subject, #1: 1	أَحَبَّ الشُّهْرَةَ
u'حَبَطَ ثَوابٌ':Subject, #1: 1	حَبِطَ أَجْرُهُ
u'حَبِطَ عَمَلٌ':Subject, #1: 1	حَبَطَ الثَّوَابُ
u'حَبَّ طَهَارَةٌ':Predicate, #24: 24	حَبِطَ عَمَلُهُ
u'حَبَّ عَبْدٌ':Subject, #1: 1	أَحَبَّ الطَّهَارَةَ
u'حَبَّ عُطاس':Predicate, #2: 2	أَحَبَّ عَبْدٌ
u'حَبَّ علم':Predicate, #1: 1	أَحَبَّ الْعُطَاسَ
u'حَبَّ عِلْمٌ':Predicate, #1: 1	أَحَبَّ الْعِلْمَ
u'حَبَّ علماء':Subject, #1: 1	أَحَبَّ الْعِلْمَ
u'حَبَّ عُلَمَاءُ':Subject, #1: 1	أَحَبَّ الْعُلَمَاءُ
u'حَبَّ عُمَرٌ':Predicate, #1: 1	أَحَبَّ الْعُلَمَاءُ
u'حَبَّ فَاسِقٌ':Predicate, #2: 2	أَحَبَّ عُمَرَ
u'حَبَّ فَسْخٌ':Predicate, #1: 1	أَحَبَّ الْفَاسِقِينَ
u'حَبَّ فلان':Predicate, #1: 1	أَحَبَّ الْفَسْخَ
u'حَبَّ قَالٌ':Predicate, #2: 2	أَحَبَّ عُثْمَانَ
u'حَبِلَ أمَةٌ':Predicate, #4: 4	أَحَبَّ قَالَ
u'حَبِلَ ثَانِي':Predicate, #2: 2	أَحْبَلَ الْأَمَةَ
u'حَبِلَ ثَانِيَةٌ':Predicate, #1: 1	أَحْبَلَ الثَّانِيَةَ
u'حَبِلَ جَارِي':Predicate, #1: 1	أَحْبَلَ الثَّانِيَةَ
u'حَبِلَ جَارِي':Predicate, #1: 1	أَحْبَلَ الْجَارِيَةَ
u'حَبِلَ جَارِيَةٌ':Predicate, #1: 1	أَحْبَلَ جَارِيَةَ
u'حَبِلَ جَارِيَةٌ':Predicate, #1: 1	أَحْبَلَ الْجَارِيَةَ
u'حَبَّ لِقَاءٌ':Predicate, #1: 1	أَحْبَلَ جَارِيَةَ
u'حَبَّ مُبْرِئٌ':Subject, #9: 9	أَحَبَّ لِقَاءَ
u'حَبَّ مُتَابَعٌ':Predicate, #1: 1	أَحَبَّ الْمُبْرِئُ
u'حَبَّ مُتَابَعَةٌ':Predicate, #1: 1	أَحَبَّ مُتَابَعَةَ
u'حَبَّ مَغْصُوب':Subject, #1: 1	أَحَبَّ مُتَابَعَةَ
u'حَبَّ مَقَامٌ':Predicate, #1: 1	أَحَبَّ الْمَغْصُوبُ
u'حَبَّ مكارم':Predicate, #1: 1	أَحَبَّ مَقَامَ
u'حَبَّ مَكَارِمُ':Predicate, #1: 1	أَحَبَّ الْمَكَارِمَ
u'حَبَّ مَوْتٌ':Predicate, #1: 1	أَحَبَّ الْمَكَارِمَ
u'حَبَّ مُؤَذِّنٌ':Subject, #1: 1	أَحَبَّ الْمَوْتَ
u'حَبَّ نَاسٌ':Subject, #1: 1	أَحَبَّ الْمُؤَذِّنُ
u'حَبَّ وَارِثٌ':Subject, #1: 1	أَحَبَّ النَّاسُ
u'حَتَّ نَجَاسَةٌ':Predicate, #1: 1	أَحَبَّ الْوَارِثُ
u'حَثَا تُرَابٌ':Predicate, #1: 1	حَتَّ النَّجَاسَةَ
u'حَثَا رَسُولٌ':Subject, #1: 1	حَثَا التُّرَابَ
u'حَثَّ شَارِعٌ':Subject, #1: 1	حَثَا رَسُولُ
u'حَثَّ نَاسٌ':Predicate, #2: 2	حَثَّ الشَّارِعُ
u'حَجَّ أَجِيرٌ':Subject, #2: 2	حَثَّ النَّاسَ
u'حَجَّ آدَمُ':Subject, #1: 1	حَجَّ الْأَجِيرُ
u'حَجَّ أَكْثَرُ':Subject, #2: 2	حَجَّ آدَمُ
u'حَجَّ أَوَّلُ':Predicate, #1: 1	حَجَّ أَكْثَرُ
u'حَجَبَ أَبٌ':Subject, #3: 3	حَجَّ أَوَّلَ
u'حَجَبَ أَخٌ':Predicate, #1: 1	حَجَبَ الْأَبُ
u'حَجَبَ أَخٌ':Subject, #1: 1	حَجَبَ الْأَخَ
u'حَجَبَ إِخْوَةٌ':Predicate, #1: 1	حَجَبَ الْأَخُ
u'حَجَبَ إِخْوَةٌ':Subject, #1: 1	حَجَبَ الْإِخْوَةَ
u'حَجَبَ أُمٌّ':Predicate, #1: 1	حَجَبَ الإِخْوَةُ
u'حَجَبَ تَوْبَةٌ':Predicate, #1: 1	حَجَبَ الْأُمَّ
u'حَجَبَ زَوْجٌ':Predicate, #1: 1	حَجَبَ التَّوْبَةَ
u'حَجَبَ شَيَاطِينُ':Predicate, #1: 1	حَجَبَ الزَّوْجَ
u'حَجَبَ لِسَانٌ':Predicate, #1: 1	حَجَبَ الشّيَاطِينَ
u'حَجَّ بَيْتٌ':Predicate, #1: 1	حَجَبَ لِسَانَ
u'حَجَّ ثَلاثُ':Predicate, #13: 13	حَجَّ الْبَيْتَ
u'حَجَّ جَرٌّ':Predicate, #1: 1	حَجَّ ثَلاثَ
u'حَجَّ حِجَّةٌ':Predicate, #1: 1	حَجَّ جَرَّ
u'حَجَّ حَسَنٌ':Subject, #3: 3	حَجَّ حِجَّةَ
u'حَجَّ خَمْسٌ':Predicate, #1: 1	حَجَّ الْحَسَنُ
u'حَجَّ خَيْرٌ':Subject, #1: 1	حَجَّ خَمْسَ
u'حَجَرَ أَبٌ':Subject, #2: 2	حَجَّ خَيْرٌ
u'حَجْرٌ أَبٌ':Added, #1: 1	حَجَرَ الْأَبُ
u'حَجْرٌ اِبْنٌ':Added, #1: 1	حَجْرُ الْأَبِ
u'حِجْرٌ أَجْنَبِيٌّ':Added, #1: 1	حَجْرِ ابْنِ
u'حَجَّرَ أرْضٌ':Predicate, #3: 3	حِجْرِ أَجْنَبِيٍّ
u'حِجْرٌ الْمَرْأَةُ':Added, #2: 2	حَجَّرَ الْأَرْضَ
u'حِجْرٌ أُمٌّ':Added, #1: 1	حِجْرِ الْمَرْأَةِ
u'حِجْرٌ أُمٌّ':Added, #1: 1	حِجْرَ أُمِّهِ
u'حِجْرٌ اِمْرَأَةٌ':Added, #3: 3	حِجْرِ أُمِّهِ
u'حِجْرٌ إِنْسانٌ':Added, #1: 1	حِجْرِ امْرَأَةٍ
u'حِجْرٌ إِنْسانٌ':Added, #1: 1	حِجْرُ الْإِنْسَانِ
u'حَجْرٌ أَوَّلُ':Added, #2: 2	حِجْرِ إنْسَانٍ
u'حَجْرٌ تَرِكَةٌ':Added, #4: 4	حَجْرَ الْأَوَّلِ
u'حَجْرٌ تَصَرُّفٌ':Added, #1: 1	حَجْرِ التَّرِكَةِ
u'حَجْرٌ تَصَرُّفٌ':Added, #1: 1	حَجْرُ التَّصَرُّفِ
u'حَجَرَ تَوْبَةٌ':Predicate, #1: 1	حَجْرِ التَّصَرُّفَاتِ
u'حَجْرٌ جَارِي':Added, #2: 2	حَجَرَ التَّوْبَةَ
u'حَجْرٌ جَارِيَةٌ':Added, #1: 1	حَجْرِ الْجَارِيَةِ
u'حَجَّ رَجُلٌ':Subject, #1: 1	حَجْرِ الْجَارِيَةِ
u'حَجَّ رَجُلٌ':Subject, #1: 1	حَجَّ رَجُلٌ
u'حِجْرٌ جُنُونٌ':Added, #5: 5	حَجَّ الرَّجُلُ
u'حَجْرٌ جُنُونٌ':Added, #1: 1	حِجْرَ جُنُونٍ
u'حَجَرَ حاكِمٌ':Subject, #3: 3	حَجْرُ الْجُنُونِ
u'حَجْرٌ حاكِمٌ':Added, #2: 2	حَجَرَ الْحَاكِمُ
u'حَجْرٌ حاكِمٌ':Added, #1: 1	حَجْرُ حَاكِمٍ
u'حِجْرٌ خَالٌ':Added, #3: 3	حَجْرِ الْحَاكِمِ
u'حَجْرٌ دَلالَةٌ':Added, #1: 1	حِجْرِ خَالٍ
u'حِجْرٌ رُبُوبِيٌّ':Added, #1: 1	حَجْرُ دَلَالَةٍ
u'حَجَرَ رَجُلٌ':Subject, #1: 1	حِجْرِ الرُّبُوبِيَّةِ
u'حَجْرٌ رَجُلٌ':Added, #1: 1	حَجَرَ الرَّجُلُ
u'حِجْرٌ رَجُلٌ':Added, #1: 1	حَجْرِ الرَّجُلِ
u'حِجْرٌ رَجُلٌ':Added, #2: 2	حِجْرِ الرَّجُلِ
u'حَجْرٌ رَسُولٌ':Added, #7: 7	حِجْرِ رَجُلٍ
u'حَجْرٌ رَسُولٌ':Added, #1: 1	حَجْرُ رَسُولِ
u'حِجْرٌ رَسُولٌ':Added, #2: 2	حَجْرِ رَسُولِ
u'حَجْرٌ رِقٌّ':Added, #4: 4	حِجْرِ رَسُولِ
u'حَجْرٌ رِقٌّ':Added, #1: 1	حَجْرَ الرِّقِّ
u'حَجْرٌ رِقٌّ':Added, #1: 1	حَجْرُ الرِّقِّ
u'حَجْرٌ رَقيقٌ':Added, #1: 1	حَجْرِ الرِّقِّ
u'حَجْرٌ رَقيق':Added, #1: 1	حَجْرِ الرَّقِيقِ
u'حِجْرٌ زَوْجٌ':Added, #1: 1	حَجْرِ الرَّقِيقِ
u'حِجْرٌ زَوْجٌ':Added, #1: 1	حِجْرِ الزَّوْجِ
u'حَجْرٌ سَفَهٌ':Added, #4: 4	حِجْرِ زَوْجِ
u'حَجْرٌ سَفَهٌ':Added, #1: 1	حَجْر السَّفَهِ
u'حَجْرٌ سَفَهٌ':Added, #1: 1	حَجْرِ السَّفَهِ
u'حَجْرٌ سَفَهٌ':Added, #1: 1	حَجْرِ سَفَهٍ
u'حَجْرٌ سَفَهٌ':Added, #2: 2	حَجْرَ السَّفَهِ
u'حَجْرٌ سَفِيهٌ':Added, #2: 2	حَجْرُ سَفَهٍ
u'حَجْرٌ سَفِيهٌ':Added, #1: 1	حَجْرُ السَّفِيهِ
u'حَجْرٌ سَفِيهٌ':Added, #1: 1	حَجْرِ السَّفِيهِ
u'حَجَّ رَسُولٌ':Subject, #3: 3	حَجْرَ السَّفِيهِ
u'حَجَرَ سَيِّدٌ':Subject, #10: 10	حَجَّ رَسُولُ
u'حَجْرٌ سَيِّدٌ':Added, #1: 1	حَجَرَ السَّيِّدُ
u'حَجْرٌ سَيِّدٌ':Added, #1: 1	حَجْرِ السَّيِّدِ
u'حَجْرٌ شَرْعٌ':Added, #1: 1	حَجْرِ سَيِّدِهِ
u'حِجْرٌ صَاحِبٌ':Added, #1: 1	حَجْرُ الشَّرْعِ
u'حَجْرٌ صَبِيٌّ':Added, #1: 1	حِجْرِ صَاحِبِهِ
u'حَجْرٌ صَبِيٌّ':Added, #1: 1	حَجْرَ الصَّبِيِّ
u'حَجْرٌ صَبِيٌّ':Added, #1: 1	حَجْرُ الصَّبِيِّ
u'حَجْرٌ صِغَرٌ':Added, #3: 3	حَجْرِ الصَّبِيِّ
u'حِجْرٌ عَمٌّ':Added, #1: 1	حَجْرِ الصِّغَرِ
u'حِجْرٌ عَمٌّ':Added, #1: 1	حِجْرِ الْعَمِّ
u'حِجْرٌ غير':Added, #1: 1	حِجْرِ عَمِّهِ
u'حِجْرٌ غَيْرٌ':Added, #3: 3	حِجْرِ غَيْرِهِ
u'حِجْرٌ فُلاَنٌ':Added, #3: 3	حِجْرِ غَيْرِهِ
u'حَجْرٌ فَلْسٌ':Added, #1: 1	حِجْرِ فُلَانٍ
u'حِجْرٌ قَابِضٌ':Added, #1: 1	حَجْرِ الْفَلْسِ
u'حِجْرٌ مَالِكٌ':Added, #1: 1	حِجْرِ الْقَابِضِ
u'حَجْرٌ مَجْنُونٌ':Added, #1: 1	حِجْرِ الْمَالِكِ
u'حَجْرٌ مَرَضٌ':Added, #1: 1	حَجْرُ الْمَجْنُونِ
u'حَجْرٌ مَرَضٌ':Added, #1: 1	حَجْرَ الْمَرَضِ
u'حَجْرٌ مَرَضٌ':Added, #1: 1	حَجْرُ الْمَرَضِ
u'حَجْرٌ مُفْلِسٌ':Added, #1: 1	حَجْرِ الْمَرَضِ
u'حَجْرٌ مُفْلِسٌ':Added, #1: 1	حَجْرَ الْمُفْلِسِ
u'حَجْرٌ مُفْلِسٌ':Added, #1: 1	حَجْرُ الْمُفْلِسِ
u'حِجْرٌ نَبِيٌّ':Added, #1: 1	حَجْرِ الْمُفْلِسِ
u'حِجْرٌ واحد':Added, #1: 1	حِجْرِ النَّبِيِّ
u'حِجْرٌ وَاحِدٌ':Added, #1: 1	حِجْرِ وَاحِدٍ
u'حِجْرٌ وَالِدٌ':Added, #1: 1	حِجْرِ وَاحِدٍ
u'حِجْرٌ ولد':Added, #1: 1	حِجْرِ وَالِدِهِ
u'حِجْرٌ وَلَدٌ':Added, #1: 1	حِجْرِ وَلَدِهِ
u'حَجْرٌ يَدٌ':Added, #1: 1	حِجْرِ وَلَدِهِ
u'حَجَزَ إِسْلامٌ':Subject, #1: 1	حَجْرِ الْيَدِ
u'حَجَزَ بَيْنٌ':Predicate, #2: 2	حَجَزَ الْإِسْلَامُ
u'حَجَّ زَوْجٌ':Subject, #1: 1	حَجَزَ بَيْنَ
u'حَجَّ سَالِمٌ':Subject, #2: 2	حَجَّ الزَّوْجُ
u'حَجَّ سَنَةٌ':Predicate, #1: 1	حَجَّ سَالِمٌ
u'حَجَّ صَبِيٌّ':Subject, #2: 2	حَجَّ سَنَةَ
u'حَجَّ صَغِيرٌ':Subject, #2: 2	حَجَّ الصَّبِيُّ
u'حَجَّ عَبْدٌ':Subject, #2: 2	حَجَّ صَغِيرٌ
u'حَجَّ عَبْدٌ':Subject, #1: 1	حَجَّ الْعَبْدُ
u'حَجَّ عَشْرٌ':Predicate, #2: 2	حَجَّ عَبْدُ
u'حَجَّ عُمَرٌ':Subject, #3: 3	حَجَّ عَشْرَ
u'حَجَّ غير':Subject, #3: 3	حَجَّ عُمَرُ
u'حَجَّ غَيْرٌ':Subject, #1: 1	حَجَّ غَيْرُهُ
u'حَجَّ فَرْضٌ':Predicate, #1: 1	حَجَّ غَيْرُهُ
u'حَجَّ فَقِيرٌ':Subject, #1: 1	حَجَّ الْفَرْضَ
u'حَجَّ فلان':Subject, #2: 2	حَجَّ الْفَقِيرُ
u'حَجَّ فلان':Subject, #1: 1	حَجَّ عُثْمَانُ
u'حَجَّ فُلاَنٌ':Subject, #1: 1	حَجَّ مُعَاوِيَةُ
u'حَجَّ كَافِرٌ':Subject, #2: 2	حَجَّ فُلَانٌ
u'حَجْمٌ أرْضٌ':Added, #1: 1	حَجَّ كَافِرٌ
u'حَجْمٌ أرْضٌ':Added, #1: 1	حَجْمِ الْأَرْضِ
u'حَجَمَ حَجَّام':Subject, #4: 4	حَجْمَ الْأَرْضِ
u'حَجَّ مُدَّةٌ':Predicate, #1: 1	حَجَمَ الْحَجَّامُ
u'حَجَّ مرٌّ':Predicate, #1: 1	حَجَّ مُدَّةَ
u'حَجَّ مَرٌّ':Predicate, #1: 1	حَجَّ مَرَّ
u'حَجَّ مرٌّ':Predicate, #1: 1	حَجَّ مَرَّ
u'حَجَمَ رَسُولٌ':Predicate, #3: 3	حَجَّ مَرَّةً
u'حَجَّ مَسْرُوقٌ':Subject, #1: 1	حَجَمَ رَسُولَ
u'حَجْمٌ سَوْطٌ':Added, #1: 1	حَجَّ مَسْرُوقٌ
u'حَجَّ مُشَاهَدٌ':Subject, #1: 1	حَجْمُ السَّوْطِ
u'حَجَّ مُشْرِك':Predicate, #1: 1	حَجَّ الْمُشَاهَدُ
u'حَجَّ مُعاوِيَة':Subject, #1: 1	حَجَّ الْمُشْرِكِينَ
u'حَجَمَ عَبْدٌ':Predicate, #1: 1	حَجَّ مُعَاوِيَةُ
u'حَجْمٌ عُضْوٌ':Added, #2: 2	حَجَمَ الْعَبْدَ
u'حَجْمٌ عُضْوٌ':Added, #1: 1	حَجْمَ الْعُضْوِ
u'حَجَمَ غُلاَمٌ':Predicate, #1: 1	حَجْمِ الْعُضْوِ
u'حَجْمٌ كِتَابٌ':Added, #1: 1	حَجَمَ الْغُلَامَ
u'حَجَمَ نَبِيٌّ':Predicate, #1: 1	حَجْمِ الْكِتَابِ
u'حَجَّ نَائِبٌ':Subject, #6: 6	حَجَمَ النَّبِيَّ
u'حَجَّ نَبِيٌّ':Subject, #1: 1	حَجَّ النَّائِبُ
u'حَجَّ نَفَلٌ':Predicate, #5: 5	حَجَّ النَّبِيُّ
u'حَجَّ وَجَبٌ':Predicate, #1: 1	حَجَّ النَّفَلَ
u'حَجَّ وَقْتٌ':Predicate, #1: 1	حَجَّ وَجَبَ
u'حَجَّ وَلِيدٌ':Subject, #2: 2	حَجَّ وَقْتَ
u'حَدَا إِبِلٌ':Predicate, #1: 1	حَجَّ الْوَلِيدُ
u'حَدَّ أَصْحَابٌ':Subject, #1: 1	حَدَا الإِبِلَ
u'حَدَّ أقَلُّ':Predicate, #1: 1	حَدَّ الْأَصْحَابُ
u'حَدَّ إمَامٌ':Subject, #1: 1	حَدَّ أَقَلَّ
u'حَدَّ أَميرٌ':Subject, #1: 1	حَدَّ الْإِمَامُ
u'حِدَةٌ أَخْلاَطٌ':Added, #1: 1	حَدَّ الْأَمِيرُ
u'حِدَّةٌ أسْنَانٌ':Added, #1: 1	حِدَةَ الْأَخْلَاطِ
u'حِدَّةٌ خَلْقٌ':Added, #1: 1	حِدَّةُ الْأَسْنَانِ
u'حِدَةٌ دَمٌ':Added, #1: 1	حِدَّةِ خَلْقٍ
u'حِدَّةٌ رُمْحٌ':Added, #1: 1	حِدَةَ الدَّمِ
u'حِدَةٌ سَمْعٌ':Added, #1: 1	حِدَّةِ الرُّمْحِ
u'حِدَةٌ عَسْكَرٌ':Added, #1: 1	حِدَةِ السَّمْعِ
u'حِدَّةٌ عُقُولٌ':Added, #1: 1	حِدَةِ عَسْكَرِهِ
u'حِدَةٌ مُجَاوَزَةٌ':Added, #1: 1	حِدَّةِ الْعُقُولِ
u'حَدَّثَ اِبْنٌ':Predicate, #1: 1	حِدَةِ الْمُجَاوَزَةِ
u'حَدَّثَ اِبْنٌ':Subject, #3: 3	حَدَّثَ ابْنَ
u'حَدُثَ أَثْناءُ':Predicate, #4: 4	حَدَّثَ ابْنُ
u'حَدَثَ إِجْمَاعٌ':Subject, #1: 1	أَحْدَثَ أَثْنَاءَ
u'حَدُثَ أَذَانٌ':Predicate, #1: 1	حَدَثَ الْإِجْمَاعُ
u'حَدَثَ اِسْتِحْقَاقٌ':Subject, #3: 3	أَحْدَثَ الْأَذَانَ
u'حَدُثَ إِسْلامٌ':Predicate, #1: 1	حَدَثَ اسْتِحْقَاقُهُ
u'حَدَثَ اِسْمٌ':Subject, #1: 1	أَحْدَثَ الْإِسْلَامَ
u'حَدَّثَ أَصْحَابٌ':Subject, #2: 2	حَدَثَ اسْمُ
u'حَدَّثَ أعْمَش':Predicate, #1: 1	حَدَّثَ أَصْحَابُ
u'حَدَثَ أَمْرٌ':Subject, #1: 1	حَدَّثَ الأَعْمَشَ
u'حَدَّثَ أَميرٌ':Predicate, #3: 3	حَدَثَ أَمْرٌ
u'حَدَّ ثَانِي':Predicate, #1: 1	حَدَّثَ الأَمِيرَ
u'حَدَّثَ بُخَارِيٌّ':Subject, #1: 1	حَدَّ الثَّانِيَ
u'حَدَثَ بَرْدٌ':Subject, #1: 1	حَدَّثَ الْبُخَارِيُّ
u'حَدُثَ بِرْسام':Predicate, #1: 1	حَدَثَ بَرْدٌ
u'حَدُثَ بَطَلٌ':Predicate, #1: 1	أَحْدَثَ الْبِرْسَامَ
u'حَدَّثَ بَعْضٌ':Subject, #1: 1	أَحْدَثَ بَطَلَ
u'حَدُثَ بَيْنٌ':Predicate, #1: 1	حَدَّثَ بَعْضُ
u'حَدَثَ بَيْنٌ':Predicate, #1: 1	أَحْدَثَ بَيْنَ
u'حَدَثَ تَحْرِيمٌ':Subject, #4: 4	حَدَثَ بَيْنَ
u'حَدَثَ تَفْصِيلٌ':Subject, #1: 1	حَدَثَ تَحْرِيمٌ
u'حَدَّثَ ثَابِتٌ':Subject, #1: 1	حَدَثَ التَّفْصِيلُ
u'حَدَثَ ثَالِثٌ':Subject, #1: 1	حَدَّثَ ثَابِتٌ
u'حَدَثَ ثَمَرٌ':Subject, #1: 1	حَدَثَ ثَالِثٌ
u'حَدَّثَ جَابِرٌ':Predicate, #1: 1	حَدَثَ الثَّمَرُ
u'حَدَّثَ جَابِرٌ':Subject, #1: 1	حَدَّثَ جَابِرَ
u'حَدُثَ جَازٌ':Predicate, #1: 1	حَدَّثَ جَابِرُ
u'حَدَثَ جِنْسٌ':Subject, #4: 4	أَحْدَثَ جَازَ
u'حَدَثَ جُنُونٌ':Subject, #2: 2	حَدَثَ جِنْسٌ
u'حَدَثَ حادِثٌ':Subject, #1: 1	حَدَثَ الْجُنُونُ
u'حَدُثَ حَدَثٌ':Predicate, #1: 1	حَدَثَ حَادِثٌ
u'حَدَثَ حَدَثٌ':Predicate, #1: 1	أَحْدَثَ الْحَدَثَ
u'حَدَّثَ حَديثٌ':Predicate, #1: 1	حَدَثَ حَدَثَ
u'حَدَثَ حُرِّيَّةٌ':Subject, #3: 3	حَدَّثَ الْحَدِيثَ
u'حَدَّثَ حَسَنٌ':Subject, #1: 1	حَدَثَ الْحُرِّيَّةُ
u'حَدُثَ حَفْرٌ':Predicate, #4: 4	حَدَّثَ الْحَسَنُ
u'حَدَثَ حَمْلٌ':Subject, #1: 1	أَحْدَثَ الْحَفْرَ
u'حَدَثَ حَمْلٌ':Subject, #2: 2	حَدَثَ حَمْلٌ
u'حَدُثَ خبطة':Predicate, #7: 7	حَدَثَ الْحَمْلُ
u'حَدُثَ خَشَبٌ':Predicate, #1: 1	أَحْدَثَ الْخَبْطَةَ
u'حَدَثَ خِلاَفٌ':Subject, #1: 1	أَحْدَثَ الْخَشَبَ
u'حَدُثَ خَلْفٌ':Predicate, #1: 1	حَدَثَ الْخِلَافُ
u'حَدَثَ خَوْفٌ':Subject, #1: 1	أَحْدَثَ خَلْفَ
u'حَدَثَ خيار':Subject, #1: 1	حَدَثَ خَوْفٌ
u'حَدَثَ خِيَارٌ':Subject, #1: 1	حَدَثَ الْخِيَارُ
u'حَدَثَ دَمٌ':Subject, #1: 1	حَدَثَ الْخِيَارُ
u'حَدَثَ دَيْنٌ':Subject, #2: 2	حَدَثَ الدَّمُ
u'حَدَّثَ رَجُلٌ':Subject, #3: 3	حَدَثَ الدَّيْنُ
u'حَدُثَ رِدَّةٌ':Predicate, #3: 3	حَدَّثَ الرَّجُلُ
u'حَدَّثَ رَسُولٌ':Predicate, #1: 1	أَحْدَثَ الرِّدَّةَ
u'حَدَّثَ رَسُولٌ':Subject, #1: 1	حَدَّثَ رَسُولَ
u'حَدَثَ رضاع':Subject, #2: 2	حَدَّثَ رَسُولُ
u'حَدُثَ زُكامٌ':Predicate, #1: 1	حَدَثَ الرَّضَاعُ
u'حَدَثَ زِيادَةٌ':Subject, #1: 1	أَحْدَثَ الزُّكَامَ
u'حَدَثَ زِيادَةٌ':Subject, #1: 1	حَدَثَ الزِّيَادَةُ
u'حَدَّثَ زَيْدٌ':Subject, #1: 1	حَدَثَ زِيَادَةٌ
u'حَدُثَ سَبَبٌ':Predicate, #1: 1	حَدَّثَ زَيْدُ
u'حَدَثَ سَبَبٌ':Subject, #1: 1	أَحْدَثَ سَبَبَ
u'حَدُثَ سِجْنٌ':Predicate, #1: 1	حَدَثَ السَّبَبُ
u'حَدَثَ سكر':Subject, #1: 1	أَحْدَثَ السِّجْنَ
u'حَدَثَ سُكْرٌ':Subject, #1: 1	حَدَثَ السُّكْرُ
u'حَدُثَ سَيَلانٌ':Predicate, #1: 1	حَدَثَ السُّكْرُ
u'حَدَّثَ شُعْبَةٌ':Subject, #1: 1	أَحْدَثَ السَّيَلَانَ
u'حَدَثَ شَكٌّ':Subject, #1: 1	حَدَّثَ شُعْبَةُ
u'حَدَثَ شَيْءٌ':Subject, #1: 1	حَدَثَ الشَّكُّ
u'حَدَّثَ صدق':Predicate, #1: 1	حَدَثَ شَيْءٌ
u'حَدُثَ صَرْعٌ':Predicate, #2: 2	حَدَّثَ صَدَقَ
u'حَدَّثَ صَفْوَان':Subject, #1: 1	أَحْدَثَ الصَّرْعَ
u'حَدَثَ ضَمَانٌ':Subject, #1: 1	حَدَّثَ صَفْوَانُ
u'حَدَثَ طَرِيقٌ':Subject, #1: 1	حَدَثَ ضَمَانٌ
u'حَدَثَ طَرِيقٌ':Subject, #1: 1	حَدَثَ طَرِيقٌ
u'حَدَثَ طَلْعٌ':Subject, #5: 5	حَدَثَ الطَّرِيقُ
u'حَدَثَ ظُهورٌ':Subject, #1: 1	حَدَثَ طَلْعٌ
u'حَدَثَ عَامٌ':Predicate, #1: 1	حَدَثَ ظُهُورُهُ
u'حَدَّثَ عَبْدٌ':Subject, #1: 1	حَدَثَ الْعَامَ
u'حَدَثَ عَجْزٌ':Subject, #2: 2	حَدَّثَ عَبْدُ
u'حَدَّثَ عَدْلٌ':Subject, #3: 3	حَدَثَ عَجْزٌ
u'حَدَثَ عُذْرٌ':Subject, #1: 1	حَدَّثَ الْعَدْلُ
u'حَدَثَ عرف':Subject, #5: 5	حَدَثَ عُذْرٌ
u'حَدَثَ عُرْفٌ':Subject, #1: 1	حَدَثَ الْعُرْفُ
u'حَدُثَ عُطاس':Predicate, #1: 1	حَدَثَ الْعُرْفُ
u'حَدَّثَ عَلِيٌّ':Subject, #1: 1	أَحْدَثَ الْعُطَاسَ
u'حَدَّثَ عُمَرٌ':Predicate, #1: 1	حَدَّثَ عَلِيٌّ
u'حَدَثَ عند':Predicate, #2: 2	حَدَّثَ عُمَرَ
u'حَدَثَ عند':Predicate, #2: 2	حَدَثَ عِنْدَكَ
u'حَدَثَ عَيْبٌ':Subject, #36: 36	حَدَثَ عِنْدَ
u'حَدَثَ عَيْبٌ':Subject, #11: 11	حَدَثَ الْعَيْبُ
u'حَدُثَ غَرْسٌ':Predicate, #3: 3	حَدَثَ عَيْبٌ
u'حَدَثَ غَلاَءٌ':Subject, #2: 2	أَحْدَثَ الْغَرْسَ
u'حَدَثَ غَلاَءٌ':Subject, #1: 1	حَدَثَ الْغَلَاءُ
u'حَدَثَ فَرْعٌ':Subject, #1: 1	حَدَثَ غَلَاءٌ
u'حَدَثَ فِسْقٌ':Subject, #1: 1	حَدَثَ فَرْعٌ
u'حَدَثَ فِسْقٌ':Subject, #1: 1	حَدَثَ الْفِسْقُ
u'حَدَثَ فِسْقٌ':Subject, #1: 1	حَدَثَ فِسْقٌ
u'حَدَّثَ فلان':Subject, #1: 1	حَدَثَ فِسْقُهُ
u'حَدَّثَ فلان':Subject, #1: 1	حَدَّثَ عُثْمَانُ
u'حَدَّثَ فلان':Subject, #1: 1	حَدَّثَ مَكْحُولٌ
u'حَدَثَ قَالٌ':Predicate, #2: 2	حَدَّثَ سُفْيَانُ
u'حَدَّثَ قَالٌ':Predicate, #1: 1	حَدَثَ قَالَ
u'حَدُثَ قضاة':Predicate, #2: 2	حَدَّثَ قَالَ
u'حَدُثَ قُعُودٌ':Predicate, #1: 1	أَحْدَثَ الْقُضَاةَ
u'حَدَّثَ قَوْمٌ':Predicate, #1: 1	أَحْدَثَ الْقُعُودَ
u'حَدَّثَ كَثِيرٌ':Subject, #1: 1	حَدَّثَ الْقَوْمَ
u'حَدَّثَ كذب':Predicate, #1: 1	حَدَّثَ كَثِيرُ
u'حَدَّثَ كَذِبٌ':Predicate, #1: 1	حَدَّثَ كَذِبَ
u'حَدَّثَ كذب':Predicate, #1: 1	حَدَّثَ كَذِبَ
u'حَدَثَ كَسْبٌ':Subject, #29: 29	حَدَّثَ كَذَبَ
u'حَدَّثَ كُوفِيٌّ':Predicate, #1: 1	حَدَثَ الْكَسْبُ
u'حَدُثَ لبس':Predicate, #1: 1	حَدَّثَ الْكُوفِيِّينَ
u'حَدُثَ لُبْسٌ':Predicate, #1: 1	أَحْدَثَ اللُّبْسَ
u'حَدَثَ لعب':Subject, #1: 1	أَحْدَثَ اللُّبْسَ
u'حَدَثَ لَعِبٌ':Subject, #1: 1	حَدَثَ اللَّعِبُ
u'حَدُثَ لَيْلٌ':Predicate, #1: 1	حَدَثَ اللَّعِبُ
u'حَدَّثَ مَالِكٌ':Subject, #1: 1	أَحْدَثَ لَيْلَةَ
u'حَدَثَ مَانِعٌ':Subject, #2: 2	حَدَّثَ مَالِكٌ
u'حَدَثَ مُبْطِلٌ':Subject, #6: 6	حَدَثَ مَانِعٌ
u'حَدَّثَ مثل':Predicate, #1: 1	حَدَثَ الْمُبْطِلُ
u'حَدَّثَ مِثْلٌ':Predicate, #1: 1	حَدَّثَ مِثْلَ
u'حَدَّثَ مُحَمَّدٌ':Predicate, #1: 1	حَدَّثَ مِثْلَ
u'حَدَّثَ مُحَمَّدٌ':Subject, #1: 1	حَدَّثَ مُحَمَّدَ
u'حَدَّثَ مُحَمَّدٌ':Subject, #1: 1	حَدَّثَ مُحَمَّدٌ
u'حَدَّثَ مُسْلِمٌ':Subject, #2: 2	حَدَّثَ مُحَمَّدُ
u'حَدَثَ مَطَرٌ':Subject, #2: 2	حَدَّثَ مُسْلِمٌ
u'حَدَّثَ مَكْحُول':Subject, #1: 1	حَدَثَ مَطَرٌ
u'حَدُثَ مَكْسٌ':Predicate, #1: 1	حَدَّثَ مَكْحُولٌ
u'حَدَثَ مِلْكٌ':Subject, #2: 2	أَحْدَثَ الْمَكْسَ
u'حَدَثَ مُنَازِعٌ':Subject, #2: 2	حَدَثَ مِلْكُهُ
u'حَدَثَ مَنَافِعُ':Subject, #2: 2	حَدَثَ مُنَازِعٌ
u'حَدَثَ مَوْتٌ':Subject, #1: 1	حَدَثَ الْمَنَافِعُ
u'حَدَّثَ نَاسٌ':Predicate, #4: 4	حَدَثَ الْمَوْتُ
u'حَدَثَ نِتَاجٌ':Subject, #3: 3	حَدَّثَ النَّاسَ
u'حَدُثَ نزلة':Predicate, #3: 3	حَدَثَ نِتَاجٌ
u'حَدُثَ نَزْلَةٌ':Predicate, #1: 1	أَحْدَثَ النَّزْلَةَ
u'حَدُثَ نِسْيَانٌ':Predicate, #1: 1	أَحْدَثَ النَّزْلَةَ
u'حَدَثَ نَقْصٌ':Subject, #1: 1	أَحْدَثَ النِّسْيَانَ
u'حَدَثَ نَقْصٌ':Subject, #1: 1	حَدَثَ نَقْصٌ
u'حَدُثَ نَوْمٌ':Predicate, #3: 3	حَدَثَ النَّقْصُ
u'حَدُثَ نِيَّةٌ':Predicate, #1: 1	أَحْدَثَ النَّوْمَ
u'حَدَثَ وَارِثٌ':Subject, #1: 1	أَحْدَثَ النِّيَّةَ
u'حَدُثَ وَجَبٌ':Predicate, #3: 3	حَدَثَ وَارِثٌ
u'حَدَثَ وُجُوبٌ':Subject, #1: 1	أَحْدَثَ وَجَبَ
u'حَدُثَ وَسْوَاسٌ':Predicate, #1: 1	حَدَثَ وُجُوبُ
u'حَدُثَ وَقْتٌ':Predicate, #1: 1	أَحْدَثَ الْوَسْوَاسَ
u'حَدَثَ وَلاَءٌ':Subject, #2: 2	أَحْدَثَ وَقْتَ
u'حَدَثَ وَلَدٌ':Subject, #1: 1	حَدَثَ وَلَاءٌ
u'حَدَثَ ولد':Subject, #3: 3	حَدَثَ وَلَدٌ
u'حَدَثَ وَلَدٌ':Subject, #5: 5	حَدَثَ الْوَلَدُ
u'حَدَّثَ وَلِيدٌ':Predicate, #5: 5	حَدَثَ الْوَلَدُ
u'حَدُثَ يَدٌ':Predicate, #1: 1	حَدَّثَ الْوَلِيدَ
u'حَدَثَ يسار':Subject, #1: 1	أَحْدَثَ الْيَدَ
u'حَدَثَ يَسَارٌ':Subject, #1: 1	حَدَثَ يَسَارٌ
u'حَدُثَ يَوْمٌ':Predicate, #1: 1	حَدَثَ يَسَارٌ
u'حَدَّ جَارِي':Predicate, #1: 1	أَحْدَثَ يَوْمَ
u'حَدَّدَ حَوْشٌ':Predicate, #2: 2	حَدَّ جَارِيَةً
u'حَدَّدَ دَارٌ':Predicate, #1: 1	حَدَّدَ الْحَوْشَ
u'حَدَّدَ سِكِّينٌ':Predicate, #2: 2	حَدَّدَ الدَّارَ
u'حَدَّدَ شَفْرَةٌ':Predicate, #1: 1	حَدَّدَ السِّكِّينَ
u'حَدَّدَ مَوَاقِيتُ':Predicate, #1: 1	حَدَّدَ الشَّفْرَةَ
u'حَدَّ رَاكِعٌ':Predicate, #1: 1	حَدَّدَ الْمَوَاقِيتَ
u'حَدْسٌ فَرَزْدَقٌ':Added, #2: 2	حَدَّ الرَّاكِعِينَ
u'حَدَّ شَارِبٌ':Predicate, #1: 1	حَدْسَ الْفَرَزْدَقِ
u'حَدَّ شَارِبٌ':Predicate, #1: 1	حَدَّ الشَّارِبَ
u'حَدَّ عرفة':Predicate, #1: 1	حَدَّ شَارِبَ
u'حَدَّ عند':Predicate, #1: 1	حَدَّ عَرَفَةَ
u'حَدَّقَ حول':Predicate, #1: 1	حَدَّ عِنْدَ
u'حَدَّقَ حَوْلٌ':Predicate, #1: 1	حَدَّقَ حَوْلَ
u'حَدَّ مُسْلِمٌ':Predicate, #1: 1	حَدَّقَ حَوْلَ
u'حَدَّ مَمْلُوكٌ':Predicate, #1: 1	حَدَّ الْمُسْلِمِينَ
u'حَدَّ نَفِيسٌ':Predicate, #2: 2	حَدَّ مَمْلُوكَةً
u'حَذَا نَعْلٌ':Predicate, #1: 1	حَدَّ النَّفِيسَ
u'حَذَرٌ الْمَرْءُ':Added, #1: 1	حَذَا النَّعْلَ
u'حَذَّرَ دَجَّالٌ':Predicate, #1: 1	حَذَرَ الْمَرْءِ
u'حَذَّرَ رَسُولٌ':Subject, #1: 1	حَذَّرَ الدَّجَّالَ
u'حَذَّرَ سَلَفٌ':Subject, #1: 1	حَذَّرَ رَسُولُ
u'حَذَرٌ عَدُوٌّ':Added, #1: 1	حَذَّرَ السَّلَفُ
u'حَذَرٌ عَذَابٌ':Added, #1: 1	حَذَرَ الْعَدُوِّ
u'حَذَّرَ علماء':Subject, #1: 1	حَذَرِ الْعَذَابِ
u'حَذَّرَ عُلَمَاءُ':Subject, #1: 1	حَذَّرَ الْعُلَمَاءُ
u'حَذَرٌ غبار':Added, #1: 1	حَذَّرَ الْعُلَمَاءُ
u'حَذَرٌ غُبَارٌ':Added, #1: 1	حَذَرَ الْغُبَارِ
u'حَذَّرَ فَاسِقٌ':Subject, #1: 1	حَذَرَ الْغُبَارِ
u'حَذَرٌ فَوَاتٌ':Added, #1: 1	حَذَّرَ فَاسِقٌ
u'حَذَرٌ لبس':Added, #1: 1	حَذَرَ فَوَاتِهِ
u'حَذَرٌ لَبْسٌ':Added, #1: 1	حَذَرَ اللَّبْسِ
u'حَذَرٌ مِرَاءٌ':Added, #1: 1	حَذَرَ اللَّبْسِ
u'حَذَرٌ مَوْتٌ':Added, #1: 1	حَذَرُ الْمِرَاءِ
u'حَذَرٌ مَوْتٌ':Added, #1: 1	حَذَرَ المَوْتِ
u'حَذَرٌ نَارٌ':Added, #6: 6	حَذَرَ الْمَوْتِ
u'حَذَّرَ نَبِيٌّ':Subject, #1: 1	حَذَرَ النَّارِ
u'حَذَفَ أحَدٌ':Predicate, #1: 1	حَذَّرَ النَّبِيُّ
u'حَذَفَ أَكْثَرُ':Predicate, #1: 1	حَذَفَ أَحَدَ
u'حَذَفَ أَمْلاكٌ':Predicate, #1: 1	حَذَفَ أَكْثَرَ
u'حَذَفَ أَمْلاَكٌ':Predicate, #1: 1	حَذَفَ الْأَمْلَاكَ
u'حَذَفَ بَطَلٌ':Predicate, #1: 1	حَذَفَ الْأَمْلَاكَ
u'حَذَفَ تاء':Predicate, #1: 1	حَذَفَ بَطَلَ
u'حَذَفَ تَخْيِيرٌ':Predicate, #1: 1	حَذَفَ التَّاءَ
u'حَذَفَ تَقْيِيد':Predicate, #1: 1	حَذَفَ التَّخْيِيرَ
u'حَذَفَ تَنْوِينٌ':Predicate, #1: 1	حَذَفَ التَّقْيِيدَ
u'حَذَفَ جَوْهَرٌ':Predicate, #1: 1	حَذَفَ التّنْوِينَ
u'حَذَفَ حَرْفٌ':Predicate, #1: 1	حَذَفَ الْجَوْهَرَ
u'حَذَفَ حُرِّيَّةٌ':Predicate, #2: 2	حَذَفَ حَرْفَ
u'حَذَفَ دَفْق':Predicate, #1: 1	حَذَفَ الْحُرِّيَّةَ
u'حَذَفَ ذكر':Predicate, #1: 1	حَذَفَ الدَّفْقَ
u'حَذَفَ ذِكْرٌ':Predicate, #2: 2	حَذَفَ ذِكْرَ
u'حَذَفَ صِلَةٌ':Predicate, #2: 2	حَذَفَ ذِكْرَ
u'حَذَفَ طَالِبٌ':Predicate, #1: 1	حَذَفَ صِلَةَ
u'حَذَفَ ظَرْفٌ':Predicate, #1: 1	حَذَفَ الطَّالِبَ
u'حَذَفَ عتق':Predicate, #1: 1	حَذَفَ الظَّرْفَ
u'حَذَفَ عِتْقٌ':Predicate, #1: 1	حَذَفَ عِتْقَ
u'حَذَفَ غير':Predicate, #1: 1	حَذَفَ عِتْقَ
u'حَذَفَ غَيْرٌ':Predicate, #1: 1	حَذَفَ الْغَيْرَ
u'حَذَفَ فَقِيرٌ':Subject, #1: 1	حَذَفَ الْغَيْرَ
u'حَذَفَ قَافٌ':Predicate, #1: 1	حَذَفَ الْفَقِيرُ
u'حَذَفَ قول':Predicate, #3: 3	حَذَفَ الْقَافَ
u'حَذَفَ قَوْلٌ':Predicate, #1: 1	حَذَفَ قَوْلَ
u'حَذَفَ قَيْدٌ':Predicate, #1: 1	حَذَفَ قَوْلَ
u'حَذَفَ كَلاَمٌ':Predicate, #1: 1	حَذَفَ الْقَيْدَ
u'حَذَفَ لاَمٌ':Predicate, #1: 1	حَذَفَ كَلَامَ
u'حَذَفَ لَفْظٌ':Predicate, #4: 4	حَذَفَ اللَّامَ
u'حَذَفَ لَفْظَةٌ':Predicate, #3: 3	حَذَفَ لَفْظَ
u'حَذَفَ مَرِيضٌ':Predicate, #3: 3	حَذَفَ لَفْظَةَ
u'حَذَفَ مُصَنِّفٌ':Subject, #1: 1	حَذَفَ الْمَرِيضَةَ
u'حَذَفَ مُضَافٌ':Predicate, #20: 20	حَذَفَ الْمُصَنِّفُ
u'حَذَفَ مَوْضِعٌ':Predicate, #2: 2	حَذَفَ الْمُضَافَ
u'حَذَفَ نَوَوِيٌّ':Subject, #1: 1	حَذَفَ الْمَوْضِعَ
u'حَذَفَ هاء':Predicate, #1: 1	حَذَفَ النَّوَوِيُّ
u'حَذَفَ وَصْفٌ':Predicate, #2: 2	حَذَفَ الْهَاءَ
u'حِذْقٌ صنعة':Added, #1: 1	حَذَفَ الْوَصْفَ
u'حِذْقٌ صَنْعَةٌ':Added, #1: 1	حِذْقُ الصَّنْعَةِ
u'حِذْقٌ عَظِيم':Added, #1: 1	حِذْقُ الصَّنْعَةِ
u'حِذْقٌ مُصَنِّفٌ':Added, #1: 1	حِذْقٍ عَظِيمٍ
u'حَذْوٌ أُمٌّ':Added, #1: 1	حِذْقَ الْمُصَنِّفِ
u'حَذْوٌ إمَامٌ':Added, #1: 1	حَذْوَ الْأُمِّ
u'حَذْوٌ رَأْسٌ':Added, #1: 1	حَذْوَ الْإِمَامِ
u'حَذْوٌ رُكْنٌ':Added, #1: 1	حَذْوَ رَأْسِهِ
u'حَذْوٌ رُكْن':Added, #3: 3	حَذْوَ الرُّكْنِ
u'حَذْوٌ صَدْرٌ':Added, #3: 3	حَذْوَ الرُّكْنِ
u'حَذْوٌ قُذَّةٌ':Added, #1: 1	حَذْوَ صَدْرِهِ
u'حَذْوٌ لَفْظٌ':Added, #4: 4	حَذْوَ الْقُذَّةِ
u'حَذْوٌ مَنْكِبٌ':Added, #1: 1	حَذْوَ اللَّفْظِ
u'حَذْوٌ مَنْكِبٌ':Added, #1: 1	حَذْوَ مَنْكِبِهِ
u'حَذْوٌ نَعْلٌ':Added, #5: 5	حَذْوَ الْمَنْكِبَيْنِ
u'حَرَّ أحَدٌ':Predicate, #2: 2	حَذْوَ النَّعْلِ
u'حَرْبٌ أحْمَر':Added, #1: 1	حَرَّكَ أَحَدَ
u'حَرْبٌ بَدْرٌ':Added, #2: 2	حَرْبِ الْأَحْمَرِ
u'حَرْبٌ بعاث':Added, #1: 1	حَرْبِ بَدْرٍ
u'حَرْبٌ بَيْداءُ':Added, #1: 1	حَرْبُ بُعَاثٍ
u'حَرْبٌ جَمَلٌ':Added, #1: 1	حَرْبَ الْبَيْدَاءِ
u'حَرْبٌ حاطِبٌ':Added, #2: 2	حَرْبِ الْجَمَلِ
u'حَرْبٌ حاطِبٌ':Added, #1: 1	حَرْبِ حَاطِبِ
u'حَرْبٌ خَنْدَقٌ':Added, #3: 3	حَرْبُ حَاطِبٍ
u'حَرْبٌ دَاحِسٌ':Added, #1: 1	حَرْبِ الْخَنْدَقِ
u'حَرْبٌ دَاحِسٌ':Added, #1: 1	حَرْبُ دَاحِسٍ
u'حَرْبٌ دَاحِسٌ':Added, #1: 1	حَرْبِ دَاحِسِ
u'حَرْبٌ دَاحِسٌ':Added, #2: 2	حَرْبَ دَاحِسٍ
u'حَرْبٌ رِدَّةٌ':Added, #7: 7	حَرْبِ دَاحِسٍ
u'حَرْبٌ رَسُولٌ':Added, #1: 1	حَرْبِ الرِّدَّةِ
u'حَرَّ بَطْنٌ':Predicate, #9: 9	حَرْبِ رَسُولِ
u'حَرْبٌ عَدَاوَةٌ':Added, #1: 1	حَرَّكَ الْبَطْنَ
u'حَرْبٌ عَدُوٌّ':Added, #1: 1	حَرْبَ الْعَدَاوَةِ
u'حَرْبٌ عِرَاقٌ':Added, #2: 2	حَرْبِ الْعَدُوِّ
u'حَرْبٌ عَرَبٌ':Added, #1: 1	حَرْبِ الْعِرَاقِ
u'حَرْبٌ فَتْحٌ':Added, #1: 1	حَرْبَ الْعَرَبِ
u'حَرْبٌ فُجَّارٌ':Added, #1: 1	حَرْبِ الْفَتْحِ
u'حَرْبٌ قُرَيْشٌ':Added, #1: 1	حَرْبَ الْفُجّارِ
u'حَرْبٌ مُبَاحٌ':Added, #2: 2	حَرْبِ قُرَيْشٍ
u'حَرْبٌ نَبِيٌّ':Added, #2: 2	حَرْبٍ مُبَاحٍ
u'حَرَثَ أحَدٌ':Subject, #1: 1	حَرْبِ النَّبِيِّ
u'حَرْثٌ آخِرَةٌ':Added, #1: 1	حَرَثَ أَحَدُ
u'حَرْثٌ آخِرَةٌ':Added, #1: 1	حَرْثِ الْآخِرَةِ
u'حَرَثَ أرْضٌ':Predicate, #5: 5	حَرْثَ الْآخِرَةِ
u'حَرْثٌ أرْضٌ':Added, #1: 1	حَرَثَ الْأَرْضَ
u'حَرْثٌ أرْضٌ':Added, #1: 1	حَرْثُ أَرْضِهِ
u'حَرْثٌ أرْضٌ':Added, #1: 1	حَرْثُ الأَرْضِ
u'حَرْثٌ أرْضٌ':Added, #1: 1	حَرْثُ الْأَرْضِ
u'حَرْثٌ أرْضٌ':Added, #1: 1	حَرْثِ الْأَرْضِ
u'حَرْثٌ تِجَارَةٌ':Added, #2: 2	حَرْثَ الْأَرْضِ
u'حَرَّ جَازٌ':Predicate, #1: 1	حَرْثِ التِّجَارَةِ
u'حَرَجٌ تَرْكٌ':Added, #1: 1	تَحَرَّكَ جَازَ
u'حَرَجٌ سَفَرٌ':Added, #1: 1	حَرَجُ تَرْكِ
u'حَرَجٌ سَفَرٌ':Added, #1: 1	حَرَجَ السَّفَرِ
u'حَرَجٌ سَفَرٌ':Added, #1: 1	حَرَجُ السَّفَرِ
u'حَرَجٌ عَامٌّ':Added, #2: 2	حَرَجِ السَّفَرِ
u'حَرَجٌ عَظِيم':Added, #1: 1	حَرَجٍ عَامٍّ
u'حَرَجٌ فَرْضٌ':Added, #5: 5	حَرَجٍ عَظِيمٍ
u'حَرَجٌ لاَزِمٌ':Added, #1: 1	حَرَجُ الْفَرْضِ
u'حَرَجٌ نَاسٌ':Added, #2: 2	حَرَجٍ لَازِمٍ
u'حَرِجَ وَهَلٌ':Predicate, #1: 1	حَرَجِ النَّاسِ
u'حَرَّرَ اِبْنٌ':Subject, #1: 1	حَرِجَ وَهَلَكَ
u'حَرَّرَ أحَدٌ':Predicate, #2: 2	حَرَّرَ ابْنُ
u'حَرَّرَ حاضِرٌ':Predicate, #1: 1	حَرَّرَ أَحَدَ
u'حَرَّرَ حَمْلٌ':Predicate, #1: 1	حَرَّرَ الْحَاضِرَ
u'حَرَّرَ عَلاَمَةٌ':Subject, #1: 1	حَرَّرَ الْحَمْلَ
u'حَرَّرَ غَاصِبٌ':Subject, #1: 1	حَرَّرَ الْعَلَامَةُ
u'حَرَّرَ مُحَقِّقٌ':Subject, #1: 1	حَرَّرَ غَاصِبٌ
u'حَرَّرَ مَذَاهِبُ':Predicate, #1: 1	حَرَّرَ الْمُحَقِّقُ
u'حَرَّرَ مُصَنِّفٌ':Subject, #1: 1	حَرَّرَ الْمَذَاهِبَ
u'حَرَّرَ مَمْلُوكٌ':Predicate, #1: 1	حَرَّرَ الْمُصَنِّفُ
u'حَرَّرَ مَوْضِعٌ':Predicate, #1: 1	حَرَّرَ الْمَمْلُوكَ
u'حَرَّرَ نِصْفٌ':Predicate, #1: 1	حَرَّرَ مَوْضِعَ
u'حَرِزَ ضَمِنٌ':Predicate, #4: 4	حَرَّرَ نِصْفَ
u'حَرِزَ مَاءٌ':Predicate, #1: 1	أَحْرَزَ ضَمِنَ
u'حَرِزَ مَالٌ':Predicate, #1: 1	أَحْرَزَ الْمَاءَ
u'حَرِزَ مِيرَاثٌ':Predicate, #2: 2	أَحْرَزَ الْمَالَ
u'حَرِزَ وَلاَءٌ':Predicate, #7: 7	أَحْرَزَ الْمِيرَاثَ
u'حَرَسَ أهْلٌ':Subject, #3: 3	أَحْرَزَ الْوَلاَءَ
u'حَرَسَ بَعْضٌ':Subject, #1: 1	حَرَسَ أَهْلُ
u'حَرَسَ بَعْضٌ':Subject, #1: 1	حَرَسَ بَعْضٌ
u'حَرَسٌ رَسُولٌ':Added, #2: 2	حَرَسَ بَعْضُ
u'حَرْسٌ لَيْلٌ':Added, #1: 1	حَرَسِ رَسُولِ
u'حِرْصٌ اِبْنٌ':Added, #1: 1	حَرْسُ لَيْلَةٍ
u'حِرْصٌ الْمَرْءُ':Added, #1: 1	حِرْصُ ابْنِ
u'حِرْصٌ اِمْرَأَةٌ':Added, #1: 1	حِرْصِ الْمَرْءِ
u'حَرَصَ جلد':Predicate, #1: 1	حِرْصِ امْرَأَةِ
u'حَرَصَ جِلْدٌ':Predicate, #1: 1	حَرَصَ الْجِلْدَ
u'حِرْصٌ رَسُولٌ':Added, #1: 1	حَرَصَ الْجِلْدَ
u'حِرْصٌ سائِل':Added, #1: 1	حِرْصَ رَسُولِ
u'حِرْصٌ سَائِلٌ':Added, #1: 1	حِرْصِ السَّائِلِ
u'حِرْصٌ نَاسٌ':Added, #1: 1	حِرْصِ السَّائِلِ
u'حَرَّضَ عَبْدٌ':Predicate, #1: 1	حِرْصِ النَّاسِ
u'حَرْفٌ اِبْتِداءٌ':Added, #1: 1	حَرَّضَ الْعَبْدَ
u'حَرْفٌ اِبْتِداءٌ':Added, #2: 2	حَرْفَ ابْتِدَاءٍ
u'حَرْفٌ اِبْنٌ':Added, #2: 2	حَرْفُ ابْتِدَاءٍ
u'حَرْفٌ آجُرَّة':Added, #3: 3	حَرْفِ ابْنِ
u'حَرْفٌ اِسْتِثْنَاءٌ':Added, #3: 3	حَرْفِ آجُرَّةٍ
u'حَرْفٌ اِسْتِثْنَاءٌ':Added, #1: 1	حَرْفَ اسْتِثْنَاءٍ
u'حَرْفٌ اِسْتِفْهامٌ':Added, #1: 1	حَرْفُ اسْتِثْنَاءٍ
u'حَرْفٌ اِسْتِئْنَافٌ':Added, #1: 1	حَرْفُ اسْتِفْهَامٍ
u'حَرْفٌ أَصابِعُ':Added, #1: 1	حَرْفَ اسْتِئْنَافٍ
u'حَرْفٌ أَصْلِيٌّ':Added, #1: 1	حَرْفَ الْأَصَابِعِ
u'حَرْفٌ إِضْرابٌ':Added, #1: 1	حَرْفٍ أَصْلِيٍّ
u'حَرْفٌ إِعْرابٌ':Added, #1: 1	حَرْفُ إضْرَابٍ
u'حَرْفٌ إِعْرابٌ':Added, #1: 1	حَرْفُ إعْرَابٍ
u'حَرْفٌ ألف':Added, #1: 1	حَرْفَ الْإِعْرَابِ
u'حَرْفٌ اِمْتِناعٌ':Added, #1: 1	حَرْفُ الْأَلِفِ
u'حَرْفٌ باء':Added, #1: 1	حَرْفُ امْتِنَاعٍ
u'حَرْفٌ باء':Added, #4: 4	حَرْفُ الْبَاءِ
u'حَرْفٌ باء':Added, #6: 6	حَرْفَ الْبَاءِ
u'حَرْفٌ تاء':Added, #8: 8	حَرْفِ الْبَاءِ
u'حَرْفٌ تَأْكِيدٌ':Added, #1: 1	حَرْفَ التَّاءِ
u'حَرْفٌ تَبْعِيض':Added, #1: 1	حَرْفُ التَّأْكِيدِ
u'حَرْفٌ تَخْيِيرٌ':Added, #1: 1	حَرْفَ التَّبْعِيضِ
u'حَرْفٌ تَشْبِيه':Added, #4: 4	حَرْفَ التَّخْيِيرِ
u'حَرْفٌ تَشْبِيه':Added, #1: 1	حَرْفُ التَّشْبِيهِ
u'حَرْفٌ تَعَدِّي':Added, #1: 1	حَرْفِ التَّشْبِيهِ
u'حَرْفٌ تَعْرِيفٌ':Added, #1: 1	حَرْفِ التَّعَدِّيَةِ
u'حَرْفٌ تَعْقِيبٌ':Added, #1: 1	حَرْفَ التَّعْرِيفِ
u'حَرْفٌ تَعْلِيقٌ':Added, #1: 1	حَرْفُ تَعْقِيبٍ
u'حَرْفٌ تَعْلِيقٌ':Added, #1: 1	حَرْفَ التَّعْلِيقِ
u'حَرْفٌ تَعْلِيقٌ':Added, #1: 1	حَرْفُ التَّعْلِيقِ
u'حَرْفٌ تَعْلِيقٌ':Added, #1: 1	حَرْفِ التَّعْلِيقِ
u'حَرْفٌ تَعْمِيمٌ':Added, #1: 1	حَرْفَ تَعْلِيقٍ
u'حَرْفٌ تَنْبِيه':Added, #1: 1	حَرْفَ تَعْمِيمٍ
u'حَرْفٌ تَنْبِيهٌ':Added, #1: 1	حَرْفُ التَّنْبِيهِ
u'حَرْفٌ تَنْفِيسٌ':Added, #1: 1	حَرْفُ تَنْبِيهٍ
u'حَرْفٌ جَرٌّ':Added, #1: 1	حَرْفُ تَنْفِيسٍ
u'حَرْفٌ جَرٌّ':Added, #4: 4	حَرْفَ الْجَرِّ
u'حَرْفٌ جَرٌّ':Added, #7: 7	حَرْفُ الْجَرِّ
u'حَرْفٌ جَزَاءٌ':Added, #8: 8	حَرْفِ الْجَرِّ
u'حَرْفٌ جَزَاءٌ':Added, #1: 1	حَرْفِ الْجَزَاءِ
u'حَرْفٌ جمع':Added, #3: 3	حَرْفَ الْجَزَاءِ
u'حَرْفٌ جَمْعٌ':Added, #1: 1	حَرْفُ الْجَمْعِ
u'حَرْفٌ جَوَابٌ':Added, #1: 1	حَرْفُ الْجَمْعِ
u'حَرْفٌ جَوَابٌ':Added, #11: 11	حَرْفِ الْجَوَابِ
u'حَرْفٌ جِيم':Added, #1: 1	حَرْفُ جَوَابٍ
u'حَرْفٌ حَلْقٌ':Added, #1: 1	حَرْفِ الْجِيمِ
u'حَرْفٌ حَلْقٌ':Added, #1: 1	حَرْفُ حَلْقٍ
u'حَرْفٌ حَلْقٌ':Added, #2: 2	حَرْفِ الْحَلْقِ
u'حَرْفٌ خاء':Added, #2: 2	حَرْفَ حَلْقٍ
u'حَرْفٌ خاء':Added, #1: 1	حَرْفُ الْخَاءِ
u'حَرْفٌ خَافِضٌ':Added, #1: 1	حَرْفِ الْخَاءِ
u'حَرْفٌ خِطَابٌ':Added, #3: 3	حَرْفِ الْخَافِضِ
u'حَرْفٌ خِطَابٌ':Added, #1: 1	حَرْفَ الْخِطَابِ
u'حَرْفٌ دَالٌ':Added, #1: 1	حَرْفَ خِطَابٍ
u'حَرْفٌ ذِراعٌ':Added, #1: 1	حَرْفُ الدَّالِ
u'حَرْفٌ رَاحَةٌ':Added, #1: 1	حَرْفِ الذِّرَاعِ
u'حَرْفٌ ركبة':Added, #1: 1	حَرْفِ رَاحَتِهِ
u'حَرْفٌ رُكْبَةٌ':Added, #1: 1	حَرْفِ الرُّكْبَةِ
u'حَرْفٌ سجدة':Added, #1: 1	حَرْفِ الرُّكْبَةِ
u'حَرْفٌ سَجْدَةٌ':Added, #1: 1	حَرْفَ السَّجْدَةِ
u'حَرْفٌ سَفِينَةٌ':Added, #1: 1	حَرْفَ السَّجْدَةِ
u'حَرْفٌ شَرْطٌ':Added, #1: 1	حَرْفِ السَّفِينَةِ
u'حَرْفٌ شَرْطٌ':Added, #1: 1	حَرْفَ الشّرْطِ
u'حَرْفٌ شَرْطٌ':Added, #1: 1	حَرْفَ شَرْطٍ
u'حَرْفٌ شَرْطٌ':Added, #3: 3	حَرْفُ الشَّرْطِ
u'حَرْفٌ شَرْطٌ':Added, #6: 6	حَرْفَ الشَّرْطِ
u'حَرْفٌ شَرْطٌ':Added, #6: 6	حَرْفِ الشَّرْطِ
u'حَرْفٌ شَكٌّ':Added, #7: 7	حَرْفُ شَرْطٍ
u'حَرْفٌ شَكٌّ':Added, #1: 1	حَرْفَ الشَّكِّ
u'حَرْفٌ صِلَةٌ':Added, #1: 1	حَرْفُ الشَّكِّ
u'حَرْفٌ طاء':Added, #1: 1	حَرْفِ صِلَةٍ
u'حَرْفٌ ظَرْفٌ':Added, #1: 1	حَرْفِ الطَّاءِ
u'حَرْفٌ عطف':Added, #4: 4	حَرْفَ الظَّرْفِ
u'حَرْفٌ عَطْفٌ':Added, #10: 10	حَرْفَ الْعَطْفِ
u'حَرْفٌ عطف':Added, #10: 10	حَرْفَ الْعَطْفِ
u'حَرْفٌ عَطْفٌ':Added, #11: 11	حَرْفُ الْعَطْفِ
u'حَرْفٌ عَطْفٌ':Added, #11: 11	حَرْفُ الْعَطْفِ
u'حَرْفٌ عطف':Added, #1: 1	حَرْفِ عَطْفٍ
u'حَرْفٌ عَطْفٌ':Added, #27: 27	حَرْفِ الْعَطْفِ
u'حَرْفٌ عطف':Added, #27: 27	حَرْفِ الْعَطْفِ
u'حَرْفٌ عِطْفٌ':Added, #2: 2	حَرْفَ الْعِطْفِ
u'حَرْفٌ عطف':Added, #2: 2	حَرْفَ الْعِطْفِ
u'حَرْفٌ عِطْفٌ':Added, #3: 3	حَرْفُ الْعِطْفِ
u'حَرْفٌ عَطْفٌ':Added, #3: 3	حَرْفُ الْعِطْفِ
u'حَرْفٌ عَطْفٌ':Added, #3: 3	حَرْفَ عَطْفٍ
u'حَرْفٌ عِلَّةٌ':Added, #5: 5	حَرْفُ عَطْفٍ
u'حَرْفٌ عِلَّةٌ':Added, #1: 1	حَرْفَ عِلّةٍ
u'حَرْفٌ عَهْدٌ':Added, #2: 2	حَرْفِ الْعِلَّةِ
u'حَرْفٌ غَايَةٌ':Added, #2: 2	حَرْفُ الْعَهْدِ
u'حَرْفٌ فاء':Added, #1: 1	حَرْفِ الْغَايَةِ
u'حَرْفٌ فاء':Added, #7: 7	حَرْفُ الْفَاءِ
u'حَرْفٌ فَرْجٌ':Added, #9: 9	حَرْفِ الْفَاءِ
u'حَرْفٌ فلان':Added, #1: 1	حَرْفَ الْفَرْجِ
u'حَرْفٌ قَسَمٌ':Added, #1: 1	حَرْفِ الْجِيمِ
u'حَرْفٌ قَسَمٌ':Added, #1: 1	حَرْفَ الْقَسَمِ
u'حَرْفٌ قَسَمٌ':Added, #2: 2	حَرْفُ قَسَمٍ
u'حَرْفٌ قَسَمٌ':Added, #4: 4	حَرْفُ الْقَسَمِ
u'حَرْفٌ كَفٌّ':Added, #5: 5	حَرْفِ الْقَسَمِ
u'حَرْفٌ كَفٌّ':Added, #2: 2	حَرْفُ الْكَفِّ
u'حَرْفٌ كِنَايَةٌ':Added, #2: 2	حَرْفِ كَفِّهِ
u'حَرْفٌ لاَمٌ':Added, #3: 3	حَرْفَ الْكِنَايَةِ
u'حَرْفٌ لاَمٌ':Added, #1: 1	حَرْفِ اللَّامِ
u'حَرْفٌ لِينٌ':Added, #5: 5	حَرْفَ اللَّامِ
u'حَرْفٌ لِينٌ':Added, #1: 1	حَرْفَ لِينٍ
u'حَرْفٌ مَسْأَلَةٌ':Added, #1: 1	حَرْفُ لِينٍ
u'حَرْفٌ مُضَارَعَةٌ':Added, #2: 2	حَرْفُ الْمَسْأَلَةِ
u'حَرْفٌ مُضَارَعَةٌ':Added, #2: 2	حَرْفِ الْمُضَارَعَةِ
u'حَرْفٌ مُضَارَعَةٌ':Added, #3: 3	حَرْفُ الْمُضَارَعَةِ
u'حَرْفٌ مِنْبَرٌ':Added, #5: 5	حَرْفَ الْمُضَارَعَةِ
u'حَرْفٌ مِنْبَرٌ':Added, #1: 1	حَرْفَ الْمِنْبَرِ
u'حَرْفٌ مِيمٌ':Added, #1: 1	حَرْفِ الْمِنْبَرِ
u'حَرْفٌ مِيمٌ':Added, #1: 1	حَرْفَ الْمِيمِ
u'حَرْفٌ نَافِعٌ':Added, #3: 3	حَرْفِ الْمِيمِ
u'حَرْفٌ نِدَاءٌ':Added, #1: 1	حَرْفُ نَافِعٍ
u'حَرْفٌ نِدَاءٌ':Added, #1: 1	حَرْفَ النِّدَاءِ
u'حَرْفٌ نِدَاءٌ':Added, #1: 1	حَرْفُ النِّدَاءِ
u'حَرْفٌ نَفْيٌ':Added, #4: 4	حَرْفِ النِّدَاءِ
u'حَرْفٌ نَفْيٌ':Added, #1: 1	حَرْفَ النّفْيِ
u'حَرْفٌ نَفْيٌ':Added, #1: 1	حَرْفِ النّفْيِ
u'حَرْفٌ نَفْيٌ':Added, #3: 3	حَرْفُ نَفْيٍ
u'حَرْفٌ نَفْيٌ':Added, #5: 5	حَرْفُ النَّفْيِ
u'حَرْفٌ نَفْيٌ':Added, #7: 7	حَرْفَ النَّفْيِ
u'حَرْفٌ نَهْيٌ':Added, #8: 8	حَرْفِ النَّفْيِ
u'حَرْفٌ نَهْيٌ':Added, #1: 1	حَرْفَ النَّهْيِ
u'حَرْفٌ نُونٌ':Added, #1: 1	حَرْفُ نَهْيٍ
u'حَرْفٌ هاء':Added, #1: 1	حَرْفَ نُونِ
u'حَرْفٌ هاء':Added, #1: 1	حَرْفُ الْهَاءِ
u'حَرْفٌ هِجَاءٌ':Added, #3: 3	حَرْفِ الْهَاءِ
u'حَرْفٌ واحد':Added, #1: 1	حَرْفُ الْهِجَاءِ
u'حَرْفٌ وَاحِدٌ':Added, #14: 14	حَرْفٍ وَاحِدٍ
u'حَرْفٌ وصل':Added, #14: 14	حَرْفٍ وَاحِدٍ
u'حَرْفٌ وَصْلٌ':Added, #1: 1	حَرْفَ الْوَصْلِ
u'حَرَقٌ اِبْنٌ':Added, #1: 1	حَرْفَ الْوَصْلِ
u'حَرِقَ بَعْضٌ':Predicate, #1: 1	حَرَقُ ابْنِ
u'حَرَّقَ بَعْضٌ':Predicate, #1: 1	أَحْرَقَ بَعْضَ
u'حَرِقَ بِنَاءٌ':Predicate, #1: 1	حَرَّقَ بَعْضَ
u'حَرِقَ بَيْتٌ':Predicate, #1: 1	أَحْرَقَ الْبِنَاءَ
u'حَرَّقَ ثَوْبٌ':Predicate, #2: 2	أَحْرَقَ بَيْتَ
u'حَرِقَ ثَوْبٌ':Predicate, #1: 1	حَرَّقَ ثَوْبَ
u'حَرِقَ حَصَائِدُ':Predicate, #2: 2	أَحْرَقَ الثَّوْبَ
u'حَرِقَ حَصَائِدُ':Predicate, #1: 1	أَحْرَقَ حَصَائِدَ
u'حَرْقٌ حَيَوَانٌ':Added, #2: 2	أَحْرَقَ الْحَصَائِدَ
u'حَرَقَ رَحْلٌ':Predicate, #1: 1	حَرْقِ الْحَيَوَانِ
u'حَرَّقَ رَسُولٌ':Subject, #2: 2	حَرَقَ رَحْلَ
u'حَرَقَ سَيِّدٌ':Subject, #4: 4	حَرَّقَ رَسُولُ
u'حَرِقَ طِيبٌ':Predicate, #1: 1	حَرَقَ السَّيِّدُ
u'حَرْقٌ غَالِبٌ':Added, #1: 1	أَحْرَقَ الطِّيبَ
u'حَرَّقَ فلان':Predicate, #1: 1	حَرْقٍ غَالِبٍ
u'حَرِقَ فلان':Predicate, #1: 1	حَرَّقَ اللُّوطِيَّةَ
u'حَرِقَ قلب':Predicate, #3: 3	أَحْرَقَ الْبُوَيْرَةَ
u'حَرِقَ قَلْبٌ':Predicate, #1: 1	أَحْرَقَ الْقَلْبَ
u'حَرِقَ قَلْب':Predicate, #1: 1	أَحْرَقَ الْقَلْبَ
u'حَرِقَ كُدْسٌ':Predicate, #1: 1	أَحْرَقَ الْقَلْبَ
u'حَرَّقَ لُوطِيّ':Predicate, #1: 1	أَحْرَقَ كُدْسَ
u'حَرْقٌ مَاءٌ':Added, #1: 1	حَرَّقَ اللُّوطِيَّةَ
u'حَرَقَ مَتَاعٌ':Predicate, #1: 1	حَرْقِ الْمَاءِ
u'حَرَّقَ مُرْتَدٌّ':Predicate, #1: 1	حَرَقَ مَتَاعَ
u'حَرِقَ مَوْضِعٌ':Predicate, #1: 1	حَرَّقَ الْمُرْتَدِّينَ
u'حَرَقٌ نَارٌ':Added, #1: 1	أَحْرَقَ مَوْضِعَ
u'حَرَقٌ نَارٌ':Added, #13: 13	حَرَقُ النَّارِ
u'حَرْقٌ نَارٌ':Added, #1: 1	حَرَقُ النّارِ
u'حَرْقٌ نَارٌ':Added, #1: 1	حَرْقُ النَّارِ
u'حَرْقٌ نَارٌ':Added, #1: 1	حَرْقِ نَارٍ
u'حَرْقٌ نَارٌ':Added, #5: 5	حَرْقِ النَّارِ
u'حَرَّقَ نَحْلٌ':Predicate, #6: 6	حَرْقُ نَارٍ
u'حَرْقٌ نَحْلٌ':Added, #1: 1	حَرَّقَ نَحْلاً
u'حَرَقَ نَخْلٌ':Predicate, #1: 1	حَرْقَ نَحْلٍ
u'حَرَّقَ نَخْلٌ':Predicate, #1: 1	حَرَقَ نَخْلَ
u'حَرَّ قِيَاسٌ':Subject, #2: 2	حَرَّقَ نَخْلَ
u'حَرَّكَ أحَدٌ':Predicate, #1: 1	حَرَّ قِيَاسٌ
u'حَرَّكَ بَطْنٌ':Predicate, #1: 1	حَرَّكَ أَحَدَ
u'حَرَّكَ شَخْصٌ':Subject, #1: 1	حَرَّكَ الْبَطْنَ
u'حَرَّكَ مَحْمِلٌ':Predicate, #1: 1	حَرَّكَ الشَّخْصُ
u'حَرَّكَ وِكاء':Predicate, #1: 1	حَرَّكَ الْمَحْمِلَ
u'حَرُمَ اِبْتِلاَعٌ':Subject, #1: 1	حَرَّكَ الْوِكَاءَ
u'حَرُمَ اِتِّخَاذٌ':Subject, #1: 1	حَرُمَ ابْتِلَاعُهُ
u'حَرُمَ إِتْلاَفٌ':Subject, #3: 3	حَرُمَ اتِّخَاذُهُ
u'حَرُمَ إجَارَةٌ':Subject, #4: 4	حَرُمَ إتْلَافُهُ
u'حَرُمَ إحْضَارٌ':Subject, #1: 1	حَرُمَ إجَارَتُهُ
u'حَرُمَ إِخْبَارٌ':Subject, #1: 1	حَرُمَ إحْضَارُهُ
u'حَرَّمَ أُخْتٌ':Predicate, #1: 1	حَرُمَ إخْبَارُهُ
u'حَرَّمَ أخْذٌ':Predicate, #1: 1	حَرَّمَ الأُخْتَ
u'حَرُمَ أخْذٌ':Subject, #1: 1	حَرَّمَ أَخْذَ
u'حِرْمٌ إِرْثٌ':Added, #2: 2	حَرُمَ أَخْذُهُ
u'حَرُمَ إِرْضاعٌ':Subject, #2: 2	حِرْمَانِ الْإِرْثِ
u'حَرَّمَ أَزْواجٌ':Predicate, #1: 1	حَرُمَ الْإِرْضَاعُ
u'حَرَّمَ اِسْتِبَاحَةٌ':Predicate, #1: 1	حَرَّمَ أَزْوَاجَ
u'حَرُمَ اِسْتِدَامَةٌ':Subject, #1: 1	حَرَّمَ اسْتِبَاحَةَ
u'حَرُمَ اِسْتِعْمالٌ':Subject, #1: 1	حَرُمَ اسْتِدَامَتُهُ
u'حَرُمَ اِسْتِمْتاعٌ':Subject, #12: 12	حَرُمَ اسْتِعْمَالُهُ
u'حَرَّمَ أَشْيَاءٌ':Predicate, #1: 1	حَرُمَ اسْتِمْتَاعُهُ
u'حَرُمَ اِفْتِرَاشٌ':Subject, #1: 1	حَرَّمَ أَشْيَاءَ
u'حِرْمٌ أَكْثَرُ':Added, #1: 1	حَرُمَ افْتِرَاشُ
u'حَرَّمَ أكل':Predicate, #1: 1	حِرْمَانِ أَكْثَرِ
u'حَرَّمَ أَكْلٌ':Predicate, #1: 1	حَرَّمَ الْأَكْلَ
u'حَرُمَ أكل':Subject, #1: 1	حَرَّمَ الْأَكْلَ
u'حَرُمَ أَكْلٌ':Subject, #12: 12	حَرُمَ أَكْلُهُ
u'حَرُمَ أكل':Subject, #12: 12	حَرُمَ أَكْلُهُ
u'حَرُمَ أَكْلٌ':Subject, #2: 2	حَرُمَ أَكْلُ
u'حَرُمَ أكل':Subject, #2: 2	حَرُمَ أَكْلُ
u'حَرُمَ أَكْلٌ':Subject, #6: 6	حَرُمَ الْأَكْلُ
u'حَرُمَ إلْبَاسٌ':Subject, #6: 6	حَرُمَ الْأَكْلُ
u'حَرَّمَ الْمَرْأَةُ':Predicate, #3: 3	حَرُمَ الْإِلْبَاسُ
u'حَرَّمَ أمَةٌ':Predicate, #1: 1	حَرَّمَ الْمَرْأَةَ
u'حَرُمَ إِمْساكٌ':Subject, #1: 1	حَرَّمَ الْأَمَةَ
u'حَرَمٌ أَميرٌ':Added, #1: 1	حَرُمَ الْإِمْسَاكُ
u'حِرْمَانٌ أَبٌ':Added, #1: 1	حَرَمِ أَمِيرِ
u'حِرْمَانٌ أرْبَابٌ':Added, #2: 2	حِرْمَانَ الْأَبِ
u'حِرْمَانٌ إِرْثٌ':Added, #1: 1	حِرْمَانَ أَرْبَابِ
u'حِرْمَانٌ إِرْثٌ':Added, #2: 2	حِرْمَانِ الْإِرْثِ
u'حِرْمَانٌ إِرْثٌ':Added, #4: 4	حِرْمَانُ الْإِرْثِ
u'حِرْمَانٌ أَكْثَرُ':Added, #5: 5	حِرْمَانَ الْإِرْثِ
u'حِرْمَانٌ أَكْثَرُ':Added, #1: 1	حِرْمَانُ أَكْثَرِ
u'حِرْمَانٌ أنصار':Added, #1: 1	حِرْمَانِ أَكْثَرِ
u'حِرْمَانٌ أَنْصارٌ':Added, #1: 1	حِرْمَانِ الْأَنْصَارِ
u'حِرْمَانٌ أَنْصَارٌ':Added, #1: 1	حِرْمَانِ الْأَنْصَارِ
u'حِرْمَانٌ أَوْلاَدٌ':Added, #1: 1	حِرْمَانِ الْأَنْصَارِ
u'حِرْمَانٌ بَعْضٌ':Added, #1: 1	حِرْمَانَ أَوْلَادِ
u'حِرْمَانٌ بَعْضٌ':Added, #1: 1	حِرْمَانُ الْبَعْضِ
u'حِرْمَانٌ بَعْضٌ':Added, #1: 1	حِرْمَانُ بَعْضٍ
u'حِرْمَانٌ جَاهِلِيٌّ':Added, #3: 3	حِرْمَانَ بَعْضِ
u'حِرْمَانٌ جَاهِلِيَّةٌ':Added, #1: 1	حِرْمَانَ الْجَاهِلِيَّةِ
u'حِرْمَانٌ رَقيقٌ':Added, #1: 1	حِرْمَانَ الْجَاهِلِيَّةِ
u'حِرْمَانٌ رَقيق':Added, #1: 1	حِرْمَانَ الرَّقِيقِ
u'حِرْمَانٌ زَكاةٌ':Added, #1: 1	حِرْمَانَ الرَّقِيقِ
u'حِرْمَانٌ زَوْجَةٌ':Added, #3: 3	حِرْمَانِ الزَّكَاةِ
u'حِرْمَانٌ زِيادَةٌ':Added, #1: 1	حِرْمَانِ الزَّوْجَةِ
u'حِرْمَانٌ سَهْمٌ':Added, #1: 1	حِرْمَانِ الزِّيَادَةِ
u'حِرْمَانٌ شَفَاعَةٌ':Added, #1: 1	حِرْمَانِ سَهْمِهِ
u'حِرْمٌ أنصار':Added, #1: 1	حِرْمَانَ الشَّفَاعَةِ
u'حِرْمٌ أَنْصارٌ':Added, #1: 1	حِرْمَانِ الْأَنْصَارِ
u'حِرْمٌ أَنْصَارٌ':Added, #1: 1	حِرْمَانِ الْأَنْصَارِ
u'حِرْمَانٌ صدقة':Added, #1: 1	حِرْمَانِ الْأَنْصَارِ
u'حِرْمَانٌ صَدَقَةٌ':Added, #1: 1	حِرْمَانُ الصَّدَقَةِ
u'حِرْمَانٌ صدقة':Added, #1: 1	حِرْمَانُ الصَّدَقَةِ
u'حِرْمَانٌ صَدَقَةٌ':Added, #8: 8	حِرْمَانِ الصَّدَقَةِ
u'حَرُمَ اِنْصِرافٌ':Subject, #8: 8	حِرْمَانِ الصَّدَقَةِ
u'حِرْمَانٌ صغار':Added, #1: 1	حَرُمَ انْصِرَافُهُ
u'حِرْمَانٌ عَاقِلٌ':Added, #1: 1	حِرْمَانَ الصِّغَارِ
u'حِرْمَانٌ عَبْدٌ':Added, #1: 1	حِرْمَانَ الْعَاقِلِ
u'حِرْمَانٌ فَادِي':Added, #1: 1	حِرْمَانُ عَبْدِ
u'حِرْمَانٌ فَرْعٌ':Added, #1: 1	حِرْمَانُ فَادِيهِ
u'حِرْمَانٌ فَرْعٌ':Added, #1: 1	حِرْمَانَ الْفَرْعِ
u'حِرْمَانٌ قَاتِلٌ':Added, #1: 1	حِرْمَانِ الْفَرْعِ
u'حِرْمَانٌ قَاتِلٌ':Added, #1: 1	حِرْمَانَ الْقَاتِلِ
u'حِرْمَانٌ قَاتِلٌ':Added, #3: 3	حِرْمَانُ الْقَاتِلِ
u'حِرْمَانٌ قُرْبَانٌ':Added, #3: 3	حِرْمَانِ الْقَاتِلِ
u'حِرْمَانٌ قَرِيبٌ':Added, #1: 1	حِرْمَانَ الْقُرْبَانِ
u'حِرْمَانٌ مَزِيدٌ':Added, #1: 1	حِرْمَانُ قَرِيبِهِ
u'حِرْمَانٌ مُسْتَحِقٌّ':Added, #1: 1	حِرْمَانَ الْمَزِيدِ
u'حِرْمَانٌ مِيرَاثٌ':Added, #1: 1	حِرْمَانِ مُسْتَحِقٍّ
u'حِرْمَانٌ مِيرَاثٌ':Added, #12: 12	حِرْمَانُ الْمِيرَاثِ
u'حِرْمَانٌ مِيرَاثٌ':Added, #3: 3	حِرْمَانِ الْمِيرَاثِ
u'حِرْمَانٌ نَفَقَةٌ':Added, #5: 5	حِرْمَانَ الْمِيرَاثِ
u'حِرْمَانٌ نَفَقَةٌ':Added, #1: 1	حِرْمَانَ النَّفَقَةِ
u'حِرْمَانٌ وَارِثٌ':Added, #3: 3	حِرْمَانِ النَّفَقَةِ
u'حِرْمَانٌ وَارِثٌ':Added, #1: 1	حِرْمَانَ الْوَارِثِ
u'حِرْمَانٌ وَارِثٌ':Added, #1: 1	حِرْمَانُ الْوَارِثِ
u'حِرْمَانٌ وَارِثٌ':Added, #1: 1	حِرْمَانِ الْوَارِثِ
u'حِرْمَانٌ وَرَثَةٌ':Added, #1: 1	حِرْمَانَ وَارِثِهِ
u'حِرْمَانٌ وَصِيٌّ':Added, #2: 2	حِرْمَانَ وَرَثَتِهِ
u'حِرْمَانٌ وَصِيَّةٌ':Added, #1: 1	حِرْمَانُ الْوَصِيَّةِ
u'حَرُمَ إيقَاعٌ':Subject, #1: 1	حِرْمَانُ الْوَصِيَّةِ
u'حَرُمَ بَائِنٌ':Subject, #1: 1	حَرُمَ إيقَاعُهُ
u'حَرَّمَ بَعْضٌ':Predicate, #1: 1	حَرُمَ الْبَائِنُ
u'حَرُمَ بِنَاءٌ':Subject, #1: 1	حَرَّمَ بَعْضَ
u'حَرُمَ بَوْلٌ':Subject, #1: 1	حَرُمَ الْبِنَاءُ
u'حَرَّمَ بَيْعٌ':Predicate, #2: 2	حَرُمَ الْبَوْلُ
u'حَرُمَ بَيْعٌ':Subject, #9: 9	حَرَّمَ بَيْعَ
u'حَرُمَ بَيْعٌ':Subject, #2: 2	حَرُمَ الْبَيْعُ
u'حَرُمَ بَيْعٌ':Subject, #3: 3	حَرُمَ بَيْعُ
u'حَرُمَ تَأْخِيرٌ':Subject, #7: 7	حَرُمَ بَيْعُهُ
u'حَرُمَ تَأْخِيرٌ':Subject, #1: 1	حَرُمَ تَأْخِيرُ
u'حَرَّمَ تَبَرُّعٌ':Predicate, #5: 5	حَرُمَ التَّأْخِيرُ
u'حَرُمَ تَبَرُّعٌ':Subject, #1: 1	حَرَّمَ تَبَرُّعَ
u'حَرُمَ تَرْجَمَةٌ':Subject, #1: 1	حَرُمَ تَبَرُّعُ
u'حَرُمَ تَرْكٌ':Subject, #1: 1	حَرُمَ تَرْجَمَتُهُ
u'حَرُمَ تَزَوُّجٌ':Subject, #1: 1	حَرُمَ تَرْكُهُ
u'حَرُمَ تَزَوُّجٌ':Subject, #1: 1	حَرُمَ التَّزَوُّجُ
u'حَرُمَ تَزْوِيجٌ':Subject, #1: 1	حَرُمَ تَزَوُّجُ
u'حَرُمَ تَزْوِيجٌ':Subject, #1: 1	حَرُمَ التَّزْوِيجُ
u'حَرُمَ تَسْلِيمٌ':Subject, #1: 1	حَرُمَ تَزْوِيجُهُ
u'حَرُمَ تَصَدُّقٌ':Subject, #1: 1	حَرُمَ التَّسْلِيمُ
u'حَرُمَ تَصَرُّفٌ':Subject, #1: 1	حَرُمَ التَّصَدُّقُ
u'حَرُمَ تَصْرِيحٌ':Subject, #1: 1	حَرُمَ تَصَرُّفُ
u'حَرُمَ تَطَيُّبٌ':Subject, #1: 1	حَرُمَ التَّصْرِيحُ
u'حَرَّمَ تَعَامُلٌ':Predicate, #1: 1	حَرُمَ تَطَيُّبُهُ
u'حَرَّمَ تَعَرُّضٌ':Predicate, #1: 1	حَرَّمَ التَّعَامُلَ
u'حَرُمَ تَعَرُّضٌ':Subject, #1: 1	حَرَّمَ التَّعَرُّضَ
u'حَرُمَ تَغْطِيَةٌ':Subject, #2: 2	حَرُمَ التَّعَرُّضُ
u'حَرُمَ تَغْيِيبٌ':Subject, #1: 1	حَرُمَ تَغْطِيَتُهُ
u'حَرُمَ تَفَاضُلٌ':Subject, #1: 1	حَرُمَ التَّغْيِيبُ
u'حَرُمَ تَفَرُّقٌ':Subject, #3: 3	حَرُمَ التَّفَاضُلُ
u'حَرُمَ تَفْرِيقٌ':Subject, #1: 1	حَرُمَ التَّفَرُّقُ
u'حَرُمَ تَقْليدٌ':Subject, #2: 2	حَرُمَ التَّفْرِيقُ
u'حَرُمَ تَقْليد':Subject, #1: 1	حَرُمَ تَقْلِيدُ
u'حَرُمَ تَقْليدٌ':Subject, #1: 1	حَرُمَ تَقْلِيدُ
u'حَرُمَ تَقْليد':Subject, #2: 2	حَرُمَ التَّقْلِيدُ
u'حَرُمَ تَمْكِينٌ':Subject, #2: 2	حَرُمَ التَّقْلِيدُ
u'حَرُمَ تَمَلُّكٌ':Subject, #1: 1	حَرُمَ تَمْكِينُ
u'حَرَّمَ تَنَاوُلٌ':Predicate, #1: 1	حَرُمَ تَمَلُّكُهُ
u'حَرُمَ تَنَاوُلٌ':Subject, #1: 1	حَرَّمَ التَّنَاوُلَ
u'حَرَّمَ ثَانِي':Predicate, #1: 1	حَرُمَ التَّنَاوُلُ
u'حَرَّمَ ثَانِيَةٌ':Predicate, #2: 2	حَرَّمَ الثَّانِيَةَ
u'حَرَّمَ ثَرْوَة':Predicate, #2: 2	حَرَّمَ الثَّانِيَةَ
u'حَرَّمَ جَارِي':Predicate, #1: 1	حَرَّمَ ثَرْوَةَ
u'حَرُمَ جُلُوسٌ':Subject, #1: 1	حَرَّمَ جَارِيَةً
u'حَرُمَ جماع':Subject, #1: 1	حَرُمَ الْجُلُوسُ
u'حَرُمَ جِمَاعٌ':Subject, #1: 1	حَرُمَ الْجِمَاعُ
u'حَرَّمَ جَمَاعَةٌ':Subject, #1: 1	حَرُمَ الْجِمَاعُ
u'حَرُمَ جمع':Subject, #1: 1	حَرَّمَ جَمَاعَةٌ
u'حَرُمَ جَمْعٌ':Subject, #3: 3	حَرُمَ الْجَمْعُ
u'حَرُمَ جَمِيع':Subject, #3: 3	حَرُمَ الْجَمْعُ
u'حَرَّمَ جَنَّةٌ':Predicate, #3: 3	حَرُمَ الْجَمِيعُ
u'حَرِمَ حالٌ':Predicate, #1: 1	حَرَّمَ الْجَنَّةَ
u'حَرَمٌ حَجٌّ':Added, #3: 3	أَحْرَمَ حَالَ
u'حَرِمَ حَديثٌ':Predicate, #1: 1	حَرَمِ الْحَجِّ
u'حَرَّمَ حَرامٌ':Subject, #1: 1	أَحْرَمَ الْحَدِيثَ
u'حَرُمَ حُضورٌ':Subject, #1: 1	حَرَّمَ حَرَامٌ
u'حَرُمَ حُضُورٌ':Subject, #1: 1	حَرُمَ الْحُضُورُ
u'حَرَّمَ حَلالٌ':Predicate, #1: 1	حَرُمَ الْحُضُورُ
u'حَرَّمَ حَلالٌ':Predicate, #1: 1	حَرَّمَ الْحَلَالَ
u'حَرَّ مَحْمِلٌ':Predicate, #7: 7	حَرَّمَ حَلاَلاً
u'حَرَّمَ خبائث':Predicate, #1: 1	حَرَّكَ الْمَحْمِلَ
u'حَرَّمَ خَبَائِثُ':Predicate, #1: 1	حَرَّمَ الْخَبَائِثَ
u'حَرُمَ خُرُوجٌ':Subject, #1: 1	حَرَّمَ الْخَبَائِثَ
u'حَرُمَ خُرُوجٌ':Subject, #1: 1	حَرُمَ خُرُوجُهُ
u'حَرِمَ خَلْفٌ':Predicate, #6: 6	حَرُمَ الْخُرُوجُ
u'حَرَّمَ خَمْرٌ':Predicate, #4: 4	أَحْرَمَ خَلْفَ
u'حَرَّمَ خِنْزِيرٌ':Predicate, #12: 12	حَرَّمَ الْخَمْرَ
u'حَرِمَ دَاخِلٌ':Predicate, #1: 1	حَرَّمَ الْخِنْزِيرَ
u'حَرِمَ دُبُرٌ':Predicate, #2: 2	أَحْرَمَ دَاخِلَ
u'حَرُمَ دُخُولٌ':Subject, #1: 1	أَحْرَمَ دُبُرَ
u'حَرُمَ دفن':Subject, #2: 2	حَرُمَ دُخُولُهُ
u'حَرُمَ دَفْنٌ':Subject, #1: 1	حَرُمَ دَفْنُهُ
u'حَرَّمَ دَمٌ':Predicate, #1: 1	حَرُمَ دَفْنُهُ
u'حَرُمَ دَمٌ':Subject, #1: 1	حَرَّمَ الدَّمَ
u'حَرِمَ دونٌ':Predicate, #1: 1	حَرُمَ الدَّمُ
u'حَرَّمَ ذَبائِحُ':Predicate, #1: 1	أَحْرَمَ دُونَ
u'حَرَّمَ ذَهَبٌ':Predicate, #1: 1	حَرَّمَ الذَّبَائِحَ
u'حَرَّمَ رَجُلٌ':Subject, #1: 1	حَرَّمَ الذَّهَبَ
u'حَرُمَ رُجُوعٌ':Subject, #2: 2	حَرَّمَ الرَّجُلُ
u'حَرُمَ رَدٌّ':Subject, #1: 1	حَرُمَ الرُّجُوعُ
u'حَرُمَ رَدٌّ':Subject, #2: 2	حَرُمَ الرَّدُّ
u'حَرَّمَ رَسُولٌ':Subject, #2: 2	حَرُمَ رَدُّهُ
u'حَرَمٌ رَسُولٌ':Added, #20: 20	حَرَّمَ رَسُولُ
u'حَرَمٌ رَسُولٌ':Added, #1: 1	حَرَمُ رَسُولِ
u'حَرُمَ رَفْعٌ':Subject, #1: 1	حَرَمِ رَسُولِ
u'حِرْمٌ زَكاةٌ':Added, #2: 2	حَرُمَ رَفْعُهُ
u'حَرَّمَ زَوْجَةٌ':Predicate, #3: 3	حِرْمَانِ الزَّكَاةِ
u'حِرْمٌ زَوْجَةٌ':Added, #1: 1	حَرَّمَ الزَّوْجَةَ
u'حِرْمٌ زِيادَةٌ':Added, #1: 1	حِرْمَانِ الزَّوْجَةِ
u'حَرَّمَ زِينَةٌ':Predicate, #1: 1	حِرْمَانِ الزِّيَادَةِ
u'حَرَّمَ سَائِرٌ':Predicate, #14: 14	حَرَّمَ زِينَةَ
u'حَرُمَ سَبَبٌ':Subject, #1: 1	حَرَّمَ سَائِرَ
u'حَرُمَ سَفَرٌ':Subject, #1: 1	حَرُمَ السَّبَبُ
u'حَرُمَ سَفَرٌ':Subject, #1: 1	حَرُمَ السَّفَرُ
u'حَرُمَ سَقْيٌ':Subject, #1: 1	حَرُمَ سَفَرُهُ
u'حَرُمَ سلام':Subject, #1: 1	حَرُمَ سَقْيُهُ
u'حَرُمَ سَلاَمٌ':Subject, #1: 1	حَرُمَ السَّلَامُ
u'حِرْمٌ سَهْمٌ':Added, #1: 1	حَرُمَ السَّلَامُ
u'حَرُمَ سُؤَالٌ':Subject, #1: 1	حِرْمَانِ سَهْمِهِ
u'حَرَّمَ شَارِعٌ':Subject, #1: 1	حَرُمَ السُّؤَالُ
u'حَرَّمَ شافِعِيّ':Subject, #2: 2	حَرَّمَ الشَّارِعُ
u'حَرُمَ شرب':Subject, #1: 1	حَرَّمَ الشَّافِعِيُّ
u'حَرُمَ شُرْبٌ':Subject, #1: 1	حَرُمَ شُرْبُ
u'حَرُمَ شرب':Subject, #1: 1	حَرُمَ شُرْبُ
u'حَرُمَ شُرْبٌ':Subject, #4: 4	حَرُمَ شُرْبُهُ
u'حَرَّمَ شَرْعٌ':Subject, #4: 4	حَرُمَ شُرْبُهُ
u'حَرُمَ شَقٌّ':Subject, #1: 1	حَرَّمَ الشَّرْعُ
u'حَرَّمَ شَيْءٌ':Predicate, #2: 2	حَرُمَ شَقُّ
u'حَرُمَ شَيْءٌ':Subject, #1: 1	حَرَّمَ الشَّيْءَ
u'حَرَّمَ شَيْخٌ':Subject, #2: 2	حَرُمَ الشَّيْءُ
u'حَرَمٌ صَخْرَةٌ':Added, #1: 1	حَرَّمَ الشَّيْخُ
u'حَرَّمَ صدقة':Predicate, #1: 1	حَرَمِ الصَّخْرَةِ
u'حَرَّمَ صَدَقَةٌ':Predicate, #1: 1	حَرَّمَ الصَّدَقَةَ
u'حِرْمٌ صدقة':Added, #1: 1	حَرَّمَ الصَّدَقَةَ
u'حِرْمٌ صَدَقَةٌ':Added, #8: 8	حِرْمَانِ الصَّدَقَةِ
u'حَرُمَ صغار':Subject, #8: 8	حِرْمَانِ الصَّدَقَةِ
u'حَرُمَ صَوْمٌ':Subject, #1: 1	حَرُمَ الصِّغَارُ
u'حَرُمَ صَوْمٌ':Subject, #1: 1	حَرُمَ الصَّوْمُ
u'حَرَّمَ صَيْدٌ':Predicate, #2: 2	حَرُمَ صَوْمُهُ
u'حَرَّمَ صَيْدٌ':Predicate, #1: 1	حَرَّمَ الصَّيْدَ
u'حَرَّمَ ضَبٌّ':Predicate, #2: 2	حَرَّمَ صَيْدَ
u'حَرِمَ طَافٌ':Predicate, #1: 1	حَرَّمَ الضَّبَّ
u'حَرُمَ طعام':Subject, #1: 1	أَحْرَمَ طَافَ
u'حَرُمَ طَعَامٌ':Subject, #4: 4	حَرُمَ الطَّعَامُ
u'حَرَّمَ طِيبٌ':Predicate, #4: 4	حَرُمَ الطَّعَامُ
u'حَرِمَ عَامٌ':Predicate, #1: 1	حَرَّمَ الطِّيبَ
u'حَرَّمَ عَسَلٌ':Predicate, #1: 1	أَحْرَمَ عَامَ
u'حَرُمَ عُضْوٌ':Subject, #3: 3	حَرَّمَ الْعَسَلَ
u'حَرِمَ عَقِبٌ':Predicate, #1: 1	حَرُمَ الْعُضْوُ
u'حَرَّمَ عِمَالَةٌ':Predicate, #1: 1	أَحْرَمَ عَقِبَ
u'حَرُمَ عَمَلٌ':Subject, #1: 1	حَرَّمَ الْعِمَالَةَ
u'حَرُمَ عند':Predicate, #1: 1	حَرُمَ الْعَمَلُ
u'حَرِمَ عند':Predicate, #1: 1	حَرُمَ عِنْدَ
u'حَرُمَ عِوَضٌ':Subject, #2: 2	أَحْرَمَ عِنْدَ
u'حَرَّمَ غير':Predicate, #1: 1	حَرُمَ الْعِوَضُ
u'حَرَّمَ غَيْرٌ':Predicate, #1: 1	حَرَّمَ غَيْرَ
u'حَرُمَ فرار':Subject, #1: 1	حَرَّمَ غَيْرَ
u'حَرُمَ فِرَارٌ':Subject, #1: 1	حَرُمَ الْفِرَارُ
u'حَرَّمَ فَرْجٌ':Predicate, #1: 1	حَرُمَ الْفِرَارُ
u'حَرُمَ فَرْجٌ':Subject, #2: 2	حَرَّمَ الْفَرْجَ
u'حِرْمٌ فَرْعٌ':Added, #1: 1	حَرُمَ فَرْجُ
u'حَرَّمَ فلان':Predicate, #1: 1	حِرْمَانِ الْفَرْعِ
u'حَرَّمَ فلان':Subject, #27: 27	حَرَّمَ مَكَّةَ
u'حَرَّمَ فَوَاحِشُ':Predicate, #1: 1	حَرَّمَ الشَّافِعِيُّ
u'حِرْمٌ قَاتِلٌ':Added, #7: 7	حَرَّمَ الْفَوَاحِشَ
u'حَرَّمَ قَالٌ':Predicate, #3: 3	حِرْمَانِ الْقَاتِلِ
u'حَرُمَ قَالٌ':Predicate, #1: 1	حَرَّمَ قَالَ
u'حَرُمَ قَبُولٌ':Subject, #2: 2	حَرُمَ قَالَ
u'حَرُمَ قَبُولٌ':Subject, #1: 1	حَرُمَ الْقَبُولُ
u'حَرُمَ قَبُولٌ':Subject, #1: 1	حَرُمَ قَبُولُهُ
u'حَرُمَ قتال':Subject, #3: 3	حَرُمَ قَبُولُ
u'حَرُمَ قِتَالٌ':Subject, #3: 3	حَرُمَ قِتَالُهُ
u'حَرُمَ قتل':Subject, #3: 3	حَرُمَ قِتَالُهُ
u'حَرُمَ قَتْلٌ':Subject, #10: 10	حَرُمَ قَتْلُهُ
u'حَرُمَ قتل':Subject, #10: 10	حَرُمَ قَتْلُهُ
u'حَرُمَ قَتْلٌ':Subject, #2: 2	حَرُمَ قَتْلُ
u'حَرُمَ قذف':Subject, #2: 2	حَرُمَ قَتْلُ
u'حَرُمَ قَذْفٌ':Subject, #1: 1	حَرُمَ قَذْفُهُ
u'حَرُمَ قسمة':Subject, #1: 1	حَرُمَ قَذْفُهُ
u'حَرُمَ قِسْمَةٌ':Subject, #1: 1	حَرُمَ قِسْمَةُ
u'حَرُمَ قَطْعٌ':Subject, #1: 1	حَرُمَ قِسْمَةُ
u'حَرُمَ قَطْعٌ':Subject, #1: 1	حَرُمَ قَطْعُهُ
u'حَرَّمَ قُعُودٌ':Predicate, #2: 2	حَرُمَ الْقَطْعُ
u'حَرَّمَ قَلِيلٌ':Predicate, #1: 1	حَرَّمَ الْقُعُودَ
u'حَرُمَ قَلِيلٌ':Subject, #1: 1	حَرَّمَ الْقَلِيلَ
u'حَرُمَ كذب':Subject, #1: 1	حَرُمَ قَلِيلُهُ
u'حَرُمَ كَذِبٌ':Subject, #2: 2	حَرُمَ الْكَذِبُ
u'حَرَمٌ كعبة':Added, #2: 2	حَرُمَ الْكَذِبُ
u'حَرَمٌ كَعْبَةٌ':Added, #1: 1	حَرَمَ الْكَعْبَةِ
u'حَرُمَ كَلاَمٌ':Subject, #1: 1	حَرَمَ الْكَعْبَةِ
u'حَرَّمَ كَلْبٌ':Predicate, #2: 2	حَرُمَ الْكَلَامُ
u'حَرُمَ لبس':Subject, #2: 2	حَرَّمَ الْكَلْبَ
u'حَرُمَ لُبْسٌ':Subject, #1: 1	حَرُمَ اللُّبْسُ
u'حَرُمَ لبس':Subject, #1: 1	حَرُمَ اللُّبْسُ
u'حَرُمَ لُبْسٌ':Subject, #1: 1	حَرُمَ لُبْسُ
u'حَرُمَ لبس':Subject, #1: 1	حَرُمَ لُبْسُ
u'حَرُمَ لُبْسٌ':Subject, #1: 1	حَرُمَ لُبْسُهُ
u'حَرُمَ لَبَنٌ':Subject, #1: 1	حَرُمَ لُبْسُهُ
u'حَرَّمَ لَحْمٌ':Predicate, #1: 1	حَرُمَ لَبَنٌ
u'حَرَّمَ لَحْمٌ':Predicate, #1: 1	حَرَّمَ اللَّحْمَ
u'حَرَّمَ لُحُومٌ':Predicate, #2: 2	حَرَّمَ لَحْمَ
u'حَرِمَ لَيْلٌ':Predicate, #5: 5	حَرَّمَ لُحُومَ
u'حَرُمَ مَالٌ':Subject, #1: 1	أَحْرَمَ لَيْلَةَ
u'حَرُمَ مُجَاوَزَةٌ':Subject, #1: 1	حَرُمَ مَالُهُ
u'حَرَمٌ مَدِينٌ':Added, #1: 1	حَرُمَ مُجَاوَزَةُ
u'حَرَمٌ مَدِينٌ':Added, #26: 26	حَرَمِ الْمَدِينَةِ
u'حَرَمٌ مَدِينٌ':Added, #3: 3	حَرَمَ الْمَدِينَةِ
u'حَرَمٌ مَدِينَةٌ':Added, #7: 7	حَرَمُ الْمَدِينَةِ
u'حَرَمٌ مَدِينَةٌ':Added, #26: 26	حَرَمِ الْمَدِينَةِ
u'حَرَمٌ مَدِينَةٌ':Added, #3: 3	حَرَمَ الْمَدِينَةِ
u'حَرُمَ مُرُورٌ':Subject, #7: 7	حَرَمُ الْمَدِينَةِ
u'حَرُمَ مَسٌّ':Subject, #2: 2	حَرُمَ الْمُرُورُ
u'حِرْمٌ مُسْتَحِقٌّ':Added, #2: 2	حَرُمَ مَسُّهُ
u'حَرَمٌ مَسْجِدٌ':Added, #1: 1	حِرْمَانِ مُسْتَحِقٍّ
u'حَرَمٌ مَطْلُوبٌ':Added, #1: 1	حَرَمَ الْمَسْجِدِ
u'حَرُمَ مُفاد':Subject, #1: 1	حَرَمَ الْمَطْلُوبِ
u'حَرُمَ مُفاداة':Subject, #1: 1	حَرُمَ مُفَادَاتُهُ
u'حَرُمَ مُكْثٌ':Subject, #1: 1	حَرُمَ مُفَادَاتُهُ
u'حَرُمَ مُكْثٌ':Subject, #1: 1	حَرُمَ مُكْثُ
u'حَرِمَ مَكْشُوفٌ':Predicate, #1: 1	حَرُمَ مُكْثُهُ
u'حَرُمَ مَنْعٌ':Subject, #1: 1	أَحْرَمَ مَكْشُوفَ
u'حَرُمَ مَنْعٌ':Subject, #2: 2	حَرُمَ مَنْعُهُ
u'حَرَّمَ مَيْتٌ':Predicate, #3: 3	حَرُمَ الْمَنْعُ
u'حَرَّمَ مَيْتَةٌ':Predicate, #3: 3	حَرَّمَ الْمَيْتَةَ
u'حِرْمٌ مِيرَاثٌ':Added, #3: 3	حَرَّمَ الْمَيْتَةَ
u'حَرَّمَ نَارٌ':Predicate, #3: 3	حِرْمَانِ الْمِيرَاثِ
u'حُرُمٌ نَاسٌ':Added, #1: 1	حَرَّمَ النَّارَ
u'حَرُمَ نَبْش':Subject, #1: 1	حُرُمِ النَّاسِ
u'حَرَّمَ نَبِيٌّ':Subject, #1: 1	حَرُمَ النَّبْشُ
u'حَرَّمَ نِساءٌ':Predicate, #6: 6	حَرَّمَ النَّبِيُّ
u'حَرَّمَ نَسَبٌ':Predicate, #1: 1	حَرَّمَ النِّسَاءَ
u'حَرَّمَ نَسَبٌ':Subject, #1: 1	حَرَّمَ النَّسَبَ
u'حَرَّمَ نَظَرٌ':Predicate, #1: 1	حَرَّمَ النَّسَبُ
u'حَرُمَ نَظَرٌ':Subject, #1: 1	حَرَّمَ نَظَرَ
u'حَرُمَ نَظَرٌ':Subject, #2: 2	حَرُمَ نَظَرُ
u'حَرُمَ نَظَرٌ':Subject, #3: 3	حَرُمَ نَظَرُهُ
u'حَرُمَ نَفْسٌ':Subject, #5: 5	حَرُمَ النَّظَرُ
u'حِرْمٌ نَفَقَةٌ':Added, #1: 1	حَرُمَ نَفْسُ
u'حَرُمَ نَفْيٌ':Subject, #3: 3	حِرْمَانِ النَّفَقَةِ
u'حَرُمَ نقل':Subject, #2: 2	حَرُمَ نَفْيُهُ
u'حَرُمَ نَقْلٌ':Subject, #3: 3	حَرُمَ نَقْلُ
u'حَرَّمَ نكاح':Predicate, #3: 3	حَرُمَ نَقْلُ
u'حَرَّمَ نِكَاحٌ':Predicate, #5: 5	حَرَّمَ نِكَاحَ
u'حَرُمَ نكاح':Subject, #5: 5	حَرَّمَ نِكَاحَ
u'حَرُمَ نِكَاحٌ':Subject, #4: 4	حَرُمَ النِّكَاحُ
u'حَرُمَ نكاح':Subject, #4: 4	حَرُمَ النِّكَاحُ
u'حَرُمَ نِكَاحٌ':Subject, #4: 4	حَرُمَ نِكَاحُهُ
u'حَرُمَ نَوْمٌ':Subject, #4: 4	حَرُمَ نِكَاحُهُ
u'حَرُمَ هجر':Subject, #1: 1	حَرُمَ النَّوْمُ
u'حَرُمَ هَجْرٌ':Subject, #1: 1	حَرُمَ هَجْرُهُ
u'حِرْمٌ وَارِثٌ':Added, #1: 1	حَرُمَ هَجْرُهُ
u'حَرِمَ وَتَرٌ':Predicate, #1: 1	حِرْمَانِ الْوَارِثِ
u'حَرِمَ وَجَبٌ':Predicate, #1: 1	أَحْرَمَ وَتَرَكَ
u'حَرُمَ وَجَبٌ':Predicate, #1: 1	أَحْرَمَ وَجَبَ
u'حَرِمَ وَراء':Predicate, #1: 1	حَرُمَ وَجَبَ
u'حَرَّمَ وَطْءٌ':Predicate, #4: 4	أَحْرَمَ وَرَاءَ
u'حَرُمَ وَطْءٌ':Subject, #2: 2	حَرَّمَ الْوَطْءَ
u'حَرُمَ وَطْءٌ':Subject, #1: 1	حَرُمَ وَطْءُ
u'حَرُمَ وَعْظٌ':Subject, #7: 7	حَرُمَ الْوَطْءُ
u'حَرَّمَ يَوْمٌ':Predicate, #1: 1	حَرُمَ وَعْظُهُ
u'حَرِمَ يَوْمٌ':Predicate, #1: 1	حَرَّمَ يَوْمَ
u'حَرَّ وِكاء':Predicate, #7: 7	أَحْرَمَ يَوْمَ
u'حَرِيمٌ آبارٌ':Added, #1: 1	حَرَّكَ الْوِكَاءَ
u'حَرِيمٌ أرْضٌ':Added, #1: 1	حَرِيمِ الآبَارِ
u'حَرِيمٌ أرْضٌ':Added, #1: 1	حَرِيمُ أَرْضِ
u'حَرِيمٌ أَمْلاكٌ':Added, #1: 1	حَرِيمُ الْأَرْضِ
u'حَرِيمٌ أَمْلاَكٌ':Added, #2: 2	حَرِيمِ الْأَمْلَاكِ
u'حَرِيمٌ أَوَّلُ':Added, #2: 2	حَرِيمِ الْأَمْلَاكِ
u'حَرِيمٌ بَلَدٌ':Added, #5: 5	حَرِيمِ الْأَوَّلِ
u'حَرِيمٌ بَلَدٌ':Added, #1: 1	حَرِيمَ الْبَلَدِ
u'حَرِيمٌ بِئْرٌ':Added, #2: 2	حَرِيمِ الْبَلَدِ
u'حَرِيمٌ بِئْرٌ':Added, #2: 2	حَرِيمُ بِئْرِ
u'حَرِيمٌ بِئْرٌ':Added, #3: 3	حَرِيمَ الْبِئْرِ
u'حَرِيمٌ بِئْرٌ':Added, #7: 7	حَرِيمُ الْبِئْرِ
u'حَرِيمٌ بَيْتٌ':Added, #8: 8	حَرِيمِ الْبِئْرِ
u'حَرِيمٌ جَوَامِعُ':Added, #2: 2	حَرِيمُ الْبَيْتِ
u'حَرِيمٌ دَارٌ':Added, #2: 2	حَرِيمُ الْجَوَامِعِ
u'حَرِيمٌ دَارٌ':Added, #1: 1	حَرِيمُ الدَّارِ
u'حَرِيمٌ سَقْيٌ':Added, #1: 1	حَرِيمِ الدَّارِ
u'حَرِيمٌ شَجَرٌ':Added, #1: 1	حَرِيمُ السَّقْيِ
u'حَرِيمٌ شَيْءٌ':Added, #1: 1	حَرِيمُ الشَّجَرِ
u'حَرِيمٌ صَاحِبٌ':Added, #1: 1	حَرِيمُ الشَّيْءِ
u'حَرِيمٌ عَامِرٌ':Added, #1: 1	حَرِيمُ صَاحِبِ
u'حَرِيمٌ عَقْدٌ':Added, #1: 1	حَرِيمَ الْعَامِرِ
u'حَرِيمٌ عَقْدٌ':Added, #1: 1	حَرِيمُ الْعَقْدِ
u'حَرِيمٌ عَقْدٌ':Added, #1: 1	حَرِيمِ الْعَقْدِ
u'حَرِيمٌ عِمَارَةٌ':Added, #3: 3	حَرِيمِ عَقْدٍ
u'حَرِيمٌ عين':Added, #1: 1	حَرِيمَ عِمَارَةٍ
u'حَرِيمٌ عَيْنٌ':Added, #6: 6	حَرِيمُ الْعَيْنِ
u'حَرِيمٌ عَيْن':Added, #6: 6	حَرِيمُ الْعَيْنِ
u'حَرِيمٌ عُيُونٌ':Added, #6: 6	حَرِيمُ الْعَيْنِ
u'حَرِيمٌ قَبْرٌ':Added, #1: 1	حَرِيمُ الْعُيُونِ
u'حَرِيمٌ قَرْيَةٌ':Added, #2: 2	حَرِيمِ الْقَبْرِ
u'حَرِيمٌ قَنَاةٌ':Added, #1: 1	حَرِيمِ الْقَرْيَةِ
u'حَرِيمٌ مَعْمُورٌ':Added, #1: 1	حَرِيمُ الْقَنَاةِ
u'حَرِيمٌ مَعْمُورٌ':Added, #1: 1	حَرِيمَ الْمَعْمُورِ
u'حَرِيمٌ مَعْمُورٌ':Added, #1: 1	حَرِيمُ الْمَعْمُورِ
u'حَرِيمٌ مِلْكٌ':Added, #2: 2	حَرِيمِ الْمَعْمُورِ
u'حَرِيمٌ مِلْكٌ':Added, #1: 1	حَرِيمِ الْمِلْكِ
u'حَرِيمٌ مِلْكٌ':Added, #1: 1	حَرِيمَ مِلْكِهِ
u'حَرِيمٌ مَمْنُوعٌ':Added, #1: 1	حَرِيمِ مِلْكِهِ
u'حَرِيمٌ نَاضِحٌ':Added, #1: 1	حَرِيمَ الْمَمْنُوعِ
u'حَرِيمٌ نَخْلٌ':Added, #1: 1	حَرِيمُ النَّاضِحِ
u'حَرِيمٌ نخلة':Added, #1: 1	حَرِيمِ النَّخْلِ
u'حَرِيمٌ نَخْلَةٌ':Added, #1: 1	حَرِيمِ نَخْلَةٍ
u'حَرِيمٌ نخلة':Added, #1: 1	حَرِيمِ نَخْلَةٍ
u'حَرِيمٌ نَخْلَةٌ':Added, #2: 2	حَرِيمِ النَّخْلَةِ
u'حَرِيمٌ نَهْرٌ':Added, #2: 2	حَرِيمِ النَّخْلَةِ
u'حَرِيمٌ نَهْرٌ':Added, #2: 2	حَرِيمَ النَّهْرِ
u'حَرِيمٌ نَهْرٌ':Added, #3: 3	حَرِيمُ النَّهْرِ
u'حَزَّ آخِرُ':Subject, #6: 6	حَرِيمِ النَّهْرِ
u'حَزَّ إِنْسانٌ':Subject, #1: 1	حَزَّ آخِرُ
u'حَزَّبَ أحْزَابٌ':Predicate, #1: 1	حَزَّ الْإِنْسَانُ
u'حَزَّبَ أحْزَابٌ':Predicate, #1: 1	حَزَّبَ الأَحْزَابَ
u'حَزَرَ كُفَّارٌ':Subject, #1: 1	حَزَّبَ الْأَحْزَابَ
u'حُزْنٌ أيتام':Added, #1: 1	حَزَرَ الْكُفّارُ
u'حَزِنَ رَسُولٌ':Predicate, #1: 1	حُزْنَ الْأَيْتَامِ
u'حَزِنَ رَسُولٌ':Subject, #1: 1	أَحْزَنَ رَسُولَ
u'حُزْنٌ رَسُولٌ':Added, #2: 2	حَزِنَ رَسُولُ
u'حُزْنٌ رَسُولٌ':Added, #1: 1	حُزْنَ رَسُولِ
u'حُزْنٌ صِدِّيقٌ':Added, #2: 2	حُزْنُ الرّسُولِ
u'حَزِنَ نَاسٌ':Subject, #1: 1	حُزْنَ الصِّدِّيقِ
u'حساب أَطْفَالٌ':Added, #1: 1	حَزِنَ النَّاسُ
u'حِسَابٌ أَطْفَالٌ':Added, #1: 1	حِسَابِ الْأَطْفَالِ
u'حساب أعاجم':Added, #1: 1	حِسَابِ الْأَطْفَالِ
u'حِسَابٌ أعاجم':Added, #1: 1	حِسَابِ الْأَعَاجِمِ
u'حساب أَغْنِيَاء':Added, #1: 1	حِسَابِ الْأَعَاجِمِ
u'حِسَابٌ أَغْنِيَاء':Added, #1: 1	حِسَابَ الْأَغْنِيَاءِ
u'حساب أهْلٌ':Added, #1: 1	حِسَابَ الْأَغْنِيَاءِ
u'حِسَابٌ أهْلٌ':Added, #1: 1	حِسَابَ أَهْلِ
u'حساب أهْلٌ':Added, #1: 1	حِسَابَ أَهْلِ
u'حِسَابٌ أهْلٌ':Added, #2: 2	حِسَابِ أَهْلِ
u'حساب ثَلاثَةٌ':Added, #2: 2	حِسَابِ أَهْلِ
u'حساب ثَلاثَةٌ':Added, #1: 1	حِسَابَ ثَلاَثَةِ
u'حِسَابٌ ثَلاثَةٌ':Added, #1: 1	حِسَابِ ثَلَاثَةِ
u'حِسَابٌ ثَلاثَةٌ':Added, #1: 1	حِسَابَ ثَلاَثَةِ
u'حساب جُمَّلٌ':Added, #1: 1	حِسَابِ ثَلَاثَةِ
u'حِسَابٌ جُمَّلٌ':Added, #1: 1	حِسَابِ الْجُمَّلِ
u'حساب خلائق':Added, #1: 1	حِسَابِ الْجُمَّلِ
u'حِسَابٌ خلائق':Added, #1: 1	حِسَابِ الْخَلَائِقِ
u'حساب خَلائِقُ':Added, #1: 1	حِسَابِ الْخَلَائِقِ
u'حِسَابٌ خَلائِقُ':Added, #1: 1	حِسَابِ الْخَلَائِقِ
u'حساب دِيَةٌ':Added, #1: 1	حِسَابِ الْخَلَائِقِ
u'حِسَابٌ دِيَةٌ':Added, #1: 1	حِسَابِ الدِّيَةِ
u'حساب سَنَةٌ':Added, #1: 1	حِسَابِ الدِّيَةِ
u'حِسَابٌ سَنَةٌ':Added, #1: 1	حِسَابِ سَنَةِ
u'حساب سَنَةٌ':Added, #1: 1	حِسَابِ سَنَةِ
u'حِسَابٌ سَنَةٌ':Added, #2: 2	حِسَابِ السَّنَةِ
u'حساب سَوادٌ':Added, #2: 2	حِسَابِ السَّنَةِ
u'حِسَابٌ سَوادٌ':Added, #1: 1	حِسَابَ السَّوَادِ
u'حساب شمس':Added, #1: 1	حِسَابَ السَّوَادِ
u'حِسَابٌ شمس':Added, #1: 1	حِسَابِ الشَّمْسِ
u'حساب شَمْسٌ':Added, #1: 1	حِسَابِ الشَّمْسِ
u'حِسَابٌ شَمْسٌ':Added, #1: 1	حِسَابِ الشَّمْسِ
u'حساب شَهْرٌ':Added, #1: 1	حِسَابِ الشَّمْسِ
u'حِسَابٌ شَهْرٌ':Added, #1: 1	حِسَابِ الشَّهْرِ
u'حساب ضَرْبٌ':Added, #1: 1	حِسَابِ الشَّهْرِ
u'حِسَابٌ ضَرْبٌ':Added, #1: 1	حِسَابُ الضَّرْبِ
u'حساب ضَرْبٌ':Added, #1: 1	حِسَابُ الضَّرْبِ
u'حِسَابٌ ضَرْبٌ':Added, #2: 2	حِسَابَ الضَّرْبِ
u'حساب طهر':Added, #2: 2	حِسَابَ الضَّرْبِ
u'حِسَابٌ طهر':Added, #1: 1	حِسَابِ الطُّهْرِ
u'حساب طُهْرٌ':Added, #1: 1	حِسَابِ الطُّهْرِ
u'حِسَابٌ طُهْرٌ':Added, #1: 1	حِسَابِ الطُّهْرِ
u'حساب عَرَبٌ':Added, #1: 1	حِسَابِ الطُّهْرِ
u'حِسَابٌ عَرَبٌ':Added, #1: 1	حِسَابَ الْعَرَبِ
u'حساب فَرَائِضُ':Added, #1: 1	حِسَابَ الْعَرَبِ
u'حِسَابٌ فَرَائِضُ':Added, #1: 1	حِسَابُ الْفَرَائِضِ
u'حساب فَرَائِضُ':Added, #1: 1	حِسَابُ الْفَرَائِضِ
u'حِسَابٌ فَرَائِضُ':Added, #2: 2	حِسَابِ الْفَرَائِضِ
u'حساب فُلاَنٌ':Added, #2: 2	حِسَابِ الْفَرَائِضِ
u'حِسَابٌ فُلاَنٌ':Added, #1: 1	حِسَابِ فُلَانٍ
u'حساب قمر':Added, #1: 1	حِسَابِ فُلَانٍ
u'حِسَابٌ قمر':Added, #1: 1	حِسَابُ الْقَمَرِ
u'حساب قَمَرٌ':Added, #1: 1	حِسَابُ الْقَمَرِ
u'حِسَابٌ قَمَرٌ':Added, #1: 1	حِسَابُ الْقَمَرِ
u'حساب كِرَاءٌ':Added, #1: 1	حِسَابُ الْقَمَرِ
u'حِسَابٌ كِرَاءٌ':Added, #1: 1	حِسَابِ الْكِرَاءِ
u'حساب مَسَائِلُ':Added, #1: 1	حِسَابِ الْكِرَاءِ
u'حِسَابٌ مَسَائِلُ':Added, #1: 1	حِسَابِ الْمَسَائِلِ
u'حساب مَسَائِلُ':Added, #1: 1	حِسَابِ الْمَسَائِلِ
u'حِسَابٌ مَسَائِلُ':Added, #2: 2	حِسَابِ مَسَائِلِ
u'حساب مَنَازِلُ':Added, #2: 2	حِسَابِ مَسَائِلِ
u'حِسَابٌ مَنَازِلُ':Added, #2: 2	حِسَابِ مَنَازِلِ
u'حساب مُنَجِّمٌ':Added, #2: 2	حِسَابِ مَنَازِلِ
u'حِسَابٌ مُنَجِّمٌ':Added, #1: 1	حِسَابِ مُنَجِّمٍ
u'حساب مَنْفَعَةٌ':Added, #1: 1	حِسَابِ مُنَجِّمٍ
u'حِسَابٌ مَنْفَعَةٌ':Added, #1: 1	حِسَابِ الْمَنْفَعَةِ
u'حساب نُجُومٌ':Added, #1: 1	حِسَابِ الْمَنْفَعَةِ
u'حِسَابٌ نُجُومٌ':Added, #1: 1	حِسَابِ النُّجُومِ
u'حساب نِسْبَةٌ':Added, #1: 1	حِسَابِ النُّجُومِ
u'حِسَابٌ نِسْبَةٌ':Added, #2: 2	حِسَابِ النِّسْبَةِ
u'حساب نَفَقَةٌ':Added, #2: 2	حِسَابِ النِّسْبَةِ
u'حِسَابٌ نَفَقَةٌ':Added, #1: 1	حِسَابُ النَّفَقَاتِ
u'حساب وَصِيٌّ':Added, #1: 1	حِسَابُ النَّفَقَاتِ
u'حِسَابٌ وَصِيٌّ':Added, #1: 1	حِسَابُ الْوَصِيَّةِ
u'حساب وَصِيٌّ':Added, #1: 1	حِسَابُ الْوَصِيَّةِ
u'حِسَابٌ وَصِيٌّ':Added, #1: 1	حِسَابُ الْوَصِيَّتَيْنِ
u'حساب وَصِيَّةٌ':Added, #1: 1	حِسَابُ الْوَصِيَّتَيْنِ
u'حِسَابٌ وَصِيَّةٌ':Added, #1: 1	حِسَابُ الْوَصِيَّةِ
u'حساب وَلاَءٌ':Added, #1: 1	حِسَابُ الْوَصِيَّةِ
u'حِسَابٌ وَلاَءٌ':Added, #2: 2	حِسَابِ الْوَلَاءِ
u'حَسَا زَيْدٌ':Subject, #2: 2	حِسَابِ الْوَلَاءِ
u'حَسَّ إمَامٌ':Subject, #1: 1	حَسَا زَيْدٌ
u'حَسَبٌ اِجْتِهَادٌ':Added, #1: 1	أَحَسَّ الْإِمَامُ
u'حَسَبٌ أَجْنَاسٌ':Added, #1: 1	حَسَبِ اجْتِهَادِهِ
u'حَسَبٌ أَحْوالٌ':Added, #1: 1	حَسَبِ أَجْنَاسِ
u'حَسَبٌ أحْوَالٌ':Added, #1: 1	حَسَبِ أَحْوَالِ
u'حَسَبٌ أَحْوالٌ':Added, #1: 1	حَسَبِ أَحْوَالِ
u'حَسَبٌ أحْوَالٌ':Added, #1: 1	حَسَبِ الْأَحْوَالِ
u'حَسَبٌ اِخْتِلاَفٌ':Added, #1: 1	حَسَبِ الْأَحْوَالِ
u'حَسَبٌ اِخْتِيَارٌ':Added, #7: 7	حَسَبِ اخْتِلَافِ
u'حَسَبٌ أَدَاءٌ':Added, #1: 1	حَسَبِ اخْتِيَارِ
u'حَسَبٌ أَزْمِنَةٌ':Added, #3: 3	حَسَبِ الْأَدَاءِ
u'حَسَبٌ اِشْتِراطٌ':Added, #1: 1	حَسَبِ أَزْمِنَةِ
u'حَسَبٌ إِطْلاقٌ':Added, #1: 1	حَسَبَ اشْتِرَاطِهِ
u'حَسَبٌ اِعْتِقادٌ':Added, #1: 1	حَسَبِ إطْلَاقِ
u'حَسَبٌ اِقْتِضَاءٌ':Added, #2: 2	حَسَبِ اعْتِقَادِهِ
u'حَسَبٌ إقْرَارٌ':Added, #1: 1	حَسَبِ اقْتِضَاءِ
u'حَسَبٌ الْمَرْءُ':Added, #1: 1	حَسَبَ إقْرَارِهِ
u'حَسَبٌ أَمْرٌ':Added, #2: 2	حَسَبُ الْمَرْءِ
u'حَسِبَ اِمْرُؤٌ':Subject, #1: 1	حَسَبِ الْأَمْرِ
u'حَسَبٌ إِمْكانٌ':Added, #1: 1	حَسِبَ امْرُؤٌ
u'حَسَبٌ إِمْكانٌ':Added, #2: 2	حَسَبُ الْإِمْكَانِ
u'حَسَبٌ إِمْكانٌ':Added, #2: 2	حَسَبِ الْإِمْكَانِ
u'حَسَبٌ إِمْكانٌ':Added, #4: 4	حَسَبَ إمْكَانِهِ
u'حُسْبَانٌ أَرْبَعُ':Added, #9: 9	حَسَبَ الْإِمْكَانِ
u'حُسْبَانٌ جَمِيع':Added, #1: 1	حُسْبَانَ الْأَرْبَعِ
u'حُسْبَانٌ رُكوعٌ':Added, #1: 1	حُسْبَانَ الْجَمِيعِ
u'حُسْبَانٌ صَلاَةٌ':Added, #1: 1	حُسْبَانِ رُكُوعِهِ
u'حَسَبٌ اِنْقِسَامٌ':Added, #1: 1	حُسْبَانِ صَلَاتِهِ
u'حَسَبٌ بَقِيَّةٌ':Added, #2: 2	حَسَبِ انْقِسَامِ
u'حَسَبٌ بُلْدانٌ':Added, #2: 2	حَسَبَ بَقِيَّةِ
u'حِسْبَةٌ أَدَاءٌ':Added, #1: 1	حَسَبِ الْبُلْدَانِ
u'حِسْبَةٌ سَتْرٌ':Added, #1: 1	حِسْبَةَ أَدَاءِ
u'حِسْبَةٌ سَتْرٌ':Added, #1: 1	حِسْبَةَ السَّتْرِ
u'حِسْبَةٌ سُوقٌ':Added, #1: 1	حِسْبَةُ السَّتْرِ
u'حِسْبَةٌ عتق':Added, #1: 1	حِسْبَةِ السُّوقِ
u'حِسْبَةٌ عِتْقٌ':Added, #1: 1	حِسْبَةِ عِتْقِ
u'حَسَبٌ تَأْثِيرٌ':Added, #1: 1	حِسْبَةِ عِتْقِ
u'حَسَبٌ تَآلُفٌ':Added, #1: 1	حَسَبَ التَّأْثِيرِ
u'حَسَبٌ تَجَدُّدٌ':Added, #1: 1	حَسَبِ التَّآلُفِ
u'حَسَبٌ تَحَقُّقٌ':Added, #1: 1	حَسَبِ تَجَدُّدِ
u'حَسَبٌ تَرْتِيبٌ':Added, #1: 1	حَسَبَ تَحَقُّقِهِ
u'حَسَبٌ تَرْكٌ':Added, #2: 2	حَسَبِ تَرْتِيبِ
u'حَسَبٌ تَشَاكُلٌ':Added, #1: 1	حَسَبِ تَرْكِهِ
u'حَسَبٌ تَفَاضُلٌ':Added, #1: 1	حَسَبِ التّشَاكُلِ
u'حَسَبٌ تَفاوُت':Added, #1: 1	حَسَبِ تَفَاضُلِ
u'حَسَبٌ تَفْصِيلٌ':Added, #3: 3	حَسَبِ التَّفَاوُتِ
u'حَسَبٌ ثُبُوتٌ':Added, #1: 1	حَسَبِ التَّفْصِيلِ
u'حَسَبٌ ثُبُوتٌ':Added, #1: 1	حَسَبَ ثُبُوتِ
u'حَسَبَ ثَمَنٌ':Predicate, #2: 2	حَسَبِ ثُبُوتِ
u'حَسَبٌ جِنَايَةٌ':Added, #1: 1	حَسَبَ الثَّمَنَ
u'حَسَبٌ جَوَابٌ':Added, #3: 3	حَسَبِ الْجِنَايَةِ
u'حَسَبٌ جَوَابٌ':Added, #2: 2	حَسَبِ الْجَوَابِ
u'حَسَبٌ حاجَةٌ':Added, #2: 2	حَسَبِ جَوَابِهِ
u'حَسَبٌ حالٌ':Added, #1: 1	حَسَبَ الْحَاجَةِ
u'حَسَبٌ حالٌ':Added, #1: 1	حَسَبِ الْحَالِ
u'حَسَبٌ حالٌ':Added, #23: 23	حَسَبِ حَالِهِ
u'حَسَبٌ حُدوثٌ':Added, #2: 2	حَسَبَ حَالِهِ
u'حَسَبٌ حُدوثٌ':Added, #1: 1	حَسَبَ حُدُوثِ
u'حَسَبٌ حُرْمَةٌ':Added, #8: 8	حَسَبِ حُدُوثِ
u'حَسَبٌ خَالِصٌ':Added, #1: 1	حَسَبِ حُرْمَةِ
u'حَسَبٌ دَلالَةٌ':Added, #1: 1	حَسَبَ الْخَالِصِ
u'حَسَبٌ دَوامٌ':Added, #1: 1	حَسَبِ دَلَالَةِ
u'حَسَبٌ دِينٌ':Added, #1: 1	حَسَبَ دَوَامِهِ
u'حَسَبٌ زَريعَةٌ':Added, #2: 2	حَسَبِ دِينِهِ
u'حَسَبٌ سَنَةٌ':Added, #2: 2	حَسَبِ الزَّرِيعَةِ
u'حَسَبٌ سُؤَالٌ':Added, #1: 1	حَسَبَ السَّنَةِ
u'حَسِبَ شافِعِيّ':Subject, #1: 1	حَسَبِ السُّؤَالِ
u'حَسَبٌ شُهُودٌ':Added, #1: 1	حَسِبَ الشَّافِعِيُّ
u'حَسَبٌ ضَلاَلَةٌ':Added, #1: 1	حَسَبِ شُهُودِ
u'حَسَبٌ ضَمٌّ':Added, #1: 1	حَسَبِ ضَلَالَتِهِ
u'حَسَبٌ طَاقَةٌ':Added, #1: 1	حَسَبِ ضَمِّ
u'حَسَبٌ طَاقَةٌ':Added, #1: 1	حَسَبَ الطَّاقَةِ
u'حَسَبٌ طَاقَةٌ':Added, #1: 1	حَسَبِ طَاقَتِهِ
u'حَسَبٌ طَاقَةٌ':Added, #3: 3	حَسَبِ الطَّاقَةِ
u'حَسَبٌ ظَنٌّ':Added, #3: 3	حَسَبَ طَاقَتِهِ
u'حَسَبٌ ظَنٌّ':Added, #1: 1	حَسَبِ الظَّنِّ
u'حَسَبٌ عَادَةٌ':Added, #1: 1	حَسَبِ ظَنِّهِ
u'حَسَبٌ عَادَةٌ':Added, #1: 1	حَسَبَ الْعَادَةِ
u'حَسَبٌ عَادَةٌ':Added, #1: 1	حَسَبِ عَادَةِ
u'حَسَبٌ عَادَةٌ':Added, #1: 1	حَسَبِ عَادَتِهِ
u'حَسَبٌ عرف':Added, #4: 4	حَسَبِ الْعَادَةِ
u'حَسَبٌ عُرْفٌ':Added, #1: 1	حَسَبِ عُرْفِ
u'حَسَبٌ عرف':Added, #1: 1	حَسَبِ عُرْفِ
u'حَسَبٌ عُرْفٌ':Added, #1: 1	حَسَبِ عُرْفِهِ
u'حَسَبٌ عَمَلٌ':Added, #1: 1	حَسَبِ عُرْفِهِ
u'حَسِبَ فلان':Subject, #2: 2	حَسَبِ الْعَمَلِ
u'حَسَبٌ قَدْرٌ':Added, #1: 1	حَسِبَ الشَّافِعِيُّ
u'حَسَبٌ قدرة':Added, #1: 1	حَسَبَ قَدْرِ
u'حَسَبٌ قُدْرَةٌ':Added, #1: 1	حَسَبِ قُدْرَتِهِ
u'حَسَبٌ قسمة':Added, #1: 1	حَسَبِ قُدْرَتِهِ
u'حَسَبٌ قِسْمَةٌ':Added, #1: 1	حَسَبِ الْقِسْمَةِ
u'حَسَبٌ قِيَمٌ':Added, #1: 1	حَسَبِ الْقِسْمَةِ
u'حَسِبَ قِيمَةٌ':Predicate, #2: 2	حَسَبِ قِيَمِ
u'حَسَبٌ كَثْرَةٌ':Added, #1: 1	حَسِبَ قِيمَةَ
u'حَسَبٌ لُزُومٌ':Added, #1: 1	حَسَبِ كَثْرَةِ
u'حَسَبٌ مُجَاوَرَةٌ':Added, #1: 1	حَسَبِ لُزُومِهِ
u'حَسَبٌ مَرَاتِبُ':Added, #1: 1	حَسَبِ الْمُجَاوَرَةِ
u'حَسَبٌ مراد':Added, #1: 1	حَسَبِ مَرَاتِبِ
u'حَسَبٌ مُرَادٌ':Added, #1: 1	حَسَبِ الْمُرَادِ
u'حَسَبٌ مَشِيئَةٌ':Added, #1: 1	حَسَبِ الْمُرَادِ
u'حَسَبٌ مَصَالِحُ':Added, #2: 2	حَسَبِ مَشِيئَتِهِ
u'حَسَبٌ مَصْلَحَةٌ':Added, #1: 1	حَسَبِ الْمَصَالِحِ
u'حَسَبٌ مِيرَاثٌ':Added, #1: 1	حَسَبِ الْمَصْلَحَةِ
u'حَسَبٌ نشاط':Added, #3: 3	حَسَبِ الْمِيرَاثِ
u'حَسَبٌ نَشَاطٌ':Added, #1: 1	حَسَبِ النَّشَاطِ
u'حَسَبٌ نَظَرٌ':Added, #1: 1	حَسَبِ النَّشَاطِ
u'حَسَبٌ هَفْوَةٌ':Added, #1: 1	حَسَبِ نَظَرِ
u'حَسَبٌ وِفَاقٌ':Added, #1: 1	حَسَبِ الْهَفْوَةِ
u'حَسَبٌ وُقُوعٌ':Added, #1: 1	حَسَبِ الْوِفَاقِ
u'حَسَبٌ يسار':Added, #1: 1	حَسَبِ وُقُوعِ
u'حَسَبٌ يَسَارٌ':Added, #1: 1	حَسَبَ الْيَسَارِ
u'حَسَدَ إبْلِيسُ':Predicate, #1: 1	حَسَبَ الْيَسَارِ
u'حَسَدَ إبْلِيسُ':Subject, #1: 1	حَسَدَ إبْلِيسَ
u'حسد اِبْنٌ':Added, #1: 1	حَسَدَ إبْلِيسُ
u'حَسَدٌ اِبْنٌ':Added, #1: 1	حَسَدَ ابْنِ
u'حسد إِخْوَةٌ':Added, #1: 1	حَسَدَ ابْنِ
u'حَسَدٌ إِخْوَةٌ':Added, #1: 1	حَسَدَ الْإِخْوَةِ
u'حسد نَاسٌ':Added, #1: 1	حَسَدَ الْإِخْوَةِ
u'حَسَدٌ نَاسٌ':Added, #1: 1	حَسَدُ النَّاسِ
u'حَسَرَ إِزَارٌ':Predicate, #1: 1	حَسَدُ النَّاسِ
u'حَسَرَ ضِيقٌ':Subject, #2: 2	حَسَرَ الإِزَارَ
u'حَسَرَ عِمَامَةٌ':Predicate, #1: 1	حَسَرَ ضِيقُ
u'حَسْمٌ بَابٌ':Added, #2: 2	حَسَرَ الْعِمَامَةَ
u'حَسْمٌ بَابٌ':Added, #1: 1	حَسْمِ بَابِ
u'حَسْمٌ تَعْلِيلٌ':Added, #2: 2	حَسْمَ بَابِ
u'حَسْمٌ سَبِيلٌ':Added, #1: 1	حَسْمِ التَّعْلِيلِ
u'حَسْمٌ سَبِيلٌ':Added, #1: 1	حَسْمُ سَبِيلِ
u'حَسَمَ عِرْقٌ':Predicate, #1: 1	حَسْمَ سَبِيلِهِ
u'حَسْمٌ فساد':Added, #1: 1	حَسَمَ الْعِرْقَ
u'حَسْمٌ فَسَادٌ':Added, #1: 1	حَسْمُ الْفَسَادِ
u'حَسْمٌ مَادَّةٌ':Added, #1: 1	حَسْمُ الْفَسَادِ
u'حَسَمَ نَبِيٌّ':Subject, #5: 5	حَسْمَ مَادَّةِ
u'حُسْنٌ أخْلاقٌ':Added, #2: 2	حَسَمَ النَّبِيُّ
u'حُسْنٌ أَخْلاَقٌ':Added, #1: 1	حُسْنِ الْأَخْلَاقِ
u'حُسْنٌ أدَب':Added, #1: 1	حُسْنِ الْأَخْلَاقِ
u'حُسْنٌ أدَب':Added, #1: 1	حُسْنُ أَدَبٍ
u'حُسْنٌ أدَب':Added, #1: 1	حُسْنُ الْأَدَبِ
u'حُسْنٌ أدَب':Added, #4: 4	حُسْنَ الْأَدَبِ
u'حَسَّ نَاسٌ':Subject, #4: 4	حُسْنِ الْأَدَبِ
u'حَسُنَ إِسْلامٌ':Subject, #1: 1	أَحَسَّ النَّاسُ
u'حَسُنَ إِسْلامٌ':Subject, #2: 2	حَسُنَ إِسْلاَمُ
u'حُسْنٌ إِسْلامٌ':Added, #8: 8	حَسُنَ إسْلَامُهُ
u'حُسْنٌ إِسْلامٌ':Added, #12: 12	حُسْنِ إسْلَامِ
u'حُسْنٌ إِسْلامٌ':Added, #1: 1	حُسْنِ إِسْلامِ
u'حُسْنٌ إِسْلامٌ':Added, #1: 1	حُسْنِ إسْلَامِهِ
u'حَسُنَ اِشْتِراطٌ':Subject, #2: 2	حُسْنُ الْإِسْلَامِ
u'حُسْنٌ اِشْتِراطٌ':Added, #1: 1	حَسُنَ اشْتِرَاطُ
u'حُسْنٌ أَشْيَاءٌ':Added, #1: 1	حُسْنُ اشْتِرَاطِ
u'حُسْنٌ إِصْغاءٌ':Added, #3: 3	حُسْنَ الْأَشْيَاءِ
u'حُسْنٌ أَصْوَاتٌ':Added, #1: 1	حُسْنِ الْإِصْغَاءِ
u'حُسْنٌ أَفْعَالٌ':Added, #1: 1	حُسْنُ أَصْوَاتٍ
u'حُسْنٌ إقْدَامٌ':Added, #1: 1	حُسْنُ الْأَفْعَالِ
u'حُسْنٌ أَمْرَد':Added, #1: 1	حُسْنُ إقْدَامٍ
u'حَسُنَ إِيجَابٌ':Subject, #1: 1	حُسْنُ الْأَمْرَدِ
u'حَسُنَ إيجَازٌ':Subject, #1: 1	حَسُنَ إيجَابُ
u'حُسْنٌ إِيدَاعٌ':Added, #1: 1	حَسُنَ إيجَازُهُ
u'حَسُنَ إيرَادٌ':Subject, #1: 1	حُسْنِ الْإِيدَاعِ
u'حُسْنٌ بِزَّةٌ':Added, #1: 1	حَسُنَ إيرَادُ
u'حُسْنٌ بِزَّةٌ':Added, #1: 1	حُسْنَ الْبِزَّةِ
u'حُسْنٌ بِضاعَةٌ':Added, #1: 1	حُسْنُ بِزَّتِهِ
u'حَسَّنَ بَعْضٌ':Subject, #1: 1	حُسْنِ بِضَاعَتِهِ
u'حُسْنٌ بَلاءٌ':Added, #1: 1	حَسَّنَ بَعْضُ
u'حُسْنٌ بَلاغَةٌ':Added, #1: 1	حُسْنَ بَلَاءٍ
u'حَسَّ نَبِيٌّ':Subject, #1: 1	حُسْنِ الْبَلَاغَةِ
u'حُسْنٌ تَأْخِيرٌ':Added, #1: 1	أَحَسَّ النَّبِيُّ
u'حُسْنٌ تَأْخِيرٌ':Added, #1: 1	حُسْنُ تَأْخِيرِ
u'حُسْنٌ تَحْرِيمٌ':Added, #1: 1	حُسْنِ تَأْخِيرِهِ
u'حُسْنٌ تَرْتِيبٌ':Added, #2: 2	حُسْنِ تَحْرِيمِ
u'حُسْنٌ تَشْبِيه':Added, #1: 1	حُسْنِ التَّرْتِيبِ
u'حُسْنٌ تَصَرُّفٌ':Added, #1: 1	حُسْنِ التّشْبِيهِ
u'حُسْنٌ تَعْبِيرٌ':Added, #3: 3	حُسْنُ التَّصَرُّفِ
u'حُسْنٌ تَقْديرٌ':Added, #1: 1	حُسْنِ تَعْبِيرِ
u'حُسْنٌ تَقْديرٌ':Added, #1: 1	حُسْنِ تَقْدِيرِ
u'حُسْنٌ تَكْليفٌ':Added, #2: 2	حُسْنِ التَّقْدِيرِ
u'حُسْنٌ تَوْفِيقٌ':Added, #1: 1	حُسْنُ التَّكْلِيفِ
u'حُسْنٌ تَوَكُّلٌ':Added, #1: 1	حُسْنِ التَّوْفِيقِ
u'حُسْنٌ ثِقَةٌ':Added, #2: 2	حُسْنَ التَّوَكُّلِ
u'حُسْنٌ ثِقَةٌ':Added, #1: 1	حُسْنُ الثِّقَةِ
u'حُسْنٌ ثَناءٌ':Added, #1: 1	حُسْنِ الثِّقَةِ
u'حُسْنٌ ثَناءٌ':Added, #1: 1	حُسْنُ الثَّنَاءِ
u'حُسْنٌ ثَوابٌ':Added, #1: 1	حُسْنِ الثَّنَاءِ
u'حُسْنٌ ثَوابٌ':Added, #1: 1	حُسْنِ ثَوَابِ
u'حُسْنٌ جَزَاءٌ':Added, #2: 2	حُسْنِ ثَوَابِهِ
u'حُسْنٌ جُسُومٌ':Added, #1: 1	حُسْنَ الْجَزَاءِ
u'حُسْنٌ جُسُومٌ':Added, #1: 1	حُسْنَ الْجُسُومِ
u'حَسُنَ جَوَابٌ':Subject, #1: 1	حُسْنِ الْجُسُومِ
u'حُسْنٌ جِوَارٌ':Added, #1: 1	حَسُنَ الْجَوَابُ
u'حُسْنٌ جِوَارٌ':Added, #1: 1	حُسْنِ الْجِوَارِ
u'حُسْنٌ حالٌ':Added, #2: 2	حُسْنُ الْجِوَارِ
u'حُسْنٌ حالٌ':Added, #1: 1	حُسْنَ حَالِهِ
u'حُسْنٌ حِجَامَةٌ':Added, #1: 1	حُسْنُ حَالِهِ
u'حَسَّنَ حَديثٌ':Predicate, #1: 1	حُسْنِ الْحِجَامَةِ
u'حُسْنٌ حَديثٌ':Added, #2: 2	حَسَّنَ الْحَدِيثَ
u'حَسُنَ حُسْنٌ':Predicate, #1: 1	حُسْنَ حَدِيثِهِ
u'حُسْنٌ حَسَنٌ':Added, #1: 1	حَسُنَ حُسْنَ
u'حُسْنٌ حَضَاَرةٌ':Added, #1: 1	حُسْنِ الْحَسَنِ
u'حَسُنَ حِلْمٌ':Subject, #1: 1	حُسْنُ الْحَضَارَةِ
u'حُسْنٌ حِيلَةٌ':Added, #1: 1	حَسُنَ الْحِلْمُ
u'حُسْنٌ خَطٌّ':Added, #1: 1	حُسْنِ حِيلَتِهِ
u'حَسُنَ خلق':Subject, #2: 2	حُسْنُ الْخَطِّ
u'حَسُنَ خُلُقٌ':Subject, #5: 5	حَسُنَ خُلُقُهُ
u'حَسُنَ خُلُق':Subject, #5: 5	حَسُنَ خُلُقُهُ
u'حُسْنٌ خلق':Added, #5: 5	حَسُنَ خُلُقُهُ
u'حُسْنٌ خُلُقٌ':Added, #16: 16	حُسْنُ الْخُلُقِ
u'حُسْنٌ خُلُق':Added, #16: 16	حُسْنُ الْخُلُقِ
u'حُسْنٌ خلق':Added, #16: 16	حُسْنُ الْخُلُقِ
u'حُسْنٌ خُلُقٌ':Added, #17: 17	حُسْنِ الْخُلُقِ
u'حُسْنٌ خُلُق':Added, #17: 17	حُسْنِ الْخُلُقِ
u'حُسْنٌ خلق':Added, #17: 17	حُسْنِ الْخُلُقِ
u'حُسْنٌ خَلْقٌ':Added, #1: 1	حُسْنِ الْخَلْقِ
u'حُسْنٌ خلق':Added, #1: 1	حُسْنِ الْخَلْقِ
u'حُسْنٌ خُلُقٌ':Added, #1: 1	حُسْنِ خُلُقِ
u'حُسْنٌ خُلُقٌ':Added, #1: 1	حُسْنُ خُلُقٍ
u'حُسْنٌ خُلُق':Added, #1: 1	حُسْنِ خُلُقِ
u'حُسْنٌ خُلُق':Added, #1: 1	حُسْنُ خُلُقٍ
u'حُسْنٌ خلق':Added, #1: 1	حُسْنِ خُلُقِ
u'حُسْنٌ خُلُقٌ':Added, #1: 1	حُسْنِ خُلُقِهِ
u'حُسْنٌ خُلُق':Added, #1: 1	حُسْنِ خُلُقِهِ
u'حُسْنٌ خلق':Added, #1: 1	حُسْنِ خُلُقِهِ
u'حُسْنٌ خُلُقٌ':Added, #2: 2	حُسْنَ الْخُلُقِ
u'حُسْنٌ خُلُق':Added, #2: 2	حُسْنَ الْخُلُقِ
u'حُسْنٌ دُعَاءٌ':Added, #2: 2	حُسْنَ الْخُلُقِ
u'حُسْنٌ رَأْيٌ':Added, #1: 1	حُسْنِ الدُّعَاءِ
u'حُسْنٌ رَأْيٌ':Added, #1: 1	حُسْنَ الرَّأْيِ
u'حُسْنٌ رِجَالٌ':Added, #2: 2	حُسْنِ رَأْيٍ
u'حَسَّنَ رُسُومٌ':Predicate, #1: 1	حُسْنُ الرِّجَالِ
u'حَسُنَ زَيْدٌ':Subject, #1: 1	حَسَّنَ رُسُومَ
u'حُسْنٌ سَمْتٌ':Added, #1: 1	حَسُنَ زَيْدٌ
u'حُسْنٌ سَمْتٌ':Added, #1: 1	حُسْنِ السَّمْتِ
u'حُسْنٌ سُؤَالٌ':Added, #1: 1	حُسْنُ سَمْتٍ
u'حُسْنٌ سِياقٌ':Added, #1: 1	حُسْنُ السُّؤَالِ
u'حُسْنٌ سِياقٌ':Added, #1: 1	حُسْنِ السِّيَاقِ
u'حُسْنٌ سَيْرٌ':Added, #1: 1	حُسْنِ سِيَاقِ
u'حُسْنٌ سَيْرٌ':Added, #1: 1	حُسْنُ السَّيْرِ
u'حُسْنٌ سيرَةٌ':Added, #1: 1	حُسْنُ سَيْرِ
u'حُسْنٌ شرب':Added, #1: 1	حُسْنِ السِّيرَةِ
u'حُسْنٌ شُرْبٌ':Added, #1: 1	حُسْنِ الشُّرْبِ
u'حُسْنٌ شَيْءٌ':Added, #1: 1	حُسْنِ الشُّرْبِ
u'حُسْنٌ شَيْءٌ':Added, #1: 1	حُسْنُ الشَّيْءِ
u'حُسْنٌ صبر':Added, #1: 1	حُسْنِ شَيْءٍ
u'حُسْنٌ صَبْرٌ':Added, #1: 1	حُسْنَ الصَّبْرِ
u'حُسْنٌ صحبة':Added, #1: 1	حُسْنَ الصَّبْرِ
u'حُسْنٌ صُحْبَةٌ':Added, #3: 3	حُسْنِ الصُّحْبَةِ
u'حُسْنٌ صدق':Added, #3: 3	حُسْنِ الصُّحْبَةِ
u'حُسْنٌ صِدْقٌ':Added, #3: 3	حُسْنَ الصِّدْقِ
u'حُسْنٌ صَلاَةٌ':Added, #3: 3	حُسْنَ الصِّدْقِ
u'حُسْنٌ صَلاَةٌ':Added, #1: 1	حُسْنُ الصَّلَاةِ
u'حُسْنٌ صَلاَةٌ':Added, #1: 1	حُسْنِ الصَّلَاةِ
u'حُسْنٌ صنعة':Added, #1: 1	حُسْنِ الصَّلاَةِ
u'حُسْنٌ صَنْعَةٌ':Added, #1: 1	حُسْنِ صَنْعَتِهِ
u'حُسْنٌ صَنِيعٌ':Added, #1: 1	حُسْنِ صَنْعَتِهِ
u'حُسْنٌ صَنِيعَةٌ':Added, #1: 1	حُسْنَ الصَّنِيعَةِ
u'حُسْنٌ صَوْتٌ':Added, #1: 1	حُسْنَ الصَّنِيعَةِ
u'حُسْنٌ صَوْتٌ':Added, #1: 1	حُسْنَ الصَّوْتِ
u'حُسْنٌ صَوْتٌ':Added, #1: 1	حُسْنُ الصّوْتِ
u'حُسْنٌ صَوْتٌ':Added, #1: 1	حُسْنَ صَوْتٍ
u'حُسْنٌ صُورَةٌ':Added, #3: 3	حُسْنُ الصَّوْتِ
u'حُسْنٌ صُورَةٌ':Added, #1: 1	حُسْنُ الصُّورَةِ
u'حُسْنٌ ضَبْطٌ':Added, #1: 1	حُسْنِ صُورَتِهِ
u'حُسْنٌ ضَبْطٌ':Added, #1: 1	حُسْن الضَّبْطِ
u'حُسْنٌ طَرِيقَةٌ':Added, #1: 1	حُسْنُ ضَبْطِهِ
u'حُسْنٌ طَرِيقَةٌ':Added, #1: 1	حُسْنُ طَرِيقَتِهِ
u'حُسْنٌ طَوِيَّةٌ':Added, #1: 1	حُسْنِ طَرِيقَتِهِ
u'حَسُنَ ظاهِرٌ':Subject, #1: 1	حُسْنِ الطَّوِيَّةِ
u'حَسُنَ ظَنٌّ':Subject, #1: 1	حَسُنَ ظَاهِرُهُ
u'حَسُنَ ظَنٌّ':Subject, #1: 1	حَسُنَ ظَنُّ
u'حُسْنٌ ظَنٌّ':Added, #4: 4	حَسُنَ ظَنُّهُ
u'حُسْنٌ ظَنٌّ':Added, #15: 15	حُسْنُ الظَّنِّ
u'حُسْنٌ ظَنٌّ':Added, #17: 17	حُسْنِ الظَّنِّ
u'حُسْنٌ ظَنٌّ':Added, #1: 1	حُسْنَ ظَنِّهِ
u'حُسْنٌ ظَنٌّ':Added, #2: 2	حُسْنَ ظَنٍّ
u'حُسْنٌ ظَنٌّ':Added, #2: 2	حُسْنِ ظَنِّ
u'حُسْنٌ عَاقِبٌ':Added, #6: 6	حُسْنَ الظَّنِّ
u'حُسْنٌ عَاقِبٌ':Added, #1: 1	حُسْنَ الْعَاقِبَةِ
u'حُسْنٌ عَاقِبَةٌ':Added, #2: 2	حُسْنِ الْعَاقِبَةِ
u'حُسْنٌ عَاقِبَةٌ':Added, #1: 1	حُسْنَ الْعَاقِبَةِ
u'حُسْنٌ عِبَادَةٌ':Added, #2: 2	حُسْنِ الْعَاقِبَةِ
u'حُسْنٌ عِبَادَةٌ':Added, #1: 1	حُسْنُ الْعِبَادَةِ
u'حُسْنٌ عِبَارَةٌ':Added, #4: 4	حُسْنِ الْعِبَادَةِ
u'حَسُنَ عَدٌّ':Subject, #1: 1	حُسْنُ عِبَارَةِ
u'حَسَّنَ عَدَمٌ':Predicate, #1: 1	حَسُنَ عَدُّ
u'حُسْنٌ عِشْرَةٌ':Added, #1: 1	حَسَّنَ عَدَمَ
u'حُسْنٌ عِشْرَةٌ':Added, #1: 1	حُسْنُ الْعِشْرَةِ
u'حُسْنٌ عقاب':Added, #3: 3	حُسْنِ الْعِشْرَةِ
u'حُسْنٌ عِقَابٌ':Added, #1: 1	حُسْنُ عِقَابِ
u'حَسُنَ علم':Subject, #1: 1	حُسْنُ عِقَابِ
u'حَسُنَ عِلْمٌ':Subject, #1: 1	حَسُنَ عِلْمُهُ
u'حَسُنَ عَمَلٌ':Subject, #1: 1	حَسُنَ عِلْمُهُ
u'حُسْنٌ عَمَلٌ':Added, #1: 1	حَسُنَ عَمَلُهُ
u'حُسْنٌ عَمَلٌ':Added, #1: 1	حُسْنِ الْعَمَلِ
u'حُسْنٌ فَطِنٌ':Added, #1: 1	حُسْنَ عَمَلِهِ
u'حُسْنٌ فطنة':Added, #1: 1	حُسْنُ الْفَطِنَةِ
u'حُسْنٌ فعال':Added, #1: 1	حُسْنُ الْفَطِنَةِ
u'حُسْنٌ فِعَالٌ':Added, #1: 1	حُسْنِ الْفِعَالِ
u'حُسْنٌ فعال':Added, #1: 1	حُسْنِ الْفِعَالِ
u'حُسْنٌ فِعَالٌ':Added, #1: 1	حُسْنُ فِعَالِهِ
u'حُسْنٌ فِعْلٌ':Added, #1: 1	حُسْنُ فِعَالِهِ
u'حُسْنٌ فِعْلٌ':Added, #2: 2	حُسْنُ الْفِعْلِ
u'حُسْنٌ فِقْهٌ':Added, #2: 2	حُسْنُ فِعْلٍ
u'حَسَّنَ فلان':Subject, #1: 1	حُسْنِ فِقْهِ
u'حُسْنٌ فَهْمٌ':Added, #1: 1	حَسَّنَ التِّرْمِذِيُّ
u'حُسْنٌ فَهْمٌ':Added, #1: 1	حُسْنُ فَهْمٍ
u'حُسْنٌ قِرَاءةٌ':Added, #1: 1	حُسْنِ فَهْمِهِ
u'حُسْنٌ قِرَاءةٌ':Added, #1: 1	حُسْنِ قِرَاءَةِ
u'حُسْنٌ قِرَاءةٌ':Added, #1: 1	حُسْنَ قِرَاءَتِهِ
u'حُسْنٌ قَرْضٌ':Added, #1: 1	حُسْنِ قِرَاءَتِهِ
u'حُسْنٌ قَصْدٌ':Added, #1: 1	حُسْنِ الْقَرْضِ
u'حُسْنٌ قَصْدٌ':Added, #1: 1	حُسْنَ الْقَصْدِ
u'حَسَّنَ قول':Predicate, #1: 1	حُسْنِ الْقَصْدِ
u'حَسَّنَ قَوْلٌ':Predicate, #1: 1	حَسَّنَ قَوْلَ
u'حُسْنٌ قول':Added, #1: 1	حَسَّنَ قَوْلَ
u'حُسْنٌ قَوْلٌ':Added, #1: 1	حُسْنِ الْقَوْلِ
u'حُسْنٌ قَوْلٌ':Added, #1: 1	حُسْنِ الْقَوْلِ
u'حَسَّنَ كَلاَمٌ':Predicate, #1: 1	حُسْنُ قَوْلٍ
u'حُسْنٌ كَلاَمٌ':Added, #1: 1	حَسَّنَ كَلَامَ
u'حُسْنٌ لِبَاسٌ':Added, #1: 1	حُسْنَ الْكَلَامِ
u'حُسْنٌ لَفْظٌ':Added, #1: 1	حُسْنُ اللِّبَاسِ
u'حُسْنٌ لِقَاءٌ':Added, #1: 1	حُسْنِ اللّفْظِ
u'حُسْنٌ مَآبٌ':Added, #1: 1	حُسْنُ اللِّقَاءِ
u'حُسْنٌ مَأْمُورٌ':Added, #1: 1	حُسْنُ الْمَآبِ
u'حُسْنٌ مَأْمُورٌ':Added, #1: 1	حُسْنُ الْمَأْمُورِ
u'حُسْنٌ مَأْمُورٌ':Added, #1: 1	حُسْنِ الْمَأْمُورِ
u'حَسُنَ مَتْنٌ':Subject, #4: 4	حُسْنَ الْمَأْمُورِ
u'حُسْنٌ مُجَامَعَةٌ':Added, #1: 1	حَسُنَ الْمَتْنُ
u'حَسُنَ مَحْضَرٌ':Subject, #1: 1	حُسْنِ مُجَامَعَةِ
u'حُسْنٌ مَحْضَرٌ':Added, #1: 1	حَسُنَ مَحْضَرُهُ
u'حُسْنٌ مُدَارَسَةٌ':Added, #1: 1	حُسْنُ الْمَحْضَرِ
u'حُسْنٌ مُصَاحَبَةٌ':Added, #1: 1	حُسْنِ الْمُدَارَسَةِ
u'حُسْنٌ مُصَافَحَةٌ':Added, #1: 1	حُسْنَ الْمُصَاحَبَةِ
u'حُسْنٌ مُعَاشَرَةٌ':Added, #1: 1	حُسْنِ الْمُصَافَحَةِ
u'حُسْنٌ مُعَامَلَةٌ':Added, #1: 1	حُسْنِ الْمُعَاشَرَةِ
u'حُسْنٌ مَعْرِفَةٌ':Added, #1: 1	حُسْنِ الْمُعَامَلَةِ
u'حُسْنٌ مَعْرِفَة':Added, #1: 1	حُسْنَ الْمَعْرِفَةِ
u'حُسْنٌ مَعُونَةٌ':Added, #1: 1	حُسْنَ الْمَعْرِفَةِ
u'حُسْنٌ مَعُونَةٌ':Added, #1: 1	حُسْنِ مَعُونَتِهِ
u'حُسْنٌ مَقْصِدٌ':Added, #2: 2	حُسْنَ مَعُونَتِهِ
u'حُسْنٌ ملكة':Added, #1: 1	حُسْنِ مَقْصِدِ
u'حُسْنٌ مَلَكَةٌ':Added, #1: 1	حُسْنِ الْمَلَكَةِ
u'حُسْنٌ مُنَاظَرَةٌ':Added, #1: 1	حُسْنِ الْمَلَكَةِ
u'حُسْنٌ نبات':Added, #1: 1	حُسْنِ الْمُنَاظَرَةِ
u'حُسْنٌ نَبَاتٌ':Added, #1: 1	حُسْنِ النَّبَاتِ
u'حُسْنٌ نَظَرٌ':Added, #1: 1	حُسْنِ النَّبَاتِ
u'حُسْنٌ نَظَرٌ':Added, #1: 1	حُسْنَ نَظَرٍ
u'حُسْنٌ نَظَرٌ':Added, #1: 1	حُسْنِ نَظَرِ
u'حُسْنٌ نَظَرٌ':Added, #2: 2	حُسْنُ النَّظَرِ
u'حُسْنٌ نِيَّةٌ':Added, #2: 2	حُسْنِ النَّظَرِ
u'حُسْنٌ نِيَّةٌ':Added, #1: 1	حُسْنُ النِّيَّةِ
u'حُسْنٌ هَيْئَةٌ':Added, #1: 1	حُسْنِ النِّيَّةِ
u'حُسْنٌ هَيْئَةٌ':Added, #1: 1	حُسْنَ الْهَيْئَةِ
u'حَسُنَ وَجْهٌ':Subject, #5: 5	حُسْنِ الْهَيْئَةِ
u'حُسْنٌ وَجْهٌ':Added, #3: 3	حَسُنَ وَجْهُهُ
u'حُسْنٌ وَجْهٌ':Added, #1: 1	حُسْنَ الْوَجْهِ
u'حُسْنٌ وُجُوهٌ':Added, #1: 1	حُسْنُ الْوَجْهِ
u'حَسُنَ وُرُودٌ':Subject, #1: 1	حُسْنَ وُجُوهٍ
u'حُسْنٌ وَفَاءٌ':Added, #1: 1	حَسُنَ وُرُودُ
u'حُسْنٌ يَقِينٌ':Added, #1: 1	حُسْنَ الْوَفَاءِ
u'حَشَّ حَشِيشٌ':Predicate, #1: 1	حُسْنِ يَقِينٍ
u'حَشْدٌ أَمْرٌ':Added, #2: 2	حَشَّ الْحَشِيشَ
u'حَشْرٌ قِيَامَةٌ':Added, #1: 1	حَشْدِ أَمْرٍ
u'حَشْرٌ نَارٌ':Added, #1: 1	حَشْرُ الْقِيَامَةِ
u'حَشْرٌ نَاسٌ':Added, #1: 1	حَشْرُ النّارِ
u'حَشْرٌ يهود':Added, #1: 1	حَشْرِ النَّاسِ
u'حَشْرٌ يَهُودٌ':Added, #1: 1	حَشْرُ الْيَهُودِ
u'حَشَمٌ صَدِيقٌ':Added, #1: 1	حَشْرُ الْيَهُودِ
u'حَشْوٌ إِحْلِيلٌ':Added, #1: 1	حَشَمُ الصَّدِيقِ
u'حَشْوٌ جِبَابٌ':Added, #1: 1	حَشْوُ إحْلِيلٍ
u'حَشْوٌ جِبَابٌ':Added, #1: 1	حَشْوِ الْجِبَابِ
u'حَشْوٌ جِبَابٌ':Added, #1: 1	حَشْوُ جِبَابٍ
u'حَشْوٌ جُبّةٌ':Added, #2: 2	حَشْوُ الْجِبَابِ
u'حَشْوٌ ذكر':Added, #1: 1	حَشْوُ جُبَّةٍ
u'حَشْوٌ ذَكَرٌ':Added, #1: 1	حَشْوَ الذَّكَرِ
u'حَشْوٌ مَحَلٌّ':Added, #1: 1	حَشْوَ الذَّكَرِ
u'حَصَاةٌ جِمَارٌ':Added, #2: 2	حَشْوُ الْمَحَلِّ
u'حَصَاةٌ جَمْرَةٌ':Added, #1: 1	حَصَاةِ الْجِمَارِ
u'حَصَاةٌ جَمْرَة':Added, #1: 1	حَصَاةِ جَمْرَةٍ
u'حَصَاةٌ مَسْجِدٌ':Added, #1: 1	حَصَاةِ جَمْرَةٍ
u'حَصَاةٌ واحد':Added, #1: 1	حَصَاةِ الْمَسْجِدِ
u'حَصَاةٌ وَاحِدٌ':Added, #5: 5	حَصَاةٍ وَاحِدَةٍ
u'حَصَادٌ أَوَّلُ':Added, #5: 5	حَصَاةٍ وَاحِدَةٍ
u'حَصَادٌ حِنْطَةٌ':Added, #8: 8	حَصَادِ الْأَوَّلِ
u'حَصَادٌ زَرْعٌ':Added, #1: 1	حَصَادِ الْحِنْطَةِ
u'حَصَادٌ زَرْعٌ':Added, #1: 1	حَصَادَ الزَّرْعِ
u'حَصَادٌ زَرْعٌ':Added, #1: 1	حَصَادِ زَرْعٍ
u'حَصَادٌ زَرْعٌ':Added, #1: 1	حَصَادِ زَرْعِ
u'حَصَادٌ زَرْعٌ':Added, #1: 1	حَصَادِ زَرْعِهِ
u'حَصَادٌ زَرْعٌ':Added, #2: 2	حَصَادُ زَرْعِهِ
u'حَصَادٌ مَضْمُومٌ':Added, #3: 3	حَصَادِ الزَّرْعِ
u'حَصَانَةٌ فَاعِلٌ':Added, #1: 1	حَصَادِ الْمَضْمُومِ
u'حَصَانَةٌ مَقْذُوفٌ':Added, #1: 1	حَصَانَةِ الْفَاعِلِ
u'حَصَانَةٌ مَوْضِعٌ':Added, #1: 1	حَصَانَةِ الْمَقْذُوفِ
u'حَصَّبَ رَسُولٌ':Subject, #1: 1	حَصَانَةُ الْمَوْضِعِ
u'حَصَدَ أَوَّلُ':Predicate, #1: 1	حَصَّبَ رَسُولُ
u'حَصَدَ ثَالِثٌ':Predicate, #1: 1	حَصَدَ الْأَوَّلَ
u'حَصَدَ زَرْعٌ':Predicate, #1: 1	حَصَدَ الثَّالِثَ
u'حَصَدَ غَاصِبٌ':Subject, #3: 3	حَصَدَ الزَّرْعَ
u'حَصَدَ قَالٌ':Predicate, #2: 2	حَصَدَ غَاصِبُ
u'حَصَرَ اِبْنٌ':Subject, #1: 1	حَصَدَ قَالَ
u'حَصْرٌ أحَدٌ':Added, #1: 1	حَصَرَ ابْنُ
u'حَصْرٌ أَسْماءٌ':Added, #1: 1	حَصْرَ أَحَدِ
u'حَصْرٌ أَعْذَارٌ':Added, #1: 1	حَصْرُ أَسْمَاءِ
u'حَصْرٌ أَعْذَارٌ':Added, #1: 1	حَصْرَ الْأَعْذَارِ
u'حَصْرٌ أَعْذَارٌ':Added, #1: 1	حَصْرُ الْأَعْذَارِ
u'حَصْرٌ أكل':Added, #1: 1	حَصْرِ الْأَعْذَارِ
u'حَصْرٌ أَكْلٌ':Added, #1: 1	حَصْرَ الْأَكْلِ
u'حَصْرٌ الْمَرْأَةُ':Added, #1: 1	حَصْرَ الْأَكْلِ
u'حَصَرَ إمَامٌ':Subject, #1: 1	حَصْرِ الْمَرْأَةِ
u'حَصْرٌ أَنْوَاعٌ':Added, #1: 1	حَصَرَ الْإِمَامُ
u'حَصَرَ أَنِيسٌ':Predicate, #1: 1	حَصْرُ أَنْوَاعِهِ
u'حَصَرَ أهْلٌ':Predicate, #1: 1	حَصَرَ الْأَنِيسَ
u'حَصْرٌ أهْلٌ':Added, #1: 1	حَصَرَ أَهْلَ
u'حَصْرٌ أَوْصَافٌ':Added, #1: 1	حَصْرِ أَهْلِ
u'حَصْرٌ أَوْصَافٌ':Added, #2: 2	حَصْرُ الْأَوْصَافِ
u'حَصْرٌ أَيْمَانٌ':Added, #2: 2	حَصْرِ الْأَوْصَافِ
u'حَصْرٌ أَيْمَانٌ':Added, #1: 1	حَصْرُ الْأَيْمَانِ
u'حَصْرٌ بَيِّنَةٌ':Added, #1: 1	حَصْرِ الْأَيْمَانِ
u'حَصْرٌ تَبْيِين':Added, #1: 1	حَصْرُ بَيِّنَةِ
u'حَصْرٌ تَقْديمٌ':Added, #1: 1	حَصْرِ التَّبْيِينِ
u'حَصْرٌ تَقْسِيمٌ':Added, #1: 1	حَصْرِ تَقْدِيمِهِ
u'حَصْرٌ ثُبُوتٌ':Added, #1: 1	حَصْرُ التَّقْسِيمِ
u'حَصْرٌ جَوَازٌ':Added, #1: 1	حَصْرُ ثُبُوتِ
u'حَصْرٌ حَضَانَةٌ':Added, #1: 1	حَصْرِ الْجَوَازِ
u'حَصْرٌ حَظٌّ':Added, #1: 1	حَصْرُ الْحَضَانَةِ
u'حَصْرٌ حَظٌّ':Added, #1: 1	حَصْرُ الْحَظِّ
u'حَصْرٌ حُكْمٌ':Added, #1: 1	حَصْرِ الْحَظِّ
u'حَصْرٌ حَيَوَانٌ':Added, #2: 2	حَصْرِ الْحُكْمِ
u'حَصْرٌ خَبَرٌ':Added, #1: 1	حَصْرِ الْحَيَوَانِ
u'حَصْرٌ خَبَر':Added, #1: 1	حَصْرَ الْخَبَرِ
u'حَصْرٌ ذاتِيٌّ':Added, #1: 1	حَصْرَ الْخَبَرِ
u'حَصْرٌ شُرُوطٌ':Added, #1: 1	حَصْرُ الذَّاتِيَّاتِ
u'حَصْرٌ شُرُوطٌ':Added, #1: 1	حَصْرِ الشُّرُوطِ
u'حَصْرٌ صَبِيٌّ':Added, #2: 2	حَصْرُ شُرُوطِهِ
u'حَصْرٌ صِحَّةٌ':Added, #1: 1	حَصْرِ الصَّبِيِّ
u'حَصْرٌ صَرِيحٌ':Added, #3: 3	حَصْرَ الصِّحَّةِ
u'حَصْرٌ صُورَةٌ':Added, #2: 2	حَصْرِ الصَّرِيحِ
u'حَصَرَ ضُرُوبٌ':Predicate, #1: 1	حَصْرَ الصُّورَةِ
u'حَصْرٌ ضَمَانٌ':Added, #1: 1	حَصَرَ الضُّرُوبَ
u'حَصْرٌ عَبْدٌ':Added, #1: 1	حَصْرِ الضَّمَانِ
u'حَصَرَ عَدُوٌّ':Subject, #1: 1	حَصْرِ الْعَبْدِ
u'حَصْرٌ عَدُوٌّ':Added, #3: 3	حَصَرَ الْعَدُوُّ
u'حَصْرٌ عَدُوٌّ':Added, #1: 1	حَصْرُ عَدُوٍّ
u'حَصْرٌ عَدُوٌّ':Added, #2: 2	حَصْرَ الْعَدُوِّ
u'حَصْرٌ عَدُوٌّ':Added, #3: 3	حَصْرُ الْعَدُوِّ
u'حَصْرٌ علم':Added, #3: 3	حَصْرِ الْعَدُوِّ
u'حَصْرٌ علم':Added, #1: 1	حَصْرَ الْعِلْمِ
u'حَصْرٌ عِلْمٌ':Added, #1: 1	حَصْرِ الْعِلْمِ
u'حَصْرٌ عِلْمٌ':Added, #1: 1	حَصْرَ الْعِلْمِ
u'حَصْرٌ علم':Added, #1: 1	حَصْرِ الْعِلْمِ
u'حَصْرٌ عِلْمٌ':Added, #1: 1	حَصْرَ عِلْمِ
u'حَصْرٌ فاء':Added, #1: 1	حَصْرَ عِلْمِ
u'حَصْرٌ فَائِدَةٌ':Added, #1: 1	حَصْرِ الْفَاءِ
u'حَصْرٌ فَائِدَةٌ':Added, #1: 1	حَصْرِ فَائِدَةِ
u'حَصْرٌ فَضِيلٌ':Added, #1: 1	حَصْرُ فَائِدَتِهِ
u'حَصْرٌ فَضِيلَةٌ':Added, #1: 1	حَصْرُ الْفَضِيلَةِ
u'حَصَرَ فِعْلٌ':Subject, #1: 1	حَصْرُ الْفَضِيلَةِ
u'حَصْرٌ قُرْآنٌ':Added, #1: 1	حَصَرَ فِعْلُ
u'حَصْرٌ كبائر':Added, #1: 1	حَصْرِ الْقُرْآنِ
u'حَصْرٌ كبائر':Added, #1: 1	حَصْرُ الْكَبَائِرِ
u'حَصْرٌ كُلِّيٌّ':Added, #1: 1	حَصْرِ الْكَبَائِرِ
u'حَصْرٌ لاَمٌ':Added, #1: 1	حَصْرِ الْكُلِّيِّ
u'حَصْرٌ لعان':Added, #1: 1	حَصْرِ اللَّامِ
u'حَصْرٌ مُبْتَدَأٌ':Added, #1: 1	حَصْرِ اللِّعَانِ
u'حَصْرٌ مُبْتَدَأٌ':Added, #1: 1	حَصْرَ الْمُبْتَدَأِ
u'حَصْرٌ مُبْتَدَأٌ':Added, #1: 1	حَصْرِ الْمُبْتَدَأِ
u'حَصْرٌ مُتَكَلِّمٌ':Added, #3: 3	حَصْرُ الْمُبْتَدَأِ
u'حَصْرٌ مُحَرَّمٌ':Added, #1: 1	حَصْرِ الْمُتَكَلِّمِ
u'حَصْرٌ مَرَضٌ':Added, #2: 2	حَصْرِ الْمُحَرَّمَاتِ
u'حَصْرٌ مَسْأَلَةٌ':Added, #1: 1	حَصْرِ الْمَرَضِ
u'حَصْرٌ مُسْتَحَبٌّ':Added, #1: 1	حَصْرُ الْمَسْأَلَةِ
u'حَصَرَ مُسْتَنَدٌ':Predicate, #1: 1	حَصْرَ مُسْتَحَبِّهِ
u'حَصْرٌ مَسْجِدٌ':Added, #1: 1	حَصَرَ مُسْتَنَدَ
u'حَصْرٌ مُصَنِّفٌ':Added, #1: 1	حَصْرِ الْمَسْجِدِ
u'حَصْرٌ مُصَنِّفٌ':Added, #1: 1	حَصْرَ الْمُصَنِّفِ
u'حَصْرٌ مُقَدِّمٌ':Added, #2: 2	حَصْرِ الْمُصَنِّفِ
u'حَصْرٌ مُقَدِّمٌ':Added, #1: 1	حَصْرَ الْمُقَدِّمَةِ
u'حَصْرٌ مُقَدِّمَةٌ':Added, #1: 1	حَصْرِ الْمُقَدِّمَةِ
u'حَصْرٌ مُقَدِّمَةٌ':Added, #1: 1	حَصْرَ الْمُقَدِّمَةِ
u'حَصْرٌ مَمْرُور':Added, #1: 1	حَصْرِ الْمُقَدِّمَةِ
u'حَصْرٌ مَنْعٌ':Added, #1: 1	حَصْرَ الْمَمْرُورِ
u'حَصِرَ مُؤَذِّنٌ':Subject, #1: 1	حَصْرَ الْمَنْعِ
u'حَصَرَ مُؤَلِّفٌ':Subject, #1: 1	حَصِرَ الْمُؤَذِّنُ
u'حَصْرٌ مِيرَاثٌ':Added, #1: 1	حَصَرَ الْمُؤَلِّفُ
u'حَصْرٌ نِساءٌ':Added, #1: 1	حَصْرَ الْمِيرَاثِ
u'حَصْرٌ نَظَرٌ':Added, #1: 1	حَصْرِ النِّسَاءِ
u'حَصْرٌ نَفْسٌ':Added, #1: 1	حَصْرُ النَّظَرِ
u'حَصْرٌ وُجُوهٌ':Added, #1: 1	حَصْرِ النَّفْسِ
u'حَصْرٌ وَرَثَةٌ':Added, #1: 1	حَصْرِ الْوُجُوهِ
u'حَصْرٌ وَرَثَةٌ':Added, #1: 1	حَصْرِ الْوَرَثَةِ
u'حَصْرٌ وُقُوعٌ':Added, #2: 2	حَصْرُ وَرَثَتِهِ
u'حَصْرٌ يَمِينٌ':Added, #1: 1	حَصْرَ الْوُقُوعِ
u'حَصَلَ اِبْتِداءٌ':Subject, #1: 1	حَصْرَ الْيَمِينِ
u'حَصَّلَ اِبْنٌ':Subject, #1: 1	حَصَلَ ابْتِدَاءُ
u'حَصَلَ إِتْلاَفٌ':Subject, #1: 1	حَصَّلَ ابْنُ
u'حَصَلَ أثَرٌ':Subject, #3: 3	حَصَلَ الْإِتْلَافُ
u'حَصَلَ إِجْمَاعٌ':Subject, #1: 1	حَصَلَ أَثَرٌ
u'حَصَلَ أحَدٌ':Subject, #5: 5	حَصَلَ الْإِجْمَاعُ
u'حَصَلَ أحَدٌ':Subject, #1: 1	حَصَلَ أَحَدٌ
u'حَصَلَ إِحْرَازٌ':Subject, #1: 1	حَصَلَ أَحَدُ
u'حَصَلَ إحْضَارٌ':Subject, #1: 1	حَصَلَ الْإِحْرَازُ
u'حَصَلَ اِخْتِلاَفٌ':Subject, #1: 1	حَصَلَ الْإِحْضَارُ
u'حَصَلَ إِخْرَاجٌ':Subject, #2: 2	حَصَلَ اخْتِلَافٌ
u'حَصَلَ أَخِيرٌ':Subject, #1: 1	حَصَلَ الْإِخْرَاجُ
u'حَصَلَ إِذْنٌ':Subject, #2: 2	حَصَلَ الْأَخِيرُ
u'حَصَلَ اِسْتِبْراء':Subject, #3: 3	حَصَلَ الْإِذْنُ
u'حَصَلَ اِسْتِحْقَاقٌ':Subject, #1: 1	حَصَلَ اسْتِبْرَاءٌ
u'حَصَلَ إِسْكارٌ':Subject, #1: 1	حَصَلَ اسْتِحْقَاقُ
u'حَصَلَ إِسْلامٌ':Subject, #1: 1	حَصَلَ الْإِسْكَارُ
u'حَصَلَ إِسْلامٌ':Subject, #1: 1	حَصَلَ إسْلَامٌ
u'حَصَلَ إِسْلامٌ':Subject, #1: 1	حَصَلَ إسْلَامُ
u'حَصَّلَ أصل':Subject, #1: 1	حَصَلَ الْإِسْلَامُ
u'حَصَّلَ أًصْلٌ':Subject, #1: 1	حَصَّلَ أَصْلُ
u'حَصَلَ أصل':Subject, #1: 1	حَصَّلَ أَصْلُ
u'حَصَلَ أًصْلٌ':Subject, #1: 1	حَصَلَ الْأَصْلُ
u'حَصَلَ أصل':Subject, #1: 1	حَصَلَ الْأَصْلُ
u'حَصَلَ أًصْلٌ':Subject, #2: 2	حَصَلَ أَصْلُ
u'حَصَّلَ أُصولٌ':Predicate, #2: 2	حَصَلَ أَصْلُ
u'حَصَلَ إعْلاَمٌ':Subject, #2: 2	حَصَّلَ أُصُولَ
u'حَصَلَ إعْلاَنٌ':Subject, #3: 3	حَصَلَ الْإِعْلَامُ
u'حَصَلَ إفْسَادٌ':Subject, #1: 1	حَصَلَ إعْلَانٌ
u'حَصَلَ إقْرَارٌ':Subject, #1: 1	حَصَلَ الْإِفْسَادُ
u'حَصَلَ أَكْثَرُ':Subject, #1: 1	حَصَلَ الْإِقْرَارُ
u'حَصَلَ إكْرَاهٌ':Subject, #1: 1	حَصَلَ الْأَكْثَرُ
u'حَصَلَ إِلْقَاءٌ':Subject, #6: 6	حَصَلَ الْإِكْرَاهُ
u'حَصَلَ إِلْقَاءٌ':Subject, #1: 1	حَصَلَ الْإِلْقَاءُ
u'حَصَلَ ألَمٌ':Subject, #1: 1	حَصَلَ إلْقَاءُ
u'حَصَلَ الْمَرْءُ':Subject, #1: 1	حَصَلَ الْأَلَمُ
u'حَصَلَ أمَانٌ':Subject, #1: 1	حَصَلَ الْمَرْءُ
u'حَصَلَ أَمْرٌ':Subject, #1: 1	حَصَلَ الْأَمَانُ
u'حَصَلَ إِمْكانٌ':Subject, #1: 1	حَصَلَ أَمْرٌ
u'حَصَلَ أَمْنٌ':Subject, #1: 1	حَصَلَ الْإِمْكَانُ
u'حَصَلَ اِنْفِساخٌ':Subject, #5: 5	حَصَلَ الْأَمْنُ
u'حَصَلَ اِنْكِسارٌ':Subject, #1: 1	حَصَلَ انْفِسَاخٌ
u'حَصَلَ إهْدَاءٌ':Subject, #1: 1	حَصَلَ انْكِسَارٌ
u'حَصَلَ أَوَّلُ':Subject, #1: 1	حَصَلَ الْإِهْدَاءُ
u'حَصَلَ إِيجَابٌ':Subject, #3: 3	حَصَلَ الْأَوَّلُ
u'حَصَلَ إيقَاعٌ':Subject, #5: 5	حَصَلَ الْإِيجَابُ
u'حَصَلَ بَذْرٌ':Subject, #2: 2	حَصَلَ الْإِيقَاعُ
u'حَصَلَ بِرٌّ':Subject, #1: 1	حَصَلَ بَذْرٌ
u'حَصَلَ بَراءةٌ':Subject, #1: 1	حَصَلَ الْبِرُّ
u'حَصَلَ بُرْهانٌ':Subject, #1: 1	حَصَلَ بَرَاءَةُ
u'حَصَلَ بُرْهَانٌ':Subject, #1: 1	حَصَلَ الْبُرْهَانُ
u'حَصَلَ بَطَلٌ':Predicate, #1: 1	حَصَلَ الْبُرْهَانُ
u'حَصَلَ بُعْدٌ':Subject, #1: 1	حَصَلَ بَطَلَ
u'حَصَّلَ بَعْضٌ':Predicate, #1: 1	حَصَلَ الْبُعْدُ
u'حَصَّلَ بَعْضٌ':Predicate, #1: 1	حَصَّلَ الْبَعْضَ
u'حَصَلَ بَعْضٌ':Subject, #2: 2	حَصَّلَ بَعْضَ
u'حَصَلَ بَعْضٌ':Subject, #1: 1	حَصَلَ الْبَعْضُ
u'حَصَلَ بَعْضٌ':Subject, #1: 1	حَصَلَ بَعْضُهُ
u'حَصَلَ بِنَاءٌ':Subject, #6: 6	حَصَلَ بَعْضُ
u'حَصَلٌ بِيدٌ':Added, #1: 1	حَصَلَ الْبِنَاءُ
u'حَصَلَ بَيْعٌ':Subject, #1: 1	حَصَلَ بِيَدِ
u'حَصَلَ بَيْعٌ':Subject, #1: 1	حَصَلَ بَيْعُ
u'حَصَلَ بَيْعٌ':Subject, #1: 1	حَصَلَ بَيْعُهُ
u'حَصَلَ بَيْنٌ':Predicate, #2: 2	حَصَلَ الْبَيْعُ
u'حَصَلَ تَأْكِيدٌ':Subject, #2: 2	حَصَلَ بَيْنَ
u'حَصَلَ تَثْلِيثٌ':Subject, #1: 1	حَصَلَ التَّأْكِيدُ
u'حَصَلَ تَجْدِيدٌ':Subject, #1: 1	حَصَلَ التَّثْلِيثُ
u'حَصَلَ تَحْرِيمٌ':Subject, #1: 1	حَصَلَ تَجْدِيدُ
u'حَصَلَ تَحْصِيلٌ':Subject, #2: 2	حَصَلَ التَّحْرِيمُ
u'حَصَلَ تَحَلُّلٌ':Subject, #1: 1	حَصَلَ تَحْصِيلُ
u'حَصَلَ تَخْصِيصٌ':Subject, #1: 1	حَصَلَ التَّحَلُّلُ
u'حَصَلَ تَخْمِير':Subject, #1: 1	حَصَلَ التَّخْصِيصُ
u'حَصَلَ تَدْلِيس':Subject, #1: 1	حَصَلَ تَخْمِيرُ
u'حَصَلَ تَرَدُّدٌ':Subject, #1: 1	حَصَلَ التَّدْلِيسُ
u'حَصَلَ تَزَاحُمٌ':Subject, #1: 1	حَصَلَ التَّرَدُّدُ
u'حَصَلَ تَزَوُّجٌ':Subject, #1: 1	حَصَلَ التَّزَاحُمُ
u'حَصَلَ تَزْوِيجٌ':Subject, #1: 1	حَصَلَ التَّزَوُّجُ
u'حَصَلَ تَسَامُحٌ':Subject, #1: 1	حَصَلَ التَّزْوِيجُ
u'حَصَلَ تَسْلِيطٌ':Subject, #1: 1	حَصَلَ تَسَامُحٌ
u'حَصَلَ تَسْلِيمٌ':Subject, #2: 2	حَصَلَ التَّسْلِيطُ
u'حَصَلَ تَشْبِيهٌ':Subject, #4: 4	حَصَلَ التَّسْلِيمُ
u'حَصَلَ تَصْدِيقٌ':Subject, #1: 1	حَصَلَ تَشْبِيهُ
u'حَصَلَ تَصَرُّفٌ':Subject, #1: 1	حَصَلَ التَّصْدِيقُ
u'حَصَلَ تَصْرِيحٌ':Subject, #3: 3	حَصَلَ التَّصَرُّفُ
u'حَصَلَ تَطْهِيرٌ':Subject, #1: 1	حَصَلَ التَّصْرِيحُ
u'حَصَلَ تَعَارُضٌ':Subject, #1: 1	حَصَلَ تَطْهِيرُ
u'حَصَلَ تَعَارُضٌ':Subject, #1: 1	حَصَلَ التَّعَارُضُ
u'حَصَلَ تَعَذُّرٌ':Subject, #1: 1	حَصَلَ تَعَارُضٌ
u'حَصَلَ تَعَرُّفٌ':Subject, #1: 1	حَصَلَ التَّعَذُّرُ
u'حَصَلَ تَعْرِيفٌ':Subject, #1: 1	حَصَلَ التَّعَرُّفُ
u'حَصَلَ تَعْزِير':Subject, #1: 1	حَصَلَ التَّعْرِيفُ
u'حَصَلَ تَعْلِيقٌ':Subject, #1: 1	حَصَلَ تَعْزِيرُهُ
u'حَصَلَ تَعْلِيمٌ':Subject, #2: 2	حَصَلَ التَّعْلِيقُ
u'حَصَلَ تَعْيِينٌ':Subject, #1: 1	حَصَلَ التَّعْلِيمُ
u'حَصَلَ تَفَاهُمٌ':Subject, #2: 2	حَصَلَ التَّعْيِينُ
u'حَصَلَ تَفَرُّقٌ':Subject, #1: 1	حَصَلَ التَّفَاهُمُ
u'حَصَلَ تَفْرِيقٌ':Subject, #1: 1	حَصَلَ التَّفَرُّقُ
u'حَصَلَ تَفْصِيلٌ':Subject, #1: 1	حَصَلَ التَّفْرِيقُ
u'حَصَلَ تَفَكُّرٌ':Subject, #2: 2	حَصَلَ التَّفْصِيلُ
u'حَصَلَ تَقْديرٌ':Subject, #1: 1	حَصَلَ التَّفَكُّرُ
u'حَصَلَ تَقْريبٌ':Subject, #1: 1	حَصَلَ التَّقْدِيرُ
u'حَصَلَ تَكْذيبٌ':Subject, #2: 2	حَصَلَ التَّقْرِيبُ
u'حَصَلَ تَلَفٌ':Subject, #1: 1	حَصَلَ التَّكْذِيبُ
u'حَصَلَ تَلَف':Subject, #1: 1	حَصَلَ تَلَفُ
u'حَصَلَ تَلْفيقٌ':Subject, #7: 7	حَصَلَ التَّلَفُ
u'حَصَلَ تَمَكُّنٌ':Subject, #1: 1	حَصَلَ تَلْفِيقٌ
u'حَصَلَ تَمْكِين':Subject, #3: 3	حَصَلَ التَّمَكُّنُ
u'حَصَلَ تَمْلِيك':Subject, #1: 1	حَصَلَ التَّمْكِينُ
u'حَصَلَ تَناجُز':Subject, #1: 1	حَصَلَ التَّمْلِيكُ
u'حَصَلَ تَنَازُعٌ':Subject, #1: 1	حَصَلَ التَّنَاجُزُ
u'حَصَلَ تَنَاقُضٌ':Subject, #3: 3	حَصَلَ التَّنَازُعُ
u'حَصَلَ تَنْجِيمٌ':Subject, #1: 1	حَصَلَ التَّنَاقُضُ
u'حَصَلَ تَوْقِيفٌ':Subject, #1: 1	حَصَلَ التَّنْجِيمُ
u'حَصَلَ تَوْكِيلٌ':Subject, #1: 1	حَصَلَ التَّوْقِيفُ
u'حَصَلَ تَيَقُّنٌ':Subject, #3: 3	حَصَلَ التَّوْكِيلُ
u'حَصَلَ ثَالِثٌ':Subject, #1: 1	حَصَلَ تَيَقُّنُ
u'حَصَلَ ثَمانِيَةٌ':Subject, #1: 1	حَصَلَ الثَّالِثُ
u'حَصَّلَ ثَمَرَةٌ':Predicate, #3: 3	حَصَلَ ثَمَانِيَةٌ
u'حَصَلَ ثَمَنٌ':Subject, #1: 1	حَصَّلَ ثَمَرَةَ
u'حَصَلَ ثَوابٌ':Subject, #1: 1	حَصَلَ الثَّمَنُ
u'حَصَلَ جَبْرٌ':Subject, #1: 1	حَصَلَ الثَّوَابُ
u'حَصَلَ جُزْءٌ':Subject, #1: 1	حَصَلَ الْجَبْرُ
u'حَصَلَ جَزْم':Subject, #1: 1	حَصَلَ جُزْءٌ
u'حَصَلَ جماع':Subject, #1: 1	حَصَلَ الْجَزْمُ
u'حَصَلَ جِمَاعٌ':Subject, #1: 1	حَصَلَ الْجِمَاعُ
u'حَصَلَ جمع':Subject, #1: 1	حَصَلَ الْجِمَاعُ
u'حَصَلَ جَمْعٌ':Subject, #4: 4	حَصَلَ الْجَمْعُ
u'حَصَّلَ جمعة':Predicate, #4: 4	حَصَلَ الْجَمْعُ
u'حَصَّلَ جُمُعَةٌ':Predicate, #1: 1	حَصَّلَ الْجُمُعَةَ
u'حَصَلَ جَوَابٌ':Subject, #1: 1	حَصَّلَ الْجُمُعَةَ
u'حَصَلَ حَجٌّ':Subject, #6: 6	حَصَلَ الْجَوَابُ
u'حَصَلَ حَصَادٌ':Subject, #1: 1	حَصَلَ الْحَجُّ
u'حَصَلَ حَصَلٌ':Predicate, #1: 1	حَصَلَ حَصَادُهُ
u'حَصَلَ حَظٌّ':Subject, #4: 4	حَصَلَ حَصَلَ
u'حَصَلَ حِفْظٌ':Subject, #1: 1	حَصَلَ حَظُّ
u'حَصَلَ حقد':Subject, #1: 1	حَصَلَ الْحِفْظُ
u'حَصَلَ حِقد':Subject, #1: 1	حَصَلَ الْحِقْدُ
u'حَصَلَ حِقْدٌ':Subject, #1: 1	حَصَلَ الْحِقْدُ
u'حَصَلَ حَقِيقِيٌّ':Subject, #1: 1	حَصَلَ الْحِقْدُ
u'حَصَلَ حُكْمٌ':Subject, #2: 2	حَصَلَ الْحَقِيقِيُّ
u'حَصَلَ حَمْلٌ':Subject, #7: 7	حَصَلَ الْحُكْمُ
u'حَصَلَ حِنْثٌ':Subject, #1: 1	حَصَلَ حَمْلُ
u'حَصَلَ حِنْثٌ':Subject, #1: 1	حَصَلَ الْحِنْثُ
u'حَصَلَ خَارِجٌ':Subject, #1: 1	حَصَلَ حِنْثٌ
u'حَصَلَ خامس':Subject, #3: 3	حَصَلَ الْخَارِجُ
u'حَصَلَ خَامِسٌ':Subject, #1: 1	حَصَلَ الْخَامِسُ
u'حَصَلَ خَبَرٌ':Subject, #1: 1	حَصَلَ الْخَامِسُ
u'حَصَلَ خَبَر':Subject, #2: 2	حَصَلَ خَبَرُ
u'حَصَلَ خَتْمٌ':Subject, #2: 2	حَصَلَ خَبَرُ
u'حَصَلَ خرس':Subject, #2: 2	حَصَلَ الْخَتْمُ
u'حَصَلَ خُسْر':Subject, #1: 1	حَصَلَ خَرَسُهُ
u'حَصَلَ خُسْران':Subject, #1: 1	حَصَلَ خُسْرٌ
u'حَصَلَ خَطَأٌ':Subject, #1: 1	حَصَلَ خُسْرَانٌ
u'حَصَلَ خِلاَفٌ':Subject, #1: 1	حَصَلَ الْخَطَأُ
u'حَصَلَ خلط':Subject, #1: 1	حَصَلَ الْخِلَافُ
u'حَصَلَ خَلْفٌ':Subject, #1: 1	حَصَلَ خَلْطُ
u'حَصَلَ خَلَلٌ':Subject, #1: 1	حَصَلَ خَلْفُهُ
u'حَصَلَ خَلَلٌ':Subject, #1: 1	حَصَلَ الْخَلَلُ
u'حَصَلَ خَمْسَةٌ':Subject, #1: 1	حَصَلَ خَلَلٌ
u'حَصَلَ خَوْفٌ':Subject, #2: 2	حَصَلَ خَمْسَةٌ
u'حَصَلَ خَوْفٌ':Subject, #1: 1	حَصَلَ خَوْفٌ
u'حَصَلَ خَوْفٌ':Subject, #1: 1	حَصَلَ خَوْفُ
u'حَصَلَ دَائِرَةٌ':Subject, #2: 2	حَصَلَ الْخَوْفُ
u'حَصَلَ دُخُولٌ':Subject, #1: 1	حَصَلَ دَائِرَةٌ
u'حَصَلَ دُخُولٌ':Subject, #1: 1	حَصَلَ الدُّخُولُ
u'حَصَلَ دَمٌ':Subject, #1: 1	حَصَلَ دُخُولٌ
u'حَصَلَ دُورٌ':Subject, #1: 1	حَصَلَ دَمُ
u'حَصَلَ دَوْرٌ':Subject, #1: 1	حَصَلَ الدُّورُ
u'حَصَلَ ذُهُولٌ':Subject, #5: 5	حَصَلَ الدَّوْرُ
u'حَصَلَ رَأْيٌ':Subject, #2: 2	حَصَلَ ذُهُولٌ
u'حَصَلَ رِبْحٌ':Subject, #1: 1	حَصَلَ رَأْيُهُ
u'حَصَلَ رِبْحٌ':Subject, #1: 1	حَصَلَ الرِّبْحُ
u'حَصَلَ رَدٌّ':Subject, #3: 3	حَصَلَ رِبْحٌ
u'حَصَلَ رَدٌّ':Subject, #1: 1	حَصَلَ رَدٌّ
u'حَصَلَ رَدٌّ':Subject, #1: 1	حَصَلَ رَدُّ
u'حَصَلَ رعاف':Subject, #4: 4	حَصَلَ الرَّدُّ
u'حَصَلَ رُعافٌ':Subject, #1: 1	حَصَلَ الرُّعَافُ
u'حَصَلَ رَفْضٌ':Subject, #1: 1	حَصَلَ الرُّعَافُ
u'حَصَلَ رَفْعٌ':Subject, #1: 1	حَصَلَ رَفْضُ
u'حَصَلَ ريحٌ':Subject, #1: 1	حَصَلَ رَفْعُهُ
u'حَصَلَ زَكاةٌ':Predicate, #1: 1	حَصَلَ رِيحٌ
u'حَصَلَ زِيادَةٌ':Subject, #1: 1	حَصَلَ الزَّكَاةَ
u'حَصَلَ سابع':Predicate, #1: 1	حَصَلَ زِيَادَةٌ
u'حَصَلَ سَابعٌ':Predicate, #1: 1	حَصَلَ السَّابِعَ
u'حَصَلَ سَبَبٌ':Subject, #1: 1	حَصَلَ السَّابِعَ
u'حَصَلَ سَبَبٌ':Subject, #1: 1	حَصَلَ السَّبَبُ
u'حَصَلَ سبقة':Subject, #1: 1	حَصَلَ سَبَبُ
u'حَصَلَ سُجُودٌ':Subject, #1: 1	حَصَلَ سَبْقَةُ
u'حَصَلَ سَفَرٌ':Subject, #1: 1	حَصَلَ سُجُودُ
u'حَصَلَ سقط':Predicate, #1: 1	حَصَلَ السَّفَرُ
u'حَصَلَ سَقَطٌ':Predicate, #1: 1	حَصَلَ سَقَطَ
u'حَصَلَ سَقْيٌ':Subject, #1: 1	حَصَلَ سَقَطَ
u'حَصَلَ سكر':Subject, #1: 1	حَصَلَ السَّقْيُ
u'حَصَلَ سُكْرٌ':Subject, #2: 2	حَصَلَ السُّكْرُ
u'حَصَلَ سَهْوٌ':Subject, #2: 2	حَصَلَ السُّكْرُ
u'حَصَلَ شِبَعٌ':Subject, #2: 2	حَصَلَ سَهْوٌ
u'حَصَلَ شِرَاءٌ':Subject, #1: 1	حَصَلَ الشِّبَعُ
u'حَصَلَ شَرْطٌ':Subject, #2: 2	حَصَلَ الشِّرَاءُ
u'حَصَلَ شركة':Subject, #1: 1	حَصَلَ الشَّرْطُ
u'حَصَلَ شَرِكَةٌ':Subject, #1: 1	حَصَلَ شَرِكَةُ
u'حَصَلَ شُرُوعٌ':Subject, #1: 1	حَصَلَ شَرِكَةُ
u'حَصَلَ شُرُوعٌ':Subject, #1: 1	حَصَلَ شُرُوعُهُ
u'حَصَلَ شعار':Subject, #3: 3	حَصَلَ الشُّرُوعُ
u'حَصَلَ شِعَارٌ':Subject, #2: 2	حَصَلَ الشِّعَارُ
u'حَصَلَ شَكٌّ':Subject, #2: 2	حَصَلَ الشِّعَارُ
u'حَصَلَ شَكٌّ':Subject, #1: 1	حَصَلَ شَكٌّ
u'حَصَلَ شَيْءٌ':Subject, #2: 2	حَصَلَ الشَّكُّ
u'حَصَلَ صلح':Subject, #4: 4	حَصَلَ شَيْءٌ
u'حَصَلَ صُلْحٌ':Subject, #1: 1	حَصَلَ الصُّلْحُ
u'حَصَلَ صَيْدٌ':Subject, #1: 1	حَصَلَ الصُّلْحُ
u'حَصَلَ ضَرْبٌ':Subject, #1: 1	حَصَلَ الصَّيْدُ
u'حَصَلَ ضَرَرٌ':Subject, #1: 1	حَصَلَ الضَّرْبُ
u'حَصَلَ ضَرَرٌ':Subject, #4: 4	حَصَلَ الضَّرَرُ
u'حَصَلَ ضَرُورَةٌ':Predicate, #6: 6	حَصَلَ ضَرَرٌ
u'حَصَلَ ضَمَانٌ':Subject, #3: 3	حَصَلَ ضَرُورَةَ
u'حَصَلَ طَرِيقٌ':Subject, #3: 3	حَصَلَ الضَّمَانُ
u'حَصَلَ طَرِيقٌ':Subject, #1: 1	حَصَلَ الطَّرِيقُ
u'حَصَلَ طلب':Subject, #1: 1	حَصَلَ طَرِيقُ
u'حَصَلَ طَلَبٌ':Subject, #1: 1	حَصَلَ الطَّلَبُ
u'حَصَلَ طلب':Subject, #1: 1	حَصَلَ الطَّلَبُ
u'حَصَلَ طَلَبٌ':Subject, #1: 1	حَصَلَ طَلَبُ
u'حَصَلَ طَلْعٌ':Subject, #1: 1	حَصَلَ طَلَبُ
u'حَصَلَ طُولٌ':Subject, #1: 1	حَصَلَ الطَّلْعُ
u'حَصَلَ ظُلْمٌ':Subject, #2: 2	حَصَلَ طُولٌ
u'حَصَلَ ظَنٌّ':Subject, #1: 1	حَصَلَ الظُّلْمُ
u'حَصَلَ ظَنٌّ':Subject, #1: 1	حَصَلَ ظَنُّ
u'حَصَلَ عَبْدٌ':Subject, #2: 2	حَصَلَ الظَّنُّ
u'حَصَلَ عتق':Subject, #1: 1	حَصَلَ الْعَبْدُ
u'حَصَلَ عِتْقٌ':Subject, #10: 10	حَصَلَ الْعِتْقُ
u'حَصَلَ عِتْقٌ':Subject, #10: 10	حَصَلَ الْعِتْقُ
u'حَصَلَ عتق':Subject, #1: 1	حَصَلَ عِتْقٌ
u'حَصَلَ عِتْقٌ':Subject, #1: 1	حَصَلَ عِتْقُهُ
u'حَصَلَ عجز':Subject, #1: 1	حَصَلَ عِتْقُهُ
u'حَصَلَ عَجْزٌ':Subject, #2: 2	حَصَلَ الْعَجْزُ
u'حَصَلَ عَدَاوَةٌ':Subject, #2: 2	حَصَلَ الْعَجْزُ
u'حَصَلَ عُذْرٌ':Subject, #1: 1	حَصَلَ عَدَاوَةٌ
u'حَصَلَ عُذْرٌ':Subject, #1: 1	حَصَلَ الْعُذْرُ
u'حَصَلَ عزل':Subject, #1: 1	حَصَلَ عُذْرٌ
u'حَصَلَ عَفْوٌ':Subject, #3: 3	حَصَلَ الْعَزْلُ
u'حَصَلَ عَفْوٌ':Subject, #1: 1	حَصَلَ عَفْوٌ
u'حَصَلَ عَقِبٌ':Predicate, #4: 4	حَصَلَ الْعَفْوُ
u'حَصَلَ عَقْدٌ':Subject, #1: 1	حَصَلَ عَقِبَ
u'حَصَلَ عَقِيبٌ':Predicate, #3: 3	حَصَلَ الْعَقْدُ
u'حَصَلَ علم':Subject, #2: 2	حَصَلَ عَقِيبَ
u'حَصَلَ عِلْمٌ':Subject, #1: 1	حَصَلَ عِلْمٌ
u'حَصَلَ علم':Subject, #1: 1	حَصَلَ عِلْمٌ
u'حَصَلَ عِلْمٌ':Subject, #25: 25	حَصَلَ الْعِلْمُ
u'حَصَلَ عُلُوقٌ':Subject, #25: 25	حَصَلَ الْعِلْمُ
u'حَصَلَ عُلُوقٌ':Subject, #1: 1	حَصَلَ الْعُلُوقُ
u'حَصَلَ عَمَلٌ':Subject, #1: 1	حَصَلَ عُلُوقٌ
u'حَصَلَ عَمَلٌ':Subject, #1: 1	حَصَلَ عَمَلٌ
u'حَصَلَ عُمُومٌ':Subject, #4: 4	حَصَلَ الْعَمَلُ
u'حَصَّلَ عند':Predicate, #1: 1	حَصَلَ الْعُمُومُ
u'حَصَلَ عند':Predicate, #1: 1	حَصَّلَ عِنْدَ
u'حَصَلَ عَوْدٌ':Subject, #5: 5	حَصَلَ عِنْدَ
u'حَصَلَ عَيْبٌ':Subject, #1: 1	حَصَلَ عَوْدُهُ
u'حَصَلَ غِذَاءٌ':Subject, #1: 1	حَصَلَ الْعَيْبُ
u'حَصَلَ غَرَضٌ':Subject, #1: 1	حَصَلَ الْغِذَاءُ
u'حَصَّلَ غَرَضٌ':Subject, #1: 1	حَصَلَ غَرَضُ
u'حَصَلَ غَرَضٌ':Subject, #1: 1	حَصَّلَ غَرَضُهُ
u'حَصَلَ غَرَضٌ':Subject, #4: 4	حَصَلَ غَرَضُهُ
u'حَصَلَ غُرُورٌ':Subject, #6: 6	حَصَلَ الْغَرَضُ
u'حَصَلَ غَسْلٌ':Subject, #1: 1	حَصَلَ الْغُرُورُ
u'حَصَلَ غُصْنٌ':Subject, #1: 1	حَصَلَ الْغَسْلُ
u'حَصَلَ غَلَبَةٌ':Subject, #2: 2	حَصَلَ غُصْنُ
u'حَصَلَ غير':Predicate, #1: 1	حَصَلَ غَلَبَةُ
u'حَصَلَ غَيْرٌ':Predicate, #1: 1	حَصَلَ غَيْرَ
u'حَصَلَ غير':Subject, #1: 1	حَصَلَ غَيْرَ
u'حَصَلَ غَيْرٌ':Subject, #1: 1	حَصَلَ غَيْرُ
u'حَصَلَ غَيْمٌ':Subject, #1: 1	حَصَلَ غَيْرُ
u'حَصَلَ فَائِدَةٌ':Subject, #1: 1	حَصَلَ غَيْمٌ
u'حَصَلَ فِرَاقٌ':Subject, #1: 1	حَصَلَ فَائِدَةٌ
u'حَصَلَ فَرْضٌ':Subject, #3: 3	حَصَلَ الْفِرَاقُ
u'حَصَلَ فرق':Subject, #1: 1	حَصَلَ الْفَرْضُ
u'حَصَلَ فَرْقٌ':Subject, #1: 1	حَصَلَ الْفَرْقُ
u'حَصَلَ فساد':Subject, #1: 1	حَصَلَ الْفَرْقُ
u'حَصَلَ فَسَادٌ':Subject, #1: 1	حَصَلَ الْفَسَادُ
u'حَصَلَ فَسْخٌ':Subject, #1: 1	حَصَلَ الْفَسَادُ
u'حَصَلَ فَسْخٌ':Subject, #1: 1	حَصَلَ فَسْخٌ
u'حَصَلَ فَصْلٌ':Subject, #4: 4	حَصَلَ الْفَسْخُ
u'حَصَلَ فَضْلٌ':Subject, #2: 2	حَصَلَ الْفَصْلُ
u'حَصَلَ فِطْرٌ':Subject, #4: 4	حَصَلَ الْفَضْلُ
u'حَصَلَ فِعْلٌ':Subject, #2: 2	حَصَلَ الْفِطْرُ
u'حَصَلَ فِعْلٌ':Subject, #1: 1	حَصَلَ فِعْلُهُ
u'حَصَلَ فِعْلٌ':Subject, #2: 2	حَصَلَ الْفِعْلُ
u'حَصَّلَ فُلاَنٌ':Subject, #2: 2	حَصَلَ فِعْلُ
u'حَصَلَ فَلَكٌ':Predicate, #1: 1	حَصَّلَ فُلَانٌ
u'حَصَلَ فَوَاتٌ':Subject, #1: 1	حَصَلَ فَلَكَ
u'حَصَلَ قَبْضٌ':Subject, #3: 3	حَصَلَ الْفَوَاتُ
u'حَصَلَ قَبْضٌ':Subject, #1: 1	حَصَلَ قَبْضٌ
u'حَصَلَ قَبْضٌ':Subject, #1: 1	حَصَلَ قَبْضُهُ
u'حَصَلَ قَبُولٌ':Subject, #3: 3	حَصَلَ الْقَبْضُ
u'حَصَلَ قتل':Subject, #1: 1	حَصَلَ الْقَبُولُ
u'حَصَلَ قَتْلٌ':Subject, #2: 2	حَصَلَ الْقَتْلُ
u'حَصَلَ قُرْبٌ':Subject, #2: 2	حَصَلَ الْقَتْلُ
u'حَصَلَ قَسَمٌ':Subject, #1: 1	حَصَلَ الْقُرْبُ
u'حَصَلَ قَضَاءٌ':Subject, #1: 1	حَصَلَ قَسَمَاهُ
u'حَصَلَ قَطْعٌ':Subject, #1: 1	حَصَلَ الْقَضَاءُ
u'حَصَلَ قول':Subject, #3: 3	حَصَلَ الْقَطْعُ
u'حَصَلَ قَوْلٌ':Subject, #1: 1	حَصَلَ الْقَوْلُ
u'حَصَلَ قِيَاسٌ':Subject, #1: 1	حَصَلَ الْقَوْلُ
u'حَصَلَ قيام':Subject, #1: 1	حَصَلَ قِيَاسٌ
u'حَصَلَ قِيَامٌ':Subject, #1: 1	حَصَلَ الْقِيَامُ
u'حَصَلَ كذب':Subject, #1: 1	حَصَلَ الْقِيَامُ
u'حَصَلَ كَذِبٌ':Subject, #1: 1	حَصَلَ الْكَذِبُ
u'حَصَلَ كَسْبٌ':Subject, #1: 1	حَصَلَ الْكَذِبُ
u'حَصَلَ كَسْرٌ':Subject, #1: 1	حَصَلَ الْكَسْبُ
u'حَصَلَ كُسُوفٌ':Subject, #2: 2	حَصَلَ كَسْرٌ
u'حَصَلَ لبس':Subject, #1: 1	حَصَلَ كُسُوفٌ
u'حَصَلَ لُبْسٌ':Subject, #1: 1	حَصَلَ اللُّبْسُ
u'حَصَلَ لَمْسٌ':Subject, #1: 1	حَصَلَ اللُّبْسُ
u'حَصَلَ مَالٌ':Subject, #1: 1	حَصَلَ اللَّمْسُ
u'حَصَلَ مَالٌ':Subject, #1: 1	حَصَلَ مَالٌ
u'حَصَلَ مُجَرَّدٌ':Subject, #4: 4	حَصَلَ الْمَالُ
u'حَصَلَ مَجِيءٌ':Subject, #1: 1	حَصَلَ مُجَرَّدُ
u'حَصَلَ مَحْدُودٌ':Subject, #1: 1	حَصَلَ الْمَجِيءُ
u'حَصَلَ مرٌّ':Predicate, #1: 1	حَصَلَ الْمَحْدُودُ
u'حَصَلَ مَرَضٌ':Subject, #3: 3	حَصَلَ مَرَّةً
u'حَصَلَ مَسٌّ':Subject, #1: 1	حَصَلَ مَرَضٌ
u'حَصَلَ مَسْنُونٌ':Subject, #2: 2	حَصَلَ الْمَسُّ
u'حَصَلَ مَشْرُوطٌ':Subject, #3: 3	حَصَلَ الْمَسْنُونُ
u'حَصَلَ مَطَرٌ':Subject, #2: 2	حَصَلَ الْمَشْرُوطُ
u'حَصَلَ مَطَرٌ':Subject, #1: 1	حَصَلَ مَطَرٌ
u'حَصَلَ مَطْلُوبٌ':Subject, #3: 3	حَصَلَ الْمَطَرُ
u'حَصَلَ مُعارِضٌ':Subject, #1: 1	حَصَلَ الْمَطْلُوبُ
u'حَصَلَ مَعْدُومٌ':Subject, #1: 1	حَصَلَ الْمُعَارِضُ
u'حَصَلَ مُعَلَّقٌ':Subject, #1: 1	حَصَلَ الْمَعْدُومُ
u'حَصَلَ مُفَارَقَةٌ':Subject, #1: 1	حَصَلَ الْمُعَلَّقُ
u'حَصَلَ مَفْرُوضٌ':Subject, #2: 2	حَصَلَ مُفَارَقَةٌ
u'حَصَلَ مُفْسِدٌ':Subject, #1: 1	حَصَلَ الْمَفْرُوضُ
u'حَصَّلَ مِقْدَارٌ':Predicate, #1: 1	حَصَلَ الْمُفْسِدُ
u'حَصَلَ مَقْصُودٌ':Subject, #1: 1	حَصَّلَ مِقْدَارَ
u'حَصَلَ مَقْصُودٌ':Subject, #1: 1	حَصَلَ مَقْصُودٌ
u'حَصَلَ مَقْصُودٌ':Subject, #33: 33	حَصَلَ الْمَقْصُودُ
u'حَصَلَ مَقْصُودٌ':Subject, #4: 4	حَصَلَ مَقْصُودُهُ
u'حَصَلَ مَلْزُوم':Subject, #7: 7	حَصَلَ مَقْصُودُ
u'حَصَلَ مِلْكٌ':Subject, #1: 1	حَصَلَ الْمَلْزُومُ
u'حَصَلَ مَنَافِعُ':Subject, #8: 8	حَصَلَ الْمِلْكُ
u'حَصَلَ مَنْعٌ':Subject, #1: 1	حَصَلَ الْمَنَافِعُ
u'حَصَلَ مُهْرٌ':Subject, #1: 1	حَصَلَ الْمَنْعُ
u'حَصَلَ مَوْتٌ':Subject, #1: 1	حَصَلَ مُهْرٌ
u'حَصَلَ مَوْتٌ':Subject, #1: 1	حَصَلَ مَوْتُهُ
u'حَصَلَ نِتَاجٌ':Subject, #2: 2	حَصَلَ الْمَوْتُ
u'حَصَلَ نَتْنٌ':Subject, #1: 1	حَصَلَ النِّتَاجُ
u'حَصَلَ نذر':Subject, #1: 1	حَصَلَ النَّتْنُ
u'حَصَلَ نَذْرٌ':Subject, #1: 1	حَصَلَ نَذْرُهُ
u'حَصَلَ نزاع':Subject, #1: 1	حَصَلَ نَذْرُهُ
u'حَصَلَ نِزَاعٌ':Subject, #1: 1	حَصَلَ نِزَاعٌ
u'حَصَلَ نُشُوزٌ':Subject, #1: 1	حَصَلَ نِزَاعٌ
u'حَصَلَ نَظَرٌ':Subject, #1: 1	حَصَلَ نُشُوزٌ
u'حَصَلَ نَفْيٌ':Subject, #1: 1	حَصَلَ النَّظَرُ
u'حَصَلَ نَفْيٌ':Subject, #1: 1	حَصَلَ النَّفْيُ
u'حَصَلَ نَقْدٌ':Subject, #1: 1	حَصَلَ نَفْيُ
u'حَصَلَ نَقْد':Subject, #1: 1	حَصَلَ نَقْدُ
u'حَصَلَ نَقْصٌ':Subject, #1: 1	حَصَلَ نَقْدُ
u'حَصَلَ نَقْصٌ':Subject, #3: 3	حَصَلَ نَقْصٌ
u'حَصَلَ نُقْصَانٌ':Subject, #4: 4	حَصَلَ النَّقْصُ
u'حَصَلَ نقل':Subject, #6: 6	حَصَلَ النُّقْصَانُ
u'حَصَلَ نَقْلٌ':Subject, #1: 1	حَصَلَ نَقْلُ
u'حَصَلَ نقل':Subject, #1: 1	حَصَلَ نَقْلُ
u'حَصَلَ نَقْلٌ':Subject, #1: 1	حَصَلَ نَقْلُهُ
u'حَصَلَ نَهْيٌ':Subject, #1: 1	حَصَلَ نَقْلُهُ
u'حَصَلَ نَوْعٌ':Subject, #1: 1	حَصَلَ النَّهْيُ
u'حَصَلَ هلاك':Subject, #1: 1	حَصَلَ نَوْعٌ
u'حَصَلَ هَلاَكٌ':Subject, #5: 5	حَصَلَ الْهَلَاكُ
u'حَصَلَ هَوْلٌ':Subject, #5: 5	حَصَلَ الْهَلَاكُ
u'حَصَلَ هَوْلٌ':Subject, #1: 1	حَصَلَ الْهَوْلُ
u'حَصَّلَ وَاجِبٌ':Predicate, #1: 1	حَصَلَ هَوْلٌ
u'حَصَلَ وَاجِبٌ':Subject, #1: 1	حَصَّلَ الْوَاجِبَ
u'حَصَلَ واحد':Subject, #1: 1	حَصَلَ الْوَاجِبُ
u'حَصَلَ وَاحِدٌ':Subject, #1: 1	حَصَلَ وَاحِدٌ
u'حَصَلَ وُثُوقٌ':Subject, #1: 1	حَصَلَ وَاحِدٌ
u'حَصَلَ وَجْهٌ':Subject, #2: 2	حَصَلَ الْوُثُوقُ
u'حَصَلَ وُجُوبٌ':Subject, #1: 1	حَصَلَ الْوَجْهُ
u'حَصَلَ وسائط':Subject, #1: 1	حَصَلَ الْوُجُوبُ
u'حَصَلَ وَصْفٌ':Subject, #1: 1	حَصَلَ الْوَسَائِطُ
u'حَصَلَ وُصُولٌ':Subject, #1: 1	حَصَلَ الْوَصْفُ
u'حَصَلَ وَضْعٌ':Subject, #1: 1	حَصَلَ الْوُصُولُ
u'حَصَلَ وَطْءٌ':Subject, #1: 1	حَصَلَ وَضْعُ
u'حَصَلَ وَعْدٌ':Subject, #6: 6	حَصَلَ الْوَطْءُ
u'حَصَلَ وَعِيدٌ':Subject, #1: 1	حَصَلَ الْوَعْدُ
u'حَصَلَ وِفَاقٌ':Subject, #1: 1	حَصَلَ وَعِيدٌ
u'حَصَلَ ولد':Subject, #1: 1	حَصَلَ الْوِفَاقُ
u'حَصَلَ وَلَدٌ':Subject, #2: 2	حَصَلَ الْوَلَدُ
u'حَصَلَ وَلَهٌ':Subject, #2: 2	حَصَلَ الْوَلَدُ
u'حَصَلَ وَهْمٌ':Subject, #1: 1	حَصَلَ وَلَهُ
u'حَصَلَ يَأْسٌ':Subject, #1: 1	حَصَلَ وَهْمٌ
u'حَصَلَ يَقِينٌ':Subject, #3: 3	حَصَلَ الْيَأْسُ
u'حَصَلَ يَوْمٌ':Predicate, #1: 1	حَصَلَ الْيَقِينُ
u'حَصِيَ رَمْلٌ':Predicate, #2: 2	حَصَلَ يَوْمَ
u'حَصَى غير':Subject, #9: 9	أَحْصَى رَمْلَ
u'حَصَى غَيْرٌ':Subject, #1: 1	حَصَى غَيْرُ
u'حَضَانَةٌ الْمَرْأَةُ':Added, #1: 1	حَصَى غَيْرُ
u'حَضَانَةٌ أُمٌّ':Added, #1: 1	حَضَانَةُ الْمَرْأَةِ
u'حَضَانَةٌ أُمٌّ':Added, #1: 1	حَضَانَةِ الْأُمِّ
u'حَضَانَةٌ أُمٌّ':Added, #1: 1	حَضَانَةُ أُمِّ
u'حَضَانَةٌ أُمٌّ':Added, #1: 1	حَضَانَةِ أُمِّهِ
u'حَضَانَةٌ إِناثٌ':Added, #2: 2	حَضَانَةُ الْأُمِّ
u'حَضَانَةٌ بِنْتٌ':Added, #1: 1	حَضَانَةُ الْإِنَاثِ
u'حَضَانَةٌ جَارِي':Added, #1: 1	حَضَانَةِ بِنْتِ
u'حَضَانَةٌ جَارِي':Added, #1: 1	حَضَانَةِ الْجَارِيَةِ
u'حَضَانَةٌ جَارِيَةٌ':Added, #3: 3	حَضَانَةُ الْجَارِيَةِ
u'حَضَانَةٌ جَارِيَةٌ':Added, #1: 1	حَضَانَةِ الْجَارِيَةِ
u'حَضَانَةٌ حُرٌّ':Added, #3: 3	حَضَانَةُ الْجَارِيَةِ
u'حَضَانَةٌ ذكر':Added, #1: 1	حَضَانَةِ الْحُرَّةِ
u'حَضَانَةٌ ذَكَرٌ':Added, #1: 1	حَضَانَةُ الذَّكَرِ
u'حَضَانَةٌ رَجُلٌ':Added, #1: 1	حَضَانَةُ الذَّكَرِ
u'حَضَانَةٌ رَقيقٌ':Added, #1: 1	حَضَانَةِ الرَّجُلِ
u'حَضَانَةٌ رَقيق':Added, #1: 1	حَضَانَةُ الرَّقِيقِ
u'حَضَانَةٌ رَقيقٌ':Added, #1: 1	حَضَانَةُ الرَّقِيقِ
u'حَضَانَةٌ رَقيق':Added, #1: 1	حَضَانَةُ رَقِيقِهِ
u'حَضَانَةٌ زَوْجٌ':Added, #1: 1	حَضَانَةُ رَقِيقِهِ
u'حَضَانَةٌ طِفْلٌ':Added, #1: 1	حَضَانَةُ زَوْجِ
u'حَضَانَةٌ عمياء':Added, #1: 1	حَضَانَةُ الطِّفْلِ
u'حَضَانَةٌ لَقِيطٌ':Added, #1: 1	حَضَانَةِ الْعَمْيَاءِ
u'حَضَانَةٌ ولد':Added, #1: 1	حَضَانَةُ اللَّقِيطِ
u'حَضَانَةٌ وَلَدٌ':Added, #1: 1	حَضَانَةِ وَلَدِ
u'حَضَانَةٌ ولد':Added, #1: 1	حَضَانَةِ وَلَدِ
u'حَضَانَةٌ وَلَدٌ':Added, #2: 2	حَضَانَةِ الْوَلَدِ
u'حَضَرَ أَبٌ':Subject, #2: 2	حَضَانَةِ الْوَلَدِ
u'حَضَرَ اِبْنٌ':Subject, #4: 4	حَضَرَ الْأَبُ
u'حَضَرَ أَجَلٌ':Subject, #4: 4	حَضَرَ ابْنُ
u'حَضَرَ أحَدٌ':Subject, #2: 2	حَضَرَ أَجَلُهُ
u'حَضَرَ أحَدٌ':Subject, #1: 1	حَضَرَ أَحَدٌ
u'حَضَرَ أَخٌ':Subject, #5: 5	حَضَرَ أَحَدُ
u'حَضَرَ أَذَانٌ':Predicate, #2: 2	حَضَرَ الْأَخُ
u'حَضَرَ أَرَاضِي':Predicate, #2: 2	حَضَرَ الْأَذَانَ
u'حَضَرَ أرْبَابٌ':Subject, #2: 2	حَضَرَ الْأَرَاضِيَ
u'حَضَرَ أَرْبَعَةٌ':Subject, #1: 1	حَضَرَ أَرْبَابُ
u'حَضَرَ أَسَدٌ':Subject, #1: 1	حَضَرَ الْأَرْبَعَةُ
u'حَضَرَ أَصْحَابٌ':Subject, #2: 2	حَضَرَ الْأَسَدُ
u'حَضَرَ أصل':Subject, #3: 3	حَضَرَ أَصْحَابُ
u'حَضَرَ أًصْلٌ':Subject, #1: 1	حَضَرَ الْأَصْلُ
u'حَضَرَ أُصولٌ':Subject, #1: 1	حَضَرَ الْأَصْلُ
u'حَضَرَ أَصيلٌ':Subject, #4: 4	حَضَرَ الْأُصُولُ
u'حَضَرَ إِعادَةٌ':Predicate, #2: 2	حَضَرَ الْأَصِيلُ
u'حَضَرَ إِفْطارٌ':Subject, #1: 1	حَضَرَ إعَادَةَ
u'حَضَرَ إِفْطارٌ':Subject, #1: 1	حَضَرَ الإِفْطَارُ
u'حَضَرَ أقْرَبُ':Subject, #2: 2	حَضَرَ الْإِفْطَارُ
u'حَضَرَ أكابر':Subject, #2: 2	حَضَرَ الْأَقْرَبُ
u'حَضَرَ ألف':Predicate, #1: 1	حَضَرَ الْأَكَابِرُ
u'حَضَرَ ألْفٌ':Predicate, #1: 1	حَضَرَ أَلْفَ
u'حَضَرَ أَلْفٌ':Predicate, #1: 1	حَضَرَ أَلْفَ
u'حَضَرَ المُشْتَرِي':Predicate, #1: 1	حَضَرَ أَلْفَ
u'حَضَرَ إمَامٌ':Subject, #1: 1	حَضَرَ الْمُشْتَرِيَ
u'حَضَرَ آمِرٌ':Subject, #6: 6	حَضَرَ الْإِمَامُ
u'حَضِرَ اِمْرَأَةٌ':Predicate, #4: 4	حَضَرَ الْآمِرُ
u'حَضَرَ اِمْرَأَةٌ':Subject, #1: 1	أَحْضَرَ امْرَأَةَ
u'حَضَرَ أُمِّيٌّ':Subject, #1: 1	حَضَرَ امْرَأَةُ
u'حَضَرَ أَوَّلُ':Subject, #3: 3	حَضَرَ الْأُمِّيُّ
u'حَضَرَ أَوْلِيَاءُ':Subject, #5: 5	حَضَرَ الْأَوَّلُ
u'حَضَرَ أيَّامٌ':Predicate, #1: 1	حَضَرَ الْأَوْلِيَاءُ
u'حَضَرَ أَيَّامٌ':Predicate, #1: 1	حَضَرَ أَيَّامَ
u'حَضَرَ بَابٌ':Predicate, #1: 1	حَضَرَ أَيَّامَ
u'حَضَرَ بَائِعٌ':Subject, #1: 1	حَضَرَ بَابَ
u'حَضَرَ بِشْرٌ':Predicate, #11: 11	حَضَرَ الْبَائِعُ
u'حَضَرَ بَعْضٌ':Predicate, #1: 1	حَضَرَ بِشْرَ
u'حَضَرَ بَعْضٌ':Subject, #2: 2	حَضَرَ بَعْضَ
u'حَضَرَ بَعْضٌ':Subject, #2: 2	حَضَرَ الْبَعْضُ
u'حَضَرَ بَيْعٌ':Predicate, #2: 2	حَضَرَ بَعْضُ
u'حَضِرَ بَيِّنَةٌ':Predicate, #3: 3	حَضَرَ الْبَيْعَ
u'حَضَرَ تَكْبيرٌ':Predicate, #1: 1	أَحْضَرَ الْبَيِّنَةَ
u'حَضَرَ ثَالِثٌ':Subject, #1: 1	حَضَرَ تَكْبِيرَ
u'حَضَرَ ثَالِثٌ':Subject, #3: 3	حَضَرَ ثَالِثٌ
u'حَضَرَ ثَمانِيَةٌ':Subject, #5: 5	حَضَرَ الثَّالِثُ
u'حَضِرَ ثَمَنٌ':Predicate, #1: 1	حَضَرَ ثَمَانِيَةٌ
u'حَضَرَ جَارِي':Predicate, #1: 1	أَحْضَرَ الثَّمَنَ
u'حَضَرَ جَامِعٌ':Predicate, #1: 1	حَضَرَ جَارِيَةً
u'حَضَرَ جداد':Subject, #1: 1	حَضَرَ الْجَامِعَ
u'حَضِرَ جلد':Predicate, #1: 1	حَضَرَ جِدَادُ
u'حَضِرَ جِلْدٌ':Predicate, #2: 2	أَحْضَرَ الْجِلْدَ
u'حَضَرَ جَمَاعَةٌ':Subject, #2: 2	أَحْضَرَ الْجِلْدَ
u'حَضَرَ جمعة':Predicate, #2: 2	حَضَرَ جَمَاعَةٌ
u'حَضَرَ جُمُعَةٌ':Predicate, #7: 7	حَضَرَ الْجُمُعَةَ
u'حَضَرَ جَنَازَةٌ':Predicate, #7: 7	حَضَرَ الْجُمُعَةَ
u'حَضَرَ حاضِرٌ':Predicate, #1: 1	حَضَرَ جَنَازَةَ
u'حَضَرَ حاكِمٌ':Subject, #1: 1	حَضَرَ الْحَاضِرَ
u'حَضَرَ حالٌ':Predicate, #1: 1	حَضَرَ الْحَاكِمُ
u'حَضَرَ حَجٌّ':Subject, #3: 3	حَضَرَ حَالَ
u'حَضَرَ حُرٌّ':Subject, #1: 1	حَضَرَ الْحَجُّ
u'حَضَرَ حُرٌّ':Subject, #1: 1	حَضَرَ حُرٌّ
u'حَضَرَ حِصَّةٌ':Subject, #2: 2	حَضَرَ حُرُّ
u'حَضَرَ حَقٌّ':Subject, #1: 1	حَضَرَ حِصَّتُهُ
u'حَضَرَ خَاطِبٌ':Subject, #1: 1	حَضَرَ حَقُّ
u'حَضَرَ خُبْزٌ':Subject, #1: 1	حَضَرَ الْخَاطِبُ
u'حَضَرَ خُرُوجٌ':Subject, #2: 2	حَضَرَ الْخُبْزُ
u'حَضَرَ خَصْمٌ':Subject, #1: 1	حَضَرَ خُرُوجُ
u'حَضَرَ خَصْمٌ':Subject, #1: 1	حَضَرَ خَصْمُهُ
u'حَضَرَ خطبة':Predicate, #3: 3	حَضَرَ الْخَصْمُ
u'حَضَرَ خُطْبَةٌ':Predicate, #2: 2	حَضَرَ الْخُطْبَةَ
u'حَضَرَ خَلِيفَةٌ':Subject, #2: 2	حَضَرَ الْخُطْبَةَ
u'حَضَرَ دَارٌ':Predicate, #1: 1	حَضَرَ الْخَلِيفَةُ
u'حَضَرَ دَائِنٌ':Subject, #1: 1	حَضَرَ دَارَ
u'حَضَرَ دَرَاهِمُ':Predicate, #3: 3	حَضَرَ الدَّائِنُ
u'حَضَرَ دَعْوَةٌ':Predicate, #1: 1	حَضَرَ دَرَاهِمَ
u'حَضَرَ دفن':Predicate, #1: 1	حَضَرَ الدَّعْوَةَ
u'حَضَرَ دَفْنٌ':Predicate, #2: 2	حَضَرَ الدَّفْنَ
u'حَضَرَ دفن':Predicate, #2: 2	حَضَرَ الدَّفْنَ
u'حَضَرَ دَفْنٌ':Predicate, #3: 3	حَضَرَ دَفْنَ
u'حَضِرَ دَنانيرُ':Predicate, #3: 3	حَضَرَ دَفْنَ
u'حَضِرَ دَيْنٌ':Predicate, #1: 1	أَحْضَرَ الدَّنَانِيرَ
u'حَضَرَ رابع':Subject, #2: 2	أَحْضَرَ الدَّيْنَ
u'حَضَرَ رَابِعٌ':Subject, #1: 1	حَضَرَ الرَّابِعُ
u'حَضَرَ رابع':Subject, #1: 1	حَضَرَ الرَّابِعُ
u'حَضَرَ رَابِعٌ':Subject, #1: 1	حَضَرَ رَابِعٌ
u'حَضَرَ رَاهِنٌ':Subject, #1: 1	حَضَرَ رَابِعٌ
u'حَضَرَ رَأْيٌ':Predicate, #2: 2	حَضَرَ الرَّاهِنُ
u'حَضَرَ رَأْيٌ':Subject, #1: 1	حَضَرَ رَأْيَ
u'حَضَرَ رَأْيٌ':Subject, #1: 1	حَضَرَ رَأْيُ
u'حَضَرَ رَبُّ':Subject, #4: 4	حَضَرَ رَأْيُهُ
u'حَضَرَ رَبُّ':Subject, #1: 1	حَضَرَ رَبُّهُ
u'حَضَرَ رَجُلٌ':Predicate, #2: 2	حَضَرَ رَبُّ
u'حَضَرَ رَجُلٌ':Subject, #2: 2	حَضَرَ رَجُلاً
u'حَضَرَ رَجُلٌ':Subject, #12: 12	حَضَرَ رَجُلٌ
u'حَضَرَ رَحِيلٌ':Subject, #4: 4	حَضَرَ الرَّجُلُ
u'حَضَرَ رُسُلٌ':Subject, #1: 1	حَضَرَ الرَّحِيلُ
u'حَضَرَ رَسُولٌ':Predicate, #1: 1	حَضَرَ رُسُلُهُ
u'حَضَرَ رَسُولٌ':Subject, #1: 1	حَضَرَ رَسُولَ
u'حَضَرَ رَمَضانُ':Subject, #2: 2	حَضَرَ رَسُولُ
u'حَضَرَ زُبْيَةٌ':Predicate, #1: 1	حَضَرَ رَمَضَانُ
u'حَضَرَ زَوْجٌ':Subject, #1: 1	حَضَرَ الزُّبْيَةَ
u'حَضَرَ زَوْجٌ':Subject, #10: 10	حَضَرَ الزَّوْجُ
u'حَضَرَ سَاقِطٌ':Subject, #1: 1	حَضَرَ زَوْجُ
u'حَضَرَ سَبَبٌ':Predicate, #3: 3	حَضَرَ سَاقِطَةٌ
u'حَضَرَ سَبَبٌ':Subject, #1: 1	حَضَرَ سَبَبَ
u'حَضَرَ سَفَرٌ':Subject, #1: 1	حَضَرَ السَّبَبُ
u'حَضَرَ سُوقٌ':Predicate, #1: 1	حَضَرَ سَفَرٌ
u'حَضَرَ سَيِّدٌ':Subject, #1: 1	حَضَرَ سُوقَ
u'حَضَرَ شَاهِدٌ':Subject, #1: 1	حَضَرَ السَّيِّدُ
u'حَضَرَ شِتَاءٌ':Subject, #1: 1	حَضَرَ شَاهِدُ
u'حَضَرَ شَخْصٌ':Subject, #1: 1	حَضَرَ الشِّتَاءُ
u'حَضَرَ شِرَاءٌ':Predicate, #2: 2	حَضَرَ شَخْصٌ
u'حَضَرَ شركاء':Subject, #1: 1	حَضَرَ الشِّرَاءَ
u'حَضَرَ شركة':Predicate, #5: 5	حَضَرَ الشُّرَكَاءُ
u'حَضَرَ شَرِكَةٌ':Predicate, #1: 1	حَضَرَ شَرِكَةَ
u'حَضَرَ شَرِيكٌ':Subject, #1: 1	حَضَرَ شَرِكَةَ
u'حَضَرَ شَرِيكٌ':Subject, #1: 1	حَضَرَ الشَّرِيكُ
u'حَضَرَ شَفِيعٌ':Predicate, #1: 1	حَضَرَ شَرِيكُ
u'حَضَرَ شَفِيعٌ':Subject, #1: 1	حَضَرَ شَفِيعَ
u'حَضَرَ شَفِيعٌ':Subject, #1: 1	حَضَرَ شَفِيعُهُ
u'حَضَرَ شَفِيعٌ':Subject, #26: 26	حَضَرَ الشَّفِيعُ
u'حَضَرَ شَهْرٌ':Predicate, #5: 5	حَضَرَ شَفِيعُ
u'حَضَرَ شُهُودٌ':Subject, #1: 1	حَضَرَ شَهْرَ
u'حَضَرَ شُهُودٌ':Subject, #1: 1	حَضَرَ شُهُودُ
u'حَضَرَ صَاحِبٌ':Subject, #2: 2	حَضَرَ الشُّهُودُ
u'حَضَرَ صَاحِبٌ':Subject, #1: 1	حَضَرَ صَاحِبُهُ
u'حَضَرَ صَبِيٌّ':Subject, #5: 5	حَضَرَ صَاحِبُ
u'حَضَرَ صِبْيَانٌ':Subject, #1: 1	حَضَرَ صَبِيٌّ
u'حَضَرَ صَغِيرٌ':Subject, #2: 2	حَضَرَ الصِّبْيَانُ
u'حَضَرَ صَفٌّ':Predicate, #1: 1	حَضَرَ صَغِيرٌ
u'حَضَرَ صَلاَةٌ':Predicate, #3: 3	حَضَرَ الصَّفَّ
u'حَضَرَ صَلاَةٌ':Predicate, #2: 2	حَضَرَ الصَّلَاةَ
u'حَضَرَ صَلاَةٌ':Predicate, #2: 2	حَضَرَ صَلَاةَ
u'حَضَرَ ضَرْبٌ':Predicate, #3: 3	حَضَرَ صَلاَةَ
u'حَضَرَ طابِخ':Subject, #2: 2	حَضَرَ ضَرْبَ
u'حَضَرَ طَالِبٌ':Subject, #1: 1	حَضَرَ الطَّابِخُ
u'حَضَرَ طعام':Subject, #5: 5	حَضَرَ الطَّالِبُ
u'حَضَرَ طَعَامٌ':Subject, #1: 1	حَضَرَ طَعَامُهُ
u'حَضَرَ طعام':Subject, #1: 1	حَضَرَ طَعَامُهُ
u'حَضَرَ طَعَامٌ':Subject, #3: 3	حَضَرَ الطَّعَامُ
u'حَضِرَ ظالِمٌ':Predicate, #3: 3	حَضَرَ الطَّعَامُ
u'حَضَرَ عَامِلٌ':Subject, #1: 1	أَحْضَرَ ظَالِمَةً
u'حَضِرَ عَبْدٌ':Predicate, #2: 2	حَضَرَ الْعَامِلُ
u'حَضَرَ عَبْدٌ':Subject, #1: 1	أَحْضَرَ الْعَبْدَ
u'حَضَرَ عَدُوٌّ':Subject, #1: 1	حَضَرَ الْعَبْدُ
u'حَضَرَ عَدُوٌّ':Subject, #1: 1	حَضَرَ عَدُوٌّ
u'حَضَرَ عرفة':Predicate, #5: 5	حَضَرَ الْعَدُوُّ
u'حَضَرَ عِشَاءٌ':Subject, #1: 1	حَضَرَ عَرَفَةَ
u'حَضَرَ عَشَاءٌ':Subject, #1: 1	حَضَرَ الْعِشَاءُ
u'حَضَرَ عقبة':Predicate, #6: 6	حَضَرَ الْعَشَاءُ
u'حَضَرَ عَقَبَةٌ':Predicate, #2: 2	حَضَرَ الْعَقَبَةَ
u'حَضَرَ عَقْدٌ':Predicate, #2: 2	حَضَرَ الْعَقَبَةَ
u'حَضَرَ عَقْدٌ':Predicate, #2: 2	حَضَرَ عَقْدَ
u'حَضَرَ علم':Predicate, #6: 6	حَضَرَ الْعَقْدَ
u'حَضَرَ عند':Predicate, #1: 1	حَضَرَ عَلِمَ
u'حَضِرَ عند':Predicate, #11: 11	حَضَرَ عِنْدَ
u'حَضَرَ عِيدٌ':Predicate, #1: 1	أَحْضَرَ عِنْدَ
u'حَضَرَ غَائِبٌ':Subject, #2: 2	حَضَرَ الْعِيدَ
u'حَضَرَ غرماء':Subject, #102: 102	حَضَرَ الْغَائِبُ
u'حَضَرَ غرماء':Subject, #2: 2	حَضَرَ غُرَمَاءُ
u'حَضَرَ غَرِيمٌ':Subject, #6: 6	حَضَرَ الْغُرَمَاءُ
u'حَضَرَ غُلاَمٌ':Subject, #5: 5	حَضَرَ الْغَرِيمُ
u'حَضَرَ غَنِيمَةٌ':Predicate, #1: 1	حَضَرَ غُلَامٌ
u'حَضَرَ غير':Predicate, #1: 1	حَضَرَ الْغَنِيمَةَ
u'حَضَرَ غَيْرٌ':Predicate, #1: 1	حَضَرَ غَيْرَ
u'حَضَرَ غير':Subject, #1: 1	حَضَرَ غَيْرَ
u'حَضَرَ غَيْرٌ':Subject, #1: 1	حَضَرَ غَيْرُ
u'حَضَرَ غير':Subject, #1: 1	حَضَرَ غَيْرُ
u'حَضَرَ غَيْرٌ':Subject, #1: 1	حَضَرَ غَيْرُهُ
u'حَضَرَ فَرِيقٌ':Subject, #1: 1	حَضَرَ غَيْرُهُ
u'حَضِرَ فقهاء':Predicate, #2: 2	حَضَرَ الْفَرِيقُ
u'حَضَرَ فلان':Predicate, #1: 1	أَحْضَرَ الْفُقَهَاءَ
u'حَضَرَ فلان':Predicate, #1: 1	حَضَرَ حُذَيْفَةَ
u'حَضَرَ فلان':Predicate, #1: 1	حَضَرَ هَرَاةَ
u'حَضَرَ فُلاَنٌ':Subject, #6: 6	حَضَرَ خَيْبَرَ
u'حَضَرَ فلان':Subject, #17: 17	حَضَرَ فُلَانٌ
u'حَضَرَ فُلاَنٌ':Subject, #1: 1	حَضَرَ بِلاَلٌ
u'حَضَرَ قَارِئٌ':Subject, #4: 4	حَضَرَ فُلَانُ
u'حَضَرَ قَاسِمٌ':Predicate, #2: 2	حَضَرَ الْقَارِئُ
u'حَضَرَ قَاضِي':Predicate, #1: 1	حَضَرَ الْقَاسِمَ
u'حَضَرَ قَالٌ':Predicate, #1: 1	حَضَرَ الْقَاضِيَ
u'حَضَرَ قتال':Predicate, #4: 4	حَضَرَ قَالَ
u'حَضَرَ قِتَالٌ':Predicate, #12: 12	حَضَرَ الْقِتَالَ
u'حَضَرَ قتال':Subject, #12: 12	حَضَرَ الْقِتَالَ
u'حَضَرَ قِتَالٌ':Subject, #1: 1	حَضَرَ الْقِتَالُ
u'حَضَرَ قتال':Subject, #1: 1	حَضَرَ الْقِتَالُ
u'حَضَرَ قِتَالٌ':Subject, #1: 1	حَضَرَ قِتَالُ
u'حَضَرَ قتل':Predicate, #1: 1	حَضَرَ قِتَالُ
u'حَضَرَ قَتْلٌ':Predicate, #1: 1	حَضَرَ الْقَتْلَ
u'حَضَرَ قَسْمٌ':Predicate, #1: 1	حَضَرَ الْقَتْلَ
u'حَضَرَ قسمة':Predicate, #3: 3	حَضَرَ الْقَسْمَ
u'حَضَرَ قِسْمَةٌ':Predicate, #12: 12	حَضَرَ الْقِسْمَةَ
u'حَضَرَ قَضَاءٌ':Predicate, #12: 12	حَضَرَ الْقِسْمَةَ
u'حَضَرَ قلب':Subject, #1: 1	حَضَرَ قَضَاءَ
u'حَضَرَ قَلْبٌ':Subject, #1: 1	حَضَرَ قَلْبُهُ
u'حَضَرَ قَلْب':Subject, #1: 1	حَضَرَ قَلْبُهُ
u'حَضَرَ قَوْمٌ':Subject, #1: 1	حَضَرَ قَلْبُهُ
u'حَضَرَ قَوْمٌ':Subject, #1: 1	حَضَرَ الْقَوْمُ
u'حَضَرَ كبار':Subject, #3: 3	حَضَرَ قَوْمٌ
u'حَضَرَ كِتَابٌ':Predicate, #1: 1	حَضَرَ الْكِبَارُ
u'حَضَرَ كِتَابٌ':Predicate, #1: 1	حَضَرَ الْكِتَابَ
u'حَضَرَ كُفَّارٌ':Subject, #1: 1	حَضَرَ كِتَابَ
u'حَضَرَ كَفِيلٌ':Subject, #1: 1	حَضَرَ الْكُفَّارُ
u'حَضِرَ لحمة':Predicate, #7: 7	حَضَرَ الْكَفِيلُ
u'حَضِرَ لُحْمَةٌ':Predicate, #1: 1	أَحْضَرَ اللُّحْمَةَ
u'حَضَرَ لَيْثٌ':Subject, #1: 1	أَحْضَرَ اللُّحْمَةَ
u'حَضِرَ مَالٌ':Predicate, #2: 2	حَضَرَ اللَّيْثُ
u'حَضِرَ مَالٌ':Predicate, #1: 1	أَحْضَرَ مَالَ
u'حَضَرَ مَالٌ':Subject, #3: 3	أَحْضَرَ الْمَالَ
u'حَضَرَ مَالٌ':Subject, #1: 1	حَضَرَ مَالُ
u'حَضَرَ مَالِكٌ':Subject, #2: 2	حَضَرَ مَالُهُ
u'حَضَرَ مُبَايَعَةٌ':Predicate, #19: 19	حَضَرَ الْمَالِكُ
u'حَضِرَ مَبْلَغٌ':Predicate, #1: 1	حَضَرَ الْمُبَايَعَةَ
u'حَضَرَ مَجْلِسٌ':Predicate, #1: 1	أَحْضَرَ الْمَبْلَغَ
u'حَضَرَ مَجْلِسٌ':Predicate, #1: 1	حَضَرَ الْمَجْلِسَ
u'حَضِرَ مَجُوسِيٌّ':Predicate, #28: 28	حَضَرَ مَجْلِسَ
u'حَضَرَ مُحَمَّدٌ':Subject, #1: 1	أَحْضَرَ الْمَجُوسِيَّ
u'حَضَرَ مَحْمُودٌ':Subject, #1: 1	حَضَرَ مُحَمَّدُ
u'حَضَرَ مُحِيل':Subject, #1: 1	حَضَرَ مَحْمُودُ
u'حَضَرَ مُسَافِرٌ':Subject, #1: 1	حَضَرَ الْمُحِيلُ
u'حَضَرَ مساكين':Subject, #1: 1	حَضَرَ الْمُسَافِرُ
u'حَضَرَ مُسْتَحِقٌّ':Subject, #1: 1	حَضَرَ مَسَاكِينُ
u'حَضَرَ مَسْجِدٌ':Predicate, #1: 1	حَضَرَ الْمُسْتَحِقُّ
u'حَضَرَ مُسْلِمٌ':Subject, #3: 3	حَضَرَ الْمَسْجِدَ
u'حَضَرَ مُسْلِمٌ':Subject, #1: 1	حَضَرَ الْمُسْلِمُ
u'حَضَرَ مُشْتَرِي':Predicate, #1: 1	حَضَرَ مُسْلِمٌ
u'حَضَرَ مُصَدِّقٌ':Subject, #1: 1	حَضَرَ الْمُشْتَرِيَ
u'حَضَرَ مِصْرٌ':Predicate, #5: 5	حَضَرَ الْمُصَدِّقُ
u'حَضَرَ مَصِيفٌ':Subject, #3: 3	حَضَرَ الْمِصْرَ
u'حَضَرَ مَطْلُوبٌ':Subject, #1: 1	حَضَرَ الْمَصِيفُ
u'حَضِرَ مَغْصُوب':Predicate, #1: 1	حَضَرَ الْمَطْلُوبُ
u'حَضَرَ مَغْصُوب':Subject, #1: 1	أَحْضَرَ الْمَغْصُوبَ
u'حَضَرَ مَقْذُوفٌ':Subject, #1: 1	حَضَرَ الْمَغْصُوبُ
u'حَضِرَ مَقْصُورٌ':Predicate, #3: 3	حَضَرَ الْمَقْذُوفُ
u'حَضِرَ مَكْفُولٌ':Predicate, #2: 2	أَحْضَرَ الْمَقْصُورَ
u'حَضَرَ مَكْفُولٌ':Subject, #2: 2	أَحْضَرَ الْمَكْفُولَ
u'حَضَرَ مِلْكِيَّةٌ':Predicate, #1: 1	حَضَرَ الْمَكْفُولُ
u'حَضَرَ مُنْكَرٌ':Predicate, #1: 1	حَضَرَ مِلْكِيَّةَ
u'حَضَرَ مُؤَجِّرٌ':Subject, #2: 2	حَضَرَ الْمُنْكَرَ
u'حَضَرَ مُودِعٌ':Subject, #1: 1	حَضَرَ الْمُؤَجِّرُ
u'حَضَرَ مَوْسِمٌ':Predicate, #4: 4	حَضَرَ الْمُودِعُ
u'حَضِرَ مُوَكِّلٌ':Predicate, #1: 1	حَضَرَ الْمَوْسِمَ
u'حَضَرَ مُوَكِّلٌ':Subject, #1: 1	أَحْضَرَ الْمُوَكِّلَ
u'حَضَرَ مُوَكِّلٌ':Subject, #16: 16	حَضَرَ الْمُوَكِّلُ
u'حَضَرَ مُوَكِّلٌ':Subject, #1: 1	حَضَرَ مُوَكِّلُ
u'حَضَرَ مَوْهُوبٌ':Subject, #2: 2	حَضَرَ مُوَكِّلُهُ
u'حَضَرَ نَاسٌ':Subject, #2: 2	حَضَرَ الْمَوْهُوبُ
u'حَضَرَ نَبِيٌّ':Subject, #1: 1	حَضَرَ نَاسٌ
u'حَضَرَ نِساءٌ':Subject, #2: 2	حَضَرَ النَّبِيُّ
u'حَضِرَ نِصْفٌ':Predicate, #1: 1	حَضَرَ نِسَاءٌ
u'حَضَرَ نكاح':Predicate, #5: 5	أَحْضَرَ نِصْفَ
u'حَضَرَ نِكَاحٌ':Predicate, #1: 1	حَضَرَ نِكَاحَ
u'حَضَرَ هَرا':Predicate, #1: 1	حَضَرَ نِكَاحَ
u'حَضَرَ واحد':Subject, #1: 1	حَضَرَ هَرَاةَ
u'حَضَرَ وَاحِدٌ':Subject, #17: 17	حَضَرَ وَاحِدٌ
u'حَضَرَ وَارِثٌ':Subject, #17: 17	حَضَرَ وَاحِدٌ
u'حَضَرَ وَارِثٌ':Subject, #12: 12	حَضَرَ وَارِثٌ
u'حَضَرَ وَارِثٌ':Subject, #2: 2	حَضَرَ وَارِثُهُ
u'حَضَرَ وَجَبٌ':Predicate, #5: 5	حَضَرَ الْوَارِثُ
u'حَضَرَ وَرَثَةٌ':Subject, #1: 1	حَضَرَ وَجَبَ
u'حَضِرَ وَصِيٌّ':Predicate, #1: 1	حَضَرَ الْوَرَثَةُ
u'حَضَرَ وَصِيٌّ':Predicate, #1: 1	أَحْضَرَ وَصِيَّ
u'حَضَرَ وَصِيٌّ':Subject, #1: 1	حَضَرَ وَصِيَّ
u'حَضَرَ وَصِيٌّ':Subject, #1: 1	حَضَرَ وَصِيٌّ
u'حَضَرَ وَقْتٌ':Predicate, #2: 2	حَضَرَ الْوَصِيُّ
u'حَضَرَ وَقْتٌ':Subject, #2: 2	حَضَرَ وَقْتَ
u'حَضَرَ وَقْتٌ':Subject, #1: 1	حَضَرَ الْوَقْتُ
u'حَضَرَ وَقْتٌ':Subject, #4: 4	حَضَرَ وَقْتُ
u'حَضَرَ وقعة':Predicate, #4: 4	حَضَرَ وَقْتُهُ
u'حَضَرَ وَقْعَةٌ':Predicate, #6: 6	حَضَرَ الْوَقْعَةَ
u'حَضَرَ وَكِيلٌ':Subject, #6: 6	حَضَرَ الْوَقْعَةَ
u'حَضَرَ ولد':Predicate, #2: 2	حَضَرَ الْوَكِيلُ
u'حَضَرَ ولد':Subject, #2: 2	حَضَرَ وُلِدَ
u'حَضَرَ وَلَدٌ':Subject, #1: 1	حَضَرَ الْوَلَدُ
u'حَضَرَ وَلَهٌ':Subject, #1: 1	حَضَرَ الْوَلَدُ
u'حَضَرَ وَلِيٌّ':Subject, #1: 1	حَضَرَ وَلَهُ
u'حَضَرَ وَلِيٌّ':Subject, #1: 1	حَضَرَ الْوَلِيُّ
u'حَضَرَ وَلِيمَةٌ':Predicate, #1: 1	حَضَرَ وَلِيُّ
u'حَضَرَ يَوْمٌ':Predicate, #1: 1	حَضَرَ الْوَلِيمَةَ
u'حَضَرَ يَوْمٌ':Predicate, #1: 1	حَضَرَ الْيَوْمَ
u'حَضَنَ غَاصِبٌ':Subject, #3: 3	حَضَرَ يَوْمَ
u'حَضَنَ ولد':Predicate, #1: 1	حَضَنَ الْغَاصِبُ
u'حَضَنَ وَلَدٌ':Predicate, #1: 1	حَضَنَ الْوَلَدَ
u'حُضورٌ أَبٌ':Added, #1: 1	حَضَنَ الْوَلَدَ
u'حُضُورٌ أَبٌ':Added, #1: 1	حُضُورِ الْأَبِ
u'حُضورٌ أَجَلٌ':Added, #1: 1	حُضُورِ الْأَبِ
u'حُضُورٌ أَجَلٌ':Added, #1: 1	حُضُورُ أَجَلِ
u'حُضورٌ أحَدٌ':Added, #1: 1	حُضُورُ أَجَلِ
u'حُضورٌ أحَدٌ':Added, #1: 1	حُضُورُ أَحَدٍ
u'حُضُورٌ أحَدٌ':Added, #1: 1	حُضُورُ أَحَدِ
u'حُضُورٌ أحَدٌ':Added, #1: 1	حُضُورُ أَحَدٍ
u'حُضورٌ أراذل':Added, #1: 1	حُضُورُ أَحَدِ
u'حُضُورٌ أراذل':Added, #1: 1	حُضُورَ الْأَرَاذِلِ
u'حُضورٌ أرْذَالٌ':Added, #1: 1	حُضُورَ الْأَرَاذِلِ
u'حُضُورٌ أرْذَالٌ':Added, #1: 1	حُضُورَ الْأَرْذَالِ
u'حُضورٌ أَصْحَابٌ':Added, #1: 1	حُضُورَ الْأَرْذَالِ
u'حُضُورٌ أَصْحَابٌ':Added, #1: 1	حُضُورُ أَصْحَابِ
u'حُضورٌ أصل':Added, #1: 1	حُضُورُ أَصْحَابِ
u'حُضورٌ أًصْلٌ':Added, #10: 10	حُضُورِ الْأَصْلِ
u'حُضُورٌ أصل':Added, #10: 10	حُضُورِ الْأَصْلِ
u'حُضُورٌ أًصْلٌ':Added, #10: 10	حُضُورِ الْأَصْلِ
u'حُضورٌ أصل':Added, #10: 10	حُضُورِ الْأَصْلِ
u'حُضورٌ أًصْلٌ':Added, #1: 1	حُضُورِ أَصْلِهِ
u'حُضُورٌ أصل':Added, #1: 1	حُضُورِ أَصْلِهِ
u'حُضُورٌ أًصْلٌ':Added, #1: 1	حُضُورِ أَصْلِهِ
u'حُضورٌ أصل':Added, #1: 1	حُضُورِ أَصْلِهِ
u'حُضورٌ أًصْلٌ':Added, #1: 1	حُضُورُ الْأَصْلِ
u'حُضُورٌ أصل':Added, #1: 1	حُضُورُ الْأَصْلِ
u'حُضُورٌ أًصْلٌ':Added, #1: 1	حُضُورُ الْأَصْلِ
u'حُضورٌ أَعْوَانٌ':Added, #1: 1	حُضُورُ الْأَصْلِ
u'حُضُورٌ أَعْوَانٌ':Added, #1: 1	حُضُورُ الْأَعْوَانِ
u'حُضورٌ الْمَرْأَةُ':Added, #1: 1	حُضُورُ الْأَعْوَانِ
u'حُضورٌ الْمَرْأَةُ':Added, #1: 1	حُضُورَ الْمَرْأَةِ
u'حُضُورٌ الْمَرْأَةُ':Added, #1: 1	حُضُورُ الْمَرْأَةِ
u'حُضُورٌ الْمَرْأَةُ':Added, #1: 1	حُضُورَ الْمَرْأَةِ
u'حُضورٌ أُمٌّ':Added, #1: 1	حُضُورُ الْمَرْأَةِ
u'حُضُورٌ أُمٌّ':Added, #1: 1	حُضُورُ أُمِّ
u'حُضورٌ إمَامٌ':Added, #1: 1	حُضُورُ أُمِّ
u'حُضُورٌ إمَامٌ':Added, #1: 1	حُضُورِ الْإِمَامِ
u'حُضورٌ إمَامٌ':Added, #1: 1	حُضُورِ الْإِمَامِ
u'حُضُورٌ إمَامٌ':Added, #2: 2	حُضُورَ الْإِمَامِ
u'حُضورٌ إمَامٌ':Added, #2: 2	حُضُورَ الْإِمَامِ
u'حُضُورٌ إمَامٌ':Added, #2: 2	حُضُورَ إمَامِ
u'حُضورٌ باقِي':Added, #2: 2	حُضُورَ إمَامِ
u'حُضُورٌ باقِي':Added, #1: 1	حُضُورَ الْبَاقِيَيْنِ
u'حُضورٌ بَائِعٌ':Added, #1: 1	حُضُورَ الْبَاقِيَيْنِ
u'حُضُورٌ بَائِعٌ':Added, #1: 1	حُضُورَ الْبَائِعِ
u'حُضورٌ بَائِعٌ':Added, #1: 1	حُضُورَ الْبَائِعِ
u'حُضُورٌ بَائِعٌ':Added, #5: 5	حُضُورُ الْبَائِعِ
u'حُضورٌ بَعْضٌ':Added, #5: 5	حُضُورُ الْبَائِعِ
u'حُضُورٌ بَعْضٌ':Added, #2: 2	حُضُورَ بَعْضِ
u'حُضورٌ تَرِكَةٌ':Added, #2: 2	حُضُورَ بَعْضِ
u'حُضُورٌ تَرِكَةٌ':Added, #1: 1	حُضُورِ التَّرِكَةِ
u'حُضورٌ جَامِعٌ':Added, #1: 1	حُضُورِ التَّرِكَةِ
u'حُضُورٌ جَامِعٌ':Added, #1: 1	حُضُورَ الْجَامِعِ
u'حُضورٌ جُزْءٌ':Added, #1: 1	حُضُورَ الْجَامِعِ
u'حُضُورٌ جُزْءٌ':Added, #1: 1	حُضُورُ جُزْءِ
u'حُضورٌ جَمٌّ':Added, #1: 1	حُضُورُ جُزْءِ
u'حُضُورٌ جَمٌّ':Added, #1: 1	حُضُورُ الْجَمِّ
u'حُضورٌ جَمَاعَةٌ':Added, #1: 1	حُضُورُ الْجَمِّ
u'حُضورٌ جَمَاعَةٌ':Added, #1: 1	حُضُورَ جَمَاعَةٍ
u'حُضُورٌ جَمَاعَةٌ':Added, #1: 1	حُضُورُ جَمَاعَةِ
u'حُضُورٌ جَمَاعَةٌ':Added, #1: 1	حُضُورَ جَمَاعَةٍ
u'حُضورٌ جَمَاعَةٌ':Added, #1: 1	حُضُورُ جَمَاعَةِ
u'حُضُورٌ جَمَاعَةٌ':Added, #2: 2	حُضُورُ جَمَاعَةٍ
u'حُضورٌ جَمَاعَةٌ':Added, #2: 2	حُضُورُ جَمَاعَةٍ
u'حُضُورٌ جَمَاعَةٌ':Added, #3: 3	حُضُورُ الْجَمَاعَاتِ
u'حُضورٌ جَمَاعَةٌ':Added, #3: 3	حُضُورُ الْجَمَاعَاتِ
u'حُضُورٌ جَمَاعَةٌ':Added, #3: 3	حُضُورِ الْجَمَاعَةِ
u'حُضورٌ جَمَاعَةٌ':Added, #3: 3	حُضُورِ الْجَمَاعَةِ
u'حُضُورٌ جَمَاعَةٌ':Added, #6: 6	حُضُورُ الْجَمَاعَةِ
u'حُضورٌ جمع':Added, #6: 6	حُضُورُ الْجَمَاعَةِ
u'حُضُورٌ جمع':Added, #1: 1	حُضُورُ جَمْعِ
u'حُضورٌ جَمْعٌ':Added, #1: 1	حُضُورُ جَمْعِ
u'حُضورٌ جَمْعٌ':Added, #1: 1	حُضُورُ جَمْعِ
u'حُضُورٌ جَمْعٌ':Added, #1: 1	حُضُورِ جَمْعٍ
u'حُضُورٌ جَمْعٌ':Added, #1: 1	حُضُورُ جَمْعِ
u'حُضورٌ جمع':Added, #1: 1	حُضُورِ جَمْعٍ
u'حُضُورٌ جمع':Added, #3: 3	حُضُورِ الْجَمْعِ
u'حُضورٌ جَمْعٌ':Added, #3: 3	حُضُورِ الْجَمْعِ
u'حُضُورٌ جَمْعٌ':Added, #3: 3	حُضُورِ الْجَمْعِ
u'حُضورٌ جمعة':Added, #3: 3	حُضُورِ الْجَمْعِ
u'حُضُورٌ جمعة':Added, #10: 10	حُضُورُ الْجُمُعَةِ
u'حُضورٌ جُمُعَةٌ':Added, #10: 10	حُضُورُ الْجُمُعَةِ
u'حُضُورٌ جُمُعَةٌ':Added, #10: 10	حُضُورُ الْجُمُعَةِ
u'حُضورٌ جمعة':Added, #10: 10	حُضُورُ الْجُمُعَةِ
u'حُضُورٌ جمعة':Added, #6: 6	حُضُورِ الْجُمُعَةِ
u'حُضورٌ جُمُعَةٌ':Added, #6: 6	حُضُورِ الْجُمُعَةِ
u'حُضُورٌ جُمُعَةٌ':Added, #6: 6	حُضُورِ الْجُمُعَةِ
u'حُضورٌ جَمِيع':Added, #6: 6	حُضُورِ الْجُمُعَةِ
u'حُضُورٌ جَمِيع':Added, #1: 1	حُضُورِ الْجَمِيعِ
u'حُضورٌ حاكِمٌ':Added, #1: 1	حُضُورِ الْجَمِيعِ
u'حُضُورٌ حاكِمٌ':Added, #3: 3	حُضُورُ الْحَاكِمِ
u'حُضورٌ حاكِمٌ':Added, #3: 3	حُضُورُ الْحَاكِمِ
u'حُضُورٌ حاكِمٌ':Added, #3: 3	حُضُورِ حَاكِمٍ
u'حُضورٌ حِصَّةٌ':Added, #3: 3	حُضُورِ حَاكِمٍ
u'حُضُورٌ حِصَّةٌ':Added, #1: 1	حُضُورِ الْحِصَّةِ
u'حُضورٌ حَقِيقٌ':Added, #1: 1	حُضُورِ الْحِصَّةِ
u'حُضُورٌ حَقِيقٌ':Added, #1: 1	حُضُورِ الْحَقِيقَةِ
u'حُضورٌ حَقِيقَةٌ':Added, #1: 1	حُضُورِ الْحَقِيقَةِ
u'حُضُورٌ حَقِيقَةٌ':Added, #1: 1	حُضُورِ الْحَقِيقَةِ
u'حُضورٌ ختان':Added, #1: 1	حُضُورِ الْحَقِيقَةِ
u'حُضُورٌ ختان':Added, #1: 1	حُضُورِ خِتَانِهِ
u'حُضورٌ خِتَانٌ':Added, #1: 1	حُضُورِ خِتَانِهِ
u'حُضُورٌ خِتَانٌ':Added, #1: 1	حُضُورِ خِتَانِهِ
u'حُضورٌ خَصْمٌ':Added, #1: 1	حُضُورِ خِتَانِهِ
u'حُضورٌ خَصْمٌ':Added, #1: 1	حُضُورَ الْخَصْمَيْنِ
u'حُضُورٌ خَصْمٌ':Added, #1: 1	حُضُورُ الْخَصْمَيْنِ
u'حُضُورٌ خَصْمٌ':Added, #1: 1	حُضُورَ الْخَصْمَيْنِ
u'حُضورٌ خَصْمٌ':Added, #1: 1	حُضُورُ الْخَصْمَيْنِ
u'حُضُورٌ خَصْمٌ':Added, #1: 1	حُضُورُ خَصْمِهِ
u'حُضورٌ خَصْمٌ':Added, #1: 1	حُضُورُ خَصْمِهِ
u'حُضُورٌ خَصْمٌ':Added, #2: 2	حُضُورَ الْخَصْمِ
u'حُضورٌ خَصْمٌ':Added, #2: 2	حُضُورَ الْخَصْمِ
u'حُضُورٌ خَصْمٌ':Added, #2: 2	حُضُورِ الْخَصْمَيْنِ
u'حُضورٌ خَصْمٌ':Added, #2: 2	حُضُورِ الْخَصْمَيْنِ
u'حُضُورٌ خَصْمٌ':Added, #2: 2	حُضُورِ خَصْمِهِ
u'حُضورٌ خَصْمٌ':Added, #2: 2	حُضُورِ خَصْمِهِ
u'حُضُورٌ خَصْمٌ':Added, #3: 3	حُضُورُ الْخَصْمِ
u'حُضورٌ خَصْمٌ':Added, #3: 3	حُضُورُ الْخَصْمِ
u'حُضُورٌ خَصْمٌ':Added, #3: 3	حُضُورِ خَصْمَيْنِ
u'حُضورٌ خَصْمٌ':Added, #3: 3	حُضُورِ خَصْمَيْنِ
u'حُضُورٌ خَصْمٌ':Added, #4: 4	حُضُورِ خَصْمٍ
u'حُضورٌ خَصْمٌ':Added, #4: 4	حُضُورِ خَصْمٍ
u'حُضُورٌ خَصْمٌ':Added, #7: 7	حُضُورِ الْخَصْمِ
u'حُضورٌ خطبة':Added, #7: 7	حُضُورِ الْخَصْمِ
u'حُضُورٌ خطبة':Added, #1: 1	حُضُورِ الْخُطْبَةِ
u'حُضورٌ خُطْبَةٌ':Added, #1: 1	حُضُورِ الْخُطْبَةِ
u'حُضُورٌ خُطْبَةٌ':Added, #1: 1	حُضُورِ الْخُطْبَةِ
u'حُضورٌ دَرْسٌ':Added, #1: 1	حُضُورِ الْخُطْبَةِ
u'حُضورٌ دَرْسٌ':Added, #1: 1	حُضُورَ الدَّرْسِ
u'حُضورٌ دَرْسٌ':Added, #1: 1	حُضُورُ الدَّرْسِ
u'حُضُورٌ دَرْسٌ':Added, #1: 1	حُضُورِ الدَّرْسِ
u'حُضُورٌ دَرْسٌ':Added, #1: 1	حُضُورَ الدَّرْسِ
u'حُضُورٌ دَرْسٌ':Added, #1: 1	حُضُورُ الدَّرْسِ
u'حُضورٌ دَرْسٌ':Added, #1: 1	حُضُورِ الدَّرْسِ
u'حُضُورٌ دَرْسٌ':Added, #1: 1	حُضُورِ دَرْسٍ
u'حُضورٌ دَعْوَةٌ':Added, #1: 1	حُضُورِ دَرْسٍ
u'حُضورٌ دَعْوَةٌ':Added, #1: 1	حُضُورَ الدَّعْوَةِ
u'حُضُورٌ دَعْوَةٌ':Added, #1: 1	حُضُورِ الدَّعْوَةِ
u'حُضُورٌ دَعْوَةٌ':Added, #1: 1	حُضُورَ الدَّعْوَةِ
u'حُضورٌ دَعْوَةٌ':Added, #1: 1	حُضُورِ الدَّعْوَةِ
u'حُضُورٌ دَعْوَةٌ':Added, #1: 1	حُضُورَ دَعْوَتِهِ
u'حُضورٌ دفن':Added, #1: 1	حُضُورَ دَعْوَتِهِ
u'حُضُورٌ دفن':Added, #1: 1	حُضُورِ الدَّفْنِ
u'حُضورٌ دَفْنٌ':Added, #1: 1	حُضُورِ الدَّفْنِ
u'حُضُورٌ دَفْنٌ':Added, #1: 1	حُضُورِ الدَّفْنِ
u'حُضورٌ دفن':Added, #1: 1	حُضُورِ الدَّفْنِ
u'حُضُورٌ دفن':Added, #2: 2	حُضُورِ دَفْنِهِ
u'حُضورٌ دَفْنٌ':Added, #2: 2	حُضُورِ دَفْنِهِ
u'حُضُورٌ دَفْنٌ':Added, #2: 2	حُضُورِ دَفْنِهِ
u'حُضورٌ دِيوانٌ':Added, #2: 2	حُضُورِ دَفْنِهِ
u'حُضُورٌ دِيوانٌ':Added, #1: 1	حُضُورِ الدِّيوَانِ
u'حُضورٌ ذَكَرٌ':Added, #1: 1	حُضُورِ الدِّيوَانِ
u'حُضُورٌ ذَكَرٌ':Added, #1: 1	حُضُورِ ذَكَرَيْنِ
u'حُضورٌ ذِهْنيٌّ':Added, #1: 1	حُضُورِ ذَكَرَيْنِ
u'حُضُورٌ ذِهْنيٌّ':Added, #1: 1	حُضُورٍ ذِهْنِيٍّ
u'حُضورٌ رَاهِنٌ':Added, #1: 1	حُضُورٍ ذِهْنِيٍّ
u'حُضُورٌ رَاهِنٌ':Added, #1: 1	حُضُورُ الرَّاهِنِ
u'حُضورٌ رَاهِنٌ':Added, #1: 1	حُضُورُ الرَّاهِنِ
u'حُضُورٌ رَاهِنٌ':Added, #2: 2	حُضُورِ الرَّاهِنِ
u'حُضورٌ رَأْيٌ':Added, #2: 2	حُضُورِ الرَّاهِنِ
u'حُضُورٌ رَأْيٌ':Added, #1: 1	حُضُورَ رَأْيِ
u'حُضورٌ رَأْيٌ':Added, #1: 1	حُضُورَ رَأْيِ
u'حُضُورٌ رَأْيٌ':Added, #2: 2	حُضُورُ الرَّأْيِ
u'حُضورٌ رَأْيٌ':Added, #2: 2	حُضُورُ الرَّأْيِ
u'حُضُورٌ رَأْيٌ':Added, #2: 2	حُضُورُ رَأْيِ
u'حُضورٌ رَأْيٌ':Added, #2: 2	حُضُورُ رَأْيِ
u'حُضُورٌ رَأْيٌ':Added, #3: 3	حُضُورُ رَأْيِهِ
u'حُضورٌ رَبُّ':Added, #3: 3	حُضُورُ رَأْيِهِ
u'حُضُورٌ رَبُّ':Added, #1: 1	حُضُورُ رَبِّ
u'حُضورٌ رَبُّ':Added, #1: 1	حُضُورُ رَبِّ
u'حُضُورٌ رَبُّ':Added, #6: 6	حُضُورِ رَبِّ
u'حُضورٌ رِجَالٌ':Added, #6: 6	حُضُورِ رَبِّ
u'حُضُورٌ رِجَالٌ':Added, #1: 1	حُضُورِ الرِّجَالِ
u'حُضورٌ رَسُولٌ':Added, #1: 1	حُضُورِ الرِّجَالِ
u'حُضُورٌ رَسُولٌ':Added, #1: 1	حُضُورِ رَسُولِ
u'حُضورٌ زَمَنٌ':Added, #1: 1	حُضُورِ رَسُولِ
u'حُضُورٌ زَمَنٌ':Added, #1: 1	حُضُورِ زَمَنٍ
u'حُضورٌ زَوْجٌ':Added, #1: 1	حُضُورِ زَمَنٍ
u'حُضُورٌ زَوْجٌ':Added, #1: 1	حُضُورُ الزَّوْجِ
u'حُضورٌ زَوْجٌ':Added, #1: 1	حُضُورُ الزَّوْجِ
u'حُضُورٌ زَوْجٌ':Added, #2: 2	حُضُورِ الزَّوْجِ
u'حُضورٌ سَائِرٌ':Added, #2: 2	حُضُورِ الزَّوْجِ
u'حُضُورٌ سَائِرٌ':Added, #1: 1	حُضُورِ سَائِرِ
u'حُضورٌ سَبَبٌ':Added, #1: 1	حُضُورِ سَائِرِ
u'حُضُورٌ سَبَبٌ':Added, #1: 1	حُضُورِ سَبَبِهِ
u'حُضورٌ سُلْطَانٌ':Added, #1: 1	حُضُورِ سَبَبِهِ
u'حُضورٌ سُلْطَانٌ':Added, #1: 1	حُضُورَ السُّلْطَانِ
u'حُضُورٌ سُلْطَانٌ':Added, #1: 1	حُضُورُ السُّلْطَانِ
u'حُضُورٌ سُلْطَانٌ':Added, #1: 1	حُضُورَ السُّلْطَانِ
u'حُضورٌ سُلْطَانٌ':Added, #1: 1	حُضُورُ السُّلْطَانِ
u'حُضُورٌ سُلْطَانٌ':Added, #2: 2	حُضُورِ السُّلْطَانِ
u'حُضورٌ شَاهِدٌ':Added, #2: 2	حُضُورِ السُّلْطَانِ
u'حُضُورٌ شَاهِدٌ':Added, #1: 1	حُضُورُ الشَّاهِدِ
u'حُضورٌ شَاهِدٌ':Added, #1: 1	حُضُورُ الشَّاهِدِ
u'حُضُورٌ شَاهِدٌ':Added, #1: 1	حُضُورِ شَاهِدَيْنِ
u'حُضورٌ شَاهِدٌ':Added, #1: 1	حُضُورِ شَاهِدَيْنِ
u'حُضُورٌ شَاهِدٌ':Added, #2: 2	حُضُورِ الشَّاهِدَيْنِ
u'حُضورٌ شَاهِدٌ':Added, #2: 2	حُضُورِ الشَّاهِدَيْنِ
u'حُضُورٌ شَاهِدٌ':Added, #3: 3	حُضُورُ شَاهِدَيْنِ
u'حُضورٌ شَخْصٌ':Added, #3: 3	حُضُورُ شَاهِدَيْنِ
u'حُضُورٌ شَخْصٌ':Added, #1: 1	حُضُورِ شَخْصَيْنِ
u'حُضورٌ شركاء':Added, #1: 1	حُضُورِ شَخْصَيْنِ
u'حُضُورٌ شركاء':Added, #2: 2	حُضُورِ الشُّرَكَاءِ
u'حُضورٌ شَرِيكٌ':Added, #2: 2	حُضُورِ الشُّرَكَاءِ
u'حُضُورٌ شَرِيكٌ':Added, #1: 1	حُضُورِ الشَّرِيكِ
u'حُضورٌ شَرِيكٌ':Added, #1: 1	حُضُورِ الشَّرِيكِ
u'حُضُورٌ شَرِيكٌ':Added, #1: 1	حُضُورَ شَرِيكِهِ
u'حُضورٌ شَفِيعٌ':Added, #1: 1	حُضُورَ شَرِيكِهِ
u'حُضُورٌ شَفِيعٌ':Added, #1: 1	حُضُورِ الشَّفِيعِ
u'حُضورٌ شُهُودٌ':Added, #1: 1	حُضُورِ الشَّفِيعِ
u'حُضُورٌ شُهُودٌ':Added, #12: 12	حُضُورِ الشُّهُودِ
u'حُضورٌ شُهُودٌ':Added, #12: 12	حُضُورِ الشُّهُودِ
u'حُضُورٌ شُهُودٌ':Added, #1: 1	حُضُورِ شُهُودِهِ
u'حُضورٌ شُهُودٌ':Added, #1: 1	حُضُورِ شُهُودِهِ
u'حُضُورٌ شُهُودٌ':Added, #2: 2	حُضُورُ شُهُودِ
u'حُضورٌ شُهُودٌ':Added, #2: 2	حُضُورُ شُهُودِ
u'حُضُورٌ شُهُودٌ':Added, #4: 4	حُضُورَ الشُّهُودِ
u'حُضورٌ شُهُودٌ':Added, #4: 4	حُضُورَ الشُّهُودِ
u'حُضُورٌ شُهُودٌ':Added, #7: 7	حُضُورُ الشُّهُودِ
u'حُضورٌ شَيَاطِينُ':Added, #7: 7	حُضُورُ الشُّهُودِ
u'حُضُورٌ شَيَاطِينُ':Added, #1: 1	حُضُورِ الشَّيَاطِينِ
u'حُضورٌ صَاحِبٌ':Added, #1: 1	حُضُورِ الشَّيَاطِينِ
u'حُضُورٌ صَاحِبٌ':Added, #1: 1	حُضُورُ صَاحِبِهِ
u'حُضورٌ صَاحِبٌ':Added, #1: 1	حُضُورُ صَاحِبِهِ
u'حُضُورٌ صَاحِبٌ':Added, #3: 3	حُضُورِ صَاحِبِهِ
u'حُضورٌ صَبِيٌّ':Added, #3: 3	حُضُورِ صَاحِبِهِ
u'حُضُورٌ صَبِيٌّ':Added, #2: 2	حُضُورِ الصَّبِيِّ
u'حُضورٌ صَفٌّ':Added, #2: 2	حُضُورِ الصَّبِيِّ
u'حُضُورٌ صَفٌّ':Added, #1: 1	حُضُورِ الصَّفِّ
u'حُضورٌ صَلاَةٌ':Added, #1: 1	حُضُورِ الصَّفِّ
u'حُضُورٌ صَلاَةٌ':Added, #1: 1	حُضُورِ الصَّلاَةِ
u'حُضورٌ صَلاَةٌ':Added, #1: 1	حُضُورِ الصَّلاَةِ
u'حُضورٌ صَلاَةٌ':Added, #1: 1	حُضُورَ صَلَاةِ
u'حُضُورٌ صَلاَةٌ':Added, #1: 1	حُضُورِ صَلاَةٍ
u'حُضُورٌ صَلاَةٌ':Added, #1: 1	حُضُورَ صَلَاةِ
u'حُضورٌ صَلاَةٌ':Added, #1: 1	حُضُورِ صَلاَةٍ
u'حُضُورٌ صَلاَةٌ':Added, #3: 3	حُضُورِ الصَّلَاةِ
u'حُضورٌ صَلَوَاتٌ':Added, #3: 3	حُضُورِ الصَّلَاةِ
u'حُضُورٌ صَلَوَاتٌ':Added, #1: 1	حُضُورِ الصَّلَوَاتِ
u'حُضورٌ طَاعَةٌ':Added, #1: 1	حُضُورِ الصَّلَوَاتِ
u'حُضُورٌ طَاعَةٌ':Added, #1: 1	حُضُورِ الطَّاعَةِ
u'حُضورٌ طَالِبٌ':Added, #1: 1	حُضُورِ الطَّاعَةِ
u'حُضُورٌ طَالِبٌ':Added, #1: 1	حُضُورُ الطَّالِبِ
u'حُضورٌ طَائِفٌ':Added, #1: 1	حُضُورُ الطَّالِبِ
u'حُضُورٌ طَائِفٌ':Added, #1: 1	حُضُورُ الطَّائِفَةِ
u'حُضورٌ طَائِفٌ':Added, #1: 1	حُضُورُ الطَّائِفَةِ
u'حُضُورٌ طَائِفٌ':Added, #2: 2	حُضُورُ طَائِفَةٍ
u'حُضورٌ طعام':Added, #2: 2	حُضُورُ طَائِفَةٍ
u'حُضُورٌ طعام':Added, #1: 1	حُضُورُ الطَّعَامِ
u'حُضورٌ طَعَامٌ':Added, #1: 1	حُضُورُ الطَّعَامِ
u'حُضُورٌ طَعَامٌ':Added, #1: 1	حُضُورُ الطَّعَامِ
u'حُضورٌ طعام':Added, #1: 1	حُضُورُ الطَّعَامِ
u'حُضُورٌ طعام':Added, #3: 3	حُضُورِ الطَّعَامِ
u'حُضورٌ طَعَامٌ':Added, #3: 3	حُضُورِ الطَّعَامِ
u'حُضُورٌ طَعَامٌ':Added, #3: 3	حُضُورِ الطَّعَامِ
u'حُضورٌ عَامِلٌ':Added, #3: 3	حُضُورِ الطَّعَامِ
u'حُضُورٌ عَامِلٌ':Added, #1: 1	حُضُورِ الْعَامِلِ
u'حُضورٌ عَبْدٌ':Added, #1: 1	حُضُورِ الْعَامِلِ
u'حُضُورٌ عَبْدٌ':Added, #2: 2	حُضُورُ الْعَبْدِ
u'حُضورٌ عَدَدٌ':Added, #2: 2	حُضُورُ الْعَبْدِ
u'حُضُورٌ عَدَدٌ':Added, #1: 1	حُضُورُ الْعَدَدِ
u'حُضورٌ عَدَدٌ':Added, #1: 1	حُضُورُ الْعَدَدِ
u'حُضُورٌ عَدَدٌ':Added, #2: 2	حُضُورَ الْعَدَدِ
u'حُضورٌ عَدُوٌّ':Added, #2: 2	حُضُورَ الْعَدَدِ
u'حُضُورٌ عَدُوٌّ':Added, #1: 1	حُضُورِ الْعَدُوِّ
u'حُضورٌ عَدُوٌّ':Added, #1: 1	حُضُورِ الْعَدُوِّ
u'حُضُورٌ عَدُوٌّ':Added, #1: 1	حُضُورِ عَدُوٍّ
u'حُضورٌ عُرْسٌ':Added, #1: 1	حُضُورِ عَدُوٍّ
u'حُضُورٌ عُرْسٌ':Added, #1: 1	حُضُورِ عُرْسِ
u'حُضورٌ عَرَفَاتٌ':Added, #1: 1	حُضُورِ عُرْسِ
u'حُضُورٌ عَرَفَاتٌ':Added, #1: 1	حُضُورِ عَرَفَاتٍ
u'حُضورٌ عُضْوٌ':Added, #1: 1	حُضُورِ عَرَفَاتٍ
u'حُضُورٌ عُضْوٌ':Added, #1: 1	حُضُورِ الْعُضْوِ
u'حُضورٌ عَقْدٌ':Added, #1: 1	حُضُورِ الْعُضْوِ
u'حُضُورٌ عَقْدٌ':Added, #2: 2	حُضُورِ الْعَقْدِ
u'حُضورٌ عَقْلٌ':Added, #2: 2	حُضُورِ الْعَقْدِ
u'حُضُورٌ عَقْلٌ':Added, #1: 1	حُضُورِ الْعَقْلِ
u'حُضورٌ عَقْلٌ':Added, #1: 1	حُضُورِ الْعَقْلِ
u'حُضُورٌ عَقْلٌ':Added, #2: 2	حُضُورِ عَقْلِهِ
u'حُضورٌ علم':Added, #2: 2	حُضُورِ عَقْلِهِ
u'حُضُورٌ علم':Added, #1: 1	حُضُورِ عِلْمِ
u'حُضورٌ عِلْمٌ':Added, #1: 1	حُضُورِ عِلْمِ
u'حُضُورٌ عِلْمٌ':Added, #1: 1	حُضُورِ عِلْمِ
u'حُضورٌ عِيدٌ':Added, #1: 1	حُضُورِ عِلْمِ
u'حُضُورٌ عِيدٌ':Added, #1: 1	حُضُورُ الْعِيدَيْنِ
u'حُضورٌ غَائِبٌ':Added, #1: 1	حُضُورُ الْعِيدَيْنِ
u'حُضُورٌ غَائِبٌ':Added, #1: 1	حُضُورِ غَائِبِهِ
u'حُضورٌ غَائِبٌ':Added, #1: 1	حُضُورِ غَائِبِهِ
u'حُضورٌ غَائِبٌ':Added, #2: 2	حُضُورَ الْغَائِبِ
u'حُضُورٌ غَائِبٌ':Added, #2: 2	حُضُورُ الْغَائِبِ
u'حُضُورٌ غَائِبٌ':Added, #2: 2	حُضُورَ الْغَائِبِ
u'حُضورٌ غَائِبٌ':Added, #2: 2	حُضُورُ الْغَائِبِ
u'حُضُورٌ غَائِبٌ':Added, #4: 4	حُضُورِ الْغَائِبِ
u'حُضورٌ غَرِيمٌ':Added, #4: 4	حُضُورِ الْغَائِبِ
u'حُضُورٌ غَرِيمٌ':Added, #3: 3	حُضُورِ الْغَرِيمِ
u'حُضورٌ غير':Added, #3: 3	حُضُورِ الْغَرِيمِ
u'حُضورٌ غير':Added, #1: 1	حُضُورَ غَيْرِ
u'حُضورٌ غَيْرٌ':Added, #1: 1	حُضُورِ غَيْرِ
u'حُضورٌ غَيْرٌ':Added, #1: 1	حُضُورَ غَيْرِ
u'حُضُورٌ غير':Added, #1: 1	حُضُورِ غَيْرِ
u'حُضُورٌ غير':Added, #1: 1	حُضُورَ غَيْرِ
u'حُضُورٌ غَيْرٌ':Added, #1: 1	حُضُورِ غَيْرِ
u'حُضُورٌ غَيْرٌ':Added, #1: 1	حُضُورَ غَيْرِ
u'حُضورٌ غير':Added, #1: 1	حُضُورِ غَيْرِ
u'حُضورٌ غَيْرٌ':Added, #1: 1	حُضُورِ غَيْرِهِ
u'حُضُورٌ غير':Added, #1: 1	حُضُورِ غَيْرِهِ
u'حُضُورٌ غَيْرٌ':Added, #1: 1	حُضُورِ غَيْرِهِ
u'حُضورٌ فقهاء':Added, #1: 1	حُضُورِ غَيْرِهِ
u'حُضُورٌ فقهاء':Added, #1: 1	حُضُورِ الْفُقَهَاءِ
u'حُضورٌ قَاصٌّ':Added, #1: 1	حُضُورِ الْفُقَهَاءِ
u'حُضُورٌ قَاصٌّ':Added, #1: 1	حُضُورُ الْقَاصِّ
u'حُضورٌ قتال':Added, #1: 1	حُضُورُ الْقَاصِّ
u'حُضُورٌ قتال':Added, #1: 1	حُضُورِ الْقِتَالِ
u'حُضورٌ قِتَالٌ':Added, #1: 1	حُضُورِ الْقِتَالِ
u'حُضُورٌ قِتَالٌ':Added, #1: 1	حُضُورِ الْقِتَالِ
u'حُضورٌ قتال':Added, #1: 1	حُضُورِ الْقِتَالِ
u'حُضُورٌ قتال':Added, #1: 1	حُضُورِ قِتَالٍ
u'حُضورٌ قِتَالٌ':Added, #1: 1	حُضُورِ قِتَالٍ
u'حُضُورٌ قِتَالٌ':Added, #1: 1	حُضُورِ قِتَالٍ
u'حُضورٌ قُرَشِيٌّ':Added, #1: 1	حُضُورِ قِتَالٍ
u'حُضُورٌ قُرَشِيٌّ':Added, #1: 1	حُضُورُ قُرَشِيٍّ
u'حُضورٌ قلب':Added, #1: 1	حُضُورُ قُرَشِيٍّ
u'حُضُورٌ قلب':Added, #1: 1	حُضُورِ الْقَلْبِ
u'حُضورٌ قَلْبٌ':Added, #1: 1	حُضُورِ الْقَلْبِ
u'حُضورٌ قَلْب':Added, #1: 1	حُضُورِ الْقَلْبِ
u'حُضُورٌ قَلْبٌ':Added, #1: 1	حُضُورِ الْقَلْبِ
u'حُضُورٌ قَلْب':Added, #1: 1	حُضُورِ الْقَلْبِ
u'حُضورٌ قَلْبٌ':Added, #1: 1	حُضُورِ الْقَلْبِ
u'حُضورٌ قَلْبٌ':Added, #1: 1	حُضُورُ قَلْبٍ
u'حُضورٌ قَلْب':Added, #1: 1	حُضُورِ قَلْبٍ
u'حُضورٌ قَلْب':Added, #1: 1	حُضُورُ قَلْبٍ
u'حُضُورٌ قَلْبٌ':Added, #1: 1	حُضُورِ قَلْبٍ
u'حُضُورٌ قَلْبٌ':Added, #1: 1	حُضُورُ قَلْبٍ
u'حُضُورٌ قَلْب':Added, #1: 1	حُضُورِ قَلْبٍ
u'حُضُورٌ قَلْب':Added, #1: 1	حُضُورُ قَلْبٍ
u'حُضورٌ قلب':Added, #1: 1	حُضُورِ قَلْبٍ
u'حُضورٌ قلب':Added, #2: 2	حُضُورَ الْقَلْبِ
u'حُضُورٌ قلب':Added, #2: 2	حُضُورُ الْقَلْبِ
u'حُضُورٌ قلب':Added, #2: 2	حُضُورَ الْقَلْبِ
u'حُضورٌ قَلْبٌ':Added, #2: 2	حُضُورُ الْقَلْبِ
u'حُضورٌ قَلْبٌ':Added, #2: 2	حُضُورَ الْقَلْبِ
u'حُضورٌ قَلْب':Added, #2: 2	حُضُورُ الْقَلْبِ
u'حُضورٌ قَلْب':Added, #2: 2	حُضُورَ الْقَلْبِ
u'حُضُورٌ قَلْبٌ':Added, #2: 2	حُضُورُ الْقَلْبِ
u'حُضُورٌ قَلْبٌ':Added, #2: 2	حُضُورَ الْقَلْبِ
u'حُضُورٌ قَلْب':Added, #2: 2	حُضُورُ الْقَلْبِ
u'حُضُورٌ قَلْب':Added, #2: 2	حُضُورَ الْقَلْبِ
u'حُضورٌ قلب':Added, #2: 2	حُضُورُ الْقَلْبِ
u'حُضُورٌ قلب':Added, #2: 2	حُضُورِ قَلْبِهِ
u'حُضورٌ قَلْبٌ':Added, #2: 2	حُضُورِ قَلْبِهِ
u'حُضورٌ قَلْب':Added, #2: 2	حُضُورِ قَلْبِهِ
u'حُضُورٌ قَلْبٌ':Added, #2: 2	حُضُورِ قَلْبِهِ
u'حُضُورٌ قَلْب':Added, #2: 2	حُضُورِ قَلْبِهِ
u'حُضورٌ قمر':Added, #2: 2	حُضُورِ قَلْبِهِ
u'حُضُورٌ قمر':Added, #1: 1	حُضُورُ الْقَمَرِ
u'حُضورٌ قَمَرٌ':Added, #1: 1	حُضُورُ الْقَمَرِ
u'حُضُورٌ قَمَرٌ':Added, #1: 1	حُضُورُ الْقَمَرِ
u'حُضورٌ كبار':Added, #1: 1	حُضُورُ الْقَمَرِ
u'حُضُورٌ كبار':Added, #2: 2	حُضُورِ الْكِبَارِ
u'حُضورٌ كَبِيرٌ':Added, #2: 2	حُضُورِ الْكِبَارِ
u'حُضُورٌ كَبِيرٌ':Added, #1: 1	حُضُورُ الْكَبِيرِ
u'حُضورٌ مَالٌ':Added, #1: 1	حُضُورُ الْكَبِيرِ
u'حُضُورٌ مَالٌ':Added, #1: 1	حُضُورِ الْمَالِ
u'حُضورٌ مَالٌ':Added, #1: 1	حُضُورِ الْمَالِ
u'حُضُورٌ مَالٌ':Added, #1: 1	حُضُورُ الْمَالَيْنِ
u'حُضورٌ مَالٌ':Added, #1: 1	حُضُورُ الْمَالَيْنِ
u'حُضُورٌ مَالٌ':Added, #1: 1	حُضُورُ مَالِ
u'حُضورٌ مَالٌ':Added, #1: 1	حُضُورُ مَالِ
u'حُضورٌ مَالٌ':Added, #2: 2	حُضُورَ الْمَالِ
u'حُضُورٌ مَالٌ':Added, #2: 2	حُضُورُ الْمَالِ
u'حُضُورٌ مَالٌ':Added, #2: 2	حُضُورَ الْمَالِ
u'حُضورٌ مَالِكٌ':Added, #2: 2	حُضُورُ الْمَالِ
u'حُضورٌ مَالِكٌ':Added, #1: 1	حُضُورَ الْمَالِكِ
u'حُضُورٌ مَالِكٌ':Added, #1: 1	حُضُورِ الْمَالِكِ
u'حُضُورٌ مَالِكٌ':Added, #1: 1	حُضُورَ الْمَالِكِ
u'حُضورٌ مَبِيعٌ':Added, #1: 1	حُضُورِ الْمَالِكِ
u'حُضُورٌ مَبِيعٌ':Added, #1: 1	حُضُورُ الْمَبِيعِ
u'حُضورٌ مُتَعَاقِدٌ':Added, #1: 1	حُضُورُ الْمَبِيعِ
u'حُضُورٌ مُتَعَاقِدٌ':Added, #1: 1	حُضُور الْمُتَعَاقِدَيْنِ
u'حُضورٌ مَجَالِسُ':Added, #1: 1	حُضُور الْمُتَعَاقِدَيْنِ
u'حُضُورٌ مَجَالِسُ':Added, #2: 2	حُضُورُ مَجَالِسِ
u'حُضورٌ مَجْلِسٌ':Added, #2: 2	حُضُورُ مَجَالِسِ
u'حُضورٌ مَجْلِسٌ':Added, #1: 1	حُضُورَ مَجْلِسٍ
u'حُضُورٌ مَجْلِسٌ':Added, #1: 1	حُضُورُ مَجْلِسِ
u'حُضُورٌ مَجْلِسٌ':Added, #1: 1	حُضُورَ مَجْلِسٍ
u'حُضورٌ مَجْلِسٌ':Added, #1: 1	حُضُورُ مَجْلِسِ
u'حُضُورٌ مَجْلِسٌ':Added, #2: 2	حُضُورِ مَجْلِسِ
u'حُضورٌ مَجْلِسٌ':Added, #2: 2	حُضُورِ مَجْلِسِ
u'حُضُورٌ مَجْلِسٌ':Added, #2: 2	حُضُورَ مَجْلِسِهِ
u'حُضورٌ مَجْلِسٌ':Added, #2: 2	حُضُورَ مَجْلِسِهِ
u'حُضُورٌ مَجْلِسٌ':Added, #3: 3	حُضُورَ مَجْلِسِ
u'حُضورٌ مَجْمَعٌ':Added, #3: 3	حُضُورَ مَجْلِسِ
u'حُضُورٌ مَجْمَعٌ':Added, #1: 1	حُضُورَ مَجْمَعِ
u'حُضورٌ مُحْتَالٌ':Added, #1: 1	حُضُورَ مَجْمَعِ
u'حُضُورٌ مُحْتَالٌ':Added, #1: 1	حُضُورِ الْمُحْتَالِ
u'حُضورٌ مُحْتَضَرٌ':Added, #1: 1	حُضُورِ الْمُحْتَالِ
u'حُضُورٌ مُحْتَضَرٌ':Added, #1: 1	حُضُورَ الْمُحْتَضَرِ
u'حُضورٌ مُرَاهِقٌ':Added, #1: 1	حُضُورَ الْمُحْتَضَرِ
u'حُضُورٌ مُرَاهِقٌ':Added, #1: 1	حُضُورُ الْمُرَاهِقِ
u'حُضورٌ مُرْتَكِبٌ':Added, #1: 1	حُضُورُ الْمُرَاهِقِ
u'حُضُورٌ مُرْتَكِبٌ':Added, #1: 1	حُضُورِ مُرْتَكِبِ
u'حُضورٌ مَسَاجِدُ':Added, #1: 1	حُضُورِ مُرْتَكِبِ
u'حُضُورٌ مَسَاجِدُ':Added, #1: 1	حُضُورِ الْمَسَاجِدِ
u'حُضورٌ مُسْتَأْجِرٌ':Added, #1: 1	حُضُورِ الْمَسَاجِدِ
u'حُضُورٌ مُسْتَأْجِرٌ':Added, #1: 1	حُضُورِ الْمُسْتَأْجِرِ
u'حُضورٌ مُسْتَحِقٌّ':Added, #1: 1	حُضُورِ الْمُسْتَأْجِرِ
u'حُضورٌ مُسْتَحِقٌّ':Added, #1: 1	حُضُورُ الْمُسْتَحِقِّ
u'حُضُورٌ مُسْتَحِقٌّ':Added, #1: 1	حُضُورِ الْمُسْتَحِقِّ
u'حُضُورٌ مُسْتَحِقٌّ':Added, #1: 1	حُضُورُ الْمُسْتَحِقِّ
u'حُضورٌ مَسْجِدٌ':Added, #1: 1	حُضُورِ الْمُسْتَحِقِّ
u'حُضُورٌ مَسْجِدٌ':Added, #3: 3	حُضُورَ الْمَسْجِدِ
u'حُضورٌ مَسْجِدٌ':Added, #3: 3	حُضُورَ الْمَسْجِدِ
u'حُضُورٌ مَسْجِدٌ':Added, #4: 4	حُضُورُ الْمَسْجِدِ
u'حُضورٌ مَسْرُوقٌ':Added, #4: 4	حُضُورُ الْمَسْجِدِ
u'حُضورٌ مَسْرُوقٌ':Added, #1: 1	حُضُورُ الْمَسْرُوقِ
u'حُضُورٌ مَسْرُوقٌ':Added, #1: 1	حُضُورِ الْمَسْرُوقِ
u'حُضُورٌ مَسْرُوقٌ':Added, #1: 1	حُضُورُ الْمَسْرُوقِ
u'حُضورٌ مُسْلِمٌ':Added, #1: 1	حُضُورِ الْمَسْرُوقِ
u'حُضورٌ مُسْلِمٌ':Added, #1: 1	حُضُورُ الْمُسْلِمِ
u'حُضُورٌ مُسْلِمٌ':Added, #1: 1	حُضُورِ الْمُسْلِمِ
u'حُضُورٌ مُسْلِمٌ':Added, #1: 1	حُضُورُ الْمُسْلِمِ
u'حُضورٌ مَشْهُودٌ':Added, #1: 1	حُضُورِ الْمُسْلِمِ
u'حُضُورٌ مَشْهُودٌ':Added, #1: 1	حُضُورِ الْمَشْهُودِ
u'حُضورٌ مَشْهُودٌ':Added, #1: 1	حُضُورِ الْمَشْهُودِ
u'حُضُورٌ مَشْهُودٌ':Added, #2: 2	حُضُورُ الْمَشْهُودِ
u'حُضورٌ مِصْرٌ':Added, #2: 2	حُضُورُ الْمَشْهُودِ
u'حُضُورٌ مِصْرٌ':Added, #1: 1	حُضُورِ الْمِصْرِ
u'حُضورٌ مُضَارِبٌ':Added, #1: 1	حُضُورِ الْمِصْرِ
u'حُضُورٌ مُضَارِبٌ':Added, #1: 1	حُضُورُ الْمُضَارِبِ
u'حُضورٌ مُعْتَرَكٌ':Added, #1: 1	حُضُورُ الْمُضَارِبِ
u'حُضُورٌ مُعْتَرَكٌ':Added, #1: 1	حُضُورِ الْمُعْتَرَكِ
u'حُضورٌ مُعْظَمٌ':Added, #1: 1	حُضُورِ الْمُعْتَرَكِ
u'حُضُورٌ مُعْظَمٌ':Added, #1: 1	حُضُورَ مُعْظَمِ
u'حُضورٌ مَقْضِيّ':Added, #1: 1	حُضُورَ مُعْظَمِ
u'حُضُورٌ مَقْضِيّ':Added, #1: 1	حُضُورِ الْمَقْضِيِّ
u'حُضورٌ مَكَانٌ':Added, #1: 1	حُضُورِ الْمَقْضِيِّ
u'حُضُورٌ مَكَانٌ':Added, #1: 1	حُضُورِ الْمَكَانِ
u'حُضورٌ مَكَانٌ':Added, #1: 1	حُضُورِ الْمَكَانِ
u'حُضُورٌ مَكَانٌ':Added, #1: 1	حُضُورَ مَكَانِ
u'حُضورٌ مَكْفُولٌ':Added, #1: 1	حُضُورَ مَكَانِ
u'حُضورٌ مَكْفُولٌ':Added, #1: 1	حُضُورُ الْمَكْفُولِ
u'حُضُورٌ مَكْفُولٌ':Added, #1: 1	حُضُورِ الْمَكْفُولِ
u'حُضُورٌ مَكْفُولٌ':Added, #1: 1	حُضُورُ الْمَكْفُولِ
u'حُضورٌ مَلاَئِكَةٌ':Added, #1: 1	حُضُورِ الْمَكْفُولِ
u'حُضُورٌ مَلاَئِكَةٌ':Added, #1: 1	حُضُورِ الْمَلَائِكَةِ
u'حُضورٌ مَلْزُوم':Added, #1: 1	حُضُورِ الْمَلَائِكَةِ
u'حُضُورٌ مَلْزُوم':Added, #1: 1	حُضُورِ الْمَلْزُومِ
u'حُضورٌ مِلْكٌ':Added, #1: 1	حُضُورِ الْمَلْزُومِ
u'حُضُورٌ مِلْكٌ':Added, #1: 1	حُضُورُ الْمِلْكِ
u'حُضورٌ مُنْكَرٌ':Added, #1: 1	حُضُورُ الْمِلْكِ
u'حُضورٌ مُنْكَرٌ':Added, #1: 1	حُضُورُ الْمُنْكَرِ
u'حُضُورٌ مُنْكَرٌ':Added, #1: 1	حُضُورِ الْمُنْكَرِ
u'حُضُورٌ مُنْكَرٌ':Added, #1: 1	حُضُورُ الْمُنْكَرِ
u'حُضورٌ مَوَاعِظُ':Added, #1: 1	حُضُورِ الْمُنْكَرِ
u'حُضُورٌ مَوَاعِظُ':Added, #1: 1	حُضُورِ مَوَاعِظِهِ
u'حُضورٌ مَوْتٌ':Added, #1: 1	حُضُورِ مَوَاعِظِهِ
u'حُضورٌ مَوْتٌ':Added, #1: 1	حُضُورَ الْمَوْتِ
u'حُضورٌ مَوْتٌ':Added, #1: 1	حُضُورُ الْمَوْتِ
u'حُضُورٌ مَوْتٌ':Added, #1: 1	حُضُورِ الْمَوْتِ
u'حُضُورٌ مَوْتٌ':Added, #1: 1	حُضُورَ الْمَوْتِ
u'حُضُورٌ مَوْتٌ':Added, #1: 1	حُضُورُ الْمَوْتِ
u'حُضورٌ مُؤْتَمَنٌ':Added, #1: 1	حُضُورِ الْمَوْتِ
u'حُضُورٌ مُؤْتَمَنٌ':Added, #1: 1	حُضُورَ الْمُؤْتَمَنِ
u'حُضورٌ مُوَكِّلٌ':Added, #1: 1	حُضُورَ الْمُؤْتَمَنِ
u'حُضُورٌ مُوَكِّلٌ':Added, #1: 1	حُضُورِ مُوَكِّلِهِ
u'حُضورٌ مُوَكِّلٌ':Added, #1: 1	حُضُورِ مُوَكِّلِهِ
u'حُضُورٌ مُوَكِّلٌ':Added, #3: 3	حُضُورُ الْمُوَكِّلِ
u'حُضورٌ مُوَكِّلٌ':Added, #3: 3	حُضُورُ الْمُوَكِّلِ
u'حُضُورٌ مُوَكِّلٌ':Added, #4: 4	حُضُورِ الْمُوَكِّلِ
u'حُضورٌ نَائِبٌ':Added, #4: 4	حُضُورِ الْمُوَكِّلِ
u'حُضُورٌ نَائِبٌ':Added, #3: 3	حُضُورُ النَّائِبِ
u'حُضورٌ نِدَاءٌ':Added, #3: 3	حُضُورُ النَّائِبِ
u'حُضُورٌ نِدَاءٌ':Added, #1: 1	حُضُورِ النِّدَاءِ
u'حُضورٌ نِساءٌ':Added, #1: 1	حُضُورِ النِّدَاءِ
u'حُضُورٌ نِساءٌ':Added, #1: 1	حُضُورِ النِّسَاءِ
u'حُضورٌ نِساءٌ':Added, #1: 1	حُضُورِ النِّسَاءِ
u'حُضُورٌ نِساءٌ':Added, #2: 2	حُضُورُ النِّسَاءِ
u'حُضورٌ نَوْبَةٌ':Added, #2: 2	حُضُورُ النِّسَاءِ
u'حُضُورٌ نَوْبَةٌ':Added, #1: 1	حُضُورَ نَوْبَتِهِ
u'حُضورٌ نِيَّةٌ':Added, #1: 1	حُضُورَ نَوْبَتِهِ
u'حُضُورٌ نِيَّةٌ':Added, #1: 1	حُضُورِ نِيَّتِهِ
u'حُضورٌ وَاجِبٌ':Added, #1: 1	حُضُورِ نِيَّتِهِ
u'حُضُورٌ وَاجِبٌ':Added, #1: 1	حُضُورُ الْوَاجِبِ
u'حُضورٌ واحد':Added, #1: 1	حُضُورُ الْوَاجِبِ
u'حُضُورٌ واحد':Added, #1: 1	حُضُورِ الْوَاحِدِ
u'حُضورٌ وَاحِدٌ':Added, #1: 1	حُضُورِ الْوَاحِدِ
u'حُضُورٌ وَاحِدٌ':Added, #1: 1	حُضُورِ الْوَاحِدِ
u'حُضورٌ واحد':Added, #1: 1	حُضُورِ الْوَاحِدِ
u'حُضُورٌ واحد':Added, #2: 2	حُضُورُ وَاحِدٍ
u'حُضورٌ وَاحِدٌ':Added, #2: 2	حُضُورُ وَاحِدٍ
u'حُضُورٌ وَاحِدٌ':Added, #2: 2	حُضُورُ وَاحِدٍ
u'حُضورٌ وَاقِعٌ':Added, #2: 2	حُضُورُ وَاحِدٍ
u'حُضُورٌ وَاقِعٌ':Added, #1: 1	حُضُورِ الْوَاقِعَةِ
u'حُضورٌ وَاقِعَةٌ':Added, #1: 1	حُضُورِ الْوَاقِعَةِ
u'حُضُورٌ وَاقِعَةٌ':Added, #1: 1	حُضُورِ الْوَاقِعَةِ
u'حُضورٌ وَصِيٌّ':Added, #1: 1	حُضُورِ الْوَاقِعَةِ
u'حُضُورٌ وَصِيٌّ':Added, #1: 1	حُضُورِ وَصِيِّهِ
u'حُضورٌ وَظِيفَةٌ':Added, #1: 1	حُضُورِ وَصِيِّهِ
u'حُضُورٌ وَظِيفَةٌ':Added, #1: 1	حُضُورِ وَظِيفَةٍ
u'حُضورٌ وَعْظٌ':Added, #1: 1	حُضُورِ وَظِيفَةٍ
u'حُضُورٌ وَعْظٌ':Added, #1: 1	حُضُورِ الْوَعْظِ
u'حُضورٌ وَقْتٌ':Added, #1: 1	حُضُورِ الْوَعْظِ
u'حُضُورٌ وَقْتٌ':Added, #11: 11	حُضُورِ وَقْتِ
u'حُضورٌ وَقْتٌ':Added, #11: 11	حُضُورِ وَقْتِ
u'حُضُورٌ وَقْتٌ':Added, #2: 2	حُضُورِ الْوَقْتِ
u'حُضورٌ وَقْتٌ':Added, #2: 2	حُضُورِ الْوَقْتِ
u'حُضُورٌ وَقْتٌ':Added, #3: 3	حُضُورِ وَقْتِهِ
u'حُضورٌ وقعة':Added, #3: 3	حُضُورِ وَقْتِهِ
u'حُضُورٌ وقعة':Added, #1: 1	حُضُورُ الْوَقْعَةِ
u'حُضورٌ وَقْعَةٌ':Added, #1: 1	حُضُورُ الْوَقْعَةِ
u'حُضُورٌ وَقْعَةٌ':Added, #1: 1	حُضُورُ الْوَقْعَةِ
u'حُضورٌ وقعة':Added, #1: 1	حُضُورُ الْوَقْعَةِ
u'حُضُورٌ وقعة':Added, #2: 2	حُضُورِ الْوَقْعَةِ
u'حُضورٌ وَقْعَةٌ':Added, #2: 2	حُضُورِ الْوَقْعَةِ
u'حُضُورٌ وَقْعَةٌ':Added, #2: 2	حُضُورِ الْوَقْعَةِ
u'حُضورٌ وَكِيلٌ':Added, #2: 2	حُضُورِ الْوَقْعَةِ
u'حُضُورٌ وَكِيلٌ':Added, #1: 1	حُضُورُ الْوَكِيلِ
u'حُضورٌ وَكِيلٌ':Added, #1: 1	حُضُورُ الْوَكِيلِ
u'حُضُورٌ وَكِيلٌ':Added, #1: 1	حُضُورَ وَكِيلِ
u'حُضورٌ وَكِيلٌ':Added, #1: 1	حُضُورَ وَكِيلِ
u'حُضُورٌ وَكِيلٌ':Added, #3: 3	حُضُورُ وَكِيلِهِ
u'حُضورٌ وَلاَئِمُ':Added, #3: 3	حُضُورُ وَكِيلِهِ
u'حُضُورٌ وَلاَئِمُ':Added, #2: 2	حُضُورُ الْوَلَائِمِ
u'حُضورٌ ولد':Added, #2: 2	حُضُورُ الْوَلَائِمِ
u'حُضُورٌ ولد':Added, #1: 1	حُضُورِ الْوَلَدِ
u'حُضورٌ وَلَدٌ':Added, #1: 1	حُضُورِ الْوَلَدِ
u'حُضُورٌ وَلَدٌ':Added, #1: 1	حُضُورِ الْوَلَدِ
u'حُضورٌ وَلِيٌّ':Added, #1: 1	حُضُورِ الْوَلَدِ
u'حُضُورٌ وَلِيٌّ':Added, #1: 1	حُضُورُ الْوَلِيِّ
u'حُضورٌ وَلِيٌّ':Added, #1: 1	حُضُورُ الْوَلِيِّ
u'حُضُورٌ وَلِيٌّ':Added, #1: 1	حُضُورِ وَلِيِّ
u'حُضورٌ وَلِيمَةٌ':Added, #1: 1	حُضُورِ وَلِيِّ
u'حُضُورٌ وَلِيمَةٌ':Added, #1: 1	حُضُورَ وَلِيمَةِ
u'حُضورٌ وَلِيمَةٌ':Added, #1: 1	حُضُورَ وَلِيمَةِ
u'حُضُورٌ وَلِيمَةٌ':Added, #2: 2	حُضُورُ الْوَلِيمَةِ
u'حُضورٌ وَلِيمَةٌ':Added, #2: 2	حُضُورُ الْوَلِيمَةِ
u'حُضورٌ وَلِيمَةٌ':Added, #2: 2	حُضُورُ وَلِيمَةٍ
u'حُضُورٌ وَلِيمَةٌ':Added, #2: 2	حُضُورِ وَلِيمَةِ
u'حُضُورٌ وَلِيمَةٌ':Added, #2: 2	حُضُورُ وَلِيمَةٍ
u'حُضورٌ وَلِيمَةٌ':Added, #2: 2	حُضُورِ وَلِيمَةِ
u'حُضُورٌ وَلِيمَةٌ':Added, #5: 5	حُضُورُ وَلِيمَةِ
u'حُضورٌ يَوْمٌ':Added, #5: 5	حُضُورُ وَلِيمَةِ
u'حُضُورٌ يَوْمٌ':Added, #1: 1	حُضُورِ الْيَوْمِ
u'حَطَّ أحَدٌ':Subject, #1: 1	حُضُورِ الْيَوْمِ
u'حَطَّ آخِرُ':Subject, #1: 1	حَطَّ أَحَدُ
u'حَطَّ بَائِعٌ':Subject, #1: 1	حَطَّ آخِرُ
u'حَطَّ بَعْضٌ':Predicate, #16: 16	حَطَّ الْبَائِعُ
u'حَطَّ بَعْضٌ':Predicate, #6: 6	حَطَّ الْبَعْضَ
u'حَطَبٌ مُبَاحٌ':Added, #7: 7	حَطَّ بَعْضَ
u'حَطَّ ثَمَنٌ':Predicate, #2: 2	حَطَبٍ مُبَاحٍ
u'حَطَّ جَمِيع':Predicate, #1: 1	حَطَّ الثَّمَنَ
u'حَطَّ حِصَّةٌ':Subject, #2: 2	حَطَّ الْجَمِيعَ
u'حَطَّ رَبُّ':Subject, #1: 1	حَطَّ حِصَّتُهُ
u'حَطَّ زِيادَةٌ':Predicate, #1: 1	حَطَّ رَبُّ
u'حَطَّ عُشْرٌ':Predicate, #2: 2	حَطَّ الزِّيَادَةَ
u'حَطَّ فَضْلٌ':Predicate, #1: 1	حَطَّ عُشْرَ
u'حَطَّ قَدْرٌ':Predicate, #1: 1	حَطَّ الْفَضْلَ
u'حَطَّ كَلاَمٌ':Subject, #1: 1	حَطَّ قَدْرَ
u'حَطَّ مَالٌ':Predicate, #1: 1	حَطَّ كَلَامُ
u'حَطَّ مَالِكٌ':Subject, #1: 1	حَطَّ الْمَالَ
u'حَطَّ مَتَاعٌ':Predicate, #1: 1	حَطَّ مَالِكٌ
u'حَطَّ مثل':Predicate, #1: 1	حَطَّ الْمَتَاعَ
u'حَطَّ مِثْلٌ':Predicate, #1: 1	حَطَّ مِثْلَ
u'حَطَّ مِقْدَارٌ':Predicate, #1: 1	حَطَّ مِثْلَ
u'حَطَّ نِصْفٌ':Predicate, #1: 1	حَطَّ مِقْدَارَ
u'حَطَّ وَكِيلٌ':Subject, #1: 1	حَطَّ نِصْفَ
u'حَظَّ رِباطِيّ':Predicate, #1: 1	حَطَّ الْوَكِيلُ
u'حَظَّ مُسْلِمٌ':Predicate, #1: 1	حَظَّ الرِّبَاطِيِّينَ
u'حُظُوظٌ أئِمَّةٌ':Added, #1: 1	حَظَّ الْمُسْلِمِينَ
u'حُظُوظٌ غُيَّبٌ':Added, #1: 1	حُظُوظِ الْأَئِمَّةِ
u'حُظُوظٌ نَفْسٌ':Added, #1: 1	حُظُوظَ الْغُيَّبِ
u'حُظُوظٌ نُفُوسٌ':Added, #3: 3	حُظُوظِ النَّفْسِ
u'حُظُوظٌ نُفُوسٌ':Added, #1: 1	حُظُوظَ النُّفُوسِ
u'حَظِيَ عند':Predicate, #3: 3	حُظُوظِ النُّفُوسِ
u'حفاظ مَوْهِبَةٌ':Added, #1: 1	أَحْظَى عِنْدَ
u'حِفَاظٌ مَوْهِبَةٌ':Added, #1: 1	حِفَاظَ مَوْهِبَتِهِ
u'حَفْرٌ آبارٌ':Added, #1: 1	حِفَاظَ مَوْهِبَتِهِ
u'حَفْرٌ آبارٌ':Added, #1: 1	حَفْرِ آبَارِ
u'حَفَرَ أرْضٌ':Predicate, #2: 2	حَفْرِ الْآبَارِ
u'حَفْرٌ أرْضٌ':Added, #1: 1	حَفَرَ الْأَرْضَ
u'حَفْرٌ أرْضٌ':Added, #1: 1	حَفْرِ الْأَرْضِ
u'حَفْرٌ أسَاسٌ':Added, #2: 2	حَفْرُ الْأَرْضِ
u'حَفْرٌ أَسَاسٌ':Added, #2: 2	حَفْرِ أَسَاسٍ
u'حَفْرٌ أسَاسٌ':Added, #2: 2	حَفْرِ أَسَاسٍ
u'حَفْرٌ أَسَاسٌ':Added, #2: 2	حَفْرِ الْأَسَاسِ
u'حَفَرَ إِنْسانٌ':Subject, #2: 2	حَفْرِ الْأَسَاسِ
u'حَفْرٌ أَنْهَارٌ':Added, #1: 1	حَفَرَ إنْسَانٌ
u'حَفْرٌ أَنْهَارٌ':Added, #1: 1	حَفْرُ الْأَنْهَارِ
u'حَفْرٌ أَنْهَارٌ':Added, #2: 2	حَفْرِ أَنْهَارٍ
u'حَفْرٌ أَوَّلُ':Added, #5: 5	حَفْرِ الْأَنْهَارِ
u'حَفْرٌ أَوَّلُ':Added, #1: 1	حَفْرَ الْأَوَّلِ
u'حَفَرَ بِئْرٌ':Predicate, #1: 1	حَفْرِ الْأَوَّلِ
u'حَفَرَ بِئْرٌ':Predicate, #3: 3	حَفَرَ الْبِئْرَ
u'حَفْرٌ بِئْرٌ':Added, #3: 3	حَفَرَ بِئْرَ
u'حَفْرٌ بِئْرٌ':Added, #16: 16	حَفْرِ بِئْرٍ
u'حَفْرٌ بِئْرٌ':Added, #1: 1	حَفْرُ بِئْرِ
u'حَفْرٌ بِئْرٌ':Added, #25: 25	حَفْرِ الْبِئْرِ
u'حَفْرٌ بِئْرٌ':Added, #3: 3	حَفْرَ بِئْرٍ
u'حَفْرٌ بِئْرٌ':Added, #5: 5	حَفْرُ بِئْرٍ
u'حَفْرٌ بِئْرٌ':Added, #6: 6	حَفْرُ الْبِئْرِ
u'حَفْرٌ تُرَابٌ':Added, #8: 8	حَفْرَ الْبِئْرِ
u'حَفَرَ ثَانِي':Predicate, #1: 1	حَفْرَ التُّرَابِ
u'حَفْرٌ ثَانِي':Added, #1: 1	حَفَرَ الثَّانِيَ
u'حَفْرٌ ثَانِيَةٌ':Added, #1: 1	حَفْرِ الثَّانِيَةِ
u'حَفَرَ جِدار':Predicate, #1: 1	حَفْرِ الثَّانِيَةِ
u'حَفَرَ حَرٌّ':Subject, #1: 1	حَفَرَ جِدَارَ
u'حَفْرٌ حَفِيرَةٌ':Added, #1: 1	حَفَرَ الْحَرُّ
u'حَفْرٌ حِيَاضٌ':Added, #1: 1	حَفْرِ الْحَفِيرَةِ
u'حَفْرٌ خَنْدَقٌ':Added, #2: 2	حَفْرِ الْحِيَاضِ
u'حَفْرٌ خَنْدَقٌ':Added, #1: 1	حَفْرُ الْخَنْدَقِ
u'حَفَرَ ذِمِّيٌّ':Subject, #3: 3	حَفْرِ الْخَنْدَقِ
u'حَفْرٌ ذِمِّيٌّ':Added, #1: 1	حَفَرَ ذِمِّيٌّ
u'حَفَرَ رَبُّ':Subject, #1: 1	حَفْرِ الذِّمِّيِّ
u'حَفَرَ رَجُلٌ':Subject, #1: 1	حَفَرَ رَبُّ
u'حَفَرَ رَجُلٌ':Subject, #1: 1	حَفَرَ رَجُلٌ
u'حَفَرَ زُبْيَةٌ':Predicate, #7: 7	حَفَرَ الرَّجُلُ
u'حَفْرٌ زَمَنٌ':Added, #1: 1	حَفَرَ الزُّبْيَةَ
u'حَفْرٌ سَاقِي':Added, #1: 1	حَفْرِ زَمَنِهِ
u'حَفْرٌ سَاقِيَةٌ':Added, #1: 1	حَفْرُ السَّاقِيَةِ
u'حَفْرٌ سِرْدَابٌ':Added, #1: 1	حَفْرُ السَّاقِيَةِ
u'حَفَرَ صَاحِبٌ':Subject, #1: 1	حَفْرُ سِرْدَابٍ
u'حَفَرَ ضَمِنٌ':Predicate, #1: 1	حَفَرَ صَاحِبُ
u'حَفَرَ طَائِفٌ':Subject, #1: 1	حَفَرَ ضَمِنَ
u'حَفَرَ عَبْدٌ':Subject, #1: 1	حَفَرَ طَائِفَةٌ
u'حَفَرَ عَبْدٌ':Subject, #10: 10	حَفَرَ الْعَبْدُ
u'حَفَرَ عَبْدٌ':Subject, #1: 1	حَفَرَ عَبْدُهُ
u'حَفَرَ عَبْدٌ':Subject, #2: 2	حَفَرَ عَبْدٌ
u'حَفْرٌ غير':Added, #2: 2	حَفَرَ عَبْدُ
u'حَفْرٌ غَيْرٌ':Added, #1: 1	حَفْرِ غَيْرِهِ
u'حَفَرَ فلان':Subject, #1: 1	حَفْرِ غَيْرِهِ
u'حَفْرٌ قَبْرٌ':Added, #1: 1	حَفَرَ مُعَاوِيَةُ
u'حَفْرٌ قَبْرٌ':Added, #1: 1	حَفْرُ الْقَبْرِ
u'حَفْرٌ قَبْرٌ':Added, #1: 1	حَفْرُ قَبْرٍ
u'حَفْرٌ قَبْرٌ':Added, #1: 1	حَفْرُ قَبْرِهِ
u'حَفْرٌ قُبُورٌ':Added, #2: 2	حَفْرِ الْقَبْرِ
u'حَفْرٌ قُبُورٌ':Added, #1: 1	حَفْرَ قُبُورِ
u'حَفَرَ قَنَاةٌ':Predicate, #5: 5	حَفْرِ الْقُبُورِ
u'حَفَرَ قَوْمٌ':Subject, #1: 1	حَفَرَ الْقَنَاةَ
u'حَفْرٌ كَرْمٌ':Added, #2: 2	حَفَرَ قَوْمٌ
u'حَفَرَ مُحْرِمٌ':Subject, #1: 1	حَفْرَ الْكَرْمِ
u'حَفَرَ مُدَبَّرٌ':Subject, #1: 1	حَفَرَ الْمُحْرِمُ
u'حَفَرَ مُسْتَأْجِرٌ':Subject, #2: 2	حَفَرَ الْمُدَبَّرُ
u'حَفَرَ مُعاوِيَة':Subject, #1: 1	حَفَرَ الْمُسْتَأْجِرُ
u'حَفَرَ مَغْصُوب':Subject, #1: 1	حَفَرَ مُعَاوِيَةُ
u'حَفْرٌ مَقَابِرُ':Added, #1: 1	حَفَرَ الْمَغْصُوبُ
u'حَفَرَ نَهْرٌ':Predicate, #2: 2	حَفْرِ مَقَابِرِ
u'حَفْرٌ نَهْرٌ':Added, #3: 3	حَفَرَ النَّهْرَ
u'حَفْرٌ نَهْرٌ':Added, #1: 1	حَفْرَ نَهْرٍ
u'حَفَرَ واحد':Subject, #3: 3	حَفْرِ النَّهْرِ
u'حَفَرَ وَاحِدٌ':Subject, #1: 1	حَفَرَ وَاحِدٌ
u'حَفِظَ اِبْنٌ':Subject, #1: 1	حَفَرَ وَاحِدٌ
u'حِفْظٌ اِبْنٌ':Added, #1: 1	حَفِظَ ابْنُ
u'حَفِظَ اِتِّصَالٌ':Predicate, #1: 1	حِفْظِ ابْنِ
u'حِفْظٌ آثَارٌ':Added, #1: 1	حَفِظَ اتِّصَالَ
u'حِفْظٌ أَحادِيثُ':Added, #1: 1	حِفْظُ آثَارِ
u'حِفْظٌ أَحادِيثُ':Added, #1: 1	حِفْظِ أَحَادِيثِ
u'حِفْظٌ أَحْكَامٌ':Added, #1: 1	حِفْظِ الْأَحَادِيثِ
u'حِفْظٌ آدابٌ':Added, #1: 1	حِفْظِ الْأَحْكَامِ
u'حِفْظٌ أدَب':Added, #1: 1	حِفْظِ الْآدَابِ
u'حِفْظٌ أَشْخَاصٌ':Added, #1: 1	حِفْظُ الْأَدَبِ
u'حِفْظٌ أُصْبُعٌ':Added, #1: 1	حِفْظِ الْأَشْخَاصِ
u'حِفْظٌ أصل':Added, #1: 1	حِفْظُ أُصْبُعِهِ
u'حِفْظٌ أًصْلٌ':Added, #1: 1	حِفْظِ أَصْلِهِ
u'حِفْظٌ أصل':Added, #1: 1	حِفْظِ أَصْلِهِ
u'حِفْظٌ أًصْلٌ':Added, #1: 1	حِفْظَ الْأَصْلِ
u'حِفْظٌ أصل':Added, #1: 1	حِفْظَ الْأَصْلِ
u'حِفْظٌ أصل':Added, #2: 2	حِفْظُ الْأَصْلِ
u'حِفْظٌ أًصْلٌ':Added, #2: 2	حِفْظِ الْأَصْلِ
u'حِفْظٌ أًصْلٌ':Added, #2: 2	حِفْظُ الْأَصْلِ
u'حِفْظٌ أُصولٌ':Added, #2: 2	حِفْظِ الْأَصْلِ
u'حِفْظٌ أُصولٌ':Added, #1: 1	حِفْظَ الْأُصُولِ
u'حِفْظٌ أُصولٌ':Added, #1: 1	حِفْظِ الْأُصُولِ
u'حِفْظٌ إِعْرابٌ':Added, #2: 2	حِفْظُ الْأُصُولِ
u'حِفْظٌ أَعْرَاضٌ':Added, #1: 1	حِفْظِ إعْرَابِهِ
u'حِفْظٌ أَعْرَاضٌ':Added, #1: 1	حِفْظَ الْأَعْرَاضِ
u'حِفْظٌ أَفْرَادٌ':Added, #1: 1	حِفْظُ الْأَعْرَاضِ
u'حَفِظَ إقامَةٌ':Predicate, #1: 1	حِفْظِ أَفْرَادٍ
u'حَفِظَ أَقَاوِيلُ':Predicate, #1: 1	حَفِظَ الْإِقَامَةَ
u'حِفْظٌ الْمَرْأَةُ':Added, #1: 1	حَفِظَ أَقَاوِيلَ
u'حَفِظَ أُمٌّ':Predicate, #1: 1	حِفْظُ الْمَرْأَةِ
u'حِفْظٌ أُمٌّ':Added, #1: 1	حَفِظَ أُمَّ
u'حِفْظٌ أُمٌّ':Added, #1: 1	حِفْظَ الْأُمِّ
u'حَفِظَ أمَانَةٌ':Predicate, #1: 1	حِفْظُ أُمِّ
u'حِفْظٌ أمَانَةٌ':Added, #1: 1	حَفِظَ أَمَانَةَ
u'حِفْظٌ أمَانَةٌ':Added, #1: 1	حِفْظَ الْأَمَانَةِ
u'حِفْظٌ أمَانَةٌ':Added, #2: 2	حِفْظِ الْأَمَانَةِ
u'حِفْظٌ أَمْرٌ':Added, #2: 2	حِفْظُ أَمَانَةٍ
u'حِفْظٌ أَمْوَالٌ':Added, #1: 1	حِفْظِ أَمْرٍ
u'حِفْظٌ أَمْوَالٌ':Added, #1: 1	حِفْظَ الأَمْوَالِ
u'حِفْظٌ أَمْوَالٌ':Added, #1: 1	حِفْظَ الْأَمْوَالِ
u'حِفْظٌ أَمْوَالٌ':Added, #1: 1	حِفْظُ الْأَمْوَالِ
u'حِفْظٌ أَمْوَالٌ':Added, #1: 1	حِفْظَ أَمْوَالِ
u'حِفْظٌ أَنْسَابٌ':Added, #3: 3	حِفْظِ الْأَمْوَالِ
u'حَفِظَ إِنْسانٌ':Subject, #3: 3	حِفْظَ الْأَنْسَابِ
u'حِفْظٌ إِنْسانٌ':Added, #1: 1	حَفِظَ الْإِنْسَانُ
u'حَفِظَ أهْلٌ':Subject, #1: 1	حِفْظُ الْإِنْسَانِ
u'حِفْظٌ أهْلٌ':Added, #1: 1	حَفِظَ أَهْلُ
u'حِفْظٌ أهْلٌ':Added, #1: 1	حِفْظَ أَهْلِ
u'حَفِظَ بَائِعٌ':Subject, #1: 1	حِفْظِ أَهْلٍ
u'حِفْظٌ بَرٌّ':Added, #1: 1	حَفِظَ الْبَائِعُ
u'حِفْظٌ بَسْمَلَةٌ':Added, #2: 2	حِفْظُ الْبَرِّ
u'حِفْظٌ بَصَرٌ':Added, #1: 1	حِفْظِ الْبَسْمَلَةِ
u'حَفِظَ بَعْضٌ':Subject, #1: 1	حِفْظُ الْبَصَرِ
u'حِفْظٌ بَعْضٌ':Added, #1: 1	حَفِظَ بَعْضُ
u'حِفْظٌ بَغْلٌ':Added, #1: 1	حِفْظَ الْبَعْضِ
u'حِفْظٌ بِنْيَةٌ':Added, #1: 1	حِفْظَ الْبَغْلِ
u'حِفْظٌ بَهيمٌ':Added, #2: 2	حِفْظِ الْبِنْيَةِ
u'حِفْظٌ بَهِيمَةٌ':Added, #1: 1	حِفْظُ بَهِيمَةِ
u'حِفْظٌ تَرِكَةٌ':Added, #1: 1	حِفْظُ بَهِيمَةِ
u'حِفْظٌ ثُغُورٌ':Added, #1: 1	حِفْظِ التَّرِكَةِ
u'حِفْظٌ ثِمارٌ':Added, #1: 1	حِفْظُ الثُّغُورِ
u'حِفْظٌ ثَمَرَةٌ':Added, #1: 1	حِفْظَ الثِّمَارِ
u'حِفْظٌ ثَمَنٌ':Added, #1: 1	حِفْظُ الثَّمَرَةِ
u'حِفْظٌ ثَوْبٌ':Added, #1: 1	حِفْظُ الثَّمَنِ
u'حِفْظٌ ثَوْبٌ':Added, #1: 1	حِفْظُ الثَّوْبِ
u'حِفْظٌ ثَوْبٌ':Added, #1: 1	حِفْظِ ثَوْبٍ
u'حِفْظٌ ثِيابٌ':Added, #2: 2	حِفْظِ ثَوْبِهِ
u'حِفْظٌ ثِيابٌ':Added, #1: 1	حِفْظُ الثِّيَابِ
u'حَفِظَ جَابِرٌ':Subject, #1: 1	حِفْظِ ثِيَابٍ
u'حِفْظٌ جَسَدٌ':Added, #1: 1	حَفِظَ جَابِرٌ
u'حِفْظٌ جَمَاعَةٌ':Added, #1: 1	حِفْظِ الْجَسَدِ
u'حِفْظٌ جِوَارٌ':Added, #1: 1	حِفْظِ الْجَمَاعَةِ
u'حَفِظَ حاكِمٌ':Subject, #1: 1	حِفْظُ الْجِوَارِ
u'حِفْظٌ حانوتٌ':Added, #1: 1	حَفِظَ الْحَاكِمُ
u'حَفِظَ حُجَّةٌ':Subject, #1: 1	حِفْظِ حَانُوتٍ
u'حِفْظٌ حَديثٌ':Added, #8: 8	حَفِظَ حُجَّةٌ
u'حِفْظٌ حَرارَةٌ':Added, #3: 3	حِفْظِ الْحَدِيثِ
u'حِفْظٌ حَرارَةٌ':Added, #1: 1	حِفْظُ الْحَرَارَةِ
u'حِفْظٌ حُروفٌ':Added, #1: 1	حِفْظِ الْحَرَارَةِ
u'حِفْظٌ حُرِّيَّةٌ':Added, #1: 1	حِفْظَ حُرُوفِهِ
u'حِفْظٌ حِشْمَةٌ':Added, #1: 1	حِفْظُ حُرِّيَّتِهِ
u'حِفْظٌ حِصْنٌ':Added, #1: 1	حِفْظِ الْحِشْمَةِ
u'حِفْظٌ حَقٌّ':Added, #1: 1	حِفْظِ الْحِصْنِ
u'حِفْظٌ حُقوقٌ':Added, #2: 2	حِفْظُ حَقِّ
u'حِفْظٌ حُقُوقٌ':Added, #1: 1	حِفْظِ الْحُقُوقِ
u'حِفْظٌ حُقوقٌ':Added, #1: 1	حِفْظِ الْحُقُوقِ
u'حِفْظٌ حُقُوقٌ':Added, #1: 1	حِفْظِ حُقُوقِ
u'حِفْظٌ حِكَايَةٌ':Added, #1: 1	حِفْظِ حُقُوقِ
u'حِفْظٌ خَارِجٌ':Added, #1: 1	حِفْظِ الْحِكَايَةِ
u'حَفِظَ خَبَرٌ':Predicate, #1: 1	حِفْظُ الْخَارِجِ
u'حَفِظَ خَبَر':Predicate, #1: 1	حَفِظَ خَبَرَ
u'حِفْظٌ خراج':Added, #1: 1	حَفِظَ خَبَرَ
u'حِفْظٌ خَرَاجٌ':Added, #1: 1	حِفْظَ الْخَرَاجِ
u'حِفْظٌ خَطٌّ':Added, #1: 1	حِفْظَ الْخَرَاجِ
u'حِفْظٌ خَطٌّ':Added, #1: 1	حِفْظَ الْخَطِّ
u'حِفْظٌ خَيْرٌ':Added, #1: 1	حِفْظِ الْخَطِّ
u'حِفْظٌ خَيْلٌ':Added, #1: 1	حِفْظِ الْخَيْرِ
u'حِفْظٌ دَابَّةٌ':Added, #1: 1	حِفْظِ الْخَيْلِ
u'حِفْظٌ دَاخِلٌ':Added, #2: 2	حِفْظِ دَابَّةٍ
u'حِفْظٌ دَارٌ':Added, #1: 1	حِفْظُ الدَّاخِلِ
u'حِفْظٌ دُعَاءٌ':Added, #1: 1	حِفْظِ دَارِهِ
u'حِفْظٌ دَمٌ':Added, #3: 3	حِفْظَ الدُّعَاءِ
u'حِفْظٌ دَمٌ':Added, #1: 1	حِفْظِ الدَّمِ
u'حِفْظٌ دَوَابُّ':Added, #1: 1	حِفْظِ دَمِ
u'حِفْظٌ دَواوينُ':Added, #1: 1	حِفْظِ دَوَابِّ
u'حِفْظٌ دَوْرٌ':Added, #1: 1	حِفْظِ دَوَاوِينِ
u'حِفْظٌ دِينٌ':Added, #1: 1	حِفْظِ دَوْرٍ
u'حِفْظٌ دِينٌ':Added, #1: 1	حِفْظَ الدِّينِ
u'حِفْظٌ دِينٌ':Added, #2: 2	حِفْظِ الدِّينِ
u'حَفِظَ رَأْسٌ':Predicate, #8: 8	حِفْظُ الدِّينِ
u'حِفْظٌ رَأْيٌ':Added, #1: 1	حَفِظَ الرَّأْسَ
u'حِفْظٌ رُبُعٌ':Added, #1: 1	حِفْظِ رَأْيٍ
u'حَفِظَ رِسَالَةٌ':Predicate, #1: 1	حِفْظُ الرُّبُعِ
u'حِفْظٌ رَهْنٌ':Added, #1: 1	حَفِظَ الرِّسَالَةَ
u'حَفِظَ رِوايَةٌ':Predicate, #1: 1	حِفْظِ الرَّهْنِ
u'حِفْظٌ رِوايَةٌ':Added, #1: 1	حَفِظَ رِوَايَةَ
u'حَفِظَ زائِدٌ':Predicate, #3: 3	حِفْظِ الرِّوَايَةِ
u'حِفْظٌ زَرْعٌ':Added, #1: 1	حَفِظَ الزَّائِدَ
u'حِفْظٌ زَرْعٌ':Added, #1: 1	حِفْظَ الزَّرْعِ
u'حِفْظٌ زُروعٌ':Added, #1: 1	حِفْظِ الزَّرْعِ
u'حِفْظٌ زُروعٌ':Added, #1: 1	حِفْظَ الزُّرُوعِ
u'حِفْظٌ سِرٌّ':Added, #1: 1	حِفْظِ الزُّرُوعِ
u'حِفْظٌ سِرٌّ':Added, #1: 1	حِفْظَ السِّرِّ
u'حِفْظٌ سَفِيهٌ':Added, #1: 1	حِفْظُ سِرِّ
u'حِفْظٌ سَلاَمَةٌ':Added, #1: 1	حِفْظِ السَّفِيهِ
u'حِفْظٌ سنن':Added, #1: 1	حِفْظُ السَّلَامَةِ
u'حِفْظٌ سنن':Added, #1: 1	حِفْظُ السُّنَنِ
u'حَفِظَ سُورَةٌ':Predicate, #1: 1	حِفْظِ السُّنَنِ
u'حِفْظٌ سُورَةٌ':Added, #2: 2	حَفِظَ سُورَةَ
u'حِفْظٌ شَارِدٌ':Added, #1: 1	حِفْظِ السُّورَةِ
u'حَفِظَ شَاهِدٌ':Subject, #1: 1	حِفْظَ الشَّارِدِ
u'حِفْظٌ شُرُوطٌ':Added, #1: 1	حَفِظَ الشَّاهِدُ
u'حِفْظٌ شَرِيعَةٌ':Added, #1: 1	حِفْظِ الشُّرُوطِ
u'حِفْظٌ شَرِيعَةٌ':Added, #1: 1	حِفْظَ الشَّرِيعَةِ
u'حِفْظٌ شَهَادَةٌ':Added, #2: 2	حِفْظِ الشَّرِيعَةِ
u'حِفْظٌ شَهَادَةٌ':Added, #1: 1	حِفْظِ الشَّهَادَاتِ
u'حِفْظٌ شَيْءٌ':Added, #1: 1	حِفْظُ الشَّهَادَةِ
u'حِفْظٌ شَيْءٌ':Added, #1: 1	حِفْظُ شَيْءٍ
u'حِفْظٌ شَيْءٌ':Added, #2: 2	حِفْظَ شَيْءٍ
u'حِفْظٌ صَبِيٌّ':Added, #2: 2	حِفْظِ شَيْءٍ
u'حِفْظٌ صَبِيٌّ':Added, #1: 1	حِفْظُ الصَّبِيِّ
u'حِفْظٌ صِبْيَانٌ':Added, #1: 1	حِفْظِ الصَّبِيِّ
u'حِفْظٌ صِحَّةٌ':Added, #1: 1	حِفْظِ الصِّبْيَانِ
u'حِفْظٌ صِحَّةٌ':Added, #1: 1	حِفْظَ الصِّحَّةِ
u'حِفْظٌ صِحَّةٌ':Added, #1: 1	حِفْظُ صِحَّةِ
u'حِفْظٌ صِحَّةٌ':Added, #1: 1	حِفْظِ صِحَّةِ
u'حِفْظٌ صِحَّةٌ':Added, #22: 22	حِفْظِ الصِّحَّةِ
u'حِفْظٌ صَغِيرٌ':Added, #3: 3	حِفْظُ الصِّحَّةِ
u'حِفْظٌ صَغِيرٌ':Added, #1: 1	حِفْظَ الصَّغِيرِ
u'حِفْظٌ صَلاَةٌ':Added, #1: 1	حِفْظِ الصَّغِيرِ
u'حِفْظٌ صَلاَةٌ':Added, #1: 1	حِفْظِ الصَّلَاةِ
u'حِفْظٌ صُورَةٌ':Added, #1: 1	حِفْظُ صَلَاتِهِ
u'حِفْظٌ صُورَةٌ':Added, #1: 1	حِفْظِ الصُّورَةِ
u'حِفْظٌ ضَرُورِيٌّ':Added, #2: 2	حِفْظُ صُورَتِهِ
u'حِفْظٌ ضَرُورِيٌّ':Added, #1: 1	حِفْظِ الضَّرُورِيِّ
u'حِفْظٌ ضَرُورِيٌّ':Added, #1: 1	حِفْظِ الضَّرُورِيَّاتِ
u'حِفْظٌ ضَرُورِيَّاتٌ':Added, #1: 1	حِفْظِ ضَرُورِيٍّ
u'حِفْظٌ طَرِيقٌ':Added, #1: 1	حِفْظِ الضَّرُورِيَّاتِ
u'حِفْظٌ طَرِيقٌ':Added, #1: 1	حِفْظُ الطَّرِيقِ
u'حِفْظٌ طعام':Added, #1: 1	حِفْظِ الطَّرِيقِ
u'حِفْظٌ طَعَامٌ':Added, #2: 2	حِفْظُ الطَّعَامِ
u'حِفْظٌ طِفْلٌ':Added, #2: 2	حِفْظُ الطَّعَامِ
u'حِفْظٌ عِبَادَةٌ':Added, #1: 1	حِفْظُ الطِّفْلِ
u'حِفْظٌ عِرْضٌ':Added, #1: 1	حِفْظُ الْعِبَادَةِ
u'حِفْظٌ عِرْضٌ':Added, #1: 1	حِفْظَ الْعِرْضِ
u'حَفِظَ عَشْرٌ':Predicate, #1: 1	حِفْظِ عِرْضِ
u'حِفْظٌ عَقْلٌ':Added, #1: 1	حَفِظَ عَشْرَ
u'حِفْظٌ عَقْلٌ':Added, #1: 1	حِفْظَ الْعَقْلِ
u'حِفْظٌ عَقْلٌ':Added, #1: 1	حِفْظُ الْعَقْلِ
u'حِفْظٌ عُقُولٌ':Added, #1: 1	حِفْظِ الْعَقْلِ
u'حِفْظٌ عُقُولٌ':Added, #1: 1	حِفْظَ الْعُقُولِ
u'حِفْظٌ علم':Added, #1: 1	حِفْظُ الْعُقُولِ
u'حِفْظٌ عِلْمٌ':Added, #1: 1	حِفْظَ الْعِلْمِ
u'حِفْظٌ عُمُومٌ':Added, #1: 1	حِفْظَ الْعِلْمِ
u'حَفِظَ عين':Predicate, #1: 1	حِفْظِ عُمُومِ
u'حَفِظَ عَيْنٌ':Predicate, #1: 1	حَفِظَ الْعَيْنَ
u'حَفِظَ عَيْن':Predicate, #1: 1	حَفِظَ الْعَيْنَ
u'حِفْظٌ عين':Added, #1: 1	حَفِظَ الْعَيْنَ
u'حِفْظٌ عَيْنٌ':Added, #1: 1	حِفْظَ الْعَيْنِ
u'حِفْظٌ عَيْن':Added, #1: 1	حِفْظَ الْعَيْنِ
u'حِفْظٌ عَيْنٌ':Added, #1: 1	حِفْظَ الْعَيْنِ
u'حِفْظٌ عَيْن':Added, #1: 1	حِفْظِ عَيْنٍ
u'حِفْظٌ عين':Added, #1: 1	حِفْظِ عَيْنٍ
u'حِفْظٌ عَيْنٌ':Added, #1: 1	حِفْظُ عَيْنِهِ
u'حِفْظٌ عَيْن':Added, #1: 1	حِفْظُ عَيْنِهِ
u'حِفْظٌ عين':Added, #1: 1	حِفْظُ عَيْنِهِ
u'حِفْظٌ عَيْنٌ':Added, #2: 2	حِفْظُ الْعَيْنِ
u'حِفْظٌ عَيْن':Added, #2: 2	حِفْظُ الْعَيْنِ
u'حِفْظٌ عين':Added, #2: 2	حِفْظُ الْعَيْنِ
u'حِفْظٌ عَيْنٌ':Added, #2: 2	حِفْظِ عَيْنِ
u'حِفْظٌ عَيْن':Added, #2: 2	حِفْظِ عَيْنِ
u'حِفْظٌ عين':Added, #2: 2	حِفْظِ عَيْنِ
u'حِفْظٌ عَيْنٌ':Added, #3: 3	حِفْظِ الْعَيْنِ
u'حِفْظٌ عَيْن':Added, #3: 3	حِفْظِ الْعَيْنِ
u'حِفْظٌ غَرِيبٌ':Added, #3: 3	حِفْظِ الْعَيْنِ
u'حِفْظٌ غير':Added, #1: 1	حِفْظُ غَرِيبِ
u'حِفْظٌ غَيْرٌ':Added, #1: 1	حِفْظِ الْغَيْرِ
u'حِفْظٌ فَرْجٌ':Added, #1: 1	حِفْظِ الْغَيْرِ
u'حَفِظَ قَالٌ':Predicate, #3: 3	حِفْظِ الْفَرْجِ
u'حِفْظٌ قَدْرٌ':Added, #1: 1	حَفِظَ قَالَ
u'حِفْظٌ قَدْرٌ':Added, #1: 1	حِفْظِ الْقَدْرِ
u'حَفِظَ قُرْآنٌ':Predicate, #1: 1	حِفْظَ قَدْرِ
u'حِفْظٌ قُرْآنٌ':Added, #6: 6	حَفِظَ الْقُرْآنَ
u'حِفْظٌ قُرْآنٌ':Added, #10: 10	حِفْظِ الْقُرْآنِ
u'حِفْظٌ قُرْآنٌ':Added, #3: 3	حِفْظَ الْقُرْآنِ
u'حِفْظٌ قِطَارٌ':Added, #3: 3	حِفْظُ الْقُرْآنِ
u'حِفْظٌ قَوَانِينُ':Added, #2: 2	حِفْظُ الْقِطَارِ
u'حِفْظٌ قَوَانِينُ':Added, #1: 1	حِفْظِ الْقَوَانِينِ
u'حِفْظٌ قُوَّةٌ':Added, #2: 2	حِفْظُ الْقَوَانِينِ
u'حِفْظٌ قُوَّة':Added, #1: 1	حِفْظُ الْقُوَّةِ
u'حِفْظٌ كُتُبٌ':Added, #1: 1	حِفْظُ الْقُوَّةِ
u'حِفْظٌ كَثِيرٌ':Added, #1: 1	حِفْظُ الْكُتُبِ
u'حِفْظٌ كُلِّيٌّ':Added, #1: 1	حِفْظِ الْكَثِيرِ
u'حِفْظٌ كُلِّيَّاتٌ':Added, #1: 1	حِفْظُ الْكُلِّيَّاتِ
u'حِفْظٌ كُلِّيَّةٌ':Added, #1: 1	حِفْظُ الْكُلِّيَّاتِ
u'حِفْظٌ لِسَانٌ':Added, #1: 1	حِفْظُ الْكُلِّيَّاتِ
u'حِفْظٌ لِسَانٌ':Added, #1: 1	حِفْظَ اللِّسَانِ
u'حِفْظٌ لِسَانٌ':Added, #1: 1	حِفْظُ لِسَانِهِ
u'حِفْظٌ لِسَانٌ':Added, #3: 3	حِفْظِ اللِّسَانِ
u'حِفْظٌ لُغَةٌ':Added, #5: 5	حِفْظُ اللِّسَانِ
u'حِفْظٌ لَفْظٌ':Added, #1: 1	حِفْظَ اللُّغَةِ
u'حِفْظٌ لَقِيطٌ':Added, #1: 1	حِفْظِ لَفْظِهِ
u'حِفْظٌ مَاءٌ':Added, #1: 1	حِفْظُ اللَّقِيطِ
u'حِفْظٌ مَاءٌ':Added, #1: 1	حِفْظَ الْمَاءِ
u'حِفْظٌ مَاءٌ':Added, #1: 1	حِفْظِ مَاءِ
u'حِفْظٌ مَاشِي':Added, #2: 2	حِفْظُ الْمَاءِ
u'حِفْظٌ مَاشِي':Added, #1: 1	حِفْظَ الْمَاشِيَةِ
u'حِفْظٌ مَاشِيَةٌ':Added, #1: 1	حِفْظِ مَاشِيَةٍ
u'حِفْظٌ مَاشِيَةٌ':Added, #1: 1	حِفْظَ الْمَاشِيَةِ
u'حِفْظٌ مَالٌ':Added, #1: 1	حِفْظِ مَاشِيَةٍ
u'حِفْظٌ مَالٌ':Added, #10: 10	حِفْظَ مَالِ
u'حِفْظٌ مَالٌ':Added, #11: 11	حِفْظِ الْمَالِ
u'حِفْظٌ مَالٌ':Added, #11: 11	حِفْظِ مَالِهِ
u'حِفْظٌ مَالٌ':Added, #1: 1	حِفْظَ الْمَالِ
u'حِفْظٌ مَالٌ':Added, #1: 1	حِفْظِ الْمَالَيْنِ
u'حِفْظٌ مَالٌ':Added, #1: 1	حِفْظِ مَالٍ
u'حِفْظٌ مَالٌ':Added, #1: 1	حِفْظَ مَالِهِ
u'حِفْظٌ مَالٌ':Added, #6: 6	حِفْظُ الْمَالِ
u'حِفْظٌ مَالٌ':Added, #6: 6	حِفْظُ مَالِ
u'حِفْظٌ مَالٌ':Added, #6: 6	حِفْظِ مَالِ
u'حِفْظٌ مَالِكٌ':Added, #7: 7	حِفْظُ مَالِهِ
u'حِفْظٌ مَتَاعٌ':Added, #1: 1	حِفْظِ مَالِكٍ
u'حِفْظٌ مَتَاعٌ':Added, #1: 1	حِفْظِ مَتَاعِ
u'حِفْظٌ مَحَلٌّ':Added, #2: 2	حِفْظِ الْمَتَاعِ
u'حِفْظٌ مُحَمَّدٌ':Added, #1: 1	حِفْظَ مَحَلِّ
u'حِفْظٌ مَحْمُودٌ':Added, #1: 1	حِفْظِ مُحَمّدِ
u'حِفْظٌ مُخْتَصَرٌ':Added, #1: 1	حِفْظِ مَحْمُودِ
u'حِفْظٌ مَخْلُوقٌ':Added, #1: 1	حِفْظِ الْمُخْتَصَرِ
u'حَفِظَ مَذْهَبٌ':Predicate, #1: 1	حِفْظُ مَخْلُوقَاتِهِ
u'حِفْظٌ مَذْهَبٌ':Added, #1: 1	حَفِظَ مَذْهَبَ
u'حِفْظٌ مَذْهَبٌ':Added, #1: 1	حِفْظُ الْمَذْهَبِ
u'حِفْظٌ مرٌّ':Added, #1: 1	حِفْظِ الْمَذْهَبِ
u'حِفْظٌ مَسْجِدٌ':Added, #1: 1	حِفْظِ مَرَّتَيْنِ
u'حِفْظٌ مَسْجِدٌ':Added, #1: 1	حِفْظُ الْمَسْجِدِ
u'حِفْظٌ مَسْنُونٌ':Added, #1: 1	حِفْظِ الْمَسْجِدِ
u'حِفْظٌ مَصَالِحُ':Added, #1: 1	حِفْظُ الْمَسْنُونِ
u'حِفْظٌ مَضْمُونٌ':Added, #1: 1	حِفْظِ مَصَالِحِ
u'حِفْظٌ مُعْتَادٌ':Added, #1: 1	حِفْظِ الْمَضْمُونِ
u'حِفْظٌ مُعْظَمٌ':Added, #1: 1	حِفْظِ مُعْتَادٍ
u'حِفْظٌ مَقَاصِدُ':Added, #1: 1	حِفْظُ مُعْظَمِ
u'حِفْظٌ مَقْصُودٌ':Added, #1: 1	حِفْظِ مَقَاصِدِ
u'حِفْظٌ مَكَانٌ':Added, #1: 1	حِفْظَ مَقْصُودٍ
u'حِفْظٌ مِلْكٌ':Added, #1: 1	حِفْظُ الْمَكَانِ
u'حِفْظٌ مِلْكٌ':Added, #1: 1	حِفْظِ مِلْكٍ
u'حِفْظٌ مَنْصِبٌ':Added, #3: 3	حِفْظُ مِلْكِهِ
u'حِفْظٌ مَنْطِقٌ':Added, #1: 1	حِفْظُ مَنْصِبِ
u'حِفْظٌ مُهْجَةٌ':Added, #2: 2	حِفْظِ الْمَنْطِقِ
u'حِفْظٌ مَوْجُودٌ':Added, #1: 1	حِفْظَ مُهْجَةِ
u'حِفْظٌ نَاسٌ':Added, #2: 2	حِفْظِ الْمَوْجُودِ
u'حِفْظٌ نِساءٌ':Added, #1: 1	حِفْظَ النَّاسِ
u'حِفْظٌ نَسَبٌ':Added, #1: 1	حِفْظُ النِّسَاءِ
u'حِفْظٌ نَسَبٌ':Added, #2: 2	حِفْظُ النَّسَبِ
u'حِفْظٌ نَسْلٌ':Added, #4: 4	حِفْظِ النَّسَبِ
u'حِفْظٌ نَسْلٌ':Added, #1: 1	حِفْظِ النَّسْلِ
u'حَفِظَ نُصُوصٌ':Predicate, #2: 2	حِفْظُ النَّسْلِ
u'حِفْظٌ نَصِيبٌ':Added, #1: 1	حَفِظَ نُصُوصَ
u'حِفْظٌ نَفْسٌ':Added, #1: 1	حِفْظُ نَصِيبِ
u'حِفْظٌ نَفْسٌ':Added, #1: 1	حِفْظَ النَّفْسِ
u'حِفْظٌ نَفْسٌ':Added, #1: 1	حِفْظَ نَفْسِهِ
u'حِفْظٌ نَفْسٌ':Added, #2: 2	حِفْظُ نَفْسِهِ
u'حِفْظٌ نَفْسٌ':Added, #3: 3	حِفْظُ النَّفْسِ
u'حِفْظٌ نَفْسٌ':Added, #7: 7	حِفْظِ نَفْسِهِ
u'حِفْظٌ نُفُوسٌ':Added, #9: 9	حِفْظِ النَّفْسِ
u'حِفْظٌ نُفُوسٌ':Added, #1: 1	حِفْظَ النُّفُوسِ
u'حِفْظٌ نُفُوسٌ':Added, #2: 2	حِفْظُ النُّفُوسِ
u'حَفِظَ وَدِيعٌ':Predicate, #4: 4	حِفْظِ النُّفُوسِ
u'حِفْظٌ وَدِيعٌ':Added, #3: 3	حَفِظَ الْوَدِيعَةَ
u'حِفْظٌ وَدِيعٌ':Added, #2: 2	حِفْظَ الْوَدِيعَةِ
u'حِفْظٌ وَدِيعٌ':Added, #2: 2	حِفْظُ الْوَدِيعَةِ
u'حَفِظَ وَدِيعَةٌ':Predicate, #4: 4	حِفْظِ الْوَدِيعَةِ
u'حِفْظٌ وَدِيعَةٌ':Added, #3: 3	حَفِظَ الْوَدِيعَةَ
u'حِفْظٌ وَدِيعَةٌ':Added, #2: 2	حِفْظَ الْوَدِيعَةِ
u'حِفْظٌ وَدِيعَةٌ':Added, #2: 2	حِفْظُ الْوَدِيعَةِ
u'حِفْظٌ وَقْتٌ':Added, #4: 4	حِفْظِ الْوَدِيعَةِ
u'حِفْظٌ وَقْفٌ':Added, #1: 1	حِفْظِ وَقْتِ
u'حِفْظٌ وَقْفٌ':Added, #1: 1	حِفْظَ الْوَقْفِ
u'حِفْظٌ وَقْفٌ':Added, #1: 1	حِفْظُ الْوَقْفِ
u'حِفْظٌ وَقْفٌ':Added, #2: 2	حِفْظِ وَقْفٍ
u'حِفْظٌ ولد':Added, #4: 4	حِفْظِ الْوَقْفِ
u'حِفْظٌ وَلَدٌ':Added, #1: 1	حِفْظِ الْوَلَدِ
u'حِفْظٌ ولد':Added, #1: 1	حِفْظِ الْوَلَدِ
u'حِفْظٌ وَلَدٌ':Added, #2: 2	حِفْظُ الْوَلَدِ
u'حِفْظٌ وَلِيٌّ':Added, #2: 2	حِفْظُ الْوَلَدِ
u'حَفِيفٌ ريحٌ':Added, #1: 1	حِفْظَ الْوَلِيِّ
u'حَفِيَ قَلَمٌ':Subject, #2: 2	حَفِيفِ الرّيحِ
u'حقاد أَعْدَاءٌ':Added, #1: 1	حَفِيَ الْقَلَمُ
u'حَقَّ آدَمِيٌّ':Predicate, #1: 1	أَحْقَادُ الْأَعْدَاءِ
u'حَقَارَةٌ أصل':Added, #1: 1	حَقَّ الْآدَمِيِّينَ
u'حَقَارَةٌ أًصْلٌ':Added, #1: 1	حَقَارَةَ أَصْلِهِ
u'حَقَّ أُمِّيٌّ':Predicate, #1: 1	حَقَارَةَ أَصْلِهِ
u'حَقَّ أُمِّيَّةٌ':Predicate, #1: 1	حَقَّ أُمِّيَّةَ
u'حَقِبَ أَمْرٌ':Subject, #1: 1	حَقَّ أُمِّيَّةَ
u'حَقِبَ بَعيرٌ':Subject, #1: 1	حَقِبَ الْأَمْرُ
u'حَقَرَ رِجَالٌ':Predicate, #3: 3	حَقِبَ الْبَعِيرُ
u'حَقَّ شَيْءٌ':Subject, #1: 1	حَقَرَ الرِّجَالَ
u'حَقَّ طَرِيقٌ':Predicate, #3: 3	حَقَّ الشَّيْءُ
u'حَقَّ عَبْدٌ':Subject, #1: 1	حَقَّ الطَّرِيقَ
u'حَقَّ غانِم':Predicate, #1: 1	حَقَّ الْعَبْدُ
u'حَقَّ فلان':Predicate, #5: 5	حَقَّ الْغَانِمِينَ
u'حَقَّقَ أَكْمَلُ':Subject, #5: 5	حَقَّ الْغَانِمِينَ
u'حَقَّ قَبْضٌ':Predicate, #1: 1	حَقَّقَ الْأَكْمَلُ
u'حَقَّقَ خِلاَفٌ':Predicate, #1: 1	حَقَّ قَبْضَ
u'حَقَّقَ سَبَبٌ':Predicate, #6: 6	حَقَّقَ الْخِلَافَ
u'حَقَّقَ مَسْأَلَةٌ':Predicate, #1: 1	حَقَّقَ سَبَبَ
u'حَقَّقَ مَفْسَدَةٌ':Predicate, #1: 1	حَقَّقَ الْمَسْأَلَةَ
u'حَقَّقَ مَقَامٌ':Predicate, #1: 1	حَقَّقَ الْمَفْسَدَةَ
u'حَقَّقَ نَظَرٌ':Predicate, #2: 2	حَقَّقَ الْمَقَامَ
u'حَقَّ قول':Subject, #2: 2	حَقَّقَ النَّظَرَ
u'حَقَّ قَوْلٌ':Subject, #2: 2	حَقَّ الْقَوْلُ
u'حَقَّ مُسْلِمٌ':Predicate, #2: 2	حَقَّ الْقَوْلُ
u'حَقْنٌ خُبْثٌ':Added, #1: 1	حَقَّ الْمُسْلِمِينَ
u'حَقْنٌ دَمٌ':Added, #1: 1	حَقْنِ الْخُبْثِ
u'حَقْنٌ دَمٌ':Added, #1: 1	حَقْنُ الدَّمِ
u'حَقْنٌ دَمٌ':Added, #4: 4	حَقْنَ الدَّمِ
u'حَقْنٌ دِماءٌ':Added, #5: 5	حَقْنِ الدَّمِ
u'حَقْنٌ دِماءٌ':Added, #1: 1	حَقْنُ الدِّمَاءِ
u'حَقْنٌ دِماءٌ':Added, #1: 1	حَقْنِ الدِّمَاءِ
u'حَقَنَ صلح':Subject, #1: 1	حَقْنُ دِمَاءِ
u'حَقَنَ صُلْحٌ':Subject, #1: 1	حَقَنَ الصّلْحُ
u'حَقَنَ مَرِيضٌ':Predicate, #1: 1	حَقَنَ الصّلْحُ
u'حَقْوٌ بَعيرٌ':Added, #1: 1	حَقَنَ الْمَرِيضَ
u'حُقوقٌ أَبٌ':Added, #2: 2	حَقْوِ الْبَعِيرِ
u'حُقُوقٌ أَبٌ':Added, #2: 2	حُقُوقِ الْأَبِ
u'حُقوقٌ آدَمِيٌّ':Added, #2: 2	حُقُوقِ الْأَبِ
u'حُقُوقٌ آدَمِيٌّ':Added, #1: 1	حُقُوقُ الْآدَمِيِّ
u'حُقوقٌ آدَمِيٌّ':Added, #1: 1	حُقُوقُ الْآدَمِيِّ
u'حُقُوقٌ آدَمِيٌّ':Added, #5: 5	حُقُوقِ الْآدَمِيِّ
u'حُقوقٌ أرْضٌ':Added, #5: 5	حُقُوقِ الْآدَمِيِّ
u'حُقُوقٌ أرْضٌ':Added, #4: 4	حُقُوقِ الْأَرْضِ
u'حُقوقٌ أُسْتَاذٌ':Added, #4: 4	حُقُوقِ الْأَرْضِ
u'حُقُوقٌ أُسْتَاذٌ':Added, #1: 1	حُقُوقَ أُسْتَاذِهِ
u'حُقوقٌ إمَارَةٌ':Added, #1: 1	حُقُوقَ أُسْتَاذِهِ
u'حُقُوقٌ إمَارَةٌ':Added, #1: 1	حُقُوقِ الْإِمَارَةِ
u'حُقوقٌ إمَامَةٌ':Added, #1: 1	حُقُوقِ الْإِمَارَةِ
u'حُقُوقٌ إمَامَةٌ':Added, #1: 1	حُقُوقُ الْإِمَامَةِ
u'حُقوقٌ أُمَّةٌ':Added, #1: 1	حُقُوقُ الْإِمَامَةِ
u'حُقُوقٌ أُمَّةٌ':Added, #3: 3	حُقُوقِ الْأُمَّةِ
u'حُقوقٌ أَمْلاكٌ':Added, #3: 3	حُقُوقِ الْأُمَّةِ
u'حُقوقٌ أَمْلاَكٌ':Added, #1: 1	حُقُوقُ أَمْلَاكٍ
u'حُقُوقٌ أَمْلاكٌ':Added, #1: 1	حُقُوقُ أَمْلَاكٍ
u'حُقُوقٌ أَمْلاَكٌ':Added, #1: 1	حُقُوقُ أَمْلَاكٍ
u'حُقوقٌ أَمْلاكٌ':Added, #1: 1	حُقُوقُ أَمْلَاكٍ
u'حُقوقٌ أَمْلاَكٌ':Added, #3: 3	حُقُوقِ الْأَمْلَاكِ
u'حُقُوقٌ أَمْلاكٌ':Added, #3: 3	حُقُوقِ الْأَمْلَاكِ
u'حُقُوقٌ أَمْلاَكٌ':Added, #3: 3	حُقُوقِ الْأَمْلَاكِ
u'حُقوقٌ أَمْوَالٌ':Added, #3: 3	حُقُوقِ الْأَمْلَاكِ
u'حُقوقٌ أَمْوَالٌ':Added, #1: 1	حُقُوقُ الْأَمْوَالِ
u'حُقُوقٌ أَمْوَالٌ':Added, #1: 1	حُقُوقِ الْأَمْوَالِ
u'حُقُوقٌ أَمْوَالٌ':Added, #1: 1	حُقُوقُ الْأَمْوَالِ
u'حُقوقٌ أُناسٌ':Added, #1: 1	حُقُوقِ الْأَمْوَالِ
u'حُقُوقٌ أُناسٌ':Added, #1: 1	حُقُوقَ أُنَاسٍ
u'حُقوقٌ أهْلٌ':Added, #1: 1	حُقُوقَ أُنَاسٍ
u'حُقُوقٌ أهْلٌ':Added, #1: 1	حُقُوقُ أَهْلِ
u'حُقوقٌ بِئْرٌ':Added, #1: 1	حُقُوقُ أَهْلِ
u'حُقُوقٌ بِئْرٌ':Added, #1: 1	حُقُوقِ الْبِئْرِ
u'حُقوقٌ بَيْتٌ':Added, #1: 1	حُقُوقِ الْبِئْرِ
u'حُقُوقٌ بَيْتٌ':Added, #19: 19	حُقُوقِ بَيْتِ
u'حُقوقٌ بَيْتٌ':Added, #19: 19	حُقُوقِ بَيْتِ
u'حُقُوقٌ بَيْتٌ':Added, #2: 2	حُقُوقُ بَيْتِ
u'حُقوقٌ تَصَرُّفٌ':Added, #2: 2	حُقُوقُ بَيْتِ
u'حُقُوقٌ تَصَرُّفٌ':Added, #1: 1	حُقُوقِ تَصَرُّفِهِ
u'حُقوقٌ تَمَلُّكٌ':Added, #1: 1	حُقُوقِ تَصَرُّفِهِ
u'حُقُوقٌ تَمَلُّكٌ':Added, #1: 1	حُقُوقُ التَّمَلُّكَاتِ
u'حُقوقٌ تَوْكِيلٌ':Added, #1: 1	حُقُوقُ التَّمَلُّكَاتِ
u'حُقُوقٌ تَوْكِيلٌ':Added, #1: 1	حُقُوقِ التَّوْكِيلِ
u'حُقوقٌ جَمِيع':Added, #1: 1	حُقُوقِ التَّوْكِيلِ
u'حُقُوقٌ جَمِيع':Added, #1: 1	حُقُوقِ الْجَمِيعِ
u'حُقوقٌ جهاد':Added, #1: 1	حُقُوقِ الْجَمِيعِ
u'حُقُوقٌ جهاد':Added, #2: 2	حُقُوقِ الْجِهَادِ
u'حُقوقٌ جِهَادٌ':Added, #2: 2	حُقُوقِ الْجِهَادِ
u'حُقُوقٌ جِهَادٌ':Added, #2: 2	حُقُوقِ الْجِهَادِ
u'حُقوقٌ حُرِّيَّةٌ':Added, #2: 2	حُقُوقِ الْجِهَادِ
u'حُقُوقٌ حُرِّيَّةٌ':Added, #1: 1	حُقُوقِ الْحُرِّيَّةِ
u'حُقوقٌ حِمَايَةٌ':Added, #1: 1	حُقُوقِ الْحُرِّيَّةِ
u'حُقُوقٌ حِمَايَةٌ':Added, #1: 1	حُقُوقِ الْحِمَايَةِ
u'حُقوقٌ خِلاَفَةٌ':Added, #1: 1	حُقُوقِ الْحِمَايَةِ
u'حُقُوقٌ خِلاَفَةٌ':Added, #1: 1	حُقُوقِ خِلَافَتِهِ
u'حُقوقٌ خلق':Added, #1: 1	حُقُوقِ خِلَافَتِهِ
u'حُقُوقٌ خلق':Added, #2: 2	حُقُوقِ الْخَلْقِ
u'حُقوقٌ خَلْقٌ':Added, #2: 2	حُقُوقِ الْخَلْقِ
u'حُقُوقٌ خَلْقٌ':Added, #2: 2	حُقُوقِ الْخَلْقِ
u'حُقوقٌ دَارٌ':Added, #2: 2	حُقُوقِ الْخَلْقِ
u'حُقُوقٌ دَارٌ':Added, #1: 1	حُقُوقَ الدَّارِ
u'حُقوقٌ دَارٌ':Added, #1: 1	حُقُوقَ الدَّارِ
u'حُقُوقٌ دَارٌ':Added, #2: 2	حُقُوقِ الدَّارِ
u'حُقوقٌ رَعِيَّةٌ':Added, #2: 2	حُقُوقِ الدَّارِ
u'حُقُوقٌ رَعِيَّةٌ':Added, #1: 1	حُقُوقِ الرَّعِيَّةِ
u'حُقوقٌ زَرْعٌ':Added, #1: 1	حُقُوقِ الرَّعِيَّةِ
u'حُقُوقٌ زَرْعٌ':Added, #1: 1	حُقُوقِ الزَّرْعِ
u'حُقوقٌ زَوْجٌ':Added, #1: 1	حُقُوقِ الزَّرْعِ
u'حُقُوقٌ زَوْجٌ':Added, #1: 1	حُقُوقِ الزَّوْجَيْنِ
u'حُقوقٌ زَوْجٌ':Added, #1: 1	حُقُوقِ الزَّوْجَيْنِ
u'حُقُوقٌ زَوْجٌ':Added, #2: 2	حُقُوقِ الزَّوْجِ
u'حُقوقٌ زَوْجَةٌ':Added, #2: 2	حُقُوقِ الزَّوْجِ
u'حُقُوقٌ زَوْجَةٌ':Added, #1: 1	حُقُوقِ زَوْجَتِهِ
u'حُقوقٌ زَوْجَةٌ':Added, #1: 1	حُقُوقِ زَوْجَتِهِ
u'حُقُوقٌ زَوْجَةٌ':Added, #2: 2	حُقُوقِ الزَّوْجَةِ
u'حُقوقٌ زَوْجِيٌّ':Added, #2: 2	حُقُوقِ الزَّوْجَةِ
u'حُقُوقٌ زَوْجِيٌّ':Added, #10: 10	حُقُوقِ الزَّوْجِيَّةِ
u'حُقوقٌ زَوْجِيٌّ':Added, #10: 10	حُقُوقِ الزَّوْجِيَّةِ
u'حُقُوقٌ زَوْجِيٌّ':Added, #1: 1	حُقُوقَ الزَّوْجِيَّةِ
u'حُقوقٌ سِياسَةٌ':Added, #1: 1	حُقُوقَ الزَّوْجِيَّةِ
u'حُقُوقٌ سِياسَةٌ':Added, #1: 1	حُقُوقِ السِّيَاسَةِ
u'حُقوقٌ سَيِّدٌ':Added, #1: 1	حُقُوقِ السِّيَاسَةِ
u'حُقُوقٌ سَيِّدٌ':Added, #2: 2	حُقُوقِ السَّيِّدِ
u'حُقوقٌ شَرْعٌ':Added, #2: 2	حُقُوقِ السَّيِّدِ
u'حُقُوقٌ شَرْعٌ':Added, #15: 15	حُقُوقِ الشَّرْعِ
u'حُقوقٌ صفح':Added, #15: 15	حُقُوقِ الشَّرْعِ
u'حُقُوقٌ صفح':Added, #1: 1	حُقُوقِ الصَّفْحِ
u'حُقوقٌ صَفْحٌ':Added, #1: 1	حُقُوقِ الصَّفْحِ
u'حُقُوقٌ صَفْحٌ':Added, #1: 1	حُقُوقِ الصَّفْحِ
u'حُقوقٌ طَرِيقٌ':Added, #1: 1	حُقُوقِ الصَّفْحِ
u'حُقُوقٌ طَرِيقٌ':Added, #1: 1	حُقُوقِ الطَّرِيقِ
u'حُقوقٌ عَامٌّ':Added, #1: 1	حُقُوقِ الطَّرِيقِ
u'حُقُوقٌ عَامٌّ':Added, #1: 1	حُقُوقِ الْعَامَّةِ
u'حُقوقٌ عِبَادٌ':Added, #1: 1	حُقُوقِ الْعَامَّةِ
u'حُقُوقٌ عِبَادٌ':Added, #10: 10	حُقُوقَ الْعِبَادِ
u'حُقوقٌ عِبَادٌ':Added, #10: 10	حُقُوقَ الْعِبَادِ
u'حُقُوقٌ عِبَادٌ':Added, #120: 120	حُقُوقِ الْعِبَادِ
u'حُقوقٌ عِبَادٌ':Added, #120: 120	حُقُوقِ الْعِبَادِ
u'حُقُوقٌ عِبَادٌ':Added, #12: 12	حُقُوقُ الْعِبَادِ
u'حُقوقٌ عِبَادٌ':Added, #12: 12	حُقُوقُ الْعِبَادِ
u'حُقُوقٌ عِبَادٌ':Added, #1: 1	حُقُوقُ عِبَادِهِ
u'حُقوقٌ عِبَادَةٌ':Added, #1: 1	حُقُوقُ عِبَادِهِ
u'حُقُوقٌ عِبَادَةٌ':Added, #1: 1	حُقُوقِ الْعِبَادَةِ
u'حُقوقٌ عَبْدٌ':Added, #1: 1	حُقُوقِ الْعِبَادَةِ
u'حُقُوقٌ عَبْدٌ':Added, #4: 4	حُقُوقِ الْعَبْدِ
u'حُقوقٌ عِدَّةٌ':Added, #4: 4	حُقُوقِ الْعَبْدِ
u'حُقُوقٌ عِدَّةٌ':Added, #1: 1	حُقُوقِ الْعِدَّةِ
u'حُقوقٌ عَسَلٌ':Added, #1: 1	حُقُوقِ الْعِدَّةِ
u'حُقُوقٌ عَسَلٌ':Added, #1: 1	حُقُوقِ الْعَسَلِ
u'حُقوقٌ عَقْدٌ':Added, #1: 1	حُقُوقِ الْعَسَلِ
u'حُقُوقٌ عَقْدٌ':Added, #13: 13	حُقُوقُ الْعَقْدِ
u'حُقوقٌ عَقْدٌ':Added, #13: 13	حُقُوقُ الْعَقْدِ
u'حُقوقٌ عَقْدٌ':Added, #1: 1	حُقُوقَ عَقْدِ
u'حُقُوقٌ عَقْدٌ':Added, #1: 1	حُقُوقِ عَقْدِ
u'حُقُوقٌ عَقْدٌ':Added, #1: 1	حُقُوقَ عَقْدِ
u'حُقوقٌ عَقْدٌ':Added, #1: 1	حُقُوقِ عَقْدِ
u'حُقُوقٌ عَقْدٌ':Added, #21: 21	حُقُوقِ الْعَقْدِ
u'حُقوقٌ عَقْدٌ':Added, #21: 21	حُقُوقِ الْعَقْدِ
u'حُقُوقٌ عَقْدٌ':Added, #28: 28	حُقُوقَ الْعَقْدِ
u'حُقوقٌ عَقْدٌ':Added, #28: 28	حُقُوقَ الْعَقْدِ
u'حُقُوقٌ عَقْدٌ':Added, #2: 2	حُقُوقُ عَقْدٍ
u'حُقوقٌ عَقْدٌ':Added, #2: 2	حُقُوقُ عَقْدٍ
u'حُقُوقٌ عَقْدٌ':Added, #2: 2	حُقُوقِ عَقْدِهِ
u'حُقوقٌ عُلْوٌ':Added, #2: 2	حُقُوقِ عَقْدِهِ
u'حُقُوقٌ عُلْوٌ':Added, #1: 1	حُقُوقِ الْعُلْوِ
u'حُقوقٌ عين':Added, #1: 1	حُقُوقِ الْعُلْوِ
u'حُقوقٌ عَيْنٌ':Added, #1: 1	حُقُوقُ الْعَيْنِ
u'حُقوقٌ عَيْن':Added, #1: 1	حُقُوقُ الْعَيْنِ
u'حُقُوقٌ عين':Added, #1: 1	حُقُوقُ الْعَيْنِ
u'حُقُوقٌ عَيْنٌ':Added, #1: 1	حُقُوقُ الْعَيْنِ
u'حُقُوقٌ عَيْن':Added, #1: 1	حُقُوقُ الْعَيْنِ
u'حُقوقٌ عين':Added, #1: 1	حُقُوقُ الْعَيْنِ
u'حُقوقٌ عَيْنٌ':Added, #4: 4	حُقُوقِ الْعَيْنِ
u'حُقوقٌ عَيْن':Added, #4: 4	حُقُوقِ الْعَيْنِ
u'حُقُوقٌ عين':Added, #4: 4	حُقُوقِ الْعَيْنِ
u'حُقُوقٌ عَيْنٌ':Added, #4: 4	حُقُوقِ الْعَيْنِ
u'حُقُوقٌ عَيْن':Added, #4: 4	حُقُوقِ الْعَيْنِ
u'حُقوقٌ غَائِبٌ':Added, #4: 4	حُقُوقِ الْعَيْنِ
u'حُقُوقٌ غَائِبٌ':Added, #3: 3	حُقُوقِ الْغَائِبِ
u'حُقوقٌ غرماء':Added, #3: 3	حُقُوقِ الْغَائِبِ
u'حُقوقٌ غرماء':Added, #1: 1	حُقُوقُ غُرَمَاءِ
u'حُقُوقٌ غرماء':Added, #1: 1	حُقُوقِ غُرَمَاءِ
u'حُقُوقٌ غرماء':Added, #1: 1	حُقُوقُ غُرَمَاءِ
u'حُقوقٌ غرماء':Added, #1: 1	حُقُوقِ غُرَمَاءِ
u'حُقُوقٌ غرماء':Added, #2: 2	حُقُوقِ الْغُرَمَاءِ
u'حُقوقٌ غرماء':Added, #2: 2	حُقُوقِ الْغُرَمَاءِ
u'حُقُوقٌ غرماء':Added, #3: 3	حُقُوقَ الْغُرَمَاءِ
u'حُقوقٌ غرماء':Added, #3: 3	حُقُوقَ الْغُرَمَاءِ
u'حُقُوقٌ غرماء':Added, #4: 4	حُقُوقُ الْغُرَمَاءِ
u'حُقوقٌ غير':Added, #4: 4	حُقُوقُ الْغُرَمَاءِ
u'حُقوقٌ غَيْرٌ':Added, #1: 1	حُقُوقِ غَيْرِ
u'حُقُوقٌ غير':Added, #1: 1	حُقُوقِ غَيْرِ
u'حُقُوقٌ غَيْرٌ':Added, #1: 1	حُقُوقِ غَيْرِ
u'حُقوقٌ فَرْعٌ':Added, #1: 1	حُقُوقِ غَيْرِ
u'حُقُوقٌ فَرْعٌ':Added, #1: 1	حُقُوقِ الْفَرْعِ
u'حُقوقٌ فقراء':Added, #1: 1	حُقُوقِ الْفَرْعِ
u'حُقُوقٌ فقراء':Added, #1: 1	حُقُوقِ الْفُقَرَاءِ
u'حُقوقٌ قُرْآنٌ':Added, #1: 1	حُقُوقِ الْفُقَرَاءِ
u'حُقُوقٌ قُرْآنٌ':Added, #1: 1	حُقُوقَ الْقُرْآنِ
u'حُقوقٌ قَضَاءٌ':Added, #1: 1	حُقُوقَ الْقُرْآنِ
u'حُقُوقٌ قَضَاءٌ':Added, #1: 1	حُقُوقِ الْقَضَاءِ
u'حُقوقٌ كِتَابَةٌ':Added, #1: 1	حُقُوقِ الْقَضَاءِ
u'حُقُوقٌ كِتَابَةٌ':Added, #1: 1	حُقُوقِ كِتَابَةِ
u'حُقوقٌ مَاءٌ':Added, #1: 1	حُقُوقِ كِتَابَةِ
u'حُقُوقٌ مَاءٌ':Added, #1: 1	حُقُوقُ مَاءٍ
u'حُقوقٌ مَارٌّ':Added, #1: 1	حُقُوقُ مَاءٍ
u'حُقُوقٌ مَارٌّ':Added, #1: 1	حُقُوقِ الْمَارِّ
u'حُقوقٌ مَالٌ':Added, #1: 1	حُقُوقِ الْمَارِّ
u'حُقُوقٌ مَالٌ':Added, #2: 2	حُقُوقِ الْمَالِ
u'حُقوقٌ مَبِيعٌ':Added, #2: 2	حُقُوقِ الْمَالِ
u'حُقُوقٌ مَبِيعٌ':Added, #4: 4	حُقُوقِ الْمَبِيعِ
u'حُقوقٌ مُرْتَهِنٌ':Added, #4: 4	حُقُوقِ الْمَبِيعِ
u'حُقُوقٌ مُرْتَهِنٌ':Added, #1: 1	حُقُوقِ الْمُرْتَهِنِ
u'حُقوقٌ مُرُوءةٌ':Added, #1: 1	حُقُوقِ الْمُرْتَهِنِ
u'حُقُوقٌ مُرُوءةٌ':Added, #1: 1	حُقُوقَ الْمُرُوءَةِ
u'حُقوقٌ مُرُوءةٌ':Added, #1: 1	حُقُوقَ الْمُرُوءَةِ
u'حُقُوقٌ مُرُوءةٌ':Added, #3: 3	حُقُوقِ الْمُرُوءَةِ
u'حُقوقٌ مساكين':Added, #3: 3	حُقُوقِ الْمُرُوءَةِ
u'حُقُوقٌ مساكين':Added, #1: 1	حُقُوقِ الْمَسَاكِينِ
u'حُقوقٌ مُسْلِمٌ':Added, #1: 1	حُقُوقِ الْمَسَاكِينِ
u'حُقُوقٌ مُسْلِمٌ':Added, #4: 4	حُقُوقِ الْمُسْلِمِ
u'حُقوقٌ مَشْرُوعٌ':Added, #4: 4	حُقُوقِ الْمُسْلِمِ
u'حُقُوقٌ مَشْرُوعٌ':Added, #1: 1	حُقُوقِ الْمَشْرُوعِ
u'حُقوقٌ مَصْلَحَةٌ':Added, #1: 1	حُقُوقِ الْمَشْرُوعِ
u'حُقُوقٌ مَصْلَحَةٌ':Added, #1: 1	حُقُوقِ الْمَصْلَحَةِ
u'حُقوقٌ مُعَامَلَةٌ':Added, #1: 1	حُقُوقِ الْمَصْلَحَةِ
u'حُقُوقٌ مُعَامَلَةٌ':Added, #1: 1	حُقُوقِ الْمُعَامَلَاتِ
u'حُقوقٌ مَقْذُوفٌ':Added, #1: 1	حُقُوقِ الْمُعَامَلَاتِ
u'حُقُوقٌ مَقْذُوفٌ':Added, #1: 1	حُقُوقِ الْمَقْذُوفِ
u'حُقوقٌ مَقَرٌّ':Added, #1: 1	حُقُوقِ الْمَقْذُوفِ
u'حُقُوقٌ مَقَرٌّ':Added, #1: 1	حُقُوقِ الْمَقَرِّ
u'حُقوقٌ مِلَّةٌ':Added, #1: 1	حُقُوقِ الْمَقَرِّ
u'حُقُوقٌ مِلَّةٌ':Added, #1: 1	حُقُوقِ الْمِلَّةِ
u'حُقوقٌ مِلْكٌ':Added, #1: 1	حُقُوقِ الْمِلَّةِ
u'حُقُوقٌ مِلْكٌ':Added, #10: 10	حُقُوقِ الْمِلْكِ
u'حُقوقٌ مِلْكٌ':Added, #10: 10	حُقُوقِ الْمِلْكِ
u'حُقُوقٌ مِلْكٌ':Added, #1: 1	حُقُوقِ مِلْكِ
u'حُقوقٌ مِلْكٌ':Added, #1: 1	حُقُوقِ مِلْكِ
u'حُقُوقٌ مِلْكٌ':Added, #1: 1	حُقُوقِ مِلْكِهِ
u'حُقوقٌ مَوَدَّةٌ':Added, #1: 1	حُقُوقِ مِلْكِهِ
u'حُقُوقٌ مَوَدَّةٌ':Added, #1: 1	حُقُوقِ الْمَوَدَّةِ
u'حُقوقٌ نَاسٌ':Added, #1: 1	حُقُوقِ الْمَوَدَّةِ
u'حُقُوقٌ نَاسٌ':Added, #17: 17	حُقُوقِ النَّاسِ
u'حُقوقٌ نَاسٌ':Added, #17: 17	حُقُوقِ النَّاسِ
u'حُقُوقٌ نَاسٌ':Added, #3: 3	حُقُوقُ النَّاسِ
u'حُقوقٌ نَاسٌ':Added, #3: 3	حُقُوقُ النَّاسِ
u'حُقُوقٌ نَاسٌ':Added, #7: 7	حُقُوقَ النَّاسِ
u'حُقوقٌ نَظَرٌ':Added, #7: 7	حُقُوقَ النَّاسِ
u'حُقُوقٌ نَظَرٌ':Added, #3: 3	حُقُوقِ النَّظَرِ
u'حُقوقٌ نَفْسٌ':Added, #3: 3	حُقُوقِ النَّظَرِ
u'حُقُوقٌ نَفْسٌ':Added, #1: 1	حُقُوقَ نَفْسِهِ
u'حُقوقٌ نَفْسٌ':Added, #1: 1	حُقُوقَ نَفْسِهِ
u'حُقُوقٌ نَفْسٌ':Added, #2: 2	حُقُوقِ نَفْسِهِ
u'حُقوقٌ نَقْدٌ':Added, #2: 2	حُقُوقِ نَفْسِهِ
u'حُقوقٌ نَقْد':Added, #1: 1	حُقُوقَ النَّقْدِ
u'حُقُوقٌ نَقْدٌ':Added, #1: 1	حُقُوقَ النَّقْدِ
u'حُقُوقٌ نَقْد':Added, #1: 1	حُقُوقَ النَّقْدِ
u'حُقوقٌ نكاح':Added, #1: 1	حُقُوقَ النَّقْدِ
u'حُقُوقٌ نكاح':Added, #37: 37	حُقُوقِ النِّكَاحِ
u'حُقوقٌ نِكَاحٌ':Added, #37: 37	حُقُوقِ النِّكَاحِ
u'حُقُوقٌ نِكَاحٌ':Added, #37: 37	حُقُوقِ النِّكَاحِ
u'حُقوقٌ نكاح':Added, #37: 37	حُقُوقِ النِّكَاحِ
u'حُقُوقٌ نكاح':Added, #7: 7	حُقُوقَ النِّكَاحِ
u'حُقوقٌ نِكَاحٌ':Added, #7: 7	حُقُوقَ النِّكَاحِ
u'حُقُوقٌ نِكَاحٌ':Added, #7: 7	حُقُوقَ النِّكَاحِ
u'حُقوقٌ وَرَثَةٌ':Added, #7: 7	حُقُوقَ النِّكَاحِ
u'حُقُوقٌ وَرَثَةٌ':Added, #1: 1	حُقُوقَ الْوَرَثَةِ
u'حُقوقٌ وِلاَيَةٌ':Added, #1: 1	حُقُوقَ الْوَرَثَةِ
u'حُقُوقٌ وِلاَيَةٌ':Added, #1: 1	حُقُوقِ وِلَايَتِهِ
u'حُقوقٌ يَتِيمٌ':Added, #1: 1	حُقُوقِ وِلَايَتِهِ
u'حُقُوقٌ يَتِيمٌ':Added, #1: 1	حُقُوقِ الْيَتِيمِ
u'حِكَايَةٌ اِبْنٌ':Added, #1: 1	حُقُوقِ الْيَتِيمِ
u'حِكَايَةٌ اِبْنٌ':Added, #4: 4	حِكَايَةَ ابْنِ
u'حِكَايَةٌ اِبْنٌ':Added, #5: 5	حِكَايَةِ ابْنِ
u'حِكَايَةٌ اِتِّفَاقٌ':Added, #6: 6	حِكَايَةُ ابْنِ
u'حِكَايَةٌ إِجْمَاعٌ':Added, #1: 1	حِكَايَةَ اتِّفَاقِ
u'حِكَايَةٌ إِجْمَاعٌ':Added, #1: 1	حِكَايَةَ الْإِجْمَاعَاتِ
u'حِكَايَةٌ إِجْمَاعٌ':Added, #6: 6	حِكَايَةُ الْإِجْمَاعِ
u'حِكَايَةٌ أَحْوالٌ':Added, #6: 6	حِكَايَةِ الْإِجْمَاعِ
u'حِكَايَةٌ أحْوَالٌ':Added, #1: 1	حِكَايَةِ أَحْوَالِ
u'حِكَايَةٌ أَحْوالٌ':Added, #1: 1	حِكَايَةِ أَحْوَالِ
u'حِكَايَةٌ أحْوَالٌ':Added, #1: 1	حِكَايَةِ الْأَحْوَالِ
u'حِكَايَةٌ أَذَانٌ':Added, #1: 1	حِكَايَةِ الْأَحْوَالِ
u'حِكَايَةٌ أُسْتَاذٌ':Added, #1: 1	حِكَايَةِ الأَذَانِ
u'حِكَايَةٌ أُسْتَاذٌ':Added, #1: 1	حِكَايَةُ الْأُسْتَاذِ
u'حِكَايَةٌ اِسْتِنْكافٌ':Added, #1: 1	حِكَايَةِ الْأُسْتَاذِ
u'حِكَايَةٌ إفَادَةٌ':Added, #1: 1	حِكَايَةَ اسْتِنْكَافِ
u'حِكَايَةٌ أَقْوَالٌ':Added, #1: 1	حِكَايَةِ إفَادَتِهِ
u'حِكَايَةٌ أَقْوَالٌ':Added, #1: 1	حِكَايَةُ الْأَقْوَالِ
u'حِكَايَةٌ إمَامٌ':Added, #8: 8	حِكَايَةِ الْأَقْوَالِ
u'حِكَايَةٌ أَمْرٌ':Added, #2: 2	حِكَايَةِ الْإِمَامِ
u'حِكَايَةٌ إِنْفاقٌ':Added, #1: 1	حِكَايَةُ الْأَمْرِ
u'حِكَايَةٌ إِنْكارٌ':Added, #2: 2	حِكَايَةَ الْإِنْفَاقِ
u'حِكَايَةٌ أوْجَهُ':Added, #1: 1	حِكَايَةِ إنْكَارِهِ
u'حِكَايَةٌ أَوْجُهٌ':Added, #1: 1	حِكَايَةِ الْأَوْجَهِ
u'حِكَايَةٌ أَوْجُهٌ':Added, #1: 1	حِكَايَةُ الْأَوْجُهِ
u'حِكَايَةٌ أَوَّلُ':Added, #2: 2	حِكَايَةَ الْأَوْجُهِ
u'حِكَايَةٌ أَوَّلُ':Added, #1: 1	حِكَايَةُ الْأَوَّلِ
u'حِكَايَةٌ أَوَّلُ':Added, #1: 1	حِكَايَةِ الْأَوَّلِ
u'حِكَايَةٌ بَعْضٌ':Added, #1: 1	حِكَايَةُ أَوَّلِ
u'حِكَايَةٌ بَعْضٌ':Added, #1: 1	حِكَايَةِ بَعْضِ
u'حِكَايَةٌ بَيَانٌ':Added, #2: 2	حِكَايَةُ بَعْضِ
u'حِكَايَةٌ تَرْجِيحٌ':Added, #1: 1	حِكَايَةِ الْبَيَانِ
u'حِكَايَةٌ تَشَهُّدٌ':Added, #1: 1	حِكَايَةُ تَرْجِيحِ
u'حِكَايَةٌ جَمَاعَةٌ':Added, #1: 1	حِكَايَةِ تَشَهُّدِ
u'حِكَايَةٌ جمعة':Added, #1: 1	حِكَايَةُ جَمَاعَةٍ
u'حِكَايَةٌ جُمُعَةٌ':Added, #1: 1	حِكَايَةِ الْجُمُعَةِ
u'حِكَايَةٌ حالٌ':Added, #1: 1	حِكَايَةِ الْجُمُعَةِ
u'حِكَايَةٌ حالٌ':Added, #1: 1	حِكَايَةَ الْحَالِ
u'حِكَايَةٌ حالٌ':Added, #1: 1	حِكَايَةِ الْحَالِ
u'حِكَايَةٌ حالٌ':Added, #1: 1	حِكَايَةَ حَالٍ
u'حِكَايَةٌ حالٌ':Added, #1: 1	حِكَايَةُ حَالِ
u'حِكَايَةٌ حالٌ':Added, #3: 3	حِكَايَةِ حَالٍ
u'حِكَايَةٌ حِلٌّ':Added, #6: 6	حِكَايَةُ حَالٍ
u'حِكَايَةٌ خِلاَفٌ':Added, #1: 1	حِكَايَةَ حِلِّ
u'حِكَايَةٌ خِلاَفٌ':Added, #12: 12	حِكَايَةِ خِلَافٍ
u'حِكَايَةٌ خِلاَفٌ':Added, #1: 1	حِكَايَةَ خِلَافٍ
u'حِكَايَةٌ خِلاَفٌ':Added, #26: 26	حِكَايَةِ الْخِلَافِ
u'حِكَايَةٌ خِلاَفٌ':Added, #5: 5	حِكَايَةُ خِلَافٍ
u'حِكَايَةٌ خِلاَفٌ':Added, #6: 6	حِكَايَةُ الْخِلَافِ
u'حِكَايَةٌ رابع':Added, #9: 9	حِكَايَةَ الْخِلَافِ
u'حِكَايَةٌ رَابِعٌ':Added, #1: 1	حِكَايَةِ الرَّابِعِ
u'حِكَايَةٌ رِوايَةٌ':Added, #1: 1	حِكَايَةِ الرَّابِعِ
u'حِكَايَةٌ رِوايَةٌ':Added, #1: 1	حِكَايَةُ الرِّوَايَةِ
u'حِكَايَةٌ سلام':Added, #1: 1	حِكَايَةِ الرِّوَايَةِ
u'حِكَايَةٌ سَلاَمٌ':Added, #1: 1	حِكَايَةُ السَّلَامِ
u'حِكَايَةٌ سلام':Added, #1: 1	حِكَايَةُ السَّلَامِ
u'حِكَايَةٌ سَلاَمٌ':Added, #2: 2	حِكَايَةُ سَلَامِ
u'حِكَايَةٌ شِرَاءٌ':Added, #2: 2	حِكَايَةُ سَلَامِ
u'حِكَايَةٌ شَيْخٌ':Added, #1: 1	حِكَايَةَ الشِّرَاءِ
u'حِكَايَةٌ صُورَةٌ':Added, #4: 4	حِكَايَةِ الشَّيْخِ
u'حِكَايَةٌ ضَعِيفٌ':Added, #1: 1	حِكَايَةَ صُورَةِ
u'حِكَايَةٌ طَرِيقٌ':Added, #1: 1	حِكَايَةَ الضَّعِيفِ
u'حِكَايَةٌ طَرِيقٌ':Added, #1: 1	حِكَايَةِ طَرِيقِهِ
u'حِكَايَةٌ طَلاَقٌ':Added, #1: 1	حِكَايَةُ طَرِيقَيْنِ
u'حِكَايَةٌ عَابِدٌ':Added, #1: 1	حِكَايَةُ طَلَاقِ
u'حِكَايَةٌ عَدْلٌ':Added, #1: 1	حِكَايَةُ عَابِدٍ
u'حِكَايَةٌ عَدَمٌ':Added, #1: 1	حِكَايَةُ الْعَدْلِ
u'حِكَايَةٌ عَدَمٌ':Added, #1: 1	حِكَايَةَ عَدَمِ
u'حِكَايَةٌ عِلَّةٌ':Added, #1: 1	حِكَايَةِ عَدَمِ
u'حِكَايَةٌ فِعْلٌ':Added, #1: 1	حِكَايَةُ عِلَّةِ
u'حِكَايَةٌ فِعْلٌ':Added, #1: 1	حِكَايَةَ فِعْلٍ
u'حِكَايَةٌ فِعْلٌ':Added, #1: 1	حِكَايَةُ فِعْلِ
u'حِكَايَةٌ فِعْلٌ':Added, #1: 1	حِكَايَةِ فِعْلٍ
u'حِكَايَةٌ فِعْلٌ':Added, #1: 1	حِكَايَةُ فِعْلِهِ
u'حِكَايَةٌ قتل':Added, #7: 7	حِكَايَةُ فِعْلٍ
u'حِكَايَةٌ قَتْلٌ':Added, #1: 1	حِكَايَةُ قَتْلِ
u'حِكَايَةٌ قول':Added, #1: 1	حِكَايَةُ قَتْلِ
u'حِكَايَةٌ قَوْلٌ':Added, #1: 1	حِكَايَةَ الْقَوْلِ
u'حِكَايَةٌ قَوْلٌ':Added, #1: 1	حِكَايَةَ الْقَوْلِ
u'حِكَايَةٌ قَوْلٌ':Added, #1: 1	حِكَايَةِ قَوْلٍ
u'حِكَايَةٌ قول':Added, #1: 1	حِكَايَةَ قَوْلَيْنِ
u'حِكَايَةٌ قَوْلٌ':Added, #2: 2	حِكَايَةُ الْقَوْلِ
u'حِكَايَةٌ قَوْلٌ':Added, #2: 2	حِكَايَةُ الْقَوْلِ
u'حِكَايَةٌ قَوْلٌ':Added, #2: 2	حِكَايَةُ الْقَوْلَيْنِ
u'حِكَايَةٌ قَوْلٌ':Added, #2: 2	حِكَايَةِ الْقَوْلَيْنِ
u'حِكَايَةٌ قَوْلٌ':Added, #2: 2	حِكَايَةُ قَوْلٍ
u'حِكَايَةٌ قول':Added, #2: 2	حِكَايَةُ قَوْلَيْنِ
u'حِكَايَةٌ قَوْلٌ':Added, #3: 3	حِكَايَةُ قَوْلِهِ
u'حِكَايَةٌ قول':Added, #3: 3	حِكَايَةُ قَوْلِهِ
u'حِكَايَةٌ قَوْلٌ':Added, #4: 4	حِكَايَةُ قَوْلِ
u'حِكَايَةٌ قول':Added, #4: 4	حِكَايَةُ قَوْلِ
u'حِكَايَةٌ قَوْلٌ':Added, #7: 7	حِكَايَةِ قَوْلِ
u'حِكَايَةٌ كفر':Added, #7: 7	حِكَايَةِ قَوْلِ
u'حِكَايَةٌ كُفْرٌ':Added, #1: 1	حِكَايَةَ الْكُفْرِ
u'حِكَايَةٌ كَلاَمٌ':Added, #1: 1	حِكَايَةَ الْكُفْرِ
u'حِكَايَةٌ كَلاَمٌ':Added, #1: 1	حِكَايَةِ الْكَلَامِ
u'حِكَايَةٌ كَلاَمٌ':Added, #4: 4	حِكَايَةِ كَلَامِهِ
u'حِكَايَةٌ كَمَالٌ':Added, #5: 5	حِكَايَةِ كَلَامِ
u'حِكَايَةٌ لعان':Added, #3: 3	حِكَايَةَ الْكَمَالِ
u'حِكَايَةٌ لَفْظٌ':Added, #1: 1	حِكَايَةِ اللِّعَانِ
u'حِكَايَةٌ لَفْظٌ':Added, #1: 1	حِكَايَةُ اللَّفْظِ
u'حِكَايَةٌ لَفْظٌ':Added, #1: 1	حِكَايَةِ اللَّفْظِ
u'حِكَايَةٌ مَاعِزٌ':Added, #1: 1	حِكَايَةُ لَفْظِهِ
u'حِكَايَةٌ مَذَاهِبُ':Added, #1: 1	حِكَايَةِ مَاعِزٍ
u'حِكَايَةٌ مَذْهَبٌ':Added, #1: 1	حِكَايَةِ الْمَذَاهِبِ
u'حِكَايَةٌ مَذْهَبٌ':Added, #1: 1	حِكَايَةُ مَذْهَبٍ
u'حِكَايَةٌ مَذْهَبٌ':Added, #1: 1	حِكَايَةَ مَذْهَبِهِ
u'حِكَايَةٌ مُصَنِّفٌ':Added, #2: 2	حِكَايَةِ مَذْهَبِ
u'حِكَايَةٌ مَوَاقِعُ':Added, #2: 2	حِكَايَةُ الْمُصَنِّفِ
u'حِكَايَةٌ مُؤَذِّنٌ':Added, #1: 1	حِكَايَةُ الْمَوَاقِعِ
u'حِكَايَةٌ نَظِيرٌ':Added, #1: 1	حِكَايَةُ الْمُؤَذِّنِ
u'حِكَايَةٌ نَقْشٌ':Added, #1: 1	حِكَايَةِ نَظِيرِهِ
u'حِكَايَةٌ نكاح':Added, #1: 1	حِكَايَةُ النَّقْشِ
u'حِكَايَةٌ نِكَاحٌ':Added, #1: 1	حِكَايَةَ النِّكَاحِ
u'حِكَايَةٌ نَوَوِيٌّ':Added, #1: 1	حِكَايَةَ النِّكَاحِ
u'حِكَايَةٌ هَتْكٌ':Added, #1: 1	حِكَايَةُ النَّوَوِيِّ
u'حِكَايَةٌ وَاقِعٌ':Added, #1: 1	حِكَايَةُ الْهَتْكِ
u'حِكَايَةٌ وَاقِعٌ':Added, #1: 1	حِكَايَةِ الْوَاقِعَةِ
u'حِكَايَةٌ وَاقِعَةٌ':Added, #3: 3	حِكَايَةِ الْوَاقِعِ
u'حِكَايَةٌ وَجْهٌ':Added, #1: 1	حِكَايَةِ الْوَاقِعَةِ
u'حِكَايَةٌ وَجْهٌ':Added, #1: 1	حِكَايَةَ الْوَجْهِ
u'حِكَايَةٌ وَجْهٌ':Added, #1: 1	حِكَايَةِ الْوَجْهِ
u'حِكَايَةٌ وَجْهٌ':Added, #1: 1	حِكَايَةَ الْوَجْهَيْنِ
u'حِكَايَةٌ وَجْهٌ':Added, #1: 1	حِكَايَةَ وَجْهٍ
u'حِكَايَةٌ وَجْهٌ':Added, #1: 1	حِكَايَةِ وَجْهِ
u'حِكَايَةٌ وَجْهٌ':Added, #1: 1	حِكَايَةِ وَجْهَيْنِ
u'حِكَايَةٌ وَجْهٌ':Added, #2: 2	حِكَايَةُ الْوَجْهَيْنِ
u'حِكَايَةٌ وَجْهٌ':Added, #2: 2	حِكَايَةُ وَجْهٍ
u'حِكَايَةٌ وَجْهٌ':Added, #5: 5	حِكَايَةَ وَجْهَيْنِ
u'حِكَايَةٌ وَجْهٌ':Added, #6: 6	حِكَايَةِ الْوَجْهَيْنِ
u'حِكَايَةٌ وَضْعٌ':Added, #6: 6	حِكَايَةُ وَجْهَيْنِ
u'حَكَّ حَنْظَلٌ':Predicate, #1: 1	حِكَايَةِ الْوَضْعِ
u'حَكَرَ إمَامٌ':Subject, #1: 1	حَكَّ الْحَنْظَلَ
u'حَكَرَ فُلاَنٌ':Subject, #1: 1	حَكَرَ الْإِمَامُ
u'حُكْمٌ أَبٌ':Added, #1: 1	حَكَرَ فُلَانٌ
u'حُكْمٌ أَبٌ':Added, #1: 1	حُكْمَ الْأَبِ
u'حُكْمٌ إبَاحَةٌ':Added, #3: 3	حُكْمُ الْأَبِ
u'حُكْمٌ إبَاحَةٌ':Added, #1: 1	حُكْمِ إبَاحَةِ
u'حُكْمٌ إبَاحَةٌ':Added, #2: 2	حُكْمَ الْإِبَاحَةِ
u'حُكْمٌ إبَاحَةٌ':Added, #3: 3	حُكْمُ الْإِبَاحَةِ
u'حُكْمٌ آبارٌ':Added, #3: 3	حُكْمِ الْإِبَاحَةِ
u'حُكْمٌ آبارٌ':Added, #1: 1	حُكْمُ آبَارِ
u'حُكْمٌ أَبْكارٌ':Added, #1: 1	حُكْمُ الْآبَارِ
u'حُكْمٌ أَبْكارٌ':Added, #1: 1	حُكْمَ الْأَبْكَارِ
u'حُكْمٌ أَبْكارٌ':Added, #2: 2	حُكْمُ الْأَبْكَارِ
u'حُكْمٌ إِبِلٌ':Added, #4: 4	حُكْمِ الْأَبْكَارِ
u'حَكَمَ اِبْنٌ':Subject, #1: 1	حُكْمُ الْإِبِلِ
u'حُكْمٌ اِبْنٌ':Added, #5: 5	حَكَمَ ابْنُ
u'حُكْمٌ اِبْنٌ':Added, #1: 1	حُكْمِ ابْنِ
u'حُكْمٌ أَبْنَاءٌ':Added, #3: 3	حُكْمُ ابْنِ
u'حُكْمٌ أَبْنَاءٌ':Added, #1: 1	حُكْمُ الْأَبْنَاءِ
u'حُكْمٌ إِتْلاَفٌ':Added, #1: 1	حُكْمِ الْأَبْنَاءِ
u'حُكْمٌ إِتْلاَفٌ':Added, #1: 1	حُكْمُ إتْلَافِ
u'حُكْمٌ إِتْلاَفٌ':Added, #1: 1	حُكْمُ الْإِتْلَافِ
u'حُكْمٌ إتْمَامٌ':Added, #2: 2	حُكْمِ الْإِتْلَافِ
u'حُكْمٌ إِتْيانٌ':Added, #1: 1	حُكْمِ الْإِتْمَامِ
u'حُكْمٌ أثَاثٌ':Added, #1: 1	حُكْمُ الْإِتْيَانِ
u'حُكْمٌ إِثْبَاتٌ':Added, #1: 1	حُكْمُ أَثَاثِ
u'حُكْمٌ إِثْبَاتٌ':Added, #1: 1	حُكْمَ إثْبَاتِ
u'حُكْمٌ أثَرٌ':Added, #1: 1	حُكْمُ الْإِثْبَاتِ
u'حُكْمٌ أَثْمانٌ':Added, #1: 1	حُكْمُ أَثَرِ
u'حُكْمٌ إِجَابَةٌ':Added, #3: 3	حُكْمُ الْأَثْمَانِ
u'حُكْمٌ إِجَابَةٌ':Added, #1: 1	حُكْمُ إجَابَةِ
u'حُكْمٌ إجَارَةٌ':Added, #2: 2	حُكْمُ الْإِجَابَةِ
u'حُكْمٌ إجَارَةٌ':Added, #10: 10	حُكْمُ الْإِجَارَةِ
u'حُكْمٌ إجَارَةٌ':Added, #1: 1	حُكْمُ إجَارَةِ
u'حُكْمٌ إجَارَةٌ':Added, #1: 1	حُكْمِ إجَارَةِ
u'حُكْمٌ إجَارَةٌ':Added, #2: 2	حُكْمَ إجَارَةِ
u'حُكْمٌ إجَارَةٌ':Added, #4: 4	حُكْمُ إجَارَتِهِ
u'حُكْمٌ إجَازَةٌ':Added, #5: 5	حُكْمِ الْإِجَارَةِ
u'حُكْمٌ إِجْبَارٌ':Added, #2: 2	حُكْمِ الْإِجَازَةِ
u'حُكْمٌ اِجْتِمَاعٌ':Added, #1: 1	حُكْمِ الْإِجْبَارِ
u'حُكْمٌ اِجْتِمَاعٌ':Added, #1: 1	حُكْمَ اجْتِمَاعِ
u'حُكْمٌ أُجْرَةٌ':Added, #3: 3	حُكْمِ اجْتِمَاعِ
u'حُكْمٌ أُجْرَةٌ':Added, #1: 1	حُكْمِ الْأُجْرَةِ
u'حُكْمٌ أُجْرَةٌ':Added, #2: 2	حُكْمُ أُجْرَةِ
u'حُكْمٌ إِجْزَاءٌ':Added, #4: 4	حُكْمُ الْأُجْرَةِ
u'حُكْمٌ إِجْزَاءٌ':Added, #1: 1	حُكْمِ الْإِجْزَاءِ
u'حُكْمٌ أَجْزَاءٌ':Added, #2: 2	حُكْمُ الْإِجْزَاءِ
u'حُكْمٌ آجِلٌ':Added, #3: 3	حُكْمُ الْأَجْزَاءِ
u'حُكْمٌ أَجَلٌ':Added, #1: 1	حُكْمِ الْآجِلِ
u'حُكْمٌ أَجَلٌ':Added, #1: 1	حُكْمُ الْأَجَلِ
u'حُكْمٌ إِجْمَاعٌ':Added, #1: 1	حُكْمِ الْأَجَلِ
u'حُكْمٌ إِجْمَاعٌ':Added, #15: 15	حُكْمِ الْإِجْمَاعِ
u'حُكْمٌ إِجْمَاعٌ':Added, #1: 1	حُكْمَ الْإِجْمَاعِ
u'حُكْمٌ أَجْنَبِيٌّ':Added, #9: 9	حُكْمُ الْإِجْمَاعِ
u'حُكْمٌ أَجْنَبِيٌّ':Added, #1: 1	حُكْمِ الْأَجْنَبِيَّةِ
u'حُكْمٌ أَجْنَبِيٌّ':Added, #1: 1	حُكْمَ الْأَجْنَبِيَّيْنِ
u'حُكْمٌ أَجْنَبِيٌّ':Added, #2: 2	حُكْمِ أَجْنَبِيٍّ
u'حُكْمٌ أَجِيرٌ':Added, #2: 2	حُكْمِ الْأَجْنَبِيِّ
u'حُكْمٌ أَجِيرٌ':Added, #1: 1	حُكْمُ أَجِيرِ
u'حُكْمٌ أَجِيرٌ':Added, #3: 3	حُكْمُ الْأَجِيرِ
u'حُكْمٌ إحَاطَةٌ':Added, #3: 3	حُكْمِ الْأَجِيرِ
u'حُكْمٌ إِحالَةٌ':Added, #1: 1	حُكْمُ الْإِحَاطَةِ
u'حَكَمَ أحَدٌ':Subject, #1: 1	حُكْمَ إحَالَةِ
u'حَكَّمَ أحَدٌ':Subject, #2: 2	حَكَمَ أَحَدُ
u'حُكْمٌ أحَدٌ':Added, #3: 3	حَكَّمَ أَحَدُ
u'حُكْمٌ أحَدٌ':Added, #1: 1	حُكْمَ أَحَدٍ
u'حُكْمٌ أحَدٌ':Added, #1: 1	حُكْمِ أَحَدٍ
u'حُكْمٌ أحَدٌ':Added, #2: 2	حُكْمُ أَحَدِ
u'حُكْمٌ أَحْداثٌ':Added, #3: 3	حُكْمِ أَحَدِ
u'حُكْمٌ أَحْدَاثٌ':Added, #1: 1	حُكْمَ الْأَحْدَاثِ
u'حُكْمٌ أَحْرارٌ':Added, #1: 1	حُكْمَ الْأَحْدَاثِ
u'حُكْمٌ أَحْرارٌ':Added, #1: 1	حُكْمِ الْأَحْرَارِ
u'حُكْمٌ أَحْرارٌ':Added, #2: 2	حُكْمَ الْأَحْرَارِ
u'حُكْمٌ إِحْرَامٌ':Added, #5: 5	حُكْمُ الْأَحْرَارِ
u'حُكْمٌ إِحْرَامٌ':Added, #1: 1	حُكْمِ إحْرَامِهِ
u'حُكْمٌ إِحْرَامٌ':Added, #3: 3	حُكْمُ الْإِحْرَامِ
u'حُكْمٌ إِحْرَامٌ':Added, #3: 3	حُكْمِ الْإِحْرَامِ
u'حُكْمٌ أحْمَر':Added, #4: 4	حُكْمَ الْإِحْرَامِ
u'حُكْمٌ إِحْيَاءٌ':Added, #2: 2	حُكْمَ الْأَحْمَرِ
u'حُكْمٌ أَحْيَاءٌ':Added, #1: 1	حُكْمُ إحْيَاءِ
u'حُكْمٌ أَحْيَاءٌ':Added, #2: 2	حُكْمَ الْأَحْيَاءِ
u'حُكْمٌ إِحْيَاءٌ':Added, #2: 2	حُكْمُ الْأَحْيَاءِ
u'حُكْمٌ أَخٌ':Added, #2: 2	حُكْمُ الْإِحْيَاءِ
u'حُكْمٌ أَخٌ':Added, #1: 1	حُكْمَ الْأَخِ
u'حُكْمٌ إِخْبَارٌ':Added, #1: 1	حُكْمُ الْأَخِ
u'حُكْمٌ إِخْبَارٌ':Added, #1: 1	حُكْمُ إخْبَارِ
u'حُكْمٌ إِخْبَارٌ':Added, #1: 1	حُكْمَ الْإِخْبَارِ
u'حُكْمٌ إِخْبَارٌ':Added, #1: 1	حُكْمُ الْإِخْبَارِ
u'حُكْمٌ اِخْتِلاَفٌ':Added, #5: 5	حُكْمِ الْإِخْبَارِ
u'حُكْمٌ أخْذٌ':Added, #2: 2	حُكْمُ اخْتِلَافِ
u'حُكْمٌ أخْذٌ':Added, #1: 1	حُكْمُ الْأَخْذِ
u'حُكْمٌ أخْذٌ':Added, #2: 2	حُكْمِ أَخْذِ
u'حُكْمٌ أخْذٌ':Added, #2: 2	حُكْمَ أَخْذِهِ
u'حُكْمٌ أخْذٌ':Added, #2: 2	حُكْمِ الْأَخْذِ
u'حُكْمٌ آخِرُ':Added, #5: 5	حُكْمُ أَخْذِ
u'حُكْمٌ إِخْرَاجٌ':Added, #1: 1	حُكْمُ آخِرِ
u'حُكْمٌ آخِرَةٌ':Added, #1: 1	حُكْمِ الْإِخْرَاجِ
u'حُكْمٌ آخِرَةٌ':Added, #2: 2	حُكْمَ الْآخِرَةِ
u'حُكْمٌ آخِرَةٌ':Added, #4: 4	حُكْمُ الْآخِرَةِ
u'حُكْمٌ أخرَس':Added, #5: 5	حُكْمِ الْآخِرَةِ
u'حُكْمٌ أخرَس':Added, #1: 1	حُكْمَ الْأَخْرَسِ
u'حُكْمٌ أخفُّ':Added, #1: 1	حُكْمُ الْأَخْرَسِ
u'حُكْمٌ أَدَاءٌ':Added, #1: 1	حُكْمَ الْأَخَفِّ
u'حُكْمٌ أَدَاءٌ':Added, #10: 10	حُكْمُ الْأَدَاءِ
u'حُكْمٌ أَدَاءٌ':Added, #1: 1	حُكْمَ أَدَاءِ
u'حُكْمٌ أَدَاءٌ':Added, #1: 1	حُكْمِ أَدَاءِ
u'حُكْمٌ آدَمِيٌّ':Added, #3: 3	حُكْمِ الْأَدَاءِ
u'حُكْمٌ أَدْهانٌ':Added, #2: 2	حُكْمُ الْآدَمِيِّ
u'حُكْمٌ أَدْوِيَةٌ':Added, #1: 1	حُكْمُ الْأَدْهَانِ
u'حُكْمٌ أَذَانٌ':Added, #1: 1	حُكْمُ الْأَدْوِيَةِ
u'حُكْمٌ أَذَانٌ':Added, #2: 2	حُكْمَ الْأَذَانِ
u'حُكْمٌ أَذَانٌ':Added, #2: 2	حُكْمِ الْأَذَانِ
u'حُكْمٌ إِذْنٌ':Added, #3: 3	حُكْمُ الْأَذَانِ
u'حُكْمٌ إِذْنٌ':Added, #1: 1	حُكْمَ الْإِذْنِ
u'حُكْمٌ إِذْنٌ':Added, #2: 2	حُكْمُ الْإِذْنِ
u'حُكْمٌ إِذْنٌ':Added, #2: 2	حُكْمِ الْإِذْنِ
u'حُكْمٌ إِرَاقَةٌ':Added, #4: 4	حُكْمَ إذْنِ
u'حُكْمٌ أرْبَابٌ':Added, #2: 2	حُكْمُ الْإِرَاقَةِ
u'حُكْمٌ أَرْبَعُ':Added, #1: 1	حُكْمُ أَرْبَابِ
u'حُكْمٌ أَرْبَعَةٌ':Added, #1: 1	حُكْمَ الْأَرْبَعِ
u'حُكْمٌ اِرْتِدَادٌ':Added, #1: 1	حُكْمِ أَرْبَعَةِ
u'حُكْمٌ إِرْثٌ':Added, #1: 1	حُكْمِ ارْتِدَادِ
u'حُكْمٌ إِرْثٌ':Added, #1: 1	حُكْمَ الْإِرْثِ
u'حُكْمٌ إِرْثٌ':Added, #1: 1	حُكْمُ الْإِرْثِ
u'حُكْمٌ إِرْسَالٌ':Added, #4: 4	حُكْمِ الْإِرْثِ
u'حُكْمٌ إِرْسَالٌ':Added, #11: 11	حُكْمُ الْإِرْسَالِ
u'حُكْمٌ إِرْسَالٌ':Added, #1: 1	حُكْمِ الْإِرْسَالِ
u'حُكْمٌ إِرْسَالٌ':Added, #2: 2	حُكْمِ إرْسَالِ
u'حُكْمٌ أرْضٌ':Added, #2: 2	حُكْمَ الْإِرْسَالِ
u'حُكْمٌ أرْضٌ':Added, #13: 13	حُكْمُ الْأَرْضِ
u'حُكْمٌ أرْضٌ':Added, #1: 1	حُكْمَ أَرْضِ
u'حُكْمٌ أرْضٌ':Added, #1: 1	حُكْمِ أَرْضِ
u'حُكْمٌ أرْضٌ':Added, #1: 1	حُكْمُ أَرْضِهِ
u'حُكْمٌ أرْضٌ':Added, #1: 1	حُكْمِ الْأَرْضِ
u'حُكْمٌ إِرْضاعٌ':Added, #2: 2	حُكْمَ الْأَرْضِ
u'حُكْمٌ أَرِقَّاءُ':Added, #2: 2	حُكْمِ إرْضَاعِ
u'حُكْمٌ إِرْكَابٌ':Added, #2: 2	حُكْمُ الْأَرِقَّاءِ
u'حُكْمٌ أَرْكانٌ':Added, #1: 1	حُكْمِ إرْكَابِ
u'حُكْمٌ أَرْكَانٌ':Added, #1: 1	حُكْمُ الْأَرْكَانِ
u'حُكْمٌ أَرْواثٌ':Added, #1: 1	حُكْمُ الْأَرْكَانِ
u'حُكْمٌ إِزَالَةٌ':Added, #1: 1	حُكْمَ الْأَرْوَاثِ
u'حُكْمٌ إِزَالَةٌ':Added, #1: 1	حُكْمَ إزَالَةِ
u'حُكْمٌ أَزْواجٌ':Added, #1: 1	حُكْمِ إزَالَةِ
u'حُكْمٌ أَزْواجٌ':Added, #1: 1	حُكْمَ الْأَزْوَاجِ
u'حُكْمٌ أَزْواجٌ':Added, #1: 1	حُكْمُ الْأَزْوَاجِ
u'حُكْمٌ إِسَاءةٌ':Added, #2: 2	حُكْمِ الْأَزْوَاجِ
u'حُكْمٌ اِسْتِثْنَاءٌ':Added, #1: 1	حُكْمَ الْإِسَاءَةِ
u'حُكْمٌ اِسْتِحْقَاقٌ':Added, #1: 1	حُكْمَ اسْتِثْنَاءِ
u'حُكْمٌ اِسْتِحْقَاقٌ':Added, #1: 1	حُكْمُ اسْتِحْقَاقِ
u'حُكْمٌ اِسْتِدَامَةٌ':Added, #1: 1	حُكْمُ اسْتِحْقَاقِهِ
u'حُكْمٌ اِسْتِصْحابٌ':Added, #2: 2	حُكْمِ اسْتِدَامَةِ
u'حُكْمٌ اِسْتِعْمالٌ':Added, #1: 1	حُكْمِ اسْتِصْحَابِ
u'حُكْمٌ اِسْتِعْمالٌ':Added, #1: 1	حُكْمُ اسْتِعْمَالِ
u'حُكْمٌ اِسْتِقْبالٌ':Added, #2: 2	حُكْمِ اسْتِعْمَالِ
u'حُكْمٌ اِسْتِمْرارٌ':Added, #2: 2	حُكْمُ اسْتِقْبَالِ
u'حُكْمٌ اِسْتيفاءٌ':Added, #1: 1	حُكْمِ اسْتِمْرَارِهِ
u'حُكْمٌ إِسْلامٌ':Added, #1: 1	حُكْمَ اسْتِيفَاءِ
u'حُكْمٌ إِسْلامٌ':Added, #12: 12	حُكْمَ الْإِسْلَامِ
u'حُكْمٌ إِسْلامٌ':Added, #18: 18	حُكْمُ الْإِسْلَامِ
u'حُكْمٌ إِسْلامٌ':Added, #18: 18	حُكْمِ الْإِسْلَامِ
u'حُكْمٌ إِسْلامٌ':Added, #1: 1	حُكْمِ إسْلَامِ
u'حُكْمٌ إِسْلامٌ':Added, #1: 1	حُكْمُ إسْلَامِهِ
u'حُكْمٌ إِسْلامٌ':Added, #1: 1	حُكْمُ الإِسْلاَمِ
u'حُكْمٌ اِسْمٌ':Added, #2: 2	حُكْمَ الإِسْلاَمِ
u'حُكْمٌ اِسْمٌ':Added, #1: 1	حُكْمِ اسْمٍ
u'حُكْمٌ إِسْنادٌ':Added, #2: 2	حُكْمِ اسْمِ
u'حُكْمٌ أَسيرٌ':Added, #1: 1	حُكْمِ الْإِسْنَادِ
u'حُكْمٌ إشارَة':Added, #3: 3	حُكْمُ الْأَسِيرِ
u'حُكْمٌ اِشْتِراطٌ':Added, #1: 1	حُكْمُ إشَارَةِ
u'حُكْمٌ أَشْرِبَةٌ':Added, #1: 1	حُكْمَ اشْتِرَاطِ
u'حُكْمٌ إِشْكالٌ':Added, #1: 1	حُكْمِ الْأَشْرِبَةِ
u'حُكْمٌ أَشْيَاءٌ':Added, #1: 1	حُكْمِ الْإِشْكَالِ
u'حُكْمٌ أَشْيَاءٌ':Added, #1: 1	حُكْمُ الْأَشْيَاءِ
u'حُكْمٌ أَشْيَاءٌ':Added, #2: 2	حُكْمِ الْأَشْيَاءِ
u'حُكْمٌ إصابَةٌ':Added, #3: 3	حُكْمَ الْأَشْيَاءِ
u'حُكْمٌ إصابَةٌ':Added, #1: 1	حُكْمَ الْإِصَابَةِ
u'حُكْمٌ أَصالَةٌ':Added, #1: 1	حُكْمِ الْإِصَابَةِ
u'حُكْمٌ إِصْبَعٌ':Added, #1: 1	حُكْمِ الْأَصَالَةِ
u'حُكْمٌ أَصْحَابٌ':Added, #1: 1	حُكْمِ إصْبَعِهِ
u'حُكْمٌ إِصْرارٌ':Added, #1: 1	حُكْمُ الْأَصْحَابِ
u'حُكْمٌ إِصْغاءٌ':Added, #1: 1	حُكْمَ الْإِصْرَارِ
u'حُكْمٌ أصْغَرٌ':Added, #1: 1	حُكْمُ الْإِصْغَاءِ
u'حُكْمٌ أَصْغَرُ':Added, #1: 1	حُكْمُ الْأَصْغَرِ
u'حُكْمٌ أصْغَرٌ':Added, #1: 1	حُكْمُ الْأَصْغَرِ
u'حُكْمٌ أَصْغَرُ':Added, #2: 2	حُكْمَ الْأَصْغَرِ
u'حُكْمٌ أصل':Added, #2: 2	حُكْمَ الْأَصْغَرِ
u'حُكْمٌ أًصْلٌ':Added, #175: 175	حُكْمِ الْأَصْلِ
u'حُكْمٌ أصل':Added, #175: 175	حُكْمِ الْأَصْلِ
u'حُكْمٌ أصل':Added, #1: 1	حُكْمَ أَصْلِ
u'حُكْمٌ أًصْلٌ':Added, #1: 1	حُكْمُ أَصْلِ
u'حُكْمٌ أًصْلٌ':Added, #1: 1	حُكْمَ أَصْلٍ
u'حُكْمٌ أًصْلٌ':Added, #1: 1	حُكْمَ أَصْلِ
u'حُكْمٌ أصل':Added, #1: 1	حُكْمُ أَصْلِ
u'حُكْمٌ أًصْلٌ':Added, #1: 1	حُكْمَ أَصْلِهِ
u'حُكْمٌ أصل':Added, #1: 1	حُكْمَ أَصْلِهِ
u'حُكْمٌ أًصْلٌ':Added, #2: 2	حُكْمِ أَصْلِ
u'حُكْمٌ أصل':Added, #2: 2	حُكْمِ أَصْلِ
u'حُكْمٌ أًصْلٌ':Added, #43: 43	حُكْمَ الْأَصْلِ
u'حُكْمٌ أصل':Added, #43: 43	حُكْمَ الْأَصْلِ
u'حُكْمٌ أًصْلٌ':Added, #70: 70	حُكْمُ الْأَصْلِ
u'حُكْمٌ أصل':Added, #70: 70	حُكْمُ الْأَصْلِ
u'حُكْمٌ أًصْلٌ':Added, #7: 7	حُكْمِ أَصْلِهِ
u'حُكْمٌ أصل':Added, #7: 7	حُكْمِ أَصْلِهِ
u'حُكْمٌ أًصْلٌ':Added, #9: 9	حُكْمُ أَصْلِهِ
u'حُكْمٌ أَصْلِيٌّ':Added, #9: 9	حُكْمُ أَصْلِهِ
u'حُكْمٌ أُصولٌ':Added, #1: 1	حُكْمِ الْأَصْلِيِّ
u'حُكْمٌ أَصيلٌ':Added, #1: 1	حُكْمَ الْأُصُولِ
u'حُكْمٌ أَصيلٌ':Added, #1: 1	حُكْمَ الْأَصِيلِ
u'حُكْمٌ إضافَةٌ':Added, #1: 1	حُكْمُ الْأَصِيلِ
u'حُكْمٌ أَطْرافٌ':Added, #1: 1	حُكْمِ الْإِضَافَةِ
u'حُكْمٌ أَطْرَافٌ':Added, #1: 1	حُكْمُ الْأَطْرَافِ
u'حُكْمٌ إِطْعامٌ':Added, #1: 1	حُكْمُ الْأَطْرَافِ
u'حُكْمٌ أَطْعِمَةٌ':Added, #1: 1	حُكْمُ الْإِطْعَامِ
u'حُكْمٌ أَطْفَالٌ':Added, #1: 1	حُكْمُ الْأَطْعِمَةِ
u'حُكْمٌ إِطْلاقٌ':Added, #1: 1	حُكْمِ أَطْفَالِ
u'حُكْمٌ إِطْلاقٌ':Added, #1: 1	حُكْمُ الْإِطْلَاقِ
u'حُكْمٌ أَظْفارٌ':Added, #1: 1	حُكْمِ الْإِطْلَاقِ
u'حُكْمٌ إِظْهارٌ':Added, #1: 1	حُكْمِ الْأَظْفَارِ
u'حُكْمٌ إِظْهارٌ':Added, #1: 1	حُكْمِ إظْهَارِ
u'حُكْمٌ إِعارَةٌ':Added, #3: 3	حُكْمُ الْإِظْهَارِ
u'حُكْمٌ إِعْتاقٌ':Added, #2: 2	حُكْمُ إعَارَتِهِ
u'حُكْمٌ إِعْتاقٌ':Added, #1: 1	حُكْمُ إعْتَاقِهِ
u'حُكْمٌ إِعْتاقٌ':Added, #2: 2	حُكْمَ الْإِعْتَاقِ
u'حُكْمٌ اِعْتِبارٌ':Added, #2: 2	حُكْمِ الْإِعْتَاقِ
u'حُكْمٌ اِعْتِدادٌ':Added, #1: 1	حُكْمِ اعْتِبَارِ
u'حُكْمٌ إِعْرابٌ':Added, #1: 1	حُكْمُ اعْتِدَادِ
u'حُكْمٌ إِعْرابٌ':Added, #1: 1	حُكْمُ إعْرَابِ
u'حُكْمٌ إِعْرابٌ':Added, #1: 1	حُكْمَ إعْرَابِهِ
u'حُكْمٌ إِعْرابٌ':Added, #1: 1	حُكْمُ إعْرَابِهِ
u'حُكْمٌ أَعْضَاءٌ':Added, #1: 1	حُكْمِ إعْرَابِهِ
u'حُكْمٌ أَعْمَالٌ':Added, #1: 1	حُكْمِ أَعْضَاءٍ
u'حُكْمٌ أعْوَر':Added, #3: 3	حُكْمُ الْأَعْمَالِ
u'حُكْمٌ أعْيانٌ':Added, #1: 1	حُكْمُ الْأَعْوَرِ
u'حُكْمٌ أَعْيَانٌ':Added, #1: 1	حُكْمُ الْأَعْيَانِ
u'حُكْمٌ أعْيانٌ':Added, #1: 1	حُكْمُ الْأَعْيَانِ
u'حُكْمٌ أَعْيَانٌ':Added, #2: 2	حُكْمِ الْأَعْيَانِ
u'حُكْمٌ أَغْصَانٌ':Added, #2: 2	حُكْمِ الْأَعْيَانِ
u'حُكْمٌ أغْلَبُ':Added, #3: 3	حُكْمُ الْأَغْصَانِ
u'حُكْمٌ إِفْرَادٌ':Added, #1: 1	حُكْمِ الْأَغْلَبِ
u'حُكْمٌ أَفْعَالٌ':Added, #1: 1	حُكْمَ الْإِفْرَادِ
u'حُكْمٌ أقارب':Added, #1: 1	حُكْمُ أَفْعَالِ
u'حُكْمٌ إقالَةٌ':Added, #1: 1	حُكْمَ الْأَقَارِبِ
u'حُكْمٌ إقامَةٌ':Added, #2: 2	حُكْمُ الْإِقَالَةِ
u'حُكْمٌ إقامَةٌ':Added, #1: 1	حُكْمَ إقَامَتِهِ
u'حُكْمٌ إقامَةٌ':Added, #2: 2	حُكْمِ إقَامَةِ
u'حُكْمٌ إقامَةٌ':Added, #5: 5	حُكْمُ الْإِقَامَةِ
u'حُكْمٌ اِقْتِداءٌ':Added, #5: 5	حُكْمِ الْإِقَامَةِ
u'حُكْمٌ إقْدَامٌ':Added, #1: 1	حُكْمَ اقْتِدَاءِ
u'حُكْمٌ إقْدَامٌ':Added, #1: 1	حُكْمَ الْإِقْدَامِ
u'حُكْمٌ إقْرَارٌ':Added, #1: 1	حُكْمُ الْإِقْدَامِ
u'حُكْمٌ إقْرَارٌ':Added, #1: 1	حُكْمِ إقْرَارِ
u'حُكْمٌ إقْرَارٌ':Added, #2: 2	حُكْمَ إقْرَارِ
u'حُكْمٌ إقْرَارٌ':Added, #2: 2	حُكْمَ الْإِقْرَارِ
u'حُكْمٌ إقْرَارٌ':Added, #4: 4	حُكْمَ إقْرَارِهِ
u'حُكْمٌ إقْرَارٌ':Added, #5: 5	حُكْمُ إقْرَارِهِ
u'حُكْمٌ إقْرَارٌ':Added, #6: 6	حُكْمُ الْإِقْرَارِ
u'حُكْمٌ إقْطَاعٌ':Added, #6: 6	حُكْمِ الْإِقْرَارِ
u'حُكْمٌ إقْطَاعٌ':Added, #1: 1	حُكْمُ إقْطَاعِ
u'حُكْمٌ إقْطَاعٌ':Added, #1: 1	حُكْمَ إقْطَاعِهِ
u'حُكْمٌ إقْطَاعٌ':Added, #1: 1	حُكْمِ الْإِقْطَاعِ
u'حُكْمٌ إقْطَاعٌ':Added, #1: 1	حُكْمُ الْإِقْطَاعَاتِ
u'حُكْمٌ إقْطَاعٌ':Added, #2: 2	حُكْمُ الْإِقْطَاعِ
u'حُكْمٌ إقْطَاعَةٌ':Added, #3: 3	حُكْمُ إقْطَاعِهِ
u'حُكْمٌ أقَلُّ':Added, #1: 1	حُكْمُ الْإِقْطَاعَاتِ
u'حُكْمٌ أقَلُّ':Added, #1: 1	حُكْمُ الْأَقَلِّ
u'حُكْمٌ أَقْوَالٌ':Added, #1: 1	حُكْمِ الْأَقَلِّ
u'حُكْمٌ أَقْوَالٌ':Added, #1: 1	حُكْمِ أَقْوَالِ
u'حَكَمَ أَكْثَرُ':Subject, #2: 2	حُكْمَ أَقْوَالِهِ
u'حُكْمٌ أَكْثَرُ':Added, #1: 1	حَكَمَ أَكْثَرُ
u'حُكْمٌ إكْرَاهٌ':Added, #4: 4	حُكْمُ الْأَكْثَرِ
u'حُكْمٌ إكْرَاهٌ':Added, #1: 1	حُكْمِ الْإِكْرَاهِ
u'حُكْمٌ أكل':Added, #2: 2	حُكْمُ الْإِكْرَاهِ
u'حُكْمٌ أكل':Added, #1: 1	حُكْمُ أَكْلِ
u'حُكْمٌ أَكْلٌ':Added, #1: 1	حُكْمِ أَكْلِ
u'حُكْمٌ أَكْلٌ':Added, #1: 1	حُكْمُ أَكْلِ
u'حُكْمٌ أكل':Added, #1: 1	حُكْمِ أَكْلِ
u'حُكْمٌ أَكْلٌ':Added, #1: 1	حُكْمُ الْأَكْلِ
u'حُكْمٌ أكل':Added, #1: 1	حُكْمُ الْأَكْلِ
u'حُكْمٌ أَكْلٌ':Added, #2: 2	حُكْمُ أَكْلِهِ
u'حُكْمٌ إلْبَاسٌ':Added, #2: 2	حُكْمُ أَكْلِهِ
u'حُكْمٌ آلةٌ':Added, #2: 2	حُكْمُ إلْبَاسِهِ
u'حُكْمٌ اِلْتِزَامٌ':Added, #4: 4	حُكْمِ الْآلَةِ
u'حُكْمٌ اِلْتِقَاطٌ':Added, #1: 1	حُكْمِ الْتِزَامِ
u'حُكْمٌ اِلْتِقَاطٌ':Added, #1: 1	حُكْمَ الْتِقَاطِ
u'حُكْمٌ ألف':Added, #2: 2	حُكْمَ الْتِقَاطِهِ
u'حُكْمٌ ألْفٌ':Added, #1: 1	حُكْمَ الْأَلِفِ
u'حُكْمٌ ألْفٌ':Added, #1: 1	حُكْمَ أَلْفٍ
u'حُكْمٌ أَلْفٌ':Added, #1: 1	حُكْمِ أَلْفٍ
u'حُكْمٌ أَلْفٌ':Added, #1: 1	حُكْمَ أَلْفٍ
u'حُكْمٌ ألف':Added, #1: 1	حُكْمِ أَلْفٍ
u'حُكْمٌ ألْفٌ':Added, #2: 2	حُكْمُ الْأَلْفِ
u'حُكْمٌ أَلْفٌ':Added, #2: 2	حُكْمُ الْأَلْفِ
u'حُكْمٌ أَلْفَاظٌ':Added, #2: 2	حُكْمُ الْأَلْفِ
u'حُكْمٌ إِلْمَامٌ':Added, #1: 1	حُكْمُ الْأَلْفَاظِ
u'حُكْمٌ الْمَرْءُ':Added, #1: 1	حُكْمِ الْإِلْمَامِ
u'حُكْمٌ الْمَرْأَةُ':Added, #1: 1	حُكْمَ الْمَرْءِ
u'حُكْمٌ الْمَرْأَةُ':Added, #12: 12	حُكْمُ الْمَرْأَةِ
u'حُكْمٌ الْمَرْأَةُ':Added, #1: 1	حُكْمِ الْمَرْأَةِ
u'حُكْمٌ ألْيَةٌ':Added, #2: 2	حُكْمَ الْمَرْأَةِ
u'حُكْمٌ أُمٌّ':Added, #1: 1	حُكْمُ الْأَلْيَةِ
u'حُكْمٌ أُمٌّ':Added, #1: 1	حُكْمِ أُمِّ
u'حُكْمٌ أُمٌّ':Added, #3: 3	حُكْمَ الْأُمِّ
u'حُكْمٌ أُمٌّ':Added, #3: 3	حُكْمُ أُمِّ
u'حُكْمٌ أُمٌّ':Added, #3: 3	حُكْمَ أُمِّهِ
u'حُكْمٌ أُمٌّ':Added, #5: 5	حُكْمِ أُمِّهِ
u'حُكْمٌ أُمٌّ':Added, #6: 6	حُكْمُ الْأُمِّ
u'حُكْمٌ إمَاءٌ':Added, #7: 7	حُكْمُ أُمِّهِ
u'حُكْمٌ إمَارَةٌ':Added, #2: 2	حُكْمَ الْإِمَاءِ
u'حَكَّمَ إمَامٌ':Subject, #1: 1	حُكْمَ الْإِمَارَةِ
u'حَكَمَ إمَامٌ':Subject, #1: 1	حَكَّمَ الْإِمَامُ
u'حَكَمَ إمَامٌ':Subject, #1: 1	حَكَمَ إمَامُ
u'حُكْمٌ إمَامٌ':Added, #4: 4	حَكَمَ الْإِمَامُ
u'حُكْمٌ إمَامٌ':Added, #1: 1	حُكْمَ إمَامِهِ
u'حُكْمٌ إمَامٌ':Added, #1: 1	حُكْمُ إمَامِهِ
u'حُكْمٌ إمَامٌ':Added, #2: 2	حُكْمِ الإِمَامِ
u'حُكْمٌ إمَامٌ':Added, #3: 3	حُكْمَ الْإِمَامِ
u'حُكْمٌ إمَامٌ':Added, #5: 5	حُكْمِ الْإِمَامِ
u'حُكْمٌ إمَامَةٌ':Added, #9: 9	حُكْمُ الْإِمَامِ
u'حُكْمٌ إمَامَةٌ':Added, #1: 1	حُكْمُ إمَامَةِ
u'حُكْمٌ إمَامَةٌ':Added, #1: 1	حُكْمِ إمَامَتِهِ
u'حُكْمٌ إمَامَةٌ':Added, #2: 2	حُكْمِ الْإِمَامَةِ
u'حُكْمٌ أمَانٌ':Added, #3: 3	حُكْمُ إمَامَتِهِ
u'حُكْمٌ أمَانٌ':Added, #2: 2	حُكْمِ الْأَمَانِ
u'حُكْمٌ أمَانٌ':Added, #3: 3	حُكْمُ الْأَمَانَاتِ
u'حُكْمٌ أمَانَةٌ':Added, #4: 4	حُكْمَ الْأَمَانِ
u'حُكْمٌ أمَانَةٌ':Added, #3: 3	حُكْمُ الْأَمَانَاتِ
u'حُكْمٌ أُمَّةٌ':Added, #6: 6	حُكْمِ الْأَمَانَةِ
u'حُكْمٌ أُمَّةٌ':Added, #1: 1	حُكْمُ الْأُمَّةِ
u'حُكْمٌ أمَةٌ':Added, #1: 1	حُكْمِ الْأُمَّةِ
u'حُكْمٌ أمَةٌ':Added, #1: 1	حُكْمُ أَمَةِ
u'حُكْمٌ أمَةٌ':Added, #1: 1	حُكْمَ أَمَتِهِ
u'حُكْمٌ أمَةٌ':Added, #4: 4	حُكْمَ الْأَمَةِ
u'حُكْمٌ أَمْرٌ':Added, #8: 8	حُكْمُ الْأَمَةِ
u'حُكْمٌ أَمْرٌ':Added, #1: 1	حُكْمُ أَمْرِ
u'حُكْمٌ أَمْرٌ':Added, #4: 4	حُكْمُ الْأَمْرِ
u'حُكْمٌ اِمْرَأَةٌ':Added, #4: 4	حُكْمِ الْأَمْرِ
u'حُكْمٌ إِمْساكٌ':Added, #1: 1	حُكْمَ امْرَأَةِ
u'حُكْمٌ أَمْلاكٌ':Added, #2: 2	حُكْمُ الْإِمْسَاكِ
u'حُكْمٌ أَمْلاَكٌ':Added, #1: 1	حُكْمُ الْأَمْلَاكِ
u'حُكْمٌ أَمْلاكٌ':Added, #1: 1	حُكْمُ الْأَمْلَاكِ
u'حُكْمٌ أَمْلاَكٌ':Added, #1: 1	حُكْمِ أَمْلَاكِ
u'حُكْمٌ إِمْلاكٌ':Added, #1: 1	حُكْمِ أَمْلَاكِ
u'حُكْمٌ أَمْلاكٌ':Added, #1: 1	حُكْمِ إمْلَاكِهِ
u'حُكْمٌ أَمْلاَكٌ':Added, #2: 2	حُكْمِ الْأَمْلَاكِ
u'حُكْمٌ أمناء':Added, #2: 2	حُكْمِ الْأَمْلَاكِ
u'حُكْمٌ أُمَّهَاتٌ':Added, #1: 1	حُكْمُ الْأُمَنَاءِ
u'حُكْمٌ أُمَّهَاتٌ':Added, #1: 1	حُكْمُ أُمَّهَاتِ
u'حُكْمٌ أموات':Added, #3: 3	حُكْمِ الْأُمَّهَاتِ
u'حُكْمٌ أموات':Added, #1: 1	حُكْمُ الْأَمْوَاتِ
u'حُكْمٌ أَمْوَالٌ':Added, #1: 1	حُكْمِ الْأَمْوَاتِ
u'حُكْمٌ أَمْوَالٌ':Added, #1: 1	حُكْمُ الْأَمْوَالِ
u'حُكْمٌ أَمْوَالٌ':Added, #1: 1	حُكْمَ أَمْوَالِ
u'حُكْمٌ أَمْوَالٌ':Added, #1: 1	حُكْمِ أَمْوَالِ
u'حُكْمٌ أَمْوَالٌ':Added, #2: 2	حُكْمِ الْأَمْوَالِ
u'حُكْمٌ أُمِّيٌّ':Added, #2: 2	حُكْمُ أَمْوَالِ
u'حُكْمٌ أُمِّيٌّ':Added, #1: 1	حُكْمِ الْأُمِّيَّةِ
u'حُكْمٌ أُمِّيٌّ':Added, #2: 2	حُكْمُ أُمِّيَّةِ
u'حُكْمٌ أُمِّيَّةٌ':Added, #2: 2	حُكْمِ أُمِّيَّةِ
u'حُكْمٌ أُمِّيَّةٌ':Added, #1: 1	حُكْمِ الْأُمِّيَّةِ
u'حُكْمٌ أُمِّيَّةٌ':Added, #2: 2	حُكْمُ أُمِّيَّةِ
u'حَكَمَ أَميرٌ':Subject, #2: 2	حُكْمِ أُمِّيَّةِ
u'حُكْمٌ اِنْتِقالٌ':Added, #1: 1	حَكَمَ الْأَمِيرُ
u'حُكْمٌ اِنْتِقالٌ':Added, #1: 1	حُكْمُ انْتِقَالِهِ
u'حُكْمٌ إِنْشاءٌ':Added, #2: 2	حُكْمُ انْتِقَالِ
u'حُكْمٌ إِنْشاءٌ':Added, #1: 1	حُكْمُ الْإِنْشَاءِ
u'حُكْمٌ إِنْشاءٌ':Added, #1: 1	حُكْمِ الْإِنْشَاءَاتِ
u'حُكْمٌ اِنْعِقَادٌ':Added, #1: 1	حُكْمُ إنْشَاءِ
u'حُكْمٌ اِنْعِقَادٌ':Added, #2: 2	حُكْمِ انْعِقَادِهِ
u'حُكْمٌ إِنْفاقٌ':Added, #3: 3	حُكْمِ انْعِقَادِ
u'حُكْمٌ إِنْفاقٌ':Added, #1: 1	حُكْمُ إنْفَاقِ
u'حُكْمٌ اِنْفِساخٌ':Added, #1: 1	حُكْمُ إنْفَاقِهِ
u'حُكْمٌ اِنْقِسَامٌ':Added, #1: 1	حُكْمِ انْفِسَاخِ
u'حُكْمٌ اِنْقِضاءٌ':Added, #1: 1	حُكْمُ انْقِسَامِ
u'حُكْمٌ اِنْقِضاءٌ':Added, #1: 1	حُكْمُ انْقِضَاءِ
u'حُكْمٌ اِنْقِطاعٌ':Added, #3: 3	حُكْمِ انْقِضَاءِ
u'حُكْمٌ آنِيَةٌ':Added, #1: 1	حُكْمِ انْقِطَاعِ
u'حَكَمَ أهْلٌ':Subject, #1: 1	حُكْمُ الْآنِيَةِ
u'حُكْمٌ أهْلٌ':Added, #2: 2	حَكَمَ أَهْلُ
u'حُكْمٌ أهْلٌ':Added, #16: 16	حُكْمُ أَهْلِ
u'حُكْمٌ أهْلٌ':Added, #1: 1	حُكْمِ الأَهْلِ
u'حُكْمٌ أهْلٌ':Added, #6: 6	حُكْمَ أَهْلِ
u'حُكْمٌ إهْلاَلٌ':Added, #9: 9	حُكْمِ أَهْلِ
u'حُكْمٌ أوامر':Added, #1: 1	حُكْمَ الْإِهْلَالِ
u'حُكْمٌ أَوامِرُ':Added, #1: 1	حُكْمُ أَوَامِرِ
u'حُكْمٌ أَوَّلُ':Added, #1: 1	حُكْمُ أَوَامِرِ
u'حُكْمٌ أَوَّلُ':Added, #10: 10	حُكْمِ الْأَوَّلِ
u'حُكْمٌ أَوَّلُ':Added, #16: 16	حُكْمُ الْأَوَّلِ
u'حُكْمٌ أَوَّلُ':Added, #1: 1	حُكْمَ أَوَّلِ
u'حُكْمٌ أَوَّلُ':Added, #1: 1	حُكْمِ أَوَّلِ
u'حُكْمٌ أَوْلاَدٌ':Added, #3: 3	حُكْمَ الْأَوَّلِ
u'حُكْمٌ أَوْلاَدٌ':Added, #1: 1	حُكْمَ أَوْلَادِ
u'حُكْمٌ أَوْلاَدٌ':Added, #1: 1	حُكْمُ أَوْلَادِ
u'حُكْمٌ أولى':Added, #4: 4	حُكْمُ الْأَوْلَادِ
u'حُكْمٌ أوْلَى':Added, #1: 1	حُكْمُ الْأُولَيَيْنِ
u'حُكْمٌ أئِمَّةٌ':Added, #1: 1	حُكْمُ الْأُولَيَيْنِ
u'حُكْمٌ أيَّامٌ':Added, #1: 1	حُكْمِ الْأَئِمَّةِ
u'حُكْمٌ أَيَّامٌ':Added, #2: 2	حُكْمِ الْأَيَّامِ
u'حُكْمٌ أيَّامٌ':Added, #2: 2	حُكْمِ الْأَيَّامِ
u'حُكْمٌ أيَّامٌ':Added, #2: 2	حُكْمِ أَيَّامٍ
u'حُكْمٌ أَيَّامٌ':Added, #2: 2	حُكْمِ أَيَّامِ
u'حُكْمٌ أَيَّامٌ':Added, #2: 2	حُكْمِ أَيَّامٍ
u'حُكْمٌ آيَةٌ':Added, #2: 2	حُكْمِ أَيَّامِ
u'حُكْمٌ آيَةٌ':Added, #2: 2	حُكْمَ الْآيَةِ
u'حُكْمٌ آيَةٌ':Added, #2: 2	حُكْمُ الْآيَةِ
u'حُكْمٌ إِيثَارٌ':Added, #2: 2	حُكْمِ الْآيَةِ
u'حُكْمٌ إِيجَابٌ':Added, #1: 1	حُكْمَ الْإِيثَارِ
u'حُكْمٌ إِيجَابٌ':Added, #1: 1	حُكْمِ الْإِيجَابَيْنِ
u'حُكْمٌ إِيجَابٌ':Added, #3: 3	حُكْمُ الْإِيجَابِ
u'حُكْمٌ إِيجَارٌ':Added, #4: 4	حُكْمِ الْإِيجَابِ
u'حُكْمٌ إِيدَاعٌ':Added, #1: 1	حُكْمُ إيجَارِ
u'حُكْمٌ إِيدَاعٌ':Added, #1: 1	حُكْمَ الْإِيدَاعِ
u'حُكْمٌ إيقَاعٌ':Added, #1: 1	حُكْمِ الْإِيدَاعِ
u'حُكْمٌ إيمَانٌ':Added, #1: 1	حُكْمُ إيقَاعِ
u'حُكْمٌ بَابٌ':Added, #1: 1	حُكْمُ الإِيمَانِ
u'حُكْمٌ بَاطِلٌ':Added, #1: 1	حُكْمُ الْبَابِ
u'حُكْمٌ بَاطِلٌ':Added, #1: 1	حُكْمُ الْبَاطِلِ
u'حُكْمٌ بَاطن':Added, #1: 1	حُكْمٍ بَاطِلٍ
u'حُكْمٌ باطِنٌ':Added, #3: 3	حُكْمُ الْبَاطِنِ
u'حُكْمٌ بَاطن':Added, #3: 3	حُكْمُ الْبَاطِنِ
u'حُكْمٌ باطِنٌ':Added, #8: 8	حُكْمِ الْبَاطِنِ
u'حُكْمٌ بالِغٌ':Added, #8: 8	حُكْمِ الْبَاطِنِ
u'حُكْمٌ بالِغٌ':Added, #1: 1	حُكْمِ الْبَالِغِ
u'حُكْمٌ بالِغٌ':Added, #2: 2	حُكْمَ الْبَالِغِ
u'حُكْمٌ بَائِعٌ':Added, #2: 2	حُكْمُ الْبَالِغِ
u'حُكْمٌ بَائِعٌ':Added, #1: 1	حُكْمِ الْبَائِعِ
u'حُكْمٌ بَائِنٌ':Added, #2: 2	حُكْمُ الْبَائِعِ
u'حُكْمٌ بَحْرٌ':Added, #1: 1	حُكْمُ الْبَائِنِ
u'حَكَمَ بُخَارِيٌّ':Subject, #1: 1	حُكْمَ الْبَحْرِ
u'حُكْمٌ بِدَايَةٌ':Added, #1: 1	حَكَمَ الْبُخَارِيُّ
u'حُكْمٌ بدعيٌّ':Added, #1: 1	حُكْمُ بِدَايَةِ
u'حُكْمٌ بَدَلٌ':Added, #1: 1	حُكْمُ الْبِدْعِيِّ
u'حُكْمٌ بَدَلٌ':Added, #2: 2	حُكْمُ بَدَلِهِ
u'حُكْمٌ بَدَلٌ':Added, #5: 5	حُكْمُ الْبَدَلِ
u'حُكْمٌ بَدَلٌ':Added, #6: 6	حُكْمِ الْبَدَلِ
u'حُكْمٌ بدن':Added, #7: 7	حُكْمَ الْبَدَلِ
u'حُكْمٌ بدن':Added, #1: 1	حُكْمَ الْبَدَنِ
u'حُكْمٌ بَدَنٌ':Added, #1: 1	حُكْمُ الْبَدَنِ
u'حُكْمٌ بَدَنٌ':Added, #1: 1	حُكْمَ الْبَدَنِ
u'حُكْمٌ بدنة':Added, #1: 1	حُكْمُ الْبَدَنِ
u'حُكْمٌ بَذْلٌ':Added, #2: 2	حُكْمُ الْبَدَنَةِ
u'حُكْمٌ بِرٌّ':Added, #1: 1	حُكْمُ بَذْلِ
u'حُكْمٌ بَرٌّ':Added, #1: 1	حُكْمُ الْبِرِّ
u'حُكْمٌ بِرٌّ':Added, #2: 2	حُكْمُ الْبَرِّ
u'حُكْمٌ برص':Added, #4: 4	حُكْمِ الْبِرِّ
u'حُكْمٌ بَرَصٌ':Added, #1: 1	حُكْمُ الْبَرَصِ
u'حُكْمٌ بَصيرٌ':Added, #1: 1	حُكْمُ الْبَرَصِ
u'حُكْمٌ بِضاعَةٌ':Added, #1: 1	حُكْمُ الْبَصِيرِ
u'حُكْمٌ بَطْنٌ':Added, #2: 2	حُكْمَ الْبِضَاعَةِ
u'حُكْمٌ بُطونٌ':Added, #1: 1	حُكْمُ الْبَطْنِ
u'حُكْمٌ بَطِيءٌ':Added, #1: 1	حُكْمُ الْبُطُونِ
u'حَكَمَ بَعْضٌ':Subject, #1: 1	حُكْمُ بَطِيءِ
u'حُكْمٌ بَعْضٌ':Added, #3: 3	حَكَمَ بَعْضُ
u'حُكْمٌ بَعْضٌ':Added, #1: 1	حُكْمِ الْبَعْضَيْنِ
u'حُكْمٌ بَعيدٌ':Added, #2: 2	حُكْمِ بَعْضِ
u'حُكْمٌ بَعيدٌ':Added, #2: 2	حُكْمِ الْبَعِيدِ
u'حُكْمٌ بَعيرٌ':Added, #3: 3	حُكْمُ الْبَعِيدِ
u'حُكْمٌ بَعيرٌ':Added, #1: 1	حُكْمَ الْبَعِيرِ
u'حُكْمٌ بُغاةٌ':Added, #2: 2	حُكْمُ الْبَعِيرِ
u'حُكْمٌ بُغاةٌ':Added, #2: 2	حُكْمَ الْبُغَاةِ
u'حُكْمٌ بَغْيٌ':Added, #7: 7	حُكْمُ الْبُغَاةِ
u'حُكْمٌ بَقاءٌ':Added, #1: 1	حُكْمُ الْبَغْيِ
u'حُكْمٌ بَقاءٌ':Added, #1: 1	حُكْمُ الْبَقَاءِ
u'حُكْمٌ بَقاءٌ':Added, #1: 1	حُكْمِ الْبَقَاءِ
u'حُكْمٌ بَقاءٌ':Added, #1: 1	حُكْمِ بَقَاءِ
u'حُكْمٌ بَقَرٌ':Added, #3: 3	حُكْمَ الْبَقَاءِ
u'حُكْمٌ بُقْعَةٌ':Added, #1: 1	حُكْمُ الْبَقَرِ
u'حُكْمٌ بُقْعَةٌ':Added, #1: 1	حُكْمُ بُقْعَةٍ
u'حُكْمٌ بُقْعَةٌ':Added, #1: 1	حُكْمِ بُقْعَةٍ
u'حُكْمٌ بَقِيَّةٌ':Added, #2: 2	حُكْمُ الْبُقْعَةِ
u'حُكْمٌ بَكارَةٌ':Added, #2: 2	حُكْمُ بَقِيَّةِ
u'حُكْمٌ بِكْرٌ':Added, #2: 2	حُكْمُ الْبَكَارَةِ
u'حُكْمٌ بِكْرٌ':Added, #1: 1	حُكْمَ الْبِكْرِ
u'حُكْمٌ بَلاغَةٌ':Added, #1: 1	حُكْمُ الْبِكْرِ
u'حُكْمٌ بَلاغَةٌ':Added, #1: 1	حُكْمُ الْبَلَاغَةِ
u'حُكْمٌ بَلَدٌ':Added, #6: 6	حُكْمِ الْبَلَاغَةِ
u'حُكْمٌ بَلَدٌ':Added, #1: 1	حُكْمِ الْبَلَدِ
u'حُكْمٌ بَلَدٌ':Added, #1: 1	حُكْمُ بَلَدِ
u'حُكْمٌ بَلَدٌ':Added, #1: 1	حُكْمِ بَلَدٍ
u'حُكْمٌ بُلُوغٌ':Added, #3: 3	حُكْمُ الْبَلَدِ
u'حُكْمٌ بُلُوغٌ':Added, #1: 1	حُكْمِ الْبُلُوغِ
u'حُكْمٌ بُلُوغٌ':Added, #1: 1	حُكْمُ بُلُوغِ
u'حُكْمٌ بِنَاءٌ':Added, #4: 4	حُكْمُ الْبُلُوغِ
u'حُكْمٌ بِنَاءٌ':Added, #1: 1	حُكْمِ بِنَاءِ
u'حُكْمٌ بِنَاءٌ':Added, #2: 2	حُكْمُ الْبِنَاءِ
u'حُكْمٌ بِنَاءٌ':Added, #2: 2	حُكْمِ الْبِنَاءِ
u'حُكْمٌ بناتٌ':Added, #4: 4	حُكْمُ بِنَاءِ
u'حُكْمٌ بِنْتٌ':Added, #1: 1	حُكْمُ الْبَنَاتِ
u'حُكْمٌ بِنْتٌ':Added, #1: 1	حُكْمِ الْبِنْتَيْنِ
u'حُكْمٌ بِنْتٌ':Added, #1: 1	حُكْمُ بِنْتِ
u'حُكْمٌ بَنْجٌ':Added, #2: 2	حُكْمُ الْبِنْتِ
u'حُكْمٌ بُنُوَّة':Added, #1: 1	حُكْمَ الْبَنْجِ
u'حُكْمٌ بَهيمٌ':Added, #1: 1	حُكْمُ الْبُنُوَّةِ
u'حُكْمٌ بَهِيمَةٌ':Added, #1: 1	حُكْمُ الْبَهِيمَةِ
u'حُكْمٌ بَوْلٌ':Added, #1: 1	حُكْمُ الْبَهِيمَةِ
u'حُكْمٌ بَوْلٌ':Added, #1: 1	حُكْمُ بَوْلِ
u'حُكْمٌ بِئْرٌ':Added, #3: 3	حُكْمُ بَوْلِهِ
u'حُكْمٌ بِئْرٌ':Added, #1: 1	حُكْمِ الْبِئْرِ
u'حُكْمٌ بَيَاضٌ':Added, #2: 2	حُكْمُ الْبِئْرِ
u'حُكْمٌ بَيَانٌ':Added, #2: 2	حُكْمُ الْبَيَاضِ
u'حُكْمٌ بَيَانٌ':Added, #1: 1	حُكْمَ بَيَانِ
u'حُكْمٌ بَيْتٌ':Added, #1: 1	حُكْمُ بَيَانِ
u'حُكْمٌ بَيْتٌ':Added, #1: 1	حُكْمُ الْبَيْتِ
u'حُكْمٌ بَيْتٌ':Added, #1: 1	حُكْمُ الْبَيْتَيْنِ
u'حُكْمٌ بَيْتٌ':Added, #1: 1	حُكْمِ بَيْتِ
u'حُكْمٌ بيض':Added, #1: 1	حُكْمِ بَيْتَيْنِ
u'حُكْمٌ بيض':Added, #1: 1	حُكْمُ بَيْضِ
u'حُكْمٌ بَيْعٌ':Added, #1: 1	حُكْمُ بَيْضِهِ
u'حُكْمٌ بَيْعٌ':Added, #16: 16	حُكْمِ الْبَيْعِ
u'حُكْمٌ بَيْعٌ':Added, #1: 1	حُكْمَ بَيْعِ
u'حُكْمٌ بَيْعٌ':Added, #1: 1	حُكْمِ بَيْعٍ
u'حُكْمٌ بَيْعٌ':Added, #35: 35	حُكْمُ الْبَيْعِ
u'حُكْمٌ بَيْعٌ':Added, #3: 3	حُكْمَ الْبَيْعِ
u'حُكْمٌ بَيْعٌ':Added, #6: 6	حُكْمُ بَيْعِهِ
u'حُكْمٌ بَيْعٌ':Added, #8: 8	حُكْمِ بَيْعِ
u'حَكَمَ بَيْنٌ':Predicate, #9: 9	حُكْمُ بَيْعِ
u'حُكْمٌ بَيِّنَةٌ':Added, #7: 7	حَكَمَ بَيْنَ
u'حُكْمٌ بَيِّنَةٌ':Added, #1: 1	حُكْمُ الْبَيِّنَةِ
u'حكمة اِتِّخَاذٌ':Added, #2: 2	حُكْمَ الْبَيِّنَةِ
u'حِكْمَةٌ اِتِّخَاذٌ':Added, #1: 1	حِكْمَةُ اتِّخَاذِ
u'حكمة إِحْيَاءٌ':Added, #1: 1	حِكْمَةُ اتِّخَاذِ
u'حِكْمَةٌ إِحْيَاءٌ':Added, #1: 1	حِكْمَةِ الْإِحْيَاءِ
u'حكمة اِخْتِلاَفٌ':Added, #1: 1	حِكْمَةِ الْإِحْيَاءِ
u'حِكْمَةٌ اِخْتِلاَفٌ':Added, #1: 1	حِكْمَةَ اخْتِلَافِ
u'حكمة إِرْسَالٌ':Added, #1: 1	حِكْمَةَ اخْتِلَافِ
u'حِكْمَةٌ إِرْسَالٌ':Added, #1: 1	حِكْمَةَ الْإِرْسَالِ
u'حكمة إِسْراءٌ':Added, #1: 1	حِكْمَةَ الْإِرْسَالِ
u'حِكْمَةٌ إِسْراءٌ':Added, #1: 1	حِكْمَةِ الْإِسْرَاءِ
u'حكمة اِصْطِناع':Added, #1: 1	حِكْمَةِ الْإِسْرَاءِ
u'حِكْمَةٌ اِصْطِناع':Added, #1: 1	حِكْمَةُ اصْطِنَاعِ
u'حكمة إكْثَارٌ':Added, #1: 1	حِكْمَةُ اصْطِنَاعِ
u'حِكْمَةٌ إكْثَارٌ':Added, #1: 1	حِكْمَةِ إكْثَارِهِ
u'حكمة أَمْرٌ':Added, #1: 1	حِكْمَةِ إكْثَارِهِ
u'حِكْمَةٌ أَمْرٌ':Added, #1: 1	حِكْمَةَ الْأَمْرِ
u'حكمة أَهِلَّةٌ':Added, #1: 1	حِكْمَةَ الْأَمْرِ
u'حِكْمَةٌ أَهِلَّةٌ':Added, #1: 1	حِكْمَةِ الْأَهِلَّةِ
u'حكمة آيَةٌ':Added, #1: 1	حِكْمَةِ الْأَهِلَّةِ
u'حِكْمَةٌ آيَةٌ':Added, #1: 1	حِكْمَةِ الْآيَةِ
u'حكمة بَعْثٌ':Added, #1: 1	حِكْمَةِ الْآيَةِ
u'حِكْمَةٌ بَعْثٌ':Added, #1: 1	حِكْمَةُ بَعْثِ
u'حكمة بَكارَةٌ':Added, #1: 1	حِكْمَةُ بَعْثِ
u'حكمة بَكارَةٌ':Added, #1: 1	حِكْمَةَ الْبَكَارَةِ
u'حِكْمَةٌ بَكارَةٌ':Added, #1: 1	حِكْمَةِ الْبَكَارَةِ
u'حِكْمَةٌ بَكارَةٌ':Added, #1: 1	حِكْمَةَ الْبَكَارَةِ
u'حكمة تَجْمِيعٌ':Added, #1: 1	حِكْمَةِ الْبَكَارَةِ
u'حِكْمَةٌ تَجْمِيعٌ':Added, #1: 1	حِكْمَةُ تَجْمِيعِ
u'حكمة تَحْرِيمٌ':Added, #1: 1	حِكْمَةُ تَجْمِيعِ
u'حِكْمَةٌ تَحْرِيمٌ':Added, #2: 2	حِكْمَةِ تَحْرِيمِ
u'حكمة تَخْصِيصٌ':Added, #2: 2	حِكْمَةِ تَحْرِيمِ
u'حِكْمَةٌ تَخْصِيصٌ':Added, #1: 1	حِكْمَةُ التَّخْصِيصِ
u'حكمة تَخْصِيصٌ':Added, #1: 1	حِكْمَةُ التَّخْصِيصِ
u'حِكْمَةٌ تَخْصِيصٌ':Added, #1: 1	حِكْمَةُ تَخْصِيصِ
u'حكمة تَرْتِيبٌ':Added, #1: 1	حِكْمَةُ تَخْصِيصِ
u'حِكْمَةٌ تَرْتِيبٌ':Added, #1: 1	حِكْمَةَ التَّرْتِيبِ
u'حكمة تَرْكٌ':Added, #1: 1	حِكْمَةَ التَّرْتِيبِ
u'حِكْمَةٌ تَرْكٌ':Added, #2: 2	حِكْمَةُ تَرْكِ
u'حكمة تَصْرِيحٌ':Added, #2: 2	حِكْمَةُ تَرْكِ
u'حِكْمَةٌ تَصْرِيحٌ':Added, #1: 1	حِكْمَةُ تَصْرِيحِهِ
u'حكمة تَعْبِيرٌ':Added, #1: 1	حِكْمَةُ تَصْرِيحِهِ
u'حِكْمَةٌ تَعْبِيرٌ':Added, #1: 1	حِكْمَةُ التَّعْبِيرِ
u'حكمة تَقْيِيد':Added, #1: 1	حِكْمَةُ التَّعْبِيرِ
u'حِكْمَةٌ تَقْيِيد':Added, #1: 1	حِكْمَةِ التَّقْيِيدِ
u'حكمة تَكْثيرٌ':Added, #1: 1	حِكْمَةِ التَّقْيِيدِ
u'حِكْمَةٌ تَكْثيرٌ':Added, #1: 1	حِكْمَةِ تَكْثِيرِ
u'حكمة تَكْنِيَة':Added, #1: 1	حِكْمَةِ تَكْثِيرِ
u'حِكْمَةٌ تَكْنِيَة':Added, #1: 1	حِكْمَةِ تَكْنِيَةِ
u'حكمة تَنْصِيص':Added, #1: 1	حِكْمَةِ تَكْنِيَةِ
u'حِكْمَةٌ تَنْصِيص':Added, #1: 1	حِكْمَةُ التَّنْصِيصِ
u'حكمة تَوْصِيف':Added, #1: 1	حِكْمَةُ التَّنْصِيصِ
u'حِكْمَةٌ تَوْصِيف':Added, #1: 1	حِكْمَةُ تَوْصِيفِ
u'حكمة ثَانِي':Added, #1: 1	حِكْمَةُ تَوْصِيفِ
u'حِكْمَةٌ ثَانِي':Added, #1: 1	حِكْمَةٍ ثَانِيَةٍ
u'حكمة ثَانِيَةٌ':Added, #1: 1	حِكْمَةٍ ثَانِيَةٍ
u'حِكْمَةٌ ثَانِيَةٌ':Added, #1: 1	حِكْمَةٍ ثَانِيَةٍ
u'حكمة حُدودٌ':Added, #1: 1	حِكْمَةٍ ثَانِيَةٍ
u'حِكْمَةٌ حُدودٌ':Added, #1: 1	حِكْمَةِ الْحُدُودِ
u'حكمة حُكْمٌ':Added, #1: 1	حِكْمَةِ الْحُدُودِ
u'حِكْمَةٌ حُكْمٌ':Added, #1: 1	حِكْمَةَ الْحُكْمِ
u'حكمة حُكْمٌ':Added, #1: 1	حِكْمَةَ الْحُكْمِ
u'حِكْمَةٌ حُكْمٌ':Added, #2: 2	حِكْمَةِ الْحُكْمِ
u'حكمة خَالِقٌ':Added, #2: 2	حِكْمَةِ الْحُكْمِ
u'حِكْمَةٌ خَالِقٌ':Added, #1: 1	حِكْمَةَ الْخَالِقِ
u'حكمة دَاعِي':Added, #1: 1	حِكْمَةَ الْخَالِقِ
u'حِكْمَةٌ دَاعِي':Added, #1: 1	حِكْمَةٍ دَاعِيَةٍ
u'حكمة رَبْطٌ':Added, #1: 1	حِكْمَةٍ دَاعِيَةٍ
u'حِكْمَةٌ رَبْطٌ':Added, #1: 1	حِكْمَةَ رَبْطِ
u'حكمة رَدْعٌ':Added, #1: 1	حِكْمَةَ رَبْطِ
u'حِكْمَةٌ رَدْعٌ':Added, #1: 1	حِكْمَةِ الرَّدْعِ
u'حكمة زَجْرٌ':Added, #1: 1	حِكْمَةِ الرَّدْعِ
u'حكمة زَجْرٌ':Added, #2: 2	حِكْمَةُ الزَّجْرِ
u'حِكْمَةٌ زَجْرٌ':Added, #2: 2	حِكْمَةِ الزَّجْرِ
u'حِكْمَةٌ زَجْرٌ':Added, #2: 2	حِكْمَةُ الزَّجْرِ
u'حكمة سَبَبٌ':Added, #2: 2	حِكْمَةِ الزَّجْرِ
u'حِكْمَةٌ سَبَبٌ':Added, #1: 1	حِكْمَةِ السَّبَبِ
u'حكمة شَرْعٌ':Added, #1: 1	حِكْمَةِ السَّبَبِ
u'حِكْمَةٌ شَرْعٌ':Added, #1: 1	حِكْمَةُ الشَّرْعِ
u'حكمة شَرْعٌ':Added, #1: 1	حِكْمَةُ الشَّرْعِ
u'حِكْمَةٌ شَرْعٌ':Added, #1: 1	حِكْمَةُ شَرْعِ
u'حكمة شَرِيعَةٌ':Added, #1: 1	حِكْمَةُ شَرْعِ
u'حِكْمَةٌ شَرِيعَةٌ':Added, #1: 1	حِكْمَةَ الشَّرِيعَةِ
u'حكمة صَوْمٌ':Added, #1: 1	حِكْمَةَ الشَّرِيعَةِ
u'حكمة صَوْمٌ':Added, #1: 1	حِكْمَةَ الصَّوْمِ
u'حِكْمَةٌ صَوْمٌ':Added, #1: 1	حِكْمَةِ الصَّوْمِ
u'حِكْمَةٌ صَوْمٌ':Added, #1: 1	حِكْمَةَ الصَّوْمِ
u'حكمة عِلَّةٌ':Added, #1: 1	حِكْمَةِ الصَّوْمِ
u'حِكْمَةٌ عِلَّةٌ':Added, #1: 1	حِكْمَةِ الْعِلَّةِ
u'حكمة غَامِضٌ':Added, #1: 1	حِكْمَةِ الْعِلَّةِ
u'حِكْمَةٌ غَامِضٌ':Added, #1: 1	حِكْمَةٍ غَامِضَةٍ
u'حكمة غَسْلٌ':Added, #1: 1	حِكْمَةٍ غَامِضَةٍ
u'حِكْمَةٌ غَسْلٌ':Added, #1: 1	حِكْمَةَ غَسْلِ
u'حكمة فِعْلٌ':Added, #1: 1	حِكْمَةَ غَسْلِ
u'حِكْمَةٌ فِعْلٌ':Added, #1: 1	حِكْمَةُ فِعْلِ
u'حكمة قصاص':Added, #1: 1	حِكْمَةُ فِعْلِ
u'حكمة قصاص':Added, #1: 1	حِكْمَةُ الْقِصَاصِ
u'حكمة قِصَاصٌ':Added, #1: 1	حِكْمَةِ الْقِصَاصِ
u'حكمة قِصَاصٌ':Added, #1: 1	حِكْمَةُ الْقِصَاصِ
u'حِكْمَةٌ قصاص':Added, #1: 1	حِكْمَةِ الْقِصَاصِ
u'حِكْمَةٌ قصاص':Added, #1: 1	حِكْمَةُ الْقِصَاصِ
u'حِكْمَةٌ قِصَاصٌ':Added, #1: 1	حِكْمَةِ الْقِصَاصِ
u'حِكْمَةٌ قِصَاصٌ':Added, #1: 1	حِكْمَةُ الْقِصَاصِ
u'حكمة قول':Added, #1: 1	حِكْمَةِ الْقِصَاصِ
u'حكمة قَوْلٌ':Added, #1: 1	حِكْمَةُ قَوْلِهِ
u'حِكْمَةٌ قول':Added, #1: 1	حِكْمَةُ قَوْلِهِ
u'حِكْمَةٌ قَوْلٌ':Added, #1: 1	حِكْمَةُ قَوْلِهِ
u'حكمة كَثْرَةٌ':Added, #1: 1	حِكْمَةُ قَوْلِهِ
u'حِكْمَةٌ كَثْرَةٌ':Added, #1: 1	حِكْمَةَ كَثْرَةِ
u'حكمة كَرَاهَةٌ':Added, #1: 1	حِكْمَةَ كَثْرَةِ
u'حِكْمَةٌ كَرَاهَةٌ':Added, #1: 1	حِكْمَةِ كَرَاهَةِ
u'حكمة كَوْنٌ':Added, #1: 1	حِكْمَةِ كَرَاهَةِ
u'حِكْمَةٌ كَوْنٌ':Added, #2: 2	حِكْمَةُ كَوْنِ
u'حكمة مُجَرَّدٌ':Added, #2: 2	حِكْمَةُ كَوْنِ
u'حِكْمَةٌ مُجَرَّدٌ':Added, #1: 1	حِكْمَةٍ مُجَرَّدَةٍ
u'حكمة مُخَاطَبٌ':Added, #1: 1	حِكْمَةٍ مُجَرَّدَةٍ
u'حِكْمَةٌ مُخَاطَبٌ':Added, #1: 1	حِكْمَةَ الْمُخَاطَبَةِ
u'حكمة مُخَاطَبَةٌ':Added, #1: 1	حِكْمَةَ الْمُخَاطَبَةِ
u'حِكْمَةٌ مُخَاطَبَةٌ':Added, #1: 1	حِكْمَةَ الْمُخَاطَبَةِ
u'حكمة مُشَاهَدٌ':Added, #1: 1	حِكْمَةَ الْمُخَاطَبَةِ
u'حِكْمَةٌ مُشَاهَدٌ':Added, #1: 1	حِكْمَةَ الْمُشَاهَدَةِ
u'حكمة مُشَاهَدَةٌ':Added, #1: 1	حِكْمَةَ الْمُشَاهَدَةِ
u'حِكْمَةٌ مُشَاهَدَةٌ':Added, #1: 1	حِكْمَةَ الْمُشَاهَدَةِ
u'حكمة مَشْرُوعِيَّةٌ':Added, #1: 1	حِكْمَةَ الْمُشَاهَدَةِ
u'حِكْمَةٌ مَشْرُوعِيَّةٌ':Added, #1: 1	حِكْمَةُ الْمَشْرُوعِيَّةِ
u'حكمة مَشْرُوعِيَّةٌ':Added, #1: 1	حِكْمَةُ الْمَشْرُوعِيَّةِ
u'حِكْمَةٌ مَشْرُوعِيَّةٌ':Added, #1: 1	حِكْمَةُ مَشْرُوعِيَّةِ
u'حكمة مَقْصُودٌ':Added, #1: 1	حِكْمَةُ مَشْرُوعِيَّةِ
u'حِكْمَةٌ مَقْصُودٌ':Added, #3: 3	حِكْمَةٍ مَقْصُودَةٍ
u'حكمة مَنْعٌ':Added, #3: 3	حِكْمَةٍ مَقْصُودَةٍ
u'حِكْمَةٌ مَنْعٌ':Added, #1: 1	حِكْمَةِ مَنْعِ
u'حكمة مَنْعٌ':Added, #1: 1	حِكْمَةِ مَنْعِ
u'حِكْمَةٌ مَنْعٌ':Added, #2: 2	حِكْمَةُ مَنْعِ
u'حكمة نَهْيٌ':Added, #2: 2	حِكْمَةُ مَنْعِ
u'حكمة نَهْيٌ':Added, #1: 1	حِكْمَةَ النَّهْيِ
u'حِكْمَةٌ نَهْيٌ':Added, #1: 1	حِكْمَةُ النَّهْيِ
u'حِكْمَةٌ نَهْيٌ':Added, #1: 1	حِكْمَةَ النَّهْيِ
u'حكمة وَاضِعٌ':Added, #1: 1	حِكْمَةُ النَّهْيِ
u'حِكْمَةٌ وَاضِعٌ':Added, #1: 1	حِكْمَةُ الْوَاضِعِ
u'حكمة وُجُوبٌ':Added, #1: 1	حِكْمَةُ الْوَاضِعِ
u'حِكْمَةٌ وُجُوبٌ':Added, #1: 1	حِكْمَةِ الْوُجُوبِ
u'حكمة وُجُوبٌ':Added, #1: 1	حِكْمَةِ الْوُجُوبِ
u'حِكْمَةٌ وُجُوبٌ':Added, #1: 1	حِكْمَةُ وُجُوبِ
u'حكمة وُضُوءٌ':Added, #1: 1	حِكْمَةُ وُجُوبِ
u'حِكْمَةٌ وُضُوءٌ':Added, #1: 1	حِكْمَةُ الْوُضُوءِ
u'حكمة وُقُوعٌ':Added, #1: 1	حِكْمَةُ الْوُضُوءِ
u'حِكْمَةٌ وُقُوعٌ':Added, #1: 1	حِكْمَةِ الْوُقُوعِ
u'حُكْمٌ تَابِعٌ':Added, #1: 1	حِكْمَةِ الْوُقُوعِ
u'حُكْمٌ تَأْثِيرٌ':Added, #1: 1	حُكْمِ التَّابِعَةِ
u'حُكْمٌ تَأَخُّرٌ':Added, #1: 1	حُكْمِ التَّأْثِيرِ
u'حُكْمٌ تَأْخِيرٌ':Added, #1: 1	حُكْمِ تَأَخُّرِ
u'حُكْمٌ تَأْخِيرٌ':Added, #1: 1	حُكْمَ تَأْخِيرِ
u'حُكْمٌ تَأْخِيرٌ':Added, #1: 1	حُكْمُ تَأْخِيرِ
u'حُكْمٌ تارِك':Added, #1: 1	حُكْمِ تَأْخِيرِ
u'حُكْمٌ تَأَكُّدٌ':Added, #1: 1	حُكْمُ تَارِكِ
u'حُكْمٌ تَأْكِيدٌ':Added, #2: 2	حُكْمُ التَّأَكُّدِ
u'حُكْمٌ تالِف':Added, #1: 1	حُكْمِ التَّأْكِيدِ
u'حُكْمٌ تالِف':Added, #1: 1	حُكْمَ التَّالِفِ
u'حُكْمٌ تالِف':Added, #1: 1	حُكْمِ التَّالِفِ
u'حُكْمٌ تَبَدُّلٌ':Added, #2: 2	حُكْمُ التَّالِفِ
u'حُكْمٌ تَبَرُّعٌ':Added, #1: 1	حُكْمِ تَبَدُّلِ
u'حُكْمٌ تَبَرُّعٌ':Added, #1: 1	حُكْمِ تَبَرُّعَاتِهِ
u'حُكْمٌ تَبَسُّمٌ':Added, #1: 1	حُكْمُ تَبَرُّعِهِ
u'حُكْمٌ تَبَع':Added, #1: 1	حُكْمُ التَّبَسُّمِ
u'حُكْمٌ تَبَع':Added, #1: 1	حُكْمُ التَّبَعِ
u'حُكْمٌ تَبَع':Added, #1: 1	حُكْمَ التَّبَعِيَّةِ
u'حُكْمٌ تَبَع':Added, #1: 1	حُكْمُ تَبَعِيَّةِ
u'حُكْمٌ تَبَع':Added, #2: 2	حُكْمُ التَّبَعِيَّةِ
u'حُكْمٌ تَبَع':Added, #3: 3	حُكْمِ التَّبَعِيَّةِ
u'حُكْمٌ تَبَعِيّ':Added, #7: 7	حُكْمِ التَّبَعِ
u'حُكْمٌ تَبَعِيّ':Added, #1: 1	حُكْمَ التَّبَعِيَّةِ
u'حُكْمٌ تَبَعِيّ':Added, #1: 1	حُكْمُ تَبَعِيَّةِ
u'حُكْمٌ تَبَعِيّ':Added, #2: 2	حُكْمُ التَّبَعِيَّةِ
u'حُكْمٌ تَبَعِيَّة':Added, #3: 3	حُكْمِ التَّبَعِيَّةِ
u'حُكْمٌ تَبَعِيَّة':Added, #1: 1	حُكْمَ التَّبَعِيَّةِ
u'حُكْمٌ تَبَعِيَّة':Added, #1: 1	حُكْمُ تَبَعِيَّةِ
u'حُكْمٌ تَبَعِيَّة':Added, #2: 2	حُكْمُ التَّبَعِيَّةِ
u'حُكْمٌ تَبْلِيغٌ':Added, #3: 3	حُكْمِ التَّبَعِيَّةِ
u'حُكْمٌ تَبْلِيغٌ':Added, #1: 1	حُكْمِ التّبْلِيغِ
u'حُكْمٌ تَتَر':Added, #1: 1	حُكْمِ التَّبْلِيغِ
u'حُكْمٌ تَثْنِيَةٌ':Added, #1: 1	حُكْمِ التَّتَرِ
u'حُكْمٌ تِجَارَةٌ':Added, #2: 2	حُكْمُ التَّثْنِيَةِ
u'حُكْمٌ تِجَارَةٌ':Added, #1: 1	حُكْمَ التِّجَارَةِ
u'حُكْمٌ تِجَارَةٌ':Added, #2: 2	حُكْمِ التِّجَارَةِ
u'حُكْمٌ تَجَزُّؤٌ':Added, #3: 3	حُكْمُ التِّجَارَةِ
u'حُكْمٌ تَجَعُّدٌ':Added, #1: 1	حُكْمُ التَّجَزُّؤِ
u'حُكْمٌ تَحَالُفٌ':Added, #1: 1	حُكْمِ التَّجَعُّدِ
u'حُكْمٌ تَحَالُفٌ':Added, #1: 1	حُكْمَ التَّحَالُفِ
u'حُكْمٌ تَحْرِيرٌ':Added, #1: 1	حُكْمِ التَّحَالُفِ
u'حُكْمٌ تَحْرِيمٌ':Added, #1: 1	حُكْمَ التَّحْرِيرِ
u'حُكْمٌ تَحْرِيمٌ':Added, #1: 1	حُكْمُ التَّحْرِيمِ
u'حُكْمٌ تَحْرِيمٌ':Added, #1: 1	حُكْمُ تَحْرِيمِ
u'حُكْمٌ تَحْكِيمٌ':Added, #2: 2	حُكْمَ التَّحْرِيمِ
u'حُكْمٌ تَحَلُّلٌ':Added, #2: 2	حُكْمَ التَّحْكِيمِ
u'حُكْمٌ تَحَلُّلٌ':Added, #1: 1	حُكْمُ التَّحَلُّلِ
u'حُكْمٌ تَحْلِيلٌ':Added, #6: 6	حُكْمِ التَّحَلُّلِ
u'حُكْمٌ تَحِيَّةٌ':Added, #1: 1	حُكْمُ تَحْلِيلِ
u'حُكْمٌ تَخْرِيجٌ':Added, #1: 1	حُكْمَ التَّحِيَّةِ
u'حُكْمٌ تَخْرِيجٌ':Added, #1: 1	حُكْمُ التَّخْرِيجِ
u'حُكْمٌ تَخَلُّفٌ':Added, #1: 1	حُكْمَ تَخْرِيجِ
u'حُكْمٌ تَخْيِيرٌ':Added, #2: 2	حُكْمُ التَّخَلُّفِ
u'حُكْمٌ تَخْيِيرٌ':Added, #1: 1	حُكْمَ التَّخْيِيرِ
u'حُكْمٌ تَدْبِيرٌ':Added, #3: 3	حُكْمُ التَّخْيِيرِ
u'حُكْمٌ تَدْبِيرٌ':Added, #2: 2	حُكْمِ التَّدْبِيرِ
u'حُكْمٌ تَدْبِيرٌ':Added, #3: 3	حُكْمَ التَّدْبِيرِ
u'حُكْمٌ تَدْرِيجٌ':Added, #5: 5	حُكْمُ التَّدْبِيرِ
u'حُكْمٌ تَذْكِيَةٌ':Added, #1: 1	حُكْمِ التَّدْرِيجِ
u'حُكْمٌ تُرَابٌ':Added, #1: 1	حُكْمَ تَذْكِيَةِ
u'حُكْمٌ تُرَابٌ':Added, #1: 1	حُكْمَ التُّرَابِ
u'حُكْمٌ تُرَابٌ':Added, #1: 1	حُكْمُ التُّرَابِ
u'حُكْمٌ تَرَاوِيحُ':Added, #2: 2	حُكْمِ التُّرَابِ
u'حُكْمٌ تَرْتِيبٌ':Added, #1: 1	حُكْمِ التَّرَاوِيحِ
u'حُكْمٌ تَرْتِيبٌ':Added, #1: 1	حُكْمُ التَّرْتِيبِ
u'حُكْمٌ تَرْتِيبٌ':Added, #1: 1	حُكْمِ التَّرْتِيبِ
u'حُكْمٌ تَرْتِيبٌ':Added, #1: 1	حُكْمِ تَرْتِيبِ
u'حُكْمٌ تَرْجَمَةٌ':Added, #3: 3	حُكْمَ التَّرْتِيبِ
u'حُكْمٌ تَرَدُّدٌ':Added, #1: 1	حُكْمِ التَّرْجَمَةِ
u'حُكْمٌ تَرْكٌ':Added, #1: 1	حُكْمُ التَّرَدُّدِ
u'حُكْمٌ تَرْكٌ':Added, #1: 1	حُكْمُ تَرْكِهِ
u'حُكْمٌ تَرْكٌ':Added, #3: 3	حُكْمُ تَرْكِ
u'حُكْمٌ تَرِكَةٌ':Added, #3: 3	حُكْمِ تَرْكِ
u'حُكْمٌ تَرْكِيبٌ':Added, #1: 1	حُكْمُ تَرِكَتِهِ
u'حُكْمٌ تَزَاحُمٌ':Added, #1: 1	حُكْمِ التَّرْكِيبِ
u'حُكْمٌ تَزْكِيَةٌ':Added, #1: 1	حُكْمِ تَزَاحُمِ
u'حُكْمٌ تَزْكِيَةٌ':Added, #1: 1	حُكْمَ التَّزْكِيَةِ
u'حُكْمٌ تَزَوُّجٌ':Added, #1: 1	حُكْمَ تَزْكِيَةِ
u'حُكْمٌ تَزْوِيجٌ':Added, #1: 1	حُكْمِ التَّزَوُّجِ
u'حُكْمٌ تَزْوِيجٌ':Added, #1: 1	حُكْمُ التَّزْوِيجِ
u'حُكْمٌ تَزْوِيجٌ':Added, #2: 2	حُكْمَ تَزْوِيجِ
u'حُكْمٌ تَسَبُّبٌ':Added, #2: 2	حُكْمُ تَزْوِيجِ
u'حُكْمٌ تَسْبِيحٌ':Added, #2: 2	حُكْمُ التَّسَبُّبِ
u'حُكْمٌ تَسْلِيمٌ':Added, #2: 2	حُكْمُ التَّسْبِيحِ
u'حُكْمٌ تَسْلِيمٌ':Added, #1: 1	حُكْمِ التَّسْلِيمِ
u'حُكْمٌ تَسْمِيَة':Added, #1: 1	حُكْمَ تَسْلِيمِ
u'حُكْمٌ تَسْمِيَة':Added, #2: 2	حُكْمَ التَّسْمِيَةِ
u'حُكْمٌ تَسْمِيَة':Added, #2: 2	حُكْمِ التَّسْمِيَةِ
u'حُكْمٌ تَسْوِيَةٌ':Added, #3: 3	حُكْمُ التَّسْمِيَةِ
u'حُكْمٌ تَشَبُّه':Added, #1: 1	حُكْمَ التَّسْوِيَةِ
u'حُكْمٌ تَشْطِيرٌ':Added, #1: 1	حُكْمُ التَّشَبُّهِ
u'حُكْمٌ تَشَهُّدٌ':Added, #1: 1	حُكْمِ التَّشْطِيرِ
u'حُكْمٌ تَصْدِيقٌ':Added, #1: 1	حُكْمُ التَّشَهُّدِ
u'حُكْمٌ تَصَرُّفٌ':Added, #1: 1	حُكْمُ التَّصْدِيقِ
u'حُكْمٌ تَصَرُّفٌ':Added, #1: 1	حُكْمِ التَّصَرُّفَاتِ
u'حُكْمٌ تَصَرُّفٌ':Added, #1: 1	حُكْمُ تَصَرُّفَاتِ
u'حُكْمٌ تَصَرُّفٌ':Added, #2: 2	حُكْمُ التَّصَرُّفِ
u'حُكْمٌ تَصَرُّفٌ':Added, #2: 2	حُكْمِ التَّصَرُّفِ
u'حُكْمٌ تَصَرُّفٌ':Added, #2: 2	حُكْمُ تَصَرُّفِ
u'حُكْمٌ تَصَرُّفٌ':Added, #2: 2	حُكْمُ تَصَرُّفَاتِهِ
u'حُكْمٌ تَصَرُّفٌ':Added, #3: 3	حُكْمَ التَّصَرُّفِ
u'حُكْمٌ تَصْرِيحٌ':Added, #3: 3	حُكْمُ تَصَرُّفِهِ
u'حُكْمٌ تَطْلِيقٌ':Added, #2: 2	حُكْمُ التَّصْرِيحِ
u'حُكْمٌ تَطْهِيرٌ':Added, #1: 1	حُكْمُ التَّطْلِيقِ
u'حُكْمٌ تَطَوُّعٌ':Added, #35: 35	حُكْمُ التَّطْهِيرِ
u'حُكْمٌ تَطَوُّعٌ':Added, #2: 2	حُكْمَ التَّطَوُّعِ
u'حُكْمٌ تَطْوِيلٌ':Added, #2: 2	حُكْمُ التَّطَوُّعِ
u'حُكْمٌ تَعَارُضٌ':Added, #2: 2	حُكْمُ تَطْوِيلِ
u'حُكْمٌ تَعَارُضٌ':Added, #1: 1	حُكْمِ التَّعَارُضِ
u'حُكْمٌ تَعَاقُدٌ':Added, #4: 4	حُكْمُ التَّعَارُضِ
u'حُكْمٌ تَعْجِيل':Added, #1: 1	حُكْمَ التَّعَاقُدِ
u'حُكْمٌ تَعْجِيل':Added, #1: 1	حُكْمَ التَّعْجِيلِ
u'حُكْمٌ تَعْجِيل':Added, #1: 1	حُكْمَ تَعْجِيلِ
u'حُكْمٌ تَعَدُّدٌ':Added, #1: 1	حُكْمِ تَعْجِيلِ
u'حُكْمٌ تَعْدِيَة':Added, #1: 1	حُكْمَ تَعَدُّدِ
u'حُكْمٌ تَعْرِيضٌ':Added, #1: 1	حُكْمِ التّعْدِيَةِ
u'حُكْمٌ تَعْرِيفٌ':Added, #1: 1	حُكْمُ التَّعْرِيضِ
u'حُكْمٌ تَعْزِير':Added, #1: 1	حُكْمَ تَعْرِيفِ
u'حُكْمٌ تَعْقِيبٌ':Added, #1: 1	حُكْمُ التَّعْزِيرِ
u'حُكْمٌ تَعَلُّقٌ':Added, #1: 1	حُكْمَ التَّعْقِيبِ
u'حُكْمٌ تَعْلِيقٌ':Added, #1: 1	حُكْمُ التَّعَلُّقِ
u'حُكْمٌ تَعْلِيقٌ':Added, #2: 2	حُكْمَ التَّعْلِيقِ
u'حُكْمٌ تَعْلِيقٌ':Added, #2: 2	حُكْمِ التَّعْلِيقِ
u'حُكْمٌ تَعْوِيلٌ':Added, #7: 7	حُكْمُ التَّعْلِيقِ
u'حُكْمٌ تَعْيِينٌ':Added, #2: 2	حُكْمِ التَّعْوِيلِ
u'حُكْمٌ تَغْلِيظٌ':Added, #1: 1	حُكْمُ التَّعْيِينِ
u'حُكْمٌ تَغَيُّرٌ':Added, #3: 3	حُكْمَ التَّغْلِيظِ
u'حُكْمٌ تَغْيِيرٌ':Added, #1: 1	حُكْمُ تَغَيُّرٍ
u'حُكْمٌ تَغْيِيرٌ':Added, #1: 1	حُكْمَ التَّغْيِيرِ
u'حُكْمٌ تَفَرُّدٌ':Added, #1: 1	حُكْمُ تَغْيِيرِهِ
u'حُكْمٌ تَفْرِقَة':Added, #1: 1	حُكْمُ التَّفَرُّدِ
u'حُكْمٌ تَفْرِيقٌ':Added, #2: 2	حُكْمَ التَّفْرِقَةِ
u'حُكْمٌ تَفْوِيت':Added, #1: 1	حُكْمُ التَّفْرِيقِ
u'حُكْمٌ تَقَبُّلٌ':Added, #1: 1	حُكْمَ التَّفْوِيتِ
u'حُكْمٌ تَقْديرٌ':Added, #1: 1	حُكْمِ تَقَبُّلِهِ
u'حُكْمٌ تَقْديمٌ':Added, #2: 2	حُكْمِ تَقْدِيرِ
u'حُكْمٌ تَقْديمٌ':Added, #1: 1	حُكْمُ التَّقْدِيمِ
u'حُكْمٌ تَقْديمٌ':Added, #1: 1	حُكْمِ التَّقْدِيمِ
u'حُكْمٌ تَقْديمٌ':Added, #1: 1	حُكْمَ تَقْدِيمِ
u'حُكْمٌ تَقْليدٌ':Added, #1: 1	حُكْمِ تَقْدِيمِ
u'حُكْمٌ تَقْليد':Added, #1: 1	حُكْمُ التَّقْلِيدِ
u'حُكْمٌ تَقِيٌّ':Added, #1: 1	حُكْمُ التَّقْلِيدِ
u'حُكْمٌ تَقِيَّةٌ':Added, #1: 1	حُكْمِ التَّقِيَّةِ
u'حُكْمٌ تَقْيِيد':Added, #1: 1	حُكْمِ التَّقِيَّةِ
u'حُكْمٌ تَكْبيرٌ':Added, #4: 4	حُكْمُ التَّقْيِيدِ
u'حُكْمٌ تَكْبيرٌ':Added, #1: 1	حُكْمَ التَّكْبِيرِ
u'حُكْمٌ تَكْرارٌ':Added, #1: 1	حُكْمُ التَّكْبِيرِ
u'حُكْمٌ تَكْفيرٌ':Added, #1: 1	حُكْمُ تَكْرَارِ
u'حُكْمٌ تَكَلُّمٌ':Added, #1: 1	حُكْمُ تَكْفِيرِهِ
u'حُكْمٌ تَكْليفٌ':Added, #1: 1	حُكْمُ التّكَلّمِ
u'حُكْمٌ تَكْليفٌ':Added, #1: 1	حُكْمَ التَّكْلِيفِ
u'حُكْمٌ تَكْليفٌ':Added, #1: 1	حُكْمُ التَّكْلِيفِ
u'حُكْمٌ تَكْليمٌ':Added, #2: 2	حُكْمِ التَّكْلِيفِ
u'حُكْمٌ تَكْميلٌ':Added, #1: 1	حُكْمَ التَّكْلِيمِ
u'حُكْمٌ تِلاوَةٌ':Added, #1: 1	حُكْمُ تَكْمِيلِ
u'حُكْمٌ تِلاوَةٌ':Added, #1: 1	حُكْمُ التِّلَاوَةِ
u'حُكْمٌ تِلاوَةٌ':Added, #1: 1	حُكْمِ التِّلَاوَةِ
u'حُكْمٌ تَلَف':Added, #2: 2	حُكْمُ التّلَاوَةِ
u'حُكْمٌ تَلَفٌ':Added, #1: 1	حُكْمُ التَّلَفِ
u'حُكْمٌ تمام':Added, #1: 1	حُكْمُ تَلَفِ
u'حُكْمٌ تَمامٌ':Added, #1: 1	حُكْمُ تَمَامِ
u'حُكْمٌ تَمَتُّعٌ':Added, #1: 1	حُكْمُ تَمَامِ
u'حُكْمٌ تَمْر':Added, #1: 1	حُكْمُ تَمَتُّعَاتِهِ
u'حُكْمٌ تَمْريضٌ':Added, #1: 1	حُكْمُ التَّمْرِ
u'حُكْمٌ تَمَلُّكٌ':Added, #1: 1	حُكْمُ تَمْرِيضِ
u'حُكْمٌ تَمْلِيك':Added, #1: 1	حُكْمِ تَمَلُّكِ
u'حُكْمٌ تَمْلِيك':Added, #1: 1	حُكْمَ التَّمْلِيكِ
u'حُكْمٌ تَمْلِيك':Added, #1: 1	حُكْمِ التَّمْلِيكِ
u'حُكْمٌ تَمْييزٌ':Added, #2: 2	حُكْمُ التَّمْلِيكِ
u'حُكْمٌ تَنَاصُرٌ':Added, #1: 1	حُكْمِ التَّمْيِيزِ
u'حُكْمٌ تَنَاوُلٌ':Added, #1: 1	حُكْمَ التَّنَاصُرِ
u'حُكْمٌ تَنَاوُلٌ':Added, #1: 1	حُكْمُ تَنَاوُلِ
u'حُكْمٌ تَنجُّسٌ':Added, #1: 1	حُكْمِ تَنَاوُلِ
u'حُكْمٌ تَنْحِيَةٌ':Added, #1: 1	حُكْمَ تَنَجُّسِ
u'حُكْمٌ تَنَصُّفٌ':Added, #1: 1	حُكْمِ تَنْحِيَةِ
u'حُكْمٌ تَنْصِيفٌ':Added, #1: 1	حُكْمَ التَّنَصُّفِ
u'حُكْمٌ تَنَفُّلٌ':Added, #1: 1	حُكْمَ التَّنْصِيفِ
u'حُكْمٌ تَنَفُّلٌ':Added, #1: 1	حُكْمَ التَّنَفُّلِ
u'حُكْمٌ تَنْفِيلٌ':Added, #2: 2	حُكْمُ التَّنَفُّلِ
u'حُكْمٌ تَنْكِيسٌ':Added, #3: 3	حُكْمُ التَّنْفِيلِ
u'حُكْمٌ تَوْبَةٌ':Added, #1: 1	حُكْمُ تَنْكِيسِ
u'حُكْمٌ تَوَثُّقٌ':Added, #1: 1	حُكْمُ تَوْبَةِ
u'حُكْمٌ تَوْثِقَة':Added, #1: 1	حُكْمُ التَّوَثُّقِ
u'حُكْمٌ تَوْرَاةٌ':Added, #1: 1	حُكْمُ التَّوْثِقَةِ
u'حُكْمٌ تَوْرَاةٌ':Added, #1: 1	حُكْمَ التّوْرَاةِ
u'حُكْمٌ تَوْرِيث':Added, #1: 1	حُكْمِ التّوْرَاةِ
u'حُكْمٌ تَوْرِيث':Added, #1: 1	حُكْمُ التَّوْرِيثِ
u'حُكْمٌ تَوْرِيث':Added, #1: 1	حُكْمِ التَّوْرِيثِ
u'حُكْمٌ تَوْزِيعٌ':Added, #2: 2	حُكْمَ التَّوْرِيثِ
u'حُكْمٌ تَوْظِيفٌ':Added, #1: 1	حُكْمِ التَّوْزِيعِ
u'حُكْمٌ تَوَقُّفٌ':Added, #1: 1	حُكْمِ التَّوْظِيفِ
u'حُكْمٌ تَوْقِيعٌ':Added, #1: 1	حُكْمِ تَوَقُّفِ
u'حُكْمٌ تَوْكِيلٌ':Added, #1: 1	حُكْمُ تَوْقِيعِهِ
u'حُكْمٌ تَوْكِيلٌ':Added, #1: 1	حُكْمَ التَّوْكِيلِ
u'حُكْمٌ تَوْلِيَةٌ':Added, #1: 1	حُكْمُ تَوْكِيلِ
u'حُكْمٌ تَوْلِيَةٌ':Added, #1: 1	حُكْمِ تَوْلِيَةِ
u'حُكْمٌ تَيَمُّمٌ':Added, #2: 2	حُكْمُ تَوْلِيَةِ
u'حُكْمٌ تَيَمُّمٌ':Added, #1: 1	حُكْمَ التَّيَمُّمِ
u'حُكْمٌ تَيَمُّمٌ':Added, #1: 1	حُكْمَ تَيَمُّمِ
u'حُكْمٌ تَيَمُّمٌ':Added, #1: 1	حُكْمُ تَيَمُّمِهِ
u'حُكْمٌ تَيَمُّمٌ':Added, #2: 2	حُكْمِ التَّيَمُّمِ
u'حُكْمٌ تَيَمُّمٌ':Added, #2: 2	حُكْمِ تَيَمُّمِ
u'حُكْمٌ ثَابِتٌ':Added, #6: 6	حُكْمُ التَّيَمُّمِ
u'حُكْمٌ ثَالِثٌ':Added, #3: 3	حُكْمٍ ثَابِتٍ
u'حُكْمٌ ثَالِثٌ':Added, #1: 1	حُكْمَ الثَّالِثِ
u'حُكْمٌ ثَالِثٌ':Added, #1: 1	حُكْمُ الثَّالِثَةِ
u'حُكْمٌ ثَانِي':Added, #1: 1	حُكْمِ الثَّالِثَةِ
u'حُكْمٌ ثَانِي':Added, #2: 2	حُكْمَ الثَّانِيَةِ
u'حُكْمٌ ثَانِيَةٌ':Added, #3: 3	حُكْمِ الثَّانِيَةِ
u'حُكْمٌ ثَانِيَةٌ':Added, #2: 2	حُكْمَ الثَّانِيَةِ
u'حُكْمٌ ثُبُوتٌ':Added, #3: 3	حُكْمِ الثَّانِيَةِ
u'حُكْمٌ ثُبُوتٌ':Added, #1: 1	حُكْمِ الثُّبُوتِ
u'حُكْمٌ ثُبُوتٌ':Added, #1: 1	حُكْمُ ثُبُوتِ
u'حُكْمٌ ثَعْلَبٌ':Added, #3: 3	حُكْمِ ثُبُوتِ
u'حُكْمٌ ثَلاثُ':Added, #1: 1	حُكْمُ الثَّعْلَبِ
u'حُكْمٌ ثَلاثَةٌ':Added, #1: 1	حُكْمُ الثَّلَاثِ
u'حُكْمٌ ثَمَرٌ':Added, #2: 2	حُكْمُ الثَّلَاثَةِ
u'حُكْمٌ ثَمَرٌ':Added, #1: 1	حُكْمُ ثَمَرِ
u'حُكْمٌ ثَمَرٌ':Added, #1: 1	حُكْمِ ثَمَرِ
u'حُكْمٌ ثَمَرَةٌ':Added, #2: 2	حُكْمُ الثَّمَرِ
u'حُكْمٌ ثَمَرَةٌ':Added, #1: 1	حُكْمُ ثَمَرَةِ
u'حُكْمٌ ثَمَنٌ':Added, #4: 4	حُكْمُ الثَّمَرَةِ
u'حُكْمٌ ثَمَنٌ':Added, #1: 1	حُكْمَ الثَّمَنِ
u'حُكْمٌ ثَمَنٌ':Added, #1: 1	حُكْمِ الثَّمَنِ
u'حُكْمٌ ثَمَنٌ':Added, #1: 1	حُكْمُ ثَمَنِ
u'حُكْمٌ ثَمَنٌ':Added, #2: 2	حُكْمَ ثَمَنِ
u'حُكْمٌ ثَوابٌ':Added, #3: 3	حُكْمُ الثَّمَنِ
u'حُكْمٌ ثَوْبٌ':Added, #2: 2	حُكْمِ الثَّوَابِ
u'حُكْمٌ ثَوْبٌ':Added, #1: 1	حُكْمُ ثَوْبٍ
u'حُكْمٌ ثَوْبٌ':Added, #1: 1	حُكْمِ ثَوْبٍ
u'حُكْمٌ ثَوْبٌ':Added, #1: 1	حُكْمَ ثَوْبَيْنِ
u'حُكْمٌ ثَوْبٌ':Added, #1: 1	حُكْمِ ثَوْبَيْنِ
u'حُكْمٌ ثِيابٌ':Added, #2: 2	حُكْمُ الثَّوْبِ
u'حُكْمٌ ثِيابٌ':Added, #1: 1	حُكْمَ الثِّيَابِ
u'حُكْمٌ ثِيابٌ':Added, #1: 1	حُكْمِ الثِّيَابِ
u'حُكْمٌ ثَيِّبٌ':Added, #3: 3	حُكْمُ الثِّيَابِ
u'حُكْمٌ ثَيِّبٌ':Added, #1: 1	حُكْمُ الثَّيِّبِ
u'حُكْمٌ جَارِي':Added, #1: 1	حُكْمِ الثَّيِّبِ
u'حُكْمٌ جَارِيَةٌ':Added, #4: 4	حُكْمُ الْجَارِيَةِ
u'حُكْمٌ جَاهِلٌ':Added, #4: 4	حُكْمُ الْجَارِيَةِ
u'حُكْمٌ جَاهِلٌ':Added, #1: 1	حُكْمَ الْجَاهِلِ
u'حُكْمٌ جَاهِلٌ':Added, #1: 1	حُكْمُ جَاهِلٍ
u'حُكْمٌ جَاهِلِيٌّ':Added, #4: 4	حُكْمُ الْجَاهِلِ
u'حُكْمٌ جَاهِلِيٌّ':Added, #1: 1	حُكْمَ الْجَاهِلِيَّةِ
u'حُكْمٌ جَاهِلِيَّةٌ':Added, #3: 3	حُكْمِ الْجَاهِلِيَّةِ
u'حُكْمٌ جَاهِلِيَّةٌ':Added, #1: 1	حُكْمَ الْجَاهِلِيَّةِ
u'حُكْمٌ جَائِحٌ':Added, #3: 3	حُكْمِ الْجَاهِلِيَّةِ
u'حُكْمٌ جَائِحٌ':Added, #1: 1	حُكْمُ الْجَائِحَةِ
u'حُكْمٌ جاَئِحَةٌ':Added, #1: 1	حُكْمِ الْجَائِحَةِ
u'حُكْمٌ جاَئِحَةٌ':Added, #1: 1	حُكْمُ الْجَائِحَةِ
u'حُكْمٌ جَائِرٌ':Added, #1: 1	حُكْمِ الْجَائِحَةِ
u'حُكْمٌ جَائِرٌ':Added, #1: 1	حُكْمُ جَائِرٍ
u'حَكَمَ جَبَّارٌ':Subject, #2: 2	حُكْمٍ جَائِرٍ
u'حُكْمٌ جَبِيرَة':Added, #1: 1	حَكَمَ الْجَبَّارُ
u'حُكْمٌ جَبِيرَة':Added, #1: 1	حُكْمُ الْجَبِيرَةِ
u'حُكْمٌ جِدار':Added, #1: 1	حُكْمِ الْجَبِيرَةِ
u'حُكْمٌ جِدار':Added, #1: 1	حُكْمُ الْجِدَارِ
u'حُكْمٌ جَرٌّ':Added, #1: 1	حُكْمُ جِدَارِ
u'حُكْمٌ جَرٌّ':Added, #1: 1	حُكْمَ الْجَرِّ
u'حُكْمٌ جُرْأَةٌ':Added, #1: 1	حُكْمَ جَرِّ
u'حُكْمٌ جراح':Added, #1: 1	حُكْمُ الْجُرْأَةِ
u'حُكْمٌ جِرَاحٌ':Added, #2: 2	حُكْمُ الْجِرَاحِ
u'حُكْمٌ جِرَاحَاتٌ':Added, #2: 2	حُكْمُ الْجِرَاحِ
u'حُكْمٌ جِرَاحَةٌ':Added, #1: 1	حُكْمُ الْجِرَاحَاتِ
u'حُكْمٌ جَرَادٌ':Added, #1: 1	حُكْمُ الْجِرَاحَاتِ
u'حُكْمٌ جَرَيان':Added, #1: 1	حُكْمُ الْجَرَادِ
u'حُكْمٌ جُزْءٌ':Added, #1: 1	حُكْمُ الْجَرَيَانِ
u'حُكْمٌ جُزْءٌ':Added, #12: 12	حُكْمِ جُزْءٍ
u'حُكْمٌ جُزْءٌ':Added, #1: 1	حُكْمُ الْجُزْءِ
u'حُكْمٌ جَزَاءٌ':Added, #9: 9	حُكْمِ الْجُزْءِ
u'حُكْمٌ جَزَاءٌ':Added, #1: 1	حُكْمَ جَزَاءِ
u'حُكْمٌ جَزَاءٌ':Added, #1: 1	حُكْمُ جَزَاءِ
u'حُكْمٌ جَزَاءٌ':Added, #2: 2	حُكْمُ الْجَزَاءِ
u'حُكْمٌ جِزْيَةٌ':Added, #3: 3	حُكْمِ الْجَزَاءِ
u'حُكْمٌ جِزْيَةٌ':Added, #1: 1	حُكْمُ الْجِزْيَةِ
u'حُكْمٌ جُعَلٌ':Added, #2: 2	حُكْمِ الْجِزْيَةِ
u'حُكْمٌ جُعَلٌ':Added, #1: 1	حُكْمَ الْجُعَلِ
u'حُكْمٌ جِلْدَةٌ':Added, #1: 1	حُكْمِ الْجُعَلِ
u'حُكْمٌ جلسة':Added, #1: 1	حُكْمُ جِلْدَةِ
u'حُكْمٌ جِلْسَةٌ':Added, #1: 1	حُكْمُ الْجِلْسَةِ
u'حُكْمٌ جُلُودٌ':Added, #1: 1	حُكْمُ الْجِلْسَةِ
u'حُكْمٌ جُلُوسٌ':Added, #1: 1	حُكْمَ جُلُودِ
u'حُكْمٌ جُلُوسٌ':Added, #1: 1	حُكْمُ الْجُلُوسِ
u'حُكْمٌ جَلِيٌّ':Added, #2: 2	حُكْمَ الْجُلُوسِ
u'حُكْمٌ جماع':Added, #1: 1	حُكْمُ الْجَلِيَّةِ
u'حُكْمٌ جِمَاعٌ':Added, #1: 1	حُكْمُ الْجِمَاعِ
u'حُكْمٌ جَمَاعَةٌ':Added, #1: 1	حُكْمُ الْجِمَاعِ
u'حُكْمٌ جَمَاعَةٌ':Added, #1: 1	حُكْمَ الْجَمَاعَةِ
u'حُكْمٌ جَمَاعَةٌ':Added, #3: 3	حُكْمُ الْجَمَاعَةِ
u'حُكْمٌ جمع':Added, #5: 5	حُكْمِ الْجَمَاعَةِ
u'حُكْمٌ جَمْعٌ':Added, #1: 1	حُكْمَ جَمْعِ
u'حُكْمٌ جمع':Added, #1: 1	حُكْمَ جَمْعِ
u'حُكْمٌ جَمْعٌ':Added, #2: 2	حُكْمُ الْجَمْعِ
u'حُكْمٌ جمع':Added, #2: 2	حُكْمُ الْجَمْعِ
u'حُكْمٌ جَمْعٌ':Added, #2: 2	حُكْمُ جَمْعِ
u'حُكْمٌ جمع':Added, #2: 2	حُكْمُ جَمْعِ
u'حُكْمٌ جمع':Added, #3: 3	حُكْمَ الْجَمْعِ
u'حُكْمٌ جَمْعٌ':Added, #3: 3	حُكْمِ الْجَمْعِ
u'حُكْمٌ جَمْعٌ':Added, #3: 3	حُكْمَ الْجَمْعِ
u'حُكْمٌ جمعة':Added, #3: 3	حُكْمِ الْجَمْعِ
u'حُكْمٌ جمعة':Added, #2: 2	حُكْمُ الْجُمُعَةِ
u'حُكْمٌ جُمُعَةٌ':Added, #2: 2	حُكْمِ الْجُمُعَةِ
u'حُكْمٌ جُمُعَةٌ':Added, #2: 2	حُكْمُ الْجُمُعَةِ
u'حُكْمٌ جُمْلَةٌ':Added, #2: 2	حُكْمِ الْجُمُعَةِ
u'حُكْمٌ جَمِيع':Added, #2: 2	حُكْمِ الْجُمْلَةِ
u'حُكْمٌ جَمِيع':Added, #2: 2	حُكْمُ الْجَمِيعِ
u'حُكْمٌ جَنَابَةٌ':Added, #3: 3	حُكْمَ الْجَمِيعِ
u'حُكْمٌ جَنَابَةٌ':Added, #2: 2	حُكْمِ الْجَنَابَةِ
u'حُكْمٌ جَنَابَةٌ':Added, #4: 4	حُكْمُ الْجَنَابَةِ
u'حُكْمٌ جناح':Added, #6: 6	حُكْمَ الْجَنَابَةِ
u'حُكْمٌ جَنَاحٌ':Added, #1: 1	حُكْمُ الْجَنَاحِ
u'حُكْمٌ جِنَايَةٌ':Added, #1: 1	حُكْمُ الْجَنَاحِ
u'حُكْمٌ جِنَايَةٌ':Added, #15: 15	حُكْمُ الْجِنَايَةِ
u'حُكْمٌ جِنَايَةٌ':Added, #1: 1	حُكْمُ جِنَايَةٍ
u'حُكْمٌ جِنَايَةٌ':Added, #2: 2	حُكْمِ جِنَايَةِ
u'حُكْمٌ جِنَايَةٌ':Added, #2: 2	حُكْمَ جِنَايَتِهِ
u'حُكْمٌ جِنَايَةٌ':Added, #3: 3	حُكْمَ الْجِنَايَةِ
u'حُكْمٌ جِنَايَةٌ':Added, #6: 6	حُكْمُ جِنَايَتِهِ
u'حُكْمٌ جِنَايَةٌ':Added, #7: 7	حُكْمِ الْجِنَايَةِ
u'حُكْمٌ جِنْسٌ':Added, #8: 8	حُكْمُ جِنَايَةِ
u'حُكْمٌ جِنْسٌ':Added, #1: 1	حُكْمَ الْجِنْسَيْنِ
u'حُكْمٌ جِنْسٌ':Added, #1: 1	حُكْمُ الْجِنْسَيْنِ
u'حُكْمٌ جِنْسٌ':Added, #1: 1	حُكْمِ الْجِنْسَيْنِ
u'حُكْمٌ جِنْسٌ':Added, #1: 1	حُكْمَ جِنْسِ
u'حُكْمٌ جُنُونٌ':Added, #2: 2	حُكْمِ الْجِنْسِ
u'حُكْمٌ جُنُونٌ':Added, #1: 1	حُكْمُ الْجُنُونِ
u'حُكْمٌ جَنِينٌ':Added, #1: 1	حُكْمِ الْجُنُونِ
u'حُكْمٌ جَنِينٌ':Added, #1: 1	حُكْمُ الْجَنِينِ
u'حُكْمٌ جهاد':Added, #1: 1	حُكْمِ الْجَنِينِ
u'حُكْمٌ جِهَادٌ':Added, #2: 2	حُكْمِ الْجِهَادِ
u'حُكْمٌ جِهَةٌ':Added, #2: 2	حُكْمِ الْجِهَادِ
u'حُكْمٌ جهر':Added, #1: 1	حُكْمُ جِهَتِهِ
u'حُكْمٌ جهر':Added, #1: 1	حُكْمَ الْجَهْرِ
u'حُكْمٌ جَهْرٌ':Added, #1: 1	حُكْمُ الْجَهْرِ
u'حُكْمٌ جَهْرٌ':Added, #1: 1	حُكْمَ الْجَهْرِ
u'حُكْمٌ جهل':Added, #1: 1	حُكْمُ الْجَهْرِ
u'حُكْمٌ جَهْلٌ':Added, #1: 1	حُكْمُ جَهْلِ
u'حُكْمٌ جهل':Added, #1: 1	حُكْمُ جَهْلِ
u'حُكْمٌ جَهْلٌ':Added, #2: 2	حُكْمُ الْجَهْلِ
u'حُكْمٌ جَوَابٌ':Added, #2: 2	حُكْمُ الْجَهْلِ
u'حُكْمٌ جَوَازٌ':Added, #1: 1	حُكْمَ جَوَابِ
u'حُكْمٌ جَوَازٌ':Added, #1: 1	حُكْمَ الْجَوَازِ
u'حُكْمٌ جَوَازٌ':Added, #1: 1	حُكْمِ جَوَازِهِ
u'حُكْمٌ جَوَازٌ':Added, #2: 2	حُكْمَ جَوَازِ
u'حُكْمٌ جَوَازٌ':Added, #2: 2	حُكْمُ جَوَازِ
u'حُكْمٌ جَوَازٌ':Added, #3: 3	حُكْمُ الْجَوَازِ
u'حُكْمٌ جَوَازٌ':Added, #3: 3	حُكْمِ الْجَوَازِ
u'حُكْمٌ جَوَاهِرُ':Added, #4: 4	حُكْمِ جَوَازِ
u'حُكْمٌ جَوَاهِرُ':Added, #1: 1	حُكْمُ الْجَوَاهِرِ
u'حُكْمٌ جُوعٌ':Added, #1: 1	حُكْمِ الْجَوَاهِرِ
u'حُكْمٌ جوف':Added, #2: 2	حُكْمُ الْجُوعِ
u'حُكْمٌ جَوْفٌ':Added, #1: 1	حُكْمُ الْجَوْفِ
u'حُكْمٌ جوف':Added, #1: 1	حُكْمُ الْجَوْفِ
u'حُكْمٌ جَوْفٌ':Added, #1: 1	حُكْمِ جَوْفِ
u'حُكْمٌ حاجٌّ':Added, #1: 1	حُكْمِ جَوْفِ
u'حُكْمٌ حادِثٌ':Added, #1: 1	حُكْمُ الْحَاجِّ
u'حُكْمٌ حادِثٌ':Added, #10: 10	حُكْمِ الْحَادِثَةِ
u'حُكْمٌ حادِثٌ':Added, #1: 1	حُكْمِ الْحَادِثِ
u'حُكْمٌ حادِثٌ':Added, #1: 1	حُكْمَ حَادِثَةٍ
u'حُكْمٌ حادِثٌ':Added, #1: 1	حُكْمُ حَادِثَةٍ
u'حُكْمٌ حادِثٌ':Added, #3: 3	حُكْمُ الْحَادِثَةِ
u'حُكْمٌ حاصِلٌ':Added, #6: 6	حُكْمِ حَادِثَةٍ
u'حُكْمٌ حاضِرٌ':Added, #1: 1	حُكْمِ الْحَاصِلِ
u'حُكْمٌ حاضِرٌ':Added, #1: 1	حُكْمَ الْحَاضِرِ
u'حُكْمٌ حاضِرٌ':Added, #2: 2	حُكْمُ الْحَاضِرَةِ
u'حُكْمٌ حافِظٌ':Added, #5: 5	حُكْمِ الْحَاضِرِ
u'حَكَمَ حاكِمٌ':Subject, #1: 1	حُكْمَ حَافِظِ
u'حَكَمَ حاكِمٌ':Subject, #49: 49	حَكَمَ الْحَاكِمُ
u'حُكْمٌ حاكِمٌ':Added, #52: 52	حَكَمَ حَاكِمٌ
u'حُكْمٌ حاكِمٌ':Added, #19: 19	حُكْمُ حَاكِمٍ
u'حُكْمٌ حاكِمٌ':Added, #1: 1	حُكْمَ حَاكِمٍ
u'حُكْمٌ حاكِمٌ':Added, #34: 34	حُكْمِ حَاكِمٍ
u'حُكْمٌ حاكِمٌ':Added, #54: 54	حُكْمُ الْحَاكِمِ
u'حُكْمٌ حاكِمٌ':Added, #73: 73	حُكْمِ الْحَاكِمِ
u'حُكْمٌ حالٌ':Added, #88: 88	حُكْمَ الْحَاكِمِ
u'حُكْمٌ حالٌ':Added, #1: 1	حُكْمُ الْحَالِ
u'حُكْمٌ حالٌ':Added, #1: 1	حُكْمِ الْحَالَيْنِ
u'حُكْمٌ حالٌ':Added, #1: 1	حُكْمِ حَالِ
u'حُكْمٌ حالَةٌ':Added, #3: 3	حُكْمِ الْحَالِ
u'حُكْمٌ حالَةٌ':Added, #1: 1	حُكْمُ الْحَالَةِ
u'حُكْمٌ حالَةٌ':Added, #1: 1	حُكْمَ حَالَةِ
u'حُكْمٌ حالِق':Added, #1: 1	حُكْمِ حَالَةٍ
u'حُكْمٌ حالِيٌّ':Added, #1: 1	حُكْمُ الْحَالِقِ
u'حُكْمٌ حامِلٌ':Added, #1: 1	حُكْمُ الْحَالِيِّ
u'حُكْمٌ حانوتٌ':Added, #2: 2	حُكْمُ الْحَامِلِ
u'حُكْمٌ حائِضٌ':Added, #1: 1	حُكْمُ الْحَانُوتِ
u'حُكْمٌ حائِضٌ':Added, #1: 1	حُكْمَ الْحَائِضِ
u'حُكْمٌ حائِضٌ':Added, #1: 1	حُكْمِ الْحَائِضِ
u'حُكْمٌ حائِلٌ':Added, #5: 5	حُكْمُ الْحَائِضِ
u'حُكْمٌ حَبٌّ':Added, #1: 1	حُكْمُ حَائِلٍ
u'حُكْمٌ حَبَّةٌ':Added, #1: 1	حُكْمِ حَبَّاتِهِ
u'حُكْمٌ حَبْسٌ':Added, #1: 1	حُكْمِ حَبَّاتِهِ
u'حُكْمٌ حُبُسٌ':Added, #1: 1	حُكْمُ الْحَبْسِ
u'حُكْمٌ حَبْلٌ':Added, #1: 1	حُكْمِ الْحُبُسِ
u'حُكْمٌ حَجٌّ':Added, #1: 1	حُكْمُ الْحَبْلِ
u'حُكْمٌ حَجٌّ':Added, #1: 1	حُكْمِ الْحَجِّ
u'حُكْمٌ حجاب':Added, #4: 4	حُكْمُ الْحَجِّ
u'حُكْمٌ حِجابٌ':Added, #1: 1	حُكْمِ الْحِجَابِ
u'حُكْمٌ حَجَرٌ':Added, #1: 1	حُكْمِ الْحِجَابِ
u'حُكْمٌ حَجْرٌ':Added, #1: 1	حُكْمِ الْحَجَرِ
u'حُكْمٌ حَجْرٌ':Added, #1: 1	حُكْمُ الْحَجْرِ
u'حُكْمٌ حَدٌّ':Added, #2: 2	حُكْمِ الْحَجْرِ
u'حُكْمٌ حَدَثٌ':Added, #2: 2	حُكْمُ الْحَدِّ
u'حُكْمٌ حَدَثٌ':Added, #1: 1	حُكْمُ الْحَدَثَيْنِ
u'حُكْمٌ حَدَثٌ':Added, #1: 1	حُكْمِ الْحَدَثَيْنِ
u'حُكْمٌ حَدَثٌ':Added, #8: 8	حُكْمِ الْحَدَثِ
u'حُكْمٌ حَدَثٌ':Added, #9: 9	حُكْمَ الْحَدَثِ
u'حُكْمٌ حُدودٌ':Added, #9: 9	حُكْمُ الْحَدَثِ
u'حُكْمٌ حَديثٌ':Added, #1: 1	حُكْمِ الْحُدُودِ
u'حُكْمٌ حَديثٌ':Added, #1: 1	حُكْمُ الْحَدِيثِ
u'حُكْمٌ حُرٌّ':Added, #2: 2	حُكْمِ الْحَدِيثِ
u'حُكْمٌ حُرٌّ':Added, #1: 1	حُكْمَ الْحُرِّ
u'حُكْمٌ حُرٌّ':Added, #1: 1	حُكْمُ حُرٍّ
u'حُكْمٌ حَرامٌ':Added, #8: 8	حُكْمُ الْحُرِّ
u'حُكْمٌ حَرائِرُ':Added, #1: 1	حُكْمَ الْحَرَامِ
u'حُكْمٌ حَرائِرُ':Added, #1: 1	حُكْمَ الْحَرَائِرِ
u'حُكْمٌ حَرَائِرُ':Added, #1: 1	حُكْمُ الْحَرَائِرِ
u'حُكْمٌ حَرَائِرُ':Added, #1: 1	حُكْمَ الْحَرَائِرِ
u'حُكْمٌ حَرَكَةٌ':Added, #1: 1	حُكْمُ الْحَرَائِرِ
u'حَكَّ مُحْرِمٌ':Subject, #1: 1	حُكْمُ حَرَكَاتِ
u'حُكْمٌ حَرَمٌ':Added, #1: 1	حَكَّ الْمُحْرِمُ
u'حُكْمٌ حَرَمٌ':Added, #1: 1	حُكْمَ الْحَرَمِ
u'حُكْمٌ حَرَمٌ':Added, #3: 3	حُكْمُ الْحَرَمِ
u'حُكْمٌ حُرْمَةٌ':Added, #6: 6	حُكْمُ حَرَمِ
u'حُكْمٌ حُرْمَةٌ':Added, #1: 1	حُكْمِ الْحُرْمَةِ
u'حُكْمٌ حَرِيرٌ':Added, #2: 2	حُكْمُ الْحُرْمَةِ
u'حُكْمٌ حَرِيمٌ':Added, #1: 1	حُكْمُ الْحَرِيرِ
u'حُكْمٌ حَسْمٌ':Added, #1: 1	حُكْمُ الْحَرِيمِ
u'حُكْمٌ حَشَرَةٌ':Added, #1: 1	حُكْمَ الْحَسْمِ
u'حُكْمٌ حَشِيشٌ':Added, #1: 1	حُكْمِ الْحَشَرَاتِ
u'حُكْمٌ حِصَّةٌ':Added, #1: 1	حُكْمِ الْحَشِيشَةِ
u'حُكْمٌ حَصْرٌ':Added, #1: 1	حُكْمَ الْحِصَّةِ
u'حُكْمٌ حَصْرٌ':Added, #1: 1	حُكْمُ الْحَصْرِ
u'حُكْمٌ حَضَرٌ':Added, #2: 2	حُكْمُ حَصْرِ
u'حُكْمٌ حَضَرٌ':Added, #1: 1	حُكْمَ الْحَضَرِ
u'حُكْمٌ حَضَرٌ':Added, #1: 1	حُكْمُ الْحَضَرِ
u'حُكْمٌ حُضورٌ':Added, #2: 2	حُكْمِ الْحَضَرِ
u'حُكْمٌ حُضُورٌ':Added, #1: 1	حُكْمُ حُضُورِ
u'حُكْمٌ حَطّ':Added, #1: 1	حُكْمُ حُضُورِ
u'حُكْمٌ حَظْر':Added, #2: 2	حُكْمُ الْحَطِّ
u'حُكْمٌ حَفْنَةٌ':Added, #1: 1	حُكْمُ الْحَظْرِ
u'حُكْمٌ حَقٌّ':Added, #4: 4	حُكْمِ الْحَفْنَةِ
u'حُكْمٌ حقائق':Added, #1: 1	حُكْمَ حَقِّ
u'حُكْمٌ حَقَائِقُ':Added, #2: 2	حُكْمُ الْحَقَائِقِ
u'حُكْمٌ حَقِيقٌ':Added, #2: 2	حُكْمُ الْحَقَائِقِ
u'حُكْمٌ حَقِيقٌ':Added, #1: 1	حُكْمُ الْحَقِيقَةِ
u'حُكْمٌ حَقِيقَةٌ':Added, #2: 2	حُكْمِ الْحَقِيقَةِ
u'حُكْمٌ حَقِيقَةٌ':Added, #1: 1	حُكْمُ الْحَقِيقَةِ
u'حُكْمٌ حُكَّامٌ':Added, #2: 2	حُكْمِ الْحَقِيقَةِ
u'حَكَمَ حَكَمٌ':Predicate, #2: 2	حُكْمُ الْحُكَّامِ
u'حَكَمَ حَكَمٌ':Subject, #2: 2	حَكَمَ حَكَمَ
u'حَكَمَ حَكَمٌ':Subject, #1: 1	حَكَمَ الْحَكَمُ
u'حُكْمٌ حَكَمٌ':Added, #1: 1	حَكَمَ حَكَمٌ
u'حُكْمٌ حُكْمٌ':Added, #1: 1	حُكْمُ الْحَكَمِ
u'حُكْمٌ حَكَمٌ':Added, #1: 1	حُكْمَ الْحُكْمِ
u'حُكْمٌ حُكْمٌ':Added, #1: 1	حُكْمِ الْحَكَمَيْنِ
u'حُكْمٌ حُكْمٌ':Added, #2: 2	حُكْمِ الْحُكْمِ
u'حُكْمٌ حَكَمٌ':Added, #2: 2	حُكْمُ حُكْمِ
u'حِكَمٌ حكماء':Added, #5: 5	حُكْمَ الْحَكَمِ
u'حُكْمٌ حِلٌّ':Added, #1: 1	حِكَمِ الْحُكَمَاءِ
u'حُكْمٌ حَلٌّ':Added, #1: 1	حُكْمَ الْحِلِّ
u'حُكْمٌ حِلٌّ':Added, #1: 1	حُكْمِ حَلِّ
u'حُكْمٌ حِلٌّ':Added, #1: 1	حُكْمَ حِلِّ
u'حُكْمٌ حِلٌّ':Added, #1: 1	حُكْمِ حِلِّ
u'حُكْمٌ حَلالٌ':Added, #2: 2	حُكْمِ الْحِلِّ
u'حُكْمٌ حُلْبَةٌ':Added, #1: 1	حُكْمِ الْحَلَالِ
u'حُكْمٌ حَلْقٌ':Added, #1: 1	حُكْمَ الْحُلْبَةِ
u'حُكْمٌ حَلْقٌ':Added, #1: 1	حُكْمَ الْحَلْقِ
u'حُكْمٌ حَلْقٌ':Added, #2: 2	حُكْمُ حَلْقِ
u'حُكْمٌ حَلْقَةٌ':Added, #3: 3	حُكْمُ الْحَلْقِ
u'حُكْمٌ حُلْقُومٌ':Added, #1: 1	حُكْمِ حَلْقَةٍ
u'حُكْمٌ حُلُولٌ':Added, #1: 1	حُكْمِ الْحُلْقُومِ
u'حُكْمٌ حُلِيٌّ':Added, #2: 2	حُكْمِ الْحُلُولِ
u'حُكْمٌ حُلِيٌّ':Added, #1: 1	حُكْمَ الْحُلِيِّ
u'حُكْمٌ حُلِيٌّ':Added, #1: 1	حُكْمُ الْحُلِيِّ
u'حُكْمٌ حَمَّامٌ':Added, #1: 1	حُكْمُ حُلِيِّ
u'حُكْمٌ حَمَّامٌ':Added, #1: 1	حُكْمَ الْحَمَّامِ
u'حُكْمٌ حَمْلٌ':Added, #1: 1	حُكْمُ الْحَمَّامِ
u'حُكْمٌ حَمْلٌ':Added, #1: 1	حُكْمِ الْحَمْلِ
u'حُكْمٌ حِنَّاءٌ':Added, #2: 2	حُكْمُ الْحَمْلِ
u'حُكْمٌ حِنَّاءٌ':Added, #1: 1	حُكْمُ الْحِنَّاءِ
u'حُكْمٌ حِنْثٌ':Added, #2: 2	حُكْمُ حِنَّاءِ
u'حُكْمٌ حِنْثٌ':Added, #2: 2	حُكْمُ الْحِنْثِ
u'حُكْمٌ حَوَالَةٌ':Added, #4: 4	حُكْمِ الْحِنْثِ
u'حُكْمٌ حَوْلٌ':Added, #2: 2	حُكْمَ الْحَوَالَةِ
u'حُكْمٌ حول':Added, #1: 1	حُكْمِ الْحَوْلَيْنِ
u'حُكْمٌ حَوْلٌ':Added, #20: 20	حُكْمُ الْحَوْلِ
u'حُكْمٌ حول':Added, #20: 20	حُكْمُ الْحَوْلِ
u'حُكْمٌ حَوْلٌ':Added, #4: 4	حُكْمَ الْحَوْلِ
u'حُكْمٌ حول':Added, #4: 4	حُكْمَ الْحَوْلِ
u'حُكْمٌ حَوْلٌ':Added, #5: 5	حُكْمِ الْحَوْلِ
u'حُكْمٌ حَيٌّ':Added, #5: 5	حُكْمِ الْحَوْلِ
u'حُكْمٌ حَيَاةٌ':Added, #1: 1	حُكْمِ الْحَيِّ
u'حُكْمٌ حَيَاةٌ':Added, #2: 2	حُكْمُ الْحَيَاةِ
u'حُكْمٌ حَيْضٌ':Added, #3: 3	حُكْمِ الْحَيَاةِ
u'حُكْمٌ حَيْضٌ':Added, #12: 12	حُكْمُ الْحَيْضِ
u'حُكْمٌ حَيْضٌ':Added, #1: 1	حُكْمِ الْحَيْضِ
u'حُكْمٌ حَيَوَانٌ':Added, #4: 4	حُكْمَ الْحَيْضِ
u'حُكْمٌ حَيَوَانٌ':Added, #1: 1	حُكْمُ الْحَيَوَانِ
u'حُكْمٌ حَيَوَانٌ':Added, #1: 1	حُكْمُ حَيَوَانِ
u'حُكْمٌ حَيَوَانٌ':Added, #1: 1	حُكْمُ حَيَوَانِهِ
u'حُكْمٌ خَارِجٌ':Added, #2: 2	حُكْمُ حَيَوَانٍ
u'حُكْمٌ خَارِجٌ':Added, #3: 3	حُكْمَ الْخَارِجِ
u'حُكْمٌ خاصّ':Added, #9: 9	حُكْمُ الْخَارِجِ
u'حُكْمٌ خاصّ':Added, #1: 1	حُكْمَ الْخَاصِّ
u'حُكْمٌ خاصّ':Added, #2: 2	حُكْمِ الْخَاصِّ
u'حُكْمٌ خَالِي':Added, #6: 6	حُكْمٍ خَاصٍّ
u'حُكْمٌ خَانٌ':Added, #1: 1	حُكْمُ الْخَالِيَةِ
u'حُكْمٌ خَبَرٌ':Added, #1: 1	حُكْمُ الْخَانِ
u'حُكْمٌ خَبَرٌ':Added, #1: 1	حُكْمَ الْخَبَرِ
u'حُكْمٌ خَبَر':Added, #1: 1	حُكْمِ الْخَبَرِ
u'حُكْمٌ خَبَر':Added, #1: 1	حُكْمَ الْخَبَرِ
u'حُكْمٌ خَبَرٌ':Added, #1: 1	حُكْمِ الْخَبَرِ
u'حُكْمٌ خَبَر':Added, #1: 1	حُكْمِ خَبَرِ
u'حُكْمٌ خَبَرٌ':Added, #1: 1	حُكْمِ خَبَرِ
u'حُكْمٌ خَبَر':Added, #2: 2	حُكْمُ الْخَبَرِ
u'حُكْمٌ ختان':Added, #2: 2	حُكْمُ الْخَبَرِ
u'حُكْمٌ خِتَانٌ':Added, #1: 1	حُكْمَ الْخِتَانِ
u'حُكْمٌ خراج':Added, #1: 1	حُكْمَ الْخِتَانِ
u'حُكْمٌ خَرَاجٌ':Added, #1: 1	حُكْمِ الْخَرَاجِ
u'حُكْمٌ خُرُوجٌ':Added, #1: 1	حُكْمِ الْخَرَاجِ
u'حُكْمٌ خُرُوجٌ':Added, #1: 1	حُكْمِ خُرُوجِ
u'حُكْمٌ خُرُوجٌ':Added, #1: 1	حُكْمُ خُرُوجِهِ
u'حُكْمٌ خُرُوجٌ':Added, #2: 2	حُكْمِ الْخُرُوجِ
u'حُكْمٌ خُسُوفٌ':Added, #2: 2	حُكْمِ خُرُوجِهِ
u'حُكْمٌ خُشُوعٌ':Added, #1: 1	حُكْمُ الْخُسُوفِ
u'حُكْمٌ خِصَالٌ':Added, #1: 1	حُكْمِ الْخُشُوعِ
u'حُكْمٌ خَصْلَةٌ':Added, #2: 2	حُكْمُ خِصَالِ
u'حُكْمٌ خَصْلَةٌ':Added, #1: 1	حُكْمِ الْخَصْلَةِ
u'حُكْمٌ خَصْلَةٌ':Added, #1: 1	حُكْم خَصْلَةٍ
u'حُكْمٌ خِضَابٌ':Added, #1: 1	حُكْمِ خَصْلَةٍ
u'حُكْمٌ خضب':Added, #1: 1	حُكْمُ الْخِضَابِ
u'حُكْمٌ خَضْبٌ':Added, #1: 1	حُكْمِ خَضْبِ
u'حُكْمٌ خَطَأٌ':Added, #1: 1	حُكْمِ خَضْبِ
u'حُكْمٌ خَطَأٌ':Added, #4: 4	حُكْمِ الْخَطَأِ
u'حُكْمٌ خِطَابٌ':Added, #6: 6	حُكْمُ الْخَطَأِ
u'حُكْمٌ خِطَابٌ':Added, #1: 1	حُكْمَ خِطَابِ
u'حُكْمٌ خِطَابٌ':Added, #1: 1	حُكْمُ خِطَابِهِ
u'حُكْمٌ خِطَابٌ':Added, #2: 2	حُكْمَ الْخِطَابِ
u'حُكْمٌ خِطَابٌ':Added, #7: 7	حُكْمُ الْخِطَابِ
u'حُكْمٌ خطبة':Added, #9: 9	حُكْمِ الْخِطَابِ
u'حُكْمٌ خطبة':Added, #1: 1	حُكْمُ الْخِطْبَةِ
u'حُكْمٌ خُطْبَةٌ':Added, #1: 1	حُكْمِ الْخُطْبَةِ
u'حُكْمٌ خِطْبَةٌ':Added, #1: 1	حُكْمِ الْخُطْبَةِ
u'حُكْمٌ خُطْوَةٌ':Added, #1: 1	حُكْمُ الْخِطْبَةِ
u'حُكْمٌ خُفٌّ':Added, #1: 1	حُكْمِ الْخُطْوَةِ
u'حُكْمٌ خُفَّاشٌ':Added, #3: 3	حُكْمُ الْخُفِّ
u'حُكْمٌ خِلاَفٌ':Added, #1: 1	حُكْمَ الْخُفَّاشِ
u'حُكْمٌ خِلاَفٌ':Added, #1: 1	حُكْمِ الْخِلَافِ
u'حُكْمٌ خِلاَفٌ':Added, #1: 1	حُكْمِ خِلَافٍ
u'حُكْمٌ خِلاَفَةٌ':Added, #3: 3	حُكْمَ الْخِلَافِ
u'حُكْمٌ خلط':Added, #1: 1	حُكْمُ الْخِلَافَةِ
u'حُكْمٌ خُلْعٌ':Added, #2: 2	حُكْمَ الْخَلْطِ
u'حُكْمٌ خُلْعٌ':Added, #1: 1	حُكْمِ الْخُلْعِ
u'حُكْمٌ خَلْفٌ':Added, #3: 3	حُكْمُ الْخُلْعِ
u'حُكْمٌ خلقة':Added, #1: 1	حُكْمُ الْخَلْفِ
u'حُكْمٌ خِلْقَةٌ':Added, #1: 1	حُكْمُ الْخِلْقَةِ
u'حُكْمٌ خَلْوَةٌ':Added, #1: 1	حُكْمُ الْخِلْقَةِ
u'حُكْمٌ خَلْوَةٌ':Added, #1: 1	حُكْمِ الْخَلْوَةِ
u'حُكْمٌ خَلِيطٌ':Added, #4: 4	حُكْمُ الْخَلْوَةِ
u'حُكْمٌ خَلِيفَةٌ':Added, #1: 1	حُكْمُ الْخَلِيطِ
u'حُكْمٌ خَلِيفَةٌ':Added, #1: 1	حُكْمِ خَلِيفَتِهِ
u'حُكْمٌ خَلِيفَةٌ':Added, #2: 2	حُكْمَ الْخَلِيفَةِ
u'حُكْمٌ خَلِيفَةٌ':Added, #2: 2	حُكْمَ خَلِيفَتِهِ
u'حُكْمٌ خَمْرٌ':Added, #2: 2	حُكْمُ خَلِيفَتِهِ
u'حُكْمٌ خَمْرٌ':Added, #1: 1	حُكْمُ الْخَمْرِ
u'حُكْمٌ خُمُسٌ':Added, #2: 2	حُكْمَ الْخَمْرِ
u'حُكْمٌ خُمُسٌ':Added, #1: 1	حُكْمُ الْخُمُسِ
u'حُكْمٌ خِنْزِيرٌ':Added, #1: 1	حُكْمُ خُمُسِ
u'حُكْمٌ خوارج':Added, #2: 2	حُكْمَ الْخِنْزِيرِ
u'حُكْمٌ خَوَارِجُ':Added, #1: 1	حُكْمَ الْخَوَارِجِ
u'حُكْمٌ خيار':Added, #1: 1	حُكْمَ الْخَوَارِجِ
u'حُكْمٌ خِيَارٌ':Added, #1: 1	حُكْمِ الْخِيَارِ
u'حُكْمٌ خيار':Added, #1: 1	حُكْمِ الْخِيَارِ
u'حُكْمٌ خِيَارٌ':Added, #3: 3	حُكْمُ خِيَارِ
u'حُكْمٌ خَيْطٌ':Added, #3: 3	حُكْمُ خِيَارِ
u'حُكْمٌ دَابَّةٌ':Added, #1: 1	حُكْمُ الْخَيْطِ
u'حُكْمٌ دَاخِلٌ':Added, #1: 1	حُكْمُ الدَّابَّةِ
u'حُكْمٌ دَارٌ':Added, #1: 1	حُكْمِ الدَّاخِلِ
u'حُكْمٌ دَارٌ':Added, #1: 1	حُكْمَ الدَّارِ
u'حُكْمٌ دَارٌ':Added, #1: 1	حُكْمِ الدَّارِ
u'حُكْمٌ دَارٌ':Added, #1: 1	حُكْمَ الدَّارَيْنِ
u'حُكْمٌ دَارٌ':Added, #1: 1	حُكْمَ دَارِ
u'حُكْمٌ دَارٌ':Added, #1: 1	حُكْمُ دَارِ
u'حُكْمٌ دَائِمٌ':Added, #3: 3	حُكْمُ الدَّارِ
u'حُكْمٌ دُبُرٌ':Added, #1: 1	حُكْمُ دَائِمِ
u'حُكْمٌ دَجَاجٌ':Added, #1: 1	حُكْمُ دُبُرِهِ
u'حُكْمٌ دُخُولٌ':Added, #1: 1	حُكْمِ الدَّجَاجِ
u'حُكْمٌ دُخُولٌ':Added, #1: 1	حُكْمَ الدُّخُولِ
u'حُكْمٌ دُخُولٌ':Added, #1: 1	حُكْمِ الدُّخُولِ
u'حُكْمٌ دُخُولٌ':Added, #1: 1	حُكْمَ دُخُولِ
u'حُكْمٌ دُخُولٌ':Added, #1: 1	حُكْمُ دُخُولِهِ
u'حُكْمٌ دَرَاهِمُ':Added, #2: 2	حُكْمُ الدُّخُولِ
u'حُكْمٌ دَرَاهِمُ':Added, #2: 2	حُكْمُ الدَّرَاهِمِ
u'حُكْمٌ دفع':Added, #5: 5	حُكْمِ الدَّرَاهِمِ
u'حُكْمٌ دفع':Added, #1: 1	حُكْمَ الدَّفْعِ
u'حُكْمٌ دَفْعٌ':Added, #1: 1	حُكْمِ الدَّفْعِ
u'حُكْمٌ دَفْعٌ':Added, #1: 1	حُكْمَ الدَّفْعِ
u'حُكْمٌ دفع':Added, #1: 1	حُكْمِ الدَّفْعِ
u'حُكْمٌ دَفْعٌ':Added, #1: 1	حُكْمُ دَفْعِ
u'حُكْمٌ دفع':Added, #1: 1	حُكْمُ دَفْعِ
u'حُكْمٌ دَفْعٌ':Added, #2: 2	حُكْمُ الدَّفْعِ
u'حُكْمٌ دفن':Added, #2: 2	حُكْمُ الدَّفْعِ
u'حُكْمٌ دَفْنٌ':Added, #1: 1	حُكْمُ دَفْنِهِ
u'حُكْمٌ دَقيقٌ':Added, #1: 1	حُكْمُ دَفْنِهِ
u'حُكْمٌ دَلالٌ':Added, #1: 1	حُكْمِ الدَّقِيقِ
u'حُكْمٌ دَلالَةٌ':Added, #2: 2	حُكْمِ دَلَالَاتِ
u'حُكْمٌ دَلالَةٌ':Added, #1: 1	حُكْمِ الدّلَالَةِ
u'حُكْمٌ دِلاَلَةٌ':Added, #1: 1	حُكْمِ الدَّلَالَةِ
u'حُكْمٌ دَلالَةٌ':Added, #1: 1	حُكْمِ الدّلَالَةِ
u'حُكْمٌ دَلالَةٌ':Added, #2: 2	حُكْمِ دَلَالَاتِ
u'حُكْمٌ دلك':Added, #2: 2	حُكْمُ دَلَالَتِهِ
u'حُكْمٌ دَلْكٌ':Added, #1: 1	حُكْمُ دَلْكِهِ
u'حُكْمٌ دَلْوٌ':Added, #1: 1	حُكْمُ دَلْكِهِ
u'حُكْمٌ دَليلٌ':Added, #1: 1	حُكْمَ الدَّلْوِ
u'حُكْمٌ دَليلٌ':Added, #1: 1	حُكْمُ الدَّلِيلِ
u'حُكْمٌ دَمٌ':Added, #3: 3	حُكْمِ الدَّلِيلِ
u'حُكْمٌ دَمٌ':Added, #1: 1	حُكْمِ دَمِ
u'حُكْمٌ دَمٌ':Added, #3: 3	حُكْمِ الدَّمِ
u'حُكْمٌ دَمٌ':Added, #4: 4	حُكْمُ دَمِ
u'حُكْمٌ دِماءٌ':Added, #6: 6	حُكْمُ الدَّمِ
u'حُكْمٌ دَنانيرُ':Added, #1: 1	حُكْمِ الدِّمَاءِ
u'حُكْمٌ دَوَابُّ':Added, #1: 1	حُكْمُ الدَّنَانِيرِ
u'حُكْمٌ دَوامٌ':Added, #1: 1	حُكْمُ دَوَابِّ
u'حُكْمٌ دَوامٌ':Added, #1: 1	حُكْمِ الدَّوَامِ
u'حُكْمٌ دُودٌ':Added, #1: 1	حُكْمُ دَوَامِ
u'حُكْمٌ دِيانَةٌ':Added, #1: 1	حُكْمَ الدُّودِ
u'حُكْمٌ دِيَةٌ':Added, #1: 1	حُكْمُ الدِّيَانَةِ
u'حُكْمٌ دِيَةٌ':Added, #1: 1	حُكْمُ الدِّيَةِ
u'حُكْمٌ دِينٌ':Added, #1: 1	حُكْمُ دِيَةِ
u'حُكْمٌ دَيْنٌ':Added, #1: 1	حُكْمِ الدّينِ
u'حُكْمٌ دَيْنٌ':Added, #1: 1	حُكْمِ الدّينِ
u'حُكْمٌ دَيْنٌ':Added, #1: 1	حُكْمُ دَيْنٍ
u'حُكْمٌ دَيْنٌ':Added, #1: 1	حُكْمُ دَيْنِ
u'حُكْمٌ دِينٌ':Added, #1: 1	حُكْمِ دَيْنِهِ
u'حُكْمٌ دَيْنٌ':Added, #2: 2	حُكْمِ الدِّينِ
u'حُكْمٌ دَيْنٌ':Added, #3: 3	حُكْمَ الدَّيْنِ
u'حُكْمٌ دَيْنٌ':Added, #3: 3	حُكْمِ دَيْنَيْنِ
u'حُكْمٌ دَيْنٌ':Added, #4: 4	حُكْمِ دَيْنٍ
u'حُكْمٌ دَيْنٌ':Added, #5: 5	حُكْمُ الدَّيْنِ
u'حُكْمٌ دِيوانٌ':Added, #5: 5	حُكْمِ الدَّيْنِ
u'حُكْمٌ دُيونٌ':Added, #1: 1	حُكْمُ دِيوَانِ
u'حُكْمٌ ذُبابٌ':Added, #1: 1	حُكْمُ دُيُونِهِ
u'حُكْمٌ ذَرَّةٌ':Added, #2: 2	حُكْمُ الذُّبَابِ
u'حُكْمٌ ذَكاةٌ':Added, #1: 1	حُكْمُ ذَرَّةٍ
u'حُكْمٌ ذَكاةٌ':Added, #1: 1	حُكْمُ الذَّكَاةِ
u'حُكْمٌ ذكر':Added, #3: 3	حُكْمُ ذَكَاةِ
u'حُكْمٌ ذكر':Added, #1: 1	حُكْمَ الذَّكَرِ
u'حُكْمٌ ذَكَرٌ':Added, #1: 1	حُكْمُ الذَّكَرِ
u'حُكْمٌ ذَكَرٌ':Added, #1: 1	حُكْمَ الذَّكَرِ
u'حُكْمٌ ذكر':Added, #1: 1	حُكْمُ الذَّكَرِ
u'حُكْمٌ ذِكْرٌ':Added, #1: 1	حُكْمُ ذِكْرِ
u'حُكْمٌ ذَمٌّ':Added, #1: 1	حُكْمُ ذِكْرِ
u'حُكْمٌ ذِمَّةٌ':Added, #1: 1	حُكْمِ الذَّمِّ
u'حُكْمٌ ذِمَّةٌ':Added, #1: 1	حُكْمِ الذِّمَّةِ
u'حَكَمَ ذِمِّيٌّ':Subject, #2: 2	حُكْمُ الذِّمَّةِ
u'حَكَمَ ذِمِّيٌّ':Subject, #1: 1	حَكَمَ الذِّمِّيُّ
u'حُكْمٌ ذِمِّيٌّ':Added, #2: 2	حَكَمَ ذِمِّيٌّ
u'حُكْمٌ ذِمِّيٌّ':Added, #1: 1	حُكْمَ الذِّمِّيِّ
u'حُكْمٌ ذِمِّيٌّ':Added, #1: 1	حُكْمُ الذِّمِّيِّ
u'حُكْمٌ ذَهَبٌ':Added, #2: 2	حُكْمِ ذِمِّيٍّ
u'حُكْمٌ ذَهَبٌ':Added, #1: 1	حُكْمَ الذَّهَبِ
u'حُكْمٌ ذَهَبٌ':Added, #1: 1	حُكْمُ الذَّهَبِ
u'حُكْمٌ ذِهْنٌ':Added, #1: 1	حُكْمِ الذَّهَبِ
u'حُكْمٌ ذِهْنٌ':Added, #1: 1	حُكْمُ الذِّهْنِ
u'حُكْمٌ ذِئْبٌ':Added, #2: 2	حُكْمَ الذِّهْنِ
u'حُكْمٌ رَاتِبٌ':Added, #1: 1	حُكْمُ الذِّئْبِ
u'حُكْمٌ رَاتِب':Added, #1: 1	حُكْمُ الرَّاتِبِ
u'حُكْمٌ رَاحَةٌ':Added, #1: 1	حُكْمُ الرَّاتِبِ
u'حُكْمٌ رَاحِلٌ':Added, #1: 1	حُكْمِ الرَّاحَةِ
u'حُكْمٌ رَاحِلَةٌ':Added, #1: 1	حُكْمُ الرَّاحِلَةِ
u'حُكْمٌ رَأْسٌ':Added, #1: 1	حُكْمُ الرَّاحِلَةِ
u'حُكْمٌ رَأْسٌ':Added, #1: 1	حُكْمِ الرَّأْسِ
u'حُكْمٌ رَأْسٌ':Added, #1: 1	حُكْمَ رَأْسِ
u'حُكْمٌ رَاكِبٌ':Added, #2: 2	حُكْمُ رَأْسِ
u'حُكْمٌ رَاكِدٌ':Added, #1: 1	حُكْمُ الرَّاكِبِ
u'حُكْمٌ رَاهِنٌ':Added, #5: 5	حُكْمُ الرَّاكِدِ
u'حُكْمٌ رَأْيٌ':Added, #1: 1	حُكْمِ الرَّاهِنِ
u'حُكْمٌ رَائِحٌ':Added, #1: 1	حُكْمُ رَأْيِهِ
u'حُكْمٌ رَائِحَةٌ':Added, #1: 1	حُكْمُ الرَّائِحَةِ
u'حُكْمٌ رايَة':Added, #1: 1	حُكْمُ الرَّائِحَةِ
u'حُكْمٌ رَبُّ':Added, #1: 1	حُكْمُ الرَّايَاتِ
u'حُكْمٌ رَبُّ':Added, #1: 1	حُكْمِ الرَّبِّ
u'حُكْمٌ رِبْحٌ':Added, #1: 1	حُكْمُ رَبِّ
u'حُكْمٌ رِبْحٌ':Added, #1: 1	حُكْمُ الرِّبْحِ
u'حُكْمٌ رَبِيبَةٌ':Added, #1: 1	حُكْمِ الرِّبْحِ
u'حَكَّمَ رِجَالٌ':Predicate, #1: 1	حُكْمِ الرَّبِيبَةِ
u'حُكْمٌ رِجَالٌ':Added, #4: 4	حَكَّمَ الرِّجَالَ
u'حُكْمٌ رِجَالٌ':Added, #1: 1	حُكْمَ الرِّجَالِ
u'حُكْمٌ رِجَالٌ':Added, #1: 1	حُكْمِ الرِّجَالِ
u'حُكْمٌ رجعة':Added, #2: 2	حُكْمُ الرِّجَالِ
u'حُكْمٌ رجعة':Added, #4: 4	حُكْمَ الرَّجْعَةِ
u'حُكْمٌ رَجْعَةٌ':Added, #4: 4	حُكْمِ الرَّجْعَةِ
u'حُكْمٌ رَجْعَةٌ':Added, #4: 4	حُكْمَ الرَّجْعَةِ
u'حُكْمٌ رجعة':Added, #4: 4	حُكْمِ الرَّجْعَةِ
u'حُكْمٌ رَجْعَةٌ':Added, #5: 5	حُكْمُ الرَّجْعَةِ
u'حُكْمٌ رَجْعِيٌّ':Added, #5: 5	حُكْمُ الرَّجْعَةِ
u'حُكْمٌ رَجْعِيَّةٌ':Added, #1: 1	حُكْمُ الرَّجْعِيَّةِ
u'حَكَمَ رَجُلٌ':Subject, #1: 1	حُكْمُ الرَّجْعِيَّةِ
u'حَكَّمَ رَجُلٌ':Subject, #1: 1	حَكَمَ رَجُلٌ
u'حُكْمٌ رَجُلٌ':Added, #1: 1	حَكَّمَ رَجُلٌ
u'حُكْمٌ رَجُلٌ':Added, #1: 1	حُكْمِ الرَّجُلِ
u'حُكْمٌ رَجُلٌ':Added, #1: 1	حُكْمِ رَجُلَيْنِ
u'حُكْمٌ رَجُلٌ':Added, #4: 4	حُكْمَ الرَّجُلِ
u'حُكْمٌ رَجُلٌ':Added, #6: 6	حُكْمِ رَجُلٍ
u'حُكْمٌ رَجْمٌ':Added, #8: 8	حُكْمُ الرَّجُلِ
u'حُكْمٌ رَجْمٌ':Added, #1: 1	حُكْمَ الرَّجْمِ
u'حُكْمٌ رُجُوعٌ':Added, #1: 1	حُكْمِ الرّجْمِ
u'حُكْمٌ رُجُوعٌ':Added, #1: 1	حُكْمَ الرُّجُوعِ
u'حُكْمٌ رُجُوعٌ':Added, #1: 1	حُكْمُ الرُّجُوعِ
u'حُكْمٌ رُجُوعٌ':Added, #1: 1	حُكْمُ رُجُوعِهِ
u'حُكْمٌ رُجُوعٌ':Added, #2: 2	حُكْمِ الرُّجُوعِ
u'حُكْمٌ رُخَصٌ':Added, #2: 2	حُكْمُ رُجُوعِ
u'حُكْمٌ رَدٌّ':Added, #1: 1	حُكْمِ الرُّخَصِ
u'حُكْمٌ رَدٌّ':Added, #1: 1	حُكْمِ رَدِّ
u'حُكْمٌ رَدٌّ':Added, #4: 4	حُكْمُ الرَّدِّ
u'حُكْمٌ رَدٌّ':Added, #5: 5	حُكْمَ الرَّدِّ
u'حُكْمٌ رِدَاءٌ':Added, #6: 6	حُكْمِ الرَّدِّ
u'حُكْمٌ رِدَّةٌ':Added, #1: 1	حُكْمُ الرِّدَاءِ
u'حُكْمٌ رِدَّةٌ':Added, #1: 1	حُكْمِ الرِّدَّةِ
u'حُكْمٌ رِدَّةٌ':Added, #1: 1	حُكْمُ رِدَّتِهِ
u'حُكْمٌ رِدَّةٌ':Added, #2: 2	حُكْمَ الرِّدَّةِ
u'حَكَمَ رَسُولٌ':Subject, #2: 2	حُكْمُ الرِّدَّةِ
u'حُكْمٌ رَسُولٌ':Added, #1: 1	حَكَمَ رَسُولُ
u'حُكْمٌ رَسُولٌ':Added, #1: 1	حُكْمَ الرَّسُولِ
u'حُكْمٌ رَسُولٌ':Added, #1: 1	حُكْمُ رَسُولِ
u'حُكْمٌ رَسُولٌ':Added, #1: 1	حُكْمَ رَسُولِهِ
u'حُكْمٌ رَسُولٌ':Added, #2: 2	حُكْمَ رَسُولِ
u'حُكْمٌ رَشيدٌ':Added, #6: 6	حُكْمِ رَسُولِ
u'حُكْمٌ رِضاءٌ':Added, #1: 1	حُكْمِ الرَّشِيدِ
u'حُكْمٌ رضاع':Added, #1: 1	حُكْمِ الرِّضَاءِ
u'حُكْمٌ رضاع':Added, #1: 1	حُكْمِ الرَّضَاعِ
u'حُكْمٌ رَطْبٌ':Added, #2: 2	حُكْمُ الرَّضَاعِ
u'حُكْمٌ رَطْبَةٌ':Added, #1: 1	حُكْمُ رَطْبِ
u'حُكْمٌ رعاف':Added, #1: 1	حُكْمُ الرَّطْبَةِ
u'حُكْمٌ رُعافٌ':Added, #1: 1	حُكْمَ الرُّعَافِ
u'حُكْمٌ رَفْضٌ':Added, #1: 1	حُكْمَ الرُّعَافِ
u'حُكْمٌ رَفْعٌ':Added, #1: 1	حُكْمُ الرَّفْضِ
u'حُكْمٌ رَفْعٌ':Added, #1: 1	حُكْمِ الرَّفْعِ
u'حُكْمٌ رَفْعٌ':Added, #2: 2	حُكْمَ الرَّفْعِ
u'حُكْمٌ رِقٌّ':Added, #3: 3	حُكْمُ الرَّفْعِ
u'حُكْمٌ رِقٌّ':Added, #2: 2	حُكْمُ الرِّقِّ
u'حُكْمٌ رَقَبَةٌ':Added, #7: 7	حُكْمِ الرِّقِّ
u'حُكْمٌ رَقيقٌ':Added, #1: 1	حُكْمُ الرَّقَبَةِ
u'حُكْمٌ رَقيق':Added, #1: 1	حُكْمِ الرَّقِيقِ
u'حُكْمٌ رَقيقٌ':Added, #1: 1	حُكْمِ الرَّقِيقِ
u'حُكْمٌ رَقيق':Added, #2: 2	حُكْمُ الرَّقِيقِ
u'حُكْمٌ رِكاز':Added, #2: 2	حُكْمُ الرَّقِيقِ
u'حُكْمٌ ركبة':Added, #3: 3	حُكْمِ الرِّكَازِ
u'حُكْمٌ رُكْبَةٌ':Added, #1: 1	حُكْمُ الرُّكْبَةِ
u'حُكْمٌ رُكوبٌ':Added, #1: 1	حُكْمُ الرُّكْبَةِ
u'حُكْمٌ رُكوبٌ':Added, #1: 1	حُكْمُ الرُّكُوبِ
u'حُكْمٌ رُكوعٌ':Added, #1: 1	حُكْمُ رُكُوبِ
u'حُكْمٌ رَمْيٌ':Added, #1: 1	حُكْمُ الرُّكُوعِ
u'حُكْمٌ رَمْيٌ':Added, #1: 1	حُكْمُ الرَّمْيِ
u'حُكْمٌ رَهْنٌ':Added, #2: 2	حُكْمَ الرَّمْيِ
u'حُكْمٌ رَهْنٌ':Added, #16: 16	حُكْمَ الرَّهْنِ
u'حُكْمٌ رَهْنٌ':Added, #19: 19	حُكْمُ الرَّهْنِ
u'حُكْمٌ رَهْنٌ':Added, #1: 1	حُكْمَ رَهْنِ
u'حُكْمٌ رَهْنٌ':Added, #1: 1	حُكْمِ رَهْنِ
u'حُكْمٌ رِوايَةٌ':Added, #8: 8	حُكْمِ الرَّهْنِ
u'حُكْمٌ رُؤْيَةٌ':Added, #2: 2	حُكْمَ الرِّوَايَةِ
u'حُكْمٌ رِيقٌ':Added, #1: 1	حُكْمِ الرُّؤْيَةِ
u'حُكْمٌ زائِدٌ':Added, #1: 1	حُكْمُ الرِّيقِ
u'حُكْمٌ زائِدٌ':Added, #2: 2	حُكْمُ الزَّائِدِ
u'حُكْمٌ زائِدٌ':Added, #2: 2	حُكْمِ الزَّائِدِ
u'حُكْمٌ زائِلٌ':Added, #5: 5	حُكْمَ الزَّائِدِ
u'حُكْمٌ زَجْرٌ':Added, #1: 1	حُكْمَ الزَّائِلِ
u'حُكْمٌ زَرْعٌ':Added, #1: 1	حُكْمِ الزَّجْرِ
u'حُكْمٌ زَرْعٌ':Added, #1: 1	حُكْمِ الزَّرْعِ
u'حُكْمٌ زَرْعٌ':Added, #1: 1	حُكْمُ زَرْعِ
u'حُكْمٌ زَرْعٌ':Added, #2: 2	حُكْمُ زَرْعٍ
u'حُكْمٌ زَكاةٌ':Added, #6: 6	حُكْمُ الزَّرْعِ
u'حُكْمٌ زَكاةٌ':Added, #1: 1	حُكْمُ زَكَاةِ
u'حُكْمٌ زَكاةٌ':Added, #1: 1	حُكْمِ زَكَاةِ
u'حُكْمٌ زَكاةٌ':Added, #25: 25	حُكْمِ الزَّكَاةِ
u'حُكْمٌ زَكاةٌ':Added, #3: 3	حُكْمَ الزَّكَاةِ
u'حُكْمٌ زَمانٌ':Added, #7: 7	حُكْمُ الزَّكَاةِ
u'حُكْمٌ زَوالٌ':Added, #1: 1	حُكْمِ زَمَانِهِ
u'حُكْمٌ زَوالٌ':Added, #1: 1	حُكْمِ الزَّوَالِ
u'حُكْمٌ زَوالٌ':Added, #1: 1	حُكْمُ زَوَالِ
u'حُكْمٌ زَوائِدُ':Added, #1: 1	حُكْمِ زَوَالِ
u'حُكْمٌ زَوْجٌ':Added, #1: 1	حُكْمُ الزَّوَائِدِ
u'حُكْمٌ زَوْجٌ':Added, #1: 1	حُكْمَ الزَّوْجِ
u'حُكْمٌ زَوْجٌ':Added, #1: 1	حُكْمِ الزَّوْجَيْنِ
u'حُكْمٌ زَوْجٌ':Added, #3: 3	حُكْمِ الزَّوْجِ
u'حُكْمٌ زَوْجَةٌ':Added, #4: 4	حُكْمُ الزَّوْجِ
u'حُكْمٌ زَوْجَةٌ':Added, #1: 1	حُكْمِ الزَّوْجَاتِ
u'حُكْمٌ زَوْجَةٌ':Added, #1: 1	حُكْمِ زَوْجَةِ
u'حُكْمٌ زَوْجَةٌ':Added, #1: 1	حُكْمِ زَوْجَتِهِ
u'حُكْمٌ زَوْجِيٌّ':Added, #3: 3	حُكْمِ الزَّوْجَةِ
u'حُكْمٌ زَوْجِيٌّ':Added, #1: 1	حُكْمِ زَوْجِيَّةِ
u'حُكْمٌ زِيادَةٌ':Added, #2: 2	حُكْمِ الزَّوْجِيَّةِ
u'حُكْمٌ زِيادَةٌ':Added, #1: 1	حُكْمُ زِيَادَةِ
u'حُكْمٌ زِيادَةٌ':Added, #1: 1	حُكْمَ زِيَادَتِهِ
u'حُكْمٌ زِيادَةٌ':Added, #2: 2	حُكْمَ الزِّيَادَةِ
u'حُكْمٌ زِيادَةٌ':Added, #2: 2	حُكْمِ الزِّيَادَةِ
u'حَكَّمَ زَيْدٌ':Predicate, #4: 4	حُكْمُ الزِّيَادَةِ
u'حُكْمٌ زُيوفٌ':Added, #1: 1	حَكَّمَ زَيْدَ
u'حُكْمٌ زُيُوفٌ':Added, #1: 1	حُكْمِ الزُّيُوفِ
u'حُكْمٌ سابّ':Added, #1: 1	حُكْمِ الزُّيُوفِ
u'حُكْمٌ سابّ':Added, #1: 1	حُكْمُ السَّابِّ
u'حُكْمٌ سَابِقٌ':Added, #1: 1	حُكْمِ سَابِّ
u'حُكْمٌ سَاحِرٌ':Added, #1: 1	حُكْمُ السَّابِقِ
u'حُكْمٌ سَارِقٌ':Added, #1: 1	حُكْمَ السَّاحِرِ
u'حُكْمٌ سَارِقٌ':Added, #1: 1	حُكْمُ سَارِقِ
u'حُكْمٌ سَاعَةٌ':Added, #2: 2	حُكْمُ السَّارِقِ
u'حُكْمٌ سَائِرٌ':Added, #1: 1	حُكْمُ سَاعَةٍ
u'حُكْمٌ سَائِرٌ':Added, #20: 20	حُكْمُ سَائِرِ
u'حُكْمٌ سَائِرٌ':Added, #3: 3	حُكْمَ سَائِرِ
u'حُكْمٌ سَائِمَةٌ':Added, #3: 3	حُكْمِ سَائِرِ
u'حُكْمٌ سَائِمَةٌ':Added, #1: 1	حُكْمَ السَّائِمَةِ
u'حُكْمٌ سَبائِكُ':Added, #1: 1	حُكْمُ السَّائِمَةِ
u'حُكْمٌ سَبَبٌ':Added, #1: 1	حُكْمُ السَّبَائِكِ
u'حُكْمٌ سَبَبٌ':Added, #1: 1	حُكْمِ السَّبَبَيْنِ
u'حُكْمٌ سَبَبٌ':Added, #4: 4	حُكْمِ السَّبَبِ
u'حُكْمٌ سَبَبِيَّةٌ':Added, #7: 7	حُكْمُ السَّبَبِ
u'حُكْمٌ سَبَبِيَّةٌ':Added, #1: 1	حُكْمَ السَّبَبِيَّةِ
u'حُكْمٌ سَبْقٌ':Added, #1: 1	حُكْمِ السَّبَبِيَّةِ
u'حُكْمٌ سَبْقٌ':Added, #1: 1	حُكْمَ السَّبْقِ
u'حُكْمٌ سَبْقٌ':Added, #1: 1	حُكْمُ السَّبْقِ
u'حُكْمٌ سُبُوتٌ':Added, #1: 1	حُكْمَ سَبْقِ
u'حُكْمٌ سَتْرٌ':Added, #1: 1	حُكْمُ السُّبُوتِ
u'حُكْمٌ سترة':Added, #1: 1	حُكْمُ سَتْرِ
u'حُكْمٌ سُتْرَةٌ':Added, #1: 1	حُكْمُ السُّتْرَةِ
u'حُكْمٌ سجدة':Added, #1: 1	حُكْمُ السُّتْرَةِ
u'حُكْمٌ سَجْدَةٌ':Added, #1: 1	حُكْمِ السَّجْدَةِ
u'حُكْمٌ سجدة':Added, #1: 1	حُكْمِ السَّجْدَةِ
u'حُكْمٌ سَجْدَةٌ':Added, #1: 1	حُكْمِ سَجْدَةِ
u'حُكْمٌ سُجُودٌ':Added, #1: 1	حُكْمِ سَجْدَةِ
u'حُكْمٌ سَحَرَةٌ':Added, #1: 1	حُكْمِ سُجُودِ
u'حُكْمٌ سَخَاءٌ':Added, #1: 1	حُكْمُ السَّحَرَةِ
u'حُكْمٌ سَرقَةٌ':Added, #1: 1	حُكْمِ السَّخَاءِ
u'حُكْمٌ سَرقَةٌ':Added, #1: 1	حُكْمَ السَّرِقَةِ
u'حُكْمٌ سَرِقَةٌ':Added, #1: 1	حُكْمِ السَّرِقَةِ
u'حُكْمٌ سَرِقَةٌ':Added, #1: 1	حُكْمَ السَّرِقَةِ
u'حُكْمٌ سَرقَةٌ':Added, #1: 1	حُكْمِ السَّرِقَةِ
u'حُكْمٌ سَرِقَةٌ':Added, #1: 1	حُكْمُ سَرِقَةِ
u'حُكْمٌ سَرقَةٌ':Added, #1: 1	حُكْمُ سَرِقَةِ
u'حُكْمٌ سَرِقَةٌ':Added, #2: 2	حُكْمُ السَّرِقَةِ
u'حُكْمٌ سُعَاةٌ':Added, #2: 2	حُكْمُ السَّرِقَةِ
u'حُكْمٌ سِعَايَةٌ':Added, #1: 1	حُكْمِ السُّعَاةِ
u'حُكْمٌ سِعَايَةٌ':Added, #1: 1	حُكْمُ السِّعَايَةِ
u'حَكَّمَ سَعْدٌ':Predicate, #1: 1	حُكْمِ السِّعَايَةِ
u'حَكَمَ سَعْدٌ':Subject, #1: 1	حَكَّمَ سَعْدَ
u'حُكْمٌ سَعْدٌ':Added, #1: 1	حَكَمَ سَعْدُ
u'حُكْمٌ سَعْدٌ':Added, #1: 1	حُكْمَ سَعْدٍ
u'حُكْمٌ سَعْدٌ':Added, #5: 5	حُكْمِ سَعْدٍ
u'حُكْمٌ سَفَرٌ':Added, #5: 5	حُكْمِ سَعْدِ
u'حُكْمٌ سَفَرٌ':Added, #10: 10	حُكْمِ السَّفَرِ
u'حُكْمٌ سَفَرٌ':Added, #3: 3	حُكْمُ سَفَرِ
u'حُكْمٌ سَفَرٌ':Added, #3: 3	حُكْمُ سَفَرِهِ
u'حُكْمٌ سَفَرٌ':Added, #7: 7	حُكْمَ السَّفَرِ
u'حُكْمٌ سقط':Added, #9: 9	حُكْمُ السَّفَرِ
u'حُكْمٌ سِقْطٌ':Added, #1: 1	حُكْمُ السِّقْطِ
u'حُكْمٌ سُقُوطٌ':Added, #1: 1	حُكْمُ السِّقْطِ
u'حُكْمٌ سِكَّةٌ':Added, #2: 2	حُكْمُ سُقُوطِ
u'حُكْمٌ سكر':Added, #1: 1	حُكْمِ سِكَّةٍ
u'حُكْمٌ سُكْرٌ':Added, #1: 1	حُكْمِ السُّكْرِ
u'حُكْمٌ سِكَكٌ':Added, #1: 1	حُكْمِ السُّكْرِ
u'حُكْمٌ سُكُونٌ':Added, #1: 1	حُكْمَ السِّكَكِ
u'حُكْمٌ سِكِّينٌ':Added, #1: 1	حُكْمِ السّكُونِ
u'حُكْمٌ سَكِينَةٌ':Added, #1: 1	حُكْمِ السِّكِّينِ
u'حُكْمٌ سلام':Added, #1: 1	حُكْمِ السّكِينَةِ
u'حُكْمٌ سَلاَمٌ':Added, #1: 1	حُكْمُ سَلَامِ
u'حُكْمٌ سلام':Added, #1: 1	حُكْمُ سَلَامِ
u'حُكْمٌ سَلاَمٌ':Added, #3: 3	حُكْمِ السَّلَامِ
u'حُكْمٌ سَلاَمَةٌ':Added, #3: 3	حُكْمِ السَّلَامِ
u'حُكْمٌ سُلْطَانٌ':Added, #1: 1	حُكْمِ السَّلَامَةِ
u'حُكْمٌ سُلْطَانٌ':Added, #1: 1	حُكْمُ السُّلْطَانِ
u'حُكْمٌ سِلْعَةٌ':Added, #1: 1	حُكْمِ السُّلْطَانِ
u'حُكْمٌ سَلَفٌ':Added, #1: 1	حُكْمَ السِّلْعَةِ
u'حُكْمٌ سَلَمٌ':Added, #1: 1	حُكْمِ السَّلَفِ
u'حُكْمٌ سَلَمٌ':Added, #1: 1	حُكْمَ السَّلَمِ
u'حُكْمٌ سَلَمٌ':Added, #1: 1	حُكْمُ السَّلَمِ
u'حُكْمٌ سَمَاعٌ':Added, #2: 2	حُكْمِ السَّلَمِ
u'حُكْمٌ سَمَاعٌ':Added, #1: 1	حُكْمِ السَّمَاعِ
u'حُكْمٌ سَمَاعٌ':Added, #1: 1	حُكْمَ سَمَاعِ
u'حُكْمٌ سَمَاعٌ':Added, #1: 1	حُكْمِ سَمَاعِ
u'حُكْمٌ سَمَكٌ':Added, #2: 2	حُكْمُ السَّمَاعِ
u'حُكْمٌ سَنَةٌ':Added, #1: 1	حُكْمُ السَّمَكِ
u'حُكْمٌ سُنَّةٌ':Added, #1: 1	حُكْمُ السَّنَةِ
u'حُكْمٌ سُنَّةٌ':Added, #1: 1	حُكْمُ السُّنَّةِ
u'حُكْمٌ سُنَّةٌ':Added, #1: 1	حُكْمَ سُنَّةِ
u'حُكْمٌ سُنَّةٌ':Added, #2: 2	حُكْمَ السُّنَّةِ
u'حُكْمٌ سنن':Added, #3: 3	حُكْمِ السُّنَّةِ
u'حُكْمٌ سنن':Added, #1: 1	حُكْمَ السُّنَنِ
u'حُكْمٌ سَهْمٌ':Added, #1: 1	حُكْمُ السُّنَنِ
u'حُكْمٌ سَهْوٌ':Added, #1: 1	حُكْمُ سَهْمِ
u'حُكْمٌ سَهْوٌ':Added, #1: 1	حُكْمَ السَّهْوِ
u'حُكْمٌ سَهْوٌ':Added, #1: 1	حُكْمِ السَّهْوِ
u'حُكْمٌ سُؤَالٌ':Added, #1: 1	حُكْمُ سَهْوِهِ
u'حُكْمٌ سُورَةٌ':Added, #1: 1	حُكْمَ السُّؤَالِ
u'حُكْمٌ سِياسَةٌ':Added, #1: 1	حُكْمُ السُّورَةِ
u'حُكْمٌ سَيِّدٌ':Added, #1: 1	حُكْمِ السِّيَاسَةِ
u'حُكْمٌ سَيِّدٌ':Added, #1: 1	حُكْمُ السَّيِّدِ
u'حُكْمٌ سَيْفٌ':Added, #1: 1	حُكْمِ سَيِّدِهِ
u'حُكْمٌ سَيْفٌ':Added, #1: 1	حُكْمَ السَّيْفِ
u'حُكْمٌ سَيْفٌ':Added, #1: 1	حُكْمُ السَّيْفِ
u'حُكْمٌ سُيوفٌ':Added, #1: 1	حُكْمِ السَّيْفِ
u'حُكْمٌ شَاةٌ':Added, #1: 1	حُكْمُ السّيُوفِ
u'حَكَمَ شَارِعٌ':Subject, #1: 1	حُكْمُ الشَّاةِ
u'حُكْمٌ شَارِعٌ':Added, #3: 3	حَكَمَ الشَّارِعُ
u'حُكْمٌ شَارِعٌ':Added, #1: 1	حُكْمَ الشَّارِعِ
u'حُكْمٌ شَارِعٌ':Added, #2: 2	حُكْمُ الشَّارِعِ
u'حَكَمَ شافِعِيّ':Subject, #3: 3	حُكْمِ الشَّارِعِ
u'حُكْمٌ شافِعِيّ':Added, #6: 6	حَكَمَ الشَّافِعِيُّ
u'حُكْمٌ شافِعِيّ':Added, #1: 1	حُكْمِ الشَّافِعِيِّ
u'حُكْمٌ شافِعِيّ':Added, #3: 3	حُكْمَ الشَّافِعِيِّ
u'حُكْمٌ شَاهِدٌ':Added, #3: 3	حُكْمُ الشَّافِعِيِّ
u'حُكْمٌ شَائِعٌ':Added, #1: 1	حُكْمِ الشَّاهِدِ
u'حُكْمٌ شَجَّةٌ':Added, #1: 1	حُكْمِ الشَّائِعِ
u'حُكْمٌ شَجَّةٌ':Added, #2: 2	حُكْمُ الشَّجَّاتِ
u'حُكْمٌ شَجَرٌ':Added, #2: 2	حُكْمُ الشَّجَّةِ
u'حُكْمٌ شَحْمٌ':Added, #4: 4	حُكْمُ الشَّجَرِ
u'حُكْمٌ شِرَاءٌ':Added, #1: 1	حُكْمُ الشَّحْمِ
u'حُكْمٌ شِرَاءٌ':Added, #1: 1	حُكْمِ الشِّرَاءِ
u'حُكْمٌ شِرَاءٌ':Added, #2: 2	حُكْمَ الشِّرَاءِ
u'حُكْمٌ شِرَاءٌ':Added, #2: 2	حُكْمِ شِرَاءِ
u'حُكْمٌ شِرَاءٌ':Added, #6: 6	حُكْمُ شِرَاءِ
u'حُكْمٌ شَرَابٌ':Added, #7: 7	حُكْمُ الشِّرَاءِ
u'حُكْمٌ شَرْطٌ':Added, #1: 1	حُكْمُ الشَّرَابِ
u'حُكْمٌ شَرْطٌ':Added, #1: 1	حُكْمِ شَرْطِ
u'حُكْمٌ شَرْطٌ':Added, #2: 2	حُكْمُ شَرْطِ
u'حُكْمٌ شَرْطٌ':Added, #6: 6	حُكْمِ الشَّرْطِ
u'حَكَمَ شَرْعٌ':Subject, #7: 7	حُكْمُ الشَّرْطِ
u'حُكْمٌ شَرْعٌ':Added, #9: 9	حَكَمَ الشَّرْعُ
u'حُكْمٌ شَرْعٌ':Added, #20: 20	حُكْمَ الشَّرْعِ
u'حُكْمٌ شَرْعٌ':Added, #31: 31	حُكْمِ الشَّرْعِ
u'حُكْمٌ شَرْعِيٌّ':Added, #9: 9	حُكْمُ الشَّرْعِ
u'حُكْمٌ شِرْكٌ':Added, #53: 53	حُكْمٍ شَرْعِيٍّ
u'حُكْمٌ شركة':Added, #1: 1	حُكْمُ الشّرْكِ
u'حُكْمٌ شَرِكَةٌ':Added, #2: 2	حُكْمُ الشَّرِكَةِ
u'حُكْمٌ شركة':Added, #2: 2	حُكْمُ الشَّرِكَةِ
u'حُكْمٌ شَرِكَةٌ':Added, #3: 3	حُكْمِ الشَّرِكَةِ
u'حُكْمٌ شركة':Added, #3: 3	حُكْمِ الشَّرِكَةِ
u'حُكْمٌ شَرِكَةٌ':Added, #4: 4	حُكْمُ شَرِكَةِ
u'حُكْمٌ شُرُوطٌ':Added, #4: 4	حُكْمُ شَرِكَةِ
u'حُكْمٌ شَرِيعَةٌ':Added, #1: 1	حُكْمِ الشُّرُوطِ
u'حُكْمٌ شَرِيعَةٌ':Added, #1: 1	حُكْمَ الشَّرِيعَةِ
u'حُكْمٌ شَرِيعَةٌ':Added, #1: 1	حُكْمِ الشّرِيعَةِ
u'حُكْمٌ شَرِيعَةٌ':Added, #1: 1	حُكْمِ الشَّرِيعَةِ
u'حُكْمٌ شَرِيكٌ':Added, #1: 1	حُكْمُ شَرِيعَةِ
u'حُكْمٌ شَرِيكٌ':Added, #2: 2	حُكْمَ الشَّرِيكِ
u'حُكْمٌ شَطٌّ':Added, #3: 3	حُكْمُ الشَّرِيكِ
u'حُكْمٌ شَعْرٌ':Added, #1: 1	حُكْمُ الشَّطِّ
u'حُكْمٌ شَعْرٌ':Added, #1: 1	حُكْمُ الشَّعْرِ
u'حُكْمٌ شَعْرٌ':Added, #1: 1	حُكْمُ الشَّعْرَةِ
u'حُكْمٌ شعرة':Added, #1: 1	حُكْمُ شَعْرِهِ
u'حُكْمٌ شَفَاعَةٌ':Added, #1: 1	حُكْمُ الشَّعْرَةِ
u'حُكْمٌ شفعة':Added, #1: 1	حُكْمِ الشَّفَاعَةِ
u'حُكْمٌ شفعة':Added, #1: 1	حُكْمَ الشُّفْعَةِ
u'حُكْمٌ شُفْعَةٌ':Added, #1: 1	حُكْمُ الشُّفْعَةِ
u'حُكْمٌ شُفْعَةٌ':Added, #1: 1	حُكْمَ الشُّفْعَةِ
u'حُكْمٌ شفعة':Added, #1: 1	حُكْمُ الشُّفْعَةِ
u'حُكْمٌ شُفْعَةٌ':Added, #2: 2	حُكْمِ الشُّفْعَةِ
u'حُكْمٌ شَقٌّ':Added, #2: 2	حُكْمِ الشُّفْعَةِ
u'حُكْمٌ شَكٌّ':Added, #1: 1	حُكْمَ شَقِّ
u'حُكْمٌ شَمْسٌ':Added, #2: 2	حُكْمُ الشَّكِّ
u'حُكْمٌ شَهَادَةٌ':Added, #1: 1	حُكْمُ شَمْسٍ
u'حُكْمٌ شَهَادَةٌ':Added, #12: 12	حُكْمِ الشَّهَادَةِ
u'حُكْمٌ شَهَادَةٌ':Added, #1: 1	حُكْمَ الشَّهَادَاتِ
u'حُكْمٌ شَهَادَةٌ':Added, #1: 1	حُكْمُ الشَّهَادَةِ
u'حُكْمٌ شَهَادَةٌ':Added, #1: 1	حُكْمَ شَهَادَةٍ
u'حُكْمٌ شَهَادَةٌ':Added, #1: 1	حُكْمُ شَهَادَةِ
u'حُكْمٌ شَهَادَةٌ':Added, #1: 1	حُكْمِ شَهَادَةٍ
u'حُكْمٌ شَهَادَةٌ':Added, #1: 1	حُكْمَ شَهَادَتِهِ
u'حُكْمٌ شَهْرٌ':Added, #2: 2	حُكْمَ الشَّهَادَةِ
u'حُكْمٌ شُهُودٌ':Added, #1: 1	حُكْمَ الشَّهْرِ
u'حُكْمٌ شَهِيدٌ':Added, #1: 1	حُكْمَ الشُّهُودِ
u'حُكْمٌ شَيْءٌ':Added, #1: 1	حُكْمُ الشَّهِيدِ
u'حُكْمٌ شَيْءٌ':Added, #2: 2	حُكْمِ الشَّيْءِ
u'حُكْمٌ شَيْءٌ':Added, #5: 5	حُكْمُ الشَّيْءِ
u'حُكْمٌ شَيْءٌ':Added, #6: 6	حُكْمَ الشَّيْءِ
u'حَكَمَ شَيْخٌ':Subject, #7: 7	حُكْمِ شَيْءٍ
u'حُكْمٌ شَيْخٌ':Added, #1: 1	حَكَمَ الشَّيْخُ
u'حُكْمٌ صَاحِبٌ':Added, #1: 1	حُكْمَ الشَّيْخِ
u'حُكْمٌ صَاحِبٌ':Added, #1: 1	حُكْمِ صَاحِبِ
u'حُكْمٌ صَاحِبٌ':Added, #1: 1	حُكْمَ صَاحِبِهِ
u'حُكْمٌ صَاحِبٌ':Added, #1: 1	حُكْمِ صَاحِبِهِ
u'حُكْمٌ صَاحِبٌ':Added, #2: 2	حُكْمُ صَاحِبِ
u'حُكْمٌ صَاعٌ':Added, #3: 3	حُكْمَ صَاحِبِ
u'حُكْمٌ صَبٌّ':Added, #1: 1	حُكْمِ الصَّاعِ
u'حُكْمٌ صَبِيٌّ':Added, #1: 1	حُكْمُ الصَّبِّ
u'حُكْمٌ صَبِيٌّ':Added, #3: 3	حُكْمَ الصَّبِيِّ
u'حُكْمٌ صَبِيٌّ':Added, #3: 3	حُكْمِ الصَّبِيِّ
u'حَكَمَ صَحَابَةٌ':Subject, #7: 7	حُكْمُ الصَّبِيِّ
u'حُكْمٌ صَحَابَةٌ':Added, #2: 2	حَكَمَ الصَّحَابَةُ
u'حُكْمٌ صَحَابِيٌّ':Added, #1: 1	حُكْمِ الصَّحَابَةِ
u'حُكْمٌ صَحَابِيٌّ':Added, #1: 1	حُكْمِ الصَّحَابِيِّ
u'حُكْمٌ صُحَاةٌ':Added, #2: 2	حُكْمُ الصَّحَابِيِّ
u'حُكْمٌ صِحَّةٌ':Added, #1: 1	حُكْمَ الصُّحَاةِ
u'حُكْمٌ صِحَّةٌ':Added, #15: 15	حُكْمُ الصِّحَّةِ
u'حُكْمٌ صِحَّةٌ':Added, #1: 1	حُكْمُ صِحَّةِ
u'حُكْمٌ صِحَّةٌ':Added, #1: 1	حُكْمِ صِحَّةِ
u'حُكْمٌ صَحْرَاءُ':Added, #3: 3	حُكْمِ الصِّحَّةِ
u'حُكْمٌ صَحِيحٌ':Added, #3: 3	حُكْمُ الصَّحْرَاءِ
u'حُكْمٌ صَحِيحٌ':Added, #10: 10	حُكْمُ الصَّحِيحِ
u'حُكْمٌ صَحِيحٌ':Added, #1: 1	حُكْمِ صَحِيحِ
u'حُكْمٌ صَحِيحٌ':Added, #2: 2	حُكْمُ الصَّحِيحَةِ
u'حُكْمٌ صداق':Added, #6: 6	حُكْمِ الصَّحِيحِ
u'حُكْمٌ صداق':Added, #1: 1	حُكْمَ الصَّدَاقِ
u'حُكْمٌ صداق':Added, #1: 1	حُكْمُ الصَّدَاقِ
u'حُكْمٌ صَدَاقٌ':Added, #1: 1	حُكْمِ الصَّدَاقِ
u'حُكْمٌ صَدَاقٌ':Added, #1: 1	حُكْمَ الصَّدَاقِ
u'حُكْمٌ صَدَاقٌ':Added, #1: 1	حُكْمُ الصَّدَاقِ
u'حُكْمٌ صَدْرٌ':Added, #1: 1	حُكْمِ الصَّدَاقِ
u'حُكْمٌ صُدْغٌ':Added, #2: 2	حُكْمِ الصَّدْرِ
u'حُكْمٌ صَدَفٌ':Added, #1: 1	حُكْمَ الصُّدْغِ
u'حُكْمٌ صدق':Added, #1: 1	حُكْمُ الصَّدَفِ
u'حُكْمٌ صِدْقٌ':Added, #3: 3	حُكْمَ صِدْقِهِ
u'حُكْمٌ صدقة':Added, #3: 3	حُكْمَ صِدْقِهِ
u'حُكْمٌ صَدَقَةٌ':Added, #1: 1	حُكْمُ الصّدَقَةِ
u'حُكْمٌ صدقة':Added, #1: 1	حُكْمُ الصّدَقَةِ
u'حُكْمٌ صَدَقَةٌ':Added, #3: 3	حُكْمِ الصَّدَقَةِ
u'حُكْمٌ صدقة':Added, #3: 3	حُكْمِ الصَّدَقَةِ
u'حُكْمٌ صَدَقَةٌ':Added, #4: 4	حُكْمُ الصَّدَقَةِ
u'حُكْمٌ صُدُورٌ':Added, #4: 4	حُكْمُ الصَّدَقَةِ
u'حُكْمٌ صَرْفٌ':Added, #1: 1	حُكْمُ صُدُورِ
u'حُكْمٌ صَرْف':Added, #1: 1	حُكْمَ الصَّرْفِ
u'حُكْمٌ صَرْفٌ':Added, #1: 1	حُكْمَ الصَّرْفِ
u'حُكْمٌ صَرْف':Added, #6: 6	حُكْمُ الصَّرْفِ
u'حُكْمٌ صَرِيحٌ':Added, #6: 6	حُكْمُ الصَّرْفِ
u'حُكْمٌ صَرِيحٌ':Added, #2: 2	حُكْمُ الصَّرِيحِ
u'حُكْمٌ صغار':Added, #5: 5	حُكْمِ الصَّرِيحِ
u'حُكْمٌ صِغَرٌ':Added, #1: 1	حُكْمِ الصِّغَارِ
u'حُكْمٌ صَغِيرٌ':Added, #2: 2	حُكْمُ الصِّغَرِ
u'حُكْمٌ صَغِيرٌ':Added, #1: 1	حُكْمُ الصَّغِيرِ
u'حُكْمٌ صَغِيرٌ':Added, #1: 1	حُكْمِ الصَّغِيرِ
u'حُكْمٌ صَفٌّ':Added, #1: 1	حُكْمُ الصَّغِيرَةِ
u'حُكْمٌ صَفَاءٌ':Added, #2: 2	حُكْمُ الصَّفِّ
u'حُكْمٌ صِفَةٌ':Added, #1: 1	حُكْمِ الصَّفَاءِ
u'حُكْمٌ صِفَةٌ':Added, #1: 1	حُكْمُ الصِّفَاتِ
u'حُكْمٌ صِفَةٌ':Added, #1: 1	حُكْمِ صِفَةِ
u'حُكْمٌ صِفَةٌ':Added, #2: 2	حُكْمِ الصِّفَةِ
u'حُكْمٌ صَفْق':Added, #4: 4	حُكْمُ الصِّفَةِ
u'حُكْمٌ صَفْقَةٌ':Added, #1: 1	حُكْمِ صَفْقَتَيْنِ
u'حُكْمٌ صَفْقَةٌ':Added, #1: 1	حُكْمِ صَفْقَةٍ
u'حُكْمٌ صَلاَةٌ':Added, #2: 2	حُكْمِ الصَّفْقَةِ
u'حُكْمٌ صَلاَةٌ':Added, #16: 16	حُكْمُ الصَّلَاةِ
u'حُكْمٌ صَلاَةٌ':Added, #16: 16	حُكْمِ الصَّلَاةِ
u'حُكْمٌ صَلاَةٌ':Added, #1: 1	حُكْمِ صَلَاةٍ
u'حُكْمٌ صَلاَةٌ':Added, #1: 1	حُكْمَ صَلَاتِهِ
u'حُكْمٌ صَلاَةٌ':Added, #4: 4	حُكْمُ صَلَاةِ
u'حُكْمٌ صَلاَةٌ':Added, #4: 4	حُكْمِ صَلَاةِ
u'حُكْمٌ صَلاَةٌ':Added, #6: 6	حُكْمَ الصَّلَاةِ
u'حُكْمٌ صَلاَحٌ':Added, #7: 7	حُكْمَ صَلَاةِ
u'حُكْمٌ صِلَةٌ':Added, #1: 1	حُكْمُ صَلَاحِ
u'حُكْمٌ صِلَةٌ':Added, #1: 1	حُكْمِ الصِّلَاتِ
u'حُكْمٌ صلح':Added, #2: 2	حُكْمِ الصِّلَةِ
u'حُكْمٌ صُلْحٌ':Added, #1: 1	حُكْمُ الصُّلْحِ
u'حُكْمٌ صلح':Added, #1: 1	حُكْمُ الصُّلْحِ
u'حُكْمٌ صُلْحٌ':Added, #2: 2	حُكْمِ الصُّلْحِ
u'حُكْمٌ صلح':Added, #2: 2	حُكْمِ الصُّلْحِ
u'حُكْمٌ صُلْحٌ':Added, #3: 3	حُكْمَ الصُّلْحِ
u'حُكْمٌ صَلَوَاتٌ':Added, #3: 3	حُكْمَ الصُّلْحِ
u'حُكْمٌ صنعة':Added, #1: 1	حُكْمُ الصَّلَوَاتِ
u'حُكْمٌ صَنْعَةٌ':Added, #1: 1	حُكْمُ صَنْعَةِ
u'حُكْمٌ صنعة':Added, #1: 1	حُكْمُ صَنْعَةِ
u'حُكْمٌ صَنْعَةٌ':Added, #1: 1	حُكْمُ صَنْعَتِهِ
u'حُكْمٌ صُورٌ':Added, #1: 1	حُكْمُ صَنْعَتِهِ
u'حُكْمٌ صُوَرٌ':Added, #1: 1	حُكْمِ الصُّوَرِ
u'حُكْمٌ صُورٌ':Added, #1: 1	حُكْمِ الصُّوَرِ
u'حُكْمٌ صُورٌ':Added, #1: 1	حُكْمُ الصُّورَتَيْنِ
u'حُكْمٌ صُورٌ':Added, #1: 1	حُكْمِ الصُّورَتَيْنِ
u'حُكْمٌ صُورٌ':Added, #1: 1	حُكْمُ صُورَتَيْنِ
u'حُكْمٌ صُوَرٌ':Added, #1: 1	حُكْمُ صُوَرِهِ
u'حُكْمٌ صُورَةٌ':Added, #1: 1	حُكْمُ صُوَرِهِ
u'حُكْمٌ صُورَةٌ':Added, #1: 1	حُكْمَ الصُّورَةِ
u'حُكْمٌ صُورَةٌ':Added, #2: 2	حُكْمُ الصُّورَةِ
u'حُكْمٌ صَوْمٌ':Added, #2: 2	حُكْمِ صُورَةِ
u'حُكْمٌ صَوْمٌ':Added, #1: 1	حُكْمَ صَوْمِ
u'حِكَمٌ صَوْمٌ':Added, #1: 1	حُكْمُ صَوْمِ
u'حُكْمٌ صَوْمٌ':Added, #1: 1	حِكَمِ صَوْمِهِ
u'حُكْمٌ صَوْمٌ':Added, #3: 3	حُكْمُ الصَّوْمِ
u'حُكْمٌ صَوْمٌ':Added, #3: 3	حُكْمُ صَوْمِهِ
u'حُكْمٌ صَوْمٌ':Added, #4: 4	حُكْمَ الصَّوْمِ
u'حُكْمٌ صِيَامٌ':Added, #4: 4	حُكْمِ الصَّوْمِ
u'حُكْمٌ صَيْدٌ':Added, #3: 3	حُكْمُ الصِّيَامِ
u'حُكْمٌ صَيْدٌ':Added, #1: 1	حُكْمَ الصَّيْدِ
u'حُكْمٌ صَيْدٌ':Added, #1: 1	حُكْمُ صَيْدِ
u'حُكْمٌ صَيْدٌ':Added, #1: 1	حُكْمَ صَيْدِهِ
u'حُكْمٌ صَيْدٌ':Added, #3: 3	حُكْمُ الصَّيْدِ
u'حُكْمٌ صَيْرَفِيٌّ':Added, #3: 3	حُكْمِ الصَّيْدِ
u'حُكْمٌ ضَالٌّ':Added, #2: 2	حُكْمُ الصَّيْرَفِيِّ
u'حُكْمٌ ضَرْبٌ':Added, #1: 1	حُكْمُ الضَّالَّةِ
u'حُكْمٌ ضَرُورَةٌ':Added, #1: 1	حُكْمُ ضَرْبِ
u'حُكْمٌ ضَرُورَةٌ':Added, #1: 1	حُكْمَ الضَّرُورَةِ
u'حُكْمٌ ضَمَانٌ':Added, #1: 1	حُكْمِ الضَّرُورَةِ
u'حُكْمٌ ضَمَانٌ':Added, #12: 12	حُكْمِ الضَّمَانِ
u'حُكْمٌ ضَمَانٌ':Added, #1: 1	حُكْمُ ضَمَانِهِ
u'حُكْمٌ ضَمَانٌ':Added, #1: 1	حُكْمِ ضَمَانِهِ
u'حُكْمٌ ضَمَانٌ':Added, #3: 3	حُكْمَ الضَّمَانِ
u'حُكْمٌ ضَمَانٌ':Added, #4: 4	حُكْمَ ضَمَانِ
u'حُكْمٌ ضَمَانٌ':Added, #4: 4	حُكْمُ ضَمَانِ
u'حُكْمٌ طَارِئٌ':Added, #9: 9	حُكْمُ الضَّمَانِ
u'حُكْمٌ طَاعَةٌ':Added, #1: 1	حُكْمُ الطَّارِئِ
u'حُكْمٌ طَالِقٌ':Added, #1: 1	حُكْمُ طَاعَةِ
u'حُكْمٌ طَاهِرٌ':Added, #1: 1	حُكْمُ طَالِقٍ
u'حُكْمٌ طَاهِرٌ':Added, #1: 1	حُكْمَ الطَّاهِرِ
u'حُكْمٌ طَاهِرٌ':Added, #1: 1	حُكْمُ الطَّاهِرَةِ
u'حُكْمٌ طَاهِرٌ':Added, #2: 2	حُكْمُ الطَّاهِرِ
u'حُكْمٌ طَاهِرٌ':Added, #2: 2	حُكْمِ الطَّاهِرَاتِ
u'حُكْمٌ طَاهِرٌ':Added, #3: 3	حُكْمِ الطَّاهِرِ
u'حُكْمٌ طَائِفٌ':Added, #4: 4	حُكْمُ الطَّاهِرَاتِ
u'حَكَمَ طِبٌّ':Subject, #1: 1	حُكْمَ الطَّائِفِ
u'حُكْمٌ طِبٌّ':Added, #1: 1	حَكَمَ الطِّبُّ
u'حُكْمٌ طَبَائِعُ':Added, #1: 1	حُكْمُ الطِّبِّ
u'حُكْمٌ طَبِيبٌ':Added, #1: 1	حُكْمِ الطَّبَائِعِ
u'حُكْمٌ طِحَالٌ':Added, #1: 1	حُكْمُ الطَّبِيبِ
u'حُكْمٌ طَرْحٌ':Added, #2: 2	حُكْمُ الطِّحَالِ
u'حُكْمٌ طرف':Added, #1: 1	حُكْمِ طَرْحِهِ
u'حُكْمٌ طرف':Added, #1: 1	حُكْمَ الطَّرَفِ
u'حُكْمٌ طَرَفٌ':Added, #1: 1	حُكْمُ الطَّرَفِ
u'حُكْمٌ طَرَفٌ':Added, #1: 1	حُكْمَ الطَّرَفِ
u'حُكْمٌ طَرَفٌ':Added, #1: 1	حُكْمُ الطَّرَفِ
u'حُكْمٌ طَرَفٌ':Added, #1: 1	حُكْمِ الطَّرَفَيْنِ
u'حُكْمٌ طرف':Added, #1: 1	حُكْمَ طَرَفٍ
u'حُكْمٌ طَرَفٌ':Added, #3: 3	حُكْمَ طَرَفِ
u'حُكْمٌ طَرِيقٌ':Added, #3: 3	حُكْمَ طَرَفِ
u'حُكْمٌ طعام':Added, #3: 3	حُكْمَ الطَّرِيقِ
u'حُكْمٌ طَعَامٌ':Added, #1: 1	حُكْمِ الطَّعَامِ
u'حُكْمٌ طعام':Added, #1: 1	حُكْمِ الطَّعَامِ
u'حُكْمٌ طَعَامٌ':Added, #2: 2	حُكْمَ الطَّعَامِ
u'حُكْمٌ طعام':Added, #2: 2	حُكْمَ الطَّعَامِ
u'حُكْمٌ طَعَامٌ':Added, #4: 4	حُكْمُ الطَّعَامِ
u'حُكْمٌ طَلاَقٌ':Added, #4: 4	حُكْمُ الطَّعَامِ
u'حُكْمٌ طَلاَقٌ':Added, #12: 12	حُكْمُ الطَّلَاقِ
u'حُكْمٌ طَلاَقٌ':Added, #17: 17	حُكْمِ الطَّلَاقِ
u'حُكْمٌ طَلاَقٌ':Added, #1: 1	حُكْمُ طَلَاقٍ
u'حُكْمٌ طَلاَقٌ':Added, #1: 1	حُكْمُ طَلَاقِ
u'حُكْمٌ طَلاَقٌ':Added, #1: 1	حُكْمُ طَلَاقِهِ
u'حُكْمٌ طلب':Added, #8: 8	حُكْمَ الطَّلَاقِ
u'حُكْمٌ طلب':Added, #1: 1	حُكْمَ طَلَبِ
u'حُكْمٌ طَلَبٌ':Added, #1: 1	حُكْمِ طَلَبِ
u'حُكْمٌ طَلَبٌ':Added, #1: 1	حُكْمَ طَلَبِ
u'حُكْمٌ طَلَبَةٌ':Added, #1: 1	حُكْمِ طَلَبِ
u'حُكْمٌ طُلُوعٌ':Added, #1: 1	حُكْمُ الطَّلَبَةِ
u'حُكْمٌ طُمَأْنِينَةٌ':Added, #1: 1	حُكْمِ الطُّلُوعِ
u'حُكْمٌ طِهَارَةٌ':Added, #1: 1	حُكْمُ الطُّمَأْنِينَةِ
u'حُكْمٌ طَهَارَةٌ':Added, #1: 1	حُكْمِ الطِّهَارَاتِ
u'حُكْمٌ طِهَارَةٌ':Added, #1: 1	حُكْمِ الطّهَارَةِ
u'حُكْمٌ طَهَارَةٌ':Added, #1: 1	حُكْمِ الطّهَارَةِ
u'حُكْمٌ طَهَارَةٌ':Added, #1: 1	حُكْمُ طَهَارَةِ
u'حُكْمٌ طَهَارَةٌ':Added, #1: 1	حُكْمُ طَهَارَتِهِ
u'حُكْمٌ طَهَارَةٌ':Added, #3: 3	حُكْمُ الطَّهَارَةِ
u'حُكْمٌ طَهَارَةٌ':Added, #4: 4	حُكْمَ الطَّهَارَةِ
u'حُكْمٌ طهر':Added, #7: 7	حُكْمِ الطَّهَارَةِ
u'حُكْمٌ طُهْرٌ':Added, #4: 4	حُكْمُ الطُّهْرِ
u'حُكْمٌ طواف':Added, #4: 4	حُكْمُ الطُّهْرِ
u'حُكْمٌ طواف':Added, #1: 1	حُكْمَ الطَّوَافِ
u'حُكْمٌ طَوَافٌ':Added, #1: 1	حُكْمُ الطَّوَافِ
u'حُكْمٌ طَوَافٌ':Added, #1: 1	حُكْمَ الطَّوَافِ
u'حُكْمٌ طواف':Added, #1: 1	حُكْمُ الطَّوَافِ
u'حُكْمٌ طَوَافٌ':Added, #2: 2	حُكْمَ طَوَافِ
u'حُكْمٌ طِيبٌ':Added, #2: 2	حُكْمَ طَوَافِ
u'حُكْمٌ طِيبٌ':Added, #1: 1	حُكْمِ طِيبِ
u'حُكْمٌ ظاهِرٌ':Added, #2: 2	حُكْمُ الطِّيبِ
u'حُكْمٌ ظاهِرٌ':Added, #1: 1	حُكْمِ ظَاهِرِ
u'حُكْمٌ ظاهِرٌ':Added, #25: 25	حُكْمِ الظَّاهِرِ
u'حُكْمٌ ظاهِرٌ':Added, #4: 4	حُكْمَ الظَّاهِرِ
u'حُكْمٌ ظَرْفٌ':Added, #7: 7	حُكْمُ الظَّاهِرِ
u'حُكْمٌ ظَنٌّ':Added, #1: 1	حُكْمَ الظَّرْفِ
u'حُكْمٌ ظَنٌّ':Added, #1: 1	حُكْمَ الظَّنِّ
u'حُكْمٌ ظَنٌّ':Added, #1: 1	حُكْمُ الظَّنِّ
u'حُكْمٌ ظهار':Added, #1: 1	حُكْمِ الظَّنِّ
u'حُكْمٌ ظهار':Added, #1: 1	حُكْمُ ظِهَارِهِ
u'حُكْمٌ ظهار':Added, #2: 2	حُكْمَ الظِّهَارِ
u'حُكْمٌ ظهار':Added, #4: 4	حُكْمُ الظِّهَارِ
u'حُكْمٌ ظَهْرٌ':Added, #7: 7	حُكْمِ الظِّهَارِ
u'حُكْمٌ ظُهْرٌ':Added, #1: 1	حُكْمُ الظَّهْرِ
u'حُكْمٌ ظُهْرٌ':Added, #1: 1	حُكْمُ الظُّهْرَيْنِ
u'حُكْمٌ ظُهورٌ':Added, #2: 2	حُكْمُ الظُّهْرِ
u'حُكْمٌ ظُهورٌ':Added, #1: 1	حُكْمُ الظُّهُورِ
u'حُكْمٌ عَاجِزٌ':Added, #2: 2	حُكْمِ ظُهُورِهِ
u'حُكْمٌ عَاجِلٌ':Added, #4: 4	حُكْمُ الْعَاجِزِ
u'حُكْمٌ عَادَةٌ':Added, #2: 2	حُكْمِ الْعَاجِلِ
u'حُكْمٌ عَادَةٌ':Added, #1: 1	حُكْمَ الْعَادَاتِ
u'حُكْمٌ عَادَةٌ':Added, #1: 1	حُكْمِ الْعَادَاتِ
u'حُكْمٌ عادِم':Added, #4: 4	حُكْمِ الْعَادَةِ
u'حُكْمٌ عارِيَّةٌ':Added, #1: 1	حُكْمُ الْعَادِمِ
u'حُكْمٌ عارِيَّةٌ':Added, #1: 1	حُكْمُ عَارِيَّةٍ
u'حُكْمٌ عارِيَّةٌ':Added, #2: 2	حُكْمَ الْعَارِيَّةِ
u'حُكْمٌ عارِيَّةٌ':Added, #3: 3	حُكْمِ الْعَارِيَّةِ
u'حُكْمٌ عَاقِبٌ':Added, #7: 7	حُكْمُ الْعَارِيَّةِ
u'حُكْمٌ عَاقِبَةٌ':Added, #1: 1	حُكْمِ الْعَاقِبَةِ
u'حُكْمٌ عَاقِلٌ':Added, #1: 1	حُكْمِ الْعَاقِبَةِ
u'حُكْمٌ عَاقِلٌ':Added, #1: 1	حُكْمُ الْعَاقِلَةِ
u'حُكْمٌ عَامٌّ':Added, #1: 1	حُكْمِ عَاقِلٍ
u'حُكْمٌ عَامٌّ':Added, #1: 1	حُكْمِ الْعَامَّةِ
u'حُكْمٌ عَامٌّ':Added, #2: 2	حُكْمٍ عَامٍّ
u'حُكْمٌ عَامٌّ':Added, #3: 3	حُكْمَ الْعَامِّ
u'حُكْمٌ عَامٌّ':Added, #5: 5	حُكْمُ الْعَامِّ
u'حُكْمٌ عَامِرٌ':Added, #5: 5	حُكْمِ الْعَامِّ
u'حُكْمٌ عَامِلٌ':Added, #1: 1	حُكْمُ الْعَامِرِ
u'حُكْمٌ عَامِلٌ':Added, #1: 1	حُكْمِ عَامِلِ
u'حُكْمٌ عَامِّيٌّ':Added, #3: 3	حُكْمُ الْعَامِلِ
u'حُكْمٌ عِبَادَةٌ':Added, #1: 1	حُكْمُ الْعَامِّيِّ
u'حُكْمٌ عِبَادَةٌ':Added, #1: 1	حُكْمُ الْعِبَادَاتِ
u'حُكْمٌ عِبَادَةٌ':Added, #1: 1	حُكْمُ عِبَادَتِهِ
u'حَكَمَ عَبْدٌ':Subject, #2: 2	حُكْمَ الْعِبَادَةِ
u'حُكْمٌ عَبْدٌ':Added, #1: 1	حَكَمَ الْعَبْدُ
u'حُكْمٌ عَبْدٌ':Added, #13: 13	حُكْمُ الْعَبْدِ
u'حُكْمٌ عَبْدٌ':Added, #1: 1	حُكْمَ عَبْدِ
u'حُكْمٌ عَبْدٌ':Added, #1: 1	حُكْمُ عَبْدِ
u'حُكْمٌ عَبْدٌ':Added, #2: 2	حُكْمِ الْعَبْدِ
u'حُكْمٌ عَبْدٌ':Added, #5: 5	حُكْمَ عَبْدٍ
u'حُكْمٌ عَبِيدٌ':Added, #7: 7	حُكْمَ الْعَبْدِ
u'حُكْمٌ عَبِيدٌ':Added, #1: 1	حُكْمِ الْعَبِيدِ
u'حُكْمٌ عتاق':Added, #2: 2	حُكْمَ الْعَبِيدِ
u'حُكْمٌ عتق':Added, #1: 1	حُكْمُ الْعَتَاقِ
u'حُكْمٌ عِتْقٌ':Added, #11: 11	حُكْمِ الْعِتْقِ
u'حُكْمٌ عتق':Added, #11: 11	حُكْمِ الْعِتْقِ
u'حُكْمٌ عِتْقٌ':Added, #12: 12	حُكْمُ الْعِتْقِ
u'حُكْمٌ عتق':Added, #12: 12	حُكْمُ الْعِتْقِ
u'حُكْمٌ عِتْقٌ':Added, #1: 1	حُكْمَ عِتْقِ
u'حُكْمٌ عتق':Added, #1: 1	حُكْمَ عِتْقِ
u'حُكْمٌ عِتْقٌ':Added, #3: 3	حُكْمُ عِتْقِ
u'حُكْمٌ عتق':Added, #3: 3	حُكْمُ عِتْقِ
u'حُكْمٌ عِتْقٌ':Added, #5: 5	حُكْمَ الْعِتْقِ
u'حُكْمٌ عجز':Added, #5: 5	حُكْمَ الْعِتْقِ
u'حُكْمٌ عَجْزٌ':Added, #2: 2	حُكْمَ الْعَجْزِ
u'حُكْمٌ عِدَادٌ':Added, #2: 2	حُكْمَ الْعَجْزِ
u'حُكْمٌ عَدَالَةٌ':Added, #1: 1	حُكْمِ عِدَادِ
u'حُكْمٌ عَدَالَةٌ':Added, #1: 1	حُكْمُ الْعَدَالَةِ
u'حُكْمٌ عِدَّةٌ':Added, #1: 1	حُكْمُ عَدَالَتِهِ
u'حُكْمٌ عِدَّةٌ':Added, #12: 12	حُكْمِ الْعِدَّةِ
u'حُكْمٌ عِدَّةٌ':Added, #1: 1	حُكْمَ الْعِدَّةِ
u'حُكْمٌ عَدْلٌ':Added, #7: 7	حُكْمُ الْعِدَّةِ
u'حُكْمٌ عَدْلٌ':Added, #1: 1	حُكْمُ عَدْلِ
u'حُكْمٌ عَدَمٌ':Added, #3: 3	حُكْمُ الْعَدْلِ
u'حُكْمٌ عَدَمٌ':Added, #13: 13	حُكْمِ الْعَدَمِ
u'حُكْمٌ عَدَمٌ':Added, #1: 1	حُكْمَ الْعَدَمِ
u'حُكْمٌ عَدَمٌ':Added, #1: 1	حُكْمَ عَدَمِ
u'حُكْمٌ عَدَمٌ':Added, #2: 2	حُكْمِ عَدَمِ
u'حُكْمٌ عَدَمٌ':Added, #3: 3	حُكْمُ الْعَدَمِ
u'حُكْمٌ عَدُوٌّ':Added, #4: 4	حُكْمُ عَدَمِ
u'حُكْمٌ عُدْوَانٌ':Added, #1: 1	حُكْمِ الْعَدُوِّ
u'حُكْمٌ عُذْرٌ':Added, #1: 1	حُكْمَ الْعُدْوَانِ
u'حَكَمَ عَرَبٌ':Predicate, #1: 1	حُكْمِ الْعُذْرِ
u'حُكْمٌ عَرَبِيٌّ':Added, #1: 1	حَكَمَ الْعَرَبَ
u'حُكْمٌ عَرْضٌ':Added, #1: 1	حُكْمُ الْعَرَبِيِّ
u'حُكْمٌ عرف':Added, #1: 1	حُكْمُ الْعَرْضِ
u'حُكْمٌ عرف':Added, #1: 1	حُكْمَ الْعُرْفِ
u'حُكْمٌ عُرْفٌ':Added, #1: 1	حُكْمُ الْعُرْفِ
u'حُكْمٌ عُرْفٌ':Added, #1: 1	حُكْمَ الْعُرْفِ
u'حُكْمٌ عرف':Added, #1: 1	حُكْمُ الْعُرْفِ
u'حُكْمٌ عُرْفٌ':Added, #1: 1	حُكْمِ عُرْفِ
u'حُكْمٌ عرف':Added, #1: 1	حُكْمِ عُرْفِ
u'حُكْمٌ عُرْفٌ':Added, #3: 3	حُكْمِ الْعُرْفِ
u'حُكْمٌ عَرَقٌ':Added, #3: 3	حُكْمِ الْعُرْفِ
u'حُكْمٌ عَرَقٌ':Added, #1: 1	حُكْمَ عَرَقِهِ
u'حُكْمٌ عُرُوضٌ':Added, #1: 1	حُكْمُ عَرَقِهِ
u'حُكْمٌ عُرُوضٌ':Added, #1: 1	حُكْمُ عُرُوضِ
u'حُكْمٌ عُرُوضٌ':Added, #2: 2	حُكْمَ الْعُرُوضِ
u'حُكْمٌ عُرُوضٌ':Added, #6: 6	حُكْمُ الْعُرُوضِ
u'حُكْمٌ عُرُوقٌ':Added, #6: 6	حُكْمِ الْعُرُوضِ
u'حُكْمٌ عزل':Added, #1: 1	حُكْمُ عُرُوقِ
u'حُكْمٌ عزل':Added, #1: 1	حُكْمَ عَزْلِهِ
u'حُكْمٌ عزلة':Added, #2: 2	حُكْمُ عَزْلِ
u'حُكْمٌ عُزْلَةٌ':Added, #1: 1	حُكْمُ الْعُزْلَةِ
u'حُكْمٌ عَسَلٌ':Added, #1: 1	حُكْمُ الْعُزْلَةِ
u'حُكْمٌ عُشْرٌ':Added, #1: 1	حُكْمِ الْعَسَلِ
u'حُكْمٌ عَصَبَةٌ':Added, #1: 1	حُكْمَ الْعُشْرِ
u'حُكْمٌ عَصِيرٌ':Added, #1: 1	حُكْمَ الْعَصَبَاتِ
u'حُكْمٌ عُضْوٌ':Added, #1: 1	حُكْمُ الْعَصِيرِ
u'حُكْمٌ عُضْوٌ':Added, #1: 1	حُكْمُ الْعُضْوِ
u'حُكْمٌ عطف':Added, #3: 3	حُكْمِ الْعُضْوِ
u'حُكْمٌ عَطْفٌ':Added, #1: 1	حُكْمِ الْعَطْفِ
u'حُكْمٌ عَظْمٌ':Added, #1: 1	حُكْمِ الْعَطْفِ
u'حُكْمٌ عَفْوٌ':Added, #1: 1	حُكْمُ الْعَظْمِ
u'حُكْمٌ عَفْوٌ':Added, #1: 1	حُكْمَ عَفْوِ
u'حُكْمٌ عَقَارٌ':Added, #3: 3	حُكْمِ الْعَفْوِ
u'حُكْمٌ عَقَارٌ':Added, #1: 1	حُكْمَ الْعَقَارِ
u'حُكْمٌ عَقَارٌ':Added, #1: 1	حُكْمِ عَقَارِ
u'حُكْمٌ عَقْدٌ':Added, #2: 2	حُكْمُ الْعَقَارِ
u'حُكْمٌ عَقْدٌ':Added, #16: 16	حُكْمِ الْعَقْدِ
u'حُكْمٌ عَقْدٌ':Added, #1: 1	حُكْمَ عَقْدَيْنِ
u'حُكْمٌ عَقْدٌ':Added, #38: 38	حُكْمُ الْعَقْدِ
u'حُكْمٌ عَقْدٌ':Added, #3: 3	حُكْمِ عَقْدِ
u'حُكْمٌ عَقْدٌ':Added, #3: 3	حُكْمِ عَقْدِهِ
u'حُكْمٌ عَقْدٌ':Added, #3: 3	حُكْمِ عَقْدَيْنِ
u'حُكْمٌ عَقْدٌ':Added, #4: 4	حُكْمِ عَقْدٍ
u'حُكْمٌ عقر':Added, #5: 5	حُكْمَ الْعَقْدِ
u'حُكْمٌ عُقْرٌ':Added, #1: 1	حُكْمَ الْعُقْرِ
u'حَكَّمَ عَقْلٌ':Subject, #1: 1	حُكْمَ الْعُقْرِ
u'حُكْمٌ عَقْلٌ':Added, #1: 1	حَكَّمَ عَقْلُهُ
u'حُكْمٌ عَقْلٌ':Added, #2: 2	حُكْمُ الْعَقْلِ
u'حُكْمٌ عَقْلِيٌّ':Added, #9: 9	حُكْمِ الْعَقْلِ
u'حُكْمٌ عُقُودٌ':Added, #1: 1	حُكْمٍ عَقْلِيٍّ
u'حُكْمٌ عُقُولٌ':Added, #1: 1	حُكْمِ الْعُقُودِ
u'حُكْمٌ عَكْسٌ':Added, #1: 1	حُكْمِ الْعُقُولِ
u'حُكْمٌ عِلَّةٌ':Added, #1: 1	حُكْمُ عَكْسِ
u'حُكْمٌ عِلَّةٌ':Added, #10: 10	حُكْمُ الْعِلَّةِ
u'حُكْمٌ عِلَّةٌ':Added, #3: 3	حُكْمِ عِلَّةٍ
u'حُكْمٌ عِلَّةٌ':Added, #5: 5	حُكْمِ الْعِلَّةِ
u'حُكْمٌ عَلَقَةٌ':Added, #7: 7	حُكْمَ الْعِلَّةِ
u'حُكْمٌ علم':Added, #2: 2	حُكْمُ الْعَلَقَةِ
u'حُكْمٌ عَلَمٌ':Added, #1: 1	حُكْمُ الْعَلَمِ
u'حُكْمٌ علم':Added, #1: 1	حُكْمُ الْعَلَمِ
u'حُكْمٌ عِلْمٌ':Added, #1: 1	حُكْمُ عِلْمِ
u'حَكَمَ علماء':Subject, #1: 1	حُكْمُ عِلْمِ
u'حَكَمَ عُلَمَاءُ':Subject, #1: 1	حَكَمَ الْعُلَمَاءُ
u'حُكْمٌ عِلِّيٌّ':Added, #1: 1	حَكَمَ الْعُلَمَاءُ
u'حُكْمٌ عِمَارَةٌ':Added, #1: 1	حُكْمُ الْعِلِّيَّةِ
u'حُكْمٌ عِمَارَةٌ':Added, #1: 1	حُكْمَ الْعِمَارَةِ
u'حُكْمٌ عِمَامَةٌ':Added, #2: 2	حُكْمِ الْعِمَارَةِ
u'حُكْمٌ عَمْدٌ':Added, #1: 1	حُكْمُ الْعِمَامَةِ
u'حُكْمٌ عمرة':Added, #4: 4	حُكْمِ الْعَمْدِ
u'حُكْمٌ عُمْرَةٌ':Added, #3: 3	حُكْمُ الْعُمْرَةِ
u'حُكْمٌ عَمَلٌ':Added, #3: 3	حُكْمُ الْعُمْرَةِ
u'حُكْمٌ عَمَلٌ':Added, #1: 1	حُكْمُ عَمَلِ
u'حُكْمٌ عَمَلٌ':Added, #1: 1	حُكْمِ عَمَلِهِ
u'حُكْمٌ عُمُومٌ':Added, #2: 2	حُكْمُ الْعَمَلِ
u'حُكْمٌ عُمُومٌ':Added, #1: 1	حُكْمَ عُمُومِ
u'حُكْمٌ عُمُومٌ':Added, #3: 3	حُكْمِ الْعُمُومِ
u'حُكْمٌ عناد':Added, #5: 5	حُكْمُ الْعُمُومِ
u'حُكْمٌ عِنَادٌ':Added, #1: 1	حُكْمُ الْعِنَادِ
u'حُكْمٌ عُنَّة':Added, #1: 1	حُكْمُ الْعِنَادِ
u'حُكْمٌ عُنَّة':Added, #1: 1	حُكْمُ الْعُنَّةِ
u'حُكْمٌ عَنْوَة':Added, #1: 1	حُكْمِ الْعُنَّةِ
u'حُكْمٌ عَهْدٌ':Added, #1: 1	حُكْمُ الْعَنْوَةِ
u'حُكْمٌ عَهْدٌ':Added, #1: 1	حُكْمِ الْعَهْدِ
u'حُكْمٌ عُهْدَةٌ':Added, #1: 1	حُكْمُ الْعَهْدَيْنِ
u'حُكْمٌ عُهْدَةٌ':Added, #1: 1	حُكْمَ الْعُهْدَةِ
u'حُكْمٌ عَوْرَةٌ':Added, #1: 1	حُكْمُ الْعُهْدَةِ
u'حُكْمٌ عَوْرَةٌ':Added, #1: 1	حُكْمِ الْعَوْرَةِ
u'حُكْمٌ عَوْرَةٌ':Added, #2: 2	حُكْمَ الْعَوْرَةِ
u'حُكْمٌ عِوَضٌ':Added, #4: 4	حُكْمُ الْعَوْرَةِ
u'حُكْمٌ عِوَضٌ':Added, #1: 1	حُكْمُ الْعِوَضِ
u'حُكْمٌ عَيْبٌ':Added, #2: 2	حُكْمِ الْعِوَضِ
u'حُكْمٌ عَيْبٌ':Added, #2: 2	حُكْمُ الْعَيْبِ
u'حُكْمٌ عِيسَوِيّ':Added, #4: 4	حُكْمَ الْعَيْبِ
u'حُكْمٌ عين':Added, #1: 1	حُكْمُ الْعِيسَوِيِّ
u'حُكْمٌ عَيْنٌ':Added, #14: 14	حُكْمِ الْعَيْنِ
u'حُكْمٌ عَيْن':Added, #14: 14	حُكْمِ الْعَيْنِ
u'حُكْمٌ عين':Added, #14: 14	حُكْمِ الْعَيْنِ
u'حُكْمٌ عَيْنٌ':Added, #1: 1	حُكْمَ عَيْنِ
u'حُكْمٌ عَيْن':Added, #1: 1	حُكْمَ عَيْنِ
u'حُكْمٌ عين':Added, #1: 1	حُكْمَ عَيْنِ
u'حُكْمٌ عَيْنٌ':Added, #2: 2	حُكْمِ عَيْنِ
u'حُكْمٌ عَيْن':Added, #2: 2	حُكْمِ عَيْنِ
u'حُكْمٌ عين':Added, #2: 2	حُكْمِ عَيْنِ
u'حُكْمٌ عَيْنٌ':Added, #2: 2	حُكْمُ عَيْنِهِ
u'حُكْمٌ عَيْن':Added, #2: 2	حُكْمُ عَيْنِهِ
u'حُكْمٌ عين':Added, #2: 2	حُكْمُ عَيْنِهِ
u'حُكْمٌ عَيْنٌ':Added, #3: 3	حُكْمُ عَيْنِ
u'حُكْمٌ عَيْنٌ':Added, #3: 3	حُكْمُ عَيْنِ
u'حُكْمٌ عَيْن':Added, #3: 3	حُكْمِ عَيْنٍ
u'حُكْمٌ عَيْن':Added, #3: 3	حُكْمُ عَيْنِ
u'حُكْمٌ عين':Added, #3: 3	حُكْمِ عَيْنٍ
u'حُكْمٌ عَيْنٌ':Added, #5: 5	حُكْمَ الْعَيْنِ
u'حُكْمٌ عَيْن':Added, #5: 5	حُكْمَ الْعَيْنِ
u'حُكْمٌ عين':Added, #5: 5	حُكْمَ الْعَيْنِ
u'حُكْمٌ عَيْنٌ':Added, #7: 7	حُكْمُ الْعَيْنِ
u'حُكْمٌ عَيْن':Added, #7: 7	حُكْمُ الْعَيْنِ
u'حُكْمٌ عُيُوبٌ':Added, #7: 7	حُكْمُ الْعَيْنِ
u'حُكْمٌ عُيُونٌ':Added, #1: 1	حُكْمِ الْعُيُوبِ
u'حُكْمٌ عُيُونٌ':Added, #1: 1	حُكْمَ عُيُونِ
u'حُكْمٌ عُيُونٌ':Added, #2: 2	حُكْمُ عُيُونِ
u'حُكْمٌ غَاصِبٌ':Added, #2: 2	حُكْمِ عُيُونِ
u'حُكْمٌ غَالِبٌ':Added, #4: 4	حُكْمُ الْغَاصِبِ
u'حُكْمٌ غَائِبٌ':Added, #2: 2	حُكْمَ الْغَالِبِ
u'حُكْمٌ غَايَةٌ':Added, #3: 3	حُكْمِ الْغَائِبِ
u'حُكْمٌ غَايَةٌ':Added, #1: 1	حُكْمَ الْغَايَةِ
u'حُكْمٌ غَايَةٌ':Added, #1: 1	حُكْمُ الْغَايَةِ
u'حُكْمٌ غَدِيرٌ':Added, #6: 6	حُكْمِ الْغَايَةِ
u'حُكْمٌ غَرْسٌ':Added, #3: 3	حُكْمُ الْغَدِيرِ
u'حُكْمٌ غُرُورٌ':Added, #1: 1	حُكْمُ الْغَرْسِ
u'حُكْمٌ غُرُورٌ':Added, #1: 1	حُكْمُ الْغُرُورِ
u'حُكْمٌ غَرِيبٌ':Added, #2: 2	حُكْمِ الْغُرُورِ
u'حُكْمٌ غُسَالَةٌ':Added, #2: 2	حُكْمُ الْغَرِيبِ
u'حُكْمٌ غَسْلٌ':Added, #2: 2	حُكْمُ الْغُسَالَةِ
u'حُكْمٌ غُسْلٌ':Added, #1: 1	حُكْمَ الْغَسْلِ
u'حُكْمٌ غُسْلٌ':Added, #1: 1	حُكْمَ الْغُسْلِ
u'حُكْمٌ غَسْلٌ':Added, #1: 1	حُكْمِ الْغُسْلِ
u'حُكْمٌ غُسْلٌ':Added, #1: 1	حُكْمَ غَسْلِ
u'حُكْمٌ غُسْلٌ':Added, #1: 1	حُكْمُ غُسْلِ
u'حُكْمٌ غَسْلٌ':Added, #1: 1	حُكْمِ غُسْلِ
u'حُكْمٌ غُسْلٌ':Added, #2: 2	حُكْمِ الْغَسْلِ
u'حُكْمٌ غِشٌّ':Added, #3: 3	حُكْمُ الْغُسْلِ
u'حُكْمٌ غَصْبٌ':Added, #1: 1	حُكْمُ الْغِشِّ
u'حُكْمٌ غَصْبٌ':Added, #1: 1	حُكْمُ غَصْبٍ
u'حُكْمٌ غَصْبٌ':Added, #1: 1	حُكْمِ غَصْبِ
u'حُكْمٌ غَصْبٌ':Added, #2: 2	حُكْمِ الْغَصْبِ
u'حُكْمٌ غُصْنٌ':Added, #5: 5	حُكْمُ الْغَصْبِ
u'حُكْمٌ غضب':Added, #2: 2	حُكْمَ الْغُصْنِ
u'حُكْمٌ غَضَبٌ':Added, #1: 1	حُكْمِ الْغَضَبِ
u'حُكْمٌ غِطَاءٌ':Added, #1: 1	حُكْمِ الْغَضَبِ
u'حُكْمٌ غُلاَمٌ':Added, #1: 1	حُكْمُ الْغِطَاءِ
u'حُكْمٌ غَلَبَةٌ':Added, #1: 1	حُكْمُ الْغُلَامِ
u'حُكْمٌ غَلَبَةٌ':Added, #1: 1	حُكْمَ الْغَلَبَةِ
u'حُكْمٌ غَلَبَةٌ':Added, #1: 1	حُكْمِ الْغَلَبَةِ
u'حُكْمٌ غَلَّةٌ':Added, #1: 1	حُكْمُ غَلَبَةِ
u'حُكْمٌ غَلَّةٌ':Added, #1: 1	حُكْمُ الْغَلَّةِ
u'حُكْمٌ غَنَمٌ':Added, #2: 2	حُكْمُ الْغَلَّاتِ
u'حُكْمٌ غَنِيمَةٌ':Added, #2: 2	حُكْمُ الْغَنَمِ
u'حُكْمٌ غُولٌ':Added, #2: 2	حُكْمُ الْغَنِيمَةِ
u'حُكْمٌ غِيبَةٌ':Added, #1: 1	حُكْمَ الْغُولِ
u'حُكْمٌ غَيْبَةٌ':Added, #1: 1	حُكْمُ الْغِيبَةِ
u'حُكْمٌ غِيبَةٌ':Added, #1: 1	حُكْمِ الْغَيْبَةِ
u'حُكْمٌ غَيْبَةٌ':Added, #1: 1	حُكْمَ غِيبَةِ
u'حَكَمَ غير':Predicate, #1: 1	حُكْمَ غَيْبَتِهِ
u'حَكَمَ غَيْرٌ':Predicate, #1: 1	حَكَمَ غَيْرَ
u'حَكَمَ غير':Subject, #1: 1	حَكَمَ غَيْرَ
u'حَكَمَ غَيْرٌ':Subject, #1: 1	حَكَمَ غَيْرُهُ
u'حُكْمٌ غير':Added, #1: 1	حَكَمَ غَيْرُهُ
u'حُكْمٌ غَيْرٌ':Added, #11: 11	حُكْمُ غَيْرِهِ
u'حُكْمٌ غير':Added, #11: 11	حُكْمُ غَيْرِهِ
u'حُكْمٌ غَيْرٌ':Added, #12: 12	حُكْمُ غَيْرِ
u'حُكْمٌ غير':Added, #12: 12	حُكْمُ غَيْرِ
u'حُكْمٌ غَيْرٌ':Added, #1: 1	حُكْمَ الْغَيْرِ
u'حُكْمٌ غَيْرٌ':Added, #1: 1	حُكْمَ الْغَيْرِ
u'حُكْمٌ غير':Added, #1: 1	حُكْمِ غَيْرٍ
u'حُكْمٌ غَيْرٌ':Added, #3: 3	حُكْمَ غَيْرِ
u'حُكْمٌ غير':Added, #3: 3	حُكْمَ غَيْرِ
u'حُكْمٌ غَيْرٌ':Added, #5: 5	حُكْمِ غَيْرِ
u'حُكْمٌ غير':Added, #5: 5	حُكْمِ غَيْرِ
u'حُكْمٌ غَيْرٌ':Added, #6: 6	حُكْمِ غَيْرِهِ
u'حُكْمٌ غير':Added, #6: 6	حُكْمِ غَيْرِهِ
u'حُكْمٌ غَيْرٌ':Added, #8: 8	حُكْمَ غَيْرِهِ
u'حُكْمٌ فاء':Added, #8: 8	حُكْمَ غَيْرِهِ
u'حُكْمٌ فَارٌّ':Added, #1: 1	حُكْمَ الْفَاءِ
u'حُكْمٌ فَارٌّ':Added, #1: 1	حُكْمُ الْفَارِّ
u'حُكْمٌ فَأْرٌ':Added, #1: 1	حُكْمِ الْفَارَّةِ
u'حُكْمٌ فَأْرٌ':Added, #1: 1	حُكْمُ الْفَأْرَتَيْنِ
u'حُكْمٌ فَارِسٌ':Added, #3: 3	حُكْمُ الْفَأْرَةِ
u'حُكْمٌ فَارِسٌ':Added, #1: 1	حُكْمَ الْفَارِسَيْنِ
u'حُكْمٌ فَاسِدٌ':Added, #2: 2	حُكْمُ الْفَارِسَيْنِ
u'حُكْمٌ فَاسِدٌ':Added, #1: 1	حُكْمُ الْفَاسِدِ
u'حُكْمٌ فَاسِدٌ':Added, #1: 1	حُكْمُ الْفَاسِدَةِ
u'حُكْمٌ فَاسِدٌ':Added, #1: 1	حُكْمَ فَاسِدِ
u'حُكْمٌ فَاسِدٌ':Added, #2: 2	حُكْمِ الْفَاسِدِ
u'حُكْمٌ فَاعِلٌ':Added, #4: 4	حُكْمَ الْفَاسِدِ
u'حُكْمٌ فَخْذٌ':Added, #1: 1	حُكْمَ الْفَاعِلِ
u'حُكْمٌ فخر':Added, #1: 1	حُكْمُ الْفَخْذِ
u'حُكْمٌ فَخْرٌ':Added, #1: 1	حُكْمِ فَخْرِ
u'حُكْمٌ فِدَاءٌ':Added, #1: 1	حُكْمِ فَخْرِ
u'حُكْمٌ فِدْيَةٌ':Added, #4: 4	حُكْمُ الْفِدَاءِ
u'حُكْمٌ فِدْيَةٌ':Added, #1: 1	حُكْمَ الْفِدْيَةِ
u'حُكْمٌ فَذٌّ':Added, #1: 1	حُكْمُ فِدْيَةِ
u'حُكْمٌ فرار':Added, #1: 1	حُكْمُ الْفَذِّ
u'حُكْمٌ فِرَارٌ':Added, #10: 10	حُكْمُ الْفِرَارِ
u'حُكْمٌ فرار':Added, #10: 10	حُكْمُ الْفِرَارِ
u'حُكْمٌ فِرَارٌ':Added, #2: 2	حُكْمِ الْفِرَارِ
u'حُكْمٌ فرار':Added, #2: 2	حُكْمِ الْفِرَارِ
u'حُكْمٌ فِرَارٌ':Added, #5: 5	حُكْمَ الْفِرَارِ
u'حُكْمٌ فِرَاشٌ':Added, #5: 5	حُكْمَ الْفِرَارِ
u'حُكْمٌ فِرَاشٌ':Added, #1: 1	حُكْمَ الْفِرَاشِ
u'حُكْمٌ فِرَاقٌ':Added, #1: 1	حُكْمِ الْفِرَاشِ
u'حُكْمٌ فَرَائِضُ':Added, #3: 3	حُكْمِ الْفِرَاقِ
u'حُكْمٌ فَرَسٌ':Added, #1: 1	حُكْمِ الْفَرَائِضِ
u'حُكْمٌ فَرَسٌ':Added, #1: 1	حُكْمَ الْفَرَسِ
u'حُكْمٌ فَرْشٌ':Added, #1: 1	حُكْمُ الْفَرَسِ
u'حُكْمٌ فَرْضٌ':Added, #1: 1	حُكْمِ فَرْشِهِ
u'حُكْمٌ فَرْضٌ':Added, #1: 1	حُكْمِ الْفَرْضِ
u'حُكْمٌ فَرْضٌ':Added, #1: 1	حُكْمَ فَرْضِ
u'حُكْمٌ فَرْضٌ':Added, #2: 2	حُكْمُ الْفَرْضِ
u'حُكْمٌ فَرْضٌ':Added, #2: 2	حُكْمُ فَرْضِ
u'حُكْمٌ فَرْعٌ':Added, #3: 3	حُكْمَ الْفَرْضِ
u'حُكْمٌ فَرْعٌ':Added, #15: 15	حُكْمَ الْفَرْعِ
u'حُكْمٌ فَرْعٌ':Added, #17: 17	حُكْمُ الْفَرْعِ
u'حُكْمٌ فَرْعٌ':Added, #1: 1	حُكْمُ فَرْعٍ
u'حُكْمٌ فَرْعٌ':Added, #1: 1	حُكْمُ فَرْعِهِ
u'حُكْمٌ فُرْقَةٌ':Added, #45: 45	حُكْمِ الْفَرْعِ
u'حُكْمٌ فُرْقَةٌ':Added, #1: 1	حُكْمُ الْفُرْقَةِ
u'حُكْمٌ فَرِيضَةٌ':Added, #1: 1	حُكْمِ الْفُرْقَةِ
u'حُكْمٌ فساد':Added, #2: 2	حُكْمِ الْفَرِيضَةِ
u'حُكْمٌ فَسَادٌ':Added, #2: 2	حُكْمَ الْفَسَادِ
u'حُكْمٌ فساد':Added, #2: 2	حُكْمَ الْفَسَادِ
u'حُكْمٌ فَسَادٌ':Added, #3: 3	حُكْمُ الْفَسَادِ
u'حُكْمٌ فَسْخٌ':Added, #3: 3	حُكْمُ الْفَسَادِ
u'حُكْمٌ فَسْخٌ':Added, #1: 1	حُكْمَ الْفَسْخِ
u'حُكْمٌ فَسْخٌ':Added, #1: 1	حُكْمُ الْفَسْخِ
u'حُكْمٌ فَسْخٌ':Added, #1: 1	حُكْمِ الْفَسْخِ
u'حُكْمٌ فَصَاحَةٌ':Added, #2: 2	حُكْمُ فَسْخِ
u'حُكْمٌ فَصْد':Added, #2: 2	حُكْمِ الْفَصَاحَةِ
u'حُكْمٌ فِضَّةٌ':Added, #1: 1	حُكْمُ الْفَصْدِ
u'حُكْمٌ فِضَّةٌ':Added, #1: 1	حُكْمُ الْفِضَّةِ
u'حُكْمٌ فِضَّةٌ':Added, #1: 1	حُكْمِ فِضَّةٍ
u'حُكْمٌ فضلة':Added, #5: 5	حُكْمِ الْفِضَّةِ
u'حُكْمٌ فَضْلَةٌ':Added, #1: 1	حُكْمُ فَضْلَةِ
u'حُكْمٌ فطرة':Added, #1: 1	حُكْمُ فَضْلَةِ
u'حُكْمٌ فِطْرَةٌ':Added, #1: 1	حُكْمُ الْفِطْرَةِ
u'حُكْمٌ فطرة':Added, #1: 1	حُكْمُ الْفِطْرَةِ
u'حُكْمٌ فِطْرَةٌ':Added, #3: 3	حُكْمَ الْفِطْرَةِ
u'حُكْمٌ فَعَّالٌ':Added, #3: 3	حُكْمَ الْفِطْرَةِ
u'حُكْمٌ فِعْلٌ':Added, #1: 1	حُكْمِ الْفَعَّالِ
u'حُكْمٌ فِعْلٌ':Added, #1: 1	حُكْمَ الْفِعْلَيْنِ
u'حُكْمٌ فِعْلٌ':Added, #1: 1	حُكْمُ الْفِعْلَيْنِ
u'حُكْمٌ فِعْلٌ':Added, #1: 1	حُكْمِ الْفِعْلَيْنِ
u'حُكْمٌ فِعْلٌ':Added, #1: 1	حُكْمُ فِعْلٍ
u'حُكْمٌ فِعْلٌ':Added, #1: 1	حُكْمِ فِعْلٍ
u'حُكْمٌ فِعْلٌ':Added, #1: 1	حُكْمِ فِعْلِهِ
u'حُكْمٌ فِعْلٌ':Added, #2: 2	حُكْمَ فِعْلِهِ
u'حُكْمٌ فِعْلٌ':Added, #3: 3	حُكْمُ فِعْلِهِ
u'حُكْمٌ فِعْلٌ':Added, #4: 4	حُكْمَ الْفِعْلِ
u'حُكْمٌ فِعْلٌ':Added, #4: 4	حُكْمِ الْفِعْلِ
u'حُكْمٌ فقهاء':Added, #9: 9	حُكْمُ الْفِعْلِ
u'حَكَمَ فلان':Subject, #1: 1	حُكْمِ الْفُقَهَاءِ
u'حَكَمَ فُلاَنٌ':Subject, #1: 1	حَكَمَ عُثْمَانُ
u'حَكَمَ فلان':Subject, #1: 1	حَكَمَ فُلَانٌ
u'حُكْمٌ فلان':Added, #6: 6	حَكَمَ الشَّافِعِيُّ
u'حُكْمٌ فلان':Added, #1: 1	حُكْمُ الرَّايَاتِ
u'حُكْمٌ فلان':Added, #1: 1	حُكْمِ الشَّافِعِيِّ
u'حُكْمٌ فلان':Added, #1: 1	حُكْمَ الصَّلَاتِيَّةِ
u'حُكْمٌ فلان':Added, #1: 1	حُكْمَ الْمَرْوِيِّ
u'حُكْمٌ فُلاَنٌ':Added, #1: 1	حُكْمُ النَّهَارِيَّةِ
u'حُكْمٌ فُلاَنٌ':Added, #1: 1	حُكْمَ فُلَانٍ
u'حُكْمٌ فلان':Added, #1: 1	حُكْمُ فُلَانٍ
u'حُكْمٌ فلان':Added, #3: 3	حُكْمَ الشَّافِعِيِّ
u'حُكْمٌ فلان':Added, #3: 3	حُكْمُ الشَّافِعِيِّ
u'حُكْمٌ فُلاَنٌ':Added, #3: 3	حُكْمِ الْمَكِّيِّ
u'حُكْمٌ فُلُوسٌ':Added, #5: 5	حُكْمِ فُلَانٍ
u'حُكْمٌ فُلُوسٌ':Added, #1: 1	حُكْمُ الْفُلُوسِ
u'حُكْمٌ فَوَاتٌ':Added, #1: 1	حُكْمِ الْفُلُوسِ
u'حُكْمٌ فَيْءٌ':Added, #1: 1	حُكْمُ الْفَوَاتِ
u'حُكْمٌ فَيْءٌ':Added, #1: 1	حُكْمَ الْفَيْءِ
u'حُكْمٌ فِيلٌ':Added, #3: 3	حُكْمُ الْفَيْءِ
u'حُكْمٌ قَاتٌ':Added, #1: 1	حُكْمُ الْفِيلِ
u'حُكْمٌ قَاتِلٌ':Added, #1: 1	حُكْمِ الْقَاتِ
u'حُكْمٌ قَادِرٌ':Added, #1: 1	حُكْمَ قَاتِلِ
u'حُكْمٌ قَادِرٌ':Added, #1: 1	حُكْمُ الْقَادِرِ
u'حُكْمٌ قَاسِمٌ':Added, #1: 1	حُكْمِ الْقَادِرِ
u'حُكْمٌ قَاضِي':Added, #1: 1	حُكْمُ الْقَاسِمِ
u'حُكْمٌ قَاعِدٌ':Added, #1: 1	حُكْمَ الْقَاضِيَيْنِ
u'حُكْمٌ قَالِبٌ':Added, #2: 2	حُكْمَ الْقَاعِدِ
u'حُكْمٌ قَاهِرٌ':Added, #2: 2	حُكْمَ الْقَالِبِ
u'حُكْمٌ قَائِدٌ':Added, #1: 1	حُكْمِ الْقَاهِرِ
u'حُكْمٌ قَائِمٌ':Added, #1: 1	حُكْمِ الْقَائِدِ
u'حُكْمٌ قَائِمٌ':Added, #1: 1	حُكْمِ الْقَائِمَةِ
u'حُكْمٌ قَائِمَةٌ':Added, #3: 3	حُكْمِ الْقَائِمِ
u'حُكْمٌ قَبْرٌ':Added, #1: 1	حُكْمِ الْقَائِمَةِ
u'حُكْمٌ قَبْرٌ':Added, #1: 1	حُكْمِ الْقَبْرَيْنِ
u'حُكْمٌ قَبْضٌ':Added, #3: 3	حُكْمِ قَبْرَيْنِ
u'حُكْمٌ قَبْضٌ':Added, #1: 1	حُكْمِ الْقَبْضِ
u'حُكْمٌ قَبْضٌ':Added, #1: 1	حُكْمَ قَبْضِ
u'حُكْمٌ قَبْضٌ':Added, #1: 1	حُكْمُ قَبْضِ
u'حُكْمٌ قُبْلَةٌ':Added, #3: 3	حُكْمُ الْقَبْضِ
u'حُكْمٌ قَبُولٌ':Added, #2: 2	حُكْمُ الْقُبْلَةِ
u'حُكْمٌ قَبُولٌ':Added, #1: 1	حُكْمَ قَبُولِ
u'حُكْمٌ قَبُولٌ':Added, #1: 1	حُكْمِ قَبُولِ
u'حُكْمٌ قَبُولٌ':Added, #1: 1	حُكْمَ قَبُولِهِ
u'حُكْمٌ قتال':Added, #2: 2	حُكْمُ قَبُولِ
u'حُكْمٌ قِتَالٌ':Added, #1: 1	حُكْمُ قِتَالِ
u'حُكْمٌ قتل':Added, #1: 1	حُكْمُ قِتَالِ
u'حُكْمٌ قَتْلٌ':Added, #1: 1	حُكْمُ الْقَتْلِ
u'حُكْمٌ قتل':Added, #1: 1	حُكْمُ الْقَتْلِ
u'حُكْمٌ قَتْلٌ':Added, #1: 1	حُكْمَ قَتْلِ
u'حُكْمٌ قتل':Added, #1: 1	حُكْمَ قَتْلِ
u'حُكْمٌ قَتْلٌ':Added, #2: 2	حُكْمِ الْقَتْلِ
u'حُكْمٌ قتل':Added, #2: 2	حُكْمِ الْقَتْلِ
u'حُكْمٌ قَتْلٌ':Added, #2: 2	حُكْمِ قَتْلِ
u'حُكْمٌ قتل':Added, #2: 2	حُكْمِ قَتْلِ
u'حُكْمٌ قَتْلٌ':Added, #3: 3	حُكْمَ الْقَتْلِ
u'حُكْمٌ قَتِيلٌ':Added, #3: 3	حُكْمَ الْقَتْلِ
u'حُكْمٌ قَتِيلٌ':Added, #1: 1	حُكْمُ الْقَتِيلِ
u'حُكْمٌ قَدَرٌ':Added, #1: 1	حُكْمُ قَتِيلِ
u'حُكْمٌ قُدْوَةٌ':Added, #1: 1	حُكْمُ الْقَدَرِ
u'حُكْمٌ قُدْوَةٌ':Added, #1: 1	حُكْمَ الْقُدْوَةِ
u'حُكْمٌ قُدْوَةٌ':Added, #3: 3	حُكْمُ الْقُدْوَةِ
u'حُكْمٌ قذف':Added, #4: 4	حُكْمِ الْقُدْوَةِ
u'حُكْمٌ قذف':Added, #1: 1	حُكْمُ الْقَذْفِ
u'حُكْمٌ قَذْفٌ':Added, #1: 1	حُكْمِ الْقَذْفِ
u'حُكْمٌ قَذْفٌ':Added, #1: 1	حُكْمُ الْقَذْفِ
u'حُكْمٌ قذف':Added, #1: 1	حُكْمِ الْقَذْفِ
u'حُكْمٌ قَذْفٌ':Added, #1: 1	حُكْمُ قَذْفِ
u'حُكْمٌ قذف':Added, #1: 1	حُكْمُ قَذْفِ
u'حُكْمٌ قَذْفٌ':Added, #1: 1	حُكْمُ قَذْفِهِ
u'حُكْمٌ قِرَاءةٌ':Added, #1: 1	حُكْمُ قَذْفِهِ
u'حُكْمٌ قِرَاءةٌ':Added, #1: 1	حُكْمَ الْقِرَاءَةِ
u'حُكْمٌ قِرَاءةٌ':Added, #3: 3	حُكْمُ الْقِرَاءَةِ
u'حُكْمٌ قَرَابَةٌ':Added, #5: 5	حُكْمِ الْقِرَاءَةِ
u'حُكْمٌ قَرَابَةٌ':Added, #1: 1	حُكْمُ قَرَابَتِهِ
u'حُكْمٌ قُرَادٌ':Added, #4: 4	حُكْمُ الْقَرَابَةِ
u'حُكْمٌ قراض':Added, #1: 1	حُكْمُ الْقُرَادِ
u'حُكْمٌ قراض':Added, #1: 1	حُكْمَ الْقِرَاضِ
u'حُكْمٌ قُرْآنٌ':Added, #1: 1	حُكْمِ الْقِرَاضِ
u'حُكْمٌ قُرْآنٌ':Added, #2: 2	حُكْمُ الْقُرْآنِ
u'حُكْمٌ قُرْآنٌ':Added, #3: 3	حُكْمَ الْقُرْآنِ
u'حُكْمٌ قُرْبَانٌ':Added, #5: 5	حُكْمِ الْقُرْآنِ
u'حُكْمٌ قُرْبَةٌ':Added, #1: 1	حُكْمُ الْقُرْبَانِ
u'حُكْمٌ قَرْضٌ':Added, #1: 1	حُكْمُ الْقُرْبَةِ
u'حُكْمٌ قَرْضٌ':Added, #1: 1	حُكْمَ الْقَرْضِ
u'حُكْمٌ قَرْضٌ':Added, #1: 1	حُكْمُ قَرْضٍ
u'حُكْمٌ قَرِيبٌ':Added, #6: 6	حُكْمُ الْقَرْضِ
u'حُكْمٌ قَرْيَةٌ':Added, #2: 2	حُكْمِ الْقَرِيبِ
u'حُكْمٌ قَسام':Added, #1: 1	حُكْمِ الْقَرْيَةِ
u'حُكْمٌ قَسام':Added, #1: 1	حُكْمُ الْقَسَامَةِ
u'حُكْمٌ قَسامَة':Added, #1: 1	حُكْمِ الْقَسَامَةِ
u'حُكْمٌ قَسامَة':Added, #1: 1	حُكْمُ الْقَسَامَةِ
u'حُكْمٌ قَسْمٌ':Added, #1: 1	حُكْمِ الْقَسَامَةِ
u'حُكْمٌ قَسْمٌ':Added, #1: 1	حُكْمِ الْقَسْمِ
u'حُكْمٌ قِسْمٌ':Added, #1: 1	حُكْمُ قَسْمِ
u'حَكَمَ قسمة':Predicate, #2: 2	حُكْمُ الْقِسْمِ
u'حَكَمَ قِسْمَةٌ':Predicate, #1: 1	حَكَمَ الْقِسْمَةَ
u'حُكْمٌ قسمة':Added, #1: 1	حَكَمَ الْقِسْمَةَ
u'حُكْمٌ قسمة':Added, #1: 1	حُكْمَ الْقِسْمَةِ
u'حُكْمٌ قِسْمَةٌ':Added, #1: 1	حُكْمُ الْقِسْمَةِ
u'حُكْمٌ قِسْمَةٌ':Added, #1: 1	حُكْمَ الْقِسْمَةِ
u'حُكْمٌ قسمة':Added, #1: 1	حُكْمُ الْقِسْمَةِ
u'حُكْمٌ قِسْمَةٌ':Added, #1: 1	حُكْمُ قِسْمَةِ
u'حُكْمٌ قصاص':Added, #1: 1	حُكْمُ قِسْمَةِ
u'حُكْمٌ قِصَاصٌ':Added, #1: 1	حُكْمَ الْقِصَاصِ
u'حُكْمٌ قصاص':Added, #1: 1	حُكْمَ الْقِصَاصِ
u'حُكْمٌ قِصَاصٌ':Added, #1: 1	حُكْمِ قِصَاصِ
u'حُكْمٌ قصاص':Added, #1: 1	حُكْمِ قِصَاصِ
u'حُكْمٌ قصاص':Added, #2: 2	حُكْمُ الْقِصَاصِ
u'حُكْمٌ قِصَاصٌ':Added, #2: 2	حُكْمِ الْقِصَاصِ
u'حُكْمٌ قِصَاصٌ':Added, #2: 2	حُكْمُ الْقِصَاصِ
u'حُكْمٌ قَصْدٌ':Added, #2: 2	حُكْمِ الْقِصَاصِ
u'حُكْمٌ قَضَاءٌ':Added, #1: 1	حُكْمِ الْقَصْدِ
u'حُكْمٌ قَضَاءٌ':Added, #1: 1	حُكْمَ قَضَاءِ
u'حُكْمٌ قَضَاءٌ':Added, #1: 1	حُكْمُ قَضَاءِ
u'حُكْمٌ قَضَاءٌ':Added, #5: 5	حُكْمَ الْقَضَاءِ
u'حُكْمٌ قَضَاءٌ':Added, #7: 7	حُكْمُ الْقَضَاءِ
u'حُكْمٌ قَضَاءٌ':Added, #8: 8	حُكْمِ الْقَضَاءِ
u'حُكْمٌ قضاة':Added, #8: 8	حُكْمِ قَضَاءِ
u'حُكْمٌ قضاة':Added, #1: 1	حُكْمِ الْقُضَاةِ
u'حُكْمٌ قَطْعٌ':Added, #1: 1	حُكْمُ قُضَاتِهِ
u'حُكْمٌ قَطْعٌ':Added, #1: 1	حُكْمُ الْقَطْعِ
u'حُكْمٌ قَطْعٌ':Added, #1: 1	حُكْمِ الْقَطْعِ
u'حُكْمٌ قَطْعٌ':Added, #1: 1	حُكْمِ قَطْعِ
u'حُكْمٌ قَطْعٌ':Added, #2: 2	حُكْمَ الْقَطْعِ
u'حُكْمٌ قعدة':Added, #2: 2	حُكْمُ قَطْعِ
u'حُكْمٌ قَعْدَةٌ':Added, #1: 1	حُكْمُ الْقَعْدَةِ
u'حُكْمٌ قعدة':Added, #1: 1	حُكْمُ الْقَعْدَةِ
u'حُكْمٌ قَعْدَةٌ':Added, #2: 2	حُكْمِ الْقَعْدَةِ
u'حُكْمٌ قلب':Added, #2: 2	حُكْمِ الْقَعْدَةِ
u'حُكْمٌ قَلْبٌ':Added, #1: 1	حُكْمِ الْقَلْبِ
u'حُكْمٌ قَلْب':Added, #1: 1	حُكْمِ الْقَلْبِ
u'حُكْمٌ قَلِيلٌ':Added, #1: 1	حُكْمِ الْقَلْبِ
u'حُكْمٌ قَلِيلٌ':Added, #1: 1	حُكْمَ الْقَلِيلِ
u'حُكْمٌ قَلِيلٌ':Added, #2: 2	حُكْمُ الْقَلِيلِ
u'حُكْمٌ قَنَاةٌ':Added, #3: 3	حُكْمِ الْقَلِيلِ
u'حُكْمٌ قَنَوَاتٌ':Added, #1: 1	حُكْمُ الْقَنَاةِ
u'حُكْمٌ قُنُوتٌ':Added, #1: 1	حُكْمَ الْقَنَوَاتِ
u'حُكْمٌ قُوَّةٌ':Added, #2: 2	حُكْمِ الْقُنُوتِ
u'حُكْمٌ قُوَّة':Added, #1: 1	حُكْمِ الْقُوَّةِ
u'حُكْمٌ قَوَد':Added, #1: 1	حُكْمِ الْقُوَّةِ
u'حُكْمٌ قَوَد':Added, #1: 1	حُكْمُ الْقَوَدِ
u'حُكْمٌ قول':Added, #1: 1	حُكْمِ الْقَوَدِ
u'حُكْمٌ قَوْلٌ':Added, #1: 1	حُكْمِ الْقَوْلِ
u'حُكْمٌ قَوْلٌ':Added, #1: 1	حُكْمِ الْقَوْلِ
u'حُكْمٌ قَوْلٌ':Added, #1: 1	حُكْمُ الْقَوْلَيْنِ
u'حُكْمٌ قول':Added, #1: 1	حُكْمِ قَوْلٍ
u'حُكْمٌ قَوْلٌ':Added, #1: 1	حُكْمِ قَوْلِهِ
u'حُكْمٌ قول':Added, #1: 1	حُكْمِ قَوْلِهِ
u'حُكْمٌ قَوْلٌ':Added, #2: 2	حُكْمُ قَوْلِهِ
u'حَكَمَ قَوْمٌ':Subject, #2: 2	حُكْمُ قَوْلِهِ
u'حُكْمٌ قَيْءٌ':Added, #1: 1	حَكَمَ قَوْمٌ
u'حُكْمٌ قَيْءٌ':Added, #1: 1	حُكْمُ الْقَيْءِ
u'حُكْمٌ قِيَاسٌ':Added, #1: 1	حُكْمِ الْقَيْءِ
u'حُكْمٌ قِيَاسٌ':Added, #11: 11	حُكْمِ الْقِيَاسِ
u'حُكْمٌ قِيَاسٌ':Added, #2: 2	حُكْمُ الْقِيَاسِ
u'حُكْمٌ قيام':Added, #4: 4	حُكْمَ الْقِيَاسِ
u'حُكْمٌ قِيَامٌ':Added, #1: 1	حُكْمَ الْقِيَامِ
u'حُكْمٌ قيام':Added, #1: 1	حُكْمَ الْقِيَامِ
u'حُكْمٌ قِيَامٌ':Added, #1: 1	حُكْمَ قِيَامِهِ
u'حُكْمٌ قيام':Added, #1: 1	حُكْمَ قِيَامِهِ
u'حُكْمٌ قِيَامٌ':Added, #4: 4	حُكْمُ الْقِيَامِ
u'حُكْمٌ كَافِرٌ':Added, #4: 4	حُكْمُ الْقِيَامِ
u'حُكْمٌ كَافِرٌ':Added, #2: 2	حُكْمَ الْكَافِرِ
u'حُكْمٌ كَافِرٌ':Added, #2: 2	حُكْمِ الْكَافِرِ
u'حُكْمٌ كَاهِنٌ':Added, #7: 7	حُكْمُ الْكَافِرِ
u'حُكْمٌ كبار':Added, #1: 1	حُكْمُ الْكَاهِنِ
u'حُكْمٌ كَبِيرٌ':Added, #1: 1	حُكْمِ الْكِبَارِ
u'حُكْمٌ كَبِيرٌ':Added, #1: 1	حُكْمُ الْكَبِيرِ
u'حُكْمٌ كَبِيرٌ':Added, #1: 1	حُكْمُ الْكَبِيرَةِ
u'حُكْمٌ كِتَابٌ':Added, #2: 2	حُكْمِ الْكَبِيرَةِ
u'حُكْمٌ كِتَابٌ':Added, #1: 1	حُكْمِ الْكِتَابِ
u'حُكْمٌ كِتَابٌ':Added, #2: 2	حُكْمُ الْكِتَابِ
u'حُكْمٌ كِتَابَةٌ':Added, #2: 2	حُكْمِ كِتَابِ
u'حُكْمٌ كِتَابَةٌ':Added, #12: 12	حُكْمَ الْكِتَابَةِ
u'حُكْمٌ كِتَابَةٌ':Added, #17: 17	حُكْمِ الْكِتَابَةِ
u'حُكْمٌ كُتُبٌ':Added, #7: 7	حُكْمُ الْكِتَابَةِ
u'حُكْمٌ كَثْرَةٌ':Added, #1: 1	حُكْمَ الْكُتُبِ
u'حُكْمٌ كَثِيرٌ':Added, #1: 1	حُكْمُ الْكَثْرَةِ
u'حُكْمٌ كَثِيرٌ':Added, #1: 1	حُكْمُ الْكَثِيرِ
u'حُكْمٌ كَثِيرٌ':Added, #1: 1	حُكْمِ الْكَثِيرِ
u'حُكْمٌ كذب':Added, #2: 2	حُكْمَ الْكَثِيرِ
u'حُكْمٌ كَذِبٌ':Added, #1: 1	حُكْمِ الْكَذِبِ
u'حُكْمٌ كِرَاءٌ':Added, #1: 1	حُكْمِ الْكَذِبِ
u'حُكْمٌ كَرَاهَةٌ':Added, #1: 1	حُكْمِ كِرَاءِ
u'حُكْمٌ كَرَاهَةٌ':Added, #1: 1	حُكْمَ الْكَرَاهَةِ
u'حُكْمٌ كَرَاهَةٌ':Added, #1: 1	حُكْمِ الْكَرَاهَةِ
u'حُكْمٌ كَرَاهِيَةٌ':Added, #1: 1	حُكْمُ كَرَاهَتِهِ
u'حُكْمٌ كَسَادٌ':Added, #1: 1	حُكْمُ الْكَرَاهِيَةِ
u'حُكْمٌ كَسْبٌ':Added, #1: 1	حُكْمُ الْكَسَادِ
u'حَكَمَ كَعْبٌ':Subject, #1: 1	حُكْمَ الْكَسْبِ
u'حُكْمٌ كَفٌّ':Added, #1: 1	حَكَمَ كَعْبُ
u'حُكْمٌ كَفَاءةٌ':Added, #2: 2	حُكْمُ الْكَفِّ
u'حُكْمٌ كُفَّارٌ':Added, #3: 3	حُكْمِ الْكَفَاءَةِ
u'حُكْمٌ كُفَّارٌ':Added, #1: 1	حُكْمَ الْكُفَّارِ
u'حُكْمٌ كَفَّارٌ':Added, #1: 1	حُكْمُ الْكُفَّارِ
u'حُكْمٌ كَفَّارٌ':Added, #1: 1	حُكْمُ الْكَفَّارَاتِ
u'حُكْمٌ كَفَّارٌ':Added, #2: 2	حُكْمُ كَفَّارَةِ
u'حُكْمٌ كَفَّارٌ':Added, #3: 3	حُكْمَ الْكَفَّارَةِ
u'حُكْمٌ كَفَّارٌ':Added, #5: 5	حُكْمُ الْكَفَّارَةِ
u'حُكْمٌ كَفَّارَةٌ':Added, #7: 7	حُكْمِ الْكَفَّارَةِ
u'حُكْمٌ كَفَّارَةٌ':Added, #1: 1	حُكْمُ الْكَفَّارَاتِ
u'حُكْمٌ كَفَّارَةٌ':Added, #2: 2	حُكْمُ كَفَّارَةِ
u'حُكْمٌ كَفَّارَةٌ':Added, #3: 3	حُكْمَ الْكَفَّارَةِ
u'حُكْمٌ كَفَّارَةٌ':Added, #5: 5	حُكْمُ الْكَفَّارَةِ
u'حُكْمٌ كَفَالَةٌ':Added, #7: 7	حُكْمِ الْكَفَّارَةِ
u'حُكْمٌ كَفَالَةٌ':Added, #1: 1	حُكْمُ الْكَفَالَةِ
u'حُكْمٌ كَفَالَةٌ':Added, #1: 1	حُكْمِ الْكَفَالَةِ
u'حُكْمٌ كفر':Added, #2: 2	حُكْمَ الْكَفَالَةِ
u'حُكْمٌ كُفْرٌ':Added, #1: 1	حُكْمِ الْكُفْرِ
u'حُكْمٌ كفر':Added, #1: 1	حُكْمِ الْكُفْرِ
u'حُكْمٌ كُفْرٌ':Added, #4: 4	حُكْمُ الْكُفْرِ
u'حُكْمٌ كلاب':Added, #4: 4	حُكْمُ الْكُفْرِ
u'حُكْمٌ كِلاَبٌ':Added, #1: 1	حُكْمُ الْكِلَابِ
u'حُكْمٌ كَلام':Added, #1: 1	حُكْمُ الْكِلَابِ
u'حُكْمٌ كَلاَمٌ':Added, #1: 1	حُكْمَ الْكَلَامَيْنِ
u'حُكْمٌ كَلاَمٌ':Added, #1: 1	حُكْمُ كَلَامِ
u'حُكْمٌ كَلاَمٌ':Added, #1: 1	حُكْمِ كَلَامٍ
u'حُكْمٌ كَلاَمٌ':Added, #2: 2	حُكْمَ كَلَامِ
u'حُكْمٌ كَلاَمٌ':Added, #4: 4	حُكْمَ الْكَلَامِ
u'حُكْمٌ كَلْبٌ':Added, #6: 6	حُكْمُ الْكَلَامِ
u'حُكْمٌ كَلْبٌ':Added, #1: 1	حُكْمَ الْكَلْبِ
u'حُكْمٌ كَلِمَةٌ':Added, #2: 2	حُكْمُ الْكَلْبِ
u'حُكْمٌ كَلِمَةٌ':Added, #1: 1	حُكْمُ الْكَلِمَاتِ
u'حُكْمٌ كَلِمَةٌ':Added, #1: 1	حُكْمِ الْكَلِمَةِ
u'حُكْمٌ كُلِّيٌّ':Added, #1: 1	حُكْمَ كَلِمَةِ
u'حُكْمٌ كُلِّيٌّ':Added, #1: 1	حُكْمَ الْكُلِّيِّ
u'حُكْمٌ كَمَالٌ':Added, #1: 1	حُكْمِ الْكُلِّيِّ
u'حُكْمٌ كَمَالٌ':Added, #1: 1	حُكْمَ الْكَمَالِ
u'حُكْمٌ كُنَاسَةٌ':Added, #4: 4	حُكْمُ الْكَمَالِ
u'حُكْمٌ كِنَايَةٌ':Added, #1: 1	حُكْمِ الْكُنَاسَةِ
u'حُكْمٌ كِنَايَةٌ':Added, #1: 1	حُكْمُ الْكِنَايَةِ
u'حُكْمٌ كَنِيسَةٌ':Added, #2: 2	حُكْمُ كِنَايَاتِ
u'حُكْمٌ كَوْنٌ':Added, #1: 1	حُكْمِ كَنِيسَةٍ
u'حُكْمٌ كَوْنٌ':Added, #1: 1	حُكْمُ كَوْنِ
u'حُكْمٌ لاَمٌ':Added, #1: 1	حُكْمِ كَوْنِهِ
u'حُكْمٌ لاَمِسٌ':Added, #1: 1	حُكْمِ لَامِ
u'حُكْمٌ لبس':Added, #1: 1	حُكْمِ اللَّامِسِ
u'حُكْمٌ لُبْسٌ':Added, #1: 1	حُكْمُ اللُّبْسِ
u'حُكْمٌ لبس':Added, #1: 1	حُكْمُ اللُّبْسِ
u'حُكْمٌ لُبْسٌ':Added, #2: 2	حُكْمُ لُبْسِ
u'حُكْمٌ لبس':Added, #2: 2	حُكْمُ لُبْسِ
u'حُكْمٌ لُبْسٌ':Added, #4: 4	حُكْمِ اللُّبْسِ
u'حُكْمٌ لبن':Added, #4: 4	حُكْمِ اللُّبْسِ
u'حُكْمٌ لَبَنٌ':Added, #1: 1	حُكْمَ لَبَنِ
u'حُكْمٌ لبن':Added, #1: 1	حُكْمَ لَبَنِ
u'حُكْمٌ لَبَنٌ':Added, #2: 2	حُكْمُ لَبَنِ
u'حُكْمٌ لبن':Added, #2: 2	حُكْمُ لَبَنِ
u'حُكْمٌ لَبَنٌ':Added, #2: 2	حُكْمُ لَبَنِهِ
u'حُكْمٌ لبن':Added, #2: 2	حُكْمُ لَبَنِهِ
u'حُكْمٌ لبن':Added, #3: 3	حُكْمَ اللَّبَنِ
u'حُكْمٌ لَبَنٌ':Added, #3: 3	حُكْمُ اللَّبَنِ
u'حُكْمٌ لَبَنٌ':Added, #3: 3	حُكْمَ اللَّبَنِ
u'حُكْمٌ لَحْمٌ':Added, #3: 3	حُكْمُ اللَّبَنِ
u'حُكْمٌ لَحْمٌ':Added, #1: 1	حُكْمَ اللَّحْمِ
u'حُكْمٌ لَحْمٌ':Added, #2: 2	حُكْمُ اللَّحْمِ
u'حُكْمٌ لَحْنٌ':Added, #2: 2	حُكْمِ اللَّحْمِ
u'حُكْمٌ لَحْنٌ':Added, #1: 1	حُكْمُ اللَّحْنِ
u'حُكْمٌ لُزُومٌ':Added, #1: 1	حُكْمِ اللَّحْنِ
u'حُكْمٌ لُزُومٌ':Added, #1: 1	حُكْمَ اللُّزُومِ
u'حُكْمٌ لُزُومٌ':Added, #1: 1	حُكْمُ اللُّزُومِ
u'حُكْمٌ لِسَانٌ':Added, #1: 1	حُكْمِ لُزُومِ
u'حُكْمٌ لُصُوصٌ':Added, #2: 2	حُكْمِ اللِّسَانِ
u'حُكْمٌ لعان':Added, #1: 1	حُكْمُ اللُّصُوصِ
u'حُكْمٌ لعان':Added, #1: 1	حُكْمَ اللِّعَانِ
u'حُكْمٌ لعان':Added, #1: 1	حُكْمِ اللِّعَانِ
u'حُكْمٌ لعب':Added, #3: 3	حُكْمُ اللِّعَانِ
u'حُكْمٌ لَعِبٌ':Added, #1: 1	حُكْمِ اللَّعِبِ
u'حُكْمٌ لَعْن':Added, #1: 1	حُكْمِ اللَّعِبِ
u'حُكْمٌ لُغَةٌ':Added, #1: 1	حُكْمُ اللَّعْنِ
u'حُكْمٌ لُغَةٌ':Added, #1: 1	حُكْمِ اللُّغَةِ
u'حُكْمٌ لُغَةٌ':Added, #1: 1	حُكْمُ لُغَةِ
u'حُكْمٌ لَغْوٌ':Added, #2: 2	حُكْمُ اللُّغَةِ
u'حُكْمٌ لَفْظٌ':Added, #1: 1	حُكْمَ اللَّغْوِ
u'حُكْمٌ لَفْظٌ':Added, #2: 2	حُكْمَ اللَّفْظِ
u'حُكْمٌ لَفْظٌ':Added, #2: 2	حُكْمُ لَفْظِ
u'حُكْمٌ لَفْظٌ':Added, #5: 5	حُكْمُ اللَّفْظِ
u'حُكْمٌ لقطة':Added, #8: 8	حُكْمِ اللَّفْظِ
u'حُكْمٌ لقطة':Added, #2: 2	حُكْمِ اللُّقَطَةِ
u'حُكْمٌ لقطة':Added, #6: 6	حُكْمَ اللُّقَطَةِ
u'حُكْمٌ لَقْلَق':Added, #8: 8	حُكْمُ اللُّقَطَةِ
u'حُكْمٌ لَقِيطٌ':Added, #1: 1	حُكْمُ اللَّقْلَقِ
u'حُكْمٌ لَقِيطٌ':Added, #1: 1	حُكْمُ اللَّقِيطِ
u'حُكْمٌ لَمْسٌ':Added, #2: 2	حُكْمَ اللَّقِيطِ
u'حُكْمٌ لِواط':Added, #1: 1	حُكْمِ اللَّمْسِ
u'حُكْمٌ لَئِيمٌ':Added, #1: 1	حُكْمِ اللِّوَاطِ
u'حُكْمٌ لَيْلٌ':Added, #1: 1	حُكْمِ لَئِيمِ
u'حُكْمٌ لَيْلٌ':Added, #1: 1	حُكْمَ اللَّيْلِ
u'حُكْمٌ لَيْلٌ':Added, #1: 1	حُكْمُ اللَّيْلَةِ
u'حُكْمٌ لَيْلٌ':Added, #1: 1	حُكْمِ اللَّيْلَتَيْنِ
u'حُكْمٌ لَيْلٌ':Added, #1: 1	حُكْمُ اللَّيْلِيَّةِ
u'حُكْمٌ لَيْلِيٌّ':Added, #2: 2	حُكْمُ اللَّيْلِ
u'حُكْمٌ مَاءٌ':Added, #1: 1	حُكْمُ اللَّيْلِيَّةِ
u'حُكْمٌ مَاءٌ':Added, #16: 16	حُكْمُ الْمَاءِ
u'حُكْمٌ مَاءٌ':Added, #1: 1	حُكْمُ مَاءِ
u'حُكْمٌ مَاءٌ':Added, #1: 1	حُكْمِ مَاءِ
u'حُكْمٌ مَاءٌ':Added, #2: 2	حُكْمَ مَاءِ
u'حُكْمٌ مَاءٌ':Added, #2: 2	حُكْمِ مَاءٍ
u'حُكْمٌ مَاءٌ':Added, #4: 4	حُكْمَ الْمَاءِ
u'حُكْمٌ مَاشِي':Added, #8: 8	حُكْمِ الْمَاءِ
u'حُكْمٌ مَأْكُولٌ':Added, #1: 1	حُكْمُ الْمَاشِيَيْنِ
u'حُكْمٌ مَأْكُولٌ':Added, #1: 1	حُكْمُ الْمَأْكُولِ
u'حُكْمٌ مَالٌ':Added, #1: 1	حُكْمَ مَأْكُولِهِ
u'حُكْمٌ مَالٌ':Added, #12: 12	حُكْمُ الْمَالِ
u'حُكْمٌ مَالٌ':Added, #1: 1	حُكْمِ الْمَالَيْنِ
u'حُكْمٌ مَالٌ':Added, #1: 1	حُكْمِ مَالِ
u'حُكْمٌ مَالٌ':Added, #1: 1	حُكْمِ مَالِهِ
u'حُكْمٌ مَالٌ':Added, #2: 2	حُكْمِ الْمَالِ
u'حُكْمٌ مَالٌ':Added, #4: 4	حُكْمُ مَالِ
u'حُكْمٌ مَالٌ':Added, #4: 4	حُكْمُ مَالِهِ
u'حُكْمٌ مَالِكٌ':Added, #5: 5	حُكْمَ الْمَالِ
u'حُكْمٌ مَالِكٌ':Added, #1: 1	حُكْمَ الْمَالِكِ
u'حُكْمٌ مَالِكٌ':Added, #1: 1	حُكْمِ الْمَالِكَةِ
u'حُكْمٌ مَالِكٌ':Added, #1: 1	حُكْمِ مَالِكٍ
u'حُكْمٌ مَالِكٌ':Added, #1: 1	حُكْمِ مَالِكِهِ
u'حُكْمٌ مالِك':Added, #2: 2	حُكْمِ الْمَالِكِ
u'حُكْمٌ مالِك':Added, #2: 2	حُكْمَ الْمَالِكِيَّةِ
u'حَكَمَ مالِكِيّ':Subject, #2: 2	حُكْمُ الْمَالِكِيَّةِ
u'حُكْمٌ مالِكِيّ':Added, #3: 3	حَكَمَ الْمَالِكِيُّ
u'حُكْمٌ مالِكِيّ':Added, #1: 1	حُكْمَ الْمَالِكِيِّ
u'حُكْمٌ مالِكِيّ':Added, #1: 1	حُكْمُ الْمَالِكِيِّ
u'حُكْمٌ مالِكِيّ':Added, #1: 1	حُكْمِ الْمَالِكِيِّ
u'حُكْمٌ مالِكِيّ':Added, #2: 2	حُكْمَ الْمَالِكِيَّةِ
u'حُكْمٌ مَالِيٌّ':Added, #2: 2	حُكْمُ الْمَالِكِيَّةِ
u'حُكْمٌ مَالِيٌّ':Added, #1: 1	حُكْمِ الْمَالِيَّةِ
u'حُكْمٌ مَالِيٌّ':Added, #1: 1	حُكْمُ مَالِيَّةِ
u'حُكْمٌ مَالِيٌّ':Added, #2: 2	حُكْمَ الْمَالِيَّةِ
u'حُكْمٌ مَالِيٌّ':Added, #2: 2	حُكْمُ الْمَالِيَّةِ
u'حُكْمٌ مَانِعٌ':Added, #3: 3	حُكْمَ مَالِيَّةِ
u'حُكْمٌ مَائِعٌ':Added, #2: 2	حُكْمُ الْمَانِعِ
u'حُكْمٌ مَائِلٌ':Added, #1: 1	حُكْمُ الْمَائِعَاتِ
u'حُكْمٌ مُبَاحٌ':Added, #1: 1	حُكْمُ الْمَائِلِ
u'حُكْمٌ مُبَاحٌ':Added, #1: 1	حُكْمَ الْمُبَاحِ
u'حُكْمٌ مُبَاشِرٌ':Added, #2: 2	حُكْمِ الْمُبَاحِ
u'حُكْمٌ مُبَاشَرَةٌ':Added, #1: 1	حُكْمُ الْمُبَاشِرِ
u'حُكْمٌ مُبَاشَرَةٌ':Added, #1: 1	حُكْمَ الْمُبَاشَرَةِ
u'حُكْمٌ مُبَاشَرَةٌ':Added, #1: 1	حُكْمُ مُبَاشَرَةِ
u'حُكْمٌ مُبَاشَرَةٌ':Added, #2: 2	حُكْمُ مُبَاشَرَتِهِ
u'حُكْمٌ مُبَايَعَةٌ':Added, #6: 6	حُكْمُ الْمُبَاشَرَةِ
u'حُكْمٌ مُبْتَدَأٌ':Added, #1: 1	حُكْمَ مُبَايَعَتِهِ
u'حُكْمٌ مُبْتَدِئٌ':Added, #4: 4	حُكْمٍ مُبْتَدَأٍ
u'حُكْمٌ مُبَدِّلٌ':Added, #3: 3	حُكْمُ الْمُبْتَدِئَةِ
u'حُكْمٌ مَبْلَغٌ':Added, #1: 1	حُكْمِ مُبَدِّلِهِ
u'حُكْمٌ مُبَلِّغٌ':Added, #1: 1	حُكْمُ الْمَبْلَغِ
u'حُكْمٌ مَبِيعٌ':Added, #1: 1	حُكْمِ الْمُبَلِّغِ
u'حُكْمٌ مَبِيعٌ':Added, #15: 15	حُكْمُ الْمَبِيعِ
u'حُكْمٌ مَبِيعٌ':Added, #3: 3	حُكْمَ الْمَبِيعِ
u'حُكْمٌ مُتَابَعٌ':Added, #5: 5	حُكْمِ الْمَبِيعِ
u'حُكْمٌ مُتَابَعٌ':Added, #1: 1	حُكْمَ الْمُتَابَعَةِ
u'حُكْمٌ مُتَابَعٌ':Added, #1: 1	حُكْمِ الْمُتَابَعَةِ
u'حُكْمٌ مُتَابَعَةٌ':Added, #2: 2	حُكْمُ الْمُتَابَعَةِ
u'حُكْمٌ مُتَابَعَةٌ':Added, #1: 1	حُكْمَ الْمُتَابَعَةِ
u'حُكْمٌ مُتَابَعَةٌ':Added, #1: 1	حُكْمِ الْمُتَابَعَةِ
u'حُكْمٌ مُتَاجَرَةٌ':Added, #2: 2	حُكْمُ الْمُتَابَعَةِ
u'حُكْمٌ مُتَأَخِّرٌ':Added, #1: 1	حُكْمِ الْمُتَاجَرَةِ
u'حُكْمٌ مُتَّبِعٌ':Added, #1: 1	حُكْمِ الْمُتَأَخِّرِ
u'حُكْمٌ متبوع':Added, #1: 1	حُكْمِ الْمُتَّبِعِ
u'حُكْمٌ متبوع':Added, #1: 1	حُكْمَ الْمَتْبُوعِ
u'حُكْمٌ متبوع':Added, #1: 1	حُكْمَ مَتْبُوعِهِ
u'حُكْمٌ مُتَحَجِّرٌ':Added, #2: 2	حُكْمُ الْمَتْبُوعِ
u'حُكْمٌ مُتَحَيِّرٌ':Added, #1: 1	حُكْمُ مُتَحَجِّرِ
u'حُكْمٌ مُتَشَابِهٌ':Added, #1: 1	حُكْمُ الْمُتَحَيِّرَةِ
u'حُكْمٌ مُتَّصِلٌ':Added, #1: 1	حُكْمِ الْمُتَشَابِهِ
u'حُكْمٌ مُتَّصِلٌ':Added, #1: 1	حُكْمُ الْمُتَّصِلِ
u'حُكْمٌ مُتَّصِلٌ':Added, #1: 1	حُكْمَ الْمُتَّصِلَةِ
u'حُكْمٌ مُتْعَةٌ':Added, #3: 3	حُكْمِ الْمُتَّصِلِ
u'حُكْمٌ مُتَعَلِّمٌ':Added, #1: 1	حُكْمِ الْمُتْعَةِ
u'حُكْمٌ مُتَعَمِّدٌ':Added, #1: 1	حُكْمُ مُتَعَلِّمٍ
u'حُكْمٌ مُتَّفَقٌ':Added, #1: 1	حُكْمِ الْمُتَعَمِّدِ
u'حُكْمٌ مُتَقَدِّمٌ':Added, #1: 1	حُكْمَ الْمُتَّفَقِ
u'حُكْمٌ مُتَكَلِّمٌ':Added, #3: 3	حُكْمُ الْمُتَقَدِّمِ
u'حُكْمٌ مُتَكَلِّمٌ':Added, #1: 1	حُكْمَ الْمُتَكَلِّمِ
u'حُكْمٌ مُتَكَلِّمٌ':Added, #1: 1	حُكْمُ الْمُتَكَلِّمِ
u'حُكْمٌ مُتَوَلِّدٌ':Added, #1: 1	حُكْمِ الْمُتَكَلِّمِ
u'حُكْمٌ مِثْلٌ':Added, #1: 1	حُكْمُ الْمُتَوَلِّدِ
u'حُكْمٌ مثل':Added, #1: 1	حُكْمَ الْمِثْلَيْنِ
u'حُكْمٌ مِثْلٌ':Added, #1: 1	حُكْمِ مِثْلِ
u'حُكْمٌ مُثَلَّثٌ':Added, #1: 1	حُكْمِ مِثْلِ
u'حُكْمٌ مِثْلِيٌّ':Added, #2: 2	حُكْمُ الْمُثَلَّثِ
u'حُكْمٌ مَجَازٌ':Added, #1: 1	حُكْمُ الْمِثْلِيِّ
u'حُكْمٌ مَجَازٌ':Added, #1: 1	حُكْمَ الْمَجَازِ
u'حُكْمٌ مُجَازَفَةٌ':Added, #1: 1	حُكْمِ الْمَجَازِ
u'حُكْمٌ مُجَاوَزَةٌ':Added, #1: 1	حُكْمُ الْمُجَازَفَةِ
u'حُكْمٌ مُجْتَهِد':Added, #1: 1	حُكْمَ الْمُجَاوَزَةِ
u'حُكْمٌ مُجْتَهِد':Added, #1: 1	حُكْمَ الْمُجْتَهِدِ
u'حُكْمٌ مُجْتَهِد':Added, #1: 1	حُكْمُ الْمُجْتَهِدِ
u'حُكْمٌ مَجْزَرٌ':Added, #1: 1	حُكْمُ مُجْتَهِدٍ
u'حُكْمٌ مَجْزُوم':Added, #1: 1	حُكْمُ الْمَجْزَرَةِ
u'حُكْمٌ مَجْلِسٌ':Added, #1: 1	حُكْمِ الْمَجْزُومِ
u'حُكْمٌ مَجْلِسٌ':Added, #3: 3	حُكْمَ الْمَجْلِسِ
u'حُكْمٌ مُجْمَعٌ':Added, #4: 4	حُكْمُ الْمَجْلِسِ
u'حُكْمٌ مُجْمَلٌ':Added, #1: 1	حُكْمٍ مُجْمَعٍ
u'حُكْمٌ مُجْمَلٌ':Added, #2: 2	حُكْمَ الْمُجْمَلِ
u'حُكْمٌ مَجْمُوعٌ':Added, #2: 2	حُكْمُ الْمُجْمَلِ
u'حُكْمٌ مَجْنُونٌ':Added, #1: 1	حُكْمُ الْمَجْمُوعِ
u'حُكْمٌ مَجْنُونٌ':Added, #1: 1	حُكْمُ الْمَجْنُونِ
u'حُكْمٌ مَجْهُولٌ':Added, #2: 2	حُكْمَ الْمَجْنُونِ
u'حُكْمٌ مَجْهُولٌ':Added, #1: 1	حُكْمَ الْمَجْهُولِ
u'حُكْمٌ مَجُوسٌ':Added, #1: 1	حُكْمَ مَجْهُولِ
u'حُكْمٌ مُحَاذَاةٌ':Added, #1: 1	حُكْمُ الْمَجُوسِ
u'حُكْمٌ مُحَارَبَةٌ':Added, #1: 1	حُكْمِ الْمُحَاذَاةِ
u'حُكْمٌ مَحْبُوسٌ':Added, #1: 1	حُكْمِ مُحَارَبَتِهِ
u'حُكْمٌ مَحْجُورٌ':Added, #2: 2	حُكْمُ الْمَحْبُوسِ
u'حُكْمٌ مَحْجُورٌ':Added, #1: 1	حُكْمُ الْمَحْجُورِ
u'حُكْمٌ مَحْدُودٌ':Added, #1: 1	حُكْمِ الْمَحْجُورِ
u'حُكْمٌ مِحْرَابٌ':Added, #1: 1	حُكْمِ مَحْدُودٍ
u'حُكْمٌ مُحْرِمٌ':Added, #1: 1	حُكْمُ مِحْرَابِ
u'حُكْمٌ مُحْرِمٌ':Added, #1: 1	حُكْمَ الْمُحْرِمِ
u'حُكْمٌ مُحْرِمٌ':Added, #1: 1	حُكْمُ الْمُحْرِمِ
u'حُكْمٌ مُحَرَّمٌ':Added, #1: 1	حُكْمِ الْمُحْرِمِ
u'حُكْمٌ مُحَقَّقٌ':Added, #1: 1	حُكْمُ الْمُحَرَّمَاتِ
u'حُكْمٌ مُحَكَّمٌ':Added, #1: 1	حُكْمُ الْمُحَقَّقِ
u'حُكْمٌ مُحَكَّمٌ':Added, #5: 5	حُكْمَ الْمُحَكَّمِ
u'حُكْمٌ مُحَكَّمٌ':Added, #6: 6	حُكْمِ الْمُحَكَّمِ
u'حُكْمٌ مَحَلٌّ':Added, #9: 9	حُكْمُ الْمُحَكَّمِ
u'حُكْمٌ مَحَلٌّ':Added, #2: 2	حُكْمَ الْمَحَلِّ
u'حُكْمٌ مَحَلَّةٌ':Added, #9: 9	حُكْمُ الْمَحَلِّ
u'حَكَمَ مُحَمَّدٌ':Subject, #1: 1	حُكْمُ الْمَحَلَّةِ
u'حُكْمٌ مُحَمَّدٌ':Added, #1: 1	حَكَمَ مُحَمَّدُ
u'حُكْمٌ مُحَمَّدٌ':Added, #1: 1	حُكْمِ مُحَمّدٍ
u'حُكْمٌ مَحْمِيٌّ':Added, #1: 1	حُكْمِ مُحَمَّدٍ
u'حَكَمَ مُخَالِفٌ':Subject, #1: 1	حُكْمُ الْمَحْمِيِّ
u'حُكْمٌ مُخَالِفٌ':Added, #1: 1	حَكَمَ مُخَالِفٌ
u'حُكْمٌ مُخَالِفٌ':Added, #1: 1	حُكْمَ الْمُخَالِفِ
u'حُكْمٌ مُخَالِفٌ':Added, #1: 1	حُكْمُ مُخَالِفِ
u'حُكْمٌ مُخَالِفٌ':Added, #1: 1	حُكْمَ مُخَالِفِهِ
u'حُكْمٌ مُخَالِفٌ':Added, #2: 2	حُكْمِ الْمُخَالِفِ
u'حُكْمٌ مُخَالَفَةٌ':Added, #2: 2	حُكْمٍ مُخَالِفٍ
u'حُكْمٌ مُخَالَفَةٌ':Added, #1: 1	حُكْمَ الْمُخَالَفَةِ
u'حُكْمٌ مُخْتَارٌ':Added, #2: 2	حُكْمُ الْمُخَالَفَةِ
u'حُكْمٌ مُخْتَارٌ':Added, #1: 1	حُكْمُ الْمُخْتَارِ
u'حُكْمٌ مُخْتَلِفٌ':Added, #2: 2	حُكْمَ الْمُخْتَارِ
u'حُكْمٌ مُخْطِئٌ':Added, #1: 1	حُكْمٍ مُخْتَلِفٍ
u'حُكْمٌ مُخَفَّفٌ':Added, #2: 2	حُكْمُ الْمُخْطِئِ
u'حُكْمٌ مَدٌّ':Added, #1: 1	حُكْمُ الْمُخَفَّفَةِ
u'حُكْمٌ مُدٌّ':Added, #1: 1	حُكْمَ الْمَدِّ
u'حُكْمٌ مَداس':Added, #1: 1	حُكْمُ مُدِّ
u'حُكْمٌ مُدَبَّرٌ':Added, #1: 1	حُكْمُ الْمَدَاسِ
u'حُكْمٌ مُدَبَّرٌ':Added, #2: 2	حُكْمَ الْمُدَبَّرِ
u'حُكْمٌ مُدَّةٌ':Added, #3: 3	حُكْمُ الْمُدَبَّرِ
u'حُكْمٌ مُدَّةٌ':Added, #1: 1	حُكْمُ الْمُدَّةِ
u'حُكْمٌ مُدَّةٌ':Added, #1: 1	حُكْمُ مُدَّةٍ
u'حُكْمٌ مَدْخُولٌ':Added, #1: 1	حُكْمُ مُدَّةِ
u'حُكْمٌ مَدْرَسَةٌ':Added, #1: 1	حُكْمُ الْمَدْخُولِ
u'حُكْمٌ مَدْفُونٌ':Added, #1: 1	حُكْمُ الْمَدْرَسَةِ
u'حُكْمٌ مَذْكُورٌ':Added, #1: 1	حُكْمَ الْمَدْفُونِ
u'حُكْمٌ مَذْكُورٌ':Added, #1: 1	حُكْمُ الْمَذْكُورِ
u'حُكْمٌ مَذْكُورٌ':Added, #3: 3	حُكْمٍ مَذْكُورٍ
u'حُكْمٌ مَرْء':Added, #7: 7	حُكْمِ الْمَذْكُورِ
u'حُكْمٌ مُرابَحَة':Added, #1: 1	حُكْمُ الْمَرْئِيَّةِ
u'حُكْمٌ مَرَاتِبُ':Added, #3: 3	حُكْمِ الْمُرَابَحَةِ
u'حُكْمٌ مراسيل':Added, #1: 1	حُكْمُ مَرَاتِبِهِ
u'حُكْمٌ مَرَاسِيلُ':Added, #1: 1	حُكْمِ الْمَرَاسِيلِ
u'حُكْمٌ مراسيل':Added, #1: 1	حُكْمِ الْمَرَاسِيلِ
u'حُكْمٌ مَرَاسِيلُ':Added, #2: 2	حُكْمُ الْمَرَاسِيلِ
u'حُكْمٌ مُرْتاب':Added, #2: 2	حُكْمُ الْمَرَاسِيلِ
u'حُكْمٌ مُرَتَّبٌ':Added, #1: 1	حُكْمُ الْمُرْتَابَةِ
u'حُكْمٌ مُرْتَدٌّ':Added, #1: 1	حُكْمٍ مُرَتَّبٍ
u'حُكْمٌ مُرْتَدٌّ':Added, #1: 1	حُكْمَ الْمُرْتَدَّةِ
u'حُكْمٌ مُرْتَدٌّ':Added, #9: 9	حُكْمُ الْمُرْتَدِّ
u'حُكْمٌ مُرْتَكِبٌ':Added, #9: 9	حُكْمِ الْمُرْتَدِّ
u'حُكْمٌ مَرْدُودٌ':Added, #1: 1	حُكْمُ مُرْتَكِبِ
u'حُكْمٌ مُرْسَلٌ':Added, #1: 1	حُكْمَ الْمَرْدُودِ
u'حُكْمٌ مُرْسِلٌ':Added, #1: 1	حُكْمِ الْمُرْسَلِ
u'حُكْمٌ مُرْسَلٌ':Added, #1: 1	حُكْمُ مُرْسِلِهِ
u'حُكْمٌ مَرَضٌ':Added, #2: 2	حُكْمُ الْمُرْسَلِ
u'حُكْمٌ مَرَضٌ':Added, #1: 1	حُكْمَ الْمَرَضِ
u'حُكْمٌ مَرَضٌ':Added, #2: 2	حُكْمِ الْمَرَضِ
u'حُكْمٌ مَرَضٌ':Added, #3: 3	حُكْمُ مَرَضِ
u'حُكْمٌ مَرْفُوعٌ':Added, #6: 6	حُكْمُ الْمَرَضِ
u'حُكْمٌ مَرْفُوعٌ':Added, #15: 15	حُكْمِ الْمَرْفُوعِ
u'حُكْمٌ مُرَكَّبٌ':Added, #5: 5	حُكْمُ الْمَرْفُوعِ
u'حُكْمٌ مَرْهُونٌ':Added, #3: 3	حُكْمُ الْمُرَكَّبِ
u'حُكْمٌ مُرُورٌ':Added, #1: 1	حُكْمُ الْمَرْهُونِ
u'حُكْمٌ مُرُورٌ':Added, #1: 1	حُكْمِ الْمُرُورِ
u'حُكْمٌ مَرْوِيّ':Added, #2: 2	حُكْمُ مُرُورِ
u'حُكْمٌ مَرِيضٌ':Added, #1: 1	حُكْمَ الْمَرْوِيِّ
u'حُكْمٌ مَرِيضٌ':Added, #1: 1	حُكْمَ الْمَرِيضِ
u'حُكْمٌ مَرِيضٌ':Added, #1: 1	حُكْمَ الْمَرِيضَةِ
u'حُكْمٌ مَرِيضٌ':Added, #1: 1	حُكْمُ الْمَرِيضَةِ
u'حُكْمٌ مَرِيضٌ':Added, #2: 2	حُكْمِ الْمَرِيضَةِ
u'حُكْمٌ مَرِيضٌ':Added, #3: 3	حُكْمِ الْمَرِيضِ
u'حُكْمٌ مَزِيدٌ':Added, #9: 9	حُكْمُ الْمَرِيضِ
u'حُكْمٌ مَسٌّ':Added, #2: 2	حُكْمُ الْمَزِيدِ
u'حُكْمٌ مَسٌّ':Added, #1: 1	حُكْمَ مَسِّ
u'حُكْمٌ مَسٌّ':Added, #1: 1	حُكْمُ مَسِّهِ
u'حُكْمٌ مَسٌّ':Added, #2: 2	حُكْمِ الْمَسِّ
u'حُكْمٌ مُسَابَقَةٌ':Added, #3: 3	حُكْمُ مَسِّ
u'حُكْمٌ مَسَاجِدُ':Added, #1: 1	حُكْمِ الْمُسَابَقَةِ
u'حُكْمٌ مُسَافِرٌ':Added, #1: 1	حُكْمُ الْمَسَاجِدِ
u'حُكْمٌ مُسَافِرٌ':Added, #4: 4	حُكْمُ الْمُسَافِرِ
u'حُكْمٌ مُساقاة':Added, #4: 4	حُكْمِ الْمُسَافِرِ
u'حُكْمٌ مُساقاة':Added, #1: 1	حُكْمَ الْمُسَاقَاةِ
u'حُكْمٌ مَسْأَلَةٌ':Added, #2: 2	حُكْمُ الْمُسَاقَاةِ
u'حُكْمٌ مَسْأَلَةٌ':Added, #11: 11	حُكْمَ الْمَسْأَلَةِ
u'حُكْمٌ مَسْأَلَةٌ':Added, #12: 12	حُكْمِ الْمَسْأَلَةِ
u'حُكْمٌ مَسْأَلَةٌ':Added, #23: 23	حُكْمُ الْمَسْأَلَةِ
u'حُكْمٌ مَسْأَلَةٌ':Added, #2: 2	حُكْمَ مَسْأَلَةِ
u'حُكْمٌ مَسْأَلَةٌ':Added, #2: 2	حُكْمُ مَسْأَلَةِ
u'حُكْمٌ مَسْأَلَةٌ':Added, #2: 2	حُكْمِ مَسْأَلَةِ
u'حُكْمٌ مَسْأَلَةٌ':Added, #4: 4	حُكْمَ مَسْأَلَةٍ
u'حُكْمٌ مُسَاوَاةٌ':Added, #7: 7	حُكْمِ مَسْأَلَةٍ
u'حُكْمٌ مَسَائِلُ':Added, #1: 1	حُكْمِ الْمُسَاوَاةِ
u'حُكْمٌ مَسْبُوق':Added, #4: 4	حُكْمُ الْمَسَائِلِ
u'حُكْمٌ مَسْبُوق':Added, #1: 1	حُكْمَ الْمَسْبُوقِ
u'حُكْمٌ مَسْبُوق':Added, #1: 1	حُكْمِ الْمَسْبُوقِ
u'حُكْمٌ مَسْبُوق':Added, #1: 1	حُكْمٍ مَسْبُوقٍ
u'حُكْمٌ مُسْتَأْجِرٌ':Added, #4: 4	حُكْمُ الْمَسْبُوقِ
u'حُكْمٌ مُسْتَأْنَفٌ':Added, #6: 6	حُكْمُ الْمُسْتَأْجِرِ
u'حُكْمٌ مُسْتَحِيلٌ':Added, #1: 1	حُكْمٍ مُسْتَأْنَفٍ
u'حُكْمٌ مُسْتَعِيرٌ':Added, #2: 2	حُكْمَ الْمُسْتَحِيلِ
u'حُكْمٌ مُسْتَغْرِقٌ':Added, #3: 3	حُكْمُ الْمُسْتَعِيرِ
u'حُكْمٌ مُسْتَفاد':Added, #1: 1	حُكْمَ مُسْتَغْرِقِ
u'حُكْمٌ مُسْتَقْبَلٌ':Added, #1: 1	حُكْمُ الْمُسْتَفَادِ
u'حُكْمٌ مُسْتَقِرٌّ':Added, #1: 1	حُكْمٍ مُسْتَقْبَلٍ
u'حُكْمٌ مُسْتَنِيب':Added, #1: 1	حُكْمُ الْمُسْتَقِرِّ
u'حُكْمٌ مُسْتَهْلَكٌ':Added, #2: 2	حُكْمَ الْمُسْتَنِيبِ
u'حُكْمٌ مُسْتَهْلِكٌ':Added, #1: 1	حُكْمَ الْمُسْتَهْلَكِ
u'حُكْمٌ مُسْتَهْلَكٌ':Added, #1: 1	حُكْمِ الْمُسْتَهْلِكِ
u'حُكْمٌ مَسْجِدٌ':Added, #3: 3	حُكْمِ الْمُسْتَهْلَكِ
u'حُكْمٌ مَسْجِدٌ':Added, #12: 12	حُكْمَ الْمَسْجِدِ
u'حُكْمٌ مَسْجِدٌ':Added, #1: 1	حُكْمِ مَسْجِدَيْنِ
u'حُكْمٌ مَسْجِدٌ':Added, #48: 48	حُكْمُ الْمَسْجِدِ
u'حُكْمٌ مَسْحٌ':Added, #4: 4	حُكْمِ الْمَسْجِدِ
u'حُكْمٌ مَسْحٌ':Added, #1: 1	حُكْمَ مَسْحِ
u'حُكْمٌ مَسْحٌ':Added, #2: 2	حُكْمُ مَسْحِ
u'حُكْمٌ مَسْحٌ':Added, #4: 4	حُكْمَ الْمَسْحِ
u'حُكْمٌ مَسْرُوقٌ':Added, #4: 4	حُكْمُ الْمَسْحِ
u'حُكْمٌ مِسْكٌ':Added, #1: 1	حُكْمُ الْمَسْرُوقِ
u'حُكْمٌ مَسْكَنٌ':Added, #1: 1	حُكْمِ الْمِسْكِ
u'حُكْمٌ مَسْكُوتٌ':Added, #1: 1	حُكْمُ الْمَسْكَنِ
u'حُكْمٌ مَسْكُوتٌ':Added, #1: 1	حُكْمُ الْمَسْكُوتِ
u'حُكْمٌ مُسَلَّحٌ':Added, #7: 7	حُكْمِ الْمَسْكُوتِ
u'حُكْمٌ مُسْلِمٌ':Added, #1: 1	حُكْمُ مُسَلَّحِ
u'حُكْمٌ مُسْلِمٌ':Added, #1: 1	حُكْمُ الْمُسْلِمَةِ
u'حُكْمٌ مُسْلِمٌ':Added, #1: 1	حُكْمُ الْمُسْلِمَيْنِ
u'حُكْمٌ مُسْلِمٌ':Added, #2: 2	حُكْمِ الْمُسْلِمِ
u'حُكْمٌ مُسْلِمٌ':Added, #2: 2	حُكْمِ الْمُسْلِمَةِ
u'حُكْمٌ مُسْلِمٌ':Added, #3: 3	حُكْمَ الْمُسْلِمِ
u'حُكْمٌ مُشَارَكَةٌ':Added, #4: 4	حُكْمُ الْمُسْلِمِ
u'حُكْمٌ مُشاعٌ':Added, #1: 1	حُكْمُ الْمُشَارَكَةِ
u'حُكْمٌ مَشَاهِدُ':Added, #1: 1	حُكْمِ مُشَاعٍ
u'حُكْمٌ مُشَبَّهٌ':Added, #1: 1	حُكْمُ الْمَشَاهِدِ
u'حُكْمٌ مُشَبَّهٌ':Added, #1: 1	حُكْمُ الْمُشَبَّهِ
u'حُكْمٌ مُشَبَّهٌ':Added, #2: 2	حُكْمِ الْمُشَبَّهِ
u'حُكْمٌ مَشْرُوطٌ':Added, #5: 5	حُكْمَ الْمُشَبَّهِ
u'حُكْمٌ مَشْرُوعٌ':Added, #1: 1	حُكْمِ الْمَشْرُوطِ
u'حُكْمٌ مَشْرُوعٌ':Added, #1: 1	حُكْمُ الْمَشْرُوعِ
u'حُكْمٌ مُصَافَحَةٌ':Added, #2: 2	حُكْمَ الْمَشْرُوعِ
u'حُكْمٌ مُصَالَحَةٌ':Added, #2: 2	حُكْمُ الْمُصَافَحَةِ
u'حُكْمٌ مِصْرٌ':Added, #1: 1	حُكْمُ الْمُصَالَحَةِ
u'حُكْمٌ مِصْرٌ':Added, #1: 1	حُكْمٍ مِصْرٍ
u'حُكْمٌ مِصْرٌ':Added, #2: 2	حُكْمَ الْمِصْرِ
u'حُكْمٌ مِصْرٌ':Added, #2: 2	حُكْمُ الْمِصْرِ
u'حُكْمٌ مَصْرِفٌ':Added, #2: 2	حُكْمِ الْمِصْرِ
u'حُكْمٌ مَصْلَحَةٌ':Added, #1: 1	حُكْمَ مَصْرِفِهِ
u'حَكَمَ مُصَنِّفٌ':Subject, #1: 1	حُكْمَ الْمَصْلَحَةِ
u'حُكْمٌ مُصَنِّفٌ':Added, #3: 3	حَكَمَ الْمُصَنِّفُ
u'حُكْمٌ مَصُوغٌ':Added, #1: 1	حُكْمِ الْمُصَنِّفِ
u'حُكْمٌ مُضَارِبٌ':Added, #1: 1	حُكْمِ الْمَصُوغِ
u'حُكْمٌ مُضَارَبَةٌ':Added, #5: 5	حُكْمُ الْمُضَارِبِ
u'حُكْمٌ مُضَارَبَةٌ':Added, #2: 2	حُكْمِ الْمُضَارَبَةِ
u'حُكْمٌ مُضَافٌ':Added, #6: 6	حُكْمُ الْمُضَارَبَةِ
u'حُكْمٌ مُطَالَبٌ':Added, #1: 1	حُكْمَ الْمُضَافِ
u'حُكْمٌ مُطَالَبَةٌ':Added, #1: 1	حُكْمِ الْمُطَالَبَةِ
u'حُكْمٌ مَطْبُوخٌ':Added, #1: 1	حُكْمِ الْمُطَالَبَةِ
u'حُكْمٌ مَطْبُوخٌ':Added, #1: 1	حُكْمُ الْمَطْبُوخَةِ
u'حُكْمٌ مُطْلَقٌ':Added, #2: 2	حُكْمُ الْمَطْبُوخِ
u'حُكْمٌ مُطَلَّقٌ':Added, #1: 1	حُكْمَ الْمُطْلَقِ
u'حُكْمٌ مُطَلَّقٌ':Added, #1: 1	حُكْمِ الْمُطَلَّقَاتِ
u'حُكْمٌ مُطْلَقٌ':Added, #1: 1	حُكْمَ الْمُطَلَّقَةِ
u'حُكْمٌ مُطْلَقٌ':Added, #1: 1	حُكْمُ الْمُطْلَقَةِ
u'حُكْمٌ مُطْلَقٌ':Added, #1: 1	حُكْمٍ مُطْلَقٍ
u'حُكْمٌ مُطْلَقٌ':Added, #1: 1	حُكْمُ مُطْلَقٍ
u'حُكْمٌ مُطْلَقٌ':Added, #1: 1	حُكْمُ مُطْلَقِ
u'حُكْمٌ مُطْلَقٌ':Added, #1: 1	حُكْمُ مُطْلَقِهِ
u'حُكْمٌ مُطَلَّقٌ':Added, #2: 2	حُكْمِ الْمُطْلَقِ
u'حُكْمٌ مُطَلَّقٌ':Added, #2: 2	حُكْمِ الْمُطَلَّقَةِ
u'حُكْمٌ مُطْلَقٌ':Added, #3: 3	حُكْمُ الْمُطَلَّقَةِ
u'حُكْمٌ مَطْلُوبٌ':Added, #4: 4	حُكْمُ الْمُطْلَقِ
u'حُكْمٌ مَظْرُوفٌ':Added, #1: 1	حُكْمٍ مَطْلُوبٍ
u'حُكْمٌ مَظْرُوفٌ':Added, #1: 1	حُكْمَ الْمَظْرُوفِ
u'حُكْمٌ مَعَادِنُ':Added, #1: 1	حُكْمَ مَظْرُوفِهِ
u'حُكْمٌ مَعَادِنُ':Added, #1: 1	حُكْمِ الْمَعَادِنِ
u'حُكْمٌ مُعَارَضَةٌ':Added, #2: 2	حُكْمُ الْمَعَادِنِ
u'حُكْمٌ مُعَامَلَةٌ':Added, #1: 1	حُكْمُ الْمُعَارَضَةِ
u'حُكْمٌ مُعَامَلَةٌ':Added, #1: 1	حُكْمُ مُعَامَلَةِ
u'حُكْمٌ مُعَامَلَةٌ':Added, #2: 2	حُكْمُ الْمُعَامَلَةِ
u'حُكْمٌ مُعْتَادٌ':Added, #4: 4	حُكْمُ مُعَامَلَتِهِ
u'حُكْمٌ مُعْتَدٌّ':Added, #1: 1	حُكْمُ الْمُعْتَادِ
u'حُكْمٌ مُعْتَقٌ':Added, #1: 1	حُكْمُ الْمُعْتَدَّةِ
u'حُكْمٌ مُعْتَقٌ':Added, #1: 1	حُكْمَ الْمُعْتَقِ
u'حُكْمٌ مُعْتَقٌ':Added, #1: 1	حُكْمِ الْمُعْتَقِ
u'حُكْمٌ مُعْتَقٌ':Added, #1: 1	حُكْمُ الْمُعْتَقَةِ
u'حُكْمٌ مَعْتُوهٌ':Added, #2: 2	حُكْمُ الْمُعْتَقِ
u'حُكْمٌ مَعْدِنٌ':Added, #1: 1	حُكْمَ الْمَعْتُوهِ
u'حُكْمٌ مَعْدِنٌ':Added, #1: 1	حُكْمَ الْمَعْدِنِ
u'حُكْمٌ مَعْدُودٌ':Added, #2: 2	حُكْمُ الْمَعْدِنِ
u'حُكْمٌ مَعْدُودٌ':Added, #1: 1	حُكْمَ الْمَعْدُودِ
u'حُكْمٌ مَعْدُول':Added, #2: 2	حُكْمُ الْمَعْدُودِ
u'حُكْمٌ مَعْدُومٌ':Added, #1: 1	حُكْمِ الْمَعْدُولَةِ
u'حُكْمٌ مَعْدُومٌ':Added, #1: 1	حُكْمُ الْمَعْدُومِ
u'حُكْمٌ مَعْدُومٌ':Added, #1: 1	حُكْمِ الْمَعْدُومَةِ
u'حُكْمٌ مَعْدُومٌ':Added, #3: 3	حُكْمَ الْمَعْدُومِ
u'حُكْمٌ مُعَرَّفٌ':Added, #5: 5	حُكْمِ الْمَعْدُومِ
u'حُكْمٌ مُعَرَّفٌ':Added, #1: 1	حُكْمُ الْمُعَرَّفِ
u'حُكْمٌ مَعْرُوضٌ':Added, #2: 2	حُكْمِ الْمُعَرَّفِ
u'حُكْمٌ مَعْرُوفٌ':Added, #1: 1	حُكْمُ الْمَعْرُوضِ
u'حُكْمٌ مَعْزُولٌ':Added, #1: 1	حُكْمَ الْمَعْرُوفِ
u'حُكْمٌ مُعْسِرٌ':Added, #1: 1	حُكْمَ الْمَعْزُولِ
u'حُكْمٌ مُعْسِرٌ':Added, #1: 1	حُكْمَ الْمُعْسِرِ
u'حُكْمٌ مَعْصُومٌ':Added, #2: 2	حُكْمِ الْمُعْسِرِ
u'حُكْمٌ مَعْصِيَةٌ':Added, #1: 1	حُكْمُ الْمَعْصُومِ
u'حُكْمٌ مَعْطُوف':Added, #1: 1	حُكْمِ الْمَعْصِيَةِ
u'حُكْمٌ مَعْطُوف':Added, #2: 2	حُكْمَ الْمَعْطُوفِ
u'حُكْمٌ مَعْطُوف':Added, #3: 3	حُكْمُ الْمَعْطُوفِ
u'حُكْمٌ مُعَلِّلٌ':Added, #3: 3	حُكْمِ الْمَعْطُوفِ
u'حُكْمٌ مُعَلَّمٌ':Added, #2: 2	حُكْمِ الْمُعَلِّلِ
u'حُكْمٌ مَعْلُومٌ':Added, #2: 2	حُكْمِ الْمُعَلَّمِ
u'حُكْمٌ مَعْلُومٌ':Added, #1: 1	حُكْمُ الْمَعْلُومِ
u'حُكْمٌ مَعْلُومٌ':Added, #1: 1	حُكْمِ الْمَعْلُومِ
u'حُكْمٌ مُعَيَّنٌ':Added, #5: 5	حُكْمَ الْمَعْلُومِ
u'حُكْمٌ مُعَيَّنٌ':Added, #1: 1	حُكْمُ الْمُعَيَّنِ
u'حُكْمٌ مُعَيَّنٌ':Added, #2: 2	حُكْمُ الْمُعَيَّنَةِ
u'حُكْمٌ مَغْسُولٌ':Added, #4: 4	حُكْمٍ مُعَيَّنٍ
u'حُكْمٌ مَغْسُولٌ':Added, #1: 1	حُكْمَ الْمَغْسُولِ
u'حُكْمٌ مَغْشُوشٌ':Added, #1: 1	حُكْمُ الْمَغْسُولِ
u'حُكْمٌ مَغْشِيٌّ':Added, #2: 2	حُكْمُ الْمَغْشُوشِ
u'حُكْمٌ مَغْصُوب':Added, #1: 1	حُكْمُ الْمَغْشِيِّ
u'حُكْمٌ مَغْصُوب':Added, #1: 1	حُكْمُ الْمَغْصُوبَةِ
u'حُكْمٌ مُغَفَّلٌ':Added, #2: 2	حُكْمُ الْمَغْصُوبِ
u'حُكْمٌ مُغَفَّلٌ':Added, #1: 1	حُكْمُ الْمُغَفَّلِ
u'حُكْمٌ مُغَلَّظ':Added, #1: 1	حُكْمُ مُغَفَّلٍ
u'حُكْمٌ مُغَلَّظ':Added, #1: 1	حُكْمِ الْمُغَلَّظِ
u'حُكْمٌ مُغَلَّظ':Added, #1: 1	حُكْمُ الْمُغَلَّظَةِ
u'حُكْمٌ مُفاداة':Added, #1: 1	حُكْمٍ مُغَلَّظٍ
u'حُكْمٌ مَفَازَة':Added, #1: 1	حُكْمُ الْمُفَادَاةِ
u'حُكْمٌ مَفَازَة':Added, #1: 1	حُكْمُ الْمَفَازَةِ
u'حُكْمٌ مُفْتَقِرٌ':Added, #1: 1	حُكْمِ الْمَفَازَةِ
u'حُكْمٌ مُفْرَدٌ':Added, #1: 1	حُكْمٍ مُفْتَقِرٍ
u'حُكْمٌ مُفْرَدٌ':Added, #1: 1	حُكْمُ الْمُفْرَدِ
u'حُكْمٌ مَفْعُولٌ':Added, #2: 2	حُكْمُ الْمُفْرَدَاتِ
u'حُكْمٌ مَفْعُولٌ':Added, #1: 1	حُكْمُ الْمَفْعُولِ
u'حُكْمٌ مَفْقُودٌ':Added, #1: 1	حُكْمِ الْمَفْعُولِ
u'حُكْمٌ مُفْلِسٌ':Added, #3: 3	حُكْمُ الْمَفْقُودِ
u'حُكْمٌ مُفْلِسٌ':Added, #1: 1	حُكْمَ الْمُفْلِسِ
u'حُكْمٌ مَفْهُومٌ':Added, #4: 4	حُكْمُ الْمُفْلِسِ
u'حُكْمٌ مَفْهُومٌ':Added, #1: 1	حُكْمُ الْمَفْهُومِ
u'حُكْمٌ مَفْهُومٌ':Added, #1: 1	حُكْمِ الْمَفْهُومِ
u'حُكْمٌ مُقَابَلٌ':Added, #1: 1	حُكْمِ مَفْهُومِ
u'حُكْمٌ مُقَابَلٌ':Added, #1: 1	حُكْمُ الْمُقَابَلَةِ
u'حُكْمٌ مُقَابَلَةٌ':Added, #1: 1	حُكْمِ الْمُقَابَلَةِ
u'حُكْمٌ مُقَابَلَةٌ':Added, #1: 1	حُكْمُ الْمُقَابَلَةِ
u'حُكْمٌ مُقَاتِلٌ':Added, #1: 1	حُكْمِ الْمُقَابَلَةِ
u'حُكْمٌ مقارِنُ':Added, #1: 1	حُكْمِ الْمُقَاتِلَةِ
u'حُكْمٌ مُقَارِنٌ':Added, #1: 1	حُكْمِ الْمُقَارِنِ
u'حُكْمٌ مُقَاصَّةٌ':Added, #1: 1	حُكْمِ الْمُقَارِنِ
u'حُكْمٌ مُقَاصَّةٌ':Added, #1: 1	حُكْمُ الْمُقَاصَّةِ
u'حُكْمٌ مُقَاصَّةٌ':Added, #1: 1	حُكْمِ الْمُقَاصَّةِ
u'حُكْمٌ مَقَاصِدُ':Added, #1: 1	حُكْمِ مُقَاصَّةِ
u'حُكْمٌ مَقَاصِدُ':Added, #11: 11	حُكْمُ الْمَقَاصِدِ
u'حُكْمٌ مُقَاطَعَةٌ':Added, #5: 5	حُكْمَ الْمَقَاصِدِ
u'حُكْمٌ مَقْبَرَةٌ':Added, #1: 1	حُكْمُ الْمُقَاطَعَةِ
u'حُكْمٌ مَقْبُوضٌ':Added, #1: 1	حُكْمُ الْمَقْبَرَةِ
u'حُكْمٌ مَقْبُوضٌ':Added, #1: 1	حُكْمَ الْمَقْبُوضِ
u'حُكْمٌ مَقْبُوضٌ':Added, #6: 6	حُكْمُ الْمَقْبُوضِ
u'حُكْمٌ مَقْتُولٌ':Added, #8: 8	حُكْمِ الْمَقْبُوضِ
u'حُكْمٌ مِقْدَارٌ':Added, #1: 1	حُكْمِ الْمَقْتُولِ
u'حُكْمٌ مُقَدَّرٌ':Added, #2: 2	حُكْمَ الْمِقْدَارِ
u'حُكْمٌ مُقَدَّرٌ':Added, #1: 1	حُكْمُ الْمُقَدَّرِ
u'حُكْمٌ مَقْدُورٌ':Added, #1: 1	حُكْمٍ مُقَدَّرٍ
u'حُكْمٌ مُقْرِضٌ':Added, #1: 1	حُكْمِ الْمَقْدُورِ
u'حُكْمٌ مَقْرُورٌ':Added, #1: 1	حُكْمِ الْمُقْرِضِ
u'حُكْمٌ مَقْصُودٌ':Added, #1: 1	حُكْمِ الْمَقْرُورِ
u'حُكْمٌ مَقْضِيّ':Added, #2: 2	حُكْمٍ مَقْصُودٍ
u'حُكْمٌ مَقْطُوعٌ':Added, #5: 5	حُكْمِ الْمَقْضِيِّ
u'حَكَمَ مُقَلَّدٌ':Subject, #1: 1	حُكْمُ الْمَقْطُوعِ
u'حُكْمٌ مُقَلِّدٌ':Added, #1: 1	حَكَمَ مُقَلَّدٌ
u'حُكْمٌ مُقَلِّدٌ':Added, #1: 1	حُكْمُ الْمُقَلِّدِ
u'حُكْمٌ مُقَيَّدٌ':Added, #1: 1	حُكْمِ الْمُقَلِّدِ
u'حُكْمٌ مُقَيَّدٌ':Added, #1: 1	حُكْمَ الْمُقَيَّدِ
u'حُكْمٌ مُقَيَّدٌ':Added, #2: 2	حُكْمُ الْمُقَيَّدِ
u'حُكْمٌ مُقِيمٌ':Added, #2: 2	حُكْمِ الْمُقَيَّدِ
u'حُكْمٌ مُقِيمٌ':Added, #2: 2	حُكْمُ الْمُقِيمِ
u'حُكْمٌ مُكَاتَبَةٌ':Added, #3: 3	حُكْمِ الْمُقِيمِ
u'حُكْمٌ مُكَاتَبَةٌ':Added, #1: 1	حُكْمُ الْمُكَاتَبَاتِ
u'حُكْمٌ مَكَاسِبُ':Added, #1: 1	حُكْمِ الْمُكَاتَبَةِ
u'حُكْمٌ مَكَانٌ':Added, #1: 1	حُكْمِ الْمَكَاسِبِ
u'حُكْمٌ مُكْثٌ':Added, #1: 1	حُكْمُ مَكَانِهِ
u'حُكْمٌ مُكْرَهٌ':Added, #1: 1	حُكْمَ الْمُكْثِ
u'حُكْمٌ مُكْرَهٌ':Added, #1: 1	حُكْمَ الْمُكْرَهِ
u'حُكْمٌ مُكْرَهٌ':Added, #1: 1	حُكْمُ الْمُكْرَهِ
u'حُكْمٌ مُكَلَّفٌ':Added, #2: 2	حُكْمِ الْمُكْرَهِ
u'حُكْمٌ مَكِّيّ':Added, #1: 1	حُكْمُ الْمُكَلَّفِ
u'حُكْمٌ مَكِيلٌ':Added, #3: 3	حُكْمِ الْمَكِّيِّ
u'حُكْمٌ مَكِيلٌ':Added, #1: 1	حُكْمَ الْمَكِيلِ
u'حُكْمٌ مُلاَزَمَةٌ':Added, #5: 5	حُكْمُ الْمَكِيلِ
u'حُكْمٌ مُلاَمَسَةٌ':Added, #1: 1	حُكْمِ مُلَازَمَةِ
u'حُكْمٌ ملح':Added, #1: 1	حُكْمِ الْمُلَامَسَةِ
u'حُكْمٌ مِلْحٌ':Added, #3: 3	حُكْمُ الْمِلْحِ
u'حُكْمٌ مَلْفُوظٌ':Added, #3: 3	حُكْمُ الْمِلْحِ
u'حُكْمٌ مَلْفُوظٌ':Added, #1: 1	حُكْمُ الْمَلْفُوظِ
u'حُكْمٌ مُلْكٌ':Added, #1: 1	حُكْمِ الْمَلْفُوظِ
u'حُكْمٌ مِلْكٌ':Added, #1: 1	حُكْمِ مُلْكِ
u'حُكْمٌ مِلْكٌ':Added, #1: 1	حُكْمُ مِلْكِ
u'حُكْمٌ مِلْكٌ':Added, #23: 23	حُكْمِ مِلْكِهِ
u'حُكْمٌ مِلْكٌ':Added, #29: 29	حُكْمِ مِلْكِ
u'حُكْمٌ مِلْكٌ':Added, #2: 2	حُكْمَ مِلْكِ
u'حُكْمٌ مِلْكٌ':Added, #2: 2	حُكْمِ مِلْكٍ
u'حُكْمٌ مِلْكٌ':Added, #4: 4	حُكْمَ الْمِلْكِ
u'حُكْمٌ مِلْكٌ':Added, #5: 5	حُكْمُ الْمِلْكِ
u'حُكْمٌ مُمْتَدٌّ':Added, #6: 6	حُكْمِ الْمِلْكِ
u'حُكْمٌ مُمْتَنِعٌ':Added, #1: 1	حُكْمُ الْمُمْتَدِّ
u'حُكْمٌ مُمْتَنِعٌ':Added, #1: 1	حُكْمَ الْمُمْتَنِعِ
u'حُكْمٌ مَمَرٌّ':Added, #1: 1	حُكْمِ الْمُمْتَنِعَةِ
u'حُكْمٌ مُمْسِكٌ':Added, #1: 1	حُكْمُ الْمَمَرِّ
u'حُكْمٌ مَمْلُوكٌ':Added, #2: 2	حُكْمُ الْمُمْسِكِ
u'حُكْمٌ مَمْلُوكٌ':Added, #1: 1	حُكْمِ مَمْلُوكِهِ
u'حُكْمٌ مَمْنُوعٌ':Added, #2: 2	حُكْمُ الْمَمْلُوكِ
u'حُكْمٌ مُمَوَّهٌ':Added, #1: 1	حُكْمٍ مَمْنُوعٍ
u'حُكْمٌ مُمَيِّزٌ':Added, #1: 1	حُكْمُ الْمُمَوَّهِ
u'حُكْمٌ مَنَافِعُ':Added, #1: 1	حُكْمُ الْمُمَيِّزِ
u'حُكْمٌ مُنْتَقِلٌ':Added, #3: 3	حُكْمُ الْمَنَافِعِ
u'حُكْمٌ مَنْذُور':Added, #2: 2	حُكْمُ الْمُنْتَقِلِ
u'حُكْمٌ مَنْذُور':Added, #1: 1	حُكْمُ الْمَنْذُورِ
u'حُكْمٌ مَنْسُوجٌ':Added, #1: 1	حُكْمِ الْمَنْذُورَةِ
u'حُكْمٌ مَنْسُوخٌ':Added, #1: 1	حُكْمُ الْمَنْسُوجِ
u'حُكْمٌ مَنْسُوخٌ':Added, #1: 1	حُكْمٍ مَنْسُوخٍ
u'حُكْمٌ مَنْسُوخٌ':Added, #2: 2	حُكْمَ الْمَنْسُوخِ
u'حُكْمٌ مَنْسُوخٌ':Added, #2: 2	حُكْمِ الْمَنْسُوخِ
u'حُكْمٌ مَنْصِبٌ':Added, #4: 4	حُكْمُ الْمَنْسُوخِ
u'حُكْمٌ مَنْصُوصٌ':Added, #1: 1	حُكْمُ الْمَنْصِبِ
u'حُكْمٌ مَنْصُوصٌ':Added, #1: 1	حُكْمُ الْمَنْصُوصَةِ
u'حُكْمٌ مَنْطُوقٌ':Added, #3: 3	حُكْمِ الْمَنْصُوصِ
u'حُكْمٌ مَنْطُوقٌ':Added, #1: 1	حُكْمُ الْمَنْطُوقِ
u'حُكْمٌ مَنْطُوقٌ':Added, #1: 1	حُكْمٍ مَنْطُوقٍ
u'حُكْمٌ مَنْعٌ':Added, #6: 6	حُكْمِ الْمَنْطُوقِ
u'حُكْمٌ مَنْعٌ':Added, #1: 1	حُكْمَ الْمَنْعِ
u'حُكْمٌ مَنْعٌ':Added, #1: 1	حُكْمُ الْمَنْعِ
u'حُكْمٌ مُنْفَتِحٌ':Added, #3: 3	حُكْمِ الْمَنْعِ
u'حُكْمٌ مُنْفَتِحٌ':Added, #1: 1	حُكْمَ الْمُنْفَتِحِ
u'حُكْمٌ مُنَفَّذٌ':Added, #1: 1	حُكْمُ الْمُنْفَتِحِ
u'حُكْمٌ مُنْفَرِدٌ':Added, #1: 1	حُكْمٍ مُنَفَّذٍ
u'حُكْمٌ مُنْفَرِدٌ':Added, #1: 1	حُكْمَ الْمُنْفَرِدِ
u'حُكْمٌ مُنْفَصِلٌ':Added, #4: 4	حُكْمِ الْمُنْفَرِدِ
u'حُكْمٌ مُنْفَصِلٌ':Added, #1: 1	حُكْمَ الْمُنْفَصِلِ
u'حُكْمٌ مَنْفَعَةٌ':Added, #4: 4	حُكْمِ الْمُنْفَصِلِ
u'حُكْمٌ مَنْفَعَةٌ':Added, #1: 1	حُكْمُ الْمَنْفَعَةِ
u'حُكْمٌ مَنْفَعَةٌ':Added, #1: 1	حُكْمِ الْمَنْفَعَةِ
u'حُكْمٌ مَنْفَعَةٌ':Added, #1: 1	حُكْمِ مَنْفَعَةِ
u'حُكْمٌ مَنْفِيٌّ':Added, #2: 2	حُكْمَ الْمَنْفَعَةِ
u'حُكْمٌ مُنْقَطِعٌ':Added, #1: 1	حُكْمُ الْمَنْفِيِّ
u'حُكْمٌ مُنْقَطِعٌ':Added, #1: 1	حُكْمَ مُنْقَطِعِ
u'حُكْمٌ مُنْقَطِعٌ':Added, #2: 2	حُكْمُ الْمُنْقَطِعِ
u'حُكْمٌ مَنْقُولٌ':Added, #4: 4	حُكْمِ الْمُنْقَطِعِ
u'حُكْمٌ مَنْقُولٌ':Added, #1: 1	حُكْمُ مَنْقُولِ
u'حُكْمٌ مُنَكَّرٌ':Added, #2: 2	حُكْمِ الْمَنْقُولِ
u'حُكْمٌ مُنْكِرٌ':Added, #1: 1	حُكْمِ الْمُنَكَّرِ
u'حُكْمٌ مَنْكُوح':Added, #1: 1	حُكْمُ مُنْكِرِ
u'حُكْمٌ مَنْهِيٌّ':Added, #1: 1	حُكْمُ الْمَنْكُوحَةِ
u'حُكْمٌ مَنِيٌّ':Added, #2: 2	حُكْمَ الْمَنْهِيِّ
u'حُكْمٌ مُنِيبٌ':Added, #1: 1	حُكْمِ الْمَنِيِّ
u'حُكْمٌ مَنِيَّةٌ':Added, #1: 1	حُكْمِ مُنِيبِهِ
u'حُكْمٌ مُهَاجِرٌ':Added, #1: 1	حُكْمُ الْمَنِيَّةِ
u'حُكْمٌ مُهَاجِرٌ':Added, #1: 1	حُكْمُ الْمُهَاجِرَاتِ
u'حُكْمٌ مُهْدَر':Added, #2: 2	حُكْمُ الْمُهَاجِرَةِ
u'حُكْمٌ مَهْدُوم':Added, #1: 1	حُكْمِ الْمُهْدَرِ
u'حُكْمٌ مَهْرٌ':Added, #2: 2	حُكْمُ الْمَهْدُومِ
u'حُكْمٌ مَهْرٌ':Added, #10: 10	حُكْمِ الْمَهْرِ
u'حُكْمٌ مَهْرٌ':Added, #3: 3	حُكْمَ الْمَهْرِ
u'حُكْمٌ مَهْرٌ':Added, #3: 3	حُكْمُ مَهْرِ
u'حُكْمٌ مَهْزُوز':Added, #7: 7	حُكْمُ الْمَهْرِ
u'حُكْمٌ مُهْلَةٌ':Added, #1: 1	حُكْمُ مَهْزُوزٍ
u'حُكْمٌ مَوَاتٌ':Added, #1: 1	حُكْمِ الْمُهْلَةِ
u'حُكْمٌ مُؤَازَرَةٌ':Added, #4: 4	حُكْمُ الْمَوَاتِ
u'حُكْمٌ مُؤَاسَاةٌ':Added, #1: 1	حُكْمُ الْمُؤَازَرَةِ
u'حُكْمٌ مُوَافِقٌ':Added, #1: 1	حُكْمُ الْمُؤَاسَاةِ
u'حُكْمٌ مُوَافَقَةٌ':Added, #3: 3	حُكْمَ الْمُوَافِقِ
u'حُكْمٌ مَوَاقِيتُ':Added, #1: 1	حُكْمِ الْمُوَافَقَةِ
u'حُكْمٌ مُوالاة':Added, #1: 1	حُكْمِ الْمَوَاقِيتِ
u'حُكْمٌ مَوْتٌ':Added, #1: 1	حُكْمِ الْمُوَالَاةِ
u'حُكْمٌ مَوْتٌ':Added, #1: 1	حُكْمَ مَوْتِ
u'حُكْمٌ مَوْتٌ':Added, #1: 1	حُكْمُ مَوْتِهِ
u'حُكْمٌ مُؤَثِّرٌ':Added, #3: 3	حُكْمُ الْمَوْتِ
u'حُكْمٌ مَوْجُودٌ':Added, #1: 1	حُكْمُ الْمُؤَثِّرِ
u'حُكْمٌ مَوْجُودٌ':Added, #1: 1	حُكْمَ الْمَوْجُودِ
u'حُكْمٌ مَوْجُودٌ':Added, #1: 1	حُكْمُ الْمَوْجُودِ
u'حُكْمٌ مَوْجُودٌ':Added, #1: 1	حُكْمَ الْمَوْجُودَاتِ
u'حُكْمٌ مَوْجُودٌ':Added, #1: 1	حُكْمِ الْمَوْجُودَةِ
u'حُكْمٌ مُؤَدّاة':Added, #4: 4	حُكْمِ الْمَوْجُودِ
u'حُكْمٌ مُودَعٌ':Added, #2: 2	حُكْمُ الْمُؤَدَّاةِ
u'حُكْمٌ مُودَعٌ':Added, #1: 1	حُكْمُ الْمُودَعِ
u'حُكْمٌ مَوْزُونٌ':Added, #1: 1	حُكْمِ الْمُودَعِ
u'حُكْمٌ مَوْزُونٌ':Added, #1: 1	حُكْمُ الْمَوْزُونِ
u'حُكْمٌ مَوْزُونٌ':Added, #1: 1	حُكْمُ الْمَوْزُونَاتِ
u'حُكْمٌ مَوْصُولٌ':Added, #1: 1	حُكْمِ الْمَوْزُونَاتِ
u'حُكْمٌ مَوْضِعٌ':Added, #1: 1	حُكْمُ الْمَوْصُولِ
u'حُكْمٌ مَوْقُوفٌ':Added, #1: 1	حُكْمِ مَوْضِعِ
u'حُكْمٌ مَوْقُوفٌ':Added, #1: 1	حُكْمُ الْمَوْقُوفِ
u'حُكْمٌ مُؤَكِّدٌ':Added, #2: 2	حُكْمَ الْمَوْقُوفِ
u'حُكْمٌ مُوَكِّلٌ':Added, #1: 1	حُكْمُ الْمُؤَكِّدِ
u'حُكْمٌ مُؤَلَّفٌ':Added, #1: 1	حُكْمُ الْمُوَكِّلِ
u'حُكْمٌ مُؤْمِنٌ':Added, #2: 2	حُكْمَ الْمُؤَلَّفَةِ
u'حُكْمٌ مِيَاهٌ':Added, #1: 1	حُكْمَ الْمُؤْمِنِ
u'حُكْمٌ مَيْتٌ':Added, #1: 1	حُكْمِ مِيَاهِ
u'حُكْمٌ مَيْتٌ':Added, #1: 1	حُكْمُ مَيْتَتِهِ
u'حُكْمٌ مَيْتَةٌ':Added, #3: 3	حُكْمُ الْمَيْتَةِ
u'حُكْمٌ مَيْتَةٌ':Added, #1: 1	حُكْمُ مَيْتَتِهِ
u'حُكْمٌ مِيرَاثٌ':Added, #3: 3	حُكْمُ الْمَيْتَةِ
u'حُكْمٌ مِيرَاثٌ':Added, #2: 2	حُكْمُ مِيرَاثِ
u'حُكْمٌ مِيرَاثٌ':Added, #3: 3	حُكْمَ الْمِيرَاثِ
u'حُكْمٌ مِيرَاثٌ':Added, #3: 3	حُكْمُ الْمِيرَاثِ
u'حُكْمٌ نَابِتٌ':Added, #9: 9	حُكْمِ الْمِيرَاثِ
u'حُكْمٌ نَاسِخٌ':Added, #1: 1	حُكْمُ نَابِتِهِ
u'حُكْمٌ نَاسِخ':Added, #1: 1	حُكْمَ النَّاسِخِ
u'حُكْمٌ نَاسِخٌ':Added, #1: 1	حُكْمَ النَّاسِخِ
u'حُكْمٌ نَاسِخ':Added, #2: 2	حُكْمِ النَّاسِخِ
u'حُكْمٌ نَاسِخٌ':Added, #2: 2	حُكْمِ النَّاسِخِ
u'حُكْمٌ نَاسِخ':Added, #4: 4	حُكْمُ النَّاسِخِ
u'حُكْمٌ نَاظِرٌ':Added, #4: 4	حُكْمُ النَّاسِخِ
u'حُكْمٌ نَاظِرٌ':Added, #1: 1	حُكْمُ النَّاظِرِ
u'حُكْمٌ نَاقِصٌ':Added, #1: 1	حُكْمُ نَاظِرِ
u'حَكَمَ نَائِبٌ':Subject, #1: 1	حُكْمُ النَّاقِصَةِ
u'حُكْمٌ نَائِبٌ':Added, #1: 1	حَكَمَ النَّائِبُ
u'حُكْمٌ نَائِبٌ':Added, #1: 1	حُكْمَ نَائِبِهِ
u'حُكْمٌ نَائِبٌ':Added, #2: 2	حُكْمُ نَائِبِ
u'حُكْمٌ نبات':Added, #3: 3	حُكْمَ النَّائِبِ
u'حُكْمٌ نَبَاتٌ':Added, #1: 1	حُكْمُ نَبَاتِهِ
u'حَكَّمَ نَبِيٌّ':Subject, #1: 1	حُكْمُ نَبَاتِهِ
u'حَكَمَ نَبِيٌّ':Subject, #1: 1	حَكَّمَ النَّبِيُّ
u'حُكْمٌ نَبِيٌّ':Added, #5: 5	حَكَمَ النَّبِيُّ
u'حُكْمٌ نَبِيذٌ':Added, #2: 2	حُكْمَ النَّبِيِّ
u'حُكْمٌ نَبِيذٌ':Added, #1: 1	حُكْمَ النَّبِيذِ
u'حُكْمٌ نَجَاسَةٌ':Added, #1: 1	حُكْمُ النَّبِيذِ
u'حُكْمٌ نَجَاسَةٌ':Added, #13: 13	حُكْمَ النَّجَاسَةِ
u'حُكْمٌ نَجَاسَةٌ':Added, #13: 13	حُكْمُ النَّجَاسَةِ
u'حُكْمٌ نُحَاسٌ':Added, #5: 5	حُكْمِ النَّجَاسَةِ
u'حُكْمٌ نُحَاسٌ':Added, #1: 1	حُكْمَ النُّحَاسِ
u'حُكْمٌ نِحَلٌ':Added, #1: 1	حُكْمُ النُّحَاسِ
u'حُكْمٌ نَحْوٌ':Added, #1: 1	حُكْمِ النِّحَلِ
u'حُكْمٌ نِدَاءٌ':Added, #1: 1	حُكْمَ نَحْوِ
u'حُكْمٌ نَدْبٌ':Added, #1: 1	حُكْمُ النِّدَاءِ
u'حُكْمٌ نذر':Added, #1: 1	حُكْمِ النَّدْبِ
u'حُكْمٌ نَذْرٌ':Added, #1: 1	حُكْمُ نَذْرِهِ
u'حُكْمٌ نذر':Added, #1: 1	حُكْمُ نَذْرِهِ
u'حُكْمٌ نَذْرٌ':Added, #2: 2	حُكْمَ النَّذْرِ
u'حُكْمٌ نذر':Added, #2: 2	حُكْمَ النَّذْرِ
u'حُكْمٌ نَذْرٌ':Added, #2: 2	حُكْمُ نَذْرِ
u'حُكْمٌ نذر':Added, #2: 2	حُكْمُ نَذْرِ
u'حُكْمٌ نذر':Added, #4: 4	حُكْمُ النَّذْرِ
u'حُكْمٌ نَذْرٌ':Added, #4: 4	حُكْمِ النَّذْرِ
u'حُكْمٌ نَذْرٌ':Added, #4: 4	حُكْمُ النَّذْرِ
u'حُكْمٌ نَرْدٌ':Added, #4: 4	حُكْمِ النَّذْرِ
u'حُكْمٌ نَزْعٌ':Added, #3: 3	حُكْمِ النَّرْدِ
u'حُكْمٌ نِساءٌ':Added, #1: 1	حُكْمُ النَّزْعِ
u'حُكْمٌ نِساءٌ':Added, #1: 1	حُكْمُ نِسَاءِ
u'حُكْمٌ نِساءٌ':Added, #2: 2	حُكْمَ النِّسَاءِ
u'حُكْمٌ نَسَبٌ':Added, #3: 3	حُكْمُ النِّسَاءِ
u'حُكْمٌ نَسَبٌ':Added, #2: 2	حُكْمُ النَّسَبِ
u'حُكْمٌ نَسَبٌ':Added, #4: 4	حُكْمَ النَّسَبِ
u'حُكْمٌ نِسْبَةٌ':Added, #8: 8	حُكْمِ النَّسَبِ
u'حُكْمٌ نُسُكٌ':Added, #1: 1	حُكْمِ نِسْبَةٍ
u'حُكْمٌ نُسُكٌ':Added, #1: 1	حُكْمَ النُّسُكَيْنِ
u'حُكْمٌ نِسْيَانٌ':Added, #1: 1	حُكْمِ نُسُكٍ
u'حُكْمٌ نُشَّابٌ':Added, #1: 1	حُكْمُ النِّسْيَانِ
u'حُكْمٌ نَصٌّ':Added, #1: 1	حُكْمُ النُّشَّابِ
u'حُكْمٌ نَصٌّ':Added, #15: 15	حُكْمِ النَّصِّ
u'حُكْمٌ نَصٌّ':Added, #1: 1	حُكْمَ النَّصِّ
u'حُكْمٌ نَصٌّ':Added, #3: 3	حُكْمِ نَصٍّ
u'حُكْمٌ نَصٌّ':Added, #4: 4	حُكْمُ النَّصِّ
u'حُكْمٌ نصاب':Added, #4: 4	حُكْمُ نَصٍّ
u'حُكْمٌ نصاب':Added, #1: 1	حُكْمَ النِّصَابِ
u'حُكْمٌ نصاب':Added, #1: 1	حُكْمُ النِّصَابِ
u'حُكْمٌ نِصَابٌ':Added, #1: 1	حُكْمِ النِّصَابِ
u'حُكْمٌ نِصَابٌ':Added, #1: 1	حُكْمَ النِّصَابِ
u'حُكْمٌ نِصَابٌ':Added, #1: 1	حُكْمُ النِّصَابِ
u'حُكْمٌ نصب':Added, #1: 1	حُكْمِ النِّصَابِ
u'حُكْمٌ نَصْبٌ':Added, #1: 1	حُكْمَ نَصْبِهِ
u'حُكْمٌ نَصْرَانِيٌّ':Added, #1: 1	حُكْمَ نَصْبِهِ
u'حُكْمٌ نصرة':Added, #1: 1	حُكْمَ نَصْرَانِيٍّ
u'حُكْمٌ نُصْرَةٌ':Added, #2: 2	حُكْمُ النُّصْرَةِ
u'حُكْمٌ نِصْفٌ':Added, #2: 2	حُكْمُ النُّصْرَةِ
u'حُكْمٌ نُصُوصٌ':Added, #1: 1	حُكْمُ النِّصْفِ
u'حُكْمٌ نُطْقٌ':Added, #1: 1	حُكْمِ النُّصُوصِ
u'حُكْمٌ نظائر':Added, #1: 1	حُكْمُ النُّطْقِ
u'حُكْمٌ نَظَرٌ':Added, #1: 1	حُكْمُ نَظَائِرِهِ
u'حُكْمٌ نَظَرٌ':Added, #1: 1	حُكْمُ نَظَرِ
u'حُكْمٌ نَظَرٌ':Added, #1: 1	حُكْمُ نَظَرِهِ
u'حُكْمٌ نَظَرٌ':Added, #1: 1	حُكْمِ نَظَرِهِ
u'حُكْمٌ نَظِيرٌ':Added, #5: 5	حُكْمِ النَّظَرِ
u'حُكْمٌ نَعْلٌ':Added, #1: 1	حُكْمُ نَظِيرِهِ
u'حُكْمٌ نفاس':Added, #2: 2	حُكْمُ النَّعْلِ
u'حُكْمٌ نِفَاسٌ':Added, #1: 1	حُكْمِ النِّفَاسِ
u'حُكْمٌ نفاس':Added, #1: 1	حُكْمِ النِّفَاسِ
u'حُكْمٌ نِفَاسٌ':Added, #5: 5	حُكْمُ النِّفَاسِ
u'حُكْمٌ نِفَاقٌ':Added, #5: 5	حُكْمُ النِّفَاسِ
u'حَكَمَ نَفَذٌ':Predicate, #1: 1	حُكْمَ النِّفَاقِ
u'حُكْمٌ نفر':Added, #3: 3	حَكَمَ نَفَذَ
u'حُكْمٌ نَفْرٌ':Added, #1: 1	حُكْمُ النَّفْرِ
u'حُكْمٌ نَفْسٌ':Added, #1: 1	حُكْمُ النَّفْرِ
u'حُكْمٌ نَفْسٌ':Added, #12: 12	حُكْمُ نَفْسِهِ
u'حُكْمٌ نَفْسٌ':Added, #1: 1	حُكْمُ نَفْسِ
u'حُكْمٌ نَفْسٌ':Added, #1: 1	حُكْمِ نَفْسِ
u'حُكْمٌ نَفْسٌ':Added, #2: 2	حُكْمُ النَّفْسِ
u'حُكْمٌ نَفْسٌ':Added, #6: 6	حُكْمِ نَفْسِهِ
u'حُكْمٌ نَفْسٌ':Added, #7: 7	حُكْمِ النَّفْسِ
u'حُكْمٌ نُفَسَاءُ':Added, #8: 8	حُكْمَ نَفْسِهِ
u'حُكْمٌ نُفَسَاءُ':Added, #1: 1	حُكْمَ النُّفَسَاءِ
u'حُكْمٌ نَفْسِيٌّ':Added, #1: 1	حُكْمُ النُّفَسَاءِ
u'حُكْمٌ نَفَقَةٌ':Added, #1: 1	حُكْمِ النَّفْسِيَّةِ
u'حُكْمٌ نَفَقَةٌ':Added, #1: 1	حُكْمَ نَفَقَةِ
u'حُكْمٌ نَفَقَةٌ':Added, #1: 1	حُكْمِ نَفَقَةِ
u'حُكْمٌ نَفَقَةٌ':Added, #2: 2	حُكْمُ النَّفَقَةِ
u'حُكْمٌ نَفَقَةٌ':Added, #2: 2	حُكْمِ النَّفَقَةِ
u'حُكْمٌ نَفَقَةٌ':Added, #3: 3	حُكْمُ نَفَقَتِهِ
u'حُكْمٌ نَفْلٌ':Added, #4: 4	حُكْمُ نَفَقَةِ
u'حُكْمٌ نَفْلٌ':Added, #1: 1	حُكْمَ النَّفْلِ
u'حُكْمٌ نُفُوذٌ':Added, #1: 1	حُكْمُ النَّفْلِ
u'حُكْمٌ نُفُوسٌ':Added, #1: 1	حُكْمُ نُفُوذِ
u'حُكْمٌ نَفْيٌ':Added, #1: 1	حُكْمِ النُّفُوسِ
u'حُكْمٌ نَفْيٌ':Added, #2: 2	حُكْمُ النَّفْيِ
u'حُكْمٌ نَقْدٌ':Added, #3: 3	حُكْمِ النَّفْيِ
u'حُكْمٌ نَقْد':Added, #1: 1	حُكْمِ النَّقْدِ
u'حُكْمٌ نَقْدٌ':Added, #1: 1	حُكْمِ النَّقْدِ
u'حُكْمٌ نَقْد':Added, #3: 3	حُكْمُ النَّقْدِ
u'حُكْمٌ نقرة':Added, #3: 3	حُكْمُ النَّقْدِ
u'حُكْمٌ نُقْرَةٌ':Added, #1: 1	حُكْمُ النُّقْرَةِ
u'حُكْمٌ نَقْشٌ':Added, #1: 1	حُكْمُ النُّقْرَةِ
u'حُكْمٌ نَقْصٌ':Added, #1: 1	حُكْمُ نَقْشِهِ
u'حُكْمٌ نُقْصَانٌ':Added, #1: 1	حُكْمَ النَّقْصِ
u'حُكْمٌ نُقْصَانٌ':Added, #2: 2	حُكْمُ نُقْصَانِهِ
u'حُكْمٌ نَقْضٌ':Added, #3: 3	حُكْمُ النُّقْصَانِ
u'حُكْمٌ نقل':Added, #2: 2	حُكْمِ النَّقْضِ
u'حُكْمٌ نَقْلٌ':Added, #1: 1	حُكْمِ النَّقْلِ
u'حُكْمٌ نقل':Added, #1: 1	حُكْمِ النَّقْلِ
u'حُكْمٌ نَقْلٌ':Added, #2: 2	حُكْمُ نَقْلِ
u'حُكْمٌ نُقُودٌ':Added, #2: 2	حُكْمُ نَقْلِ
u'حُكْمٌ نُقُوطٌ':Added, #3: 3	حُكْمِ النُّقُودِ
u'حُكْمٌ نَقِيبٌ':Added, #2: 2	حُكْمُ النُّقُوطِ
u'حُكْمٌ نَقِيبٌ':Added, #1: 1	حُكْمِ النَّقِيبِ
u'حُكْمٌ نكاح':Added, #2: 2	حُكْمِ نَقِيبِهِ
u'حُكْمٌ نِكَاحٌ':Added, #1: 1	حُكْمَ نِكَاحِ
u'حُكْمٌ نكاح':Added, #1: 1	حُكْمَ نِكَاحِ
u'حُكْمٌ نِكَاحٌ':Added, #5: 5	حُكْمُ نِكَاحِ
u'حُكْمٌ نكاح':Added, #5: 5	حُكْمُ نِكَاحِ
u'حُكْمٌ نكاح':Added, #8: 8	حُكْمَ النِّكَاحِ
u'حُكْمٌ نِكَاحٌ':Added, #8: 8	حُكْمُ النِّكَاحِ
u'حُكْمٌ نِكَاحٌ':Added, #8: 8	حُكْمَ النِّكَاحِ
u'حُكْمٌ نكاح':Added, #8: 8	حُكْمُ النِّكَاحِ
u'حُكْمٌ نِكَاحٌ':Added, #9: 9	حُكْمِ النِّكَاحِ
u'حُكْمٌ نُكُولٌ':Added, #9: 9	حُكْمِ النِّكَاحِ
u'حُكْمٌ نُكُولٌ':Added, #2: 2	حُكْمَ النُّكُولِ
u'حُكْمٌ نُكُولٌ':Added, #2: 2	حُكْمِ النُّكُولِ
u'حُكْمٌ نَمَاءٌ':Added, #3: 3	حُكْمُ النُّكُولِ
u'حُكْمٌ نَمَاءٌ':Added, #2: 2	حُكْمُ النَّمَاءِ
u'حُكْمٌ نَمْلٌ':Added, #3: 3	حُكْمَ النَّمَاءِ
u'حُكْمٌ نهار':Added, #1: 1	حُكْمُ النَّمْلِ
u'حُكْمٌ نَهَارٌ':Added, #1: 1	حُكْمَ النَّهَارِ
u'حُكْمٌ نَهار':Added, #1: 1	حُكْمَ النَّهَارِ
u'حُكْمٌ نَهَارٌ':Added, #1: 1	حُكْمُ النَّهَارِيَّةِ
u'حُكْمٌ نَهارِيّ':Added, #1: 1	حُكْمَ النَّهَارِيَّتَيْنِ
u'حُكْمٌ نَهْرٌ':Added, #1: 1	حُكْمُ النَّهَارِيَّةِ
u'حُكْمٌ نَهْيٌ':Added, #1: 1	حُكْمُ النَّهْرِ
u'حُكْمٌ نَهْيٌ':Added, #1: 1	حُكْمُ النَّهْيِ
u'حُكْمٌ نَهْيٌ':Added, #2: 2	حُكْمَ النَّهْيِ
u'حُكْمٌ نَوَازِلُ':Added, #2: 2	حُكْمِ النَّهْيِ
u'حُكْمٌ نَوْعٌ':Added, #1: 1	حُكْمَ النَّوَازِلِ
u'حُكْمٌ نَوْعٌ':Added, #1: 1	حُكْمُ النَّوْعِ
u'حُكْمٌ نَوْمٌ':Added, #1: 1	حُكْمِ النَّوْعَيْنِ
u'حُكْمٌ نَوْمٌ':Added, #2: 2	حُكْمُ النَّوْمِ
u'حُكْمٌ نِيَابَةٌ':Added, #3: 3	حُكْمُ نَوْمِ
u'حُكْمٌ نِيَّةٌ':Added, #1: 1	حُكْمُ النِّيَابَةِ
u'حُكْمٌ نِيَّةٌ':Added, #1: 1	حُكْمَ نِيَّةِ
u'حُكْمٌ نِيَّةٌ':Added, #1: 1	حُكْمُ نِيَّتِهِ
u'حُكْمٌ نِيَّةٌ':Added, #2: 2	حُكْمِ النِّيَّةِ
u'حُكْمٌ نِيَّةٌ':Added, #2: 2	حُكْمُ نِيَّةِ
u'حُكْمٌ نِيَّةٌ':Added, #3: 3	حُكْمُ النِّيَّةِ
u'حُكْمٌ نِيلٌ':Added, #4: 4	حُكْمَ النِّيَّةِ
u'حُكْمٌ هاء':Added, #1: 1	حُكْمُ النِّيلِ
u'حُكْمٌ هَالِكٌ':Added, #1: 1	حُكْمُ الْهَاءِ
u'حُكْمٌ هِبَاتٌ':Added, #1: 1	حُكْمِ الْهَالِكِ
u'حُكْمٌ هِبَاتٌ':Added, #1: 1	حُكْمُ الْهِبَاتِ
u'حُكْمٌ هِبَةٌ':Added, #1: 1	حُكْمِ الْهِبَاتِ
u'حُكْمٌ هِبَةٌ':Added, #10: 10	حُكْمُ الْهِبَةِ
u'حُكْمٌ هِبَةٌ':Added, #1: 1	حُكْمَ هِبَةِ
u'حُكْمٌ هِبَةٌ':Added, #1: 1	حُكْمِ هِبَةٍ
u'حُكْمٌ هِبَةٌ':Added, #1: 1	حُكْمِ هِبَةِ
u'حُكْمٌ هِبَةٌ':Added, #2: 2	حُكْمَ الْهِبَةِ
u'حُكْمٌ هِبَةٌ':Added, #2: 2	حُكْمُ هِبَةِ
u'حُكْمٌ هِبَةٌ':Added, #2: 2	حُكْمُ هِبَتِهِ
u'حُكْمٌ هجر':Added, #5: 5	حُكْمِ الْهِبَةِ
u'حُكْمٌ هَجْرٌ':Added, #1: 1	حُكْمُ هَجْرِ
u'حُكْمٌ هجرة':Added, #1: 1	حُكْمُ هَجْرِ
u'حُكْمٌ هِجْرَةٌ':Added, #1: 1	حُكْمُ الْهِجْرَةِ
u'حُكْمٌ هَجِينٌ':Added, #1: 1	حُكْمُ الْهِجْرَةِ
u'حُكْمٌ هَدِيٌّ':Added, #1: 1	حُكْمُ الْهَجِينِ
u'حُكْمٌ هَدِيٌّ':Added, #1: 1	حُكْمُ الْهَدِيَّةِ
u'حُكْمٌ هَدِيٌّ':Added, #1: 1	حُكْمِ الْهَدِيَّةِ
u'حُكْمٌ هَدِيٌّ':Added, #1: 1	حُكْمَ هَدِيَّةِ
u'حُكْمٌ هَدْيٌ':Added, #1: 1	حُكْمُ هَدِيَّةِ
u'حُكْمٌ هَدْيٌ':Added, #2: 2	حُكْمَ الْهَدْيِ
u'حُكْمٌ هَدِيَّةٌ':Added, #3: 3	حُكْمُ الْهَدْيِ
u'حُكْمٌ هَدِيَّةٌ':Added, #1: 1	حُكْمُ الْهَدِيَّةِ
u'حُكْمٌ هَدِيَّةٌ':Added, #1: 1	حُكْمِ الْهَدِيَّةِ
u'حُكْمٌ هَدِيَّةٌ':Added, #1: 1	حُكْمَ هَدِيَّةِ
u'حُكْمٌ هِرٌّ':Added, #1: 1	حُكْمُ هَدِيَّةِ
u'حُكْمٌ هلاك':Added, #1: 1	حُكْمُ الْهِرَّةِ
u'حُكْمٌ هَلاَكٌ':Added, #1: 1	حُكْمِ الْهَلَاكِ
u'حُكْمٌ هلاك':Added, #1: 1	حُكْمِ الْهَلَاكِ
u'حُكْمٌ هَلاَكٌ':Added, #1: 1	حُكْمَ هَلَاكِ
u'حُكْمٌ هلاك':Added, #1: 1	حُكْمَ هَلَاكِ
u'حُكْمٌ هَلاَكٌ':Added, #1: 1	حُكْمَ هَلَاكِهِ
u'حُكْمٌ وَاجِبٌ':Added, #1: 1	حُكْمَ هَلَاكِهِ
u'حُكْمٌ وَاجِبٌ':Added, #1: 1	حُكْمِ الْوَاجِبِ
u'حُكْمٌ وَاجِدٌ':Added, #2: 2	حُكْمُ الْوَاجِبِ
u'حُكْمٌ وَاجِدٌ':Added, #1: 1	حُكْمِ الْوَاجِدِ
u'حُكْمٌ واحد':Added, #1: 1	حُكْمُ وَاجِدِ
u'حُكْمٌ وَاحِدٌ':Added, #1: 1	حُكْمِ الْوَاحِدَةِ
u'حُكْمٌ واحد':Added, #1: 1	حُكْمِ الْوَاحِدَةِ
u'حُكْمٌ وَاحِدٌ':Added, #1: 1	حُكْمِ وَاحِدٍ
u'حُكْمٌ واحد':Added, #1: 1	حُكْمِ وَاحِدٍ
u'حُكْمٌ وَاحِدٌ':Added, #2: 2	حُكْمُ الْوَاحِدَةِ
u'حُكْمٌ واحد':Added, #2: 2	حُكْمُ الْوَاحِدَةِ
u'حُكْمٌ وَاحِدٌ':Added, #31: 31	حُكْمٍ وَاحِدٍ
u'حُكْمٌ واحد':Added, #31: 31	حُكْمٍ وَاحِدٍ
u'حُكْمٌ وَاحِدٌ':Added, #3: 3	حُكْمِ الْوَاحِدِ
u'حُكْمٌ واحد':Added, #3: 3	حُكْمِ الْوَاحِدِ
u'حُكْمٌ وَاحِدٌ':Added, #3: 3	حُكْمَ الْوَاحِدَةِ
u'حُكْمٌ واحد':Added, #3: 3	حُكْمَ الْوَاحِدَةِ
u'حُكْمٌ وَاحِدٌ':Added, #4: 4	حُكْمُ الْوَاحِدِ
u'حُكْمٌ وَارِثٌ':Added, #4: 4	حُكْمُ الْوَاحِدِ
u'حُكْمٌ وَارِثٌ':Added, #1: 1	حُكْمُ الْوَارِثِ
u'حُكْمٌ وَازِنٌ':Added, #1: 1	حُكْمِ وَارِثِهِ
u'حُكْمٌ وَاضِعٌ':Added, #1: 1	حُكْمُ الْوَازِنَةِ
u'حُكْمٌ وَاطِئٌ':Added, #1: 1	حُكْمُ الْوَاضِعِ
u'حُكْمٌ وَاطِئٌ':Added, #1: 1	حُكْمُ الْوَاطِئِ
u'حُكْمٌ وَاقِعٌ':Added, #1: 1	حُكْمُ وَاطِئِ
u'حُكْمٌ وَاقِعٌ':Added, #1: 1	حُكْمُ الْوَاقِعِ
u'حُكْمٌ وَاقِعٌ':Added, #1: 1	حُكْمِ الْوَاقِعَةِ
u'حُكْمٌ وَاقِعٌ':Added, #1: 1	حُكْمِ وَاقِعَةٍ
u'حُكْمٌ وَاقِعَةٌ':Added, #2: 2	حُكْمَ الْوَاقِعَةِ
u'حُكْمٌ وَاقِعَةٌ':Added, #1: 1	حُكْمِ الْوَاقِعَةِ
u'حُكْمٌ وَاقِعَةٌ':Added, #1: 1	حُكْمِ وَاقِعَةٍ
u'حُكْمٌ وَاقِفٌ':Added, #2: 2	حُكْمَ الْوَاقِعَةِ
u'حُكْمٌ وَاقِفٌ':Added, #1: 1	حُكْمِ الْوَاقِفِ
u'حُكْمٌ وَالِدٌ':Added, #2: 2	حُكْمَ الْوَاقِفِ
u'حُكْمٌ وَثَنٌ':Added, #2: 2	حُكْمِ الْوَالِدَيْنِ
u'حُكْمٌ وَجْهٌ':Added, #1: 1	حُكْمُ الْوَثَنِ
u'حُكْمٌ وُجُوبٌ':Added, #1: 1	حُكْمُ الْوَجْهِ
u'حُكْمٌ وُجُوبٌ':Added, #1: 1	حُكْمِ وُجُوبِ
u'حُكْمٌ وُجُوبٌ':Added, #2: 2	حُكْمَ الْوُجُوبِ
u'حُكْمٌ وُجُوبٌ':Added, #2: 2	حُكْمُ وُجُوبِ
u'حُكْمٌ وُجُوبٌ':Added, #3: 3	حُكْمُ الْوُجُوبِ
u'حُكْمٌ وُجُودٌ':Added, #5: 5	حُكْمِ الْوُجُوبِ
u'حَكَّمَ وَحْيٌ':Predicate, #1: 1	حُكْمُ الْوُجُودِ
u'حُكْمٌ وَدِيعٌ':Added, #1: 1	حَكَّمَ الْوَحْيَ
u'حُكْمٌ وَدِيعٌ':Added, #1: 1	حُكْمُ الْوَدِيعِ
u'حُكْمٌ وَدِيعٌ':Added, #1: 1	حُكْم الْوَدِيعَةِ
u'حُكْمٌ وَدِيعٌ':Added, #1: 1	حُكْمَ الْوَدِيعَةِ
u'حُكْمٌ وَدِيعٌ':Added, #2: 2	حُكْمِ الْوَدِيعَةِ
u'حُكْمٌ وَدِيعَةٌ':Added, #5: 5	حُكْمُ الْوَدِيعَةِ
u'حُكْمٌ وَدِيعَةٌ':Added, #1: 1	حُكْم الْوَدِيعَةِ
u'حُكْمٌ وَدِيعَةٌ':Added, #1: 1	حُكْمَ الْوَدِيعَةِ
u'حُكْمٌ وَدِيعَةٌ':Added, #2: 2	حُكْمِ الْوَدِيعَةِ
u'حُكْمٌ وَزْنٌ':Added, #5: 5	حُكْمُ الْوَدِيعَةِ
u'حُكْمٌ وَزِيرٌ':Added, #1: 1	حُكْمَ الْوَزْنِ
u'حُكْمٌ وِصَايَةٌ':Added, #1: 1	حُكْمُ وَزِيرِهِ
u'حَكَمَ وَصِيٌّ':Subject, #1: 1	حُكْمِ وِصَايَتِهِ
u'حُكْمٌ وَصِيٌّ':Added, #1: 1	حَكَمَ الْوَصِيُّ
u'حُكْمٌ وَصِيٌّ':Added, #11: 11	حُكْمُ الْوَصِيَّةِ
u'حُكْمٌ وَصِيٌّ':Added, #1: 1	حُكْمُ وَصِيَّتِهِ
u'حُكْمٌ وَصِيٌّ':Added, #2: 2	حُكْمُ الْوَصِيِّ
u'حُكْمٌ وَصِيٌّ':Added, #3: 3	حُكْمُ وَصِيِّ
u'حُكْمٌ وَصِيٌّ':Added, #5: 5	حُكْمَ الْوَصِيَّةِ
u'حُكْمٌ وَصِيَّةٌ':Added, #7: 7	حُكْمِ الْوَصِيَّةِ
u'حُكْمٌ وَصِيَّةٌ':Added, #11: 11	حُكْمُ الْوَصِيَّةِ
u'حُكْمٌ وَصِيَّةٌ':Added, #1: 1	حُكْمُ وَصِيَّتِهِ
u'حُكْمٌ وَصِيَّةٌ':Added, #5: 5	حُكْمَ الْوَصِيَّةِ
u'حُكْمٌ وَضْعٌ':Added, #7: 7	حُكْمِ الْوَصِيَّةِ
u'حُكْمٌ وُضُوءٌ':Added, #2: 2	حُكْمَ وَضْعِ
u'حُكْمٌ وُضُوءٌ':Added, #1: 1	حُكْمِ الْوُضُوءِ
u'حُكْمٌ وُضُوءٌ':Added, #2: 2	حُكْمَ الْوُضُوءِ
u'حُكْمٌ وَطْءٌ':Added, #7: 7	حُكْمُ الْوُضُوءِ
u'حُكْمٌ وَطْءٌ':Added, #1: 1	حُكْمِ وَطْءٍ
u'حُكْمٌ وَطْءٌ':Added, #2: 2	حُكْمَ الْوَطْءِ
u'حُكْمٌ وَطْءٌ':Added, #2: 2	حُكْمِ الْوَطْءِ
u'حُكْمٌ وَطْءٌ':Added, #3: 3	حُكْمُ الْوَطْءِ
u'حُكْمٌ وَطَنٌ':Added, #3: 3	حُكْمُ وَطْءِ
u'حُكْمٌ وَطَنٌ':Added, #1: 1	حُكْمُ الْوَطَنِ
u'حُكْمٌ وَطَنٌ':Added, #1: 1	حُكْمِ وَطَنِ
u'حُكْمٌ وَظِيفٌ':Added, #1: 1	حُكْمِ وَطَنِهِ
u'حُكْمٌ وَظِيفَةٌ':Added, #2: 2	حُكْمُ الْوَظِيفَةِ
u'حُكْمٌ وِقَايَةٌ':Added, #2: 2	حُكْمُ الْوَظِيفَةِ
u'حُكْمٌ وَقْتٌ':Added, #1: 1	حُكْمِ الْوِقَايَةِ
u'حُكْمٌ وَقْت':Added, #1: 1	حُكْمُ الْوَقْتِ
u'حُكْمٌ وَقْتٌ':Added, #1: 1	حُكْمَ الْوَقْتِيَّةِ
u'حُكْمٌ وَقْتِيّ':Added, #1: 1	حُكْمِ وَقْتٍ
u'حُكْمٌ وَقْفٌ':Added, #1: 1	حُكْمَ الْوَقْتِيَّةِ
u'حُكْمٌ وَقْفٌ':Added, #12: 12	حُكْمُ الْوَقْفِ
u'حُكْمٌ وَقْفٌ':Added, #1: 1	حُكْمِ وَقْفِ
u'حُكْمٌ وَقْفٌ':Added, #2: 2	حُكْمَ وَقْفِ
u'حُكْمٌ وَقْفٌ':Added, #3: 3	حُكْمُ وَقْفِ
u'حُكْمٌ وَقْفٌ':Added, #6: 6	حُكْمَ الْوَقْفِ
u'حُكْمٌ وُقُوعٌ':Added, #7: 7	حُكْمِ الْوَقْفِ
u'حُكْمٌ وُقُوفٌ':Added, #3: 3	حُكْمِ وُقُوعِ
u'حُكْمٌ وُقُوفٌ':Added, #1: 1	حُكْمُ الْوُقُوفِ
u'حُكْمٌ وُقُوفٌ':Added, #3: 3	حُكْمِ الْوُقُوفِ
u'حُكْمٌ وَكِيلٌ':Added, #3: 3	حُكْمُ وُقُوفِ
u'حُكْمٌ وَكِيلٌ':Added, #11: 11	حُكْمُ الْوَكِيلِ
u'حُكْمٌ وَكِيلٌ':Added, #1: 1	حُكْمِ وَكِيلِ
u'حُكْمٌ وَلاَءٌ':Added, #3: 3	حُكْمَ الْوَكِيلِ
u'حُكْمٌ وَلاَءٌ':Added, #2: 2	حُكْمَ الْوَلَاءِ
u'حُكْمٌ وَلاَءٌ':Added, #2: 2	حُكْمُ الْوَلَاءِ
u'حُكْمٌ وَلاَءٌ':Added, #2: 2	حُكْمُ وَلَاءِ
u'حُكْمٌ وُلاَةٌ':Added, #6: 6	حُكْمِ الْوَلَاءِ
u'حُكْمٌ وِلاَدَةٌ':Added, #2: 2	حُكْمُ وُلَاةِ
u'حُكْمٌ وِلاَيَةٌ':Added, #2: 2	حُكْمِ الْوِلَادَةِ
u'حُكْمٌ وِلاَيَةٌ':Added, #1: 1	حُكْمُ وِلَايَاتِ
u'حُكْمٌ ولد':Added, #3: 3	حُكْمِ الْوِلَايَةِ
u'حُكْمٌ وَلَدٌ':Added, #14: 14	حُكْمُ الْوَلَدِ
u'حُكْمٌ ولد':Added, #14: 14	حُكْمُ الْوَلَدِ
u'حُكْمٌ وَلَدٌ':Added, #1: 1	حُكْمِ الْوَلَدِ
u'حُكْمٌ وَلَدٌ':Added, #1: 1	حُكْمِ الْوَلَدِ
u'حُكْمٌ وَلَدٌ':Added, #1: 1	حُكْمَ وَلَدٍ
u'حُكْمٌ ولد':Added, #1: 1	حُكْمِ وَلَدٍ
u'حُكْمٌ ولد':Added, #2: 2	حُكْمَ وَلَدِ
u'حُكْمٌ وَلَدٌ':Added, #2: 2	حُكْمِ وَلَدِ
u'حُكْمٌ وَلَدٌ':Added, #2: 2	حُكْمَ وَلَدِ
u'حُكْمٌ ولد':Added, #2: 2	حُكْمِ وَلَدِ
u'حُكْمٌ وَلَدٌ':Added, #5: 5	حُكْمَ الْوَلَدِ
u'حُكْمٌ ولد':Added, #5: 5	حُكْمَ الْوَلَدِ
u'حُكْمٌ وَلَدٌ':Added, #9: 9	حُكْمُ وَلَدِ
u'حُكْمٌ وَلِيٌّ':Added, #9: 9	حُكْمُ وَلَدِ
u'حُكْمٌ وَلِيٌّ':Added, #2: 2	حُكْمُ الْوَلِيِّ
u'حُكْمٌ وَلِيٌّ':Added, #2: 2	حُكْمِ الْوَلِيِّ
u'حُكْمٌ يُتْمٌ':Added, #5: 5	حُكْمُ وَلِيِّ
u'حُكْمٌ يَدٌ':Added, #1: 1	حُكْمِ الْيُتْمِ
u'حُكْمٌ يَدٌ':Added, #1: 1	حُكْمَ الْيَدِ
u'حُكْمٌ يَدٌ':Added, #1: 1	حُكْمِ الْيَدِ
u'حُكْمٌ يَدٌ':Added, #1: 1	حُكْمَ يَدِ
u'حُكْمٌ يَدٌ':Added, #1: 1	حُكْمِ يَدِ
u'حُكْمٌ يَدٌ':Added, #1: 1	حُكْمُ يَدِهِ
u'حُكْمٌ يَدٌ':Added, #1: 1	حُكْمِ يَدَيْنِ
u'حُكْمٌ يَسِيرٌ':Added, #6: 6	حُكْمُ الْيَدِ
u'حُكْمٌ يَسِيرٌ':Added, #1: 1	حُكْمَ الْيَسِيرِ
u'حُكْمٌ يَسِيرٌ':Added, #1: 1	حُكْمُ الْيَسِيرِ
u'حُكْمٌ يَقْظَان':Added, #1: 1	حُكْمِ الْيَسِيرِ
u'حُكْمٌ يَقِينٌ':Added, #1: 1	حُكْمَ الْيَقْظَانِ
u'حُكْمٌ يَمِينٌ':Added, #3: 3	حُكْمُ الْيَقِينِ
u'حُكْمٌ يَمِينٌ':Added, #13: 13	حُكْمُ الْيَمِينِ
u'حُكْمٌ يَمِينٌ':Added, #1: 1	حُكْمُ يَمِينٍ
u'حُكْمٌ يَمِينٌ':Added, #1: 1	حُكْمُ يَمِينِ
u'حُكْمٌ يَمِينٌ':Added, #1: 1	حُكْمَ يَمِينِهِ
u'حُكْمٌ يَمِينٌ':Added, #2: 2	حُكْمَ يَمِينِ
u'حُكْمٌ يَمِينٌ':Added, #6: 6	حُكْمَ الْيَمِينِ
u'حُكْمٌ يَهُودِيٌّ':Added, #8: 8	حُكْمِ الْيَمِينِ
u'حُكْمٌ يَهُودِيٌّ':Added, #1: 1	حُكْمِ الْيَهُودِيَّةِ
u'حَكَمَ يَوْمٌ':Predicate, #1: 1	حُكْمُ يَهُودِيٍّ
u'حُكْمٌ يَوْمٌ':Added, #1: 1	حَكَمَ الْيَوْمَ
u'حُكْمٌ يَوْمٌ':Added, #1: 1	حُكْمُ الْيَوْمَيْنِ
u'حُكُومَةٌ أَرْبَعَةٌ':Added, #2: 2	حُكْمَ الْيَوْمِ
u'حُكُومَةٌ ألَمٌ':Added, #1: 1	حُكُومَةُ أَرْبَعَةِ
u'حُكُومَةٌ ألَمٌ':Added, #1: 1	حُكُومَةُ الْأَلَمِ
u'حُكُومَةٌ أهْدَابٌ':Added, #1: 1	حُكُومَةِ الْأَلَمِ
u'حُكُومَةٌ أَهْدَابٌ':Added, #1: 1	حُكُومَةُ الْأَهْدَابِ
u'حُكُومَةٌ بَعْضٌ':Added, #1: 1	حُكُومَةُ الْأَهْدَابِ
u'حُكُومَةٌ جُرْحٌ':Added, #1: 1	حُكُومَةُ بَعْضِ
u'حُكُومَةٌ جَوَانِبُ':Added, #1: 1	حُكُومَةُ جُرْحٍ
u'حُكُومَةٌ خُمُسٌ':Added, #1: 1	حُكُومَةُ جَوَانِبِهِ
u'حُكُومَةٌ خُمُسٌ':Added, #1: 1	حُكُومَةُ الْخُمُسِ
u'حُكُومَةٌ خَمْسَةٌ':Added, #2: 2	حُكُومَةُ خُمُسِ
u'حُكُومَةٌ ذِمِّيٌّ':Added, #1: 1	حُكُومَةُ خَمْسَةِ
u'حُكُومَةٌ سَاعِدٌ':Added, #1: 1	حُكُومَةِ الذِّمِّيِّ
u'حُكُومَةٌ سِنٌّ':Added, #1: 1	حُكُومَةُ السَّاعِدِ
u'حُكُومَةٌ سِنْخ':Added, #1: 1	حُكُومَةِ سِنٍّ
u'حُكُومَةٌ شَارِبٌ':Added, #1: 1	حُكُومَةُ سِنْخِ
u'حُكُومَةٌ شَعْرٌ':Added, #1: 1	حُكُومَةُ الشَّارِبِ
u'حُكُومَةٌ شُفْرٌ':Added, #1: 1	حُكُومَةُ الشَّعْرِ
u'حُكُومَةٌ شُفْرٌ':Added, #1: 1	حُكُومَةُ الشُّفْرَيْنِ
u'حُكُومَةٌ شُفْرٌ':Added, #1: 1	حُكُومَةِ الشُّفْرَيْنِ
u'حُكُومَةٌ شَقٌّ':Added, #2: 2	حُكُومَةَ الشُّفْرَيْنِ
u'حُكُومَةٌ عَدْلٌ':Added, #1: 1	حُكُومَةُ الشَّقِّ
u'حُكُومَةٌ عَدْلٌ':Added, #146: 146	حُكُومَةُ عَدْلٍ
u'حُكُومَةٌ عَدْلٌ':Added, #17: 17	حُكُومَةُ الْعَدْلِ
u'حُكُومَةٌ عَدْلٌ':Added, #2: 2	حُكُومَةَ الْعَدْلِ
u'حُكُومَةٌ عَدْلٌ':Added, #3: 3	حُكُومَة عَدْلٍ
u'حُكُومَةٌ عَدْلٌ':Added, #3: 3	حُكُومَةَ عَدْلٍ
u'حُكُومَةٌ عَدْلٌ':Added, #3: 3	حُكُومَةِ عَدْلٍ
u'حُكُومَةٌ عُضْوٌ':Added, #4: 4	حُكُومَةِ الْعَدْلِ
u'حُكُومَةٌ قَصَبَةٌ':Added, #1: 1	حُكُومَةُ الْعُضْوِ
u'حُكُومَةٌ كَفٌّ':Added, #1: 1	حُكُومَةُ قَصَبَةِ
u'حُكُومَةٌ مذاكير':Added, #5: 5	حُكُومَةُ الْكَفِّ
u'حُكُومَةٌ مذاكير':Added, #1: 1	حُكُومَةَ الْمَذَاكِيرِ
u'حُكُومَةٌ مذاكير':Added, #1: 1	حُكُومَةُ الْمَذَاكِيرِ
u'حُكُومَةٌ مُعَيَّنٌ':Added, #2: 2	حُكُومَةِ الْمَذَاكِيرِ
u'حُكُومَةٌ مَنَابِتُ':Added, #1: 1	حُكُومَةٍ مُعَيَّنَةٍ
u'حُكُومَةٌ نِصْفٌ':Added, #1: 1	حُكُومَةِ مَنَابِتِ
u'حُكُومَةٌ نَقْصٌ':Added, #1: 1	حُكُومَةُ نِصْفِ
u'حُكُومَةٌ واحد':Added, #1: 1	حُكُومَةِ نَقْصِهِ
u'حُكُومَةٌ وَاحِدٌ':Added, #3: 3	حُكُومَةٍ وَاحِدَةٍ
u'حُكُومَةٌ يَدٌ':Added, #3: 3	حُكُومَةٍ وَاحِدَةٍ
u'حَكَى اِبْنٌ':Subject, #1: 1	حُكُومَةَ الْيَدِ
u'حَكَى اِتِّفَاقٌ':Predicate, #69: 69	حَكَى ابْنُ
u'حَكَى أثَرٌ':Predicate, #1: 1	حَكَى اتِّفَاقَ
u'حَكَى إِجْمَاعٌ':Predicate, #1: 1	حَكَى أَثَرَ
u'حَكَى إِجْمَاعٌ':Predicate, #3: 3	حَكَى إجْمَاعَ
u'حَكَى اِحْتِمَالٌ':Predicate, #7: 7	حَكَى الْإِجْمَاعَ
u'حَكَى اِخْتِلاَفٌ':Predicate, #1: 1	حَكَى احْتِمَالَ
u'حَكَى اِخْتِيَارٌ':Predicate, #1: 1	حَكَى اخْتِلَافَ
u'حَكَى أَذَانٌ':Predicate, #1: 1	حَكَى اخْتِيَارَ
u'حَكَى أُسْتَاذٌ':Subject, #1: 1	حَكَى الْأَذَانَ
u'حَكَى أَشْيَاخٌ':Subject, #4: 4	حَكَى الْأُسْتَاذُ
u'حَكَى أَصْحَابٌ':Subject, #1: 1	حَكَى الْأَشْيَاخُ
u'حَكَى أصل':Subject, #12: 12	حَكَى الْأَصْحَابُ
u'حَكَى أًصْلٌ':Subject, #4: 4	حَكَى الْأَصْلُ
u'حَكَى إِطْلاقٌ':Predicate, #4: 4	حَكَى الْأَصْلُ
u'حَكَى أَقْوَالٌ':Predicate, #1: 1	حَكَى الْإِطْلَاقَ
u'حَكَى أَكْثَرُ':Subject, #4: 4	حَكَى الْأَقْوَالَ
u'حَكَى إمَامٌ':Subject, #1: 1	حَكَى أَكْثَرُ
u'حَكَى إمَامٌ':Subject, #11: 11	حَكَى الْإِمَامُ
u'حَكَى اِنْقِسَامٌ':Predicate, #2: 2	حَكَى إمَامُ
u'حَكَى أَوْجُهٌ':Predicate, #1: 1	حَكَى انْقِسَامَ
u'حَكَى أَوَّلُ':Predicate, #1: 1	حَكَى الْأَوْجُهَ
u'حَكَى أئِمَّةٌ':Subject, #3: 3	حَكَى الْأَوَّلَ
u'حَكَى بَصيرٌ':Subject, #2: 2	حَكَى الْأَئِمَّةُ
u'حَكَى بَعْضٌ':Predicate, #1: 1	حَكَى الْبَصِيرُ
u'حَكَى بَعْضٌ':Subject, #1: 1	حَكَى بَعْضَ
u'حَكَى بَقِيَّةٌ':Predicate, #12: 12	حَكَى بَعْضُ
u'حَكَى تَاجٌ':Subject, #1: 1	حَكَى بَقِيَّةَ
u'حَكَى تَعْبِيرٌ':Predicate, #1: 1	حَكَى التَّاجُ
u'حَكَى ثَلاثَةٌ':Predicate, #1: 1	حَكَى تَعْبِيرَ
u'حَكَى جَابِرٌ':Subject, #2: 2	حَكَى الثَّلَاثَةَ
u'حَكَى جَصَّاصٌ':Subject, #1: 1	حَكَى جَابِرٌ
u'حَكَى جَلاَلٌ':Subject, #1: 1	حَكَى الْجَصَّاصُ
u'حَكَى جَمَاعَةٌ':Subject, #1: 1	حَكَى الْجَلَالُ
u'حَكَى حاكِمٌ':Subject, #2: 2	حَكَى جَمَاعَةٌ
u'حَكَى حَلْوانِيٌّ':Subject, #1: 1	حَكَى الْحَاكِمُ
u'حَكَى حَمْلٌ':Predicate, #1: 1	حَكَى الْحَلْوَانِيُّ
u'حَكَى خُرُوجٌ':Predicate, #1: 1	حَكَى حَمْلَ
u'حَكَى خَطِيبٌ':Subject, #1: 1	حَكَى الْخُرُوجَ
u'حَكَى خِلاَفٌ':Predicate, #3: 3	حَكَى الْخَطِيبُ
u'حَكَى خِلاَفٌ':Predicate, #4: 4	حَكَى خِلَافَ
u'حَكَى خِيرَةٌ':Subject, #83: 83	حَكَى الْخِلَافَ
u'حَكَى رَافِعٌ':Subject, #1: 1	حَكَى الْخِيَرَةُ
u'حَكَى رُجُوعٌ':Predicate, #1: 1	حَكَى رَافِعٌ
u'حَكَى رَضِيٌّ':Subject, #1: 1	حَكَى رُجُوعَ
u'حَكَى رِوايَةٌ':Predicate, #1: 1	حَكَى الرَّضِيُّ
u'حَكَى رِوايَةٌ':Predicate, #1: 1	حَكَى رِوَايَةَ
u'حَكَى سَامِريٌّ':Subject, #5: 5	حَكَى الرِّوَايَةَ
u'حَكَى سِبْطٌ':Subject, #1: 1	حَكَى السَّامِرِيُّ
u'حَكَى شَارِحٌ':Subject, #1: 1	حَكَى سِبْطُ
u'حَكَى شافِع':Subject, #2: 2	حَكَى الشَّارِحُ
u'حَكَى شافِعِيّ':Subject, #1: 1	حَكَى الشَّافِعِيَّةُ
u'حَكَى شافِعِيّ':Subject, #1: 1	حَكَى الشَّافِعِيُّ
u'حَكَى شَيْخٌ':Subject, #1: 1	حَكَى الشَّافِعِيَّةُ
u'حَكَى صَاحِبٌ':Subject, #10: 10	حَكَى الشَّيْخُ
u'حَكَى صَالِحٌ':Subject, #12: 12	حَكَى صَاحِبُ
u'حَكَى صَالِح':Subject, #1: 1	حَكَى صَالِحُ
u'حَكَى صَلاَةٌ':Predicate, #1: 1	حَكَى صَالِحُ
u'حَكَى صُورَةٌ':Predicate, #1: 1	حَكَى صَلَاةَ
u'حَكَى صَيْدَلانِيّ':Subject, #1: 1	حَكَى الصُّورَةَ
u'حَكَى ضَمَانٌ':Predicate, #1: 1	حَكَى الصَّيْدَلَانِيُّ
u'حَكَى طَائِفٌ':Subject, #1: 1	حَكَى الضَّمَانَ
u'حَكَى طَبَرِيّ':Subject, #1: 1	حَكَى طَائِفَةٌ
u'حَكَى ظَنٌّ':Predicate, #2: 2	حَكَى الطَّبَرِيُّ
u'حَكَى ظَهيرٌ':Subject, #1: 1	حَكَى ظَنَّ
u'حَكَى عَبْدٌ':Subject, #1: 1	حَكَى ظَهِيرُ
u'حَكَى عَدَمٌ':Predicate, #4: 4	حَكَى عَبْدُ
u'حَكَى عِزٌّ':Subject, #3: 3	حَكَى عَدَمَ
u'حَكَى عُمَرٌ':Subject, #1: 1	حَكَى عِزُّ
u'حَكَى غير':Subject, #1: 1	حَكَى عُمَرُ
u'حَكَى غَيْرٌ':Subject, #1: 1	حَكَى غَيْرُ
u'حَكَى فُحْشٌ':Predicate, #1: 1	حَكَى غَيْرُ
u'حَكَى فلان':Predicate, #1: 1	حَكَى فُحْشَ
u'حَكَى فلان':Subject, #1: 1	حَكَى الرَّازِيَّ
u'حَكَى فلان':Subject, #1: 1	حَكَى الْبَيْهَقِيُّ
u'حَكَى فلان':Subject, #1: 1	حَكَى التِّرْمِذِيُّ
u'حَكَى فلان':Subject, #1: 1	حَكَى الزّبَيْرُ
u'حَكَى فلان':Subject, #1: 1	حَكَى الزُّبَيْرُ
u'حَكَى فلان':Subject, #1: 1	حَكَى الشَّافِعِيُّ
u'حَكَى فلان':Subject, #1: 1	حَكَى الشَّافِعِيَّةُ
u'حَكَى فلان':Subject, #1: 1	حَكَى الْقُرْطُبِيُّ
u'حَكَى فلان':Subject, #1: 1	حَكَى عُثْمَانُ
u'حَكَى قَاسِمٌ':Subject, #2: 2	حَكَى الطَّبَرِيُّ
u'حَكَى قُرْآنٌ':Subject, #1: 1	حَكَى الْقَاسِمُ
u'حَكَى قُرْطُبِيّ':Subject, #1: 1	حَكَى الْقُرْآنُ
u'حَكَى قَضَاءٌ':Predicate, #1: 1	حَكَى الْقُرْطُبِيُّ
u'حَكَى قُطْرُبٌ':Subject, #1: 1	حَكَى الْقَضَاءَ
u'حَكَى قَفَّالٌ':Subject, #1: 1	حَكَى قُطْرُبٌ
u'حَكَى قول':Predicate, #1: 1	حَكَى الْقَفَّالُ
u'حَكَى قَوْلٌ':Predicate, #6: 6	حَكَى قَوْلَ
u'حَكَى قول':Predicate, #6: 6	حَكَى قَوْلَ
u'حَكَى قَوْلٌ':Predicate, #7: 7	حَكَى الْقَوْلَ
u'حَكَى قَوْمٌ':Subject, #7: 7	حَكَى الْقَوْلَ
u'حَكَى كَلاَمٌ':Predicate, #1: 1	حَكَى قَوْمٌ
u'حَكَى كَلاَمٌ':Subject, #4: 4	حَكَى كَلَامَ
u'حَكَى مُحَمَّدٌ':Subject, #1: 1	حَكَى كَلَامُ
u'حَكَى مُحَمَّدٌ':Subject, #1: 1	حَكَى مُحَمَّدٌ
u'حَكَى مَذَاهِبُ':Predicate, #4: 4	حَكَى مُحَمَّدُ
u'حَكَى مَذْهَبٌ':Predicate, #1: 1	حَكَى مَذَاهِبَ
u'حَكَى مَشْهُورٌ':Predicate, #1: 1	حَكَى مَذْهَبَ
u'حَكَى مُصَنِّفٌ':Subject, #1: 1	حَكَى الْمَشْهُورَ
u'حَكَى نَصٌّ':Predicate, #18: 18	حَكَى الْمُصَنِّفُ
u'حَكَى نَصٌّ':Predicate, #1: 1	حَكَى النَّصَّ
u'حَكَى نَوَوِيٌّ':Subject, #1: 1	حَكَى نَصَّ
u'حَكَى وُضُوءٌ':Predicate, #4: 4	حَكَى النَّوَوِيُّ
u'حَكَى وَقْفٌ':Predicate, #2: 2	حَكَى وُضُوءَ
u'حَكَى يَعْقُوبٌ':Subject, #1: 1	حَكَى الْوَقْفَ
u'حَكَى يَمِينٌ':Predicate, #1: 1	حَكَى يَعْقُوبُ
u'حَلَّ اِبْنٌ':Predicate, #1: 1	حَكَى يَمِينَ
u'حَلَا تَوْلِيَةٌ':Subject, #2: 2	أَحَلَّ ابْنَ
u'حَلَّ إِتْيانٌ':Predicate, #1: 1	حَلَا تَوْلِيَةٌ
u'حَلَّ أَجَلٌ':Subject, #1: 1	أَحَلَّ إِتْيَانَ
u'حَلَّ أَجَلٌ':Subject, #2: 2	حَلَّ الأَجَلُ
u'حَلَّ أَجَلٌ':Subject, #6: 6	حَلَّ أَجَلُهُ
u'حَلَّ أَجَلٌ':Subject, #8: 8	حَلَّ أَجَلُ
u'حَلَّ إِحْرَامٌ':Subject, #91: 91	حَلَّ الْأَجَلُ
u'حَلَّ أخْذٌ':Subject, #1: 1	حَلَّ إحْرَامُهُ
u'حَلَّ إدْخَالٌ':Subject, #1: 1	حَلَّ أَخْذُهُ
u'حَلَّ اِسْتِعْمالٌ':Subject, #1: 1	حَلَّ إدْخَالُ
u'حَلَّ أكل':Subject, #2: 2	حَلَّ اسْتِعْمَالُهُ
u'حَلَّ أَكْلٌ':Subject, #2: 2	حَلَّ الْأَكْلُ
u'حَلَّ أكل':Subject, #2: 2	حَلَّ الْأَكْلُ
u'حَلَّ أَكْلٌ':Subject, #49: 49	حَلَّ أَكْلُهُ
u'حَلَّ الْمَرْأَةُ':Predicate, #49: 49	حَلَّ أَكْلُهُ
u'حَلَّ أهْلٌ':Subject, #1: 1	أَحَلَّ الْمَرْأَةَ
u'حَلاَوَةٌ إيمَانٌ':Added, #1: 1	حَلَّ أَهْلُهُ
u'حَلَبَ أَكْثَرُ':Subject, #1: 1	حَلاَوَةَ الإِيمَانِ
u'حَلَبَ ثَانِي':Predicate, #1: 1	حَلَبَ أَكْثَرُ
u'حَلَبَ خدمة':Subject, #1: 1	حَلَبَ ثَانِيَةً
u'حَلَبَ خِدْمَةٌ':Subject, #1: 1	حَلَبَ خِدْمَةُ
u'حَلَبَ صَيْدٌ':Predicate, #1: 1	حَلَبَ خِدْمَةُ
u'حَلَبَ ظَبْيٌ':Predicate, #2: 2	حَلَبَ صَيْدَ
u'حَلَّ بَعْضٌ':Subject, #1: 1	حَلَبَ ظَبْيَةً
u'حَلَبَ غَنَمٌ':Predicate, #1: 1	حَلَّ بَعْضُهُ
u'حَلَبَ فُلاَنٌ':Subject, #2: 2	حَلَبَ الْغَنَمَ
u'حَلَبَ قَالٌ':Predicate, #1: 1	حَلَبَ فُلَانٌ
u'حَلَبَ لبن':Predicate, #1: 1	حَلَبَ قَالَ
u'حَلَبَ لَبَنٌ':Predicate, #3: 3	حَلَبَ اللَّبَنَ
u'حَلَبَ لبن':Predicate, #3: 3	حَلَبَ اللَّبَنَ
u'حَلَبَ لَبَنٌ':Predicate, #4: 4	حَلَبَ لَبَنَ
u'حَلَّ بَيْعٌ':Predicate, #4: 4	حَلَبَ لَبَنَ
u'حَلَّ بَيْعٌ':Predicate, #1: 1	أَحَلَّ بَيْعَ
u'حَلَّ بَيْعٌ':Subject, #2: 2	أَحَلَّ الْبَيْعَ
u'حَلَّ بَيْعٌ':Subject, #1: 1	حَلَّ بَيْعُ
u'حَلَّ بَيْنٌ':Predicate, #9: 9	حَلَّ بَيْعُهُ
u'حَلَّ تَزَوُّجٌ':Subject, #1: 1	أَحَلَّ بَيْنَ
u'حَلَّ تَصَرُّفٌ':Subject, #1: 1	حَلَّ تَزَوُّجُ
u'حَلَّ تَصْرِيحٌ':Subject, #1: 1	حَلَّ تَصَرُّفُهُ
u'حَلَّ تَفَاضُلٌ':Subject, #1: 1	حَلَّ التَّصْرِيحُ
u'حَلَّ تَفْرِيقٌ':Subject, #9: 9	حَلَّ التَّفَاضُلُ
u'حَلَّ تَمَلُّكٌ':Subject, #1: 1	حَلَّ التَّفْرِيقُ
u'حَلَّ تَنَاوُلٌ':Subject, #1: 1	حَلَّ تَمَلُّكُهُ
u'حَلَّ تَنَاوُلٌ':Subject, #1: 1	حَلَّ التَّنَاوُلُ
u'حَلَّ ثَمَنٌ':Subject, #6: 6	حَلَّ تَنَاوُلُهُ
u'حَلَّ ثَمَنٌ':Subject, #1: 1	حَلَّ الثَّمَنُ
u'حَلَّ جَمِيع':Subject, #1: 1	حَلَّ ثَمَنُهُ
u'حَلَّ حَدَثٌ':Subject, #2: 2	حَلَّ الْجَمِيعُ
u'حَلَّ حَقٌّ':Subject, #1: 1	حَلَّ الْحَدَثُ
u'حَلَّ حَلالٌ':Predicate, #6: 6	حَلَّ الْحَقُّ
u'حَلَّ حَلْقٌ':Subject, #1: 1	أَحَلَّ حَلاَلاً
u'حَلَّ حول':Subject, #1: 1	حَلَّ الْحَلْقُ
u'حَلَّ حَوْلٌ':Subject, #1: 1	حَلَّ الْحَوْلُ
u'حَلَّ حول':Subject, #1: 1	حَلَّ الْحَوْلُ
u'حَلَّ حَوْلٌ':Subject, #3: 3	حَلَّ حَوْلُ
u'حَلَّ حول':Subject, #3: 3	حَلَّ حَوْلُ
u'حَلَّ حَوْلٌ':Subject, #4: 4	حَلَّ حَوْلُهُ
u'حَلَّ خَوْفٌ':Subject, #4: 4	حَلَّ حَوْلُهُ
u'حَلَّ دِرْهَمٌ':Subject, #1: 1	حَلَّ خَوْفُ
u'حَلَّ دِرْهَم':Subject, #1: 1	حَلَّ دِرْهَمٌ
u'حَلَّ دفع':Predicate, #1: 1	حَلَّ دِرْهَمٌ
u'حَلَّ دفع':Subject, #1: 1	حَلَّ دَفَعَ
u'حَلَّ دَفْعٌ':Subject, #2: 2	حَلَّ الدَّفْعُ
u'حَلَّ دَمٌ':Subject, #2: 2	حَلَّ الدَّفْعُ
u'حَلَّ دِماءٌ':Predicate, #10: 10	حَلَّ دَمُهُ
u'حَلَّ دَوَابُّ':Predicate, #1: 1	أَحَلَّ دِمَاءَ
u'حَلَّ دَيْنٌ':Subject, #1: 1	حَلَّ دَوَابَّ
u'حَلَّ دَيْنٌ':Subject, #1: 1	حَلَّ دَيْنٌ
u'حَلَّ دَيْنٌ':Subject, #3: 3	حَلَّ دَيْنُ
u'حَلَّ دَيْنٌ':Subject, #41: 41	حَلَّ الدَّيْنُ
u'حَلَّ ذَبيحٌ':Subject, #6: 6	حَلَّ دَيْنُهُ
u'حَلَّ رَبُّ':Subject, #2: 2	حَلَّ الذَّبِيحُ
u'حَلَّ رباط':Predicate, #1: 1	أَحَلَّ رَبُّ
u'حَلَّ رِبَاطٌ':Predicate, #5: 5	حَلَّ الرِّبَاطَ
u'حَلَّ رباط':Predicate, #5: 5	حَلَّ الرِّبَاطَ
u'حَلَّ رِبَاطٌ':Predicate, #6: 6	حَلَّ رِبَاطَ
u'حَلَّ رِزْقٌ':Subject, #6: 6	حَلَّ رِبَاطَ
u'حَلَّ رَسُولٌ':Subject, #1: 1	حَلَّ رِزْقُهُ
u'حَلَّ رَسُولٌ':Subject, #1: 1	حَلَّ رَسُولُ
u'حَلَّ زادٌ':Predicate, #2: 2	أَحَلَّ رَسُولُ
u'حَلَّ سِجِلٌّ':Predicate, #1: 1	حَلَّ زَادَ
u'حَلَّ سَرْجٌ':Predicate, #1: 1	حَلَّ سِجِلَّ
u'حَلَّ سقط':Predicate, #1: 1	حَلَّ سَرْجَ
u'حَلَّ سَقَطٌ':Predicate, #1: 1	حَلَّ سَقَطَ
u'حَلَّ سِلْسلَةٌ':Predicate, #1: 1	حَلَّ سَقَطَ
u'حَلَّ سَلَفٌ':Predicate, #2: 2	حَلَّ سِلْسِلَةَ
u'حَلَّ سَلَمٌ':Subject, #2: 2	أَحَلَّ السَّلَفَ
u'حَلَّ سَواءٌ':Subject, #3: 3	حَلَّ السَّلَمُ
u'حَلَّ شَارِحٌ':Predicate, #1: 1	حَلَّ سَوَاءٌ
u'حَلَّ شِرَاءٌ':Subject, #1: 1	حَلَّ الشَّارِحِينَ
u'حَلَّ شَرَابٌ':Subject, #1: 1	حَلَّ الشِّرَاءُ
u'حَلَّ شراك':Predicate, #1: 1	حَلَّ الشَّرَابُ
u'حَلَّ شِرَاكٌ':Predicate, #1: 1	حَلَّ شِرَاكَ
u'حَلَّ شرب':Subject, #1: 1	حَلَّ شِرَاكَ
u'حَلَّ شُرْبٌ':Subject, #2: 2	حَلَّ شُرْبُهُ
u'حَلَّ شَيْءٌ':Subject, #2: 2	حَلَّ شُرْبُهُ
u'حَلَّ صِحَّةٌ':Predicate, #2: 2	حَلَّ شَيْءٌ
u'حَلَّ صَيْدٌ':Subject, #1: 1	أَحَلَّ صِحَّةَ
u'حَلَّ صَيْدٌ':Subject, #1: 1	حَلَّ صَيْدُهُ
u'حَلَّ ضَمِنٌ':Predicate, #3: 3	حَلَّ الصَّيْدُ
u'حَلَّ طَالِبٌ':Subject, #4: 4	حَلَّ ضَمِنَ
u'حَلَّ طِلاَءٌ':Predicate, #1: 1	حَلَّ طَالِبُهُ
u'حَلَّ طلب':Subject, #1: 1	أَحَلَّ الطِّلاَءَ
u'حَلَّ طَلَبٌ':Subject, #1: 1	حَلَّ طَلَبُهُ
u'حَلَّ عَبْدٌ':Subject, #1: 1	حَلَّ طَلَبُهُ
u'حَلَّ عَدُوٌّ':Subject, #1: 1	حَلَّ الْعَبْدُ
u'حَلَّ عند':Predicate, #1: 1	حَلَّ الْعَدُوُّ
u'حَلَّفَ اِبْنٌ':Predicate, #3: 3	حَلَّ عِنْدَ
u'حَلَفَ أحَدٌ':Subject, #2: 2	حَلَّفَ ابْنَ
u'حَلَفَ أَخٌ':Subject, #1: 1	حَلَفَ أَحَدُ
u'حَلَفَ أخرَس':Subject, #1: 1	حَلَفَ الْأَخُ
u'حَلَفَ أرْبَابٌ':Subject, #1: 1	حَلَفَ الْأَخْرَسُ
u'حَلَفَ آمِرٌ':Subject, #1: 1	حَلَفَ أَرْبَابُ
u'حَلَفَ أَميرٌ':Subject, #4: 4	حَلَفَ الْآمِرُ
u'حَلَفَ أَوَّلُ':Subject, #2: 2	حَلَفَ الْأَمِيرُ
u'حَلَفَ أَوْلِيَاءُ':Subject, #6: 6	حَلَفَ الْأَوَّلُ
u'حَلَّفَ بَائِعٌ':Subject, #1: 1	حَلَفَ الْأَوْلِيَاءُ
u'حَلَفَ بَائِعٌ':Subject, #1: 1	حَلَّفَ الْبَائِعُ
u'حَلَفَ بَائِعٌ':Subject, #1: 1	حَلَفَ بَائِعُ
u'حَلَفَ بَائِعٌ':Subject, #25: 25	حَلَفَ الْبَائِعُ
u'حَلَفَ بَرٌّ':Predicate, #3: 3	حَلَفَ بَائِعُهُ
u'حَلَفَ بَرِيءٌ':Predicate, #2: 2	حَلَفَ بَرَّ
u'حَلَفَ بَطَلٌ':Predicate, #4: 4	حَلَفَ بَرِيءَ
u'حَلَفَ بَعْضٌ':Subject, #4: 4	حَلَفَ بَطَلَ
u'حَلَفَ بَيْنٌ':Predicate, #2: 2	حَلَفَ بَعْضُ
u'حَلَفَ تَمٌّ':Predicate, #1: 1	حَلَفَ بَيْنَ
u'حَلَفَ جَاحِدٌ':Subject, #1: 1	حَلَفَ تَمَّ
u'حَلَفَ جَازٌ':Predicate, #1: 1	حَلَفَ الْجَاحِدُ
u'حِلْفٌ جَاهِلِيٌّ':Added, #2: 2	حَلَفَ جَازَ
u'حِلْفٌ جَاهِلِيٌّ':Added, #1: 1	حِلْفَ الْجَاهِلِيَّةِ
u'حِلْفٌ جَاهِلِيَّةٌ':Added, #1: 1	حِلْفُ الْجَاهِلِيَّةِ
u'حِلْفٌ جَاهِلِيَّةٌ':Added, #1: 1	حِلْفَ الْجَاهِلِيَّةِ
u'حَلَفَ جَمَاعَةٌ':Subject, #1: 1	حِلْفُ الْجَاهِلِيَّةِ
u'حَلَفَ حالَف':Subject, #1: 1	حَلَفَ جَمَاعَةٌ
u'حَلَفَ حُرٌّ':Subject, #1: 1	حَلَفَ حَالَفٌ
u'حَلَفَ حَكَمٌ':Predicate, #1: 1	حَلَفَ حُرٌّ
u'حَلَفَ خَصْمٌ':Subject, #1: 1	حَلَفَ حَكَمَ
u'حَلَفَ خَصْمٌ':Subject, #1: 1	حَلَفَ الْخَصْمُ
u'حَلَفَ خَوْفٌ':Subject, #2: 2	حَلَفَ خَصْمُهُ
u'حَلَفَ دَائِنٌ':Subject, #1: 1	حَلَفَ خَوْفٌ
u'حَلَفَ دفع':Predicate, #1: 1	حَلَفَ الدَّائِنُ
u'حَلَفَ ذُكورٌ':Subject, #1: 1	حَلَفَ دُفِعَ
u'حَلَفَ ذِمِّيٌّ':Subject, #2: 2	حَلَفَ الذُّكُورُ
u'حَلَفَ ذَهَبٌ':Predicate, #2: 2	حَلَفَ الذِّمِّيُّ
u'حَلَفَ رَاهِنٌ':Subject, #1: 1	حَلَفَ ذَهَبَ
u'حَلَّفَ رَبُّ':Subject, #5: 5	حَلَفَ الرَّاهِنُ
u'حَلَفَ رَبُّ':Subject, #1: 1	حَلَّفَ رَبُّ
u'حَلَفَ رَجُلٌ':Subject, #4: 4	حَلَفَ رَبُّ
u'حَلَفَ رَجُلٌ':Subject, #38: 38	حَلَفَ الرَّجُلُ
u'حَلَفَ رَدٌّ':Predicate, #5: 5	حَلَفَ رَجُلٌ
u'حَلَفَ رَسُولٌ':Subject, #2: 2	حَلَفَ رَدَّ
u'حَلَفَ رَسُولٌ':Subject, #1: 1	حَلَفَ الرَّسُولُ
u'حَلَفَ زَمَنٌ':Predicate, #1: 1	حَلَفَ رَسُولُ
u'حَلَفَ زَوْجٌ':Subject, #1: 1	حَلَفَ زَمَنَ
u'حَلَفَ زَوْجٌ':Subject, #14: 14	حَلَفَ الزَّوْجُ
u'حَلَفَ سقط':Predicate, #1: 1	حَلَفَ زَوْجُ
u'حَلَفَ سَقَطٌ':Predicate, #2: 2	حَلَفَ سَقَطَ
u'حَلَّفَ سُلْطَانٌ':Subject, #2: 2	حَلَفَ سَقَطَ
u'حَلَفَ سَيِّدٌ':Subject, #2: 2	حَلَّفَ السُّلْطَانُ
u'حَلَفَ سَيِّدٌ':Subject, #3: 3	حَلَفَ سَيِّدُهُ
u'حَلَفَ شَاهِدٌ':Subject, #5: 5	حَلَفَ السَّيِّدُ
u'حَلَفَ شَخْصٌ':Subject, #1: 1	حَلَفَ الشَّاهِدُ
u'حَلَفَ شَرِيكٌ':Subject, #2: 2	حَلَفَ شَخْصٌ
u'حَلَفَ شَفِيعٌ':Subject, #2: 2	حَلَفَ الشَّرِيكُ
u'حَلَّفَ صَاحِبٌ':Subject, #2: 2	حَلَفَ الشَّفِيعُ
u'حَلَفَ صَاحِبٌ':Subject, #2: 2	حَلَّفَ صَاحِبُ
u'حَلَفَ صَاحِبٌ':Subject, #3: 3	حَلَفَ صَاحِبُهُ
u'حَلَفَ صَانِعٌ':Subject, #5: 5	حَلَفَ صَاحِبُ
u'حَلَفَ صَائِمٌ':Subject, #1: 1	حَلَفَ صَانِعُ
u'حَلَفَ صَوَابٌ':Subject, #1: 1	حَلَفَ صَائِمٌ
u'حَلَفَ ضَرَبٌ':Predicate, #1: 1	حَلَفَ صَوَابُهُ
u'حَلَّ فَضْلٌ':Subject, #1: 1	حَلَفَ ضَرَبَ
u'حَلَفَ ضَمِنٌ':Predicate, #4: 4	حَلَّ الْفَضْلُ
u'حَلَفَ طَالِبٌ':Subject, #4: 4	حَلَفَ ضَمِنَ
u'حَلَّفَ طَالِبٌ':Subject, #11: 11	حَلَفَ الطَّالِبُ
u'حَلَفَ طَالِبٌ':Subject, #1: 1	حَلَّفَ الطَّالِبُ
u'حَلَّ فِطْرٌ':Subject, #1: 1	حَلَفَ طَالِبُهُ
u'حَلَّ فِطْرٌ':Subject, #1: 1	حَلَّ فِطْرُ
u'حَلَفَ عَاقِلٌ':Subject, #3: 3	حَلَّ الْفِطْرُ
u'حَلَفَ عَبْدٌ':Subject, #1: 1	حَلَفَ الْعَاقِلَةُ
u'حَلَفَ عَبْدٌ':Subject, #2: 2	حَلَفَ عَبْدٌ
u'حَلَفَ عتق':Predicate, #4: 4	حَلَفَ الْعَبْدُ
u'حَلَفَ عَتِيقٌ':Subject, #1: 1	حَلَفَ عَتَقَ
u'حَلَفَ عَدْلٌ':Subject, #1: 1	حَلَفَ الْعَتِيقُ
u'حَلَفَ عَرَبِيٌّ':Subject, #1: 1	حَلَفَ الْعَدْلُ
u'حَلَفَ عَشَاءٌ':Predicate, #1: 1	حَلَفَ الْعَرَبِيُّ
u'حَلَّفَ عُمَرٌ':Subject, #1: 1	حَلَفَ الْعَشَاءَ
u'حَلَفَ عند':Predicate, #1: 1	حَلَّفَ عُمَرُ
u'حَلَفَ غَاصِبٌ':Subject, #4: 4	حَلَفَ عِنْدَ
u'حَلَفَ غَرِيمٌ':Subject, #2: 2	حَلَفَ الْغَاصِبُ
u'حَلَفَ غير':Subject, #3: 3	حَلَفَ غَرِيمُهُ
u'حَلَفَ غَيْرٌ':Subject, #1: 1	حَلَفَ غَيْرُ
u'حَلَفَ فَارِسِيٌّ':Subject, #1: 1	حَلَفَ غَيْرُ
u'حِلْفٌ فُضُولٌ':Added, #1: 1	حَلَفَ فَارِسِيٌّ
u'حِلْفٌ فُضُولٌ':Added, #13: 13	حِلْفَ الْفُضُولِ
u'حِلْفٌ فُضُولٌ':Added, #6: 6	حِلْفِ الْفُضُولِ
u'حَلَفَ قَابِضٌ':Subject, #7: 7	حِلْفُ الْفُضُولِ
u'حَلَفَ قَاتِلٌ':Subject, #1: 1	حَلَفَ الْقَابِضُ
u'حَلَفَ قَاذِفٌ':Subject, #2: 2	حَلَفَ الْقَاتِلُ
u'حَلَفَ قَالٌ':Predicate, #1: 1	حَلَفَ الْقَاذِفُ
u'حِلْفٌ قُرَيْشٌ':Added, #2: 2	حَلَفَ قَالَ
u'حِلْفٌ قُرَيْشٌ':Added, #1: 1	حِلْفَ قُرَيْشٍ
u'حِلْفٌ قَوْمٌ':Added, #1: 1	حِلْفُ قُرَيْشٍ
u'حَلَفَ كَافِرٌ':Subject, #1: 1	حِلْفِ قَوْمٍ
u'حَلَفَ كَفِيلٌ':Subject, #5: 5	حَلَفَ الْكَافِرُ
u'حَلَفَ مَالِكٌ':Predicate, #1: 1	حَلَفَ الْكَفِيلُ
u'حَلَفَ مَالِكٌ':Subject, #1: 1	حَلَفَ الْمَالِكَ
u'حَلَفَ مَأْمُورٌ':Subject, #7: 7	حَلَفَ الْمَالِكُ
u'حَلَفَ مُبْتاع':Subject, #2: 2	حَلَفَ الْمَأْمُورُ
u'حَلَفَ مثل':Subject, #1: 1	حَلَفَ الْمُبْتَاعُ
u'حَلَفَ مِثْلٌ':Subject, #1: 1	حَلَفَ مِثْلُهُ
u'حَلَفَ مَجْنِيٌّ':Subject, #1: 1	حَلَفَ مِثْلُهُ
u'حَلَفَ مُحْتَالٌ':Subject, #2: 2	حَلَفَ الْمَجْنِيُّ
u'حَلَّفَ مُدَّعِي':Predicate, #2: 2	حَلَفَ الْمُحْتَالُ
u'حَلَفَ مَدِينٌ':Subject, #1: 1	حَلَّفَ الْمُدَّعِيَ
u'حَلَّفَ مَدْيُونٌ':Predicate, #1: 1	حَلَفَ الْمَدِينُ
u'حَلَفَ مَدْيُونٌ':Subject, #1: 1	حَلَّفَ الْمَدْيُونَ
u'حَلَفَ مَدْيُونٌ':Subject, #1: 1	حَلَفَ مَدْيُونُهُ
u'حَلَفَ مرٌّ':Predicate, #2: 2	حَلَفَ الْمَدْيُونُ
u'حَلَفَ مُرْتَهِنٌ':Subject, #1: 1	حَلَفَ مَرَّةً
u'حَلَفَ مُسْتَحِقٌّ':Subject, #3: 3	حَلَفَ الْمُرْتَهِنُ
u'حَلَفَ مُسْلِمٌ':Subject, #3: 3	حَلَفَ الْمُسْتَحِقُّ
u'حَلَفَ مُضِيٌّ':Subject, #1: 1	حَلَفَ الْمُسْلِمُ
u'حَلَفَ مَطْلُوبٌ':Subject, #1: 1	حَلَفَ مُضِيُّ
u'حَلَفَ مُفْلِسٌ':Subject, #13: 13	حَلَفَ الْمَطْلُوبُ
u'حَلَفَ مَقْضِيّ':Subject, #2: 2	حَلَفَ الْمُفْلِسُ
u'حَلَفَ مَقْطُوعٌ':Subject, #1: 1	حَلَفَ الْمَقْضِيُّ
u'حَلَفَ مَكْفُولٌ':Subject, #1: 1	حَلَفَ الْمَقْطُوعُ
u'حَلَفَ مَمْلُوكٌ':Subject, #1: 1	حَلَفَ الْمَكْفُولُ
u'حَلَفَ مُنْكِرٌ':Subject, #1: 1	حَلَفَ مَمْلُوكٌ
u'حَلَفَ مُنْكِرٌ':Subject, #1: 1	حَلَفَ مُنْكِرُ
u'حِلْفٌ مَهْدٌ':Added, #7: 7	حَلَفَ الْمُنْكِرُ
u'حَلَفَ مُودِعٌ':Subject, #1: 1	حِلْفُ الْمَهْدِ
u'حَلَفَ مُودَعٌ':Subject, #1: 1	حَلَفَ الْمُودِعُ
u'حَلَفَ مُوَكِّلٌ':Subject, #2: 2	حَلَفَ الْمُودَعُ
u'حَلَفَ مَوْهُوبٌ':Subject, #10: 10	حَلَفَ الْمُوَكِّلُ
u'حَلَفَ نَبِيٌّ':Subject, #1: 1	حَلَفَ الْمَوْهُوبُ
u'حَلَفَ نَصِيبٌ':Subject, #2: 2	حَلَفَ النَّبِيُّ
u'حَلَفَ واحد':Predicate, #1: 1	حَلَفَ نَصِيبُهُ
u'حَلَفَ وَاحِدٌ':Predicate, #4: 4	حَلَفَ وَاحِدَةً
u'حَلَفَ واحد':Subject, #4: 4	حَلَفَ وَاحِدَةً
u'حَلَفَ وَاحِدٌ':Subject, #2: 2	حَلَفَ وَاحِدٌ
u'حَلَفَ وَارِثٌ':Subject, #2: 2	حَلَفَ وَاحِدٌ
u'حَلَفَ وَارِثٌ':Subject, #2: 2	حَلَفَ وَارِثُهُ
u'حَلَفَ وَاطِئٌ':Subject, #6: 6	حَلَفَ الْوَارِثُ
u'حَلَفَ وَرَثَةٌ':Subject, #2: 2	حَلَفَ الْوَاطِئُ
u'حَلَفَ وَرَثَةٌ':Subject, #1: 1	حَلَفَ وَرَثَتُهُ
u'حَلَفَ وَرَثَةٌ':Subject, #2: 2	حَلَفَ الْوَرَثَةُ
u'حَلَفَ وَكِيلٌ':Subject, #2: 2	حَلَفَ وَرَثَةُ
u'حَلَفَ ولد':Subject, #7: 7	حَلَفَ الْوَكِيلُ
u'حَلَفَ وَلَدٌ':Subject, #1: 1	حَلَفَ الْوَلَدُ
u'حَلَفَ وَلِيٌّ':Subject, #1: 1	حَلَفَ الْوَلَدُ
u'حَلَفَ يَمِينٌ':Predicate, #8: 8	حَلَفَ الْوَلِيُّ
u'حَلَفَ يَمِينٌ':Predicate, #1: 1	حَلَفَ الْيَمِينَ
u'حَلَفَ يَمِينٌ':Subject, #3: 3	حَلَفَ يَمِينَ
u'حَلَفَ يَوْمٌ':Predicate, #1: 1	حَلَفَ يَمِينٌ
u'حَلْقٌ إِبْطٌ':Added, #1: 1	حَلَفَ يَوْمَ
u'حَلَقَ أقَلُّ':Predicate, #1: 1	حَلْقُ الْإِبْطِ
u'حَلَقَ أَكْثَرُ':Predicate, #3: 3	حَلَقَ أَقَلَّ
u'حَلْقٌ أَكْثَرُ':Added, #3: 3	حَلَقَ أَكْثَرَ
u'حَلَّ قَالٌ':Predicate, #1: 1	حَلْقِ الْأَكْثَرِ
u'حَلَقَ بَعْضٌ':Predicate, #3: 3	حَلَّ قَالَ
u'حَلَقَ بَعْضٌ':Predicate, #1: 1	حَلَقَ الْبَعْضَ
u'حَلْقٌ بَعْضٌ':Added, #2: 2	حَلَقَ بَعْضَ
u'حَلْقٌ بَعْضٌ':Added, #1: 1	حَلْقُ بَعْضِهِ
u'حَلْقٌ بَعْضٌ':Added, #1: 1	حَلْقِ بَعْضِهِ
u'حَلْقٌ بَعْضٌ':Added, #2: 2	حَلْقُ بَعْضِ
u'حَلْقٌ بَعْضٌ':Added, #2: 2	حَلْقِ بَعْضِ
u'حَلْقٌ بَعْضٌ':Added, #3: 3	حَلْقُ الْبَعْضِ
u'حَلْقٌ بُقَعٌ':Added, #4: 4	حَلْقَ بَعْضِ
u'حَلَّ قتال':Subject, #1: 1	حَلْقُ بُقَعٍ
u'حَلَّ قِتَالٌ':Subject, #1: 1	حَلَّ قِتَالُهُ
u'حَلَّ قتل':Subject, #1: 1	حَلَّ قِتَالُهُ
u'حَلَّ قَتْلٌ':Subject, #5: 5	حَلَّ قَتْلُهُ
u'حَلَقَ ثَلاثُ':Predicate, #5: 5	حَلَّ قَتْلُهُ
u'حَلْقٌ ثَلاثُ':Added, #3: 3	حَلَقَ ثَلَاثَ
u'حَلَقَ ثَلاثَةٌ':Predicate, #1: 1	حَلْقِ الثَّلَاثِ
u'حَلَقَ جَعْدٌ':Predicate, #1: 1	حَلَقَ ثَلَاثَةَ
u'حَلَقَ جَعْدٌ':Subject, #1: 1	حَلَقَ جَعْدَ
u'حَلْقٌ جَمِيع':Added, #1: 1	حَلَقَ جَعْدٌ
u'حَلَقَ حاجٌّ':Subject, #1: 1	حَلْقَ الْجَمِيعِ
u'حَلَقَ حاجِبٌ':Predicate, #2: 2	حَلَقَ الْحَاجُّ
u'حَلْقٌ حاجِبٌ':Added, #1: 1	حَلَقَ الْحَاجِبَ
u'حَلَقَ حَجَّام':Subject, #1: 1	حَلْقِ الْحَاجِبَيْنِ
u'حَلَقَ حَديثٌ':Predicate, #1: 1	حَلَقَ الْحَجَّامُ
u'حَلَقَ حِلٌّ':Subject, #1: 1	حَلَقَ الْحَدِيثَ
u'حَلَقَ حَلاَّقٌ':Subject, #1: 1	حَلَقَ حِلٌّ
u'حَلَقَ حَلالٌ':Subject, #1: 1	حَلَقَ الْحَلاَّقُ
u'حَلَقَ خَارِجٌ':Predicate, #1: 1	حَلَقَ الْحَلَالُ
u'حَلَقَ دونٌ':Predicate, #2: 2	حَلَقَ خَارِجَ
u'حَلَقَ رَأْسٌ':Predicate, #1: 1	حَلَقَ دُونَ
u'حَلَقَ رَأْسٌ':Predicate, #21: 21	حَلَقَ رَأْسَ
u'حَلْقٌ رَأْسٌ':Added, #3: 3	حَلَقَ الرَّأْسَ
u'حَلْقٌ رَأْسٌ':Added, #11: 11	حَلْقِ رَأْسِهِ
u'حَلْقٌ رَأْسٌ':Added, #12: 12	حَلْقُ الرَّأْسِ
u'حَلْقٌ رَأْسٌ':Added, #16: 16	حَلْقِ الرَّأْسِ
u'حَلْقٌ رَأْسٌ':Added, #1: 1	حَلْقَ رَأْسِ
u'حَلْقٌ رَأْسٌ':Added, #1: 1	حَلْقِ رَأْسِ
u'حَلْقٌ رَأْسٌ':Added, #1: 1	حَلْق رَأْسِهِ
u'حَلْقٌ رَأْسٌ':Added, #1: 1	حَلْقَ رَأْسِهِ
u'حَلْقٌ رَأْسٌ':Added, #3: 3	حَلْقُ رَأْسِ
u'حَلْقٌ رَأْسٌ':Added, #6: 6	حَلْقَ الرَّأْسِ
u'حَلَقَ رُبُعٌ':Predicate, #6: 6	حَلْقُ رَأْسِهِ
u'حَلَقَ رُبْعٌ':Predicate, #5: 5	حَلَقَ رُبُعَ
u'حَلْقٌ رُبْعٌ':Added, #8: 8	حَلَقَ رُبْعَ
u'حَلْقٌ رُبُعٌ':Added, #1: 1	حَلْقَ الرُّبْعِ
u'حَلْقٌ رُبْعٌ':Added, #1: 1	حَلْقَ رُبُعِ
u'حَلْقٌ رُبْعٌ':Added, #1: 1	حَلْقَ رُبْعِ
u'حَلْقٌ رُبْعٌ':Added, #1: 1	حَلْقُ رُبْعِ
u'حَلْقٌ رُبْعٌ':Added, #2: 2	حَلْقِ الرُّبْعِ
u'حَلَقَ رِجَالٌ':Subject, #3: 3	حَلْقِ رُبْعِ
u'حَلَقَ رَسُولٌ':Subject, #2: 2	حَلَقَ رِجَالٌ
u'حَلْقٌ رَسُولٌ':Added, #7: 7	حَلَقَ رَسُولُ
u'حَلَقَ رَقَبَةٌ':Predicate, #1: 1	حَلْقُ رَسُولِ
u'حَلْقٌ رُكْنٌ':Added, #5: 5	حَلَقَ الرَّقَبَةَ
u'حَلْقٌ رُكْن':Added, #2: 2	حَلْقِ الرُّكْنِ
u'حَلْقٌ زَيْدٌ':Added, #2: 2	حَلْقِ الرُّكْنِ
u'حَلْقٌ شَاةٌ':Added, #1: 1	حَلْقِ زَيْدٍ
u'حَلْقٌ شَاةٌ':Added, #1: 1	حَلْقَ شَاةٍ
u'حَلَقَ شَارِبٌ':Predicate, #3: 3	حَلْقِ شَاةٍ
u'حَلَقَ شَارِبٌ':Predicate, #1: 1	حَلَقَ الشَّارِبَ
u'حَلْقٌ شَارِبٌ':Added, #2: 2	حَلَقَ شَارِبَ
u'حَلْقٌ شَارِبٌ':Added, #1: 1	حَلْقَ الشَّارِبِ
u'حَلْقٌ شَارِبٌ':Added, #1: 1	حَلْقُ الشَّارِبِ
u'حَلَقَ شَعْرٌ':Predicate, #1: 1	حَلْقِ الشَّارِبِ
u'حَلَقَ شَعْرٌ':Predicate, #5: 5	حَلَقَ الشَّعْرَ
u'حَلْقٌ شَعْرٌ':Added, #9: 9	حَلَقَ شَعْرَ
u'حَلْقٌ شَعْرٌ':Added, #1: 1	حَلْق شَعْرَةٍ
u'حَلْقٌ شَعْرٌ':Added, #1: 1	حَلْقُ شَعْرَةٍ
u'حَلْقٌ شَعَرٌ':Added, #1: 1	حَلْقِ شَعْرَتَيْنِ
u'حَلْقٌ شَعْرٌ':Added, #1: 1	حَلْقُ شَعَرِهِ
u'حَلْقٌ شَعْرٌ':Added, #1: 1	حَلْقُ شَعْرِهِ
u'حَلْقٌ شَعْرٌ':Added, #2: 2	حَلْقَ الشَّعْرِ
u'حَلْقٌ شَعْرٌ':Added, #2: 2	حَلْقَ شَعْرِ
u'حَلْقٌ شَعْرٌ':Added, #2: 2	حَلْقِ شَعْرِهِ
u'حَلْقٌ شَعْرٌ':Added, #4: 4	حَلْقُ شَعْرٍ
u'حَلْقٌ شَعْرٌ':Added, #4: 4	حَلْقِ شَعْرَةٍ
u'حَلْقٌ شَعْرٌ':Added, #5: 5	حَلْقِ الشَّعْرِ
u'حَلْقٌ شَعْرٌ':Added, #6: 6	حَلْقُ الشَّعْرِ
u'حَلْقٌ شَعْرٌ':Added, #8: 8	حَلْقِ شَعْرِ
u'حَلْقٌ شعرة':Added, #9: 9	حَلْقُ شَعْرِ
u'حَلْقٌ شعرة':Added, #1: 1	حَلْق شَعْرَةٍ
u'حَلْقٌ شعرة':Added, #1: 1	حَلْقُ شَعْرَةٍ
u'حَلَقَ شِقٌّ':Predicate, #4: 4	حَلْقِ شَعْرَةٍ
u'حَلْقٌ صَائِمٌ':Added, #1: 1	حَلَقَ الشِّقَّ
u'حَلْقٌ صَائِمٌ':Added, #1: 1	حَلْقَ الصَّائِمِ
u'حَلْقٌ صَبِيٌّ':Added, #2: 2	حَلْقِ الصَّائِمِ
u'حَلْقٌ صَدْرٌ':Added, #3: 3	حَلْقَ الصَّبِيِّ
u'حَلَقَ عَامٌ':Predicate, #1: 1	حَلْقُ الصَّدْرِ
u'حَلَقَ عَانَةٌ':Predicate, #2: 2	حَلَقَ عَامَ
u'حَلْقٌ عَانَةٌ':Added, #1: 1	حَلَقَ عَانَةَ
u'حَلْقٌ عَانَةٌ':Added, #1: 1	حَلْقَ الْعَانَةِ
u'حَلْقٌ عَانَةٌ':Added, #1: 1	حَلْقُ عَانَتِهِ
u'حَلْقٌ عَانَةٌ':Added, #2: 2	حَلْقَ عَانَتِهِ
u'حَلْقٌ عَانَةٌ':Added, #3: 3	حَلْقِ الْعَانَةِ
u'حَلَّقَ علماء':Subject, #8: 8	حَلْقُ الْعَانَةِ
u'حَلَّقَ عُلَمَاءُ':Subject, #1: 1	حَلَّقَ الْعُلَمَاءُ
u'حَلَقَ عُمَرٌ':Subject, #1: 1	حَلَّقَ الْعُلَمَاءُ
u'حَلْقٌ عمرة':Added, #1: 1	حَلَقَ عُمَرُ
u'حَلْقٌ عُمْرَةٌ':Added, #1: 1	حَلْقَ الْعُمْرَةِ
u'حَلَقَ لِحْيَةٌ':Predicate, #1: 1	حَلْقَ الْعُمْرَةِ
u'حَلَقَ لِحْيَةٌ':Predicate, #2: 2	حَلَقَ اللِّحْيَةَ
u'حَلْقٌ لِحْيَةٌ':Added, #4: 4	حَلَقَ لِحْيَةَ
u'حَلْقٌ لِحْيَةٌ':Added, #1: 1	حَلْقُ اللِّحْيَةِ
u'حَلْقٌ لِحْيَةٌ':Added, #1: 1	حَلْقِ لِحْيَةٍ
u'حَلْقٌ لِحْيَةٌ':Added, #1: 1	حَلْقِ لِحْيَةِ
u'حَلْقٌ لِحْيَةٌ':Added, #1: 1	حَلْقِ لِحْيَتِهِ
u'حَلَقَ مُحْرِمٌ':Subject, #2: 2	حَلْقُ لِحْيَتِهِ
u'حَلَقَ مُحْرِمٌ':Subject, #5: 5	حَلَقَ مُحْرِمٌ
u'حَلْقٌ مُسْتَيْقِظ':Added, #9: 9	حَلَقَ الْمُحْرِمُ
u'حَلْقٌ مُقَدَّمٌ':Added, #1: 1	حَلْقِ الْمُسْتَيْقِظِ
u'حَلَقَ مُكْرَهٌ':Subject, #1: 1	حَلْقُ مُقَدَّمِ
u'حَلَقَ مَوَاضِعُ':Predicate, #1: 1	حَلَقَ مُكْرَهٌ
u'حَلَقَ مَوْضِعٌ':Predicate, #1: 1	حَلَقَ مَوَاضِعَ
u'حَلْقٌ نَائِمٌ':Added, #6: 6	حَلَقَ مَوْضِعَ
u'حَلَقَ نَبِيٌّ':Subject, #2: 2	حَلْقِ النَّائِمِ
u'حَلْقٌ نَبِيٌّ':Added, #1: 1	حَلَقَ النَّبِيُّ
u'حَلَقَ نِصْفٌ':Predicate, #2: 2	حَلْقُ النَّبِيِّ
u'حَلْقٌ نِصْفٌ':Added, #4: 4	حَلَقَ نِصْفَ
u'حَلْقٌ وسط':Added, #1: 1	حَلْقِ النِّصْفِ
u'حَلْقٌ وَسَطٌ':Added, #1: 1	حَلْقُ وَسَطِ
u'حَلْقٌ ولد':Added, #1: 1	حَلْقُ وَسَطِ
u'حَلْقٌ وَلَدٌ':Added, #1: 1	حَلْقَ الْوَلَدِ
u'حَلَّ قيام':Subject, #1: 1	حَلْقَ الْوَلَدِ
u'حَلَّ قِيَامٌ':Subject, #1: 1	حَلَّ قِيَامُ
u'حَلَّ قَيْدٌ':Predicate, #1: 1	حَلَّ قِيَامُ
u'حَلَّ قَيْدٌ':Predicate, #10: 10	حَلَّ قَيْدَ
u'حَلَقَ يَوْمٌ':Predicate, #4: 4	حَلَّ الْقَيْدَ
u'حَلَّلَ مَاءٌ':Predicate, #6: 6	حَلَقَ يَوْمَ
u'حَلَّلَ وَرَمٌ':Predicate, #1: 1	حَلَّلَ الْمَاءَ
u'حَلِمَ أَدِيمٌ':Subject, #1: 1	حَلَّلَ وَرَمَ
u'حَلَّ مَالٌ':Subject, #1: 1	حَلِمَ الْأَدِيمُ
u'حَلَّ مَالٌ':Subject, #2: 2	حَلَّ مَالُهُ
u'حِلْمٌ إمَامٌ':Added, #4: 4	حَلَّ الْمَالُ
u'حِلْمٌ أهْلٌ':Added, #1: 1	حِلْمِ إمَامٍ
u'حَلَّ مُتْعَةٌ':Predicate, #2: 2	حِلْمُ أَهْلِهِ
u'حَلَّ مُحَرَّمٌ':Predicate, #1: 1	أَحَلَّ الْمُتْعَةَ
u'حَلَّ مَحَلٌّ':Predicate, #1: 1	أَحَلَّ الْمُحَرَّمَ
u'حَلُمَ رَجُلٌ':Subject, #1: 1	حَلَّ مَحَلَّ
u'حِلْمٌ رَجُلٌ':Added, #1: 1	حَلُمَ الرَّجُلُ
u'حَلَّ مُرْسِلٌ':Subject, #1: 1	حِلْمِ الرَّجُلِ
u'حَلَّ مَسٌّ':Subject, #1: 1	حَلَّ مُرْسِلُهُ
u'حَلَّ مُصَابٌ':Subject, #1: 1	حَلَّ مَسُّهُ
u'حَلَّ مُكَاتَبَةٌ':Subject, #5: 5	حَلَّ الْمُصَابُ
u'حِلْمٌ مُلُوكٌ':Added, #1: 1	حَلَّ مُكَاتَبَةُ
u'حَلَّ مُوَكِّلٌ':Subject, #1: 1	حِلْمُ الْمُلُوكِ
u'حَلَّ مُوَكِّلٌ':Subject, #1: 1	أَحَلَّ الْمُوَكِّلُ
u'حَلَّ مَيْتٌ':Subject, #1: 1	حَلَّ الْمُوَكِّلُ
u'حَلَّ مَيْتَةٌ':Subject, #1: 1	حَلَّ مَيْتَتُهُ
u'حَلَّ نَاسٌ':Subject, #1: 1	حَلَّ مَيْتَتُهُ
u'حَلَّ نَجْمٌ':Subject, #4: 4	حَلَّ النَّاسُ
u'حَلَّ نُجُومٌ':Subject, #12: 12	حَلَّ نَجْمٌ
u'حَلَّ نَظَرٌ':Subject, #1: 1	حَلَّ نُجُومُهُ
u'حَلَّ نفر':Predicate, #1: 1	حَلَّ النَّظَرُ
u'حَلَّ نَفْرٌ':Predicate, #1: 1	أَحَلَّ النَّفْرَ
u'حَلَّ نفر':Predicate, #1: 1	أَحَلَّ النَّفْرَ
u'حَلَّ نَفْرٌ':Predicate, #1: 1	حَلَّ النَّفْرَ
u'حَلَّ نفر':Subject, #1: 1	حَلَّ النَّفْرَ
u'حَلَّ نَفَرٌ':Subject, #1: 1	حَلَّ النَّفَرُ
u'حَلَّ نفر':Subject, #1: 1	حَلَّ النَّفَرُ
u'حَلَّ نَفْرٌ':Subject, #4: 4	حَلَّ النَّفْرُ
u'حَلَّ نَفْيٌ':Subject, #4: 4	حَلَّ النَّفْرُ
u'حَلَّ نكاح':Predicate, #1: 1	حَلَّ نَفْيُهُ
u'حَلَّ نِكَاحٌ':Predicate, #1: 1	أَحَلَّ نِكَاحَ
u'حَلَّ نكاح':Subject, #1: 1	أَحَلَّ نِكَاحَ
u'حَلَّ نِكَاحٌ':Subject, #1: 1	حَلَّ نِكَاحُ
u'حَلَّ وَجَبٌ':Predicate, #1: 1	حَلَّ نِكَاحُ
u'حَلَّ وَطْءٌ':Subject, #1: 1	حَلَّ وَجَبَ
u'حَلَّ وَطْءٌ':Subject, #3: 3	حَلَّ وَطْءُ
u'حُلُوقٌ صِبْيَانٌ':Added, #7: 7	حَلَّ الْوَطْءُ
u'حَلَّ وِكاء':Predicate, #1: 1	حُلُوقِ الصِّبْيَانِ
u'حُلُولٌ آجَالٌ':Added, #3: 3	حَلَّ وِكَاءَ
u'حُلُولٌ أَجَلٌ':Added, #3: 3	حُلُولِ الْآجَالِ
u'حُلُولٌ أَجَلٌ':Added, #1: 1	حُلُولُ أَجَلِ
u'حُلُولٌ أَجَلٌ':Added, #1: 1	حُلُولَ الْأَجَلِ
u'حُلُولٌ أَجَلٌ':Added, #4: 4	حُلُولِ أَجَلِهِ
u'حُلُولٌ أَجَلٌ':Added, #6: 6	حُلُولِ أَجَلِ
u'حُلُولٌ بَعْضٌ':Added, #89: 89	حُلُولِ الْأَجَلِ
u'حُلُولٌ بَعْضٌ':Added, #1: 1	حُلُولَ الْبَعْضِ
u'حُلُولٌ بَعْضٌ':Added, #1: 1	حُلُولُ بَعْضِهِ
u'حُلُولٌ بَعْضٌ':Added, #1: 1	حُلُولِ بَعْضِهِ
u'حُلُولٌ ثَمَنٌ':Added, #2: 2	حُلُولِ الْبَعْضِ
u'حُلُولٌ جَمِيع':Added, #1: 1	حُلُولَ الثَّمَنِ
u'حُلُولٌ حَدَثٌ':Added, #1: 1	حُلُولِ الْجَمِيعِ
u'حُلُولٌ حَدَثٌ':Added, #3: 3	حُلُولَ الْحَدَثِ
u'حُلُولٌ حول':Added, #4: 4	حُلُولِ الْحَدَثِ
u'حُلُولٌ حَوْلٌ':Added, #2: 2	حُلُولِ حَوْلِ
u'حُلُولٌ حول':Added, #2: 2	حُلُولِ حَوْلِ
u'حُلُولٌ حَوْلٌ':Added, #6: 6	حُلُولِ الْحَوْلِ
u'حُلُولٌ دَيْنٌ':Added, #6: 6	حُلُولِ الْحَوْلِ
u'حُلُولٌ دَيْنٌ':Added, #12: 12	حُلُولِ الدَّيْنِ
u'حُلُولٌ دَيْنٌ':Added, #1: 1	حُلُولُ دَيْنِ
u'حُلُولٌ دَيْنٌ':Added, #1: 1	حُلُولُ دَيْنِهِ
u'حُلُولٌ دَيْنٌ':Added, #3: 3	حُلُولَ الدَّيْنِ
u'حُلُولٌ رَأْسٌ':Added, #3: 3	حُلُولِ دَيْنِهِ
u'حُلُولٌ رِزْقٌ':Added, #2: 2	حُلُولِ رَأْسِ
u'حُلُولٌ رَسُولٌ':Added, #1: 1	حُلُولِ رِزْقِهِ
u'حُلُولٌ سَلَمٌ':Added, #1: 1	حُلُولِ رَسُولِ
u'حُلُولٌ شَرْطٌ':Added, #1: 1	حُلُولِ السَّلَمِ
u'حُلُولٌ شمس':Added, #1: 1	حُلُولِ الشَّرْطِ
u'حُلُولٌ شَمْسٌ':Added, #1: 1	حُلُولِ الشَّمْسِ
u'حُلُولٌ صدقة':Added, #1: 1	حُلُولِ الشَّمْسِ
u'حُلُولٌ صَدَقَةٌ':Added, #1: 1	حُلُولِ الصَّدَقَةِ
u'حُلُولٌ عتق':Added, #1: 1	حُلُولِ الصَّدَقَةِ
u'حُلُولٌ عِتْقٌ':Added, #3: 3	حُلُولِ الْعِتْقِ
u'حُلُولٌ عَطَاءٌ':Added, #3: 3	حُلُولِ الْعِتْقِ
u'حُلُولٌ عقاب':Added, #2: 2	حُلُولِ الْعَطَاءِ
u'حُلُولٌ عِقَابٌ':Added, #1: 1	حُلُولِ الْعِقَابِ
u'حُلُولٌ عَقِبٌ':Added, #1: 1	حُلُولِ الْعِقَابِ
u'حُلُولٌ فِرَاشٌ':Added, #1: 1	حُلُولِ الْعَقِبِ
u'حُلُولٌ قِسْطٌ':Added, #2: 2	حُلُولِ الْفِرَاشِ
u'حُلُولٌ كِتَابَةٌ':Added, #1: 1	حُلُولِ الْقِسْطِ
u'حُلُولٌ مَالٌ':Added, #1: 1	حُلُولِ الْكِتَابَةِ
u'حُلُولٌ مَرِيضٌ':Added, #2: 2	حُلُولِ الْمَالِ
u'حُلُولٌ مَهْرٌ':Added, #1: 1	حُلُولِ الْمَرِيضِ
u'حُلُولٌ مُؤَجَّلٌ':Added, #1: 1	حُلُولِ مَهْرٍ
u'حُلُولٌ نَجَاسَةٌ':Added, #2: 2	حُلُولِ الْمُؤَجَّلِ
u'حُلُولٌ نَجْمٌ':Added, #1: 1	حُلُولِ نَجَاسَةِ
u'حُلُولٌ نَجْمٌ':Added, #6: 6	حُلُولِ النَّجْمِ
u'حُلُولٌ وَقْتٌ':Added, #9: 9	حُلُولِ نَجْمٍ
u'حُلُولٌ وَقْتٌ':Added, #1: 1	حُلُولِ وَقْتِ
u'حَلَّ يَدٌ':Predicate, #2: 2	حُلُولِ وَقْتِهِ
u'حَلَّى رَجُلٌ':Subject, #1: 1	حَلَّ الْيَدَ
u'حَلَّى شَاةٌ':Predicate, #1: 1	حَلَّى الرَّجُلُ
u'حَلِيَ عند':Predicate, #1: 1	حَلَّى الشَّاةَ
u'حَلَّى مَسَاجِدُ':Predicate, #1: 1	أَحْلَى عِنْدَ
u'حَلَّ يَمِينٌ':Subject, #1: 1	حَلَّى الْمَسَاجِدَ
u'حَلَّ يَوْمٌ':Predicate, #1: 1	حَلَّ الْيَمِينُ
u'حِمَايَةٌ أَطْرافٌ':Added, #1: 1	حَلَّ يَوْمَ
u'حِمَايَةٌ أَطْرَافٌ':Added, #1: 1	حِمَايَةِ أَطْرَافِ
u'حِمَايَةٌ إمَامٌ':Added, #1: 1	حِمَايَةِ أَطْرَافِ
u'حِمَايَةٌ بَيْتٌ':Added, #6: 6	حِمَايَةِ الْإِمَامِ
u'حِمَايَةٌ بَيْضَةٌ':Added, #1: 1	حِمَايَةَ الْبَيْتِ
u'حِمَايَةٌ بَيْضَةٌ':Added, #2: 2	حِمَايَةُ الْبَيْضَةِ
u'حِمَايَةٌ حُرْمَةٌ':Added, #5: 5	حِمَايَةِ الْبَيْضَةِ
u'حِمَايَةٌ خِنْزِيرٌ':Added, #1: 1	حِمَايَةِ حُرْمَةِ
u'حِمَايَةٌ دَبْرٌ':Added, #2: 2	حِمَايَةِ خِنْزِيرِ
u'حِمَايَةٌ دِبْرٌ':Added, #1: 1	حِمَايَةُ الدّبْرِ
u'حِمَايَةٌ دِماءٌ':Added, #1: 1	حِمَايَةُ الدّبْرِ
u'حِمَايَةٌ دِينٌ':Added, #1: 1	حِمَايَةُ الدِّمَاءِ
u'حِمَايَةٌ ذَرائِعُ':Added, #1: 1	حِمَايَةُ الدِّينِ
u'حِمَايَةٌ رَسُولٌ':Added, #1: 1	حِمَايَةِ الذَّرَائِعِ
u'حِمَايَةٌ شَخْصٌ':Added, #1: 1	حِمَايَةِ رَسُولِ
u'حِمَايَةٌ طهر':Added, #1: 1	حِمَايَةِ شَخْصٍ
u'حِمَايَةٌ طُهْرٌ':Added, #1: 1	حِمَايَةَ طُهْرِ
u'حِمَايَةٌ عِرْضٌ':Added, #1: 1	حِمَايَةَ طُهْرِ
u'حِمَايَةٌ قلب':Added, #1: 1	حِمَايَةَ عِرْضِ
u'حِمَايَةٌ قَلْبٌ':Added, #1: 1	حِمَايَةُ قَلْبِهِ
u'حِمَايَةٌ قَلْب':Added, #1: 1	حِمَايَةُ قَلْبِهِ
u'حَمِدَ رَبُّ':Subject, #1: 1	حِمَايَةُ قَلْبِهِ
u'حَمْدٌ غير':Added, #1: 1	حَمِدَ رَبّهُ
u'حَمْدٌ غير':Added, #1: 1	حَمْدَ غَيْرِهِ
u'حَمْدٌ غَيْرٌ':Added, #1: 1	حَمْدِ غَيْرِهِ
u'حَمْدٌ غَيْرٌ':Added, #1: 1	حَمْدَ غَيْرِهِ
u'حَمْدٌ فلان':Added, #1: 1	حَمْدِ غَيْرِهِ
u'حَمْدٌ مُعْتَرِفٌ':Added, #1: 1	حَمْدِ الْحَامِدِ
u'حَمْدٌ نَاسٌ':Added, #1: 1	حَمْدَ مُعْتَرِفٍ
u'حَمْدٌ نَاسٌ':Added, #1: 1	حَمْدُ النَّاسِ
u'حَمَّرَ وَجْنَةٌ':Predicate, #1: 1	حَمْدِ النّاسِ
u'حَمُقَ رَجُلٌ':Subject, #1: 1	حَمَّرَ وَجْنَةَ
u'حَمَلَ اِبْنٌ':Predicate, #1: 1	حَمُقَ الرَّجُلُ
u'حَمَلَ اِبْنٌ':Subject, #4: 4	حَمَلَ ابْنَ
u'حَمَلَ أَجِيرٌ':Subject, #9: 9	حَمَلَ ابْنُ
u'حَمَلَ أَحادِيثُ':Predicate, #1: 1	حَمَلَ الْأَجِيرُ
u'حَمَلَ أحَدٌ':Predicate, #1: 1	حَمَلَ أَحَادِيثَ
u'حَمَلَ أخْبَارٌ':Predicate, #1: 1	حَمَلَ أَحَدَ
u'حَمَلَ أَخْبَارٌ':Predicate, #1: 1	حَمَلَ أَخْبَارَ
u'حَمَلَ أُسْتَاذٌ':Subject, #1: 1	حَمَلَ أَخْبَارَ
u'حَمَّلَ أَسَدٌ':Predicate, #1: 1	حَمَلَ الأُسْتَاذُ
u'حَمَلَ أَصْحَابٌ':Subject, #1: 1	حَمَّلَ الْأَسَدَ
u'حَمَلَ أَصْحَابٌ':Subject, #1: 1	حَمَلَ أَصْحَابُ
u'حَمَلَ إِطْلاقٌ':Predicate, #2: 2	حَمَلَ الْأَصْحَابُ
u'حَمَلَ أَكْثَرُ':Predicate, #2: 2	حَمَلَ إطْلَاقَ
u'حَمَلَ أَكْسِيَةٌ':Predicate, #1: 1	حَمَلَ أَكْثَرَ
u'حَمَلَ آلةٌ':Predicate, #1: 1	حَمَلَ الْأَكْسِيَةَ
u'حَمَلَ أَمْرٌ':Predicate, #1: 1	حَمَلَ الْآلَةَ
u'حَمَلَ أَميرٌ':Subject, #4: 4	حَمَلَ الْأَمْرَ
u'حَمَلَ أهْلٌ':Subject, #1: 1	حَمَلَ الْأَمِيرُ
u'حَمَلَ آيَةٌ':Predicate, #3: 3	حَمَلَ أَهْلُ
u'حَمَلَ آيَةٌ':Predicate, #1: 1	حَمَلَ الآيَةَ
u'حَمَلَ آيَةٌ':Predicate, #1: 1	حَمَلَ آيَةَ
u'حَمَلَ بَعْضٌ':Predicate, #3: 3	حَمَلَ الْآيَةَ
u'حَمَلَ بَعْضٌ':Subject, #1: 1	حَمَلَ الْبَعْضَ
u'حَمَلَ بَعْضٌ':Subject, #2: 2	حَمَلَ بَعْضُهُ
u'حَمْلَةٌ تابُوت':Added, #7: 7	حَمَلَ بَعْضُ
u'حَمَلَ تابُوت':Predicate, #2: 2	حَمْلَةِ التَّابُوتِ
u'حَمَلَ ثَوْبٌ':Predicate, #1: 1	حَمَلَ تَابُوتَ
u'حَمَلَ جَمَاعَةٌ':Subject, #1: 1	حَمَلَ ثَوْبَ
u'حَمَلَ جُمْهُورٌ':Subject, #1: 1	حَمَلَ جَمَاعَةٌ
u'حَمَلَ جُمْهُورٌ':Subject, #1: 1	حَمَلَ الْجُمْهُورُ
u'حَمَلَ جَنَازَةٌ':Predicate, #1: 1	حَمَلَ جُمْهُورُ
u'حَمَلَ جهر':Predicate, #2: 2	حَمَلَ الْجَنَازَةَ
u'حَمَلَ جَهْرٌ':Predicate, #1: 1	حَمَلَ الْجَهْرَ
u'حَمَلَ جَوَانِبُ':Predicate, #1: 1	حَمَلَ الْجَهْرَ
u'حَمَلَ حادِي':Predicate, #1: 1	حَمَلَ جَوَانِبَ
u'حَمَلَ حاكِمٌ':Predicate, #1: 1	حَمَلَ الْحَادِيَ
u'حَمَلَ حالَةٌ':Predicate, #1: 1	حَمَلَ الْحَاكِمَ
u'حَمَلَ حامِلٌ':Subject, #1: 1	حَمَلَ حَالَةَ
u'حَمَلَ حَديثٌ':Predicate, #1: 1	حَمَلَ حَامِلٌ
u'حَمَلَ حَديثٌ':Predicate, #4: 4	حَمَلَ الْحَدِيثَ
u'حَمَلَ حَديدٌ':Predicate, #4: 4	حَمَلَ حَدِيثَ
u'حَمَلَ حُرٌّ':Subject, #2: 2	حَمَلَ الْحَدِيدَ
u'حَمَلَ خَبَرٌ':Predicate, #1: 1	حَمَلَ الْحُرُّ
u'حَمَلَ خَبَر':Predicate, #1: 1	حَمَلَ الْخَبَرَ
u'حَمَلَ خِلاَفٌ':Predicate, #1: 1	حَمَلَ الْخَبَرَ
u'حَمَّلَ دَابَّةٌ':Predicate, #1: 1	حَمَلَ الْخِلَافَ
u'حَمَلَ رَأْسٌ':Predicate, #1: 1	حَمَّلَ الدَّابَّةَ
u'حَمَلَ رَبُّ':Subject, #1: 1	حَمَلَ رَأْسَ
u'حَمَلَ رَجُلٌ':Predicate, #1: 1	حَمَلَ رَبُّ
u'حَمَلَ رَجُلٌ':Subject, #1: 1	حَمَلَ الرَّجُلَ
u'حَمَلَ رَسُولٌ':Predicate, #3: 3	حَمَلَ رَجُلٌ
u'حَمَلَ رَسُولٌ':Subject, #1: 1	حَمَلَ رَسُولَ
u'حَمَلَ رَمْلِيٌّ':Subject, #2: 2	حَمَلَ رَسُولُ
u'حَمَلَ رِوايَةٌ':Predicate, #1: 1	حَمَلَ الرَّمْلِيُّ
u'حَمَّلَ زِيادَةٌ':Predicate, #9: 9	حَمَلَ رِوَايَةَ
u'حَمَلَ سِلاَحٌ':Predicate, #2: 2	حَمَّلَ الزِّيَادَةَ
u'حَمَلَ سُلْطَانٌ':Subject, #1: 1	حَمَلَ السِّلاَحَ
u'حَمَلَ سَهْوٌ':Predicate, #3: 3	حَمَلَ السُّلْطَانُ
u'حَمَلَ سِواكٌ':Predicate, #1: 1	حَمَلَ السَّهْوَ
u'حَمَلَ سَيْفٌ':Predicate, #1: 1	حَمَلَ السِّوَاكَ
u'حَمَلَ سَيْل':Subject, #1: 1	حَمَلَ السّيْفَ
u'حَمَلَ سَيْل':Subject, #1: 1	حَمَلَ سَيْلٌ
u'حَمَلَ شَارِعٌ':Subject, #8: 8	حَمَلَ السَّيْلُ
u'حَمَلَ شافِعِيّ':Subject, #1: 1	حَمَلَ الشَّارِعُ
u'حَمَلَ شَهَادَةٌ':Predicate, #5: 5	حَمَلَ الشَّافِعِيُّ
u'حَمَلَ شَيْخٌ':Subject, #1: 1	حَمَلَ الشَّهَادَةَ
u'حَمَلَ شُيُوخٌ':Subject, #2: 2	حَمَلَ الشَّيْخُ
u'حَمَلَ صَاحِبٌ':Predicate, #1: 1	حَمَلَ الشُّيُوخُ
u'حَمَلَ صَاحِبٌ':Subject, #1: 1	حَمَلَ صَاحِبَ
u'حَمَلَ صِحَّةٌ':Predicate, #6: 6	حَمَلَ صَاحِبُ
u'حَمَلَ طَائِفٌ':Subject, #3: 3	حَمَلَ الصِّحَّةَ
u'حَمَلَ طعام':Predicate, #1: 1	حَمَلَ طَائِفَةٌ
u'حَمَلَ طَعَامٌ':Predicate, #1: 1	حَمَلَ الطَّعَامَ
u'حَمَلَ عَاقِلٌ':Predicate, #1: 1	حَمَلَ الطَّعَامَ
u'حَمَّلَ عَاقِلٌ':Predicate, #1: 1	حَمَلَ الْعَاقِلَةَ
u'حَمَلَ عِبَارَةٌ':Predicate, #1: 1	حَمَّلَ الْعَاقِلَةَ
u'حَمَلَ عِبَارَةٌ':Predicate, #1: 1	حَمَلَ عِبَارَةَ
u'حَمَلَ عَبْدٌ':Predicate, #2: 2	حَمَلَ الْعِبَارَةَ
u'حَمَلَ عَدُوٌّ':Subject, #1: 1	حَمَلَ الْعَبْدَ
u'حَمَلَ علم':Predicate, #1: 1	حَمَلَ الْعَدُوُّ
u'حَمَلَ عِلْمٌ':Predicate, #1: 1	حَمَلَ الْعِلْمَ
u'حَمَلَ علماء':Subject, #1: 1	حَمَلَ الْعِلْمَ
u'حَمَلَ عُلَمَاءُ':Subject, #4: 4	حَمَلَ الْعُلَمَاءُ
u'حَمَلَ عُمَرٌ':Predicate, #4: 4	حَمَلَ الْعُلَمَاءُ
u'حَمَلَ عُمَرٌ':Subject, #1: 1	حَمَلَ عُمَرَ
u'حَمَلَ عُودٌ':Predicate, #2: 2	حَمَلَ عُمَرُ
u'حَمَلَ غَاصِبٌ':Subject, #1: 1	حَمَلَ الْعُودَ
u'حَمَلَ غَرْسٌ':Predicate, #1: 1	حَمَلَ غَاصِبٌ
u'حَمَلَ فَاطِمٌ':Predicate, #1: 1	حَمَلَ غَرْسَ
u'حَمَلَ فَحْلٌ':Subject, #1: 1	حَمَلَ فَاطِمَةَ
u'حَمَلَ فرق':Predicate, #1: 1	حَمَلَ الْفَحْلُ
u'حَمَلَ فَرْقٌ':Predicate, #1: 1	حَمَلَ الْفَرْقَ
u'حَمَلَ فِضَّةٌ':Predicate, #1: 1	حَمَلَ الْفَرْقَ
u'حَمَلَ فِعْلٌ':Predicate, #1: 1	حَمَلَ الْفِضَّةَ
u'حَمَلَ فلان':Predicate, #1: 1	حَمَلَ فِعْلَ
u'حَمَلَ فُلاَنٌ':Subject, #3: 3	حَمَلَ الْمَرْوِيَّ
u'حَمَلَ فلان':Subject, #2: 2	حَمَلَ فُلَانٌ
u'حَمَلَ قَائِلٌ':Predicate, #5: 5	حَمَلَ الشَّافِعِيُّ
u'حَمَلَ قُرْآنٌ':Predicate, #1: 1	حَمَلَ الْقَائِلِينَ
u'حَمَلَ قَسْمٌ':Predicate, #1: 1	حَمَلَ الْقُرْآنَ
u'حَمَلَ قَسْمٌ':Subject, #1: 1	حَمَلَ الْقَسْمَ
u'حَمَلَ قول':Predicate, #2: 2	حَمَلَ الْقَسْمُ
u'حَمَلَ قَوْلٌ':Predicate, #2: 2	حَمَلَ قَوْلَ
u'حَمَلَ كِتَابٌ':Predicate, #2: 2	حَمَلَ قَوْلَ
u'حَمَلَ كَرَاهَةٌ':Predicate, #1: 1	حَمَلَ الْكِتَابَ
u'حَمَلَ كَعْبٌ':Predicate, #3: 3	حَمَلَ الْكَرَاهَةَ
u'حَمَلَ كُفَّارٌ':Predicate, #1: 1	حَمَلَ الْكَعْبَ
u'حَمَلَ كَلاَمٌ':Predicate, #1: 1	حَمَلَ الْكُفَّارَ
u'حَمَلَ كُوزٌ':Predicate, #11: 11	حَمَلَ كَلَامَ
u'حَمَلَ كِيسٌ':Predicate, #1: 1	حَمَلَ كُوزَ
u'حَمَلَ لَحْمٌ':Predicate, #1: 1	حَمَلَ الْكِيسَ
u'حَمَلَ لَفْظٌ':Predicate, #1: 1	حَمَلَ اللَّحْمَ
u'حَمَلَ لَفْظٌ':Predicate, #1: 1	حَمَلَ لَفْظَ
u'حَمَلَ مَاءٌ':Predicate, #2: 2	حَمَلَ اللَّفْظَ
u'حَمَلَ مَالِكٌ':Subject, #1: 1	حَمَلَ الْمَاءَ
u'حَمَلَ مَالِكٌ':Subject, #1: 1	حَمَلَ الْمَالِكُ
u'حَمَلَ مثل':Predicate, #1: 1	حَمَلَ مَالِكٌ
u'حَمَلَ مِثْلٌ':Predicate, #2: 2	حَمَلَ مِثْلَ
u'حَمَلَ مُحْدِثٌ':Subject, #2: 2	حَمَلَ مِثْلَ
u'حَمَلَ مُحْرِمٌ':Subject, #1: 1	حَمَلَ الْمُحْدِثُ
u'حَمَلَ مُحْرِمٌ':Subject, #1: 1	حَمَلَ مُحْرِمٌ
u'حَمَلَ مَذْكُورٌ':Predicate, #2: 2	حَمَلَ الْمُحْرِمُ
u'حَمَلَ مَرْحَبٌ':Subject, #3: 3	حَمَلَ الْمَذْكُورَ
u'حَمَلَ مَرْدُودٌ':Predicate, #1: 1	حَمَلَ مَرْحَبٌ
u'حَمَلَ مَرْوِيّ':Predicate, #1: 1	حَمَلَ الْمَرْدُودَ
u'حَمَلَ مَسْأَلَةٌ':Predicate, #3: 3	حَمَلَ الْمَرْوِيَّ
u'حَمَلَ مَسْأَلَةٌ':Predicate, #1: 1	حَمَلَ الْمَسْأَلَةَ
u'حَمَلَ مُسْتَأْجِرٌ':Subject, #1: 1	حَمَلَ مَسْأَلَةَ
u'حَمَّلَ مُسْتَأْجِرٌ':Subject, #1: 1	حَمَلَ الْمُسْتَأْجِرُ
u'حَمَلَ مُسْتَعِيرٌ':Subject, #1: 1	حَمَّلَ الْمُسْتَأْجِرُ
u'حَمَلَ مِسْكٌ':Predicate, #1: 1	حَمَلَ الْمُسْتَعِيرُ
u'حَمَلَ مُسْلِمٌ':Subject, #2: 2	حَمَلَ الْمِسْكَ
u'حَمَلَ مَصٌّ':Predicate, #1: 1	حَمَلَ مُسْلِمٌ
u'حَمَلَ مُصْحَفٌ':Predicate, #1: 1	حَمَلَ الْمَصَّ
u'حَمَلَ مُصَنِّفٌ':Predicate, #2: 2	حَمَلَ الْمُصْحَفَ
u'حَمَلَ مُصَنِّفٌ':Subject, #1: 1	حَمَلَ الْمُصَنِّفَ
u'حَمَلَ مُعْتَزِلٌ':Predicate, #1: 1	حَمَلَ الْمُصَنِّفُ
u'حَمَلَ مُعْتَزِلَةٌ':Predicate, #1: 1	حَمَلَ الْمُعْتَزِلَةَ
u'حَمَلَ مَغْصُوب':Predicate, #1: 1	حَمَلَ الْمُعْتَزِلَةَ
u'حَمَلَ مَغْصُوب':Subject, #1: 1	حَمَلَ الْمَغْصُوبَ
u'حَمَلَ مَكْفُولٌ':Predicate, #1: 1	حَمَلَ الْمَغْصُوبُ
u'حَمَلَ مُلاَمَسَةٌ':Predicate, #1: 1	حَمَلَ الْمَكْفُولَ
u'حَمَلَ نَاسٌ':Predicate, #1: 1	حَمَلَ الْمُلَامَسَةَ
u'حَمَلَ نَاسٌ':Subject, #1: 1	حَمَلَ النَّاسَ
u'حَمَلَ نَبِيٌّ':Predicate, #3: 3	حَمَلَ النَّاسُ
u'حَمَلَ نَحْوٌ':Predicate, #1: 1	حَمَلَ النَّبِيَّ
u'حَمَلَ نَسَبٌ':Predicate, #1: 1	حَمَلَ نَحْوَ
u'حَمَلَ نَسِيمٌ':Subject, #1: 1	حَمَلَ النَّسَبَ
u'حَمَلَ نَصٌّ':Predicate, #1: 1	حَمَلَ النَّسِيمُ
u'حَمَلَ نُقُولٌ':Predicate, #3: 3	حَمَلَ النَّصَّ
u'حَمَلَ نَهْيٌ':Predicate, #1: 1	حَمَلَ نُقُولَ
u'حَمَلَ نَوَوِيٌّ':Predicate, #3: 3	حَمَلَ النَّهْيَ
u'حَمَلَ هَدْيٌ':Predicate, #1: 1	حَمَلَ النَّوَوِيَّ
u'حَمَلَ وَصِيٌّ':Predicate, #1: 1	حَمَلَ الْهَدْيَ
u'حَمَلَ وَصِيَّةٌ':Predicate, #1: 1	حَمَلَ الْوَصِيَّةَ
u'حَمَلَ وُضُوءٌ':Predicate, #1: 1	حَمَلَ الْوَصِيَّةَ
u'حُمُوضَةٌ بِطِّيخٌ':Added, #1: 1	حَمَلَ الْوُضُوءَ
u'حَمَى إمَامٌ':Subject, #1: 1	حُمُوضَةُ الْبِطِّيخِ
u'حَمِيَ بَأسٌ':Subject, #1: 1	حَمَى الْإِمَامُ
u'حَمِيَ تَنُّورٌ':Subject, #2: 2	حَمِيَ الْبَأْسُ
u'حَمَى حَوْمَةٌ':Predicate, #1: 1	حَمِيَ التَّنُّورُ
u'حَمَى رَسُولٌ':Subject, #1: 1	حَمَى حَوْمَةَ
u'حَمَى سَرَف':Predicate, #2: 2	حَمَى رَسُولُ
u'حَمَى شرف':Predicate, #1: 1	حَمَى السَّرَفَ
u'حَمَى شَرَفٌ':Predicate, #2: 2	حَمَى الشَّرَفَ
u'حَمِيَ ظَهْرٌ':Subject, #2: 2	حَمَى الشَّرَفَ
u'حَمَى غَرَزٌ':Predicate, #1: 1	حَمِيَ ظَهْرُهُ
u'حَمَى نَقِيعٌ':Predicate, #1: 1	حَمَى غَرَزَ
u'حَمَى وَطِيسٌ':Subject, #15: 15	حَمَى النَّقِيعَ
u'حَمِيَ وَطِيسٌ':Subject, #1: 1	حَمَى الْوَطِيسُ
u'حَنَانٌ دَفْعٌ':Added, #4: 4	حَمِيَ الْوَطِيسُ
u'حَنْبَلَ رحمة':Subject, #1: 1	حَنَانَ دَفْعٍ
u'حَنْبَلَ رَحْمَةٌ':Subject, #1: 1	حَنْبَلَ رَحْمَةُ
u'حَنِثَ أَوَّلُ':Subject, #1: 1	حَنْبَلَ رَحْمَةُ
u'حَنِثَ بَائِعٌ':Subject, #2: 2	حَنِثَ الْأَوَّلُ
u'حِنْثٌ جَاهِلٌ':Added, #1: 1	حَنِثَ الْبَائِعُ
u'حَنِثَ حالٌ':Predicate, #2: 2	حِنْثِ الْجَاهِلِ
u'حَنِثَ رَجُلٌ':Subject, #1: 1	حَنِثَ حَالَ
u'حَنِثَ رَجُلٌ':Subject, #2: 2	حَنِثَ الرَّجُلُ
u'حَنِثَ زَوْجٌ':Subject, #2: 2	حَنِثَ رَجُلٌ
u'حَنِثَ سَاعَةٌ':Predicate, #2: 2	حَنِثَ الزَّوْجُ
u'حَنِثَ سقط':Predicate, #1: 1	حَنِثَ سَاعَةَ
u'حَنِثَ سَقَطٌ':Predicate, #1: 1	حَنِثَ سَقَطَ
u'حَنِثَ سَواءٌ':Subject, #1: 1	حَنِثَ سَقَطَ
u'حَنِثَ صَاحِبٌ':Subject, #8: 8	حَنِثَ سَوَاءٌ
u'حَنِثَ صَاحِبٌ':Subject, #1: 1	حَنِثَ صَاحِبُ
u'حِنْثٌ صَاحِبٌ':Added, #1: 1	حَنِثَ صَاحِبُهُ
u'حَنِثَ صدق':Predicate, #1: 1	حِنْثِ صَاحِبِهِ
u'حَنِثَ صَوَابٌ':Subject, #1: 1	حَنِثَ صَدَقَ
u'حَنِثَ عَبْدٌ':Subject, #1: 1	حَنِثَ صَوَابُهُ
u'حَنِثَ عَقِبٌ':Predicate, #2: 2	حَنِثَ عَبْدٌ
u'حَنِثَ عَقِيبٌ':Predicate, #1: 1	حَنِثَ عَقِبَ
u'حَنِثَ علم':Predicate, #1: 1	حَنِثَ عَقِيبَ
u'حَنِثَ عند':Predicate, #3: 3	حَنِثَ عَلِمَ
u'حَنِثَ فَاعِلٌ':Subject, #14: 14	حَنِثَ عِنْدَ
u'حَنِثَ قَالٌ':Predicate, #1: 1	حَنِثَ فَاعِلُهُ
u'حَنَّثَ قَائِلٌ':Predicate, #11: 11	حَنِثَ قَالَ
u'حَنِثَ قول':Subject, #1: 1	حَنَّثَ الْقَائِلَ
u'حَنِثَ قَوْلٌ':Subject, #1: 1	حَنِثَ قَوْلُهُ
u'حَنِثَ كَفَّارٌ':Subject, #1: 1	حَنِثَ قَوْلُهُ
u'حَنِثَ كَفَّارَةٌ':Subject, #2: 2	حَنِثَ كَفَّارَةُ
u'حَنِثَ مرٌّ':Predicate, #2: 2	حَنِثَ كَفَّارَةُ
u'حِنْثٌ مُضِيفٌ':Added, #3: 3	حَنِثَ مَرَّةً
u'حِنْثٌ مَطْلُوبٌ':Added, #1: 1	حِنْثِ الْمُضِيفِ
u'حَنِثَ مُعْسِرٌ':Subject, #1: 1	حِنْثَ الْمَطْلُوبِ
u'حِنْثٌ مُكْرَهٌ':Added, #1: 1	حَنِثَ مُعْسِرٌ
u'حِنْثٌ مُكْرَهٌ':Added, #1: 1	حِنْثُ الْمُكْرَهِ
u'حِنْثٌ مُوَكِّلٌ':Added, #3: 3	حِنْثِ الْمُكْرَهِ
u'حَنِثَ نَصٌّ':Predicate, #1: 1	حِنْثُ الْمُوَكِّلِ
u'حِنْثٌ وُقُوعٌ':Added, #2: 2	حَنِثَ نَصَّ
u'حِنْثٌ وَكِيلٌ':Added, #1: 1	حِنْثَ وُقُوعِ
u'حَنِثَ وَلَهٌ':Subject, #1: 1	حِنْثُ الْوَكِيلِ
u'حِنْثٌ يَمِينٌ':Added, #1: 1	حَنِثَ وَلَهُ
u'حِنْثٌ يَمِينٌ':Added, #1: 1	حِنْثِ الْيَمِينِ
u'حَنَّ جِذْعٌ':Subject, #2: 2	حِنْثُ الْيَمِينِ
u'حَنَّطَ سَعِيدٌ':Predicate, #3: 3	حَنَّ الْجِذْعُ
u'حَوْزٌ أَبٌ':Added, #1: 1	حَنَّطَ سَعِيدَ
u'حَوْزٌ أَحْباسٌ':Added, #1: 1	حَوْزُ الْأَبِ
u'حَوْزٌ أَزْواجٌ':Added, #1: 1	حَوْزَ الْأَحْبَاسِ
u'حَوْزٌ أُصولٌ':Added, #1: 1	حَوْزَ الْأَزْوَاجِ
u'حَوْزٌ تَرِكَةٌ':Added, #1: 1	حَوْزُ الْأُصُولِ
u'حَوْزٌ حَبْسٌ':Added, #2: 2	حَوْزُ تَرِكَتِهِ
u'حَوْزٌ سَفِيهٌ':Added, #1: 1	حَوْزُ الْحَبْسِ
u'حَوْزٌ عَبْدٌ':Added, #1: 1	حَوْزُ السَّفِيهِ
u'حَوْزٌ عَشْرٌ':Added, #1: 1	حَوْزَ الْعَبْدِ
u'حَوْزٌ غَاصِبٌ':Added, #1: 1	حَوْزُ عَشْرِ
u'حَوْزٌ غَنِيمَةٌ':Added, #1: 1	حَوْزِ الْغَاصِبِ
u'حَوْزٌ غير':Added, #1: 1	حَوْزِ الْغَنِيمَةِ
u'حَوْزٌ غَيْرٌ':Added, #1: 1	حَوْزِ غَيْرِهِ
u'حَوْزٌ مُرْتَهِنٌ':Added, #1: 1	حَوْزِ غَيْرِهِ
u'حَوْزٌ مُسْتَأْجِرٌ':Added, #1: 1	حَوْزِ الْمُرْتَهِنِ
u'حَوْزٌ مُسْتَوْدَعٌ':Added, #1: 1	حَوْزُ الْمُسْتَأْجِرِ
u'حَوْزٌ مَقْبُولٌ':Added, #1: 1	حَوْزِ الْمُسْتَوْدَعِ
u'حَوْزٌ مُودَعٌ':Added, #1: 1	حَوْزٍ مَقْبُولٍ
u'حَوْزٌ مَوْهُوبٌ':Added, #1: 1	حَوْزِ الْمُودَعِ
u'حَوْزٌ نَصِيبٌ':Added, #1: 1	حَوْزِ الْمَوْهُوبِ
u'حَوْزٌ واحد':Added, #1: 1	حَوْزِ نَصِيبِهِ
u'حَوْزٌ وَاحِدٌ':Added, #2: 2	حَوْزِ وَاحِدٍ
u'حَوْزٌ وَلِيٌّ':Added, #2: 2	حَوْزِ وَاحِدٍ
u'حَوْشٌ شَرِيكٌ':Added, #1: 1	حَوْزُ وَلِيِّ
u'حَوْشٌ نَاسٌ':Added, #1: 1	حَوْشِ شَرِيكِ
u'حَوَّطَ بُقْعَةٌ':Predicate, #1: 1	حَوْشِ النَّاسِ
u'حَوَّطَ رَمْلِيٌّ':Subject, #2: 2	حَوَّطَ الْبُقْعَةَ
u'حول أَبٌ':Added, #1: 1	حَوَّطَ رَمْلِيٌّ
u'حَوْلٌ أَبٌ':Added, #2: 2	حَوْلِ الْأَبِ
u'حول أرْضٌ':Added, #2: 2	حَوْلِ الْأَبِ
u'حَوْلٌ أرْضٌ':Added, #1: 1	حَوْلَ الْأَرْضِ
u'حول أرْضٌ':Added, #1: 1	حَوْلَ الْأَرْضِ
u'حَوْلٌ أرْضٌ':Added, #2: 2	حَوْلَ أَرْضِهِ
u'حول اِسْمٌ':Added, #2: 2	حَوْلَ أَرْضِهِ
u'حَوْلٌ اِسْمٌ':Added, #1: 1	حَوْلَ اسْمِ
u'حول أَسْماءٌ':Added, #1: 1	حَوْلَ اسْمِ
u'حَوْلٌ أَسْماءٌ':Added, #1: 1	حَوْلَ أَسْمَاءِ
u'حول أسْنَانٌ':Added, #1: 1	حَوْلَ أَسْمَاءِ
u'حَوْلٌ أسْنَانٌ':Added, #1: 1	حَوْلَ الْأَسْنَانِ
u'حول أصل':Added, #1: 1	حَوْلَ الْأَسْنَانِ
u'حول أًصْلٌ':Added, #1: 1	حَوْلِ أَصْلِهِ
u'حَوْلٌ أصل':Added, #1: 1	حَوْلِ أَصْلِهِ
u'حَوْلٌ أًصْلٌ':Added, #1: 1	حَوْلِ أَصْلِهِ
u'حول أصل':Added, #1: 1	حَوْلِ أَصْلِهِ
u'حول أًصْلٌ':Added, #1: 1	حَوْلِ الْأَصْلِ
u'حَوْلٌ أصل':Added, #1: 1	حَوْلِ الْأَصْلِ
u'حَوْلٌ أًصْلٌ':Added, #1: 1	حَوْلِ الْأَصْلِ
u'حول أصل':Added, #1: 1	حَوْلِ الْأَصْلِ
u'حول أًصْلٌ':Added, #2: 2	حَوْلِ أَصْلِ
u'حَوْلٌ أصل':Added, #2: 2	حَوْلِ أَصْلِ
u'حَوْلٌ أًصْلٌ':Added, #2: 2	حَوْلِ أَصْلِ
u'حول أصل':Added, #2: 2	حَوْلِ أَصْلِ
u'حول أًصْلٌ':Added, #2: 2	حَوْلَ أَصْلِهِ
u'حَوْلٌ أصل':Added, #2: 2	حَوْلَ أَصْلِهِ
u'حَوْلٌ أًصْلٌ':Added, #2: 2	حَوْلَ أَصْلِهِ
u'حول أصل':Added, #2: 2	حَوْلَ أَصْلِهِ
u'حول أًصْلٌ':Added, #2: 2	حَوْلُ الْأَصْلِ
u'حَوْلٌ أصل':Added, #2: 2	حَوْلُ الْأَصْلِ
u'حَوْلٌ أًصْلٌ':Added, #2: 2	حَوْلُ الْأَصْلِ
u'حول أصل':Added, #2: 2	حَوْلُ الْأَصْلِ
u'حول أًصْلٌ':Added, #7: 7	حَوْلُ أَصْلِهِ
u'حَوْلٌ أصل':Added, #7: 7	حَوْلُ أَصْلِهِ
u'حَوْلٌ أًصْلٌ':Added, #7: 7	حَوْلُ أَصْلِهِ
u'حول أُصولٌ':Added, #7: 7	حَوْلُ أَصْلِهِ
u'حَوْلٌ أُصولٌ':Added, #2: 2	حَوْلُ الْأُصُولِ
u'حول إضافَةٌ':Added, #2: 2	حَوْلُ الْأُصُولِ
u'حَوْلٌ إضافَةٌ':Added, #1: 1	حَوْلُ إضَافَةِ
u'حول إمَامٌ':Added, #1: 1	حَوْلُ إضَافَةِ
u'حَوْلٌ إمَامٌ':Added, #1: 1	حَوْلَ الْإِمَامِ
u'حول أُمَّهَاتٌ':Added, #1: 1	حَوْلَ الْإِمَامِ
u'حَوْلٌ أُمَّهَاتٌ':Added, #1: 1	حَوْلِ الْأُمَّهَاتِ
u'حول أُمَّهَاتٌ':Added, #1: 1	حَوْلِ الْأُمَّهَاتِ
u'حَوْلٌ أُمَّهَاتٌ':Added, #1: 1	حَوْلَ أُمّهَاتِ
u'حول أُمَّهَاتٌ':Added, #1: 1	حَوْلَ أُمّهَاتِ
u'حَوْلٌ أُمَّهَاتٌ':Added, #1: 1	حَوْلِ أُمَّهَاتِهِ
u'حول أُمَّهَاتٌ':Added, #1: 1	حَوْلِ أُمَّهَاتِهِ
u'حول أُمَّهَاتٌ':Added, #2: 2	حَوْلَ الْأُمَّهَاتِ
u'حَوْلٌ أُمَّهَاتٌ':Added, #2: 2	حَوْلُ الْأُمَّهَاتِ
u'حَوْلٌ أُمَّهَاتٌ':Added, #2: 2	حَوْلَ الْأُمَّهَاتِ
u'حول اِنْقِطاعٌ':Added, #2: 2	حَوْلُ الْأُمَّهَاتِ
u'حَوْلٌ اِنْقِطاعٌ':Added, #1: 1	حَوْلَ انْقِطَاعِ
u'حول اِهْتِزَازٌ':Added, #1: 1	حَوْلَ انْقِطَاعِ
u'حَوْلٌ اِهْتِزَازٌ':Added, #1: 1	حَوْلَ اهْتِزَازِ
u'حول أهْلٌ':Added, #1: 1	حَوْلَ اهْتِزَازِ
u'حَوْلٌ أهْلٌ':Added, #1: 1	حَوْلَ أَهْلِ
u'حول أَوَّلُ':Added, #1: 1	حَوْلَ أَهْلِ
u'حَوْلٌ أَوَّلُ':Added, #4: 4	حَوْلُ الْأَوَّلِ
u'حول أَوَّلُ':Added, #4: 4	حَوْلُ الْأَوَّلِ
u'حَوْلٌ أَوَّلُ':Added, #6: 6	حَوْلِ الْأَوَّلِ
u'حول آيَةٌ':Added, #6: 6	حَوْلِ الْأَوَّلِ
u'حَوْلٌ آيَةٌ':Added, #1: 1	حَوْلَ آيَةِ
u'حول بَابٌ':Added, #1: 1	حَوْلَ آيَةِ
u'حَوْلٌ بَابٌ':Added, #1: 1	حَوْلَ الْبَابِ
u'حول بَائِعٌ':Added, #1: 1	حَوْلَ الْبَابِ
u'حَوْلٌ بَائِعٌ':Added, #4: 4	حَوْلُ الْبَائِعِ
u'حول بَراءةٌ':Added, #4: 4	حَوْلُ الْبَائِعِ
u'حَوْلٌ بَراءةٌ':Added, #1: 1	حَوْلَ بَرَاءَةِ
u'حول بَعيرٌ':Added, #1: 1	حَوْلَ بَرَاءَةِ
u'حَوْلٌ بَعيرٌ':Added, #1: 1	حَوْلَ الْبَعِيرِ
u'حَوَّلَ بَلَّةٌ':Predicate, #1: 1	حَوْلَ الْبَعِيرِ
u'حول بَلَدٌ':Added, #1: 1	حَوَّلَ بَلَّةَ
u'حَوْلٌ بَلَدٌ':Added, #1: 1	حَوْلَ الْبَلَدِ
u'حول بِنَاءٌ':Added, #1: 1	حَوْلَ الْبَلَدِ
u'حَوْلٌ بِنَاءٌ':Added, #2: 2	حَوْلَ بِنَاءِ
u'حول بِنْتٌ':Added, #2: 2	حَوْلَ بِنَاءِ
u'حَوْلٌ بِنْتٌ':Added, #2: 2	حَوْلُ بِنْتِ
u'حول بِئْرٌ':Added, #2: 2	حَوْلُ بِنْتِ
u'حَوْلٌ بِئْرٌ':Added, #3: 3	حَوْلَ الْبِئْرِ
u'حول بَيْتٌ':Added, #3: 3	حَوْلَ الْبِئْرِ
u'حَوْلٌ بَيْتٌ':Added, #25: 25	حَوْلَ الْبَيْتِ
u'حول تُجَّارٌ':Added, #25: 25	حَوْلَ الْبَيْتِ
u'حَوْلٌ تُجَّارٌ':Added, #1: 1	حَوْلِ التُّجَّارِ
u'حول تِجَارَةٌ':Added, #1: 1	حَوْلِ التُّجَّارِ
u'حَوْلٌ تِجَارَةٌ':Added, #4: 4	حَوْلِ التِّجَارَةِ
u'حول تِجَارَةٌ':Added, #4: 4	حَوْلِ التِّجَارَةِ
u'حَوْلٌ تِجَارَةٌ':Added, #6: 6	حَوْلَ التِّجَارَةِ
u'حول تِجَارَةٌ':Added, #6: 6	حَوْلَ التِّجَارَةِ
u'حَوْلٌ تِجَارَةٌ':Added, #7: 7	حَوْلُ التِّجَارَةِ
u'حول تَخْيِيرٌ':Added, #7: 7	حَوْلُ التِّجَارَةِ
u'حَوْلٌ تَخْيِيرٌ':Added, #1: 1	حَوْلَ التّخْيِيرِ
u'حول تَعْرِيفٌ':Added, #1: 1	حَوْلَ التّخْيِيرِ
u'حول تَعْرِيفٌ':Added, #2: 2	حَوْلَ التَّعْرِيفِ
u'حَوْلٌ تَعْرِيفٌ':Added, #2: 2	حَوْلِ التَّعْرِيفِ
u'حَوْلٌ تَعْرِيفٌ':Added, #2: 2	حَوْلَ التَّعْرِيفِ
u'حول تَقَدُّمٌ':Added, #2: 2	حَوْلِ التَّعْرِيفِ
u'حَوْلٌ تَقَدُّمٌ':Added, #1: 1	حَوْلَ تَقَدّمِ
u'حول تَقْديرٌ':Added, #1: 1	حَوْلَ تَقَدّمِ
u'حَوْلٌ تَقْديرٌ':Added, #1: 1	حَوْلَ التَّقْدِيرِ
u'حول ثَانِي':Added, #1: 1	حَوْلَ التَّقْدِيرِ
u'حَوْلٌ ثَانِي':Added, #10: 10	حَوْلُ الثَّانِيَةِ
u'حول ثَانِي':Added, #10: 10	حَوْلُ الثَّانِيَةِ
u'حَوْلٌ ثَانِي':Added, #2: 2	حَوْلِ الثَّانِيَةِ
u'حول ثَانِيَةٌ':Added, #2: 2	حَوْلِ الثَّانِيَةِ
u'حَوْلٌ ثَانِيَةٌ':Added, #10: 10	حَوْلُ الثَّانِيَةِ
u'حول ثَانِيَةٌ':Added, #10: 10	حَوْلُ الثَّانِيَةِ
u'حَوْلٌ ثَانِيَةٌ':Added, #2: 2	حَوْلِ الثَّانِيَةِ
u'حول ثَمَرَةٌ':Added, #2: 2	حَوْلِ الثَّانِيَةِ
u'حَوْلٌ ثَمَرَةٌ':Added, #1: 1	حَوْلُ الثَّمَرَةِ
u'حول ثَمَنٌ':Added, #1: 1	حَوْلُ الثَّمَرَةِ
u'حَوْلٌ ثَمَنٌ':Added, #1: 1	حَوْلَ ثَمَنِ
u'حول جَديدٌ':Added, #1: 1	حَوْلَ ثَمَنِ
u'حَوْلٌ جَديدٌ':Added, #3: 3	حَوْلٍ جَدِيدٍ
u'حول جِرَاحَةٌ':Added, #3: 3	حَوْلٍ جَدِيدٍ
u'حَوْلٌ جِرَاحَةٌ':Added, #1: 1	حَوْلَ الْجِرَاحَةِ
u'حول جِزْيَةٌ':Added, #1: 1	حَوْلَ الْجِرَاحَةِ
u'حَوْلٌ جِزْيَةٌ':Added, #2: 2	حَوْلَ الْجِزْيَةِ
u'حول جمع':Added, #2: 2	حَوْلَ الْجِزْيَةِ
u'حَوْلٌ جمع':Added, #1: 1	حَوْلَ جَمْعِ
u'حول جَمْعٌ':Added, #1: 1	حَوْلَ جَمْعِ
u'حَوْلٌ جَمْعٌ':Added, #1: 1	حَوْلَ جَمْعِ
u'حَوَّلَ جَمِيع':Predicate, #1: 1	حَوْلَ جَمْعِ
u'حول جَمِيع':Added, #1: 1	حَوَّلَ الْجَمِيعَ
u'حَوْلٌ جَمِيع':Added, #2: 2	حَوْلُ الْجَمِيعِ
u'حول جَنَابٌ':Added, #2: 2	حَوْلُ الْجَمِيعِ
u'حَوْلٌ جَنَابٌ':Added, #1: 1	حَوْلَ جَنَابِهِ
u'حول حافِرٌ':Added, #1: 1	حَوْلَ جَنَابِهِ
u'حَوْلٌ حافِرٌ':Added, #1: 1	حَوْلَ الْحَافِرِ
u'حول حُفْرَةٌ':Added, #1: 1	حَوْلَ الْحَافِرِ
u'حَوْلٌ حُفْرَةٌ':Added, #1: 1	حَوْلَ الْحُفْرَةِ
u'حَوَّلَ حَقٌّ':Predicate, #1: 1	حَوْلَ الْحُفْرَةِ
u'حول حَوافِرُ':Added, #1: 1	حَوَّلَ حَقَّ
u'حَوْلٌ حَوافِرُ':Added, #1: 1	حَوْلَ الْحَوَافِرِ
u'حول حول':Added, #1: 1	حَوْلَ الْحَوَافِرِ
u'حَوْلٌ حول':Added, #1: 1	حَوْلِ الْحَوْلِ
u'حول حَوْلٌ':Added, #1: 1	حَوْلِ الْحَوْلِ
u'حَوْلٌ حَوْلٌ':Added, #1: 1	حَوْلِ الْحَوْلِ
u'حول خِبَاءٌ':Added, #1: 1	حَوْلِ الْحَوْلِ
u'حَوْلٌ خِبَاءٌ':Added, #1: 1	حَوْلَ الْخِبَاءِ
u'حول خُمُورٌ':Added, #1: 1	حَوْلَ الْخِبَاءِ
u'حَوْلٌ خُمُورٌ':Added, #1: 1	حَوْلَ الْخُمُورِ
u'حول دُبُرٌ':Added, #1: 1	حَوْلَ الْخُمُورِ
u'حَوْلٌ دُبُرٌ':Added, #1: 1	حَوْلَ الدُّبُرِ
u'حول دَرْء':Added, #1: 1	حَوْلَ الدُّبُرِ
u'حَوْلٌ دَرْء':Added, #1: 1	حَوْلَ الدَّرْءِ
u'حول دَيْنٌ':Added, #1: 1	حَوْلَ الدَّرْءِ
u'حول دَيْنٌ':Added, #1: 1	حَوْلَ الدَّيْنِ
u'حَوْلٌ دَيْنٌ':Added, #1: 1	حَوْلِ الدَّيْنِ
u'حَوْلٌ دَيْنٌ':Added, #1: 1	حَوْلَ الدَّيْنِ
u'حول ذكر':Added, #1: 1	حَوْلِ الدَّيْنِ
u'حَوْلٌ ذكر':Added, #1: 1	حَوْلَ ذَكَرِ
u'حول ذَكَرٌ':Added, #1: 1	حَوْلَ ذَكَرِ
u'حَوْلٌ ذَكَرٌ':Added, #1: 1	حَوْلَ ذَكَرِ
u'حول رَأْسٌ':Added, #1: 1	حَوْلَ ذَكَرِ
u'حَوْلٌ رَأْسٌ':Added, #1: 1	حَوْلَ الرَّأْسِ
u'حول رَأْسٌ':Added, #1: 1	حَوْلَ الرَّأْسِ
u'حَوْلٌ رَأْسٌ':Added, #6: 6	حَوْلَ رَأْسِهِ
u'حول رِبْحٌ':Added, #6: 6	حَوْلَ رَأْسِهِ
u'حول رِبْحٌ':Added, #1: 1	حَوْلَ رِبْحِ
u'حَوْلٌ رِبْحٌ':Added, #1: 1	حَوْلُ رِبْحِ
u'حَوْلٌ رِبْحٌ':Added, #1: 1	حَوْلَ رِبْحِ
u'حول رِبْحٌ':Added, #1: 1	حَوْلُ رِبْحِ
u'حَوْلٌ رِبْحٌ':Added, #2: 2	حَوْلُ الرِّبْحِ
u'حول رَجُلٌ':Added, #2: 2	حَوْلُ الرِّبْحِ
u'حَوْلٌ رَجُلٌ':Added, #1: 1	حَوْلَ الرَّجُلِ
u'حول رَجُلٌ':Added, #1: 1	حَوْلَ الرَّجُلِ
u'حَوْلٌ رَجُلٌ':Added, #1: 1	حَوْلَ رَجُلٍ
u'حول رَسُولٌ':Added, #1: 1	حَوْلَ رَجُلٍ
u'حَوْلٌ رَسُولٌ':Added, #5: 5	حَوْلَ رَسُولِ
u'حول رِياضٌ':Added, #5: 5	حَوْلَ رَسُولِ
u'حَوْلٌ رِياضٌ':Added, #1: 1	حَوْلَ رِيَاضِهِ
u'حول زَكاةٌ':Added, #1: 1	حَوْلَ رِيَاضِهِ
u'حَوْلٌ زَكاةٌ':Added, #12: 12	حَوْلِ الزَّكَاةِ
u'حول زَكاةٌ':Added, #12: 12	حَوْلِ الزَّكَاةِ
u'حول زَكاةٌ':Added, #1: 1	حَوْلَ الزَّكَاةِ
u'حَوْلٌ زَكاةٌ':Added, #1: 1	حَوْلُ الزَّكَاةِ
u'حَوْلٌ زَكاةٌ':Added, #1: 1	حَوْلَ الزَّكَاةِ
u'حول زَكاةٌ':Added, #1: 1	حَوْلُ الزَّكَاةِ
u'حَوْلٌ زَكاةٌ':Added, #1: 1	حَوْلَ زَكَاةِ
u'حول زَكاةٌ':Added, #1: 1	حَوْلَ زَكَاةِ
u'حَوْلٌ زَكاةٌ':Added, #1: 1	حَوْلَ زَكَاتِهِ
u'حول زِيادَةٌ':Added, #1: 1	حَوْلَ زَكَاتِهِ
u'حَوْلٌ زِيادَةٌ':Added, #1: 1	حَوْلُ الزِّيَادَةِ
u'حول ساج':Added, #1: 1	حَوْلُ الزِّيَادَةِ
u'حَوْلٌ ساج':Added, #1: 1	حَوْلَ السَّاجَةِ
u'حول ساجَة':Added, #1: 1	حَوْلَ السَّاجَةِ
u'حَوْلٌ ساجَة':Added, #1: 1	حَوْلَ السَّاجَةِ
u'حول سَائِرٌ':Added, #1: 1	حَوْلَ السَّاجَةِ
u'حَوْلٌ سَائِرٌ':Added, #1: 1	حَوْلَ سَائِرِ
u'حول سَائِمَةٌ':Added, #1: 1	حَوْلَ سَائِرِ
u'حول سَائِمَةٌ':Added, #1: 1	حَوْلَ السَّائِمَةِ
u'حول سَائِمَةٌ':Added, #1: 1	حَوْلُ السَّائِمَةِ
u'حَوْلٌ سَائِمَةٌ':Added, #1: 1	حَوْلِ السَّائِمَةِ
u'حَوْلٌ سَائِمَةٌ':Added, #1: 1	حَوْلَ السَّائِمَةِ
u'حَوْلٌ سَائِمَةٌ':Added, #1: 1	حَوْلُ السَّائِمَةِ
u'حول سَبْيٌ':Added, #1: 1	حَوْلِ السَّائِمَةِ
u'حَوْلٌ سَبْيٌ':Added, #1: 1	حَوْلَ سَبْيِ
u'حول سَرِيرٌ':Added, #1: 1	حَوْلَ سَبْيِ
u'حَوْلٌ سَرِيرٌ':Added, #1: 1	حَوْلَ السَّرِيرِ
u'حول سُورَةٌ':Added, #1: 1	حَوْلَ السَّرِيرِ
u'حَوْلٌ سُورَةٌ':Added, #1: 1	حَوْلُ سُورَةِ
u'حول سَيْرٌ':Added, #1: 1	حَوْلُ سُورَةِ
u'حَوْلٌ سَيْرٌ':Added, #1: 1	حَوْلَ سَيْرٍ
u'حول شَجَّةٌ':Added, #1: 1	حَوْلَ سَيْرٍ
u'حَوْلٌ شَجَّةٌ':Added, #2: 2	حَوْلَ الشَّجَّةِ
u'حول شَجَرٌ':Added, #2: 2	حَوْلَ الشَّجَّةِ
u'حَوْلٌ شَجَرٌ':Added, #1: 1	حَوْلَ الشَّجَرِ
u'حول شَجَرَةٌ':Added, #1: 1	حَوْلَ الشَّجَرِ
u'حول شَجَرَةٌ':Added, #1: 1	حَوْلَ الشّجَرَةِ
u'حَوْلٌ شَجَرَةٌ':Added, #1: 1	حَوْلَ الشَّجَرَةِ
u'حَوْلٌ شَجَرَةٌ':Added, #1: 1	حَوْلَ الشّجَرَةِ
u'حول شِعْرٌ':Added, #1: 1	حَوْلَ الشَّجَرَةِ
u'حَوْلٌ شِعْرٌ':Added, #1: 1	حَوْلُ شِعْرِ
u'حول شِعْرٌ':Added, #1: 1	حَوْلُ شِعْرِ
u'حَوْلٌ شِعْرٌ':Added, #3: 3	حَوْلَ شِعْرِ
u'حول صَحْنٌ':Added, #3: 3	حَوْلَ شِعْرِ
u'حَوْلٌ صَحْنٌ':Added, #1: 1	حَوْلَ صَحْنِ
u'حول صداق':Added, #1: 1	حَوْلَ صَحْنِ
u'حَوْلٌ صداق':Added, #1: 1	حَوْلُ الصَّدَاقِ
u'حول صَدَاقٌ':Added, #1: 1	حَوْلُ الصَّدَاقِ
u'حَوْلٌ صَدَاقٌ':Added, #1: 1	حَوْلُ الصَّدَاقِ
u'حول صِرَاطٌ':Added, #1: 1	حَوْلُ الصَّدَاقِ
u'حَوْلٌ صِرَاطٌ':Added, #1: 1	حَوْلَ الصّرَاطِ
u'حول صِيَامٌ':Added, #1: 1	حَوْلَ الصّرَاطِ
u'حَوْلٌ صِيَامٌ':Added, #1: 1	حَوْلُ الصِّيَامِ
u'حول ظُهورٌ':Added, #1: 1	حَوْلُ الصِّيَامِ
u'حَوْلٌ ظُهورٌ':Added, #1: 1	حَوْلِ ظُهُورِ
u'حول ظُهورٌ':Added, #1: 1	حَوْلِ ظُهُورِ
u'حَوْلٌ ظُهورٌ':Added, #2: 2	حَوْلِ الظُّهُورِ
u'حول عتاب':Added, #2: 2	حَوْلِ الظُّهُورِ
u'حَوْلٌ عتاب':Added, #1: 1	حَوْلَ عِتَابِ
u'حول عِتَابٌ':Added, #1: 1	حَوْلَ عِتَابِ
u'حَوْلٌ عِتَابٌ':Added, #1: 1	حَوْلَ عِتَابِ
u'حول عَرْضٌ':Added, #1: 1	حَوْلَ عِتَابِ
u'حَوْلٌ عَرْضٌ':Added, #1: 1	حَوْلِ الْعَرْضِ
u'حول عُرُوضٌ':Added, #1: 1	حَوْلِ الْعَرْضِ
u'حَوْلٌ عُرُوضٌ':Added, #1: 1	حَوْلِ عُرُوضِ
u'حول عَسْكَرٌ':Added, #1: 1	حَوْلِ عُرُوضِ
u'حَوْلٌ عَسْكَرٌ':Added, #1: 1	حَوْلَ الْعَسْكَرِ
u'حول عصاب':Added, #1: 1	حَوْلَ الْعَسْكَرِ
u'حَوْلٌ عصاب':Added, #1: 1	حَوْلَ الْعِصَابِ
u'حول عِصَابٌ':Added, #1: 1	حَوْلَ الْعِصَابِ
u'حَوْلٌ عِصَابٌ':Added, #1: 1	حَوْلَ الْعِصَابِ
u'حول عُلُوٌّ':Added, #1: 1	حَوْلَ الْعِصَابِ
u'حَوْلٌ عُلُوٌّ':Added, #1: 1	حَوْلَ الْعُلُوِّ
u'حول عين':Added, #1: 1	حَوْلَ الْعُلُوِّ
u'حول عَيْنٌ':Added, #1: 1	حَوْلَ الْعَيْنِ
u'حول عَيْن':Added, #1: 1	حَوْلَ الْعَيْنِ
u'حَوْلٌ عين':Added, #1: 1	حَوْلَ الْعَيْنِ
u'حَوْلٌ عَيْنٌ':Added, #1: 1	حَوْلَ الْعَيْنِ
u'حَوْلٌ عَيْن':Added, #1: 1	حَوْلَ الْعَيْنِ
u'حول عين':Added, #1: 1	حَوْلَ الْعَيْنِ
u'حول عَيْنٌ':Added, #1: 1	حَوْلَ عَيْنِ
u'حول عَيْن':Added, #1: 1	حَوْلَ عَيْنِ
u'حَوْلٌ عين':Added, #1: 1	حَوْلَ عَيْنِ
u'حَوْلٌ عَيْنٌ':Added, #1: 1	حَوْلَ عَيْنِ
u'حَوْلٌ عَيْن':Added, #1: 1	حَوْلَ عَيْنِ
u'حول عين':Added, #1: 1	حَوْلَ عَيْنِ
u'حول عَيْنٌ':Added, #2: 2	حَوْلِ الْعَيْنِ
u'حول عَيْن':Added, #2: 2	حَوْلِ الْعَيْنِ
u'حَوْلٌ عين':Added, #2: 2	حَوْلِ الْعَيْنِ
u'حَوْلٌ عَيْنٌ':Added, #2: 2	حَوْلِ الْعَيْنِ
u'حَوْلٌ عَيْن':Added, #2: 2	حَوْلِ الْعَيْنِ
u'حول فَأْرٌ':Added, #2: 2	حَوْلِ الْعَيْنِ
u'حَوْلٌ فَأْرٌ':Added, #1: 1	حَوْلَ الْفَأْرَةِ
u'حول فَائِدَةٌ':Added, #1: 1	حَوْلَ الْفَأْرَةِ
u'حَوْلٌ فَائِدَةٌ':Added, #1: 1	حَوْلِ الْفَائِدَةِ
u'حول فتنة':Added, #1: 1	حَوْلِ الْفَائِدَةِ
u'حَوْلٌ فتنة':Added, #1: 1	حَوْلَ فِتْنَةِ
u'حول فِتْنَةٌ':Added, #1: 1	حَوْلَ فِتْنَةِ
u'حَوْلٌ فِتْنَةٌ':Added, #1: 1	حَوْلَ فِتْنَةِ
u'حول فِرَاشٌ':Added, #1: 1	حَوْلَ فِتْنَةِ
u'حَوْلٌ فِرَاشٌ':Added, #1: 1	حَوْلَ فِرَاشِهِ
u'حول فَرْجٌ':Added, #1: 1	حَوْلَ فِرَاشِهِ
u'حَوْلٌ فَرْجٌ':Added, #1: 1	حَوْلَ الْفَرْجِ
u'حَوَّلَ قَادِرٌ':Subject, #1: 1	حَوْلَ الْفَرْجِ
u'حول قَبْرٌ':Added, #1: 1	حَوَّلَ الْقَادِرُ
u'حَوْلٌ قَبْرٌ':Added, #1: 1	حَوْلَ قَبْرِهِ
u'حول قَبْرٌ':Added, #1: 1	حَوْلَ قَبْرِهِ
u'حَوْلٌ قَبْرٌ':Added, #3: 3	حَوْلَ قَبْرِ
u'حول قُبُلٌ':Added, #3: 3	حَوْلَ قَبْرِ
u'حَوْلٌ قُبُلٌ':Added, #1: 1	حَوْلَ الْقُبُلِ
u'حول قُبُلٌ':Added, #1: 1	حَوْلَ الْقُبُلِ
u'حَوْلٌ قُبُلٌ':Added, #1: 1	حَوْلَ قُبُلِهِ
u'حول قُبُورٌ':Added, #1: 1	حَوْلَ قُبُلِهِ
u'حَوْلٌ قُبُورٌ':Added, #1: 1	حَوْلَ قُبُورِ
u'حول قَسْمٌ':Added, #1: 1	حَوْلَ قُبُورِ
u'حَوْلٌ قَسْمٌ':Added, #1: 1	حَوْلَ الْقَسْمِ
u'حول قِصَّةٌ':Added, #1: 1	حَوْلَ الْقَسْمِ
u'حَوْلٌ قِصَّةٌ':Added, #1: 1	حَوْلَ قِصّةِ
u'حول قَصْرٌ':Added, #1: 1	حَوْلَ قِصّةِ
u'حَوْلٌ قَصْرٌ':Added, #1: 1	حَوْلَ الْقَصْرِ
u'حول قَصِيدٌ':Added, #1: 1	حَوْلَ الْقَصْرِ
u'حَوْلٌ قَصِيدٌ':Added, #1: 1	حَوْلَ قَصِيدَةِ
u'حول قمر':Added, #1: 1	حَوْلَ قَصِيدَةِ
u'حَوْلٌ قمر':Added, #2: 2	حَوْلَ الْقَمَرِ
u'حول قَمَرٌ':Added, #2: 2	حَوْلَ الْقَمَرِ
u'حَوْلٌ قَمَرٌ':Added, #2: 2	حَوْلَ الْقَمَرِ
u'حول قول':Added, #2: 2	حَوْلَ الْقَمَرِ
u'حَوْلٌ قول':Added, #1: 1	حَوْلَ قَوْلِ
u'حول قَوْلٌ':Added, #1: 1	حَوْلَ قَوْلِ
u'حَوْلٌ قَوْلٌ':Added, #1: 1	حَوْلَ قَوْلِ
u'حول كعبة':Added, #1: 1	حَوْلَ قَوْلِ
u'حَوْلٌ كعبة':Added, #1: 1	حَوْلِ الْكَعْبَةِ
u'حول كَعْبَةٌ':Added, #1: 1	حَوْلِ الْكَعْبَةِ
u'حَوْلٌ كَعْبَةٌ':Added, #1: 1	حَوْلِ الْكَعْبَةِ
u'حول كعبة':Added, #1: 1	حَوْلِ الْكَعْبَةِ
u'حَوْلٌ كعبة':Added, #23: 23	حَوْلَ الْكَعْبَةِ
u'حول كَعْبَةٌ':Added, #23: 23	حَوْلَ الْكَعْبَةِ
u'حَوْلٌ كَعْبَةٌ':Added, #23: 23	حَوْلَ الْكَعْبَةِ
u'حول كَلِمَةٌ':Added, #23: 23	حَوْلَ الْكَعْبَةِ
u'حَوْلٌ كَلِمَةٌ':Added, #1: 1	حَوْلَ كَلِمَةِ
u'حَوَّلَ مَاءٌ':Predicate, #1: 1	حَوْلَ كَلِمَةِ
u'حول مَاءٌ':Added, #1: 1	حَوَّلَ الْمَاءَ
u'حَوْلٌ مَاءٌ':Added, #1: 1	حَوْلَ الْمَاءِ
u'حول مَاشِي':Added, #1: 1	حَوْلَ الْمَاءِ
u'حَوْلٌ مَاشِي':Added, #2: 2	حَوْلَ الْمَاشِيَةِ
u'حول مَاشِيَةٌ':Added, #2: 2	حَوْلَ الْمَاشِيَةِ
u'حَوْلٌ مَاشِيَةٌ':Added, #2: 2	حَوْلَ الْمَاشِيَةِ
u'حول مَالٌ':Added, #2: 2	حَوْلَ الْمَاشِيَةِ
u'حول مَالٌ':Added, #2: 2	حَوْلُ الْمَالِ
u'حَوْلٌ مَالٌ':Added, #2: 2	حَوْلِ الْمَالِ
u'حَوْلٌ مَالٌ':Added, #2: 2	حَوْلُ الْمَالِ
u'حول مَالٌ':Added, #2: 2	حَوْلِ الْمَالِ
u'حَوْلٌ مَالٌ':Added, #2: 2	حَوْلُ الْمَالَيْنِ
u'حول مَالٌ':Added, #2: 2	حَوْلُ الْمَالَيْنِ
u'حَوْلٌ مَالٌ':Added, #2: 2	حَوْلِ مَالِ
u'حول مَبِيعٌ':Added, #2: 2	حَوْلِ مَالِ
u'حَوْلٌ مَبِيعٌ':Added, #3: 3	حَوْلُ الْمَبِيعِ
u'حَوَّلَ مَتَاعٌ':Predicate, #3: 3	حَوْلُ الْمَبِيعِ
u'حول مُجَاوَرَةٌ':Added, #1: 1	حَوَّلَ الْمَتَاعَ
u'حَوْلٌ مُجَاوَرَةٌ':Added, #1: 1	حَوْلَ مُجَاوَرَتِهِ
u'حول مَجَرَّةٌ':Added, #1: 1	حَوْلَ مُجَاوَرَتِهِ
u'حَوْلٌ مَجَرَّةٌ':Added, #1: 1	حَوْلَ الْمَجَرّةِ
u'حول مُحْتَالٌ':Added, #1: 1	حَوْلَ الْمَجَرّةِ
u'حَوْلٌ مُحْتَالٌ':Added, #1: 1	حَوْلُ مُحْتَالِ
u'حول مَحَلٌّ':Added, #1: 1	حَوْلُ مُحْتَالِ
u'حَوْلٌ مَحَلٌّ':Added, #1: 1	حَوْلَ مَحَلِّ
u'حول مَخْرَجٌ':Added, #1: 1	حَوْلَ مَحَلِّ
u'حَوْلٌ مَخْرَجٌ':Added, #1: 1	حَوْلَ الْمَخْرَجِ
u'حول مُدِيرٌ':Added, #1: 1	حَوْلَ الْمَخْرَجِ
u'حَوْلٌ مُدِيرٌ':Added, #1: 1	حَوْلُ الْمُدِيرِ
u'حول مَدِينٌ':Added, #1: 1	حَوْلُ الْمُدِيرِ
u'حَوْلٌ مَدِينٌ':Added, #16: 16	حَوْلَ الْمَدِينَةِ
u'حول مَدِينٌ':Added, #16: 16	حَوْلَ الْمَدِينَةِ
u'حَوْلٌ مَدِينٌ':Added, #1: 1	حَوْلِ الْمَدِينَةِ
u'حول مَدِينَةٌ':Added, #1: 1	حَوْلِ الْمَدِينَةِ
u'حَوْلٌ مَدِينَةٌ':Added, #16: 16	حَوْلَ الْمَدِينَةِ
u'حول مَدِينَةٌ':Added, #16: 16	حَوْلَ الْمَدِينَةِ
u'حَوْلٌ مَدِينَةٌ':Added, #1: 1	حَوْلِ الْمَدِينَةِ
u'حول مُسْتَعِيرٌ':Added, #1: 1	حَوْلِ الْمَدِينَةِ
u'حَوْلٌ مُسْتَعِيرٌ':Added, #1: 1	حَوْلِ الْمُسْتَعِيرِ
u'حول مُسْتَفاد':Added, #1: 1	حَوْلِ الْمُسْتَعِيرِ
u'حَوْلٌ مُسْتَفاد':Added, #1: 1	حَوْلِ الْمُسْتَفَادِ
u'حول مُسْتَفاد':Added, #1: 1	حَوْلِ الْمُسْتَفَادِ
u'حَوْلٌ مُسْتَفاد':Added, #4: 4	حَوْلُ الْمُسْتَفَادِ
u'حول مَسْجِدٌ':Added, #4: 4	حَوْلُ الْمُسْتَفَادِ
u'حَوْلٌ مَسْجِدٌ':Added, #15: 15	حَوْلَ الْمَسْجِدِ
u'حول مَسْجِدٌ':Added, #15: 15	حَوْلَ الْمَسْجِدِ
u'حَوْلٌ مَسْجِدٌ':Added, #1: 1	حَوْلَ مَسْجِدِهِ
u'حول مِصْرٌ':Added, #1: 1	حَوْلَ مَسْجِدِهِ
u'حَوْلٌ مِصْرٌ':Added, #1: 1	حَوْلَ الْمِصْرِ
u'حول مَعْرُوفٌ':Added, #1: 1	حَوْلَ الْمِصْرِ
u'حَوْلٌ مَعْرُوفٌ':Added, #1: 1	حَوْلَ مَعْرُوفٍ
u'حول مَغْرِسٌ':Added, #1: 1	حَوْلَ مَعْرُوفٍ
u'حَوْلٌ مَغْرِسٌ':Added, #2: 2	حَوْلَ الْمَغْرِسِ
u'حول مُكْثٌ':Added, #2: 2	حَوْلَ الْمَغْرِسِ
u'حَوْلٌ مُكْثٌ':Added, #1: 1	حَوْلِ الْمُكْثِ
u'حول مِلْكٌ':Added, #1: 1	حَوْلِ الْمُكْثِ
u'حَوْلٌ مِلْكٌ':Added, #1: 1	حَوْلِ مِلْكِهِ
u'حول مِنْبَرٌ':Added, #1: 1	حَوْلِ مِلْكِهِ
u'حَوْلٌ مِنْبَرٌ':Added, #1: 1	حَوْلَ الْمِنْبَرِ
u'حول مُوَرِّث':Added, #1: 1	حَوْلَ الْمِنْبَرِ
u'حول مُوَرِّث':Added, #1: 1	حَوْلُ الْمُوَرِّثِ
u'حَوْلٌ مُوَرِّث':Added, #1: 1	حَوْلِ الْمُوَرِّثِ
u'حَوْلٌ مُوَرِّث':Added, #1: 1	حَوْلُ الْمُوَرِّثِ
u'حول مَوْرُوثٌ':Added, #1: 1	حَوْلِ الْمُوَرِّثِ
u'حَوْلٌ مَوْرُوثٌ':Added, #1: 1	حَوْلِ الْمَوْرُوثِ
u'حول مَوْضِعٌ':Added, #1: 1	حَوْلِ الْمَوْرُوثِ
u'حَوْلٌ مَوْضِعٌ':Added, #1: 1	حَوْلَ مَوْضِعٍ
u'حول نِتَاجٌ':Added, #1: 1	حَوْلَ مَوْضِعٍ
u'حَوْلٌ نِتَاجٌ':Added, #1: 1	حَوْلُ النِّتَاجِ
u'حول نَخْلٌ':Added, #1: 1	حَوْلُ النِّتَاجِ
u'حَوْلٌ نَخْلٌ':Added, #1: 1	حَوْلَ النَّخْلِ
u'حول نخلة':Added, #1: 1	حَوْلَ النَّخْلِ
u'حَوْلٌ نخلة':Added, #1: 1	حَوْلَ النَّخْلَةِ
u'حول نَخْلَةٌ':Added, #1: 1	حَوْلَ النَّخْلَةِ
u'حَوْلٌ نَخْلَةٌ':Added, #1: 1	حَوْلَ النَّخْلَةِ
u'حول نذر':Added, #1: 1	حَوْلَ النَّخْلَةِ
u'حَوْلٌ نذر':Added, #1: 1	حَوْلَ النّذْرِ
u'حول نَذْرٌ':Added, #1: 1	حَوْلَ النّذْرِ
u'حَوْلٌ نَذْرٌ':Added, #1: 1	حَوْلَ النّذْرِ
u'حول نَسَبٌ':Added, #1: 1	حَوْلَ النّذْرِ
u'حَوْلٌ نَسَبٌ':Added, #1: 1	حَوْلَ نَسَبِ
u'حول نَسْلٌ':Added, #1: 1	حَوْلَ نَسَبِ
u'حَوْلٌ نَسْلٌ':Added, #1: 1	حَوْلُ النَّسْلِ
u'حول نَسْلٌ':Added, #1: 1	حَوْلُ النَّسْلِ
u'حَوْلٌ نَسْلٌ':Added, #2: 2	حَوْلُ نَسْلِ
u'حول نصاب':Added, #2: 2	حَوْلُ نَسْلِ
u'حول نصاب':Added, #1: 1	حَوْلَ النِّصَابِ
u'حَوْلٌ نصاب':Added, #1: 1	حَوْلِ النِّصَابِ
u'حَوْلٌ نصاب':Added, #1: 1	حَوْلَ النِّصَابِ
u'حول نِصَابٌ':Added, #1: 1	حَوْلِ النِّصَابِ
u'حول نِصَابٌ':Added, #1: 1	حَوْلَ النِّصَابِ
u'حَوْلٌ نِصَابٌ':Added, #1: 1	حَوْلِ النِّصَابِ
u'حَوْلٌ نِصَابٌ':Added, #1: 1	حَوْلَ النِّصَابِ
u'حول نَقْدٌ':Added, #1: 1	حَوْلِ النِّصَابِ
u'حول نَقْد':Added, #1: 1	حَوْلِ النَّقْدِ
u'حَوْلٌ نَقْدٌ':Added, #1: 1	حَوْلِ النَّقْدِ
u'حَوْلٌ نَقْد':Added, #1: 1	حَوْلِ النَّقْدِ
u'حول نَقْدٌ':Added, #1: 1	حَوْلِ النَّقْدِ
u'حول نَقْدٌ':Added, #2: 2	حَوْلُ نَقْدٍ
u'حول نَقْد':Added, #2: 2	حَوْلِ نَقْدٍ
u'حول نَقْد':Added, #2: 2	حَوْلُ نَقْدٍ
u'حَوْلٌ نَقْدٌ':Added, #2: 2	حَوْلِ نَقْدٍ
u'حَوْلٌ نَقْدٌ':Added, #2: 2	حَوْلُ نَقْدٍ
u'حَوْلٌ نَقْد':Added, #2: 2	حَوْلِ نَقْدٍ
u'حَوْلٌ نَقْد':Added, #2: 2	حَوْلُ نَقْدٍ
u'حول نَهِيمٌ':Added, #2: 2	حَوْلِ نَقْدٍ
u'حَوْلٌ نَهِيمٌ':Added, #1: 1	حَوْلَ النّهِيمِ
u'حول هَدْمٌ':Added, #1: 1	حَوْلَ النّهِيمِ
u'حَوْلٌ هَدْمٌ':Added, #1: 1	حَوْلَ هَدْمِ
u'حول واحد':Added, #1: 1	حَوْلَ هَدْمِ
u'حَوْلٌ واحد':Added, #3: 3	حَوْلٍ وَاحِدٍ
u'حول وَاحِدٌ':Added, #3: 3	حَوْلٍ وَاحِدٍ
u'حَوْلٌ وَاحِدٌ':Added, #3: 3	حَوْلٍ وَاحِدٍ
u'حول وَجْهٌ':Added, #3: 3	حَوْلٍ وَاحِدٍ
u'حَوْلٌ وَجْهٌ':Added, #1: 1	حَوْلَ وَجْهِهِ
u'حول وُجُوبٌ':Added, #1: 1	حَوْلَ وَجْهِهِ
u'حَوْلٌ وُجُوبٌ':Added, #2: 2	حَوْلِ الْوُجُوبِ
u'حول وَصَائِلُ':Added, #2: 2	حَوْلِ الْوُجُوبِ
u'حَوْلٌ وَصَائِلُ':Added, #1: 1	حَوْلُ الْوَصَائِلِ
u'حول وقاف':Added, #1: 1	حَوْلُ الْوَصَائِلِ
u'حَوْلٌ وقاف':Added, #1: 1	حَوْلِ وَقَافِ
u'حول وَقْفٌ':Added, #1: 1	حَوْلِ وَقَافِ
u'حَوْلٌ وَقْفٌ':Added, #1: 1	حَوْلَ وَقْفٍ
u'حول يَافُوخٌ':Added, #1: 1	حَوْلَ وَقْفٍ
u'حَوْلٌ يَافُوخٌ':Added, #1: 1	حَوْلَ الْيَافُوخِ
u'حَوْمَةٌ كبائر':Added, #1: 1	حَوْلَ الْيَافُوخِ
u'حَوْمَةٌ مَجْدٌ':Added, #1: 1	حَوْمَةَ الْكَبَائِرِ
u'حَوْمَةٌ مَوْتٌ':Added, #1: 1	حَوْمَةِ الْمَجْدِ
u'حَوَى آباءٌ':Subject, #1: 1	حَوْمَةِ الْمَوْتِ
u'حَوَى طعام':Predicate, #1: 1	حَوَى الْآبَاءُ
u'حَوَى طَعَامٌ':Predicate, #1: 1	حَوَى الطَّعَامَ
u'حَوَى علم':Predicate, #1: 1	حَوَى الطَّعَامَ
u'حَوَى عِلْمٌ':Predicate, #1: 1	حَوَى عِلْمَ
u'حَوَى غَالِبٌ':Predicate, #1: 1	حَوَى عِلْمَ
u'حَوَى قُرْآنٌ':Subject, #1: 1	حَوَى غَالِبَ
u'حَيَاءٌ الْمَرْأَةُ':Added, #1: 1	حَوَى الْقُرْآنُ
u'حَيَاءٌ إِنْسانٌ':Added, #1: 1	حَيَاءِ الْمَرْأَةِ
u'حَيَاءٌ بَكارَةٌ':Added, #1: 1	حَيَاءُ الْإِنْسَانِ
u'حَيَاءٌ بِكْرٌ':Added, #1: 1	حَيَاءِ الْبَكَارَةِ
u'حَيَاءٌ بِكْرٌ':Added, #1: 1	حَيَاءَ الْبِكْرِ
u'حَيَاءٌ بِكْرٌ':Added, #1: 1	حَيَاءِ بِكْرٍ
u'حَيَاءٌ كَرَمٌ':Added, #2: 2	حَيَاءِ الْبِكْرِ
u'حَيَاءٌ مَعْصِيَةٌ':Added, #1: 1	حَيَاءُ كَرَمِ
u'حَيَاةٌ أَبٌ':Added, #1: 1	حَيَاءُ مَعْصِيَةٍ
u'حَيَاةٌ آباءٌ':Added, #14: 14	حَيَاةِ الْأَبِ
u'حَيَاةٌ أبدانٌ':Added, #1: 1	حَيَاةِ الْآبَاءِ
u'حَيَاةٌ اِبْنٌ':Added, #1: 1	حَيَاةُ الْأَبْدَانِ
u'حَيَاةٌ أُخْتٌ':Added, #1: 1	حَيَاةِ ابْنِهِ
u'حَيَاةٌ أشْبَاحٌ':Added, #1: 1	حَيَاةِ الْأُخْتِ
u'حَيَاةٌ الْمَرْءُ':Added, #2: 2	حَيَاةُ الْأَشْبَاحِ
u'حَيَاةٌ الْمَرْأَةُ':Added, #2: 2	حَيَاةَ الْمَرْءِ
u'حَيَاةٌ أُمٌّ':Added, #1: 1	حَيَاةِ الْمَرْأَةِ
u'حَيَاةٌ أُمٌّ':Added, #1: 1	حَيَاةِ أُمِّهِ
u'حَيَاةٌ آمِرٌ':Added, #4: 4	حَيَاةِ الْأُمِّ
u'حَيَاةٌ أنبياء':Added, #3: 3	حَيَاةِ الْآمِرِ
u'حَيَاةٌ أَنْفُسٌ':Added, #2: 2	حَيَاةِ الْأَنْبِيَاءِ
u'حَيَاةٌ أَنْفُسٌ':Added, #1: 1	حَيَاةُ الْأَنْفُسِ
u'حَيَاةٌ أهْلٌ':Added, #1: 1	حَيَاةِ الْأَنْفُسِ
u'حَيَاةٌ أَوَّلُ':Added, #1: 1	حَيَاةِ أَهْلِ
u'حَيَاةٌ بَائِعٌ':Added, #2: 2	حَيَاةِ الْأَوَّلِ
u'حَيَاةٌ بَطْنٌ':Added, #1: 1	حَيَاةِ الْبَائِعِ
u'حَيَاةٌ بَهيمٌ':Added, #1: 1	حَيَاةِ الْبَطْنِ
u'حَيَاةٌ بَهِيمَةٌ':Added, #1: 1	حَيَاةِ الْبَهِيمَةِ
u'حَيَاةٌ بَيِّنَةٌ':Added, #1: 1	حَيَاةِ الْبَهِيمَةِ
u'حَيَاةٌ بَيِّنَةٌ':Added, #2: 2	حَيَاةِ الْبَيِّنَةِ
u'حَيَاةٌ جَسَدٌ':Added, #2: 2	حَيَاةٍ بَيِّنَةٍ
u'حَيَاةٌ جَسَدٌ':Added, #1: 1	حَيَاةَ جَسَدِهِ
u'حَيَاةٌ جَنِينٌ':Added, #2: 2	حَيَاةُ الْجَسَدِ
u'حَيَاةٌ جَنِينٌ':Added, #1: 1	حَيَاةِ الْجَنِينِ
u'حَيَاةٌ جَنِينٌ':Added, #1: 1	حَيَاةُ جَنِينٍ
u'حَيَاةٌ حاضِرٌ':Added, #1: 1	حَيَاةُ جَنِينِ
u'حَيَاةٌ حَيَوَانٌ':Added, #1: 1	حَيَاةِ الْحَاضِرِ
u'حَيَاةٌ خَلِيفَةٌ':Added, #3: 3	حَيَاةِ الْحَيَوَانِ
u'حَيَاةٌ دَارٌ':Added, #3: 3	حَيَاةِ الْخَلِيفَةِ
u'حَيَاةٌ ذكر':Added, #1: 1	حَيَاةُ الدَّارِ
u'حَيَاةٌ ذكر':Added, #1: 1	حَيَاةَ الذَّكَرِ
u'حَيَاةٌ ذَكَرٌ':Added, #1: 1	حَيَاةِ الذَّكَرِ
u'حَيَاةٌ ذَكَرٌ':Added, #1: 1	حَيَاةَ الذَّكَرِ
u'حَيَاةٌ رَاهِنٌ':Added, #1: 1	حَيَاةِ الذَّكَرِ
u'حَيَاةٌ رَبُّ':Added, #8: 8	حَيَاةِ الرَّاهِنِ
u'حَيَاةٌ رَجُلٌ':Added, #1: 1	حَيَاةِ رَبِّهِ
u'حَيَاةٌ رَسُولٌ':Added, #1: 1	حَيَاةَ الرَّجُلِ
u'حَيَاةٌ رَسُولٌ':Added, #17: 17	حَيَاةِ رَسُولِ
u'حَيَاةٌ رَسُولٌ':Added, #4: 4	حَيَاةِ الرَّسُولِ
u'حَيَاةٌ زَوْجٌ':Added, #4: 4	حَيَاةَ رَسُولِ
u'حَيَاةٌ زَوْجَةٌ':Added, #7: 7	حَيَاةِ الزَّوْجِ
u'حَيَاةٌ زَيْدٌ':Added, #1: 1	حَيَاةِ الزَّوْجَةِ
u'حَيَاةٌ سَيِّدٌ':Added, #2: 2	حَيَاةِ زَيْدٍ
u'حَيَاةٌ سَيِّدٌ':Added, #1: 1	حَيَاةَ سَيِّدِهِ
u'حَيَاةٌ سَيِّدٌ':Added, #26: 26	حَيَاةِ السَّيِّدِ
u'حَيَاةٌ شَاةٌ':Added, #3: 3	حَيَاةِ سَيِّدِهِ
u'حَيَاةٌ شَجَرٌ':Added, #2: 2	حَيَاةُ الشَّاةِ
u'حَيَاةٌ شَخْصٌ':Added, #1: 1	حَيَاةُ الشَّجَرِ
u'حَيَاةٌ شهداء':Added, #1: 1	حَيَاةِ شَخْصٍ
u'حَيَاةٌ شهداء':Added, #1: 1	حَيَاةُ الشُّهَدَاءِ
u'حَيَاةٌ شُهُودٌ':Added, #1: 1	حَيَاةِ الشّهَدَاءِ
u'حَيَاةٌ شُهُودٌ':Added, #1: 1	حَيَاةُ الشُّهُودِ
u'حَيَاةٌ صَاحِبٌ':Added, #1: 1	حَيَاةِ الشُّهُودِ
u'حَيَاةٌ طَالِبٌ':Added, #1: 1	حَيَاةِ صَاحِبِهِ
u'حَيَاةٌ طَبَقَةٌ':Added, #1: 1	حَيَاةِ الطَّالِبِ
u'حَيَاةٌ عَبْدٌ':Added, #1: 1	حَيَاةِ الطَّبَقَةِ
u'حَيَاةٌ عَبْدٌ':Added, #1: 1	حَيَاةِ الْعَبْدَيْنِ
u'حَيَاةٌ عَمٌّ':Added, #1: 1	حَيَاةِ عَبْدِ
u'حَيَاةٌ عَمٌّ':Added, #1: 1	حَيَاةِ عَمّهِ
u'حَيَاةٌ عَيْشٌ':Added, #2: 2	حَيَاةِ الْعَمِّ
u'حَيَاةٌ غَرْسٌ':Added, #1: 1	حَيَاةُ عَيْشِ
u'حَيَاةٌ فَرْخٌ':Added, #1: 1	حَيَاةَ الْغَرْسِ
u'حَيَاةٌ فَرْخٌ':Added, #1: 1	حَيَاةُ الْفَرْخِ
u'حَيَاةٌ قلب':Added, #3: 3	حَيَاةَ الْفَرْخِ
u'حَيَاةٌ قَلْبٌ':Added, #1: 1	حَيَاةُ الْقَلْبِ
u'حَيَاةٌ قَلْب':Added, #1: 1	حَيَاةُ الْقَلْبِ
u'حَيَاةٌ قُلُوبٌ':Added, #1: 1	حَيَاةُ الْقَلْبِ
u'حَيَاةٌ قِيَامَةٌ':Added, #2: 2	حَيَاةُ الْقُلُوبِ
u'حَيَاةٌ مَالِكٌ':Added, #1: 1	حَيَاةَ الْقِيَامَةِ
u'حَيَاةٌ مَالِكٌ':Added, #1: 1	حَيَاةُ الْمَالِكِ
u'حَيَاةٌ مثل':Added, #1: 1	حَيَاةِ الْمَالِكِ
u'حَيَاةٌ مِثْلٌ':Added, #1: 1	حَيَاةَ مِثْلِهِ
u'حَيَاةٌ مَجْنِيٌّ':Added, #1: 1	حَيَاةَ مِثْلِهِ
u'حَيَاةٌ مَجْنِيٌّ':Added, #1: 1	حَيَاةَ الْمَجْنِيِّ
u'حَيَاةٌ مُحَمَّدٌ':Added, #1: 1	حَيَاةِ الْمَجْنِيِّ
u'حَيَاةٌ مَدْيُونٌ':Added, #1: 1	حَيَاةِ مُحَمَّدٍ
u'حَيَاةٌ مَذْبُوحٌ':Added, #3: 3	حَيَاةِ الْمَدْيُونِ
u'حَيَاةٌ مَرِيضٌ':Added, #1: 1	حَيَاةِ الْمَذْبُوحِ
u'حَيَاةٌ مُسْتَأْجِرٌ':Added, #1: 1	حَيَاةِ الْمَرِيضِ
u'حَيَاةٌ مُسْتَقِرٌّ':Added, #1: 1	حَيَاةِ الْمُسْتَأْجِرِ
u'حَيَاةٌ مُسْتَوْدَعٌ':Added, #3: 3	حَيَاةٍ مُسْتَقِرَّةٍ
u'حَيَاةٌ مُشَاهَدٌ':Added, #1: 1	حَيَاةِ الْمُسْتَوْدَعِ
u'حَيَاةٌ مُشَاهَدَةٌ':Added, #1: 1	حَيَاةَ الْمُشَاهَدَةِ
u'حَيَاةٌ مُعْتَقٌ':Added, #1: 1	حَيَاةَ الْمُشَاهَدَةِ
u'حَيَاةٌ مُعْتَقٌ':Added, #1: 1	حَيَاةِ الْمُعْتَقِ
u'حَيَاةٌ مَفْقُودٌ':Added, #1: 1	حَيَاةِ مُعْتَقِهِ
u'حَيَاةٌ مُفْلِسٌ':Added, #1: 1	حَيَاةُ الْمَفْقُودِ
u'حَيَاةٌ مَقْدُودٌ':Added, #2: 2	حَيَاةُ الْمُفْلِسِ
u'حَيَاةٌ مَكْتُوبٌ':Added, #1: 1	حَيَاةُ الْمَقْدُودِ
u'حَيَاةٌ مَنْذُور':Added, #1: 1	حَيَاةِ الْمَكْتُوبِ
u'حَيَاةٌ مُوجِبٌ':Added, #2: 2	حَيَاةِ الْمَنْذُورِ
u'حَيَاةٌ مُوجِبٌ':Added, #1: 1	حَيَاةُ الْمُوجِبِ
u'حَيَاةٌ مُؤَجِّرٌ':Added, #2: 2	حَيَاةِ الْمُوجِبِ
u'حَيَاةٌ مُوَرِّث':Added, #2: 2	حَيَاةِ الْمُؤَجِّرِ
u'حَيَاةٌ مَوْرُوثٌ':Added, #8: 8	حَيَاةِ الْمُوَرِّثِ
u'حَيَاةٌ مَوْقُوفٌ':Added, #2: 2	حَيَاةِ الْمَوْرُوثِ
u'حَيَاةٌ مُوَكِّلٌ':Added, #2: 2	حَيَاةِ الْمَوْقُوفِ
u'حَيَاةٌ ناذِر':Added, #2: 2	حَيَاةِ الْمُوَكِّلِ
u'حَيَاةٌ نَافِعٌ':Added, #1: 1	حَيَاةِ النَّاذِرِ
u'حَيَاةٌ نَبِيٌّ':Added, #1: 1	حَيَاةِ نَافِعٍ
u'حَيَاةٌ نَفْسٌ':Added, #18: 18	حَيَاةِ النَّبِيِّ
u'حَيَاةٌ واحد':Added, #1: 1	حَيَاةُ النَّفْسِ
u'حَيَاةٌ وَاحِدٌ':Added, #1: 1	حَيَاةُ الْوَاحِدِ
u'حَيَاةٌ وَارِثٌ':Added, #1: 1	حَيَاةُ الْوَاحِدِ
u'حَيَاةٌ وَارِثٌ':Added, #1: 1	حَيَاةُ الْوَارِثِ
u'حَيَاةٌ وَاقِفٌ':Added, #3: 3	حَيَاةِ الْوَارِثِ
u'حَيَاةٌ وَالِدٌ':Added, #10: 10	حَيَاةِ الْوَاقِفِ
u'حَيَاةٌ وَالِدٌ':Added, #2: 2	حَيَاةِ الْوَالِدِ
u'حَيَاةٌ وَاهِبٌ':Added, #5: 5	حَيَاةِ وَالِدِهِ
u'حَيَاةٌ وَجْهٌ':Added, #1: 1	حَيَاةِ الْوَاهِبِ
u'حَيَاةٌ ولد':Added, #1: 1	حَيَاةُ الْوَجْهِ
u'حَيَاةٌ وَلَدٌ':Added, #1: 1	حَيَاةَ الْوَلَدِ
u'حَيَاةٌ ولد':Added, #1: 1	حَيَاةَ الْوَلَدِ
u'حَيَاةٌ وَلَدٌ':Added, #1: 1	حَيَاةِ وَلَدِهِ
u'حَيَاةٌ ولد':Added, #1: 1	حَيَاةِ وَلَدِهِ
u'حَيَاةٌ وَلَدٌ':Added, #2: 2	حَيَاةُ الْوَلَدِ
u'حَيَاةٌ ولد':Added, #2: 2	حَيَاةُ الْوَلَدِ
u'حَيَاةٌ وَلَدٌ':Added, #3: 3	حَيَاةِ الْوَلَدِ
u'حِيَالٌ حِصْنٌ':Added, #3: 3	حَيَاةِ الْوَلَدِ
u'حِيَالٌ حَيَاةٌ':Added, #1: 1	حِيَالُ حِصْنٍ
u'حِيَالٌ زَوْجٌ':Added, #1: 1	حِيَالِ الْحَيَاةِ
u'حِيَالٌ عنق':Added, #1: 1	حِيَالِ الزَّوْجِ
u'حِيَالٌ عُنُقٌ':Added, #1: 1	حِيَالَ الْعُنُقِ
u'حِيَالٌ كعبة':Added, #1: 1	حِيَالَ الْعُنُقِ
u'حِيَالٌ كَعْبَةٌ':Added, #1: 1	حِيَالَ الْكَعْبَةِ
u'حَيْدٌ دَليلٌ':Added, #1: 1	حِيَالَ الْكَعْبَةِ
u'حَيْرَةٌ فقهاء':Added, #1: 1	حَيْدِ الدَّلِيلِ
u'حَيْزٌ أرْضٌ':Added, #2: 2	حَيْرَةِ الْفُقَهَاءِ
u'حَيْزٌ عُبُودِيَّةٌ':Added, #4: 4	حَيْزِ أَرْضِ
u'حَيْضٌ الْمَرْأَةُ':Added, #1: 1	حَيْزِ الْعُبُودِيَّةِ
u'حَيْضٌ الْمَرْأَةُ':Added, #1: 1	حَيْضَ الْمَرْأَةِ
u'حَيْضٌ الْمَرْأَةُ':Added, #1: 1	حَيْضِ الْمَرْأَةِ
u'حَيْضٌ بِنْتٌ':Added, #2: 2	حَيْضُ الْمَرْأَةِ
u'حَيْضَةٌ اِسْتِبْراء':Added, #1: 1	حَيْضِ بِنْتِ
u'حَيْضَةٌ اِسْتِبْراء':Added, #1: 1	حَيْضَةُ اسْتِبْرَاءٍ
u'حَيْضَةٌ أُمٌّ':Added, #2: 2	حَيْضَةِ اسْتِبْرَاءٍ
u'حَيْضَةٌ ثَالِثٌ':Added, #1: 1	حَيْضَةُ أُمِّ
u'حَيْضَةٌ رابع':Added, #4: 4	حَيْضَةٍ ثَالِثَةٍ
u'حَيْضَةٌ رَابِعٌ':Added, #2: 2	حَيْضَةٍ رَابِعَةٍ
u'حَيْضَةٌ طَلاَقٌ':Added, #2: 2	حَيْضَةٍ رَابِعَةٍ
u'حَيْضَةٌ كَامِلٌ':Added, #1: 1	حَيْضَةِ الطَّلَاقِ
u'حَيْضَةٌ مُسْتَقْبَلٌ':Added, #2: 2	حَيْضَةٍ كَامِلَةٍ
u'حَيْضَةٌ مُسْتَقْبَلٌ':Added, #1: 1	حَيْضَةِ مُسْتَقْبَلَةٍ
u'حَيْضَةٌ مُلْقاة':Added, #3: 3	حَيْضَةٍ مُسْتَقْبَلَةٍ
u'حَيْضَةٌ واحد':Added, #1: 1	حَيْضَةٍ مُلْقَاةٍ
u'حَيْضَةٌ وَاحِدٌ':Added, #4: 4	حَيْضَةٍ وَاحِدَةٍ
u'حَيْضٌ تَامٌّ':Added, #4: 4	حَيْضَةٍ وَاحِدَةٍ
u'حَيْضٌ جَارِي':Added, #1: 1	حَيْضٍ تَامٍّ
u'حَيْضٌ جَارِيَةٌ':Added, #1: 1	حَيْضِ الْجَارِيَةِ
u'حَيْضٌ خَالٌ':Added, #1: 1	حَيْضِ الْجَارِيَةِ
u'حَيْضٌ صَاحِبٌ':Added, #1: 1	حَيْضٍ خَالٍ
u'حَيْضٌ طَالِبٌ':Added, #1: 1	حَيْضِ صَاحِبَةِ
u'حَيْضٌ عِدَّةٌ':Added, #1: 1	حَيْضُ الطَّالِبَةِ
u'حَيْضٌ عِدَّةٌ':Added, #1: 1	حَيْضُ الْعِدَّةِ
u'حَيْضٌ عَشْرٌ':Added, #1: 1	حَيْضِ الْعِدَّةِ
u'حَيْضٌ مُبْتَدِئٌ':Added, #1: 1	حَيْضَ عَشْرَةِ
u'حَيْضٌ مُبْتَدِئٌ':Added, #1: 1	حَيْضَ الْمُبْتَدِئَةِ
u'حَيْضٌ مُتَجَدِّدٌ':Added, #2: 2	حَيْضِ الْمُبْتَدِئَةِ
u'حَيْضٌ مُسْتَقْبَلٌ':Added, #1: 1	حَيْضٍ مُتَجَدِّدٍ
u'حَيْضٌ مُصَدَّقٌ':Added, #1: 1	حَيْضٍ مُسْتَقْبَلٍ
u'حَيْضٌ مِنْهَاجٌ':Added, #1: 1	حَيْضِ الْمُصَدَّقَةِ
u'حَيْضٌ نِساءٌ':Added, #3: 3	حَيْضِ مِنْهَاجِ
u'حَيْضٌ نِساءٌ':Added, #1: 1	حَيْضُ النِّسَاءِ
u'حَيْضٌ واحد':Added, #1: 1	حَيْضِ النِّسَاءِ
u'حَيْضٌ وَاحِدٌ':Added, #1: 1	حَيْضُ وَاحِدَةٍ
u'حَيْضٌ وَعِيدٌ':Added, #1: 1	حَيْضُ وَاحِدَةٍ
u'حَيْلُولَةٌ حاكِمٌ':Added, #1: 1	حَيْضٍ وَعِيدٍ
u'حَيْلُولَةٌ خُفٌّ':Added, #1: 1	حَيْلُولَةِ الْحَاكِمِ
u'حَيْلُولَةٌ شَارِعٌ':Added, #1: 1	حَيْلُولَةِ الْخُفِّ
u'حَيْلُولَةٌ شَارِعٌ':Added, #1: 1	حَيْلُولَةُ الشَّارِعِ
u'حَيْلُولَةٌ ظلمة':Added, #1: 1	حَيْلُولَةِ الشَّارِعِ
u'حَيْلُولَةٌ ظُلْمَةٌ':Added, #1: 1	حَيْلُولَةَ الظُّلْمَةِ
u'حَيْلُولَةٌ نَحْوٌ':Added, #1: 1	حَيْلُولَةَ الظُّلْمَةِ
u'حَيْلُولَةٌ نَهْرٌ':Added, #1: 1	حَيْلُولَةِ نَحْوِ
u'حَيِيَ أرْضٌ':Predicate, #1: 1	حَيْلُولَةِ النَّهْرِ
u'حَيِيَ أَكْثَرُ':Predicate, #1: 1	أَحْيَا الْأَرْضَ
u'حَيِيَ أَمْرٌ':Predicate, #1: 1	أَحْيَا الْأَكْثَرَ
u'حَيِيَ بَعْضٌ':Predicate, #1: 1	أَحْيَا أَمْرَ
u'حَيِيَ بَعْضٌ':Subject, #1: 1	أَحْيَا بَعْضَ
u'حَيِيَ جَوَانِبُ':Predicate, #1: 1	حَيِيَ بَعْضُ
u'حَيِيَ خُمُسٌ':Predicate, #1: 1	أَحْيَا الْجَوَانِبَ
u'حَيِيَ سَاقِي':Predicate, #1: 1	أَحْيَا خُمُسَ
u'حَيِيَ سُفْلٌ':Predicate, #1: 1	أَحْيَا سَاقِيَةً
u'حَيِيَ شَهَادَةٌ':Predicate, #1: 1	أَحْيَا السُّفْلَ
u'حَيِيَ غير':Predicate, #1: 1	أَحْيَا الشَّهَادَةَ
u'حَيِيَ غَيْرٌ':Predicate, #2: 2	أَحْيَا غَيْرَ
u'حَيِيَ قَتِيلٌ':Predicate, #2: 2	أَحْيَا غَيْرَ
u'حَيِيَ لَيْلٌ':Predicate, #1: 1	أَحْيَا قَتِيلَ
u'حَيِيَ لَيْلٌ':Predicate, #1: 1	أَحْيَا لَيْلَةَ
u'حَيِيَ مثل':Subject, #4: 4	أَحْيَا اللَّيْلَ
u'حَيِيَ مِثْلٌ':Subject, #1: 1	حَيِيَ مِثْلُهُ
u'حَيِيَ نَاسٌ':Predicate, #1: 1	حَيِيَ مِثْلُهُ
u'حَيِيَ نَفْسٌ':Predicate, #12: 12	أَحْيَا النَّاسَ
u'خَابَ أَمَلٌ':Subject, #2: 2	أَحْيَا النَّفْسَ
u'خَابَ بَيْنٌ':Predicate, #1: 1	خَابَ أَمَلُهُ
u'خَابَ رَجاء':Subject, #1: 1	خَابَ بَيْنَ
u'خَابَ رَجَاءٌ':Subject, #1: 1	خَابَ رَجَاءٌ
u'خَابَ قَوْمٌ':Subject, #1: 1	خَابَ رَجَاءٌ
u'خَابَ كِتَابٌ':Subject, #2: 2	خَابَ قَوْمٌ
u'خَارَ جِذْعٌ':Subject, #1: 1	خَابَ كِتَابٌ
u'خَاصَمَ اِبْنٌ':Subject, #2: 2	خَارَ الْجِذْعُ
u'خَاصَمَ اِبْنٌ':Subject, #1: 1	خَاصَمَ ابْنٌ
u'خَاصَمَ المُشْتَرِي':Predicate, #1: 1	خَاصَمَ ابْنُ
u'خَاصَمَ أُمٌّ':Predicate, #1: 1	خَاصَمَ الْمُشْتَرِيَ
u'خَاصَمَ بَائِعٌ':Subject, #1: 1	خَاصَمَ أُمَّ
u'خَاصَمَ رَجُلٌ':Subject, #3: 3	خَاصَمَ الْبَائِعُ
u'خَاصَمَ رَجُلٌ':Subject, #1: 1	خَاصَمَ الرَّجُلُ
u'خَاصَمَ زَوْجٌ':Predicate, #5: 5	خَاصَمَ رَجُلٌ
u'خَاصَمَ سُلْطَانٌ':Predicate, #1: 1	خَاصَمَ الزَّوْجَ
u'خَاصَمَ سُلْطَانٌ':Subject, #1: 1	خَاصَمَ السُّلْطَانَ
u'خَاصَمَ شَاهِدٌ':Subject, #1: 1	خَاصَمَ السُّلْطَانُ
u'خَاصَمَ شَخْصٌ':Subject, #1: 1	خَاصَمَ الشَّاهِدُ
u'خَاصَمَ صَاحِبٌ':Subject, #1: 1	خَاصَمَ الشَّخْصُ
u'خَاصَمَ طَالِبٌ':Subject, #1: 1	خَاصَمَ صَاحِبُ
u'خَاصَمَ عُمَرٌ':Subject, #1: 1	خَاصَمَ الطَّالِبُ
u'خَاصَمَ عند':Predicate, #1: 1	خَاصَمَ عُمَرُ
u'خَاصَمَ غَاصِبٌ':Predicate, #2: 2	خَاصَمَ عِنْدَ
u'خَاصَمَ غَاصِبٌ':Subject, #1: 1	خَاصَمَ الْغَاصِبَ
u'خَاصَمَ غَرِيمٌ':Predicate, #1: 1	خَاصَمَ الْغَاصِبُ
u'خَاصَمَ غير':Subject, #2: 2	خَاصَمَ الْغَرِيمَ
u'خَاصَمَ غَيْرٌ':Subject, #1: 1	خَاصَمَ غَيْرُهُ
u'خَاصَمَ فلان':Predicate, #1: 1	خَاصَمَ غَيْرُهُ
u'خَاصَمَ فلان':Subject, #5: 5	خَاصَمَ الزُّبَيْرَ
u'خَاصَمَ قول':Subject, #1: 1	خَاصَمَ الزُّبَيْرُ
u'خَاصَمَ قَوْلٌ':Subject, #1: 1	خَاصَمَ قَوْلُهُ
u'خَاصَمَ كَافِرٌ':Subject, #1: 1	خَاصَمَ قَوْلُهُ
u'خَاصَمَ مَالِكٌ':Subject, #1: 1	خَاصَمَ الْكَافِرُ
u'خَاصَمَ مُحْتَالٌ':Predicate, #1: 1	خَاصَمَ الْمَالِكُ
u'خَاصَمَ مُشْتَرِي':Predicate, #1: 1	خَاصَمَ الْمُحْتَالَ
u'خَاصَمَ مُكْرِهٌ':Predicate, #1: 1	خَاصَمَ الْمُشْتَرِيَ
u'خَاصَمَ مُوَكِّلٌ':Subject, #1: 1	خَاصَمَ الْمُكْرِهَ
u'خَاصَمَ وَجَبٌ':Predicate, #2: 2	خَاصَمَ الْمُوَكِّلُ
u'خَاصَمَ وَكِيلٌ':Subject, #1: 1	خَاصَمَ وَجَبَ
u'خَاصِّيَّةٌ بِدْعَةٌ':Added, #1: 1	خَاصَمَ الْوَكِيلُ
u'خَاصِّيَّةٌ حَبْسٌ':Added, #1: 1	خَاصِّيَّةُ الْبِدْعَةِ
u'خَاصِّيَّةٌ دَمٌ':Added, #1: 1	خَاصِّيَّةَ الْحَبْسِ
u'خَاصِّيَّةٌ شَحْمٌ':Added, #1: 1	خَاصِّيَّةُ الدَّمِ
u'خَاصِّيَّةٌ شَرَابٌ':Added, #2: 2	خَاصِّيَّةِ الشَّحْمِ
u'خَاصِّيَّةٌ شَعِيرٌ':Added, #1: 1	خَاصِّيَّةَ الشَّرَابِ
u'خَاصِّيَّةٌ شَيْءٌ':Added, #1: 1	خَاصِّيَّةُ الشَّعِيرِ
u'خَاصِّيَّةٌ مَاءٌ':Added, #1: 1	خَاصِّيَّةُ الشَّيْءِ
u'خَاصِّيَّةٌ مُحَرَّمٌ':Added, #1: 1	خَاصِّيَّةُ الْمَاءِ
u'خَاصِّيَّةٌ مِلْكٌ':Added, #1: 1	خَاصِّيَّةُ الْمُحَرَّمِ
u'خَاصِّيَّةٌ وُجُوبٌ':Added, #1: 1	خَاصِّيَّةِ الْمِلْكِ
u'خَاضَ رَجُلٌ':Subject, #1: 1	خَاصِّيَّةُ الْوُجُوبِ
u'خَاضَ مَاءٌ':Predicate, #2: 2	خَاضَ الرَّجُلُ
u'خَاضَ مَاءٌ':Predicate, #1: 1	خَاضَ مَاءَ
u'خَاضَ نَهْرٌ':Predicate, #5: 5	خَاضَ الْمَاءَ
u'خَاطَبَ أَجْنَبِيٌّ':Predicate, #2: 2	خَاضَ النَّهْرَ
u'خَاطَبَ أَصَمّ':Predicate, #2: 2	خَاطَبَ الْأَجْنَبِيَّ
u'خَاطَبَ المُشْتَرِي':Predicate, #1: 1	خَاطَبَ أَصَمَّ
u'خَاطَبَ جمع':Predicate, #1: 1	خَاطَبَ الْمُشْتَرِيَ
u'خَاطَبَ جَمْعٌ':Predicate, #1: 1	خَاطَبَ الْجَمْعَ
u'خَاطَبَ حاضِرٌ':Predicate, #1: 1	خَاطَبَ الْجَمْعَ
u'خَاطَبَ رِجَالٌ':Predicate, #1: 1	خَاطَبَ الْحَاضِرَ
u'خَاطَبَ زَوْجٌ':Predicate, #1: 1	خَاطَبَ الرِّجَالَ
u'خَاطَبَ زَوْجٌ':Subject, #1: 1	خَاطَبَ الزَّوْجَ
u'خَاطَبَ صَائِمٌ':Predicate, #1: 1	خَاطَبَ الزَّوْجُ
u'خَاطَبَ صَبِيٌّ':Predicate, #1: 1	خَاطَبَ الصَّائِمِينَ
u'خَاطَبَ صَبِيٌّ':Subject, #1: 1	خَاطَبَ الصَّبِيَّ
u'خَاطَبَ عَبْدٌ':Predicate, #1: 1	خَاطَبَ الصَّبِيُّ
u'خَاطَبَ عَرَبٌ':Predicate, #1: 1	خَاطَبَ الْعَبْدَ
u'خَاطَ بَعْضٌ':Predicate, #1: 1	خَاطَبَ الْعَرَبَ
u'خَاطَ بَعْضٌ':Predicate, #1: 1	خَاطَ الْبَعْضَ
u'خَاطَبَ غير':Predicate, #1: 1	خَاطَ بَعْضَ
u'خَاطَبَ غَيْرٌ':Predicate, #1: 1	خَاطَبَ غَيْرَ
u'خَاطَبَ مُشْتَرِي':Predicate, #1: 1	خَاطَبَ غَيْرَ
u'خَاطَبَ مُؤْمِنٌ':Predicate, #1: 1	خَاطَبَ الْمُشْتَرِيَ
u'خَاطَبَ نَاسٌ':Predicate, #2: 2	خَاطَبَ الْمُؤْمِنِينَ
u'خَاطَبَ واحد':Predicate, #1: 1	خَاطَبَ النَّاسَ
u'خَاطَبَ وَاحِدٌ':Predicate, #1: 1	خَاطَبَ الْوَاحِدَ
u'خَاطَ ثَوْبٌ':Predicate, #1: 1	خَاطَبَ الْوَاحِدَ
u'خَاطَ ثَوْبٌ':Predicate, #1: 1	خَاطَ الثَّوْبَ
u'خَاطَرَ أقَلُّ':Predicate, #3: 3	خَاطَ ثَوْبَ
u'خَاطَرَ أقَلُّ':Subject, #1: 1	خَاطَرَ أَقَلَّ
u'خَاطَ سَرَاوِيلُ':Predicate, #1: 1	خَاطَرَ أَقَلُّ
u'خَاطَ فُلاَنٌ':Subject, #1: 1	خَاطَ سَرَاوِيلَ
u'خَاطَ مَبِيعٌ':Predicate, #2: 2	خَاطَ فُلَانٌ
u'خَاطَ نِصْفٌ':Predicate, #1: 1	خَاطَ الْمَبِيعَ
u'خَافَ اِبْنٌ':Subject, #3: 3	خَاطَ نِصْفَ
u'خَافَ أَجْنَبِيٌّ':Subject, #1: 1	خَافَ ابْنُ
u'خَافَ إمَامٌ':Subject, #1: 1	خَافَ الْأَجْنَبِيُّ
u'خَافَ أَمْرَد':Subject, #3: 3	خَافَ الْإِمَامُ
u'خَافَ اِنْتِشارٌ':Predicate, #1: 1	خَافَ الْأَمْرَدُ
u'خَافَ إِنْسانٌ':Subject, #1: 1	خَافَ انْتِشَارَ
u'خَافَ أهْلٌ':Predicate, #1: 1	خَافَ الْإِنْسَانُ
u'خَافَ أهْلٌ':Subject, #4: 4	أَخَافَ أَهْلَ
u'خَافَ تَعَطُّلٌ':Predicate, #2: 2	خَافَ أَهْلُ
u'خَافَ تَلَف':Predicate, #1: 1	خَافَ تَعَطُّلَ
u'خَافَ تَلَفٌ':Predicate, #16: 16	خَافَ التَّلَفَ
u'خَافَ تَلَوُّثٌ':Predicate, #1: 1	خَافَ تَلَفَ
u'خَافَ تَنجُّسٌ':Predicate, #2: 2	خَافَ التَّلَوُّثَ
u'خَافَ تُهْمَةٌ':Predicate, #1: 1	خَافَ تَنَجُّسَ
u'خَافَ ثَوَرَانٌ':Predicate, #1: 1	خَافَ تُهْمَةَ
u'خَافَ جَارٌ':Subject, #1: 1	خَافَ ثَوَرَانَ
u'خَافَ جَوْرٌ':Predicate, #1: 1	خَافَ جَارُهُ
u'خَافَ حاجَةٌ':Predicate, #3: 3	خَافَ الْجَوْرَ
u'خَافَ حاكِمٌ':Subject, #2: 2	خَافَ الْحَاجَةَ
u'خَافَ حُدوثٌ':Predicate, #1: 1	خَافَ الْحَاكِمُ
u'خَافَ حَشاً':Subject, #1: 1	خَافَ حُدُوثَ
u'خَافَ حيفٌ':Predicate, #1: 1	خَافَ حَشَاهُ
u'خَافَ حَيْفٌ':Predicate, #2: 2	خَافَ الْحَيْفَ
u'خَافَ خَائِنٌ':Subject, #2: 2	خَافَ الْحَيْفَ
u'خَافَ خُرُوجٌ':Predicate, #1: 1	خَافَ الْخَائِنُ
u'خَافَ خُرُوجٌ':Predicate, #1: 1	خَافَ الْخُرُوجَ
u'خَافَ خَصْمٌ':Subject, #8: 8	خَافَ خُرُوجَ
u'خَافَ دَخَلٌ':Predicate, #1: 1	خَافَ خَصْمُ
u'خَافَ ذَهَابٌ':Predicate, #1: 1	خَافَ دَخَلَ
u'خَافَ رَاهِنٌ':Subject, #2: 2	خَافَ ذَهَابَ
u'خَافَ رَبُّ':Subject, #1: 1	خَافَ الرَّاهِنُ
u'خَافَ رَجُلٌ':Subject, #1: 1	خَافَ رَبُّ
u'خَافَ رُجُوعٌ':Predicate, #4: 4	خَافَ الرَّجُلُ
u'خَافَ رَسُولٌ':Predicate, #2: 2	خَافَ رُجُوعَ
u'خَافَ رَفْعٌ':Predicate, #4: 4	أَخَافَ رَسُولَ
u'خَافَ رفقة':Predicate, #1: 1	خَافَ رَفْعَ
u'خَافَ رُفْقَةٌ':Predicate, #1: 1	أَخَافَ الرُّفْقَةَ
u'خَافَ رَقيبٌ':Subject, #1: 1	أَخَافَ الرُّفْقَةَ
u'خَافَ زِحامٌ':Predicate, #1: 1	خَافَ رَقِيبُ
u'خَافَ زِيادَةٌ':Predicate, #3: 3	خَافَ الزِّحَامَ
u'خَافَ سَارِقٌ':Predicate, #7: 7	خَافَ زِيَادَةَ
u'خَافَ سَبْقٌ':Predicate, #1: 1	خَافَ السَّارِقَ
u'خَافَ سَبِيلٌ':Predicate, #1: 1	خَافَ سَبْقَ
u'خَافَ سَفَرٌ':Predicate, #3: 3	أَخَافَ السَّبِيلَ
u'خَافَ سُقُوطٌ':Predicate, #1: 1	خَافَ سَفَرَ
u'خَافَ سُلْطَانٌ':Subject, #2: 2	خَافَ سُقُوطَ
u'خَافَ سَلِيمٌ':Subject, #2: 2	خَافَ السُّلْطَانُ
u'خَافَ شَاهِدٌ':Subject, #1: 1	خَافَ السَّلِيمُ
u'خَافَ شَخْصٌ':Subject, #2: 2	خَافَ الشَّاهِدُ
u'خَافَ شَهْوَةٌ':Predicate, #1: 1	خَافَ شَخْصٌ
u'خَافَ صَاحِبٌ':Subject, #5: 5	خَافَ الشَّهْوَةَ
u'خَافَ ضَرَرٌ':Predicate, #1: 1	خَافَ صَاحِبُ
u'خَافَ ضَمَانٌ':Predicate, #6: 6	خَافَ الضَّرَرَ
u'خَافَ ضَيَاعٌ':Predicate, #1: 1	خَافَ الضَّمَانَ
u'خَافَ ضَيَاعٌ':Predicate, #10: 10	خَافَ الضَّيَاعَ
u'خَافَ ضَيْعَةٌ':Predicate, #2: 2	خَافَ ضَيَاعَ
u'خَافَ طَالِبٌ':Subject, #2: 2	خَافَ ضَيْعَةَ
u'خَافَ طَرِيقٌ':Predicate, #2: 2	خَافَ الطَّالِبُ
u'خَافَ طُلُوعٌ':Predicate, #4: 4	أَخَافَ الطَّرِيقَ
u'خَافَ طُولٌ':Predicate, #3: 3	خَافَ طُلُوعَ
u'خَافَ ظُلْمٌ':Predicate, #1: 1	خَافَ طُولَ
u'خَافَ ظلمة':Predicate, #1: 1	خَافَ الظُّلْمَ
u'خَافَ ظُهورٌ':Predicate, #1: 1	خَافَ الظَّلَمَةَ
u'خَافَ عَامِلٌ':Subject, #1: 1	خَافَ ظُهُورَ
u'خَافَ عجز':Predicate, #1: 1	خَافَ الْعَامِلُ
u'خَافَ عَجْزٌ':Predicate, #2: 2	خَافَ الْعَجْزَ
u'خَافَ عجلة':Predicate, #2: 2	خَافَ الْعَجْزَ
u'خَافَ عَجَلَةٌ':Predicate, #2: 2	خَافَ الْعَجَلَةَ
u'خَافَ عَدَمٌ':Predicate, #2: 2	خَافَ الْعَجَلَةَ
u'خَافَ عَدُوٌّ':Predicate, #3: 3	خَافَ عَدَمَ
u'خَافَ عَذَابٌ':Predicate, #1: 1	خَافَ الْعَدُوَّ
u'خَافَ عُزُوبَةٌ':Predicate, #1: 1	خَافَ عَذَابَ
u'خَافَ عَطَشٌ':Predicate, #1: 1	خَافَ الْعُزُوبَةَ
u'خَافَ عَطَشٌ':Predicate, #1: 1	خَافَ عَطَشَ
u'خَافَ علماء':Subject, #2: 2	خَافَ الْعَطَشَ
u'خَافَ عُلَمَاءُ':Subject, #1: 1	خَافَ الْعُلَمَاءُ
u'خَافَ عَوْرَةٌ':Predicate, #1: 1	خَافَ الْعُلَمَاءُ
u'خَافَ غَرِيمٌ':Subject, #1: 1	خَافَ عَوْرَةَ
u'خَافَ غَيْبَةٌ':Predicate, #2: 2	خَافَ غَرِيمُهُ
u'خَافَ فتنة':Predicate, #1: 1	خَافَ الْغَيْبَةَ
u'خَافَ فِتْنَةٌ':Predicate, #1: 1	خَافَ الْفِتْنَةَ
u'خَافَ فساد':Predicate, #1: 1	خَافَ الْفِتْنَةَ
u'خَافَ فَسَادٌ':Predicate, #1: 1	خَافَ الْفَسَادَ
u'خَافَ فساد':Predicate, #1: 1	خَافَ الْفَسَادَ
u'خَافَ فَسَادٌ':Predicate, #2: 2	خَافَ فَسَادَ
u'خَافَ فَوَاتٌ':Predicate, #2: 2	خَافَ فَسَادَ
u'خَافَ فَوَاتٌ':Predicate, #13: 13	خَافَ فَوَاتَ
u'خَافَ فَوْت':Predicate, #7: 7	خَافَ الْفَوَاتَ
u'خَافَ قَاتِلٌ':Subject, #8: 8	خَافَ الْفَوْتَ
u'خَافَ قتل':Predicate, #1: 1	خَافَ الْقَاتِلُ
u'خَافَ قَتْلٌ':Predicate, #1: 1	خَافَ الْقَتْلَ
u'خَافَ قَطْعٌ':Predicate, #1: 1	خَافَ الْقَتْلَ
u'خَافَ قَيِّمٌ':Subject, #2: 2	خَافَ الْقَطْعَ
u'خَافَ كذب':Predicate, #1: 1	خَافَ الْقَيِّمُ
u'خَافَ كَذِبٌ':Predicate, #1: 1	خَافَ الْكَذِبَ
u'خَافَ كَرَاهِيَةٌ':Predicate, #1: 1	خَافَ الْكَذِبَ
u'خَافَ لُصُوصٌ':Predicate, #1: 1	خَافَ كَرَاهِيَةَ
u'خَافَ مَاءٌ':Predicate, #2: 2	خَافَ اللُّصُوصَ
u'خَافَ مَالِكٌ':Subject, #1: 1	خَافَ الْمَاءَ
u'خَافَ مُحْدِثٌ':Subject, #1: 1	خَافَ مَالِكٌ
u'خَافَ مَدِينٌ':Predicate, #1: 1	خَافَ الْمُحْدِثُ
u'خَافَ مَدِينَةٌ':Predicate, #2: 2	أَخَافَ الْمَدِينَةَ
u'خَافَ مَدْيُونٌ':Subject, #2: 2	أَخَافَ الْمَدِينَةَ
u'خَافَ مُرُورٌ':Predicate, #1: 1	خَافَ الْمَدْيُونُ
u'خَافَ مَرِيضٌ':Subject, #1: 1	خَافَ الْمُرُورَ
u'خَافَ مُسَافِرٌ':Subject, #3: 3	خَافَ الْمَرِيضُ
u'خَافَ مَسْبُوق':Subject, #1: 1	خَافَ الْمُسَافِرُ
u'خَافَ مُسْتَأْجِرٌ':Subject, #4: 4	خَافَ الْمَسْبُوقُ
u'خَافَ مَشَقَّةٌ':Predicate, #2: 2	خَافَ الْمُسْتَأْجِرُ
u'خَافَ مُضَارِبٌ':Subject, #1: 1	خَافَ الْمَشَقَّةَ
u'خَافَ مَقَامٌ':Predicate, #1: 1	خَافَ الْمُضَارِبُ
u'خَافَ مَكَانٌ':Predicate, #11: 11	خَافَ مَقَامَ
u'خَافَ مُكْرَهٌ':Subject, #1: 1	خَافَ الْمَكَانَ
u'خَافَ مُلُوكٌ':Predicate, #2: 2	خَافَ الْمُكْرَهُ
u'خَافَ مَوْتٌ':Predicate, #1: 1	أَخَافَ الْمُلُوكَ
u'خَافَ مَوْتٌ':Predicate, #2: 2	خَافَ مَوْتَ
u'خَافَ مُودَعٌ':Subject, #7: 7	خَافَ الْمَوْتَ
u'خَافَ مُودِعٌ':Subject, #1: 1	خَافَ الْمُودَعُ
u'خَافَ نَاسٌ':Subject, #1: 1	خَافَ الْمُودِعُ
u'خَافَ نَاسٌ':Subject, #1: 1	خَافَ النّاسُ
u'خَافَ نَقْضٌ':Predicate, #1: 1	خَافَ النَّاسُ
u'خَافَ هَدْمٌ':Predicate, #1: 1	خَافَ نَقْضَ
u'خَافَ هلاك':Predicate, #2: 2	خَافَ هَدْمَ
u'خَافَ هَلاَكٌ':Predicate, #12: 12	خَافَ الْهَلَاكَ
u'خَافَ هلاك':Predicate, #12: 12	خَافَ الْهَلَاكَ
u'خَافَ هَلاَكٌ':Predicate, #2: 2	خَافَ هَلَاكَ
u'خَافَ هلاك':Subject, #2: 2	خَافَ هَلَاكَ
u'خَافَ هَلاَكٌ':Subject, #1: 1	خَافَ الْهَلَاكُ
u'خَافَ وَاقِفٌ':Subject, #1: 1	خَافَ الْهَلَاكُ
u'خَافَ وَصِيٌّ':Subject, #3: 3	خَافَ الْوَاقِفُ
u'خَافَ وَطْءٌ':Predicate, #3: 3	خَافَ الْوَصِيُّ
u'خَافَ وقاع':Predicate, #1: 1	خَافَ الْوَطْءَ
u'خَافَ وَقْتٌ':Predicate, #1: 1	خَافَ الْوَقَاعَ
u'خَافَ وُقُوعٌ':Predicate, #1: 1	خَافَ الْوَقْتَ
u'خَافَ وُقُوعٌ':Predicate, #1: 1	خَافَ الْوُقُوعَ
u'خَافَ وَلِيٌّ':Subject, #2: 2	خَافَ وُقُوعَ
u'خَالَطَ إِناثٌ':Predicate, #1: 1	خَافَ الْوَلِيُّ
u'خَالَطَ أهْلٌ':Predicate, #1: 1	خَالَطَ الْإِنَاثَ
u'خَالَطَ تُرَابٌ':Predicate, #1: 1	خَالَطَ أَهْلَ
u'خَالَطَ تُرَابٌ':Subject, #1: 1	خَالَطَ التُّرَابَ
u'خَالَطَ جِنْسٌ':Predicate, #1: 1	خَالَطَ التُّرَابُ
u'خَالَطَ دُهْنٌ':Predicate, #1: 1	خَالَطَ الْجِنْسَ
u'خَالَطَ عجم':Subject, #1: 1	خَالَطَ الدُّهْنَ
u'خَالَطَ عَجَمٌ':Subject, #1: 1	خَالَطَ الْعَجَمُ
u'خَالَطَ عُرُوقٌ':Predicate, #1: 1	خَالَطَ الْعَجَمُ
u'خَالَطَ كَلْبٌ':Predicate, #1: 1	خَالَطَ الْعُرُوقَ
u'خَالَطَ لَحْمٌ':Predicate, #1: 1	خَالَطَ كَلْبَكَ
u'خَالَطَ مَاءٌ':Predicate, #1: 1	خَالَطَ اللَّحْمَ
u'خَالَطَ مَاءٌ':Subject, #1: 1	خَالَطَ الْمَاءَ
u'خَالَطَ مَائِعٌ':Subject, #1: 1	خَالَطَ الْمَاءُ
u'خَالَعَ أَبٌ':Subject, #1: 1	خَالَطَ الْمَائِعُ
u'خَالَعَ أَجْنَبِيٌّ':Subject, #2: 2	خَالَعَ الْأَبُ
u'خَالَعَ الْمَرْأَةُ':Predicate, #1: 1	خَالَعَ أَجْنَبِيٌّ
u'خَالَعَ حامِلٌ':Predicate, #1: 1	خَالَعَ الْمَرْأَةَ
u'خَالَعَ حائِضٌ':Predicate, #1: 1	خَالَعَ الْحَامِلَ
u'خَالَعَ زَوْجَةٌ':Predicate, #1: 1	خَالَعَ الْحَائِضَ
u'خَالَعَ سَفِيهٌ':Subject, #2: 2	خَالَعَ الزَّوْجَةَ
u'خَالَعَ سَيِّدٌ':Subject, #1: 1	خَالَعَ السَّفِيهُ
u'خَالَعَ صَغِيرٌ':Predicate, #1: 1	خَالَعَ السَّيِّدُ
u'خَالَعَ فُلاَنٌ':Subject, #1: 1	خَالَعَ الصَّغِيرَةَ
u'خَالَعَ مَرِيضٌ':Subject, #1: 1	خَالَعَ فُلَانُ
u'خَالَعَ مُسْلِمٌ':Subject, #3: 3	خَالَعَ الْمَرِيضُ
u'خَالَعَ مُطَلَّقٌ':Predicate, #1: 1	خَالَعَ الْمُسْلِمُ
u'خَالَعَ وَكِيلٌ':Subject, #1: 1	خَالَعَ الْمُطَلَّقَةَ
u'خَالَعَ وَكِيلٌ':Subject, #1: 1	خَالَعَ وَكِيلُ
u'خَالَعَ يَوْمٌ':Predicate, #1: 1	خَالَعَ وَكِيلُهُ
u'خَالَفَ اِبْنٌ':Predicate, #1: 1	خَالَعَ يَوْمَ
u'خَالَفَ اِبْنٌ':Subject, #1: 1	خَالَفَ ابْنَ
u'خَالَفَ أثَرٌ':Predicate, #10: 10	خَالَفَ ابْنُ
u'خَالَفَ إِجْمَاعٌ':Predicate, #1: 1	خَالَفَ الْأَثَرَ
u'خَالَفَ إِجْمَاعٌ':Predicate, #15: 15	خَالَفَ الْإِجْمَاعَ
u'خَالَفَ آحَادٌ':Predicate, #1: 1	خَالَفَ إجْمَاعَ
u'خَالَفَ آحَادٌ':Subject, #1: 1	خَالَفَ الْآحَادَ
u'خَالَفَ أحَدٌ':Predicate, #1: 1	خَالَفَ الْآحَادُ
u'خَالَفَ أحَدٌ':Subject, #3: 3	خَالَفَ أَحَدَ
u'خَالَفَ آخِرُ':Subject, #1: 1	خَالَفَ أَحَدٌ
u'خَالَفَ إِسْلامٌ':Predicate, #1: 1	خَالَفَ الْآخِرُ
u'خَالَفَ أسْوَد':Subject, #3: 3	خَالَفَ الْإِسْلَامَ
u'خَالَفَ أسْوَد':Subject, #1: 1	خَالَفَ الأَسْوَدُ
u'خَالَفَ أصل':Predicate, #1: 1	خَالَفَ الْأَسْوَدُ
u'خَالَفَ أًصْلٌ':Predicate, #2: 2	خَالَفَ الْأَصْلَ
u'خَالَفَ إِطْلاقٌ':Predicate, #2: 2	خَالَفَ الْأَصْلَ
u'خَالَفَ إِطْلاقٌ':Predicate, #1: 1	خَالَفَ إطْلَاقَ
u'خَالَفَ أفْضَلُ':Predicate, #1: 1	خَالَفَ إِطْلَاقَ
u'خَالَفَ أَقَاوِيلُ':Predicate, #1: 1	خَالَفَ الْأَفْضَلَ
u'خَالَفَ إقْرَارٌ':Subject, #1: 1	خَالَفَ أَقَاوِيلَ
u'خَالَفَ أَكْثَرُ':Predicate, #1: 1	خَالَفَ إقْرَارُهُ
u'خَالَفَ أَكْثَرُ':Predicate, #1: 1	خَالَفَ الْأَكْثَرَ
u'خَالَفَ أَمْرٌ':Predicate, #3: 3	خَالَفَ أَكْثَرَ
u'خَالَفَ آمِرٌ':Predicate, #1: 1	خَالَفَ الْأَمْرَ
u'خَالَفَ أَمْرٌ':Predicate, #2: 2	خَالَفَ الْآمِرَ
u'خَالَفَ أَمْرٌ':Subject, #6: 6	خَالَفَ أَمْرَ
u'خَالَفَ أهْلٌ':Subject, #1: 1	خَالَفَ أَمْرُهُ
u'خَالَفَ أوْثَقُ':Predicate, #1: 1	خَالَفَ أَهْلُ
u'خَالَفَ أَوَّلُ':Predicate, #1: 1	خَالَفَ أَوْثَقَ
u'خَالَفَ بَطَلٌ':Predicate, #1: 1	خَالَفَ الْأَوَّلَ
u'خَالَفَ بَعْضٌ':Subject, #1: 1	خَالَفَ بَطَلَ
u'خَالَفَ بَيْنٌ':Predicate, #1: 1	خَالَفَ الْبَعْضُ
u'خَالَفَ تَرْتِيبٌ':Predicate, #8: 8	خَالَفَ بَيْنَ
u'خَالَفَ تَسْعِيرٌ':Predicate, #3: 3	خَالَفَ التَّرْتِيبَ
u'خَالَفَ تَعْلِيقٌ':Predicate, #1: 1	خَالَفَ تَسْعِيرَ
u'خَالَفَ تَفْصِيلٌ':Predicate, #1: 1	خَالَفَ التَّعْلِيقَ
u'خَالَفَ ثِيابٌ':Predicate, #1: 1	خَالَفَ التَّفْصِيلَ
u'خَالَفَ جَازٌ':Predicate, #1: 1	خَالَفَ ثِيَابَ
u'خَالَفَ جَائِزٌ':Predicate, #1: 1	خَالَفَ جَازَ
u'خَالَفَ جَرِيرٌ':Subject, #1: 1	خَالَفَ الْجَائِزَ
u'خَالَفَ جَمَاعَةٌ':Predicate, #1: 1	خَالَفَ جَرِيرٌ
u'خَالَفَ جَمَاعَةٌ':Subject, #5: 5	خَالَفَ الْجَمَاعَةَ
u'خَالَفَ جَمَاعَةٌ':Subject, #1: 1	خَالَفَ الْجَمَاعَةُ
u'خَالَفَ جمعة':Predicate, #2: 2	خَالَفَ جَمَاعَةٌ
u'خَالَفَ جُمُعَةٌ':Predicate, #1: 1	خَالَفَ الْجُمُعَةَ
u'خَالَفَ حَجٌّ':Predicate, #1: 1	خَالَفَ الْجُمُعَةَ
u'خَالَفَ حَديثٌ':Predicate, #1: 1	خَالَفَ الْحَجَّ
u'خَالَفَ حُكْمٌ':Predicate, #2: 2	خَالَفَ الْحَدِيثَ
u'خَالَفَ حُكْمٌ':Predicate, #1: 1	خَالَفَ الْحُكْمَ
u'خَالَفَ حُكْمٌ':Subject, #4: 4	خَالَفَ حُكْمَ
u'خَالَفَ حَنْبَلٌ':Subject, #1: 1	خَالَفَ حُكْمُهُ
u'خَالَفَ خَبَرٌ':Predicate, #1: 1	خَالَفَ حَنْبَلٌ
u'خَالَفَ خَبَر':Predicate, #1: 1	خَالَفَ الْخَبَرَ
u'خَالَفَ خَبَرٌ':Subject, #1: 1	خَالَفَ الْخَبَرَ
u'خَالَفَ خَبَر':Subject, #2: 2	خَالَفَ خَبَرُ
u'خَالَفَ ختان':Subject, #2: 2	خَالَفَ خَبَرُ
u'خَالَفَ خِتَانٌ':Subject, #1: 1	خَالَفَ الْخِتَانُ
u'خَالَفَ خَطِيبٌ':Subject, #1: 1	خَالَفَ الْخِتَانُ
u'خَالَفَ دَاعِي':Predicate, #1: 1	خَالَفَ الْخَطِيبُ
u'خَالَفَ دَلالَةٌ':Predicate, #1: 1	خَالَفَ دَاعِيَةَ
u'خَالَفَ دَليلٌ':Predicate, #1: 1	خَالَفَ دَلَالَةَ
u'خَالَفَ دَيْنٌ':Predicate, #3: 3	خَالَفَ الدَّلِيلَ
u'خَالَفَ دِينٌ':Predicate, #1: 1	خَالَفَ دَيْنَ
u'خَالَفَ دِينٌ':Subject, #2: 2	خَالَفَ دِينَ
u'خَالَفَ رَأْيٌ':Predicate, #1: 1	خَالَفَ دِينُهُ
u'خَالَفَ رَسُولٌ':Predicate, #1: 1	خَالَفَ رَأْيَ
u'خَالَفَ رِوايَةٌ':Predicate, #1: 1	خَالَفَ رَسُولَ
u'خَالَفَ زِيٌّ':Predicate, #1: 1	خَالَفَ رِوَايَةَ
u'خَالَفَ سَائِرٌ':Predicate, #2: 2	خَالَفَ زِيَّ
u'خَالَفَ سِنٌّ':Subject, #1: 1	خَالَفَ سَائِرَ
u'خَالَفَ سُنَّةٌ':Predicate, #4: 4	خَالَفَ سِنُّ
u'خَالَفَ شَارِحٌ':Subject, #21: 21	خَالَفَ السُّنَّةَ
u'خَالَفَ شافِعِيّ':Predicate, #1: 1	خَالَفَ شَارِحُ
u'خَالَفَ شافِعِيّ':Subject, #1: 1	خَالَفَ الشَّافِعِيَّ
u'خَالَفَ شَخْصٌ':Subject, #1: 1	خَالَفَ الشَّافِعِيُّ
u'خَالَفَ شَرْطٌ':Predicate, #1: 1	خَالَفَ الشَّخْصُ
u'خَالَفَ شَرْطٌ':Predicate, #2: 2	خَالَفَ الشَّرْطَ
u'خَالَفَ شَرْعٌ':Predicate, #6: 6	خَالَفَ شَرْطَ
u'خَالَفَ شَيْخٌ':Subject, #4: 4	خَالَفَ الشَّرْعَ
u'خَالَفَ صَاحِبٌ':Subject, #2: 2	خَالَفَ الشَّيْخُ
u'خَالَفَ صَحَابَةٌ':Predicate, #2: 2	خَالَفَ صَاحِبُ
u'خَالَفَ صَحَابَةٌ':Subject, #1: 1	خَالَفَ الصَّحَابَةَ
u'خَالَفَ صِفَةٌ':Predicate, #2: 2	خَالَفَ الصَّحَابَةُ
u'خَالَفَ صَوَابٌ':Predicate, #1: 1	خَالَفَ الصِّفَةَ
u'خَالَفَ ضَمِنٌ':Predicate, #1: 1	خَالَفَ الصَّوَابَ
u'خَالَفَ طَرِيقٌ':Predicate, #3: 3	خَالَفَ ضَمِنَ
u'خَالَفَ طَرِيقَةٌ':Predicate, #1: 1	خَالَفَ الطَّرِيقَ
u'خَالَفَ ظاهِرٌ':Predicate, #1: 1	خَالَفَ طَرِيقَةَ
u'خَالَفَ ظاهِرٌ':Predicate, #1: 1	خَالَفَ الظَّاهِرَ
u'خَالَفَ ظَنٌّ':Predicate, #7: 7	خَالَفَ ظَاهِرَ
u'خَالَفَ عَادٌ':Predicate, #1: 1	خَالَفَ ظَنَّ
u'خَالَفَ عَادَةٌ':Predicate, #1: 1	خَالَفَ عَادَ
u'خَالَفَ عَامِلٌ':Subject, #9: 9	خَالَفَ الْعَادَةَ
u'خَالَفَ عَجْوَةٌ':Predicate, #1: 1	خَالَفَ الْعَامِلُ
u'خَالَفَ عِراقِيّ':Predicate, #1: 1	خَالَفَ الْعَجْوَةَ
u'خَالَفَ عَرَبٌ':Predicate, #1: 1	خَالَفَ الْعِرَاقِيِّينَ
u'خَالَفَ عرف':Predicate, #1: 1	خَالَفَ الْعَرَبَ
u'خَالَفَ عُرْفٌ':Predicate, #1: 1	خَالَفَ الْعُرْفَ
u'خَالَفَ عرف':Predicate, #1: 1	خَالَفَ الْعُرْفَ
u'خَالَفَ عُرْفٌ':Predicate, #1: 1	خَالَفَ عُرْفَ
u'خَالَفَ علماء':Predicate, #1: 1	خَالَفَ عُرْفَ
u'خَالَفَ عُلَمَاءُ':Predicate, #1: 1	خَالَفَ عُلَمَاءَ
u'خَالَفَ عَلِيٌّ':Subject, #1: 1	خَالَفَ عُلَمَاءَ
u'خَالَفَ عُمَارَةٌ':Subject, #1: 1	خَالَفَ عَلِيٌّ
u'خَالَفَ عَمَلٌ':Predicate, #1: 1	خَالَفَ عُمَارَةُ
u'خَالَفَ عند':Predicate, #1: 1	خَالَفَ الْعَمَلَ
u'خَالَفَ فقهاء':Predicate, #1: 1	خَالَفَ عِنْدَ
u'خَالَفَ فلان':Predicate, #2: 2	خَالَفَ الْفُقَهَاءَ
u'خَالَفَ فلان':Predicate, #1: 1	خَالَفَ الرَّازِيَّ
u'خَالَفَ فلان':Subject, #1: 1	خَالَفَ الشَّافِعِيَّ
u'خَالَفَ فلان':Subject, #1: 1	خَالَفَ التِّرْمِذِيُّ
u'خَالَفَ فلان':Subject, #1: 1	خَالَفَ الزُّبَيْرُ
u'خَالَفَ قَاطِعٌ':Predicate, #1: 1	خَالَفَ الشَّافِعِيُّ
u'خَالَفَ قَاعِدٌ':Predicate, #1: 1	خَالَفَ الْقَاطِعَ
u'خَالَفَ قِبْلَةٌ':Predicate, #2: 2	خَالَفَ قَاعِدَةَ
u'خَالَفَ قتل':Predicate, #1: 1	خَالَفَ الْقِبْلَةَ
u'خَالَفَ قُرْآنٌ':Predicate, #1: 1	خَالَفَ قُتِلَ
u'خَالَفَ قَوَاطِعُ':Predicate, #2: 2	خَالَفَ الْقُرْآنَ
u'خَالَفَ قَوَاعِدُ':Predicate, #1: 1	خَالَفَ الْقَوَاطِعَ
u'خَالَفَ قَوَاعِدُ':Predicate, #1: 1	خَالَفَ قَوَاعِدَ
u'خَالَفَ قول':Predicate, #3: 3	خَالَفَ الْقَوَاعِدَ
u'خَالَفَ قَوْلٌ':Predicate, #2: 2	خَالَفَ قَوْلَ
u'خَالَفَ قول':Subject, #2: 2	خَالَفَ قَوْلَ
u'خَالَفَ قَوْلٌ':Subject, #2: 2	خَالَفَ قَوْلُهُ
u'خَالَفَ قِيَاسٌ':Predicate, #2: 2	خَالَفَ قَوْلُهُ
u'خَالَفَ قِيَاسٌ':Predicate, #13: 13	خَالَفَ الْقِيَاسَ
u'خَالَفَ قَيْدٌ':Predicate, #1: 1	خَالَفَ قِيَاسَ
u'خَالَفَ كِتَابٌ':Predicate, #1: 1	خَالَفَ الْقَيْدَ
u'خَالَفَ كِتَابٌ':Predicate, #2: 2	خَالَفَ كِتَابَ
u'خَالَفَ كُتُبٌ':Predicate, #3: 3	خَالَفَ الْكِتَابَ
u'خَالَفَ كَلاَمٌ':Subject, #1: 1	خَالَفَ الْكُتُبَ
u'خَالَفَ لُغَةٌ':Predicate, #1: 1	خَالَفَ كَلَامُهُ
u'خَالَفَ لَفْظٌ':Subject, #1: 1	خَالَفَ اللُّغَةَ
u'خَالَفَ مَأْمُورٌ':Predicate, #1: 1	خَالَفَ اللَّفْظُ
u'خَالَفَ مُحَمَّدٌ':Predicate, #1: 1	خَالَفَ الْمَأْمُورَ
u'خَالَفَ مَذَاهِبُ':Predicate, #1: 1	خَالَفَ مُحَمّدَ
u'خَالَفَ مَذْكُورٌ':Predicate, #3: 3	خَالَفَ الْمَذَاهِبَ
u'خَالَفَ مَذْهَبٌ':Predicate, #1: 1	خَالَفَ الْمَذْكُورَ
u'خَالَفَ مَذْهَبٌ':Predicate, #1: 1	خَالَفَ الْمَذْهَبَ
u'خَالَفَ مُرْتَدٌّ':Predicate, #2: 2	خَالَفَ مَذْهَبَ
u'خَالَفَ مُسْتَحَبٌّ':Predicate, #1: 1	خَالَفَ الْمُرْتَدَّ
u'خَالَفَ مُسَطَّرٌ':Predicate, #1: 1	خَالَفَ الْمُسْتَحَبَّ
u'خَالَفَ مَصَالِحُ':Predicate, #1: 1	خَالَفَ الْمُسَطَّرَ
u'خَالَفَ مُصْحَفٌ':Predicate, #1: 1	خَالَفَ الْمَصَالِحَ
u'خَالَفَ مُصْطَلَحٌ':Predicate, #2: 2	خَالَفَ الْمُصْحَفَ
u'خَالَفَ مُضَارِبٌ':Subject, #1: 1	خَالَفَ الْمُصْطَلَحَ
u'خَالَفَ مَطْلُوبٌ':Predicate, #1: 1	خَالَفَ الْمُضَارِبُ
u'خَالَفَ مَفْهُومٌ':Predicate, #2: 2	خَالَفَ الْمَطْلُوبَ
u'خَالَفَ مَقْصُودٌ':Predicate, #1: 1	خَالَفَ الْمَفْهُومَ
u'خَالَفَ مِلَّةٌ':Predicate, #1: 1	خَالَفَ مَقْصُودَ
u'خَالَفَ مَنْقُولٌ':Predicate, #1: 1	خَالَفَ مِلَّةَ
u'خَالَفَ مَهْرٌ':Subject, #1: 1	خَالَفَ الْمَنْقُولَ
u'خَالَفَ مُوجِبٌ':Subject, #1: 1	خَالَفَ مَهْرُ
u'خَالَفَ نَاسٌ':Predicate, #1: 1	خَالَفَ مُوجِبُهُ
u'خَالَفَ نَصٌّ':Predicate, #3: 3	خَالَفَ النَّاسَ
u'خَالَفَ نَصٌّ':Predicate, #3: 3	خَالَفَ نَصَّ
u'خَالَفَ نَظْمٌ':Predicate, #7: 7	خَالَفَ النَّصَّ
u'خَالَفَ نَهْيٌ':Predicate, #1: 1	خَالَفَ نَظْمَ
u'خَالَفَ نَوَوِيٌّ':Subject, #1: 1	خَالَفَ النَّهْيَ
u'خَالَفَ نِيَّةٌ':Predicate, #1: 1	خَالَفَ النَّوَوِيُّ
u'خَالَفَ وَاجِبٌ':Predicate, #1: 1	خَالَفَ نِيَّةَ
u'خَالَفَ وَاقِعٌ':Predicate, #3: 3	خَالَفَ الْوَاجِبَ
u'خَالَفَ وَضْعٌ':Predicate, #1: 1	خَالَفَ الْوَاقِعَ
u'خَالَفَ وقع':Predicate, #1: 1	خَالَفَ الْوَضْعَ
u'خَالَفَ وَكِيلٌ':Subject, #1: 1	خَالَفَ وَقَعَ
u'خَالَفَ وَكِيلٌ':Subject, #1: 1	خَالَفَ وَكِيلُ
u'خَالَفَ وَهَلٌ':Predicate, #6: 6	خَالَفَ الْوَكِيلُ
u'خَامَرَ عَقْلٌ':Predicate, #1: 1	خَالَفَ وَهَلَكَ
u'خَانَ إمَامٌ':Subject, #14: 14	خَامَرَ الْعَقْلَ
u'خَانَ أمَانَةٌ':Predicate, #1: 1	خَانَ الْإِمَامُ
u'خَانَ دِينٌ':Predicate, #1: 1	خَانَ الْأَمَانَةَ
u'خَانَ رَجْلٌ':Predicate, #1: 1	خَانَ الدِّينَ
u'خَانَ رِجْلٌ':Predicate, #1: 1	خَانَ الرّجْلَ
u'خَانَ رِسَالَةٌ':Predicate, #1: 1	خَانَ الرّجْلَ
u'خَايَرَ بَيْنٌ':Predicate, #4: 4	خَانَ الرِّسَالَةَ
u'خَبَّأَ عَشْرٌ':Predicate, #1: 1	خَايَرَ بَيْنَ
u'خَبَّأَ قراض':Predicate, #1: 1	خَبَّأَ عَشْرَةَ
u'خَبَّأَ كبائر':Predicate, #1: 1	خَبَّأَ الْقِرَاضَ
u'خَبَّأَ لَيْلٌ':Predicate, #1: 1	خَبَّأَ الْكَبَائِرَ
u'خَبُثَ أَسْفَلُ':Subject, #1: 1	خَبَّأَ لَيْلَةَ
u'خَبُثَ ريحٌ':Subject, #2: 2	خَبُثَ أَسْفَلُهُ
u'خَبَّ ثَلاثَةٌ':Predicate, #1: 1	خَبُثَ رِيحُهُ
u'خَبَّ ثَلاثَةٌ':Predicate, #1: 1	خَبَّ ثَلَاثَةَ
u'خَبُثَ مَلِكٌ':Subject, #2: 2	خَبَّ ثَلاَثَةَ
u'خَبَرٌ اِبْتِداءٌ':Added, #1: 1	خَبُثَ الْمَلِكُ
u'خَبَر اِبْتِداءٌ':Added, #1: 1	خَبَرُ ابْتِدَاءٍ
u'خَبَرٌ اِبْنٌ':Added, #1: 1	خَبَرُ ابْتِدَاءٍ
u'خَبَر اِبْنٌ':Added, #17: 17	خَبَرُ ابْنِ
u'خَبَرٌ اِبْنٌ':Added, #17: 17	خَبَرُ ابْنِ
u'خَبَر اِبْنٌ':Added, #23: 23	خَبَرِ ابْنِ
u'خَبَرٌ اِبْنٌ':Added, #23: 23	خَبَرِ ابْنِ
u'خَبَر اِبْنٌ':Added, #9: 9	خَبَرَ ابْنِ
u'خَبَرٌ إِثْبَاتٌ':Added, #9: 9	خَبَرَ ابْنِ
u'خَبَرٌ إِثْبَاتٌ':Added, #1: 1	خَبَرُ الْإِثْبَاتِ
u'خَبَر إِثْبَاتٌ':Added, #1: 1	خَبَرِ الْإِثْبَاتِ
u'خَبَر إِثْبَاتٌ':Added, #1: 1	خَبَرُ الْإِثْبَاتِ
u'خَبَرٌ آحَادٌ':Added, #1: 1	خَبَرِ الْإِثْبَاتِ
u'خَبَر آحَادٌ':Added, #1: 1	خَبَرُ آحَادٍ
u'خَبَرٌ آحَادٌ':Added, #1: 1	خَبَرُ آحَادٍ
u'خَبَر آحَادٌ':Added, #2: 2	خَبَرُ الْآحَادِ
u'خَبَرٌ آحَادٌ':Added, #2: 2	خَبَرُ الْآحَادِ
u'خَبَر آحَادٌ':Added, #4: 4	خَبَرِ الْآحَادِ
u'خَبَرٌ أحَدٌ':Added, #4: 4	خَبَرِ الْآحَادِ
u'خَبَر أحَدٌ':Added, #1: 1	خَبَرِ أَحَدٍ
u'خَبَرٌ إِحْيَاءٌ':Added, #1: 1	خَبَرِ أَحَدٍ
u'خَبَر إِحْيَاءٌ':Added, #1: 1	خَبَرِ إحْيَاءِ
u'خَبَرٌ إِخْفَاءٌ':Added, #1: 1	خَبَرِ إحْيَاءِ
u'خَبَر إِخْفَاءٌ':Added, #1: 1	خَبَرُ الْإِخْفَاءِ
u'خَبَرَ آدَمُ':Predicate, #1: 1	خَبَرُ الْإِخْفَاءِ
u'خَبَرٌ أَذَانٌ':Added, #1: 1	خَبَرَ آدَمَ
u'خَبَر أَذَانٌ':Added, #1: 1	خَبَرُ الْأَذَانِ
u'خَبَرٌ أَرْبَعَةٌ':Added, #1: 1	خَبَرُ الْأَذَانِ
u'خَبَر أَرْبَعَةٌ':Added, #1: 1	خَبَرَ أَرْبَعَةٍ
u'خَبَرٌ أَرْبَعَةٌ':Added, #1: 1	خَبَرَ أَرْبَعَةٍ
u'خَبَر أَرْبَعَةٌ':Added, #2: 2	خَبَرُ الْأَرْبَعَةِ
u'خَبِرَ أرْضٌ':Predicate, #2: 2	خَبَرُ الْأَرْبَعَةِ
u'خَبَرٌ اِسْتِبْعَادٌ':Added, #1: 1	خَبِرَ الْأَرْضَ
u'خَبَر اِسْتِبْعَادٌ':Added, #1: 1	خَبَرُ اسْتِبْعَادٍ
u'خَبَرٌ اِسْتِدْلاَلٌ':Added, #1: 1	خَبَرُ اسْتِبْعَادٍ
u'خَبَر اِسْتِدْلاَلٌ':Added, #1: 1	خَبَرُ اسْتِدْلَالِ
u'خَبَرٌ إِسْراءٌ':Added, #1: 1	خَبَرُ اسْتِدْلَالِ
u'خَبَر إِسْراءٌ':Added, #2: 2	خَبَرِ الْإِسْرَاءِ
u'خَبَرٌ إِسْلامٌ':Added, #2: 2	خَبَرِ الْإِسْرَاءِ
u'خَبَرٌ إِسْلامٌ':Added, #1: 1	خَبَرُ إسْلَامِ
u'خَبَر إِسْلامٌ':Added, #1: 1	خَبَرِ إسْلَامِ
u'خَبَر إِسْلامٌ':Added, #1: 1	خَبَرُ إسْلَامِ
u'خَبَرٌ إِسْلامٌ':Added, #1: 1	خَبَرِ إسْلَامِ
u'خَبَر إِسْلامٌ':Added, #1: 1	خَبَرَ إسْلَامِهِ
u'خَبَرٌ إشارَة':Added, #1: 1	خَبَرَ إسْلَامِهِ
u'خَبَر إشارَة':Added, #1: 1	خَبَرُ الْإِشَارَةِ
u'خَبَرٌ إِصْلاحٌ':Added, #1: 1	خَبَرُ الْإِشَارَةِ
u'خَبَر إِصْلاحٌ':Added, #1: 1	خَبَرُ إصْلَاحٍ
u'خَبَرٌ أُصولٌ':Added, #1: 1	خَبَرُ إصْلَاحٍ
u'خَبَر أُصولٌ':Added, #1: 1	خَبَرِ الْأُصُولِ
u'خَبَرٌ أعْرَابِيٌّ':Added, #1: 1	خَبَرِ الْأُصُولِ
u'خَبَر أعْرَابِيٌّ':Added, #1: 1	خَبَرُ الْأَعْرَابِيِّ
u'خَبَرٌ إفْكٌ':Added, #1: 1	خَبَرُ الْأَعْرَابِيِّ
u'خَبَر إفْكٌ':Added, #1: 1	خَبَرُ الْإِفْكِ
u'خَبَرٌ إقْرَارٌ':Added, #1: 1	خَبَرُ الْإِفْكِ
u'خَبَر إقْرَارٌ':Added, #1: 1	خَبَرُ الْإِقْرَارِ
u'خَبَرٌ أكْبَرُ':Added, #1: 1	خَبَرُ الْإِقْرَارِ
u'خَبَر أكْبَرُ':Added, #1: 1	خَبَرُ الْأَكْبَرِ
u'خَبَرٌ الْمَرْأَةُ':Added, #1: 1	خَبَرُ الْأَكْبَرِ
u'خَبَر الْمَرْأَةُ':Added, #1: 1	خَبَرِ الْمَرْأَةِ
u'خَبَرٌ الْمَرْأَةُ':Added, #1: 1	خَبَرِ الْمَرْأَةِ
u'خَبَر الْمَرْأَةُ':Added, #3: 3	خَبَرُ الْمَرْأَةِ
u'خَبَرٌ أُمٌّ':Added, #3: 3	خَبَرُ الْمَرْأَةِ
u'خَبَر أُمٌّ':Added, #2: 2	خَبَرِ أُمِّ
u'خَبَرٌ إمَامٌ':Added, #2: 2	خَبَرِ أُمِّ
u'خَبَر إمَامٌ':Added, #1: 1	خَبَرُ الْإِمَامِ
u'خَبَرٌ أَمْرٌ':Added, #1: 1	خَبَرُ الْإِمَامِ
u'خَبَرٌ أَمْرٌ':Added, #1: 1	خَبَرَ الْأَمْرِ
u'خَبَر أَمْرٌ':Added, #1: 1	خَبَرِ الْأَمْرِ
u'خَبَر أَمْرٌ':Added, #1: 1	خَبَرَ الْأَمْرِ
u'خَبَرٌ أَمْرٌ':Added, #1: 1	خَبَرِ الْأَمْرِ
u'خَبَر أَمْرٌ':Added, #1: 1	خَبَرَ أَمْرِ
u'خَبَرٌ اِنْفِصالٌ':Added, #1: 1	خَبَرَ أَمْرِ
u'خَبَر اِنْفِصالٌ':Added, #1: 1	خَبَرُ انْفِصَالٍ
u'خَبَرٌ إنْهَاءٌ':Added, #1: 1	خَبَرُ انْفِصَالٍ
u'خَبَر إنْهَاءٌ':Added, #1: 1	خَبَرِ الْإِنْهَاءِ
u'خَبَرٌ إنْهَاءٌ':Added, #1: 1	خَبَرِ الْإِنْهَاءِ
u'خَبَر إنْهَاءٌ':Added, #2: 2	خَبَرَ الْإِنْهَاءِ
u'خَبَرٌ أَوْسَاقٌ':Added, #2: 2	خَبَرَ الْإِنْهَاءِ
u'خَبَر أَوْسَاقٌ':Added, #1: 1	خَبَرَ الْأَوْسَاقِ
u'خَبَرٌ أَوَّلُ':Added, #1: 1	خَبَرَ الْأَوْسَاقِ
u'خَبَر أَوَّلُ':Added, #1: 1	خَبَرُ الْأَوَّلِ
u'خَبَرٌ أَوَّلُ':Added, #1: 1	خَبَرُ الْأَوَّلِ
u'خَبَر أَوَّلُ':Added, #1: 1	خَبَرِ أَوَّلِهِ
u'خَبَرٌ إِيجَابٌ':Added, #1: 1	خَبَرِ أَوَّلِهِ
u'خَبَر إِيجَابٌ':Added, #1: 1	خَبَرُ إيجَابِ
u'خَبَرٌ بُخَارِيٌّ':Added, #1: 1	خَبَرُ إيجَابِ
u'خَبَر بُخَارِيٌّ':Added, #11: 11	خَبَرُ الْبُخَارِيِّ
u'خَبَرٌ بُخَارِيٌّ':Added, #11: 11	خَبَرُ الْبُخَارِيِّ
u'خَبَر بُخَارِيٌّ':Added, #12: 12	خَبَرِ الْبُخَارِيِّ
u'خَبَرٌ بُخَارِيٌّ':Added, #12: 12	خَبَرِ الْبُخَارِيِّ
u'خَبَر بُخَارِيٌّ':Added, #1: 1	خَبَرَ الْبُخَارِيِّ
u'خَبَرٌ بَدْرٌ':Added, #1: 1	خَبَرَ الْبُخَارِيِّ
u'خَبَر بَدْرٌ':Added, #1: 1	خَبَرِ بَدْرٍ
u'خَبَرٌ براءٌ':Added, #1: 1	خَبَرِ بَدْرٍ
u'خَبَرٌ براءٌ':Added, #2: 2	خَبَرَ الْبَرَاءِ
u'خَبَر براءٌ':Added, #2: 2	خَبَرِ الْبَرَاءِ
u'خَبَر براءٌ':Added, #2: 2	خَبَرَ الْبَرَاءِ
u'خَبَرٌ بَراءٌ':Added, #2: 2	خَبَرِ الْبَرَاءِ
u'خَبَرٌ بَراءٌ':Added, #2: 2	خَبَرَ الْبَرَاءِ
u'خَبَر بَراءٌ':Added, #2: 2	خَبَرِ الْبَرَاءِ
u'خَبَر بَراءٌ':Added, #2: 2	خَبَرَ الْبَرَاءِ
u'خَبَرٌ بَزَّارٌ':Added, #2: 2	خَبَرِ الْبَرَاءِ
u'خَبَر بَزَّارٌ':Added, #1: 1	خَبَرُ الْبَزَّارِ
u'خَبَرٌ بعوثٌ':Added, #1: 1	خَبَرُ الْبَزَّارِ
u'خَبَر بعوثٌ':Added, #1: 1	خَبَرِ الْبُعُوثِ
u'خَبَرٌ بُنْيانٌ':Added, #1: 1	خَبَرِ الْبُعُوثِ
u'خَبَر بُنْيانٌ':Added, #1: 1	خَبَرِ بُنْيَانِ
u'خَبَرٌ بِئْرٌ':Added, #1: 1	خَبَرِ بُنْيَانِ
u'خَبَر بِئْرٌ':Added, #1: 1	خَبَرُ بِئْرِ
u'خَبَرٌ بَيْعٌ':Added, #1: 1	خَبَرُ بِئْرِ
u'خَبَر بَيْعٌ':Added, #1: 1	خَبَرِ الْبَيْعِ
u'خِبْرَةٌ بَاطن':Added, #1: 1	خَبَرِ الْبَيْعِ
u'خِبْرَةٌ باطِنٌ':Added, #1: 1	خِبْرَةِ الْبَاطِنِ
u'خِبْرَةٌ بَاطن':Added, #1: 1	خِبْرَةِ الْبَاطِنِ
u'خِبْرَةٌ باطِنٌ':Added, #1: 1	خِبْرَةُ بَاطِنِهِ
u'خِبْرَةٌ باطِنٌ':Added, #1: 1	خِبْرَةُ بَاطِنِهِ
u'خِبْرَةٌ مُتَكَلِّمٌ':Added, #3: 3	خِبْرَةٍ بَاطِنَةٍ
u'خَبَرٌ تابُوت':Added, #1: 1	خِبْرَةِ الْمُتَكَلِّمِ
u'خَبَر تابُوت':Added, #1: 1	خَبَرِ التّابُوتِ
u'خَبَرٌ تَأْخِيرٌ':Added, #1: 1	خَبَرِ التّابُوتِ
u'خَبَر تَأْخِيرٌ':Added, #1: 1	خَبَرُ تَأْخِيرِ
u'خَبَرٌ تَحَالُفٌ':Added, #1: 1	خَبَرُ تَأْخِيرِ
u'خَبَر تَحَالُفٌ':Added, #1: 1	خَبَرِ التَّحَالُفِ
u'خَبَرٌ تَحْرِيمٌ':Added, #1: 1	خَبَرِ التَّحَالُفِ
u'خَبَر تَحْرِيمٌ':Added, #1: 1	خَبَرِ التَّحْرِيمِ
u'خَبَرٌ تَحْلِيلٌ':Added, #1: 1	خَبَرِ التَّحْرِيمِ
u'خَبَر تَحْلِيلٌ':Added, #1: 1	خَبَرُ التَّحْلِيلِ
u'خَبَرٌ تَحِيَّةٌ':Added, #1: 1	خَبَرُ التَّحْلِيلِ
u'خَبَر تَحِيَّةٌ':Added, #1: 1	خَبَرُ التَّحِيَّةِ
u'خَبَرٌ تَفْرِيقٌ':Added, #1: 1	خَبَرُ التَّحِيَّةِ
u'خَبَرٌ تَفْرِيقٌ':Added, #1: 1	خَبَرُ التَّفْرِيقِ
u'خَبَر تَفْرِيقٌ':Added, #1: 1	خَبَرِ التَّفْرِيقِ
u'خَبَر تَفْرِيقٌ':Added, #1: 1	خَبَرُ التَّفْرِيقِ
u'خَبَرٌ تَفْضِيلٌ':Added, #1: 1	خَبَرِ التَّفْرِيقِ
u'خَبَر تَفْضِيلٌ':Added, #1: 1	خَبَرُ التَّفْضِيلِ
u'خَبَرٌ تَقْريرٌ':Added, #1: 1	خَبَرُ التَّفْضِيلِ
u'خَبَر تَقْريرٌ':Added, #1: 1	خَبَرُ تَقْرِيرِهِ
u'خَبَرٌ تَكْبيرٌ':Added, #1: 1	خَبَرُ تَقْرِيرِهِ
u'خَبَر تَكْبيرٌ':Added, #1: 1	خَبَرِ التَّكْبِيرِ
u'خَبَرٌ تَمْر':Added, #1: 1	خَبَرِ التَّكْبِيرِ
u'خَبَر تَمْر':Added, #1: 1	خَبَرِ التَّمْرِ
u'خَبَرٌ تَوَاتُرٌ':Added, #1: 1	خَبَرِ التَّمْرِ
u'خَبَرٌ تَوَاتُرٌ':Added, #1: 1	خَبَرَ التَّوَاتُرِ
u'خَبَرٌ تَوَاتُرٌ':Added, #1: 1	خَبَرُ التَّوَاتُرِ
u'خَبَر تَوَاتُرٌ':Added, #1: 1	خَبَرِ التَّوَاتُرِ
u'خَبَر تَوَاتُرٌ':Added, #1: 1	خَبَرَ التَّوَاتُرِ
u'خَبَر تَوَاتُرٌ':Added, #1: 1	خَبَرُ التَّوَاتُرِ
u'خَبَرٌ تَوْبَةٌ':Added, #1: 1	خَبَرِ التَّوَاتُرِ
u'خَبَر تَوْبَةٌ':Added, #1: 1	خَبَرُ تَوْبَةِ
u'خَبَرٌ ثِقَةٌ':Added, #1: 1	خَبَرُ تَوْبَةِ
u'خَبَر ثِقَةٌ':Added, #1: 1	خَبَرُ الثِّقَةِ
u'خَبَرٌ ثِقَةٌ':Added, #1: 1	خَبَرُ الثِّقَةِ
u'خَبَر ثِقَةٌ':Added, #1: 1	خَبَرِ ثِقَةٍ
u'خَبَرٌ ثِقَةٌ':Added, #1: 1	خَبَرِ ثِقَةٍ
u'خَبَر ثِقَةٌ':Added, #3: 3	خَبَرِ الثِّقَةِ
u'خَبَرٌ ثَلاثَةٌ':Added, #3: 3	خَبَرِ الثِّقَةِ
u'خَبَرٌ ثَلاثَةٌ':Added, #1: 1	خَبَرَ الثَّلَاثَةِ
u'خَبَر ثَلاثَةٌ':Added, #1: 1	خَبَرِ الثَّلَاثَةِ
u'خَبَر ثَلاثَةٌ':Added, #1: 1	خَبَرَ الثَّلَاثَةِ
u'خَبَرٌ ثَوْرِيٌّ':Added, #1: 1	خَبَرِ الثَّلَاثَةِ
u'خَبَر ثَوْرِيٌّ':Added, #1: 1	خَبَرِ الثَّوْرِيِّ
u'خَبَرٌ جَابِرٌ':Added, #1: 1	خَبَرِ الثَّوْرِيِّ
u'خَبَر جَابِرٌ':Added, #1: 1	خَبَرِ جَابِرِ
u'خَبَرٌ جَابِرٌ':Added, #1: 1	خَبَرِ جَابِرِ
u'خَبَرٌ جَابِرٌ':Added, #2: 2	خَبَرَ جَابِرٍ
u'خَبَر جَابِرٌ':Added, #2: 2	خَبَرُ جَابِرٍ
u'خَبَر جَابِرٌ':Added, #2: 2	خَبَرَ جَابِرٍ
u'خَبَرٌ جَابِرٌ':Added, #2: 2	خَبَرُ جَابِرٍ
u'خَبَر جَابِرٌ':Added, #6: 6	خَبَرِ جَابِرٍ
u'خَبَرٌ جَارٌ':Added, #6: 6	خَبَرِ جَابِرٍ
u'خَبَر جَارٌ':Added, #1: 1	خَبَرَ جَارِهِ
u'خَبَرٌ جَامِعٌ':Added, #1: 1	خَبَرَ جَارِهِ
u'خَبَر جَامِعٌ':Added, #1: 1	خَبَرٍ جَامِعٍ
u'خَبَرٌ جَديدٌ':Added, #1: 1	خَبَرٍ جَامِعٍ
u'خَبَر جَديدٌ':Added, #1: 1	خَبَرٍ جَدِيدٍ
u'خَبَرٌ جَرِيرٌ':Added, #1: 1	خَبَرٍ جَدِيدٍ
u'خَبَر جَرِيرٌ':Added, #1: 1	خَبَرِ جَرِيرٍ
u'خَبَرٌ جَرِيرٌ':Added, #1: 1	خَبَرِ جَرِيرٍ
u'خَبَر جَرِيرٌ':Added, #2: 2	خَبَرَ جَرِيرٍ
u'خَبَرٌ جَفْنَةٌ':Added, #2: 2	خَبَرَ جَرِيرٍ
u'خَبَر جَفْنَةٌ':Added, #1: 1	خَبَر جَفْنَتِهِ
u'خَبَرٌ جَمَاعَةٌ':Added, #1: 1	خَبَر جَفْنَتِهِ
u'خَبَر جَمَاعَةٌ':Added, #2: 2	خَبَرُ جَمَاعَةٍ
u'خَبَرٌ جَمْعٌ':Added, #2: 2	خَبَرُ جَمَاعَةٍ
u'خَبَر جَمْعٌ':Added, #3: 3	خَبَرُ جَمْعٍ
u'خَبَرٌ جهر':Added, #3: 3	خَبَرُ جَمْعٍ
u'خَبَر جهر':Added, #1: 1	خَبَرُ الْجَهْرِ
u'خَبَرٌ جَهْرٌ':Added, #1: 1	خَبَرُ الْجَهْرِ
u'خَبَر جَهْرٌ':Added, #1: 1	خَبَرُ الْجَهْرِ
u'خَبَرٌ حاكِمٌ':Added, #1: 1	خَبَرُ الْجَهْرِ
u'خَبَر حاكِمٌ':Added, #2: 2	خَبَرِ الْحَاكِمِ
u'خَبَرٌ حاكِمٌ':Added, #2: 2	خَبَرِ الْحَاكِمِ
u'خَبَر حاكِمٌ':Added, #5: 5	خَبَرُ الْحَاكِمِ
u'خَبَرٌ حُرٌّ':Added, #5: 5	خَبَرُ الْحَاكِمِ
u'خَبَر حُرٌّ':Added, #1: 1	خَبَرِ الْحُرِّ
u'خَبَرٌ حُرٌّ':Added, #1: 1	خَبَرِ الْحُرِّ
u'خَبَر حُرٌّ':Added, #1: 1	خَبَرُ الْحُرَّيْنِ
u'خَبَرٌ حَرِيرٌ':Added, #1: 1	خَبَرُ الْحُرَّيْنِ
u'خَبَر حَرِيرٌ':Added, #1: 1	خَبَرَ الْحَرِيرِ
u'خَبَرٌ حُصُول':Added, #1: 1	خَبَرَ الْحَرِيرِ
u'خَبَر حُصُول':Added, #1: 1	خَبَرُ حُصُولٍ
u'خَبَرٌ حِلٌّ':Added, #1: 1	خَبَرُ حُصُولٍ
u'خَبَر حِلٌّ':Added, #1: 1	خَبَرُ الْحِلِّ
u'خَبَرٌ حَمَّادٌ':Added, #1: 1	خَبَرُ الْحِلِّ
u'خَبَر حَمَّادٌ':Added, #1: 1	خَبَرُ حَمَّادِ
u'خَبَرٌ حَمَاسٌ':Added, #1: 1	خَبَرُ حَمَّادِ
u'خَبَر حَمَاسٌ':Added, #1: 1	خَبَرُ حَمَاسٍ
u'خَبَرٌ خَالِدٌ':Added, #1: 1	خَبَرُ حَمَاسٍ
u'خَبَر خَالِدٌ':Added, #1: 1	خَبَرُ خَالِدٍ
u'خَبَرٌ دِينٌ':Added, #1: 1	خَبَرُ خَالِدٍ
u'خَبَر دِينٌ':Added, #1: 1	خَبَرِ الدِّينِ
u'خَبَرٌ ذكر':Added, #1: 1	خَبَرِ الدِّينِ
u'خَبَرٌ ذكر':Added, #1: 1	خَبَرَ الذِّكْرِ
u'خَبَر ذكر':Added, #1: 1	خَبَرُ الذَّكَرِ
u'خَبَر ذكر':Added, #1: 1	خَبَرَ الذِّكْرِ
u'خَبَرٌ ذَكَرٌ':Added, #1: 1	خَبَرُ الذَّكَرِ
u'خَبَرٌ ذِكْرٌ':Added, #1: 1	خَبَرُ الذَّكَرِ
u'خَبَر ذَكَرٌ':Added, #1: 1	خَبَرَ الذِّكْرِ
u'خَبَر ذِكْرٌ':Added, #1: 1	خَبَرُ الذَّكَرِ
u'خَبَرٌ رَافِعٌ':Added, #1: 1	خَبَرَ الذِّكْرِ
u'خَبَر رَافِعٌ':Added, #1: 1	خَبَرُ رَافِعِ
u'خَبَرٌ رِجَالٌ':Added, #1: 1	خَبَرُ رَافِعِ
u'خَبَر رِجَالٌ':Added, #1: 1	خَبَرِ رِجَالٍ
u'خَبَرٌ رَجُلٌ':Added, #1: 1	خَبَرِ رِجَالٍ
u'خَبَر رَجُلٌ':Added, #1: 1	خَبَرَ الرّجُلِ
u'خَبَرٌ رَجُلٌ':Added, #1: 1	خَبَرَ الرّجُلِ
u'خَبَر رَجُلٌ':Added, #1: 1	خَبَرَ الرّجُلَيْنِ
u'خَبَرٌ رَجُلٌ':Added, #1: 1	خَبَرَ الرّجُلَيْنِ
u'خَبَر رَجُلٌ':Added, #1: 1	خَبَرَ رَجُلٍ
u'خَبَرٌ رَجُلٌ':Added, #1: 1	خَبَرَ رَجُلٍ
u'خَبَر رَجُلٌ':Added, #1: 1	خَبَرِ رَجُلَيْنِ
u'خَبَرٌ رَجُلٌ':Added, #1: 1	خَبَرِ رَجُلَيْنِ
u'خَبَر رَجُلٌ':Added, #2: 2	خَبَرِ الرَّجُلِ
u'خَبَرٌ رَسُولٌ':Added, #2: 2	خَبَرِ الرَّجُلِ
u'خَبَرٌ رَسُولٌ':Added, #1: 1	خَبَرُ الرَّسُولِ
u'خَبَر رَسُولٌ':Added, #1: 1	خَبَرِ الرَّسُولِ
u'خَبَر رَسُولٌ':Added, #1: 1	خَبَرُ الرَّسُولِ
u'خَبَرٌ رَسُولٌ':Added, #1: 1	خَبَرِ الرَّسُولِ
u'خَبَر رَسُولٌ':Added, #2: 2	خَبَرِ رَسُولِ
u'خَبَرٌ رُومٌ':Added, #2: 2	خَبَرِ رَسُولِ
u'خَبَر رُومٌ':Added, #2: 2	خَبَرَ الرُّومِ
u'خَبَرٌ زَيْدٌ':Added, #2: 2	خَبَرَ الرُّومِ
u'خَبَر زَيْدٌ':Added, #1: 1	خَبَرِ زَيْدِ
u'خَبَرٌ زَيْدٌ':Added, #1: 1	خَبَرِ زَيْدِ
u'خَبَر زَيْدٌ':Added, #2: 2	خَبَرِ زَيْدٍ
u'خَبَرٌ سِباعٌ':Added, #2: 2	خَبَرِ زَيْدٍ
u'خَبَر سِباعٌ':Added, #1: 1	خَبَرَ السِّبَاعِ
u'خَبَرٌ سَبْعَةٌ':Added, #1: 1	خَبَرَ السِّبَاعِ
u'خَبَر سَبْعَةٌ':Added, #1: 1	خَبَرِ السَّبْعَةِ
u'خَبَرٌ سِرٌّ':Added, #1: 1	خَبَرِ السَّبْعَةِ
u'خَبَر سِرٌّ':Added, #1: 1	خَبَرَ السِّرِّ
u'خَبَرٌ سِرٌّ':Added, #1: 1	خَبَرَ السِّرِّ
u'خَبَر سِرٌّ':Added, #2: 2	خَبَرُ السِّرِّ
u'خَبَرٌ سِعَايَةٌ':Added, #2: 2	خَبَرُ السِّرِّ
u'خَبَر سِعَايَةٌ':Added, #1: 1	خَبَرِ السِّعَايَةِ
u'خَبَرٌ سَعْدٌ':Added, #1: 1	خَبَرِ السِّعَايَةِ
u'خَبَر سَعْدٌ':Added, #1: 1	خَبَرِ سَعْدِ
u'خَبَرٌ سَمَاءٌ':Added, #1: 1	خَبَرِ سَعْدِ
u'خَبَر سَمَاءٌ':Added, #18: 18	خَبَرِ السَّمَاءِ
u'خَبَرٌ سَمَاءٌ':Added, #18: 18	خَبَرِ السَّمَاءِ
u'خَبَر سَمَاءٌ':Added, #1: 1	خَبَرَ السّمَاءِ
u'خَبَرٌ سَمَاءٌ':Added, #1: 1	خَبَرَ السّمَاءِ
u'خَبَر سَمَاءٌ':Added, #2: 2	خَبَرُ السّمَاءِ
u'خَبَرٌ سَمَاءٌ':Added, #2: 2	خَبَرُ السّمَاءِ
u'خَبَر سَمَاءٌ':Added, #3: 3	خَبَرِ السّمَاءِ
u'خَبَرٌ سَهْلٌ':Added, #3: 3	خَبَرِ السّمَاءِ
u'خَبَرٌ سَهْلٌ':Added, #1: 1	خَبَرٍ سَهْلٍ
u'خَبَر سَهْلٌ':Added, #1: 1	خَبَرَ سَهْلٍ
u'خَبَر سَهْلٌ':Added, #1: 1	خَبَرٍ سَهْلٍ
u'خَبَرٌ سَهْلٌ':Added, #1: 1	خَبَرَ سَهْلٍ
u'خَبَر سَهْلٌ':Added, #2: 2	خَبَرِ سَهْلٍ
u'خَبَرٌ شافِعِيّ':Added, #2: 2	خَبَرِ سَهْلٍ
u'خَبَر شافِعِيّ':Added, #1: 1	خَبَرُ الشَّافِعِيِّ
u'خَبَرٌ شَاهِدٌ':Added, #1: 1	خَبَرُ الشَّافِعِيِّ
u'خَبَر شَاهِدٌ':Added, #1: 1	خَبَرِ الشَّاهِدِ
u'خَبَرٌ شَخْصٌ':Added, #1: 1	خَبَرِ الشَّاهِدِ
u'خَبَر شَخْصٌ':Added, #1: 1	خَبَرَ الشَّخْصِ
u'خَبَرٌ شِرَاءٌ':Added, #1: 1	خَبَرَ الشَّخْصِ
u'خَبَر شِرَاءٌ':Added, #1: 1	خَبَرِ شِرَاءِ
u'خَبَرٌ شَيْخٌ':Added, #1: 1	خَبَرِ شِرَاءِ
u'خَبَر شَيْخٌ':Added, #1: 1	خَبَرِ الشَّيْخَيْنِ
u'خَبَرٌ شَيْخٌ':Added, #1: 1	خَبَرِ الشَّيْخَيْنِ
u'خَبَر شَيْخٌ':Added, #2: 2	خَبَرُ الشَّيْخَيْنِ
u'خَبَرٌ صَاحِبٌ':Added, #2: 2	خَبَرُ الشَّيْخَيْنِ
u'خَبَرٌ صَاحِبٌ':Added, #1: 1	خَبَرَ صَاحِبِ
u'خَبَر صَاحِبٌ':Added, #1: 1	خَبَرِ صَاحِبِ
u'خَبَر صَاحِبٌ':Added, #1: 1	خَبَرَ صَاحِبِ
u'خَبَرٌ صَاحِبٌ':Added, #1: 1	خَبَرِ صَاحِبِ
u'خَبَرٌ صَاحِبٌ':Added, #1: 1	خَبَرَ صَاحِبِهِ
u'خَبَر صَاحِبٌ':Added, #1: 1	خَبَرُ صَاحِبِهِ
u'خَبَر صَاحِبٌ':Added, #1: 1	خَبَرَ صَاحِبِهِ
u'خَبَرٌ صَادِقٌ':Added, #1: 1	خَبَرُ صَاحِبِهِ
u'خَبَر صَادِقٌ':Added, #1: 1	خَبَرُ الصَّادِقِ
u'خَبَرٌ صَادِقٌ':Added, #1: 1	خَبَرُ الصَّادِقِ
u'خَبَر صَادِقٌ':Added, #1: 1	خَبَرِ صَادِقٍ
u'خَبَرٌ صَبِيٌّ':Added, #1: 1	خَبَرِ صَادِقٍ
u'خَبَرٌ صَبِيٌّ':Added, #2: 2	خَبَرُ الصَّبِيِّ
u'خَبَر صَبِيٌّ':Added, #2: 2	خَبَرِ الصَّبِيِّ
u'خَبَر صَبِيٌّ':Added, #2: 2	خَبَرُ الصَّبِيِّ
u'خَبَرٌ صَحِيحٌ':Added, #2: 2	خَبَرِ الصَّبِيِّ
u'خَبَر صَحِيحٌ':Added, #1: 1	خَبَرَ الصَّحِيحَيْنِ
u'خَبَرٌ صَحِيحٌ':Added, #1: 1	خَبَرَ الصَّحِيحَيْنِ
u'خَبَر صَحِيحٌ':Added, #37: 37	خَبَرِ الصَّحِيحَيْنِ
u'خَبَرٌ صَحِيحٌ':Added, #37: 37	خَبَرِ الصَّحِيحَيْنِ
u'خَبَر صَحِيحٌ':Added, #50: 50	خَبَرُ الصَّحِيحَيْنِ
u'خَبَرٌ صَحِيفَةٌ':Added, #50: 50	خَبَرُ الصَّحِيحَيْنِ
u'خَبَر صَحِيفَةٌ':Added, #1: 1	خَبَرُ الصّحِيفَةِ
u'خَبَرٌ صدقة':Added, #1: 1	خَبَرُ الصّحِيفَةِ
u'خَبَر صدقة':Added, #1: 1	خَبَرَ الصَّدَقَةِ
u'خَبَرٌ صَدَقَةٌ':Added, #1: 1	خَبَرَ الصَّدَقَةِ
u'خَبَر صَدَقَةٌ':Added, #1: 1	خَبَرَ الصَّدَقَةِ
u'خَبَرٌ صِدِّيقٌ':Added, #1: 1	خَبَرَ الصَّدَقَةِ
u'خَبَر صِدِّيقٌ':Added, #1: 1	خَبَرِ الصِّدِّيقِ
u'خَبَرَ صَفِيٌّ':Predicate, #1: 1	خَبَرِ الصِّدِّيقِ
u'خَبَرٌ صَلاَةٌ':Added, #1: 1	خَبَرَ صَفِيَّةَ
u'خَبَرٌ صَلاَةٌ':Added, #1: 1	خَبَرَ صَلَاةِ
u'خَبَر صَلاَةٌ':Added, #1: 1	خَبَرُ صَلَاةِ
u'خَبَر صَلاَةٌ':Added, #1: 1	خَبَرَ صَلَاةِ
u'خَبَرٌ صَلاَةٌ':Added, #1: 1	خَبَرُ صَلَاةِ
u'خَبَر صَلاَةٌ':Added, #2: 2	خَبَرِ صَلَاةِ
u'خَبَرٌ ضَابِطٌ':Added, #2: 2	خَبَرِ صَلَاةِ
u'خَبَر ضَابِطٌ':Added, #1: 1	خَبَرَ الضَّابِطِ
u'خَبَرٌ ضِمْنِيٌّ':Added, #1: 1	خَبَرَ الضَّابِطِ
u'خَبَر ضِمْنِيٌّ':Added, #1: 1	خَبَرٍ ضِمْنِيٍّ
u'خَبَرٌ عَارِفٌ':Added, #1: 1	خَبَرٍ ضِمْنِيٍّ
u'خَبَر عَارِفٌ':Added, #1: 1	خَبَرُ عَارِفٍ
u'خَبَرٌ عَامِرٌ':Added, #1: 1	خَبَرُ عَارِفٍ
u'خَبَر عَامِرٌ':Added, #1: 1	خَبَرَ عَامِرِ
u'خَبَرَ عَائِشٌ':Predicate, #1: 1	خَبَرَ عَامِرِ
u'خَبَرٌ عَبْدٌ':Added, #4: 4	خَبَرَ عَائِشَةَ
u'خَبَرٌ عَبْدٌ':Added, #1: 1	خَبَرَ الْعَبْدِ
u'خَبَر عَبْدٌ':Added, #1: 1	خَبَرُ الْعَبْدِ
u'خَبَر عَبْدٌ':Added, #1: 1	خَبَرَ الْعَبْدِ
u'خَبَرٌ عَبْدٌ':Added, #1: 1	خَبَرُ الْعَبْدِ
u'خَبَر عَبْدٌ':Added, #1: 1	خَبَرُ عَبْدِ
u'خَبَرٌ عَبْدٌ':Added, #1: 1	خَبَرُ عَبْدِ
u'خَبَر عَبْدٌ':Added, #3: 3	خَبَرَ عَبْدِ
u'خَبَرٌ عَبْدٌ':Added, #3: 3	خَبَرَ عَبْدِ
u'خَبَر عَبْدٌ':Added, #4: 4	خَبَرِ عَبْدِ
u'خَبَرٌ عَدَاوَةٌ':Added, #4: 4	خَبَرِ عَبْدِ
u'خَبَر عَدَاوَةٌ':Added, #1: 1	خَبَرِ الْعَدَاوَةِ
u'خَبَرٌ عَدَدٌ':Added, #1: 1	خَبَرِ الْعَدَاوَةِ
u'خَبَر عَدَدٌ':Added, #1: 1	خَبَرُ الْعَدَدِ
u'خَبَرٌ عَدَدٌ':Added, #1: 1	خَبَرُ الْعَدَدِ
u'خَبَرٌ عَدَدٌ':Added, #1: 1	خَبَرُ عَدَدٍ
u'خَبَر عَدَدٌ':Added, #1: 1	خَبَرِ عَدَدٍ
u'خَبَر عَدَدٌ':Added, #1: 1	خَبَرُ عَدَدٍ
u'خَبَرٌ عَدْلٌ':Added, #1: 1	خَبَرِ عَدَدٍ
u'خَبَر عَدْلٌ':Added, #1: 1	خَبَرَ الْعَدْلِ
u'خَبَرٌ عَدْلٌ':Added, #1: 1	خَبَرَ الْعَدْلِ
u'خَبَر عَدْلٌ':Added, #1: 1	خَبَرِ عَدْلَيْنِ
u'خَبَرٌ عَدْلٌ':Added, #1: 1	خَبَرِ عَدْلَيْنِ
u'خَبَر عَدْلٌ':Added, #2: 2	خَبَرِ عَدْلٍ
u'خَبَرٌ عَدْلٌ':Added, #2: 2	خَبَرِ عَدْلٍ
u'خَبَر عَدْلٌ':Added, #2: 2	خَبَرُ عَدْلَيْنِ
u'خَبَرٌ عَدْلٌ':Added, #2: 2	خَبَرُ عَدْلَيْنِ
u'خَبَر عَدْلٌ':Added, #3: 3	خَبَرُ عَدْلٍ
u'خَبَرٌ عَدْلٌ':Added, #3: 3	خَبَرُ عَدْلٍ
u'خَبَر عَدْلٌ':Added, #5: 5	خَبَرُ الْعَدْلِ
u'خَبَرٌ عَدْلٌ':Added, #5: 5	خَبَرُ الْعَدْلِ
u'خَبَر عَدْلٌ':Added, #8: 8	خَبَرِ الْعَدْلِ
u'خَبَرٌ عَدُوٌّ':Added, #8: 8	خَبَرِ الْعَدْلِ
u'خَبَر عَدُوٌّ':Added, #1: 1	خَبَرِ عَدُوٍّ
u'خَبَرٌ عزل':Added, #1: 1	خَبَرِ عَدُوٍّ
u'خَبَرٌ عزل':Added, #1: 1	خَبَرَ الْعَزْلِ
u'خَبَر عزل':Added, #1: 1	خَبَرِ الْعَزْلِ
u'خَبَر عزل':Added, #1: 1	خَبَرَ الْعَزْلِ
u'خَبَرٌ عزل':Added, #1: 1	خَبَرِ الْعَزْلِ
u'خَبَر عزل':Added, #1: 1	خَبَرُ عَزْلِ
u'خَبَرٌ عزل':Added, #1: 1	خَبَرُ عَزْلِ
u'خَبَرٌ عزل':Added, #1: 1	خَبَرُ عَزْلِهِ
u'خَبَر عزل':Added, #1: 1	خَبَرِ عَزْلِهِ
u'خَبَر عزل':Added, #1: 1	خَبَرُ عَزْلِهِ
u'خَبَرَ عَطِيَّةٌ':Predicate, #1: 1	خَبَرِ عَزْلِهِ
u'خَبَرٌ عقاب':Added, #1: 1	خَبَرَ عَطِيَّةَ
u'خَبَر عقاب':Added, #1: 1	خَبَرَ الْعُقَابِ
u'خَبَرٌ عُقَابٌ':Added, #1: 1	خَبَرَ الْعُقَابِ
u'خَبَر عُقَابٌ':Added, #1: 1	خَبَرَ الْعُقَابِ
u'خَبَرٌ عقبة':Added, #1: 1	خَبَرَ الْعُقَابِ
u'خَبَر عقبة':Added, #1: 1	خَبَرِ الْعَقَبَةِ
u'خَبَرٌ عَقَبَةٌ':Added, #1: 1	خَبَرِ الْعَقَبَةِ
u'خَبَر عَقَبَةٌ':Added, #1: 1	خَبَرِ الْعَقَبَةِ
u'خَبَرٌ عِلَّةٌ':Added, #1: 1	خَبَرِ الْعَقَبَةِ
u'خَبَرٌ عِلَّةٌ':Added, #1: 1	خَبَرُ الْعِلَّةِ
u'خَبَر عِلَّةٌ':Added, #1: 1	خَبَرِ الْعِلَّةِ
u'خَبَر عِلَّةٌ':Added, #1: 1	خَبَرُ الْعِلَّةِ
u'خَبَرٌ عِلَّةٌ':Added, #1: 1	خَبَرِ الْعِلَّةِ
u'خَبَر عِلَّةٌ':Added, #2: 2	خَبَرَ الْعِلَّةِ
u'خَبَرَ عَلَوِيٌّ':Predicate, #2: 2	خَبَرَ الْعِلَّةِ
u'خَبَرٌ عَلِيٌّ':Added, #1: 1	خَبَرَ الْعَلَوِيَّةَ
u'خَبَرٌ عَلِيٌّ':Added, #1: 1	خَبَرَ عَلِيٍّ
u'خَبَر عَلِيٌّ':Added, #1: 1	خَبَرُ عَلِيٍّ
u'خَبَر عَلِيٌّ':Added, #1: 1	خَبَرَ عَلِيٍّ
u'خَبَرٌ عَلِيٌّ':Added, #1: 1	خَبَرُ عَلِيٍّ
u'خَبَر عَلِيٌّ':Added, #2: 2	خَبَرِ عَلِيٍّ
u'خَبَرٌ عمرة':Added, #2: 2	خَبَرِ عَلِيٍّ
u'خَبَر عمرة':Added, #1: 1	خَبَرِ الْعُمْرَةِ
u'خَبَرٌ عُمْرَةٌ':Added, #1: 1	خَبَرِ الْعُمْرَةِ
u'خَبَر عُمْرَةٌ':Added, #1: 1	خَبَرِ الْعُمْرَةِ
u'خَبَرٌ غَائِبٌ':Added, #1: 1	خَبَرِ الْعُمْرَةِ
u'خَبَر غَائِبٌ':Added, #2: 2	خَبَرُ الْغَائِبِ
u'خَبَرٌ غَزَاةٌ':Added, #2: 2	خَبَرُ الْغَائِبِ
u'خَبَر غَزَاةٌ':Added, #1: 1	خَبَرُ الْغَزَاةِ
u'خَبَرٌ غَزْوَةٌ':Added, #1: 1	خَبَرُ الْغَزَاةِ
u'خَبَر غَزْوَةٌ':Added, #1: 1	خَبَرُ غَزْوَةِ
u'خَبَرٌ غير':Added, #1: 1	خَبَرُ غَزْوَةِ
u'خَبَر غير':Added, #2: 2	خَبَرِ غَيْرِ
u'خَبَرٌ غَيْرٌ':Added, #2: 2	خَبَرِ غَيْرِ
u'خَبَر غَيْرٌ':Added, #2: 2	خَبَرِ غَيْرِ
u'خَبَرٌ غير':Added, #2: 2	خَبَرِ غَيْرِ
u'خَبَر غير':Added, #3: 3	خَبَرِ غَيْرِهِ
u'خَبَرٌ غَيْرٌ':Added, #3: 3	خَبَرِ غَيْرِهِ
u'خَبَر غَيْرٌ':Added, #3: 3	خَبَرِ غَيْرِهِ
u'خَبَرٌ فَاتِحٌ':Added, #3: 3	خَبَرِ غَيْرِهِ
u'خَبَرٌ فَاتِحٌ':Added, #1: 1	خَبَرَ الْفَاتِحَةِ
u'خَبَر فَاتِحٌ':Added, #1: 1	خَبَرُ الْفَاتِحَةِ
u'خَبَر فَاتِحٌ':Added, #1: 1	خَبَرَ الْفَاتِحَةِ
u'خَبَرٌ فَاتِحَةٌ':Added, #1: 1	خَبَرُ الْفَاتِحَةِ
u'خَبَرٌ فَاتِحَةٌ':Added, #1: 1	خَبَرَ الْفَاتِحَةِ
u'خَبَر فَاتِحَةٌ':Added, #1: 1	خَبَرُ الْفَاتِحَةِ
u'خَبَر فَاتِحَةٌ':Added, #1: 1	خَبَرَ الْفَاتِحَةِ
u'خَبَرٌ فَاسِقٌ':Added, #1: 1	خَبَرُ الْفَاتِحَةِ
u'خَبَر فَاسِقٌ':Added, #11: 11	خَبَرِ الْفَاسِقِ
u'خَبَرٌ فَاسِقٌ':Added, #11: 11	خَبَرِ الْفَاسِقِ
u'خَبَر فَاسِقٌ':Added, #1: 1	خَبَرَ الْفَاسِقِ
u'خَبَرٌ فَاسِقٌ':Added, #1: 1	خَبَرَ الْفَاسِقِ
u'خَبَرٌ فَاسِقٌ':Added, #1: 1	خَبَرَ الْفَاسِقَيْنِ
u'خَبَرٌ فَاسِقٌ':Added, #1: 1	خَبَرُ الْفَاسِقَيْنِ
u'خَبَر فَاسِقٌ':Added, #1: 1	خَبَرِ الْفَاسِقَيْنِ
u'خَبَر فَاسِقٌ':Added, #1: 1	خَبَرَ الْفَاسِقَيْنِ
u'خَبَر فَاسِقٌ':Added, #1: 1	خَبَرُ الْفَاسِقَيْنِ
u'خَبَرٌ فَاسِقٌ':Added, #1: 1	خَبَرِ الْفَاسِقَيْنِ
u'خَبَر فَاسِقٌ':Added, #7: 7	خَبَرُ الْفَاسِقِ
u'خَبَرَ فَاطِمٌ':Predicate, #7: 7	خَبَرُ الْفَاسِقِ
u'خَبَرٌ فتنة':Added, #1: 1	خَبَرَ فَاطِمَةَ
u'خَبَر فتنة':Added, #1: 1	خَبَرُ فِتْنَةِ
u'خَبَرٌ فِتْنَةٌ':Added, #1: 1	خَبَرُ فِتْنَةِ
u'خَبَر فِتْنَةٌ':Added, #1: 1	خَبَرُ فِتْنَةِ
u'خَبَرٌ فرد':Added, #1: 1	خَبَرُ فِتْنَةِ
u'خَبَر فرد':Added, #1: 1	خَبَرُ الْفَرْدِ
u'خَبَرٌ فَرْدٌ':Added, #1: 1	خَبَرُ الْفَرْدِ
u'خَبَر فَرْدٌ':Added, #1: 1	خَبَرُ الْفَرْدِ
u'خَبَرَ فلان':Predicate, #1: 1	خَبَرُ الْفَرْدِ
u'خَبَرٌ فلان':Added, #1: 1	خَبَرَ حُذَيْفَةَ
u'خَبَرٌ فلان':Added, #1: 1	خَبَر التِّرْمِذِيِّ
u'خَبَر فلان':Added, #1: 1	خَبَرَ التِّرْمِذِيِّ
u'خَبَر فلان':Added, #1: 1	خَبَر التِّرْمِذِيِّ
u'خَبَرٌ فلان':Added, #1: 1	خَبَرَ التِّرْمِذِيِّ
u'خَبَر فلان':Added, #1: 1	خَبَرَ الزُّبَيْرِ
u'خَبَرٌ فلان':Added, #1: 1	خَبَرَ الزُّبَيْرِ
u'خَبَر فلان':Added, #1: 1	خَبَرُ الشَّافِعِيِّ
u'خَبَرٌ فلان':Added, #1: 1	خَبَرُ الشَّافِعِيِّ
u'خَبَر فلان':Added, #1: 1	خَبَرَ بِلَالٍ
u'خَبَرٌ فلان':Added, #1: 1	خَبَرَ بِلَالٍ
u'خَبَر فلان':Added, #1: 1	خَبَرِ قَيْسٍ
u'خَبَرٌ فلان':Added, #1: 1	خَبَرِ قَيْسٍ
u'خَبَر فلان':Added, #2: 2	خَبَرُ الطَّبَرَانِيِّ
u'خَبَرٌ فلان':Added, #2: 2	خَبَرُ الطَّبَرَانِيِّ
u'خَبَر فلان':Added, #5: 5	خَبَرِ التِّرْمِذِيِّ
u'خَبَرٌ فلان':Added, #5: 5	خَبَرِ التِّرْمِذِيِّ
u'خَبَر فلان':Added, #9: 9	خَبَرُ التِّرْمِذِيِّ
u'خَبَرٌ قُرْآنٌ':Added, #9: 9	خَبَرُ التِّرْمِذِيِّ
u'خَبَر قُرْآنٌ':Added, #1: 1	خَبَرِ الْقُرْآنِ
u'خَبَرٌ قَسام':Added, #1: 1	خَبَرِ الْقُرْآنِ
u'خَبَر قَسام':Added, #1: 1	خَبَرَ الْقَسَامَةِ
u'خَبَرٌ قَسامَة':Added, #1: 1	خَبَرَ الْقَسَامَةِ
u'خَبَر قَسامَة':Added, #1: 1	خَبَرَ الْقَسَامَةِ
u'خَبَرٌ قَسْمٌ':Added, #1: 1	خَبَرَ الْقَسَامَةِ
u'خَبَر قَسْمٌ':Added, #1: 1	خَبَرُ قَسْمٍ
u'خَبَرٌ قَهْقَه':Added, #1: 1	خَبَرُ قَسْمٍ
u'خَبَر قَهْقَه':Added, #1: 1	خَبَرَ الْقَهْقَهَةِ
u'خَبَرٌ قَهْقَهَة':Added, #1: 1	خَبَرَ الْقَهْقَهَةِ
u'خَبَر قَهْقَهَة':Added, #1: 1	خَبَرَ الْقَهْقَهَةِ
u'خَبَرٌ قول':Added, #1: 1	خَبَرَ الْقَهْقَهَةِ
u'خَبَر قول':Added, #5: 5	خَبَرُ قَوْلِهِ
u'خَبَرٌ قَوْلٌ':Added, #5: 5	خَبَرُ قَوْلِهِ
u'خَبَر قَوْلٌ':Added, #5: 5	خَبَرُ قَوْلِهِ
u'خَبَرٌ قَوْمٌ':Added, #5: 5	خَبَرُ قَوْلِهِ
u'خَبَر قَوْمٌ':Added, #1: 1	خَبَرَ الْقَوْمِ
u'خَبَرٌ قَوْمٌ':Added, #1: 1	خَبَرَ الْقَوْمِ
u'خَبَر قَوْمٌ':Added, #1: 1	خَبَرِ قَوْمٍ
u'خَبَرٌ قيام':Added, #1: 1	خَبَرِ قَوْمٍ
u'خَبَر قيام':Added, #1: 1	خَبَرُ الْقِيَامِ
u'خَبَرٌ قِيَامٌ':Added, #1: 1	خَبَرُ الْقِيَامِ
u'خَبَر قِيَامٌ':Added, #1: 1	خَبَرُ الْقِيَامِ
u'خَبَرٌ قَيْس':Added, #1: 1	خَبَرُ الْقِيَامِ
u'خَبَر قَيْس':Added, #1: 1	خَبَرِ قَيْسٍ
u'خَبَرٌ كَاذِبٌ':Added, #1: 1	خَبَرِ قَيْسٍ
u'خَبَر كَاذِبٌ':Added, #2: 2	خَبَرُ الْكَاذِبِ
u'خَبَرٌ كَافِرٌ':Added, #2: 2	خَبَرُ الْكَاذِبِ
u'خَبَر كَافِرٌ':Added, #4: 4	خَبَرِ الْكَافِرِ
u'خَبَرٌ كذب':Added, #4: 4	خَبَرِ الْكَافِرِ
u'خَبَر كذب':Added, #1: 1	خَبَرِ الْكَذِبِ
u'خَبَرٌ كَذِبٌ':Added, #1: 1	خَبَرِ الْكَذِبِ
u'خَبَر كَذِبٌ':Added, #1: 1	خَبَرِ الْكَذِبِ
u'خَبَرٌ كَذِبٌ':Added, #1: 1	خَبَرِ الْكَذِبِ
u'خَبَر كَذِبٌ':Added, #1: 1	خَبَرُ كَذِبٍ
u'خَبَرٌ كَعْبٌ':Added, #1: 1	خَبَرُ كَذِبٍ
u'خَبَر كَعْبٌ':Added, #1: 1	خَبَرُ كَعْبِ
u'خَبَرٌ كَعْبٌ':Added, #1: 1	خَبَرُ كَعْبِ
u'خَبَرٌ كَعْبٌ':Added, #2: 2	خَبَرُ كَعْبٍ
u'خَبَر كَعْبٌ':Added, #2: 2	خَبَرِ كَعْبِ
u'خَبَر كَعْبٌ':Added, #2: 2	خَبَرُ كَعْبٍ
u'خَبَرٌ لُحُومٌ':Added, #2: 2	خَبَرِ كَعْبِ
u'خَبَر لُحُومٌ':Added, #1: 1	خَبَرُ لُحُومٍ
u'خَبَرٌ لعان':Added, #1: 1	خَبَرُ لُحُومٍ
u'خَبَر لعان':Added, #1: 1	خَبَرِ اللِّعَانِ
u'خَبَرٌ مَاعِزٌ':Added, #1: 1	خَبَرِ اللِّعَانِ
u'خَبَرٌ مَاعِزٌ':Added, #1: 1	خَبَرَ مَاعِزٍ
u'خَبَر مَاعِزٌ':Added, #1: 1	خَبَرُ مَاعِزٍ
u'خَبَر مَاعِزٌ':Added, #1: 1	خَبَرَ مَاعِزٍ
u'خَبَرٌ مَاعِزٌ':Added, #1: 1	خَبَرُ مَاعِزٍ
u'خَبَر مَاعِزٌ':Added, #3: 3	خَبَرِ مَاعِزٍ
u'خَبَرٌ مَالِكٌ':Added, #3: 3	خَبَرِ مَاعِزٍ
u'خَبَرٌ مَالِكٌ':Added, #1: 1	خَبَرُ الْمَالِكِ
u'خَبَر مَالِكٌ':Added, #1: 1	خَبَرِ الْمَالِكِ
u'خَبَر مَالِكٌ':Added, #1: 1	خَبَرُ الْمَالِكِ
u'خَبَرٌ مَالِكٌ':Added, #1: 1	خَبَرِ الْمَالِكِ
u'خَبَرٌ مَالِكٌ':Added, #1: 1	خَبَرُ مَالِكٍ
u'خَبَر مَالِكٌ':Added, #1: 1	خَبَرِ مَالِكٍ
u'خَبَر مَالِكٌ':Added, #1: 1	خَبَرُ مَالِكٍ
u'خَبَرٌ مَالِكٌ':Added, #1: 1	خَبَرِ مَالِكٍ
u'خَبَر مَالِكٌ':Added, #1: 1	خَبَرُ مَالِكِهِ
u'خَبَرٌ مُبْتَدَأٌ':Added, #1: 1	خَبَرُ مَالِكِهِ
u'خَبَر مُبْتَدَأٌ':Added, #1: 1	خَبَرَ مُبْتَدَأٍ
u'خَبَرٌ مُبْتَدَأٌ':Added, #1: 1	خَبَرَ مُبْتَدَأٍ
u'خَبَر مُبْتَدَأٌ':Added, #2: 2	خَبَرَ الْمُبْتَدَأِ
u'خَبَرٌ مُبْتَدَأٌ':Added, #2: 2	خَبَرَ الْمُبْتَدَأِ
u'خَبَر مُبْتَدَأٌ':Added, #5: 5	خَبَرُ مُبْتَدَأٍ
u'خَبَرٌ مُبْتَدَأٌ':Added, #5: 5	خَبَرُ مُبْتَدَأٍ
u'خَبَر مُبْتَدَأٌ':Added, #6: 6	خَبَرِ الْمُبْتَدَأِ
u'خَبَرٌ مُبْتَدَأٌ':Added, #6: 6	خَبَرِ الْمُبْتَدَأِ
u'خَبَر مُبْتَدَأٌ':Added, #9: 9	خَبَرُ الْمُبْتَدَأِ
u'خَبَرٌ مُتَأَخِّرٌ':Added, #9: 9	خَبَرُ الْمُبْتَدَأِ
u'خَبَر مُتَأَخِّرٌ':Added, #1: 1	خَبَرُ الْمُتَأَخِّرِ
u'خَبَرٌ مُتَأَخِّرٌ':Added, #1: 1	خَبَرُ الْمُتَأَخِّرِ
u'خَبَر مُتَأَخِّرٌ':Added, #1: 1	خَبَرُ مُتَأَخِّرِ
u'خَبَرٌ مُتَقَدِّمٌ':Added, #1: 1	خَبَرُ مُتَأَخِّرِ
u'خَبَرٌ مُتَقَدِّمٌ':Added, #1: 1	خَبَرَ مُتَقَدِّمِهِ
u'خَبَر مُتَقَدِّمٌ':Added, #1: 1	خَبَرِ مُتَقَدِّمِهِ
u'خَبَر مُتَقَدِّمٌ':Added, #1: 1	خَبَرَ مُتَقَدِّمِهِ
u'خَبَرٌ مُتَوَاتِرٌ':Added, #1: 1	خَبَرِ مُتَقَدِّمِهِ
u'خَبَر مُتَوَاتِرٌ':Added, #1: 1	خَبَرٍ مُتَوَاتِرٍ
u'خَبَرٌ مُجَاهِدٌ':Added, #1: 1	خَبَرٍ مُتَوَاتِرٍ
u'خَبَر مُجَاهِدٌ':Added, #1: 1	خَبَرُ مُجَاهِدٍ
u'خَبَرٌ مَحْذُوفٌ':Added, #1: 1	خَبَرُ مُجَاهِدٍ
u'خَبَر مَحْذُوفٌ':Added, #1: 1	خَبَرَ الْمَحْذُوفِ
u'خَبَرٌ مُخَابَرَةٌ':Added, #1: 1	خَبَرَ الْمَحْذُوفِ
u'خَبَر مُخَابَرَةٌ':Added, #1: 1	خَبَرِ الْمُخَابَرَةِ
u'خَبَرٌ مُخْبِرٌ':Added, #1: 1	خَبَرِ الْمُخَابَرَةِ
u'خَبَر مُخْبِرٌ':Added, #1: 1	خَبَرَ الْمُخْبِرِ
u'خَبَرٌ مُخَنَّث':Added, #1: 1	خَبَرَ الْمُخْبِرِ
u'خَبَر مُخَنَّث':Added, #1: 1	خَبَرِ الْمُخَنَّثِ
u'خَبَرٌ مُرْسَلٌ':Added, #1: 1	خَبَرِ الْمُخَنَّثِ
u'خَبَر مُرْسَلٌ':Added, #1: 1	خَبَرٍ مُرْسَلٍ
u'خَبَرٌ مُرْسَلٌ':Added, #1: 1	خَبَرٍ مُرْسَلٍ
u'خَبَر مُرْسَلٌ':Added, #2: 2	خَبَرِ الْمُرْسَلِ
u'خَبَرٌ مَرْفُوعٌ':Added, #2: 2	خَبَرِ الْمُرْسَلِ
u'خَبَر مَرْفُوعٌ':Added, #2: 2	خَبَرٍ مَرْفُوعٍ
u'خَبَرٌ مَسْتُورٌ':Added, #2: 2	خَبَرٍ مَرْفُوعٍ
u'خَبَر مَسْتُورٌ':Added, #1: 1	خَبَرَ الْمَسْتُورِ
u'خَبَرٌ مَسْتُورٌ':Added, #1: 1	خَبَرَ الْمَسْتُورِ
u'خَبَر مَسْتُورٌ':Added, #1: 1	خَبَرُ مَسْتُورِ
u'خَبَرٌ مَسْجِدٌ':Added, #1: 1	خَبَرُ مَسْتُورِ
u'خَبَر مَسْجِدٌ':Added, #1: 1	خَبَرُ الْمَسْجِدِ
u'خَبَرٌ مَسْحٌ':Added, #1: 1	خَبَرُ الْمَسْجِدِ
u'خَبَرٌ مَسْحٌ':Added, #1: 1	خَبَرَ الْمَسْحِ
u'خَبَر مَسْحٌ':Added, #1: 1	خَبَرِ الْمَسْحِ
u'خَبَر مَسْحٌ':Added, #1: 1	خَبَرَ الْمَسْحِ
u'خَبَرٌ مَسْحٌ':Added, #1: 1	خَبَرِ الْمَسْحِ
u'خَبَر مَسْحٌ':Added, #4: 4	خَبَرُ الْمَسْحِ
u'خَبَرَ مُسْلِمٌ':Predicate, #4: 4	خَبَرُ الْمَسْحِ
u'خَبَرٌ مُسْلِمٌ':Added, #1: 1	خَبَرَ الْمُسْلِمِينَ
u'خَبَر مُسْلِمٌ':Added, #40: 40	خَبَرُ مُسْلِمٍ
u'خَبَرٌ مُسْلِمٌ':Added, #40: 40	خَبَرُ مُسْلِمٍ
u'خَبَر مُسْلِمٌ':Added, #46: 46	خَبَرِ مُسْلِمٍ
u'خَبَرٌ مُسْلِمٌ':Added, #46: 46	خَبَرِ مُسْلِمٍ
u'خَبَر مُسْلِمٌ':Added, #4: 4	خَبَرَ مُسْلِمٍ
u'خَبَرٌ مُسْنَدٌ':Added, #4: 4	خَبَرَ مُسْلِمٍ
u'خَبَرٌ مُسْنَدٌ':Added, #1: 1	خَبَرٍ مُسْنَدٍ
u'خَبَرٌ مُسْنَدٌ':Added, #1: 1	خَبَرَ مُسْنَدِ
u'خَبَر مُسْنَدٌ':Added, #1: 1	خَبَرِ مُسْنَدِ
u'خَبَر مُسْنَدٌ':Added, #1: 1	خَبَرٍ مُسْنَدٍ
u'خَبَر مُسْنَدٌ':Added, #1: 1	خَبَرَ مُسْنَدِ
u'خَبَرٌ مُسِيءٌ':Added, #1: 1	خَبَرِ مُسْنَدِ
u'خَبَر مُسِيءٌ':Added, #3: 3	خَبَرِ الْمُسِيءِ
u'خَبَرٌ مُشْرِفٌ':Added, #3: 3	خَبَرِ الْمُسِيءِ
u'خَبَر مُشْرِفٌ':Added, #1: 1	خَبَرَ الْمُشْرِفِ
u'خَبَرٌ مُشْرِك':Added, #1: 1	خَبَرَ الْمُشْرِفِ
u'خَبَر مُشْرِك':Added, #1: 1	خَبَرُ الْمُشْرِكِ
u'خَبَرٌ مَشْهُورٌ':Added, #1: 1	خَبَرُ الْمُشْرِكِ
u'خَبَر مَشْهُورٌ':Added, #1: 1	خَبَرَ الْمَشْهُورِ
u'خَبَرٌ مَشْهُورٌ':Added, #1: 1	خَبَرَ الْمَشْهُورِ
u'خَبَر مَشْهُورٌ':Added, #1: 1	خَبَرٍ مَشْهُورٍ
u'خَبَرٌ مُصَارَعَةٌ':Added, #1: 1	خَبَرٍ مَشْهُورٍ
u'خَبَر مُصَارَعَةٌ':Added, #1: 1	خَبَرَ الْمُصَارَعَةِ
u'خَبَرٌ مُعَايِنٌ':Added, #1: 1	خَبَرَ الْمُصَارَعَةِ
u'خَبَر مُعَايِنٌ':Added, #1: 1	خَبَرِ الْمُعَايِنِ
u'خَبَرٌ ملح':Added, #1: 1	خَبَرِ الْمُعَايِنِ
u'خَبَر ملح':Added, #1: 1	خَبَرِ الْمِلْحِ
u'خَبَرٌ مِلْحٌ':Added, #1: 1	خَبَرِ الْمِلْحِ
u'خَبَر مِلْحٌ':Added, #1: 1	خَبَرِ الْمِلْحِ
u'خَبَرٌ مَمْلُوكٌ':Added, #1: 1	خَبَرِ الْمِلْحِ
u'خَبَر مَمْلُوكٌ':Added, #1: 1	خَبَرَ الْمَمْلُوكِ
u'خَبَرٌ مُمَيِّزٌ':Added, #1: 1	خَبَرَ الْمَمْلُوكِ
u'خَبَر مُمَيِّزٌ':Added, #1: 1	خَبَرَ الْمُمَيِّزِ
u'خَبَرٌ مُمَيِّزٌ':Added, #1: 1	خَبَرَ الْمُمَيِّزِ
u'خَبَر مُمَيِّزٌ':Added, #2: 2	خَبَرُ الْمُمَيِّزِ
u'خَبَرٌ مَنْقُولٌ':Added, #2: 2	خَبَرُ الْمُمَيِّزِ
u'خَبَر مَنْقُولٌ':Added, #1: 1	خَبَرٍ مَنْقُولٍ
u'خَبَرٌ مَوْتٌ':Added, #1: 1	خَبَرٍ مَنْقُولٍ
u'خَبَر مَوْتٌ':Added, #1: 1	خَبَرُ مَوْتٍ
u'خَبَرٌ مَوْتٌ':Added, #1: 1	خَبَرُ مَوْتٍ
u'خَبَر مَوْتٌ':Added, #1: 1	خَبَرُ مَوْتِهِ
u'خَبَرٌ مَوْتٌ':Added, #1: 1	خَبَرُ مَوْتِهِ
u'خَبَر مَوْتٌ':Added, #5: 5	خَبَرُ مَوْتِ
u'خَبَرَ مَيْمُونٌ':Predicate, #5: 5	خَبَرُ مَوْتِ
u'خَبَرٌ نَاسٌ':Added, #1: 1	خَبَرَ مَيْمُونَةَ
u'خَبَر نَاسٌ':Added, #1: 1	خَبَرِ النّاسِ
u'خَبَرٌ نَاقِصٌ':Added, #1: 1	خَبَرِ النّاسِ
u'خَبَر نَاقِصٌ':Added, #1: 1	خَبَرٍ نَاقِصٍ
u'خَبَرٌ نَبْذٌ':Added, #1: 1	خَبَرٍ نَاقِصٍ
u'خَبَر نَبْذٌ':Added, #3: 3	خَبَرُ النَّبْذِ
u'خَبَرٌ نَبِيٌّ':Added, #3: 3	خَبَرُ النَّبْذِ
u'خَبَرٌ نَبِيٌّ':Added, #1: 1	خَبَرَ النَّبِيِّ
u'خَبَر نَبِيٌّ':Added, #1: 1	خَبَرِ النَّبِيِّ
u'خَبَر نَبِيٌّ':Added, #1: 1	خَبَرَ النَّبِيِّ
u'خَبَرٌ نَبِيذٌ':Added, #1: 1	خَبَرِ النَّبِيِّ
u'خَبَر نَبِيذٌ':Added, #1: 1	خَبَرُ نَبِيذِ
u'خَبَرٌ نَجَاسَةٌ':Added, #1: 1	خَبَرُ نَبِيذِ
u'خَبَر نَجَاسَةٌ':Added, #1: 1	خَبَرَ النَّجَاسَةِ
u'خَبَرٌ نَدْوَةٌ':Added, #1: 1	خَبَرَ النَّجَاسَةِ
u'خَبَر نَدْوَةٌ':Added, #1: 1	خَبَرُ النّدْوَةِ
u'خَبَرٌ نُزُولٌ':Added, #1: 1	خَبَرُ النّدْوَةِ
u'خَبَر نُزُولٌ':Added, #1: 1	خَبَرَ نُزُولِ
u'خَبَرٌ نُعْمَانُ':Added, #1: 1	خَبَرَ نُزُولِ
u'خَبَر نُعْمَانُ':Added, #4: 4	خَبَرِ النُّعْمَانِ
u'خَبَرٌ نكاح':Added, #4: 4	خَبَرِ النُّعْمَانِ
u'خَبَر نكاح':Added, #2: 2	خَبَرُ النِّكَاحِ
u'خَبَرٌ نِكَاحٌ':Added, #2: 2	خَبَرُ النِّكَاحِ
u'خَبَر نِكَاحٌ':Added, #2: 2	خَبَرُ النِّكَاحِ
u'خَبَرٌ نَهْيٌ':Added, #2: 2	خَبَرُ النِّكَاحِ
u'خَبَر نَهْيٌ':Added, #2: 2	خَبَرُ النَّهْيِ
u'خَبَرٌ نَهْيٌ':Added, #2: 2	خَبَرُ النَّهْيِ
u'خَبَر نَهْيٌ':Added, #3: 3	خَبَرِ النَّهْيِ
u'خَبَرٌ هَدِيٌّ':Added, #3: 3	خَبَرِ النَّهْيِ
u'خَبَر هَدِيٌّ':Added, #1: 1	خَبَرَ الْهَدِيَّةِ
u'خَبَرٌ هَدِيَّةٌ':Added, #1: 1	خَبَرَ الْهَدِيَّةِ
u'خَبَر هَدِيَّةٌ':Added, #1: 1	خَبَرَ الْهَدِيَّةِ
u'خَبَرٌ هِنْدٌ':Added, #1: 1	خَبَرَ الْهَدِيَّةِ
u'خَبَر هِنْدٌ':Added, #2: 2	خَبَرِ هِنْدٍ
u'خَبَرٌ واحد':Added, #2: 2	خَبَرِ هِنْدٍ
u'خَبَر واحد':Added, #101: 101	خَبَرِ الْوَاحِدِ
u'خَبَرٌ وَاحِدٌ':Added, #101: 101	خَبَرِ الْوَاحِدِ
u'خَبَر وَاحِدٌ':Added, #101: 101	خَبَرِ الْوَاحِدِ
u'خَبَرٌ واحد':Added, #101: 101	خَبَرِ الْوَاحِدِ
u'خَبَر واحد':Added, #11: 11	خَبَرَ وَاحِدٍ
u'خَبَرٌ وَاحِدٌ':Added, #11: 11	خَبَرَ وَاحِدٍ
u'خَبَر وَاحِدٌ':Added, #11: 11	خَبَرَ وَاحِدٍ
u'خَبَرٌ واحد':Added, #11: 11	خَبَرَ وَاحِدٍ
u'خَبَر واحد':Added, #26: 26	خَبَرُ وَاحِدٍ
u'خَبَرٌ وَاحِدٌ':Added, #26: 26	خَبَرُ وَاحِدٍ
u'خَبَر وَاحِدٌ':Added, #26: 26	خَبَرُ وَاحِدٍ
u'خَبَرٌ واحد':Added, #26: 26	خَبَرُ وَاحِدٍ
u'خَبَر واحد':Added, #3: 3	خَبَرٍ وَاحِدٍ
u'خَبَرٌ وَاحِدٌ':Added, #3: 3	خَبَرٍ وَاحِدٍ
u'خَبَر وَاحِدٌ':Added, #3: 3	خَبَرٍ وَاحِدٍ
u'خَبَرٌ واحد':Added, #3: 3	خَبَرٍ وَاحِدٍ
u'خَبَر واحد':Added, #5: 5	خَبَرِ وَاحِدٍ
u'خَبَرٌ وَاحِدٌ':Added, #5: 5	خَبَرِ وَاحِدٍ
u'خَبَر وَاحِدٌ':Added, #5: 5	خَبَرِ وَاحِدٍ
u'خَبَرٌ واحد':Added, #5: 5	خَبَرِ وَاحِدٍ
u'خَبَر واحد':Added, #63: 63	خَبَرَ الْوَاحِدِ
u'خَبَرٌ وَاحِدٌ':Added, #63: 63	خَبَرَ الْوَاحِدِ
u'خَبَر وَاحِدٌ':Added, #63: 63	خَبَرَ الْوَاحِدِ
u'خَبَرٌ واحد':Added, #63: 63	خَبَرَ الْوَاحِدِ
u'خَبَر واحد':Added, #72: 72	خَبَرُ الْوَاحِدِ
u'خَبَرٌ وَاحِدٌ':Added, #72: 72	خَبَرُ الْوَاحِدِ
u'خَبَر وَاحِدٌ':Added, #72: 72	خَبَرُ الْوَاحِدِ
u'خَبَرٌ وَاقِعٌ':Added, #72: 72	خَبَرُ الْوَاحِدِ
u'خَبَر وَاقِعٌ':Added, #1: 1	خَبَرٍ وَاقِعٍ
u'خَبَرٌ وَحْدٌ':Added, #1: 1	خَبَرٍ وَاقِعٍ
u'خَبَر وَحْدٌ':Added, #1: 1	خَبَرُ الْوَحْدِ
u'خَبَرٌ وفاة':Added, #1: 1	خَبَرُ الْوَحْدِ
u'خَبَر وفاة':Added, #1: 1	خَبَرُ وَفَاةِ
u'خَبَرٌ وَفَاةٌ':Added, #1: 1	خَبَرُ وَفَاةِ
u'خَبَر وَفَاةٌ':Added, #1: 1	خَبَرُ وَفَاةِ
u'خَبَرٌ وِلاَيَةٌ':Added, #1: 1	خَبَرُ وَفَاةِ
u'خَبَر وِلاَيَةٌ':Added, #1: 1	خَبَرُ وِلَايَتِهِ
u'خَبَرٌ وُلُوغ':Added, #1: 1	خَبَرُ وِلَايَتِهِ
u'خَبَر وُلُوغ':Added, #1: 1	خَبَرِ الْوُلُوغِ
u'خَبَرٌ وَلِيدٌ':Added, #1: 1	خَبَرِ الْوُلُوغِ
u'خَبَر وَلِيدٌ':Added, #1: 1	خَبَرَ الْوَلِيدِ
u'خَبَرٌ يَمِينٌ':Added, #1: 1	خَبَرَ الْوَلِيدِ
u'خَبَر يَمِينٌ':Added, #1: 1	خَبَرَ الْيَمِينِ
u'خُبْزٌ أَرُزٌّ':Added, #1: 1	خَبَرَ الْيَمِينِ
u'خُبْزٌ أَرُزٌّ':Added, #1: 1	خُبْزَ الْأَرُزِّ
u'خُبْزٌ بُرٌّ':Added, #1: 1	خُبْزُ الْأَرُزِّ
u'خُبْزٌ بُرٌّ':Added, #1: 1	خُبْزُ بُرٍّ
u'خُبْزٌ بُرٌّ':Added, #2: 2	خُبْزَ بُرٍّ
u'خُبْزٌ بُرٌّ':Added, #3: 3	خُبْزُ الْبُرِّ
u'خُبْزٌ بُرٌّ':Added, #3: 3	خُبْزِ بُرٍّ
u'خُبْزٌ بُرٌّ':Added, #6: 6	خُبْزَ الْبُرِّ
u'خُبْزٌ بَلَدٌ':Added, #9: 9	خُبْزِ الْبُرِّ
u'خُبْزٌ بَلَدٌ':Added, #1: 1	خُبْزُ بَلَدِهِ
u'خُبْزٌ تَنُّورٌ':Added, #3: 3	خُبْزِ الْبَلَدِ
u'خُبْزٌ تَنُّورٌ':Added, #1: 1	خُبْزُ التَّنُّورِ
u'خُبْزٌ حارٌّ':Added, #1: 1	خُبْزَ تَنُّورٍ
u'خُبْزٌ حَشِيشٌ':Added, #1: 1	خُبْزٍ حَارٍّ
u'خُبْزٌ حِنْطَةٌ':Added, #2: 2	خُبْزُ الْحَشِيشَةِ
u'خُبْزٌ حِنْطَةٌ':Added, #1: 1	خُبْزُ الْحِنْطَةِ
u'خُبْزٌ حِنْطَةٌ':Added, #1: 1	خُبْزَ حِنْطَةٍ
u'خُبْزٌ حِنْطَةٌ':Added, #1: 1	خُبْزُ حِنْطَةٍ
u'خُبْزٌ حِنْطَةٌ':Added, #1: 1	خُبْزِ حِنْطَةٍ
u'خُبْزٌ خَتَنٌ':Added, #8: 8	خُبْزِ الْحِنْطَةِ
u'خَبَزَ دَقيقٌ':Predicate, #1: 1	خُبْزِ خَتَنِهِ
u'خُبْزٌ رقاق':Added, #2: 2	خَبَزَ الدَّقِيقَ
u'خُبْزٌ رُقاقٌ':Added, #1: 1	خُبْزَ رُقَاقٍ
u'خُبْزٌ سَمِيدٌ':Added, #1: 1	خُبْزَ رُقَاقٍ
u'خُبْزٌ سُوقٌ':Added, #1: 1	خُبْزُ السَّمِيدِ
u'خُبْزٌ شَعِيرٌ':Added, #1: 1	خُبْزِ السُّوقِ
u'خُبْزٌ شَعِيرٌ':Added, #11: 11	خُبْزِ الشَّعِيرِ
u'خُبْزٌ شَعِيرٌ':Added, #1: 1	خُبْزُ الشَّعِيرِ
u'خُبْزٌ شَعِيرٌ':Added, #1: 1	خُبْزَ شَعِيرٍ
u'خُبْزٌ شَعِيرٌ':Added, #1: 1	خُبْزُ شَعِيرٍ
u'خُبْزٌ شَعِيرٌ':Added, #2: 2	خُبْزِ شَعِيرٍ
u'خُبْزٌ صَاحِبٌ':Added, #8: 8	خُبْزَ الشَّعِيرِ
u'خُبْزٌ صَاحِبٌ':Added, #1: 1	خُبْزَ صَاحِبِهِ
u'خُبْزٌ عَجِينٌ':Added, #1: 1	خُبْزُ صَاحِبِهِ
u'خُبْزٌ غير':Added, #1: 1	خُبْزَ الْعَجِينِ
u'خُبْزٌ غَيْرٌ':Added, #1: 1	خُبْزِ غَيْرِهِ
u'خُبْزٌ فُرْنٌ':Added, #1: 1	خُبْزِ غَيْرِهِ
u'خُبْزٌ فُرْنٌ':Added, #1: 1	خُبْزَ الْفُرْنِ
u'خُبْزٌ فُرْنٌ':Added, #1: 1	خُبْزُ الْفُرْنِ
u'خَبَزَ فُلاَنٌ':Subject, #1: 1	خُبْزِ فُرْنٍ
u'خُبْزٌ فُلاَنٌ':Added, #1: 1	خَبَزَ فُلَانٌ
u'خُبْزٌ قَطَائِفُ':Added, #3: 3	خُبْزِ فُلَانٍ
u'خُبْزٌ قَطَائِفُ':Added, #1: 1	خُبْزَ الْقَطَائِفِ
u'خُبْزٌ قُطْنِيٌّ':Added, #2: 2	خُبْزِ الْقَطَائِفِ
u'خُبْزٌ كُوفَةٌ':Added, #1: 1	خُبْزُ الْقُطْنِيَّةِ
u'خَبَزَ مُحْرِمٌ':Subject, #1: 1	خُبْزَ الْكُوفَةِ
u'خُبْزٌ مُشْتَرَكٌ':Added, #1: 1	خَبَزَ الْمُحْرِمُ
u'خُبْزٌ مُلْقاة':Added, #1: 1	خُبْزٍ مُشْتَرَكٍ
u'خَبَلٌ جَبَلِيٌّ':Added, #1: 1	خُبْزٍ مُلْقَاةٍ
u'خِتَامٌ علماء':Added, #1: 1	خَبَلٍ جَبَلِيٍّ
u'خِتَامٌ عُلَمَاءُ':Added, #1: 1	خِتَامُ الْعُلَمَاءِ
u'خَتْمٌ أَخَصُّ':Added, #1: 1	خِتَامُ الْعُلَمَاءِ
u'خَتْمٌ أَعَمُّ':Added, #1: 1	خَتْمِ الْأَخَصِّ
u'خَتْمٌ إمَامٌ':Added, #1: 1	خَتْمُ الْأَعَمِّ
u'خَتَمَ أَمْرٌ':Predicate, #2: 2	خَتْمِ الْإِمَامِ
u'خَتَمَ أَوَّلُ':Predicate, #1: 1	خَتَمَ أَمْرَ
u'خَتَمَ آيَةٌ':Predicate, #1: 1	خَتَمَ أَوَّلَ
u'خَتَمَ آيَةٌ':Predicate, #1: 1	خَتَمَ الآيَةَ
u'خَتْمٌ آيَةٌ':Added, #1: 1	خَتَمَ الْآيَةَ
u'خَتَمَ بَابٌ':Predicate, #1: 1	خَتْمِ الْآيَةِ
u'خَتَمَ بَابٌ':Predicate, #1: 1	خَتَمَ بَابَ
u'خَتَمَ بَقَرٌ':Predicate, #2: 2	خَتَمَ الْبَابَ
u'خَتْمٌ تَبْيِيض':Added, #1: 1	خَتَمَ الْبَقَرَةَ
u'خَتَمَ تَحْقِيقٌ':Predicate, #1: 1	خَتْمَ تَبْيِيضِ
u'خَتْمٌ ثَلاثَةٌ':Added, #1: 1	خَتَمَ التَّحْقِيقَ
u'خَتَمَ حالٌ':Predicate, #2: 2	خَتْمَ الثَّلَاثَةِ
u'خَتْمٌ حَيْضٌ':Added, #1: 1	خَتَمَ الْحَالَ
u'خَتْمٌ حَيْضٌ':Added, #10: 10	خَتْمَ الْحَيْضِ
u'خَتْمٌ حَيْضٌ':Added, #1: 1	خَتْمُ الْحَيْضِ
u'خَتَمَ رِسَالَةٌ':Predicate, #1: 1	خَتْمِ الْحَيْضِ
u'خَتْمٌ رِسَالَةٌ':Added, #3: 3	خَتَمَ الرِّسَالَةَ
u'خَتْمٌ رِسَالَةٌ':Added, #1: 1	خَتْمَ الرِّسَالَةِ
u'خَتَمَ سُورَةٌ':Predicate, #1: 1	خَتْمِ الرِّسَالَةِ
u'خَتَمَ سُورَةٌ':Predicate, #1: 1	خَتَمَ سُورَةَ
u'خَتْمٌ سُورَةٌ':Added, #5: 5	خَتَمَ السُّورَةَ
u'خَتْمٌ سُورَةٌ':Added, #1: 1	خَتْمِ السُّورَةِ
u'خَتْمٌ شَهْرٌ':Added, #1: 1	خَتْمِ سُورَةِ
u'خَتْمٌ شَهْرٌ':Added, #1: 1	خَتْمُ الشَّهْرِ
u'خَتْمٌ شَهْرٌ':Added, #24: 24	خَتْمَ الشَّهْرِ
u'خَتْمٌ شَهْرٌ':Added, #3: 3	خَتْمِ الشَّهْرِ
u'خَتْمٌ صَلاَةٌ':Added, #3: 3	خَتْمَ الشَّهْرَيْنِ
u'خَتْمٌ صَلاَةٌ':Added, #1: 1	خَتْمِ الصَّلاَةِ
u'خَتَمَ صِيَامٌ':Predicate, #3: 3	خَتْمُ الصَّلَاةِ
u'خَتَمَ طواف':Predicate, #1: 1	خَتَمَ الصِّيَامَ
u'خَتَمَ طَوَافٌ':Predicate, #1: 1	خَتَمَ الطَّوَافَ
u'خَتْمٌ طواف':Added, #1: 1	خَتَمَ الطَّوَافَ
u'خَتْمٌ طواف':Added, #1: 1	خَتْمَ الطَّوَافِ
u'خَتْمٌ طَوَافٌ':Added, #1: 1	خَتْمِ الطَّوَافِ
u'خَتْمٌ طَوَافٌ':Added, #1: 1	خَتْمَ الطَّوَافِ
u'خَتْمٌ طواف':Added, #1: 1	خَتْمِ الطَّوَافِ
u'خَتْمٌ طَوَافٌ':Added, #4: 4	خَتْمُ الطَّوَافِ
u'خَتْمٌ عِبَادَةٌ':Added, #4: 4	خَتْمُ الطَّوَافِ
u'خَتَمَ عَشْرٌ':Predicate, #1: 1	خَتْمِ الْعِبَادَةِ
u'خَتْمٌ فَاتِحٌ':Added, #1: 1	خَتَمَ عَشْرَ
u'خَتْمٌ فَاتِحَةٌ':Added, #1: 1	خَتْمِ فَاتِحَةِ
u'خَتَمَ قُرْآنٌ':Predicate, #1: 1	خَتْمِ فَاتِحَةِ
u'خَتْمٌ قُرْآنٌ':Added, #5: 5	خَتَمَ الْقُرْآنَ
u'خَتْمٌ قُرْآنٌ':Added, #1: 1	خَتْمَ الْقُرْآنِ
u'خَتْمٌ قُرْآنٌ':Added, #6: 6	خَتْمُ الْقُرْآنِ
u'خَتَمَ كِتَابٌ':Predicate, #8: 8	خَتْمِ الْقُرْآنِ
u'خَتَمَ كِتَابٌ':Predicate, #1: 1	خَتَمَ الْكِتَابَ
u'خَتْمٌ كِتَابٌ':Added, #1: 1	خَتَمَ كِتَابَ
u'خَتْمٌ كِتَابٌ':Added, #1: 1	خَتْمُ الْكِتَابِ
u'خَتْمٌ كِتَابٌ':Added, #2: 2	خَتْمِ الْكِتَابِ
u'خَتْمٌ كُتُبٌ':Added, #2: 2	خَتْمُ كِتَابِ
u'خَتْمٌ كَلاَمٌ':Added, #1: 1	خَتْمُ الْكُتُبِ
u'خَتَمَ مُصَنِّفٌ':Subject, #1: 1	خَتْمَ الْكَلَامِ
u'خَتَمَ مَلَكٌ':Subject, #1: 1	خَتَمَ الْمُصَنِّفُ
u'خَتْمٌ نُبُوَّةٌ':Added, #1: 1	خَتَمَ الْمَلَكُ
u'خَتَمَ نَحَّاسٌ':Subject, #1: 1	خَتْمِ النّبُوّةِ
u'خَتْمٌ نفاس':Added, #1: 1	خَتَمَ النّحّاسُ
u'خَتْمٌ نِفَاسٌ':Added, #2: 2	خَتْمَ النِّفَاسِ
u'خَتَنَ أَجِيرٌ':Subject, #2: 2	خَتْمَ النِّفَاسِ
u'خَتَنَ حَسَنٌ':Predicate, #2: 2	خَتَنَ الْأَجِيرُ
u'خَتَنَ رَسُولٌ':Subject, #2: 2	خَتَنَ الْحَسَنَ
u'خَتَنَ عَبْدٌ':Subject, #1: 1	خَتَنَ رَسُولُ
u'خَتَنَ نَبِيٌّ':Predicate, #1: 1	خَتَنَ عَبْدُ
u'خَتَنَ وَلِيٌّ':Subject, #2: 2	خَتَنَ النَّبِيَّ
u'خجل تَعْنِيف':Added, #1: 1	خَتَنَ الْوَلِيُّ
u'خَجَلٌ تَعْنِيف':Added, #1: 1	خَجَلِ التَّعْنِيفِ
u'خجل مَجْلِسٌ':Added, #1: 1	خَجَلِ التَّعْنِيفِ
u'خَجَلٌ مَجْلِسٌ':Added, #1: 1	خَجَلُ مَجْلِسٍ
u'خداع حِيلَةٌ':Added, #1: 1	خَجَلُ مَجْلِسٍ
u'خِدَاعٌ حِيلَةٌ':Added, #1: 1	خِدَاعَ حِيلَتِهِ
u'خداع عَدُوٌّ':Added, #1: 1	خِدَاعَ حِيلَتِهِ
u'خِدَاعٌ عَدُوٌّ':Added, #1: 1	خِدَاعِ الْعَدُوِّ
u'خَدَعَ اِمْرَأَةٌ':Predicate, #1: 1	خِدَاعِ الْعَدُوِّ
u'خَدَمَ تمام':Predicate, #2: 2	خَدَعَ امْرَأَةَ
u'خَدَمَ تَمامٌ':Predicate, #1: 1	خَدَمَ تَمَامَ
u'خَدَمَ سُلْطَانٌ':Predicate, #1: 1	خَدَمَ تَمَامَ
u'خَدَمَ عَبْدٌ':Subject, #1: 1	خَدَمَ السُّلْطَانَ
u'خَدَمَ مَحَابِرُ':Predicate, #2: 2	خَدَمَ الْعَبْدُ
u'خَدَمَ نَظِيرٌ':Subject, #1: 1	خَدَمَ الْمَحَابِرَ
u'خَدَمَ وَرَثَةٌ':Predicate, #1: 1	خَدَمَ نَظِيرُهُ
u'خَدِيعَةٌ حَرْبٌ':Added, #4: 4	خَدَمَ الْوَرَثَةَ
u'خَدِيعَةٌ نَاسٌ':Added, #1: 1	خَدِيعَةِ حَرْبٍ
u'خَذَلَ يَوْمٌ':Predicate, #1: 1	خَدِيعَةِ النَّاسِ
u'خَرَابٌ أرْضٌ':Added, #1: 1	خَذَلَ الْيَوْمَ
u'خَرَابٌ حَبْسٌ':Added, #1: 1	خَرَابِ الْأَرْضِ
u'خَرَابٌ دَارٌ':Added, #1: 1	خَرَابُ الْحَبْسِ
u'خَرَابٌ دِيَارٌ':Added, #1: 1	خَرَابِ الدَّارِ
u'خَرَابٌ دِينٌ':Added, #2: 2	خَرَابِ الدِّيَارِ
u'خَرَابٌ عَالَمٌ':Added, #1: 1	خَرَابُ الدِّينِ
u'خَرَابٌ مَدِينٌ':Added, #1: 1	خَرَابِ الْعَالَمِ
u'خَرَابٌ مَدِينَةٌ':Added, #1: 1	خَرَاب الْمَدِينَةِ
u'خَرَابٌ مَسْجِدٌ':Added, #1: 1	خَرَاب الْمَدِينَةِ
u'خَرَابٌ مَسْجِدٌ':Added, #1: 1	خَرَابِ الْمَسْجِدِ
u'خَرَابٌ مَسْكَنٌ':Added, #2: 2	خَرَابُ الْمَسْجِدِ
u'خَرَابٌ مَكَانٌ':Added, #1: 1	خَرَابَ الْمَسْكَنِ
u'خَرَابٌ وَقْفٌ':Added, #1: 1	خَرَابِ الْمَكَانِ
u'خَرَابٌ وَقْفٌ':Added, #1: 1	خَرَابَ الْوَقْفِ
u'خَرِبَ أحَدٌ':Subject, #1: 1	خَرَابُ الْوَقْفِ
u'خَرَّبَ أرْضٌ':Predicate, #1: 1	خَرِبَ أَحَدُ
u'خَرِبَ بَعْضٌ':Subject, #2: 2	خَرَّبَ الْأَرْضَ
u'خَرِبَ بَلَدٌ':Subject, #1: 1	خَرِبَ بَعْضُ
u'خَرِبَ بِنَاءٌ':Subject, #1: 1	خَرِبَ الْبَلَدُ
u'خَرِبَ بَيْتٌ':Subject, #1: 1	خَرِبَ الْبِنَاءُ
u'خَرِبَ جَانِبٌ':Subject, #3: 3	خَرِبَ بَيْتُ
u'خَرِبَ حانوتٌ':Subject, #1: 1	خَرِبَ جَانِبٌ
u'خَرِبَ حَوْضٌ':Subject, #2: 2	خَرِبَ حَانُوتٌ
u'خَرَّبَ دَارٌ':Predicate, #1: 1	خَرِبَ الْحَوْضُ
u'خَرِبَ رباط':Subject, #1: 1	خَرَّبَ الدَّارَ
u'خَرِبَ رِبَاطٌ':Subject, #1: 1	خَرِبَ الرِّبَاطُ
u'خَرَّبَ رَجُلٌ':Subject, #1: 1	خَرِبَ الرِّبَاطُ
u'خَرِبَ سَوادٌ':Subject, #1: 1	خَرَّبَ رَجُلٌ
u'خَرَّبَ سَيْل':Subject, #1: 1	خَرِبَ السَّوَادُ
u'خَرَّبَ ضِفَّةٌ':Predicate, #1: 1	خَرَّبَ السَّيْلُ
u'خَرِبَ فَاسِدٌ':Subject, #1: 1	خَرَّبَ ضِفَّةَ
u'خَرِبَ مُسْتَأْجِرٌ':Subject, #1: 1	خَرِبَ فَاسِدٌ
u'خَرَّبَ مُسْتَأْجِرٌ':Subject, #1: 1	خَرِبَ الْمُسْتَأْجِرُ
u'خَرِبَ مَسْجِدٌ':Subject, #1: 1	خَرَّبَ الْمُسْتَأْجِرُ
u'خَرِبَ مَكَانٌ':Subject, #6: 6	خَرِبَ الْمَسْجِدُ
u'خَرَّبَ نَهْرٌ':Predicate, #1: 1	خَرِبَ الْمَكَانُ
u'خَرِبَ وَقْفٌ':Subject, #1: 1	خَرَّبَ النَّهْرَ
u'خَرَجَ أَبٌ':Subject, #8: 8	خَرِبَ الْوَقْفُ
u'خَرَّجَ اِبْنٌ':Subject, #1: 1	خَرَجَ الْأَبُ
u'خَرَجَ اِبْنٌ':Subject, #17: 17	خَرَّجَ ابْنُ
u'خَرَجَ أَبْيَض':Predicate, #5: 5	خَرَجَ ابْنُ
u'خَرَجَ اِتِّفَاقٌ':Subject, #1: 1	خَرَجَ أَبْيَضَ
u'خَرَجَ إثْرٌ':Predicate, #1: 1	خَرَجَ اتِّفَاقُ
u'خَرَجَ أثَرٌ':Subject, #2: 2	خَرَجَ إثْرَ
u'خَرَجَ إِجْمَاعٌ':Subject, #1: 1	خَرَجَ أَثَرُ
u'خَرَجَ أَجِيرٌ':Subject, #1: 1	خَرَجَ الْإِجْمَاعُ
u'خَرَجَ أحَدٌ':Subject, #1: 1	خَرَجَ الْأَجِيرُ
u'خَرَجَ أحَدٌ':Subject, #10: 10	خَرَجَ أَحَدُ
u'خَرَجَ إِدْرَاكٌ':Subject, #2: 2	خَرَجَ أَحَدٌ
u'خَرَجَ أَذَانٌ':Subject, #1: 1	خَرَجَ إدْرَاكُ
u'خَرَجَ إِزَالَةٌ':Subject, #1: 1	خَرَجَ الْأَذَانُ
u'خَرَجَ اِسْمٌ':Subject, #1: 1	خَرَجَ إزَالَةُ
u'خَرَجَ اِسْمٌ':Subject, #20: 20	خَرَجَ اسْمُهُ
u'خَرَجَ أسْوَد':Subject, #4: 4	خَرَجَ اسْمُ
u'خَرَجَ أَصْحَابٌ':Subject, #1: 1	خَرَجَ الْأَسْوَدُ
u'خَرَجَ أَصْحَابٌ':Subject, #1: 1	خَرَجَ أَصْحَابُ
u'خَرَّجَ أَصْحَابٌ':Subject, #1: 1	خَرَجَ أَصْحَابُهُ
u'خَرَّجَ أَصْحَابٌ':Subject, #1: 1	خَرَّجَ أَصْحَابُهُ
u'خَرَجَ إِطْلاقٌ':Subject, #2: 2	خَرَّجَ الْأَصْحَابُ
u'خَرَجَ أقْرَبُ':Subject, #1: 1	خَرَجَ الْإِطْلَاقُ
u'خَرَجَ أقْرَع':Predicate, #1: 1	خَرَجَ الْأَقْرَبُ
u'خَرَجَ إقْطَاعٌ':Subject, #2: 2	خَرَجَ أَقْرَعَ
u'خَرَجَ أقَلُّ':Predicate, #1: 1	خَرَجَ الْإِقْطَاعُ
u'خَرَجَ أقَلُّ':Subject, #1: 1	خَرَجَ أَقَلَّ
u'خَرَجَ أقَلُّ':Subject, #2: 2	خَرَجَ أَقَلُّهُ
u'خَرَجَ أَكْثَرُ':Subject, #2: 2	خَرَجَ الْأَقَلُّ
u'خَرَجَ أَكْثَرُ':Subject, #4: 4	خَرَجَ الْأَكْثَرُ
u'خَرَجَ أَكْثَرُ':Subject, #6: 6	خَرَجَ أَكْثَرُ
u'خَرَجَ إكْرَاهٌ':Subject, #6: 6	خَرَجَ أَكْثَرُهُ
u'خَرَجَ ألف':Subject, #1: 1	خَرَجَ الْإِكْرَاهُ
u'خَرَجَ ألف':Subject, #1: 1	خَرَجَ الْأَلِفُ
u'خَرَجَ ألْفٌ':Subject, #5: 5	خَرَجَ الْأَلْفُ
u'خَرَجَ أَلْفٌ':Subject, #5: 5	خَرَجَ الْأَلْفُ
u'خَرَجَ الْمَرْأَةُ':Subject, #5: 5	خَرَجَ الْأَلْفُ
u'خَرَجَ إمَامٌ':Subject, #1: 1	خَرَجَ الْمَرْأَةُ
u'خَرَجَ إمَامٌ':Subject, #12: 12	خَرَجَ الإِمَامُ
u'خَرَجَ إمَامٌ':Subject, #1: 1	خَرَجَ إِمَامُهُ
u'خَرَجَ إمَامٌ':Subject, #2: 2	خَرَجَ إمَامُهُ
u'خَرَجَ أَمْرٌ':Subject, #37: 37	خَرَجَ الْإِمَامُ
u'خَرَجَ أَمْعاءٌ':Subject, #32: 32	خَرَجَ الْأَمْرُ
u'خَرَجَ أَمْعَاءٌ':Subject, #1: 1	خَرَجَ الْأَمْعَاءُ
u'خَرَجَ آمِنٌ':Subject, #1: 1	خَرَجَ الْأَمْعَاءُ
u'خَرَجَ أهْلٌ':Subject, #1: 1	خَرَجَ آمِنٌ
u'خَرَجَ أَوَّلُ':Subject, #4: 4	خَرَجَ أَهْلُ
u'خَرَجَ أَوْلٌ':Subject, #1: 1	خَرَجَ أَوَّلُ
u'خَرَجَ أَوَّلُ':Subject, #1: 1	خَرَجَ أَوْلُ
u'خَرَجَ إِيجَابٌ':Subject, #4: 4	خَرَجَ الْأَوَّلُ
u'خَرَجَ بَانٌ':Predicate, #1: 1	خَرَجَ إيجَابُ
u'خَرَّجَ بُخَارِيٌّ':Subject, #1: 1	خَرَجَ بَانَ
u'خَرَجَ بَدَلٌ':Subject, #1: 1	خَرَّجَ الْبُخَارِيُّ
u'خَرَجَ براءٌ':Subject, #1: 1	خَرَجَ بَدَلُ
u'خَرَجَ بَراءٌ':Subject, #1: 1	خَرَجَ الْبَرَاءُ
u'خَرَجَ بَطَلٌ':Predicate, #1: 1	خَرَجَ الْبَرَاءُ
u'خَرَجَ بَعْضٌ':Subject, #1: 1	خَرَجَ بَطَلَ
u'خَرَجَ بَعْضٌ':Subject, #17: 17	خَرَجَ بَعْضُ
u'خَرَجَ بَعْضٌ':Subject, #18: 18	خَرَجَ بَعْضُهُ
u'خَرَّجَ بَعْضٌ':Subject, #1: 1	خَرَجَ الْبَعْضُ
u'خَرَجَ بَقِيَّةٌ':Subject, #2: 2	خَرَّجَ بَعْضُ
u'خَرَجَ بَوْلٌ':Subject, #3: 3	خَرَجَ بَقِيَّةُ
u'خَرَجَ بَوْلٌ':Subject, #2: 2	خَرَجَ بَوْلُهُ
u'خَرَجَ بَيْعٌ':Subject, #3: 3	خَرَجَ الْبَوْلُ
u'خَرَجَ بَيْنٌ':Predicate, #1: 1	خَرَجَ الْبَيْعُ
u'خَرَجَ تَرِكَةٌ':Subject, #4: 4	خَرَجَ بَيْنَ
u'خَرَجَ تَصَوُّرٌ':Subject, #1: 1	خَرَجَ التَّرِكَةُ
u'خَرَجَ تَغَيُّرٌ':Subject, #1: 1	خَرَجَ التَّصَوُّرُ
u'خَرَجَ تَفْرِيع':Subject, #1: 1	خَرَجَ تَغَيُّرُ
u'خَرَجَ تَوْقِيعٌ':Subject, #1: 1	خَرَجَ تَفْرِيعٌ
u'خَرَجَ تَوْقِيعٌ':Subject, #1: 1	خَرَجَ التَّوْقِيعُ
u'خَرَجَ ثَالِثٌ':Subject, #1: 1	خَرَجَ تَوْقِيعُهُ
u'خَرَجَ ثَدْيٌ':Subject, #1: 1	خَرَجَ الثَّالِثُ
u'خَرَجَ ثَلاثَةٌ':Predicate, #1: 1	خَرَجَ الثَّدْيُ
u'خَرَجَ ثَلاثَةٌ':Subject, #1: 1	خَرَجَ ثَلَاثَةَ
u'خَرَجَ ثَلاثَةٌ':Subject, #1: 1	خَرَجَ ثَلاثَةُ
u'خَرَجَ ثَلاثَةٌ':Subject, #1: 1	خَرَجَ ثَلاَثَةٌ
u'خَرَجَ ثَمَرٌ':Subject, #3: 3	خَرَجَ ثَلَاثَةٌ
u'خَرَجَ ثَمَرَةٌ':Predicate, #4: 4	خَرَجَ الثَّمَرُ
u'خَرَجَ ثَمَنٌ':Subject, #1: 1	خَرَجَ ثَمَرَةَ
u'خَرَجَ ثَمَنٌ':Subject, #1: 1	خَرَجَ ثَمَنُ
u'خَرَجَ ثَوْبٌ':Subject, #3: 3	خَرَجَ الثَّمَنُ
u'خَرَجَ جُرْحٌ':Subject, #1: 1	خَرَجَ الثَّوْبُ
u'خَرَجَ جُزْءٌ':Subject, #1: 1	خَرَجَ الْجُرْحُ
u'خَرَجَ جلد':Subject, #1: 1	خَرَجَ جُزْءٌ
u'خَرَجَ جلد':Subject, #1: 1	خَرَجَ الْجَلْدُ
u'خَرَجَ جَلْدٌ':Subject, #1: 1	خَرَجَ الْجِلْدُ
u'خَرَجَ جِلْدٌ':Subject, #1: 1	خَرَجَ الْجَلْدُ
u'خَرَجَ جلد':Subject, #1: 1	خَرَجَ الْجِلْدُ
u'خَرَجَ جِلْدٌ':Subject, #1: 1	خَرَجَ جِلْدُ
u'خَرَجَ جَمَاعَةٌ':Subject, #1: 1	خَرَجَ جِلْدُ
u'خَرَجَ جَنِينٌ':Subject, #6: 6	خَرَجَ جَمَاعَةٌ
u'خَرَجَ جَنِينٌ':Subject, #1: 1	خَرَجَ جَنِينُ
u'خَرَجَ جَوَابٌ':Subject, #6: 6	خَرَجَ الْجَنِينُ
u'خَرَجَ جَوَابٌ':Subject, #1: 1	خَرَجَ جَوَابُ
u'خَرَجَ جَوَابٌ':Subject, #1: 1	خَرَجَ جَوَابُهُ
u'خَرَجَ جَوَازٌ':Subject, #7: 7	خَرَجَ الْجَوَابُ
u'خَرَجَ جَوَازٌ':Subject, #1: 1	خَرَجَ جَوَازُ
u'خَرَجَ جَوْزٌ':Subject, #2: 2	خَرَجَ الْجَوَازُ
u'خَرَجَ جَيْبٌ':Subject, #1: 1	خَرَجَ الْجَوْزُ
u'خَرَجَ حارِثٌ':Subject, #1: 1	خَرَجَ الْجَيْبُ
u'خَرَجَ حاكِمٌ':Subject, #1: 1	خَرَجَ الْحَارِثُ
u'خَرَجَ حالٌ':Predicate, #3: 3	خَرَجَ الْحَاكِمُ
u'خَرَجَ حَدَثٌ':Subject, #1: 1	خَرَجَ حَالَ
u'خَرَجَ حَديثٌ':Predicate, #1: 1	خَرَجَ حَدَثُهُ
u'خَرَّجَ حَديثٌ':Predicate, #1: 1	خَرَجَ الْحَدِيثَ
u'خَرَّجَ حُذَّاقٌ':Subject, #1: 1	خَرَّجَ الْحَدِيثَ
u'خَرَجَ حُرٌّ':Subject, #1: 1	خَرَّجَ حُذَّاقُ
u'خَرَجَ حَقٌّ':Subject, #1: 1	خَرَجَ حُرٌّ
u'خَرَجَ حُكْمٌ':Subject, #2: 2	خَرَجَ حَقُّهُ
u'خَرَجَ حِمَارٌ':Subject, #1: 1	خَرَجَ حُكْمُهُ
u'خَرَجَ حِمَارٌ':Subject, #1: 1	خَرَجَ الْحِمَارُ
u'خَرَجَ حَمَامٌ':Subject, #1: 1	خَرَجَ حِمَارٌ
u'خَرَجَ حَمْدٌ':Subject, #2: 2	خَرَجَ الْحَمَامُ
u'خَرَجَ حَيْضٌ':Subject, #1: 1	خَرَجَ الْحَمْدُ
u'خَرَجَ خَبَرٌ':Subject, #1: 1	خَرَجَ الْحَيْضُ
u'خَرَجَ خَبَر':Subject, #1: 1	خَرَجَ الْخَبَرُ
u'خَرَجَ خُصُومَةٌ':Subject, #1: 1	خَرَجَ الْخَبَرُ
u'خَرَجَ خَطَأٌ':Subject, #1: 1	خَرَجَ خُصُومَةٌ
u'خَرَجَ خَطِيبٌ':Subject, #1: 1	خَرَجَ الْخَطَأُ
u'خَرَّجَ خِلاَفٌ':Predicate, #1: 1	خَرَجَ الْخَطِيبُ
u'خَرَجَ خِلاَفٌ':Subject, #3: 3	خَرَّجَ الْخِلَافَ
u'خَرَجَ خَلْفٌ':Predicate, #2: 2	خَرَجَ خِلَافُهُ
u'خَرَجَ خَلِيفَةٌ':Subject, #1: 1	خَرَجَ خَلْفَ
u'خَرَجَ خَمْسَةٌ':Subject, #1: 1	خَرَجَ الْخَلِيفَةُ
u'خَرَجَ دَاءٌ':Subject, #1: 1	خَرَجَ خَمْسَةٌ
u'خَرَجَ دُبُرٌ':Subject, #1: 1	خَرَجَ الدَّاءُ
u'خَرَجَ دَجَّالٌ':Subject, #2: 2	خَرَجَ دُبُرُهُ
u'خَرَجَ دَمٌ':Subject, #2: 2	خَرَجَ الدَّجَّالُ
u'خَرَجَ دَمٌ':Subject, #13: 13	خَرَجَ الدَّمُ
u'خَرَجَ دَمٌ':Subject, #1: 1	خَرَجَ دَمُهُ
u'خَرَجَ دمع':Subject, #2: 2	خَرَجَ دَمٌ
u'خَرَجَ دَمْعٌ':Subject, #1: 1	خَرَجَ دَمْعُهُ
u'خَرَجَ دمع':Subject, #1: 1	خَرَجَ دَمْعُهُ
u'خَرَجَ دَمْعٌ':Subject, #3: 3	خَرَجَ الدَّمْعُ
u'خَرَجَ دِهْقانٌ':Subject, #3: 3	خَرَجَ الدَّمْعُ
u'خَرَجَ دُهْنٌ':Subject, #1: 1	خَرَجَ دِهْقَانُ
u'خَرَجَ دَوْرٌ':Subject, #1: 1	خَرَجَ الدُّهْنُ
u'خَرَجَ دونٌ':Predicate, #1: 1	خَرَجَ الدَّوْرُ
u'خَرَجَ دَيْنٌ':Subject, #1: 1	خَرَجَ دُونَ
u'خَرَجَ دَيْنٌ':Subject, #10: 10	خَرَجَ الدَّيْنُ
u'خَرَجَ ذكر':Predicate, #2: 2	خَرَجَ دَيْنُ
u'خَرَجَ ذِكْرٌ':Predicate, #1: 1	خَرَجَ ذِكْرَ
u'خَرَجَ ذِمِّيٌّ':Subject, #1: 1	خَرَجَ ذِكْرَ
u'خَرَجَ رابع':Subject, #1: 1	خَرَجَ ذِمِّيٌّ
u'خَرَجَ رَابِعٌ':Subject, #3: 3	خَرَجَ الرَّابِعُ
u'خَرَجَ رَأْسٌ':Subject, #3: 3	خَرَجَ الرَّابِعُ
u'خَرَجَ رَأْسٌ':Subject, #1: 1	خَرَجَ الرَّأْسُ
u'خَرَجَ رَأْسٌ':Subject, #7: 7	خَرَجَ رَأْسُ
u'خَرَجَ رَاعِفٌ':Subject, #9: 9	خَرَجَ رَأْسُهُ
u'خَرَجَ رَأْيٌ':Subject, #1: 1	خَرَجَ الرَّاعِفُ
u'خَرَجَ رَجُلٌ':Subject, #1: 1	خَرَجَ رَأْيُهُ
u'خَرَجَ رِجْلٌ':Subject, #12: 12	خَرَجَ رَجُلٌ
u'خَرَجَ رَجُلٌ':Subject, #1: 1	خَرَجَ رِجْلٌ
u'خَرَجَ رِزْقٌ':Subject, #7: 7	خَرَجَ الرَّجُلُ
u'خَرَجَ رِزْقٌ':Subject, #1: 1	خَرَجَ الرِّزْقُ
u'خَرَجَ رَسُولٌ':Subject, #1: 1	خَرَجَ رِزْقٌ
u'خَرَجَ رَفْعٌ':Subject, #147: 147	خَرَجَ رَسُولُ
u'خَرَجَ رَهْنٌ':Subject, #1: 1	خَرَجَ الرَّفْعُ
u'خَرَجَ روحٌ':Subject, #2: 2	خَرَجَ الرَّهْنُ
u'خَرَجَ ريحٌ':Subject, #1: 1	خَرَجَ الرُّوحُ
u'خَرَجَ زادٌ':Subject, #3: 3	خَرَجَ الرِّيحُ
u'خَرَجَ زَرْعٌ':Subject, #1: 1	خَرَجَ زَادُهُ
u'خَرَجَ زَوْجٌ':Subject, #4: 4	خَرَجَ الزَّرْعُ
u'خَرَجَ زَيْدٌ':Subject, #9: 9	خَرَجَ الزَّوْجُ
u'خَرَجَ زَيْدٌ':Subject, #1: 1	خَرَجَ زَيْدُ
u'خَرَجَ سَائِقٌ':Subject, #5: 5	خَرَجَ زَيْدٌ
u'خَرَّجَ سَبْيٌ':Predicate, #1: 1	خَرَجَ السَّائِقُ
u'خَرَجَ سرعان':Subject, #1: 1	خَرَّجَ سَبْيَ
u'خَرَجَ سَعْدٌ':Subject, #1: 1	خَرَجَ سَرَعَانُ
u'خَرَجَ سُقُوطٌ':Subject, #2: 2	خَرَجَ سَعْدُ
u'خَرَجَ سُلْطَانٌ':Subject, #1: 1	خَرَجَ السُّقُوطُ
u'خَرَجَ سلمة':Subject, #1: 1	خَرَجَ السُّلْطَانُ
u'خَرَجَ سهام':Subject, #1: 1	خَرَجَ سَلَمَةُ
u'خَرَجَ سِهَامٌ':Subject, #1: 1	خَرَجَ السِّهَامُ
u'خَرَجَ سَهْمٌ':Subject, #1: 1	خَرَجَ السِّهَامُ
u'خَرَجَ سَهْمٌ':Subject, #1: 1	خَرَجَ السّهْمُ
u'خَرَجَ سَهْمٌ':Subject, #3: 3	خَرَجَ السَّهْمُ
u'خَرَجَ سَهْمٌ':Subject, #5: 5	خَرَجَ سَهْمُهُ
u'خَرَجَ سَيْفٌ':Subject, #8: 8	خَرَجَ سَهْمُ
u'خَرَجَ شافِعِيّ':Subject, #1: 1	خَرَجَ سَيْفُ
u'خَرَجَ شُبَّانٌ':Subject, #1: 1	خَرَجَ الشَّافِعِيُّ
u'خَرَجَ شِبْهٌ':Subject, #1: 1	خَرَجَ شُبَّانُ
u'خَرَجَ شَخْصٌ':Subject, #1: 1	خَرَجَ شِبْهُ
u'خَرَجَ شَهْرٌ':Subject, #1: 1	خَرَجَ الشَّخْصُ
u'خَرَجَ شَيْءٌ':Subject, #4: 4	خَرَجَ الشَّهْرُ
u'خَرَجَ شَيَاطِينُ':Subject, #19: 19	خَرَجَ شَيْءٌ
u'خَرَّجَ شَيْخٌ':Subject, #1: 1	خَرَجَ الشَّيَاطِينُ
u'خَرَجَ صَاحِبٌ':Subject, #2: 2	خَرَّجَ الشَّيْخُ
u'خَرَّجَ صَاحِبٌ':Subject, #2: 2	خَرَجَ صَاحِبُ
u'خَرَّجَ صِحَّةٌ':Predicate, #2: 2	خَرَّجَ صَاحِبُ
u'خَرَّجَ صَحِيحٌ':Predicate, #1: 1	خَرَّجَ الصِّحَّةَ
u'خَرَجَ صَدْرٌ':Subject, #1: 1	خَرَّجَ الصَّحِيحَ
u'خَرَجَ صَفْوَان':Subject, #1: 1	خَرَجَ صَدْرُهُ
u'خَرَجَ صَوْتٌ':Subject, #1: 1	خَرَجَ صَفْوَانُ
u'خَرَجَ صَيْدٌ':Subject, #1: 1	خَرَجَ صَوْتُهُ
u'خَرَجَ طَائِفٌ':Subject, #1: 1	خَرَجَ الصَّيْدُ
u'خَرَّجَ طَائِفٌ':Subject, #1: 1	خَرَجَ الطَّائِفُ
u'خَرَجَ طَرَفٌ':Subject, #1: 1	خَرَّجَ طَائِفَةٌ
u'خَرَجَ طرف':Subject, #1: 1	خَرَجَ طَرَفٌ
u'خَرَجَ طَرَفٌ':Subject, #1: 1	خَرَجَ طَرَفُهُ
u'خَرَجَ طَلْعٌ':Subject, #1: 1	خَرَجَ طَرَفُهُ
u'خَرَجَ طَلْعٌ':Subject, #1: 1	خَرَجَ الطَّلْعُ
u'خَرَجَ طَهَارَةٌ':Subject, #1: 1	خَرَجَ طَلْعٌ
u'خَرَجَ عَامٌ':Predicate, #1: 1	خَرَجَ طَهَارَةٌ
u'خَرَجَ عَبْدٌ':Subject, #5: 5	خَرَجَ عَامَ
u'خَرَجَ عَبْدٌ':Subject, #10: 10	خَرَجَ عَبْدُ
u'خَرَجَ عَبْدٌ':Subject, #23: 23	خَرَجَ الْعَبْدُ
u'خَرَجَ عتبة':Subject, #2: 2	خَرَجَ عَبْدٌ
u'خَرَجَ عتق':Predicate, #1: 1	خَرَجَ عُتْبَةُ
u'خَرَجَ عتق':Subject, #1: 1	خَرَجَ عَتَقَ
u'خَرَجَ عِتْقٌ':Subject, #3: 3	خَرَجَ الْعِتْقُ
u'خَرَجَ عَدَدٌ':Subject, #3: 3	خَرَجَ الْعِتْقُ
u'خَرَجَ عَدْلٌ':Subject, #2: 2	خَرَجَ عَدَدُ
u'خَرَّجَ عَدَمٌ':Predicate, #1: 1	خَرَجَ الْعَدْلُ
u'خَرَجَ عَرَضٌ':Subject, #2: 2	خَرَّجَ عَدَمَ
u'خَرَجَ عرف':Predicate, #1: 1	خَرَجَ الْعَرَضُ
u'خَرَجَ عَشْرٌ':Subject, #1: 1	خَرَجَ عُرِفَ
u'خَرَجَ عَقِبٌ':Predicate, #1: 1	خَرَجَ عَشْرٌ
u'خَرَجَ عَقْلٌ':Subject, #1: 1	خَرَجَ عَقِبَ
u'خَرَجَ علم':Predicate, #1: 1	خَرَجَ الْعَقْلُ
u'خَرَجَ علم':Subject, #1: 1	خَرَجَ عُلِمَ
u'خَرَجَ عِلْمٌ':Subject, #1: 1	خَرَجَ عِلْمُ
u'خَرَجَ عَلِيٌّ':Subject, #1: 1	خَرَجَ عِلْمُ
u'خَرَجَ عُمَرٌ':Predicate, #3: 3	خَرَجَ عَلِيٌّ
u'خَرَجَ عُمَرٌ':Subject, #1: 1	خَرَجَ عُمَرَ
u'خَرَجَ عند':Predicate, #8: 8	خَرَجَ عُمَرُ
u'خَرَجَ غَاصِبٌ':Subject, #2: 2	خَرَجَ عِنْدَ
u'خَرَجَ غُصْنٌ':Subject, #1: 1	خَرَجَ غَاصِبُ
u'خَرَجَ غُفْلٌ':Subject, #1: 1	خَرَجَ الْغُصْنُ
u'خَرَجَ غير':Predicate, #1: 1	خَرَجَ الْغُفْلُ
u'خَرَجَ غَيْرٌ':Predicate, #3: 3	خَرَجَ غَيْرَ
u'خَرَجَ فَجْرٌ':Subject, #3: 3	خَرَجَ غَيْرَ
u'خَرَجَ فَرْخٌ':Subject, #1: 1	خَرَجَ الْفَجْرُ
u'خَرَجَ فَرْضٌ':Subject, #2: 2	خَرَجَ فَرْخٌ
u'خَرَجَ فَرْعٌ':Subject, #1: 1	خَرَجَ الْفَرْضُ
u'خَرَجَ فِعْلٌ':Subject, #1: 1	خَرَجَ الْفَرْعُ
u'خَرَجَ فَقِيرٌ':Subject, #1: 1	خَرَجَ الْفِعْلُ
u'خَرَجَ فلان':Subject, #1: 1	خَرَجَ الْفَقِيرُ
u'خَرَجَ فلان':Subject, #1: 1	خَرَجَ الشَّافِعِيُّ
u'خَرَجَ فلان':Subject, #1: 1	خَرَجَ الْمِقْدَادُ
u'خَرَجَ فلان':Subject, #1: 1	خَرَجَ بُرَيْدَةُ
u'خَرَجَ فلان':Subject, #1: 1	خَرَجَ بِلاَلٌ
u'خَرَجَ فلان':Subject, #1: 1	خَرَجَ جَعْفَرُ
u'خَرَّجَ فلان':Subject, #1: 1	خَرَجَ مَكِّيٌّ
u'خَرَجَ فلان':Subject, #2: 2	خَرَّجَ التِّرْمِذِيُّ
u'خَرَجَ فُلاَنٌ':Subject, #2: 2	خَرَجَ مُعَاوِيَةُ
u'خَرَجَ فلان':Subject, #3: 3	خَرَجَ فُلَانٌ
u'خَرَجَ فلان':Subject, #4: 4	خَرَجَ عُثْمَانُ
u'خَرَجَ فَيْلَقٌ':Subject, #7: 7	خَرَجَ الْمَكِّيُّ
u'خَرَجَ قَالٌ':Predicate, #1: 1	خَرَجَ الْفَيْلَقُ
u'خَرَجَ قَبُولٌ':Subject, #15: 15	خَرَجَ قَالَ
u'خَرَجَ قتل':Subject, #1: 1	خَرَجَ الْقَبُولُ
u'خَرَجَ قَتْلٌ':Subject, #1: 1	خَرَجَ الْقَتْلُ
u'خَرَجَ قدم':Subject, #1: 1	خَرَجَ الْقَتْلُ
u'خَرَجَ قَدَمٌ':Subject, #1: 1	خَرَجَ الْقَدَمُ
u'خَرَجَ قُرْعَةٌ':Subject, #1: 1	خَرَجَ الْقَدَمُ
u'خَرَجَ قَطْعٌ':Subject, #1: 1	خَرَجَ قُرْعَةُ
u'خَرَجَ قول':Subject, #1: 1	خَرَجَ الْقَطْعُ
u'خَرَجَ قَوْلٌ':Subject, #1: 1	خَرَجَ قَوْلُ
u'خَرَجَ قَوْمٌ':Subject, #1: 1	خَرَجَ قَوْلُ
u'خَرَجَ قَوْمٌ':Subject, #2: 2	خَرَجَ الْقَوْمُ
u'خَرَجَ قِيَاسٌ':Subject, #8: 8	خَرَجَ قَوْمٌ
u'خَرَجَ كَافِرٌ':Subject, #1: 1	خَرَجَ الْقِيَاسُ
u'خَرَجَ كرش':Subject, #1: 1	خَرَجَ كَافِرٌ
u'خَرَجَ كِرْشٌ':Subject, #1: 1	خَرَجَ الْكِرْشُ
u'خَرَجَ كَعْبٌ':Subject, #1: 1	خَرَجَ الْكِرْشُ
u'خَرَجَ كِفَايَةٌ':Subject, #2: 2	خَرَجَ كَعْبٌ
u'خَرَجَ كَلاَمٌ':Subject, #1: 1	خَرَجَ الْكِفَايَةُ
u'خَرَجَ كَلاَمٌ':Subject, #1: 1	خَرَجَ كَلَامُهُ
u'خَرَجَ كَلْبٌ':Subject, #7: 7	خَرَجَ الْكَلَامُ
u'خَرَجَ كُوفِيٌّ':Subject, #1: 1	خَرَجَ الْكَلْبُ
u'خَرَجَ كُوفِيٌّ':Subject, #1: 1	خَرَجَ الْكُوفِيُّ
u'خَرَجَ لبن':Subject, #1: 1	خَرَجَ كُوفِيٌّ
u'خَرَجَ لَبَنٌ':Subject, #4: 4	خَرَجَ اللَّبَنُ
u'خَرَجَ لُصُوصٌ':Subject, #4: 4	خَرَجَ اللَّبَنُ
u'خَرَجَ لَفْظٌ':Subject, #2: 2	خَرَجَ اللُّصُوصُ
u'خَرَجَ لَيَالِي':Predicate, #1: 1	خَرَجَ اللَّفْظُ
u'خَرَجَ لَيْلٌ':Predicate, #1: 1	خَرَجَ لَيَالِيَ
u'خَرَجَ لَيْلٌ':Predicate, #2: 2	خَرَجَ لَيْلَةَ
u'خَرَجَ مَاءٌ':Subject, #4: 4	خَرَجَ لَيْلَةً
u'خَرَجَ مَاءٌ':Subject, #7: 7	خَرَجَ مَاءُ
u'خَرَجَ مَأْكُولٌ':Subject, #9: 9	خَرَجَ الْمَاءُ
u'خَرَجَ مَالٌ':Subject, #1: 1	خَرَجَ الْمَأْكُولُ
u'خَرَجَ مَالٌ':Subject, #1: 1	خَرَجَ الْمَالُ
u'خَرَجَ مَأْمُورٌ':Subject, #1: 1	خَرَجَ مَالُهُ
u'خَرَجَ مَبِيعٌ':Predicate, #1: 1	خَرَجَ الْمَأْمُورُ
u'خَرَجَ مَبِيعٌ':Subject, #1: 1	خَرَجَ الْمَبِيعَ
u'خَرَجَ مَتْرُوكٌ':Subject, #19: 19	خَرَجَ الْمَبِيعُ
u'خَرَجَ مُتَغَيِّرٌ':Predicate, #2: 2	خَرَجَ مَتْرُوكُ
u'خَرَجَ مثل':Subject, #1: 1	خَرَجَ مُتَغَيِّرَ
u'خَرَجَ مِثْلٌ':Subject, #1: 1	خَرَجَ الْمِثْلُ
u'خَرَجَ مثل':Subject, #1: 1	خَرَجَ الْمِثْلُ
u'خَرَجَ مِثْلٌ':Subject, #1: 1	خَرَجَ مِثْلُهُ
u'خَرَجَ مِثْلِيٌّ':Subject, #1: 1	خَرَجَ مِثْلُهُ
u'خَرَجَ مُجَاهِدٌ':Subject, #1: 1	خَرَجَ الْمِثْلِيُّ
u'خَرَّجَ مَجْدٌ':Subject, #1: 1	خَرَجَ الْمُجَاهِدُ
u'خَرَجَ مَجْرُوحٌ':Subject, #1: 1	خَرَّجَ الْمَجْدُ
u'خَرَّجَ مُحَمَّدٌ':Subject, #1: 1	خَرَجَ الْمَجْرُوحُ
u'خَرَجَ مُخْتَارٌ':Subject, #1: 1	خَرَّجَ مُحَمَّدٌ
u'خَرَجَ مَخْرَجٌ':Predicate, #1: 1	خَرَجَ الْمُخْتَارُ
u'خَرَجَ مُدَبَّرٌ':Subject, #58: 58	خَرَجَ مَخْرَجَ
u'خَرَجَ مرٌّ':Predicate, #1: 1	خَرَجَ الْمُدَبَّرُ
u'خَرَجَ مرٌّ':Predicate, #1: 1	خَرَجَ مَرّةً
u'خَرَجَ مُرَتَّبٌ':Subject, #1: 1	خَرَجَ مَرَّةً
u'خَرَجَ مُرْتَهِنٌ':Subject, #1: 1	خَرَجَ الْمُرَتَّبُ
u'خَرَجَ مَرْحَبٌ':Subject, #1: 1	خَرَجَ الْمُرْتَهِنُ
u'خَرَجَ مُزَاحِمٌ':Subject, #6: 6	خَرَجَ مَرْحَبٌ
u'خَرَّجَ مَسْأَلَةٌ':Predicate, #1: 1	خَرَجَ الْمُزَاحِمُ
u'خَرَجَ مُسْتَأْجِرٌ':Subject, #3: 3	خَرَّجَ الْمَسْأَلَةَ
u'خَرَجَ مُسْتَعْجِلٌ':Predicate, #3: 3	خَرَجَ الْمُسْتَأْجِرُ
u'خَرَجَ مُسْلِمٌ':Subject, #1: 1	خَرَجَ مُسْتَعْجِلاً
u'خَرَّجَ مُسْلِمٌ':Subject, #2: 2	خَرَجَ الْمُسْلِمُ
u'خَرَجَ مَسِيرَةٌ':Predicate, #2: 2	خَرَّجَ مُسْلِمٌ
u'خَرَّجَ مُصَنِّفٌ':Subject, #4: 4	خَرَجَ مَسِيرَةَ
u'خَرَجَ مُضَارِبٌ':Subject, #2: 2	خَرَّجَ الْمُصَنِّفُ
u'خَرَجَ مُعاوِيَة':Subject, #1: 1	خَرَجَ الْمُضَارِبُ
u'خَرَجَ مُعْتَادٌ':Subject, #2: 2	خَرَجَ مُعَاوِيَةُ
u'خَرَجَ مُعْتَمِرٌ':Subject, #1: 1	خَرَجَ الْمُعْتَادُ
u'خَرَجَ مُعَجَّلٌ':Subject, #1: 1	خَرَجَ الْمُعْتَمِرُ
u'خَرَجَ مَعِيبٌ':Subject, #1: 1	خَرَجَ الْمُعَجَّلُ
u'خَرَجَ مُعَيَّنٌ':Subject, #3: 3	خَرَجَ الْمَعِيبُ
u'خَرَجَ مِقْدَارٌ':Subject, #1: 1	خَرَجَ الْمُعَيَّنُ
u'خَرَجَ مُكْرِهٌ':Subject, #1: 1	خَرَجَ مِقْدَارُ
u'خَرَجَ مَكِّيّ':Subject, #1: 1	خَرَجَ الْمُكْرِهُ
u'خَرَجَ مَكِّيّ':Subject, #1: 1	خَرَجَ مَكِّيٌّ
u'خَرَجَ مَلَكٌ':Subject, #7: 7	خَرَجَ الْمَكِّيُّ
u'خَرَجَ مَنْزِلٌ':Subject, #1: 1	خَرَجَ مَلَكٌ
u'خَرَجَ مَنِيٌّ':Subject, #1: 1	خَرَجَ مَنْزِلُهُ
u'خَرَجَ مَنِيٌّ':Subject, #12: 12	خَرَجَ الْمَنِيُّ
u'خَرَجَ مَنِيٌّ':Subject, #1: 1	خَرَجَ مَنِيٌّ
u'خَرَجَ مَنِيٌّ':Subject, #1: 1	خَرَجَ مَنِيُّ
u'خَرَجَ مُودَعٌ':Subject, #2: 2	خَرَجَ مَنِيُّهُ
u'خَرَجَ مُوَدِّعٌ':Subject, #1: 1	خَرَجَ الْمُودَعُ
u'خَرَجَ مُوَكِّلٌ':Subject, #1: 1	خَرَجَ الْمُوَدِّعُ
u'خَرَجَ مَوْهُوبٌ':Subject, #1: 1	خَرَجَ الْمُوَكِّلُ
u'خَرَجَ مِيقَاتٌ':Subject, #1: 1	خَرَجَ الْمَوْهُوبُ
u'خَرَجَ نَاسٌ':Subject, #1: 1	خَرَجَ الْمِيقَاتُ
u'خَرَجَ نَاسٌ':Subject, #1: 1	خَرَجَ نَاسٌ
u'خَرَجَ نَبِيٌّ':Subject, #5: 5	خَرَجَ النَّاسُ
u'خَرَجَ نَجْمٌ':Subject, #23: 23	خَرَجَ النَّبِيُّ
u'خَرَجَ نَحْوٌ':Predicate, #1: 1	خَرَجَ نَجْمُهُ
u'خَرَجَ نذر':Subject, #1: 1	خَرَجَ نَحْوَ
u'خَرَجَ نَذْرٌ':Subject, #1: 1	خَرَجَ النَّذْرُ
u'خَرَجَ نِصْفٌ':Subject, #1: 1	خَرَجَ النَّذْرُ
u'خَرَجَ نِصْفٌ':Subject, #2: 2	خَرَجَ نِصْفُ
u'خَرَجَ نَصِيبٌ':Subject, #2: 2	خَرَجَ نِصْفُهُ
u'خَرَجَ نَفَرٌ':Subject, #1: 1	خَرَجَ النَّصِيبُ
u'خَرَجَ نَفَلٌ':Subject, #1: 1	خَرَجَ نَفَرٌ
u'خَرَجَ نُورٌ':Subject, #1: 1	خَرَجَ النَّفَلُ
u'خَرَجَ هِبَةٌ':Subject, #1: 1	خَرَجَ نُورُ
u'خَرَجَ هشام':Subject, #1: 1	خَرَجَ الْهِبَةُ
u'خَرَجَ هِشَامٌ':Subject, #1: 1	خَرَجَ هِشَامٌ
u'خَرَجَ واحد':Subject, #1: 1	خَرَجَ هِشَامٌ
u'خَرَجَ وَاحِدٌ':Subject, #6: 6	خَرَجَ وَاحِدٌ
u'خَرَجَ وَجْهٌ':Subject, #6: 6	خَرَجَ وَاحِدٌ
u'خَرَجَ وُجُوبٌ':Subject, #1: 1	خَرَجَ وَجْهُهُ
u'خَرَجَ وَرَثَةٌ':Subject, #1: 1	خَرَجَ وُجُوبُ
u'خَرَجَ وُضُوءٌ':Subject, #1: 1	خَرَجَ وَرَثَتُهُ
u'خَرَجَ وَفْدٌ':Subject, #1: 1	خَرَجَ الْوُضُوءُ
u'خَرَجَ وَقْتٌ':Subject, #2: 2	خَرَجَ وَفْدُ
u'خَرَجَ وَقْتٌ':Subject, #124: 124	خَرَجَ الْوَقْتُ
u'خَرَجَ وَقْتٌ':Subject, #40: 40	خَرَجَ وَقْتُ
u'خَرَجَ وَكِيلٌ':Subject, #7: 7	خَرَجَ وَقْتُهُ
u'خَرَجَ وَكِيلٌ':Subject, #11: 11	خَرَجَ الْوَكِيلُ
u'خَرَجَ ولد':Subject, #1: 1	خَرَجَ وَكِيلُهُ
u'خَرَجَ وَلَدٌ':Subject, #6: 6	خَرَجَ الْوَلَدُ
u'خَرَجَ وَلِيٌّ':Subject, #6: 6	خَرَجَ الْوَلَدُ
u'خَرَجَ يَاسِرٌ':Subject, #1: 1	خَرَجَ وَلِيُّ
u'خَرَجَ يَوْمٌ':Predicate, #1: 1	خَرَجَ يَاسِرٌ
u'خَرَجَ يَوْمٌ':Subject, #26: 26	خَرَجَ يَوْمَ
u'خَرَّ رَجُلٌ':Subject, #2: 2	خَرَجَ يَوْمُ
u'خَرِسَ أَصَمّ':Predicate, #2: 2	خَرَّ رَجُلٌ
u'خَرِسَ إمَامٌ':Subject, #2: 2	أَخْرَسَ أَصَمَّ
u'خَرِسَ بَائِعٌ':Subject, #1: 1	خَرِسَ إمَامُهُ
u'خَرِسَ حالٌ':Predicate, #1: 1	خَرِسَ الْبَائِعُ
u'خَرَسَ لِسَانٌ':Subject, #1: 1	أَخْرَسَ حَالَ
u'خَرَصَ ثَلاثَةٌ':Subject, #1: 1	خَرَسَ لِسَانُهُ
u'خَرَصَ حَديقَةٌ':Predicate, #1: 1	خَرَصَ ثَلَاثَةٌ
u'خَرَّ صَفٌّ':Subject, #1: 1	خَرَصَ حَدِيقَةَ
u'خَرَّ عنق':Subject, #2: 2	خَرَّ الصَّفُّ
u'خَرَّ عُنُقٌ':Subject, #1: 1	خَرَّ عُنُقُ
u'خَرَقَ إِجْمَاعٌ':Predicate, #1: 1	خَرَّ عُنُقُ
u'خَرَقَ إِجْمَاعٌ':Predicate, #1: 1	خَرَقَ إجْمَاعَ
u'خرق إِجْمَاعٌ':Added, #3: 3	خَرَقَ الْإِجْمَاعَ
u'خَرْقٌ إِجْمَاعٌ':Added, #5: 5	خَرْقُ الْإِجْمَاعِ
u'خرق إِجْمَاعٌ':Added, #5: 5	خَرْقُ الْإِجْمَاعِ
u'خَرْقٌ إِجْمَاعٌ':Added, #7: 7	خَرْقِ الْإِجْمَاعِ
u'خَرَقَ آخِرُ':Subject, #7: 7	خَرْقِ الْإِجْمَاعِ
u'خَرَقَ أَعْرَاضٌ':Predicate, #1: 1	خَرَقَ آخِرُ
u'خرق أَمْعاءٌ':Added, #1: 1	خَرَقَ أَعْرَاضَ
u'خرق أَمْعَاءٌ':Added, #1: 1	خَرْقِ الْأَمْعَاءِ
u'خَرْقٌ أَمْعاءٌ':Added, #1: 1	خَرْقِ الْأَمْعَاءِ
u'خَرْقٌ أَمْعَاءٌ':Added, #1: 1	خَرْقِ الْأَمْعَاءِ
u'خرق أوداج':Added, #1: 1	خَرْقِ الْأَمْعَاءِ
u'خَرْقٌ أوداج':Added, #1: 1	خَرْقُ الْأَوْدَاجِ
u'خرق تَعْصِيبٌ':Added, #1: 1	خَرْقُ الْأَوْدَاجِ
u'خَرْقٌ تَعْصِيبٌ':Added, #1: 1	خَرْقِ التَّعْصِيبِ
u'خَرَقَ ثَوْبٌ':Predicate, #1: 1	خَرْقِ التَّعْصِيبِ
u'خَرَقَ ثَوْبٌ':Subject, #11: 11	خَرَقَ ثَوْبَ
u'خرق ثَوْبٌ':Added, #2: 2	خَرَقَ الثَّوْبُ
u'خَرْقٌ ثَوْبٌ':Added, #1: 1	خَرْقِ الثَّوْبِ
u'خرق ثَوْبٌ':Added, #1: 1	خَرْقِ الثَّوْبِ
u'خَرْقٌ ثَوْبٌ':Added, #1: 1	خَرْقَ ثَوْبِ
u'خرق جِرَابٌ':Added, #1: 1	خَرْقَ ثَوْبِ
u'خَرْقٌ جِرَابٌ':Added, #1: 1	خَرْقِ الْجِرَابِ
u'خرق جِلْدَةٌ':Added, #1: 1	خَرْقِ الْجِرَابِ
u'خَرْقٌ جِلْدَةٌ':Added, #1: 1	خَرْقِ الْجِلْدَةِ
u'خرق حاجِزٌ':Added, #1: 1	خَرْقِ الْجِلْدَةِ
u'خَرْقٌ حاجِزٌ':Added, #1: 1	خَرْقَ الْحَاجِزِ
u'خرق خَرِيطَةٌ':Added, #1: 1	خَرْقَ الْحَاجِزِ
u'خَرْقٌ خَرِيطَةٌ':Added, #1: 1	خَرْقُ خَرِيطَةِ
u'خرق خضر':Added, #1: 1	خَرْقُ خَرِيطَةِ
u'خَرْقٌ خضر':Added, #1: 1	خَرْقِ الْخَضِرِ
u'خرق خَضِرٌ':Added, #1: 1	خَرْقِ الْخَضِرِ
u'خَرْقٌ خَضِرٌ':Added, #1: 1	خَرْقِ الْخَضِرِ
u'خَرَقَ زِقٌّ':Predicate, #1: 1	خَرْقِ الْخَضِرِ
u'خَرَقَ سترة':Predicate, #1: 1	خَرَقَ الزِّقَّ
u'خَرَقَ سُتْرَةٌ':Predicate, #1: 1	خَرَقَ السُّتْرَةَ
u'خرق صُفُوفٌ':Added, #1: 1	خَرَقَ السُّتْرَةَ
u'خَرْقٌ صُفُوفٌ':Added, #2: 2	خَرْقُ الصُّفُوفِ
u'خرق صُفُوفٌ':Added, #2: 2	خَرْقُ الصُّفُوفِ
u'خَرْقٌ صُفُوفٌ':Added, #3: 3	خَرْقِ الصُّفُوفِ
u'خَرَقَ صَكٌّ':Predicate, #3: 3	خَرْقِ الصُّفُوفِ
u'خرق عَادَةٌ':Added, #2: 2	خَرَقَ صَكَّ
u'خَرْقٌ عَادَةٌ':Added, #1: 1	خَرْقُ الْعَادَاتِ
u'خرق عَادَةٌ':Added, #1: 1	خَرْقُ الْعَادَاتِ
u'خَرْقٌ عَادَةٌ':Added, #1: 1	خَرْقُ الْعَادَةِ
u'خرق عَادَةٌ':Added, #1: 1	خَرْقُ الْعَادَةِ
u'خَرْقٌ عَادَةٌ':Added, #2: 2	خَرْقِ الْعَادَةِ
u'خرق عَادَةٌ':Added, #2: 2	خَرْقِ الْعَادَةِ
u'خَرْقٌ عَادَةٌ':Added, #3: 3	خَرْقَ الْعَادَةِ
u'خرق عَوَائِدُ':Added, #3: 3	خَرْقَ الْعَادَةِ
u'خرق عَوَائِدُ':Added, #1: 1	خَرْقُ الْعَوَائِدِ
u'خَرْقٌ عَوَائِدُ':Added, #1: 1	خَرْقِ الْعَوَائِدِ
u'خَرْقٌ عَوَائِدُ':Added, #1: 1	خَرْقُ الْعَوَائِدِ
u'خَرَقَ غَرَضٌ':Predicate, #1: 1	خَرْقِ الْعَوَائِدِ
u'خَرَقَ فُلاَنٌ':Subject, #1: 1	خَرَقَ الْغَرَضَ
u'خَرَقَ كِيسٌ':Predicate, #1: 1	خَرَقَ فُلَانٌ
u'خرق كِيسٌ':Added, #2: 2	خَرَقَ الْكِيسَ
u'خَرْقٌ كِيسٌ':Added, #1: 1	خَرْقِ الْكِيسِ
u'خَرَمَ أَنْفٌ':Predicate, #1: 1	خَرْقِ الْكِيسِ
u'خَرُمَ حَرْفٌ':Subject, #1: 1	خَرَمَ أَنْفَ
u'خُرُوجٌ أَبٌ':Added, #2: 2	خَرُمَ حَرْفٌ
u'خُرُوجٌ اِجْتِهَادٌ':Added, #1: 1	خُرُوجِ الْأَبِ
u'خُرُوجٌ أَجِيرٌ':Added, #1: 1	خُرُوجِ اجْتِهَادِ
u'خُرُوجٌ أحْزَابٌ':Added, #1: 1	خُرُوجِ الْأَجِيرِ
u'خُرُوجٌ أخْذٌ':Added, #1: 1	خُرُوجُ الْأَحْزَابِ
u'خُرُوجٌ اِسْمٌ':Added, #1: 1	خُرُوجِ الْأَخْذِ
u'خُرُوجٌ أسْوَد':Added, #1: 1	خُرُوجِ اسْمِ
u'خُرُوجٌ أَشْجَارٌ':Added, #1: 1	خُرُوجَ الْأَسْوَدِ
u'خُرُوجٌ أَصْحَابٌ':Added, #1: 1	خُرُوجُ الْأَشْجَارِ
u'خُرُوجٌ أصل':Added, #1: 1	خُرُوجَ أَصْحَابِهِ
u'خُرُوجٌ أًصْلٌ':Added, #1: 1	خُرُوجُ الْأَصْلِ
u'خُرُوجٌ أقَلُّ':Added, #1: 1	خُرُوجُ الْأَصْلِ
u'خُرُوجٌ أقوياء':Added, #2: 2	خُرُوجُ الْأَقَلِّ
u'خُرُوجٌ أقوياء':Added, #1: 1	خُرُوجَ الْأَقْوِيَاءِ
u'خُرُوجٌ أَكْثَرُ':Added, #1: 1	خُرُوجِ الْأَقْوِيَاءِ
u'خُرُوجٌ أَكْثَرُ':Added, #1: 1	خُرُوجَ الْأَكْثَرِ
u'خُرُوجٌ أَكْثَرُ':Added, #2: 2	خُرُوجُ أَكْثَرِ
u'خُرُوجٌ أَكْثَرُ':Added, #2: 2	خُرُوجِ أَكْثَرِهِ
u'خُرُوجٌ أَكْثَرُ':Added, #2: 2	خُرُوجِ الْأَكْثَرِ
u'خُرُوجٌ أَكْثَرُ':Added, #4: 4	خُرُوجَ أَكْثَرِ
u'خُرُوجٌ الْمَرْأَةُ':Added, #4: 4	خُرُوجِ أَكْثَرِ
u'خُرُوجٌ الْمَرْأَةُ':Added, #2: 2	خُرُوجُ الْمَرْأَةِ
u'خُرُوجٌ إمَامٌ':Added, #3: 3	خُرُوجِ الْمَرْأَةِ
u'خُرُوجٌ إمَامٌ':Added, #1: 1	خُرُوجَ الْإِمَامِ
u'خُرُوجٌ إمَامٌ':Added, #1: 1	خُرُوجِ إمَامٍ
u'خُرُوجٌ إمَامٌ':Added, #2: 2	خُرُوجُ الإِمَامِ
u'خُرُوجٌ إمَامٌ':Added, #30: 30	خُرُوجِ الْإِمَامِ
u'خُرُوجٌ إمَامٌ':Added, #4: 4	خُرُوجِ الإِمَامِ
u'خُرُوجٌ أَمْرٌ':Added, #8: 8	خُرُوجُ الْإِمَامِ
u'خُرُوجٌ أمراء':Added, #4: 4	خُرُوجِ الْأَمْرِ
u'خُرُوجٌ أَمْلاكٌ':Added, #1: 1	خُرُوجُ الْأُمَرَاءِ
u'خُرُوجٌ أَمْلاَكٌ':Added, #1: 1	خُرُوجِ الْأَمْلَاكِ
u'خُرُوجٌ اِنْتِقالٌ':Added, #1: 1	خُرُوجِ الْأَمْلَاكِ
u'خُرُوجٌ اِنْتِقالٌ':Added, #1: 1	خُرُوجَ انْتِقَالٍ
u'خُرُوجٌ أهْلٌ':Added, #1: 1	خُرُوجُ انْتِقَالٍ
u'خُرُوجٌ أَوْلاَدٌ':Added, #12: 12	خُرُوجِ أَهْلِ
u'خُرُوجٌ أيَّامٌ':Added, #1: 1	خُرُوجِ أَوْلَادِ
u'خُرُوجٌ أَيَّامٌ':Added, #1: 1	خُرُوجُ أَيَّامِ
u'خُرُوجٌ أيَّامٌ':Added, #1: 1	خُرُوجُ أَيَّامِ
u'خُرُوجٌ أَيَّامٌ':Added, #2: 2	خُرُوجِ أَيَّامِ
u'خُرُوجٌ بَائِعٌ':Added, #2: 2	خُرُوجِ أَيَّامِ
u'خُرُوجٌ بَحْثٌ':Added, #1: 1	خُرُوجُ الْبَائِعِ
u'خُرُوجٌ بَدَلٌ':Added, #1: 1	خُرُوجُ الْبَحْثِ
u'خُرُوجٌ بدن':Added, #2: 2	خُرُوجَ الْبَدَلِ
u'خُرُوجٌ بَدَنٌ':Added, #1: 1	خُرُوجِ الْبَدَنِ
u'خُرُوجٌ بُسْتانٌ':Added, #1: 1	خُرُوجِ الْبَدَنِ
u'خُرُوجٌ بسط':Added, #1: 1	خُرُوجُ الْبُسْتَانِ
u'خُرُوجٌ بُسُطٌ':Added, #1: 1	خُرُوجُ بُسُطِ
u'خُرُوجٌ بِضْعٌ':Added, #1: 1	خُرُوجُ بُسُطِ
u'خُرُوجٌ بَعْضٌ':Added, #1: 1	خُرُوجَ الْبِضْعِ
u'خُرُوجٌ بَعْضٌ':Added, #1: 1	خُرُوجَ الْبَعْضِ
u'خُرُوجٌ بَعْضٌ':Added, #1: 1	خُرُوجَ بَعْضِ
u'خُرُوجٌ بَعْضٌ':Added, #1: 1	خُرُوجَ بَعْضِهِ
u'خُرُوجٌ بَعْضٌ':Added, #1: 1	خُرُوجُ بَعْضِهِ
u'خُرُوجٌ بَعْضٌ':Added, #2: 2	خُرُوجِ بَعْضِهِ
u'خُرُوجٌ بَعْضٌ':Added, #3: 3	خُرُوجُ بَعْضِ
u'خُرُوجٌ بَلْغَم':Added, #6: 6	خُرُوجِ بَعْضِ
u'خُرُوجٌ بَهائِمُ':Added, #1: 1	خُرُوجُ الْبَلْغَمِ
u'خُرُوجٌ بَوْلٌ':Added, #1: 1	خُرُوجِ الْبَهَائِمِ
u'خُرُوجٌ بَوْلٌ':Added, #1: 1	خُرُوجَ الْبَوْلِ
u'خُرُوجٌ بَوْلٌ':Added, #2: 2	خُرُوجُ بَوْلٍ
u'خُرُوجٌ تُفْل':Added, #3: 3	خُرُوجُ الْبَوْلِ
u'خُرُوجٌ ثَالِثٌ':Added, #1: 1	خُرُوجَ التُّفْلِ
u'خُرُوجٌ ثِمارٌ':Added, #2: 2	خُرُوجِ الثَّالِثِ
u'خُرُوجٌ ثِمارٌ':Added, #1: 1	خُرُوجَ الثِّمَارِ
u'خُرُوجٌ ثَمَرٌ':Added, #2: 2	خُرُوجِ الثِّمَارِ
u'خُرُوجٌ ثَمَرَةٌ':Added, #3: 3	خُرُوجِ الثَّمَرِ
u'خُرُوجٌ ثَمَرَةٌ':Added, #1: 1	خُرُوجُ الثَّمَرَةِ
u'خُرُوجٌ ثَمَنٌ':Added, #7: 7	خُرُوجِ الثَّمَرَةِ
u'خُرُوجٌ ثَوْبٌ':Added, #1: 1	خُرُوجَ الثَّمَنِ
u'خُرُوجٌ جِبِلَّةٌ':Added, #1: 1	خُرُوجِ الثَّوْبِ
u'خُرُوجٌ جُدَرِيٌّ':Added, #1: 1	خُرُوجُ الْجِبِلَّةِ
u'خُرُوجٌ جِصٌّ':Added, #1: 1	خُرُوجِ الْجُدَرِيِّ
u'خُرُوجٌ جلد':Added, #1: 1	خُرُوجَ الْجِصِّ
u'خُرُوجٌ جِلْدٌ':Added, #1: 1	خُرُوجِ الْجِلْدِ
u'خُرُوجٌ جَنِينٌ':Added, #1: 1	خُرُوجِ الْجِلْدِ
u'خُرُوجٌ جَنِينٌ':Added, #1: 1	خُرُوجَ الْجَنِينِ
u'خُرُوجٌ جَوَابٌ':Added, #2: 2	خُرُوجِ الْجَنِينِ
u'خُرُوجٌ حاجٌّ':Added, #1: 1	خُرُوجَ الْجَوَابِ
u'خُرُوجٌ حاجٌّ':Added, #1: 1	خُرُوجُ الْحَاجِّ
u'خُرُوجٌ حاطِبٌ':Added, #2: 2	خُرُوجِ الْحَاجِّ
u'خُرُوجٌ حالَةٌ':Added, #1: 1	خُرُوجِ حَاطِبٍ
u'خُرُوجٌ حُبٌّ':Added, #1: 1	خُرُوجَ حَالَةِ
u'خُرُوجٌ حَجَرٌ':Added, #1: 1	خُرُوجُ حُبِّ
u'خُرُوجٌ حَدَثٌ':Added, #1: 1	خُرُوجُ الْحَجَرِ
u'خُرُوجٌ حَدَثٌ':Added, #1: 1	خُرُوجَ الْحَدَثِ
u'خُرُوجٌ حَدَثٌ':Added, #2: 2	خُرُوجُ الْحَدَثِ
u'خُرُوجٌ حَدْسٌ':Added, #3: 3	خُرُوجِ الْحَدَثِ
u'خُرُوجٌ حَقٌّ':Added, #1: 1	خُرُوجُ الْحَدْسِ
u'خُرُوجٌ حَقٌّ':Added, #1: 1	خُرُوجُ الْحَقِّ
u'خُرُوجٌ حُكْمٌ':Added, #1: 1	خُرُوجِ الْحَقِّ
u'خُرُوجٌ حَلاَوَةٌ':Added, #1: 1	خُرُوجِ الْحُكْمِ
u'خُرُوجٌ حَمْلٌ':Added, #1: 1	خُرُوجِ الْحَلَاوَةِ
u'خُرُوجٌ حَيْضٌ':Added, #1: 1	خُرُوجِ الْحَمْلِ
u'خُرُوجٌ حَيْضٌ':Added, #1: 1	خُرُوجُ الْحَيْضِ
u'خُرُوجٌ خَارِجٌ':Added, #2: 2	خُرُوجِ الْحَيْضِ
u'خُرُوجٌ خَارِجٌ':Added, #1: 1	خُرُوجُ خَارِجٍ
u'خُرُوجٌ خَارِجٌ':Added, #2: 2	خُرُوجَ الْخَارِجِ
u'خُرُوجٌ خَارِجٌ':Added, #2: 2	خُرُوجِ خَارِجٍ
u'خُرُوجٌ خَارِجٌ':Added, #3: 3	خُرُوجُ الْخَارِجِ
u'خُرُوجٌ خَاصَّةٌ':Added, #5: 5	خُرُوجِ الْخَارِجِ
u'خُرُوجٌ خامس':Added, #1: 1	خُرُوجَ الْخَاصَّةِ
u'خُرُوجٌ خَامِسٌ':Added, #1: 1	خُرُوجِ الْخَامِسِ
u'خُرُوجٌ خَطِيبٌ':Added, #1: 1	خُرُوجِ الْخَامِسِ
u'خُرُوجٌ خِلاَفٌ':Added, #8: 8	خُرُوجِ الْخَطِيبِ
u'خُرُوجٌ دَابَّةٌ':Added, #1: 1	خُرُوجُ الْخِلَافِ
u'خُرُوجٌ دُبُرٌ':Added, #1: 1	خُرُوجِ الدَّابَّةِ
u'خُرُوجٌ دُبُرٌ':Added, #1: 1	خُرُوجَ الدُّبُرِ
u'خُرُوجٌ دَجَّالٌ':Added, #1: 1	خُرُوجِ الدُّبُرِ
u'خُرُوجٌ دَجَّالٌ':Added, #1: 1	خُرُوجُ الدَّجَّالِ
u'خُرُوجٌ دَجَّالٌ':Added, #1: 1	خُرُوجِ الدّجّالِ
u'خُرُوجٌ دَرَاهِمُ':Added, #4: 4	خُرُوجِ الدَّجَّالِ
u'خُرُوجٌ دَمٌ':Added, #1: 1	خُرُوجُ دَرَاهِمِهِ
u'خُرُوجٌ دَمٌ':Added, #11: 11	خُرُوجِ الدَّمِ
u'خُرُوجٌ دَمٌ':Added, #13: 13	خُرُوجُ الدَّمِ
u'خُرُوجٌ دَمٌ':Added, #1: 1	خُرُوجِ الدّمِ
u'خُرُوجٌ دَمٌ':Added, #1: 1	خُرُوجَ دَمِ
u'خُرُوجٌ دَمٌ':Added, #1: 1	خُرُوجِ دَمٍ
u'خُرُوجٌ دَمٌ':Added, #2: 2	خُرُوجُ دَمٍ
u'خُرُوجٌ دَمٌ':Added, #2: 2	خُرُوجِ دَمِ
u'خُرُوجٌ دمع':Added, #5: 5	خُرُوجَ الدَّمِ
u'خُرُوجٌ دَمْعٌ':Added, #1: 1	خُرُوجِ الدَّمْعِ
u'خُرُوجٌ دُودٌ':Added, #1: 1	خُرُوجِ الدَّمْعِ
u'خُرُوجٌ دُودَةٌ':Added, #1: 1	خُرُوجِ دُودِهِ
u'خُرُوجٌ دَيْنٌ':Added, #2: 2	خُرُوجُ دُودَةٍ
u'خُرُوجٌ دِينارٌ':Added, #4: 4	خُرُوجِ الدَّيْنِ
u'خُرُوجٌ ذِمِّيٌّ':Added, #1: 1	خُرُوجِ الدِّينَارِ
u'خُرُوجٌ ذَنْبٌ':Added, #1: 1	خُرُوجَ الذِّمِّيِّ
u'خُرُوجٌ رَأْسٌ':Added, #1: 1	خُرُوجِ ذَنْبِهِ
u'خُرُوجٌ رَأْسٌ':Added, #1: 1	خُرُوجِ الرَّأْسِ
u'خُرُوجٌ رَأْسٌ':Added, #1: 1	خُرُوجَ رَأْسِهِ
u'خُرُوجٌ رَجُلٌ':Added, #1: 1	خُرُوجِ رَأْسِهِ
u'خُرُوجٌ رَجُلٌ':Added, #1: 1	خُرُوجُ الرَّجُلِ
u'خُرُوجٌ رَسُولٌ':Added, #1: 1	خُرُوجِ الرَّجُلِ
u'خُرُوجٌ رَسُولٌ':Added, #1: 1	خُرُوجَ رَسُولِ
u'خُرُوجٌ رَسُولٌ':Added, #3: 3	خُرُوجُ الرّسُولِ
u'خُرُوجٌ رُطوبَةٌ':Added, #4: 4	خُرُوجِ رَسُولِ
u'خُرُوجٌ رفقة':Added, #1: 1	خُرُوجِ الرُّطُوبَةِ
u'خُرُوجٌ رُفْقَةٌ':Added, #1: 1	خُرُوجُ رُفْقَةٍ
u'خُرُوجٌ روحٌ':Added, #1: 1	خُرُوجُ رُفْقَةٍ
u'خُرُوجٌ روحٌ':Added, #1: 1	خُرُوجُ الرُّوحِ
u'خُرُوجٌ روحٌ':Added, #1: 1	خُرُوجَ رُوحِهِ
u'خُرُوجٌ رَوْحٌ':Added, #1: 1	خُرُوجِ رَوْحِهِ
u'خُرُوجٌ روحٌ':Added, #1: 1	خُرُوجِ رَوْحِهِ
u'خُرُوجٌ روحٌ':Added, #2: 2	خُرُوجَ الرُّوحِ
u'خُرُوجٌ روحٌ':Added, #6: 6	خُرُوجِ الرُّوحِ
u'خُرُوجٌ ريحٌ':Added, #6: 6	خُرُوجِ رُوحِهِ
u'خُرُوجٌ ريحٌ':Added, #1: 1	خُرُوجَ الرِّيحِ
u'خُرُوجٌ ريحٌ':Added, #3: 3	خُرُوجُ الرِّيحِ
u'خُرُوجٌ ريحٌ':Added, #4: 4	خُرُوجِ رِيحٍ
u'خُرُوجٌ زَرْعٌ':Added, #5: 5	خُرُوجِ الرِّيحِ
u'خُرُوجٌ زَرْعٌ':Added, #1: 1	خُرُوجُ الزَّرْعِ
u'خُرُوجٌ زهر':Added, #4: 4	خُرُوجِ الزَّرْعِ
u'خُرُوجٌ زَهْرٌ':Added, #1: 1	خُرُوجِ زَهْرِهِ
u'خُرُوجٌ زَوْجٌ':Added, #1: 1	خُرُوجِ زَهْرِهِ
u'خُرُوجٌ زَوْجٌ':Added, #2: 2	خُرُوجِ الزَّوْجِ
u'خُرُوجٌ زَيْتٌ':Added, #2: 2	خُرُوجُ زَوْجٍ
u'خُرُوجٌ سادس':Added, #1: 1	خُرُوجُ الزَّيْتِ
u'خُرُوجٌ سَادِسٌ':Added, #1: 1	خُرُوجَ السَّادِسَةِ
u'خُرُوجٌ سَارِقٌ':Added, #1: 1	خُرُوجَ السَّادِسَةِ
u'خُرُوجٌ سِباعٌ':Added, #1: 1	خُرُوجِ السَّارِقِ
u'خُرُوجٌ سُرَّةٌ':Added, #1: 1	خُرُوجِ السِّبَاعِ
u'خُرُوجٌ سُرَّةٌ':Added, #1: 1	خُرُوجُ السُّرَّةِ
u'خُرُوجٌ سلام':Added, #1: 1	خُرُوجُ سُرَّتِهِ
u'خُرُوجٌ سَلاَمٌ':Added, #1: 1	خُرُوجَ السَّلَامِ
u'خُرُوجٌ سُنَّةٌ':Added, #1: 1	خُرُوجَ السَّلَامِ
u'خُرُوجٌ سَهْمٌ':Added, #1: 1	خُرُوجُ السُّنَّةِ
u'خُرُوجٌ سَيْفٌ':Added, #1: 1	خُرُوجِ السَّهْمِ
u'خُرُوجٌ شَعْرٌ':Added, #1: 1	خُرُوجُ سَيْفِ
u'خُرُوجٌ شَهَادَةٌ':Added, #1: 1	خُرُوجِ الشَّعْرِ
u'خُرُوجٌ شَهْرٌ':Added, #1: 1	خُرُوجَ الشَّهَادَةِ
u'خُرُوجٌ شَيْءٌ':Added, #1: 1	خُرُوجِ الشَّهْرِ
u'خُرُوجٌ شَيْءٌ':Added, #1: 1	خُرُوجُ الشَّيْءِ
u'خُرُوجٌ شَيْءٌ':Added, #3: 3	خُرُوجَ شَيْءٍ
u'خُرُوجٌ صَبِيٌّ':Added, #8: 8	خُرُوجِ شَيْءٍ
u'خُرُوجٌ صِبْيَانٌ':Added, #1: 1	خُرُوجَ الصَّبِيِّ
u'خُرُوجٌ صِبْيَانٌ':Added, #1: 1	خُرُوجُ الصِّبْيَانِ
u'خُرُوجٌ صَدْرٌ':Added, #1: 1	خُرُوجِ الصِّبْيَانِ
u'خُرُوجٌ صُورٌ':Added, #2: 2	خُرُوجُ الصَّدْرِ
u'خُرُوجٌ صُوَرٌ':Added, #1: 1	خُرُوجُ صُوَرِ
u'خُرُوجٌ صَيْدٌ':Added, #1: 1	خُرُوجُ صُوَرِ
u'خُرُوجٌ صَيْدٌ':Added, #1: 1	خُرُوجِ الصَّيْدِ
u'خُرُوجٌ ضَحِيَّةٌ':Added, #1: 1	خُرُوجِ صَيْدِ
u'خُرُوجٌ طَلْعٌ':Added, #1: 1	خُرُوجِ الضَّحِيَّةِ
u'خُرُوجٌ ظُهْرٌ':Added, #2: 2	خُرُوجِ الطَّلْعِ
u'خُرُوجٌ ظُهْرٌ':Added, #1: 1	خُرُوجُ الظُّهْرِ
u'خُرُوجٌ عِبَادَةٌ':Added, #1: 1	خُرُوجِ الظُّهْرِ
u'خُرُوجٌ عَبْدٌ':Added, #2: 2	خُرُوجُ الْعِبَادَةِ
u'خُرُوجٌ عجائز':Added, #1: 1	خُرُوجِ الْعَبْدِ
u'خُرُوجٌ عجائز':Added, #1: 1	خُرُوجِ الْعَجَائِزِ
u'خُرُوجٌ عَسْكَرٌ':Added, #2: 2	خُرُوجُ الْعَجَائِزِ
u'خُرُوجٌ عُصَاةٌ':Added, #1: 1	خُرُوجَ عَسْكَرِ
u'خُرُوجٌ عُضْوٌ':Added, #1: 1	خُرُوجِ عُصَاةِ
u'خُرُوجٌ عُضْوٌ':Added, #1: 1	خُرُوجَ الْعُضْوِ
u'خُرُوجٌ عَطَاءٌ':Added, #1: 1	خُرُوجِ عُضْوٍ
u'خُرُوجٌ علم':Added, #1: 1	خُرُوجِ الْعَطَاءِ
u'خُرُوجٌ عِلْمٌ':Added, #1: 1	خُرُوجِ الْعِلْمِ
u'خُرُوجٌ علماء':Added, #1: 1	خُرُوجِ الْعِلْمِ
u'خُرُوجٌ عُلَمَاءُ':Added, #1: 1	خُرُوجُ عُلَمَاءِ
u'خُرُوجٌ عِمَارَةٌ':Added, #1: 1	خُرُوجُ عُلَمَاءِ
u'خُرُوجٌ عِوَضٌ':Added, #2: 2	خُرُوجِ الْعِمَارَةِ
u'خُرُوجٌ عِيدٌ':Added, #1: 1	خُرُوجَ الْعِوَضِ
u'خُرُوجٌ غَايَةٌ':Added, #1: 1	خُرُوجُ الْعِيدِ
u'خُرُوجٌ غَدٌ':Added, #1: 1	خُرُوجِ الْغَايَةِ
u'خُرُوجٌ غَلَّةٌ':Added, #1: 1	خُرُوجِ الْغَدِ
u'خُرُوجٌ غير':Added, #3: 3	خُرُوجِ الْغَلَّةِ
u'خُرُوجٌ غَيْرٌ':Added, #1: 1	خُرُوجِ غَيْرِ
u'خُرُوجٌ فَاسِقٌ':Added, #1: 1	خُرُوجِ غَيْرِ
u'خُرُوجٌ فَرْخٌ':Added, #1: 1	خُرُوجِ الْفَاسِقِ
u'خُرُوجٌ فلان':Added, #1: 1	خُرُوجِ الْفَرْخِ
u'خُرُوجٌ قَابِلٌ':Added, #1: 1	خُرُوجُ الصَّلَاتَيْنِ
u'خُرُوجٌ قَافِلٌ':Added, #1: 1	خُرُوجَ الْقَابِلَةِ
u'خُرُوجٌ قَافِلٌ':Added, #1: 1	خُرُوجِ قَافِلَةِ
u'خُرُوجٌ قَافِلٌ':Added, #2: 2	خُرُوجَ الْقَافِلَةِ
u'خُرُوجٌ قَافِلٌ':Added, #2: 2	خُرُوجِ قَافِلَتِهِ
u'خُرُوجٌ قَافِلَةٌ':Added, #7: 7	خُرُوجِ الْقَافِلَةِ
u'خُرُوجٌ قَافِلَةٌ':Added, #1: 1	خُرُوجِ قَافِلَةِ
u'خُرُوجٌ قَافِلَةٌ':Added, #2: 2	خُرُوجَ الْقَافِلَةِ
u'خُرُوجٌ قَافِلَةٌ':Added, #2: 2	خُرُوجِ قَافِلَتِهِ
u'خُرُوجٌ قتل':Added, #7: 7	خُرُوجِ الْقَافِلَةِ
u'خُرُوجٌ قَتْلٌ':Added, #1: 1	خُرُوجُ الْقَتْلِ
u'خُرُوجٌ قدم':Added, #1: 1	خُرُوجُ الْقَتْلِ
u'خُرُوجٌ قَدَمٌ':Added, #1: 1	خُرُوجُ الْقَدَمِ
u'خُرُوجٌ قُرْعَةٌ':Added, #1: 1	خُرُوجُ الْقَدَمِ
u'خُرُوجٌ قُرْعَةٌ':Added, #1: 1	خُرُوجُ الْقُرْعَةِ
u'خُرُوجٌ قُرْعَةٌ':Added, #1: 1	خُرُوجِ قُرْعَتِهِ
u'خُرُوجٌ قُرَيْشٌ':Added, #3: 3	خُرُوجِ الْقُرْعَةِ
u'خُرُوجٌ قِسْمٌ':Added, #1: 1	خُرُوجُ قُرَيْشٍ
u'خُرُوجٌ قَلِيلٌ':Added, #1: 1	خُرُوجِ الْقِسْمَيْنِ
u'خُرُوجٌ قَوْمٌ':Added, #1: 1	خُرُوجِ الْقَلِيلِ
u'خُرُوجٌ قَوْمٌ':Added, #1: 1	خُرُوجِ الْقَوْمِ
u'خُرُوجٌ قَيْءٌ':Added, #1: 1	خُرُوجُ قَوْمِ
u'خُرُوجٌ قِيَاسٌ':Added, #1: 1	خُرُوجَ الْقَيْءِ
u'خُرُوجٌ كَافِرٌ':Added, #1: 1	خُرُوجُ الْقِيَاسِ
u'خُرُوجٌ كَدِرٌ':Added, #1: 1	خُرُوجِ الْكَافِرِ
u'خُرُوجٌ كَدِرٌ':Added, #1: 1	خُرُوجِ الْكَدِرِ
u'خُرُوجٌ كُدْرَةٌ':Added, #2: 2	خُرُوجُ الْكَدِرِ
u'خُرُوجٌ كَلاَمٌ':Added, #2: 2	خُرُوجَ الْكُدْرَةِ
u'خُرُوجٌ لبن':Added, #1: 1	خُرُوجُ الْكَلَامِ
u'خُرُوجٌ لَبَنٌ':Added, #1: 1	خُرُوجِ لَبَنِ
u'خُرُوجٌ لِحْيَةٌ':Added, #1: 1	خُرُوجِ لَبَنِ
u'خُرُوجٌ لَيْلٌ':Added, #1: 1	خُرُوجُ اللِّحْيَةِ
u'خُرُوجٌ مَاءٌ':Added, #1: 1	خُرُوجُ لَيْلَةٍ
u'خُرُوجٌ مَاءٌ':Added, #1: 1	خُرُوجَ مَاءِ
u'خُرُوجٌ مَاءٌ':Added, #4: 4	خُرُوجُ الْمَاءِ
u'خُرُوجٌ مَبِيعٌ':Added, #7: 7	خُرُوجِ الْمَاءِ
u'خُرُوجٌ مَبِيعٌ':Added, #2: 2	خُرُوجُ الْمَبِيعِ
u'خُرُوجٌ مَبِيعٌ':Added, #2: 2	خُرُوجِ الْمَبِيعِ
u'خُرُوجٌ مُحَابَاةٌ':Added, #9: 9	خُرُوجَ الْمَبِيعِ
u'خُرُوجٌ مُحْتَسِبٌ':Added, #1: 1	خُرُوجِ الْمُحَابَاةِ
u'خُرُوجٌ مَحَلٌّ':Added, #1: 1	خُرُوجُ الْمُحْتَسِبِ
u'خُرُوجٌ مُرْتَكِبٌ':Added, #1: 1	خُرُوجَ مَحَلِّ
u'خُرُوجٌ مَرْحَبٌ':Added, #1: 1	خُرُوجِ مُرْتَكِبِ
u'خُرُوجٌ مُرَكَّبٌ':Added, #1: 1	خُرُوجَ مَرْحَبٍ
u'خُرُوجٌ مَرْهُونٌ':Added, #1: 1	خُرُوجِ الْمُرَكَّبِ
u'خُرُوجٌ مُسْتَأْجِرٌ':Added, #1: 1	خُرُوجِ الْمَرْهُونِ
u'خُرُوجٌ مُسْتَأْجِرٌ':Added, #1: 1	خُرُوجُ الْمُسْتَأْجِرِ
u'خُرُوجٌ مُسْتَقْبَلٌ':Added, #1: 1	خُرُوجِ الْمُسْتَأْجِرِ
u'خُرُوجٌ مُسْلِمٌ':Added, #1: 1	خُرُوجٍ مُسْتَقْبَلٍ
u'خُرُوجٌ مُصَدِّقٌ':Added, #1: 1	خُرُوجُ الْمُسْلِمِ
u'خُرُوجٌ مُطَلَّقٌ':Added, #3: 3	خُرُوجِ الْمُصَدِّقِ
u'خُرُوجٌ مُعْتَادٌ':Added, #3: 3	خُرُوجِ الْمُطَلَّقَةِ
u'خُرُوجٌ مُعْتَدٌّ':Added, #1: 1	خُرُوجُ الْمُعْتَادِ
u'خُرُوجٌ مُعْتَدٌّ':Added, #1: 1	خُرُوجُ الْمُعْتَدَّةِ
u'خُرُوجٌ مُعَلَّقٌ':Added, #1: 1	خُرُوجِ الْمُعْتَدَّةِ
u'خُرُوجٌ مَغْصُوب':Added, #1: 1	خُرُوجُ الْمُعَلَّقِ
u'خُرُوجٌ مَقْعَدَةٌ':Added, #1: 1	خُرُوجِ الْمَغْصُوبِ
u'خُرُوجٌ مُكَلَّفٌ':Added, #1: 1	خُرُوجِ الْمَقْعَدَةِ
u'خُرُوجٌ مَلِكٌ':Added, #1: 1	خُرُوجِ الْمُكَلَّفِ
u'خُرُوجٌ مِلْكٌ':Added, #1: 1	خُرُوجِ الْمَلِكِ
u'خُرُوجٌ مُمْكِنٌ':Added, #2: 2	خُرُوجَ الْمِلْكِ
u'خُرُوجٌ مُمْكِن':Added, #1: 1	خُرُوجِ الْمُمْكِنِ
u'خُرُوجٌ مُمَيِّزٌ':Added, #1: 1	خُرُوجِ الْمُمْكِنِ
u'خُرُوجٌ مَنِيٌّ':Added, #1: 1	خُرُوجُ الْمُمَيِّزِ
u'خُرُوجٌ مَنِيٌّ':Added, #12: 12	خُرُوجُ الْمَنِيِّ
u'خُرُوجٌ مَنِيٌّ':Added, #14: 14	خُرُوجِ الْمَنِيِّ
u'خُرُوجٌ مَنِيٌّ':Added, #1: 1	خُرُوجَ مَنِيِّ
u'خُرُوجٌ مَنِيٌّ':Added, #1: 1	خُرُوجُ مَنِيِّهِ
u'خُرُوجٌ مَنِيٌّ':Added, #1: 1	خُرُوجِ مَنِيِّهِ
u'خُرُوجٌ مَنِيٌّ':Added, #2: 2	خُرُوجِ مَنِيٍّ
u'خُرُوجٌ مَوْهُوبٌ':Added, #4: 4	خُرُوجَ الْمَنِيِّ
u'خُرُوجٌ نَاسٌ':Added, #1: 1	خُرُوجُ الْمَوْهُوبِ
u'خُرُوجٌ نَبِيٌّ':Added, #22: 22	خُرُوجِ النَّاسِ
u'خُرُوجٌ نَبِيٌّ':Added, #1: 1	خُرُوجُ النَّبِيِّ
u'خُرُوجٌ نَجَاسَةٌ':Added, #1: 1	خُرُوجِ النَّبِيِّ
u'خُرُوجٌ نَجَاسَةٌ':Added, #1: 1	خُرُوجُ النَّجَاسَاتِ
u'خُرُوجٌ نَجَاسَةٌ':Added, #4: 4	خُرُوجَ النَّجَاسَةِ
u'خُرُوجٌ نَجَاسَةٌ':Added, #5: 5	خُرُوجُ النَّجَاسَةِ
u'خُرُوجٌ نَجَسٌ':Added, #5: 5	خُرُوجِ النَّجَاسَةِ
u'خُرُوجٌ نَجَسٌ':Added, #1: 1	خُرُوجِ نَجَسٍ
u'خُرُوجٌ نَجَسٌ':Added, #2: 2	خُرُوجَ النَّجَسِ
u'خُرُوجٌ نَجَسٌ':Added, #3: 3	خُرُوجُ النَّجَسِ
u'خُرُوجٌ نَجَسٌ':Added, #3: 3	خُرُوجِ النَّجَسِ
u'خُرُوجٌ نِساءٌ':Added, #3: 3	خُرُوجُ نَجَسٍ
u'خُرُوجٌ نِساءٌ':Added, #2: 2	خُرُوجُ النِّسَاءِ
u'خُرُوجٌ نَفَسٌ':Added, #5: 5	خُرُوجِ النِّسَاءِ
u'خُرُوجٌ نَفْسٌ':Added, #1: 1	خُرُوجِ النَّفَسِ
u'خُرُوجٌ نَفْسٌ':Added, #1: 1	خُرُوجُ النَّفْسِ
u'خُرُوجٌ نَفْسٌ':Added, #1: 1	خُرُوجُ نَفْسِهِ
u'خُرُوجٌ نَوْعٌ':Added, #5: 5	خُرُوجِ النَّفْسِ
u'خُرُوجٌ هِبَةٌ':Added, #1: 1	خُرُوجِ نَوْعٍ
u'خُرُوجٌ واحد':Added, #2: 2	خُرُوجُ الْهِبَةِ
u'خُرُوجٌ وَاحِدٌ':Added, #1: 1	خُرُوجَ الْوَاحِدِ
u'خُرُوجٌ وَارِثٌ':Added, #1: 1	خُرُوجَ الْوَاحِدِ
u'خُرُوجٌ وَجْهٌ':Added, #1: 1	خُرُوجِ الْوَارِثِ
u'خُرُوجٌ وَقْتٌ':Added, #1: 1	خُرُوجَ الْوَجْهَيْنِ
u'خُرُوجٌ وَقْتٌ':Added, #110: 110	خُرُوجِ الْوَقْتِ
u'خُرُوجٌ وَقْتٌ':Added, #14: 14	خُرُوجُ الْوَقْتِ
u'خُرُوجٌ وَقْتٌ':Added, #1: 1	خُرُوجَ وَقْتٍ
u'خُرُوجٌ وَقْتٌ':Added, #1: 1	خُرُوجُ وَقْتٍ
u'خُرُوجٌ وَقْتٌ':Added, #1: 1	خُرُوجِ وَقْتٍ
u'خُرُوجٌ وَقْتٌ':Added, #23: 23	خُرُوجِ وَقْتِ
u'خُرُوجٌ وَقْتٌ':Added, #27: 27	خُرُوجَ الْوَقْتِ
u'خُرُوجٌ وَقْتٌ':Added, #2: 2	خُرُوجَ وَقْتِ
u'خُرُوجٌ وَقْتٌ':Added, #2: 2	خُرُوجُ وَقْتِ
u'خُرُوجٌ وَقْفٌ':Added, #2: 2	خُرُوجِ وَقْتِهِ
u'خُرُوجٌ ولد':Added, #2: 2	خُرُوجُ الْوَقْفِ
u'خُرُوجٌ وَلَدٌ':Added, #20: 20	خُرُوجِ الْوَلَدِ
u'خُرُوجٌ ولد':Added, #20: 20	خُرُوجِ الْوَلَدِ
u'خُرُوجٌ وَلَدٌ':Added, #4: 4	خُرُوجَ الْوَلَدِ
u'خُرُوجٌ وَهْمٌ':Added, #4: 4	خُرُوجَ الْوَلَدِ
u'خُرُوجٌ يَدٌ':Added, #1: 1	خُرُوجِ الْوَهْمِ
u'خُرُوجٌ يَدٌ':Added, #1: 1	خُرُوجُ يَدِهِ
u'خُرُوقٌ دَائِرَةٌ':Added, #1: 1	خُرُوجِ يَدِهِ
u'خُرُوقٌ قَسَاطِلُ':Added, #1: 1	خُرُوقِ دَائِرَةِ
u'خَرِيرٌ كَوْثَرٌ':Added, #1: 1	خُرُوقَ الْقَسَاطِلِ
u'خَزَقَ مِعْراض':Subject, #1: 1	خَرِيرِ الْكَوْثَرِ
u'خَزَنَ بَخِيلٌ':Subject, #1: 1	خَزَقَ الْمِعْرَاضُ
u'خَزَّنَ مَتَاعٌ':Predicate, #1: 1	خَزَنَ الْبَخِيلُ
u'خَسَارَةٌ دِينٌ':Added, #1: 1	خَزَّنَ الْمَتَاعَ
u'خَسَاسَةٌ هِمَّةٌ':Added, #1: 1	خَسَارَةُ الدِّينِ
u'خَسَّ تَعِسٌ':Predicate, #1: 1	خَسَاسَةِ الْهِمَّةِ
u'خَسِرَ جَنَّةٌ':Predicate, #1: 1	خَسَّ تَعِسَ
u'خَسِرَ دِرْهَمٌ':Subject, #1: 1	خَسِرَ الْجَنَّةَ
u'خَسِرَ دِرْهَم':Subject, #1: 1	خَسِرَ دِرْهَمٌ
u'خَسِرَ ضَمِنٌ':Predicate, #1: 1	خَسِرَ دِرْهَمٌ
u'خَسِرَ مَالٌ':Predicate, #2: 2	خَسِرَ ضَمِنَ
u'خَسِرَ مُحِبٌّ':Subject, #1: 1	خَسِرَ الْمَالَ
u'خَسَفَ لَيْلٌ':Predicate, #1: 1	خَسِرَ الْمُحِبُّ
u'خُسُوفٌ شمس':Added, #1: 1	خَسَفَ لَيْلَةَ
u'خُسُوفٌ شَمْسٌ':Added, #11: 11	خُسُوفِ الشَّمْسِ
u'خُسُوفٌ قمر':Added, #11: 11	خُسُوفِ الشَّمْسِ
u'خُسُوفٌ قَمَرٌ':Added, #16: 16	خُسُوفِ الْقَمَرِ
u'خُسُوفٌ قمر':Added, #16: 16	خُسُوفِ الْقَمَرِ
u'خُسُوفٌ قَمَرٌ':Added, #2: 2	خُسُوفَ الْقَمَرِ
u'خُسُوفٌ قمر':Added, #2: 2	خُسُوفَ الْقَمَرِ
u'خُسُوفٌ قَمَرٌ':Added, #4: 4	خُسُوفُ الْقَمَرِ
u'خَشَعَ خضع':Predicate, #4: 4	خُسُوفُ الْقَمَرِ
u'خَشَعَ قلب':Subject, #1: 1	خَشَعَ خَضَعَ
u'خَشَعَ قَلْبٌ':Subject, #1: 1	خَشَعَ قَلْبُهُ
u'خَشَعَ قَلْب':Subject, #1: 1	خَشَعَ قَلْبُهُ
u'خَشَعَ قلب':Subject, #1: 1	خَشَعَ قَلْبُهُ
u'خَشَعَ قَلْبٌ':Subject, #2: 2	خَشَعَ قَلْبُ
u'خَشَعَ قَلْب':Subject, #2: 2	خَشَعَ قَلْبُ
u'خُشُوعٌ تَوْبَةٌ':Added, #2: 2	خَشَعَ قَلْبُ
u'خُشُوعٌ نِفَاقٌ':Added, #1: 1	خُشُوعُ التَّوْبَةِ
u'خُشُوعٌ نِفَاقٌ':Added, #1: 1	خُشُوعُ النِّفَاقِ
u'خُشُونَةٌ حَلْقٌ':Added, #2: 2	خُشُوعِ النِّفَاقِ
u'خُشُونَةٌ حَلْقٌ':Added, #1: 1	خُشُونَةَ الْحَلْقِ
u'خُشُونَةٌ صَدْرٌ':Added, #4: 4	خُشُونَةِ الْحَلْقِ
u'خُشُونَةٌ عَيْشٌ':Added, #2: 2	خُشُونَةِ الصَّدْرِ
u'خُشُونَةٌ عين':Added, #1: 1	خُشُونَةُ الْعَيْشِ
u'خُشُونَةٌ عَيْنٌ':Added, #1: 1	خُشُونَةِ الْعَيْنِ
u'خُشُونَةٌ عَيْن':Added, #1: 1	خُشُونَةِ الْعَيْنِ
u'خُشُونَةٌ مَحَلٌّ':Added, #1: 1	خُشُونَةِ الْعَيْنِ
u'خُشُونَةٌ مَشْيٌ':Added, #2: 2	خُشُونَةُ الْمَحَلِّ
u'خُشُونَةٌ مَطْعَمٌ':Added, #1: 1	خُشُونَةِ مَشْيٍ
u'خَشِيَ إِتْلاَفٌ':Predicate, #1: 1	خُشُونَةِ الْمَطْعَمِ
u'خَشِيَ أَسْرٌ':Predicate, #1: 1	خَشِيَ إتْلَافَ
u'خَشِيَ الْمَرْءُ':Subject, #1: 1	خَشِيَ الْأَسْرَ
u'خَشِيَ إِنْزالٌ':Predicate, #1: 1	خَشِيَ الْمَرْءُ
u'خَشْيَةٌ إِثَارَةٌ':Added, #1: 1	خَشِيَ الْإِنْزَالَ
u'خَشْيَةٌ اِرْتِكَابٌ':Added, #1: 1	خَشْيَةَ إثَارَةِ
u'خَشْيَةٌ أَضْيَافٌ':Added, #1: 1	خَشْيَةُ ارْتِكَابِ
u'خَشْيَةٌ إِطالَةٌ':Added, #2: 2	خَشْيَةَ الْأَضْيَافِ
u'خَشْيَةٌ إِطالَةٌ':Added, #1: 1	خَشْيَةُ الْإِطَالَةِ
u'خَشْيَةٌ اِفْتِتَانٌ':Added, #2: 2	خَشْيَةَ الْإِطَالَةِ
u'خَشْيَةٌ اللهُ':Added, #2: 2	خَشْيَةَ افْتِتَانِ
u'خَشْيَةٌ إِمْلاقٌ':Added, #2: 2	خَشْيَةِ اللهِ
u'خَشْيَةٌ إِمْلاقٌ':Added, #1: 1	خَشْيَةَ إِمْلَاقٍ
u'خَشْيَةٌ إِنْفاقٌ':Added, #5: 5	خَشْيَةَ إمْلَاقٍ
u'خَشْيَةٌ تَغَيُّبٌ':Added, #3: 3	خَشْيَةَ الْإِنْفَاقِ
u'خَشْيَةٌ تَغَيُّرٌ':Added, #1: 1	خَشْيَةِ تَغَيُّبِهِ
u'خَشْيَةٌ تَغَيُّرٌ':Added, #1: 1	خَشْيَةَ تَغَيُّرِهِ
u'خَشْيَةٌ تَلْطيخٌ':Added, #1: 1	خَشْيَةِ تَغَيُّرِهِ
u'خَشْيَةٌ تَلَف':Added, #1: 1	خَشْيَةَ تَلْطِيخِ
u'خَشْيَةٌ تَلَوُّثٌ':Added, #1: 1	خَشْيَةَ التَّلَفِ
u'خَشْيَةٌ تَوَهُّمٌ':Added, #1: 1	خَشْيَةَ التَّلَوُّثِ
u'خَشْيَةٌ حَبْسٌ':Added, #1: 1	خَشْيَةِ تَوَهُّمِ
u'خَشْيَةٌ حيفٌ':Added, #1: 1	خَشْيَةَ الْحَبْسِ
u'خَشْيَةٌ حَيْفٌ':Added, #2: 2	خَشْيَةِ الْحَيْفِ
u'خَشْيَةٌ خُرُوجٌ':Added, #2: 2	خَشْيَةِ الْحَيْفِ
u'خَشْيَةٌ خُلَفَاءُ':Added, #1: 1	خَشْيَةُ خُرُوجِ
u'خَشْيَةٌ خَمْرٌ':Added, #1: 1	خَشْيَةُ الْخُلَفَاءِ
u'خَشْيَةٌ زِيادَةٌ':Added, #1: 1	خَشْيَةَ الْخَمْرِ
u'خَشْيَةٌ سُقُوطٌ':Added, #1: 1	خَشْيَةِ الزِّيَادَةِ
u'خَشْيَةٌ شَهَادَةٌ':Added, #1: 1	خَشْيَةَ سُقُوطِ
u'خَشْيَةٌ شَهْوَةٌ':Added, #1: 1	خَشْيَةَ الشَّهَادَةِ
u'خَشْيَةٌ صدقة':Added, #1: 1	خَشْيَةِ الشَّهْوَةِ
u'خَشْيَةٌ صَدَقَةٌ':Added, #19: 19	خَشْيَةَ الصَّدَقَةِ
u'خَشْيَةٌ صدقة':Added, #19: 19	خَشْيَةَ الصَّدَقَةِ
u'خَشْيَةٌ صَدَقَةٌ':Added, #3: 3	خَشْيَةِ الصَّدَقَةِ
u'خَشْيَةٌ ضَرَرٌ':Added, #3: 3	خَشْيَةِ الصَّدَقَةِ
u'خَشْيَةٌ ضَرَرٌ':Added, #1: 1	خَشْيَةُ الضَّرَرِ
u'خَشْيَةٌ عَدَمٌ':Added, #1: 1	خَشْيَةَ ضَرَرِهِ
u'خَشْيَةٌ فتنة':Added, #1: 1	خَشْيَةَ عَدَمِ
u'خَشْيَةٌ فِتْنَةٌ':Added, #1: 1	خَشْيَةَ الْفِتْنَةِ
u'خَشْيَةٌ فتنة':Added, #1: 1	خَشْيَةَ الْفِتْنَةِ
u'خَشْيَةٌ فِتْنَةٌ':Added, #1: 1	خَشْيَةَ فِتْنَةٍ
u'خَشْيَةٌ فتنة':Added, #1: 1	خَشْيَةَ فِتْنَةٍ
u'خَشْيَةٌ فِتْنَةٌ':Added, #2: 2	خَشْيَةُ فِتْنَةٍ
u'خَشْيَةٌ فقر':Added, #2: 2	خَشْيَةُ فِتْنَةٍ
u'خَشْيَةٌ فقر':Added, #1: 1	خَشْيَةَ الْفَقْرِ
u'خَشْيَةٌ فَقْرٌ':Added, #1: 1	خَشْيَةُ الْفَقْرِ
u'خَشْيَةٌ فَقْرٌ':Added, #1: 1	خَشْيَةَ الْفَقْرِ
u'خَشْيَةٌ فَوَاتٌ':Added, #1: 1	خَشْيَةُ الْفَقْرِ
u'خَشْيَةٌ فَوَاتٌ':Added, #1: 1	خَشْيَةِ الْفَوَاتِ
u'خَشْيَةٌ فَوَاتٌ':Added, #1: 1	خَشْيَةُ فَوَاتٍ
u'خَشْيَةٌ فَوَاتٌ':Added, #1: 1	خَشْيَةَ فَوَاتِهِ
u'خَشْيَةٌ فَوَاتٌ':Added, #1: 1	خَشْيَةِ فَوَاتِهِ
u'خَشْيَةٌ فَوْت':Added, #3: 3	خَشْيَةَ الْفَوَاتِ
u'خَشْيَةٌ قَوَد':Added, #1: 1	خَشْيَةَ الْفَوْتِ
u'خَشْيَةٌ مَاءٌ':Added, #2: 2	خَشْيَةُ الْقَوَدِ
u'خَشْيَةٌ مُبِيحٌ':Added, #1: 1	خَشْيَةِ الْمَاءِ
u'خَشْيَةٌ مُبِيحٌ':Added, #1: 1	خَشْيَةُ مُبِيحِ
u'خَشْيَةٌ مُحَابَاةٌ':Added, #1: 1	خَشْيَةِ مُبِيحِ
u'خَشْيَةٌ مَحْذُور':Added, #2: 2	خَشْيَةُ الْمُحَابَاةِ
u'خَشْيَةٌ مَحْذُور':Added, #1: 1	خَشْيَةَ الْمَحْذُورِ
u'خَشْيَةٌ مَحْذُور':Added, #1: 1	خَشْيَةِ مَحْذُورٍ
u'خَشْيَةٌ مَرَضٌ':Added, #2: 2	خَشْيَةُ مَحْذُورِ
u'خَشْيَةٌ مَشَقَّةٌ':Added, #1: 1	خَشْيَةَ مَرَضٍ
u'خَشْيَةٌ مُصَادَمَةٌ':Added, #1: 1	خَشْيَةُ الْمَشَقَّةِ
u'خَشْيَةٌ ملل':Added, #1: 1	خَشْيَةِ الْمُصَادَمَةِ
u'خَشْيَةٌ مَلَلٌ':Added, #1: 1	خَشْيَةَ الْمَلَلِ
u'خَشْيَةٌ مَنْعٌ':Added, #1: 1	خَشْيَةَ الْمَلَلِ
u'خَشْيَةٌ مَوْتٌ':Added, #1: 1	خَشْيَةَ مَنْعِ
u'خَشْيَةٌ مَوْتٌ':Added, #1: 1	خَشْيَةَ الْمَوْتِ
u'خَشْيَةٌ نَبْش':Added, #1: 1	خَشْيَةَ مَوْتِهِ
u'خَشْيَةٌ نَجَاسَةٌ':Added, #1: 1	خَشْيَةِ النَّبْشِ
u'خَشْيَةٌ نَظَرٌ':Added, #1: 1	خَشْيَةَ النَّجَاسَةِ
u'خَشْيَةٌ وُقُوعٌ':Added, #1: 1	خَشْيَةِ النَّظَرِ
u'خَشْيَةٌ وُقُوعٌ':Added, #1: 1	خَشْيَةُ الْوُقُوعِ
u'خَشْيَةٌ وُقُوعٌ':Added, #1: 1	خَشْيَةِ الْوُقُوعِ
u'خَشِيَ تَأَلُّمٌ':Predicate, #2: 2	خَشْيَةَ الْوُقُوعِ
u'خَشِيَ تَطْلِيقٌ':Predicate, #1: 1	خَشِيَ التَّأَلُّمَ
u'خَشِيَ تَعْطِيلٌ':Predicate, #1: 1	خَشِيَ تَطْلِيقَهُنَّ
u'خَشِيَ تَغَيُّرٌ':Predicate, #1: 1	خَشِيَ التَّعْطِيلَ
u'خَشِيَ تَفَاقُمٌ':Predicate, #1: 1	خَشِيَ تَغَيُّرَ
u'خَشِيَ تَلَف':Predicate, #1: 1	خَشِيَ تَفَاقُمَ
u'خَشِيَ تَلَفٌ':Predicate, #1: 1	خَشِيَ التَّلَفَ
u'خَشِيَ تَلَوُّثٌ':Predicate, #2: 2	خَشِيَ تَلَفَ
u'خَشِيَ تَوَهُّمٌ':Predicate, #1: 1	خَشِيَ تَلَوُّثَ
u'خَشِيَ خُرُوجٌ':Predicate, #1: 1	خَشِيَ تَوَهُّمَ
u'خَشِيَ دونٌ':Predicate, #1: 1	خَشِيَ خُرُوجَ
u'خَشِيَ رَفْعٌ':Predicate, #1: 1	خَشِيَ دُونَ
u'خَشِيَ سُقُوطٌ':Predicate, #2: 2	خَشِيَ رَفْعَ
u'خَشِيَ صُبْحٌ':Predicate, #2: 2	خَشِيَ سُقُوطَ
u'خَشِيَ ضَرَرٌ':Predicate, #3: 3	خَشِيَ الصُّبْحَ
u'خَشِيَ طُلُوعٌ':Predicate, #1: 1	خَشِيَ ضَرَرَ
u'خَشِيَ طُولٌ':Predicate, #1: 1	خَشِيَ طُلُوعَ
u'خَشِيَ عَدَمٌ':Predicate, #1: 1	خَشِيَ طُولَ
u'خَشِيَ عَطْشَان':Subject, #1: 1	خَشِيَ عَدَمَ
u'خَشِيَ فتنة':Predicate, #1: 1	خَشِيَ الْعَطْشَانُ
u'خَشِيَ فِتْنَةٌ':Predicate, #1: 1	خَشِيَ الْفِتْنَةَ
u'خَشِيَ فَوَاتٌ':Predicate, #1: 1	خَشِيَ الْفِتْنَةَ
u'خَشِيَ فَوْت':Predicate, #15: 15	خَشِيَ فَوَاتَ
u'خَشِيَ قتل':Predicate, #1: 1	خَشِيَ الْفَوْتَ
u'خَشِيَ قَتْلٌ':Predicate, #1: 1	خَشِيَ الْقَتْلَ
u'خَشِيَ مَالِكٌ':Subject, #1: 1	خَشِيَ الْقَتْلَ
u'خَشِيَ مَجَامِعُ':Subject, #1: 1	خَشِيَ مَالِكٌ
u'خَشِيَ مُفَاجَأَةٌ':Predicate, #1: 1	خَشِيَ الْمَجَامِعُ
u'خَشِيَ مَوْتٌ':Predicate, #2: 2	خَشِيَ مُفَاجَأَةَ
u'خَشِيَ نَقْضٌ':Predicate, #1: 1	خَشِيَ الْمَوْتَ
u'خَشِيَ هلاك':Predicate, #1: 1	خَشِيَ نَقْضَ
u'خَشِيَ هَلاَكٌ':Predicate, #2: 2	خَشِيَ هَلَاكَ
u'خَشِيَ هلاك':Predicate, #2: 2	خَشِيَ هَلَاكَ
u'خَشِيَ هَلاَكٌ':Predicate, #4: 4	خَشِيَ الْهَلَاكَ
u'خَصَّ اِبْنٌ':Subject, #4: 4	خَشِيَ الْهَلَاكَ
u'خَصَّ إجَازَةٌ':Predicate, #2: 2	خَصَّ ابْنُ
u'خَصَّ أحَدٌ':Predicate, #1: 1	خَصَّ إجَازَةَ
u'خَصَّ إِذْنٌ':Predicate, #1: 1	خَصَّ أَحَدَ
u'خَصَّ اِسْمٌ':Predicate, #1: 1	خَصَّ الْإِذْنَ
u'خَصَاصٌ بَابٌ':Added, #1: 1	خَصَّ اسْمَ
u'خَصَاصٌ بَابٌ':Added, #1: 1	خَصَاصِ الْبَابِ
u'خَصَاصَةٌ بَابٌ':Added, #1: 1	خَصَاصِ بَابٍ
u'خَصَّ أَصْحَابٌ':Subject, #3: 3	خَصَاصَةَ الْبَابِ
u'خَصَّ أصل':Predicate, #2: 2	خَصَّ الْأَصْحَابُ
u'خَصَّ أًصْلٌ':Predicate, #1: 1	خَصَّ الْأَصْلَ
u'خَصَّ أصل':Subject, #1: 1	خَصَّ الْأَصْلَ
u'خَصَّ أًصْلٌ':Subject, #1: 1	خَصَّ الْأَصْلُ
u'خَصَّ إِطْلاقٌ':Predicate, #1: 1	خَصَّ الْأَصْلُ
u'خَصَّ أعْقَابٌ':Predicate, #1: 1	خَصَّ الْإِطْلَاقَ
u'خَصَّ أَعْقَابٌ':Predicate, #1: 1	خَصَّ الْأَعْقَابَ
u'خَصَّ أكْبَرُ':Predicate, #1: 1	خَصَّ الْأَعْقَابَ
u'خَصَّ أَكْثَرُ':Subject, #2: 2	خَصَّ الْأَكْبَرَ
u'خَصَّ الْمَرْأَةُ':Predicate, #1: 1	خَصَّ أَكْثَرُ
u'خَصَّ أُمٌّ':Predicate, #1: 1	خَصَّ الْمَرْأَةَ
u'خَصَّ أُمٌّ':Predicate, #1: 1	خَصَّ الْأُمَّ
u'خَصَّ إمَامٌ':Subject, #2: 2	خَصَّ أُمَّ
u'خَصَّ أمَةٌ':Predicate, #2: 2	خَصَّ الْإِمَامُ
u'خَصَّ أَمْرٌ':Predicate, #1: 1	خَصَّ الْأَمَةَ
u'خَصَّ أمراء':Predicate, #1: 1	خَصَّ أَمْرَ
u'خَصَّ أمراء':Predicate, #1: 1	خَصَّ الْأُمَرَاءَ
u'خَصَّ اِمْرُؤٌ':Subject, #1: 1	خَصَّ أُمَرَاءَ
u'خِصَامٌ واحد':Added, #1: 1	خَصَّ امْرُؤٌ
u'خِصَامٌ وَاحِدٌ':Added, #1: 1	خِصَامٍ وَاحِدٍ
u'خَصَّ أَميرٌ':Predicate, #1: 1	خِصَامٍ وَاحِدٍ
u'خَصَّ أهْلٌ':Predicate, #1: 1	خَصَّ الْأَمِيرَ
u'خَصَّ أَوْلاَدٌ':Predicate, #3: 3	خَصَّ أَهْلَ
u'خَصَّ أَوْلاَدٌ':Predicate, #1: 1	خَصَّ أَوْلَادَ
u'خَصَّ أئِمَّةٌ':Subject, #2: 2	خَصَّ الْأَوْلَادَ
u'خِصْبٌ بدن':Added, #1: 1	خَصَّ الْأَئِمَّةُ
u'خِصْبٌ بَدَنٌ':Added, #1: 1	خِصْبَ الْبَدَنِ
u'خِصْبٌ دَارٌ':Added, #1: 1	خِصْبَ الْبَدَنِ
u'خَصَّ بَعْضٌ':Predicate, #1: 1	خِصْبُ دَارٍ
u'خَصَّ بَعْضٌ':Predicate, #1: 1	خَصَّ الْبَعْضَ
u'خِصْبٌ مَكَاسِبُ':Added, #1: 1	خَصَّ بَعْضَ
u'خِصْبٌ مَوَادُّ':Added, #1: 1	خِصْبُ الْمَكَاسِبِ
u'خِصْبٌ مَوَادُّ':Added, #1: 1	خِصْبُ الْمَوَادِّ
u'خَصَّ بِنْتٌ':Predicate, #1: 1	خِصْبِ الْمَوَادِّ
u'خَصَّ تَحْرِيمٌ':Predicate, #1: 1	خَصَّ الْبِنْتَ
u'خَصَّ تَرْجِيحٌ':Predicate, #1: 1	خَصَّ التَّحْرِيمَ
u'خَصَّ تَفْوِيضٌ':Predicate, #1: 1	خَصَّ التَّرْجِيحَ
u'خَصَّ تَمْر':Predicate, #1: 1	خَصَّ التَّفْوِيضَ
u'خَصَّ ثَلاثَةٌ':Predicate, #1: 1	خَصَّ التَّمْرَ
u'خَصَّ ثَيِّبٌ':Predicate, #1: 1	خَصَّ الثَّلَاثَةَ
u'خَصَّ جَابِرٌ':Subject, #1: 1	خَصَّ الثَّيِّبَ
u'خَصَّ جَمَاعَةٌ':Subject, #1: 1	خَصَّ جَابِرٌ
u'خَصَّ جمعة':Predicate, #1: 1	خَصَّ جَمَاعَةٌ
u'خَصَّ جُمُعَةٌ':Predicate, #1: 1	خَصَّ الْجُمُعَةَ
u'خَصَّ جَوَازٌ':Predicate, #1: 1	خَصَّ الْجُمُعَةَ
u'خَصَّ جَوَازٌ':Predicate, #1: 1	خَصَّ الْجَوَازَ
u'خَصَّ حالَةٌ':Predicate, #1: 1	خَصَّ جَوَازَ
u'خَصَّ حَجٌّ':Predicate, #3: 3	خَصَّ حَالَةَ
u'خَصَّ حُسْنٌ':Predicate, #1: 1	خَصَّ الْحَجَّ
u'خَصَّ حِلْفٌ':Predicate, #1: 1	خَصَّ الْحُسْنَ
u'خَصَّ خَدٌّ':Predicate, #1: 1	خَصَّ حِلْفَ
u'خَصَّ خُرُوجٌ':Predicate, #1: 1	خَصَّ الْخَدَّ
u'خَصَّ خِطَابٌ':Predicate, #1: 1	خَصَّ خُرُوجَ
u'خَصَّ خُفٌّ':Predicate, #1: 1	خَصَّ الْخِطَابَ
u'خَصَّ خِلاَفٌ':Predicate, #1: 1	خَصَّ الْخُفَّ
u'خَصَّ خيار':Predicate, #3: 3	خَصَّ الْخِلَافَ
u'خَصَّ خِيَارٌ':Predicate, #1: 1	خَصَّ خِيَارَ
u'خَصَّ دَيْنٌ':Predicate, #1: 1	خَصَّ خِيَارَ
u'خَصَّ رَأْسٌ':Predicate, #1: 1	خَصَّ دَيْنَ
u'خَصَّ رَأْيٌ':Predicate, #1: 1	خَصَّ الرَّأْسَ
u'خَصَّ رَسُولٌ':Predicate, #1: 1	خَصَّ رَأْيَ
u'خَصَّ رَسُولٌ':Predicate, #1: 1	خَصَّ الرَّسُولَ
u'خَصَّ رَسُولٌ':Subject, #2: 2	خَصَّ رَسُولَ
u'خَصَّ رِوايَةٌ':Predicate, #1: 1	خَصَّ رَسُولُ
u'خَصَّ زَوْجَةٌ':Predicate, #2: 2	خَصَّ الرِّوَايَةَ
u'خَصَّ زَيْتٌ':Predicate, #1: 1	خَصَّ الزَّوْجَةَ
u'خَصَّ سَبْعٌ':Predicate, #1: 1	خَصَّ الزَّيْتَ
u'خَصَّ سَفَرٌ':Predicate, #1: 1	خَصَّ السَّبْعَ
u'خَصَّ سكر':Predicate, #1: 1	خَصَّ السَّفَرَ
u'خَصَّ سُكْرٌ':Predicate, #1: 1	خَصَّ السُّكْرَ
u'خَصَّ شافِعِيّ':Predicate, #1: 1	خَصَّ السُّكْرَ
u'خَصَّ شجاع':Predicate, #1: 1	خَصَّ الشَّافِعِيَّ
u'خَصَّ شجَاعٌ':Predicate, #1: 1	خَصَّ الشُّجَاعَ
u'خَصَّ شَعْرٌ':Predicate, #1: 1	خَصَّ الشُّجَاعَ
u'خَصَّ شَيْخٌ':Subject, #1: 1	خَصَّ الشَّعْرَ
u'خَصَّصَ إمَامَةٌ':Predicate, #1: 1	خَصَّ الشَّيْخُ
u'خَصَّصَ أمَةٌ':Predicate, #1: 1	خَصَّصَ الْإِمَامَةَ
u'خَصَّصَ بَعْضٌ':Predicate, #1: 1	خَصَّصَ الْأَمَةَ
u'خَصَّ صَبِيٌّ':Predicate, #1: 1	خَصَّصَ بَعْضَ
u'خَصَّصَ تَغَابُنٌ':Predicate, #2: 2	خَصَّ الصَّبِيَّ
u'خَصَّصَ جلد':Predicate, #1: 1	خَصَّصَ التَّغَابُنَ
u'خَصَّصَ جِلْدٌ':Predicate, #1: 1	خَصَّصَ جِلْدَ
u'خَصَّصَ جَوَازٌ':Predicate, #1: 1	خَصَّصَ جِلْدَ
u'خَصَّ صِحَّةٌ':Predicate, #1: 1	خَصَّصَ جَوَازَ
u'خَصَّصَ خِلاَفٌ':Predicate, #1: 1	خَصَّ صِحَّةَ
u'خَصَّصَ دِبَاغٌ':Predicate, #1: 1	خَصَّصَ الْخِلَافَ
u'خَصَّ صدقة':Predicate, #1: 1	خَصَّصَ الدِّبَاغَ
u'خَصَّ صَدَقَةٌ':Predicate, #1: 1	خَصَّ الصَّدَقَةَ
u'خَصَّصَ ذِمِّيٌّ':Predicate, #1: 1	خَصَّ الصَّدَقَةَ
u'خَصَّصَ رِسَالَةٌ':Predicate, #1: 1	خَصَّصَ الذِّمِّيِّينَ
u'خَصَّصَ صَاحِبٌ':Subject, #2: 2	خَصَّصَ رِسَالَةَ
u'خَصَّصَ ضَمَانٌ':Predicate, #1: 1	خَصَّصَ صَاحِبُ
u'خَصَّصَ عَامٌّ':Predicate, #1: 1	خَصَّصَ الضَّمَانَ
u'خَصَّصَ عَامِلٌ':Predicate, #1: 1	خَصَّصَ الْعَامَّ
u'خَصَّصَ عُمُومٌ':Predicate, #1: 1	خَصَّصَ الْعَامِلَ
u'خَصَّصَ عُمُومٌ':Predicate, #1: 1	خَصَّصَ الْعُمُومَ
u'خَصَّصَ فقراء':Predicate, #2: 2	خَصَّصَ عُمُومَ
u'خَصَّصَ قَضِيَّةٌ':Predicate, #1: 1	خَصَّصَ فُقَرَاءَ
u'خَصَّصَ كَلاَمٌ':Predicate, #1: 1	خَصَّصَ قَضِيَّةَ
u'خَصَّصَ مَدْرَسَةٌ':Predicate, #1: 1	خَصَّصَ كَلَامَ
u'خَصَّصَ مَشْغُولٌ':Predicate, #1: 1	خَصَّصَ الْمَدْرَسَةَ
u'خَصَّصَ نَاسٌ':Predicate, #1: 1	خَصَّصَ الْمَشْغُولَ
u'خَصَّصَ نَهْيٌ':Predicate, #1: 1	خَصَّصَ النَّاسَ
u'خَصَّ صُورَةٌ':Predicate, #3: 3	خَصَّصَ النَّهْيَ
u'خَصَّ صَوْمٌ':Predicate, #1: 1	خَصَّ صُورَةَ
u'خَصَّ ضَمَانٌ':Predicate, #3: 3	خَصَّ الصَّوْمَ
u'خَصَّ طَيْرٌ':Predicate, #2: 2	خَصَّ ضَمَانَ
u'خَصَّ عَامٌّ':Predicate, #1: 1	خَصَّ الطَّيْرَ
u'خَصَّ عَبْدٌ':Predicate, #1: 1	خَصَّ الْعَامَّ
u'خَصَّ عَبْدٌ':Predicate, #1: 1	خَصَّ الْعَبْدَ
u'خَصَّ عِلَّةٌ':Predicate, #1: 1	خَصَّ عَبْدَ
u'خَصَّ عِلَّةٌ':Predicate, #1: 1	خَصَّ الْعِلَّةَ
u'خَصَّ عَمْدٌ':Predicate, #1: 1	خَصَّ عِلَّةَ
u'خَصَّ عُمُومٌ':Predicate, #1: 1	خَصَّ الْعَمْدَ
u'خَصَّ غير':Predicate, #3: 3	خَصَّ عُمُومَ
u'خَصَّ غَيْرٌ':Predicate, #2: 2	خَصَّ غَيْرَهُنَّ
u'خَصَّ فَسْخٌ':Predicate, #2: 2	خَصَّ غَيْرَهُنَّ
u'خَصَّ فلان':Predicate, #1: 1	خَصَّ فَسْخَ
u'خَصَّ فلان':Predicate, #1: 1	خَصَّ الشَّافِعِيَّ
u'خَصْفٌ نَعْلٌ':Added, #2: 2	خَصَّ الزُّبَيْرَ
u'خَصَّ قَالٌ':Predicate, #1: 1	خَصْفِ نَعْلِهِ
u'خَصَّ قرار':Predicate, #1: 1	خَصَّ قَالَ
u'خَصَّ قَرَارٌ':Predicate, #1: 1	خَصَّ الْقَرَارَ
u'خَصَّ قَوَاعِدُ':Predicate, #1: 1	خَصَّ الْقَرَارَ
u'خَصَّ قول':Predicate, #1: 1	خَصَّ الْقَوَاعِدَ
u'خَصَّ قَوْلٌ':Predicate, #2: 2	خَصَّ قَوْلَ
u'خَصَّ كِتَابَةٌ':Predicate, #2: 2	خَصَّ قَوْلَ
u'خَصَّ كَلاَمٌ':Predicate, #3: 3	خَصَّ الْكِتَابَةَ
u'خَصَّ لَحْمٌ':Predicate, #1: 1	خَصَّ الْكَلَامَ
u'خَصَّ لَفْظٌ':Predicate, #1: 1	خَصَّ اللَّحْمَ
u'خَصَّ لَيْلٌ':Predicate, #1: 1	خَصَّ اللَّفْظَ
u'خَصَّ لَيْلٌ':Predicate, #1: 1	خَصَّ اللَّيْلَ
u'خَصَّ مَاءٌ':Predicate, #2: 2	خَصَّ لَيْلَةَ
u'خَصَّ مُبَشِّرٌ':Subject, #1: 1	خَصَّ الْمَاءَ
u'خَصَّ مُتَعَمِّدٌ':Predicate, #1: 1	خَصَّ الْمُبَشِّرُ
u'خَصْمٌ حادِثٌ':Added, #1: 1	خَصَّ الْمُتَعَمِّدَ
u'خَصْمٌ حاضِرٌ':Added, #2: 2	خَصْمٍ حَادِثٍ
u'خَصَّ مُحَمَّدٌ':Subject, #22: 22	خَصْمٍ حَاضِرٍ
u'خَصَّ مراسيل':Predicate, #1: 1	خَصَّ مُحَمَّدٌ
u'خَصَّ مَرَاسِيلُ':Predicate, #1: 1	خَصَّ مَرَاسِيلَ
u'خَصَّ مَسٌّ':Predicate, #1: 1	خَصَّ مَرَاسِيلَ
u'خَصَّ مَسْجِدٌ':Predicate, #1: 1	خَصَّ مَسَّ
u'خَصْمٌ سُلْطَانٌ':Added, #1: 1	خَصَّ الْمَسْجِدَ
u'خَصَّ مُسْلِمٌ':Predicate, #2: 2	خَصْمَ السُّلْطَانِ
u'خَصْمٌ شَرْعِيٌّ':Added, #1: 1	خَصَّ الْمُسْلِمَ
u'خَصَّ مُصْحَفٌ':Predicate, #1: 1	خَصْمٍ شَرْعِيٍّ
u'خَصَّ مُصَنِّفٌ':Subject, #2: 2	خَصَّ الْمُصْحَفَ
u'خَصَّ مُطْلَقٌ':Predicate, #5: 5	خَصَّ الْمُصَنِّفُ
u'خَصَّ مَعْدِنٌ':Predicate, #1: 1	خَصَّ الْمُطْلَقَةَ
u'خَصْمٌ غَائِبٌ':Added, #1: 1	خَصَّ الْمَعْدِنَ
u'خَصْمٌ غَرِيمٌ':Added, #2: 2	خَصْمٍ غَائِبٍ
u'خَصَّ مَقْبَرَةٌ':Predicate, #2: 2	خَصْمُ الْغَرِيمِ
u'خَصْمٌ مَحْبُوسٌ':Added, #1: 1	خَصَّ الْمَقْبَرَةَ
u'خَصْمٌ مُسْتَحِقٌّ':Added, #1: 1	خَصْمٍ مَحْبُوسٍ
u'خَصْمٌ مُسْتَقْبَلٌ':Added, #1: 1	خَصْمٍ مُسْتَحِقٍّ
u'خَصْمٌ مُعَامِلٌ':Added, #2: 2	خَصْمٍ مُسْتَقْبَلٍ
u'خَصْمٌ مُقَدَّرٌ':Added, #1: 1	خَصْمُ مُعَامِلِهِ
u'خَصْمٌ مُنَازَعٌ':Added, #2: 2	خَصْمٍ مُقَدَّرٍ
u'خَصْمٌ مُنْكِرٌ':Added, #2: 2	خَصْمٍ مُنَازَعٍ
u'خَصَّ مَهْرٌ':Predicate, #1: 1	خَصْمٍ مُنْكِرٍ
u'خَصْمٌ واحد':Added, #1: 1	خَصَّ مَهْرَ
u'خَصْمٌ وَاحِدٌ':Added, #1: 1	خَصْمٍ وَاحِدٍ
u'خَصْمٌ وَارِثٌ':Added, #1: 1	خَصْمٍ وَاحِدٍ
u'خَصَّ نَبِيٌّ':Subject, #1: 1	خَصْمُ وَارِثِهِ
u'خَصَّ نِصْفٌ':Predicate, #2: 2	خَصَّ النَّبِيُّ
u'خَصَّ نَفْيٌ':Predicate, #3: 3	خَصَّ النِّصْفَ
u'خَصَّ نَقْضٌ':Predicate, #1: 1	خَصَّ نَفْيَ
u'خَصَّ وَاقِفٌ':Subject, #1: 1	خَصَّ نَقْضَ
u'خَصَّ وَجْهٌ':Predicate, #1: 1	خَصَّ الْوَاقِفُ
u'خَصَّ وُجُوبٌ':Predicate, #1: 1	خَصَّ الْوَجْهَ
u'خَصَّ وُجُوبٌ':Predicate, #1: 1	خَصَّ الْوُجُوبَ
u'خَصَّ وَقْفٌ':Predicate, #1: 1	خَصَّ وُجُوبَ
u'خُصُومَةٌ آدَمِيٌّ':Added, #1: 1	خَصَّ الْوَقْفَ
u'خُصُومَةٌ أَزْواجٌ':Added, #2: 2	خُصُومَةِ الْآدَمِيِّ
u'خُصُومَةٌ أُسْبُوعٌ':Added, #1: 1	خُصُومَةُ الْأَزْوَاجِ
u'خُصُومَةٌ أَوَّلُ':Added, #1: 1	خُصُومَةَ أُسْبُوعِ
u'خُصُومَةٌ بَائِعٌ':Added, #1: 1	خُصُومَةِ الْأَوَّلِ
u'خُصُومَةٌ جَارٌ':Added, #3: 3	خُصُومَةَ الْبَائِعِ
u'خُصُومَةٌ دَابَّةٌ':Added, #1: 1	خُصُومَةُ الْجَارِ
u'خُصُومَةٌ رَجُلٌ':Added, #1: 1	خُصُومَةُ الدَّابَّةِ
u'خُصُومَةٌ زَوْجٌ':Added, #2: 2	خُصُومَةِ رَجُلٍ
u'خُصُومَةٌ صَاحِبٌ':Added, #1: 1	خُصُومَةُ الزَّوْجِ
u'خُصُومَةٌ صَاحِبٌ':Added, #1: 1	خُصُومَةَ صَاحِبِ
u'خُصُومَةٌ صَاحِبٌ':Added, #1: 1	خُصُومَةُ صَاحِبِهِ
u'خُصُومَةٌ طَالِبٌ':Added, #1: 1	خُصُومَةِ صَاحِبِهِ
u'خُصُومَةٌ غَرِيبٌ':Added, #3: 3	خُصُومَةِ الطَّالِبِ
u'خُصُومَةٌ فُلاَنٌ':Added, #2: 2	خُصُومَةَ الْغَرِيبِ
u'خُصُومَةٌ فُلاَنٌ':Added, #2: 2	خُصُومَةَ فُلَانٍ
u'خُصُومَةٌ مَالِكٌ':Added, #3: 3	خُصُومَةِ فُلَانٍ
u'خُصُومَةٌ مَالِكٌ':Added, #1: 1	خُصُومَةَ الْمَالِكِ
u'خُصُومَةٌ مُسْتَقِيمٌ':Added, #1: 1	خُصُومَةِ الْمَالِكِ
u'خُصُومَةٌ مَسْرُوقٌ':Added, #2: 2	خُصُومَةٍ مُسْتَقِيمَةٍ
u'خُصُومَةٌ مُعْتَبَرٌ':Added, #1: 1	خُصُومَةَ الْمَسْرُوقِ
u'خُصُومَةٌ مُعَيَّنٌ':Added, #7: 7	خُصُومَةٍ مُعْتَبَرَةٍ
u'خُصُومَةٌ مَقْذُوفٌ':Added, #1: 1	خُصُومَةٍ مُعَيَّنَةٍ
u'خُصُومَةٌ نَصْرَانِيٌّ':Added, #1: 1	خُصُومَةُ الْمَقْذُوفِ
u'خُصُومَةٌ وَكِيلٌ':Added, #1: 1	خُصُومَةِ نَصْرَانِيٍّ
u'خَصَى عَبْدٌ':Predicate, #1: 1	خُصُومَةِ الْوَكِيلِ
u'خَصَى غَاصِبٌ':Subject, #2: 2	خَصَى عَبْدَ
u'خَصَى كَبْشٌ':Predicate, #1: 1	خَصَى الْغَاصِبُ
u'خَصَّ يهود':Predicate, #1: 1	خَصَى كَبْشَ
u'خَصَّ يَهُودٌ':Predicate, #1: 1	خَصَّ الْيَهُودَ
u'خِضَابٌ الْمَرْأَةُ':Added, #1: 1	خَصَّ الْيَهُودَ
u'خِضَابٌ الْمَرْأَةُ':Added, #1: 1	خِضَابَ الْمَرْأَةِ
u'خِضَابٌ حِنَّاءٌ':Added, #1: 1	خِضَابِ الْمَرْأَةِ
u'خِضَابٌ رَأْسٌ':Added, #2: 2	خِضَابِ الْحِنَّاءِ
u'خِضَابٌ رِجَالٌ':Added, #2: 2	خِضَابِ الرَّأْسِ
u'خِضَابٌ شَعْرٌ':Added, #1: 1	خِضَابِ الرِّجَالِ
u'خِضَابٌ شَعْرٌ':Added, #1: 1	خِضَابُ الشَّعْرِ
u'خِضَابٌ شيب':Added, #1: 1	خِضَابُ شَعْرِ
u'خِضَابٌ شَيْبٌ':Added, #1: 1	خِضَابِ الشَّيْبِ
u'خِضَابٌ شيب':Added, #1: 1	خِضَابِ الشَّيْبِ
u'خِضَابٌ شَيْبٌ':Added, #2: 2	خِضَابُ الشَّيْبِ
u'خِضَابٌ لِحْيَةٌ':Added, #2: 2	خِضَابُ الشَّيْبِ
u'خِضَابٌ نَبِيٌّ':Added, #2: 2	خِضَابُ اللِّحْيَةِ
u'خِضَابٌ نِساءٌ':Added, #2: 2	خِضَابِ النَّبِيِّ
u'خضب رَجُلٌ':Added, #1: 1	خِضَابِ النِّسَاءِ
u'خَضْبٌ رَجُلٌ':Added, #1: 1	خَضْبَ الرَّجُلِ
u'خَضَبَ رَسُولٌ':Subject, #1: 1	خَضْبَ الرَّجُلِ
u'خضب شيب':Added, #2: 2	خَضَبَ رَسُولُ
u'خضب شَيْبٌ':Added, #1: 1	خَضْبُ الشَّيْبِ
u'خَضْبٌ شيب':Added, #1: 1	خَضْبُ الشَّيْبِ
u'خَضْبٌ شَيْبٌ':Added, #1: 1	خَضْبُ الشَّيْبِ
u'خَضَّبَ صُوفٌ':Predicate, #1: 1	خَضْبُ الشَّيْبِ
u'خضب لِحْيَةٌ':Added, #1: 1	خَضَّبَ الصُّوفَ
u'خَضْبٌ لِحْيَةٌ':Added, #1: 1	خَضْبُ لِحْيَتِهِ
u'خضب نَحْوٌ':Added, #1: 1	خَضْبُ لِحْيَتِهِ
u'خَضْبٌ نَحْوٌ':Added, #1: 1	خَضْبُ نَحْوِ
u'خضب يَدٌ':Added, #1: 1	خَضْبُ نَحْوِ
u'خَضْبٌ يَدٌ':Added, #1: 1	خَضْبِ الْيَدَيْنِ
u'خَضَعَ وَجْهٌ':Subject, #1: 1	خَضْبِ الْيَدَيْنِ
u'خَطَّأَ إمَامٌ':Subject, #1: 1	خَضَعَ وَجْهُهُ
u'خَطَّأَ إمَامٌ':Subject, #1: 1	خَطَّأَ الْإِمَامُ
u'خِطَابٌ إبَاحَةٌ':Added, #1: 1	خَطَّأَ إمَامُ
u'خِطَابٌ أَجْنَبِيٌّ':Added, #1: 1	خِطَابُ الْإِبَاحَةِ
u'خِطَابٌ أَجْنَبِيٌّ':Added, #1: 1	خِطَابُ أَجْنَبِيٍّ
u'خِطَابٌ أحَدٌ':Added, #1: 1	خِطَابِ أَجْنَبِيٍّ
u'خِطَابٌ أحَدٌ':Added, #1: 1	خِطَابِ أَحَدٍ
u'خِطَابٌ أَحْكَامٌ':Added, #2: 2	خِطَابُ أَحَدٍ
u'خِطَابٌ إِخْبَارٌ':Added, #1: 1	خِطَابِ أَحْكَامِ
u'خِطَابٌ أَدَاءٌ':Added, #1: 1	خِطَابَ الْإِخْبَارِ
u'خِطَابٌ أَدَاءٌ':Added, #3: 3	خِطَابِ الْأَدَاءِ
u'خِطَابٌ آدَمِيٌّ':Added, #5: 5	خِطَابُ الْأَدَاءِ
u'خِطَابٌ آدَمِيٌّ':Added, #1: 1	خِطَابُ آدَمِيٍّ
u'خِطَابٌ آدَمِيٌّ':Added, #1: 1	خِطَابُ الْآدَمِيِّ
u'خِطَابٌ آدَمِيٌّ':Added, #2: 2	خِطَابِ آدَمِيٍّ
u'خِطَابٌ إِلْزَامٌ':Added, #5: 5	خِطَابَ آدَمِيٍّ
u'خِطَابٌ الْمَرْأَةُ':Added, #1: 1	خِطَابِ الْإِلْزَامِ
u'خِطَابٌ اِمْرَأَةٌ':Added, #1: 1	خِطَابِ الْمَرْأَةِ
u'خِطَابٌ إِنْسانٌ':Added, #1: 1	خِطَابُ امْرَأَتِهِ
u'خِطَابٌ أَوْلِيَاءُ':Added, #1: 1	خِطَابَ إنْسَانٍ
u'خَطَابَةٌ عَامِّيٌّ':Added, #1: 1	خِطَابِ الْأَوْلِيَاءِ
u'خِطَابٌ تَحْرِيمٌ':Added, #1: 1	خَطَابَةٍ عَامِّيَّةٍ
u'خِطَابٌ تَحْرِيمٌ':Added, #1: 1	خِطَابَ التَّحْرِيمِ
u'خِطَابٌ تَحْرِيمٌ':Added, #1: 1	خِطَابُ التَّحْرِيمِ
u'خِطَابٌ تَخْصِيصٌ':Added, #1: 1	خِطَابُ تَحْرِيمِهِ
u'خِطَابٌ تَشْرِيفٌ':Added, #1: 1	خِطَابِ التَّخْصِيصِ
u'خِطَابٌ تَطْهِيرٌ':Added, #1: 1	خِطَابِ التَّشْرِيفِ
u'خِطَابٌ تَكْليفٌ':Added, #1: 1	خِطَابَ التَّطْهِيرِ
u'خِطَابٌ تَكْليفٌ':Added, #12: 12	خِطَابِ التَّكْلِيفِ
u'خِطَابٌ تَكْليفٌ':Added, #1: 1	خِطَابَ التَّكْلِيفِ
u'خِطَابٌ تَلَطُّفٌ':Added, #3: 3	خِطَابُ التَّكْلِيفِ
u'خِطَابٌ جَديدٌ':Added, #1: 1	خِطَابُ تَلَطُّفٍ
u'خِطَابٌ جَزَاءٌ':Added, #2: 2	خِطَابٍ جَدِيدٍ
u'خِطَابٌ جَزْم':Added, #2: 2	خِطَابُ الْجَزَاءِ
u'خِطَابٌ جَمَاعَةٌ':Added, #1: 1	خِطَابُ الْجَزْمِ
u'خِطَابٌ جَمْعٌ':Added, #1: 1	خِطَابُ الْجَمَاعَةِ
u'خِطَابٌ جمعة':Added, #1: 1	خِطَابُ جَمْعٍ
u'خِطَابٌ جُمُعَةٌ':Added, #1: 1	خِطَابُ الْجُمُعَةِ
u'خِطَابٌ حاضِرٌ':Added, #1: 1	خِطَابُ الْجُمُعَةِ
u'خِطَابٌ حَظْر':Added, #1: 1	خِطَابِ الْحَاضِرِ
u'خِطَابٌ حُكْمٌ':Added, #1: 1	خِطَابُ الْحَظْرِ
u'خِطَابٌ خَالِقٌ':Added, #1: 1	خِطَابِ الْحُكْمِ
u'خِطَابٌ دفع':Added, #1: 1	خِطَابُ الْخَالِقِ
u'خِطَابٌ دَفْعٌ':Added, #2: 2	خِطَابِ الدَّفْعِ
u'خِطَابٌ رِجَالٌ':Added, #2: 2	خِطَابِ الدَّفْعِ
u'خِطَابٌ رِجَالٌ':Added, #1: 1	خِطَابَ الرِّجَالِ
u'خِطَابٌ رَدٌّ':Added, #2: 2	خِطَابِ الرِّجَالِ
u'خِطَابٌ رَسُولٌ':Added, #1: 1	خِطَابُ الرَّدِّ
u'خِطَابٌ رَسُولٌ':Added, #1: 1	خِطَابِ الرَّسُولِ
u'خِطَابٌ زواجر':Added, #1: 1	خِطَابَ رَسُولِ
u'خِطَابٌ زَوْجٌ':Added, #2: 2	خِطَابَ الزَّوَاجِرِ
u'خِطَابٌ سَابِقٌ':Added, #1: 1	خِطَابِ الزَّوْجِ
u'خِطَابٌ سَتْرٌ':Added, #1: 1	خِطَابٍ سَابِقٍ
u'خِطَابٌ سِتْرٌ':Added, #1: 1	خِطَابَ السَّتْرِ
u'خِطَابٌ شَارِعٌ':Added, #1: 1	خِطَابُ السِّتْرِ
u'خِطَابٌ شَارِعٌ':Added, #4: 4	خِطَابُ الشَّارِعِ
u'خِطَابٌ شَرْعٌ':Added, #9: 9	خِطَابِ الشَّارِعِ
u'خِطَابٌ شَرْعٌ':Added, #11: 11	خِطَابِ الشَّرْعِ
u'خِطَابٌ شَرْعٌ':Added, #1: 1	خِطَابَ الشَّرْعِ
u'خِطَابٌ شَرْعِيٌّ':Added, #7: 7	خِطَابُ الشَّرْعِ
u'خِطَابٌ صَاحِبٌ':Added, #1: 1	خِطَابٍ شَرْعِيٍّ
u'خِطَابٌ صَبِيٌّ':Added, #2: 2	خِطَابِ صَاحِبِهِ
u'خِطَابٌ صِبْيَانٌ':Added, #1: 1	خِطَابَ الصَّبِيِّ
u'خِطَابٌ صَلاَةٌ':Added, #1: 1	خِطَابُ الصِّبْيَانِ
u'خِطَابٌ صَوْمٌ':Added, #1: 1	خِطَابِ الصَّلَاةِ
u'خِطَابٌ عَامٌّ':Added, #1: 1	خِطَابُ الصَّوْمِ
u'خِطَابٌ عقاب':Added, #2: 2	خِطَابٍ عَامٍّ
u'خِطَابٌ عِقَابٌ':Added, #1: 1	خِطَابَ عِقَابٍ
u'خِطَابٌ غَائِبٌ':Added, #1: 1	خِطَابَ عِقَابٍ
u'خِطَابٌ غير':Added, #1: 1	خِطَابِ الْغَائِبِ
u'خِطَابٌ غَيْرٌ':Added, #1: 1	خِطَابُ الْغَيْرِ
u'خِطَابٌ فَرْضٌ':Added, #1: 1	خِطَابُ الْغَيْرِ
u'خِطَابٌ قُرْآنٌ':Added, #1: 1	خِطَابَ فَرْضٍ
u'خِطَابٌ كُفَّارٌ':Added, #1: 1	خِطَابِ الْقُرْآنِ
u'خِطَابٌ كُفَّارٌ':Added, #13: 13	خِطَابِ الْكُفَّارِ
u'خِطَابٌ لَفْظٌ':Added, #2: 2	خِطَابُ الْكُفَّارِ
u'خِطَابٌ لَفْظٌ':Added, #1: 1	خِطَابَ اللَّفْظِ
u'خِطَابٌ مُتَأَخِّرٌ':Added, #1: 1	خِطَابِ اللَّفْظِ
u'خِطَابٌ مَجْهُولٌ':Added, #1: 1	خِطَابٍ مُتَأَخِّرٍ
u'خِطَابٌ مَخْلُوقٌ':Added, #1: 1	خِطَابِ الْمَجْهُولِ
u'خِطَابٌ مُذَكَّرٌ':Added, #2: 2	خِطَابَ مَخْلُوقٍ
u'خِطَابٌ مُشَابَهَةٌ':Added, #1: 1	خِطَابِ الْمُذَكَّرِ
u'خِطَابٌ مُشَافَهَةٌ':Added, #1: 1	خِطَابَ الْمُشَابَهَةِ
u'خِطَابٌ مُشَافَهَةٌ':Added, #1: 1	خِطَابَ الْمُشَافَهَةِ
u'خِطَابٌ مُشَافَهَةٌ':Added, #1: 1	خِطَابُ الْمُشَافَهَةِ
u'خِطَابٌ مُطَالَبٌ':Added, #1: 1	خِطَابِ الْمُشَافَهَةِ
u'خِطَابٌ مُطَالَبَةٌ':Added, #1: 1	خِطَابَ مُطَالَبَةٍ
u'خِطَابٌ مَعْدُومٌ':Added, #1: 1	خِطَابَ مُطَالَبَةٍ
u'خِطَابٌ مَعْدُومٌ':Added, #1: 1	خِطَابِ الْمَعْدُومِ
u'خِطَابٌ مُعَيَّنٌ':Added, #2: 2	خِطَابَ الْمَعْدُومِ
u'خِطَابٌ مَكْفُولٌ':Added, #1: 1	خِطَابِ الْمُعَيَّنِ
u'خِطَابٌ مَكْفُولٌ':Added, #1: 1	خِطَابِ الْمَكْفُولِ
u'خِطَابٌ مُكَلَّفٌ':Added, #2: 2	خِطَابُ الْمَكْفُولِ
u'خِطَابٌ مُوَاجَهَةٌ':Added, #2: 2	خِطَابِ الْمُكَلَّفِ
u'خِطَابٌ مُوَاجَهَةٌ':Added, #1: 1	خِطَابَ الْمُوَاجَهَةِ
u'خِطَابٌ مُوَاجَهَةٌ':Added, #1: 1	خِطَابُ الْمُوَاجَهَةِ
u'خِطَابٌ نَاسٌ':Added, #2: 2	خِطَابِ الْمُوَاجَهَةِ
u'خِطَابٌ نَدْبٌ':Added, #1: 1	خِطَابُ النَّاسِ
u'خِطَابٌ نِساءٌ':Added, #2: 2	خِطَابُ النَّدْبِ
u'خِطَابٌ نَفْسِيٌّ':Added, #1: 1	خِطَابِ النِّسَاءِ
u'خِطَابٌ نَهْيٌ':Added, #1: 1	خِطَابٍ نَفْسِيٍّ
u'خِطَابٌ وَاجِبٌ':Added, #1: 1	خِطَابُ نَهْيِ
u'خِطَابٌ واحد':Added, #1: 1	خِطَابُ الْوَاجِبِ
u'خِطَابٌ واحد':Added, #1: 1	خِطَابَ الْوَاحِدِ
u'خِطَابٌ واحد':Added, #1: 1	خِطَابُ الْوَاحِدِ
u'خِطَابٌ وَاحِدٌ':Added, #1: 1	خِطَابِ الْوَاحِدِ
u'خِطَابٌ وَاحِدٌ':Added, #1: 1	خِطَابَ الْوَاحِدِ
u'خِطَابٌ وَاحِدٌ':Added, #1: 1	خِطَابُ الْوَاحِدِ
u'خِطَابٌ واحد':Added, #1: 1	خِطَابِ الْوَاحِدِ
u'خِطَابٌ وَاحِدٌ':Added, #2: 2	خِطَابٍ وَاحِدٍ
u'خِطَابٌ وَضْعٌ':Added, #2: 2	خِطَابٍ وَاحِدٍ
u'خِطَابٌ وَضْعٌ':Added, #2: 2	خِطَابَ الْوَضْعِ
u'خِطَابٌ وَضْعٌ':Added, #30: 30	خِطَابِ الْوَضْعِ
u'خِطَابٌ وَضْعٌ':Added, #3: 3	خِطَابُ وَضْعٍ
u'خِطَابٌ وُضُوءٌ':Added, #7: 7	خِطَابُ الْوَضْعِ
u'خِطَابٌ ولد':Added, #1: 1	خِطَابُ الْوُضُوءِ
u'خِطَابٌ وَلَدٌ':Added, #1: 1	خِطَابِ الْوَلَدِ
u'خَطَّ أَرْبَعَةٌ':Predicate, #1: 1	خِطَابِ الْوَلَدِ
u'خَطَّأَ رِوايَةٌ':Predicate, #1: 1	خَطَّ أَرْبَعَةَ
u'خَطَّأَ صَاحِبٌ':Predicate, #1: 1	خَطَّأَ رِوَايَةَ
u'خَطَا غناء':Predicate, #1: 1	خَطَّأَ صَاحِبَ
u'خَطَا غِنَاءٌ':Predicate, #1: 1	خَطَا الْغِنَاءَ
u'خَطَبَ اِبْنٌ':Subject, #1: 1	خَطَا الْغِنَاءَ
u'خَطَبَ اِبْنٌ':Subject, #1: 1	خَطَبَ ابْنُ
u'خَطَبَ اِبْنَة':Predicate, #1: 1	خَطَبَ ابْنُهُ
u'خَطَبَ أُخْتٌ':Predicate, #6: 6	خَطَبَ ابْنَةَ
u'خَطَبَ الْمَرْأَةُ':Predicate, #1: 1	خَطَبَ أُخْتَ
u'خَطَبَ أُمٌّ':Predicate, #1: 1	خَطَبَ الْمَرْأَةَ
u'خَطَبَ إمَامٌ':Subject, #7: 7	خَطَبَ أُمَّ
u'خَطَبَ إمَامٌ':Subject, #10: 10	خَطَبَ الْإِمَامُ
u'خَطَبَ أهْلٌ':Predicate, #1: 1	خَطَبَ إمَامُهُ
u'خَطَبَ أيَّامٌ':Predicate, #1: 1	خَطَبَ أَهْلَ
u'خَطَبَ أَيَّامٌ':Predicate, #1: 1	خَطَبَ أَيَّامَ
u'خَطَبَ بِنْتٌ':Predicate, #1: 1	خَطَبَ أَيَّامَ
u'خطبة أمَةٌ':Added, #2: 2	خَطَبَ بِنْتَ
u'خِطْبَةٌ أمَةٌ':Added, #1: 1	خِطْبَةُ الْأَمَةِ
u'خطبة اِمْرَأَةٌ':Added, #1: 1	خِطْبَةُ الْأَمَةِ
u'خِطْبَةٌ اِمْرَأَةٌ':Added, #7: 7	خِطْبَةَ امْرَأَةٍ
u'خطبة أَوَّلُ':Added, #7: 7	خِطْبَةَ امْرَأَةٍ
u'خِطْبَةٌ أَوَّلُ':Added, #1: 1	خِطْبَةِ الْأَوَّلِ
u'خطبة ذِمِّيٌّ':Added, #1: 1	خِطْبَةِ الْأَوَّلِ
u'خِطْبَةٌ ذِمِّيٌّ':Added, #2: 2	خِطْبَةِ الذِّمِّيِّ
u'خطبة رَجُلٌ':Added, #2: 2	خِطْبَةِ الذِّمِّيِّ
u'خِطْبَةٌ رَجُلٌ':Added, #1: 1	خِطْبَةُ رَجُلٍ
u'خطبة غير':Added, #1: 1	خِطْبَةُ رَجُلٍ
u'خطبة غَيْرٌ':Added, #1: 1	خِطْبَةُ غَيْرِ
u'خِطْبَةٌ غير':Added, #1: 1	خِطْبَةُ غَيْرِ
u'خِطْبَةٌ غَيْرٌ':Added, #1: 1	خِطْبَةُ غَيْرِ
u'خطبة غير':Added, #1: 1	خِطْبَةُ غَيْرِ
u'خطبة غَيْرٌ':Added, #3: 3	خِطْبَةِ غَيْرِهِ
u'خِطْبَةٌ غير':Added, #3: 3	خِطْبَةِ غَيْرِهِ
u'خِطْبَةٌ غَيْرٌ':Added, #3: 3	خِطْبَةِ غَيْرِهِ
u'خطبة غير':Added, #3: 3	خِطْبَةِ غَيْرِهِ
u'خطبة غَيْرٌ':Added, #4: 4	خِطْبَةِ الْغَيْرِ
u'خِطْبَةٌ غير':Added, #4: 4	خِطْبَةِ الْغَيْرِ
u'خِطْبَةٌ غَيْرٌ':Added, #4: 4	خِطْبَةِ الْغَيْرِ
u'خطبة فَاسِقٌ':Added, #4: 4	خِطْبَةِ الْغَيْرِ
u'خِطْبَةٌ فَاسِقٌ':Added, #1: 1	خِطْبَةُ الْفَاسِقِ
u'خطبة فَاسِقٌ':Added, #1: 1	خِطْبَةُ الْفَاسِقِ
u'خِطْبَةٌ فَاسِقٌ':Added, #2: 2	خِطْبَةِ الْفَاسِقِ
u'خطبة كَافِرٌ':Added, #2: 2	خِطْبَةِ الْفَاسِقِ
u'خِطْبَةٌ كَافِرٌ':Added, #1: 1	خِطْبَةِ الْكَافِرِ
u'خطبة مُحْرِمٌ':Added, #1: 1	خِطْبَةِ الْكَافِرِ
u'خِطْبَةٌ مُحْرِمٌ':Added, #1: 1	خِطْبَةُ الْمُحْرِمَةِ
u'خطبة مُحْرِمٌ':Added, #1: 1	خِطْبَةُ الْمُحْرِمَةِ
u'خطبة مُحْرِمٌ':Added, #1: 1	خِطْبَةُ مُحْرِمَةٍ
u'خِطْبَةٌ مُحْرِمٌ':Added, #1: 1	خِطْبَةِ مُحْرِمَةٍ
u'خِطْبَةٌ مُحْرِمٌ':Added, #1: 1	خِطْبَةُ مُحْرِمَةٍ
u'خطبة مُحْرِمٌ':Added, #1: 1	خِطْبَةِ مُحْرِمَةٍ
u'خِطْبَةٌ مُحْرِمٌ':Added, #2: 2	خِطْبَةُ الْمُحْرِمِ
u'خطبة مَسْخُوط':Added, #2: 2	خِطْبَةُ الْمُحْرِمِ
u'خِطْبَةٌ مَسْخُوط':Added, #1: 1	خِطْبَةِ الْمَسْخُوطِ
u'خطبة مُسْلِمٌ':Added, #1: 1	خِطْبَةِ الْمَسْخُوطِ
u'خِطْبَةٌ مُسْلِمٌ':Added, #1: 1	خِطْبَةِ مُسْلِمٍ
u'خطبة مُعْتَدٌّ':Added, #1: 1	خِطْبَةِ مُسْلِمٍ
u'خِطْبَةٌ مُعْتَدٌّ':Added, #1: 1	خِطْبَةُ الْمُعْتَدَّةِ
u'خطبة مُعْتَدٌّ':Added, #1: 1	خِطْبَةُ الْمُعْتَدَّةِ
u'خِطْبَةٌ مُعْتَدٌّ':Added, #1: 1	خِطْبَةٍ مُعْتَدَّةٍ
u'خطبة مُعْتَدٌّ':Added, #1: 1	خِطْبَةٍ مُعْتَدَّةٍ
u'خِطْبَةٌ مُعْتَدٌّ':Added, #2: 2	خِطْبَةِ الْمُعْتَدَّةِ
u'خطبة مُعْتَدٌّ':Added, #2: 2	خِطْبَةِ الْمُعْتَدَّةِ
u'خِطْبَةٌ مُعْتَدٌّ':Added, #2: 2	خِطْبَةِ مُعْتَدَّةٍ
u'خطبة مَنْكُوح':Added, #2: 2	خِطْبَةِ مُعْتَدَّةٍ
u'خِطْبَةٌ مَنْكُوح':Added, #1: 1	خِطْبَةِ الْمَنْكُوحَةِ
u'خطبة نَحْوٌ':Added, #1: 1	خِطْبَةِ الْمَنْكُوحَةِ
u'خِطْبَةٌ نَحْوٌ':Added, #1: 1	خِطْبَةُ نَحْوِ
u'خطبة نِساءٌ':Added, #1: 1	خِطْبَةُ نَحْوِ
u'خِطْبَةٌ نِساءٌ':Added, #14: 14	خِطْبَةِ النِّسَاءِ
u'خطبة نكاح':Added, #14: 14	خِطْبَةِ النِّسَاءِ
u'خطبة نِكَاحٌ':Added, #1: 1	خِطْبَةَ النِّكَاحِ
u'خِطْبَةٌ نكاح':Added, #1: 1	خِطْبَةَ النِّكَاحِ
u'خِطْبَةٌ نِكَاحٌ':Added, #1: 1	خِطْبَةَ النِّكَاحِ
u'خَطَبَ حَديثٌ':Predicate, #1: 1	خِطْبَةَ النِّكَاحِ
u'خَطَبَ حَسَنٌ':Subject, #2: 2	خَطَبَ الْحَدِيثَ
u'خَطَبَ خطبة':Predicate, #2: 2	خَطَبَ الْحَسَنُ
u'خَطَبَ خُطْبَةٌ':Predicate, #1: 1	خَطَبَ خُطْبَةَ
u'خَطَبَ رَجُلٌ':Subject, #1: 1	خَطَبَ خُطْبَةَ
u'خَطَبَ رَجُلٌ':Subject, #1: 1	خَطَبَ الرَّجُلُ
u'خَطَبَ رَسُولٌ':Subject, #4: 4	خَطَبَ رَجُلٌ
u'خَطَبَ صَبِيٌّ':Subject, #26: 26	خَطَبَ رَسُولُ
u'خَطَبَ صَبِيٌّ':Subject, #1: 1	خَطَبَ الصَّبِيُّ
u'خَطَبَ ضَرَّةٌ':Predicate, #4: 4	خَطَبَ صَبِيٌّ
u'خَطَبَ عَائِشٌ':Predicate, #1: 1	خَطَبَ الضَّرَّةَ
u'خَطَبَ عَشِيَّةٌ':Predicate, #2: 2	خَطَبَ عَائِشَةَ
u'خَطَبَ عَطْفٌ':Subject, #2: 2	خَطَبَ عَشِيَّةَ
u'خَطَبَ عَلِيٌّ':Subject, #1: 1	خَطَبَ عَطْفٌ
u'خَطَبَ عُمَرٌ':Subject, #2: 2	خَطَبَ عَلِيٌّ
u'خَطَبَ عند':Predicate, #9: 9	خَطَبَ عُمَرُ
u'خَطَبَ فَاسِقٌ':Subject, #1: 1	خَطَبَ عِنْدَ
u'خَطَبَ فُلاَنٌ':Subject, #1: 1	خَطَبَ الْفَاسِقُ
u'خَطَبَ فلان':Subject, #1: 1	خَطَبَ فُلَانُ
u'خَطَبَ فُلاَنٌ':Subject, #1: 1	خَطَبَ مُعَاوِيَةُ
u'خَطَبَ كَافِرٌ':Subject, #2: 2	خَطَبَ فُلَانٌ
u'خَطَبَ مَأْمُونٌ':Subject, #1: 1	خَطَبَ الْكَافِرُ
u'خَطَبَ مرد':Subject, #1: 1	خَطَبَ الْمَأْمُونُ
u'خَطَبَ مُسْلِمٌ':Predicate, #1: 1	خَطَبَ الْمُرْدُ
u'خَطَبَ مُعاوِيَة':Subject, #1: 1	خَطَبَ الْمُسْلِمَةَ
u'خَطَبَ مَقْدَمٌ':Predicate, #1: 1	خَطَبَ مُعَاوِيَةُ
u'خَطَبَ مُمَيِّزٌ':Subject, #1: 1	خَطَبَ مَقْدَمَ
u'خَطَبَ مَيْمُونٌ':Predicate, #1: 1	خَطَبَ مُمَيِّزٌ
u'خَطَبَ نَاسٌ':Predicate, #1: 1	خَطَبَ مَيْمُونَةَ
u'خَطَبَ نَبِيٌّ':Subject, #47: 47	خَطَبَ النَّاسَ
u'خَطَبَ واحد':Predicate, #4: 4	خَطَبَ النَّبِيُّ
u'خَطَبَ وَاحِدٌ':Predicate, #3: 3	خَطَبَ وَاحِدَةً
u'خَطَبَ وَاهِبٌ':Predicate, #3: 3	خَطَبَ وَاحِدَةً
u'خَطَبَ وسط':Predicate, #2: 2	خَطَبَ الْوَاهِبَةَ
u'خَطَبَ وَسَطٌ':Predicate, #1: 1	خَطَبَ وَسَطَ
u'خَطَّ بَيْنٌ':Predicate, #1: 1	خَطَبَ وَسَطَ
u'خَطَبَ يَوْمٌ':Predicate, #1: 1	خَطَّ بَيْنَ
u'خطر اِحْتِمَالٌ':Added, #14: 14	خَطَبَ يَوْمَ
u'خَطَرٌ اِحْتِمَالٌ':Added, #1: 1	خَطَرِ احْتِمَالِ
u'خطر أَمْرٌ':Added, #1: 1	خَطَرِ احْتِمَالِ
u'خَطَرٌ أَمْرٌ':Added, #1: 1	خَطَرِ أَمْرِ
u'خطر إِنْكارٌ':Added, #1: 1	خَطَرِ أَمْرِ
u'خَطَرٌ إِنْكارٌ':Added, #1: 1	خَطَرِ إنْكَارِ
u'خطر بَحْرٌ':Added, #1: 1	خَطَرِ إنْكَارِ
u'خَطَرٌ بَحْرٌ':Added, #1: 1	خَطَرِ الْبَحْرِ
u'خطر بِدْعَةٌ':Added, #1: 1	خَطَرِ الْبَحْرِ
u'خَطَرٌ بِدْعَةٌ':Added, #1: 1	خَطَرُ بِدْعَتِهِ
u'خطر تَرْكٌ':Added, #1: 1	خَطَرُ بِدْعَتِهِ
u'خَطَرٌ تَرْكٌ':Added, #2: 2	خَطَرُ التَّرْكِ
u'خطر ثَلاثَةٌ':Added, #2: 2	خَطَرُ التَّرْكِ
u'خَطَرٌ ثَلاثَةٌ':Added, #1: 1	خَطَرُ الثَّلَاثَةِ
u'خطر دِماءٌ':Added, #1: 1	خَطَرُ الثَّلَاثَةِ
u'خَطَرٌ دِماءٌ':Added, #1: 1	خَطَرِ الدِّمَاءِ
u'خطر دَيْنٌ':Added, #1: 1	خَطَرِ الدِّمَاءِ
u'خَطَرٌ دَيْنٌ':Added, #1: 1	خَطَرَ الدَّيْنِ
u'خَطَّ رَسُولٌ':Subject, #1: 1	خَطَرَ الدَّيْنِ
u'خطر ضَمَانٌ':Added, #6: 6	خَطَّ رَسُولُ
u'خَطَرٌ ضَمَانٌ':Added, #5: 5	خَطَرِ الضَّمَانِ
u'خطر طَرِيقٌ':Added, #5: 5	خَطَرِ الضَّمَانِ
u'خَطَرٌ طَرِيقٌ':Added, #10: 10	خَطَرِ الطَّرِيقِ
u'خطر طَرِيقٌ':Added, #10: 10	خَطَرِ الطَّرِيقِ
u'خَطَرٌ طَرِيقٌ':Added, #2: 2	خَطَرَ الطَّرِيقِ
u'خطر عَدَمٌ':Added, #2: 2	خَطَرَ الطَّرِيقِ
u'خَطَرٌ عَدَمٌ':Added, #2: 2	خَطَرُ الْعَدَمِ
u'خَطَرٌ عَظِيم':Added, #2: 2	خَطَرُ الْعَدَمِ
u'خَطَرَ غير':Subject, #1: 1	خَطَرٍ عَظِيمٍ
u'خَطَرَ غَيْرٌ':Subject, #1: 1	خَطَرَ غَيْرُهُ
u'خطر فساد':Added, #1: 1	خَطَرَ غَيْرُهُ
u'خَطَرٌ فساد':Added, #1: 1	خَطَرِ فَسَادِ
u'خطر فَسَادٌ':Added, #1: 1	خَطَرِ فَسَادِ
u'خَطَرٌ فَسَادٌ':Added, #1: 1	خَطَرِ فَسَادِ
u'خطر فَوَاتٌ':Added, #1: 1	خَطَرِ فَسَادِ
u'خَطَرٌ فَوَاتٌ':Added, #1: 1	خَطَرَ الْفَوَاتِ
u'خطر فَوَاتٌ':Added, #1: 1	خَطَرَ الْفَوَاتِ
u'خَطَرٌ فَوَاتٌ':Added, #1: 1	خَطَرِ فَوَاتِ
u'خطر فَوَاتٌ':Added, #1: 1	خَطَرِ فَوَاتِ
u'خَطَرٌ فَوَاتٌ':Added, #2: 2	خَطَرُ الْفَوَاتِ
u'خطر قُرْعَةٌ':Added, #2: 2	خَطَرُ الْفَوَاتِ
u'خَطَرٌ قُرْعَةٌ':Added, #1: 1	خَطَرِ الْقُرْعَةِ
u'خطر قَطْع':Added, #1: 1	خَطَرِ الْقُرْعَةِ
u'خَطَرٌ قَطْع':Added, #1: 1	خَطَرُ الْقَطْعَيْنِ
u'خطر قَطْعٌ':Added, #1: 1	خَطَرُ الْقَطْعَيْنِ
u'خَطَرٌ قَطْعٌ':Added, #3: 3	خَطَرُ الْقَطْعِ
u'خطر كِتْمَانٌ':Added, #3: 3	خَطَرُ الْقَطْعِ
u'خَطَرٌ كِتْمَانٌ':Added, #1: 1	خَطَرِ كِتْمَانِ
u'خطر مَالٌ':Added, #1: 1	خَطَرِ كِتْمَانِ
u'خَطَرٌ مَالٌ':Added, #1: 1	خَطَرِ الْمَالِ
u'خطر مَحَلٌّ':Added, #1: 1	خَطَرِ الْمَالِ
u'خَطَرٌ مَحَلٌّ':Added, #1: 1	خَطَرِ الْمَحَلِّ
u'خطر مَشِيئَةٌ':Added, #1: 1	خَطَرِ الْمَحَلِّ
u'خَطَرٌ مَشِيئَةٌ':Added, #1: 1	خَطَرِ الْمَشِيئَةِ
u'خطر مِلْكٌ':Added, #1: 1	خَطَرِ الْمَشِيئَةِ
u'خَطَرٌ مِلْكٌ':Added, #1: 1	خَطَرِ مِلْكِ
u'خطر مَوْتٌ':Added, #1: 1	خَطَرِ مِلْكِ
u'خَطَرٌ مَوْتٌ':Added, #1: 1	خَطَرِ الْمَوْتِ
u'خطر نَفْسٌ':Added, #1: 1	خَطَرِ الْمَوْتِ
u'خَطَرٌ نَفْسٌ':Added, #2: 2	خَطَرِ النَّفْسِ
u'خطر نكاح':Added, #2: 2	خَطَرِ النَّفْسِ
u'خَطَرٌ نكاح':Added, #1: 1	خَطَرِ النِّكَاحِ
u'خطر نِكَاحٌ':Added, #1: 1	خَطَرِ النِّكَاحِ
u'خَطَرٌ نِكَاحٌ':Added, #1: 1	خَطَرِ النِّكَاحِ
u'خطر هلاك':Added, #1: 1	خَطَرِ النِّكَاحِ
u'خَطَرٌ هلاك':Added, #2: 2	خَطَرُ الْهَلَاكِ
u'خطر هَلاَكٌ':Added, #2: 2	خَطَرُ الْهَلَاكِ
u'خَطَرٌ هَلاَكٌ':Added, #2: 2	خَطَرُ الْهَلَاكِ
u'خطر هلاك':Added, #2: 2	خَطَرُ الْهَلَاكِ
u'خَطَرٌ هلاك':Added, #3: 3	خَطَرِ الْهَلَاكِ
u'خطر هَلاَكٌ':Added, #3: 3	خَطَرِ الْهَلَاكِ
u'خَطَرٌ هَلاَكٌ':Added, #3: 3	خَطَرِ الْهَلَاكِ
u'خطر وُجُودٌ':Added, #3: 3	خَطَرِ الْهَلَاكِ
u'خَطَرٌ وُجُودٌ':Added, #1: 1	خَطَرُ الْوُجُودِ
u'خطر وُجُودٌ':Added, #1: 1	خَطَرُ الْوُجُودِ
u'خَطَرٌ وُجُودٌ':Added, #32: 32	خَطَرِ الْوُجُودِ
u'خطر وُقُوعٌ':Added, #32: 32	خَطَرِ الْوُجُودِ
u'خطر وُقُوعٌ':Added, #1: 1	خَطَرَ الْوُقُوعِ
u'خَطَرٌ وُقُوعٌ':Added, #1: 1	خَطَرِ الْوُقُوعِ
u'خَطَرٌ وُقُوعٌ':Added, #1: 1	خَطَرَ الْوُقُوعِ
u'خَطَّطَ نَبِيٌّ':Predicate, #1: 1	خَطَرِ الْوُقُوعِ
u'خَطَّ عَبْدٌ':Subject, #1: 1	خَطَّطَ النَّبِيَّ
u'خَطَّ عند':Predicate, #1: 1	خَطَّ عَبْدُ
u'خَطْفٌ بَرْقٌ':Added, #1: 1	خَطَّ عِنْدَ
u'خَطْفٌ بَصَرٌ':Added, #1: 1	خَطْفَ بَرْقٍ
u'خَطِفَ خطفة':Predicate, #1: 1	خَطْفِ الْبَصَرِ
u'خَطِفَ خَطْفَةٌ':Predicate, #1: 1	خَطِفَ الْخَطْفَةَ
u'خَطَفَ كَلْبٌ':Subject, #1: 1	خَطِفَ الْخَطْفَةَ
u'خَطْفٌ لَحْمٌ':Added, #1: 1	خَطَفَ الْكَلْبُ
u'خَطْفٌ مَالٌ':Added, #1: 1	خَطْفَ لَحْمٍ
u'خَطَّ قَلَمٌ':Subject, #1: 1	خَطْفَ الْمَالِ
u'خَطَّ مَسْجِدٌ':Predicate, #1: 1	خَطَّ الْقَلَمُ
u'خَطَّ مَلِكٌ':Subject, #1: 1	خَطَّ الْمَسْجِدَ
u'خُطُوطٌ إمَامٌ':Added, #1: 1	خَطَّ الْمَلِكُ
u'خُطُوطٌ شُهُودٌ':Added, #1: 1	خُطُوطَ الْإِمَامِ
u'خُطُوطٌ عُدُولٌ':Added, #1: 1	خُطُوطِ الشُّهُودِ
u'خُطُوطٌ علماء':Added, #1: 1	خُطُوطُ عُدُولٍ
u'خُطُوطٌ عُلَمَاءُ':Added, #1: 1	خُطُوطَ الْعُلَمَاءِ
u'خُطُوطٌ عُمَّالٌ':Added, #1: 1	خُطُوطَ الْعُلَمَاءِ
u'خُطُوطٌ مَصَاحِفُ':Added, #2: 2	خُطُوطِ الْعُمَّالِ
u'خَطِئَ جِهَةٌ':Predicate, #1: 1	خُطُوطُ الْمَصَاحِفِ
u'خَطِئَ حُجَّةٌ':Predicate, #1: 1	أَخْطَأَ جِهَةَ
u'خَطِئَ حَقٌّ':Predicate, #3: 3	أَخْطَأَ الْحُجَّةَ
u'خَطِئَ خَطِيئَةٌ':Predicate, #2: 2	أَخْطَأَ الْحَقَّ
u'خَطِئَ دَليلٌ':Predicate, #1: 1	أَخْطَأَ الْخَطِيئَةَ
u'خَطِئَ رَأْيٌ':Predicate, #1: 1	أَخْطَأَ الدَّلِيلَ
u'خَطِئَ سُنَّةٌ':Predicate, #1: 1	أَخْطَأَ الرَّأْيَ
u'خَطِئَ صَوَابٌ':Predicate, #19: 19	أَخْطَأَ السُّنَّةَ
u'خَطِئَ ضَرٌّ':Predicate, #1: 1	أَخْطَأَ الصَّوَابَ
u'خَطِئَ طَرِيقٌ':Predicate, #1: 1	أَخْطَأَ ضَرَّ
u'خَطِئَ طَرِيقٌ':Predicate, #1: 1	أَخْطَأَ طَرِيقَ
u'خَطِئَ طَرِيقٌ':Predicate, #3: 3	خَطِئَ طَرِيقَ
u'خَطِئَ عَدَدٌ':Predicate, #4: 4	أَخْطَأَ الطَّرِيقَ
u'خَطِئَ عند':Predicate, #3: 3	أَخْطَأَ الْعَدَدَ
u'خَطِئَ عين':Predicate, #1: 1	أَخْطَأَ عِنْدَ
u'خَطِئَ عَيْنٌ':Predicate, #1: 1	أَخْطَأَ عَيْنَ
u'خَطِئَ عَيْن':Predicate, #1: 1	أَخْطَأَ عَيْنَ
u'خَطِئَ قِبْلَةٌ':Predicate, #1: 1	أَخْطَأَ عَيْنَ
u'خَطِئَ قِرْطَاسٌ':Predicate, #10: 10	أَخْطَأَ الْقِبْلَةَ
u'خَطِئَ مثل':Predicate, #1: 1	أَخْطَأَ الْقِرْطَاسَ
u'خَطِئَ مِثْلٌ':Predicate, #1: 1	أَخْطَأَ مِثْلَ
u'خَطِئَ مُفَصَّلٌ':Predicate, #1: 1	أَخْطَأَ مِثْلَ
u'خَطِئَ نَصٌّ':Predicate, #1: 1	أَخْطَأَ الْمُفَصّلَ
u'خَطِئَ واحد':Predicate, #2: 2	أَخْطَأَ النَّصَّ
u'خَطِئَ وَاحِدٌ':Predicate, #1: 1	أَخْطَأَ وَاحِدَةَ
u'خَطِئَ وصل':Predicate, #1: 1	أَخْطَأَ وَاحِدَةَ
u'خَطِئَ وَقْتٌ':Predicate, #1: 1	أَخْطَأَ وَصَلَ
u'خَفَاءٌ إِشْكالٌ':Added, #1: 1	أَخْطَأَ الْوَقْتَ
u'خَفَاءٌ حالٌ':Added, #1: 1	خَفَاءَ الْإِشْكَالِ
u'خَفَاءٌ حَقٌّ':Added, #2: 2	خَفَاءِ الْحَالِ
u'خَفَاءٌ خُرُوجٌ':Added, #1: 1	خَفَاءِ الْحَقِّ
u'خَفَاءٌ دَلالَةٌ':Added, #2: 2	خَفَاءِ خُرُوجِهِ
u'خَفَاءٌ دَليلٌ':Added, #2: 2	خَفَاءِ دَلَالَتِهِ
u'خَفَاءٌ سَبَبٌ':Added, #1: 1	خَفَاءِ الدَّلِيلِ
u'خَفَاءٌ شَيْءٌ':Added, #1: 1	خَفَاءِ السَّبَبِ
u'خَفَاءٌ عتق':Added, #1: 1	خَفَاءُ شَيْءٍ
u'خَفَاءٌ عِتْقٌ':Added, #1: 1	خَفَاءِ الْعِتْقِ
u'خَفَاءٌ قَيْدٌ':Added, #1: 1	خَفَاءِ الْعِتْقِ
u'خَفَاءٌ لَفْظٌ':Added, #1: 1	خَفَاءِ قَيْدٍ
u'خَفَاءٌ مَالٌ':Added, #4: 4	خَفَاءِ اللَّفْظِ
u'خَفَاءٌ مراد':Added, #1: 1	خَفَاءِ مَالِهِ
u'خَفَاءٌ مراد':Added, #1: 1	خَفَاءَ الْمُرَادِ
u'خَفَاءٌ مُرَادٌ':Added, #1: 1	خَفَاءِ الْمُرَادِ
u'خَفَاءٌ مُرَادٌ':Added, #1: 1	خَفَاءَ الْمُرَادِ
u'خَفَاءٌ مَكْرٌ':Added, #1: 1	خَفَاءِ الْمُرَادِ
u'خِفٌّ إمَامَةٌ':Added, #1: 1	خَفَاءَ مَكْرِهِ
u'خَفَّ أَمْرٌ':Subject, #1: 1	خِفَّةَ إمَامَةِ
u'خَفَّ أَمْرٌ':Subject, #1: 1	خَفَّ الْأَمْرُ
u'خِفٌّ أَمْرٌ':Added, #1: 1	خَفَّ أَمْرُهُ
u'خِفٌّ أَمْرٌ':Added, #1: 1	خِفَّةِ الْأَمْرِ
u'خَفَّ أهْلٌ':Subject, #1: 1	خِفَّةُ أَمْرِهِ
u'خِفٌّ بدن':Added, #1: 1	خَفَّ أَهْلُهُ
u'خِفٌّ بَدَنٌ':Added, #1: 1	خِفَّةِ الْبَدَنِ
u'خِفٌّ بَدَنٌ':Added, #1: 1	خِفَّةِ الْبَدَنِ
u'خَفَّ بُعْدٌ':Subject, #1: 1	خِفَّةِ بَدَنٍ
u'خِفَّةٌ إمَامَةٌ':Added, #1: 1	خَفَّ بُعْدُهُ
u'خِفَّةٌ أَمْرٌ':Added, #1: 1	خِفَّةَ إمَامَةِ
u'خِفَّةٌ أَمْرٌ':Added, #1: 1	خِفَّةِ الْأَمْرِ
u'خِفَّةٌ بدن':Added, #1: 1	خِفَّةُ أَمْرِهِ
u'خِفَّةٌ بَدَنٌ':Added, #1: 1	خِفَّةِ الْبَدَنِ
u'خِفَّةٌ بَدَنٌ':Added, #1: 1	خِفَّةِ الْبَدَنِ
u'خِفَّةٌ تَعْذِيب':Added, #1: 1	خِفَّةِ بَدَنٍ
u'خِفَّةٌ جِسْمٌ':Added, #1: 1	خِفَّةِ التَّعْذِيبِ
u'خِفَّةٌ حَرَكَةٌ':Added, #1: 1	خِفَّةُ الْجِسْمِ
u'خِفَّةٌ حُرْمَةٌ':Added, #1: 1	خِفَّةَ الْحَرَكَةِ
u'خِفَّةٌ حُكْمٌ':Added, #1: 1	خِفَّةَ الْحُرْمَةِ
u'خِفَّةٌ دَرَاهِمُ':Added, #1: 1	خِفَّةُ الْحُكْمِ
u'خِفَّةٌ رِدَاءٌ':Added, #1: 1	خِفَّةِ الدَّرَاهِمِ
u'خِفَّةٌ رِدَاءٌ':Added, #1: 1	خِفَّةُ الرِّدَاءِ
u'خِفَّةٌ روحٌ':Added, #1: 1	خِفَّةِ الرِّدَاءِ
u'خِفَّةٌ زِيادَةٌ':Added, #1: 1	خِفَّةِ الرُّوحِ
u'خِفَّةٌ شِرَاءٌ':Added, #1: 1	خِفَّةِ زِيَادَةِ
u'خِفَّةٌ عُضْوٌ':Added, #1: 1	خِفَّةَ شِرَاءِ
u'خِفَّةٌ عُقُوبَةٌ':Added, #1: 1	خِفَّةُ الْعُضْوِ
u'خِفَّةٌ كُتُبٌ':Added, #1: 1	خِفَّةُ الْعُقُوبَةِ
u'خِفَّةٌ لِحْيَةٌ':Added, #1: 1	خِفَّةَ كُتُبِ
u'خِفَّةٌ مَرَضٌ':Added, #2: 2	خِفَّةُ لِحْيَتِهِ
u'خِفَّةٌ مَضْغٌ':Added, #1: 1	خِفَّةِ الْمَرَضِ
u'خِفَّةٌ نَجَاسَةٌ':Added, #1: 1	خِفَّةِ الْمَضْغِ
u'خِفَّةٌ نَجَاسَةٌ':Added, #1: 1	خِفَّةَ النَّجَاسَةِ
u'خِفَّةٌ نَظَرٌ':Added, #1: 1	خِفَّةُ النَّجَاسَةِ
u'خِفَّةٌ نَوْمٌ':Added, #1: 1	خِفَّةُ النَّظَرِ
u'خِفَّةٌ هَوْدَجٌ':Added, #1: 1	خِفَّةِ نَوْمِهِ
u'خِفٌّ تَعْذِيب':Added, #1: 1	خِفَّةَ الْهَوْدَجِ
u'خَفَّ جَزَاءٌ':Subject, #1: 1	خِفَّةِ التَّعْذِيبِ
u'خِفٌّ جِسْمٌ':Added, #1: 1	خَفَّ الْجَزَاءُ
u'خِفٌّ حَرَكَةٌ':Added, #1: 1	خِفَّةُ الْجِسْمِ
u'خِفٌّ حُرْمَةٌ':Added, #1: 1	خِفَّةَ الْحَرَكَةِ
u'خَفَّ حُكْمٌ':Subject, #1: 1	خِفَّةَ الْحُرْمَةِ
u'خِفٌّ حُكْمٌ':Added, #3: 3	خَفَّ حُكْمُهُ
u'خَفَّ حَمْلٌ':Subject, #1: 1	خِفَّةُ الْحُكْمِ
u'خِفٌّ دَرَاهِمُ':Added, #1: 1	خَفَّ حَمْلُهُ
u'خِفٌّ رِدَاءٌ':Added, #1: 1	خِفَّةِ الدَّرَاهِمِ
u'خِفٌّ رِدَاءٌ':Added, #1: 1	خِفَّةُ الرِّدَاءِ
u'خِفٌّ روحٌ':Added, #1: 1	خِفَّةِ الرِّدَاءِ
u'خِفٌّ زِيادَةٌ':Added, #1: 1	خِفَّةِ الرُّوحِ
u'خَفَّ شَأْنٌ':Subject, #1: 1	خِفَّةِ زِيَادَةِ
u'خِفٌّ شِرَاءٌ':Added, #1: 1	خَفَّ شَأْنُهُ
u'خَفَّ صَلاَةٌ':Predicate, #1: 1	خِفَّةَ شِرَاءِ
u'خَفَّ صَلاَةٌ':Predicate, #1: 1	أَخَفَّ الصَّلَاةَ
u'خَفَضَ بَعْضٌ':Predicate, #2: 2	أَخَفَّ الصَّلاَةَ
u'خَفَضَ جَازٌ':Predicate, #1: 1	خَفَضَ بَعْضَ
u'خَفَضَ رَسُولٌ':Subject, #1: 1	خَفَضَ جَازَ
u'خِفٌّ عُضْوٌ':Added, #1: 1	خَفَضَ رَسُولُ
u'خِفٌّ عُقُوبَةٌ':Added, #1: 1	خِفَّةُ الْعُضْوِ
u'خَفَّفَ أَمْرٌ':Predicate, #1: 1	خِفَّةُ الْعُقُوبَةِ
u'خَفَّفَ دُعَاءٌ':Predicate, #1: 1	خَفَّفَ أَمْرَ
u'خَفَّفَ شَارِعٌ':Subject, #1: 1	خَفَّفَ الدُّعَاءَ
u'خَفَّفَ شَدَّةٌ':Predicate, #1: 1	خَفَّفَ الشَّارِعُ
u'خَفَّفَ مَالِكٌ':Subject, #1: 1	خَفَّفَ الشَّدَّةَ
u'خَفَقَانٌ قلب':Added, #3: 3	خَفَّفَ مَالِكٌ
u'خَفَقَانٌ قَلْبٌ':Added, #1: 1	خَفَقَانُ الْقَلْبِ
u'خَفَقَانٌ قَلْب':Added, #1: 1	خَفَقَانُ الْقَلْبِ
u'خَفَّ قَدْرٌ':Subject, #1: 1	خَفَقَانُ الْقَلْبِ
u'خِفٌّ كُتُبٌ':Added, #1: 1	خَفَّ قَدْرُهُ
u'خِفٌّ لِحْيَةٌ':Added, #1: 1	خِفَّةَ كُتُبِ
u'خَفَّ مَرَضٌ':Subject, #2: 2	خِفَّةُ لِحْيَتِهِ
u'خِفٌّ مَرَضٌ':Added, #3: 3	خَفَّ مَرَضُهُ
u'خِفٌّ مَضْغٌ':Added, #1: 1	خِفَّةِ الْمَرَضِ
u'خَفَّ مَعْذُورٌ':Subject, #1: 1	خِفَّةِ الْمَضْغِ
u'خَفَّ مَنَامٌ':Subject, #3: 3	خَفَّ مَعْذُورٌ
u'خَفَّ نَاسٌ':Subject, #1: 1	خَفَّ مَنَامُهُ
u'خِفٌّ نَجَاسَةٌ':Added, #1: 1	خَفَّ النَّاسُ
u'خِفٌّ نَجَاسَةٌ':Added, #1: 1	خِفَّةَ النَّجَاسَةِ
u'خِفٌّ نَظَرٌ':Added, #1: 1	خِفَّةُ النَّجَاسَةِ
u'خِفٌّ نَوْمٌ':Added, #1: 1	خِفَّةُ النَّظَرِ
u'خِفٌّ هَوْدَجٌ':Added, #1: 1	خِفَّةِ نَوْمِهِ
u'خَفَى اِبْنٌ':Subject, #1: 1	خِفَّةَ الْهَوْدَجِ
u'خَفِيَ أَمْرٌ':Subject, #1: 1	خَفَى ابْنُ
u'خَفِيَ حِسٌّ':Subject, #1: 1	خَفِيَ أَمْرُهُ
u'خَفِيَ حُكْمٌ':Subject, #1: 1	خَفِيَ حِسُّهُ
u'خَفِيَ رَجُلٌ':Predicate, #1: 1	خَفِيَ حُكْمُ
u'خَفِيَ طُلُوعٌ':Subject, #1: 1	أَخْفَى الرَّجُلَ
u'خَفِيَ علم':Subject, #1: 1	خَفِيَ الطُّلُوعُ
u'خَفِيَ عِلْمٌ':Subject, #1: 1	خَفِيَ عِلْمُهُ
u'خَفِيَ غناء':Predicate, #1: 1	خَفِيَ عِلْمُهُ
u'خَفِيَ غِنَاءٌ':Predicate, #1: 1	أَخْفَى الْغِنَاءَ
u'خَفِيَ فساد':Subject, #1: 1	أَخْفَى الْغِنَاءَ
u'خَفِيَ فَسَادٌ':Subject, #1: 1	خَفِيَ فَسَادُهُ
u'خَفِيَ فِسْقٌ':Subject, #1: 1	خَفِيَ فَسَادُهُ
u'خَفِيَ لَفْظٌ':Subject, #2: 2	خَفِيَ فِسْقُهُ
u'خَفِيَ لَوْنٌ':Subject, #4: 4	خَفِيَ اللَّفْظُ
u'خَفِيَ لَيْلٌ':Predicate, #1: 1	خَفِيَ لَوْنُهُ
u'خَفِيَ مَانِعٌ':Subject, #2: 2	أَخْفَى لَيْلَةَ
u'خَفِيَ مراد':Subject, #2: 2	خَفِيَ الْمَانِعُ
u'خَفِيَ مُرَادٌ':Subject, #1: 1	خَفِيَ الْمُرَادُ
u'خَفِيَ مَوْضِعٌ':Subject, #1: 1	خَفِيَ الْمُرَادُ
u'خَفِيَ نَصٌّ':Subject, #1: 1	خَفِيَ مَوْضِعُ
u'خَفِيَ هِلاَلٌ':Subject, #1: 1	خَفِيَ النَّصُّ
u'خَفِيَ وَجْهٌ':Subject, #1: 1	خَفِيَ الْهِلَالُ
u'خَلَا أَبٌ':Predicate, #1: 1	خَفِيَ وَجْهُ
u'خَلَا اِبْنٌ':Predicate, #1: 1	خَلَا الْأَبَ
u'خَلَا أحَدٌ':Subject, #1: 1	خَلَا ابْنَ
u'خَلَا أرْضٌ':Predicate, #1: 1	خَلَا أَحَدُ
u'خَلَا إِزَارٌ':Predicate, #1: 1	خَلَا أَرْضَ
u'خَلَا أَشْهَب':Predicate, #1: 1	خَلَا الْإِزَارَ
u'خَلَا أَصْحَابٌ':Predicate, #1: 1	خَلَا أَشْهَبَ
u'خَلَا إمَامٌ':Predicate, #1: 1	خَلَا أَصْحَابَ
u'خَلَا أَنْفٌ':Predicate, #1: 1	خَلَا الْإِمَامَ
u'خَلَا أَوَّلُ':Subject, #1: 1	خَلَا الْأَنْفَ
u'خَلَا أيَّامٌ':Predicate, #1: 1	خَلَا أَوَّلُ
u'خَلَا أَيَّامٌ':Predicate, #1: 1	خَلَا الْأَيَّامَ
u'خَلَا بصرة':Predicate, #1: 1	خَلَا الْأَيَّامَ
u'خَلَا بَلَدٌ':Subject, #1: 1	خَلَا الْبَصْرَةَ
u'خَلَا بَلَدٌ':Subject, #2: 2	خَلَا الْبَلَدُ
u'خَلَا بَلَدٌ':Subject, #2: 2	خَلَا بَلَدٌ
u'خَلَا بَيْتٌ':Subject, #2: 2	خَلَا بَلَدُهُ
u'خَلَا بَيْتٌ':Subject, #1: 1	خَلَا الْبَيْتُ
u'خَلَا تَخْصِيصٌ':Subject, #1: 1	خَلَا بَيْتُهُ
u'خَلَا تُرَابٌ':Predicate, #1: 1	خَلَا التَّخْصِيصُ
u'خَلَا تَكْبِير':Predicate, #1: 1	خَلَا التُّرَابَ
u'خَلَا تَوْكِيلٌ':Subject, #3: 3	خَلَا تَكْبِيرَةَ
u'خَلَا جَبْهَةٌ':Predicate, #1: 1	خَلَا تَوْكِيلُهُ
u'خَلَا حُدودٌ':Predicate, #1: 1	خَلَا الْجَبْهَةَ
u'خَلَا خَشَبٌ':Predicate, #1: 1	خَلَا الْحُدُودَ
u'خَلَا خَمْرٌ':Predicate, #1: 1	خَلَا الْخَشَبَ
u'خَلَا دَجاج':Predicate, #2: 2	خَلَا الْخَمْرَ
u'خَلَا دَمٌ':Predicate, #2: 2	خَلَا الدَّجَاجَةَ
u'خَلَا دونٌ':Predicate, #1: 1	خَلَا الدَّمَ
u'خَلَا دَيْنٌ':Predicate, #1: 1	خَلَا دُونَ
u'خَلَا دَيْنٌ':Predicate, #1: 1	خَلَا الدَّيْنَ
u'خَلَا ذكر':Subject, #1: 1	خَلَا دَيْنَ
u'خَلَا ذِكْرٌ':Subject, #1: 1	خَلَا ذِكْرُ
u'خَلَا رَجُلٌ':Subject, #1: 1	خَلَا ذِكْرُ
u'خَلَا رَجُلٌ':Subject, #1: 1	خَلَا الرَّجُلُ
u'خَلَا رَجْمٌ':Predicate, #4: 4	خَلَا رَجُلٌ
u'خَلَا رَقيقٌ':Predicate, #1: 1	خَلَا الرَّجْمَ
u'خَلَا رَقيق':Predicate, #1: 1	خَلَا الرَّقِيقَ
u'خَلَا رِوايَةٌ':Predicate, #1: 1	خَلَا الرَّقِيقَ
u'خَلَا زَمانٌ':Subject, #1: 1	خَلَا رِوَايَةَ
u'خَلَا زَمانٌ':Subject, #1: 1	خَلَا الزَّمَانُ
u'خَلَا زَوْجٌ':Subject, #2: 2	خَلَا زَمَانٌ
u'خَلَا زَوْجَةٌ':Predicate, #2: 2	خَلَا الزَّوْجُ
u'خَلَا سَبَبٌ':Subject, #1: 1	خَلَا الزَّوْجَةَ
u'خَلَا سُنْبُلٌ':Subject, #2: 2	خَلَا السَّبَبُ
u'خَلَا سُورَةٌ':Predicate, #1: 1	خَلَا السُّنْبُلُ
u'خَلَا شَرْطٌ':Subject, #1: 1	خَلَا سُورَةَ
u'خَلَا شَرْعٌ':Subject, #1: 1	خَلَا الشَّرْطُ
u'خَلَا شِرْكٌ':Predicate, #1: 1	خَلَا شَرْعٌ
u'خَلَا شَكٌّ':Predicate, #3: 3	خَلَا الشِّرْكَ
u'خَلَا صَيْدَلانِيّ':Predicate, #1: 1	خَلَا الشَّكَّ
u'خَلَا طعام':Predicate, #1: 1	خَلَا الصَّيْدَلَانِيَّ
u'خَلَا طَعَامٌ':Predicate, #2: 2	خَلَا الطَّعَامَ
u'خَلَا طَلاَقٌ':Predicate, #2: 2	خَلَا الطَّعَامَ
u'خَلَا طَلاَقٌ':Subject, #2: 2	خَلَا الطَّلَاقَ
u'خَلَا ظُفْرٌ':Predicate, #2: 2	خَلَا الطَّلَاقُ
u'خَلَا ظُفْرٌ':Subject, #1: 1	خَلَا الظُّفْرَ
u'خَلَا عرفة':Predicate, #1: 1	خَلَا الظُّفْرُ
u'خَلَا عَصْرٌ':Subject, #1: 1	خَلَا عَرَفَةَ
u'خَلَا عَصْرٌ':Subject, #1: 1	خَلَا عَصْرٌ
u'خَلَا عَقَارٌ':Predicate, #2: 2	خَلَا الْعَصْرُ
u'خَلَا عَقْدٌ':Subject, #1: 1	خَلَا الْعَقَارَ
u'خَلَا عُمَرٌ':Subject, #2: 2	خَلَا الْعَقْدُ
u'خَلَا عِوَضٌ':Subject, #1: 1	خَلَا عُمَرُ
u'خَلَا غَائِبٌ':Predicate, #1: 1	خَلَا الْعِوَضُ
u'خِلاَفٌ اِبْنٌ':Added, #1: 1	خَلَا الْغَائِبَ
u'خِلاَفَةٌ عَبْدٌ':Added, #1: 1	خِلاَفِ ابْنِ
u'خَلَا فَجْرٌ':Predicate, #2: 2	خِلاَفَةِ عَبْدِ
u'خِلاَفٌ حِكَايَةٌ':Added, #1: 1	خَلَا الْفَجْرَ
u'خِلاَفٌ حَلالٌ':Added, #1: 1	خِلاَفُ حِكَايَتِهِ
u'خَلَا فَرْجٌ':Predicate, #1: 1	خِلاَفُ الْحَلاَلِ
u'خِلاَفٌ رَسُولٌ':Added, #1: 1	خَلَا الْفَرْجَ
u'خِلاَفٌ رِوايَةٌ':Added, #2: 2	خِلاَفَ رَسُولِ
u'خِلاَفٌ رِوايَةٌ':Added, #1: 1	خِلاَفَ رِوَايَةِ
u'خَلَا فَسْخٌ':Subject, #3: 3	خِلاَفُ رِوَايَةِ
u'خِلاَفٌ سَرِيٌّ':Added, #1: 1	خَلَا الْفَسْخُ
u'خِلاَفٌ سَرِيَّةٌ':Added, #2: 2	خِلاَفَ سَرِيَّةٍ
u'خِلاَفٌ سُنَّةٌ':Added, #2: 2	خِلاَفَ سَرِيَّةٍ
u'خِلاَفٌ سُنَّةٌ':Added, #1: 1	خِلاَفُ السُّنَّةِ
u'خِلاَفٌ سُنَّةٌ':Added, #1: 1	خِلاَفِ السُّنَّةِ
u'خِلاَفٌ صَلاَةٌ':Added, #1: 1	خِلاَفَ سُنَّةِ
u'خِلاَفٌ عَاصِمٌ':Added, #1: 1	خِلاَفَ صَلاَةِ
u'خَلَا فِعْلٌ':Subject, #1: 1	خِلاَفَ عَاصِمٍ
u'خِلاَفٌ قُرْآنٌ':Added, #1: 1	خَلَا الْفِعْلُ
u'خِلاَفٌ قول':Added, #1: 1	خِلاَفُ الْقُرْآنِ
u'خِلاَفٌ قَوْلٌ':Added, #1: 1	خِلاَفِ قَوْلِ
u'خِلاَفٌ كِتَابٌ':Added, #1: 1	خِلاَفِ قَوْلِ
u'خَلَا فلان':Predicate, #1: 1	خِلاَفُ كِتَابِ
u'خِلاَفٌ مَاءٌ':Added, #1: 1	خَلَا مَكَّةَ
u'خِلاَفٌ مَلِكٌ':Added, #1: 1	خِلاَفَ الْمَاءِ
u'خَلَا قِرَاءةٌ':Predicate, #1: 1	خِلاَفِ مَلِكِ
u'خَلَا قُرْآنٌ':Predicate, #1: 1	خَلَا قِرَاءَةَ
u'خَلَا قيام':Predicate, #1: 1	خَلَا الْقُرْآنَ
u'خَلَا قِيَامٌ':Predicate, #2: 2	خَلَا قِيَامَ
u'خَلَا كَافِرٌ':Subject, #2: 2	خَلَا قِيَامَ
u'خِلاَلٌ جَاهِلِيٌّ':Added, #1: 1	خَلَا كَافِرٌ
u'خِلاَلٌ جَاهِلِيَّةٌ':Added, #2: 2	خِلاَلِ الْجَاهِلِيَّةِ
u'خِلاَلٌ شَجَرٌ':Added, #2: 2	خِلاَلِ الْجَاهِلِيَّةِ
u'خِلاَلٌ شَهْرٌ':Added, #1: 1	خِلاَلِ الشَّجَرِ
u'خِلاَلٌ صَلاَةٌ':Added, #1: 1	خِلاَلِ شَهْرِ
u'خِلاَلٌ صَوْمٌ':Added, #1: 1	خِلاَلِ صَلاَةٍ
u'خَلَا لَفْظٌ':Subject, #1: 1	خِلاَلَ الصَّوْمِ
u'خِلاَلٌ كَلاَمٌ':Added, #1: 1	خَلَا اللَّفْظُ
u'خِلاَلٌ لبن':Added, #1: 1	خِلاَلَ كَلاَمِهِ
u'خِلاَلٌ لَبِنٌ':Added, #1: 1	خِلاَلَ اللَّبِنِ
u'خِلاَلٌ مَسْأَلَةٌ':Added, #1: 1	خِلاَلَ اللَّبِنِ
u'خَلَا مَاشِي':Predicate, #1: 1	خِلاَلَ مَسْأَلَةِ
u'خَلَا مَاشِيَةٌ':Predicate, #1: 1	خَلَا الْمَاشِيَةَ
u'خَلَا مَالٌ':Subject, #1: 1	خَلَا الْمَاشِيَةَ
u'خَلَّ إمَامٌ':Subject, #1: 1	خَلَا الْمَالُ
u'خَلَا مَدْحٌ':Subject, #1: 1	أَخَلَّ الْإِمَامُ
u'خَلَا مَسْأَلَةٌ':Predicate, #1: 1	خَلَا مَدْحُهُ
u'خَلَا مَسْجِدٌ':Subject, #1: 1	خَلَا الْمَسْأَلَةَ
u'خَلَا مُسْلِمٌ':Predicate, #1: 1	خَلَا الْمَسْجِدُ
u'خَلَا مَكَانٌ':Subject, #1: 1	خَلَا الْمُسْلِمِينَ
u'خَلَا مَكَانٌ':Subject, #1: 1	خَلَا مَكَانُ
u'خَلَا مَوَاضِعُ':Predicate, #2: 2	خَلَا الْمَكَانُ
u'خَلَا نصاب':Subject, #1: 1	خَلَا مَوَاضِعَ
u'خَلَا نِصَابٌ':Subject, #1: 1	خَلَا النِّصَابُ
u'خَلَا نكاح':Predicate, #1: 1	خَلَا النِّصَابُ
u'خَلَا نِكَاحٌ':Predicate, #1: 1	خَلَا النِّكَاحَ
u'خَلَا وَجْهٌ':Predicate, #1: 1	خَلَا النِّكَاحَ
u'خَلَا وَطْءٌ':Predicate, #2: 2	خَلَا الْوَجْهَ
u'خَلَا ولد':Predicate, #1: 1	خَلَا الْوَطْءَ
u'خَلَا وَلَدٌ':Predicate, #1: 1	خَلَا الْوَلَدَ
u'خَلَا ولد':Predicate, #1: 1	خَلَا الْوَلَدَ
u'خَلَا وَلَدٌ':Predicate, #1: 1	خَلَا وَلَدَ
u'خَلَا يَوْمٌ':Predicate, #1: 1	خَلَا وَلَدَ
u'خَلَا يَوْمٌ':Subject, #1: 1	خَلَا الْيَوْمَ
u'خَلَدَ مُلُوكٌ':Subject, #1: 1	خَلَا الْيَوْمُ
u'خَلَصَ إِكْسَابٌ':Subject, #1: 1	خَلَدَ الْمُلُوكُ
u'خَلَصَ أَمْرٌ':Subject, #1: 1	خَلَصَ إكْسَابُهُ
u'خَلِصَ إيمَانٌ':Predicate, #1: 1	خَلَصَ الأَمْرُ
u'خَلَصَ بَعْضٌ':Subject, #1: 1	أَخْلَصَ الْإِيمَانَ
u'خَلَّصَ عَبْدٌ':Predicate, #1: 1	خَلَصَ بَعْضُهُ
u'خَلَصَ عَمَلٌ':Subject, #1: 1	خَلَّصَ عَبْدَ
u'خَلَصَ عين':Subject, #1: 1	خَلَصَ الْعَمَلُ
u'خَلَصَ عَيْنٌ':Subject, #1: 1	خَلَصَ الْعَيْنُ
u'خَلَصَ عَيْن':Subject, #1: 1	خَلَصَ الْعَيْنُ
u'خَلَصَ لَفْظٌ':Subject, #1: 1	خَلَصَ الْعَيْنُ
u'خَلَصَ لَوْنٌ':Subject, #1: 1	خَلَصَ لَفْظُهُ
u'خَلَصَ مَالٌ':Subject, #1: 1	خَلَصَ اللَّوْنُ
u'خَلَطَ أَثْمانٌ':Predicate, #1: 1	خَلَصَ الْمَالُ
u'خَلَطَ أحَدٌ':Predicate, #1: 1	خَلَطَ أَثْمَانَ
u'خَلَطَ أَغْنَامٌ':Predicate, #6: 6	خَلَطَ أَحَدَ
u'خَلَطَ بَابٌ':Predicate, #2: 2	خَلَطَ الْأَغْنَامَ
u'خَلَطَ بَائِعٌ':Subject, #1: 1	خَلَطَ الْبَابَ
u'خَلَطَ بَعْضٌ':Predicate, #1: 1	خَلَطَ الْبَائِعُ
u'خَلَطَ حِنْطَةٌ':Predicate, #1: 1	خَلَطَ الْبَعْضَ
u'خَلَطَ حِنْطَةٌ':Predicate, #1: 1	خَلَطَ الْحِنْطَةَ
u'خَلَطَ خَمْرٌ':Predicate, #1: 1	خَلَطَ حِنْطَةَ
u'خَلَطَ دَرَاهِمُ':Predicate, #2: 2	خَلَطَ الْخَمْرَ
u'خَلَطَ دَرَاهِمُ':Predicate, #1: 1	خَلَطَ دَرَاهِمَ
u'خَلَطَ دَقيقٌ':Predicate, #3: 3	خَلَطَ الدَّرَاهِمَ
u'خَلَطَ ذُنُوبٌ':Predicate, #1: 1	خَلَطَ الدَّقِيقَ
u'خَلَطَ زَيْتٌ':Predicate, #1: 1	خَلَطَ الذُّنُوبَ
u'خَلَطَ صبرة':Predicate, #2: 2	خَلَطَ الزَّيْتَ
u'خَلَطَ صُبْرَةٌ':Predicate, #1: 1	خَلَطَ صُبْرَةَ
u'خَلَطَ صبرة':Predicate, #1: 1	خَلَطَ صُبْرَةَ
u'خَلَطَ صُبْرَةٌ':Predicate, #2: 2	خَلَطَ الصُّبْرَةَ
u'خَلَطَ طعام':Predicate, #2: 2	خَلَطَ الصُّبْرَةَ
u'خَلَطَ طَعَامٌ':Predicate, #2: 2	خَلَطَ الطَّعَامَ
u'خَلَطَ طِيبٌ':Predicate, #2: 2	خَلَطَ الطَّعَامَ
u'خَلَطَ عَامِلٌ':Subject, #1: 1	خَلَطَ الطِّيبَ
u'خَلَطَ غَاصِبٌ':Subject, #1: 1	خَلَطَ الْعَامِلُ
u'خَلَطَ لبن':Predicate, #2: 2	خَلَطَ الْغَاصِبُ
u'خَلَطَ لَبَنٌ':Predicate, #2: 2	خَلَطَ لَبَنَ
u'خَلَطَ لبن':Predicate, #2: 2	خَلَطَ لَبَنَ
u'خَلَطَ لَبَنٌ':Predicate, #3: 3	خَلَطَ اللَّبَنَ
u'خَلَطَ مَالٌ':Predicate, #3: 3	خَلَطَ اللَّبَنَ
u'خَلَطَ مَالٌ':Predicate, #2: 2	خَلَطَ الْمَالَ
u'خَلَطَ مَائِعٌ':Predicate, #8: 8	خَلَطَ مَالَ
u'خَلَطَ مَبِيعٌ':Predicate, #3: 3	خَلَطَ الْمَائِعَ
u'خَلَطَ مُضَارِبٌ':Subject, #1: 1	خَلَطَ الْمَبِيعَ
u'خَلَطَ مَغْصُوب':Predicate, #1: 1	خَلَطَ الْمُضَارِبُ
u'خَلَطَ مَكْتُوبٌ':Predicate, #6: 6	خَلَطَ الْمَغْصُوبَ
u'خَلَطَ نَفَلٌ':Predicate, #2: 2	خَلَطَ الْمَكْتُوبَةَ
u'خَلَطَ وَدِيعٌ':Predicate, #3: 3	خَلَطَ النَّفَلَ
u'خَلَطَ وَدِيعٌ':Predicate, #1: 1	خَلَطَ وَدِيعَةَ
u'خَلَطَ وَدِيعَةٌ':Predicate, #4: 4	خَلَطَ الْوَدِيعَةَ
u'خَلَطَ وَدِيعَةٌ':Predicate, #1: 1	خَلَطَ وَدِيعَةَ
u'خَلَطَ وَصِيٌّ':Subject, #4: 4	خَلَطَ الْوَدِيعَةَ
u'خَلْعٌ أَجْنَبِيٌّ':Added, #1: 1	خَلَطَ الْوَصِيُّ
u'خَلَعَ أحَدٌ':Predicate, #1: 1	خَلْعِ الْأَجْنَبِيِّ
u'خَلَعَ أَسيرٌ':Subject, #1: 1	خَلَعَ أَحَدَ
u'خَلْعٌ إمَامٌ':Added, #1: 1	خَلَعَ الْأَسِيرُ
u'خَلْعٌ إمَامٌ':Added, #1: 1	خَلْعُ الْإِمَامِ
u'خَلَعَ أمَةٌ':Predicate, #1: 1	خَلْعِ الْإِمَامِ
u'خَلَعَ أهْلٌ':Subject, #2: 2	خَلَعَ الْأَمَةَ
u'خَلَعَ أَوَّلُ':Subject, #3: 3	خَلَعَ أَهْلُ
u'خَلْعٌ أَوَّلُ':Added, #1: 1	خَلَعَ الْأَوَّلُ
u'خَلْعٌ أَوَّلُ':Added, #1: 1	خَلْعُ الْأَوَّلِ
u'خَلْعٌ بَيْضَةٌ':Added, #1: 1	خَلْعِ الْأَوَّلِ
u'خَلْعٌ ثَوْبٌ':Added, #2: 2	خَلْعِ الْبَيْضَةِ
u'خَلْعٌ جِلْبَابٌ':Added, #1: 1	خَلْعُ ثَوْبِهِ
u'خَلْعٌ حَسَنٌ':Added, #1: 1	خَلْعِ جِلْبَابِ
u'خَلَعَ خُفٌّ':Predicate, #1: 1	خَلْعُ الْحَسَنِ
u'خَلْعٌ خُفٌّ':Added, #1: 1	خَلَعَ الْخُفَّ
u'خَلْعٌ خُفٌّ':Added, #1: 1	خَلْعِ الْخُفِّ
u'خَلَعَ خَلِيفَةٌ':Subject, #1: 1	خَلْعِ الْخُفَّيْنِ
u'خَلَعَ رِبْقٌ':Predicate, #1: 1	خَلَعَ الْخَلِيفَةُ
u'خَلَعَ رِبْقٌ':Predicate, #16: 16	خَلَعَ رِبْقَةَ
u'خَلَعَ رِبْقٌ':Predicate, #1: 1	خَلَعَ رِبْقَ
u'خَلَعَ رَجُلٌ':Subject, #2: 2	خَلَعَ الرِّبْقَةَ
u'خَلَعَ زَوْجٌ':Subject, #3: 3	خَلَعَ الرَّجُلُ
u'خَلْعٌ زَوْجَةٌ':Added, #1: 1	خَلَعَ الزَّوْجُ
u'خَلَعَ سَرَاوِيلُ':Predicate, #1: 1	خَلْعِ الزَّوْجَةِ
u'خَلْعٌ سَرَاوِيلُ':Added, #1: 1	خَلَعَ السَّرَاوِيلَ
u'خَلَعَ صَغِيرٌ':Predicate, #2: 2	خَلْعِ السَّرَاوِيلِ
u'خَلَعَ صَغِيرٌ':Predicate, #1: 1	خَلَعَ صَغِيرَةً
u'خَلَعَ عَادٌ':Predicate, #2: 2	خَلَعَ الصَّغِيرَةَ
u'خَلَعَ عَبْدٌ':Subject, #1: 1	خَلَعَ عَادَ
u'خَلْعٌ غير':Added, #2: 2	خَلَعَ الْعَبْدُ
u'خَلْعٌ غَيْرٌ':Added, #1: 1	خَلْعِ غَيْرِ
u'خَلْعٌ لِبَاسٌ':Added, #1: 1	خَلْعِ غَيْرِ
u'خَلْعٌ مَرِيضٌ':Added, #1: 1	خَلْعِ اللِّبَاسِ
u'خَلْعٌ نِعَالٌ':Added, #1: 1	خَلْعُ الْمَرِيضَةِ
u'خَلَعَ نَعْلٌ':Predicate, #2: 2	خَلْعِ النِّعَالِ
u'خَلْعٌ نَعْلٌ':Added, #1: 1	خَلَعَ النَّعْلَ
u'خَلْعٌ نَعْلٌ':Added, #1: 1	خَلْعِ النَّعْلِ
u'خَلْعٌ نَعْلٌ':Added, #1: 1	خَلْعُ النَّعْلَيْنِ
u'خَلْعٌ نَعْلٌ':Added, #2: 2	خَلْعَ النَّعْلَيْنِ
u'خَلْعٌ نَعْلٌ':Added, #3: 3	خَلْعِ النَّعْلَيْنِ
u'خَلْعٌ نَفْسٌ':Added, #4: 4	خَلْعُ النَّعْلِ
u'خَلْعٌ نَفْسٌ':Added, #1: 1	خَلْعُ النَّفْسِ
u'خَلَّفَ أَبٌ':Subject, #1: 1	خَلْعُ نَفْسِهِ
u'خَلْفٌ إِبِلٌ':Added, #2: 2	خَلَّفَ الْأَبُ
u'خَلْفٌ اِبْنٌ':Added, #2: 2	خَلْفَ الْإِبِلِ
u'خَلَفٌ أَبْنَاءٌ':Added, #12: 12	خَلْفَ ابْنِ
u'خَلَّفَ اِبْنَة':Predicate, #1: 1	خَلَفُ الْأَبْنَاءِ
u'خَلَفَ أبْنيَةٌ':Predicate, #1: 1	خَلَّفَ ابْنَةَ
u'خَلَّفَ أحَدٌ':Subject, #1: 1	خَلَفَ الْأَبْنِيَةَ
u'خَلَّفَ أحَدٌ':Subject, #1: 1	خَلَّفَ أَحَدٌ
u'خَلْفٌ أحَدٌ':Added, #1: 1	خَلَّفَ أَحَدُ
u'خَلَفٌ أحْمَر':Added, #5: 5	خَلْفَ أَحَدٍ
u'خَلْفٌ أَدَاءٌ':Added, #1: 1	خَلَفُ الْأَحْمَرِ
u'خَلَّفَ أَرْبَعَةٌ':Predicate, #4: 4	خَلْفَ الْأَدَاءِ
u'خَلْفٌ أصل':Added, #1: 1	خَلَّفَ أَرْبَعَةَ
u'خَلْفٌ أًصْلٌ':Added, #1: 1	خَلْفَ الْأَصْلِ
u'خَلَّفَ أَصيلٌ':Subject, #1: 1	خَلْفَ الْأَصْلِ
u'خَلَّفَ أَكْثَرُ':Predicate, #2: 2	خَلَّفَ الْأَصِيلُ
u'خَلْفٌ الْمَرْأَةُ':Added, #1: 1	خَلَّفَ أَكْثَرَ
u'خَلْفٌ إمَامٌ':Added, #1: 1	خَلْفَ الْمَرْأَةِ
u'خَلْفٌ إمَامٌ':Added, #133: 133	خَلْفَ الْإِمَامِ
u'خَلَفٌ إمَامٌ':Added, #18: 18	خَلْفَ إمَامٍ
u'خَلَفٌ إمَامٌ':Added, #1: 1	خَلَفَ الْإِمَامِ
u'خَلْفٌ إمَامٌ':Added, #1: 1	خَلَفَ إِمَامٍ
u'خَلْفٌ إمَامٌ':Added, #1: 1	خَلْفَ إمَامَيْنِ
u'خَلْفٌ إمَامٌ':Added, #3: 3	خَلْفَ إِمَامٍ
u'خَلْفٌ إمَامٌ':Added, #49: 49	خَلْفَ الإِمَامِ
u'خَلْفٌ إمَامٌ':Added, #4: 4	خَلْفَ إمَامِ
u'خَلْفٌ إمَامٌ':Added, #4: 4	خَلْفَ إمَامِهِ
u'خَلْفٌ اِمْرَأَةٌ':Added, #5: 5	خَلْفِ الْإِمَامِ
u'خَلْفٌ أُمِّيٌّ':Added, #3: 3	خَلْفَ امْرَأَةٍ
u'خَلْفٌ أُمِّيٌّ':Added, #2: 2	خَلْفَ أُمِّيٍّ
u'خَلَفٌ أهْلٌ':Added, #5: 5	خَلْفَ الْأُمِّيِّ
u'خَلْفٌ أهْلٌ':Added, #1: 1	خَلَفَ أَهْلِ
u'خَلْفٌ أَوَّلُ':Added, #1: 1	خَلْفَ أَهْلِ
u'خَلَفٌ أئِمَّةٌ':Added, #1: 1	خَلْفَ الْأَوَّلِ
u'خَلْفٌ أئِمَّةٌ':Added, #1: 1	خَلَفَ الْأَئِمَّةِ
u'خَلْفٌ أئِمَّةٌ':Added, #1: 1	خَلْفَ الْأَئِمَّةِ
u'خَلْفٌ بَابٌ':Added, #1: 1	خَلْفَ أَئِمَّةِ
u'خَلْفٌ بَحْرٌ':Added, #1: 1	خَلْفَ الْبَابِ
u'خَلَّفَ بَصَرٌ':Subject, #1: 1	خَلْفِ الْبَحْرِ
u'خَلْفٌ بَعْضٌ':Added, #1: 1	خَلَّفَ بَصَرُهُ
u'خَلَفَ بِنَاءٌ':Predicate, #3: 3	خَلْفَ بَعْضٍ
u'خَلْفٌ تارِك':Added, #1: 1	خَلَفَ الْبِنَاءَ
u'خَلْفٌ تارِك':Added, #1: 1	خَلْفَ تَارِكٍ
u'خَلَفَ تَبْعِيض':Predicate, #1: 1	خَلْفَ تَارِكِ
u'خَلْفٌ تَرَاوِيحُ':Added, #1: 1	خَلَفَ التَّبْعِيضَ
u'خَلْفٌ تَقِيٌّ':Added, #3: 3	خَلْفَ التَّرَاوِيحِ
u'خَلَّفَ ثَلاثُ':Predicate, #3: 3	خَلْفَ تَقِيٍّ
u'خَلَفَ ثَلاثَةٌ':Predicate, #1: 1	خَلَّفَ ثَلَاثَ
u'خَلَّفَ ثَلاثَةٌ':Predicate, #1: 1	خَلَفَ ثَلَاثَةَ
u'خَلْفٌ ثَمانِيَةٌ':Added, #1: 1	خَلَّفَ ثَلَاثَةَ
u'خَلَفَ ثَنِيَّةٌ':Predicate, #1: 1	خَلْفَ ثَمَانِيَةٍ
u'خَلَّفَ ثَنِيَّةٌ':Predicate, #1: 1	خَلَفَ ثَنِيَّةَ
u'خَلْفٌ ثَوْبٌ':Added, #2: 2	خَلَّفَ ثَنِيَّةَ
u'خَلْفٌ جِبَالٌ':Added, #1: 1	خَلْفِ الثَّوْبِ
u'خَلْفٌ جَبَلٌ':Added, #1: 1	خَلْفَ الْجِبَالِ
u'خَلْفٌ جَبَلٌ':Added, #1: 1	خَلْفَ جَبَلٍ
u'خَلْفٌ جِدار':Added, #1: 1	خَلْفِ جَبَلٍ
u'خَلْفٌ جمعة':Added, #1: 1	خَلْفَ جِدَارٍ
u'خَلْفٌ جُمُعَةٌ':Added, #1: 1	خَلْفَ الْجُمُعَةِ
u'خَلْفٌ جَمِيع':Added, #1: 1	خَلْفَ الْجُمُعَةِ
u'خَلْفٌ جَنَازَةٌ':Added, #3: 3	خَلْفَ الْجَمِيعِ
u'خَلْفٌ جَنَائِزُ':Added, #4: 4	خَلْفَ الْجَنَازَةِ
u'خَلْفٌ حائِطٌ':Added, #1: 1	خَلْفَ الْجَنَائِزِ
u'خَلْفٌ حائِطٌ':Added, #1: 1	خَلْفَ الْحَائِطِ
u'خَلْفٌ حائِطٌ':Added, #1: 1	خَلْفِ الْحَائِطِ
u'خَلْفٌ حجاب':Added, #1: 1	خَلْفَ حَائِطٍ
u'خَلْفٌ حِجابٌ':Added, #1: 1	خَلْفَ الْحِجَابِ
u'خَلْفٌ حُجْرَةٌ':Added, #1: 1	خَلْفَ الْحِجَابِ
u'خَلَّفَ حُرٌّ':Subject, #2: 2	خَلْفَ الْحُجْرَةِ
u'خَلْفٌ حَقِيبَةٌ':Added, #1: 1	خَلَّفَ حُرٌّ
u'خَلْفٌ حَلْقَةٌ':Added, #1: 1	خَلْفَ الْحَقِيبَةِ
u'خَلْفٌ حَمَّادٌ':Added, #2: 2	خَلْفَ الْحَلْقَةِ
u'خَلْفٌ حِمَارٌ':Added, #1: 1	خَلْفَ حَمَّادِ
u'خَلَفَ خَارِجٌ':Predicate, #1: 1	خَلْفَ الْحِمَارِ
u'خَلْفٌ خَطِيبٌ':Added, #4: 4	خَلَفَ الْخَارِجَ
u'خَلَفَ خُلُوفٌ':Subject, #1: 1	خَلْفَ خَطِيبِ
u'خَلْفٌ خَلِيفَةٌ':Added, #1: 1	خَلَفَ الْخُلُوفُ
u'خَلَّفَ خَمْسَةٌ':Predicate, #1: 1	خَلْفَ خَلِيفَتِهِ
u'خَلَفَ خَيَّامٌ':Predicate, #1: 1	خَلَّفَ خَمْسَةَ
u'خَلْفٌ دَارٌ':Added, #1: 1	خَلَفَ الْخَيَّامَ
u'خَلْفٌ دَوَابُّ':Added, #1: 1	خَلْفَ الدَّارِ
u'خَلِفَ دونٌ':Predicate, #1: 1	خَلْفَ الدَّوَابِّ
u'خَلَّفَ دونٌ':Predicate, #1: 1	أَخْلَفَ دُونَ
u'خَلَّفَ دِيَةٌ':Predicate, #1: 1	خَلَّفَ دُونَ
u'خَلَفٌ دِينارٌ':Added, #1: 1	خَلَّفَ دِيَةَ
u'خَلْفٌ رَاكِبٌ':Added, #1: 1	خَلَفَ دِينَارَيْنِ
u'خَلْفٌ رايَة':Added, #3: 3	خَلْفَ الرَّاكِبِ
u'خَلْفٌ رُبَاعِيُّ':Added, #1: 1	خَلْفَ رَايَةِ
u'خَلْفٌ رِجَالٌ':Added, #1: 1	خَلْفَ رُبَاعِيَّةٍ
u'خَلْفٌ رِجَالٌ':Added, #1: 1	خَلْفَ الرّجَالِ
u'خَلْفٌ رَجُلٌ':Added, #4: 4	خَلْفَ الرِّجَالِ
u'خَلْفٌ رَجُلٌ':Added, #1: 1	خَلْفِ الرّجُلِ
u'خَلْفٌ رَجُلٌ':Added, #4: 4	خَلْفَ رَجُلٍ
u'خَلَفَ رَسُولٌ':Predicate, #7: 7	خَلْفَ الرَّجُلِ
u'خَلَفَ رَسُولٌ':Subject, #2: 2	خَلَفَ رَسُولَ
u'خَلَّفَ رَسُولٌ':Subject, #1: 1	خَلَفَ رَسُولُ
u'خَلْفٌ رَسُولٌ':Added, #1: 1	خَلَّفَ رَسُولُ
u'خَلْفٌ رَسُولٌ':Added, #2: 2	خَلْفَ الرَّسُولِ
u'خَلْفٌ زَيْدٌ':Added, #66: 66	خَلْفَ رَسُولِ
u'خَلْفٌ زَيْدٌ':Added, #1: 1	خَلْف زَيْدٍ
u'خَلْفٌ سَارِي':Added, #5: 5	خَلْفَ زَيْدٍ
u'خَلْفٌ سَائِرٌ':Added, #1: 1	خَلْفَ سَارِيَةٍ
u'خَلْفٌ سَائِقٌ':Added, #1: 1	خَلْفَ سَائِرِ
u'خَلَّفَ سَبْعٌ':Predicate, #1: 1	خَلْفَ السَّائِقِ
u'خَلْفٌ سِتْرٌ':Added, #1: 1	خَلَّفَ سَبْعَ
u'خَلْفٌ سِتْرٌ':Added, #1: 1	خَلْفَ سِتْرٍ
u'خَلْفٌ سَدٌّ':Added, #2: 2	خَلْفِ سِتْرٍ
u'خَلْفٌ سَرِيٌّ':Added, #1: 1	خَلْفِ سَدٍّ
u'خَلْفٌ سَرِيَّةٌ':Added, #2: 2	خَلْفَ سَرِيَّةٍ
u'خَلَفَ سلام':Subject, #2: 2	خَلْفَ سَرِيَّةٍ
u'خَلَفَ سِلامٌ':Subject, #1: 1	خَلَفَ السّلَامُ
u'خَلَفَ سَلاَمٌ':Subject, #1: 1	خَلَفَ السّلَامُ
u'خَلْفٌ سُوقٌ':Added, #1: 1	خَلَفَ السّلَامُ
u'خَلْفٌ شَاخِصٌ':Added, #1: 1	خَلْفَ سُوقِ
u'خَلْفٌ شَارِبٌ':Added, #1: 1	خَلْفَ شَاخِصٍ
u'خَلْفٌ شافِع':Added, #2: 2	خَلْفَ شَارِبِ
u'خَلْفٌ شافِعِيّ':Added, #2: 2	خَلْفَ الشَّافِعِيَّةِ
u'خَلْفٌ شافِعِيّ':Added, #1: 1	خَلْفَ الشَّافِعِيِّ
u'خَلْفٌ شَجَرَةٌ':Added, #2: 2	خَلْفَ الشَّافِعِيَّةِ
u'خَلْفٌ شَخْصٌ':Added, #1: 1	خَلْفَ شَجَرَةٍ
u'خَلِفَ شَرْطٌ':Predicate, #1: 1	خَلْفَ شَخْصٍ
u'خَلَفَ شَرْطٌ':Subject, #1: 1	أَخْلَفَ الشَّرْطَ
u'خَلَفٌ شَرْطٌ':Added, #1: 1	خَلَفَ الشَّرْطُ
u'خَلْفٌ شَيْخٌ':Added, #1: 1	خَلَفَ الشَّرْطِ
u'خَلْفٌ صَاحِبٌ':Added, #4: 4	خَلْفَ شَيْخٍ
u'خَلْفٌ صَاحِبٌ':Added, #1: 1	خَلْفَ صَاحِبِ
u'خَلْفٌ صَبِيٌّ':Added, #1: 1	خَلْفَ صَاحِبِهِ
u'خَلْفٌ صَبِيٌّ':Added, #1: 1	خَلْفَ صَبِيٍّ
u'خَلْفٌ صَخْرَةٌ':Added, #3: 3	خَلْفَ الصَّبِيِّ
u'خَلْفٌ صَخْرَةٌ':Added, #1: 1	خَلْفَ الصَّخْرَةِ
u'خَلْفٌ صَفٌّ':Added, #1: 1	خَلْفَ صَخْرَةٍ
u'خَلْفٌ صَفٌّ':Added, #37: 37	خَلْفَ الصَّفِّ
u'خَلْفٌ صَفٌّ':Added, #3: 3	خَلْفَ صَفٍّ
u'خَلْفٌ صُفُوفٌ':Added, #3: 3	خَلْفَ صَفِّ
u'خَلْفٌ صُفُوفٌ':Added, #3: 3	خَلْفَ صُفُوفِ
u'خَلْفٌ صَلاَةٌ':Added, #9: 9	خَلْفَ الصُّفُوفِ
u'خَلْفٌ صَلاَةٌ':Added, #1: 1	خَلْفَ الصَّلاَةِ
u'خَلْفٌ صَلاَةٌ':Added, #1: 1	خَلْفَ صَلَاةٍ
u'خَلْفٌ صَلاَةٌ':Added, #2: 2	خَلْفَ صَلَاةِ
u'خَلْفٌ صَلَوَاتٌ':Added, #3: 3	خَلْفَ صَلاَةِ
u'خَلْفٌ ظُفْرٌ':Added, #3: 3	خَلْفَ الصَّلَوَاتِ
u'خَلْفٌ ظَهْرٌ':Added, #1: 1	خَلْفَ ظُفْرِهِ
u'خَلْفٌ ظُهْرٌ':Added, #13: 13	خَلْفَ ظَهْرِهِ
u'خَلْفٌ ظُهْرٌ':Added, #1: 1	خَلْفَ الظُّهْرِ
u'خَلْفٌ ظَهْرٌ':Added, #1: 1	خَلْفَ ظُهْرِ
u'خَلْفٌ عَاجِزٌ':Added, #2: 2	خَلْفِ ظَهْرِهِ
u'خَلْفٌ عَالَمٌ':Added, #1: 1	خَلْفَ عَاجِزٍ
u'خَلْفٌ عَالِمٌ':Added, #1: 1	خَلْفَ عَالَمٍ
u'خَلْفٌ عَامِلٌ':Added, #2: 2	خَلْفَ عَالِمٍ
u'خَلَّفَ عَبْدٌ':Subject, #1: 1	خَلْفَ عَامِلِهِ
u'خَلْفٌ عَبْدٌ':Added, #1: 1	خَلَّفَ عَبْدٌ
u'خَلْفٌ عَبْدٌ':Added, #1: 1	خَلْفَ عَبْدٍ
u'خَلْفٌ عَدْلٌ':Added, #2: 2	خَلْفَ عَبْدِ
u'خَلْفٌ عُرْيَانٌ':Added, #1: 1	خَلْفَ عَدْلٍ
u'خَلْفٌ عِشَاءٌ':Added, #1: 1	خَلْفَ الْعُرْيَانِ
u'خَلْفٌ عَصْرٌ':Added, #3: 3	خَلْفَ الْعِشَاءِ
u'خَلْفٌ عَلِيٌّ':Added, #5: 5	خَلْفَ عَصْرٍ
u'خَلْفٌ عَنَزَةٌ':Added, #1: 1	خَلْفَ عَلِيِّ
u'خَلْفٌ عِيدٌ':Added, #1: 1	خَلْفَ الْعَنَزَةِ
u'خَلْفٌ غَرِيمٌ':Added, #1: 1	خَلْفَ الْعِيدِ
u'خَلْفٌ غُلاَمٌ':Added, #1: 1	خَلْفَ غَرِيمِهِ
u'خَلِفَ غَنَمٌ':Predicate, #1: 1	خَلْفَ الْغُلاَمِ
u'خَلَفٌ غير':Added, #1: 1	أَخْلَفَ الْغَنَمَ
u'خَلَفٌ غَيْرٌ':Added, #1: 1	خَلَفَ غَيْرِهِ
u'خَلْفٌ غير':Added, #1: 1	خَلَفَ غَيْرِهِ
u'خَلْفٌ غَيْرٌ':Added, #4: 4	خَلْفَ غَيْرِهِ
u'خَلْفٌ فَاسِقٌ':Added, #4: 4	خَلْفَ غَيْرِهِ
u'خَلْفٌ فَاسِقٌ':Added, #1: 1	خَلْف الْفَاسِقِ
u'خَلْفٌ فَاسِقٌ':Added, #3: 3	خَلْفَ فَاسِقٍ
u'خَلْفٌ فَجْرٌ':Added, #6: 6	خَلْفَ الْفَاسِقِ
u'خَلْفٌ فَرْضٌ':Added, #1: 1	خَلْفَ فَجْرٍ
u'خَلْفٌ فَقِيرٌ':Added, #1: 1	خَلْفَ فَرْضٍ
u'خَلَفَ فلان':Predicate, #1: 1	خَلْفَ الْفَقِيرِ
u'خَلَّفَ فُلاَنٌ':Subject, #1: 1	خَلَفَ عُثْمَانَ
u'خَلْفٌ فلان':Added, #1: 1	خَلَّفَ فُلَانٌ
u'خَلْفٌ فلان':Added, #1: 1	خَلْفَ الشَّافِعِيِّ
u'خَلْفٌ فلان':Added, #1: 1	خَلْفُ الْمُزْدَلِفَةِ
u'خَلْفٌ فلان':Added, #1: 1	خَلْفَ رَايَةِ
u'خَلْفٌ فُلاَنٌ':Added, #2: 2	خَلْفَ الشَّافِعِيَّةِ
u'خَلْفٌ قَاتِلٌ':Added, #3: 3	خَلْفَ فُلَانٍ
u'خَلْفٌ قَارِئٌ':Added, #1: 1	خَلْفَ الْقَاتِلِ
u'خَلْفٌ قَارِئٌ':Added, #1: 1	خَلْفَ الْقَارِئِ
u'خَلْفٌ قَاصِرٌ':Added, #7: 7	خَلْفَ قَارِئٍ
u'خَلْفٌ قَاصِرٌ':Added, #1: 1	خَلْفَ قَاصِرِ
u'خَلْفٌ قَاعِدٌ':Added, #3: 3	خَلْفَ قَاصِرٍ
u'خَلْفٌ قَاعِدٌ':Added, #1: 1	خَلْف الْقَاعِدِ
u'خَلْفٌ قَاعِدٌ':Added, #1: 1	خَلْفَ قَاعِدٍ
u'خَلَفَ قَالٌ':Predicate, #4: 4	خَلْفَ الْقَاعِدِ
u'خَلْفٌ قدم':Added, #1: 1	خَلَفَ قَالَ
u'خَلْفٌ قَدَمٌ':Added, #1: 1	خَلْفَ قَدَمِ
u'خَلْفٌ قَصَبٌ':Added, #1: 1	خَلْفَ قَدَمِ
u'خَلْفٌ قَضَاءٌ':Added, #1: 1	خَلْفَ الْقَصَبِ
u'خَلْفٌ قَضَاءٌ':Added, #1: 1	خَلْفَ الْقَضَاءِ
u'خَلْفٌ قِطَارٌ':Added, #1: 1	خَلْفَ قَضَاءٍ
u'خَلَّفَ كَافِرٌ':Subject, #1: 1	خَلْفِ الْقِطَارِ
u'خَلْفٌ كَافِرٌ':Added, #1: 1	خَلَّفَ كَافِرٌ
u'خَلْفٌ كَبِيرٌ':Added, #2: 2	خَلْفَ كَافِرٍ
u'خَلْفٌ لَحَّانٌ':Added, #1: 1	خَلْفَ الْكَبِيرِ
u'خَلَفٌ مَاءٌ':Added, #3: 3	خَلْفَ اللَّحَّانِ
u'خَلْفٌ مالِكِيّ':Added, #1: 1	خَلَفُ مَاءٍ
u'خَلْفٌ مَأْمُورٌ':Added, #2: 2	خَلْفَ الْمَالِكِيِّ
u'خَلْفٌ مُبْتَدِعٌ':Added, #1: 1	خَلْفَ مَأْمُورِهِ
u'خَلْفٌ مُبْتَدِعٌ':Added, #2: 2	خَلْفَ الْمُبْتَدِعِ
u'خَلْفٌ مُتَطَوِّعٌ':Added, #6: 6	خَلْفَ مُبْتَدِعٍ
u'خَلْفٌ مُتَطَوِّعٌ':Added, #1: 1	خَلْفَ الْمُتَطَوِّعِ
u'خَلْفٌ مُتَغَلِّب':Added, #1: 1	خَلْفَ مُتَطَوِّعٍ
u'خَلْفٌ مثل':Added, #2: 2	خَلْفَ الْمُتَغَلِّبِ
u'خَلْفٌ مِثْلٌ':Added, #5: 5	خَلْفَ مِثْلِهِ
u'خَلْفٌ مُجْتَهِد':Added, #5: 5	خَلْفَ مِثْلِهِ
u'خَلْفٌ مَجْهُولٌ':Added, #1: 1	خَلْفَ الْمُجْتَهِدِ
u'خَلْفٌ مُحْدِثٌ':Added, #1: 1	خَلْفَ مَجْهُولٍ
u'خَلْفٌ مُحْدِثٌ':Added, #1: 1	خَلْفَ مُحْدِثٍ
u'خَلْفٌ مَحْمَلٌ':Added, #7: 7	خَلْفَ الْمُحْدِثِ
u'خَلْفٌ مُخَالِفٌ':Added, #1: 1	خَلْفَ الْمَحْمَلِ
u'خَلْفٌ مُسَافِرٌ':Added, #1: 1	خَلْفَ مُخَالِفٍ
u'خَلْفٌ مُسَافِرٌ':Added, #6: 6	خَلْفَ مُسَافِرٍ
u'خَلْفٌ مُسَنّاة':Added, #8: 8	خَلْفَ الْمُسَافِرِ
u'خَلْفٌ مُشْرِك':Added, #2: 2	خَلْفَ الْمُسَنَّاةِ
u'خَلْفٌ مُعْتَزِلٌ':Added, #1: 1	خَلْفَ مُشْرِكٍ
u'خَلْفٌ مُعْتَزِلَةٌ':Added, #2: 2	خَلْفَ الْمُعْتَزِلَةِ
u'خَلْفٌ مُعْتَقٌ':Added, #2: 2	خَلْفَ الْمُعْتَزِلَةِ
u'خَلْفٌ مُعْتَمِرٌ':Added, #1: 1	خَلْفَ الْمُعْتَقِ
u'خَلْفٌ مَعْذُورٌ':Added, #17: 17	خَلْفَ الْمُعْتَمِرِ
u'خَلْفٌ مُعْلِنٌ':Added, #1: 1	خَلْفَ الْمَعْذُورِ
u'خَلْفٌ مُعِيدٌ':Added, #1: 1	خَلْفَ الْمُعْلِنِ
u'خَلْفٌ مَفْرُوضٌ':Added, #1: 1	خَلْفَ الْمُعِيدِ
u'خَلْفٌ مَقَامٌ':Added, #1: 1	خَلْفَ الْمَفْرُوضَةِ
u'خَلْفٌ مُقِيمٌ':Added, #31: 31	خَلْفَ الْمَقَامِ
u'خَلْفٌ مُقِيمٌ':Added, #3: 3	خَلْفَ الْمُقِيمِ
u'خَلَّفَ مُوَرِّث':Subject, #5: 5	خَلْفَ مُقِيمٍ
u'خَلْفٌ مَوْقِفٌ':Added, #1: 1	خَلَّفَ مُوَرِّثُهُ
u'خَلْفٌ نَاسٌ':Added, #1: 1	خَلْفَ مَوْقِفِ
u'خَلْفٌ نَاقَةٌ':Added, #2: 2	خَلْفَ النَّاسِ
u'خَلْفٌ نَاقَة':Added, #1: 1	خَلْفَ النَّاقَةِ
u'خَلْفٌ نَائِبٌ':Added, #1: 1	خَلْفَ النَّاقَةِ
u'خَلْفٌ نَائِمٌ':Added, #1: 1	خَلْفَ نَائِبِهِ
u'خَلْفٌ نَائِمٌ':Added, #1: 1	خَلْفَ نَائِمٍ
u'خَلْفٌ نَبِيٌّ':Added, #2: 2	خَلْفَ النَّائِمِ
u'خَلْفٌ نَبِيٌّ':Added, #1: 1	خَلْفُ النَّبِيِّ
u'خَلْفٌ نِساءٌ':Added, #31: 31	خَلْفَ النَّبِيِّ
u'خَلْفٌ نُعْمَانُ':Added, #1: 1	خَلْفَ النِّسَاءِ
u'خَلْفٌ نَفْلٌ':Added, #2: 2	خَلْفَ النُّعْمَانِ
u'خَلْفٌ نَهْرٌ':Added, #1: 1	خَلْفَ النَّفْلِ
u'خَلْفٌ نَوَافِلُ':Added, #1: 1	خَلْفَ النَّهْرِ
u'خَلْفٌ واحد':Added, #1: 1	خَلْفَ النَّوَافِلِ
u'خَلْفٌ وَاحِدٌ':Added, #3: 3	خَلْفَ وَاحِدٍ
u'خَلْفٌ وِرْدٌ':Added, #3: 3	خَلْفَ وَاحِدٍ
u'خَلْفٌ وَعْدٌ':Added, #1: 1	خَلْفَ الْوِرْدِ
u'خَلْفٌ وَعْدٌ':Added, #1: 1	خَلْفَ الْوَعْدِ
u'خَلَفَ ولد':Subject, #1: 1	خَلْفِ الْوَعْدِ
u'خَلَفَ وَلَدٌ':Subject, #1: 1	خَلَفَ الْوَلَدُ
u'خَلَفٌ وَلَدٌ':Added, #1: 1	خَلَفَ الْوَلَدُ
u'خلق إِبِلٌ':Added, #1: 1	خَلَفَ وَلَدَيْنِ
u'خَلْقٌ إِبِلٌ':Added, #1: 1	خَلْقَ الْإِبِلِ
u'خلق اِبْنٌ':Added, #1: 1	خَلْقَ الْإِبِلِ
u'خَلْقٌ اِبْنٌ':Added, #1: 1	خَلْقِ ابْنِ
u'خَلَقَ آدَمُ':Predicate, #1: 1	خَلْقِ ابْنِ
u'خَلْقٌ آدَمِيٌّ':Added, #12: 12	خَلَقَ آدَمَ
u'خلق آدَمِيٌّ':Added, #1: 1	خَلْقٍ آدَمِيٍّ
u'خَلْقٌ آدَمِيٌّ':Added, #2: 2	خَلْقُ آدَمِيٍّ
u'خلق آدَمِيٌّ':Added, #2: 2	خَلْقُ آدَمِيٍّ
u'خَلْقٌ آدَمِيٌّ':Added, #2: 2	خَلْقِ الْآدَمِيِّ
u'خلق آدَمِيٌّ':Added, #2: 2	خَلْقِ الْآدَمِيِّ
u'خَلْقٌ آدَمِيٌّ':Added, #4: 4	خَلْقِ آدَمِيٍّ
u'خلق إِرَادَةٌ':Added, #4: 4	خَلْقِ آدَمِيٍّ
u'خَلْقٌ إِرَادَةٌ':Added, #1: 1	خَلْقِ الْإِرَادَةِ
u'خَلَقَ أرْضٌ':Predicate, #1: 1	خَلْقِ الْإِرَادَةِ
u'خَلَقَ أرْضٌ':Predicate, #2: 2	خَلَقَ الأَرْضَ
u'خلق أرْضٌ':Added, #7: 7	خَلَقَ الْأَرْضَ
u'خلق أرْضٌ':Added, #1: 1	خَلْقَ الْأَرْضِ
u'خَلْقٌ أرْضٌ':Added, #1: 1	خَلْقِ الْأَرْضِ
u'خَلْقٌ أرْضٌ':Added, #1: 1	خَلْقَ الْأَرْضِ
u'خَلَقَ أَزْواجٌ':Predicate, #1: 1	خَلْقِ الْأَرْضِ
u'خلق أَشْيَاءٌ':Added, #1: 1	خَلَقَ الْأَزْوَاجَ
u'خلق أَشْيَاءٌ':Added, #1: 1	خَلْقَ الْأَشْيَاءِ
u'خَلْقٌ أَشْيَاءٌ':Added, #1: 1	خَلْقِ الْأَشْيَاءِ
u'خَلْقٌ أَشْيَاءٌ':Added, #1: 1	خَلْقَ الْأَشْيَاءِ
u'خَلَقَ أَفْعَالٌ':Predicate, #1: 1	خَلْقِ الْأَشْيَاءِ
u'خلق أَفْعَالٌ':Added, #1: 1	خَلَقَ أَفْعَالَ
u'خلق أَفْعَالٌ':Added, #1: 1	خَلْقَ الْأَفْعَالِ
u'خَلْقٌ أَفْعَالٌ':Added, #1: 1	خَلْقُ الْأَفْعَالِ
u'خَلْقٌ أَفْعَالٌ':Added, #1: 1	خَلْقَ الْأَفْعَالِ
u'خلق أَفْعَالٌ':Added, #1: 1	خَلْقُ الْأَفْعَالِ
u'خَلْقٌ أَفْعَالٌ':Added, #4: 4	خَلْقِ الْأَفْعَالِ
u'خلق أَلْطَافٌ':Added, #4: 4	خَلْقِ الْأَفْعَالِ
u'خَلْقٌ أَلْطَافٌ':Added, #1: 1	خَلْقِ أَلْطَافٍ
u'خلق اللهُ':Added, #1: 1	خَلْقِ أَلْطَافٍ
u'خَلْقٌ اللهُ':Added, #1: 1	خَلْقِ اللهِ
u'خلق إلَهٌ':Added, #1: 1	خَلْقِ اللهِ
u'خَلْقٌ إلَهٌ':Added, #1: 1	خَلْقُ الْإِلَهِ
u'خَلَقَ أَمْرٌ':Subject, #1: 1	خَلْقُ الْإِلَهِ
u'خَلَقَ إِنْسانٌ':Predicate, #1: 1	خَلَقَ أَمْرُهُ
u'خَلَقَ إِنْسانٌ':Predicate, #2: 2	خَلَقَ الإِنْسَانَ
u'خلق إِنْسانٌ':Added, #6: 6	خَلَقَ الْإِنْسَانَ
u'خَلْقٌ إِنْسانٌ':Added, #10: 10	خَلْقِ الْإِنْسَانِ
u'خلق إِنْسانٌ':Added, #10: 10	خَلْقِ الْإِنْسَانِ
u'خَلْقٌ إِنْسانٌ':Added, #2: 2	خَلْقُ الْإِنْسَانِ
u'خلق إِنْسانٌ':Added, #2: 2	خَلْقُ الْإِنْسَانِ
u'خَلْقٌ إِنْسانٌ':Added, #2: 2	خَلْقُ إنْسَانٍ
u'خَلَقَ أهْلٌ':Predicate, #2: 2	خَلْقُ إنْسَانٍ
u'خلق إيمَانٌ':Added, #2: 2	خَلَقَ أَهْلَ
u'خَلْقٌ إيمَانٌ':Added, #2: 2	خَلْقِ الْإِيمَانِ
u'خَلَقَ بُروجٌ':Predicate, #2: 2	خَلْقِ الْإِيمَانِ
u'خلق بَقَرٌ':Added, #1: 1	خَلَقَ الْبُرُوجَ
u'خَلْقٌ بَقَرٌ':Added, #1: 1	خَلْقَ الْبَقَرِ
u'خَلَقَ تُرْبَةٌ':Predicate, #1: 1	خَلْقَ الْبَقَرِ
u'خلق ثَقَل':Added, #3: 3	خَلَقَ التّرْبَةَ
u'خَلْقٌ ثَقَل':Added, #1: 1	خَلْقِ الثَّقَلَيْنِ
u'خَلُقَ ثَوْبٌ':Subject, #1: 1	خَلْقِ الثَّقَلَيْنِ
u'خَلِقَ ثَوْبٌ':Subject, #1: 1	خَلُقَ الثَّوْبُ
u'خَلْقٌ جَديدٌ':Added, #1: 1	خَلِقَ الثَّوْبُ
u'خلق جِنٌّ':Added, #1: 1	خَلْقٍ جَدِيدٍ
u'خَلْقٌ جِنٌّ':Added, #1: 1	خَلْقِ الْجِنِّ
u'خَلَقَ جَنَّةٌ':Predicate, #1: 1	خَلْقِ الْجِنِّ
u'خَلَقَ جَنَّةٌ':Predicate, #1: 1	خَلَقَ الْجَنّةَ
u'خلق جَنَّةٌ':Added, #3: 3	خَلَقَ الْجَنَّةَ
u'خَلْقٌ جَنَّةٌ':Added, #1: 1	خَلْقِ الْجَنَّةِ
u'خَلَقَ حَنِينٌ':Predicate, #1: 1	خَلْقِ الْجَنَّةِ
u'خلق حَيٌّ':Added, #1: 1	خَلَقَ الْحَنِينَ
u'خَلْقٌ حَيٌّ':Added, #1: 1	خَلْقِ الْحَيَّاتِ
u'خلق حَيَّاتٌ':Added, #1: 1	خَلْقِ الْحَيَّاتِ
u'خَلْقٌ حَيَّاتٌ':Added, #1: 1	خَلْقِ الْحَيَّاتِ
u'خلق حَيَّةٌ':Added, #1: 1	خَلْقِ الْحَيَّاتِ
u'خَلْقٌ حَيَّةٌ':Added, #1: 1	خَلْقِ الْحَيَّاتِ
u'خلق حَيَوَانٌ':Added, #1: 1	خَلْقِ الْحَيَّاتِ
u'خَلْقٌ حَيَوَانٌ':Added, #1: 1	خَلْقِ الْحَيَوَانَاتِ
u'خَلَقَ خلق':Predicate, #1: 1	خَلْقِ الْحَيَوَانَاتِ
u'خَلَقَ خَلْقٌ':Predicate, #14: 14	خَلَقَ الْخَلْقَ
u'خَلَقَ خلق':Predicate, #14: 14	خَلَقَ الْخَلْقَ
u'خلق خلق':Added, #4: 4	خَلَقَ خَلَقَ
u'خَلْقٌ خلق':Added, #1: 1	خَلْقِ الْخَلْقِ
u'خلق خَلْقٌ':Added, #1: 1	خَلْقِ الْخَلْقِ
u'خَلْقٌ خَلْقٌ':Added, #1: 1	خَلْقِ الْخَلْقِ
u'خلق خَيْرٌ':Added, #1: 1	خَلْقِ الْخَلْقِ
u'خَلْقٌ خَيْرٌ':Added, #1: 1	خَلْقُ الْخَيْرِ
u'خَلَقَ دَاءٌ':Predicate, #1: 1	خَلْقُ الْخَيْرِ
u'خَلَقَ دَاعِي':Predicate, #1: 1	خَلَقَ الدَّاءَ
u'خَلَقَ دُرٌّ':Predicate, #1: 1	خَلَقَ الدَّاعِيَةَ
u'خَلَقَ دَواءٌ':Predicate, #2: 2	خَلَقَ دُرَّةً
u'خَلَقَ ذُبابٌ':Predicate, #2: 2	خَلَقَ الدَّوَاءَ
u'خَلَقَ ذكر':Predicate, #1: 1	خَلَقَ الذُّبَابَةَ
u'خَلَقَ ذَكَرٌ':Predicate, #7: 7	خَلَقَ الذَّكَرَ
u'خَلَقَ رَبُّ':Predicate, #7: 7	خَلَقَ الذَّكَرَ
u'خَلَقَ ريحٌ':Predicate, #1: 1	خَلَقَ رَبَّكَ
u'خَلَقَ سَبَبٌ':Predicate, #1: 1	خَلَقَ الرِّيحَ
u'خَلَقَ سَبْعٌ':Predicate, #1: 1	خَلَقَ السَّبَبَ
u'خَلَقَ سَمَاءٌ':Predicate, #1: 1	خَلَقَ سَبْعَ
u'خَلَقَ سَمَاءٌ':Predicate, #1: 1	خَلَقَ السّمَاءَ
u'خلق سَمَاءٌ':Added, #2: 2	خَلَقَ السَّمَاءَ
u'خلق سَمَاءٌ':Added, #1: 1	خَلْقَ السَّمَاءِ
u'خَلْقٌ سَمَاءٌ':Added, #1: 1	خَلْقِ السَّمَاءِ
u'خَلْقٌ سَمَاءٌ':Added, #1: 1	خَلْقَ السَّمَاءِ
u'خلق سَمَاواتٌ':Added, #1: 1	خَلْقِ السَّمَاءِ
u'خَلْقٌ سَمَاواتٌ':Added, #8: 8	خَلْقِ السَّمَاوَاتِ
u'خلق سموات':Added, #8: 8	خَلْقِ السَّمَاوَاتِ
u'خَلْقٌ سموات':Added, #16: 16	خَلْقِ السَّمَوَاتِ
u'خلق سموات':Added, #16: 16	خَلْقِ السَّمَوَاتِ
u'خلق سموات':Added, #1: 1	خَلْقَ السّمَوَاتِ
u'خلق سموات':Added, #1: 1	خَلْقُ السَّمَوَاتِ
u'خَلْقٌ سموات':Added, #1: 1	خَلْقِ السّمَوَاتِ
u'خَلْقٌ سموات':Added, #1: 1	خَلْقَ السّمَوَاتِ
u'خَلْقٌ سموات':Added, #1: 1	خَلْقُ السَّمَوَاتِ
u'خَلَقَ سَنَةٌ':Predicate, #1: 1	خَلْقِ السّمَوَاتِ
u'خلق شَرٌّ':Added, #1: 1	خَلَقَ السَّنَةَ
u'خَلْقٌ شَرٌّ':Added, #2: 2	خَلْقُ الشَّرِّ
u'خَلَقَ شمس':Predicate, #2: 2	خَلْقُ الشَّرِّ
u'خَلَقَ شَمْسٌ':Predicate, #1: 1	خَلَقَ الشَّمْسَ
u'خلق شَيْءٌ':Added, #1: 1	خَلَقَ الشَّمْسَ
u'خَلْقٌ شَيْءٌ':Added, #1: 1	خَلْقَ شَيْءٍ
u'خَلَقَ صَوْتٌ':Predicate, #1: 1	خَلْقَ شَيْءٍ
u'خلق طَيْرٌ':Added, #1: 1	خَلَقَ صَوْتَ
u'خَلْقٌ طَيْرٌ':Added, #1: 1	خَلْقَ الطَّيْرِ
u'خلق عَاقِلٌ':Added, #1: 1	خَلْقَ الطَّيْرِ
u'خَلْقٌ عَاقِلٌ':Added, #1: 1	خَلْقَ الْعَاقِلِ
u'خَلَقَ عَالَمٌ':Predicate, #1: 1	خَلْقَ الْعَاقِلِ
u'خلق عَالَمٌ':Added, #1: 1	خَلَقَ الْعَالَمَ
u'خَلْقٌ عَالَمٌ':Added, #1: 1	خَلْقُ الْعَالَمِ
u'خَلَقَ عَامٌّ':Subject, #1: 1	خَلْقُ الْعَالَمِ
u'خَلَقَ عَبْدٌ':Predicate, #1: 1	خَلَقَ عَامٌّ
u'خَلَقَ عَقْلٌ':Predicate, #5: 5	خَلَقَ الْعَبْدَ
u'خلق علم':Added, #1: 1	خَلَقَ الْعَقْلَ
u'خَلْقٌ علم':Added, #2: 2	خَلْقِ عِلْمٍ
u'خلق عِلْمٌ':Added, #2: 2	خَلْقِ عِلْمٍ
u'خَلْقٌ عِلْمٌ':Added, #2: 2	خَلْقِ عِلْمٍ
u'خَلَقَ غضب':Predicate, #2: 2	خَلْقِ عِلْمٍ
u'خَلَقَ غَضَبٌ':Predicate, #1: 1	خَلَقَ الْغَضَبَ
u'خلق قَبِيحٌ':Added, #1: 1	خَلَقَ الْغَضَبَ
u'خَلْقٌ قَبِيحٌ':Added, #1: 1	خَلْقِ الْقَبِيحِ
u'خَلَقَ قدرة':Predicate, #1: 1	خَلْقِ الْقَبِيحِ
u'خَلَقَ قُدْرَةٌ':Predicate, #2: 2	خَلَقَ الْقُدْرَةَ
u'خَلَقَ قدرة':Predicate, #2: 2	خَلَقَ الْقُدْرَةَ
u'خَلَقَ قُدْرَةٌ':Predicate, #4: 4	خَلَقَ قُدْرَةَ
u'خلق قدرة':Added, #4: 4	خَلَقَ قُدْرَةَ
u'خَلْقٌ قدرة':Added, #1: 1	خَلْقُ قُدْرَةِ
u'خلق قُدْرَةٌ':Added, #1: 1	خَلْقُ قُدْرَةِ
u'خَلْقٌ قُدْرَةٌ':Added, #1: 1	خَلْقُ قُدْرَةِ
u'خلق قدرة':Added, #1: 1	خَلْقُ قُدْرَةِ
u'خَلْقٌ قدرة':Added, #2: 2	خَلْقِ الْقُدْرَةِ
u'خلق قُدْرَةٌ':Added, #2: 2	خَلْقِ الْقُدْرَةِ
u'خَلْقٌ قُدْرَةٌ':Added, #2: 2	خَلْقِ الْقُدْرَةِ
u'خلق قدرة':Added, #2: 2	خَلْقِ الْقُدْرَةِ
u'خَلْقٌ قدرة':Added, #3: 3	خَلْقُ الْقُدْرَةِ
u'خلق قُدْرَةٌ':Added, #3: 3	خَلْقُ الْقُدْرَةِ
u'خَلْقٌ قُدْرَةٌ':Added, #3: 3	خَلْقُ الْقُدْرَةِ
u'خلق قَدِيمٌ':Added, #3: 3	خَلْقُ الْقُدْرَةِ
u'خَلْقٌ قَدِيمٌ':Added, #1: 1	خَلْقِ الْقَدِيمِ
u'خلق قُرْآنٌ':Added, #1: 1	خَلْقِ الْقَدِيمِ
u'خَلْقٌ قُرْآنٌ':Added, #7: 7	خَلْقِ الْقُرْآنِ
u'خَلَقَ قَلَمٌ':Predicate, #7: 7	خَلْقِ الْقُرْآنِ
u'خَلَقَ قُوَّةٌ':Predicate, #2: 2	خَلَقَ الْقَلَمَ
u'خَلَقَ قُوَّة':Predicate, #1: 1	خَلَقَ الْقُوَّةَ
u'خَلَقَ كعبة':Predicate, #1: 1	خَلَقَ الْقُوَّةَ
u'خَلَقَ كَعْبَةٌ':Predicate, #1: 1	خَلَقَ الْكَعْبَةَ
u'خلق كفر':Added, #1: 1	خَلَقَ الْكَعْبَةَ
u'خَلْقٌ كفر':Added, #1: 1	خَلْقِ الْكُفْرِ
u'خلق كُفْرٌ':Added, #1: 1	خَلْقِ الْكُفْرِ
u'خَلْقٌ كُفْرٌ':Added, #1: 1	خَلْقِ الْكُفْرِ
u'خلق كَوَاكِبُ':Added, #1: 1	خَلْقِ الْكُفْرِ
u'خَلْقٌ كَوَاكِبُ':Added, #1: 1	خَلْقِ الْكَوَاكِبِ
u'خَلَقَ لبن':Predicate, #1: 1	خَلْقِ الْكَوَاكِبِ
u'خَلَقَ لَبَنٌ':Predicate, #1: 1	خَلَقَ اللَّبَنَ
u'خَلَقَ مَاءٌ':Predicate, #1: 1	خَلَقَ اللَّبَنَ
u'خلق مَاءٌ':Added, #1: 1	خَلَقَ الْمَاءَ
u'خَلْقٌ مَاءٌ':Added, #1: 1	خَلْقِ الْمَاءِ
u'خلق مَانِعٌ':Added, #1: 1	خَلْقِ الْمَاءِ
u'خَلْقٌ مَانِعٌ':Added, #1: 1	خَلْقِ مَانِعٍ
u'خَلَقَ مَرَضٌ':Predicate, #1: 1	خَلْقِ مَانِعٍ
u'خلق مَرْكُوبٌ':Added, #1: 1	خَلَقَ الْمَرَضَ
u'خَلْقٌ مَرْكُوبٌ':Added, #1: 1	خَلْقَ مَرْكُوبِهِ
u'خَلَقَ مَعْرُوفٌ':Predicate, #1: 1	خَلْقَ مَرْكُوبِهِ
u'خلق مَقَامٌ':Added, #1: 1	خَلَقَ الْمَعْرُوفَ
u'خَلْقٌ مَقَامٌ':Added, #1: 1	خَلْقِ الْمَقَامِ
u'خلق مَقْدُورٌ':Added, #1: 1	خَلْقِ الْمَقَامِ
u'خَلْقٌ مَقْدُورٌ':Added, #1: 1	خَلْقُ الْمَقْدُورِ
u'خَلَقَ مَكَانٌ':Predicate, #1: 1	خَلْقُ الْمَقْدُورِ
u'خلق مَلاَئِكَةٌ':Added, #1: 1	خَلَقَ الْمَكَانَ
u'خَلْقٌ مَلاَئِكَةٌ':Added, #1: 1	خَلْقَ الْمَلَائِكَةِ
u'خَلَقَ مَلَكٌ':Predicate, #1: 1	خَلْقَ الْمَلَائِكَةِ
u'خَلَقَ مَوْتٌ':Predicate, #1: 1	خَلَقَ مَلَكَ
u'خلق مَوْتٌ':Added, #6: 6	خَلَقَ الْمَوْتَ
u'خَلْقٌ مَوْتٌ':Added, #2: 2	خَلْقِ الْمَوْتِ
u'خَلَقَ نَارٌ':Predicate, #2: 2	خَلْقِ الْمَوْتِ
u'خَلَقَ نَفْسٌ':Subject, #7: 7	خَلَقَ النَّارَ
u'خلق نَفْسٌ':Added, #1: 1	خَلَقَ النَّفْسُ
u'خَلْقٌ نَفْسٌ':Added, #1: 1	خَلْقِ نَفْسِهِ
u'خَلَقَ نُورٌ':Predicate, #1: 1	خَلْقِ نَفْسِهِ
u'خَلَقَ نَوْعٌ':Predicate, #1: 1	خَلَقَ النُّورَ
u'خَلَقَ نُونٌ':Predicate, #1: 1	خَلَقَ النَّوْعَ
u'خَلَقَ وَثَنٌ':Predicate, #2: 2	خَلَقَ النُّونَ
u'خَلَقَ يَوْمٌ':Predicate, #2: 2	خَلَقَ الْوَثَنَ
u'خَلَّلَ أَصابِعُ':Predicate, #3: 3	خَلَقَ يَوْمَ
u'خَلَّلَ ألف':Predicate, #2: 2	خَلَّلَ أَصَابِعَ
u'خَلَّلَ خَمْرٌ':Predicate, #2: 2	خَلَّلَ الْأَلِفَ
u'خَلَّلَ شَرْطٌ':Predicate, #3: 3	خَلَّلَ الْخَمْرَ
u'خَلَّ مُتَكَلِّمٌ':Subject, #1: 1	خَلَّلَ الشَّرْطَ
u'خَلَّ مُصَنِّفٌ':Subject, #1: 1	أَخَلَّ الْمُتَكَلِّمُ
u'خَلَوَاتٌ أرْضٌ':Added, #5: 5	أَخَلَّ الْمُصَنِّفُ
u'خَلَّ واحد':Subject, #1: 1	خَلَوَاتِ الْأَرْضِ
u'خَلَّ وَاحِدٌ':Subject, #2: 2	أَخَلَّ وَاحِدٌ
u'خَلْوَةٌ أَجْنَبِيٌّ':Added, #2: 2	أَخَلَّ وَاحِدٌ
u'خَلْوَةٌ الْمَرْأَةُ':Added, #1: 1	خَلْوَةَ الْأَجْنَبِيِّ
u'خَلْوَةٌ الْمَرْأَةُ':Added, #1: 1	خَلْوَةُ الْمَرْأَةِ
u'خَلْوَةٌ إِنْسانٌ':Added, #1: 1	خَلْوَةِ الْمَرْأَةِ
u'خَلْوَةٌ اِهْتِدَاءٌ':Added, #1: 1	خَلْوَةِ الْإِنْسَانِ
u'خَلْوَةٌ بِنَاءٌ':Added, #1: 1	خَلْوَةَ اهْتِدَاءٍ
u'خَلْوَةٌ ذكر':Added, #1: 1	خَلْوَةَ بِنَاءٍ
u'خَلْوَةٌ ذَكَرٌ':Added, #1: 1	خَلْوَةُ الذَّكَرِ
u'خَلْوَةٌ ذِمِّيٌّ':Added, #1: 1	خَلْوَةُ الذَّكَرِ
u'خَلْوَةٌ ذِمِّيٌّ':Added, #1: 1	خَلْوَةُ الذِّمِّيَّةِ
u'خَلْوَةٌ رَجُلٌ':Added, #1: 1	خَلْوَةِ الذِّمِّيَّةِ
u'خَلْوَةٌ رَجُلٌ':Added, #1: 1	خَلْوَةَ الرَّجُلِ
u'خَلْوَةٌ رَجُلٌ':Added, #1: 1	خَلْوَةُ الرَّجُلِ
u'خَلْوَةٌ رَجُلٌ':Added, #1: 1	خَلْوَةُ رَجُلٍ
u'خَلْوَةٌ رَجُلٌ':Added, #1: 1	خَلْوَةِ رَجُلٍ
u'خَلْوَةٌ زِيارَةٌ':Added, #1: 1	خَلْوَةُ رَجُلَيْنِ
u'خَلْوَةٌ زِيارَةٌ':Added, #1: 1	خَلْوَةُ الزِّيَارَةِ
u'خَلْوَةٌ شَيْخٌ':Added, #1: 1	خَلْوَةَ زِيَارَةٍ
u'خَلْوَةٌ صَغِيرٌ':Added, #1: 1	خَلْوَةَ الشَّيْخِ
u'خَلْوَةٌ صَغِيرٌ':Added, #1: 1	خَلْوَةُ الصَّغِيرِ
u'خَلْوَةٌ صَغِيرٌ':Added, #1: 1	خَلْوَةِ الصَّغِيرِ
u'خَلْوَةٌ غُلاَمٌ':Added, #2: 2	خَلْوَةَ الصَّغِيرَةِ
u'خَلْوَةٌ فَحْلٌ':Added, #1: 1	خَلْوَةُ الْغُلَامِ
u'خَلْوَةٌ مُحَرَّمٌ':Added, #1: 1	خَلْوَةُ الْفَحْلِ
u'خَلْوَةٌ مَرِيضٌ':Added, #2: 2	خَلْوَةٍ مُحَرَّمَةٍ
u'خَلْوَةٌ مُمَيِّزٌ':Added, #1: 1	خَلْوَةَ الْمَرِيضِ
u'خَلْوَةٌ مُمَيِّزٌ':Added, #1: 1	خَلْوَةَ الْمُمَيِّزَةِ
u'خَلْوَةٌ نَبِيٌّ':Added, #1: 1	خَلْوَةُ الْمُمَيِّزَةِ
u'خَلْوَةٌ نِساءٌ':Added, #2: 2	خَلْوَةَ نَبِيِّهِ
u'خُلُودٌ عَذَابٌ':Added, #1: 1	خَلْوَةُ النِّسَاءِ
u'خُلُوصٌ حَقٌّ':Added, #1: 1	خُلُودِ عَذَابِ
u'خُلُوصٌ خُرُوجٌ':Added, #1: 1	خُلُوصِ الْحَقِّ
u'خُلُوصٌ دِينٌ':Added, #1: 1	خُلُوصِ الْخُرُوجِ
u'خُلُوصٌ ذِمَّةٌ':Added, #1: 1	خُلُوصِ الدِّينِ
u'خُلُوصٌ سَفَرٌ':Added, #1: 1	خُلُوصُ ذِمَّةِ
u'خُلُوصٌ فِضَّةٌ':Added, #1: 1	خُلُوصُ السَّفَرِ
u'خُلُوصٌ مَسَاجِدُ':Added, #1: 1	خُلُوصَ الْفِضَّةِ
u'خُلُوصٌ مَسْجِدٌ':Added, #1: 1	خُلُوصَ الْمَسَاجِدِ
u'خُلُوصٌ مَشْرُوطٌ':Added, #1: 1	خُلُوصِ الْمَسْجِدِ
u'خُلُوصٌ مِلْكٌ':Added, #1: 1	خُلُوصِ الْمَشْرُوطِ
u'خُلُوصٌ نَجَاسَةٌ':Added, #1: 1	خُلُوصُ الْمِلْكِ
u'خُلُوصٌ نكاح':Added, #4: 4	خُلُوصِ النَّجَاسَةِ
u'خُلُوصٌ نِكَاحٌ':Added, #1: 1	خُلُوصُ النِّكَاحِ
u'خُلُوصٌ نِيَّةٌ':Added, #1: 1	خُلُوصُ النِّكَاحِ
u'خُلُوصٌ نِيَّةٌ':Added, #1: 1	خُلُوصُ النِّيَّةِ
u'خُلُوصٌ يَدٌ':Added, #1: 1	خُلُوصِ النِّيَّةِ
u'خُلُوصٌ يَدٌ':Added, #2: 2	خُلُوصَ الْيَدِ
u'خَلَّى بَائِعٌ':Subject, #2: 2	خُلُوصَ يَدِ
u'خَلَّى بَيْنٌ':Predicate, #2: 2	خَلَّى الْبَائِعُ
u'خَلَّى مُسْلِمٌ':Subject, #6: 6	خَلَّى بَيْنَ
u'خَلَّى وَرَثَةٌ':Subject, #1: 1	خَلَّى الْمُسْلِمُ
u'خَمَّرَ اِبْنٌ':Subject, #2: 2	خَلَّى الْوَرَثَةُ
u'خَمَّرَ إِناءٌ':Predicate, #1: 1	خَمَّرَ ابْنُ
u'خَمَّرَ عَبْدٌ':Subject, #1: 1	خَمَّرَ الْإِنَاءَ
u'خَمَّسَ أَسْلاَبٌ':Predicate, #1: 1	خَمَّرَ عَبْدُ
u'خَمَسَ قَوْمٌ':Predicate, #1: 1	خَمَّسَ الْأَسْلَابَ
u'خَمْشٌ سَاقٌ':Added, #1: 1	خَمَسَ الْقَوْمَ
u'خَمَشَ وُجُوهٌ':Predicate, #3: 3	خَمْشَ السَّاقَيْنِ
u'خَمْشٌ وُجُوهٌ':Added, #1: 1	خَمَشَ الْوُجُوهَ
u'خَمَلَ رَجُلٌ':Subject, #1: 1	خَمْشِ وُجُوهٍ
u'خُمُودٌ أَرْواحٌ':Added, #1: 1	خَمَلَ الرَّجُلُ
u'خَنْدَقَ حول':Predicate, #1: 1	خُمُودِ الْأَرْوَاحِ
u'خَنْدَقَ حَوْلٌ':Predicate, #1: 1	خَنْدَقَ حَوْلَ
u'خَنْدَقَ خَنَادِقُ':Predicate, #1: 1	خَنْدَقَ حَوْلَ
u'خَنَقَ غير':Predicate, #1: 1	خَنْدَقَ الْخَنَادِقَ
u'خَنَقَ غَيْرٌ':Predicate, #2: 2	خَنَقَ غَيْرَ
u'خَنَقَ مرٌّ':Predicate, #2: 2	خَنَقَ غَيْرَ
u'خُوَارٌ بَقَرٌ':Added, #2: 2	خَنَقَ مَرَّةً
u'خُوَارٌ جِذْعٌ':Added, #1: 1	خُوَارَ بَقَرَةٍ
u'خُوَارٌ نَاقَةٌ':Added, #1: 1	خُوَارِ الْجِذْعِ
u'خُوَارٌ نَاقَة':Added, #1: 1	خُوَارَ النّاقَةِ
u'خَوْضٌ غير':Added, #1: 1	خُوَارَ النّاقَةِ
u'خَوْضٌ غَيْرٌ':Added, #1: 1	خَوْضِ غَيْرِ
u'خَوْضٌ مَاءٌ':Added, #1: 1	خَوْضِ غَيْرِ
u'خَوْضٌ مُحْسِنٌ':Added, #1: 1	خَوْضَ الْمَاءِ
u'خَوْضٌ مَهَالِكُ':Added, #1: 1	خَوْضَ الْمُحْسِنِ
u'خَوْضٌ نَاسٌ':Added, #1: 1	خَوْضِ الْمَهَالِكِ
u'خَوْفٌ إِحْبَالٌ':Added, #1: 1	خَوْضِ النَّاسِ
u'خَوْفٌ اِخْتِلاطٌ':Added, #1: 1	خَوْفُ الْإِحْبَالِ
u'خَوْفٌ اِخْتِلاطٌ':Added, #1: 1	خَوْفَ اخْتِلَاطِ
u'خَوْفٌ إدْخَالٌ':Added, #1: 1	خَوْفِ اخْتِلَاطِ
u'خَوْفٌ اِسْتيلاءٌ':Added, #1: 1	خَوْفَ إدْخَالِ
u'خَوْفٌ أَسْرٌ':Added, #1: 1	خَوْفُ اسْتِيلَاءِ
u'خَوْفٌ إصابَةٌ':Added, #1: 1	خَوْفَ الْأَسْرِ
u'خَوْفٌ إِطالَةٌ':Added, #1: 1	خَوْفَ إصَابَةِ
u'خَوْفٌ إِطالَةٌ':Added, #1: 1	خَوْف الْإِطَالَةِ
u'خَوْفٌ إِطالَةٌ':Added, #1: 1	خَوْفُ الْإِطَالَةِ
u'خَوْفٌ اِطِّلاعٌ':Added, #2: 2	خَوْفَ الْإِطَالَةِ
u'خَوْفٌ اِغْتِرَارٌ':Added, #1: 1	خَوْفَ اطِّلَاعِهِ
u'خَوْفٌ إفْرنْجٌ':Added, #1: 1	خَوْفُ اغْتِرَارِ
u'خَوْفٌ أكل':Added, #1: 1	خَوْفِ الْإِفْرِنْجِ
u'خَوْفٌ أَكْلٌ':Added, #1: 1	خَوْفِ أَكْلِ
u'خَوْفٌ اِمْتِهانٌ':Added, #1: 1	خَوْفِ أَكْلِ
u'خَوْفٌ أَمْرٌ':Added, #1: 1	خَوْفَ امْتِهَانِهِ
u'خَوْفٌ إِمْلاقٌ':Added, #1: 1	خَوْفَ أَمْرِ
u'خَوْفٌ أنبياء':Added, #1: 1	خَوْفُ الْإِمْلَاقِ
u'خَوْفٌ اِنْتِشارٌ':Added, #1: 1	خَوْفَ الْأَنْبِيَاءِ
u'خَوْفٌ اِنْتِظارٌ':Added, #1: 1	خَوْفِ الاِنْتِشَارِ
u'خَوْفٌ اِنْتِفاخٌ':Added, #1: 1	خَوْفَ انْتِظَارِ
u'خَوْفٌ اِنْدِراسٌ':Added, #1: 1	خَوْفَ انْتِفَاخِهِ
u'خَوْفٌ اِنْقِطاعٌ':Added, #1: 1	خَوْفَ انْدِرَاسِهِ
u'خَوْفٌ اِنْقِلابٌ':Added, #1: 1	خَوْفِ انْقِطَاعِهِ
u'خَوْفٌ إِنْكارٌ':Added, #1: 1	خَوْفُ انْقِلَابِهِ
u'خَوَّفَ أهْلٌ':Predicate, #2: 2	خَوْفَ الْإِنْكَارِ
u'خَوْفٌ أهْلٌ':Added, #1: 1	خَوَّفَ أَهْلَ
u'خَوْفٌ أهْلٌ':Added, #1: 1	خَوْفُ أَهْلِهِ
u'خَوْفٌ إِيثَارٌ':Added, #2: 2	خَوْفِ أَهْلِ
u'خَوْفٌ بَحْرٌ':Added, #1: 1	خَوْفَ إيثَارِ
u'خَوْفٌ بَحْرٌ':Added, #1: 1	خَوْفُ الْبَحْرِ
u'خَوْفٌ بَرْدٌ':Added, #1: 1	خَوْفِ الْبَحْرِ
u'خَوْفٌ بَرْدٌ':Added, #1: 1	خَوْفَ الْبَرْدِ
u'خَوْفٌ بُعْدٌ':Added, #2: 2	خَوْفِ الْبَرْدِ
u'خَوْفٌ بَقاءٌ':Added, #2: 2	خَوْفِ الْبُعْدِ
u'خَوْفٌ بَلَدٌ':Added, #1: 1	خَوْفُ بَقَاءِ
u'خَوْفٌ بَيِّنٌ':Added, #1: 1	خَوْفُ الْبَلَدِ
u'خَوْفٌ تَجْهِيزٌ':Added, #1: 1	خَوْفٍ بَيِّنٍ
u'خَوْفٌ تَحْرِيمٌ':Added, #1: 1	خَوْفُ التَّجْهِيزِ
u'خَوْفٌ تَحَلُّلٌ':Added, #1: 1	خَوْفِ التَّحْرِيمِ
u'خَوْفٌ تُخَمَةٌ':Added, #1: 1	خَوْفَ تَحَلُّلِهِ
u'خَوْفٌ تَرْكٌ':Added, #2: 2	خَوْفِ تُخَمَةٍ
u'خَوْفٌ تَعْطِيلٌ':Added, #1: 1	خَوْفِ تَرْكِ
u'خَوْفٌ تَغَيُّرٌ':Added, #1: 1	خَوْفَ تَعْطِيلِ
u'خَوْفٌ تَغَيُّرٌ':Added, #1: 1	خَوْفٍ تَغَيُّرٍ
u'خَوْفٌ تَفَاؤُلٌ':Added, #1: 1	خَوْفُ تَغَيُّرِ
u'خَوْفٌ تَفْوِيت':Added, #1: 1	خَوْفَ التَّفَاؤُلِ
u'خَوْفٌ تَقْصيرٌ':Added, #1: 1	خَوْفَ تَفْوِيتِ
u'خَوْفٌ تَقْصيرٌ':Added, #1: 1	خَوْفُ التَّقْصِيرِ
u'خَوْفٌ تَلْطيخٌ':Added, #1: 1	خَوْفِ التَّقْصِيرِ
u'خَوْفٌ تَلَفٌ':Added, #1: 1	خَوْفِ تَلْطِيخِ
u'خَوْفٌ تَلَفٌ':Added, #1: 1	خَوْفَ تَلَفِ
u'خَوْفٌ تَلَفٌ':Added, #1: 1	خَوْفَ تَلَفِهِ
u'خَوْفٌ تَلَف':Added, #2: 2	خَوْفِ تَلَفِهِ
u'خَوْفٌ تَلَف':Added, #3: 3	خَوْفِ التَّلَفِ
u'خَوْفٌ تَلَف':Added, #8: 8	خَوْفَ التَّلَفِ
u'خَوْفٌ تَلَوُّثٌ':Added, #9: 9	خَوْفُ التَّلَفِ
u'خَوْفٌ تَنَازُعٌ':Added, #1: 1	خَوْفِ التَّلَوُّثِ
u'خَوْفٌ تَنَازُعٌ':Added, #1: 1	خَوْفُ التَّنَازُعِ
u'خَوْفٌ تَنْقِيصٌ':Added, #1: 1	خَوْفَ تَنَازُعِ
u'خَوْفٌ جَبَلٌ':Added, #1: 1	خَوْفَ التَّنْقِيصِ
u'خَوْفٌ جُحُود':Added, #1: 1	خَوْفِ الْجَبَلِ
u'خَوْفٌ جِدال':Added, #1: 1	خَوْفَ جُحُودٍ
u'خَوْفٌ جَوْرٌ':Added, #1: 1	خَوْفِ الْجِدَالِ
u'خَوْفٌ حَجْرٌ':Added, #5: 5	خَوْفِ الْجَوْرِ
u'خَوْفٌ حَدَثٌ':Added, #1: 1	خَوْفِ الْحَجْرِ
u'خَوْفٌ حَرِيقٌ':Added, #1: 1	خَوْفُ حَدَثٍ
u'خَوْفٌ حُصُول':Added, #1: 1	خَوْفِ حَرِيقٍ
u'خَوْفٌ حيفٌ':Added, #1: 1	خَوْفُ حُصُولِ
u'خَوْفٌ حَيْفٌ':Added, #1: 1	خَوْفَ الْحَيْفِ
u'خَوْفٌ حيفٌ':Added, #1: 1	خَوْفَ الْحَيْفِ
u'خَوْفٌ حَيْفٌ':Added, #1: 1	خَوْفِ حَيْفٍ
u'خَوْفٌ خَائِنٌ':Added, #1: 1	خَوْفِ حَيْفٍ
u'خَوْفٌ خَرَابٌ':Added, #1: 1	خَوْفِ الْخَائِنِ
u'خَوْفٌ خُرُوجٌ':Added, #1: 1	خَوْفِ خَرَابٍ
u'خَوْفٌ خُرُوجٌ':Added, #1: 1	خَوْفُ خُرُوجِ
u'خَوْفٌ خِصَامٌ':Added, #1: 1	خَوْفِ خُرُوجِ
u'خَوْفٌ خِيَانَةٌ':Added, #1: 1	خَوْفَ خِصَامٍ
u'خَوْفٌ دُخُولٌ':Added, #1: 1	خَوْفِ الْخِيَانَةِ
u'خَوْفٌ دُخُولٌ':Added, #1: 1	خَوْفَ دُخُولِ
u'خَوْفٌ دَيْنٌ':Added, #1: 1	خَوْفِ دُخُولِ
u'خَوْفٌ ذَريعٌ':Added, #1: 1	خَوْفِ الدَّيْنِ
u'خَوْفٌ ذَريعَةٌ':Added, #1: 1	خَوْفَ الذَّرِيعَةِ
u'خَوْفٌ ذَهَابٌ':Added, #1: 1	خَوْفَ الذَّرِيعَةِ
u'خَوْفٌ رُجُوعٌ':Added, #2: 2	خَوْفِ ذَهَابِ
u'خَوْفٌ زِحامٌ':Added, #1: 1	خَوْفَ رُجُوعِ
u'خَوْفٌ زِيادَةٌ':Added, #3: 3	خَوْفَ الزِّحَامِ
u'خَوْفٌ زِيادَةٌ':Added, #1: 1	خَوْفَ الزِّيَادَةِ
u'خَوْفٌ زِيادَةٌ':Added, #1: 1	خَوْفُ الزِّيَادَةِ
u'خَوْفٌ زِيادَةٌ':Added, #1: 1	خَوْفَ زِيَادَةٍ
u'خَوْفٌ زِيادَةٌ':Added, #1: 1	خَوْفُ زِيَادَةِ
u'خَوْفٌ زِيادَةٌ':Added, #1: 1	خَوْفِ زِيَادَةٍ
u'خَوْفٌ زِيادَةٌ':Added, #1: 1	خَوْفِ زِيَادَةِ
u'خَوْفٌ سَابِقٌ':Added, #1: 1	خَوْفِ زِيَادَتِهِ
u'خَوْفٌ سَارِقٌ':Added, #1: 1	خَوْفُ السَّابِقَةِ
u'خَوْفٌ سَبْقٌ':Added, #1: 1	خَوْفِ السَّارِقِ
u'خَوْفٌ سَطْوَةٌ':Added, #1: 1	خَوْفُ سَبْقِ
u'خَوْفٌ سُقُوطٌ':Added, #1: 1	خَوْفِ سَطْوَتِهِ
u'خَوْفٌ سُقُوطٌ':Added, #1: 1	خَوْفِ السُّقُوطِ
u'خَوْفٌ سُقُوطٌ':Added, #1: 1	خَوْفِ سُقُوطِ
u'خَوْفٌ سُقُوطٌ':Added, #1: 1	خَوْفَ سُقُوطِهِ
u'خَوْفٌ سُقُوطٌ':Added, #1: 1	خَوْفُ سُقُوطِهِ
u'خَوْفٌ سَلَفٌ':Added, #2: 2	خَوْفِ سُقُوطِهِ
u'خَوْفٌ سَيْفٌ':Added, #1: 1	خَوْفُ السَّلَفِ
u'خَوْفٌ شِدَّةٌ':Added, #2: 2	خَوْفَ السَّيْفِ
u'خَوْفٌ شَمَاتَةٌ':Added, #2: 2	خَوْفَ شِدَّةِ
u'خَوْفٌ شهرة':Added, #1: 1	خَوْفَ الشَّمَاتَةِ
u'خَوْفٌ شُهْرَةٌ':Added, #1: 1	خَوْفَ الشُّهْرَةِ
u'خَوْفٌ شَهْوَةٌ':Added, #1: 1	خَوْفَ الشُّهْرَةِ
u'خَوْفٌ ضَرَرٌ':Added, #2: 2	خَوْفَ الشَّهْوَةِ
u'خَوْفٌ ضَرَرٌ':Added, #1: 1	خَوْفُ الضَّرَرِ
u'خَوْفٌ ضَرَرٌ':Added, #2: 2	خَوْفِ ضَرَرٍ
u'خَوْفٌ ضَرَرٌ':Added, #3: 3	خَوْفِ ضَرَرِهِ
u'خَوْفٌ ضلال':Added, #4: 4	خَوْفِ الضَّرَرِ
u'خَوْفٌ ضَلاَلٌ':Added, #1: 1	خَوْفُ الضَّلَالِ
u'خَوْفٌ ضَمَانٌ':Added, #1: 1	خَوْفُ الضَّلَالِ
u'خَوْفٌ ضَمَانٌ':Added, #1: 1	خَوْفَ ضَمَانِ
u'خَوْفٌ ضَيَاعٌ':Added, #1: 1	خَوْفِ ضَمَانِ
u'خَوْفٌ ضَيَاعٌ':Added, #1: 1	خَوْفُ ضَيَاعِ
u'خَوْفٌ ضَيْعَةٌ':Added, #3: 3	خَوْفِ الضَّيَاعِ
u'خَوْفٌ ضَيْعَةٌ':Added, #1: 1	خَوْفِ ضَيْعَتِهِ
u'خَوْفٌ ضَيْعَةٌ':Added, #2: 2	خَوْفَ الضَّيْعَةِ
u'خَوْفٌ طَرِيقٌ':Added, #2: 2	خَوْفِ الضَّيْعَةِ
u'خَوْفٌ طَرِيقٌ':Added, #1: 1	خَوْفُ الطَّرِيقِ
u'خَوْفٌ طَرِيقٌ':Added, #2: 2	خَوْفِ الطَّرِيقِ
u'خَوْفٌ طُلُوعٌ':Added, #3: 3	خَوْفِ طَرِيقٍ
u'خَوْفٌ طُولٌ':Added, #1: 1	خَوْفَ طُلُوعِ
u'خَوْفٌ ظالِمٌ':Added, #1: 1	خَوْفَ طُولِ
u'خَوْفٌ عَارٌ':Added, #1: 1	خَوْفِ ظَالِمٍ
u'خَوْفٌ عَامٌّ':Added, #1: 1	خَوْفَ عَارٍ
u'خَوْفٌ عُجْبٌ':Added, #1: 1	خَوْفٍ عَامٍّ
u'خَوْفٌ عجز':Added, #1: 1	خَوْفَ عُجْبٍ
u'خَوْفٌ عَجْزٌ':Added, #1: 1	خَوْفِ الْعَجْزِ
u'خَوْفٌ عَدْلٌ':Added, #1: 1	خَوْفِ الْعَجْزِ
u'خَوْفٌ عَدَمٌ':Added, #1: 1	خَوْفُ الْعَدْلِ
u'خَوْفٌ عَدَمٌ':Added, #1: 1	خَوْفَ عَدَمِ
u'خَوْفٌ عَدُوٌّ':Added, #1: 1	خَوْفِ عَدَمِ
u'خَوْفٌ عَدُوٌّ':Added, #1: 1	خَوْفُ عَدُوٍّ
u'خَوْفٌ عَدُوٌّ':Added, #1: 1	خَوْفِ عَدُوٍّ
u'خَوْفٌ عَضْب':Added, #3: 3	خَوْفِ الْعَدُوِّ
u'خَوْفٌ عَطَشٌ':Added, #1: 1	خَوْفِ عَضْبٍ
u'خَوْفٌ عَطَشٌ':Added, #1: 1	خَوْفَ الْعَطَشِ
u'خَوْفٌ عقاب':Added, #1: 1	خَوْفِ الْعَطَشِ
u'خَوْفٌ عقاب':Added, #1: 1	خَوْفَ عِقَابِ
u'خَوْفٌ عِقَابٌ':Added, #1: 1	خَوْفُ عِقَابٍ
u'خَوْفٌ عِقَابٌ':Added, #1: 1	خَوْفَ عِقَابِ
u'خَوْفٌ عقاب':Added, #1: 1	خَوْفُ عِقَابٍ
u'خَوْفٌ عِقَابٌ':Added, #2: 2	خَوْفِ الْعِقَابِ
u'خَوْفٌ عُقُوبَةٌ':Added, #2: 2	خَوْفِ الْعِقَابِ
u'خَوْفٌ عَوْرَةٌ':Added, #1: 1	خَوْفَ الْعُقُوبَةِ
u'خَوْفٌ عَيْلَةٌ':Added, #1: 1	خَوْفِ عَوْرَةِ
u'خَوْفٌ غَصْبٌ':Added, #1: 1	خَوْفَ الْعَيْلَةِ
u'خَوْفٌ غَضَاضَةٌ':Added, #1: 1	خَوْفَ غَصْبٍ
u'خَوْفٌ غِيل':Added, #1: 1	خَوْفَ غَضَاضَةٍ
u'خَوْفٌ فتنة':Added, #1: 1	خَوْفِ غِيلٍ
u'خَوْفٌ فِتْنَةٌ':Added, #10: 10	خَوْفَ الْفِتْنَةِ
u'خَوْفٌ فتنة':Added, #10: 10	خَوْفَ الْفِتْنَةِ
u'خَوْفٌ فِتْنَةٌ':Added, #1: 1	خَوْفَ فِتْنَةِ
u'خَوْفٌ فتنة':Added, #1: 1	خَوْفَ فِتْنَةِ
u'خَوْفٌ فِتْنَةٌ':Added, #21: 21	خَوْفِ الْفِتْنَةِ
u'خَوْفٌ فتنة':Added, #21: 21	خَوْفِ الْفِتْنَةِ
u'خَوْفٌ فِتْنَةٌ':Added, #2: 2	خَوْفُ فِتْنَةٍ
u'خَوْفٌ فتنة':Added, #2: 2	خَوْفُ فِتْنَةٍ
u'خَوْفٌ فِتْنَةٌ':Added, #3: 3	خَوْفُ الْفِتْنَةِ
u'خَوْفٌ فتنة':Added, #3: 3	خَوْفُ الْفِتْنَةِ
u'خَوْفٌ فِتْنَةٌ':Added, #3: 3	خَوْفِ فِتْنَةٍ
u'خَوْفٌ فِرَاقٌ':Added, #3: 3	خَوْفِ فِتْنَةٍ
u'خَوْفٌ فساد':Added, #2: 2	خَوْفَ الْفِرَاقِ
u'خَوْفٌ فساد':Added, #1: 1	خَوْفُ الْفَسَادِ
u'خَوْفٌ فَسَادٌ':Added, #1: 1	خَوْفِ الْفَسَادِ
u'خَوْفٌ فَسَادٌ':Added, #1: 1	خَوْفُ الْفَسَادِ
u'خَوْفٌ فساد':Added, #1: 1	خَوْفِ الْفَسَادِ
u'خَوْفٌ فَسَادٌ':Added, #1: 1	خَوْفِ فَسَادٍ
u'خَوْفٌ فساد':Added, #1: 1	خَوْفِ فَسَادٍ
u'خَوْفٌ فَسَادٌ':Added, #3: 3	خَوْفِ فَسَادِهِ
u'خَوْفٌ فقر':Added, #3: 3	خَوْفِ فَسَادِهِ
u'خَوْفٌ فقر':Added, #1: 1	خَوْفُ الْفَقْرِ
u'خَوْفٌ فَقْرٌ':Added, #1: 1	خَوْفِ الْفَقْرِ
u'خَوْفٌ فَقْرٌ':Added, #1: 1	خَوْفُ الْفَقْرِ
u'خَوْفٌ فَنَاءٌ':Added, #1: 1	خَوْفِ الْفَقْرِ
u'خَوْفٌ فَوَاتٌ':Added, #1: 1	خَوْفِ الْفَنَاءِ
u'خَوْفٌ فَوَاتٌ':Added, #1: 1	خَوْفَ الْفَوَاتِ
u'خَوْفٌ فَوَاتٌ':Added, #1: 1	خَوْفَ فَوَاتِ
u'خَوْفٌ فَوَاتٌ':Added, #2: 2	خَوْفُ الْفَوَاتِ
u'خَوْفٌ فَوَاتٌ':Added, #3: 3	خَوْفُ فَوَاتِ
u'خَوْفٌ فَوَاتٌ':Added, #3: 3	خَوْفِ فَوَاتِ
u'خَوْفٌ فَوْت':Added, #5: 5	خَوْفِ الْفَوَاتِ
u'خَوْفٌ فَوْت':Added, #3: 3	خَوْفَ الْفَوْتِ
u'خَوْفٌ فَوْت':Added, #6: 6	خَوْفُ الْفَوْتِ
u'خَوْفٌ قَادِرٌ':Added, #8: 8	خَوْفِ الْفَوْتِ
u'خَوْفٌ قتل':Added, #2: 2	خَوْفَ قَادِرٍ
u'خَوْفٌ قَتْلٌ':Added, #1: 1	خَوْفَ قَتْلِ
u'خَوْفٌ قتل':Added, #1: 1	خَوْفَ قَتْلِ
u'خَوْفٌ قَتْلٌ':Added, #2: 2	خَوْفَ الْقَتْلِ
u'خَوْفٌ قَطْعٌ':Added, #2: 2	خَوْفَ الْقَتْلِ
u'خَوْفٌ قَطِيعٌ':Added, #1: 1	خَوْفِ الْقَطْعِ
u'خَوْفٌ قَطِيعَةٌ':Added, #1: 1	خَوْفُ الْقَطِيعَةِ
u'خَوْفٌ كبر':Added, #1: 1	خَوْفُ الْقَطِيعَةِ
u'خَوْفٌ كِبْرٌ':Added, #1: 1	خَوْفَ الْكِبْرِ
u'خَوْفٌ كَرَاهِيَةٌ':Added, #1: 1	خَوْفَ الْكِبْرِ
u'خَوْفٌ لِصٌّ':Added, #1: 1	خَوْفُ كَرَاهِيَةِ
u'خَوْفٌ لُصُوصٌ':Added, #1: 1	خَوْفَ لِصٍّ
u'خَوْفٌ مُحَابَاةٌ':Added, #2: 2	خَوْفُ لُصُوصٍ
u'خَوْفٌ مُحَارِبٌ':Added, #1: 1	خَوْفَ الْمُحَابَاةِ
u'خَوْفٌ مَحْذُور':Added, #1: 1	خَوْفِ الْمُحَارِبِ
u'خَوْفٌ مَحْذُور':Added, #1: 1	خَوْفُ الْمَحْذُورِ
u'خَوْفٌ مَحْذُور':Added, #1: 1	خَوْفُ مَحْذُورِ
u'خَوْفٌ مَحْظُورٌ':Added, #2: 2	خَوْفِ الْمَحْذُورِ
u'خَوْفٌ مَحْمَدَةٌ':Added, #1: 1	خَوْفُ الْمَحْظُورِ
u'خَوْفٌ مَحْوٌ':Added, #2: 2	خَوْفَ الْمَحْمَدَةِ
u'خَوْفٌ مُخَالَفَةٌ':Added, #1: 1	خَوْفَ مَحْوِهِ
u'خَوْفٌ مَذَمَّةٌ':Added, #1: 1	خَوْفُ مُخَالَفَةِ
u'خَوْفٌ مَذَمَّةٌ':Added, #1: 1	خَوْفَ مَذَمَّتِهِ
u'خَوْفٌ مَرَضٌ':Added, #2: 2	خَوْفَ الْمَذَمَّةِ
u'خَوْفٌ مَرَضٌ':Added, #1: 1	خَوْفَ الْمَرَضِ
u'خَوْفٌ مَرَضٌ':Added, #1: 1	خَوْفِ الْمَرَضِ
u'خَوْفٌ مَرَضٌ':Added, #1: 1	خَوْفَ مَرَضٍ
u'خَوْفٌ مَرَضٌ':Added, #1: 1	خَوْفَ مَرَضِهِ
u'خَوْفٌ مُزَاحَمَةٌ':Added, #2: 2	خَوْفُ الْمَرَضِ
u'خَوْفٌ مَشَقَّةٌ':Added, #1: 1	خَوْفِ الْمُزَاحَمَةِ
u'خَوْفٌ مَشَقَّةٌ':Added, #1: 1	خَوْفِ الْمَشَقَّةِ
u'خَوْفٌ مَضَرَّةٌ':Added, #3: 3	خَوْفُ الْمَشَقَّةِ
u'خَوْفٌ مُفْسِدٌ':Added, #1: 1	خَوْفَ مَضَرَّةٍ
u'خَوْفٌ مُكْرَهٌ':Added, #1: 1	خَوْفِ الْمُفْسِدِ
u'خَوْفٌ مُكْرِهٌ':Added, #1: 1	خَوْفِ الْمُكْرَهِ
u'خَوْفٌ مُكْرَهٌ':Added, #1: 1	خَوْفِ الْمُكْرِهِ
u'خَوْفٌ مُنْفَرِدٌ':Added, #2: 2	خَوْفُ الْمُكْرَهِ
u'خَوْفٌ مُنْكِرٌ':Added, #1: 1	خَوْفُ الْمُنْفَرِدِ
u'خَوْفٌ مَوْتٌ':Added, #1: 1	خَوْفِ الْمُنْكِرِ
u'خَوْفٌ مَوْتٌ':Added, #1: 1	خَوْفُ الْمَوْتِ
u'خَوْفٌ مَوْتٌ':Added, #1: 1	خَوْفَ مَوْتٍ
u'خَوْفٌ مَوْتٌ':Added, #2: 2	خَوْفَ الْمَوْتِ
u'خَوْفٌ مَوْتٌ':Added, #2: 2	خَوْفِ الْمَوْتِ
u'خَوْفٌ مَوْضِعٌ':Added, #2: 2	خَوْفَ مَوْتِهِ
u'خَوْفٌ ميل':Added, #1: 1	خَوْفُ مَوْضِعِهِ
u'خَوْفٌ مَيْلٌ':Added, #1: 1	خَوْفَ الْمَيْلِ
u'خَوْفٌ نَاسٌ':Added, #1: 1	خَوْفَ الْمَيْلِ
u'خَوْفٌ نَجَاسَةٌ':Added, #1: 1	خَوْفَ النَّاسِ
u'خَوْفٌ نَدَمٌ':Added, #2: 2	خَوْفَ نَجَاسَةٍ
u'خَوْفٌ نُزُولٌ':Added, #2: 2	خَوْفِ النَّدَمِ
u'خَوْفٌ نِسْيَانٌ':Added, #1: 1	خَوْفِ نُزُولِ
u'خَوْفٌ نُشُوزٌ':Added, #2: 2	خَوْفَ النِّسْيَانِ
u'خَوْفٌ نُشُوزٌ':Added, #1: 1	خَوْفَ النُّشُوزِ
u'خَوْفٌ نعاس':Added, #2: 2	خَوْفِ النُّشُوزِ
u'خَوْفٌ نُعَاسٌ':Added, #1: 1	خَوْفِ نُعَاسٍ
u'خَوْفٌ نَفْسٌ':Added, #1: 1	خَوْفِ نُعَاسٍ
u'خَوْفٌ نَقْصٌ':Added, #1: 1	خَوْفَ النَّفْسِ
u'خَوْفٌ نَقْضٌ':Added, #1: 1	خَوْفُ نَقْصِهِ
u'خَوْفٌ هِرٌّ':Added, #1: 1	خَوْفَ نَقْضِ
u'خَوْفٌ هلاك':Added, #1: 1	خَوْفِ الْهِرَّةِ
u'خَوْفٌ هلاك':Added, #1: 1	خَوْفُ هَلَاكِهِ
u'خَوْفٌ هَلاَكٌ':Added, #1: 1	خَوْفِ هَلَاكِهِ
u'خَوْفٌ هَلاَكٌ':Added, #1: 1	خَوْفُ هَلَاكِهِ
u'خَوْفٌ هلاك':Added, #1: 1	خَوْفِ هَلَاكِهِ
u'خَوْفٌ هَلاَكٌ':Added, #2: 2	خَوْفُ هَلَاكٍ
u'خَوْفٌ هلاك':Added, #2: 2	خَوْفُ هَلَاكٍ
u'خَوْفٌ هَلاَكٌ':Added, #4: 4	خَوْفَ الْهَلَاكِ
u'خَوْفٌ هلاك':Added, #4: 4	خَوْفَ الْهَلَاكِ
u'خَوْفٌ هَلاَكٌ':Added, #4: 4	خَوْفِ هَلَاكِ
u'خَوْفٌ هلاك':Added, #4: 4	خَوْفِ هَلَاكِ
u'خَوْفٌ هَلاَكٌ':Added, #7: 7	خَوْفُ الْهَلَاكِ
u'خَوْفٌ هلاك':Added, #7: 7	خَوْفُ الْهَلَاكِ
u'خَوْفٌ هَلاَكٌ':Added, #8: 8	خَوْفِ الْهَلَاكِ
u'خَوْفٌ هَوَامٌّ':Added, #8: 8	خَوْفِ الْهَلَاكِ
u'خَوْفٌ وُصُولٌ':Added, #1: 1	خَوْفَ الْهَوَامِّ
u'خَوْفٌ وَطْءٌ':Added, #1: 1	خَوْفَ الْوُصُولِ
u'خَوْفٌ وَعِيدٌ':Added, #1: 1	خَوْفَ الْوَطْءِ
u'خَوْفٌ وَعِيدٌ':Added, #1: 1	خَوْفَ الْوَعِيدِ
u'خَوْفٌ وَقْتٌ':Added, #2: 2	خَوْفِ الْوَعِيدِ
u'خَوْفٌ وَقْتٌ':Added, #1: 1	خَوْفَ الْوَقْتِ
u'خَوْفٌ وُقُوعٌ':Added, #1: 1	خَوْفِ الْوَقْتِ
u'خَوْفٌ وُقُوعٌ':Added, #1: 1	خَوْفَ الْوُقُوعِ
u'خَوْفٌ وُقُوعٌ':Added, #1: 1	خَوْفُ الْوُقُوعِ
u'خَوْفٌ وُقُوعٌ':Added, #1: 1	خَوْفَ وُقُوعِ
u'خَوْفٌ وُقُوعٌ':Added, #1: 1	خَوْفِ وُقُوعِ
u'خَوْفٌ وُقُوعٌ':Added, #2: 2	خَوْفِ الْوُقُوعِ
u'خَوْفٌ وُلاَةٌ':Added, #3: 3	خَوْفِ وُقُوعِهِ
u'خِيَامٌ تُجَّارٌ':Added, #1: 1	خَوْفِ الْوُلَاةِ
u'خِيَامٌ حَيٌّ':Added, #1: 1	خِيَامِ التّجّارِ
u'خِيَامٌ حَيٌّ':Added, #1: 1	خِيَامَ الْحَيِّ
u'خِيَامٌ قَوْمٌ':Added, #1: 1	خِيَامِ حَيٍّ
u'خِيَانَةٌ أحَدٌ':Added, #1: 1	خِيَامَ قَوْمِهِ
u'خِيَانَةٌ أمَانٌ':Added, #1: 1	خِيَانَةُ أَحَدِ
u'خِيَانَةٌ أمَانَةٌ':Added, #1: 1	خِيَانَةُ الْأَمَانَاتِ
u'خِيَانَةٌ أَوَّلُ':Added, #1: 1	خِيَانَةُ الْأَمَانَاتِ
u'خِيَانَةٌ دارِيّ':Added, #1: 1	خِيَانَةِ الْأَوَّلِ
u'خِيَانَةٌ سَيِّدٌ':Added, #1: 1	خِيَانَةِ الدَّارِيَّيْنِ
u'خِيَانَةٌ عَامِلٌ':Added, #1: 1	خِيَانَةِ السَّيِّدِ
u'خِيَانَةٌ غَنِيمَةٌ':Added, #2: 2	خِيَانَةَ الْعَامِلِ
u'خِيَانَةٌ مَالٌ':Added, #1: 1	خِيَانَةُ الْغَنِيمَةِ
u'خِيَانَةٌ مَغْنَمٌ':Added, #1: 1	خِيَانَةُ الْمَالِ
u'خِيَانَةٌ نَفْسٌ':Added, #2: 2	خِيَانَةُ الْمَغْنَمِ
u'خِيَانَةٌ وَكِيلٌ':Added, #3: 3	خِيَانَةَ نَفْسِهِ
u'خَيْبَةٌ دَهْرٌ':Added, #1: 1	خِيَانَةِ الْوَكِيلِ
u'خَيَّرَ إمَامٌ':Predicate, #5: 5	خَيْبَةَ الدَّهْرِ
u'خَيَّرَ بَيْنٌ':Predicate, #1: 1	خَيَّرَ الْإِمَامَ
u'خِيرَةٌ أسْبَابٌ':Added, #1: 1	خَيَّرَ بَيْنَ
u'خِيرَةٌ أَسْبَابٌ':Added, #1: 1	خِيرَةِ أَسْبَابِهِ
u'خِيرَةٌ إِعْتاقٌ':Added, #1: 1	خِيرَةِ أَسْبَابِهِ
u'خِيرَةٌ أَمْوَالٌ':Added, #1: 1	خِيرَةُ الْإِعْتَاقِ
u'خِيرَةٌ ضَمَانٌ':Added, #1: 1	خِيرَةُ الْأَمْوَالِ
u'خِيرَةٌ مَالِكٌ':Added, #2: 2	خِيرَةُ الضَّمَانِ
u'خِيرَةٌ مُتَعَبِّدٌ':Added, #1: 1	خِيرَةِ مَالِكِهِ
u'خِيرَةٌ نِساءٌ':Added, #1: 1	خِيرَةِ الْمُتَعَبِّدِ
u'خَيَّرَ دُورٌ':Predicate, #1: 1	خِيرَةُ النِّسَاءِ
u'خَيَّرَ رَجُلٌ':Subject, #1: 1	خَيَّرَ دُورَ
u'خَيَّرَ رَسُولٌ':Subject, #4: 4	خَيَّرَ الرَّجُلُ
u'خَيَّرَ صَاحِبٌ':Predicate, #5: 5	خَيَّرَ رَسُولُ
u'خَيَّرَ عند':Predicate, #1: 1	خَيَّرَ صَاحِبَ
u'خَيَّرَ غَرِيمٌ':Predicate, #1: 1	خَيَّرَ عِنْدَ
u'خَيَّرَ كُفَّارٌ':Subject, #1: 1	خَيَّرَ الْغَرِيمَ
u'خَيَّرَ مُصَنِّفٌ':Subject, #1: 1	خَيَّرَ الْكُفَّارُ
u'خَيَّرَ مُفْطِر':Predicate, #1: 1	خَيَّرَ الْمُصَنِّفُ
u'خَيَّرَ مَفْقُودٌ':Predicate, #1: 1	خَيَّرَ الْمُفْطِرَ
u'خَيَّرَ وَصِيٌّ':Predicate, #2: 2	خَيَّرَ الْمَفْقُودَ
u'خَيَّطَ بَيْنٌ':Predicate, #1: 1	خَيَّرَ الْوَصِيَّ
u'خِيفَةٌ أخْذٌ':Added, #1: 1	خَيَّطَ بَيْنَ
u'خِيفَةٌ اِعْتِقادٌ':Added, #1: 1	خِيفَةَ أَخْذِ
u'خِيفَةٌ اِعْتِقادٌ':Added, #1: 1	خِيفَةَ اعْتِقَادِ
u'خِيفَةٌ اِنْتِزاعٌ':Added, #1: 1	خِيفَةِ اعْتِقَادِ
u'خِيفَةٌ تَرْكٌ':Added, #1: 1	خِيفَةَ انْتِزَاعِ
u'خِيفَةٌ تَغْرِير':Added, #1: 1	خِيفَةَ تَرْكِ
u'خِيفَةٌ خُرُوجٌ':Added, #4: 4	خِيفَةَ التَّغْرِيرِ
u'خِيفَةٌ رقباء':Added, #1: 1	خِيفَةَ خُرُوجِ
u'خِيفَةٌ ضَيْعَةٌ':Added, #1: 1	خِيفَةَ الرُّقَبَاءِ
u'خِيفَةٌ ضَيْعَةٌ':Added, #1: 1	خِيفَةَ الضَّيْعَةِ
u'خِيفَةٌ عجز':Added, #1: 1	خِيفَةِ الضَّيْعَةِ
u'خِيفَةٌ عَجْزٌ':Added, #1: 1	خِيفَةُ عَجْزِهِ
u'خِيفَةٌ غَرَامَةٌ':Added, #1: 1	خِيفَةُ عَجْزِهِ
u'خِيفَةٌ فُجُورٌ':Added, #1: 1	خِيفَةَ الْغَرَامَةِ
u'خِيفَةٌ فَوَاتٌ':Added, #2: 2	خِيفَةُ الْفُجُورِ
u'خِيفَةٌ فَوْت':Added, #2: 2	خِيفَةَ الْفَوَاتِ
u'خِيفَةٌ قتل':Added, #1: 1	خِيفَةَ الْفَوْتِ
u'خِيفَةٌ قَتْلٌ':Added, #1: 1	خِيفَةَ الْقَتْلِ
u'خِيفَةٌ قتل':Added, #1: 1	خِيفَةَ الْقَتْلِ
u'خِيفَةٌ قَتْلٌ':Added, #1: 1	خِيفَةَ قَتْلِ
u'خِيفَةٌ قَوْمٌ':Added, #1: 1	خِيفَةَ قَتْلِ
u'خِيفَةٌ كَوْنٌ':Added, #1: 1	خِيفَةِ الْقَوْمِ
u'خِيفَةٌ هلاك':Added, #1: 1	خِيفَةُ كَوْنِ
u'خِيفَةٌ هَلاَكٌ':Added, #1: 1	خِيفَةَ الْهَلَاكِ
u'خَيْلٌ اِبْنٌ':Added, #1: 1	خِيفَةَ الْهَلَاكِ
u'خَيْلٌ أنصار':Added, #3: 3	خَيْلُ ابْنِ
u'خَيْلٌ أَنْصارٌ':Added, #1: 1	خَيْلِ الْأَنْصَارِ
u'خَيْلٌ أَنْصَارٌ':Added, #1: 1	خَيْلِ الْأَنْصَارِ
u'خَيْلٌ بَدْرٌ':Added, #1: 1	خَيْلِ الْأَنْصَارِ
u'خَيْلٌ بلق':Added, #1: 1	خَيْلُ بَدْرٍ
u'خَيْلٌ جَمَاعَةٌ':Added, #3: 3	خَيْلٍ بُلْقٍ
u'خَيْلٌ جُنْدِيٌّ':Added, #1: 1	خَيْلِ جَمَاعَةٍ
u'خَيْلٌ جهاد':Added, #1: 1	خَيْلَ الْجُنْدِيِّ
u'خَيْلٌ جِهَادٌ':Added, #1: 1	خَيْلُ الْجِهَادِ
u'خَيْلٌ جهاد':Added, #1: 1	خَيْلُ الْجِهَادِ
u'خَيْلٌ جِهَادٌ':Added, #2: 2	خَيْلِ الْجِهَادِ
u'خَيْلٌ جَيْشٌ':Added, #2: 2	خَيْلِ الْجِهَادِ
u'خَيْلٌ خَالِدٌ':Added, #1: 1	خَيْلِ الْجَيْشِ
u'خَيْلٌ دهم':Added, #4: 4	خَيْلِ خَالِدِ
u'خَيْلٌ دُهْمٌ':Added, #3: 3	خَيْلٍ دُهْمٍ
u'خَيْلٌ رَسُولٌ':Added, #3: 3	خَيْلٍ دُهْمٍ
u'خَيْلٌ رَسُولٌ':Added, #1: 1	خَيْلِ الرّسُولِ
u'خَيْلٌ رَسُولٌ':Added, #1: 1	خَيْلِ رَسُولِ
u'خَيْلٌ سباق':Added, #7: 7	خَيْلُ رَسُولِ
u'خَيْلٌ سِبَاقٌ':Added, #1: 1	خَيْلَ السِّبَاقِ
u'خَيْلٌ شمس':Added, #1: 1	خَيْلَ السِّبَاقِ
u'خَيْلٌ شَمْسٌ':Added, #1: 1	خَيْلِ الشُّمُسِ
u'خَيَّلَ شَيْطَانٌ':Subject, #1: 1	خَيْلِ شَمْسٍ
u'خَيْلٌ عجم':Added, #1: 1	خَيَّلَ الشَّيْطَانُ
u'خَيْلٌ عَجَمٌ':Added, #1: 1	خَيْلُ الْعَجَمِ
u'خَيْلٌ عَدُوٌّ':Added, #1: 1	خَيْلُ الْعَجَمِ
u'خَيْلٌ عَدُوٌّ':Added, #1: 1	خَيْلُ الْعَدُوِّ
u'خَيْلٌ عَرَبٌ':Added, #1: 1	خَيْلِ الْعَدُوِّ
u'خَيْلٌ قُرَيْشٌ':Added, #1: 1	خَيْلِ الْعَرَبِ
u'خَيْلٌ كَلاَمٌ':Added, #1: 1	خَيْلُ قُرَيْشٍ
u'خَيْلٌ لاَتٌ':Added, #1: 1	خَيْلُ الْكَلَامِ
u'خَيْلٌ مُحَمَّدٌ':Added, #2: 2	خَيْلَ اللّاتِ
u'خَيْلٌ مُحَمَّدٌ':Added, #1: 1	خَيْلَ مُحَمّدِ
u'خُيُولٌ رِجَالٌ':Added, #1: 1	خَيْلُ مُحَمّدٍ
u'خُيُولٌ نَاسٌ':Added, #1: 1	خُيُولِ رِجَالٍ
u'خُيُولٌ نَاسٌ':Added, #1: 1	خُيُولُ النّاسِ
u'دَاءٌ اِبْنٌ':Added, #1: 1	خُيُولُ النَّاسِ
u'دَاءٌ أُجْرَةٌ':Added, #1: 1	أَدَاءِ ابْنِهِ
u'دَاءٌ أُجْرَةٌ':Added, #1: 1	أَدَاءُ الْأُجْرَةِ
u'دَاءٌ أحَدٌ':Added, #1: 1	أَدَاءِ الْأُجْرَةِ
u'دَاءٌ أَحْكَامٌ':Added, #1: 1	أَدَاءُ أَحَدِ
u'دَاءٌ أخْرِجَةٌ':Added, #1: 1	أَدَاءِ الْأَحْكَامِ
u'دَاءٌ أَرْبَعَةٌ':Added, #1: 1	أَدَاءِ الْأَخْرِجَةِ
u'دَاءٌ أَرْكانٌ':Added, #1: 1	أَدَاءِ أَرْبَعَةِ
u'دَاءٌ أَرْكَانٌ':Added, #1: 1	أَدَاءُ الْأَرْكَانِ
u'دَاءٌ أَرْكانٌ':Added, #1: 1	أَدَاءُ الْأَرْكَانِ
u'دَاءٌ أَرْكَانٌ':Added, #3: 3	أَدَاءِ أَرْكَانِهِ
u'دَاءٌ أَرْكانٌ':Added, #3: 3	أَدَاءِ أَرْكَانِهِ
u'دَاءٌ أَرْكانٌ':Added, #3: 3	أَدَاءَ الْأَرْكَانِ
u'دَاءٌ أَرْكَانٌ':Added, #3: 3	أَدَاءِ الْأَرْكَانِ
u'دَاءٌ أَرْكَانٌ':Added, #3: 3	أَدَاءَ الْأَرْكَانِ
u'دَاءٌ أُسْبُوعٌ':Added, #3: 3	أَدَاءِ الْأَرْكَانِ
u'دَاءٌ أَشْهُرٌ':Added, #1: 1	أَدَاءِ أُسْبُوعٍ
u'دَاءٌ أَصْحَابٌ':Added, #1: 1	أَدَاءِ أَشْهُرِ
u'دَاءٌ أصل':Added, #1: 1	أَدَاءِ أَصْحَابِ
u'دَاءٌ أًصْلٌ':Added, #1: 1	أَدَاءِ أَصْلِ
u'دَاءٌ أصل':Added, #1: 1	أَدَاءِ أَصْلِ
u'دَاءٌ أصل':Added, #1: 1	أَدَاءُ الْأَصْلِ
u'دَاءٌ أًصْلٌ':Added, #1: 1	أَدَاءِ الْأَصْلِ
u'دَاءٌ أًصْلٌ':Added, #1: 1	أَدَاءُ الْأَصْلِ
u'دَاءٌ أعْظَمُ':Added, #1: 1	أَدَاءِ الْأَصْلِ
u'دَاءٌ أَعْمَالٌ':Added, #1: 1	أَدَاءُ أَعْظَمِ
u'دَاءٌ أَعْمَالٌ':Added, #12: 12	أَدَاءِ الْأَعْمَالِ
u'دَاءٌ أَعْمَالٌ':Added, #1: 1	أَدَاءُ الْأَعْمَالِ
u'دَاءٌ أَفْعَالٌ':Added, #2: 2	أَدَاءُ أَعْمَالِ
u'دَاءٌ أَفْعَالٌ':Added, #12: 12	أَدَاءُ الْأَفْعَالِ
u'دَاءٌ أَفْعَالٌ':Added, #13: 13	أَدَاءِ الْأَفْعَالِ
u'دَاءٌ أَفْعَالٌ':Added, #1: 1	أَدَاءَ أَفْعَالٍ
u'دَاءٌ أَفْعَالٌ':Added, #2: 2	أَدَاءُ أَفْعَالِ
u'دَاءٌ أَفْعَالٌ':Added, #2: 2	أَدَاءِ أَفْعَالِ
u'دَاءٌ أقْصَرُ':Added, #2: 2	أَدَاءَ الْأَفْعَالِ
u'دَاءٌ أقَلُّ':Added, #1: 1	أَدَاءِ أَقْصَرِ
u'دَاءٌ أَكْثَرُ':Added, #1: 1	أَدَاءِ الْأَقَلِّ
u'دَاءٌ أَكْثَرُ':Added, #1: 1	أَدَاءَ أَكْثَرِ
u'دَاءٌ أَكْثَرُ':Added, #1: 1	أَدَاءِ أَكْثَرِ
u'دَاءٌ أَكْثَرُ':Added, #2: 2	أَدَاءُ أَكْثَرِ
u'دَاءٌ أَكْمَلُ':Added, #3: 3	أَدَاءِ الْأَكْثَرِ
u'دَاءٌ ألف':Added, #1: 1	أَدَاءِ الْأَكْمَلِ
u'دَاءٌ ألْفٌ':Added, #1: 1	أَدَاءَ الْأَلْفِ
u'دَاءٌ أَلْفٌ':Added, #1: 1	أَدَاءَ الْأَلْفِ
u'دَاءٌ ألْفٌ':Added, #1: 1	أَدَاءَ الْأَلْفِ
u'دَاءٌ أَلْفٌ':Added, #1: 1	أَدَاءِ أَلْفٍ
u'دَاءٌ ألف':Added, #1: 1	أَدَاءِ أَلْفٍ
u'دَاءٌ ألْفٌ':Added, #8: 8	أَدَاءِ الْأَلْفِ
u'دَاءٌ أَلْفٌ':Added, #8: 8	أَدَاءِ الْأَلْفِ
u'دَاءٌ أَلْفَاظٌ':Added, #8: 8	أَدَاءِ الْأَلْفِ
u'دَاءٌ إمَامٌ':Added, #1: 1	أَدَاءِ الْأَلْفَاظِ
u'دَاءٌ أمَانٌ':Added, #1: 1	أَدَاءِ الْإِمَامِ
u'دَاءٌ أمَانٌ':Added, #1: 1	أَدَاءِ الأَمَانَاتِ
u'دَاءٌ أمَانَةٌ':Added, #2: 2	أَدَاءِ الْأَمَانَاتِ
u'دَاءٌ أمَانَةٌ':Added, #1: 1	أَدَاءِ الأَمَانَاتِ
u'دَاءٌ أمَانَةٌ':Added, #1: 1	أَدَاءَ الْأَمَانَةِ
u'دَاءٌ أمَانَةٌ':Added, #1: 1	أَدَاءُ أَمَانَةٍ
u'دَاءٌ أمَانَةٌ':Added, #2: 2	أَدَاءِ الْأَمَانَاتِ
u'دَاءٌ أمَانَةٌ':Added, #2: 2	أَدَاءُ الْأَمَانَةِ
u'دَاءٌ آمِرٌ':Added, #6: 6	أَدَاءِ الْأَمَانَةِ
u'دَاءٌ إِمْكانٌ':Added, #1: 1	أَدَاءِ الْآمِرِ
u'دَاءٌ أوامر':Added, #1: 1	أَدَاءِ إمْكَانِ
u'دَاءٌ أَوامِرُ':Added, #1: 1	أَدَاءِ أَوَامِرِ
u'دَاءٌ أَوَّلُ':Added, #1: 1	أَدَاءِ أَوَامِرِ
u'دَاءٌ أَيْمَانٌ':Added, #3: 3	أَدَاءِ الْأَوَّلِ
u'دَاءٌ إيمَانٌ':Added, #1: 1	أَدَاءِ الْأَيْمَانِ
u'دَاءٌ إيمَانٌ':Added, #1: 1	أَدَاءُ الْإِيمَانِ
u'دَاءٌ بَدَلٌ':Added, #1: 1	أَدَاءِ الْإِيمَانِ
u'دَاءٌ بَدَلٌ':Added, #1: 1	أَدَاءَ الْبَدَلِ
u'دَاءٌ بَدَلٌ':Added, #1: 1	أَدَاءُ بَدَلِ
u'دَاءٌ بَدَلٌ':Added, #26: 26	أَدَاءِ الْبَدَلِ
u'دَاءٌ بَدَلٌ':Added, #27: 27	أَدَاءِ بَدَلِ
u'دَاءٌ بَعْضٌ':Added, #8: 8	أَدَاءُ الْبَدَلِ
u'دَاءٌ بَعْضٌ':Added, #1: 1	أَدَاءَ الْبَعْضِ
u'دَاءٌ بَعْضٌ':Added, #1: 1	أَدَاءِ بَعْضِ
u'دَاءٌ بَعْضٌ':Added, #1: 1	أَدَاءِ بَعْضِهِ
u'دَاءٌ بَعْضٌ':Added, #2: 2	أَدَاءِ الْبَعْضِ
u'دَاءٌ بَعيرٌ':Added, #2: 2	أَدَاءَ بَعْضِ
u'دَاءٌ بَقِيَّةٌ':Added, #1: 1	أَدَاءِ الْبَعِيرِ
u'دَاءٌ بَقِيَّةٌ':Added, #1: 1	أَدَاءُ بَقِيَّةِ
u'دَاءٌ تَرَاوِيحُ':Added, #1: 1	أَدَاءِ بَقِيَّةِ
u'دَاءٌ تَرَاوِيحُ':Added, #1: 1	أَدَاءَ التَّرَاوِيحِ
u'دَاءٌ تَرَاوِيحُ':Added, #1: 1	أَدَاءِ التَّرَاوِيحِ
u'دَاءٌ تَطَوُّعٌ':Added, #2: 2	أَدَاءُ التَّرَاوِيحِ
u'دَاءٌ تَطَوُّعٌ':Added, #1: 1	أَدَاءِ التَّطَوُّعِ
u'دَاءٌ تَطَوُّعٌ':Added, #2: 2	أَدَاءَ التَّطَوُّعِ
u'دَاءٌ تَمْييزٌ':Added, #2: 2	أَدَاءُ التَّطَوُّعِ
u'دَاءٌ ثَانِي':Added, #1: 1	أَدَاءِ التَّمْيِيزِ
u'دَاءٌ ثَانِيَةٌ':Added, #1: 1	أَدَاءُ الثَّانِيَةِ
u'دَاءٌ ثَلاثَةٌ':Added, #1: 1	أَدَاءُ الثَّانِيَةِ
u'دَاءٌ ثَمَنٌ':Added, #1: 1	أَدَاءِ ثَلَاثَةِ
u'دَاءٌ ثَمَنٌ':Added, #21: 21	أَدَاءِ الثَّمَنِ
u'دَاءٌ ثَمَنٌ':Added, #2: 2	أَدَاءُ الثَّمَنِ
u'دَاءٌ ثَمَنٌ':Added, #2: 2	أَدَاءُ ثَمَنٍ
u'دَاءٌ ثَوْبٌ':Added, #3: 3	أَدَاءَ الثَّمَنِ
u'دَاءٌ جُزْءٌ':Added, #1: 1	أَدَاءِ ثَوْبٍ
u'دَاءٌ جُزْءٌ':Added, #1: 1	أَدَاءَ جُزْءٍ
u'دَاءٌ جَزَاءٌ':Added, #2: 2	أَدَاءُ جُزْءٍ
u'دَاءٌ جَزَاءٌ':Added, #1: 1	أَدَاءَ الْجَزَاءِ
u'دَاءٌ جَزَاءٌ':Added, #2: 2	أَدَاءِ جَزَاءِ
u'دَاءٌ جِزْيَةٌ':Added, #6: 6	أَدَاءِ الْجَزَاءِ
u'دَاءٌ جِزْيَةٌ':Added, #19: 19	أَدَاءِ الْجِزْيَةِ
u'دَاءٌ جِزْيَةٌ':Added, #1: 1	أَدَاءَ الْجِزْيَةِ
u'دَاءٌ جِزْيَةٌ':Added, #1: 1	أَدَاءِ جِزْيَةٍ
u'دَاءٌ جمعة':Added, #1: 1	أَدَاءِ جِزْيَتِهِ
u'دَاءٌ جمعة':Added, #2: 2	أَدَاءَ الْجُمُعَةِ
u'دَاءٌ جُمُعَةٌ':Added, #2: 2	أَدَاءُ الْجُمُعَةِ
u'دَاءٌ جُمُعَةٌ':Added, #2: 2	أَدَاءَ الْجُمُعَةِ
u'دَاءٌ جمعة':Added, #2: 2	أَدَاءُ الْجُمُعَةِ
u'دَاءٌ جُمُعَةٌ':Added, #9: 9	أَدَاءِ الْجُمُعَةِ
u'دَاءٌ حاضِرٌ':Added, #9: 9	أَدَاءِ الْجُمُعَةِ
u'دَاءٌ حاضِرٌ':Added, #1: 1	أَدَاءِ الْحَاضِرَةِ
u'دَاءٌ حَجٌّ':Added, #2: 2	أَدَاءِ الْحَاضِرِ
u'دَاءٌ حَجٌّ':Added, #12: 12	أَدَاءُ الْحَجِّ
u'دَاءٌ حَجّ':Added, #14: 14	أَدَاءِ الْحَجِّ
u'دَاءٌ حَجٌّ':Added, #2: 2	أَدَاءُ حَجَّتَيْنِ
u'دَاءٌ حَدٌّ':Added, #3: 3	أَدَاءَ الْحَجِّ
u'دَاءٌ حُروفٌ':Added, #1: 1	أَدَاءُ الْحَدِّ
u'دَاءٌ حِصَّةٌ':Added, #2: 2	أَدَاءِ الْحُرُوفِ
u'دَاءٌ حَقٌّ':Added, #1: 1	أَدَاءُ حِصَّتِهِ
u'دَاءٌ حَقٌّ':Added, #1: 1	أَدَاءَ الْحَقِّ
u'دَاءٌ حَقٌّ':Added, #1: 1	أَدَاءِ حَقِّ
u'دَاءٌ حَقٌّ':Added, #1: 1	أَدَاءُ حَقِّهِ
u'دَاءٌ حَقٌّ':Added, #1: 1	أَدَاءِ حَقّهِ
u'دَاءٌ حَقٌّ':Added, #1: 1	أَدَاءِ حَقِّهِ
u'دَاءٌ حَقٌّ':Added, #2: 2	أَدَاءَ حَقِّهِ
u'دَاءٌ حَقٌّ':Added, #3: 3	أَدَاءُ الْحَقِّ
u'دَاءٌ حَقٌّ':Added, #3: 3	أَدَاءِ حَقٍّ
u'دَاءٌ حُقوقٌ':Added, #9: 9	أَدَاءِ الْحَقِّ
u'دَاءٌ حُقُوقٌ':Added, #1: 1	أَدَاءُ الْحُقُوقِ
u'دَاءٌ حُقوقٌ':Added, #1: 1	أَدَاءُ الْحُقُوقِ
u'دَاءٌ حُقوقٌ':Added, #1: 1	أَدَاءُ حُقُوقِهِ
u'دَاءٌ حُقُوقٌ':Added, #1: 1	أَدَاءِ حُقُوقِهِ
u'دَاءٌ حُقُوقٌ':Added, #1: 1	أَدَاءُ حُقُوقِهِ
u'دَاءٌ حُقوقٌ':Added, #1: 1	أَدَاءِ حُقُوقِهِ
u'دَاءٌ حُقوقٌ':Added, #2: 2	أَدَاءُ حُقُوقِ
u'دَاءٌ حُقُوقٌ':Added, #2: 2	أَدَاءِ حُقُوقِ
u'دَاءٌ حُقُوقٌ':Added, #2: 2	أَدَاءُ حُقُوقِ
u'دَاءٌ حُقوقٌ':Added, #2: 2	أَدَاءِ حُقُوقِ
u'دَاءٌ حُقُوقٌ':Added, #6: 6	أَدَاءِ الْحُقُوقِ
u'دَاءٌ حَمْلٌ':Added, #6: 6	أَدَاءِ الْحُقُوقِ
u'دَاءٌ حِنْطَةٌ':Added, #1: 1	أَدَاءِ حَمْلِهِ
u'دَاءٌ حِنْطَةٌ':Added, #1: 1	أَدَاءُ الْحِنْطَةِ
u'دَاءٌ خدمة':Added, #1: 1	أَدَاءِ الْحِنْطَةِ
u'دَاءٌ خِدْمَةٌ':Added, #1: 1	أَدَاءَ خِدْمَةٍ
u'دَاءٌ خراج':Added, #1: 1	أَدَاءَ خِدْمَةٍ
u'دَاءٌ خَرَاجٌ':Added, #2: 2	أَدَاءَ الْخَرَاجِ
u'دَاءٌ خَلَفٌ':Added, #2: 2	أَدَاءَ الْخَرَاجِ
u'دَاءٌ خَلْفٌ':Added, #1: 1	أَدَاءُ خَلَفِهِ
u'دَاءٌ خَلِيفَةٌ':Added, #1: 1	أَدَاءُ خَلْفِهِ
u'دَاءٌ خَمْرٌ':Added, #1: 1	أَدَاءُ الْخَلِيفَةِ
u'دَاءٌ خُمُسٌ':Added, #1: 1	أَدَاءِ الْخَمْرِ
u'دَاءٌ خَمْسَةٌ':Added, #1: 1	أَدَاءَ الْخُمُسِ
u'دَاءٌ دَرَاهِمُ':Added, #1: 1	أَدَاءَ الْخَمْسَةِ
u'دَاءٌ دِرْهَمٌ':Added, #1: 1	أَدَاءُ الدَّرَاهِمِ
u'دَاءٌ دِرْهَم':Added, #1: 1	أَدَاءُ دِرْهَمٍ
u'دَاءٌ دِرْهَمٌ':Added, #1: 1	أَدَاءُ دِرْهَمٍ
u'دَاءٌ دِرْهَم':Added, #1: 1	أَدَاءُ دِرْهَمَيْنِ
u'دَاءٌ دَقيقٌ':Added, #1: 1	أَدَاءُ دِرْهَمَيْنِ
u'دَاءٌ دَقيقٌ':Added, #1: 1	أَدَاءُ الدَّقِيقِ
u'دَاءٌ دَنانيرُ':Added, #1: 1	أَدَاءِ الدَّقِيقِ
u'دَاءٌ دَنانيرُ':Added, #1: 1	أَدَاءُ الدَّنَانِيرِ
u'دَاءٌ دِيَةٌ':Added, #1: 1	أَدَاءِ الدَّنَانِيرِ
u'دَاءٌ دَيْنٌ':Added, #1: 1	أَدَاءِ الدِّيَةِ
u'دَاءٌ دَيْنٌ':Added, #10: 10	أَدَاءِ الدَّيْنِ
u'دَاءٌ دَيْنٌ':Added, #2: 2	أَدَاءُ دَيْنِ
u'دَاءٌ دَيْنٌ':Added, #4: 4	أَدَاءَ الدَّيْنِ
u'دَاءٌ دَيْنٌ':Added, #5: 5	أَدَاءُ الدَّيْنِ
u'دَاءٌ دِينارٌ':Added, #7: 7	أَدَاءِ دَيْنِهِ
u'دَاءٌ دِينارٌ':Added, #1: 1	أَدَاءُ الدِّينَارِ
u'دَاءٌ دُيونٌ':Added, #1: 1	أَدَاءِ الدِّينَارِ
u'دَاءٌ دُيونٌ':Added, #1: 1	أَدَاءَ الدُّيُونِ
u'دَاءٌ دُيونٌ':Added, #1: 1	أَدَاءُ الدُّيُونِ
u'دَاءٌ دُيونٌ':Added, #1: 1	أَدَاءِ الدُّيُونِ
u'دَاءٌ دُيونٌ':Added, #1: 1	أَدَاءُ دُيُونِ
u'دَاءٌ دُيونٌ':Added, #1: 1	أَدَاءِ دُيُونِهِ
u'دَاءٌ رَبُّ':Added, #2: 2	أَدَاءِ دُيُونِ
u'دَاءٌ رُبْعٌ':Added, #1: 1	أَدَاءُ رَبِّ
u'دَاءٌ رِسَالَةٌ':Added, #1: 1	أَدَاءِ رُبْعِ
u'دَاءٌ رَسُولٌ':Added, #1: 1	أَدَاءِ الرِّسَالَةِ
u'دَاءٌ ركعة':Added, #1: 1	أَدَاءَ الرَّسُولِ
u'دَاءٌ ركعة':Added, #1: 1	أَدَاءَ الرَّكْعَةِ
u'دَاءٌ رَكْعَةٌ':Added, #1: 1	أَدَاءِ الرَّكْعَةِ
u'دَاءٌ رَكْعَةٌ':Added, #1: 1	أَدَاءَ الرَّكْعَةِ
u'دَاءٌ ركعة':Added, #1: 1	أَدَاءِ الرَّكْعَةِ
u'دَاءٌ رَكْعَةٌ':Added, #1: 1	أَدَاءِ رَكْعَةٍ
u'دَاءٌ رُكْنٌ':Added, #1: 1	أَدَاءِ رَكْعَةٍ
u'دَاءٌ رُكْن':Added, #13: 13	أَدَاءِ رُكْنٍ
u'دَاءٌ رُكْنٌ':Added, #13: 13	أَدَاءِ رُكْنٍ
u'دَاءٌ رُكْن':Added, #2: 2	أَدَاءُ الرُّكْنِ
u'دَاءٌ رُكْنٌ':Added, #2: 2	أَدَاءُ الرُّكْنِ
u'دَاءٌ رُكْن':Added, #2: 2	أَدَاءُ رُكْنٍ
u'دَاءٌ رُكْنٌ':Added, #2: 2	أَدَاءُ رُكْنٍ
u'دَاءٌ رُكْن':Added, #3: 3	أَدَاءَ رُكْنٍ
u'دَاءٌ رُكْنٌ':Added, #3: 3	أَدَاءَ رُكْنٍ
u'دَاءٌ رُكْنٌ':Added, #4: 4	أَدَاءَ الرُّكْنِ
u'دَاءٌ رُكْن':Added, #4: 4	أَدَاءِ الرُّكْنِ
u'دَاءٌ رُكْن':Added, #4: 4	أَدَاءَ الرُّكْنِ
u'دَاءٌ رُكوعٌ':Added, #4: 4	أَدَاءِ الرُّكْنِ
u'دَاءٌ رَمْيٌ':Added, #1: 1	أَدَاءُ الرُّكُوعِ
u'دَاءٌ زَكاةٌ':Added, #1: 1	أَدَاءِ رَمْيِ
u'دَاءٌ زَكاةٌ':Added, #13: 13	أَدَاءَ الزَّكَاةِ
u'دَاءٌ زَكاةٌ':Added, #1: 1	أَدَاءِ زَكَاةِ
u'دَاءٌ زَكاةٌ':Added, #27: 27	أَدَاءُ الزَّكَاةِ
u'دَاءٌ زَكاةٌ':Added, #37: 37	أَدَاءِ الزَّكَاةِ
u'دَاءٌ زَكاةٌ':Added, #5: 5	أَدَاءُ زَكَاةِ
u'دَاءٌ زَكَواتٌ':Added, #7: 7	أَدَاءُ زَكَاتِهِ
u'دَاءٌ سابع':Added, #1: 1	أَدَاءُ الزَّكَوَاتِ
u'دَاءٌ سَابعٌ':Added, #1: 1	أَدَاءُ السَّابِعَةِ
u'دَاءٌ سادس':Added, #1: 1	أَدَاءُ السَّابِعَةِ
u'دَاءٌ سادس':Added, #1: 1	أَدَاءَ السَّادِسَةِ
u'دَاءٌ سادس':Added, #1: 1	أَدَاءُ السَّادِسَةِ
u'دَاءٌ سَادِسٌ':Added, #1: 1	أَدَاءِ السَّادِسَةِ
u'دَاءٌ سَادِسٌ':Added, #1: 1	أَدَاءَ السَّادِسَةِ
u'دَاءٌ سَادِسٌ':Added, #1: 1	أَدَاءُ السَّادِسَةِ
u'دَاءٌ سَائِرٌ':Added, #1: 1	أَدَاءِ السَّادِسَةِ
u'دَاءٌ سِتٌّ':Added, #1: 1	أَدَاءِ سَائِرِ
u'دَاءٌ سجدة':Added, #1: 1	أَدَاءِ سِتِّ
u'دَاءٌ سَجْدَةٌ':Added, #1: 1	أَدَاءَ السَّجْدَةِ
u'دَاءٌ سجدة':Added, #1: 1	أَدَاءَ السَّجْدَةِ
u'دَاءٌ سجدة':Added, #4: 4	أَدَاءُ السَّجْدَةِ
u'دَاءٌ سَجْدَةٌ':Added, #4: 4	أَدَاءِ السَّجْدَةِ
u'دَاءٌ سَجْدَةٌ':Added, #4: 4	أَدَاءُ السَّجْدَةِ
u'دَاءٌ سُجُودٌ':Added, #4: 4	أَدَاءِ السَّجْدَةِ
u'دَاءٌ سِعَايَةٌ':Added, #1: 1	أَدَاءِ سُجُودِ
u'دَاءٌ سِعَايَةٌ':Added, #1: 1	أَدَاءِ سِعَايَتِهِ
u'دَاءٌ سلام':Added, #5: 5	أَدَاءِ السِّعَايَةِ
u'دَاءٌ سَلاَمٌ':Added, #1: 1	أَدَاءِ السَّلَامِ
u'دَاءٌ سُنَّةٌ':Added, #1: 1	أَدَاءِ السَّلَامِ
u'دَاءٌ سُنَّةٌ':Added, #2: 2	أَدَاءُ السُّنَّةِ
u'دَاءٌ سنن':Added, #5: 5	أَدَاءِ السُّنَّةِ
u'دَاءٌ سَهْوٌ':Added, #2: 2	أَدَاءِ السُّنَنِ
u'دَاءٌ شَاةٌ':Added, #1: 1	أَدَاءُ السَّهْوِ
u'دَاءٌ شَرَائِعُ':Added, #1: 1	أَدَاءِ الشَّاةِ
u'دَاءٌ شَرْطٌ':Added, #1: 1	أَدَاءِ الشَّرَائِعِ
u'دَاءٌ شَطْرٌ':Added, #1: 1	أَدَاءِ الشَّرْطِ
u'دَاءٌ شَفْعٌ':Added, #1: 1	أَدَاءِ الشَّطْرِ
u'دَاءٌ شَهَادَةٌ':Added, #1: 1	أَدَاءَ شَفْعَيْنِ
u'دَاءٌ شَهَادَةٌ':Added, #1: 1	أَدَاءِ شَهَادَةِ
u'دَاءٌ شَهَادَةٌ':Added, #20: 20	أَدَاءَ الشَّهَادَةِ
u'دَاءٌ شَهَادَةٌ':Added, #21: 21	أَدَاءُ الشَّهَادَةِ
u'دَاءٌ شَهَادَةٌ':Added, #2: 2	أَدَاءَ الشَّهَادَاتِ
u'دَاءٌ شَهَادَةٌ':Added, #2: 2	أَدَاءُ شَهَادَةٍ
u'دَاءٌ شَهَادَةٌ':Added, #3: 3	أَدَاءِ شَهَادَتِهِ
u'دَاءٌ شُهُودٌ':Added, #71: 71	أَدَاءِ الشَّهَادَةِ
u'دَاءٌ شَيْءٌ':Added, #1: 1	أَدَاءِ الشُّهُودِ
u'دَاءٌ شَيْءٌ':Added, #3: 3	أَدَاءَ شَيْءٍ
u'دَاءٌ شَيْءٌ':Added, #5: 5	أَدَاءِ شَيْءٍ
u'دَاءٌ صَاحِبٌ':Added, #7: 7	أَدَاءُ شَيْءٍ
u'دَاءٌ صُبْحٌ':Added, #1: 1	أَدَاءِ صَاحِبِهِ
u'دَاءٌ صَبِيٌّ':Added, #1: 1	أَدَاءِ الصُّبْحِ
u'دَاءٌ صدقة':Added, #1: 1	أَدَاءُ الصَّبِيِّ
u'دَاءٌ صَدَقَةٌ':Added, #1: 1	أَدَاءِ صَدَقَةِ
u'دَاءٌ صدقة':Added, #1: 1	أَدَاءِ صَدَقَةِ
u'دَاءٌ صَدَقَةٌ':Added, #2: 2	أَدَاءِ الصَّدَقَةِ
u'دَاءٌ صَغِيرٌ':Added, #2: 2	أَدَاءِ الصَّدَقَةِ
u'دَاءٌ صَلاَةٌ':Added, #3: 3	أَدَاءِ الصَّغِيرِ
u'دَاءٌ صَلاَةٌ':Added, #15: 15	أَدَاءَ الصَّلَاةِ
u'دَاءٌ صَلاَةٌ':Added, #1: 1	أَدَاءَ صَلَاةٍ
u'دَاءٌ صَلاَةٌ':Added, #1: 1	أَدَاءَ صَلَاةِ
u'دَاءٌ صَلاَةٌ':Added, #22: 22	أَدَاءُ الصَّلَاةِ
u'دَاءٌ صَلاَةٌ':Added, #2: 2	أَدَاءِ صَلَاةِ
u'دَاءٌ صَلاَةٌ':Added, #48: 48	أَدَاءِ الصَّلَاةِ
u'دَاءٌ صَلَوَاتٌ':Added, #7: 7	أَدَاءُ صَلَاةٍ
u'دَاءٌ صَلَوَاتٌ':Added, #1: 1	أَدَاءَ الصَّلَوَاتِ
u'دَاءٌ صَلَوَاتٌ':Added, #1: 1	أَدَاءِ الصَّلَوَاتِ
u'دَاءٌ صَوْم':Added, #1: 1	أَدَاءِ صَلَوَاتٍ
u'دَاءٌ صَوْمٌ':Added, #1: 1	أَدَاءُ الصَّوْمَيْنِ
u'دَاءٌ صَوْمٌ':Added, #1: 1	أَدَاءَ صَوْمِ
u'دَاءٌ صَوْمٌ':Added, #1: 1	أَدَاءِ صَوْمِ
u'دَاءٌ صَوْمٌ':Added, #28: 28	أَدَاءِ الصَّوْمِ
u'دَاءٌ صَوْمٌ':Added, #2: 2	أَدَاءُ الصَّوْمِ
u'دَاءٌ صَوْمٌ':Added, #2: 2	أَدَاءُ صَوْمِ
u'دَاءٌ صِيَامٌ':Added, #4: 4	أَدَاءَ الصَّوْمِ
u'دَاءٌ ضَامِنٌ':Added, #1: 1	أَدَاءِ صِيَامِ
u'دَاءٌ ضَامِنٌ':Added, #1: 1	أَدَاءَ الضَّامِنِ
u'دَاءٌ ضَامِنٌ':Added, #1: 1	أَدَاءُ ضَامِنٍ
u'دَاءٌ ضَمَانٌ':Added, #2: 2	أَدَاءِ الضَّامِنِ
u'دَاءٌ ضَمَانٌ':Added, #1: 1	أَدَاءُ الضَّمَانِ
u'دَاءٌ ضَمَانٌ':Added, #1: 1	أَدَاءِ ضَمَانِهِ
u'دَاءٌ ضَمَانٌ':Added, #34: 34	أَدَاءِ الضَّمَانِ
u'دَاءٌ طَاعَةٌ':Added, #3: 3	أَدَاءَ الضَّمَانِ
u'دَاءٌ طَاعَةٌ':Added, #1: 1	أَدَاءُ الطَّاعَةِ
u'دَاءٌ طَالِبٌ':Added, #1: 1	أَدَاءِ الطَّاعَةِ
u'دَاءٌ طعام':Added, #1: 1	أَدَاءِ الطَّالِبِ
u'دَاءٌ طَعَامٌ':Added, #1: 1	أَدَاءَ طَعَامٍ
u'دَاءٌ طواف':Added, #1: 1	أَدَاءَ طَعَامٍ
u'دَاءٌ طَوَافٌ':Added, #2: 2	أَدَاءِ الطَّوَافِ
u'دَاءٌ ظُهْرٌ':Added, #2: 2	أَدَاءِ الطَّوَافِ
u'دَاءٌ ظُهْرٌ':Added, #15: 15	أَدَاءُ الظُّهْرِ
u'دَاءٌ ظُهْرٌ':Added, #16: 16	أَدَاءِ الظُّهْرِ
u'دَاءٌ عِبَادَةٌ':Added, #3: 3	أَدَاءَ الظُّهْرِ
u'دَاءٌ عِبَادَةٌ':Added, #1: 1	أَدَاءُ عِبَادَةٍ
u'دَاءٌ عِبَادَةٌ':Added, #2: 2	أَدَاءَ الْعِبَادَةِ
u'دَاءٌ عِبَادَةٌ':Added, #2: 2	أَدَاءِ عِبَادَةٍ
u'دَاءٌ عِبَادَةٌ':Added, #3: 3	أَدَاءُ الْعِبَادَةِ
u'دَاءٌ عِبَادَةٌ':Added, #4: 4	أَدَاءِ الْعِبَادَاتِ
u'دَاءٌ عَبْدٌ':Added, #7: 7	أَدَاءِ الْعِبَادَةِ
u'دَاءٌ عَبْدٌ':Added, #1: 1	أَدَاءِ الْعَبْدِ
u'دَاءٌ عِشَاءٌ':Added, #1: 1	أَدَاءِ عَبْدِ
u'دَاءٌ عِشَاءٌ':Added, #2: 2	أَدَاءُ الْعِشَاءِ
u'دَاءٌ عُشْرٌ':Added, #4: 4	أَدَاءِ الْعِشَاءِ
u'دَاءٌ عُشْرٌ':Added, #2: 2	أَدَاءُ الْعُشْرِ
u'دَاءٌ عَصْرٌ':Added, #4: 4	أَدَاءِ الْعُشْرِ
u'دَاءٌ عَصْرٌ':Added, #1: 1	أَدَاءُ عَصْرِهِ
u'دَاءٌ عَصْرٌ':Added, #2: 2	أَدَاءَ الْعَصْرِ
u'دَاءٌ عَصْرٌ':Added, #4: 4	أَدَاءُ الْعَصْرِ
u'دَاءٌ علم':Added, #4: 4	أَدَاءِ الْعَصْرِ
u'دَاءٌ عِلْمٌ':Added, #1: 1	أَدَاءُ الْعِلْمِ
u'دَاءٌ عمرة':Added, #1: 1	أَدَاءُ الْعِلْمِ
u'دَاءٌ عُمْرَةٌ':Added, #3: 3	أَدَاءُ الْعُمْرَةِ
u'دَاءٌ عمرة':Added, #3: 3	أَدَاءُ الْعُمْرَةِ
u'دَاءٌ عُمْرَةٌ':Added, #8: 8	أَدَاءِ الْعُمْرَةِ
u'دَاءٌ عَمَلٌ':Added, #8: 8	أَدَاءِ الْعُمْرَةِ
u'دَاءٌ عِوَضٌ':Added, #1: 1	أَدَاءَ الْعَمَلِ
u'دَاءٌ عين':Added, #1: 1	أَدَاءِ الْعِوَضِ
u'دَاءٌ عَيْنٌ':Added, #1: 1	أَدَاءُ عَيْنِ
u'دَاءٌ عَيْن':Added, #1: 1	أَدَاءُ عَيْنِ
u'دَاءٌ عين':Added, #1: 1	أَدَاءُ عَيْنِ
u'دَاءٌ عَيْنٌ':Added, #2: 2	أَدَاءَ الْعَيْنِ
u'دَاءٌ عَيْن':Added, #2: 2	أَدَاءَ الْعَيْنِ
u'دَاءٌ غَاصِبٌ':Added, #2: 2	أَدَاءَ الْعَيْنِ
u'دَاءٌ غُسْلٌ':Added, #1: 1	أَدَاءِ الْغَاصِبِ
u'دَاءٌ غَلَّةٌ':Added, #1: 1	أَدَاءَ الْغُسْلِ
u'دَاءٌ غير':Added, #1: 1	أَدَاءِ الْغَلَّةِ
u'دَاءٌ غَيْرٌ':Added, #1: 1	أَدَاءِ الْغَيْرِ
u'دَاءٌ غير':Added, #1: 1	أَدَاءِ الْغَيْرِ
u'دَاءٌ غَيْرٌ':Added, #1: 1	أَدَاءُ غَيْرِ
u'دَاءٌ غير':Added, #1: 1	أَدَاءُ غَيْرِ
u'دَاءٌ غَيْرٌ':Added, #2: 2	أَدَاءِ غَيْرِهِ
u'دَاءٌ فَاسِقٌ':Added, #2: 2	أَدَاءِ غَيْرِهِ
u'دَاءٌ فَاسِقٌ':Added, #1: 1	أَدَاءُ الْفَاسِقِ
u'دَاءٌ فِدَاءٌ':Added, #1: 1	أَدَاءُ فَاسِقٍ
u'دَاءٌ فَرَائِضُ':Added, #1: 1	أَدَاءِ الْفِدَاءِ
u'دَاءٌ فَرَائِضُ':Added, #11: 11	أَدَاءِ الْفَرَائِضِ
u'دَاءٌ فَرَائِضُ':Added, #1: 1	أَدَاءِ فَرَائِضِهِ
u'دَاءٌ فَرَائِضُ':Added, #2: 2	أَدَاءُ الْفَرَائِضِ
u'دَاءٌ فَرْضٌ':Added, #3: 3	أَدَاءَ الْفَرَائِضِ
u'دَاءٌ فَرْضٌ':Added, #13: 13	أَدَاءِ الْفَرْضِ
u'دَاءٌ فَرْضٌ':Added, #1: 1	أَدَاءُ فَرْضٍ
u'دَاءٌ فَرْضٌ':Added, #1: 1	أَدَاءِ فَرْضٍ
u'دَاءٌ فَرْضٌ':Added, #1: 1	أَدَاءِ فَرْضِهِ
u'دَاءٌ فَرْضٌ':Added, #1: 1	أَدَاءُ فَرْضَيْنِ
u'دَاءٌ فَرْضٌ':Added, #2: 2	أَدَاءَ فَرْضِ
u'دَاءٌ فَرْضٌ':Added, #2: 2	أَدَاءُ فَرْضِ
u'دَاءٌ فَرْضٌ':Added, #3: 3	أَدَاءُ فَرْضِهِ
u'دَاءٌ فَرْضٌ':Added, #8: 8	أَدَاءُ الْفَرْضِ
u'دَاءٌ فَرْعٌ':Added, #9: 9	أَدَاءِ فَرْضِ
u'دَاءٌ فُرُوعٌ':Added, #2: 2	أَدَاءِ الْفَرْعِ
u'دَاءٌ فُرُوعٌ':Added, #1: 1	أَدَاءُ الْفُرُوعِ
u'دَاءٌ فَرِيضَةٌ':Added, #1: 1	أَدَاءِ الْفُرُوعِ
u'دَاءٌ فَرِيضَةٌ':Added, #1: 1	أَدَاءِ الْفَرِيضَةِ
u'دَاءٌ فَرِيضَةٌ':Added, #1: 1	أَدَاءَ فَرِيضَةٍ
u'دَاءٌ فَرِيضَةٌ':Added, #2: 2	أَدَاءَ الْفَرِيضَةِ
u'دَاءٌ فَرِيضَةٌ':Added, #2: 2	أَدَاءُ الْفَرِيضَةِ
u'دَاءٌ فَضْلٌ':Added, #2: 2	أَدَاءُ فَرِيضَةٍ
u'دَاءٌ فَضْلٌ':Added, #1: 1	أَدَاءِ الْفَضْلِ
u'دَاءٌ فِعْلٌ':Added, #2: 2	أَدَاءُ فَضْلِ
u'دَاءٌ فُلاَنٌ':Added, #1: 1	أَدَاءِ الْفِعْلِ
u'دَاءٌ فلان':Added, #1: 1	أَدَاءَ فُلَانٍ
u'دَاءٌ فلان':Added, #4: 4	أَدَاءِ الصَّلَاتَيْنِ
u'دَاءٌ قَاصِرٌ':Added, #5: 5	أَدَاءُ الصَّلَاتَيْنِ
u'دَاءٌ قَائِلٌ':Added, #1: 1	أَدَاءَ قَاصِرٍ
u'دَاءٌ قَدْرٌ':Added, #1: 1	أَدَاءِ الْقَائِلِ
u'دَاءٌ قَدْرٌ':Added, #1: 1	أَدَاءُ الْقَدْرِ
u'دَاءٌ قَدْرٌ':Added, #1: 1	أَدَاءِ الْقَدْرِ
u'دَاءٌ قَدْرٌ':Added, #1: 1	أَدَاءُ قَدْرِ
u'دَاءٌ قُرْبَةٌ':Added, #2: 2	أَدَاءَ قَدْرِ
u'دَاءٌ قَرْضٌ':Added, #1: 1	أَدَاءِ الْقُرْبَةِ
u'دَاءٌ قِسْطٌ':Added, #1: 1	أَدَاءُ الْقَرْضِ
u'دَاءٌ قِنْطَارٌ':Added, #1: 1	أَدَاءِ قِسْطِهِ
u'دَاءٌ قِيمَةٌ':Added, #1: 1	أَدَاءِ الْقِنْطَارِ
u'دَاءٌ قِيمَةٌ':Added, #12: 12	أَدَاءِ الْقِيمَةِ
u'دَاءٌ قِيمَةٌ':Added, #4: 4	أَدَاءُ الْقِيمَةِ
u'دَاءٌ كَامِلٌ':Added, #5: 5	أَدَاءَ الْقِيمَةِ
u'دَاءٌ كِتَابَةٌ':Added, #1: 1	أَدَاءُ الْكَامِلِ
u'دَاءٌ كِتَابَةٌ':Added, #15: 15	أَدَاءِ الْكِتَابَةِ
u'دَاءٌ كِتَابَةٌ':Added, #3: 3	أَدَاءِ كِتَابَةِ
u'دَاءٌ كِرَاءٌ':Added, #4: 4	أَدَاءِ كِتَابَتِهِ
u'دَاءٌ كَفَّارٌ':Added, #1: 1	أَدَاءِ الْكِرَاءِ
u'دَاءٌ كَفَّارٌ':Added, #1: 1	أَدَاءِ الْكَفَّارَاتِ
u'دَاءٌ كَفَّارٌ':Added, #2: 2	أَدَاءَ الْكَفَّارَةِ
u'دَاءٌ كَفَّارٌ':Added, #2: 2	أَدَاءُ الْكَفَّارَةِ
u'دَاءٌ كَفَّارَةٌ':Added, #2: 2	أَدَاءِ الْكَفَّارَةِ
u'دَاءٌ كَفَّارَةٌ':Added, #1: 1	أَدَاءِ الْكَفَّارَاتِ
u'دَاءٌ كَفَّارَةٌ':Added, #2: 2	أَدَاءَ الْكَفَّارَةِ
u'دَاءٌ كَفَّارَةٌ':Added, #2: 2	أَدَاءُ الْكَفَّارَةِ
u'دَاءٌ كَفِيلٌ':Added, #2: 2	أَدَاءِ الْكَفَّارَةِ
u'دَاءٌ لاَزِمٌ':Added, #2: 2	أَدَاءِ الْكَفِيلِ
u'دَاءٌ لَفْظٌ':Added, #1: 1	أَدَاءِ اللَّازِمِ
u'دَاءٌ لَوَازِمُ':Added, #2: 2	أَدَاءُ اللَّفْظِ
u'دَاءٌ مَالٌ':Added, #1: 1	أَدَاءِ اللَّوَازِمِ
u'دَاءٌ مَالٌ':Added, #1: 1	أَدَاءَ الْمَالِ
u'دَاءٌ مَالٌ':Added, #22: 22	أَدَاءِ الْمَالِ
u'دَاءٌ مَالٌ':Added, #3: 3	أَدَاءُ الْمَالِ
u'دَاءٌ مَأْمُورٌ':Added, #5: 5	أَدَاءِ مَالِ
u'دَاءٌ مَأْمُورٌ':Added, #1: 1	أَدَاءِ الْمَأْمُورِ
u'دَاءٌ مَأْمُورٌ':Added, #2: 2	أَدَاءَ الْمَأْمُورِ
u'دَاءٌ مثل':Added, #2: 2	أَدَاءُ الْمَأْمُورِ
u'دَاءٌ مِثْلٌ':Added, #2: 2	أَدَاءِ الْمِثْلِ
u'دَاءٌ مثل':Added, #2: 2	أَدَاءِ الْمِثْلِ
u'دَاءٌ مِثْلٌ':Added, #3: 3	أَدَاءُ الْمِثْلِ
u'دَاءٌ مثل':Added, #3: 3	أَدَاءُ الْمِثْلِ
u'دَاءٌ مِثْلٌ':Added, #7: 7	أَدَاءُ مِثْلِ
u'دَاءٌ مَجْنُونٌ':Added, #7: 7	أَدَاءُ مِثْلِ
u'دَاءٌ مُحْرِمٌ':Added, #1: 1	أَدَاءِ الْمَجْنُونِ
u'دَاءٌ مُحِيل':Added, #1: 1	أَدَاءِ الْمُحْرِمِ
u'دَاءٌ مَشْرُوطٌ':Added, #2: 2	أَدَاءُ الْمُحِيلِ
u'دَاءٌ مُعَجَّلٌ':Added, #1: 1	أَدَاءُ الْمَشْرُوطِ
u'دَاءٌ مَعْلُومٌ':Added, #1: 1	أَدَاءِ الْمُعَجَّلِ
u'دَاءٌ مَغْرِبٌ':Added, #1: 1	أَدَاءِ الْمَعْلُومِ
u'دَاءٌ مَغْرِبٌ':Added, #1: 1	أَدَاءَ الْمَغْرِبِ
u'دَاءٌ مَغْرِبٌ':Added, #1: 1	أَدَاءُ الْمَغْرِبِ
u'دَاءٌ مَغْصُوب':Added, #6: 6	أَدَاءِ الْمَغْرِبِ
u'دَاءٌ مِقْدَارٌ':Added, #1: 1	أَدَاءِ الْمَغْصُوبِ
u'دَاءٌ مُكَاتَبَةٌ':Added, #1: 1	أَدَاءِ مِقْدَارِ
u'دَاءٌ مُكَاتَبَةٌ':Added, #1: 1	أَدَاءِ مُكَاتَبَةِ
u'دَاءٌ مَكْتُوبٌ':Added, #2: 2	أَدَاءِ الْمُكَاتَبَةِ
u'دَاءٌ مَكْتُوبٌ':Added, #1: 1	أَدَاءَ الْمَكْتُوبَةِ
u'دَاءٌ مَكْتُوبٌ':Added, #2: 2	أَدَاءِ مَكْتُوبَاتِ
u'دَاءٌ مَكْتُوبٌ':Added, #3: 3	أَدَاءُ الْمَكْتُوبَةِ
u'دَاءٌ مَكْتُوبٌ':Added, #6: 6	أَدَاءِ الْمَكْتُوبَاتِ
u'دَاءٌ مُلْتَزِمٌ':Added, #6: 6	أَدَاءِ الْمَكْتُوبَةِ
u'دَاءٌ مَنَاسِكُ':Added, #1: 1	أَدَاءُ مُلْتَزِمِهِ
u'دَاءٌ مَنْذُور':Added, #1: 1	أَدَاءِ الْمَنَاسِكِ
u'دَاءٌ مَهْرٌ':Added, #1: 1	أَدَاءِ الْمَنْذُورِ
u'دَاءٌ مُوجِبٌ':Added, #1: 1	أَدَاءُ الْمَهْرِ
u'دَاءٌ مُوَكِّلٌ':Added, #2: 2	أَدَاءِ مُوجِبِ
u'دَاءٌ مُوَكِّلٌ':Added, #1: 1	أَدَاءُ الْمُوَكِّلِ
u'دَاءٌ نَاسٌ':Added, #3: 3	أَدَاءِ الْمُوَكِّلِ
u'دَاءٌ نَافِلَةٌ':Added, #1: 1	أَدَاءِ النَّاسِ
u'دَاءٌ نَافِلَةٌ':Added, #1: 1	أَدَاءِ النَّافِلَةِ
u'دَاءٌ نَافِلَةٌ':Added, #2: 2	أَدَاءَ النَّافِلَةِ
u'دَاءٌ نَاقِصٌ':Added, #2: 2	أَدَاءُ النَّافِلَةِ
u'دَاءٌ نَائِبٌ':Added, #1: 1	أَدَاءُ النَّاقِصِ
u'دَاءٌ نَجْمٌ':Added, #3: 3	أَدَاءَ نَائِبِهِ
u'دَاءٌ نَجْمٌ':Added, #2: 2	أَدَاءِ نَجْمَيْنِ
u'دَاءٌ نُجُومٌ':Added, #6: 6	أَدَاءِ نَجْمٍ
u'دَاءٌ نُجُومٌ':Added, #1: 1	أَدَاءِ نُجُومٍ
u'دَاءٌ نُجُومٌ':Added, #1: 1	أَدَاءِ نُجُومِ
u'دَاءٌ نُجُومٌ':Added, #1: 1	أَدَاءُ نُجُومِهِ
u'دَاءٌ نُجُومٌ':Added, #1: 1	أَدَاءِ نُجُومِهِ
u'دَاءٌ نذر':Added, #8: 8	أَدَاءِ النُّجُومِ
u'دَاءٌ نَذْرٌ':Added, #1: 1	أَدَاءِ النَّذْرِ
u'دَاءٌ نُسُكٌ':Added, #1: 1	أَدَاءِ النَّذْرِ
u'دَاءٌ نُسُكٌ':Added, #1: 1	أَدَاءُ النُّسُكِ
u'دَاءٌ نُسُكٌ':Added, #2: 2	أَدَاءَ النُّسُكِ
u'دَاءٌ نُسُكٌ':Added, #5: 5	أَدَاءِ النُّسُكَيْنِ
u'دَاءٌ نِصْفٌ':Added, #6: 6	أَدَاءِ النُّسُكِ
u'دَاءٌ نِصْفٌ':Added, #1: 1	أَدَاءَ نِصْفِ
u'دَاءٌ نِصْفٌ':Added, #1: 1	أَدَاءِ نِصْفِ
u'دَاءٌ نَصِيبٌ':Added, #2: 2	أَدَاءُ نِصْفِ
u'دَاءٌ نَفَقَةٌ':Added, #1: 1	أَدَاءِ نَصِيبِ
u'دَاءٌ نَفْلٌ':Added, #1: 1	أَدَاءِ النَّفَقَةِ
u'دَاءٌ نَفْلٌ':Added, #3: 3	أَدَاءِ النَّفْلِ
u'دَاءٌ نقل':Added, #8: 8	أَدَاءُ النَّفْلِ
u'دَاءٌ نَقْلٌ':Added, #1: 1	أَدَاءَ النَّقْلِ
u'دَاءٌ نَوَافِلُ':Added, #1: 1	أَدَاءَ النَّقْلِ
u'دَاءٌ نَوَافِلُ':Added, #1: 1	أَدَاءِ النَّوَافِلِ
u'دَاءٌ وَاجِبٌ':Added, #1: 1	أَدَاءِ نَوَافِلِ
u'دَاءٌ وَاجِبٌ':Added, #19: 19	أَدَاءِ الْوَاجِبِ
u'دَاءٌ وَاجِبٌ':Added, #1: 1	أَدَاءُ وَاجِبٍ
u'دَاءٌ وَاجِبٌ':Added, #1: 1	أَدَاءِ وَاجِبٍ
u'دَاءٌ وَاجِبٌ':Added, #1: 1	أَدَاءِ وَاجِبِ
u'دَاءٌ وَاجِبٌ':Added, #1: 1	أَدَاءِ وَاجِبَاتِهِ
u'دَاءٌ وَاجِبٌ':Added, #2: 2	أَدَاءِ الْوَاجِبَاتِ
u'دَاءٌ وَاجِبٌ':Added, #6: 6	أَدَاءُ الْوَاجِبِ
u'دَاءٌ واحد':Added, #7: 7	أَدَاءَ الْوَاجِبِ
u'دَاءٌ وَاحِدٌ':Added, #1: 1	أَدَاءُ وَاحِدَةٍ
u'دَاءٌ وُجُودٌ':Added, #1: 1	أَدَاءُ وَاحِدَةٍ
u'دَاءٌ وَحْيٌ':Added, #1: 1	أَدَاءَ وُجُودِ
u'دَاءٌ وُضُوءٌ':Added, #1: 1	أَدَاءِ الْوَحْيِ
u'دَاءٌ وُضُوءٌ':Added, #2: 2	أَدَاءُ الْوُضُوءِ
u'دَاءٌ وَظِيفٌ':Added, #2: 2	أَدَاءِ الْوُضُوءِ
u'دَاءٌ وَظِيفَةٌ':Added, #1: 1	أَدَاءِ وَظِيفَةِ
u'دَاءٌ وَقْت':Added, #1: 1	أَدَاءِ وَظِيفَةِ
u'دَاءٌ وَقْت':Added, #1: 1	أَدَاءِ الْوَقْتِيَّةِ
u'دَاءٌ وَقْتِيّ':Added, #2: 2	أَدَاءُ الْوَقْتِيَّةِ
u'دَاءٌ وَقْتِيّ':Added, #1: 1	أَدَاءِ الْوَقْتِيَّةِ
u'دَاءٌ ولد':Added, #2: 2	أَدَاءُ الْوَقْتِيَّةِ
u'دَاءٌ وَلَدٌ':Added, #1: 1	أَدَاءِ الْوَلَدِ
u'دَاءٌ يَمِينٌ':Added, #1: 1	أَدَاءِ الْوَلَدِ
u'دَأْبٌ أهْلٌ':Added, #1: 1	أَدَاءِ الْيَمِينِ
u'دَأْبٌ أئِمَّةٌ':Added, #1: 1	دَأْبُ أَهْلِ
u'دَأْبٌ إيجَازٌ':Added, #1: 1	دَأْبُ الْأَئِمَّةِ
u'دَأْبٌ شُرَّاحٌ':Added, #1: 1	دَأْبُ إيجَازِ
u'دَأْبٌ شَرْعٌ':Added, #1: 1	دَأْبِ الشُّرَّاحِ
u'دَأْبٌ شَيْخٌ':Added, #1: 1	دَأْبِ الشَّرْعِ
u'دَأْبٌ صَحَابَةٌ':Added, #1: 1	دَأْبِ الشَّيْخِ
u'دَأْبٌ عُقَلاَءُ':Added, #1: 1	دَأْبُ الصَّحَابَةِ
u'دَأْبٌ عُقَلاَءُ':Added, #1: 1	دَأْبُ الْعُقَلَاءِ
u'دَأْبٌ لَعِينٌ':Added, #1: 1	دَأْبِ الْعُقَلَاءِ
u'دَأْبٌ مَشَايِخُ':Added, #1: 1	دَأْبُ اللَّعِينِ
u'دَأْبٌ مُصَنِّفٌ':Added, #1: 1	دَأْبُ الْمَشَايِخِ
u'دَأْبٌ نَفْسٌ':Added, #1: 1	دَأْبِ الْمُصَنِّفِ
u'دَاخَلَ قَوْمٌ':Predicate, #1: 1	دَأْبِ نَفْسِهِ
u'دَاخَلَ نَفْسٌ':Predicate, #1: 1	دَاخَلَ الْقَوْمَ
u'دَارَ اِبْنٌ':Predicate, #1: 1	دَاخَلَ النَّفْسَ
u'دَارَ اِسْتِناد':Subject, #1: 1	دَارَ ابْنَ
u'دَارَ إِسْنادٌ':Subject, #1: 1	دَارَ اسْتِنَادُهُ
u'دَارَ أَمْرٌ':Subject, #1: 1	دَارَ إسْنَادُهُ
u'دَارَ أَمْرٌ':Subject, #15: 15	دَارَ الْأَمْرُ
u'دَارَ إِيجَابٌ':Subject, #1: 1	دَارَ أَمْرُ
u'دَارَ بَيْعٌ':Subject, #2: 2	دَارَ الْإِيجَابُ
u'دَارَ بَيْنٌ':Predicate, #1: 1	دَارَ بَيْعٌ
u'دَارَ حَديثٌ':Subject, #15: 15	دَارَ بَيْنَ
u'دَارَ حُكْمٌ':Predicate, #3: 3	دَارَ الْحَدِيثُ
u'دَارَ حُكْمٌ':Subject, #1: 1	أَدَارَ الْحُكْمَ
u'دَارَ حول':Predicate, #2: 2	دَارَ الْحُكْمُ
u'دَارَ حَوْلٌ':Predicate, #3: 3	دَارَ حَوْلَ
u'دَارَ حول':Subject, #3: 3	دَارَ حَوْلَ
u'دَارَ حَوْلٌ':Subject, #1: 1	دَارَ الْحَوْلُ
u'دَارَ رَسُولٌ':Subject, #1: 1	دَارَ الْحَوْلُ
u'دَارَ سلام':Predicate, #1: 1	دَارَ رَسُولُ
u'دَارَ سَلاَمٌ':Predicate, #1: 1	دَارَ السَّلَامَ
u'دَارَ صَاحِبٌ':Subject, #1: 1	دَارَ السَّلَامَ
u'دَارَ عِذَارٌ':Subject, #1: 1	دَارَ صَاحِبُهُ
u'دَارَ عُمَرٌ':Subject, #1: 1	دَارَ الْعِذَارُ
u'دَارَ غَدٌ':Subject, #2: 2	دَارَ عُمَرُ
u'دَارَ غُسْلٌ':Subject, #1: 1	دَارَ غَدٌ
u'دَارَ فَاسِقٌ':Predicate, #1: 1	دَارَ الْغُسْلُ
u'دَارَ فَضْلٌ':Subject, #1: 1	دَارَ الْفَاسِقِينَ
u'دَارَ فلان':Predicate, #2: 2	دَارَ فَضْلٌ
u'دَارَ فُلاَنٌ':Predicate, #1: 1	دَارَ مَيَّةَ
u'دَارَكَ أحَدٌ':Subject, #2: 2	دَارَ فُلَانَةَ
u'دَارَ لَفْظٌ':Subject, #1: 1	دَارَكَ أَحَدٌ
u'دَارَ لَفْظٌ':Subject, #1: 1	دَارَ لَفْظٌ
u'دَارَ لَفْظٌ':Subject, #2: 2	دَارَ لَفْظُ
u'دَارَ مَاءٌ':Predicate, #5: 5	دَارَ اللَّفْظُ
u'دَارَ نَدْوَةٌ':Predicate, #3: 3	أَدَارَ الْمَاءَ
u'دَارَ وَصْفٌ':Subject, #1: 1	دَارَ النَّدْوَةَ
u'دَارَ يَوْمٌ':Subject, #1: 1	دَارَ الْوَصْفُ
u'دَاسَ طِينٌ':Predicate, #1: 1	دَارَ يَوْمٌ
u'دَافَعَ قَوْمٌ':Predicate, #1: 1	دَاسَ الطِّينَ
u'دَافَعَ نَصٌّ':Predicate, #1: 1	دَافَعَ الْقَوْمَ
u'دَامَ أَبٌ':Subject, #1: 1	دَافَعَ نَصَّ
u'دَامَ أثَرٌ':Subject, #4: 4	دَامَ الْأَبُ
u'دَامَ أحَدٌ':Subject, #1: 1	دَامَ أَثَرُ
u'دَامَ أَذَانٌ':Subject, #3: 3	دَامَ أَحَدٌ
u'دَامَ إِذْنٌ':Subject, #1: 1	دَامَ الْأَذَانُ
u'دَامَ اِسْتِحْقَاقٌ':Subject, #1: 1	دَامَ إذْنُهُ
u'دَامَ اِسْمٌ':Subject, #1: 1	دَامَ اسْتِحْقَاقُهُ
u'دَامَ إِشْكالٌ':Subject, #1: 1	دَامَ اسْمُهُ
u'دَامَ أصل':Subject, #1: 1	دَامَ الْإِشْكَالُ
u'دَامَ أًصْلٌ':Subject, #2: 2	دَامَ الْأَصْلُ
u'دَامَ أفْضَلُ':Subject, #2: 2	دَامَ الْأَصْلُ
u'دَامَ إقْرَارٌ':Subject, #1: 1	دَامَ الْأَفْضَلُ
u'دَامَ إمَامٌ':Subject, #1: 1	دَامَ الْإِقْرَارُ
u'دَامَ أَمْرٌ':Subject, #2: 2	دَامَ الْإِمَامُ
u'دَامَ أَمْرٌ':Subject, #1: 1	دَامَ الْأَمْرُ
u'دَامَ أَميرٌ':Subject, #1: 1	دَامَ أَمْرُهُ
u'دَامَ إِنْسانٌ':Subject, #2: 2	دَامَ الْأَمِيرُ
u'دَامَ أهْلٌ':Subject, #3: 3	دَامَ الْإِنْسَانُ
u'دَامَ بَائِعٌ':Subject, #1: 1	دَامَ أَهْلُهُ
u'دَامَ بَصَرٌ':Subject, #1: 1	دَامَ الْبَائِعُ
u'دَامَ بَعْضٌ':Subject, #2: 2	دَامَ بَصَرُهُ
u'دَامَ بِنَاءٌ':Subject, #1: 1	دَامَ بَعْضُ
u'دَامَ بَيَانٌ':Subject, #2: 2	دَامَ الْبِنَاءُ
u'دَامَ بَيْنٌ':Predicate, #1: 1	دَامَ بَيَانُهُ
u'دَامَ تَرْجِيحٌ':Subject, #1: 1	دَامَ بَيْنَ
u'دَامَ تَقَطُّعٌ':Subject, #1: 1	دَامَ تَرْجِيحُهُ
u'دَامَ تَكْليفٌ':Subject, #2: 2	دَامَ التَّقَطُّعُ
u'دَامَ تَوَاضُعٌ':Subject, #1: 1	دَامَ التَّكْلِيفُ
u'دَامَ جَنِينٌ':Subject, #1: 1	دَامَ تَوَاضُعُهُ
u'دَامَ حَبْسٌ':Subject, #1: 1	دَامَ الْجَنِينُ
u'دَامَ حَرْبٌ':Subject, #1: 1	دَامَ حَبْسُهُ
u'دَامَ حسد':Subject, #1: 1	دَامَ الْحَرْبُ
u'دَامَ حَسَدٌ':Subject, #1: 1	دَامَ الْحَسَدُ
u'دَامَ حَصْرٌ':Subject, #1: 1	دَامَ الْحَسَدُ
u'دَامَ حِفْظٌ':Predicate, #1: 1	دَامَ الْحَصْرُ
u'دَامَ حَقٌّ':Subject, #1: 1	أَدَامَ الْحِفْظَ
u'دَامَ حَمْلٌ':Subject, #2: 2	دَامَ الْحَقُّ
u'دَامَ خَصْمٌ':Subject, #2: 2	دَامَ الْحَمْلُ
u'دَامَ خَلِيلٌ':Subject, #1: 1	دَامَ خَصْمُهُ
u'دَامَ خَوْفٌ':Subject, #1: 1	دَامَ الْخَلِيلُ
u'دَامَ خيار':Subject, #1: 1	دَامَ خَوْفُهُ
u'دَامَ خِيَارٌ':Subject, #1: 1	دَامَ الْخِيَارُ
u'دَامَ خيار':Subject, #1: 1	دَامَ الْخِيَارُ
u'دَامَ خِيَارٌ':Subject, #1: 1	دَامَ خِيَارُ
u'دَامَ دَخَلٌ':Predicate, #1: 1	دَامَ خِيَارُ
u'دَامَ دَمٌ':Subject, #1: 1	دَامَ دَخَلَ
u'دَامَ دَيْنٌ':Subject, #2: 2	دَامَ دَمُ
u'دَامَ دَيْنٌ':Subject, #1: 1	دَامَ دَيْنُهُ
u'دَامَ رَأْسٌ':Subject, #3: 3	دَامَ الدَّيْنُ
u'دَامَ رَهْنٌ':Subject, #1: 1	دَامَ الرَّأْسُ
u'دَامَ روحٌ':Subject, #1: 1	دَامَ الرَّهْنُ
u'دَامَ زَرْعٌ':Subject, #1: 1	دَامَ الرُّوحُ
u'دَامَ زَمَنٌ':Subject, #1: 1	دَامَ زَرْعُ
u'دَامَ زَوْجٌ':Subject, #1: 1	دَامَ زَمَنُ
u'دَامَ زَيْدٌ':Subject, #1: 1	دَامَ الزَّوْجُ
u'دَامَ سائِل':Subject, #2: 2	دَامَ زَيْدٌ
u'دَامَ سَائِلٌ':Subject, #1: 1	دَامَ السَّائِلُ
u'دَامَ سِتْرٌ':Subject, #1: 1	دَامَ السَّائِلُ
u'دَامَ سِدْرٌ':Subject, #1: 1	دَامَ سِتْرُهُ
u'دَامَ سَمْنٌ':Subject, #1: 1	دَامَ السِّدْرُ
u'دَامَ سُؤْدُدٌ':Subject, #2: 2	دَامَ السَّمْنُ
u'دَامَ سَيِّدٌ':Subject, #1: 1	دَامَ سُؤْدُدُهُ
u'دَامَ سَيِّدٌ':Subject, #1: 1	دَامَ السَّيِّدُ
u'دَامَ شَرْطٌ':Subject, #1: 1	دَامَ سَيِّدُهُ
u'دَامَ شَكٌّ':Subject, #1: 1	دَامَ شَرْطُهُ
u'دَامَ شَهْرٌ':Subject, #2: 2	دَامَ شَكُّهُ
u'دَامَ شَيْءٌ':Subject, #1: 1	دَامَ الشَّهْرُ
u'دَامَ صَغِيرٌ':Subject, #2: 2	دَامَ شَيْءٌ
u'دَامَ صلح':Subject, #1: 1	دَامَ الصَّغِيرُ
u'دَامَ صُلْحٌ':Subject, #1: 1	دَامَ الصُّلْحُ
u'دَامَ ضَرَرٌ':Subject, #1: 1	دَامَ الصُّلْحُ
u'دَامَ طعام':Subject, #2: 2	دَامَ ضَرَرُهُ
u'دَامَ طَعَامٌ':Subject, #1: 1	دَامَ الطَّعَامُ
u'دَامَ طلب':Subject, #1: 1	دَامَ الطَّعَامُ
u'دَامَ طَلَبٌ':Subject, #1: 1	دَامَ طَلَبُهُ
u'دَامَ ظِلٌّ':Subject, #1: 1	دَامَ طَلَبُهُ
u'دَامَ ظِلٌّ':Subject, #1: 1	دَامَ ظِلُّ
u'دَامَ عَالِمٌ':Subject, #3: 3	دَامَ الظِّلُّ
u'دَامَ عَبْدٌ':Subject, #1: 1	دَامَ الْعَالِمُ
u'دَامَ عجز':Subject, #8: 8	دَامَ الْعَبْدُ
u'دَامَ عَجْزٌ':Subject, #3: 3	دَامَ الْعَجْزُ
u'دَامَ عَدَمٌ':Subject, #3: 3	دَامَ الْعَجْزُ
u'دَامَ عُذْرٌ':Subject, #1: 1	دَامَ عَدَمُ
u'دَامَ عُذْرٌ':Subject, #3: 3	دَامَ الْعُذْرُ
u'دَامَ عَقْدٌ':Subject, #3: 3	دَامَ عُذْرُهُ
u'دَامَ عَقْدٌ':Subject, #1: 1	دَامَ الْعَقْدُ
u'دَامَ عَقْلٌ':Subject, #2: 2	دَامَ عَقْدُ
u'دَامَ عند':Predicate, #5: 5	دَامَ عَقْلُهُ
u'دَامَ عين':Subject, #1: 1	دَامَ عِنْدَ
u'دَامَ عَيْنٌ':Subject, #1: 1	دَامَ عَيْنُ
u'دَامَ عَيْن':Subject, #1: 1	دَامَ عَيْنُ
u'دَامَ غُسْلٌ':Subject, #1: 1	دَامَ عَيْنُ
u'دَامَ غَضْبَان':Predicate, #1: 1	دَامَ الْغُسْلُ
u'دَامَ غيم':Subject, #1: 1	دَامَ غَضْبَانَ
u'دَامَ غَيْمٌ':Subject, #1: 1	دَامَ الْغَيْمُ
u'دَامَ فُلاَنٌ':Subject, #1: 1	دَامَ الْغَيْمُ
u'دَامَ قَاتِلٌ':Subject, #6: 6	دَامَ فُلَانٌ
u'دَامَ قَائِمٌ':Predicate, #1: 1	دَامَ الْقَاتِلُ
u'دَامَ قَبْضٌ':Subject, #2: 2	دَامَ قَائِمَ
u'دَامَ قلب':Subject, #1: 1	دَامَ الْقَبْضُ
u'دَامَ قَلْبٌ':Subject, #1: 1	دَامَ الْقَلْبُ
u'دَامَ قَلْب':Subject, #1: 1	دَامَ الْقَلْبُ
u'دَامَ قِنٌّ':Subject, #1: 1	دَامَ الْقَلْبُ
u'دَامَ كسل':Subject, #1: 1	دَامَ الْقِنُّ
u'دَامَ كَسَلٌ':Subject, #1: 1	دَامَ كَسَلُهُ
u'دَامَ كَلْبٌ':Subject, #1: 1	دَامَ كَسَلُهُ
u'دَامَ لَيْلٌ':Subject, #1: 1	دَامَ الْكَلْبُ
u'دَامَ مَاءٌ':Subject, #1: 1	دَامَ اللَّيْلُ
u'دَامَ مَالٌ':Subject, #2: 2	دَامَ الْمَاءُ
u'دَامَ مَالِكٌ':Subject, #4: 4	دَامَ الْمَالُ
u'دَامَ مَانِعٌ':Subject, #1: 1	دَامَ مَالِكُهُ
u'دَامَ مَبِيعٌ':Subject, #1: 1	دَامَ الْمَانِعُ
u'دَامَ مَتَاعٌ':Subject, #4: 4	دَامَ الْمَبِيعُ
u'دَامَ مَجْلِسٌ':Subject, #2: 2	دَامَ الْمَتَاعُ
u'دَامَ مَدْفُوعٌ':Subject, #1: 1	دَامَ الْمَجْلِسُ
u'دَامَ مَرَضٌ':Subject, #1: 1	دَامَ الْمَدْفُوعُ
u'دَامَ مَرَضٌ':Subject, #1: 1	دَامَ الْمَرَضُ
u'دَامَ مَعْقُودٌ':Subject, #1: 1	دَامَ مَرَضُهُ
u'دَامَ مَغْصُوب':Subject, #1: 1	دَامَ الْمَعْقُودُ
u'دَامَ مُقَدَّمٌ':Subject, #1: 1	دَامَ الْمَغْصُوبُ
u'دَامَ مُكْثٌ':Subject, #2: 2	دَامَ الْمُقَدَّمُ
u'دَامَ مُكَلَّفٌ':Subject, #1: 1	دَامَ مُكْثُهُ
u'دَامَ مِلْكٌ':Subject, #1: 1	دَامَ الْمُكَلَّفُ
u'دَامَ مُودَعٌ':Subject, #6: 6	دَامَ مِلْكُهُ
u'دَامَ مَوْقُوفٌ':Subject, #1: 1	دَامَ الْمُودَعُ
u'دَامَ مُوَكِّلٌ':Subject, #3: 3	دَامَ الْمَوْقُوفُ
u'دَامَ نصاب':Subject, #1: 1	دَامَ مُوَكِّلُهُ
u'دَامَ نِصَابٌ':Subject, #2: 2	دَامَ نِصَابُ
u'دَامَ نكاح':Subject, #2: 2	دَامَ نِصَابُ
u'دَامَ نِكَاحٌ':Subject, #3: 3	دَامَ النِّكَاحُ
u'دَامَ واحد':Subject, #3: 3	دَامَ النِّكَاحُ
u'دَامَ وَاحِدٌ':Subject, #4: 4	دَامَ وَاحِدٌ
u'دَامَ وَارِثٌ':Subject, #4: 4	دَامَ وَاحِدٌ
u'دَامَ وَاقِفٌ':Subject, #2: 2	دَامَ الْوَارِثُ
u'دَامَ وَقْتٌ':Subject, #3: 3	دَامَ الْوَاقِفُ
u'دَامَ وَكِيلٌ':Subject, #11: 11	دَامَ الْوَقْتُ
u'دَامَ ولد':Subject, #2: 2	دَامَ الْوَكِيلُ
u'دَامَ وَلَدٌ':Subject, #1: 1	دَامَ الْوَلَدُ
u'دَامَ ولد':Subject, #1: 1	دَامَ الْوَلَدُ
u'دَامَ وَلَدٌ':Subject, #2: 2	دَامَ وَلَدُ
u'دَامَ يَدٌ':Subject, #2: 2	دَامَ وَلَدُ
u'دَانَ اِمْرُؤٌ':Subject, #1: 1	دَامَ يَدُ
u'دَانَ دِينٌ':Predicate, #1: 1	دَانَ امْرُؤٌ
u'دَانَ عَبْدٌ':Predicate, #1: 1	دَانَ دِينَ
u'دَانَ فُلاَنٌ':Subject, #3: 3	أَدَانَ الْعَبْدَ
u'دَانَ مُسْلِمٌ':Subject, #1: 1	دَانَ فُلَانٌ
u'دَانَ مُلْكٌ':Subject, #1: 1	أَدَانَ مُسْلِمٌ
u'دَانَى يهود':Predicate, #1: 1	دَانَ الْمُلْكُ
u'دَانَى يَهُودٌ':Predicate, #1: 1	دَانَى الْيَهُودَ
u'دَاوَمَ مُرَاقَبٌ':Predicate, #1: 1	دَانَى الْيَهُودَ
u'دَاوَمَ مُرَاقَبَةٌ':Predicate, #1: 1	دَاوَمَ الْمُرَاقَبَةَ
u'دَاوَمَ نَاسٌ':Subject, #1: 1	دَاوَمَ الْمُرَاقَبَةَ
u'دَاوَى طَبِيبٌ':Subject, #1: 1	دَاوَمَ النَّاسُ
u'دَاوَى عَبْدٌ':Predicate, #1: 1	دَاوَى طَبِيبٌ
u'دَاوَى مَبِيعٌ':Predicate, #1: 1	دَاوَى الْعَبْدَ
u'دَاوَى مَرِيضٌ':Predicate, #1: 1	دَاوَى الْمَبِيعَ
u'دَاوَى وَلِيٌّ':Subject, #1: 1	دَاوَى الْمَرِيضَ
u'دِبَاغٌ أَدِيمٌ':Added, #1: 1	دَاوَى الْوَلِيُّ
u'دِبَاغٌ أَدِيمٌ':Added, #1: 1	دِبَاغُ الأَدِيمِ
u'دِبَاغٌ أَدِيمٌ':Added, #3: 3	دِبَاغَ الْأَدِيمِ
u'دِبَاغٌ جلد':Added, #3: 3	دِبَاغُ الْأَدِيمِ
u'دِبَاغٌ جِلْدٌ':Added, #1: 1	دِبَاغِ الْجِلْدِ
u'دِبَاغٌ جلد':Added, #1: 1	دِبَاغِ الْجِلْدِ
u'دِبَاغٌ جلد':Added, #1: 1	دِبَاغُ جِلْدِ
u'دِبَاغٌ جِلْدٌ':Added, #1: 1	دِبَاغِ جِلْدِ
u'دِبَاغٌ جِلْدٌ':Added, #1: 1	دِبَاغُ جِلْدِ
u'دِبَاغٌ جُلُودٌ':Added, #1: 1	دِبَاغِ جِلْدِ
u'دِبَاغٌ جُلُودٌ':Added, #1: 1	دِبَاغُ جُلُودِ
u'دِبَاغٌ مَعِدَةٌ':Added, #2: 2	دِبَاغَ الْجُلُودِ
u'دَبَّ بِزْرٌ':Subject, #1: 1	دِبَاغُ الْمَعِدَةِ
u'دَبَّرَ اِبْنٌ':Predicate, #1: 1	دَبَّ بِزْرُ
u'دَبَّرَ اِبْنٌ':Subject, #2: 2	دَبَّرَ ابْنَ
u'دَبَّرَ أحَدٌ':Predicate, #1: 1	دَبَّرَ ابْنُ
u'دَبَّرَ أحَدٌ':Subject, #4: 4	دَبَّرَ أَحَدَ
u'دَبَّرَ أحَدٌ':Subject, #1: 1	دَبَّرَ أَحَدٌ
u'دَبَّرَ أُمٌّ':Predicate, #1: 1	دَبَّرَ أَحَدُ
u'دَبَّرَ أُمٌّ':Predicate, #1: 1	دَبَّرَ أُمَّ
u'دَبَّرَ أَمْرٌ':Predicate, #4: 4	دَبَّرَ الْأُمَّ
u'دَبَّرَ أَنامٌ':Predicate, #1: 1	دَبَّرَ أَمْرَ
u'دَبَّرَ بِنْتٌ':Predicate, #1: 1	دَبَّرَ الْأَنَامَ
u'دَبَّرَ ثَلاثَةٌ':Predicate, #1: 1	دَبَّرَ الْبِنْتَ
u'دَبَّرَ جَارِي':Predicate, #2: 2	دَبَّرَ ثَلَاثَةَ
u'دَبَّرَ جَازٌ':Predicate, #1: 1	دَبَّرَ جَارِيَةً
u'دَبَّرَ حَمْلٌ':Predicate, #1: 1	دَبَّرَ جَازَ
u'دَبَّرَ حوادِثُ':Predicate, #1: 1	دَبَّرَ الْحَمْلَ
u'دَبَّرَ ذِمِّيٌّ':Subject, #1: 1	دَبَّرَ الْحَوَادِثَ
u'دَبَّرَ رَجُلٌ':Subject, #1: 1	دَبَّرَ الذِّمِّيُّ
u'دَبَّرَ رَجُلٌ':Subject, #3: 3	دَبَّرَ الرَّجُلُ
u'دَبَّرَ رَهْنٌ':Predicate, #3: 3	دَبَّرَ رَجُلٌ
u'دَبَّرَ سَاكِتٌ':Subject, #1: 1	دَبَّرَ الرَّهْنَ
u'دَبَّرَ سَفِيهٌ':Subject, #1: 1	دَبَّرَ السَّاكِتُ
u'دَبَّرَ فُلاَنٌ':Subject, #1: 1	دَبَّرَ السَّفِيهُ
u'دَبِرَ قَالٌ':Predicate, #2: 2	دَبَّرَ فُلَانٌ
u'دَبَّرَ لَقِيطٌ':Subject, #5: 5	أَدْبَرَ قَالَ
u'دَبَّرَ مَالِكٌ':Subject, #1: 1	دَبَّرَ اللَّقِيطُ
u'دَبَّرَ مُرْتَدٌّ':Subject, #1: 1	دَبَّرَ الْمَالِكُ
u'دَبَّرَ مُسْلِمٌ':Subject, #1: 1	دَبَّرَ الْمُرْتَدُّ
u'دَبَّرَ مَكَانٌ':Predicate, #1: 1	دَبَّرَ الْمُسْلِمُ
u'دَبَّرَ مُوسِرٌ':Subject, #1: 1	دَبَّرَ مَكَانَ
u'دَبَّرَ نِصْفٌ':Predicate, #1: 1	دَبَّرَ مُوسِرٌ
u'دَبِرَ وقع':Predicate, #1: 1	دَبَّرَ نِصْفَ
u'دَبَّرَ ولد':Predicate, #1: 1	أَدْبَرَ وَقَعَ
u'دَبَّرَ وَلَدٌ':Predicate, #1: 1	دَبَّرَ الْوَلَدَ
u'دَبَّ شَرَابٌ':Subject, #1: 1	دَبَّرَ الْوَلَدَ
u'دَبَّ صَبِيٌّ':Subject, #1: 1	دَبَّ الشَّرَابُ
u'دَبَغَ جلد':Predicate, #1: 1	دَبَّ صَبِيٌّ
u'دَبَغَ جِلْدٌ':Predicate, #1: 1	دَبَغَ جِلْدَ
u'دَبَغَ مَثَانَةٌ':Predicate, #1: 1	دَبَغَ جِلْدَ
u'دَبَغَ مُرْتَهِنٌ':Subject, #1: 1	دَبَغَ الْمَثَانَةَ
u'دَبِيبٌ ذَرٌّ':Added, #1: 1	دَبَغَ الْمُرْتَهِنُ
u'دَبِيبٌ نَمْلٌ':Added, #1: 1	دَبِيبِ الذَّرِّ
u'دَحَا أرْضٌ':Predicate, #11: 11	دَبِيبِ النَّمْلِ
u'دَحْضٌ أَقْدَامٌ':Added, #1: 1	دَحَا الْأَرْضَ
u'دَخَلَ أَبٌ':Subject, #1: 1	دَحْضِ الأَقْدَامِ
u'دَخَلَ آباءٌ':Subject, #1: 1	دَخَلَ الْأَبُ
u'دَخَلَ أَبْعَدُ':Subject, #1: 1	دَخَلَ الْآبَاءُ
u'دَخَلَ اِبْنٌ':Subject, #1: 1	دَخَلَ الْأَبْعَدُ
u'دَخَلَ أَجَلٌ':Subject, #4: 4	دَخَلَ ابْنُ
u'دَخَلَ أَجَلٌ':Subject, #1: 1	دَخَلَ أَجَلُ
u'دَخَلَ أحَدٌ':Subject, #2: 2	دَخَلَ الْأَجَلُ
u'دَخَلَ أحَدٌ':Subject, #2: 2	دَخَلَ أَحَدٌ
u'دَخِلَ إِحْرَامٌ':Predicate, #2: 2	دَخَلَ أَحَدُ
u'دَخَلَ إِحْرَامٌ':Subject, #5: 5	أَدْخَلَ إحْرَامَ
u'دَخِلَ أَحْكَامٌ':Predicate, #1: 1	دَخَلَ إحْرَامُ
u'دَخَلَ أَحْنَف':Subject, #1: 1	أَدْخَلَ الْأَحْكَامَ
u'دَخَلَ أَخَوَاتٌ':Subject, #1: 1	دَخَلَ الأَحْنَفُ
u'دَخَلَ إِخْوَةٌ':Subject, #1: 1	دَخَلَ الْأَخَوَاتُ
u'دَخِلَ آدَمِيٌّ':Predicate, #1: 1	دَخَلَ الْإِخْوَةُ
u'دَخَلَ أرْضٌ':Predicate, #1: 1	أَدْخَلَ الْآدَمِيَّ
u'دَخَلَ أرْضٌ':Predicate, #1: 1	دَخَلَ أَرْضَكَ
u'دَخَلَ أرْضٌ':Predicate, #2: 2	دَخَلَ أَرْضَ
u'دَخَلَ أزِقَّةٌ':Predicate, #2: 2	دَخَلَ الْأَرْضَ
u'دَخَلَ أَزِقَّةٌ':Predicate, #1: 1	دَخَلَ أَزِقَّةَ
u'دَخَلَ أُسٌّ':Subject, #1: 1	دَخَلَ أَزِقَّةَ
u'دَخَلَ إِسْلامٌ':Predicate, #1: 1	دَخَلَ الْأُسُّ
u'دَخَلَ أَشْعَث':Subject, #2: 2	دَخَلَ الْإِسْلَامَ
u'دَخَلَ أَشْهُرٌ':Predicate, #1: 1	دَخَلَ الأَشْعَثُ
u'دَخَلَ أَشْهُرٌ':Subject, #2: 2	دَخَلَ أَشْهُرَ
u'دَخِلَ أَصابِعُ':Predicate, #1: 1	دَخَلَ أَشْهُرُ
u'دَخَلَ أصل':Subject, #1: 1	أَدْخَلَ أَصَابِعَ
u'دَخَلَ أًصْلٌ':Subject, #1: 1	دَخَلَ أَصْلُهُ
u'دَخِلَ أَصْنَامٌ':Predicate, #1: 1	دَخَلَ أَصْلُهُ
u'دَخَلَ أَطْرافٌ':Predicate, #1: 1	أَدْخَلَ الْأَصْنَامَ
u'دَخَلَ أَطْرَافٌ':Predicate, #1: 1	دَخَلَ أَطْرَافَ
u'دَخِلَ إِطْعامٌ':Predicate, #1: 1	دَخَلَ أَطْرَافَ
u'دَخَلَ أعْرَابِيٌّ':Subject, #1: 1	أَدْخَلَ الْإِطْعَامَ
u'دَخَلَ أعْرَابِيٌّ':Subject, #1: 1	دَخَلَ أَعْرَابِيٌّ
u'دَخِلَ أَعْمَالٌ':Predicate, #1: 1	دَخَلَ أَعْرَابِيُّ
u'دَخَلَ أُفُقِيٌّ':Subject, #1: 1	أَدْخَلَ الْأَعْمَالَ
u'دَخَلَ أقَلُّ':Subject, #1: 1	دَخَلَ أُفُقِيٌّ
u'دَخِلَ ألف':Predicate, #6: 6	دَخَلَ الْأَقَلُّ
u'دَخَلَ أَلْوَاحٌ':Subject, #2: 2	أَدْخَلَ الْأَلِفَ
u'دَخَلَ أُمٌّ':Predicate, #1: 1	دَخَلَ أَلْوَاحُ
u'دَخَلَ إمَاءٌ':Subject, #1: 1	دَخَلَ أُمَّ
u'دَخَلَ إمَامٌ':Subject, #1: 1	دَخَلَ الْإِمَاءُ
u'دَخَلَ أَمْرٌ':Subject, #7: 7	دَخَلَ الْإِمَامُ
u'دَخَلٌ أَمْس':Added, #1: 1	دَخَلَ الْأَمْرُ
u'دَخَلَ أَميرٌ':Subject, #2: 2	دَخَلَ أَمْسِ
u'دَخَلَ إِناثٌ':Subject, #2: 2	دَخَلَ الْأَمِيرُ
u'دَخِلَ أَنْدَلُسُ':Predicate, #1: 1	دَخَلَ الْإِنَاثُ
u'دَخَلَ أَنْدَلُسُ':Predicate, #1: 1	أَدْخَلَ الْأَنْدَلُسَ
u'دَخَلَ إِنْسانٌ':Subject, #1: 1	دَخَلَ الْأَنْدَلُسَ
u'دَخَلَ أهْلٌ':Subject, #1: 1	دَخَلَ إنْسَانٌ
u'دَخَلَ أَوَّلُ':Predicate, #8: 8	دَخَلَ أَهْلُ
u'دَخَلَ أَوَّلُ':Subject, #2: 2	دَخَلَ أَوَّلَ
u'دَخَلَ أَوَّلُ':Subject, #1: 1	دَخَلَ الْأَوَّلُ
u'دَخَلَ أَوْلاَدٌ':Subject, #2: 2	دَخَلَ أَوَّلُ
u'دَخَلَ أَوْلاَدٌ':Subject, #1: 1	دَخَلَ الْأَوْلَادُ
u'دَخَلَ أَوْلاَدٌ':Subject, #1: 1	دَخَلَ أَوْلَادُ
u'دَخَلَ أيَّامٌ':Subject, #1: 1	دَخَلَ أَوْلَادُهُ
u'دَخَلَ أَيَّامٌ':Subject, #1: 1	دَخَلَ أَيَّامُ
u'دَخِلَ باء':Predicate, #1: 1	دَخَلَ أَيَّامُ
u'دَخَلَ بَابٌ':Predicate, #1: 1	أَدْخَلَ الْبَاءَ
u'دَخِلَ بَاغِي':Predicate, #1: 1	دَخَلَ الْبَابَ
u'دَخَلَ بُسْتانٌ':Predicate, #1: 1	أَدْخَلَ الْبَاغِيَ
u'دَخَلَ بَصَرٌ':Subject, #2: 2	دَخَلَ الْبُسْتَانَ
u'دَخَلَ بصرة':Predicate, #2: 2	دَخَلَ الْبَصَرُ
u'دَخَلَ بَطْنٌ':Subject, #1: 1	دَخَلَ الْبَصْرَةَ
u'دَخَلَ بَعْضٌ':Predicate, #1: 1	دَخَلَ الْبَطْنُ
u'دَخِلَ بَعْضٌ':Predicate, #1: 1	دَخَلَ الْبَعْضَ
u'دَخَلَ بَعْضٌ':Predicate, #2: 2	أَدْخَلَ بَعْضَ
u'دَخَلَ بَعْضٌ':Subject, #2: 2	دَخَلَ بَعْضَ
u'دَخَلَ بَعيرٌ':Subject, #1: 1	دَخَلَ بَعْضُ
u'دَخَلَ بَغْدادُ':Predicate, #1: 1	دَخَلَ بَعِيرٌ
u'دَخِلَ بَقَرٌ':Predicate, #6: 6	دَخَلَ بَغْدَادَ
u'دَخِلَ بَقَرٌ':Predicate, #1: 1	أَدْخَلَ الْبَقَرَ
u'دَخَلَ بِلادٌ':Predicate, #1: 1	أَدْخَلَ الْبَقَرَةَ
u'دَخَلَ بِلادٌ':Predicate, #1: 1	دَخَلَ بِلَادَ
u'دَخَلَ بَلَدٌ':Predicate, #1: 1	دَخَلَ بِلاَدَ
u'دَخَلَ بِنَاءٌ':Subject, #8: 8	دَخَلَ الْبَلَدَ
u'دَخَلَ بِنَاءٌ':Subject, #1: 1	دَخَلَ بِنَاءُ
u'دَخَلَ بِئْرٌ':Predicate, #2: 2	دَخَلَ الْبِنَاءُ
u'دَخَلَ بَيْتٌ':Predicate, #2: 2	دَخَلَ الْبِئْرَ
u'دَخَلَ بَيْتٌ':Predicate, #1: 1	دَخَلَ البَيْتَ
u'دَخَلَ بَيْتٌ':Predicate, #26: 26	دَخَلَ الْبَيْتَ
u'دَخِلَ بَيْضَةٌ':Predicate, #9: 9	دَخَلَ بَيْتَ
u'دَخَلَ بَيْنٌ':Predicate, #1: 1	أَدْخَلَ الْبَيْضَةَ
u'دَخِلَ بَيْنٌ':Predicate, #3: 3	دَخَلَ بَيْنَ
u'دَخَلَ بُيُوتٌ':Predicate, #5: 5	أَدْخَلَ بَيْنَ
u'دَخَلَ تَابِعٌ':Subject, #1: 1	دَخَلَ بُيُوتَ
u'دَخَلَ تَأَخُّرٌ':Predicate, #1: 1	دَخَلَ التَّابِعُ
u'دَخَلَ تُجَّارٌ':Subject, #1: 1	دَخَلَ تَأَخّرَ
u'دَخَلَ تُجَّارٌ':Subject, #1: 1	دَخَلَ تُجَّارُ
u'دَخَلَ تَخْصِيصٌ':Subject, #2: 2	دَخَلَ التُّجَّارُ
u'دَخَلَ تُرَابٌ':Subject, #2: 2	دَخَلَ التَّخْصِيصُ
u'دَخِلَ تَسْمِيَة':Predicate, #1: 1	دَخَلَ التُّرَابُ
u'دَخَلَ تَغْرِيبٌ':Subject, #1: 1	أَدْخَلَ التَّسْمِيَةَ
u'دَخَلَ تَقْريرٌ':Subject, #1: 1	دَخَلَ التَّغْرِيبُ
u'دَخَلَ ثَابِتٌ':Subject, #2: 2	دَخَلَ تَقْرِيرُهُ
u'دَخَلَ ثَالِثٌ':Predicate, #2: 2	دَخَلَ ثَابِتٌ
u'دَخَلَ ثَالِثٌ':Subject, #1: 1	دَخَلَ الثَّالِثَةَ
u'دَخِلَ ثَانِي':Predicate, #1: 1	دَخَلَ الثَّالِثُ
u'دَخَلَ ثَانِي':Predicate, #1: 1	أَدْخَلَ الثَّانِيَةَ
u'دَخِلَ ثَانِيَةٌ':Predicate, #5: 5	دَخَلَ الثَّانِيَةَ
u'دَخَلَ ثَانِيَةٌ':Predicate, #1: 1	أَدْخَلَ الثَّانِيَةَ
u'دَخَلَ ثَلاثُ':Subject, #5: 5	دَخَلَ الثَّانِيَةَ
u'دَخَلَ ثَلاثَةٌ':Predicate, #1: 1	دَخَلَ ثَلَاثُ
u'دَخَلَ ثَلاثَةٌ':Subject, #1: 1	دَخَلَ ثَلَاثَةَ
u'دَخَلَ ثَلاثَةٌ':Subject, #1: 1	دَخَلَ ثَلاَثَةُ
u'دَخَلَ ثُمام':Subject, #2: 2	دَخَلَ ثَلَاثَةٌ
u'دَخِلَ ثَمَنٌ':Predicate, #1: 1	دَخَلَ ثُمَامَةُ
u'دَخَلَ ثَمَنٌ':Subject, #1: 1	أَدْخَلَ الثَّمَنَ
u'دَخَلَ ثَوْبٌ':Subject, #1: 1	دَخَلَ الثَّمَنُ
u'دَخَلَ جَارِي':Predicate, #1: 1	دَخَلَ ثَوْبٌ
u'دَخَلَ جَارِيَةٌ':Predicate, #1: 1	دَخَلَ الْجَارِيَةَ
u'دَخَلَ جَازِمٌ':Subject, #1: 1	دَخَلَ الْجَارِيَةَ
u'دَخَلَ جَامِدٌ':Subject, #1: 1	دَخَلَ الْجَازِمُ
u'دَخَلَ جَامِعٌ':Predicate, #1: 1	دَخَلَ الْجَامِدُ
u'دَخَلَ جُرْحٌ':Subject, #1: 1	دَخَلَ الْجَامِعَ
u'دَخِلَ جلد':Predicate, #1: 1	دَخَلَ الْجُرْحُ
u'دَخِلَ جِلْدٌ':Predicate, #1: 1	أَدْخَلَ جِلْدَ
u'دَخَلَ جلد':Subject, #1: 1	أَدْخَلَ جِلْدَ
u'دَخَلَ جَلْدٌ':Subject, #1: 1	دَخَلَ الْجَلْدُ
u'دَخَلَ جَمَاعَةٌ':Subject, #1: 1	دَخَلَ الْجَلْدُ
u'دَخَلَ جِمَالٌ':Subject, #9: 9	دَخَلَ جَمَاعَةٌ
u'دَخَلَ جَمْعٌ':Subject, #1: 1	دَخَلَ الْجِمَالُ
u'دَخَلَ جمع':Subject, #1: 1	دَخَلَ جَمْعٌ
u'دَخَلَ جَمْعٌ':Subject, #2: 2	دَخَلَ الْجَمْعُ
u'دَخَلَ جمعة':Predicate, #2: 2	دَخَلَ الْجَمْعُ
u'دَخَلَ جُمُعَةٌ':Predicate, #2: 2	دَخَلَ الْجُمُعَةَ
u'دَخَلَ جَمَلٌ':Subject, #2: 2	دَخَلَ الْجُمُعَةَ
u'دَخَلَ جَنَّةٌ':Predicate, #2: 2	دَخَلَ الْجَمَلُ
u'دَخَلَ جَنَّةٌ':Predicate, #1: 1	دَخَلَ الجَنَّةَ
u'دَخَلَ جَنَّةٌ':Predicate, #3: 3	دَخَلَ الْجَنّةَ
u'دَخَلٌ جوف':Added, #89: 89	دَخَلَ الْجَنَّةَ
u'دَخَلٌ جَوْفٌ':Added, #1: 1	دَخَلَ جَوْفِهِ
u'دَخَلَ جَيْشٌ':Subject, #1: 1	دَخَلَ جَوْفِهِ
u'دَخَلَ حاجٌّ':Subject, #4: 4	دَخَلَ الْجَيْشُ
u'دَخَلَ حائِطٌ':Predicate, #1: 1	دَخَلَ الْحَاجُّ
u'دَخَلَ حائِطٌ':Subject, #1: 1	دَخَلَ الْحَائِطَ
u'دَخَلَ حَبْلٌ':Subject, #1: 1	دَخَلَ الْحَائِطُ
u'دَخِلَ حَجٌّ':Predicate, #1: 1	دَخَلَ الْحَبْلُ
u'دَخَلَ حُجَّاجٌ':Subject, #4: 4	أَدْخَلَ الْحَجَّ
u'دَخَلَ حجاز':Predicate, #1: 1	دَخَلَ الْحُجَّاجُ
u'دَخَلَ حَدٌّ':Subject, #2: 2	دَخَلَ الْحِجَازَ
u'دَخِلَ حَديثٌ':Predicate, #1: 1	دَخَلَ الْحَدُّ
u'دَخَلَ حَديثٌ':Subject, #1: 1	أَدْخَلَ الْحَدِيثَ
u'دَخَلَ حَرامٌ':Predicate, #2: 2	دَخَلَ حَدِيثُ
u'دَخَلَ حِرْزٌ':Predicate, #1: 1	دَخَلَ الْحَرَامَ
u'دَخَلَ حِرْزٌ':Subject, #4: 4	دَخَلَ الْحِرْزَ
u'دَخِلَ حَرْفٌ':Predicate, #2: 2	دَخَلَ الْحِرْزُ
u'دَخَلَ حَرْفٌ':Subject, #5: 5	أَدْخَلَ حَرْفَ
u'دَخَلَ حَرَمٌ':Predicate, #2: 2	دَخَلَ حَرْفُ
u'دَخَلَ حَرَمٌ':Predicate, #1: 1	دَخَلَ حَرَمَ
u'دَخِلَ حَرَمٌ':Predicate, #25: 25	دَخَلَ الْحَرَمَ
u'دَخَلٌ حَرَمٌ':Added, #2: 2	أَدْخَلَ الْحَرَمَ
u'دَخَلَ حِصْنٌ':Predicate, #1: 1	دَخَلَ الْحَرَمِ
u'دَخَلَ حَطِيم':Predicate, #1: 1	دَخَلَ الْحِصْنَ
u'دَخَلَ حَظِيرَةٌ':Predicate, #1: 1	دَخَلَ الْحَطِيمَ
u'دَخَلَ حَقٌّ':Subject, #1: 1	دَخَلَ الْحَظِيرَةَ
u'دَخَلَ حُكْمٌ':Subject, #1: 1	دَخَلَ حَقُّ
u'دَخِلَ حِمَارٌ':Predicate, #1: 1	دَخَلَ حُكْمُ
u'دَخَلَ حِمَارٌ':Subject, #1: 1	أَدْخَلَ الْحِمَارَ
u'دَخَلَ حَمَّامٌ':Predicate, #1: 1	دَخَلَ حِمَارُ
u'دَخَلَ حَمَّامٌ':Predicate, #24: 24	دَخَلَ الْحَمَّامَ
u'دَخَلَ حَمَامٌ':Subject, #3: 3	دَخَلَ حَمَّامَ
u'دَخَلٌ حَمَّامٌ':Added, #1: 1	دَخَلَ حَمَامٌ
u'دَخِلَ حِنْطَةٌ':Predicate, #1: 1	دَخَلَ الْحَمَّامَاتِ
u'دَخَلَ حِنْطَةٌ':Predicate, #1: 1	أَدْخَلَ الْحِنْطَةَ
u'دَخِلَ حَيٌّ':Predicate, #1: 1	دَخَلَ الْحِنْطَةَ
u'دَخِلَ حَيَّةٌ':Predicate, #1: 1	أَدْخَلَ الْحَيَّةَ
u'دَخَلَ حَيَوَانٌ':Subject, #1: 1	أَدْخَلَ الْحَيَّةَ
u'دَخَلَ حَيَوَانٌ':Subject, #1: 1	دَخَلَ حَيَوَانٌ
u'دَخَلَ خَادِمٌ':Subject, #1: 1	دَخَلَ حَيَوَانُ
u'دَخَلَ خَبَّازٌ':Subject, #2: 2	دَخَلَ الْخَادِمُ
u'دَخَلَ خُصٌّ':Predicate, #2: 2	دَخَلَ الْخَبَّازُ
u'دَخَلَ خَطِيبٌ':Subject, #1: 1	دَخَلَ خُصَّ
u'دَخَلَ خَلاَءٌ':Predicate, #1: 1	دَخَلَ الْخَطِيبُ
u'دَخَلَ خَلاَءٌ':Predicate, #2: 2	دَخَلَ الْخَلاءَ
u'دَخَلَ خَلاَءٌ':Predicate, #6: 6	دَخَلَ الْخَلاَءَ
u'دَخِلَ خَمْرٌ':Predicate, #8: 8	دَخَلَ الْخَلَاءَ
u'دَخَلَ دَاءٌ':Subject, #1: 1	أَدْخَلَ الْخَمْرَ
u'دَخِلَ دَابَّةٌ':Predicate, #1: 1	دَخَلَ دَاءٌ
u'دَخَلَ دَارٌ':Predicate, #1: 1	أَدْخَلَ الدَّابَّةَ
u'دَخَلَ دَارٌ':Predicate, #2: 2	دَخَلَ دَارَكَ
u'دَخَلَ دَارٌ':Predicate, #52: 52	دَخَلَ الدَّارَ
u'دَخَلٌ دَارٌ':Added, #97: 97	دَخَلَ دَارَ
u'دَخَلَ دُخَانٌ':Subject, #10: 10	دَخَلَ دَارِهِ
u'دَخَلَ دَرَاهِمُ':Predicate, #1: 1	دَخَلَ الدُّخَانُ
u'دَخَلَ دُكَّانٌ':Predicate, #1: 1	دَخَلَ دَرَاهِمَ
u'دَخَلَ دَمْعٌ':Subject, #1: 1	دَخَلَ دُكَّانَ
u'دَخَلَ دمع':Subject, #1: 1	دَخَلَ دَمْعٌ
u'دَخَلَ دَمْعٌ':Subject, #1: 1	دَخَلَ دَمْعُهُ
u'دَخَلَ دِهْليزٌ':Predicate, #1: 1	دَخَلَ دَمْعُهُ
u'دَخَلَ دِهْليزٌ':Predicate, #1: 1	دَخَلَ دِهْلِيزَ
u'دَخَلَ دُهْنٌ':Subject, #3: 3	دَخَلَ الدِّهْلِيزَ
u'دَخِلَ دونٌ':Predicate, #1: 1	دَخَلَ الدُّهْنُ
u'دَخَلَ ذُبابٌ':Subject, #1: 1	أَدْخَلَ دُونَ
u'دَخَلَ ذكر':Subject, #1: 1	دَخَلَ ذُبَابٌ
u'دَخَلَ ذَكَرٌ':Subject, #1: 1	دَخَلَ ذَكَرُهُ
u'دَخَلَ ذُكورٌ':Subject, #1: 1	دَخَلَ ذَكَرُهُ
u'دَخَلَ ذِمِّيٌّ':Subject, #2: 2	دَخَلَ الذُّكُورُ
u'دَخَلَ ذِمِّيٌّ':Subject, #1: 1	دَخَلَ الذِّمِّيُّ
u'دَخِلَ رَأْسٌ':Predicate, #2: 2	دَخَلَ ذِمِّيٌّ
u'دَخِلَ رَأْسٌ':Predicate, #1: 1	أَدْخَلَ الرَّأْسَ
u'دَخَلَ رَأْسٌ':Subject, #2: 2	أَدْخَلَ رَأْسَ
u'دَخَلَ رَاهِنٌ':Subject, #1: 1	دَخَلَ رَأْسُهُ
u'دَخَلَ رَبُّ':Subject, #1: 1	دَخَلَ الرَّاهِنُ
u'دَخَلَ رَبُّ':Subject, #1: 1	دَخَلَ رَبُّ
u'دَخَلَ رُبُعٌ':Subject, #1: 1	دَخَلَ رَبُّهُ
u'دَخَلَ رِجَالٌ':Subject, #1: 1	دَخَلَ رُبُعُ
u'دَخَلَ رَجَبٌ':Subject, #1: 1	دَخَلَ الرّجَالُ
u'دَخَلَ رَجُلٌ':Subject, #1: 1	دَخَلَ رَجَبٌ
u'دَخَلَ رَجُلٌ':Subject, #12: 12	دَخَلَ الرَّجُلُ
u'دَخَلَ رَسُولٌ':Subject, #39: 39	دَخَلَ رَجُلٌ
u'دَخَلَ رَمَضانُ':Predicate, #66: 66	دَخَلَ رَسُولُ
u'دَخَلَ رَمَضانُ':Subject, #2: 2	دَخَلَ رَمَضَانَ
u'دَخَلَ رَهْطٌ':Subject, #25: 25	دَخَلَ رَمَضَانُ
u'دَخَلَ روحٌ':Subject, #1: 1	دَخَلَ رَهْطٌ
u'دَخَلَ زَمِن':Predicate, #1: 1	دَخَلَ الرُّوحُ
u'دَخَلَ زَوْجٌ':Subject, #2: 2	دَخَلَ زَمِنَةً
u'دَخَلَ زَيْدٌ':Subject, #9: 9	دَخَلَ الزَّوْجُ
u'دَخَلَ زَيْدٌ':Subject, #4: 4	دَخَلَ زَيْدُ
u'دَخَلَ سَارِقٌ':Subject, #6: 6	دَخَلَ زَيْدٌ
u'دَخَلَ سَارِقٌ':Subject, #1: 1	دَخَلَ سَارِقٌ
u'دَخَلَ سَبَبٌ':Subject, #3: 3	دَخَلَ السَّارِقُ
u'دَخِلَ سَبْعَةٌ':Predicate, #1: 1	دَخَلَ سَبَبُ
u'دَخَلَ سَخِيٌّ':Subject, #1: 1	أَدْخَلَ سَبْعَةَ
u'دَخِلَ سِرَاجٌ':Predicate, #1: 1	دَخَلَ السَّخِيُّ
u'دَخَلَ سَعْدٌ':Subject, #1: 1	أَدْخَلَ السِّرَاجَ
u'دَخِلَ سكر':Predicate, #1: 1	دَخَلَ سَعْدٌ
u'دَخِلَ سُكْرٌ':Predicate, #2: 2	أَدْخَلَ السُّكْرَ
u'دَخِلَ سِكِّينٌ':Predicate, #2: 2	أَدْخَلَ السُّكْرَ
u'دَخِلَ سِمْسِم':Predicate, #3: 3	أَدْخَلَ السِّكِّينَ
u'دَخَلَ سَمَكٌ':Subject, #1: 1	أَدْخَلَ سِمْسِمَةً
u'دَخَلَ سَهْمٌ':Subject, #2: 2	دَخَلَ السَّمَكُ
u'دَخَلَ سَواءٌ':Subject, #2: 2	دَخَلَ سَهْمُهُ
u'دَخَلَ سُوقٌ':Predicate, #2: 2	دَخَلَ سَوَاءٌ
u'دَخَلَ سَيِّدٌ':Subject, #5: 5	دَخَلَ السُّوقَ
u'دَخَلَ سَيْفٌ':Subject, #1: 1	دَخَلَ سَيِّدُهُ
u'دَخَلَ شَابٌّ':Subject, #1: 1	دَخَلَ السَّيْفُ
u'دَخَلَ شافِعِيّ':Subject, #1: 1	دَخَلَ شَابٌّ
u'دَخَلَ شَبابٌ':Subject, #1: 1	دَخَلَ الشَّافِعِيُّ
u'دَخَلَ شَبَابٌ':Subject, #1: 1	دَخَلَ شَبَابٌ
u'دَخَلَ شَخْصٌ':Subject, #1: 1	دَخَلَ شَبَابٌ
u'دَخَلَ شرب':Predicate, #1: 1	دَخَلَ شَخْصٌ
u'دَخَلَ شرب':Subject, #1: 1	دَخَلَ شَرِبَ
u'دَخَلَ شِرْبٌ':Subject, #4: 4	دَخَلَ الشِّرْبُ
u'دَخَلَ شَرْطٌ':Subject, #4: 4	دَخَلَ الشِّرْبُ
u'دَخَلَ شَعْبَانُ':Subject, #3: 3	دَخَلَ الشَّرْطُ
u'دَخَلَ شَعْبِيٌّ':Subject, #1: 1	دَخَلَ شَعْبَانُ
u'دَخِلَ شَكٌّ':Predicate, #2: 2	دَخَلَ الشَّعْبِيُّ
u'دَخَلَ شَهْرٌ':Subject, #7: 7	أَدْخَلَ الشَّكَّ
u'دَخَلَ شَهْرٌ':Subject, #1: 1	دَخَلَ شَهْرٌ
u'دَخَلَ شَهْرٌ':Subject, #5: 5	دَخَلَ الشَّهْرُ
u'دَخَلَ شَوَّالٌ':Subject, #7: 7	دَخَلَ شَهْرُ
u'دَخَلَ شَوْكٌ':Subject, #2: 2	دَخَلَ شَوَّالٌ
u'دَخَلَ شَوْكِ':Subject, #2: 2	دَخَلَ الشَّوْكُ
u'دَخَلَ شَيْبَةٌ':Subject, #2: 2	دَخَلَ الشَّوْكُ
u'دَخَلَ شَيْطَانٌ':Subject, #1: 1	دَخَلَ شَيْبَةُ
u'دَخَلَ صَبِيٌّ':Subject, #2: 2	دَخَلَ الشَّيْطَانُ
u'دَخَلَ صِبْيَانٌ':Subject, #2: 2	دَخَلَ صَبِيٌّ
u'دَخَلَ صَحَابَةٌ':Subject, #1: 1	دَخَلَ الصِّبْيَانُ
u'دَخَلَ صَحْنٌ':Predicate, #1: 1	دَخَلَ الصَّحَابَةُ
u'دَخَلَ صداق':Subject, #3: 3	دَخَلَ صَحْنَ
u'دَخَلَ صَدَاقٌ':Subject, #1: 1	دَخَلَ الصَّدَاقُ
u'دَخَلَ صَفٌّ':Predicate, #1: 1	دَخَلَ الصَّدَاقُ
u'دَخَلَ صَلاَةٌ':Predicate, #5: 5	دَخَلَ الصَّفَّ
u'دَخَلَ صَوْمٌ':Subject, #1: 1	دَخَلَ الصَّلاَةَ
u'دَخَلَ صَوْمٌ':Subject, #1: 1	دَخَلَ الصَّوْمُ
u'دَخَلَ صِيَامٌ':Subject, #1: 1	دَخَلَ صَوْمُهُ
u'دَخِلَ صَيْدٌ':Predicate, #1: 1	دَخَلَ الصِّيَامُ
u'دَخَلَ صَيْدٌ':Subject, #1: 1	أَدْخَلَ صَيْدَ
u'دَخَلَ صَيْدٌ':Subject, #13: 13	دَخَلَ الصَّيْدُ
u'دَخَلَ ضَرَرٌ':Subject, #2: 2	دَخَلَ صَيْدٌ
u'دَخَلَ ضَمَانٌ':Subject, #1: 1	دَخَلَ الضَّرَرُ
u'دَخَلَ ضَيْفٌ':Subject, #2: 2	دَخَلَ ضَمَانُ
u'دَخَلَ ضَيْمٌ':Subject, #1: 1	دَخَلَ ضَيْفٌ
u'دَخَلَ طَاقٌ':Predicate, #1: 1	دَخَلَ الضَّيْمُ
u'دَخَلَ طَرِيقٌ':Subject, #5: 5	دَخَلَ طَاقَ
u'دَخَلَ طواف':Predicate, #2: 2	دَخَلَ الطَّرِيقُ
u'دَخَلَ طَوَافٌ':Predicate, #1: 1	دَخَلَ الطَّوَافَ
u'دَخَلَ ظاهِرٌ':Subject, #1: 1	دَخَلَ الطَّوَافَ
u'دَخَلَ ظاهِرَة':Subject, #1: 1	دَخَلَ ظَاهِرَةٌ
u'دَخَلَ ظَبْيٌ':Subject, #1: 1	دَخَلَ ظَاهِرَةٌ
u'دَخَلٌ ظفار':Added, #1: 1	دَخَلَ ظَبْيٌ
u'دَخَلَ عَاشِرٌ':Subject, #1: 1	دَخَلَ ظَفَارِ
u'دَخَلَ عَالَمٌ':Subject, #1: 1	دَخَلَ الْعَاشِرُ
u'دَخَلَ عَامٌ':Predicate, #1: 1	دَخَلَ عَالَمٌ
u'دَخَلَ عَبَّاسٌ':Subject, #5: 5	دَخَلَ عَامَ
u'دَخَلَ عَبْدٌ':Subject, #1: 1	دَخَلَ الْعَبَّاسُ
u'دَخَلَ عَبْدٌ':Subject, #5: 5	دَخَلَ عَبْدُ
u'دَخَلَ عتبة':Predicate, #6: 6	دَخَلَ الْعَبْدُ
u'دَخَلَ عَتَبَةٌ':Predicate, #1: 1	دَخَلَ عَتَبَةَ
u'دَخَلَ عتق':Predicate, #1: 1	دَخَلَ عَتَبَةَ
u'دَخَلَ عِرَاقٌ':Predicate, #8: 8	دَخَلَ عَتَقَ
u'دَخَلَ عَسْكَرٌ':Subject, #1: 1	دَخَلَ الْعِرَاقَ
u'دَخَلَ عَسْكَرٌ':Subject, #2: 2	دَخَلَ عَسْكَرٌ
u'دَخَلَ عَشْرٌ':Subject, #5: 5	دَخَلَ الْعَسْكَرُ
u'دَخَلَ عَفْوٌ':Subject, #9: 9	دَخَلَ الْعَشْرُ
u'دَخَلَ عَقِبٌ':Predicate, #1: 1	دَخَلَ الْعَفْوُ
u'دَخَلَ عَلِيٌّ':Subject, #1: 1	دَخَلَ عَقِبَ
u'دَخَلَ عَلِيٌّ':Subject, #1: 1	دَخَلَ عَلِيُّ
u'دَخَلَ عُمَرٌ':Subject, #2: 2	دَخَلَ عَلِيٌّ
u'دَخَلَ عُمْرَانٌ':Predicate, #10: 10	دَخَلَ عُمَرُ
u'دَخِلَ عمرة':Predicate, #1: 1	دَخَلَ الْعُمْرَانَ
u'دَخِلَ عُمْرَةٌ':Predicate, #1: 1	أَدْخَلَ الْعُمْرَةَ
u'دَخَلَ عند':Predicate, #1: 1	أَدْخَلَ الْعُمْرَةَ
u'دَخَلَ عَيْبٌ':Subject, #2: 2	دَخَلَ عِنْدَ
u'دَخَلَ غَاصِبٌ':Subject, #3: 3	دَخَلَ الْعَيْبُ
u'دَخَلَ غبار':Subject, #1: 1	دَخَلَ غَاصِبٌ
u'دَخَلَ غُبَارٌ':Subject, #2: 2	دَخَلَ الْغُبَارُ
u'دَخَلَ غَدٌ':Subject, #2: 2	دَخَلَ الْغُبَارُ
u'دَخَلَ غُصْنٌ':Subject, #1: 1	دَخَلَ الْغَدُ
u'دَخَلَ غُلاَمٌ':Subject, #2: 2	دَخَلَ الْغُصْنُ
u'دَخَلَ غَلَّةٌ':Subject, #1: 1	دَخَلَ غُلَامُ
u'دَخِلَ غير':Predicate, #1: 1	دَخَلَ غَلَّةُ
u'دَخِلَ غَيْرٌ':Predicate, #1: 1	أَدْخَلَ غَيْرَ
u'دَخَلَ غير':Predicate, #1: 1	أَدْخَلَ غَيْرَ
u'دَخَلَ غَيْرٌ':Predicate, #1: 1	دَخَلَ غَيْرَ
u'دَخَلَ غير':Subject, #1: 1	دَخَلَ غَيْرَ
u'دَخَلَ غَيْرٌ':Subject, #1: 1	دَخَلَ غَيْرُهُ
u'دَخَلَ غَيْضَةٌ':Predicate, #1: 1	دَخَلَ غَيْرُهُ
u'دَخَلَ فاء':Subject, #1: 1	دَخَلَ الْغَيْضَةَ
u'دَخَلَ فَاضِلٌ':Subject, #1: 1	دَخَلَ الْفَاءُ
u'دَخَلَ فُرْجَةٌ':Predicate, #1: 1	دَخَلَ الْفَاضِلُ
u'دَخَلَ فِرْعَوْنُ':Subject, #3: 3	دَخَلَ الْفُرْجَةَ
u'دَخَلَ فَرِيقٌ':Subject, #1: 1	دَخَلَ فِرْعَوْنُ
u'دَخِلَ فساد':Predicate, #1: 1	دَخَلَ الْفَرِيقُ
u'دَخِلَ فَسَادٌ':Predicate, #2: 2	أَدْخَلَ الْفَسَادَ
u'دَخَلَ فساد':Subject, #2: 2	أَدْخَلَ الْفَسَادَ
u'دَخَلَ فَسَادٌ':Subject, #3: 3	دَخَلَ الْفَسَادُ
u'دَخَلَ فُسْطَاطٌ':Predicate, #3: 3	دَخَلَ الْفَسَادُ
u'دَخَلَ فَصٌّ':Subject, #2: 2	دَخَلَ فُسْطَاطَ
u'دَخِلَ فَصِيلٌ':Predicate, #1: 1	دَخَلَ الْفَصُّ
u'دَخَلَ فَضْلٌ':Subject, #1: 1	أَدْخَلَ فَصِيلَ
u'دَخَلَ فِعْلٌ':Subject, #1: 1	دَخَلَ الْفَضْلُ
u'دَخَلَ فَقِيهٌ':Subject, #1: 1	دَخَلَ الْفِعْلُ
u'دَخَلَ فلان':Predicate, #1: 1	دَخَلَ الْفَقِيهُ
u'دَخِلَ فلان':Predicate, #107: 107	دَخَلَ مَكَّةَ
u'دَخَلَ فلان':Predicate, #1: 1	أَدْخَلَ سِمْسِمَةً
u'دَخَلَ فُلاَنٌ':Subject, #7: 7	دَخَلَ مَكّةَ
u'دَخَلَ فلان':Subject, #16: 16	دَخَلَ فُلَانٌ
u'دَخَلَ فلان':Subject, #1: 1	دَخَلَ الشَّافِعِيُّ
u'دَخَلَ فُلاَنٌ':Subject, #1: 1	دَخَلَ بُرَيْدَةُ
u'دَخَلَ فلان':Subject, #1: 1	دَخَلَ فُلَانُ
u'دَخَلَ فلان':Subject, #1: 1	دَخَلَ هَارُونُ
u'دَخَلَ فلان':Subject, #2: 2	دَخَلَ سُفْيَانُ
u'دَخَلَ فلان':Subject, #2: 2	دَخَلَ مُعَاوِيَةُ
u'دَخَلَ فَمٌ':Predicate, #4: 4	دَخَلَ عُثْمَانُ
u'دَخَلَ قَادِمٌ':Subject, #2: 2	دَخَلَ فَمَ
u'دَخَلٌ قَاعَةٌ':Added, #1: 1	دَخَلَ الْقَادِمُ
u'دَخَلَ قَالٌ':Predicate, #1: 1	دَخَلَ قَاعَاتِ
u'دَخَلَ قَبْرٌ':Predicate, #7: 7	دَخَلَ قَالَ
u'دَخَلَ قَبْرٌ':Predicate, #2: 2	دَخَلَ قَبْرَ
u'دَخِلَ قَرْضٌ':Predicate, #3: 3	دَخَلَ الْقَبْرَ
u'دَخَلَ قَرْنٌ':Subject, #1: 1	أَدْخَلَ الْقَرْضَ
u'دَخَلَ قَرِيبٌ':Subject, #2: 2	دَخَلَ قَرْنُ
u'دَخَلَ قَرْيَةٌ':Predicate, #1: 1	دَخَلَ الْقَرِيبُ
u'دَخَلَ قَلِيلٌ':Subject, #1: 1	دَخَلَ الْقَرْيَةَ
u'دَخَلَ قَنَاةٌ':Predicate, #1: 1	دَخَلَ الْقَلِيلُ
u'دَخَلَ قَوْمٌ':Subject, #1: 1	دَخَلَ الْقَنَاةَ
u'دَخَلَ قَوْمٌ':Subject, #3: 3	دَخَلَ الْقَوْمُ
u'دَخَلَ قِيمَةٌ':Subject, #4: 4	دَخَلَ قَوْمٌ
u'دَخَلَ كَافِرٌ':Subject, #1: 1	دَخَلَ قِيمَةُ
u'دَخِلَ كِتَابٌ':Predicate, #2: 2	دَخَلَ الْكَافِرُ
u'دَخَلَ كَرْمٌ':Predicate, #1: 1	أَدْخَلَ الْكِتَابَ
u'دَخَلَ كعبة':Predicate, #2: 2	دَخَلَ كَرْمَ
u'دَخَلَ كَعْبَةٌ':Predicate, #18: 18	دَخَلَ الْكَعْبَةَ
u'دَخِلَ كَفٌّ':Predicate, #18: 18	دَخَلَ الْكَعْبَةَ
u'دَخِلَ كُفَّارٌ':Predicate, #1: 1	أَدْخَلَ الْكَفَّ
u'دَخَلَ كُفَّارٌ':Subject, #1: 1	أَدْخَلَ الْكُفَّارَ
u'دَخَلَ كَلاَمٌ':Subject, #3: 3	دَخَلَ الْكُفَّارُ
u'دَخَلَ كَنِيفٌ':Predicate, #1: 1	دَخَلَ الْكَلَامُ
u'دَخَلَ كُوفَةٌ':Predicate, #1: 1	دَخَلَ الْكَنِيفَ
u'دَخَلَ كُوفِيٌّ':Subject, #1: 1	دَخَلَ الْكُوفَةَ
u'دَخِلَ لاَمٌ':Predicate, #1: 1	دَخَلَ كُوفِيٌّ
u'دَخِلَ لاَمٌ':Predicate, #1: 1	أَدْخَلَ اللَّامَ
u'دَخِلَ لَحْمٌ':Predicate, #1: 1	أَدْخَلَ لَامَ
u'دَخَلَ لِصٌّ':Subject, #1: 1	أَدْخَلَ اللَّحْمَ
u'دَخِلَ لِفَافَةٌ':Predicate, #2: 2	دَخَلَ اللِّصُّ
u'دَخِلَ لَوْحٌ':Predicate, #1: 1	أَدْخَلَ اللِّفَافَةَ
u'دَخَلَ لَيْلٌ':Subject, #2: 2	أَدْخَلَ اللَّوْحَ
u'دَخَلَ مَاءٌ':Predicate, #2: 2	دَخَلَ اللَّيْلُ
u'دَخَلَ مَاءٌ':Subject, #2: 2	دَخَلَ الْمَاءَ
u'دَخَلَ مَالٌ':Subject, #21: 21	دَخَلَ الْمَاءُ
u'دَخِلَ مَأْمُورٌ':Predicate, #3: 3	دَخَلَ الْمَالُ
u'دَخَلَ مَجَازٌ':Subject, #1: 1	أَدْخَلَ الْمَأْمُورَ
u'دَخَلَ مَحْدُودٌ':Subject, #1: 1	دَخَلَ الْمَجَازُ
u'دَخَلَ مُحْرِمٌ':Subject, #1: 1	دَخَلَ الْمَحْدُودُ
u'دَخَلَ مَحْرَمٌ':Subject, #1: 1	دَخَلَ الْمُحْرِمُ
u'دَخَلَ مُحَمَّدٌ':Subject, #1: 1	دَخَلَ مَحْرَمُهُ
u'دَخَلَ مُخَاطٌ':Subject, #2: 2	دَخَلَ مُحَمَّدُ
u'دَخَلَ مَخْرَجٌ':Predicate, #2: 2	دَخَلَ الْمُخَاطُ
u'دَخَلَ مَدَاخِلُ':Predicate, #1: 1	دَخَلَ الْمَخْرَجَ
u'دَخَلَ مَدْخَلٌ':Predicate, #1: 1	دَخَلَ مَدَاخِلَ
u'دَخَلَ مَدِينٌ':Predicate, #4: 4	دَخَلَ مَدْخَلَ
u'دَخَلٌ مَدِينٌ':Added, #11: 11	دَخَلَ الْمَدِينَةَ
u'دَخَلَ مَدِينَةٌ':Predicate, #1: 1	دَخَلَ الْمَدِينَةِ
u'دَخَلٌ مَدِينَةٌ':Added, #11: 11	دَخَلَ الْمَدِينَةَ
u'دَخَلَ مرٌّ':Predicate, #1: 1	دَخَلَ الْمَدِينَةِ
u'دَخِلَ مَرَارَةٌ':Predicate, #2: 2	دَخَلَ مَرَّةً
u'دَخِلَ مَرَافِقُ':Predicate, #2: 2	أَدْخَلَ الْمَرَارَةَ
u'دَخَلَ مرو':Predicate, #1: 1	أَدْخَلَ الْمَرَافِقَ
u'دَخَلَ مَسَافَةٌ':Predicate, #1: 1	دَخَلَ مَرْوَ
u'دَخَلَ مُسَافِرٌ':Subject, #1: 1	دَخَلَ مَسَافَةَ
u'دَخَلَ مُسَافِرٌ':Subject, #12: 12	دَخَلَ الْمُسَافِرُ
u'دَخَلَ مساكين':Subject, #2: 2	دَخَلَ مُسَافِرٌ
u'دَخَلَ مَسْأَلَةٌ':Predicate, #1: 1	دَخَلَ الْمَسَاكِينُ
u'دَخَلَ مَسْأَلَةٌ':Subject, #1: 1	دَخَلَ مَسْأَلَةَ
u'دَخَلَ مَسْبُوق':Subject, #1: 1	دَخَلَ مَسْأَلَةُ
u'دَخَلَ مَسْبُوق':Subject, #1: 1	دَخَلَ الْمَسْبُوقُ
u'دَخَلَ مُسْتَرَاحٌ':Predicate, #1: 1	دَخَلَ مَسْبُوقٌ
u'دَخَلَ مَسْجِدٌ':Predicate, #1: 1	دَخَلَ الْمُسْتَرَاحَ
u'دَخَلَ مَسْجِدٌ':Predicate, #169: 169	دَخَلَ الْمَسْجِدَ
u'دَخَلَ مُسْلِمٌ':Subject, #5: 5	دَخَلَ مَسْجِدَ
u'دَخَلَ مُسْلِمٌ':Subject, #14: 14	دَخَلَ مُسْلِمٌ
u'دَخَلَ مُسَنّاة':Subject, #15: 15	دَخَلَ الْمُسْلِمُ
u'دَخَلَ مِصْرٌ':Predicate, #1: 1	دَخَلَ الْمُسَنَّاةُ
u'دَخَلَ مِصْرٌ':Predicate, #11: 11	دَخَلَ الْمِصْرَ
u'دَخَلَ مُعاوِيَة':Subject, #1: 1	دَخَلَ مِصْرَ
u'دَخِلَ مُغِلّ':Predicate, #2: 2	دَخَلَ مُعَاوِيَةُ
u'دَخَلَ مَقَابِرُ':Predicate, #1: 1	أَدْخَلَ مُغِلَّ
u'دَخَلَ مَقْصُورٌ':Predicate, #1: 1	دَخَلَ الْمَقَابِرَ
u'دَخَلَ مَقْصُورٌ':Predicate, #1: 1	دَخَلَ مَقْصُورَةً
u'دَخَلَ مَقْصُورَةٌ':Predicate, #1: 1	دَخَلَ مَقْصُورَةَ
u'دَخَلَ مُكْحُلَةٌ':Predicate, #1: 1	دَخَلَ مَقْصُورَةَ
u'دَخَلَ مَنْزِلٌ':Predicate, #1: 1	دَخَلَ الْمُكْحُلَةَ
u'دَخَلَ مُؤَذِّنٌ':Subject, #3: 3	دَخَلَ مَنْزِلَ
u'دَخَلَ مَوْضِعٌ':Predicate, #1: 1	دَخَلَ الْمُؤَذِّنُ
u'دَخِلَ مُؤْمِنٌ':Predicate, #1: 1	دَخَلَ الْمَوْضِعَ
u'دَخَلَ نَارٌ':Predicate, #1: 1	أَدْخَلَ الْمُؤْمِنَ
u'دَخَلَ نَاسٌ':Subject, #24: 24	دَخَلَ النَّارَ
u'دَخَلَ نَاسٌ':Subject, #1: 1	دَخَلَ نَاسٌ
u'دَخَلَ نَاسٌ':Subject, #3: 3	دَخَلَ النّاسُ
u'دَخَلَ نَائِبٌ':Subject, #6: 6	دَخَلَ النَّاسُ
u'دَخَلَ نَبِيٌّ':Subject, #1: 1	دَخَلَ النَّائِبُ
u'دَخَلَ نَجْرَان':Predicate, #24: 24	دَخَلَ النَّبِيُّ
u'دَخَلَ نَجْمٌ':Subject, #1: 1	دَخَلَ نَجْرَانَ
u'دَخَلَ نَحْنَح':Predicate, #2: 2	دَخَلَ نَجْمٌ
u'دَخَلَ نَحْنَحَة':Predicate, #1: 1	دَخَلَ النَّحْنَحَةَ
u'دَخَلَ نَحْوٌ':Subject, #1: 1	دَخَلَ النَّحْنَحَةَ
u'دَخَلَ نَخْلٌ':Predicate, #1: 1	دَخَلَ نَحْوُ
u'دَخَلَ نَخْلٌ':Subject, #3: 3	دَخَلَ نَخْلاً
u'دَخَلَ نِساءٌ':Subject, #1: 1	دَخَلَ النَّخْلُ
u'دَخَلَ نِساءٌ':Subject, #1: 1	دَخَلَ نِسَاءٌ
u'دَخَلَ نِصْفٌ':Subject, #2: 2	دَخَلَ النِّسَاءُ
u'دَخَلَ نَصْلٌ':Subject, #2: 2	دَخَلَ النِّصْفُ
u'دَخَلَ نَظَرٌ':Predicate, #1: 1	دَخَلَ النَّصْلُ
u'دَخَلَ نَفَرٌ':Subject, #1: 1	دَخَلَ نَظَرَ
u'دَخِلَ نَقْصٌ':Predicate, #2: 2	دَخَلَ نَفَرٌ
u'دَخَلَ نَقْصٌ':Subject, #9: 9	أَدْخَلَ النَّقْصَ
u'دَخَلَ نَقْصٌ':Subject, #1: 1	دَخَلَ نَقْصٌ
u'دَخَلَ نُقْصَانٌ':Subject, #4: 4	دَخَلَ النَّقْصُ
u'دَخِلَ نَقْضٌ':Predicate, #1: 1	دَخَلَ النُّقْصَانُ
u'دَخَلَ نَهْرٌ':Predicate, #2: 2	أَدْخَلَ النَّقْضَ
u'دَخَلَ هِلاَلٌ':Subject, #1: 1	دَخَلَ النَّهْرَ
u'دَخَلَ واحد':Subject, #1: 1	دَخَلَ هِلَالُ
u'دَخَلَ وَاحِدٌ':Subject, #5: 5	دَخَلَ الْوَاحِدُ
u'دَخَلَ واحد':Subject, #5: 5	دَخَلَ الْوَاحِدُ
u'دَخَلَ وَاحِدٌ':Subject, #8: 8	دَخَلَ وَاحِدٌ
u'دَخَلَ وَادِي':Predicate, #8: 8	دَخَلَ وَاحِدٌ
u'دَخَلَ وَارِثٌ':Subject, #1: 1	دَخَلَ الْوَادِيَ
u'دَخَلَ وَارِثٌ':Subject, #1: 1	دَخَلَ الْوَارِثُ
u'دَخَلٌ وَاقِعٌ':Added, #1: 1	دَخَلَ وَارِثُهُ
u'دَخَلَ وَجَبٌ':Predicate, #1: 1	دَخَلَ الْوَاقِعِ
u'دَخَلَ وُجُودٌ':Predicate, #1: 1	دَخَلَ وَجَبَ
u'دَخَلَ وَصْفٌ':Subject, #1: 1	دَخَلَ الْوُجُودَ
u'دَخَلَ وَصِيٌّ':Predicate, #1: 1	دَخَلَ الْوَصْفُ
u'دَخَلَ وَصِيَّةٌ':Predicate, #1: 1	دَخَلَ الْوَصِيَّةَ
u'دَخَلَ وَفْدٌ':Subject, #1: 1	دَخَلَ الْوَصِيَّةَ
u'دَخَلَ وَفْقٌ':Predicate, #1: 1	دَخَلَ وَفْدُ
u'دَخَلَ وَقْتٌ':Predicate, #1: 1	دَخَلَ وَفْقَ
u'دَخَلَ وَقْتٌ':Subject, #2: 2	دَخَلَ وَقْتَ
u'دَخَلَ وَقْتٌ':Subject, #22: 22	دَخَلَ الْوَقْتُ
u'دَخَلَ وَقْتٌ':Subject, #23: 23	دَخَلَ وَقْتُهُ
u'دَخَلَ وَقْتٌ':Subject, #2: 2	دَخَلَ وَقْتٌ
u'دَخَلَ وقع':Predicate, #69: 69	دَخَلَ وَقْتُ
u'دَخَلَ وَقْفٌ':Predicate, #1: 1	دَخَلَ وَقَعَ
u'دَخَلَ وَكِيلٌ':Subject, #1: 1	دَخَلَ الْوَقْفَ
u'دَخَلَ ولد':Subject, #1: 1	دَخَلَ الْوَكِيلُ
u'دَخَلَ وَلَدٌ':Subject, #8: 8	دَخَلَ الْوَلَدُ
u'دَخَلَ وَهْمٌ':Subject, #8: 8	دَخَلَ الْوَلَدُ
u'دَخَلَ وَهْنٌ':Subject, #2: 2	دَخَلَ الْوَهْمُ
u'دَخِلَ يَدٌ':Predicate, #1: 1	دَخَلَ الْوَهْنُ
u'دَخَلَ يمن':Predicate, #1: 1	أَدْخَلَ الْيَدَ
u'دَخَلَ يَمَنُ':Predicate, #1: 1	دَخَلَ الْيَمَنَ
u'دَخَلَ يهود':Subject, #1: 1	دَخَلَ الْيَمَنَ
u'دَخَلَ يَهُودٌ':Subject, #1: 1	دَخَلَ الْيَهُودُ
u'دَخَلَ يَهُودِيٌّ':Subject, #1: 1	دَخَلَ الْيَهُودُ
u'دَخَلَ يَوْمٌ':Predicate, #3: 3	دَخَلَ يَهُودِيٌّ
u'دَخَلَ يَوْمٌ':Predicate, #1: 1	دَخَلَ الْيَوْمَ
u'دَخَلَ يَوْمٌ':Subject, #6: 6	دَخَلَ يَوْمَ
u'دُخُولٌ إبَاحَةٌ':Added, #3: 3	دَخَلَ يَوْمُ
u'دُخُولٌ اِبْنٌ':Added, #1: 1	دُخُولِ الْإِبَاحَةِ
u'دُخُولٌ إِتْلاَفٌ':Added, #1: 1	دُخُولِ ابْنِ
u'دُخُولٌ إِجْبَارٌ':Added, #1: 1	دُخُولِ إتْلَافِهِ
u'دُخُولٌ أُجْرَةٌ':Added, #1: 1	دُخُولِ الْإِجْبَارِ
u'دُخُولٌ أُجْرَةٌ':Added, #1: 1	دُخُولِ أُجْرَةِ
u'دُخُولٌ أَجْزَاءٌ':Added, #1: 1	دُخُولِ الْأُجْرَةِ
u'دُخُولٌ أحَدٌ':Added, #1: 1	دُخُولَ أَجْزَاءِ
u'دُخُولٌ أَحْكَامٌ':Added, #2: 2	دُخُولِ أَحَدٍ
u'دُخُولٌ آخِرُ':Added, #1: 1	دُخُولِ الْأَحْكَامِ
u'دُخُولٌ آخِرُ':Added, #1: 1	دُخُولُ الْآخِرِ
u'دُخُولٌ أدَاةٌ':Added, #1: 1	دُخُولِ الْآخِرِ
u'دُخُولٌ آدَمِيٌّ':Added, #1: 1	دُخُولِ أَدَاةِ
u'دُخُولٌ أرْضٌ':Added, #1: 1	دُخُولِ الْآدَمِيِّ
u'دُخُولٌ أرْضٌ':Added, #1: 1	دُخُولُ أَرْضِ
u'دُخُولٌ أرْضٌ':Added, #1: 1	دُخُولَ أَرْضِهِ
u'دُخُولٌ أرْضٌ':Added, #1: 1	دُخُولُ أَرْضِهِ
u'دُخُولٌ أرْضٌ':Added, #1: 1	دُخُولِ أَرْضِهِ
u'دُخُولٌ أرْضٌ':Added, #1: 1	دُخُولَ الْأَرْضِ
u'دُخُولٌ أرْضٌ':Added, #1: 1	دُخُولِ الْأَرْضِ
u'دُخُولٌ أرْضٌ':Added, #2: 2	دُخُولِ أَرْضِ
u'دُخُولٌ إِزَالَةٌ':Added, #2: 2	دُخُولُ الْأَرْضِ
u'دُخُولٌ أَزْواجٌ':Added, #1: 1	دُخُولُ إزَالَةِ
u'دُخُولٌ أَسْواقٌ':Added, #1: 1	دُخُولُ أَزْوَاجِهِ
u'دُخُولٌ أَشْهُرٌ':Added, #2: 2	دُخُولِ الْأَسْوَاقِ
u'دُخُولٌ أَشْهُرٌ':Added, #1: 1	دُخُولِ أَشْهُرِهِ
u'دُخُولٌ أُصْبُعٌ':Added, #3: 3	دُخُولِ أَشْهُرِ
u'دُخُولٌ أعْيانٌ':Added, #1: 1	دُخُولِ الْأُصْبُعِ
u'دُخُولٌ أَعْيَانٌ':Added, #1: 1	دُخُولُ الْأَعْيَانِ
u'دُخُولٌ ألف':Added, #1: 1	دُخُولُ الْأَعْيَانِ
u'دُخُولٌ ألف':Added, #1: 1	دُخُولَ الْأَلِفِ
u'دُخُولٌ الْمَرْأَةُ':Added, #1: 1	دُخُولِ الْأَلِفِ
u'دُخُولٌ الْمَرْأَةُ':Added, #1: 1	دُخُولِ الْمَرْأَةِ
u'دُخُولٌ أُمٌّ':Added, #2: 2	دُخُولَ الْمَرْأَةِ
u'دُخُولٌ إمَاءٌ':Added, #1: 1	دُخُولُ الْأُمِّ
u'دُخُولٌ أمثال':Added, #1: 1	دُخُولِ الْإِمَاءِ
u'دُخُولٌ أَمْثَالٌ':Added, #1: 1	دُخُولِ أَمْثَالِ
u'دُخُولٌ إِناثٌ':Added, #1: 1	دُخُولِ أَمْثَالِ
u'دُخُولٌ إِناثٌ':Added, #1: 1	دُخُولَ الْإِنَاثِ
u'دُخُولٌ إِناثٌ':Added, #1: 1	دُخُولُ الْإِنَاثِ
u'دُخُولٌ أنبياء':Added, #2: 2	دُخُولِ الْإِنَاثِ
u'دُخُولٌ أنبياء':Added, #1: 1	دُخُولَ الْأَنْبِيَاءِ
u'دُخُولٌ إِنْسانٌ':Added, #1: 1	دُخُولِ الْأَنْبِيَاءِ
u'دُخُولٌ أَنْهَارٌ':Added, #1: 1	دُخُولُ الْإِنْسَانِ
u'دُخُولٌ اِهْتِدَاءٌ':Added, #1: 1	دُخُولُ الْأَنْهَارِ
u'دُخُولٌ أهْلٌ':Added, #1: 1	دُخُولَ اهْتِدَاءٍ
u'دُخُولٌ أهْلٌ':Added, #1: 1	دُخُولِ أَهْلِ
u'دُخُولٌ أَوْقَاتٌ':Added, #3: 3	دُخُولِ أَهْلِهِ
u'دُخُولٌ أَوَّلُ':Added, #3: 3	دُخُولِ الْأَوْقَاتِ
u'دُخُولٌ أَوَّلُ':Added, #1: 1	دُخُولَ الْأَوَّلِ
u'دُخُولٌ أَوَّلُ':Added, #1: 1	دُخُولَ أَوَّلِ
u'دُخُولٌ أَوَّلُ':Added, #1: 1	دُخُولُ أَوَّلِ
u'دُخُولٌ أَوْلاَدٌ':Added, #2: 2	دُخُولِ الْأَوَّلِ
u'دُخُولٌ أَوْلاَدٌ':Added, #12: 12	دُخُولِ أَوْلَادِ
u'دُخُولٌ أَوْلاَدٌ':Added, #1: 1	دُخُولَ الْأَوْلَادِ
u'دُخُولٌ أَوْلاَدٌ':Added, #1: 1	دُخُولِ الْأَوْلَادِ
u'دُخُولٌ أَوْلاَدٌ':Added, #3: 3	دُخُولَ أَوْلَادِ
u'دُخُولٌ أيَّامٌ':Added, #3: 3	دُخُولُ أَوْلَادِ
u'دُخُولٌ أَيَّامٌ':Added, #1: 1	دُخُولُ الْأَيَّامِ
u'دُخُولٌ باء':Added, #1: 1	دُخُولُ الْأَيَّامِ
u'دُخُولٌ باء':Added, #1: 1	دُخُولَ الْبَاءِ
u'دُخُولٌ باء':Added, #2: 2	دُخُولُ الْبَاءِ
u'دُخُولٌ بَابٌ':Added, #2: 2	دُخُولِ الْبَاءِ
u'دُخُولٌ بادِي':Added, #1: 1	دُخُولِ الْبَابِ
u'دُخُولٌ بَادِيَةٌ':Added, #1: 1	دُخُولِ الْبَادِيَةِ
u'دُخُولٌ بَائِعٌ':Added, #1: 1	دُخُولِ الْبَادِيَةِ
u'دُخُولٌ بِرْكَةٌ':Added, #1: 1	دُخُولِ الْبَائِعِ
u'دُخُولٌ بُسْتانٌ':Added, #1: 1	دُخُولِ بِرْكَةٍ
u'دُخُولٌ بُسْتانٌ':Added, #1: 1	دُخُولِ الْبُسْتَانِ
u'دُخُولٌ بُسْتانٌ':Added, #1: 1	دُخُولَ بُسْتَانِ
u'دُخُولٌ بَعْضٌ':Added, #3: 3	دُخُولَ الْبُسْتَانِ
u'دُخُولٌ بَعْضٌ':Added, #1: 1	دُخُولُ الْبَعْضِ
u'دُخُولٌ بَعيدٌ':Added, #2: 2	دُخُولِ بَعْضِ
u'دُخُولٌ بَقَرٌ':Added, #1: 1	دُخُولَ الْبَعِيدِ
u'دُخُولٌ بَقِيَّةٌ':Added, #1: 1	دُخُولَ الْبَقَرِ
u'دُخُولٌ بَلَحٌ':Added, #1: 1	دُخُولَ بَقِيَّةِ
u'دُخُولٌ بَلَدٌ':Added, #1: 1	دُخُولِ الْبَلَحِ
u'دُخُولٌ بَلَدٌ':Added, #1: 1	دُخُولُ الْبَلَدِ
u'دُخُولٌ بَلَدٌ':Added, #1: 1	دُخُولَ بَلَدِ
u'دُخُولٌ بَلَدٌ':Added, #2: 2	دُخُولِ بَلَدِ
u'دُخُولٌ بَلَدٌ':Added, #2: 2	دُخُولُ بَلَدِهِ
u'دُخُولٌ بِنَاءٌ':Added, #4: 4	دُخُولِ الْبَلَدِ
u'دُخُولٌ بِئْرٌ':Added, #2: 2	دُخُولِ الْبِنَاءِ
u'دُخُولٌ بَيْتٌ':Added, #1: 1	دُخُولُ الْبِئْرِ
u'دُخُولٌ بَيْتٌ':Added, #1: 1	دُخُولَ بَيْتٍ
u'دُخُولٌ بَيْتٌ':Added, #1: 1	دُخُولُ بَيْتِهِ
u'دُخُولٌ بَيْتٌ':Added, #2: 2	دُخُولِ بَيْتٍ
u'دُخُولٌ بَيْتٌ':Added, #2: 2	دُخُولِ بَيْتِ
u'دُخُولٌ بَيْتٌ':Added, #3: 3	دُخُولَ الْبَيْتِ
u'دُخُولٌ بَيْتٌ':Added, #3: 3	دُخُولُ الْبَيْتِ
u'دُخُولٌ بَيْتٌ':Added, #4: 4	دُخُولِ بَيْتِهِ
u'دُخُولٌ بِيَعٌ':Added, #7: 7	دُخُولِ الْبَيْتِ
u'دُخُولٌ بِيعَةٌ':Added, #1: 1	دُخُولِ الْبِيَعِ
u'دُخُولٌ بِيعَةٌ':Added, #1: 1	دُخُولُ الْبِيعَةِ
u'دُخُولٌ بِيعَةٌ':Added, #1: 1	دُخُولُ بِيعَةٍ
u'دُخُولٌ بَيْعَةٌ':Added, #1: 1	دُخُولِ بِيعَةٍ
u'دُخُولٌ بُيُوتٌ':Added, #2: 2	دُخُولُ بَيْعَةٍ
u'دُخُولٌ بُيُوتٌ':Added, #1: 1	دُخُولُ بُيُوتِ
u'دُخُولٌ تاء':Added, #2: 2	دُخُولِ بُيُوتِهِ
u'دُخُولٌ تَخْصِيصٌ':Added, #1: 1	دُخُولُ تَاءِ
u'دُخُولٌ تَخْصِيصٌ':Added, #1: 1	دُخُولُ التَّخْصِيصِ
u'دُخُولٌ تَرْجِيحٌ':Added, #3: 3	دُخُولَ التَّخْصِيصِ
u'دُخُولٌ تَرْجِيحٌ':Added, #1: 1	دُخُولَ التَّرْجِيحِ
u'دُخُولٌ تَنْوِينٌ':Added, #1: 1	دُخُولِ التَّرْجِيحِ
u'دُخُولٌ ثَانِي':Added, #1: 1	دُخُولَ التّنْوِينِ
u'دُخُولٌ ثَانِي':Added, #2: 2	دُخُولَ الثَّانِيَةِ
u'دُخُولٌ ثَانِيَةٌ':Added, #2: 2	دُخُولِ الثَّانِيَةِ
u'دُخُولٌ ثَانِيَةٌ':Added, #2: 2	دُخُولَ الثَّانِيَةِ
u'دُخُولٌ ثَلاثُ':Added, #2: 2	دُخُولِ الثَّانِيَةِ
u'دُخُولٌ ثَلاثُ':Added, #1: 1	دُخُولِ الثَّلَاثِ
u'دُخُولٌ ثَمَرٌ':Added, #2: 2	دُخُولَ الثَّلَاثِ
u'دُخُولٌ ثَوْبٌ':Added, #1: 1	دُخُولَ الثَّمَرِ
u'دُخُولٌ جَارٌ':Added, #1: 1	دُخُولَ الثَّوْبِ
u'دُخُولٌ جَارٌ':Added, #1: 1	دُخُولِ الْجَارِ
u'دُخُولٌ جَارٌ':Added, #1: 1	دُخُولِ جَارِ
u'دُخُولٌ جَارِي':Added, #1: 1	دُخُولِ جَارِهِ
u'دُخُولٌ جَارِيَةٌ':Added, #1: 1	دُخُولُ الْجَارِيَةِ
u'دُخُولٌ جَازِمٌ':Added, #1: 1	دُخُولُ الْجَارِيَةِ
u'دُخُولٌ جَازِمٌ':Added, #1: 1	دُخُولُ الْجَازِمِ
u'دُخُولٌ جُزْءٌ':Added, #1: 1	دُخُولِ الْجَازِمِ
u'دُخُولٌ جُزْئِيٌّ':Added, #2: 2	دُخُولِ جُزْءٍ
u'دُخُولٌ جلد':Added, #1: 1	دُخُولٍ جُزْئِيٍّ
u'دُخُولٌ جَلْدٌ':Added, #1: 1	دُخُولِ الْجَلْدِ
u'دُخُولٌ جمعة':Added, #1: 1	دُخُولِ الْجَلْدِ
u'دُخُولٌ جُمُعَةٌ':Added, #1: 1	دُخُولُ الْجُمُعَةِ
u'دُخُولٌ جَمِيع':Added, #1: 1	دُخُولُ الْجُمُعَةِ
u'دُخُولٌ جَمِيع':Added, #1: 1	دُخُولُ الْجَمِيعِ
u'دُخُولٌ جَنَّةٌ':Added, #1: 1	دُخُولِ الْجَمِيعِ
u'دُخُولٌ جَنَّةٌ':Added, #13: 13	دُخُولِ الْجَنَّةِ
u'دُخُولٌ جَنَّةٌ':Added, #1: 1	دُخُولِ الْجَنّةِ
u'دُخُولٌ جَنَّةٌ':Added, #5: 5	دُخُولَ الْجَنَّةِ
u'دُخُولٌ جَنِينٌ':Added, #6: 6	دُخُولُ الْجَنَّةِ
u'دُخُولٌ جوارح':Added, #1: 1	دُخُولِ الْجَنِينِ
u'دُخُولٌ جَوَارِحُ':Added, #1: 1	دُخُولَ الْجَوَارِحِ
u'دُخُولٌ حائِضٌ':Added, #1: 1	دُخُولَ الْجَوَارِحِ
u'دُخُولٌ حائِضٌ':Added, #1: 1	دُخُولُ الْحَائِضِ
u'دُخُولٌ حائِضٌ':Added, #1: 1	دُخُولِ حَائِضٍ
u'دُخُولٌ حائِطٌ':Added, #2: 2	دُخُولِ الْحَائِضِ
u'دُخُولٌ حَبْسٌ':Added, #1: 1	دُخُولِ الْحَائِطِ
u'دُخُولٌ حجاز':Added, #1: 1	دُخُولِ الْحَبْسِ
u'دُخُولٌ حِجْرٌ':Added, #2: 2	دُخُولِ الْحِجَازِ
u'دُخُولٌ حَجَرٌ':Added, #1: 1	دُخُولِ الْحِجْرِ
u'دُخُولٌ حَدٌّ':Added, #2: 2	دُخُولِ الْحَجَرِ
u'دُخُولٌ حَرَجٌ':Added, #2: 2	دُخُولِ الْحَدِّ
u'دُخُولٌ حِرْزٌ':Added, #1: 1	دُخُولِ الْحَرَجِ
u'دُخُولٌ حِرْزٌ':Added, #1: 1	دُخُولُ الْحِرْزِ
u'دُخُولٌ حِرْزٌ':Added, #2: 2	دُخُولَ الْحِرْزِ
u'دُخُولٌ حَرْفٌ':Added, #2: 2	دُخُولِ الْحِرْزِ
u'دُخُولٌ حَرْفٌ':Added, #2: 2	دُخُولُ حَرْفِ
u'دُخُولٌ حَرَمٌ':Added, #2: 2	دُخُولِ حَرْفِ
u'دُخُولٌ حَرَمٌ':Added, #10: 10	دُخُولَ الْحَرَمِ
u'دُخُولٌ حَرَمٌ':Added, #1: 1	دُخُولِ حَرَمِ
u'دُخُولٌ حَرَمٌ':Added, #2: 2	دُخُولُ الْحَرَمَيْنِ
u'دُخُولٌ حَرَمٌ':Added, #4: 4	دُخُولُ الْحَرَمِ
u'دُخُولٌ حَرِيمٌ':Added, #7: 7	دُخُولِ الْحَرَمِ
u'دُخُولٌ حضرة':Added, #1: 1	دُخُولِ الْحَرِيمِ
u'دُخُولٌ حَضْرَةٌ':Added, #1: 1	دُخُولِ حَضْرَةِ
u'دُخُولٌ حِلٌّ':Added, #1: 1	دُخُولِ حَضْرَةِ
u'دُخُولٌ حَمَّامٌ':Added, #1: 1	دُخُولَ الْحِلِّ
u'دُخُولٌ حَمَّامٌ':Added, #12: 12	دُخُولِ الْحَمَّامِ
u'دُخُولٌ حَمَّامٌ':Added, #14: 14	دُخُولُ الْحَمَّامِ
u'دُخُولٌ حَمَّامٌ':Added, #1: 1	دُخُولُ حَمَّامٍ
u'دُخُولٌ حَمَّامٌ':Added, #4: 4	دُخُولَ الْحَمَّامِ
u'دُخُولٌ حُمْرَةٌ':Added, #5: 5	دُخُولِ الْحَمَّامَاتِ
u'دُخُولٌ حَمْلٌ':Added, #1: 1	دُخُولِ الْحُمْرَةِ
u'دُخُولٌ حَيْضٌ':Added, #1: 1	دُخُولِ الْحَمْلِ
u'دُخُولٌ خَارِجٌ':Added, #1: 1	دُخُولِ الْحَيْضِ
u'دُخُولٌ خَزٌّ':Added, #1: 1	دُخُولِ الْخَارِجَةِ
u'دُخُولٌ خَصْمٌ':Added, #1: 1	دُخُولُ الْخَزِّ
u'دُخُولٌ خُفٌّ':Added, #1: 1	دُخُولِ خَصْمِهِ
u'دُخُولٌ خَلاَءٌ':Added, #1: 1	دُخُولِ الْخُفِّ
u'دُخُولٌ خَلاَءٌ':Added, #1: 1	دُخُولَ الْخَلاَءِ
u'دُخُولٌ خَلاَءٌ':Added, #2: 2	دُخُولَ الْخَلَاءِ
u'دُخُولٌ خَلاَءٌ':Added, #3: 3	دُخُولِ الْخَلاَءِ
u'دُخُولٌ خَلاَءٌ':Added, #4: 4	دُخُولُ الْخَلَاءِ
u'دُخُولٌ خَلْفٌ':Added, #4: 4	دُخُولِ الْخَلَاءِ
u'دُخُولٌ خَيْمَةٌ':Added, #1: 1	دُخُولَ الْخَلْفِ
u'دُخُولٌ دَاخِلٌ':Added, #1: 1	دُخُولِ الْخَيْمَةِ
u'دُخُولٌ دَاخِلٌ':Added, #1: 1	دُخُولَ الدَّاخِلِ
u'دُخُولٌ دَاخِلٌ':Added, #1: 1	دُخُولِ دَاخِلٍ
u'دُخُولٌ دَارٌ':Added, #3: 3	دُخُولِ دَاخِلِ
u'دُخُولٌ دَارٌ':Added, #14: 14	دُخُولُ الدَّارِ
u'دُخُولٌ دَارٌ':Added, #1: 1	دُخُولَ الدَّارَيْنِ
u'دُخُولٌ دَارٌ':Added, #1: 1	دُخُولَ دَارِ
u'دُخُولٌ دَارٌ':Added, #2: 2	دُخُولُ الدَّارَيْنِ
u'دُخُولٌ دَارٌ':Added, #2: 2	دُخُولُ دَارِ
u'دُخُولٌ دَارٌ':Added, #47: 47	دُخُولِ الدَّارِ
u'دُخُولٌ دَارٌ':Added, #4: 4	دُخُولِ الدَّارَيْنِ
u'دُخُولٌ دَارٌ':Added, #6: 6	دُخُولِ دَارٍ
u'دُخُولٌ دَارٌ':Added, #8: 8	دُخُولَ الدَّارِ
u'دُخُولٌ دَارٌ':Added, #8: 8	دُخُولِ دَارِ
u'دُخُولٌ دِيَةٌ':Added, #9: 9	دُخُولِ دَارِهِ
u'دُخُولٌ دَيْنٌ':Added, #1: 1	دُخُولِ دِيَةٍ
u'دُخُولٌ دَيْنٌ':Added, #1: 1	دُخُولَ الدَّيْنِ
u'دُخُولٌ ذكر':Added, #1: 1	دُخُولِ الدَّيْنِ
u'دُخُولٌ ذَكَرٌ':Added, #1: 1	دُخُولُ الذَّكَرِ
u'دُخُولٌ ذكر':Added, #1: 1	دُخُولُ الذَّكَرِ
u'دُخُولٌ ذَكَرٌ':Added, #1: 1	دُخُولَ ذَكَرِهِ
u'دُخُولٌ ذُكورٌ':Added, #1: 1	دُخُولَ ذَكَرِهِ
u'دُخُولٌ ذِمِّيٌّ':Added, #1: 1	دُخُولُ الذُّكُورِ
u'دُخُولٌ ذِمِّيٌّ':Added, #1: 1	دُخُولُ الذِّمِّيِّ
u'دُخُولٌ رابع':Added, #1: 1	دُخُولِ الذِّمِّيِّ
u'دُخُولٌ رَابِعٌ':Added, #2: 2	دُخُولِ الرَّابِعِ
u'دُخُولٌ رَأْسٌ':Added, #2: 2	دُخُولِ الرَّابِعِ
u'دُخُولٌ رَأْسٌ':Added, #1: 1	دُخُولُ الرَّأْسِ
u'دُخُولٌ رَبُّ':Added, #1: 1	دُخُولِ الرَّأْسِ
u'دُخُولٌ رِجَالٌ':Added, #1: 1	دُخُولِ رَبِّ
u'دُخُولٌ رَجَبٌ':Added, #1: 1	دُخُولِ الرِّجَالِ
u'دُخُولٌ رَجْعِيٌّ':Added, #1: 1	دُخُولِ رَجَبٍ
u'دُخُولٌ رَجْعِيٌّ':Added, #1: 1	دُخُولُ الرَّجْعِيَّةِ
u'دُخُولٌ رَجْعِيَّةٌ':Added, #1: 1	دُخُولِ الرَّجْعِيَّةِ
u'دُخُولٌ رَجْعِيَّةٌ':Added, #1: 1	دُخُولُ الرَّجْعِيَّةِ
u'دُخُولٌ رَجُلٌ':Added, #1: 1	دُخُولِ الرَّجْعِيَّةِ
u'دُخُولٌ رِجْلٌ':Added, #1: 1	دُخُولِ الرَّجُلِ
u'دُخُولٌ رِزْقٌ':Added, #1: 1	دُخُولِ الرِّجْلَيْنِ
u'دُخُولٌ رَسُولٌ':Added, #1: 1	دُخُولِ رِزْقِ
u'دُخُولٌ رَقيقٌ':Added, #2: 2	دُخُولِ رَسُولِ
u'دُخُولٌ رَقيق':Added, #1: 1	دُخُولِ الرَّقِيقِ
u'دُخُولٌ رَمَضانُ':Added, #1: 1	دُخُولِ الرَّقِيقِ
u'دُخُولٌ زائِرٌ':Added, #1: 1	دُخُولِ رَمَضَانِ
u'دُخُولٌ زحاف':Added, #1: 1	دُخُولِ زَائِرٍ
u'دُخُولٌ زِحافٌ':Added, #1: 1	دُخُولُ زِحَافٍ
u'دُخُولٌ زَرْعٌ':Added, #1: 1	دُخُولُ زِحَافٍ
u'دُخُولٌ زَرْعٌ':Added, #1: 1	دُخُولُ الزَّرْعِ
u'دُخُولٌ زَكاةٌ':Added, #2: 2	دُخُولِ الزَّرْعِ
u'دُخُولٌ زَمانٌ':Added, #1: 1	دُخُولُ زَكَاةِ
u'دُخُولٌ زَوْجٌ':Added, #1: 1	دُخُولُ الزَّمَانِ
u'دُخُولٌ زَوْجٌ':Added, #10: 10	دُخُولِ الزَّوْجِ
u'دُخُولٌ زَوْجٌ':Added, #1: 1	دُخُولُ زَوْجٍ
u'دُخُولٌ زَوْجَةٌ':Added, #2: 2	دُخُولِ زَوْجٍ
u'دُخُولٌ زِيادَةٌ':Added, #1: 1	دُخُولِ الزَّوْجَاتِ
u'دُخُولٌ زِيادَةٌ':Added, #1: 1	دُخُولُ الزِّيَادَةِ
u'دُخُولٌ زَيْدٌ':Added, #1: 1	دُخُولِ الزِّيَادَةِ
u'دُخُولٌ سابع':Added, #2: 2	دُخُولِ زَيْدٍ
u'دُخُولٌ سَابعٌ':Added, #2: 2	دُخُولِ السَّابِعَةِ
u'دُخُولٌ سادس':Added, #2: 2	دُخُولِ السَّابِعَةِ
u'دُخُولٌ سَادِسٌ':Added, #2: 2	دُخُولُ السَّادِسَةِ
u'دُخُولٌ سَالِمٌ':Added, #2: 2	دُخُولُ السَّادِسَةِ
u'دُخُولٌ سَائِرٌ':Added, #2: 2	دُخُولِ سَالِمٍ
u'دُخُولٌ سَبَبٌ':Added, #1: 1	دُخُولِ سَائِرِ
u'دُخُولٌ سَبَبٌ':Added, #1: 1	دُخُولَ السَّبَبِ
u'دُخُولٌ سَخْلَة':Added, #1: 1	دُخُولِ السَّبَبِ
u'دُخُولٌ سَلاَمَةٌ':Added, #1: 1	دُخُولِ السَّخْلَةِ
u'دُخُولٌ سَنَةٌ':Added, #1: 1	دُخُولَ السَّلَامَةِ
u'دُخُولٌ سُوقٌ':Added, #3: 3	دُخُولِ السَّنَةِ
u'دُخُولٌ سَيِّدٌ':Added, #1: 1	دُخُولِ السُّوقِ
u'دُخُولٌ شَابٌّ':Added, #1: 1	دُخُولُ السَّيِّدِ
u'دُخُولٌ شِتَاءٌ':Added, #1: 1	دُخُولُ الشَّابَّةِ
u'دُخُولٌ شَجَرٌ':Added, #2: 2	دُخُولِ الشِّتَاءِ
u'دُخُولٌ شَجَرَةٌ':Added, #2: 2	دُخُولِ الشَّجَرِ
u'دُخُولٌ شَخْصٌ':Added, #1: 1	دُخُولِ الشَّجَرَةِ
u'دُخُولٌ شرب':Added, #1: 1	دُخُولِ شَخْصٍ
u'دُخُولٌ شُرْبٌ':Added, #1: 1	دُخُولُ الشُّرْبِ
u'دُخُولٌ شَرْطٌ':Added, #1: 1	دُخُولُ الشُّرْبِ
u'دُخُولٌ شَرْطٌ':Added, #1: 1	دُخُولِ الشَّرْطِ
u'دُخُولٌ شَرْطٌ':Added, #2: 2	دُخُولَ الشَّرْطِ
u'دُخُولٌ شَعْرٌ':Added, #4: 4	دُخُولُ الشَّرْطِ
u'دُخُولٌ شَعْرٌ':Added, #1: 1	دُخُولَ الشَّعْرِ
u'دُخُولٌ شَكٌّ':Added, #1: 1	دُخُولُ شَعْرِ
u'دُخُولٌ شَهْرٌ':Added, #1: 1	دُخُولُ الشَّكِّ
u'دُخُولٌ شَهْرٌ':Added, #2: 2	دُخُولِ الشَّهْرِ
u'دُخُولٌ شَوَّالٌ':Added, #4: 4	دُخُولِ شَهْرِ
u'دُخُولٌ شَيْءٌ':Added, #1: 1	دُخُولِ شَوَّالٍ
u'دُخُولٌ شَيْءٌ':Added, #1: 1	دُخُول شَيْءٍ
u'دُخُولٌ شَيْءٌ':Added, #1: 1	دُخُولَ شَيْءٍ
u'دُخُولٌ شَيْءٌ':Added, #1: 1	دُخُولُ شَيْءِ
u'دُخُولٌ صَبِيٌّ':Added, #5: 5	دُخُولِ شَيْءٍ
u'دُخُولٌ صَبِيٌّ':Added, #1: 1	دُخُولُ الصَّبِيِّ
u'دُخُولٌ صِبْيَانٌ':Added, #1: 1	دُخُولِ الصَّبِيِّ
u'دُخُولٌ صدق':Added, #2: 2	دُخُولِ الصِّبْيَانِ
u'دُخُولٌ صِدْقٌ':Added, #1: 1	دُخُولُ الصِّدْقِ
u'دُخُولٌ صِفَةٌ':Added, #1: 1	دُخُولُ الصِّدْقِ
u'دُخُولٌ صَلاَةٌ':Added, #1: 1	دُخُولِ الصِّفَةِ
u'دُخُولٌ صَلاَةٌ':Added, #1: 1	دُخُولَ الصَّلَاةِ
u'دُخُولٌ صَلاَةٌ':Added, #1: 1	دُخُولِ صَلَاةٍ
u'دُخُولٌ صِهْرِيجٌ':Added, #2: 2	دُخُولِ الصَّلَاةِ
u'دُخُولٌ صَوْمٌ':Added, #1: 1	دُخُولِ الصِّهْرِيجِ
u'دُخُولٌ صَيْفٌ':Added, #2: 2	دُخُولُ الصَّوْمِ
u'دُخُولٌ ضَرَرٌ':Added, #1: 1	دُخُولِ الصَّيْفِ
u'دُخُولٌ طَاعُونٌ':Added, #1: 1	دُخُولِ الضَّرَرِ
u'دُخُولٌ طَرِيقٌ':Added, #1: 1	دُخُولِ الطَّاعُونِ
u'دُخُولٌ طَلاَقٌ':Added, #1: 1	دُخُولِ الطَّرِيقِ
u'دُخُولٌ طَوْقٌ':Added, #1: 1	دُخُولِ الطَّلَاقِ
u'دُخُولٌ ظاهِرٌ':Added, #1: 1	دُخُولَ الطَّوْقِ
u'دُخُولٌ ظَرْفٌ':Added, #1: 1	دُخُولِ الظَّاهِرِ
u'دُخُولٌ ظلمة':Added, #1: 1	دُخُولَ الظَّرْفِ
u'دُخُولٌ ظُلْمَةٌ':Added, #1: 1	دُخُولِ الظُّلْمَةِ
u'دُخُولٌ عَاشِرٌ':Added, #1: 1	دُخُولِ الظُّلْمَةِ
u'دُخُولٌ عَامٌّ':Added, #1: 1	دُخُولِ الْعَاشِرِ
u'دُخُولٌ عَبْدٌ':Added, #2: 2	دُخُولِ الْعَامَّةِ
u'دُخُولٌ عَبْدٌ':Added, #1: 1	دُخُولَ الْعَبْدِ
u'دُخُولٌ عَبْدٌ':Added, #2: 2	دُخُولُ الْعَبْدِ
u'دُخُولٌ عَبِيدٌ':Added, #2: 2	دُخُولِ الْعَبْدِ
u'دُخُولٌ عَبِيدٌ':Added, #1: 1	دُخُولُ الْعَبِيدِ
u'دُخُولٌ عَدُوٌّ':Added, #1: 1	دُخُولِ الْعَبِيدِ
u'دُخُولٌ عَرَفَاتٌ':Added, #1: 1	دُخُولِ الْعَدُوِّ
u'دُخُولٌ عَشْرٌ':Added, #1: 1	دُخُولِ عَرَفَاتٍ
u'دُخُولٌ عَفْوٌ':Added, #3: 3	دُخُولِ الْعَشْرِ
u'دُخُولٌ عُلُوٌّ':Added, #1: 1	دُخُولُ الْعَفْوِ
u'دُخُولٌ عَيْنٌ':Added, #1: 1	دُخُولُ الْعُلُوِّ
u'دُخُولٌ عَيْن':Added, #1: 1	دُخُولُ عَيْنٍ
u'دُخُولٌ غَايَةٌ':Added, #1: 1	دُخُولُ عَيْنٍ
u'دُخُولٌ غَايَةٌ':Added, #1: 1	دُخُولَ الْغَايَةِ
u'دُخُولٌ غَايَةٌ':Added, #1: 1	دُخُولَ غَايَةِ
u'دُخُولٌ غَايَةٌ':Added, #2: 2	دُخُولُ الْغَايَةِ
u'دُخُولٌ غَدٌ':Added, #3: 3	دُخُولِ الْغَايَةِ
u'دُخُولٌ غَصْبٌ':Added, #2: 2	دُخُولِ الْغَدِ
u'دُخُولٌ غُصْنٌ':Added, #1: 1	دُخُولِ غَصْبِ
u'دُخُولٌ غَلَطٌ':Added, #1: 1	دُخُولَ الْغُصْنِ
u'دُخُولٌ غَمُوس':Added, #1: 1	دُخُولُ الْغَلَطِ
u'دُخُولٌ غَنِيٌّ':Added, #1: 1	دُخُولُ الْغَمُوسِ
u'دُخُولٌ غير':Added, #1: 1	دُخُولِ الْغَنِيِّ
u'دُخُولٌ غير':Added, #1: 1	دُخُولُ غَيْرِ
u'دُخُولٌ غَيْرٌ':Added, #1: 1	دُخُولِ غَيْرِ
u'دُخُولٌ غَيْرٌ':Added, #1: 1	دُخُولُ غَيْرِ
u'دُخُولٌ غير':Added, #1: 1	دُخُولِ غَيْرِ
u'دُخُولٌ غَيْرٌ':Added, #2: 2	دُخُولُ غَيْرِهِ
u'دُخُولٌ غير':Added, #2: 2	دُخُولُ غَيْرِهِ
u'دُخُولٌ غَيْرٌ':Added, #3: 3	دُخُولَ غَيْرِهِ
u'دُخُولٌ فاء':Added, #3: 3	دُخُولَ غَيْرِهِ
u'دُخُولٌ فاء':Added, #2: 2	دُخُولِ الْفَاءِ
u'دُخُولٌ فُرَاتٌ':Added, #8: 8	دُخُولُ الْفَاءِ
u'دُخُولٌ فَرْعٌ':Added, #1: 1	دُخُولُ الْفُرَاتِ
u'دُخُولٌ فَرْعٌ':Added, #1: 1	دُخُولُ الْفَرْعِ
u'دُخُولٌ فَرْوَةٌ':Added, #2: 2	دُخُولِ الْفَرْعِ
u'دُخُولٌ فُرُوعٌ':Added, #3: 3	دُخُولِ الْفَرْوَةِ
u'دُخُولٌ فقهاء':Added, #5: 5	دُخُولِ فُرُوعِ
u'دُخُولٌ فلان':Added, #2: 2	دُخُولِ الْفُقَهَاءِ
u'دُخُولٌ فُلاَنٌ':Added, #1: 1	دُخُولِ جَعْفَرِ
u'دُخُولٌ قَائِمٌ':Added, #1: 1	دُخُولُ فُلَانٍ
u'دُخُولٌ قَائِمَةٌ':Added, #1: 1	دُخُولِ الْقَائِمَةِ
u'دُخُولٌ قَرَابَةٌ':Added, #1: 1	دُخُولِ الْقَائِمَةِ
u'دُخُولٌ قُرْعَةٌ':Added, #1: 1	دُخُولِ قَرَابَةِ
u'دُخُولٌ قُرْعَةٌ':Added, #1: 1	دُخُولُ الْقُرْعَةِ
u'دُخُولٌ قَرِيبٌ':Added, #2: 2	دُخُولِ الْقُرْعَةِ
u'دُخُولٌ قسمة':Added, #1: 1	دُخُولُ الْقَرِيبِ
u'دُخُولٌ قِسْمَةٌ':Added, #1: 1	دُخُولِ قِسْمَةِ
u'دُخُولٌ قول':Added, #1: 1	دُخُولِ قِسْمَةِ
u'دُخُولٌ قَوْلٌ':Added, #1: 1	دُخُولُ قَوْلِ
u'دُخُولٌ قِيَاسٌ':Added, #1: 1	دُخُولُ قَوْلِ
u'دُخُولٌ قِيَاسٌ':Added, #1: 1	دُخُولِ قِيَاسِ
u'دُخُولٌ كَافِرٌ':Added, #2: 2	دُخُولَ الْقِيَاسِ
u'دُخُولٌ كَافِرٌ':Added, #1: 1	دُخُولُ الْكَافِرِ
u'دُخُولٌ كذب':Added, #3: 3	دُخُولِ الْكَافِرِ
u'دُخُولٌ كَذِبٌ':Added, #1: 1	دُخُولُ الْكَذِبِ
u'دُخُولٌ كَسْبٌ':Added, #1: 1	دُخُولُ الْكَذِبِ
u'دُخُولٌ كَسْبٌ':Added, #1: 1	دُخُولِ الْكَسْبِ
u'دُخُولٌ كَعْبٌ':Added, #2: 2	دُخُولِ كَسْبٍ
u'دُخُولٌ كعبة':Added, #1: 1	دُخُولِ الْكَعْبَيْنِ
u'دُخُولٌ كَعْبَةٌ':Added, #1: 1	دُخُولُ الْكَعْبَةِ
u'دُخُولٌ كُفَّارٌ':Added, #1: 1	دُخُولُ الْكَعْبَةِ
u'دُخُولٌ كَفَّارٌ':Added, #1: 1	دُخُولِ الْكُفَّارِ
u'دُخُولٌ كَفَّارَةٌ':Added, #1: 1	دُخُولُ الْكَفَّارَةِ
u'دُخُولٌ كَلْبٌ':Added, #1: 1	دُخُولُ الْكَفَّارَةِ
u'دُخُولٌ كَلْبٌ':Added, #1: 1	دُخُولَ الْكَلْبِ
u'دُخُولٌ كَلِمَةٌ':Added, #1: 1	دُخُولِ الْكَلْبِ
u'دُخُولٌ كَنَائِسُ':Added, #1: 1	دُخُولِ كَلِمَةِ
u'دُخُولٌ كُوفَةٌ':Added, #1: 1	دُخُولُ الْكَنَائِسِ
u'دُخُولٌ لاَمٌ':Added, #1: 1	دُخُولِ الْكُوفَةِ
u'دُخُولٌ لاَمٌ':Added, #1: 1	دُخُولُ اللَّامِ
u'دُخُولٌ لاَمٌ':Added, #1: 1	دُخُولِ لَامِ
u'دُخُولٌ لِحَافٌ':Added, #4: 4	دُخُولِ اللَّامِ
u'دُخُولٌ لَحْظٌ':Added, #1: 1	دُخُولِ اللِّحَافِ
u'دُخُولٌ لَيْلٌ':Added, #1: 1	دُخُولُ اللَّحْظِ
u'دُخُولٌ لَيْلٌ':Added, #1: 1	دُخُولَ اللَّيْلِ
u'دُخُولٌ لَيْلٌ':Added, #1: 1	دُخُولُ اللَّيْلَةِ
u'دُخُولٌ لَيْلٌ':Added, #2: 2	دُخُولِ اللَّيْلَةِ
u'دُخُولٌ لَيْلٌ':Added, #2: 2	دُخُولِ لَيْلَتِهِ
u'دُخُولٌ لَيْلٌ':Added, #3: 3	دُخُولُ اللَّيْلِ
u'دُخُولٌ مَاءٌ':Added, #7: 7	دُخُولِ اللَّيْلِ
u'دُخُولٌ مَاءٌ':Added, #3: 3	دُخُولَ الْمَاءِ
u'دُخُولٌ مَاءٌ':Added, #3: 3	دُخُولُ الْمَاءِ
u'دُخُولٌ مَالٌ':Added, #8: 8	دُخُولِ الْمَاءِ
u'دُخُولٌ مَالٌ':Added, #1: 1	دُخُولَ الْمَالِ
u'دُخُولٌ مَبِيعٌ':Added, #3: 3	دُخُولِ الْمَالِ
u'دُخُولٌ مَبِيعٌ':Added, #1: 1	دُخُولَ الْمَبِيعِ
u'دُخُولٌ مَبِيعٌ':Added, #1: 1	دُخُولِ مَبِيعٍ
u'دُخُولٌ مُتَجَدِّدٌ':Added, #3: 3	دُخُولِ الْمَبِيعِ
u'دُخُولٌ مُتَشَابِهٌ':Added, #3: 3	دُخُولِ الْمُتَجَدِّدِ
u'دُخُولٌ مِثَالٌ':Added, #1: 1	دُخُولُ الْمُتَشَابِهِ
u'دُخُولٌ مِثْلٌ':Added, #1: 1	دُخُولَ مِثَالِهِ
u'دُخُولٌ مَجَازٌ':Added, #1: 1	دُخُولَ مِثْلٍ
u'دُخُولٌ مَجَازٌ':Added, #1: 1	دُخُولِ الْمَجَازِ
u'دُخُولٌ مَجَانِينُ':Added, #2: 2	دُخُولُ الْمَجَازِ
u'دُخُولٌ مُجْتَهِد':Added, #1: 1	دُخُولِ الْمَجَانِينِ
u'دُخُولٌ مَحَلٌّ':Added, #1: 1	دُخُولُ الْمُجْتَهِدِ
u'دُخُولٌ مَحَلٌّ':Added, #1: 1	دُخُولُ مَحَلِّ
u'دُخُولٌ مَحَلٌّ':Added, #1: 1	دُخُولِ مَحَلٍّ
u'دُخُولٌ مُخَاطَبٌ':Added, #2: 2	دُخُولِ مَحَلِّ
u'دُخُولٌ مُخَاطِبٌ':Added, #1: 1	دُخُولُ الْمُخَاطَبِ
u'دُخُولٌ مُخَاطِبٌ':Added, #1: 1	دُخُولُ الْمُخَاطِبِ
u'دُخُولٌ مُخَاطَبٌ':Added, #1: 1	دُخُولِ الْمُخَاطِبِ
u'دُخُولٌ مَخْصُوصٌ':Added, #3: 3	دُخُولِ الْمُخَاطَبِ
u'دُخُولٌ مَخْصُوصٌ':Added, #1: 1	دُخُولِ الْمَخْصُوصِ
u'دُخُولٌ مَدَارِسُ':Added, #1: 1	دُخُولٍ مَخْصُوصٍ
u'دُخُولٌ مَرَافِقُ':Added, #1: 1	دُخُولُ الْمَدَارِسِ
u'دُخُولٌ مُرَافِقٌ':Added, #1: 1	دُخُولِ الْمَرَافِقِ
u'دُخُولٌ مَرَافِقُ':Added, #1: 1	دُخُولُ الْمُرَافِقِ
u'دُخُولٌ مُرَاهِقٌ':Added, #2: 2	دُخُولُ الْمَرَافِقِ
u'دُخُولٌ مُرْسَلٌ':Added, #1: 1	دُخُولُ الْمُرَاهِقِ
u'دُخُولٌ مِرْفَقٌ':Added, #1: 1	دُخُولُ الْمُرْسَلِ
u'دُخُولٌ مِرْفَقٌ':Added, #1: 1	دُخُولِ الْمِرْفَقِ
u'دُخُولٌ مَزَارِعُ':Added, #3: 3	دُخُولِ الْمِرْفَقَيْنِ
u'دُخُولٌ مَسَاجِدُ':Added, #1: 1	دُخُولِ مَزَارِعِ
u'دُخُولٌ مَسَاجِدُ':Added, #1: 1	دُخُولُ الْمَسَاجِدِ
u'دُخُولٌ مَسَاجِدُ':Added, #1: 1	دُخُولَ مَسَاجِدِ
u'دُخُولٌ مَسَاجِدُ':Added, #2: 2	دُخُولِ الْمَسَاجِدِ
u'دُخُولٌ مُسْتَأْجِرٌ':Added, #3: 3	دُخُولُ مَسَاجِدِ
u'دُخُولٌ مُسْتَعِيرٌ':Added, #1: 1	دُخُولِ الْمُسْتَأْجِرِ
u'دُخُولٌ مُسْتَقْبَلٌ':Added, #1: 1	دُخُولِ الْمُسْتَعِيرِ
u'دُخُولٌ مَسْجِدٌ':Added, #1: 1	دُخُولٍ مُسْتَقْبَلٍ
u'دُخُولٌ مَسْجِدٌ':Added, #15: 15	دُخُولَ الْمَسْجِدِ
u'دُخُولٌ مَسْجِدٌ':Added, #18: 18	دُخُولُ الْمَسْجِدِ
u'دُخُولٌ مَسْجِدٌ':Added, #1: 1	دُخُولِ مَسْجِدٍ
u'دُخُولٌ مَسْجِدٌ':Added, #37: 37	دُخُولِ الْمَسْجِدِ
u'دُخُولٌ مُسْلِمٌ':Added, #5: 5	دُخُولُ مَسْجِدٍ
u'دُخُولٌ مُسْلِمٌ':Added, #1: 1	دُخُولَ الْمُسْلِمِ
u'دُخُولٌ مُسْلِمٌ':Added, #1: 1	دُخُولَ مُسْلِمٍ
u'دُخُولٌ مُشْرِك':Added, #2: 2	دُخُولِ الْمُسْلِمِ
u'دُخُولٌ مَشَقَّةٌ':Added, #1: 1	دُخُولِ الْمُشْرِكِ
u'دُخُولٌ مِصْرٌ':Added, #1: 1	دُخُولَ الْمَشَقَّةِ
u'دُخُولٌ مِصْرٌ':Added, #1: 1	دُخُولُ الْمِصْرِ
u'دُخُولٌ مِصْرٌ':Added, #2: 2	دُخُولِ مِصْرِهِ
u'دُخُولٌ مُطَلَّقٌ':Added, #3: 3	دُخُولِ الْمِصْرِ
u'دُخُولٌ مَعَابِدُ':Added, #1: 1	دُخُولِ مُطَلَّقَةٍ
u'دُخُولٌ مُعْتَكَف':Added, #1: 1	دُخُولُ مَعَابِدِ
u'دُخُولٌ مُعْتَكَف':Added, #1: 1	دُخُولُ الْمُعْتَكَفِ
u'دُخُولٌ مَعْدُودٌ':Added, #1: 1	دُخُولِ الْمُعْتَكَفِ
u'دُخُولٌ مَعْصَرَةٌ':Added, #1: 1	دُخُولَ الْمَعْدُودِ
u'دُخُولٌ مِفْتَاحٌ':Added, #1: 1	دُخُولُ الْمَعْصَرَةِ
u'دُخُولٌ مَقَاصِدُ':Added, #1: 1	دُخُولِ الْمِفْتَاحِ
u'دُخُولٌ مَقَرٌّ':Added, #1: 1	دُخُولِ الْمَقَاصِدِ
u'دُخُولٌ مَقْصِدٌ':Added, #1: 1	دُخُولِ مَقَرِّ
u'دُخُولٌ مَقْصِدٌ':Added, #1: 1	دُخُولَ مَقْصِدِهِ
u'دُخُولٌ مُكَلَّفٌ':Added, #1: 1	دُخُولُ مَقْصِدِهِ
u'دُخُولٌ مَلاَئِكَةٌ':Added, #1: 1	دُخُولُ الْمُكَلَّفِ
u'دُخُولٌ مَلاَئِكَةٌ':Added, #1: 1	دُخُولَ الْمَلَائِكَةِ
u'دُخُولٌ مَلاَئِكَةٌ':Added, #1: 1	دُخُولَ مَلَائِكَةِ
u'دُخُولٌ مِلْكٌ':Added, #4: 4	دُخُولِ الْمَلَائِكَةِ
u'دُخُولٌ مِلْكٌ':Added, #1: 1	دُخُولُ الْمِلْكِ
u'دُخُولٌ مِلْكٌ':Added, #1: 1	دُخُولُ مِلْكِ
u'دُخُولٌ مِلْكٌ':Added, #1: 1	دُخُولُ مِلْكِهِ
u'دُخُولٌ مِلْكٌ':Added, #2: 2	دُخُولِ مِلْكِ
u'دُخُولٌ مَنْزِلٌ':Added, #2: 2	دُخُولِ مِلْكِهِ
u'دُخُولٌ مَنْزِلٌ':Added, #1: 1	دُخُولِ مَنْزِلٍ
u'دُخُولٌ مَنْزِلٌ':Added, #2: 2	دُخُولَ مَنْزِلِهِ
u'دُخُولٌ مَنْسُوبٌ':Added, #4: 4	دُخُولِ الْمَنْزِلِ
u'دُخُولٌ مَنْقُولٌ':Added, #1: 1	دُخُولِ الْمَنْسُوبَةِ
u'دُخُولٌ مَنْهِيٌّ':Added, #1: 1	دُخُولِ الْمَنْقُولِ
u'دُخُولٌ مُؤَخَّرٌ':Added, #1: 1	دُخُولِ الْمَنْهِيِّ
u'دُخُولٌ مَوْسِمٌ':Added, #1: 1	دُخُولِ الْمُؤَخَّرَةِ
u'دُخُولٌ مَوْضِعٌ':Added, #2: 2	دُخُولَ مَوْسِمٍ
u'دُخُولٌ مَوْضِعٌ':Added, #1: 1	دُخُولُ الْمَوْضِعِ
u'دُخُولٌ مَوْهُوبٌ':Added, #1: 1	دُخُولَ مَوْضِعِ
u'دُخُولٌ مِيقَاتٌ':Added, #2: 2	دُخُولُ الْمَوْهُوبِ
u'دُخُولٌ ميل':Added, #1: 1	دُخُولِ الْمِيقَاتِ
u'دُخُولٌ مِيلٌ':Added, #1: 1	دُخُولَ الْمِيلِ
u'دُخُولٌ نَادِرٌ':Added, #1: 1	دُخُولَ الْمِيلِ
u'دُخُولٌ نَارٌ':Added, #1: 1	دُخُولُ النَّادِرِ
u'دُخُولٌ نَارٌ':Added, #2: 2	دُخُولُ النَّارِ
u'دُخُولٌ نَارٌ':Added, #3: 3	دُخُولَ النَّارِ
u'دُخُولٌ نَاسٌ':Added, #4: 4	دُخُولِ النَّارِ
u'دُخُولٌ نَاسٌ':Added, #1: 1	دُخُولَ النَّاسِ
u'دُخُولٌ نَجَاسَةٌ':Added, #2: 2	دُخُولُ النَّاسِ
u'دُخُولٌ نَحْوٌ':Added, #1: 1	دُخُولِ النَّجَاسَةِ
u'دُخُولٌ نِساءٌ':Added, #4: 4	دُخُولِ نَحْوِ
u'دُخُولٌ نِساءٌ':Added, #1: 1	دُخُولُ النِّسَاءِ
u'دُخُولٌ نَفْيٌ':Added, #1: 1	دُخُولِ النِّسَاءِ
u'دُخُولٌ نَقْصٌ':Added, #1: 1	دُخُولِ النَّفْيِ
u'دُخُولٌ نُقْصَانٌ':Added, #1: 1	دُخُولَ النَّقْصِ
u'دُخُولٌ نَقْضٌ':Added, #1: 1	دُخُولِ نُقْصَانِ
u'دُخُولٌ نكاح':Added, #2: 2	دُخُولِ نَقْضِ
u'دُخُولٌ نِكَاحٌ':Added, #1: 1	دُخُولَ النِّكَاحِ
u'دُخُولٌ نَكِرٌ':Added, #1: 1	دُخُولَ النِّكَاحِ
u'دُخُولٌ نكرة':Added, #1: 1	دُخُولِ النَّكِرَةِ
u'دُخُولٌ نَكِرَةٌ':Added, #1: 1	دُخُولِ النَّكِرَةِ
u'دُخُولٌ نُوَّابٌ':Added, #1: 1	دُخُولِ النَّكِرَةِ
u'دُخُولٌ نَوَادِرُ':Added, #1: 1	دُخُولَ النُّوَّابِ
u'دُخُولٌ نُونٌ':Added, #1: 1	دُخُولِ نَوَادِرِ
u'دُخُولٌ نِيَابَةٌ':Added, #1: 1	دُخُولُ النُّونِ
u'دُخُولٌ هاء':Added, #3: 3	دُخُولِ النِّيَابَةِ
u'دُخُولٌ هَوَاءٌ':Added, #1: 1	دُخُولُ الْهَاءِ
u'دُخُولٌ هَوَامٌّ':Added, #1: 1	دُخُولُ الْهَوَاءِ
u'دُخُولٌ وَاجِبٌ':Added, #1: 1	دُخُولِ الْهَوَامِّ
u'دُخُولٌ واحد':Added, #1: 1	دُخُولُ الْوَاجِبِ
u'دُخُولٌ وَاحِدٌ':Added, #1: 1	دُخُولُ الْوَاحِدِ
u'دُخُولٌ وَارِثٌ':Added, #1: 1	دُخُولُ الْوَاحِدِ
u'دُخُولٌ ورق':Added, #1: 1	دُخُولُ وَارِثِهِ
u'دُخُولٌ وَرَقٌ':Added, #2: 2	دُخُولِ وَرَقِ
u'دُخُولٌ وَصِيٌّ':Added, #2: 2	دُخُولِ وَرَقِ
u'دُخُولٌ وَصِيَّةٌ':Added, #2: 2	دُخُولِ الْوَصِيَّةِ
u'دُخُولٌ وُضُوءٌ':Added, #2: 2	دُخُولِ الْوَصِيَّةِ
u'دُخُولٌ وَطَنٌ':Added, #1: 1	دُخُولِ الْوُضُوءِ
u'دُخُولٌ وَطَنٌ':Added, #1: 1	دُخُولِ الْوَطَنِ
u'دُخُولٌ وَقْتٌ':Added, #1: 1	دُخُولُ وَطَنِهِ
u'دُخُولٌ وَقْتٌ':Added, #106: 106	دُخُولِ الْوَقْتِ
u'دُخُولٌ وَقْتٌ':Added, #10: 10	دُخُولَ الْوَقْتِ
u'دُخُولٌ وَقْتٌ':Added, #16: 16	دُخُولُ الْوَقْتِ
u'دُخُولٌ وَقْتٌ':Added, #19: 19	دُخُولَ وَقْتِ
u'دُخُولٌ وَقْتٌ':Added, #1: 1	دُخُولَ وَقْتٍ
u'دُخُولٌ وَقْتٌ':Added, #1: 1	دُخُولُ وَقْتٍ
u'دُخُولٌ وَقْتٌ':Added, #1: 1	دُخُولُ وَقْتِهِ
u'دُخُولٌ وَقْتٌ':Added, #2: 2	دُخُولَ وَقْتِهِ
u'دُخُولٌ وَقْتٌ':Added, #68: 68	دُخُولِ وَقْتِ
u'دُخُولٌ وَقْتٌ':Added, #7: 7	دُخُولِ وَقْتِهِ
u'دُخُولٌ وَقْفٌ':Added, #8: 8	دُخُولُ وَقْتِ
u'دُخُولٌ ولد':Added, #1: 1	دُخُولِ الْوَقْفِ
u'دُخُولٌ وَلَدٌ':Added, #1: 1	دُخُولِ الْوَلَدِ
u'دُخُولٌ ولد':Added, #1: 1	دُخُولِ الْوَلَدِ
u'دُخُولٌ وَلَدٌ':Added, #1: 1	دُخُولَ وَلَدِ
u'دُخُولٌ ولد':Added, #1: 1	دُخُولَ وَلَدِ
u'دُخُولٌ وَلَدٌ':Added, #2: 2	دُخُولُ وَلَدِ
u'دُخُولٌ ولد':Added, #2: 2	دُخُولُ وَلَدِ
u'دُخُولٌ وَلَدٌ':Added, #3: 3	دُخُولُ الْوَلَدِ
u'دُخُولٌ ولد':Added, #3: 3	دُخُولُ الْوَلَدِ
u'دُخُولٌ وَلَدٌ':Added, #3: 3	دُخُولِ وَلَدِ
u'دُخُولٌ يَدٌ':Added, #3: 3	دُخُولِ وَلَدِ
u'دُخُولٌ يَدٌ':Added, #1: 1	دُخُولُ يَدِهِ
u'دُخُولٌ يَمِينٌ':Added, #4: 4	دُخُولِ يَدِهِ
u'دُخُولٌ يَوْمٌ':Added, #1: 1	دُخُولُ الْيَمِينِ
u'دُخُولٌ يَوْمٌ':Added, #1: 1	دُخُولِ الْيَوْمِ
u'دَرَأَ حَدٌّ':Predicate, #2: 2	دُخُولِ يَوْمِ
u'دَرَأَ رَجُلٌ':Subject, #7: 7	دَرَأَ الْحَدَّ
u'دِرَايَةٌ دَوْرٌ':Added, #1: 1	دَرَأَ رَجُلٌ
u'دُرْبَةٌ أحَدٌ':Added, #1: 1	دِرَايَةِ الدَّوْرِ
u'دَرِجَ حُكْمٌ':Predicate, #1: 1	دُرْبَةُ أَحَدٍ
u'دَرَجَ خُلَفَاءُ':Subject, #1: 1	أَدْرَجَ الْحُكْمَ
u'دَرَجَ سَلَفٌ':Subject, #3: 3	دَرَجَ الْخُلَفَاءُ
u'دَرَجَ غير':Subject, #2: 2	دَرَجَ السَّلَفُ
u'دَرَجَ غَيْرٌ':Subject, #1: 1	دَرَجَ غَيْرُ
u'دَرِجَ قِرَاءةٌ':Predicate, #1: 1	دَرَجَ غَيْرُ
u'دَرِجَ مَاءٌ':Predicate, #1: 1	أَدْرَجَ الْقِرَاءَةَ
u'دَرَّ حَيْضٌ':Predicate, #1: 1	أَدْرَجَ الْمَاءَ
u'دَرَّ خَلْفٌ':Predicate, #1: 1	أَدَرَّ الْحَيْضَ
u'دَرْسٌ اِبْنٌ':Added, #1: 1	دَرَّ خَلْفَكَ
u'دَرْسٌ حَديثٌ':Added, #1: 1	دَرْسِ ابْنِ
u'دَرْسٌ شَيْخٌ':Added, #1: 1	دَرْسِ الْحَدِيثِ
u'دَرْسٌ علم':Added, #1: 1	دَرْسِ شَيْخِهِ
u'دَرْسٌ علم':Added, #1: 1	دَرْسُ الْعِلْمِ
u'دَرْسٌ عِلْمٌ':Added, #1: 1	دَرْسِ الْعِلْمِ
u'دَرْسٌ عِلْمٌ':Added, #1: 1	دَرْسُ الْعِلْمِ
u'دَرْسٌ علم':Added, #1: 1	دَرْسِ الْعِلْمِ
u'دَرْسٌ عِلْمٌ':Added, #1: 1	دَرْسِ عِلْمٍ
u'دَرَسَ فِقْهٌ':Predicate, #1: 1	دَرْسِ عِلْمٍ
u'دَرْسٌ فِقْهٌ':Added, #1: 1	دَرَسَ الْفِقْهَ
u'دَرْسٌ كِتَابٌ':Added, #1: 1	دَرْسُ الْفِقْهِ
u'دَرْسٌ مُدَرِّسٌ':Added, #1: 1	دَرْسَ كِتَابِهِ
u'دَرْسٌ مَسَائِلُ':Added, #1: 1	دَرْسَ الْمُدَرِّسِ
u'دَرَسَ مُسْتَنَدٌ':Subject, #1: 1	دَرْسِ الْمَسَائِلِ
u'دَرْسٌ نِظَامِيٌّ':Added, #1: 1	دَرَسَ مُسْتَنَدُهُ
u'دَرَكٌ ثَمَنٌ':Added, #1: 1	دَرْسَ النِّظَامِيَّةِ
u'دَرَكٌ حَواسٌّ':Added, #1: 1	دَرَكَ الثَّمَنِ
u'دَرَكٌ حَوَاسُّ':Added, #2: 2	دَرَكِ الْحَوَاسِّ
u'دَرَكٌ مُخَالَفَةٌ':Added, #2: 2	دَرَكِ الْحَوَاسِّ
u'دَرَكٌ نجباء':Added, #1: 1	دَرَكُ الْمُخَالَفَةِ
u'دُرُوسٌ حَديثٌ':Added, #1: 1	دَرَكَ النُّجَبَاءِ
u'دُرُوسٌ مَذْهَبٌ':Added, #1: 1	دُرُوسَ الْحَدِيثِ
u'دُرُوسٌ مَسَائِلُ':Added, #1: 1	دُرُوسُ مَذْهَبٍ
u'دَرَى أَميرٌ':Subject, #1: 1	دُرُوسِ الْمَسَائِلِ
u'دَرَى أَيْنٌ':Predicate, #1: 1	دَرَى أَمِيرُ
u'دَرَى جَاهِلٌ':Subject, #1: 1	دَرَى أَيْنَ
u'دَرَى سَاكِتٌ':Subject, #2: 2	دَرَى الْجَاهِلُ
u'دَرَى عَبْدٌ':Subject, #1: 1	دَرَى السَّاكِتُ
u'دَرَى مُخَادِعٌ':Subject, #1: 1	دَرَى عَبْدُ
u'دَرَى مَخْذُولٌ':Subject, #1: 1	دَرَى الْمُخَادِعُ
u'دَسَّ مُخَاطَبٌ':Subject, #1: 1	دَرَى الْمَخْذُولُ
u'دُعَاءٌ أَخٌ':Added, #2: 2	دَسَّ الْمُخَاطَبُ
u'دُعَاءٌ اِسْتِسْقَاءٌ':Added, #1: 1	دُعَاءُ الْأَخِ
u'دُعَاءٌ أَعْضَاءٌ':Added, #1: 1	دُعَاءِ الاِسْتِسْقَاءِ
u'دُعَاءٌ أقْرَبُ':Added, #3: 3	دُعَاءِ الْأَعْضَاءِ
u'دُعَاءٌ الْمَرْءُ':Added, #1: 1	دُعَاءَ الْأَقْرَبِ
u'دُعَاءٌ إمَامٌ':Added, #1: 1	دُعَاءِ الْمَرْءِ
u'دُعَاءٌ أُنْسٌ':Added, #1: 1	دُعَاءِ الْإِمَامِ
u'دُعَاءٌ إِنْسانٌ':Added, #1: 1	دُعَاءُ الْأُنْسِ
u'دُعَاءٌ إِنْسانٌ':Added, #1: 1	دُعَاءُ الْإِنْسَانِ
u'دُعَاءٌ بَعْضٌ':Added, #2: 2	دُعَاءِ الْإِنْسَانِ
u'دُعَاءٌ تَشَهُّدٌ':Added, #2: 2	دُعَاءُ الْبَعْضِ
u'دُعَاءٌ تَضَرُّعٌ':Added, #1: 1	دُعَاءِ التَّشَهُّدِ
u'دُعَاءٌ تَوَجُّهٌ':Added, #4: 4	دُعَاءِ التَّضَرُّعِ
u'دُعَاءٌ تَوَجُّهٌ':Added, #1: 1	دُعَاءَ التَّوَجُّهِ
u'دُعَاءٌ تَوَجُّهٌ':Added, #1: 1	دُعَاءُ التَّوَجُّهِ
u'دُعَاءٌ جَاهِلِيٌّ':Added, #1: 1	دُعَاءِ التَّوَجُّهِ
u'دُعَاءٌ جَاهِلِيَّةٌ':Added, #1: 1	دُعَاءَ الْجَاهِلِيَّةِ
u'دُعَاءٌ جَمَاعَةٌ':Added, #1: 1	دُعَاءَ الْجَاهِلِيَّةِ
u'دُعَاءٌ حاجَةٌ':Added, #1: 1	دُعَاءِ جَمَاعَةٍ
u'دُعَاءٌ حِفْظٌ':Added, #1: 1	دُعَاءِ الْحَاجَةِ
u'دُعَاءٌ خَطِيبٌ':Added, #4: 4	دُعَاءُ الْحِفْظِ
u'دُعَاءٌ خلق':Added, #2: 2	دُعَاءِ الْخَطِيبِ
u'دُعَاءٌ خَلْقٌ':Added, #1: 1	دُعَاءِ الْخَلْقِ
u'دُعَاءٌ رَجُلٌ':Added, #1: 1	دُعَاءِ الْخَلْقِ
u'دُعَاءٌ رَسُولٌ':Added, #1: 1	دُعَاءِ الرَّجُلِ
u'دُعَاءٌ رَسُولٌ':Added, #1: 1	دُعَاءَ الرّسُولِ
u'دُعَاءٌ رَسُولٌ':Added, #1: 1	دُعَاءِ الرَّسُولِ
u'دُعَاءٌ رَسُولٌ':Added, #2: 2	دُعَاءُ الرّسُولِ
u'دُعَاءٌ رَسُولٌ':Added, #5: 5	دُعَاءِ رَسُولِ
u'دُعَاءٌ رَغْبَةٌ':Added, #6: 6	دُعَاءَ الرَّسُولِ
u'دُعَاءٌ رَغْبَةٌ':Added, #4: 4	دُعَاءِ الرَّغْبَةِ
u'دُعَاءٌ رهبة':Added, #4: 4	دُعَاءُ رَغْبَةٍ
u'دُعَاءٌ رَهْبَةٌ':Added, #1: 1	دُعَاءَ الرَّهْبَةِ
u'دُعَاءٌ رهبة':Added, #1: 1	دُعَاءَ الرَّهْبَةِ
u'دُعَاءٌ رَهْبَةٌ':Added, #1: 1	دُعَاءُ رَهْبَةٍ
u'دُعَاءٌ رهبة':Added, #1: 1	دُعَاءُ رَهْبَةٍ
u'دُعَاءٌ رَهْبَةٌ':Added, #2: 2	دُعَاءُ الرَّهْبَةِ
u'دُعَاءٌ رهبة':Added, #2: 2	دُعَاءُ الرَّهْبَةِ
u'دُعَاءٌ رَهْبَةٌ':Added, #4: 4	دُعَاءِ الرَّهْبَةِ
u'دُعَاءٌ زَوْجٌ':Added, #4: 4	دُعَاءِ الرَّهْبَةِ
u'دُعَاءٌ شَجَرَةٌ':Added, #1: 1	دُعَاءَ الزَّوْجِ
u'دُعَاءٌ شَرْعٌ':Added, #1: 1	دُعَاءِ الشَّجَرَةِ
u'دُعَاءٌ صَائِمٌ':Added, #1: 1	دُعَاءُ الشَّرْعِ
u'دُعَاءٌ ضَرُورَةٌ':Added, #1: 1	دُعَاءِ الصَّائِمِ
u'دُعَاءٌ طَبْعٌ':Added, #1: 1	دُعَاءِ ضَرُورَةٍ
u'دُعَاءٌ عَبْدٌ':Added, #3: 3	دُعَاءِ الطَّبْعِ
u'دُعَاءٌ عظماء':Added, #1: 1	دُعَاءِ الْعَبْدِ
u'دُعَاءٌ عَلِيٌّ':Added, #1: 1	دُعَاءِ الْعُظَمَاءِ
u'دُعَاءٌ غَائِبٌ':Added, #1: 1	دُعَاءِ عَلِيِّ
u'دُعَاءٌ قَارِئٌ':Added, #1: 1	دُعَاءُ الْغَائِبِ
u'دُعَاءٌ قُرْآنٌ':Added, #1: 1	دُعَاءِ الْقَارِئِ
u'دُعَاءٌ قَلِيلٌ':Added, #1: 1	دُعَاءِ الْقُرْآنِ
u'دُعَاءٌ قُنُوتٌ':Added, #1: 1	دُعَاءَ الْقَلِيلِ
u'دُعَاءٌ قُنُوتٌ':Added, #14: 14	دُعَاءِ الْقُنُوتِ
u'دُعَاءٌ قُنُوتٌ':Added, #1: 1	دُعَاءُ الْقُنُوتِ
u'دُعَاءٌ قُنُوتٌ':Added, #1: 1	دُعَاءِ قُنُوتِ
u'دُعَاءٌ قَوْمٌ':Added, #2: 2	دُعَاءَ الْقُنُوتِ
u'دُعَاءٌ كَافِرٌ':Added, #1: 1	دُعَاءِ الْقَوْمِ
u'دُعَاءٌ كَافِرٌ':Added, #1: 1	دُعَاءُ الْكَافِرِ
u'دُعَاءٌ كُتَّابٌ':Added, #2: 2	دُعَاءِ الْكَافِرِ
u'دُعَاءٌ كَرْبٌ':Added, #1: 1	دُعَاءِ الْكُتَّابِ
u'دُعَاءٌ كُرَبٌ':Added, #1: 1	دُعَاءُ الْكَرْبِ
u'دُعَاءٌ كَرْبٌ':Added, #1: 1	دُعَاءِ الْكُرَبِ
u'دُعَاءٌ كُفَّارٌ':Added, #3: 3	دُعَاءِ الْكَرْبِ
u'دُعَاءٌ لُغَةٌ':Added, #1: 1	دُعَاءِ الْكُفّارِ
u'دُعَاءٌ مَخْصُوصٌ':Added, #1: 1	دُعَاءِ اللُّغَةِ
u'دُعَاءٌ مُسْتَجَابٌ':Added, #1: 1	دُعَاءٍ مَخْصُوصٍ
u'دُعَاءٌ مَظْلُومٌ':Added, #1: 1	دُعَاءٍ مُسْتَجَابٍ
u'دُعَاءٌ مَغْفُورٌ':Added, #1: 1	دُعَاءِ الْمَظْلُومِ
u'دُعَاءٌ مَلاَئِكَةٌ':Added, #1: 1	دُعَاءَ الْمَغْفُورِ
u'دُعَاءٌ نَاسٌ':Added, #1: 1	دُعَاءِ الْمَلَائِكَةِ
u'دُعَاءٌ نَبِيٌّ':Added, #1: 1	دُعَاءُ النَّاسِ
u'دُعَاءٌ نَبِيٌّ':Added, #1: 1	دُعَاءُ النَّبِيِّ
u'دُعَاءٌ واحد':Added, #6: 6	دُعَاءِ النَّبِيِّ
u'دُعَاءٌ وَاحِدٌ':Added, #1: 1	دُعَاءٍ وَاحِدٍ
u'دُعَاءٌ ولد':Added, #1: 1	دُعَاءٍ وَاحِدٍ
u'دُعَاءٌ ولد':Added, #1: 1	دُعَاءَ الْوَلَدِ
u'دُعَاءٌ ولد':Added, #1: 1	دُعَاءُ الْوَلَدِ
u'دُعَاءٌ وَلَدٌ':Added, #1: 1	دُعَاءِ الْوَلَدِ
u'دُعَاءٌ وَلَدٌ':Added, #1: 1	دُعَاءَ الْوَلَدِ
u'دُعَاءٌ وَلَدٌ':Added, #1: 1	دُعَاءُ الْوَلَدِ
u'دُعَاءٌ ولد':Added, #1: 1	دُعَاءِ الْوَلَدِ
u'دُعَاءٌ وَلَدٌ':Added, #1: 1	دُعَاءَ وَلَدِهِ
u'دُعَاءٌ يَوْمٌ':Added, #1: 1	دُعَاءَ وَلَدِهِ
u'دَعَا اِبْنٌ':Predicate, #8: 8	دُعَاءُ يَوْمِ
u'دَعَا اِبْنٌ':Subject, #1: 1	دَعَا ابْنَ
u'دَعَا أحَدٌ':Subject, #2: 2	دَعَا ابْنُ
u'دَعَا أَعْرابٌ':Predicate, #2: 2	دَعَا أَحَدُ
u'دَعَا أكفاء':Predicate, #1: 1	دَعَا الْأَعْرَابَ
u'دَعَا أُمٌّ':Predicate, #1: 1	دَعَا الْأَكْفَاءَ
u'دَعَا إمَامٌ':Subject, #1: 1	دَعَا أُمَّ
u'دَعَا أنبياء':Subject, #1: 1	دَعَا الْإِمَامُ
u'دَعَا أنصار':Predicate, #1: 1	دَعَا الْأَنْبِيَاءُ
u'دَعَا أَنْصارٌ':Predicate, #1: 1	دَعَا الأَنْصَارَ
u'دَعَا أَنْصَارٌ':Predicate, #1: 1	دَعَا الأَنْصَارَ
u'دَعَا أنصار':Predicate, #1: 1	دَعَا الأَنْصَارَ
u'دَعَا أَنْصارٌ':Predicate, #2: 2	دَعَا الْأَنْصَارَ
u'دَعَا أَنْصَارٌ':Predicate, #2: 2	دَعَا الْأَنْصَارَ
u'دَعَا أَوَّلُ':Predicate, #2: 2	دَعَا الْأَنْصَارَ
u'دَعَا أئِمَّةٌ':Subject, #1: 1	دَعَا الْأَوَّلَ
u'دَعَا بَيْعٌ':Predicate, #1: 1	دَعَا أَئِمَّةُ
u'دَعَا بَيْنٌ':Predicate, #1: 1	دَعَا الْبَيْعَ
u'دَعَا جَارِي':Predicate, #2: 2	دَعَا بَيْنَ
u'دَعَا جَارِيَةٌ':Predicate, #2: 2	دَعَا الْجَارِيَةَ
u'دَعَا جَيْشٌ':Predicate, #2: 2	دَعَا الْجَارِيَةَ
u'دَعَا خَارِجٌ':Predicate, #1: 1	دَعَا الْجَيْشَ
u'دَعَا خَالِدٌ':Predicate, #1: 1	دَعَا خَارِجَ
u'دَعَا خَصْمٌ':Subject, #1: 1	دَعَا خَالِدَ
u'دَعَا دَعْوَةٌ':Predicate, #1: 1	دَعَا الْخَصْمُ
u'دَعَا دونٌ':Predicate, #1: 1	دَعَا دَعْوَةَ
u'دَعَا رَأْسٌ':Predicate, #1: 1	دَعَا دُونَ
u'دَعَا رَبُّ':Subject, #1: 1	دَعَا رَأْسَ
u'دَعَا رَجُلٌ':Predicate, #2: 2	دَعَا رَبّهُ
u'دَعَا رَجُلٌ':Predicate, #2: 2	دَعَا الرَّجُلَ
u'دَعَا رَجُلٌ':Subject, #2: 2	دَعَا رَجُلاً
u'دَعَا رَجُلٌ':Subject, #3: 3	دَعَا رَجُلٌ
u'دَعَا رَسُولٌ':Predicate, #7: 7	دَعَا الرَّجُلُ
u'دَعَا رَسُولٌ':Subject, #8: 8	دَعَا رَسُولَ
u'دَعَا رَسُولٌ':Subject, #1: 1	دَعَا الرَّسُولُ
u'دَعَا زَوْجٌ':Subject, #28: 28	دَعَا رَسُولُ
u'دَعَا زَوْجٌ':Subject, #1: 1	دَعَا زَوْجٌ
u'دَعَا سَعْدٌ':Predicate, #2: 2	دَعَا الزَّوْجُ
u'دَعَا سَيِّدٌ':Subject, #2: 2	دَعَا سَعْدَ
u'دَعَا صَادِقٌ':Subject, #1: 1	دَعَا السَّيِّدُ
u'دَعَا ضَرِيرٌ':Subject, #1: 1	دَعَا صَادِقٌ
u'دَعَا طَائِفٌ':Predicate, #1: 1	دَعَا الضَّرِيرُ
u'دَعَا طَلْحٌ':Predicate, #2: 2	دَعَا طَائِفَةً
u'دَعَا طلحة':Predicate, #2: 2	دَعَا طَلْحَةَ
u'دَعَا عَبْدٌ':Predicate, #2: 2	دَعَا طَلْحَةَ
u'دَعَا عَبْدٌ':Subject, #2: 2	دَعَا عَبْدَ
u'دَعَا عَشِيَّةٌ':Predicate, #1: 1	دَعَا عَبْدُ
u'دَعَا عَلِيٌّ':Subject, #3: 3	دَعَا عَشِيَّةَ
u'دَعَا عُمَرٌ':Predicate, #1: 1	دَعَا عَلِيٌّ
u'دَعَا عُمَرٌ':Subject, #1: 1	دَعَا عُمَرَ
u'دَعَا غير':Subject, #7: 7	دَعَا عُمَرُ
u'دَعَا غَيْرٌ':Subject, #1: 1	دَعَا غَيْرُ
u'دَعَا فَاطِمٌ':Predicate, #1: 1	دَعَا غَيْرُ
u'دَعَا فِتْيَانٌ':Predicate, #1: 1	دَعَا فَاطِمَةَ
u'دَعَا فَضْلٌ':Predicate, #1: 1	دَعَا الْفِتْيَانَ
u'دَعَا فَقِيرٌ':Subject, #1: 1	دَعَا الْفَضْلَ
u'دَعَا فلان':Predicate, #1: 1	دَعَا الْفَقِيرُ
u'دَعَا فلان':Predicate, #1: 1	دَعَا الزُّبَيْرَ
u'دَعَا فلان':Predicate, #1: 1	دَعَا جُبَيْرَ
u'دَعَا فلان':Predicate, #1: 1	دَعَا حُذَيْفَةَ
u'دَعَا فلان':Predicate, #1: 1	دَعَا عُبَيْدَةَ
u'دَعَا فلان':Subject, #3: 3	دَعَا عُثْمَانَ
u'دَعَا فلان':Subject, #1: 1	دَعَا مُعَاوِيَةُ
u'دَعَا قَاذِفٌ':Subject, #2: 2	دَعَا عُثْمَانُ
u'دَعَا قَبَائِلُ':Predicate, #1: 1	دَعَا الْقَاذِفُ
u'دَعَا قَوْمٌ':Predicate, #1: 1	دَعَا الْقَبَائِلَ
u'دَعَا كَافِرٌ':Subject, #1: 1	دَعَا الْقَوْمَ
u'دَعَا مُسْلِمٌ':Subject, #1: 1	دَعَا كَافِرٌ
u'دَعَا مَشْيَخَةٌ':Predicate, #1: 1	دَعَا مُسْلِمٌ
u'دَعَا مُعاوِيَة':Subject, #1: 1	دَعَا مَشْيَخَةَ
u'دَعَا مُغْتاب':Predicate, #1: 1	دَعَا مُعَاوِيَةُ
u'دَعَا نَاسٌ':Predicate, #1: 1	دَعَا الْمُغْتَابَ
u'دَعَا نَاسٌ':Predicate, #3: 3	دَعَا النّاسَ
u'دَعَا نَبِيٌّ':Predicate, #4: 4	دَعَا النَّاسَ
u'دَعَا نَبِيٌّ':Subject, #4: 4	دَعَا النَّبِيَّ
u'دَعَا هِرٌّ':Predicate, #7: 7	دَعَا النَّبِيُّ
u'دَعَاوَى أمناء':Added, #1: 1	دَعَا الْهِرَّةَ
u'دَعَاوَى أهْلٌ':Added, #1: 1	دَعَاوَى الْأُمَنَاءِ
u'دَعَاوَى دفع':Added, #1: 1	دَعَاوَى أَهْلِ
u'دَعَاوَى دَفْعٌ':Added, #1: 1	دَعَاوَى الدَّفْعِ
u'دَعَا يهود':Predicate, #1: 1	دَعَاوَى الدَّفْعِ
u'دَعَا يَهُودٌ':Predicate, #2: 2	دَعَا الْيَهُودَ
u'دَعِبَ لعب':Predicate, #2: 2	دَعَا الْيَهُودَ
u'دَعِبَ لَعِبٌ':Predicate, #1: 1	دَعِبَ لَعِبَ
u'دَعِرَ عُودٌ':Predicate, #1: 1	دَعِبَ لَعِبَ
u'دَعْوَةٌ أَبٌ':Added, #1: 1	دَعِرَ الْعُودَ
u'دَعْوَةٌ أَبٌ':Added, #2: 2	دَعْوَةِ الْأَبِ
u'دَعْوَةٌ أَخٌ':Added, #8: 8	دَعْوَةُ الْأَبِ
u'دَعْوَةٌ أَذَانٌ':Added, #1: 1	دَعْوَةُ الأَخِ
u'دَعْوَةٌ اِسْتِيلاد':Added, #2: 2	دَعْوَةُ الْأَذَانِ
u'دَعْوَةٌ اِسْتِيلاد':Added, #4: 4	دَعْوَةَ اسْتِيلَادٍ
u'دَعْوَةٌ إِسْلامٌ':Added, #8: 8	دَعْوَةُ اسْتِيلَادٍ
u'دَعْوَةٌ إِسْلامٌ':Added, #2: 2	دَعْوَةِ الْإِسْلَامِ
u'دَعْوَةٌ إِعْتاقٌ':Added, #4: 4	دَعْوَةُ الْإِسْلَامِ
u'دَعْوَةٌ أكْبَرُ':Added, #1: 1	دَعْوَةُ إعْتَاقٍ
u'دَعْوَةٌ الْمَرْءُ':Added, #2: 2	دَعْوَةِ الْأَكْبَرِ
u'دَعْوَةٌ أُمٌّ':Added, #3: 3	دَعْوَةُ الْمَرْءِ
u'دَعْوَةٌ أَوَّلُ':Added, #1: 1	دَعْوَةِ الْأُمِّ
u'دَعْوَةٌ أَوْلاَدٌ':Added, #1: 1	دَعْوَةِ الْأَوَّلِ
u'دَعْوَةٌ بَائِعٌ':Added, #1: 1	دَعْوَةَ الْأَوْلَادِ
u'دَعْوَةٌ بَائِعٌ':Added, #13: 13	دَعْوَةُ الْبَائِعِ
u'دَعْوَةٌ بَائِعٌ':Added, #1: 1	دَعْوَةَ الْبَائِعِ
u'دَعْوَةٌ بِنْتٌ':Added, #5: 5	دَعْوَةِ الْبَائِعِ
u'دَعْوَةٌ بُنُوَّة':Added, #2: 2	دَعْوَةُ الْبِنْتِ
u'دَعْوَةٌ تَحْرِيرٌ':Added, #2: 2	دَعْوَةَ الْبُنُوَّةِ
u'دَعْوَةٌ تَحْرِيرٌ':Added, #10: 10	دَعْوَةُ تَحْرِيرٍ
u'دَعْوَةٌ تَحْرِيرٌ':Added, #1: 1	دَعْوَةَ التَّحْرِيرِ
u'دَعْوَةٌ تَحْرِيرٌ':Added, #3: 3	دَعْوَةِ التَّحْرِيرِ
u'دَعْوَةٌ تَحْرِيرٌ':Added, #5: 5	دَعْوَةَ تَحْرِيرٍ
u'دَعْوَةٌ ثَانِي':Added, #6: 6	دَعْوَةُ التَّحْرِيرِ
u'دَعْوَةٌ ثَانِيَةٌ':Added, #1: 1	دَعْوَةَ الثَّانِيَةِ
u'دَعْوَةٌ جَاهِلِيٌّ':Added, #1: 1	دَعْوَةَ الثَّانِيَةِ
u'دَعْوَةٌ جَاهِلِيٌّ':Added, #1: 1	دَعْوَةَ الْجَاهِلِيَّةِ
u'دَعْوَةٌ جَاهِلِيَّةٌ':Added, #1: 1	دَعْوَةَ جَاهِلِيَّةٍ
u'دَعْوَةٌ جَاهِلِيَّةٌ':Added, #1: 1	دَعْوَةَ الْجَاهِلِيَّةِ
u'دَعْوَةٌ جَنَّةٌ':Added, #1: 1	دَعْوَةَ جَاهِلِيَّةٍ
u'دَعْوَةٌ حُرٌّ':Added, #1: 1	دَعْوَةُ الْجَنّةِ
u'دَعْوَةٌ حُرٌّ':Added, #1: 1	دَعْوَةِ الْحُرِّ
u'دَعْوَةٌ حَقٌّ':Added, #2: 2	دَعْوَةُ الْحُرِّ
u'دَعْوَةٌ خَالِدٌ':Added, #1: 1	دَعْوَةِ الْحَقِّ
u'دَعْوَةٌ ختان':Added, #1: 1	دَعْوَةُ خَالِدٍ
u'دَعْوَةٌ خِتَانٌ':Added, #2: 2	دَعْوَةُ الْخِتَانِ
u'دَعْوَةٌ خلق':Added, #2: 2	دَعْوَةُ الْخِتَانِ
u'دَعْوَةٌ خَلْقٌ':Added, #1: 1	دَعْوَةُ الْخَلْقِ
u'دَعْوَةٌ دِيوانٌ':Added, #1: 1	دَعْوَةُ الْخَلْقِ
u'دَعْوَةٌ ذِمِّيٌّ':Added, #1: 1	دَعْوَةُ الدِّيوَانِ
u'دَعْوَةٌ رَجُلٌ':Added, #2: 2	دَعْوَةَ الذِّمِّيِّ
u'دَعْوَةٌ رَجُلٌ':Added, #1: 1	دَعْوَةُ الرّجُلِ
u'دَعْوَةٌ رُسُلٌ':Added, #2: 2	دَعْوَةَ رَجُلٍ
u'دَعْوَةٌ رَسُولٌ':Added, #1: 1	دَعْوَةِ الرُّسُلِ
u'دَعْوَةٌ رَسُولٌ':Added, #1: 1	دَعْوَةَ الرّسُولِ
u'دَعْوَةٌ رَسُولٌ':Added, #1: 1	دَعْوَةَ رَسُولِ
u'دَعْوَةٌ رَسُولٌ':Added, #1: 1	دَعْوَةِ رَسُولِهِ
u'دَعْوَةٌ زَوْجٌ':Added, #2: 2	دَعْوَةُ رَسُولِ
u'دَعْوَةٌ سَعْدٌ':Added, #1: 1	دَعْوَةُ الزَّوْجِ
u'دَعْوَةٌ سَعْدٌ':Added, #1: 1	دَعْوَةَ سَعْدٍ
u'دَعْوَةٌ سُلْطَانٌ':Added, #1: 1	دَعْوَةُ سَعْدٍ
u'دَعْوَةٌ سُلْطَانٌ':Added, #1: 1	دَعْوَةِ السُّلْطَانِ
u'دَعْوَةٌ شُبْهَةٌ':Added, #2: 2	دَعْوَةُ السُّلْطَانِ
u'دَعْوَةٌ شُبْهَةٌ':Added, #1: 1	دَعْوَةُ شُبْهَةِ
u'دَعْوَةٌ صَاحِبٌ':Added, #1: 1	دَعْوَةِ شُبْهَةِ
u'دَعْوَةٌ صَائِمٌ':Added, #1: 1	دَعْوَةُ صَاحِبِ
u'دَعْوَةٌ صَائِمٌ':Added, #1: 1	دَعْوَةَ الصَّائِمِ
u'دَعْوَةٌ عَبْدٌ':Added, #1: 1	دَعْوَةُ الصَّائِمِ
u'دَعْوَةٌ عَبْدٌ':Added, #1: 1	دَعْوَةُ عَبْدِ
u'دَعْوَةٌ عَبْدٌ':Added, #2: 2	دَعْوَةِ الْعَبْدِ
u'دَعْوَةٌ عِتْقٌ':Added, #3: 3	دَعْوَةَ الْعَبْدِ
u'دَعْوَةٌ عَرَبٌ':Added, #2: 2	دَعْوَةُ عِتْقٍ
u'دَعْوَةٌ عُرْسٌ':Added, #1: 1	دَعْوَةِ الْعَرَبِ
u'دَعْوَةٌ عُرْسٌ':Added, #1: 1	دَعْوَةِ عُرْسٍ
u'دَعْوَةٌ غَائِبٌ':Added, #4: 4	دَعْوَةُ الْعُرْسِ
u'دَعْوَةٌ غير':Added, #2: 2	دَعْوَةُ غَائِبٍ
u'دَعْوَةٌ غَيْرٌ':Added, #1: 1	دَعْوَةِ الْغَيْرِ
u'دَعْوَةٌ غير':Added, #1: 1	دَعْوَةِ الْغَيْرِ
u'دَعْوَةٌ غَيْرٌ':Added, #1: 1	دَعْوَةُ غَيْرِ
u'دَعْوَةٌ غير':Added, #1: 1	دَعْوَةُ غَيْرِ
u'دَعْوَةٌ غَيْرٌ':Added, #1: 1	دَعْوَةُ غَيْرِهِ
u'دَعْوَةٌ فَاسِقٌ':Added, #1: 1	دَعْوَةُ غَيْرِهِ
u'دَعْوَةٌ فَقِيرٌ':Added, #2: 2	دَعْوَةَ الْفَاسِقِ
u'دَعْوَةٌ قَرِيبٌ':Added, #1: 1	دَعْوَةَ الْفَقِيرِ
u'دَعْوَةٌ كَافِرٌ':Added, #1: 1	دَعْوَةَ الْقَرِيبِ
u'دَعْوَةٌ مَجُوسِيٌّ':Added, #1: 1	دَعْوَةِ الْكَافِرِ
u'دَعْوَةٌ مَجُوسِيٌّ':Added, #1: 1	دَعْوَةَ مَجُوسِيٍّ
u'دَعْوَةٌ مُحَمَّدٌ':Added, #1: 1	دَعْوَةِ مَجُوسِيٍّ
u'دَعْوَةٌ مُدَبَّرٌ':Added, #1: 1	دَعْوَةُ مُحَمَّدٍ
u'دَعْوَةٌ مُسْلِمٌ':Added, #1: 1	دَعْوَةِ الْمُدَبَّرِ
u'دَعْوَةٌ مُسْلِمٌ':Added, #1: 1	دَعْوَةَ الْمُسْلِمِ
u'دَعْوَةٌ مُسْلِمٌ':Added, #1: 1	دَعْوَةِ الْمُسْلِمِ
u'دَعْوَةٌ مُسْلِمٌ':Added, #1: 1	دَعْوَةَ مُسْلِمٍ
u'دَعْوَةٌ مُضَارِبٌ':Added, #5: 5	دَعْوَةُ الْمُسْلِمِ
u'دَعْوَةٌ مُضَارِبٌ':Added, #2: 2	دَعْوَةُ الْمُضَارِبِ
u'دَعْوَةٌ مَظْلُومٌ':Added, #2: 2	دَعْوَةِ الْمُضَارِبِ
u'دَعْوَةٌ مَظْلُومٌ':Added, #11: 11	دَعْوَةُ الْمَظْلُومِ
u'دَعْوَةٌ مَظْلُومٌ':Added, #17: 17	دَعْوَةَ الْمَظْلُومِ
u'دَعْوَةٌ مَظْلُومٌ':Added, #1: 1	دَعْوَةِ الْمَظْلُومِ
u'دَعْوَةٌ مَكْرُوبٌ':Added, #1: 1	دَعْوَةُ مَظْلُومٍ
u'دَعْوَةٌ مِلْكٌ':Added, #1: 1	دَعْوَةُ الْمَكْرُوبِ
u'دَعْوَةٌ مِلْكٌ':Added, #1: 1	دَعْوَةَ الْمِلْكِ
u'دَعْوَةٌ مِلْكٌ':Added, #1: 1	دَعْوَةُ الْمِلْكِ
u'دَعْوَةٌ مَمْلُوكٌ':Added, #2: 2	دَعْوَةُ مِلْكٍ
u'دَعْوَةٌ مُنَاسَبَةٌ':Added, #1: 1	دَعْوَةِ الْمَمْلُوكِ
u'دَعْوَةٌ نَبِيٌّ':Added, #1: 1	دَعْوَةِ الْمُنَاسَبَةِ
u'دَعْوَةٌ نَبِيٌّ':Added, #2: 2	دَعْوَةُ النَّبِيِّ
u'دَعْوَةٌ نَسَبٌ':Added, #2: 2	دَعْوَةِ النَّبِيِّ
u'دَعْوَةٌ نَسَبٌ':Added, #1: 1	دَعْوَةُ النَّسَبِ
u'دَعْوَةٌ نَسَبٌ':Added, #1: 1	دَعْوَةِ نَسَبِ
u'دَعْوَةٌ نَسَبٌ':Added, #2: 2	دَعْوَةَ النَّسَبِ
u'دَعْوَةٌ نَسَبٌ':Added, #2: 2	دَعْوَةِ نَسَبِهِ
u'دَعْوَةٌ نَظَرٌ':Added, #3: 3	دَعْوَةِ النَّسَبِ
u'دَعْوَةٌ واحد':Added, #1: 1	دَعْوَةَ النَّظَرِ
u'دَعْوَةٌ وَاحِدٌ':Added, #4: 4	دَعْوَةُ وَاحِدٍ
u'دَعْوَةٌ وَالِدٌ':Added, #4: 4	دَعْوَةُ وَاحِدٍ
u'دَعْوَةٌ ولد':Added, #2: 2	دَعْوَةُ الْوَالِدِ
u'دَعْوَةٌ ولد':Added, #1: 1	دَعْوَةَ الْوَلَدِ
u'دَعْوَةٌ وَلَدٌ':Added, #1: 1	دَعْوَةِ الْوَلَدِ
u'دَعْوَةٌ وَلَدٌ':Added, #1: 1	دَعْوَةَ الْوَلَدِ
u'دَعْوَةٌ ولد':Added, #1: 1	دَعْوَةِ الْوَلَدِ
u'دَعْوَةٌ وَلَدٌ':Added, #2: 2	دَعْوَةُ الْوَلَدِ
u'دَعْوَةٌ وَلَدٌ':Added, #2: 2	دَعْوَةُ الْوَلَدِ
u'دَعْوَةٌ ولد':Added, #2: 2	دَعْوَةِ وَلَدَيْنِ
u'دَعْوَةٌ وَلَدٌ':Added, #3: 3	دَعْوَةِ وَلَدِ
u'دَعْوَةٌ وَلِيمَةٌ':Added, #3: 3	دَعْوَةِ وَلَدِ
u'دَعْوَةٌ يَهُودِيٌّ':Added, #1: 1	دَعْوَةِ الْوَلِيمَةِ
u'دَعْوَى أَبٌ':Added, #1: 1	دَعْوَةَ يَهُودِيٍّ
u'دَعْوَى إبَاحَةٌ':Added, #3: 3	دَعْوَى الْأَبِ
u'دَعْوَى إِبْطَالٌ':Added, #1: 1	دَعْوَى الْإِبَاحَةِ
u'دَعْوَى اِبْنٌ':Added, #1: 1	دَعْوَى إبْطَالِهِ
u'دَعْوَى أُبُوَّةٌ':Added, #1: 1	دَعْوَى ابْنِ
u'دَعْوَى إِتْلاَفٌ':Added, #4: 4	دَعْوَى الْأُبُوَّةِ
u'دَعْوَى اِتِّهَامٌ':Added, #1: 1	دَعْوَى الْإِتْلَافِ
u'دَعْوَى إِتْيانٌ':Added, #1: 1	دَعْوَى اتِّهَامٍ
u'دَعْوَى إجَارَةٌ':Added, #1: 1	دَعْوَى الْإِتْيَانِ
u'دَعْوَى إجَارَةٌ':Added, #1: 1	دَعْوَى إجَارَةِ
u'دَعْوَى إجَارَةٌ':Added, #2: 2	دَعْوَى إجَارَةٍ
u'دَعْوَى إجَازَةٌ':Added, #4: 4	دَعْوَى الْإِجَارَةِ
u'دَعْوَى أَجْرٌ':Added, #3: 3	دَعْوَى الْإِجَازَةِ
u'دَعْوَى أُجْرَةٌ':Added, #1: 1	دَعْوَى الْأَجْرِ
u'دَعْوَى أَجَلٌ':Added, #1: 1	دَعْوَى الْأُجْرَةِ
u'دَعْوَى أَجَلٌ':Added, #2: 2	دَعْوَى أَجَلٍ
u'دَعْوَى إِجْمَاعٌ':Added, #3: 3	دَعْوَى الْأَجَلِ
u'دَعْوَى إِجْمَاعٌ':Added, #17: 17	دَعْوَى الْإِجْمَاعِ
u'دَعْوَى أَجْنَبِيٌّ':Added, #1: 1	دَعْوَى إجْمَاعِ
u'دَعْوَى أَجْنَبِيٌّ':Added, #1: 1	دَعْوَى أَجْنَبِيٍّ
u'دَعْوَى أحَدٌ':Added, #1: 1	دَعْوَى الْأَجْنَبِيِّ
u'دَعْوَى أحَدٌ':Added, #1: 1	دَعْوَى أَحَدِ
u'دَعْوَى إحْضَارٌ':Added, #4: 4	دَعْوَى أَحَدٍ
u'دَعْوَى إحْضَارٌ':Added, #1: 1	دَعْوَى الْإِحْضَارِ
u'دَعْوَى إِحْلاَلٌ':Added, #2: 2	دَعْوَى إحْضَارِ
u'دَعْوَى إِحْيَاءٌ':Added, #2: 2	دَعْوَى الْإِحْلَالِ
u'دَعْوَى أَخٌ':Added, #1: 1	دَعْوَى إحْيَاءِ
u'دَعْوَى إِخْبَارٌ':Added, #1: 1	دَعْوَى الْأَخِ
u'دَعْوَى أُخْتٌ':Added, #1: 1	دَعْوَى الْإِخْبَارِ
u'دَعْوَى إِخْرَاجٌ':Added, #1: 1	دَعْوَى أُخْتِهِ
u'دَعْوَى أُخُوَّةٌ':Added, #1: 1	دَعْوَى الْإِخْرَاجِ
u'دَعْوَى أَدَاءٌ':Added, #5: 5	دَعْوَى الْأُخُوَّةِ
u'دَعْوَى إِذْنٌ':Added, #2: 2	دَعْوَى الْأَدَاءِ
u'دَعْوَى إِرَادَةٌ':Added, #1: 1	دَعْوَى الْإِذْنِ
u'دَعْوَى إِرَادَةٌ':Added, #2: 2	دَعْوَى إرَادَتِهِ
u'دَعْوَى أَرْبَعَةٌ':Added, #4: 4	دَعْوَى إرَادَةِ
u'دَعْوَى إِرْثٌ':Added, #1: 1	دَعْوَى أَرْبَعَةِ
u'دَعْوَى أرْضٌ':Added, #6: 6	دَعْوَى الْإِرْثِ
u'دَعْوَى إِزَالَةٌ':Added, #2: 2	دَعْوَى أَرْضٍ
u'دَعْوَى اِسْتِبْراء':Added, #1: 1	دَعْوَى إزَالَةٍ
u'دَعْوَى اِسْتِحْقَاقٌ':Added, #3: 3	دَعْوَى اسْتِبْرَاءٍ
u'دَعْوَى اِسْتِئْجَارٌ':Added, #4: 4	دَعْوَى اسْتِحْقَاقِ
u'دَعْوَى اِسْتِيلاد':Added, #1: 1	دَعْوَى اسْتِئْجَارِ
u'دَعْوَى إِسْلامٌ':Added, #3: 3	دَعْوَى اسْتِيلَادٍ
u'دَعْوَى أصل':Added, #1: 1	دَعْوَى الْإِسْلَامِ
u'دَعْوَى أًصْلٌ':Added, #1: 1	دَعْوَى أَصْلِ
u'دَعْوَى أصل':Added, #1: 1	دَعْوَى أَصْلِ
u'دَعْوَى أًصْلٌ':Added, #5: 5	دَعْوَى الْأَصْلِ
u'دَعْوَى اِعْتِرافٌ':Added, #5: 5	دَعْوَى الْأَصْلِ
u'دَعْوَى إعْرَاضٌ':Added, #1: 1	دَعْوَى اعْتِرَافِهِ
u'دَعْوَى أعْيانٌ':Added, #1: 1	دَعْوَى الْإِعْرَاضِ
u'دَعْوَى أَعْيَانٌ':Added, #1: 1	دَعْوَى أَعْيَانٍ
u'دَعْوَى أعْيانٌ':Added, #1: 1	دَعْوَى أَعْيَانٍ
u'دَعْوَى أَعْيَانٌ':Added, #2: 2	دَعْوَى الْأَعْيَانِ
u'دَعْوَى إفَادَةٌ':Added, #2: 2	دَعْوَى الْأَعْيَانِ
u'دَعْوَى إقالَةٌ':Added, #1: 1	دَعْوَى إفَادَتِهِ
u'دَعْوَى إقْرَارٌ':Added, #1: 1	دَعْوَى الْإِقَالَةِ
u'دَعْوَى إقْرَارٌ':Added, #12: 12	دَعْوَى الْإِقْرَارِ
u'دَعْوَى أقَلُّ':Added, #1: 1	دَعْوَى إقْرَارِ
u'دَعْوَى اِكْتِسَابٌ':Added, #4: 4	دَعْوَى أَقَلِّ
u'دَعْوَى أكْثَرِيَّةٌ':Added, #1: 1	دَعْوَى اكْتِسَابِ
u'دَعْوَى إكْرَاهٌ':Added, #1: 1	دَعْوَى أَكْثَرِيَّةِ
u'دَعْوَى اِلْتِقَاطٌ':Added, #5: 5	دَعْوَى الْإِكْرَاهِ
u'دَعْوَى إلْغَاءٌ':Added, #1: 1	دَعْوَى الْتِقَاطِ
u'دَعْوَى ألف':Added, #1: 1	دَعْوَى إلْغَاءِ
u'دَعْوَى ألْفٌ':Added, #7: 7	دَعْوَى الْأَلْفِ
u'دَعْوَى أَلْفٌ':Added, #7: 7	دَعْوَى الْأَلْفِ
u'دَعْوَى الْمَرْأَةُ':Added, #7: 7	دَعْوَى الْأَلْفِ
u'دَعْوَى أُمٌّ':Added, #14: 14	دَعْوَى الْمَرْأَةِ
u'دَعْوَى إمَامٌ':Added, #6: 6	دَعْوَى الْأُمِّ
u'دَعْوَى إمَامٌ':Added, #1: 1	دَعْوَى الْإِمَامِ
u'دَعْوَى أمَانٌ':Added, #1: 1	دَعْوَى إمَامِ
u'دَعْوَى أمَانَةٌ':Added, #1: 1	دَعْوَى الْأَمَانِ
u'دَعْوَى أمَةٌ':Added, #1: 1	دَعْوَى الْأَمَانَةِ
u'دَعْوَى اِمْتِناعٌ':Added, #5: 5	دَعْوَى الْأَمَةِ
u'دَعْوَى اِمْتِناعٌ':Added, #1: 1	دَعْوَى امْتِنَاعِ
u'دَعْوَى اِمْرَأَةٌ':Added, #1: 1	دَعْوَى امْتِنَاعِهِ
u'دَعْوَى أَمْلاكٌ':Added, #2: 2	دَعْوَى امْرَأَةٍ
u'دَعْوَى أَمْلاَكٌ':Added, #2: 2	دَعْوَى الْأَمْلَاكِ
u'دَعْوَى أَمْوَالٌ':Added, #2: 2	دَعْوَى الْأَمْلَاكِ
u'دَعْوَى أُمومَةٌ':Added, #6: 6	دَعْوَى الْأَمْوَالِ
u'دَعْوَى إِنْسانٌ':Added, #1: 1	دَعْوَى الْأُمُومَةِ
u'دَعْوَى إِنْفاقٌ':Added, #3: 3	دَعْوَى الْإِنْسَانِ
u'دَعْوَى إِنْفاقٌ':Added, #1: 1	دَعْوَى الْإِنْفَاقِ
u'دَعْوَى إِنْفاقٌ':Added, #1: 1	دَعْوَى إنْفَاقٍ
u'دَعْوَى اِنْقِضاءٌ':Added, #2: 2	دَعْوَى إنْفَاقِهِ
u'دَعْوَى أهْلٌ':Added, #2: 2	دَعْوَى انْقِضَاءِ
u'دَعْوَى أَوَّلُ':Added, #1: 1	دَعْوَى أَهْلِ
u'دَعْوَى أَوْلَوِيٌّ':Added, #1: 1	دَعْوَى الْأَوَّلِ
u'دَعْوَى أَوَّلِيٌّ':Added, #2: 2	دَعْوَى الْأَوْلَوِيَّةِ
u'دَعْوَى أيتام':Added, #4: 4	دَعْوَى أَوَّلِيَّةِ
u'دَعْوَى إِيدَاعٌ':Added, #2: 2	دَعْوَى الْأَيْتَامِ
u'دَعْوَى إِيدَاعٌ':Added, #1: 1	دَعْوَى إيدَاعِ
u'دَعْوَى إيصَالٌ':Added, #3: 3	دَعْوَى الْإِيدَاعِ
u'دَعْوَى بَائِعٌ':Added, #1: 1	دَعْوَى إيصَالِ
u'دَعْوَى بَائِعٌ':Added, #17: 17	دَعْوَى الْبَائِعِ
u'دَعْوَى بَراءةٌ':Added, #1: 1	دَعْوَى بَائِعِ
u'دَعْوَى بِرْذَوْنٌ':Added, #3: 3	دَعْوَى الْبَرَاءَةِ
u'دَعْوَى بَزّاز':Added, #1: 1	دَعْوَى الْبِرْذَوْنِ
u'دَعْوَى بَزّازَة':Added, #9: 9	دَعْوَى الْبَزَّازِيَّةِ
u'دَعْوَى بِشْرٌ':Added, #9: 9	دَعْوَى الْبَزَّازِيَّةِ
u'دَعْوَى بِضاعَةٌ':Added, #1: 1	دَعْوَى بِشْرٍ
u'دَعْوَى بَعْضٌ':Added, #2: 2	دَعْوَى الْبِضَاعَةِ
u'دَعْوَى بَعْضٌ':Added, #2: 2	دَعْوَى الْبَعْضِ
u'دَعْوَى بَقِيَّةٌ':Added, #2: 2	دَعْوَى بَعْضِ
u'دَعْوَى بَكارَةٌ':Added, #2: 2	دَعْوَى بَقِيَّةِ
u'دَعْوَى بُلُوغٌ':Added, #1: 1	دَعْوَى الْبَكَارَةِ
u'دَعْوَى بُلُوغٌ':Added, #1: 1	دَعْوَى بُلُوغِ
u'دَعْوَى بِنَاءٌ':Added, #4: 4	دَعْوَى الْبُلُوغِ
u'دَعْوَى بُنُوَّة':Added, #3: 3	دَعْوَى الْبِنَاءِ
u'دَعْوَى بَيْعٌ':Added, #7: 7	دَعْوَى الْبُنُوَّةِ
u'دَعْوَى بَيْعٌ':Added, #12: 12	دَعْوَى الْبَيْعِ
u'دَعْوَى بَيْعٌ':Added, #1: 1	دَعْوَى بَيْعٍ
u'دَعْوَى تَارِيخٌ':Added, #1: 1	دَعْوَى بَيْعِ
u'دَعْوَى تَجْدِيدٌ':Added, #1: 1	دَعْوَى التَّارِيخِ
u'دَعْوَى تَجْهِيل':Added, #2: 2	دَعْوَى التَّجْدِيدِ
u'دَعْوَى تَجْوِيزٌ':Added, #1: 1	دَعْوَى تَجْهِيلِ
u'دَعْوَى تَحْرِيرٌ':Added, #1: 1	دَعْوَى تَجْوِيزِ
u'دَعْوَى تَحْرِيرٌ':Added, #1: 1	دَعْوَى التَّحْرِيرِ
u'دَعْوَى تَحْقِيقٌ':Added, #1: 1	دَعْوَى تَحْرِيرٍ
u'دَعْوَى تَحْقِيقٌ':Added, #1: 1	دَعْوَى تَحْقِيقٍ
u'دَعْوَى تَحَكُّمٌ':Added, #6: 6	دَعْوَى التَّحْقِيقِ
u'دَعْوَى تَحْلِيف':Added, #1: 1	دَعْوَى التَّحَكُّمِ
u'دَعْوَى تَخارُج':Added, #1: 1	دَعْوَى التَّحْلِيفِ
u'دَعْوَى تَخْصِيصٌ':Added, #1: 1	دَعْوَى التَّخَارُجِ
u'دَعْوَى تَخْلِيَة':Added, #1: 1	دَعْوَى التَّخْصِيصِ
u'دَعْوَى تَدْبِيرٌ':Added, #1: 1	دَعْوَى التَّخْلِيَةِ
u'دَعْوَى تَرِكَةٌ':Added, #1: 1	دَعْوَى التَّدْبِيرِ
u'دَعْوَى تَسَلْسُلٌ':Added, #1: 1	دَعْوَى التَّرِكَةِ
u'دَعْوَى تَسْلِيمٌ':Added, #1: 1	دَعْوَى التَّسَلْسُلِ
u'دَعْوَى تَسْلِيمٌ':Added, #1: 1	دَعْوَى التَّسْلِيمِ
u'دَعْوَى تَعَارُضٌ':Added, #2: 2	دَعْوَى تَسْلِيمِ
u'دَعْوَى تَعَدُّدٌ':Added, #1: 1	دَعْوَى التَّعَارُضِ
u'دَعْوَى تَعْلِيلٌ':Added, #1: 1	دَعْوَى التَّعَدُّدِ
u'دَعْوَى تَغَيُّرٌ':Added, #1: 1	دَعْوَى التَّعْلِيلِ
u'دَعْوَى تَفَرُّدٌ':Added, #1: 1	دَعْوَى التَّغَيُّرِ
u'دَعْوَى تَفْرِيغٌ':Added, #1: 1	دَعْوَى تَفَرُّدِ
u'دَعْوَى تَكْرارٌ':Added, #1: 1	دَعْوَى تَفْرِيغِ
u'دَعْوَى تَلَف':Added, #1: 1	دَعْوَى التَّكْرَارِ
u'دَعْوَى تَمَلُّك':Added, #18: 18	دَعْوَى التَّلَفِ
u'دَعْوَى تَمَلُّكٌ':Added, #2: 2	دَعْوَى التَّمَلُّكِ
u'دَعْوَى تَمْلِيك':Added, #2: 2	دَعْوَى تَمَلُّكِهِ
u'دَعْوَى تَمْلِيكٌ':Added, #1: 1	دَعْوَى التَّمْلِيكِ
u'دَعْوَى تَنَاقُضٌ':Added, #1: 1	دَعْوَى تَمْلِيكٍ
u'دَعْوَى تَوْفِيقٌ':Added, #1: 1	دَعْوَى التَّنَاقُضِ
u'دَعْوَى تَوْكِيلٌ':Added, #4: 4	دَعْوَى التَّوْفِيقِ
u'دَعْوَى تَوَهُّمٌ':Added, #1: 1	دَعْوَى التَّوْكِيلِ
u'دَعْوَى ثَلاثُ':Added, #2: 2	دَعْوَى التَّوَهُّمِ
u'دَعْوَى ثَمَنٌ':Added, #1: 1	دَعْوَى الثَّلَاثِ
u'دَعْوَى ثَمَنٌ':Added, #3: 3	دَعْوَى ثَمَنِ
u'دَعْوَى ثَوْبٌ':Added, #5: 5	دَعْوَى الثَّمَنِ
u'دَعْوَى جَارِي':Added, #1: 1	دَعْوَى الثَّوْبِ
u'دَعْوَى جَارِيَةٌ':Added, #2: 2	دَعْوَى الْجَارِيَةِ
u'دَعْوَى جَامِعٌ':Added, #2: 2	دَعْوَى الْجَارِيَةِ
u'دَعْوَى جَاهِلِيٌّ':Added, #3: 3	دَعْوَى الْجَامِعِ
u'دَعْوَى جَاهِلِيٌّ':Added, #1: 1	دَعْوَى الْجَاهِلِيَّةِ
u'دَعْوَى جَاهِلِيَّةٌ':Added, #3: 3	دَعْوَى الْجَاهِلِيّةِ
u'دَعْوَى جَاهِلِيَّةٌ':Added, #1: 1	دَعْوَى الْجَاهِلِيَّةِ
u'دَعْوَى جِرَاحَةٌ':Added, #3: 3	دَعْوَى الْجَاهِلِيّةِ
u'دَعْوَى جَمِيع':Added, #1: 1	دَعْوَى جِرَاحَةِ
u'دَعْوَى جِنَايَةٌ':Added, #1: 1	دَعْوَى الْجَمِيعِ
u'دَعْوَى جَهالَة':Added, #1: 1	دَعْوَى الْجِنَايَةِ
u'دَعْوَى جهل':Added, #5: 5	دَعْوَى الْجَهَالَةِ
u'دَعْوَى جَهْلٌ':Added, #11: 11	دَعْوَى الْجَهْلِ
u'دَعْوَى جهل':Added, #11: 11	دَعْوَى الْجَهْلِ
u'دَعْوَى جَهْلٌ':Added, #2: 2	دَعْوَى جَهْلِهِ
u'دَعْوَى جهل':Added, #2: 2	دَعْوَى جَهْلِهِ
u'دَعْوَى جَهْلٌ':Added, #3: 3	دَعْوَى جَهْلِ
u'دَعْوَى جَوْرٌ':Added, #3: 3	دَعْوَى جَهْلِ
u'دَعْوَى حاجَةٌ':Added, #2: 2	دَعْوَى جَوْرٍ
u'دَعْوَى حاضِرٌ':Added, #1: 1	دَعْوَى الْحَاجَةِ
u'دَعْوَى حانوتٌ':Added, #2: 2	دَعْوَى الْحَاضِرِ
u'دَعْوَى حائِزٌ':Added, #1: 1	دَعْوَى الْحَانُوتِ
u'دَعْوَى حائِطٌ':Added, #1: 1	دَعْوَى الْحَائِزِ
u'دَعْوَى حَدّ':Added, #1: 1	دَعْوَى الْحَائِطِ
u'دَعْوَى حَدٌّ':Added, #1: 1	دَعْوَى الْحَدِّيَّةِ
u'دَعْوَى حَدٌّ':Added, #1: 1	دَعْوَى حَدِّ
u'دَعْوَى حُرْمَةٌ':Added, #3: 3	دَعْوَى حَدٍّ
u'دَعْوَى حُرِّيَّةٌ':Added, #2: 2	دَعْوَى الْحُرْمَةِ
u'دَعْوَى حُرِّيَّةٌ':Added, #12: 12	دَعْوَى الْحُرِّيَّةِ
u'دَعْوَى حِسْبَةٌ':Added, #3: 3	دَعْوَى حُرِّيَّةِ
u'دَعْوَى حِسْبَةٌ':Added, #4: 4	دَعْوَى حِسْبَةٍ
u'دَعْوَى حَقٌّ':Added, #5: 5	دَعْوَى الْحِسْبَةِ
u'دَعْوَى حَقٌّ':Added, #2: 2	دَعْوَى الْحَقِّ
u'دَعْوَى حَقٌّ':Added, #3: 3	دَعْوَى حَقِّ
u'دَعْوَى حَقِيقٌ':Added, #4: 4	دَعْوَى حَقٍّ
u'دَعْوَى حَقِيقَةٌ':Added, #1: 1	دَعْوَى الْحَقِيقَةِ
u'دَعْوَى حُكْمٌ':Added, #1: 1	دَعْوَى الْحَقِيقَةِ
u'دَعْوَى حُكْمٌ':Added, #1: 1	دَعْوَى الْحُكْمِ
u'دَعْوَى حَمْلٌ':Added, #1: 1	دَعْوَى حُكْمٍ
u'دَعْوَى حِنْطَةٌ':Added, #2: 2	دَعْوَى الْحَمْلِ
u'دَعْوَى حَنَفِيَّةٌ':Added, #1: 1	دَعْوَى الْحِنْطَةِ
u'دَعْوَى حَوَالَةٌ':Added, #1: 1	دَعْوَى الْحَنَفِيَّةِ
u'دَعْوَى خَارِجٌ':Added, #2: 2	دَعْوَى الْحَوَالَةِ
u'دَعْوَى خَارِجٌ':Added, #3: 3	دَعْوَى الْخَارِجِ
u'دَعْوَى خان':Added, #3: 3	دَعْوَى الْخَارِجَيْنِ
u'دَعْوَى خانَة':Added, #1: 1	دَعْوَى الْخَانِيَّةِ
u'دَعْوَى خَرْسَاء':Added, #1: 1	دَعْوَى الْخَانِيَّةِ
u'دَعْوَى خرق':Added, #1: 1	دَعْوَى الْخَرْسَاءِ
u'دَعْوَى خَرْقٌ':Added, #1: 1	دَعْوَى خَرْقِ
u'دَعْوَى خَصْمٌ':Added, #1: 1	دَعْوَى خَرْقِ
u'دَعْوَى خَصْمٌ':Added, #3: 3	دَعْوَى الْخَصْمِ
u'دَعْوَى خُصُوصِيٌّ':Added, #3: 3	دَعْوَى خَصْمِهِ
u'دَعْوَى خَطَأٌ':Added, #1: 1	دَعْوَى الْخُصُوصِيَّةِ
u'دَعْوَى خِلاَفٌ':Added, #2: 2	دَعْوَى الْخَطَأِ
u'دَعْوَى خِلاَفٌ':Added, #1: 1	دَعْوَى خِلَافِ
u'دَعْوَى خَمْرٌ':Added, #2: 2	دَعْوَى خِلَافِهِ
u'دَعْوَى خَمْرِيٌّ':Added, #1: 1	دَعْوَى الْخَمْرِ
u'دَعْوَى خِيَانَةٌ':Added, #1: 1	دَعْوَى الْخَمْرِيَّةِ
u'دَعْوَى دَابَّةٌ':Added, #4: 4	دَعْوَى الْخِيَانَةِ
u'دَعْوَى دَارٌ':Added, #2: 2	دَعْوَى الدَّابَّةِ
u'دَعْوَى دَارٌ':Added, #1: 1	دَعْوَى دَارٍ
u'دَعْوَى دَائِنٌ':Added, #4: 4	دَعْوَى الدَّارِ
u'دَعْوَى دَرَاهِمُ':Added, #2: 2	دَعْوَى الدَّائِنِ
u'دَعْوَى دفع':Added, #1: 1	دَعْوَى الدَّرَاهِمِ
u'دَعْوَى دَفْعٌ':Added, #18: 18	دَعْوَى الدَّفْعِ
u'دَعْوَى دفع':Added, #18: 18	دَعْوَى الدَّفْعِ
u'دَعْوَى دَفْعٌ':Added, #6: 6	دَعْوَى دَفْعِ
u'دَعْوَى دَليلٌ':Added, #6: 6	دَعْوَى دَفْعِ
u'دَعْوَى دَمٌ':Added, #1: 1	دَعْوَى الدَّلِيلِ
u'دَعْوَى دَنانيرُ':Added, #10: 10	دَعْوَى الدَّمِ
u'دَعْوَى دنيء':Added, #2: 2	دَعْوَى الدَّنَانِيرِ
u'دَعْوَى دُهْنٌ':Added, #1: 1	دَعْوَى دَنِيءٍ
u'دَعْوَى دَوْرٌ':Added, #1: 1	دَعْوَى الدُّهْنِ
u'دَعْوَى دُورٌ':Added, #1: 1	دَعْوَى الدَّوْرِ
u'دَعْوَى دِيَةٌ':Added, #2: 2	دَعْوَى الدُّورِ
u'دَعْوَى دَيْمومَةٌ':Added, #1: 1	دَعْوَى دِيَةِ
u'دَعْوَى دَيْنٌ':Added, #1: 1	دَعْوَى الدَّيْمُومَةِ
u'دَعْوَى دَيْنٌ':Added, #3: 3	دَعْوَى دَيْنٍ
u'دَعْوَى ذكر':Added, #47: 47	دَعْوَى الدَّيْنِ
u'دَعْوَى ذِكْرٌ':Added, #1: 1	دَعْوَى ذِكْرِ
u'دَعْوَى ذَمٌّ':Added, #1: 1	دَعْوَى ذِكْرِ
u'دَعْوَى ذِمِّيٌّ':Added, #1: 1	دَعْوَى الذَّمِّ
u'دَعْوَى رَاهِنٌ':Added, #1: 1	دَعْوَى الذِّمِّيِّ
u'دَعْوَى رَبُّ':Added, #1: 1	دَعْوَى الرَّاهِنِ
u'دَعْوَى رَجُلٌ':Added, #1: 1	دَعْوَى رَبِّ
u'دَعْوَى رَجُلٌ':Added, #1: 1	دَعْوَى رَجُلَيْنِ
u'دَعْوَى رَجُلٌ':Added, #8: 8	دَعْوَى الرَّجُلَيْنِ
u'دَعْوَى رَجُلٌ':Added, #8: 8	دَعْوَى رَجُلٍ
u'دَعْوَى رُجُوعٌ':Added, #9: 9	دَعْوَى الرَّجُلِ
u'دَعْوَى رَدٌّ':Added, #3: 3	دَعْوَى الرُّجُوعِ
u'دَعْوَى رَدٌّ':Added, #1: 1	دَعْوَى رَدٍّ
u'دَعْوَى رَدٌّ':Added, #1: 1	دَعْوَى رَدِّ
u'دَعْوَى رَدٌّ':Added, #2: 2	دَعْوَى رَدِّهِ
u'دَعْوَى رَدَاءةٌ':Added, #34: 34	دَعْوَى الرَّدِّ
u'دَعْوَى رِسَالَةٌ':Added, #1: 1	دَعْوَى الرَّدَاءَةِ
u'دَعْوَى رِسَالَةٌ':Added, #1: 1	دَعْوَى الرِّسَالَةِ
u'دَعْوَى رِسَالَةٌ':Added, #1: 1	دَعْوَى رِسَالَةِ
u'دَعْوَى رضاع':Added, #1: 1	دَعْوَى رِسَالَتِهِ
u'دَعْوَى رِقٌّ':Added, #1: 1	دَعْوَى الرَّضَاعِ
u'دَعْوَى رِقٌّ':Added, #1: 1	دَعْوَى رِقِّهِ
u'دَعْوَى رَقَبَةٌ':Added, #8: 8	دَعْوَى الرِّقِّ
u'دَعْوَى رَمْلِيٌّ':Added, #1: 1	دَعْوَى رَقَبَةِ
u'دَعْوَى رَهْنٌ':Added, #1: 1	دَعْوَى الرَّمْلِيِّ
u'دَعْوَى رُؤْيَةٌ':Added, #6: 6	دَعْوَى الرَّهْنِ
u'دَعْوَى رُؤْيَةٌ':Added, #1: 1	دَعْوَى رُؤْيَةٍ
u'دَعْوَى رُؤْيَةٌ':Added, #1: 1	دَعْوَى رُؤْيَتِهِ
u'دَعْوَى رِيبَةٌ':Added, #3: 3	دَعْوَى الرُّؤْيَةِ
u'دَعْوَى زَجَّاجٌ':Added, #1: 1	دَعْوَى الرِّيبَةِ
u'دَعْوَى زَوالٌ':Added, #1: 1	دَعْوَى الزَّجَّاجِ
u'دَعْوَى زَوالٌ':Added, #1: 1	دَعْوَى زَوَالِهِ
u'دَعْوَى زَوْجٌ':Added, #2: 2	دَعْوَى زَوَالِ
u'دَعْوَى زَوْجَةٌ':Added, #11: 11	دَعْوَى الزَّوْجِ
u'دَعْوَى زَوْجِيٌّ':Added, #1: 1	دَعْوَى الزَّوْجَةِ
u'دَعْوَى زِيادَةٌ':Added, #1: 1	دَعْوَى الزَّوْجِيَّةِ
u'دَعْوَى زَيْدٌ':Added, #4: 4	دَعْوَى الزِّيَادَةِ
u'دَعْوَى سَبَبٌ':Added, #1: 1	دَعْوَى زَيْدٍ
u'دَعْوَى سَبْقٌ':Added, #1: 1	دَعْوَى السَّبَبِ
u'دَعْوَى سَرقَةٌ':Added, #1: 1	دَعْوَى سَبْقِ
u'دَعْوَى سَرِقَةٌ':Added, #2: 2	دَعْوَى سَرِقَةٍ
u'دَعْوَى سَرقَةٌ':Added, #2: 2	دَعْوَى سَرِقَةٍ
u'دَعْوَى سَرِقَةٌ':Added, #9: 9	دَعْوَى السَّرِقَةِ
u'دَعْوَى سِعَايَةٌ':Added, #9: 9	دَعْوَى السَّرِقَةِ
u'دَعْوَى سَفَرٌ':Added, #4: 4	دَعْوَى السِّعَايَةِ
u'دَعْوَى سَفِيهٌ':Added, #1: 1	دَعْوَى السَّفَرِ
u'دَعْوَى سقط':Added, #1: 1	دَعْوَى السَّفِيهِ
u'دَعْوَى سَقَطٌ':Added, #1: 1	دَعْوَى السَّقَطِ
u'دَعْوَى سَقَطٌ':Added, #1: 1	دَعْوَى السَّقَطِ
u'دَعْوَى سُقُوطٌ':Added, #1: 1	دَعْوَى سَقَطٍ
u'دَعْوَى سكر':Added, #1: 1	دَعْوَى سُقُوطِ
u'دَعْوَى سُكْرٌ':Added, #2: 2	دَعْوَى السُّكْرِ
u'دَعْوَى سَهْوٌ':Added, #2: 2	دَعْوَى السُّكْرِ
u'دَعْوَى سَيِّدٌ':Added, #1: 1	دَعْوَى سَهْوٍ
u'دَعْوَى شَاهِدٌ':Added, #3: 3	دَعْوَى السَّيِّدِ
u'دَعْوَى شُبْهَةٌ':Added, #2: 2	دَعْوَى الشَّاهِدِ
u'دَعْوَى شُبْهَةٌ':Added, #6: 6	دَعْوَى الشُّبْهَةِ
u'دَعْوَى شِرَاءٌ':Added, #8: 8	دَعْوَى شُبْهَةٍ
u'دَعْوَى شِرَاءٌ':Added, #1: 1	دَعْوَى شِرَاءِ
u'دَعْوَى شرب':Added, #20: 20	دَعْوَى الشِّرَاءِ
u'دَعْوَى شُرْبٌ':Added, #1: 1	دَعْوَى الشُّرْبِ
u'دَعْوَى شرب':Added, #1: 1	دَعْوَى الشُّرْبِ
u'دَعْوَى شِرْبٌ':Added, #2: 2	دَعْوَى الشِّرْبِ
u'دَعْوَى شَرْطٌ':Added, #2: 2	دَعْوَى الشِّرْبِ
u'دَعْوَى شركة':Added, #4: 4	دَعْوَى الشَّرْطِ
u'دَعْوَى شَرِكَةٌ':Added, #1: 1	دَعْوَى شَرِكَةِ
u'دَعْوَى شَرِيكٌ':Added, #1: 1	دَعْوَى شَرِكَةِ
u'دَعْوَى شفعة':Added, #1: 1	دَعْوَى الشَّرِيكِ
u'دَعْوَى شُفْعَةٌ':Added, #3: 3	دَعْوَى الشُّفْعَةِ
u'دَعْوَى شَفِيعٌ':Added, #3: 3	دَعْوَى الشُّفْعَةِ
u'دَعْوَى شَيْءٌ':Added, #2: 2	دَعْوَى الشَّفِيعِ
u'دَعْوَى شَيْءٌ':Added, #2: 2	دَعْوَى الشَّيْءِ
u'دَعْوَى شَيْخٌ':Added, #4: 4	دَعْوَى شَيْءٍ
u'دَعْوَى شَيْخٌ':Added, #1: 1	دَعْوَى الشَّيْخِ
u'دَعْوَى صَاحِبٌ':Added, #1: 1	دَعْوَى شَيْخِ
u'دَعْوَى صَانِعٌ':Added, #39: 39	دَعْوَى صَاحِبِهِ
u'دَعْوَى صَبِيٌّ':Added, #2: 2	دَعْوَى الصَّانِعِ
u'دَعْوَى صَبِيٌّ':Added, #1: 1	دَعْوَى صَبِيٍّ
u'دَعْوَى صِحَّةٌ':Added, #2: 2	دَعْوَى الصَّبِيِّ
u'دَعْوَى صدقة':Added, #12: 12	دَعْوَى الصِّحَّةِ
u'دَعْوَى صَدَقَةٌ':Added, #2: 2	دَعْوَى الصَّدَقَةِ
u'دَعْوَى صَرَاحَةٌ':Added, #2: 2	دَعْوَى الصَّدَقَةِ
u'دَعْوَى صِغَرٌ':Added, #1: 1	دَعْوَى الصَّرَاحَةِ
u'دَعْوَى صَغِيرٌ':Added, #2: 2	دَعْوَى الصِّغَرِ
u'دَعْوَى صلح':Added, #4: 4	دَعْوَى الصَّغِيرِ
u'دَعْوَى صُلْحٌ':Added, #2: 2	دَعْوَى الصُّلْحِ
u'دَعْوَى ضَامِنٌ':Added, #2: 2	دَعْوَى الصُّلْحِ
u'دَعْوَى ضَامِنٌ':Added, #1: 1	دَعْوَى الضَّامِنِ
u'دَعْوَى ضَرُورَةٌ':Added, #1: 1	دَعْوَى الضَّامِنَيْنِ
u'دَعْوَى ضَمَانٌ':Added, #1: 1	دَعْوَى الضَّرُورَةِ
u'دَعْوَى ضَيَاعٌ':Added, #3: 3	دَعْوَى الضَّمَانِ
u'دَعْوَى ضِيَاعٌ':Added, #1: 1	دَعْوَى ضَيَاعِهِ
u'دَعْوَى ضَيَاعٌ':Added, #4: 4	دَعْوَى الضِّيَاعِ
u'دَعْوَى طَارِئٌ':Added, #6: 6	دَعْوَى الضَّيَاعِ
u'دَعْوَى طَرِيقٌ':Added, #1: 1	دَعْوَى طَارِئَةٍ
u'دَعْوَى طَلاَقٌ':Added, #1: 1	دَعْوَى الطَّرِيقِ
u'دَعْوَى ظَنٌّ':Added, #7: 7	دَعْوَى الطَّلَاقِ
u'دَعْوَى ظُهورٌ':Added, #1: 1	دَعْوَى ظَنِّهِ
u'دَعْوَى ظُهورٌ':Added, #1: 1	دَعْوَى الظُّهُورِ
u'دَعْوَى عارِيَّةٌ':Added, #2: 2	دَعْوَى ظُهُورِ
u'دَعْوَى عَامِلٌ':Added, #1: 1	دَعْوَى الْعَارِيَّةِ
u'دَعْوَى عَبْد':Added, #1: 1	دَعْوَى الْعَامِلِ
u'دَعْوَى عَبْدٌ':Added, #1: 1	دَعْوَى الْعَبْدِيَّةِ
u'دَعْوَى عَبْدٌ':Added, #3: 3	دَعْوَى عَبْدٍ
u'دَعْوَى عَبْدِيّ':Added, #9: 9	دَعْوَى الْعَبْدِ
u'دَعْوَى عتق':Added, #1: 1	دَعْوَى الْعَبْدِيَّةِ
u'دَعْوَى عِتْقٌ':Added, #2: 2	دَعْوَى عِتْقِهِ
u'دَعْوَى عتق':Added, #2: 2	دَعْوَى عِتْقِهِ
u'دَعْوَى عِتْقٌ':Added, #9: 9	دَعْوَى الْعِتْقِ
u'دَعْوَى عَدَدٌ':Added, #9: 9	دَعْوَى الْعِتْقِ
u'دَعْوَى عَدَمٌ':Added, #1: 1	دَعْوَى عَدَدٍ
u'دَعْوَى عَدَمٌ':Added, #1: 1	دَعْوَى عَدَمِهِ
u'دَعْوَى عرف':Added, #6: 6	دَعْوَى عَدَمِ
u'دَعْوَى عُرْفٌ':Added, #1: 1	دَعْوَى عُرْفٍ
u'دَعْوَى عُسْرَةٌ':Added, #1: 1	دَعْوَى عُرْفٍ
u'دَعْوَى عِصْمَةٌ':Added, #1: 1	دَعْوَى الْعُسْرَةِ
u'دَعْوَى عَفْوٌ':Added, #1: 1	دَعْوَى الْعِصْمَةِ
u'دَعْوَى عَفْوٌ':Added, #1: 1	دَعْوَى الْعَفْوِ
u'دَعْوَى عَقَارٌ':Added, #1: 1	دَعْوَى عَفْوِ
u'دَعْوَى عَقْدٌ':Added, #8: 8	دَعْوَى الْعَقَارِ
u'دَعْوَى عَقْدٌ':Added, #1: 1	دَعْوَى عَقْدِ
u'دَعْوَى عَقْدٌ':Added, #2: 2	دَعْوَى عَقْدٍ
u'دَعْوَى علم':Added, #9: 9	دَعْوَى الْعَقْدِ
u'دَعْوَى عِلْمٌ':Added, #1: 1	دَعْوَى عِلْمِ
u'دَعْوَى عَمَلٌ':Added, #1: 1	دَعْوَى عِلْمِ
u'دَعْوَى عَمَلٌ':Added, #1: 1	دَعْوَى الْعَمَلِ
u'دَعْوَى عُمُومٌ':Added, #1: 1	دَعْوَى عَمَلِ
u'دَعْوَى عُمُوم':Added, #12: 12	دَعْوَى الْعُمُومِ
u'دَعْوَى عُمُومَة':Added, #1: 1	دَعْوَى الْعُمُومَةِ
u'دَعْوَى عُنَّة':Added, #1: 1	دَعْوَى الْعُمُومَةِ
u'دَعْوَى عِوَض':Added, #1: 1	دَعْوَى الْعُنَّةِ
u'دَعْوَى عَيْبٌ':Added, #1: 1	دَعْوَى الْعِوَضِيَّةِ
u'دَعْوَى عين':Added, #5: 5	دَعْوَى الْعَيْبِ
u'دَعْوَى عَيْنٌ':Added, #1: 1	دَعْوَى عَيْنِ
u'دَعْوَى عَيْن':Added, #1: 1	دَعْوَى عَيْنِ
u'دَعْوَى عين':Added, #1: 1	دَعْوَى عَيْنِ
u'دَعْوَى عَيْنٌ':Added, #6: 6	دَعْوَى الْعَيْنِ
u'دَعْوَى عَيْن':Added, #6: 6	دَعْوَى الْعَيْنِ
u'دَعْوَى عَيْنٌ':Added, #6: 6	دَعْوَى الْعَيْنِ
u'دَعْوَى عَيْن':Added, #9: 9	دَعْوَى عَيْنٍ
u'دَعْوَى غَاصِبٌ':Added, #9: 9	دَعْوَى عَيْنٍ
u'دَعْوَى غَائِبٌ':Added, #1: 1	دَعْوَى غَاصِبِ
u'دَعْوَى غَبَنٌ':Added, #3: 3	دَعْوَى الْغَائِبِ
u'دَعْوَى غَبْنٌ':Added, #1: 1	دَعْوَى الْغَبَنِ
u'دَعْوَى غُرْمٌ':Added, #2: 2	دَعْوَى الْغَبْنِ
u'دَعْوَى غُرُورٌ':Added, #1: 1	دَعْوَى الْغُرْمِ
u'دَعْوَى غَرِيمٌ':Added, #1: 1	دَعْوَى الْغُرُورِ
u'دَعْوَى غَصْبٌ':Added, #1: 1	دَعْوَى غَرِيمِ
u'دَعْوَى غَصْبٌ':Added, #18: 18	دَعْوَى الْغَصْبِ
u'دَعْوَى غَصْبٌ':Added, #1: 1	دَعْوَى غَصْبِ
u'دَعْوَى غَلَّةٌ':Added, #2: 2	دَعْوَى غَصْبٍ
u'دَعْوَى غَلَّةٌ':Added, #1: 1	دَعْوَى الْغَلَّةِ
u'دَعْوَى غَلَطٌ':Added, #1: 1	دَعْوَى غَلَّةِ
u'دَعْوَى غَلَطٌ':Added, #11: 11	دَعْوَى الْغَلَطِ
u'دَعْوَى غَلَطٌ':Added, #1: 1	دَعْوَى غَلَطِ
u'دَعْوَى غَيْبَةٌ':Added, #3: 3	دَعْوَى غَلَطٍ
u'دَعْوَى غير':Added, #1: 1	دَعْوَى غَيْبَةِ
u'دَعْوَى غَيْرٌ':Added, #1: 1	دَعْوَى غَيْرِهِ
u'دَعْوَى غير':Added, #1: 1	دَعْوَى غَيْرِهِ
u'دَعْوَى غَيْرٌ':Added, #4: 4	دَعْوَى الْغَيْرِ
u'دَعْوَى غير':Added, #4: 4	دَعْوَى الْغَيْرِ
u'دَعْوَى غَيْرٌ':Added, #6: 6	دَعْوَى غَيْرِ
u'دَعْوَى فَارِغٌ':Added, #6: 6	دَعْوَى غَيْرِ
u'دَعْوَى فَاسِدٌ':Added, #1: 1	دَعْوَى فَارِغَةٍ
u'دَعْوَى فَرْض':Added, #2: 2	دَعْوَى فَاسِدَةٍ
u'دَعْوَى فَرْضِيّ':Added, #1: 1	دَعْوَى الْفَرْضِيَّةِ
u'دَعْوَى فَرْضِيَّة':Added, #1: 1	دَعْوَى الْفَرْضِيَّةِ
u'دَعْوَى فرق':Added, #1: 1	دَعْوَى الْفَرْضِيَّةِ
u'دَعْوَى فَرْقٌ':Added, #1: 1	دَعْوَى الْفَرْقِ
u'دَعْوَى فساد':Added, #1: 1	دَعْوَى الْفَرْقِ
u'دَعْوَى فَسَادٌ':Added, #5: 5	دَعْوَى الْفَسَادِ
u'دَعْوَى فِعْلٌ':Added, #5: 5	دَعْوَى الْفَسَادِ
u'دَعْوَى فِعْلٌ':Added, #11: 11	دَعْوَى الْفِعْلِ
u'دَعْوَى فقر':Added, #1: 1	دَعْوَى فِعْلٍ
u'دَعْوَى فَقْرٌ':Added, #1: 1	دَعْوَى الْفَقْرِ
u'دَعْوَى فلان':Added, #1: 1	دَعْوَى الْفَقْرِ
u'دَعْوَى فلان':Added, #1: 1	دَعْوَى التِّرْمِذِيِّ
u'دَعْوَى فلان':Added, #1: 1	دَعْوَى الْخَانِيَّةِ
u'دَعْوَى فلان':Added, #1: 1	دَعْوَى الْعَبْدِيَّةِ
u'دَعْوَى فلان':Added, #1: 1	دَعْوَى تَمِيمٍ
u'دَعْوَى فلان':Added, #1: 1	دَعْوَى قَابِيلِ
u'دَعْوَى قَاذِفٌ':Added, #9: 9	دَعْوَى الْبَزَّازِيَّةِ
u'دَعْوَى قَاذِفٌ':Added, #1: 1	دَعْوَى قَاذِفِ
u'دَعْوَى قَبْضٌ':Added, #1: 1	دَعْوَى قَاذِفِهِ
u'دَعْوَى قَبْضٌ':Added, #1: 1	دَعْوَى قَبْضٍ
u'دَعْوَى قَبْضٌ':Added, #1: 1	دَعْوَى قَبْضِ
u'دَعْوَى قتل':Added, #2: 2	دَعْوَى الْقَبْضِ
u'دَعْوَى قَتْلٌ':Added, #1: 1	دَعْوَى قَتْلِهِ
u'دَعْوَى قتل':Added, #1: 1	دَعْوَى قَتْلِهِ
u'دَعْوَى قَتْلٌ':Added, #6: 6	دَعْوَى قَتْلِ
u'دَعْوَى قتل':Added, #6: 6	دَعْوَى قَتْلِ
u'دَعْوَى قَتْلٌ':Added, #8: 8	دَعْوَى الْقَتْلِ
u'دَعْوَى قَرْضٌ':Added, #8: 8	دَعْوَى الْقَتْلِ
u'دَعْوَى قَرْضٌ':Added, #2: 2	دَعْوَى قَرْضٍ
u'دَعْوَى قُرْعَةٌ':Added, #4: 4	دَعْوَى الْقَرْضِ
u'دَعْوَى قسمة':Added, #1: 1	دَعْوَى الْقُرْعَةِ
u'دَعْوَى قِسْمَةٌ':Added, #1: 1	دَعْوَى الْقِسْمَةِ
u'دَعْوَى قصاص':Added, #1: 1	دَعْوَى الْقِسْمَةِ
u'دَعْوَى قِصَاصٌ':Added, #6: 6	دَعْوَى الْقِصَاصِ
u'دَعْوَى قَضَاءٌ':Added, #6: 6	دَعْوَى الْقِصَاصِ
u'دَعْوَى قَطْعٌ':Added, #3: 3	دَعْوَى الْقَضَاءِ
u'دَعْوَى قُطْنٌ':Added, #4: 4	دَعْوَى الْقَطْعِ
u'دَعْوَى قَمِيصٌ':Added, #1: 1	دَعْوَى الْقُطْنِ
u'دَعْوَى قُوَّةٌ':Added, #1: 1	دَعْوَى الْقَمِيصِ
u'دَعْوَى قُوَّة':Added, #1: 1	دَعْوَى قُوَّةٍ
u'دَعْوَى قَوْمٌ':Added, #1: 1	دَعْوَى قُوَّةٍ
u'دَعْوَى قِيَاسٌ':Added, #1: 1	دَعْوَى الْقَوْمِ
u'دَعْوَى قيام':Added, #2: 2	دَعْوَى قِيَاسِ
u'دَعْوَى قِيَامٌ':Added, #2: 2	دَعْوَى قِيَامِ
u'دَعْوَى قَيِّمٌ':Added, #2: 2	دَعْوَى قِيَامِ
u'دَعْوَى قِيمَةٌ':Added, #3: 3	دَعْوَى الْقَيِّمِ
u'دَعْوَى قِيمَةٌ':Added, #2: 2	دَعْوَى قِيمَةِ
u'دَعْوَى كَافِرٌ':Added, #3: 3	دَعْوَى الْقِيمَةِ
u'دَعْوَى كَافِرٌ':Added, #1: 1	دَعْوَى كَافِرٍ
u'دَعْوَى كَامِلٌ':Added, #2: 2	دَعْوَى الْكَافِرِ
u'دَعْوَى كِتَابَةٌ':Added, #6: 6	دَعْوَى الْكَامِلِ
u'دَعْوَى كذب':Added, #1: 1	دَعْوَى الْكِتَابَةِ
u'دَعْوَى كَذِبٌ':Added, #1: 1	دَعْوَى الْكَذِبِ
u'دَعْوَى كَرَاهَةٌ':Added, #1: 1	دَعْوَى الْكَذِبِ
u'دَعْوَى كَرْمٌ':Added, #2: 2	دَعْوَى الْكَرَاهَةِ
u'دَعْوَى كَسْبٌ':Added, #1: 1	دَعْوَى الْكَرْمِ
u'دَعْوَى كَعْكٌ':Added, #1: 1	دَعْوَى الْكَسْبِ
u'دَعْوَى كَفَالَةٌ':Added, #2: 2	دَعْوَى الْكَعْكِ
u'دَعْوَى كَفَالَةٌ':Added, #1: 1	دَعْوَى كَفَالَةِ
u'دَعْوَى كفر':Added, #8: 8	دَعْوَى الْكَفَالَةِ
u'دَعْوَى كُفْرٌ':Added, #1: 1	دَعْوَى الْكُفْرِ
u'دَعْوَى كَفِيلٌ':Added, #1: 1	دَعْوَى الْكُفْرِ
u'دَعْوَى كَوْنٌ':Added, #1: 1	دَعْوَى الْكَفِيلِ
u'دَعْوَى لَحْمٌ':Added, #3: 3	دَعْوَى كَوْنِ
u'دَعْوَى لُزُومٌ':Added, #2: 2	دَعْوَى اللَّحْمِ
u'دَعْوَى لُزُومٌ':Added, #1: 1	دَعْوَى اللُّزُومِ
u'دَعْوَى لِصٌّ':Added, #2: 2	دَعْوَى لُزُومِ
u'دَعْوَى لَيْثٌ':Added, #1: 1	دَعْوَى اللِّصِّ
u'دَعْوَى مَالٌ':Added, #2: 2	دَعْوَى اللَّيْثِ
u'دَعْوَى مَالٌ':Added, #10: 10	دَعْوَى مَالِ
u'دَعْوَى مَالٌ':Added, #38: 38	دَعْوَى الْمَالِ
u'دَعْوَى مَالِكٌ':Added, #6: 6	دَعْوَى مَالٍ
u'دَعْوَى مَالِيٌّ':Added, #3: 3	دَعْوَى الْمَالِكِ
u'دَعْوَى مَانِعٌ':Added, #1: 1	دَعْوَى مَالِيَّةٍ
u'دَعْوَى مَبْسُوطٌ':Added, #2: 2	دَعْوَى الْمَانِعِ
u'دَعْوَى مُبْطِلٌ':Added, #3: 3	دَعْوَى الْمَبْسُوطِ
u'دَعْوَى مَبِيعٌ':Added, #2: 2	دَعْوَى الْمُبْطِلِ
u'دَعْوَى مِثْلِيٌّ':Added, #2: 2	دَعْوَى الْمَبِيعِ
u'دَعْوَى مَجَازٌ':Added, #1: 1	دَعْوَى الْمِثْلِيَّاتِ
u'دَعْوَى مَجْمَعٌ':Added, #1: 1	دَعْوَى الْمَجَازِ
u'دَعْوَى مَجْنُونٌ':Added, #1: 1	دَعْوَى الْمَجْمَعِ
u'دَعْوَى مَجْهُولٌ':Added, #1: 1	دَعْوَى الْمَجْنُونِ
u'دَعْوَى مَجْهُولٌ':Added, #2: 2	دَعْوَى الْمَجْهُولِ
u'دَعْوَى مَجْهُولٌ':Added, #2: 2	دَعْوَى مَجْهُولٍ
u'دَعْوَى مَحْجُورٌ':Added, #2: 2	دَعْوَى مَجْهُولَةٍ
u'دَعْوَى مُحِقٌّ':Added, #1: 1	دَعْوَى الْمَحْجُورِ
u'دَعْوَى مُخْبِرٌ':Added, #1: 1	دَعْوَى الْمُحِقِّ
u'دَعْوَى مُدَبَّرٌ':Added, #1: 1	دَعْوَى الْمُخْبِرِ
u'دَعْوَى مَدْلُول':Added, #1: 1	دَعْوَى الْمُدَبَّرِ
u'دَعْوَى مَدْيُونٌ':Added, #1: 1	دَعْوَى الْمَدْلُولِيَّةِ
u'دَعْوَى مراد':Added, #1: 1	دَعْوَى الْمَدْيُونِ
u'دَعْوَى مُرَادٌ':Added, #1: 1	دَعْوَى مُرَادٍ
u'دَعْوَى مُرْتَهِنٌ':Added, #1: 1	دَعْوَى مُرَادٍ
u'دَعْوَى مُسْتَأْجِرٌ':Added, #5: 5	دَعْوَى الْمُرْتَهِنِ
u'دَعْوَى مُسْتَحِقٌّ':Added, #2: 2	دَعْوَى الْمُسْتَأْجِرِ
u'دَعْوَى مُسْتَحِيلٌ':Added, #1: 1	دَعْوَى الْمُسْتَحِقِّ
u'دَعْوَى مُسْتَقِلٌّ':Added, #1: 1	دَعْوَى الْمُسْتَحِيلِ
u'دَعْوَى مُسْتَنَدٌ':Added, #1: 1	دَعْوَى مُسْتَقِلَّةٍ
u'دَعْوَى مَسْرُوقٌ':Added, #1: 1	دَعْوَى مُسْتَنَدِهِ
u'دَعْوَى مُسْلِمٌ':Added, #1: 1	دَعْوَى الْمَسْرُوقِ
u'دَعْوَى مُسْلِمٌ':Added, #1: 1	دَعْوَى الْمُسْلِمِ
u'دَعْوَى مُشاعٌ':Added, #1: 1	دَعْوَى مُسْلِمٍ
u'دَعْوَى مُشَاكَلَةٌ':Added, #1: 1	دَعْوَى الْمُشَاعِ
u'دَعْوَى مُضَارَبَةٌ':Added, #1: 1	دَعْوَى الْمُشَاكَلَةِ
u'دَعْوَى مُطَالَبٌ':Added, #1: 1	دَعْوَى الْمُضَارَبَةِ
u'دَعْوَى مُطَالَبٌ':Added, #1: 1	دَعْوَى مُطَالَبَتِهِ
u'دَعْوَى مُطَالَبَةٌ':Added, #3: 3	دَعْوَى الْمُطَالَبَةِ
u'دَعْوَى مُطَالَبَةٌ':Added, #1: 1	دَعْوَى مُطَالَبَتِهِ
u'دَعْوَى مُطْلَقٌ':Added, #3: 3	دَعْوَى الْمُطَالَبَةِ
u'دَعْوَى مُطْلَقٌ':Added, #1: 1	دَعْوَى الْمُطْلَقِ
u'دَعْوَى مُعَارَضَةٌ':Added, #2: 2	دَعْوَى مُطْلَقِ
u'دَعْوَى مُعْتَرِضٌ':Added, #1: 1	دَعْوَى الْمُعَارَضَةِ
u'دَعْوَى مُعْجِزٌ':Added, #1: 1	دَعْوَى الْمُعْتَرِضِ
u'دَعْوَى مُعْجِزَةٌ':Added, #1: 1	دَعْوَى الْمُعْجِزَةِ
u'دَعْوَى مَعْرِفَةٌ':Added, #1: 1	دَعْوَى الْمُعْجِزَةِ
u'دَعْوَى مَعْرِفَة':Added, #1: 1	دَعْوَى مَعْرِفَتِهِ
u'دَعْوَى مُعَيَّنٌ':Added, #1: 1	دَعْوَى مَعْرِفَتِهِ
u'دَعْوَى مُغَيَّرٌ':Added, #1: 1	دَعْوَى الْمُعَيَّنَاتِ
u'دَعْوَى مُفَصَّلٌ':Added, #1: 1	دَعْوَى الْمُغَيَّرِ
u'دَعْوَى مَقْذُوفٌ':Added, #1: 1	دَعْوَى مُفَصَّلَةٍ
u'دَعْوَى مُقَيَّدٌ':Added, #1: 1	دَعْوَى الْمَقْذُوفِ
u'دَعْوَى مَكْفُولٌ':Added, #1: 1	دَعْوَى الْمُقَيَّدِ
u'دَعْوَى مُلاَزَمَةٌ':Added, #2: 2	دَعْوَى الْمَكْفُولِ
u'دَعْوَى مُلْتَقِط':Added, #1: 1	دَعْوَى الْمُلَازَمَةِ
u'دَعْوَى مِلْكٌ':Added, #4: 4	دَعْوَى الْمُلْتَقِطِ
u'دَعْوَى مِلْكٌ':Added, #1: 1	دَعْوَى مِلْكِهِ
u'دَعْوَى مِلْكٌ':Added, #2: 2	دَعْوَى مِلْكٍ
u'دَعْوَى مِلْكٌ':Added, #2: 2	دَعْوَى مِلْكِ
u'دَعْوَى مَلَكِيٌّ':Added, #52: 52	دَعْوَى الْمِلْكِ
u'دَعْوَى مَلَكِيَّةٌ':Added, #1: 1	دَعْوَى مَلَكِيَّةِ
u'دَعْوَى مِلْكِيَّةٌ':Added, #1: 1	دَعْوَى مَلَكِيَّةِ
u'دَعْوَى مَمَرٌّ':Added, #4: 4	دَعْوَى مِلْكِيَّةِ
u'دَعْوَى مُنَاصَفَةٌ':Added, #1: 1	دَعْوَى الْمَمَرِّ
u'دَعْوَى مَنَافِعُ':Added, #1: 1	دَعْوَى الْمُنَاصَفَةِ
u'دَعْوَى مَنْزِلٌ':Added, #3: 3	دَعْوَى الْمَنَافِعِ
u'دَعْوَى مَنْقُولٌ':Added, #1: 1	دَعْوَى الْمَنْزِلِ
u'دَعْوَى مُنْيَةٌ':Added, #1: 1	دَعْوَى الْمَنْقُولِ
u'دَعْوَى مَهْرٌ':Added, #1: 1	دَعْوَى مُنْيَةِ
u'دَعْوَى مَوْتٌ':Added, #7: 7	دَعْوَى الْمَهْرِ
u'دَعْوَى مُودَعٌ':Added, #2: 2	دَعْوَى مَوْتِ
u'دَعْوَى مَوْقُوفٌ':Added, #1: 1	دَعْوَى الْمُودَعِ
u'دَعْوَى مُوَكِّلٌ':Added, #1: 1	دَعْوَى الْمَوْقُوفِ
u'دَعْوَى مُوَكِّلٌ':Added, #1: 1	دَعْوَى مُوَكِّلِهِ
u'دَعْوَى مِيرَاثٌ':Added, #2: 2	دَعْوَى الْمُوَكِّلِ
u'دَعْوَى ناذِر':Added, #6: 6	دَعْوَى الْمِيرَاثِ
u'دَعْوَى نَاقَةٌ':Added, #1: 1	دَعْوَى نَاذِرٍ
u'دَعْوَى نَاقَة':Added, #1: 1	دَعْوَى النَّاقَةِ
u'دَعْوَى نُبُوَّةٌ':Added, #1: 1	دَعْوَى النَّاقَةِ
u'دَعْوَى نِتَاجٌ':Added, #2: 2	دَعْوَى النُّبُوَّةِ
u'دَعْوَى نُحَاسٌ':Added, #6: 6	دَعْوَى النِّتَاجِ
u'دَعْوَى نَحْوٌ':Added, #1: 1	دَعْوَى النُّحَاسِ
u'دَعْوَى نخلة':Added, #1: 1	دَعْوَى نَحْوِ
u'دَعْوَى نَخْلَةٌ':Added, #1: 1	دَعْوَى النَّخْلَةِ
u'دَعْوَى نَسَبٌ':Added, #1: 1	دَعْوَى النَّخْلَةِ
u'دَعْوَى نَسَبٌ':Added, #1: 1	دَعْوَى نَسَبٍ
u'دَعْوَى نَسَبٌ':Added, #1: 1	دَعْوَى نَسَبِهِ
u'دَعْوَى نِسْيَانٌ':Added, #27: 27	دَعْوَى النَّسَبِ
u'دَعْوَى نِسْيَانٌ':Added, #2: 2	دَعْوَى نِسْيَانِ
u'دَعْوَى نصب':Added, #8: 8	دَعْوَى النِّسْيَانِ
u'دَعْوَى نَصْبٌ':Added, #1: 1	دَعْوَى النَّصْبِ
u'دَعْوَى نِصْفٌ':Added, #1: 1	دَعْوَى النَّصْبِ
u'دَعْوَى نَصِيبٌ':Added, #3: 3	دَعْوَى النِّصْفِ
u'دَعْوَى نقرة':Added, #1: 1	دَعْوَى نَصِيبٍ
u'دَعْوَى نقرة':Added, #1: 1	دَعْوَى النَّقْرَةِ
u'دَعْوَى نُقْرَةٌ':Added, #1: 1	دَعْوَى النُّقْرَةِ
u'دَعْوَى نَقْصٌ':Added, #1: 1	دَعْوَى النُّقْرَةِ
u'دَعْوَى نقلة':Added, #1: 1	دَعْوَى نَقْصِهِ
u'دَعْوَى نكاح':Added, #2: 2	دَعْوَى النَّقْلَةِ
u'دَعْوَى نِكَاحٌ':Added, #1: 1	دَعْوَى نِكَاحٍ
u'دَعْوَى نكاح':Added, #1: 1	دَعْوَى نِكَاحٍ
u'دَعْوَى نِكَاحٌ':Added, #34: 34	دَعْوَى النِّكَاحِ
u'دَعْوَى نكاح':Added, #34: 34	دَعْوَى النِّكَاحِ
u'دَعْوَى نِكَاحٌ':Added, #3: 3	دَعْوَى نِكَاحِ
u'دَعْوَى نَوْمٌ':Added, #3: 3	دَعْوَى نِكَاحِ
u'دَعْوَى نَوَوِيٌّ':Added, #3: 3	دَعْوَى النَّوْمِ
u'دَعْوَى نِيَّةٌ':Added, #1: 1	دَعْوَى النَّوَوِيِّ
u'دَعْوَى هِبَةٌ':Added, #1: 1	دَعْوَى نِيَّةِ
u'دَعْوَى هِبَةٌ':Added, #1: 1	دَعْوَى هِبَةِ
u'دَعْوَى هَزْلٌ':Added, #8: 8	دَعْوَى الْهِبَةِ
u'دَعْوَى هلاك':Added, #1: 1	دَعْوَى الْهَزْلِ
u'دَعْوَى هَلاَكٌ':Added, #2: 2	دَعْوَى الْهَلَاكِ
u'دَعْوَى واحد':Added, #2: 2	دَعْوَى الْهَلَاكِ
u'دَعْوَى وَاحِدٌ':Added, #1: 1	دَعْوَى الْوَاحِدِ
u'دَعْوَى واحد':Added, #1: 1	دَعْوَى الْوَاحِدِ
u'دَعْوَى وَاحِدٌ':Added, #1: 1	دَعْوَى الْوَاحِدَةِ
u'دَعْوَى وَارِثٌ':Added, #1: 1	دَعْوَى الْوَاحِدَةِ
u'دَعْوَى وَارِثٌ':Added, #1: 1	دَعْوَى الْوَارِثِ
u'دَعْوَى وَاهِبٌ':Added, #1: 1	دَعْوَى وَارِثِ
u'دَعْوَى وُجُوبٌ':Added, #1: 1	دَعْوَى الْوَاهِبِ
u'دَعْوَى وُجُودٌ':Added, #1: 1	دَعْوَى الْوُجُوبِ
u'دَعْوَى وَدِيعٌ':Added, #3: 3	دَعْوَى وُجُودِ
u'دَعْوَى وَدِيعَةٌ':Added, #6: 6	دَعْوَى الْوَدِيعَةِ
u'دَعْوَى وِرَاثَةٌ':Added, #6: 6	دَعْوَى الْوَدِيعَةِ
u'دَعْوَى وَرَثَةٌ':Added, #1: 1	دَعْوَى الْوِرَاثَةِ
u'دَعْوَى وَرَثَةٌ':Added, #1: 1	دَعْوَى وَرَثَةِ
u'دَعْوَى وَرَثَةٌ':Added, #1: 1	دَعْوَى وَرَثَتِهِ
u'دَعْوَى وُرُودٌ':Added, #2: 2	دَعْوَى الْوَرَثَةِ
u'دَعْوَى وِصَايَةٌ':Added, #1: 1	دَعْوَى وُرُودِ
u'دَعْوَى وَصِيٌّ':Added, #3: 3	دَعْوَى الْوِصَايَةِ
u'دَعْوَى وَصِيٌّ':Added, #1: 1	دَعْوَى وَصِيَّةٍ
u'دَعْوَى وَصِيٌّ':Added, #3: 3	دَعْوَى الْوَصِيِّ
u'دَعْوَى وَصِيَّةٌ':Added, #6: 6	دَعْوَى الْوَصِيَّةِ
u'دَعْوَى وَصِيَّةٌ':Added, #1: 1	دَعْوَى وَصِيَّةٍ
u'دَعْوَى وَقْفٌ':Added, #6: 6	دَعْوَى الْوَصِيَّةِ
u'دَعْوَى وَقْفٌ':Added, #10: 10	دَعْوَى الْوَقْفِ
u'دَعْوَى وَقْف':Added, #1: 1	دَعْوَى وَقْفِ
u'دَعْوَى وَقْف':Added, #1: 1	دَعْوَى وَقْفِيَّةِ
u'دَعْوَى وَقْفَة':Added, #4: 4	دَعْوَى الْوَقْفِيَّةِ
u'دَعْوَى وَقْفَة':Added, #1: 1	دَعْوَى وَقْفِيَّةِ
u'دَعْوَى وَقْفِيّ':Added, #4: 4	دَعْوَى الْوَقْفِيَّةِ
u'دَعْوَى وَقْفِيّ':Added, #1: 1	دَعْوَى وَقْفِيَّةِ
u'دَعْوَى وَقْفِيَّة':Added, #4: 4	دَعْوَى الْوَقْفِيَّةِ
u'دَعْوَى وَقْفِيَّة':Added, #1: 1	دَعْوَى وَقْفِيَّةِ
u'دَعْوَى وُقُوعٌ':Added, #4: 4	دَعْوَى الْوَقْفِيَّةِ
u'دَعْوَى وُقُوعٌ':Added, #1: 1	دَعْوَى الْوُقُوعِ
u'دَعْوَى وَكِيلٌ':Added, #1: 1	دَعْوَى وُقُوعِهِ
u'دَعْوَى وَلاَءٌ':Added, #9: 9	دَعْوَى الْوَكِيلِ
u'دَعْوَى وَلاَءٌ':Added, #1: 1	دَعْوَى الْوَلَاءِ
u'دَعْوَى ولد':Added, #2: 2	دَعْوَى وَلَاءِ
u'دَعْوَى وَلَدٌ':Added, #3: 3	دَعْوَى الْوَلَدِ
u'دَعْوَى وَلِيٌّ':Added, #3: 3	دَعْوَى الْوَلَدِ
u'دَعْوَى وَلِيٌّ':Added, #1: 1	دَعْوَى الْوَلِيِّ
u'دَعْوَى يسار':Added, #1: 1	دَعْوَى وَلِيِّ
u'دَعْوَى يَسَارٌ':Added, #1: 1	دَعْوَى الْيَسَارِ
u'دَعْوَى يهود':Added, #1: 1	دَعْوَى الْيَسَارِ
u'دَعْوَى يَهُودٌ':Added, #1: 1	دَعْوَى الْيَهُودِ
u'دفاع مَكْرُوهٌ':Added, #1: 1	دَعْوَى الْيَهُودِ
u'دِفَاعٌ مَكْرُوهٌ':Added, #1: 1	دِفَاعَ مَكْرُوهٍ
u'دَفَّ أهْلٌ':Subject, #1: 1	دِفَاعَ مَكْرُوهٍ
u'دَفَّ طَائِرٌ':Subject, #1: 1	دَفَّ أَهْلُ
u'دَفَعَ أَبٌ':Subject, #1: 1	دَفَّ الطَّائِرُ
u'دَفَعَ اِبْنٌ':Predicate, #1: 1	دَفَعَ الْأَبُ
u'دفع اِبْنٌ':Added, #2: 2	دَفَعَ ابْنَ
u'دفع اِبْنٌ':Added, #1: 1	دَفْعَ ابْنِ
u'دَفْعٌ اِبْنٌ':Added, #1: 1	دَفْعُ ابْنِ
u'دَفْعٌ اِبْنٌ':Added, #1: 1	دَفْعَ ابْنِ
u'دفع إِثْمٌ':Added, #1: 1	دَفْعُ ابْنِ
u'دَفْعٌ إِثْمٌ':Added, #1: 1	دَفْعُ الْإِثْمِ
u'دَفَعَ أَجْرٌ':Predicate, #1: 1	دَفْعُ الْإِثْمِ
u'دَفَعَ أُجْرَةٌ':Predicate, #3: 3	دَفَعَ الْأَجْرَ
u'دفع أُجْرَةٌ':Added, #3: 3	دَفَعَ الْأُجْرَةَ
u'دفع أُجْرَةٌ':Added, #1: 1	دَفْعُ أُجْرَةٍ
u'دفع أُجْرَةٌ':Added, #1: 1	دَفْعُ أُجْرَةِ
u'دَفْعٌ أُجْرَةٌ':Added, #1: 1	دَفْعِ أُجْرَةِ
u'دَفْعٌ أُجْرَةٌ':Added, #1: 1	دَفْعُ أُجْرَةٍ
u'دَفْعٌ أُجْرَةٌ':Added, #1: 1	دَفْعُ أُجْرَةِ
u'دفع أُجْرَةٌ':Added, #1: 1	دَفْعِ أُجْرَةِ
u'دفع أُجْرَةٌ':Added, #3: 3	دَفْعُ الْأُجْرَةِ
u'دَفْعٌ أُجْرَةٌ':Added, #3: 3	دَفْعِ الْأُجْرَةِ
u'دَفْعٌ أُجْرَةٌ':Added, #3: 3	دَفْعُ الْأُجْرَةِ
u'دَفَعَ أَجْنَبِيٌّ':Predicate, #3: 3	دَفْعِ الْأُجْرَةِ
u'دَفَعَ أَجْنَبِيٌّ':Subject, #4: 4	دَفَعَ أَجْنَبِيَّةً
u'دفع أَجْنَبِيٌّ':Added, #1: 1	دَفَعَ أَجْنَبِيٌّ
u'دَفْعٌ أَجْنَبِيٌّ':Added, #1: 1	دَفْعِ الْأَجْنَبِيِّ
u'دفع أُجُورٌ':Added, #1: 1	دَفْعِ الْأَجْنَبِيِّ
u'دَفْعٌ أُجُورٌ':Added, #1: 1	دَفْعُ الْأُجُورِ
u'دفع آحَادٌ':Added, #1: 1	دَفْعُ الْأُجُورِ
u'دَفْعٌ آحَادٌ':Added, #1: 1	دَفْعُ الْآحَادِ
u'دَفَعَ أحَدٌ':Subject, #1: 1	دَفْعُ الْآحَادِ
u'دَفَعَ أحَدٌ':Subject, #1: 1	دَفَعَ أَحَدٌ
u'دَفَعَ أَرَاضِي':Predicate, #3: 3	دَفَعَ أَحَدُ
u'دَفَعَ أرْضٌ':Predicate, #2: 2	دَفَعَ الْأَرَاضِيَ
u'دَفَعَ أرْضٌ':Predicate, #11: 11	دَفَعَ الْأَرْضَ
u'دفع أرْضٌ':Added, #3: 3	دَفَعَ أَرْضَ
u'دَفْعٌ أرْضٌ':Added, #1: 1	دَفْعَ الْأَرْضِ
u'دفع أرْضٌ':Added, #1: 1	دَفْعَ الْأَرْضِ
u'دَفْعٌ أرْضٌ':Added, #2: 2	دَفْعُ الْأَرْضِ
u'دفع اِسْتِحَالَةٌ':Added, #2: 2	دَفْعُ الْأَرْضِ
u'دَفْعٌ اِسْتِحَالَةٌ':Added, #1: 1	دَفْعُ اسْتِحَالَةِ
u'دفع اِسْتِحْقَاقٌ':Added, #1: 1	دَفْعُ اسْتِحَالَةِ
u'دَفْعٌ اِسْتِحْقَاقٌ':Added, #1: 1	دَفْعُ اسْتِحْقَاقِهِ
u'دفع اِسْتِحْقَاقٌ':Added, #1: 1	دَفْعُ اسْتِحْقَاقِهِ
u'دَفْعٌ اِسْتِحْقَاقٌ':Added, #2: 2	دَفْعِ اسْتِحْقَاقِ
u'دفع اِسْتِقْرارٌ':Added, #2: 2	دَفْعِ اسْتِحْقَاقِ
u'دَفْعٌ اِسْتِقْرارٌ':Added, #1: 1	دَفْعِ اسْتِقْرَارِ
u'دَفَعَ أَشْجَارٌ':Predicate, #1: 1	دَفْعِ اسْتِقْرَارِ
u'دفع أَشْجَارٌ':Added, #3: 3	دَفَعَ الْأَشْجَارَ
u'دَفْعٌ أَشْجَارٌ':Added, #1: 1	دَفْعُ الْأَشْجَارِ
u'دفع أَشْجَارٌ':Added, #1: 1	دَفْعُ الْأَشْجَارِ
u'دَفْعٌ أَشْجَارٌ':Added, #3: 3	دَفْعِ الْأَشْجَارِ
u'دَفَعَ إِشْكالٌ':Predicate, #3: 3	دَفْعِ الْأَشْجَارِ
u'دفع إِشْكالٌ':Added, #2: 2	دَفَعَ الْإِشْكَالَ
u'دَفْعٌ إِشْكالٌ':Added, #1: 1	دَفْعِ الْإِشْكَالِ
u'دفع إِشْكالٌ':Added, #1: 1	دَفْعِ الْإِشْكَالِ
u'دَفْعٌ إِشْكالٌ':Added, #2: 2	دَفْعُ الْإِشْكَالِ
u'دفع أَصْحَابٌ':Added, #2: 2	دَفْعُ الْإِشْكَالِ
u'دَفْعٌ أَصْحَابٌ':Added, #1: 1	دَفْعَ أَصْحَابِهِ
u'دفع أصل':Added, #1: 1	دَفْعَ أَصْحَابِهِ
u'دفع أصل':Added, #1: 1	دَفْعَ أَصْلِ
u'دفع أًصْلٌ':Added, #1: 1	دَفْعُ أَصْلِ
u'دفع أًصْلٌ':Added, #1: 1	دَفْعَ أَصْلِ
u'دَفْعٌ أصل':Added, #1: 1	دَفْعُ أَصْلِ
u'دَفْعٌ أصل':Added, #1: 1	دَفْعَ أَصْلِ
u'دَفْعٌ أًصْلٌ':Added, #1: 1	دَفْعُ أَصْلِ
u'دَفْعٌ أًصْلٌ':Added, #1: 1	دَفْعَ أَصْلِ
u'دفع أعْشَارٌ':Added, #1: 1	دَفْعُ أَصْلِ
u'دفع أَعْشَارٌ':Added, #1: 1	دَفْعُ الْأَعْشَارِ
u'دَفْعٌ أعْشَارٌ':Added, #1: 1	دَفْعُ الْأَعْشَارِ
u'دَفْعٌ أَعْشَارٌ':Added, #1: 1	دَفْعُ الْأَعْشَارِ
u'دفع أعْظَمُ':Added, #1: 1	دَفْعُ الْأَعْشَارِ
u'دَفْعٌ أعْظَمُ':Added, #1: 1	دَفْعِ أَعْظَمِ
u'دفع أقَلُّ':Added, #1: 1	دَفْعِ أَعْظَمِ
u'دَفْعٌ أقَلُّ':Added, #1: 1	دَفْعِ أَقَلِّهِ
u'دَفَعَ أَكْثَرُ':Predicate, #1: 1	دَفْعِ أَقَلِّهِ
u'دفع إكْرَاهٌ':Added, #2: 2	دَفَعَ أَكْثَرَ
u'دَفْعٌ إكْرَاهٌ':Added, #2: 2	دَفْعِ الْإِكْرَاهِ
u'دفع إِلْزَامٌ':Added, #2: 2	دَفْعِ الْإِكْرَاهِ
u'دَفْعٌ إِلْزَامٌ':Added, #1: 1	دَفْعَ إلْزَامِ
u'دفع أَلْسِنَةٌ':Added, #1: 1	دَفْعَ إلْزَامِ
u'دَفْعٌ أَلْسِنَةٌ':Added, #1: 1	دَفْعَ أَلْسِنَةِ
u'دَفَعَ ألف':Predicate, #1: 1	دَفْعَ أَلْسِنَةِ
u'دَفَعَ ألْفٌ':Predicate, #3: 3	دَفَعَ أَلْفَ
u'دَفَعَ أَلْفٌ':Predicate, #3: 3	دَفَعَ أَلْفَ
u'دَفَعَ ألف':Predicate, #3: 3	دَفَعَ أَلْفَ
u'دَفَعَ ألْفٌ':Predicate, #4: 4	دَفَعَ الْأَلْفَ
u'دَفَعَ أَلْفٌ':Predicate, #4: 4	دَفَعَ الْأَلْفَ
u'دفع ألف':Added, #4: 4	دَفَعَ الْأَلْفَ
u'دفع ألْفٌ':Added, #1: 1	دَفْعِ الْأَلْفِ
u'دفع أَلْفٌ':Added, #1: 1	دَفْعِ الْأَلْفِ
u'دَفْعٌ ألف':Added, #1: 1	دَفْعِ الْأَلْفِ
u'دَفْعٌ ألْفٌ':Added, #1: 1	دَفْعِ الْأَلْفِ
u'دَفْعٌ أَلْفٌ':Added, #1: 1	دَفْعِ الْأَلْفِ
u'دفع الْمَرْأَةُ':Added, #1: 1	دَفْعِ الْأَلْفِ
u'دفع الْمَرْأَةُ':Added, #1: 1	دَفْعَ الْمَرْأَةِ
u'دفع الْمَرْأَةُ':Added, #1: 1	دَفْعُ الْمَرْأَةِ
u'دَفْعٌ الْمَرْأَةُ':Added, #1: 1	دَفْعِ الْمَرْأَةِ
u'دَفْعٌ الْمَرْأَةُ':Added, #1: 1	دَفْعَ الْمَرْأَةِ
u'دَفْعٌ الْمَرْأَةُ':Added, #1: 1	دَفْعُ الْمَرْأَةِ
u'دَفَعَ أُمٌّ':Predicate, #1: 1	دَفْعِ الْمَرْأَةِ
u'دفع أُمٌّ':Added, #3: 3	دَفَعَ الْأُمَّ
u'دَفْعٌ أُمٌّ':Added, #1: 1	دَفْعَ الْأُمِّ
u'دَفَعَ إمَامٌ':Subject, #1: 1	دَفْعَ الْأُمِّ
u'دفع إمَامٌ':Added, #6: 6	دَفَعَ الْإِمَامُ
u'دَفْعٌ إمَامٌ':Added, #2: 2	دَفْعِ الْإِمَامِ
u'دَفَعَ أمَانَةٌ':Predicate, #2: 2	دَفْعِ الْإِمَامِ
u'دَفَعَ أمَةٌ':Predicate, #2: 2	دَفَعَ الْأَمَانَةَ
u'دفع أمَةٌ':Added, #1: 1	دَفَعَ الْأَمَةَ
u'دَفْعٌ أمَةٌ':Added, #1: 1	دَفْعَ الْأَمَةِ
u'دَفَعَ آمِرٌ':Subject, #1: 1	دَفْعَ الْأَمَةِ
u'دَفَعَ اِمْرَأَةٌ':Predicate, #3: 3	دَفَعَ الْآمِرُ
u'دفع إِنْسانٌ':Added, #2: 2	دَفَعَ امْرَأَةَ
u'دفع إِنْسانٌ':Added, #1: 1	دَفْعُ الْإِنْسَانِ
u'دَفْعٌ إِنْسانٌ':Added, #1: 1	دَفْعِ الْإِنْسَانِ
u'دَفْعٌ إِنْسانٌ':Added, #1: 1	دَفْعُ الْإِنْسَانِ
u'دفع أهْلٌ':Added, #1: 1	دَفْعِ الْإِنْسَانِ
u'دَفْعٌ أهْلٌ':Added, #2: 2	دَفْعُ أَهْلِ
u'دفع أَوَّلُ':Added, #2: 2	دَفْعُ أَهْلِ
u'دَفْعٌ أَوَّلُ':Added, #2: 2	دَفْعِ الْأَوَّلِ
u'دفع أَوْلاَدٌ':Added, #2: 2	دَفْعِ الْأَوَّلِ
u'دَفْعٌ أَوْلاَدٌ':Added, #1: 1	دَفْعِ الْأَوْلَادِ
u'دفع إِيجَابٌ':Added, #1: 1	دَفْعِ الْأَوْلَادِ
u'دَفْعٌ إِيجَابٌ':Added, #1: 1	دَفْعِ إيجَابِهِ
u'دَفَعَ إيرَادٌ':Predicate, #1: 1	دَفْعِ إيجَابِهِ
u'دفع إيرَادٌ':Added, #1: 1	دَفَعَ الْإِيرَادَ
u'دَفْعٌ إيرَادٌ':Added, #1: 1	دَفْعِ الْإِيرَادِ
u'دفع إيرَادٌ':Added, #1: 1	دَفْعِ الْإِيرَادِ
u'دَفْعٌ إيرَادٌ':Added, #1: 1	دَفْعِ إيرَادِ
u'دفع إِيهَامٌ':Added, #1: 1	دَفْعِ إيرَادِ
u'دَفْعٌ إِيهَامٌ':Added, #2: 2	دَفْعُ إيهَامِ
u'دفع بَاطن':Added, #2: 2	دَفْعُ إيهَامِ
u'دفع باطِنٌ':Added, #1: 1	دَفْعُ الْبَاطِنِ
u'دَفْعٌ بَاطن':Added, #1: 1	دَفْعُ الْبَاطِنِ
u'دَفْعٌ باطِنٌ':Added, #1: 1	دَفْعُ الْبَاطِنِ
u'دفع باطِنٌ':Added, #1: 1	دَفْعُ الْبَاطِنِ
u'دَفْعٌ باطِنٌ':Added, #1: 1	دَفْعُ الْبَاطِنَةِ
u'دَفَعَ بَائِعٌ':Subject, #1: 1	دَفْعُ الْبَاطِنَةِ
u'دفع بِدَعٌ':Added, #3: 3	دَفَعَ الْبَائِعُ
u'دَفْعٌ بِدَعٌ':Added, #1: 1	دَفْعَ الْبِدَعِ
u'دفع بَدَلٌ':Added, #1: 1	دَفْعَ الْبِدَعِ
u'دفع بَدَلٌ':Added, #1: 1	دَفْعُ الْبَدَلِ
u'دَفْعٌ بَدَلٌ':Added, #1: 1	دَفْعِ الْبَدَلِ
u'دَفْعٌ بَدَلٌ':Added, #1: 1	دَفْعُ الْبَدَلِ
u'دفع بَدَلٌ':Added, #1: 1	دَفْعِ الْبَدَلِ
u'دَفْعٌ بَدَلٌ':Added, #2: 2	دَفْعُ بَدَلِهِ
u'دَفَعَ بَذْرٌ':Predicate, #2: 2	دَفْعُ بَدَلِهِ
u'دَفَعَ بَذْرٌ':Predicate, #1: 1	دَفَعَ بَذْرَ
u'دَفَعَ بَراءةٌ':Predicate, #4: 4	دَفَعَ الْبَذْرَ
u'دفع بَرْدٌ':Added, #1: 1	دَفَعَ الْبَرَاءَةَ
u'دَفْعٌ بَرْدٌ':Added, #2: 2	دَفْعَ الْبَرْدِ
u'دَفَعَ بَطَلٌ':Predicate, #2: 2	دَفْعَ الْبَرْدِ
u'دَفَعَ بَعْضٌ':Predicate, #2: 2	دَفَعَ بَطَلَ
u'دَفَعَ بَعْضٌ':Predicate, #1: 1	دَفَعَ بَعْضَ
u'دَفَعَ بَعْضٌ':Subject, #2: 2	دَفَعَ الْبَعْضَ
u'دفع بَعْضٌ':Added, #1: 1	دَفَعَ الْبَعْضُ
u'دَفْعٌ بَعْضٌ':Added, #1: 1	دَفْعُ بَعْضِ
u'دَفَعَ بَقَرٌ':Predicate, #1: 1	دَفْعُ بَعْضِ
u'دَفَعَ بَقَرٌ':Predicate, #2: 2	دَفَعَ الْبَقَرَةَ
u'دفع بَقِيَّةٌ':Added, #2: 2	دَفَعَ بَقَرَةً
u'دَفْعٌ بَقِيَّةٌ':Added, #1: 1	دَفْعِ بَقِيَّةِ
u'دفع بَلاءٌ':Added, #1: 1	دَفْعِ بَقِيَّةِ
u'دَفْعٌ بَلاءٌ':Added, #1: 1	دَفْعِ الْبَلَاءِ
u'دَفَعَ بِنَاءٌ':Predicate, #1: 1	دَفْعِ الْبَلَاءِ
u'دَفَعَ بِنْتٌ':Predicate, #1: 1	دَفَعَ بِنَاءَ
u'دَفَعَ بِنْتٌ':Predicate, #1: 1	دَفَعَ الْبِنْتَ
u'دفع بِنْتٌ':Added, #1: 1	دَفَعَ بِنْتَ
u'دَفْعٌ بِنْتٌ':Added, #1: 1	دَفْعَ الْبِنْتِ
u'دفع بِنْتٌ':Added, #1: 1	دَفْعَ الْبِنْتِ
u'دَفْعٌ بِنْتٌ':Added, #1: 1	دَفْعَ بِنْتِ
u'دفع بَهيمٌ':Added, #1: 1	دَفْعَ بِنْتِ
u'دَفْعٌ بَهيمٌ':Added, #1: 1	دَفْعِ الْبَهِيمَةِ
u'دفع بَهِيمَةٌ':Added, #1: 1	دَفْعِ الْبَهِيمَةِ
u'دَفْعٌ بَهِيمَةٌ':Added, #1: 1	دَفْعِ الْبَهِيمَةِ
u'دَفَعَ بَيَاضٌ':Predicate, #1: 1	دَفْعِ الْبَهِيمَةِ
u'دَفَعَ بِيَعٌ':Predicate, #1: 1	دَفَعَ الْبَيَاضَ
u'دفع بَيِّنَةٌ':Added, #1: 1	دَفَعَ بِيعَ
u'دفع بَيِّنَةٌ':Added, #1: 1	دَفْعَ بَيِّنَةِ
u'دَفْعٌ بَيِّنَةٌ':Added, #1: 1	دَفْعِ بَيِّنَةِ
u'دَفْعٌ بَيِّنَةٌ':Added, #1: 1	دَفْعَ بَيِّنَةِ
u'دفع بَيِّنَةٌ':Added, #1: 1	دَفْعِ بَيِّنَةِ
u'دَفْعٌ بَيِّنَةٌ':Added, #1: 1	دَفْعِ بَيِّنَتِهِ
u'دفعة ثَالِثٌ':Added, #1: 1	دَفْعِ بَيِّنَتِهِ
u'دَفْعَةٌ ثَالِثٌ':Added, #1: 1	دَفْعَةِ الثَّالِثِ
u'دفعة نَاسٌ':Added, #1: 1	دَفْعَةِ الثَّالِثِ
u'دَفْعَةٌ نَاسٌ':Added, #2: 2	دَفْعَةِ النَّاسِ
u'دفعة واحد':Added, #2: 2	دَفْعَةِ النَّاسِ
u'دفعة وَاحِدٌ':Added, #3: 3	دَفْعَةٍ وَاحِدَةٍ
u'دَفْعَةٌ واحد':Added, #3: 3	دَفْعَةٍ وَاحِدَةٍ
u'دَفْعَةٌ وَاحِدٌ':Added, #3: 3	دَفْعَةٍ وَاحِدَةٍ
u'دفع تَثَاؤُبٌ':Added, #3: 3	دَفْعَةٍ وَاحِدَةٍ
u'دَفْعٌ تَثَاؤُبٌ':Added, #1: 1	دَفْعِ التَّثَاؤُبِ
u'دفع تُرَابٌ':Added, #1: 1	دَفْعِ التَّثَاؤُبِ
u'دَفْعٌ تُرَابٌ':Added, #1: 1	دَفْعِ التُّرَابِ
u'دفع تَرْجِيحٌ':Added, #1: 1	دَفْعِ التُّرَابِ
u'دَفْعٌ تَرْجِيحٌ':Added, #1: 1	دَفْعِ تَرْجِيحِ
u'دفع تَرَدُّدٌ':Added, #1: 1	دَفْعِ تَرْجِيحِ
u'دفع تَرَدُّدٌ':Added, #1: 1	دَفْعُ التَّرَدُّدِ
u'دَفْعٌ تَرَدُّدٌ':Added, #1: 1	دَفْعِ التَّرَدُّدِ
u'دَفْعٌ تَرَدُّدٌ':Added, #1: 1	دَفْعُ التَّرَدُّدِ
u'دفع تَسَلُّطٌ':Added, #1: 1	دَفْعِ التَّرَدُّدِ
u'دفع تَسَلُّطٌ':Added, #1: 1	دَفْعُ تَسَلُّطِ
u'دَفْعٌ تَسَلُّطٌ':Added, #1: 1	دَفْعِ تَسَلُّطِ
u'دَفْعٌ تَسَلُّطٌ':Added, #1: 1	دَفْعُ تَسَلُّطِ
u'دفع تَسْلِيطٌ':Added, #1: 1	دَفْعِ تَسَلُّطِ
u'دَفْعٌ تَسْلِيطٌ':Added, #1: 1	دَفْعِ تَسْلِيطِ
u'دفع تَصَرُّفٌ':Added, #1: 1	دَفْعِ تَسْلِيطِ
u'دَفْعٌ تَصَرُّفٌ':Added, #1: 1	دَفْعِ تَصَرُّفِ
u'دفع تَطَوُّعٌ':Added, #1: 1	دَفْعِ تَصَرُّفِ
u'دَفْعٌ تَطَوُّعٌ':Added, #1: 1	دَفْعُ التَّطَوُّعَاتِ
u'دَفَعَ تَعَارُضٌ':Predicate, #1: 1	دَفْعُ التَّطَوُّعَاتِ
u'دفع تَعْزِير':Added, #1: 1	دَفَعَ التَّعَارُضَ
u'دَفْعٌ تَعْزِير':Added, #1: 1	دَفْعِ التَّعْزِيرِ
u'دفع تَعَمُّدٌ':Added, #1: 1	دَفْعِ التَّعْزِيرِ
u'دَفْعٌ تَعَمُّدٌ':Added, #1: 1	دَفْعِ تَعَمُّدِ
u'دفع تَعَنُّت':Added, #1: 1	دَفْعِ تَعَمُّدِ
u'دَفْعٌ تَعَنُّت':Added, #1: 1	دَفْعَ التَّعَنُّتِ
u'دفع تَلَف':Added, #1: 1	دَفْعَ التَّعَنُّتِ
u'دَفْعٌ تَلَف':Added, #1: 1	دَفْعَ التَّلَفِ
u'دَفَعَ تَنَاقُضٌ':Predicate, #1: 1	دَفْعَ التَّلَفِ
u'دفع تَنَاقُضٌ':Added, #1: 1	دَفَعَ التَّنَاقُضَ
u'دَفْعٌ تَنَاقُضٌ':Added, #1: 1	دَفْعِ التَّنَاقُضِ
u'دفع تَنَاقُضٌ':Added, #1: 1	دَفْعِ التَّنَاقُضِ
u'دَفْعٌ تَنَاقُضٌ':Added, #2: 2	دَفْعُ التَّنَاقُضِ
u'دفع تَوَهُّمٌ':Added, #2: 2	دَفْعُ التَّنَاقُضِ
u'دَفْعٌ تَوَهُّمٌ':Added, #1: 1	دَفْعَ تَوَهُّمِ
u'دفع تَوَهُّمٌ':Added, #1: 1	دَفْعَ تَوَهُّمِ
u'دَفْعٌ تَوَهُّمٌ':Added, #2: 2	دَفْعِ تَوَهُّمِ
u'دفع تَوَهُّمٌ':Added, #2: 2	دَفْعِ تَوَهُّمِ
u'دَفْعٌ تَوَهُّمٌ':Added, #4: 4	دَفْعُ تَوَهُّمِ
u'دفع ثَلاثُ':Added, #4: 4	دَفْعُ تَوَهُّمِ
u'دَفْعٌ ثَلاثُ':Added, #1: 1	دَفْعَ الثَّلَاثِ
u'دَفَعَ ثَمَنٌ':Predicate, #1: 1	دَفْعَ الثَّلَاثِ
u'دفع ثَمَنٌ':Added, #24: 24	دَفَعَ الثَّمَنَ
u'دَفْعٌ ثَمَنٌ':Added, #13: 13	دَفْعَ الثَّمَنِ
u'دفع ثَمَنٌ':Added, #13: 13	دَفْعَ الثَّمَنِ
u'دَفْعٌ ثَمَنٌ':Added, #1: 1	دَفْعِ ثَمَنٍ
u'دفع ثَمَنٌ':Added, #1: 1	دَفْعِ ثَمَنٍ
u'دَفْعٌ ثَمَنٌ':Added, #1: 1	دَفْعِ ثَمَنِهِ
u'دفع ثَمَنٌ':Added, #1: 1	دَفْعِ ثَمَنِهِ
u'دَفْعٌ ثَمَنٌ':Added, #48: 48	دَفْعِ الثَّمَنِ
u'دفع ثَمَنٌ':Added, #48: 48	دَفْعِ الثَّمَنِ
u'دَفْعٌ ثَمَنٌ':Added, #5: 5	دَفْعُ الثَّمَنِ
u'دَفَعَ ثَوْبٌ':Predicate, #5: 5	دَفْعُ الثَّمَنِ
u'دفع ثَوْبٌ':Added, #10: 10	دَفَعَ الثَّوْبَ
u'دَفْعٌ ثَوْبٌ':Added, #1: 1	دَفْعَ الثَّوْبِ
u'دفع ثَوْبٌ':Added, #1: 1	دَفْعَ الثَّوْبِ
u'دَفْعٌ ثَوْبٌ':Added, #1: 1	دَفْعِ ثَوْبٍ
u'دفع ثَوْبٌ':Added, #1: 1	دَفْعِ ثَوْبٍ
u'دَفْعٌ ثَوْبٌ':Added, #1: 1	دَفْعَ ثَوْبِهِ
u'دفع ثَوْبٌ':Added, #1: 1	دَفْعَ ثَوْبِهِ
u'دَفْعٌ ثَوْبٌ':Added, #3: 3	دَفْعِ الثَّوْبِ
u'دَفَعَ جَارِي':Predicate, #3: 3	دَفْعِ الثَّوْبِ
u'دَفَعَ جَازٌ':Predicate, #1: 1	دَفَعَ جَارِيَةً
u'دفع جُثَّة':Added, #2: 2	دَفَعَ جَازَ
u'دَفْعٌ جُثَّة':Added, #2: 2	دَفْعَ الْجُثَّةِ
u'دَفَعَ جَرَّةٌ':Predicate, #2: 2	دَفْعَ الْجُثَّةِ
u'دفع جِزْيَةٌ':Added, #1: 1	دَفَعَ الْجَرَّةَ
u'دَفْعٌ جِزْيَةٌ':Added, #1: 1	دَفْعَ جِزْيَتِهِ
u'دفع جَفَاءٌ':Added, #1: 1	دَفْعَ جِزْيَتِهِ
u'دَفْعٌ جَفَاءٌ':Added, #1: 1	دَفْعُ الْجَفَاءِ
u'دَفَعَ جلد':Predicate, #1: 1	دَفْعُ الْجَفَاءِ
u'دَفَعَ جِلْدٌ':Predicate, #1: 1	دَفَعَ الْجِلْدَ
u'دَفَعَ جَمِيع':Predicate, #1: 1	دَفَعَ الْجِلْدَ
u'دفع جَمِيع':Added, #1: 1	دَفَعَ الْجَمِيعَ
u'دَفْعٌ جَمِيع':Added, #1: 1	دَفْعَ الْجَمِيعِ
u'دفع جَهْدٌ':Added, #1: 1	دَفْعَ الْجَمِيعِ
u'دَفْعٌ جَهْدٌ':Added, #1: 1	دَفْعُ الْجَهْدِ
u'دَفَعَ جَوَاهِرُ':Predicate, #1: 1	دَفْعُ الْجَهْدِ
u'دفع جُوعٌ':Added, #1: 1	دَفَعَ جَوَاهِرَ
u'دَفْعٌ جُوعٌ':Added, #3: 3	دَفْعَ الْجُوعِ
u'دفع حاجَةٌ':Added, #3: 3	دَفْعَ الْجُوعِ
u'دَفْعٌ حاجَةٌ':Added, #1: 1	دَفْعَ حَاجَةِ
u'دفع حاجَةٌ':Added, #1: 1	دَفْعَ حَاجَةِ
u'دفع حاجَةٌ':Added, #1: 1	دَفْعُ حَاجَتِهِ
u'دَفْعٌ حاجَةٌ':Added, #1: 1	دَفْعِ حَاجَتِهِ
u'دَفْعٌ حاجَةٌ':Added, #1: 1	دَفْعُ حَاجَتِهِ
u'دفع حاجَةٌ':Added, #1: 1	دَفْعِ حَاجَتِهِ
u'دَفْعٌ حاجَةٌ':Added, #22: 22	دَفْعُ الْحَاجَةِ
u'دفع حاجَةٌ':Added, #22: 22	دَفْعُ الْحَاجَةِ
u'دَفْعٌ حاجَةٌ':Added, #2: 2	دَفْعَ الْحَاجَةِ
u'دفع حاجَةٌ':Added, #2: 2	دَفْعَ الْحَاجَةِ
u'دَفْعٌ حاجَةٌ':Added, #2: 2	دَفْعِ حَاجَةِ
u'دفع حاجَةٌ':Added, #2: 2	دَفْعِ حَاجَةِ
u'دَفْعٌ حاجَةٌ':Added, #6: 6	دَفْعِ الْحَاجَةِ
u'دفع حاجَةٌ':Added, #6: 6	دَفْعِ الْحَاجَةِ
u'دَفْعٌ حاجَةٌ':Added, #6: 6	دَفْعُ حَاجَةِ
u'دَفَعَ حاضِرٌ':Subject, #6: 6	دَفْعُ حَاجَةِ
u'دَفَعَ حاكِمٌ':Subject, #2: 2	دَفَعَ الْحَاضِرُ
u'دفع حائِطٌ':Added, #1: 1	دَفَعَ الْحَاكِمُ
u'دَفْعٌ حائِطٌ':Added, #1: 1	دَفْعُ حَائِطِ
u'دفع حُبٌّ':Added, #1: 1	دَفْعُ حَائِطِ
u'دَفْعٌ حُبٌّ':Added, #2: 2	دَفْعِ حُبِّ
u'دفع حُتوفٌ':Added, #2: 2	دَفْعِ حُبِّ
u'دَفْعٌ حُتوفٌ':Added, #1: 1	دَفْعَ الْحُتُوفِ
u'دفع حُجَّةٌ':Added, #1: 1	دَفْعَ الْحُتُوفِ
u'دَفْعٌ حُجَّةٌ':Added, #1: 1	دَفْعُ الْحُجَّةِ
u'دفع حُجَّةٌ':Added, #1: 1	دَفْعُ الْحُجَّةِ
u'دَفْعٌ حُجَّةٌ':Added, #1: 1	دَفْعِ حُجَّةِ
u'دفع حَدٌّ':Added, #1: 1	دَفْعِ حُجَّةِ
u'دَفْعٌ حَدٌّ':Added, #1: 1	دَفْعِ الْحَدِّ
u'دفع حَرٌّ':Added, #1: 1	دَفْعِ الْحَدِّ
u'دَفْعٌ حَرٌّ':Added, #1: 1	دَفْعَ الْحَرِّ
u'دفع حَرٌّ':Added, #1: 1	دَفْعَ الْحَرِّ
u'دفع حَرٌّ':Added, #2: 2	دَفْعُ الْحَرِّ
u'دَفْعٌ حَرٌّ':Added, #2: 2	دَفْعِ الْحَرِّ
u'دَفْعٌ حَرٌّ':Added, #2: 2	دَفْعُ الْحَرِّ
u'دفع حَرَجٌ':Added, #2: 2	دَفْعِ الْحَرِّ
u'دفع حَرَجٌ':Added, #1: 1	دَفْعَ الْحَرَجِ
u'دَفْعٌ حَرَجٌ':Added, #1: 1	دَفْعُ الْحَرَجِ
u'دَفْعٌ حَرَجٌ':Added, #1: 1	دَفْعَ الْحَرَجِ
u'دفع حِرْمَانٌ':Added, #1: 1	دَفْعُ الْحَرَجِ
u'دَفْعٌ حِرْمَانٌ':Added, #2: 2	دَفْعِ الْحِرْمَانِ
u'دفع حُرْمَةٌ':Added, #2: 2	دَفْعِ الْحِرْمَانِ
u'دَفْعٌ حُرْمَةٌ':Added, #1: 1	دَفْعَ الْحُرْمَةِ
u'دفع حَرِيرٌ':Added, #1: 1	دَفْعَ الْحُرْمَةِ
u'دَفْعٌ حَرِيرٌ':Added, #1: 1	دَفْعُ الْحَرِيرِ
u'دفع حَصْرٌ':Added, #1: 1	دَفْعُ الْحَرِيرِ
u'دَفْعٌ حَصْرٌ':Added, #1: 1	دَفْعُ حَصْرِ
u'دَفَعَ حَقٌّ':Predicate, #1: 1	دَفْعُ حَصْرِ
u'دَفَعَ حَقٌّ':Predicate, #1: 1	دَفَعَ حَقَّ
u'دفع حَقٌّ':Added, #3: 3	دَفَعَ الْحَقَّ
u'دفع حَقٌّ':Added, #1: 1	دَفْعُ الْحَقِّ
u'دَفْعٌ حَقٌّ':Added, #1: 1	دَفْعِ الْحَقِّ
u'دَفْعٌ حَقٌّ':Added, #1: 1	دَفْعُ الْحَقِّ
u'دفع حَقٌّ':Added, #1: 1	دَفْعِ الْحَقِّ
u'دَفْعٌ حَقٌّ':Added, #1: 1	دَفْعِ حَقٍّ
u'دفع حُقوقٌ':Added, #1: 1	دَفْعِ حَقٍّ
u'دفع حُقُوقٌ':Added, #2: 2	دَفْعِ الْحُقُوقِ
u'دَفْعٌ حُقوقٌ':Added, #2: 2	دَفْعِ الْحُقُوقِ
u'دَفْعٌ حُقُوقٌ':Added, #2: 2	دَفْعِ الْحُقُوقِ
u'دفع حُكْمٌ':Added, #2: 2	دَفْعِ الْحُقُوقِ
u'دفع حُكْمٌ':Added, #1: 1	دَفْعَ الْحُكْمِ
u'دَفْعٌ حُكْمٌ':Added, #1: 1	دَفْعُ الْحُكْمِ
u'دَفْعٌ حُكْمٌ':Added, #1: 1	دَفْعَ الْحُكْمِ
u'دفع حُكْمٌ':Added, #1: 1	دَفْعُ الْحُكْمِ
u'دَفْعٌ حُكْمٌ':Added, #1: 1	دَفْعِ حُكْمِ
u'دَفَعَ حِنْطَةٌ':Predicate, #1: 1	دَفْعِ حُكْمِ
u'دفع حِنْطَةٌ':Added, #1: 1	دَفَعَ الْحِنْطَةَ
u'دفع حِنْطَةٌ':Added, #1: 1	دَفْعَ الْحِنْطَةِ
u'دَفْعٌ حِنْطَةٌ':Added, #1: 1	دَفْعِ الْحِنْطَةِ
u'دَفْعٌ حِنْطَةٌ':Added, #1: 1	دَفْعَ الْحِنْطَةِ
u'دفع حَوائِجُ':Added, #1: 1	دَفْعِ الْحِنْطَةِ
u'دَفْعٌ حَوائِجُ':Added, #2: 2	دَفْعِ الْحَوَائِجِ
u'دفع خراج':Added, #2: 2	دَفْعِ الْحَوَائِجِ
u'دَفْعٌ خراج':Added, #1: 1	دَفْعِ الْخَرَاجِ
u'دفع خَرَاجٌ':Added, #1: 1	دَفْعِ الْخَرَاجِ
u'دَفْعٌ خَرَاجٌ':Added, #1: 1	دَفْعِ الْخَرَاجِ
u'دفع خراج':Added, #1: 1	دَفْعِ الْخَرَاجِ
u'دَفْعٌ خراج':Added, #1: 1	دَفْعَ خَرَاجٍ
u'دفع خَرَاجٌ':Added, #1: 1	دَفْعَ خَرَاجٍ
u'دَفْعٌ خَرَاجٌ':Added, #1: 1	دَفْعَ خَرَاجٍ
u'دفع خراج':Added, #1: 1	دَفْعَ خَرَاجٍ
u'دَفْعٌ خراج':Added, #1: 1	دَفْعَ خَرَاجِهِ
u'دفع خَرَاجٌ':Added, #1: 1	دَفْعَ خَرَاجِهِ
u'دَفْعٌ خَرَاجٌ':Added, #1: 1	دَفْعَ خَرَاجِهِ
u'دفع خراج':Added, #1: 1	دَفْعَ خَرَاجِهِ
u'دَفْعٌ خراج':Added, #2: 2	دَفْعَ الْخَرَاجِ
u'دفع خَرَاجٌ':Added, #2: 2	دَفْعَ الْخَرَاجِ
u'دَفْعٌ خَرَاجٌ':Added, #2: 2	دَفْعَ الْخَرَاجِ
u'دفع خراج':Added, #2: 2	دَفْعَ الْخَرَاجِ
u'دَفْعٌ خراج':Added, #2: 2	دَفْعِ خَرَاجٍ
u'دفع خَرَاجٌ':Added, #2: 2	دَفْعِ خَرَاجٍ
u'دَفْعٌ خَرَاجٌ':Added, #2: 2	دَفْعِ خَرَاجٍ
u'دفع خسار':Added, #2: 2	دَفْعِ خَرَاجٍ
u'دَفْعٌ خسار':Added, #1: 1	دَفْعِ الْخَسَارِ
u'دفع خَصْمٌ':Added, #1: 1	دَفْعِ الْخَسَارِ
u'دَفْعٌ خَصْمٌ':Added, #1: 1	دَفْعَ الْخَصْمِ
u'دفع خُصُومَةٌ':Added, #1: 1	دَفْعَ الْخَصْمِ
u'دفع خُصُومَةٌ':Added, #2: 2	دَفْعَ الْخُصُومَةِ
u'دَفْعٌ خُصُومَةٌ':Added, #2: 2	دَفْعِ الْخُصُومَةِ
u'دَفْعٌ خُصُومَةٌ':Added, #2: 2	دَفْعَ الْخُصُومَةِ
u'دفع خطر':Added, #2: 2	دَفْعِ الْخُصُومَةِ
u'دَفْعٌ خطر':Added, #1: 1	دَفْعِ الْخَطَرِ
u'دفع خَطَرٌ':Added, #1: 1	دَفْعِ الْخَطَرِ
u'دَفْعٌ خَطَرٌ':Added, #1: 1	دَفْعِ الْخَطَرِ
u'دفع خطر':Added, #1: 1	دَفْعِ الْخَطَرِ
u'دَفْعٌ خطر':Added, #1: 1	دَفْعِ خَطَرِ
u'دفع خَطَرٌ':Added, #1: 1	دَفْعِ خَطَرِ
u'دَفْعٌ خَطَرٌ':Added, #1: 1	دَفْعِ خَطَرِ
u'دفع خَفَاءٌ':Added, #1: 1	دَفْعِ خَطَرِ
u'دَفْعٌ خَفَاءٌ':Added, #1: 1	دَفْعِ خَفَاءِ
u'دَفَعَ خَلِيطٌ':Subject, #1: 1	دَفْعِ خَفَاءِ
u'دَفَعَ خَمْرٌ':Predicate, #1: 1	دَفَعَ الْخَلِيطُ
u'دَفَعَ خُمْسٌ':Predicate, #1: 1	دَفَعَ الْخَمْرَ
u'دَفَعَ خُمُسٌ':Predicate, #1: 1	دَفَعَ الْخُمْسَ
u'دفع خُمُسٌ':Added, #2: 2	دَفَعَ الْخُمُسَ
u'دَفْعٌ خُمُسٌ':Added, #1: 1	دَفْعِ الْخُمُسِ
u'دفع خُمُسٌ':Added, #1: 1	دَفْعِ الْخُمُسِ
u'دَفْعٌ خُمُسٌ':Added, #1: 1	دَفْعِ خُمُسِ
u'دفع خُمُسٌ':Added, #1: 1	دَفْعِ خُمُسِ
u'دَفْعٌ خُمُسٌ':Added, #2: 2	دَفْعُ الْخُمُسِ
u'دفع خُمُسٌ':Added, #2: 2	دَفْعُ الْخُمُسِ
u'دَفْعٌ خُمُسٌ':Added, #3: 3	دَفْعُ خُمُسِهِ
u'دَفَعَ خَمْسَةٌ':Predicate, #3: 3	دَفْعُ خُمُسِهِ
u'دَفَعَ خَيْطٌ':Predicate, #2: 2	دَفَعَ خَمْسَةَ
u'دَفَعَ دَابَّةٌ':Predicate, #1: 1	دَفَعَ الْخَيْطَ
u'دفع دَابَّةٌ':Added, #1: 1	دَفَعَ الدَّابَّةَ
u'دَفْعٌ دَابَّةٌ':Added, #2: 2	دَفْعُ دَابَّتِهِ
u'دَفَعَ دَارٌ':Predicate, #2: 2	دَفْعُ دَابَّتِهِ
u'دفع دَارٌ':Added, #3: 3	دَفَعَ الدَّارَ
u'دَفْعٌ دَارٌ':Added, #1: 1	دَفْعِ الدَّارِ
u'دفع دَافِعٌ':Added, #1: 1	دَفْعِ الدَّارِ
u'دَفْعٌ دَافِعٌ':Added, #1: 1	دَفْعِ الدَّافِعِ
u'دَفَعَ دَجاج':Predicate, #1: 1	دَفْعِ الدَّافِعِ
u'دَفَعَ دَجاج':Predicate, #1: 1	دَفَعَ الدَّجَاجَةَ
u'دَفَعَ دَجَاجٌ':Predicate, #1: 1	دَفَعَ دَجَاجَةً
u'دَفَعَ دَرَاهِمُ':Predicate, #2: 2	دَفَعَ الدَّجَاجَ
u'دَفَعَ دَرَاهِمُ':Predicate, #4: 4	دَفَعَ دَرَاهِمَ
u'دفع دَرَاهِمُ':Added, #9: 9	دَفَعَ الدَّرَاهِمَ
u'دَفْعٌ دَرَاهِمُ':Added, #1: 1	دَفْعَ الدَّرَاهِمِ
u'دفع دَرَاهِمُ':Added, #1: 1	دَفْعَ الدَّرَاهِمِ
u'دَفْعٌ دَرَاهِمُ':Added, #2: 2	دَفْعِ الدَّرَاهِمِ
u'دَفَعَ دِرْهَمٌ':Predicate, #2: 2	دَفْعِ الدَّرَاهِمِ
u'دَفَعَ دِرْهَم':Predicate, #1: 1	دَفَعَ الدِّرْهَمَ
u'دفع دِرْهَمٌ':Added, #1: 1	دَفَعَ الدِّرْهَمَ
u'دفع دِرْهَم':Added, #2: 2	دَفْعِ الدِّرْهَمِ
u'دَفْعٌ دِرْهَمٌ':Added, #2: 2	دَفْعِ الدِّرْهَمِ
u'دَفْعٌ دِرْهَم':Added, #2: 2	دَفْعِ الدِّرْهَمِ
u'دفع دِرْهَمٌ':Added, #2: 2	دَفْعِ الدِّرْهَمِ
u'دفع دِرْهَم':Added, #2: 2	دَفْعِ دِرْهَمٍ
u'دَفْعٌ دِرْهَمٌ':Added, #2: 2	دَفْعِ دِرْهَمٍ
u'دَفْعٌ دِرْهَم':Added, #2: 2	دَفْعِ دِرْهَمٍ
u'دفع دفع':Added, #2: 2	دَفْعِ دِرْهَمٍ
u'دَفْعٌ دفع':Added, #1: 1	دَفْعِ الدَّفْعِ
u'دفع دَفْعٌ':Added, #1: 1	دَفْعِ الدَّفْعِ
u'دَفْعٌ دَفْعٌ':Added, #1: 1	دَفْعِ الدَّفْعِ
u'دفع دفع':Added, #1: 1	دَفْعِ الدَّفْعِ
u'دَفْعٌ دفع':Added, #2: 2	دَفْعَ الدَّفْعِ
u'دفع دَفْعٌ':Added, #2: 2	دَفْعَ الدَّفْعِ
u'دَفْعٌ دَفْعٌ':Added, #2: 2	دَفْعَ الدَّفْعِ
u'دفع دفع':Added, #2: 2	دَفْعَ الدَّفْعِ
u'دَفْعٌ دفع':Added, #5: 5	دَفْعُ الدَّفْعِ
u'دفع دَفْعٌ':Added, #5: 5	دَفْعُ الدَّفْعِ
u'دَفْعٌ دَفْعٌ':Added, #5: 5	دَفْعُ الدَّفْعِ
u'دفع دَمٌ':Added, #5: 5	دَفْعُ الدَّفْعِ
u'دَفْعٌ دَمٌ':Added, #1: 1	دَفْعِ الدَّمِ
u'دَفَعَ دِهْقانٌ':Subject, #1: 1	دَفْعِ الدَّمِ
u'دَفَعَ دِيَةٌ':Predicate, #1: 1	دَفَعَ الدِّهْقَانُ
u'دفع دِيَةٌ':Added, #1: 1	دَفَعَ دِيَةَ
u'دَفْعٌ دِيَةٌ':Added, #1: 1	دَفْعُ الدِّيَةِ
u'دفع دِيَةٌ':Added, #1: 1	دَفْعُ الدِّيَةِ
u'دَفْعٌ دِيَةٌ':Added, #1: 1	دَفْعِ دِيَةِ
u'دَفَعَ دَيْنٌ':Predicate, #1: 1	دَفْعِ دِيَةِ
u'دَفَعَ دَيْنٌ':Predicate, #1: 1	دَفَعَ دَيْنَ
u'دفع دَيْنٌ':Added, #6: 6	دَفَعَ الدَّيْنَ
u'دَفْعٌ دَيْنٌ':Added, #2: 2	دَفْعُ الدَّيْنِ
u'دفع دَيْنٌ':Added, #2: 2	دَفْعُ الدَّيْنِ
u'دَفْعٌ دَيْنٌ':Added, #2: 2	دَفْعِ دَيْنٍ
u'دفع دَيْنٌ':Added, #2: 2	دَفْعِ دَيْنٍ
u'دَفْعٌ دَيْنٌ':Added, #4: 4	دَفْعِ الدَّيْنِ
u'دَفَعَ دِينارٌ':Predicate, #4: 4	دَفْعِ الدَّيْنِ
u'دفع ذُبابٌ':Added, #1: 1	دَفَعَ الدِّينَارَ
u'دَفْعٌ ذُبابٌ':Added, #1: 1	دَفْعُ الذُّبَابِ
u'دفع ذُكورٌ':Added, #1: 1	دَفْعُ الذُّبَابِ
u'دَفْعٌ ذُكورٌ':Added, #1: 1	دَفْعُ الذُّكُورِ
u'دفع ذُلٌّ':Added, #1: 1	دَفْعُ الذُّكُورِ
u'دَفْعٌ ذُلٌّ':Added, #1: 1	دَفْعِ الذُّلِّ
u'دفع ذَنْبٌ':Added, #1: 1	دَفْعِ الذُّلِّ
u'دَفْعٌ ذَنْبٌ':Added, #1: 1	دَفْعِ الذَّنْبِ
u'دَفَعَ رَأْسٌ':Predicate, #1: 1	دَفْعِ الذَّنْبِ
u'دفع رَأْسٌ':Added, #2: 2	دَفَعَ رَأْسَ
u'دَفْعٌ رَأْسٌ':Added, #1: 1	دَفْعِ رَأْسٍ
u'دفع رَأْسٌ':Added, #1: 1	دَفْعِ رَأْسٍ
u'دَفْعٌ رَأْسٌ':Added, #2: 2	دَفْعِ رَأْسِ
u'دفع رَاكِبٌ':Added, #2: 2	دَفْعِ رَأْسِ
u'دَفْعٌ رَاكِبٌ':Added, #1: 1	دَفْعُ رَاكِبِهِ
u'دَفَعَ رَاهِنٌ':Subject, #1: 1	دَفْعُ رَاكِبِهِ
u'دَفَعَ رايَة':Predicate, #1: 1	دَفَعَ الرَّاهِنُ
u'دَفَعَ رَبُّ':Subject, #2: 2	دَفَعَ الرَّايَةَ
u'دفع رَبُّ':Added, #6: 6	دَفَعَ رَبُّ
u'دَفْعٌ رَبُّ':Added, #1: 1	دَفْعُ رَبِّ
u'دفع رُبُعٌ':Added, #1: 1	دَفْعُ رَبِّ
u'دفع رُبْعٌ':Added, #1: 1	دَفْعَ رُبُعِ
u'دَفْعٌ رُبُعٌ':Added, #1: 1	دَفْعَ رُبْعِ
u'دَفْعٌ رُبْعٌ':Added, #1: 1	دَفْعَ رُبُعِ
u'دفع رُبْعٌ':Added, #1: 1	دَفْعَ رُبْعِ
u'دَفْعٌ رُبْعٌ':Added, #2: 2	دَفْعِ رُبْعِ
u'دَفَعَ رَجُلٌ':Predicate, #2: 2	دَفْعِ رُبْعِ
u'دَفَعَ رَجُلٌ':Subject, #1: 1	دَفَعَ رَجُلاً
u'دَفَعَ رَجُلٌ':Subject, #20: 20	دَفَعَ رَجُلٌ
u'دفع رَدِيءٌ':Added, #58: 58	دَفَعَ الرَّجُلُ
u'دَفْعٌ رَدِيءٌ':Added, #2: 2	دَفْعِ رَدِيءٍ
u'دفع رَذِيلٌ':Added, #2: 2	دَفْعِ رَدِيءٍ
u'دَفْعٌ رَذِيلٌ':Added, #1: 1	دَفْعُ رَذِيلَتِهِ
u'دفع رَذِيلَةٌ':Added, #1: 1	دَفْعُ رَذِيلَتِهِ
u'دَفْعٌ رَذِيلَةٌ':Added, #1: 1	دَفْعُ رَذِيلَتِهِ
u'دفع رِزْقٌ':Added, #1: 1	دَفْعُ رَذِيلَتِهِ
u'دَفْعٌ رِزْقٌ':Added, #1: 1	دَفْعِ رِزْقِهِ
u'دَفَعَ رَسُولٌ':Subject, #1: 1	دَفْعِ رِزْقِهِ
u'دفع رضعاء':Added, #8: 8	دَفَعَ رَسُولُ
u'دَفْعٌ رضعاء':Added, #1: 1	دَفْعِ الرّضَعَاءِ
u'دَفَعَ رِقٌّ':Predicate, #1: 1	دَفْعِ الرّضَعَاءِ
u'دفع رِقٌّ':Added, #1: 1	دَفَعَ الرِّقَّ
u'دَفْعٌ رِقٌّ':Added, #3: 3	دَفْعِ الرِّقِّ
u'دفع رَقَبَةٌ':Added, #3: 3	دَفْعِ الرِّقِّ
u'دفع رَقَبَةٌ':Added, #1: 1	دَفْعُ الرَّقَبَةِ
u'دَفْعٌ رَقَبَةٌ':Added, #1: 1	دَفْعِ الرَّقَبَةِ
u'دَفْعٌ رَقَبَةٌ':Added, #1: 1	دَفْعُ الرَّقَبَةِ
u'دفع رَقَبَةٌ':Added, #1: 1	دَفْعِ الرَّقَبَةِ
u'دَفْعٌ رَقَبَةٌ':Added, #2: 2	دَفْعَ رَقَبَتِهِ
u'دَفَعَ ركب':Subject, #2: 2	دَفْعَ رَقَبَتِهِ
u'دَفَعَ رَكْبٌ':Subject, #2: 2	دَفَعَ الرَّكْبُ
u'دَفَعَ رَهْنٌ':Predicate, #2: 2	دَفَعَ الرَّكْبُ
u'دفع رَهْنٌ':Added, #1: 1	دَفَعَ الرَّهْنَ
u'دَفْعٌ رَهْنٌ':Added, #1: 1	دَفْعُ الرَّهْنِ
u'دفع زائِدٌ':Added, #1: 1	دَفْعُ الرَّهْنِ
u'دَفْعٌ زائِدٌ':Added, #1: 1	دَفْعِ الزَّائِدِ
u'دَفَعَ زَرْعٌ':Predicate, #1: 1	دَفْعِ الزَّائِدِ
u'دفع زَرْعٌ':Added, #1: 1	دَفَعَ الزَّرْعَ
u'دفع زَرْعٌ':Added, #1: 1	دَفْعَ الزَّرْعِ
u'دَفْعٌ زَرْعٌ':Added, #1: 1	دَفْعُ الزَّرْعِ
u'دَفْعٌ زَرْعٌ':Added, #1: 1	دَفْعَ الزَّرْعِ
u'دَفَعَ زَكاةٌ':Predicate, #1: 1	دَفْعُ الزَّرْعِ
u'دَفَعَ زَكاةٌ':Predicate, #10: 10	دَفَعَ الزَّكَاةَ
u'دفع زَكاةٌ':Added, #3: 3	دَفَعَ زَكَاةَ
u'دَفْعٌ زَكاةٌ':Added, #13: 13	دَفْعُ زَكَاتِهِ
u'دفع زَكاةٌ':Added, #13: 13	دَفْعُ زَكَاتِهِ
u'دَفْعٌ زَكاةٌ':Added, #16: 16	دَفْعِ الزَّكَاةِ
u'دفع زَكاةٌ':Added, #16: 16	دَفْعِ الزَّكَاةِ
u'دفع زَكاةٌ':Added, #1: 1	دَفْعِ زَكَاةٍ
u'دَفْعٌ زَكاةٌ':Added, #1: 1	دَفْعِ زَكَاةِ
u'دَفْعٌ زَكاةٌ':Added, #1: 1	دَفْعِ زَكَاةٍ
u'دفع زَكاةٌ':Added, #1: 1	دَفْعِ زَكَاةِ
u'دفع زَكاةٌ':Added, #1: 1	دَفْعَ زَكَاتِهِ
u'دَفْعٌ زَكاةٌ':Added, #1: 1	دَفْعِ زَكَاتِهِ
u'دَفْعٌ زَكاةٌ':Added, #1: 1	دَفْعَ زَكَاتِهِ
u'دفع زَكاةٌ':Added, #1: 1	دَفْعِ زَكَاتِهِ
u'دَفْعٌ زَكاةٌ':Added, #2: 2	دَفْعَ زَكَاةِ
u'دفع زَكاةٌ':Added, #2: 2	دَفْعَ زَكَاةِ
u'دَفْعٌ زَكاةٌ':Added, #40: 40	دَفْعُ الزَّكَاةِ
u'دفع زَكاةٌ':Added, #40: 40	دَفْعُ الزَّكَاةِ
u'دَفْعٌ زَكاةٌ':Added, #5: 5	دَفْعُ زَكَاةِ
u'دفع زَكاةٌ':Added, #5: 5	دَفْعُ زَكَاةِ
u'دَفْعٌ زَكاةٌ':Added, #6: 6	دَفْعَ الزَّكَاةِ
u'دَفَعَ زَوْجٌ':Subject, #6: 6	دَفْعَ الزَّكَاةِ
u'دفع زَوْجٌ':Added, #3: 3	دَفَعَ الزَّوْجُ
u'دَفْعٌ زَوْجٌ':Added, #1: 1	دَفْعُ الزَّوْجِ
u'دفع زِيادَةٌ':Added, #1: 1	دَفْعُ الزَّوْجِ
u'دَفْعٌ زِيادَةٌ':Added, #12: 12	دَفْعِ الزِّيَادَةِ
u'دفع زِيادَةٌ':Added, #12: 12	دَفْعِ الزِّيَادَةِ
u'دَفْعٌ زِيادَةٌ':Added, #1: 1	دَفْعُ الزِّيَادَةِ
u'دفع زِيادَةٌ':Added, #1: 1	دَفْعُ الزِّيَادَةِ
u'دَفْعٌ زِيادَةٌ':Added, #1: 1	دَفْعُ زِيَادَةٍ
u'دفع زِيادَةٌ':Added, #1: 1	دَفْعُ زِيَادَةٍ
u'دفع زِيادَةٌ':Added, #2: 2	دَفْعُ زِيَادَةِ
u'دَفْعٌ زِيادَةٌ':Added, #2: 2	دَفْعِ زِيَادَةِ
u'دَفْعٌ زِيادَةٌ':Added, #2: 2	دَفْعُ زِيَادَةِ
u'دفع زِيادَةٌ':Added, #2: 2	دَفْعِ زِيَادَةِ
u'دَفْعٌ زِيادَةٌ':Added, #4: 4	دَفْعَ زِيَادَةِ
u'دفع سَارِقٌ':Added, #4: 4	دَفْعَ زِيَادَةِ
u'دَفْعٌ سَارِقٌ':Added, #1: 1	دَفْعِ السَّارِقِ
u'دفع سائِل':Added, #1: 1	دَفْعِ السَّارِقِ
u'دفع سَائِلٌ':Added, #1: 1	دَفْعِ السَّائِلِ
u'دَفْعٌ سائِل':Added, #1: 1	دَفْعِ السَّائِلِ
u'دَفْعٌ سَائِلٌ':Added, #1: 1	دَفْعِ السَّائِلِ
u'دَفَعَ سَبْرٌ':Predicate, #1: 1	دَفْعِ السَّائِلِ
u'دفع سَرَاوِيلُ':Added, #1: 1	دَفَعَ السَّبْرَ
u'دَفْعٌ سَرَاوِيلُ':Added, #1: 1	دَفْعِ السَّرَاوِيلِ
u'دَفَعَ سَرقَةٌ':Predicate, #1: 1	دَفْعِ السَّرَاوِيلِ
u'دَفَعَ سَرِقَةٌ':Predicate, #2: 2	دَفَعَ السَّرِقَةَ
u'دَفَعَ سِلاَحٌ':Predicate, #2: 2	دَفَعَ السَّرِقَةَ
u'دفع سُلْطَانٌ':Added, #1: 1	دَفَعَ السِّلَاحَ
u'دفع سُلْطَانٌ':Added, #1: 1	دَفْعُ السُّلْطَانِ
u'دَفْعٌ سُلْطَانٌ':Added, #1: 1	دَفْعِ السُّلْطَانِ
u'دَفْعٌ سُلْطَانٌ':Added, #1: 1	دَفْعُ السُّلْطَانِ
u'دفع سِلْعَةٌ':Added, #1: 1	دَفْعِ السُّلْطَانِ
u'دَفْعٌ سِلْعَةٌ':Added, #2: 2	دَفْعِ السِّلْعَةِ
u'دَفَعَ سِمْسَارٌ':Subject, #2: 2	دَفْعِ السِّلْعَةِ
u'دفع سِنٌّ':Added, #1: 1	دَفَعَ السِّمْسَارُ
u'دَفْعٌ سِنٌّ':Added, #1: 1	دَفْعُ سِنٍّ
u'دفع سِنٌّ':Added, #1: 1	دَفْعُ سِنٍّ
u'دَفْعٌ سِنٌّ':Added, #2: 2	دَفْعُ السِّنِّ
u'دفع سُوءٌ':Added, #2: 2	دَفْعُ السِّنِّ
u'دفع سُوءٌ':Added, #1: 1	دَفْعُ سُوءِ
u'دَفْعٌ سُوءٌ':Added, #1: 1	دَفْعِ سُوءٍ
u'دَفْعٌ سُوءٌ':Added, #1: 1	دَفْعُ سُوءِ
u'دفع سِواكٌ':Added, #1: 1	دَفْعِ سُوءٍ
u'دَفْعٌ سِواكٌ':Added, #1: 1	دَفْعِ السِّوَاكِ
u'دَفَعَ سَيِّدٌ':Subject, #1: 1	دَفْعِ السِّوَاكِ
u'دَفَعَ سَيِّدٌ':Subject, #1: 1	دَفَعَ السَّيِّدُ
u'دفع سَيِّدٌ':Added, #2: 2	دَفَعَ سَيِّدُهُ
u'دَفْعٌ سَيِّدٌ':Added, #1: 1	دَفْعِ السَّيِّدِ
u'دَفَعَ سَيْرٌ':Predicate, #1: 1	دَفْعِ السَّيِّدِ
u'دَفَعَ شَاةٌ':Predicate, #1: 1	دَفَعَ السَّيْرَ
u'دفع شبكة':Added, #1: 1	دَفَعَ الشَّاةَ
u'دَفْعٌ شبكة':Added, #1: 1	دَفْعُ الشَّبَكَةِ
u'دفع شَبَكَةٌ':Added, #1: 1	دَفْعُ الشَّبَكَةِ
u'دَفْعٌ شَبَكَةٌ':Added, #1: 1	دَفْعُ الشَّبَكَةِ
u'دَفَعَ شُبْهَةٌ':Subject, #1: 1	دَفْعُ الشَّبَكَةِ
u'دَفَعَ شَجَرٌ':Predicate, #1: 1	دَفَعَ شُبْهَةٌ
u'دفع شَجَرٌ':Added, #1: 1	دَفَعَ شَجَرَ
u'دَفْعٌ شَجَرٌ':Added, #1: 1	دَفْعُ شَجَرٍ
u'دَفَعَ شَخْصٌ':Subject, #1: 1	دَفْعُ شَجَرٍ
u'دفع شَرٌّ':Added, #1: 1	دَفَعَ الشَّخْصُ
u'دفع شَرٌّ':Added, #1: 1	دَفْعَ الشَّرِّ
u'دَفْعٌ شَرٌّ':Added, #1: 1	دَفْعِ الشَّرِّ
u'دَفْعٌ شَرٌّ':Added, #1: 1	دَفْعَ الشَّرِّ
u'دفع شَرٌّ':Added, #1: 1	دَفْعِ الشَّرِّ
u'دفع شَرٌّ':Added, #1: 1	دَفْعَ شَرِّهِ
u'دَفْعٌ شَرٌّ':Added, #1: 1	دَفْعِ شَرِّهِ
u'دَفْعٌ شَرٌّ':Added, #1: 1	دَفْعَ شَرِّهِ
u'دفع شَرٌّ':Added, #1: 1	دَفْعِ شَرِّهِ
u'دَفْعٌ شَرٌّ':Added, #2: 2	دَفْعِ شَرٍّ
u'دفع شَرٌّ':Added, #2: 2	دَفْعِ شَرٍّ
u'دَفْعٌ شَرٌّ':Added, #3: 3	دَفْعُ شَرِّ
u'دفع شَرٌّ':Added, #3: 3	دَفْعُ شَرِّ
u'دَفْعٌ شَرٌّ':Added, #5: 5	دَفْعُ شَرِّهِ
u'دفع شَرٌّ':Added, #5: 5	دَفْعُ شَرِّهِ
u'دَفْعٌ شَرٌّ':Added, #9: 9	دَفْعُ الشَّرِّ
u'دفع شفعة':Added, #9: 9	دَفْعُ الشَّرِّ
u'دَفْعٌ شفعة':Added, #3: 3	دَفْعِ الشُّفْعَةِ
u'دفع شُفْعَةٌ':Added, #3: 3	دَفْعِ الشُّفْعَةِ
u'دَفْعٌ شُفْعَةٌ':Added, #3: 3	دَفْعِ الشُّفْعَةِ
u'دَفَعَ شَفِيعٌ':Subject, #3: 3	دَفْعِ الشُّفْعَةِ
u'دفع شُهُودٌ':Added, #1: 1	دَفَعَ الشَّفِيعُ
u'دَفْعٌ شُهُودٌ':Added, #1: 1	دَفْعِ الشُّهُودِ
u'دفع شوائب':Added, #1: 1	دَفْعِ الشُّهُودِ
u'دَفْعٌ شوائب':Added, #1: 1	دَفْعِ شَوَائِبِ
u'دفع شَوَائِبُ':Added, #1: 1	دَفْعِ شَوَائِبِ
u'دَفْعٌ شَوَائِبُ':Added, #1: 1	دَفْعِ شَوَائِبِ
u'دفع شَيْءٌ':Added, #1: 1	دَفْعِ شَوَائِبِ
u'دَفْعٌ شَيْءٌ':Added, #1: 1	دَفْعَ الشَّيْءِ
u'دفع شَيْءٌ':Added, #1: 1	دَفْعَ الشَّيْءِ
u'دَفْعٌ شَيْءٌ':Added, #2: 2	دَفْعِ شَيْءٍ
u'دفع شَيْءٌ':Added, #2: 2	دَفْعِ شَيْءٍ
u'دَفْعٌ شَيْءٌ':Added, #3: 3	دَفْعُ شَيْءٍ
u'دفع شَيْطَانٌ':Added, #3: 3	دَفْعُ شَيْءٍ
u'دفع شَيْطَانٌ':Added, #1: 1	دَفْعُ الشَّيْطَانِ
u'دَفْعٌ شَيْطَانٌ':Added, #1: 1	دَفْعِ الشَّيْطَانِ
u'دَفْعٌ شَيْطَانٌ':Added, #1: 1	دَفْعُ الشَّيْطَانِ
u'دَفَعَ صَاحِبٌ':Subject, #1: 1	دَفْعِ الشَّيْطَانِ
u'دَفَعَ صَاحِبٌ':Subject, #1: 1	دَفَعَ صَاحِبُهُ
u'دفع صَاحِبٌ':Added, #2: 2	دَفَعَ صَاحِبُ
u'دَفْعٌ صَاحِبٌ':Added, #1: 1	دَفْعِ صَاحِبِ
u'دَفَعَ صَانِعٌ':Subject, #1: 1	دَفْعِ صَاحِبِ
u'دَفَعَ صَبِيٌّ':Subject, #1: 1	دَفَعَ الصَّانِعُ
u'دفع صَبِيٌّ':Added, #1: 1	دَفَعَ الصَّبِيُّ
u'دَفْعٌ صَبِيٌّ':Added, #1: 1	دَفْعِ الصَّبِيِّ
u'دفع صِبْيَانٌ':Added, #1: 1	دَفْعِ الصَّبِيِّ
u'دَفْعٌ صِبْيَانٌ':Added, #1: 1	دَفْعِ الصِّبْيَانِ
u'دَفَعَ صَحِيحٌ':Subject, #1: 1	دَفْعِ الصِّبْيَانِ
u'دفع صَحِيحٌ':Added, #2: 2	دَفَعَ الصَّحِيحُ
u'دَفْعٌ صَحِيحٌ':Added, #1: 1	دَفْعِ الصَّحِيحِ
u'دفع صَدْرٌ':Added, #1: 1	دَفْعِ الصَّحِيحِ
u'دَفْعٌ صَدْرٌ':Added, #1: 1	دَفْعُ صَدْرِ
u'دَفَعَ صدقة':Predicate, #1: 1	دَفْعُ صَدْرِ
u'دَفَعَ صَدَقَةٌ':Predicate, #3: 3	دَفَعَ صَدَقَةَ
u'دفع صدقة':Added, #3: 3	دَفَعَ صَدَقَةَ
u'دَفْعٌ صدقة':Added, #1: 1	دَفْعَ الصَّدَقَةِ
u'دفع صَدَقَةٌ':Added, #1: 1	دَفْعَ الصَّدَقَةِ
u'دَفْعٌ صَدَقَةٌ':Added, #1: 1	دَفْعَ الصَّدَقَةِ
u'دفع صدقة':Added, #1: 1	دَفْعَ الصَّدَقَةِ
u'دَفْعٌ صدقة':Added, #1: 1	دَفْعُ صَدَقَتِهِ
u'دفع صَدَقَةٌ':Added, #1: 1	دَفْعُ صَدَقَتِهِ
u'دَفْعٌ صَدَقَةٌ':Added, #1: 1	دَفْعُ صَدَقَتِهِ
u'دفع صدقة':Added, #1: 1	دَفْعُ صَدَقَتِهِ
u'دَفْعٌ صدقة':Added, #3: 3	دَفْعِ الصَّدَقَةِ
u'دفع صَدَقَةٌ':Added, #3: 3	دَفْعِ الصَّدَقَةِ
u'دَفْعٌ صَدَقَةٌ':Added, #3: 3	دَفْعِ الصَّدَقَةِ
u'دفع صدقة':Added, #3: 3	دَفْعِ الصَّدَقَةِ
u'دَفْعٌ صدقة':Added, #6: 6	دَفْعُ الصَّدَقَةِ
u'دفع صَدَقَةٌ':Added, #6: 6	دَفْعُ الصَّدَقَةِ
u'دَفْعٌ صَدَقَةٌ':Added, #6: 6	دَفْعُ الصَّدَقَةِ
u'دفع صدقة':Added, #6: 6	دَفْعُ الصَّدَقَةِ
u'دَفْعٌ صدقة':Added, #6: 6	دَفْعُ صَدَقَةِ
u'دفع صَدَقَةٌ':Added, #6: 6	دَفْعُ صَدَقَةِ
u'دَفْعٌ صَدَقَةٌ':Added, #6: 6	دَفْعُ صَدَقَةِ
u'دَفَعَ صَغِيرٌ':Subject, #6: 6	دَفْعُ صَدَقَةِ
u'دفع صَغِيرٌ':Added, #1: 1	دَفَعَ الصَّغِيرُ
u'دَفْعٌ صَغِيرٌ':Added, #1: 1	دَفْعِ الصَّغِيرِ
u'دفع صَكٌّ':Added, #1: 1	دَفْعِ الصَّغِيرِ
u'دَفْعٌ صَكٌّ':Added, #1: 1	دَفْعِ الصَّكِّ
u'دفع صَنِيعَةٌ':Added, #1: 1	دَفْعِ الصَّكِّ
u'دَفْعٌ صَنِيعَةٌ':Added, #1: 1	دَفْعُ صَنِيعَةٍ
u'دفع ضَرَرٌ':Added, #1: 1	دَفْعُ صَنِيعَةٍ
u'دَفْعٌ ضَرَرٌ':Added, #16: 16	دَفْعُ ضَرَرِ
u'دفع ضَرَرٌ':Added, #16: 16	دَفْعُ ضَرَرِ
u'دفع ضَرَرٌ':Added, #1: 1	دَفْعَ ضَرَرِهِ
u'دَفْعٌ ضَرَرٌ':Added, #1: 1	دَفْعِ ضَرَرِهِ
u'دَفْعٌ ضَرَرٌ':Added, #1: 1	دَفْعَ ضَرَرِهِ
u'دفع ضَرَرٌ':Added, #1: 1	دَفْعِ ضَرَرِهِ
u'دَفْعٌ ضَرَرٌ':Added, #23: 23	دَفْعَ الضَّرَرِ
u'دفع ضَرَرٌ':Added, #23: 23	دَفْعَ الضَّرَرِ
u'دَفْعٌ ضَرَرٌ':Added, #2: 2	دَفْعَ ضَرَرِ
u'دفع ضَرَرٌ':Added, #2: 2	دَفْعَ ضَرَرِ
u'دَفْعٌ ضَرَرٌ':Added, #31: 31	دَفْعِ الضَّرَرِ
u'دفع ضَرَرٌ':Added, #31: 31	دَفْعِ الضَّرَرِ
u'دَفْعٌ ضَرَرٌ':Added, #33: 33	دَفْعُ الضَّرَرِ
u'دفع ضَرَرٌ':Added, #33: 33	دَفْعُ الضَّرَرِ
u'دفع ضَرَرٌ':Added, #4: 4	دَفْعَ ضَرَرٍ
u'دَفْعٌ ضَرَرٌ':Added, #4: 4	دَفْعِ ضَرَرٍ
u'دَفْعٌ ضَرَرٌ':Added, #4: 4	دَفْعَ ضَرَرٍ
u'دفع ضَرَرٌ':Added, #4: 4	دَفْعِ ضَرَرٍ
u'دَفْعٌ ضَرَرٌ':Added, #7: 7	دَفْعِ ضَرَرِ
u'دفع ضَرَرٌ':Added, #7: 7	دَفْعِ ضَرَرِ
u'دَفْعٌ ضَرَرٌ':Added, #8: 8	دَفْعُ ضَرَرٍ
u'دفع ضَرُورَةٌ':Added, #8: 8	دَفْعُ ضَرَرٍ
u'دَفْعٌ ضَرُورَةٌ':Added, #1: 1	دَفْعُ الضَّرُورَةِ
u'دفع ضَغِينَةٌ':Added, #1: 1	دَفْعُ الضَّرُورَةِ
u'دَفْعٌ ضَغِينَةٌ':Added, #1: 1	دَفْعُ ضَغِينَةٍ
u'دفع ضَمَانٌ':Added, #1: 1	دَفْعُ ضَغِينَةٍ
u'دَفْعٌ ضَمَانٌ':Added, #10: 10	دَفْعِ الضَّمَانِ
u'دفع ضَمَانٌ':Added, #10: 10	دَفْعِ الضَّمَانِ
u'دَفْعٌ ضَمَانٌ':Added, #2: 2	دَفْعُ الضَّمَانِ
u'دفع طَاعِنٌ':Added, #2: 2	دَفْعُ الضَّمَانِ
u'دَفْعٌ طَاعِنٌ':Added, #1: 1	دَفْعِ الطَّاعِنِ
u'دفع طَالِبٌ':Added, #1: 1	دَفْعِ الطَّاعِنِ
u'دَفْعٌ طَالِبٌ':Added, #1: 1	دَفْعُ طَالِبٍ
u'دَفَعَ طَائِفٌ':Predicate, #1: 1	دَفْعُ طَالِبٍ
u'دفع طَرْد':Added, #1: 1	دَفَعَ طَائِفَةً
u'دَفْعٌ طَرْد':Added, #1: 1	دَفْعِ الطَّرْدِيَّةِ
u'دفع طَرْدَة':Added, #1: 1	دَفْعِ الطَّرْدِيَّةِ
u'دَفْعٌ طَرْدَة':Added, #1: 1	دَفْعِ الطَّرْدِيَّةِ
u'دفع طَرْدِيّ':Added, #1: 1	دَفْعِ الطَّرْدِيَّةِ
u'دَفْعٌ طَرْدِيّ':Added, #1: 1	دَفْعِ الطَّرْدِيَّةِ
u'دَفَعَ طعام':Predicate, #1: 1	دَفْعِ الطَّرْدِيَّةِ
u'دَفَعَ طَعَامٌ':Predicate, #2: 2	دَفَعَ الطَّعَامَ
u'دَفَعَ طعام':Predicate, #2: 2	دَفَعَ الطَّعَامَ
u'دَفَعَ طَعَامٌ':Predicate, #2: 2	دَفَعَ طَعَامَ
u'دفع طَلاَقٌ':Added, #2: 2	دَفَعَ طَعَامَ
u'دَفْعٌ طَلاَقٌ':Added, #1: 1	دَفْعَ الطَّلَاقِ
u'دفع طلب':Added, #1: 1	دَفْعَ الطَّلَاقِ
u'دَفْعٌ طلب':Added, #1: 1	دَفْعَ الطَّلَبِ
u'دفع طَلَبٌ':Added, #1: 1	دَفْعَ الطَّلَبِ
u'دَفْعٌ طَلَبٌ':Added, #1: 1	دَفْعَ الطَّلَبِ
u'دفع طلب':Added, #1: 1	دَفْعَ الطَّلَبِ
u'دَفْعٌ طلب':Added, #1: 1	دَفْعِ طَلَبِ
u'دفع طَلَبٌ':Added, #1: 1	دَفْعِ طَلَبِ
u'دَفْعٌ طَلَبٌ':Added, #1: 1	دَفْعِ طَلَبِ
u'دفع طِينَةٌ':Added, #1: 1	دَفْعِ طَلَبِ
u'دَفْعٌ طِينَةٌ':Added, #1: 1	دَفْعَ طِينَةٍ
u'دفع ظالِمٌ':Added, #1: 1	دَفْعَ طِينَةٍ
u'دَفْعٌ ظالِمٌ':Added, #2: 2	دَفْعِ الظَّالِمِ
u'دفع ظاهِرٌ':Added, #2: 2	دَفْعِ الظَّالِمِ
u'دَفْعٌ ظاهِرٌ':Added, #1: 1	دَفْعُ الظَّاهِرِ
u'دفع ظُلْمٌ':Added, #1: 1	دَفْعُ الظَّاهِرِ
u'دَفْعٌ ظُلْمٌ':Added, #3: 3	دَفْعُ الظُّلْمِ
u'دفع ظُلْمٌ':Added, #3: 3	دَفْعُ الظُّلْمِ
u'دَفْعٌ ظُلْمٌ':Added, #4: 4	دَفْعِ الظُّلْمِ
u'دفع ظَنٌّ':Added, #4: 4	دَفْعِ الظُّلْمِ
u'دَفْعٌ ظَنٌّ':Added, #1: 1	دَفْعِ الظَّنِّ
u'دفع عَارٌ':Added, #1: 1	دَفْعِ الظَّنِّ
u'دَفْعٌ عَارٌ':Added, #1: 1	دَفْعِ عَارِ
u'دفع عَارٌ':Added, #1: 1	دَفْعِ عَارِ
u'دَفْعٌ عَارٌ':Added, #2: 2	دَفْعَ الْعَارِ
u'دفع عَارٌ':Added, #2: 2	دَفْعَ الْعَارِ
u'دَفْعٌ عَارٌ':Added, #2: 2	دَفْعُ عَارِ
u'دفع عَارٌ':Added, #2: 2	دَفْعُ عَارِ
u'دَفْعٌ عَارٌ':Added, #4: 4	دَفْعِ الْعَارِ
u'دفع عَارٌ':Added, #4: 4	دَفْعِ الْعَارِ
u'دَفْعٌ عَارٌ':Added, #6: 6	دَفْعُ الْعَارِ
u'دَفَعَ عَامِلٌ':Subject, #6: 6	دَفْعُ الْعَارِ
u'دَفَعَ عَبْدٌ':Predicate, #1: 1	دَفَعَ الْعَامِلُ
u'دَفَعَ عَبْدٌ':Subject, #20: 20	دَفَعَ الْعَبْدَ
u'دَفَعَ عَبْدٌ':Subject, #1: 1	دَفَعَ عَبْدٌ
u'دفع عَبْدٌ':Added, #6: 6	دَفَعَ الْعَبْدُ
u'دَفْعٌ عَبْدٌ':Added, #5: 5	دَفْعُ الْعَبْدِ
u'دفع عَبْدٌ':Added, #5: 5	دَفْعُ الْعَبْدِ
u'دَفْعٌ عَبْدٌ':Added, #6: 6	دَفْعَ الْعَبْدِ
u'دفع عَبْدٌ':Added, #6: 6	دَفْعَ الْعَبْدِ
u'دَفْعٌ عَبْدٌ':Added, #8: 8	دَفْعِ الْعَبْدِ
u'دفع عَتَبٌ':Added, #8: 8	دَفْعِ الْعَبْدِ
u'دَفْعٌ عَتَبٌ':Added, #1: 1	دَفْعِ الْعَتَبِ
u'دَفَعَ عَدْلٌ':Subject, #1: 1	دَفْعِ الْعَتَبِ
u'دفع عَدْلِيٌّ':Added, #7: 7	دَفَعَ الْعَدْلُ
u'دَفْعٌ عَدْلِيٌّ':Added, #1: 1	دَفْعِ الْعَدْلِيَّاتِ
u'دفع عَدْلِيَّةٌ':Added, #1: 1	دَفْعِ الْعَدْلِيَّاتِ
u'دَفْعٌ عَدْلِيَّةٌ':Added, #1: 1	دَفْعِ الْعَدْلِيَّاتِ
u'دَفَعَ عَدُوٌّ':Predicate, #1: 1	دَفْعِ الْعَدْلِيَّاتِ
u'دفع عَدُوٌّ':Added, #1: 1	دَفَعَ الْعَدُوَّ
u'دَفْعٌ عَدُوٌّ':Added, #1: 1	دَفْعُ الْعَدُوِّ
u'دفع عَدُوٌّ':Added, #1: 1	دَفْعُ الْعَدُوِّ
u'دَفْعٌ عَدُوٌّ':Added, #1: 1	دَفْعُ عَدُوٍّ
u'دفع عُدْوَانٌ':Added, #1: 1	دَفْعُ عَدُوٍّ
u'دَفْعٌ عُدْوَانٌ':Added, #1: 1	دَفْعِ الْعُدْوَانِ
u'دفع عَرَقٌ':Added, #1: 1	دَفْعِ الْعُدْوَانِ
u'دَفْعٌ عَرَقٌ':Added, #1: 1	دَفْعُ الْعَرَقِ
u'دَفَعَ عُشْرٌ':Predicate, #1: 1	دَفْعُ الْعَرَقِ
u'دفع عُشْرٌ':Added, #1: 1	دَفَعَ عُشْرَ
u'دَفْعٌ عُشْرٌ':Added, #1: 1	دَفْعَ الْعُشْرِ
u'دفع عُشْرٌ':Added, #1: 1	دَفْعَ الْعُشْرِ
u'دَفْعٌ عُشْرٌ':Added, #1: 1	دَفْعُ عُشْرٍ
u'دفع عُشْرٌ':Added, #1: 1	دَفْعُ عُشْرٍ
u'دَفْعٌ عُشْرٌ':Added, #1: 1	دَفْعُ عُشْرِهِ
u'دَفَعَ عَشِيَّةٌ':Predicate, #1: 1	دَفْعُ عُشْرِهِ
u'دَفَعَ عقر':Predicate, #1: 1	دَفَعَ عَشِيَّةَ
u'دَفَعَ عُقْرٌ':Predicate, #5: 5	دَفَعَ الْعُقْرَ
u'دفع عَقْلٌ':Added, #5: 5	دَفَعَ الْعُقْرَ
u'دفع عَقْلٌ':Added, #1: 1	دَفْعَ الْعَقْلِ
u'دَفْعٌ عَقْلٌ':Added, #1: 1	دَفْعِ الْعَقْلِ
u'دَفْعٌ عَقْلٌ':Added, #1: 1	دَفْعَ الْعَقْلِ
u'دفع عُقُوبَةٌ':Added, #1: 1	دَفْعِ الْعَقْلِ
u'دَفْعٌ عُقُوبَةٌ':Added, #1: 1	دَفْعَ الْعُقُوبَةِ
u'دفع عَكْسٌ':Added, #1: 1	دَفْعَ الْعُقُوبَةِ
u'دَفْعٌ عَكْسٌ':Added, #1: 1	دَفْعُ عَكْسِ
u'دفع عِلَّةٌ':Added, #1: 1	دَفْعُ عَكْسِ
u'دَفْعٌ عِلَّةٌ':Added, #1: 1	دَفْعِ الْعِلَّةِ
u'دفع عِلَلٌ':Added, #1: 1	دَفْعِ الْعِلَّةِ
u'دَفْعٌ عِلَلٌ':Added, #2: 2	دَفْعِ الْعِلَلِ
u'دفع عُلُومٌ':Added, #2: 2	دَفْعِ الْعِلَلِ
u'دَفْعٌ عُلُومٌ':Added, #1: 1	دَفْعِ الْعُلُومِ
u'دفع عِمَالَةٌ':Added, #1: 1	دَفْعِ الْعُلُومِ
u'دَفْعٌ عِمَالَةٌ':Added, #1: 1	دَفْعَ الْعِمَالَةِ
u'دَفَعَ عُمُومٌ':Predicate, #1: 1	دَفْعَ الْعِمَالَةِ
u'دَفَعَ عند':Predicate, #1: 1	دَفَعَ عُمُومَ
u'دَفَعَ عِوَضٌ':Predicate, #1: 1	دَفَعَ عِنْدَ
u'دفع عِوَضٌ':Added, #6: 6	دَفَعَ الْعِوَضَ
u'دَفْعٌ عِوَضٌ':Added, #1: 1	دَفْعَ الْعِوَضِ
u'دفع عِوَضٌ':Added, #1: 1	دَفْعَ الْعِوَضِ
u'دفع عِوَضٌ':Added, #1: 1	دَفْعُ عِوَضٍ
u'دفع عِوَضٌ':Added, #1: 1	دَفْعُ عِوَضِ
u'دَفْعٌ عِوَضٌ':Added, #1: 1	دَفْعِ عِوَضٍ
u'دَفْعٌ عِوَضٌ':Added, #1: 1	دَفْعُ عِوَضٍ
u'دَفْعٌ عِوَضٌ':Added, #1: 1	دَفْعُ عِوَضِ
u'دفع عِوَضٌ':Added, #1: 1	دَفْعِ عِوَضٍ
u'دَفْعٌ عِوَضٌ':Added, #1: 1	دَفْعُ عِوَضِهِ
u'دفع عِوَضٌ':Added, #1: 1	دَفْعُ عِوَضِهِ
u'دَفْعٌ عِوَضٌ':Added, #2: 2	دَفْعِ الْعِوَضِ
u'دَفَعَ عين':Predicate, #2: 2	دَفْعِ الْعِوَضِ
u'دَفَعَ عَيْنٌ':Predicate, #1: 1	دَفَعَ عَيْنَ
u'دَفَعَ عَيْن':Predicate, #1: 1	دَفَعَ عَيْنَ
u'دفع عين':Added, #1: 1	دَفَعَ عَيْنَ
u'دفع عين':Added, #1: 1	دَفْعَ الْعَيْنِ
u'دفع عَيْنٌ':Added, #1: 1	دَفْعُ الْعَيْنِ
u'دفع عَيْنٌ':Added, #1: 1	دَفْعَ الْعَيْنِ
u'دفع عَيْن':Added, #1: 1	دَفْعُ الْعَيْنِ
u'دفع عَيْن':Added, #1: 1	دَفْعَ الْعَيْنِ
u'دَفْعٌ عين':Added, #1: 1	دَفْعُ الْعَيْنِ
u'دَفْعٌ عين':Added, #1: 1	دَفْعَ الْعَيْنِ
u'دَفْعٌ عَيْنٌ':Added, #1: 1	دَفْعُ الْعَيْنِ
u'دَفْعٌ عَيْنٌ':Added, #1: 1	دَفْعَ الْعَيْنِ
u'دَفْعٌ عَيْن':Added, #1: 1	دَفْعُ الْعَيْنِ
u'دَفْعٌ عَيْن':Added, #1: 1	دَفْعَ الْعَيْنِ
u'دفع عين':Added, #1: 1	دَفْعُ الْعَيْنِ
u'دفع عين':Added, #1: 1	دَفْعُ عَيْنِهِ
u'دفع عَيْنٌ':Added, #1: 1	دَفْعِ عَيْنِهِ
u'دفع عَيْنٌ':Added, #1: 1	دَفْعُ عَيْنِهِ
u'دفع عَيْن':Added, #1: 1	دَفْعِ عَيْنِهِ
u'دفع عَيْن':Added, #1: 1	دَفْعُ عَيْنِهِ
u'دَفْعٌ عين':Added, #1: 1	دَفْعِ عَيْنِهِ
u'دَفْعٌ عين':Added, #1: 1	دَفْعُ عَيْنِهِ
u'دَفْعٌ عَيْنٌ':Added, #1: 1	دَفْعِ عَيْنِهِ
u'دَفْعٌ عَيْنٌ':Added, #1: 1	دَفْعُ عَيْنِهِ
u'دَفْعٌ عَيْن':Added, #1: 1	دَفْعِ عَيْنِهِ
u'دَفْعٌ عَيْن':Added, #1: 1	دَفْعُ عَيْنِهِ
u'دَفَعَ غَاصِبٌ':Subject, #1: 1	دَفْعِ عَيْنِهِ
u'دفع غَاصِبٌ':Added, #1: 1	دَفَعَ الْغَاصِبُ
u'دفع غَاصِبٌ':Added, #1: 1	دَفْعُ الْغَاصِبِ
u'دَفْعٌ غَاصِبٌ':Added, #1: 1	دَفْعِ الْغَاصِبِ
u'دَفْعٌ غَاصِبٌ':Added, #1: 1	دَفْعُ الْغَاصِبِ
u'دَفَعَ غَائِبٌ':Subject, #1: 1	دَفْعِ الْغَاصِبِ
u'دفع غَبَنٌ':Added, #1: 1	دَفَعَ الْغَائِبُ
u'دفع غَبَنٌ':Added, #1: 1	دَفْعُ الْغَبَنِ
u'دَفْعٌ غَبَنٌ':Added, #1: 1	دَفْعِ الْغَبَنِ
u'دَفْعٌ غَبَنٌ':Added, #1: 1	دَفْعُ الْغَبَنِ
u'دفع غَبْنٌ':Added, #1: 1	دَفْعِ الْغَبَنِ
u'دَفْعٌ غَبْنٌ':Added, #5: 5	دَفْعِ الْغَبْنِ
u'دَفَعَ غرماء':Subject, #5: 5	دَفْعِ الْغَبْنِ
u'دفع غُرُورٌ':Added, #1: 1	دَفَعَ الْغُرَمَاءُ
u'دَفْعٌ غُرُورٌ':Added, #1: 1	دَفْعِ الْغُرُورِ
u'دَفَعَ غَرِيمٌ':Subject, #1: 1	دَفْعِ الْغُرُورِ
u'دفع غَرِيمٌ':Added, #6: 6	دَفَعَ الْغَرِيمُ
u'دَفْعٌ غَرِيمٌ':Added, #1: 1	دَفْعُ الْغَرِيمِ
u'دفع غَرِيمٌ':Added, #1: 1	دَفْعُ الْغَرِيمِ
u'دَفْعٌ غَرِيمٌ':Added, #2: 2	دَفْعِ الْغَرِيمِ
u'دَفَعَ غُلاَمٌ':Predicate, #2: 2	دَفْعِ الْغَرِيمِ
u'دَفَعَ غَلَّةٌ':Predicate, #1: 1	دَفَعَ الْغُلَامَ
u'دفع غَلَّةٌ':Added, #1: 1	دَفَعَ الْغَلَّةَ
u'دَفْعٌ غَلَّةٌ':Added, #1: 1	دَفْعُ الْغَلَّةِ
u'دفع غَلَّةٌ':Added, #1: 1	دَفْعُ الْغَلَّةِ
u'دَفْعٌ غَلَّةٌ':Added, #1: 1	دَفْعَ غَلَّةِ
u'دفع غَلَّةٌ':Added, #1: 1	دَفْعَ غَلَّةِ
u'دَفْعٌ غَلَّةٌ':Added, #1: 1	دَفْعُ غَلَّتِهِ
u'دَفَعَ غَنَمٌ':Predicate, #1: 1	دَفْعُ غَلَّتِهِ
u'دفع غَنَمٌ':Added, #1: 1	دَفَعَ الْغَنَمَ
u'دَفْعٌ غَنَمٌ':Added, #1: 1	دَفْعِ الْغَنَمِ
u'دفع غَوَائِلُ':Added, #1: 1	دَفْعِ الْغَنَمِ
u'دَفْعٌ غَوَائِلُ':Added, #1: 1	دَفْعُ غَوَائِلِ
u'دَفَعَ غير':Predicate, #1: 1	دَفْعُ غَوَائِلِ
u'دَفَعَ غَيْرٌ':Predicate, #1: 1	دَفَعَ غَيْرَ
u'دفع غير':Added, #1: 1	دَفَعَ غَيْرَ
u'دفع غير':Added, #1: 1	دَفْعُ غَيْرِ
u'دفع غَيْرٌ':Added, #1: 1	دَفْعِ غَيْرِ
u'دفع غَيْرٌ':Added, #1: 1	دَفْعُ غَيْرِ
u'دَفْعٌ غير':Added, #1: 1	دَفْعِ غَيْرِ
u'دَفْعٌ غير':Added, #1: 1	دَفْعُ غَيْرِ
u'دَفْعٌ غَيْرٌ':Added, #1: 1	دَفْعِ غَيْرِ
u'دَفْعٌ غَيْرٌ':Added, #1: 1	دَفْعُ غَيْرِ
u'دفع فَاضِلٌ':Added, #1: 1	دَفْعِ غَيْرِ
u'دَفْعٌ فَاضِلٌ':Added, #1: 1	دَفْعُ الْفَاضِلِ
u'دفع فتنة':Added, #1: 1	دَفْعُ الْفَاضِلِ
u'دَفْعٌ فتنة':Added, #2: 2	دَفْعِ الْفِتْنَةِ
u'دفع فِتْنَةٌ':Added, #2: 2	دَفْعِ الْفِتْنَةِ
u'دَفْعٌ فِتْنَةٌ':Added, #2: 2	دَفْعِ الْفِتْنَةِ
u'دفع فُجُورٌ':Added, #2: 2	دَفْعِ الْفِتْنَةِ
u'دَفْعٌ فُجُورٌ':Added, #1: 1	دَفْعِ الْفُجُورِ
u'دَفَعَ فِدَاءٌ':Predicate, #1: 1	دَفْعِ الْفُجُورِ
u'دفع فِدَاءٌ':Added, #1: 1	دَفَعَ فِدَاءَ
u'دَفْعٌ فِدَاءٌ':Added, #1: 1	دَفْعَ الْفِدَاءِ
u'دفع فَرْدٌ':Added, #1: 1	دَفْعَ الْفِدَاءِ
u'دَفْعٌ فَرْدٌ':Added, #1: 1	دَفْعِ فَرْدٍ
u'دفع فَرِيضَةٌ':Added, #1: 1	دَفْعِ فَرْدٍ
u'دَفْعٌ فَرِيضَةٌ':Added, #1: 1	دَفْعِ الْفَرِيضَةِ
u'دفع فساد':Added, #1: 1	دَفْعِ الْفَرِيضَةِ
u'دفع فساد':Added, #1: 1	دَفْعَ الْفَسَادِ
u'دَفْعٌ فساد':Added, #1: 1	دَفْعُ الْفَسَادِ
u'دَفْعٌ فساد':Added, #1: 1	دَفْعَ الْفَسَادِ
u'دفع فَسَادٌ':Added, #1: 1	دَفْعُ الْفَسَادِ
u'دفع فَسَادٌ':Added, #1: 1	دَفْعَ الْفَسَادِ
u'دَفْعٌ فَسَادٌ':Added, #1: 1	دَفْعُ الْفَسَادِ
u'دَفْعٌ فَسَادٌ':Added, #1: 1	دَفْعَ الْفَسَادِ
u'دفع فساد':Added, #1: 1	دَفْعُ الْفَسَادِ
u'دَفْعٌ فساد':Added, #2: 2	دَفْعِ الْفَسَادِ
u'دفع فَسَادٌ':Added, #2: 2	دَفْعِ الْفَسَادِ
u'دَفْعٌ فَسَادٌ':Added, #2: 2	دَفْعِ الْفَسَادِ
u'دفع فَسْخٌ':Added, #2: 2	دَفْعِ الْفَسَادِ
u'دَفْعٌ فَسْخٌ':Added, #1: 1	دَفْعِ الْفَسْخِ
u'دَفَعَ فُسْطَاطٌ':Predicate, #1: 1	دَفْعِ الْفَسْخِ
u'دفع فَضْلٌ':Added, #2: 2	دَفَعَ الْفُسْطَاطَ
u'دَفْعٌ فَضْلٌ':Added, #1: 1	دَفْعُ الْفَضْلِ
u'دفع فَضْلٌ':Added, #1: 1	دَفْعُ الْفَضْلِ
u'دَفْعٌ فَضْلٌ':Added, #1: 1	دَفْعِ فَضْلِ
u'دفع فطرة':Added, #1: 1	دَفْعِ فَضْلِ
u'دَفْعٌ فطرة':Added, #1: 1	دَفْعُ الْفِطْرَةِ
u'دفع فِطْرَةٌ':Added, #1: 1	دَفْعُ الْفِطْرَةِ
u'دَفْعٌ فِطْرَةٌ':Added, #1: 1	دَفْعُ الْفِطْرَةِ
u'دَفَعَ فلان':Predicate, #1: 1	دَفْعُ الْفِطْرَةِ
u'دَفَعَ فلان':Predicate, #2: 2	دَفَعَ الرَّايَةَ
u'دَفَعَ فلان':Subject, #2: 2	دَفَعَ خَيْبَرَ
u'دَفَعَ فُلاَنٌ':Subject, #1: 1	دَفَعَ رِفَاعَةُ
u'دفع فلان':Added, #6: 6	دَفَعَ فُلَانٌ
u'دَفْعٌ فلان':Added, #1: 1	دَفْعُ الْمَكِّيَّاتِ
u'دَفَعَ قَارُورَةٌ':Predicate, #1: 1	دَفْعُ الْمَكِّيَّاتِ
u'دفع قتل':Added, #1: 1	دَفَعَ الْقَارُورَةَ
u'دَفْعٌ قتل':Added, #1: 1	دَفْعُ الْقَتْلِ
u'دفع قَتْلٌ':Added, #1: 1	دَفْعُ الْقَتْلِ
u'دَفْعٌ قَتْلٌ':Added, #1: 1	دَفْعُ الْقَتْلِ
u'دفع قَدْرٌ':Added, #1: 1	دَفْعُ الْقَتْلِ
u'دفع قَدْرٌ':Added, #1: 1	دَفْعُ قَدْرٍ
u'دَفْعٌ قَدْرٌ':Added, #1: 1	دَفْعِ قَدْرِ
u'دَفْعٌ قَدْرٌ':Added, #1: 1	دَفْعُ قَدْرٍ
u'دفع قُرَيْشٌ':Added, #1: 1	دَفْعِ قَدْرِ
u'دَفْعٌ قُرَيْشٌ':Added, #1: 1	دَفْعُ قُرَيْشٍ
u'دفع قَصْدٌ':Added, #1: 1	دَفْعُ قُرَيْشٍ
u'دَفْعٌ قَصْدٌ':Added, #1: 1	دَفْعُ قَصْدِ
u'دَفَعَ قَضَاءٌ':Predicate, #1: 1	دَفْعُ قَصْدِ
u'دفع قَطْعٌ':Added, #1: 1	دَفَعَ الْقَضَاءَ
u'دَفْعٌ قَطْعٌ':Added, #1: 1	دَفْعِ الْقَطْعِ
u'دَفَعَ قلب':Predicate, #1: 1	دَفْعِ الْقَطْعِ
u'دَفَعَ قَلْبٌ':Predicate, #2: 2	دَفَعَ الْقَلْبَ
u'دَفَعَ قَلْب':Predicate, #2: 2	دَفَعَ الْقَلْبَ
u'دَفَعَ قُوتٌ':Predicate, #2: 2	دَفَعَ الْقَلْبَ
u'دفع قُوتٌ':Added, #1: 1	دَفَعَ قُوتَ
u'دَفْعٌ قُوتٌ':Added, #1: 1	دَفْعُ الْقُوتِ
u'دفع قول':Added, #1: 1	دَفْعُ الْقُوتِ
u'دَفْعٌ قول':Added, #1: 1	دَفْعُ الْقَوْلِ
u'دفع قَوْلٌ':Added, #1: 1	دَفْعُ الْقَوْلِ
u'دَفْعٌ قَوْلٌ':Added, #1: 1	دَفْعُ الْقَوْلِ
u'دفع قول':Added, #1: 1	دَفْعُ الْقَوْلِ
u'دَفْعٌ قول':Added, #4: 4	دَفْعِ قَوْلِ
u'دفع قَوْلٌ':Added, #4: 4	دَفْعِ قَوْلِ
u'دَفْعٌ قَوْلٌ':Added, #4: 4	دَفْعِ قَوْلِ
u'دَفَعَ قَوْمٌ':Subject, #4: 4	دَفْعِ قَوْلِ
u'دفع قِيَاسٌ':Added, #1: 1	دَفَعَ قَوْمٌ
u'دَفْعٌ قِيَاسٌ':Added, #2: 2	دَفْعُ الْقِيَاسِ
u'دَفَعَ قِيَمٌ':Predicate, #2: 2	دَفْعُ الْقِيَاسِ
u'دَفَعَ قَيِّمٌ':Subject, #1: 1	دَفَعَ الْقِيَمَ
u'دفع قِيَمٌ':Added, #1: 1	دَفَعَ الْقَيِّمُ
u'دَفْعٌ قِيَمٌ':Added, #1: 1	دَفْعِ الْقِيَمِ
u'دفع قِيَمٌ':Added, #1: 1	دَفْعِ الْقِيَمِ
u'دَفْعٌ قِيَمٌ':Added, #2: 2	دَفْعُ الْقِيَمِ
u'دَفَعَ قِيمَةٌ':Predicate, #2: 2	دَفْعُ الْقِيَمِ
u'دَفَعَ قِيمَةٌ':Predicate, #14: 14	دَفَعَ الْقِيمَةَ
u'دفع قِيمَةٌ':Added, #3: 3	دَفَعَ قِيمَةَ
u'دَفْعٌ قِيمَةٌ':Added, #12: 12	دَفْعِ الْقِيمَةِ
u'دفع قِيمَةٌ':Added, #12: 12	دَفْعِ الْقِيمَةِ
u'دفع قِيمَةٌ':Added, #1: 1	دَفْعَ قِيمَتِهِ
u'دَفْعٌ قِيمَةٌ':Added, #1: 1	دَفْعُ قِيمَتِهِ
u'دَفْعٌ قِيمَةٌ':Added, #1: 1	دَفْعَ قِيمَتِهِ
u'دفع قِيمَةٌ':Added, #1: 1	دَفْعُ قِيمَتِهِ
u'دَفْعٌ قِيمَةٌ':Added, #3: 3	دَفْعِ قِيمَةِ
u'دفع قِيمَةٌ':Added, #3: 3	دَفْعِ قِيمَةِ
u'دَفْعٌ قِيمَةٌ':Added, #3: 3	دَفْعِ قِيمَتِهِ
u'دفع قِيمَةٌ':Added, #3: 3	دَفْعِ قِيمَتِهِ
u'دَفْعٌ قِيمَةٌ':Added, #5: 5	دَفْعُ قِيمَةِ
u'دفع قِيمَةٌ':Added, #5: 5	دَفْعُ قِيمَةِ
u'دَفْعٌ قِيمَةٌ':Added, #6: 6	دَفْعَ الْقِيمَةِ
u'دفع قِيمَةٌ':Added, #6: 6	دَفْعَ الْقِيمَةِ
u'دَفْعٌ قِيمَةٌ':Added, #7: 7	دَفْعُ الْقِيمَةِ
u'دفع كَامِلٌ':Added, #7: 7	دَفْعُ الْقِيمَةِ
u'دَفْعٌ كَامِلٌ':Added, #1: 1	دَفْعُ الْكَامِلِ
u'دَفَعَ كِتَابٌ':Predicate, #1: 1	دَفْعُ الْكَامِلِ
u'دفع كِتَابَةٌ':Added, #1: 1	دَفَعَ الْكِتَابَ
u'دَفْعٌ كِتَابَةٌ':Added, #1: 1	دَفْعِ الْكِتَابَةِ
u'دفع كِتَابَةٌ':Added, #1: 1	دَفْعِ الْكِتَابَةِ
u'دَفْعٌ كِتَابَةٌ':Added, #1: 1	دَفْعِ كِتَابَتِهِ
u'دَفَعَ كِرَاءٌ':Predicate, #1: 1	دَفْعِ كِتَابَتِهِ
u'دَفَعَ كِرَاءٌ':Predicate, #1: 1	دَفَعَ الْكِرَاءَ
u'دفع كِرَاءٌ':Added, #1: 1	دَفَعَ كِرَاءَ
u'دَفْعٌ كِرَاءٌ':Added, #1: 1	دَفْعُ الْكِرَاءِ
u'دفع كرائه':Added, #1: 1	دَفْعُ الْكِرَاءِ
u'دَفْعٌ كرائه':Added, #1: 1	دَفْعُ كِرَائِهِ
u'دَفَعَ كَرْمٌ':Predicate, #1: 1	دَفْعُ كِرَائِهِ
u'دفع كَفَّارٌ':Added, #2: 2	دَفَعَ الْكَرْمَ
u'دفع كَفَّارٌ':Added, #1: 1	دَفْعُ الْكَفَّارَةِ
u'دَفْعٌ كَفَّارٌ':Added, #1: 1	دَفْعِ الْكَفَّارَةِ
u'دَفْعٌ كَفَّارٌ':Added, #1: 1	دَفْعُ الْكَفَّارَةِ
u'دفع كَفَّارٌ':Added, #1: 1	دَفْعِ الْكَفَّارَةِ
u'دَفْعٌ كَفَّارٌ':Added, #2: 2	دَفْعُ الْكَفَّارَاتِ
u'دفع كَفَّارَةٌ':Added, #2: 2	دَفْعُ الْكَفَّارَاتِ
u'دفع كَفَّارَةٌ':Added, #1: 1	دَفْعُ الْكَفَّارَةِ
u'دَفْعٌ كَفَّارَةٌ':Added, #1: 1	دَفْعِ الْكَفَّارَةِ
u'دَفْعٌ كَفَّارَةٌ':Added, #1: 1	دَفْعُ الْكَفَّارَةِ
u'دفع كَفَّارَةٌ':Added, #1: 1	دَفْعِ الْكَفَّارَةِ
u'دَفْعٌ كَفَّارَةٌ':Added, #2: 2	دَفْعُ الْكَفَّارَاتِ
u'دَفَعَ كَفِيلٌ':Subject, #2: 2	دَفْعُ الْكَفَّارَاتِ
u'دفع كَفِيلٌ':Added, #4: 4	دَفَعَ الْكَفِيلُ
u'دَفْعٌ كَفِيلٌ':Added, #1: 1	دَفْعِ الْكَفِيلِ
u'دفع كُلْفَةٌ':Added, #1: 1	دَفْعِ الْكَفِيلِ
u'دَفْعٌ كُلْفَةٌ':Added, #1: 1	دَفْعُ كُلْفَةِ
u'دَفَعَ لَحْمٌ':Predicate, #1: 1	دَفْعُ كُلْفَةِ
u'دفع لِصٌّ':Added, #1: 1	دَفَعَ لَحْمَ
u'دَفْعٌ لِصٌّ':Added, #1: 1	دَفْعِ اللِّصِّ
u'دفع لعان':Added, #1: 1	دَفْعِ اللِّصِّ
u'دَفْعٌ لعان':Added, #1: 1	دَفْعِ اللِّعَانِ
u'دَفَعَ لقطة':Predicate, #1: 1	دَفْعِ اللِّعَانِ
u'دفع لُقْمَةٌ':Added, #1: 1	دَفَعَ اللُّقَطَةَ
u'دَفْعٌ لُقْمَةٌ':Added, #1: 1	دَفْعِ لُقْمَةٍ
u'دفع مَاءٌ':Added, #1: 1	دَفْعِ لُقْمَةٍ
u'دفع مَاءٌ':Added, #1: 1	دَفْعَ الْمَاءِ
u'دَفْعٌ مَاءٌ':Added, #1: 1	دَفْعُ الْمَاءِ
u'دَفْعٌ مَاءٌ':Added, #1: 1	دَفْعَ الْمَاءِ
u'دفع مَارٌّ':Added, #1: 1	دَفْعُ الْمَاءِ
u'دَفْعٌ مَارٌّ':Added, #1: 1	دَفْعَ الْمَارِّ
u'دفع مَارٌّ':Added, #1: 1	دَفْعَ الْمَارِّ
u'دَفْعٌ مَارٌّ':Added, #1: 1	دَفْعِ مَارٍّ
u'دَفَعَ مَالٌ':Predicate, #1: 1	دَفْعِ مَارٍّ
u'دَفَعَ مَالٌ':Predicate, #11: 11	دَفَعَ مَالَ
u'دَفَعَ مَالٌ':Predicate, #1: 1	دَفَعَ مَالاً
u'دفع مَالٌ':Added, #42: 42	دَفَعَ الْمَالَ
u'دَفْعٌ مَالٌ':Added, #1: 1	دَفْعِ الْمَالَيْنِ
u'دفع مَالٌ':Added, #1: 1	دَفْعِ الْمَالَيْنِ
u'دَفْعٌ مَالٌ':Added, #1: 1	دَفْعَ مَالِهِ
u'دفع مَالٌ':Added, #1: 1	دَفْعَ مَالِهِ
u'دفع مَالٌ':Added, #2: 2	دَفْعُ مَالٍ
u'دفع مَالٌ':Added, #2: 2	دَفْعُ مَالِ
u'دَفْعٌ مَالٌ':Added, #2: 2	دَفْعِ مَالٍ
u'دَفْعٌ مَالٌ':Added, #2: 2	دَفْعُ مَالٍ
u'دَفْعٌ مَالٌ':Added, #2: 2	دَفْعُ مَالِ
u'دفع مَالٌ':Added, #2: 2	دَفْعِ مَالٍ
u'دَفْعٌ مَالٌ':Added, #2: 2	دَفْعِ مَالِهِ
u'دفع مَالٌ':Added, #2: 2	دَفْعِ مَالِهِ
u'دَفْعٌ مَالٌ':Added, #30: 30	دَفْعِ الْمَالِ
u'دفع مَالٌ':Added, #30: 30	دَفْعِ الْمَالِ
u'دَفْعٌ مَالٌ':Added, #3: 3	دَفْعَ مَالٍ
u'دفع مَالٌ':Added, #3: 3	دَفْعَ مَالٍ
u'دَفْعٌ مَالٌ':Added, #3: 3	دَفْعُ مَالِهِ
u'دفع مَالٌ':Added, #3: 3	دَفْعُ مَالِهِ
u'دَفْعٌ مَالٌ':Added, #6: 6	دَفْعَ الْمَالِ
u'دفع مَالٌ':Added, #6: 6	دَفْعَ الْمَالِ
u'دَفْعٌ مَالٌ':Added, #8: 8	دَفْعُ الْمَالِ
u'دَفَعَ مَالِكٌ':Subject, #8: 8	دَفْعُ الْمَالِ
u'دفع مَالِكٌ':Added, #5: 5	دَفَعَ الْمَالِكُ
u'دَفْعٌ مَالِكٌ':Added, #1: 1	دَفْعِ الْمَالِكِ
u'دَفَعَ مَأْمُورٌ':Subject, #1: 1	دَفْعِ الْمَالِكِ
u'دفع مَانِعٌ':Added, #1: 1	دَفَعَ الْمَأْمُورُ
u'دَفْعٌ مَانِعٌ':Added, #1: 1	دَفْعُ الْمَانِعِ
u'دَفَعَ مُبْتاع':Subject, #1: 1	دَفْعُ الْمَانِعِ
u'دَفَعَ مَبِيعٌ':Predicate, #1: 1	دَفَعَ مُبْتَاعُ
u'دفع مَبِيعٌ':Added, #4: 4	دَفَعَ الْمَبِيعَ
u'دَفْعٌ مَبِيعٌ':Added, #1: 1	دَفْعِ الْمَبِيعِ
u'دَفَعَ مَتَاعٌ':Predicate, #1: 1	دَفْعِ الْمَبِيعِ
u'دفع مُتَحَقِّق':Added, #1: 1	دَفَعَ مَتَاعَ
u'دَفْعٌ مُتَحَقِّق':Added, #1: 1	دَفْعِ الْمُتَحَقِّقِ
u'دَفَعَ مثل':Predicate, #1: 1	دَفْعِ الْمُتَحَقِّقِ
u'دَفَعَ مِثْلٌ':Predicate, #1: 1	دَفَعَ الْمِثْلَ
u'دفع مثل':Added, #1: 1	دَفَعَ الْمِثْلَ
u'دَفْعٌ مثل':Added, #1: 1	دَفْعُ مِثْلِ
u'دفع مِثْلٌ':Added, #1: 1	دَفْعُ مِثْلِ
u'دَفْعٌ مِثْلٌ':Added, #1: 1	دَفْعُ مِثْلِ
u'دفع مثل':Added, #1: 1	دَفْعُ مِثْلِ
u'دفع مثل':Added, #1: 1	دَفْعَ مِثْلِهِ
u'دَفْعٌ مثل':Added, #1: 1	دَفْعُ مِثْلِهِ
u'دَفْعٌ مثل':Added, #1: 1	دَفْعَ مِثْلِهِ
u'دفع مِثْلٌ':Added, #1: 1	دَفْعُ مِثْلِهِ
u'دفع مِثْلٌ':Added, #1: 1	دَفْعَ مِثْلِهِ
u'دَفْعٌ مِثْلٌ':Added, #1: 1	دَفْعُ مِثْلِهِ
u'دَفْعٌ مِثْلٌ':Added, #1: 1	دَفْعَ مِثْلِهِ
u'دفع مثل':Added, #1: 1	دَفْعُ مِثْلِهِ
u'دَفْعٌ مثل':Added, #2: 2	دَفْعِ مِثْلِ
u'دفع مِثْلٌ':Added, #2: 2	دَفْعِ مِثْلِ
u'دَفْعٌ مِثْلٌ':Added, #2: 2	دَفْعِ مِثْلِ
u'دفع مثل':Added, #2: 2	دَفْعِ مِثْلِ
u'دَفْعٌ مثل':Added, #2: 2	دَفْعِ مِثْلِهِ
u'دفع مِثْلٌ':Added, #2: 2	دَفْعِ مِثْلِهِ
u'دَفْعٌ مِثْلٌ':Added, #2: 2	دَفْعِ مِثْلِهِ
u'دفع مُحْتَالٌ':Added, #2: 2	دَفْعِ مِثْلِهِ
u'دَفْعٌ مُحْتَالٌ':Added, #2: 2	دَفْعِ الْمُحْتَالِ
u'دفع مَحْذُور':Added, #2: 2	دَفْعِ الْمُحْتَالِ
u'دَفْعٌ مَحْذُور':Added, #1: 1	دَفْعِ الْمَحْذُورِ
u'دَفَعَ مُحِيل':Subject, #1: 1	دَفْعِ الْمَحْذُورِ
u'دَفَعَ مُخَالَفَةٌ':Predicate, #1: 1	دَفَعَ الْمُحِيلُ
u'دفع مُخَالَفَةٌ':Added, #1: 1	دَفَعَ الْمُخَالَفَةَ
u'دَفْعٌ مُخَالَفَةٌ':Added, #1: 1	دَفْعُ الْمُخَالَفَةِ
u'دَفَعَ مَدْيُونٌ':Subject, #1: 1	دَفْعُ الْمُخَالَفَةِ
u'دفع مَذَمَّةٌ':Added, #3: 3	دَفَعَ الْمَدْيُونُ
u'دَفْعٌ مَذَمَّةٌ':Added, #1: 1	دَفْعُ الْمَذَمَّةِ
u'دَفَعَ مَذْهَبٌ':Predicate, #1: 1	دَفْعُ الْمَذَمَّةِ
u'دَفَعَ مرٌّ':Predicate, #1: 1	دَفَعَ مَذْهَبَ
u'دَفَعَ مُرْتَدٌّ':Subject, #2: 2	دَفَعَ مَرَّةً
u'دَفَعَ مُرْتَهِنٌ':Subject, #1: 1	دَفَعَ الْمُرْتَدُّ
u'دفع مَرَضٌ':Added, #1: 1	دَفَعَ الْمُرْتَهِنُ
u'دَفْعٌ مَرَضٌ':Added, #1: 1	دَفْعِ الْمَرَضِ
u'دَفَعَ مَرْهُونٌ':Predicate, #1: 1	دَفْعِ الْمَرَضِ
u'دَفَعَ مَرِيضٌ':Subject, #1: 1	دَفَعَ الْمَرْهُونَ
u'دفع مُزَاحَمَةٌ':Added, #6: 6	دَفَعَ الْمَرِيضُ
u'دَفْعٌ مُزَاحَمَةٌ':Added, #1: 1	دَفْعِ مُزَاحَمَةِ
u'دَفَعَ مُزَارِعٌ':Subject, #1: 1	دَفْعِ مُزَاحَمَةِ
u'دفع مُزَارِعٌ':Added, #2: 2	دَفَعَ الْمُزَارِعُ
u'دَفْعٌ مُزَارِعٌ':Added, #1: 1	دَفْعِ الْمُزَارِعِ
u'دفع مُساقاة':Added, #1: 1	دَفْعِ الْمُزَارِعِ
u'دَفْعٌ مُساقاة':Added, #2: 2	دَفْعُ الْمُسَاقَاةِ
u'دَفَعَ مُسْتَأْجِرٌ':Subject, #2: 2	دَفْعُ الْمُسَاقَاةِ
u'دَفَعَ مُسَلَّمٌ':Predicate, #1: 1	دَفَعَ الْمُسْتَأْجِرُ
u'دَفَعَ مُسْلِمٌ':Subject, #1: 1	دَفَعَ الْمُسَلَّمَ
u'دفع مُسْلِمٌ':Added, #3: 3	دَفَعَ الْمُسْلِمُ
u'دَفْعٌ مُسْلِمٌ':Added, #1: 1	دَفْعُ مُسْلِمٍ
u'دفع مُسْلِمٌ':Added, #1: 1	دَفْعُ مُسْلِمٍ
u'دَفْعٌ مُسْلِمٌ':Added, #2: 2	دَفْعِ الْمُسْلِمِ
u'دفع مُشَارَكَةٌ':Added, #2: 2	دَفْعِ الْمُسْلِمِ
u'دَفْعٌ مُشَارَكَةٌ':Added, #1: 1	دَفْعِ مُشَارَكَتِهِ
u'دَفَعَ مَشْرُوطٌ':Subject, #1: 1	دَفْعِ مُشَارَكَتِهِ
u'دفع مُصْحَفٌ':Added, #1: 1	دَفَعَ الْمَشْرُوطُ
u'دَفْعٌ مُصْحَفٌ':Added, #1: 1	دَفْعَ الْمُصْحَفِ
u'دفع مُصْحَفٌ':Added, #1: 1	دَفْعَ الْمُصْحَفِ
u'دَفْعٌ مُصْحَفٌ':Added, #2: 2	دَفْعِ الْمُصْحَفِ
u'دفع مَضَارُّ':Added, #2: 2	دَفْعِ الْمُصْحَفِ
u'دفع مَضَارُّ':Added, #1: 1	دَفْعَ الْمَضَارِّ
u'دَفْعٌ مَضَارُّ':Added, #1: 1	دَفْعِ الْمَضَارِّ
u'دَفْعٌ مَضَارُّ':Added, #1: 1	دَفْعَ الْمَضَارِّ
u'دَفَعَ مُضَارِبٌ':Subject, #1: 1	دَفْعِ الْمَضَارِّ
u'دفع مُضَارِبٌ':Added, #5: 5	دَفَعَ الْمُضَارِبُ
u'دَفْعٌ مُضَارِبٌ':Added, #1: 1	دَفْعُ الْمُضَارِبِ
u'دفع مَضَرَّةٌ':Added, #1: 1	دَفْعُ الْمُضَارِبِ
u'دَفْعٌ مَضَرَّةٌ':Added, #1: 1	دَفْعُ الْمَضَرَّةِ
u'دفع مَضَرَّةٌ':Added, #1: 1	دَفْعُ الْمَضَرَّةِ
u'دفع مَضَرَّةٌ':Added, #2: 2	دَفْعَ مَضَرَّةٍ
u'دَفْعٌ مَضَرَّةٌ':Added, #2: 2	دَفْعُ مَضَرَّةٍ
u'دَفْعٌ مَضَرَّةٌ':Added, #2: 2	دَفْعَ مَضَرَّةٍ
u'دفع مَضَرَّةٌ':Added, #2: 2	دَفْعُ مَضَرَّةٍ
u'دَفْعٌ مَضَرَّةٌ':Added, #4: 4	دَفْعِ مَضَرَّةٍ
u'دفع مُطَالَبٌ':Added, #4: 4	دَفْعِ مَضَرَّةٍ
u'دَفْعٌ مُطَالَبٌ':Added, #1: 1	دَفْعِ الْمُطَالَبَةِ
u'دفع مُطَالَبَةٌ':Added, #1: 1	دَفْعِ الْمُطَالَبَةِ
u'دَفْعٌ مُطَالَبَةٌ':Added, #1: 1	دَفْعِ الْمُطَالَبَةِ
u'دفع مَطَرٌ':Added, #1: 1	دَفْعِ الْمُطَالَبَةِ
u'دَفْعٌ مَطَرٌ':Added, #1: 1	دَفْعِ الْمَطَرِ
u'دَفَعَ مَطْلُوبٌ':Predicate, #1: 1	دَفْعِ الْمَطَرِ
u'دَفَعَ مَطْلُوبٌ':Subject, #1: 1	دَفَعَ الْمَطْلُوبَ
u'دفع مُعَارَضَةٌ':Added, #6: 6	دَفَعَ الْمَطْلُوبُ
u'دَفْعٌ مُعَارَضَةٌ':Added, #1: 1	دَفْعِ الْمُعَارَضَاتِ
u'دفع مُعَارَضَةٌ':Added, #1: 1	دَفْعِ الْمُعَارَضَاتِ
u'دَفْعٌ مُعَارَضَةٌ':Added, #3: 3	دَفْعِ الْمُعَارَضَةِ
u'دفع مُعَجَّلٌ':Added, #3: 3	دَفْعِ الْمُعَارَضَةِ
u'دَفْعٌ مُعَجَّلٌ':Added, #1: 1	دَفْعِ الْمُعَجَّلِ
u'دفع مَعْدِنٌ':Added, #1: 1	دَفْعِ الْمُعَجَّلِ
u'دَفْعٌ مَعْدِنٌ':Added, #1: 1	دَفْعُ الْمَعْدِنِ
u'دفع مَعْصِيَةٌ':Added, #1: 1	دَفْعُ الْمَعْدِنِ
u'دَفْعٌ مَعْصِيَةٌ':Added, #1: 1	دَفْعُ مَعْصِيَةٍ
u'دَفَعَ مَغْصُوب':Subject, #1: 1	دَفْعُ مَعْصِيَةٍ
u'دَفَعَ مَفَاتِيحُ':Predicate, #1: 1	دَفَعَ الْمَغْصُوبُ
u'دفع مَفَاسِدُ':Added, #1: 1	دَفَعَ الْمَفَاتِيحَ
u'دفع مَفَاسِدُ':Added, #1: 1	دَفْعَ الْمَفَاسِدِ
u'دَفْعٌ مَفَاسِدُ':Added, #1: 1	دَفْعِ الْمَفَاسِدِ
u'دَفْعٌ مَفَاسِدُ':Added, #1: 1	دَفْعَ الْمَفَاسِدِ
u'دَفَعَ مِفْتَاحٌ':Predicate, #1: 1	دَفْعِ الْمَفَاسِدِ
u'دفع مِفْتَاحٌ':Added, #1: 1	دَفَعَ الْمِفْتَاحَ
u'دَفْعٌ مِفْتَاحٌ':Added, #1: 1	دَفْعُ الْمِفْتَاحِ
u'دفع مُفْسِدٌ':Added, #1: 1	دَفْعُ الْمِفْتَاحِ
u'دَفْعٌ مُفْسِدٌ':Added, #1: 1	دَفْعِ مُفْسِدَةٍ
u'دفع مَفْسَدَةٌ':Added, #1: 1	دَفْعِ مُفْسِدَةٍ
u'دفع مَفْسَدَةٌ':Added, #1: 1	دَفْعَ الْمَفْسَدَةِ
u'دَفْعٌ مَفْسَدَةٌ':Added, #1: 1	دَفْعُ الْمَفْسَدَةِ
u'دَفْعٌ مَفْسَدَةٌ':Added, #1: 1	دَفْعَ الْمَفْسَدَةِ
u'دفع مَفْسَدَةٌ':Added, #1: 1	دَفْعُ الْمَفْسَدَةِ
u'دفع مَفْسَدَةٌ':Added, #1: 1	دَفْعَ مَفْسَدَةِ
u'دَفْعٌ مَفْسَدَةٌ':Added, #1: 1	دَفْعُ مَفْسَدَةٍ
u'دَفْعٌ مَفْسَدَةٌ':Added, #1: 1	دَفْعَ مَفْسَدَةِ
u'دفع مَفْسَدَةٌ':Added, #1: 1	دَفْعُ مَفْسَدَةٍ
u'دَفْعٌ مَفْسَدَةٌ':Added, #2: 2	دَفْعِ الْمَفْسَدَةِ
u'دفع مَفْسَدَةٌ':Added, #2: 2	دَفْعِ الْمَفْسَدَةِ
u'دَفْعٌ مَفْسَدَةٌ':Added, #2: 2	دَفْعِ مَفْسَدَةِ
u'دفع مَفْسَدَةٌ':Added, #2: 2	دَفْعِ مَفْسَدَةِ
u'دَفْعٌ مَفْسَدَةٌ':Added, #5: 5	دَفْعِ مَفْسَدَةٍ
u'دفع مُقَابِلٌ':Added, #5: 5	دَفْعِ مَفْسَدَةٍ
u'دَفْعٌ مُقَابِلٌ':Added, #2: 2	دَفْعِ مُقَابِلِهِ
u'دفع مَقَادِيرُ':Added, #2: 2	دَفْعِ مُقَابِلِهِ
u'دَفْعٌ مَقَادِيرُ':Added, #1: 1	دَفْعَ الْمَقَادِيرِ
u'دَفَعَ مِقْدَارٌ':Predicate, #1: 1	دَفْعَ الْمَقَادِيرِ
u'دَفَعَ مُقْرِضٌ':Subject, #1: 1	دَفَعَ مِقْدَارَ
u'دفع مُقْرِضٌ':Added, #1: 1	دَفَعَ الْمُقْرِضُ
u'دَفْعٌ مُقْرِضٌ':Added, #1: 1	دَفْعَ الْمُقْرِضِ
u'دَفَعَ مَكَانٌ':Predicate, #1: 1	دَفْعَ الْمُقْرِضِ
u'دفع مُكْرَهٌ':Added, #1: 1	دَفَعَ مَكَانَ
u'دفع مُكْرِهٌ':Added, #2: 2	دَفْعُ الْمُكْرَهِ
u'دَفْعٌ مُكْرَهٌ':Added, #2: 2	دَفْعُ الْمُكْرِهِ
u'دَفْعٌ مُكْرِهٌ':Added, #2: 2	دَفْعُ الْمُكْرَهِ
u'دَفَعَ مَكْرُوهٌ':Predicate, #2: 2	دَفْعُ الْمُكْرِهِ
u'دفع مَكْسٌ':Added, #1: 1	دَفَعَ مَكْرُوهَ
u'دَفْعٌ مَكْسٌ':Added, #1: 1	دَفْعُ مَكْسٍ
u'دفع مَكْسٌ':Added, #1: 1	دَفْعُ مَكْسٍ
u'دَفْعٌ مَكْسٌ':Added, #2: 2	دَفْعِ مَكْسٍ
u'دَفَعَ مَكْفُولٌ':Predicate, #2: 2	دَفْعِ مَكْسٍ
u'دَفَعَ مَكْفُولٌ':Subject, #1: 1	دَفَعَ الْمَكْفُولَ
u'دفع مَكْفُولٌ':Added, #1: 1	دَفَعَ الْمَكْفُولُ
u'دفع مَكْفُولٌ':Added, #1: 1	دَفْعَ الْمَكْفُولِ
u'دَفْعٌ مَكْفُولٌ':Added, #1: 1	دَفْعِ الْمَكْفُولِ
u'دَفْعٌ مَكْفُولٌ':Added, #1: 1	دَفْعَ الْمَكْفُولِ
u'دفع مَكِّيّ':Added, #1: 1	دَفْعِ الْمَكْفُولِ
u'دَفْعٌ مَكِّيّ':Added, #1: 1	دَفْعُ الْمَكِّيَّاتِ
u'دَفَعَ مَكِيل':Predicate, #1: 1	دَفْعُ الْمَكِّيَّاتِ
u'دَفَعَ مُلْتَقِط':Subject, #1: 1	دَفَعَ مَكِيلَةً
u'دَفَعَ مِلْكٌ':Predicate, #2: 2	دَفَعَ الْمُلْتَقِطُ
u'دَفَعَ مِلْكٌ':Predicate, #1: 1	دَفَعَ الْمِلْكَ
u'دفع مُنَازَعٌ':Added, #1: 1	دَفَعَ مِلْكَ
u'دَفْعٌ مُنَازَعٌ':Added, #1: 1	دَفْعُ الْمُنَازَعَةِ
u'دفع مُنَازَعَةٌ':Added, #1: 1	دَفْعُ الْمُنَازَعَةِ
u'دَفْعٌ مُنَازَعَةٌ':Added, #1: 1	دَفْعُ الْمُنَازَعَةِ
u'دَفَعَ مُنافاة':Predicate, #1: 1	دَفْعُ الْمُنَازَعَةِ
u'دفع مُنافاة':Added, #1: 1	دَفَعَ الْمُنَافَاةَ
u'دفع مُنافاة':Added, #3: 3	دَفْعُ الْمُنَافَاةِ
u'دَفْعٌ مُنافاة':Added, #3: 3	دَفْعِ الْمُنَافَاةِ
u'دَفْعٌ مُنافاة':Added, #3: 3	دَفْعُ الْمُنَافَاةِ
u'دفع مُنَاقَضَةٌ':Added, #3: 3	دَفْعِ الْمُنَافَاةِ
u'دَفْعٌ مُنَاقَضَةٌ':Added, #1: 1	دَفْعُ الْمُنَاقَضَةِ
u'دفع مُنَاقَضَةٌ':Added, #1: 1	دَفْعُ الْمُنَاقَضَةِ
u'دَفْعٌ مُنَاقَضَةٌ':Added, #2: 2	دَفْعِ الْمُنَاقَضَةِ
u'دَفَعَ مَنْصُوصٌ':Predicate, #2: 2	دَفْعِ الْمُنَاقَضَةِ
u'دفع مُنْكَرٌ':Added, #1: 1	دَفَعَ الْمَنْصُوصَ
u'دَفْعٌ مُنْكَرٌ':Added, #1: 1	دَفْعِ مُنْكَرٍ
u'دَفَعَ مَهْرٌ':Predicate, #1: 1	دَفْعِ مُنْكَرٍ
u'دَفَعَ مَهْرٌ':Predicate, #1: 1	دَفَعَ الْمَهْرَ
u'دفع مَهْرٌ':Added, #1: 1	دَفَعَ مَهْرَ
u'دفع مَهْرٌ':Added, #1: 1	دَفْعَ الْمَهْرِ
u'دفع مَهْرٌ':Added, #1: 1	دَفْعُ الْمَهْرِ
u'دَفْعٌ مَهْرٌ':Added, #1: 1	دَفْعِ الْمَهْرِ
u'دَفْعٌ مَهْرٌ':Added, #1: 1	دَفْعَ الْمَهْرِ
u'دَفْعٌ مَهْرٌ':Added, #1: 1	دَفْعُ الْمَهْرِ
u'دفع مَهْرٌ':Added, #1: 1	دَفْعِ الْمَهْرِ
u'دَفْعٌ مَهْرٌ':Added, #1: 1	دَفْعُ مَهْرٍ
u'دفع مُهْلِكٌ':Added, #1: 1	دَفْعُ مَهْرٍ
u'دَفْعٌ مُهْلِكٌ':Added, #1: 1	دَفْعُ الْمُهْلِكَاتِ
u'دَفَعَ مُؤَاخَذَةٌ':Predicate, #1: 1	دَفْعُ الْمُهْلِكَاتِ
u'دفع مُؤَاخَذَةٌ':Added, #1: 1	دَفَعَ الْمُؤَاخَذَةَ
u'دَفْعٌ مُؤَاخَذَةٌ':Added, #1: 1	دَفْعِ الْمُؤَاخَذَةِ
u'دفع مُوَاظَبَةٌ':Added, #1: 1	دَفْعِ الْمُؤَاخَذَةِ
u'دَفْعٌ مُوَاظَبَةٌ':Added, #1: 1	دَفْعِ الْمُوَاظَبَةِ
u'دفع مُؤَثِّرٌ':Added, #1: 1	دَفْعِ الْمُوَاظَبَةِ
u'دَفْعٌ مُؤَثِّرٌ':Added, #1: 1	دَفْعِ الْمُؤَثِّرَةِ
u'دفع مَوْجُودٌ':Added, #1: 1	دَفْعِ الْمُؤَثِّرَةِ
u'دَفْعٌ مَوْجُودٌ':Added, #1: 1	دَفْعِ الْمَوْجُودِ
u'دَفَعَ مُودِعٌ':Predicate, #1: 1	دَفْعِ الْمَوْجُودِ
u'دَفَعَ مُودِعٌ':Subject, #1: 1	دَفَعَ الْمُودِعَ
u'دَفَعَ مُودَعٌ':Subject, #1: 1	دَفَعَ الْمُودِعُ
u'دَفَعَ مُوَكَّلٌ':Subject, #6: 6	دَفَعَ الْمُودَعُ
u'دَفَعَ مُوَكِّلٌ':Subject, #1: 1	دَفَعَ الْمُوَكَّلُ
u'دفع مُؤَلِّفٌ':Added, #4: 4	دَفَعَ الْمُوَكِّلُ
u'دَفْعٌ مُؤَلِّفٌ':Added, #1: 1	دَفْعُ الْمُؤَلِّفِ
u'دفع نَازِعٌ':Added, #1: 1	دَفْعُ الْمُؤَلِّفِ
u'دَفْعٌ نَازِعٌ':Added, #1: 1	دَفْعِ النَّازِعِ
u'دفع نَاسٌ':Added, #1: 1	دَفْعِ النَّازِعِ
u'دَفْعٌ نَاسٌ':Added, #1: 1	دَفْعِ النَّاسِ
u'دَفَعَ نَبِيٌّ':Subject, #1: 1	دَفْعِ النَّاسِ
u'دَفَعَ نَجَاسَةٌ':Predicate, #1: 1	دَفَعَ النَّبِيُّ
u'دفع نَجَاسَةٌ':Added, #1: 1	دَفَعَ النَّجَاسَةَ
u'دَفْعٌ نَجَاسَةٌ':Added, #2: 2	دَفْعَ النَّجَاسَةِ
u'دفع نَجَاسَةٌ':Added, #2: 2	دَفْعَ النَّجَاسَةِ
u'دَفْعٌ نَجَاسَةٌ':Added, #8: 8	دَفْعِ النَّجَاسَةِ
u'دَفَعَ نُجُومٌ':Predicate, #8: 8	دَفْعِ النَّجَاسَةِ
u'دَفَعَ نَخْلٌ':Predicate, #1: 1	دَفَعَ النُّجُومَ
u'دفع نَخْلٌ':Added, #1: 1	دَفَعَ النَّخْلَ
u'دَفْعٌ نَخْلٌ':Added, #1: 1	دَفْعُ النَّخْلِ
u'دَفَعَ نَخِيلٌ':Predicate, #1: 1	دَفْعُ النَّخْلِ
u'دَفَعَ نَخِيلٌ':Predicate, #1: 1	دَفَعَ النَّخِيلَ
u'دفع نصاب':Added, #1: 1	دَفَعَ نَخِيلَ
u'دَفْعٌ نصاب':Added, #1: 1	دَفْعَ النِّصَابِ
u'دفع نِصَابٌ':Added, #1: 1	دَفْعَ النِّصَابِ
u'دَفْعٌ نِصَابٌ':Added, #1: 1	دَفْعَ النِّصَابِ
u'دَفَعَ نِصْفٌ':Predicate, #1: 1	دَفْعَ النِّصَابِ
u'دَفَعَ نِصْفٌ':Predicate, #6: 6	دَفَعَ النِّصْفَ
u'دفع نِصْفٌ':Added, #6: 6	دَفَعَ نِصْفَ
u'دَفْعٌ نِصْفٌ':Added, #1: 1	دَفْعِ نِصْفِهِ
u'دفع نِصْفٌ':Added, #1: 1	دَفْعِ نِصْفِهِ
u'دَفْعٌ نِصْفٌ':Added, #2: 2	دَفْعُ نِصْفِ
u'دفع نِصْفٌ':Added, #2: 2	دَفْعُ نِصْفِ
u'دَفْعٌ نِصْفٌ':Added, #3: 3	دَفْعِ النِّصْفِ
u'دفع نِصْفٌ':Added, #3: 3	دَفْعِ النِّصْفِ
u'دَفْعٌ نِصْفٌ':Added, #3: 3	دَفْعَ نِصْفِ
u'دفع نِصْفٌ':Added, #3: 3	دَفْعَ نِصْفِ
u'دَفْعٌ نِصْفٌ':Added, #5: 5	دَفْعِ نِصْفِ
u'دفع نَصِيبٌ':Added, #5: 5	دَفْعِ نِصْفِ
u'دفع نَصِيبٌ':Added, #1: 1	دَفْعُ نَصِيبِ
u'دَفْعٌ نَصِيبٌ':Added, #1: 1	دَفْعِ نَصِيبِ
u'دَفْعٌ نَصِيبٌ':Added, #1: 1	دَفْعُ نَصِيبِ
u'دفع نَصِيبٌ':Added, #1: 1	دَفْعِ نَصِيبِ
u'دَفْعٌ نَصِيبٌ':Added, #1: 1	دَفْعِ نَصِيبِهِ
u'دَفَعَ نَظَرٌ':Predicate, #1: 1	دَفْعِ نَصِيبِهِ
u'دفع نعاس':Added, #1: 1	دَفَعَ النَّظَرَ
u'دَفْعٌ نعاس':Added, #3: 3	دَفْعِ النُّعَاسِ
u'دفع نُعَاسٌ':Added, #3: 3	دَفْعِ النُّعَاسِ
u'دَفْعٌ نُعَاسٌ':Added, #3: 3	دَفْعِ النُّعَاسِ
u'دَفَعَ نَعْجَةٌ':Predicate, #3: 3	دَفْعِ النُّعَاسِ
u'دفع نَفْسٌ':Added, #1: 1	دَفَعَ النَّعْجَةَ
u'دَفْعٌ نَفْسٌ':Added, #1: 1	دَفْعِ نَفْسِ
u'دَفَعَ نَفَقَةٌ':Predicate, #1: 1	دَفْعِ نَفْسِ
u'دَفَعَ نَفَقَةٌ':Predicate, #1: 1	دَفَعَ النَّفَقَةَ
u'دفع نَفَقَةٌ':Added, #3: 3	دَفَعَ نَفَقَةَ
u'دَفْعٌ نَفَقَةٌ':Added, #1: 1	دَفْعِ النَّفَقَةِ
u'دفع نَفَقَةٌ':Added, #1: 1	دَفْعِ النَّفَقَةِ
u'دَفْعٌ نَفَقَةٌ':Added, #1: 1	دَفْعِ نَفَقَةٍ
u'دفع نَفَقَةٌ':Added, #1: 1	دَفْعِ نَفَقَةٍ
u'دَفْعٌ نَفَقَةٌ':Added, #3: 3	دَفْعُ النَّفَقَةِ
u'دَفَعَ نَقْدٌ':Predicate, #3: 3	دَفْعُ النَّفَقَةِ
u'دَفَعَ نَقْد':Predicate, #1: 1	دَفَعَ نَقْدَ
u'دفع نَقْدٌ':Added, #1: 1	دَفَعَ نَقْدَ
u'دفع نَقْد':Added, #1: 1	دَفْعُ النَّقْدِ
u'دَفْعٌ نَقْدٌ':Added, #1: 1	دَفْعُ النَّقْدِ
u'دَفْعٌ نَقْد':Added, #1: 1	دَفْعُ النَّقْدِ
u'دفع نَقْصٌ':Added, #1: 1	دَفْعُ النَّقْدِ
u'دَفْعٌ نَقْصٌ':Added, #1: 1	دَفْعَ النَّقْصِ
u'دَفَعَ نَقْضٌ':Predicate, #1: 1	دَفْعَ النَّقْصِ
u'دفع نَقْضٌ':Added, #1: 1	دَفَعَ النَّقْضَ
u'دَفْعٌ نَقْضٌ':Added, #1: 1	دَفْعِ النَّقْضِ
u'دفع نَقْضٌ':Added, #1: 1	دَفْعِ النَّقْضِ
u'دَفْعٌ نَقْضٌ':Added, #5: 5	دَفْعُ النَّقْضِ
u'دفع نقمة':Added, #5: 5	دَفْعُ النَّقْضِ
u'دَفْعٌ نقمة':Added, #4: 4	دَفْعِ نِقْمَةٍ
u'دفع نِقْمَةٌ':Added, #4: 4	دَفْعِ نِقْمَةٍ
u'دَفْعٌ نِقْمَةٌ':Added, #4: 4	دَفْعِ نِقْمَةٍ
u'دفع نُقُوضٌ':Added, #4: 4	دَفْعِ نِقْمَةٍ
u'دَفْعٌ نُقُوضٌ':Added, #1: 1	دَفْعِ النُّقُوضِ
u'دفع نكاح':Added, #1: 1	دَفْعِ النُّقُوضِ
u'دَفْعٌ نكاح':Added, #1: 1	دَفْعِ النِّكَاحِ
u'دفع نِكَاحٌ':Added, #1: 1	دَفْعِ النِّكَاحِ
u'دَفْعٌ نِكَاحٌ':Added, #1: 1	دَفْعِ النِّكَاحِ
u'دفع نَوْمٌ':Added, #1: 1	دَفْعِ النِّكَاحِ
u'دَفْعٌ نَوْمٌ':Added, #1: 1	دَفْعِ النَّوْمِ
u'دفع هِبَةٌ':Added, #1: 1	دَفْعِ النَّوْمِ
u'دَفْعٌ هِبَةٌ':Added, #1: 1	دَفْعِ الْهِبَةِ
u'دفع هلاك':Added, #1: 1	دَفْعِ الْهِبَةِ
u'دَفْعٌ هلاك':Added, #1: 1	دَفْعَ هَلَاكِ
u'دفع هَلاَكٌ':Added, #1: 1	دَفْعَ هَلَاكِ
u'دَفْعٌ هَلاَكٌ':Added, #1: 1	دَفْعَ هَلَاكِ
u'دفع هلاك':Added, #1: 1	دَفْعَ هَلَاكِ
u'دَفْعٌ هلاك':Added, #4: 4	دَفْعِ الْهَلَاكِ
u'دفع هَلاَكٌ':Added, #4: 4	دَفْعِ الْهَلَاكِ
u'دَفْعٌ هَلاَكٌ':Added, #4: 4	دَفْعِ الْهَلَاكِ
u'دفع هلاك':Added, #4: 4	دَفْعِ الْهَلَاكِ
u'دَفْعٌ هلاك':Added, #6: 6	دَفْعَ الْهَلَاكِ
u'دفع هَلاَكٌ':Added, #6: 6	دَفْعَ الْهَلَاكِ
u'دَفْعٌ هَلاَكٌ':Added, #6: 6	دَفْعَ الْهَلَاكِ
u'دفع هلاك':Added, #6: 6	دَفْعَ الْهَلَاكِ
u'دَفْعٌ هلاك':Added, #7: 7	دَفْعُ الْهَلَاكِ
u'دفع هَلاَكٌ':Added, #7: 7	دَفْعُ الْهَلَاكِ
u'دَفْعٌ هَلاَكٌ':Added, #7: 7	دَفْعُ الْهَلَاكِ
u'دفع وَاجِبٌ':Added, #7: 7	دَفْعُ الْهَلَاكِ
u'دَفْعٌ وَاجِبٌ':Added, #1: 1	دَفْعُ وَاجِبِهِ
u'دفع وَاجِبٌ':Added, #1: 1	دَفْعُ وَاجِبِهِ
u'دَفْعٌ وَاجِبٌ':Added, #2: 2	دَفْعِ الْوَاجِبِ
u'دَفَعَ وَارِثٌ':Subject, #2: 2	دَفْعِ الْوَاجِبِ
u'دفع وَثِيقٌ':Added, #2: 2	دَفَعَ الْوَارِثُ
u'دَفْعٌ وَثِيقٌ':Added, #2: 2	دَفْعُ الْوَثِيقَةِ
u'دفع وُجُوبٌ':Added, #2: 2	دَفْعُ الْوَثِيقَةِ
u'دَفْعٌ وُجُوبٌ':Added, #1: 1	دَفْعُ وُجُوبِهِ
u'دفع وُجُوبٌ':Added, #1: 1	دَفْعُ وُجُوبِهِ
u'دَفْعٌ وُجُوبٌ':Added, #2: 2	دَفْعِ وُجُوبِ
u'دفع وَحْشَةٌ':Added, #2: 2	دَفْعِ وُجُوبِ
u'دَفْعٌ وَحْشَةٌ':Added, #1: 1	دَفْعَ الْوَحْشَةِ
u'دفع وَحْشَةٌ':Added, #1: 1	دَفْعَ الْوَحْشَةِ
u'دَفْعٌ وَحْشَةٌ':Added, #1: 1	دَفْعَ وَحْشَةِ
u'دَفَعَ وَدِيعٌ':Predicate, #1: 1	دَفْعَ وَحْشَةِ
u'دَفَعَ وَدِيعٌ':Predicate, #10: 10	دَفَعَ الْوَدِيعَةَ
u'دفع وَدِيعٌ':Added, #1: 1	دَفَعَ وَدِيعَةَ
u'دَفْعٌ وَدِيعٌ':Added, #4: 4	دَفْعِ الْوَدِيعَةِ
u'دَفَعَ وَدِيعَةٌ':Predicate, #4: 4	دَفْعِ الْوَدِيعَةِ
u'دَفَعَ وَدِيعَةٌ':Predicate, #10: 10	دَفَعَ الْوَدِيعَةَ
u'دفع وَدِيعَةٌ':Added, #1: 1	دَفَعَ وَدِيعَةَ
u'دَفْعٌ وَدِيعَةٌ':Added, #4: 4	دَفْعِ الْوَدِيعَةِ
u'دفع وَرَثَةٌ':Added, #4: 4	دَفْعِ الْوَدِيعَةِ
u'دَفْعٌ وَرَثَةٌ':Added, #1: 1	دَفْعِ وَرَثَتِهِ
u'دفع وُرُودٌ':Added, #1: 1	دَفْعِ وَرَثَتِهِ
u'دَفْعٌ وُرُودٌ':Added, #2: 2	دَفْعُ وُرُودِ
u'دفع وَسْوَسَةٌ':Added, #2: 2	دَفْعُ وُرُودِ
u'دَفْعٌ وَسْوَسَةٌ':Added, #1: 1	دَفْعِ الْوَسْوَسَةِ
u'دَفَعَ وَصِيٌّ':Predicate, #1: 1	دَفْعِ الْوَسْوَسَةِ
u'دَفَعَ وَصِيٌّ':Subject, #1: 1	دَفَعَ الْوَصِيَّةَ
u'دفع وَصِيٌّ':Added, #6: 6	دَفَعَ الْوَصِيُّ
u'دفع وَصِيٌّ':Added, #1: 1	دَفْعُ الْوَصِيِّ
u'دَفْعٌ وَصِيٌّ':Added, #1: 1	دَفْعِ الْوَصِيِّ
u'دَفْعٌ وَصِيٌّ':Added, #1: 1	دَفْعُ الْوَصِيِّ
u'دَفَعَ وَصِيَّةٌ':Predicate, #1: 1	دَفْعِ الْوَصِيِّ
u'دفع وَظِيفٌ':Added, #1: 1	دَفَعَ الْوَصِيَّةَ
u'دَفْعٌ وَظِيفٌ':Added, #1: 1	دَفْعِ الْوَظِيفَةِ
u'دفع وَظِيفَةٌ':Added, #1: 1	دَفْعِ الْوَظِيفَةِ
u'دَفْعٌ وَظِيفَةٌ':Added, #1: 1	دَفْعِ الْوَظِيفَةِ
u'دفع وُقُوعٌ':Added, #1: 1	دَفْعِ الْوَظِيفَةِ
u'دَفْعٌ وُقُوعٌ':Added, #1: 1	دَفْعِ وُقُوعِ
u'دَفَعَ وَكِيلٌ':Subject, #1: 1	دَفْعِ وُقُوعِ
u'دفع وَكِيلٌ':Added, #9: 9	دَفَعَ الْوَكِيلُ
u'دَفْعٌ وَكِيلٌ':Added, #2: 2	دَفْعِ وَكِيلِهِ
u'دفع وَكِيلٌ':Added, #2: 2	دَفْعِ وَكِيلِهِ
u'دَفْعٌ وَكِيلٌ':Added, #3: 3	دَفْعَ وَكِيلِهِ
u'دفع وَكِيلٌ':Added, #3: 3	دَفْعَ وَكِيلِهِ
u'دَفْعٌ وَكِيلٌ':Added, #8: 8	دَفْعِ الْوَكِيلِ
u'دَفَعَ ولد':Predicate, #8: 8	دَفْعِ الْوَكِيلِ
u'دَفَعَ وَلَدٌ':Predicate, #2: 2	دَفَعَ الْوَلَدَ
u'دَفَعَ ولد':Subject, #2: 2	دَفَعَ الْوَلَدَ
u'دَفَعَ وَلَدٌ':Subject, #1: 1	دَفَعَ الْوَلَدُ
u'دفع ولد':Added, #1: 1	دَفَعَ الْوَلَدُ
u'دفع ولد':Added, #1: 1	دَفْعَ الْوَلَدِ
u'دَفْعٌ ولد':Added, #1: 1	دَفْعِ الْوَلَدِ
u'دَفْعٌ ولد':Added, #1: 1	دَفْعَ الْوَلَدِ
u'دفع وَلَدٌ':Added, #1: 1	دَفْعِ الْوَلَدِ
u'دفع وَلَدٌ':Added, #1: 1	دَفْعَ الْوَلَدِ
u'دَفْعٌ وَلَدٌ':Added, #1: 1	دَفْعِ الْوَلَدِ
u'دَفْعٌ وَلَدٌ':Added, #1: 1	دَفْعَ الْوَلَدِ
u'دَفَعَ وَلِيٌّ':Subject, #1: 1	دَفْعِ الْوَلَدِ
u'دَفَعَ وَلِيٌّ':Subject, #1: 1	دَفَعَ الْوَلِيُّ
u'دَفَعَ وَهَلٌ':Predicate, #1: 1	دَفَعَ وَلِيُّهُ
u'دَفَعَ وَهْمٌ':Predicate, #1: 1	دَفَعَ وَهَلَكَ
u'دفع وَهْمٌ':Added, #1: 1	دَفَعَ وَهْمَ
u'دفع وَهْمٌ':Added, #1: 1	دَفْعَ الْوَهْمِ
u'دَفْعٌ وَهْمٌ':Added, #1: 1	دَفْعِ الْوَهْمِ
u'دَفْعٌ وَهْمٌ':Added, #1: 1	دَفْعَ الْوَهْمِ
u'دفع وَهْمٌ':Added, #1: 1	دَفْعِ الْوَهْمِ
u'دَفْعٌ وَهْمٌ':Added, #1: 1	دَفْعُ وَهْمِ
u'دفع يَدٌ':Added, #1: 1	دَفْعُ وَهْمِ
u'دَفْعٌ يَدٌ':Added, #1: 1	دَفْعِ يَدِ
u'دَفَعَ يَسِيرٌ':Subject, #1: 1	دَفْعِ يَدِ
u'دفع يَمِينٌ':Added, #1: 1	دَفَعَ يَسِيرُ
u'دَفْعٌ يَمِينٌ':Added, #3: 3	دَفْعِ الْيَمِينِ
u'دَفَقَ مَاءٌ':Predicate, #3: 3	دَفْعِ الْيَمِينِ
u'دَفَقَ مَاءٌ':Subject, #2: 2	دَفَقَ الْمَاءَ
u'دَفَّ نَاسٌ':Subject, #1: 1	دَفَقَ الْمَاءُ
u'دَفَنَ دَرَاهِمُ':Predicate, #1: 1	دَفَّ نَاسٌ
u'دَفَنَ دَفَاتِرُ':Predicate, #1: 1	دَفَنَ دَرَاهِمَ
u'دَفَنَ رَجُلٌ':Subject, #1: 1	دَفَنَ دَفَاتِرَ
u'دَفَنَ زَيْدٌ':Predicate, #1: 1	دَفَنَ الرَّجُلُ
u'دَفَنَ سَعْدٌ':Predicate, #1: 1	دَفَنَ زَيْدَ
u'دَفَنَ فلان':Predicate, #2: 2	دَفَنَ سَعْدَ
u'دَفَنَ فلان':Subject, #1: 1	دَفَنَ عُثْمَانَ
u'دَفَنَ قَمْلَةٌ':Predicate, #1: 1	دَفَنَ عُثْمَانُ
u'دَفَنَ وَدِيعٌ':Predicate, #1: 1	دَفَنَ الْقَمْلَةَ
u'دَفَنَ وَدِيعَةٌ':Predicate, #1: 1	دَفَنَ الْوَدِيعَةَ
u'دَقَّ بَابٌ':Predicate, #1: 1	دَفَنَ الْوَدِيعَةَ
u'دِقَّةٌ خَطٌّ':Added, #2: 2	دَقَّ الْبَابَ
u'دَقَّ ثَوْبٌ':Predicate, #1: 1	دِقَّةِ الْخَطِّ
u'دَقَّ سِنٌّ':Predicate, #1: 1	دَقَّ الثَّوْبَ
u'دَقَّ طِينٌ':Predicate, #1: 1	دَقَّ سِنَّ
u'دَقَّقَ نَظَرٌ':Predicate, #1: 1	دَقَّ الطِّينَ
u'دَقَّ كفر':Predicate, #1: 1	دَقَّقَ النَّظَرَ
u'دَلَّ إِجْمَاعٌ':Subject, #2: 2	دَقَّ كَفَرَ
u'دَلَّ أحَدٌ':Subject, #1: 1	دَلَّ الْإِجْمَاعُ
u'دَلَّ اِسْتِقْراءٌ':Subject, #1: 1	دَلَّ أَحَدُ
u'دَلَّ إقْدَامٌ':Subject, #1: 1	دَلَّ اسْتِقْرَاءُ
u'دِلاَلَةٌ مُشَاهَدٌ':Added, #3: 3	دَلَّ الْإِقْدَامُ
u'دِلاَلَةٌ مُشَاهَدَةٌ':Added, #1: 1	دِلاَلَةِ الْمُشَاهَدَةِ
u'دِلاَلَةٌ مُشْرِك':Added, #1: 1	دِلاَلَةِ الْمُشَاهَدَةِ
u'دَلَّ أُمَّةٌ':Predicate, #1: 1	دِلاَلَةَ مُشْرِكٍ
u'دَلَّ أَمْرٌ':Subject, #1: 1	دَلَّ الأُمَّةَ
u'دَلَّ أَوَّلُ':Subject, #3: 3	دَلَّ الْأَمْرُ
u'دَلَّ أَوَّلُ':Subject, #1: 1	دَلَّ الْأَوَّلُ
u'دَلَّ بساط':Subject, #1: 1	دَلَّ أَوَّلُهُ
u'دَلَّ بِساطٌ':Subject, #4: 4	دَلَّ بِسَاطٌ
u'دَلَّ تَخْصِيصٌ':Subject, #4: 4	دَلَّ بِسَاطٌ
u'دَلَّ تَصَرُّفٌ':Subject, #1: 1	دَلَّ التَّخْصِيصُ
u'دَلَّ تَقْريرٌ':Subject, #1: 1	دَلَّ التَّصَرُّفُ
u'دَلَّ تَكَلُّمٌ':Subject, #3: 3	دَلَّ التَّقْرِيرُ
u'دَلَّ حالٌ':Subject, #1: 1	دَلَّ التَّكَلُّمُ
u'دَلَّ حَديثٌ':Subject, #5: 5	دَلَّ الْحَالُ
u'دَلَّ حَديثٌ':Subject, #2: 2	دَلَّ حَدِيثُ
u'دَلَّ حَرامٌ':Subject, #5: 5	دَلَّ الْحَدِيثُ
u'دَلَّ حساب':Subject, #1: 1	دَلَّ الْحَرَامُ
u'دَلَّ حِسَابٌ':Subject, #2: 2	دَلَّ الْحِسَابُ
u'دَلَّ حَلالٌ':Subject, #2: 2	دَلَّ الْحِسَابُ
u'دَلَّ حَلالٌ':Subject, #1: 1	دَلَّ الْحَلَالُ
u'دَلَّ دَليلٌ':Subject, #2: 2	دَلَّ حَلَالٌ
u'دَلَّ دَليلٌ':Subject, #3: 3	دَلَّ دَلِيلُ
u'دَلَّ رَجُلٌ':Subject, #41: 41	دَلَّ الدَّلِيلُ
u'دَلَّ رَسُولٌ':Predicate, #1: 1	دَلَّ رَجُلٌ
u'دَلَّ سَارِقٌ':Predicate, #1: 1	دَلَّ رَسُولَ
u'دَلَّ سَارِقٌ':Subject, #4: 4	دَلَّ السَّارِقَ
u'دَلَّسَ بَائِعٌ':Subject, #1: 1	دَلَّ السَّارِقُ
u'دَلَّسَ عَيْبٌ':Predicate, #10: 10	دَلَّسَ الْبَائِعُ
u'دَلَّسَ غير':Subject, #7: 7	دَلَّسَ الْعَيْبَ
u'دَلَّسَ غَيْرٌ':Subject, #2: 2	دَلَّسَ غَيْرُ
u'دَلَّسَ قَوْمٌ':Subject, #2: 2	دَلَّسَ غَيْرُ
u'دَلَّ سُكُوتٌ':Subject, #1: 1	دَلَّسَ قَوْمٌ
u'دَلَّ سُكُوتٌ':Subject, #1: 1	دَلَّ السُّكُوتُ
u'دَلَّسَ مَالِكٌ':Subject, #1: 1	دَلَّ سُكُوتُهُ
u'دَلَّسَ مُسْتَأْجِرٌ':Subject, #1: 1	دَلَّسَ الْمَالِكُ
u'دَلَّ سَمْعٌ':Subject, #2: 2	دَلَّسَ مُسْتَأْجِرٌ
u'دَلَّ شَرْعٌ':Subject, #1: 1	دَلَّ السَّمْعُ
u'دَلَّ صَرِيحٌ':Subject, #5: 5	دَلَّ الشَّرْعُ
u'دَلَّ ضَمِنٌ':Predicate, #1: 1	دَلَّ صَرِيحُ
u'دَلَّ عَدَمٌ':Subject, #2: 2	دَلَّ ضَمِنَ
u'دَلَّ عرف':Subject, #1: 1	دَلَّ عَدَمُ
u'دَلَّ عُرْفٌ':Subject, #1: 1	دَلَّ عُرْفُ
u'دَلَّ عرف':Subject, #1: 1	دَلَّ عُرْفُ
u'دَلَّ عُرْفٌ':Subject, #4: 4	دَلَّ الْعُرْفُ
u'دَلَّ عَقْلٌ':Subject, #4: 4	دَلَّ الْعُرْفُ
u'دَلَّ عُقُولٌ':Predicate, #2: 2	دَلَّ الْعَقْلُ
u'دَلَّ علم':Subject, #1: 1	دَلَّ الْعُقُولَ
u'دَلَّ عِلْمٌ':Subject, #1: 1	دَلَّ عِلْمُهُ
u'دَلَّ عُمُومٌ':Subject, #1: 1	دَلَّ عِلْمُهُ
u'دَلَّ عند':Predicate, #1: 1	دَلَّ الْعُمُومُ
u'دَلَّ غير':Subject, #1: 1	دَلَّ عِنْدَ
u'دَلَّ غَيْرٌ':Subject, #1: 1	دَلَّ غَيْرُ
u'دَلَّ فِعْلٌ':Subject, #1: 1	دَلَّ غَيْرُ
u'دَلَّ قُرْآنٌ':Subject, #1: 1	دَلَّ الْفِعْلُ
u'دَلَّ قَضَاءٌ':Subject, #1: 1	دَلَّ الْقُرْآنُ
u'دَلَّ قَلِيلٌ':Subject, #1: 1	دَلَّ قَضَاءُ
u'دَلَّ قَوَاطِعُ':Subject, #1: 1	دَلَّ قَلِيلُهُ
u'دَلَّ قول':Subject, #1: 1	دَلَّ الْقَوَاطِعُ
u'دَلَّ قَوْلٌ':Subject, #1: 1	دَلَّ الْقَوْلُ
u'دَلَّ قول':Subject, #1: 1	دَلَّ الْقَوْلُ
u'دَلَّ قَوْلٌ':Subject, #4: 4	دَلَّ قَوْلُهُ
u'دلك أسْنَانٌ':Added, #4: 4	دَلَّ قَوْلُهُ
u'دَلْكٌ أسْنَانٌ':Added, #1: 1	دَلْكُ الأَسْنَانِ
u'دلك أَعْضَاءٌ':Added, #1: 1	دَلْكُ الأَسْنَانِ
u'دَلْكٌ أَعْضَاءٌ':Added, #1: 1	دَلْكُ الْأَعْضَاءِ
u'دلك بدن':Added, #1: 1	دَلْكُ الْأَعْضَاءِ
u'دَلْكٌ بدن':Added, #1: 1	دَلْكُ بَدَنِهِ
u'دلك بَدَنٌ':Added, #1: 1	دَلْكُ بَدَنِهِ
u'دَلْكٌ بَدَنٌ':Added, #1: 1	دَلْكُ بَدَنِهِ
u'دلك بُصاقٌ':Added, #1: 1	دَلْكُ بَدَنِهِ
u'دَلْكٌ بُصاقٌ':Added, #1: 1	دَلْكِ الْبُصَاقِ
u'دلك بَعْضٌ':Added, #1: 1	دَلْكِ الْبُصَاقِ
u'دَلْكٌ بَعْضٌ':Added, #1: 1	دَلْكُ بَعْضِ
u'دلك خُفٌّ':Added, #1: 1	دَلْكُ بَعْضِ
u'دَلْكٌ خُفٌّ':Added, #1: 1	دَلْكُ خُفٍّ
u'دلك عَوْرَةٌ':Added, #1: 1	دَلْكُ خُفٍّ
u'دَلْكٌ عَوْرَةٌ':Added, #1: 1	دَلْكِ عَوْرَتِهِ
u'دلك غير':Added, #1: 1	دَلْكِ عَوْرَتِهِ
u'دلك غَيْرٌ':Added, #1: 1	دَلْكُ غَيْرِهِ
u'دَلْكٌ غير':Added, #1: 1	دَلْكُ غَيْرِهِ
u'دَلْكٌ غَيْرٌ':Added, #1: 1	دَلْكُ غَيْرِهِ
u'دَلَّ كُفَّارٌ':Predicate, #1: 1	دَلْكُ غَيْرِهِ
u'دَلَّ كَلاَمٌ':Subject, #1: 1	دَلَّ الْكُفَّارَ
u'دَلَّ كَلاَمٌ':Subject, #1: 1	دَلَّ كَلاَمُ
u'دَلَّ كَلاَمٌ':Subject, #6: 6	دَلَّ كَلَامُهُ
u'دلك نَعْلٌ':Added, #8: 8	دَلَّ كَلَامُ
u'دلك نَعْلٌ':Added, #1: 1	دَلْكُ النَّعْلِ
u'دَلْكٌ نَعْلٌ':Added, #1: 1	دَلْكِ النَّعْلِ
u'دَلْكٌ نَعْلٌ':Added, #1: 1	دَلْكُ النَّعْلِ
u'دلك يَدٌ':Added, #1: 1	دَلْكِ النَّعْلِ
u'دَلْكٌ يَدٌ':Added, #2: 2	دَلْكِ الْيَدِ
u'دَلَّ لَفْظٌ':Subject, #2: 2	دَلْكِ الْيَدِ
u'دَلَّ لَفْظٌ':Subject, #1: 1	دَلَّ لَفْظٌ
u'دَلَّ لَفْظٌ':Subject, #1: 1	دَلَّ لَفْظُهُ
u'دَلَّ مُبَيَّنٌ':Subject, #7: 7	دَلَّ اللَّفْظُ
u'دَلَّ مَجْمُوعٌ':Subject, #1: 1	دَلَّ الْمُبَيَّنُ
u'دَلَّ مُحْرِمٌ':Subject, #1: 1	دَلَّ مَجْمُوعُ
u'دَلَّ مُحْرِمٌ':Subject, #2: 2	دَلَّ الْمُحْرِمُ
u'دَلَّ مُظْهَرٌ':Subject, #8: 8	دَلَّ مُحْرِمٌ
u'دَلَّ مُودِعٌ':Subject, #1: 1	دَلَّ الْمُظْهَرُ
u'دَلَّ مُوَدِّعٌ':Subject, #1: 1	دَلَّ الْمُودِعُ
u'دَلَّ نَصٌّ':Subject, #1: 1	دَلَّ الْمُوَدِّعُ
u'دَلَّ نَصٌّ':Subject, #2: 2	دَلَّ نَصٌّ
u'دَلَّ نَصٌّ':Subject, #2: 2	دَلَّ نَصُّهُ
u'دَلَّ نَصِيبٌ':Subject, #4: 4	دَلَّ النَّصُّ
u'دَلَّ نقل':Subject, #1: 1	دَلَّ النَّصِيبُ
u'دَلَّ نَقْلٌ':Subject, #1: 1	دَلَّ النَّقْلُ
u'دمع عين':Added, #1: 1	دَلَّ النَّقْلُ
u'دمع عَيْنٌ':Added, #1: 1	دَمْعُ الْعَيْنِ
u'دمع عَيْن':Added, #1: 1	دَمْعُ الْعَيْنِ
u'دَمْعٌ عين':Added, #1: 1	دَمْعُ الْعَيْنِ
u'دَمْعٌ عَيْنٌ':Added, #1: 1	دَمْعُ الْعَيْنِ
u'دَمْعٌ عَيْن':Added, #1: 1	دَمْعُ الْعَيْنِ
u'دمع عين':Added, #1: 1	دَمْعُ الْعَيْنِ
u'دمع عَيْنٌ':Added, #4: 4	دَمْعِ الْعَيْنِ
u'دمع عَيْن':Added, #4: 4	دَمْعِ الْعَيْنِ
u'دَمْعٌ عين':Added, #4: 4	دَمْعِ الْعَيْنِ
u'دَمْعٌ عَيْنٌ':Added, #4: 4	دَمْعِ الْعَيْنِ
u'دَمْعٌ عَيْن':Added, #4: 4	دَمْعِ الْعَيْنِ
u'دَمَغَ نِفَاقٌ':Predicate, #4: 4	دَمْعِ الْعَيْنِ
u'دَمِنَ قرع':Predicate, #1: 1	دَمَغَ النّفَاقَ
u'دَمِنَ قَرْعٌ':Predicate, #3: 3	أَدْمَنَ قَرْعَ
u'دَمِيَ أَنْفٌ':Subject, #3: 3	أَدْمَنَ قَرْعَ
u'دَمِيَ عند':Predicate, #1: 1	دَمِيَ أَنْفُهُ
u'دَمِيَ فَاهٌ':Subject, #1: 1	دَمِيَ عِنْدَ
u'دَمِيَ فَمٌ':Subject, #1: 1	دَمِيَ فَاهُ
u'دَمَّى وَجْهٌ':Predicate, #1: 1	دَمِيَ فَمُ
u'دَنَا أَجَلٌ':Subject, #1: 1	دَمَّى وَجْهَ
u'دَنَا أَجَلٌ':Subject, #1: 1	دَنَا أَجَلُهُ
u'دَنَا أصل':Subject, #1: 1	دَنَا الْأَجَلُ
u'دَنَا أَصيلٌ':Subject, #1: 1	دَنَا الْأُصُلُ
u'دَنَا جَيْشٌ':Subject, #1: 1	دَنَا الْأَصِيلُ
u'دَنَا حَصَادٌ':Subject, #1: 1	دَنَا جَيْشُهُ
u'دَنَا حَصَلٌ':Predicate, #2: 2	دَنَا حَصَادُهُ
u'دَنَا رَحِيلٌ':Subject, #1: 1	دَنَا حَصَلَ
u'دَنَا رَسُولٌ':Subject, #1: 1	دَنَا الرَّحِيلُ
u'دَنَا رَواحٌ':Subject, #1: 1	دَنَا رَسُولُ
u'دَنَا صَاحِبٌ':Subject, #1: 1	دَنَا الرّوَاحُ
u'دَنَا صباح':Subject, #1: 1	دَنَا صَاحِبُ
u'دَنَا صَبَاحٌ':Subject, #1: 1	دَنَا الصَّبَاحُ
u'دَنَا غَيْبُوبَةٌ':Subject, #1: 1	دَنَا الصَّبَاحُ
u'دَنَا فَجْرٌ':Subject, #1: 1	دَنَا غَيْبُوبَةُ
u'دَنَا فساد':Subject, #1: 1	دَنَا الْفَجْرُ
u'دَنَا فَسَادٌ':Subject, #1: 1	دَنَا الْفَسَادُ
u'دَنَا قَالٌ':Predicate, #1: 1	دَنَا الْفَسَادُ
u'دَنَا قَوْمٌ':Subject, #1: 1	دَنَا قَالَ
u'دَنَا مَوْتٌ':Subject, #1: 1	دَنَا الْقَوْمُ
u'دَنَسٌ حَيْضٌ':Added, #1: 1	دَنَا مَوْتُهُ
u'دَنَسٌ ذُنُوبٌ':Added, #1: 1	دَنَسِ الْحَيْضِ
u'دَنِيَ جَازٌ':Predicate, #2: 2	دَنَسِ الذُّنُوبِ
u'دَنِيَ فلان':Predicate, #2: 2	أَدْنَى جَازَ
u'دَنِيَ مثل':Predicate, #1: 1	أَدْنَى خَيْبَرَ
u'دَنِيَ مِثْلٌ':Predicate, #1: 1	أَدْنَى مِثْلَ
u'دَنِيَ مَرَاتِبُ':Predicate, #1: 1	أَدْنَى مِثْلَ
u'دَنِيَ مُرْسَلٌ':Predicate, #1: 1	أَدْنَى مَرَاتِبَ
u'دَنِيَ مُسْلِمٌ':Predicate, #1: 1	أَدْنَى الْمُرْسَلِينَ
u'دَنِيَ مُؤْمِنٌ':Predicate, #4: 4	أَدْنَى الْمُسْلِمِينَ
u'دَهْنٌ آس':Added, #1: 1	أَدْنَى الْمُؤْمِنِينَ
u'دَهَنَ أَصْلَع':Subject, #1: 1	دَهْنِ الْآسِ
u'دَهْنٌ بدن':Added, #1: 1	دَهَنَ الْأَصْلَعُ
u'دَهْنٌ بَدَنٌ':Added, #2: 2	دَهْنُ بَدَنِهِ
u'دَهْنٌ رَأْسٌ':Added, #2: 2	دَهْنُ بَدَنِهِ
u'دَهْنٌ رَأْسٌ':Added, #1: 1	دَهْنَ الرَّأْسِ
u'دَهْنٌ شَارِبٌ':Added, #3: 3	دَهْنَ رَأْسِهِ
u'دَهْنٌ شَارِبٌ':Added, #1: 1	دَهْنُ شَارِبٍ
u'دَهْنٌ شَعْرٌ':Added, #2: 2	دَهْنُ الشَّارِبِ
u'دَهَنَ شقاق':Predicate, #2: 2	دَهْنِ شَعْرِهِ
u'دَهَنَ صَائِمٌ':Subject, #1: 1	دَهَنَ شُقَاقَ
u'دَهْنٌ لِحْيَةٌ':Added, #1: 1	دَهَنَ الصَّائِمُ
u'دَهْنٌ مُحْرِمٌ':Added, #1: 1	دَهْنُ اللِّحْيَةِ
u'دَوْحٌ دِينٌ':Added, #1: 1	دَهْنُ الْمُحْرِمِ
u'دَوَّخَ أرْضٌ':Predicate, #1: 1	دَوْحِ دِينِهِ
u'دَوْرٌ الْمَرْأَةُ':Added, #1: 1	دَوَّخَ الْأَرْضَ
u'دَوْرٌ بِئْرٌ':Added, #2: 2	دَوْرَ الْمَرْأَةِ
u'دَوْرٌ خَمْسٌ':Added, #1: 1	دَوْرُ الْبِئْرِ
u'دَوْرٌ خَمْسَةٌ':Added, #1: 1	دَوْرَ الْخَمْسِ
u'دَوْرٌ دَمٌ':Added, #1: 1	دَوْرَ الْخَمْسَةِ
u'دَوْرٌ دَمٌ':Added, #1: 1	دَوْرَ الدَّمِ
u'دَوْرٌ طَلاَقٌ':Added, #1: 1	دَوْرِ الدَّمِ
u'دَوْرٌ لَفْظٌ':Added, #1: 1	دَوْرِ الطَّلَاقِ
u'دَوْرٌ واحد':Added, #1: 1	دَوْرُ لَفْظِ
u'دَوْرٌ وَاحِدٌ':Added, #1: 1	دَوْرٍ وَاحِدٍ
u'دَوْرٌ يَمِينٌ':Added, #1: 1	دَوْرٍ وَاحِدٍ
u'دَوْلَةٌ اِبْنٌ':Added, #2: 2	دَوْرُ الْيَمِينِ
u'دَوْلَةٌ إِسْلامٌ':Added, #1: 1	دَوْلَةِ ابْنِ
u'دَوْلَةٌ جَاهِلٌ':Added, #1: 1	دَوْلَةِ الْإِسْلَامِ
u'دَوْلَةٌ سُلْطَانٌ':Added, #1: 1	دَوْلَةُ الْجَاهِلِ
u'دَوْلَةٌ عَدُوٌّ':Added, #2: 2	دَوْلَةِ السُّلْطَانِ
u'دَوْلَةٌ مَلِكٌ':Added, #1: 1	دَوْلَةَ الْعَدُوِّ
u'دَوْلَةٌ نِساءٌ':Added, #1: 1	دَوْلَةِ مَلِكِ
u'دُوَلٌ دَهْرٌ':Added, #1: 1	دَوْلَةِ النِّسَاءِ
u'دَوَّنَ دَواوينُ':Predicate, #1: 1	دُوَلِ الدّهْرِ
u'دَوَّنَ عُمَرٌ':Predicate, #8: 8	دَوَّنَ الدَّوَاوِينَ
u'دَوَّنَ فِقْهٌ':Predicate, #1: 1	دَوَّنَ عُمَرَ
u'دَوَّنَ كُتُبٌ':Predicate, #1: 1	دَوَّنَ الْفِقْهَ
u'دَوِيَ دواة':Predicate, #1: 1	دَوَّنَ الْكُتُبَ
u'دَوِيَ دَواةٌ':Predicate, #1: 1	دَوِيَ الدَّوَاةَ
u'دِيَةٌ أَبٌ':Added, #1: 1	دَوِيَ الدَّوَاةَ
u'دِيَةٌ اِبْنٌ':Added, #5: 5	دِيَةِ الْأَبِ
u'دِيَةٌ اِبْنٌ':Added, #1: 1	دِيَةُ ابْنِ
u'دِيَةٌ أَثْمانٌ':Added, #1: 1	دِيَةَ ابْنِهِ
u'دِيَةٌ أَجْفَانٌ':Added, #2: 2	دِيَةِ الْأَثْمَانِ
u'دِيَةٌ أَحْرارٌ':Added, #1: 1	دِيَةِ الْأَجْفَانِ
u'دِيَةٌ أَرْبَعُ':Added, #1: 1	دِيَةُ أَحْرَارٍ
u'دِيَةٌ أسْنَانٌ':Added, #1: 1	دِيَةِ أَرْبَعِ
u'دِيَةٌ أَشْفَارٌ':Added, #1: 1	دِيَةِ الأَسْنَانِ
u'دِيَةٌ أَصابِعُ':Added, #1: 1	دِيَةِ أَشْفَارِ
u'دِيَةٌ أَصابِعُ':Added, #1: 1	دِيَةُ أَصَابِعِ
u'دِيَةٌ أَصابِعُ':Added, #1: 1	دِيَةِ الأَصَابِعِ
u'دِيَةٌ أَصابِعُ':Added, #2: 2	دِيَةَ الْأَصَابِعِ
u'دِيَةٌ أَصابِعُ':Added, #5: 5	دِيَةُ الْأَصَابِعِ
u'دِيَةٌ أُصْبُعٌ':Added, #9: 9	دِيَةِ الْأَصَابِعِ
u'دِيَةٌ أُصْبُعٌ':Added, #16: 16	دِيَةِ الْأُصْبُعِ
u'دِيَةٌ أُصْبُعٌ':Added, #1: 1	دِيَةَ أُصْبُعٍ
u'دِيَةٌ أُصْبُعٌ':Added, #1: 1	دِيَةُ أُصْبُعٍ
u'دِيَةٌ أُصْبُعٌ':Added, #1: 1	دِيَةَ أُصْبُعِهِ
u'دِيَةٌ إِصْبَعٌ':Added, #1: 1	دِيَةُ أُصْبُعِهِ
u'دِيَةٌ أُصْبُعٌ':Added, #1: 1	دِيَةُ إصْبَعِهِ
u'دِيَةٌ إِصْبَعٌ':Added, #1: 1	دِيَةَ أُصْبُعَيْنِ
u'دِيَةٌ أُصْبُعٌ':Added, #1: 1	دِيَةُ الْإِصْبَعِ
u'دِيَةٌ أُصْبُعٌ':Added, #1: 1	دِيَةِ الْأُصْبُعَيْنِ
u'دِيَةٌ أُصْبُعٌ':Added, #2: 2	دِيَةِ أُصْبُعٍ
u'دِيَةٌ إِصْبَعٌ':Added, #2: 2	دِيَةُ الْأُصْبُعَيْنِ
u'دِيَةٌ أُصْبُعٌ':Added, #3: 3	دِيَةَ الْإِصْبَعِ
u'دِيَةٌ إِصْبَعٌ':Added, #4: 4	دِيَةُ الْأُصْبُعِ
u'دِيَةٌ أَطْرافٌ':Added, #4: 4	دِيَةِ الْإِصْبَعِ
u'دِيَةٌ أَطْرَافٌ':Added, #1: 1	دِيَةَ أَطْرَافِ
u'دِيَةٌ أَطْرافٌ':Added, #1: 1	دِيَةَ أَطْرَافِ
u'دِيَةٌ أَطْرافٌ':Added, #2: 2	دِيَةَ الْأَطْرَافِ
u'دِيَةٌ أَطْرَافٌ':Added, #2: 2	دِيَةِ الْأَطْرَافِ
u'دِيَةٌ أَطْرَافٌ':Added, #2: 2	دِيَةَ الْأَطْرَافِ
u'دِيَةٌ أَعْضَاءٌ':Added, #2: 2	دِيَةِ الْأَطْرَافِ
u'دِيَةٌ الْمَرْءُ':Added, #1: 1	دِيَةِ الْأَعْضَاءِ
u'دِيَةٌ الْمَرْأَةُ':Added, #1: 1	دِيَةَ الْمَرْءِ
u'دِيَةٌ الْمَرْأَةُ':Added, #15: 15	دِيَةِ الْمَرْأَةِ
u'دِيَةٌ الْمَرْأَةُ':Added, #3: 3	دِيَةَ الْمَرْأَةِ
u'دِيَةٌ أُمٌّ':Added, #9: 9	دِيَةُ الْمَرْأَةِ
u'دِيَةٌ أُمٌّ':Added, #16: 16	دِيَةِ أُمِّهِ
u'دِيَةٌ أُمٌّ':Added, #1: 1	دِيَةَ الْأُمِّ
u'دِيَةٌ أُمٌّ':Added, #6: 6	دِيَةُ الْأُمِّ
u'دِيَةٌ اِمْرَأَةٌ':Added, #9: 9	دِيَةِ الْأُمِّ
u'دِيَةٌ اِمْرَأَةٌ':Added, #1: 1	دِيَةَ امْرَأَةٍ
u'دِيَةٌ اِمْرَأَةٌ':Added, #1: 1	دِيَةُ امْرَأَةٍ
u'دِيَةٌ أُنْثَى':Added, #1: 1	دِيَةِ امْرَأَةٍ
u'دِيَةٌ أَنْفٌ':Added, #1: 1	دِيَةُ الْأُنْثَيَيْنِ
u'دِيَةٌ أَنْفٌ':Added, #1: 1	دِيَةَ الْأَنْفِ
u'دِيَةٌ أَنْفٌ':Added, #1: 1	دِيَةَ أَنْفِهِ
u'دِيَةٌ أُنْمُلَةٌ':Added, #2: 2	دِيَةِ الأَنْفِ
u'دِيَةٌ أُنْمُلَةٌ':Added, #1: 1	دِيَةُ أُنْمُلَةٍ
u'دِيَةٌ أهْلٌ':Added, #1: 1	دِيَةِ أُنْمُلَتِهِ
u'دِيَةٌ أهْلٌ':Added, #3: 3	دِيَةَ أَهْلِ
u'دِيَةٌ أهْلٌ':Added, #4: 4	دِيَةِ أَهْلِ
u'دِيَةٌ أَوَّلُ':Added, #5: 5	دِيَةُ أَهْلِ
u'دِيَةٌ أَوَّلُ':Added, #3: 3	دِيَةَ الْأَوَّلِ
u'دِيَةٌ أَوَّلُ':Added, #3: 3	دِيَةُ الْأَوَّلِ
u'دِيَةٌ بَصَرٌ':Added, #6: 6	دِيَةِ الْأَوَّلِ
u'دِيَةٌ بَطْشٌ':Added, #4: 4	دِيَةِ الْبَصَرِ
u'دِيَةٌ تَعْزِير':Added, #2: 2	دِيَةُ الْبَطْشِ
u'دِيَةٌ ثَالِثٌ':Added, #1: 1	دِيَةِ التَّعْزِيرِ
u'دِيَةٌ ثَالِثٌ':Added, #2: 2	دِيَةَ الثَّالِثِ
u'دِيَةٌ ثَالِثٌ':Added, #4: 4	دِيَةِ الثَّالِثِ
u'دِيَةٌ ثَدْيٌ':Added, #8: 8	دِيَةُ الثَّالِثِ
u'دِيَةٌ جراح':Added, #1: 1	دِيَةِ الثَّدْيِ
u'دِيَةٌ جِرَاحٌ':Added, #1: 1	دِيَةِ الْجِرَاحِ
u'دِيَةٌ جراح':Added, #1: 1	دِيَةِ الْجِرَاحِ
u'دِيَةٌ جِرَاحٌ':Added, #1: 1	دِيَةِ جِرَاحِ
u'دِيَةٌ جِرَاحَاتٌ':Added, #1: 1	دِيَةِ جِرَاحِ
u'دِيَةٌ جِرَاحَاتٌ':Added, #1: 1	دِيَةُ الْجِرَاحَاتِ
u'دِيَةٌ جِرَاحَةٌ':Added, #1: 1	دِيَةِ الْجِرَاحَاتِ
u'دِيَةٌ جِرَاحَةٌ':Added, #1: 1	دِيَةُ الْجِرَاحَاتِ
u'دِيَةٌ جُرْحٌ':Added, #1: 1	دِيَةِ الْجِرَاحَاتِ
u'دِيَةٌ جُرْحٌ':Added, #1: 1	دِيَةَ الْجُرْحِ
u'دِيَةٌ جلد':Added, #1: 1	دِيَةُ الْجُرْحِ
u'دِيَةٌ جِلْدٌ':Added, #1: 1	دِيَةُ الْجِلْدِ
u'دِيَةٌ جِنَايَةٌ':Added, #1: 1	دِيَةُ الْجِلْدِ
u'دِيَةٌ جِنَايَةٌ':Added, #1: 1	دِيَةِ الْجِنَايَةِ
u'دِيَةٌ جَنِينٌ':Added, #1: 1	دِيَةُ جِنَايَتِهِ
u'دِيَةٌ جَنِينٌ':Added, #2: 2	دِيَةُ الْجَنِينِ
u'دِيَةٌ حُرٌّ':Added, #6: 6	دِيَةِ الْجَنِينِ
u'دِيَةٌ حُرٌّ':Added, #12: 12	دِيَةُ الْحُرِّ
u'دِيَةٌ حُرٌّ':Added, #13: 13	دِيَةَ الْحُرِّ
u'دِيَةٌ حُرٌّ':Added, #17: 17	دِيَةُ حُرٍّ
u'دِيَةٌ حُرٌّ':Added, #1: 1	دِيَةِ الْحُرَّةِ
u'دِيَةٌ حُرٌّ':Added, #1: 1	دِيَةَ الْحُرَّيْنِ
u'دِيَةٌ حُرٌّ':Added, #1: 1	دِيَةُ حُرَّةٍ
u'دِيَةٌ حُرٌّ':Added, #1: 1	دِيَةِ حُرَّةٍ
u'دِيَةٌ حُرٌّ':Added, #1: 1	دِيَةُ حُرَّيْنِ
u'دِيَةٌ حُرٌّ':Added, #2: 2	دِيَةَ الْحُرَّةِ
u'دِيَةٌ حُرٌّ':Added, #2: 2	دِيَةُ الْحُرَّةِ
u'دِيَةٌ حُرٌّ':Added, #2: 2	دِيَةِ حُرٍّ
u'دِيَةٌ حُرٌّ':Added, #36: 36	دِيَةِ الْحُرِّ
u'دِيَةٌ حَرْفٌ':Added, #4: 4	دِيَةَ حُرٍّ
u'دِيَةٌ حَشَفَةٌ':Added, #4: 4	دِيَةُ الْحَرْفِ
u'دِيَةٌ حَلَمَةٌ':Added, #1: 1	دِيَةِ الْحَشَفَةِ
u'دِيَةٌ خامس':Added, #2: 2	دِيَةِ الْحَلَمَةِ
u'دِيَةٌ خَامِسٌ':Added, #1: 1	دِيَةَ الْخَامِسَةِ
u'دِيَةٌ خَطَأٌ':Added, #1: 1	دِيَةَ الْخَامِسَةِ
u'دِيَةٌ خَطَأٌ':Added, #12: 12	دِيَةِ الْخَطَأِ
u'دِيَةٌ خَطَأٌ':Added, #1: 1	دِيَةَ خَطَأِ
u'دِيَةٌ خَطَأٌ':Added, #1: 1	دِيَةُ خَطَأٍ
u'دِيَةٌ خَطَأٌ':Added, #3: 3	دِيَةَ الْخَطَأِ
u'دِيَةٌ ذَكَرٌ':Added, #7: 7	دِيَةُ الْخَطَأِ
u'دِيَةٌ ذكر':Added, #2: 2	دِيَةِ ذَكَرٍ
u'دِيَةٌ ذَكَرٌ':Added, #3: 3	دِيَةِ الذَّكَرِ
u'دِيَةٌ ذِمِّيٌّ':Added, #3: 3	دِيَةِ الذَّكَرِ
u'دِيَةٌ ذِمِّيٌّ':Added, #1: 1	دِيَةِ ذِمِّيٍّ
u'دِيَةٌ ذِمِّيٌّ':Added, #3: 3	دِيَةَ الذِّمِّيِّ
u'دِيَةٌ ذِمِّيٌّ':Added, #3: 3	دِيَةُ الذِّمِّيِّ
u'دِيَةٌ ذِمِّيٌّ':Added, #3: 3	دِيَةِ الذِّمِّيِّ
u'دِيَةٌ ذَنْبٌ':Added, #4: 4	دِيَةُ ذِمِّيٍّ
u'دِيَةٌ ذَوْقٌ':Added, #1: 1	دِيَةُ الذَّنْبِ
u'دِيَةٌ رابع':Added, #1: 1	دِيَةُ الذَّوْقِ
u'دِيَةٌ رَابِعٌ':Added, #4: 4	دِيَةُ الرَّابِعِ
u'دِيَةٌ رِجَالٌ':Added, #4: 4	دِيَةُ الرَّابِعِ
u'دِيَةٌ رِجَالٌ':Added, #1: 1	دِيَةِ رِجَالِ
u'دِيَةٌ رَجُلٌ':Added, #1: 1	دِيَةِ رِجَالِهِ
u'دِيَةٌ رِجْلٌ':Added, #1: 1	دِيَةَ الرَّجُلِ
u'دِيَةٌ رَجُلٌ':Added, #1: 1	دِيَةُ الرِّجْلِ
u'دِيَةٌ رَجُلٌ':Added, #1: 1	دِيَةَ رَجُلٍ
u'دِيَةٌ رَجُلٌ':Added, #1: 1	دِيَةُ رَجُلٍ
u'دِيَةٌ رَجُلٌ':Added, #1: 1	دِيَةِ رَجُلٍ
u'دِيَةٌ رَجُلٌ':Added, #38: 38	دِيَةِ الرَّجُلِ
u'دِيَةٌ رِجْلٌ':Added, #3: 3	دِيَةُ الرَّجُلِ
u'دِيَةٌ زَوْجٌ':Added, #4: 4	دِيَةُ رِجْلِهِ
u'دِيَةٌ زَوْجٌ':Added, #1: 1	دِيَةِ الزَّوْجِ
u'دِيَةٌ سادس':Added, #4: 4	دِيَةُ الزَّوْجِ
u'دِيَةٌ سَادِسٌ':Added, #1: 1	دِيَةَ السَّادِسَةِ
u'دِيَةٌ سَاقِطٌ':Added, #1: 1	دِيَةَ السَّادِسَةِ
u'دِيَةٌ سَمْعٌ':Added, #1: 1	دِيَةُ السَّاقِطِ
u'دِيَةٌ سَمْعٌ':Added, #1: 1	دِيَةُ السَّمْعِ
u'دِيَةٌ سَمْعٌ':Added, #1: 1	دِيَةُ سَمْعٍ
u'دِيَةٌ سِنٌّ':Added, #5: 5	دِيَةِ السَّمْعِ
u'دِيَةٌ سِنٌّ':Added, #1: 1	دِيَةَ سِنٍّ
u'دِيَةٌ سِنٌّ':Added, #1: 1	دِيَةِ سِنِّ
u'دِيَةٌ سِنٌّ':Added, #3: 3	دِيَةُ السِّنِّ
u'دِيَةٌ شِبْهٌ':Added, #3: 3	دِيَةُ سِنٍّ
u'دِيَةٌ شِبْهٌ':Added, #1: 1	دِيَةِ شِبْهِهِ
u'دِيَةٌ شِبْهٌ':Added, #2: 2	دِيَةَ شِبْهِ
u'دِيَةٌ شِبْهٌ':Added, #3: 3	دِيَةِ شِبْهِ
u'دِيَةٌ شَرِيكٌ':Added, #6: 6	دِيَةُ شِبْهِ
u'دِيَةٌ شُفْرٌ':Added, #1: 1	دِيَةُ الشَّرِيكِ
u'دِيَةٌ شُفْرٌ':Added, #1: 1	دِيَةُ الشُّفْرَيْنِ
u'دِيَةٌ شَيْءٌ':Added, #4: 4	دِيَةَ الشُّفْرَيْنِ
u'دِيَةٌ صَاحِبٌ':Added, #1: 1	دِيَةُ شَيْءٍ
u'دِيَةٌ صَاحِبٌ':Added, #1: 1	دِيَةِ صَاحِبِ
u'دِيَةٌ صَاحِبٌ':Added, #2: 2	دِيَةُ صَاحِبِهِ
u'دِيَةٌ صَبِيٌّ':Added, #3: 3	دِيَةِ صَاحِبِهِ
u'دِيَةٌ ضرس':Added, #5: 5	دِيَةُ الصَّبِيِّ
u'دِيَةٌ ضِرْسٌ':Added, #1: 1	دِيَةَ ضِرْسِهِ
u'دِيَةٌ طرف':Added, #1: 1	دِيَةَ ضِرْسِهِ
u'دِيَةٌ طَرَفٌ':Added, #1: 1	دِيَةُ الطَّرَفِ
u'دِيَةٌ طَرَفٌ':Added, #1: 1	دِيَةُ الطَّرَفِ
u'دِيَةٌ طرف':Added, #1: 1	دِيَةُ طَرَفٍ
u'دِيَةٌ طَرَفٌ':Added, #3: 3	دِيَةَ الطَّرَفِ
u'دِيَةٌ عَبْدٌ':Added, #3: 3	دِيَةَ الطَّرَفِ
u'دِيَةٌ عَبْدٌ':Added, #1: 1	دِيَةَ الْعَبْدِ
u'دِيَةٌ عَبْدٌ':Added, #1: 1	دِيَةِ الْعَبْدِ
u'دِيَةٌ عُشْرٌ':Added, #1: 1	دِيَةَ عَبْدٍ
u'دِيَةٌ عُضْوٌ':Added, #1: 1	دِيَةُ عُشْرِ
u'دِيَةٌ عُضْوٌ':Added, #1: 1	دِيَةُ عُضْوِ
u'دِيَةٌ عُضْوٌ':Added, #1: 1	دِيَةِ عُضْوٍ
u'دِيَةٌ عَقْلٌ':Added, #2: 2	دِيَةُ الْعُضْوِ
u'دِيَةٌ عَقْلٌ':Added, #1: 1	دِيَةَ الْعَقْلِ
u'دِيَةٌ عَقْلٌ':Added, #1: 1	دِيَةُ عَقْلِهِ
u'دِيَةٌ عَقْلٌ':Added, #3: 3	دِيَةِ الْعَقْلِ
u'دِيَةٌ عَلِيلٌ':Added, #5: 5	دِيَةُ الْعَقْلِ
u'دِيَةٌ عَمْدٌ':Added, #1: 1	دِيَةِ الْعَلِيلَةِ
u'دِيَةٌ عَمْدٌ':Added, #1: 1	دِيَةَ عَمْدٍ
u'دِيَةٌ عَمْدٌ':Added, #2: 2	دِيَةُ عَمْدٍ
u'دِيَةٌ عَمْدٌ':Added, #4: 4	دِيَةَ الْعَمْدِ
u'دِيَةٌ عَمْدٌ':Added, #6: 6	دِيَةِ عَمْدٍ
u'دِيَةٌ عَمْدٌ':Added, #7: 7	دِيَةُ الْعَمْدِ
u'دِيَةٌ عين':Added, #9: 9	دِيَةِ الْعَمْدِ
u'دِيَةٌ عَيْنٌ':Added, #1: 1	دِيَةُ عَيْنِ
u'دِيَةٌ عَيْن':Added, #1: 1	دِيَةُ عَيْنِ
u'دِيَةٌ عين':Added, #1: 1	دِيَةُ عَيْنِ
u'دِيَةٌ عين':Added, #1: 1	دِيَةَ عَيْنِهِ
u'دِيَةٌ عَيْنٌ':Added, #1: 1	دِيَةُ عَيْنِهِ
u'دِيَةٌ عَيْنٌ':Added, #1: 1	دِيَةَ عَيْنِهِ
u'دِيَةٌ عَيْن':Added, #1: 1	دِيَةُ عَيْنِهِ
u'دِيَةٌ عَيْن':Added, #1: 1	دِيَةَ عَيْنِهِ
u'دِيَةٌ عين':Added, #1: 1	دِيَةُ عَيْنِهِ
u'دِيَةٌ عَيْنٌ':Added, #2: 2	دِيَةِ الْعَيْنِ
u'دِيَةٌ عَيْن':Added, #2: 2	دِيَةِ الْعَيْنِ
u'دِيَةٌ عَيْنٌ':Added, #2: 2	دِيَةِ الْعَيْنِ
u'دِيَةٌ عَيْن':Added, #2: 2	دِيَةِ الْعَيْنَيْنِ
u'دِيَةٌ غُلاَمٌ':Added, #2: 2	دِيَةِ الْعَيْنَيْنِ
u'دِيَةٌ فَرْجٌ':Added, #1: 1	دِيَةِ الْغُلَامِ
u'دِيَةٌ فَرْجٌ':Added, #1: 1	دِيَةُ فَرْجِ
u'دِيَةٌ فَرْعٌ':Added, #2: 2	دِيَةُ الْفَرْجِ
u'دِيَةٌ فِعْلٌ':Added, #1: 1	دِيَةِ الْفَرْعِ
u'دِيَةٌ فلان':Added, #1: 1	دِيَةَ فِعْلِهِ
u'دِيَةٌ فلان':Added, #1: 1	دِيَةَ الْعَامِرِيَّيْنِ
u'دِيَةٌ فلان':Added, #1: 1	دِيَةِ الْعَامِرِيَّيْنِ
u'دِيَةٌ فُلاَنٌ':Added, #1: 1	دِيَةِ الْعَامِرِيّيْنِ
u'دِيَةٌ قَاتِلٌ':Added, #1: 1	دِيَةِ فُلَانٍ
u'دِيَةٌ قَاتِلٌ':Added, #1: 1	دِيَةِ الْقَاتِلِ
u'دِيَةٌ قتل':Added, #1: 1	دِيَةِ قَاتِلٍ
u'دِيَةٌ قَتْلٌ':Added, #1: 1	دِيَةُ الْقَتْلِ
u'دِيَةٌ قَتِيلٌ':Added, #1: 1	دِيَةُ الْقَتْلِ
u'دِيَةٌ قَتِيلٌ':Added, #1: 1	دِيَةَ الْقَتِيلَيْنِ
u'دِيَةٌ قَتِيلٌ':Added, #1: 1	دِيَةُ قَتِيلِ
u'دِيَةٌ قَتِيلٌ':Added, #1: 1	دِيَةُ قَتِيلِهِ
u'دِيَةٌ قَتِيلٌ':Added, #2: 2	دِيَةِ الْقَتِيلِ
u'دِيَةٌ قَتِيلٌ':Added, #3: 3	دِيَةِ قَتِيلِهِ
u'دِيَةٌ قَوَد':Added, #5: 5	دِيَةُ الْقَتِيلِ
u'دِيَةٌ كَافِرٌ':Added, #2: 2	دِيَةُ الْقَوَدِ
u'دِيَةٌ كَافِرٌ':Added, #1: 1	دِيَةُ الْكَافِرِ
u'دِيَةٌ كَافِرٌ':Added, #1: 1	دِيَةِ الْكَافِرِ
u'دِيَةٌ كَامِلٌ':Added, #1: 1	دِيَةُ كَافِرٍ
u'دِيَةٌ كَامِلٌ':Added, #1: 1	دِيَةُ كَامِلِ
u'دِيَةٌ كَفٌّ':Added, #1: 1	دِيَةٍ كَامِلَةٍ
u'دِيَةٌ كَفٌّ':Added, #1: 1	دِيَةُ الْكَفِّ
u'دِيَةٌ كَفٌّ':Added, #1: 1	دِيَةُ كَفِّهِ
u'دِيَةٌ كَلْبٌ':Added, #2: 2	دِيَةِ الْكَفِّ
u'دِيَةٌ لِسَانٌ':Added, #1: 1	دِيَةَ الْكَلْبِ
u'دِيَةٌ مَارِنٌ':Added, #1: 1	دِيَةِ اللِّسَانِ
u'دِيَةٌ مَالِكٌ':Added, #1: 1	دِيَةِ الْمَارِنِ
u'دِيَةٌ متبوع':Added, #1: 1	دِيَةِ الْمَالِكِ
u'دِيَةٌ مَجْرُوحٌ':Added, #1: 1	دِيَةُ الْمَتْبُوعِ
u'دِيَةٌ مَجْنِيٌّ':Added, #1: 1	دِيَةُ الْمَجْرُوحِ
u'دِيَةٌ مَجْنِيٌّ':Added, #1: 1	دِيَةَ الْمَجْنِيِّ
u'دِيَةٌ مَجُوسِيٌّ':Added, #2: 2	دِيَةِ الْمَجْنِيِّ
u'دِيَةٌ مَجُوسِيٌّ':Added, #2: 2	دِيَةَ الْمَجُوسِيِّ
u'دِيَةٌ مَجُوسِيٌّ':Added, #3: 3	دِيَةُ الْمَجُوسِيِّ
u'دِيَةٌ مَجُوسِيٌّ':Added, #4: 4	دِيَةِ الْمَجُوسِيِّ
u'دِيَةٌ مُخَفَّفٌ':Added, #5: 5	دِيَةُ مَجُوسِيٍّ
u'دِيَةٌ مُرْتَدٌّ':Added, #1: 1	دِيَةٍ مُخَفَّفَةٍ
u'دِيَةٌ مُسْلِمٌ':Added, #1: 1	دِيَةُ الْمُرْتَدَّةِ
u'دِيَةٌ مُسْلِمٌ':Added, #22: 22	دِيَةِ الْمُسْلِمِ
u'دِيَةٌ مُسْلِمٌ':Added, #2: 2	دِيَةُ الْمُسْلِمِ
u'دِيَةٌ مُسْلِمٌ':Added, #2: 2	دِيَةَ مُسْلِمٍ
u'دِيَةٌ مُسْلِمٌ':Added, #3: 3	دِيَةَ الْمُسْلِمِ
u'دِيَةٌ مُسْلِمٌ':Added, #7: 7	دِيَةُ مُسْلِمٍ
u'دِيَةٌ مَشْهُودٌ':Added, #8: 8	دِيَةِ مُسْلِمٍ
u'دِيَةٌ مَشْيٌ':Added, #1: 1	دِيَةَ الْمَشْهُودِ
u'دِيَةٌ مُعْتَرِفٌ':Added, #1: 1	دِيَةَ الْمَشْيِ
u'دِيَةٌ مُعْتَقٌ':Added, #2: 2	دِيَةِ الْمُعْتَرِفِ
u'دِيَةٌ مُغَلَّظ':Added, #1: 1	دِيَةُ الْمُعْتَقِ
u'دِيَةٌ مَقْتُولٌ':Added, #2: 2	دِيَةٍ مُغَلَّظَةٍ
u'دِيَةٌ مَقْتُولٌ':Added, #14: 14	دِيَةِ الْمَقْتُولِ
u'دِيَةٌ مَقْتُولٌ':Added, #2: 2	دِيَةَ الْمَقْتُولِ
u'دِيَةٌ مَقْتُولٌ':Added, #2: 2	دِيَةُ الْمَقْتُولِ
u'دِيَةٌ مَقْطُوعٌ':Added, #2: 2	دِيَةَ الْمَقْتُولَةِ
u'دِيَةٌ مَقْطُوعٌ':Added, #1: 1	دِيَةَ الْمَقْطُوعِ
u'دِيَةٌ مَنَافِعُ':Added, #1: 1	دِيَةُ الْمَقْطُوعِ
u'دِيَةٌ مُنْكَبٌّ':Added, #1: 1	دِيَةِ الْمَنَافِعِ
u'دِيَةٌ مَوْجُودٌ':Added, #1: 1	دِيَةِ الْمُنْكَبِّ
u'دِيَةٌ مُؤْمِنٌ':Added, #1: 1	دِيَةِ الْمَوْجُودِ
u'دِيَةٌ نَاخِسٌ':Added, #1: 1	دِيَةِ الْمُؤْمِنِ
u'دِيَةٌ نَائِمٌ':Added, #2: 2	دِيَةِ النَّاخِسِ
u'دِيَةٌ نِساءٌ':Added, #2: 2	دِيَةِ النَّائِمِ
u'دِيَةٌ نَصْرَانِيٌّ':Added, #2: 2	دِيَةُ نِسَاءِ
u'دِيَةٌ نَصْرَانِيٌّ':Added, #1: 1	دِيَةَ نَصْرَانِيٍّ
u'دِيَةٌ نَفْسٌ':Added, #3: 3	دِيَةُ نَصْرَانِيٍّ
u'دِيَةٌ نَفْسٌ':Added, #17: 17	دِيَةُ النَّفْسِ
u'دِيَةٌ نَفْسٌ':Added, #1: 1	دِيَةَ نَفْسٍ
u'دِيَةٌ نَفْسٌ':Added, #1: 1	دِيَةَ نَفْسِ
u'دِيَةٌ نَفْسٌ':Added, #1: 1	دِيَةَ نَفْسِهِ
u'دِيَةٌ نَفْسٌ':Added, #2: 2	دِيَةُ نَفْسِهِ
u'دِيَةٌ نَفْسٌ':Added, #35: 35	دِيَةِ النَّفْسِ
u'دِيَةٌ نَفْسٌ':Added, #3: 3	دِيَةُ نَفْسٍ
u'دِيَةٌ نَقْدٌ':Added, #6: 6	دِيَةَ النَّفْسِ
u'دِيَةٌ نَقْد':Added, #1: 1	دِيَةَ نَقْدٍ
u'دِيَةٌ واحد':Added, #1: 1	دِيَةَ نَقْدٍ
u'دِيَةٌ وَاحِدٌ':Added, #1: 1	دِيَةِ الْوَاحِدِ
u'دِيَةٌ واحد':Added, #1: 1	دِيَةِ الْوَاحِدِ
u'دِيَةٌ وَاحِدٌ':Added, #6: 6	دِيَةٍ وَاحِدَةٍ
u'دِيَةٌ وَاقِعٌ':Added, #6: 6	دِيَةٍ وَاحِدَةٍ
u'دِيَةٌ ولد':Added, #3: 3	دِيَةُ الْوَاقِعِ
u'دِيَةٌ وَلَدٌ':Added, #1: 1	دِيَةِ الْوَلَدِ
u'دِيَةٌ ولد':Added, #1: 1	دِيَةِ الْوَلَدِ
u'دِيَةٌ وَلَدٌ':Added, #3: 3	دِيَةُ الْوَلَدِ
u'دِيَةٌ يَدٌ':Added, #3: 3	دِيَةُ الْوَلَدِ
u'دِيَةٌ يَدٌ':Added, #15: 15	دِيَةَ الْيَدِ
u'دِيَةٌ يَدٌ':Added, #1: 1	دِيَةَ يَدٍ
u'دِيَةٌ يَدٌ':Added, #24: 24	دِيَةُ الْيَدِ
u'دِيَةٌ يَدٌ':Added, #26: 26	دِيَةِ الْيَدِ
u'دِيَةٌ يَدٌ':Added, #2: 2	دِيَةِ الْيَدَيْنِ
u'دِيَةٌ يَدٌ':Added, #2: 2	دِيَةِ يَدٍ
u'دِيَةٌ يَدٌ':Added, #3: 3	دِيَةُ يَدِهِ
u'دِيَةٌ يَدٌ':Added, #4: 4	دِيَةَ يَدِهِ
u'دِيَةٌ يَدٌ':Added, #5: 5	دِيَةَ يَدِ
u'دِيَةٌ يَدٌ':Added, #5: 5	دِيَةُ يَدٍ
u'دِيَةٌ يسار':Added, #6: 6	دِيَةِ يَدِهِ
u'دِيَةٌ يَسَارٌ':Added, #1: 1	دِيَةُ الْيَسَارِ
u'دِيَةٌ يسار':Added, #1: 1	دِيَةُ الْيَسَارِ
u'دِيَةٌ يَسَارٌ':Added, #2: 2	دِيَةَ الْيَسَارِ
u'دِيَةٌ يَمِينٌ':Added, #2: 2	دِيَةَ الْيَسَارِ
u'دِيَةٌ يَهُودِيٌّ':Added, #1: 1	دِيَةِ الْيَمِينِ
u'دِيَةٌ يَهُودِيٌّ':Added, #1: 1	دِيَةُ يَهُودِيٍّ
u'دِيَةٌ يَهُودِيٌّ':Added, #4: 4	دِيَةَ الْيَهُودِيِّ
u'دِيَةٌ يَهُودِيٌّ':Added, #4: 4	دِيَةِ الْيَهُودِيِّ
u'دِينٌ أَبٌ':Added, #8: 8	دِيَةُ الْيَهُودِيِّ
u'دَيْنٌ أَبٌ':Added, #1: 1	دِينُ الْأَبِ
u'دَيْنٌ أَبٌ':Added, #1: 1	دَيْنَ الْأَبِ
u'دَيْنٌ أَبٌ':Added, #1: 1	دَيْنُ الْأَبِ
u'دَيْنٌ اِبْنٌ':Added, #2: 2	دَيْنِ الْأَبِ
u'دَيْنٌ اِبْنٌ':Added, #1: 1	دَيْنِ ابْنِ
u'دَيْنٌ اِبْنٌ':Added, #1: 1	دَيْنَ ابْنِهِ
u'دِينٌ أَبْنَاءٌ':Added, #4: 4	دَيْنِ ابْنِهِ
u'دَيْنٌ إِتْلاَفٌ':Added, #1: 1	دِينِ أَبْنَاءِ
u'دَيْنٌ إِتْلاَفٌ':Added, #1: 1	دَيْنَ إتْلَافٍ
u'دَيْنٌ أَجَلٌ':Added, #1: 1	دَيْنُ الْإِتْلَافِ
u'دَيْنٌ أَجْنَبِيٌّ':Added, #1: 1	دَيْنُ الْأَجَلِ
u'دَيْنٌ أَجْنَبِيٌّ':Added, #1: 1	دَيْنُ أَجْنَبِيٍّ
u'دَيْنٌ أَجْنَبِيٌّ':Added, #3: 3	دَيْنُ الْأَجْنَبِيِّ
u'دَيْنٌ أَجْنَبِيٌّ':Added, #4: 4	دَيْنِ الْأَجْنَبِيِّ
u'دِينٌ أحَدٌ':Added, #5: 5	دَيْنَ الْأَجْنَبِيِّ
u'دِينٌ أحَدٌ':Added, #1: 1	دِينَ أَحَدٍ
u'دَيْنٌ أحَدٌ':Added, #1: 1	دِينِ أَحَدٍ
u'دِينٌ أحَدٌ':Added, #1: 1	دَيْنَ أَحَدِ
u'دَيْنٌ آدَمِيٌّ':Added, #1: 1	دِينِ الْأَحَدِ
u'دَيْنٌ آدَمِيٌّ':Added, #3: 3	دَيْنَ الْآدَمِيِّ
u'دَيْنٌ آدَمِيٌّ':Added, #3: 3	دَيْنِ الْآدَمِيِّ
u'دَيْنٌ إِذْنٌ':Added, #8: 8	دَيْنُ الْآدَمِيِّ
u'دَيْنٌ إِذْنٌ':Added, #1: 1	دَيْن الْإِذْنِ
u'دِينٌ إِسْلامٌ':Added, #4: 4	دَيْنِ الْإِذْنِ
u'دِينٌ إِسْلامٌ':Added, #11: 11	دِينُ الْإِسْلَامِ
u'دِينٌ إِسْلامٌ':Added, #12: 12	دِينَ الْإِسْلَامِ
u'دِينٌ إِسْلامٌ':Added, #1: 1	دِينَ الإِسْلاَمِ
u'دَيْنٌ إِسْلامٌ':Added, #1: 1	دِينِ الإِسْلاَمِ
u'دِينٌ إِسْلامٌ':Added, #2: 2	دَيْنِ إسْلَامِهِ
u'دَيْنٌ إِسْلامٌ':Added, #2: 2	دِينِ الإِسْلامِ
u'دَيْنٌ إِسْلامٌ':Added, #3: 3	دَيْنَ الْإِسْلَامِ
u'دِينٌ إِسْلامٌ':Added, #3: 3	دَيْنُ الْإِسْلَامِ
u'دَيْنٌ أصْغَرٌ':Added, #48: 48	دِينِ الْإِسْلَامِ
u'دَيْنٌ أَصْغَرُ':Added, #1: 1	دَيْنِ الْأَصْغَرِ
u'دَيْنٌ أكْبَرُ':Added, #1: 1	دَيْنِ الْأَصْغَرِ
u'دَيْنٌ ألْفٌ':Added, #1: 1	دَيْنِ الْأَكْبَرِ
u'دَيْنٌ أَلْفٌ':Added, #1: 1	دَيْنِ أَلْفٍ
u'دَيْنٌ ألْفٌ':Added, #1: 1	دَيْنِ أَلْفٍ
u'دَيْنٌ أَلْفٌ':Added, #2: 2	دَيْنُ أَلْفٍ
u'دِينٌ اللهُ':Added, #2: 2	دَيْنُ أَلْفٍ
u'دِينٌ الْمَرْءُ':Added, #2: 2	دِينَ اللهِ
u'دَيْنٌ الْمَرْأَةُ':Added, #1: 1	دِينِ الْمَرْءِ
u'دَيْنٌ الْمَرْأَةُ':Added, #1: 1	دَيْنَ الْمَرْأَةِ
u'دِينٌ الْمَرْأَةُ':Added, #1: 1	دَيْنِ الْمَرْأَةِ
u'دِينٌ أُمٌّ':Added, #2: 2	دِينِ الْمَرْأَةِ
u'دَيْنٌ أُمٌّ':Added, #1: 1	دِينِ الْأُمِّ
u'دَيْنٌ أُمٌّ':Added, #1: 1	دَيْنَ الْأُمِّ
u'دِينٌ أُمٌّ':Added, #1: 1	دَيْنِ الْأُمِّ
u'دَيْنٌ أُمٌّ':Added, #1: 1	دِينِ أُمِّهِ
u'دَيْنٌ أمَةٌ':Added, #4: 4	دَيْنِ أُمِّهِ
u'دِينٌ أُمَّةٌ':Added, #1: 1	دَيْنَ الْأَمَةِ
u'دَيْنٌ آمِرٌ':Added, #2: 2	دِينِ الْأُمَّةِ
u'دَيْنٌ إِنْسانٌ':Added, #1: 1	دَيْنَ الْآمِرِ
u'دَيْنٌ إِنْسانٌ':Added, #1: 1	دَيْنَ الْإِنْسَانِ
u'دَيْنٌ إِنْسانٌ':Added, #1: 1	دَيْنِ إنْسَانٍ
u'دِينٌ أهْلٌ':Added, #2: 2	دَيْنَ إنْسَانٍ
u'دِينٌ أهْلٌ':Added, #14: 14	دِينِ أَهْلِ
u'دِينٌ أهْلٌ':Added, #2: 2	دِينَ أَهْلِ
u'دِينٌ بَاطِلٌ':Added, #6: 6	دِينُ أَهْلِ
u'دَيْنٌ بَائِعٌ':Added, #1: 1	دِينٍ بَاطِلٍ
u'دَيْنٌ بُرٌّ':Added, #2: 2	دَيْنِ الْبَائِعِ
u'دَيْنٌ بَعْضٌ':Added, #1: 1	دَيْنِ الْبُرِّ
u'دَيْنٌ بَعْضٌ':Added, #3: 3	دَيْنَ الْبَعْضِ
u'دَيْنٌ بَيِّنَةٌ':Added, #7: 7	دَيْنَ بَعْضِ
u'دِينٌ تَاجِرٌ':Added, #1: 1	دَيْنُ الْبَيِّنَةِ
u'دَيْنٌ تِجَارَةٌ':Added, #1: 1	دِينِ التَّاجِرِ
u'دَيْنٌ تِجَارَةٌ':Added, #11: 11	دَيْنِ التِّجَارَةِ
u'دَيْنٌ تِجَارَةٌ':Added, #1: 1	دَيْنِ تِجَارَةٍ
u'دَيْنٌ تِجَارَةٌ':Added, #2: 2	دَيْنَ التِّجَارَةِ
u'دَيْنٌ تِجَارَةٌ':Added, #2: 2	دَيْنُ تِجَارَةٍ
u'دَيْنٌ ثَابِتٌ':Added, #7: 7	دَيْنُ التِّجَارَةِ
u'دَيْنٌ ثَمَنٌ':Added, #3: 3	دَيْنٍ ثَابِتٍ
u'دِينٌ جَارِحٌ':Added, #1: 1	دَيْنُ الثَّمَنِ
u'دَيْنٌ جَمِيع':Added, #1: 1	دِينُ جَارِحٍ
u'دَيْنٌ جِنَايَةٌ':Added, #1: 1	دَيْنِ الْجَمِيعِ
u'دَيْنٌ جَنِينٌ':Added, #1: 1	دَيْنِ الْجِنَايَةِ
u'دَيْنٌ جَهالَة':Added, #1: 1	دَيْنَ الْجَنِينِ
u'دَيْنٌ حادِثٌ':Added, #1: 1	دَيْنَ الْجَهَالَةِ
u'دَيْنٌ حامِلٌ':Added, #6: 6	دَيْنٍ حَادِثٍ
u'دَيْنٌ حائِزٌ':Added, #1: 1	دَيْنِ الْحَامِلِ
u'دَيْنٌ حُرٌّ':Added, #1: 1	دَيْنِ الْحَائِزِ
u'دَيْنٌ حُرِّيَّةٌ':Added, #2: 2	دَيْنَ الْحُرِّ
u'دِينٌ حَقٌّ':Added, #1: 1	دَيْنَ الْحُرِّيَّةِ
u'دِينٌ حَقٌّ':Added, #12: 12	دِينَ الْحَقِّ
u'دَيْنٌ حَقٌّ':Added, #1: 1	دِينِ الْحَقِّ
u'دِينٌ حَقٌّ':Added, #1: 1	دَيْنَ الْحَقِّ
u'دِينٌ حَنِيفٌ':Added, #1: 1	دِينِ حَقٍّ
u'دِينٌ حَنِيفيٌّ':Added, #2: 2	دِينَ الْحَنِيفَةِ
u'دِينٌ حَنِيفِيٌّ':Added, #2: 2	دِينِ الْحَنِيفِيَّةِ
u'دَيْنٌ حَوَالَةٌ':Added, #2: 2	دِينِ الْحَنِيفِيَّةِ
u'دَيْنٌ حَوَالَةٌ':Added, #1: 1	دَيْنَ الْحَوَالَةِ
u'دَيْنٌ حَيٌّ':Added, #2: 2	دَيْنِ الْحَوَالَةِ
u'دَيْنٌ حَيٌّ':Added, #1: 1	دَيْنَ الْحَيِّ
u'دَيْنٌ حَيٌّ':Added, #2: 2	دَيْنَ حَيٍّ
u'دَيْنٌ خراج':Added, #3: 3	دَيْنِ الْحَيِّ
u'دَيْنٌ خَرَاجٌ':Added, #1: 1	دَيْنُ الْخَرَاجِ
u'دَيْنٌ خَصْمٌ':Added, #1: 1	دَيْنُ الْخَرَاجِ
u'دِينٌ خَلِيلٌ':Added, #1: 1	دَيْنَ خَصْمِهِ
u'دَيْنٌ دَائِنٌ':Added, #5: 5	دِينِ خَلِيلِهِ
u'دَيْنٌ دِيَةٌ':Added, #1: 1	دَيْنِ دَائِنِهِ
u'دَيْنٌ ذِمِّيٌّ':Added, #1: 1	دَيْنِ الدِّيَةِ
u'دَيْنٌ ذَهَبٌ':Added, #1: 1	دَيْنُ الذِّمِّيِّ
u'دَيْنٌ رَاجِعٌ':Added, #1: 1	دَيْنٍ ذَهَبٍ
u'دَيْنٌ رَاهِنٌ':Added, #1: 1	دَيْنَ الرَّاجِعِ
u'دَيْنٌ رَاهِنٌ':Added, #1: 1	دَيْنَ الرَّاهِنِ
u'دَيْنٌ رَبُّ':Added, #2: 2	دَيْنِ الرَّاهِنِ
u'دَيْنٌ رَجُلٌ':Added, #2: 2	دَيْنِ رَبِّ
u'دَيْنٌ رَجُلٌ':Added, #2: 2	دَيْنِ رَجُلٍ
u'دَيْنٌ رِدَّةٌ':Added, #3: 3	دَيْنَ رَجُلٍ
u'دَيْنٌ رِدَّةٌ':Added, #1: 1	دَيْنَ الرِّدَّةِ
u'دَيْنٌ رِدَّةٌ':Added, #1: 1	دَيْنَ رِدَّتِهِ
u'دِينٌ رُسُلٌ':Added, #1: 1	دَيْنِ رِدَّتِهِ
u'دِينٌ رَسُولٌ':Added, #1: 1	دِينِ الرُّسُلِ
u'دِينٌ رَسُولٌ':Added, #1: 1	دِينَ الرّسُولِ
u'دَيْنٌ رَهْنٌ':Added, #2: 2	دِينِ الرَّسُولِ
u'دَيْنٌ رَهْنٌ':Added, #4: 4	دَيْنَ الرَّهْنِ
u'دَيْنٌ رَهْنٌ':Added, #7: 7	دَيْنُ الرَّهْنِ
u'دَيْنٌ زَكاةٌ':Added, #9: 9	دَيْنِ الرَّهْنِ
u'دَيْنٌ زَكاةٌ':Added, #1: 1	دَيْنِ زَكَاةِ
u'دَيْنٌ زَكاةٌ':Added, #2: 2	دَيْنَ زَكَاةٍ
u'دَيْنٌ زَكاةٌ':Added, #5: 5	دَيْنَ الزَّكَاةِ
u'دَيْنٌ زَكاةٌ':Added, #5: 5	دَيْنُ الزَّكَاةِ
u'دَيْنٌ زَوْجٌ':Added, #8: 8	دَيْنِ الزَّكَاةِ
u'دَيْنٌ زَوْجٌ':Added, #1: 1	دَيْنُ الزَّوْجِ
u'دَيْنٌ زَوْجَةٌ':Added, #1: 1	دَيْنِ الزَّوْجِ
u'دَيْنٌ زَوْجَةٌ':Added, #1: 1	دَيْنِ الزَّوْجَةِ
u'دَيْنٌ زَيْدٌ':Added, #1: 1	دَيْنِ زَوْجَتِهِ
u'دِينٌ زَيْدٌ':Added, #1: 1	دَيْنِ زَيْدٍ
u'دَيْنٌ سَابِقٌ':Added, #2: 2	دِينُ زَيْدٍ
u'دَيْنٌ سَفِيهٌ':Added, #1: 1	دَيْنٍ سَابِقٍ
u'دَيْنٌ سَلَمٌ':Added, #1: 1	دَيْنِ السَّفِيهِ
u'دَيْنٌ سَلَمٌ':Added, #17: 17	دَيْنِ السَّلَمِ
u'دَيْنٌ سَلَمٌ':Added, #1: 1	دَيْن السَّلَمِ
u'دَيْنٌ سَلَمٌ':Added, #1: 1	دَيْنَ سَلَمٍ
u'دَيْنٌ سَلَمٌ':Added, #2: 2	دَيْنَ السَّلَمِ
u'دَيْنٌ سَلَمٌ':Added, #3: 3	دَيْنِ سَلَمٍ
u'دَيْنٌ سَلَمٌ':Added, #4: 4	دَيْنُ السَّلَمِ
u'دِينٌ سَمَاوِيٌّ':Added, #4: 4	دَيْنُ سَلَمٍ
u'دَيْنٌ سَيِّدٌ':Added, #1: 1	دِينٍ سَمَاوِيٍّ
u'دَيْنٌ شَرْعِيٌّ':Added, #3: 3	دَيْنِ السَّيِّدِ
u'دَيْنٌ صَاحِبٌ':Added, #2: 2	دَيْنٍ شَرْعِيٍّ
u'دَيْنٌ صَاحِبٌ':Added, #1: 1	دَيْنَ صَاحِبِ
u'دَيْنٌ صَاحِبٌ':Added, #1: 1	دَيْنِ صَاحِبِ
u'دَيْنٌ صَبِيٌّ':Added, #3: 3	دَيْنِ صَاحِبِهِ
u'دَيْنٌ صِحَّةٌ':Added, #2: 2	دَيْنَ الصَّبِيِّ
u'دَيْنٌ صِحَّةٌ':Added, #1: 1	دَيْنِ صِحَّةٍ
u'دَيْنٌ صِحَّةٌ':Added, #43: 43	دَيْنُ الصِّحَّةِ
u'دَيْنٌ صِحَّةٌ':Added, #8: 8	دَيْنَ الصِّحَّةِ
u'دَيْنٌ صداق':Added, #9: 9	دَيْنِ الصِّحَّةِ
u'دَيْنٌ صداق':Added, #1: 1	دَيْنَ الصَّدَاقِ
u'دَيْنٌ صَدَاقٌ':Added, #1: 1	دَيْنُ الصَّدَاقِ
u'دَيْنٌ صَدَاقٌ':Added, #1: 1	دَيْنَ الصَّدَاقِ
u'دِينٌ صِدْقٌ':Added, #1: 1	دَيْنُ الصَّدَاقِ
u'دَيْنٌ صدقة':Added, #1: 1	دِينُ صِدْقٍ
u'دَيْنٌ صَدَقَةٌ':Added, #1: 1	دَيْنُ صَدَقَةِ
u'دَيْنٌ ضَامِنٌ':Added, #1: 1	دَيْنُ صَدَقَةِ
u'دَيْنٌ طَالِبٌ':Added, #1: 1	دَيْنِ الضَّامِنِ
u'دَيْنٌ طَالِبٌ':Added, #1: 1	دَيْنُ الطَّالِبِ
u'دَيْنٌ طَالِبٌ':Added, #4: 4	دَيْنَ الطَّالِبِ
u'دَيْنٌ طِفْلٌ':Added, #7: 7	دَيْنِ الطَّالِبِ
u'دَيْنٌ عِبَادٌ':Added, #2: 2	دَيْنِ الطِّفْلِ
u'دَيْنٌ عِبَادٌ':Added, #2: 2	دَيْنَ الْعِبَادِ
u'دَيْنٌ عِبَادٌ':Added, #3: 3	دَيْنُ الْعِبَادِ
u'دَيْنٌ عَبْدٌ':Added, #4: 4	دَيْنِ الْعِبَادِ
u'دَيْنٌ عَبْدٌ':Added, #11: 11	دَيْنِ الْعَبْدِ
u'دِينٌ عَبْدٌ':Added, #14: 14	دَيْنُ الْعَبْدِ
u'دِينٌ عَبْدٌ':Added, #1: 1	دِينَ الْعَبْدِ
u'دَيْنٌ عَبْدٌ':Added, #1: 1	دِينِ عَبْدِ
u'دَيْنٌ عَبْدٌ':Added, #1: 1	دَيْنُ عَبْدٍ
u'دَيْنٌ عَبْدٌ':Added, #1: 1	دَيْنَ عَبْدِهِ
u'دَيْنٌ عَبْدٌ':Added, #22: 22	دَيْنَ الْعَبْدِ
u'دِينٌ عَبَدَةٌ':Added, #3: 3	دَيْنِ عَبْدِهِ
u'دَيْنٌ عَدْلٌ':Added, #1: 1	دِينُ عَبَدَةِ
u'دِينٌ عَرَبٌ':Added, #1: 1	دَيْنُ الْعَدْلِ
u'دَيْنٌ عَرَضٌ':Added, #1: 1	دِينِ الْعَرَبِ
u'دَيْنٌ عَرَضٌ':Added, #1: 1	دَيْنُ الْعَرَضِ
u'دَيْنٌ عَرَضٌ':Added, #1: 1	دَيْنِ الْعَرَضِ
u'دَيْنٌ عين':Added, #1: 1	دَيْنُ عَرَضٍ
u'دَيْنٌ عين':Added, #2: 2	دَيْنَ الْعَيْنِ
u'دَيْنٌ عَيْنٌ':Added, #2: 2	دَيْنِ الْعَيْنِ
u'دَيْنٌ عَيْنٌ':Added, #2: 2	دَيْنَ الْعَيْنِ
u'دَيْنٌ عَيْن':Added, #2: 2	دَيْنِ الْعَيْنِ
u'دَيْنٌ عَيْن':Added, #2: 2	دَيْنَ الْعَيْنِ
u'دَيْنٌ غَائِبٌ':Added, #2: 2	دَيْنِ الْعَيْنِ
u'دَيْنٌ غَائِبٌ':Added, #1: 1	دَيْنَ الْغَائِبِ
u'دَيْنٌ غَائِبٌ':Added, #1: 1	دَيْنَ غَائِبٍ
u'دَيْنٌ غَائِبٌ':Added, #2: 2	دَيْنِ غَائِبٍ
u'دَيْنٌ غرماء':Added, #6: 6	دَيْنِ الْغَائِبِ
u'دَيْنٌ غرماء':Added, #10: 10	دَيْنَ الْغُرَمَاءِ
u'دَيْنٌ غرماء':Added, #1: 1	دَيْنُ غُرَمَاءِ
u'دَيْنٌ غرماء':Added, #1: 1	دَيْنِ غُرَمَاءِ
u'دَيْنٌ غرماء':Added, #2: 2	دَيْنَ غُرَمَاءِ
u'دَيْنٌ غرماء':Added, #3: 3	دَيْنُ الْغُرَمَاءِ
u'دَيْنٌ غَرِيمٌ':Added, #8: 8	دَيْنِ الْغُرَمَاءِ
u'دَيْنٌ غَرِيمٌ':Added, #2: 2	دَيْنَ غَرِيمِ
u'دَيْنٌ غَرِيمٌ':Added, #3: 3	دَيْنَ الْغَرِيمِ
u'دَيْنٌ غَرِيمٌ':Added, #5: 5	دَيْنُ الْغَرِيمِ
u'دَيْنٌ غير':Added, #8: 8	دَيْنِ الْغَرِيمِ
u'دَيْنٌ غير':Added, #1: 1	دَيْنَ الْغَيْرِ
u'دَيْنٌ غَيْرٌ':Added, #1: 1	دَيْنُ الْغَيْرِ
u'دَيْنٌ غَيْرٌ':Added, #1: 1	دَيْنَ الْغَيْرِ
u'دِينٌ غير':Added, #1: 1	دَيْنُ الْغَيْرِ
u'دِينٌ غَيْرٌ':Added, #1: 1	دِينِ غَيْرِ
u'دَيْنٌ غير':Added, #1: 1	دِينِ غَيْرِ
u'دَيْنٌ غَيْرٌ':Added, #1: 1	دَيْنُ غَيْرِهِ
u'دَيْنٌ غير':Added, #1: 1	دَيْنُ غَيْرِهِ
u'دَيْنٌ غَيْرٌ':Added, #23: 23	دَيْنَ غَيْرِهِ
u'دَيْنٌ غير':Added, #23: 23	دَيْنَ غَيْرِهِ
u'دَيْنٌ غَيْرٌ':Added, #2: 2	دَيْنِ غَيْرِ
u'دَيْنٌ غير':Added, #2: 2	دَيْنِ غَيْرِ
u'دَيْنٌ غَيْرٌ':Added, #7: 7	دَيْنِ غَيْرِهِ
u'دَيْنٌ غير':Added, #7: 7	دَيْنِ غَيْرِهِ
u'دَيْنٌ غَيْرٌ':Added, #8: 8	دَيْنِ الْغَيْرِ
u'دَيْنٌ فَادِحٌ':Added, #8: 8	دَيْنِ الْغَيْرِ
u'دَيْنٌ فَرْعٌ':Added, #1: 1	دَيْنٍ فَادِحٍ
u'دَيْنٌ فَقِيرٌ':Added, #6: 6	دَيْنِ فَرْعِهِ
u'دِينٌ فُلاَنٌ':Added, #1: 1	دَيْنَ الْفَقِيرِ
u'دَيْنٌ فُلاَنٌ':Added, #1: 1	دِينِ فُلَانٍ
u'دَيْنٌ قَاتِلٌ':Added, #8: 8	دَيْنَ فُلَانٍ
u'دَيْنٌ قَاتِلٌ':Added, #1: 1	دَيْنَ الْقَاتِلِ
u'دَيْنٌ قَاتِلٌ':Added, #1: 1	دَيْنُ الْقَاتِلِ
u'دَيْنٌ قَاتِلٌ':Added, #1: 1	دَيْنِ الْقَاتِلِ
u'دَيْنٌ قَاتِلٌ':Added, #1: 1	دَيْنُ الْقَاتِلَةِ
u'دَيْنٌ قَائِمٌ':Added, #1: 1	دَيْنِ الْقَاتِلَةِ
u'دَيْنٌ قَتِيلٌ':Added, #2: 2	دَيْنٍ قَائِمٍ
u'دَيْنٌ قَتِيلٌ':Added, #1: 1	دَيْنَ الْقَتِيلِ
u'دَيْنٌ قَدْرٌ':Added, #1: 1	دَيْنِ الْقَتِيلِ
u'دَيْنٌ قَرْضٌ':Added, #1: 1	دَيْنُ قَدْرِ
u'دَيْنٌ قَرْضٌ':Added, #1: 1	دَيْنَ قَرْضٍ
u'دَيْنٌ قَرْضٌ':Added, #2: 2	دَيْنَ الْقَرْضِ
u'دَيْنٌ قَرْضٌ':Added, #5: 5	دَيْنُ الْقَرْضِ
u'دِينٌ قَوْمٌ':Added, #5: 5	دَيْنِ الْقَرْضِ
u'دِينٌ قَوْمٌ':Added, #1: 1	دِينُ قَوْمِ
u'دِينٌ قَوْمٌ':Added, #1: 1	دِينَ قَوْمِهِ
u'دِينٌ قَوْمٌ':Added, #4: 4	دِينِ قَوْمِ
u'دِينٌ قَيِّمٌ':Added, #8: 8	دِينِ قَوْمِهِ
u'دَيْنٌ كِتَابَةٌ':Added, #6: 6	دِينُ الْقَيِّمَةِ
u'دَيْنٌ كِتَابَةٌ':Added, #1: 1	دَيْنَ كِتَابَةٍ
u'دَيْنٌ كِتَابَةٌ':Added, #24: 24	دَيْنِ الْكِتَابَةِ
u'دَيْنٌ كِتَابَةٌ':Added, #2: 2	دَيْنِ كِتَابَةٍ
u'دَيْنٌ كِتَابَةٌ':Added, #4: 4	دَيْنُ الْكِتَابَةِ
u'دَيْنٌ كِرَاءٌ':Added, #6: 6	دَيْنَ الْكِتَابَةِ
u'دَيْنٌ كَفَّارٌ':Added, #3: 3	دَيْنَ كِرَاءٍ
u'دِينٌ كُفَّارٌ':Added, #1: 1	دَيْنُ الْكَفَّارَةِ
u'دَيْنٌ كَفَّارَةٌ':Added, #1: 1	دِينِ كُفَّارِ
u'دَيْنٌ كَفَّارَةٌ':Added, #1: 1	دَيْنُ الْكَفَّارَةِ
u'دَيْنٌ كَفَالَةٌ':Added, #1: 1	دَيْنَ كَفَّارَةٍ
u'دَيْنٌ كَفَالَةٌ':Added, #1: 1	دَيْنَ الْكَفَالَةِ
u'دَيْنٌ كَفَالَةٌ':Added, #1: 1	دَيْنِ الْكَفَالَةِ
u'دِينٌ كفر':Added, #1: 1	دَيْنَ كَفَالَةٍ
u'دِينٌ كُفْرٌ':Added, #1: 1	دِينِ الْكُفْرِ
u'دَيْنٌ كَفِيلٌ':Added, #1: 1	دِينِ الْكُفْرِ
u'دَيْنٌ كَفِيلٌ':Added, #1: 1	دَيْنِ الْكَفِيلِ
u'دَيْنٌ لاَزِمٌ':Added, #2: 2	دَيْنُ الْكَفِيلِ
u'دَيْنٌ مُتَبَرِّعٌ':Added, #4: 4	دَيْنٍ لَازِمٍ
u'دَيْنٌ مثل':Added, #1: 1	دَيْنِ الْمُتَبَرِّعِ
u'دَيْنٌ مِثْلٌ':Added, #2: 2	دَيْنُ مِثْلِهِ
u'دَيْنٌ مُجَرَّدٌ':Added, #2: 2	دَيْنُ مِثْلِهِ
u'دِينٌ مَجُوسٌ':Added, #1: 1	دَيْنٍ مُجَرَّدٍ
u'دَيْنٌ مُحْتَالٌ':Added, #1: 1	دِينِ الْمَجُوسِ
u'دَيْنٌ مُحْتَالٌ':Added, #1: 1	دَيْنَ الْمُحْتَالِ
u'دَيْنٌ مُحْتَكِرٌ':Added, #3: 3	دَيْنِ الْمُحْتَالِ
u'دَيْنٌ مَحْجُورٌ':Added, #1: 1	دَيْنِ الْمُحْتَكِرِ
u'دِينٌ مُحَمَّدٌ':Added, #1: 1	دَيْنَ مَحْجُورٍ
u'دِينٌ مُحَمَّدٌ':Added, #10: 10	دِينِ مُحَمَّدٍ
u'دِينٌ مُحَمَّدٌ':Added, #1: 1	دِينِ مُحَمّدٍ
u'دِينٌ مُحَمَّدٌ':Added, #2: 2	دِينَ مُحَمَّدٍ
u'دِينٌ مُحَمَّدٌ':Added, #3: 3	دِينُ مُحَمّدٍ
u'دَيْنٌ مُحِيل':Added, #5: 5	دِينَ مُحَمّدٍ
u'دَيْنٌ مُحِيل':Added, #2: 2	دَيْنَ الْمُحِيلِ
u'دَيْنٌ مُدِيرٌ':Added, #7: 7	دَيْنِ الْمُحِيلِ
u'دَيْنٌ مُرْتَدٌّ':Added, #1: 1	دَيْنَ الْمُدِيرِ
u'دَيْنٌ مُرْتَهِنٌ':Added, #1: 1	دَيْنُ الْمُرْتَدِّ
u'دَيْنٌ مُرْتَهِنٌ':Added, #10: 10	دَيْنَ الْمُرْتَهِنِ
u'دَيْنٌ مُرْتَهِنٌ':Added, #15: 15	دَيْنُ الْمُرْتَهِنِ
u'دَيْنٌ مَرَضٌ':Added, #17: 17	دَيْنِ الْمُرْتَهِنِ
u'دَيْنٌ مَرَضٌ':Added, #10: 10	دَيْنُ الْمَرَضِ
u'دَيْنٌ مَرَضٌ':Added, #10: 10	دَيْنِ الْمَرَضِ
u'دَيْنٌ مَرْهُونٌ':Added, #6: 6	دَيْنَ الْمَرَضِ
u'دَيْنٌ مَرِيضٌ':Added, #1: 1	دَيْنَ الْمَرْهُونِ
u'دَيْنٌ مَرِيضٌ':Added, #1: 1	دَيْنُ الْمَرِيضِ
u'دَيْنٌ مُسْتَحَقٌّ':Added, #3: 3	دَيْنِ الْمَرِيضِ
u'دَيْنٌ مُسْتَعِيرٌ':Added, #1: 1	دَيْنٍ مُسْتَحَقٍّ
u'دَيْنٌ مُسْتَعِيرٌ':Added, #1: 1	دَيْنَ الْمُسْتَعِيرِ
u'دَيْنٌ مُسْتَقِرٌّ':Added, #1: 1	دَيْنِ الْمُسْتَعِيرِ
u'دَيْنٌ مُسْلِمٌ':Added, #8: 8	دَيْنٍ مُسْتَقِرٍّ
u'دَيْنٌ مُسْلِمٌ':Added, #1: 1	دَيْن الْمُسْلِمِ
u'دَيْنٌ مُسْلِمٌ':Added, #1: 1	دَيْنِ الْمُسْلِمِ
u'دَيْنٌ مُسْلِمٌ':Added, #1: 1	دَيْنِ مُسْلِمٍ
u'دِينٌ مَسِيحٌ':Added, #2: 2	دَيْنَ مُسْلِمٍ
u'دَيْنٌ مُشْتَرَكٌ':Added, #3: 3	دِينِ الْمَسِيحِ
u'دِينٌ مُشْتَرِي':Added, #3: 3	دَيْنٍ مُشْتَرَكٍ
u'دِينٌ مَشْرُوعٌ':Added, #1: 1	دِينِ مُشْتَرِيهِ
u'دَيْنٌ مُضَارِبٌ':Added, #1: 1	دِينٍ مَشْرُوعٍ
u'دَيْنٌ مَضْمُونٌ':Added, #2: 2	دَيْنِ الْمُضَارِبِ
u'دَيْنٌ مَضْمُونٌ':Added, #1: 1	دَيْنَ الْمَضْمُونِ
u'دَيْنٌ مُطَالَبٌ':Added, #1: 1	دَيْنُ الْمَضْمُونِ
u'دِينٌ مَظْلُومٌ':Added, #1: 1	دَيْنٍ مُطَالَبٍ
u'دَيْنٌ مُعَامَلَةٌ':Added, #1: 1	دِينِ الْمَظْلُومِ
u'دَيْنٌ مُعَامَلَةٌ':Added, #1: 1	دَيْنُ الْمُعَامَلَةِ
u'دَيْنٌ مُعَامَلَةٌ':Added, #1: 1	دَيْنِ مُعَامَلَتِهِ
u'دَيْنٌ مُعَامَلَةٌ':Added, #2: 2	دَيْنَ مُعَامَلَةٍ
u'دَيْنٌ مُعَامَلَةٌ':Added, #3: 3	دَيْنُ مُعَامَلَةٍ
u'دَيْنٌ مُعَامَلَةٌ':Added, #4: 4	دَيْنَ الْمُعَامَلَةِ
u'دَيْنٌ مُعَرَّفٌ':Added, #9: 9	دَيْنِ الْمُعَامَلَةِ
u'دَيْنٌ مَعْرُوفٌ':Added, #3: 3	دَيْنٍ مُعَرَّفٍ
u'دَيْنٌ مُعْسِرٌ':Added, #1: 1	دَيْنٍ مَعْرُوفٍ
u'دَيْنٌ مَعْلُومٌ':Added, #1: 1	دَيْنَ الْمُعْسِرِ
u'دَيْنٌ مُعَيَّنٌ':Added, #1: 1	دَيْنٍ مَعْلُومٍ
u'دِينٌ مَغْصُوب':Added, #1: 1	دَيْنٍ مُعَيَّنٍ
u'دَيْنٌ مُفَاوَضَةٌ':Added, #1: 1	دِينِ الْمَغْصُوبِ
u'دَيْنٌ مَفْقُودٌ':Added, #1: 1	دَيْنِ الْمُفَاوَضَةِ
u'دَيْنٌ مُفْلِسٌ':Added, #1: 1	دَيْنُ الْمَفْقُودِ
u'دَيْنٌ مُفْلِسٌ':Added, #1: 1	دَيْنِ الْمُفْلِسِ
u'دَيْنٌ مُقَارِنٌ':Added, #2: 2	دَيْنُ الْمُفْلِسِ
u'دَيْنٌ مَقْتُولٌ':Added, #2: 2	دَيْنٍ مُقَارِنٍ
u'دَيْنٌ مَقْتُولٌ':Added, #1: 1	دَيْنُ الْمَقْتُولِ
u'دَيْنٌ مُقْرِضٌ':Added, #1: 1	دَيْنِ الْمَقْتُولِ
u'دَيْنٌ مُقْرِضٌ':Added, #1: 1	دَيْنَ الْمُقْرِضِ
u'دَيْنٌ مُكَاتَبَةٌ':Added, #1: 1	دَيْنُ الْمُقْرِضِ
u'دِينٌ مِلَّةٌ':Added, #1: 1	دَيْنِ الْمُكَاتَبَةِ
u'دِينٌ مَلِكٌ':Added, #1: 1	دِينُ الْمِلَّةِ
u'دِينٌ مَلِكٌ':Added, #1: 1	دِينَ الْمَلِكِ
u'دَيْنٌ مَمْلُوكٌ':Added, #3: 3	دِينِ الْمَلِكِ
u'دَيْنٌ مَمْلُوكٌ':Added, #1: 1	دَيْنَ الْمَمْلُوكِ
u'دَيْنٌ مَهْرٌ':Added, #1: 1	دَيْنُ الْمَمْلُوكِ
u'دَيْنٌ مَهْرٌ':Added, #1: 1	دَيْنَ الْمَهْرِ
u'دَيْنٌ مَهْرٌ':Added, #2: 2	دَيْنُ الْمَهْرِ
u'دَيْنٌ مَهْرٌ':Added, #2: 2	دَيْنِ مَهْرٍ
u'دَيْنٌ مُؤَجَّلٌ':Added, #3: 3	دَيْنِ الْمَهْرِ
u'دَيْنٌ مُؤَجِّلٌ':Added, #10: 10	دَيْنٍ مُؤَجَّلٍ
u'دَيْنٌ مُودَعٌ':Added, #1: 1	دَيْنِ الْمُؤَجِّلِ
u'دَيْنٌ مُودِعٌ':Added, #1: 1	دَيْنَ الْمُودَعِ
u'دَيْنٌ مُودِعٌ':Added, #1: 1	دَيْنَ مُودِعِهِ
u'دَيْنٌ مُوَرِّث':Added, #3: 3	دَيْنَ الْمُودِعِ
u'دَيْنٌ مُوَرِّث':Added, #1: 1	دَيْنَ الْمُوَرِّثِ
u'دَيْنٌ مَوْرُوثٌ':Added, #1: 1	دَيْنِ مُوَرِّثٍ
u'دَيْنٌ مُوَكِّلٌ':Added, #1: 1	دَيْنٍ مَوْرُوثٍ
u'دَيْنٌ مُوَكِّلٌ':Added, #1: 1	دَيْنَ الْمُوَكِّلِ
u'دَيْنٌ مُوَكِّلٌ':Added, #1: 1	دَيْنُ الْمُوَكِّلِ
u'دَيْنٌ مُوَكِّلٌ':Added, #1: 1	دَيْنَ مُوَكِّلِهِ
u'دِينٌ نَبِيٌّ':Added, #2: 2	دَيْنِ الْمُوَكِّلِ
u'دَيْنٌ نُجُومٌ':Added, #1: 1	دِينِ النَّبِيِّ
u'دَيْنٌ نذر':Added, #1: 1	دَيْنِ النُّجُومِ
u'دَيْنٌ نَذْرٌ':Added, #1: 1	دَيْنُ النَّذْرِ
u'دِينٌ نِساءٌ':Added, #1: 1	دَيْنُ النَّذْرِ
u'دَيْنٌ نصاب':Added, #1: 1	دِينِ النِّسَاءِ
u'دَيْنٌ نِصَابٌ':Added, #1: 1	دَيْنَ النِّصَابِ
u'دَيْنٌ نَصْرَانِيٌّ':Added, #1: 1	دَيْنَ النِّصَابِ
u'دِينٌ نَصْرَانِيٌّ':Added, #1: 1	دَيْنِ النَّصْرَانِيِّ
u'دِينٌ نَصْرَانِيٌّ':Added, #2: 2	دِينِ النَّصْرَانِيَّةِ
u'دِينٌ نَصْرَانِيَّةٌ':Added, #3: 3	دِينَ النَّصْرَانِيَّةِ
u'دِينٌ نَصْرَانِيَّةٌ':Added, #2: 2	دِينِ النَّصْرَانِيَّةِ
u'دَيْنٌ نَفْسٌ':Added, #3: 3	دِينَ النَّصْرَانِيَّةِ
u'دَيْنٌ نَفْسٌ':Added, #5: 5	دَيْنَ نَفْسِهِ
u'دَيْنٌ نَفَقَةٌ':Added, #5: 5	دَيْنِ نَفْسِهِ
u'دَيْنٌ نَفَقَةٌ':Added, #4: 4	دَيْنِ النَّفَقَةِ
u'دَيْنٌ نَفَقَةٌ':Added, #5: 5	دَيْنَ النَّفَقَةِ
u'دِينٌ هَاجِرٌ':Added, #5: 5	دَيْنُ النَّفَقَةِ
u'دَيْنٌ وَاجِبٌ':Added, #1: 1	دِينِ الْهَاجِرِ
u'دِينٌ واحد':Added, #2: 2	دَيْنٍ وَاجِبٍ
u'دِينٌ وَاحِدٌ':Added, #1: 1	دِينُ وَاحِدٍ
u'دِينٌ واحد':Added, #1: 1	دِينُ وَاحِدٍ
u'دِينٌ وَاحِدٌ':Added, #2: 2	دِينٍ وَاحِدٍ
u'دَيْنٌ وَارِثٌ':Added, #2: 2	دِينٍ وَاحِدٍ
u'دَيْنٌ وَارِثٌ':Added, #1: 1	دَيْنِ الْوَارِثَةِ
u'دَيْنٌ وَارِثٌ':Added, #3: 3	دَيْنَ الْوَارِثِ
u'دَيْنٌ وَارِثٌ':Added, #3: 3	دَيْنُ الْوَارِثِ
u'دِينٌ وَاقِفٌ':Added, #7: 7	دَيْنِ الْوَارِثِ
u'دَيْنٌ وَجْهٌ':Added, #1: 1	دِينِ الْوَاقِفِ
u'دَيْنٌ وَدِيعَةٌ':Added, #1: 1	دَيْنِ الْوَجْهِ
u'دَيْنٌ وَدِيعَةٌ':Added, #1: 1	دَيْنَ وَدِيعَةٍ
u'دَيْنٌ وسط':Added, #2: 2	دَيْنُ وَدِيعَةٍ
u'دَيْنٌ وَسَطٌ':Added, #1: 1	دَيْنِ الْوَسَطِ
u'دَيْنٌ وَكِيلٌ':Added, #1: 1	دَيْنِ الْوَسَطِ
u'دَيْنٌ وَكِيلٌ':Added, #1: 1	دَيْنَ الْوَكِيلِ
u'دَيْنٌ وَكِيلٌ':Added, #1: 1	دَيْنُ الْوَكِيلِ
u'دَيْنٌ ولد':Added, #3: 3	دَيْنِ الْوَكِيلِ
u'دَيْنٌ وَلَدٌ':Added, #10: 10	دَيْنِ وَلَدِهِ
u'دِينٌ ولد':Added, #10: 10	دَيْنِ وَلَدِهِ
u'دَيْنٌ ولد':Added, #1: 1	دِينِ الْوَلَدِ
u'دِينٌ وَلَدٌ':Added, #1: 1	دَيْنَ الْوَلَدِ
u'دَيْنٌ وَلَدٌ':Added, #1: 1	دِينِ الْوَلَدِ
u'دَيْنٌ ولد':Added, #1: 1	دَيْنَ الْوَلَدِ
u'دَيْنٌ وَلَدٌ':Added, #1: 1	دَيْنِ وَلَدِ
u'دِينٌ ولد':Added, #1: 1	دَيْنِ وَلَدِ
u'دَيْنٌ ولد':Added, #1: 1	دِينِ وَلَدِهِ
u'دِينٌ وَلَدٌ':Added, #1: 1	دَيْنُ وَلَدِهِ
u'دَيْنٌ وَلَدٌ':Added, #1: 1	دِينِ وَلَدِهِ
u'دَيْنٌ ولد':Added, #1: 1	دَيْنُ وَلَدِهِ
u'دَيْنٌ وَلَدٌ':Added, #3: 3	دَيْنِ الْوَلَدِ
u'دَيْنٌ يهود':Added, #3: 3	دَيْنِ الْوَلَدِ
u'دَيْنٌ يَهُودٌ':Added, #1: 1	دَيْنِ الْيَهُودِ
u'دِينٌ يهود':Added, #1: 1	دَيْنِ الْيَهُودِ
u'دِينٌ يَهُودٌ':Added, #2: 2	دِينَ الْيَهُودِ
u'دِينٌ يهود':Added, #2: 2	دِينَ الْيَهُودِ
u'دِينٌ يهود':Added, #3: 3	دِينُ الْيَهُودِ
u'دِينٌ يَهُودٌ':Added, #3: 3	دِينِ الْيَهُودِ
u'دِينٌ يَهُودٌ':Added, #3: 3	دِينُ الْيَهُودِ
u'دِينٌ يَهُودِيٌّ':Added, #3: 3	دِينِ الْيَهُودِ
u'ذَابَ جَمْدٌ':Subject, #4: 4	دِينِ الْيَهُودِيَّةِ
u'ذَاقَ أَوَّلُ':Subject, #1: 1	ذَابَ الْجَمْدُ
u'ذَاقَ أَوَّلُ':Subject, #1: 1	ذَاقَ الْأَوَّلُ
u'ذَاقَ حَمْز':Subject, #3: 3	ذَاقَ الأَوَّلُ
u'ذَاقَ صَائِمٌ':Subject, #1: 1	ذَاقَ حَمْزَةُ
u'ذَاقَ طَعْمٌ':Predicate, #1: 1	ذَاقَ الصَّائِمُ
u'ذَاقَ عَبْدٌ':Subject, #2: 2	ذَاقَ طَعْمَ
u'ذَاقَ فلان':Subject, #1: 1	ذَاقَ عَبْدُ
u'ذَاقَ مَرَارَةٌ':Predicate, #1: 1	ذَاقَ حَمْزَةُ
u'ذَبَحَ إِبِلٌ':Predicate, #1: 1	ذَاقَ مَرَارَةَ
u'ذَبَحَ أَجْنَبِيٌّ':Subject, #2: 2	ذَبَحَ الْإِبِلَ
u'ذَبَحَ أحَدٌ':Predicate, #1: 1	ذَبَحَ الْأَجْنَبِيُّ
u'ذَبَحَ إمَامٌ':Subject, #1: 1	ذَبَحَ أَحَدَ
u'ذَبَحَ بَقَرٌ':Predicate, #1: 1	ذَبَحَ الْإِمَامُ
u'ذَبَحَ بَقَرٌ':Predicate, #1: 1	ذَبَحَ الْبَقَرَ
u'ذَبَحَ بَقَرٌ':Predicate, #2: 2	ذَبَحَ بَقَرَةَ
u'ذَبَحَ بَيْنٌ':Predicate, #6: 6	ذَبَحَ بَقَرَةً
u'ذَبَحَ ثَانِي':Predicate, #1: 1	ذَبَحَ بَيْنَ
u'ذَبَحَ ثَانِيَةٌ':Predicate, #1: 1	ذَبَحَ الثَّانِيَةَ
u'ذَبَحَ جَذَع':Predicate, #1: 1	ذَبَحَ الثَّانِيَةَ
u'ذَبَحَ جَذَعَة':Predicate, #1: 1	ذَبَحَ الْجَذَعَةَ
u'ذَبَحَ جَزَاءٌ':Predicate, #1: 1	ذَبَحَ الْجَذَعَةَ
u'ذَبَحَ حَلٌّ':Predicate, #1: 1	ذَبَحَ الْجَزَاءَ
u'ذَبَحَ حَلالٌ':Subject, #1: 1	ذَبَحَ حَلَّ
u'ذَبَحَ حَلالٌ':Subject, #1: 1	ذَبَحَ حَلَالٌ
u'ذَبَحَ حِمَارٌ':Predicate, #6: 6	ذَبَحَ الْحَلَالُ
u'ذَبَحَ حَيَوَانٌ':Predicate, #2: 2	ذَبَحَ حِمَارَ
u'ذَبَحَ خِنْزِيرٌ':Predicate, #1: 1	ذَبَحَ الْحَيَوَانَ
u'ذَبَحَ دَجاج':Predicate, #1: 1	ذَبَحَ الْخِنْزِيرَ
u'ذَبَحَ دَمٌ':Predicate, #1: 1	ذَبَحَ دَجَاجَةً
u'ذَبَحَ رَسُولٌ':Subject, #1: 1	ذَبَحَ الدَّمَ
u'ذَبَحَ شَاةٌ':Predicate, #12: 12	ذَبَحَ رَسُولُ
u'ذَبَحَ شَاةٌ':Predicate, #15: 15	ذَبَحَ شَاةَ
u'ذَبَحَ شَخْصٌ':Subject, #22: 22	ذَبَحَ الشَّاةَ
u'ذَبَحَ صَيْدٌ':Predicate, #1: 1	ذَبَحَ الشَّخْصُ
u'ذَبَحَ صَيْدٌ':Predicate, #2: 2	ذَبَحَ الصَّيْدَ
u'ذَبَحَ عند':Predicate, #2: 2	ذَبَحَ صَيْدَ
u'ذَبَحَ غير':Subject, #3: 3	ذَبَحَ عِنْدَ
u'ذَبَحَ غَيْرٌ':Subject, #1: 1	ذَبَحَ غَيْرُهُ
u'ذَبَحَ قَالٌ':Predicate, #1: 1	ذَبَحَ غَيْرُهُ
u'ذَبَحَ كَافِرٌ':Subject, #1: 1	ذَبَحَ قَالَ
u'ذَبَحَ مُتَمَتِّعٌ':Subject, #1: 1	ذَبَحَ كَافِرٌ
u'ذَبَحَ مَجُوسِيٌّ':Subject, #1: 1	ذَبَحَ الْمُتَمَتِّعُ
u'ذَبَحَ مُحْرِمٌ':Subject, #2: 2	ذَبَحَ الْمَجُوسِيُّ
u'ذَبَحَ مُحْرِمٌ':Subject, #10: 10	ذَبَحَ الْمُحْرِمُ
u'ذَبَحَ مَسْرُوقٌ':Predicate, #2: 2	ذَبَحَ مُحْرِمٌ
u'ذَبَحَ مُسْلِمٌ':Subject, #1: 1	ذَبَحَ الْمَسْرُوقَ
u'ذَبَحَ مُسْلِمٌ':Subject, #1: 1	ذَبَحَ الْمُسْلِمُ
u'ذَبَحَ مَفْرُوغٌ':Predicate, #2: 2	ذَبَحَ مُسْلِمٌ
u'ذَبَحَ مِلْكٌ':Predicate, #1: 1	ذَبَحَ الْمَفْرُوغَ
u'ذَبَحَ مَنْذُور':Predicate, #1: 1	ذَبَحَ مِلْكَ
u'ذَبَحَ مُوَكِّلٌ':Subject, #2: 2	ذَبَحَ الْمَنْذُورَةَ
u'ذَبَحَ نَاسٌ':Subject, #1: 1	ذَبَحَ الْمُوَكِّلُ
u'ذَبَحَ نَبِيٌّ':Subject, #1: 1	ذَبَحَ النَّاسُ
u'ذَبَحَ هَدَايَا':Subject, #2: 2	ذَبَحَ النَّبِيُّ
u'ذَبَحَ هَدْيٌ':Predicate, #1: 1	ذَبَحَ هَدَايَاهُ
u'ذَبَحَ هَدْيٌ':Predicate, #1: 1	ذَبَحَ هَدْيَ
u'ذَبَحَ وَاجِبٌ':Predicate, #8: 8	ذَبَحَ الْهَدْيَ
u'ذَبَحَ واحد':Subject, #2: 2	ذَبَحَ الْوَاجِبَ
u'ذَبَحَ وَاحِدٌ':Subject, #1: 1	ذَبَحَ وَاحِدٌ
u'ذَبَحَ وَارِثٌ':Subject, #1: 1	ذَبَحَ وَاحِدٌ
u'ذَبَحَ ولد':Predicate, #1: 1	ذَبَحَ الْوَارِثُ
u'ذَبَحَ وَلَدٌ':Predicate, #2: 2	ذَبَحَ الْوَلَدَ
u'ذَبَحَ يَوْمٌ':Predicate, #2: 2	ذَبَحَ الْوَلَدَ
u'ذَرَّ تُرَابٌ':Predicate, #1: 1	ذَبَحَ يَوْمَ
u'ذَرْعٌ أرْضٌ':Added, #1: 1	ذَرَّ التُّرَابَ
u'ذَرْعٌ بَيْتٌ':Added, #1: 1	ذَرْعِ الْأَرْضِ
u'ذَرْعٌ ثَوْبٌ':Added, #7: 7	ذَرْعِ الْبَيْتِ
u'ذَرْعٌ دَارٌ':Added, #1: 1	ذَرْعِ ثَوْبٍ
u'ذَرَعَ فُلاَنٌ':Subject, #6: 6	ذَرْعِ الدَّارِ
u'ذَرْعٌ قَيْءٌ':Added, #1: 1	ذَرَعَ فُلَانٌ
u'ذَرْعٌ نِصْفٌ':Added, #1: 1	ذَرْعُ قَيْءٍ
u'ذَرْقٌ حَمَامٌ':Added, #4: 4	ذَرْعِ نِصْفِ
u'ذَرْقٌ حَمَامٌ':Added, #1: 1	ذَرْقَ الْحَمَامِ
u'ذَرْقٌ ذُبابٌ':Added, #1: 1	ذَرْقَ حَمَامٍ
u'ذَرْقٌ طَيْرٌ':Added, #1: 1	ذَرْقِ الذُّبَابِ
u'ذَرْقٌ طُيُورٌ':Added, #1: 1	ذَرْقُ الطَّيْرِ
u'ذَرْقٌ طُيُورٌ':Added, #1: 1	ذَرْقَ الطُّيُورِ
u'ذَرْقٌ طُيُورٌ':Added, #1: 1	ذَرْقُ الطُّيُورِ
u'ذَرْقٌ نعام':Added, #6: 6	ذَرْقِ الطُّيُورِ
u'ذَرْقٌ نَعَامٌ':Added, #1: 1	ذَرْقَ النَّعَامِ
u'ذكر أَبٌ':Added, #1: 1	ذَرْقَ النَّعَامِ
u'ذِكْرٌ أَبٌ':Added, #3: 3	ذِكْرِ الْأَبِ
u'ذَكَرَ إبَاءٌ':Predicate, #3: 3	ذِكْرِ الْأَبِ
u'ذَكَرَ أبَدٌ':Predicate, #1: 1	ذَكَرَ الْإِبَاءَ
u'ذكر أبَدٌ':Added, #6: 6	ذَكَرَ الْأَبَدَ
u'ذِكْرٌ أبَدٌ':Added, #1: 1	ذِكْرَ الْأَبَدِ
u'ذكر أبَدٌ':Added, #1: 1	ذِكْرَ الْأَبَدِ
u'ذِكْرٌ أبَدٌ':Added, #2: 2	ذِكْرِ الْأَبَدِ
u'ذَكَرَ إِبِلٌ':Predicate, #2: 2	ذِكْرِ الْأَبَدِ
u'ذَكَرَ إِبِلٌ':Predicate, #1: 1	ذَكَرَ الإِبِلَ
u'ذَكَرَ إبْلِيسُ':Predicate, #2: 2	ذَكَرَ الْإِبِلَ
u'ذَكَرَ اِبْنٌ':Predicate, #1: 1	ذَكَرَ إبْلِيسَ
u'ذَكَرَ اِبْنٌ':Subject, #4: 4	ذَكَرَ ابْنَ
u'ذكر اِبْنٌ':Added, #332: 332	ذَكَرَ ابْنُ
u'ذِكْرٌ اِبْنٌ':Added, #1: 1	ذِكْرِ ابْنٍ
u'ذكر اِبْنٌ':Added, #1: 1	ذِكْرِ ابْنٍ
u'ذكر اِبْنٌ':Added, #2: 2	ذِكْرَ ابْنِ
u'ذِكْرٌ اِبْنٌ':Added, #2: 2	ذِكْرُ ابْنِ
u'ذِكْرٌ اِبْنٌ':Added, #2: 2	ذِكْرَ ابْنِ
u'ذكر اِبْنٌ':Added, #2: 2	ذِكْرُ ابْنِ
u'ذِكْرٌ اِبْنٌ':Added, #6: 6	ذِكْرِ ابْنِ
u'ذَكَرَ اِبْنَة':Predicate, #6: 6	ذِكْرِ ابْنِ
u'ذكر أَبْوَابٌ':Added, #2: 2	ذَكَرَ ابْنَةَ
u'ذِكْرٌ أَبْوَابٌ':Added, #1: 1	ذِكْرِ أَبْوَابِ
u'ذكر أَبْوَابٌ':Added, #1: 1	ذِكْرِ أَبْوَابِ
u'ذِكْرٌ أَبْوَابٌ':Added, #1: 1	ذِكْرِ الْأَبْوَابِ
u'ذَكَرَ أبْيَاتٌ':Predicate, #1: 1	ذِكْرِ الْأَبْوَابِ
u'ذكر آثَارٌ':Added, #1: 1	ذَكَرَ أَبْيَاتَ
u'ذِكْرٌ آثَارٌ':Added, #1: 1	ذِكْرُ الْآثَارِ
u'ذكر أثَرٌ':Added, #1: 1	ذِكْرُ الْآثَارِ
u'ذِكْرٌ أثَرٌ':Added, #1: 1	ذِكْرِ الأَثَرِ
u'ذَكَرَ أَثْمانٌ':Predicate, #1: 1	ذِكْرِ الأَثَرِ
u'ذكر إجَارَةٌ':Added, #1: 1	ذَكَرَ الْأَثْمَانَ
u'ذكر إجَارَةٌ':Added, #1: 1	ذِكْرُ إجَارَةٍ
u'ذِكْرٌ إجَارَةٌ':Added, #1: 1	ذِكْرِ إجَارَةِ
u'ذِكْرٌ إجَارَةٌ':Added, #1: 1	ذِكْرُ إجَارَةٍ
u'ذكر إجَارَةٌ':Added, #1: 1	ذِكْرِ إجَارَةِ
u'ذِكْرٌ إجَارَةٌ':Added, #2: 2	ذِكْرَ الْإِجَارَةِ
u'ذكر إجَارَةٌ':Added, #2: 2	ذِكْرَ الْإِجَارَةِ
u'ذِكْرٌ إجَارَةٌ':Added, #3: 3	ذِكْرِ الْإِجَارَةِ
u'ذكر إجَازَةٌ':Added, #3: 3	ذِكْرِ الْإِجَارَةِ
u'ذِكْرٌ إجَازَةٌ':Added, #1: 1	ذِكْرَ الْإِجَازَةِ
u'ذَكَرَ إِجْبَارٌ':Predicate, #1: 1	ذِكْرَ الْإِجَازَةِ
u'ذَكَرَ إِجْبَارٌ':Predicate, #1: 1	ذَكَرَ إجْبَارَ
u'ذَكَرَ آجُرٌّ':Predicate, #1: 1	ذَكَرَ الْإِجْبَارَ
u'ذَكَرَ أَجْرٌ':Predicate, #1: 1	ذَكَرَ الْآجُرَّ
u'ذَكَرَ أَجْرٌ':Predicate, #1: 1	ذَكَرَ الأَجْرَ
u'ذَكَرَ أُجْرَةٌ':Predicate, #2: 2	ذَكَرَ الْأَجْرَ
u'ذكر أُجْرَةٌ':Added, #4: 4	ذَكَرَ الْأُجْرَةَ
u'ذِكْرٌ أُجْرَةٌ':Added, #1: 1	ذِكْرَ الْأُجْرَةِ
u'ذكر أُجْرَةٌ':Added, #1: 1	ذِكْرَ الْأُجْرَةِ
u'ذكر أُجْرَةٌ':Added, #2: 2	ذِكْرُ الْأُجْرَةِ
u'ذِكْرٌ أُجْرَةٌ':Added, #2: 2	ذِكْرِ الْأُجْرَةِ
u'ذِكْرٌ أُجْرَةٌ':Added, #2: 2	ذِكْرُ الْأُجْرَةِ
u'ذَكَرَ إِجْزَاءٌ':Predicate, #2: 2	ذِكْرِ الْأُجْرَةِ
u'ذَكَرَ أَجَلٌ':Predicate, #1: 1	ذَكَرَ الْإِجْزَاءَ
u'ذكر أَجَلٌ':Added, #5: 5	ذَكَرَ الْأَجَلَ
u'ذِكْرٌ أَجَلٌ':Added, #1: 1	ذِكْرُ أَجَلٍ
u'ذكر أَجَلٌ':Added, #1: 1	ذِكْرُ أَجَلٍ
u'ذكر أَجَلٌ':Added, #1: 1	ذِكْرَ الْأَجَلِ
u'ذِكْرٌ أَجَلٌ':Added, #1: 1	ذِكْرُ الْأَجَلِ
u'ذِكْرٌ أَجَلٌ':Added, #1: 1	ذِكْرَ الْأَجَلِ
u'ذكر أَجَلٌ':Added, #1: 1	ذِكْرُ الْأَجَلِ
u'ذِكْرٌ أَجَلٌ':Added, #7: 7	ذِكْرِ الْأَجَلِ
u'ذَكَرَ إِجْمَاعٌ':Predicate, #7: 7	ذِكْرِ الْأَجَلِ
u'ذكر إِجْمَاعٌ':Added, #2: 2	ذَكَرَ الْإِجْمَاعَ
u'ذِكْرٌ إِجْمَاعٌ':Added, #1: 1	ذِكْرُ الْإِجْمَاعِ
u'ذكر أَجْوِبَةٌ':Added, #1: 1	ذِكْرُ الْإِجْمَاعِ
u'ذِكْرٌ أَجْوِبَةٌ':Added, #1: 1	ذِكْرِ الْأَجْوِبَةِ
u'ذَكَرَ أَحادِيثُ':Predicate, #1: 1	ذِكْرِ الْأَجْوِبَةِ
u'ذكر أَحادِيثُ':Added, #1: 1	ذَكَرَ أَحَادِيثَ
u'ذكر أَحادِيثُ':Added, #1: 1	ذِكْرُ الأَحَادِيثِ
u'ذِكْرٌ أَحادِيثُ':Added, #1: 1	ذِكْرُ الْأَحَادِيثِ
u'ذِكْرٌ أَحادِيثُ':Added, #1: 1	ذِكْرُ الأَحَادِيثِ
u'ذَكَرَ أحَدٌ':Predicate, #1: 1	ذِكْرُ الْأَحَادِيثِ
u'ذَكَرَ أحَدٌ':Subject, #2: 2	ذَكَرَ أَحَدَ
u'ذكر أحَدٌ':Added, #1: 1	ذَكَرَ أَحَدٌ
u'ذكر أحَدٌ':Added, #1: 1	ذِكْرِ أَحَدٍ
u'ذِكْرٌ أحَدٌ':Added, #1: 1	ذِكْرِ أَحَدِ
u'ذِكْرٌ أحَدٌ':Added, #1: 1	ذِكْرِ أَحَدٍ
u'ذكر أحَدٌ':Added, #1: 1	ذِكْرِ أَحَدِ
u'ذِكْرٌ أحَدٌ':Added, #3: 3	ذِكْرُ أَحَدِ
u'ذكر أحَدٌ':Added, #3: 3	ذِكْرُ أَحَدِ
u'ذِكْرٌ أحَدٌ':Added, #6: 6	ذِكْرَ أَحَدِ
u'ذكر أَحْداثٌ':Added, #6: 6	ذِكْرَ أَحَدِ
u'ذكر أَحْدَاثٌ':Added, #1: 1	ذِكْرَ الْأَحْدَاثِ
u'ذِكْرٌ أَحْداثٌ':Added, #1: 1	ذِكْرَ الْأَحْدَاثِ
u'ذِكْرٌ أَحْدَاثٌ':Added, #1: 1	ذِكْرَ الْأَحْدَاثِ
u'ذكر إِحْرَامٌ':Added, #1: 1	ذِكْرَ الْأَحْدَاثِ
u'ذِكْرٌ إِحْرَامٌ':Added, #1: 1	ذِكْرُ الْإِحْرَامِ
u'ذَكَرَ إحْسَانٌ':Predicate, #1: 1	ذِكْرُ الْإِحْرَامِ
u'ذَكَرَ أَحْكَامٌ':Predicate, #1: 1	ذَكَرَ الْإِحْسَانَ
u'ذكر أَحْكَامٌ':Added, #18: 18	ذَكَرَ أَحْكَامَ
u'ذِكْرٌ أَحْكَامٌ':Added, #1: 1	ذِكْرُ أَحْكَامٍ
u'ذكر أَحْكَامٌ':Added, #1: 1	ذِكْرُ أَحْكَامٍ
u'ذكر أَحْكَامٌ':Added, #2: 2	ذِكْرَ أَحْكَامِ
u'ذِكْرٌ أَحْكَامٌ':Added, #2: 2	ذِكْرِ أَحْكَامٍ
u'ذِكْرٌ أَحْكَامٌ':Added, #2: 2	ذِكْرَ أَحْكَامِ
u'ذكر أَحْكَامٌ':Added, #2: 2	ذِكْرِ أَحْكَامٍ
u'ذِكْرٌ أَحْكَامٌ':Added, #3: 3	ذِكْرِ أَحْكَامِ
u'ذَكَرَ أحْمَر':Predicate, #3: 3	ذِكْرِ أَحْكَامِ
u'ذكر أحْمَر':Added, #3: 3	ذَكَرَ أَحْمَرَ
u'ذِكْرٌ أحْمَر':Added, #2: 2	ذِكْرِ الْأَحْمَرِ
u'ذكر أَحْوالٌ':Added, #2: 2	ذِكْرِ الْأَحْمَرِ
u'ذكر أحْوَالٌ':Added, #1: 1	ذِكْرُ أَحْوَالِ
u'ذِكْرٌ أَحْوالٌ':Added, #1: 1	ذِكْرُ أَحْوَالِ
u'ذِكْرٌ أحْوَالٌ':Added, #1: 1	ذِكْرُ أَحْوَالِ
u'ذكر أَحْوالٌ':Added, #1: 1	ذِكْرُ أَحْوَالِ
u'ذكر أحْوَالٌ':Added, #1: 1	ذِكْرَ الْأَحْوَالِ
u'ذِكْرٌ أَحْوالٌ':Added, #1: 1	ذِكْرَ الْأَحْوَالِ
u'ذِكْرٌ أحْوَالٌ':Added, #1: 1	ذِكْرَ الْأَحْوَالِ
u'ذكر أَحْوالٌ':Added, #1: 1	ذِكْرَ الْأَحْوَالِ
u'ذكر أحْوَالٌ':Added, #4: 4	ذِكْرِ أَحْوَالِ
u'ذِكْرٌ أَحْوالٌ':Added, #4: 4	ذِكْرِ أَحْوَالِ
u'ذِكْرٌ أحْوَالٌ':Added, #4: 4	ذِكْرِ أَحْوَالِ
u'ذكر إِحْيَاءٌ':Added, #4: 4	ذِكْرِ أَحْوَالِ
u'ذِكْرٌ إِحْيَاءٌ':Added, #2: 2	ذِكْرِ إحْيَاءِ
u'ذكر أَخٌ':Added, #2: 2	ذِكْرِ إحْيَاءِ
u'ذِكْرٌ أَخٌ':Added, #1: 1	ذِكْرُ أَخٍ
u'ذكر أَخٌ':Added, #1: 1	ذِكْرُ أَخٍ
u'ذِكْرٌ أَخٌ':Added, #1: 1	ذِكْرِ الْأَخِ
u'ذَكَرَ إِخْبَارٌ':Predicate, #1: 1	ذِكْرِ الْأَخِ
u'ذَكَرَ أخْبَارٌ':Predicate, #1: 1	ذَكَرَ الْإِخْبَارَ
u'ذَكَرَ أَخْبَارٌ':Predicate, #2: 2	ذَكَرَ الْأَخْبَارَ
u'ذكر أخْبَارٌ':Added, #2: 2	ذَكَرَ الْأَخْبَارَ
u'ذكر أَخْبَارٌ':Added, #1: 1	ذِكْرِ أَخْبَارٍ
u'ذِكْرٌ أخْبَارٌ':Added, #1: 1	ذِكْرِ أَخْبَارٍ
u'ذِكْرٌ أَخْبَارٌ':Added, #1: 1	ذِكْرِ أَخْبَارٍ
u'ذكر أخْبَارٌ':Added, #1: 1	ذِكْرِ أَخْبَارٍ
u'ذكر أَخْبَارٌ':Added, #1: 1	ذِكْرِ الْأَخْبَارِ
u'ذِكْرٌ أخْبَارٌ':Added, #1: 1	ذِكْرِ الْأَخْبَارِ
u'ذِكْرٌ أَخْبَارٌ':Added, #1: 1	ذِكْرِ الْأَخْبَارِ
u'ذكر أخْبَارٌ':Added, #1: 1	ذِكْرِ الْأَخْبَارِ
u'ذكر أَخْبَارٌ':Added, #2: 2	ذِكْرِ الأَخْبَارِ
u'ذِكْرٌ أخْبَارٌ':Added, #2: 2	ذِكْرِ الأَخْبَارِ
u'ذِكْرٌ أَخْبَارٌ':Added, #2: 2	ذِكْرِ الأَخْبَارِ
u'ذَكَرَ اِخْتِلاَفٌ':Predicate, #2: 2	ذِكْرِ الأَخْبَارِ
u'ذكر اِخْتِلاَفٌ':Added, #2: 2	ذَكَرَ اخْتِلَافَ
u'ذِكْرٌ اِخْتِلاَفٌ':Added, #1: 1	ذِكْرِ اخْتِلَافٍ
u'ذَكَرَ اِخْتِيَارٌ':Predicate, #1: 1	ذِكْرِ اخْتِلَافٍ
u'ذكر اِخْتِيَارٌ':Added, #1: 1	ذَكَرَ اخْتِيَارَ
u'ذِكْرٌ اِخْتِيَارٌ':Added, #1: 1	ذِكْرُ اخْتِيَارِ
u'ذَكَرَ أخْذٌ':Predicate, #1: 1	ذِكْرُ اخْتِيَارِ
u'ذكر أخْذٌ':Added, #1: 1	ذَكَرَ الْأَخْذَ
u'ذِكْرٌ أخْذٌ':Added, #1: 1	ذِكْرِ الْأَخْذِ
u'ذكر أخْذٌ':Added, #1: 1	ذِكْرِ الْأَخْذِ
u'ذِكْرٌ أخْذٌ':Added, #2: 2	ذِكْرُ أَخْذِ
u'ذَكَرَ آخِرُ':Predicate, #2: 2	ذِكْرُ أَخْذِ
u'ذكر آخِرُ':Added, #3: 3	ذَكَرَ آخِرَ
u'ذِكْرٌ آخِرُ':Added, #1: 1	ذِكْرُ آخِرِ
u'ذكر آخِرَةٌ':Added, #1: 1	ذِكْرُ آخِرِ
u'ذكر آخِرَةٌ':Added, #1: 1	ذِكْرَ الْآخِرَةِ
u'ذِكْرٌ آخِرَةٌ':Added, #1: 1	ذِكْرُ الْآخِرَةِ
u'ذِكْرٌ آخِرَةٌ':Added, #1: 1	ذِكْرَ الْآخِرَةِ
u'ذكر أَخَصُّ':Added, #1: 1	ذِكْرُ الْآخِرَةِ
u'ذِكْرٌ أَخَصُّ':Added, #1: 1	ذِكْرَ الْأَخَصِّ
u'ذَكَرَ أَخِيرٌ':Predicate, #1: 1	ذِكْرَ الْأَخَصِّ
u'ذكر أَدَاءٌ':Added, #1: 1	ذَكَرَ الْأَخِيرِينَ
u'ذكر أَدَاءٌ':Added, #1: 1	ذِكْرُ الْأَدَاءِ
u'ذِكْرٌ أَدَاءٌ':Added, #1: 1	ذِكْرِ الْأَدَاءِ
u'ذِكْرٌ أَدَاءٌ':Added, #1: 1	ذِكْرُ الْأَدَاءِ
u'ذَكَرَ آدابٌ':Predicate, #1: 1	ذِكْرِ الْأَدَاءِ
u'ذَكَرَ إدْخَالٌ':Predicate, #1: 1	ذَكَرَ آدَابَ
u'ذَكَرَ أَذَانٌ':Predicate, #1: 1	ذَكَرَ إدْخَالَ
u'ذكر أَذَانٌ':Added, #1: 1	ذَكَرَ الأَذَانَ
u'ذكر أَذَانٌ':Added, #1: 1	ذِكْرُ الأَذَانِ
u'ذِكْرٌ أَذَانٌ':Added, #1: 1	ذِكْرِ الْأَذَانِ
u'ذِكْرٌ أَذَانٌ':Added, #1: 1	ذِكْرُ الأَذَانِ
u'ذكر أَذَانٌ':Added, #1: 1	ذِكْرِ الْأَذَانِ
u'ذِكْرٌ أَذَانٌ':Added, #5: 5	ذِكْرُ الْأَذَانِ
u'ذكر إِذْنٌ':Added, #5: 5	ذِكْرُ الْأَذَانِ
u'ذِكْرٌ إِذْنٌ':Added, #1: 1	ذِكْرُ الْإِذْنِ
u'ذَكَرَ أَرْبَعُ':Predicate, #1: 1	ذِكْرُ الْإِذْنِ
u'ذَكَرَ أَرْبَعُ':Predicate, #2: 2	ذَكَرَ الْأَرْبَعَ
u'ذَكَرَ أَرْبَعَةٌ':Predicate, #7: 7	ذَكَرَ أَرْبَعَ
u'ذَكَرَ أَرْبَعَةٌ':Predicate, #1: 1	ذَكَرَ الْأَرْبَعَةَ
u'ذكر أَرْبَعَةٌ':Added, #3: 3	ذَكَرَ أَرْبَعَةَ
u'ذكر أَرْبَعَةٌ':Added, #1: 1	ذِكْرُ أَرْبَعَةٍ
u'ذِكْرٌ أَرْبَعَةٌ':Added, #1: 1	ذِكْرِ أَرْبَعَةٍ
u'ذِكْرٌ أَرْبَعَةٌ':Added, #1: 1	ذِكْرُ أَرْبَعَةٍ
u'ذَكَرَ إِرْثٌ':Predicate, #1: 1	ذِكْرِ أَرْبَعَةٍ
u'ذَكَرَ أرْضٌ':Predicate, #1: 1	ذَكَرَ الْإِرْثَ
u'ذَكَرَ أرْضٌ':Predicate, #1: 1	ذَكَرَ أَرْضَ
u'ذكر أرْضٌ':Added, #1: 1	ذَكَرَ الْأَرْضَ
u'ذِكْرٌ أرْضٌ':Added, #1: 1	ذِكْرِ أَرْضِهِ
u'ذكر أرْضٌ':Added, #1: 1	ذِكْرِ أَرْضِهِ
u'ذِكْرٌ أرْضٌ':Added, #1: 1	ذِكْرِ الْأَرْضِ
u'ذَكَرَ أَرْكانٌ':Predicate, #1: 1	ذِكْرِ الْأَرْضِ
u'ذَكَرَ أَرْكَانٌ':Predicate, #1: 1	ذَكَرَ أَرْكَانَ
u'ذكر إِزَارٌ':Added, #1: 1	ذَكَرَ أَرْكَانَ
u'ذِكْرٌ إِزَارٌ':Added, #1: 1	ذِكْرَ الْإِزَارَيْنِ
u'ذَكَرَ أَزْرَق':Subject, #1: 1	ذِكْرَ الْإِزَارَيْنِ
u'ذَكَرَ أَزْواجٌ':Predicate, #1: 1	ذَكَرَ الْأَزْرَقُ
u'ذكر أَزْواجٌ':Added, #1: 1	ذَكَرَ الْأَزْوَاجَ
u'ذِكْرٌ أَزْواجٌ':Added, #1: 1	ذِكْرُ أَزْوَاجِهِ
u'ذكر أسْبَابٌ':Added, #1: 1	ذِكْرُ أَزْوَاجِهِ
u'ذكر أَسْبَابٌ':Added, #1: 1	ذِكْرِ أَسْبَابِ
u'ذِكْرٌ أسْبَابٌ':Added, #1: 1	ذِكْرِ أَسْبَابِ
u'ذِكْرٌ أَسْبَابٌ':Added, #1: 1	ذِكْرِ أَسْبَابِ
u'ذكر أسْبَابٌ':Added, #1: 1	ذِكْرِ أَسْبَابِ
u'ذكر أَسْبَابٌ':Added, #1: 1	ذِكْرُ الْأَسْبَابِ
u'ذِكْرٌ أسْبَابٌ':Added, #1: 1	ذِكْرُ الْأَسْبَابِ
u'ذِكْرٌ أَسْبَابٌ':Added, #1: 1	ذِكْرُ الْأَسْبَابِ
u'ذَكَرَ أُسْتَاذٌ':Subject, #1: 1	ذِكْرُ الْأَسْبَابِ
u'ذَكَرَ اِسْتِثْنَاءٌ':Predicate, #5: 5	ذَكَرَ الْأُسْتَاذُ
u'ذَكَرَ اِسْتِثْنَاءٌ':Predicate, #1: 1	ذَكَرَ اسْتِثْنَاءَ
u'ذَكَرَ اِسْتِحْقَاقٌ':Predicate, #1: 1	ذَكَرَ الاِسْتِثْنَاءَ
u'ذكر اِسْتِحْقَاقٌ':Added, #1: 1	ذَكَرَ اسْتِحْقَاقَ
u'ذِكْرٌ اِسْتِحْقَاقٌ':Added, #1: 1	ذِكْرِ اسْتِحْقَاقٍ
u'ذَكَرَ اِسْتِهْلالٌ':Predicate, #1: 1	ذِكْرِ اسْتِحْقَاقٍ
u'ذَكَرَ اِسْتِواءٌ':Subject, #1: 1	ذَكَرَ اسْتِهْلَالَ
u'ذكر اِسْتِئْجَارٌ':Added, #1: 1	ذَكَرَ اسْتِوَاءُ
u'ذِكْرٌ اِسْتِئْجَارٌ':Added, #1: 1	ذِكْرِ اسْتِئْجَارِ
u'ذكر إِسْراءٌ':Added, #1: 1	ذِكْرِ اسْتِئْجَارِ
u'ذِكْرٌ إِسْراءٌ':Added, #1: 1	ذِكْرُ الْإِسْرَاءِ
u'ذكر إِسْلامٌ':Added, #1: 1	ذِكْرُ الْإِسْرَاءِ
u'ذِكْرٌ إِسْلامٌ':Added, #1: 1	ذِكْرُ إسْلَامِ
u'ذكر إِسْلامٌ':Added, #1: 1	ذِكْرُ إسْلَامِ
u'ذِكْرٌ إِسْلامٌ':Added, #1: 1	ذِكْرُ الْإِسْلَامِ
u'ذكر إِسْلامٌ':Added, #1: 1	ذِكْرُ الْإِسْلَامِ
u'ذِكْرٌ إِسْلامٌ':Added, #2: 2	ذِكْرُ إسْلَامِهِ
u'ذكر إِسْلامٌ':Added, #2: 2	ذِكْرُ إسْلَامِهِ
u'ذِكْرٌ إِسْلامٌ':Added, #3: 3	ذِكْرَ الْإِسْلَامِ
u'ذَكَرَ اِسْمٌ':Predicate, #3: 3	ذِكْرَ الْإِسْلَامِ
u'ذكر اِسْمٌ':Added, #26: 26	ذَكَرَ اسْمَ
u'ذِكْرٌ اِسْمٌ':Added, #10: 10	ذِكْرُ اسْمِ
u'ذكر اِسْمٌ':Added, #10: 10	ذِكْرُ اسْمِ
u'ذِكْرٌ اِسْمٌ':Added, #16: 16	ذِكْرِ اسْمِ
u'ذكر اِسْمٌ':Added, #16: 16	ذِكْرِ اسْمِ
u'ذِكْرٌ اِسْمٌ':Added, #1: 1	ذِكْرِ اسْمٍ
u'ذكر اِسْمٌ':Added, #1: 1	ذِكْرِ اسْمٍ
u'ذِكْرٌ اِسْمٌ':Added, #3: 3	ذِكْرُ اسْمِهِ
u'ذكر اِسْمٌ':Added, #3: 3	ذِكْرُ اسْمِهِ
u'ذِكْرٌ اِسْمٌ':Added, #6: 6	ذِكْرَ اسْمِ
u'ذكر اِسْمٌ':Added, #6: 6	ذِكْرَ اسْمِ
u'ذِكْرٌ اِسْمٌ':Added, #8: 8	ذِكْرِ اسْمِهِ
u'ذَكَرَ أَسْماءٌ':Predicate, #8: 8	ذِكْرِ اسْمِهِ
u'ذكر أَسْماءٌ':Added, #1: 1	ذَكَرَ أَسْمَاءَ
u'ذكر أَسْماءٌ':Added, #1: 1	ذِكْرِ أَسْمَاءٍ
u'ذِكْرٌ أَسْماءٌ':Added, #1: 1	ذِكْرِ أَسْمَاءِ
u'ذِكْرٌ أَسْماءٌ':Added, #1: 1	ذِكْرِ أَسْمَاءٍ
u'ذكر أَسْماءٌ':Added, #1: 1	ذِكْرِ أَسْمَاءِ
u'ذكر أَسْماءٌ':Added, #1: 1	ذِكْرَ الْأَسْمَاءِ
u'ذِكْرٌ أَسْماءٌ':Added, #1: 1	ذِكْرِ الْأَسْمَاءِ
u'ذِكْرٌ أَسْماءٌ':Added, #1: 1	ذِكْرَ الْأَسْمَاءِ
u'ذكر أَسْماءٌ':Added, #1: 1	ذِكْرِ الْأَسْمَاءِ
u'ذِكْرٌ أَسْماءٌ':Added, #2: 2	ذِكْرُ الْأَسْمَاءِ
u'ذكر إِسْنادٌ':Added, #2: 2	ذِكْرُ الْأَسْمَاءِ
u'ذِكْرٌ إِسْنادٌ':Added, #1: 1	ذِكْرُ إِسْنَادِهِ
u'ذَكَرَ إشارَة':Subject, #1: 1	ذِكْرُ إِسْنَادِهِ
u'ذكر إشارَة':Added, #1: 1	ذَكَرَ إشَارَةٌ
u'ذكر إشارَة':Added, #1: 1	ذِكْرَ الْإِشَارَةِ
u'ذِكْرٌ إشارَة':Added, #1: 1	ذِكْرُ الْإِشَارَةِ
u'ذِكْرٌ إشارَة':Added, #1: 1	ذِكْرَ الْإِشَارَةِ
u'ذكر إشارَة':Added, #1: 1	ذِكْرُ الْإِشَارَةِ
u'ذِكْرٌ إشارَة':Added, #3: 3	ذِكْرِ الْإِشَارَةِ
u'ذَكَرَ اِشْتِباهٌ':Predicate, #3: 3	ذِكْرِ الْإِشَارَةِ
u'ذكر اِشْتِراطٌ':Added, #1: 1	ذَكَرَ اشْتِبَاهَ
u'ذِكْرٌ اِشْتِراطٌ':Added, #4: 4	ذِكْرِ اشْتِرَاطِ
u'ذَكَرَ أَشْرَاطٌ':Predicate, #4: 4	ذِكْرِ اشْتِرَاطِ
u'ذَكَرَ أَشْرِبَةٌ':Predicate, #1: 1	ذَكَرَ أَشْرَاطَ
u'ذكر أَشْرِبَةٌ':Added, #2: 2	ذَكَرَ الْأَشْرِبَةَ
u'ذِكْرٌ أَشْرِبَةٌ':Added, #1: 1	ذِكْرِ الْأَشْرِبَةِ
u'ذَكَرَ أَشْعَث':Subject, #1: 1	ذِكْرِ الْأَشْرِبَةِ
u'ذَكَرَ إِشْكالٌ':Predicate, #1: 1	ذَكَرَ أَشْعَثُ
u'ذَكَرَ أَشَلّ':Predicate, #1: 1	ذَكَرَ الْإِشْكَالَ
u'ذَكَرَ أَشْهُرٌ':Predicate, #1: 1	ذَكَرَ أَشَلَّ
u'ذكر أَشْيَاءٌ':Added, #1: 1	ذَكَرَ الْأَشْهُرَ
u'ذِكْرٌ أَشْيَاءٌ':Added, #1: 1	ذِكْرِ الْأَشْيَاءِ
u'ذكر أَصابِعُ':Added, #1: 1	ذِكْرِ الْأَشْيَاءِ
u'ذِكْرٌ أَصابِعُ':Added, #1: 1	ذِكْرَ الْأَصَابِعِ
u'ذَكَرَ أَصْحَابٌ':Predicate, #1: 1	ذِكْرَ الْأَصَابِعِ
u'ذَكَرَ أَصْحَابٌ':Subject, #2: 2	ذَكَرَ أَصْحَابَ
u'ذَكَرَ أَصْحَابٌ':Subject, #1: 1	ذَكَرَ أَصْحَابُهُ
u'ذَكَرَ أَصْحَابٌ':Subject, #3: 3	ذَكَرَ أَصْحَابُ
u'ذكر أَصْحَابٌ':Added, #48: 48	ذَكَرَ الْأَصْحَابُ
u'ذِكْرٌ أَصْحَابٌ':Added, #1: 1	ذِكْرِ أَصْحَابِ
u'ذَكَرَ أصل':Predicate, #1: 1	ذِكْرِ أَصْحَابِ
u'ذَكَرَ أًصْلٌ':Predicate, #3: 3	ذَكَرَ الْأَصْلَ
u'ذَكَرَ أصل':Subject, #3: 3	ذَكَرَ الْأَصْلَ
u'ذَكَرَ أًصْلٌ':Subject, #12: 12	ذَكَرَ الْأَصْلُ
u'ذكر أصل':Added, #12: 12	ذَكَرَ الْأَصْلُ
u'ذكر أًصْلٌ':Added, #1: 1	ذِكْرُ أَصْلِ
u'ذكر أًصْلٌ':Added, #1: 1	ذِكْرُ أَصْلٍ
u'ذِكْرٌ أصل':Added, #1: 1	ذِكْرُ أَصْلِ
u'ذِكْرٌ أًصْلٌ':Added, #1: 1	ذِكْرُ أَصْلِ
u'ذِكْرٌ أًصْلٌ':Added, #1: 1	ذِكْرُ أَصْلٍ
u'ذكر أصل':Added, #1: 1	ذِكْرُ أَصْلِ
u'ذكر أًصْلٌ':Added, #1: 1	ذِكْرِ أَصْلِهِ
u'ذِكْرٌ أصل':Added, #1: 1	ذِكْرِ أَصْلِهِ
u'ذِكْرٌ أًصْلٌ':Added, #1: 1	ذِكْرِ أَصْلِهِ
u'ذكر أصل':Added, #1: 1	ذِكْرِ أَصْلِهِ
u'ذكر أصل':Added, #3: 3	ذِكْرُ الْأَصْلِ
u'ذكر أًصْلٌ':Added, #3: 3	ذِكْرِ الْأَصْلِ
u'ذكر أًصْلٌ':Added, #3: 3	ذِكْرُ الْأَصْلِ
u'ذِكْرٌ أصل':Added, #3: 3	ذِكْرِ الْأَصْلِ
u'ذِكْرٌ أصل':Added, #3: 3	ذِكْرُ الْأَصْلِ
u'ذِكْرٌ أًصْلٌ':Added, #3: 3	ذِكْرِ الْأَصْلِ
u'ذِكْرٌ أًصْلٌ':Added, #3: 3	ذِكْرُ الْأَصْلِ
u'ذَكَرَ أَصْنَافٌ':Predicate, #3: 3	ذِكْرِ الْأَصْلِ
u'ذَكَرَ أَصْنَافٌ':Predicate, #1: 1	ذَكَرَ أَصْنَافَ
u'ذكر أَصْنَافٌ':Added, #4: 4	ذَكَرَ الْأَصْنَافَ
u'ذِكْرٌ أَصْنَافٌ':Added, #4: 4	ذِكْرِ أَصْنَافِ
u'ذَكَرَ أُصولٌ':Predicate, #4: 4	ذِكْرِ أَصْنَافِ
u'ذكر أُصولٌ':Added, #1: 1	ذَكَرَ الْأُصُولَ
u'ذِكْرٌ أُصولٌ':Added, #1: 1	ذِكْرِ أُصُولِ
u'ذَكَرَ إضْمارٌ':Predicate, #1: 1	ذِكْرِ أُصُولِ
u'ذَكَرَ إِطْعامٌ':Predicate, #1: 1	ذَكَرَ الْإِضْمَارَ
u'ذَكَرَ أظهر':Predicate, #1: 1	ذَكَرَ الْإِطْعَامَ
u'ذَكَرَ إِعادَةٌ':Predicate, #1: 1	ذَكَرَ الْأَظْهَرَ
u'ذَكَرَ إِعْتاقٌ':Predicate, #2: 2	ذَكَرَ إعَادَةَ
u'ذكر إِعْتاقٌ':Added, #1: 1	ذَكَرَ الْإِعْتَاقَ
u'ذِكْرٌ إِعْتاقٌ':Added, #1: 1	ذِكْرُ الْإِعْتَاقِ
u'ذكر أعداد':Added, #1: 1	ذِكْرُ الْإِعْتَاقِ
u'ذكر أَعْدَادٌ':Added, #1: 1	ذِكْرِ أَعْدَادِ
u'ذِكْرٌ أعداد':Added, #1: 1	ذِكْرِ أَعْدَادِ
u'ذِكْرٌ أَعْدَادٌ':Added, #1: 1	ذِكْرِ أَعْدَادِ
u'ذكر أَعْذَارٌ':Added, #1: 1	ذِكْرِ أَعْدَادِ
u'ذِكْرٌ أَعْذَارٌ':Added, #1: 1	ذِكْرِ أَعْذَارِ
u'ذَكَرَ أَعْرابٌ':Predicate, #1: 1	ذِكْرِ أَعْذَارِ
u'ذكر أَعْرابٌ':Added, #2: 2	ذَكَرَ الْأَعْرَابَ
u'ذِكْرٌ أَعْرابٌ':Added, #1: 1	ذِكْرُ الْأَعْرَابِ
u'ذَكَرَ أَعْرَافٌ':Predicate, #1: 1	ذِكْرُ الْأَعْرَابِ
u'ذكر أعْرَج':Added, #1: 1	ذَكَرَ الْأَعْرَافَ
u'ذِكْرٌ أعْرَج':Added, #1: 1	ذِكْرُ الْأَعْرَجِ
u'ذَكَرَ أَعْضَاءٌ':Predicate, #1: 1	ذِكْرُ الْأَعْرَجِ
u'ذكر أَعْضَاءٌ':Added, #1: 1	ذَكَرَ الْأَعْضَاءَ
u'ذكر أَعْضَاءٌ':Added, #1: 1	ذِكْرُ أَعْضَاءِ
u'ذِكْرٌ أَعْضَاءٌ':Added, #1: 1	ذِكْرِ أَعْضَاءِ
u'ذِكْرٌ أَعْضَاءٌ':Added, #1: 1	ذِكْرُ أَعْضَاءِ
u'ذَكَرَ إعْطَاءٌ':Predicate, #1: 1	ذِكْرِ أَعْضَاءِ
u'ذكر أعْظَمُ':Added, #1: 1	ذَكَرَ الْإِعْطَاءَ
u'ذِكْرٌ أعْظَمُ':Added, #1: 1	ذِكْرِ الْأَعْظَمِ
u'ذَكَرَ إعْفاءٌ':Predicate, #1: 1	ذِكْرِ الْأَعْظَمِ
u'ذكر أعْلَمُ':Added, #1: 1	ذَكَرَ إِعْفَاءَ
u'ذِكْرٌ أعْلَمُ':Added, #1: 1	ذِكْرِ الْأَعْلَمِ
u'ذَكَرَ أَعَمُّ':Predicate, #1: 1	ذِكْرِ الْأَعْلَمِ
u'ذَكَرَ أَعَمُّ':Subject, #1: 1	ذَكَرَ أَعَمَّ
u'ذكر أَعَمُّ':Added, #1: 1	ذَكَرَ أَعَمُّ
u'ذِكْرٌ أَعَمُّ':Added, #1: 1	ذِكْرُ الْأَعَمِّ
u'ذكر أَعْمَالٌ':Added, #1: 1	ذِكْرُ الْأَعَمِّ
u'ذِكْرٌ أَعْمَالٌ':Added, #1: 1	ذِكْرِ الْأَعْمَالِ
u'ذكر إعْياءٌ':Added, #1: 1	ذِكْرِ الْأَعْمَالِ
u'ذِكْرٌ إعْياءٌ':Added, #1: 1	ذِكْرَ الْإِعْيَاءِ
u'ذكر أعْيانٌ':Added, #1: 1	ذِكْرَ الْإِعْيَاءِ
u'ذكر أَعْيَانٌ':Added, #1: 1	ذِكْرِ الْأَعْيَانِ
u'ذِكْرٌ أعْيانٌ':Added, #1: 1	ذِكْرِ الْأَعْيَانِ
u'ذِكْرٌ أَعْيَانٌ':Added, #1: 1	ذِكْرِ الْأَعْيَانِ
u'ذَكَرَ أَغْنِيَاء':Predicate, #1: 1	ذِكْرِ الْأَعْيَانِ
u'ذَكَرَ اِفْتِرَاضٌ':Predicate, #1: 1	ذَكَرَ أَغْنِيَاءَ
u'ذكر أَفْرَادٌ':Added, #1: 1	ذَكَرَ افْتِرَاضَ
u'ذكر أَفْرَادٌ':Added, #1: 1	ذِكْرَ الْأَفْرَادِ
u'ذِكْرٌ أَفْرَادٌ':Added, #1: 1	ذِكْرِ الْأَفْرَادِ
u'ذِكْرٌ أَفْرَادٌ':Added, #1: 1	ذِكْرَ الْأَفْرَادِ
u'ذَكَرَ أفْضَلُ':Predicate, #1: 1	ذِكْرِ الْأَفْرَادِ
u'ذَكَرَ أَفْعَالٌ':Predicate, #1: 1	ذَكَرَ الْأَفْضَلَ
u'ذكر أَفْعَالٌ':Added, #1: 1	ذَكَرَ أَفْعَالَ
u'ذِكْرٌ أَفْعَالٌ':Added, #1: 1	ذِكْرِ أَفْعَالِ
u'ذكر إفْكٌ':Added, #1: 1	ذِكْرِ أَفْعَالِ
u'ذِكْرٌ إفْكٌ':Added, #1: 1	ذِكْرِ الإِفْكِ
u'ذكر إقامَةٌ':Added, #1: 1	ذِكْرِ الإِفْكِ
u'ذكر إقامَةٌ':Added, #1: 1	ذِكْرِ الإِقَامَةِ
u'ذِكْرٌ إقامَةٌ':Added, #1: 1	ذِكْرِ الْإِقَامَةِ
u'ذِكْرٌ إقامَةٌ':Added, #1: 1	ذِكْرِ الإِقَامَةِ
u'ذَكَرَ إقْرَارٌ':Predicate, #1: 1	ذِكْرِ الْإِقَامَةِ
u'ذكر إقْرَارٌ':Added, #1: 1	ذَكَرَ الْإِقْرَارَ
u'ذكر إقْرَارٌ':Added, #1: 1	ذِكْرُ إقْرَارٍ
u'ذكر إقْرَارٌ':Added, #1: 1	ذِكْرُ إقْرَارِ
u'ذِكْرٌ إقْرَارٌ':Added, #1: 1	ذِكْرِ إقْرَارٍ
u'ذِكْرٌ إقْرَارٌ':Added, #1: 1	ذِكْرُ إقْرَارٍ
u'ذِكْرٌ إقْرَارٌ':Added, #1: 1	ذِكْرُ إقْرَارِ
u'ذكر إقْرَارٌ':Added, #1: 1	ذِكْرِ إقْرَارٍ
u'ذِكْرٌ إقْرَارٌ':Added, #1: 1	ذِكْرَ الْإِقْرَارِ
u'ذكر إقْرَارٌ':Added, #1: 1	ذِكْرَ الْإِقْرَارِ
u'ذِكْرٌ إقْرَارٌ':Added, #2: 2	ذِكْرِ الْإِقْرَارِ
u'ذكر أقْرَبُ':Added, #2: 2	ذِكْرِ الْإِقْرَارِ
u'ذِكْرٌ أقْرَبُ':Added, #1: 1	ذِكْرُ الْأَقْرَبِ
u'ذَكَرَ أَقْسَامٌ':Predicate, #1: 1	ذِكْرُ الْأَقْرَبِ
u'ذكر أَقْسَامٌ':Added, #1: 1	ذَكَرَ أَقْسَامَ
u'ذِكْرٌ أَقْسَامٌ':Added, #1: 1	ذِكْرُ أَقْسَامِ
u'ذكر أَقْسَامٌ':Added, #1: 1	ذِكْرُ أَقْسَامِ
u'ذِكْرٌ أَقْسَامٌ':Added, #1: 1	ذِكْرُ أَقْسَامِهِ
u'ذكر أَقْسَامٌ':Added, #1: 1	ذِكْرُ أَقْسَامِهِ
u'ذِكْرٌ أَقْسَامٌ':Added, #1: 1	ذِكْرَ الْأَقْسَامِ
u'ذَكَرَ أقَلُّ':Predicate, #1: 1	ذِكْرَ الْأَقْسَامِ
u'ذَكَرَ أَقْوَالٌ':Predicate, #1: 1	ذَكَرَ الْأَقَلَّ
u'ذكر أكَاذِيبُ':Added, #3: 3	ذَكَرَ الْأَقْوَالَ
u'ذِكْرٌ أكَاذِيبُ':Added, #1: 1	ذِكْرِ الْأَكَاذِيبِ
u'ذَكَرَ أَكْثَرُ':Predicate, #1: 1	ذِكْرِ الْأَكَاذِيبِ
u'ذَكَرَ أَكْثَرُ':Subject, #1: 1	ذَكَرَ أَكْثَرَ
u'ذَكَرَ أَكْثَرُ':Subject, #1: 1	ذَكَرَ الْأَكْثَرُ
u'ذكر أَكْثَرُ':Added, #2: 2	ذَكَرَ أَكْثَرُ
u'ذِكْرٌ أَكْثَرُ':Added, #1: 1	ذِكْرَ أَكْثَرِ
u'ذكر أَكْثَرُ':Added, #1: 1	ذِكْرَ أَكْثَرِ
u'ذِكْرٌ أَكْثَرُ':Added, #1: 1	ذِكْرِ الْأَكْثَرِ
u'ذَكَرَ أكل':Predicate, #1: 1	ذِكْرِ الْأَكْثَرِ
u'ذَكَرَ أَكْلٌ':Predicate, #1: 1	ذَكَرَ أَكْلَ
u'ذكر أكل':Added, #1: 1	ذَكَرَ أَكْلَ
u'ذكر أَكْلٌ':Added, #1: 1	ذِكْرَ الأَكْلِ
u'ذِكْرٌ أكل':Added, #1: 1	ذِكْرَ الأَكْلِ
u'ذِكْرٌ أَكْلٌ':Added, #1: 1	ذِكْرَ الأَكْلِ
u'ذكر أكل':Added, #1: 1	ذِكْرَ الأَكْلِ
u'ذكر أكل':Added, #3: 3	ذِكْرُ الأَكْلِ
u'ذكر أَكْلٌ':Added, #3: 3	ذِكْرُ الْأَكْلِ
u'ذكر أَكْلٌ':Added, #3: 3	ذِكْرُ الأَكْلِ
u'ذِكْرٌ أكل':Added, #3: 3	ذِكْرُ الْأَكْلِ
u'ذِكْرٌ أكل':Added, #3: 3	ذِكْرُ الأَكْلِ
u'ذِكْرٌ أَكْلٌ':Added, #3: 3	ذِكْرُ الْأَكْلِ
u'ذِكْرٌ أَكْلٌ':Added, #3: 3	ذِكْرُ الأَكْلِ
u'ذَكَرَ أَكْمَلُ':Subject, #3: 3	ذِكْرُ الْأَكْلِ
u'ذكر أَلْبَانٌ':Added, #1: 1	ذَكَرَ الْأَكْمَلُ
u'ذِكْرٌ أَلْبَانٌ':Added, #1: 1	ذِكْرُ الْأَلْبَانِ
u'ذَكَرَ ألف':Predicate, #1: 1	ذِكْرُ الْأَلْبَانِ
u'ذَكَرَ ألْفٌ':Predicate, #2: 2	ذَكَرَ الْأَلْفَ
u'ذَكَرَ أَلْفٌ':Predicate, #2: 2	ذَكَرَ الْأَلْفَ
u'ذكر ألف':Added, #2: 2	ذَكَرَ الْأَلْفَ
u'ذِكْرٌ ألف':Added, #1: 1	ذِكْرُ الْأَلِفِ
u'ذكر ألْفٌ':Added, #1: 1	ذِكْرُ الْأَلِفِ
u'ذِكْرٌ ألْفٌ':Added, #1: 1	ذِكْرِ أَلْفَيْنِ
u'ذكر ألف':Added, #1: 1	ذِكْرِ أَلْفَيْنِ
u'ذكر ألْفٌ':Added, #2: 2	ذِكْرُ الْأَلْفِ
u'ذكر أَلْفٌ':Added, #2: 2	ذِكْرُ الْأَلْفِ
u'ذِكْرٌ ألف':Added, #2: 2	ذِكْرُ الْأَلْفِ
u'ذِكْرٌ ألْفٌ':Added, #2: 2	ذِكْرُ الْأَلْفِ
u'ذِكْرٌ أَلْفٌ':Added, #2: 2	ذِكْرُ الْأَلْفِ
u'ذكر أَلْفَاظٌ':Added, #2: 2	ذِكْرُ الْأَلْفِ
u'ذِكْرٌ أَلْفَاظٌ':Added, #1: 1	ذِكْرِ الْأَلْفَاظِ
u'ذكر اللهُ':Added, #1: 1	ذِكْرِ الْأَلْفَاظِ
u'ذِكْرٌ اللهُ':Added, #1: 1	ذِكْرِ اللهِ
u'ذكر الْمَرْءُ':Added, #1: 1	ذِكْرِ اللهِ
u'ذِكْرٌ الْمَرْءُ':Added, #1: 1	ذِكْرِ الْمَرْءِ
u'ذَكَرَ الْمَرْأَةُ':Predicate, #1: 1	ذِكْرِ الْمَرْءِ
u'ذكر الْمَرْأَةُ':Added, #1: 1	ذَكَرَ الْمَرْأَةَ
u'ذكر الْمَرْأَةُ':Added, #4: 4	ذِكْرُ الْمَرْأَةِ
u'ذِكْرٌ الْمَرْأَةُ':Added, #4: 4	ذِكْرِ الْمَرْأَةِ
u'ذِكْرٌ الْمَرْأَةُ':Added, #4: 4	ذِكْرُ الْمَرْأَةِ
u'ذكر إلَهٌ':Added, #4: 4	ذِكْرِ الْمَرْأَةِ
u'ذِكْرٌ إلَهٌ':Added, #1: 1	ذِكْرُ الْإِلَهِ
u'ذكر أُمٌّ':Added, #1: 1	ذِكْرُ الْإِلَهِ
u'ذِكْرٌ أُمٌّ':Added, #1: 1	ذِكْرُ أُمِّ
u'ذَكَرَ إمَاءٌ':Predicate, #1: 1	ذِكْرُ أُمِّ
u'ذَكَرَ إمَارَةٌ':Predicate, #1: 1	ذَكَرَ الْإِمَاءَ
u'ذكر أَمَاكِنُ':Added, #1: 1	ذَكَرَ الإِمَارَةَ
u'ذِكْرٌ أَمَاكِنُ':Added, #1: 1	ذِكْرَ الْأَمَاكِنِ
u'ذَكَرَ إمَامٌ':Predicate, #1: 1	ذِكْرَ الْأَمَاكِنِ
u'ذَكَرَ إمَامٌ':Subject, #2: 2	ذَكَرَ الْإِمَامَ
u'ذَكَرَ إمَامٌ':Subject, #45: 45	ذَكَرَ الْإِمَامُ
u'ذكر إمَامٌ':Added, #7: 7	ذَكَرَ إمَامُ
u'ذِكْرٌ إمَامٌ':Added, #1: 1	ذِكْرِ إمَامِ
u'ذكر إمَامٌ':Added, #1: 1	ذِكْرِ إمَامِ
u'ذِكْرٌ إمَامٌ':Added, #3: 3	ذِكْرِ الْإِمَامِ
u'ذكر أمَانٌ':Added, #3: 3	ذِكْرِ الْإِمَامِ
u'ذِكْرٌ أمَانٌ':Added, #1: 1	ذِكْرِ الْأَمَانِ
u'ذَكَرَ أمَانَةٌ':Predicate, #1: 1	ذِكْرِ الْأَمَانِ
u'ذكر أمَانَةٌ':Added, #2: 2	ذَكَرَ الْأَمَانَةَ
u'ذِكْرٌ أمَانَةٌ':Added, #4: 4	ذِكْرِ الْأَمَانَةِ
u'ذَكَرَ أمَةٌ':Predicate, #4: 4	ذِكْرِ الْأَمَانَةِ
u'ذَكَرَ أمَةٌ':Subject, #1: 1	ذَكَرَ الْأَمَةَ
u'ذكر أُمَّةٌ':Added, #1: 1	ذَكَرَ الْأَمَةُ
u'ذِكْرٌ أُمَّةٌ':Added, #1: 1	ذِكْرِ الْأُمَّةِ
u'ذكر أَمْثِلَةٌ':Added, #1: 1	ذِكْرِ الْأُمَّةِ
u'ذِكْرٌ أَمْثِلَةٌ':Added, #1: 1	ذِكْرُ أَمْثِلَةٍ
u'ذَكَرَ أَمْرٌ':Predicate, #1: 1	ذِكْرُ أَمْثِلَةٍ
u'ذكر اِمْرَأَةٌ':Added, #2: 2	ذَكَرَ أَمْرَ
u'ذِكْرٌ اِمْرَأَةٌ':Added, #1: 1	ذِكْرِ امْرَأَةٍ
u'ذكر اِمْرَأَةٌ':Added, #1: 1	ذِكْرِ امْرَأَةٍ
u'ذِكْرٌ اِمْرَأَةٌ':Added, #2: 2	ذِكْرُ امْرَأَةٍ
u'ذكر أَمْس':Added, #2: 2	ذِكْرُ امْرَأَةٍ
u'ذِكْرٌ أَمْس':Added, #2: 2	ذِكْرُ أَمْسِ
u'ذكر أُمُورٌ':Added, #2: 2	ذِكْرُ أَمْسِ
u'ذِكْرٌ أُمُورٌ':Added, #2: 2	ذِكْرِ أُمُورٍ
u'ذكر أنبياء':Added, #2: 2	ذِكْرِ أُمُورٍ
u'ذِكْرٌ أنبياء':Added, #1: 1	ذِكْرُ الْأَنْبِيَاءِ
u'ذكر اِنْتِظارٌ':Added, #1: 1	ذِكْرُ الْأَنْبِيَاءِ
u'ذِكْرٌ اِنْتِظارٌ':Added, #1: 1	ذِكْرِ انْتِظَارِ
u'ذَكَرَ اِنْتِفاء':Subject, #1: 1	ذِكْرِ انْتِظَارِ
u'ذَكَرَ اِنْتِقالٌ':Predicate, #2: 2	ذَكَرَ انْتِفَاءُ
u'ذَكَّرَ إِنْسانٌ':Predicate, #2: 2	ذَكَرَ انْتِقَالَ
u'ذكر إِنْسانٌ':Added, #1: 1	ذَكَّرَ الْإِنْسَانَ
u'ذِكْرٌ إِنْسانٌ':Added, #2: 2	ذِكْرِ الْإِنْسَانِ
u'ذكر إِنْسانٌ':Added, #2: 2	ذِكْرِ الْإِنْسَانِ
u'ذِكْرٌ إِنْسانٌ':Added, #3: 3	ذِكْرُ الْإِنْسَانِ
u'ذَكَرَ أَنْعامٌ':Predicate, #3: 3	ذِكْرُ الْإِنْسَانِ
u'ذَكَرَ أَنْعَامٌ':Predicate, #1: 1	ذَكَرَ الْأَنْعَامَ
u'ذكر أَنْفٌ':Added, #1: 1	ذَكَرَ الْأَنْعَامَ
u'ذكر أَنْفٌ':Added, #1: 1	ذِكْرَ الأَنْفِ
u'ذِكْرٌ أَنْفٌ':Added, #1: 1	ذِكْرَ الْأَنْفِ
u'ذِكْرٌ أَنْفٌ':Added, #1: 1	ذِكْرَ الأَنْفِ
u'ذَكَرَ اِنْفِرادٌ':Predicate, #1: 1	ذِكْرَ الْأَنْفِ
u'ذكر أَنْفُسٌ':Added, #1: 1	ذَكَرَ انْفِرَادَ
u'ذِكْرٌ أَنْفُسٌ':Added, #2: 2	ذِكْرِ الْأَنْفُسِ
u'ذَكَرَ إِنْكارٌ':Predicate, #2: 2	ذِكْرِ الْأَنْفُسِ
u'ذكر أَنْمَاطٌ':Added, #1: 1	ذَكَرَ إنْكَارَ
u'ذِكْرٌ أَنْمَاطٌ':Added, #1: 1	ذِكْرُ الأَنْمَاطِ
u'ذَكَرَ أَنْوَاعٌ':Predicate, #1: 1	ذِكْرُ الأَنْمَاطِ
u'ذكر أَنْوَاعٌ':Added, #2: 2	ذَكَرَ أَنْوَاعَ
u'ذكر أَنْوَاعٌ':Added, #1: 1	ذِكْرُ أَنْوَاعٍ
u'ذِكْرٌ أَنْوَاعٌ':Added, #1: 1	ذِكْرُ أَنْوَاعِ
u'ذِكْرٌ أَنْوَاعٌ':Added, #1: 1	ذِكْرُ أَنْوَاعٍ
u'ذكر أَنْوَاعٌ':Added, #1: 1	ذِكْرُ أَنْوَاعِ
u'ذِكْرٌ أَنْوَاعٌ':Added, #1: 1	ذِكْرِ أَنْوَاعِهِ
u'ذكر أَنْوَاعٌ':Added, #1: 1	ذِكْرِ أَنْوَاعِهِ
u'ذِكْرٌ أَنْوَاعٌ':Added, #3: 3	ذِكْرِ أَنْوَاعِ
u'ذَكَرَ أهْلٌ':Predicate, #3: 3	ذِكْرِ أَنْوَاعِ
u'ذَكَرَ أهْلٌ':Subject, #8: 8	ذَكَرَ أَهْلَ
u'ذكر أهْلٌ':Added, #5: 5	ذَكَرَ أَهْلُ
u'ذِكْرٌ أهْلٌ':Added, #15: 15	ذِكْرِ أَهْلِ
u'ذكر أهْلٌ':Added, #15: 15	ذِكْرِ أَهْلِ
u'ذكر أهْلٌ':Added, #2: 2	ذِكْرُ الْأَهْلِ
u'ذِكْرٌ أهْلٌ':Added, #2: 2	ذِكْرِ الْأَهْلِ
u'ذِكْرٌ أهْلٌ':Added, #2: 2	ذِكْرُ الْأَهْلِ
u'ذَكَرَ أوائل':Predicate, #2: 2	ذِكْرِ الْأَهْلِ
u'ذَكَرَ أَوْجُهٌ':Predicate, #1: 1	ذَكَرَ أَوَائِلَ
u'ذكر أَوْجُهٌ':Added, #1: 1	ذَكَرَ الْأَوْجُهَ
u'ذِكْرٌ أَوْجُهٌ':Added, #1: 1	ذِكْرِ الْأَوْجُهِ
u'ذَكَرَ أَوْسَاقٌ':Predicate, #1: 1	ذِكْرِ الْأَوْجُهِ
u'ذَكَرَ أَوْصَافٌ':Predicate, #1: 1	ذَكَرَ الْأَوْسَاقَ
u'ذكر أَوْصَافٌ':Added, #1: 1	ذَكَرَ أَوْصَافَ
u'ذكر أَوْصَافٌ':Added, #1: 1	ذِكْرُ أَوْصَافِ
u'ذكر أَوْصَافٌ':Added, #1: 1	ذِكْرِ أَوْصَافٍ
u'ذِكْرٌ أَوْصَافٌ':Added, #1: 1	ذِكْرِ أَوْصَافِ
u'ذِكْرٌ أَوْصَافٌ':Added, #1: 1	ذِكْرُ أَوْصَافِ
u'ذِكْرٌ أَوْصَافٌ':Added, #1: 1	ذِكْرِ أَوْصَافٍ
u'ذكر أَوْصَافٌ':Added, #1: 1	ذِكْرِ أَوْصَافِ
u'ذِكْرٌ أَوْصَافٌ':Added, #1: 1	ذِكْرِ أَوْصَافِهِ
u'ذكر أَوْصَافٌ':Added, #1: 1	ذِكْرِ أَوْصَافِهِ
u'ذِكْرٌ أَوْصَافٌ':Added, #5: 5	ذِكْرِ الْأَوْصَافِ
u'ذكر أَوْعَالٌ':Added, #5: 5	ذِكْرِ الْأَوْصَافِ
u'ذِكْرٌ أَوْعَالٌ':Added, #1: 1	ذِكْرِ الأَوْعَالِ
u'ذَكَرَ أَوْقَاتٌ':Predicate, #1: 1	ذِكْرِ الأَوْعَالِ
u'ذكر أَوْقَاتٌ':Added, #1: 1	ذَكَرَ الْأَوْقَاتَ
u'ذِكْرٌ أَوْقَاتٌ':Added, #1: 1	ذِكْرَ الْأَوْقَاتِ
u'ذَكَرَ أَوَّلُ':Predicate, #1: 1	ذِكْرَ الْأَوْقَاتِ
u'ذَكَرَ أَوَّلُ':Predicate, #3: 3	ذَكَرَ أَوَّلَ
u'ذَكَرَ أَوَّلُ':Subject, #8: 8	ذَكَرَ الْأَوَّلَ
u'ذكر أَوَّلُ':Added, #4: 4	ذَكَرَ الْأَوَّلُ
u'ذِكْرٌ أَوَّلُ':Added, #1: 1	ذِكْرُ أَوَّلِ
u'ذكر أَوَّلُ':Added, #1: 1	ذِكْرُ أَوَّلِ
u'ذِكْرٌ أَوَّلُ':Added, #2: 2	ذِكْرَ الْأَوَّلِ
u'ذَكَرَ أَوْلاَدٌ':Predicate, #2: 2	ذِكْرَ الْأَوَّلِ
u'ذكر أَوْلاَدٌ':Added, #2: 2	ذَكَرَ الْأَوْلَادَ
u'ذِكْرٌ أَوْلاَدٌ':Added, #1: 1	ذِكْرَ الْأَوْلَادِ
u'ذكر أَوْلاَدٌ':Added, #1: 1	ذِكْرَ الْأَوْلَادِ
u'ذكر أَوْلاَدٌ':Added, #1: 1	ذِكْرَ أَوْلَادِ
u'ذكر أَوْلاَدٌ':Added, #1: 1	ذِكْرُ أَوْلَادِ
u'ذِكْرٌ أَوْلاَدٌ':Added, #1: 1	ذِكْرِ أَوْلَادِ
u'ذِكْرٌ أَوْلاَدٌ':Added, #1: 1	ذِكْرَ أَوْلَادِ
u'ذِكْرٌ أَوْلاَدٌ':Added, #1: 1	ذِكْرُ أَوْلَادِ
u'ذكر أَوْلاَدٌ':Added, #1: 1	ذِكْرِ أَوْلَادِ
u'ذِكْرٌ أَوْلاَدٌ':Added, #2: 2	ذِكْرِ الْأَوْلَادِ
u'ذَكَرَ أَوْلَوِيٌّ':Predicate, #2: 2	ذِكْرِ الْأَوْلَادِ
u'ذكر أَوْلَوِيٌّ':Added, #1: 1	ذَكَرَ الْأَوْلَوِيَّةَ
u'ذِكْرٌ أَوْلَوِيٌّ':Added, #1: 1	ذِكْرِ الْأَوْلَوِيَّةِ
u'ذكر أَوْلَوِيٌّ':Added, #1: 1	ذِكْرِ الْأَوْلَوِيَّةِ
u'ذِكْرٌ أَوْلَوِيٌّ':Added, #1: 1	ذِكْرِ أَوْلَوِيَّتِهِ
u'ذَكَرَ أئِمَّةٌ':Subject, #1: 1	ذِكْرِ أَوْلَوِيَّتِهِ
u'ذَكَرَ أيَّامٌ':Predicate, #4: 4	ذَكَرَ الْأَئِمَّةُ
u'ذَكَرَ أَيَّامٌ':Predicate, #2: 2	ذَكَرَ الْأَيَّامَ
u'ذكر أيَّامٌ':Added, #2: 2	ذَكَرَ الْأَيَّامَ
u'ذكر أيَّامٌ':Added, #1: 1	ذِكْرُ الْأَيَّامِ
u'ذكر أَيَّامٌ':Added, #1: 1	ذِكْرِ الْأَيَّامِ
u'ذكر أَيَّامٌ':Added, #1: 1	ذِكْرُ الْأَيَّامِ
u'ذِكْرٌ أيَّامٌ':Added, #1: 1	ذِكْرِ الْأَيَّامِ
u'ذِكْرٌ أيَّامٌ':Added, #1: 1	ذِكْرُ الْأَيَّامِ
u'ذِكْرٌ أَيَّامٌ':Added, #1: 1	ذِكْرِ الْأَيَّامِ
u'ذِكْرٌ أَيَّامٌ':Added, #1: 1	ذِكْرُ الْأَيَّامِ
u'ذكر أيَّامٌ':Added, #1: 1	ذِكْرِ الْأَيَّامِ
u'ذكر أَيَّامٌ':Added, #6: 6	ذِكْرَ الْأَيَّامِ
u'ذِكْرٌ أيَّامٌ':Added, #6: 6	ذِكْرَ الْأَيَّامِ
u'ذِكْرٌ أَيَّامٌ':Added, #6: 6	ذِكْرَ الْأَيَّامِ
u'ذَكَرَ آيَةٌ':Predicate, #6: 6	ذِكْرَ الْأَيَّامِ
u'ذكر آيَةٌ':Added, #1: 1	ذَكَرَ آيَةَ
u'ذكر آيَةٌ':Added, #1: 1	ذِكْرُ آيَةٍ
u'ذكر آيَةٌ':Added, #1: 1	ذِكْرُ آيَةِ
u'ذِكْرٌ آيَةٌ':Added, #1: 1	ذِكْرِ آيَةِ
u'ذِكْرٌ آيَةٌ':Added, #1: 1	ذِكْرُ آيَةٍ
u'ذِكْرٌ آيَةٌ':Added, #1: 1	ذِكْرُ آيَةِ
u'ذكر آيَةٌ':Added, #1: 1	ذِكْرِ آيَةِ
u'ذِكْرٌ آيَةٌ':Added, #3: 3	ذِكْرِ الْآيَةِ
u'ذَكَرَ إِيجَابٌ':Predicate, #3: 3	ذِكْرِ الْآيَةِ
u'ذكر إِيجَابٌ':Added, #1: 1	ذَكَرَ إيجَابَ
u'ذِكْرٌ إِيجَابٌ':Added, #1: 1	ذِكْرِ الْإِيجَابِ
u'ذكر إِيدَاعٌ':Added, #1: 1	ذِكْرِ الْإِيجَابِ
u'ذِكْرٌ إِيدَاعٌ':Added, #1: 1	ذِكْرِ إيدَاعٍ
u'ذَكَرَ إيمَانٌ':Predicate, #1: 1	ذِكْرِ إيدَاعٍ
u'ذكر أَيْمَانٌ':Added, #2: 2	ذَكَرَ الْإِيمَانَ
u'ذِكْرٌ أَيْمَانٌ':Added, #1: 1	ذِكْرِ الْأَيْمَانِ
u'ذَكَرَ بَابٌ':Predicate, #1: 1	ذِكْرِ الْأَيْمَانِ
u'ذكر بَابٌ':Added, #4: 4	ذَكَرَ بَابَ
u'ذِكْرٌ بَابٌ':Added, #3: 3	ذِكْرَ بَابِ
u'ذكر بَارِحٌ':Added, #3: 3	ذِكْرَ بَابِ
u'ذِكْرٌ بَارِحٌ':Added, #1: 1	ذِكْرُ الْبَارِحَةِ
u'ذَكَرَ بَاطِلٌ':Subject, #1: 1	ذِكْرُ الْبَارِحَةِ
u'ذكر بَانٌ':Added, #1: 1	ذَكَرَ بَاطِلٌ
u'ذِكْرٌ بَانٌ':Added, #1: 1	ذِكْرَ بَانِيهِ
u'ذَكَرَ بَائِعٌ':Subject, #1: 1	ذِكْرَ بَانِيهِ
u'ذكر بَائِعٌ':Added, #7: 7	ذَكَرَ الْبَائِعُ
u'ذكر بَائِعٌ':Added, #1: 1	ذِكْرَ الْبَائِعِ
u'ذِكْرٌ بَائِعٌ':Added, #1: 1	ذِكْرِ الْبَائِعِ
u'ذِكْرٌ بَائِعٌ':Added, #1: 1	ذِكْرَ الْبَائِعِ
u'ذَكَرَ بَائِنٌ':Predicate, #1: 1	ذِكْرِ الْبَائِعِ
u'ذَكَرَ بُخَارِيٌّ':Predicate, #1: 1	ذَكَرَ الْبَائِنَ
u'ذَكَرَ بُخَارِيٌّ':Subject, #1: 1	ذَكَرَ الْبُخَارِيَّ
u'ذكر بَدْءٌ':Added, #4: 4	ذَكَرَ الْبُخَارِيُّ
u'ذِكْرٌ بَدْءٌ':Added, #1: 1	ذِكْرِ بَدْءِ
u'ذكر بَدْرٌ':Added, #1: 1	ذِكْرِ بَدْءِ
u'ذِكْرٌ بَدْرٌ':Added, #1: 1	ذِكْرُ بَدْرٍ
u'ذَكَرَ بَدَلٌ':Predicate, #1: 1	ذِكْرُ بَدْرٍ
u'ذَكَرَ بَدَلٌ':Predicate, #2: 2	ذَكَرَ الْبَدَلَ
u'ذكر بَدَلٌ':Added, #4: 4	ذَكَرَ بَدَلَ
u'ذِكْرٌ بَدَلٌ':Added, #1: 1	ذِكْرِ بَدَلِ
u'ذكر بَدَلٌ':Added, #1: 1	ذِكْرِ بَدَلِ
u'ذِكْرٌ بَدَلٌ':Added, #3: 3	ذِكْرُ الْبَدَلِ
u'ذكر بَدَلٌ':Added, #3: 3	ذِكْرُ الْبَدَلِ
u'ذِكْرٌ بَدَلٌ':Added, #6: 6	ذِكْرِ الْبَدَلِ
u'ذكر بَدِيعٌ':Added, #6: 6	ذِكْرِ الْبَدَلِ
u'ذِكْرٌ بَدِيعٌ':Added, #1: 1	ذِكْرِ الْبَدِيعِ
u'ذكر بُرٌّ':Added, #1: 1	ذِكْرِ الْبَدِيعِ
u'ذِكْرٌ بُرٌّ':Added, #1: 1	ذِكْرِ الْبُرِّ
u'ذكر بُرٌّ':Added, #1: 1	ذِكْرِ الْبُرِّ
u'ذِكْرٌ بُرٌّ':Added, #1: 1	ذِكْرُ الْبُرَّةِ
u'ذكر بَراءةٌ':Added, #1: 1	ذِكْرُ الْبُرَّةِ
u'ذِكْرٌ بَراءةٌ':Added, #1: 1	ذِكْرُ الْبَرَاءَةِ
u'ذكر بَراءةٌ':Added, #1: 1	ذِكْرُ الْبَرَاءَةِ
u'ذِكْرٌ بَراءةٌ':Added, #2: 2	ذِكْرَ الْبَرَاءَةِ
u'ذَكَرَ بُرْهانٌ':Subject, #2: 2	ذِكْرَ الْبَرَاءَةِ
u'ذَكَرَ بُرْهَانٌ':Subject, #1: 1	ذَكَرَ بُرْهَانُ
u'ذكر بُزاةٌ':Added, #1: 1	ذَكَرَ بُرْهَانُ
u'ذِكْرٌ بُزاةٌ':Added, #1: 1	ذِكْرُ الْبُزَاةِ
u'ذَكَرَ بَزَّارٌ':Subject, #1: 1	ذِكْرُ الْبُزَاةِ
u'ذَكَرَ بِشْرٌ':Subject, #3: 3	ذَكَرَ الْبَزَّارُ
u'ذَكَرَ بِشْرٌ':Subject, #1: 1	ذَكَرَ بِشْرٌ
u'ذَكَرَ بَطَلٌ':Predicate, #1: 1	ذَكَرَ بِشْرُ
u'ذَكَرَ بَطْنٌ':Predicate, #1: 1	ذَكَرَ بَطَلَ
u'ذَكَرَ بُطونٌ':Predicate, #1: 1	ذَكَرَ الْبَطْنَ
u'ذَكَرَ بَعْضٌ':Predicate, #1: 1	ذَكَرَ الْبُطُونَ
u'ذَكَرَ بَعْضٌ':Subject, #11: 11	ذَكَرَ بَعْضَ
u'ذكر بَعْضٌ':Added, #63: 63	ذَكَرَ بَعْضُ
u'ذِكْرٌ بَعْضٌ':Added, #1: 1	ذِكْرُ الْبَعْضِ
u'ذكر بَعْضٌ':Added, #1: 1	ذِكْرُ الْبَعْضِ
u'ذكر بَعْضٌ':Added, #1: 1	ذِكْرُ بَعْضٍ
u'ذِكْرٌ بَعْضٌ':Added, #1: 1	ذِكْرِ بَعْضٍ
u'ذِكْرٌ بَعْضٌ':Added, #1: 1	ذِكْرُ بَعْضٍ
u'ذكر بَعْضٌ':Added, #1: 1	ذِكْرِ بَعْضٍ
u'ذكر بَعْضٌ':Added, #1: 1	ذِكْرُ بَعْضِهِ
u'ذِكْرٌ بَعْضٌ':Added, #1: 1	ذِكْرِ بَعْضِهِ
u'ذِكْرٌ بَعْضٌ':Added, #1: 1	ذِكْرُ بَعْضِهِ
u'ذكر بَعْضٌ':Added, #1: 1	ذِكْرِ بَعْضِهِ
u'ذكر بَعْضٌ':Added, #5: 5	ذِكْرَ بَعْضِ
u'ذِكْرٌ بَعْضٌ':Added, #5: 5	ذِكْرِ بَعْضِ
u'ذِكْرٌ بَعْضٌ':Added, #5: 5	ذِكْرَ بَعْضِ
u'ذكر بَعْضٌ':Added, #5: 5	ذِكْرِ بَعْضِ
u'ذِكْرٌ بَعْضٌ':Added, #8: 8	ذِكْرُ بَعْضِ
u'ذكر بَعيرٌ':Added, #8: 8	ذِكْرُ بَعْضِ
u'ذِكْرٌ بَعيرٌ':Added, #1: 1	ذِكْرِ الْبَعِيرِ
u'ذكر بُغاث':Added, #1: 1	ذِكْرِ الْبَعِيرِ
u'ذِكْرٌ بُغاث':Added, #1: 1	ذِكْرِ الْبُغَاثِ
u'ذَكَرَ بَقَرٌ':Predicate, #1: 1	ذِكْرِ الْبُغَاثِ
u'ذكر بَقَرٌ':Added, #1: 1	ذَكَرَ الْبَقَرَ
u'ذِكْرٌ بَقَرٌ':Added, #1: 1	ذِكْرُ الْبَقَرِ
u'ذَكَرَ بَقِيَّةٌ':Predicate, #1: 1	ذِكْرُ الْبَقَرِ
u'ذكر بَقِيَّةٌ':Added, #6: 6	ذَكَرَ بَقِيَّةَ
u'ذكر بَقِيَّةٌ':Added, #1: 1	ذِكْرُ بَقِيَّةِ
u'ذِكْرٌ بَقِيَّةٌ':Added, #1: 1	ذِكْرِ بَقِيَّةِ
u'ذِكْرٌ بَقِيَّةٌ':Added, #1: 1	ذِكْرُ بَقِيَّةِ
u'ذكر بَكارَةٌ':Added, #1: 1	ذِكْرِ بَقِيَّةِ
u'ذِكْرٌ بَكارَةٌ':Added, #1: 1	ذِكْرِ الْبَكَارَةِ
u'ذكر بَلَدٌ':Added, #1: 1	ذِكْرِ الْبَكَارَةِ
u'ذِكْرٌ بَلَدٌ':Added, #1: 1	ذِكْرُ الْبَلَدِ
u'ذكر بُلُوغٌ':Added, #1: 1	ذِكْرُ الْبَلَدِ
u'ذِكْرٌ بُلُوغٌ':Added, #1: 1	ذِكْرَ الْبُلُوغِ
u'ذكر بِنَاءٌ':Added, #1: 1	ذِكْرَ الْبُلُوغِ
u'ذِكْرٌ بِنَاءٌ':Added, #1: 1	ذِكْرَ الْبِنَاءِ
u'ذكر بِنَاءٌ':Added, #1: 1	ذِكْرَ الْبِنَاءِ
u'ذِكْرٌ بِنَاءٌ':Added, #1: 1	ذِكْرُ بِنَاءِ
u'ذكر بِنَاءٌ':Added, #1: 1	ذِكْرُ بِنَاءِ
u'ذِكْرٌ بِنَاءٌ':Added, #2: 2	ذِكْرُ الْبِنَاءِ
u'ذكر بَهيمٌ':Added, #2: 2	ذِكْرُ الْبِنَاءِ
u'ذِكْرٌ بَهيمٌ':Added, #1: 1	ذِكْرَ الْبَهِيمَةِ
u'ذكر بَهِيمَةٌ':Added, #1: 1	ذِكْرَ الْبَهِيمَةِ
u'ذِكْرٌ بَهِيمَةٌ':Added, #1: 1	ذِكْرَ الْبَهِيمَةِ
u'ذكر بِئْرٌ':Added, #1: 1	ذِكْرَ الْبَهِيمَةِ
u'ذِكْرٌ بِئْرٌ':Added, #1: 1	ذِكْرِ بِئْرِ
u'ذَكَرَ بَيَانٌ':Predicate, #1: 1	ذِكْرِ بِئْرِ
u'ذكر بَيَانٌ':Added, #2: 2	ذَكَرَ بَيَانَ
u'ذِكْرٌ بَيَانٌ':Added, #1: 1	ذِكْرِ بَيَانِ
u'ذكر بَيَانٌ':Added, #1: 1	ذِكْرِ بَيَانِ
u'ذِكْرٌ بَيَانٌ':Added, #7: 7	ذِكْرِ الْبَيَانِ
u'ذَكَرَ بَيْتٌ':Predicate, #7: 7	ذِكْرِ الْبَيَانِ
u'ذكر بَيْتٌ':Added, #2: 2	ذَكَرَ الْبَيْتَ
u'ذِكْرٌ بَيْتٌ':Added, #3: 3	ذِكْرِ الْبَيْتِ
u'ذَكَرَ بَيْعٌ':Predicate, #3: 3	ذِكْرِ الْبَيْتِ
u'ذَكَرَ بَيْعٌ':Predicate, #1: 1	ذَكَرَ الْبَيْعَ
u'ذكر بَيْعٌ':Added, #3: 3	ذَكَرَ بَيْعَ
u'ذكر بَيْعٌ':Added, #1: 1	ذِكْرَ الْبَيْعِ
u'ذِكْرٌ بَيْعٌ':Added, #1: 1	ذِكْرُ الْبَيْعِ
u'ذِكْرٌ بَيْعٌ':Added, #1: 1	ذِكْرَ الْبَيْعِ
u'ذكر بَيْعٌ':Added, #1: 1	ذِكْرُ الْبَيْعِ
u'ذِكْرٌ بَيْعٌ':Added, #1: 1	ذِكْرِ بَيْعِ
u'ذكر بَيْعٌ':Added, #1: 1	ذِكْرِ بَيْعِ
u'ذِكْرٌ بَيْعٌ':Added, #2: 2	ذِكْرِ الْبَيْعِ
u'ذكر بَيْعَةٌ':Added, #2: 2	ذِكْرِ الْبَيْعِ
u'ذكر بَيْعَةٌ':Added, #1: 1	ذِكْرُ الْبَيْعَةِ
u'ذِكْرٌ بَيْعَةٌ':Added, #1: 1	ذِكْرِ الْبَيْعَةِ
u'ذِكْرٌ بَيْعَةٌ':Added, #1: 1	ذِكْرُ الْبَيْعَةِ
u'ذَكَرَ بَيْنٌ':Predicate, #1: 1	ذِكْرِ الْبَيْعَةِ
u'ذكر بَيِّنَةٌ':Added, #4: 4	ذَكَرَ بَيْنَ
u'ذِكْرٌ بَيِّنَةٌ':Added, #1: 1	ذِكْرِ الْبَيِّنَةِ
u'ذَكَرَ بُيُوتٌ':Predicate, #1: 1	ذِكْرِ الْبَيِّنَةِ
u'ذكر تاء':Added, #2: 2	ذَكَرَ بُيُوتَ
u'ذِكْرٌ تاء':Added, #1: 1	ذِكْرُ التَّاءِ
u'ذَكَرَ تَأْبِيدٌ':Predicate, #1: 1	ذِكْرُ التَّاءِ
u'ذكر تَأْبِيدٌ':Added, #1: 1	ذَكَرَ التَّأْبِيدَ
u'ذكر تَأْبِيدٌ':Added, #1: 1	ذِكْرَ التَّأْبِيدِ
u'ذِكْرٌ تَأْبِيدٌ':Added, #1: 1	ذِكْرِ التَّأْبِيدِ
u'ذِكْرٌ تَأْبِيدٌ':Added, #1: 1	ذِكْرَ التَّأْبِيدِ
u'ذكر تَأْبِيدٌ':Added, #1: 1	ذِكْرِ التَّأْبِيدِ
u'ذِكْرٌ تَأْبِيدٌ':Added, #7: 7	ذِكْرُ التَّأْبِيدِ
u'ذكر تَأْجِيلٌ':Added, #7: 7	ذِكْرُ التَّأْبِيدِ
u'ذِكْرٌ تَأْجِيلٌ':Added, #2: 2	ذِكْرِ التَّأْجِيلِ
u'ذَكَرَ تَأَخُّرٌ':Predicate, #2: 2	ذِكْرِ التَّأْجِيلِ
u'ذَكَرَ تَارِيخٌ':Predicate, #1: 1	ذَكَرَ تَأَخُّرَ
u'ذَكَرَ تَارِيخٌ':Predicate, #3: 3	ذَكَرَ التَّارِيخَ
u'ذكر تَارِيخٌ':Added, #3: 3	ذَكَرَ تَارِيخَ
u'ذكر تَارِيخٌ':Added, #1: 1	ذِكْرُ التَّارِيخِ
u'ذِكْرٌ تَارِيخٌ':Added, #1: 1	ذِكْرِ التَّارِيخِ
u'ذِكْرٌ تَارِيخٌ':Added, #1: 1	ذِكْرُ التَّارِيخِ
u'ذكر تَارِيخٌ':Added, #1: 1	ذِكْرِ التَّارِيخِ
u'ذِكْرٌ تَارِيخٌ':Added, #1: 1	ذِكْرِ تَارِيخٍ
u'ذكر تَبَع':Added, #1: 1	ذِكْرِ تَارِيخٍ
u'ذِكْرٌ تَبَع':Added, #1: 1	ذِكْرُ التَّبَعِ
u'ذكر تَبَع':Added, #1: 1	ذِكْرُ التَّبَعِ
u'ذِكْرٌ تَبَع':Added, #1: 1	ذِكْرِ التَّبَعِيَّةِ
u'ذكر تَبَعِيّ':Added, #1: 1	ذِكْرِ التَّبَعِيَّةِ
u'ذِكْرٌ تَبَعِيّ':Added, #1: 1	ذِكْرِ التَّبَعِيَّةِ
u'ذكر تَبَعِيَّة':Added, #1: 1	ذِكْرِ التَّبَعِيَّةِ
u'ذِكْرٌ تَبَعِيَّة':Added, #1: 1	ذِكْرِ التَّبَعِيَّةِ
u'ذكر تِبْن':Added, #1: 1	ذِكْرِ التَّبَعِيَّةِ
u'ذِكْرٌ تِبْن':Added, #1: 1	ذِكْرِ التِّبْنِ
u'ذَكَرَ تَتَابُعٌ':Predicate, #1: 1	ذِكْرِ التِّبْنِ
u'ذكر تَتَابُعٌ':Added, #4: 4	ذَكَرَ التَّتَابُعَ
u'ذِكْرٌ تَتَابُعٌ':Added, #2: 2	ذِكْرَ التَّتَابُعِ
u'ذَكَرَ تَحَالُفٌ':Predicate, #2: 2	ذِكْرَ التَّتَابُعِ
u'ذكر تَحْت':Added, #2: 2	ذَكَرَ التَّحَالُفَ
u'ذِكْرٌ تَحْت':Added, #1: 1	ذِكْرُ التَّحْتِيَّةِ
u'ذكر تَحْتِيّ':Added, #1: 1	ذِكْرُ التَّحْتِيَّةِ
u'ذِكْرٌ تَحْتِيّ':Added, #1: 1	ذِكْرُ التَّحْتِيَّةِ
u'ذَكَرَ تَحْرِيقٌ':Predicate, #1: 1	ذِكْرُ التَّحْتِيَّةِ
u'ذَكَرَ تَحْرِيم':Predicate, #1: 1	ذَكَرَ تَحْرِيقَ
u'ذَكَرَ تَحْرِيمٌ':Predicate, #1: 1	ذَكَرَ التَّحْرِيمَةَ
u'ذَكَرَ تَحْرِيمٌ':Predicate, #2: 2	ذَكَرَ التَّحْرِيمَ
u'ذَكَرَ تَحْقِيقٌ':Predicate, #6: 6	ذَكَرَ تَحْرِيمَ
u'ذَكَرَ تَحْكِيمٌ':Predicate, #1: 1	ذَكَرَ التَّحْقِيقَ
u'ذكر تَحْكِيمٌ':Added, #1: 1	ذَكَرَ تَحْكِيمَ
u'ذِكْرٌ تَحْكِيمٌ':Added, #2: 2	ذِكْرِ التَّحْكِيمِ
u'ذَكَرَ تَحَلُّلٌ':Predicate, #2: 2	ذِكْرِ التَّحْكِيمِ
u'ذكر تَحِيَّةٌ':Added, #1: 1	ذَكَرَ التَّحَلُّلَ
u'ذِكْرٌ تَحِيَّةٌ':Added, #1: 1	ذِكْرِ التّحِيّاتِ
u'ذكر تَخارُج':Added, #1: 1	ذِكْرِ التّحِيّاتِ
u'ذِكْرٌ تَخارُج':Added, #1: 1	ذِكْرِ التَّخَارُجِ
u'ذكر تَخْرِيجٌ':Added, #1: 1	ذِكْرِ التَّخَارُجِ
u'ذِكْرٌ تَخْرِيجٌ':Added, #2: 2	ذِكْرِ التَّخْرِيجِ
u'ذَكَرَ تَخْلِيَة':Predicate, #2: 2	ذِكْرِ التَّخْرِيجِ
u'ذكر تَخْيِيرٌ':Added, #1: 1	ذَكَرَ التَّخْلِيَةَ
u'ذِكْرٌ تَخْيِيرٌ':Added, #2: 2	ذِكْرِ التَّخْيِيرِ
u'ذكر تَدَارُكٌ':Added, #2: 2	ذِكْرِ التَّخْيِيرِ
u'ذِكْرٌ تَدَارُكٌ':Added, #1: 1	ذِكْرِ تَدَارُكِ
u'ذكر تُرَابٌ':Added, #1: 1	ذِكْرِ تَدَارُكِ
u'ذِكْرٌ تُرَابٌ':Added, #4: 4	ذِكْرُ التُّرَابِ
u'ذَكَرَ تَرَاوِيحُ':Predicate, #4: 4	ذِكْرُ التُّرَابِ
u'ذَكَرَ تَرْتِيبٌ':Predicate, #1: 1	ذَكَرَ التَّرَاوِيحَ
u'ذكر تَرْتِيبٌ':Added, #1: 1	ذَكَرَ التَّرْتِيبَ
u'ذِكْرٌ تَرْتِيبٌ':Added, #1: 1	ذِكْرُ تَرْتِيبِ
u'ذكر تَرْتِيبٌ':Added, #1: 1	ذِكْرُ تَرْتِيبِ
u'ذِكْرٌ تَرْتِيبٌ':Added, #3: 3	ذِكْرُ التَّرْتِيبِ
u'ذكر تَرْتِيبٌ':Added, #3: 3	ذِكْرُ التَّرْتِيبِ
u'ذِكْرٌ تَرْتِيبٌ':Added, #3: 3	ذِكْرِ تَرْتِيبِ
u'ذَكَرَ تَرْجِيحٌ':Predicate, #3: 3	ذِكْرِ تَرْتِيبِ
u'ذكر تَرْجِيعٌ':Added, #1: 1	ذَكَرَ تَرْجِيحَ
u'ذِكْرٌ تَرْجِيعٌ':Added, #1: 1	ذِكْرُ التَّرْجِيعِ
u'ذكر تَرْغِيبٌ':Added, #1: 1	ذِكْرُ التَّرْجِيعِ
u'ذِكْرٌ تَرْغِيبٌ':Added, #2: 2	ذِكْرُ التَّرْغِيبِ
u'ذَكَرَ تَرْكٌ':Predicate, #2: 2	ذِكْرُ التَّرْغِيبِ
u'ذكر تَرْكٌ':Added, #2: 2	ذَكَرَ تَرْكَ
u'ذِكْرٌ تَرْكٌ':Added, #1: 1	ذِكْرِ تَرْكِ
u'ذَكَرَ تَزَوُّجٌ':Predicate, #1: 1	ذِكْرِ تَرْكِ
u'ذكر تَزَوُّجٌ':Added, #1: 1	ذَكَرَ التَّزَوُّجَ
u'ذِكْرٌ تَزَوُّجٌ':Added, #1: 1	ذِكْرَ التَّزَوُّجِ
u'ذَكَرَ تَزْوِيجٌ':Predicate, #1: 1	ذِكْرَ التَّزَوُّجِ
u'ذَكَرَ تَسْبِيحٌ':Predicate, #2: 2	ذَكَرَ تَزْوِيجَ
u'ذَكَرَ تِسْعَةٌ':Predicate, #1: 1	ذَكَرَ تَسْبِيحَ
u'ذَكَرَ تَسْلِيمٌ':Predicate, #1: 1	ذَكَرَ التِّسْعَةَ
u'ذكر تَسْلِيمٌ':Added, #1: 1	ذَكَرَ التَّسْلِيمَ
u'ذكر تَسْلِيمٌ':Added, #1: 1	ذِكْرَ التَّسْلِيمِ
u'ذِكْرٌ تَسْلِيمٌ':Added, #1: 1	ذِكْرِ التَّسْلِيمِ
u'ذِكْرٌ تَسْلِيمٌ':Added, #1: 1	ذِكْرَ التَّسْلِيمِ
u'ذكر تَسْمِيَة':Added, #1: 1	ذِكْرِ التَّسْلِيمِ
u'ذِكْرٌ تَسْمِيَة':Added, #2: 2	ذِكْرِ التَّسْمِيَةِ
u'ذكر تَسْمِيَة':Added, #2: 2	ذِكْرِ التَّسْمِيَةِ
u'ذِكْرٌ تَسْمِيَة':Added, #5: 5	ذِكْرُ التَّسْمِيَةِ
u'ذَكَرَ تَشَهُّدٌ':Predicate, #5: 5	ذِكْرُ التَّسْمِيَةِ
u'ذكر تَشَهُّدٌ':Added, #2: 2	ذَكَرَ التَّشَهُّدَ
u'ذِكْرٌ تَشَهُّدٌ':Added, #1: 1	ذِكْرَ التَّشَهُّدِ
u'ذكر تَشَهُّدٌ':Added, #1: 1	ذِكْرَ التَّشَهُّدِ
u'ذِكْرٌ تَشَهُّدٌ':Added, #3: 3	ذِكْرُ التَّشَهُّدِ
u'ذَكَرَ تَصْحِيحٌ':Predicate, #3: 3	ذِكْرُ التَّشَهُّدِ
u'ذكر تَصَدُّقٌ':Added, #1: 1	ذَكَرَ تَصْحِيحَ
u'ذِكْرٌ تَصَدُّقٌ':Added, #1: 1	ذِكْرِ التَّصَدُّقِ
u'ذَكَرَ تَصْدِيقٌ':Predicate, #1: 1	ذِكْرِ التَّصَدُّقِ
u'ذكر تَصْدِيقٌ':Added, #1: 1	ذَكَرَ التَّصْدِيقَ
u'ذِكْرٌ تَصْدِيقٌ':Added, #2: 2	ذِكْرِ التَّصْدِيقِ
u'ذكر تَصَرُّفٌ':Added, #2: 2	ذِكْرِ التَّصْدِيقِ
u'ذكر تَصَرُّفٌ':Added, #1: 1	ذِكْرُ التَّصَرُّفِ
u'ذِكْرٌ تَصَرُّفٌ':Added, #1: 1	ذِكْرِ التَّصَرُّفِ
u'ذِكْرٌ تَصَرُّفٌ':Added, #1: 1	ذِكْرُ التَّصَرُّفِ
u'ذَكَرَ تَطْهِيرٌ':Predicate, #1: 1	ذِكْرِ التَّصَرُّفِ
u'ذكر تَعَارُضٌ':Added, #1: 1	ذَكَرَ تَطْهِيرَ
u'ذكر تَعَارُضٌ':Added, #1: 1	ذِكْرُ تَعَارُضِ
u'ذِكْرٌ تَعَارُضٌ':Added, #1: 1	ذِكْرِ تَعَارُضِ
u'ذِكْرٌ تَعَارُضٌ':Added, #1: 1	ذِكْرُ تَعَارُضِ
u'ذكر تَعْجِيل':Added, #1: 1	ذِكْرِ تَعَارُضِ
u'ذِكْرٌ تَعْجِيل':Added, #2: 2	ذِكْرِ التَّعْجِيلِ
u'ذَكَرَ تَعْدِيَة':Predicate, #2: 2	ذِكْرِ التَّعْجِيلِ
u'ذكر تَعْرِيفٌ':Added, #1: 1	ذَكَرَ التَّعْدِيَةَ
u'ذِكْرٌ تَعْرِيفٌ':Added, #1: 1	ذِكْرِ تَعْرِيفِ
u'ذَكَرَ تَعْزِير':Subject, #1: 1	ذِكْرِ تَعْرِيفِ
u'ذكر تَعْزِير':Added, #1: 1	ذَكَرَ التَّعْزِيرُ
u'ذِكْرٌ تَعْزِير':Added, #1: 1	ذِكْرِ التَّعْزِيرِ
u'ذَكَرَ تَعْلِيقٌ':Predicate, #1: 1	ذِكْرِ التَّعْزِيرِ
u'ذكر تَعَمُّدٌ':Added, #1: 1	ذَكَرَ التَّعْلِيقَ
u'ذِكْرٌ تَعَمُّدٌ':Added, #1: 1	ذِكْرُ التَّعَمُّدِ
u'ذَكَرَ تَعْوِيضٌ':Predicate, #1: 1	ذِكْرُ التَّعَمُّدِ
u'ذكر تَفَاصِيلُ':Added, #1: 1	ذَكَرَ التَّعْوِيضَ
u'ذِكْرٌ تَفَاصِيلُ':Added, #1: 1	ذِكْرَ تَفَاصِيلِ
u'ذكر تَفَرُّقٌ':Added, #1: 1	ذِكْرَ تَفَاصِيلِ
u'ذِكْرٌ تَفَرُّقٌ':Added, #1: 1	ذِكْرِ التَّفَرُّقِ
u'ذَكَرَ تَفْسِيرٌ':Predicate, #1: 1	ذِكْرِ التَّفَرُّقِ
u'ذَكَرَ تَفْسِيرٌ':Predicate, #1: 1	ذَكَرَ التَّفْسِيرَ
u'ذكر تَفْسِيرٌ':Added, #2: 2	ذَكَرَ تَفْسِيرَ
u'ذكر تَفْسِيرٌ':Added, #1: 1	ذِكْرُ تَفْسِيرِ
u'ذِكْرٌ تَفْسِيرٌ':Added, #1: 1	ذِكْرِ تَفْسِيرِ
u'ذِكْرٌ تَفْسِيرٌ':Added, #1: 1	ذِكْرُ تَفْسِيرِ
u'ذَكَرَ تَفْصِيلٌ':Predicate, #1: 1	ذِكْرِ تَفْسِيرِ
u'ذَكَرَ تَفْصِيلٌ':Predicate, #2: 2	ذَكَرَ التَّفْصِيلَ
u'ذكر تَفْصِيلٌ':Added, #2: 2	ذَكَرَ تَفْصِيلَ
u'ذِكْرٌ تَفْصِيلٌ':Added, #1: 1	ذِكْرِ التَّفْصِيلِ
u'ذكر تَفْصِيلٌ':Added, #1: 1	ذِكْرِ التَّفْصِيلِ
u'ذكر تَفْصِيلٌ':Added, #1: 1	ذِكْرُ تَفْصِيلِ
u'ذكر تَفْصِيلٌ':Added, #1: 1	ذِكْرِ تَفْصِيلٍ
u'ذِكْرٌ تَفْصِيلٌ':Added, #1: 1	ذِكْرِ تَفْصِيلِ
u'ذِكْرٌ تَفْصِيلٌ':Added, #1: 1	ذِكْرُ تَفْصِيلِ
u'ذِكْرٌ تَفْصِيلٌ':Added, #1: 1	ذِكْرِ تَفْصِيلٍ
u'ذَكَرَ تَفْضِيلٌ':Predicate, #1: 1	ذِكْرِ تَفْصِيلِ
u'ذَكَرَ تَفَكُّرٌ':Predicate, #2: 2	ذَكَرَ تَفْضِيلَ
u'ذكر تَفْوِيضٌ':Added, #1: 1	ذَكَرَ تَفَكُّرَ
u'ذِكْرٌ تَفْوِيضٌ':Added, #1: 1	ذِكْرَ التَّفْوِيضِ
u'ذَكَرَ تَقابُض':Predicate, #1: 1	ذِكْرَ التَّفْوِيضِ
u'ذكر تَقابُض':Added, #1: 1	ذَكَرَ التَّقَابُضَ
u'ذِكْرٌ تَقابُض':Added, #1: 1	ذِكْرِ التَّقَابُضِ
u'ذكر تَقْديرٌ':Added, #1: 1	ذِكْرِ التَّقَابُضِ
u'ذِكْرٌ تَقْديرٌ':Added, #1: 1	ذِكْرِ التَّقْدِيرِ
u'ذكر تَقْديرٌ':Added, #1: 1	ذِكْرِ التَّقْدِيرِ
u'ذِكْرٌ تَقْديرٌ':Added, #1: 1	ذِكْرِ تَقْدِيرِ
u'ذَكَرَ تَقْسِيمٌ':Predicate, #1: 1	ذِكْرِ تَقْدِيرِ
u'ذكر تَقْليدٌ':Added, #1: 1	ذَكَرَ التَّقْسِيمَ
u'ذكر تَقْليد':Added, #1: 1	ذِكْرُ تَقْلِيدِ
u'ذِكْرٌ تَقْليدٌ':Added, #1: 1	ذِكْرُ تَقْلِيدِ
u'ذِكْرٌ تَقْليد':Added, #1: 1	ذِكْرُ تَقْلِيدِ
u'ذكر تَقْيِيد':Added, #1: 1	ذِكْرُ تَقْلِيدِ
u'ذِكْرٌ تَقْيِيد':Added, #1: 1	ذِكْرُ التَّقْيِيدِ
u'ذَكَرَ تَكْبيرٌ':Predicate, #1: 1	ذِكْرُ التَّقْيِيدِ
u'ذكر تَكْبيرٌ':Added, #2: 2	ذَكَرَ التَّكْبِيرَ
u'ذكر تَكْبيرٌ':Added, #1: 1	ذِكْرَ التَّكْبِيرِ
u'ذِكْرٌ تَكْبيرٌ':Added, #1: 1	ذِكْرُ التَّكْبِيرِ
u'ذِكْرٌ تَكْبيرٌ':Added, #1: 1	ذِكْرَ التَّكْبِيرِ
u'ذكر تَكْذيبٌ':Added, #1: 1	ذِكْرُ التَّكْبِيرِ
u'ذِكْرٌ تَكْذيبٌ':Added, #1: 1	ذِكْرِ التَّكْذِيبِ
u'ذكر تَكْرارٌ':Added, #1: 1	ذِكْرِ التَّكْذِيبِ
u'ذِكْرٌ تَكْرارٌ':Added, #1: 1	ذِكْرُ التَّكْرَارِ
u'ذكر تَكْرارٌ':Added, #1: 1	ذِكْرُ التَّكْرَارِ
u'ذِكْرٌ تَكْرارٌ':Added, #2: 2	ذِكْرِ التَّكْرَارِ
u'ذكر تَلْبيَةٌ':Added, #2: 2	ذِكْرِ التَّكْرَارِ
u'ذِكْرٌ تَلْبيَةٌ':Added, #2: 2	ذِكْرُ التَّلْبِيَةِ
u'ذَكَرَ تَلْخيصٌ':Subject, #2: 2	ذِكْرُ التَّلْبِيَةِ
u'ذَكَرَ تَلَف':Predicate, #1: 1	ذَكَرَ التَّلْخِيصُ
u'ذَكَرَ تمام':Predicate, #1: 1	ذَكَرَ التَّلَفَ
u'ذَكَرَ تَمامٌ':Predicate, #3: 3	ذَكَرَ تَمَامَ
u'ذكر تمام':Added, #3: 3	ذَكَرَ تَمَامَ
u'ذكر تَمامٌ':Added, #1: 1	ذِكْرِ التَّمَامِ
u'ذِكْرٌ تمام':Added, #1: 1	ذِكْرِ التَّمَامِ
u'ذِكْرٌ تَمامٌ':Added, #1: 1	ذِكْرِ التَّمَامِ
u'ذَكَرَ تَمَتُّعٌ':Predicate, #1: 1	ذِكْرِ التَّمَامِ
u'ذَكَرَ تَمْكِينٌ':Subject, #1: 1	ذَكَرَ التَّمَتُّعَ
u'ذَكَرَ تَنْبِيهٌ':Subject, #1: 1	ذَكَرَ تَمْكِينُ
u'ذكر تَنْبِيه':Added, #1: 1	ذَكَرَ تَنْبِيهٌ
u'ذِكْرٌ تَنْبِيه':Added, #1: 1	ذِكْرُ التَّنْبِيهِ
u'ذكر تَنْجِيمٌ':Added, #1: 1	ذِكْرُ التَّنْبِيهِ
u'ذِكْرٌ تَنْجِيمٌ':Added, #1: 1	ذِكْرُ التَّنْجِيمِ
u'ذكر تَهْلِيلٌ':Added, #1: 1	ذِكْرُ التَّنْجِيمِ
u'ذكر تَهْلِيلٌ':Added, #1: 1	ذِكْرُ التَّهْلِيلِ
u'ذِكْرٌ تَهْلِيلٌ':Added, #1: 1	ذِكْرِ التَّهْلِيلِ
u'ذِكْرٌ تَهْلِيلٌ':Added, #1: 1	ذِكْرُ التَّهْلِيلِ
u'ذَكَرَ تَهَيُّؤٌ':Predicate, #1: 1	ذِكْرِ التَّهْلِيلِ
u'ذكر تَوابِعُ':Added, #1: 1	ذَكَرَ التَّهَيُّؤَ
u'ذكر تَوَابِعُ':Added, #1: 1	ذِكْرُ تَوَابِعِهِ
u'ذِكْرٌ تَوابِعُ':Added, #1: 1	ذِكْرُ تَوَابِعِهِ
u'ذِكْرٌ تَوَابِعُ':Added, #1: 1	ذِكْرُ تَوَابِعِهِ
u'ذكر تَوابِعُ':Added, #1: 1	ذِكْرُ تَوَابِعِهِ
u'ذكر تَوَابِعُ':Added, #2: 2	ذِكْرِ التَّوَابِعِ
u'ذِكْرٌ تَوابِعُ':Added, #2: 2	ذِكْرِ التَّوَابِعِ
u'ذِكْرٌ تَوَابِعُ':Added, #2: 2	ذِكْرِ التَّوَابِعِ
u'ذكر تَوْحِيدٌ':Added, #2: 2	ذِكْرِ التَّوَابِعِ
u'ذِكْرٌ تَوْحِيدٌ':Added, #1: 1	ذِكْرُ التَّوْحِيدِ
u'ذكر تَوْرَاةٌ':Added, #1: 1	ذِكْرُ التَّوْحِيدِ
u'ذِكْرٌ تَوْرَاةٌ':Added, #1: 1	ذِكْرِ التّوْرَاةِ
u'ذَكَرَ تَوْزِيعٌ':Predicate, #1: 1	ذِكْرِ التّوْرَاةِ
u'ذَكَرَ تَوْفِيقٌ':Predicate, #1: 1	ذَكَرَ التَّوْزِيعَ
u'ذكر تَوْفِيقٌ':Added, #2: 2	ذَكَرَ التَّوْفِيقَ
u'ذِكْرٌ تَوْفِيقٌ':Added, #1: 1	ذِكْرِ التَّوْفِيقِ
u'ذكر تَوْقِيت':Added, #1: 1	ذِكْرِ التَّوْفِيقِ
u'ذِكْرٌ تَوْقِيت':Added, #1: 1	ذِكْرُ التَّوْقِيتِ
u'ذكر تَوْكِيلٌ':Added, #1: 1	ذِكْرُ التَّوْقِيتِ
u'ذِكْرٌ تَوْكِيلٌ':Added, #2: 2	ذِكْرِ التَّوْكِيلِ
u'ذَكَرَ تَيَمُّمٌ':Predicate, #2: 2	ذِكْرِ التَّوْكِيلِ
u'ذكر تَيَمُّمٌ':Added, #2: 2	ذَكَرَ التَّيَمُّمَ
u'ذِكْرٌ تَيَمُّمٌ':Added, #1: 1	ذِكْرِ التَّيَمُّمِ
u'ذكر تَيَمُّمٌ':Added, #1: 1	ذِكْرِ التَّيَمُّمِ
u'ذِكْرٌ تَيَمُّمٌ':Added, #2: 2	ذِكْرُ التَّيَمُّمِ
u'ذَكَرَ ثَالِثٌ':Predicate, #2: 2	ذِكْرُ التَّيَمُّمِ
u'ذَكَرَ ثَالِثٌ':Predicate, #1: 1	ذَكَرَ الثَّالِثَ
u'ذكر ثَالِثٌ':Added, #1: 1	ذَكَرَ الثَّالِثَةَ
u'ذِكْرٌ ثَالِثٌ':Added, #1: 1	ذِكْرَ الثَّالِثِ
u'ذكر ثَالِثٌ':Added, #1: 1	ذِكْرَ الثَّالِثِ
u'ذِكْرٌ ثَالِثٌ':Added, #1: 1	ذِكْرَ الثَّالِثَةِ
u'ذكر ثَالِثٌ':Added, #1: 1	ذِكْرَ الثَّالِثَةِ
u'ذِكْرٌ ثَالِثٌ':Added, #1: 1	ذِكْرِ ثَالِثِ
u'ذكر ثَالِثٌ':Added, #1: 1	ذِكْرِ ثَالِثِ
u'ذِكْرٌ ثَالِثٌ':Added, #2: 2	ذِكْرِ الثَّالِثِ
u'ذَكَرَ ثَانِي':Predicate, #2: 2	ذِكْرِ الثَّالِثِ
u'ذَكَرَ ثَانِي':Predicate, #3: 3	ذَكَرَ الثَّانِيَ
u'ذكر ثَانِي':Added, #6: 6	ذَكَرَ الثَّانِيَةَ
u'ذِكْرٌ ثَانِي':Added, #5: 5	ذِكْرِ الثَّانِيَةِ
u'ذَكَرَ ثَانِيَةٌ':Predicate, #5: 5	ذِكْرِ الثَّانِيَةِ
u'ذكر ثَانِيَةٌ':Added, #6: 6	ذَكَرَ الثَّانِيَةَ
u'ذِكْرٌ ثَانِيَةٌ':Added, #5: 5	ذِكْرِ الثَّانِيَةِ
u'ذكر ثُبُوتٌ':Added, #5: 5	ذِكْرِ الثَّانِيَةِ
u'ذِكْرٌ ثُبُوتٌ':Added, #1: 1	ذِكْرِ الثُّبُوتِ
u'ذَكَرَ ثِقَة':Subject, #1: 1	ذِكْرِ الثُّبُوتِ
u'ذَكَرَ ثَلاثُ':Predicate, #2: 2	ذَكَرَ الثِّقَاتُ
u'ذَكَرَ ثَلاثُ':Predicate, #2: 2	ذَكَرَ الثَّلَاثَ
u'ذكر ثَلاثُ':Added, #7: 7	ذَكَرَ ثَلَاثَ
u'ذكر ثَلاثُ':Added, #1: 1	ذِكْرَ الثَّلَاثِ
u'ذِكْرٌ ثَلاثُ':Added, #1: 1	ذِكْرُ الثَّلَاثِ
u'ذِكْرٌ ثَلاثُ':Added, #1: 1	ذِكْرَ الثَّلَاثِ
u'ذكر ثَلاثُ':Added, #1: 1	ذِكْرُ الثَّلَاثِ
u'ذِكْرٌ ثَلاثُ':Added, #2: 2	ذِكْرِ الثَّلَاثِ
u'ذَكَرَ ثَلاثَةٌ':Predicate, #2: 2	ذِكْرِ الثَّلَاثِ
u'ذَكَرَ ثَلاثَةٌ':Predicate, #12: 12	ذَكَرَ ثَلَاثَةَ
u'ذكر ثَلاثَةٌ':Added, #3: 3	ذَكَرَ الثَّلَاثَةَ
u'ذِكْرٌ ثَلاثَةٌ':Added, #1: 1	ذِكْرَ ثَلَاثَةٍ
u'ذكر ثَلاثَةٌ':Added, #1: 1	ذِكْرَ ثَلَاثَةٍ
u'ذِكْرٌ ثَلاثَةٌ':Added, #2: 2	ذِكْرُ ثَلَاثَةِ
u'ذكر ثَلْجٌ':Added, #2: 2	ذِكْرُ ثَلَاثَةِ
u'ذِكْرٌ ثَلْجٌ':Added, #1: 1	ذِكْرِ الثَّلْجِ
u'ذكر ثُمام':Added, #1: 1	ذِكْرِ الثَّلْجِ
u'ذِكْرٌ ثُمام':Added, #1: 1	ذِكْرَ ثُمَامِ
u'ذَكَرَ ثَمَرٌ':Predicate, #1: 1	ذِكْرَ ثُمَامِ
u'ذَكَرَ ثَمَرٌ':Predicate, #1: 1	ذَكَرَ الثّمَرَ
u'ذكر ثَمَرٌ':Added, #1: 1	ذَكَرَ الثَّمَرَ
u'ذِكْرٌ ثَمَرٌ':Added, #1: 1	ذِكْرُ الثَّمَرِ
u'ذكر ثَمَرَةٌ':Added, #1: 1	ذِكْرُ الثَّمَرِ
u'ذِكْرٌ ثَمَرَةٌ':Added, #2: 2	ذِكْرِ ثَمَرَةِ
u'ذَكَرَ ثَمَنٌ':Predicate, #2: 2	ذِكْرِ ثَمَرَةِ
u'ذكر ثَمَنٌ':Added, #4: 4	ذَكَرَ الثَّمَنَ
u'ذِكْرٌ ثَمَنٌ':Added, #11: 11	ذِكْرِ الثَّمَنِ
u'ذكر ثَمَنٌ':Added, #11: 11	ذِكْرِ الثَّمَنِ
u'ذِكْرٌ ثَمَنٌ':Added, #1: 1	ذِكْرِ ثَمَنٍ
u'ذكر ثَمَنٌ':Added, #1: 1	ذِكْرِ ثَمَنٍ
u'ذِكْرٌ ثَمَنٌ':Added, #2: 2	ذِكْرَ الثَّمَنِ
u'ذكر ثَمَنٌ':Added, #2: 2	ذِكْرَ الثَّمَنِ
u'ذِكْرٌ ثَمَنٌ':Added, #4: 4	ذِكْرُ الثَّمَنِ
u'ذكر ثَوابٌ':Added, #4: 4	ذِكْرُ الثَّمَنِ
u'ذِكْرٌ ثَوابٌ':Added, #1: 1	ذِكْرِ الثَّوَابِ
u'ذكر ثَوابٌ':Added, #1: 1	ذِكْرِ الثَّوَابِ
u'ذِكْرٌ ثَوابٌ':Added, #1: 1	ذِكْرُ ثَوَابِهِ
u'ذَكَرَ ثَوْبٌ':Predicate, #1: 1	ذِكْرُ ثَوَابِهِ
u'ذكر ثَوْبٌ':Added, #2: 2	ذَكَرَ الثَّوْبَ
u'ذِكْرٌ ثَوْبٌ':Added, #1: 1	ذِكْرَ الثَّوْبِ
u'ذكر ثَوْبٌ':Added, #1: 1	ذِكْرَ الثَّوْبِ
u'ذِكْرٌ ثَوْبٌ':Added, #2: 2	ذِكْرُ الثَّوْبِ
u'ذكر ثَوْرٌ':Added, #2: 2	ذِكْرُ الثَّوْبِ
u'ذِكْرٌ ثَوْرٌ':Added, #3: 3	ذِكْرَ ثَوْرٍ
u'ذَكَرَ ثِيابٌ':Predicate, #3: 3	ذِكْرَ ثَوْرٍ
u'ذَكَرَ جَابِرٌ':Subject, #2: 2	ذَكَرَ الثِّيَابَ
u'ذكر جَابِرٌ':Added, #3: 3	ذَكَرَ جَابِرٌ
u'ذِكْرٌ جَابِرٌ':Added, #1: 1	ذِكْرُ جَابِرٍ
u'ذكر جَابِرٌ':Added, #1: 1	ذِكْرُ جَابِرٍ
u'ذِكْرٌ جَابِرٌ':Added, #3: 3	ذِكْرِ جَابِرٍ
u'ذكر جَادٌّ':Added, #3: 3	ذِكْرِ جَابِرٍ
u'ذِكْرٌ جَادٌّ':Added, #1: 1	ذِكْرِ جَادَّةِ
u'ذكر جَادَّةٌ':Added, #1: 1	ذِكْرِ جَادَّةِ
u'ذِكْرٌ جَادَّةٌ':Added, #1: 1	ذِكْرِ جَادَّةِ
u'ذَكَرَ جَاسُوسٌ':Predicate, #1: 1	ذِكْرِ جَادَّةِ
u'ذكر جَامِعٌ':Added, #1: 1	ذَكَرَ الْجَاسُوسَ
u'ذِكْرٌ جَامِعٌ':Added, #1: 1	ذِكْرِ الْجَامِعِ
u'ذَكَرَ جَانِبٌ':Predicate, #1: 1	ذِكْرِ الْجَامِعِ
u'ذكر جَبْرٌ':Added, #1: 1	ذَكَرَ جَانِبَ
u'ذِكْرٌ جَبْرٌ':Added, #1: 1	ذِكْرِ الْجَبْرِ
u'ذكر جَبَلٌ':Added, #1: 1	ذِكْرِ الْجَبْرِ
u'ذِكْرٌ جَبَلٌ':Added, #1: 1	ذِكْرَ الْجَبَلِ
u'ذكر جُبْنٌ':Added, #1: 1	ذِكْرَ الْجَبَلِ
u'ذِكْرٌ جُبْنٌ':Added, #1: 1	ذِكْرِ الْجُبْنِ
u'ذكر جُثَّة':Added, #1: 1	ذِكْرِ الْجُبْنِ
u'ذِكْرٌ جُثَّة':Added, #1: 1	ذِكْرِ الْجُثَّةِ
u'ذكر جَديدٌ':Added, #1: 1	ذِكْرِ الْجُثَّةِ
u'ذكر جَدِيدٌ':Added, #1: 1	ذِكْرِ الْجَدِيدِ
u'ذِكْرٌ جَديدٌ':Added, #1: 1	ذِكْرِ الْجَدِيدِ
u'ذِكْرٌ جَدِيدٌ':Added, #1: 1	ذِكْرِ الْجَدِيدِ
u'ذَكَرَ جَرٌّ':Predicate, #1: 1	ذِكْرِ الْجَدِيدِ
u'ذكر جَرَيان':Added, #1: 1	ذَكَرَ جَرَّ
u'ذِكْرٌ جَرَيان':Added, #1: 1	ذِكْرُ جَرَيَانِ
u'ذكر جُزْءٌ':Added, #1: 1	ذِكْرُ جَرَيَانِ
u'ذِكْرٌ جُزْءٌ':Added, #1: 1	ذِكْرِ الْجُزْءِ
u'ذكر جُزْءٌ':Added, #1: 1	ذِكْرِ الْجُزْءِ
u'ذِكْرٌ جُزْءٌ':Added, #1: 1	ذِكْرُ جُزْءٍ
u'ذَكَرَ جَزَاءٌ':Predicate, #1: 1	ذِكْرُ جُزْءٍ
u'ذكر جَزَاءٌ':Added, #3: 3	ذَكَرَ الْجَزَاءَ
u'ذِكْرٌ جَزَاءٌ':Added, #1: 1	ذِكْرِ الْجَزَاءِ
u'ذكر جَزَاءٌ':Added, #1: 1	ذِكْرِ الْجَزَاءِ
u'ذِكْرٌ جَزَاءٌ':Added, #2: 2	ذِكْرُ الْجَزَاءِ
u'ذَكَرَ جَصَّاصٌ':Subject, #2: 2	ذِكْرُ الْجَزَاءِ
u'ذَكَرَ جَلاَلٌ':Subject, #5: 5	ذَكَرَ الْجَصَّاصُ
u'ذَكَرَ جلد':Predicate, #1: 1	ذَكَرَ الْجَلَالُ
u'ذَكَرَ جَلْدٌ':Predicate, #3: 3	ذَكَرَ الْجَلْدَ
u'ذكر جلد':Added, #3: 3	ذَكَرَ الْجَلْدَ
u'ذكر جلد':Added, #1: 1	ذِكْرَ الْجَلْدِ
u'ذِكْرٌ جلد':Added, #1: 1	ذِكْرُ الْجِلْدِ
u'ذِكْرٌ جلد':Added, #1: 1	ذِكْرَ الْجَلْدِ
u'ذكر جَلْدٌ':Added, #1: 1	ذِكْرُ الْجِلْدِ
u'ذكر جِلْدٌ':Added, #1: 1	ذِكْرَ الْجَلْدِ
u'ذِكْرٌ جَلْدٌ':Added, #1: 1	ذِكْرُ الْجِلْدِ
u'ذِكْرٌ جِلْدٌ':Added, #1: 1	ذِكْرَ الْجَلْدِ
u'ذكر جَلِيٌّ':Added, #1: 1	ذِكْرُ الْجِلْدِ
u'ذِكْرٌ جَلِيٌّ':Added, #1: 1	ذِكْرِ الْجَلِيِّ
u'ذَكَرَ جماع':Predicate, #1: 1	ذِكْرِ الْجَلِيِّ
u'ذَكَرَ جِمَاعٌ':Predicate, #1: 1	ذَكَرَ الْجِمَاعَ
u'ذكر جماع':Added, #1: 1	ذَكَرَ الْجِمَاعَ
u'ذكر جماع':Added, #1: 1	ذِكْرَ الْجِمَاعِ
u'ذِكْرٌ جماع':Added, #1: 1	ذِكْرِ الْجِمَاعِ
u'ذِكْرٌ جماع':Added, #1: 1	ذِكْرَ الْجِمَاعِ
u'ذكر جِمَاعٌ':Added, #1: 1	ذِكْرِ الْجِمَاعِ
u'ذكر جِمَاعٌ':Added, #1: 1	ذِكْرَ الْجِمَاعِ
u'ذِكْرٌ جِمَاعٌ':Added, #1: 1	ذِكْرِ الْجِمَاعِ
u'ذِكْرٌ جِمَاعٌ':Added, #1: 1	ذِكْرَ الْجِمَاعِ
u'ذكر جماع':Added, #1: 1	ذِكْرِ الْجِمَاعِ
u'ذِكْرٌ جماع':Added, #2: 2	ذِكْرُ الْجِمَاعِ
u'ذكر جِمَاعٌ':Added, #2: 2	ذِكْرُ الْجِمَاعِ
u'ذِكْرٌ جِمَاعٌ':Added, #2: 2	ذِكْرُ الْجِمَاعِ
u'ذَكَرَ جَمَاعَةٌ':Subject, #2: 2	ذِكْرُ الْجِمَاعِ
u'ذكر جَمَاعَةٌ':Added, #23: 23	ذَكَرَ جَمَاعَةٌ
u'ذِكْرٌ جَمَاعَةٌ':Added, #1: 1	ذِكْرَ جَمَاعَةٍ
u'ذَكَرَ جمع':Predicate, #1: 1	ذِكْرَ جَمَاعَةٍ
u'ذَكَرَ جَمْعٌ':Predicate, #4: 4	ذَكَرَ الْجَمْعَ
u'ذَكَرَ جَمْعٌ':Subject, #4: 4	ذَكَرَ الْجَمْعَ
u'ذكر جمع':Added, #2: 2	ذَكَرَ جَمْعٌ
u'ذِكْرٌ جمع':Added, #1: 1	ذِكْرِ الْجَمْعِ
u'ذكر جَمْعٌ':Added, #1: 1	ذِكْرِ الْجَمْعِ
u'ذِكْرٌ جَمْعٌ':Added, #1: 1	ذِكْرِ الْجَمْعِ
u'ذَكَرَ جمعة':Predicate, #1: 1	ذِكْرِ الْجَمْعِ
u'ذَكَرَ جُمُعَةٌ':Predicate, #2: 2	ذَكَرَ الْجُمُعَةَ
u'ذكر جمعة':Added, #2: 2	ذَكَرَ الْجُمُعَةَ
u'ذكر جمعة':Added, #1: 1	ذِكْرَ الْجُمُعَةِ
u'ذكر جمعة':Added, #1: 1	ذِكْرُ الْجُمُعَةِ
u'ذِكْرٌ جمعة':Added, #1: 1	ذِكْرِ الْجُمُعَةِ
u'ذِكْرٌ جمعة':Added, #1: 1	ذِكْرَ الْجُمُعَةِ
u'ذِكْرٌ جمعة':Added, #1: 1	ذِكْرُ الْجُمُعَةِ
u'ذكر جُمُعَةٌ':Added, #1: 1	ذِكْرِ الْجُمُعَةِ
u'ذكر جُمُعَةٌ':Added, #1: 1	ذِكْرَ الْجُمُعَةِ
u'ذكر جُمُعَةٌ':Added, #1: 1	ذِكْرُ الْجُمُعَةِ
u'ذِكْرٌ جُمُعَةٌ':Added, #1: 1	ذِكْرِ الْجُمُعَةِ
u'ذِكْرٌ جُمُعَةٌ':Added, #1: 1	ذِكْرَ الْجُمُعَةِ
u'ذِكْرٌ جُمُعَةٌ':Added, #1: 1	ذِكْرُ الْجُمُعَةِ
u'ذكر جَمَلٌ':Added, #1: 1	ذِكْرِ الْجُمُعَةِ
u'ذكر جُمَلٌ':Added, #1: 1	ذِكْرِ الْجَمَلِ
u'ذِكْرٌ جَمَلٌ':Added, #1: 1	ذِكْرِ الْجُمَلِ
u'ذِكْرٌ جُمَلٌ':Added, #1: 1	ذِكْرِ الْجَمَلِ
u'ذكر جُمَلٌ':Added, #1: 1	ذِكْرِ الْجُمَلِ
u'ذِكْرٌ جُمَلٌ':Added, #1: 1	ذِكْرُ جُمَلٍ
u'ذكر جُمْلَةٌ':Added, #1: 1	ذِكْرُ جُمَلٍ
u'ذكر جُمْلَةٌ':Added, #1: 1	ذِكْرِ جُمْلَةٍ
u'ذِكْرٌ جُمْلَةٌ':Added, #1: 1	ذِكْرِ جُمْلَةِ
u'ذِكْرٌ جُمْلَةٌ':Added, #1: 1	ذِكْرِ جُمْلَةٍ
u'ذكر جُمْلَةٌ':Added, #1: 1	ذِكْرِ جُمْلَةِ
u'ذِكْرٌ جُمْلَةٌ':Added, #2: 2	ذِكْرِ الْجُمْلَةِ
u'ذكر جُمْلَةٌ':Added, #2: 2	ذِكْرِ الْجُمْلَةِ
u'ذِكْرٌ جُمْلَةٌ':Added, #2: 2	ذِكْرُ جُمْلَةِ
u'ذَكَرَ جُمْهُورٌ':Subject, #2: 2	ذِكْرُ جُمْلَةِ
u'ذَكَرَ جُمْهُورٌ':Subject, #1: 1	ذَكَرَ الْجُمْهُورُ
u'ذَكَرَ جُمَّيْزٌ':Subject, #1: 1	ذَكَرَ جُمْهُورُ
u'ذَكَرَ جَمِيع':Predicate, #1: 1	ذَكَرَ الْجُمَّيْزُ
u'ذكر جَمِيع':Added, #1: 1	ذَكَرَ الْجَمِيعَ
u'ذِكْرٌ جَمِيع':Added, #2: 2	ذِكْرُ الْجَمِيعِ
u'ذكر جِنٌّ':Added, #2: 2	ذِكْرُ الْجَمِيعِ
u'ذِكْرٌ جِنٌّ':Added, #2: 2	ذِكْرِ الْجِنِّ
u'ذَكَرَ جِنَايَةٌ':Predicate, #2: 2	ذِكْرِ الْجِنِّ
u'ذَكَرَ جِنَايَةٌ':Predicate, #1: 1	ذَكَرَ الْجِنَايَةَ
u'ذكر جِنَايَةٌ':Added, #2: 2	ذَكَرَ جِنَايَةَ
u'ذِكْرٌ جِنَايَةٌ':Added, #1: 1	ذِكْرِ الْجِنَايَاتِ
u'ذكر جِنَايَةٌ':Added, #1: 1	ذِكْرِ الْجِنَايَاتِ
u'ذِكْرٌ جِنَايَةٌ':Added, #1: 1	ذِكْرِ جِنَايَةِ
u'ذَكَرَ جَنَّةٌ':Predicate, #1: 1	ذِكْرِ جِنَايَةِ
u'ذكر جَنَّةٌ':Added, #1: 1	ذَكَرَ الْجَنّةَ
u'ذِكْرٌ جَنَّةٌ':Added, #1: 1	ذِكْرِ جَنّةٍ
u'ذكر جَنَّةٌ':Added, #1: 1	ذِكْرِ جَنّةٍ
u'ذِكْرٌ جَنَّةٌ':Added, #2: 2	ذِكْرِ جَنَّةٍ
u'ذكر جَنَّةٌ':Added, #2: 2	ذِكْرِ جَنَّةٍ
u'ذِكْرٌ جَنَّةٌ':Added, #6: 6	ذِكْرُ الْجَنَّةِ
u'ذكر جَنَّةٌ':Added, #6: 6	ذِكْرُ الْجَنَّةِ
u'ذِكْرٌ جَنَّةٌ':Added, #8: 8	ذِكْرِ الْجَنَّةِ
u'ذَكَرَ جِنْسٌ':Predicate, #8: 8	ذِكْرِ الْجَنَّةِ
u'ذكر جِنْسٌ':Added, #2: 2	ذَكَرَ الْجِنْسَ
u'ذِكْرٌ جِنْسٌ':Added, #1: 1	ذِكْرَ الْجِنْسِ
u'ذكر جِنْسٌ':Added, #1: 1	ذِكْرَ الْجِنْسِ
u'ذِكْرٌ جِنْسٌ':Added, #1: 1	ذِكْرُ جِنْسٍ
u'ذكر جِنْسٌ':Added, #1: 1	ذِكْرُ جِنْسٍ
u'ذكر جِنْسٌ':Added, #1: 1	ذِكْرُ جِنْسِهِ
u'ذِكْرٌ جِنْسٌ':Added, #1: 1	ذِكْرِ جِنْسِهِ
u'ذِكْرٌ جِنْسٌ':Added, #1: 1	ذِكْرُ جِنْسِهِ
u'ذكر جِنْسٌ':Added, #1: 1	ذِكْرِ جِنْسِهِ
u'ذِكْرٌ جِنْسٌ':Added, #2: 2	ذِكْرِ جِنْسِ
u'ذكر جِنْسٌ':Added, #2: 2	ذِكْرِ جِنْسِ
u'ذِكْرٌ جِنْسٌ':Added, #3: 3	ذِكْرُ جِنْسِ
u'ذكر جِنْسٌ':Added, #3: 3	ذِكْرُ جِنْسِ
u'ذِكْرٌ جِنْسٌ':Added, #5: 5	ذِكْرُ الْجِنْسِ
u'ذكر جِنْسٌ':Added, #5: 5	ذِكْرُ الْجِنْسِ
u'ذِكْرٌ جِنْسٌ':Added, #8: 8	ذِكْرِ الْجِنْسِ
u'ذَكَرَ جُنُونٌ':Predicate, #8: 8	ذِكْرِ الْجِنْسِ
u'ذكر جَنِينٌ':Added, #1: 1	ذَكَرَ الْجُنُونَ
u'ذِكْرٌ جَنِينٌ':Added, #1: 1	ذِكْرَ الْجَنِينِ
u'ذَكَرَ جهاد':Predicate, #1: 1	ذِكْرَ الْجَنِينِ
u'ذَكَرَ جِهَادٌ':Predicate, #1: 1	ذَكَرَ الْجِهَادَ
u'ذكر جهاد':Added, #1: 1	ذَكَرَ الْجِهَادَ
u'ذِكْرٌ جهاد':Added, #1: 1	ذِكْرِ الْجِهَادِ
u'ذكر جِهَادٌ':Added, #1: 1	ذِكْرِ الْجِهَادِ
u'ذِكْرٌ جِهَادٌ':Added, #1: 1	ذِكْرِ الْجِهَادِ
u'ذَكَرَ جهاز':Predicate, #1: 1	ذِكْرِ الْجِهَادِ
u'ذَكَرَ جِهَازٌ':Predicate, #1: 1	ذَكَرَ جِهَازَ
u'ذَكَرَ جِهَةٌ':Predicate, #1: 1	ذَكَرَ جِهَازَ
u'ذكر جِهَةٌ':Added, #1: 1	ذَكَرَ جِهَةَ
u'ذِكْرٌ جِهَةٌ':Added, #1: 1	ذِكْرُ الْجِهَةِ
u'ذكر جِهَةٌ':Added, #1: 1	ذِكْرُ الْجِهَةِ
u'ذِكْرٌ جِهَةٌ':Added, #1: 1	ذِكْرِ جِهَةِ
u'ذكر جِهَةٌ':Added, #1: 1	ذِكْرِ جِهَةِ
u'ذِكْرٌ جِهَةٌ':Added, #2: 2	ذِكْرَ الْجِهَةِ
u'ذكر جِهَةٌ':Added, #2: 2	ذِكْرَ الْجِهَةِ
u'ذِكْرٌ جِهَةٌ':Added, #2: 2	ذِكْرِ جِهَةٍ
u'ذكر جِهَةٌ':Added, #2: 2	ذِكْرِ جِهَةٍ
u'ذِكْرٌ جِهَةٌ':Added, #7: 7	ذِكْرِ الْجِهَةِ
u'ذَكَرَ جهر':Predicate, #7: 7	ذِكْرِ الْجِهَةِ
u'ذَكَرَ جَهَنَّمُ':Predicate, #1: 1	ذَكَرَ جَهَرَ
u'ذَكَرَ جَهَنَّمِيّ':Predicate, #1: 1	ذَكَرَ جَهَنّمَ
u'ذَكَرَ جَوَابٌ':Predicate, #1: 1	ذَكَرَ الْجَهَنَّمِيِّينَ
u'ذَكَرَ جَوَابٌ':Predicate, #3: 3	ذَكَرَ الْجَوَابَ
u'ذكر جَوَابٌ':Added, #3: 3	ذَكَرَ جَوَابَ
u'ذِكْرٌ جَوَابٌ':Added, #1: 1	ذِكْرَ الْجَوَابِ
u'ذَكَرَ جَوَازٌ':Predicate, #1: 1	ذِكْرَ الْجَوَابِ
u'ذكر جَوَازٌ':Added, #5: 5	ذَكَرَ جَوَازَ
u'ذِكْرٌ جَوَازٌ':Added, #1: 1	ذِكْرُ الْجَوَازِ
u'ذكر جَوَازٌ':Added, #1: 1	ذِكْرُ الْجَوَازِ
u'ذِكْرٌ جَوَازٌ':Added, #1: 1	ذِكْرَ جَوَازِ
u'ذكر جَوْدَةٌ':Added, #1: 1	ذِكْرَ جَوَازِ
u'ذِكْرٌ جَوْدَةٌ':Added, #1: 1	ذِكْرَ الْجَوْدَةِ
u'ذكر جَوْدَةٌ':Added, #1: 1	ذِكْرَ الْجَوْدَةِ
u'ذِكْرٌ جَوْدَةٌ':Added, #2: 2	ذِكْرُ الْجَوْدَةِ
u'ذكر جَوْدَةٌ':Added, #2: 2	ذِكْرُ الْجَوْدَةِ
u'ذِكْرٌ جَوْدَةٌ':Added, #3: 3	ذِكْرِ الْجَوْدَةِ
u'ذَكَرَ جَوْرٌ':Predicate, #3: 3	ذِكْرِ الْجَوْدَةِ
u'ذَكَرَ جَيِّدٌ':Predicate, #1: 1	ذَكَرَ جَوْرَ
u'ذكر جِيدٌ':Added, #1: 1	ذَكَرَ الْجَيِّدَ
u'ذِكْرٌ جِيدٌ':Added, #2: 2	ذِكْرُ الْجِيدِ
u'ذكر جَيِّدٌ':Added, #2: 2	ذِكْرُ الْجِيدِ
u'ذِكْرٌ جَيِّدٌ':Added, #5: 5	ذِكْرِ الْجَيِّدِ
u'ذكر جِيرَانٌ':Added, #5: 5	ذِكْرِ الْجَيِّدِ
u'ذِكْرٌ جِيرَانٌ':Added, #1: 1	ذِكْرَ الْجِيرَانِ
u'ذكر جُيوشٌ':Added, #1: 1	ذِكْرَ الْجِيرَانِ
u'ذِكْرٌ جُيوشٌ':Added, #1: 1	ذِكْرِ جُيُوشِ
u'ذكر حارِثٌ':Added, #1: 1	ذِكْرِ جُيُوشِ
u'ذِكْرٌ حارِثٌ':Added, #1: 1	ذِكْرِ الْحَارِثِ
u'ذكر حاصِلٌ':Added, #1: 1	ذِكْرِ الْحَارِثِ
u'ذِكْرٌ حاصِلٌ':Added, #1: 1	ذِكْرِ حَاصِلِ
u'ذَكَرَ حاضِرٌ':Subject, #1: 1	ذِكْرِ حَاصِلِ
u'ذكر حاضِرٌ':Added, #1: 1	ذَكَرَ الْحَاضِرُ
u'ذِكْرٌ حاضِرٌ':Added, #1: 1	ذِكْرُ حَاضِرَةٍ
u'ذَكَرَ حافِظٌ':Subject, #1: 1	ذِكْرُ حَاضِرَةٍ
u'ذَكَرَ حاكِمٌ':Subject, #4: 4	ذَكَرَ الْحَافِظُ
u'ذكر حاكِمٌ':Added, #24: 24	ذَكَرَ الْحَاكِمُ
u'ذِكْرٌ حاكِمٌ':Added, #1: 1	ذِكْرِ الْحَاكِمِ
u'ذَكَرَ حالٌ':Predicate, #1: 1	ذِكْرِ الْحَاكِمِ
u'ذكر حالٌ':Added, #1: 1	ذَكَرَ حَالَ
u'ذِكْرٌ حالٌ':Added, #1: 1	ذِكْرُ حَالِ
u'ذكر حالٌ':Added, #1: 1	ذِكْرُ حَالِ
u'ذِكْرٌ حالٌ':Added, #1: 1	ذِكْرُ حَالِهِ
u'ذكر حالٌ':Added, #1: 1	ذِكْرُ حَالِهِ
u'ذِكْرٌ حالٌ':Added, #3: 3	ذِكْرِ الْحَالِ
u'ذكر حالَةٌ':Added, #3: 3	ذِكْرِ الْحَالِ
u'ذِكْرٌ حالَةٌ':Added, #1: 1	ذِكْرَ الْحَالَةِ
u'ذكر حالَةٌ':Added, #1: 1	ذِكْرَ الْحَالَةِ
u'ذِكْرٌ حالَةٌ':Added, #1: 1	ذِكْرَ حَالَةِ
u'ذكر حانوتٌ':Added, #1: 1	ذِكْرَ حَالَةِ
u'ذِكْرٌ حانوتٌ':Added, #1: 1	ذِكْرَ الْحَانُوتِ
u'ذَكَرَ حائِضٌ':Predicate, #1: 1	ذِكْرَ الْحَانُوتِ
u'ذكر حائِطٌ':Added, #1: 1	ذَكَرَ الْحَائِضَ
u'ذِكْرٌ حائِطٌ':Added, #1: 1	ذِكْرُ الْحَائِطِ
u'ذكر حَبٌّ':Added, #1: 1	ذِكْرُ الْحَائِطِ
u'ذِكْرٌ حَبٌّ':Added, #1: 1	ذِكْرُ الْحَبَّةِ
u'ذكر حَبَّةٌ':Added, #1: 1	ذِكْرُ الْحَبَّةِ
u'ذِكْرٌ حَبَّةٌ':Added, #1: 1	ذِكْرُ الْحَبَّةِ
u'ذكر حُبوبٌ':Added, #1: 1	ذِكْرُ الْحَبَّةِ
u'ذِكْرٌ حُبوبٌ':Added, #1: 1	ذِكْرُ الْحُبُوبِ
u'ذَكَرَ حَثّ':Predicate, #1: 1	ذِكْرُ الْحُبُوبِ
u'ذكر حَجٌّ':Added, #1: 1	ذَكَرَ الْحَثَّ
u'ذِكْرٌ حَجٌّ':Added, #1: 1	ذِكْرُ الْحَجِّ
u'ذكر حَجٌّ':Added, #1: 1	ذِكْرُ الْحَجِّ
u'ذِكْرٌ حَجٌّ':Added, #2: 2	ذِكْرِ الْحَجِّ
u'ذَكَرَ حجاب':Predicate, #2: 2	ذِكْرِ الْحَجِّ
u'ذَكَرَ حِجابٌ':Predicate, #1: 1	ذَكَرَ الْحِجَابَ
u'ذكر حِجَامَةٌ':Added, #1: 1	ذَكَرَ الْحِجَابَ
u'ذِكْرٌ حِجَامَةٌ':Added, #1: 1	ذِكْرِ الْحِجَامَةِ
u'ذكر حِجْرٌ':Added, #1: 1	ذِكْرِ الْحِجَامَةِ
u'ذِكْرٌ حِجْرٌ':Added, #2: 2	ذِكْرَ الْحِجْرِ
u'ذكر حَجْمٌ':Added, #2: 2	ذِكْرَ الْحِجْرِ
u'ذِكْرٌ حَجْمٌ':Added, #1: 1	ذِكْرِ حَجْمٍ
u'ذكر حَجْمٌ':Added, #1: 1	ذِكْرِ حَجْمٍ
u'ذِكْرٌ حَجْمٌ':Added, #2: 2	ذِكْرِ الْحَجْمِ
u'ذَكَرَ حَدٌّ':Predicate, #2: 2	ذِكْرِ الْحَجْمِ
u'ذَكَرَ حَدٌّ':Predicate, #1: 1	ذَكَرَ الْحَدَّ
u'ذكر حَدٌّ':Added, #1: 1	ذَكَرَ حَدَّ
u'ذِكْرٌ حَدٌّ':Added, #1: 1	ذِكْرُ الْحَدِّ
u'ذكر حَدٌّ':Added, #1: 1	ذِكْرُ الْحَدِّ
u'ذكر حَدٌّ':Added, #1: 1	ذِكْرَ حَدٍّ
u'ذِكْرٌ حَدٌّ':Added, #1: 1	ذِكْرِ حَدِّ
u'ذِكْرٌ حَدٌّ':Added, #1: 1	ذِكْرَ حَدٍّ
u'ذكر حَدٌّ':Added, #1: 1	ذِكْرِ حَدِّ
u'ذِكْرٌ حَدٌّ':Added, #4: 4	ذِكْرِ الْحَدِّ
u'ذَكَرَ حَدَثٌ':Predicate, #4: 4	ذِكْرِ الْحَدِّ
u'ذكر حَدَثٌ':Added, #1: 1	ذَكَرَ الْحَدَثَ
u'ذِكْرٌ حَدَثٌ':Added, #2: 2	ذِكْرِ الْحَدَثِ
u'ذَكَرَ حُدودٌ':Predicate, #2: 2	ذِكْرِ الْحَدَثِ
u'ذكر حُدودٌ':Added, #4: 4	ذَكَرَ الْحُدُودَ
u'ذكر حُدودٌ':Added, #1: 1	ذِكْرَ حُدُودٍ
u'ذِكْرٌ حُدودٌ':Added, #1: 1	ذِكْرُ حُدُودِ
u'ذِكْرٌ حُدودٌ':Added, #1: 1	ذِكْرَ حُدُودٍ
u'ذكر حُدودٌ':Added, #1: 1	ذِكْرُ حُدُودِ
u'ذِكْرٌ حُدودٌ':Added, #20: 20	ذِكْرِ الْحُدُودِ
u'ذكر حُدودٌ':Added, #20: 20	ذِكْرِ الْحُدُودِ
u'ذكر حُدودٌ':Added, #2: 2	ذِكْرَ الْحُدُودِ
u'ذِكْرٌ حُدودٌ':Added, #2: 2	ذِكْرُ الْحُدُودِ
u'ذِكْرٌ حُدودٌ':Added, #2: 2	ذِكْرَ الْحُدُودِ
u'ذكر حُدودٌ':Added, #2: 2	ذِكْرُ الْحُدُودِ
u'ذِكْرٌ حُدودٌ':Added, #2: 2	ذِكْرِ حُدُودِ
u'ذكر حُدودٌ':Added, #2: 2	ذِكْرِ حُدُودِ
u'ذِكْرٌ حُدودٌ':Added, #2: 2	ذِكْرِ حُدُودِهِ
u'ذَكَرَ حَديثٌ':Predicate, #2: 2	ذِكْرِ حُدُودِهِ
u'ذَكَرَ حَديثٌ':Predicate, #24: 24	ذَكَرَ حَدِيثَ
u'ذكر حَديثٌ':Added, #43: 43	ذَكَرَ الْحَدِيثَ
u'ذِكْرٌ حَديثٌ':Added, #1: 1	ذِكْرَ الْحَدِيثِ
u'ذكر حَديثٌ':Added, #1: 1	ذِكْرَ الْحَدِيثِ
u'ذِكْرٌ حَديثٌ':Added, #1: 1	ذِكْرُ حَدِيثِ
u'ذكر حَديثٌ':Added, #1: 1	ذِكْرُ حَدِيثِ
u'ذِكْرٌ حَديثٌ':Added, #2: 2	ذِكْرِ حَدِيثِ
u'ذكر حَديثٌ':Added, #2: 2	ذِكْرِ حَدِيثِ
u'ذِكْرٌ حَديثٌ':Added, #4: 4	ذِكْرِ الْحَدِيثِ
u'ذَكَرَ حَرائِرُ':Predicate, #4: 4	ذِكْرِ الْحَدِيثِ
u'ذَكَرَ حَرَائِرُ':Predicate, #1: 1	ذَكَرَ الْحَرَائِرَ
u'ذَكَرَ حَرْفٌ':Predicate, #1: 1	ذَكَرَ الْحَرَائِرَ
u'ذكر حَرْفٌ':Added, #3: 3	ذَكَرَ حَرْفَ
u'ذِكْرٌ حَرْفٌ':Added, #1: 1	ذِكْرُ حَرْفٍ
u'ذكر حَرْفٌ':Added, #1: 1	ذِكْرُ حَرْفٍ
u'ذِكْرٌ حَرْفٌ':Added, #2: 2	ذِكْرِ حَرْفِ
u'ذكر حِرْفَةٌ':Added, #2: 2	ذِكْرِ حَرْفِ
u'ذِكْرٌ حِرْفَةٌ':Added, #1: 1	ذِكْرِ حِرْفَتِهِ
u'ذكر حَرَمٌ':Added, #1: 1	ذِكْرِ حِرْفَتِهِ
u'ذِكْرٌ حَرَمٌ':Added, #1: 1	ذِكْرُ حَرَمِ
u'ذَكَرَ حُرْمَةٌ':Predicate, #1: 1	ذِكْرُ حَرَمِ
u'ذَكَرَ حُرْمَةٌ':Predicate, #1: 1	ذَكَرَ الْحُرْمَةَ
u'ذكر حُرِّيَّةٌ':Added, #1: 1	ذَكَرَ حُرْمَةَ
u'ذِكْرٌ حُرِّيَّةٌ':Added, #1: 1	ذِكْرُ الْحُرِّيَّةِ
u'ذكر حُرِّيَّةٌ':Added, #1: 1	ذِكْرُ الْحُرِّيَّةِ
u'ذِكْرٌ حُرِّيَّةٌ':Added, #1: 1	ذِكْرِ حُرِّيَّةِ
u'ذَكَرَ حَرِيرِيٌّ':Subject, #1: 1	ذِكْرِ حُرِّيَّةِ
u'ذكر حساب':Added, #1: 1	ذَكَرَ الْحَرِيرِيُّ
u'ذِكْرٌ حساب':Added, #1: 1	ذِكْرِ الْحِسَابِ
u'ذكر حِسَابٌ':Added, #1: 1	ذِكْرِ الْحِسَابِ
u'ذِكْرٌ حِسَابٌ':Added, #1: 1	ذِكْرِ الْحِسَابِ
u'ذَكَرَ حسام':Subject, #1: 1	ذِكْرِ الْحِسَابِ
u'ذَكَرَ حُسَامٌ':Subject, #1: 1	ذَكَرَ حُسَامُ
u'ذَكَرَ حَسَنٌ':Subject, #1: 1	ذَكَرَ حُسَامُ
u'ذكر حَسَنٌ':Added, #7: 7	ذَكَرَ الْحَسَنُ
u'ذكر حَسَنٌ':Added, #1: 1	ذِكْرُ الْحَسَنِ
u'ذِكْرٌ حَسَنٌ':Added, #1: 1	ذِكْرِ الْحَسَنِ
u'ذِكْرٌ حَسَنٌ':Added, #1: 1	ذِكْرُ الْحَسَنِ
u'ذكر حُسْنٌ':Added, #1: 1	ذِكْرِ الْحَسَنِ
u'ذِكْرٌ حُسْنٌ':Added, #1: 1	ذِكْرِ حُسْنِ
u'ذكر حَشْرٌ':Added, #1: 1	ذِكْرِ حُسْنِ
u'ذِكْرٌ حَشْرٌ':Added, #2: 2	ذِكْرِ الْحَشْرِ
u'ذَكَرَ حَصَادٌ':Predicate, #2: 2	ذِكْرِ الْحَشْرِ
u'ذكر حَصْرٌ':Added, #1: 1	ذَكَرَ الْحَصَادَ
u'ذكر حَصْرٌ':Added, #1: 1	ذِكْرَ الْحَصْرِ
u'ذِكْرٌ حَصْرٌ':Added, #1: 1	ذِكْرِ الْحَصْرِ
u'ذِكْرٌ حَصْرٌ':Added, #1: 1	ذِكْرَ الْحَصْرِ
u'ذَكَرَ حَفْرٌ':Predicate, #1: 1	ذِكْرِ الْحَصْرِ
u'ذَكَرَ حَفَظَةٌ':Predicate, #1: 1	ذَكَرَ حَفْرَ
u'ذَكَرَ حَفَظَةٌ':Subject, #1: 1	ذَكَرَ الْحَفَظَةَ
u'ذكر حَفَظَةٌ':Added, #1: 1	ذَكَرَ حَفَظَةُ
u'ذِكْرٌ حَفَظَةٌ':Added, #1: 1	ذِكْرِ الْحَفَظَةِ
u'ذَكَرَ حَقٌّ':Predicate, #1: 1	ذِكْرِ الْحَفَظَةِ
u'ذكر حَقٌّ':Added, #1: 1	ذَكَرَ الْحَقَّ
u'ذِكْرٌ حَقٌّ':Added, #1: 1	ذِكْرِ حَقٍّ
u'ذكر حَقٌّ':Added, #1: 1	ذِكْرِ حَقٍّ
u'ذِكْرٌ حَقٌّ':Added, #2: 2	ذِكْرِ الْحَقِّ
u'ذكر حَقٌّ':Added, #2: 2	ذِكْرِ الْحَقِّ
u'ذِكْرٌ حَقٌّ':Added, #4: 4	ذِكْرَ حَقٍّ
u'ذكر حَقٌّ':Added, #4: 4	ذِكْرَ حَقٍّ
u'ذِكْرٌ حَقٌّ':Added, #6: 6	ذِكْرَ الْحَقِّ
u'ذكر حَقٌّ':Added, #6: 6	ذِكْرَ الْحَقِّ
u'ذِكْرٌ حَقٌّ':Added, #6: 6	ذِكْرُ حَقٍّ
u'ذَكَرَ حُقوقٌ':Predicate, #6: 6	ذِكْرُ حَقٍّ
u'ذَكَرَ حُقُوقٌ':Predicate, #14: 14	ذَكَرَ الْحُقُوقَ
u'ذَكَرَ حُقوقٌ':Predicate, #14: 14	ذَكَرَ الْحُقُوقَ
u'ذَكَرَ حُقُوقٌ':Predicate, #1: 1	ذَكَرَ حُقُوقَ
u'ذكر حُقوقٌ':Added, #1: 1	ذَكَرَ حُقُوقَ
u'ذكر حُقُوقٌ':Added, #13: 13	ذِكْرِ الْحُقُوقِ
u'ذِكْرٌ حُقوقٌ':Added, #13: 13	ذِكْرِ الْحُقُوقِ
u'ذِكْرٌ حُقُوقٌ':Added, #13: 13	ذِكْرِ الْحُقُوقِ
u'ذكر حُقوقٌ':Added, #13: 13	ذِكْرِ الْحُقُوقِ
u'ذكر حُقُوقٌ':Added, #1: 1	ذِكْرَ الْحُقُوقِ
u'ذِكْرٌ حُقوقٌ':Added, #1: 1	ذِكْرَ الْحُقُوقِ
u'ذِكْرٌ حُقُوقٌ':Added, #1: 1	ذِكْرَ الْحُقُوقِ
u'ذكر حُقوقٌ':Added, #1: 1	ذِكْرَ الْحُقُوقِ
u'ذكر حُقُوقٌ':Added, #3: 3	ذِكْرُ الْحُقُوقِ
u'ذِكْرٌ حُقوقٌ':Added, #3: 3	ذِكْرُ الْحُقُوقِ
u'ذِكْرٌ حُقُوقٌ':Added, #3: 3	ذِكْرُ الْحُقُوقِ
u'ذكر حَقِيقَةٌ':Added, #3: 3	ذِكْرُ الْحُقُوقِ
u'ذِكْرٌ حَقِيقَةٌ':Added, #1: 1	ذِكْرُ حَقِيقَةٍ
u'ذَكَرَ حِكَايَةٌ':Predicate, #1: 1	ذِكْرُ حَقِيقَةٍ
u'ذَكَرَ حُكْمٌ':Predicate, #2: 2	ذَكَرَ حِكَايَةَ
u'ذَكَرَ حُكْمٌ':Predicate, #23: 23	ذَكَرَ حُكْمَ
u'ذَكَرَ حُكْمٌ':Subject, #8: 8	ذَكَرَ الْحُكْمَ
u'ذكر حُكْمٌ':Added, #1: 1	ذَكَرَ حُكْمُ
u'ذِكْرٌ حُكْمٌ':Added, #12: 12	ذِكْرِ حُكْمِ
u'ذكر حَكَمٌ':Added, #12: 12	ذِكْرِ حُكْمِ
u'ذكر حَكَمٌ':Added, #1: 1	ذِكْرَ الْحَكَمَيْنِ
u'ذكر حَكَمٌ':Added, #1: 1	ذِكْرُ الْحَكَمَيْنِ
u'ذكر حُكْمٌ':Added, #1: 1	ذِكْرِ الْحَكَمَيْنِ
u'ذِكْرٌ حَكَمٌ':Added, #1: 1	ذِكْرُ الْحُكْمَيْنِ
u'ذِكْرٌ حَكَمٌ':Added, #1: 1	ذِكْرَ الْحَكَمَيْنِ
u'ذِكْرٌ حَكَمٌ':Added, #1: 1	ذِكْرُ الْحَكَمَيْنِ
u'ذِكْرٌ حُكْمٌ':Added, #1: 1	ذِكْرِ الْحَكَمَيْنِ
u'ذكر حُكْمٌ':Added, #1: 1	ذِكْرُ الْحُكْمَيْنِ
u'ذِكْرٌ حُكْمٌ':Added, #1: 1	ذِكْرِ حُكْمٍ
u'ذكر حُكْمٌ':Added, #1: 1	ذِكْرِ حُكْمٍ
u'ذِكْرٌ حُكْمٌ':Added, #1: 1	ذِكْرَ حُكْمِهِ
u'ذكر حُكْمٌ':Added, #1: 1	ذِكْرَ حُكْمِهِ
u'ذكر حُكْمٌ':Added, #2: 2	ذِكْرَ الْحُكْمِ
u'ذِكْرٌ حُكْمٌ':Added, #2: 2	ذِكْرُ الْحُكْمِ
u'ذِكْرٌ حُكْمٌ':Added, #2: 2	ذِكْرَ الْحُكْمِ
u'ذكر حُكْمٌ':Added, #2: 2	ذِكْرُ الْحُكْمِ
u'ذِكْرٌ حُكْمٌ':Added, #2: 2	ذِكْرُ حُكْمِ
u'ذكر حُكْمٌ':Added, #2: 2	ذِكْرُ حُكْمِ
u'ذِكْرٌ حُكْمٌ':Added, #9: 9	ذِكْرِ الْحُكْمِ
u'ذَكَرَ حكماء':Subject, #9: 9	ذِكْرِ الْحُكْمِ
u'ذَكَرَ حَكِيمٌ':Subject, #1: 1	ذَكَرَ الْحُكَمَاءُ
u'ذَكَرَ حَلْقٌ':Predicate, #1: 1	ذَكَرَ الْحَكِيمُ
u'ذَكَرَ حَلْقٌ':Predicate, #1: 1	ذَكَرَ حَلْقَ
u'ذكر حَلْقٌ':Added, #2: 2	ذَكَرَ الْحَلْقَ
u'ذِكْرٌ حَلْقٌ':Added, #2: 2	ذِكْرِ الْحَلْقِ
u'ذَكَرَ حَلْوانِيٌّ':Subject, #2: 2	ذِكْرِ الْحَلْقِ
u'ذَكَرَ حَمْدٌ':Predicate, #6: 6	ذَكَرَ الْحَلْوَانِيُّ
u'ذكر حُمْرَةٌ':Added, #1: 1	ذَكَرَ الْحَمْدَ
u'ذِكْرٌ حُمْرَةٌ':Added, #1: 1	ذِكْرُ الْحُمْرَةِ
u'ذكر حَمْلٌ':Added, #1: 1	ذِكْرُ الْحُمْرَةِ
u'ذِكْرٌ حَمْلٌ':Added, #1: 1	ذِكْرَ الْحَمْلِ
u'ذكر حَمْلٌ':Added, #1: 1	ذِكْرَ الْحَمْلِ
u'ذِكْرٌ حَمْلٌ':Added, #1: 1	ذِكْرُ حَمْلِ
u'ذكر حُمَمٌ':Added, #1: 1	ذِكْرُ حَمْلِ
u'ذِكْرٌ حُمَمٌ':Added, #1: 1	ذِكْرُ الْحُمَمَةِ
u'ذكر حِمْيَةٌ':Added, #1: 1	ذِكْرُ الْحُمَمَةِ
u'ذِكْرٌ حِمْيَةٌ':Added, #1: 1	ذِكْرِ الْحِمْيَةِ
u'ذكر حِمْيَةٌ':Added, #1: 1	ذِكْرِ الْحِمْيَةِ
u'ذِكْرٌ حِمْيَةٌ':Added, #2: 2	ذِكْرُ الْحِمْيَةِ
u'ذَكَرَ حِنْثٌ':Predicate, #2: 2	ذِكْرُ الْحِمْيَةِ
u'ذَكَرَ حَنَفِيَّةٌ':Subject, #1: 1	ذَكَرَ الْحِنْثَ
u'ذكر حُوتٌ':Added, #3: 3	ذَكَرَ الْحَنَفِيَّةُ
u'ذِكْرٌ حُوتٌ':Added, #1: 1	ذِكْرُ الْحُوتِ
u'ذَكَرَ حَوْضٌ':Predicate, #1: 1	ذِكْرُ الْحُوتِ
u'ذكر حَوْضٌ':Added, #2: 2	ذَكَرَ الْحَوْضَ
u'ذِكْرٌ حَوْضٌ':Added, #1: 1	ذِكْرُ الْحَوْضِ
u'ذكر حَوْضٌ':Added, #1: 1	ذِكْرُ الْحَوْضِ
u'ذِكْرٌ حَوْضٌ':Added, #2: 2	ذِكْرِ الْحَوْضِ
u'ذكر حَوْلٌ':Added, #2: 2	ذِكْرِ الْحَوْضِ
u'ذِكْرٌ حَوْلٌ':Added, #1: 1	ذِكْرِ الْحَوْلَيْنِ
u'ذَكَرَ حَيٌّ':Predicate, #1: 1	ذِكْرِ الْحَوْلَيْنِ
u'ذكر حَيٌّ':Added, #2: 2	ذَكَرَ الْحَيَّ
u'ذِكْرٌ حَيٌّ':Added, #1: 1	ذِكْرُ الْحَيِّ
u'ذكر حَيٌّ':Added, #1: 1	ذِكْرُ الْحَيِّ
u'ذِكْرٌ حَيٌّ':Added, #1: 1	ذِكْرُ الْحَيَّةِ
u'ذكر حَيَاةٌ':Added, #1: 1	ذِكْرُ الْحَيَّةِ
u'ذكر حَيَاةٌ':Added, #1: 1	ذِكْرُ الْحَيَاةِ
u'ذِكْرٌ حَيَاةٌ':Added, #1: 1	ذِكْرِ الْحَيَاةِ
u'ذِكْرٌ حَيَاةٌ':Added, #1: 1	ذِكْرُ الْحَيَاةِ
u'ذكر حِيازَة':Added, #1: 1	ذِكْرِ الْحَيَاةِ
u'ذِكْرٌ حِيازَة':Added, #1: 1	ذِكْرُ حِيَازَةِ
u'ذكر حَيَّةٌ':Added, #1: 1	ذِكْرُ حِيَازَةِ
u'ذِكْرٌ حَيَّةٌ':Added, #1: 1	ذِكْرُ الْحَيَّةِ
u'ذكر حَيْثِيَّةٌ':Added, #1: 1	ذِكْرُ الْحَيَّةِ
u'ذِكْرٌ حَيْثِيَّةٌ':Added, #1: 1	ذِكْرِ الْحَيْثِيَّةِ
u'ذكر حَيْضٌ':Added, #1: 1	ذِكْرِ الْحَيْثِيَّةِ
u'ذِكْرٌ حَيْضٌ':Added, #1: 1	ذِكْرَ الْحَيْضِ
u'ذَكَرَ حَيْضَةٌ':Predicate, #1: 1	ذِكْرَ الْحَيْضِ
u'ذكر حِيَلٌ':Added, #2: 2	ذَكَرَ الْحَيْضَةَ
u'ذِكْرٌ حِيَلٌ':Added, #1: 1	ذِكْرِ الْحِيَلِ
u'ذَكَرَ حِيلَةٌ':Predicate, #1: 1	ذِكْرِ الْحِيَلِ
u'ذَكَرَ خاصّ':Predicate, #1: 1	ذَكَرَ الْحِيلَةَ
u'ذكر خاصّ':Added, #1: 1	ذَكَرَ الْخَاصَّ
u'ذِكْرٌ خاصّ':Added, #1: 1	ذِكْرَ الْخَاصِّ
u'ذكر خاصّ':Added, #1: 1	ذِكْرَ الْخَاصِّ
u'ذِكْرٌ خاصّ':Added, #8: 8	ذِكْرِ الْخَاصِّ
u'ذكر خَاطِئٌ':Added, #8: 8	ذِكْرِ الْخَاصِّ
u'ذِكْرٌ خَاطِئٌ':Added, #1: 1	ذِكْرُ الْخَاطِئِ
u'ذكر خَائِنٌ':Added, #1: 1	ذِكْرُ الْخَاطِئِ
u'ذِكْرٌ خَائِنٌ':Added, #1: 1	ذِكْرُ الْخَائِنِ
u'ذَكَرَ خَبَرٌ':Predicate, #1: 1	ذِكْرُ الْخَائِنِ
u'ذَكَرَ خَبَر':Predicate, #3: 3	ذَكَرَ الْخَبَرَ
u'ذَكَرَ خَبَرٌ':Predicate, #3: 3	ذَكَرَ الْخَبَرَ
u'ذَكَرَ خَبَر':Predicate, #7: 7	ذَكَرَ خَبَرَ
u'ذكر خَبَرٌ':Added, #7: 7	ذَكَرَ خَبَرَ
u'ذكر خَبَر':Added, #12: 12	ذِكْرِ الْخَبَرِ
u'ذِكْرٌ خَبَرٌ':Added, #12: 12	ذِكْرِ الْخَبَرِ
u'ذِكْرٌ خَبَر':Added, #12: 12	ذِكْرِ الْخَبَرِ
u'ذكر خَبَرٌ':Added, #12: 12	ذِكْرِ الْخَبَرِ
u'ذكر خَبَر':Added, #1: 1	ذِكْرُ الْخَبَرِ
u'ذِكْرٌ خَبَرٌ':Added, #1: 1	ذِكْرُ الْخَبَرِ
u'ذِكْرٌ خَبَر':Added, #1: 1	ذِكْرُ الْخَبَرِ
u'ذكر خَبَرٌ':Added, #1: 1	ذِكْرُ الْخَبَرِ
u'ذكر خَبَر':Added, #2: 2	ذِكْرَ الْخَبَرِ
u'ذِكْرٌ خَبَرٌ':Added, #2: 2	ذِكْرَ الْخَبَرِ
u'ذِكْرٌ خَبَر':Added, #2: 2	ذِكْرَ الْخَبَرِ
u'ذكر خُبْزٌ':Added, #2: 2	ذِكْرَ الْخَبَرِ
u'ذِكْرٌ خُبْزٌ':Added, #1: 1	ذِكْرِ الْخُبْزِ
u'ذكر خُبْزٌ':Added, #1: 1	ذِكْرِ الْخُبْزِ
u'ذِكْرٌ خُبْزٌ':Added, #2: 2	ذِكْرُ الْخُبْزِ
u'ذكر خدمة':Added, #2: 2	ذِكْرُ الْخُبْزِ
u'ذِكْرٌ خدمة':Added, #1: 1	ذِكْرَ الْخِدْمَةِ
u'ذكر خِدْمَةٌ':Added, #1: 1	ذِكْرَ الْخِدْمَةِ
u'ذِكْرٌ خِدْمَةٌ':Added, #1: 1	ذِكْرَ الْخِدْمَةِ
u'ذَكَرَ خَدِيج':Predicate, #1: 1	ذِكْرَ الْخِدْمَةِ
u'ذَكَرَ خَدِيج':Predicate, #1: 1	ذَكَرَ خَدِيجَ
u'ذكر خراج':Added, #2: 2	ذَكَرَ خَدِيجَةَ
u'ذِكْرٌ خراج':Added, #1: 1	ذِكْرِ خَرَاجِ
u'ذكر خَرَاجٌ':Added, #1: 1	ذِكْرِ خَرَاجِ
u'ذِكْرٌ خَرَاجٌ':Added, #1: 1	ذِكْرِ خَرَاجِ
u'ذَكَرَ خُرُوجٌ':Predicate, #1: 1	ذِكْرِ خَرَاجِ
u'ذكر خُرُوجٌ':Added, #1: 1	ذَكَرَ خُرُوجَ
u'ذِكْرٌ خُرُوجٌ':Added, #1: 1	ذِكْرِ الْخُرُوجِ
u'ذكر خُرُوجٌ':Added, #1: 1	ذِكْرِ الْخُرُوجِ
u'ذِكْرٌ خُرُوجٌ':Added, #1: 1	ذِكْرُ خُرُوجِهِ
u'ذكر خُرُوجٌ':Added, #1: 1	ذِكْرُ خُرُوجِهِ
u'ذِكْرٌ خُرُوجٌ':Added, #4: 4	ذِكْرُ الْخُرُوجِ
u'ذكر خُشُوعٌ':Added, #4: 4	ذِكْرُ الْخُرُوجِ
u'ذِكْرٌ خُشُوعٌ':Added, #1: 1	ذِكْرُ الْخُشُوعِ
u'ذكر خِصاء':Added, #1: 1	ذِكْرُ الْخُشُوعِ
u'ذِكْرٌ خِصاء':Added, #1: 1	ذِكْرِ الْخِصَاءِ
u'ذَكَرَ خَصْمٌ':Subject, #1: 1	ذِكْرِ الْخِصَاءِ
u'ذكر خُصُوصِيٌّ':Added, #1: 1	ذَكَرَ الْخَصْمُ
u'ذِكْرٌ خُصُوصِيٌّ':Added, #1: 1	ذِكْرُ الْخُصُوصِيَّةِ
u'ذكر خِضَابٌ':Added, #1: 1	ذِكْرُ الْخُصُوصِيَّةِ
u'ذِكْرٌ خِضَابٌ':Added, #1: 1	ذِكْرِ الْخِضَابِ
u'ذَكَرَ خَطَأٌ':Predicate, #1: 1	ذِكْرِ الْخِضَابِ
u'ذكر خطبة':Added, #1: 1	ذَكَرَ الْخَطَأَ
u'ذِكْرٌ خطبة':Added, #2: 2	ذِكْرِ الْخُطْبَةِ
u'ذكر خُطْبَةٌ':Added, #2: 2	ذِكْرِ الْخُطْبَةِ
u'ذِكْرٌ خُطْبَةٌ':Added, #2: 2	ذِكْرِ الْخُطْبَةِ
u'ذَكَرَ خَطِيبٌ':Subject, #2: 2	ذِكْرِ الْخُطْبَةِ
u'ذكر خُفٌّ':Added, #5: 5	ذَكَرَ الْخَطِيبُ
u'ذِكْرٌ خُفٌّ':Added, #1: 1	ذِكْرَ الْخُفِّ
u'ذكر خُلاصَة':Added, #1: 1	ذِكْرَ الْخُفِّ
u'ذِكْرٌ خُلاصَة':Added, #1: 1	ذِكْرِ خُلَاصَةِ
u'ذَكَرَ خِلاَفٌ':Predicate, #1: 1	ذِكْرِ خُلَاصَةِ
u'ذَكَرَ خِلاَفٌ':Predicate, #3: 3	ذَكَرَ خِلَافَ
u'ذكر خِلاَفٌ':Added, #41: 41	ذَكَرَ الْخِلَافَ
u'ذِكْرٌ خِلاَفٌ':Added, #13: 13	ذِكْرِ الْخِلَافِ
u'ذكر خِلاَفٌ':Added, #13: 13	ذِكْرِ الْخِلَافِ
u'ذِكْرٌ خِلاَفٌ':Added, #1: 1	ذِكْرَ الْخِلَافِ
u'ذكر خِلاَفٌ':Added, #1: 1	ذِكْرَ الْخِلَافِ
u'ذِكْرٌ خِلاَفٌ':Added, #33: 33	ذِكْرِ خِلَافٍ
u'ذكر خِلاَفٌ':Added, #33: 33	ذِكْرِ خِلَافٍ
u'ذِكْرٌ خِلاَفٌ':Added, #4: 4	ذِكْرِ خِلَافِ
u'ذكر خِلاَفٌ':Added, #4: 4	ذِكْرِ خِلَافِ
u'ذِكْرٌ خِلاَفٌ':Added, #6: 6	ذِكْرُ الْخِلَافِ
u'ذكر خِلاَفِيٌّ':Added, #6: 6	ذِكْرُ الْخِلَافِ
u'ذِكْرٌ خِلاَفِيٌّ':Added, #1: 1	ذِكْرِ الْخِلَافِيَّاتِ
u'ذكر خلط':Added, #1: 1	ذِكْرِ الْخِلَافِيَّاتِ
u'ذِكْرٌ خلط':Added, #1: 1	ذِكْرِ الْخَلْطِ
u'ذكر خُلْعٌ':Added, #1: 1	ذِكْرِ الْخَلْطِ
u'ذكر خُلْعٌ':Added, #1: 1	ذِكْرَ الْخُلْعِ
u'ذِكْرٌ خُلْعٌ':Added, #1: 1	ذِكْرِ الْخُلْعِ
u'ذِكْرٌ خُلْعٌ':Added, #1: 1	ذِكْرَ الْخُلْعِ
u'ذَكَرَ خَلْفٌ':Predicate, #1: 1	ذِكْرِ الْخُلْعِ
u'ذَكَرَ خَلَفٌ':Subject, #1: 1	ذَكَرَ خَلْفَ
u'ذكر خِلْف':Added, #1: 1	ذَكَرَ خَلَفُ
u'ذِكْرٌ خِلْف':Added, #1: 1	ذِكْرِ الْخِلْفَاتِ
u'ذكر خُلَفَاءُ':Added, #1: 1	ذِكْرِ الْخِلْفَاتِ
u'ذكر خُلَفَاءُ':Added, #1: 1	ذِكْرَ الْخُلَفَاءِ
u'ذِكْرٌ خُلَفَاءُ':Added, #1: 1	ذِكْرِ الْخُلَفَاءِ
u'ذِكْرٌ خُلَفَاءُ':Added, #1: 1	ذِكْرَ الْخُلَفَاءِ
u'ذكر خِلْفَة':Added, #1: 1	ذِكْرِ الْخُلَفَاءِ
u'ذِكْرٌ خِلْفَة':Added, #1: 1	ذِكْرِ الْخِلْفَاتِ
u'ذكر خَمْرٌ':Added, #1: 1	ذِكْرِ الْخِلْفَاتِ
u'ذِكْرٌ خَمْرٌ':Added, #1: 1	ذِكْرُ الْخَمْرِ
u'ذكر خَمْرٌ':Added, #1: 1	ذِكْرُ الْخَمْرِ
u'ذِكْرٌ خَمْرٌ':Added, #5: 5	ذِكْرِ الْخَمْرِ
u'ذَكَرَ خَمْسٌ':Predicate, #5: 5	ذِكْرِ الْخَمْرِ
u'ذَكَرَ خَمْسَةٌ':Predicate, #2: 2	ذَكَرَ خَمْسَ
u'ذكر خِنْزِيرٌ':Added, #1: 1	ذَكَرَ خَمْسَةَ
u'ذِكْرٌ خِنْزِيرٌ':Added, #1: 1	ذِكْرَ الْخِنْزِيرِ
u'ذَكَرَ خوارج':Predicate, #1: 1	ذِكْرَ الْخِنْزِيرِ
u'ذَكَرَ خَوَارِجُ':Predicate, #1: 1	ذَكَرَ الْخَوَارِجَ
u'ذكر خوارج':Added, #1: 1	ذَكَرَ الْخَوَارِجَ
u'ذِكْرٌ خوارج':Added, #1: 1	ذِكْرِ الْخَوَارِجِ
u'ذكر خَوَارِجُ':Added, #1: 1	ذِكْرِ الْخَوَارِجِ
u'ذِكْرٌ خَوَارِجُ':Added, #1: 1	ذِكْرِ الْخَوَارِجِ
u'ذكر خوارج':Added, #1: 1	ذِكْرِ الْخَوَارِجِ
u'ذِكْرٌ خوارج':Added, #3: 3	ذِكْرُ الْخَوَارِجِ
u'ذكر خَوَارِجُ':Added, #3: 3	ذِكْرُ الْخَوَارِجِ
u'ذِكْرٌ خَوَارِجُ':Added, #3: 3	ذِكْرُ الْخَوَارِجِ
u'ذكر خَوْفٌ':Added, #3: 3	ذِكْرُ الْخَوَارِجِ
u'ذِكْرٌ خَوْفٌ':Added, #2: 2	ذِكْرِ الْخَوْفِ
u'ذَكَرَ خيار':Predicate, #2: 2	ذِكْرِ الْخَوْفِ
u'ذَكَرَ خِيَارٌ':Predicate, #1: 1	ذَكَرَ خِيَارَ
u'ذَكَرَ خيار':Predicate, #1: 1	ذَكَرَ خِيَارَ
u'ذَكَرَ خِيَارٌ':Predicate, #2: 2	ذَكَرَ الْخِيَارَ
u'ذكر خيار':Added, #2: 2	ذَكَرَ الْخِيَارَ
u'ذكر خِيَارٌ':Added, #2: 2	ذِكْرِ خِيَارِ
u'ذِكْرٌ خيار':Added, #2: 2	ذِكْرِ خِيَارِ
u'ذِكْرٌ خِيَارٌ':Added, #2: 2	ذِكْرِ خِيَارِ
u'ذَكَرَ خِيَاطَةٌ':Predicate, #2: 2	ذِكْرِ خِيَارِ
u'ذَكَرَ خَيْلٌ':Predicate, #1: 1	ذَكَرَ الْخِيَاطَةَ
u'ذَكَرَ دَابَّةٌ':Predicate, #1: 1	ذَكَرَ الْخَيْلَ
u'ذكر دَابَّةٌ':Added, #1: 1	ذَكَرَ الدَّابَّةَ
u'ذِكْرٌ دَابَّةٌ':Added, #1: 1	ذِكْرُ الدّابّةِ
u'ذَكَرَ دَارٌ':Predicate, #1: 1	ذِكْرُ الدّابّةِ
u'ذَكَرَ دَارٌ':Predicate, #1: 1	ذَكَرَ الدَّارَ
u'ذكر دَارٌ':Added, #1: 1	ذَكَرَ دَارَ
u'ذِكْرٌ دَارٌ':Added, #1: 1	ذِكْرِ الدَّارِ
u'ذكر دَارٌ':Added, #1: 1	ذِكْرِ الدَّارِ
u'ذِكْرٌ دَارٌ':Added, #1: 1	ذِكْرَ دَارٍ
u'ذَكَرَ دَافِعٌ':Subject, #1: 1	ذِكْرَ دَارٍ
u'ذَكَرَ دُبٌّ':Predicate, #1: 1	ذَكَرَ الدَّافِعُ
u'ذكر دِبَاغٌ':Added, #1: 1	ذَكَرَ الدّبّةَ
u'ذِكْرٌ دِبَاغٌ':Added, #2: 2	ذِكْرِ الدِّبَاغِ
u'ذكر دِبَاغَةٌ':Added, #2: 2	ذِكْرِ الدِّبَاغِ
u'ذِكْرٌ دِبَاغَةٌ':Added, #1: 1	ذِكْرِ الدِّبَاغَةِ
u'ذَكَرَ دَجاج':Predicate, #1: 1	ذِكْرِ الدِّبَاغَةِ
u'ذَكَرَ دَجَّالٌ':Predicate, #2: 2	ذَكَرَ الدَّجَاجَةَ
u'ذَكَرَ دُخُولٌ':Predicate, #1: 1	ذَكَرَ الدَّجَّالَ
u'ذَكَرَ دُخُولٌ':Predicate, #1: 1	ذَكَرَ الدّخُولَ
u'ذكر دُخُولٌ':Added, #1: 1	ذَكَرَ الدُّخُولَ
u'ذِكْرٌ دُخُولٌ':Added, #1: 1	ذِكْرَ الدُّخُولِ
u'ذَكَرَ دَرَاهِمُ':Predicate, #1: 1	ذِكْرَ الدُّخُولِ
u'ذَكَرَ دَرَاهِمُ':Predicate, #1: 1	ذَكَرَ الدَّرَاهِمَ
u'ذكر درجة':Added, #1: 1	ذَكَرَ دَرَاهِمَ
u'ذِكْرٌ درجة':Added, #1: 1	ذِكْرُ الدَّرَجَةِ
u'ذكر دَرَجَةٌ':Added, #1: 1	ذِكْرُ الدَّرَجَةِ
u'ذِكْرٌ دَرَجَةٌ':Added, #1: 1	ذِكْرُ الدَّرَجَةِ
u'ذكر دُرَرٌ':Added, #1: 1	ذِكْرُ الدَّرَجَةِ
u'ذِكْرٌ دُرَرٌ':Added, #1: 1	ذِكْرِ الدُّرَرِ
u'ذكر دَرَكٌ':Added, #1: 1	ذِكْرِ الدُّرَرِ
u'ذِكْرٌ دَرَكٌ':Added, #1: 1	ذِكْرُ الدَّرَكِ
u'ذَكَرَ دِرْهَمٌ':Predicate, #1: 1	ذِكْرُ الدَّرَكِ
u'ذَكَرَ دِرْهَم':Predicate, #1: 1	ذَكَرَ الدِّرْهَمَ
u'ذكر دِرْهَمٌ':Added, #1: 1	ذَكَرَ الدِّرْهَمَ
u'ذكر دِرْهَم':Added, #1: 1	ذِكْرَ الدِّرْهَمِ
u'ذِكْرٌ دِرْهَمٌ':Added, #1: 1	ذِكْرَ الدِّرْهَمِ
u'ذِكْرٌ دِرْهَم':Added, #1: 1	ذِكْرَ الدِّرْهَمِ
u'ذَكَرَ دُعَاءٌ':Predicate, #1: 1	ذِكْرَ الدِّرْهَمِ
u'ذكر دُعَاءٌ':Added, #3: 3	ذَكَرَ الدُّعَاءَ
u'ذِكْرٌ دُعَاءٌ':Added, #1: 1	ذِكْرُ الدُّعَاءِ
u'ذَكَرَ دفع':Predicate, #1: 1	ذِكْرُ الدُّعَاءِ
u'ذَكَرَ دَفْعٌ':Predicate, #1: 1	ذَكَرَ الدَّفْعَ
u'ذكر دَفْق':Added, #1: 1	ذَكَرَ الدَّفْعَ
u'ذِكْرٌ دَفْق':Added, #1: 1	ذِكْرُ الدَّفْقِ
u'ذَكَرَ دُكَّانٌ':Predicate, #1: 1	ذِكْرُ الدَّفْقِ
u'ذَكَرَ دَكَّةٌ':Predicate, #1: 1	ذَكَرَ الدُّكَّانَ
u'ذكر دَلالَةٌ':Added, #1: 1	ذَكَرَ الدَّكَّةَ
u'ذِكْرٌ دَلالَةٌ':Added, #1: 1	ذِكْرُ الدَّلَالَةِ
u'ذكر دَلالَةٌ':Added, #1: 1	ذِكْرُ الدَّلَالَةِ
u'ذِكْرٌ دَلالَةٌ':Added, #2: 2	ذِكْرَ الدَّلَالَةِ
u'ذكر دَلائِلُ':Added, #2: 2	ذِكْرَ الدَّلَالَةِ
u'ذِكْرٌ دَلائِلُ':Added, #1: 1	ذِكْرِ دَلَائِلِ
u'ذَكَرَ دلك':Predicate, #1: 1	ذِكْرِ دَلَائِلِ
u'ذَكَرَ دَلْكٌ':Predicate, #1: 1	ذَكَرَ الدَّلْكَ
u'ذكر دلك':Added, #1: 1	ذَكَرَ الدَّلْكَ
u'ذِكْرٌ دلك':Added, #1: 1	ذِكْرُ الدَّلْكِ
u'ذكر دَلْكٌ':Added, #1: 1	ذِكْرُ الدَّلْكِ
u'ذِكْرٌ دَلْكٌ':Added, #1: 1	ذِكْرُ الدَّلْكِ
u'ذَكَرَ دَليلٌ':Predicate, #1: 1	ذِكْرُ الدَّلْكِ
u'ذَكَرَ دَليلٌ':Predicate, #2: 2	ذَكَرَ الدَّلِيلَ
u'ذكر دَليلٌ':Added, #2: 2	ذَكَرَ دَلِيلَ
u'ذِكْرٌ دَليلٌ':Added, #1: 1	ذِكْرُ الدَّلِيلِ
u'ذكر دَليلٌ':Added, #1: 1	ذِكْرُ الدَّلِيلِ
u'ذِكْرٌ دَليلٌ':Added, #1: 1	ذِكْرُ دَلِيلِ
u'ذكر دَليلٌ':Added, #1: 1	ذِكْرُ دَلِيلِ
u'ذِكْرٌ دَليلٌ':Added, #5: 5	ذِكْرِ الدَّلِيلِ
u'ذَكَرَ دَمٌ':Predicate, #5: 5	ذِكْرِ الدَّلِيلِ
u'ذكر دَمٌ':Added, #1: 1	ذَكَرَ الدَّمَ
u'ذِكْرٌ دَمٌ':Added, #1: 1	ذِكْرِ الدَّمِ
u'ذكر دَمٌ':Added, #1: 1	ذِكْرِ الدَّمِ
u'ذِكْرٌ دَمٌ':Added, #1: 1	ذِكْرِ الدَّمَيْنِ
u'ذكر دَمٌ':Added, #1: 1	ذِكْرِ الدَّمَيْنِ
u'ذِكْرٌ دَمٌ':Added, #2: 2	ذِكْرُ الدَّمِ
u'ذَكَرَ دُهْنٌ':Predicate, #2: 2	ذِكْرُ الدَّمِ
u'ذكر دَوامٌ':Added, #1: 1	ذَكَرَ الدُّهْنَ
u'ذِكْرٌ دَوامٌ':Added, #1: 1	ذِكْرِ الدَّوَامِ
u'ذَكَرَ دَوْرٌ':Predicate, #1: 1	ذِكْرِ الدَّوَامِ
u'ذكر ديباجٌ':Added, #1: 1	ذَكَرَ الدَّوْرَ
u'ذِكْرٌ ديباجٌ':Added, #1: 1	ذِكْرُ الدِّيبَاجِ
u'ذَكَرَ دِيَةٌ':Predicate, #1: 1	ذِكْرُ الدِّيبَاجِ
u'ذَكَرَ دِيَةٌ':Predicate, #1: 1	ذَكَرَ الدِّيَةَ
u'ذكر دِيَةٌ':Added, #1: 1	ذَكَرَ دِيَةَ
u'ذِكْرٌ دِيَةٌ':Added, #1: 1	ذِكْرُ الدّيَاتِ
u'ذكر دِيَةٌ':Added, #1: 1	ذِكْرُ الدّيَاتِ
u'ذِكْرٌ دِيَةٌ':Added, #1: 1	ذِكْرِ الدِّيَةِ
u'ذكر دِيَةٌ':Added, #1: 1	ذِكْرِ الدِّيَةِ
u'ذِكْرٌ دِيَةٌ':Added, #1: 1	ذِكْرِ دِيَاتِ
u'ذكر دِيَةٌ':Added, #1: 1	ذِكْرِ دِيَاتِ
u'ذِكْرٌ دِيَةٌ':Added, #2: 2	ذِكْرُ الدِّيَاتِ
u'ذَكَرَ دَيْنٌ':Predicate, #2: 2	ذِكْرُ الدِّيَاتِ
u'ذكر دِينٌ':Added, #1: 1	ذَكَرَ دَيْنَ
u'ذِكْرٌ دِينٌ':Added, #1: 1	ذِكْرُ الدِّينِ
u'ذكر دَيْنٌ':Added, #1: 1	ذِكْرُ الدِّينِ
u'ذِكْرٌ دَيْنٌ':Added, #2: 2	ذِكْرِ الدَّيْنِ
u'ذَكَرَ ذُبابٌ':Predicate, #2: 2	ذِكْرِ الدَّيْنِ
u'ذكر ذِراعٌ':Added, #1: 1	ذَكَرَ الذُّبَابَ
u'ذِكْرٌ ذِراعٌ':Added, #1: 1	ذِكْرَ الذِّرَاعِ
u'ذكر ذِراعٌ':Added, #1: 1	ذِكْرَ الذِّرَاعِ
u'ذِكْرٌ ذِراعٌ':Added, #1: 1	ذِكْرُ الذِّرَاعَيْنِ
u'ذكر ذُرَةٌ':Added, #1: 1	ذِكْرُ الذِّرَاعَيْنِ
u'ذِكْرٌ ذُرَةٌ':Added, #1: 1	ذِكْرُ الذُّرَةِ
u'ذَكَرَ ذُرْعانٌ':Predicate, #1: 1	ذِكْرُ الذُّرَةِ
u'ذكر ذُرْعانٌ':Added, #1: 1	ذَكَرَ ذُرْعَانَ
u'ذِكْرٌ ذُرْعانٌ':Added, #1: 1	ذِكْرِ الذُّرْعَانِ
u'ذكر ذُرْعانٌ':Added, #1: 1	ذِكْرِ الذُّرْعَانِ
u'ذِكْرٌ ذُرْعانٌ':Added, #2: 2	ذِكْرِ ذُرْعَانِ
u'ذكر ذَكاةٌ':Added, #2: 2	ذِكْرِ ذُرْعَانِ
u'ذِكْرٌ ذَكاةٌ':Added, #1: 1	ذِكْرُ الذَّكَاةِ
u'ذكر ذَكاةٌ':Added, #1: 1	ذِكْرُ الذَّكَاةِ
u'ذِكْرٌ ذَكاةٌ':Added, #1: 1	ذِكْرِ ذَكَاةِ
u'ذكر ذكر':Added, #1: 1	ذِكْرِ ذَكَاةِ
u'ذِكْرٌ ذكر':Added, #1: 1	ذِكْرِ الذَّكَرِ
u'ذكر ذَكَرٌ':Added, #1: 1	ذِكْرِ الذَّكَرِ
u'ذِكْرٌ ذَكَرٌ':Added, #1: 1	ذِكْرِ الذَّكَرِ
u'ذكر ذُكورَةٌ':Added, #1: 1	ذِكْرِ الذَّكَرِ
u'ذِكْرٌ ذُكورَةٌ':Added, #1: 1	ذِكْرَ الذُّكُورَةِ
u'ذكر ذُكورَةٌ':Added, #1: 1	ذِكْرَ الذُّكُورَةِ
u'ذِكْرٌ ذُكورَةٌ':Added, #2: 2	ذِكْرِ الذُّكُورَةِ
u'ذكر ذُكورَةٌ':Added, #2: 2	ذِكْرِ الذُّكُورَةِ
u'ذِكْرٌ ذُكورَةٌ':Added, #4: 4	ذِكْرُ الذُّكُورَةِ
u'ذَكَرَ ذَنْبٌ':Predicate, #4: 4	ذِكْرُ الذُّكُورَةِ
u'ذكر ذَهَبٌ':Added, #2: 2	ذَكَرَ الذَّنْبَ
u'ذِكْرٌ ذَهَبٌ':Added, #3: 3	ذِكْرُ الذَّهَبِ
u'ذَكَرَ ذَوْقٌ':Predicate, #3: 3	ذِكْرُ الذَّهَبِ
u'ذَكَرَ رابع':Predicate, #1: 1	ذَكَرَ الذَّوْقَ
u'ذَكَرَ رَابِعٌ':Predicate, #1: 1	ذَكَرَ الرَّابِعَةَ
u'ذكر رابع':Added, #1: 1	ذَكَرَ الرَّابِعَةَ
u'ذِكْرٌ رابع':Added, #1: 1	ذِكْرَ الرَّابِعِ
u'ذكر رَابِعٌ':Added, #1: 1	ذِكْرَ الرَّابِعِ
u'ذِكْرٌ رَابِعٌ':Added, #1: 1	ذِكْرَ الرَّابِعِ
u'ذكر رَأْسٌ':Added, #1: 1	ذِكْرَ الرَّابِعِ
u'ذكر رَأْسٌ':Added, #1: 1	ذِكْرَ الرَّأْسِ
u'ذِكْرٌ رَأْسٌ':Added, #1: 1	ذِكْرُ الرَّأْسِ
u'ذِكْرٌ رَأْسٌ':Added, #1: 1	ذِكْرَ الرَّأْسِ
u'ذكر رَأْسٌ':Added, #1: 1	ذِكْرُ الرَّأْسِ
u'ذِكْرٌ رَأْسٌ':Added, #2: 2	ذِكْرِ الرَّأْسِ
u'ذَكَرَ رَافِعٌ':Subject, #2: 2	ذِكْرِ الرَّأْسِ
u'ذكر رَبُّ':Added, #1: 1	ذَكَرَ رَافِعٌ
u'ذِكْرٌ رَبُّ':Added, #2: 2	ذِكْرِ الرَّبِّ
u'ذكر رَبُّ':Added, #2: 2	ذِكْرِ الرَّبِّ
u'ذِكْرٌ رَبُّ':Added, #2: 2	ذِكْرَ رَبِّهِ
u'ذكر رَبَابٌ':Added, #2: 2	ذِكْرَ رَبِّهِ
u'ذِكْرٌ رَبَابٌ':Added, #1: 1	ذِكْرِ الرَّبَابِ
u'ذَكَرَ رَبِيعٌ':Predicate, #1: 1	ذِكْرِ الرَّبَابِ
u'ذَكَرَ رَتَم':Predicate, #1: 1	ذَكَرَ الرّبِيعَ
u'ذكر رِجَالٌ':Added, #1: 1	ذَكَرَ الرَّتَمَ
u'ذِكْرٌ رِجَالٌ':Added, #2: 2	ذِكْرِ الرِّجَالِ
u'ذَكَرَ رِجْسٌ':Predicate, #2: 2	ذِكْرِ الرِّجَالِ
u'ذكر رَجْعِيٌّ':Added, #1: 1	ذَكَرَ الرّجْسَ
u'ذِكْرٌ رَجْعِيٌّ':Added, #1: 1	ذِكْرِ الرَّجْعِيَّةِ
u'ذكر رَجْعِيَّةٌ':Added, #1: 1	ذِكْرِ الرَّجْعِيَّةِ
u'ذِكْرٌ رَجْعِيَّةٌ':Added, #1: 1	ذِكْرِ الرَّجْعِيَّةِ
u'ذَكَرَ رَجُلٌ':Predicate, #1: 1	ذِكْرِ الرَّجْعِيَّةِ
u'ذَكَرَ رَجُلٌ':Predicate, #1: 1	ذَكَرَ رَجُلاً
u'ذَكَرَ رَجُلٌ':Subject, #4: 4	ذَكَرَ الرَّجُلَ
u'ذكر رَجُلٌ':Added, #5: 5	ذَكَرَ رَجُلٌ
u'ذِكْرٌ رَجُلٌ':Added, #1: 1	ذِكْرِ الرَّجُلِ
u'ذكر رِجْلٌ':Added, #1: 1	ذِكْرِ الرَّجُلِ
u'ذِكْرٌ رِجْلٌ':Added, #2: 2	ذِكْرُ الرِّجْلِ
u'ذكر رَجُلٌ':Added, #2: 2	ذِكْرُ الرِّجْلِ
u'ذِكْرٌ رَجُلٌ':Added, #3: 3	ذِكْرَ الرَّجُلِ
u'ذَكَرَ رَجْمٌ':Predicate, #3: 3	ذِكْرَ الرَّجُلِ
u'ذكر رَجْمٌ':Added, #1: 1	ذَكَرَ الرَّجْمَ
u'ذِكْرٌ رَجْمٌ':Added, #1: 1	ذِكْرَ الرّجْمِ
u'ذَكَرَ رُجُوعٌ':Predicate, #1: 1	ذِكْرَ الرّجْمِ
u'ذَكَرَ رُجُوعٌ':Predicate, #1: 1	ذَكَرَ الرُّجُوعَ
u'ذكر رُجُوعٌ':Added, #1: 1	ذَكَرَ رُجُوعَ
u'ذِكْرٌ رُجُوعٌ':Added, #1: 1	ذِكْرِ رُجُوعٍ
u'ذكر رُجُوعٌ':Added, #1: 1	ذِكْرِ رُجُوعٍ
u'ذِكْرٌ رُجُوعٌ':Added, #2: 2	ذِكْرِ الرُّجُوعِ
u'ذَكَرَ رحم':Predicate, #2: 2	ذِكْرِ الرُّجُوعِ
u'ذَكَرَ رَحِمٌ':Predicate, #1: 1	ذَكَرَ الرَّحِمَ
u'ذكر رحمة':Added, #1: 1	ذَكَرَ الرَّحِمَ
u'ذِكْرٌ رحمة':Added, #1: 1	ذِكْرُ رَحْمَةِ
u'ذكر رَحْمَةٌ':Added, #1: 1	ذِكْرُ رَحْمَةِ
u'ذِكْرٌ رَحْمَةٌ':Added, #1: 1	ذِكْرُ رَحْمَةِ
u'ذكر رحمة':Added, #1: 1	ذِكْرُ رَحْمَةِ
u'ذكر رحمة':Added, #2: 2	ذِكْرُ الرَّحْمَةِ
u'ذِكْرٌ رحمة':Added, #2: 2	ذِكْرِ الرَّحْمَةِ
u'ذِكْرٌ رحمة':Added, #2: 2	ذِكْرُ الرَّحْمَةِ
u'ذكر رَحْمَةٌ':Added, #2: 2	ذِكْرِ الرَّحْمَةِ
u'ذكر رَحْمَةٌ':Added, #2: 2	ذِكْرُ الرَّحْمَةِ
u'ذِكْرٌ رَحْمَةٌ':Added, #2: 2	ذِكْرِ الرَّحْمَةِ
u'ذِكْرٌ رَحْمَةٌ':Added, #2: 2	ذِكْرُ الرَّحْمَةِ
u'ذكر رُخْصَةٌ':Added, #2: 2	ذِكْرِ الرَّحْمَةِ
u'ذِكْرٌ رُخْصَةٌ':Added, #1: 1	ذِكْرُ الرُّخْصَةِ
u'ذَكَرَ رَدٌّ':Predicate, #1: 1	ذِكْرُ الرُّخْصَةِ
u'ذَكَرَ رَدٌّ':Predicate, #1: 1	ذَكَرَ الرَّدَّ
u'ذكر رَدٌّ':Added, #1: 1	ذَكَرَ رَدَّ
u'ذِكْرٌ رَدٌّ':Added, #1: 1	ذِكْرِ رَدِّ
u'ذكر رَدِيفٌ':Added, #1: 1	ذِكْرِ رَدِّ
u'ذِكْرٌ رَدِيفٌ':Added, #2: 2	ذِكْرُ الرَّدِيفِ
u'ذَكَرَ رُسُلٌ':Predicate, #2: 2	ذِكْرُ الرَّدِيفِ
u'ذَكَرَ رَسُولٌ':Predicate, #1: 1	ذَكَرَ الرُّسُلَ
u'ذَكَرَ رَسُولٌ':Subject, #3: 3	ذَكَرَ رَسُولَ
u'ذكر رَسُولٌ':Added, #18: 18	ذَكَرَ رَسُولُ
u'ذكر رَسُولٌ':Added, #1: 1	ذِكْرُ الرّسُولِ
u'ذكر رَسُولٌ':Added, #1: 1	ذِكْرُ الرَّسُولِ
u'ذِكْرٌ رَسُولٌ':Added, #1: 1	ذِكْرِ الرَّسُولِ
u'ذِكْرٌ رَسُولٌ':Added, #1: 1	ذِكْرُ الرّسُولِ
u'ذِكْرٌ رَسُولٌ':Added, #1: 1	ذِكْرُ الرَّسُولِ
u'ذكر رَسُولٌ':Added, #1: 1	ذِكْرِ الرَّسُولِ
u'ذكر رَسُولٌ':Added, #1: 1	ذِكْرَ رَسُولِ
u'ذِكْرٌ رَسُولٌ':Added, #1: 1	ذِكْرِ رَسُولِ
u'ذِكْرٌ رَسُولٌ':Added, #1: 1	ذِكْرَ رَسُولِ
u'ذكر رَسُولٌ':Added, #1: 1	ذِكْرِ رَسُولِ
u'ذِكْرٌ رَسُولٌ':Added, #2: 2	ذِكْرُ رَسُولِهِ
u'ذَكَرَ رَشيدٌ':Subject, #2: 2	ذِكْرُ رَسُولِهِ
u'ذَكَرَ رَضِيٌّ':Subject, #2: 2	ذَكَرَ رَشِيدُ
u'ذَكَرَ رَطْبٌ':Predicate, #1: 1	ذَكَرَ رَضِيُّ
u'ذكر رَفَثِ':Added, #1: 1	ذَكَرَ الرَّطْبَ
u'ذكر رَفَث':Added, #1: 1	ذِكْرُ الرَّفَثِ
u'ذِكْرٌ رَفَثِ':Added, #1: 1	ذِكْرُ الرَّفَثِ
u'ذِكْرٌ رَفَث':Added, #1: 1	ذِكْرُ الرَّفَثِ
u'ذكر رَفْعٌ':Added, #1: 1	ذِكْرُ الرَّفَثِ
u'ذِكْرٌ رَفْعٌ':Added, #1: 1	ذِكْرَ الرَّفْعِ
u'ذكر رَفيقٌ':Added, #1: 1	ذِكْرَ الرَّفْعِ
u'ذِكْرٌ رَفيقٌ':Added, #1: 1	ذِكْرُ الرَّفِيقِ
u'ذَكَرَ رَقَبَةٌ':Predicate, #1: 1	ذِكْرُ الرَّفِيقِ
u'ذكر رَقَبَةٌ':Added, #1: 1	ذَكَرَ الرَّقَبَةَ
u'ذكر رَقَبَةٌ':Added, #1: 1	ذِكْرَ الرَّقَبَةِ
u'ذِكْرٌ رَقَبَةٌ':Added, #1: 1	ذِكْرِ الرَّقَبَةِ
u'ذِكْرٌ رَقَبَةٌ':Added, #1: 1	ذِكْرَ الرَّقَبَةِ
u'ذَكَرَ رَقيقٌ':Predicate, #1: 1	ذِكْرِ الرَّقَبَةِ
u'ذَكَرَ رَقيق':Predicate, #1: 1	ذَكَرَ الرَّقِيقَ
u'ذكر ركعة':Added, #1: 1	ذَكَرَ الرَّقِيقَ
u'ذِكْرٌ ركعة':Added, #1: 1	ذِكْرِ رَكْعَةٍ
u'ذكر رَكْعَةٌ':Added, #1: 1	ذِكْرِ رَكْعَةٍ
u'ذِكْرٌ رَكْعَةٌ':Added, #1: 1	ذِكْرِ رَكْعَةٍ
u'ذَكَرَ رُكْنٌ':Predicate, #1: 1	ذِكْرِ رَكْعَةٍ
u'ذَكَرَ رُكْن':Predicate, #2: 2	ذَكَرَ رُكْنَ
u'ذَكَرَ رُكْنٌ':Subject, #2: 2	ذَكَرَ رُكْنَ
u'ذَكَرَ رُكْن':Subject, #1: 1	ذَكَرَ رُكْنُ
u'ذَكَرَ رُكوبٌ':Predicate, #1: 1	ذَكَرَ رُكْنُ
u'ذكر رُكوبٌ':Added, #1: 1	ذَكَرَ الرُّكُوبَ
u'ذِكْرٌ رُكوبٌ':Added, #1: 1	ذِكْرُ رُكُوبِ
u'ذكر رُكوعٌ':Added, #1: 1	ذِكْرُ رُكُوبِ
u'ذِكْرٌ رُكوعٌ':Added, #2: 2	ذِكْرِ الرُّكُوعِ
u'ذَكَرَ رماح':Predicate, #2: 2	ذِكْرِ الرُّكُوعِ
u'ذَكَرَ رِماحٌ':Predicate, #1: 1	ذَكَرَ الرِّمَاحَ
u'ذكر رُمْحٌ':Added, #1: 1	ذَكَرَ الرِّمَاحَ
u'ذِكْرٌ رُمْحٌ':Added, #1: 1	ذِكْرُ الرُّمْحِ
u'ذكر رَمْزٌ':Added, #1: 1	ذِكْرُ الرُّمْحِ
u'ذِكْرٌ رَمْزٌ':Added, #1: 1	ذِكْرَ الرَّمْزِ
u'ذَكَرَ رَمَضانُ':Predicate, #1: 1	ذِكْرَ الرَّمْزِ
u'ذَكَرَ رَمْلِيٌّ':Subject, #4: 4	ذَكَرَ رَمَضَانَ
u'ذكر رَمْيٌ':Added, #3: 3	ذَكَرَ الرَّمْلِيُّ
u'ذِكْرٌ رَمْيٌ':Added, #1: 1	ذِكْرِ رَمْيِ
u'ذَكَرَ رَهْنٌ':Predicate, #1: 1	ذِكْرِ رَمْيِ
u'ذَكَرَ رُوَاةٌ':Subject, #1: 1	ذَكَرَ الرَّهْنَ
u'ذكر رَوَاجٌ':Added, #1: 1	ذَكَرَ رُوَاةُ
u'ذِكْرٌ رَوَاجٌ':Added, #1: 1	ذِكْرِ رَوَاجِ
u'ذكر روائح':Added, #1: 1	ذِكْرِ رَوَاجِ
u'ذِكْرٌ روائح':Added, #1: 1	ذِكْرِ الرَّوَائِحِ
u'ذكر رَوائِحُ':Added, #1: 1	ذِكْرِ الرَّوَائِحِ
u'ذكر رَوَائِحُ':Added, #1: 1	ذِكْرِ الرَّوَائِحِ
u'ذِكْرٌ رَوائِحُ':Added, #1: 1	ذِكْرِ الرَّوَائِحِ
u'ذِكْرٌ رَوَائِحُ':Added, #1: 1	ذِكْرِ الرَّوَائِحِ
u'ذكر رِواياتٌ':Added, #1: 1	ذِكْرِ الرَّوَائِحِ
u'ذِكْرٌ رِواياتٌ':Added, #3: 3	ذِكْرِ الرِّوَايَاتِ
u'ذَكَرَ رِوايَةٌ':Predicate, #3: 3	ذِكْرِ الرِّوَايَاتِ
u'ذَكَرَ رِوايَةٌ':Predicate, #14: 14	ذَكَرَ رِوَايَةَ
u'ذكر رِوايَةٌ':Added, #5: 5	ذَكَرَ الرِّوَايَةَ
u'ذِكْرٌ رِوايَةٌ':Added, #1: 1	ذِكْرُ الرِّوَايَةِ
u'ذكر رِوايَةٌ':Added, #1: 1	ذِكْرُ الرِّوَايَةِ
u'ذِكْرٌ رِوايَةٌ':Added, #1: 1	ذِكْرِ رِوَايَتِهِ
u'ذكر رِوايَةٌ':Added, #1: 1	ذِكْرِ رِوَايَتِهِ
u'ذِكْرٌ رِوايَةٌ':Added, #5: 5	ذِكْرِ الرِّوَايَةِ
u'ذكر رِوايَةٌ':Added, #5: 5	ذِكْرِ الرِّوَايَةِ
u'ذِكْرٌ رِوايَةٌ':Added, #7: 7	ذِكْرِ رِوَايَةِ
u'ذكر رَوْضَةٌ':Added, #7: 7	ذِكْرِ رِوَايَةِ
u'ذِكْرٌ رَوْضَةٌ':Added, #1: 1	ذِكْرِ الرَّوْضَةِ
u'ذكر روع':Added, #1: 1	ذِكْرِ الرَّوْضَةِ
u'ذكر رُوعٌ':Added, #1: 1	ذِكْرُ الرّوْعِ
u'ذِكْرٌ روع':Added, #1: 1	ذِكْرُ الرّوْعِ
u'ذكر رَوْعٌ':Added, #1: 1	ذِكْرُ الرّوْعِ
u'ذِكْرٌ رُوعٌ':Added, #1: 1	ذِكْرُ الرّوْعِ
u'ذِكْرٌ رَوْعٌ':Added, #1: 1	ذِكْرُ الرّوْعِ
u'ذكر رُؤْيَةٌ':Added, #1: 1	ذِكْرُ الرّوْعِ
u'ذِكْرٌ رُؤْيَةٌ':Added, #1: 1	ذِكْرِ الرُّؤْيَةِ
u'ذكر رُؤْيَةٌ':Added, #1: 1	ذِكْرِ الرُّؤْيَةِ
u'ذِكْرٌ رُؤْيَةٌ':Added, #1: 1	ذِكْرَ رُؤْيَتِهِ
u'ذكر ريحٌ':Added, #1: 1	ذِكْرَ رُؤْيَتِهِ
u'ذِكْرٌ ريحٌ':Added, #1: 1	ذِكْرِ الرِّيحِ
u'ذَكَرَ زانِي':Predicate, #1: 1	ذِكْرِ الرِّيحِ
u'ذكر زَبيبٌ':Added, #1: 1	ذَكَرَ الزَّانِيَ
u'ذِكْرٌ زَبيبٌ':Added, #1: 1	ذِكْرِ الزَّبِيبِ
u'ذَكَرَ زَجَّاجٌ':Subject, #1: 1	ذِكْرِ الزَّبِيبِ
u'ذَكَرَ زَجْرٌ':Predicate, #1: 1	ذَكَرَ الزّجّاجُ
u'ذَكَرَ زُفَرٌ':Subject, #1: 1	ذَكَرَ الزَّجْرَ
u'ذَكَرَ زَكاةٌ':Predicate, #1: 1	ذَكَرَ زُفَرُ
u'ذَكَرَ زُكاةٌ':Predicate, #1: 1	ذَكَرَ الزّكَاةَ
u'ذَكَرَ زَكاةٌ':Predicate, #1: 1	ذَكَرَ الزّكَاةَ
u'ذكر زَكاةٌ':Added, #2: 2	ذَكَرَ الزَّكَاةَ
u'ذكر زَكاةٌ':Added, #1: 1	ذِكْرَ زَكَاةِ
u'ذِكْرٌ زَكاةٌ':Added, #1: 1	ذِكْرِ زَكَاةِ
u'ذِكْرٌ زَكاةٌ':Added, #1: 1	ذِكْرَ زَكَاةِ
u'ذكر زَمانٌ':Added, #1: 1	ذِكْرِ زَكَاةِ
u'ذكر زَمانٌ':Added, #1: 1	ذِكْرُ الزَّمَانِ
u'ذِكْرٌ زَمانٌ':Added, #1: 1	ذِكْرِ الزَّمَانِ
u'ذِكْرٌ زَمانٌ':Added, #1: 1	ذِكْرُ الزَّمَانِ
u'ذكر زَمانَةٌ':Added, #1: 1	ذِكْرِ الزَّمَانِ
u'ذِكْرٌ زَمانَةٌ':Added, #1: 1	ذِكْرُ الزَّمَانَةِ
u'ذكر زُهْدٌ':Added, #1: 1	ذِكْرُ الزَّمَانَةِ
u'ذِكْرٌ زُهْدٌ':Added, #2: 2	ذِكْرِ الزُّهْدِ
u'ذكر زهر':Added, #2: 2	ذِكْرِ الزُّهْدِ
u'ذِكْرٌ زهر':Added, #1: 1	ذِكْرِ زَهْرٍ
u'ذكر زَهْرٌ':Added, #1: 1	ذِكْرِ زَهْرٍ
u'ذِكْرٌ زَهْرٌ':Added, #1: 1	ذِكْرِ زَهْرٍ
u'ذكر زواجر':Added, #1: 1	ذِكْرِ زَهْرٍ
u'ذِكْرٌ زواجر':Added, #3: 3	ذِكْرِ الزَّوَاجِرِ
u'ذَكَرَ زَوْجٌ':Predicate, #3: 3	ذِكْرِ الزَّوَاجِرِ
u'ذَكَرَ زَوْجٌ':Subject, #5: 5	ذَكَرَ الزَّوْجَ
u'ذكر زَوْجٌ':Added, #2: 2	ذَكَرَ الزَّوْجُ
u'ذكر زَوْجٌ':Added, #1: 1	ذِكْرَ الزَّوْجِ
u'ذِكْرٌ زَوْجٌ':Added, #1: 1	ذِكْرِ الزَّوْجِ
u'ذِكْرٌ زَوْجٌ':Added, #1: 1	ذِكْرَ الزَّوْجِ
u'ذكر زَوْجَةٌ':Added, #1: 1	ذِكْرِ الزَّوْجِ
u'ذِكْرٌ زَوْجَةٌ':Added, #1: 1	ذِكْرِ الزَّوْجَاتِ
u'ذكر زَوْجَةٌ':Added, #1: 1	ذِكْرِ الزَّوْجَاتِ
u'ذكر زَوْجَةٌ':Added, #1: 1	ذِكْر الزَّوْجَةِ
u'ذِكْرٌ زَوْجَةٌ':Added, #1: 1	ذِكْرِ الزَّوْجَةِ
u'ذِكْرٌ زَوْجَةٌ':Added, #1: 1	ذِكْر الزَّوْجَةِ
u'ذَكَرَ زِيادَةٌ':Predicate, #1: 1	ذِكْرِ الزَّوْجَةِ
u'ذَكَرَ زِيادَةٌ':Predicate, #2: 2	ذَكَرَ الزِّيَادَةَ
u'ذكر زَيْدٌ':Added, #2: 2	ذَكَرَ زِيَادَةَ
u'ذِكْرٌ زَيْدٌ':Added, #1: 1	ذِكْرِ زَيْدٍ
u'ذكر زَيْفٌ':Added, #1: 1	ذِكْرِ زَيْدٍ
u'ذِكْرٌ زَيْفٌ':Added, #1: 1	ذِكْرُ الزَّيْفِ
u'ذَكَرَ سَابِقٌ':Predicate, #1: 1	ذِكْرُ الزَّيْفِ
u'ذَكَرَ سَابِقٌ':Predicate, #1: 1	ذَكَرَ السّابِقِينَ
u'ذَكَرَ سَابِقٌ':Predicate, #1: 1	ذَكَرَ السَّابِقِينَ
u'ذَكَرَ سادة':Subject, #3: 3	ذَكَرَ سَابِقَةً
u'ذَكَرَ سَادَةٌ':Subject, #1: 1	ذَكَرَ السَّادَةُ
u'ذَكَرَ سَاعَةٌ':Predicate, #1: 1	ذَكَرَ السَّادَةُ
u'ذكر سَاعَةٌ':Added, #3: 3	ذَكَرَ السَّاعَةَ
u'ذِكْرٌ سَاعَةٌ':Added, #1: 1	ذِكْرَ السَّاعَةِ
u'ذكر سَاعَةٌ':Added, #1: 1	ذِكْرَ السَّاعَةِ
u'ذِكْرٌ سَاعَةٌ':Added, #1: 1	ذِكْرِ سَاعَةِ
u'ذكر سَاعَةٌ':Added, #1: 1	ذِكْرِ سَاعَةِ
u'ذِكْرٌ سَاعَةٌ':Added, #2: 2	ذِكْرُ السَّاعَةِ
u'ذَكَرَ سَائِمَةٌ':Predicate, #2: 2	ذِكْرُ السَّاعَةِ
u'ذكر سَبٌّ':Added, #1: 1	ذَكَرَ السَّائِمَةَ
u'ذِكْرٌ سَبٌّ':Added, #1: 1	ذِكْرِ سَبِّ
u'ذَكَرَ سَبَبٌ':Predicate, #1: 1	ذِكْرِ سَبِّ
u'ذَكَرَ سَبَبٌ':Predicate, #2: 2	ذَكَرَ السَّبَبَ
u'ذكر سَبَبٌ':Added, #3: 3	ذَكَرَ سَبَبَ
u'ذِكْرٌ سَبَبٌ':Added, #11: 11	ذِكْرِ السَّبَبِ
u'ذكر سَبَبٌ':Added, #11: 11	ذِكْرِ السَّبَبِ
u'ذِكْرٌ سَبَبٌ':Added, #1: 1	ذِكْرَ سَبَبِ
u'ذكر سَبَبٌ':Added, #1: 1	ذِكْرَ سَبَبِ
u'ذكر سَبَبٌ':Added, #2: 2	ذِكْرِ سَبَبٍ
u'ذِكْرٌ سَبَبٌ':Added, #2: 2	ذِكْرِ سَبَبِ
u'ذِكْرٌ سَبَبٌ':Added, #2: 2	ذِكْرِ سَبَبٍ
u'ذكر سَبَبٌ':Added, #2: 2	ذِكْرِ سَبَبِ
u'ذِكْرٌ سَبَبٌ':Added, #2: 2	ذِكْرَ سَبَبِهِ
u'ذكر سَبَبٌ':Added, #2: 2	ذِكْرَ سَبَبِهِ
u'ذِكْرٌ سَبَبٌ':Added, #3: 3	ذِكْرُ سَبَبِهِ
u'ذكر سَبَبٌ':Added, #3: 3	ذِكْرُ سَبَبِهِ
u'ذِكْرٌ سَبَبٌ':Added, #4: 4	ذِكْرَ السَّبَبِ
u'ذكر سَبَبٌ':Added, #4: 4	ذِكْرَ السَّبَبِ
u'ذِكْرٌ سَبَبٌ':Added, #4: 4	ذِكْرِ سَبَبِهِ
u'ذكر سَبَبٌ':Added, #4: 4	ذِكْرِ سَبَبِهِ
u'ذِكْرٌ سَبَبٌ':Added, #5: 5	ذِكْرُ سَبَبِ
u'ذكر سَبَبٌ':Added, #5: 5	ذِكْرُ سَبَبِ
u'ذِكْرٌ سَبَبٌ':Added, #8: 8	ذِكْرُ السَّبَبِ
u'ذكر سَبْعٌ':Added, #8: 8	ذِكْرُ السَّبَبِ
u'ذِكْرٌ سَبْعٌ':Added, #1: 1	ذِكْرِ السَّبْعِ
u'ذَكَرَ سَبْعَةٌ':Predicate, #1: 1	ذِكْرِ السَّبْعِ
u'ذكر سَبْعَةٌ':Added, #1: 1	ذَكَرَ السَّبْعَةَ
u'ذِكْرٌ سَبْعَةٌ':Added, #1: 1	ذِكْرِ السَّبْعَةِ
u'ذَكَرَ سِتٌّ':Predicate, #1: 1	ذِكْرِ السَّبْعَةِ
u'ذَكَرَ سِتٌّ':Predicate, #1: 1	ذَكَرَ السِّتَّ
u'ذَكَرَ سِتٌّ':Predicate, #1: 1	ذَكَرَ سِتَّ
u'ذكر سِتٌّ':Added, #1: 1	ذَكَرَ سِتَّةَ
u'ذِكْرٌ سِتٌّ':Added, #1: 1	ذِكْرِ السّتّةِ
u'ذكر سجدة':Added, #1: 1	ذِكْرِ السّتّةِ
u'ذِكْرٌ سجدة':Added, #1: 1	ذِكْرَ السَّجْدَةِ
u'ذكر سَجْدَةٌ':Added, #1: 1	ذِكْرَ السَّجْدَةِ
u'ذِكْرٌ سَجْدَةٌ':Added, #1: 1	ذِكْرَ السَّجْدَةِ
u'ذكر سِجِلٌّ':Added, #1: 1	ذِكْرَ السَّجْدَةِ
u'ذِكْرٌ سِجِلٌّ':Added, #1: 1	ذِكْرُ سِجِلٍّ
u'ذَكَرَ سُجُودٌ':Predicate, #1: 1	ذِكْرُ سِجِلٍّ
u'ذكر سُجُودٌ':Added, #2: 2	ذَكَرَ سُجُودَ
u'ذِكْرٌ سُجُودٌ':Added, #1: 1	ذِكْرِ السُّجُودِ
u'ذكر سِدْرٌ':Added, #1: 1	ذِكْرِ السُّجُودِ
u'ذِكْرٌ سِدْرٌ':Added, #1: 1	ذِكْرِ السِّدْرِ
u'ذَكَرَ سدرة':Predicate, #1: 1	ذِكْرِ السِّدْرِ
u'ذَكَرَ سِدْرَةٌ':Predicate, #1: 1	ذَكَرَ سِدْرَةَ
u'ذكر سدرة':Added, #1: 1	ذَكَرَ سِدْرَةَ
u'ذِكْرٌ سدرة':Added, #1: 1	ذِكْرُ السِّدْرَةِ
u'ذكر سِدْرَةٌ':Added, #1: 1	ذِكْرُ السِّدْرَةِ
u'ذِكْرٌ سِدْرَةٌ':Added, #1: 1	ذِكْرُ السِّدْرَةِ
u'ذَكَرَ سِرَاجٌ':Subject, #1: 1	ذِكْرُ السِّدْرَةِ
u'ذكر سَرْدٌ':Added, #1: 1	ذَكَرَ السِّرَاجُ
u'ذِكْرٌ سَرْدٌ':Added, #1: 1	ذِكْرُ سَرْدِ
u'ذَكَرَ سَرقَةٌ':Predicate, #1: 1	ذِكْرُ سَرْدِ
u'ذَكَرَ سَرِقَةٌ':Predicate, #1: 1	ذَكَرَ السَّرِقَةَ
u'ذَكَرَ سُرُوجِيّ':Subject, #1: 1	ذَكَرَ السَّرِقَةَ
u'ذكر سِعَايَةٌ':Added, #1: 1	ذَكَرَ السُّرُوجِيُّ
u'ذِكْرٌ سِعَايَةٌ':Added, #1: 1	ذِكْرَ السِّعَايَةِ
u'ذكر سَعْدٌ':Added, #1: 1	ذِكْرَ السِّعَايَةِ
u'ذكر سَعْدٌ':Added, #1: 1	ذِكْرُ سَعْدٍ
u'ذِكْرٌ سَعْدٌ':Added, #1: 1	ذِكْرِ سَعْدٍ
u'ذِكْرٌ سَعْدٌ':Added, #1: 1	ذِكْرُ سَعْدٍ
u'ذَكَرَ سَعِيدٌ':Subject, #1: 1	ذِكْرِ سَعْدٍ
u'ذَكَرَ سَفَر':Predicate, #2: 2	ذَكَرَ سَعِيدُ
u'ذكر سَفَرٌ':Added, #1: 1	ذَكَرَ سَفَرِيَّةً
u'ذِكْرٌ سَفَرٌ':Added, #1: 1	ذِكْرُ السَّفَرِ
u'ذكر سَفَرٌ':Added, #1: 1	ذِكْرُ السَّفَرِ
u'ذِكْرٌ سَفَرٌ':Added, #2: 2	ذِكْرِ السَّفَرِ
u'ذكر سَفَرْجَلٌ':Added, #2: 2	ذِكْرِ السَّفَرِ
u'ذِكْرٌ سَفَرْجَلٌ':Added, #1: 1	ذِكْرِ السَّفَرْجَلِ
u'ذَكَرَ سَفَرِيّ':Predicate, #1: 1	ذِكْرِ السَّفَرْجَلِ
u'ذَكَرَ سَفِيهٌ':Subject, #1: 1	ذَكَرَ سَفَرِيَّةً
u'ذكر سقط':Added, #1: 1	ذَكَرَ السَّفِيهُ
u'ذِكْرٌ سقط':Added, #1: 1	ذِكْرِ السِّقْطِ
u'ذكر سِقْطٌ':Added, #1: 1	ذِكْرِ السِّقْطِ
u'ذِكْرٌ سِقْطٌ':Added, #1: 1	ذِكْرِ السِّقْطِ
u'ذكر سُقُوطٌ':Added, #1: 1	ذِكْرِ السِّقْطِ
u'ذِكْرٌ سُقُوطٌ':Added, #1: 1	ذِكْرُ سُقُوطِهِ
u'ذكر سُقُوطٌ':Added, #1: 1	ذِكْرُ سُقُوطِهِ
u'ذِكْرٌ سُقُوطٌ':Added, #2: 2	ذِكْرُ السُّقُوطِ
u'ذكر سَقْيٌ':Added, #2: 2	ذِكْرُ السُّقُوطِ
u'ذِكْرٌ سَقْيٌ':Added, #2: 2	ذِكْرِ السَّقْيِ
u'ذكر سِكَّةٌ':Added, #2: 2	ذِكْرِ السَّقْيِ
u'ذِكْرٌ سِكَّةٌ':Added, #2: 2	ذِكْرِ السِّكَّةِ
u'ذكر سِلاَحٌ':Added, #2: 2	ذِكْرِ السِّكَّةِ
u'ذِكْرٌ سِلاَحٌ':Added, #1: 1	ذِكْرِ السِّلَاحِ
u'ذَكَرَ سلام':Predicate, #1: 1	ذِكْرِ السِّلَاحِ
u'ذَكَرَ سَلاَمٌ':Predicate, #1: 1	ذَكَرَ السَّلَامَ
u'ذكر سَلاَمَةٌ':Added, #1: 1	ذَكَرَ السَّلَامَ
u'ذِكْرٌ سَلاَمَةٌ':Added, #1: 1	ذِكْرِ سَلَامَةِ
u'ذكر سَلْبٌ':Added, #1: 1	ذِكْرِ سَلَامَةِ
u'ذِكْرٌ سَلْبٌ':Added, #1: 1	ذِكْرِ سَلْبِ
u'ذَكَرَ سِلْسلَةٌ':Predicate, #1: 1	ذِكْرِ سَلْبِ
u'ذكر سَمَاعٌ':Added, #1: 1	ذَكَرَ سِلْسِلَةَ
u'ذِكْرٌ سَمَاعٌ':Added, #1: 1	ذِكْرِ سَمَاعِ
u'ذكر سَمَاعٌ':Added, #1: 1	ذِكْرِ سَمَاعِ
u'ذِكْرٌ سَمَاعٌ':Added, #1: 1	ذِكْرِ سَمَاعِهِ
u'ذكر سَمْعٌ':Added, #1: 1	ذِكْرِ سَمَاعِهِ
u'ذِكْرٌ سَمْعٌ':Added, #1: 1	ذِكْرِ السَّمْعِ
u'ذكر سَمَكٌ':Added, #1: 1	ذِكْرِ السَّمْعِ
u'ذِكْرٌ سَمَكٌ':Added, #1: 1	ذِكْرُ السَّمَكِ
u'ذكر سَمْهَرِيّ':Added, #1: 1	ذِكْرُ السَّمَكِ
u'ذِكْرٌ سَمْهَرِيّ':Added, #1: 1	ذِكْرِ السّمْهَرِيّةِ
u'ذَكَرَ سِنٌّ':Predicate, #1: 1	ذِكْرِ السّمْهَرِيّةِ
u'ذَكَرَ سَنَةٌ':Predicate, #2: 2	ذَكَرَ السِّنَّ
u'ذكر سَنَةٌ':Added, #1: 1	ذَكَرَ السَّنَةَ
u'ذكر سَنَةٌ':Added, #1: 1	ذِكْرُ السَّنَةِ
u'ذكر سُنَّةٌ':Added, #1: 1	ذِكْرِ السَّنَةِ
u'ذِكْرٌ سَنَةٌ':Added, #1: 1	ذِكْرُ السُّنَّةِ
u'ذِكْرٌ سَنَةٌ':Added, #1: 1	ذِكْرُ السَّنَةِ
u'ذِكْرٌ سُنَّةٌ':Added, #1: 1	ذِكْرِ السَّنَةِ
u'ذكر سَنَةٌ':Added, #1: 1	ذِكْرُ السُّنَّةِ
u'ذكر سُنَّةٌ':Added, #1: 1	ذِكْرُ سَنَةِ
u'ذِكْرٌ سَنَةٌ':Added, #1: 1	ذِكْرَ سُنَّةِ
u'ذِكْرٌ سُنَّةٌ':Added, #1: 1	ذِكْرُ سَنَةِ
u'ذكر سَنَةٌ':Added, #1: 1	ذِكْرَ سُنَّةِ
u'ذِكْرٌ سَنَةٌ':Added, #2: 2	ذِكْرَ السَّنَةِ
u'ذكر سَنَدٌ':Added, #2: 2	ذِكْرَ السَّنَةِ
u'ذِكْرٌ سَنَدٌ':Added, #1: 1	ذِكْرِ السَّنَدِ
u'ذكر سنن':Added, #1: 1	ذِكْرِ السَّنَدِ
u'ذكر سنن':Added, #1: 1	ذِكْرُ السُّنَنِ
u'ذِكْرٌ سنن':Added, #1: 1	ذِكْرِ السُّنَنِ
u'ذِكْرٌ سنن':Added, #1: 1	ذِكْرُ السُّنَنِ
u'ذكر سنن':Added, #1: 1	ذِكْرِ السُّنَنِ
u'ذِكْرٌ سنن':Added, #1: 1	ذِكْرِ سُنَنِ
u'ذَكَرَ سَهْمٌ':Predicate, #1: 1	ذِكْرِ سُنَنِ
u'ذكر سَهْمٌ':Added, #1: 1	ذَكَرَ السَّهْمَ
u'ذِكْرٌ سَهْمٌ':Added, #1: 1	ذِكْرَ السَّهْمِ
u'ذَكَرَ سَهْوٌ':Predicate, #1: 1	ذِكْرَ السَّهْمِ
u'ذَكَرَ سَواءٌ':Subject, #2: 2	ذَكَرَ السَّهْوَ
u'ذكر سِواكٌ':Added, #1: 1	ذَكَرَ سَوَاءٌ
u'ذِكْرٌ سِواكٌ':Added, #1: 1	ذِكْرِ السِّوَاكِ
u'ذَكَرَ سُؤَالٌ':Predicate, #1: 1	ذِكْرِ السِّوَاكِ
u'ذكر سُؤَالٌ':Added, #1: 1	ذَكَرَ السُّؤَالَ
u'ذِكْرٌ سُؤَالٌ':Added, #7: 7	ذِكْرِ السُّؤَالِ
u'ذكر سُؤْرٌ':Added, #7: 7	ذِكْرِ السُّؤَالِ
u'ذكر سُؤْرٌ':Added, #1: 1	ذِكْرُ السُّؤْرِ
u'ذِكْرٌ سُؤْرٌ':Added, #1: 1	ذِكْرِ السُّؤْرِ
u'ذِكْرٌ سُؤْرٌ':Added, #1: 1	ذِكْرُ السُّؤْرِ
u'ذكر سُورَةٌ':Added, #1: 1	ذِكْرِ السُّؤْرِ
u'ذِكْرٌ سُورَةٌ':Added, #1: 1	ذِكْرُ السُّورَةِ
u'ذكر سُورَةٌ':Added, #1: 1	ذِكْرُ السُّورَةِ
u'ذِكْرٌ سُورَةٌ':Added, #1: 1	ذِكْرِ سُورَةِ
u'ذَكَرَ سَيِّدٌ':Subject, #1: 1	ذِكْرِ سُورَةِ
u'ذَكَرَ سِيَرٌ':Predicate, #2: 2	ذَكَرَ السَّيِّدُ
u'ذَكَرَ سَيْفٌ':Predicate, #1: 1	ذَكَرَ السِّيَرَ
u'ذَكَرَ سَيْفٌ':Subject, #2: 2	ذَكَرَ السَّيْفَ
u'ذكر ش':Added, #1: 1	ذَكَرَ سَيْفٌ
u'ذِكْرٌ ش':Added, #1: 1	ذِكْرُ الشِّيَاتِ
u'ذَكَرَ شَاةٌ':Predicate, #1: 1	ذِكْرُ الشِّيَاتِ
u'ذكر شَاةٌ':Added, #3: 3	ذَكَرَ الشَّاةَ
u'ذِكْرٌ شَاةٌ':Added, #2: 2	ذِكْرَ الشَّاةِ
u'ذَكَرَ شاذِلِيّ':Subject, #2: 2	ذِكْرَ الشَّاةِ
u'ذَكَرَ شَارِحٌ':Subject, #1: 1	ذَكَرَ الشَّاذِلِيُّ
u'ذَكَرَ شَارِحٌ':Subject, #1: 1	ذَكَرَ شَارِحُ
u'ذَكَرَ شَارِحٌ':Subject, #1: 1	ذَكَرَ شَارِحُهُ
u'ذَكَرَ شافِع':Subject, #51: 51	ذَكَرَ الشَّارِحُ
u'ذَكَرَ شافِعِيّ':Subject, #3: 3	ذَكَرَ الشَّافِعِيَّةُ
u'ذَكَرَ شافِعِيّ':Subject, #10: 10	ذَكَرَ الشَّافِعِيُّ
u'ذَكَرَ شَأْنٌ':Predicate, #3: 3	ذَكَرَ الشَّافِعِيَّةُ
u'ذَكَرَ شَاهِدٌ':Subject, #1: 1	ذَكَرَ شَأْنَ
u'ذكر شَاهِدٌ':Added, #1: 1	ذَكَرَ الشَّاهِدُ
u'ذِكْرٌ شَاهِدٌ':Added, #1: 1	ذِكْرَ الشَّاهِدِ
u'ذكر شِبَعٌ':Added, #1: 1	ذِكْرَ الشَّاهِدِ
u'ذِكْرٌ شِبَعٌ':Added, #1: 1	ذِكْرُ الشِّبَعِ
u'ذكر شِبْلٌ':Added, #1: 1	ذِكْرُ الشِّبَعِ
u'ذِكْرٌ شِبْلٌ':Added, #3: 3	ذِكْرِ شِبْلٍ
u'ذَكَرَ شَبَهٌ':Predicate, #3: 3	ذِكْرِ شِبْلٍ
u'ذَكَرَ شِبْهٌ':Predicate, #1: 1	ذَكَرَ شَبَهَ
u'ذكر شجَاعٌ':Added, #1: 1	ذَكَرَ شِبْهَ
u'ذِكْرٌ شجَاعٌ':Added, #1: 1	ذِكْرُ شَجَاعَةِ
u'ذكر شَجَاعَةٌ':Added, #1: 1	ذِكْرُ شَجَاعَةِ
u'ذِكْرٌ شَجَاعَةٌ':Added, #1: 1	ذِكْرُ شَجَاعَةِ
u'ذكر شَجَرٌ':Added, #1: 1	ذِكْرُ شَجَاعَةِ
u'ذِكْرٌ شَجَرٌ':Added, #1: 1	ذِكْرِ الشَّجَرِ
u'ذَكَرَ شَجَرَةٌ':Predicate, #1: 1	ذِكْرِ الشَّجَرِ
u'ذَكَرَ شِرَاءٌ':Predicate, #1: 1	ذَكَرَ شَجَرَةَ
u'ذكر شِرَاءٌ':Added, #2: 2	ذَكَرَ الشِّرَاءَ
u'ذِكْرٌ شِرَاءٌ':Added, #1: 1	ذِكْرَ الشِّرَاءِ
u'ذكر شِرَاءٌ':Added, #1: 1	ذِكْرَ الشِّرَاءِ
u'ذِكْرٌ شِرَاءٌ':Added, #1: 1	ذِكْرُ شِرَاءٍ
u'ذكر شِرَاءٌ':Added, #1: 1	ذِكْرُ شِرَاءٍ
u'ذِكْرٌ شِرَاءٌ':Added, #3: 3	ذِكْرِ الشِّرَاءِ
u'ذَكَرَ شَرَابٌ':Predicate, #3: 3	ذِكْرِ الشِّرَاءِ
u'ذَكَرَ شُرَّاحٌ':Subject, #1: 1	ذَكَرَ الشَّرَابَ
u'ذكر شَرَائِطُ':Added, #1: 1	ذَكَرَ شُرَّاحُ
u'ذِكْرٌ شَرَائِطُ':Added, #2: 2	ذِكْرِ الشَّرَائِطِ
u'ذكر شَرَائِعُ':Added, #2: 2	ذِكْرِ الشَّرَائِطِ
u'ذِكْرٌ شَرَائِعُ':Added, #1: 1	ذِكْرِ الشَّرَائِعِ
u'ذَكَرَ شرب':Predicate, #1: 1	ذِكْرِ الشَّرَائِعِ
u'ذَكَرَ شِرْبٌ':Predicate, #1: 1	ذَكَرَ الشِّرْبَ
u'ذَكَرَ شرب':Predicate, #1: 1	ذَكَرَ الشِّرْبَ
u'ذَكَرَ شُرْبٌ':Predicate, #2: 2	ذَكَرَ الشُّرْبَ
u'ذكر شرب':Added, #2: 2	ذَكَرَ الشُّرْبَ
u'ذكر شرب':Added, #1: 1	ذِكْرُ الشُّرْبِ
u'ذكر شرب':Added, #1: 1	ذِكْرِ الشُّرْبِ
u'ذِكْرٌ شرب':Added, #1: 1	ذِكْرِ الشِّرْبِ
u'ذِكْرٌ شرب':Added, #1: 1	ذِكْرُ الشُّرْبِ
u'ذِكْرٌ شرب':Added, #1: 1	ذِكْرِ الشُّرْبِ
u'ذكر شُرْبٌ':Added, #1: 1	ذِكْرِ الشِّرْبِ
u'ذكر شُرْبٌ':Added, #1: 1	ذِكْرُ الشُّرْبِ
u'ذكر شِرْبٌ':Added, #1: 1	ذِكْرِ الشُّرْبِ
u'ذِكْرٌ شُرْبٌ':Added, #1: 1	ذِكْرِ الشِّرْبِ
u'ذِكْرٌ شُرْبٌ':Added, #1: 1	ذِكْرُ الشُّرْبِ
u'ذِكْرٌ شِرْبٌ':Added, #1: 1	ذِكْرِ الشُّرْبِ
u'ذَكَرَ شَرْطٌ':Predicate, #1: 1	ذِكْرِ الشِّرْبِ
u'ذَكَرَ شَرْطٌ':Predicate, #2: 2	ذَكَرَ شَرْطَ
u'ذكر شَرْطٌ':Added, #4: 4	ذَكَرَ الشَّرْطَ
u'ذِكْرٌ شَرْطٌ':Added, #1: 1	ذِكْرِ الشَّرْطِ
u'ذكر شَرْطٌ':Added, #1: 1	ذِكْرِ الشَّرْطِ
u'ذكر شَرْطٌ':Added, #1: 1	ذِكْرُ شَرْطٍ
u'ذِكْرٌ شَرْطٌ':Added, #1: 1	ذِكْرِ شَرْطِ
u'ذِكْرٌ شَرْطٌ':Added, #1: 1	ذِكْرُ شَرْطٍ
u'ذكر شَرْطٌ':Added, #1: 1	ذِكْرِ شَرْطِ
u'ذِكْرٌ شَرْطٌ':Added, #1: 1	ذِكْرِ شَرْطِهِ
u'ذكر شَرْطٌ':Added, #1: 1	ذِكْرِ شَرْطِهِ
u'ذِكْرٌ شَرْطٌ':Added, #6: 6	ذِكْرُ الشَّرْطِ
u'ذكر شرف':Added, #6: 6	ذِكْرُ الشَّرْطِ
u'ذِكْرٌ شرف':Added, #1: 1	ذِكْرُ شَرَفِ
u'ذكر شَرَفٌ':Added, #1: 1	ذِكْرُ شَرَفِ
u'ذِكْرٌ شَرَفٌ':Added, #1: 1	ذِكْرُ شَرَفِ
u'ذَكَرَ شَرْقِيٌّ':Predicate, #1: 1	ذِكْرُ شَرَفِ
u'ذَكَرَ شركة':Predicate, #1: 1	ذَكَرَ الشَّرْقِيَّ
u'ذَكَرَ شَرِكَةٌ':Predicate, #1: 1	ذَكَرَ الشَّرِكَةَ
u'ذَكَرَ شُرُوطٌ':Predicate, #1: 1	ذَكَرَ الشَّرِكَةَ
u'ذكر شُرُوطٌ':Added, #1: 1	ذَكَرَ الشُّرُوطَ
u'ذِكْرٌ شُرُوطٌ':Added, #10: 10	ذِكْرُ شُرُوطِهِ
u'ذكر شُرُوطٌ':Added, #10: 10	ذِكْرُ شُرُوطِهِ
u'ذِكْرٌ شُرُوطٌ':Added, #1: 1	ذِكْرِ الشُّرُوطِ
u'ذكر شُرُوطٌ':Added, #1: 1	ذِكْرِ الشُّرُوطِ
u'ذكر شُرُوطٌ':Added, #1: 1	ذِكْرُ شُرُوطٍ
u'ذِكْرٌ شُرُوطٌ':Added, #1: 1	ذِكْرُ شُرُوطِ
u'ذِكْرٌ شُرُوطٌ':Added, #1: 1	ذِكْرُ شُرُوطٍ
u'ذكر شُرُوطٌ':Added, #1: 1	ذِكْرُ شُرُوطِ
u'ذكر شُرُوطٌ':Added, #1: 1	ذِكْرَ شُرُوطِهِ
u'ذِكْرٌ شُرُوطٌ':Added, #1: 1	ذِكْرِ شُرُوطِهِ
u'ذِكْرٌ شُرُوطٌ':Added, #1: 1	ذِكْرَ شُرُوطِهِ
u'ذكر شُرُوطٌ':Added, #1: 1	ذِكْرِ شُرُوطِهِ
u'ذِكْرٌ شُرُوطٌ':Added, #2: 2	ذِكْرُ الشُّرُوطِ
u'ذكر شُرُوطٌ':Added, #2: 2	ذِكْرُ الشُّرُوطِ
u'ذِكْرٌ شُرُوطٌ':Added, #3: 3	ذِكْرِ شُرُوطِ
u'ذَكَرَ شَطْرٌ':Predicate, #3: 3	ذِكْرِ شُرُوطِ
u'ذَكَرَ شَعْبِيٌّ':Subject, #2: 2	ذَكَرَ شَطْرَ
u'ذَكَرَ شِعْرٌ':Predicate, #1: 1	ذَكَرَ الشَّعْبِيُّ
u'ذَكَرَ شِعْرٌ':Predicate, #1: 1	ذَكَرَ الشِّعْرَ
u'ذكر شِعْرٌ':Added, #1: 1	ذَكَرَ شِعْرَ
u'ذِكْرٌ شِعْرٌ':Added, #1: 1	ذِكْرُ شِعْرِ
u'ذكر شَفَاعَةٌ':Added, #1: 1	ذِكْرُ شِعْرِ
u'ذِكْرٌ شَفَاعَةٌ':Added, #1: 1	ذِكْرُ الشَّفَاعَةِ
u'ذكر شَفْعٌ':Added, #1: 1	ذِكْرُ الشَّفَاعَةِ
u'ذِكْرٌ شَفْعٌ':Added, #1: 1	ذِكْرَ الشَّفْعِ
u'ذَكَرَ شَفِيف':Predicate, #1: 1	ذِكْرَ الشَّفْعِ
u'ذَكَرَ شمس':Subject, #1: 1	ذَكَرَ الشّفِيفَ
u'ذَكَرَ شَمْسٌ':Subject, #50: 50	ذَكَرَ شَمْسُ
u'ذكر شَهَادَةٌ':Added, #50: 50	ذَكَرَ شَمْسُ
u'ذِكْرٌ شَهَادَةٌ':Added, #1: 1	ذِكْرِ الشّهَادَةِ
u'ذكر شَهَادَةٌ':Added, #1: 1	ذِكْرِ الشّهَادَةِ
u'ذِكْرٌ شَهَادَةٌ':Added, #1: 1	ذِكْرِ شَهَادَةِ
u'ذَكَرَ شهداء':Predicate, #1: 1	ذِكْرِ شَهَادَةِ
u'ذكر شهداء':Added, #1: 1	ذَكَرَ الشّهَدَاءَ
u'ذكر شهداء':Added, #1: 1	ذِكْرُ الشُّهَدَاءِ
u'ذِكْرٌ شهداء':Added, #1: 1	ذِكْرِ الشُّهَدَاءِ
u'ذِكْرٌ شهداء':Added, #1: 1	ذِكْرُ الشُّهَدَاءِ
u'ذَكَرَ شَهْرٌ':Predicate, #1: 1	ذِكْرِ الشُّهَدَاءِ
u'ذكر شَهْرٌ':Added, #3: 3	ذَكَرَ الشَّهْرَ
u'ذِكْرٌ شَهْرٌ':Added, #1: 1	ذِكْرَ الشَّهْرِ
u'ذكر شَهْرٌ':Added, #1: 1	ذِكْرَ الشَّهْرِ
u'ذِكْرٌ شَهْرٌ':Added, #2: 2	ذِكْرِ الشَّهْرِ
u'ذكر شَهْرٌ':Added, #2: 2	ذِكْرِ الشَّهْرِ
u'ذِكْرٌ شَهْرٌ':Added, #3: 3	ذِكْرِ شَهْرٍ
u'ذَكَرَ شُهُودٌ':Subject, #3: 3	ذِكْرِ شَهْرٍ
u'ذَكَرَ شَهِيدٌ':Subject, #6: 6	ذَكَرَ الشُّهُودُ
u'ذَكَرَ شَوَّالٌ':Predicate, #1: 1	ذَكَرَ الشَّهِيدُ
u'ذكر شوَاهِدُ':Added, #1: 1	ذَكَرَ شَوَّالَ
u'ذكر شَوَاهِدُ':Added, #1: 1	ذِكْرِ شَوَاهِدِ
u'ذِكْرٌ شوَاهِدُ':Added, #1: 1	ذِكْرِ شَوَاهِدِ
u'ذِكْرٌ شَوَاهِدُ':Added, #1: 1	ذِكْرِ شَوَاهِدِ
u'ذكر شَيْءٌ':Added, #1: 1	ذِكْرِ شَوَاهِدِ
u'ذِكْرٌ شَيْءٌ':Added, #10: 10	ذِكْرِ شَيْءٍ
u'ذكر شَيْءٌ':Added, #10: 10	ذِكْرِ شَيْءٍ
u'ذِكْرٌ شَيْءٌ':Added, #1: 1	ذِكْرَ الشَّيْءِ
u'ذكر شَيْءٌ':Added, #1: 1	ذِكْرَ الشَّيْءِ
u'ذِكْرٌ شَيْءٌ':Added, #1: 1	ذِكْرَ شَيْءٍ
u'ذكر شَيْءٌ':Added, #1: 1	ذِكْرَ شَيْءٍ
u'ذِكْرٌ شَيْءٌ':Added, #2: 2	ذِكْرِ الشَّيْءِ
u'ذكر شَيْءٌ':Added, #2: 2	ذِكْرِ الشَّيْءِ
u'ذِكْرٌ شَيْءٌ':Added, #3: 3	ذِكْرُ شَيْءٍ
u'ذكر شَيْءٌ':Added, #3: 3	ذِكْرُ شَيْءٍ
u'ذِكْرٌ شَيْءٌ':Added, #5: 5	ذِكْرُ الشَّيْءِ
u'ذكر شِيَة':Added, #5: 5	ذِكْرُ الشَّيْءِ
u'ذِكْرٌ شِيَة':Added, #1: 1	ذِكْرُ الشِّيَاتِ
u'ذَكَرَ شِيحٌ':Subject, #1: 1	ذِكْرُ الشِّيَاتِ
u'ذَكَرَ شَيْخٌ':Subject, #1: 1	ذَكَرَ شِيحُ
u'ذَكَرَ شَيْخٌ':Subject, #81: 81	ذَكَرَ شَيْخُ
u'ذَكَرَ شِيرازِيّ':Subject, #89: 89	ذَكَرَ الشَّيْخُ
u'ذكر شَيْطَانٌ':Added, #1: 1	ذَكَرَ الشِّيرَازِيُّ
u'ذكر شَيْطَانٌ':Added, #1: 1	ذِكْرَ الشَّيْطَانِ
u'ذِكْرٌ شَيْطَانٌ':Added, #1: 1	ذِكْرِ الشَّيْطَانِ
u'ذِكْرٌ شَيْطَانٌ':Added, #1: 1	ذِكْرَ الشَّيْطَانِ
u'ذكر شِيعَةٌ':Added, #1: 1	ذِكْرِ الشَّيْطَانِ
u'ذِكْرٌ شِيعَةٌ':Added, #1: 1	ذِكْرُ الشِّيعَةِ
u'ذَكَرَ صَاحِبٌ':Subject, #1: 1	ذِكْرُ الشِّيعَةِ
u'ذَكَرَ صَاحِبٌ':Subject, #1: 1	ذَكَرَ صَاحِبُهُ
u'ذكر صَاحِبٌ':Added, #64: 64	ذَكَرَ صَاحِبُ
u'ذِكْرٌ صَاحِبٌ':Added, #1: 1	ذِكْرُ صَاحِبِ
u'ذكر صَاحِبٌ':Added, #1: 1	ذِكْرُ صَاحِبِ
u'ذِكْرٌ صَاحِبٌ':Added, #3: 3	ذِكْرِ صَاحِبِ
u'ذَكَرَ صَاعٌ':Predicate, #3: 3	ذِكْرِ صَاحِبِ
u'ذكر صَاعٌ':Added, #1: 1	ذَكَرَ الصَّاعَ
u'ذِكْرٌ صَاعٌ':Added, #1: 1	ذِكْرُ الصَّاعِ
u'ذكر صَاعٌ':Added, #1: 1	ذِكْرُ الصَّاعِ
u'ذِكْرٌ صَاعٌ':Added, #1: 1	ذِكْرُ صَاعٍ
u'ذكر صَاغَةٌ':Added, #1: 1	ذِكْرُ صَاعٍ
u'ذِكْرٌ صَاغَةٌ':Added, #1: 1	ذِكْرَ الصَّاغَةِ
u'ذَكَرَ صَالِحٌ':Subject, #1: 1	ذِكْرَ الصَّاغَةِ
u'ذَكَرَ صَالِح':Subject, #1: 1	ذَكَرَ صَالِحُ
u'ذكر صَائِمٌ':Added, #1: 1	ذَكَرَ صَالِحُ
u'ذِكْرٌ صَائِمٌ':Added, #1: 1	ذِكْرُ الصَّائِمِ
u'ذكر صَبٌّ':Added, #1: 1	ذِكْرُ الصَّائِمِ
u'ذِكْرٌ صَبٌّ':Added, #1: 1	ذِكْرُ الصَّبِّ
u'ذَكَرَ صُبْحٌ':Predicate, #1: 1	ذِكْرُ الصَّبِّ
u'ذكر صُبْحٌ':Added, #1: 1	ذَكَرَ الصُّبْحَ
u'ذِكْرٌ صُبْحٌ':Added, #1: 1	ذِكْرُ الصُّبْحِ
u'ذكر صبر':Added, #1: 1	ذِكْرُ الصُّبْحِ
u'ذِكْرٌ صبر':Added, #1: 1	ذِكْرُ الصَّبِرِ
u'ذكر صَبِرٌ':Added, #1: 1	ذِكْرُ الصَّبِرِ
u'ذِكْرٌ صَبِرٌ':Added, #1: 1	ذِكْرُ الصَّبِرِ
u'ذَكَرَ صَبِيٌّ':Predicate, #1: 1	ذِكْرُ الصَّبِرِ
u'ذَكَرَ صَبِيٌّ':Subject, #1: 1	ذَكَرَ الصَّبِيَّ
u'ذَكَرَ صَحَابَةٌ':Predicate, #1: 1	ذَكَرَ الصَّبِيُّ
u'ذكر صَحَابَةٌ':Added, #2: 2	ذَكَرَ الصَّحَابَةَ
u'ذِكْرٌ صَحَابَةٌ':Added, #1: 1	ذِكْرِ الصَّحَابَةِ
u'ذكر صَحَابَةٌ':Added, #1: 1	ذِكْرِ الصَّحَابَةِ
u'ذِكْرٌ صَحَابَةٌ':Added, #1: 1	ذِكْرِ صَحَابَةٍ
u'ذَكَرَ صِحَّةٌ':Predicate, #1: 1	ذِكْرِ صَحَابَةٍ
u'ذَكَرَ صِحَّةٌ':Predicate, #1: 1	ذَكَرَ الصِّحَّةَ
u'ذَكَرَ صِحَّةٌ':Subject, #2: 2	ذَكَرَ صِحَّةَ
u'ذكر صِحَّةٌ':Added, #1: 1	ذَكَرَ الصِّحَّةُ
u'ذِكْرٌ صِحَّةٌ':Added, #1: 1	ذِكْرُ صِحَّةِ
u'ذَكَرَ صَحِيحٌ':Predicate, #1: 1	ذِكْرُ صِحَّةِ
u'ذَكَرَ صداق':Predicate, #1: 1	ذَكَرَ الصَّحِيحَ
u'ذَكَرَ صَدَاقٌ':Predicate, #1: 1	ذَكَرَ الصَّدَاقَ
u'ذكر صداق':Added, #1: 1	ذَكَرَ الصَّدَاقَ
u'ذِكْرٌ صداق':Added, #1: 1	ذِكْر الصَّدَاقِ
u'ذكر صَدَاقٌ':Added, #1: 1	ذِكْر الصَّدَاقِ
u'ذِكْرٌ صَدَاقٌ':Added, #1: 1	ذِكْر الصَّدَاقِ
u'ذكر صداق':Added, #1: 1	ذِكْر الصَّدَاقِ
u'ذِكْرٌ صداق':Added, #5: 5	ذِكْرِ الصَّدَاقِ
u'ذكر صَدَاقٌ':Added, #5: 5	ذِكْرِ الصَّدَاقِ
u'ذِكْرٌ صَدَاقٌ':Added, #5: 5	ذِكْرِ الصَّدَاقِ
u'ذَكَرَ صَدْرٌ':Subject, #5: 5	ذِكْرِ الصَّدَاقِ
u'ذَكَرَ صَدْرٌ':Subject, #10: 10	ذَكَرَ صَدْرُ
u'ذَكَرَ صدقة':Predicate, #26: 26	ذَكَرَ الصَّدْرُ
u'ذَكَرَ صَدَقَةٌ':Predicate, #1: 1	ذَكَرَ الصَّدَقَةَ
u'ذكر صدقة':Added, #1: 1	ذَكَرَ الصَّدَقَةَ
u'ذِكْرٌ صدقة':Added, #1: 1	ذِكْرِ صَدَقَةٍ
u'ذكر صَدَقَةٌ':Added, #1: 1	ذِكْرِ صَدَقَةٍ
u'ذِكْرٌ صَدَقَةٌ':Added, #1: 1	ذِكْرِ صَدَقَةٍ
u'ذكر صدقة':Added, #1: 1	ذِكْرِ صَدَقَةٍ
u'ذِكْرٌ صدقة':Added, #5: 5	ذِكْرِ الصَّدَقَةِ
u'ذكر صَدَقَةٌ':Added, #5: 5	ذِكْرِ الصَّدَقَةِ
u'ذِكْرٌ صَدَقَةٌ':Added, #5: 5	ذِكْرِ الصَّدَقَةِ
u'ذَكَرَ صَرِيحٌ':Subject, #5: 5	ذِكْرِ الصَّدَقَةِ
u'ذكر صَرِيحٌ':Added, #1: 1	ذَكَرَ صَرِيحٌ
u'ذِكْرٌ صَرِيحٌ':Added, #1: 1	ذِكْرِ صَرِيحِ
u'ذكر صَرِيحٌ':Added, #1: 1	ذِكْرِ صَرِيحِ
u'ذِكْرٌ صَرِيحٌ':Added, #2: 2	ذِكْرِ الصَّرِيحِ
u'ذكر صُعُودٌ':Added, #2: 2	ذِكْرِ الصَّرِيحِ
u'ذِكْرٌ صُعُودٌ':Added, #1: 1	ذِكْرُ الصُّعُودِ
u'ذكر صَغِيرٌ':Added, #1: 1	ذِكْرُ الصُّعُودِ
u'ذِكْرٌ صَغِيرٌ':Added, #1: 1	ذِكْرِ الصَّغِيرِ
u'ذَكَرَ صِفَةٌ':Predicate, #1: 1	ذِكْرِ الصَّغِيرِ
u'ذَكَرَ صِفَةٌ':Predicate, #2: 2	ذَكَرَ الصِّفَةَ
u'ذكر صِفَةٌ':Added, #4: 4	ذَكَرَ صِفَةَ
u'ذِكْرٌ صِفَةٌ':Added, #11: 11	ذِكْرِ الصِّفَةِ
u'ذكر صِفَةٌ':Added, #11: 11	ذِكْرِ الصِّفَةِ
u'ذِكْرٌ صِفَةٌ':Added, #1: 1	ذِكْرُ الصِّفَاتِ
u'ذكر صِفَةٌ':Added, #1: 1	ذِكْرُ الصِّفَاتِ
u'ذِكْرٌ صِفَةٌ':Added, #1: 1	ذِكْرِ صِفَاتِ
u'ذكر صِفَةٌ':Added, #1: 1	ذِكْرِ صِفَاتِ
u'ذِكْرٌ صِفَةٌ':Added, #1: 1	ذِكْرِ صِفَاتِهِ
u'ذكر صِفَةٌ':Added, #1: 1	ذِكْرِ صِفَاتِهِ
u'ذِكْرٌ صِفَةٌ':Added, #1: 1	ذِكْرَ صِفَةِ
u'ذكر صِفَةٌ':Added, #1: 1	ذِكْرَ صِفَةِ
u'ذِكْرٌ صِفَةٌ':Added, #1: 1	ذِكْرُ صِفَتِهِ
u'ذكر صِفَةٌ':Added, #1: 1	ذِكْرُ صِفَتِهِ
u'ذِكْرٌ صِفَةٌ':Added, #2: 2	ذِكْرِ الصِّفَاتِ
u'ذكر صِفَةٌ':Added, #2: 2	ذِكْرِ الصِّفَاتِ
u'ذِكْرٌ صِفَةٌ':Added, #4: 4	ذِكْرُ الصِّفَةِ
u'ذكر صِفَةٌ':Added, #4: 4	ذِكْرُ الصِّفَةِ
u'ذِكْرٌ صِفَةٌ':Added, #5: 5	ذِكْرِ صِفَةِ
u'ذكر صَفْرَاء':Added, #5: 5	ذِكْرِ صِفَةِ
u'ذِكْرٌ صَفْرَاء':Added, #1: 1	ذِكْرُ الصّفْرَاءِ
u'ذَكَرَ صَفِيٌّ':Predicate, #1: 1	ذِكْرُ الصّفْرَاءِ
u'ذَكَرَ صَلاَةٌ':Predicate, #1: 1	ذَكَرَ صَفِيَّةَ
u'ذَكَرَ صَلاَةٌ':Predicate, #16: 16	ذَكَرَ صَلَاةَ
u'ذَكَرَ صَلاَةٌ':Predicate, #1: 1	ذَكَرَ الصَّلاَةَ
u'ذكر صَلاَةٌ':Added, #5: 5	ذَكَرَ الصَّلَاةَ
u'ذكر صَلاَةٌ':Added, #1: 1	ذِكْرُ الصَّلَاةِ
u'ذِكْرٌ صَلاَةٌ':Added, #1: 1	ذِكْرِ الصَّلاَةِ
u'ذِكْرٌ صَلاَةٌ':Added, #1: 1	ذِكْرُ الصَّلَاةِ
u'ذكر صَلاَةٌ':Added, #1: 1	ذِكْرِ الصَّلاَةِ
u'ذِكْرٌ صَلاَةٌ':Added, #1: 1	ذِكْرَ صَلاَةِ
u'ذكر صَلاَةٌ':Added, #1: 1	ذِكْرَ صَلاَةِ
u'ذِكْرٌ صَلاَةٌ':Added, #3: 3	ذِكْرَ الصَّلَاةِ
u'ذكر صَلاَةٌ':Added, #3: 3	ذِكْرَ الصَّلَاةِ
u'ذِكْرٌ صَلاَةٌ':Added, #3: 3	ذِكْرِ صَلَاةِ
u'ذكر صَلاَةٌ':Added, #3: 3	ذِكْرِ صَلَاةِ
u'ذِكْرٌ صَلاَةٌ':Added, #5: 5	ذِكْرِ الصَّلَاةِ
u'ذكر صِلَةٌ':Added, #5: 5	ذِكْرِ الصَّلَاةِ
u'ذكر صِلَةٌ':Added, #1: 1	ذِكْرَ الصِّلَةِ
u'ذِكْرٌ صِلَةٌ':Added, #1: 1	ذِكْرِ الصِّلَةِ
u'ذِكْرٌ صِلَةٌ':Added, #1: 1	ذِكْرَ الصِّلَةِ
u'ذكر صِلَةٌ':Added, #1: 1	ذِكْرِ الصِّلَةِ
u'ذِكْرٌ صِلَةٌ':Added, #1: 1	ذِكْرِ صِلَتِهِ
u'ذكر صلح':Added, #1: 1	ذِكْرِ صِلَتِهِ
u'ذكر صلح':Added, #1: 1	ذِكْرُ الصُّلْحِ
u'ذِكْرٌ صلح':Added, #1: 1	ذِكْرِ الصُّلْحِ
u'ذِكْرٌ صلح':Added, #1: 1	ذِكْرُ الصُّلْحِ
u'ذكر صُلْحٌ':Added, #1: 1	ذِكْرِ الصُّلْحِ
u'ذكر صُلْحٌ':Added, #1: 1	ذِكْرُ الصُّلْحِ
u'ذِكْرٌ صُلْحٌ':Added, #1: 1	ذِكْرِ الصُّلْحِ
u'ذِكْرٌ صُلْحٌ':Added, #1: 1	ذِكْرُ الصُّلْحِ
u'ذكر صُلْحٌ':Added, #1: 1	ذِكْرِ الصُّلْحِ
u'ذِكْرٌ صُلْحٌ':Added, #1: 1	ذِكْرِ صُلْحٍ
u'ذكر صَلَوَاتٌ':Added, #1: 1	ذِكْرِ صُلْحٍ
u'ذِكْرٌ صَلَوَاتٌ':Added, #1: 1	ذِكْرُ الصَّلَوَاتِ
u'ذكر صِمَاخٌ':Added, #1: 1	ذِكْرُ الصَّلَوَاتِ
u'ذِكْرٌ صِمَاخٌ':Added, #1: 1	ذِكْرُ الصِّمَاخَيْنِ
u'ذكر صِنَاعَةٌ':Added, #1: 1	ذِكْرُ الصِّمَاخَيْنِ
u'ذِكْرٌ صِنَاعَةٌ':Added, #1: 1	ذِكْرُ الصِّنَاعَةِ
u'ذكر صِنْفٌ':Added, #1: 1	ذِكْرُ الصِّنَاعَةِ
u'ذكر صِنْفٌ':Added, #1: 1	ذِكْرُ الصِّنْفِ
u'ذِكْرٌ صِنْفٌ':Added, #1: 1	ذِكْرِ الصِّنْفِ
u'ذِكْرٌ صِنْفٌ':Added, #1: 1	ذِكْرُ الصِّنْفِ
u'ذكر صِنْفٌ':Added, #1: 1	ذِكْرِ الصِّنْفِ
u'ذِكْرٌ صِنْفٌ':Added, #1: 1	ذِكْرُ الصِّنْفَيْنِ
u'ذَكَرَ صُورٌ':Predicate, #1: 1	ذِكْرُ الصِّنْفَيْنِ
u'ذَكَرَ صُوَرٌ':Predicate, #1: 1	ذَكَرَ الصُّوَرَ
u'ذَكَرَ صُورٌ':Predicate, #1: 1	ذَكَرَ الصُّوَرَ
u'ذَكَرَ صُوَرٌ':Predicate, #1: 1	ذَكَرَ صُوَرَ
u'ذكر صُورٌ':Added, #1: 1	ذَكَرَ صُوَرَ
u'ذكر صُوَرٌ':Added, #1: 1	ذِكْرِ الصُّوَرِ
u'ذِكْرٌ صُورٌ':Added, #1: 1	ذِكْرِ الصُّوَرِ
u'ذِكْرٌ صُوَرٌ':Added, #1: 1	ذِكْرِ الصُّوَرِ
u'ذكر صُورٌ':Added, #1: 1	ذِكْرِ الصُّوَرِ
u'ذكر صُوَرٌ':Added, #2: 2	ذِكْرُ صُوَرٍ
u'ذِكْرٌ صُورٌ':Added, #2: 2	ذِكْرُ صُوَرٍ
u'ذِكْرٌ صُوَرٌ':Added, #2: 2	ذِكْرُ صُوَرٍ
u'ذَكَرَ صُورَةٌ':Predicate, #2: 2	ذِكْرُ صُوَرٍ
u'ذَكَرَ صُورَةٌ':Predicate, #1: 1	ذَكَرَ الصُّورَةَ
u'ذكر صُورَةٌ':Added, #4: 4	ذَكَرَ صُورَةَ
u'ذِكْرٌ صُورَةٌ':Added, #1: 1	ذِكْرِ صُورَةِ
u'ذكر صُوفٌ':Added, #1: 1	ذِكْرِ صُورَةِ
u'ذكر صُوفٌ':Added, #1: 1	ذِكْرُ الصُّوفِ
u'ذِكْرٌ صُوفٌ':Added, #1: 1	ذِكْرِ الصُّوفِ
u'ذِكْرٌ صُوفٌ':Added, #1: 1	ذِكْرُ الصُّوفِ
u'ذكر صَوْمٌ':Added, #1: 1	ذِكْرِ الصُّوفِ
u'ذِكْرٌ صَوْمٌ':Added, #1: 1	ذِكْرِ صَوْمِ
u'ذكر صَوْمٌ':Added, #1: 1	ذِكْرِ صَوْمِ
u'ذِكْرٌ صَوْمٌ':Added, #3: 3	ذِكْرِ الصَّوْمِ
u'ذكر صَوْمٌ':Added, #3: 3	ذِكْرِ الصَّوْمِ
u'ذِكْرٌ صَوْمٌ':Added, #5: 5	ذِكْرُ الصَّوْمِ
u'ذَكَرَ صِيَامٌ':Predicate, #5: 5	ذِكْرُ الصَّوْمِ
u'ذَكَرَ صَيْدٌ':Predicate, #1: 1	ذَكَرَ الصِّيَامَ
u'ذَكَرَ صَيْدَلانِيّ':Subject, #1: 1	ذَكَرَ صَيْدَ
u'ذَكَرَ صَيْرَفِيٌّ':Subject, #1: 1	ذَكَرَ الصَّيْدَلَانِيُّ
u'ذَكَرَ صِيَغٌ':Predicate, #1: 1	ذَكَرَ الصَّيْرَفِيُّ
u'ذَكَرَ ضَابِطٌ':Predicate, #1: 1	ذَكَرَ صِيَغَ
u'ذَكَرَ ضَابِطٌ':Predicate, #1: 1	ذَكَرَ الضَّابِطَ
u'ذكر ضَابِطٌ':Added, #1: 1	ذَكَرَ ضَابِطَ
u'ذِكْرٌ ضَابِطٌ':Added, #1: 1	ذِكْرِ الضَّابِطِ
u'ذكر ضَابِطٌ':Added, #1: 1	ذِكْرِ الضَّابِطِ
u'ذِكْرٌ ضَابِطٌ':Added, #1: 1	ذِكْرِ ضَابِطٍ
u'ذكر ضَرْبٌ':Added, #1: 1	ذِكْرِ ضَابِطٍ
u'ذِكْرٌ ضَرْبٌ':Added, #1: 1	ذِكْرُ الضَّرْبِ
u'ذكر ضَرْبٌ':Added, #1: 1	ذِكْرُ الضَّرْبِ
u'ذِكْرٌ ضَرْبٌ':Added, #1: 1	ذِكْرِ ضَرْبِ
u'ذكر ضَعِيفٌ':Added, #1: 1	ذِكْرِ ضَرْبِ
u'ذِكْرٌ ضَعِيفٌ':Added, #1: 1	ذِكْرِ الضَّعِيفِ
u'ذَكَرَ ضَمَانٌ':Predicate, #1: 1	ذِكْرِ الضَّعِيفِ
u'ذَكَرَ ضَمِيرٌ':Predicate, #2: 2	ذَكَرَ الضَّمَانَ
u'ذَكَرَ ضَمِيرٌ':Predicate, #1: 1	ذَكَرَ ضَمِيرَ
u'ذَكَّرَ ضَمِيرٌ':Predicate, #3: 3	ذَكَرَ الضَّمِيرَ
u'ذكر طَاعَةٌ':Added, #4: 4	ذَكَّرَ الضَّمِيرَ
u'ذِكْرٌ طَاعَةٌ':Added, #1: 1	ذِكْرِ الطَّاعَةِ
u'ذكر طَالِقٌ':Added, #1: 1	ذِكْرِ الطَّاعَةِ
u'ذِكْرٌ طَالِقٌ':Added, #3: 3	ذِكْرَ الطَّالِقِ
u'ذَكَرَ طَائِفٌ':Subject, #3: 3	ذِكْرَ الطَّالِقِ
u'ذكر طَائِفٌ':Added, #1: 1	ذَكَرَ طَائِفَةٌ
u'ذِكْرٌ طَائِفٌ':Added, #1: 1	ذِكْرُ الطَّائِفِ
u'ذَكَرَ طَبَرِيّ':Subject, #1: 1	ذِكْرُ الطَّائِفِ
u'ذَكَرَ طِبْقٌ':Predicate, #2: 2	ذَكَرَ الطَّبَرِيُّ
u'ذَكَرَ طَبِيبٌ':Subject, #1: 1	ذَكَرَ طِبْقَ
u'ذَكَرَ طَرِيقٌ':Predicate, #1: 1	ذَكَرَ طَبِيبٌ
u'ذكر طَرِيقٌ':Added, #1: 1	ذَكَرَ طَرِيقَ
u'ذِكْرٌ طَرِيقٌ':Added, #5: 5	ذِكْرِ الطَّرِيقِ
u'ذَكَرَ طَرِيقَةٌ':Predicate, #5: 5	ذِكْرِ الطَّرِيقِ
u'ذكر طَسْت':Added, #1: 1	ذَكَرَ طَرِيقَةَ
u'ذِكْرٌ طَسْت':Added, #1: 1	ذِكْرِ الطّسْتِ
u'ذَكَرَ طعام':Predicate, #1: 1	ذِكْرِ الطّسْتِ
u'ذَكَرَ طَعَامٌ':Predicate, #3: 3	ذَكَرَ الطَّعَامَ
u'ذكر طعام':Added, #3: 3	ذَكَرَ الطَّعَامَ
u'ذِكْرٌ طعام':Added, #1: 1	ذِكْرَ الطَّعَامِ
u'ذكر طَعَامٌ':Added, #1: 1	ذِكْرَ الطَّعَامِ
u'ذِكْرٌ طَعَامٌ':Added, #1: 1	ذِكْرَ الطَّعَامِ
u'ذكر طعام':Added, #1: 1	ذِكْرَ الطَّعَامِ
u'ذِكْرٌ طعام':Added, #4: 4	ذِكْرِ الطَّعَامِ
u'ذكر طَعَامٌ':Added, #4: 4	ذِكْرِ الطَّعَامِ
u'ذِكْرٌ طَعَامٌ':Added, #4: 4	ذِكْرِ الطَّعَامِ
u'ذَكَرَ طِفْلٌ':Predicate, #4: 4	ذِكْرِ الطَّعَامِ
u'ذَكَرَ طَلاَقٌ':Predicate, #1: 1	ذَكَرَ الطِّفْلَ
u'ذَكَرَ طَلاَقٌ':Predicate, #1: 1	ذَكَرَ طَلَاقَ
u'ذكر طَلاَقٌ':Added, #3: 3	ذَكَرَ الطَّلَاقَ
u'ذِكْرٌ طَلاَقٌ':Added, #10: 10	ذِكْرِ الطَّلَاقِ
u'ذكر طَلاَقٌ':Added, #10: 10	ذِكْرِ الطَّلَاقِ
u'ذِكْرٌ طَلاَقٌ':Added, #5: 5	ذِكْرَ الطَّلَاقِ
u'ذكر طَلاَقٌ':Added, #5: 5	ذِكْرَ الطَّلَاقِ
u'ذِكْرٌ طَلاَقٌ':Added, #9: 9	ذِكْرُ الطَّلَاقِ
u'ذكر طلب':Added, #9: 9	ذِكْرُ الطَّلَاقِ
u'ذِكْرٌ طلب':Added, #1: 1	ذِكْرُ الطَّلَبِ
u'ذكر طَلَبٌ':Added, #1: 1	ذِكْرُ الطَّلَبِ
u'ذِكْرٌ طَلَبٌ':Added, #1: 1	ذِكْرُ الطَّلَبِ
u'ذكر طلب':Added, #1: 1	ذِكْرُ الطَّلَبِ
u'ذِكْرٌ طلب':Added, #1: 1	ذِكْرِ طَلَبِ
u'ذكر طَلَبٌ':Added, #1: 1	ذِكْرِ طَلَبِ
u'ذِكْرٌ طَلَبٌ':Added, #1: 1	ذِكْرِ طَلَبِ
u'ذكر طَلْعٌ':Added, #1: 1	ذِكْرِ طَلَبِ
u'ذِكْرٌ طَلْعٌ':Added, #1: 1	ذِكْرُ الطَّلْعِ
u'ذكر طُمَأْنِينَةٌ':Added, #1: 1	ذِكْرُ الطَّلْعِ
u'ذِكْرٌ طُمَأْنِينَةٌ':Added, #2: 2	ذِكْرَ الطُّمَأْنِينَةِ
u'ذكر طَهَارَةٌ':Added, #2: 2	ذِكْرَ الطُّمَأْنِينَةِ
u'ذِكْرٌ طَهَارَةٌ':Added, #1: 1	ذِكْرِ الطَّهَارَةِ
u'ذكر طَهَارَةٌ':Added, #1: 1	ذِكْرِ الطَّهَارَةِ
u'ذِكْرٌ طَهَارَةٌ':Added, #1: 1	ذِكْرِ طَهَارَةِ
u'ذكر طَوَاعِيَةٌ':Added, #1: 1	ذِكْرِ طَهَارَةِ
u'ذِكْرٌ طَوَاعِيَةٌ':Added, #2: 2	ذِكْرِ الطَّوَاعِيَةِ
u'ذَكَرَ طواف':Predicate, #2: 2	ذِكْرِ الطَّوَاعِيَةِ
u'ذَكَرَ طَوَافٌ':Predicate, #2: 2	ذَكَرَ الطَّوَافَ
u'ذكر طواف':Added, #2: 2	ذَكَرَ الطَّوَافَ
u'ذكر طواف':Added, #2: 2	ذِكْرُ الطَّوَافِ
u'ذِكْرٌ طواف':Added, #2: 2	ذِكْرِ الطَّوَافِ
u'ذِكْرٌ طواف':Added, #2: 2	ذِكْرُ الطَّوَافِ
u'ذكر طَوَافٌ':Added, #2: 2	ذِكْرِ الطَّوَافِ
u'ذكر طَوَافٌ':Added, #2: 2	ذِكْرُ الطَّوَافِ
u'ذِكْرٌ طَوَافٌ':Added, #2: 2	ذِكْرِ الطَّوَافِ
u'ذِكْرٌ طَوَافٌ':Added, #2: 2	ذِكْرُ الطَّوَافِ
u'ذَكَرَ طُولٌ':Predicate, #2: 2	ذِكْرِ الطَّوَافِ
u'ذكر طُولٌ':Added, #2: 2	ذَكَرَ طُولَ
u'ذِكْرٌ طُولٌ':Added, #1: 1	ذِكْرُ الطُّولِ
u'ذكر طُولٌ':Added, #1: 1	ذِكْرُ الطُّولِ
u'ذِكْرٌ طُولٌ':Added, #1: 1	ذِكْرُ طُولِ
u'ذكر طُولٌ':Added, #1: 1	ذِكْرُ طُولِ
u'ذِكْرٌ طُولٌ':Added, #1: 1	ذِكْرَ طُولِهِ
u'ذَكَرَ طِيبٌ':Predicate, #1: 1	ذِكْرَ طُولِهِ
u'ذكر طَيِّبٌ':Added, #1: 1	ذَكَرَ الطِّيبَ
u'ذِكْرٌ طَيِّبٌ':Added, #1: 1	ذِكْرُ الطَّيِّبِ
u'ذَكَرَ طَيْرٌ':Predicate, #1: 1	ذِكْرُ الطَّيِّبِ
u'ذكر طَيْرٌ':Added, #1: 1	ذَكَرَ الطَّيْرَ
u'ذِكْرٌ طَيْرٌ':Added, #1: 1	ذِكْرِ الطَّيْرِ
u'ذَكَرَ ظاهِرٌ':Subject, #1: 1	ذِكْرِ الطَّيْرِ
u'ذَكَرَ ظُهْرٌ':Predicate, #1: 1	ذَكَرَ ظَاهِرٌ
u'ذَكَرَ ظَهْرٌ':Predicate, #1: 1	ذَكَرَ الظُّهْرَ
u'ذكر ظَهْرٌ':Added, #2: 2	ذَكَرَ الظَّهْرَ
u'ذِكْرٌ ظَهْرٌ':Added, #1: 1	ذِكْرِ الظَّهْرِ
u'ذَكَرَ ظَهيرٌ':Subject, #1: 1	ذِكْرِ الظَّهْرِ
u'ذَكَرَ عَارِفٌ':Subject, #2: 2	ذَكَرَ ظَهِيرُ
u'ذكر عَاشِرٌ':Added, #1: 1	ذَكَرَ الْعَارِفُ
u'ذِكْرٌ عَاشِرٌ':Added, #1: 1	ذِكْرِ الْعَاشِرِ
u'ذَكَرَ عَامٌّ':Predicate, #1: 1	ذِكْرِ الْعَاشِرِ
u'ذَكَرَ عَامٌّ':Subject, #1: 1	ذَكَرَ الْعَامَّ
u'ذكر عَامٌّ':Added, #1: 1	ذَكَرَ عَامَّةُ
u'ذِكْرٌ عَامٌّ':Added, #1: 1	ذِكْرُ الْعَامِّ
u'ذكر عَامٌّ':Added, #1: 1	ذِكْرُ الْعَامِّ
u'ذِكْرٌ عَامٌّ':Added, #4: 4	ذِكْرِ الْعَامِّ
u'ذكر عَامِرٌ':Added, #4: 4	ذِكْرِ الْعَامِّ
u'ذِكْرٌ عَامِرٌ':Added, #2: 2	ذِكْرِ عَامِرِ
u'ذَكَرَ عَائِشٌ':Predicate, #2: 2	ذِكْرِ عَامِرِ
u'ذَكَرَ عُبَابٌ':Subject, #2: 2	ذَكَرَ عَائِشَةَ
u'ذكر عِبَادَةٌ':Added, #1: 1	ذَكَرَ الْعُبَابُ
u'ذِكْرٌ عِبَادَةٌ':Added, #1: 1	ذِكْرَ الْعِبَادَاتِ
u'ذكر عِبَادَةٌ':Added, #1: 1	ذِكْرَ الْعِبَادَاتِ
u'ذِكْرٌ عِبَادَةٌ':Added, #1: 1	ذِكْرَ الْعِبَادَةِ
u'ذَكَرَ عِبَارَةٌ':Predicate, #1: 1	ذِكْرَ الْعِبَادَةِ
u'ذَكَرَ عِبَارَةٌ':Predicate, #11: 11	ذَكَرَ عِبَارَةَ
u'ذكر عِبَارَةٌ':Added, #3: 3	ذَكَرَ الْعِبَارَةَ
u'ذِكْرٌ عِبَارَةٌ':Added, #1: 1	ذِكْرَ عِبَارَتِهِ
u'ذكر عَبَّاسٌ':Added, #1: 1	ذِكْرَ عِبَارَتِهِ
u'ذِكْرٌ عَبَّاسٌ':Added, #2: 2	ذِكْرِ الْعَبَّاسِ
u'ذَكَرَ عَبْدٌ':Predicate, #2: 2	ذِكْرِ الْعَبَّاسِ
u'ذَكَرَ عَبْدٌ':Predicate, #11: 11	ذَكَرَ عَبْدَ
u'ذَكَرَ عَبْدٌ':Subject, #3: 3	ذَكَرَ الْعَبْدَ
u'ذَكَرَ عَبْدٌ':Subject, #10: 10	ذَكَرَ عَبْدُ
u'ذكر عَبْدٌ':Added, #1: 1	ذَكَرَ الْعَبْدُ
u'ذِكْرٌ عَبْدٌ':Added, #1: 1	ذِكْرَ الْعَبْدِ
u'ذكر عَبْدٌ':Added, #1: 1	ذِكْرَ الْعَبْدِ
u'ذِكْرٌ عَبْدٌ':Added, #1: 1	ذِكْرِ عَبْدِهِ
u'ذكر عَبْدٌ':Added, #1: 1	ذِكْرِ عَبْدِهِ
u'ذِكْرٌ عَبْدٌ':Added, #2: 2	ذِكْرِ عَبْدِ
u'ذكر عَبْدٌ':Added, #2: 2	ذِكْرِ عَبْدِ
u'ذِكْرٌ عَبْدٌ':Added, #4: 4	ذِكْرُ عَبْدِ
u'ذَكَرَ عتاق':Predicate, #4: 4	ذِكْرُ عَبْدِ
u'ذَكَرَ عتق':Predicate, #1: 1	ذَكَرَ الْعَتَاقَ
u'ذَكَرَ عِتْقٌ':Predicate, #3: 3	ذَكَرَ الْعِتْقَ
u'ذكر عتق':Added, #3: 3	ذَكَرَ الْعِتْقَ
u'ذِكْرٌ عتق':Added, #1: 1	ذِكْرَ الْعِتْقِ
u'ذكر عِتْقٌ':Added, #1: 1	ذِكْرَ الْعِتْقِ
u'ذِكْرٌ عِتْقٌ':Added, #1: 1	ذِكْرَ الْعِتْقِ
u'ذكر عَتِيقٌ':Added, #1: 1	ذِكْرَ الْعِتْقِ
u'ذِكْرٌ عَتِيقٌ':Added, #1: 1	ذِكْرِ الْعَتِيقِ
u'ذكر عجز':Added, #1: 1	ذِكْرِ الْعَتِيقِ
u'ذِكْرٌ عجز':Added, #1: 1	ذِكْرِ الْعَجْزِ
u'ذكر عَجْزٌ':Added, #1: 1	ذِكْرِ الْعَجْزِ
u'ذِكْرٌ عَجْزٌ':Added, #1: 1	ذِكْرِ الْعَجْزِ
u'ذكر عَدٌّ':Added, #1: 1	ذِكْرِ الْعَجْزِ
u'ذِكْرٌ عَدٌّ':Added, #1: 1	ذِكْرُ الْعَدِّ
u'ذَكَرَ عَدَالَةٌ':Predicate, #1: 1	ذِكْرُ الْعَدِّ
u'ذكر عَدَالَةٌ':Added, #1: 1	ذَكَرَ الْعَدَالَةَ
u'ذكر عَدَالَةٌ':Added, #1: 1	ذِكْرَ الْعَدَالَةِ
u'ذكر عَدَالَةٌ':Added, #1: 1	ذِكْرُ الْعَدَالَةِ
u'ذِكْرٌ عَدَالَةٌ':Added, #1: 1	ذِكْرِ الْعَدَالَةِ
u'ذِكْرٌ عَدَالَةٌ':Added, #1: 1	ذِكْرَ الْعَدَالَةِ
u'ذِكْرٌ عَدَالَةٌ':Added, #1: 1	ذِكْرُ الْعَدَالَةِ
u'ذَكَرَ عَدَدٌ':Predicate, #1: 1	ذِكْرِ الْعَدَالَةِ
u'ذَكَرَ عَدَدٌ':Predicate, #2: 2	ذَكَرَ عَدَدَ
u'ذكر عَدَدٌ':Added, #4: 4	ذَكَرَ الْعَدَدَ
u'ذِكْرٌ عَدَدٌ':Added, #13: 13	ذِكْرِ الْعَدَدِ
u'ذكر عَدَدٌ':Added, #13: 13	ذِكْرِ الْعَدَدِ
u'ذكر عَدَدٌ':Added, #1: 1	ذِكْرِ عَدَدٍ
u'ذِكْرٌ عَدَدٌ':Added, #1: 1	ذِكْرِ عَدَدِ
u'ذِكْرٌ عَدَدٌ':Added, #1: 1	ذِكْرِ عَدَدٍ
u'ذكر عَدَدٌ':Added, #1: 1	ذِكْرِ عَدَدِ
u'ذِكْرٌ عَدَدٌ':Added, #4: 4	ذِكْرُ الْعَدَدِ
u'ذكر عَدَدٌ':Added, #4: 4	ذِكْرُ الْعَدَدِ
u'ذِكْرٌ عَدَدٌ':Added, #6: 6	ذِكْرَ الْعَدَدِ
u'ذَكَرَ عَدْلٌ':Subject, #6: 6	ذِكْرَ الْعَدَدِ
u'ذَكَرَ عَدَمٌ':Predicate, #1: 1	ذَكَرَ الْعَدْلُ
u'ذَكَرَ عَدَمٌ':Subject, #6: 6	ذَكَرَ عَدَمَ
u'ذكر عَدَمٌ':Added, #4: 4	ذَكَرَ عَدَمُ
u'ذِكْرٌ عَدَمٌ':Added, #1: 1	ذِكْرُ عَدَمِ
u'ذكر عَدَمٌ':Added, #1: 1	ذِكْرُ عَدَمِ
u'ذِكْرٌ عَدَمٌ':Added, #3: 3	ذِكْرِ عَدَمِ
u'ذكر عَدُوٌّ':Added, #3: 3	ذِكْرِ عَدَمِ
u'ذِكْرٌ عَدُوٌّ':Added, #1: 1	ذِكْرُ الْعَدُوِّ
u'ذكر عُدْوَانٌ':Added, #1: 1	ذِكْرُ الْعَدُوِّ
u'ذِكْرٌ عُدْوَانٌ':Added, #1: 1	ذِكْرُ عُدْوَانِ
u'ذكر عُذْرٌ':Added, #1: 1	ذِكْرُ عُدْوَانِ
u'ذِكْرٌ عُذْرٌ':Added, #1: 1	ذِكْرِ الْعُذْرِ
u'ذكر عَذِرَةٌ':Added, #1: 1	ذِكْرِ الْعُذْرِ
u'ذِكْرٌ عَذِرَةٌ':Added, #1: 1	ذِكْرِ الْعَذِرَةِ
u'ذكر عَرَبٌ':Added, #1: 1	ذِكْرِ الْعَذِرَةِ
u'ذِكْرٌ عَرَبٌ':Added, #1: 1	ذِكْرُ الْعَرَبِ
u'ذكر عَرَضٌ':Added, #1: 1	ذِكْرُ الْعَرَبِ
u'ذِكْرٌ عَرَضٌ':Added, #1: 1	ذِكْرِ الْعَرَضِ
u'ذَكَرَ عِزٌّ':Subject, #1: 1	ذِكْرِ الْعَرَضِ
u'ذكر عزلة':Added, #1: 1	ذَكَرَ عِزُّ
u'ذِكْرٌ عزلة':Added, #1: 1	ذِكْرِ الْعُزْلَةِ
u'ذكر عُزْلَةٌ':Added, #1: 1	ذِكْرِ الْعُزْلَةِ
u'ذِكْرٌ عُزْلَةٌ':Added, #1: 1	ذِكْرِ الْعُزْلَةِ
u'ذكر عسر':Added, #1: 1	ذِكْرِ الْعُزْلَةِ
u'ذِكْرٌ عسر':Added, #1: 1	ذِكْرُ عُسْرِ
u'ذكر عُسْرٌ':Added, #1: 1	ذِكْرُ عُسْرِ
u'ذِكْرٌ عُسْرٌ':Added, #1: 1	ذِكْرُ عُسْرِ
u'ذَكَرَ عِشَاءٌ':Predicate, #1: 1	ذِكْرُ عُسْرِ
u'ذكر عِشَاءٌ':Added, #1: 1	ذَكَرَ الْعِشَاءَ
u'ذِكْرٌ عِشَاءٌ':Added, #1: 1	ذِكْرُ الْعِشَاءِ
u'ذَكَرَ عَشْرٌ':Predicate, #1: 1	ذِكْرُ الْعِشَاءِ
u'ذَكَرَ عُشْرٌ':Predicate, #1: 1	ذَكَرَ الْعَشْرَ
u'ذَكَرَ عَشْرٌ':Predicate, #1: 1	ذَكَرَ الْعُشْرَ
u'ذَكَرَ عِصَامٌ':Subject, #1: 1	ذَكَرَ عَشْرَ
u'ذكر عَصَبَةٌ':Added, #2: 2	ذَكَرَ عِصَامٌ
u'ذِكْرٌ عَصَبَةٌ':Added, #2: 2	ذِكْرِ الْعَصَبَاتِ
u'ذكر عَصْرٌ':Added, #2: 2	ذِكْرِ الْعَصَبَاتِ
u'ذكر عَصْرٌ':Added, #1: 1	ذِكْرُ الْعَصْرِ
u'ذِكْرٌ عَصْرٌ':Added, #1: 1	ذِكْرِ الْعَصْرِ
u'ذِكْرٌ عَصْرٌ':Added, #1: 1	ذِكْرُ الْعَصْرِ
u'ذَكَرَ عَضُدٌ':Subject, #1: 1	ذِكْرِ الْعَصْرِ
u'ذكر عُضْوٌ':Added, #5: 5	ذَكَرَ عَضُدُ
u'ذِكْرٌ عُضْوٌ':Added, #1: 1	ذِكْرِ الْعُضْوِ
u'ذَكَرَ عَطَاءٌ':Subject, #1: 1	ذِكْرِ الْعُضْوِ
u'ذكر عَطَاءٌ':Added, #1: 1	ذَكَرَ عَطَاءٌ
u'ذِكْرٌ عَطَاءٌ':Added, #1: 1	ذِكْرَ الْعَطَاءِ
u'ذكر عَطَاءٌ':Added, #1: 1	ذِكْرَ الْعَطَاءِ
u'ذِكْرٌ عَطَاءٌ':Added, #1: 1	ذِكْرِ عَطَاءٍ
u'ذَكَرَ عِظَمٌ':Predicate, #1: 1	ذِكْرِ عَطَاءٍ
u'ذكر عَظْمٌ':Added, #6: 6	ذَكَرَ الْعِظَمَ
u'ذكر عِظَمٌ':Added, #1: 1	ذِكْرِ الْعَظْمِ
u'ذكر عِظَمٌ':Added, #1: 1	ذِكْرَ الْعِظَمِ
u'ذِكْرٌ عَظْمٌ':Added, #1: 1	ذِكْرُ الْعِظَمِ
u'ذِكْرٌ عِظَمٌ':Added, #1: 1	ذِكْرِ الْعَظْمِ
u'ذِكْرٌ عِظَمٌ':Added, #1: 1	ذِكْرَ الْعِظَمِ
u'ذَكَرَ عَقِبٌ':Predicate, #1: 1	ذِكْرُ الْعِظَمِ
u'ذكر عَقِبٌ':Added, #2: 2	ذَكَرَ عَقِبَ
u'ذِكْرٌ عَقِبٌ':Added, #1: 1	ذِكْرُ الْعَقِبِ
u'ذكر عقبة':Added, #1: 1	ذِكْرُ الْعَقِبِ
u'ذِكْرٌ عقبة':Added, #1: 1	ذِكْرِ الْعَقَبَةِ
u'ذكر عَقَبَةٌ':Added, #1: 1	ذِكْرِ الْعَقَبَةِ
u'ذِكْرٌ عَقَبَةٌ':Added, #1: 1	ذِكْرِ الْعَقَبَةِ
u'ذكر عَقْدٌ':Added, #1: 1	ذِكْرِ الْعَقَبَةِ
u'ذِكْرٌ عَقْدٌ':Added, #1: 1	ذِكْرُ الْعَقْدِ
u'ذكر عَقْدٌ':Added, #1: 1	ذِكْرُ الْعَقْدِ
u'ذِكْرٌ عَقْدٌ':Added, #1: 1	ذِكْرِ عَقْدٍ
u'ذكر عَقْدٌ':Added, #1: 1	ذِكْرِ عَقْدٍ
u'ذِكْرٌ عَقْدٌ':Added, #2: 2	ذِكْرِ الْعَقْدِ
u'ذكر عقر':Added, #2: 2	ذِكْرِ الْعَقْدِ
u'ذِكْرٌ عقر':Added, #1: 1	ذِكْرِ الْعَقْرِ
u'ذَكَرَ عَقْلٌ':Predicate, #1: 1	ذِكْرِ الْعَقْرِ
u'ذكر عُقُولٌ':Added, #1: 1	ذَكَرَ عَقْلَ
u'ذِكْرٌ عُقُولٌ':Added, #1: 1	ذِكْرُ الْعُقُولِ
u'ذَكَرَ عَقِيبٌ':Predicate, #1: 1	ذِكْرُ الْعُقُولِ
u'ذَكَرَ عِلاَجٌ':Predicate, #3: 3	ذَكَرَ عَقِيبَ
u'ذَكَرَ عِلَّةٌ':Predicate, #1: 1	ذَكَرَ عِلَاجَ
u'ذكر عِلَّةٌ':Added, #4: 4	ذَكَرَ عِلَّةَ
u'ذِكْرٌ عِلَّةٌ':Added, #1: 1	ذِكْرَ الْعِلَّةِ
u'ذكر عِلَّةٌ':Added, #1: 1	ذِكْرَ الْعِلَّةِ
u'ذِكْرٌ عِلَّةٌ':Added, #1: 1	ذِكْرَ عِلَّتِهِ
u'ذكر عِلَّةٌ':Added, #1: 1	ذِكْرَ عِلَّتِهِ
u'ذِكْرٌ عِلَّةٌ':Added, #2: 2	ذِكْرُ الْعِلَّةِ
u'ذكر عِلَّةٌ':Added, #2: 2	ذِكْرُ الْعِلَّةِ
u'ذِكْرٌ عِلَّةٌ':Added, #4: 4	ذِكْرِ الْعِلَّةِ
u'ذَكَرَ عَلَفٌ':Predicate, #4: 4	ذِكْرِ الْعِلَّةِ
u'ذَكَرَ علم':Predicate, #1: 1	ذَكَرَ الْعَلَفَ
u'ذكر علم':Added, #2: 2	ذَكَرَ عُلِمَ
u'ذِكْرٌ علم':Added, #1: 1	ذِكْرِ الْعَلَمِ
u'ذكر عَلَمٌ':Added, #1: 1	ذِكْرِ الْعَلَمِ
u'ذِكْرٌ عَلَمٌ':Added, #1: 1	ذِكْرِ الْعَلَمِ
u'ذكر علم':Added, #1: 1	ذِكْرِ الْعَلَمِ
u'ذِكْرٌ علم':Added, #2: 2	ذِكْرِ الْعِلْمِ
u'ذكر عِلْمٌ':Added, #2: 2	ذِكْرِ الْعِلْمِ
u'ذِكْرٌ عِلْمٌ':Added, #2: 2	ذِكْرِ الْعِلْمِ
u'ذَكَرَ علماء':Subject, #2: 2	ذِكْرِ الْعِلْمِ
u'ذَكَرَ عُلَمَاءُ':Subject, #1: 1	ذَكَرَ عُلَمَاءُ
u'ذَكَرَ علماء':Subject, #1: 1	ذَكَرَ عُلَمَاءُ
u'ذَكَرَ عُلَمَاءُ':Subject, #7: 7	ذَكَرَ الْعُلَمَاءُ
u'ذكر علماء':Added, #7: 7	ذَكَرَ الْعُلَمَاءُ
u'ذِكْرٌ علماء':Added, #1: 1	ذِكْرَ الْعُلَمَاءِ
u'ذكر عُلَمَاءُ':Added, #1: 1	ذِكْرَ الْعُلَمَاءِ
u'ذِكْرٌ عُلَمَاءُ':Added, #1: 1	ذِكْرَ الْعُلَمَاءِ
u'ذَكَرَ عُلُومٌ':Predicate, #1: 1	ذِكْرَ الْعُلَمَاءِ
u'ذَكَرَ عَلِيٌّ':Subject, #1: 1	ذَكَرَ الْعُلُومَ
u'ذَكَرَ عَلِيٌّ':Subject, #1: 1	ذَكَرَ عَلِيٌّ
u'ذَكَرَ عَمٌّ':Predicate, #4: 4	ذَكَرَ عَلِيُّ
u'ذكر عِمَامَةٌ':Added, #1: 1	ذَكَرَ عَمَّ
u'ذِكْرٌ عِمَامَةٌ':Added, #1: 1	ذِكْرُ الْعِمَامَةِ
u'ذَكَرَ عَمْدٌ':Predicate, #1: 1	ذِكْرُ الْعِمَامَةِ
u'ذكر عَمْدٌ':Added, #3: 3	ذَكَرَ الْعَمْدَ
u'ذِكْرٌ عَمْدٌ':Added, #1: 1	ذِكْرَ الْعَمْدِ
u'ذكر عَمْدٌ':Added, #1: 1	ذِكْرَ الْعَمْدِ
u'ذِكْرٌ عَمْدٌ':Added, #3: 3	ذِكْرُ الْعَمْدِ
u'ذَكَرَ عُمَرٌ':Subject, #3: 3	ذِكْرُ الْعَمْدِ
u'ذَكَرَ عمرة':Predicate, #5: 5	ذَكَرَ عُمَرُ
u'ذَكَرَ عُمْرَةٌ':Predicate, #2: 2	ذَكَرَ الْعُمْرَةَ
u'ذكر عمرة':Added, #2: 2	ذَكَرَ الْعُمْرَةَ
u'ذِكْرٌ عمرة':Added, #1: 1	ذِكْرَ الْعُمْرَةِ
u'ذكر عُمْرَةٌ':Added, #1: 1	ذِكْرَ الْعُمْرَةِ
u'ذِكْرٌ عُمْرَةٌ':Added, #1: 1	ذِكْرَ الْعُمْرَةِ
u'ذكر عمرة':Added, #1: 1	ذِكْرَ الْعُمْرَةِ
u'ذِكْرٌ عمرة':Added, #3: 3	ذِكْرُ الْعُمْرَةِ
u'ذكر عُمْرَةٌ':Added, #3: 3	ذِكْرُ الْعُمْرَةِ
u'ذِكْرٌ عُمْرَةٌ':Added, #3: 3	ذِكْرُ الْعُمْرَةِ
u'ذَكَرَ عَمَلٌ':Predicate, #3: 3	ذِكْرُ الْعُمْرَةِ
u'ذكر عَمَلٌ':Added, #3: 3	ذَكَرَ الْعَمَلَ
u'ذِكْرٌ عَمَلٌ':Added, #2: 2	ذِكْرُ الْعَمَلِ
u'ذكر عَمَلٌ':Added, #2: 2	ذِكْرُ الْعَمَلِ
u'ذكر عَمَلٌ':Added, #3: 3	ذِكْرَ الْعَمَلِ
u'ذِكْرٌ عَمَلٌ':Added, #3: 3	ذِكْرِ الْعَمَلِ
u'ذِكْرٌ عَمَلٌ':Added, #3: 3	ذِكْرَ الْعَمَلِ
u'ذكر عَمَلِيٌّ':Added, #3: 3	ذِكْرِ الْعَمَلِ
u'ذِكْرٌ عَمَلِيٌّ':Added, #1: 1	ذِكْرِ الْعَمَلِيَّةِ
u'ذكر عَمَلِيَّةٌ':Added, #1: 1	ذِكْرِ الْعَمَلِيَّةِ
u'ذِكْرٌ عَمَلِيَّةٌ':Added, #1: 1	ذِكْرِ الْعَمَلِيَّةِ
u'ذكر عُمُومٌ':Added, #1: 1	ذِكْرِ الْعَمَلِيَّةِ
u'ذِكْرٌ عُمُومٌ':Added, #1: 1	ذِكْرُ الْعُمُومِ
u'ذكر عَنَاقٌ':Added, #1: 1	ذِكْرُ الْعُمُومِ
u'ذِكْرٌ عَنَاقٌ':Added, #1: 1	ذِكْرِ الْعَنَاقِ
u'ذكر عِنان':Added, #1: 1	ذِكْرِ الْعَنَاقِ
u'ذكر عِنَانٌ':Added, #1: 1	ذِكْرِ الْعِنَانِ
u'ذِكْرٌ عِنان':Added, #1: 1	ذِكْرِ الْعِنَانِ
u'ذِكْرٌ عِنَانٌ':Added, #1: 1	ذِكْرِ الْعِنَانِ
u'ذَكَرَ عند':Predicate, #1: 1	ذِكْرِ الْعِنَانِ
u'ذكر عَهْدٌ':Added, #3: 3	ذَكَرَ عِنْدَ
u'ذِكْرٌ عَهْدٌ':Added, #1: 1	ذِكْرِ الْعَهْدِ
u'ذكر عَوَاقِلُ':Added, #1: 1	ذِكْرِ الْعَهْدِ
u'ذِكْرٌ عَوَاقِلُ':Added, #1: 1	ذِكْرُ الْعَوَاقِلِ
u'ذَكَرَ عَوْدٌ':Predicate, #1: 1	ذِكْرُ الْعَوَاقِلِ
u'ذَكَرَ عِوَضٌ':Predicate, #2: 2	ذَكَرَ الْعَوْدَ
u'ذكر عِوَضٌ':Added, #2: 2	ذَكَرَ الْعِوَضَ
u'ذِكْرٌ عِوَضٌ':Added, #11: 11	ذِكْرِ الْعِوَضِ
u'ذكر عِوَضٌ':Added, #11: 11	ذِكْرِ الْعِوَضِ
u'ذِكْرٌ عِوَضٌ':Added, #1: 1	ذِكْرَ الْعِوَضَيْنِ
u'ذكر عِوَضٌ':Added, #1: 1	ذِكْرَ الْعِوَضَيْنِ
u'ذِكْرٌ عِوَضٌ':Added, #2: 2	ذِكْرِ عِوَضٍ
u'ذكر عِوَضٌ':Added, #2: 2	ذِكْرِ عِوَضٍ
u'ذكر عِوَضٌ':Added, #3: 3	ذِكْرَ الْعِوَضِ
u'ذِكْرٌ عِوَضٌ':Added, #3: 3	ذِكْرُ الْعِوَضِ
u'ذِكْرٌ عِوَضٌ':Added, #3: 3	ذِكْرَ الْعِوَضِ
u'ذكر عَيْبٌ':Added, #3: 3	ذِكْرُ الْعِوَضِ
u'ذِكْرٌ عَيْبٌ':Added, #1: 1	ذِكْرُ الْعَيْبِ
u'ذكر عَيْبٌ':Added, #1: 1	ذِكْرُ الْعَيْبِ
u'ذكر عَيْبٌ':Added, #1: 1	ذِكْرِ عَيْبٍ
u'ذِكْرٌ عَيْبٌ':Added, #1: 1	ذِكْرِ عَيْبِ
u'ذِكْرٌ عَيْبٌ':Added, #1: 1	ذِكْرِ عَيْبٍ
u'ذَكَرَ عين':Predicate, #1: 1	ذِكْرِ عَيْبِ
u'ذَكَرَ عَيْنٌ':Predicate, #1: 1	ذَكَرَ عَيْنَ
u'ذَكَرَ عَيْن':Predicate, #1: 1	ذَكَرَ عَيْنَ
u'ذَكَرَ عُيُوبٌ':Predicate, #1: 1	ذَكَرَ عَيْنَ
u'ذكر عُيُوبٌ':Added, #2: 2	ذَكَرَ الْعُيُوبَ
u'ذِكْرٌ عُيُوبٌ':Added, #1: 1	ذِكْرِ عُيُوبِ
u'ذكر غَادِرٌ':Added, #1: 1	ذِكْرِ عُيُوبِ
u'ذِكْرٌ غَادِرٌ':Added, #1: 1	ذِكْرَ غَادِرٍ
u'ذَكَرَ غَاصِبٌ':Predicate, #1: 1	ذِكْرَ غَادِرٍ
u'ذَكَرَ غَالِبٌ':Predicate, #1: 1	ذَكَرَ الْغَاصِبَ
u'ذَكَرَ غَالِبٌ':Subject, #1: 1	ذَكَرَ غَالِبَ
u'ذَكَرَ غَايَةٌ':Predicate, #1: 1	ذَكَرَ غَالِبُ
u'ذكر غَايَةٌ':Added, #1: 1	ذَكَرَ الْغَايَةَ
u'ذِكْرٌ غَايَةٌ':Added, #1: 1	ذِكْرِ الْغَايَةِ
u'ذكر غَايَةٌ':Added, #1: 1	ذِكْرِ الْغَايَةِ
u'ذِكْرٌ غَايَةٌ':Added, #2: 2	ذِكْرُ الْغَايَةِ
u'ذكر غَايَةٌ':Added, #2: 2	ذِكْرُ الْغَايَةِ
u'ذِكْرٌ غَايَةٌ':Added, #3: 3	ذِكْرَ الْغَايَةِ
u'ذكر غَدٌ':Added, #3: 3	ذِكْرَ الْغَايَةِ
u'ذِكْرٌ غَدٌ':Added, #3: 3	ذِكْرُ الْغَدِ
u'ذكر غَدٌ':Added, #3: 3	ذِكْرُ الْغَدِ
u'ذِكْرٌ غَدٌ':Added, #5: 5	ذِكْرَ الْغَدِ
u'ذكر غَدَاءٌ':Added, #5: 5	ذِكْرَ الْغَدِ
u'ذِكْرٌ غَدَاءٌ':Added, #1: 1	ذِكْرِ الْغَدَاءِ
u'ذَكَرَ غِرٌّ':Predicate, #1: 1	ذِكْرِ الْغَدَاءِ
u'ذَكَرَ غِرَّةٌ':Predicate, #1: 1	ذَكَرَ غِرّةَ
u'ذكر غُرَّةٌ':Added, #1: 1	ذَكَرَ غِرّةَ
u'ذِكْرٌ غُرَّةٌ':Added, #1: 1	ذِكْرُ الْغُرَّةِ
u'ذكر غَزَالٌ':Added, #1: 1	ذِكْرُ الْغُرَّةِ
u'ذِكْرٌ غَزَالٌ':Added, #1: 1	ذِكْرَ الْغَزَالَيْنِ
u'ذَكَرَ غَزْلٌ':Predicate, #1: 1	ذِكْرَ الْغَزَالَيْنِ
u'ذكر غَزْوٌ':Added, #1: 1	ذَكَرَ غَزْلَ
u'ذِكْرٌ غَزْوٌ':Added, #1: 1	ذِكْرِ الْغَزْوِ
u'ذكر غَزْوَةٌ':Added, #1: 1	ذِكْرِ الْغَزْوِ
u'ذِكْرٌ غَزْوَةٌ':Added, #2: 2	ذِكْرُ غَزْوَةِ
u'ذَكَرَ غُسْلٌ':Predicate, #2: 2	ذِكْرُ غَزْوَةِ
u'ذَكَرَ غُسْلٌ':Predicate, #1: 1	ذَكَرَ غُسْلاً
u'ذكر غُسْلٌ':Added, #2: 2	ذَكَرَ الْغُسْلَ
u'ذكر غُسْلٌ':Added, #1: 1	ذِكْرُ الْغُسْلِ
u'ذِكْرٌ غُسْلٌ':Added, #1: 1	ذِكْرِ الْغُسْلِ
u'ذِكْرٌ غُسْلٌ':Added, #1: 1	ذِكْرُ الْغُسْلِ
u'ذَكَرَ غَصْبٌ':Predicate, #1: 1	ذِكْرِ الْغُسْلِ
u'ذَكَرَ غضب':Predicate, #1: 1	ذَكَرَ الْغَصْبَ
u'ذَكَرَ غَضَبٌ':Predicate, #1: 1	ذَكَرَ الْغَضَبَ
u'ذكر غضب':Added, #1: 1	ذَكَرَ الْغَضَبَ
u'ذِكْرٌ غضب':Added, #1: 1	ذِكْرُ الْغَضَبِ
u'ذكر غَضَبٌ':Added, #1: 1	ذِكْرُ الْغَضَبِ
u'ذِكْرٌ غَضَبٌ':Added, #1: 1	ذِكْرُ الْغَضَبِ
u'ذكر غَطِيط':Added, #1: 1	ذِكْرُ الْغَضَبِ
u'ذِكْرٌ غَطِيط':Added, #1: 1	ذِكْرُ الْغَطِيطِ
u'ذَكَرَ غُلُول':Predicate, #1: 1	ذِكْرُ الْغَطِيطِ
u'ذَكَرَ غَنَائِمُ':Predicate, #1: 1	ذَكَرَ غُلُولَ
u'ذكر غَنَمٌ':Added, #1: 1	ذَكَرَ الْغَنَائِمَ
u'ذِكْرٌ غَنَمٌ':Added, #2: 2	ذِكْرُ الْغَنَمِ
u'ذَكَرَ غَيْبَةٌ':Predicate, #2: 2	ذِكْرُ الْغَنَمِ
u'ذكر غَيْبَةٌ':Added, #1: 1	ذَكَرَ غَيْبَةَ
u'ذِكْرٌ غَيْبَةٌ':Added, #1: 1	ذِكْرَ غَيْبَةِ
u'ذكر غِيبَةٌ':Added, #1: 1	ذِكْرَ غَيْبَةِ
u'ذِكْرٌ غِيبَةٌ':Added, #2: 2	ذِكْرِ الْغِيبَةِ
u'ذَكَرَ غير':Predicate, #2: 2	ذِكْرِ الْغِيبَةِ
u'ذَكَرَ غَيْرٌ':Predicate, #4: 4	ذَكَرَ غَيْرَ
u'ذَكَرَ غير':Subject, #4: 4	ذَكَرَ غَيْرَ
u'ذَكَرَ غَيْرٌ':Subject, #16: 16	ذَكَرَ غَيْرُهُ
u'ذَكَرَ غير':Subject, #16: 16	ذَكَرَ غَيْرُهُ
u'ذَكَرَ غَيْرٌ':Subject, #1: 1	ذَكَرَ الْغَيْرُ
u'ذَكَرَ غير':Subject, #1: 1	ذَكَرَ الْغَيْرُ
u'ذَكَرَ غَيْرٌ':Subject, #27: 27	ذَكَرَ غَيْرُ
u'ذكر غير':Added, #27: 27	ذَكَرَ غَيْرُ
u'ذكر غير':Added, #1: 1	ذِكْرَ الْغَيْرِ
u'ذكر غير':Added, #1: 1	ذِكْرُ الْغَيْرِ
u'ذكر غَيْرٌ':Added, #1: 1	ذِكْرِ الْغَيْرِ
u'ذكر غَيْرٌ':Added, #1: 1	ذِكْرَ الْغَيْرِ
u'ذكر غَيْرٌ':Added, #1: 1	ذِكْرُ الْغَيْرِ
u'ذِكْرٌ غير':Added, #1: 1	ذِكْرِ الْغَيْرِ
u'ذِكْرٌ غير':Added, #1: 1	ذِكْرَ الْغَيْرِ
u'ذِكْرٌ غير':Added, #1: 1	ذِكْرُ الْغَيْرِ
u'ذِكْرٌ غَيْرٌ':Added, #1: 1	ذِكْرِ الْغَيْرِ
u'ذِكْرٌ غَيْرٌ':Added, #1: 1	ذِكْرَ الْغَيْرِ
u'ذِكْرٌ غَيْرٌ':Added, #1: 1	ذِكْرُ الْغَيْرِ
u'ذكر غير':Added, #1: 1	ذِكْرِ الْغَيْرِ
u'ذكر غير':Added, #1: 1	ذِكْرُ غَيْرِ
u'ذكر غَيْرٌ':Added, #1: 1	ذِكْرِ غَيْرِ
u'ذكر غَيْرٌ':Added, #1: 1	ذِكْرُ غَيْرِ
u'ذِكْرٌ غير':Added, #1: 1	ذِكْرِ غَيْرِ
u'ذِكْرٌ غير':Added, #1: 1	ذِكْرُ غَيْرِ
u'ذِكْرٌ غَيْرٌ':Added, #1: 1	ذِكْرِ غَيْرِ
u'ذِكْرٌ غَيْرٌ':Added, #1: 1	ذِكْرُ غَيْرِ
u'ذكر غير':Added, #1: 1	ذِكْرِ غَيْرِ
u'ذكر غَيْرٌ':Added, #1: 1	ذِكْرُ غَيْرِهِ
u'ذِكْرٌ غير':Added, #1: 1	ذِكْرُ غَيْرِهِ
u'ذِكْرٌ غَيْرٌ':Added, #1: 1	ذِكْرُ غَيْرِهِ
u'ذكر غير':Added, #1: 1	ذِكْرُ غَيْرِهِ
u'ذكر غَيْرٌ':Added, #3: 3	ذِكْرِ غَيْرِهِ
u'ذِكْرٌ غير':Added, #3: 3	ذِكْرِ غَيْرِهِ
u'ذِكْرٌ غَيْرٌ':Added, #3: 3	ذِكْرِ غَيْرِهِ
u'ذَكَرَ غَيْرَةٌ':Predicate, #3: 3	ذِكْرِ غَيْرِهِ
u'ذكر فاء':Added, #1: 1	ذَكَرَ الْغَيْرَةَ
u'ذِكْرٌ فاء':Added, #1: 1	ذِكْرَ الْفَاءِ
u'ذَكَرَ فَاتِحٌ':Predicate, #1: 1	ذِكْرَ الْفَاءِ
u'ذكر فَاتِحٌ':Added, #1: 1	ذَكَرَ الْفَاتِحَةَ
u'ذِكْرٌ فَاتِحٌ':Added, #1: 1	ذِكْرِ الْفَاتِحَةِ
u'ذَكَرَ فَاتِحَةٌ':Predicate, #1: 1	ذِكْرِ الْفَاتِحَةِ
u'ذكر فَاتِحَةٌ':Added, #1: 1	ذَكَرَ الْفَاتِحَةَ
u'ذِكْرٌ فَاتِحَةٌ':Added, #1: 1	ذِكْرِ الْفَاتِحَةِ
u'ذكر فَاجِرٌ':Added, #1: 1	ذِكْرِ الْفَاتِحَةِ
u'ذِكْرٌ فَاجِرٌ':Added, #1: 1	ذِكْرِ الْفَاجِرِ
u'ذكر فَاحِشٌ':Added, #1: 1	ذِكْرِ الْفَاجِرِ
u'ذِكْرٌ فَاحِشٌ':Added, #1: 1	ذِكْرِ فَاحِشَةٍ
u'ذَكَرَ فَارِسِيٌّ':Subject, #1: 1	ذِكْرِ فَاحِشَةٍ
u'ذكر فَارِقٌ':Added, #1: 1	ذَكَرَ الْفَارِسِيُّ
u'ذِكْرٌ فَارِقٌ':Added, #1: 1	ذِكْرِ فَارِقٍ
u'ذَكَرَ فَاسِدٌ':Predicate, #1: 1	ذِكْرِ فَارِقٍ
u'ذكر فَاسِقٌ':Added, #1: 1	ذَكَرَ الْفَاسِدَ
u'ذِكْرٌ فَاسِقٌ':Added, #1: 1	ذِكْرِ الْفَاسِقِ
u'ذكر فَاصِلٌ':Added, #1: 1	ذِكْرِ الْفَاسِقِ
u'ذِكْرٌ فَاصِلٌ':Added, #3: 3	ذِكْرِ الْفَاصِلِ
u'ذَكَرَ فَاضِلٌ':Subject, #3: 3	ذِكْرِ الْفَاصِلِ
u'ذكر فَاعِلٌ':Added, #3: 3	ذَكَرَ الْفَاضِلُ
u'ذِكْرٌ فَاعِلٌ':Added, #1: 1	ذِكْرِ الْفَاعِلِ
u'ذكر فَاعِلٌ':Added, #1: 1	ذِكْرِ الْفَاعِلِ
u'ذِكْرٌ فَاعِلٌ':Added, #1: 1	ذِكْرِ فَاعِلِهِ
u'ذكر فَاعِلٌ':Added, #1: 1	ذِكْرِ فَاعِلِهِ
u'ذِكْرٌ فَاعِلٌ':Added, #2: 2	ذِكْرُ الْفَاعِلِ
u'ذكر فاغِيَة':Added, #2: 2	ذِكْرُ الْفَاعِلِ
u'ذِكْرٌ فاغِيَة':Added, #1: 1	ذِكْرُ فَاغِيَةٍ
u'ذكر فَتَّانٌ':Added, #1: 1	ذِكْرُ فَاغِيَةٍ
u'ذِكْرٌ فَتَّانٌ':Added, #1: 1	ذِكْرِ فَتَّانِ
u'ذَكَرَ فَتْحٌ':Predicate, #1: 1	ذِكْرِ فَتَّانِ
u'ذَكَرَ فتنة':Predicate, #1: 1	ذَكَرَ فَتْحَ
u'ذَكَرَ فِتْنَةٌ':Predicate, #1: 1	ذَكَرَ فِتْنَةَ
u'ذَكَرَ فَجْرٌ':Predicate, #1: 1	ذَكَرَ فِتْنَةَ
u'ذَكَرَ فخر':Subject, #1: 1	ذَكَرَ الْفَجْرَ
u'ذَكَرَ فَخْرٌ':Subject, #11: 11	ذَكَرَ فَخْرُ
u'ذكر فِدَاءٌ':Added, #11: 11	ذَكَرَ فَخْرُ
u'ذكر فِدَاءٌ':Added, #1: 1	ذِكْرُ الْفِدَاءِ
u'ذِكْرٌ فِدَاءٌ':Added, #1: 1	ذِكْرِ الْفِدَاءِ
u'ذِكْرٌ فِدَاءٌ':Added, #1: 1	ذِكْرُ الْفِدَاءِ
u'ذَكَرَ فِدْيَةٌ':Predicate, #1: 1	ذِكْرِ الْفِدَاءِ
u'ذَكَرَ فَذٌّ':Subject, #2: 2	ذَكَرَ الْفِدْيَةَ
u'ذَكَرَ فَذٌّ':Subject, #1: 1	ذَكَرَ الْفَذُّ
u'ذَكَرَ فُرَاتٌ':Predicate, #1: 1	ذَكَرَ فَذٌّ
u'ذَكَرَ فَرَائِضُ':Predicate, #1: 1	ذَكَرَ الْفُرَاتَ
u'ذكر فَرَائِضُ':Added, #2: 2	ذَكَرَ الْفَرَائِضَ
u'ذِكْرٌ فَرَائِضُ':Added, #1: 1	ذِكْرِ فَرَائِضِ
u'ذكر فَرَائِضُ':Added, #1: 1	ذِكْرِ فَرَائِضِ
u'ذِكْرٌ فَرَائِضُ':Added, #2: 2	ذِكْرِ الْفَرَائِضِ
u'ذكر فَرْجٌ':Added, #2: 2	ذِكْرِ الْفَرَائِضِ
u'ذِكْرٌ فَرْجٌ':Added, #1: 1	ذِكْرِ الْفَرْجِ
u'ذكر فَرْدٌ':Added, #1: 1	ذِكْرِ الْفَرْجِ
u'ذِكْرٌ فَرْدٌ':Added, #1: 1	ذِكْرَ فَرْدٍ
u'ذكر فَرَسٌ':Added, #1: 1	ذِكْرَ فَرْدٍ
u'ذِكْرٌ فَرَسٌ':Added, #1: 1	ذِكْرِ الْفَرَسَيْنِ
u'ذكر فَرَسٌ':Added, #1: 1	ذِكْرِ الْفَرَسَيْنِ
u'ذِكْرٌ فَرَسٌ':Added, #2: 2	ذِكْرِ الْفَرَسِ
u'ذكر فَرْسَخٌ':Added, #2: 2	ذِكْرِ الْفَرَسِ
u'ذِكْرٌ فَرْسَخٌ':Added, #1: 1	ذِكْرَ الْفَرْسَخِ
u'ذَكَرَ فَرْضٌ':Predicate, #1: 1	ذِكْرَ الْفَرْسَخِ
u'ذكر فَرْضٌ':Added, #1: 1	ذَكَرَ فَرْضَ
u'ذِكْرٌ فَرْضٌ':Added, #1: 1	ذِكْرِ الْفَرْضِ
u'ذكر فَرْضٌ':Added, #1: 1	ذِكْرِ الْفَرْضِ
u'ذِكْرٌ فَرْضٌ':Added, #1: 1	ذِكْرِ فَرْضِ
u'ذكر فَرْضٌ':Added, #1: 1	ذِكْرِ فَرْضِ
u'ذِكْرٌ فَرْضٌ':Added, #2: 2	ذِكْرُ فَرْضِ
u'ذكر فَرْعٌ':Added, #2: 2	ذِكْرُ فَرْضِ
u'ذِكْرٌ فَرْعٌ':Added, #1: 1	ذِكْرُ الْفَرْعِ
u'ذَكَرَ فرق':Predicate, #1: 1	ذِكْرُ الْفَرْعِ
u'ذَكَرَ فِرَقٌ':Predicate, #1: 1	ذَكَرَ الْفِرَقَ
u'ذَكَرَ فرق':Predicate, #1: 1	ذَكَرَ الْفِرَقَ
u'ذَكَرَ فَرْقٌ':Predicate, #4: 4	ذَكَرَ الْفَرْقَ
u'ذكر فرق':Added, #4: 4	ذَكَرَ الْفَرْقَ
u'ذِكْرٌ فرق':Added, #4: 4	ذِكْرِ الْفَرْقِ
u'ذكر فَرْقٌ':Added, #4: 4	ذِكْرِ الْفَرْقِ
u'ذِكْرٌ فَرْقٌ':Added, #4: 4	ذِكْرِ الْفَرْقِ
u'ذكر فُرُوعٌ':Added, #4: 4	ذِكْرِ الْفَرْقِ
u'ذِكْرٌ فُرُوعٌ':Added, #1: 1	ذِكْرِ الْفُرُوعِ
u'ذكر فُرُوعٌ':Added, #1: 1	ذِكْرِ الْفُرُوعِ
u'ذِكْرٌ فُرُوعٌ':Added, #2: 2	ذِكْرُ الْفُرُوعِ
u'ذكر فَرِيضَةٌ':Added, #2: 2	ذِكْرُ الْفُرُوعِ
u'ذِكْرٌ فَرِيضَةٌ':Added, #1: 1	ذِكْرِ الْفَرِيضَةِ
u'ذَكَرَ فَسْخٌ':Predicate, #1: 1	ذِكْرِ الْفَرِيضَةِ
u'ذكر فِسْقٌ':Added, #2: 2	ذَكَرَ الْفَسْخَ
u'ذِكْرٌ فِسْقٌ':Added, #2: 2	ذِكْرُ الْفِسْقِ
u'ذَكَرَ فَصْلٌ':Predicate, #2: 2	ذِكْرُ الْفِسْقِ
u'ذَكَرَ فَصْلٌ':Predicate, #1: 1	ذَكَرَ الْفَصْلَ
u'ذَكَرَ فَصْلٌ':Subject, #2: 2	ذَكَرَ فَصْلَ
u'ذكر فَصْلٌ':Added, #1: 1	ذَكَرَ الْفَصْلُ
u'ذكر فَصْلٌ':Added, #1: 1	ذِكْرُ الْفَصْلِ
u'ذِكْرٌ فَصْلٌ':Added, #1: 1	ذِكْرِ الْفَصْلِ
u'ذِكْرٌ فَصْلٌ':Added, #1: 1	ذِكْرُ الْفَصْلِ
u'ذكر فُصُولٌ':Added, #1: 1	ذِكْرِ الْفَصْلِ
u'ذِكْرٌ فُصُولٌ':Added, #1: 1	ذِكْرِ فُصُولِ
u'ذكر فَضَائِلُ':Added, #1: 1	ذِكْرِ فُصُولِ
u'ذِكْرٌ فَضَائِلُ':Added, #1: 1	ذِكْرَ فَضَائِلِ
u'ذكر فَضَائِلُ':Added, #1: 1	ذِكْرَ فَضَائِلِ
u'ذِكْرٌ فَضَائِلُ':Added, #1: 1	ذِكْرِ فَضَائِلِهِ
u'ذكر فَضَائِلُ':Added, #1: 1	ذِكْرِ فَضَائِلِهِ
u'ذِكْرٌ فَضَائِلُ':Added, #2: 2	ذِكْرِ فَضَائِلِ
u'ذَكَرَ فَضْلٌ':Predicate, #2: 2	ذِكْرِ فَضَائِلِ
u'ذكر فَضْلٌ':Added, #1: 1	ذَكَرَ فَضْلَ
u'ذِكْرٌ فَضْلٌ':Added, #1: 1	ذِكْرِ فَضْلِ
u'ذَكَرَ فِعْلٌ':Predicate, #1: 1	ذِكْرِ فَضْلِ
u'ذكر فِعْلٌ':Added, #2: 2	ذَكَرَ الْفِعْلَ
u'ذِكْرٌ فِعْلٌ':Added, #1: 1	ذِكْرُ فِعْلِ
u'ذكر فِعْلٌ':Added, #1: 1	ذِكْرُ فِعْلِ
u'ذكر فِعْلٌ':Added, #3: 3	ذِكْرَ الْفِعْلِ
u'ذِكْرٌ فِعْلٌ':Added, #3: 3	ذِكْرِ الْفِعْلِ
u'ذِكْرٌ فِعْلٌ':Added, #3: 3	ذِكْرَ الْفِعْلِ
u'ذَكَرَ فقراء':Predicate, #3: 3	ذِكْرِ الْفِعْلِ
u'ذكر فقراء':Added, #2: 2	ذَكَرَ الْفُقَرَاءَ
u'ذِكْرٌ فقراء':Added, #1: 1	ذِكْرِ الْفُقَرَاءِ
u'ذكر فقراء':Added, #1: 1	ذِكْرِ الْفُقَرَاءِ
u'ذِكْرٌ فقراء':Added, #1: 1	ذِكْرِ فُقَرَاءِ
u'ذَكَرَ فِقْهٌ':Predicate, #1: 1	ذِكْرِ فُقَرَاءِ
u'ذَكَرَ فقهاء':Subject, #1: 1	ذَكَرَ الْفِقْهَ
u'ذَكَرَ فَقِيهٌ':Subject, #7: 7	ذَكَرَ الْفُقَهَاءُ
u'ذَكَرَ فلان':Predicate, #19: 19	ذَكَرَ الْفَقِيهُ
u'ذَكَرَ فلان':Predicate, #1: 1	ذَكَرَ حَفْصَةَ
u'ذَكَرَ فلان':Predicate, #1: 1	ذَكَرَ خَيْبَرَ
u'ذَكَرَ فلان':Predicate, #2: 2	ذَكَرَ خَدِيجَةَ
u'ذَكَرَ فلان':Subject, #2: 2	ذَكَرَ مَرْيَمَ
u'ذَكَرَ فلان':Subject, #10: 10	ذَكَرَ الشَّافِعِيُّ
u'ذَكَرَ فلان':Subject, #1: 1	ذَكَرَ الزُّبَيْرُ
u'ذَكَرَ فلان':Subject, #1: 1	ذَكَرَ الزَّمَخْشَرِيُّ
u'ذَكَرَ فُلاَنٌ':Subject, #1: 1	ذَكَرَ الشَّاذِلِيُّ
u'ذَكَرَ فلان':Subject, #1: 1	ذَكَرَ فُلَانٌ
u'ذَكَرَ فلان':Subject, #22: 22	ذَكَرَ سُفْيَانُ
u'ذَكَرَ فلان':Subject, #2: 2	ذَكَرَ الطَّبَرِيُّ
u'ذَكَرَ فلان':Subject, #2: 2	ذَكَرَ عُبَيْدَةُ
u'ذَكَرَ فلان':Subject, #2: 2	ذَكَرَ قَتَادَةُ
u'ذَكَرَ فلان':Subject, #3: 3	ذَكَرَ التِّرْمِذِيُّ
u'ذَكَرَ فلان':Subject, #3: 3	ذَكَرَ الشَّافِعِيَّةُ
u'ذَكَرَ فلان':Subject, #5: 5	ذَكَرَ الْبَيْهَقِيُّ
u'ذَكَرَ فلان':Subject, #5: 5	ذَكَرَ الزّبَيْرُ
u'ذكر فلان':Added, #6: 6	ذَكَرَ الْقُرْطُبِيُّ
u'ذِكْرٌ فلان':Added, #1: 1	ذِكْرُ النَّجَاشِيِّ
u'ذكر فلان':Added, #1: 1	ذِكْرُ النَّجَاشِيِّ
u'ذِكْرٌ فلان':Added, #1: 1	ذِكْرُ بِلالٍ
u'ذكر فلان':Added, #1: 1	ذِكْرُ بِلالٍ
u'ذِكْرٌ فلان':Added, #1: 1	ذِكْرِ جُبَيْرِ
u'ذكر فُلاَنٌ':Added, #1: 1	ذِكْرِ جُبَيْرِ
u'ذِكْرٌ فُلاَنٌ':Added, #2: 2	ذِكْرَ فُلَانٍ
u'ذكر فُلاَنٌ':Added, #2: 2	ذِكْرَ فُلَانٍ
u'ذِكْرٌ فُلاَنٌ':Added, #5: 5	ذِكْرِ فُلَانٍ
u'ذكر فِنَاءٌ':Added, #5: 5	ذِكْرِ فُلَانٍ
u'ذِكْرٌ فِنَاءٌ':Added, #1: 1	ذِكْرُ الْفِنَاءِ
u'ذكر فَوَاحِشُ':Added, #1: 1	ذِكْرُ الْفِنَاءِ
u'ذِكْرٌ فَوَاحِشُ':Added, #1: 1	ذِكْرَ الْفَوَاحِشِ
u'ذَكَرَ فَيْءٌ':Predicate, #1: 1	ذِكْرَ الْفَوَاحِشِ
u'ذكر فَيْءٌ':Added, #1: 1	ذَكَرَ الْفَيْءَ
u'ذِكْرٌ فَيْءٌ':Added, #1: 1	ذِكْرُ الْفَيْءِ
u'ذكر قَابِضٌ':Added, #1: 1	ذِكْرُ الْفَيْءِ
u'ذِكْرٌ قَابِضٌ':Added, #1: 1	ذِكْرُ قَابِضِ
u'ذَكَرَ قَابِلٌ':Subject, #1: 1	ذِكْرُ قَابِضِ
u'ذَكَرَ قَاتِلٌ':Predicate, #1: 1	ذَكَرَ الْقَابِلُ
u'ذَكَرَ قَاتِلٌ':Predicate, #1: 1	ذَكَرَ الْقَاتِلَ
u'ذكر قادِح':Added, #2: 2	ذَكَرَ قَاتِلَ
u'ذِكْرٌ قادِح':Added, #1: 1	ذِكْرِ الْقَادِحِ
u'ذَكَرَ قَاسِمٌ':Subject, #1: 1	ذِكْرِ الْقَادِحِ
u'ذَكَرَ قَاضِي':Predicate, #2: 2	ذَكَرَ قَاسِمُ
u'ذكر قَاضِي':Added, #1: 1	ذَكَرَ الْقَاضِيَ
u'ذِكْرٌ قَاضِي':Added, #1: 1	ذِكْرَ قَاضِيَيْنِ
u'ذَكَرَ قَاعِدٌ':Predicate, #1: 1	ذِكْرَ قَاضِيَيْنِ
u'ذكر قَاعِدٌ':Added, #1: 1	ذَكَرَ الْقَاعِدَةَ
u'ذِكْرٌ قَاعِدٌ':Added, #1: 1	ذِكْرُ الْقَاعِدَةِ
u'ذَكَرَ قَالٌ':Predicate, #1: 1	ذِكْرُ الْقَاعِدَةِ
u'ذكر قَالَبٌ':Added, #5: 5	ذَكَرَ قَالَ
u'ذِكْرٌ قَالَبٌ':Added, #1: 1	ذِكْرِ الْقَالَبِ
u'ذكر قُبَّةٌ':Added, #1: 1	ذِكْرِ الْقَالَبِ
u'ذِكْرٌ قُبَّةٌ':Added, #1: 1	ذِكْرُ الْقُبَّةِ
u'ذكر قَبْرٌ':Added, #1: 1	ذِكْرُ الْقُبَّةِ
u'ذِكْرٌ قَبْرٌ':Added, #1: 1	ذِكْرَ الْقَبْرِ
u'ذَكَرَ قَبْضٌ':Predicate, #1: 1	ذِكْرَ الْقَبْرِ
u'ذكر قَبْضٌ':Added, #4: 4	ذَكَرَ الْقَبْضَ
u'ذِكْرٌ قَبْضٌ':Added, #3: 3	ذِكْرِ الْقَبْضِ
u'ذكر قَبْضٌ':Added, #3: 3	ذِكْرِ الْقَبْضِ
u'ذكر قَبْضٌ':Added, #3: 3	ذِكْرُ قَبْضِ
u'ذِكْرٌ قَبْضٌ':Added, #3: 3	ذِكْرِ قَبْضِ
u'ذِكْرٌ قَبْضٌ':Added, #3: 3	ذِكْرُ قَبْضِ
u'ذكر قُبْلَةٌ':Added, #3: 3	ذِكْرِ قَبْضِ
u'ذِكْرٌ قُبْلَةٌ':Added, #2: 2	ذِكْرِ الْقُبْلَةِ
u'ذكر قَبُولٌ':Added, #2: 2	ذِكْرِ الْقُبْلَةِ
u'ذِكْرٌ قَبُولٌ':Added, #1: 1	ذِكْرُ قَبُولِهِ
u'ذكر قَبُولٌ':Added, #1: 1	ذِكْرُ قَبُولِهِ
u'ذِكْرٌ قَبُولٌ':Added, #2: 2	ذِكْرِ الْقَبُولِ
u'ذَكَرَ قَتاد':Subject, #2: 2	ذِكْرِ الْقَبُولِ
u'ذكر قتال':Added, #2: 2	ذَكَرَ قَتَادَةُ
u'ذِكْرٌ قتال':Added, #2: 2	ذِكْرِ الْقِتَالِ
u'ذكر قِتَالٌ':Added, #2: 2	ذِكْرِ الْقِتَالِ
u'ذِكْرٌ قِتَالٌ':Added, #2: 2	ذِكْرِ الْقِتَالِ
u'ذَكَرَ قتل':Predicate, #2: 2	ذِكْرِ الْقِتَالِ
u'ذَكَرَ قَتْلٌ':Predicate, #1: 1	ذَكَرَ قَتْلَ
u'ذَكَرَ قتل':Predicate, #1: 1	ذَكَرَ قَتْلَ
u'ذَكَرَ قَتْلٌ':Predicate, #2: 2	ذَكَرَ الْقَتْلَ
u'ذكر قتل':Added, #2: 2	ذَكَرَ الْقَتْلَ
u'ذِكْرٌ قتل':Added, #1: 1	ذِكْرُ الْقَتْلِ
u'ذكر قَتْلٌ':Added, #1: 1	ذِكْرُ الْقَتْلِ
u'ذِكْرٌ قَتْلٌ':Added, #1: 1	ذِكْرُ الْقَتْلِ
u'ذكر قتل':Added, #1: 1	ذِكْرُ الْقَتْلِ
u'ذِكْرٌ قتل':Added, #1: 1	ذِكْرِ قَتْلِ
u'ذكر قَتْلٌ':Added, #1: 1	ذِكْرِ قَتْلِ
u'ذِكْرٌ قَتْلٌ':Added, #1: 1	ذِكْرِ قَتْلِ
u'ذكر قَدٌّ':Added, #1: 1	ذِكْرِ قَتْلِ
u'ذِكْرٌ قَدٌّ':Added, #1: 1	ذِكْرُ الْقَدِّ
u'ذَكَرَ قَدْرٌ':Predicate, #1: 1	ذِكْرُ الْقَدِّ
u'ذَكَرَ قَدْرٌ':Predicate, #2: 2	ذَكَرَ الْقَدْرَ
u'ذكر قَدْرٌ':Added, #3: 3	ذَكَرَ قَدْرَ
u'ذِكْرٌ قَدْرٌ':Added, #2: 2	ذِكْرِ الْقَدْرِ
u'ذكر قَدْرٌ':Added, #2: 2	ذِكْرِ الْقَدْرِ
u'ذِكْرٌ قَدْرٌ':Added, #2: 2	ذِكْرِ قَدْرِ
u'ذكر قَدْرٌ':Added, #2: 2	ذِكْرِ قَدْرِ
u'ذِكْرٌ قَدْرٌ':Added, #2: 2	ذِكْرِ قَدْرِهِ
u'ذكر قَدْرٌ':Added, #2: 2	ذِكْرِ قَدْرِهِ
u'ذِكْرٌ قَدْرٌ':Added, #3: 3	ذِكْرُ قَدْرِهِ
u'ذكر قَدْرٌ':Added, #3: 3	ذِكْرُ قَدْرِهِ
u'ذِكْرٌ قَدْرٌ':Added, #4: 4	ذِكْرُ قَدْرِ
u'ذَكَرَ قدرة':Predicate, #4: 4	ذِكْرُ قَدْرِ
u'ذَكَرَ قُدْرَةٌ':Predicate, #1: 1	ذَكَرَ قُدْرَةَ
u'ذَكَرَ قُدُومٌ':Predicate, #1: 1	ذَكَرَ قُدْرَةَ
u'ذكر قُدُومٌ':Added, #1: 1	ذَكَرَ قُدُومَ
u'ذِكْرٌ قُدُومٌ':Added, #1: 1	ذِكْرُ قُدُومِ
u'ذكر قِرَاءةٌ':Added, #1: 1	ذِكْرُ قُدُومِ
u'ذِكْرٌ قِرَاءةٌ':Added, #1: 1	ذِكْرِ قِرَاءَةٍ
u'ذكر قَرَابَةٌ':Added, #1: 1	ذِكْرِ قِرَاءَةٍ
u'ذِكْرٌ قَرَابَةٌ':Added, #1: 1	ذِكْرِ الْقَرَابَةِ
u'ذكر قَرَابَةٌ':Added, #1: 1	ذِكْرِ الْقَرَابَةِ
u'ذِكْرٌ قَرَابَةٌ':Added, #3: 3	ذِكْرُ الْقَرَابَةِ
u'ذكر قُرْآنٌ':Added, #3: 3	ذِكْرُ الْقَرَابَةِ
u'ذِكْرٌ قُرْآنٌ':Added, #1: 1	ذِكْرِ الْقُرْآنِ
u'ذكر قرائن':Added, #1: 1	ذِكْرِ الْقُرْآنِ
u'ذِكْرٌ قرائن':Added, #1: 1	ذِكْرُ الْقَرَائِنِ
u'ذَكَرَ قُرْطُبِيّ':Subject, #1: 1	ذِكْرُ الْقَرَائِنِ
u'ذكر قرع':Added, #6: 6	ذَكَرَ الْقُرْطُبِيُّ
u'ذِكْرٌ قرع':Added, #1: 1	ذِكْرُ الْقَرْعِ
u'ذكر قَرْعٌ':Added, #1: 1	ذِكْرُ الْقَرْعِ
u'ذِكْرٌ قَرْعٌ':Added, #1: 1	ذِكْرُ الْقَرْعِ
u'ذكر قَرْنٌ':Added, #1: 1	ذِكْرُ الْقَرْعِ
u'ذِكْرٌ قَرْنٌ':Added, #1: 1	ذِكْرُ الْقَرْنِ
u'ذَكَرَ قَرِيبٌ':Predicate, #1: 1	ذِكْرُ الْقَرْنِ
u'ذكر قَرْيَةٌ':Added, #1: 1	ذَكَرَ الْقَرِيبَ
u'ذِكْرٌ قَرْيَةٌ':Added, #1: 1	ذِكْرُ قَرْيَةِ
u'ذَكَرَ قَرِينٌ':Subject, #1: 1	ذِكْرُ قَرْيَةِ
u'ذكر قَسَمٌ':Added, #2: 2	ذَكَرَ قَرِينُهُ
u'ذِكْرٌ قَسَمٌ':Added, #1: 1	ذِكْرُ الْقَسَمِ
u'ذكر قِسْمٌ':Added, #1: 1	ذِكْرُ الْقَسَمِ
u'ذِكْرٌ قِسْمٌ':Added, #1: 1	ذِكْرَ قِسْمٍ
u'ذكر قسمة':Added, #1: 1	ذِكْرَ قِسْمٍ
u'ذِكْرٌ قسمة':Added, #1: 1	ذِكْرَ الْقِسْمَةِ
u'ذكر قِسْمَةٌ':Added, #1: 1	ذِكْرَ الْقِسْمَةِ
u'ذِكْرٌ قِسْمَةٌ':Added, #1: 1	ذِكْرَ الْقِسْمَةِ
u'ذكر قَصٌّ':Added, #1: 1	ذِكْرَ الْقِسْمَةِ
u'ذِكْرٌ قَصٌّ':Added, #1: 1	ذِكْرُ الْقَصِّ
u'ذكر قصاص':Added, #1: 1	ذِكْرُ الْقَصِّ
u'ذِكْرٌ قصاص':Added, #1: 1	ذِكْرَ الْقِصَاصِ
u'ذكر قِصَاصٌ':Added, #1: 1	ذِكْرَ الْقِصَاصِ
u'ذِكْرٌ قِصَاصٌ':Added, #1: 1	ذِكْرَ الْقِصَاصِ
u'ذكر قصاص':Added, #1: 1	ذِكْرَ الْقِصَاصِ
u'ذِكْرٌ قصاص':Added, #2: 2	ذِكْرِ الْقِصَاصِ
u'ذكر قِصَاصٌ':Added, #2: 2	ذِكْرِ الْقِصَاصِ
u'ذِكْرٌ قِصَاصٌ':Added, #2: 2	ذِكْرِ الْقِصَاصِ
u'ذَكَرَ قِصَّةٌ':Predicate, #2: 2	ذِكْرِ الْقِصَاصِ
u'ذَكَرَ قِصَّةٌ':Predicate, #10: 10	ذَكَرَ قِصَّةَ
u'ذَكَرَ قِصَّةٌ':Predicate, #1: 1	ذَكَرَ قِصّةَ
u'ذكر قِصَّةٌ':Added, #5: 5	ذَكَرَ الْقِصَّةَ
u'ذِكْرٌ قِصَّةٌ':Added, #1: 1	ذِكْرِ قِصَّةِ
u'ذَكَرَ قَصَصٌ':Predicate, #1: 1	ذِكْرِ قِصَّةِ
u'ذكر قَضَاءٌ':Added, #1: 1	ذَكَرَ قَصَصَ
u'ذِكْرٌ قَضَاءٌ':Added, #1: 1	ذِكْرِ الْقَضَاءِ
u'ذكر قَضَاءٌ':Added, #1: 1	ذِكْرِ الْقَضَاءِ
u'ذِكْرٌ قَضَاءٌ':Added, #1: 1	ذِكْرَ قَضَاءِ
u'ذَكَرَ قَطْعٌ':Predicate, #1: 1	ذِكْرَ قَضَاءِ
u'ذَكَرَ قَفَّالٌ':Subject, #1: 1	ذَكَرَ الْقَطْعَ
u'ذَكَرَ قَفِيز':Predicate, #5: 5	ذَكَرَ الْقَفَّالُ
u'ذكر قَلاَئِدُ':Added, #1: 1	ذَكَرَ الْقَفِيزَ
u'ذِكْرٌ قَلاَئِدُ':Added, #1: 1	ذِكْرِ الْقَلَائِدِ
u'ذكر قلب':Added, #1: 1	ذِكْرِ الْقَلَائِدِ
u'ذِكْرٌ قلب':Added, #1: 1	ذِكْرُ الْقَلْبِ
u'ذكر قَلْبٌ':Added, #1: 1	ذِكْرُ الْقَلْبِ
u'ذكر قَلْب':Added, #1: 1	ذِكْرُ الْقَلْبِ
u'ذِكْرٌ قَلْبٌ':Added, #1: 1	ذِكْرُ الْقَلْبِ
u'ذِكْرٌ قَلْب':Added, #1: 1	ذِكْرُ الْقَلْبِ
u'ذكر قلب':Added, #1: 1	ذِكْرُ الْقَلْبِ
u'ذكر قلب':Added, #3: 3	ذِكْرَ الْقَلْبِ
u'ذِكْرٌ قلب':Added, #3: 3	ذِكْرِ الْقَلْبِ
u'ذِكْرٌ قلب':Added, #3: 3	ذِكْرَ الْقَلْبِ
u'ذكر قَلْبٌ':Added, #3: 3	ذِكْرِ الْقَلْبِ
u'ذكر قَلْبٌ':Added, #3: 3	ذِكْرَ الْقَلْبِ
u'ذكر قَلْب':Added, #3: 3	ذِكْرِ الْقَلْبِ
u'ذكر قَلْب':Added, #3: 3	ذِكْرَ الْقَلْبِ
u'ذِكْرٌ قَلْبٌ':Added, #3: 3	ذِكْرِ الْقَلْبِ
u'ذِكْرٌ قَلْبٌ':Added, #3: 3	ذِكْرَ الْقَلْبِ
u'ذِكْرٌ قَلْب':Added, #3: 3	ذِكْرِ الْقَلْبِ
u'ذِكْرٌ قَلْب':Added, #3: 3	ذِكْرَ الْقَلْبِ
u'ذكر قُلَّةٌ':Added, #3: 3	ذِكْرِ الْقَلْبِ
u'ذكر قِلَّةٌ':Added, #1: 1	ذِكْرِ الْقُلَّةِ
u'ذِكْرٌ قُلَّةٌ':Added, #1: 1	ذِكْرُ الْقِلَّةِ
u'ذِكْرٌ قِلَّةٌ':Added, #1: 1	ذِكْرِ الْقُلَّةِ
u'ذكر قَلِيلٌ':Added, #1: 1	ذِكْرُ الْقِلَّةِ
u'ذِكْرٌ قَلِيلٌ':Added, #1: 1	ذِكْرُ الْقَلِيلِ
u'ذكر قمر':Added, #1: 1	ذِكْرُ الْقَلِيلِ
u'ذِكْرٌ قمر':Added, #1: 1	ذِكْرِ الْقَمَرِ
u'ذكر قَمَرٌ':Added, #1: 1	ذِكْرِ الْقَمَرِ
u'ذِكْرٌ قَمَرٌ':Added, #1: 1	ذِكْرِ الْقَمَرِ
u'ذَكَرَ قَمِيصٌ':Predicate, #1: 1	ذِكْرِ الْقَمَرِ
u'ذكر قَمِيصٌ':Added, #2: 2	ذَكَرَ الْقَمِيصَ
u'ذِكْرٌ قَمِيصٌ':Added, #1: 1	ذِكْرُ الْقَمِيصِ
u'ذكر قُنْفُذٌ':Added, #1: 1	ذِكْرُ الْقَمِيصِ
u'ذِكْرٌ قُنْفُذٌ':Added, #2: 2	ذِكْرِ الْقُنْفُذِ
u'ذكر قُنُوتٌ':Added, #2: 2	ذِكْرِ الْقُنْفُذِ
u'ذِكْرٌ قُنُوتٌ':Added, #1: 1	ذِكْرَ الْقُنُوتِ
u'ذكر قَوَاعِدُ':Added, #1: 1	ذِكْرَ الْقُنُوتِ
u'ذِكْرٌ قَوَاعِدُ':Added, #1: 1	ذِكْرِ قَوَاعِدِ
u'ذَكَرَ قول':Predicate, #1: 1	ذِكْرِ قَوَاعِدِ
u'ذَكَرَ قَوْلٌ':Predicate, #42: 42	ذَكَرَ قَوْلَ
u'ذَكَرَ قول':Predicate, #42: 42	ذَكَرَ قَوْلَ
u'ذَكَرَ قَوْلٌ':Predicate, #5: 5	ذَكَرَ الْقَوْلَ
u'ذَكَرَ قول':Subject, #5: 5	ذَكَرَ الْقَوْلَ
u'ذَكَرَ قَوْلٌ':Subject, #1: 1	ذَكَرَ قَوْلُ
u'ذكر قَوْلٌ':Added, #1: 1	ذَكَرَ قَوْلُ
u'ذكر قَوْلٌ':Added, #1: 1	ذِكْرُ الْقَوْلَيْنِ
u'ذِكْرٌ قَوْلٌ':Added, #1: 1	ذِكْرِ الْقَوْلَيْنِ
u'ذِكْرٌ قَوْلٌ':Added, #1: 1	ذِكْرُ الْقَوْلَيْنِ
u'ذكر قول':Added, #1: 1	ذِكْرِ الْقَوْلَيْنِ
u'ذِكْرٌ قول':Added, #1: 1	ذِكْرِ قَوْلِ
u'ذكر قَوْلٌ':Added, #1: 1	ذِكْرِ قَوْلِ
u'ذِكْرٌ قَوْلٌ':Added, #1: 1	ذِكْرِ قَوْلِ
u'ذكر قول':Added, #1: 1	ذِكْرِ قَوْلِ
u'ذِكْرٌ قول':Added, #2: 2	ذِكْرُ قَوْلِهِ
u'ذكر قَوْلٌ':Added, #2: 2	ذِكْرُ قَوْلِهِ
u'ذِكْرٌ قَوْلٌ':Added, #2: 2	ذِكْرُ قَوْلِهِ
u'ذكر قول':Added, #2: 2	ذِكْرُ قَوْلِهِ
u'ذِكْرٌ قول':Added, #3: 3	ذِكْرَ قَوْلِهِ
u'ذكر قَوْلٌ':Added, #3: 3	ذِكْرَ قَوْلِهِ
u'ذِكْرٌ قَوْلٌ':Added, #3: 3	ذِكْرَ قَوْلِهِ
u'ذكر قول':Added, #3: 3	ذِكْرَ قَوْلِهِ
u'ذِكْرٌ قول':Added, #5: 5	ذِكْرِ قَوْلِهِ
u'ذكر قَوْلٌ':Added, #5: 5	ذِكْرِ قَوْلِهِ
u'ذِكْرٌ قَوْلٌ':Added, #5: 5	ذِكْرِ قَوْلِهِ
u'ذَكَرَ قَوْمٌ':Predicate, #5: 5	ذِكْرِ قَوْلِهِ
u'ذَكَرَ قَوْمٌ':Subject, #1: 1	ذَكَرَ الْقَوْمَ
u'ذَكَرَ قَوْمٌ':Subject, #1: 1	ذَكَرَ الْقَوْمُ
u'ذكر قِيَاسٌ':Added, #1: 1	ذَكَرَ قَوْمٌ
u'ذكر قِيَاسٌ':Added, #1: 1	ذِكْرَ الْقِيَاسِ
u'ذِكْرٌ قِيَاسٌ':Added, #1: 1	ذِكْرِ الْقِيَاسِ
u'ذِكْرٌ قِيَاسٌ':Added, #1: 1	ذِكْرَ الْقِيَاسِ
u'ذكر قِيَاسٌ':Added, #1: 1	ذِكْرِ الْقِيَاسِ
u'ذِكْرٌ قِيَاسٌ':Added, #3: 3	ذِكْرُ الْقِيَاسِ
u'ذَكَرَ قيام':Predicate, #3: 3	ذِكْرُ الْقِيَاسِ
u'ذَكَرَ قِيَامٌ':Predicate, #1: 1	ذَكَرَ قِيَامَ
u'ذكر قيام':Added, #1: 1	ذَكَرَ قِيَامَ
u'ذكر قيام':Added, #1: 1	ذِكْرَ الْقِيَامِ
u'ذكر قِيَامٌ':Added, #1: 1	ذِكْرِ الْقِيَامِ
u'ذكر قِيَامٌ':Added, #1: 1	ذِكْرَ الْقِيَامِ
u'ذِكْرٌ قيام':Added, #1: 1	ذِكْرِ الْقِيَامِ
u'ذِكْرٌ قيام':Added, #1: 1	ذِكْرَ الْقِيَامِ
u'ذِكْرٌ قِيَامٌ':Added, #1: 1	ذِكْرِ الْقِيَامِ
u'ذِكْرٌ قِيَامٌ':Added, #1: 1	ذِكْرَ الْقِيَامِ
u'ذكر قِيَامَةٌ':Added, #1: 1	ذِكْرِ الْقِيَامِ
u'ذِكْرٌ قِيَامَةٌ':Added, #1: 1	ذِكْرَ الْقِيَامَةِ
u'ذَكَرَ قَيْدٌ':Predicate, #1: 1	ذِكْرَ الْقِيَامَةِ
u'ذكر قَيْدٌ':Added, #1: 1	ذَكَرَ قَيْدَ
u'ذِكْرٌ قَيْدٌ':Added, #1: 1	ذِكْرَ الْقَيْدِ
u'ذكر قَيْدٌ':Added, #1: 1	ذِكْرَ الْقَيْدِ
u'ذِكْرٌ قَيْدٌ':Added, #1: 1	ذِكْرِ قَيْدِ
u'ذَكَرَ قِيمَةٌ':Predicate, #1: 1	ذِكْرِ قَيْدِ
u'ذكر قِيمَةٌ':Added, #5: 5	ذَكَرَ الْقِيمَةَ
u'ذكر قِيمَةٌ':Added, #1: 1	ذِكْرُ قِيمَةٍ
u'ذكر قِيمَةٌ':Added, #1: 1	ذِكْرُ قِيمَةِ
u'ذِكْرٌ قِيمَةٌ':Added, #1: 1	ذِكْرِ قِيمَةِ
u'ذِكْرٌ قِيمَةٌ':Added, #1: 1	ذِكْرُ قِيمَةٍ
u'ذِكْرٌ قِيمَةٌ':Added, #1: 1	ذِكْرُ قِيمَةِ
u'ذكر قِيمَةٌ':Added, #1: 1	ذِكْرِ قِيمَةِ
u'ذِكْرٌ قِيمَةٌ':Added, #1: 1	ذِكْرُ قِيمَتِهِ
u'ذكر قِيمَةٌ':Added, #1: 1	ذِكْرُ قِيمَتِهِ
u'ذكر قِيمَةٌ':Added, #7: 7	ذِكْرُ الْقِيمَةِ
u'ذِكْرٌ قِيمَةٌ':Added, #7: 7	ذِكْرِ الْقِيمَةِ
u'ذِكْرٌ قِيمَةٌ':Added, #7: 7	ذِكْرُ الْقِيمَةِ
u'ذَكَرَ كَاتِبٌ':Subject, #7: 7	ذِكْرِ الْقِيمَةِ
u'ذكر كبائر':Added, #1: 1	ذَكَرَ الْكَاتِبُ
u'ذِكْرٌ كبائر':Added, #3: 3	ذِكْرِ الْكَبَائِرِ
u'ذكر كَبِيرٌ':Added, #3: 3	ذِكْرِ الْكَبَائِرِ
u'ذِكْرٌ كَبِيرٌ':Added, #2: 2	ذِكْرِ الْكَبِيرِ
u'ذَكَرَ كِتَابٌ':Predicate, #2: 2	ذِكْرِ الْكَبِيرِ
u'ذكر كِتَابٌ':Added, #1: 1	ذَكَرَ كِتَابَ
u'ذِكْرٌ كِتَابٌ':Added, #1: 1	ذِكْرِ الْكِتَابِ
u'ذكر كِتَابٌ':Added, #1: 1	ذِكْرِ الْكِتَابِ
u'ذِكْرٌ كِتَابٌ':Added, #1: 1	ذِكْرَ كِتَابِ
u'ذكر كِتَابٌ':Added, #1: 1	ذِكْرَ كِتَابِ
u'ذِكْرٌ كِتَابٌ':Added, #2: 2	ذِكْرُ كِتَابِ
u'ذَكَرَ كِتَابَةٌ':Predicate, #2: 2	ذِكْرُ كِتَابِ
u'ذكر كُتُبٌ':Added, #2: 2	ذَكَرَ كِتَابَةَ
u'ذِكْرٌ كُتُبٌ':Added, #1: 1	ذِكْرِ كُتُبٍ
u'ذَكَرَ كَثْرَةٌ':Predicate, #1: 1	ذِكْرِ كُتُبٍ
u'ذكر كحل':Added, #1: 1	ذَكَرَ الْكَثْرَةَ
u'ذِكْرٌ كحل':Added, #2: 2	ذِكْرُ الْكُحْلِ
u'ذكر كُحْلٌ':Added, #2: 2	ذِكْرُ الْكُحْلِ
u'ذِكْرٌ كُحْلٌ':Added, #2: 2	ذِكْرُ الْكُحْلِ
u'ذكر كحل':Added, #2: 2	ذِكْرُ الْكُحْلِ
u'ذِكْرٌ كحل':Added, #4: 4	ذِكْرِ الْكُحْلِ
u'ذكر كُحْلٌ':Added, #4: 4	ذِكْرِ الْكُحْلِ
u'ذِكْرٌ كُحْلٌ':Added, #4: 4	ذِكْرِ الْكُحْلِ
u'ذكر كَذَّابٌ':Added, #4: 4	ذِكْرِ الْكُحْلِ
u'ذِكْرٌ كَذَّابٌ':Added, #1: 1	ذِكْرُ الْكَذّابَيْنِ
u'ذَكَرَ كَرَاهَةٌ':Predicate, #1: 1	ذِكْرُ الْكَذّابَيْنِ
u'ذكر كُرْسِيٌّ':Added, #5: 5	ذَكَرَ الْكَرَاهَةَ
u'ذِكْرٌ كُرْسِيٌّ':Added, #1: 1	ذِكْرِ الْكُرْسِيِّ
u'ذكر كَرَمٌ':Added, #1: 1	ذِكْرِ الْكُرْسِيِّ
u'ذِكْرٌ كَرَمٌ':Added, #1: 1	ذِكْرِ الْكَرَمِ
u'ذَكَرَ كعبة':Predicate, #1: 1	ذِكْرِ الْكَرَمِ
u'ذَكَرَ كَعْبَةٌ':Predicate, #1: 1	ذَكَرَ الْكَعْبَةَ
u'ذَكَرَ كَفَّارٌ':Predicate, #1: 1	ذَكَرَ الْكَعْبَةَ
u'ذَكَرَ كَفَّارٌ':Predicate, #1: 1	ذَكَرَ كَفَّارَةَ
u'ذكر كَفَّارٌ':Added, #2: 2	ذَكَرَ الْكَفَّارَةَ
u'ذِكْرٌ كَفَّارٌ':Added, #1: 1	ذِكْرَ الْكَفَّارَةِ
u'ذكر كَفَّارٌ':Added, #1: 1	ذِكْرَ الْكَفَّارَةِ
u'ذِكْرٌ كَفَّارٌ':Added, #1: 1	ذِكْرُ كَفَّارَةِ
u'ذكر كَفَّارٌ':Added, #1: 1	ذِكْرُ كَفَّارَةِ
u'ذِكْرٌ كَفَّارٌ':Added, #3: 3	ذِكْرِ الْكَفَّارَةِ
u'ذَكَرَ كَفَّارَةٌ':Predicate, #3: 3	ذِكْرِ الْكَفَّارَةِ
u'ذَكَرَ كَفَّارَةٌ':Predicate, #1: 1	ذَكَرَ كَفَّارَةَ
u'ذكر كَفَّارَةٌ':Added, #2: 2	ذَكَرَ الْكَفَّارَةَ
u'ذِكْرٌ كَفَّارَةٌ':Added, #1: 1	ذِكْرَ الْكَفَّارَةِ
u'ذكر كَفَّارَةٌ':Added, #1: 1	ذِكْرَ الْكَفَّارَةِ
u'ذِكْرٌ كَفَّارَةٌ':Added, #1: 1	ذِكْرُ كَفَّارَةِ
u'ذكر كَفَّارَةٌ':Added, #1: 1	ذِكْرُ كَفَّارَةِ
u'ذِكْرٌ كَفَّارَةٌ':Added, #3: 3	ذِكْرِ الْكَفَّارَةِ
u'ذَكَرَ كَفَالَةٌ':Predicate, #3: 3	ذِكْرِ الْكَفَّارَةِ
u'ذكر كَفَالَةٌ':Added, #1: 1	ذَكَرَ كَفَالَةَ
u'ذكر كَفَالَةٌ':Added, #1: 1	ذِكْرَ الْكَفَالَةِ
u'ذكر كَفَالَةٌ':Added, #1: 1	ذِكْرُ الْكَفَالَةِ
u'ذِكْرٌ كَفَالَةٌ':Added, #1: 1	ذِكْرِ الْكَفَالَةِ
u'ذِكْرٌ كَفَالَةٌ':Added, #1: 1	ذِكْرَ الْكَفَالَةِ
u'ذِكْرٌ كَفَالَةٌ':Added, #1: 1	ذِكْرُ الْكَفَالَةِ
u'ذكر كَفَالَةٌ':Added, #1: 1	ذِكْرِ الْكَفَالَةِ
u'ذِكْرٌ كَفَالَةٌ':Added, #1: 1	ذِكْرِ كَفَالَةِ
u'ذكر كِفَايَةٌ':Added, #1: 1	ذِكْرِ كَفَالَةِ
u'ذِكْرٌ كِفَايَةٌ':Added, #1: 1	ذِكْرِ الْكِفَايَةِ
u'ذَكَرَ كفر':Predicate, #1: 1	ذِكْرِ الْكِفَايَةِ
u'ذَكَرَ كُفْرٌ':Predicate, #1: 1	ذَكَرَ الْكُفْرَ
u'ذَكَرَ كفر':Predicate, #1: 1	ذَكَرَ الْكُفْرَ
u'ذَكَرَ كُفْرٌ':Predicate, #1: 1	ذَكَرَ كُفْرَ
u'ذكر كفر':Added, #1: 1	ذَكَرَ كُفْرَ
u'ذِكْرٌ كفر':Added, #1: 1	ذِكْرِ الْكُفْرِ
u'ذكر كُفْرٌ':Added, #1: 1	ذِكْرِ الْكُفْرِ
u'ذِكْرٌ كُفْرٌ':Added, #1: 1	ذِكْرِ الْكُفْرِ
u'ذَكَرَ كلاب':Predicate, #1: 1	ذِكْرِ الْكُفْرِ
u'ذَكَرَ كِلاَبٌ':Predicate, #1: 1	ذَكَرَ الْكِلَابَ
u'ذَكَرَ كَلاَمٌ':Predicate, #1: 1	ذَكَرَ الْكِلَابَ
u'ذَكَرَ كَلاَمٌ':Predicate, #14: 14	ذَكَرَ كَلَامَ
u'ذكر كَلاَمٌ':Added, #2: 2	ذَكَرَ الْكَلَامَ
u'ذِكْرٌ كَلاَمٌ':Added, #1: 1	ذِكْرُ كَلَامِ
u'ذكر كَلاَمٌ':Added, #1: 1	ذِكْرُ كَلَامِ
u'ذِكْرٌ كَلاَمٌ':Added, #2: 2	ذِكْرِ كَلَامِ
u'ذَكَرَ كَلْبٌ':Predicate, #2: 2	ذِكْرِ كَلَامِ
u'ذكر كَلْبٌ':Added, #1: 1	ذَكَرَ الْكَلْبَ
u'ذِكْرٌ كَلْبٌ':Added, #1: 1	ذِكْرِ الْكَلْبِ
u'ذَكَرَ كَلِمَةٌ':Predicate, #1: 1	ذِكْرِ الْكَلْبِ
u'ذكر كَلِمَةٌ':Added, #2: 2	ذَكَرَ كَلِمَةَ
u'ذِكْرٌ كَلِمَةٌ':Added, #1: 1	ذِكْرِ كَلِمَاتٍ
u'ذكر كَلِمَةٌ':Added, #1: 1	ذِكْرِ كَلِمَاتٍ
u'ذكر كَلِمَةٌ':Added, #1: 1	ذِكْرُ كَلِمَةٍ
u'ذِكْرٌ كَلِمَةٌ':Added, #1: 1	ذِكْرِ كَلِمَةِ
u'ذِكْرٌ كَلِمَةٌ':Added, #1: 1	ذِكْرُ كَلِمَةٍ
u'ذَكَرَ كِنَايَةٌ':Predicate, #1: 1	ذِكْرِ كَلِمَةِ
u'ذكر كَنْزٌ':Added, #1: 1	ذَكَرَ الْكِنَايَةَ
u'ذكر كَنْزٌ':Added, #1: 1	ذِكْرُ الْكَنْزِ
u'ذِكْرٌ كَنْزٌ':Added, #1: 1	ذِكْرِ الْكَنْزِ
u'ذِكْرٌ كَنْزٌ':Added, #1: 1	ذِكْرُ الْكَنْزِ
u'ذَكَرَ كُنْيَةٌ':Predicate, #1: 1	ذِكْرِ الْكَنْزِ
u'ذكر كُنْيَةٌ':Added, #1: 1	ذَكَرَ الْكُنْيَةَ
u'ذِكْرٌ كُنْيَةٌ':Added, #1: 1	ذِكْرَ الْكُنْيَةِ
u'ذكر كَوْثَرٌ':Added, #1: 1	ذِكْرَ الْكُنْيَةِ
u'ذِكْرٌ كَوْثَرٌ':Added, #1: 1	ذِكْرُ الْكَوْثَرِ
u'ذَكَرَ كَوْرٌ':Predicate, #1: 1	ذِكْرُ الْكَوْثَرِ
u'ذكر كُورَةٌ':Added, #1: 1	ذَكَرَ كَوْرَ
u'ذكر كُورَةٌ':Added, #1: 1	ذِكْرَ الْكُورَةِ
u'ذِكْرٌ كُورَةٌ':Added, #1: 1	ذِكْرِ الْكُورَةِ
u'ذِكْرٌ كُورَةٌ':Added, #1: 1	ذِكْرَ الْكُورَةِ
u'ذكر كَوْنٌ':Added, #1: 1	ذِكْرِ الْكُورَةِ
u'ذكر كَوْنٌ':Added, #1: 1	ذِكْر كَوْنِ
u'ذكر كَوْنٌ':Added, #1: 1	ذِكْرَ كَوْنِ
u'ذِكْرٌ كَوْنٌ':Added, #1: 1	ذِكْرُ كَوْنِ
u'ذِكْرٌ كَوْنٌ':Added, #1: 1	ذِكْر كَوْنِ
u'ذِكْرٌ كَوْنٌ':Added, #1: 1	ذِكْرَ كَوْنِ
u'ذكر كَوْنٌ':Added, #1: 1	ذِكْرُ كَوْنِ
u'ذكر كَوْنٌ':Added, #4: 4	ذِكْرُ كَوْنِهِ
u'ذِكْرٌ كَوْنٌ':Added, #4: 4	ذِكْرِ كَوْنِهِ
u'ذِكْرٌ كَوْنٌ':Added, #4: 4	ذِكْرُ كَوْنِهِ
u'ذَكَرَ كَيْفِيَّةٌ':Predicate, #4: 4	ذِكْرِ كَوْنِهِ
u'ذكر كَيْفِيَّةٌ':Added, #3: 3	ذَكَرَ كَيْفِيَّةَ
u'ذِكْرٌ كَيْفِيَّةٌ':Added, #1: 1	ذِكْرِ كَيْفِيَّةِ
u'ذكر كَيْلٌ':Added, #1: 1	ذِكْرِ كَيْفِيَّةِ
u'ذِكْرٌ كَيْلٌ':Added, #1: 1	ذِكْرِ الْكَيْلِ
u'ذَكَرَ لاَزِمٌ':Predicate, #1: 1	ذِكْرِ الْكَيْلِ
u'ذكر لاَزِمٌ':Added, #2: 2	ذَكَرَ اللَّازِمَ
u'ذِكْرٌ لاَزِمٌ':Added, #1: 1	ذِكْرُ اللَّازِمِ
u'ذكر لاَزِمٌ':Added, #1: 1	ذِكْرُ اللَّازِمِ
u'ذِكْرٌ لاَزِمٌ':Added, #1: 1	ذِكْرِ لَازِمِهِ
u'ذكر لآلِئُ':Added, #1: 1	ذِكْرِ لَازِمِهِ
u'ذِكْرٌ لآلِئُ':Added, #1: 1	ذِكْرِ اللَّآلِئِ
u'ذَكَرَ لاَمٌ':Predicate, #1: 1	ذِكْرِ اللَّآلِئِ
u'ذَكَرَ لبس':Subject, #2: 2	ذَكَرَ اللَّامَ
u'ذَكَرَ لُبْسٌ':Subject, #1: 1	ذَكَرَ لُبْسُ
u'ذَكَرَ لبن':Predicate, #1: 1	ذَكَرَ لُبْسُ
u'ذَكَرَ لَبَنٌ':Predicate, #2: 2	ذَكَرَ اللَّبَنَ
u'ذكر لبن':Added, #2: 2	ذَكَرَ اللَّبَنَ
u'ذكر لبن':Added, #1: 1	ذِكْرُ اللَّبَنِ
u'ذِكْرٌ لبن':Added, #1: 1	ذِكْرِ اللَّبَنِ
u'ذِكْرٌ لبن':Added, #1: 1	ذِكْرُ اللَّبَنِ
u'ذكر لَبَنٌ':Added, #1: 1	ذِكْرِ اللَّبَنِ
u'ذكر لَبَنٌ':Added, #1: 1	ذِكْرُ اللَّبَنِ
u'ذِكْرٌ لَبَنٌ':Added, #1: 1	ذِكْرِ اللَّبَنِ
u'ذِكْرٌ لَبَنٌ':Added, #1: 1	ذِكْرُ اللَّبَنِ
u'ذَكَرَ لَحْظ':Subject, #1: 1	ذِكْرِ اللَّبَنِ
u'ذَكَرَ لَحْظَة':Subject, #1: 1	ذَكَرَ لَحْظَةٌ
u'ذَكَرَ لَحْمٌ':Predicate, #1: 1	ذَكَرَ لَحْظَةٌ
u'ذكر لَحْمٌ':Added, #1: 1	ذَكَرَ اللَّحْمَ
u'ذِكْرٌ لَحْمٌ':Added, #2: 2	ذِكْرِ اللَّحْمِ
u'ذَكَرَ لُزُومٌ':Predicate, #2: 2	ذِكْرِ اللَّحْمِ
u'ذكر لُزُومٌ':Added, #2: 2	ذَكَرَ لُزُومَ
u'ذِكْرٌ لُزُومٌ':Added, #1: 1	ذِكْرُ اللُّزُومِ
u'ذكر لُزُومٌ':Added, #1: 1	ذِكْرُ اللُّزُومِ
u'ذِكْرٌ لُزُومٌ':Added, #1: 1	ذِكْرُ لُزُومِ
u'ذكر لِسَانٌ':Added, #1: 1	ذِكْرُ لُزُومِ
u'ذِكْرٌ لِسَانٌ':Added, #1: 1	ذِكْرَ اللِّسَانِ
u'ذكر لِسَانٌ':Added, #1: 1	ذِكْرَ اللِّسَانِ
u'ذِكْرٌ لِسَانٌ':Added, #2: 2	ذِكْرُ اللِّسَانِ
u'ذكر لِسَانٌ':Added, #2: 2	ذِكْرُ اللِّسَانِ
u'ذِكْرٌ لِسَانٌ':Added, #3: 3	ذِكْرِ اللِّسَانِ
u'ذَكَرَ لَفْظٌ':Predicate, #3: 3	ذِكْرِ اللِّسَانِ
u'ذكر لَفْظٌ':Added, #21: 21	ذَكَرَ لَفْظَ
u'ذِكْرٌ لَفْظٌ':Added, #1: 1	ذِكْرَ لَفْظِ
u'ذكر لَفْظٌ':Added, #1: 1	ذِكْرَ لَفْظِ
u'ذِكْرٌ لَفْظٌ':Added, #1: 1	ذِكْرِ لَفْظِهِ
u'ذكر لَفْظٌ':Added, #1: 1	ذِكْرِ لَفْظِهِ
u'ذِكْرٌ لَفْظٌ':Added, #2: 2	ذِكْرَ اللَّفْظِ
u'ذكر لَفْظٌ':Added, #2: 2	ذِكْرَ اللَّفْظِ
u'ذِكْرٌ لَفْظٌ':Added, #9: 9	ذِكْرِ لَفْظِ
u'ذَكَرَ لَفْظَةٌ':Predicate, #9: 9	ذِكْرِ لَفْظِ
u'ذكر لَفْظَةٌ':Added, #3: 3	ذَكَرَ لَفْظَةَ
u'ذِكْرٌ لَفْظَةٌ':Added, #1: 1	ذِكْرُ لَفْظَةِ
u'ذَكَرَ لِقَاءٌ':Predicate, #1: 1	ذِكْرُ لَفْظَةِ
u'ذكر لَقَبٌ':Added, #1: 1	ذَكَرَ لِقَاءَ
u'ذِكْرٌ لَقَبٌ':Added, #1: 1	ذِكْرَ اللَّقَبِ
u'ذكر لقطة':Added, #1: 1	ذِكْرَ اللَّقَبِ
u'ذِكْرٌ لقطة':Added, #3: 3	ذِكْرُ اللُّقَطَةِ
u'ذكر لِوَاءٌ':Added, #3: 3	ذِكْرُ اللُّقَطَةِ
u'ذِكْرٌ لِوَاءٌ':Added, #1: 1	ذِكْرَ اللِّوَاءِ
u'ذَكَرَ لَوْنٌ':Predicate, #1: 1	ذِكْرَ اللِّوَاءِ
u'ذكر لَوْنٌ':Added, #1: 1	ذَكَرَ اللَّوْنَ
u'ذِكْرٌ لَوْنٌ':Added, #1: 1	ذِكْرِ اللَّوْنِ
u'ذكر لَوْنٌ':Added, #1: 1	ذِكْرِ اللَّوْنِ
u'ذِكْرٌ لَوْنٌ':Added, #1: 1	ذِكْرِ لَوْنِ
u'ذكر لَوْنٌ':Added, #1: 1	ذِكْرِ لَوْنِ
u'ذِكْرٌ لَوْنٌ':Added, #2: 2	ذِكْرُ اللَّوْنِ
u'ذَكَرَ لَيَالِي':Predicate, #2: 2	ذِكْرُ اللَّوْنِ
u'ذكر لَيْلٌ':Added, #1: 1	ذَكَرَ اللَّيَالِيَ
u'ذِكْرٌ لَيْلٌ':Added, #1: 1	ذِكْرُ اللَّيْلَةِ
u'ذكر لَيْلٌ':Added, #1: 1	ذِكْرُ اللَّيْلَةِ
u'ذِكْرٌ لَيْلٌ':Added, #1: 1	ذِكْرِ لَيْلَةِ
u'ذكر لِينٌ':Added, #1: 1	ذِكْرِ لَيْلَةِ
u'ذِكْرٌ لِينٌ':Added, #2: 2	ذِكْرِ اللِّينِ
u'ذَكَرَ مَاءٌ':Predicate, #2: 2	ذِكْرِ اللِّينِ
u'ذكر مَادَّةٌ':Added, #6: 6	ذَكَرَ الْمَاءَ
u'ذِكْرٌ مَادَّةٌ':Added, #1: 1	ذِكْرِ الْمَادَّةِ
u'ذكر مَأْكُولٌ':Added, #1: 1	ذِكْرِ الْمَادَّةِ
u'ذِكْرٌ مَأْكُولٌ':Added, #3: 3	ذِكْرِ الْمَأْكُولِ
u'ذَكَرَ مَالٌ':Predicate, #3: 3	ذِكْرِ الْمَأْكُولِ
u'ذَكَرَ مَالٌ':Predicate, #1: 1	ذَكَرَ مَالَ
u'ذكر مَالٌ':Added, #3: 3	ذَكَرَ الْمَالَ
u'ذِكْرٌ مَالٌ':Added, #14: 14	ذِكْرِ الْمَالِ
u'ذكر مَالٌ':Added, #14: 14	ذِكْرِ الْمَالِ
u'ذِكْرٌ مَالٌ':Added, #3: 3	ذِكْرُ الْمَالِ
u'ذكر مَالٌ':Added, #3: 3	ذِكْرُ الْمَالِ
u'ذِكْرٌ مَالٌ':Added, #3: 3	ذِكْرِ مَالٍ
u'ذكر مَالٌ':Added, #3: 3	ذِكْرِ مَالٍ
u'ذِكْرٌ مَالٌ':Added, #5: 5	ذِكْرَ الْمَالِ
u'ذَكَرَ مَالِكٌ':Subject, #5: 5	ذِكْرَ الْمَالِ
u'ذَكَرَ مَالِكٌ':Subject, #2: 2	ذَكَرَ مَالِكُ
u'ذكر مَالِكٌ':Added, #4: 4	ذَكَرَ مَالِكٌ
u'ذكر مَالِكٌ':Added, #1: 1	ذِكْرُ مَالِكٍ
u'ذكر مَالِكٌ':Added, #1: 1	ذِكْرِ مَالِكٍ
u'ذِكْرٌ مَالِكٌ':Added, #1: 1	ذِكْرِ مَالِكِ
u'ذِكْرٌ مَالِكٌ':Added, #1: 1	ذِكْرُ مَالِكٍ
u'ذِكْرٌ مَالِكٌ':Added, #1: 1	ذِكْرِ مَالِكٍ
u'ذَكَرَ مَانِعٌ':Predicate, #1: 1	ذِكْرِ مَالِكِ
u'ذكر مُبَالَغَةٌ':Added, #1: 1	ذَكَرَ الْمَانِعَ
u'ذِكْرٌ مُبَالَغَةٌ':Added, #1: 1	ذِكْرَ الْمُبَالَغَةِ
u'ذكر مُبْتَدِئٌ':Added, #1: 1	ذِكْرَ الْمُبَالَغَةِ
u'ذِكْرٌ مُبْتَدِئٌ':Added, #2: 2	ذِكْرُ الْمُبْتَدِئِ
u'ذكر مَبِيتٌ':Added, #2: 2	ذِكْرُ الْمُبْتَدِئِ
u'ذِكْرٌ مَبِيتٌ':Added, #1: 1	ذِكْرُ الْمَبِيتِ
u'ذكر متبوع':Added, #1: 1	ذِكْرُ الْمَبِيتِ
u'ذِكْرٌ متبوع':Added, #1: 1	ذِكْرِ الْمَتْبُوعِ
u'ذَكَرَ مُتَخَلِّف':Predicate, #1: 1	ذِكْرِ الْمَتْبُوعِ
u'ذكر مَتْرُوكٌ':Added, #1: 1	ذَكَرَ الْمُتَخَلِّفِينَ
u'ذِكْرٌ مَتْرُوكٌ':Added, #1: 1	ذِكْرَ الْمَتْرُوكِ
u'ذكر مُتْعَةٌ':Added, #1: 1	ذِكْرَ الْمَتْرُوكِ
u'ذِكْرٌ مُتْعَةٌ':Added, #1: 1	ذِكْرِ الْمُتْعَةِ
u'ذَكَرَ مُتَعَلِّقٌ':Predicate, #1: 1	ذِكْرِ الْمُتْعَةِ
u'ذَكَرَ مُتَفَرِّقٌ':Predicate, #1: 1	ذَكَرَ مُتَعَلِّقَ
u'ذَكَرَ مِثَالٌ':Predicate, #1: 1	ذَكَرَ مُتَفَرِّقَةً
u'ذكر مِثَالٌ':Added, #1: 1	ذَكَرَ مِثَالَ
u'ذِكْرٌ مِثَالٌ':Added, #1: 1	ذِكْرِ الْمِثَالِ
u'ذكر مِثَالٌ':Added, #1: 1	ذِكْرِ الْمِثَالِ
u'ذِكْرٌ مِثَالٌ':Added, #1: 1	ذِكْرِ الْمِثَالَيْنِ
u'ذَكَرَ مثل':Predicate, #1: 1	ذِكْرِ الْمِثَالَيْنِ
u'ذَكَرَ مِثْلٌ':Predicate, #10: 10	ذَكَرَ مِثْلَ
u'ذكر مثل':Added, #10: 10	ذَكَرَ مِثْلَ
u'ذِكْرٌ مثل':Added, #1: 1	ذِكْرُ الْمِثْلِ
u'ذكر مِثْلٌ':Added, #1: 1	ذِكْرُ الْمِثْلِ
u'ذِكْرٌ مِثْلٌ':Added, #1: 1	ذِكْرُ الْمِثْلِ
u'ذكر مثل':Added, #1: 1	ذِكْرُ الْمِثْلِ
u'ذِكْرٌ مثل':Added, #1: 1	ذِكْرِ مِثْلِ
u'ذكر مِثْلٌ':Added, #1: 1	ذِكْرِ مِثْلِ
u'ذكر مِثْلٌ':Added, #1: 1	ذِكْرِ مِثْلٍ
u'ذِكْرٌ مِثْلٌ':Added, #1: 1	ذِكْرِ مِثْلِ
u'ذِكْرٌ مِثْلٌ':Added, #1: 1	ذِكْرِ مِثْلٍ
u'ذكر مثل':Added, #1: 1	ذِكْرِ مِثْلِ
u'ذِكْرٌ مثل':Added, #2: 2	ذِكْرِ الْمِثْلِ
u'ذكر مِثْلٌ':Added, #2: 2	ذِكْرِ الْمِثْلِ
u'ذِكْرٌ مِثْلٌ':Added, #2: 2	ذِكْرِ الْمِثْلِ
u'ذكر مِثْلِيٌّ':Added, #2: 2	ذِكْرِ الْمِثْلِ
u'ذِكْرٌ مِثْلِيٌّ':Added, #1: 1	ذِكْرِ الْمِثْلِيِّ
u'ذكر مِثْلِيٌّ':Added, #1: 1	ذِكْرِ الْمِثْلِيِّ
u'ذِكْرٌ مِثْلِيٌّ':Added, #1: 1	ذِكْرِ مِثْلِيٍّ
u'ذكر مُجَاهِدٌ':Added, #1: 1	ذِكْرِ مِثْلِيٍّ
u'ذِكْرٌ مُجَاهِدٌ':Added, #3: 3	ذِكْرِ مُجَاهِدٍ
u'ذكر مُجَاوَرَةٌ':Added, #3: 3	ذِكْرِ مُجَاهِدٍ
u'ذِكْرٌ مُجَاوَرَةٌ':Added, #1: 1	ذِكْرِ الْمُجَاوَرَةِ
u'ذَكَرَ مَجْدٌ':Subject, #1: 1	ذِكْرِ الْمُجَاوَرَةِ
u'ذَكَرَ مُجَرَّدٌ':Predicate, #4: 4	ذَكَرَ الْمَجْدُ
u'ذِكْرٌ مُجَرَّدٌ':Added, #1: 1	ذَكَرَ مُجَرَّدَ
u'ذكر مُجَرَّدٌ':Added, #1: 1	ذِكْرٍ مُجَرَّدٍ
u'ذِكْرٌ مُجَرَّدٌ':Added, #2: 2	ذِكْرُ مُجَرَّدِ
u'ذكر مَجَلَّةٌ':Added, #2: 2	ذِكْرُ مُجَرَّدِ
u'ذِكْرٌ مَجَلَّةٌ':Added, #1: 1	ذِكْرُ مَجَلّةِ
u'ذَكَرَ مَجْلِسٌ':Predicate, #1: 1	ذِكْرُ مَجَلّةِ
u'ذكر مَجْلِسٌ':Added, #2: 2	ذَكَرَ الْمَجْلِسَ
u'ذِكْرٌ مَجْلِسٌ':Added, #1: 1	ذِكْرِ الْمَجْلِسِ
u'ذكر مُجْمَعٌ':Added, #1: 1	ذِكْرِ الْمَجْلِسِ
u'ذِكْرٌ مُجْمَعٌ':Added, #1: 1	ذِكْرَ الْمُجْمَعِ
u'ذَكَرَ مَجُوسٌ':Predicate, #1: 1	ذِكْرَ الْمُجْمَعِ
u'ذكر مَحَاسِنُ':Added, #1: 1	ذَكَرَ الْمَجُوسَ
u'ذِكْرٌ مَحَاسِنُ':Added, #1: 1	ذِكْرِ مَحَاسِنِهِ
u'ذكر مُحَافَظَةٌ':Added, #1: 1	ذِكْرِ مَحَاسِنِهِ
u'ذِكْرٌ مُحَافَظَةٌ':Added, #1: 1	ذِكْرُ الْمُحَافَظَةِ
u'ذَكَرَ مُحِبٌّ':Subject, #1: 1	ذِكْرُ الْمُحَافَظَةِ
u'ذكر مَحَبَّةٌ':Added, #1: 1	ذَكَرَ الْمُحِبُّ
u'ذِكْرٌ مَحَبَّةٌ':Added, #1: 1	ذِكْرَ الْمَحَبَّةِ
u'ذِكْرٌ مُحْتَمَلٌ':Added, #1: 1	ذِكْرَ الْمَحَبَّةِ
u'ذَكَرَ مَحْدُودٌ':Predicate, #1: 1	ذِكْرٍ مُحْتَمَلٍ
u'ذكر مَحْدُودٌ':Added, #1: 1	ذَكَرَ الْمَحْدُودَ
u'ذِكْرٌ مَحْدُودٌ':Added, #1: 1	ذِكْرُ الْمَحْدُودِ
u'ذكر مَحْدُودٌ':Added, #1: 1	ذِكْرُ الْمَحْدُودِ
u'ذِكْرٌ مَحْدُودٌ':Added, #1: 1	ذِكْرِ الْمَحْدُودَاتِ
u'ذَكَرَ مُحَرَّمٌ':Subject, #1: 1	ذِكْرِ الْمَحْدُودَاتِ
u'ذكر مُحْرِمٌ':Added, #1: 1	ذَكَرَ الْمُحَرَّمَةُ
u'ذِكْرٌ مُحْرِمٌ':Added, #1: 1	ذِكْرُ الْمُحْرِمِ
u'ذكر مُحَرَّمٌ':Added, #1: 1	ذِكْرُ الْمُحْرِمِ
u'ذِكْرٌ مُحَرَّمٌ':Added, #1: 1	ذِكْرِ مُحَرَّمٍ
u'ذَكَرَ مُحَقِّقٌ':Subject, #1: 1	ذِكْرِ مُحَرَّمٍ
u'ذَكَرَ مَحَلٌّ':Predicate, #8: 8	ذَكَرَ الْمُحَقِّقُ
u'ذَكَرَ مَحَلٌّ':Subject, #1: 1	ذَكَرَ الْمَحَلَّ
u'ذكر مَحَلٌّ':Added, #1: 1	ذَكَرَ مَحَلُّهُ
u'ذِكْرٌ مَحَلٌّ':Added, #1: 1	ذِكْرِ الْمَحَلِّ
u'ذكر مَحَلٌّ':Added, #1: 1	ذِكْرِ الْمَحَلِّ
u'ذِكْرٌ مَحَلٌّ':Added, #1: 1	ذِكْرِ مَحَلِّ
u'ذكر مَحَلَّةٌ':Added, #1: 1	ذِكْرِ مَحَلِّ
u'ذِكْرٌ مَحَلَّةٌ':Added, #2: 2	ذِكْرِ الْمَحَلَّةِ
u'ذَكَرَ مُحَلِّقٌ':Predicate, #2: 2	ذِكْرِ الْمَحَلَّةِ
u'ذَكَرَ مُحَمَّدٌ':Predicate, #1: 1	ذَكَرَ الْمُحَلِّقِينَ
u'ذَكَرَ مُحَمَّدٌ':Subject, #3: 3	ذَكَرَ مُحَمَّدَ
u'ذَكَرَ مُحَمَّدٌ':Subject, #183: 183	ذَكَرَ مُحَمَّدٌ
u'ذَكَرَ مُحَمَّدٌ':Subject, #1: 1	ذَكَرَ مُحَمّدُ
u'ذكر مُحَمَّدٌ':Added, #8: 8	ذَكَرَ مُحَمَّدُ
u'ذكر مُحَمَّدٌ':Added, #1: 1	ذِكْرُ مُحَمّدٍ
u'ذكر مُحَمَّدٌ':Added, #1: 1	ذِكْرُ مُحَمَّدٍ
u'ذِكْرٌ مُحَمَّدٌ':Added, #1: 1	ذِكْرِ مُحَمَّدِ
u'ذِكْرٌ مُحَمَّدٌ':Added, #1: 1	ذِكْرُ مُحَمّدٍ
u'ذِكْرٌ مُحَمَّدٌ':Added, #1: 1	ذِكْرُ مُحَمَّدٍ
u'ذكر مُحَمَّدٌ':Added, #1: 1	ذِكْرِ مُحَمَّدِ
u'ذكر مُحَمَّدٌ':Added, #2: 2	ذِكْرَ مُحَمَّدٍ
u'ذِكْرٌ مُحَمَّدٌ':Added, #2: 2	ذِكْرِ مُحَمَّدٍ
u'ذِكْرٌ مُحَمَّدٌ':Added, #2: 2	ذِكْرَ مُحَمَّدٍ
u'ذَكَرَ مُخَاطَبٌ':Predicate, #2: 2	ذِكْرِ مُحَمَّدٍ
u'ذَكَرَ مُخَالِفٌ':Predicate, #1: 1	ذَكَرَ الْمُخَاطَبِينَ
u'ذَكَرَ مُخَالَفَةٌ':Predicate, #1: 1	ذَكَرَ مُخَالِفَ
u'ذَكَرَ مُخْتَارٌ':Predicate, #1: 1	ذَكَرَ مُخَالَفَةَ
u'ذكر مُخْتَارٌ':Added, #1: 1	ذَكَرَ الْمُخْتَارَ
u'ذِكْرٌ مُخْتَارٌ':Added, #1: 1	ذِكْرِ الْمُخْتَارِ
u'ذكر مُخْتَلَفٌ':Added, #1: 1	ذِكْرِ الْمُخْتَارِ
u'ذِكْرٌ مُخْتَلَفٌ':Added, #1: 1	ذِكْرِ الْمُخْتَلَفِ
u'ذَكَرَ مَخْرَجٌ':Predicate, #1: 1	ذِكْرِ الْمُخْتَلَفِ
u'ذِكْرٌ مَخْصُوصٌ':Added, #1: 1	ذَكَرَ مَخْرَجَ
u'ذكر مُخَوِّفٌ':Added, #1: 1	ذِكْرٍ مَخْصُوصٍ
u'ذِكْرٌ مُخَوِّفٌ':Added, #1: 1	ذِكْرِ الْمُخَوِّفَاتِ
u'ذكر مَدٌّ':Added, #1: 1	ذِكْرِ الْمُخَوِّفَاتِ
u'ذِكْرٌ مَدٌّ':Added, #1: 1	ذِكْرِ مَدٍّ
u'ذكر مُدٌّ':Added, #1: 1	ذِكْرِ مَدٍّ
u'ذِكْرٌ مُدٌّ':Added, #1: 1	ذِكْرِ مُدَّيْنِ
u'ذكر مُدَبَّرٌ':Added, #1: 1	ذِكْرِ مُدَّيْنِ
u'ذِكْرٌ مُدَبَّرٌ':Added, #1: 1	ذِكْرِ الْمُدَبَّرِ
u'ذَكَرَ مُدَّةٌ':Predicate, #1: 1	ذِكْرِ الْمُدَبَّرِ
u'ذَكَرَ مُدَّةٌ':Predicate, #1: 1	ذَكَرَ مُدَّةَ
u'ذكر مُدَّةٌ':Added, #4: 4	ذَكَرَ الْمُدَّةَ
u'ذِكْرٌ مُدَّةٌ':Added, #10: 10	ذِكْرِ الْمُدَّةِ
u'ذكر مُدَّةٌ':Added, #10: 10	ذِكْرِ الْمُدَّةِ
u'ذِكْرٌ مُدَّةٌ':Added, #1: 1	ذِكْرَ الْمُدَّةِ
u'ذكر مُدَّةٌ':Added, #1: 1	ذِكْرَ الْمُدَّةِ
u'ذكر مُدَّةٌ':Added, #1: 1	ذِكْرُ مُدَّةٍ
u'ذِكْرٌ مُدَّةٌ':Added, #1: 1	ذِكْرِ مُدَّةٍ
u'ذِكْرٌ مُدَّةٌ':Added, #1: 1	ذِكْرُ مُدَّةٍ
u'ذكر مُدَّةٌ':Added, #1: 1	ذِكْرِ مُدَّةٍ
u'ذِكْرٌ مُدَّةٌ':Added, #2: 2	ذِكْرُ الْمُدَّةِ
u'ذَكَرَ مَدْخُولٌ':Predicate, #2: 2	ذِكْرُ الْمُدَّةِ
u'ذكر مَدْعُوٌّ':Added, #1: 1	ذَكَرَ الْمَدْخُولَ
u'ذِكْرٌ مَدْعُوٌّ':Added, #1: 1	ذِكْرُ الْمَدْعُوِّ
u'ذكر مَذَاهِبُ':Added, #1: 1	ذِكْرُ الْمَدْعُوِّ
u'ذِكْرٌ مَذَاهِبُ':Added, #1: 1	ذِكْرِ مَذَاهِبِ
u'ذكر مَذْكُورٌ':Added, #1: 1	ذِكْرِ مَذَاهِبِ
u'ذِكْرٌ مَذْكُورٌ':Added, #1: 1	ذِكْرُ الْمَذْكُورِ
u'ذَكَرَ مَذْهَبٌ':Predicate, #1: 1	ذِكْرُ الْمَذْكُورِ
u'ذَكَرَ مَذْهَبٌ':Predicate, #1: 1	ذَكَرَ الْمَذْهَبَ
u'ذَكَرَ مَذْهَبٌ':Subject, #2: 2	ذَكَرَ مَذْهَبَ
u'ذكر مَذْهَبٌ':Added, #1: 1	ذَكَرَ مَذْهَبُ
u'ذِكْرٌ مَذْهَبٌ':Added, #1: 1	ذِكْرِ الْمَذْهَبِ
u'ذكر مَذْهَبٌ':Added, #1: 1	ذِكْرِ الْمَذْهَبِ
u'ذِكْرٌ مَذْهَبٌ':Added, #1: 1	ذِكْرِ مَذْهَبِهِ
u'ذكر مُرابَحَة':Added, #1: 1	ذِكْرِ مَذْهَبِهِ
u'ذِكْرٌ مُرابَحَة':Added, #1: 1	ذِكْرُ الْمُرَابَحَةِ
u'ذكر مَرَاتِبُ':Added, #1: 1	ذِكْرُ الْمُرَابَحَةِ
u'ذِكْرٌ مَرَاتِبُ':Added, #2: 2	ذِكْرِ مَرَاتِبِ
u'ذَكَرَ مَرَافِقُ':Predicate, #2: 2	ذِكْرِ مَرَاتِبِ
u'ذكر مَرَافِقُ':Added, #7: 7	ذَكَرَ الْمَرَافِقَ
u'ذكر مَرَافِقُ':Added, #1: 1	ذِكْرَ الْمَرَافِقِ
u'ذِكْرٌ مَرَافِقُ':Added, #1: 1	ذِكْرُ الْمَرَافِقِ
u'ذِكْرٌ مَرَافِقُ':Added, #1: 1	ذِكْرَ الْمَرَافِقِ
u'ذكر مَرَافِقُ':Added, #1: 1	ذِكْرُ الْمَرَافِقِ
u'ذِكْرٌ مَرَافِقُ':Added, #1: 1	ذِكْرِ مَرَافِقِ
u'ذكر مَرَافِقُ':Added, #1: 1	ذِكْرِ مَرَافِقِ
u'ذِكْرٌ مَرَافِقُ':Added, #3: 3	ذِكْرِ الْمَرَافِقِ
u'ذكر مُرْتَهِنٌ':Added, #3: 3	ذِكْرِ الْمَرَافِقِ
u'ذِكْرٌ مُرْتَهِنٌ':Added, #1: 1	ذِكْرُ الْمُرْتَهِنِ
u'ذكر مَرْجُوعٌ':Added, #1: 1	ذِكْرُ الْمُرْتَهِنِ
u'ذِكْرٌ مَرْجُوعٌ':Added, #1: 1	ذِكْرِ الْمَرْجُوعِ
u'ذكر مَرْفِقٌ':Added, #1: 1	ذِكْرِ الْمَرْجُوعِ
u'ذكر مَرْفِق':Added, #1: 1	ذِكْرَ الْمَرْفِقِ
u'ذِكْرٌ مَرْفِقٌ':Added, #1: 1	ذِكْرَ الْمَرْفِقِ
u'ذِكْرٌ مَرْفِق':Added, #1: 1	ذِكْرَ الْمَرْفِقِ
u'ذَكَرَ مَرْكَبٌ':Predicate, #1: 1	ذِكْرَ الْمَرْفِقِ
u'ذَكَرَ مَرْكُوبٌ':Predicate, #1: 1	ذَكَرَ الْمَرْكَبَ
u'ذكر مَرْكُوبٌ':Added, #1: 1	ذَكَرَ الْمَرْكُوبَ
u'ذِكْرٌ مَرْكُوبٌ':Added, #1: 1	ذِكْرِ الْمَرْكُوبِ
u'ذكر مُرُورٌ':Added, #1: 1	ذِكْرِ الْمَرْكُوبِ
u'ذِكْرٌ مُرُورٌ':Added, #1: 1	ذِكْرِ مُرُورِ
u'ذكر مَسَاجِدُ':Added, #1: 1	ذِكْرِ مُرُورِ
u'ذكر مَسَاجِدُ':Added, #1: 1	ذِكْرُ الْمَسَاجِدِ
u'ذِكْرٌ مَسَاجِدُ':Added, #1: 1	ذِكْرِ الْمَسَاجِدِ
u'ذِكْرٌ مَسَاجِدُ':Added, #1: 1	ذِكْرُ الْمَسَاجِدِ
u'ذكر مَسَافَةٌ':Added, #1: 1	ذِكْرِ الْمَسَاجِدِ
u'ذِكْرٌ مَسَافَةٌ':Added, #1: 1	ذِكْرِ الْمَسَافَةِ
u'ذكر مُسَافِرٌ':Added, #1: 1	ذِكْرِ الْمَسَافَةِ
u'ذِكْرٌ مُسَافِرٌ':Added, #1: 1	ذِكْرِ الْمُسَافِرِ
u'ذكر مساكين':Added, #1: 1	ذِكْرِ الْمُسَافِرِ
u'ذِكْرٌ مساكين':Added, #1: 1	ذِكْرُ الْمَسَاكِينِ
u'ذكر مساكين':Added, #1: 1	ذِكْرُ الْمَسَاكِينِ
u'ذِكْرٌ مساكين':Added, #2: 2	ذِكْرَ الْمَسَاكِينِ
u'ذَكَرَ مَسْأَلَةٌ':Predicate, #2: 2	ذِكْرَ الْمَسَاكِينِ
u'ذَكَرَ مَسْأَلَةٌ':Predicate, #24: 24	ذَكَرَ مَسْأَلَةَ
u'ذكر مَسْأَلَةٌ':Added, #70: 70	ذَكَرَ الْمَسْأَلَةَ
u'ذِكْرٌ مَسْأَلَةٌ':Added, #1: 1	ذِكْرَ الْمَسْأَلَةِ
u'ذكر مَسْأَلَةٌ':Added, #1: 1	ذِكْرَ الْمَسْأَلَةِ
u'ذِكْرٌ مَسْأَلَةٌ':Added, #2: 2	ذِكْرِ مَسْأَلَةِ
u'ذكر مَسْأَلَةٌ':Added, #2: 2	ذِكْرِ مَسْأَلَةِ
u'ذِكْرٌ مَسْأَلَةٌ':Added, #5: 5	ذِكْرُ مَسْأَلَةِ
u'ذكر مَسْأَلَةٌ':Added, #5: 5	ذِكْرُ مَسْأَلَةِ
u'ذِكْرٌ مَسْأَلَةٌ':Added, #7: 7	ذِكْرُ الْمَسْأَلَةِ
u'ذكر مَسْأَلَةٌ':Added, #7: 7	ذِكْرُ الْمَسْأَلَةِ
u'ذِكْرٌ مَسْأَلَةٌ':Added, #9: 9	ذِكْرِ الْمَسْأَلَةِ
u'ذَكَرَ مَسَاوِئُ':Predicate, #9: 9	ذِكْرِ الْمَسْأَلَةِ
u'ذكر مَسَاوِئُ':Added, #1: 1	ذَكَرَ مَسَاوِئَ
u'ذكر مَسَاوِئُ':Added, #1: 1	ذِكْرُ الْمَسَاوِئِ
u'ذِكْرٌ مَسَاوِئُ':Added, #1: 1	ذِكْرِ الْمَسَاوِئِ
u'ذِكْرٌ مَسَاوِئُ':Added, #1: 1	ذِكْرُ الْمَسَاوِئِ
u'ذكر مَسَاوِئُ':Added, #1: 1	ذِكْرِ الْمَسَاوِئِ
u'ذِكْرٌ مَسَاوِئُ':Added, #3: 3	ذِكْرُ مَسَاوِئِ
u'ذَكَرَ مَسَائِلُ':Predicate, #3: 3	ذِكْرُ مَسَاوِئِ
u'ذَكَرَ مَسَائِلُ':Predicate, #22: 22	ذَكَرَ مَسَائِلَ
u'ذكر مَسَائِلُ':Added, #3: 3	ذَكَرَ الْمَسَائِلَ
u'ذِكْرٌ مَسَائِلُ':Added, #1: 1	ذِكْرُ الْمَسَائِلِ
u'ذكر مَسَائِلُ':Added, #1: 1	ذِكْرُ الْمَسَائِلِ
u'ذِكْرٌ مَسَائِلُ':Added, #1: 1	ذِكْرَ مَسَائِلِ
u'ذكر مَسَائِلُ':Added, #1: 1	ذِكْرَ مَسَائِلِ
u'ذِكْرٌ مَسَائِلُ':Added, #4: 4	ذِكْرِ الْمَسَائِلِ
u'ذكر مَسَائِلُ':Added, #4: 4	ذِكْرِ الْمَسَائِلِ
u'ذِكْرٌ مَسَائِلُ':Added, #6: 6	ذِكْرِ مَسَائِلِ
u'ذكر مُسْتَعَارٌ':Added, #6: 6	ذِكْرِ مَسَائِلِ
u'ذِكْرٌ مُسْتَعَارٌ':Added, #1: 1	ذِكْرَ الْمُسْتَعَارِ
u'ذَكَرَ مُسْتَعِيرٌ':Subject, #1: 1	ذِكْرَ الْمُسْتَعَارِ
u'ذكر مُسْتَنَدٌ':Added, #1: 1	ذَكَرَ الْمُسْتَعِيرُ
u'ذِكْرٌ مُسْتَنَدٌ':Added, #1: 1	ذِكْرَ الْمُسْتَنَدِ
u'ذكر مُسْتَنَدٌ':Added, #1: 1	ذِكْرَ الْمُسْتَنَدِ
u'ذِكْرٌ مُسْتَنَدٌ':Added, #1: 1	ذِكْرِ مُسْتَنَدٍ
u'ذكر مَسْجِدٌ':Added, #1: 1	ذِكْرِ مُسْتَنَدٍ
u'ذِكْرٌ مَسْجِدٌ':Added, #1: 1	ذِكْرِ الْمَسْجِدِ
u'ذَكَرَ مَسْحٌ':Predicate, #1: 1	ذِكْرِ الْمَسْجِدِ
u'ذَكَرَ مَسْحٌ':Predicate, #1: 1	ذَكَرَ الْمَسْحَ
u'ذكر مَسْحٌ':Added, #1: 1	ذَكَرَ مَسْحَ
u'ذِكْرٌ مَسْحٌ':Added, #1: 1	ذِكْرُ الْمَسْحِ
u'ذكر مَسْرُوقٌ':Added, #1: 1	ذِكْرُ الْمَسْحِ
u'ذِكْرٌ مَسْرُوقٌ':Added, #1: 1	ذِكْرُ مَسْرُوقٍ
u'ذكر مَسْكُوتٌ':Added, #1: 1	ذِكْرُ مَسْرُوقٍ
u'ذِكْرٌ مَسْكُوتٌ':Added, #1: 1	ذِكْرِ الْمَسْكُوتِ
u'ذَكَرَ مُسَلَّمٌ':Subject, #1: 1	ذِكْرِ الْمَسْكُوتِ
u'ذكر مُسْلِمٌ':Added, #1: 1	ذَكَرَ مُسَلَّمٌ
u'ذِكْرٌ مُسْلِمٌ':Added, #1: 1	ذِكْرَ الْمُسْلِمِ
u'ذكر مُسْلِمٌ':Added, #1: 1	ذِكْرَ الْمُسْلِمِ
u'ذِكْرٌ مُسْلِمٌ':Added, #1: 1	ذِكْرِ الْمُسْلِمَةِ
u'ذكر مَسِيرٌ':Added, #1: 1	ذِكْرِ الْمُسْلِمَةِ
u'ذِكْرٌ مَسِيرٌ':Added, #1: 1	ذِكْرُ الْمَسِيرِ
u'ذكر مُشار':Added, #1: 1	ذِكْرُ الْمَسِيرِ
u'ذِكْرٌ مُشار':Added, #1: 1	ذِكْرَ الْمُشَارِ
u'ذَكَرَ مَشَايِخُ':Subject, #1: 1	ذِكْرَ الْمُشَارِ
u'ذَكَرَ مَشَايِخُ':Subject, #1: 1	ذَكَرَ مَشَايِخُ
u'ذكر مَشْهُودٌ':Added, #5: 5	ذَكَرَ الْمَشَايِخُ
u'ذِكْرٌ مَشْهُودٌ':Added, #3: 3	ذِكْرِ الْمَشْهُودِ
u'ذَكَرَ مَشِيئَةٌ':Predicate, #3: 3	ذِكْرِ الْمَشْهُودِ
u'ذكر مَشِيئَةٌ':Added, #1: 1	ذَكَرَ الْمَشِيئَةَ
u'ذِكْرٌ مَشِيئَةٌ':Added, #1: 1	ذِكْرَ الْمَشِيئَةِ
u'ذكر مَشِيئَةٌ':Added, #1: 1	ذِكْرَ الْمَشِيئَةِ
u'ذِكْرٌ مَشِيئَةٌ':Added, #3: 3	ذِكْرُ الْمَشِيئَةِ
u'ذَكَرَ مَصٌّ':Predicate, #3: 3	ذِكْرُ الْمَشِيئَةِ
u'ذكر مَصَارِفُ':Added, #1: 1	ذَكَرَ الْمَصَّ
u'ذِكْرٌ مَصَارِفُ':Added, #1: 1	ذِكْرُ الْمَصَارِفِ
u'ذَكَرَ مَصَانِعُ':Predicate, #1: 1	ذِكْرُ الْمَصَارِفِ
u'ذَكَرَ مَصْدَرٌ':Predicate, #1: 1	ذَكَرَ الْمَصَانِعَ
u'ذكر مَصْدَرٌ':Added, #1: 1	ذَكَرَ الْمَصْدَرَ
u'ذِكْرٌ مَصْدَرٌ':Added, #1: 1	ذِكْرِ الْمَصْدَرِ
u'ذكر مِصْرٌ':Added, #1: 1	ذِكْرِ الْمَصْدَرِ
u'ذِكْرٌ مِصْرٌ':Added, #1: 1	ذِكْرُ الْمِصْرِ
u'ذكر مَصْرِفٌ':Added, #1: 1	ذِكْرُ الْمِصْرِ
u'ذِكْرٌ مَصْرِفٌ':Added, #1: 1	ذِكْرِ الْمَصْرِفِ
u'ذَكَرَ مُصَنِّفٌ':Subject, #1: 1	ذِكْرِ الْمَصْرِفِ
u'ذكر مُصَنِّفٌ':Added, #226: 226	ذَكَرَ الْمُصَنِّفُ
u'ذِكْرٌ مُصَنِّفٌ':Added, #1: 1	ذِكْرَ الْمُصَنِّفِ
u'ذكر مُصَنِّفٌ':Added, #1: 1	ذِكْرَ الْمُصَنِّفِ
u'ذِكْرٌ مُصَنِّفٌ':Added, #5: 5	ذِكْرِ الْمُصَنِّفِ
u'ذَكَرَ مُصِيبٌ':Predicate, #5: 5	ذِكْرِ الْمُصَنِّفِ
u'ذكر مُصِيبٌ':Added, #1: 1	ذَكَرَ الْمُصِيبَةَ
u'ذِكْرٌ مُصِيبٌ':Added, #1: 1	ذِكْرَ الْمُصِيبَةِ
u'ذَكَرَ مُصِيبَةٌ':Predicate, #1: 1	ذِكْرَ الْمُصِيبَةِ
u'ذكر مُصِيبَةٌ':Added, #1: 1	ذَكَرَ الْمُصِيبَةَ
u'ذِكْرٌ مُصِيبَةٌ':Added, #1: 1	ذِكْرَ الْمُصِيبَةِ
u'ذَكَرَ مُضَافٌ':Predicate, #1: 1	ذِكْرَ الْمُصِيبَةِ
u'ذكر مُضَافٌ':Added, #2: 2	ذَكَرَ الْمُضَافَ
u'ذِكْرٌ مُضَافٌ':Added, #1: 1	ذِكْرُ الْمُضَافِ
u'ذَكَرَ مَضْمُونٌ':Predicate, #1: 1	ذِكْرُ الْمُضَافِ
u'ذكر مَضْمُونٌ':Added, #3: 3	ذَكَرَ مَضْمُونَ
u'ذِكْرٌ مَضْمُونٌ':Added, #1: 1	ذِكْرُ مَضْمُونٍ
u'ذكر مُطَالَبٌ':Added, #1: 1	ذِكْرُ مَضْمُونٍ
u'ذِكْرٌ مُطَالَبٌ':Added, #1: 1	ذِكْرُ الْمُطَالَبَةِ
u'ذكر مُطَالَبَةٌ':Added, #1: 1	ذِكْرُ الْمُطَالَبَةِ
u'ذِكْرٌ مُطَالَبَةٌ':Added, #1: 1	ذِكْرُ الْمُطَالَبَةِ
u'ذكر مُطْعِمٌ':Added, #1: 1	ذِكْرُ الْمُطَالَبَةِ
u'ذِكْرٌ مُطْعِمٌ':Added, #1: 1	ذِكْرِ مُطْعِمٍ
u'ذَكَرَ مُطَلَّقٌ':Predicate, #1: 1	ذِكْرِ مُطْعِمٍ
u'ذكر مُطَلَّقٌ':Added, #1: 1	ذَكَرَ الْمُطَلَّقَةَ
u'ذِكْرٌ مُطَلَّقٌ':Added, #1: 1	ذِكْرِ الْمُطَلَّقَاتِ
u'ذكر مُطْلَقٌ':Added, #1: 1	ذِكْرِ الْمُطَلَّقَاتِ
u'ذكر مُطْلَقٌ':Added, #1: 1	ذِكْرُ مُطْلَقِ
u'ذِكْرٌ مُطْلَقٌ':Added, #1: 1	ذِكْرِ مُطْلَقِ
u'ذِكْرٌ مُطْلَقٌ':Added, #1: 1	ذِكْرُ مُطْلَقِ
u'ذكر مُظْهَرٌ':Added, #1: 1	ذِكْرِ مُطْلَقِ
u'ذِكْرٌ مُظْهَرٌ':Added, #1: 1	ذِكْرُ الْمُظْهَرِ
u'ذَكَرَ مَعَادِنُ':Predicate, #1: 1	ذِكْرُ الْمُظْهَرِ
u'ذكر مَعَاذِيرُ':Added, #1: 1	ذَكَرَ الْمَعَادِنَ
u'ذِكْرٌ مَعَاذِيرُ':Added, #1: 1	ذِكْرَ الْمَعَاذِيرِ
u'ذكر مُعَارَضَةٌ':Added, #1: 1	ذِكْرَ الْمَعَاذِيرِ
u'ذِكْرٌ مُعَارَضَةٌ':Added, #1: 1	ذِكْرَ مُعَارَضَةِ
u'ذكر مَعَايِبُ':Added, #1: 1	ذِكْرَ مُعَارَضَةِ
u'ذِكْرٌ مَعَايِبُ':Added, #1: 1	ذِكْرُ مَعَايِبِ
u'ذَكَرَ مُعْتَرِضٌ':Subject, #1: 1	ذِكْرُ مَعَايِبِ
u'ذَكَرَ مُعْتَزِلٌ':Predicate, #2: 2	ذَكَرَ الْمُعْتَرِضُ
u'ذَكَرَ مُعْتَزِلَةٌ':Predicate, #1: 1	ذَكَرَ الْمُعْتَزِلَةَ
u'ذَكَرَ مُعْتَقٌ':Predicate, #1: 1	ذَكَرَ الْمُعْتَزِلَةَ
u'ذكر مُعْجِزٌ':Added, #1: 1	ذَكَرَ الْمُعْتَقَةَ
u'ذِكْرٌ مُعْجِزٌ':Added, #1: 1	ذِكْرِ الْمُعْجِزَاتِ
u'ذكر مُعْجِزَةٌ':Added, #1: 1	ذِكْرِ الْمُعْجِزَاتِ
u'ذِكْرٌ مُعْجِزَةٌ':Added, #1: 1	ذِكْرِ الْمُعْجِزَاتِ
u'ذكر مَعْدُودٌ':Added, #1: 1	ذِكْرِ الْمُعْجِزَاتِ
u'ذِكْرٌ مَعْدُودٌ':Added, #2: 2	ذِكْرِ الْمَعْدُودِ
u'ذكر مَعْدُومٌ':Added, #2: 2	ذِكْرِ الْمَعْدُودِ
u'ذِكْرٌ مَعْدُومٌ':Added, #1: 1	ذِكْرُ الْمَعْدُومِ
u'ذكر مَعْذِرَةٌ':Added, #1: 1	ذِكْرُ الْمَعْدُومِ
u'ذِكْرٌ مَعْذِرَةٌ':Added, #1: 1	ذِكْرِ مَعْذِرَةٍ
u'ذَكَرَ مَعْرِفَةٌ':Predicate, #1: 1	ذِكْرِ مَعْذِرَةٍ
u'ذَكَرَ مَعْرِفَة':Predicate, #1: 1	ذَكَرَ الْمَعْرِفَةَ
u'ذَكَرَ مَعْصِيَةٌ':Subject, #1: 1	ذَكَرَ الْمَعْرِفَةَ
u'ذَكَرَ مُعْظَمٌ':Predicate, #1: 1	ذَكَرَ مَعْصِيَةٌ
u'ذَكَرَ مُعْظَمٌ':Predicate, #1: 1	ذَكَرَ الْمُعْظَمَ
u'ذكر مَعْقُودٌ':Added, #2: 2	ذَكَرَ مُعْظَمَ
u'ذِكْرٌ مَعْقُودٌ':Added, #1: 1	ذِكْرُ الْمَعْقُودِ
u'ذَكَرَ مُعَلِّلٌ':Subject, #1: 1	ذِكْرُ الْمَعْقُودِ
u'ذكر مَعْلُولٌ':Added, #2: 2	ذَكَرَ الْمُعَلِّلُ
u'ذِكْرٌ مَعْلُولٌ':Added, #1: 1	ذِكْرِ الْمَعْلُولِ
u'ذكر مَعْلُومٌ':Added, #1: 1	ذِكْرِ الْمَعْلُولِ
u'ذِكْرٌ مَعْلُومٌ':Added, #1: 1	ذِكْرَ الْمَعْلُومِ
u'ذكر مَعْلُومٌ':Added, #1: 1	ذِكْرَ الْمَعْلُومِ
u'ذِكْرٌ مَعْلُومٌ':Added, #1: 1	ذِكْرُ الْمَعْلُومَاتِ
u'ذكر مَغْشُوشٌ':Added, #1: 1	ذِكْرُ الْمَعْلُومَاتِ
u'ذِكْرٌ مَغْشُوشٌ':Added, #1: 1	ذِكْرِ الْمَغْشُوشِ
u'ذكر مَغْفِرَةٌ':Added, #1: 1	ذِكْرِ الْمَغْشُوشِ
u'ذِكْرٌ مَغْفِرَةٌ':Added, #1: 1	ذِكْرِ الْمَغْفِرَةِ
u'ذَكَرَ مُغَنِّي':Predicate, #1: 1	ذِكْرِ الْمَغْفِرَةِ
u'ذكر مُفْرَدٌ':Added, #1: 1	ذَكَرَ الْمُغَنِّيَةَ
u'ذِكْرٌ مُفْرَدٌ':Added, #1: 1	ذِكْرِ الْمُفْرَدِ
u'ذكر مُفْرَدٌ':Added, #1: 1	ذِكْرِ الْمُفْرَدِ
u'ذِكْرٌ مُفْرَدٌ':Added, #1: 1	ذِكْرِ الْمُفْرَدَاتِ
u'ذكر مُفْرَدٌ':Added, #1: 1	ذِكْرِ الْمُفْرَدَاتِ
u'ذِكْرٌ مُفْرَدٌ':Added, #1: 1	ذِكْرِ مُفْرَدَاتٍ
u'ذَكَرَ مَفْرُوضٌ':Subject, #1: 1	ذِكْرِ مُفْرَدَاتٍ
u'ذِكْرٌ مَفْرُوضٌ':Added, #1: 1	ذَكَرَ مَفْرُوضٌ
u'ذكر مَفْعُولٌ':Added, #1: 1	ذِكْرٍ مَفْرُوضٍ
u'ذكر مَفْعُولٌ':Added, #1: 1	ذِكْرُ الْمَفْعُولِ
u'ذِكْرٌ مَفْعُولٌ':Added, #1: 1	ذِكْرِ الْمَفْعُولِ
u'ذِكْرٌ مَفْعُولٌ':Added, #1: 1	ذِكْرُ الْمَفْعُولِ
u'ذكر مُفَلَّج':Added, #1: 1	ذِكْرِ الْمَفْعُولِ
u'ذِكْرٌ مُفَلَّج':Added, #1: 1	ذِكْرُ مُفَلَّجِ
u'ذَكَرَ مَفْهُومٌ':Predicate, #1: 1	ذِكْرُ مُفَلَّجِ
u'ذكر مَفْهُومٌ':Added, #10: 10	ذَكَرَ مَفْهُومَ
u'ذِكْرٌ مَفْهُومٌ':Added, #1: 1	ذِكْرَ مَفْهُومٍ
u'ذكر مَفْهُومٌ':Added, #1: 1	ذِكْرَ مَفْهُومٍ
u'ذِكْرٌ مَفْهُومٌ':Added, #1: 1	ذِكْر مَفْهُومِهِ
u'ذكر مُقَابِلٌ':Added, #1: 1	ذِكْر مَفْهُومِهِ
u'ذِكْرٌ مُقَابِلٌ':Added, #1: 1	ذِكْرِ الْمُقَابِلِ
u'ذكر مُقَابِلٌ':Added, #1: 1	ذِكْرِ الْمُقَابِلِ
u'ذِكْرٌ مُقَابِلٌ':Added, #1: 1	ذِكْرَ مُقَابِلِهِ
u'ذَكَرَ مَقَادِيرُ':Predicate, #1: 1	ذِكْرَ مُقَابِلِهِ
u'ذكر مُقَاصَّةٌ':Added, #1: 1	ذَكَرَ مَقَادِيرَ
u'ذِكْرٌ مُقَاصَّةٌ':Added, #1: 1	ذِكْرِ الْمُقَاصَّةِ
u'ذكر مَقَاعِدُ':Added, #1: 1	ذِكْرِ الْمُقَاصَّةِ
u'ذِكْرٌ مَقَاعِدُ':Added, #2: 2	ذِكْرَ الْمَقَاعِدِ
u'ذَكَرَ مَقَالَةٌ':Predicate, #2: 2	ذِكْرَ الْمَقَاعِدِ
u'ذَكَرَ مَقَامٌ':Predicate, #2: 2	ذَكَرَ مَقَالَةَ
u'ذكر مِقْدَارٌ':Added, #2: 2	ذَكَرَ مَقَامَ
u'ذِكْرٌ مِقْدَارٌ':Added, #1: 1	ذِكْرَ الْمِقْدَارِ
u'ذكر مِقْدَارٌ':Added, #1: 1	ذِكْرَ الْمِقْدَارِ
u'ذِكْرٌ مِقْدَارٌ':Added, #2: 2	ذِكْرِ الْمِقْدَارِ
u'ذَكَرَ مَقْدِسِيٌّ':Predicate, #2: 2	ذِكْرِ الْمِقْدَارِ
u'ذكر مُقَدِّمٌ':Added, #1: 1	ذَكَرَ الْمَقْدِسِيَّ
u'ذِكْرٌ مُقَدِّمٌ':Added, #1: 1	ذِكْرُ الْمُقَدِّمَةِ
u'ذكر مُقَدِّمٌ':Added, #1: 1	ذِكْرُ الْمُقَدِّمَةِ
u'ذِكْرٌ مُقَدِّمٌ':Added, #1: 1	ذِكْرِ مُقَدِّمَةٍ
u'ذكر مُقَدِّمٌ':Added, #1: 1	ذِكْرِ مُقَدِّمَةٍ
u'ذِكْرٌ مُقَدِّمٌ':Added, #3: 3	ذِكْرِ مُقَدِّمَاتِ
u'ذكر مُقَدِّمَةٌ':Added, #3: 3	ذِكْرِ مُقَدِّمَاتِ
u'ذِكْرٌ مُقَدِّمَةٌ':Added, #1: 1	ذِكْرُ الْمُقَدِّمَةِ
u'ذكر مُقَدِّمَةٌ':Added, #1: 1	ذِكْرُ الْمُقَدِّمَةِ
u'ذِكْرٌ مُقَدِّمَةٌ':Added, #1: 1	ذِكْرِ مُقَدِّمَةٍ
u'ذكر مُقَدِّمَةٌ':Added, #1: 1	ذِكْرِ مُقَدِّمَةٍ
u'ذِكْرٌ مُقَدِّمَةٌ':Added, #3: 3	ذِكْرِ مُقَدِّمَاتِ
u'ذكر مَقْصُودٌ':Added, #3: 3	ذِكْرِ مُقَدِّمَاتِ
u'ذِكْرٌ مَقْصُودٌ':Added, #1: 1	ذِكْرِ الْمَقْصُودِ
u'ذكر مُقْمِرٌ':Added, #1: 1	ذِكْرِ الْمَقْصُودِ
u'ذِكْرٌ مُقْمِرٌ':Added, #1: 1	ذِكْرِ مُقْمِرٍ
u'ذكر مُقَيَّدٌ':Added, #1: 1	ذِكْرِ مُقْمِرٍ
u'ذِكْرٌ مُقَيَّدٌ':Added, #1: 1	ذِكْرَ الْمُقَيَّدِ
u'ذكر مُقِيمٌ':Added, #1: 1	ذِكْرَ الْمُقَيَّدِ
u'ذِكْرٌ مُقِيمٌ':Added, #1: 1	ذِكْرِ الْمُقِيمِ
u'ذكر مكارم':Added, #1: 1	ذِكْرِ الْمُقِيمِ
u'ذِكْرٌ مكارم':Added, #1: 1	ذِكْرِ الْمَكَارِمِ
u'ذكر مَكَارِمُ':Added, #1: 1	ذِكْرِ الْمَكَارِمِ
u'ذِكْرٌ مَكَارِمُ':Added, #1: 1	ذِكْرِ الْمَكَارِمِ
u'ذَكَرَ مَكَانٌ':Predicate, #1: 1	ذِكْرِ الْمَكَارِمِ
u'ذَكَرَ مَكَانٌ':Predicate, #1: 1	ذَكَرَ الْمَكَانَ
u'ذكر مَكَانٌ':Added, #4: 4	ذَكَرَ مَكَانَ
u'ذكر مَكَانٌ':Added, #1: 1	ذِكْرَ مَكَانِ
u'ذِكْرٌ مَكَانٌ':Added, #1: 1	ذِكْرِ مَكَانِ
u'ذِكْرٌ مَكَانٌ':Added, #1: 1	ذِكْرَ مَكَانِ
u'ذكر مَكَانٌ':Added, #1: 1	ذِكْرِ مَكَانِ
u'ذِكْرٌ مَكَانٌ':Added, #1: 1	ذِكْرِ مَكَانِهِ
u'ذكر مَكَانٌ':Added, #1: 1	ذِكْرِ مَكَانِهِ
u'ذكر مَكَانٌ':Added, #2: 2	ذِكْرَ الْمَكَانِ
u'ذِكْرٌ مَكَانٌ':Added, #2: 2	ذِكْرُ الْمَكَانِ
u'ذِكْرٌ مَكَانٌ':Added, #2: 2	ذِكْرَ الْمَكَانِ
u'ذكر مَكَانٌ':Added, #2: 2	ذِكْرُ الْمَكَانِ
u'ذِكْرٌ مَكَانٌ':Added, #4: 4	ذِكْرُ مَكَانِ
u'ذَكَرَ مَكْرُوهٌ':Subject, #4: 4	ذِكْرُ مَكَانِ
u'ذكر مَكْرُوهٌ':Added, #1: 1	ذَكَرَ مَكْرُوهٌ
u'ذِكْرٌ مَكْرُوهٌ':Added, #1: 1	ذِكْرَ الْمَكْرُوهَاتِ
u'ذكر مَكْرُوهَةٌ':Added, #1: 1	ذِكْرَ الْمَكْرُوهَاتِ
u'ذِكْرٌ مَكْرُوهَةٌ':Added, #1: 1	ذِكْرَ الْمَكْرُوهَاتِ
u'ذَكَرَ مُلاَمَسَةٌ':Predicate, #1: 1	ذِكْرَ الْمَكْرُوهَاتِ
u'ذكر مُلاَمَسَةٌ':Added, #1: 1	ذَكَرَ الْمُلَامَسَةَ
u'ذِكْرٌ مُلاَمَسَةٌ':Added, #1: 1	ذِكْرَ الْمُلَامَسَةِ
u'ذَكَرَ مَلاَئِكَةٌ':Predicate, #1: 1	ذِكْرَ الْمُلَامَسَةِ
u'ذكر مَلاَئِكَةٌ':Added, #1: 1	ذَكَرَ الْمَلَائِكَةَ
u'ذِكْرٌ مَلاَئِكَةٌ':Added, #2: 2	ذِكْرِ الْمَلَائِكَةِ
u'ذكر مَلْزُوم':Added, #2: 2	ذِكْرِ الْمَلَائِكَةِ
u'ذكر مَلْزُوم':Added, #1: 1	ذِكْرَ الْمَلْزُومِ
u'ذِكْرٌ مَلْزُوم':Added, #1: 1	ذِكْرُ الْمَلْزُومِ
u'ذِكْرٌ مَلْزُوم':Added, #1: 1	ذِكْرَ الْمَلْزُومِ
u'ذكر مَلْزُوم':Added, #1: 1	ذِكْرُ الْمَلْزُومِ
u'ذِكْرٌ مَلْزُوم':Added, #2: 2	ذِكْرِ الْمَلْزُومِ
u'ذَكَرَ مُلْكٌ':Predicate, #2: 2	ذِكْرِ الْمَلْزُومِ
u'ذكر مِلْكٌ':Added, #1: 1	ذَكَرَ الْمُلْكَ
u'ذكر مِلْكٌ':Added, #1: 1	ذِكْرُ الْمِلْكِ
u'ذِكْرٌ مِلْكٌ':Added, #1: 1	ذِكْرِ الْمِلْكِ
u'ذِكْرٌ مِلْكٌ':Added, #1: 1	ذِكْرُ الْمِلْكِ
u'ذكر مِلْكٌ':Added, #1: 1	ذِكْرِ الْمِلْكِ
u'ذِكْرٌ مِلْكٌ':Added, #4: 4	ذِكْرَ الْمِلْكِ
u'ذكر مِلْكٌ':Added, #4: 4	ذِكْرَ الْمِلْكِ
u'ذِكْرٌ مِلْكٌ':Added, #4: 4	ذِكْرِ مِلْكِ
u'ذكر مُلُوكٌ':Added, #4: 4	ذِكْرِ مِلْكِ
u'ذِكْرٌ مُلُوكٌ':Added, #1: 1	ذِكْرِ مُلُوكِ
u'ذكر مَمْدوحٌ':Added, #1: 1	ذِكْرِ مُلُوكِ
u'ذِكْرٌ مَمْدوحٌ':Added, #1: 1	ذِكْرِ الْمَمْدُوحِ
u'ذَكَرَ مَمْنُوعٌ':Subject, #1: 1	ذِكْرِ الْمَمْدُوحِ
u'ذَكَرَ مَنَاقِبُ':Predicate, #1: 1	ذَكَرَ مَمْنُوعٌ
u'ذكر مَنَاقِبُ':Added, #1: 1	ذَكَرَ مَنَاقِبَ
u'ذِكْرٌ مَنَاقِبُ':Added, #1: 1	ذِكْرِ مَنَاقِبِ
u'ذكر مِنْبَرٌ':Added, #1: 1	ذِكْرِ مَنَاقِبِ
u'ذِكْرٌ مِنْبَرٌ':Added, #1: 1	ذِكْرِ الْمِنْبَرِ
u'ذَكَرَ مِنَّةٌ':Predicate, #1: 1	ذِكْرِ الْمِنْبَرِ
u'ذَكَرَ مُنْتَسِبٌ':Predicate, #1: 1	ذَكَرَ مِنَّةَ
u'ذَكَرَ مَنْسِيٌّ':Predicate, #1: 1	ذَكَرَ الْمُنْتَسِبَ
u'ذَكَرَ مَنْسِيٌّ':Predicate, #1: 1	ذَكَرَ مَنْسِيَّةً
u'ذكر مَنْسِيٌّ':Added, #2: 2	ذَكَرَ الْمَنْسِيَّةَ
u'ذِكْرٌ مَنْسِيٌّ':Added, #2: 2	ذِكْرُ الْمَنْسِيَّةِ
u'ذَكَرَ مَنْصُوصٌ':Predicate, #2: 2	ذِكْرُ الْمَنْسِيَّةِ
u'ذَكَرَ مَنْصُوصٌ':Subject, #1: 1	ذَكَرَ الْمَنْصُوصَ
u'ذكر مَنْطِقٌ':Added, #1: 1	ذَكَرَ الْمَنْصُوصُ
u'ذِكْرٌ مَنْطِقٌ':Added, #1: 1	ذِكْرِ الْمَنْطِقِ
u'ذَكَرَ مَنْعٌ':Predicate, #1: 1	ذِكْرِ الْمَنْطِقِ
u'ذَكَرَ مَنْعٌ':Predicate, #1: 1	ذَكَرَ مَنْعَ
u'ذكر مَنْعٌ':Added, #3: 3	ذَكَرَ الْمَنْعَ
u'ذِكْرٌ مَنْعٌ':Added, #1: 1	ذِكْرِ الْمَنْعِ
u'ذَكَرَ مَنْفَعَةٌ':Predicate, #1: 1	ذِكْرِ الْمَنْعِ
u'ذكر مَنْقُولٌ':Added, #2: 2	ذَكَرَ مَنْفَعَةَ
u'ذِكْرٌ مَنْقُولٌ':Added, #1: 1	ذِكْرِ مَنْقُولَاتٍ
u'ذَكَرَ مِنْهَاجٌ':Subject, #1: 1	ذِكْرِ مَنْقُولَاتٍ
u'ذَكَرَ مَنِيٌّ':Predicate, #1: 1	ذَكَرَ الْمِنْهَاجُ
u'ذَكَرَ مَنِيَّةٌ':Predicate, #1: 1	ذَكَرَ الْمَنِيَّ
u'ذكر مَهْدِيٌّ':Added, #1: 1	ذَكَرَ الْمَنِيَّةَ
u'ذِكْرٌ مَهْدِيٌّ':Added, #1: 1	ذِكْرِ الْمَهْدِيِّ
u'ذَكَرَ مَهْرٌ':Predicate, #1: 1	ذِكْرِ الْمَهْدِيِّ
u'ذكر مَهْرٌ':Added, #1: 1	ذَكَرَ الْمَهْرَ
u'ذِكْرٌ مَهْرٌ':Added, #3: 3	ذِكْرِ مَهْرٍ
u'ذكر مَهْرٌ':Added, #3: 3	ذِكْرِ مَهْرٍ
u'ذِكْرٌ مَهْرٌ':Added, #4: 4	ذِكْرُ الْمَهْرِ
u'ذكر مَهْرٌ':Added, #4: 4	ذِكْرُ الْمَهْرِ
u'ذِكْرٌ مَهْرٌ':Added, #9: 9	ذِكْرِ الْمَهْرِ
u'ذَكَرَ مَوَاضِعُ':Predicate, #9: 9	ذِكْرِ الْمَهْرِ
u'ذكر مَوَاضِعُ':Added, #1: 1	ذَكَرَ الْمَوَاضِعَ
u'ذِكْرٌ مَوَاضِعُ':Added, #1: 1	ذِكْرِ الْمَوَاضِعِ
u'ذَكَرَ مَوَاقِيتُ':Predicate, #1: 1	ذِكْرِ الْمَوَاضِعِ
u'ذكر مَوَاقِيتُ':Added, #1: 1	ذَكَرَ مَوَاقِيتَ
u'ذكر مَوَاقِيتُ':Added, #1: 1	ذِكْرَ الْمَوَاقِيتِ
u'ذِكْرٌ مَوَاقِيتُ':Added, #1: 1	ذِكْرِ الْمَوَاقِيتِ
u'ذِكْرٌ مَوَاقِيتُ':Added, #1: 1	ذِكْرَ الْمَوَاقِيتِ
u'ذَكَرَ مَوْتٌ':Predicate, #1: 1	ذِكْرِ الْمَوَاقِيتِ
u'ذَكَرَ مَوْتٌ':Predicate, #2: 2	ذَكَرَ الْمَوْتَ
u'ذكر مَوْتٌ':Added, #3: 3	ذَكَرَ مَوْتَ
u'ذِكْرٌ مَوْتٌ':Added, #2: 2	ذِكْرُ الْمَوْتِ
u'ذكر مَوْتٌ':Added, #2: 2	ذِكْرُ الْمَوْتِ
u'ذِكْرٌ مَوْتٌ':Added, #3: 3	ذِكْرَ الْمَوْتِ
u'ذكر مَوْتٌ':Added, #3: 3	ذِكْرَ الْمَوْتِ
u'ذِكْرٌ مَوْتٌ':Added, #4: 4	ذِكْرِ الْمَوْتِ
u'ذَكَرَ مُوجِبٌ':Predicate, #4: 4	ذِكْرِ الْمَوْتِ
u'ذَكَرَ مُوجِبٌ':Predicate, #1: 1	ذَكَرَ الْمُوجِبَ
u'ذَكَرَ مُوجَبٌ':Predicate, #1: 1	ذَكَرَ مُوجِبَ
u'ذكر مُوجِبٌ':Added, #2: 2	ذَكَرَ الْمُوجَبَ
u'ذِكْرٌ مُوجِبٌ':Added, #1: 1	ذِكْرُ الْمُوجِبِ
u'ذَكَرَ مُؤَذِّنٌ':Predicate, #1: 1	ذِكْرُ الْمُوجِبِ
u'ذكر مُؤَذِّنٌ':Added, #1: 1	ذَكَرَ الْمُؤَذِّنِينَ
u'ذِكْرٌ مُؤَذِّنٌ':Added, #1: 1	ذِكْرِ الْمُؤَذِّنِ
u'ذَكَرَ مُوَرِّقٌ':Subject, #1: 1	ذِكْرِ الْمُؤَذِّنِ
u'ذكر مَوْصُوفٌ':Added, #2: 2	ذَكَرَ الْمُوَرِّقُ
u'ذِكْرٌ مَوْصُوفٌ':Added, #2: 2	ذِكْرِ الْمَوْصُوفِ
u'ذَكَرَ مَوْضِعٌ':Predicate, #2: 2	ذِكْرِ الْمَوْصُوفِ
u'ذكر مَوْضِعٌ':Added, #3: 3	ذَكَرَ مَوْضِعَ
u'ذِكْرٌ مَوْضِعٌ':Added, #1: 1	ذِكْرَ الْمَوْضِعِ
u'ذكر مَوْضِعٌ':Added, #1: 1	ذِكْرَ الْمَوْضِعِ
u'ذِكْرٌ مَوْضِعٌ':Added, #1: 1	ذِكْرَ مَوْضِعِ
u'ذكر مَوْضِعٌ':Added, #1: 1	ذِكْرَ مَوْضِعِ
u'ذِكْرٌ مَوْضِعٌ':Added, #1: 1	ذِكْرِ مَوْضِعِهِ
u'ذكر مَوْضِعٌ':Added, #1: 1	ذِكْرِ مَوْضِعِهِ
u'ذكر مَوْضِعٌ':Added, #2: 2	ذِكْرُ مَوْضِعِ
u'ذِكْرٌ مَوْضِعٌ':Added, #2: 2	ذِكْرِ مَوْضِعِ
u'ذِكْرٌ مَوْضِعٌ':Added, #2: 2	ذِكْرُ مَوْضِعِ
u'ذكر مَوْضُوعٌ':Added, #2: 2	ذِكْرِ مَوْضِعِ
u'ذِكْرٌ مَوْضُوعٌ':Added, #1: 1	ذِكْرِ الْمَوْضُوعِ
u'ذكر مُؤَكَّدٌ':Added, #1: 1	ذِكْرِ الْمَوْضُوعِ
u'ذِكْرٌ مُؤَكَّدٌ':Added, #1: 1	ذِكْرُ الْمُؤَكَّدِ
u'ذَكَرَ مُوَكِّلٌ':Subject, #1: 1	ذِكْرُ الْمُؤَكَّدِ
u'ذكر مُوَكِّلٌ':Added, #1: 1	ذَكَرَ الْمُوَكِّلُ
u'ذكر مُوَكِّلٌ':Added, #2: 2	ذِكْرُ الْمُوَكِّلِ
u'ذِكْرٌ مُوَكِّلٌ':Added, #2: 2	ذِكْرِ الْمُوَكِّلِ
u'ذِكْرٌ مُوَكِّلٌ':Added, #2: 2	ذِكْرُ الْمُوَكِّلِ
u'ذكر مَوْلِدٌ':Added, #2: 2	ذِكْرِ الْمُوَكِّلِ
u'ذِكْرٌ مَوْلِدٌ':Added, #1: 1	ذِكْرِ مَوْلِدِهِ
u'ذَكَرَ مُؤَلِّفٌ':Subject, #1: 1	ذِكْرِ مَوْلِدِهِ
u'ذَكَرَ مُؤْمِنٌ':Predicate, #31: 31	ذَكَرَ الْمُؤَلِّفُ
u'ذَكَرَ مُؤْمِنٌ':Predicate, #1: 1	ذَكَرَ الْمُؤْمِنَ
u'ذكر مُؤْمِنٌ':Added, #1: 1	ذَكَرَ الْمُؤْمِنِينَ
u'ذِكْرٌ مُؤْمِنٌ':Added, #1: 1	ذِكْرَ الْمُؤْمِنِ
u'ذكر مُؤْمِنٌ':Added, #1: 1	ذِكْرَ الْمُؤْمِنِ
u'ذِكْرٌ مُؤْمِنٌ':Added, #1: 1	ذِكْرَ الْمُؤْمِنَاتِ
u'ذكر مُؤْنِسٌ':Added, #1: 1	ذِكْرَ الْمُؤْمِنَاتِ
u'ذِكْرٌ مُؤْنِسٌ':Added, #1: 1	ذِكْرَ الْمُؤْنِسَةِ
u'ذَكَرَ مِيرَاثٌ':Predicate, #1: 1	ذِكْرَ الْمُؤْنِسَةِ
u'ذَكَرَ مِيزَانٌ':Subject, #1: 1	ذَكَرَ مِيرَاثَ
u'ذكر مِيقَاتٌ':Added, #1: 1	ذَكَرَ الْمِيزَانُ
u'ذِكْرٌ مِيقَاتٌ':Added, #1: 1	ذِكْرُ الْمِيقَاتِ
u'ذكر نَاحِي':Added, #1: 1	ذِكْرُ الْمِيقَاتِ
u'ذكر نَاحِي':Added, #1: 1	ذِكْرُ النَّاحِيَةِ
u'ذِكْرٌ نَاحِي':Added, #1: 1	ذِكْرِ النَّاحِيَةِ
u'ذِكْرٌ نَاحِي':Added, #1: 1	ذِكْرُ النَّاحِيَةِ
u'ذكر نَاحِيَةٌ':Added, #1: 1	ذِكْرِ النَّاحِيَةِ
u'ذكر نَاحِيَةٌ':Added, #1: 1	ذِكْرُ النَّاحِيَةِ
u'ذِكْرٌ نَاحِيَةٌ':Added, #1: 1	ذِكْرِ النَّاحِيَةِ
u'ذِكْرٌ نَاحِيَةٌ':Added, #1: 1	ذِكْرُ النَّاحِيَةِ
u'ذكر نَادِرٌ':Added, #1: 1	ذِكْرِ النَّاحِيَةِ
u'ذِكْرٌ نَادِرٌ':Added, #1: 1	ذِكْرِ النَّادِرِ
u'ذَكَرَ نَارٌ':Predicate, #1: 1	ذِكْرِ النَّادِرِ
u'ذكر نَارٌ':Added, #1: 1	ذَكَرَ النَّارَ
u'ذِكْرٌ نَارٌ':Added, #3: 3	ذِكْرَ النَّارِ
u'ذكر نَارٌ':Added, #3: 3	ذِكْرَ النَّارِ
u'ذِكْرٌ نَارٌ':Added, #4: 4	ذِكْرِ النَّارِ
u'ذكر نَارٌ':Added, #4: 4	ذِكْرِ النَّارِ
u'ذِكْرٌ نَارٌ':Added, #5: 5	ذِكْرُ النَّارِ
u'ذَكَرَ نَاسٌ':Predicate, #5: 5	ذِكْرُ النَّارِ
u'ذَكَّرَ نَاسٌ':Predicate, #1: 1	ذَكَرَ النّاسَ
u'ذَكَرَ نَاصِرٌ':Subject, #1: 1	ذَكَّرَ النَّاسَ
u'ذَكَرَ نَاظِمٌ':Subject, #1: 1	ذَكَرَ النَّاصِرُ
u'ذكر نَاقَةٌ':Added, #1: 1	ذَكَرَ نَاظِمُ
u'ذكر نَاقَة':Added, #1: 1	ذِكْرِ النَّاقَةِ
u'ذِكْرٌ نَاقَةٌ':Added, #1: 1	ذِكْرِ النَّاقَةِ
u'ذِكْرٌ نَاقَة':Added, #1: 1	ذِكْرِ النَّاقَةِ
u'ذَكَرَ نَبِيٌّ':Predicate, #1: 1	ذِكْرِ النَّاقَةِ
u'ذَكَرَ نَبِيٌّ':Subject, #1: 1	ذَكَرَ النَّبِيَّ
u'ذكر نَبِيٌّ':Added, #5: 5	ذَكَرَ النَّبِيُّ
u'ذِكْرٌ نَبِيٌّ':Added, #1: 1	ذِكْرِ النَّبِيِّ
u'ذكر نَبِيٌّ':Added, #1: 1	ذِكْرِ النَّبِيِّ
u'ذكر نَبِيٌّ':Added, #1: 1	ذِكْرُ نَبِيِّهِ
u'ذِكْرٌ نَبِيٌّ':Added, #1: 1	ذِكْرِ نَبِيِّهِ
u'ذِكْرٌ نَبِيٌّ':Added, #1: 1	ذِكْرُ نَبِيِّهِ
u'ذكر نَبِيٌّ':Added, #1: 1	ذِكْرِ نَبِيِّهِ
u'ذكر نَبِيٌّ':Added, #3: 3	ذِكْرَ النَّبِيِّ
u'ذِكْرٌ نَبِيٌّ':Added, #3: 3	ذِكْرُ النَّبِيِّ
u'ذِكْرٌ نَبِيٌّ':Added, #3: 3	ذِكْرَ النَّبِيِّ
u'ذَكَرَ نَبِيذٌ':Predicate, #3: 3	ذِكْرُ النَّبِيِّ
u'ذكر نَبِيذٌ':Added, #1: 1	ذَكَرَ نَبِيذَ
u'ذِكْرٌ نَبِيذٌ':Added, #1: 1	ذِكْرُ نَبِيذِ
u'ذكر نجاة':Added, #1: 1	ذِكْرُ نَبِيذِ
u'ذِكْرٌ نجاة':Added, #1: 1	ذِكْرُ نَجَاةِ
u'ذكر نَجَاةٌ':Added, #1: 1	ذِكْرُ نَجَاةِ
u'ذِكْرٌ نَجَاةٌ':Added, #1: 1	ذِكْرُ نَجَاةِ
u'ذكر نَجَاسَةٌ':Added, #1: 1	ذِكْرُ نَجَاةِ
u'ذِكْرٌ نَجَاسَةٌ':Added, #1: 1	ذِكْرِ النَّجَاسَاتِ
u'ذكر نَجَاسَةٌ':Added, #1: 1	ذِكْرِ النَّجَاسَاتِ
u'ذِكْرٌ نَجَاسَةٌ':Added, #1: 1	ذِكْرِ النَّجَاسَةِ
u'ذكر نَجاشِيّ':Added, #1: 1	ذِكْرِ النَّجَاسَةِ
u'ذِكْرٌ نَجاشِيّ':Added, #1: 1	ذِكْرُ النَّجَاشِيِّ
u'ذَكَرَ نَجْمٌ':Subject, #1: 1	ذِكْرُ النَّجَاشِيِّ
u'ذَكَرَ نُحَاةٌ':Subject, #1: 1	ذَكَرَ نَجْمُ
u'ذَكَرَ نَحَّاسٌ':Subject, #1: 1	ذَكَرَ النُّحَاةُ
u'ذكر نَحْلٌ':Added, #1: 1	ذَكَرَ النّحّاسُ
u'ذِكْرٌ نَحْلٌ':Added, #1: 1	ذِكْرِ النَّحْلِ
u'ذَكَرَ نَحْوٌ':Predicate, #1: 1	ذِكْرِ النَّحْلِ
u'ذَكَرَ نَحْوٌ':Subject, #10: 10	ذَكَرَ نَحْوَ
u'ذكر نَحْوٌ':Added, #1: 1	ذَكَرَ نَحْوُ
u'ذكر نَحْوٌ':Added, #1: 1	ذِكْرَ نَحْوِ
u'ذكر نَحْوٌ':Added, #1: 1	ذِكْرُ نَحْوِ
u'ذِكْرٌ نَحْوٌ':Added, #1: 1	ذِكْرِ نَحْوِ
u'ذِكْرٌ نَحْوٌ':Added, #1: 1	ذِكْرَ نَحْوِ
u'ذِكْرٌ نَحْوٌ':Added, #1: 1	ذِكْرُ نَحْوِ
u'ذكر نخلة':Added, #1: 1	ذِكْرِ نَحْوِ
u'ذِكْرٌ نخلة':Added, #3: 3	ذِكْرِ النَّخْلَةِ
u'ذكر نَخْلَةٌ':Added, #3: 3	ذِكْرِ النَّخْلَةِ
u'ذِكْرٌ نَخْلَةٌ':Added, #3: 3	ذِكْرِ النَّخْلَةِ
u'ذَكَرَ نَدْبٌ':Predicate, #3: 3	ذِكْرِ النَّخْلَةِ
u'ذكر نذر':Added, #1: 1	ذَكَرَ النَّدْبَ
u'ذِكْرٌ نذر':Added, #1: 1	ذِكْرَ النَّذْرِ
u'ذكر نَذْرٌ':Added, #1: 1	ذِكْرَ النَّذْرِ
u'ذِكْرٌ نَذْرٌ':Added, #1: 1	ذِكْرَ النَّذْرِ
u'ذكر نذر':Added, #1: 1	ذِكْرَ النَّذْرِ
u'ذِكْرٌ نذر':Added, #2: 2	ذِكْرُ نَذْرِ
u'ذكر نَذْرٌ':Added, #2: 2	ذِكْرُ نَذْرِ
u'ذِكْرٌ نَذْرٌ':Added, #2: 2	ذِكْرُ نَذْرِ
u'ذَكَرَ نُزُولٌ':Predicate, #2: 2	ذِكْرُ نَذْرِ
u'ذكر نُزُولٌ':Added, #2: 2	ذَكَرَ نُزُولَ
u'ذِكْرٌ نُزُولٌ':Added, #1: 1	ذِكْرُ نُزُولِ
u'ذَكَرَ نِساءٌ':Predicate, #1: 1	ذِكْرُ نُزُولِ
u'ذكر نِساءٌ':Added, #2: 2	ذَكَرَ النِّسَاءَ
u'ذِكْرٌ نِساءٌ':Added, #1: 1	ذِكْرُ النِّسَاءِ
u'ذَكَرَ نَسَبٌ':Predicate, #1: 1	ذِكْرُ النِّسَاءِ
u'ذكر نَسَبٌ':Added, #1: 1	ذَكَرَ نَسَبَ
u'ذكر نَسَبٌ':Added, #1: 1	ذِكْرِ النّسَبِ
u'ذكر نِسَبٌ':Added, #1: 1	ذِكْرِ النَّسَبِ
u'ذِكْرٌ نَسَبٌ':Added, #1: 1	ذِكْرِ النّسَبِ
u'ذِكْرٌ نَسَبٌ':Added, #1: 1	ذِكْرِ النّسَبِ
u'ذِكْرٌ نِسَبٌ':Added, #1: 1	ذِكْرِ النَّسَبِ
u'ذَكَرَ نِسْبَةٌ':Predicate, #1: 1	ذِكْرِ النّسَبِ
u'ذكر نِسْبَةٌ':Added, #1: 1	ذَكَرَ النِّسْبَةَ
u'ذِكْرٌ نِسْبَةٌ':Added, #1: 1	ذِكْرِ النِّسْبَةِ
u'ذكر نِسْبِيَّةٌ':Added, #1: 1	ذِكْرِ النِّسْبَةِ
u'ذِكْرٌ نِسْبِيَّةٌ':Added, #1: 1	ذِكْرِ النِّسْبِيَّةِ
u'ذكر نُسُكٌ':Added, #1: 1	ذِكْرِ النِّسْبِيَّةِ
u'ذِكْرٌ نُسُكٌ':Added, #1: 1	ذِكْرِ نُسُكٍ
u'ذكر نُسُكٌ':Added, #1: 1	ذِكْرِ نُسُكٍ
u'ذِكْرٌ نُسُكٌ':Added, #2: 2	ذِكْرُ نُسُكِهِ
u'ذكر نَسْلٌ':Added, #2: 2	ذِكْرُ نُسُكِهِ
u'ذِكْرٌ نَسْلٌ':Added, #1: 1	ذِكْرِ النَّسْلِ
u'ذكر نِسْوَةٌ':Added, #1: 1	ذِكْرِ النَّسْلِ
u'ذِكْرٌ نِسْوَةٌ':Added, #1: 1	ذِكْرِ النِّسْوَةِ
u'ذكر نَسِيبٌ':Added, #1: 1	ذِكْرِ النِّسْوَةِ
u'ذِكْرٌ نَسِيبٌ':Added, #1: 1	ذِكْرِ النَّسِيبِ
u'ذَكَرَ نَصٌّ':Predicate, #1: 1	ذِكْرِ النَّسِيبِ
u'ذَكَرَ نَصٌّ':Predicate, #3: 3	ذَكَرَ نَصَّ
u'ذكر نَصٌّ':Added, #6: 6	ذَكَرَ النَّصَّ
u'ذِكْرٌ نَصٌّ':Added, #1: 1	ذِكْرِ النَّصِّ
u'ذَكَرَ نصرة':Predicate, #1: 1	ذِكْرِ النَّصِّ
u'ذَكَرَ نُصْرَةٌ':Predicate, #1: 1	ذَكَرَ نُصْرَةَ
u'ذكر نِصْفٌ':Added, #1: 1	ذَكَرَ نُصْرَةَ
u'ذِكْرٌ نِصْفٌ':Added, #1: 1	ذِكْرَ النِّصْفِ
u'ذكر نِصْفٌ':Added, #1: 1	ذِكْرَ النِّصْفِ
u'ذِكْرٌ نِصْفٌ':Added, #1: 1	ذِكْرَ نِصْفِ
u'ذكر نِصْفٌ':Added, #1: 1	ذِكْرَ نِصْفِ
u'ذِكْرٌ نِصْفٌ':Added, #2: 2	ذِكْرُ النِّصْفِ
u'ذَكَرَ نَصْلٌ':Predicate, #2: 2	ذِكْرُ النِّصْفِ
u'ذَكَرَ نُصُوصٌ':Predicate, #1: 1	ذَكَرَ النَّصْلَ
u'ذكر نَصِيبٌ':Added, #2: 2	ذَكَرَ النُّصُوصَ
u'ذِكْرٌ نَصِيبٌ':Added, #1: 1	ذِكْرِ نَصِيبِ
u'ذَكَرَ نظائر':Predicate, #1: 1	ذِكْرِ نَصِيبِ
u'ذكر نظائر':Added, #1: 1	ذَكَرَ نَظَائِرَ
u'ذِكْرٌ نظائر':Added, #1: 1	ذِكْرُ نَظَائِرِ
u'ذَكَرَ نَظَرٌ':Predicate, #1: 1	ذِكْرُ نَظَائِرِ
u'ذَكَرَ نَظَرٌ':Subject, #1: 1	ذَكَرَ النَّظَرَ
u'ذَكَرَ نَظِيرٌ':Predicate, #1: 1	ذَكَرَ نَظَرٌ
u'ذَكَرَ نَظِيرٌ':Subject, #1: 1	ذَكَرَ نَظِيرَ
u'ذَكَرَ نَعْتٌ':Predicate, #1: 1	ذَكَرَ نَظِيرُ
u'ذكر نَعْتٌ':Added, #2: 2	ذَكَرَ النَّعْتَ
u'ذِكْرٌ نَعْتٌ':Added, #1: 1	ذِكْرَ النَّعْتِ
u'ذكر نَعَمٌ':Added, #1: 1	ذِكْرَ النَّعْتِ
u'ذكر نِعَمٌ':Added, #1: 1	ذِكْرِ النَّعَمِ
u'ذكر نِعَمٌ':Added, #1: 1	ذِكْرُ النِّعَمِ
u'ذِكْرٌ نَعَمٌ':Added, #1: 1	ذِكْرِ النِّعَمِ
u'ذِكْرٌ نِعَمٌ':Added, #1: 1	ذِكْرِ النَّعَمِ
u'ذِكْرٌ نِعَمٌ':Added, #1: 1	ذِكْرُ النِّعَمِ
u'ذكر نُعْمَانُ':Added, #1: 1	ذِكْرِ النِّعَمِ
u'ذِكْرٌ نُعْمَانُ':Added, #1: 1	ذِكْرُ النّعْمَانِ
u'ذَكَرَ نعمة':Predicate, #1: 1	ذِكْرُ النّعْمَانِ
u'ذَكَرَ نِعْمَةٌ':Predicate, #1: 1	ذَكَرَ نِعْمَةَ
u'ذكر نعمة':Added, #1: 1	ذَكَرَ نِعْمَةَ
u'ذِكْرٌ نعمة':Added, #1: 1	ذِكْرَ النِّعْمَةِ
u'ذكر نِعْمَةٌ':Added, #1: 1	ذِكْرَ النِّعْمَةِ
u'ذِكْرٌ نِعْمَةٌ':Added, #1: 1	ذِكْرَ النِّعْمَةِ
u'ذكر نعمة':Added, #1: 1	ذِكْرَ النِّعْمَةِ
u'ذِكْرٌ نعمة':Added, #1: 1	ذِكْرِ نِعْمَةِ
u'ذكر نِعْمَةٌ':Added, #1: 1	ذِكْرِ نِعْمَةِ
u'ذِكْرٌ نِعْمَةٌ':Added, #1: 1	ذِكْرِ نِعْمَةِ
u'ذكر نُعُوتٌ':Added, #1: 1	ذِكْرِ نِعْمَةِ
u'ذِكْرٌ نُعُوتٌ':Added, #1: 1	ذِكْرِ النُّعُوتِ
u'ذكر نفر':Added, #1: 1	ذِكْرِ النُّعُوتِ
u'ذِكْرٌ نفر':Added, #1: 1	ذِكْرُ النَّفَرِ
u'ذكر نَفَرٌ':Added, #1: 1	ذِكْرُ النَّفَرِ
u'ذِكْرٌ نَفَرٌ':Added, #1: 1	ذِكْرُ النَّفَرِ
u'ذَكَرَ نَفْسٌ':Predicate, #1: 1	ذِكْرُ النَّفَرِ
u'ذكر نَفْسٌ':Added, #2: 2	ذَكَرَ نَفْسَ
u'ذِكْرٌ نَفْسٌ':Added, #1: 1	ذِكْرَ النَّفْسِ
u'ذكر نَفْسٌ':Added, #1: 1	ذِكْرَ النَّفْسِ
u'ذِكْرٌ نَفْسٌ':Added, #23: 23	ذِكْرِ النَّفْسِ
u'ذكر نَفْسٌ':Added, #23: 23	ذِكْرِ النَّفْسِ
u'ذِكْرٌ نَفْسٌ':Added, #2: 2	ذِكْرُ النَّفْسِ
u'ذكر نَفْسٌ':Added, #2: 2	ذِكْرُ النَّفْسِ
u'ذِكْرٌ نَفْسٌ':Added, #3: 3	ذِكْرِ نَفْسِ
u'ذَكَرَ نَفَقَةٌ':Predicate, #3: 3	ذِكْرِ نَفْسِ
u'ذكر نَفَقَةٌ':Added, #1: 1	ذَكَرَ النَّفَقَةَ
u'ذِكْرٌ نَفَقَةٌ':Added, #1: 1	ذِكْرِ النَّفَقَةِ
u'ذكر نَفَقَةٌ':Added, #1: 1	ذِكْرِ النَّفَقَةِ
u'ذِكْرٌ نَفَقَةٌ':Added, #1: 1	ذِكْرَ نَفَقَةٍ
u'ذكر نَفْلٌ':Added, #1: 1	ذِكْرَ نَفَقَةٍ
u'ذِكْرٌ نَفْلٌ':Added, #1: 1	ذِكْرِ النَّفْلِ
u'ذَكَرَ نُفُوذٌ':Predicate, #1: 1	ذِكْرِ النَّفْلِ
u'ذَكَرَ نَفْيٌ':Predicate, #1: 1	ذَكَرَ نُفُوذَ
u'ذكر نَفْيٌ':Added, #1: 1	ذَكَرَ نَفْيَ
u'ذِكْرٌ نَفْيٌ':Added, #1: 1	ذِكْرَ نَفْيِ
u'ذَكَرَ نَقَّاشٌ':Subject, #1: 1	ذِكْرَ نَفْيِ
u'ذَكَرَ نَقَّاشٌ':Subject, #1: 1	ذَكَرَ النّقّاشُ
u'ذَكَرَ نَقْدٌ':Predicate, #1: 1	ذَكَرَ النَّقَّاشُ
u'ذَكَرَ نَقْد':Predicate, #2: 2	ذَكَرَ نَقْدَ
u'ذكر نَقْدٌ':Added, #2: 2	ذَكَرَ نَقْدَ
u'ذكر نَقْد':Added, #1: 1	ذِكْرِ النَّقْدَيْنِ
u'ذِكْرٌ نَقْدٌ':Added, #1: 1	ذِكْرِ النَّقْدَيْنِ
u'ذِكْرٌ نَقْد':Added, #1: 1	ذِكْرِ النَّقْدَيْنِ
u'ذَكَرَ نَقْضٌ':Predicate, #1: 1	ذِكْرِ النَّقْدَيْنِ
u'ذكر نَقْضٌ':Added, #1: 1	ذَكَرَ النَّقْضَ
u'ذِكْرٌ نَقْضٌ':Added, #1: 1	ذِكْرَ نَقْضِ
u'ذَكَرَ نقل':Predicate, #1: 1	ذِكْرَ نَقْضِ
u'ذَكَرَ نَقْلٌ':Predicate, #2: 2	ذَكَرَ النَّقْلَ
u'ذَكَرَ نكاح':Predicate, #2: 2	ذَكَرَ النَّقْلَ
u'ذَكَرَ نِكَاحٌ':Predicate, #1: 1	ذَكَرَ نِكَاحَ
u'ذَكَرَ نكاح':Predicate, #1: 1	ذَكَرَ نِكَاحَ
u'ذَكَرَ نِكَاحٌ':Predicate, #3: 3	ذَكَرَ النِّكَاحَ
u'ذكر نكاح':Added, #3: 3	ذَكَرَ النِّكَاحَ
u'ذِكْرٌ نكاح':Added, #1: 1	ذِكْرُ النِّكَاحِ
u'ذكر نِكَاحٌ':Added, #1: 1	ذِكْرُ النِّكَاحِ
u'ذِكْرٌ نِكَاحٌ':Added, #1: 1	ذِكْرُ النِّكَاحِ
u'ذكر نكاح':Added, #1: 1	ذِكْرُ النِّكَاحِ
u'ذِكْرٌ نكاح':Added, #2: 2	ذِكْرِ النِّكَاحِ
u'ذكر نِكَاحٌ':Added, #2: 2	ذِكْرِ النِّكَاحِ
u'ذِكْرٌ نِكَاحٌ':Added, #2: 2	ذِكْرِ النِّكَاحِ
u'ذَكَرَ نَمَطٌ':Predicate, #2: 2	ذِكْرِ النِّكَاحِ
u'ذكر نهار':Added, #1: 1	ذَكَرَ نَمَطَ
u'ذِكْرٌ نهار':Added, #1: 1	ذِكْرُ النَّهَارِ
u'ذكر نَهَارٌ':Added, #1: 1	ذِكْرُ النَّهَارِ
u'ذِكْرٌ نَهَارٌ':Added, #1: 1	ذِكْرُ النَّهَارِ
u'ذكر نهار':Added, #1: 1	ذِكْرُ النَّهَارِ
u'ذِكْرٌ نهار':Added, #2: 2	ذِكْرِ النَّهَارِ
u'ذكر نَهَارٌ':Added, #2: 2	ذِكْرِ النَّهَارِ
u'ذِكْرٌ نَهَارٌ':Added, #2: 2	ذِكْرِ النَّهَارِ
u'ذَكَرَ نَهْيٌ':Predicate, #2: 2	ذِكْرِ النَّهَارِ
u'ذكر نَهْيٌ':Added, #2: 2	ذَكَرَ النَّهْيَ
u'ذكر نَهْيٌ':Added, #1: 1	ذِكْرَ النَّهْيِ
u'ذِكْرٌ نَهْيٌ':Added, #1: 1	ذِكْرِ النَّهْيِ
u'ذِكْرٌ نَهْيٌ':Added, #1: 1	ذِكْرَ النَّهْيِ
u'ذَكَرَ نَوَافِلُ':Predicate, #1: 1	ذِكْرِ النَّهْيِ
u'ذَكَرَ نَوْعٌ':Predicate, #1: 1	ذَكَرَ النَّوَافِلَ
u'ذكر نَوْعٌ':Added, #2: 2	ذَكَرَ النَّوْعَ
u'ذكر نَوْعٌ':Added, #1: 1	ذِكْرُ نَوْعٍ
u'ذكر نَوْعٌ':Added, #1: 1	ذِكْرِ نَوْعٍ
u'ذِكْرٌ نَوْعٌ':Added, #1: 1	ذِكْرِ نَوْعِ
u'ذِكْرٌ نَوْعٌ':Added, #1: 1	ذِكْرُ نَوْعٍ
u'ذِكْرٌ نَوْعٌ':Added, #1: 1	ذِكْرِ نَوْعٍ
u'ذكر نَوْعٌ':Added, #1: 1	ذِكْرِ نَوْعِ
u'ذِكْرٌ نَوْعٌ':Added, #1: 1	ذِكْرُ نَوْعِهِ
u'ذكر نَوْعٌ':Added, #1: 1	ذِكْرُ نَوْعِهِ
u'ذِكْرٌ نَوْعٌ':Added, #3: 3	ذِكْرِ النَّوْعِ
u'ذكر نَوْعٌ':Added, #3: 3	ذِكْرِ النَّوْعِ
u'ذِكْرٌ نَوْعٌ':Added, #6: 6	ذِكْرُ النَّوْعِ
u'ذكر نَوْمٌ':Added, #6: 6	ذِكْرُ النَّوْعِ
u'ذكر نَوْمٌ':Added, #1: 1	ذِكْرُ النّوْمِ
u'ذِكْرٌ نَوْمٌ':Added, #1: 1	ذِكْرُ النَّوْمِ
u'ذِكْرٌ نَوْمٌ':Added, #1: 1	ذِكْرُ النّوْمِ
u'ذَكَرَ نَوَوِيٌّ':Subject, #1: 1	ذِكْرُ النَّوْمِ
u'ذَكَرَ نِيَّةٌ':Predicate, #15: 15	ذَكَرَ النَّوَوِيُّ
u'ذكر نِيَّةٌ':Added, #1: 1	ذَكَرَ النِّيَّةَ
u'ذِكْرٌ نِيَّةٌ':Added, #2: 2	ذِكْرُ نِيَّةِ
u'ذكر هِبَةٌ':Added, #2: 2	ذِكْرُ نِيَّةِ
u'ذِكْرٌ هِبَةٌ':Added, #1: 1	ذِكْرُ الْهِبَةِ
u'ذكر هجرة':Added, #1: 1	ذِكْرُ الْهِبَةِ
u'ذِكْرٌ هجرة':Added, #1: 1	ذِكْرُ الْهِجْرَةِ
u'ذكر هِجْرَةٌ':Added, #1: 1	ذِكْرُ الْهِجْرَةِ
u'ذِكْرٌ هِجْرَةٌ':Added, #1: 1	ذِكْرُ الْهِجْرَةِ
u'ذكر هَدْمٌ':Added, #1: 1	ذِكْرُ الْهِجْرَةِ
u'ذِكْرٌ هَدْمٌ':Added, #1: 1	ذِكْرِ الْهَدْمِ
u'ذَكَرَ هَدْيٌ':Predicate, #1: 1	ذِكْرِ الْهَدْمِ
u'ذكر هَدْيٌ':Added, #2: 2	ذَكَرَ الْهَدْيَ
u'ذكر هَدْيٌ':Added, #1: 1	ذِكْرَ الْهَدْيِ
u'ذِكْرٌ هَدْيٌ':Added, #1: 1	ذِكْرِ الْهَدْيِ
u'ذِكْرٌ هَدْيٌ':Added, #1: 1	ذِكْرَ الْهَدْيِ
u'ذكر هَدِيٌّ':Added, #1: 1	ذِكْرِ الْهَدْيِ
u'ذِكْرٌ هَدِيٌّ':Added, #1: 1	ذِكْرُ الْهَدِيَّةِ
u'ذكر هَدِيٌّ':Added, #1: 1	ذِكْرُ الْهَدِيَّةِ
u'ذِكْرٌ هَدِيٌّ':Added, #1: 1	ذِكْرِ هَدِيَّةِ
u'ذكر هَدِيَّةٌ':Added, #1: 1	ذِكْرِ هَدِيَّةِ
u'ذِكْرٌ هَدِيَّةٌ':Added, #1: 1	ذِكْرُ الْهَدِيَّةِ
u'ذكر هَدِيَّةٌ':Added, #1: 1	ذِكْرُ الْهَدِيَّةِ
u'ذِكْرٌ هَدِيَّةٌ':Added, #1: 1	ذِكْرِ هَدِيَّةِ
u'ذكر هَدِيرٌ':Added, #1: 1	ذِكْرِ هَدِيَّةِ
u'ذِكْرٌ هَدِيرٌ':Added, #1: 1	ذِكْرِ الْهَدِيرِ
u'ذَكَرَ هَرَوِيّ':Subject, #1: 1	ذِكْرِ الْهَدِيرِ
u'ذَكَرَ هشام':Subject, #1: 1	ذَكَرَ الْهَرَوِيُّ
u'ذَكَرَ هِشَامٌ':Subject, #12: 12	ذَكَرَ هِشَامٌ
u'ذَكَرَ هشام':Subject, #12: 12	ذَكَرَ هِشَامٌ
u'ذَكَرَ هِشَامٌ':Subject, #1: 1	ذَكَرَ هِشَامُ
u'ذَكَرَ هِلاَلٌ':Predicate, #1: 1	ذَكَرَ هِشَامُ
u'ذَكَرَ هِلاَلٌ':Predicate, #1: 1	ذَكَرَ الْهِلَالَ
u'ذَكَرَ هِلاَلٌ':Subject, #1: 1	ذَكَرَ الْهِلاَلَ
u'ذكر وَاثِقٌ':Added, #15: 15	ذَكَرَ هِلَالٌ
u'ذِكْرٌ وَاثِقٌ':Added, #1: 1	ذِكْرُ وَاثِقٍ
u'ذَكَرَ وَاجِبٌ':Predicate, #1: 1	ذِكْرُ وَاثِقٍ
u'ذَكَرَ وَاجِبٌ':Subject, #2: 2	ذَكَرَ الْوَاجِبَ
u'ذكر وَاجِبٌ':Added, #1: 1	ذَكَرَ وَاجِبٌ
u'ذِكْرٌ وَاجِبٌ':Added, #1: 1	ذِكْرِ الْوَاجِبِ
u'ذكر وَاجِبٌ':Added, #1: 1	ذِكْرِ الْوَاجِبِ
u'ذِكْرٌ وَاجِبٌ':Added, #1: 1	ذِكْرِ الْوَاجِبَاتِ
u'ذكر وَاجِبٌ':Added, #1: 1	ذِكْرِ الْوَاجِبَاتِ
u'ذِكْرٌ وَاجِبٌ':Added, #1: 1	ذِكْرِ وَاجِبَاتِ
u'ذَكَرَ واحد':Predicate, #1: 1	ذِكْرِ وَاجِبَاتِ
u'ذَكَرَ وَاحِدٌ':Predicate, #1: 1	ذَكَرَ الْوَاحِدَةَ
u'ذَكَرَ واحد':Subject, #1: 1	ذَكَرَ الْوَاحِدَةَ
u'ذَكَرَ وَاحِدٌ':Subject, #1: 1	ذَكَرَ وَاحِدٌ
u'ذكر واحد':Added, #1: 1	ذَكَرَ وَاحِدٌ
u'ذِكْرٌ واحد':Added, #1: 1	ذِكْرَ الْوَاحِدَةِ
u'ذكر وَاحِدٌ':Added, #1: 1	ذِكْرَ الْوَاحِدَةِ
u'ذِكْرٌ وَاحِدٌ':Added, #1: 1	ذِكْرَ الْوَاحِدَةِ
u'ذكر واحد':Added, #1: 1	ذِكْرَ الْوَاحِدَةِ
u'ذكر واحد':Added, #1: 1	ذِكْرُ وَاحِدٍ
u'ذِكْرٌ واحد':Added, #1: 1	ذِكْرِ وَاحِدٍ
u'ذِكْرٌ واحد':Added, #1: 1	ذِكْرُ وَاحِدٍ
u'ذكر وَاحِدٌ':Added, #1: 1	ذِكْرِ وَاحِدٍ
u'ذكر وَاحِدٌ':Added, #1: 1	ذِكْرُ وَاحِدٍ
u'ذِكْرٌ وَاحِدٌ':Added, #1: 1	ذِكْرِ وَاحِدٍ
u'ذِكْرٌ وَاحِدٌ':Added, #1: 1	ذِكْرُ وَاحِدٍ
u'ذكر واحد':Added, #1: 1	ذِكْرِ وَاحِدٍ
u'ذِكْرٌ واحد':Added, #3: 3	ذِكْرَ الْوَاحِدِ
u'ذكر وَاحِدٌ':Added, #3: 3	ذِكْرَ الْوَاحِدِ
u'ذِكْرٌ وَاحِدٌ':Added, #3: 3	ذِكْرَ الْوَاحِدِ
u'ذكر وَارِثٌ':Added, #3: 3	ذِكْرَ الْوَاحِدِ
u'ذِكْرٌ وَارِثٌ':Added, #2: 2	ذِكْرَ الْوَارِثِ
u'ذكر وَاسِطٌ':Added, #2: 2	ذِكْرَ الْوَارِثِ
u'ذِكْرٌ وَاسِطٌ':Added, #1: 1	ذِكْرَ الْوَاسِطَةِ
u'ذَكَرَ وَاضِحٌ':Subject, #1: 1	ذِكْرَ الْوَاسِطَةِ
u'ذكر وَاقِعٌ':Added, #1: 1	ذَكَرَ وَاضِحُ
u'ذِكْرٌ وَاقِعٌ':Added, #1: 1	ذِكْرِ الْوَاقِعِ
u'ذكر وَاقِعٌ':Added, #1: 1	ذِكْرِ الْوَاقِعِ
u'ذِكْرٌ وَاقِعٌ':Added, #3: 3	ذِكْرُ الْوَاقِعَةِ
u'ذكر وَاقِعَةٌ':Added, #3: 3	ذِكْرُ الْوَاقِعَةِ
u'ذِكْرٌ وَاقِعَةٌ':Added, #3: 3	ذِكْرُ الْوَاقِعَةِ
u'ذَكَرَ وَاقِفٌ':Subject, #3: 3	ذِكْرُ الْوَاقِعَةِ
u'ذكر وَاقِفٌ':Added, #1: 1	ذَكَرَ الْوَاقِفُ
u'ذِكْرٌ وَاقِفٌ':Added, #1: 1	ذِكْرِ الْوَاقِفِ
u'ذكر وَالِدٌ':Added, #1: 1	ذِكْرِ الْوَاقِفِ
u'ذِكْرٌ وَالِدٌ':Added, #1: 1	ذِكْرُ الْوَالِدِ
u'ذكر وَالِدٌ':Added, #1: 1	ذِكْرُ الْوَالِدِ
u'ذِكْرٌ وَالِدٌ':Added, #2: 2	ذِكْرُ وَالِدِهِ
u'ذَكَرَ وَجْهٌ':Predicate, #2: 2	ذِكْرُ وَالِدِهِ
u'ذَكَرَ وَجْهٌ':Predicate, #3: 3	ذَكَرَ وَجْهَ
u'ذكر وَجْهٌ':Added, #4: 4	ذَكَرَ الْوَجْهَ
u'ذِكْرٌ وَجْهٌ':Added, #1: 1	ذِكْرِ الْوَجْهَيْنِ
u'ذكر وَجْهٌ':Added, #1: 1	ذِكْرِ الْوَجْهَيْنِ
u'ذِكْرٌ وَجْهٌ':Added, #2: 2	ذِكْرُ وَجْهِ
u'ذكر وَجْهٌ':Added, #2: 2	ذِكْرُ وَجْهِ
u'ذِكْرٌ وَجْهٌ':Added, #4: 4	ذِكْرِ الْوَجْهِ
u'ذكر وَجْهٌ':Added, #4: 4	ذِكْرِ الْوَجْهِ
u'ذِكْرٌ وَجْهٌ':Added, #5: 5	ذِكْرُ الْوَجْهِ
u'ذَكَرَ وُجُوبٌ':Predicate, #5: 5	ذِكْرُ الْوَجْهِ
u'ذَكَرَ وُجُوبٌ':Subject, #2: 2	ذَكَرَ وُجُوبَ
u'ذكر وُجُوبٌ':Added, #1: 1	ذَكَرَ وُجُوبُ
u'ذِكْرٌ وُجُوبٌ':Added, #1: 1	ذِكْرِ الْوُجُوبِ
u'ذكر وُجُوبٌ':Added, #1: 1	ذِكْرِ الْوُجُوبِ
u'ذِكْرٌ وُجُوبٌ':Added, #1: 1	ذِكْرُ وُجُوبِ
u'ذكر وُجُوبٌ':Added, #1: 1	ذِكْرُ وُجُوبِ
u'ذِكْرٌ وُجُوبٌ':Added, #4: 4	ذِكْرِ وُجُوبِ
u'ذكر وُجُودٌ':Added, #4: 4	ذِكْرِ وُجُوبِ
u'ذِكْرٌ وُجُودٌ':Added, #1: 1	ذِكْرِ وُجُودِ
u'ذِكْرٌ ودعاء':Added, #1: 1	ذِكْرِ وُجُودِ
u'ذكر وَدِيعٌ':Added, #1: 1	ذِكْرٍ وَدُعَاءٍ
u'ذِكْرٌ وَدِيعٌ':Added, #1: 1	ذِكْرَ الْوَدِيعَةِ
u'ذكر وَدِيعَةٌ':Added, #1: 1	ذِكْرَ الْوَدِيعَةِ
u'ذِكْرٌ وَدِيعَةٌ':Added, #1: 1	ذِكْرَ الْوَدِيعَةِ
u'ذكر وِرَاثَةٌ':Added, #1: 1	ذِكْرَ الْوَدِيعَةِ
u'ذِكْرٌ وِرَاثَةٌ':Added, #1: 1	ذِكْرِ الْوِرَاثَةِ
u'ذكر ورق':Added, #1: 1	ذِكْرِ الْوِرَاثَةِ
u'ذِكْرٌ ورق':Added, #1: 1	ذِكْرُ الْوَرِقِ
u'ذكر وَرِقٌ':Added, #1: 1	ذِكْرُ الْوَرِقِ
u'ذِكْرٌ وَرِقٌ':Added, #1: 1	ذِكْرُ الْوَرِقِ
u'ذَكَرَ وَرَقَةٌ':Subject, #1: 1	ذِكْرُ الْوَرِقِ
u'ذَكَرَ وَزَغَةٌ':Predicate, #1: 1	ذَكَرَ وَرَقَةُ
u'ذَكَرَ وَزْنٌ':Predicate, #1: 1	ذَكَرَ الْوَزَغَةَ
u'ذكر وَزْنٌ':Added, #5: 5	ذَكَرَ الْوَزْنَ
u'ذكر وَزْنٌ':Added, #1: 1	ذِكْرُ وَزْنِ
u'ذِكْرٌ وَزْنٌ':Added, #1: 1	ذِكْرِ وَزْنِ
u'ذِكْرٌ وَزْنٌ':Added, #1: 1	ذِكْرُ وَزْنِ
u'ذكر وَزْنٌ':Added, #1: 1	ذِكْرِ وَزْنِ
u'ذِكْرٌ وَزْنٌ':Added, #1: 1	ذِكْرِ وَزْنِهِ
u'ذكر وَزْنٌ':Added, #1: 1	ذِكْرِ وَزْنِهِ
u'ذِكْرٌ وَزْنٌ':Added, #3: 3	ذِكْرِ الْوَزْنِ
u'ذكر وَزْنٌ':Added, #3: 3	ذِكْرِ الْوَزْنِ
u'ذِكْرٌ وَزْنٌ':Added, #7: 7	ذِكْرُ الْوَزْنِ
u'ذكر وَسَائِلُ':Added, #7: 7	ذِكْرُ الْوَزْنِ
u'ذِكْرٌ وَسَائِلُ':Added, #1: 1	ذِكْرِ الْوَسَائِلِ
u'ذَكَرَ وسط':Predicate, #1: 1	ذِكْرِ الْوَسَائِلِ
u'ذَكَرَ وَسَطٌ':Predicate, #1: 1	ذَكَرَ الْوَسَطَ
u'ذكر وسط':Added, #1: 1	ذَكَرَ الْوَسَطَ
u'ذِكْرٌ وسط':Added, #1: 1	ذِكْرِ الْوَسَطِ
u'ذكر وَسَطٌ':Added, #1: 1	ذِكْرِ الْوَسَطِ
u'ذِكْرٌ وَسَطٌ':Added, #1: 1	ذِكْرِ الْوَسَطِ
u'ذَكَرَ وَسْوَاسٌ':Predicate, #1: 1	ذِكْرِ الْوَسَطِ
u'ذكر وصال':Added, #1: 1	ذَكَرَ الْوَسْوَاسَ
u'ذِكْرٌ وصال':Added, #1: 1	ذِكْرُ الْوِصَالِ
u'ذكر وِصَالٌ':Added, #1: 1	ذِكْرُ الْوِصَالِ
u'ذِكْرٌ وِصَالٌ':Added, #1: 1	ذِكْرُ الْوِصَالِ
u'ذَكَرَ وَصْفٌ':Predicate, #1: 1	ذِكْرُ الْوِصَالِ
u'ذَكَرَ وَصْفٌ':Predicate, #2: 2	ذَكَرَ الْوَصْفَ
u'ذكر وَصْفٌ':Added, #2: 2	ذَكَرَ وَصْفَ
u'ذِكْرٌ وَصْفٌ':Added, #1: 1	ذِكْرَ الْوَصْفِ
u'ذكر وَصْفٌ':Added, #1: 1	ذِكْرَ الْوَصْفِ
u'ذِكْرٌ وَصْفٌ':Added, #1: 1	ذِكْرِ وَصْفِهِ
u'ذكر وَصْفٌ':Added, #1: 1	ذِكْرِ وَصْفِهِ
u'ذِكْرٌ وَصْفٌ':Added, #2: 2	ذِكْرِ وَصْفِ
u'ذكر وَصْفٌ':Added, #2: 2	ذِكْرِ وَصْفِ
u'ذِكْرٌ وَصْفٌ':Added, #2: 2	ذِكْرُ وَصْفِهِ
u'ذكر وَصْفٌ':Added, #2: 2	ذِكْرُ وَصْفِهِ
u'ذكر وَصْفٌ':Added, #4: 4	ذِكْرُ الْوَصْفِ
u'ذِكْرٌ وَصْفٌ':Added, #4: 4	ذِكْرِ الْوَصْفِ
u'ذِكْرٌ وَصْفٌ':Added, #4: 4	ذِكْرُ الْوَصْفِ
u'ذَكَرَ وَصِيٌّ':Predicate, #4: 4	ذِكْرِ الْوَصْفِ
u'ذَكَرَ وَصِيٌّ':Predicate, #1: 1	ذَكَرَ وَصِيَّةً
u'ذكر وَصِيٌّ':Added, #2: 2	ذَكَرَ الْوَصِيَّةَ
u'ذِكْرٌ وَصِيٌّ':Added, #1: 1	ذِكْرَ الْوَصِيَّةِ
u'ذكر وَصِيٌّ':Added, #1: 1	ذِكْرَ الْوَصِيَّةِ
u'ذِكْرٌ وَصِيٌّ':Added, #1: 1	ذِكْرُ وَصِيَّةٍ
u'ذكر وَصِيٌّ':Added, #1: 1	ذِكْرُ وَصِيَّةٍ
u'ذِكْرٌ وَصِيٌّ':Added, #1: 1	ذِكْرِ وَصِيَّتِهِ
u'ذكر وَصِيٌّ':Added, #1: 1	ذِكْرِ وَصِيَّتِهِ
u'ذِكْرٌ وَصِيٌّ':Added, #3: 3	ذِكْرِ وَصِيَّةٍ
u'ذكر وَصِيٌّ':Added, #3: 3	ذِكْرِ وَصِيَّةٍ
u'ذِكْرٌ وَصِيٌّ':Added, #6: 6	ذِكْرِ الْوَصِيَّةِ
u'ذَكَرَ وَصِيَّةٌ':Predicate, #6: 6	ذِكْرِ الْوَصِيَّةِ
u'ذكر وَصِيَّةٌ':Added, #2: 2	ذَكَرَ الْوَصِيَّةَ
u'ذِكْرٌ وَصِيَّةٌ':Added, #1: 1	ذِكْرَ الْوَصِيَّةِ
u'ذكر وَصِيَّةٌ':Added, #1: 1	ذِكْرَ الْوَصِيَّةِ
u'ذِكْرٌ وَصِيَّةٌ':Added, #1: 1	ذِكْرُ وَصِيَّةٍ
u'ذكر وَصِيَّةٌ':Added, #1: 1	ذِكْرُ وَصِيَّةٍ
u'ذِكْرٌ وَصِيَّةٌ':Added, #1: 1	ذِكْرِ وَصِيَّتِهِ
u'ذكر وَصِيَّةٌ':Added, #1: 1	ذِكْرِ وَصِيَّتِهِ
u'ذِكْرٌ وَصِيَّةٌ':Added, #3: 3	ذِكْرِ وَصِيَّةٍ
u'ذكر وَصِيَّةٌ':Added, #3: 3	ذِكْرِ وَصِيَّةٍ
u'ذِكْرٌ وَصِيَّةٌ':Added, #6: 6	ذِكْرِ الْوَصِيَّةِ
u'ذكر وَصِيفٌ':Added, #6: 6	ذِكْرِ الْوَصِيَّةِ
u'ذِكْرٌ وَصِيفٌ':Added, #1: 1	ذِكْرِ الْوَصِيفِ
u'ذَكَرَ وَضْعٌ':Predicate, #1: 1	ذِكْرِ الْوَصِيفِ
u'ذكر وَضْعٌ':Added, #1: 1	ذَكَرَ الْوَضْعَ
u'ذِكْرٌ وَضْعٌ':Added, #1: 1	ذِكْرِ الْوَضْعِ
u'ذكر وَضْعٌ':Added, #1: 1	ذِكْرِ الْوَضْعِ
u'ذِكْرٌ وَضْعٌ':Added, #1: 1	ذِكْرِ وَضْعِ
u'ذَكَرَ وُضُوءٌ':Predicate, #1: 1	ذِكْرِ وَضْعِ
u'ذَكَرَ وُضُوءٌ':Predicate, #1: 1	ذَكَرَ وُضُوءَ
u'ذكر وُضُوءٌ':Added, #2: 2	ذَكَرَ الْوُضُوءَ
u'ذِكْرٌ وُضُوءٌ':Added, #1: 1	ذِكْرَ الْوُضُوءِ
u'ذكر وُضُوءٌ':Added, #1: 1	ذِكْرَ الْوُضُوءِ
u'ذِكْرٌ وُضُوءٌ':Added, #3: 3	ذِكْرُ الْوُضُوءِ
u'ذكر وُضُوءٌ':Added, #3: 3	ذِكْرُ الْوُضُوءِ
u'ذِكْرٌ وُضُوءٌ':Added, #4: 4	ذِكْرِ الْوُضُوءِ
u'ذكر وَطْءٌ':Added, #4: 4	ذِكْرِ الْوُضُوءِ
u'ذكر وَطْءٌ':Added, #1: 1	ذِكْرُ الْوَطْءِ
u'ذِكْرٌ وَطْءٌ':Added, #1: 1	ذِكْرِ الْوَطْءِ
u'ذِكْرٌ وَطْءٌ':Added, #1: 1	ذِكْرُ الْوَطْءِ
u'ذكر وَظَائِفُ':Added, #1: 1	ذِكْرِ الْوَطْءِ
u'ذِكْرٌ وَظَائِفُ':Added, #1: 1	ذِكْرَ وَظَائِفِ
u'ذَكَرَ وفاة':Predicate, #1: 1	ذِكْرَ وَظَائِفِ
u'ذَكَرَ وَفَاةٌ':Predicate, #1: 1	ذَكَرَ وَفَاةَ
u'ذكر وفاة':Added, #1: 1	ذَكَرَ وَفَاةَ
u'ذكر وفاة':Added, #1: 1	ذِكْرَ وَفَاةِ
u'ذِكْرٌ وفاة':Added, #1: 1	ذِكْرِ وَفَاةِ
u'ذِكْرٌ وفاة':Added, #1: 1	ذِكْرَ وَفَاةِ
u'ذكر وَفَاةٌ':Added, #1: 1	ذِكْرِ وَفَاةِ
u'ذكر وَفَاةٌ':Added, #1: 1	ذِكْرَ وَفَاةِ
u'ذِكْرٌ وَفَاةٌ':Added, #1: 1	ذِكْرِ وَفَاةِ
u'ذِكْرٌ وَفَاةٌ':Added, #1: 1	ذِكْرَ وَفَاةِ
u'ذكر وِفَاقٌ':Added, #1: 1	ذِكْرِ وَفَاةِ
u'ذِكْرٌ وِفَاقٌ':Added, #1: 1	ذِكْرِ الْوِفَاقِ
u'ذَكَرَ وَقْتٌ':Predicate, #1: 1	ذِكْرِ الْوِفَاقِ
u'ذكر وَقْتٌ':Added, #4: 4	ذَكَرَ الْوَقْتَ
u'ذكر وَقْتٌ':Added, #1: 1	ذِكْرَ وَقْتِ
u'ذِكْرٌ وَقْتٌ':Added, #1: 1	ذِكْرِ وَقْتٍ
u'ذِكْرٌ وَقْتٌ':Added, #1: 1	ذِكْرَ وَقْتِ
u'ذكر وَقْتٌ':Added, #1: 1	ذِكْرِ وَقْتٍ
u'ذِكْرٌ وَقْتٌ':Added, #6: 6	ذِكْرِ الْوَقْتِ
u'ذكر وَقْتٌ':Added, #6: 6	ذِكْرِ الْوَقْتِ
u'ذِكْرٌ وَقْتٌ':Added, #7: 7	ذِكْرُ الْوَقْتِ
u'ذكر وَقْتٌ':Added, #7: 7	ذِكْرُ الْوَقْتِ
u'ذِكْرٌ وَقْتٌ':Added, #9: 9	ذِكْرَ الْوَقْتِ
u'ذَكَرَ وَقْفٌ':Predicate, #9: 9	ذِكْرَ الْوَقْتِ
u'ذكر وَقْفٌ':Added, #2: 2	ذَكَرَ الْوَقْفَ
u'ذِكْرٌ وَقْفٌ':Added, #1: 1	ذِكْرَ الْوَقْفِ
u'ذكر وَقْفٌ':Added, #1: 1	ذِكْرَ الْوَقْفِ
u'ذِكْرٌ وَقْفٌ':Added, #1: 1	ذِكْرِ وَقْفٍ
u'ذكر وَقْفٌ':Added, #1: 1	ذِكْرِ وَقْفٍ
u'ذِكْرٌ وَقْفٌ':Added, #2: 2	ذِكْرِ الْوَقْفِ
u'ذَكَرَ وُقُوعٌ':Predicate, #2: 2	ذِكْرِ الْوَقْفِ
u'ذكر وُلاَةٌ':Added, #1: 1	ذَكَرَ وُقُوعَ
u'ذِكْرٌ وُلاَةٌ':Added, #1: 1	ذِكْرُ الْوُلَاةِ
u'ذكر وِلاَدَةٌ':Added, #1: 1	ذِكْرُ الْوُلَاةِ
u'ذِكْرٌ وِلاَدَةٌ':Added, #1: 1	ذِكْرِ الْوِلَادَةِ
u'ذَكَرَ ولد':Predicate, #1: 1	ذِكْرِ الْوِلَادَةِ
u'ذَكَرَ وَلَدٌ':Predicate, #1: 1	ذَكَرَ وَلَدَ
u'ذَكَرَ ولد':Predicate, #1: 1	ذَكَرَ وَلَدَ
u'ذَكَرَ وَلَدٌ':Predicate, #2: 2	ذَكَرَ الْوَلَدَ
u'ذكر ولد':Added, #2: 2	ذَكَرَ الْوَلَدَ
u'ذِكْرٌ ولد':Added, #1: 1	ذِكْرَ الْوَلَدِ
u'ذكر وَلَدٌ':Added, #1: 1	ذِكْرَ الْوَلَدِ
u'ذِكْرٌ وَلَدٌ':Added, #1: 1	ذِكْرَ الْوَلَدِ
u'ذكر ولد':Added, #1: 1	ذِكْرَ الْوَلَدِ
u'ذِكْرٌ ولد':Added, #1: 1	ذِكْرُ وَلَدِ
u'ذكر وَلَدٌ':Added, #1: 1	ذِكْرُ وَلَدِ
u'ذِكْرٌ وَلَدٌ':Added, #1: 1	ذِكْرُ وَلَدِ
u'ذكر ولد':Added, #1: 1	ذِكْرُ وَلَدِ
u'ذِكْرٌ ولد':Added, #2: 2	ذِكْرُ وَلَدِهِ
u'ذكر وَلَدٌ':Added, #2: 2	ذِكْرُ وَلَدِهِ
u'ذِكْرٌ وَلَدٌ':Added, #2: 2	ذِكْرُ وَلَدِهِ
u'ذكر ولد':Added, #2: 2	ذِكْرُ وَلَدِهِ
u'ذكر ولد':Added, #3: 3	ذِكْرُ الْوَلَدِ
u'ذِكْرٌ ولد':Added, #3: 3	ذِكْرِ الْوَلَدِ
u'ذِكْرٌ ولد':Added, #3: 3	ذِكْرُ الْوَلَدِ
u'ذكر وَلَدٌ':Added, #3: 3	ذِكْرِ الْوَلَدِ
u'ذكر وَلَدٌ':Added, #3: 3	ذِكْرُ الْوَلَدِ
u'ذِكْرٌ وَلَدٌ':Added, #3: 3	ذِكْرِ الْوَلَدِ
u'ذِكْرٌ وَلَدٌ':Added, #3: 3	ذِكْرُ الْوَلَدِ
u'ذَكَرَ وَلِيٌّ':Predicate, #3: 3	ذِكْرِ الْوَلَدِ
u'ذكر وَلِيٌّ':Added, #1: 1	ذَكَرَ الْوَلِيَّ
u'ذكر وَلِيٌّ':Added, #1: 1	ذِكْرُ الْوَلِيِّ
u'ذِكْرٌ وَلِيٌّ':Added, #1: 1	ذِكْرِ الْوَلِيِّ
u'ذِكْرٌ وَلِيٌّ':Added, #1: 1	ذِكْرُ الْوَلِيِّ
u'ذكر وَلِيٌّ':Added, #1: 1	ذِكْرِ الْوَلِيِّ
u'ذِكْرٌ وَلِيٌّ':Added, #1: 1	ذِكْرِ وَلِيٍّ
u'ذَكَرَ وَهْمٌ':Predicate, #1: 1	ذِكْرِ وَلِيٍّ
u'ذَكَرَ يَابِسٌ':Predicate, #1: 1	ذَكَرَ الْوَهْمَ
u'ذكر يَافُوخٌ':Added, #1: 1	ذَكَرَ الْيَابِسَ
u'ذِكْرٌ يَافُوخٌ':Added, #1: 1	ذِكْرُ الْيَافُوخِ
u'ذكر يُتْمٌ':Added, #1: 1	ذِكْرُ الْيَافُوخِ
u'ذِكْرٌ يُتْمٌ':Added, #1: 1	ذِكْرُ يُتْمِ
u'ذَكَرَ يَدٌ':Predicate, #1: 1	ذِكْرُ يُتْمِ
u'ذكر يَدٌ':Added, #1: 1	ذَكَرَ الْيَدَ
u'ذِكْرٌ يَدٌ':Added, #1: 1	ذِكْرَ الْيَدِ
u'ذكر يَدٌ':Added, #1: 1	ذِكْرَ الْيَدِ
u'ذِكْرٌ يَدٌ':Added, #1: 1	ذِكْرَ الْيَدَيْنِ
u'ذكر يَدٌ':Added, #1: 1	ذِكْرَ الْيَدَيْنِ
u'ذِكْرٌ يَدٌ':Added, #1: 1	ذِكْرَ يَدِ
u'ذكر يسار':Added, #1: 1	ذِكْرَ يَدِ
u'ذكر يَسَارٌ':Added, #1: 1	ذِكْرَ الْيَسَارِ
u'ذِكْرٌ يسار':Added, #1: 1	ذِكْرَ الْيَسَارِ
u'ذِكْرٌ يَسَارٌ':Added, #1: 1	ذِكْرَ الْيَسَارِ
u'ذَكَرَ يَسِيرٌ':Predicate, #1: 1	ذِكْرَ الْيَسَارِ
u'ذِكْرٌ يَسِيرٌ':Added, #3: 3	ذَكَرَ الْيَسِيرَ
u'ذَكَرَ يَمِينٌ':Predicate, #1: 1	ذِكْرٍ يَسِيرٍ
u'ذَكَرَ يَمِينٌ':Predicate, #1: 1	ذَكَرَ اليَمِينَ
u'ذكر يَمِينٌ':Added, #2: 2	ذَكَرَ الْيَمِينَ
u'ذكر يَمِينٌ':Added, #1: 1	ذِكْرَ الْيَمِينِ
u'ذِكْرٌ يَمِينٌ':Added, #1: 1	ذِكْرِ الْيَمِينِ
u'ذِكْرٌ يَمِينٌ':Added, #1: 1	ذِكْرَ الْيَمِينِ
u'ذكر يَمِينٌ':Added, #1: 1	ذِكْرِ الْيَمِينِ
u'ذِكْرٌ يَمِينٌ':Added, #1: 1	ذِكْرَ يَمِينٍ
u'ذَكَرَ يهود':Predicate, #1: 1	ذِكْرَ يَمِينٍ
u'ذَكَرَ يَهُودٌ':Predicate, #1: 1	ذَكَرَ الْيَهُودَ
u'ذَكَرَ يَوْمٌ':Predicate, #1: 1	ذَكَرَ الْيَهُودَ
u'ذَكَرَ يَوْمٌ':Predicate, #3: 3	ذَكَرَ يَوْمَ
u'ذكر يَوْمٌ':Added, #8: 8	ذَكَرَ الْيَوْمَ
u'ذِكْرٌ يَوْمٌ':Added, #13: 13	ذِكْرَ الْيَوْمِ
u'ذكر يَوْمٌ':Added, #13: 13	ذِكْرَ الْيَوْمِ
u'ذِكْرٌ يَوْمٌ':Added, #1: 1	ذِكْرُ يَوْمِ
u'ذكر يَوْمٌ':Added, #1: 1	ذِكْرُ يَوْمِ
u'ذِكْرٌ يَوْمٌ':Added, #4: 4	ذِكْرِ الْيَوْمِ
u'ذكر يَوْمٌ':Added, #4: 4	ذِكْرِ الْيَوْمِ
u'ذِكْرٌ يَوْمٌ':Added, #8: 8	ذِكْرُ الْيَوْمِ
u'ذَكَّى حَلٌّ':Predicate, #8: 8	ذِكْرُ الْيَوْمِ
u'ذَلَّ اِبْنٌ':Predicate, #1: 1	ذَكَّى حَلَّ
u'ذَلَّ حِرْصٌ':Subject, #1: 1	أَذَلَّ ابْنَ
u'ذَلَّ دَهْرٌ':Subject, #1: 1	أَذَلَّ الْحِرْصُ
u'ذَمَّ اِسْتِعْمالٌ':Predicate, #1: 1	أَذَلَّ الدَّهْرُ
u'ذَمَّ أعْرَابِيٌّ':Subject, #1: 1	ذَمَّ اسْتِعْمَالَ
u'ذَمَّ بَعْضٌ':Predicate, #2: 2	ذَمَّ أَعْرَابِيٌّ
u'ذَمَّ بَغْدادُ':Predicate, #1: 1	ذَمَّ بَعْضَ
u'ذَمَّ رَسُولٌ':Subject, #1: 1	ذَمَّ بَغْدَادَ
u'ذَمَّ صُورٌ':Predicate, #1: 1	ذَمَّ الرَّسُولُ
u'ذَمَّ صُوَرٌ':Predicate, #1: 1	ذَمَّ الصُّوَرَ
u'ذَمَّ علماء':Subject, #1: 1	ذَمَّ الصُّوَرَ
u'ذَمَّ عُلَمَاءُ':Subject, #1: 1	ذَمَّ الْعُلَمَاءُ
u'ذَمَّ غير':Subject, #1: 1	ذَمَّ الْعُلَمَاءُ
u'ذَمَّ غَيْرٌ':Subject, #1: 1	ذَمَّ غَيْرُ
u'ذَمَّ قَوْمٌ':Predicate, #1: 1	ذَمَّ غَيْرُ
u'ذَمَّ كُفَّارٌ':Predicate, #1: 1	ذَمَّ قَوْمَ
u'ذَمَّ مُتَقَدِّمٌ':Predicate, #1: 1	ذَمَّ الْكُفَّارَ
u'ذَهَابٌ إِبْهَامٌ':Added, #1: 1	ذَمَّ الْمُتَقَدِّمِينَ
u'ذَهَابٌ أثَرٌ':Added, #1: 1	ذَهَابَ الْإِبْهَامِ
u'ذَهَابٌ أثَرٌ':Added, #1: 1	ذَهَابِ أَثَرِ
u'ذَهَابٌ أَجْرٌ':Added, #1: 1	ذَهَابِ الْأَثَرِ
u'ذَهَابٌ أَزْواجٌ':Added, #1: 1	ذَهَابِ الْأَجْرِ
u'ذَهَابٌ إِسْلامٌ':Added, #1: 1	ذَهَابِ أَزْوَاجِ
u'ذَهَابٌ أَكْثَرُ':Added, #1: 1	ذَهَابُ الْإِسْلَامِ
u'ذَهَابٌ أَمْس':Added, #1: 1	ذَهَابِ الْأَكْثَرِ
u'ذَهَابٌ أَمْوَالٌ':Added, #1: 1	ذَهَابَ أَمْسِ
u'ذَهَابٌ أهْلٌ':Added, #2: 2	ذَهَابِ الْأَمْوَالِ
u'ذَهَابٌ أَوَّلُ':Added, #2: 2	ذَهَابُ أَهْلِهِ
u'ذَهَابٌ أئِمَّةٌ':Added, #1: 1	ذَهَابِ الْأَوَّلِ
u'ذَهَابٌ بَرْدٌ':Added, #1: 1	ذَهَابُ الْأَئِمَّةِ
u'ذَهَابٌ بَرَكَةٌ':Added, #1: 1	ذَهَابُ الْبَرْدِ
u'ذَهَابٌ بَصَرٌ':Added, #1: 1	ذَهَابُ الْبَرَكَةِ
u'ذَهَابٌ بَصَرٌ':Added, #1: 1	ذَهَابُ بَصَرِ
u'ذَهَابٌ بَصَرٌ':Added, #2: 2	ذَهَابِ بَصَرِهِ
u'ذَهَابٌ بَصَرٌ':Added, #3: 3	ذَهَابَ الْبَصَرِ
u'ذَهَابٌ بَصَرٌ':Added, #3: 3	ذَهَابِ الْبَصَرِ
u'ذَهَابٌ بَعْضٌ':Added, #5: 5	ذَهَابُ الْبَصَرِ
u'ذَهَابٌ بَعْضٌ':Added, #1: 1	ذَهَابُ بَعْضِ
u'ذَهَابٌ بَعْضٌ':Added, #1: 1	ذَهَابِ بَعْضِ
u'ذَهَابٌ بَعْضٌ':Added, #1: 1	ذَهَابُ بَعْضِهِ
u'ذَهَابٌ بَكارَةٌ':Added, #2: 2	ذَهَابَ الْبَعْضِ
u'ذَهَابٌ بَيَاضٌ':Added, #1: 1	ذَهَابِ الْبَكَارَةِ
u'ذَهَابٌ تَمْييزٌ':Added, #2: 2	ذَهَابِ الْبَيَاضِ
u'ذَهَابٌ ثَوابٌ':Added, #1: 1	ذَهَابُ التَّمْيِيزِ
u'ذَهَابٌ جَاهٌ':Added, #1: 1	ذَهَابُ الثَّوَابِ
u'ذَهَابٌ جِرْمٌ':Added, #1: 1	ذَهَابَ الْجَاهِ
u'ذَهَابٌ جُزْءٌ':Added, #1: 1	ذَهَابِ الْجِرْمِ
u'ذَهَابٌ جماع':Added, #1: 1	ذَهَابِ جُزْءٍ
u'ذَهَابٌ جِمَاعٌ':Added, #1: 1	ذَهَابِ الْجِمَاعِ
u'ذَهَابٌ جَمَاعَةٌ':Added, #1: 1	ذَهَابِ الْجِمَاعِ
u'ذَهَابٌ جُمْهُورٌ':Added, #1: 1	ذَهَابُ الْجَمَاعَةِ
u'ذَهَابٌ جُمْهُورٌ':Added, #1: 1	ذَهَابُ الْجُمْهُورِ
u'ذَهَابٌ جَمِيع':Added, #1: 1	ذَهَابِ الْجُمْهُورِ
u'ذَهَابٌ حُجَّاجٌ':Added, #1: 1	ذَهَابِ الْجَمِيعِ
u'ذَهَابٌ حَقٌّ':Added, #1: 1	ذَهَابُ الْحُجَّاجِ
u'ذَهَابٌ خَوْفٌ':Added, #1: 1	ذَهَابِ حَقِّ
u'ذَهَابٌ دَابَّةٌ':Added, #1: 1	ذَهَابِ الْخَوْفِ
u'ذَهَابٌ دَابَّةٌ':Added, #1: 1	ذَهَابِ دَابَّةٍ
u'ذَهَابٌ دَائِرَةٌ':Added, #1: 1	ذَهَابِ دَابَّتِهِ
u'ذَهَابٌ دَائِرَةٌ':Added, #1: 1	ذَهَابُ الدَّائِرَةِ
u'ذَهَابٌ دَيْنٌ':Added, #1: 1	ذَهَابُ دَائِرَتِهِ
u'ذَهَابٌ ذَوْقٌ':Added, #1: 1	ذَهَابِ الدَّيْنِ
u'ذَهَابٌ رَاكِبٌ':Added, #2: 2	ذَهَابِ الذَّوْقِ
u'ذَهَابٌ رَائِحٌ':Added, #1: 1	ذَهَابُ الرَّاكِبِ
u'ذَهَابٌ رَائِحٌ':Added, #1: 1	ذَهَابُ الرَّائِحَةِ
u'ذَهَابٌ رَائِحَةٌ':Added, #1: 1	ذَهَابِ رَائِحَةِ
u'ذَهَابٌ رَائِحَةٌ':Added, #1: 1	ذَهَابُ الرَّائِحَةِ
u'ذَهَابٌ رُبْعٌ':Added, #1: 1	ذَهَابِ رَائِحَةِ
u'ذَهَابٌ رِجْلٌ':Added, #1: 1	ذَهَابِ رُبْعِ
u'ذَهَابٌ رَسُولٌ':Added, #1: 1	ذَهَابَ رِجْلِهِ
u'ذَهَابٌ زَبَدٌ':Added, #1: 1	ذَهَابِ رَسُولِ
u'ذَهَابٌ سَمْعٌ':Added, #2: 2	ذَهَابِ الزَّبَدِ
u'ذَهَابٌ سَمْعٌ':Added, #1: 1	ذَهَابِ سَمْعٍ
u'ذَهَابٌ سَمْعٌ':Added, #1: 1	ذَهَابِ سَمْعِهِ
u'ذَهَابٌ سَهْمٌ':Added, #4: 4	ذَهَابِ السَّمْعِ
u'ذَهَابٌ شافِعِيّ':Added, #1: 1	ذَهَابَ السَّهْمِ
u'ذَهَابٌ شُحٌّ':Added, #1: 1	ذَهَابُ الشَّافِعِيِّ
u'ذَهَابٌ شَعْرٌ':Added, #1: 1	ذَهَابِ الشُّحِّ
u'ذَهَابٌ شفق':Added, #2: 2	ذَهَابِ الشَّعْرِ
u'ذَهَابٌ شَفَقٌ':Added, #1: 1	ذَهَابِ الشَّفَقِ
u'ذَهَابٌ شَمٌّ':Added, #1: 1	ذَهَابِ الشَّفَقِ
u'ذَهَابٌ شَيْءٌ':Added, #2: 2	ذَهَابِ الشَّمِّ
u'ذَهَابٌ شَيْءٌ':Added, #1: 1	ذَهَابُ الشَّيْءِ
u'ذَهَابٌ صُورَةٌ':Added, #3: 3	ذَهَابِ شَيْءٍ
u'ذَهَابٌ صَيْفٌ':Added, #1: 1	ذَهَابِ الصُّورَةِ
u'ذَهَابٌ ضَوْءٌ':Added, #1: 1	ذَهَابِ الصَّيْفِ
u'ذَهَابٌ ضَوْءٌ':Added, #2: 2	ذَهَابُ الضَّوْءِ
u'ذَهَابٌ طَائِفٌ':Added, #2: 2	ذَهَابُ ضَوْءِ
u'ذَهَابٌ طَرَفٌ':Added, #2: 2	ذَهَابِ الطَّائِفَةِ
u'ذَهَابٌ عُذْرَةٌ':Added, #1: 1	ذَهَابُ الطَّرَفَيْنِ
u'ذَهَابٌ عُذْرَةٌ':Added, #1: 1	ذَهَابُ الْعُذْرَةِ
u'ذَهَابٌ عُضْوٌ':Added, #1: 1	ذَهَابِ الْعُذْرَةِ
u'ذَهَابٌ عَطَاءٌ':Added, #1: 1	ذَهَابَ عُضْوٍ
u'ذَهَابٌ عَقْلٌ':Added, #1: 1	ذَهَابُ عَطَاءٍ
u'ذَهَابٌ عَقْلٌ':Added, #1: 1	ذَهَابَ الْعَقْلِ
u'ذَهَابٌ عَقْلٌ':Added, #2: 2	ذَهَابِ عَقْلِهِ
u'ذَهَابٌ عَقْلٌ':Added, #4: 4	ذَهَابُ الْعَقْلِ
u'ذَهَابٌ عِلَّةٌ':Added, #7: 7	ذَهَابِ الْعَقْلِ
u'ذَهَابٌ علم':Added, #1: 1	ذَهَابَ عِلَّتِهِ
u'ذَهَابٌ عِلْمٌ':Added, #1: 1	ذَهَابُ الْعِلْمِ
u'ذَهَابٌ علم':Added, #1: 1	ذَهَابُ الْعِلْمِ
u'ذَهَابٌ علم':Added, #2: 2	ذَهَابَ الْعِلْمِ
u'ذَهَابٌ عِلْمٌ':Added, #2: 2	ذَهَابِ الْعِلْمِ
u'ذَهَابٌ عِلْمٌ':Added, #2: 2	ذَهَابَ الْعِلْمِ
u'ذَهَابٌ علماء':Added, #2: 2	ذَهَابِ الْعِلْمِ
u'ذَهَابٌ علماء':Added, #1: 1	ذَهَابُ الْعُلَمَاءِ
u'ذَهَابٌ عُلَمَاءُ':Added, #1: 1	ذَهَابِ الْعُلَمَاءِ
u'ذَهَابٌ عُلَمَاءُ':Added, #1: 1	ذَهَابُ الْعُلَمَاءِ
u'ذَهَابٌ عور':Added, #1: 1	ذَهَابِ الْعُلَمَاءِ
u'ذَهَابٌ عور':Added, #1: 1	ذَهَابُ الْعَوَرِ
u'ذَهَابٌ عَوَرٌ':Added, #1: 1	ذَهَابِ الْعَوَرِ
u'ذَهَابٌ عَوَرٌ':Added, #1: 1	ذَهَابُ الْعَوَرِ
u'ذَهَابٌ عَيْبٌ':Added, #1: 1	ذَهَابِ الْعَوَرِ
u'ذَهَابٌ عين':Added, #1: 1	ذَهَابُ الْعَيْبِ
u'ذَهَابٌ عَيْنٌ':Added, #1: 1	ذَهَابِ الْعَيْنِ
u'ذَهَابٌ عَيْن':Added, #1: 1	ذَهَابِ الْعَيْنِ
u'ذَهَابٌ عين':Added, #1: 1	ذَهَابِ الْعَيْنِ
u'ذَهَابٌ عَيْنٌ':Added, #1: 1	ذَهَابِ عَيْنِ
u'ذَهَابٌ عَيْن':Added, #1: 1	ذَهَابِ عَيْنِ
u'ذَهَابٌ عين':Added, #1: 1	ذَهَابِ عَيْنِ
u'ذَهَابٌ عين':Added, #1: 1	ذَهَابَ عَيْنِهِ
u'ذَهَابٌ عَيْنٌ':Added, #1: 1	ذَهَابِ عَيْنِهِ
u'ذَهَابٌ عَيْنٌ':Added, #1: 1	ذَهَابَ عَيْنِهِ
u'ذَهَابٌ عَيْن':Added, #1: 1	ذَهَابِ عَيْنِهِ
u'ذَهَابٌ عَيْن':Added, #1: 1	ذَهَابَ عَيْنِهِ
u'ذَهَابٌ عين':Added, #1: 1	ذَهَابِ عَيْنِهِ
u'ذَهَابٌ عَيْنٌ':Added, #2: 2	ذَهَابُ الْعَيْنِ
u'ذَهَابٌ عَيْن':Added, #2: 2	ذَهَابُ الْعَيْنِ
u'ذَهَابٌ عين':Added, #2: 2	ذَهَابُ الْعَيْنِ
u'ذَهَابٌ عَيْنٌ':Added, #2: 2	ذَهَابُ عَيْنِ
u'ذَهَابٌ عَيْن':Added, #2: 2	ذَهَابُ عَيْنِ
u'ذَهَابٌ فلان':Added, #2: 2	ذَهَابُ عَيْنِ
u'ذَهَابٌ قَافِلٌ':Added, #1: 1	ذَهَابُ الشَّافِعِيِّ
u'ذَهَابٌ قَافِلَةٌ':Added, #1: 1	ذَهَابِ الْقَافِلَةِ
u'ذَهَابٌ قَدْرٌ':Added, #1: 1	ذَهَابِ الْقَافِلَةِ
u'ذَهَابٌ قَرْنٌ':Added, #1: 1	ذَهَابُ قَدْرِ
u'ذَهَابٌ قُوَّةٌ':Added, #1: 1	ذَهَابَ الْقَرْنِ
u'ذَهَابٌ قُوَّة':Added, #1: 1	ذَهَابُ الْقُوَّةِ
u'ذَهَابٌ قُوَّةٌ':Added, #1: 1	ذَهَابُ الْقُوَّةِ
u'ذَهَابٌ قُوَّة':Added, #1: 1	ذَهَابِ قُوَّةِ
u'ذَهَابٌ قُوتٌ':Added, #1: 1	ذَهَابِ قُوَّةِ
u'ذَهَابٌ كَلاَمٌ':Added, #2: 2	ذَهَابُ قُوتِهِ
u'ذَهَابٌ كَلاَمٌ':Added, #1: 1	ذَهَابِ الْكَلاَمِ
u'ذَهَابٌ لُثْغَةٌ':Added, #2: 2	ذَهَابَ الْكَلَامِ
u'ذَهَابٌ لِحْيَةٌ':Added, #1: 1	ذَهَابِ لُثْغَتِهِ
u'ذَهَابٌ لَذَّةٌ':Added, #1: 1	ذَهَابُ لِحْيَتِهِ
u'ذَهَابٌ مَاءٌ':Added, #1: 1	ذَهَابِ لَذَّةٍ
u'ذَهَابٌ مَالٌ':Added, #3: 3	ذَهَابُ الْمَاءِ
u'ذَهَابٌ مَالٌ':Added, #1: 1	ذَهَابَ الْمَالِ
u'ذَهَابٌ مَالٌ':Added, #1: 1	ذَهَابُ الْمَالِ
u'ذَهَابٌ مَالٌ':Added, #1: 1	ذَهَاب مَالِ
u'ذَهَابٌ مَالٌ':Added, #1: 1	ذَهَابُ مَالِهِ
u'ذَهَابٌ مَالٌ':Added, #1: 1	ذَهَابِ مَالِهِ
u'ذَهَابٌ مَالٌ':Added, #3: 3	ذَهَابِ الْمَالِ
u'ذَهَابٌ مُجَاوَزَةٌ':Added, #7: 7	ذَهَابَ مَالِهِ
u'ذَهَابٌ مَشْيٌ':Added, #1: 1	ذَهَابِ الْمُجَاوَزَةِ
u'ذَهَابٌ مَشْيٌ':Added, #1: 1	ذَهَابَ الْمَشْيِ
u'ذَهَابٌ مَنْفَعَةٌ':Added, #1: 1	ذَهَابَ مَشْيِهِ
u'ذَهَابٌ نِساءٌ':Added, #1: 1	ذَهَابَ مَنْفَعَةِ
u'ذَهَابٌ نَسْلٌ':Added, #1: 1	ذَهَابِ النِّسَاءِ
u'ذَهَابٌ نِصْفٌ':Added, #1: 1	ذَهَابُ النَّسْلِ
u'ذَهَابٌ نَفْسٌ':Added, #1: 1	ذَهَابِ نِصْفِ
u'ذَهَابٌ نَفْسٌ':Added, #1: 1	ذَهَابِ النَّفْسِ
u'ذَهَابٌ نَفْعٌ':Added, #1: 1	ذَهَابِ نَفْسِهِ
u'ذَهَابٌ نَفَقَةٌ':Added, #2: 2	ذَهَابِ نَفْعِهِ
u'ذَهَابٌ نَفَقَةٌ':Added, #1: 1	ذَهَابِ نَفَقَةٍ
u'ذَهَابٌ هلاك':Added, #2: 2	ذَهَابُ نَفَقَةٍ
u'ذَهَابٌ هَلاَكٌ':Added, #1: 1	ذَهَابَ هَلَاكٍ
u'ذَهَابٌ وَقْتٌ':Added, #1: 1	ذَهَابَ هَلَاكٍ
u'ذَهَابٌ وَقْتٌ':Added, #1: 1	ذَهَابِ الْوَقْتَيْنِ
u'ذَهَابٌ وَقْتٌ':Added, #2: 2	ذَهَابُ الْوَقْتِ
u'ذَهَابٌ وَقْتٌ':Added, #5: 5	ذَهَابَ الْوَقْتِ
u'ذَهَابٌ ولد':Added, #6: 6	ذَهَابِ الْوَقْتِ
u'ذَهَابٌ وَلَدٌ':Added, #1: 1	ذَهَابِ الْوَلَدِ
u'ذَهَبَ أَبْعَدُ':Predicate, #1: 1	ذَهَابِ الْوَلَدِ
u'ذَهَبَ اِبْنٌ':Subject, #1: 1	ذَهَبَ أَبْعَدَ
u'ذَهَبَ أثَرٌ':Subject, #22: 22	ذَهَبَ ابْنُ
u'ذَهَبَ أثَرٌ':Subject, #2: 2	ذَهَبَ أَثَرُ
u'ذَهَبَ أثَرٌ':Subject, #2: 2	ذَهَبَ أَثَرُهُ
u'ذَهَبَ أَجْرٌ':Subject, #3: 3	ذَهَبَ الْأَثَرُ
u'ذَهَبَ إِحْسَاسٌ':Predicate, #1: 1	ذَهَبَ أَجْرُهُ
u'ذَهَبَ إِذْنٌ':Subject, #1: 1	أَذْهَبَ الْإِحْسَاسَ
u'ذَهَبَ أَرْبَعَةٌ':Subject, #1: 1	ذَهَبَ الْإِذْنُ
u'ذَهَبَ أُسْتَاذٌ':Subject, #1: 1	ذَهَبَ أَرْبَعَةُ
u'ذَهَبَ اِسْتِقْرارٌ':Subject, #4: 4	ذَهَبَ الْأُسْتَاذُ
u'ذَهَبَ أسْنَانٌ':Subject, #1: 1	ذَهَبَ اسْتِقْرَارُ
u'ذَهَبَ أَصْحَابٌ':Subject, #1: 1	ذَهَبَ أَسْنَانُهُ
u'ذَهَبَ أَغْنِيَاء':Subject, #4: 4	ذَهَبَ أَصْحَابُ
u'ذَهَبَ أقَلُّ':Subject, #1: 1	ذَهَبَ الأَغْنِيَاءُ
u'ذَهَبَ أَكْثَرُ':Predicate, #4: 4	ذَهَبَ أَقَلُّ
u'ذَهَبَ أَكْثَرُ':Subject, #1: 1	ذَهَبَ أَكْثَرَ
u'ذَهَبَ أَكْثَرُ':Subject, #1: 1	ذَهَبَ الْأَكْثَرُ
u'ذَهَبَ إمَامٌ':Subject, #23: 23	ذَهَبَ أَكْثَرُ
u'ذَهَبَ إمَامٌ':Subject, #10: 10	ذَهَبَ الْإِمَامُ
u'ذَهَبَ أَمْرٌ':Subject, #2: 2	ذَهَبَ إمَامُ
u'ذَهَبَ أهْلٌ':Subject, #2: 2	ذَهَبَ أَمْرُ
u'ذَهَبَ أهْلٌ':Subject, #11: 11	ذَهَبَ أَهْلُ
u'ذَهَبَ أئِمَّةٌ':Subject, #1: 1	ذَهَبَ أَهْلُهُ
u'ذَهَبَ بَائِعٌ':Subject, #1: 1	ذَهَبَ أَئِمَّةُ
u'ذَهَبَ بُخَارِيٌّ':Subject, #1: 1	ذَهَبَ الْبَائِعُ
u'ذَهَبَ بَصَرٌ':Predicate, #2: 2	ذَهَبَ الْبُخَارِيُّ
u'ذَهَبَ بَصَرٌ':Subject, #1: 1	أَذْهَبَ بَصَرَ
u'ذَهَبَ بَصَرٌ':Subject, #13: 13	ذَهَبَ بَصَرُهُ
u'ذَهَبَ بَعْضٌ':Predicate, #1: 1	ذَهَبَ بَصَرُ
u'ذَهَبَ بَعْضٌ':Subject, #1: 1	أَذْهَبَ بَعْضَ
u'ذَهَبَ بَعْضٌ':Subject, #1: 1	ذَهَبَ الْبَعْضُ
u'ذَهَبَ بَعْضٌ':Subject, #44: 44	ذَهَبَ بَعْضُ
u'ذَهَبَ بَيَاضٌ':Subject, #6: 6	ذَهَبَ بَعْضُهُ
u'ذَهَبَ بَيَاضٌ':Subject, #11: 11	ذَهَبَ الْبَيَاضُ
u'ذَهَبَ تَطْلِيقٌ':Subject, #2: 2	ذَهَبَ بَيَاضُ
u'ذَهَبَ تَكَرُّمٌ':Subject, #1: 1	ذَهَبَ تَطْلِيقَاتُ
u'ذَهَبَ تونِسِيّ':Subject, #2: 2	ذَهَبَ التَّكَرُّمُ
u'ذَهَبَ ثَلاثَةٌ':Subject, #1: 1	ذَهَبَ التُّونِسِيُّ
u'ذَهَبَ ثِمارٌ':Subject, #2: 2	ذَهَبَ ثَلَاثَةُ
u'ذَهَبَ ثَمانِيَةٌ':Subject, #1: 1	ذَهَبَ ثِمَارُهُ
u'ذَهَبَ ثَوْرٌ':Subject, #1: 1	ذَهَبَ ثَمَانِيَةٌ
u'ذَهَبَ جَمَاعَةٌ':Subject, #1: 1	ذَهَبَ الثَّوْرُ
u'ذَهَبَ جَمَاهِيرُ':Subject, #13: 13	ذَهَبَ جَمَاعَةٌ
u'ذَهَبَ جمع':Subject, #1: 1	ذَهَبَ جَمَاهِيرُ
u'ذَهَبَ جَمْعٌ':Subject, #1: 1	ذَهَبَ الْجَمْعُ
u'ذَهَبَ جَمْعٌ':Subject, #1: 1	ذَهَبَ الْجَمْعُ
u'ذَهَبَ جُمْهُورٌ':Subject, #2: 2	ذَهَبَ جَمْعٌ
u'ذَهَبَ جُمْهُورٌ':Subject, #6: 6	ذَهَبَ جُمْهُورُ
u'ذَهَبَ حارِثٌ':Subject, #8: 8	ذَهَبَ الْجُمْهُورُ
u'ذَهَبَ حَرْفٌ':Subject, #1: 1	ذَهَبَ الْحَارِثُ
u'ذَهَبَ حِزْبٌ':Subject, #2: 2	ذَهَبَ حَرْفٌ
u'ذَهَبَ حَسَنٌ':Subject, #1: 1	ذَهَبَ حِزْبُ
u'ذَهَبَ حُسْنٌ':Subject, #3: 3	ذَهَبَ الْحَسَنُ
u'ذَهَبَ حِصَّةٌ':Subject, #3: 3	ذَهَبَ حُسْنُ
u'ذَهَبَ حَصْرٌ':Subject, #1: 1	ذَهَبَ حِصَّتُهُ
u'ذَهَبَ حِفْظٌ':Subject, #1: 1	ذَهَبَ الْحَصْرُ
u'ذَهَبَ حَقٌّ':Subject, #1: 1	ذَهَبَ حِفْظُ
u'ذَهَبَ حَلاَوَةٌ':Subject, #2: 2	ذَهَبَ حَقُّهُ
u'ذَهَبَ حَلْوانِيٌّ':Subject, #1: 1	ذَهَبَ حَلَاوَةُ
u'ذَهَبَ حِمَارٌ':Subject, #1: 1	ذَهَبَ الْحَلْوَانِيُّ
u'ذَهَبَ حَيَاءٌ':Subject, #1: 1	ذَهَبَ الْحِمَارُ
u'ذَهَبَ خُشُوعٌ':Predicate, #3: 3	ذَهَبَ الْحَيَاءُ
u'ذَهَبَ خَشْيَةٌ':Predicate, #2: 2	أَذْهَبَ الْخُشُوعَ
u'ذَهَبَ خلائق':Subject, #2: 2	ذَهَبَ خَشْيَةَ
u'ذَهَبَ خَلائِقُ':Subject, #1: 1	ذَهَبَ خَلَائِقُ
u'ذَهَبَ خَلِيلٌ':Subject, #1: 1	ذَهَبَ خَلَائِقُ
u'ذَهَبَ خِنْصَرٌ':Subject, #1: 1	ذَهَبَ الْخَلِيلُ
u'ذَهَبَ خَوْفٌ':Subject, #1: 1	ذَهَبَ خِنْصَرٌ
u'ذَهَبَ دَمٌ':Subject, #2: 2	ذَهَبَ الْخَوْفُ
u'ذَهَبَ دَمٌ':Subject, #1: 1	ذَهَبَ الدَّمُ
u'ذَهَبَ دِيَةٌ':Subject, #4: 4	ذَهَبَ دَمُهُ
u'ذَهَبَ دِينٌ':Subject, #2: 2	ذَهَبَ الدِّيَةُ
u'ذَهَبَ ذاهِب':Subject, #3: 3	ذَهَبَ دِينُهُ
u'ذَهَبَ ذَهَبٌ':Predicate, #6: 6	ذَهَبَ ذَاهِبٌ
u'ذَهَبَ ذَهَبٌ':Subject, #2: 2	ذَهَبَ ذَهَبَ
u'ذَهَبَ رَبُّ':Subject, #1: 1	ذَهَبَ الذَّهَبُ
u'ذَهَبَ رُبْعٌ':Subject, #1: 1	ذَهَبَ رَبُّ
u'ذَهَبَ رُبُعٌ':Subject, #1: 1	ذَهَبَ رُبْعُ
u'ذَهَبَ رُبُعٌ':Subject, #1: 1	ذَهَبَ رُبُعُهُ
u'ذَهَبَ رِجَالٌ':Subject, #9: 9	ذَهَبَ رُبُعُ
u'ذَهَبَ رَسُولٌ':Subject, #1: 1	ذَهَبَ الرِّجَالُ
u'ذَهَبَ رِطْلٌ':Subject, #8: 8	ذَهَبَ رَسُولُ
u'ذَهَبَ رُقادٌ':Subject, #1: 1	ذَهَبَ رِطْلٌ
u'ذَهَبَ روحٌ':Subject, #1: 1	ذَهَبَ الرّقَادُ
u'ذَهَبَ روع':Subject, #2: 2	ذَهَبَ الرُّوحُ
u'ذَهَبَ رَوْعٌ':Subject, #1: 1	ذَهَبَ الرَّوْعُ
u'ذَهَبَ رَوْنَقٌ':Predicate, #1: 1	ذَهَبَ الرَّوْعُ
u'ذَهَبَ ريحٌ':Subject, #1: 1	أَذْهَبَ رَوْنَقَ
u'ذَهَبَ زَمانٌ':Subject, #2: 2	ذَهَبَ رِيحُهُ
u'ذَهَبَ زَيْدٌ':Subject, #1: 1	ذَهَبَ زَمَانُ
u'ذَهَبَ سَاعَةٌ':Subject, #1: 1	ذَهَبَ زَيْدٌ
u'ذَهَبَ سِتٌّ':Subject, #1: 1	ذَهَبَ سَاعَةٌ
u'ذَهَبَ سَحَابٌ':Subject, #1: 1	ذَهَبَ سِتَّةٌ
u'ذَهَبَ سُرَّاقٌ':Subject, #1: 1	ذَهَبَ السَّحَابُ
u'ذَهَبَ سَعِيدٌ':Subject, #3: 3	ذَهَبَ السُّرَّاقُ
u'ذَهَبَ سكر':Subject, #3: 3	ذَهَبَ سَعِيدُ
u'ذَهَبَ سكر':Subject, #1: 1	ذَهَبَ سَكَرُهُ
u'ذَهَبَ سُكْرٌ':Subject, #2: 2	ذَهَبَ سُكْرُهُ
u'ذَهَبَ سِلاَحٌ':Subject, #2: 2	ذَهَبَ سُكْرُهُ
u'ذَهَبَ سَمْعٌ':Predicate, #1: 1	ذَهَبَ سِلَاحُهُ
u'ذَهَبَ سَمْعٌ':Subject, #1: 1	أَذْهَبَ سَمْعَ
u'ذَهَبَ شافِعِيّ':Subject, #11: 11	ذَهَبَ سَمْعُهُ
u'ذَهَبَ شَرٌّ':Subject, #13: 13	ذَهَبَ الشَّافِعِيُّ
u'ذَهَبَ شَرٌّ':Subject, #1: 1	ذَهَبَ الشَّرُّ
u'ذَهَبَ شَرِيفٌ':Subject, #1: 1	ذَهَبَ شَرُّهُ
u'ذَهَبَ شَطْرٌ':Subject, #1: 1	ذَهَبَ الشَّرِيفُ
u'ذَهَبَ شَعَرٌ':Subject, #3: 3	ذَهَبَ شَطْرُ
u'ذَهَبَ شَعْرٌ':Subject, #1: 1	ذَهَبَ شَعَرُ
u'ذَهَبَ شَعْرٌ':Subject, #3: 3	ذَهَبَ شَعْرُ
u'ذَهَبَ شفق':Subject, #3: 3	ذَهَبَ شَعْرُهُ
u'ذَهَبَ شفق':Subject, #1: 1	ذَهَبَ الشّفَقُ
u'ذَهَبَ شَفَقٌ':Subject, #1: 1	ذَهَبَ الشَّفَقُ
u'ذَهَبَ شَفَقٌ':Subject, #1: 1	ذَهَبَ الشّفَقُ
u'ذَهَبَ شَمٌّ':Subject, #1: 1	ذَهَبَ الشَّفَقُ
u'ذَهَبَ شمس':Subject, #2: 2	ذَهَبَ شَمُّهُ
u'ذَهَبَ شَمْسٌ':Subject, #6: 6	ذَهَبَ شَمْسُ
u'ذَهَبَ شَيْخٌ':Subject, #6: 6	ذَهَبَ شَمْسُ
u'ذَهَبَ شَيْخٌ':Subject, #1: 1	ذَهَبَ شَيْخُهُ
u'ذَهَبَ شَيْخٌ':Subject, #2: 2	ذَهَبَ شَيْخُ
u'ذَهَبَ شُيُوخٌ':Subject, #3: 3	ذَهَبَ الشَّيْخُ
u'ذَهَبَ صَاحِبٌ':Subject, #1: 1	ذَهَبَ الشُّيُوخُ
u'ذَهَبَ صَحَابَةٌ':Subject, #7: 7	ذَهَبَ صَاحِبُ
u'ذَهَبَ صَلاَةٌ':Subject, #1: 1	ذَهَبَ الصَّحَابَةُ
u'ذَهَبَ صَوْتٌ':Subject, #1: 1	ذَهَبَ صَلاَةُ
u'ذَهَبَ صَيْرَفِيٌّ':Subject, #1: 1	ذَهَبَ صَوْتُهُ
u'ذَهَبَ ضَوْءٌ':Predicate, #1: 1	ذَهَبَ الصَّيْرَفِيُّ
u'ذَهَبَ ضَوْءٌ':Predicate, #1: 1	أَذْهَبَ ضَوْءَ
u'ذَهَبَ طَائِفٌ':Subject, #2: 2	أَذْهَبَ الضَّوْءَ
u'ذَهَبَ طَرَفٌ':Subject, #2: 2	ذَهَبَ طَائِفَةٌ
u'ذَهَبَ ظُفْرٌ':Subject, #1: 1	ذَهَبَ طَرَفَاهُ
u'ذَهَبَ ظَمَأٌ':Subject, #1: 1	ذَهَبَ ظُفْرٌ
u'ذَهَبَ عَادٌ':Predicate, #7: 7	ذَهَبَ الظَّمَأُ
u'ذَهَبَ عَامٌّ':Subject, #1: 1	ذَهَبَ عَادَ
u'ذَهَبَ عَامِرٌ':Subject, #11: 11	ذَهَبَ عَامَّةُ
u'ذَهَبَ عجز':Subject, #1: 1	ذَهَبَ عَامِرٌ
u'ذَهَبَ عَجْزٌ':Subject, #1: 1	ذَهَبَ الْعَجْزُ
u'ذَهَبَ عَدَمٌ':Subject, #1: 1	ذَهَبَ الْعَجْزُ
u'ذَهَبَ عَدُوٌّ':Subject, #1: 1	ذَهَبَ عَدَمُ
u'ذَهَبَ عُرْوَةٌ':Subject, #3: 3	ذَهَبَ الْعَدُوُّ
u'ذَهَبَ عزل':Subject, #2: 2	ذَهَبَ عُرْوَةُ
u'ذَهَبَ عِشَاءٌ':Subject, #1: 1	ذَهَبَ عَزْلُهُ
u'ذَهَبَ عُطاس':Subject, #3: 3	ذَهَبَ الْعِشَاءُ
u'ذَهَبَ عَقِبٌ':Predicate, #1: 1	ذَهَبَ الْعُطَاسُ
u'ذَهَبَ عَقْلٌ':Subject, #1: 1	ذَهَبَ عَقِبَ
u'ذَهَبَ عَقْلٌ':Subject, #1: 1	ذَهَبَ عَقْلُ
u'ذَهَبَ علم':Subject, #23: 23	ذَهَبَ عَقْلُهُ
u'ذَهَبَ عِلْمٌ':Subject, #1: 1	ذَهَبَ عِلْمُهُ
u'ذَهَبَ عَمَلٌ':Subject, #1: 1	ذَهَبَ عِلْمُهُ
u'ذَهَبَ عور':Subject, #1: 1	ذَهَبَ الْعَمَلُ
u'ذَهَبَ عَوَرٌ':Subject, #4: 4	ذَهَبَ الْعَوَرُ
u'ذَهَبَ عَيْبٌ':Subject, #4: 4	ذَهَبَ الْعَوَرُ
u'ذَهَبَ عِيرٌ':Subject, #1: 1	ذَهَبَ الْعَيْبُ
u'ذَهَبَ عين':Predicate, #1: 1	ذَهَبَ عِيرٌ
u'ذَهَبَ عَيْنٌ':Predicate, #1: 1	أَذْهَبَ الْعَيْنَ
u'ذَهَبَ عَيْن':Predicate, #1: 1	أَذْهَبَ الْعَيْنَ
u'ذَهَبَ عين':Subject, #1: 1	أَذْهَبَ الْعَيْنَ
u'ذَهَبَ عَيْنٌ':Subject, #4: 4	ذَهَبَ عَيْنُهُ
u'ذَهَبَ عَيْن':Subject, #4: 4	ذَهَبَ عَيْنُهُ
u'ذَهَبَ عين':Subject, #4: 4	ذَهَبَ عَيْنُهُ
u'ذَهَبَ عَيْنٌ':Subject, #5: 5	ذَهَبَ عَيْنُ
u'ذَهَبَ عَيْن':Subject, #5: 5	ذَهَبَ عَيْنُ
u'ذَهَبَ غَرَضٌ':Subject, #5: 5	ذَهَبَ عَيْنُ
u'ذَهَبَ غير':Subject, #1: 1	ذَهَبَ غَرَضُهُ
u'ذَهَبَ غَيْرٌ':Subject, #3: 3	ذَهَبَ غَيْرُ
u'ذَهَبَ فخر':Subject, #3: 3	ذَهَبَ غَيْرُ
u'ذَهَبَ فَخْرٌ':Subject, #3: 3	ذَهَبَ فَخْرُ
u'ذَهَبَ فَرِيقٌ':Subject, #3: 3	ذَهَبَ فَخْرُ
u'ذَهَبَ فَضْلٌ':Subject, #1: 1	ذَهَبَ فَرِيقٌ
u'ذَهَبَ فقهاء':Subject, #1: 1	ذَهَبَ الْفَضْلُ
u'ذَهَبَ فلان':Predicate, #2: 2	ذَهَبَ فُقَهَاءُ
u'ذَهَبَ فلان':Subject, #1: 1	ذَهَبَ دَاوُدَ
u'ذَهَبَ فلان':Subject, #13: 13	ذَهَبَ الشَّافِعِيُّ
u'ذَهَبَ فلان':Subject, #1: 1	ذَهَبَ الزَّمَخْشَرِيُّ
u'ذَهَبَ فلان':Subject, #1: 1	ذَهَبَ الْمِقْدَادُ
u'ذَهَبَ قَالٌ':Predicate, #1: 1	ذَهَبَ عُثْمَانُ
u'ذَهَبَ قَالٌ':Predicate, #1: 1	أَذْهَبَ قَالَ
u'ذَهَبَ قَائِلٌ':Subject, #1: 1	ذَهَبَ قَالَ
u'ذَهَبَ قُدَّامٌ':Subject, #1: 1	ذَهَبَ الْقَائِلُ
u'ذَهَبَ قدماء':Subject, #1: 1	ذَهَبَ قُدَّامُ
u'ذَهَبَ قول':Subject, #1: 1	ذَهَبَ قُدَمَاءُ
u'ذَهَبَ قَوْلٌ':Subject, #1: 1	ذَهَبَ قَوْلُ
u'ذَهَبَ قَوْمٌ':Subject, #1: 1	ذَهَبَ قَوْلُ
u'ذَهَبَ كَافٌّ':Subject, #16: 16	ذَهَبَ قَوْمٌ
u'ذَهَبَ كَافَّةٌ':Subject, #4: 4	ذَهَبَ كَافَّةُ
u'ذَهَبَ كِتَابٌ':Subject, #4: 4	ذَهَبَ كَافَّةُ
u'ذَهَّبَ كعبة':Predicate, #1: 1	ذَهَبَ الْكِتَابُ
u'ذَهَّبَ كَعْبَةٌ':Predicate, #1: 1	ذَهَّبَ الْكَعْبَةَ
u'ذَهَبَ كَلاَمٌ':Subject, #1: 1	ذَهَّبَ الْكَعْبَةَ
u'ذَهَبَ كُوفِيٌّ':Subject, #1: 1	ذَهَبَ الْكَلَامُ
u'ذَهَبَ لبن':Subject, #1: 1	ذَهَبَ الْكُوفِيُّ
u'ذَهَبَ لَبَنٌ':Subject, #1: 1	ذَهَبَ لَبَنُ
u'ذَهَبَ لبن':Subject, #1: 1	ذَهَبَ لَبَنُ
u'ذَهَبَ لَبَنٌ':Subject, #3: 3	ذَهَبَ اللَّبَنُ
u'ذَهَبَ لَحْمٌ':Subject, #3: 3	ذَهَبَ اللَّبَنُ
u'ذَهَبَ لَيْثٌ':Subject, #1: 1	ذَهَبَ لَحْمُ
u'ذَهَبَ لَيْلٌ':Subject, #1: 1	ذَهَبَ اللَّيْثُ
u'ذَهَبَ لَيْلٌ':Subject, #1: 1	ذَهَبَ اللّيْلُ
u'ذَهَبَ مَاءٌ':Subject, #2: 2	ذَهَبَ اللَّيْلُ
u'ذَهَبَ مَاءٌ':Subject, #1: 1	ذَهَبَ مَاءُ
u'ذَهَبَ مَالٌ':Subject, #6: 6	ذَهَبَ الْمَاءُ
u'ذَهَبَ مَالٌ':Subject, #1: 1	ذَهَبَ الْمَالُ
u'ذَهَبَ مَالِكٌ':Subject, #3: 3	ذَهَبَ مَالُهُ
u'ذَهَبَ مَالِكٌ':Subject, #1: 1	ذَهَبَ الْمَالِكُ
u'ذَهَبَ مُجْتَهِد':Subject, #9: 9	ذَهَبَ مَالِكٌ
u'ذَهَبَ مَحَافِظُ':Subject, #1: 1	ذَهَبَ مُجْتَهِدٌ
u'ذَهَبَ مُحَمَّدٌ':Subject, #1: 1	ذَهَبَ الْمَحَافِظُ
u'ذَهَبَ مُحَمَّدٌ':Subject, #1: 1	ذَهَبَ مُحَمَّدٌ
u'ذَهَبَ مَذْهَبٌ':Predicate, #1: 1	ذَهَبَ مُحَمَّدُ
u'ذَهَبَ مرٌّ':Predicate, #5: 5	ذَهَبَ مَذْهَبَ
u'ذَهَبَ مُسْتَأْجِرٌ':Subject, #1: 1	ذَهَبَ مَرَّةً
u'ذَهَبَ مَشَايِخُ':Subject, #1: 1	ذَهَبَ مُسْتَأْجِرُ
u'ذَهَبَ مُصَالِحٌ':Subject, #1: 1	ذَهَبَ الْمَشَايِخُ
u'ذَهَبَ مُصَنِّفٌ':Subject, #1: 1	ذَهَبَ الْمُصَالِحُ
u'ذَهَبَ مَعْرِفَةٌ':Predicate, #1: 1	ذَهَبَ الْمُصَنِّفُ
u'ذَهَبَ مَعْرِفَة':Predicate, #1: 1	أَذْهَبَ الْمَعْرِفَةَ
u'ذَهَبَ مُعْظَمٌ':Subject, #1: 1	أَذْهَبَ الْمَعْرِفَةَ
u'ذَهَبَ مِقْدَارٌ':Subject, #7: 7	ذَهَبَ مُعْظَمُ
u'ذَهَبَ مُنْذِرٌ':Subject, #1: 1	ذَهَبَ مِقْدَارُ
u'ذَهَبَ مَنْفَعَةٌ':Subject, #1: 1	ذَهَبَ مُنْذِرُ
u'ذَهَبَ مُودِعٌ':Subject, #2: 2	ذَهَبَ مَنْفَعَتُهُ
u'ذَهَبَ مَوْهُوبٌ':Subject, #1: 1	ذَهَبَ الْمُودِعُ
u'ذَهَبَ مِيرَاثٌ':Subject, #1: 1	ذَهَبَ الْمَوْهُوبُ
u'ذَهَبَ نَاسٌ':Subject, #3: 3	ذَهَبَ الْمِيرَاثُ
u'ذَهَبَ نَبِيٌّ':Subject, #4: 4	ذَهَبَ النَّاسُ
u'ذَهَبَ نُحَاةٌ':Subject, #2: 2	ذَهَبَ النَّبِيُّ
u'ذَهَبَ نَحْوٌ':Predicate, #1: 1	ذَهَبَ النُّحَاةُ
u'ذَهَبَ نَحْوٌ':Subject, #1: 1	ذَهَبَ نَحْوَ
u'ذَهَبَ نَسْلٌ':Subject, #3: 3	ذَهَبَ نَحْوٌ
u'ذَهَبَ نِصْفٌ':Subject, #1: 1	ذَهَبَ نَسْلُهُ
u'ذَهَبَ نِصْفٌ':Subject, #15: 15	ذَهَبَ نِصْفُ
u'ذَهَبَ نِصْفٌ':Subject, #3: 3	ذَهَبَ النِّصْفُ
u'ذَهَبَ نِصْفٌ':Subject, #3: 3	ذَهَبَ نِصْفٌ
u'ذَهَبَ نَصِيبٌ':Subject, #8: 8	ذَهَبَ نِصْفُهُ
u'ذَهَبَ نَصِيبٌ':Subject, #1: 1	ذَهَبَ نَصِيبُ
u'ذَهَبَ نَصِيحٌ':Subject, #1: 1	ذَهَبَ نَصِيبُهُ
u'ذَهَبَ نُطْقٌ':Predicate, #1: 1	ذَهَبَ النَّصِيحُ
u'ذَهَبَ نَظَّامٌ':Subject, #1: 1	أَذْهَبَ النُّطْقَ
u'ذَهَبَ نَفْعٌ':Subject, #1: 1	ذَهَبَ النَّظَّامُ
u'ذَهَبَ نَفْعٌ':Subject, #1: 1	ذَهَبَ نَفْعُ
u'ذَهَبَ نُورٌ':Subject, #1: 1	ذَهَبَ نَفْعُهُ
u'ذَهَبَ نَوْمٌ':Subject, #1: 1	ذَهَبَ نُورُ
u'ذَهَبَ نَوَوِيٌّ':Subject, #1: 1	ذَهَبَ نَوْمُهُ
u'ذَهَبَ هِلاَلٌ':Subject, #1: 1	ذَهَبَ النَّوَوِيُّ
u'ذَهَبَ واحد':Subject, #1: 1	ذَهَبَ هِلَالٌ
u'ذَهَبَ وَاحِدٌ':Subject, #1: 1	ذَهَبَ وَاحِدٌ
u'ذَهَبَ وَفَاءٌ':Subject, #1: 1	ذَهَبَ وَاحِدٌ
u'ذَهَبَ وَقْتٌ':Subject, #1: 1	ذَهَبَ الْوَفَاءُ
u'ذَهَبَ وَقْتٌ':Subject, #1: 1	ذَهَبَ وَقْتُهُ
u'ذَهَبَ وَقْتٌ':Subject, #5: 5	ذَهَبَ وَقْتُ
u'ذَهَبَ وَكِيلٌ':Subject, #9: 9	ذَهَبَ الْوَقْتُ
u'ذَهَبَ وَهْمٌ':Subject, #1: 1	ذَهَبَ الْوَكِيلُ
u'ذَهَبَ يَوْمٌ':Predicate, #1: 1	ذَهَبَ وَهْمُهُ
u'ذَهِلَ جَمَاعَةٌ':Subject, #1: 1	ذَهَبَ يَوْمَ
u'ذُهُولٌ شُهُودٌ':Added, #1: 1	ذَهِلَ جَمَاعَةٌ
u'ذُهُولٌ مَرَاضِعُ':Added, #1: 1	ذُهُولُ الشُّهُودِ
u'ذُهُولٌ نِيَّةٌ':Added, #1: 1	ذُهُولَ الْمَرَاضِعِ
u'ذَوْبٌ رَصاصٌ':Added, #1: 1	ذُهُولُ النِّيَّةِ
u'ذَوْبٌ ملح':Added, #2: 2	ذَوْبَ الرَّصَاصِ
u'ذَوْبٌ مِلْحٌ':Added, #2: 2	ذَوْبَ الْمِلْحِ
u'ذَوْدٌ رَسُولٌ':Added, #2: 2	ذَوْبَ الْمِلْحِ
u'ذَوْقٌ شَيْءٌ':Added, #1: 1	ذَوْدَ رَسُولِ
u'ذَوْقٌ طعام':Added, #2: 2	ذَوْقُ شَيْءٍ
u'ذَوْقٌ طعام':Added, #2: 2	ذَوْقَ الطَّعَامِ
u'ذَوْقٌ طعام':Added, #2: 2	ذَوْقُ الطَّعَامِ
u'ذَوْقٌ طَعَامٌ':Added, #2: 2	ذَوْقِ الطَّعَامِ
u'ذَوْقٌ طَعَامٌ':Added, #2: 2	ذَوْقَ الطَّعَامِ
u'ذَوْقٌ طَعَامٌ':Added, #2: 2	ذَوْقُ الطَّعَامِ
u'ذَوْقٌ عَسَلٌ':Added, #2: 2	ذَوْقِ الطَّعَامِ
u'ذَوْقٌ فِقْهٌ':Added, #1: 1	ذَوْقَ الْعَسَلِ
u'ذَوْقٌ ملح':Added, #1: 1	ذَوْقِ الْفِقْهِ
u'ذَوْقٌ مِلْحٌ':Added, #1: 1	ذَوْقُ مِلْحٍ
u'ذَوْقٌ مُنَاسِبٌ':Added, #1: 1	ذَوْقُ مِلْحٍ
u'ذَيَّلَ كَلاَمٌ':Predicate, #1: 1	ذَوْقِ الْمُنَاسِبَاتِ
u'رَاءَى عَبْدٌ':Subject, #1: 1	ذَيَّلَ الْكَلَامَ
u'رَأْبٌ اِبْنٌ':Added, #2: 2	رَاءَى الْعَبْدُ
u'رَابَ بَعْضٌ':Subject, #1: 1	رَأْبَ ابْنِ
u'رَاجَ جَازٌ':Predicate, #1: 1	رَابَ بَعْضُ
u'رَاجَ رَوَاجٌ':Predicate, #2: 2	رَاجَ جَازَ
u'رَاجَعَ إِسْلامٌ':Predicate, #1: 1	رَاجَ رَوَاجَ
u'رَاجَعَ أمَةٌ':Predicate, #6: 6	رَاجَعَ الْإِسْلَامَ
u'رَاجَعَ بَانٌ':Predicate, #1: 1	رَاجَعَ الْأَمَةَ
u'رَاجَعَ بَقِيَّةٌ':Predicate, #1: 1	رَاجَعَ بَانَ
u'رَاجَعَ حامِلٌ':Predicate, #1: 1	رَاجَعَ بَقِيَّةَ
u'رَاجَعَ حَمْلٌ':Predicate, #1: 1	رَاجَعَ الْحَامِلَ
u'رَاجَعَ رَجُلٌ':Subject, #1: 1	رَاجَعَ الْحَمْلَ
u'رَاجَعَ زَوْجٌ':Subject, #1: 1	رَاجَعَ الرَّجُلُ
u'رَاجَعَ سنن':Predicate, #2: 2	رَاجَعَ الزَّوْجُ
u'رَاجَعَ مرٌّ':Predicate, #1: 1	رَاجَعَ سُنَنَ
u'رَاجَعَ مُسْتَوْعِبٌ':Predicate, #1: 1	رَاجَعَ مَرَّةً
u'رَاجَعَ مُطَلَّقٌ':Predicate, #1: 1	رَاجَعَ الْمُسْتَوْعِبَ
u'رَاجَعَ نَظَرٌ':Predicate, #1: 1	رَاجَعَ الْمُطَلَّقَةَ
u'رَاجَعَ واحد':Predicate, #1: 1	رَاجَعَ النَّظَرَ
u'رَاجَعَ وَاحِدٌ':Predicate, #2: 2	رَاجَعَ وَاحِدَةً
u'رَاحَ إمَامٌ':Subject, #2: 2	رَاجَعَ وَاحِدَةً
u'رَاحَةٌ آخِرَةٌ':Added, #1: 1	رَاحَ الْإِمَامُ
u'رَاحَةٌ أهْلٌ':Added, #1: 1	رَاحَةُ الْآخِرَةِ
u'رَاحَةٌ أهْلٌ':Added, #1: 1	رَاحَةَ أَهْلِ
u'رَاحَةٌ بُرودَةٌ':Added, #3: 3	رَاحَةُ أَهْلِ
u'رَاحَةٌ ذَبيحٌ':Added, #1: 1	رَاحَةَ الْبُرُودَةِ
u'رَاحَةٌ ذَبيحَةٌ':Added, #1: 1	رَاحَةُ الذَّبِيحَةِ
u'رَاحَةٌ علم':Added, #1: 1	رَاحَةُ الذَّبِيحَةِ
u'رَاحَةٌ عِلْمٌ':Added, #1: 1	رَاحَةَ الْعِلْمِ
u'رَاحَةٌ فَضْلٌ':Added, #1: 1	رَاحَةَ الْعِلْمِ
u'رَاحَةٌ قُلُوبٌ':Added, #1: 1	رَاحَةَ الْفَضْلِ
u'رَاحَةٌ نَفْسٌ':Added, #1: 1	رَاحَةُ الْقُلُوبِ
u'رَاحَةٌ نَقْدٌ':Added, #1: 1	رَاحَةِ النَّفْسِ
u'رَاحَةٌ نَقْد':Added, #1: 1	رَاحَةَ النَّقْدِ
u'رَاحَ رَسُولٌ':Subject, #1: 1	رَاحَةَ النَّقْدِ
u'رَادَ أَبٌ':Subject, #2: 2	رَاحَ رَسُولُ
u'رَادَ إبَاحَةٌ':Predicate, #7: 7	أَرَادَ الْأَبُ
u'رَادَ إِبِلٌ':Predicate, #1: 1	أَرَادَ الْإِبَاحَةَ
u'رَادَ أَبْلَق':Predicate, #1: 1	أَرَادَ الْإِبِلَ
u'رَادَ اِبْنٌ':Predicate, #1: 1	أَرَادَ الْأَبْلَقَ
u'رَادَ اِبْنٌ':Subject, #1: 1	أَرَادَ ابْنَ
u'رَادَ أَبْوَالٌ':Predicate, #10: 10	أَرَادَ ابْنُ
u'رَادَ إتْمَامٌ':Predicate, #1: 1	أَرَادَ أَبْوَالَ
u'رَادَ إِتْيانٌ':Predicate, #1: 1	أَرَادَ إتْمَامَ
u'رَادَ إِتْيانٌ':Predicate, #1: 1	أَرَادَ إِتْيَانَ
u'رَادَ إِثْبَاتٌ':Predicate, #1: 1	أَرَادَ الْإِتْيَانَ
u'رَادَ إجَارَةٌ':Predicate, #7: 7	أَرَادَ إثْبَاتَ
u'رَادَ إجَازَةٌ':Predicate, #1: 1	أَرَادَ إجَارَةَ
u'رَادَ إجَازَةٌ':Predicate, #1: 1	أَرَادَ إجَازَةَ
u'رَادَ إِجْرَاءٌ':Predicate, #1: 1	أَرَادَ الْإِجَازَةَ
u'رَادَ إِجْلاَءٌ':Predicate, #1: 1	أَرَادَ إجْرَاءَ
u'رَادَ إِجْمَاعٌ':Predicate, #2: 2	أَرَادَ إجْلَاءَ
u'رَادَ أَجْنَبِيٌّ':Predicate, #1: 1	أَرَادَ إجْمَاعَ
u'رَادَ أَجْنَبِيٌّ':Subject, #2: 2	أَرَادَ الْأَجْنَبِيَّةَ
u'رَادَ أَجِيرٌ':Subject, #1: 1	أَرَادَ أَجْنَبِيٌّ
u'رَادَ إحَاطَةٌ':Predicate, #1: 1	أَرَادَ الْأَجِيرُ
u'رَادَ أحَدٌ':Predicate, #2: 2	أَرَادَ الْإِحَاطَةَ
u'رَادَ أحَدٌ':Subject, #3: 3	أَرَادَ أَحَدَ
u'رَادَ أحَدٌ':Subject, #3: 3	أَرَادَ أَحَدٌ
u'رَادَ إِحْدَاثٌ':Predicate, #8: 8	أَرَادَ أَحَدُ
u'رَادَ إِحْرَامٌ':Predicate, #4: 4	أَرَادَ إحْدَاثَ
u'رَادَ إحْضَارٌ':Predicate, #17: 17	أَرَادَ الْإِحْرَامَ
u'رَادَ أَحَقُّ':Subject, #1: 1	أَرَادَ إحْضَارَ
u'رَادَ إِحْيَاءٌ':Predicate, #1: 1	أَرَادَ الْأَحَقُّ
u'رَادَ أَخٌ':Subject, #4: 4	أَرَادَ إحْيَاءَ
u'رَادَ إِخْبَارٌ':Predicate, #1: 1	أَرَادَ الْأَخُ
u'رَادَ اِخْتِصَارٌ':Predicate, #5: 5	أَرَادَ الْإِخْبَارَ
u'رَادَ أخْذٌ':Predicate, #1: 1	أَرَادَ الاخْتِصَارَ
u'رَادَ أخْذٌ':Predicate, #12: 12	أَرَادَ أَخْذَ
u'رَادَ آخِرُ':Predicate, #4: 4	أَرَادَ الْأَخْذَ
u'رَادَ إِخْرَاجٌ':Predicate, #2: 2	أَرَادَ آخِرَ
u'رَادَ إِخْرَاجٌ':Predicate, #1: 1	أَرَادَ إخْرَاجَ
u'رَادَ آخِرَةٌ':Predicate, #4: 4	أَرَادَ إِخْرَاجَ
u'رَادَ آخِرَةٌ':Predicate, #1: 1	أَرَادَ الآخِرَةَ
u'رَادَ أَخَصُّ':Predicate, #3: 3	أَرَادَ الْآخِرَةَ
u'رَادَ أَخِيرٌ':Predicate, #1: 1	أَرَادَ الْأَخَصَّ
u'رَادَ أَدَاءٌ':Predicate, #1: 1	أَرَادَ الْأَخِيرَ
u'رَادَ أَدَاءٌ':Predicate, #1: 1	أَرَادَ الْأَدَاءَ
u'رَادَ أدَب':Predicate, #3: 3	أَرَادَ أَدَاءَ
u'رَادَ إدْخَالٌ':Predicate, #1: 1	أَرَادَ الأَدَبَ
u'رَادَ إِذْلاَلٌ':Predicate, #2: 2	أَرَادَ إدْخَالَ
u'رَادَ أرْبَابٌ':Subject, #1: 1	أَرَادَ إذْلَالَ
u'رَادَ إِرْثٌ':Predicate, #1: 1	أَرَادَ أَرْبَابُ
u'رَادَ إِرْسَالٌ':Predicate, #1: 1	أَرَادَ إرْثَ
u'رَادَ إِزَالَةٌ':Predicate, #1: 1	أَرَادَ إرْسَالَ
u'رَادَ أَزْواجٌ':Predicate, #1: 1	أَرَادَ إزَالَةَ
u'رَادَ اِسْتِبْدَالٌ':Predicate, #2: 2	أَرَادَ الْأَزْوَاجَ
u'رَادَ اِسْتِجْلاَبٌ':Predicate, #1: 1	أَرَادَ اسْتِبْدَالَ
u'رَادَ اِسْتِدَامَةٌ':Predicate, #1: 1	أَرَادَ اسْتِجْلَابَ
u'رَادَ اِسْتِرْدَادٌ':Predicate, #2: 2	أَرَادَ اسْتِدَامَةَ
u'رَادَ اِسْتِصْحابٌ':Predicate, #1: 1	أَرَادَ اسْتِرْدَادَ
u'رَادَ اِسْتِطابَةٌ':Subject, #1: 1	أَرَادَ اسْتِصْحَابَ
u'رَادَ اِسْتِمْتاعٌ':Predicate, #1: 1	أَرَادَ اسْتِطَابَةُ
u'رَادَ اِسْتِئْنَافٌ':Predicate, #1: 1	أَرَادَ اسْتِمْتَاعَ
u'رَادَ اِسْتِيطانٌ':Predicate, #4: 4	أَرَادَ اسْتِئْنَافَ
u'رَادَ اِسْتيعابٌ':Predicate, #1: 1	أَرَادَ اسْتِيطَانَ
u'رَادَ إِسْقاطٌ':Predicate, #1: 1	أَرَادَ اسْتِيعَابَ
u'رَادَ إِسْلامٌ':Predicate, #3: 3	أَرَادَ إسْقَاطَ
u'رَادَ اِسْمٌ':Predicate, #1: 1	أَرَادَ الْإِسْلَامَ
u'رَادَ إشارَة':Predicate, #1: 1	أَرَادَ اسْمَ
u'رَادَ أَشْخَاصٌ':Predicate, #1: 1	أَرَادَ الْإِشَارَةَ
u'رَادَ أَشْهَب':Subject, #1: 1	أَرَادَ الْأَشْخَاصَ
u'رَادَ أَصْحَابٌ':Predicate, #1: 1	أَرَادَ أَشْهَبُ
u'رَادَ أصْغَرٌ':Predicate, #1: 1	أَرَادَ أَصْحَابَ
u'رَادَ أَصْغَرُ':Predicate, #1: 1	أَرَادَ الْأَصْغَرَ
u'رَادَ أصل':Predicate, #1: 1	أَرَادَ الْأَصْغَرَ
u'رَادَ أًصْلٌ':Predicate, #1: 1	أَرَادَ أَصْلَ
u'رَادَ إِصْلاحٌ':Predicate, #1: 1	أَرَادَ أَصْلَ
u'رَادَ إِصْلاحٌ':Predicate, #1: 1	أَرَادَ إصْلَاحَ
u'رَادَ أُصولٌ':Predicate, #1: 1	أَرَادَ الْإِصْلَاحَ
u'رَادَ إضافَةٌ':Predicate, #2: 2	أَرَادَ أُصُولَ
u'رَادَ إِضْرابٌ':Predicate, #1: 1	أَرَادَ إضَافَةَ
u'رَادَ إِطْعامٌ':Predicate, #1: 1	أَرَادَ الْإِضْرَابَ
u'رَادَ إِطْلاعٌ':Predicate, #1: 1	أَرَادَ الْإِطْعَامَ
u'رَادَ إِطْلاقٌ':Predicate, #1: 1	أَرَادَ الْإِطْلَاعَ
u'رَادَ إِظْهارٌ':Predicate, #1: 1	أَرَادَ الْإِطْلَاقَ
u'رَادَ إِعادَةٌ':Predicate, #3: 3	أَرَادَ إظْهَارَ
u'رَادَ اِعْتِقادٌ':Predicate, #1: 1	أَرَادَ الْإِعَادَةَ
u'رَادَ اِعْتِكافٌ':Predicate, #1: 1	أَرَادَ اعْتِقَادَ
u'رَادَ اِعْتِكافٌ':Predicate, #1: 1	أَرَادَ الاِعْتِكَافَ
u'رَادَ إِعْدامٌ':Predicate, #2: 2	أَرَادَ اعْتِكَافَ
u'رَادَ أَعْذَارٌ':Predicate, #1: 1	أَرَادَ إعْدَامَ
u'رَادَ إعْطَاءٌ':Predicate, #1: 1	أَرَادَ الْأَعْذَارَ
u'رَادَ أَعْلاَمٌ':Predicate, #2: 2	أَرَادَ إعْطَاءَ
u'رَادَ إعْلاَمٌ':Predicate, #1: 1	أَرَادَ الْأَعْلَامَ
u'رَادَ أَعَمُّ':Predicate, #1: 1	أَرَادَ الْإِعْلَامَ
u'رَادَ أَعَمُّ':Predicate, #1: 1	أَرَادَ أَعَمَّ
u'رَادَ أعْمَش':Predicate, #1: 1	أَرَادَ الْأَعَمَّ
u'رَادَ اِفْتِتَاحٌ':Predicate, #1: 1	أَرَادَ الْأَعْمَشَ
u'رَادَ إِفْطارٌ':Predicate, #3: 3	أَرَادَ افْتِتَاحَ
u'رَادَ إقالَةٌ':Predicate, #1: 1	أَرَادَ الْإِفْطَارَ
u'رَادَ إقامَةٌ':Predicate, #1: 1	أَرَادَ الْإِقَالَةَ
u'رَادَ إقامَةٌ':Predicate, #2: 2	أَرَادَ الْإِقَامَةَ
u'رَادَ إقْدَامٌ':Predicate, #4: 4	أَرَادَ إقَامَةَ
u'رَادَ أقْرأُ':Predicate, #1: 1	أَرَادَ الْإِقْدَامَ
u'رَادَ إقْرَارٌ':Predicate, #1: 1	أَرَادَ الْأَقْرَأَ
u'رَادَ إقْطَاعٌ':Predicate, #1: 1	أَرَادَ الْإِقْرَارَ
u'رَادَ أكابر':Subject, #1: 1	أَرَادَ إقْطَاعَ
u'رَادَ أكْبَرُ':Predicate, #1: 1	أَرَادَ الْأَكَابِرُ
u'رَادَ أكْبَرُ':Subject, #1: 1	أَرَادَ الْأَكْبَرَ
u'رَادَ أَكْثَرُ':Predicate, #1: 1	أَرَادَ الْأَكْبَرُ
u'رَادَ أَكْثَرُ':Subject, #2: 2	أَرَادَ أَكْثَرَ
u'رَادَ إكْرَامٌ':Predicate, #3: 3	أَرَادَ أَكْثَرُ
u'رَادَ أكل':Predicate, #1: 1	أَرَادَ الْإِكْرَامَ
u'رَادَ أَكْلٌ':Predicate, #1: 1	أَرَادَ أَكْلَ
u'رَادَ أكل':Predicate, #1: 1	أَرَادَ أَكْلَ
u'رَادَ أَكْلٌ':Predicate, #4: 4	أَرَادَ الْأَكْلَ
u'رَادَ إِلْزَامٌ':Predicate, #4: 4	أَرَادَ الْأَكْلَ
u'رَادَ ألف':Predicate, #1: 1	أَرَادَ إلْزَامَ
u'رَادَ ألْفٌ':Predicate, #1: 1	أَرَادَ الْأَلْفَ
u'رَادَ أَلْفٌ':Predicate, #1: 1	أَرَادَ الْأَلْفَ
u'رَادَ إمَامٌ':Subject, #1: 1	أَرَادَ الْأَلْفَ
u'رَادَ أَمْرٌ':Predicate, #20: 20	أَرَادَ الْإِمَامُ
u'رَادَ إِمْضاءٌ':Predicate, #1: 1	أَرَادَ الْأَمْرَ
u'رَادَ إِمْضاءٌ':Predicate, #1: 1	أَرَادَ الْإِمْضَاءَ
u'رَادَ أُمَّهَاتٌ':Predicate, #1: 1	أَرَادَ إمْضَاءَ
u'رَادَ أَمْوَالٌ':Predicate, #1: 1	أَرَادَ الْأُمّهَاتَ
u'رَادَ أَميرٌ':Subject, #1: 1	أَرَادَ الْأَمْوَالَ
u'رَادَ أَميرٌ':Subject, #1: 1	أَرَادَ أَمِيرُ
u'رَادَ اِنْتِقاضٌ':Predicate, #2: 2	أَرَادَ الْأَمِيرُ
u'رَادَ اِنْحِطاطٌ':Predicate, #1: 1	أَرَادَ انْتِقَاضَ
u'رَادَ إِنْزالٌ':Predicate, #1: 1	أَرَادَ انْحِطَاطَ
u'رَادَ إِنْسانٌ':Subject, #1: 1	أَرَادَ الْإِنْزَالَ
u'رَادَ إِنْسانٌ':Subject, #2: 2	أَرَادَ الْإِنْسَانُ
u'رَادَ إِنْشاءٌ':Predicate, #4: 4	أَرَادَ إنْسَانٌ
u'رَادَ إِنْصافٌ':Predicate, #1: 1	أَرَادَ إنْشَاءَ
u'رَادَ إهَانَةٌ':Predicate, #1: 1	أَرَادَ الإِنْصَافَ
u'رَادَ أهْلٌ':Predicate, #1: 1	أَرَادَ الْإِهَانَةَ
u'رَادَ أهْلٌ':Subject, #2: 2	أَرَادَ أَهْلَ
u'رَادَ أهْلٌ':Subject, #10: 10	أَرَادَ أَهْلُ
u'رَادَ إِهْلاَكٌ':Predicate, #3: 3	أَرَادَ أَهْلُهُ
u'رَادَ أوْسَطُ':Predicate, #1: 1	أَرَادَ إهْلَاكَ
u'رَادَ أوْسَطُ':Subject, #1: 1	أَرَادَ الْأَوْسَطَ
u'رَادَ أَوْقَاتٌ':Predicate, #1: 1	أَرَادَ الْأَوْسَطُ
u'رَادَ أَوَّلُ':Predicate, #1: 1	أَرَادَ أَوْقَاتَ
u'رَادَ أَوَّلُ':Subject, #4: 4	أَرَادَ الْأَوَّلَ
u'رَادَ أيَّامٌ':Predicate, #3: 3	أَرَادَ الْأَوَّلُ
u'رَادَ أَيَّامٌ':Predicate, #1: 1	أَرَادَ الْأَيَّامَ
u'رَادَ أيَّامٌ':Predicate, #1: 1	أَرَادَ الْأَيَّامَ
u'رَادَ أَيَّامٌ':Predicate, #1: 1	أَرَادَ أَيَّامَ
u'رَادَ آيَةٌ':Predicate, #1: 1	أَرَادَ أَيَّامَ
u'رَادَ إِيجَابٌ':Predicate, #1: 1	أَرَادَ الْآيَةَ
u'رَادَ إِيجَابٌ':Predicate, #1: 1	أَرَادَ الْإِيجَابَ
u'رَادَ إِيجَابٌ':Subject, #2: 2	أَرَادَ إيجَابَ
u'رَادَ إيقَاعٌ':Predicate, #1: 1	أَرَادَ الْإِيجَابُ
u'رَادَ إيقَاعٌ':Predicate, #1: 1	أَرَادَ الْإِيقَاعَ
u'رَادَ بالِغٌ':Predicate, #2: 2	أَرَادَ إيقَاعَ
u'رَادَ بَائِعٌ':Subject, #1: 1	أَرَادَ الْبَالِغَةَ
u'رَادَ بَائِعٌ':Subject, #1: 1	أَرَادَ بَائِعُ
u'رَادَ بُحْبُوحَةٌ':Predicate, #21: 21	أَرَادَ الْبَائِعُ
u'رَادَ بَحْثٌ':Predicate, #1: 1	أَرَادَ بُحْبُوحَةَ
u'رَادَ بَحْرٌ':Predicate, #1: 1	أَرَادَ الْبَحْثَ
u'رَادَ بُخَارِيٌّ':Subject, #1: 1	أَرَادَ الْبَحْرَ
u'رَادَ بَخِيلٌ':Subject, #2: 2	أَرَادَ الْبُخَارِيُّ
u'رَادَ بَدْءٌ':Predicate, #3: 3	أَرَادَ الْبَخِيلُ
u'رَادَ بَذْلٌ':Predicate, #1: 1	أَرَادَ بَدْءَ
u'رَادَ بِرٌّ':Predicate, #1: 1	أَرَادَ بَذْلَ
u'رَادَ بِرٌّ':Predicate, #1: 1	أَرَادَ الْبِرَّ
u'رَادَ بَراءةٌ':Predicate, #1: 1	أَرَادَ بِرَّ
u'رَادَ براز':Predicate, #6: 6	أَرَادَ الْبَرَاءَةَ
u'رَادَ بِرازٌ':Predicate, #1: 1	أَرَادَ الْبِرَازَ
u'رَادَ براز':Predicate, #1: 1	أَرَادَ الْبِرَازَ
u'رَادَ بَرَازٌ':Predicate, #2: 2	أَرَادَ الْبَرَازَ
u'رَادَ بَعْضٌ':Predicate, #2: 2	أَرَادَ الْبَرَازَ
u'رَادَ بَعْضٌ':Predicate, #1: 1	أَرَادَ الْبَعْضَ
u'رَادَ بَعْضٌ':Subject, #6: 6	أَرَادَ بَعْضَ
u'رَادَ بَعْضٌ':Subject, #3: 3	أَرَادَ الْبَعْضُ
u'رَادَ بُغْضٌ':Predicate, #5: 5	أَرَادَ بَعْضُ
u'رَادَ بَقاءٌ':Predicate, #1: 1	أَرَادَ بُغْضَ
u'رَادَ بَقاءٌ':Predicate, #2: 2	أَرَادَ بَقَاءَ
u'رَادَ بِلادٌ':Predicate, #5: 5	أَرَادَ الْبَقَاءَ
u'رَادَ بِنَاءٌ':Predicate, #1: 1	أَرَادَ الْبِلَادَ
u'رَادَ بِنَاءٌ':Predicate, #2: 2	أَرَادَ بِنَاءَ
u'رَادَ بَوْلٌ':Predicate, #3: 3	أَرَادَ الْبِنَاءَ
u'رَادَ بَيَانٌ':Predicate, #1: 1	أَرَادَ بَوْلَ
u'رَادَ بَيْتٌ':Predicate, #7: 7	أَرَادَ بَيَانَ
u'رَادَ بيض':Predicate, #2: 2	أَرَادَ بَيْتَ
u'رَادَ بَيْعٌ':Predicate, #1: 1	أَرَادَ بَيْضَ
u'رَادَ بَيْعٌ':Predicate, #11: 11	أَرَادَ بَيْعَ
u'رَادَ تَأْخِيرٌ':Predicate, #2: 2	أَرَادَ الْبَيْعَ
u'رَادَ تَأْخِيرٌ':Predicate, #1: 1	أَرَادَ تَأْخِيرَ
u'رَادَ تَارِيخٌ':Predicate, #2: 2	أَرَادَ التَّأْخِيرَ
u'رَادَ تَأْسِيسٌ':Predicate, #1: 1	أَرَادَ التَّارِيخَ
u'رَادَ تَأْكِيدٌ':Predicate, #1: 1	أَرَادَ تَأْسِيسَ
u'رَادَ تَأْكِيدٌ':Predicate, #3: 3	أَرَادَ التَّأْكِيدَ
u'رَادَ تَتَابُعٌ':Predicate, #3: 3	أَرَادَ تَأْكِيدَ
u'رَادَ تَثْبِيط':Predicate, #1: 1	أَرَادَ التَّتَابُعَ
u'رَادَ تَجْدِيدٌ':Predicate, #1: 1	أَرَادَ التَّثْبِيطَ
u'رَادَ تَحْرِيم':Predicate, #1: 1	أَرَادَ التَّجْدِيدَ
u'رَادَ تَحْرِيمٌ':Predicate, #1: 1	أَرَادَ التَّحْرِيمِيَّةَ
u'رَادَ تَحْرِيمٌ':Predicate, #1: 1	أَرَادَ تَحْرِيمَ
u'رَادَ تَحْصِيلٌ':Predicate, #4: 4	أَرَادَ التَّحْرِيمَ
u'رَادَ تَحْقِيقٌ':Predicate, #2: 2	أَرَادَ تَحْصِيلَ
u'رَادَ تَحْقِيقٌ':Predicate, #1: 1	أَرَادَ تَحْقِيقَ
u'رَادَ تَحَلُّلٌ':Predicate, #2: 2	أَرَادَ التَّحْقِيقَ
u'رَادَ تَحْلِيف':Predicate, #1: 1	أَرَادَ التَّحَلُّلَ
u'رَادَ تَحَمُّلٌ':Predicate, #3: 3	أَرَادَ تَحْلِيفَ
u'رَادَ تَحَوُّلٌ':Predicate, #2: 2	أَرَادَ تَحَمُّلَ
u'رَادَ تَحْوِيلٌ':Predicate, #4: 4	أَرَادَ التَّحَوُّلَ
u'رَادَ تَخْرِيبٌ':Predicate, #1: 1	أَرَادَ تَحْوِيلَ
u'رَادَ تَخْصِيصٌ':Predicate, #1: 1	أَرَادَ تَخْرِيبَ
u'رَادَ تَخْصِيصٌ':Predicate, #1: 1	أَرَادَ التَّخْصِيصَ
u'رَادَ تَخَلُّصٌ':Predicate, #1: 1	أَرَادَ تَخْصِيصَ
u'رَادَ تَخْوِيفٌ':Predicate, #2: 2	أَرَادَ التَّخَلُّصَ
u'رَادَ تَخْيِيرٌ':Predicate, #1: 1	أَرَادَ تَخْوِيفَ
u'رَادَ تَخْيِيرٌ':Predicate, #1: 1	أَرَادَ تَخْيِيرَ
u'رَادَ تَدْبِيرٌ':Predicate, #2: 2	أَرَادَ التَّخْيِيرَ
u'رَادَ تَرَاوِيحُ':Predicate, #1: 1	أَرَادَ التَّدْبِيرَ
u'رَادَ تَرْكٌ':Predicate, #1: 1	أَرَادَ التَّرَاوِيحَ
u'رَادَ تَزْوِيجٌ':Predicate, #2: 2	أَرَادَ تَرْكَ
u'رَادَ تَسَاوِي':Predicate, #3: 3	أَرَادَ تَزْوِيجَ
u'رَادَ تَسَرِّي':Predicate, #1: 1	أَرَادَ تَسَاوِيَ
u'رَادَ تَسْكِينٌ':Predicate, #1: 1	أَرَادَ التَّسَرِّيَ
u'رَادَ تَسْمِيَة':Predicate, #3: 3	أَرَادَ تَسْكِينَ
u'رَادَ تَسْهِيلٌ':Predicate, #1: 1	أَرَادَ التَّسْمِيَةَ
u'رَادَ تَسْهِيلٌ':Predicate, #1: 1	أَرَادَ التَّسْهِيلَ
u'رَادَ تَسَوُّرٌ':Predicate, #2: 2	أَرَادَ تَسْهِيلَ
u'رَادَ تَشْبِيه':Predicate, #1: 1	أَرَادَ التَّسَوُّرَ
u'رَادَ تَشْبِيه':Predicate, #2: 2	أَرَادَ التّشْبِيهَ
u'رَادَ تَشْدِيدٌ':Predicate, #3: 3	أَرَادَ التَّشْبِيهَ
u'رَادَ تَصَدُّقٌ':Predicate, #1: 1	أَرَادَ التَّشْدِيدَ
u'رَادَ تَصَرُّفٌ':Predicate, #1: 1	أَرَادَ التَّصَدُّقَ
u'رَادَ تَصْرِيحٌ':Predicate, #4: 4	أَرَادَ التَّصَرُّفَ
u'رَادَ تَضْحِيَةٌ':Predicate, #1: 1	أَرَادَ التَّصْرِيحَ
u'رَادَ تَضْمِين':Predicate, #2: 2	أَرَادَ التَّضْحِيَةَ
u'رَادَ تَطَرُّبٌ':Predicate, #1: 1	أَرَادَ التَّضْمِينَ
u'رَادَ تَطْيِيرٌ':Predicate, #1: 1	أَرَادَ التَّطَرُّبَ
u'رَادَ تَعْجِيل':Predicate, #1: 1	أَرَادَ تَطْيِيرَ
u'رَادَ تَعْجِيل':Predicate, #3: 3	أَرَادَ التَّعْجِيلَ
u'رَادَ تَعَرُّضٌ':Predicate, #3: 3	أَرَادَ تَعْجِيلَ
u'رَادَ تَعْرِيفٌ':Predicate, #1: 1	أَرَادَ التَّعَرُّضَ
u'رَادَ تَعْرِيفٌ':Predicate, #2: 2	أَرَادَ التَّعْرِيفَ
u'رَادَ تَعْظِيمٌ':Predicate, #5: 5	أَرَادَ تَعْرِيفَ
u'رَادَ تَعْلِيقٌ':Predicate, #1: 1	أَرَادَ التَّعْظِيمَ
u'رَادَ تَعْلِيقٌ':Predicate, #14: 14	أَرَادَ التَّعْلِيقَ
u'رَادَ تَعْلِيلٌ':Predicate, #2: 2	أَرَادَ تَعْلِيقَ
u'رَادَ تَعْلِيمٌ':Predicate, #1: 1	أَرَادَ التَّعْلِيلَ
u'رَادَ تَعْلِيمٌ':Predicate, #2: 2	أَرَادَ التَّعْلِيمَ
u'رَادَ تَعَمُّدٌ':Predicate, #4: 4	أَرَادَ تَعْلِيمَ
u'رَادَ تَعْمِيمٌ':Predicate, #1: 1	أَرَادَ تَعَمُّدَ
u'رَادَ تَعْيِينٌ':Predicate, #1: 1	أَرَادَ التَّعْمِيمَ
u'رَادَ تَغْلِيظٌ':Predicate, #3: 3	أَرَادَ التَّعْيِينَ
u'رَادَ تَغْيِيبٌ':Predicate, #5: 5	أَرَادَ التَّغْلِيظَ
u'رَادَ تَغْيِيرٌ':Predicate, #1: 1	أَرَادَ تَغْيِيبَ
u'رَادَ تَفْرِيغٌ':Predicate, #1: 1	أَرَادَ تَغْيِيرَ
u'رَادَ تَفْصِيلٌ':Predicate, #1: 1	أَرَادَ تَفْرِيغَ
u'رَادَ تَفْضِيلٌ':Predicate, #2: 2	أَرَادَ التَّفْصِيلَ
u'رَادَ تَفْهِيمٌ':Predicate, #1: 1	أَرَادَ تَفْضِيلَ
u'رَادَ تَقَابُلٌ':Predicate, #1: 1	أَرَادَ تَفْهِيمَ
u'رَادَ تَقْبيحٌ':Predicate, #1: 1	أَرَادَ التَّقَابُلَ
u'رَادَ تَقَدُّمٌ':Predicate, #1: 1	أَرَادَ تَقْبِيحَ
u'رَادَ تَقَدُّمٌ':Predicate, #1: 1	أَرَادَ تَقَدُّمَ
u'رَادَ تَقْديرٌ':Predicate, #2: 2	أَرَادَ التَّقَدُّمَ
u'رَادَ تَقْديرٌ':Predicate, #1: 1	أَرَادَ تَقْدِيرَ
u'رَادَ تَقْديمٌ':Predicate, #3: 3	أَرَادَ التَّقْدِيرَ
u'رَادَ تَقْريرٌ':Predicate, #2: 2	أَرَادَ تَقْدِيمَ
u'رَادَ تَقْليدٌ':Predicate, #1: 1	أَرَادَ التَّقْرِيرَ
u'رَادَ تَقْليد':Predicate, #1: 1	أَرَادَ تَقْلِيدَ
u'رَادَ تَكْبيرٌ':Predicate, #1: 1	أَرَادَ تَقْلِيدَ
u'رَادَ تَكْثيرٌ':Predicate, #3: 3	أَرَادَ التَّكْبِيرَ
u'رَادَ تَكْرارٌ':Predicate, #1: 1	أَرَادَ تَكْثِيرَ
u'رَادَ تَكْرارٌ':Predicate, #1: 1	أَرَادَ تَكْرَارَ
u'رَادَ تَكَشُّفٌ':Predicate, #5: 5	أَرَادَ التَّكْرَارَ
u'رَادَ تَكْليفٌ':Predicate, #1: 1	أَرَادَ التَّكَشُّفَ
u'رَادَ تَلْبيَةٌ':Predicate, #1: 1	أَرَادَ التَّكْلِيفَ
u'رَادَ تَلْخيصٌ':Predicate, #1: 1	أَرَادَ التَّلْبِيَةَ
u'رَادَ تَلَذُّذٌ':Predicate, #1: 1	أَرَادَ التَّلْخِيصَ
u'رَادَ تمام':Predicate, #2: 2	أَرَادَ التَّلَذُّذَ
u'رَادَ تَمامٌ':Predicate, #1: 1	أَرَادَ تَمَامَ
u'رَادَ تَمَتُّعٌ':Predicate, #1: 1	أَرَادَ تَمَامَ
u'رَادَ تَمَلُّك':Predicate, #6: 6	أَرَادَ التَّمَتُّعَ
u'رَادَ تَمْلِيك':Predicate, #1: 1	أَرَادَ التَّمَلُّكَ
u'رَادَ تَمْلِيكٌ':Predicate, #1: 1	أَرَادَ التَّمْلِيكَ
u'رَادَ تَمْييزٌ':Predicate, #1: 1	أَرَادَ تَمْلِيكَ
u'رَادَ تَنْبِيه':Predicate, #1: 1	أَرَادَ تَمْيِيزَهُنَّ
u'رَادَ تَنْبِيهٌ':Predicate, #1: 1	أَرَادَ التَّنْبِيهَ
u'رَادَ تَنْجِيزٌ':Predicate, #1: 1	أَرَادَ تَنْبِيهَ
u'رَادَ تَنَحِّي':Predicate, #1: 1	أَرَادَ التَّنْجِيزَ
u'رَادَ تَنْزِيه':Predicate, #1: 1	أَرَادَ التَّنَحِّيَ
u'رَادَ تَنْظِيفٌ':Predicate, #1: 1	أَرَادَ التَّنْزِيهِيَّةَ
u'رَادَ تَنَفُّلٌ':Predicate, #1: 1	أَرَادَ التَّنْظِيفَ
u'رَادَ تَنْفِيذٌ':Predicate, #1: 1	أَرَادَ التَّنَفُّلَ
u'رَادَ تَنْفِيرٌ':Predicate, #1: 1	أَرَادَ تَنْفِيذَ
u'رَادَ تَنْقِيصٌ':Predicate, #1: 1	أَرَادَ التَّنْفِيرَ
u'رَادَ تَهَجُّدٌ':Predicate, #2: 2	أَرَادَ تَنْقِيصَ
u'رَادَ تَهَوُّدٌ':Predicate, #1: 1	أَرَادَ التَّهَجُّدَ
u'رَادَ تَوْبَةٌ':Predicate, #1: 1	أَرَادَ التّهَوّدَ
u'رَادَ تَوْزِيعٌ':Predicate, #1: 1	أَرَادَ تَوْبَةَ
u'رَادَ تَوَسُّعٌ':Predicate, #1: 1	أَرَادَ التَّوْزِيعَ
u'رَادَ تَوَقُّفٌ':Predicate, #2: 2	أَرَادَ التَّوَسُّعَ
u'رَادَ تَوْكِيدٌ':Predicate, #1: 1	أَرَادَ التَّوَقُّفَ
u'رَادَ تَوْكِيلٌ':Predicate, #1: 1	أَرَادَ تَوْكِيدَ
u'رَادَ تَيَمُّمٌ':Predicate, #2: 2	أَرَادَ التَّوْكِيلَ
u'رَادَ ثَانِي':Predicate, #3: 3	أَرَادَ التَّيَمُّمَ
u'رَادَ ثُبُوتٌ':Predicate, #4: 4	أَرَادَ الثَّانِيَ
u'رَادَ ثَعَالِبُ':Predicate, #1: 1	أَرَادَ الثُّبُوتَ
u'رَادَ ثَغْرٌ':Predicate, #1: 1	أَرَادَ الثّعَالِبَ
u'رَادَ ثَلاثُ':Predicate, #2: 2	أَرَادَ الثَّغْرَ
u'رَادَ ثَلاثُ':Predicate, #1: 1	أَرَادَ ثَلَاثَ
u'رَادَ ثَمَرٌ':Predicate, #5: 5	أَرَادَ الثَّلَاثَ
u'رَادَ ثَوابٌ':Predicate, #1: 1	أَرَادَ الثَّمَرَ
u'رَادَ جَارٌ':Subject, #3: 3	أَرَادَ الثَّوَابَ
u'رَادَ جَارِحٌ':Predicate, #1: 1	أَرَادَ الْجَارُ
u'رَادَ جَارِحَةٌ':Predicate, #1: 1	أَرَادَ الْجَارِحَةَ
u'رَادَ جَازٌ':Predicate, #1: 1	أَرَادَ الْجَارِحَةَ
u'رَادَ جِدار':Predicate, #1: 1	أَرَادَ جَازَ
u'رَادَ جُذام':Predicate, #1: 1	أَرَادَ الْجِدَارَ
u'رَادَ جُذامَة':Predicate, #1: 1	أَرَادَ جُذَامَةَ
u'رَادَ جَزَاءٌ':Predicate, #1: 1	أَرَادَ جُذَامَةَ
u'رَادَ جُلُوسٌ':Predicate, #1: 1	أَرَادَ الْجَزَاءَ
u'رَادَ جماع':Predicate, #4: 4	أَرَادَ الْجُلُوسَ
u'رَادَ جِمَاعٌ':Predicate, #1: 1	أَرَادَ الْجِمَاعَ
u'رَادَ جَمَاعَةٌ':Predicate, #1: 1	أَرَادَ الْجِمَاعَ
u'رَادَ جَمَاعَةٌ':Subject, #1: 1	أَرَادَ الْجَمَاعَةَ
u'رَادَ جمع':Predicate, #1: 1	أَرَادَ جَمَاعَةٌ
u'رَادَ جَمْعٌ':Predicate, #2: 2	أَرَادَ الْجَمْعَ
u'رَادَ جمع':Predicate, #2: 2	أَرَادَ الْجَمْعَ
u'رَادَ جَمْعٌ':Predicate, #5: 5	أَرَادَ جَمْعَ
u'رَادَ جمعة':Predicate, #5: 5	أَرَادَ جَمْعَ
u'رَادَ جُمُعَةٌ':Predicate, #2: 2	أَرَادَ الْجُمُعَةَ
u'رَادَ جَمِيع':Predicate, #2: 2	أَرَادَ الْجُمُعَةَ
u'رَادَ جِنَايَةٌ':Predicate, #1: 1	أَرَادَ الْجَمِيعَ
u'رَادَ جِنْسٌ':Predicate, #1: 1	أَرَادَ جِنَايَةَ
u'رَادَ جِهَةٌ':Predicate, #2: 2	أَرَادَ الْجِنْسَ
u'رَادَ جَوَابٌ':Predicate, #1: 1	أَرَادَ الْجِهَةَ
u'رَادَ جَوَازٌ':Predicate, #4: 4	أَرَادَ الْجَوَابَ
u'رَادَ جَوَازٌ':Predicate, #2: 2	أَرَادَ جَوَازَ
u'رَادَ حاجٌّ':Subject, #4: 4	أَرَادَ الْجَوَازَ
u'رَادَ حاجَةٌ':Predicate, #1: 1	أَرَادَ الْحَاجُّ
u'رَادَ حاجَةٌ':Predicate, #1: 1	أَرَادَ الْحَاجَةَ
u'رَادَ حاكِمٌ':Subject, #1: 1	أَرَادَ حَاجَةَ
u'رَادَ حالٌ':Predicate, #2: 2	أَرَادَ الْحَاكِمُ
u'رَادَ حَبْسٌ':Predicate, #3: 3	أَرَادَ الْحَالَ
u'رَادَ حَجٌّ':Predicate, #1: 1	أَرَادَ حَبْسَ
u'رَادَ حَجٌّ':Predicate, #19: 19	أَرَادَ الْحَجَّ
u'رَادَ حِجَامَةٌ':Predicate, #2: 2	أَرَادَ حَجَّ
u'رَادَ حُجَّةٌ':Predicate, #2: 2	أَرَادَ الْحِجَامَةَ
u'رَادَ حَجْرٌ':Predicate, #1: 1	أَرَادَ حُجَّةَ
u'رَادَ حُدوثٌ':Predicate, #1: 1	أَرَادَ حَجْرَ
u'رَادَ حَديثٌ':Predicate, #1: 1	أَرَادَ حُدُوثَ
u'رَادَ حَديثٌ':Predicate, #1: 1	أَرَادَ الْحَدِيثَ
u'رَادَ حُرٌّ':Subject, #2: 2	أَرَادَ حَدِيثَ
u'رَادَ حَرامٌ':Predicate, #1: 1	أَرَادَ حُرٌّ
u'رَادَ حَرَمٌ':Predicate, #1: 1	أَرَادَ الْحَرَامَ
u'رَادَ حَرَمٌ':Predicate, #2: 2	أَرَادَ حَرَمَ
u'رَادَ حُرْمَةٌ':Predicate, #3: 3	أَرَادَ الْحَرَمَ
u'رَادَ حساب':Predicate, #1: 1	أَرَادَ الْحُرْمَةَ
u'رَادَ حِسَابٌ':Predicate, #3: 3	أَرَادَ الْحِسَابَ
u'رَادَ حَصْرٌ':Predicate, #3: 3	أَرَادَ الْحِسَابَ
u'رَادَ حَصْرٌ':Predicate, #1: 1	أَرَادَ الْحَصْرَ
u'رَادَ حُصُول':Predicate, #2: 2	أَرَادَ حَصْرَ
u'رَادَ حُضورٌ':Predicate, #1: 1	أَرَادَ حُصُولَ
u'رَادَ حُضُورٌ':Predicate, #1: 1	أَرَادَ الْحُضُورَ
u'رَادَ حُضورٌ':Predicate, #1: 1	أَرَادَ الْحُضُورَ
u'رَادَ حُضُورٌ':Predicate, #2: 2	أَرَادَ حُضُورَ
u'رَادَ حَفْرٌ':Predicate, #2: 2	أَرَادَ حُضُورَ
u'رَادَ حَفْرٌ':Predicate, #1: 1	أَرَادَ الْحَفْرَ
u'رَادَ حِفْظٌ':Predicate, #2: 2	أَرَادَ حَفْرَ
u'رَادَ حَقٌّ':Predicate, #1: 1	أَرَادَ حِفْظَ
u'رَادَ حَقِيقٌ':Predicate, #2: 2	أَرَادَ الْحَقَّ
u'رَادَ حَقِيقٌ':Predicate, #1: 1	أَرَادَ الْحَقِيقَةَ
u'رَادَ حَقِيقَةٌ':Predicate, #8: 8	أَرَادَ حَقِيقَةَ
u'رَادَ حَقِيقَةٌ':Predicate, #1: 1	أَرَادَ الْحَقِيقَةَ
u'رَادَ حِكَايَةٌ':Predicate, #8: 8	أَرَادَ حَقِيقَةَ
u'رَادَ حُكْمٌ':Predicate, #2: 2	أَرَادَ حِكَايَةَ
u'رَادَ حُكْمٌ':Predicate, #1: 1	أَرَادَ حُكْمَ
u'رَادَ حِلْفٌ':Predicate, #7: 7	أَرَادَ الْحُكْمَ
u'رَادَ حَلْقٌ':Predicate, #2: 2	أَرَادَ حِلْفَ
u'رَادَ حَلْقٌ':Predicate, #1: 1	أَرَادَ حَلْقَ
u'رَادَ حَمْلٌ':Predicate, #3: 3	أَرَادَ الْحَلْقَ
u'رَادَ حُمْلاَنٌ':Predicate, #2: 2	أَرَادَ حَمْلَ
u'رَادَ حَنَفِيَّةٌ':Subject, #1: 1	أَرَادَ حُمْلَانَ
u'رَادَ حَوْضٌ':Predicate, #2: 2	أَرَادَ الْحَنَفِيَّةُ
u'رَادَ حَيَاةٌ':Predicate, #1: 1	أَرَادَ الْحَوْضَ
u'رَادَ حَيْضَةٌ':Predicate, #2: 2	أَرَادَ حَيَاةَ
u'رَادَ حِيلَةٌ':Predicate, #1: 1	أَرَادَ الْحَيْضَةَ
u'رَادَ خَالِدٌ':Subject, #13: 13	أَرَادَ الْحِيلَةَ
u'رَادَ خِبْرَةٌ':Predicate, #1: 1	أَرَادَ خَالِدٌ
u'رَادَ خَتْمٌ':Predicate, #1: 1	أَرَادَ الْخِبْرَةَ
u'رَادَ خُرُوجٌ':Predicate, #1: 1	أَرَادَ الْخَتْمَ
u'رَادَ خُرُوجٌ':Predicate, #1: 1	أَرَادَ خُرُوجَ
u'رَادَ خَصْمٌ':Subject, #30: 30	أَرَادَ الْخُرُوجَ
u'رَادَ خُصُومَةٌ':Predicate, #2: 2	أَرَادَ الْخَصْمُ
u'رَادَ خِطَابٌ':Predicate, #1: 1	أَرَادَ الْخُصُومَةَ
u'رَادَ خطبة':Predicate, #1: 1	أَرَادَ الْخِطَابَ
u'رَادَ خُطْبَةٌ':Predicate, #1: 1	أَرَادَ الْخُطْبَةَ
u'رَادَ خطبة':Predicate, #1: 1	أَرَادَ الْخُطْبَةَ
u'رَادَ خِطْبَةٌ':Predicate, #2: 2	أَرَادَ خِطْبَةَ
u'رَادَ خَلاَءٌ':Predicate, #2: 2	أَرَادَ خِطْبَةَ
u'رَادَ خَلاَءٌ':Predicate, #1: 1	أَرَادَ الْخَلَاءَ
u'رَادَ خلاص':Predicate, #1: 1	أَرَادَ الْخَلاَءَ
u'رَادَ خَلاَصٌ':Predicate, #3: 3	أَرَادَ الْخَلَاصَ
u'رَادَ خِلاَفٌ':Predicate, #3: 3	أَرَادَ الْخَلَاصَ
u'رَادَ خِلاَفٌ':Predicate, #1: 1	أَرَادَ الْخِلَافَ
u'رَادَ خِلاَفٌ':Predicate, #1: 1	أَرَادَ خِلَافَ
u'رَادَ خِلاَفَةٌ':Predicate, #1: 1	أَرَادَ خِلاَفَ
u'رَادَ خُلْعٌ':Predicate, #1: 1	أَرَادَ الْخِلَافَةَ
u'رَادَ خلق':Predicate, #2: 2	أَرَادَ خُلْعَ
u'رَادَ خَلْقٌ':Predicate, #1: 1	أَرَادَ خَلْقَ
u'رَادَ خَمْسٌ':Predicate, #1: 1	أَرَادَ خَلْقَ
u'رَادَ خَوْفٌ':Predicate, #1: 1	أَرَادَ خَمْسَ
u'رَادَ دَارٌ':Predicate, #1: 1	أَرَادَ خَوْفَ
u'رَادَ دُخُولٌ':Predicate, #2: 2	أَرَادَ الدَّارَ
u'رَادَ دُخُولٌ':Predicate, #12: 12	أَرَادَ الدُّخُولَ
u'رَادَ دَرَاهِمُ':Predicate, #23: 23	أَرَادَ دُخُولَ
u'رَادَ دَرَاهِمُ':Predicate, #1: 1	أَرَادَ الدَّرَاهِمَ
u'رَادَ دُعَاءٌ':Predicate, #1: 1	أَرَادَ دَرَاهِمَ
u'رَادَ دُعَاءٌ':Predicate, #1: 1	أَرَادَ الدّعَاءَ
u'رَادَ دفع':Predicate, #4: 4	أَرَادَ الدُّعَاءَ
u'رَادَ دَفْعٌ':Predicate, #1: 1	أَرَادَ الدَّفْعَ
u'رَادَ دفع':Predicate, #1: 1	أَرَادَ الدَّفْعَ
u'رَادَ دَفْعٌ':Predicate, #6: 6	أَرَادَ دَفْعَ
u'رَادَ دفن':Predicate, #6: 6	أَرَادَ دَفْعَ
u'رَادَ دَفْنٌ':Predicate, #2: 2	أَرَادَ الدَّفْنَ
u'رَادَ دَلالَةٌ':Predicate, #2: 2	أَرَادَ الدَّفْنَ
u'رَادَ دَمٌ':Predicate, #1: 1	أَرَادَ دَلَالَةَ
u'رَادَ دونٌ':Predicate, #1: 1	أَرَادَ الدَّمَ
u'رَادَ ذَكاةٌ':Predicate, #1: 1	أَرَادَ دُونَ
u'رَادَ ذكر':Predicate, #1: 1	أَرَادَ الذَّكَاةَ
u'رَادَ ذِكْرٌ':Predicate, #4: 4	أَرَادَ ذِكْرَ
u'رَادَ ذَمٌّ':Predicate, #4: 4	أَرَادَ ذِكْرَ
u'رَادَ ذِمِّيٌّ':Subject, #1: 1	أَرَادَ ذَمَّ
u'رَادَ ذَهَابٌ':Predicate, #1: 1	أَرَادَ الذِّمِّيُّ
u'رَادَ رابع':Predicate, #4: 4	أَرَادَ الذَّهَابَ
u'رَادَ رَابِعٌ':Predicate, #1: 1	أَرَادَ الرَّابِعَةَ
u'رَادَ رَاهِنٌ':Subject, #1: 1	أَرَادَ الرَّابِعَةَ
u'رَادَ رَبُّ':Subject, #4: 4	أَرَادَ الرَّاهِنُ
u'رَادَ رَبُّ':Subject, #1: 1	أَرَادَ الرَّبُّ
u'رَادَ رَبُّ':Subject, #1: 1	أَرَادَ رَبُّهُ
u'رَادَ رِبْحٌ':Predicate, #20: 20	أَرَادَ رَبُّ
u'رَادَ رَبْطٌ':Predicate, #1: 1	أَرَادَ رِبْحَ
u'رَادَ رِجَالٌ':Predicate, #1: 1	أَرَادَ رَبْطَ
u'رَادَ رجعة':Predicate, #1: 1	أَرَادَ الرِّجَالَ
u'رَادَ رَجْعَةٌ':Predicate, #2: 2	أَرَادَ الرَّجْعَةَ
u'رَادَ رَجُلٌ':Subject, #2: 2	أَرَادَ الرَّجْعَةَ
u'رَادَ رَجُلٌ':Subject, #11: 11	أَرَادَ رَجُلٌ
u'رَادَ رَجُلٌ':Subject, #1: 1	أَرَادَ الرّجُلُ
u'رَادَ رُجُوعٌ':Predicate, #48: 48	أَرَادَ الرَّجُلُ
u'رَادَ رُجُوعٌ':Predicate, #1: 1	أَرَادَ الرّجُوعَ
u'رَادَ رُجُوعٌ':Predicate, #25: 25	أَرَادَ الرُّجُوعَ
u'رَادَ رَدٌّ':Predicate, #2: 2	أَرَادَ رُجُوعَ
u'رَادَ رَدٌّ':Predicate, #5: 5	أَرَادَ رَدَّ
u'رَادَ رَسُولٌ':Subject, #8: 8	أَرَادَ الرَّدَّ
u'رَادَ رَسُولٌ':Subject, #11: 11	أَرَادَ رَسُولُ
u'رَادَ رَسُولٌ':Subject, #1: 1	أَرَادَ الرَّسُولُ
u'رَادَ رَفْعٌ':Predicate, #1: 1	أَرَادَ رَسُولُهُ
u'رَادَ رَفْعٌ':Predicate, #3: 3	أَرَادَ الرَّفْعَ
u'رَادَ رِفْقٌ':Predicate, #6: 6	أَرَادَ رَفْعَ
u'رَادَ رُقادٌ':Predicate, #1: 1	أَرَادَ الرّفْقَ
u'رَادَ رِقَّةٌ':Predicate, #1: 1	أَرَادَ الرّقَادَ
u'رَادَ رُكوبٌ':Predicate, #1: 1	أَرَادَ رِقّةَ
u'رَادَ رُكوعٌ':Predicate, #1: 1	أَرَادَ الرُّكُوبَ
u'رَادَ رماح':Predicate, #2: 2	أَرَادَ الرُّكُوعَ
u'رَادَ رِماحٌ':Predicate, #1: 1	أَرَادَ الرّمَاحَ
u'رَادَ رَمَلٌ':Predicate, #1: 1	أَرَادَ الرّمَاحَ
u'رَادَ رَمْيٌ':Predicate, #1: 1	أَرَادَ الرَّمَلَ
u'رَادَ رَهْنٌ':Predicate, #1: 1	أَرَادَ الرَّمْيَ
u'رَادَ زَارِعٌ':Subject, #1: 1	أَرَادَ رَهْنَ
u'رَادَ زَكاةٌ':Predicate, #1: 1	أَرَادَ الزَّارِعُ
u'رَادَ زَكاةٌ':Predicate, #1: 1	أَرَادَ الزّكَاةَ
u'رَادَ زُكاةٌ':Predicate, #1: 1	أَرَادَ الزَّكَاةَ
u'رَادَ زَمانٌ':Predicate, #1: 1	أَرَادَ الزّكَاةَ
u'رَادَ زَمَنٌ':Predicate, #1: 1	أَرَادَ الزَّمَانَ
u'رَادَ زَوْجٌ':Subject, #1: 1	أَرَادَ الزَّمَنَ
u'رَادَ زَوْجٌ':Subject, #1: 1	أَرَادَ زَوْجُ
u'رَادَ زِيادَةٌ':Predicate, #28: 28	أَرَادَ الزَّوْجُ
u'رَادَ زِيادَةٌ':Predicate, #2: 2	أَرَادَ زِيَادَةَ
u'رَادَ زِيارَةٌ':Predicate, #3: 3	أَرَادَ الزِّيَادَةَ
u'رَادَ زَيْدٌ':Predicate, #1: 1	أَرَادَ زِيَارَةَ
u'رَادَ زَيْنَبٌ':Predicate, #1: 1	أَرَادَ زَيْدَ
u'رَادَ زِينَةٌ':Predicate, #1: 1	أَرَادَ زَيْنَبَ
u'رَادَ سَارٌّ':Predicate, #1: 1	أَرَادَ الزِّينَةَ
u'رَادَ سَاكِتٌ':Subject, #1: 1	أَرَادَ سَارّةَ
u'رَادَ سائِل':Subject, #2: 2	أَرَادَ السَّاكِتُ
u'رَادَ سَائِلٌ':Subject, #1: 1	أَرَادَ السَّائِلُ
u'رَادَ سِجِلٌّ':Predicate, #1: 1	أَرَادَ السَّائِلُ
u'رَادَ سُجُودٌ':Predicate, #1: 1	أَرَادَ السِّجِلَّ
u'رَادَ سَخِينٌ':Predicate, #11: 11	أَرَادَ السُّجُودَ
u'رَادَ سِدْرٌ':Predicate, #1: 1	أَرَادَ سَخِينَةَ
u'رَادَ سِدْرٌ':Predicate, #1: 1	أَرَادَ السِّدْرَ
u'رَادَ سَرقَةٌ':Predicate, #1: 1	أَرَادَ سِدْرَ
u'رَادَ سَرِقَةٌ':Predicate, #1: 1	أَرَادَ سَرِقَةَ
u'رَادَ سَعَادَةٌ':Predicate, #1: 1	أَرَادَ سَرِقَةَ
u'رَادَ سَفَرٌ':Predicate, #1: 1	أَرَادَ السَّعَادَةَ
u'رَادَ سقط':Predicate, #17: 17	أَرَادَ السَّفَرَ
u'رَادَ سُقُوطٌ':Predicate, #1: 1	أَرَادَ السَّقْطَ
u'رَادَ سَقْيٌ':Predicate, #1: 1	أَرَادَ سُقُوطَ
u'رَادَ سَقْيٌ':Predicate, #1: 1	أَرَادَ السَّقْيَ
u'رَادَ سَلاَمَةٌ':Predicate, #4: 4	أَرَادَ سَقْيَ
u'رَادَ سَلْبٌ':Predicate, #1: 1	أَرَادَ السَّلَامَةَ
u'رَادَ سُلْطَانٌ':Subject, #1: 1	أَرَادَ سَلْبَ
u'رَادَ سُلُوكٌ':Predicate, #4: 4	أَرَادَ السُّلْطَانُ
u'رَادَ سُلُوك':Predicate, #2: 2	أَرَادَ سُلُوكَ
u'رَادَ سُنَّةٌ':Predicate, #2: 2	أَرَادَ سُلُوكَ
u'رَادَ سُنَّةٌ':Predicate, #1: 1	أَرَادَ سُنَّةَ
u'رَادَ سُؤَالٌ':Predicate, #2: 2	أَرَادَ السُّنَّةَ
u'رَادَ سُؤَالٌ':Predicate, #1: 1	أَرَادَ السُّؤَالَ
u'رَادَ سَيِّدٌ':Subject, #1: 1	أَرَادَ سُؤَالَ
u'رَادَ سَيِّدٌ':Subject, #1: 1	أَرَادَ سَيّدَاهُ
u'رَادَ سَيِّدٌ':Subject, #1: 1	أَرَادَ سَيِّدُهُ
u'رَادَ سَيْفٌ':Predicate, #8: 8	أَرَادَ السَّيِّدُ
u'رَادَ سُيوفٌ':Predicate, #1: 1	أَرَادَ السّيْفَ
u'رَادَ شَاعِر':Subject, #1: 1	أَرَادَ السّيُوفَ
u'رَادَ شافِعِيّ':Subject, #1: 1	أَرَادَ الشّاعِرُ
u'رَادَ شَائِعٌ':Subject, #9: 9	أَرَادَ الشَّافِعِيُّ
u'رَادَ شَتْمٌ':Predicate, #1: 1	أَرَادَ شَائِعٌ
u'رَادَ شَجَرَةٌ':Predicate, #1: 1	أَرَادَ الشَّتْمَ
u'رَادَ شَخْصٌ':Subject, #1: 1	أَرَادَ شَجَرَةَ
u'رَادَ شَخْصٌ':Subject, #1: 1	أَرَادَ الشَّخْصُ
u'رَادَ شِرَاءٌ':Predicate, #2: 2	أَرَادَ شَخْصٌ
u'رَادَ شِرَاءٌ':Predicate, #7: 7	أَرَادَ الشِّرَاءَ
u'رَادَ شَرْطٌ':Predicate, #9: 9	أَرَادَ شِرَاءَ
u'رَادَ شركاء':Subject, #3: 3	أَرَادَ الشَّرْطَ
u'رَادَ شركة':Predicate, #1: 1	أَرَادَ الشُّرَكَاءُ
u'رَادَ شِرْكَةٌ':Predicate, #2: 2	أَرَادَ الشِّرْكَةَ
u'رَادَ شركة':Predicate, #2: 2	أَرَادَ الشِّرْكَةَ
u'رَادَ شَرِكَةٌ':Predicate, #4: 4	أَرَادَ الشَّرِكَةَ
u'رَادَ شُرُوعٌ':Predicate, #4: 4	أَرَادَ الشَّرِكَةَ
u'رَادَ شِفَاءٌ':Predicate, #4: 4	أَرَادَ الشُّرُوعَ
u'رَادَ شفعة':Predicate, #1: 1	أَرَادَ الشِّفَاءَ
u'رَادَ شُفْعَةٌ':Predicate, #1: 1	أَرَادَ الشُّفْعَةَ
u'رَادَ شَفِيعٌ':Subject, #1: 1	أَرَادَ الشُّفْعَةَ
u'رَادَ شَقٌّ':Predicate, #7: 7	أَرَادَ الشَّفِيعُ
u'رَادَ شَقٌّ':Predicate, #1: 1	أَرَادَ الشَّقَّ
u'رَادَ شَقَاءٌ':Predicate, #1: 1	أَرَادَ شَقَّ
u'رَادَ شُمُول':Predicate, #1: 1	أَرَادَ الشَّقَاءَ
u'رَادَ شَهْرٌ':Predicate, #1: 1	أَرَادَ الشُّمُولَ
u'رَادَ شَهْوَةٌ':Predicate, #1: 1	أَرَادَ الشَّهْرَ
u'رَادَ شُهُودٌ':Subject, #2: 2	أَرَادَ الشَّهْوَةَ
u'رَادَ شَيْخٌ':Predicate, #1: 1	أَرَادَ الشُّهُودُ
u'رَادَ شَيْخٌ':Subject, #1: 1	أَرَادَ الشَّيْخَ
u'رَادَ شَيْطَانٌ':Subject, #5: 5	أَرَادَ الشَّيْخُ
u'رَادَ صَاحِبٌ':Predicate, #1: 1	أَرَادَ الشَّيْطَانُ
u'رَادَ صَاحِبٌ':Subject, #1: 1	أَرَادَ صَاحِبَ
u'رَادَ صَاحِبٌ':Subject, #1: 1	أَرَادَ صَاحِبُهُ
u'رَادَ صَاعٌ':Predicate, #23: 23	أَرَادَ صَاحِبُ
u'رَادَ صَبٌّ':Predicate, #1: 1	أَرَادَ صَاعَ
u'رَادَ صَبِيٌّ':Predicate, #1: 1	أَرَادَ صَبَّ
u'رَادَ صِبْيَةٌ':Subject, #1: 1	أَرَادَ الصَّبِيَّ
u'رَادَ صِحَّةٌ':Predicate, #1: 1	أَرَادَ الصِّبْيَةُ
u'رَادَ صِحَّةٌ':Predicate, #1: 1	أَرَادَ الصِّحَّةَ
u'رَادَ صدقة':Predicate, #1: 1	أَرَادَ صِحَّةَ
u'رَادَ صَدَقَةٌ':Predicate, #2: 2	أَرَادَ الصَّدَقَةَ
u'رَادَ صَرْفٌ':Predicate, #2: 2	أَرَادَ الصَّدَقَةَ
u'رَادَ صَرْف':Predicate, #1: 1	أَرَادَ صَرْفَ
u'رَادَ صُعُودٌ':Predicate, #1: 1	أَرَادَ صَرْفَ
u'رَادَ صُفْرَةٌ':Predicate, #1: 1	أَرَادَ الصُّعُودَ
u'رَادَ صَلاَةٌ':Predicate, #1: 1	أَرَادَ الصُّفْرَةَ
u'رَادَ صَلاَةٌ':Predicate, #1: 1	أَرَادَ صَلَاةَ
u'رَادَ صلْبٌ':Predicate, #23: 23	أَرَادَ الصَّلَاةَ
u'رَادَ صَلْبٌ':Predicate, #1: 1	أَرَادَ الصَّلْبَ
u'رَادَ صُنَّاعٌ':Subject, #1: 1	أَرَادَ الصَّلْبَ
u'رَادَ صُورٌ':Predicate, #1: 1	أَرَادَ الصُّنَّاعُ
u'رَادَ صُوَرٌ':Predicate, #1: 1	أَرَادَ الصُّوَرَ
u'رَادَ صَوْمٌ':Predicate, #1: 1	أَرَادَ الصُّوَرَ
u'رَادَ صِيَامٌ':Predicate, #2: 2	أَرَادَ الصَّوْمَ
u'رَادَ صِيغَةٌ':Predicate, #2: 2	أَرَادَ الصِّيَامَ
u'رَادَ ضَرْبٌ':Predicate, #1: 1	أَرَادَ صِيغَةَ
u'رَادَ ضَرَرٌ':Predicate, #3: 3	أَرَادَ ضَرْبَ
u'رَادَ ضَمٌّ':Predicate, #1: 1	أَرَادَ الضَّرَرَ
u'رَادَ ضَمَانٌ':Predicate, #1: 1	أَرَادَ ضَمَّ
u'رَادَ ضَيْفٌ':Subject, #1: 1	أَرَادَ ضَمَانَ
u'رَادَ طَالِبٌ':Predicate, #1: 1	أَرَادَ الضَّيْفُ
u'رَادَ طَالِبٌ':Subject, #1: 1	أَرَادَ طَالِبَ
u'رَادَ طَالِقٌ':Predicate, #3: 3	أَرَادَ الطَّالِبُ
u'رَادَ طَبْخٌ':Predicate, #1: 1	أَرَادَ طَالِقَةً
u'رَادَ طَرِيقٌ':Predicate, #1: 1	أَرَادَ طَبْخَ
u'رَادَ طعام':Predicate, #3: 3	أَرَادَ الطَّرِيقَ
u'رَادَ طَعَامٌ':Predicate, #1: 1	أَرَادَ الطَّعَامَ
u'رَادَ طَلاَقٌ':Predicate, #1: 1	أَرَادَ الطَّعَامَ
u'رَادَ طَلاَقٌ':Predicate, #12: 12	أَرَادَ الطَّلَاقَ
u'رَادَ طَمٌّ':Predicate, #4: 4	أَرَادَ طَلَاقَ
u'رَادَ طهر':Predicate, #1: 1	أَرَادَ الطَّمَّ
u'رَادَ طُهْرٌ':Predicate, #1: 1	أَرَادَ الطُّهْرَ
u'رَادَ طوال':Predicate, #1: 1	أَرَادَ الطُّهْرَ
u'رَادَ طَوْقٌ':Predicate, #1: 1	أَرَادَ الطِّوَالَ
u'رَادَ طُولٌ':Predicate, #1: 1	أَرَادَ طَوْقَ
u'رَادَ طَوْلٌ':Predicate, #1: 1	أَرَادَ الطّوْلَ
u'رَادَ ظالِمٌ':Predicate, #1: 1	أَرَادَ الطّوْلَ
u'رَادَ ظالِمٌ':Subject, #1: 1	أَرَادَ الظَّالِمِينَ
u'رَادَ ظاهِرٌ':Predicate, #1: 1	أَرَادَ ظَالِمٌ
u'رَادَ ظاهِرٌ':Predicate, #2: 2	أَرَادَ الظَّاهِرَةَ
u'رَادَ ظاهِرَة':Predicate, #2: 2	أَرَادَ ظَاهِرَ
u'رَادَ ظَرْفٌ':Predicate, #2: 2	أَرَادَ الظَّاهِرَةَ
u'رَادَ ظُلْمٌ':Predicate, #1: 1	أَرَادَ الظَّرْفَ
u'رَادَ ظهار':Predicate, #1: 1	أَرَادَ الظُّلْمَ
u'رَادَ عَامِرٌ':Predicate, #2: 2	أَرَادَ الظِّهَارَ
u'رَادَ عَامِلٌ':Subject, #1: 1	أَرَادَ عَامِرَ
u'رَادَ عَائِدٌ':Subject, #5: 5	أَرَادَ الْعَامِلُ
u'رَادَ عَائِشٌ':Predicate, #1: 1	أَرَادَ عَائِدٌ
u'رَادَ عَبَّاسٌ':Subject, #1: 1	أَرَادَ عَائِشَةَ
u'رَادَ عَبْدٌ':Predicate, #1: 1	أَرَادَ عَبّاسُ
u'رَادَ عَبْدٌ':Predicate, #1: 1	أَرَادَ عَبْدَ
u'رَادَ عَبْدٌ':Subject, #2: 2	أَرَادَ الْعَبْدَ
u'رَادَ عَبْدٌ':Subject, #3: 3	أَرَادَ عَبْدُ
u'رَادَ عتق':Predicate, #8: 8	أَرَادَ الْعَبْدُ
u'رَادَ عِتْقٌ':Predicate, #1: 1	أَرَادَ الْعِتْقَ
u'رَادَ عتق':Predicate, #1: 1	أَرَادَ الْعِتْقَ
u'رَادَ عِتْقٌ':Predicate, #2: 2	أَرَادَ عِتْقَ
u'رَادَ عَثَاكِيلُ':Predicate, #2: 2	أَرَادَ عِتْقَ
u'رَادَ عَدٌّ':Predicate, #1: 1	أَرَادَ الْعَثَاكِيلَ
u'رَادَ عَدَدٌ':Predicate, #1: 1	أَرَادَ عَدَّ
u'رَادَ عَدْلٌ':Subject, #1: 1	أَرَادَ الْعَدَدَ
u'رَادَ عَدَمٌ':Predicate, #2: 2	أَرَادَ الْعَدْلُ
u'رَادَ عُدُولٌ':Predicate, #3: 3	أَرَادَ عَدَمَ
u'رَادَ عرف':Predicate, #2: 2	أَرَادَ الْعُدُولَ
u'رَادَ عُرْفٌ':Predicate, #2: 2	أَرَادَ عُرْفَ
u'رَادَ عُرْوَةٌ':Subject, #2: 2	أَرَادَ عُرْفَ
u'رَادَ عزل':Predicate, #1: 1	أَرَادَ عُرْوَةُ
u'رَادَ عَصَافِيرُ':Predicate, #1: 1	أَرَادَ عَزْلَ
u'رَادَ عَصَافِيرُ':Subject, #2: 2	أَرَادَ الْعَصَافِيرَ
u'رَادَ عَصْرٌ':Predicate, #1: 1	أَرَادَ الْعَصَافِيرُ
u'رَادَ عطف':Predicate, #1: 1	أَرَادَ عَصْرَ
u'رَادَ عَطْفٌ':Predicate, #1: 1	أَرَادَ الْعَطْفَ
u'رَادَ عَطِيَّةٌ':Predicate, #1: 1	أَرَادَ الْعَطْفَ
u'رَادَ عَقْدٌ':Predicate, #1: 1	أَرَادَ الْعَطِيَّةَ
u'رَادَ عَقْلٌ':Predicate, #1: 1	أَرَادَ الْعَقْدَ
u'رَادَ عَكْسٌ':Predicate, #1: 1	أَرَادَ الْعَقْلَ
u'رَادَ علم':Predicate, #1: 1	أَرَادَ الْعَكْسَ
u'رَادَ عِلْمٌ':Predicate, #3: 3	أَرَادَ الْعِلْمَ
u'رَادَ علماء':Predicate, #3: 3	أَرَادَ الْعِلْمَ
u'رَادَ عُلَمَاءُ':Predicate, #1: 1	أَرَادَ عُلَمَاءَ
u'رَادَ عَمٌّ':Subject, #1: 1	أَرَادَ عُلَمَاءَ
u'رَادَ عِمَارَةٌ':Predicate, #1: 1	أَرَادَ الْعَمُّ
u'رَادَ عُمَرٌ':Predicate, #2: 2	أَرَادَ الْعِمَارَةَ
u'رَادَ عُمَرٌ':Subject, #1: 1	أَرَادَ عُمَرَ
u'رَادَ عمرة':Predicate, #10: 10	أَرَادَ عُمَرُ
u'رَادَ عُمْرَةٌ':Predicate, #1: 1	أَرَادَ الْعُمْرَةَ
u'رَادَ عمرة':Predicate, #1: 1	أَرَادَ الْعُمْرَةَ
u'رَادَ عُمْرَةٌ':Predicate, #1: 1	أَرَادَ عُمْرَةَ
u'رَادَ عَمَلٌ':Predicate, #1: 1	أَرَادَ عُمْرَةَ
u'رَادَ عُمُومٌ':Predicate, #2: 2	أَرَادَ الْعَمَلَ
u'رَادَ عند':Predicate, #2: 2	أَرَادَ الْعُمُومَ
u'رَادَ عَوْدٌ':Predicate, #1: 1	أَرَادَ عِنْدَ
u'رَادَ عَوْدَةٌ':Predicate, #5: 5	أَرَادَ الْعَوْدَ
u'رَادَ عَيْبٌ':Predicate, #1: 1	أَرَادَ الْعَوْدَةَ
u'رَادَ عين':Predicate, #1: 1	أَرَادَ الْعَيْبَ
u'رَادَ عَيْنٌ':Predicate, #1: 1	أَرَادَ عَيْنَ
u'رَادَ عَيْن':Predicate, #1: 1	أَرَادَ عَيْنَ
u'رَادَ غَاصِبٌ':Subject, #1: 1	أَرَادَ عَيْنَ
u'رَادَ غَائِبٌ':Subject, #9: 9	أَرَادَ الْغَاصِبُ
u'رَادَ غَايَةٌ':Predicate, #1: 1	أَرَادَ الْغَائِبُ
u'رَادَ غرماء':Subject, #1: 1	أَرَادَ غَايَةَ
u'رَادَ غَرِيمٌ':Subject, #1: 1	أَرَادَ الْغُرَمَاءُ
u'رَادَ غَرِيمٌ':Subject, #2: 2	أَرَادَ غَرِيمُهُ
u'رَادَ غَزْوٌ':Predicate, #4: 4	أَرَادَ الْغَرِيمُ
u'رَادَ غَزْوَةٌ':Predicate, #1: 1	أَرَادَ الْغَزْوَ
u'رَادَ غُسْلٌ':Predicate, #1: 1	أَرَادَ غَزْوَةَ
u'رَادَ غَسْلٌ':Predicate, #3: 3	أَرَادَ الْغُسْلَ
u'رَادَ غطاريف':Predicate, #3: 3	أَرَادَ غَسْلَ
u'رَادَ غَلَبَةٌ':Predicate, #1: 1	أَرَادَ الْغَطَارِيفَ
u'رَادَ غَمٌّ':Predicate, #1: 1	أَرَادَ غَلَبَةَ
u'رَادَ غير':Predicate, #1: 1	أَرَادَ غَمَّ
u'رَادَ غَيْرٌ':Predicate, #24: 24	أَرَادَ غَيْرَ
u'رَادَ غير':Subject, #24: 24	أَرَادَ غَيْرَ
u'رَادَ غَيْرٌ':Subject, #1: 1	أَرَادَ غَيْرُ
u'رَادَ غير':Subject, #1: 1	أَرَادَ غَيْرُ
u'رَادَ غَيْرٌ':Subject, #1: 1	أَرَادَ غَيْرُهُ
u'رَادَ فُجُورٌ':Predicate, #1: 1	أَرَادَ غَيْرُهُ
u'رَادَ فِدَاءٌ':Predicate, #1: 1	أَرَادَ الْفُجُورَ
u'رَادَ فِرَاقٌ':Predicate, #1: 1	أَرَادَ فِدَاءَ
u'رَادَ فَرَسٌ':Predicate, #2: 2	أَرَادَ فِرَاقَ
u'رَادَ فَرْضٌ':Predicate, #1: 1	أَرَادَ فَرَسَ
u'رَادَ فَرْضٌ':Predicate, #1: 1	أَرَادَ الْفَرْضَ
u'رَادَ فَرَطٌ':Predicate, #1: 1	أَرَادَ فَرْضَ
u'رَادَ فَرْعٌ':Subject, #1: 1	أَرَادَ الْفَرَطَ
u'رَادَ فِرْقَةٌ':Predicate, #1: 1	أَرَادَ الْفَرْعُ
u'رَادَ فَرِيضَةٌ':Predicate, #1: 1	أَرَادَ الْفِرْقَةَ
u'رَادَ فَسْخٌ':Predicate, #1: 1	أَرَادَ الْفَرِيضَةَ
u'رَادَ فَسْخٌ':Predicate, #12: 12	أَرَادَ الْفَسْخَ
u'رَادَ فَصْلٌ':Predicate, #1: 1	أَرَادَ فَسْخَ
u'رَادَ فِطَامٌ':Predicate, #1: 1	أَرَادَ فَصْلَ
u'رَادَ فِطْرٌ':Predicate, #1: 1	أَرَادَ الْفِطَامَ
u'رَادَ فِعْلٌ':Predicate, #3: 3	أَرَادَ الْفِطْرَ
u'رَادَ فِقْهٌ':Predicate, #3: 3	أَرَادَ فِعْلَ
u'رَادَ فقهاء':Predicate, #1: 1	أَرَادَ الْفِقْهَ
u'رَادَ فَقِيهٌ':Subject, #1: 1	أَرَادَ الْفُقَهَاءَ
u'رَادَ فلان':Predicate, #2: 2	أَرَادَ الْفَقِيهُ
u'رَادَ فلان':Subject, #1: 1	أَرَادَ مَكَّةَ
u'رَادَ فلان':Subject, #1: 1	أَرَادَ الزَّمَخْشَرِيُّ
u'رَادَ فلان':Subject, #1: 1	أَرَادَ بِلَالٌ
u'رَادَ فلان':Subject, #1: 1	أَرَادَ حُذَيْفَةُ
u'رَادَ فلان':Subject, #1: 1	أَرَادَ مُعَاوِيَةُ
u'رَادَ فلان':Subject, #2: 2	أَرَادَ عُثْمَانُ
u'رَادَ فلان':Subject, #3: 3	أَرَادَ الْمُتَصَدِّقُ
u'رَادَفَ مُبَاحٌ':Predicate, #9: 9	أَرَادَ الشَّافِعِيُّ
u'رَادَ فَهْمٌ':Predicate, #1: 1	رَادَفَ الْمُبَاحَ
u'رَادَ قَابِضٌ':Subject, #1: 1	أَرَادَ فَهْمَ
u'رَادَ قَالٌ':Predicate, #1: 1	أَرَادَ الْقَابِضُ
u'رَادَ قَائِلٌ':Subject, #1: 1	أَرَادَ قَالَ
u'رَادَ قَائِلٌ':Subject, #1: 1	أَرَادَ قَائِلُهُ
u'رَادَ قَبُولٌ':Predicate, #2: 2	أَرَادَ الْقَائِلُ
u'رَادَ قَبُولٌ':Predicate, #1: 1	أَرَادَ الْقَبُولَ
u'رَادَ قتال':Predicate, #1: 1	أَرَادَ قَبُولَ
u'رَادَ قِتَالٌ':Predicate, #2: 2	أَرَادَ الْقِتَالَ
u'رَادَ قتل':Predicate, #2: 2	أَرَادَ الْقِتَالَ
u'رَادَ قَتْلٌ':Predicate, #1: 1	أَرَادَ قَتْلَكَ
u'رَادَ قتل':Predicate, #1: 1	أَرَادَ قَتْلَكَ
u'رَادَ قَتْلٌ':Predicate, #8: 8	أَرَادَ قَتْلَ
u'رَادَ قَدْرٌ':Predicate, #8: 8	أَرَادَ قَتْلَ
u'رَادَ قدرة':Predicate, #2: 2	أَرَادَ قَدْرَ
u'رَادَ قُدْرَةٌ':Predicate, #1: 1	أَرَادَ الْقُدْرَةَ
u'رَادَ قِرَاءةٌ':Predicate, #1: 1	أَرَادَ الْقُدْرَةَ
u'رَادَ قِرَانٌ':Predicate, #5: 5	أَرَادَ قِرَاءَةَ
u'رَادَ قُرْبَةٌ':Predicate, #2: 2	أَرَادَ الْقِرَانَ
u'رَادَ قَرْيَةٌ':Predicate, #1: 1	أَرَادَ الْقُرْبَةَ
u'رَادَ قَسَمٌ':Predicate, #1: 1	أَرَادَ الْقَرْيَةَ
u'رَادَ قسمة':Predicate, #1: 1	أَرَادَ الْقَسَمَ
u'رَادَ قِسْمَةٌ':Predicate, #5: 5	أَرَادَ قِسْمَةَ
u'رَادَ قسمة':Predicate, #5: 5	أَرَادَ قِسْمَةَ
u'رَادَ قِسْمَةٌ':Predicate, #8: 8	أَرَادَ الْقِسْمَةَ
u'رَادَ قصاص':Predicate, #8: 8	أَرَادَ الْقِسْمَةَ
u'رَادَ قِصَاصٌ':Predicate, #1: 1	أَرَادَ الْقِصَاصَ
u'رَادَ قَصْرٌ':Predicate, #1: 1	أَرَادَ الْقِصَاصَ
u'رَادَ قَصِيلٌ':Predicate, #2: 2	أَرَادَ الْقَصْرَ
u'رَادَ قَضَاءٌ':Predicate, #1: 1	أَرَادَ الْقَصِيلَ
u'رَادَ قَضَاءٌ':Predicate, #2: 2	أَرَادَ الْقَضَاءَ
u'رَادَ قَطْعٌ':Predicate, #9: 9	أَرَادَ قَضَاءَ
u'رَادَ قَطْعٌ':Predicate, #1: 1	أَرَادَ قَطْعَ
u'رَادَ قلب':Predicate, #3: 3	أَرَادَ الْقَطْعَ
u'رَادَ قَلْبٌ':Predicate, #1: 1	أَرَادَ الْقَلْبَ
u'رَادَ قَلْب':Predicate, #1: 1	أَرَادَ الْقَلْبَ
u'رَادَ قمر':Predicate, #1: 1	أَرَادَ الْقَلْبَ
u'رَادَ قَمَرٌ':Predicate, #1: 1	أَرَادَ الْقَمَرَ
u'رَادَ قَنَاعَةٌ':Predicate, #1: 1	أَرَادَ الْقَمَرَ
u'رَادَ قُنُوتٌ':Predicate, #1: 1	أَرَادَ الْقَنَاعَةَ
u'رَادَ قَوَد':Predicate, #1: 1	أَرَادَ الْقُنُوتَ
u'رَادَ قول':Predicate, #2: 2	أَرَادَ الْقَوَدَ
u'رَادَ قَوْلٌ':Predicate, #1: 1	أَرَادَ قَوْلَ
u'رَادَ قَوْمٌ':Predicate, #1: 1	أَرَادَ قَوْلَ
u'رَادَ قَوْمٌ':Subject, #1: 1	أَرَادَ قَوْمَ
u'رَادَ قَوْمٌ':Subject, #1: 1	أَرَادَ قَوْمُهُ
u'رَادَ قَوْمٌ':Subject, #2: 2	أَرَادَ قَوْمٌ
u'رَادَ قِيَاسٌ':Predicate, #7: 7	أَرَادَ الْقَوْمُ
u'رَادَ قيام':Predicate, #1: 1	أَرَادَ قِيَاسَ
u'رَادَ قِيَامٌ':Predicate, #1: 1	أَرَادَ قِيَامَ
u'رَادَ قيام':Predicate, #1: 1	أَرَادَ قِيَامَ
u'رَادَ قِيَامٌ':Predicate, #4: 4	أَرَادَ الْقِيَامَ
u'رَادَ قَيِّمٌ':Subject, #4: 4	أَرَادَ الْقِيَامَ
u'رَادَ قِيمَةٌ':Predicate, #5: 5	أَرَادَ الْقَيِّمُ
u'رَادَ كَافِرٌ':Subject, #3: 3	أَرَادَ الْقِيمَةَ
u'رَادَ كبر':Predicate, #3: 3	أَرَادَ الْكَافِرُ
u'رَادَ كِبَرٌ':Predicate, #2: 2	أَرَادَ كِبَرَ
u'رَادَ كِتَابٌ':Predicate, #2: 2	أَرَادَ كِبَرَ
u'رَادَ كِتَابَةٌ':Predicate, #1: 1	أَرَادَ الْكِتَابَ
u'رَادَ كِتَابَةٌ':Predicate, #2: 2	أَرَادَ الْكِتَابَةَ
u'رَادَ كَثْرَةٌ':Predicate, #6: 6	أَرَادَ كِتَابَةَ
u'رَادَ كَثِيرٌ':Predicate, #1: 1	أَرَادَ كَثْرَةَ
u'رَادَ كَرَامَةٌ':Predicate, #1: 1	أَرَادَ الْكَثِيرَ
u'رَادَ كَرَاهَةٌ':Predicate, #1: 1	أَرَادَ الْكَرَامَةَ
u'رَادَ كَسْرٌ':Predicate, #6: 6	أَرَادَ كَرَاهَةَ
u'رَادَ كَعْبٌ':Subject, #1: 1	أَرَادَ كَسْرَ
u'رَادَ كَفٌّ':Predicate, #1: 1	أَرَادَ كَعْبُ
u'رَادَ كَفِيلٌ':Subject, #1: 1	أَرَادَ الْكَفَّ
u'رَادَ كَلاَمٌ':Predicate, #4: 4	أَرَادَ الْكَفِيلُ
u'رَادَ كَلْكَل':Predicate, #1: 1	أَرَادَ الْكَلَامَ
u'رَادَ كَلِمٌ':Predicate, #1: 1	أَرَادَ الْكَلْكَلَ
u'رَادَ كَمَالٌ':Predicate, #1: 1	أَرَادَ الْكَلِمَ
u'رَادَ كَمَالٌ':Predicate, #1: 1	أَرَادَ الْكَمَالَ
u'رَادَ كُمَيْتٌ':Subject, #1: 1	أَرَادَ كَمَالَ
u'رَادَ كِنَايَةٌ':Predicate, #1: 1	أَرَادَ الْكُمَيْتُ
u'رَادَ كُوفِيٌّ':Subject, #1: 1	أَرَادَ الْكِنَايَةَ
u'رَادَ كَيْلٌ':Predicate, #1: 1	أَرَادَ الْكُوفِيُّ
u'رَادَ لبنة':Predicate, #1: 1	أَرَادَ كَيْلاَ
u'رَادَ لَبِنَةٌ':Predicate, #1: 1	أَرَادَ لَبِنَةَ
u'رَادَ لَحْمٌ':Predicate, #1: 1	أَرَادَ لَبِنَةَ
u'رَادَ لَحْنٌ':Predicate, #1: 1	أَرَادَ اللَّحْمَ
u'رَادَ لُزُومٌ':Predicate, #1: 1	أَرَادَ اللّحْنَ
u'رَادَ لعان':Predicate, #1: 1	أَرَادَ لُزُومَ
u'رَادَ لَفْظٌ':Predicate, #1: 1	أَرَادَ اللِّعَانَ
u'رَادَ لَفْظٌ':Predicate, #1: 1	أَرَادَ اللَّفْظَ
u'رَادَ مَاءٌ':Predicate, #5: 5	أَرَادَ لَفْظَ
u'رَادَ مَالِكٌ':Subject, #1: 1	أَرَادَ مَاءَ
u'رَادَ مَالِكٌ':Subject, #10: 10	أَرَادَ الْمَالِكُ
u'رَادَ مَالِكٌ':Subject, #3: 3	أَرَادَ مَالِكٌ
u'رَادَ مَالِكٌ':Subject, #3: 3	أَرَادَ مَالِكُ
u'رَادَ مَأْمُورٌ':Subject, #3: 3	أَرَادَ مَالِكُهُ
u'رَادَ مُبَالَغَةٌ':Predicate, #2: 2	أَرَادَ الْمَأْمُورُ
u'رَادَ مُبْتَدِئٌ':Subject, #2: 2	أَرَادَ الْمُبَالَغَةَ
u'رَادَ مُتَحَجِّرٌ':Subject, #5: 5	أَرَادَ الْمُبْتَدِئُ
u'رَادَ مُتَصَدِّق':Subject, #1: 1	أَرَادَ الْمُتَحَجِّرُ
u'رَادَ مُتْعَةٌ':Predicate, #3: 3	أَرَادَ الْمُتَصَدِّقُ
u'رَادَ مُتَقَدِّمٌ':Predicate, #1: 1	أَرَادَ الْمُتْعَةَ
u'رَادَ مُتَكَلِّمٌ':Subject, #1: 1	أَرَادَ الْمُتَقَدِّمِينَ
u'رَادَ مُتَمَتِّعٌ':Subject, #1: 1	أَرَادَ الْمُتَكَلِّمُ
u'رَادَ مثل':Predicate, #3: 3	أَرَادَ الْمُتَمَتِّعُ
u'رَادَ مِثْلٌ':Predicate, #5: 5	أَرَادَ مِثْلَ
u'رَادَ مَجَازٌ':Predicate, #5: 5	أَرَادَ مِثْلَ
u'رَادَ مُجَاهِدٌ':Predicate, #1: 1	أَرَادَ الْمَجَازَ
u'رَادَ مُجَاهِدٌ':Subject, #1: 1	أَرَادَ الْمُجَاهِدِينَ
u'رَادَ مُجْتَهِد':Predicate, #1: 1	أَرَادَ مُجَاهِدٌ
u'رَادَ مُجَرَّدٌ':Predicate, #1: 1	أَرَادَ الْمُجْتَهِدِينَ
u'رَادَ مَجْمُوعٌ':Predicate, #2: 2	أَرَادَ مُجَرَّدَ
u'رَادَ مُحْرِمٌ':Subject, #2: 2	أَرَادَ مَجْمُوعَ
u'رَادَ مَحْرُومٌ':Subject, #1: 1	أَرَادَ الْمُحْرِمُ
u'رَادَ مُحَمَّدٌ':Predicate, #1: 1	أَرَادَ الْمَحْرُومُ
u'رَادَ مُحَمَّدٌ':Subject, #1: 1	أَرَادَ مُحَمَّدَ
u'رَادَ مُحِيل':Subject, #2: 2	أَرَادَ مُحَمَّدٌ
u'رَادَ مُخَالِفٌ':Subject, #1: 1	أَرَادَ الْمُحِيلُ
u'رَادَ مَدْيُونٌ':Subject, #2: 2	أَرَادَ الْمُخَالِفُ
u'رَادَ مَدْيُونٌ':Subject, #1: 1	أَرَادَ الْمَدْيُونُ
u'رَادَ مَذْكُورٌ':Predicate, #1: 1	أَرَادَ مَدْيُونُ
u'رَادَ مرٌّ':Predicate, #1: 1	أَرَادَ الْمَذْكُورَ
u'رَادَ مُرَاعَاةٌ':Predicate, #1: 1	أَرَادَ مَرَّةً
u'رَادَ مُرْتَدٌّ':Predicate, #1: 1	أَرَادَ مُرَاعَاةَ
u'رَادَ مُرْتَهِنٌ':Subject, #1: 1	أَرَادَ الْمُرْتَدَّ
u'رَادَ مَرِحٌ':Predicate, #5: 5	أَرَادَ الْمُرْتَهِنُ
u'رَادَ مُرُورٌ':Predicate, #1: 1	أَرَادَ الْمَرِحَ
u'رَادَ مُرِيدٌ':Subject, #2: 2	أَرَادَ الْمُرُورَ
u'رَادَ مُزَارِعٌ':Subject, #2: 2	أَرَادَ مُرِيدٌ
u'رَادَ مُسَافِرٌ':Subject, #6: 6	أَرَادَ الْمُزَارِعُ
u'رَادَ مَسْأَلَةٌ':Predicate, #2: 2	أَرَادَ الْمُسَافِرُ
u'رَادَ مُسْتَأْجِرٌ':Predicate, #1: 1	أَرَادَ مَسْأَلَةَ
u'رَادَ مُسْتَأْجِرٌ':Subject, #1: 1	أَرَادَ الْمُسْتَأْجِرَ
u'رَادَ مُسْتَحِقٌّ':Subject, #11: 11	أَرَادَ الْمُسْتَأْجِرُ
u'رَادَ مُسْتَعِيرٌ':Subject, #2: 2	أَرَادَ الْمُسْتَحِقُّ
u'رَادَ مَسْحٌ':Predicate, #2: 2	أَرَادَ الْمُسْتَعِيرُ
u'رَادَ مَسْكَنَةٌ':Predicate, #5: 5	أَرَادَ الْمَسْحَ
u'رَادَ مُسْلِمٌ':Subject, #1: 1	أَرَادَ الْمَسْكَنَةَ
u'رَادَ مُسْلِمٌ':Subject, #2: 2	أَرَادَ الْمُسْلِمُ
u'رَادَ مَسِيرٌ':Predicate, #3: 3	أَرَادَ مُسْلِمٌ
u'رَادَ مُشَابَهَةٌ':Predicate, #1: 1	أَرَادَ الْمَسِيرَ
u'رَادَ مُشْرِفٌ':Subject, #1: 1	أَرَادَ الْمُشَابَهَةَ
u'رَادَ مُشْرِك':Predicate, #1: 1	أَرَادَ الْمُشْرِفُ
u'رَادَ مُشْرِك':Subject, #1: 1	أَرَادَ الْمُشْرِكِينَ
u'رَادَ مَشْرُوطٌ':Subject, #1: 1	أَرَادَ مُشْرِكٌ
u'رَادَ مَشْيٌ':Predicate, #1: 1	أَرَادَ الْمَشْرُوطُ
u'رَادَ مَصْدَرٌ':Predicate, #1: 1	أَرَادَ الْمَشْيَ
u'رَادَ مُصَنِّفٌ':Subject, #3: 3	أَرَادَ الْمَصْدَرَ
u'رَادَ مَصِيرٌ':Predicate, #6: 6	أَرَادَ الْمُصَنِّفُ
u'رَادَ مُضَارَبَةٌ':Predicate, #1: 1	أَرَادَ الْمَصِيرَ
u'رَادَ مُضْطَرٌّ':Subject, #1: 1	أَرَادَ الْمُضَارَبَةَ
u'رَادَ مَضْمُومٌ':Predicate, #1: 1	أَرَادَ الْمُضْطَرُّ
u'رَادَ مُطَالَبٌ':Predicate, #1: 1	أَرَادَ الْمَضْمُومَ
u'رَادَ مُطَالَبَةٌ':Predicate, #1: 1	أَرَادَ مُطَالَبَةَ
u'رَادَ مُطْلَقٌ':Predicate, #1: 1	أَرَادَ مُطَالَبَةَ
u'رَادَ مُطْلَقٌ':Predicate, #1: 1	أَرَادَ الْمُطْلَقَ
u'رَادَ مَطْلُوبٌ':Subject, #3: 3	أَرَادَ مُطْلَقَ
u'رَادَ مُطَهَّرٌ':Predicate, #1: 1	أَرَادَ الْمَطْلُوبُ
u'رَادَ مُعَاوَدَةٌ':Predicate, #1: 1	أَرَادَ الْمُطَهَّرِينَ
u'رَادَ مُعاوِيَة':Subject, #2: 2	أَرَادَ مُعَاوَدَةَ
u'رَادَ مُعْتَرِضٌ':Subject, #1: 1	أَرَادَ مُعَاوِيَةُ
u'رَادَ مَعْرِفَةٌ':Predicate, #1: 1	أَرَادَ الْمُعْتَرِضُ
u'رَادَ مَعْرِفَة':Predicate, #1: 1	أَرَادَ الْمَعْرِفَةَ
u'رَادَ مَعْرِفَةٌ':Predicate, #1: 1	أَرَادَ الْمَعْرِفَةَ
u'رَادَ مَعْرِفَة':Predicate, #2: 2	أَرَادَ مَعْرِفَةَ
u'رَادَ مُعْظَمٌ':Predicate, #2: 2	أَرَادَ مَعْرِفَةَ
u'رَادَ مُعَلِّلٌ':Subject, #1: 1	أَرَادَ مُعْظَمَ
u'رَادَ مُعَلِّمٌ':Subject, #1: 1	أَرَادَ الْمُعَلِّلُ
u'رَادَ مَعِيٌّ':Predicate, #1: 1	أَرَادَ الْمُعَلِّمُ
u'رَادَ مَعِيَّةٌ':Predicate, #4: 4	أَرَادَ الْمَعِيَّةَ
u'رَادَ مُعِير':Subject, #4: 4	أَرَادَ الْمَعِيَّةَ
u'رَادَ مَغَازِي':Predicate, #2: 2	أَرَادَ الْمُعِيرُ
u'رَادَ مَغْفِرَةٌ':Predicate, #1: 1	أَرَادَ الْمَغَازِيَ
u'رَادَ مُفَاوِضٌ':Subject, #2: 2	أَرَادَ الْمَغْفِرَةَ
u'رَادَ مُفْلِسٌ':Subject, #1: 1	أَرَادَ الْمُفَاوِضُ
u'رَادَ مَفْهُومٌ':Predicate, #1: 1	أَرَادَ الْمُفْلِسُ
u'رَادَ مُقَاتِلٌ':Subject, #1: 1	أَرَادَ الْمَفْهُومَ
u'رَادَ مُقَامٌ':Predicate, #1: 1	أَرَادَ الْمُقَاتِلُ
u'رَادَ مِقْدَارٌ':Predicate, #1: 1	أَرَادَ الْمُقَامَ
u'رَادَ مَقْذُوفٌ':Subject, #1: 1	أَرَادَ مِقْدَارَ
u'رَادَ مُقْرِضٌ':Subject, #3: 3	أَرَادَ الْمَقْذُوفُ
u'رَادَ مُقِيمٌ':Subject, #1: 1	أَرَادَ الْمُقْرِضُ
u'رَادَ مُكَافَأَةٌ':Predicate, #1: 1	أَرَادَ الْمُقِيمُ
u'رَادَ مَكَانٌ':Predicate, #1: 1	أَرَادَ الْمُكَافَأَةَ
u'رَادَ مُكَلَّفٌ':Subject, #1: 1	أَرَادَ الْمَكَانَ
u'رَادَ مَلأٌ':Predicate, #2: 2	أَرَادَ الْمُكَلَّفُ
u'رَادَ مُلْتَقِط':Subject, #1: 1	أَرَادَ الْمَلَأَ
u'رَادَ مِلْكٌ':Predicate, #1: 1	أَرَادَ الْمُلْتَقِطُ
u'رَادَ مَلَكٌ':Predicate, #1: 1	أَرَادَ الْمِلْكَ
u'رَادَ مِلْكٌ':Predicate, #1: 1	أَرَادَ مَلَكَ
u'رَادَ مُمَاثَلَةٌ':Predicate, #1: 1	أَرَادَ مِلْكَ
u'رَادَ مَنٌّ':Predicate, #3: 3	أَرَادَ الْمُمَاثَلَةَ
u'رَادَ مُنْتَقِلٌ':Subject, #1: 1	أَرَادَ الْمَنَّ
u'رَادَ مَنْصُورٌ':Subject, #2: 2	أَرَادَ الْمُنْتَقِلُ
u'رَادَ مَنْعٌ':Predicate, #1: 1	أَرَادَ الْمَنْصُورُ
u'رَادَ مَنْعٌ':Predicate, #2: 2	أَرَادَ الْمَنْعَ
u'رَادَ مَنْفَعَةٌ':Predicate, #2: 2	أَرَادَ مَنْعَ
u'رَادَ مَوَاضِعُ':Predicate, #1: 1	أَرَادَ الْمَنْفَعَةَ
u'رَادَ مُودَعٌ':Subject, #1: 1	أَرَادَ مَوَاضِعَ
u'رَادَ مَوْضِعٌ':Predicate, #2: 2	أَرَادَ الْمُودَعُ
u'رَادَ مُوَكِّلٌ':Subject, #1: 1	أَرَادَ الْمَوْضِعَ
u'رَادَ نَاسٌ':Predicate, #2: 2	أَرَادَ الْمُوَكِّلُ
u'رَادَ نَاسٌ':Subject, #1: 1	أَرَادَ النَّاسَ
u'رَادَ نَاصِرٌ':Predicate, #1: 1	أَرَادَ نَاسٌ
u'رَادَ نَاظِرٌ':Subject, #1: 1	أَرَادَ النَّاصِرَ
u'رَادَ نَاقَةٌ':Predicate, #3: 3	أَرَادَ النَّاظِرُ
u'رَادَ نَاقَة':Predicate, #1: 1	أَرَادَ النَّاقَةَ
u'رَادَ نَبِيٌّ':Subject, #1: 1	أَرَادَ النَّاقَةَ
u'رَادَ نِدَاءٌ':Predicate, #17: 17	أَرَادَ النَّبِيُّ
u'رَادَ نذر':Predicate, #1: 1	أَرَادَ النِّدَاءَ
u'رَادَ نَذْرٌ':Predicate, #5: 5	أَرَادَ النَّذْرَ
u'رَادَ نُزُولٌ':Predicate, #5: 5	أَرَادَ النَّذْرَ
u'رَادَ نِساءٌ':Subject, #1: 1	أَرَادَ النُّزُولَ
u'رَادَ نُسُكٌ':Predicate, #1: 1	أَرَادَ النِّسَاءُ
u'رَادَ نصب':Predicate, #3: 3	أَرَادَ النُّسُكَ
u'رَادَ نَصْبٌ':Predicate, #2: 2	أَرَادَ نَصْبَ
u'رَادَ نِصْفٌ':Predicate, #2: 2	أَرَادَ نَصْبَ
u'رَادَ نُطْقٌ':Predicate, #2: 2	أَرَادَ نِصْفَ
u'رَادَ نَفَلٌ':Predicate, #1: 1	أَرَادَ النُّطْقَ
u'رَادَ نَفْيٌ':Predicate, #1: 1	أَرَادَ النَّفَلَ
u'رَادَ نَفْيٌ':Predicate, #1: 1	أَرَادَ النّفْيَ
u'رَادَ نقرة':Predicate, #5: 5	أَرَادَ نَفْيَ
u'رَادَ نُقْرَةٌ':Predicate, #1: 1	أَرَادَ النُّقْرَةَ
u'رَادَ نَقْضٌ':Predicate, #1: 1	أَرَادَ النُّقْرَةَ
u'رَادَ نقل':Predicate, #2: 2	أَرَادَ نَقْضَ
u'رَادَ نَقْلٌ':Predicate, #1: 1	أَرَادَ النَّقْلَ
u'رَادَ نقل':Predicate, #1: 1	أَرَادَ النَّقْلَ
u'رَادَ نَقْلٌ':Predicate, #6: 6	أَرَادَ نَقْلَ
u'رَادَ نكاح':Predicate, #6: 6	أَرَادَ نَقْلَ
u'رَادَ نِكَاحٌ':Predicate, #1: 1	أَرَادَ النِّكَاحَ
u'رَادَ نكاح':Predicate, #1: 1	أَرَادَ النِّكَاحَ
u'رَادَ نِكَاحٌ':Predicate, #2: 2	أَرَادَ نِكَاحَ
u'رَادَ نَهْيٌ':Predicate, #2: 2	أَرَادَ نِكَاحَ
u'رَادَ نَوْعِيٌّ':Predicate, #2: 2	أَرَادَ النَّهْيَ
u'رَادَ نَوْمٌ':Predicate, #1: 1	أَرَادَ النَّوْعِيَّةَ
u'رَادَ نَوَوِيٌّ':Subject, #3: 3	أَرَادَ النَّوْمَ
u'رَادَ نِيَّةٌ':Predicate, #1: 1	أَرَادَ النَّوَوِيُّ
u'رَادَ نِيَّةٌ':Predicate, #1: 1	أَرَادَ النِّيَّةَ
u'رَادَ هِبَةٌ':Predicate, #1: 1	أَرَادَ نِيَّةَ
u'رَادَ هجرة':Predicate, #1: 1	أَرَادَ الْهِبَةَ
u'رَادَ هِجْرَةٌ':Predicate, #4: 4	أَرَادَ الْهِجْرَةَ
u'رَادَ هِدَايَةٌ':Predicate, #4: 4	أَرَادَ الْهِجْرَةَ
u'رَادَ هَدْمٌ':Predicate, #1: 1	أَرَادَ هِدَايَةَ
u'رَادَ هَدْيٌ':Predicate, #2: 2	أَرَادَ هَدْمَ
u'رَادَ وَاجِبٌ':Predicate, #1: 1	أَرَادَ الْهَدْيَ
u'رَادَ وَاجِبٌ':Subject, #1: 1	أَرَادَ الْوَاجِبَ
u'رَادَ واحد':Predicate, #1: 1	أَرَادَ وَاجِبٌ
u'رَادَ وَاحِدٌ':Predicate, #1: 1	أَرَادَ الْوَاحِدَ
u'رَادَ واحد':Predicate, #1: 1	أَرَادَ الْوَاحِدَ
u'رَادَ وَاحِدٌ':Predicate, #3: 3	أَرَادَ وَاحِدَةً
u'رَادَ واحد':Subject, #3: 3	أَرَادَ وَاحِدَةً
u'رَادَ وَاحِدٌ':Subject, #8: 8	أَرَادَ وَاحِدٌ
u'رَادَ وَارِثٌ':Subject, #8: 8	أَرَادَ وَاحِدٌ
u'رَادَ وَارِثٌ':Subject, #1: 1	أَرَادَ وَارِثٌ
u'رَادَ وَارِثٌ':Subject, #1: 1	أَرَادَ وَارِثُ
u'رَادَ وَاقِفٌ':Subject, #6: 6	أَرَادَ الْوَارِثُ
u'رَادَ وَاهِبٌ':Subject, #5: 5	أَرَادَ الْوَاقِفُ
u'رَادَ وَتْرٌ':Predicate, #9: 9	أَرَادَ الْوَاهِبُ
u'رَادَ وَجْهٌ':Predicate, #1: 1	أَرَادَ الْوَتْرَ
u'رَادَ وُجُوبٌ':Predicate, #1: 1	أَرَادَ الْوَجْهَ
u'رَادَ وَحْدَةٌ':Predicate, #2: 2	أَرَادَ الْوُجُوبَ
u'رَادَ وَرَثَةٌ':Subject, #1: 1	أَرَادَ الْوَحْدَةَ
u'رَادَ وَرَثَةٌ':Subject, #1: 1	أَرَادَ وَرَثَتُهُ
u'رَادَ وَسْوَسَةٌ':Predicate, #4: 4	أَرَادَ الْوَرَثَةُ
u'رَادَ وصال':Predicate, #1: 1	أَرَادَ الْوَسْوَسَةَ
u'رَادَ وِصَالٌ':Predicate, #1: 1	أَرَادَ الْوِصَالَ
u'رَادَ وَصْفٌ':Predicate, #1: 1	أَرَادَ الْوِصَالَ
u'رَادَ وُصُولٌ':Predicate, #2: 2	أَرَادَ وَصْفَ
u'رَادَ وَصِيٌّ':Subject, #4: 4	أَرَادَ الْوُصُولَ
u'رَادَ وَضْعٌ':Predicate, #4: 4	أَرَادَ الْوَصِيُّ
u'رَادَ وَضْعٌ':Predicate, #1: 1	أَرَادَ الْوَضْعَ
u'رَادَ وُضُوءٌ':Predicate, #2: 2	أَرَادَ وَضْعَ
u'رَادَ وَطْءٌ':Predicate, #3: 3	أَرَادَ الْوُضُوءَ
u'رَادَ وَقْتٌ':Predicate, #3: 3	أَرَادَ الْوَطْءَ
u'رَادَ وَقْفٌ':Predicate, #1: 1	أَرَادَ وَقْتَ
u'رَادَ وُقُوعٌ':Predicate, #2: 2	أَرَادَ الْوَقْفَ
u'رَادَ وُقُوفٌ':Predicate, #2: 2	أَرَادَ وُقُوعَ
u'رَادَ وَكِيلٌ':Subject, #3: 3	أَرَادَ الْوُقُوفَ
u'رَادَ وَكِيلٌ':Subject, #1: 1	أَرَادَ وَكِيلُ
u'رَادَ وِلاَيَةٌ':Predicate, #3: 3	أَرَادَ الْوَكِيلُ
u'رَادَ ولد':Predicate, #1: 1	أَرَادَ الْوِلَايَةَ
u'رَادَ وَلَدٌ':Predicate, #2: 2	أَرَادَ وَلَدَ
u'رَادَ ولد':Subject, #2: 2	أَرَادَ وَلَدَ
u'رَادَ وَلَدٌ':Subject, #3: 3	أَرَادَ الْوَلَدُ
u'رَادَ وَلِيٌّ':Subject, #3: 3	أَرَادَ الْوَلَدُ
u'رَادَ وَلِيٌّ':Subject, #2: 2	أَرَادَ وَلِيُّهُ
u'رَادَ وَلِيٌّ':Subject, #3: 3	أَرَادَ الْوَلِيُّ
u'رَادَ يَدٌ':Predicate, #6: 6	أَرَادَ وَلِيُّ
u'رَادَ يَمِينٌ':Predicate, #2: 2	أَرَادَ يَدَ
u'رَاسَلَ رَسُولٌ':Predicate, #7: 7	أَرَادَ الْيَمِينَ
u'رَاشَ نَاسٌ':Predicate, #1: 1	رَاسَلَ رَسُولَ
u'رَاضَى وَرَثَةٌ':Predicate, #1: 1	رَاشَ النّاسَ
u'رَاعَ عُمَرٌ':Predicate, #1: 1	رَاضَى الْوَرَثَةَ
u'رَاعَى اِبْنٌ':Subject, #1: 1	رَاعَ عُمَرَ
u'رَاعَى أَشْخَاصٌ':Predicate, #2: 2	رَاعَى ابْنُ
u'رَاعَى أَصْلَحُ':Predicate, #1: 1	رَاعَى الْأَشْخَاصَ
u'رَاعَى أَلْفَاظٌ':Predicate, #2: 2	رَاعَى الْأَصْلَحَ
u'رَاعَى إمَامٌ':Subject, #1: 1	رَاعَى الْأَلْفَاظَ
u'رَاعَى أَمْرٌ':Predicate, #1: 1	رَاعَى الْإِمَامُ
u'رَاعَى أَمْرٌ':Predicate, #1: 1	رَاعَى الْأَمْرَ
u'رَاعَى تَرْتِيبٌ':Predicate, #1: 1	رَاعَى أَمْرَ
u'رَاعَى تَسْمِيَة':Predicate, #3: 3	رَاعَى التَّرْتِيبَ
u'رَاعَى جُبَاةٌ':Predicate, #1: 1	رَاعَى التَّسْمِيَةَ
u'رَاعَى حاجَةٌ':Predicate, #1: 1	رَاعَى الْجُبَاةَ
u'رَاعَى حَقٌّ':Predicate, #1: 1	رَاعَى الْحَاجَةَ
u'رَاعَى حِمَايَةٌ':Predicate, #2: 2	رَاعَى حَقَّ
u'رَاعَى دَليلٌ':Predicate, #1: 1	رَاعَى حِمَايَةَ
u'رَاعَى ريعٌ':Predicate, #1: 1	رَاعَى دَلِيلَ
u'رَاعَى رَيْعٌ':Predicate, #3: 3	رَاعَى الرَّيْعَ
u'رَاعَى شافِعِيّ':Subject, #3: 3	رَاعَى الرَّيْعَ
u'رَاعَى صِحَّةٌ':Predicate, #2: 2	رَاعَى الشَّافِعِيُّ
u'رَاعَى صَغِيرٌ':Predicate, #1: 1	رَاعَى صِحَّةَ
u'رَاعَى صَلاَةٌ':Predicate, #1: 1	رَاعَى الصَّغِيرَ
u'رَاعَى ظاهِرٌ':Predicate, #1: 1	رَاعَى الصَّلَاةَ
u'رَاعَى علماء':Subject, #1: 1	رَاعَى ظَاهِرَ
u'رَاعَى عُلَمَاءُ':Subject, #1: 1	رَاعَى الْعُلَمَاءُ
u'رَاعَى عُمُومٌ':Predicate, #1: 1	رَاعَى الْعُلَمَاءُ
u'رَاعَى غَالِبٌ':Predicate, #1: 1	رَاعَى الْعُمُومَ
u'رَاعَى فلان':Subject, #1: 1	رَاعَى الْغَالِبَ
u'رَاعَى فلان':Subject, #1: 1	رَاعَى زِيَادٌ
u'رَاعَى قيام':Predicate, #2: 2	رَاعَى الشَّافِعِيُّ
u'رَاعَى قِيَامٌ':Predicate, #1: 1	رَاعَى قِيَامَ
u'رَاعَى لَفْظٌ':Predicate, #1: 1	رَاعَى قِيَامَ
u'رَاعَى مَالِكٌ':Subject, #1: 1	رَاعَى لَفْظَ
u'رَاعَى مُحْتَسِبٌ':Subject, #3: 3	رَاعَى مَالِكٌ
u'رَاعَى مَصْلَحَةٌ':Predicate, #1: 1	رَاعَى الْمُحْتَسِبُ
u'رَاعَى مُصَنِّفٌ':Subject, #1: 1	رَاعَى مَصْلَحَةَ
u'رَاعَى مَقْصِدٌ':Predicate, #1: 1	رَاعَى الْمُصَنِّفُ
u'رَافَقَ رَجُلٌ':Predicate, #1: 1	رَاعَى مَقْصِدَ
u'رَاقَبَ مَوْتٌ':Predicate, #1: 1	رَافَقَ رَجُلاً
u'رَاقَبَ نَاسٌ':Predicate, #1: 1	رَاقَبَ الْمَوْتَ
u'رَاقَ خَمْرٌ':Predicate, #1: 1	رَاقَبَ النَّاسَ
u'رَاقَ خَمْرٌ':Predicate, #1: 1	أَرَاقَ الْخَمْرَ
u'رَاقَ خُمُورٌ':Predicate, #1: 1	أَرَاقَ خَمْرَ
u'رَاقَ دَمٌ':Predicate, #3: 3	أَرَاقَ خُمُورَ
u'رَاقَ زَيْتٌ':Predicate, #1: 1	أَرَاقَ دَمَ
u'رَاقَ سُؤْرٌ':Predicate, #1: 1	أَرَاقَ زَيْتَ
u'رَاقَ لبن':Predicate, #1: 1	أَرَاقَ سُؤْرَ
u'رَاقَ لَبَنٌ':Predicate, #1: 1	أَرَاقَ اللَّبَنَ
u'رَاقَ مَاءٌ':Predicate, #1: 1	أَرَاقَ اللَّبَنَ
u'رَاقَ مَاءٌ':Predicate, #1: 1	أَرَاقَ مَاءَ
u'رَاقَ مَاءٌ':Subject, #8: 8	أَرَاقَ الْمَاءَ
u'رَامَ إِزَالَةٌ':Predicate, #1: 1	رَاقَ الْمَاءُ
u'رَامَ إِنْجاحٌ':Predicate, #2: 2	رَامَ إزَالَةَ
u'رَامَ بَائِعٌ':Subject, #1: 1	رَامَ إنْجَاحَ
u'رَامَ بَعْضٌ':Subject, #1: 1	رَامَ الْبَائِعُ
u'رَامَ بِنَاءٌ':Predicate, #3: 3	رَامَ بَعْضُ
u'رَامَ بَيِّنَةٌ':Predicate, #1: 1	رَامَ بِنَاءَ
u'رَامَ تَصْحِيحٌ':Predicate, #1: 1	رَامَ الْبَيِّنَةَ
u'رَامَ رَتْقٌ':Predicate, #1: 1	رَامَ تَصْحِيحَ
u'رَامَ رَدٌّ':Predicate, #1: 1	رَامَ رَتْقَ
u'رَامَ رَسُولٌ':Subject, #3: 3	رَامَ رَدَّ
u'رَامَ زِيادَةٌ':Predicate, #1: 1	رَامَ رَسُولُ
u'رَامَ شيب':Subject, #2: 2	رَامَ الزِّيَادَةَ
u'رَامَ شَيْبٌ':Subject, #1: 1	رَامَ شَيْبٌ
u'رَامَ عَوْدٌ':Predicate, #1: 1	رَامَ شَيْبٌ
u'رَامَ مُتَدَيِّنٌ':Subject, #1: 1	رَامَ عَوْدَ
u'رَامَ مُجَانَبَةٌ':Predicate, #1: 1	رَامَ الْمُتَدَيِّنُ
u'رَامَ وُقُوفٌ':Predicate, #1: 1	رَامَ مُجَانَبَةَ
u'رَاهَقَ حُلُمٌ':Predicate, #1: 1	رَامَ الْوُقُوفَ
u'رَاهَقَ غُلاَمٌ':Subject, #3: 3	رَاهَقَ الْحُلُمَ
u'رَاهَقَ قَالٌ':Predicate, #4: 4	رَاهَقَ الْغُلَامُ
u'رَاهَنَ رَسُولٌ':Subject, #3: 3	رَاهَقَ قَالَ
u'رَأَى إِبْقَاءٌ':Predicate, #3: 3	رَاهَنَ رَسُولُ
u'رَأَى إبْلِيسُ':Predicate, #1: 1	رَأَى إبْقَاءَ
u'رَأَى اِبْنٌ':Predicate, #3: 3	رَأَى إبْلِيسَ
u'رَأَى اِبْنٌ':Subject, #9: 9	رَأَى ابْنَ
u'رَأَى أثَرٌ':Predicate, #6: 6	رَأَى ابْنُ
u'رَأَى إِحْجَامٌ':Predicate, #1: 1	رَأَى أَثَرَ
u'رَأَى أحَدٌ':Predicate, #1: 1	رَأَى الْإِحْجَامَ
u'رَأَى أحَدٌ':Subject, #8: 8	رَأَى أَحَدَ
u'رَأَى إِحْلاَلٌ':Predicate, #11: 11	رَأَى أَحَدٌ
u'رَأَى أخْبَارٌ':Predicate, #1: 1	رَأَى الإِحْلاَلَ
u'رَأَى أَخْبَارٌ':Predicate, #1: 1	رَأَى أَخْبَارَ
u'رَأَى أخْبَارٌ':Predicate, #1: 1	رَأَى أَخْبَارَ
u'رَأَى أَخْبَارٌ':Predicate, #1: 1	رَأَى الْأَخْبَارَ
u'رَأَى أخْبِيَةٌ':Predicate, #1: 1	رَأَى الْأَخْبَارَ
u'رَأَى اِخْتِصَاصٌ':Predicate, #1: 1	رَأَى أَخْبِيَةَ
u'رَأَى اِخْتِلاَفٌ':Predicate, #1: 1	رَأَى اخْتِصَاصَ
u'رَأَى اِخْتِلاَفٌ':Predicate, #1: 1	رَأَى اخْتِلَافَ
u'رَأَى إِخْرَاجٌ':Predicate, #1: 1	رَأَى اخْتِلاَفَ
u'رَأَى أَذَانٌ':Predicate, #1: 1	رَأَى إخْرَاجَ
u'رَأَى أَذَانٌ':Predicate, #1: 1	رَأَى الأَذَانَ
u'رَأَى إِرْجَاءٌ':Predicate, #1: 1	رَأَى الْأَذَانَ
u'رَأَى أرْسَاغٌ':Predicate, #1: 1	رَأَى الْإِرْجَاءَ
u'رَأَى إِسْقاطٌ':Predicate, #1: 1	رَأَى أَرْسَاغَ
u'رَأَى إشارَة':Predicate, #1: 1	رَأَى إسْقَاطَ
u'رَأَى أَشْجَارٌ':Predicate, #1: 1	رَأَى إشَارَةَ
u'رَأَى إِشْكالٌ':Predicate, #2: 2	رَأَى أَشْجَارَ
u'رَأَى أَصْحَابٌ':Subject, #2: 2	رَأَى الْإِشْكَالَ
u'رَأَى إِضاعَةٌ':Predicate, #1: 1	رَأَى أَصْحَابُهُ
u'رَأَى إِعادَةٌ':Predicate, #1: 1	رَأَى إضَاعَةَ
u'رَأَى اِعْتِكافٌ':Predicate, #1: 1	رَأَى إِعَادَةَ
u'رَأَى أعْقَابٌ':Predicate, #1: 1	رَأَى الاِعْتِكَافَ
u'رَأَى أَعْقَابٌ':Predicate, #1: 1	رَأَى أَعْقَابَ
u'رَأَى إقامَةٌ':Predicate, #1: 1	رَأَى أَعْقَابَ
u'رَأَى أَكْثَرُ':Predicate, #1: 1	رَأَى إقَامَةَ
u'رَأَى الْمَرْأَةُ':Predicate, #2: 2	رَأَى أَكْثَرَ
u'رَأَى أُمٌّ':Predicate, #1: 1	رَأَى الْمَرْأَةَ
u'رَأَى إمَامٌ':Predicate, #1: 1	رَأَى أُمَّ
u'رَأَى إمَامٌ':Subject, #3: 3	رَأَى الْإِمَامَ
u'رَأَى إمَامٌ':Subject, #1: 1	رَأَى الإِمَامُ
u'رَأَى إمَامٌ':Subject, #1: 1	رَأَى إمَامٌ
u'رَأَى إمَامٌ':Subject, #1: 1	رَأَى إمَامُ
u'رَأَى أَمْرٌ':Predicate, #41: 41	رَأَى الْإِمَامُ
u'رَأَى أَمْرٌ':Predicate, #1: 1	رَأَى الْأَمْرَ
u'رَأَى أمراء':Subject, #1: 1	رَأَى أَمْرَ
u'رَأَى أَمْرَد':Predicate, #1: 1	رَأَى الْأُمَرَاءُ
u'رَأَى أنبياء':Predicate, #1: 1	رَأَى أَمْرَدَ
u'رَأَى إِنْسانٌ':Subject, #1: 1	رَأَى الْأَنْبِيَاءَ
u'رَأَى إِنْفاقٌ':Predicate, #1: 1	رَأَى إنْسَانٌ
u'رَأَى أهْلٌ':Subject, #2: 2	رَأَى الْإِنْفَاقَ
u'رَأَى باقِي':Predicate, #7: 7	رَأَى أَهْلُ
u'رَأَى بِشْرٌ':Predicate, #1: 1	رَأَى الْبَاقِيَ
u'رَأَى بَعْضٌ':Predicate, #3: 3	رَأَى بِشْرَ
u'رَأَى بَعْضٌ':Predicate, #2: 2	رَأَى الْبَعْضَ
u'رَأَى بَعْضٌ':Subject, #5: 5	رَأَى بَعْضَ
u'رَأَى بَقَرٌ':Predicate, #5: 5	رَأَى بَعْضُ
u'رَأَى بَقَرٌ':Predicate, #1: 1	رَأَى الْبَقَرَةَ
u'رَأَى بَيْتٌ':Predicate, #1: 1	رَأَى بَقَرَةً
u'رَأَى بَيْعٌ':Predicate, #18: 18	رَأَى الْبَيْتَ
u'رَأَى بَيْنٌ':Predicate, #2: 2	رَأَى بَيْعَ
u'رَأَى بُيُوتٌ':Predicate, #2: 2	رَأَى بَيْنَ
u'رَأَى تَأْخِيرٌ':Predicate, #1: 1	رَأَى بُيُوتَ
u'رَأَى تَجْفِيفٌ':Predicate, #1: 1	رَأَى تَأْخِيرَ
u'رَأَى تَخْصِيصٌ':Predicate, #1: 1	رَأَى تَجْفِيفَ
u'رَأَى تَرْتِيبٌ':Predicate, #1: 1	رَأَى تَخْصِيصَ
u'رَأَى تَرْكٌ':Predicate, #1: 1	رَأَى تَرْتِيبَ
u'رَأَى تَرِكَةٌ':Predicate, #2: 2	رَأَى تَرْكَ
u'رَأَى تَعْمِيقٌ':Predicate, #1: 1	رَأَى التَّرِكَةَ
u'رَأَى تَغْلِيظٌ':Predicate, #1: 1	رَأَى تَعْمِيقَ
u'رَأَى تَقْديمٌ':Predicate, #1: 1	رَأَى التَّغْلِيظَ
u'رَأَى تَقْديمٌ':Predicate, #1: 1	رَأَى التَّقْدِيمَ
u'رَأَى تَقْصيرٌ':Predicate, #1: 1	رَأَى تَقْدِيمَ
u'رَأَى تَكْبيرٌ':Predicate, #1: 1	رَأَى تَقْصِيرَ
u'رَأَى تَوَقُّفٌ':Predicate, #1: 1	رَأَى التَّكْبِيرَ
u'رَأَى تَيَمُّمٌ':Predicate, #1: 1	رَأَى التَّوَقُّفَ
u'رَأَى ثَلاثَةٌ':Predicate, #3: 3	رَأَى التَّيَمُّمَ
u'رَأَى ثَلْجٌ':Predicate, #1: 1	رَأَى ثَلَاثَةَ
u'رَأَى ثِمارٌ':Predicate, #1: 1	رَأَى الثّلْجَ
u'رَأَى جَارِي':Predicate, #1: 1	رَأَى الثِّمَارَ
u'رَأَى جَارِي':Predicate, #1: 1	رَأَى الْجَارِيَةَ
u'رَأَى جَارِيَةٌ':Predicate, #6: 6	رَأَى جَارِيَةً
u'رَأَى جَائِزٌ':Predicate, #1: 1	رَأَى الْجَارِيَةَ
u'رَأَى جَائِزَةٌ':Predicate, #1: 1	رَأَى جَائِزَةَ
u'رَأَى جُبْن':Predicate, #1: 1	رَأَى جَائِزَةَ
u'رَأَى جَمَاعَةٌ':Subject, #1: 1	رَأَى جُبْنَةً
u'رَأَى جمع':Predicate, #1: 1	رَأَى جَمَاعَةٌ
u'رَأَى جَمْعٌ':Predicate, #1: 1	رَأَى الْجَمْعَ
u'رَأَى جَنَازَةٌ':Predicate, #1: 1	رَأَى الْجَمْعَ
u'رَأَى جَنَّةٌ':Predicate, #1: 1	رَأَى الْجَنَازَةَ
u'رَأَى جَنَّةٌ':Predicate, #1: 1	رَأَى الْجَنّةَ
u'رَأَى جُنُودٌ':Predicate, #1: 1	رَأَى الْجَنَّةَ
u'رَأَى جَوَازٌ':Predicate, #1: 1	رَأَى جُنُودَ
u'رَأَى جَيْشٌ':Predicate, #2: 2	رَأَى جَوَازَ
u'رَأَى حاجَةٌ':Predicate, #1: 1	رَأَى الْجَيْشَ
u'رَأَى حاكِمٌ':Subject, #1: 1	رَأَى حَاجَةَ
u'رَأَى حاكِمٌ':Subject, #18: 18	رَأَى الْحَاكِمُ
u'رَأَى حالٌ':Predicate, #1: 1	رَأَى حَاكِمٌ
u'رَأَى حائِطٌ':Predicate, #1: 1	رَأَى حَالَ
u'رَأَى حُجَّةٌ':Predicate, #1: 1	رَأَى الْحَائِطَ
u'رَأَى حَجَرٌ':Predicate, #1: 1	رَأَى الْحُجَّةَ
u'رَأَى حَديثٌ':Predicate, #1: 1	رَأَى الْحَجَرَ
u'رَأَى حِرْصٌ':Predicate, #2: 2	رَأَى الْحَدِيثَ
u'رَأَى حَشِيشٌ':Predicate, #1: 1	رَأَى حِرْصَ
u'رَأَى حِصْنٌ':Predicate, #1: 1	رَأَى حَشِيشَ
u'رَأَى حُصُول':Predicate, #1: 1	رَأَى الْحِصْنَ
u'رَأَى حَظٌّ':Predicate, #1: 1	رَأَى حُصُولَ
u'رَأَى حَقٌّ':Predicate, #4: 4	رَأَى الْحَظَّ
u'رَأَى حُكْمٌ':Predicate, #3: 3	رَأَى الْحَقَّ
u'رَأَى حُكْمٌ':Predicate, #1: 1	رَأَى الْحُكْمَ
u'رَأَى حكماء':Subject, #1: 1	رَأَى حُكْمَ
u'رَأَى حَلالٌ':Subject, #1: 1	رَأَى الْحُكَمَاءُ
u'رَأَى حُلَّةٌ':Predicate, #2: 2	رَأَى حَلَالٌ
u'رَأَى حَمَّالٌ':Subject, #2: 2	رَأَى حُلَّةَ
u'رَأَى حِنْثٌ':Predicate, #1: 1	رَأَى الْحَمَّالُ
u'رَأَى حِنْطَةٌ':Predicate, #1: 1	رَأَى الْحِنْثَ
u'رَأَى حَنَفِيَّةٌ':Predicate, #1: 1	رَأَى الْحِنْطَةَ
u'رَأَى حَيٌّ':Predicate, #1: 1	رَأَى الْحَنَفِيَّةَ
u'رَأَى حَيَوَانٌ':Predicate, #1: 1	رَأَى حَيَّةً
u'رَأَى خَارِجٌ':Predicate, #1: 1	رَأَى الْحَيَوَانَ
u'رَأَى خَالِدٌ':Subject, #2: 2	رَأَى خَارِجَ
u'رَأَى خَبَرٌ':Predicate, #1: 1	رَأَى خَالِدُ
u'رَأَى خَبَر':Predicate, #1: 1	رَأَى الْخَبَرَ
u'رَأَى خَصْمٌ':Predicate, #1: 1	رَأَى الْخَبَرَ
u'رَأَى خِلاَفٌ':Predicate, #1: 1	رَأَى الْخَصْمَ
u'رَأَى خِلاَفٌ':Predicate, #1: 1	رَأَى الْخِلَافَ
u'رَأَى خَلَلٌ':Predicate, #1: 1	رَأَى خِلَافَ
u'رَأَى خَلِيفَةٌ':Subject, #2: 2	رَأَى خَلَلاً
u'رَأَى خوارج':Predicate, #1: 1	رَأَى الْخَلِيفَةُ
u'رَأَى خَوَارِجُ':Predicate, #1: 1	رَأَى الْخَوَارِجَ
u'رَأَى دَابَّةٌ':Predicate, #1: 1	رَأَى الْخَوَارِجَ
u'رَأَى دَاخِلٌ':Subject, #1: 1	رَأَى الدَّابَّةَ
u'رَأَى دَارٌ':Predicate, #1: 1	رَأَى الدَّاخِلُ
u'رَأَى دُرٌّ':Predicate, #1: 1	رَأَى الدَّارَ
u'رَأَى دَرَاهِمُ':Predicate, #1: 1	رَأَى دُرَّةً
u'رَأَى دَمٌ':Predicate, #2: 2	رَأَى الدَّرَاهِمَ
u'رَأَى ذَهَبٌ':Predicate, #1: 1	رَأَى الدَّمَ
u'رَأَى رَاهِنٌ':Predicate, #1: 1	رَأَى الذَّهَبَ
u'رَأَى رَأْيٌ':Predicate, #2: 2	رَأَى الرَّاهِنَ
u'رَأَى رَبُّ':Subject, #1: 1	رَأَى رَأْيَ
u'رَأَى رَجُلٌ':Predicate, #2: 2	رَأَى رَبّهُ
u'رَأَى رَجُلٌ':Predicate, #1: 1	رَأَى رَجُلاَ
u'رَأَى رَجُلٌ':Subject, #28: 28	رَأَى رَجُلاً
u'رَأَى رَجُلٌ':Subject, #3: 3	رَأَى الرَّجُلُ
u'رَأَى رُجُوعٌ':Predicate, #8: 8	رَأَى رَجُلٌ
u'رَأَى رَسُولٌ':Predicate, #1: 1	رَأَى الرُّجُوعَ
u'رَأَى رَسُولٌ':Predicate, #1: 1	رَأَى الرَّسُولَ
u'رَأَى رَسُولٌ':Subject, #41: 41	رَأَى رَسُولَ
u'رَأَى رَفْعٌ':Predicate, #60: 60	رَأَى رَسُولُ
u'رَأَى رَقيقٌ':Subject, #1: 1	رَأَى الرّفْعَ
u'رَأَى رَقيق':Subject, #1: 1	رَأَى رَقِيقُهُ
u'رَأَى زَيْدٌ':Predicate, #1: 1	رَأَى رَقِيقُهُ
u'رَأَى زَيْدٌ':Subject, #1: 1	رَأَى زَيْدَ
u'رَأَى سدرة':Predicate, #1: 1	رَأَى زَيْدٌ
u'رَأَى سِدْرَةٌ':Predicate, #1: 1	رَأَى سِدْرَةَ
u'رَأَى سَعْدٌ':Subject, #1: 1	رَأَى سِدْرَةَ
u'رَأَى سَعِيدٌ':Predicate, #2: 2	رَأَى سَعْدٌ
u'رَأَى سَنَةٌ':Predicate, #1: 1	رَأَى سَعِيدَ
u'رَأَى سُهَيْلٌ':Subject, #1: 1	رَأَى سَنَةَ
u'رَأَى سَيِّدٌ':Subject, #1: 1	رَأَى سُهَيْلٌ
u'رَأَى شَاةٌ':Predicate, #1: 1	رَأَى السَّيِّدُ
u'رَأَى شافِعِيّ':Subject, #1: 1	رَأَى الشَّاةَ
u'رَأَى شَخْصٌ':Predicate, #1: 1	رَأَى الشَّافِعِيُّ
u'رَأَى شَخْصٌ':Subject, #3: 3	رَأَى شَخْصَ
u'رَأَى شَرِيعَةٌ':Predicate, #2: 2	رَأَى شَخْصٌ
u'رَأَى شُعاعٌ':Predicate, #2: 2	رَأَى الشَّرِيعَةَ
u'رَأَى شُعَاعٌ':Predicate, #1: 1	رَأَى الشُّعَاعَ
u'رَأَى شمس':Predicate, #1: 1	رَأَى الشُّعَاعَ
u'رَأَى شَمْسٌ':Predicate, #2: 2	رَأَى الشَّمْسَ
u'رَأَى شَيْخٌ':Subject, #2: 2	رَأَى الشَّمْسَ
u'رَأَى شَيْطَانٌ':Subject, #2: 2	رَأَى الشَّيْخُ
u'رَأَى صَاحِبٌ':Predicate, #1: 1	رَأَى الشَّيْطَانُ
u'رَأَى صَاحِبٌ':Subject, #3: 3	رَأَى صَاحِبَ
u'رَأَى صبر':Predicate, #1: 1	رَأَى صَاحِبُ
u'رَأَى صَبْرٌ':Predicate, #1: 1	رَأَى الصَّبْرَ
u'رَأَى صَحْنٌ':Predicate, #1: 1	رَأَى الصَّبْرَ
u'رَأَى صَرْفٌ':Predicate, #3: 3	رَأَى صَحْنَ
u'رَأَى صَرْف':Predicate, #1: 1	رَأَى صَرْفَ
u'رَأَى صَغِيرٌ':Predicate, #1: 1	رَأَى صَرْفَ
u'رَأَى صَفْقَةٌ':Predicate, #1: 1	رَأَى الصَّغِيرَ
u'رَأَى صَفِيٌّ':Predicate, #3: 3	رَأَى الصَّفْقَةَ
u'رَأَى صَلاَحٌ':Predicate, #1: 1	رَأَى صَفِيَّةَ
u'رَأَى صَوَابٌ':Predicate, #1: 1	رَأَى الصَّلَاحَ
u'رَأَى صُورَةٌ':Predicate, #1: 1	رَأَى الصَّوَابَ
u'رَأَى صَيْدٌ':Predicate, #1: 1	رَأَى صُورَةَ
u'رَأَى صَيْدٌ':Subject, #1: 1	رَأَى الصَّيْدَ
u'رَأَى ضَمٌّ':Predicate, #1: 1	رَأَى الصَّيْدُ
u'رَأَى طَائِرٌ':Predicate, #1: 1	رَأَى الضَّمَّ
u'رَأَى طلب':Predicate, #1: 1	رَأَى الطَّائِرَ
u'رَأَى طَلَبٌ':Predicate, #1: 1	رَأَى طَلَبَ
u'رَأَى طُلُوعٌ':Predicate, #1: 1	رَأَى طَلَبَ
u'رَأَى ظاهِرٌ':Predicate, #1: 1	رَأَى طُلُوعَ
u'رَأَى ظَبْيٌ':Predicate, #1: 1	رَأَى ظَاهِرَ
u'رَأَى عَادَةٌ':Predicate, #4: 4	رَأَى ظَبْيَةً
u'رَأَى عَاصِرٌ':Predicate, #1: 1	رَأَى عَادَةَ
u'رَأَى عَامٌّ':Predicate, #1: 1	رَأَى عَاصِرَ
u'رَأَى عَامٌّ':Subject, #1: 1	رَأَى الْعَامَّةَ
u'رَأَى عَامِرٌ':Subject, #1: 1	رَأَى الْعَامَّةُ
u'رَأَى عَامِلٌ':Subject, #1: 1	رَأَى عَامِرٌ
u'رَأَى عَبْدٌ':Predicate, #2: 2	رَأَى الْعَامِلُ
u'رَأَى عَبْدٌ':Predicate, #10: 10	رَأَى عَبْدَ
u'رَأَى عَبْدٌ':Subject, #3: 3	رَأَى الْعَبْدَ
u'رَأَى عتبة':Subject, #7: 7	رَأَى عَبْدُ
u'رَأَى عَدُوٌّ':Predicate, #1: 1	رَأَى عُتْبَةُ
u'رَأَى عَفْوٌ':Predicate, #1: 1	رَأَى الْعَدُوَّ
u'رَأَى عَكْسٌ':Predicate, #2: 2	رَأَى الْعَفْوَ
u'رَأَى عَلْقَم':Predicate, #2: 2	رَأَى عَكْسَ
u'رَأَى عَلْقَمَة':Predicate, #2: 2	رَأَى عَلْقَمَةَ
u'رَأَى علماء':Subject, #2: 2	رَأَى عَلْقَمَةَ
u'رَأَى عُلَمَاءُ':Subject, #1: 1	رَأَى الْعُلَمَاءُ
u'رَأَى عَلِيٌّ':Subject, #1: 1	رَأَى الْعُلَمَاءُ
u'رَأَى عُمَارَةٌ':Subject, #3: 3	رَأَى عَلِيٌّ
u'رَأَى عُمَرٌ':Predicate, #1: 1	رَأَى عُمَارَةُ
u'رَأَى عُمَرٌ':Subject, #7: 7	رَأَى عُمَرَ
u'رَأَى عِنَبٌ':Predicate, #18: 18	رَأَى عُمَرُ
u'رَأَى عند':Predicate, #1: 1	رَأَى عِنَبَ
u'رَأَى عَهْدٌ':Predicate, #1: 1	رَأَى عِنْدَ
u'رَأَى عَوَامُّ':Subject, #1: 1	رَأَى الْعَهْدَ
u'رَأَى عَوْرَةٌ':Predicate, #1: 1	رَأَى الْعَوَامُّ
u'رَأَى عَيْبٌ':Predicate, #1: 1	رَأَى عَوْرَةَ
u'رَأَى عين':Predicate, #6: 6	رَأَى الْعَيْبَ
u'رَأَى عَيْنٌ':Predicate, #2: 2	رَأَى عَيْنَ
u'رَأَى عَيْن':Predicate, #2: 2	رَأَى عَيْنَ
u'رَأَى غاسِل':Subject, #2: 2	رَأَى عَيْنَ
u'رَأَى غَسْلٌ':Predicate, #1: 1	رَأَى الْغَاسِلُ
u'رَأَى غَصْبٌ':Predicate, #1: 1	رَأَى غَسْلَ
u'رَأَى غَلَبَةٌ':Predicate, #1: 1	رَأَى الْغَصْبَ
u'رَأَى غَنِيٌّ':Predicate, #1: 1	رَأَى غَلَبَةَ
u'رَأَى غير':Predicate, #1: 1	رَأَى الْغَنِيَّ
u'رَأَى غَيْرٌ':Predicate, #8: 8	رَأَى غَيْرَ
u'رَأَى فَاطِمٌ':Predicate, #8: 8	رَأَى غَيْرَ
u'رَأَى فَاكِهَانِيٌّ':Subject, #2: 2	رَأَى فَاطِمَةَ
u'رَأَى فَتًى':Predicate, #1: 1	رَأَى الْفَاكِهَانِيُّ
u'رَأَى فَرْجٌ':Predicate, #1: 1	رَأَى فَتىً
u'رَأَى فَرَسٌ':Predicate, #2: 2	رَأَى فَرْجَ
u'رَأَى فَضْلٌ':Predicate, #2: 2	رَأَى فَرَسَ
u'رَأَى فقهاء':Subject, #1: 1	رَأَى الْفَضْلَ
u'رَأَى فَقِيرٌ':Predicate, #1: 1	رَأَى الْفُقَهَاءُ
u'رَأَى فلان':Predicate, #2: 2	رَأَى الْفَقِيرَ
u'رَأَى فلان':Predicate, #2: 2	رَأَى مُعَاوِيَةَ
u'رَأَى فلان':Subject, #6: 6	رَأَى عُثْمَانَ
u'رَأَى فلان':Subject, #1: 1	رَأَى الشَّافِعِيُّ
u'رَأَى فلان':Subject, #1: 1	رَأَى حُذَيْفَةُ
u'رَأَى فلان':Subject, #1: 1	رَأَى عُثْمَانُ
u'رَأَى فُلاَنٌ':Subject, #1: 1	رَأَى قَابِيلُ
u'رَأَى قَالٌ':Predicate, #2: 2	رَأَى فُلَانٌ
u'رَأَى قَائِمٌ':Subject, #1: 1	رَأَى قَالَ
u'رَأَى قَبَاءٌ':Predicate, #1: 1	رَأَى الْقَائِمُ
u'رَأَى قَبْرٌ':Predicate, #1: 1	رَأَى الْقَبَاءَ
u'رَأَى قِبْطِيٌّ':Subject, #5: 5	رَأَى قَبْرَ
u'رَأَى قَبُولٌ':Predicate, #1: 1	رَأَى الْقِبْطِيُّ
u'رَأَى قتل':Predicate, #1: 1	رَأَى قَبُولَ
u'رَأَى قَتْلٌ':Predicate, #1: 1	رَأَى قَتْلَ
u'رَأَى قتل':Predicate, #1: 1	رَأَى قَتْلَ
u'رَأَى قَتْلٌ':Predicate, #1: 1	رَأَى قَتْلَهُنَّ
u'رَأَى قدم':Predicate, #1: 1	رَأَى قَتْلَهُنَّ
u'رَأَى قَدَمٌ':Predicate, #2: 2	رَأَى الْقَدَمَ
u'رَأَى قِرَاءةٌ':Predicate, #2: 2	رَأَى الْقَدَمَ
u'رَأَى قسمة':Predicate, #5: 5	رَأَى قِرَاءَةَ
u'رَأَى قِسْمَةٌ':Predicate, #1: 1	رَأَى قِسْمَةَ
u'رَأَى قَصْدٌ':Predicate, #1: 1	رَأَى قِسْمَةَ
u'رَأَى قَضَاءٌ':Predicate, #1: 1	رَأَى الْقَصْدَ
u'رَأَى قطعة':Predicate, #1: 1	رَأَى الْقَضَاءَ
u'رَأَى قِطْعَةٌ':Predicate, #1: 1	رَأَى قِطْعَةَ
u'رَأَى قِلَّةٌ':Predicate, #1: 1	رَأَى قِطْعَةَ
u'رَأَى قمر':Predicate, #1: 1	رَأَى قِلَّةَ
u'رَأَى قَمَرٌ':Predicate, #2: 2	رَأَى الْقَمَرَ
u'رَأَى قُوَّةٌ':Predicate, #2: 2	رَأَى الْقَمَرَ
u'رَأَى قُوَّة':Predicate, #1: 1	رَأَى الْقُوَّةَ
u'رَأَى قُوَّةٌ':Predicate, #1: 1	رَأَى الْقُوَّةَ
u'رَأَى قُوَّة':Predicate, #2: 2	رَأَى قُوَّةَ
u'رَأَى قَوَد':Predicate, #2: 2	رَأَى قُوَّةَ
u'رَأَى قول':Predicate, #1: 1	رَأَى الْقَوَدَ
u'رَأَى قَوْلٌ':Predicate, #3: 3	رَأَى قَوْلَ
u'رَأَى قَوْمٌ':Predicate, #3: 3	رَأَى قَوْلَ
u'رَأَى قَوْمٌ':Subject, #2: 2	رَأَى الْقَوْمَ
u'رَأَى قَوْمٌ':Subject, #1: 1	رَأَى الْقَوْمُ
u'رَأَى قَوِيٌّ':Subject, #3: 3	رَأَى قَوْمٌ
u'رَأَى قِيَاسٌ':Predicate, #1: 1	رَأَى قَوِيُّ
u'رَأَى قِيمَةٌ':Predicate, #1: 1	رَأَى الْقِيَاسَ
u'رَأَى كَبِيرٌ':Predicate, #1: 1	رَأَى الْقِيمَةَ
u'رَأَى كِتَابٌ':Predicate, #1: 1	رَأَى الْكَبِيرَ
u'رَأَى كِتَابَةٌ':Predicate, #1: 1	رَأَى الْكِتَابَ
u'رَأَى كَثْرَةٌ':Predicate, #1: 1	رَأَى الْكِتَابَةَ
u'رَأَى كَرَاهَةٌ':Predicate, #1: 1	رَأَى كَثْرَةَ
u'رَأَى كَرَاهِيَةٌ':Predicate, #2: 2	رَأَى الْكَرَاهَةَ
u'رَأَى كسرة':Predicate, #1: 1	رَأَى الْكَرَاهِيَةَ
u'رَأَى كِسْرَةٌ':Predicate, #1: 1	رَأَى كِسْرَةَ
u'رَأَى كعبة':Predicate, #1: 1	رَأَى كِسْرَةَ
u'رَأَى كَعْبَةٌ':Predicate, #1: 1	رَأَى الْكَعْبَةَ
u'رَأَى كَلاَمٌ':Predicate, #1: 1	رَأَى الْكَعْبَةَ
u'رَأَى كَوْكَبٌ':Predicate, #4: 4	رَأَى كَلَامَ
u'رَأَى لبن':Predicate, #1: 1	رَأَى الْكَوْكَبَ
u'رَأَى لبن':Predicate, #1: 1	رَأَى اللّبَنَ
u'رَأَى لَبَنٌ':Predicate, #1: 1	رَأَى اللَّبَنَ
u'رَأَى لَبَنٌ':Predicate, #1: 1	رَأَى اللّبَنَ
u'رَأَى لقطة':Predicate, #1: 1	رَأَى اللَّبَنَ
u'رَأَى لُؤْلُؤَةٌ':Predicate, #1: 1	رَأَى اللُّقَطَةَ
u'رَأَى لَيْلٌ':Predicate, #2: 2	رَأَى اللُّؤْلُؤَةَ
u'رَأَى مَاءٌ':Predicate, #10: 10	رَأَى لَيْلَةَ
u'رَأَى مَالٌ':Predicate, #26: 26	رَأَى الْمَاءَ
u'رَأَى مَالٌ':Predicate, #1: 1	رَأَى الْمَالَ
u'رَأَى مَالِكٌ':Predicate, #2: 2	رَأَى مَالَ
u'رَأَى مَالِكٌ':Subject, #1: 1	رَأَى مَالِكَ
u'رَأَى مَائِدٌ':Predicate, #8: 8	رَأَى مَالِكٌ
u'رَأَى مَائِدَةٌ':Predicate, #2: 2	رَأَى مَائِدَةَ
u'رَأَى مَبَاحِثُ':Predicate, #2: 2	رَأَى مَائِدَةَ
u'رَأَى مبرَّد':Subject, #1: 1	رَأَى الْمَبَاحِثَ
u'رَأَى مُبَرَّدٌ':Subject, #1: 1	رَأَى الْمُبَرّدُ
u'رَأَى مُبَرِّدٌ':Subject, #1: 1	رَأَى الْمُبَرّدُ
u'رَأَى مَبِيعٌ':Predicate, #1: 1	رَأَى الْمُبَرّدُ
u'رَأَى مُتَقَدِّمٌ':Predicate, #5: 5	رَأَى الْمَبِيعَ
u'رَأَى مثل':Predicate, #1: 1	رَأَى الْمُتَقَدِّمِينَ
u'رَأَى مِثْلٌ':Predicate, #6: 6	رَأَى مِثْلَ
u'رَأَى مَثْمُون':Predicate, #6: 6	رَأَى مِثْلَ
u'رَأَى مُحْتَاجٌ':Subject, #1: 1	رَأَى الْمَثْمُونَ
u'رَأَى مُحْتَسِبٌ':Subject, #1: 1	رَأَى مُحْتَاجٌ
u'رَأَى مُحْرِمٌ':Subject, #2: 2	رَأَى الْمُحْتَسِبُ
u'رَأَى مُحْرِمٌ':Subject, #1: 1	رَأَى الْمُحْرِمُ
u'رَأَى مُحَمَّدٌ':Subject, #1: 1	رَأَى مُحْرِمٌ
u'رَأَى مُحَمَّدٌ':Subject, #1: 1	رَأَى مُحَمَّدُ
u'رَأَى مُدَرِّسٌ':Subject, #3: 3	رَأَى مُحَمّدٌ
u'رَأَى مرٌّ':Predicate, #1: 1	رَأَى الْمُدَرِّسُ
u'رَأَى مَرَاكِبُ':Predicate, #1: 1	رَأَى مَرَّةً
u'رَأَى مَسْأَلَةٌ':Predicate, #1: 1	رَأَى مَرَاكِبَ
u'رَأَى مُسْتَأْجِرٌ':Subject, #1: 1	رَأَى مَسْأَلَةَ
u'رَأَى مَسْجِدٌ':Predicate, #2: 2	رَأَى الْمُسْتَأْجِرُ
u'رَأَى مَسْحٌ':Predicate, #1: 1	رَأَى مَسْجِدَ
u'رَأَى مُسْلِمٌ':Subject, #1: 1	رَأَى مَسْحَ
u'رَأَى مَشَايِخُ':Subject, #2: 2	رَأَى مُسْلِمٌ
u'رَأَى مُصَدِّقٌ':Subject, #1: 1	رَأَى مَشَايِخُ
u'رَأَى مَصْلَحَةٌ':Predicate, #1: 1	رَأَى الْمُصَدِّقُ
u'رَأَى مُصَنِّفٌ':Subject, #42: 42	رَأَى الْمَصْلَحَةَ
u'رَأَى مَصْنُوعٌ':Predicate, #2: 2	رَأَى الْمُصَنِّفُ
u'رَأَى مَطَرٌ':Predicate, #1: 1	رَأَى الْمَصْنُوعَ
u'رَأَى مُعاوِيَة':Predicate, #4: 4	رَأَى الْمَطَرَ
u'رَأَى مَقْتَلٌ':Predicate, #2: 2	رَأَى مُعَاوِيَةَ
u'رَأَى مَكَانٌ':Predicate, #1: 1	رَأَى مَقْتَلَ
u'رَأَى مَكْرُوهٌ':Predicate, #1: 1	رَأَى مَكَانَ
u'رَأَى مُكَلَّفٌ':Subject, #2: 2	رَأَى الْمَكْرُوهَ
u'رَأَى مَلاَئِكَةٌ':Predicate, #1: 1	رَأَى الْمُكَلَّفُ
u'رَأَى مَلِكٌ':Subject, #1: 1	رَأَى الْمَلَائِكَةَ
u'رَأَى مَمْلُوكٌ':Predicate, #1: 1	رَأَى الْمَلِكُ
u'رَأَى مُنْكَرٌ':Predicate, #1: 1	رَأَى الْمَمْلُوكَ
u'رَأَى مَنِيٌّ':Predicate, #2: 2	رَأَى الْمُنْكَرَ
u'رَأَى نَاسٌ':Predicate, #1: 1	رَأَى الْمَنِيَّ
u'رَأَى نَاسٌ':Predicate, #1: 1	رَأَى النّاسَ
u'رَأَى نَاسٌ':Subject, #4: 4	رَأَى النَّاسَ
u'رَأَى نَاسٌ':Subject, #1: 1	رَأَى النّاسُ
u'رَأَى نَاسٌ':Subject, #3: 3	رَأَى نَاسٌ
u'رَأَى نَاظِرٌ':Subject, #6: 6	رَأَى النَّاسُ
u'رَأَى نَائِمٌ':Subject, #5: 5	رَأَى النَّاظِرُ
u'رَأَى نَبِيٌّ':Predicate, #1: 1	رَأَى النَّائِمُ
u'رَأَى نَبِيٌّ':Subject, #40: 40	رَأَى النَّبِيَّ
u'رَأَى نَجَاسَةٌ':Predicate, #9: 9	رَأَى النَّبِيُّ
u'رَأَى نِدَاءٌ':Predicate, #2: 2	رَأَى النَّجَاسَةَ
u'رَأَى نِدَاءٌ':Predicate, #1: 1	رَأَى النّدَاءَ
u'رَأَى نِساءٌ':Predicate, #1: 1	رَأَى النِّدَاءَ
u'رَأَى نسخة':Predicate, #2: 2	رَأَى النِّسَاءَ
u'رَأَى نُسْخَةٌ':Predicate, #2: 2	رَأَى النُّسْخَةَ
u'رَأَى نَصْرَانِيٌّ':Predicate, #2: 2	رَأَى النُّسْخَةَ
u'رَأَى نِعَمٌ':Predicate, #1: 1	رَأَى نَصْرَانِيَّةً
u'رَأَى نَفْعٌ':Predicate, #1: 1	رَأَى نِعَمَ
u'رَأَى نَقْضٌ':Predicate, #2: 2	رَأَى النَّفْعَ
u'رَأَى نِقْيٌ':Predicate, #2: 2	رَأَى نَقْضَ
u'رَأَى هَدْيٌ':Predicate, #1: 1	رَأَى النِّقْيَ
u'رَأَى هِلاَلٌ':Predicate, #1: 1	رَأَى الْهَدْيَ
u'رَأَى هِلاَلٌ':Predicate, #1: 1	رَأَى الْهِلالَ
u'رَأَى هِلاَلٌ':Predicate, #26: 26	رَأَى الْهِلَالَ
u'رَأَى هِلاَلٌ':Predicate, #37: 37	رَأَى هِلَالَ
u'رَأَى هِلاَلٌ':Subject, #3: 3	رَأَى الْهِلاَلَ
u'رَأَى واحد':Subject, #1: 1	رَأَى الْهِلَالُ
u'رَأَى وَاحِدٌ':Subject, #1: 1	رَأَى الْوَاحِدُ
u'رَأَى واحد':Subject, #1: 1	رَأَى الْوَاحِدُ
u'رَأَى وَاحِدٌ':Subject, #2: 2	رَأَى وَاحِدٌ
u'رَأَى وَاقِعٌ':Predicate, #2: 2	رَأَى وَاحِدٌ
u'رَأَى وَاقِعَةٌ':Predicate, #1: 1	رَأَى وَاقِعَةَ
u'رَأَى وَاقِفٌ':Subject, #1: 1	رَأَى وَاقِعَةَ
u'رَأَى وبال':Predicate, #1: 1	رَأَى الْوَاقِفُ
u'رَأَى وَبَالٌ':Predicate, #1: 1	رَأَى وَبَالَهُنَّ
u'رَأَى وَجْهٌ':Predicate, #1: 1	رَأَى وَبَالَهُنَّ
u'رَأَى وَصِيٌّ':Subject, #3: 3	رَأَى وَجْهَ
u'رَأَى وطاء':Predicate, #2: 2	رَأَى الْوَصِيُّ
u'رَأَى وِطَاءٌ':Predicate, #1: 1	رَأَى الْوِطَاءَ
u'رَأَى وقفة':Predicate, #1: 1	رَأَى الْوِطَاءَ
u'رَأَى وَقْفَةٌ':Predicate, #1: 1	رَأَى وَقْفَةَ
u'رَأَى وُقُوفٌ':Predicate, #1: 1	رَأَى وَقْفَةَ
u'رَأَى وَكِيلٌ':Subject, #1: 1	رَأَى وُقُوفَ
u'رَأَى وَلِيٌّ':Subject, #1: 1	رَأَى الْوَكِيلُ
u'رباط بَهيمٌ':Added, #2: 2	رَأَى الْوَلِيُّ
u'رباط بَهيمٌ':Added, #1: 1	رِبَاطَ الْبَهِيمَةِ
u'رِبَاطٌ بَهيمٌ':Added, #1: 1	رِبَاطِ الْبَهِيمَةِ
u'رِبَاطٌ بَهيمٌ':Added, #1: 1	رِبَاطَ الْبَهِيمَةِ
u'رباط بَهِيمَةٌ':Added, #1: 1	رِبَاطِ الْبَهِيمَةِ
u'رباط بَهِيمَةٌ':Added, #1: 1	رِبَاطَ الْبَهِيمَةِ
u'رِبَاطٌ بَهِيمَةٌ':Added, #1: 1	رِبَاطِ الْبَهِيمَةِ
u'رِبَاطٌ بَهِيمَةٌ':Added, #1: 1	رِبَاطَ الْبَهِيمَةِ
u'رباط بَهِيمَةٌ':Added, #1: 1	رِبَاطِ الْبَهِيمَةِ
u'رِبَاطٌ بَهِيمَةٌ':Added, #1: 1	رِبَاطَ بَهِيمَةٍ
u'رباط خَيْلٌ':Added, #1: 1	رِبَاطَ بَهِيمَةٍ
u'رِبَاطٌ خَيْلٌ':Added, #16: 16	رِبَاطِ الْخَيْلِ
u'رباط خَيْلٌ':Added, #16: 16	رِبَاطِ الْخَيْلِ
u'رِبَاطٌ خَيْلٌ':Added, #1: 1	رِبَاطُ الْخَيْلِ
u'رباط دَابَّةٌ':Added, #1: 1	رِبَاطُ الْخَيْلِ
u'رِبَاطٌ دَابَّةٌ':Added, #1: 1	رِبَاطَ دَابَّتِهِ
u'رباط زِقٌّ':Added, #1: 1	رِبَاطَ دَابَّتِهِ
u'رِبَاطٌ زِقٌّ':Added, #1: 1	رِبَاطَ الزِّقِّ
u'رباط زِقٌّ':Added, #1: 1	رِبَاطَ الزِّقِّ
u'رِبَاطٌ زِقٌّ':Added, #1: 1	رِبَاطَ زِقٍّ
u'رباط سَبِيلٌ':Added, #1: 1	رِبَاطَ زِقٍّ
u'رِبَاطٌ سَبِيلٌ':Added, #2: 2	رِبَاطُ سَبِيلٍ
u'رباط سَفِينَةٌ':Added, #2: 2	رِبَاطُ سَبِيلٍ
u'رِبَاطٌ سَفِينَةٌ':Added, #1: 1	رِبَاطِ السَّفِينَةِ
u'رباط سَفِينَةٌ':Added, #1: 1	رِبَاطِ السَّفِينَةِ
u'رِبَاطٌ سَفِينَةٌ':Added, #2: 2	رِبَاطَ سَفِينَةٍ
u'رباط سَنَةٌ':Added, #2: 2	رِبَاطَ سَفِينَةٍ
u'رِبَاطٌ سَنَةٌ':Added, #1: 1	رِبَاطَ سَنَةٍ
u'رباط شَرْعٌ':Added, #1: 1	رِبَاطَ سَنَةٍ
u'رِبَاطٌ شَرْعٌ':Added, #1: 1	رِبَاطُ الشَّرْعِ
u'رباط صُوفِيٌّ':Added, #1: 1	رِبَاطُ الشَّرْعِ
u'رِبَاطٌ صُوفِيٌّ':Added, #1: 1	رِبَاطَ الصُّوفِيَّةِ
u'رباط صُوفِيَّةٌ':Added, #1: 1	رِبَاطَ الصُّوفِيَّةِ
u'رِبَاطٌ صُوفِيَّةٌ':Added, #1: 1	رِبَاطَ الصُّوفِيَّةِ
u'رباط فَرَسٌ':Added, #1: 1	رِبَاطَ الصُّوفِيَّةِ
u'رِبَاطٌ فَرَسٌ':Added, #1: 1	رِبَاطَ فَرَسٍ
u'رباط قِرْبَةٌ':Added, #1: 1	رِبَاطَ فَرَسٍ
u'رِبَاطٌ قِرْبَةٌ':Added, #1: 1	رِبَاطُ الْقِرْبَةِ
u'رباط كَلْبٌ':Added, #1: 1	رِبَاطُ الْقِرْبَةِ
u'رِبَاطٌ كَلْبٌ':Added, #1: 1	رِبَاطِ الْكَلْبِ
u'رباط لَيْلٌ':Added, #1: 1	رِبَاطِ الْكَلْبِ
u'رِبَاطٌ لَيْلٌ':Added, #2: 2	رِبَاطُ لَيْلَةٍ
u'رباط مَارٌّ':Added, #2: 2	رِبَاطُ لَيْلَةٍ
u'رِبَاطٌ مَارٌّ':Added, #1: 1	رِبَاطِ الْمَارَّةِ
u'رباط مَارَّةٌ':Added, #1: 1	رِبَاطِ الْمَارَّةِ
u'رِبَاطٌ مَارَّةٌ':Added, #1: 1	رِبَاطِ الْمَارَّةِ
u'رباط مُخْتَلِفٌ':Added, #1: 1	رِبَاطِ الْمَارَّةِ
u'رِبَاطٌ مُخْتَلِفٌ':Added, #1: 1	رِبَاطُ الْمُخْتَلِفَةِ
u'رباط مُعَيَّنٌ':Added, #1: 1	رِبَاطُ الْمُخْتَلِفَةِ
u'رِبَاطٌ مُعَيَّنٌ':Added, #1: 1	رِبَاطٍ مُعَيَّنٍ
u'رباط مَوْقُوفٌ':Added, #1: 1	رِبَاطٍ مُعَيَّنٍ
u'رِبَاطٌ مَوْقُوفٌ':Added, #1: 1	رِبَاطٍ مَوْقُوفٍ
u'رباط نِساءٌ':Added, #1: 1	رِبَاطٍ مَوْقُوفٍ
u'رِبَاطٌ نِساءٌ':Added, #1: 1	رِبَاطِ نِسَاءٍ
u'رباط واحد':Added, #1: 1	رِبَاطِ نِسَاءٍ
u'رِبَاطٌ واحد':Added, #2: 2	رِبَاطٍ وَاحِدٍ
u'رباط وَاحِدٌ':Added, #2: 2	رِبَاطٍ وَاحِدٍ
u'رِبَاطٌ وَاحِدٌ':Added, #2: 2	رِبَاطٍ وَاحِدٍ
u'رباط يَوْمٌ':Added, #2: 2	رِبَاطٍ وَاحِدٍ
u'رِبَاطٌ يَوْمٌ':Added, #8: 8	رِبَاطُ يَوْمٍ
u'رَبَا مَالٌ':Subject, #8: 8	رِبَاطُ يَوْمٍ
u'رِبْحٌ أحَدٌ':Added, #1: 1	رَبَا الْمَالُ
u'رِبْحٌ أحَدٌ':Added, #1: 1	رِبْحِ أَحَدِ
u'رِبْحٌ أُخَرٌ':Added, #3: 3	رِبْحَ أَحَدِ
u'رِبْحٌ أُخَرٌ':Added, #1: 1	رِبْحَ الْأُخَرِ
u'رَبِحَ ألف':Predicate, #1: 1	رِبْحِ الْأُخَرِ
u'رَبِحَ ألْفٌ':Predicate, #1: 1	رَبِحَ أَلْفَ
u'رَبِحَ أَلْفٌ':Predicate, #1: 1	رَبِحَ أَلْفَ
u'رَبِحَ ألف':Subject, #1: 1	رَبِحَ أَلْفَ
u'رَبِحَ ألْفٌ':Subject, #1: 1	رَبِحَ الْأَلْفُ
u'رَبِحَ أَلْفٌ':Subject, #1: 1	رَبِحَ الْأَلْفُ
u'رِبْحٌ ألف':Added, #1: 1	رَبِحَ الْأَلْفُ
u'رِبْحٌ ألف':Added, #1: 1	رِبْحُ أَلْفِ
u'رِبْحٌ ألْفٌ':Added, #1: 1	رِبْحِ أَلْفِ
u'رِبْحٌ ألْفٌ':Added, #1: 1	رِبْحُ أَلْفِ
u'رِبْحٌ أَلْفٌ':Added, #1: 1	رِبْحِ أَلْفِ
u'رِبْحٌ أَلْفٌ':Added, #1: 1	رِبْحُ أَلْفِ
u'رِبْحٌ ألف':Added, #1: 1	رِبْحِ أَلْفِ
u'رِبْحٌ ألْفٌ':Added, #1: 1	رِبْحِ أَلْفِهِ
u'رِبْحٌ أَلْفٌ':Added, #1: 1	رِبْحِ أَلْفِهِ
u'رَبِحَ أَوَّلُ':Subject, #1: 1	رِبْحِ أَلْفِهِ
u'رِبْحٌ أَوَّلُ':Added, #2: 2	رَبِحَ الْأَوَّلُ
u'رِبْحٌ أَوَّلُ':Added, #1: 1	رِبْحُ الْأَوَّلِ
u'رِبْحٌ باقَةٌ':Added, #1: 1	رِبْحِ الْأَوَّلِ
u'رِبْحٌ باقِي':Added, #2: 2	رِبْحِ بَاقِيهِ
u'رِبْحٌ بِضاعَةٌ':Added, #2: 2	رِبْحِ بَاقِيهِ
u'رَبِحَ بَيْعٌ':Subject, #1: 1	رِبْحُ بِضَاعَتِهِ
u'رِبْحٌ تِجَارَةٌ':Added, #2: 2	رَبِحَ الْبَيْعُ
u'رِبْحٌ تِجَارَةٌ':Added, #1: 1	رِبْحُ التِّجَارَةِ
u'رِبْحٌ تِجَارَةٌ':Added, #2: 2	رِبْحَ التِّجَارَةِ
u'رِبْحٌ تِجَارَةٌ':Added, #2: 2	رِبْحَ تِجَارَةٍ
u'رِبْحٌ ثَانِي':Added, #4: 4	رِبْحِ التِّجَارَةِ
u'رِبْحٌ ثَانِيَةٌ':Added, #1: 1	رِبْحِ الثَّانِيَةِ
u'رِبْحٌ حادِثٌ':Added, #1: 1	رِبْحِ الثَّانِيَةِ
u'رِبْحٌ حِرْفَةٌ':Added, #1: 1	رِبْحٍ حَادِثٍ
u'رِبْحٌ خَمْسَةٌ':Added, #1: 1	رِبْحِ حِرْفَتِهِ
u'رِبْحٌ دَرَاهِمُ':Added, #2: 2	رِبْحِ خَمْسَةٍ
u'رِبْحٌ دِرْهَمٌ':Added, #5: 5	رِبْحُ الدَّرَاهِمِ
u'رِبْحٌ دِرْهَمٌ':Added, #1: 1	رِبْحُ دِرْهَمٍ
u'رِبْحٌ دِرْهَم':Added, #1: 1	رِبْحِ دِرْهَمٍ
u'رِبْحٌ دِرْهَم':Added, #1: 1	رِبْحُ دِرْهَمٍ
u'رِبْحٌ دِرْهَمٌ':Added, #1: 1	رِبْحِ دِرْهَمٍ
u'رِبْحٌ دِرْهَم':Added, #1: 1	رِبْحُ دِرْهَمَيْنِ
u'رِبْحٌ دَنانيرُ':Added, #1: 1	رِبْحُ دِرْهَمَيْنِ
u'رَبِحَ دونٌ':Predicate, #1: 1	رِبْحُ الدَّنَانِيرِ
u'رِبْحٌ دَيْنٌ':Added, #1: 1	رَبِحَ دُونَ
u'رِبْحٌ دِينارٌ':Added, #2: 2	رِبْحَ دَيْنٍ
u'رِبْحٌ دِينارٌ':Added, #1: 1	رِبْحِ الدِّينَارِ
u'رِبْحٌ رَبُّ':Added, #1: 1	رِبْحُ دِينَارٍ
u'رِبْحٌ رِبْحٌ':Added, #2: 2	رِبْحَ رَبِّ
u'رِبْحٌ سَفَرٌ':Added, #1: 1	رِبْحَ رِبْحِهِ
u'رِبْحٌ شَيْءٌ':Added, #1: 1	رِبْحَ سَفَرٍ
u'رِبْحٌ صَاحِبٌ':Added, #1: 1	رِبْحَ شَيْءٍ
u'رَبِحَ ضَمِنٌ':Predicate, #1: 1	رِبْحِ صَاحِبِهِ
u'رِبْحٌ عَامِلٌ':Added, #2: 2	رَبِحَ ضَمِنَ
u'رِبْحٌ عَامِلٌ':Added, #1: 1	رِبْحُ الْعَامِلِ
u'رَبِحَ عَبْدٌ':Subject, #1: 1	رِبْحِ الْعَامِلِ
u'رِبْحٌ عُرُوضٌ':Added, #1: 1	رَبِحَ الْعَبْدُ
u'رَبِحَ عُشْرٌ':Predicate, #1: 1	رِبْحِ الْعُرُوضِ
u'رِبْحٌ عمرة':Added, #1: 1	رَبِحَ عُشْرَ
u'رِبْحٌ عُمْرَةٌ':Added, #1: 1	رِبْحَ عُمْرَةٍ
u'رَبِحَ عند':Predicate, #1: 1	رِبْحَ عُمْرَةٍ
u'رَبِحَ غير':Predicate, #1: 1	رَبِحَ عِنْدَ
u'رَبِحَ غَيْرٌ':Predicate, #1: 1	رَبِحَ غَيْرَ
u'رِبْحٌ فَوَائِدُ':Added, #1: 1	رَبِحَ غَيْرَ
u'رِبْحٌ قراض':Added, #1: 1	رِبْحِ الْفَوَائِدِ
u'رِبْحٌ قَوَد':Added, #1: 1	رِبْحِ الْقِرَاضِ
u'رَبِحَ كَفِيلٌ':Subject, #1: 1	رِبْحِ الْقَوَدِ
u'رَبِحَ مَالٌ':Predicate, #3: 3	رَبِحَ الْكَفِيلُ
u'رَبِحَ مَالٌ':Subject, #2: 2	رَبِحَ الْمَالَ
u'رِبْحٌ مَالٌ':Added, #2: 2	رَبِحَ الْمَالُ
u'رِبْحٌ مَالٌ':Added, #1: 1	رِبْحَ الْمَالِ
u'رِبْحٌ مَالٌ':Added, #1: 1	رِبْحَ مَالِهِ
u'رِبْحٌ مَالٌ':Added, #2: 2	رِبْحِ الْمَالَيْنِ
u'رِبْحٌ مَالٌ':Added, #2: 2	رِبْحَ مَالٍ
u'رِبْحٌ مَالٌ':Added, #2: 2	رِبْحِ مَالِ
u'رِبْحٌ مَالٌ':Added, #4: 4	رِبْحُ الْمَالِ
u'رِبْحٌ مَالٌ':Added, #4: 4	رِبْحِ مَالِهِ
u'رِبْحٌ مَالٌ':Added, #5: 5	رِبْحُ مَالِهِ
u'رِبْحٌ مَبِيعٌ':Added, #8: 8	رِبْحِ الْمَالِ
u'رِبْحٌ مَتَاعٌ':Added, #1: 1	رِبْحُ الْمَبِيعِ
u'رَبِحَ مُضَارِبٌ':Subject, #1: 1	رِبْحُ مَتَاعِهِ
u'رِبْحٌ مُضَارِبٌ':Added, #5: 5	رَبِحَ الْمُضَارِبُ
u'رِبْحٌ مُضَارِبٌ':Added, #1: 1	رِبْحِ مُضَارِبٍ
u'رِبْحٌ مُضَارَبَةٌ':Added, #2: 2	رِبْحُ الْمُضَارِبِ
u'رَبِحَ مِيقَاتٌ':Predicate, #2: 2	رِبْحِ الْمُضَارَبَةِ
u'رِبْحٌ مِيقَاتٌ':Added, #2: 2	رَبِحَ مِيقَاتَ
u'رِبْحٌ مِيقَاتٌ':Added, #1: 1	رِبْحِ مِيقَاتِ
u'رِبْحٌ نِصْفٌ':Added, #3: 3	رِبْحُ الْمِيقَاتِ
u'رِبْحٌ نِصْفٌ':Added, #1: 1	رِبْحُ نِصْفِ
u'رِبْحٌ نِصْفٌ':Added, #1: 1	رِبْحَ نِصْفِهِ
u'رِبْحٌ نَصِيبٌ':Added, #3: 3	رِبْحُ نِصْفِهِ
u'رَبِحَ وَجَبٌ':Predicate, #1: 1	رِبْحِ نَصِيبِ
u'رِبْحٌ ولد':Added, #1: 1	رَبِحَ وَجَبَ
u'رِبْحٌ وَلَدٌ':Added, #1: 1	رِبْحِ الْوَلَدِ
u'رَبَضَ بَعيرٌ':Subject, #1: 1	رِبْحِ الْوَلَدِ
u'رَبْطٌ أَجْزَاءٌ':Added, #2: 2	رَبَضَ الْبَعِيرُ
u'رَبْطٌ أحَدٌ':Added, #1: 1	رَبْطُ أَجْزَاءِ
u'رَبْطٌ أَحْكَامٌ':Added, #1: 1	رَبْطِ أَحَدِ
u'رَبَطَ آخِرُ':Predicate, #6: 6	رَبْطِ الْأَحْكَامِ
u'رَبْطٌ أَخْلاَفٌ':Added, #2: 2	رَبَطَ آخِرَ
u'رَبَطَ أسْبَابٌ':Predicate, #1: 1	رَبْطُ أَخْلَافِ
u'رَبَطَ أَسْبَابٌ':Predicate, #1: 1	رَبَطَ الْأَسْبَابَ
u'رَبْطٌ أسْنَانٌ':Added, #1: 1	رَبَطَ الْأَسْبَابَ
u'رَبَطَ أَمْرٌ':Predicate, #2: 2	رَبْطِ أَسْنَانِهِ
u'رَبْطٌ أَمْرٌ':Added, #1: 1	رَبَطَ الْأَمْرَ
u'رَبْطٌ بَطْنٌ':Added, #2: 2	رَبْطِ الْأَمْرِ
u'رَبَطَ بَعْضٌ':Predicate, #1: 1	رَبْطِ بَطْنِهِ
u'رَبَطَ بَعيرٌ':Predicate, #1: 1	رَبَطَ الْبَعْضَ
u'رَبَطَ ثُمام':Predicate, #3: 3	رَبَطَ الْبَعِيرَ
u'رَبَطَ جُرْحٌ':Predicate, #2: 2	رَبَطَ ثُمَامَةَ
u'رَبْطٌ جَوَابٌ':Added, #2: 2	رَبَطَ الْجُرْحَ
u'رَبْطٌ حُصُول':Added, #1: 1	رَبْطَ الْجَوَابِ
u'رَبْطٌ حُكْمٌ':Added, #1: 1	رَبْطُ حُصُولِ
u'رَبْطٌ حُكْمٌ':Added, #1: 1	رَبْطُ الْحُكْمِ
u'رَبْطٌ حُكْمٌ':Added, #1: 1	رَبْطَ حُكْمِ
u'رَبْطٌ حُكْمٌ':Added, #1: 1	رَبْطُ حُكْمِ
u'رَبَطَ حِمَارٌ':Predicate, #2: 2	رَبْطِ الْحُكْمِ
u'رَبْطٌ خاصّ':Added, #3: 3	رَبَطَ الْحِمَارَ
u'رَبْطٌ خِلاَفٌ':Added, #1: 1	رَبْطُ خَاصٍّ
u'رَبَطَ دَابَّةٌ':Predicate, #1: 1	رَبْطُ خِلَافِ
u'رَبَطَ دَابَّةٌ':Predicate, #1: 1	رَبَطَ الدَّابَّةَ
u'رَبْطٌ دَابَّةٌ':Added, #1: 1	رَبَطَ دَابَّةَ
u'رَبْطٌ دَابَّةٌ':Added, #1: 1	رَبْطٍ دَابَّةٍ
u'رَبْطٌ دَابَّةٌ':Added, #1: 1	رَبْطِ دَابَّةٍ
u'رَبَطَ دَرَاهِمُ':Predicate, #2: 2	رَبْطِ الدَّابَّةِ
u'رَبْطٌ دَرَاهِمُ':Added, #1: 1	رَبَطَ دَرَاهِمَ
u'رَبْطٌ دَوَابُّ':Added, #1: 1	رَبْطِ الدَّرَاهِمِ
u'رَبَطَ رَجُلٌ':Subject, #1: 1	رَبْطُ الدَّوَابِّ
u'رَبْطٌ شَعْرٌ':Added, #4: 4	رَبَطَ رَجُلٌ
u'رَبْطٌ شَيْءٌ':Added, #1: 1	رَبْطُ الشَّعْرِ
u'رَبْطٌ شَيْءٌ':Added, #1: 1	رَبْطُ الشَّيْءِ
u'رَبْطٌ صِفَةٌ':Added, #3: 3	رَبْطِ شَيْءٍ
u'رَبْطٌ صَلاَةٌ':Added, #1: 1	رَبْطِ الصِّفَةِ
u'رَبَطَ طَلاَقٌ':Predicate, #1: 1	رَبْطُ صَلَاتِهِ
u'رَبْطٌ عَقْدٌ':Added, #1: 1	رَبَطَ الطَّلَاقَ
u'رَبْطٌ عَقْدٌ':Added, #1: 1	رَبْطَ الْعَقْدِ
u'رَبَطَ عُودٌ':Predicate, #4: 4	رَبْطُ الْعَقْدِ
u'رَبْطٌ غير':Added, #1: 1	رَبَطَ الْعُودَ
u'رَبْطٌ غَيْرٌ':Added, #1: 1	رَبْطِ الْغَيْرِ
u'رَبْطٌ غير':Added, #1: 1	رَبْطِ الْغَيْرِ
u'رَبْطٌ غَيْرٌ':Added, #3: 3	رَبْطِ غَيْرِهِ
u'رَبْطٌ قَبُولٌ':Added, #3: 3	رَبْطِ غَيْرِهِ
u'رَبْطٌ قَصْدٌ':Added, #1: 1	رَبْطُ الْقَبُولِ
u'رَبْطٌ قول':Added, #1: 1	رَبْطِ قَصْدِهِ
u'رَبْطٌ قَوْلٌ':Added, #1: 1	رَبْطُ الْقَوْلِ
u'رَبَطَ قِيرَاطٌ':Predicate, #1: 1	رَبْطُ الْقَوْلِ
u'رَبَطَ كَلْبٌ':Predicate, #1: 1	رَبَطَ الْقِيرَاطَ
u'رُبُطٌ مَارٌّ':Added, #1: 1	رَبَطَ كَلْبَ
u'رُبُطٌ مَارَّةٌ':Added, #1: 1	رُبُطِ الْمَارَّةِ
u'رَبْطٌ مَحَلٌّ':Added, #1: 1	رُبُطِ الْمَارَّةِ
u'رَبْطٌ مَشِيئَةٌ':Added, #1: 1	رَبْطِ مَحَلِّ
u'رَبْطٌ مَعَانِي':Added, #1: 1	رَبْطَ الْمَشِيئَةِ
u'رَبَطَ وَصِيٌّ':Predicate, #1: 1	رَبْطُ مَعَانِيهِ
u'رَبَطَ وَصِيَّةٌ':Predicate, #1: 1	رَبَطَ الْوَصِيَّةَ
u'رَبَطَ وَقْفٌ':Predicate, #1: 1	رَبَطَ الْوَصِيَّةَ
u'رَبْعٌ أرْضٌ':Added, #1: 1	رَبَطَ الْوَقْفَ
u'رَبْعٌ حَبْسٌ':Added, #1: 1	رَبْعِ أَرْضٍ
u'رَبْعٌ حَبْسٌ':Added, #1: 1	رَبْعَ الْحَبْسِ
u'رَبْعٌ مُفْلِسٌ':Added, #1: 1	رَبْعِ الْحَبْسِ
u'رَبْعٌ يَتِيمٌ':Added, #1: 1	رَبْعِ الْمُفْلِسِ
u'رَبَّ غير':Subject, #1: 1	رَبْعَ يَتِيمِهِ
u'رَبَّ غَيْرٌ':Subject, #11: 11	رَبَّ غَيْرُهُ
u'رَبَلَ طَفْلٌ':Subject, #11: 11	رَبَّ غَيْرُهُ
u'رَبَلَ طِفْلٌ':Subject, #1: 1	رَبَلَ الطّفْلُ
u'رَبَّ يَعْقُوبٌ':Predicate, #1: 1	رَبَلَ الطّفْلُ
u'رَبَّى مَكْفُولٌ':Predicate, #1: 1	رَبَّ يَعْقُوبَ
u'رَتَّبَ أَجْوِبَةٌ':Predicate, #1: 1	رَبَّى الْمَكْفُولَةَ
u'رَتَّبَ أَحْكَامٌ':Predicate, #1: 1	رَتَّبَ الْأَجْوِبَةَ
u'رَتَّبَ اِسْتِمْرارٌ':Predicate, #1: 1	رَتَّبَ الْأَحْكَامَ
u'رَتَّبَ أَصْحَابٌ':Subject, #1: 1	رَتَّبَ اسْتِمْرَارَ
u'رَتَّبَ أصل':Subject, #1: 1	رَتَّبَ الْأَصْحَابُ
u'رَتَّبَ أًصْلٌ':Subject, #1: 1	رَتَّبَ الْأَصْلُ
u'رَتَّبَ إمَامٌ':Subject, #1: 1	رَتَّبَ الْأَصْلُ
u'رَتَّبَ بَعْثٌ':Predicate, #1: 1	رَتَّبَ الْإِمَامُ
u'رَتَّبَ بَعْضٌ':Subject, #1: 1	رَتَّبَ بَعْثَ
u'رَتَّبَ بَيْنٌ':Predicate, #1: 1	رَتَّبَ بَعْضُ
u'رَتَّبَ تَخْيِيرٌ':Predicate, #2: 2	رَتَّبَ بَيْنَ
u'رَتَّبَ تَعْلِيقٌ':Predicate, #1: 1	رَتَّبَ التَّخْيِيرَ
u'رَتَّبَ جَرَائِدُ':Predicate, #1: 1	رَتَّبَ التَّعْلِيقَ
u'رَتَّبَ جَمَاعَةٌ':Subject, #2: 2	رَتَّبَ الْجَرَائِدَ
u'رَتَّبَ جَوَازٌ':Predicate, #1: 1	رَتَّبَ جَمَاعَةٌ
u'رَتَّبَ حُدودٌ':Predicate, #1: 1	رَتَّبَ جَوَازَ
u'رَتَّبَ حُكْمٌ':Predicate, #1: 1	رَتَّبَ الْحُدُودَ
u'رَتَّبَ خِلاَفَةٌ':Predicate, #4: 4	رَتَّبَ الْحُكْمَ
u'رَتَّبَ رَسُولٌ':Subject, #1: 1	رَتَّبَ الْخِلَافَةَ
u'رَتَّبَ سائِل':Subject, #1: 1	رَتَّبَ رَسُولُ
u'رَتَّبَ سَائِلٌ':Subject, #1: 1	رَتَّبَ السَّائِلُ
u'رَتَّبَ سُجُودٌ':Predicate, #1: 1	رَتَّبَ السَّائِلُ
u'رَتَّبَ شَرْعٌ':Subject, #1: 1	رَتَّبَ السُّجُودَ
u'رَتَّبَ صِحَّةٌ':Predicate, #2: 2	رَتَّبَ الشَّرْعُ
u'رَتَّبَ عَدَمٌ':Predicate, #2: 2	رَتَّبَ صِحَّةَ
u'رَتَّبَ عَمَلٌ':Predicate, #1: 1	رَتَّبَ عَدَمَ
u'رَتَّبَ قِرَاءةٌ':Predicate, #1: 1	رَتَّبَ الْعَمَلَ
u'رَتَّبَ قَطْعٌ':Predicate, #1: 1	رَتَّبَ الْقِرَاءَةَ
u'رَتَّبَ قِيمَةٌ':Predicate, #1: 1	رَتَّبَ الْقَطْعَ
u'رَتَّبَ مَسْأَلَةٌ':Predicate, #1: 1	رَتَّبَ الْقِيمَةَ
u'رَتَّبَ مَقَادِيرُ':Predicate, #1: 1	رَتَّبَ الْمَسْأَلَةَ
u'رَتَّبَ مَنْعٌ':Predicate, #1: 1	رَتَّبَ مَقَادِيرَ
u'رَتَّبَ مَوَارِيثُ':Predicate, #1: 1	رَتَّبَ مَنْعَ
u'رَتَّبَ هَدِيٌّ':Predicate, #1: 1	رَتَّبَ الْمَوَارِيثَ
u'رَتَّبَ هَدِيَّةٌ':Predicate, #1: 1	رَتَّبَ الْهَدِيَّةَ
u'رَتَّبَ وَاقِفٌ':Subject, #1: 1	رَتَّبَ الْهَدِيَّةَ
u'رَتَّبَ وُجُوبٌ':Predicate, #1: 1	رَتَّبَ الْوَاقِفُ
u'رَتَّبَ وَصْفٌ':Predicate, #1: 1	رَتَّبَ وُجُوبَ
u'رَتَّبَ يَمِينٌ':Predicate, #1: 1	رَتَّبَ وَصْفَ
u'رَتَعَ حول':Predicate, #1: 1	رَتَّبَ الْيَمِينَ
u'رَتَعَ حَوْلٌ':Predicate, #3: 3	رَتَعَ حَوْلَ
u'رَتْقٌ خَصْمٌ':Added, #3: 3	رَتَعَ حَوْلَ
u'رِثَاءٌ فلان':Added, #1: 1	رَتْقَ خَصْمٍ
u'رِثَاءٌ كَعْبٌ':Added, #2: 2	رِثَاءِ جَعْفَرٍ
u'رَجاء اِبْنٌ':Added, #1: 1	رِثَاءُ كَعْبٍ
u'رَجَاءٌ اِبْنٌ':Added, #1: 1	رَجَاءِ ابْنِ
u'رَجاء إِجَابَةٌ':Added, #1: 1	رَجَاءِ ابْنِ
u'رَجَاءٌ إِجَابَةٌ':Added, #1: 1	رَجَاءَ الْإِجَابَةِ
u'رَجاء إِجَابَةٌ':Added, #1: 1	رَجَاءَ الْإِجَابَةِ
u'رَجَاءٌ إِجَابَةٌ':Added, #2: 2	رَجَاءَ الإِجَابَةِ
u'رَجاء إجَازَةٌ':Added, #2: 2	رَجَاءَ الإِجَابَةِ
u'رَجَاءٌ إجَازَةٌ':Added, #8: 8	رَجَاءِ الْإِجَازَةِ
u'رَجاء أَجْرٌ':Added, #8: 8	رَجَاءِ الْإِجَازَةِ
u'رَجَاءٌ أَجْرٌ':Added, #1: 1	رَجَاءَ الأَجْرِ
u'رَجاء أَدَاءٌ':Added, #1: 1	رَجَاءَ الأَجْرِ
u'رَجَاءٌ أَدَاءٌ':Added, #1: 1	رَجَاءَ الْأَدَاءِ
u'رَجاء اِسْتِقْرارٌ':Added, #1: 1	رَجَاءَ الْأَدَاءِ
u'رَجَاءٌ اِسْتِقْرارٌ':Added, #1: 1	رَجَاءَ اسْتِقْرَارِ
u'رَجاء إِسْلامٌ':Added, #1: 1	رَجَاءَ اسْتِقْرَارِ
u'رَجَاءٌ إِسْلامٌ':Added, #1: 1	رَجَاءَ إِسْلاَمِهِ
u'رَجاء إِسْلامٌ':Added, #1: 1	رَجَاءَ إِسْلاَمِهِ
u'رَجَاءٌ إِسْلامٌ':Added, #1: 1	رَجَاءَ الْإِسْلَامِ
u'رَجاء إِسْلامٌ':Added, #1: 1	رَجَاءَ الْإِسْلَامِ
u'رَجَاءٌ إِسْلامٌ':Added, #2: 2	رَجَاءَ إسْلَامِهِ
u'رَجاء اِنْقِطاعٌ':Added, #2: 2	رَجَاءَ إسْلَامِهِ
u'رَجَاءٌ اِنْقِطاعٌ':Added, #2: 2	رَجَاءِ انْقِطَاعِهِ
u'رَجاء بَرَكَةٌ':Added, #2: 2	رَجَاءِ انْقِطَاعِهِ
u'رَجَاءٌ بَرَكَةٌ':Added, #1: 1	رَجَاءَ بَرَكَةِ
u'رَجاء بَرَكَةٌ':Added, #1: 1	رَجَاءَ بَرَكَةِ
u'رَجَاءٌ بَرَكَةٌ':Added, #2: 2	رَجَاءَ الْبَرَكَةِ
u'رَجاء تَرْكٌ':Added, #2: 2	رَجَاءَ الْبَرَكَةِ
u'رَجَاءٌ تَرْكٌ':Added, #1: 1	رَجَاءِ تَرْكِهِ
u'رَجاء تَنْفِيذٌ':Added, #1: 1	رَجَاءِ تَرْكِهِ
u'رَجَاءٌ تَنْفِيذٌ':Added, #1: 1	رَجَاءُ تَنْفِيذِ
u'رَجاء تَوْبَةٌ':Added, #1: 1	رَجَاءُ تَنْفِيذِ
u'رَجَاءٌ تَوْبَةٌ':Added, #1: 1	رَجَاءُ تَوْبَةٍ
u'رَجاء ثَوابٌ':Added, #1: 1	رَجَاءُ تَوْبَةٍ
u'رَجَاءٌ ثَوابٌ':Added, #1: 1	رَجَاءُ الثَّوَابِ
u'رَجاء ثَوابٌ':Added, #1: 1	رَجَاءُ الثَّوَابِ
u'رَجَاءٌ ثَوابٌ':Added, #1: 1	رَجَاءُ ثَوَابٍ
u'رَجاء ثَوابٌ':Added, #1: 1	رَجَاءُ ثَوَابٍ
u'رَجَاءٌ ثَوابٌ':Added, #1: 1	رَجَاءَ ثَوَابِهِ
u'رَجاء ثَوابٌ':Added, #1: 1	رَجَاءَ ثَوَابِهِ
u'رَجَاءٌ ثَوابٌ':Added, #3: 3	رَجَاءَ الثَّوَابِ
u'رَجاء جِنَانٌ':Added, #3: 3	رَجَاءَ الثَّوَابِ
u'رَجَاءٌ جِنَانٌ':Added, #1: 1	رَجَاءَ الْجِنَانِ
u'رَجاء حُصُول':Added, #1: 1	رَجَاءَ الْجِنَانِ
u'رَجَاءٌ حُصُول':Added, #1: 1	رَجَاءَ الْحُصُولِ
u'رَجاء حُصُول':Added, #1: 1	رَجَاءَ الْحُصُولِ
u'رَجاء حُصُول':Added, #1: 1	رَجَاءَ حُصُولِ
u'رَجَاءٌ حُصُول':Added, #1: 1	رَجَاءِ حُصُولِ
u'رَجَاءٌ حُصُول':Added, #1: 1	رَجَاءَ حُصُولِ
u'رَجاء حُضورٌ':Added, #1: 1	رَجَاءِ حُصُولِ
u'رَجَاءٌ حُضورٌ':Added, #1: 1	رَجَاءِ الْحُضُورِ
u'رَجاء حُضُورٌ':Added, #1: 1	رَجَاءِ الْحُضُورِ
u'رَجَاءٌ حُضُورٌ':Added, #1: 1	رَجَاءِ الْحُضُورِ
u'رَجاء حَيَاةٌ':Added, #1: 1	رَجَاءِ الْحُضُورِ
u'رَجَاءٌ حَيَاةٌ':Added, #1: 1	رَجَاءَ حَيَاتِهِ
u'رَجاء خُرُوجٌ':Added, #1: 1	رَجَاءَ حَيَاتِهِ
u'رَجَاءٌ خُرُوجٌ':Added, #1: 1	رَجَاءَ خُرُوجِ
u'رَجاء خِفٌّ':Added, #1: 1	رَجَاءَ خُرُوجِ
u'رَجَاءٌ خِفٌّ':Added, #1: 1	رَجَاءَ خِفَّةِ
u'رَجاء خِفَّةٌ':Added, #1: 1	رَجَاءَ خِفَّةِ
u'رَجَاءٌ خِفَّةٌ':Added, #1: 1	رَجَاءَ خِفَّةِ
u'رَجاء خَيْرٌ':Added, #1: 1	رَجَاءَ خِفَّةِ
u'رَجَاءٌ خَيْرٌ':Added, #1: 1	رَجَاءُ خَيْرٍ
u'رَجاء رَاحَةٌ':Added, #1: 1	رَجَاءُ خَيْرٍ
u'رَجَاءٌ رَاحَةٌ':Added, #1: 1	رَجَاءَ الرَّاحَةِ
u'رَجاء رحمة':Added, #1: 1	رَجَاءَ الرَّاحَةِ
u'رَجَاءٌ رحمة':Added, #1: 1	رَجَاءَ الرَّحْمَةِ
u'رَجاء رَحْمَةٌ':Added, #1: 1	رَجَاءَ الرَّحْمَةِ
u'رَجَاءٌ رَحْمَةٌ':Added, #1: 1	رَجَاءَ الرَّحْمَةِ
u'رَجاء رَغْبَةٌ':Added, #1: 1	رَجَاءَ الرَّحْمَةِ
u'رَجَاءٌ رَغْبَةٌ':Added, #1: 1	رَجَاءَ رَغْبَةِ
u'رَجاء زَوالٌ':Added, #1: 1	رَجَاءَ رَغْبَةِ
u'رَجَاءٌ زَوالٌ':Added, #1: 1	رَجَاءُ الزَّوَالِ
u'رَجاء سَلاَمَةٌ':Added, #1: 1	رَجَاءُ الزَّوَالِ
u'رَجَاءٌ سَلاَمَةٌ':Added, #2: 2	رَجَاءِ السَّلَامَةِ
u'رَجاء صدق':Added, #2: 2	رَجَاءِ السَّلَامَةِ
u'رَجَاءٌ صدق':Added, #5: 5	رَجَاءُ الصِّدْقِ
u'رَجاء صِدْقٌ':Added, #5: 5	رَجَاءُ الصِّدْقِ
u'رَجَاءٌ صِدْقٌ':Added, #5: 5	رَجَاءُ الصِّدْقِ
u'رَجاء صَلاَةٌ':Added, #5: 5	رَجَاءُ الصِّدْقِ
u'رَجَاءٌ صَلاَةٌ':Added, #1: 1	رَجَاءَ الصَّلَاةِ
u'رَجاء طَمَعٌ':Added, #1: 1	رَجَاءَ الصَّلَاةِ
u'رَجَاءٌ طَمَعٌ':Added, #1: 1	رَجَاءِ طَمَعٍ
u'رَجاء ظُفْرٌ':Added, #1: 1	رَجَاءِ طَمَعٍ
u'رَجَاءٌ ظُفْرٌ':Added, #1: 1	رَجَاءَ الظُّفْرِ
u'رَجاء ظَفَرٌ':Added, #1: 1	رَجَاءَ الظُّفْرِ
u'رَجَاءٌ ظَفَرٌ':Added, #2: 2	رَجَاءَ الظَّفَرِ
u'رَجاء ظُهورٌ':Added, #2: 2	رَجَاءَ الظَّفَرِ
u'رَجَاءٌ ظُهورٌ':Added, #1: 1	رَجَاءَ ظُهُورِهِ
u'رَجاء عتق':Added, #1: 1	رَجَاءَ ظُهُورِهِ
u'رَجاء عتق':Added, #1: 1	رَجَاءُ الْعِتْقِ
u'رَجَاءٌ عتق':Added, #1: 1	رَجَاءِ الْعِتْقِ
u'رَجَاءٌ عتق':Added, #1: 1	رَجَاءُ الْعِتْقِ
u'رَجاء عِتْقٌ':Added, #1: 1	رَجَاءِ الْعِتْقِ
u'رَجاء عِتْقٌ':Added, #1: 1	رَجَاءُ الْعِتْقِ
u'رَجَاءٌ عِتْقٌ':Added, #1: 1	رَجَاءِ الْعِتْقِ
u'رَجَاءٌ عِتْقٌ':Added, #1: 1	رَجَاءُ الْعِتْقِ
u'رَجاء عَظِيم':Added, #1: 1	رَجَاءِ الْعِتْقِ
u'رَجَاءٌ عَظِيم':Added, #2: 2	رَجَاءٍ عَظِيمٍ
u'رَجاء عَفْوٌ':Added, #2: 2	رَجَاءٍ عَظِيمٍ
u'رَجَاءٌ عَفْوٌ':Added, #1: 1	رَجَاءَ الْعَفْوِ
u'رَجاء عَفْوٌ':Added, #1: 1	رَجَاءَ الْعَفْوِ
u'رَجَاءٌ عَفْوٌ':Added, #2: 2	رَجَاءِ الْعَفْوِ
u'رَجاء عَوْدٌ':Added, #2: 2	رَجَاءِ الْعَفْوِ
u'رَجَاءٌ عَوْدٌ':Added, #2: 2	رَجَاءَ الْعَوْدِ
u'رَجاء عَوْنٌ':Added, #2: 2	رَجَاءَ الْعَوْدِ
u'رَجَاءٌ عَوْنٌ':Added, #1: 1	رَجَاءَ الْعَوْنِ
u'رَجاء فَضْلٌ':Added, #1: 1	رَجَاءَ الْعَوْنِ
u'رَجَاءٌ فَضْلٌ':Added, #1: 1	رَجَاءُ الْفَضْلِ
u'رَجاء قَبُولٌ':Added, #1: 1	رَجَاءُ الْفَضْلِ
u'رَجَاءٌ قَبُولٌ':Added, #1: 1	رَجَاءُ قَبُولِ
u'رَجاء كَثْرَةٌ':Added, #1: 1	رَجَاءُ قَبُولِ
u'رَجَاءٌ كَثْرَةٌ':Added, #1: 1	رَجَاءَ كَثْرَةِ
u'رَجاء مَرِيضٌ':Added, #1: 1	رَجَاءَ كَثْرَةِ
u'رَجَاءٌ مَرِيضٌ':Added, #1: 1	رَجَاءُ الْمَرِيضِ
u'رَجاء مَعْرِفَةٌ':Added, #1: 1	رَجَاءُ الْمَرِيضِ
u'رَجاء مَعْرِفَةٌ':Added, #1: 1	رَجَاءُ مَعْرِفَتِهِ
u'رَجاء مَعْرِفَة':Added, #1: 1	رَجَاءِ مَعْرِفَتِهِ
u'رَجاء مَعْرِفَة':Added, #1: 1	رَجَاءُ مَعْرِفَتِهِ
u'رَجَاءٌ مَعْرِفَةٌ':Added, #1: 1	رَجَاءِ مَعْرِفَتِهِ
u'رَجَاءٌ مَعْرِفَةٌ':Added, #1: 1	رَجَاءُ مَعْرِفَتِهِ
u'رَجَاءٌ مَعْرِفَة':Added, #1: 1	رَجَاءِ مَعْرِفَتِهِ
u'رَجَاءٌ مَعْرِفَة':Added, #1: 1	رَجَاءُ مَعْرِفَتِهِ
u'رَجاء مَوْتٌ':Added, #1: 1	رَجَاءِ مَعْرِفَتِهِ
u'رَجَاءٌ مَوْتٌ':Added, #1: 1	رَجَاءِ مَوْتِهِ
u'رَجاء مَوْعُودٌ':Added, #1: 1	رَجَاءِ مَوْتِهِ
u'رَجَاءٌ مَوْعُودٌ':Added, #1: 1	رَجَاءِ الْمَوْعُودِ
u'رَجاء نجاة':Added, #1: 1	رَجَاءِ الْمَوْعُودِ
u'رَجَاءٌ نجاة':Added, #1: 1	رَجَاءَ النَّجَاةِ
u'رَجاء نَجَاةٌ':Added, #1: 1	رَجَاءَ النَّجَاةِ
u'رَجَاءٌ نَجَاةٌ':Added, #1: 1	رَجَاءَ النَّجَاةِ
u'رَجاء نُكُولٌ':Added, #1: 1	رَجَاءَ النَّجَاةِ
u'رَجَاءٌ نُكُولٌ':Added, #1: 1	رَجَاءُ النُّكُولِ
u'رَجاء وُجُودٌ':Added, #1: 1	رَجَاءُ النُّكُولِ
u'رَجَاءٌ وُجُودٌ':Added, #1: 1	رَجَاءَ وُجُودِ
u'رَجاء وُصُولٌ':Added, #1: 1	رَجَاءَ وُجُودِ
u'رَجَاءٌ وُصُولٌ':Added, #4: 4	رَجَاءَ الْوُصُولِ
u'رَجَا إِجَابَةٌ':Predicate, #4: 4	رَجَاءَ الْوُصُولِ
u'رَجَا إِسْلامٌ':Predicate, #1: 1	رَجَا الْإِجَابَةَ
u'رَجَا إمَامٌ':Subject, #1: 1	رَجَا إسْلَامَ
u'رَجَا بُرْء':Predicate, #1: 1	رَجَا الْإِمَامُ
u'رَجَا تَخْفِيفٌ':Predicate, #1: 1	رَجَا الْبُرْءَ
u'رَجَا تَكْبِير':Predicate, #2: 2	رَجَا التَّخْفِيفَ
u'رَجَا تَوَقُّعٌ':Predicate, #1: 1	رَجَا التَّكْبِيرَةَ
u'رَجَا حُصُول':Predicate, #1: 1	رَجَا تَوَقُّعَ
u'رَجَا حُضورٌ':Predicate, #1: 1	رَجَا حُصُولَ
u'رَجَا حُضُورٌ':Predicate, #1: 1	رَجَا حُضُورَ
u'رَجَا حَلالٌ':Predicate, #1: 1	رَجَا حُضُورَ
u'رَجَا زَوالٌ':Predicate, #1: 1	رَجَا الْحَلَالَ
u'رَجَا زَوالٌ':Subject, #1: 1	رَجَا زَوَالَ
u'رَجَا سَلاَمَةٌ':Predicate, #1: 1	رَجَا زَوَالُهُ
u'رَجَا عَفْوٌ':Predicate, #2: 2	رَجَا السَّلَامَةَ
u'رَجَا عَوْدٌ':Predicate, #4: 4	رَجَا الْعَفْوَ
u'رَجَا كَشْفٌ':Predicate, #1: 1	رَجَا عَوْدَ
u'رَجَا مَاءٌ':Predicate, #1: 1	رَجَا كَشْفَ
u'رَجَا نصرة':Predicate, #1: 1	رَجَا الْمَاءَ
u'رَجَا نُصْرَةٌ':Predicate, #1: 1	رَجَا نُصْرَةَ
u'رَجَا وُجُودٌ':Predicate, #1: 1	رَجَا نُصْرَةَ
u'رَجَا وَفَاءٌ':Predicate, #1: 1	رَجَا وُجُودَ
u'رَجَّحَ اِبْنٌ':Subject, #2: 2	رَجَا الْوَفَاءَ
u'رَجَّحَ أحَدٌ':Predicate, #9: 9	رَجَّحَ ابْنُ
u'رَجَّحَ أَشْهَب':Subject, #1: 1	رَجَّحَ أَحَدَ
u'رَجَّحَ أَطْهَارٌ':Predicate, #1: 1	رَجَّحَ أَشْهَبُ
u'رَجَّحَ إمَامٌ':Subject, #1: 1	رَجَّحَ الْأَطْهَارَ
u'رَجَّحَ أَوَّلُ':Predicate, #1: 1	رَجَّحَ الْإِمَامُ
u'رَجَّحَ بُخَارِيٌّ':Subject, #1: 1	رَجَّحَ الْأَوَّلَ
u'رَجَّحَ بَعْضٌ':Subject, #1: 1	رَجَّحَ الْبُخَارِيُّ
u'رَجَّحَ تَخْيِيرٌ':Predicate, #1: 1	رَجَّحَ بَعْضُ
u'رَجَّحَ ثَانِي':Predicate, #1: 1	رَجَّحَ التَّخْيِيرَ
u'رَجَّحَ ثُبُوتٌ':Predicate, #1: 1	رَجَّحَ الثَّانِيَ
u'رَجَّحَ جَمَاعَةٌ':Subject, #1: 1	رَجَّحَ ثُبُوتَ
u'رَجَّحَ جَمْعٌ':Subject, #1: 1	رَجَّحَ جَمَاعَةٌ
u'رَجَّحَ جِهَةٌ':Predicate, #1: 1	رَجَّحَ جَمْعٌ
u'رَجَّحَ جَوَازٌ':Predicate, #1: 1	رَجَّحَ جِهَةَ
u'رَجَّحَ حَديثٌ':Predicate, #1: 1	رَجَّحَ جَوَازَ
u'رَجَّحَ حَمْلٌ':Predicate, #1: 1	رَجَّحَ حَدِيثَ
u'رَجَّحَ خَبَرٌ':Predicate, #1: 1	رَجَّحَ الْحَمْلَ
u'رَجَّحَ خَبَر':Predicate, #1: 1	رَجَّحَ الْخَبَرَ
u'رَجَّحَ خَيْرٌ':Subject, #1: 1	رَجَّحَ الْخَبَرَ
u'رَجَحَ خَيْرٌ':Subject, #1: 1	رَجَّحَ الْخَيْرُ
u'رَجَّحَ دَاعِي':Predicate, #2: 2	رَجَحَ خَيْرُهُ
u'رَجَحَ دَليلٌ':Subject, #1: 1	رَجَّحَ دَاعِيَةَ
u'رَجَحَ دِينٌ':Subject, #4: 4	رَجَحَ دَلِيلُهُ
u'رَجَّحَ ذكر':Predicate, #1: 1	رَجَحَ دِينُ
u'رَجَّحَ ذِكْرٌ':Predicate, #2: 2	رَجَّحَ ذِكْرَ
u'رَجَّحَ رِوايَةٌ':Predicate, #2: 2	رَجَّحَ ذِكْرَ
u'رَجَحَ سُؤَالٌ':Subject, #2: 2	رَجَّحَ رِوَايَةَ
u'رَجَّحَ شافِع':Subject, #1: 1	رَجَحَ السُّؤَالُ
u'رَجَّحَ شافِعِيّ':Subject, #1: 1	رَجَّحَ الشَّافِعِيَّةُ
u'رَجَّحَ شافِعِيّ':Subject, #1: 1	رَجَّحَ الشَّافِعِيَّةُ
u'رَجَّحَ شَرْعٌ':Subject, #5: 5	رَجَّحَ الشَّافِعِيُّ
u'رَجَّحَ شَيْخٌ':Subject, #1: 1	رَجَّحَ الشَّرْعُ
u'رَجَّحَ صَاحِبٌ':Subject, #4: 4	رَجَّحَ الشَّيْخُ
u'رَجَّحَ صَاحِبٌ':Subject, #1: 1	رَجَّحَ صَاحِبُهُ
u'رَجَّحَ صِحَّةٌ':Predicate, #2: 2	رَجَّحَ صَاحِبُ
u'رَجَّحَ عَبْدٌ':Subject, #1: 1	رَجَّحَ الصِّحَّةَ
u'رَجَّحَ عَدَمٌ':Predicate, #1: 1	رَجَّحَ عَبْدُ
u'رَجَّحَ عُرُوضٌ':Predicate, #2: 2	رَجَّحَ عَدَمَ
u'رَجَّحَ عَفْوٌ':Predicate, #1: 1	رَجَّحَ الْعُرُوضَ
u'رَجَّحَ فلان':Subject, #1: 1	رَجَّحَ الْعَفْوَ
u'رَجَّحَ فلان':Subject, #1: 1	رَجَّحَ الشَّافِعِيَّةُ
u'رَجَّحَ قَاصِرٌ':Predicate, #5: 5	رَجَّحَ الشَّافِعِيُّ
u'رَجَّحَ قول':Predicate, #1: 1	رَجَّحَ الْقَاصِرَةَ
u'رَجَّحَ قَوْلٌ':Predicate, #4: 4	رَجَّحَ قَوْلَ
u'رَجَّحَ كَثِيرٌ':Subject, #4: 4	رَجَّحَ قَوْلَ
u'رَجَّحَ لُزُومٌ':Predicate, #1: 1	رَجَّحَ كَثِيرُ
u'رَجَّحَ مُجْتَهِد':Subject, #1: 1	رَجَّحَ اللُّزُومَ
u'رَجَّحَ مُحَقِّقٌ':Subject, #1: 1	رَجَّحَ الْمُجْتَهِدُ
u'رَجَّحَ مُصَنِّفٌ':Subject, #2: 2	رَجَّحَ الْمُحَقِّقُ
u'رَجَّحَ مَقَالَةٌ':Predicate, #2: 2	رَجَّحَ الْمُصَنِّفُ
u'رَجَّحَ نَوَوِيٌّ':Subject, #1: 1	رَجَّحَ مَقَالَةَ
u'رَجَّحَ وَالِدٌ':Subject, #3: 3	رَجَّحَ النَّوَوِيُّ
u'رَجَّحَ وَجْهٌ':Predicate, #1: 1	رَجَّحَ وَالِدُهُ
u'رَجَّحَ وَزْنٌ':Predicate, #1: 1	رَجَّحَ الْوَجْهَ
u'رَجَعَ أَبٌ':Subject, #1: 1	رَجَّحَ الْوَزْنَ
u'رَجَعَ اِبْنٌ':Subject, #6: 6	رَجَعَ الْأَبُ
u'رَجَعَ اِبْنٌ':Subject, #2: 2	رَجَعَ ابْنُهُ
u'رَجَعَ أَجْنَبِيٌّ':Subject, #9: 9	رَجَعَ ابْنُ
u'رَجَعَ أَجِيرٌ':Subject, #1: 1	رَجَعَ الْأَجْنَبِيُّ
u'رَجَعَ أحَدٌ':Subject, #1: 1	رَجَعَ الْأَجِيرُ
u'رَجَعَ أدَب':Subject, #24: 24	رَجَعَ أَحَدُ
u'رَجَعَ أَرْبَعَةٌ':Subject, #1: 1	رَجَعَ الْأَدَبُ
u'رَجَعَ أَرْبَعَةٌ':Subject, #1: 1	رَجَعَ أَرْبَعَةٌ
u'رَجَعَ أَصْحَابٌ':Subject, #2: 2	رَجَعَ الْأَرْبَعَةُ
u'رَجَعَ أُصولٌ':Subject, #2: 2	رَجَعَ الْأَصْحَابُ
u'رَجَعَ أَعْجَميٌّ':Subject, #8: 8	رَجَعَ الْأُصُولُ
u'رَجَعَ أَعْلاَمٌ':Subject, #1: 1	رَجَعَ الْأَعْجَمِيُّ
u'رَجَعَ أكل':Predicate, #1: 1	رَجَعَ أَعْلَامُ
u'رَجَعَ إمَامٌ':Subject, #1: 1	رَجَعَ أَكَلَ
u'رَجَعَ آمِرٌ':Subject, #10: 10	رَجَعَ الْإِمَامُ
u'رَجَعَ أَمْرٌ':Subject, #1: 1	رَجَعَ الْآمِرُ
u'رَجَعَ أَمْرٌ':Subject, #1: 1	رَجَعَ الأَمْرُ
u'رَجَعَ أهْلٌ':Subject, #4: 4	رَجَعَ الْأَمْرُ
u'رَجَعَ أَوَّلُ':Subject, #2: 2	رَجَعَ أَهْلُ
u'رَجَعَ أَوْلِيَاءُ':Subject, #12: 12	رَجَعَ الْأَوَّلُ
u'رَجَعَ بادِئٌ':Subject, #2: 2	رَجَعَ أَوْلِيَاءُ
u'رَجَعَ بَارِزٌ':Subject, #1: 1	رَجَعَ الْبَادِئُ
u'رَجَعَ بَاعَةٌ':Subject, #1: 1	رَجَعَ الْبَارِزُ
u'رَجَعَ بَائِعٌ':Subject, #2: 2	رَجَعَ الْبَاعَةُ
u'رَجَعَ بَحْثٌ':Subject, #22: 22	رَجَعَ الْبَائِعُ
u'رَجَعَ بَطَلٌ':Predicate, #1: 1	رَجَعَ الْبَحْثُ
u'رَجَعَ بَطْنٌ':Subject, #3: 3	رَجَعَ بَطَلَ
u'رَجَعَ بَعْضٌ':Subject, #1: 1	رَجَعَ الْبَطْنُ
u'رَجَعَ بَعيدٌ':Subject, #1: 1	رَجَعَ بَعْضُ
u'رَجَعَ بَقِيَّةٌ':Subject, #1: 1	رَجَعَ الْبَعِيدُ
u'رَجَعَ بَيْعٌ':Subject, #1: 1	رَجَعَ بَقِيَّةُ
u'رَجَعَ بَيْنٌ':Predicate, #1: 1	رَجَعَ الْبَيْعُ
u'رجعة أمَةٌ':Added, #2: 2	رَجَعَ بَيْنَ
u'رَجْعَةٌ أمَةٌ':Added, #1: 1	رَجْعَةَ الْأَمَةِ
u'رجعة أمَةٌ':Added, #1: 1	رَجْعَةَ الْأَمَةِ
u'رَجْعَةٌ أمَةٌ':Added, #1: 1	رَجْعَةُ أَمَةٍ
u'رجعة حاكِمٌ':Added, #1: 1	رَجْعَةُ أَمَةٍ
u'رَجْعَةٌ حاكِمٌ':Added, #1: 1	رَجْعَةِ الْحَاكِمِ
u'رجعة رَجْعِيٌّ':Added, #1: 1	رَجْعَةِ الْحَاكِمِ
u'رَجْعَةٌ رَجْعِيٌّ':Added, #2: 2	رَجْعَةُ الرَّجْعِيَّةِ
u'رجعة رَجْعِيَّةٌ':Added, #2: 2	رَجْعَةُ الرَّجْعِيَّةِ
u'رَجْعَةٌ رَجْعِيَّةٌ':Added, #2: 2	رَجْعَةُ الرَّجْعِيَّةِ
u'رجعة زَوْجٌ':Added, #2: 2	رَجْعَةُ الرَّجْعِيَّةِ
u'رَجْعَةٌ زَوْجٌ':Added, #1: 1	رَجْعَةُ الزَّوْجِ
u'رجعة زَوْجٌ':Added, #1: 1	رَجْعَةُ الزَّوْجِ
u'رَجْعَةٌ زَوْجٌ':Added, #2: 2	رَجْعَةِ الزَّوْجِ
u'رجعة مَجْنُونٌ':Added, #2: 2	رَجْعَةِ الزَّوْجِ
u'رَجْعَةٌ مَجْنُونٌ':Added, #1: 1	رَجْعَةُ الْمَجْنُونِ
u'رجعة مُعْسِرٌ':Added, #1: 1	رَجْعَةُ الْمَجْنُونِ
u'رَجْعَةٌ مُعْسِرٌ':Added, #1: 1	رَجْعَةِ الْمُعْسِرِ
u'رجعة واحد':Added, #1: 1	رَجْعَةِ الْمُعْسِرِ
u'رجعة وَاحِدٌ':Added, #2: 2	رَجْعَةٍ وَاحِدَةٍ
u'رَجْعَةٌ واحد':Added, #2: 2	رَجْعَةٍ وَاحِدَةٍ
u'رَجْعَةٌ وَاحِدٌ':Added, #2: 2	رَجْعَةٍ وَاحِدَةٍ
u'رَجَعَ ثَالِثٌ':Subject, #2: 2	رَجْعَةٍ وَاحِدَةٍ
u'رَجَعَ ثَالِثٌ':Subject, #3: 3	رَجَعَ الثَّالِثُ
u'رَجَعَ ثَانِي':Predicate, #3: 3	رَجَعَ ثَالِثٌ
u'رَجَعَ ثَمَنٌ':Subject, #1: 1	رَجَعَ ثَانِيَةً
u'رَجَعَ ثَوْبٌ':Subject, #1: 1	رَجَعَ الثَّمَنُ
u'رَجَعَ جَارٌ':Subject, #1: 1	رَجَعَ الثَّوْبُ
u'رَجَعَ جَازٌ':Predicate, #1: 1	رَجَعَ الْجَارُ
u'رَجَعَ جَمِيع':Subject, #10: 10	رَجَعَ جَازَ
u'رَجَعَ جَوَابٌ':Subject, #5: 5	رَجَعَ الْجَمِيعُ
u'رَجَعَ جَوَازٌ':Subject, #1: 1	رَجَعَ الْجَوَابُ
u'رَجَعَ حاصِلٌ':Subject, #1: 1	رَجَعَ الْجَوَازُ
u'رَجَعَ حالٌ':Subject, #1: 1	رَجَعَ حَاصِلُ
u'رَجَعَ حائِطٌ':Subject, #1: 1	رَجَعَ الْحَالُ
u'رَجْعٌ حَديثٌ':Added, #1: 1	رَجَعَ الْحَائِطُ
u'رَجَعَ حَقٌّ':Subject, #1: 1	رَجْعُ الْحَدِيثِ
u'رَجَعَ حَقٌّ':Subject, #1: 1	رَجَعَ الْحَقُّ
u'رَجَعَ حُقوقٌ':Subject, #1: 1	رَجَعَ حَقُّهُ
u'رَجَعَ حُقُوقٌ':Subject, #1: 1	رَجَعَ الْحُقُوقُ
u'رَجَعَ حُكْمٌ':Subject, #1: 1	رَجَعَ الْحُقُوقُ
u'رَجَعَ خامس':Subject, #1: 1	رَجَعَ الْحُكْمُ
u'رَجَعَ خَامِسٌ':Subject, #1: 1	رَجَعَ الْخَامِسُ
u'رَجَعَ خَتَنٌ':Subject, #1: 1	رَجَعَ الْخَامِسُ
u'رَجَعَ خَصْمٌ':Subject, #1: 1	رَجَعَ الْخَتَنُ
u'رَجَعَ خِلاَفٌ':Subject, #1: 1	رَجَعَ الْخَصْمُ
u'رَجَعَ خَلَلٌ':Subject, #1: 1	رَجَعَ الْخِلَافُ
u'رَجَعَ خَمْسَةٌ':Subject, #1: 1	رَجَعَ الْخَلَلُ
u'رَجَعَ خيار':Subject, #2: 2	رَجَعَ الْخَمْسَةُ
u'رَجَعَ خِيَارٌ':Subject, #1: 1	رَجَعَ خِيَارُ
u'رَجَعَ دَافِعٌ':Subject, #1: 1	رَجَعَ خِيَارُ
u'رَجَعَ دُعَاءٌ':Subject, #2: 2	رَجَعَ الدَّافِعُ
u'رَجَعَ رابع':Subject, #1: 1	رَجَعَ الدُّعَاءُ
u'رَجَعَ رَابِعٌ':Subject, #3: 3	رَجَعَ الرَّابِعُ
u'رَجَعَ رَاهِنٌ':Subject, #3: 3	رَجَعَ الرَّابِعُ
u'رَجَعَ رَبُّ':Subject, #5: 5	رَجَعَ الرَّاهِنُ
u'رَجَعَ رَبِيعَةٌ':Subject, #3: 3	رَجَعَ رَبُّ
u'رَجَعَ رِجَالٌ':Subject, #1: 1	رَجَعَ رَبِيعَةُ
u'رَجَعَ رَجُلٌ':Subject, #2: 2	رَجَعَ الرِّجَالُ
u'رَجَعَ رَجُلٌ':Subject, #12: 12	رَجَعَ الرَّجُلُ
u'رَجَعَ رَدٌّ':Predicate, #13: 13	رَجَعَ رَجُلٌ
u'رَجَعَ رَسُولٌ':Subject, #3: 3	رَجَعَ رَدَّ
u'رَجَعَ زائِدٌ':Subject, #27: 27	رَجَعَ رَسُولُ
u'رَجَعَ زَرْعٌ':Subject, #1: 1	رَجَعَ الزَّائِدُ
u'رَجَعَ زَوْجٌ':Subject, #2: 2	رَجَعَ الزَّرْعُ
u'رَجَعَ زَيْدٌ':Subject, #20: 20	رَجَعَ الزَّوْجُ
u'رَجَعَ سادس':Subject, #2: 2	رَجَعَ زَيْدٌ
u'رَجَعَ سَادِسٌ':Subject, #1: 1	رَجَعَ سَادِسٌ
u'رَجَعَ سَائِرٌ':Subject, #1: 1	رَجَعَ سَادِسٌ
u'رَجَعَ سَعْدٌ':Subject, #2: 2	رَجَعَ سَائِرُ
u'رَجَعَ سَعْدٌ':Subject, #1: 1	رَجَعَ سَعْدٌ
u'رَجَعَ سقط':Predicate, #1: 1	رَجَعَ سَعْدُ
u'رَجَعَ سَقَطٌ':Predicate, #4: 4	رَجَعَ سَقَطَ
u'رَجَعَ سِنٌّ':Subject, #4: 4	رَجَعَ سَقَطَ
u'رَجَعَ سَهْمٌ':Subject, #1: 1	رَجَعَ سِنُّهُ
u'رَجَعَ سَواءٌ':Subject, #1: 1	رَجَعَ السَّهْمُ
u'رَجَعَ سَيِّدٌ':Subject, #2: 2	رَجَعَ سَوَاءٌ
u'رَجَعَ شَارِعٌ':Subject, #5: 5	رَجَعَ السَّيِّدُ
u'رَجَعَ شافِعِيّ':Subject, #1: 1	رَجَعَ الشَّارِعُ
u'رَجَعَ شَاهِدٌ':Subject, #4: 4	رَجَعَ الشَّافِعِيُّ
u'رَجَعَ شَاهِدٌ':Subject, #11: 11	رَجَعَ الشَّاهِدُ
u'رَجَعَ شَرِيكٌ':Subject, #8: 8	رَجَعَ شَاهِدُ
u'رَجَعَ شَرِيكٌ':Subject, #1: 1	رَجَعَ شَرِيكُهُ
u'رَجَعَ شَطْرٌ':Subject, #3: 3	رَجَعَ الشَّرِيكُ
u'رَجَعَ شُعْبَةٌ':Subject, #1: 1	رَجَعَ الشَّطْرُ
u'رَجَعَ شَفِيعٌ':Subject, #1: 1	رَجَعَ شُعْبَةُ
u'رَجَعَ شهداء':Subject, #5: 5	رَجَعَ الشَّفِيعُ
u'رَجَعَ شُهُودٌ':Subject, #1: 1	رَجَعَ الشُّهَدَاءُ
u'رَجَعَ شُهُودٌ':Subject, #25: 25	رَجَعَ الشُّهُودُ
u'رَجَعَ شُهُودٌ':Subject, #2: 2	رَجَعَ شُهُودٌ
u'رَجَعَ شَيْخٌ':Subject, #42: 42	رَجَعَ شُهُودُ
u'رَجَعَ صَاحِبٌ':Subject, #2: 2	رَجَعَ الشَّيْخُ
u'رَجَعَ صَاحِبٌ':Subject, #13: 13	رَجَعَ صَاحِبُ
u'رَجَعَ صَيْدٌ':Subject, #3: 3	رَجَعَ صَاحِبُهُ
u'رَجَعَ صَيْرَفِيٌّ':Subject, #1: 1	رَجَعَ الصَّيْدُ
u'رَجَعَ ضَامِنٌ':Subject, #2: 2	رَجَعَ الصَّيْرَفِيُّ
u'رَجَعَ ضَمِنٌ':Predicate, #1: 1	رَجَعَ الضَّامِنُ
u'رَجَعَ ضَمِيرٌ':Subject, #1: 1	رَجَعَ ضَمِنَ
u'رَجَعَ طَالِبٌ':Subject, #3: 3	رَجَعَ الضَّمِيرُ
u'رَجَعَ عَادٌ':Predicate, #3: 3	رَجَعَ الطَّالِبُ
u'رَجَعَ عَاصِمٌ':Subject, #2: 2	رَجَعَ عَادَ
u'رَجَعَ عَامِلٌ':Subject, #1: 1	رَجَعَ عَاصِمٌ
u'رَجَعَ عَبْدٌ':Subject, #1: 1	رَجَعَ الْعَامِلُ
u'رَجَعَ عجز':Predicate, #10: 10	رَجَعَ الْعَبْدُ
u'رَجَعَ عَدْلٌ':Subject, #1: 1	رَجَعَ عَجَزَ
u'رَجَعَ عَقِبٌ':Predicate, #2: 2	رَجَعَ الْعَدْلُ
u'رَجَعَ عَقْلٌ':Subject, #1: 1	رَجَعَ عَقِبَ
u'رَجَعَ علم':Subject, #1: 1	رَجَعَ الْعَقْلُ
u'رَجَعَ عِلْمٌ':Subject, #1: 1	رَجَعَ عِلْمُهُ
u'رَجَعَ عُمَرٌ':Subject, #1: 1	رَجَعَ عِلْمُهُ
u'رَجَعَ عند':Predicate, #3: 3	رَجَعَ عُمَرُ
u'رَجَعَ عِوَضٌ':Subject, #9: 9	رَجَعَ عِنْدَ
u'رَجَعَ غَاصِبٌ':Subject, #1: 1	رَجَعَ الْعِوَضُ
u'رَجَعَ غَائِبٌ':Subject, #5: 5	رَجَعَ الْغَاصِبُ
u'رَجَعَ غرماء':Subject, #6: 6	رَجَعَ الْغَائِبُ
u'رَجَعَ غَرِيمٌ':Subject, #2: 2	رَجَعَ الْغُرَمَاءُ
u'رَجَعَ غضب':Subject, #6: 6	رَجَعَ الْغَرِيمُ
u'رَجَعَ غَضَبٌ':Subject, #1: 1	رَجَعَ غَضَبُهُ
u'رَجَعَ غير':Predicate, #1: 1	رَجَعَ غَضَبُهُ
u'رَجَعَ غَيْرٌ':Predicate, #2: 2	رَجَعَ غَيْرَ
u'رَجَعَ غير':Subject, #2: 2	رَجَعَ غَيْرَ
u'رَجَعَ غَيْرٌ':Subject, #1: 1	رَجَعَ غَيْرُهُ
u'رَجَعَ فُرُوعٌ':Subject, #1: 1	رَجَعَ غَيْرُهُ
u'رَجَعَ فُرُوعٌ':Subject, #2: 2	رَجَعَ الْفُرُوعُ
u'رَجَعَ فِسْقٌ':Subject, #2: 2	رَجَعَ فُرُوعٌ
u'رَجَعَ فقراء':Subject, #1: 1	رَجَعَ الْفِسْقُ
u'رَجَعَ فلان':Subject, #1: 1	رَجَعَ فُقَرَاءُ
u'رَجَعَ فلان':Subject, #1: 1	رَجَعَ بِلَالٌ
u'رَجَعَ فُلاَنٌ':Subject, #1: 1	رَجَعَ عُثْمَانُ
u'رَجَعَ فلان':Subject, #1: 1	رَجَعَ فُلَانٌ
u'رَجَعَ قَالٌ':Predicate, #4: 4	رَجَعَ الشَّافِعِيُّ
u'رَجَعَ قَالٌ':Predicate, #12: 12	رَجَعَ قَالَ
u'رَجَعَ قُرْآنٌ':Subject, #2: 2	رَجَعَ قَالَهُنَّ
u'رَجَعَ قَرِيبٌ':Subject, #2: 2	رَجَعَ الْقُرْآنُ
u'رَجَعَ قول':Subject, #2: 2	رَجَعَ الْقَرِيبُ
u'رَجَعَ قَوْلٌ':Subject, #1: 1	رَجَعَ الْقَوْلُ
u'رَجَعَ قول':Subject, #1: 1	رَجَعَ الْقَوْلُ
u'رَجَعَ قَوْلٌ':Subject, #1: 1	رَجَعَ قَوْلُهُ
u'رَجَعَ قَوْمٌ':Subject, #1: 1	رَجَعَ قَوْلُهُ
u'رَجَعَ قَيِّمٌ':Subject, #2: 2	رَجَعَ قَوْمٌ
u'رَجَعَ كَعْبٌ':Subject, #1: 1	رَجَعَ الْقَيِّمُ
u'رَجَعَ كَفِيلٌ':Subject, #1: 1	رَجَعَ كَعْبُ
u'رَجَعَ كَلْبٌ':Subject, #11: 11	رَجَعَ الْكَفِيلُ
u'رَجَعَ مَاءٌ':Subject, #1: 1	رَجَعَ الْكَلْبُ
u'رَجَعَ مَالٌ':Subject, #3: 3	رَجَعَ الْمَاءُ
u'رَجَعَ مَالِكٌ':Subject, #1: 1	رَجَعَ الْمَالُ
u'رَجَعَ مَالِكٌ':Subject, #20: 20	رَجَعَ مَالِكٌ
u'رَجَعَ مَأْمُورٌ':Subject, #6: 6	رَجَعَ الْمَالِكُ
u'رَجَعَ مُبَارِزٌ':Subject, #3: 3	رَجَعَ الْمَأْمُورُ
u'رَجَعَ مُبْتاع':Subject, #1: 1	رَجَعَ الْمُبَارِزُ
u'رَجَعَ مُبِيحٌ':Subject, #1: 1	رَجَعَ الْمُبْتَاعُ
u'رَجَعَ مَبِيعٌ':Subject, #1: 1	رَجَعَ الْمُبِيحُ
u'رَجَعَ مُتَبَرِّعٌ':Subject, #1: 1	رَجَعَ الْمَبِيعُ
u'رَجَعَ مُتَطَوِّعٌ':Subject, #3: 3	رَجَعَ الْمُتَبَرِّعُ
u'رَجَعَ مُجْتَهِد':Subject, #2: 2	رَجَعَ الْمُتَطَوِّعُ
u'رَجَعَ مُحْتَالٌ':Subject, #1: 1	رَجَعَ الْمُجْتَهِدُ
u'رَجَعَ مُحَكَّمٌ':Subject, #3: 3	رَجَعَ الْمُحْتَالُ
u'رَجَعَ مُحَمَّدٌ':Subject, #1: 1	رَجَعَ الْمُحَكَّمُ
u'رَجَعَ مُحِيل':Subject, #11: 11	رَجَعَ مُحَمَّدٌ
u'رَجَعَ مَدْفُوعٌ':Subject, #1: 1	رَجَعَ الْمُحِيلُ
u'رَجَعَ مُرْتَدٌّ':Subject, #1: 1	رَجَعَ الْمَدْفُوعُ
u'رَجَعَ مُرْتَهِنٌ':Subject, #4: 4	رَجَعَ الْمُرْتَدُّ
u'رَجَعَ مُزَارِعٌ':Subject, #8: 8	رَجَعَ الْمُرْتَهِنُ
u'رَجَعَ مُسَافِرٌ':Subject, #1: 1	رَجَعَ الْمُزَارِعُ
u'رَجَعَ مُسْتَأْجِرٌ':Subject, #1: 1	رَجَعَ الْمُسَافِرُ
u'رَجَعَ مُسْتَحِقٌّ':Subject, #3: 3	رَجَعَ الْمُسْتَأْجِرُ
u'رَجَعَ مُسْلِمٌ':Subject, #1: 1	رَجَعَ الْمُسْتَحِقُّ
u'رَجَعَ مَشْهُودٌ':Subject, #1: 1	رَجَعَ الْمُسْلِمُ
u'رَجَعَ مُصَالِحٌ':Subject, #2: 2	رَجَعَ الْمَشْهُودُ
u'رَجْعٌ مَصَالِحُ':Added, #2: 2	رَجَعَ الْمُصَالِحُ
u'رَجَعَ مُضَارِبٌ':Subject, #1: 1	رَجْعُ الْمَصَالِحِ
u'رَجَعَ مُطِيعٌ':Subject, #4: 4	رَجَعَ الْمُضَارِبُ
u'رَجَعَ مُعِير':Subject, #1: 1	رَجَعَ الْمُطِيعُ
u'رَجَعَ مُعِير':Subject, #1: 1	رَجَعَ مُعِيرُهُ
u'رَجَعَ مُعِير':Subject, #2: 2	رَجَعَ مُعِيرُ
u'رَجَعَ مَغْصُوب':Subject, #8: 8	رَجَعَ الْمُعِيرُ
u'رَجَعَ مُقْرِضٌ':Subject, #2: 2	رَجَعَ الْمَغْصُوبُ
u'رَجَعَ مَقْضِيّ':Subject, #1: 1	رَجَعَ الْمُقْرِضُ
u'رَجَعَ مُكْرِهٌ':Subject, #2: 2	رَجَعَ الْمَقْضِيُّ
u'رَجَعَ مُكْرَهٌ':Subject, #1: 1	رَجَعَ الْمُكْرِهُ
u'رَجَعَ مَلَكٌ':Predicate, #3: 3	رَجَعَ الْمُكْرَهُ
u'رَجَعَ مُلْكٌ':Subject, #1: 1	رَجَعَ مَلَكَ
u'رَجَعَ مِلْكٌ':Subject, #1: 1	رَجَعَ مُلْكُ
u'رَجَعَ مُمَلِّك':Subject, #1: 1	رَجَعَ مِلْكُهُ
u'رَجْعٌ مَمْنُوعٌ':Added, #1: 1	رَجَعَ الْمُمَلِّكُ
u'رَجَعَ مُنْكِرٌ':Subject, #1: 1	رَجْعَ مَمْنُوعٍ
u'رَجَعَ مَنِيٌّ':Subject, #2: 2	رَجَعَ الْمُنْكِرُ
u'رَجَعَ مُوَكِّلٌ':Subject, #1: 1	رَجَعَ الْمَنِيُّ
u'رَجَعَ مُؤَمَّنٌ':Subject, #2: 2	رَجَعَ الْمُوَكِّلُ
u'رَجَعَ نَاسٌ':Subject, #1: 1	رَجَعَ الْمُؤَمَّنُ
u'رَجَعَ نَبِيٌّ':Subject, #1: 1	رَجَعَ النَّاسُ
u'رَجَعَ نزاع':Subject, #1: 1	رَجَعَ النَّبِيُّ
u'رَجَعَ نِزَاعٌ':Subject, #1: 1	رَجَعَ النِّزَاعُ
u'رَجَعَ نِسْوَةٌ':Subject, #1: 1	رَجَعَ النِّزَاعُ
u'رَجَعَ نَصِيبٌ':Subject, #3: 3	رَجَعَ النِّسْوَةُ
u'رَجَعَ نُقْصَانٌ':Subject, #7: 7	رَجَعَ نَصِيبُهُ
u'رَجَعَ نَهْيٌ':Subject, #1: 1	رَجَعَ النُّقْصَانُ
u'رَجَعَ واحد':Subject, #1: 1	رَجَعَ النَّهْيُ
u'رَجَعَ وَاحِدٌ':Subject, #32: 32	رَجَعَ وَاحِدٌ
u'رَجَعَ وَارِثٌ':Subject, #32: 32	رَجَعَ وَاحِدٌ
u'رَجَعَ وَاقِفٌ':Subject, #2: 2	رَجَعَ الْوَارِثُ
u'رَجَعَ وَالِدٌ':Subject, #1: 1	رَجَعَ الْوَاقِفُ
u'رَجَعَ وَاهِبٌ':Subject, #1: 1	رَجَعَ الْوَالِدُ
u'رَجَعَ وَتَرٌ':Predicate, #22: 22	رَجَعَ الْوَاهِبُ
u'رَجَعَ وَرَثَةٌ':Subject, #1: 1	رَجَعَ وَتَرَكَ
u'رَجَعَ وَفْدٌ':Subject, #2: 2	رَجَعَ الْوَرَثَةُ
u'رَجَعَ وَقْتٌ':Predicate, #1: 1	رَجَعَ الْوَفْدُ
u'رَجَعَ وَقْفٌ':Subject, #1: 1	رَجَعَ وَقْتَ
u'رَجَعَ وَكِيلٌ':Subject, #1: 1	رَجَعَ الْوَقْفُ
u'رَجَعَ وَلاَءٌ':Subject, #8: 8	رَجَعَ الْوَكِيلُ
u'رَجَعَ وَلاَءٌ':Subject, #2: 2	رَجَعَ الْوَلاَءُ
u'رَجَعَ وَلِيٌّ':Subject, #3: 3	رَجَعَ الْوَلَاءُ
u'رَجَعَ وَلِيٌّ':Subject, #1: 1	رَجَعَ وَلِيٌّ
u'رَجَعَ وَلِيٌّ':Subject, #1: 1	رَجَعَ وَلِيُّ
u'رَجَعَ يَعْقُوبٌ':Subject, #6: 6	رَجَعَ الْوَلِيُّ
u'رَجَّلَ أحَدٌ':Predicate, #2: 2	رَجَعَ يَعْقُوبُ
u'رَجْلٌ حَيَوَانٌ':Added, #1: 1	رَجَّلَ أَحَدَ
u'رَجْمٌ الْمَرْأَةُ':Added, #1: 1	رَجْلِ حَيَوَانِ
u'رَجَمَ إمَامٌ':Subject, #2: 2	رَجْمِ الْمَرْأَةِ
u'رَجْمٌ أمَةٌ':Added, #3: 3	رَجَمَ الْإِمَامُ
u'رَجْمٌ ثَيِّبٌ':Added, #1: 1	رَجْمِ أَمَةٍ
u'رَجْمٌ ثَيِّبٌ':Added, #1: 1	رَجْمُ الثَّيِّبِ
u'رَجَمَ حاكِمٌ':Subject, #1: 1	رَجْمِ الثَّيِّبِ
u'رَجْمٌ ذِمِّيٌّ':Added, #1: 1	رَجَمَ الْحَاكِمُ
u'رَجَمَ رَجُلٌ':Predicate, #1: 1	رَجْمُ الذِّمِّيِّ
u'رَجَمَ رَجُلٌ':Subject, #1: 1	رَجَمَ رَجُلاً
u'رَجَمَ رَسُولٌ':Subject, #1: 1	رَجَمَ رَجُلٌ
u'رَجْمٌ سِرٌّ':Added, #7: 7	رَجَمَ رَسُولُ
u'رَجْمٌ ظُنونٌ':Added, #1: 1	رَجْمُ سِرٍّ
u'رَجَمَ فلان':Predicate, #1: 1	رَجْمِ الظُّنُونِ
u'رَجَمَ قَوْمٌ':Subject, #1: 1	رَجَمَ الْغَامِدِيَّةَ
u'رَجْمٌ كَلْبٌ':Added, #3: 3	رَجَمَ قَوْمٌ
u'رَجَمَ مَاعِزٌ':Predicate, #2: 2	رَجْمَ الْكَلْبِ
u'رَجْمٌ مَاعِزٌ':Added, #2: 2	رَجَمَ مَاعِزَ
u'رَجْمٌ مَاعِزٌ':Added, #1: 1	رَجْمَ مَاعِزٍ
u'رَجْمٌ مُحْصَنٌ':Added, #2: 2	رَجْمِ مَاعِزٍ
u'رَجْمٌ مَفْعُولٌ':Added, #1: 1	رَجْمِ الْمُحْصَنِ
u'رَجَمَ نَبِيٌّ':Subject, #1: 1	رَجْمِ الْمَفْعُولِ
u'رَجْمٌ نَبِيٌّ':Added, #4: 4	رَجَمَ النَّبِيُّ
u'رَجْمٌ يهود':Added, #1: 1	رَجْمَ النَّبِيِّ
u'رَجْمٌ يَهُودٌ':Added, #1: 1	رَجْمِ الْيَهُودِ
u'رَجْمٌ يَهُودِيّ':Added, #1: 1	رَجْمِ الْيَهُودِ
u'رُجُوعٌ أَبٌ':Added, #2: 2	رَجْمِ يَهُودِيَّيْنِ
u'رُجُوعٌ أَبٌ':Added, #1: 1	رُجُوعَ الْأَبِ
u'رُجُوعٌ أَبٌ':Added, #4: 4	رُجُوعِ الْأَبِ
u'رُجُوعٌ اِبْنٌ':Added, #7: 7	رُجُوعُ الْأَبِ
u'رُجُوعٌ اِبْنٌ':Added, #1: 1	رُجُوعَ ابْنِ
u'رُجُوعٌ اِبْنٌ':Added, #1: 1	رُجُوعُ ابْنِ
u'رُجُوعٌ إِثْبَاتٌ':Added, #1: 1	رُجُوعِ ابْنِ
u'رُجُوعٌ أثَرٌ':Added, #1: 1	رُجُوعِ إِثْبَاتِ
u'رُجُوعٌ أحَدٌ':Added, #1: 1	رُجُوعُ أَثَرِهِ
u'رُجُوعٌ أحَدٌ':Added, #1: 1	رُجُوعَ أَحَدِ
u'رُجُوعٌ أَرْبَعَةٌ':Added, #1: 1	رُجُوعِ أَحَدِ
u'رُجُوعٌ أَشْيَاخٌ':Added, #1: 1	رُجُوعِ الْأَرْبَعَةِ
u'رُجُوعٌ أصل':Added, #1: 1	رُجُوعِ أَشْيَاخِهِ
u'رُجُوعٌ أصل':Added, #1: 1	رُجُوعَ الْأَصْلِ
u'رُجُوعٌ أصل':Added, #1: 1	رُجُوعُ الْأَصْلِ
u'رُجُوعٌ أًصْلٌ':Added, #1: 1	رُجُوعِ الْأَصْلِ
u'رُجُوعٌ أًصْلٌ':Added, #1: 1	رُجُوعَ الْأَصْلِ
u'رُجُوعٌ أًصْلٌ':Added, #1: 1	رُجُوعُ الْأَصْلِ
u'رُجُوعٌ أفاضل':Added, #1: 1	رُجُوعِ الْأَصْلِ
u'رُجُوعٌ الْمَرْءُ':Added, #1: 1	رُجُوعَ الْأَفَاضِلِ
u'رُجُوعٌ الْمَرْأَةُ':Added, #1: 1	رُجُوعِ الْمَرْءِ
u'رُجُوعٌ الْمَرْأَةُ':Added, #1: 1	رُجُوعِ الْمَرْأَةِ
u'رُجُوعٌ إمَامٌ':Added, #2: 2	رُجُوعَ الْمَرْأَةِ
u'رُجُوعٌ إمَامٌ':Added, #2: 2	رُجُوعَ الْإِمَامِ
u'رُجُوعٌ إمَامٌ':Added, #4: 4	رُجُوعُ الْإِمَامِ
u'رُجُوعٌ اِمْرَأَةٌ':Added, #4: 4	رُجُوعِ الْإِمَامِ
u'رُجُوعٌ أُمَّهَاتٌ':Added, #2: 2	رُجُوعِ امْرَأَةٍ
u'رُجُوعٌ إِنْسانٌ':Added, #1: 1	رُجُوعُ أُمَّهَاتِهِ
u'رُجُوعٌ أهْلٌ':Added, #1: 1	رُجُوعِ الْإِنْسَانِ
u'رُجُوعٌ أهْلٌ':Added, #1: 1	رُجُوعُ أَهْلِ
u'رُجُوعٌ أَوَّلُ':Added, #2: 2	رُجُوعَ أَهْلِ
u'رُجُوعٌ بادِئٌ':Added, #2: 2	رُجُوعِ الْأَوَّلِ
u'رُجُوعٌ باذِلٌ':Added, #2: 2	رُجُوعُ الْبَادِئِ
u'رُجُوعٌ بَاعَةٌ':Added, #1: 1	رُجُوعِ بَاذِلِ
u'رُجُوعٌ بَائِعٌ':Added, #2: 2	رُجُوعِ الْبَاعَةِ
u'رُجُوعٌ بَائِعٌ':Added, #2: 2	رُجُوعُ الْبَائِعِ
u'رُجُوعٌ بَائِعٌ':Added, #2: 2	رُجُوعُ بَائِعِ
u'رُجُوعٌ بَائِعٌ':Added, #6: 6	رُجُوعَ الْبَائِعِ
u'رُجُوعٌ بَحْثٌ':Added, #6: 6	رُجُوعِ الْبَائِعِ
u'رُجُوعٌ بَعْضٌ':Added, #1: 1	رُجُوعِ الْبَحْثِ
u'رُجُوعٌ بَيِّنَةٌ':Added, #2: 2	رُجُوعِ بَعْضِ
u'رُجُوعٌ ثَالِثٌ':Added, #1: 1	رُجُوعِ الْبَيِّنَةِ
u'رُجُوعٌ جَمِيع':Added, #1: 1	رُجُوعُ الثَّالِثِ
u'رُجُوعٌ حالٌ':Added, #1: 1	رُجُوعِ الْجَمِيعِ
u'رُجُوعٌ حُقوقٌ':Added, #1: 1	رُجُوعُ الْحَالِ
u'رُجُوعٌ حُقُوقٌ':Added, #2: 2	رُجُوعُ الْحُقُوقِ
u'رُجُوعٌ حُقوقٌ':Added, #2: 2	رُجُوعُ الْحُقُوقِ
u'رُجُوعٌ حُقُوقٌ':Added, #4: 4	رُجُوعِ الْحُقُوقِ
u'رُجُوعٌ خَصْمٌ':Added, #4: 4	رُجُوعِ الْحُقُوقِ
u'رُجُوعٌ خَصْمٌ':Added, #1: 1	رُجُوعَ الْخَصْمِ
u'رُجُوعٌ خِلاَفٌ':Added, #1: 1	رُجُوعُ الْخَصْمِ
u'رُجُوعٌ خِلاَفٌ':Added, #1: 1	رُجُوعَ الْخِلَافِ
u'رُجُوعٌ خَمْسَةٌ':Added, #2: 2	رُجُوعِ الْخِلَافِ
u'رُجُوعٌ دَافِعٌ':Added, #1: 1	رُجُوعِ الْخَمْسَةِ
u'رُجُوعٌ دَائِنٌ':Added, #1: 1	رُجُوعِ الدَّافِعِ
u'رُجُوعٌ دَيْنٌ':Added, #2: 2	رُجُوعُ الدَّائِنِ
u'رُجُوعٌ رَسُولٌ':Added, #1: 1	رُجُوعَ الدَّيْنِ
u'رُجُوعٌ رَهْنٌ':Added, #2: 2	رُجُوعُ الرّسُولِ
u'رُجُوعٌ زَكاةٌ':Added, #1: 1	رُجُوعُ الرَّهْنِ
u'رُجُوعٌ زَوْجٌ':Added, #1: 1	رُجُوعِ زَكَاتِهِ
u'رُجُوعٌ زَوْجٌ':Added, #1: 1	رُجُوعُ الزَّوْجِ
u'رُجُوعٌ زَوْجٌ':Added, #2: 2	رُجُوعَ الزَّوْجِ
u'رُجُوعٌ زَوْجَةٌ':Added, #3: 3	رُجُوعِ الزَّوْجِ
u'رُجُوعٌ زَيْدٌ':Added, #1: 1	رُجُوعِ الزَّوْجَةِ
u'رُجُوعٌ سِلْعَةٌ':Added, #1: 1	رُجُوعَ زَيْدٍ
u'رُجُوعٌ سَيْفٌ':Added, #1: 1	رُجُوعِ السِّلْعَةِ
u'رُجُوعٌ شَاهِدٌ':Added, #1: 1	رُجُوعِ سَيْفِ
u'رُجُوعٌ شَبَهٌ':Added, #4: 4	رُجُوعَ الشَّاهِدِ
u'رُجُوعٌ شَرِيكٌ':Added, #1: 1	رُجُوعُ الشَّبَهَيْنِ
u'رُجُوعٌ شَفِيعٌ':Added, #1: 1	رُجُوعِ الشَّرِيكِ
u'رُجُوعٌ شَفِيعٌ':Added, #1: 1	رُجُوعُ الشَّفِيعِ
u'رُجُوعٌ شُهُودٌ':Added, #1: 1	رُجُوعِ الشَّفِيعِ
u'رُجُوعٌ شُهُودٌ':Added, #1: 1	رُجُوعَ الشُّهُودِ
u'رُجُوعٌ شُهُودٌ':Added, #3: 3	رُجُوعُ شُهُودِ
u'رُجُوعٌ شَيْءٌ':Added, #6: 6	رُجُوعِ الشُّهُودِ
u'رُجُوعٌ صَاحِبٌ':Added, #1: 1	رُجُوعِ شَيْءٍ
u'رُجُوعٌ صَاحِبٌ':Added, #1: 1	رُجُوعُ صَاحِبِهِ
u'رُجُوعٌ صَحَابِيٌّ':Added, #1: 1	رُجُوعِ صَاحِبِهِ
u'رُجُوعٌ صَقْرٌ':Added, #1: 1	رُجُوعِ الصَّحَابِيِّ
u'رُجُوعٌ صَيْرَفِيٌّ':Added, #1: 1	رُجُوعِ صَقْرِهِ
u'رُجُوعٌ ضَامِنٌ':Added, #1: 1	رُجُوعُ الصَّيْرَفِيِّ
u'رُجُوعٌ ضَمِيرٌ':Added, #6: 6	رُجُوعِ الضَّامِنِ
u'رُجُوعٌ ضَمِيرٌ':Added, #2: 2	رُجُوعِ الضَّمِيرِ
u'رُجُوعٌ ضَمِيرٌ':Added, #3: 3	رُجُوعَ الضَّمِيرِ
u'رُجُوعٌ عَارٌ':Added, #6: 6	رُجُوعُ الضَّمِيرِ
u'رُجُوعٌ عَاقِلٌ':Added, #1: 1	رُجُوعِ الْعَارِ
u'رُجُوعٌ عَامِّيٌّ':Added, #1: 1	رُجُوعَ عَاقِلَةِ
u'رُجُوعٌ عَبْدٌ':Added, #3: 3	رُجُوعَ الْعَامِّيِّ
u'رُجُوعٌ عَمَلٌ':Added, #1: 1	رُجُوعُ الْعَبْدِ
u'رُجُوعٌ غَائِبٌ':Added, #1: 1	رُجُوعُ الْعَمَلِ
u'رُجُوعٌ غَرِيمٌ':Added, #1: 1	رُجُوعِ الْغَائِبِ
u'رُجُوعٌ غَرِيمٌ':Added, #1: 1	رُجُوعُ الْغَرِيمِ
u'رُجُوعٌ غَرِيمٌ':Added, #1: 1	رُجُوعِ الْغَرِيمِ
u'رُجُوعٌ فَائِدَةٌ':Added, #1: 1	رُجُوعُ غَرِيمِ
u'رُجُوعٌ فقراء':Added, #1: 1	رُجُوعِ الْفَائِدَةِ
u'رُجُوعٌ فِقْهٌ':Added, #1: 1	رُجُوعِ فُقَرَاءِ
u'رُجُوعٌ فلان':Added, #1: 1	رُجُوعُ الْفِقْهِ
u'رُجُوعٌ قَاطِعٌ':Added, #1: 1	رُجُوعِ جَعْفَرِ
u'رُجُوعٌ قَافِلٌ':Added, #1: 1	رُجُوعُ الْقَاطِعِ
u'رُجُوعٌ قَافِلَةٌ':Added, #1: 1	رُجُوعِ الْقَافِلَةِ
u'رُجُوعٌ قَائِلٌ':Added, #1: 1	رُجُوعِ الْقَافِلَةِ
u'رُجُوعٌ كَاتِبٌ':Added, #1: 1	رُجُوعُ قَائِلِهِ
u'رُجُوعٌ كُفَّارٌ':Added, #1: 1	رُجُوعُ الْكَاتِبِ
u'رُجُوعٌ كفر':Added, #1: 1	رُجُوعُ الْكُفَّارِ
u'رُجُوعٌ كُفْرٌ':Added, #1: 1	رُجُوعُ الْكُفْرِ
u'رُجُوعٌ كَفِيلٌ':Added, #1: 1	رُجُوعُ الْكُفْرِ
u'رُجُوعٌ كلاب':Added, #2: 2	رُجُوعُ الْكَفِيلِ
u'رُجُوعٌ كِلاَبٌ':Added, #1: 1	رُجُوعِ كِلَابِ
u'رُجُوعٌ لُطْفٌ':Added, #1: 1	رُجُوعِ كِلَابِ
u'رُجُوعٌ مَاءٌ':Added, #1: 1	رُجُوعُ لُطْفِهِ
u'رُجُوعٌ مَالٌ':Added, #1: 1	رُجُوعِ الْمَاءِ
u'رُجُوعٌ مَالِكٌ':Added, #1: 1	رُجُوعُ الْمَالِ
u'رُجُوعٌ مَأْمُورٌ':Added, #1: 1	رُجُوعِ الْمَالِكِ
u'رُجُوعٌ مَبِيعٌ':Added, #1: 1	رُجُوعِ الْمَأْمُورِ
u'رُجُوعٌ مُتَبَرِّعٌ':Added, #1: 1	رُجُوعَ الْمَبِيعِ
u'رُجُوعٌ مُجْتَهِد':Added, #2: 2	رُجُوعَ الْمُتَبَرِّعِ
u'رُجُوعٌ مُحَمَّدٌ':Added, #1: 1	رُجُوعُ الْمُجْتَهِدِ
u'رُجُوعٌ مُحَمَّدٌ':Added, #1: 1	رُجُوعَ مُحَمَّدٍ
u'رُجُوعٌ مُحَمَّدٌ':Added, #2: 2	رُجُوعِ مُحَمَّدٍ
u'رُجُوعٌ مَحْمُولٌ':Added, #4: 4	رُجُوعُ مُحَمَّدٍ
u'رُجُوعٌ مُخَالِفٌ':Added, #1: 1	رُجُوعَ الْمَحْمُولَاتِ
u'رُجُوعٌ مُدَبِّرٌ':Added, #1: 1	رُجُوعُ الْمُخَالِفِ
u'رُجُوعٌ مُرْسَلٌ':Added, #1: 1	رُجُوعَ الْمُدَبِّرِ
u'رُجُوعٌ مُزَارِعٌ':Added, #1: 1	رُجُوعُ الْمُرْسَلِ
u'رُجُوعٌ مُسْتَأْجِرٌ':Added, #1: 1	رُجُوعَ الْمُزَارِعِ
u'رُجُوعٌ مُسْتَعِيرٌ':Added, #1: 1	رُجُوعُ الْمُسْتَأْجِرِ
u'رُجُوعٌ مُعَمِّرٌ':Added, #1: 1	رُجُوعِ الْمُسْتَعِيرِ
u'رُجُوعٌ مُعِير':Added, #1: 1	رُجُوعِ الْمُعَمِّرِ
u'رُجُوعٌ مَغْرُورٌ':Added, #6: 6	رُجُوعِ الْمُعِيرِ
u'رُجُوعٌ مُقْتَرِضٌ':Added, #2: 2	رُجُوعِ الْمَغْرُورِ
u'رُجُوعٌ مُقَلِّدٌ':Added, #1: 1	رُجُوعَ الْمُقْتَرِضِ
u'رُجُوعٌ مِلْكٌ':Added, #1: 1	رُجُوعِ الْمُقَلِّدِ
u'رُجُوعٌ مَنَافِعُ':Added, #1: 1	رُجُوعَ مِلْكٍ
u'رُجُوعٌ مَنَافِعُ':Added, #1: 1	رُجُوعُ الْمَنَافِعِ
u'رُجُوعٌ مُوجِبٌ':Added, #2: 2	رُجُوعِ الْمَنَافِعِ
u'رُجُوعٌ مُوجِبٌ':Added, #1: 1	رُجُوعِ الْمُوجِبِ
u'رُجُوعٌ مُؤَذِّنٌ':Added, #2: 2	رُجُوعَ الْمُوجِبِ
u'رُجُوعٌ نَاسٌ':Added, #1: 1	رُجُوعُ الْمُؤَذِّنِ
u'رُجُوعٌ نَظَرٌ':Added, #1: 1	رُجُوعِ النَّاسِ
u'رُجُوعٌ هِبَةٌ':Added, #1: 1	رُجُوعِ النَّظَرِ
u'رُجُوعٌ واحد':Added, #1: 1	رُجُوعُ الْهِبَةِ
u'رُجُوعٌ وَاحِدٌ':Added, #1: 1	رُجُوعَ الْوَاحِدِ
u'رُجُوعٌ وَاقِعٌ':Added, #1: 1	رُجُوعَ الْوَاحِدِ
u'رُجُوعٌ وَالِدٌ':Added, #1: 1	رُجُوعَ الْوَاقِعِ
u'رُجُوعٌ وَالِدٌ':Added, #1: 1	رُجُوعَ الْوَالِدِ
u'رُجُوعٌ وَاهِبٌ':Added, #2: 2	رُجُوعِ الْوَالِدِ
u'رُجُوعٌ وَاهِبٌ':Added, #1: 1	رُجُوعُ الْوَاهِبِ
u'رُجُوعٌ وَاهِبٌ':Added, #1: 1	رُجُوعِ الْوَاهِبِ
u'رُجُوعٌ وَصْفٌ':Added, #1: 1	رُجُوعُ وَاهِبٍ
u'رُجُوعٌ وَصْفٌ':Added, #1: 1	رُجُوعَ الْوَصْفِ
u'رُجُوعٌ وَصِيٌّ':Added, #1: 1	رُجُوعِ الْوَصْفِ
u'رُجُوعٌ وَصِيٌّ':Added, #1: 1	رُجُوعِ الْوَصِيِّ
u'رُجُوعٌ وَصِيَّةٌ':Added, #1: 1	رُجُوعِ الْوَصِيَّةِ
u'رُجُوعٌ وَكِيلٌ':Added, #1: 1	رُجُوعِ الْوَصِيَّةِ
u'رُجُوعٌ وَلاَءٌ':Added, #1: 1	رُجُوعِ الْوَكِيلِ
u'رَجَّى نَسْلٌ':Predicate, #1: 1	رُجُوعِ الْوَلَاءِ
u'رِحَالٌ ذَهَبٌ':Added, #1: 1	رَجَّى النَّسْلَ
u'رِحَالٌ قَوْمٌ':Added, #1: 1	رِحَالُ الذَّهَبِ
u'رِحَالٌ نَاسٌ':Added, #1: 1	رِحَالِ الْقَوْمِ
u'رَحَلَ أَصْحَابٌ':Subject, #1: 1	رِحَالَ النَّاسِ
u'رَحَلَ أعْظَمُ':Predicate, #1: 1	رَحَلَ أَصْحَابُ
u'رَحَلَ أَكْثَرُ':Subject, #1: 1	رَحَلَ أَعْظَمَ
u'رَحَلَ بَطَلٌ':Predicate, #1: 1	رَحَلَ أَكْثَرُ
u'رَحْلٌ بَعيرٌ':Added, #1: 1	رَحَلَ بَطَلَ
u'رحلة اِبْنٌ':Added, #1: 1	رَحْلَ بَعِيرٍ
u'رِحْلَةٌ اِبْنٌ':Added, #2: 2	رِحْلَةِ ابْنِ
u'رحلة شِتَاءٌ':Added, #2: 2	رِحْلَةِ ابْنِ
u'رحلة شِتَاءٌ':Added, #1: 1	رِحْلَةَ الشّتَاءِ
u'رحلة شِتَاءٌ':Added, #1: 1	رِحْلَةَ الشِّتَاءِ
u'رحلة شِتَاءٌ':Added, #1: 1	رِحْلَةُ الشِّتَاءِ
u'رِحْلَةٌ شِتَاءٌ':Added, #1: 1	رِحْلَةِ الشِّتَاءِ
u'رِحْلَةٌ شِتَاءٌ':Added, #1: 1	رِحْلَةَ الشّتَاءِ
u'رِحْلَةٌ شِتَاءٌ':Added, #1: 1	رِحْلَةَ الشِّتَاءِ
u'رِحْلَةٌ شِتَاءٌ':Added, #1: 1	رِحْلَةُ الشِّتَاءِ
u'رَحْلٌ خَالِدٌ':Added, #1: 1	رِحْلَةِ الشِّتَاءِ
u'رَحْلٌ خَالِدٌ':Added, #2: 2	رَحْلِ خَالِدٍ
u'رَحْلٌ دَابَّةٌ':Added, #3: 3	رَحْلِ خَالِدِ
u'رَحْلٌ رَجُلٌ':Added, #1: 1	رَحْلِ الدَّابَّةِ
u'رَحْلٌ رَسُولٌ':Added, #1: 1	رَحْلِ رَجُلٍ
u'رَحْلٌ رَسُولٌ':Added, #1: 1	رَحْلُ رَسُولِ
u'رَحَلَ شافِعِيّ':Subject, #3: 3	رَحْلَ رَسُولِ
u'رَحْلٌ شَرِيكٌ':Added, #1: 1	رَحَلَ الشَّافِعِيُّ
u'رَحَلَ فلان':Subject, #1: 1	رَحْلِ شَرِيكَيْنِ
u'رَحْلٌ فلان':Added, #1: 1	رَحَلَ الشَّافِعِيُّ
u'رَحْلٌ مُسَافِرٌ':Added, #1: 1	رَحْلَ زِيَادِ
u'رحمة اللهُ':Added, #3: 3	رَحْلَ الْمُسَافِرِ
u'رَحْمَةٌ اللهُ':Added, #1: 1	رَحْمَةُ اللهِ
u'رحمة جُهَّالٌ':Added, #1: 1	رَحْمَةُ اللهِ
u'رَحْمَةٌ جُهَّالٌ':Added, #1: 1	رَحْمَةُ الْجُهَّالِ
u'رحمة رَبُّ':Added, #1: 1	رَحْمَةُ الْجُهَّالِ
u'رَحْمَةٌ رَبُّ':Added, #1: 1	رَحْمَةُ رَبّهِ
u'رحمة رَبُّ':Added, #1: 1	رَحْمَةُ رَبّهِ
u'رَحْمَةٌ رَبُّ':Added, #2: 2	رَحْمَةَ رَبِّهِ
u'رحمة رَبُّ':Added, #2: 2	رَحْمَةَ رَبِّهِ
u'رَحْمَةٌ رَبُّ':Added, #6: 6	رَحْمَةِ رَبِّهِ
u'رحمة رَسُولٌ':Added, #6: 6	رَحْمَةِ رَبِّهِ
u'رَحْمَةٌ رَسُولٌ':Added, #1: 1	رَحْمَةَ الرّسُولِ
u'رحمة شَرْعٌ':Added, #1: 1	رَحْمَةَ الرّسُولِ
u'رَحْمَةٌ شَرْعٌ':Added, #1: 1	رَحْمَةِ الشَّرْعِ
u'رحمة عَامٌّ':Added, #1: 1	رَحْمَةِ الشَّرْعِ
u'رَحْمَةٌ عَامٌّ':Added, #1: 1	رَحْمَةُ الْعَامَّةِ
u'رحمة فقراء':Added, #1: 1	رَحْمَةُ الْعَامَّةِ
u'رَحْمَةٌ فقراء':Added, #1: 1	رَحْمَةِ الْفُقَرَاءِ
u'رحمة نَفْسٌ':Added, #1: 1	رَحْمَةِ الْفُقَرَاءِ
u'رَحْمَةٌ نَفْسٌ':Added, #1: 1	رَحْمَةِ نَفْسِهِ
u'رَحِمَ غير':Subject, #1: 1	رَحْمَةِ نَفْسِهِ
u'رَحِمَ غَيْرٌ':Subject, #1: 1	رَحِمَ غَيْرُ
u'رَحِمَ يَتِيمٌ':Predicate, #1: 1	رَحِمَ غَيْرُ
u'رَحِيلٌ حاجٌّ':Added, #2: 2	رَحِمَ الْيَتِيمَ
u'رَخَاءٌ ريحٌ':Added, #1: 1	رَحِيلِ الْحَاجِّ
u'رَخَاءٌ عَيْشٌ':Added, #1: 1	رَخَاءُ رِيحِهِ
u'رَخَاءٌ عَيْشٌ':Added, #1: 1	رَخَاءُ الْعَيْشِ
u'رَخُصَ أَجْرٌ':Subject, #1: 1	رَخَاءِ عَيْشٍ
u'رَخُصَ أَرْبَعَةٌ':Subject, #1: 1	رَخُصَ أَجْرُ
u'رَخَّصَ أَصْحَابٌ':Subject, #1: 1	رَخُصَ أَرْبَعَةُ
u'رَخَّصَ أكْبَرُ':Subject, #2: 2	رَخَّصَ أَصْحَابُ
u'رَخَّصَ إمَامٌ':Subject, #1: 1	رَخَّصَ أَكْبَرُ
u'رَخَّصَ بَعْضٌ':Subject, #3: 3	رَخَّصَ الْإِمَامُ
u'رَخَّصَ رَسُولٌ':Subject, #7: 7	رَخَّصَ بَعْضُ
u'رَخُصَ سعر':Subject, #23: 23	رَخَّصَ رَسُولُ
u'رَخُصَ سِعْرٌ':Subject, #3: 3	رَخُصَ سِعْرُهُ
u'رَخُصَ سعر':Subject, #3: 3	رَخُصَ سِعْرُهُ
u'رَخُصَ سِعْرٌ':Subject, #5: 5	رَخُصَ السِّعْرُ
u'رَخَّصَ شَارِعٌ':Subject, #5: 5	رَخُصَ السِّعْرُ
u'رَخَّصَ شَرْعٌ':Subject, #4: 4	رَخَّصَ الشَّارِعُ
u'رَخَّصَ قَوْمٌ':Subject, #1: 1	رَخَّصَ الشَّرْعُ
u'رَخَّصَ نَبِيٌّ':Subject, #1: 1	رَخَّصَ قَوْمٌ
u'رَخِيَ حجاب':Predicate, #1: 1	رَخَّصَ النَّبِيُّ
u'رَخِيَ حِجابٌ':Predicate, #1: 1	أَرْخَى الْحِجَابَ
u'رَخِيَ سِتْرٌ':Predicate, #1: 1	أَرْخَى الْحِجَابَ
u'رَدَّ إبَاحَةٌ':Predicate, #2: 2	أَرْخَى السِّتْرَ
u'رَدَّ اِبْنٌ':Predicate, #1: 1	رَدَّ الْإِبَاحَةَ
u'رَدَّ اِبْنٌ':Subject, #2: 2	رَدَّ ابْنَ
u'رَدَّ اِبْنٌ':Subject, #2: 2	رَدَّ ابْنُهُ
u'رَدَّ أحَدٌ':Subject, #4: 4	رَدَّ ابْنُ
u'رَدَّ أخْبَارٌ':Predicate, #1: 1	رَدَّ أَحَدٌ
u'رَدَّ أَخْبَارٌ':Predicate, #1: 1	رَدَّ الْأَخْبَارَ
u'رَدَّ آخِرُ':Predicate, #1: 1	رَدَّ الْأَخْبَارَ
u'رَدَّ أرْضٌ':Subject, #1: 1	رَدَّ آخِرَ
u'رَدَّ أصل':Predicate, #1: 1	رَدَّ أَرْضٌ
u'رَدَّ أًصْلٌ':Predicate, #1: 1	رَدَّ أَصْلَ
u'رَدَّ أصل':Predicate, #1: 1	رَدَّ أَصْلَ
u'رَدَّ أًصْلٌ':Predicate, #3: 3	رَدَّ الْأَصْلَ
u'رَدَّ إقْرَارٌ':Predicate, #3: 3	رَدَّ الْأَصْلَ
u'رَدَّ إقْرَارٌ':Predicate, #1: 1	رَدَّ إقْرَارَ
u'رَدَّ أَكْثَرُ':Predicate, #1: 1	رَدَّ الْإِقْرَارَ
u'رَدَّ ألف':Predicate, #1: 1	رَدَّ أَكْثَرَ
u'رَدَّ ألْفٌ':Predicate, #1: 1	رَدَّ الْأَلْفَ
u'رَدَّ أَلْفٌ':Predicate, #1: 1	رَدَّ الْأَلْفَ
u'رَدَّ ألف':Predicate, #1: 1	رَدَّ الْأَلْفَ
u'رَدَّ ألْفٌ':Predicate, #2: 2	رَدَّ أَلْفَ
u'رَدَّ أَلْفٌ':Predicate, #2: 2	رَدَّ أَلْفَ
u'رَدَّ الْمَرْأَةُ':Predicate, #2: 2	رَدَّ أَلْفَ
u'رَدَّ أُمٌّ':Predicate, #3: 3	رَدَّ الْمَرْأَةَ
u'رَدَّ أُمٌّ':Predicate, #1: 1	رَدَّ الْأُمَّ
u'رَدَّ إمَامٌ':Subject, #1: 1	رَدَّ أُمَّ
u'رَدَّ أمَانَةٌ':Predicate, #6: 6	رَدَّ الْإِمَامُ
u'رَدَّ أمَةٌ':Predicate, #1: 1	رَدَّ الْأَمَانَةَ
u'رَدَّ أَمْرٌ':Predicate, #1: 1	رَدَّ الْأَمَةَ
u'رَدَّ أَمْرٌ':Predicate, #1: 1	رَدَّ الأَمْرَ
u'رَدَّ أَوَّلُ':Predicate, #1: 1	رَدَّ الْأَمْرَ
u'رَدَّ أَوَّلُ':Subject, #1: 1	رَدَّ الْأَوَّلَ
u'رَدَّ أَوْلاَدٌ':Subject, #3: 3	رَدَّ الْأَوَّلُ
u'رَدَّ أَيْمَانٌ':Predicate, #1: 1	رَدَّ أَوْلَادُ
u'رَدَّ أَيْمَانٌ':Predicate, #1: 1	رَدَّ الْأَيْمَانَ
u'رَدَّ بَابٌ':Predicate, #2: 2	رَدَّ الأَيْمَانَ
u'رَدَّ باقِي':Predicate, #2: 2	رَدَّ الْبَابَ
u'رَدَّ بَائِعٌ':Subject, #3: 3	رَدَّ الْبَاقِيَ
u'رَدَّ بَائِعٌ':Subject, #12: 12	رَدَّ الْبَائِعُ
u'رَدَّ بَائِعٌ':Subject, #1: 1	رَدَّ بَائِعُ
u'رَدَّ بَدَلٌ':Predicate, #2: 2	رَدَّ بَائِعُهُ
u'رَدَّ بَدَلٌ':Predicate, #3: 3	رَدَّ الْبَدَلَ
u'رَدَّ بَراءةٌ':Predicate, #3: 3	رَدَّ بَدَلَ
u'رَدَّ بَطَلٌ':Predicate, #1: 1	رَدَّ الْبَرَاءَةَ
u'رَدَّ بَطْنٌ':Subject, #14: 14	رَدَّ بَطَلَ
u'رَدَّ بَعْضٌ':Predicate, #1: 1	رَدَّ الْبَطْنُ
u'رَدَّ بَعْضٌ':Predicate, #2: 2	رَدَّ بَعْضَ
u'رَدَّ بَعْضٌ':Subject, #3: 3	رَدَّ الْبَعْضَ
u'رَدَّ بَعْضٌ':Subject, #1: 1	رَدَّ الْبَعْضُ
u'رَدَّ بَيْعٌ':Predicate, #3: 3	رَدَّ بَعْضُ
u'رَدَّ تَحْلِيلٌ':Predicate, #6: 6	رَدَّ الْبَيْعَ
u'رَدَّ تَسْوِيَةٌ':Predicate, #1: 1	رَدَّ التَّحْلِيلَ
u'رَدَّ تَعْلِيلٌ':Predicate, #1: 1	رَدَّ التَّسْوِيَةَ
u'رَدَّ تَفاوُت':Predicate, #1: 1	رَدَّ تَعْلِيلَ
u'رَدَّ ثَمانِيَةٌ':Predicate, #2: 2	رَدَّ التَّفَاوُتَ
u'رَدَّ ثَمَنٌ':Predicate, #1: 1	رَدَّ الثَّمَانِيَةَ
u'رَدَّ ثَوْبٌ':Predicate, #25: 25	رَدَّ الثَّمَنَ
u'رَدَّ جَارِي':Predicate, #3: 3	رَدَّ الثَّوْبَ
u'رَدَّ جَارِي':Predicate, #1: 1	رَدَّ جَارِيَةً
u'رَدَّ جَارِيَةٌ':Predicate, #7: 7	رَدَّ الْجَارِيَةَ
u'رَدَّ جمع':Predicate, #7: 7	رَدَّ الْجَارِيَةَ
u'رَدَّ جَمْعٌ':Predicate, #1: 1	رَدَّ الْجَمْعَ
u'رَدَّ جُمْهُورٌ':Subject, #1: 1	رَدَّ الْجَمْعَ
u'رَدَّ جَمِيع':Predicate, #1: 1	رَدَّ الْجُمْهُورُ
u'رَدَّ جَمِيع':Subject, #1: 1	رَدَّ الْجَمِيعَ
u'رَدَّ حاجِزٌ':Predicate, #1: 1	رَدَّ الْجَمِيعُ
u'رَدَّ حاضِرٌ':Subject, #1: 1	رَدَّ الْحَاجِزَ
u'رَدَّ حاكِمٌ':Subject, #1: 1	رَدَّ الْحَاضِرُ
u'رَدَّ حاكِمٌ':Subject, #1: 1	رَدَّ حَاكِمٌ
u'رَدَّ حَديثٌ':Predicate, #5: 5	رَدَّ الْحَاكِمُ
u'رَدَّ حَديثٌ':Predicate, #1: 1	رَدَّ الْحَدِيثَ
u'رَدَّ حِرْزٌ':Predicate, #1: 1	رَدَّ حَدِيثَ
u'رَدَّ حِصَّةٌ':Predicate, #2: 2	رَدَّ الْحِرْزَ
u'رَدَّ حُكْمٌ':Predicate, #1: 1	رَدَّ حِصَّةَ
u'رَدَّ حُكْمٌ':Predicate, #1: 1	رَدَّ الْحُكْمَ
u'رَدَّ حُكْمٌ':Predicate, #1: 1	رَدَّ حُكْمَكَ
u'رَدَّ حَكَمٌ':Subject, #2: 2	رَدَّ حُكْمَ
u'رَدَّ حِنْطَةٌ':Predicate, #1: 1	رَدَّ الْحَكَمُ
u'رَدَّ خَالِدٌ':Subject, #1: 1	رَدَّ الْحِنْطَةَ
u'رَدَّ خيار':Predicate, #1: 1	رَدَّ خَالِدٌ
u'رَدَّ خِيَارٌ':Predicate, #1: 1	رَدَّ خِيَارَ
u'رَدَّ دَابَّةٌ':Predicate, #1: 1	رَدَّ خِيَارَ
u'رَدَّ دَارٌ':Predicate, #4: 4	رَدَّ الدَّابَّةَ
u'رَدَّدَ بَيْنٌ':Predicate, #5: 5	رَدَّ الدَّارَ
u'رَدَّ دَرَاهِمُ':Predicate, #3: 3	رَدَّدَ بَيْنَ
u'رَدَّ دَرَاهِمُ':Predicate, #1: 1	رَدَّ الدَّرَاهِمَ
u'رَدَّ دِرْهَمٌ':Predicate, #1: 1	رَدَّ دَرَاهِمَ
u'رَدَّ دِرْهَم':Predicate, #1: 1	رَدَّ الدِّرْهَمَ
u'رَدَّ دفع':Predicate, #1: 1	رَدَّ الدِّرْهَمَ
u'رَدَّدَ قول':Predicate, #1: 1	رَدَّ دَفَعَ
u'رَدَّدَ قَوْلٌ':Predicate, #1: 1	رَدَّدَ الْقَوْلَ
u'رَدَّدَ كَلاَمٌ':Predicate, #1: 1	رَدَّدَ الْقَوْلَ
u'رَدَّدَ كَلِمَةٌ':Predicate, #1: 1	رَدَّدَ الْكَلَامَ
u'رَدَّدَ مَاءٌ':Predicate, #1: 1	رَدَّدَ الْكَلِمَةَ
u'رَدَّدَ مُوَسْوِسٌ':Subject, #1: 1	رَدَّدَ الْمَاءَ
u'رَدَّ دَنانيرُ':Predicate, #1: 1	رَدَّدَ الْمُوَسْوِسُ
u'رَدَّدَ نَبِيٌّ':Subject, #1: 1	رَدَّ الدَّنَانِيرَ
u'رَدَّدَ نَظَرٌ':Predicate, #2: 2	رَدَّدَ النَّبِيُّ
u'رَدَّ دِيَةٌ':Predicate, #3: 3	رَدَّدَ النَّظَرَ
u'رَدَّدَ يَمِينٌ':Predicate, #1: 1	رَدَّ الدِّيَةَ
u'رَدَّ رَأْسٌ':Predicate, #2: 2	رَدَّدَ الْيَمِينَ
u'رَدَّ رَائِعٌ':Predicate, #1: 1	رَدَّ رَأْسَ
u'رَدَّ رِبْحٌ':Predicate, #1: 1	رَدَّ الرَّائِعَةَ
u'رَدَّ رَجُلٌ':Predicate, #2: 2	رَدَّ الرِّبْحَ
u'رَدَّ رَجُلٌ':Subject, #1: 1	رَدَّ رَجُلاً
u'رَدَّ رَدٌّ':Predicate, #1: 1	رَدَّ الرَّجُلُ
u'رَدَّ رَسُولٌ':Subject, #1: 1	رَدَّ رَدَّ
u'رَدَّ رَصاصٌ':Predicate, #7: 7	رَدَّ رَسُولُ
u'رَدَّ رِقٌّ':Predicate, #1: 1	رَدَّ الرَّصَاصَ
u'رَدَّ رَهْنٌ':Predicate, #1: 1	رَدَّ الرِّقَّ
u'رَدَّ ريحٌ':Subject, #4: 4	رَدَّ الرَّهْنَ
u'رَدَّ زَوْجٌ':Subject, #1: 1	رَدَّ الرِّيحُ
u'رَدَّ زِيادَةٌ':Predicate, #1: 1	رَدَّ الزَّوْجُ
u'رَدَّ زَيْنَبٌ':Predicate, #5: 5	رَدَّ الزِّيَادَةَ
u'رَدَّ زُيوفٌ':Predicate, #2: 2	رَدَّ زَيْنَبَ
u'رَدَّ زُيُوفٌ':Predicate, #1: 1	رَدَّ الزُّيُوفَ
u'رَدَّ سَارِقٌ':Subject, #1: 1	رَدَّ الزُّيُوفَ
u'رَدَّ سَبْيٌ':Predicate, #4: 4	رَدَّ السَّارِقُ
u'رَدَّ سَفِينَةٌ':Predicate, #1: 1	رَدَّ سَبْيَ
u'رَدَّ سلام':Predicate, #1: 1	رَدَّ السَّفِينَةَ
u'رَدَّ سَلاَمٌ':Predicate, #9: 9	رَدَّ السَّلَامَ
u'رَدَّ سُلْطَانٌ':Subject, #9: 9	رَدَّ السَّلَامَ
u'رَدَّ سُلْطَانٌ':Subject, #1: 1	رَدَّ سُلْطَانٌ
u'رَدَّ سِلْعَةٌ':Predicate, #2: 2	رَدَّ السُّلْطَانُ
u'رَدَّ سِمْسَارٌ':Subject, #2: 2	رَدَّ السِّلْعَةَ
u'رَدَّ سِنٌّ':Predicate, #1: 1	رَدَّ السِّمْسَارُ
u'رَدَّ سُنَّةٌ':Predicate, #3: 3	رَدَّ السِّنَّ
u'رَدَّ سَيِّدٌ':Subject, #1: 1	رَدَّ السُّنَّةَ
u'رَدَّ شافِعِيّ':Subject, #2: 2	رَدَّ السَّيِّدُ
u'رَدَّ شَعِيرٌ':Predicate, #1: 1	رَدَّ الشَّافِعِيُّ
u'رَدَّ شَفِيعٌ':Subject, #1: 1	رَدَّ الشَّعِيرَ
u'رَدَّ شمس':Subject, #3: 3	رَدَّ الشَّفِيعُ
u'رَدَّ شَمْسٌ':Subject, #1: 1	رَدَّ شَمْسُ
u'رَدَّ شَهَادَةٌ':Predicate, #1: 1	رَدَّ شَمْسُ
u'رَدَّ شَهَادَةٌ':Predicate, #12: 12	رَدَّ شَهَادَةَ
u'رَدَّ شَيْخٌ':Subject, #2: 2	رَدَّ الشَّهَادَةَ
u'رَدَّ صَاحِبٌ':Subject, #1: 1	رَدَّ الشَّيْخُ
u'رَدَّ صَاحِبٌ':Subject, #1: 1	رَدَّ صَاحِبُ
u'رَدَّ صَبِيٌّ':Subject, #1: 1	رَدَّ صَاحِبُهُ
u'رَدَّ صَيْدٌ':Predicate, #1: 1	رَدَّ الصَّبِيُّ
u'رَدَّ ضَمِيرٌ':Predicate, #2: 2	رَدَّ الصَّيْدَ
u'رَدَّ عارِيَّةٌ':Predicate, #1: 1	رَدَّ الضَّمِيرَ
u'رَدَّ عَبْدٌ':Predicate, #1: 1	رَدَّ الْعَارِيَّةَ
u'رَدَّ عَبْدٌ':Predicate, #24: 24	رَدَّ الْعَبْدَ
u'رَدَّ عَبْدٌ':Subject, #4: 4	رَدَّ عَبْدَ
u'رَدَّ عتق':Predicate, #4: 4	رَدَّ الْعَبْدُ
u'رَدْعٌ حِنَّاءٌ':Added, #1: 1	رَدَّ عَتَقَ
u'رَدْعٌ زَعْفَرانٌ':Added, #1: 1	رَدْعُ حِنَّاءٍ
u'رَدْعٌ سَفَلَةٌ':Added, #2: 2	رَدْعُ زَعْفَرَانٍ
u'رَدَّ عُشْرٌ':Predicate, #1: 1	رَدْعِ السَّفَلَةِ
u'رَدْعٌ طِيبٌ':Added, #1: 1	رَدَّ الْعُشْرَ
u'رَدْعٌ ظالِمٌ':Added, #1: 1	رَدْعُ الطِّيبِ
u'رَدَّ عَقْدٌ':Predicate, #1: 1	رَدْعِ الظَّالِمِ
u'رَدَّ عُمَرٌ':Predicate, #1: 1	رَدَّ الْعَقْدَ
u'رَدَّ عُمَرٌ':Subject, #1: 1	رَدَّ عُمَرَ
u'رَدَّ عِوَضٌ':Predicate, #1: 1	رَدَّ عُمَرُ
u'رَدَّ عين':Predicate, #1: 1	رَدَّ الْعِوَضَ
u'رَدَّ عَيْنٌ':Predicate, #7: 7	رَدَّ الْعَيْنَ
u'رَدَّ عَيْن':Predicate, #7: 7	رَدَّ الْعَيْنَ
u'رَدَّ عين':Predicate, #7: 7	رَدَّ الْعَيْنَ
u'رَدَّ عَيْنٌ':Predicate, #7: 7	رَدَّ عَيْنَ
u'رَدَّ عَيْن':Predicate, #7: 7	رَدَّ عَيْنَ
u'رَدَّ غَاصِبٌ':Subject, #7: 7	رَدَّ عَيْنَ
u'رَدَّ غَرِيمٌ':Subject, #3: 3	رَدَّ الْغَاصِبُ
u'رَدَّ غَلَّةٌ':Predicate, #3: 3	رَدَّ الْغَرِيمُ
u'رَدَّ غَنَمٌ':Predicate, #1: 1	رَدَّ الْغَلَّةَ
u'رَدَّ غير':Predicate, #1: 1	رَدَّ الْغَنَمَ
u'رَدَّ غَيْرٌ':Predicate, #3: 3	رَدَّ غَيْرَ
u'رَدَّ غير':Subject, #3: 3	رَدَّ غَيْرَ
u'رَدَّ غَيْرٌ':Subject, #1: 1	رَدَّ غَيْرُهُ
u'رَدِفَ إِثْمٌ':Predicate, #1: 1	رَدَّ غَيْرُهُ
u'رَدَّ فَاضِلٌ':Predicate, #1: 1	أَرْدَفَ إثْمَ
u'رَدِفَ حَجٌّ':Predicate, #2: 2	رَدَّ الْفَاضِلَ
u'رَدِفَ حَرامٌ':Predicate, #11: 11	أَرْدَفَ الْحَجَّ
u'رَدِفَ حَرْفٌ':Predicate, #1: 1	أَرْدَفَ الْحَرَامَ
u'رَدِفَ رَجُلٌ':Predicate, #1: 1	أَرْدَفَ حَرْفَ
u'رَدَّ فَرَسٌ':Predicate, #1: 1	أَرْدَفَ رَجُلاً
u'رَدَّ فُرُوعٌ':Predicate, #1: 1	رَدَّ الْفَرَسَ
u'رَدَّ فَضْلٌ':Predicate, #1: 1	رَدَّ الْفُرُوعَ
u'رَدِفَ فَضْلٌ':Predicate, #1: 1	رَدَّ الْفَضْلَ
u'رَدِفَ فَضْلٌ':Subject, #8: 8	أَرْدَفَ الْفَضْلَ
u'رَدِفَ قلب':Predicate, #1: 1	رَدِفَ الْفَضْلُ
u'رَدَّ فَقِيرٌ':Subject, #1: 1	أَرْدَفَ قَلَبَ
u'رَدَّ فلان':Subject, #1: 1	رَدَّ الْفَقِيرُ
u'رَدَّ فلان':Subject, #1: 1	رَدَّ الشَّافِعِيُّ
u'رَدَّ فُلاَنٌ':Subject, #1: 1	رَدَّ عُثْمَانُ
u'رَدَّ قِنٌّ':Predicate, #1: 1	رَدَّ فُلَانٌ
u'رَدَّ قِنٌّ':Subject, #1: 1	رَدَّ الْقِنَّ
u'رَدَّ قول':Predicate, #2: 2	رَدَّ الْقِنُّ
u'رَدَّ قَوْلٌ':Predicate, #1: 1	رَدَّ الْقَوْلَ
u'رَدَّ قول':Predicate, #1: 1	رَدَّ الْقَوْلَ
u'رَدَّ قَوْلٌ':Predicate, #3: 3	رَدَّ قَوْلَ
u'رَدَّ قَيْءٌ':Predicate, #3: 3	رَدَّ قَوْلَ
u'رَدَّ قِيَاسٌ':Predicate, #1: 1	رَدَّ الْقَيْءَ
u'رَدَّ قِيمَةٌ':Predicate, #1: 1	رَدَّ قِيَاسَ
u'رَدَّ قِيمَةٌ':Predicate, #2: 2	رَدَّ قِيمَةَ
u'رَدَّ كِتَابٌ':Predicate, #9: 9	رَدَّ الْقِيمَةَ
u'رَدَّ كِتَابَةٌ':Predicate, #3: 3	رَدَّ الْكِتَابَ
u'رَدَّ كَفِيلٌ':Subject, #1: 1	رَدَّ الْكِتَابَةَ
u'رَدَّ كَلاَمٌ':Predicate, #1: 1	رَدَّ الْكَفِيلُ
u'رَدَّ لَحْمٌ':Predicate, #2: 2	رَدَّ كَلَامَ
u'رَدَّ مَاءٌ':Predicate, #1: 1	رَدَّ اللَّحْمَ
u'رَدَّ مَالٌ':Predicate, #1: 1	رَدَّ الْمَاءَ
u'رَدَّ مُبْتاع':Subject, #9: 9	رَدَّ الْمَالَ
u'رَدَّ مَبِيعٌ':Predicate, #1: 1	رَدَّ الْمُبْتَاعُ
u'رَدَّ مَتَاعٌ':Predicate, #25: 25	رَدَّ الْمَبِيعَ
u'رَدَّ مثل':Predicate, #1: 1	رَدَّ الْمَتَاعَ
u'رَدَّ مِثْلٌ':Predicate, #2: 2	رَدَّ مِثْلَ
u'رَدَّ مثل':Predicate, #2: 2	رَدَّ مِثْلَ
u'رَدَّ مِثْلٌ':Predicate, #3: 3	رَدَّ الْمِثْلَ
u'رَدَّ مَجْنُونٌ':Subject, #3: 3	رَدَّ الْمِثْلَ
u'رَدَّ مُحَقِّقٌ':Subject, #1: 1	رَدَّ الْمَجْنُونُ
u'رَدَّ مُحَكَّمٌ':Subject, #1: 1	رَدَّ الْمُحَقِّقُ
u'رَدَّ مراسيل':Predicate, #1: 1	رَدَّ الْمُحَكَّمُ
u'رَدَّ مَرَاسِيلُ':Predicate, #1: 1	رَدَّ الْمَرَاسِيلَ
u'رَدَّ مُرْتَهِنٌ':Subject, #1: 1	رَدَّ الْمَرَاسِيلَ
u'رَدَّ مُرْسَلٌ':Predicate, #1: 1	رَدَّ الْمُرْتَهِنُ
u'رَدَّ مُسْتَحَقٌّ':Predicate, #1: 1	رَدَّ الْمُرْسَلَ
u'رَدَّ مُسْتَعِيرٌ':Subject, #1: 1	رَدَّ الْمُسْتَحَقَّ
u'رَدَّ مَشِيئَةٌ':Predicate, #4: 4	رَدَّ الْمُسْتَعِيرُ
u'رَدَّ مُصَنِّفٌ':Subject, #5: 5	رَدَّ الْمَشِيئَةَ
u'رَدَّ مَطْلُوبٌ':Subject, #2: 2	رَدَّ الْمُصَنِّفُ
u'رَدَّ مَعِيبٌ':Predicate, #1: 1	رَدَّ الْمَطْلُوبُ
u'رَدَّ مَغْصُوب':Predicate, #7: 7	رَدَّ الْمَعِيبَ
u'رَدَّ مُفَوَّضٌ':Subject, #6: 6	رَدَّ الْمَغْصُوبَ
u'رَدَّ مَقْبُوضٌ':Predicate, #2: 2	رَدَّ الْمُفَوَّضُ
u'رَدَّ مُلْتَحِمٌ':Predicate, #1: 1	رَدَّ الْمَقْبُوضَ
u'رَدَّ مُلْتَحِمٌ':Subject, #1: 1	رَدَّ الْمُلْتَحِمَ
u'رَدَّ مُنَافِقٌ':Predicate, #1: 1	رَدَّ الْمُلْتَحِمُ
u'رَدَّ مَنْصُوصٌ':Predicate, #1: 1	رَدَّ الْمُنَافِقِينَ
u'رَدَّ مَهْرٌ':Predicate, #1: 1	رَدَّ الْمَنْصُوصَ
u'رَدَّ مَوْجُودٌ':Predicate, #1: 1	رَدَّ الْمَهْرَ
u'رَدَّ مَوْقُوفٌ':Subject, #1: 1	رَدَّ الْمَوْجُودَ
u'رَدَّ مَوْهُوبٌ':Predicate, #1: 1	رَدَّ الْمَوْقُوفُ
u'رَدَّ نَبِيٌّ':Subject, #1: 1	رَدَّ الْمَوْهُوبَ
u'رَدَّ نِصْفٌ':Predicate, #5: 5	رَدَّ النَّبِيُّ
u'رَدَّ نِصْفٌ':Predicate, #2: 2	رَدَّ النِّصْفَ
u'رَدَّ نَفَقَةٌ':Predicate, #3: 3	رَدَّ نِصْفَ
u'رَدَّ نَقْضٌ':Predicate, #2: 2	رَدَّ نَفَقَةَ
u'رَدَّ نكاح':Predicate, #1: 1	رَدَّ النَّقْضَ
u'رَدَّ نِكَاحٌ':Predicate, #5: 5	رَدَّ نِكَاحَ
u'رَدَّ هِبَةٌ':Predicate, #5: 5	رَدَّ نِكَاحَ
u'رَدَّ واحد':Subject, #6: 6	رَدَّ الْهِبَةَ
u'رَدَّ وَاحِدٌ':Subject, #6: 6	رَدَّ وَاحِدٌ
u'رَدَّ وَارِثٌ':Subject, #6: 6	رَدَّ وَاحِدٌ
u'رُدُودٌ علماء':Added, #2: 2	رَدَّ الْوَارِثُ
u'رُدُودٌ عُلَمَاءُ':Added, #1: 1	رُدُودُ الْعُلَمَاءِ
u'رَدَّ وَدِيعٌ':Predicate, #1: 1	رُدُودُ الْعُلَمَاءِ
u'رَدَّ وَدِيعَةٌ':Predicate, #11: 11	رَدَّ الْوَدِيعَةَ
u'رَدَّ وَرَثَةٌ':Subject, #11: 11	رَدَّ الْوَدِيعَةَ
u'رَدَّ وَرَثَةٌ':Subject, #2: 2	رَدَّ وَرَثَتُهُ
u'رَدَّ وَصِيٌّ':Predicate, #3: 3	رَدَّ الْوَرَثَةُ
u'رَدَّ وَصِيَّةٌ':Predicate, #5: 5	رَدَّ الْوَصِيَّةَ
u'رَدَّ وَقْفٌ':Predicate, #5: 5	رَدَّ الْوَصِيَّةَ
u'رَدَّ وَكِيلٌ':Subject, #3: 3	رَدَّ الْوَقْفَ
u'رَدَّ وَكِيلٌ':Subject, #1: 1	رَدَّ وَكِيلُهُ
u'رَدَّ ولد':Predicate, #4: 4	رَدَّ الْوَكِيلُ
u'رَدَّ وَلَدٌ':Predicate, #1: 1	رَدَّ الْوَلَدَ
u'رَدَّ ولد':Subject, #1: 1	رَدَّ الْوَلَدَ
u'رَدَّ وَلَدٌ':Subject, #1: 1	رَدَّ وَلَدُ
u'رَدَّ وَلِيٌّ':Subject, #1: 1	رَدَّ وَلَدُ
u'رَدَّ يَمِينٌ':Predicate, #2: 2	رَدَّ الْوَلِيُّ
u'رَدَّ يَوْمٌ':Predicate, #8: 8	رَدَّ الْيَمِينَ
u'رذال مَالٌ':Added, #1: 1	رَدَّ يَوْمَ
u'رُذَالٌ مَالٌ':Added, #1: 1	رُذَالَ الْمَالِ
u'رذال مَالٌ':Added, #1: 1	رُذَالَ الْمَالِ
u'رُذَالٌ مَالٌ':Added, #2: 2	رُذَالُ الْمَالِ
u'رَزَقَ إمَامٌ':Subject, #2: 2	رُذَالُ الْمَالِ
u'رَزَقَ أَميرٌ':Subject, #2: 2	رَزَقَ الْإِمَامُ
u'رَزَقَ أهْلٌ':Subject, #3: 3	رَزَقَ الْأَمِيرُ
u'رَزَقَ رَسُولٌ':Subject, #1: 1	رَزَقَ أَهْلُ
u'رَسَا فلان':Subject, #1: 1	رَزَقَ رَسُولُ
u'رَسِلَ اِبْنٌ':Predicate, #1: 1	رَسَا حِرَاءٌ
u'رَسِلَ أُمٌّ':Predicate, #1: 1	أَرْسَلَ ابْنَ
u'رَسِلَ أيَّامٌ':Predicate, #2: 2	أَرْسَلَ أُمَّ
u'رَسِلَ أَيَّامٌ':Predicate, #1: 1	أَرْسَلَ أَيَّامَ
u'رَسِلَ بَدَلٌ':Predicate, #1: 1	أَرْسَلَ أَيَّامَ
u'رَسِلَ بُسْرٌ':Predicate, #1: 1	أَرْسَلَ الْبَدَلَ
u'رَسِلَ بَهيمٌ':Predicate, #1: 1	أَرْسَلَ بُسْرَ
u'رَسِلَ بَهِيمَةٌ':Predicate, #1: 1	أَرْسَلَ الْبَهِيمَةَ
u'رَسِلَ تَفْوِيضٌ':Predicate, #1: 1	أَرْسَلَ الْبَهِيمَةَ
u'رَسِلَ ثَلاثُ':Predicate, #2: 2	أَرْسَلَ التَّفْوِيضَ
u'رَسِلَ ثَلاثَةٌ':Predicate, #2: 2	أَرْسَلَ الثَّلَاثَ
u'رَسِلَ جَارِي':Predicate, #1: 1	أَرْسَلَ ثَلَاثَةَ
u'رَسِلَ جَارِيَةٌ':Predicate, #1: 1	أَرْسَلَ جَارِيَةَ
u'رَسِلَ حَديثٌ':Predicate, #1: 1	أَرْسَلَ جَارِيَةَ
u'رَسِلَ دَابَّةٌ':Predicate, #1: 1	أَرْسَلَ الْحَدِيثَ
u'رَسِلَ رَسُولٌ':Predicate, #1: 1	أَرْسَلَ الدَّابَّةَ
u'رَسِلَ رِياحٌ':Predicate, #1: 1	أَرْسَلَ الرَّسُولَ
u'رَسِلَ سَهْمٌ':Predicate, #1: 1	أَرْسَلَ الرِّيَاحَ
u'رَسِلَ صَوْبٌ':Predicate, #1: 1	أَرْسَلَ السَّهْمَ
u'رَسِلَ صَيْدٌ':Predicate, #1: 1	أَرْسَلَ صَوْبَ
u'رَسِلَ طَلاَقٌ':Predicate, #2: 2	أَرْسَلَ الصَّيْدَ
u'رَسِلَ عَامِلٌ':Predicate, #1: 1	أَرْسَلَ الطَّلَاقَ
u'رَسِلَ عَبْدٌ':Predicate, #1: 1	أَرْسَلَ الْعَامِلَ
u'رَسِلَ عتق':Predicate, #1: 1	أَرْسَلَ الْعَبْدَ
u'رَسِلَ عِتْقٌ':Predicate, #1: 1	أَرْسَلَ الْعِتْقَ
u'رَسِلَ فلان':Predicate, #1: 1	أَرْسَلَ الْعِتْقَ
u'رَسِلَ كِتَابٌ':Predicate, #1: 1	أَرْسَلَ عُثْمَانَ
u'رَسِلَ كِتَابَةٌ':Predicate, #1: 1	أَرْسَلَ الْكِتَابَ
u'رَسِلَ كَلاَمٌ':Predicate, #1: 1	أَرْسَلَ الْكِتَابَةَ
u'رَسِلَ كَلْبٌ':Predicate, #1: 1	أَرْسَلَ الْكَلَامَ
u'رَسِلَ مَاءٌ':Predicate, #2: 2	أَرْسَلَ الْكَلْبَ
u'رَسِلَ مُسْتَأْجِرٌ':Predicate, #3: 3	أَرْسَلَ الْمَاءَ
u'رَسِلَ مَلَكٌ':Predicate, #1: 1	أَرْسَلَ الْمُسْتَأْجِرَ
u'رَسِلَ نذر':Predicate, #1: 1	أَرْسَلَ الْمَلَكَ
u'رَسِلَ نَذْرٌ':Predicate, #2: 2	أَرْسَلَ النَّذْرَ
u'رَسِلَ وَتَرٌ':Predicate, #2: 2	أَرْسَلَ النَّذْرَ
u'رَسِلَ ولد':Predicate, #1: 1	أَرْسَلَ وَتَرَكَ
u'رَسِلَ وَلَدٌ':Predicate, #1: 1	أَرْسَلَ الْوَلَدَ
u'رَسْمٌ أُجْرَةٌ':Added, #1: 1	أَرْسَلَ الْوَلَدَ
u'رَسْمٌ إِخْلاَصٌ':Added, #1: 1	رَسْمِ الْأُجْرَةِ
u'رَسْمٌ أَسَدٌ':Added, #1: 1	رَسْمِ الْإِخْلَاصِ
u'رَسْمٌ أصل':Added, #1: 1	رَسْمِ أَسَدِ
u'رَسْمٌ أًصْلٌ':Added, #1: 1	رَسْمُ أَصْلِ
u'رَسْمٌ أَقْضِيَةٌ':Added, #1: 1	رَسْمُ أَصْلِ
u'رَسْمٌ أَقْضِيَةٌ':Added, #1: 1	رَسْمَ الْأَقْضِيَةِ
u'رَسَمَ إمَامٌ':Subject, #2: 2	رَسْمِ الْأَقْضِيَةِ
u'رَسْمٌ اِنْتِفاعٌ':Added, #1: 1	رَسَمَ الْإِمَامُ
u'رَسْمٌ بَراءةٌ':Added, #1: 1	رَسْمُ انْتِفَاعٍ
u'رَسْمٌ بَزّ':Added, #1: 1	رَسْمَ الْبَرَاءَةِ
u'رَسْمٌ بِنَاءٌ':Added, #2: 2	رَسْمَ الْبَزِّ
u'رَسْمٌ بيوع':Added, #1: 1	رَسْمِ بِنَاءِ
u'رَسْمٌ تَأْخِيرٌ':Added, #4: 4	رَسْمَ الْبُيُوعِ
u'رَسْمٌ تَأْخِيرٌ':Added, #1: 1	رَسْمَ تَأْخِيرٍ
u'رَسْمٌ تَزْكِيَةٌ':Added, #1: 1	رَسْمِ تَأْخِيرٍ
u'رَسْمٌ تَعَبُّدٌ':Added, #4: 4	رَسْمُ التَّزْكِيَةِ
u'رَسْمٌ تَعْدِيلٌ':Added, #1: 1	رَسْمِ التَّعَبُّدِ
u'رَسْمٌ تَهْدِيدٌ':Added, #5: 5	رَسْمُ التَّعْدِيلِ
u'رَسْمٌ ثَمَرَةٌ':Added, #1: 1	رَسْمِ التَّهْدِيدِ
u'رَسْمٌ جَوَابٌ':Added, #2: 2	رَسْمَ الثَّمَرَةِ
u'رَسْمٌ خراج':Added, #1: 1	رَسْمِ الْجَوَابِ
u'رَسْمٌ خَرَاجٌ':Added, #1: 1	رَسْمِ الْخَرَاجِ
u'رَسْمٌ دَارٌ':Added, #1: 1	رَسْمِ الْخَرَاجِ
u'رَسْمٌ دَارِسٌ':Added, #1: 1	رَسْمِ دَارٍ
u'رَسَمَ دُعَاءٌ':Predicate, #1: 1	رَسْمُ دَارِسَةِ
u'رَسْمٌ رَسُولٌ':Added, #1: 1	رَسَمَ الدُّعَاءَ
u'رَسْمٌ رُطَبٌ':Added, #1: 1	رَسْمَ الرّسُولِ
u'رَسْمٌ رُهونٌ':Added, #1: 1	رَسْمِ الرُّطَبِ
u'رَسْمٌ سِلْعَةٌ':Added, #1: 1	رَسْمِ الرُّهُونِ
u'رَسْمٌ سَلَفٌ':Added, #1: 1	رَسْمِ سِلْعَةٍ
u'رَسْمٌ سَمَاعٌ':Added, #2: 2	رَسْمَ سَلَفٍ
u'رَسْمٌ شَجَرَةٌ':Added, #1: 1	رَسْمِ سَمَاعٍ
u'رَسْمٌ شُرْبٌ':Added, #2: 2	رَسْمَ الشَّجَرَةِ
u'رَسْمٌ شِرْبٌ':Added, #15: 15	رَسْمُ شُرْبٍ
u'رَسْمٌ شُرْبٌ':Added, #2: 2	رَسْمُ شِرْبٍ
u'رَسْمٌ شَكٌّ':Added, #3: 3	رَسْمَ شُرْبٍ
u'رَسْمٌ شَهَادَةٌ':Added, #1: 1	رَسْمِ شَكٍّ
u'رَسْمٌ صبرة':Added, #1: 1	رَسْمِ شَهَادَتِهِ
u'رَسْمٌ صُبْرَةٌ':Added, #3: 3	رَسْمِ الصُّبْرَةِ
u'رَسْمٌ صَحِيحٌ':Added, #3: 3	رَسْمِ الصُّبْرَةِ
u'رَسْمٌ صَحِيحٌ':Added, #1: 1	رَسْم الصَّحِيحِ
u'رَسْمٌ صَلاَةٌ':Added, #1: 1	رَسْمِ الصَّحِيحِ
u'رَسْمٌ صَلاَةٌ':Added, #1: 1	رَسْمِ الصَّلَاةِ
u'رَسْمٌ طَرْحٌ':Added, #2: 2	رَسْمَ الصَّلَاةِ
u'رَسْمٌ طَرْحٌ':Added, #1: 1	رَسْمُ طَرْحِ
u'رَسْمٌ عَبْدٌ':Added, #2: 2	رَسْمِ طَرْحِ
u'رَسْمٌ عَبْدٌ':Added, #1: 1	رَسْمَ عَبْدٍ
u'رَسْمٌ عَرَبٌ':Added, #1: 1	رَسْمَ عَبْدِ
u'رَسْمٌ عِوَض':Added, #1: 1	رَسْمِ الْعَرَبِ
u'رَسْمٌ قُبَالَةٌ':Added, #1: 1	رَسْمِ الْعِوَضِيَّةِ
u'رَسْمٌ قِبْلَةٌ':Added, #1: 1	رَسْمِ الْقُبَالَةِ
u'رَسْمٌ قِبْلَةٌ':Added, #1: 1	رَسْمَ الْقِبْلَةِ
u'رَسْمٌ قسمة':Added, #3: 3	رَسْمِ الْقِبْلَةِ
u'رَسْمٌ قِسْمَةٌ':Added, #1: 1	رَسْمِ الْقِسْمَةِ
u'رَسْمٌ قضاة':Added, #1: 1	رَسْمِ الْقِسْمَةِ
u'رَسْمٌ قضاة':Added, #1: 1	رَسْمُ قُضَاةِ
u'رَسْمٌ قطعان':Added, #2: 2	رَسْمُ الْقُضَاةِ
u'رَسْمٌ قطعان':Added, #1: 1	رَسْمَ الْقُطْعَانِ
u'رَسْمٌ كَبْشٌ':Added, #1: 1	رَسْمِ الْقُطْعَانِ
u'رَسْمٌ كِتَابَةٌ':Added, #1: 1	رَسْمَ الْكَبْشِ
u'رَسْمٌ كُتُبٌ':Added, #1: 1	رَسْمِ الْكِتَابَةِ
u'رَسَمَ مَالِكٌ':Subject, #1: 1	رَسْمِ الْكُتُبِ
u'رَسْمٌ مُحْرِمٌ':Added, #1: 1	رَسَمَ مَالِكٌ
u'رَسْمٌ مُحْرِمٌ':Added, #1: 1	رَسْمَ الْمُحْرِمِ
u'رَسْمٌ مَسْأَلَةٌ':Added, #1: 1	رَسْمِ الْمُحْرِمِ
u'رَسْمٌ مُصْحَفٌ':Added, #1: 1	رَسْمُ الْمَسْأَلَةِ
u'رَسْمٌ مُصَنِّفٌ':Added, #2: 2	رَسْمَ الْمُصْحَفِ
u'رَسْمٌ مَفْهُومٌ':Added, #1: 1	رَسْمِ الْمُصَنِّفِ
u'رَسَمَ مَنْفَعَةٌ':Predicate, #1: 1	رَسْمِ مَفْهُومِ
u'رَسْمٌ نَاسِخٌ':Added, #1: 1	رَسَمَ الْمَنْفَعَةَ
u'رَسْمٌ نَاسِخ':Added, #2: 2	رَسْمُ النَّاسِخِ
u'رُسُومٌ تَوْقِيعٌ':Added, #2: 2	رَسْمُ النَّاسِخِ
u'رُسُومٌ جَاهِلِيٌّ':Added, #1: 1	رُسُومَ التَّوْقِيعَاتِ
u'رُسُومٌ جَاهِلِيَّةٌ':Added, #1: 1	رُسُومِ الْجَاهِلِيَّةِ
u'رُسُومٌ حُقوقٌ':Added, #1: 1	رُسُومِ الْجَاهِلِيَّةِ
u'رُسُومٌ حُقُوقٌ':Added, #1: 1	رُسُومَ الْحُقُوقِ
u'رُسُومٌ حُكَّامٌ':Added, #1: 1	رُسُومَ الْحُقُوقِ
u'رُسُومٌ دَارٌ':Added, #2: 2	رُسُومِ الْحُكَّامِ
u'رُسُومٌ سُنَّةٌ':Added, #1: 1	رُسُومُ الدّارِ
u'رُسُومٌ شِرْكٌ':Added, #1: 1	رُسُومُ السُّنَّةِ
u'رُسُومٌ كَفَرَةٌ':Added, #1: 1	رُسُومِ الشّرْكِ
u'رُسُومٌ مَجُوسٌ':Added, #1: 1	رُسُومَ الْكَفَرَةِ
u'رُسُومٌ هَيَاكِلُ':Added, #3: 3	رُسُومِ الْمَجُوسِ
u'رُسُومٌ وُقُوفٌ':Added, #1: 1	رُسُومِ الْهَيَاكِلِ
u'رَشَا فَرْخٌ':Subject, #1: 1	رُسُومُ الْوُقُوفِ
u'رَشَّ بَعْضٌ':Predicate, #1: 1	رَشَا الْفَرْخُ
u'رَشَّحَ اِبْنٌ':Subject, #2: 2	رَشَّ بَعْضَ
u'رَشْحٌ بُخارٌ':Added, #3: 3	رَشَّحَ ابْنُ
u'رَشَّحَ جَوَازٌ':Predicate, #1: 1	رَشْحُ بُخَارِ
u'رَشَّحَ قول':Predicate, #1: 1	رَشَّحَ الْجَوَازَ
u'رَشَّحَ قَوْلٌ':Predicate, #2: 2	رَشَّحَ قَوْلَ
u'رَشْحٌ مِسْكٌ':Added, #2: 2	رَشَّحَ قَوْلَ
u'رَشَدَ اِبْنٌ':Subject, #1: 1	رَشْحَ مِسْكٍ
u'رُشْدٌ الْمَرْأَةُ':Added, #1: 1	رَشَدَ ابْنُ
u'رَشَدَ بِنْتٌ':Subject, #1: 1	رُشْدُ الْمَرْأَةِ
u'رَشَدَ حَديثٌ':Predicate, #1: 1	رَشَدَ بِنْتُهُ
u'رُشْدٌ زَوْجٌ':Added, #1: 1	رَشَدَ الْحَدِيثَ
u'رُشْدٌ زَوْجَةٌ':Added, #1: 1	رُشْدُ الزَّوْجِ
u'رَشَدَ سَفِيهٌ':Subject, #1: 1	رُشْدُ الزَّوْجَةِ
u'رُشْدٌ سَفِيهٌ':Added, #1: 1	رَشَدَ السَّفِيهُ
u'رَشَدَ صَبِيٌّ':Subject, #1: 1	رُشْدِ السَّفِيهِ
u'رَشَدَ عند':Predicate, #1: 1	رَشَدَ الصَّبِيُّ
u'رُشْدٌ كَافِرٌ':Added, #1: 1	رَشَدَ عِنْدَ
u'رُشْدٌ مَالِكٌ':Added, #1: 1	رُشْدِ الْكَافِرِ
u'رَشَدَ مَحْجُورٌ':Subject, #1: 1	رُشْدِ الْمَالِكِ
u'رُشْدٌ مَقْطُوعٌ':Added, #1: 1	رَشَدَ مَحْجُورَتُهُ
u'رَشَدَ نَقْضٌ':Subject, #1: 1	رُشْدُ مَقْطُوعٍ
u'رُشْدٌ وَارِثٌ':Added, #1: 1	رَشَدَ نَقْضُ
u'رُشْدٌ ولد':Added, #1: 1	رُشْدِ وَارِثِهِ
u'رُشْدٌ وَلَدٌ':Added, #1: 1	رُشْدُ الْوَلَدِ
u'رُشْدٌ يَتِيمٌ':Added, #1: 1	رُشْدُ الْوَلَدِ
u'رَشَّ فِنَاءٌ':Predicate, #1: 1	رُشْدُ يَتِيمِهِ
u'رَشَّ قَبْرٌ':Predicate, #3: 3	رَشَّ فِنَاءَ
u'رَشَّ مَاءٌ':Predicate, #1: 1	رَشَّ قَبْرَ
u'رَضَاعَةٌ صَغِيرٌ':Added, #4: 4	رَشَّ الْمَاءَ
u'رَضَاعَةٌ كَبِيرٌ':Added, #2: 2	رَضَاعَةُ الصَّغِيرِ
u'رَضَخَ إمَامٌ':Subject, #2: 2	رَضَاعَةِ الْكَبِيرِ
u'رَضَخَ رَأْسٌ':Predicate, #1: 1	رَضَخَ الْإِمَامُ
u'رَضَخَ يَهُودِيٌّ':Subject, #2: 2	رَضَخَ رَأْسَ
u'رَضَّ رَأْسٌ':Predicate, #1: 1	رَضَخَ يَهُودِيٌّ
u'رَضَعَ خامس':Predicate, #5: 5	رَضَّ رَأْسَ
u'رَضِعَ خامس':Predicate, #1: 1	أَرْضَعَ الْخَامِسَةَ
u'رَضَعَ خَامِسٌ':Predicate, #1: 1	أَرْضَعَ الْخَامِسَةَ
u'رَضِعَ خَامِسٌ':Predicate, #1: 1	أَرْضَعَ الْخَامِسَةَ
u'رَضَعَ صَبِيٌّ':Subject, #1: 1	أَرْضَعَ الْخَامِسَةَ
u'رَضِعَ صَبِيٌّ':Subject, #1: 1	رَضَعَ الصَّبِيُّ
u'رَضَعَ صَبِيٌّ':Subject, #1: 1	رَضِعَ الصَّبِيُّ
u'رَضَعَ فُلاَنٌ':Subject, #1: 1	رَضَعَ صَبِيٌّ
u'رَضَعَ لُؤْمٌ':Predicate, #1: 1	رَضَعَ فُلَانٌ
u'رَضَّ واحد':Predicate, #1: 1	رَضَعَ اللّؤْمَ
u'رَضَّ وَاحِدٌ':Predicate, #1: 1	رَضَّ وَاحِدَةً
u'رَضِيَ أَبٌ':Subject, #1: 1	رَضَّ وَاحِدَةً
u'رَضِيَ آباءٌ':Predicate, #1: 1	رَضِيَ الْأَبُ
u'رَضِيَ أَبْعَدُ':Subject, #1: 1	رَضِيَ الْآبَاءَ
u'رَضِيَ أحَدٌ':Subject, #1: 1	رَضِيَ الْأَبْعَدُ
u'رَضِيَ أرْبَابٌ':Subject, #3: 3	رَضِيَ أَحَدُ
u'رَضِيَ أَصْحَابٌ':Subject, #1: 1	رَضِيَ أَرْبَابُ
u'رَضِيَ أكَّارٌ':Predicate, #1: 1	رَضِيَ أَصْحَابُ
u'رَضِيَ اللهُ':Subject, #1: 1	رَضِيَ الْأَكَّارَ
u'رَضِيَ إلَهٌ':Subject, #6: 6	رَضِيَ اللهُ
u'رَضِيَ أهْلٌ':Subject, #2: 2	رَضِيَ الْإِلَهُ
u'رَضِيَ بَائِعٌ':Subject, #3: 3	رَضِيَ أَهْلُ
u'رَضِيَ بَائِعٌ':Subject, #1: 1	رَضِيَ بَائِعُ
u'رَضِيَ بَائِعٌ':Subject, #25: 25	رَضِيَ الْبَائِعُ
u'رَضِيَ بَرِيءٌ':Subject, #2: 2	رَضِيَ بَائِعُهُ
u'رَضِيَ تَابِعٌ':Subject, #1: 1	رَضِيَ الْبَرِيءُ
u'رَضِيَ جَارٌ':Subject, #1: 1	رَضِيَ التَّابِعُ
u'رَضِيَ جَازٌ':Predicate, #3: 3	رَضِيَ الْجَارُ
u'رَضِيَ جَازٌ':Predicate, #1: 1	رَضِيَ جَازَ
u'رَضِيَ جَمِيع':Subject, #2: 2	أَرْضَى جَازَ
u'رَضِيَ جِيرَانٌ':Subject, #2: 2	رَضِيَ الْجَمِيعُ
u'رَضِيَ حَتْمٌ':Subject, #2: 2	رَضِيَ الْجِيرَانُ
u'رَضِيَ خَاطِبٌ':Subject, #1: 1	رَضِيَ حَتْمٌ
u'رَضِيَ خَصْمٌ':Subject, #1: 1	رَضِيَ الْخَاطِبُ
u'رَضِيَ ذِمِّيٌّ':Subject, #3: 3	رَضِيَ الْخَصْمُ
u'رَضِيَ رَاهِنٌ':Subject, #2: 2	رَضِيَ الذِّمِّيُّ
u'رَضِيَ رَبُّ':Subject, #2: 2	رَضِيَ الرَّاهِنُ
u'رَضِيَ زَارِعٌ':Subject, #5: 5	رَضِيَ رَبُّ
u'رَضِيَ زَوْجٌ':Subject, #1: 1	رَضِيَ الزَّارِعُ
u'رَضِيَ زَوْجَةٌ':Subject, #15: 15	رَضِيَ الزَّوْجُ
u'رَضِيَ زَيْدٌ':Subject, #1: 1	رَضِيَ الزَّوْجَاتُ
u'رَضِيَ سِلْعَةٌ':Predicate, #1: 1	رَضِيَ زَيْدٌ
u'رَضِيَ سَيِّدٌ':Subject, #1: 1	رَضِيَ السِّلْعَةَ
u'رَضِيَ سَيِّدٌ':Subject, #1: 1	رَضِيَ سَيِّدُ
u'رَضِيَ سَيِّدٌ':Subject, #2: 2	رَضِيَ السَّيِّدُ
u'رَضِيَ شَرِيكٌ':Subject, #2: 2	رَضِيَ سَيِّدُهُ
u'رَضِيَ شَرِيكٌ':Subject, #3: 3	رَضِيَ الشَّرِيكُ
u'رَضِيَ صَاحِبٌ':Subject, #4: 4	رَضِيَ شَرِيكُهُ
u'رَضِيَ صَاحِبٌ':Subject, #1: 1	رَضِيَ صَاحِبُهُ
u'رَضِيَ عَامِلٌ':Subject, #5: 5	رَضِيَ صَاحِبُ
u'رَضِيَ عَبْدٌ':Subject, #3: 3	رَضِيَ الْعَامِلُ
u'رَضِيَ عَسْكَرٌ':Subject, #4: 4	رَضِيَ الْعَبْدُ
u'رَضِيَ عند':Predicate, #1: 1	رَضِيَ الْعَسْكَرُ
u'رَضِيَ عَوْدٌ':Predicate, #1: 1	رَضِيَ عِنْدَ
u'رَضِيَ غرماء':Subject, #1: 1	رَضِيَ الْعَوْدَ
u'رَضِيَ غَرِيمٌ':Subject, #4: 4	رَضِيَ الْغُرَمَاءُ
u'رَضِيَ فَقِيرٌ':Subject, #1: 1	رَضِيَ الْغَرِيمُ
u'رَضِيَ فُلاَنٌ':Subject, #1: 1	رَضِيَ الْفَقِيرُ
u'رَضِيَ قَيِّمٌ':Subject, #10: 10	رَضِيَ فُلَانٌ
u'رَضِيَ مَالِكٌ':Subject, #2: 2	رَضِيَ الْقَيِّمُ
u'رَضِيَ مَجْنِيٌّ':Subject, #5: 5	رَضِيَ الْمَالِكُ
u'رَضِيَ مُحْتَالٌ':Subject, #1: 1	رَضِيَ الْمَجْنِيُّ
u'رَضِيَ مَحْرُومٌ':Subject, #2: 2	رَضِيَ الْمُحْتَالُ
u'رَضِيَ مُحَكَّمٌ':Subject, #1: 1	رَضِيَ الْمَحْرُومُ
u'رَضِيَ مَدْيُونٌ':Subject, #1: 1	رَضِيَ الْمُحَكَّمُ
u'رَضِيَ مُرْتَهِنٌ':Subject, #1: 1	رَضِيَ الْمَدْيُونُ
u'رَضِيَ مُرْتَهِنٌ':Subject, #1: 1	رَضِيَ مُرْتَهِنُهُ
u'رَضِيَ مُزَارِعٌ':Subject, #4: 4	رَضِيَ الْمُرْتَهِنُ
u'رَضِيَ مُسْتَأْجِرٌ':Subject, #1: 1	رَضِيَ الْمُزَارِعُ
u'رَضِيَ مُسْتَحِقٌّ':Subject, #7: 7	رَضِيَ الْمُسْتَأْجِرُ
u'رَضِيَ مُسْتَعِيرٌ':Subject, #1: 1	رَضِيَ الْمُسْتَحِقُّ
u'رَضِيَ مُسْلِمٌ':Subject, #1: 1	رَضِيَ الْمُسْتَعِيرُ
u'رَضِيَ مُشْتَرِط':Subject, #1: 1	رَضِيَ الْمُسْلِمُ
u'رَضِيَ مُضْطَرٌّ':Subject, #1: 1	رَضِيَ مُشْتَرِطُ
u'رَضِيَ مَطْلُوبٌ':Subject, #1: 1	رَضِيَ الْمُضْطَرُّ
u'رَضِيَ مُعِير':Subject, #1: 1	رَضِيَ الْمَطْلُوبُ
u'رَضِيَ مُفْلِسٌ':Subject, #2: 2	رَضِيَ الْمُعِيرُ
u'رَضِيَ مُقْرِضٌ':Subject, #1: 1	رَضِيَ الْمُفْلِسُ
u'رَضِيَ مُؤَجِّرٌ':Subject, #1: 1	رَضِيَ الْمُقْرِضُ
u'رَضِيَ مَوْقُوفٌ':Subject, #2: 2	رَضِيَ الْمُؤَجِّرُ
u'رَضِيَ مُوَكِّلٌ':Subject, #1: 1	رَضِيَ الْمَوْقُوفُ
u'رَضِيَ نَاظِرٌ':Subject, #3: 3	رَضِيَ الْمُوَكِّلُ
u'رَضِيَ وَاجِدٌ':Subject, #1: 1	رَضِيَ النَّاظِرُ
u'رَضِيَ وَارِثٌ':Subject, #1: 1	رَضِيَ وَاجِدُهُ
u'رَضِيَ وَارِثٌ':Subject, #2: 2	رَضِيَ الْوَارِثُ
u'رَضِيَ وَرَثَةٌ':Subject, #2: 2	رَضِيَ وَارِثُ
u'رَضِيَ وَصِيٌّ':Subject, #1: 1	رَضِيَ وَرَثَةُ
u'رَضِيَ وَكِيلٌ':Subject, #1: 1	رَضِيَ الْوَصِيُّ
u'رَضِيَ ولد':Subject, #1: 1	رَضِيَ الْوَكِيلُ
u'رَضِيَ وَلَدٌ':Subject, #2: 2	رَضِيَ الْوَلَدُ
u'رَضِيَ وَلِيٌّ':Subject, #2: 2	رَضِيَ الْوَلَدُ
u'رَضِيَ وَلِيٌّ':Subject, #1: 1	رَضِيَ وَلِيُّهُ
u'رَطْبٌ جَوْزٌ':Added, #2: 2	رَضِيَ الْوَلِيُّ
u'رَطْبٌ طَيْرٌ':Added, #1: 1	رَطْبُ الْجَوْزِ
u'رَطْبٌ فَمٌ':Added, #1: 1	رَطْبُ الطَّيْرِ
u'رَطْبٌ فواكه':Added, #1: 1	رَطْبِ الْفَمِ
u'رَطْبٌ فَوَاكِهُ':Added, #5: 5	رَطْبِ الْفَوَاكِهِ
u'رَطْبٌ كَلاَمٌ':Added, #5: 5	رَطْبِ الْفَوَاكِهِ
u'رَطِبَ وَرَاقٌ':Predicate, #2: 2	رَطْبَ الْكَلَامِ
u'رُعْبٌ ولد':Added, #1: 1	رَطِبَ وَرَاقَ
u'رُعْبٌ وَلَدٌ':Added, #1: 1	رُعْبَ الْوَلَدِ
u'رَعَدَ كُمٌّ':Subject, #1: 1	رُعْبَ الْوَلَدِ
u'رَعَفَ إمَامٌ':Subject, #2: 2	رَعَدَ كُمُّ
u'رَعَفَ قَلَمٌ':Subject, #4: 4	رَعَفَ الْإِمَامُ
u'رَعَى أحَدٌ':Subject, #1: 1	رَعَفَ الْقَلَمُ
u'رَعْيٌ أَغْنَامٌ':Added, #1: 1	رَعَى أَحَدٌ
u'رَعْيٌ أَغْنَامٌ':Added, #1: 1	رَعْيَ أَغْنَامٍ
u'رَعْيٌ أَغْنَامٌ':Added, #1: 1	رَعْيُ أَغْنَامِ
u'رَعْيٌ أَوْلاَدٌ':Added, #1: 1	رَعْيِ الْأَغْنَامِ
u'رَعْيٌ أَوْلاَدٌ':Added, #1: 1	رَعْيُ أَوْلَادِ
u'رَعْيٌ بَقاءٌ':Added, #2: 2	رَعْيُ الْأَوْلَادِ
u'رَعَى جَدْب':Predicate, #1: 1	رَعْيِ بَقَاءِ
u'رَعْيٌ حَشِيشٌ':Added, #1: 1	رَعَى الْجَدْبَةَ
u'رَعْيٌ حَشِيشٌ':Added, #1: 1	رَعْيُ الْحَشِيشِ
u'رَعْيٌ حَشِيشٌ':Added, #1: 1	رَعْيِ الْحَشِيشِ
u'رَعْيٌ حَشِيشٌ':Added, #1: 1	رَعْيُ حَشِيشِ
u'رَعْيٌ حَشِيشٌ':Added, #1: 1	رَعْي حَشِيشِهِ
u'رَعْيٌ حَشِيشٌ':Added, #1: 1	رَعْيُ حَشِيشِهِ
u'رَعْيٌ حَيَوَانٌ':Added, #1: 1	رَعْيِ حَشِيشِهِ
u'رَعْيٌ دَوَابُّ':Added, #1: 1	رَعْيِ حَيَوَانٍ
u'رَعْيٌ زَوْجٌ':Added, #3: 3	رَعْيِ الدَّوَابِّ
u'رَعَى عُشْبٌ':Predicate, #2: 2	رَعْيِ الزَّوْجِ
u'رَعَى غَنَمٌ':Predicate, #1: 1	رَعَى الْعُشْبَ
u'رَعْيٌ غَنَمٌ':Added, #3: 3	رَعَى الْغَنَمَ
u'رَعْيٌ غَنَمٌ':Added, #1: 1	رَعْيُ الْغَنَمِ
u'رَعْيٌ غَنَمٌ':Added, #1: 1	رَعْيِ غَنَمٍ
u'رَعْيٌ غَنَمٌ':Added, #2: 2	رَعْيَ الْغَنَمِ
u'رَعْيٌ غير':Added, #3: 3	رَعْيِ الْغَنَمِ
u'رَعْيٌ غَيْرٌ':Added, #1: 1	رَعْيِ غَيْرِ
u'رَعْيٌ كَلَأٌ':Added, #1: 1	رَعْيِ غَيْرِ
u'رَعْيٌ لَفْظٌ':Added, #1: 1	رَعْيِ الْكَلَأِ
u'رَعْيٌ لئام':Added, #1: 1	رَعْيِ اللَّفْظِ
u'رَعْيٌ لَيْلٌ':Added, #1: 1	رَعْيُ اللِّئَامِ
u'رَعْيٌ مَاشِي':Added, #1: 1	رَعْيُ اللَّيْلِ
u'رَعْيٌ مَاشِي':Added, #1: 1	رَعْيَ الْمَاشِيَةِ
u'رَعْيٌ مَاشِيَةٌ':Added, #1: 1	رَعْيُ الْمَاشِيَةِ
u'رَعْيٌ مَاشِيَةٌ':Added, #1: 1	رَعْيَ الْمَاشِيَةِ
u'رَعْيٌ مَقْصِدٌ':Added, #1: 1	رَعْيُ الْمَاشِيَةِ
u'رَعَى نَبِيٌّ':Subject, #1: 1	رَعْيُ الْمَقْصِدِ
u'رَعْيٌ نِتَاجٌ':Added, #2: 2	رَعَى النَّبِيُّ
u'رَعْيٌ نهار':Added, #1: 1	رَعْيُ نِتَاجِهِ
u'رَعْيٌ نَهَارٌ':Added, #1: 1	رَعْيُ النَّهَارِ
u'رَعْيٌ ولد':Added, #1: 1	رَعْيُ النَّهَارِ
u'رَعْيٌ ولد':Added, #1: 1	رَعْيَ الْوَلَدِ
u'رَعْيٌ وَلَدٌ':Added, #1: 1	رَعْيُ الْوَلَدِ
u'رَعْيٌ وَلَدٌ':Added, #1: 1	رَعْيَ الْوَلَدِ
u'رَغِبَ أحَدٌ':Subject, #1: 1	رَعْيُ الْوَلَدِ
u'رَغِبَ بَائِعٌ':Subject, #1: 1	رَغِبَ أَحَدٌ
u'رَغْبَةٌ اِعْتِداءٌ':Added, #3: 3	رَغِبَ الْبَائِعُ
u'رَغْبَةٌ أكفاء':Added, #1: 1	رَغْبَةِ اعْتِدَاءٍ
u'رَغْبَةٌ باذِلٌ':Added, #1: 1	رَغْبَةِ الْأَكْفَاءِ
u'رَغْبَةٌ رِجَالٌ':Added, #1: 1	رَغْبَةِ بَاذِلِهِ
u'رَغْبَةٌ رَجُلٌ':Added, #1: 1	رَغْبَةِ الرِّجَالِ
u'رَغْبَةٌ رَجُلٌ':Added, #1: 1	رَغْبَةُ الرَّجُلِ
u'رَغْبَةٌ زَوْجٌ':Added, #2: 2	رَغْبَةِ الرَّجُلِ
u'رَغْبَةٌ شَفِيعٌ':Added, #2: 2	رَغْبَةِ الزَّوْجِ
u'رَغْبَةٌ صَحَابَةٌ':Added, #1: 1	رَغْبَةِ الشَّفِيعِ
u'رَغْبَةٌ فضلاء':Added, #1: 1	رَغْبَةَ الصَّحَابَةِ
u'رَغْبَةٌ فُضَلاَءُ':Added, #1: 1	رَغْبَةُ فُضَلَاءِ
u'رَغْبَةٌ مَالِكٌ':Added, #1: 1	رَغْبَةُ فُضَلَاءِ
u'رَغْبَةٌ مُتَحَقِّق':Added, #1: 1	رَغْبَةَ مَالِكِهِ
u'رَغْبَةٌ مَرْجُوّ':Added, #1: 1	رَغْبَةَ مُتَحَقِّقٍ
u'رَغْبَةٌ نَاسٌ':Added, #1: 1	رَغْبَةٍ مَرْجُوَّةٍ
u'رَغْبَةٌ نَفْسٌ':Added, #1: 1	رَغْبَةِ النَّاسِ
u'رَغْبَةٌ واحد':Added, #1: 1	رَغْبَةِ النَّفْسِ
u'رَغْبَةٌ وَاحِدٌ':Added, #1: 1	رَغْبَةُ الْوَاحِدِ
u'رَغِبَ راغِب':Subject, #1: 1	رَغْبَةُ الْوَاحِدِ
u'رَغِبَ رَسُولٌ':Subject, #1: 1	رَغِبَ رَاغِبٌ
u'رَغِبَ شَارِعٌ':Subject, #1: 1	رَغِبَ رَسُولُ
u'رَغَّبَ شَارِعٌ':Subject, #1: 1	رَغِبَ الشَّارِعُ
u'رَغَّبَ شَرْعٌ':Subject, #4: 4	رَغَّبَ الشَّارِعُ
u'رَغِبَ عَبْدٌ':Subject, #1: 1	رَغَّبَ الشَّرْعُ
u'رَغِبَ فلان':Subject, #1: 1	رَغِبَ الْعَبْدُ
u'رَغِبَ مَلِكٌ':Subject, #1: 1	رَغِبَ رَاغِبٌ
u'رَغِبَ نَاسٌ':Subject, #2: 2	رَغِبَ الْمَلِكُ
u'رَغِبَ نَبِيٌّ':Subject, #1: 1	رَغِبَ النَّاسُ
u'رَغِمَ أَنْفٌ':Predicate, #1: 1	رَغِبَ نَبِيُّ
u'رَغِمَ أَنْفٌ':Subject, #1: 1	أَرْغَمَ أَنْفَ
u'رَغِمَ أَنْفٌ':Subject, #4: 4	رَغِمَ أَنْفُهُ
u'رَغْمٌ أَنْفٌ':Added, #8: 8	رَغِمَ أَنْفُ
u'رَغْمٌ أَنْفٌ':Added, #1: 1	رَغْم أَنْفِ
u'رَغْمٌ أَنْفٌ':Added, #1: 1	رَغْمَ أَنْفِ
u'رَغْمٌ أَنْفٌ':Added, #1: 1	رَغْمِ أَنْفٍ
u'رَغْمٌ دُعَاءٌ':Added, #1: 1	رَغْمِ أَنْفِ
u'رَغِمَ فلان':Subject, #1: 1	رَغْمَ الدّعَاءِ
u'رَغِمَ مُعاوِيَة':Subject, #1: 1	رَغِمَ مُعَاوِيَةُ
u'رَفَّأَ إِنْسانٌ':Predicate, #1: 1	رَغِمَ مُعَاوِيَةُ
u'رَفَأَ سَفِينَةٌ':Predicate, #1: 1	رَفَّأَ الإِنْسَانَ
u'رَفَأَ نَاسٌ':Subject, #1: 1	رَفَأَ السَّفِينَةَ
u'رَفْضٌ إِحْرَامٌ':Added, #1: 1	رَفَأَ النَّاسُ
u'رَفْضٌ إِحْرَامٌ':Added, #1: 1	رَفْضُ الْإِحْرَامِ
u'رَفْضٌ إِحْرَامٌ':Added, #1: 1	رَفْضِ الْإِحْرَامِ
u'رَفَضَ إقامَةٌ':Predicate, #2: 2	رَفْضَ الْإِحْرَامِ
u'رَفْضٌ إِيجَابٌ':Added, #1: 1	رَفَضَ الْإِقَامَةَ
u'رَفْضٌ تَسْلِيمٌ':Added, #1: 1	رَفْضُ الْإِيجَابِ
u'رَفَضَ ثَانِي':Predicate, #1: 1	رَفْضُ تَسْلِيمِ
u'رَفَضَ ثَانِيَةٌ':Predicate, #2: 2	رَفَضَ الثَّانِيَةَ
u'رَفَضَ حَجٌّ':Predicate, #2: 2	رَفَضَ الثَّانِيَةَ
u'رَفْضٌ حَجٌّ':Added, #5: 5	رَفَضَ الْحَجَّ
u'رَفْضٌ حَجٌّ':Added, #1: 1	رَفْضُ الْحَجِّ
u'رَفْضٌ حَجٌّ':Added, #3: 3	رَفْضَ الْحَجِّ
u'رَفَضَ دنيا':Subject, #9: 9	رَفْضِ الْحَجِّ
u'رَفَضَ دُنْيا':Subject, #1: 1	رَفَضَ دُنْيَاهُ
u'رَفْضٌ رُكْنٌ':Added, #1: 1	رَفَضَ دُنْيَاهُ
u'رَفْضٌ رُكْن':Added, #1: 1	رَفْضِ الرُّكْنِ
u'رَفْضٌ رُكْنٌ':Added, #1: 1	رَفْضِ الرُّكْنِ
u'رَفْضٌ رُكْن':Added, #1: 1	رَفْضُ رُكْنٍ
u'رَفَضَ رُكوعٌ':Predicate, #1: 1	رَفْضُ رُكْنٍ
u'رَفْضٌ رُكوعٌ':Added, #1: 1	رَفَضَ الرُّكُوعَ
u'رَفْضٌ شَرَائِعُ':Added, #1: 1	رَفْضُ الرُّكُوعِ
u'رَفْضٌ صَلاَةٌ':Added, #1: 1	رَفْضُ الشَّرَائِعِ
u'رَفْضٌ طعام':Added, #1: 1	رَفْضَ الصَّلَاةِ
u'رَفْضٌ طَعَامٌ':Added, #1: 1	رَفْضِ الطَّعَامِ
u'رَفَضَ عمرة':Predicate, #1: 1	رَفْضِ الطَّعَامِ
u'رَفَضَ عُمْرَةٌ':Predicate, #4: 4	رَفَضَ الْعُمْرَةَ
u'رَفْضٌ عمرة':Added, #4: 4	رَفَضَ الْعُمْرَةَ
u'رَفْضٌ عُمْرَةٌ':Added, #7: 7	رَفْضُ الْعُمْرَةِ
u'رَفْضٌ عمرة':Added, #7: 7	رَفْضُ الْعُمْرَةِ
u'رَفْضٌ عُمْرَةٌ':Added, #8: 8	رَفْضِ الْعُمْرَةِ
u'رَفْضٌ فَاسِدٌ':Added, #8: 8	رَفْضِ الْعُمْرَةِ
u'رَفَضَ فَرْضٌ':Predicate, #1: 1	رَفْضَ الْفَاسِدَةِ
u'رَفْضٌ فَرْضٌ':Added, #1: 1	رَفَضَ الْفَرْضَ
u'رَفَضَ قول':Predicate, #2: 2	رَفْضُ الْفَرْضِ
u'رَفَضَ قَوْلٌ':Predicate, #1: 1	رَفَضَ قَوْلَ
u'رَفَضَ مَوَاضِعُ':Predicate, #1: 1	رَفَضَ قَوْلَ
u'رَفْضٌ نِساءٌ':Added, #1: 1	رَفَضَ مَوَاضِعَ
u'رَفْضٌ نُسُكٌ':Added, #2: 2	رَفْضُ النِّسَاءِ
u'رَفْضٌ نُسُكٌ':Added, #1: 1	رَفْضِ النُّسُكِ
u'رَفَضَ نِيَّةٌ':Predicate, #1: 1	رَفْضُ نُسُكٍ
u'رَفْضٌ نِيَّةٌ':Added, #1: 1	رَفَضَ النِّيَّةَ
u'رَفْضٌ نِيَّةٌ':Added, #1: 1	رَفْضُ النِّيَّةِ
u'رَفْضٌ نِيَّةٌ':Added, #1: 1	رَفْضِ نِيَّةِ
u'رَفْعٌ إبَاحَةٌ':Added, #2: 2	رَفْضَ النِّيَّةِ
u'رَفْعٌ إبَاحَةٌ':Added, #1: 1	رَفْعُ الْإِبَاحَةِ
u'رَفْعٌ إِبْهَامٌ':Added, #6: 6	رَفْعَ الْإِبَاحَةِ
u'رَفَعَ إِثْمٌ':Predicate, #1: 1	رَفْعُ الْإِبْهَامِ
u'رَفْعٌ إِثْمٌ':Added, #1: 1	رَفَعَ الْإِثْمَ
u'رَفْعٌ إِثْمٌ':Added, #2: 2	رَفْعَ الْإِثْمِ
u'رَفْعٌ إِثْمٌ':Added, #5: 5	رَفْعِ الْإِثْمِ
u'رَفْعٌ إِجْمَالٌ':Added, #6: 6	رَفْعُ الْإِثْمِ
u'رَفْعٌ إِجْمَالٌ':Added, #1: 1	رَفْعِ إجْمَالٍ
u'رَفْعٌ اِحْتِمَالٌ':Added, #1: 1	رَفْعِ الْإِجْمَالِ
u'رَفْعٌ اِحْتِمَالٌ':Added, #1: 1	رَفْعُ احْتِمَالِ
u'رَفْعٌ اِحْتِمَالٌ':Added, #2: 2	رَفْعَ احْتِمَالِ
u'رَفَعَ أحَدٌ':Subject, #2: 2	رَفْعُ احْتِمَالٍ
u'رَفْعٌ أحَدٌ':Added, #1: 1	رَفَعَ أَحَدُ
u'رَفْعٌ أَحْداثٌ':Added, #1: 1	رَفْعَ أَحَدِ
u'رَفْعٌ أَحْدَاثٌ':Added, #2: 2	رَفْعِ الْأَحْدَاثِ
u'رَفْعٌ إِحْرَامٌ':Added, #2: 2	رَفْعِ الْأَحْدَاثِ
u'رَفْعٌ أَحْكَامٌ':Added, #1: 1	رَفْعَ الْإِحْرَامِ
u'رَفْعٌ أَذَانٌ':Added, #1: 1	رَفْعَ الْأَحْكَامِ
u'رَفْعٌ إِذْنٌ':Added, #1: 1	رَفْعَ الْأَذَانِ
u'رَفْعٌ اِسْتِبَاحَةٌ':Added, #1: 1	رَفْعِ الْإِذْنِ
u'رَفْعٌ اِسْمٌ':Added, #1: 1	رَفْعُ اسْتِبَاحَةِ
u'رَفْعٌ إِشْراكٌ':Added, #1: 1	رَفْعِ اسْمِ
u'رَفْعٌ إِشْكالٌ':Added, #1: 1	رَفْعَ الْإِشْرَاكِ
u'رَفْعٌ أصل':Added, #3: 3	رَفْعِ الْإِشْكَالِ
u'رَفْعٌ أصل':Added, #1: 1	رَفْعَ الْأَصْلِ
u'رَفْعٌ أًصْلٌ':Added, #1: 1	رَفْعُ الْأَصْلِ
u'رَفْعٌ أًصْلٌ':Added, #1: 1	رَفْعَ الْأَصْلِ
u'رَفْعٌ أصل':Added, #1: 1	رَفْعُ الْأَصْلِ
u'رَفْعٌ أًصْلٌ':Added, #2: 2	رَفْعَ أَصْلِ
u'رَفْعٌ أَصْوَاتٌ':Added, #2: 2	رَفْعَ أَصْلِ
u'رَفْعٌ أَصْوَاتٌ':Added, #1: 1	رَفْعَ أَصْوَاتٍ
u'رَفْعٌ أَصْوَاتٌ':Added, #2: 2	رَفْعَ الْأَصْوَاتِ
u'رَفْعٌ أَصْوَاتٌ':Added, #2: 2	رَفْعُ الْأَصْوَاتِ
u'رَفْعٌ أَعْمَالٌ':Added, #3: 3	رَفْعِ الْأَصْوَاتِ
u'رَفْعٌ أَعْمِدَةٌ':Added, #1: 1	رَفْعِ أَعْمَالِ
u'رَفْعٌ أَفْعَالٌ':Added, #2: 2	رَفْعِ الْأَعْمِدَةِ
u'رَفْعٌ أكْبَرُ':Added, #1: 1	رَفْعَ الْأَفْعَالِ
u'رَفَعَ ألف':Predicate, #2: 2	رَفْعِ الْأَكْبَرِ
u'رَفَعَ ألْفٌ':Predicate, #3: 3	رَفَعَ الْأَلْفَ
u'رَفَعَ أَلْفٌ':Predicate, #3: 3	رَفَعَ الْأَلْفَ
u'رَفَعَ إمَامٌ':Subject, #3: 3	رَفَعَ الْأَلْفَ
u'رَفَعَ إمَامٌ':Subject, #22: 22	رَفَعَ الْإِمَامُ
u'رَفَعَ إمَامٌ':Subject, #2: 2	رَفَعَ الإِمَامُ
u'رَفْعٌ إمَامٌ':Added, #4: 4	رَفَعَ إمَامُهُ
u'رَفْعٌ إمَامٌ':Added, #11: 11	رَفْعِ الْإِمَامِ
u'رَفْعٌ إمَامٌ':Added, #1: 1	رَفْعِ إمَامِهِ
u'رَفْعٌ أمَانَةٌ':Added, #2: 2	رَفْعَ الْإِمَامِ
u'رَفْعٌ أمَانَةٌ':Added, #1: 1	رَفْعَ الْأَمَانَةِ
u'رَفَعَ أَمْرٌ':Predicate, #1: 1	رَفْعِ الْأَمَانَةِ
u'رَفْعٌ أَمْرٌ':Added, #30: 30	رَفَعَ الْأَمْرَ
u'رَفْعٌ أَمْرٌ':Added, #2: 2	رَفْعَ الْأَمْرِ
u'رَفْعٌ أَمْرٌ':Added, #4: 4	رَفْعُ الْأَمْرِ
u'رَفَعَ أَميرٌ':Subject, #7: 7	رَفْعِ الْأَمْرِ
u'رَفَعَ إِنْسانٌ':Subject, #1: 1	رَفَعَ أَمِيرُ
u'رَفَعَ أَوَّلُ':Subject, #3: 3	رَفَعَ إنْسَانٌ
u'رَفْعٌ أَوَّلُ':Added, #1: 1	رَفَعَ الْأَوَّلُ
u'رَفْعٌ إِيجَابٌ':Added, #1: 1	رَفْعُ الْأَوَّلِ
u'رَفْعٌ بَابٌ':Added, #1: 1	رَفْعُ إيجَابِهِ
u'رَفْعٌ بالِغٌ':Added, #1: 1	رَفْعَ بَابِهِ
u'رَفْعٌ بَذْرٌ':Added, #1: 1	رَفْعٍ بَالِغٍ
u'رَفْعٌ بَراءةٌ':Added, #1: 1	رَفْعِ الْبَذْرِ
u'رَفْعٌ بَصَرٌ':Added, #1: 1	رَفْعِ بَرَاءَةِ
u'رَفْعٌ بَصَرٌ':Added, #1: 1	رَفْعُ الْبَصَرِ
u'رَفْعٌ بَصَرٌ':Added, #1: 1	رَفْعِ الْبَصَرِ
u'رَفَعَ بَعْضٌ':Predicate, #4: 4	رَفْعُ بَصَرِهِ
u'رَفْعٌ بَعْضٌ':Added, #1: 1	رَفَعَ بَعْضَ
u'رَفْعٌ بَعْضٌ':Added, #1: 1	رَفْعُ بَعْضِ
u'رَفْعٌ بَعْضٌ':Added, #1: 1	رَفْعُ بَعْضِهِ
u'رَفْعٌ بَعْضٌ':Added, #1: 1	رَفْعِ بَعْضِهِ
u'رَفْعٌ بَلاءٌ':Added, #3: 3	رَفْعَ بَعْضِ
u'رَفَعَ بِنَاءٌ':Predicate, #1: 1	رَفْعُ الْبَلَاءِ
u'رَفْعٌ بِنَاءٌ':Added, #1: 1	رَفَعَ الْبِنَاءَ
u'رَفْعٌ بِنَاءٌ':Added, #1: 1	رَفْعَ الْبِنَاءِ
u'رَفْعٌ بِنَاءٌ':Added, #1: 1	رَفْعِ الْبِنَاءِ
u'رَفْعٌ بُنْيانٌ':Added, #2: 2	رَفْعُ الْبِنَاءِ
u'رَفْعٌ بَيْعٌ':Added, #1: 1	رَفْعِ بُنْيَانِهِ
u'رَفَعَ بَيْنٌ':Predicate, #3: 3	رَفْعَ الْبَيْعِ
u'رفعة دَوْلَةٌ':Added, #1: 1	رَفَعَ بَيْنَ
u'رِفْعَةٌ دَوْلَةٌ':Added, #1: 1	رِفْعَةِ دَوْلَةِ
u'رفعة قَدْرٌ':Added, #1: 1	رِفْعَةِ دَوْلَةِ
u'رِفْعَةٌ قَدْرٌ':Added, #1: 1	رِفْعَةِ الْقَدْرِ
u'رفعة مَاءٌ':Added, #1: 1	رِفْعَةِ الْقَدْرِ
u'رِفْعَةٌ مَاءٌ':Added, #1: 1	رِفْعَةَ الْمَاءِ
u'رفعة نَفْسٌ':Added, #1: 1	رِفْعَةَ الْمَاءِ
u'رِفْعَةٌ نَفْسٌ':Added, #1: 1	رِفْعَةِ نَفْسِهِ
u'رَفْعٌ تَابِعٌ':Added, #1: 1	رِفْعَةِ نَفْسِهِ
u'رَفَعَ تَثْرِيبٌ':Predicate, #1: 1	رَفْعِ التَّابِعِ
u'رَفْعٌ تَجَوُّزٌ':Added, #1: 1	رَفَعَ التَّثْرِيبَ
u'رَفَعَ تُرَابٌ':Predicate, #1: 1	رَفْعَ التَّجَوُّزِ
u'رَفْعٌ تُرَابٌ':Added, #1: 1	رَفَعَ التُّرَابَ
u'رَفْعٌ تَرَدُّدٌ':Added, #2: 2	رَفْعِ التُّرَابِ
u'رَفْعٌ تَشْبِيه':Added, #1: 1	رَفْعُ التَّرَدُّدِ
u'رَفْعٌ تَصَرُّفٌ':Added, #1: 1	رَفْعُ التَّشْبِيهِ
u'رَفْعٌ تَعَلُّقٌ':Added, #1: 1	رَفْعُ تَصَرُّفِ
u'رَفْعٌ تَعَلُّقٌ':Added, #1: 1	رَفْعَ تَعَلُّقِ
u'رَفْعٌ تَكْبيرٌ':Added, #1: 1	رَفْعِ تَعَلُّقِ
u'رَفْعٌ تَكْليفٌ':Added, #1: 1	رَفْعُ التَّكْبِيرِ
u'رَفْعٌ تَكْليفٌ':Added, #1: 1	رَفْعُ التَّكْلِيفِ
u'رَفْعٌ تَوَهُّمٌ':Added, #3: 3	رَفْعِ التَّكْلِيفِ
u'رَفَعَ ثَالِثٌ':Subject, #2: 2	رَفْعِ تَوَهُّمِ
u'رَفَعَ ثَلاثُ':Predicate, #1: 1	رَفَعَ الثَّالِثُ
u'رَفْعٌ ثَلاثُ':Added, #1: 1	رَفَعَ الثَّلَاثَ
u'رَفْعٌ ثَلْجٌ':Added, #1: 1	رَفْعَ الثَّلَاثِ
u'رَفْعٌ ثِمارٌ':Added, #1: 1	رَفْعِ الثَّلْجِ
u'رَفْعٌ ثَوْبٌ':Added, #2: 2	رَفْعُ الثِّمَارِ
u'رَفْعٌ ثَوْبٌ':Added, #1: 1	رَفْعُ الثَّوْبِ
u'رَفَعَ جَبْهَةٌ':Predicate, #2: 2	رَفْعُ ثَوْبِهِ
u'رَفْعٌ جَبْهَةٌ':Added, #2: 2	رَفَعَ الْجَبْهَةَ
u'رَفْعٌ جِدار':Added, #1: 1	رَفْعِ جَبْهَتِهِ
u'رَفَعَ جِدال':Predicate, #1: 1	رَفْعُ الْجِدَارِ
u'رَفْعٌ جُذُوعٌ':Added, #1: 1	رَفَعَ الْجِدَالَ
u'رَفَعَ جَرَّةٌ':Predicate, #2: 2	رَفْعَ الْجُذُوعِ
u'رَفَعَ جَرَّةٌ':Predicate, #2: 2	رَفَعَ الْجَرَّةَ
u'رَفْعٌ جَرَّةٌ':Added, #2: 2	رَفَعَ جَرَّةَ
u'رَفْعٌ جَرَّةٌ':Added, #1: 1	رَفْعُ الْجَرَّةِ
u'رَفْعٌ جَمَاعَةٌ':Added, #1: 1	رَفْعِ الْجَرَّةِ
u'رَفْعٌ جَنَابَةٌ':Added, #2: 2	رَفْعِ الْجَمَاعَةِ
u'رَفْعٌ جَنَابَةٌ':Added, #1: 1	رَفْعُ الْجَنَابَةِ
u'رَفْعٌ جَنَابَةٌ':Added, #2: 2	رَفْعَ جَنَابَتِهِ
u'رَفْعٌ جَنَابَةٌ':Added, #4: 4	رَفْعِ الْجَنَابَةِ
u'رَفْعٌ جناح':Added, #7: 7	رَفْعَ الْجَنَابَةِ
u'رَفْعٌ جُنَاحٌ':Added, #1: 1	رَفْعَ الْجُنَاحِ
u'رَفْعٌ جناح':Added, #1: 1	رَفْعَ الْجُنَاحِ
u'رَفْعٌ جناح':Added, #2: 2	رَفْعُ الْجُنَاحِ
u'رَفْعٌ جُنَاحٌ':Added, #2: 2	رَفْعِ الْجُنَاحِ
u'رَفْعٌ جُنَاحٌ':Added, #2: 2	رَفْعُ الْجُنَاحِ
u'رَفْعٌ جُوعٌ':Added, #2: 2	رَفْعِ الْجُنَاحِ
u'رَفْعٌ حاجِبٌ':Added, #1: 1	رَفْعِ الْجُوعِ
u'رَفَعَ حاجَةٌ':Predicate, #1: 1	رَفْعِ الْحَاجِبِ
u'رَفْعٌ حاجَةٌ':Added, #1: 1	رَفَعَ حَاجَةَ
u'رَفَعَ حاجِزٌ':Predicate, #2: 2	رَفْعُ الْحَاجَاتِ
u'رَفَعَ حاجِزٌ':Predicate, #1: 1	رَفَعَ الْحَاجِزَ
u'رَفْعٌ حادِثٌ':Added, #1: 1	رَفَعَ حَاجِزَ
u'رَفَعَ حائِطٌ':Predicate, #1: 1	رَفْعِ الْحَادِثَةِ
u'رَفْعٌ حائِطٌ':Added, #1: 1	رَفَعَ الْحَائِطَ
u'رَفْعٌ حائِطٌ':Added, #1: 1	رَفْعَ الْحَائِطِ
u'رَفْعٌ حائِلٌ':Added, #1: 1	رَفْعِ الْحَائِطِ
u'رَفْعٌ حَبٌّ':Added, #1: 1	رَفْعَ الْحَائِلِ
u'رَفْعٌ حَبَّةٌ':Added, #1: 1	رَفْعِ حَبَّةٍ
u'رَفْعٌ حجاب':Added, #1: 1	رَفْعِ حَبَّةٍ
u'رَفْعٌ حِجابٌ':Added, #6: 6	رَفْعِ الْحِجَابِ
u'رَفَعَ حَجَرٌ':Predicate, #6: 6	رَفْعِ الْحِجَابِ
u'رَفْعٌ حَجَرٌ':Added, #1: 1	رَفَعَ الْحَجَرَ
u'رَفْعٌ حَجَرٌ':Added, #1: 1	رَفْعُ الْحَجَرِ
u'رَفْعٌ حَدٌّ':Added, #1: 1	رَفْعِ حَجَرٍ
u'رَفْعٌ حَدٌّ':Added, #1: 1	رَفْعَ الْحَدِّ
u'رَفْعٌ حَدٌّ':Added, #1: 1	رَفْعِ الْحَدِّ
u'رَفَعَ حَدَثٌ':Predicate, #3: 3	رَفْعُ الْحَدِّ
u'رَفْعٌ حَدَثٌ':Added, #4: 4	رَفَعَ الْحَدَثَ
u'رَفْعٌ حَدَثٌ':Added, #10: 10	رَفْعِ حَدَثٍ
u'رَفْعٌ حَدَثٌ':Added, #18: 18	رَفْعُ الْحَدَثِ
u'رَفْعٌ حَدَثٌ':Added, #1: 1	رَفْعَ الْحَدَثَيْنِ
u'رَفْعٌ حَدَثٌ':Added, #1: 1	رَفْعُ الْحَدَثَيْنِ
u'رَفْعٌ حَدَثٌ':Added, #1: 1	رَفْعُ حَدَثِ
u'رَفْعٌ حَدَثٌ':Added, #1: 1	رَفْعُ حَدَثِهِ
u'رَفْعٌ حَدَثٌ':Added, #3: 3	رَفْعَ حَدَثٍ
u'رَفْعٌ حَدَثٌ':Added, #3: 3	رَفْعِ حَدَثِهِ
u'رَفْعٌ حَدَثٌ':Added, #51: 51	رَفْعَ الْحَدَثِ
u'رَفْعٌ حَدَثٌ':Added, #5: 5	رَفْعَ حَدَثِ
u'رَفْعٌ حَدَثٌ':Added, #6: 6	رَفْعَ حَدَثِهِ
u'رَفْعٌ حَدَثٌ':Added, #73: 73	رَفْعِ الْحَدَثِ
u'رَفَعَ حَديثٌ':Predicate, #8: 8	رَفْعُ حَدَثٍ
u'رَفَعَ حَديثٌ':Predicate, #1: 1	رَفَعَ حَدِيثَ
u'رَفْعٌ حَديثٌ':Added, #5: 5	رَفَعَ الْحَدِيثَ
u'رَفْعٌ حَديثٌ':Added, #1: 1	رَفْعُ الْحَدِيثِ
u'رَفْعٌ حَديثٌ':Added, #1: 1	رَفْعِ حَدِيثِ
u'رَفْعٌ حَرْبٌ':Added, #3: 3	رَفْعِ الْحَدِيثِ
u'رَفَعَ حَرَجٌ':Predicate, #1: 1	رَفْعُ الْحَرْبِ
u'رَفْعٌ حَرَجٌ':Added, #5: 5	رَفَعَ الْحَرَجَ
u'رَفْعٌ حَرَجٌ':Added, #13: 13	رَفْعُ الْحَرَجِ
u'رَفْعٌ حَرَجٌ':Added, #15: 15	رَفْعِ الْحَرَجِ
u'رَفْعٌ حَرَجٌ':Added, #1: 1	رَفْعِ حَرَجٍ
u'رَفَعَ حِرْزٌ':Predicate, #3: 3	رَفْعَ الْحَرَجِ
u'رَفْعٌ حُرْمَةٌ':Added, #1: 1	رَفَعَ الْحِرْزَ
u'رَفْعٌ حُرْمَةٌ':Added, #1: 1	رَفْعُ الْحُرْمَةِ
u'رَفْعٌ حُرْمَةٌ':Added, #1: 1	رَفْعِ الْحُرْمَةِ
u'رَفْعٌ حساب':Added, #1: 1	رَفْعِ حُرْمَتِهِ
u'رَفْعٌ حِسَابٌ':Added, #1: 1	رَفْعُ حِسَابِ
u'رَفْعٌ حساب':Added, #1: 1	رَفْعُ حِسَابِ
u'رَفْعٌ حِسَابٌ':Added, #3: 3	رَفْعُ الْحِسَابِ
u'رَفَعَ حَقِيقٌ':Predicate, #3: 3	رَفْعُ الْحِسَابِ
u'رَفَعَ حَقِيقَةٌ':Predicate, #1: 1	رَفَعَ الْحَقِيقَةَ
u'رَفَعَ حُكْمٌ':Predicate, #1: 1	رَفَعَ الْحَقِيقَةَ
u'رَفَعَ حُكْمٌ':Predicate, #1: 1	رَفَعَ الْحُكْمَ
u'رَفْعٌ حُكْمٌ':Added, #3: 3	رَفَعَ حُكْمَ
u'رَفْعٌ حُكْمٌ':Added, #1: 1	رَفْعَ حُكْمٍ
u'رَفْعٌ حُكْمٌ':Added, #1: 1	رَفْعُ حُكْمٍ
u'رَفْعٌ حُكْمٌ':Added, #1: 1	رَفْعَ حُكْمِهِ
u'رَفْعٌ حُكْمٌ':Added, #2: 2	رَفْعِ الْحُكْمِ
u'رَفْعٌ حُكْمٌ':Added, #3: 3	رَفْعَ الْحُكْمِ
u'رَفْعٌ حُكْمٌ':Added, #3: 3	رَفْعُ حُكْمِ
u'رَفْعٌ حُكْمٌ':Added, #3: 3	رَفْعِ حُكْمِ
u'رَفْعٌ حُكْمٌ':Added, #5: 5	رَفْعَ حُكْمِ
u'رَفْعٌ حُكْمٌ':Added, #7: 7	رَفْعُ حُكْمِهِ
u'رَفَعَ حِلٌّ':Predicate, #8: 8	رَفْعُ الْحُكْمِ
u'رَفْعٌ حِلٌّ':Added, #1: 1	رَفَعَ الْحِلَّ
u'رَفْعٌ حَمْلٌ':Added, #3: 3	رَفْعُ الْحِلِّ
u'رَفْعٌ حَنَكٌ':Added, #1: 1	رَفْعُ الْحَمْلِ
u'رَفَعَ حَيْضٌ':Predicate, #1: 1	رَفْعَ حَنَكِهِ
u'رَفْعٌ حَيْضٌ':Added, #1: 1	رَفَعَ الْحَيْضَ
u'رَفْعٌ حَيْضٌ':Added, #1: 1	رَفْعِ حَيْضٍ
u'رَفْعٌ خَبَرٌ':Added, #2: 2	رَفْعِ الْحَيْضِ
u'رَفْعٌ خَبَر':Added, #2: 2	رَفْعِ خَبَرِ
u'رَفْعٌ خراج':Added, #2: 2	رَفْعِ خَبَرِ
u'رَفْعٌ خَرَاجٌ':Added, #1: 1	رَفْعُ الْخَرَاجِ
u'رَفْعٌ خراج':Added, #1: 1	رَفْعُ الْخَرَاجِ
u'رَفْعٌ خَرَاجٌ':Added, #3: 3	رَفْعَ الْخَرَاجِ
u'رَفْعٌ خرقة':Added, #3: 3	رَفْعَ الْخَرَاجِ
u'رَفْعٌ خِرْقَةٌ':Added, #2: 2	رَفْعِ الْخِرْقَةِ
u'رَفْعٌ خَشَبَةٌ':Added, #2: 2	رَفْعِ الْخِرْقَةِ
u'رَفْعٌ خَطٌّ':Added, #1: 1	رَفْعَ الْخَشَبَةِ
u'رَفْعٌ خَطَأٌ':Added, #1: 1	رَفْعِ خَطِّهِ
u'رَفَعَ خِطَابٌ':Subject, #2: 2	رَفْعِ الْخَطَأِ
u'رَفَعَ خِلاَفٌ':Predicate, #1: 1	رَفَعَ الْخِطَابُ
u'رَفْعٌ خِلاَفٌ':Added, #3: 3	رَفَعَ الْخِلَافَ
u'رَفْعٌ خِلاَفٌ':Added, #2: 2	رَفْعِ الْخِلَافِ
u'رَفَعَ خُمُسٌ':Predicate, #5: 5	رَفْعَ الْخِلَافِ
u'رَفْعٌ خُمُسٌ':Added, #3: 3	رَفَعَ الْخُمُسَ
u'رَفَعَ دَرَاهِمُ':Predicate, #1: 1	رَفْعِ الْخُمُسِ
u'رَفَعَ درجة':Predicate, #1: 1	رَفَعَ دَرَاهِمَ
u'رَفَعَ دَرَجَةٌ':Predicate, #1: 1	رَفَعَ دَرَجَةَ
u'رَفْعٌ دَرَجَةٌ':Added, #1: 1	رَفَعَ دَرَجَةَ
u'رَفْعٌ دَرَجَةٌ':Added, #1: 1	رَفْعِ الدَّرَجَاتِ
u'رَفْعٌ درجة':Added, #1: 1	رَفْعِ دَرَجَاتِ
u'رَفْعٌ دَرَجَةٌ':Added, #1: 1	رَفْعِ دَرَجَتِهِ
u'رَفْعٌ دَرَجَةٌ':Added, #1: 1	رَفْعِ دَرَجَتِهِ
u'رَفْعٌ دَرَجَةٌ':Added, #2: 2	رَفْعُ دَرَجَاتٍ
u'رَفَعَ دِرْهَمٌ':Predicate, #2: 2	رَفْعِ دَرَجَاتٍ
u'رَفَعَ دِرْهَم':Predicate, #3: 3	رَفَعَ الدِّرْهَمَ
u'رَفْعٌ دِماءٌ':Added, #3: 3	رَفَعَ الدِّرْهَمَ
u'رَفَعَ دَنانيرُ':Predicate, #1: 1	رَفْعِ الدِّمَاءِ
u'رَفْعٌ دِيَةٌ':Added, #1: 1	رَفَعَ دَنَانِيرَ
u'رَفَعَ دِينارٌ':Predicate, #1: 1	رَفْعِ الدِّيَةِ
u'رَفْعٌ ذكر':Added, #2: 2	رَفَعَ الدِّينَارَ
u'رَفْعٌ ذِكْرٌ':Added, #1: 1	رَفْعِ ذِكْرِهِ
u'رَفْعٌ ذَنْبٌ':Added, #1: 1	رَفْعِ ذِكْرِهِ
u'رَفْعٌ ذَنْبٌ':Added, #1: 1	رَفْعُ الذَّنْبِ
u'رَفْعٌ رَأْسٌ':Added, #4: 4	رَفْعَ الذَّنْبِ
u'رَفْعٌ رَأْسٌ':Added, #1: 1	رَفْعَ الرَّأْسِ
u'رَفْعٌ رَأْسٌ':Added, #1: 1	رَفْعُ رَأْسٍ
u'رَفْعٌ رَأْسٌ':Added, #29: 29	رَفْعِ رَأْسِهِ
u'رَفْعٌ رَأْسٌ':Added, #2: 2	رَفْعَ رَأْسِهِ
u'رَفْعٌ رَأْسٌ':Added, #38: 38	رَفْعِ الرَّأْسِ
u'رَفْعٌ رِجَالٌ':Added, #6: 6	رَفْعُ الرَّأْسِ
u'رَفْعٌ رِجَالٌ':Added, #1: 1	رَفْعِ الرِّجَالِ
u'رَفَعَ رَجُلٌ':Subject, #1: 1	رَفْعِ رِجَالٍ
u'رَفَعَ رَجُلٌ':Subject, #2: 2	رَفَعَ رَجُلٌ
u'رَفْعٌ رَجُلٌ':Added, #4: 4	رَفَعَ الرَّجُلُ
u'رَفْعٌ رِجْلٌ':Added, #1: 1	رَفْعِ الرَّجُلِ
u'رَفْعٌ رَحْمَن':Added, #1: 1	رَفْعِ الرِّجْلِ
u'رَفَعَ رَسُولٌ':Subject, #1: 1	رَفْعُ الرَّحْمَنِ
u'رَفْعٌ رُكوعٌ':Added, #5: 5	رَفَعَ رَسُولُ
u'رَفْعٌ رُؤْيَةٌ':Added, #1: 1	رَفْعِ الرُّكُوعِ
u'رَفَعَ زَرْعٌ':Predicate, #2: 2	رَفْعُ رُؤْيَتِهِ
u'رَفْعٌ زَلَّةٌ':Added, #1: 1	رَفَعَ الزَّرْعَ
u'رَفَعَ زَوْجٌ':Subject, #1: 1	رَفْعُ الزَّلَّةِ
u'رَفْعٌ زَوْجٌ':Added, #1: 1	رَفَعَ الزَّوْجُ
u'رَفْعٌ سَاتِرٌ':Added, #1: 1	رَفْعُ الزَّوْجِ
u'رَفَعَ سَبَبٌ':Predicate, #1: 1	رَفْعِ السَّاتِرِ
u'رَفْعٌ سَبَبٌ':Added, #1: 1	رَفَعَ السَّبَبَ
u'رَفْعٌ سَبَبٌ':Added, #1: 1	رَفْعِ السَّبَبِ
u'رَفْعٌ سَرْجٌ':Added, #2: 2	رَفْعِ سَبَبٍ
u'رَفْعٌ سِكِّينٌ':Added, #1: 1	رَفْعُ السَّرْجِ
u'رَفْعٌ سَلَسٌ':Added, #1: 1	رَفْعِ السِّكِّينِ
u'رَفَعَ سُنَّةٌ':Predicate, #1: 1	رَفْعُ سَلَسٍ
u'رَفْعٌ سهام':Added, #1: 1	رَفَعَ السُّنَّةَ
u'رَفْعٌ سِهَامٌ':Added, #1: 1	رَفْعَ السِّهَامِ
u'رَفَعَ سَيِّدٌ':Subject, #1: 1	رَفْعَ السِّهَامِ
u'رَفَعَ شَابٌّ':Subject, #1: 1	رَفَعَ السَّيِّدُ
u'رَفْعٌ شُبَهٌ':Added, #1: 1	رَفَعَ الشَّابُّ
u'رَفْعٌ شُبَهٌ':Added, #1: 1	رَفْعَ الشُّبَهِ
u'رَفْعٌ شُبْهَةٌ':Added, #1: 1	رَفْعُ الشُّبَهِ
u'رَفْعٌ شُبْهَةٌ':Added, #1: 1	رَفْعَ الشُّبْهَةِ
u'رَفْعٌ شُبْهَةٌ':Added, #1: 1	رَفْعُ الشُّبْهَةِ
u'رَفَعَ شَرْطٌ':Predicate, #1: 1	رَفْعِ الشُّبْهَةِ
u'رَفْعٌ شَرْعِيٌّ':Added, #1: 1	رَفَعَ الشَّرْطَ
u'رَفْعٌ شَيْءٌ':Added, #2: 2	رَفْعُ شَرْعِيَّةِ
u'رَفْعٌ شَيْءٌ':Added, #1: 1	رَفْعِ الشَّيْءِ
u'رَفْعٌ شَيْءٌ':Added, #1: 1	رَفْعَ شَيْءٍ
u'رَفَعَ شَيْخٌ':Subject, #2: 2	رَفْعُ شَيْءٍ
u'رَفْعٌ صداق':Added, #2: 2	رَفَعَ الشَّيْخُ
u'رَفْعٌ صداق':Added, #1: 1	رَفْعَ الصَّدَاقِ
u'رَفْعٌ صَدَاقٌ':Added, #1: 1	رَفْعِ الصَّدَاقِ
u'رَفْعٌ صَدَاقٌ':Added, #1: 1	رَفْعَ الصَّدَاقِ
u'رَفْعٌ صِفَةٌ':Added, #1: 1	رَفْعِ الصَّدَاقِ
u'رَفَعَ صَلاَةٌ':Predicate, #1: 1	رَفْعُ صِفَتِهِ
u'رَفَعَ صَوْتٌ':Subject, #1: 1	رَفَعَ الصّلَاةَ
u'رَفْعٌ صَوْتٌ':Added, #1: 1	رَفَعَ صَوْتُهُ
u'رَفْعٌ صَوْتٌ':Added, #1: 1	رَفْعِ صَوْتِ
u'رَفْعٌ صَوْتٌ':Added, #23: 23	رَفْعَ الصَّوْتِ
u'رَفْعٌ صَوْتٌ':Added, #2: 2	رَفْعُ صَوْتٍ
u'رَفْعٌ صَوْتٌ':Added, #2: 2	رَفْعِ صَوْتِهِ
u'رَفْعٌ صَوْتٌ':Added, #3: 3	رَفْعُ الصّوْتِ
u'رَفْعٌ صَوْتٌ':Added, #41: 41	رَفْعِ الصَّوْتِ
u'رَفْعٌ صَوْتٌ':Added, #52: 52	رَفْعُ الصَّوْتِ
u'رَفْعٌ صَوْتٌ':Added, #8: 8	رَفْعِ صَوْتٍ
u'رَفْعٌ ضِدٌّ':Added, #8: 8	رَفْعُ صَوْتِهِ
u'رَفْعٌ ضَرَرٌ':Added, #2: 2	رَفْعِ ضِدِّهِ
u'رَفْعٌ ضَمَانٌ':Added, #1: 1	رَفْعِ الضَّرَرِ
u'رَفَعَ طرف':Predicate, #4: 4	رَفْعِ الضَّمَانِ
u'رَفَعَ طَرْفٌ':Predicate, #1: 1	رَفَعَ الطَّرْفَ
u'رَفْعٌ طرف':Added, #1: 1	رَفَعَ الطَّرْفَ
u'رَفْعٌ طرف':Added, #1: 1	رَفْعُ الطَّرْفِ
u'رَفْعٌ طَرْفٌ':Added, #1: 1	رَفْعِ الطَّرْفِ
u'رَفْعٌ طَرْفٌ':Added, #1: 1	رَفْعُ الطَّرْفِ
u'رَفْعٌ طَرِيقٌ':Added, #1: 1	رَفْعِ الطَّرْفِ
u'رَفْعٌ طَرِيقٌ':Added, #1: 1	رَفْعَ الطَّرِيقِ
u'رَفْعٌ طعام':Added, #3: 3	رَفْعِ الطَّرِيقِ
u'رَفْعٌ طعام':Added, #1: 1	رَفْعُ الطَّعَامِ
u'رَفْعٌ طَعَامٌ':Added, #1: 1	رَفْعِ الطَّعَامِ
u'رَفْعٌ طَعَامٌ':Added, #1: 1	رَفْعُ الطَّعَامِ
u'رَفْعٌ طَلاَقٌ':Added, #1: 1	رَفْعِ الطَّعَامِ
u'رَفْعٌ طَلاَقٌ':Added, #1: 1	رَفْعُ الطَّلَاقِ
u'رَفْعٌ طَلاَقٌ':Added, #2: 2	رَفْعَ الطَّلَاقِ
u'رَفْعٌ طلب':Added, #4: 4	رَفْعِ الطَّلَاقِ
u'رَفْعٌ طلب':Added, #1: 1	رَفْعَ الطَّلَبِ
u'رَفْعٌ طَلَبٌ':Added, #1: 1	رَفْعُ الطَّلَبِ
u'رَفْعٌ طَلَبٌ':Added, #1: 1	رَفْعَ الطَّلَبِ
u'رَفْعٌ طِينٌ':Added, #1: 1	رَفْعُ الطَّلَبِ
u'رَفْعٌ ظُلْمٌ':Added, #1: 1	رَفْعِ طِينٍ
u'رَفَعَ ظِهارَةٌ':Predicate, #1: 1	رَفْعُ الظُّلْمِ
u'رَفْعٌ عَارٌ':Added, #1: 1	رَفَعَ الظِّهَارَةَ
u'رَفْعٌ عَارٌ':Added, #1: 1	رَفْعُ الْعَارِ
u'رَفَعَ عَامِلٌ':Subject, #2: 2	رَفْعَ الْعَارِ
u'رَفْعٌ عَدَاءٌ':Added, #1: 1	رَفَعَ الْعَامِلُ
u'رَفْعٌ عُشْرٌ':Added, #1: 1	رَفْعَ الْعَدَاءِ
u'رَفْعٌ عِصْمَةٌ':Added, #2: 2	رَفْعَ الْعُشْرِ
u'رَفْعٌ عَطَاءٌ':Added, #1: 1	رَفْعُ الْعِصْمَةِ
u'رَفْعٌ عقاب':Added, #1: 1	رَفْعِ الْعَطَاءِ
u'رَفْعٌ عِقَابٌ':Added, #2: 2	رَفْعِ الْعِقَابِ
u'رَفْعٌ عَقْدٌ':Added, #2: 2	رَفْعِ الْعِقَابِ
u'رَفْعٌ عَقْدٌ':Added, #1: 1	رَفْعَ عَقْدِ
u'رَفْعٌ عَقْدٌ':Added, #1: 1	رَفْعِ عَقْدٍ
u'رَفْعٌ عَقْدٌ':Added, #1: 1	رَفْعِ عَقْدِ
u'رَفْعٌ عَقْدٌ':Added, #2: 2	رَفْعُ عَقْدٍ
u'رَفْعٌ عَقْدٌ':Added, #3: 3	رَفْعَ الْعَقْدِ
u'رَفْعٌ عَقْدٌ':Added, #4: 4	رَفْعُ عَقْدِ
u'رَفْعٌ عَقْدٌ':Added, #7: 7	رَفْعُ الْعَقْدِ
u'رَفْعٌ عُقُوبَةٌ':Added, #9: 9	رَفْعِ الْعَقْدِ
u'رَفْعٌ عِلَّةٌ':Added, #3: 3	رَفْعُ الْعُقُوبَةِ
u'رَفْعٌ عَلَقَةٌ':Added, #1: 1	رَفْعَ الْعِلَّةِ
u'رَفْعٌ علم':Added, #1: 1	رَفْعِ الْعَلَقَةِ
u'رَفْعٌ عِلْمٌ':Added, #1: 1	رَفْعُ عِلْمِ
u'رَفَعَ عِمَادٌ':Predicate, #1: 1	رَفْعُ عِلْمِ
u'رَفْعٌ عِمَارَةٌ':Added, #1: 1	رَفَعَ الْعِمَادَ
u'رَفَعَ عِمَامَةٌ':Predicate, #1: 1	رَفْعَ الْعِمَارَةِ
u'رَفَعَ عِمَامَةٌ':Predicate, #2: 2	رَفَعَ عِمَامَةَ
u'رَفْعٌ عِمَامَةٌ':Added, #4: 4	رَفَعَ الْعِمَامَةَ
u'رَفَعَ عَمَلٌ':Predicate, #1: 1	رَفْعِ الْعِمَامَةِ
u'رَفَعَ عُودٌ':Predicate, #1: 1	رَفَعَ عَمَلَ
u'رَفْعٌ عين':Added, #1: 1	رَفَعَ الْعُودَ
u'رَفْعٌ عَيْنٌ':Added, #1: 1	رَفْعُ الْعَيْنِ
u'رَفْعٌ عَيْن':Added, #1: 1	رَفْعُ الْعَيْنِ
u'رَفَعَ غَلَّةٌ':Predicate, #1: 1	رَفْعُ الْعَيْنِ
u'رَفَعَ غير':Predicate, #3: 3	رَفَعَ الْغَلَّةَ
u'رَفَعَ غَيْرٌ':Predicate, #3: 3	رَفَعَ غَيْرَ
u'رَفْعٌ غير':Added, #3: 3	رَفَعَ غَيْرَ
u'رَفْعٌ غَيْرٌ':Added, #1: 1	رَفْعُ غَيْرِ
u'رَفْعٌ فَاسِدٌ':Added, #1: 1	رَفْعُ غَيْرِ
u'رَفْعٌ فَاعِلٌ':Added, #1: 1	رَفْعَ الْفَاسِدِ
u'رَفْعٌ فَاعِلٌ':Added, #1: 1	رَفْعَ الْفَاعِلِ
u'رَفَعَ فَتْحٌ':Subject, #1: 1	رَفْعِ الْفَاعِلِ
u'رَفْعٌ فتحة':Added, #1: 1	رَفَعَ الْفَتْحُ
u'رَفْعٌ فَتْحَةٌ':Added, #1: 1	رَفْعِ الْفَتْحَةِ
u'رَفْعٌ فَرْعٌ':Added, #1: 1	رَفْعِ الْفَتْحَةِ
u'رَفْعٌ فساد':Added, #1: 1	رَفْعَ الْفَرْعِ
u'رَفْعٌ فساد':Added, #1: 1	رَفْعَ الْفَسَادِ
u'رَفْعٌ فساد':Added, #1: 1	رَفْعُ الْفَسَادِ
u'رَفْعٌ فَسَادٌ':Added, #1: 1	رَفْعِ الْفَسَادِ
u'رَفْعٌ فَسَادٌ':Added, #1: 1	رَفْعَ الْفَسَادِ
u'رَفْعٌ فَسَادٌ':Added, #1: 1	رَفْعُ الْفَسَادِ
u'رَفَعَ فُلاَنٌ':Subject, #1: 1	رَفْعِ الْفَسَادِ
u'رَفْعٌ فلان':Added, #1: 1	رَفَعَ فُلَانٌ
u'رَفْعٌ قَاطِعٌ':Added, #1: 1	رَفْعُ الرَّحْمَنِ
u'رَفْعٌ قَبْضٌ':Added, #1: 1	رَفْعِ الْقَاطِعِ
u'رَفَعَ قَدْرٌ':Predicate, #1: 1	رَفْعُ الْقَبْضِ
u'رَفَعَ قدم':Predicate, #1: 1	رَفَعَ قَدْرَ
u'رَفَعَ قَدَمٌ':Predicate, #3: 3	رَفَعَ الْقَدَمَ
u'رَفْعٌ قَدَمٌ':Added, #3: 3	رَفَعَ الْقَدَمَ
u'رَفَعَ قَدُومٌ':Predicate, #1: 1	رَفْعِ الْقَدَمَيْنِ
u'رَفَعَ قُرْآنٌ':Predicate, #1: 1	رَفَعَ قَدُومَ
u'رَفْعٌ قُرْآنٌ':Added, #1: 1	رَفَعَ الْقُرْآنَ
u'رَفَعَ قسمة':Predicate, #1: 1	رَفْعِ الْقُرْآنِ
u'رَفَعَ قِسْمَةٌ':Predicate, #1: 1	رَفَعَ الْقِسْمَةَ
u'رَفْعٌ قِصَّةٌ':Added, #1: 1	رَفَعَ الْقِسْمَةَ
u'رَفَعَ قُضْبَانٌ':Predicate, #1: 1	رَفْعِ قِصَّةٍ
u'رَفْعٌ قَضِيَّةٌ':Added, #1: 1	رَفَعَ الْقُضْبَانَ
u'رَفْعٌ قَلَمٌ':Added, #2: 2	رَفْعُ الْقَضِيَّةِ
u'رَفْعٌ قَلَمٌ':Added, #1: 1	رَفْعُ الْقَلَمِ
u'رَفْعٌ قَلَمٌ':Added, #2: 2	رَفْعَ الْقَلَمِ
u'رَفَعَ قَلَنْسُوَةٌ':Predicate, #2: 2	رَفْعِ الْقَلَمِ
u'رَفَعَ قَوَاعِدُ':Predicate, #1: 1	رَفَعَ الْقَلَنْسُوَةَ
u'رَفَعَ قَوْسٌ':Predicate, #1: 1	رَفَعَ الْقَوَاعِدَ
u'رَفَعَ قَوْمٌ':Subject, #1: 1	رَفَعَ الْقَوْسَ
u'رَفْعٌ قِيَاسٌ':Added, #2: 2	رَفَعَ الْقَوْمُ
u'رَفَعَ قَيْدٌ':Predicate, #1: 1	رَفْعُ الْقِيَاسِ
u'رَفْعٌ قَيْدٌ':Added, #1: 1	رَفَعَ الْقَيْدَ
u'رَفْعٌ قَيْدٌ':Added, #2: 2	رَفْعَ الْقَيْدِ
u'رَفْعٌ قَيْدٌ':Added, #2: 2	رَفْعِ قَيْدِ
u'رَفْعٌ قَيْدٌ':Added, #4: 4	رَفْعُ قَيْدِ
u'رَفْعٌ قَيْدٌ':Added, #6: 6	رَفْعِ الْقَيْدِ
u'رَفْعٌ كحل':Added, #7: 7	رَفْعُ الْقَيْدِ
u'رَفْعٌ كُحْلٌ':Added, #1: 1	رَفْعُ الْكُحْلِ
u'رَفْعٌ كَرَاهَةٌ':Added, #1: 1	رَفْعُ الْكُحْلِ
u'رَفْعٌ كَفٌّ':Added, #2: 2	رَفْعُ الْكَرَاهَةِ
u'رَفْعٌ كَفٌّ':Added, #2: 2	رَفْعُ الْكَفَّيْنِ
u'رَفَعَ كَفِيلٌ':Subject, #2: 2	رَفْعِ الْكَفَّيْنِ
u'رَفَعَ كَلْبٌ':Subject, #1: 1	رَفَعَ الْكَفِيلُ
u'رَفَعَ لبن':Predicate, #1: 1	رَفَعَ كَلْبٌ
u'رَفَعَ لَبِنٌ':Predicate, #1: 1	رَفَعَ اللَّبِنَ
u'رَفَعَ لقطة':Predicate, #1: 1	رَفَعَ اللَّبِنَ
u'رَفَعَ لُقْطَةٌ':Predicate, #1: 1	رَفَعَ اللُّقْطَةَ
u'رَفْعٌ لُقْمَةٌ':Added, #1: 1	رَفَعَ اللُّقْطَةَ
u'رَفَعَ مَاءٌ':Predicate, #3: 3	رَفْعِ اللُّقْمَةِ
u'رَفْعٌ مَاءٌ':Added, #5: 5	رَفَعَ الْمَاءَ
u'رَفَعَ مَالِكٌ':Subject, #1: 1	رَفْعِ الْمَاءِ
u'رَفَعَ مَانِعٌ':Predicate, #1: 1	رَفَعَ مَالِكٌ
u'رَفْعٌ مَانِعٌ':Added, #2: 2	رَفَعَ الْمَانِعَ
u'رَفْعٌ مانِع':Added, #1: 1	رَفْعَ الْمَانِعِ
u'رَفْعٌ مَانِعٌ':Added, #1: 1	رَفْعُ الْمَانِعِيَّةِ
u'رَفْعٌ مَانِعٌ':Added, #1: 1	رَفْعُ مَانِعِ
u'رَفْعٌ مانِع':Added, #3: 3	رَفْعِ الْمَانِعِ
u'رَفْعٌ مَانِعٌ':Added, #3: 3	رَفْعِ الْمَانِعِيَّةِ
u'رَفْعٌ مَائِدٌ':Added, #6: 6	رَفْعُ الْمَانِعِ
u'رَفْعٌ مَائِدَةٌ':Added, #1: 1	رَفْعُ الْمَائِدَةِ
u'رَفْعٌ متبوع':Added, #1: 1	رَفْعُ الْمَائِدَةِ
u'رَفَعَ مُتَعَلِّمٌ':Subject, #1: 1	رَفْعُ الْمَتْبُوعِ
u'رَفْعٌ مُتَوَاتِرٌ':Added, #1: 1	رَفَعَ الْمُتَعَلِّمُ
u'رَفْعٌ مَجَازٌ':Added, #1: 1	رَفْعِ الْمُتَوَاتِرِ
u'رَفْعٌ مَجَازٌ':Added, #1: 1	رَفْعِ الْمَجَازِ
u'رَفْعٌ مُخَالِفٌ':Added, #2: 2	رَفْعَ الْمَجَازِ
u'رَفَعَ مُدَّةٌ':Predicate, #1: 1	رَفْعِ الْمُخَالِفِ
u'رَفَعَ مَرِيضٌ':Subject, #1: 1	رَفَعَ الْمُدَّةَ
u'رَفْعٌ مِسَاحَةٌ':Added, #2: 2	رَفَعَ الْمَرِيضُ
u'رَفْعٌ مِسَاحَةٌ':Added, #1: 1	رَفْعُ الْمِسَاحَةِ
u'رَفَعَ مُسْتَأْجِرٌ':Subject, #1: 1	رَفْعُ مِسَاحَةٍ
u'رَفْعٌ مَسْجِدٌ':Added, #2: 2	رَفَعَ الْمُسْتَأْجِرُ
u'رَفْعٌ مَسْجِدٌ':Added, #1: 1	رَفْعُ الْمَسْجِدِ
u'رَفَعَ مَسْكُوتٌ':Predicate, #2: 2	رَفْعِ مَسْجِدٍ
u'رَفَعَ مُسْلِمٌ':Subject, #1: 1	رَفَعَ الْمَسْكُوتَ
u'رَفْعٌ مَشْرُوعٌ':Added, #1: 1	رَفَعَ الْمُسْلِمُ
u'رَفْعٌ مَضَرَّةٌ':Added, #2: 2	رَفْعَ الْمَشْرُوعِ
u'رَفْعٌ مُطْلَقٌ':Added, #1: 1	رَفْعِ مَضَرَّةٍ
u'رَفَعَ مَطْلُوبٌ':Predicate, #1: 1	رَفْعِ الْمُطْلَقِ
u'رَفْعٌ مَعْدُومٌ':Added, #1: 1	رَفَعَ الْمَطْلُوبَ
u'رَفْعٌ مَعْصِيَةٌ':Added, #1: 1	رَفْعَ الْمَعْدُومِ
u'رَفْعٌ مَعْصِيَةٌ':Added, #1: 1	رَفْعَ الْمَعْصِيَةِ
u'رَفْعٌ مَعْصِيَةٌ':Added, #1: 1	رَفْعُ الْمَعْصِيَةِ
u'رَفَعَ مَعْطُوف':Predicate, #1: 1	رَفْعِ الْمَعْصِيَةِ
u'رَفْعٌ مُفْلِسٌ':Added, #1: 1	رَفَعَ الْمَعْطُوفَ
u'رَفَعَ مِقْدَارٌ':Predicate, #1: 1	رَفْعَ الْمُفْلِسِ
u'رَفْعٌ مُقَيَّدٌ':Added, #1: 1	رَفَعَ مِقْدَارَ
u'رَفْعٌ مَلاَئِكَةٌ':Added, #1: 1	رَفْعُ الْمُقَيَّدِ
u'رَفْعٌ مِلْكٌ':Added, #1: 1	رَفْعُ الْمَلَائِكَةِ
u'رَفْعٌ مِلْكٌ':Added, #1: 1	رَفْعِ الْمِلْكِ
u'رَفْعٌ مِلْكٌ':Added, #2: 2	رَفْعُ مِلْكٍ
u'رَفَعَ مَنْقُولٌ':Predicate, #2: 2	رَفْعُ مِلْكِ
u'رَفْعٌ مَنْقُولٌ':Added, #2: 2	رَفَعَ الْمَنْقُولَ
u'رَفَعَ مُنْكَرٌ':Predicate, #1: 1	رَفْعِ الْمَنْقُولِ
u'رَفْعٌ مُنْكَرٌ':Added, #1: 1	رَفَعَ الْمُنْكَرَ
u'رَفْعٌ مَنْهِيٌّ':Added, #1: 1	رَفْعِ مُنْكَرٍ
u'رَفَعَ مُؤَاخَذَةٌ':Predicate, #1: 1	رَفْعُ الْمَنْهِيِّ
u'رَفْعٌ مُؤَاخَذَةٌ':Added, #1: 1	رَفَعَ الْمُؤَاخَذَةَ
u'رَفْعٌ مُؤَاخَذَةٌ':Added, #1: 1	رَفْعَ الْمُؤَاخَذَةِ
u'رَفْعٌ مَوَانِعُ':Added, #1: 1	رَفْعُ الْمُؤَاخَذَةِ
u'رَفْعٌ مَوَانِعُ':Added, #2: 2	رَفْعُ الْمَوَانِعِ
u'رَفْعٌ مَوْتٌ':Added, #2: 2	رَفْعِ الْمَوَانِعِ
u'رَفْعٌ مَوْقُوفٌ':Added, #1: 1	رَفْعُ الْمَوْتِ
u'رَفْعٌ نَاسٌ':Added, #2: 2	رَفْعُ الْمَوْقُوفَاتِ
u'رَفْعٌ نَاسِخٌ':Added, #1: 1	رَفْعِ النَّاسِ
u'رَفْعٌ نَاسِخٌ':Added, #1: 1	رَفْعَ النَّاسِخِ
u'رَفْعٌ نَاسِخ':Added, #1: 1	رَفْعُ النَّاسِخِ
u'رَفْعٌ نَاسِخ':Added, #1: 1	رَفْعَ النَّاسِخِ
u'رَفْعٌ نَجَاسَةٌ':Added, #1: 1	رَفْعُ النَّاسِخِ
u'رَفْعٌ نَجَاسَةٌ':Added, #1: 1	رَفْعُ النَّجَاسَاتِ
u'رَفْعٌ نَجَاسَةٌ':Added, #1: 1	رَفْعُ النَّجَاسَةِ
u'رَفْعٌ نَسَبٌ':Added, #2: 2	رَفْعُ نَجَاسَتِهِ
u'رَفْعٌ نَصٌّ':Added, #1: 1	رَفْعِ نَسَبِ
u'رَفْعٌ نَصِيبٌ':Added, #1: 1	رَفْعِ النَّصِّ
u'رَفْعٌ نعمة':Added, #1: 1	رَفْعِ نَصِيبِ
u'رَفْعٌ نِعْمَةٌ':Added, #1: 1	رَفْعُ نِعْمَتِهِ
u'رَفْعٌ نَفْسٌ':Added, #1: 1	رَفْعُ نِعْمَتِهِ
u'رَفْعٌ نُقْصَانٌ':Added, #1: 1	رَفْعُ نَفْسِ
u'رَفْعٌ نَقْضٌ':Added, #1: 1	رَفْعَ النُّقْصَانِ
u'رَفْعٌ نكاح':Added, #1: 1	رَفْعِ النَّقْضِ
u'رَفْعٌ نِكَاحٌ':Added, #1: 1	رَفْعِ نِكَاحٍ
u'رَفْعٌ نكاح':Added, #1: 1	رَفْعِ نِكَاحٍ
u'رَفْعٌ نِكَاحٌ':Added, #2: 2	رَفْعَ النِّكَاحِ
u'رَفْعٌ نكاح':Added, #2: 2	رَفْعَ النِّكَاحِ
u'رَفْعٌ نِكَاحٌ':Added, #4: 4	رَفْعُ النِّكَاحِ
u'رَفْعٌ نكاح':Added, #4: 4	رَفْعُ النِّكَاحِ
u'رَفْعٌ نِكَاحٌ':Added, #6: 6	رَفْعِ النِّكَاحِ
u'رَفَعَ نِيَّةٌ':Predicate, #6: 6	رَفْعِ النِّكَاحِ
u'رَفْعٌ نِيَّةٌ':Added, #1: 1	رَفَعَ نِيَّةَ
u'رَفْعٌ هَرَجٌ':Added, #1: 1	رَفْعَ نِيَّةٍ
u'رَفَعَ واحد':Predicate, #1: 1	رَفْعِ الْهَرَجِ
u'رَفَعَ وَاحِدٌ':Predicate, #1: 1	رَفَعَ الْوَاحِدَةَ
u'رَفْعٌ واحد':Added, #1: 1	رَفَعَ الْوَاحِدَةَ
u'رَفْعٌ وَاحِدٌ':Added, #1: 1	رَفْعَ وَاحِدٍ
u'رَفْعٌ وَاقِعٌ':Added, #1: 1	رَفْعَ وَاحِدٍ
u'رَفْعٌ وبال':Added, #1: 1	رَفْعِ الْوَاقِعِ
u'رَفْعٌ وَبَالٌ':Added, #1: 1	رَفْعِ الْوَبَالِ
u'رَفْعٌ وَجْهٌ':Added, #1: 1	رَفْعِ الْوَبَالِ
u'رَفْعٌ وُجُوبٌ':Added, #1: 1	رَفْعُ وَجْهِهِ
u'رَفْعٌ وُجُوبٌ':Added, #1: 1	رَفْعُ الْوُجُوبِ
u'رَفْعٌ وَدِيعٌ':Added, #3: 3	رَفْعِ الْوُجُوبِ
u'رَفْعٌ وَدِيعَةٌ':Added, #1: 1	رَفْعِ الْوَدِيعَةِ
u'رَفَعَ وَرَثَةٌ':Subject, #1: 1	رَفْعِ الْوَدِيعَةِ
u'رَفَعَ وَصِيٌّ':Subject, #1: 1	رَفَعَ وَرَثَتُهُ
u'رَفْعٌ وِلاَيَةٌ':Added, #1: 1	رَفَعَ الْوَصِيُّ
u'رَفْعٌ يَدٌ':Added, #1: 1	رَفْعِ وِلَايَتِهِ
u'رَفْعٌ يَدٌ':Added, #10: 10	رَفْعِ الْيَدِ
u'رَفْعٌ يَدٌ':Added, #11: 11	رَفْعُ الْيَدِ
u'رَفْعٌ يَدٌ':Added, #16: 16	رَفْعَ الْيَدَيْنِ
u'رَفْعٌ يَدٌ':Added, #1: 1	رَفْعَ يَدِ
u'رَفْعٌ يَدٌ':Added, #1: 1	رَفْعِ يَدٍ
u'رَفْعٌ يَدٌ':Added, #1: 1	رَفْعِ يَدِ
u'رَفْعٌ يَدٌ':Added, #1: 1	رَفْعِ يَدَيْنِ
u'رَفْعٌ يَدٌ':Added, #2: 2	رَفْعُ يَدِ
u'رَفْعٌ يَدٌ':Added, #31: 31	رَفْعُ الْيَدَيْنِ
u'رَفْعٌ يَدٌ':Added, #60: 60	رَفْعِ الْيَدَيْنِ
u'رَفْعٌ يَدٌ':Added, #7: 7	رَفْعَ يَدِهِ
u'رَفْعٌ يَدٌ':Added, #8: 8	رَفْعَ الْيَدِ
u'رَفْعٌ يَدٌ':Added, #8: 8	رَفْعُ يَدِهِ
u'رَفْعٌ يَمِينٌ':Added, #9: 9	رَفْعِ يَدِهِ
u'رَفْعٌ يَمِينٌ':Added, #1: 1	رَفْعُ الْيَمِينِ
u'رِفْقٌ أهْلٌ':Added, #2: 2	رَفْعَ الْيَمِينِ
u'رِفْقٌ أَوْلاَدٌ':Added, #1: 1	رِفْقَ أَهْلِ
u'رِفْقٌ خَالِقٌ':Added, #1: 1	رِفْقَ أَوْلَادِ
u'رِفْقٌ دَرٌّ':Added, #1: 1	رِفْقِ الْخَالِقِ
u'رِفْقٌ فقراء':Added, #1: 1	رِفْقِ الدَّرِّ
u'رِفْقٌ نَفْسٌ':Added, #1: 1	رِفْقُ فُقَرَاءِ
u'رِفْقٌ يَتِيمٌ':Added, #1: 1	رِفْقَ نَفْسِهِ
u'رَقَّ بَطْنٌ':Subject, #1: 1	رِفْقَ الْيَتِيمِ
u'رِقَّةٌ بُطونٌ':Added, #1: 1	رَقَّ بَطْنُهُ
u'رِقَّةٌ ثِيابٌ':Added, #1: 1	رِقَّةُ الْبُطُونِ
u'رِقَّةٌ جِبِلَّةٌ':Added, #1: 1	رِقَّةُ الثِّيَابِ
u'رِقَّةٌ حالٌ':Added, #1: 1	رِقَّةُ الْجِبِلَّةِ
u'رِقَّةٌ عَقْلٌ':Added, #1: 1	رِقَّةُ الْحَالِ
u'رِقَّةٌ قلب':Added, #4: 4	رِقَّةُ الْعَقْلِ
u'رِقَّةٌ قَلْبٌ':Added, #1: 1	رِقَّةَ الْقَلْبِ
u'رِقَّةٌ قَلْب':Added, #1: 1	رِقَّةَ الْقَلْبِ
u'رِقَّةٌ قلب':Added, #1: 1	رِقَّةَ الْقَلْبِ
u'رِقَّةٌ قَلْبٌ':Added, #1: 1	رِقَّةَ قَلْبِهِ
u'رِقَّةٌ قَلْب':Added, #1: 1	رِقَّةَ قَلْبِهِ
u'رِقَّةٌ قلب':Added, #1: 1	رِقَّةَ قَلْبِهِ
u'رِقَّةٌ قَلْبٌ':Added, #2: 2	رِقَّةِ الْقَلْبِ
u'رِقَّةٌ قَلْب':Added, #2: 2	رِقَّةِ الْقَلْبِ
u'رِقَّةٌ قلب':Added, #2: 2	رِقَّةِ الْقَلْبِ
u'رِقَّةٌ قَلْبٌ':Added, #4: 4	رِقَّةُ الْقَلْبِ
u'رِقَّةٌ قَلْب':Added, #4: 4	رِقَّةُ الْقَلْبِ
u'رِقَّةٌ قُلُوبٌ':Added, #4: 4	رِقَّةُ الْقَلْبِ
u'رِقَّةٌ مَاءٌ':Added, #1: 1	رِقَّةِ الْقُلُوبِ
u'رِقَّةٌ مَاءٌ':Added, #1: 1	رِقَّةُ الْمَاءِ
u'رِقَّةٌ نِساءٌ':Added, #1: 1	رِقَّةِ الْمَاءِ
u'رِقَّةٌ نَفْسٌ':Added, #1: 1	رِقَّةَ النِّسَاءِ
u'رِقَّةٌ نُفُوسٌ':Added, #1: 1	رِقَّةِ النَّفْسِ
u'رَقَدَ عند':Predicate, #1: 1	رِقَّةِ النُّفُوسِ
u'رَقَدَ نَاسٌ':Subject, #2: 2	رَقَدَ عِنْدَ
u'رَقَدَ نِساءٌ':Subject, #5: 5	رَقَدَ النَّاسُ
u'رَقَّ ذكر':Subject, #1: 1	رَقَدَ النِّسَاءُ
u'رَقَّ ذَكَرٌ':Subject, #1: 1	رَقَّ الذَّكَرُ
u'رَقَّ رَقٌّ':Predicate, #1: 1	رَقَّ الذَّكَرُ
u'رَقَصَ حَبَشَة':Subject, #1: 1	رَقَّ رَقَّ
u'رَقَّ طَبْعٌ':Subject, #1: 1	رَقَصَ الْحَبَشَةُ
u'رَقَّعَ بَيْنٌ':Predicate, #2: 2	رَقَّ طَبْعُهُ
u'رَقَّ علم':Subject, #2: 2	رَقَّعَ بَيْنَ
u'رَقَّ عِلْمٌ':Subject, #3: 3	رَقَّ عِلْمُهُ
u'رَقَّ فُلاَنٌ':Subject, #3: 3	رَقَّ عِلْمُهُ
u'رَقَّ قَالٌ':Predicate, #1: 1	رَقَّ فُلَانٌ
u'رَقْمٌ أَشْجَارٌ':Added, #1: 1	رَقَّ قَالَ
u'رَقْم أَشْجَارٌ':Added, #1: 1	رَقْمُ الْأَشْجَارِ
u'رَقَمَ أَوْقَافٌ':Predicate, #1: 1	رَقْمُ الْأَشْجَارِ
u'رَقْمٌ ثَمَنٌ':Added, #1: 1	رَقَمَ الْأَوْقَافَ
u'رَقْم ثَمَنٌ':Added, #1: 1	رَقْمُ ثَمَنِهِ
u'رَقَّمَ ثَوْبٌ':Predicate, #1: 1	رَقْمُ ثَمَنِهِ
u'رَقْمٌ ثَوْبٌ':Added, #1: 1	رَقَّمَ الثَّوْبَ
u'رَقْم ثَوْبٌ':Added, #1: 1	رَقْمِ الثَّوْبِ
u'رَقْمٌ حُرٌّ':Added, #1: 1	رَقْمِ الثَّوْبِ
u'رَقْم حُرٌّ':Added, #1: 1	رَقْمِ حُرٍّ
u'رَقَّ مُقَابِلٌ':Subject, #1: 1	رَقْمِ حُرٍّ
u'رَقٌّ نَاسٌ':Added, #1: 1	رَقَّ الْمُقَابِلُ
u'رَقَّ نَصِيبٌ':Subject, #1: 1	أَرَقّ النّاسِ
u'رَقَّ وَجْهٌ':Subject, #1: 1	رَقَّ نَصِيبُهُ
u'رَقَّ ولد':Subject, #3: 3	رَقَّ وَجْهُهُ
u'رَقَّ وَلَدٌ':Subject, #1: 1	رَقَّ الْوَلَدُ
u'رَقَى خَطِيبٌ':Subject, #1: 1	رَقَّ الْوَلَدُ
u'رَقِيَ سَطْحٌ':Predicate, #3: 3	رَقَى الْخَطِيبُ
u'رَقَى سَطْحٌ':Predicate, #2: 2	رَقِيَ السَّطْحَ
u'رَقِيَ مَشْعَرٌ':Predicate, #2: 2	رَقَى السَّطْحَ
u'رَقِيَ مَشْعَر':Predicate, #1: 1	رَقِيَ الْمَشْعَرَ
u'رَقَى مَلْدُوغ':Predicate, #1: 1	رَقِيَ الْمَشْعَرَ
u'رَقِيَ مَنَارٌ':Predicate, #1: 1	رَقَى الْمَلْدُوغَ
u'رَقَى مِنْبَرٌ':Predicate, #1: 1	رَقِيَ مَنَارَةَ
u'رَقِيَ مِنْبَرٌ':Predicate, #4: 4	رَقَى الْمِنْبَرَ
u'رَقَى مِئْذَنَةٌ':Predicate, #5: 5	رَقِيَ الْمِنْبَرَ
u'رَقِيَ نَاسٌ':Subject, #1: 1	رَقَى الْمِئْذَنَةَ
u'رَقَى نَاسٌ':Subject, #1: 1	رَقِيَ النَّاسُ
u'رَكِبَ أَجْرٌ':Subject, #1: 1	رَقَى النَّاسُ
u'رَكِبَ أَجْنَبِيٌّ':Subject, #1: 1	رَكِبَ أَجْرُ
u'رَكِبَ أقَلُّ':Predicate, #1: 1	رَكِبَ أَجْنَبِيٌّ
u'رَكِبَ أَميرٌ':Subject, #1: 1	رَكِبَ الْأَقَلَّ
u'رَكِبَ إِنْسانٌ':Subject, #1: 1	رَكِبَ الْأَمِيرُ
u'رَكِبَ بَحْرٌ':Predicate, #1: 1	رَكِبَ الْإِنْسَانُ
u'رَكِبَ بَعيرٌ':Predicate, #5: 5	رَكِبَ الْبَحْرَ
u'رَكِبَ بَغْلٌ':Predicate, #1: 1	رَكِبَ بَعِيرَ
u'رَكِبَ بَغْلٌ':Predicate, #1: 1	رَكِبَ الْبَغْلَ
u'رَكِبَ بَغْلٌ':Predicate, #1: 1	رَكِبَ الْبَغْلَةَ
u'رَكِبَ بَقَرٌ':Predicate, #1: 1	رَكِبَ بَغْلَةً
u'رَكِبَ بَيْنٌ':Predicate, #1: 1	رَكِبَ الْبَقَرَ
u'رَكِبَ ثَالِثٌ':Subject, #1: 1	رَكِبَ بَيْنَ
u'رَكِبَ جَمَلٌ':Predicate, #1: 1	رَكِبَ الثَّالِثُ
u'رَكِبَ حالٌ':Predicate, #1: 1	رَكِبَ الْجَمَلَ
u'ركب حَجيجٌ':Added, #3: 3	رَكِبَ حَالَ
u'رَكْبٌ حَجيجٌ':Added, #1: 1	رَكْبِ الْحَجِيجِ
u'رَكِبَ حِمَارٌ':Predicate, #1: 1	رَكْبِ الْحَجِيجِ
u'رَكِبَ خَالِدٌ':Subject, #3: 3	رَكِبَ الْحِمَارَ
u'رَكِبَ خِلاَفٌ':Predicate, #1: 1	رَكِبَ خَالِدُ
u'رَكِبَ خَلْفٌ':Predicate, #1: 1	رَكِبَ الْخِلَافَ
u'رَكِبَ خَيْلٌ':Predicate, #1: 1	رَكِبَ خَلْفَ
u'رَكِبَ دَابَّةٌ':Predicate, #1: 1	رَكِبَ الْخَيْلَ
u'رَكِبَ دَابَّةٌ':Predicate, #15: 15	رَكِبَ الدَّابَّةَ
u'رَكِبَ دَارٌ':Predicate, #15: 15	رَكِبَ دَابَّةَ
u'رَكِبَ رَاحِلٌ':Predicate, #1: 1	رَكِبَ دَارَ
u'رَكِبَ رَجُلٌ':Subject, #1: 1	رَكِبَ رَاحِلَةً
u'رَكِبَ رَجُلٌ':Subject, #1: 1	رَكِبَ الرَّجُلُ
u'رَكِبَ رَسُولٌ':Subject, #3: 3	رَكِبَ رَجُلٌ
u'ركب سُعَاةٌ':Added, #5: 5	رَكِبَ رَسُولُ
u'رَكْبٌ سُعَاةٌ':Added, #1: 1	رَكْبَ السُّعَاةِ
u'رَكِبَ سَفِينَةٌ':Predicate, #1: 1	رَكْبَ السُّعَاةِ
u'رَكِبَ سَفِينَةٌ':Predicate, #1: 1	رَكِبَ السَّفِينَةَ
u'رَكِبَ سَواءٌ':Subject, #1: 1	رَكِبَ سَفِينَةَ
u'رَكِبَ شافِعِيّ':Subject, #1: 1	رَكِبَ سَوَاءٌ
u'رَكِبَ صَبِيٌّ':Subject, #1: 1	رَكِبَ الشَّافِعِيُّ
u'رَكِبَ صَغِيرٌ':Predicate, #1: 1	رَكِبَ صَبِيٌّ
u'رَكِبَ ظَهْرٌ':Predicate, #2: 2	أَرْكَبَ الصَّغِيرَ
u'رَكِبَ عُمَرٌ':Subject, #2: 2	رَكِبَ ظَهْرَ
u'رَكِبَ غَرَرٌ':Predicate, #2: 2	رَكِبَ عُمَرُ
u'رَكِبَ غير':Subject, #1: 1	رَكِبَ الْغَرَرَ
u'رَكِبَ غَيْرٌ':Subject, #1: 1	رَكِبَ غَيْرُهُ
u'رَكِبَ فَرَسٌ':Predicate, #1: 1	رَكِبَ غَيْرُهُ
u'رَكِبَ فلان':Subject, #1: 1	رَكِبَ فَرَسَ
u'رَكِبَ فلان':Subject, #1: 1	رَكِبَ الشَّافِعِيُّ
u'رَكِبَ فُلاَنٌ':Subject, #1: 1	رَكِبَ مُعَاوِيَةُ
u'رَكِبَ قَالٌ':Predicate, #2: 2	رَكِبَ فُلَانٌ
u'رَكِبَ قَدْرٌ':Predicate, #1: 1	رَكِبَ قَالَ
u'رَكِبَ قَوْمٌ':Subject, #1: 1	أَرْكَبَ قَدْرَ
u'رَكِبَ مَالِكٌ':Subject, #2: 2	رَكِبَ الْقَوْمُ
u'رَكِبَ مَتْنٌ':Predicate, #1: 1	رَكِبَ الْمَالِكُ
u'رَكِبَ مُرْتَهِنٌ':Subject, #1: 1	رَكِبَ مَتْنَ
u'رَكِبَ مُسَافِرٌ':Subject, #1: 1	رَكِبَ الْمُرْتَهِنُ
u'رَكَّبَ مُسْتَأْجِرٌ':Subject, #1: 1	رَكِبَ الْمُسَافِرُ
u'رَكِبَ مُعاوِيَة':Subject, #1: 1	رَكَّبَ الْمُسْتَأْجِرُ
u'رَكِبَ مَنَاسِكُ':Predicate, #1: 1	رَكِبَ مُعَاوِيَةُ
u'رَكِبَ نَفَرٌ':Subject, #1: 1	رَكِبَ الْمَنَاسِكَ
u'رَكِبَ يَوْمٌ':Predicate, #3: 3	رَكِبَ نَفَرٌ
u'رَكَدَ زِبْلٌ':Subject, #1: 1	رَكِبَ يَوْمَ
u'رَكَزَ حَرْبَةٌ':Predicate, #1: 1	رَكَدَ الزِّبْلُ
u'رَكَّزَ رُمْحٌ':Predicate, #1: 1	رَكَزَ الْحَرْبَةَ
u'رَكَضَ خِلاَفٌ':Predicate, #1: 1	رَكَّزَ الرُّمْحَ
u'رَكَضَ فَرَسٌ':Subject, #1: 1	رَكَضَ خِلَافَ
u'ركض فَرَسٌ':Added, #1: 1	رَكَضَ الْفَرَسُ
u'رَكْضٌ فَرَسٌ':Added, #1: 1	رَكْضَ فَرَسِهِ
u'رَكَعَ أَرْبَعُ':Predicate, #1: 1	رَكْضَ فَرَسِهِ
u'رَكَعَ إمَامٌ':Subject, #5: 5	رَكَعَ أَرْبَعَ
u'رَكَعَ إمَامٌ':Subject, #1: 1	رَكَعَ الإِمَامُ
u'رَكَعَ إمَامٌ':Subject, #25: 25	رَكَعَ الْإِمَامُ
u'رَكَعَ إِنْسانٌ':Subject, #5: 5	رَكَعَ إمَامُهُ
u'رَكَعَ بسط':Predicate, #1: 1	رَكَعَ إنْسَانٌ
u'رَكَعَ بَطَلٌ':Predicate, #5: 5	رَكَعَ بَسَطَ
u'ركعة أَصْلِيٌّ':Added, #1: 1	رَكَعَ بَطَلَ
u'رَكْعَةٌ أَصْلِيٌّ':Added, #3: 3	رَكْعَةٍ أَصْلِيَّةٍ
u'ركعة إمَامٌ':Added, #3: 3	رَكْعَةٍ أَصْلِيَّةٍ
u'رَكْعَةٌ إمَامٌ':Added, #1: 1	رَكْعَةَ الْإِمَامِ
u'ركعة بِنَاءٌ':Added, #1: 1	رَكْعَةَ الْإِمَامِ
u'ركعة بِنَاءٌ':Added, #1: 1	رَكْعَةَ الْبِنَاءِ
u'رَكْعَةٌ بِنَاءٌ':Added, #1: 1	رَكْعَةُ الْبِنَاءِ
u'رَكْعَةٌ بِنَاءٌ':Added, #1: 1	رَكْعَةَ الْبِنَاءِ
u'ركعة تَالِي':Added, #1: 1	رَكْعَةُ الْبِنَاءِ
u'رَكْعَةٌ تَالِي':Added, #1: 1	رَكْعَةٍ تَالِيَةٍ
u'ركعة تَامٌّ':Added, #1: 1	رَكْعَةٍ تَالِيَةٍ
u'رَكْعَةٌ تَامٌّ':Added, #1: 1	رَكْعَةٍ تَامَّةٍ
u'ركعة تِلاوَةٌ':Added, #1: 1	رَكْعَةٍ تَامَّةٍ
u'رَكْعَةٌ تِلاوَةٌ':Added, #1: 1	رَكْعَةَ التِّلَاوَةِ
u'ركعة زائِدٌ':Added, #1: 1	رَكْعَةَ التِّلَاوَةِ
u'رَكْعَةٌ زائِدٌ':Added, #4: 4	رَكْعَةٍ زَائِدَةٍ
u'ركعة ظُهْرٌ':Added, #4: 4	رَكْعَةٍ زَائِدَةٍ
u'رَكْعَةٌ ظُهْرٌ':Added, #2: 2	رَكْعَةِ الظُّهْرِ
u'ركعة قَضَاءٌ':Added, #2: 2	رَكْعَةِ الظُّهْرِ
u'رَكْعَةٌ قَضَاءٌ':Added, #1: 1	رَكْعَةَ الْقَضَاءِ
u'ركعة قَضَاءٌ':Added, #1: 1	رَكْعَةَ الْقَضَاءِ
u'رَكْعَةٌ قَضَاءٌ':Added, #1: 1	رَكْعَةُ قَضَاءٍ
u'ركعة قَضَاءٌ':Added, #1: 1	رَكْعَةُ قَضَاءٍ
u'رَكْعَةٌ قَضَاءٌ':Added, #2: 2	رَكْعَةِ الْقَضَاءِ
u'ركعة كَامِلٌ':Added, #2: 2	رَكْعَةِ الْقَضَاءِ
u'رَكْعَةٌ كَامِلٌ':Added, #7: 7	رَكْعَةٍ كَامِلَةٍ
u'ركعة مَحْسُوبٌ':Added, #7: 7	رَكْعَةٍ كَامِلَةٍ
u'رَكْعَةٌ مَحْسُوبٌ':Added, #1: 1	رَكْعَةٍ مَحْسُوبَةٍ
u'ركعة مَسْبُوق':Added, #1: 1	رَكْعَةٍ مَحْسُوبَةٍ
u'ركعة مَسْبُوق':Added, #1: 1	رَكْعَةَ الْمَسْبُوقِ
u'رَكْعَةٌ مَسْبُوق':Added, #1: 1	رَكْعَةِ الْمَسْبُوقِ
u'رَكْعَةٌ مَسْبُوق':Added, #1: 1	رَكْعَةَ الْمَسْبُوقِ
u'ركعة مَسْبُوق':Added, #1: 1	رَكْعَةِ الْمَسْبُوقِ
u'ركعة مَسْبُوق':Added, #1: 1	رَكْعَةُ مَسْبُوقٍ
u'رَكْعَةٌ مَسْبُوق':Added, #1: 1	رَكْعَةِ مَسْبُوقٍ
u'رَكْعَةٌ مَسْبُوق':Added, #1: 1	رَكْعَةُ مَسْبُوقٍ
u'ركعة واحد':Added, #1: 1	رَكْعَةِ مَسْبُوقٍ
u'ركعة وَاحِدٌ':Added, #1: 1	رَكْعَةِ وَاحِدَةٍ
u'رَكْعَةٌ واحد':Added, #1: 1	رَكْعَةِ وَاحِدَةٍ
u'رَكْعَةٌ وَاحِدٌ':Added, #1: 1	رَكْعَةِ وَاحِدَةٍ
u'ركعة واحد':Added, #1: 1	رَكْعَةِ وَاحِدَةٍ
u'ركعة وَاحِدٌ':Added, #38: 38	رَكْعَةٍ وَاحِدَةٍ
u'رَكْعَةٌ واحد':Added, #38: 38	رَكْعَةٍ وَاحِدَةٍ
u'رَكْعَةٌ وَاحِدٌ':Added, #38: 38	رَكْعَةٍ وَاحِدَةٍ
u'رَكَعَ ثَلاثُ':Predicate, #38: 38	رَكْعَةٍ وَاحِدَةٍ
u'رَكَعَ جَازٌ':Predicate, #1: 1	رَكَعَ ثَلَاثَ
u'رَكَعَ حَديثٌ':Predicate, #1: 1	رَكَعَ جَازَ
u'رَكَعَ خَمْسٌ':Predicate, #1: 1	رَكَعَ الْحَدِيثَ
u'رَكَعَ دونٌ':Predicate, #2: 2	رَكَعَ خَمْسَ
u'رَكَعَ ذكر':Predicate, #3: 3	رَكَعَ دُونَ
u'رَكَعَ رَجُلٌ':Subject, #1: 1	رَكَعَ ذُكِرَ
u'رَكَعَ رَسُولٌ':Subject, #1: 1	رَكَعَ الرَّجُلُ
u'رَكَعَ زادٌ':Predicate, #6: 6	رَكَعَ رَسُولُ
u'رَكَعَ سجدة':Predicate, #1: 1	رَكَعَ زَادَ
u'رَكَعَ سَجْدَةٌ':Predicate, #1: 1	رَكَعَ سَجْدَةَ
u'رَكَعَ صنع':Predicate, #1: 1	رَكَعَ سَجْدَةَ
u'رَكَعَ عند':Predicate, #1: 1	رَكَعَ صَنَعَ
u'رَكَعَ فَجْرٌ':Predicate, #4: 4	رَكَعَ عِنْدَ
u'رَكَعَ قَالٌ':Predicate, #4: 4	رَكَعَ الْفَجْرَ
u'رَكَعَ قَدْرٌ':Predicate, #9: 9	رَكَعَ قَالَ
u'رَكَعَ مَسْبُوق':Subject, #2: 2	رَكَعَ قَدْرَ
u'رَكَعَ نَبِيٌّ':Subject, #1: 1	رَكَعَ الْمَسْبُوقُ
u'رَكَنَ بَائِعٌ':Subject, #1: 1	رَكَعَ النَّبِيُّ
u'رَمَّ أَوَّلُ':Subject, #1: 1	رَكَنَ الْبَائِعُ
u'رَمَحَ نَاسٌ':Predicate, #1: 1	رَمَّ الْأَوَّلُ
u'رَمَّ حيطانٌ':Predicate, #1: 1	رَمَحَ النَّاسَ
u'رَمْزٌ زِيادَةٌ':Added, #1: 1	رَمَّ حِيطَانَ
u'رَمَزَ شَرْعٌ':Subject, #1: 1	رَمْزُ الزِّيَادَاتِ
u'رَمَزَ شمس':Subject, #1: 1	رَمَزَ الشَّرْعُ
u'رَمَزَ شَمْسٌ':Subject, #1: 1	رَمَزَ شَمْسُ
u'رَمْزٌ كِتَابٌ':Added, #1: 1	رَمَزَ شَمْسُ
u'رَمَلَ بَيْنٌ':Predicate, #1: 1	رَمْزُ كِتَابٍ
u'رَمَلَ ثَلاثَةٌ':Predicate, #1: 1	رَمَلَ بَيْنَ
u'رَمَلَ رَسُولٌ':Subject, #2: 2	رَمَلَ ثَلاَثَةَ
u'رَمَلٌ رَسُولٌ':Added, #6: 6	رَمَلَ رَسُولُ
u'رَمَلٌ طواف':Added, #1: 1	رَمَلِ رَسُولِ
u'رَمَلٌ طَوَافٌ':Added, #1: 1	رَمَلَ الطَّوَافِ
u'رَمَلَ نَبِيٌّ':Subject, #1: 1	رَمَلَ الطَّوَافِ
u'رَمَلٌ نَبِيٌّ':Added, #1: 1	رَمَلَ النَّبِيُّ
u'رَمَى اِبْنٌ':Predicate, #1: 1	رَمَلِ النَّبِيِّ
u'رَمْيٌ أُخْرَى':Added, #2: 2	رَمَى ابْنَ
u'رَمْيٌ آدَمِيٌّ':Added, #2: 2	رَمْيُ الْأُخْرَيَيْنِ
u'رَمْيٌ آدَمِيٌّ':Added, #1: 1	رَمْيَ آدَمِيٍّ
u'رَمْيٌ آدَمِيٌّ':Added, #1: 1	رَمْيَ الْآدَمِيِّ
u'رَمَى أسْوَد':Predicate, #1: 1	رَمْيِ الْآدَمِيِّ
u'رَمَى أَكْثَرُ':Predicate, #1: 1	رَمَى الْأَسْوَدَ
u'رَمْيٌ أَكْثَرُ':Added, #1: 1	رَمَى أَكْثَرَ
u'رَمَى إِنْسانٌ':Subject, #1: 1	رَمْيَ أَكْثَرِ
u'رَمَى إهَابٌ':Predicate, #1: 1	رَمَى إنْسَانٌ
u'رَمَى أهْلٌ':Predicate, #1: 1	رَمَى إهَابَ
u'رَمْيٌ أَوَّلُ':Added, #1: 1	رَمَى أَهْلَ
u'رَمْيٌ أيَّامٌ':Added, #1: 1	رَمْيِ أَوَّلِ
u'رَمْيٌ أَيَّامٌ':Added, #1: 1	رَمْيَ الْأَيَّامِ
u'رَمْيٌ أيَّامٌ':Added, #1: 1	رَمْيَ الْأَيَّامِ
u'رَمْيٌ أَيَّامٌ':Added, #1: 1	رَمْيُ أَيَّامِ
u'رَمْيٌ أيَّامٌ':Added, #1: 1	رَمْيُ أَيَّامِ
u'رَمْيٌ أَيَّامٌ':Added, #6: 6	رَمْيِ أَيَّامِ
u'رَمَى بَحْرٌ':Subject, #6: 6	رَمْيِ أَيَّامِ
u'رَمْيٌ بَعْضٌ':Added, #1: 1	رَمَى الْبَحْرُ
u'رَمْيٌ بُنْدُقٌ':Added, #1: 1	رَمْيِ بَعْضِ
u'رَمَى تُرَابٌ':Predicate, #1: 1	رَمْيِ الْبُنْدُقِ
u'رَمْيٌ تُرْس':Added, #1: 1	رَمَى التُّرَابَ
u'رَمْيٌ تُرْس':Added, #1: 1	رَمْيُ التُّرْسِ
u'رَمَى ثَالِثٌ':Predicate, #1: 1	رَمْيِ التُّرْسِ
u'رَمْيٌ ثَالِثٌ':Added, #1: 1	رَمَى الثَّالِثَةَ
u'رَمْيٌ ثَالِثٌ':Added, #1: 1	رَمْيَ الثَّالِثِ
u'رَمَى ثَانِي':Predicate, #4: 4	رَمْيُ الثَّالِثِ
u'رَمْيٌ ثَانِي':Added, #2: 2	رَمَى الثَّانِيَةَ
u'رَمَى ثَانِيَةٌ':Predicate, #1: 1	رَمْيُ الثَّانِيَةِ
u'رَمْيٌ ثَانِيَةٌ':Added, #2: 2	رَمَى الثَّانِيَةَ
u'رَمَى ثَلاثُ':Predicate, #1: 1	رَمْيُ الثَّانِيَةِ
u'رَمْيٌ ثَلاثُ':Added, #2: 2	رَمَى الثَّلَاثَ
u'رَمَى ثَلاثَةٌ':Predicate, #1: 1	رَمْيَ ثَلَاثِ
u'رَمَى ثَلاثَةٌ':Subject, #1: 1	رَمَى ثَلَاثَةَ
u'رَمَى جِمَارٌ':Predicate, #5: 5	رَمَى ثَلَاثَةٌ
u'رَمْيٌ جِمَارٌ':Added, #20: 20	رَمَى الْجِمَارَ
u'رَمْيٌ جِمَارٌ':Added, #1: 1	رَمْي الْجِمَارِ
u'رَمْيٌ جِمَارٌ':Added, #1: 1	رَمْيِ جِمَارٍ
u'رَمْيٌ جِمَارٌ':Added, #27: 27	رَمْيِ الْجِمَارِ
u'رَمْيٌ جِمَارٌ':Added, #7: 7	رَمْيُ الْجِمَارِ
u'رَمْيٌ جَمْر':Added, #8: 8	رَمْيَ الْجِمَارِ
u'رَمْيٌ جَمْر':Added, #1: 1	رَمْيُ الْجَمْرَتَيْنِ
u'رَمَى جَمْرَةٌ':Predicate, #1: 1	رَمْيِ الْجَمْرَتَيْنِ
u'رَمَى جَمْرَة':Predicate, #39: 39	رَمَى الْجَمْرَةَ
u'رَمَى جَمْرَةٌ':Predicate, #39: 39	رَمَى الْجَمْرَةَ
u'رَمَى جَمْرَة':Predicate, #54: 54	رَمَى جَمْرَةَ
u'رَمْيٌ جَمْرَةٌ':Added, #54: 54	رَمَى جَمْرَةَ
u'رَمْيٌ جَمْرَةٌ':Added, #1: 1	رَمْيَ جَمْرَةٍ
u'رَمْيٌ جَمْرَة':Added, #1: 1	رَمْيِ جَمْرَةٍ
u'رَمْيٌ جَمْرَة':Added, #1: 1	رَمْيَ جَمْرَةٍ
u'رَمْيٌ جَمْرَةٌ':Added, #1: 1	رَمْيِ جَمْرَةٍ
u'رَمْيٌ جَمْرَة':Added, #20: 20	رَمْيِ جَمْرَةِ
u'رَمْيٌ جَمْرَةٌ':Added, #20: 20	رَمْيِ جَمْرَةِ
u'رَمْيٌ جَمْرَة':Added, #2: 2	رَمْيُ الْجَمْرَةِ
u'رَمْيٌ جَمْرَةٌ':Added, #2: 2	رَمْيُ الْجَمْرَةِ
u'رَمْيٌ جَمْرَة':Added, #2: 2	رَمْيُ جَمْرَةِ
u'رَمْيٌ جَمْرَةٌ':Added, #2: 2	رَمْيُ جَمْرَةِ
u'رَمْيٌ جَمْرَة':Added, #6: 6	رَمْيِ الْجَمْرَةِ
u'رَمْيٌ جَمْرَةٌ':Added, #6: 6	رَمْيِ الْجَمْرَةِ
u'رَمْيٌ جَمْرَة':Added, #6: 6	رَمْيَ جَمْرَةِ
u'رَمَى جَوَابٌ':Predicate, #6: 6	رَمْيَ جَمْرَةِ
u'رَمْيٌ حِجارَةٌ':Added, #1: 1	رَمَى الْجَوَابَ
u'رَمَى حَديثٌ':Predicate, #2: 2	رَمْيِ الْحِجَارَةِ
u'رَمَى حُرٌّ':Subject, #2: 2	رَمَى الْحَدِيثَ
u'رَمْيٌ حَصَاةٌ':Added, #1: 1	رَمَى حُرٌّ
u'رَمْيٌ حَصَاةٌ':Added, #1: 1	رَمْيُ الْحَصَاةِ
u'رَمَى حَلالٌ':Subject, #1: 1	رَمْيِ الْحَصَاةِ
u'رَمَى حَلالٌ':Subject, #4: 4	رَمَى حَلَالٌ
u'رَمْيٌ خَلِيلٌ':Added, #7: 7	رَمَى الْحَلَالُ
u'رَمَى ذِمِّيٌّ':Subject, #1: 1	رَمْيُ الْخَلِيلِ
u'رَمْيٌ رابع':Added, #1: 1	رَمَى الذِّمِّيُّ
u'رَمْيٌ رابع':Added, #1: 1	رَمْيُ الرَّابِعِ
u'رَمْيٌ رَابِعٌ':Added, #1: 1	رَمْيِ الرَّابِعِ
u'رَمْيٌ رَابِعٌ':Added, #1: 1	رَمْيُ الرَّابِعِ
u'رَمْيٌ رَاكِبٌ':Added, #1: 1	رَمْيِ الرَّابِعِ
u'رَمَى رَجُلٌ':Predicate, #1: 1	رَمْيِ الرَّاكِبِ
u'رَمَى رَجُلٌ':Predicate, #1: 1	رَمَى الرَّجُلَ
u'رَمَى رَجُلٌ':Subject, #4: 4	رَمَى رَجُلاً
u'رَمَى رَجُلٌ':Subject, #1: 1	رَمَى الرَّجُلُ
u'رَمْيٌ رَجُلٌ':Added, #7: 7	رَمَى رَجُلٌ
u'رَمَى رَسُولٌ':Predicate, #1: 1	رَمْيِ الرَّجُلِ
u'رَمَى رَسُولٌ':Subject, #1: 1	رَمَى رَسُولَ
u'رَمْيٌ رَسُولٌ':Added, #6: 6	رَمَى رَسُولُ
u'رَمْيٌ رَسُولٌ':Added, #1: 1	رَمْيُ الرّسُولِ
u'رَمْيٌ رَسُولٌ':Added, #1: 1	رَمْيِ الرّسُولِ
u'رَمَى رَقيقٌ':Predicate, #1: 1	رَمْيِ رَسُولِ
u'رَمَى رَقيق':Predicate, #1: 1	رَمَى رَقِيقَ
u'رَمَى رَوْث':Predicate, #1: 1	رَمَى رَقِيقَ
u'رَمْيٌ رَوْث':Added, #1: 1	رَمَى الرَّوْثَةَ
u'رَمَى زُجٌّ':Predicate, #1: 1	رَمْيِ الرَّوْثَةِ
u'رَمْيٌ سَهْمٌ':Added, #1: 1	رَمَى الزُّجَّ
u'رَمْيٌ شَجَرٌ':Added, #3: 3	رَمْيِ السَّهْمِ
u'رَمَى شَخْصٌ':Subject, #1: 1	رَمْيُ الشَّجَرِ
u'رَمَى شَعْرٌ':Predicate, #1: 1	رَمَى شَخْصٌ
u'رَمَى شِهَابٌ':Subject, #2: 2	رَمَى الشَّعْرَ
u'رَمْيٌ شَيَاطِينُ':Added, #1: 1	رَمَى الشّهَابُ
u'رَمْيٌ شَيْخٌ':Added, #1: 1	رَمْيُ الشّيَاطِينِ
u'رَمَى صَاحِبٌ':Subject, #1: 1	رَمْيُ الشَّيْخِ
u'رَمْيٌ صَاحِبٌ':Added, #2: 2	رَمَى صَاحِبُهُ
u'رَمَى صَبِيٌّ':Predicate, #1: 1	رَمْيِ صَاحِبِهِ
u'رَمَى صَيْدٌ':Predicate, #1: 1	رَمَى صَبِيَّةً
u'رَمْيٌ صَيْدٌ':Added, #3: 3	رَمَى الصَّيْدَ
u'رَمْيٌ صَيْدٌ':Added, #2: 2	رَمْيِ الصَّيْدِ
u'رَمَى طَيْرٌ':Predicate, #2: 2	رَمْيِ صَيْدٍ
u'رَمْيٌ طَيْرٌ':Added, #2: 2	رَمَى طَيْرَ
u'رَمْيٌ طُيُورٌ':Added, #1: 1	رَمْيِ الطَّيْرِ
u'رَمْيٌ طُيُورٌ':Added, #1: 1	رَمْيُ الطُّيُورِ
u'رَمْيٌ عَالِمٌ':Added, #1: 1	رَمْيِ الطُّيُورِ
u'رَمَى عَبْدٌ':Predicate, #1: 1	رَمْي الْعَالِمِ
u'رَمَى عَبْدٌ':Subject, #1: 1	رَمَى عَبْدَ
u'رَمَى عَدُوٌّ':Predicate, #1: 1	رَمَى عَبْدٌ
u'رَمْيٌ عَدُوٌّ':Added, #1: 1	رَمَى الْعَدُوَّ
u'رَمَى عقبة':Predicate, #1: 1	رَمْيِ الْعَدُوِّ
u'رَمَى عَقَبَةٌ':Predicate, #2: 2	رَمَى الْعَقَبَةَ
u'رَمَى عَمَلٌ':Subject, #2: 2	رَمَى الْعَقَبَةَ
u'رَمَى عند':Predicate, #1: 1	رَمَى عَمَلٌ
u'رَمْيٌ عين':Added, #2: 2	رَمَى عِنْدَ
u'رَمْيٌ عَيْنٌ':Added, #1: 1	رَمْيَ الْعَيْنِ
u'رَمْيٌ عَيْن':Added, #1: 1	رَمْيَ الْعَيْنِ
u'رَمْيٌ عين':Added, #1: 1	رَمْيَ الْعَيْنِ
u'رَمْيٌ عَيْنٌ':Added, #1: 1	رَمْيُ عَيْنِ
u'رَمْيٌ عَيْن':Added, #1: 1	رَمْيُ عَيْنِ
u'رَمْيٌ عين':Added, #1: 1	رَمْيُ عَيْنِ
u'رَمْيٌ عَيْنٌ':Added, #4: 4	رَمْيُ عَيْنِهِ
u'رَمْيٌ عَيْن':Added, #4: 4	رَمْيُ عَيْنِهِ
u'رَمَى غَرَضٌ':Predicate, #4: 4	رَمْيُ عَيْنِهِ
u'رَمَى غير':Predicate, #2: 2	رَمَى الْغَرَضَ
u'رَمَى غَيْرٌ':Predicate, #3: 3	رَمَى غَيْرَ
u'رَمْيٌ غير':Added, #3: 3	رَمَى غَيْرَ
u'رَمْيٌ غَيْرٌ':Added, #1: 1	رَمْيِ الْغَيْرِ
u'رَمَى فلان':Predicate, #1: 1	رَمْيِ الْغَيْرِ
u'رَمَى قِشْرٌ':Predicate, #1: 1	رَمَى الْغَامِدِيَّةَ
u'رَمْيٌ قَمْلَةٌ':Added, #1: 1	رَمَى قِشْرَ
u'رَمَى كَافِرٌ':Subject, #2: 2	رَمْيُ الْقَمْلَةِ
u'رَمْيٌ كَافِرٌ':Added, #2: 2	رَمَى الْكَافِرُ
u'رَمْيٌ كِتَابٌ':Added, #1: 1	رَمْيُ الْكَافِرِ
u'رَمْيٌ كُفَّارٌ':Added, #1: 1	رَمْيَ الْكِتَابِ
u'رَمَى لَيْلٌ':Predicate, #1: 1	رَمْيُ كُفَّارٍ
u'رَمْيٌ مَالٌ':Added, #1: 1	رَمَى لَيْلَةَ
u'رَمْيٌ مَالِكٌ':Added, #1: 1	رَمْيِ مَالِ
u'رَمْيٌ مُتَدَارَكٌ':Added, #1: 1	رَمْيُ الْمَالِكِ
u'رَمْيٌ مُتَعَجِّل':Added, #1: 1	رَمْيُ الْمُتَدَارَكِ
u'رَمَى مَجُوسِيٌّ':Subject, #1: 1	رَمْيُ مُتَعَجِّلٍ
u'رَمَى مَجُوسِيٌّ':Subject, #1: 1	رَمَى مَجُوسِيٌّ
u'رَمَى مُحْرِمٌ':Subject, #2: 2	رَمَى الْمَجُوسِيُّ
u'رَمَى مُحْرِمٌ':Subject, #1: 1	رَمَى مُحْرِمٌ
u'رَمْيٌ مُحْصَنٌ':Added, #5: 5	رَمَى الْمُحْرِمُ
u'رَمْيٌ مُحْصَنٌ':Added, #1: 1	رَمْيُ الْمُحْصَنِ
u'رَمْيٌ مُحْصَنٌ':Added, #1: 1	رَمْيِ الْمُحْصَنَاتِ
u'رَمْيٌ مُرَاهِقٌ':Added, #1: 1	رَمْيُ الْمُحْصَنَةِ
u'رَمْيٌ مُرْتَدٌّ':Added, #1: 1	رَمْيُ الْمُرَاهِقِ
u'رَمْيٌ مُرْتَدٌّ':Added, #1: 1	رَمْيَ الْمُرْتَدِّ
u'رَمَى مُسْتَحِقٌّ':Subject, #1: 1	رَمْيِ الْمُرْتَدِّ
u'رَمَى مُسْلِمٌ':Subject, #1: 1	رَمَى الْمُسْتَحِقُّ
u'رَمْيٌ مُسْلِمٌ':Added, #14: 14	رَمَى مُسْلِمٌ
u'رَمْيٌ مُسْلِمٌ':Added, #1: 1	رَمْيَ الْمُسْلِمِ
u'رَمْيٌ مُسْلِمٌ':Added, #1: 1	رَمْيِ الْمُسْلِمِ
u'رَمْيٌ مُقَدَّمٌ':Added, #3: 3	رَمْيُ الْمُسْلِمِ
u'رَمَى نَارٌ':Predicate, #1: 1	رَمْيُ الْمُقَدَّمَةِ
u'رَمَى نَاسٌ':Subject, #1: 1	رَمَى النَّارَ
u'رَمْيٌ نَاظِرٌ':Added, #1: 1	رَمَى النَّاسُ
u'رَمْيٌ نَحْرٌ':Added, #1: 1	رَمْيُ النَّاظِرِ
u'رَمْيٌ نُفُوسٌ':Added, #1: 1	رَمْيُ النَّحْرِ
u'رَمَى واحد':Predicate, #1: 1	رَمْيِ النُّفُوسِ
u'رَمَى وَاحِدٌ':Predicate, #1: 1	رَمَى وَاحِدَةً
u'رَمَى واحد':Subject, #1: 1	رَمَى وَاحِدَةً
u'رَمَى وَاحِدٌ':Subject, #1: 1	رَمَى وَاحِدٌ
u'رَمَى يَوْمٌ':Predicate, #1: 1	رَمَى وَاحِدٌ
u'رَمْيٌ يَوْمٌ':Added, #4: 4	رَمَى يَوْمَ
u'رَمْيٌ يَوْمٌ':Added, #10: 10	رَمْيَ يَوْمٍ
u'رَمْيٌ يَوْمٌ':Added, #1: 1	رَمْيَ الْيَوْمِ
u'رَمْيٌ يَوْمٌ':Added, #1: 1	رَمْيُ الْيَوْمِ
u'رَمْيٌ يَوْمٌ':Added, #1: 1	رَمْيَ يَوْمِ
u'رَمْيٌ يَوْمٌ':Added, #1: 1	رَمْيُ يَوْمٍ
u'رَمْيٌ يَوْمٌ':Added, #1: 1	رَمْيَ يَوْمَيْنِ
u'رَمْيٌ يَوْمٌ':Added, #2: 2	رَمْيَ يَوْمِهِ
u'رَمْيٌ يَوْمٌ':Added, #3: 3	رَمْيِ يَوْمٍ
u'رَمْيٌ يَوْمٌ':Added, #4: 4	رَمْيِ يَوْمِ
u'رَمْيٌ يَوْمٌ':Added, #4: 4	رَمْيِ يَوْمَيْنِ
u'رَنَّ إبْلِيسُ':Subject, #6: 6	رَمْيُ يَوْمِ
u'رَنَّةٌ شَيْطَانٌ':Added, #1: 1	رَنَّ إبْلِيسُ
u'رهبة الْمَرْءُ':Added, #1: 1	رَنَّةُ الشَّيْطَانِ
u'رَهْبَةٌ الْمَرْءُ':Added, #1: 1	رَهْبَةُ الْمَرْءِ
u'رهبة سُلْطَانٌ':Added, #1: 1	رَهْبَةُ الْمَرْءِ
u'رَهْبَةٌ سُلْطَانٌ':Added, #1: 1	رَهْبَةُ السُّلْطَانِ
u'رهبة نَاسٌ':Added, #1: 1	رَهْبَةُ السُّلْطَانِ
u'رَهْبَةٌ نَاسٌ':Added, #1: 1	رَهْبَةُ النَّاسِ
u'رَهَنَ أَبٌ':Subject, #1: 1	رَهْبَةُ النَّاسِ
u'رَهْنٌ أَبٌ':Added, #10: 10	رَهَنَ الْأَبُ
u'رَهْنٌ أَبٌ':Added, #1: 1	رَهْنَ الْأَبِ
u'رَهْنٌ أَبٌ':Added, #1: 1	رَهْنُ الْأَبِ
u'رَهَنَ إِبْرِيقٌ':Predicate, #1: 1	رَهْنِ الْأَبِ
u'رَهَنَ أَجْنَبِيٌّ':Subject, #1: 1	رَهَنَ إبْرِيقَ
u'رَهَنَ أحَدٌ':Subject, #1: 1	رَهَنَ أَجْنَبِيٌّ
u'رَهَنَ أرْضٌ':Predicate, #2: 2	رَهَنَ أَحَدُ
u'رَهَنَ أرْضٌ':Predicate, #2: 2	رَهَنَ أَرْضَ
u'رَهْنٌ أرْضٌ':Added, #3: 3	رَهَنَ الْأَرْضَ
u'رَهْنٌ أرْضٌ':Added, #1: 1	رَهْنُ الْأَرْضِ
u'رَهْنٌ أرْضٌ':Added, #2: 2	رَهْنَ الْأَرْضِ
u'رَهَنَ أصل':Predicate, #7: 7	رَهْنِ الْأَرْضِ
u'رَهَنَ أًصْلٌ':Predicate, #1: 1	رَهَنَ الْأَصْلَ
u'رَهْنٌ أصل':Added, #1: 1	رَهَنَ الْأَصْلَ
u'رَهْنٌ أًصْلٌ':Added, #6: 6	رَهْنِ الْأَصْلِ
u'رَهْنٌ أُمٌّ':Added, #6: 6	رَهْنِ الْأَصْلِ
u'رَهَنَ أمَةٌ':Predicate, #1: 1	رَهْنِ الْأُمِّ
u'رَهْنٌ أمَةٌ':Added, #1: 1	رَهَنَ أَمَةَ
u'رَهْنٌ أمَةٌ':Added, #1: 1	رَهْنَ الْأَمَةِ
u'رَهْنٌ أمَةٌ':Added, #1: 1	رَهْنُ الْأَمَةِ
u'رَهْنٌ أمَةٌ':Added, #1: 1	رَهْنِ الْأَمَةِ
u'رَهَنَ إِنْسانٌ':Subject, #1: 1	رَهْنُ أَمَةٍ
u'رَهَنَ أَوَّلُ':Subject, #1: 1	رَهَنَ إنْسَانٌ
u'رَهْنٌ بَزّاز':Added, #1: 1	رَهَنَ الْأَوَّلُ
u'رَهْنٌ بَزّازَة':Added, #1: 1	رَهْنِ الْبَزَّازِيَّةِ
u'رَهَنَ بَعْضٌ':Predicate, #1: 1	رَهْنِ الْبَزَّازِيَّةِ
u'رَهْنٌ بُؤْسٌ':Added, #1: 1	رَهَنَ بَعْضَ
u'رَهْنٌ بَيْعٌ':Added, #1: 1	رَهْنَ بُؤْسٍ
u'رَهْنٌ تَبَرُّعٌ':Added, #1: 1	رَهْنِ الْبَيْعِ
u'رَهْنٌ تَبَرُّعٌ':Added, #1: 1	رَهْنُ تَبَرُّعٍ
u'رَهْنٌ تَرِكَةٌ':Added, #2: 2	رَهْنَ تَبَرُّعٍ
u'رَهَنَ تَمْر':Predicate, #2: 2	رَهْنُ التَّرِكَةِ
u'رَهْنٌ تَمْر':Added, #1: 1	رَهَنَ التَّمْرَ
u'رَهْنٌ ثِقَةٌ':Added, #1: 1	رَهْنِ التَّمْرِ
u'رَهَنَ ثَلاثَةٌ':Subject, #1: 1	رَهْنُ ثِقَةٍ
u'رَهَنَ ثَمَرٌ':Predicate, #1: 1	رَهَنَ ثَلَاثَةٌ
u'رَهْنٌ ثَمَرٌ':Added, #1: 1	رَهَنَ الثَّمَرَ
u'رَهَنَ ثَمَرَةٌ':Predicate, #1: 1	رَهْنُ الثَّمَرِ
u'رَهْنٌ ثَمَرَةٌ':Added, #1: 1	رَهَنَ الثَّمَرَةَ
u'رَهْنٌ ثَمَرَةٌ':Added, #1: 1	رَهْنَ الثَّمَرَةِ
u'رَهْنٌ ثَمَرَةٌ':Added, #2: 2	رَهْنِ الثَّمَرَةِ
u'رَهْنٌ ثَمَنٌ':Added, #3: 3	رَهْنُ ثَمَرَةٍ
u'رَهْنٌ ثَمَنٌ':Added, #1: 1	رَهْنَ ثَمَنِهِ
u'رَهْنٌ ثَمَنٌ':Added, #1: 1	رَهْنِ ثَمَنِهِ
u'رَهْنٌ ثَمَنٌ':Added, #2: 2	رَهْنَ الثَّمَنِ
u'رَهَنَ ثَوْبٌ':Predicate, #2: 2	رَهْنِ الثَّمَنِ
u'رَهَنَ جَارِي':Predicate, #1: 1	رَهَنَ ثَوْبَ
u'رَهْنٌ جَارِي':Added, #18: 18	رَهَنَ جَارِيَةً
u'رَهْنٌ جَارِيَةٌ':Added, #3: 3	رَهْنُ الْجَارِيَةِ
u'رَهَنَ جَازٌ':Predicate, #3: 3	رَهْنُ الْجَارِيَةِ
u'رَهْنٌ جَامِعٌ':Added, #1: 1	رَهَنَ جَازَ
u'رَهْنٌ جُلُودٌ':Added, #2: 2	رَهْنِ الْجَامِعِ
u'رَهْنٌ جَمِيع':Added, #1: 1	رَهْنُ جُلُودِ
u'رَهْنٌ جَمِيع':Added, #2: 2	رَهْنُ الْجَمِيعِ
u'رَهْنٌ حَجَرٌ':Added, #2: 2	رَهْنِ الْجَمِيعِ
u'رَهْنٌ حُرٌّ':Added, #1: 1	رَهْنُ الْحَجَرَيْنِ
u'رَهْنٌ حِصَّةٌ':Added, #3: 3	رَهْنُ الْحُرِّ
u'رَهْنٌ حَقٌّ':Added, #2: 2	رَهْنُ حِصَّتِهِ
u'رَهْنٌ حُلِيٌّ':Added, #2: 2	رَهْنُ حَقِّهِ
u'رَهَنَ حَمْلٌ':Predicate, #1: 1	رَهْنِ حُلِيٍّ
u'رَهَنَ حِمْلٌ':Predicate, #1: 1	رَهَنَ الْحَمْلَ
u'رَهْنٌ حَيَوَانٌ':Added, #3: 3	رَهَنَ الْحِمْلَ
u'رَهْنٌ خان':Added, #1: 1	رَهْنُ الْحَيَوَانِ
u'رَهْنٌ خان':Added, #1: 1	رَهْنُ الْخَانِيَّةِ
u'رَهْنٌ خانَة':Added, #2: 2	رَهْنِ الْخَانِيَّةِ
u'رَهْنٌ خانَة':Added, #1: 1	رَهْنُ الْخَانِيَّةِ
u'رَهْنٌ خدمة':Added, #2: 2	رَهْنِ الْخَانِيَّةِ
u'رَهْنٌ خِدْمَةٌ':Added, #1: 1	رَهْنُ خِدْمَةِ
u'رَهْنٌ خَمْرٌ':Added, #1: 1	رَهْنُ خِدْمَةِ
u'رَهْنٌ دَابَّةٌ':Added, #2: 2	رَهْنُ الْخَمْرِ
u'رَهَنَ دَارٌ':Predicate, #1: 1	رَهْنِ الدَّابَّةِ
u'رَهَنَ دَارٌ':Predicate, #1: 1	رَهَنَ دَارَ
u'رَهْنٌ دَارٌ':Added, #4: 4	رَهَنَ الدَّارَ
u'رَهْنٌ دَارٌ':Added, #1: 1	رَهْنُ الدَّارِ
u'رَهْنٌ دَرَاهِمُ':Added, #3: 3	رَهْنِ الدَّارِ
u'رَهْنٌ دَيْنٌ':Added, #4: 4	رَهْنُ الدَّرَاهِمِ
u'رَهْنٌ دَيْنٌ':Added, #1: 1	رَهْنِ الدَّيْنِ
u'رَهْنٌ دَيْنٌ':Added, #1: 1	رَهْنُ دَيْنٍ
u'رَهَنَ ذِمِّيٌّ':Subject, #2: 2	رَهْنُ الدَّيْنِ
u'رَهَنَ ذِمِّيٌّ':Subject, #2: 2	رَهَنَ الذِّمِّيُّ
u'رَهَنَ رَاهِنٌ':Subject, #5: 5	رَهَنَ ذِمِّيٌّ
u'رَهَنَ رَبُّ':Subject, #1: 1	رَهَنَ الرَّاهِنُ
u'رَهْنٌ رَبُّ':Added, #2: 2	رَهَنَ رَبُّ
u'رَهَنَ رَجُلٌ':Subject, #1: 1	رَهْنِ رَبِّ
u'رَهَنَ رَجُلٌ':Subject, #1: 1	رَهَنَ الرَّجُلُ
u'رَهْنٌ رَجُلٌ':Added, #3: 3	رَهَنَ رَجُلٌ
u'رَهَنَ رَسُولٌ':Subject, #2: 2	رَهْنِ رَجُلَيْنِ
u'رَهَنَ رَهْنٌ':Predicate, #3: 3	رَهَنَ رَسُولُ
u'رَهْنٌ زَرْعٌ':Added, #3: 3	رَهَنَ الرَّهْنَ
u'رَهْنٌ زَيْدٌ':Added, #1: 1	رَهْنَ الزَّرْعِ
u'رَهَنَ شَجَرٌ':Predicate, #1: 1	رَهْنُ زَيْدٍ
u'رَهْنٌ شَجَرٌ':Added, #1: 1	رَهَنَ الشَّجَرَ
u'رَهَنَ شَجَرَةٌ':Predicate, #1: 1	رَهْنِ الشَّجَرِ
u'رَهَنَ شَيْءٌ':Predicate, #1: 1	رَهَنَ شَجَرَةَ
u'رَهْنٌ شَيْءٌ':Added, #1: 1	رَهَنَ الشَّيْءَ
u'رَهْنٌ شَيْءٌ':Added, #2: 2	رَهْنُ شَيْءٍ
u'رَهْنٌ صَاحِبٌ':Added, #3: 3	رَهْنُ الشَّيْءِ
u'رَهْنٌ صَيْدٌ':Added, #2: 2	رَهْنِ صَاحِبِهِ
u'رَهْنٌ ظَرْفٌ':Added, #1: 1	رَهْنُ صَيْدِ
u'رَهَنَ عَبْدٌ':Predicate, #1: 1	رَهْنَ الظَّرْفِ
u'رَهْنٌ عَبْدٌ':Added, #1: 1	رَهَنَ الْعَبْدَ
u'رَهْنٌ عَبْدٌ':Added, #1: 1	رَهْنَ عَبْدِهِ
u'رَهْنٌ عَبْدٌ':Added, #1: 1	رَهْن عَبْدَيْنِ
u'رَهْنٌ عَبْدٌ':Added, #2: 2	رَهْنِ الْعَبْدِ
u'رَهْنٌ عَبْدٌ':Added, #2: 2	رَهْنِ عَبْدِهِ
u'رَهَنَ عَشْرٌ':Predicate, #3: 3	رَهْنُ الْعَبْدِ
u'رَهَنَ عِمَارَةٌ':Predicate, #1: 1	رَهَنَ عَشْرَ
u'رَهَنَ عند':Predicate, #1: 1	رَهَنَ عِمَارَةَ
u'رَهَنَ عين':Predicate, #18: 18	رَهَنَ عِنْدَ
u'رَهَنَ عَيْنٌ':Predicate, #2: 2	رَهَنَ الْعَيْنَ
u'رَهَنَ عَيْن':Predicate, #2: 2	رَهَنَ الْعَيْنَ
u'رَهْنٌ عين':Added, #2: 2	رَهَنَ الْعَيْنَ
u'رَهْنٌ عَيْنٌ':Added, #1: 1	رَهْنُ الْعَيْنِ
u'رَهْنٌ عَيْن':Added, #1: 1	رَهْنُ الْعَيْنِ
u'رَهْنٌ عُيُونٌ':Added, #1: 1	رَهْنُ الْعَيْنِ
u'رَهَنَ غَاصِبٌ':Subject, #1: 1	رَهْنِ الْعُيُونِ
u'رَهْنٌ غَائِبٌ':Added, #2: 2	رَهَنَ الْغَاصِبُ
u'رَهْنٌ غَرَرٌ':Added, #1: 1	رَهْنٍ غَائِبٍ
u'رَهْنٌ غَنَمٌ':Added, #1: 1	رَهْنُ الْغَرَرِ
u'رَهَنَ غير':Predicate, #1: 1	رَهْنِ الْغَنَمِ
u'رَهَنَ غَيْرٌ':Predicate, #2: 2	رَهَنَ غَيْرَ
u'رَهْنٌ غير':Added, #2: 2	رَهَنَ غَيْرَ
u'رَهْنٌ غَيْرٌ':Added, #1: 1	رَهْنُ غَيْرِ
u'رَهْنٌ غير':Added, #1: 1	رَهْنُ غَيْرِ
u'رَهْنٌ غَيْرٌ':Added, #1: 1	رَهْنِ غَيْرِهِ
u'رَهْنٌ فَاسِدٌ':Added, #1: 1	رَهْنِ غَيْرِهِ
u'رَهْنٌ فِضَّةٌ':Added, #2: 2	رَهْنٍ فَاسِدٍ
u'رَهَنَ فضلة':Predicate, #1: 1	رَهْنِ الْفِضَّةِ
u'رَهَنَ فَضْلَةٌ':Predicate, #1: 1	رَهَنَ فَضْلَةَ
u'رَهْنٌ فضلة':Added, #1: 1	رَهَنَ فَضْلَةَ
u'رَهْنٌ فَضْلَةٌ':Added, #1: 1	رَهْنُ الْفَضْلَةِ
u'رَهْنٌ فضلة':Added, #1: 1	رَهْنُ الْفَضْلَةِ
u'رَهْنٌ فَضْلَةٌ':Added, #1: 1	رَهْنُ فَضْلَةِ
u'رَهْنٌ فضلة':Added, #1: 1	رَهْنُ فَضْلَةِ
u'رَهْنٌ فَضْلَةٌ':Added, #1: 1	رَهْنُ فَضْلَتِهِ
u'رَهَنَ فُلاَنٌ':Subject, #1: 1	رَهْنُ فَضْلَتِهِ
u'رَهْنٌ فلان':Added, #1: 1	رَهَنَ فُلَانٌ
u'رَهْنٌ فلان':Added, #1: 1	رَهْنِ الْبَزَّازِيَّةِ
u'رَهْنٌ فلان':Added, #1: 1	رَهْنُ الْخَانِيَّةِ
u'رَهَنَ قَالٌ':Predicate, #2: 2	رَهْنِ الْخَانِيَّةِ
u'رَهْنٌ قَتِيلٌ':Added, #1: 1	رَهَنَ قَالَ
u'رَهَنَ قلب':Predicate, #1: 1	رَهْنِ الْقَتِيلِ
u'رَهْنٌ كَافِرٌ':Added, #4: 4	رَهَنَ قُلْبَ
u'رَهْنٌ كَفِيلٌ':Added, #1: 1	رَهْنَ الْكَافِرِ
u'رَهَنَ مَالٌ':Predicate, #1: 1	رَهْنِ الْكَفِيلِ
u'رَهْنٌ مَالٌ':Added, #2: 2	رَهَنَ مَالَ
u'رَهْنٌ مَالٌ':Added, #1: 1	رَهْنَ مَالِ
u'رَهْنٌ مَالِكٌ':Added, #2: 2	رَهْنُ مَالِ
u'رَهْنٌ مُبَاحٌ':Added, #1: 1	رَهْنِ الْمَالِكِ
u'رَهَنَ مَبِيعٌ':Predicate, #1: 1	رَهْنُ الْمُبَاحَاتِ
u'رَهْنٌ مَبِيعٌ':Added, #1: 1	رَهَنَ الْمَبِيعَ
u'رَهْنٌ مَبِيعٌ':Added, #1: 1	رَهْنَ الْمَبِيعِ
u'رَهْنٌ مَبِيعٌ':Added, #4: 4	رَهْنُ الْمَبِيعِ
u'رَهْنٌ مُتَبَرِّعٌ':Added, #4: 4	رَهْنِ الْمَبِيعِ
u'رَهَنَ مَجْنِيٌّ':Subject, #1: 1	رَهْنُ الْمُتَبَرِّعِ
u'رَهْنٌ مَجْنِيٌّ':Added, #1: 1	رَهَنَ الْمَجْنِيُّ
u'رَهْنٌ مُدَبَّرٌ':Added, #1: 1	رَهْنَ الْمَجْنِيِّ
u'رَهْنٌ مُدَبَّرٌ':Added, #1: 1	رَهْنِ الْمُدَبَّرِ
u'رَهْنٌ مُدَبَّرٌ':Added, #2: 2	رَهْنَ الْمُدَبَّرِ
u'رَهْنٌ مَدْيُونٌ':Added, #3: 3	رَهْنُ الْمُدَبَّرِ
u'رَهْنٌ مُرْتَدٌّ':Added, #1: 1	رَهْنُ الْمَدْيُونِ
u'رَهَنَ مُرْتَهِنٌ':Subject, #2: 2	رَهْنُ الْمُرْتَدِّ
u'رَهْنٌ مُرْتَهِنٌ':Added, #1: 1	رَهَنَ الْمُرْتَهِنُ
u'رَهْنٌ مُرْتَهِنٌ':Added, #1: 1	رَهْنُ الْمُرْتَهِنِ
u'رَهْنٌ مَرْهُونٌ':Added, #1: 1	رَهْنُ مُرْتَهِنِ
u'رَهْنٌ مَرْهُونٌ':Added, #1: 1	رَهْنِ الْمَرْهُونِ
u'رَهْنٌ مَرْهُونٌ':Added, #1: 1	رَهْنُ مَرْهُونٍ
u'رَهَنَ مُسْتَعَارٌ':Predicate, #2: 2	رَهْنَ الْمَرْهُونِ
u'رَهَنَ مُسْلِمٌ':Subject, #2: 2	رَهَنَ الْمُسْتَعَارَ
u'رَهْنٌ مُسْلِمٌ':Added, #2: 2	رَهَنَ مُسْلِمٌ
u'رَهْنٌ مُشاعٌ':Added, #1: 1	رَهْنُ الْمُسْلِمِ
u'رَهْنٌ مُشاعٌ':Added, #14: 14	رَهْنُ الْمُشَاعِ
u'رَهْنٌ مُشاعٌ':Added, #1: 1	رَهْنَ الْمُشَاعِ
u'رَهْنٌ مَشْرُوطٌ':Added, #4: 4	رَهْنِ الْمُشَاعِ
u'رَهَنَ مُصْحَفٌ':Predicate, #1: 1	رَهْنٍ مَشْرُوطٍ
u'رَهْنٌ مُصْحَفٌ':Added, #1: 1	رَهَنَ الْمُصْحَفَ
u'رَهْنٌ مُصْحَفٌ':Added, #1: 1	رَهْنُ مُصْحَفٍ
u'رَهْنٌ مُصْحَفٌ':Added, #2: 2	رَهْنُ الْمُصْحَفِ
u'رَهَنَ مُضَارِبٌ':Subject, #3: 3	رَهْنِ الْمُصْحَفِ
u'رَهْنٌ مُضَارِبٌ':Added, #2: 2	رَهَنَ الْمُضَارِبُ
u'رَهْنٌ مُعَارٌ':Added, #1: 1	رَهْنِ الْمُضَارِبِ
u'رَهْنٌ مُعَلَّقٌ':Added, #1: 1	رَهْنِ الْمُعَارِ
u'رَهْنٌ مُعَلَّقٌ':Added, #1: 1	رَهْنَ الْمُعَلَّقِ
u'رَهْنٌ مَعْلُومٌ':Added, #1: 1	رَهْنِ الْمُعَلَّقِ
u'رَهْنٌ مُعَيَّنٌ':Added, #1: 1	رَهْنٍ مَعْلُومٍ
u'رَهْنٌ مُعَيَّنٌ':Added, #1: 1	رَهْنُ الْمُعَيَّنِ
u'رَهَنَ مَغْصُوب':Predicate, #2: 2	رَهْنِ الْمُعَيَّنِ
u'رَهْنٌ مُفَاوِضٌ':Added, #2: 2	رَهَنَ الْمَغْصُوبَ
u'رَهَنَ مُفْلِسٌ':Subject, #1: 1	رَهْنُ الْمُفَاوِضِ
u'رَهْنٌ مَقْبُوضٌ':Added, #1: 1	رَهَنَ الْمُفْلِسُ
u'رَهْنٌ مَكْفُولٌ':Added, #1: 1	رَهْنٍ مَقْبُوضٍ
u'رَهْنٌ مَكِيلٌ':Added, #1: 1	رَهْنِ الْمَكْفُولِ
u'رَهَنَ مِلْكٌ':Predicate, #1: 1	رَهْنِ الْمَكِيلِ
u'رَهْنٌ مِلْكٌ':Added, #13: 13	رَهَنَ مِلْكَ
u'رَهْنٌ مَنَافِعُ':Added, #1: 1	رَهْنُ مِلْكِ
u'رَهْنٌ مَنْفَعَةٌ':Added, #1: 1	رَهْنُ الْمَنَافِعِ
u'رَهْنٌ مُؤَجَّرٌ':Added, #1: 1	رَهْنُ مَنْفَعَةٍ
u'رَهْنٌ مَيْتٌ':Added, #1: 1	رَهْنِ الْمُؤَجَّرِ
u'رَهْنٌ مَيْتَةٌ':Added, #1: 1	رَهْنُ الْمَيْتَةِ
u'رَهَنَ نَخْلٌ':Predicate, #1: 1	رَهْنُ الْمَيْتَةِ
u'رَهْنٌ نَخْلٌ':Added, #4: 4	رَهَنَ النَّخْلَ
u'رَهَنَ نَخِيلٌ':Predicate, #2: 2	رَهْنِ النَّخْلِ
u'رَهْنٌ نَخِيلٌ':Added, #2: 2	رَهَنَ النَّخِيلَ
u'رَهَنَ نِصْفٌ':Predicate, #1: 1	رَهْنُ النَّخِيلِ
u'رَهَنَ نَصِيبٌ':Predicate, #8: 8	رَهَنَ نِصْفَ
u'رَهْنٌ نَصِيبٌ':Added, #1: 1	رَهَنَ نَصِيبَ
u'رَهْنٌ هَالِكٌ':Added, #1: 1	رَهْنِ نَصِيبِهِ
u'رَهَنَ واحد':Subject, #1: 1	رَهْنَ هَالِكِ
u'رَهَنَ وَاحِدٌ':Subject, #1: 1	رَهَنَ وَاحِدٌ
u'رَهَنَ وَارِثٌ':Subject, #1: 1	رَهَنَ وَاحِدٌ
u'رَهْنٌ وَرَثَةٌ':Added, #4: 4	رَهَنَ الْوَارِثُ
u'رَهَنَ وَصِيٌّ':Subject, #1: 1	رَهْنُ الْوَرَثَةِ
u'رَهْنٌ وَصِيٌّ':Added, #8: 8	رَهَنَ الْوَصِيُّ
u'رَهَنَ وَقْفٌ':Predicate, #1: 1	رَهْنِ الْوَصِيِّ
u'رَهْنٌ ولد':Added, #2: 2	رَهَنَ الْوَقْفَ
u'رَهْنٌ وَلَدٌ':Added, #1: 1	رَهْنُ الْوَلَدِ
u'رَهَنَ وَلِيٌّ':Subject, #1: 1	رَهْنُ الْوَلَدِ
u'رَهَنَ يَتِيمٌ':Subject, #1: 1	رَهَنَ وَلِيٌّ
u'رَوَاجٌ أَثْمانٌ':Added, #1: 1	رَهَنَ الْيَتِيمُ
u'رَوَاجٌ بَيْعٌ':Added, #4: 4	رَوَاجَ الْأَثْمَانِ
u'رَوَاجٌ تَامٌّ':Added, #1: 1	رَوَاجِ بَيْعِ
u'رَوَاجٌ ثَمَنٌ':Added, #1: 1	رَوَاجَ التَّامِّ
u'رَوَاجٌ سِلْعَةٌ':Added, #1: 1	رَوَاجِ الثَّمَنِ
u'رَوَاجٌ صنعة':Added, #1: 1	رَوَاجِ السِّلْعَةِ
u'رَوَاجٌ صَنْعَةٌ':Added, #1: 1	رَوَاجِ صَنْعَةِ
u'رَوَاجٌ فُلُوسٌ':Added, #1: 1	رَوَاجِ صَنْعَةِ
u'رَوَاجٌ كَامِلٌ':Added, #1: 1	رَوَاجَ الْفُلُوسِ
u'رَوَاجٌ مَتَاعٌ':Added, #1: 1	رَوَاجَ الْكَامِلَةِ
u'رَوَاجٌ نُقُودٌ':Added, #1: 1	رَوَاجِ الْمَتَاعِ
u'روحٌ اِبْنٌ':Added, #7: 7	رَوَاجَ النُّقُودِ
u'رَوْحٌ اِبْنٌ':Added, #1: 1	رَوْحَ ابْنِ
u'روحٌ بَعوضَةٌ':Added, #1: 1	رَوْحَ ابْنِ
u'رَوْحٌ بَعوضَةٌ':Added, #1: 1	رَوْحَ بَعُوضَةٍ
u'روحٌ جَنَّةٌ':Added, #1: 1	رَوْحَ بَعُوضَةٍ
u'رَوْحٌ جَنَّةٌ':Added, #1: 1	رَوْحِ الْجَنّةِ
u'رَوَّحَ واحد':Predicate, #1: 1	رَوْحِ الْجَنّةِ
u'رَوَّحَ وَاحِدٌ':Predicate, #1: 1	رَوَّحَ وَاحِدَةً
u'روع عَاقِلٌ':Added, #1: 1	رَوَّحَ وَاحِدَةً
u'رَوْعٌ عَاقِلٌ':Added, #1: 1	رَوْعِ الْعَاقِلِ
u'رَوَى إبَاحَةٌ':Predicate, #1: 1	رَوْعِ الْعَاقِلِ
u'رَوَى اِبْنٌ':Subject, #1: 1	رَوَى الْإِبَاحَةَ
u'رَوَى أَحادِيثُ':Predicate, #371: 371	رَوَى ابْنُ
u'رَوَى أَسَدٌ':Subject, #2: 2	رَوَى أَحَادِيثَ
u'رَوَى أَشْهَب':Subject, #2: 2	رَوَى أَسَدُ
u'رَوَى أَصْحَابٌ':Subject, #24: 24	رَوَى أَشْهَبُ
u'رَوَى أَصْحَابٌ':Subject, #1: 1	رَوَى الْأَصْحَابُ
u'رَوَى أعْمَش':Subject, #7: 7	رَوَى أَصْحَابُ
u'رَوَى أعْمَش':Subject, #1: 1	رَوَى الأَعْمَشُ
u'رَوَى إِفْرَادٌ':Predicate, #2: 2	رَوَى الْأَعْمَشُ
u'رَوَى أَكْثَرُ':Subject, #1: 1	رَوَى الْإِفْرَادَ
u'رَوَى إمَامٌ':Subject, #1: 1	رَوَى الْأَكْثَرُ
u'رَوَى أَمْرٌ':Predicate, #17: 17	رَوَى الْإِمَامُ
u'رَوَى أهْلٌ':Subject, #1: 1	رَوَى الأَمْرَ
u'رَوَى أَوَّلُ':Predicate, #1: 1	رَوَى أَهْلُ
u'رَوَى أَوَّلُ':Predicate, #1: 1	رَوَى أَوَّلَ
u'رَوَى أئِمَّةٌ':Subject, #5: 5	رَوَى الْأَوَّلَ
u'رَوَى بُخَارِيٌّ':Subject, #30: 30	رَوَى الْأَئِمَّةُ
u'رَوَى براءٌ':Subject, #92: 92	رَوَى الْبُخَارِيُّ
u'رَوَى بَراءٌ':Subject, #1: 1	رَوَى الْبَرَاءُ
u'رَوَى بَزَّارٌ':Subject, #1: 1	رَوَى الْبَرَاءُ
u'رَوَى بَزَّارٌ':Subject, #1: 1	رَوَى الْبَزّارُ
u'رَوَى بِشْرٌ':Subject, #5: 5	رَوَى الْبَزَّارُ
u'رَوَى بِشْرٌ':Subject, #16: 16	رَوَى بِشْرٌ
u'رَوَى بَشيرٌ':Subject, #1: 1	رَوَى بِشْرُ
u'رَوَى بَعْضٌ':Subject, #1: 1	رَوَى بَشِيرُ
u'رَوَى بَعْضٌ':Subject, #2: 2	رَوَى بَعْضٌ
u'رَوِيَ بِنْتٌ':Predicate, #4: 4	رَوَى بَعْضُ
u'رُؤْيَةٌ أَبْصارٌ':Added, #1: 1	أَرْوَى بِنْتَ
u'رُؤْيَةٌ أَجْنَبِيٌّ':Added, #1: 1	رُؤْيَةَ الْأَبْصَارِ
u'رُؤْيَةٌ أَجْنَبِيٌّ':Added, #1: 1	رُؤْيَةَ الْأَجْنَبِيِّ
u'رُؤْيَةٌ أحَدٌ':Added, #1: 1	رُؤْيَةُ الْأَجْنَبِيَّةِ
u'رُؤْيَةٌ أخْذٌ':Added, #1: 1	رُؤْيَةَ أَحَدِ
u'رُؤْيَةٌ أَرْبَعَةٌ':Added, #1: 1	رُؤْيَةُ أَخْذِ
u'رُؤْيَةٌ أرْضٌ':Added, #1: 1	رُؤْيَةُ أَرْبَعَةِ
u'رُؤْيَةٌ أَشْجَارٌ':Added, #1: 1	رُؤْيَةُ الْأَرْضِ
u'رُؤْيَةٌ أَشْخَاصٌ':Added, #1: 1	رُؤْيَةُ أَشْجَارِهِ
u'رُؤْيَةٌ اِعْتِبار':Added, #1: 1	رُؤْيَةَ الْأَشْخَاصِ
u'رُؤْيَةٌ اِعْتِبارِيّ':Added, #1: 1	رُؤْيَةٍ اعْتِبَارِيَّةٍ
u'رُؤْيَةٌ إقْرَارٌ':Added, #1: 1	رُؤْيَةٍ اعْتِبَارِيَّةٍ
u'رُؤْيَةٌ إِقْراضٌ':Added, #1: 1	رُؤْيَةُ الْإِقْرَارِ
u'رُؤْيَةٌ إمَامٌ':Added, #1: 1	رُؤْيَةُ الْإِقْرَاضِ
u'رُؤْيَةٌ أمثال':Added, #1: 1	رُؤْيَةِ الْإِمَامِ
u'رُؤْيَةٌ أَمْثَالٌ':Added, #1: 1	رُؤْيَةِ الْأَمْثَالِ
u'رُؤْيَةٌ إِنْسانٌ':Added, #1: 1	رُؤْيَةِ الْأَمْثَالِ
u'رُؤْيَةٌ أَنْعامٌ':Added, #2: 2	رُؤْيَةِ الْإِنْسَانِ
u'رُؤْيَةٌ أَنْعَامٌ':Added, #1: 1	رُؤْيَةِ الْأَنْعَامِ
u'رُؤْيَةٌ إِنْكارٌ':Added, #1: 1	رُؤْيَةِ الْأَنْعَامِ
u'رُؤْيَةٌ أهْلٌ':Added, #1: 1	رُؤْيَةِ الْإِنْكَارِ
u'رُؤْيَةٌ أَوَّلُ':Added, #1: 1	رُؤْيَةِ أَهْلِ
u'رُؤْيَةٌ بَاطن':Added, #2: 2	رُؤْيَةِ الْأَوَّلِ
u'رُؤْيَةٌ بَاطن':Added, #1: 1	رُؤْيَةَ الْبَاطِنِ
u'رُؤْيَةٌ باطِنٌ':Added, #1: 1	رُؤْيَةِ الْبَاطِنِ
u'رُؤْيَةٌ باطِنٌ':Added, #1: 1	رُؤْيَةَ الْبَاطِنِ
u'رُؤْيَةٌ بَاطن':Added, #1: 1	رُؤْيَةِ الْبَاطِنِ
u'رُؤْيَةٌ باطِنٌ':Added, #1: 1	رُؤْيَةَ بَاطِنِ
u'رُؤْيَةٌ بَاطن':Added, #1: 1	رُؤْيَةَ بَاطِنِ
u'رُؤْيَةٌ باطِنٌ':Added, #2: 2	رُؤْيَةُ بَاطِنِ
u'رُؤْيَةٌ باقَةٌ':Added, #2: 2	رُؤْيَةُ بَاطِنِ
u'رُؤْيَةٌ باقِي':Added, #1: 1	رُؤْيَةُ بَاقِيهِ
u'رُؤْيَةٌ بالُوعَةٌ':Added, #1: 1	رُؤْيَةُ بَاقِيهِ
u'رُؤْيَةٌ بَدْرٌ':Added, #1: 1	رُؤْيَةِ بَالُوعَتِهِ
u'رُؤْيَةٌ بَشَرَةٌ':Added, #1: 1	رُؤْيَةِ الْبَدْرَيْنِ
u'رُؤْيَةٌ بَصَرٌ':Added, #1: 1	رُؤْيَةُ بَشَرَتِهِ
u'رُؤْيَةٌ بَعْضٌ':Added, #1: 1	رُؤْيَةَ بَصَرٍ
u'رُؤْيَةٌ بَعْضٌ':Added, #1: 1	رُؤْيَةِ الْبَعْضِ
u'رُؤْيَةٌ بَعْضٌ':Added, #1: 1	رُؤْيَةُ بَعْضِهِ
u'رُؤْيَةٌ بَعْضٌ':Added, #2: 2	رُؤْيَةَ الْبَعْضِ
u'رُؤْيَةٌ بَعْضٌ':Added, #2: 2	رُؤْيَةُ بَعْضِ
u'رُؤْيَةٌ بَعْضٌ':Added, #2: 2	رُؤْيَةِ بَعْضِ
u'رُؤْيَةٌ بِلادٌ':Added, #3: 3	رُؤْيَةُ الْبَعْضِ
u'رُؤْيَةٌ بِلادٌ':Added, #10: 10	رُؤْيَةِ الْبِلَادِ
u'رُؤْيَةٌ بَلَدٌ':Added, #1: 1	رُؤْيَةَ الْبِلَادِ
u'رُؤْيَةٌ بَيْتٌ':Added, #1: 1	رُؤْيَةِ بَلَدٍ
u'رُؤْيَةٌ بَيْتٌ':Added, #1: 1	رُؤْيَةَ الْبَيْتِ
u'رُؤْيَةٌ جِدار':Added, #8: 8	رُؤْيَةِ الْبَيْتِ
u'رُؤْيَةٌ جُزْءٌ':Added, #2: 2	رُؤْيَةَ الْجِدَارِ
u'رُؤْيَةٌ جَسَدٌ':Added, #2: 2	رُؤْيَةُ جُزْءٍ
u'رُؤْيَةٌ جَمِيع':Added, #1: 1	رُؤْيَةِ الْجَسَدِ
u'رُؤْيَةٌ جَمِيع':Added, #1: 1	رُؤْيَةَ الْجَمِيعِ
u'رُؤْيَةٌ جَمِيع':Added, #1: 1	رُؤْيَةِ الْجَمِيعِ
u'رُؤْيَةٌ حلْوٌ':Added, #2: 2	رُؤْيَةُ الْجَمِيعِ
u'رُؤْيَةٌ حَمْلٌ':Added, #1: 1	رُؤْيَةِ الْحُلْوِ
u'رُؤْيَةٌ حِنْطَةٌ':Added, #1: 1	رُؤْيَةِ الْحَمْلِ
u'رُؤْيَةٌ دَاخِلٌ':Added, #1: 1	رُؤْيَةُ الْحِنْطَةِ
u'رُؤْيَةٌ دَاخِلٌ':Added, #1: 1	رُؤْيَةِ الدَّاخِلِ
u'رُؤْيَةٌ دَاخِلٌ':Added, #1: 1	رُؤْيَةِ دَاخِلِ
u'رُؤْيَةٌ دَائِرَةٌ':Added, #1: 1	رُؤْيَةِ دَاخِلِهِ
u'رُؤْيَةٌ دَمٌ':Added, #2: 2	رُؤْيَةِ الدَّائِرَةِ
u'رُؤْيَةٌ دَمٌ':Added, #20: 20	رُؤْيَةِ الدَّمِ
u'رُؤْيَةٌ دَمٌ':Added, #3: 3	رُؤْيَةَ الدَّمِ
u'رُؤْيَةٌ رَأْسٌ':Added, #5: 5	رُؤْيَةُ الدَّمِ
u'رُؤْيَةٌ رَاكِبٌ':Added, #1: 1	رُؤْيَةُ رَأْسِ
u'رُؤْيَةٌ رِجَالٌ':Added, #1: 1	رُؤْيَةِ الرَّاكِبِ
u'رُؤْيَةٌ رَجُلٌ':Added, #2: 2	رُؤْيَةُ الرِّجَالِ
u'رُؤْيَةٌ رَجُلٌ':Added, #1: 1	رُؤْيَةِ الرَّجُلِ
u'رُؤْيَةٌ زَيْدٌ':Added, #2: 2	رُؤْيَةَ رَجُلٍ
u'رُؤْيَةٌ زَيْدٌ':Added, #1: 1	رُؤْيَةَ زَيْدٍ
u'رُؤْيَةٌ سَابِقٌ':Added, #2: 2	رُؤْيَةِ زَيْدٍ
u'رُؤْيَةٌ سَحَابٌ':Added, #5: 5	رُؤْيَةٍ سَابِقَةٍ
u'رُؤْيَةٌ سُقُوفٌ':Added, #1: 1	رُؤْيَةِ السَّحَابِ
u'رُؤْيَةٌ سَيِّدٌ':Added, #1: 1	رُؤْيَةُ السُّقُوفِ
u'رُؤْيَةٌ شَاهِدٌ':Added, #1: 1	رُؤْيَةُ سَيِّدِ
u'رُؤْيَةٌ شَاهِدٌ':Added, #1: 1	رُؤْيَةُ الشَّاهِدِ
u'رُؤْيَةٌ شَاهِدٌ':Added, #1: 1	رُؤْيَةِ الشَّاهِدِ
u'رُؤْيَةٌ شَخْصٌ':Added, #1: 1	رُؤْيَةُ الشَّاهِدَيْنِ
u'رُؤْيَةٌ شَخْصٌ':Added, #1: 1	رُؤْيَةَ الشَّخْصِ
u'رُؤْيَةٌ شَخْصٌ':Added, #1: 1	رُؤْيَةُ الشَّخْصِ
u'رُؤْيَةٌ شَرْحٌ':Added, #1: 1	رُؤْيَةِ شَخْصِ
u'رُؤْيَةٌ شمس':Added, #1: 1	رُؤْيَةُ الشَّرْحِ
u'رُؤْيَةٌ شَمْسٌ':Added, #3: 3	رُؤْيَةِ الشَّمْسِ
u'رُؤْيَةٌ شَهْرٌ':Added, #3: 3	رُؤْيَةِ الشَّمْسِ
u'رُؤْيَةٌ شُهُودٌ':Added, #1: 1	رُؤْيَةِ شَهْرٍ
u'رُؤْيَةٌ شَيْءٌ':Added, #1: 1	رُؤْيَةِ الشُّهُودِ
u'رُؤْيَةٌ صَبِيٌّ':Added, #3: 3	رُؤْيَةُ شَيْءٍ
u'رُؤْيَةٌ صَحْنٌ':Added, #1: 1	رُؤْيَة الصَّبِيِّ
u'رُؤْيَةٌ صَدَفٌ':Added, #3: 3	رُؤْيَةُ صَحْنِ
u'رُؤْيَةٌ صَرْم':Added, #1: 1	رُؤْيَةُ صَدَفِ
u'رُؤْيَةٌ صَيْدٌ':Added, #1: 1	رُؤْيَةُ الصَّرْمِ
u'رُؤْيَةٌ ضرع':Added, #4: 4	رُؤْيَةِ الصَّيْدِ
u'رُؤْيَةٌ ضَرْعٌ':Added, #4: 4	رُؤْيَةِ الضَّرْعِ
u'رُؤْيَةٌ طَاعَةٌ':Added, #4: 4	رُؤْيَةِ الضَّرْعِ
u'رُؤْيَةٌ طَرِيقٌ':Added, #1: 1	رُؤْيَةِ الطَّاعَةِ
u'رُؤْيَةٌ طعام':Added, #1: 1	رُؤْيَةُ طَرِيقِ
u'رُؤْيَةٌ طَعَامٌ':Added, #1: 1	رُؤْيَةَ طَعَامِهِ
u'رُؤْيَةٌ ظاهِرٌ':Added, #1: 1	رُؤْيَةَ طَعَامِهِ
u'رُؤْيَةٌ ظاهِرٌ':Added, #1: 1	رُؤْيَةَ ظَاهِرِ
u'رُؤْيَةٌ ظاهِرٌ':Added, #1: 1	رُؤْيَةُ ظَاهِرِ
u'رُؤْيَةٌ ظاهِرٌ':Added, #1: 1	رُؤْيَةُ ظَاهِرِهِ
u'رُؤْيَةٌ ظِهارَةٌ':Added, #2: 2	رُؤْيَةِ ظَاهِرِهِ
u'رُؤْيَةٌ عِبَادَةٌ':Added, #1: 1	رُؤْيَةُ الظِّهَارَةِ
u'رُؤْيَةٌ عِبَادَةٌ':Added, #1: 1	رُؤْيَةُ الْعِبَادَةِ
u'رُؤْيَةٌ عَبْدٌ':Added, #1: 1	رُؤْيَةِ عِبَادَةِ
u'رُؤْيَةٌ عَدْلٌ':Added, #3: 3	رُؤْيَةِ عَبْدِهِ
u'رُؤْيَةٌ عَدْلٌ':Added, #1: 1	رُؤْيَةُ الْعَدْلِ
u'رُؤْيَةٌ عَدْلٌ':Added, #1: 1	رُؤْيَةِ الْعَدْلِ
u'رُؤْيَةٌ عَدُوٌّ':Added, #2: 2	رُؤْيَةِ الْعَدْلَيْنِ
u'رُؤْيَةٌ عُرُوقٌ':Added, #1: 1	رُؤْيَةَ عَدُوٍّ
u'رُؤْيَةٌ عُقَلاَءُ':Added, #1: 1	رُؤْيَةُ عُرُوقِ
u'رُؤْيَةٌ عُقُوبَةٌ':Added, #1: 1	رُؤْيَةِ الْعُقَلَاءِ
u'رُؤْيَةٌ عَلاَمَةٌ':Added, #1: 1	رُؤْيَةِ الْعُقُوبَةِ
u'رُؤْيَةٌ علم':Added, #1: 1	رُؤْيَةُ عَلَامَةِ
u'رُؤْيَةٌ عِلْمٌ':Added, #1: 1	رُؤْيَةُ عِلْمٍ
u'رُؤْيَةٌ عُلْوٌ':Added, #1: 1	رُؤْيَةُ عِلْمٍ
u'رُؤْيَةٌ عِنَبٌ':Added, #1: 1	رُؤْيَةَ الْعُلْوِ
u'رُؤْيَةٌ عَوْرَةٌ':Added, #1: 1	رُؤْيَةِ عِنَبِ
u'رُؤْيَةٌ عَوْرَةٌ':Added, #1: 1	رُؤْيَةَ الْعَوْرَةِ
u'رُؤْيَةٌ عَوْرَةٌ':Added, #1: 1	رُؤْيَةِ الْعَوْرَةِ
u'رُؤْيَةٌ عَوْرَةٌ':Added, #2: 2	رُؤْيَةُ الْعَوْرَةِ
u'رُؤْيَةٌ عَيْبٌ':Added, #3: 3	رُؤْيَةُ عَوْرَتِهِ
u'رُؤْيَةٌ عَيْبٌ':Added, #1: 1	رُؤْيَةَ الْعَيْبِ
u'رُؤْيَةٌ عَيْنٌ':Added, #4: 4	رُؤْيَةِ الْعَيْبِ
u'رُؤْيَةٌ عَيْنٌ':Added, #1: 1	رُؤْيَةَ عَيْنٍ
u'رُؤْيَةٌ عَيْن':Added, #1: 1	رُؤْيَةُ عَيْنٍ
u'رُؤْيَةٌ عَيْن':Added, #1: 1	رُؤْيَةَ عَيْنٍ
u'رُؤْيَةٌ عين':Added, #1: 1	رُؤْيَةُ عَيْنٍ
u'رُؤْيَةٌ عَيْنٌ':Added, #3: 3	رُؤْيَةُ الْعَيْنِ
u'رُؤْيَةٌ عَيْن':Added, #3: 3	رُؤْيَةُ الْعَيْنِ
u'رُؤْيَةٌ غير':Added, #3: 3	رُؤْيَةُ الْعَيْنِ
u'رُؤْيَةٌ غير':Added, #1: 1	رُؤْيَةُ غَيْرِهِ
u'رُؤْيَةٌ غَيْرٌ':Added, #1: 1	رُؤْيَةِ غَيْرِهِ
u'رُؤْيَةٌ غَيْرٌ':Added, #1: 1	رُؤْيَةُ غَيْرِهِ
u'رُؤْيَةٌ فَرْجٌ':Added, #1: 1	رُؤْيَةِ غَيْرِهِ
u'رُؤْيَةٌ فَرْجٌ':Added, #1: 1	رُؤْيَةَ الْفَرْجِ
u'رُؤْيَةٌ قتل':Added, #1: 1	رُؤْيَةِ الْفَرْجِ
u'رُؤْيَةٌ قَتْلٌ':Added, #1: 1	رُؤْيَةَ الْقَتْلِ
u'رُؤْيَةٌ قِشْرٌ':Added, #1: 1	رُؤْيَةَ الْقَتْلِ
u'رُؤْيَةٌ قِشْرٌ':Added, #1: 1	رُؤْيَةِ الْقِشْرِ
u'رُؤْيَةٌ قمر':Added, #2: 2	رُؤْيَةُ الْقِشْرِ
u'رُؤْيَةٌ قَمَرٌ':Added, #1: 1	رُؤْيَةِ الْقَمَرِ
u'رُؤْيَةٌ قَنَادِيلُ':Added, #1: 1	رُؤْيَةِ الْقَمَرِ
u'رُؤْيَةٌ قوائم':Added, #1: 1	رُؤْيَةَ الْقَنَادِيلِ
u'رُؤْيَةٌ قَوَائِمُ':Added, #1: 1	رُؤْيَةُ الْقَوَائِمِ
u'رُؤْيَةٌ قوائم':Added, #1: 1	رُؤْيَةُ الْقَوَائِمِ
u'رُؤْيَةٌ قَوَائِمُ':Added, #3: 3	رُؤْيَةَ الْقَوَائِمِ
u'رُؤْيَةٌ كَثْرَةٌ':Added, #3: 3	رُؤْيَةَ الْقَوَائِمِ
u'رُؤْيَةٌ كعبة':Added, #1: 1	رُؤْيَةُ كَثْرَةِ
u'رُؤْيَةٌ كَعْبَةٌ':Added, #5: 5	رُؤْيَةِ الْكَعْبَةِ
u'رُؤْيَةٌ كَفٌّ':Added, #5: 5	رُؤْيَةِ الْكَعْبَةِ
u'رُؤْيَةٌ لُبٌّ':Added, #1: 1	رُؤْيَةُ الْكَفَّيْنِ
u'رُؤْيَةٌ لِسَانٌ':Added, #2: 2	رُؤْيَةِ اللُّبِّ
u'رُؤْيَةٌ لِسَانٌ':Added, #1: 1	رُؤْيَةَ اللِّسَانِ
u'رُؤْيَةٌ مَاءٌ':Added, #2: 2	رُؤْيَةُ اللِّسَانِ
u'رُؤْيَةٌ مَاءٌ':Added, #3: 3	رُؤْيَةَ الْمَاءِ
u'رُؤْيَةٌ مَاءٌ':Added, #8: 8	رُؤْيَةُ الْمَاءِ
u'رُؤْيَةٌ مَبِيعٌ':Added, #8: 8	رُؤْيَةِ الْمَاءِ
u'رُؤْيَةٌ مَبِيعٌ':Added, #3: 3	رُؤْيَةِ الْمَبِيعِ
u'رُؤْيَةٌ مَتَاعٌ':Added, #5: 5	رُؤْيَةُ الْمَبِيعِ
u'رُؤْيَةٌ مُتَعَلِّمٌ':Added, #1: 1	رُؤْيَةَ مَتَاعِهِ
u'رُؤْيَةٌ مُتَقَدِّمٌ':Added, #1: 1	رُؤْيَةُ الْمُتَعَلِّمِ
u'رُؤْيَةٌ مِثَالٌ':Added, #4: 4	رُؤْيَةٍ مُتَقَدِّمَةٍ
u'رُؤْيَةٌ مَحَلٌّ':Added, #1: 1	رُؤْيَةَ الْمِثَالِ
u'رُؤْيَةٌ مَحَلٌّ':Added, #1: 1	رُؤْيَةَ مَحَلِّ
u'رُؤْيَةٌ مَحَلٌّ':Added, #1: 1	رُؤْيَةُ مَحَلِّهِ
u'رُؤْيَةٌ مَحْمُولٌ':Added, #2: 2	رُؤْيَةِ الْمَحَلِّ
u'رُؤْيَةٌ مَخْلُوقٌ':Added, #1: 1	رُؤْيَةِ الْمَحْمُولِ
u'رُؤْيَةٌ مُرْسِلٌ':Added, #1: 1	رُؤْيَةِ الْمَخْلُوقِ
u'رُؤْيَةٌ مُسْتَأْجِرٌ':Added, #1: 1	رُؤْيَةَ الْمُرْسِلِ
u'رُؤْيَةٌ مُسْتَأْجِرٌ':Added, #1: 1	رُؤْيَةُ الْمُسْتَأْجِرِ
u'رُؤْيَةٌ مُسْتَتِرٌ':Added, #1: 1	رُؤْيَةِ الْمُسْتَأْجِرِ
u'رُؤْيَةٌ مُسْتَتِرٌ':Added, #1: 1	رُؤْيَةُ الْمُسْتَتِرِ
u'رُؤْيَةٌ مُسَلَّمٌ':Added, #1: 1	رُؤْيَةِ الْمُسْتَتِرِ
u'رُؤْيَةٌ مَشَاعِرُ':Added, #1: 1	رُؤْيَةِ الْمُسَلَّمِ
u'رُؤْيَةٌ مَشْهُودٌ':Added, #2: 2	رُؤْيَةَ الْمَشَاعِرِ
u'رُؤْيَةٌ مَصْلَحَةٌ':Added, #2: 2	رُؤْيَةِ الْمَشْهُودِ
u'رُؤْيَةٌ مَطْبَخٌ':Added, #1: 1	رُؤْيَةِ الْمَصْلَحَةِ
u'رُؤْيَةٌ مَعْقُودٌ':Added, #2: 2	رُؤْيَةُ الْمَطْبَخِ
u'رُؤْيَةٌ مَعْقُودٌ':Added, #1: 1	رُؤْيَةُ الْمَعْقُودِ
u'رُؤْيَةٌ مَقْصُودٌ':Added, #1: 1	رُؤْيَةِ الْمَعْقُودِ
u'رُؤْيَةٌ مَنْبَعٌ':Added, #1: 1	رُؤْيَةِ الْمَقْصُودِ
u'رُؤْيَةٌ مَنْزِلٌ':Added, #2: 2	رُؤْيَةِ الْمَنْبَعِ
u'رُؤْيَةٌ مَوْجُودٌ':Added, #1: 1	رُؤْيَةَ الْمَنْزِلِ
u'رُؤْيَةٌ مُوَكِّلٌ':Added, #1: 1	رُؤْيَةِ الْمَوْجُودِ
u'رُؤْيَةٌ مُؤَلِّفٌ':Added, #1: 1	رُؤْيَةَ الْمُوَكِّلِ
u'رُؤْيَةٌ مُؤْمِنٌ':Added, #1: 1	رُؤْيَةِ الْمُؤَلِّفِ
u'رُؤْيَةٌ نَاسٌ':Added, #1: 1	رُؤْيَةِ الْمُؤْمِنِ
u'رُؤْيَةٌ نَاسٌ':Added, #1: 1	رُؤْيَةَ النَّاسِ
u'رُؤْيَةٌ نَبِيٌّ':Added, #2: 2	رُؤْيَةِ النَّاسِ
u'رُؤْيَةٌ نِساءٌ':Added, #2: 2	رُؤْيَةِ النَّبِيِّ
u'رُؤْيَةٌ نَفْسٌ':Added, #1: 1	رُؤْيَةُ النِّسَاءِ
u'رُؤْيَةٌ نَفْسٌ':Added, #1: 1	رُؤْيَةُ النَّفْسِ
u'رُؤْيَةٌ نَفْسٌ':Added, #1: 1	رُؤْيَةِ النَّفْسِ
u'رُؤْيَةٌ نَفْسٌ':Added, #1: 1	رُؤْيَةُ نَفْسِهِ
u'رُؤْيَةٌ نَوْعٌ':Added, #5: 5	رُؤْيَةِ نَفْسِهِ
u'رُؤْيَةٌ هِلاَلٌ':Added, #1: 1	رُؤْيَةَ نَوْعٍ
u'رُؤْيَةٌ هِلاَلٌ':Added, #1: 1	رُؤْيَةِ الْهِلالِ
u'رُؤْيَةٌ هِلاَلٌ':Added, #1: 1	رُؤْيَةُ هِلَالِ
u'رُؤْيَةٌ هِلاَلٌ':Added, #1: 1	رُؤْيَةِ هِلَالٍ
u'رُؤْيَةٌ هِلاَلٌ':Added, #36: 36	رُؤْيَةِ الْهِلَالِ
u'رُؤْيَةٌ هِلاَلٌ':Added, #3: 3	رُؤْيَةِ هِلَالِهِ
u'رُؤْيَةٌ هِلاَلٌ':Added, #4: 4	رُؤْيَةِ هِلالِ
u'رُؤْيَةٌ هِلاَلٌ':Added, #5: 5	رُؤْيَةِ هِلاَلِ
u'رُؤْيَةٌ هِلاَلٌ':Added, #6: 6	رُؤْيَةُ الْهِلَالِ
u'رُؤْيَةٌ هِلاَلٌ':Added, #6: 6	رُؤْيَةِ الْهِلاَلِ
u'رُؤْيَةٌ واحد':Added, #6: 6	رُؤْيَةِ هِلَالِ
u'رُؤْيَةٌ واحد':Added, #1: 1	رُؤْيَةُ الْوَاحِدِ
u'رُؤْيَةٌ وَاحِدٌ':Added, #1: 1	رُؤْيَةِ الْوَاحِدِ
u'رُؤْيَةٌ وَاحِدٌ':Added, #1: 1	رُؤْيَةُ الْوَاحِدِ
u'رُؤْيَةٌ وَجْهٌ':Added, #1: 1	رُؤْيَةِ الْوَاحِدِ
u'رُؤْيَةٌ وَجْهٌ':Added, #1: 1	رُؤْيَةُ الْوَجْهِ
u'رُؤْيَةٌ وَجْهٌ':Added, #1: 1	رُؤْيَةِ الْوَجْهَيْنِ
u'رُؤْيَةٌ وَجْهٌ':Added, #1: 1	رُؤْيَةِ وَجْهِ
u'رُؤْيَةٌ وَجْهٌ':Added, #1: 1	رُؤْيَةِ وَجْهِهِ
u'رُؤْيَةٌ وَجْهٌ':Added, #3: 3	رُؤْيَةَ وَجْهِ
u'رُؤْيَةٌ وِطَاءٌ':Added, #3: 3	رُؤْيَةُ وَجْهِ
u'رُؤْيَةٌ وَكِيلٌ':Added, #1: 1	رُؤْيَةُ وِطَاءٍ
u'رُؤْيَةٌ وِلاَدَةٌ':Added, #4: 4	رُؤْيَةَ الْوَكِيلِ
u'رُؤْيَةٌ يَأْسٌ':Added, #1: 1	رُؤْيَةُ الْوِلَادَةِ
u'رُؤْيَةٌ يَدٌ':Added, #1: 1	رُؤْيَةِ الْيَأْسِ
u'رَوَى تَابِعِيٌّ':Subject, #1: 1	رُؤْيَةِ يَدٍ
u'رَوَى تَشَهُّدٌ':Predicate, #1: 1	رَوَى تَابِعِيٌّ
u'رَوَى تَعْزِير':Predicate, #1: 1	رَوَى التَّشَهُّدَ
u'رَوَى تِلْميذٌ':Subject, #1: 1	رَوَى التَّعْزِيرَ
u'رَوَى تَمَتُّعٌ':Predicate, #1: 1	رَوَى تِلْمِيذُهُ
u'رَوَى ثَابِتٌ':Subject, #3: 3	رَوَى التَّمَتُّعَ
u'رَوَى ثَابِتٌ':Subject, #2: 2	رَوَى ثَابِتٌ
u'رَوَى ثِقَةٌ':Subject, #2: 2	رَوَى ثَابِتُ
u'رَوَى ثِقَة':Subject, #1: 1	رَوَى الثِّقَةُ
u'رَوَى ثِقَةٌ':Subject, #1: 1	رَوَى ثِقَاتُ
u'رَوَى ثَوْرِيٌّ':Subject, #2: 2	رَوَى ثِقَةٌ
u'رَوَى جَابِرٌ':Subject, #1: 1	رَوَى الثَّوْرِيُّ
u'رَوَى جَابِرٌ':Subject, #11: 11	رَوَى جَابِرُ
u'رَوَى جَرِيرٌ':Subject, #25: 25	رَوَى جَابِرٌ
u'رَوَى جَلّاب':Subject, #1: 1	رَوَى جَرِيرُ
u'رَوَى جَمَاعَةٌ':Subject, #1: 1	رَوَى الْجَلَّابُ
u'رَوَى جَمَاعَةٌ':Subject, #5: 5	رَوَى جَمَاعَةٌ
u'رَوَى جمع':Predicate, #6: 6	رَوَى الْجَمَاعَةُ
u'رَوَى جَمْعٌ':Predicate, #2: 2	رَوَى الْجَمْعَ
u'رَوَى جمع':Subject, #2: 2	رَوَى الْجَمْعَ
u'رَوَى جَمْعٌ':Subject, #1: 1	رَوَى الْجَمْعُ
u'رَوَى جُنْدُبٌ':Subject, #1: 1	رَوَى الْجَمْعُ
u'رَوَى حارِثٌ':Subject, #1: 1	رَوَى جُنْدُبُ
u'رَوَى حارِثٌ':Subject, #1: 1	رَوَى حَارِثُ
u'رَوَى حافِظٌ':Subject, #2: 2	رَوَى الْحَارِثُ
u'رَوَى حاكِمٌ':Subject, #3: 3	رَوَى الْحَافِظُ
u'رَوَى حُجَّةٌ':Subject, #22: 22	رَوَى الْحَاكِمُ
u'رَوَى حَديثٌ':Predicate, #1: 1	رَوَى حُجَّةٌ
u'رَوَى حَديثٌ':Predicate, #13: 13	رَوَى الْحَدِيثَ
u'رَوَى حَرْبٌ':Subject, #21: 21	رَوَى حَدِيثَ
u'رَوَى حَسَنٌ':Subject, #2: 2	رَوَى حَرْبٌ
u'رَوَى حَمَّادٌ':Subject, #109: 109	رَوَى الْحَسَنُ
u'رَوَى حَمْز':Subject, #4: 4	رَوَى حَمَّادُ
u'رَوَى حَنْبَلٌ':Subject, #1: 1	رَوَى حَمْزَةُ
u'رَوَى خَارِجٌ':Subject, #2: 2	رَوَى حَنْبَلٌ
u'رَوَى خَالِدٌ':Subject, #1: 1	رَوَى خَارِجَةُ
u'رَوَى خَالِدٌ':Subject, #2: 2	رَوَى خَالِدٌ
u'رَوَى خَبَرٌ':Predicate, #5: 5	رَوَى خَالِدُ
u'رَوَى خَبَر':Predicate, #1: 1	رَوَى خَبَرَ
u'رَوَى خَبَرٌ':Predicate, #1: 1	رَوَى خَبَرَ
u'رَوَى خَبَر':Predicate, #6: 6	رَوَى الْخَبَرَ
u'رَوَى خَطِيبٌ':Subject, #6: 6	رَوَى الْخَبَرَ
u'رَوَى خِلاَفٌ':Predicate, #5: 5	رَوَى الْخَطِيبُ
u'رَوَى خَلَفٌ':Subject, #1: 1	رَوَى خِلَافَ
u'رَوَى خَلَفٌ':Subject, #1: 1	رَوَى خَلَفٌ
u'رَوَى رَبِيعٌ':Subject, #4: 4	رَوَى خَلَفُ
u'رَوَى رَفْعٌ':Predicate, #3: 3	رَوَى الرَّبِيعُ
u'رَوَى رِيبَةٌ':Predicate, #4: 4	رَوَى الرَّفْعَ
u'رَوَى زِيادَةٌ':Predicate, #1: 1	رَوَى الرِّيبَةَ
u'رَوَى زَيْدٌ':Subject, #1: 1	رَوَى الزِّيَادَةَ
u'رَوَى زَيْدٌ':Subject, #1: 1	رَوَى زَيْدٌ
u'رَوَى سَالِمٌ':Subject, #3: 3	رَوَى زَيْدُ
u'رَوَى سَبْعٌ':Predicate, #2: 2	رَوَى سَالِمٌ
u'رَوَى سَعْدٌ':Subject, #1: 1	رَوَى سَبْعَ
u'رَوَى سَعْدٌ':Subject, #1: 1	رَوَى سَعْدٌ
u'رَوَى سَعِيدٌ':Subject, #1: 1	رَوَى سَعْدُ
u'رَوَى سلام':Subject, #22: 22	رَوَى سَعِيدُ
u'رَوَى سَلاَمٌ':Subject, #1: 1	رَوَى سَلامُ
u'رَوَى سمرة':Subject, #1: 1	رَوَى سَلامُ
u'رَوَى سَهْلٌ':Subject, #1: 1	رَوَى سَمُرَةُ
u'رَوَى سُهَيْلٌ':Subject, #1: 1	رَوَى سَهْلُ
u'رَوَّى سَوَاحِلُ':Predicate, #1: 1	رَوَى سُهَيْلُ
u'رَوَى سيرَةٌ':Predicate, #1: 1	رَوَّى السَّوَاحِلَ
u'رَوَى شافِعِيّ':Subject, #1: 1	رَوَى السِّيرَةَ
u'رَوَى شَرِيكٌ':Subject, #21: 21	رَوَى الشَّافِعِيُّ
u'رَوَى شُعْبَةٌ':Subject, #2: 2	رَوَى شَرِيكُ
u'رَوَى شَعْبِيٌّ':Subject, #4: 4	رَوَى شُعْبَةُ
u'رَوَى شَكٌّ':Predicate, #5: 5	رَوَى الشَّعْبِيُّ
u'رَوَى شمس':Subject, #1: 1	رَوَى الشَّكَّ
u'رَوَى شَمْسٌ':Subject, #1: 1	رَوَى شَمْسُ
u'رَوَى شَهَادَةٌ':Predicate, #1: 1	رَوَى شَمْسُ
u'رَوَى شَيْخٌ':Subject, #1: 1	رَوَى شَهَادَةَ
u'رَوَى صَاحِبٌ':Subject, #5: 5	رَوَى الشَّيْخُ
u'رَوَى صَاعٌ':Predicate, #3: 3	رَوَى صَاحِبُ
u'رَوَى صَالِحٌ':Subject, #1: 1	رَوَى الصَّاعَ
u'رَوَى صَالِح':Subject, #1: 1	رَوَى صَالِحٌ
u'رَوَى صَالِحٌ':Subject, #1: 1	رَوَى صَالِحٌ
u'رَوَى صَالِح':Subject, #3: 3	رَوَى صَالِحُ
u'رَوَى صَحَابَةٌ':Subject, #3: 3	رَوَى صَالِحُ
u'رَوَى صَحَابِيٌّ':Subject, #1: 1	رَوَى الصَّحَابَةُ
u'رَوَى صَخْرٌ':Subject, #1: 1	رَوَى الصَّحَابِيُّ
u'رَوَى صِدِّيقٌ':Subject, #1: 1	رَوَى صَخْرُ
u'رَوَى صِفَةٌ':Predicate, #1: 1	رَوَى الصِّدِّيقُ
u'رَوَى ضَمَانٌ':Predicate, #1: 1	رَوَى صِفَةَ
u'رَوَى طَبَرِيّ':Subject, #1: 1	رَوَى الضَّمَانَ
u'رَوَى طَلْحٌ':Subject, #4: 4	رَوَى الطَّبَرِيُّ
u'رَوَى طلحة':Subject, #4: 4	رَوَى طَلْحَةُ
u'رَوَى طَلْقٌ':Subject, #4: 4	رَوَى طَلْحَةُ
u'رَوَى عَارِي':Predicate, #1: 1	رَوَى طَلْقُ
u'رَوَى عَارِيَةٌ':Predicate, #1: 1	رَوَى الْعَارِيَةَ
u'رَوَى عَاصِمٌ':Subject, #1: 1	رَوَى الْعَارِيَةَ
u'رَوَى عَامٌ':Predicate, #1: 1	رَوَى عَاصِمٌ
u'رَوَى عَامِرٌ':Subject, #1: 1	رَوَى عَامَ
u'رَوَى عَبْدٌ':Subject, #1: 1	رَوَى عَامِرٌ
u'رَوَى عتبة':Subject, #52: 52	رَوَى عَبْدُ
u'رَوَى عَدْلٌ':Subject, #2: 2	رَوَى عُتْبَةُ
u'رَوَى عَدْلٌ':Subject, #1: 1	رَوَى عَدْلٌ
u'رَوَى عُرْوَةٌ':Subject, #2: 2	رَوَى الْعَدْلُ
u'رَوَى عَطَاءٌ':Subject, #6: 6	رَوَى عُرْوَةُ
u'رَوَى عَطَاءٌ':Subject, #2: 2	رَوَى عَطَاءُ
u'رَوَى عَطِيَّةٌ':Subject, #4: 4	رَوَى عَطَاءٌ
u'رَوَى عقبة':Subject, #1: 1	رَوَى عَطِيَّةُ
u'رَوَى عُقْبَةٌ':Subject, #3: 3	رَوَى عُقْبَةُ
u'رَوَى عَلاءٌ':Subject, #3: 3	رَوَى عُقْبَةُ
u'رَوَى عَلْقَم':Subject, #2: 2	رَوَى الْعَلَاءُ
u'رَوَى عَلْقَمَة':Subject, #1: 1	رَوَى عَلْقَمَةُ
u'رَوَى علماء':Subject, #1: 1	رَوَى عَلْقَمَةُ
u'رَوَى عُلَمَاءُ':Subject, #2: 2	رَوَى الْعُلَمَاءُ
u'رَوَى عَلِيٌّ':Subject, #2: 2	رَوَى الْعُلَمَاءُ
u'رَوَى عَلِيٌّ':Subject, #11: 11	رَوَى عَلِيٌّ
u'رَوَى عُمَرٌ':Subject, #2: 2	رَوَى عَلِيُّ
u'رَوَى غير':Predicate, #4: 4	رَوَى عُمَرُ
u'رَوَى غَيْرٌ':Predicate, #1: 1	رَوَى غَيْرَ
u'رَوَى غير':Subject, #1: 1	رَوَى غَيْرَ
u'رَوَى غَيْرٌ':Subject, #2: 2	رَوَى غَيْرُهُ
u'رَوَى غير':Subject, #2: 2	رَوَى غَيْرُهُ
u'رَوَى غَيْرٌ':Subject, #3: 3	رَوَى غَيْرُ
u'رَوَى فقهاء':Subject, #3: 3	رَوَى غَيْرُ
u'رَوَى فَقِيهٌ':Subject, #1: 1	رَوَى الْفُقَهَاءُ
u'رَوَى فلان':Subject, #1: 1	رَوَى الْفَقِيهُ
u'رَوَى فلان':Subject, #19: 19	رَوَى الطَّبَرَانِيُّ
u'رَوَى فلان':Subject, #1: 1	رَوَى الزّبَيْرُ
u'رَوَى فلان':Subject, #1: 1	رَوَى الزُّبَيْرُ
u'رَوَى فلان':Subject, #1: 1	رَوَى الْمُنْذِرِيُّ
u'رَوَى فلان':Subject, #1: 1	رَوَى جَعْفَرٌ
u'رَوَى فلان':Subject, #1: 1	رَوَى حَمْزَةُ
u'رَوَى فلان':Subject, #1: 1	رَوَى عُثْمَانُ
u'رَوَى فلان':Subject, #21: 21	رَوَى الشَّافِعِيُّ
u'رَوَى فلان':Subject, #2: 2	رَوَى زِيَادٌ
u'رَوَى فلان':Subject, #2: 2	رَوَى مُعَاوِيَةُ
u'رَوَى فلان':Subject, #2: 2	رَوَى هَارُونُ
u'رَوَى فلان':Subject, #3: 3	رَوَى زِيَادُ
u'رَوَى فلان':Subject, #44: 44	رَوَى الْبَيْهَقِيُّ
u'رَوَى فلان':Subject, #4: 4	رَوَى الطَّبَرِيُّ
u'رَوَى فلان':Subject, #4: 4	رَوَى حُذَيْفَةُ
u'رَوَى فلان':Subject, #4: 4	رَوَى سُفْيَانُ
u'رَوَى فلان':Subject, #4: 4	رَوَى قَتَادَةُ
u'رَوَى فلان':Subject, #5: 5	رَوَى مَكْحُولٌ
u'رَوَى قَاسِمٌ':Subject, #73: 73	رَوَى التِّرْمِذِيُّ
u'رَوَى قَتاد':Subject, #2: 2	رَوَى الْقَاسِمُ
u'رَوَى قُرَّةٌ':Subject, #4: 4	رَوَى قَتَادَةُ
u'رَوَى قِصَّةٌ':Predicate, #1: 1	رَوَى قُرَّةُ
u'رَوَى قِصَّةٌ':Predicate, #1: 1	رَوَى الْقِصَّةَ
u'رَوَى قِصَّةٌ':Predicate, #1: 1	رَوَى قِصّةَ
u'رَوَى قَلِيلٌ':Predicate, #5: 5	رَوَى قِصَّةَ
u'رَوَى قُنُوتٌ':Predicate, #1: 1	رَوَى الْقَلِيلَ
u'رَوَى كِتَابٌ':Predicate, #1: 1	رَوَى الْقُنُوتَ
u'رَوَى كَثِيرٌ':Subject, #1: 1	رَوَى كِتَابَ
u'رَوَى لَفْظٌ':Predicate, #1: 1	رَوَى كَثِيرُ
u'رَوَى لَيْثٌ':Subject, #1: 1	رَوَى اللَّفْظَ
u'رَوَى لَيْثٌ':Subject, #1: 1	رَوَى اللَّيْثُ
u'رَوَى مَالِكٌ':Subject, #1: 1	رَوَى لَيْثُ
u'رَوَى مَالِكٌ':Subject, #36: 36	رَوَى مَالِكٌ
u'رَوَى مُبَارَكٌ':Subject, #4: 4	رَوَى مَالِكُ
u'رَوَى مُبَشِّرٌ':Subject, #1: 1	رَوَى مُبَارَكٌ
u'رَوَى مثل':Predicate, #1: 1	رَوَى مُبَشِّرُ
u'رَوَى مِثْلٌ':Predicate, #1: 1	رَوَى مِثْلَ
u'رَوَى مُجَاهِدٌ':Subject, #1: 1	رَوَى مِثْلَ
u'رَوَى مُجْمَلٌ':Predicate, #5: 5	رَوَى مُجَاهِدٌ
u'رَوَى مُحَدِّثٌ':Subject, #1: 1	رَوَى الْمُجْمَلَ
u'رَوَى مُحَمَّدٌ':Subject, #1: 1	رَوَى الْمُحَدِّثُ
u'رَوَى مُحَمَّدٌ':Subject, #25: 25	رَوَى مُحَمَّدُ
u'رَوَى مَحْمُودٌ':Subject, #60: 60	رَوَى مُحَمَّدٌ
u'رَوَى مَحْمُولٌ':Subject, #1: 1	رَوَى مَحْمُودُ
u'رَوَى مرٌّ':Predicate, #1: 1	رَوَى مَحْمُولَةٌ
u'رَوَى مَسْرُوقٌ':Subject, #1: 1	رَوَى مَرَّةً
u'رَوَى مُسْلِمٌ':Subject, #1: 1	رَوَى مَسْرُوقٌ
u'رَوَى مُسْلِمٌ':Subject, #1: 1	رَوَى مُسْلِمُ
u'رَوَى مَشَايِخُ':Subject, #56: 56	رَوَى مُسْلِمٌ
u'رَوَى مُعاوِيَة':Subject, #2: 2	رَوَى الْمَشَايِخُ
u'رَوَى مَعْبَدٌ':Subject, #2: 2	رَوَى مُعَاوِيَةُ
u'رَوَى مُعْتَمِرٌ':Subject, #2: 2	رَوَى مَعْبَدُ
u'رَوَى مُعْتَمِرٌ':Subject, #1: 1	رَوَى الْمُعْتَمِرُ
u'رَوَى مَكْحُول':Subject, #1: 1	رَوَى مُعْتَمِرُ
u'رَوَى مَنَاكِيرُ':Predicate, #5: 5	رَوَى مَكْحُولٌ
u'رَوَى مَنْدَلٌ':Subject, #1: 1	رَوَى مَنَاكِيرَ
u'رَوَى مَنْصُورٌ':Subject, #1: 1	رَوَى مَنْدَلٌ
u'رَوَى مَنْصُورٌ':Subject, #1: 1	رَوَى الْمَنْصُورُ
u'رَوَى مُوَطَّأٌ':Predicate, #3: 3	رَوَى مَنْصُورٌ
u'رَوَى مَيْمُونٌ':Subject, #1: 1	رَوَى الْمُوَطّأَ
u'رَوَى نَاجِي':Subject, #1: 1	رَوَى مَيْمُونُ
u'رَوَى نَاسٌ':Subject, #1: 1	رَوَى نَاجِيَةُ
u'رَوَى نَاسٌ':Subject, #1: 1	رَوَى النّاسُ
u'رَوَى نَافِعٌ':Subject, #2: 2	رَوَى النَّاسُ
u'رَوَى نَجَّادٌ':Subject, #7: 7	رَوَى نَافِعٌ
u'رَوَى نُعْمَانُ':Subject, #1: 1	رَوَى النَّجَّادُ
u'رَوَى نَهْيٌ':Predicate, #1: 1	رَوَى النُّعْمَانُ
u'رَوَى هشام':Subject, #2: 2	رَوَى النَّهْيَ
u'رَوَى هِشَامٌ':Subject, #2: 2	رَوَى هِشَامُ
u'رَوَى هشام':Subject, #2: 2	رَوَى هِشَامُ
u'رَوَى هِشَامٌ':Subject, #38: 38	رَوَى هِشَامٌ
u'رَوَى واحد':Subject, #38: 38	رَوَى هِشَامٌ
u'رَوَى وَاحِدٌ':Subject, #1: 1	رَوَى الْوَاحِدُ
u'رَوَى واحد':Subject, #1: 1	رَوَى الْوَاحِدُ
u'رَوَى وَاحِدٌ':Subject, #1: 1	رَوَى وَاحِدٌ
u'رَوَى وُجُوبٌ':Predicate, #1: 1	رَوَى وَاحِدٌ
u'رَوَى وَلِيدٌ':Subject, #1: 1	رَوَى وُجُوبَ
u'رِيبَةٌ حَمْلٌ':Added, #2: 2	رَوَى الْوَلِيدُ
u'رَيْبٌ حوادِثُ':Added, #1: 1	رِيبَةَ حَمْلٍ
u'رَيْبٌ دَهْرٌ':Added, #1: 1	رَيْبِ الْحَوَادِثِ
u'رَيْبٌ زَمانٌ':Added, #1: 1	رَيْبُ الدّهْرِ
u'رَيْبٌ علم':Added, #1: 1	رَيْبَ الزّمَانِ
u'رَيْبٌ عِلْمٌ':Added, #1: 1	رَيْبِ الْعِلْمِ
u'رَيْبٌ قلب':Added, #1: 1	رَيْبِ الْعِلْمِ
u'رَيْبٌ قَلْبٌ':Added, #1: 1	رَيْبِ الْقَلْبِ
u'رَيْبٌ قَلْب':Added, #1: 1	رَيْبِ الْقَلْبِ
u'رَيْبٌ مَنُونٌ':Added, #1: 1	رَيْبِ الْقَلْبِ
u'رَيْبٌ مَنُونٌ':Added, #2: 2	رَيْبُ الْمَنُونِ
u'ريعٌ أَمْلاكٌ':Added, #4: 4	رَيْبَ الْمَنُونِ
u'ريعٌ أَمْلاَكٌ':Added, #1: 1	رَيْعِ الْأَمْلَاكِ
u'رَيْعٌ أَمْلاكٌ':Added, #1: 1	رَيْعِ الْأَمْلَاكِ
u'رَيْعٌ أَمْلاَكٌ':Added, #1: 1	رَيْعِ الْأَمْلَاكِ
u'ريعٌ حاصِلٌ':Added, #1: 1	رَيْعِ الْأَمْلَاكِ
u'رَيْعٌ حاصِلٌ':Added, #1: 1	رَيْعٍ حَاصِلٍ
u'ريعٌ قَمْحٌ':Added, #1: 1	رَيْعٍ حَاصِلٍ
u'رَيْعٌ قَمْحٌ':Added, #1: 1	رَيْعِ الْقَمْحِ
u'ريعٌ مَوْقُوفٌ':Added, #1: 1	رَيْعِ الْقَمْحِ
u'رَيْعٌ مَوْقُوفٌ':Added, #1: 1	رَيْعُ الْمَوْقُوفِ
u'ريعٌ وَقْفٌ':Added, #1: 1	رَيْعُ الْمَوْقُوفِ
u'رَيْعٌ وَقْفٌ':Added, #1: 1	رَيْعِ وَقْفِ
u'ريعٌ وَقْفٌ':Added, #1: 1	رَيْعِ وَقْفِ
u'رَيْعٌ وَقْفٌ':Added, #1: 1	رَيْعِ وَقْفِهِ
u'ريعٌ وَقْفٌ':Added, #1: 1	رَيْعِ وَقْفِهِ
u'رَيْعٌ وَقْفٌ':Added, #2: 2	رَيْعُ الْوَقْفِ
u'ريعٌ وَقْفٌ':Added, #2: 2	رَيْعُ الْوَقْفِ
u'رَيْعٌ وَقْفٌ':Added, #3: 3	رَيْعِ الْوَقْفِ
u'زَاحَمَ صَاحِبٌ':Subject, #3: 3	رَيْعِ الْوَقْفِ
u'زَاحَمَ غرماء':Predicate, #1: 1	زَاحَمَ صَاحِبُ
u'زَاحَمَ مَلاَئِكَةٌ':Predicate, #1: 1	زَاحَمَ الْغُرَمَاءَ
u'زَاحَمَ نَاسٌ':Predicate, #1: 1	زَاحَمَ الْمَلَائِكَةَ
u'زَادَ إِبِلٌ':Subject, #1: 1	زَاحَمَ النَّاسَ
u'زَادَ اِبْنٌ':Subject, #1: 1	زَادَ الإِبِلُ
u'زَادَ أَجْرٌ':Subject, #101: 101	زَادَ ابْنُ
u'زَادَ أُجْرَةٌ':Subject, #1: 1	زَادَ أَجْرُ
u'زَادَ أَجَلٌ':Subject, #1: 1	زَادَ أُجْرَةُ
u'زَادَ أَجْنَبِيٌّ':Predicate, #4: 4	زَادَ الْأَجَلُ
u'زَادَ أَجْنَبِيٌّ':Subject, #1: 1	زَادَ الْأَجْنَبِيَّ
u'زَادَ اِحْتِمَالٌ':Subject, #2: 2	زَادَ الْأَجْنَبِيُّ
u'زَادَ آدَمُ':Subject, #1: 1	زَادَ احْتِمَالُهُ
u'زَادَ أَذَانٌ':Predicate, #2: 2	زَادَ آدَمُ
u'زَادَ أَسَدٌ':Subject, #1: 1	زَادَ الْأَذَانَ
u'زَادَ إِسْنادٌ':Subject, #2: 2	زَادَ أَسَدٌ
u'زَادَ أسْوَد':Subject, #1: 1	زَادَ إسْنَادُهُ
u'زَادَ أسْوَد':Subject, #1: 1	زَادَ الْأَسْوَدُ
u'زَادَ اِشْتِعالٌ':Subject, #2: 2	زَادَ أَسْوَدُ
u'زَادَ أَشْهَب':Subject, #1: 1	زَادَ اشْتِعَالُ
u'زَادَ أَصْبَاغٌ':Subject, #1: 1	زَادَ أَشْهَبُ
u'زَادَ أصل':Subject, #2: 2	زَادَ الْأَصْبَاغُ
u'زَادَ أًصْلٌ':Subject, #2: 2	زَادَ الْأَصْلُ
u'زَادَ أكْبَرُ':Subject, #2: 2	زَادَ الْأَصْلُ
u'زَادَ اللَّهُمَّ':Predicate, #1: 1	زَادَ أَكْبَرُ
u'زَادَ إمَامٌ':Subject, #1: 1	زَادَ اللَّهُمَّ
u'زَادَ أهْلٌ':Predicate, #6: 6	زَادَ الْإِمَامُ
u'زَادَ إيمَانٌ':Subject, #1: 1	زَادَ أَهْلَ
u'زَادَ بَائِعٌ':Subject, #1: 1	زَادَ إيمَانُهُ
u'زَادَ بَائِعٌ':Subject, #1: 1	زَادَ بَائِعُ
u'زَادَ بُخَارِيٌّ':Subject, #6: 6	زَادَ الْبَائِعُ
u'زَادَ بَذْرٌ':Subject, #18: 18	زَادَ الْبُخَارِيُّ
u'زَادَ بَزَّارٌ':Subject, #3: 3	زَادَ الْبَذْرُ
u'زَادَ بَطَلٌ':Predicate, #3: 3	زَادَ الْبَزَّارُ
u'زَادَ بُعْدٌ':Subject, #1: 1	زَادَ بَطَلَ
u'زَادَ بُعْدٌ':Subject, #1: 1	زَادَ الْبُعْدُ
u'زَادَ بَعْضٌ':Subject, #1: 1	زَادَ بُعْدُهُ
u'زَادَ بِنَاءٌ':Subject, #15: 15	زَادَ بَعْضُ
u'زَادَ بَيْعٌ':Subject, #1: 1	زَادَ الْبِنَاءُ
u'زَادَ بَيْنٌ':Predicate, #1: 1	زَادَ الْبَيْعُ
u'زَادَ تَحْرِيمٌ':Subject, #1: 1	زَادَ بَيْنَ
u'زَادَ تَخَلُّفٌ':Subject, #1: 1	زَادَ تَحْرِيمُ
u'زَادَ تَسْمِيَة':Predicate, #1: 1	زَادَ تَخَلُّفُهُ
u'زَادَ تَشَهُّدٌ':Predicate, #1: 1	زَادَ التَّسْمِيَةَ
u'زَادَ تَضَرُّرٌ':Subject, #1: 1	زَادَ التَّشَهُّدَ
u'زَادَ تَعَجُّبٌ':Subject, #1: 1	زَادَ تَضَرُّرُهُ
u'زَادَ تَعَدُّدٌ':Subject, #1: 1	زَادَ التَّعَجُّبُ
u'زَادَ تَكْريرٌ':Subject, #1: 1	زَادَ التَّعَدُّدُ
u'زَادَ تَلْويثٌ':Subject, #2: 2	زَادَ التَّكْرِيرُ
u'زَادَ تَمْتامٌ':Subject, #1: 1	زَادَ التَّلْوِيثُ
u'زَادَ تَمْلِيكٌ':Subject, #1: 1	زَادَ تَمْتَامٌ
u'زَادَ تَوْفِيقٌ':Subject, #2: 2	زَادَ تَمْلِيكٌ
u'زَادَ ثَلاثُ':Predicate, #1: 1	زَادَ تَوْفِيقُهُ
u'زَادَ ثَلاثَةٌ':Subject, #1: 1	زَادَ الثَّلَاثَ
u'زَادَ ثَمَنٌ':Subject, #1: 1	زَادَ الثَّلَاثَةُ
u'زَادَ ثَمَنٌ':Subject, #2: 2	زَادَ ثَمَنُهُ
u'زَادَ ثَوْرِيٌّ':Subject, #4: 4	زَادَ الثَّمَنُ
u'زَادَ ثِيابٌ':Predicate, #1: 1	زَادَ الثَّوْرِيُّ
u'زَادَ جَارِي':Predicate, #1: 1	زَادَ الثِّيَابَ
u'زَادَ جَازٌ':Predicate, #2: 2	زَادَ جَارِيَةً
u'زَادَ جَرَيان':Subject, #1: 1	زَادَ جَازَ
u'زَادَ جَمَاعَةٌ':Subject, #1: 1	زَادَ جَرَيَانُهُ
u'زَادَ جَمَاعَةٌ':Subject, #13: 13	زَادَ جَمَاعَةٌ
u'زَادَ جمع':Subject, #1: 1	زَادَ الْجَمَاعَةُ
u'زَادَ جَمْعٌ':Subject, #2: 2	زَادَ جَمْعُ
u'زَادَ جَوْهَرِيٌّ':Subject, #2: 2	زَادَ جَمْعُ
u'زَادَ حادِي':Predicate, #1: 1	زَادَ الْجَوْهَرِيُّ
u'زَادَ حاكِمٌ':Subject, #1: 1	زَادَ حَادِيَ
u'زَادَ حَرامٌ':Subject, #6: 6	زَادَ الْحَاكِمُ
u'زَادَ حَرْبٌ':Subject, #4: 4	زَادَ الْحَرَامُ
u'زَادَ حُرِّيَّةٌ':Predicate, #4: 4	زَادَ حَرْبٌ
u'زَادَ حَصْرٌ':Predicate, #1: 1	زَادَ الْحُرِّيَّةَ
u'زَادَ حَصَلٌ':Predicate, #1: 1	زَادَ حَصْرَ
u'زَادَ حَفْصٌ':Subject, #1: 1	زَادَ حَصَلَ
u'زَادَ حَفْصٌ':Subject, #1: 1	زَادَ حَفْصُ
u'زَادَ حَقٌّ':Subject, #3: 3	زَادَ حَفْصٌ
u'زَادَ حَمَّادٌ':Subject, #1: 1	زَادَ حَقُّ
u'زَادَ حَنَفِيَّةٌ':Subject, #1: 1	زَادَ حَمَّادُ
u'زَادَ خُرُوجٌ':Predicate, #1: 1	زَادَ الْحَنَفِيَّةُ
u'زَادَ خُشُوعٌ':Subject, #1: 1	زَادَ الْخُرُوجَ
u'زَادَ خطر':Subject, #1: 1	زَادَ خُشُوعُهُ
u'زَادَ خَطَرٌ':Subject, #5: 5	زَادَ خَطَرُ
u'زَادَ خُمَاسَ':Subject, #5: 5	زَادَ خَطَرُ
u'زَادَ خَمْسٌ':Subject, #1: 1	زَادَ الْخُمَاسُ
u'زَادَ خَوْفٌ':Subject, #1: 1	زَادَ خَمْسٌ
u'زَادَ دِبَاغٌ':Subject, #1: 1	زَادَ خَوْفُ
u'زَادَ دَبَّاغٌ':Subject, #30: 30	زَادَ الدِّبَاغُ
u'زَادَ دُعَاءٌ':Predicate, #3: 3	زَادَ الدَّبَّاغُ
u'زَادَ دَلٌّ':Predicate, #3: 3	زَادَ الدُّعَاءَ
u'زَادَ دَمٌ':Subject, #1: 1	زَادَ دَلَّ
u'زَادَ دِهانٌ':Subject, #13: 13	زَادَ الدَّمُ
u'زَادَ دُورِيٌّ':Subject, #1: 1	زَادَ الدِّهَانُ
u'زَادَ دَيْنٌ':Subject, #1: 1	زَادَ الدُّورِيُّ
u'زَادَ دَيْنٌ':Subject, #1: 1	زَادَ دَيْنُ
u'زَادَ دَيْنٌ':Subject, #2: 2	زَادَ الدَّيْنُ
u'زَادَ راغِب':Subject, #5: 5	زَادَ دَيْنُهُ
u'زَادَ راغِب':Subject, #1: 1	زَادَ الرَّاغِبُ
u'زَادَ رَبُّ':Predicate, #2: 2	زَادَ رَاغِبٌ
u'زَادَ رَبُّ':Subject, #1: 1	زَادَ رَبَّ
u'زَادَ رِبْحٌ':Subject, #2: 2	زَادَ رَبُّ
u'زَادَ رَجُلٌ':Subject, #1: 1	زَادَ رِبْحُ
u'زَادَ رَجُلٌ':Subject, #1: 1	زَادَ الرّجُلُ
u'زَادَ رَجُلٌ':Subject, #1: 1	زَادَ الرَّجُلُ
u'زَادَ رَحْمَن':Predicate, #2: 2	زَادَ رَجُلٌ
u'زَادَ رَدٌّ':Predicate, #1: 1	زَادَ الرَّحْمَنَ
u'زَادَ رَسُولٌ':Subject, #1: 1	زَادَ رَدَّ
u'زَادَ ركعة':Predicate, #4: 4	زَادَ رَسُولُ
u'زَادَ رَكْعَةٌ':Predicate, #1: 1	زَادَ الرَّكْعَةَ
u'زَادَ رَمْيٌ':Predicate, #1: 1	زَادَ الرَّكْعَةَ
u'زَادَ روحٌ':Subject, #1: 1	زَادَ الرَّمْيَ
u'زَادَ رَوْحٌ':Subject, #1: 1	زَادَ رَوْحٌ
u'زَادَ زادٌ':Predicate, #1: 1	زَادَ رَوْحٌ
u'زَادَ زائِدٌ':Subject, #3: 3	زَادَ زَادَ
u'زَادَ زَمانٌ':Subject, #1: 1	زَادَ زَائِدَةُ
u'زَادَ زَوْجٌ':Subject, #1: 1	زَادَ زَمَانُ
u'زَادَ زَيْدٌ':Subject, #6: 6	زَادَ الزَّوْجُ
u'زَادَ زَيْدٌ':Subject, #1: 1	زَادَ زَيْدُ
u'زَادَ سَرَّاجٌ':Subject, #3: 3	زَادَ زَيْدٌ
u'زَادَ سِرْقِين':Predicate, #2: 2	زَادَ السَّرَّاجُ
u'زَادَ سعر':Subject, #1: 1	زَادَ السِّرْقِينَ
u'زَادَ سِعْرٌ':Subject, #1: 1	زَادَ السِّعْرُ
u'زَادَ سقط':Predicate, #1: 1	زَادَ السِّعْرُ
u'زَادَ سَقَطٌ':Predicate, #3: 3	زَادَ سَقَطَ
u'زَادَ سلمة':Subject, #3: 3	زَادَ سَقَطَ
u'زَادَ سَمْنٌ':Subject, #1: 1	زَادَ سَلَمَةُ
u'زَادَ سَهْمٌ':Subject, #1: 1	زَادَ السَّمْنُ
u'زَادَ سُهَيْلٌ':Subject, #1: 1	زَادَ سَهْمُ
u'زَادَ سَوادٌ':Subject, #1: 1	زَادَ سُهَيْلٌ
u'زَادَ سُوقٌ':Subject, #1: 1	زَادَ السَّوَادُ
u'زَادَ شَارِحٌ':Subject, #1: 1	زَادَ سُوقُهُ
u'زَادَ شافِعِيّ':Subject, #2: 2	زَادَ الشَّارِحُ
u'زَادَ شَرٌّ':Subject, #1: 1	زَادَ الشَّافِعِيُّ
u'زَادَ شَرْطٌ':Predicate, #2: 2	زَادَ شَرُّهُ
u'زَادَ شَرِيفٌ':Subject, #1: 1	زَادَ شَرْطَ
u'زَادَ شَلَلٌ':Subject, #1: 1	زَادَ الشَّرِيفُ
u'زَادَ شَهَادَةٌ':Predicate, #1: 1	زَادَ شَلَلُ
u'زَادَ شَيْءٌ':Subject, #1: 1	زَادَ شَهَادَةَ
u'زَادَ شَيْخٌ':Subject, #2: 2	زَادَ شَيْءٌ
u'زَادَ شَيْطَانٌ':Subject, #11: 11	زَادَ الشَّيْخُ
u'زَادَ صَاحِبٌ':Predicate, #1: 1	زَادَ الشَّيْطَانُ
u'زَادَ صَاحِبٌ':Subject, #1: 1	زَادَ صَاحِبَ
u'زَادَ صَبٌّ':Predicate, #24: 24	زَادَ صَاحِبُ
u'زَادَ صَبْغٌ':Subject, #1: 1	زَادَ صَبَّ
u'زَادَ صِبْغٌ':Subject, #38: 38	زَادَ الصَّبْغُ
u'زَادَ صداق':Subject, #4: 4	زَادَ الصِّبْغُ
u'زَادَ صَدَاقٌ':Subject, #3: 3	زَادَ الصَّدَاقُ
u'زَادَ ضَرَرٌ':Subject, #3: 3	زَادَ الصَّدَاقُ
u'زَادَ ضَرَرٌ':Subject, #1: 1	زَادَ ضَرَرُ
u'زَادَ ضَمِنٌ':Predicate, #1: 1	زَادَ ضَرَرُهُ
u'زَادَ ضَمِيرٌ':Subject, #3: 3	زَادَ ضَمِنَ
u'زَادَ طَبَرِيّ':Subject, #1: 1	زَادَ ضَمِيرُ
u'زَادَ طَبِيبٌ':Subject, #1: 1	زَادَ الطَّبَرِيُّ
u'زَادَ طَلاَقٌ':Predicate, #1: 1	زَادَ الطَّبِيبُ
u'زَادَ طُولٌ':Subject, #2: 2	زَادَ الطَّلَاقَ
u'زَادَ ظِلٌّ':Subject, #2: 2	زَادَ الطُّولُ
u'زَادَ عَارِفٌ':Subject, #1: 1	زَادَ الظِّلُّ
u'زَادَ عَامِلٌ':Subject, #1: 1	زَادَ الْعَارِفُ
u'زَادَ عَبَّاسٌ':Subject, #1: 1	زَادَ الْعَامِلُ
u'زَادَ عَبْدٌ':Predicate, #1: 1	زَادَ الْعَبّاسُ
u'زَادَ عَبْدٌ':Subject, #1: 1	زَادَ الْعَبْدَ
u'زَادَ عَبْدٌ':Subject, #11: 11	زَادَ عَبْدُ
u'زَادَ عَبْدٌ':Subject, #1: 1	زَادَ عَبْدٌ
u'زَادَ عجز':Predicate, #3: 3	زَادَ الْعَبْدُ
u'زَادَ عجز':Subject, #1: 1	زَادَ عَجَزَ
u'زَادَ عَجْزٌ':Subject, #1: 1	زَادَ عَجْزُهُ
u'زَادَ عَدَدٌ':Subject, #1: 1	زَادَ عَجْزُهُ
u'زَادَ عَدَدٌ':Subject, #1: 1	زَادَ عَدَدُهُ
u'زَادَ عَدَدٌ':Subject, #2: 2	زَادَ الْعَدَدُ
u'زَادَ عَدُوٌّ':Subject, #3: 3	زَادَ عَدَدُ
u'زَادَ عَدْوٌ':Subject, #2: 2	زَادَ الْعَدُوُّ
u'زَادَ عُصْفُر':Subject, #2: 2	زَادَ عَدْوُهُ
u'زَادَ عَقْلٌ':Subject, #2: 2	زَادَ الْعُصْفُرُ
u'زَادَ علم':Subject, #1: 1	زَادَ عَقْلُهُ
u'زَادَ عِلْمٌ':Subject, #1: 1	زَادَ عِلْمُهُ
u'زَادَ عَلِيٌّ':Subject, #1: 1	زَادَ عِلْمُهُ
u'زَادَ عُمَرٌ':Subject, #1: 1	زَادَ عَلِيٌّ
u'زَادَ عَمَلٌ':Predicate, #8: 8	زَادَ عُمَرُ
u'زَادَ عَمَلٌ':Subject, #1: 1	زَادَ الْعَمَلَ
u'زَادَ عَمَلٌ':Subject, #3: 3	زَادَ عَمَلُ
u'زَادَ عند':Predicate, #3: 3	زَادَ عَمَلُهُ
u'زَادَ عِوَضٌ':Subject, #7: 7	زَادَ عِنْدَ
u'زَادَ غير':Subject, #1: 1	زَادَ الْعِوَضُ
u'زَادَ غَيْرٌ':Subject, #10: 10	زَادَ غَيْرُ
u'زَادَ غير':Subject, #10: 10	زَادَ غَيْرُ
u'زَادَ غَيْرٌ':Subject, #14: 14	زَادَ غَيْرُهُ
u'زَادَ فَاسِقٌ':Subject, #14: 14	زَادَ غَيْرُهُ
u'زَادَ فُتُورٌ':Subject, #1: 1	زَادَ فَاسِقٌ
u'زَادَ فَجْرٌ':Predicate, #1: 1	زَادَ فُتُورُهُ
u'زَادَ فِسْقٌ':Subject, #2: 2	زَادَ الْفَجْرَ
u'زَادَ فِسْقٌ':Subject, #1: 1	زَادَ فِسْقُ
u'زَادَ فلان':Predicate, #1: 1	زَادَ فِسْقُهُ
u'زَادَ فلان':Subject, #1: 1	زَادَ الرَّحْمَنَ
u'زَادَ فلان':Subject, #11: 11	زَادَ الطَّبَرَانِيُّ
u'زَادَ فلان':Subject, #1: 1	زَادَ الرَّاغِبُ
u'زَادَ فلان':Subject, #1: 1	زَادَ الشَّافِعِيُّ
u'زَادَ فلان':Subject, #1: 1	زَادَ الطَّبَرِيُّ
u'زَادَ فلان':Subject, #1: 1	زَادَ بِلاَلٌ
u'زَادَ فلان':Subject, #1: 1	زَادَ زُهَيْرٌ
u'زَادَ فلان':Subject, #1: 1	زَادَ شُعَيْبٌ
u'زَادَ فلان':Subject, #1: 1	زَادَ عَقِيلٌ
u'زَادَ فلان':Subject, #1: 1	زَادَ مُعَاوِيَةُ
u'زَادَ فلان':Subject, #1: 1	زَادَ هَارُونُ
u'زَادَ فلان':Subject, #2: 2	زَادَ الْقُرْطُبِيُّ
u'زَادَ فُلاَنٌ':Subject, #2: 2	زَادَ رَاغِبٌ
u'زَادَ فلان':Subject, #2: 2	زَادَ فُلَانٌ
u'زَادَ فلان':Subject, #2: 2	زَادَ قَتَادَةُ
u'زَادَ فلان':Subject, #3: 3	زَادَ سُفْيَانُ
u'زَادَ فلان':Subject, #4: 4	زَادَ جَعْفَرٌ
u'زَادَ فلان':Subject, #6: 6	زَادَ عُثْمَانُ
u'زَادَ فلان':Subject, #8: 8	زَادَ الْبَيْهَقِيُّ
u'زَادَ فلان':Subject, #8: 8	زَادَ عَفَّانُ
u'زَادَ فَلَكٌ':Predicate, #9: 9	زَادَ التِّرْمِذِيُّ
u'زَادَ قَاسِمٌ':Subject, #4: 4	زَادَ فَلَكَ
u'زَادَ قَاصِرٌ':Subject, #1: 1	زَادَ قَاسِمٌ
u'زَادَ قَالٌ':Predicate, #1: 1	زَادَ الْقَاصِرُ
u'زَادَ قَبُولٌ':Predicate, #12: 12	زَادَ قَالَ
u'زَادَ قَتاد':Subject, #1: 1	زَادَ الْقَبُولَ
u'زَادَ قتال':Subject, #2: 2	زَادَ قَتَادَةُ
u'زَادَ قِتَالٌ':Subject, #1: 1	زَادَ قِتَالُهُ
u'زَادَ قَدْرٌ':Predicate, #1: 1	زَادَ قِتَالُهُ
u'زَادَ قَدْرٌ':Subject, #2: 2	زَادَ قَدْرَ
u'زَادَ قُرْطُبِيّ':Subject, #2: 2	زَادَ قَدْرُ
u'زَادَ قِسْطٌ':Subject, #2: 2	زَادَ الْقُرْطُبِيُّ
u'زَادَ قَطْعٌ':Predicate, #1: 1	زَادَ الْقِسْطُ
u'زَادَ قَفِيز':Subject, #1: 1	زَادَ قَطْعَ
u'زَادَ قول':Subject, #5: 5	زَادَ الْقَفِيزُ
u'زَادَ قَوْلٌ':Subject, #1: 1	زَادَ قَوْلُهُ
u'زَادَ قَوْمٌ':Subject, #1: 1	زَادَ قَوْلُهُ
u'زَادَ قَيْدٌ':Predicate, #1: 1	زَادَ قَوْمٌ
u'زَادَ قِيمَةٌ':Subject, #1: 1	زَادَ قَيْدَ
u'زَادَ كُفَّارٌ':Subject, #1: 1	زَادَ قِيمَةُ
u'زَادَ لبن':Subject, #1: 1	زَادَ الْكُفَّارُ
u'زَادَ لَبَنٌ':Subject, #2: 2	زَادَ اللَّبَنُ
u'زَادَ لَفْظٌ':Predicate, #2: 2	زَادَ اللَّبَنُ
u'زَادَ لَفْظَةٌ':Predicate, #1: 1	زَادَ لَفْظَ
u'زَادَ لَفْظِيٌّ':Subject, #3: 3	زَادَ لَفْظَةَ
u'زَادَ لَيْثٌ':Subject, #1: 1	زَادَ لَفْظِيٌّ
u'زَادَ مَاءٌ':Subject, #3: 3	زَادَ اللَّيْثُ
u'زَادَ مَالٌ':Subject, #1: 1	زَادَ الْمَاءُ
u'زَادَ مَالِكٌ':Subject, #4: 4	زَادَ مَالُهُ
u'زَادَ مَالِكٌ':Subject, #1: 1	زَادَ الْمَالِكُ
u'زَادَ مَبِيعٌ':Subject, #3: 3	زَادَ مَالِكٌ
u'زَادَ مُتَّصِلٌ':Predicate, #4: 4	زَادَ الْمَبِيعُ
u'زَادَ مثل':Subject, #1: 1	زَادَ الْمُتَّصِلَ
u'زَادَ مِثْلٌ':Subject, #1: 1	زَادَ مِثْلُهُ
u'زَادَ مُجْتَهِد':Subject, #1: 1	زَادَ مِثْلُهُ
u'زَادَ مَجْدٌ':Subject, #1: 1	زَادَ الْمُجْتَهِدُ
u'زَادَ مَجْمُوعٌ':Subject, #5: 5	زَادَ الْمَجْدُ
u'زَادَ مُحَمَّدٌ':Subject, #1: 1	زَادَ مَجْمُوعُهُ
u'زَادَ مُحَمَّدٌ':Subject, #2: 2	زَادَ مُحَمَّدُ
u'زَادَ مرٌّ':Predicate, #3: 3	زَادَ مُحَمَّدٌ
u'زَادَ مَرَضٌ':Subject, #2: 2	زَادَ مَرَّةً
u'زَادَ مَرَضٌ':Subject, #1: 1	زَادَ الْمَرَضُ
u'زَادَ مُزَارِعٌ':Predicate, #4: 4	زَادَ مَرَضُهُ
u'زَادَ مزال':Subject, #1: 1	زَادَ الْمُزَارِعَ
u'زَادَ مُسْتَأْجِرٌ':Subject, #1: 1	زَادَ الْمُزَالُ
u'زَادَ مُسَدَّدٌ':Subject, #2: 2	زَادَ الْمُسْتَأْجِرُ
u'زَادَ مُسَدَّدٌ':Subject, #1: 1	زَادَ مُسَدَّدٌ
u'زَادَ مُسَلَّمٌ':Subject, #1: 1	زَادَ مُسَدَّدُ
u'زَادَ مُسْلِمٌ':Subject, #1: 1	زَادَ الْمُسَلَّمُ
u'زَادَ مُسْلِمٌ':Subject, #1: 1	زَادَ مُسْلِمُ
u'زَادَ مَشْكُوكٌ':Subject, #22: 22	زَادَ مُسْلِمٌ
u'زَادَ مَصْبُوبٌ':Subject, #3: 3	زَادَ مَشْكُوكٌ
u'زَادَ مُصَنِّفٌ':Subject, #2: 2	زَادَ الْمَصْبُوبُ
u'زَادَ مُضَارِبٌ':Subject, #13: 13	زَادَ الْمُصَنِّفُ
u'زَادَ مُعاوِيَة':Subject, #1: 1	زَادَ الْمُضَارِبُ
u'زَادَ مُعْتَرِضٌ':Subject, #1: 1	زَادَ مُعَاوِيَةُ
u'زَادَ مَغْصُوب':Subject, #1: 1	زَادَ الْمُعْتَرِضُ
u'زَادَ مُفْرَدٌ':Subject, #1: 1	زَادَ الْمَغْصُوبُ
u'زَادَ ملح':Predicate, #1: 1	زَادَ الْمُفْرَدُ
u'زَادَ مِلْحٌ':Predicate, #2: 2	زَادَ الْمِلْحَ
u'زَادَ ملح':Subject, #2: 2	زَادَ الْمِلْحَ
u'زَادَ مِلْحٌ':Subject, #3: 3	زَادَ الْمِلْحُ
u'زَادَ مَنْذُور':Subject, #3: 3	زَادَ الْمِلْحُ
u'زَادَ مَنْسِيٌّ':Subject, #1: 1	زَادَ الْمَنْذُورُ
u'زَادَ مَنْصُورٌ':Subject, #1: 1	زَادَ الْمَنْسِيُّ
u'زَادَ مَهْرٌ':Subject, #1: 1	زَادَ مَنْصُورٌ
u'زَادَ مُؤَدِّبٌ':Subject, #1: 1	زَادَ الْمَهْرُ
u'زَادَ مُؤَلِّفٌ':Subject, #1: 1	زَادَ الْمُؤَدِّبُ
u'زَادَ مُؤَمَّلٌ':Subject, #1: 1	زَادَ الْمُؤَلِّفُ
u'زَادَ مَوْهُوبٌ':Subject, #1: 1	زَادَ مُؤَمَّلٌ
u'زَادَ نَاسٌ':Predicate, #1: 1	زَادَ الْمَوْهُوبُ
u'زَادَ نَاسٌ':Subject, #1: 1	زَادَ النَّاسَ
u'زَادَ نَافِعٌ':Subject, #1: 1	زَادَ النَّاسُ
u'زَادَ نَافِلَةٌ':Subject, #1: 1	زَادَ نَافِعٌ
u'زَادَ نَحْوٌ':Predicate, #2: 2	زَادَ نَافِلَةٌ
u'زَادَ نِدَاءٌ':Predicate, #1: 1	زَادَ النَّحْوَ
u'زَادَ نُزُولٌ':Subject, #6: 6	زَادَ النِّدَاءَ
u'زَادَ نشاط':Subject, #1: 1	زَادَ نُزُولُهُ
u'زَادَ نَشَاطٌ':Subject, #1: 1	زَادَ نَشَاطُهُ
u'زَادَ نصاب':Subject, #1: 1	زَادَ نَشَاطُهُ
u'زَادَ نِصَابٌ':Subject, #1: 1	زَادَ النِّصَابُ
u'زَادَ نَعْلٌ':Predicate, #1: 1	زَادَ النِّصَابُ
u'زَادَ نُعْمَانُ':Subject, #7: 7	زَادَ النَّعْلَ
u'زَادَ نفاس':Subject, #1: 1	زَادَ النُّعْمَانُ
u'زَادَ نِفَاسٌ':Subject, #1: 1	زَادَ النِّفَاسُ
u'زَادَ نَفْعٌ':Subject, #1: 1	زَادَ النِّفَاسُ
u'زَادَ نَقْصٌ':Subject, #1: 1	زَادَ نَفْعُهُ
u'زَادَ نُقْصَانٌ':Subject, #1: 1	زَادَ النَّقْصُ
u'زَادَ نَمَاءٌ':Subject, #2: 2	زَادَ النُّقْصَانُ
u'زَادَ نَوَوِيٌّ':Subject, #2: 2	زَادَ النَّمَاءُ
u'زَادَ هَالِكٌ':Subject, #9: 9	زَادَ النَّوَوِيُّ
u'زَادَ هَرَوِيّ':Subject, #3: 3	زَادَ الْهَالِكُ
u'زَادَ هشام':Subject, #1: 1	زَادَ الْهَرَوِيُّ
u'زَادَ هِشَامٌ':Subject, #2: 2	زَادَ هِشَامٌ
u'زَادَ هلاك':Subject, #2: 2	زَادَ هِشَامٌ
u'زَادَ هَلاَكٌ':Subject, #1: 1	زَادَ الْهَلَاكُ
u'زَادَ هَيْثَمٌ':Subject, #1: 1	زَادَ الْهَلَاكُ
u'زَادَ وَاجِبٌ':Subject, #1: 1	زَادَ الْهَيْثَمُ
u'زَادَ واحد':Subject, #1: 1	زَادَ وَاجِبٌ
u'زَادَ وَاحِدٌ':Subject, #2: 2	زَادَ وَاحِدٌ
u'زَادَ وَاقِفٌ':Subject, #2: 2	زَادَ وَاحِدٌ
u'زَادَ وَجَبٌ':Predicate, #1: 1	زَادَ الْوَاقِفُ
u'زَادَ وَجْهٌ':Subject, #1: 1	زَادَ وَجَبَ
u'زَادَ وَزْنٌ':Subject, #1: 1	زَادَ وَجْهُ
u'زَادَ وَقْتٌ':Predicate, #1: 1	زَادَ وَزْنُهُ
u'زَادَ وقع':Predicate, #1: 1	زَادَ وَقْتَ
u'زَادَ ولد':Subject, #2: 2	زَادَ وَقَعَ
u'زَادَ وَلَدٌ':Subject, #1: 1	زَادَ الْوَلَدُ
u'زَادَ وَلِيٌّ':Subject, #1: 1	زَادَ الْوَلَدُ
u'زَادَ يَسِيرٌ':Predicate, #1: 1	زَادَ الْوَلِيُّ
u'زَادَ يَمِينٌ':Subject, #1: 1	زَادَ الْيَسِيرَ
u'زَارَ بَيْتٌ':Predicate, #1: 1	زَادَ الْيَمِينُ
u'زَارَ رَسُولٌ':Subject, #2: 2	زَارَ الْبَيْتَ
u'زَارَ قَبْرٌ':Predicate, #2: 2	زَارَ رَسُولُ
u'زَارَ قُبُورٌ':Predicate, #2: 2	زَارَ قَبْرَ
u'زَاغَ بَصَرٌ':Subject, #1: 1	زَارَ الْقُبُورَ
u'زَاغَ فَهْمٌ':Subject, #1: 1	زَاغَ الْبَصَرُ
u'زَاغَ قَوْمٌ':Subject, #1: 1	زَاغَ فَهْمُ
u'زَالَ اِبْنٌ':Subject, #1: 1	زَاغَ قَوْمٌ
u'زَالَ إِبْهَامٌ':Subject, #1: 1	زَالَ ابْنُ
u'زَالَ أثَرٌ':Predicate, #1: 1	زَالَ الْإِبْهَامُ
u'زَالَ أثَرٌ':Subject, #1: 1	أَزَالَ أَثَرَ
u'زَالَ أثَرٌ':Subject, #1: 1	زَالَ أَثَرُ
u'زَالَ أحَدٌ':Predicate, #1: 1	زَالَ الْأَثَرُ
u'زَالَ أحَدٌ':Subject, #1: 1	أَزَالَ أَحَدَ
u'زَالَ إِحْرَامٌ':Subject, #2: 2	زَالَ أَحَدُ
u'زَالَ أَخِيرٌ':Subject, #3: 3	زَالَ الْإِحْرَامُ
u'زَالَ اِسْتِحْقَاقٌ':Subject, #1: 1	زَالَ الْأَخِيرُ
u'زَالَ اِسْمٌ':Subject, #2: 2	زَالَ اسْتِحْقَاقُهُ
u'زَالَ اِسْمٌ':Subject, #1: 1	زَالَ اسْمُهُ
u'زَالَ إِشْكالٌ':Predicate, #2: 2	زَالَ اسْمُ
u'زَالَ إِشْكالٌ':Subject, #1: 1	أَزَالَ الْإِشْكَالَ
u'زَالَ إِشْكالٌ':Subject, #10: 10	زَالَ الْإِشْكَالُ
u'زَالَ إِشْكالٌ':Subject, #1: 1	زَالَ الإِشْكَالُ
u'زَالَ أصل':Subject, #2: 2	زَالَ إشْكَالُهُ
u'زَالَ أًصْلٌ':Subject, #2: 2	زَالَ الْأَصْلُ
u'زَالَ إكْرَاهٌ':Subject, #2: 2	زَالَ الْأَصْلُ
u'زَالَ آلةٌ':Predicate, #14: 14	زَالَ الْإِكْرَاهُ
u'زَالَ اِلْتِزَامٌ':Subject, #1: 1	أَزَالَ الْآلَةَ
u'زَالَ ألَمٌ':Subject, #1: 1	زَالَ الْتِزَامُهُ
u'زَالَ ألَمٌ':Subject, #1: 1	أَزَالَ أَلَمُ
u'زَالَ اِمْتِناعٌ':Predicate, #1: 1	زَالَ الْأَلَمُ
u'زَالَ أَمْرٌ':Subject, #1: 1	أَزَالَ امْتِنَاعَ
u'زَالَ إِمْكانٌ':Subject, #1: 1	زَالَ الْأَمْرُ
u'زَالَ إِمْكانٌ':Subject, #1: 1	زَالَ إمْكَانُهُ
u'زَالَ أَمَلٌ':Subject, #2: 2	زَالَ الْإِمْكَانُ
u'زَالَ أَمْنٌ':Predicate, #1: 1	زَالَ الْأَمَلُ
u'زَالَ اِنْتِفاعٌ':Subject, #1: 1	أَزَالَ الْأَمْنَ
u'زَالَ إِنْكارٌ':Subject, #1: 1	زَالَ انْتِفَاعُ
u'زَالَ أهْلٌ':Subject, #1: 1	زَالَ الْإِنْكَارُ
u'زَالَ اِئْتِمَانٌ':Subject, #1: 1	زَالَ أَهْلُ
u'زَالَ إِيهَامٌ':Subject, #3: 3	زَالَ ائْتِمَانُهُ
u'زَالَ بَابٌ':Predicate, #1: 1	زَالَ الْإِيهَامُ
u'زَالَ بَرْدٌ':Subject, #1: 1	أَزَالَ بَابَ
u'زَالَ بَطَلٌ':Predicate, #1: 1	زَالَ الْبَرْدُ
u'زَالَ بَعْضٌ':Subject, #1: 1	زَالَ بَطَلَ
u'زَالَ بَعْضٌ':Subject, #1: 1	زَالَ الْبَعْضُ
u'زَالَ بَعْضٌ':Subject, #1: 1	زَالَ بَعْضُهُ
u'زَالَ بَكارَةٌ':Predicate, #2: 2	زَالَ بَعْضُ
u'زَالَ بَكارَةٌ':Predicate, #1: 1	أَزَالَ الْبَكَارَةَ
u'زَالَ بكم':Subject, #5: 5	أَزَالَ بَكَارَةَ
u'زَالَ بِنَاءٌ':Subject, #1: 1	زَالَ بِكُمُ
u'زَالَ بَيَاضٌ':Subject, #1: 1	زَالَ الْبِنَاءُ
u'زَالَ بَيْنٌ':Predicate, #3: 3	زَالَ الْبَيَاضُ
u'زَالَ تَحْرِيمٌ':Subject, #1: 1	زَالَ بَيْنَ
u'زَالَ تَحْرِيمٌ':Subject, #1: 1	زَالَ تَحْرِيمُ
u'زَالَ تَحَكُّمٌ':Subject, #4: 4	زَالَ التَّحْرِيمُ
u'زَالَ تَرَدُّدٌ':Subject, #2: 2	زَالَ التَّحَكُّمُ
u'زَالَ تَرَدُّدٌ':Subject, #1: 1	زَالَ التَّرَدُّدُ
u'زَالَ تَزَوُّجٌ':Subject, #1: 1	زَالَ تَرَدُّدُهُ
u'زَالَ تَشْنِيعٌ':Subject, #1: 1	زَالَ التَّزَوُّجُ
u'زَالَ تَصَرُّفٌ':Subject, #1: 1	زَالَ التَّشْنِيعُ
u'زَالَ تَعَدِّي':Predicate, #1: 1	زَالَ التَّصَرُّفُ
u'زَالَ تَعْلِيقٌ':Subject, #8: 8	أَزَالَ التَّعَدِّيَ
u'زَالَ تَغَيُّرٌ':Subject, #1: 1	زَالَ التَّعْلِيقُ
u'زَالَ تَغَيُّرٌ':Subject, #11: 11	زَالَ تَغَيُّرُهُ
u'زَالَ تَغَيُّرٌ':Subject, #4: 4	زَالَ تَغَيُّرُ
u'زَالَ تَقَدُّمٌ':Subject, #7: 7	زَالَ التَّغَيُّرُ
u'زَالَ تَكْرارٌ':Subject, #1: 1	زَالَ التَّقَدُّمُ
u'زَالَ تَكْليفٌ':Subject, #2: 2	زَالَ التَّكْرَارُ
u'زَالَ تَمَكُّنٌ':Subject, #4: 4	زَالَ التَّكْلِيفُ
u'زَالَ تَمْييزٌ':Subject, #1: 1	زَالَ تَمَكُّنُهُ
u'زَالَ تَنَاقُضٌ':Subject, #1: 1	زَالَ التَّمْيِيزُ
u'زَالَ تَنْوِينٌ':Subject, #1: 1	زَالَ التَّنَاقُضُ
u'زَالَ تَوَقُّفٌ':Subject, #1: 1	زَالَ التّنْوِينُ
u'زَالَ تَوَلُّعٌ':Subject, #4: 4	زَالَ التَّوَقُّفُ
u'زَالَ تَوَهُّمٌ':Subject, #1: 1	زَالَ تَوَلُّعُ
u'زَالَ ثَلاثُ':Predicate, #1: 1	زَالَ التَّوَهُّمُ
u'زَالَ جَازٌ':Predicate, #2: 2	أَزَالَ ثَلَاثَ
u'زَالَ جَانِبٌ':Subject, #1: 1	زَالَ جَازَ
u'زَالَ جِسْمٌ':Subject, #1: 1	زَالَ جَانِبُهُ
u'زَالَ جَمَالٌ':Predicate, #1: 1	زَالَ جِسْمُ
u'زَالَ جَمَالٌ':Subject, #1: 1	أَزَالَ الْجَمَالَ
u'زَالَ جُنُونٌ':Subject, #1: 1	زَالَ الْجَمَالُ
u'زَالَ جِوَارٌ':Subject, #1: 1	زَالَ الْجُنُونُ
u'زَالَ حاجِبٌ':Subject, #1: 1	زَالَ جِوَارُهُ
u'زَالَ حائِطٌ':Predicate, #1: 1	زَالَ الْحَاجِبُ
u'زَالَ حائِطٌ':Subject, #1: 1	أَزَالَ الْحَائِطَ
u'زَالَ حجاب':Predicate, #1: 1	زَالَ الْحَائِطُ
u'زَالَ حِجابٌ':Predicate, #1: 1	أَزَالَ الْحِجَابَ
u'زَالَ حَجْرٌ':Subject, #1: 1	أَزَالَ الْحِجَابَ
u'زَالَ حَدَثٌ':Subject, #5: 5	زَالَ الْحَجْرُ
u'زَالَ حِرْزٌ':Predicate, #3: 3	زَالَ الْحَدَثُ
u'زَالَ حَصْرٌ':Subject, #1: 1	أَزَالَ الْحِرْزَ
u'زَالَ حَظْر':Subject, #3: 3	زَالَ الْحَصْرُ
u'زَالَ حِفْظٌ':Predicate, #1: 1	زَالَ الْحَظْرُ
u'زَالَ حَقٌّ':Subject, #2: 2	أَزَالَ حِفْظَ
u'زَالَ حَقٌّ':Subject, #5: 5	زَالَ حَقُّ
u'زَالَ حُكْمٌ':Predicate, #5: 5	زَالَ حَقُّهُ
u'زَالَ حُكْمٌ':Predicate, #1: 1	أَزَالَ الْحُكْمَ
u'زَالَ حُكْمٌ':Subject, #1: 1	أَزَالَ حُكْمَ
u'زَالَ حُكْمٌ':Subject, #2: 2	زَالَ حُكْمُهُ
u'زَالَ حُكْمٌ':Subject, #3: 3	زَالَ الْحُكْمُ
u'زَالَ خَفْض':Subject, #6: 6	زَالَ حُكْمُ
u'زَالَ خِلاَفٌ':Subject, #1: 1	زَالَ الْخَفْضُ
u'زَالَ خَلَفٌ':Subject, #2: 2	زَالَ الْخِلَافُ
u'زَالَ خَوَاصُّ':Subject, #1: 1	زَالَ الْخَلَفُ
u'زَالَ خَوَاصّ':Subject, #2: 2	زَالَ خَوَاصُّ
u'زَالَ خَوْفٌ':Subject, #2: 2	زَالَ خَوَاصُّ
u'زَالَ خَوْفٌ':Subject, #2: 2	زَالَ الْخَوْفُ
u'زَالَ دَمٌ':Predicate, #2: 2	زَالَ خَوْفُ
u'زَالَ دَمٌ':Subject, #1: 1	أَزَالَ الدَّمَ
u'زَالَ دَيْنٌ':Subject, #1: 1	زَالَ الدَّمُ
u'زَالَ رَجُلٌ':Subject, #2: 2	زَالَ الدَّيْنُ
u'زَالَ رَدٌّ':Subject, #1: 1	زَالَ الرَّجُلُ
u'زَالَ رَسُولٌ':Subject, #1: 1	زَالَ رَدُّ
u'زَالَ رِقٌّ':Subject, #10: 10	زَالَ رَسُولُ
u'زَالَ رَهْنٌ':Predicate, #2: 2	زَالَ رِقُّهُ
u'زَالَ رَهْنٌ':Subject, #1: 1	أَزَالَ الرَّهْنَ
u'زَالَ ريحٌ':Predicate, #1: 1	زَالَ الرَّهْنُ
u'زَالَ زِحامٌ':Subject, #1: 1	أَزَالَ الرِّيحَ
u'زَالَ سَاتِرٌ':Predicate, #1: 1	زَالَ الزِّحَامُ
u'زَالَ سَبَبٌ':Subject, #1: 1	أَزَالَ السَّاتِرَ
u'زَالَ سَبَبٌ':Subject, #2: 2	زَالَ سَبَبُ
u'زَالَ سِدْرٌ':Subject, #5: 5	زَالَ السَّبَبُ
u'زَالَ سقط':Predicate, #1: 1	زَالَ السِّدْرُ
u'زَالَ سَقَطٌ':Predicate, #2: 2	زَالَ سَقَطَ
u'زَالَ سكر':Subject, #2: 2	زَالَ سَقَطَ
u'زَالَ سُكْرٌ':Subject, #1: 1	زَالَ سُكْرُهُ
u'زَالَ سكر':Subject, #1: 1	زَالَ سُكْرُهُ
u'زَالَ سُكْرٌ':Subject, #2: 2	زَالَ السُّكْرُ
u'زَالَ سَلاَمَةٌ':Predicate, #2: 2	زَالَ السُّكْرُ
u'زَالَ سُلْطَانٌ':Subject, #1: 1	أَزَالَ سَلَامَةَ
u'زَالَ سَلَفٌ':Subject, #1: 1	زَالَ سُلْطَانُهُ
u'زَالَ سَوادٌ':Subject, #1: 1	زَالَ السَّلَفُ
u'زَالَ سَوادٌ':Subject, #1: 1	زَالَ السَّوَادُ
u'زَالَ شُبْهَةٌ':Predicate, #1: 1	زَالَ سَوَادُهُ
u'زَالَ شَرْطٌ':Subject, #1: 1	أَزَالَ الشُّبْهَةَ
u'زَالَ شَرْطٌ':Subject, #1: 1	زَالَ الشّرْطُ
u'زَالَ شَعْرٌ':Predicate, #2: 2	زَالَ الشَّرْطُ
u'زَالَ شَعْرٌ':Predicate, #1: 1	أَزَالَ شَعْرَةً
u'زَالَ شَعْرٌ':Subject, #5: 5	أَزَالَ شَعْرَ
u'زَالَ شُغْلٌ':Subject, #1: 1	زَالَ شَعْرُ
u'زَالَ شُغْل':Subject, #1: 1	زَالَ الشُّغْلُ
u'زَالَ شَكٌّ':Subject, #1: 1	زَالَ الشُّغْلُ
u'زَالَ شَكٌّ':Subject, #3: 3	زَالَ الشَّكُّ
u'زَالَ شُكُوكٌ':Predicate, #4: 4	زَالَ شَكُّهُ
u'زَالَ شَلَلٌ':Subject, #1: 1	أَزَالَ الشُّكُوكَ
u'زَالَ شَيْءٌ':Subject, #1: 1	زَالَ الشَّلَلُ
u'زَالَ شَيْطَانٌ':Subject, #2: 2	زَالَ شَيْءٌ
u'زَالَ صِغَرٌ':Subject, #1: 1	زَالَ الشَّيْطَانُ
u'زَالَ ضَرَرٌ':Predicate, #1: 1	زَالَ الصِّغَرُ
u'زَالَ ضَرَرٌ':Subject, #1: 1	أَزَالَ الضَّرَرَ
u'زَالَ ضَمَانٌ':Subject, #3: 3	زَالَ الضَّرَرُ
u'زَالَ ضَوْءٌ':Subject, #10: 10	زَالَ الضَّمَانُ
u'زَالَ ضِيقٌ':Subject, #1: 1	زَالَ ضَوْءُ
u'زَالَ طَلاَقٌ':Subject, #1: 1	زَالَ ضِيقُ
u'زَالَ طلب':Subject, #1: 1	زَالَ طَلَاقُ
u'زَالَ طَلَبٌ':Subject, #1: 1	زَالَ طَلَبُ
u'زَالَ طَهُور':Predicate, #1: 1	زَالَ طَلَبُ
u'زَالَ طِيبٌ':Subject, #1: 1	أَزَالَ الطَّهُورِيَّةَ
u'زَالَ طِينٌ':Subject, #1: 1	زَالَ الطِّيبُ
u'زَالَ ظُلْمٌ':Subject, #1: 1	زَالَ الطِّينُ
u'زَالَ ظَنٌّ':Predicate, #4: 4	زَالَ الظُّلْمُ
u'زَالَ ظَنٌّ':Subject, #1: 1	أَزَالَ ظَنَّ
u'زَالَ ظَنٌّ':Subject, #1: 1	زَالَ ظَنُّ
u'زَالَ عَادٌ':Predicate, #1: 1	زَالَ ظَنُّهُ
u'زَالَ عَارِضٌ':Subject, #2: 2	زَالَ عَادَ
u'زَالَ عَبْدٌ':Subject, #3: 3	زَالَ الْعَارِضُ
u'زَالَ عَبْدٌ':Subject, #1: 1	زَالَ عَبْدٌ
u'زَالَ عجز':Subject, #2: 2	زَالَ الْعَبْدُ
u'زَالَ عَجْزٌ':Subject, #2: 2	زَالَ الْعَجْزُ
u'زَالَ عُذْرٌ':Subject, #2: 2	زَالَ الْعَجْزُ
u'زَالَ عُذْرٌ':Subject, #16: 16	زَالَ الْعُذْرُ
u'زَالَ عُذْرٌ':Subject, #16: 16	زَالَ عُذْرُهُ
u'زَالَ عَقِبٌ':Subject, #7: 7	زَالَ عُذْرُ
u'زَالَ عَقْدٌ':Subject, #1: 1	زَالَ عَقِبُهُ
u'زَالَ عَقْلٌ':Subject, #3: 3	زَالَ الْعَقْدُ
u'زَالَ عَقْلٌ':Subject, #43: 43	زَالَ عَقْلُهُ
u'زَالَ علم':Subject, #4: 4	زَالَ الْعَقْلُ
u'زَالَ عِلْمٌ':Subject, #1: 1	زَالَ الْعِلْمُ
u'زَالَ عَمَلٌ':Subject, #1: 1	زَالَ الْعِلْمُ
u'زَالَ عند':Predicate, #1: 1	زَالَ الْعَمَلُ
u'زَالَ عور':Subject, #4: 4	زَالَ عِنْدَ
u'زَالَ عَوَرٌ':Subject, #1: 1	زَالَ الْعَوَرُ
u'زَالَ عور':Subject, #1: 1	زَالَ الْعَوَرُ
u'زَالَ عَوَرٌ':Subject, #1: 1	زَالَ عَوَرُهُ
u'زَالَ عَيْبٌ':Subject, #1: 1	زَالَ عَوَرُهُ
u'زَالَ عَيْبٌ':Subject, #15: 15	زَالَ الْعَيْبُ
u'زَالَ عين':Predicate, #2: 2	زَالَ عَيْبُ
u'زَالَ عَيْنٌ':Predicate, #2: 2	أَزَالَ الْعَيْنَ
u'زَالَ عَيْن':Predicate, #2: 2	أَزَالَ الْعَيْنَ
u'زَالَ عين':Subject, #2: 2	أَزَالَ الْعَيْنَ
u'زَالَ عَيْنٌ':Subject, #3: 3	زَالَ عَيْنُ
u'زَالَ عَيْن':Subject, #3: 3	زَالَ عَيْنُ
u'زَالَ غَاصِبٌ':Subject, #3: 3	زَالَ عَيْنُ
u'زَالَ غيم':Subject, #1: 1	أَزَالَ غَاصِبٌ
u'زَالَ غَيْمٌ':Subject, #1: 1	زَالَ الْغَيْمُ
u'زَالَ فُرَاتٌ':Subject, #1: 1	زَالَ الْغَيْمُ
u'زَالَ فِرَاشٌ':Subject, #1: 1	زَالَ فُرَاتٌ
u'زَالَ فِرَاشٌ':Subject, #1: 1	زَالَ الْفِرَاشُ
u'زَالَ فِسْقٌ':Subject, #1: 1	زَالَ فِرَاشُهُ
u'زَالَ فقر':Subject, #2: 2	زَالَ فِسْقُهُ
u'زَالَ فَقْرٌ':Subject, #2: 2	زَالَ فَقْرُهُ
u'زَالَ قَالٌ':Predicate, #2: 2	زَالَ فَقْرُهُ
u'زَالَ قَبْضٌ':Predicate, #2: 2	زَالَ قَالَ
u'زَالَ قتال':Subject, #1: 1	أَزَالَ الْقَبْضَ
u'زَالَ قِتَالٌ':Subject, #1: 1	زَالَ الْقِتَالُ
u'زَالَ قَذَرٌ':Predicate, #1: 1	زَالَ الْقِتَالُ
u'زَالَ قِسْطٌ':Predicate, #1: 1	أَزَالَ الْقَذَرَ
u'زَالَ قَهْرٌ':Subject, #1: 1	أَزَالَ الْقِسْطَ
u'زَالَ قول':Predicate, #1: 1	زَالَ قَهْرُهُ
u'زَالَ قَوْلٌ':Predicate, #1: 1	أَزَالَ الْقَوْلَ
u'زَالَ قَيْدٌ':Subject, #1: 1	أَزَالَ الْقَوْلَ
u'زَالَ قَيْدٌ':Subject, #1: 1	زَالَ الْقَيْدُ
u'زَالَ كَاتِبٌ':Subject, #1: 1	زَالَ قَيْدُ
u'زَالَ كفر':Subject, #1: 1	زَالَ كَاتِبُهُ
u'زَالَ كُفْرٌ':Subject, #5: 5	زَالَ الْكُفْرُ
u'زَالَ لبس':Predicate, #5: 5	زَالَ الْكُفْرُ
u'زَالَ لَبْسٌ':Predicate, #1: 1	أَزَالَ اللَّبْسَ
u'زَالَ لُزُومٌ':Subject, #1: 1	أَزَالَ اللَّبْسَ
u'زَالَ لُزُومٌ':Subject, #2: 2	زَالَ اللُّزُومُ
u'زَالَ لَفْظٌ':Subject, #2: 2	زَالَ لُزُومُهُ
u'زَالَ لَوْنٌ':Predicate, #1: 1	زَالَ اللّفْظُ
u'زَالَ مَالٌ':Subject, #1: 1	أَزَالَ لَوْنَ
u'زَالَ مَانِعٌ':Subject, #1: 1	زَالَ مَالُهُ
u'زَالَ مَانِعٌ':Subject, #2: 2	زَالَ مَانِعُهُ
u'زَالَ مُبِيحٌ':Subject, #60: 60	زَالَ الْمَانِعُ
u'زَالَ مَبِيعٌ':Predicate, #2: 2	زَالَ الْمُبِيحُ
u'زَالَ مُحَابَاةٌ':Predicate, #2: 2	أَزَالَ الْمَبِيعَ
u'زَالَ مُرَجِّحٌ':Subject, #3: 3	أَزَالَ الْمُحَابَاةَ
u'زَالَ مَرَضٌ':Subject, #1: 1	زَالَ الْمُرَجِّحُ
u'زَالَ مَرَضٌ':Subject, #10: 10	زَالَ الْمَرَضُ
u'زَالَ مُسِيءٌ':Subject, #4: 4	زَالَ مَرَضُهُ
u'زَالَ مُغَيَّرٌ':Subject, #2: 2	زَالَ الْمُسِيءُ
u'زَالَ مَلَكٌ':Predicate, #1: 1	زَالَ الْمُغَيَّرُ
u'زَالَ مِلْكٌ':Predicate, #1: 1	زَالَ مَلَكَ
u'زَالَ مِلْكٌ':Predicate, #2: 2	أَزَالَ مِلْكَ
u'زَالَ مِلْكٌ':Subject, #3: 3	أَزَالَ الْمِلْكَ
u'زَالَ مَلَكٌ':Subject, #16: 16	زَالَ الْمِلْكُ
u'زَالَ مِلْكٌ':Subject, #1: 1	زَالَ مَلَكٌ
u'زَالَ مِلْكٌ':Subject, #24: 24	زَالَ مِلْكُ
u'زَالَ مَمْسُوح':Subject, #56: 56	زَالَ مِلْكُهُ
u'زَالَ مَنِيٌّ':Subject, #1: 1	زَالَ الْمَمْسُوحُ
u'زَالَ مُوجِبٌ':Subject, #1: 1	زَالَ الْمَنِيُّ
u'زَالَ مُؤَجِّرٌ':Subject, #2: 2	زَالَ الْمُوجِبُ
u'زَالَ مَوْصُوفٌ':Subject, #1: 1	أَزَالَ الْمُؤَجِّرُ
u'زَالَ مَوْضِعٌ':Subject, #1: 1	زَالَ الْمَوْصُوفُ
u'زَالَ مَوْهُوبٌ':Subject, #1: 1	زَالَ مَوْضِعُ
u'زَالَ نَاسٌ':Subject, #1: 1	زَالَ الْمَوْهُوبُ
u'زَالَ نَجَاسَةٌ':Predicate, #3: 3	زَالَ النَّاسُ
u'زَالَ نَجَسٌ':Subject, #2: 2	أَزَالَ النَّجَاسَةَ
u'زَالَ نُطْقٌ':Predicate, #1: 1	زَالَ النَّجَسُ
u'زَالَ نَقْصٌ':Subject, #1: 1	أَزَالَ النُّطْقَ
u'زَالَ نَقْصٌ':Subject, #2: 2	زَالَ النَّقْصُ
u'زَالَ نُقْصَانٌ':Predicate, #2: 2	زَالَ نَقْصُ
u'زَالَ نُقْصَانٌ':Subject, #1: 1	أَزَالَ النُّقْصَانَ
u'زَالَ نَقْضٌ':Subject, #1: 1	زَالَ النُّقْصَانُ
u'زَالَ نكاح':Subject, #1: 1	زَالَ نَقْضُ
u'زَالَ نِكَاحٌ':Subject, #5: 5	زَالَ النِّكَاحُ
u'زَالَ نهار':Subject, #5: 5	زَالَ النِّكَاحُ
u'زَالَ نَهَارٌ':Subject, #2: 2	زَالَ النَّهَارُ
u'زَالَ نَهْيٌ':Subject, #2: 2	زَالَ النَّهَارُ
u'زَالَ وَجَعٌ':Subject, #1: 1	زَالَ النَّهْيُ
u'زَالَ وَجْهٌ':Subject, #1: 1	زَالَ الْوَجَعُ
u'زَالَ وُجُوبٌ':Subject, #1: 1	زَالَ وَجْهُ
u'زَالَ ورق':Predicate, #1: 1	زَالَ وُجُوبُهُ
u'زَالَ وَرَقٌ':Predicate, #1: 1	أَزَالَ وَرَقَ
u'زَالَ وَصْفٌ':Predicate, #1: 1	أَزَالَ وَرَقَ
u'زَالَ وَصْفٌ':Subject, #1: 1	أَزَالَ الْوَصْفَ
u'زَالَ وِلاَيَةٌ':Predicate, #1: 1	زَالَ الْوَصْفُ
u'زَالَ وَلِيٌّ':Subject, #1: 1	أَزَالَ الْوِلَايَةَ
u'زَالَ يَدٌ':Predicate, #1: 1	أَزَالَ الْوَلِيُّ
u'زَالَ يَدٌ':Subject, #1: 1	أَزَالَ يَدَ
u'زَالَ يُسْرٌ':Subject, #1: 1	زَالَ يَدُ
u'زَالَ يَمِينٌ':Subject, #1: 1	زَالَ الْيُسْرُ
u'زَاوَلَ فِقْهٌ':Predicate, #1: 1	زَالَ الْيَمِينُ
u'زَايَلَ بدن':Predicate, #1: 1	زَاوَلَ الْفِقْهَ
u'زَايَلَ بَدَنٌ':Predicate, #1: 1	زَايَلَ الْبَدَنَ
u'زَايَلَ رِيقٌ':Subject, #1: 1	زَايَلَ الْبَدَنَ
u'زَايَلَ عُضْوٌ':Predicate, #1: 1	زَايَلَ رِيقُهُ
u'زَايَلَ مَقْعَدٌ':Subject, #7: 7	زَايَلَ الْعُضْوَ
u'زَايَلَ مَنِيٌّ':Predicate, #1: 1	زَايَلَ مَقْعَدُهُ
u'زَجْرٌ أَسَدٌ':Added, #2: 2	زَايَلَ الْمَنِيَّ
u'زَجْرٌ أمثال':Added, #1: 1	زَجْرُ الْأَسَدِ
u'زَجْرٌ أَمْثَالٌ':Added, #1: 1	زَجْرَ أَمْثَالِهِ
u'زَجْرٌ أمراء':Added, #1: 1	زَجْرَ أَمْثَالِهِ
u'زَجْرٌ حكمة':Added, #1: 1	زَجْرُ الْأُمَرَاءِ
u'زَجْرٌ حِكْمَةٌ':Added, #1: 1	زَجْرِ الْحِكْمَةِ
u'زَجْرٌ خَيْلٌ':Added, #1: 1	زَجْرِ الْحِكْمَةِ
u'زَجَرَ رَسُولٌ':Subject, #2: 2	زَجْرِ الْخَيْلِ
u'زَجْرٌ زاجِرٌ':Added, #1: 1	زَجَرَ رَسُولُ
u'زَجْرٌ طَيْرٌ':Added, #1: 1	زَجْرِ زَاجِرٍ
u'زَجْرٌ عُصَاةٌ':Added, #3: 3	زَجْرُ الطَّيْرِ
u'زَجْرٌ غير':Added, #1: 1	زَجْرِ الْعُصَاةِ
u'زَجْرٌ غَيْرٌ':Added, #2: 2	زَجْرَ غَيْرِهِ
u'زَجْرٌ فَارٌّ':Added, #2: 2	زَجْرَ غَيْرِهِ
u'زَجْرٌ قَطْعٌ':Added, #1: 1	زَجْرُ الْفَارِّ
u'زَجَرَ قَوْمٌ':Predicate, #1: 1	زَجْرِ الْقَطْعِ
u'زَجَرَ كَلْبٌ':Predicate, #2: 2	زَجَرَ الْقَوْمَ
u'زَجَرَ كَلْبٌ':Predicate, #1: 1	زَجَرَ الْكَلْبَ
u'زَجْرٌ مَجُوسِيٌّ':Added, #1: 1	زَجَرَ كَلْبَ
u'زَجْرٌ مُحْرِمٌ':Added, #1: 1	زَجْرَ الْمَجُوسِيِّ
u'زَجَرَ نَبِيٌّ':Subject, #2: 2	زَجْرَ الْمُحْرِمِ
u'زَجْرٌ نَفْسٌ':Added, #1: 1	زَجَرَ النَّبِيُّ
u'زَجْرٌ نَفْسٌ':Added, #1: 1	زَجْرُ النَّفْسِ
u'زَجَلٌ مَلاَئِكَةٌ':Added, #1: 1	زَجْرِ نَفْسِهِ
u'زَحَفَ عَلِيٌّ':Predicate, #1: 1	زَجَلَ الْمَلَائِكَةِ
u'زَحْمَةٌ نَاسٌ':Added, #1: 1	أَزْحَفَ عَلِيَّ
u'زَحَمَ حَظٌّ':Predicate, #1: 1	زَحْمَةِ النَّاسِ
u'زَحْمٌ مُرْتَهِنٌ':Added, #1: 1	زَحَمَ حَظَّ
u'زَحَمَ نَاسٌ':Predicate, #1: 1	زَحْمِ الْمُرْتَهِنِ
u'زَخْرَفَةٌ مَسَاجِدُ':Added, #1: 1	زَحَمَ النَّاسَ
u'زَخْرَفَةٌ مَسْجِدٌ':Added, #3: 3	زَخْرَفَةُ الْمَسَاجِدِ
u'زَخْرَفَةٌ مُصْحَفٌ':Added, #1: 1	زَخْرَفَةِ الْمَسْجِدِ
u'زَرْعٌ أبطأ':Added, #1: 1	زَخْرَفَةِ الْمُصْحَفِ
u'زَرَعَ أحَدٌ':Subject, #2: 2	زَرْعِ الْأَبْطَأِ
u'زَرْعٌ أحَدٌ':Added, #2: 2	زَرَعَ أَحَدُ
u'زَرَعَ أرْضٌ':Predicate, #1: 1	زَرْعَ أَحَدِ
u'زَرَعَ أرْضٌ':Predicate, #11: 11	زَرَعَ الْأَرْضَ
u'زَرْعٌ أرْضٌ':Added, #13: 13	زَرَعَ أَرْضَ
u'زَرْعٌ أرْضٌ':Added, #1: 1	زَرْعُ الْأَرْضِ
u'زَرْعٌ أرْضٌ':Added, #2: 2	زَرْعَ الْأَرْضِ
u'زَرْعٌ أَسْفَلُ':Added, #6: 6	زَرْعِ الْأَرْضِ
u'زَرْعٌ إِنْسانٌ':Added, #1: 1	زَرْعُ الْأَسْفَلِ
u'زَرْعٌ بَائِعٌ':Added, #5: 5	زَرْعَ إنْسَانٍ
u'زَرْعٌ بَائِعٌ':Added, #1: 1	زَرْعِ الْبَائِعِ
u'زَرَعَ بَذْرٌ':Predicate, #2: 2	زَرْعُ الْبَائِعِ
u'زَرْعٌ بُرٌّ':Added, #2: 2	زَرَعَ بَذْرَ
u'زَرَعَ بِزْرٌ':Predicate, #1: 1	زَرْعِ بُرٍّ
u'زَرَعَ بَعْضٌ':Predicate, #1: 1	زَرَعَ بِزْرَ
u'زَرَعَ بَعْضٌ':Predicate, #1: 1	زَرَعَ الْبَعْضَ
u'زَرْعٌ بَعْضٌ':Added, #1: 1	زَرَعَ بَعْضَ
u'زَرْعٌ بَقْلٌ':Added, #1: 1	زَرْعَ بَعْضِ
u'زَرْعٌ بَقْلٌ':Added, #1: 1	زَرْعُ بَقْلٍ
u'زَرْعٌ بَيَاضٌ':Added, #1: 1	زَرْعِ بَقْلٍ
u'زَرَعَ ثَالِثٌ':Predicate, #1: 1	زَرْعِ الْبَيَاضِ
u'زَرَعَ ثَانِي':Predicate, #1: 1	زَرَعَ الثَّالِثَ
u'زَرَعَ ثَلاثَةٌ':Predicate, #2: 2	زَرَعَ الثَّانِيَ
u'زَرْعٌ جَارٌ':Added, #1: 1	زَرَعَ ثَلَاثَةَ
u'زَرْعٌ جَانِبٌ':Added, #3: 3	زَرْعِ جَارِهِ
u'زَرَعَ حَصَدٌ':Predicate, #1: 1	زَرْعِ جَانِبٍ
u'زَرَعَ حِنْطَةٌ':Predicate, #1: 1	زَرَعَ حَصَدَ
u'زَرْعٌ حِنْطَةٌ':Added, #1: 1	زَرَعَ الْحِنْطَةَ
u'زَرْعٌ حِنْطَةٌ':Added, #1: 1	زَرْعَ الْحِنْطَةِ
u'زَرْعٌ حِنْطَةٌ':Added, #2: 2	زَرْعُ الْحِنْطَةِ
u'زَرْعٌ دَخَنٌ':Added, #2: 2	زَرْعِ الْحِنْطَةِ
u'زَرْعٌ دَخَنٌ':Added, #1: 1	زَرْعُ الدَّخَنِ
u'زَرْعٌ رَبُّ':Added, #1: 1	زَرْعِ الدَّخَنِ
u'زَرْعٌ رَجُلٌ':Added, #1: 1	زَرْعِ رَبِّ
u'زَرْعٌ رَجُلٌ':Added, #1: 1	زَرْعَ الرَّجُلِ
u'زَرْعٌ رَجُلٌ':Added, #1: 1	زَرْعَ رَجُلٍ
u'زَرْعٌ رَعِيَّةٌ':Added, #2: 2	زَرْعِ رَجُلٍ
u'زَرْعٌ سَنَةٌ':Added, #1: 1	زَرْعِ الرَّعِيَّةِ
u'زَرْعٌ شَرِيكٌ':Added, #1: 1	زَرْعِ السَّنَةِ
u'زَرْعٌ شَعِيرٌ':Added, #2: 2	زَرْعُ شَرِيكِهِ
u'زَرْعٌ شَعِيرٌ':Added, #1: 1	زَرْعِ الشَّعِيرِ
u'زَرْعٌ شَيْءٌ':Added, #2: 2	زَرْعُ الشَّعِيرِ
u'زَرْعٌ صَاحِبٌ':Added, #2: 2	زَرْعِ شَيْءٍ
u'زَرْعٌ صَاحِبٌ':Added, #1: 1	زَرْعُ صَاحِبِ
u'زَرَعَ صِنْفٌ':Predicate, #1: 1	زَرْعِ صَاحِبِ
u'زَرْعٌ صَيْفٌ':Added, #1: 1	زَرَعَ الصِّنْفَ
u'زَرْعٌ ظاهِرٌ':Added, #1: 1	زَرْعِ الصَّيْفِ
u'زَرْعٌ عَامٌ':Added, #1: 1	زَرْعٍ ظَاهِرٍ
u'زَرْعٌ عَامٌ':Added, #1: 1	زَرْعَ عَامٍ
u'زَرْعٌ عَامٌ':Added, #1: 1	زَرْعُ عَامٍ
u'زَرَعَ عَامِلٌ':Subject, #2: 2	زَرْعُ الْعَامِ
u'زَرَعَ عَبْدٌ':Subject, #3: 3	زَرَعَ الْعَامِلُ
u'زَرَعَ غَاصِبٌ':Subject, #1: 1	زَرَعَ الْعَبْدُ
u'زَرْعٌ غَاصِبٌ':Added, #3: 3	زَرَعَ الْغَاصِبُ
u'زَرْعٌ غَاصِبٌ':Added, #2: 2	زَرْعَ الْغَاصِبِ
u'زَرْعٌ غَاصِبٌ':Added, #2: 2	زَرْعُ الْغَاصِبِ
u'زَرَعَ غير':Predicate, #7: 7	زَرْعِ الْغَاصِبِ
u'زَرَعَ غَيْرٌ':Predicate, #1: 1	زَرَعَ غَيْرَ
u'زَرْعٌ غير':Added, #1: 1	زَرَعَ غَيْرَ
u'زَرْعٌ غَيْرٌ':Added, #1: 1	زَرْعُ غَيْرِهِ
u'زَرْعٌ غير':Added, #1: 1	زَرْعُ غَيْرِهِ
u'زَرْعٌ غَيْرٌ':Added, #28: 28	زَرْعَ غَيْرِهِ
u'زَرْعٌ غير':Added, #28: 28	زَرْعَ غَيْرِهِ
u'زَرْعٌ غَيْرٌ':Added, #5: 5	زَرْعِ غَيْرِهِ
u'زَرَعَ فُلاَنٌ':Subject, #5: 5	زَرْعِ غَيْرِهِ
u'زَرْعٌ فُلاَنٌ':Added, #1: 1	زَرَعَ فُلَانٌ
u'زَرْعٌ فُلاَنٌ':Added, #1: 1	زَرْعُ فُلاَنٍ
u'زَرْعٌ قَائِمٌ':Added, #2: 2	زَرْعِ فُلَانٍ
u'زَرَعَ قَدْرٌ':Predicate, #2: 2	زَرْعٍ قَائِمٍ
u'زَرْعٌ قطعة':Added, #3: 3	زَرَعَ قَدْرَ
u'زَرْعٌ قِطْعَةٌ':Added, #1: 1	زَرْعَ قِطْعَةٍ
u'زَرَعَ مَالِكٌ':Subject, #1: 1	زَرْعَ قِطْعَةٍ
u'زَرْعٌ مَالِكٌ':Added, #1: 1	زَرَعَ الْمَالِكُ
u'زَرَعَ مُزَارِعٌ':Subject, #2: 2	زَرْعُ الْمَالِكِ
u'زَرْعٌ مَزَارِعُ':Added, #2: 2	زَرَعَ الْمُزَارِعُ
u'زَرْعٌ مُسْتَأْجِرٌ':Added, #1: 1	زَرْعُ الْمَزَارِعِ
u'زَرَعَ مُسْلِمٌ':Subject, #1: 1	زَرْعَ الْمُسْتَأْجِرِ
u'زَرْعٌ مُشْتَرَكٌ':Added, #1: 1	زَرَعَ الْمُسْلِمُ
u'زَرْعٌ مَضْمُومٌ':Added, #1: 1	زَرْعٍ مُشْتَرَكٍ
u'زَرْعٌ مُفْلِسٌ':Added, #1: 1	زَرْعِ الْمَضْمُومِ
u'زَرَعَ مِلْكٌ':Predicate, #1: 1	زَرْعِ الْمُفْلِسِ
u'زَرْعٌ مَوْجُودٌ':Added, #3: 3	زَرَعَ مِلْكَ
u'زَرْعٌ مَوْضِعٌ':Added, #2: 2	زَرْعٍ مَوْجُودٍ
u'زَرْعٌ نَابِتٌ':Added, #2: 2	زَرْعَ مَوْضِعٍ
u'زَرَعَ نِصْفٌ':Predicate, #1: 1	زَرْعٍ نَابِتٍ
u'زَرَعَ نِصْفٌ':Predicate, #1: 1	زَرَعَ نِصْفَ
u'زَرْعٌ واحد':Added, #2: 2	زَرَعَ النِّصْفَ
u'زَرْعٌ وَاحِدٌ':Added, #5: 5	زَرْعٍ وَاحِدٍ
u'زَرَعَ وَاقِفٌ':Subject, #5: 5	زَرْعٍ وَاحِدٍ
u'زَرْعٌ وِزَاغٌ':Added, #1: 1	زَرَعَ الْوَاقِفُ
u'زَرَّ قَبَاءٌ':Predicate, #1: 1	زَرْعٍ وِزَاغٍ
u'زَعَجَ مَالِكٌ':Predicate, #1: 1	زَرَّ الْقَبَاءَ
u'زَعِجَ مَالِكٌ':Predicate, #1: 1	أَزْعَجَ الْمَالِكَ
u'زَعْمٌ أَبٌ':Added, #1: 1	أَزْعَجَ الْمَالِكَ
u'زَعَمَ إبَاحَةٌ':Predicate, #1: 1	زَعْمِ الْأَبِ
u'زَعَمَ اِبْنٌ':Subject, #1: 1	زَعَمَ إبَاحَةَ
u'زَعَمَ أحَدٌ':Subject, #17: 17	زَعَمَ ابْنُ
u'زَعَمَ إمَامٌ':Subject, #1: 1	زَعَمَ أَحَدُ
u'زَعَمَ إمَامٌ':Subject, #1: 1	زَعَمَ الْإِمَامُ
u'زَعْمٌ إمَامٌ':Added, #4: 4	زَعَمَ إمَامُ
u'زَعْمٌ إمَامٌ':Added, #1: 1	زَعْمَ الْإِمَامِ
u'زَعْمٌ إمَامٌ':Added, #1: 1	زَعْمُ الْإِمَامِ
u'زَعَمَ أهْلٌ':Subject, #4: 4	زَعْمِ الْإِمَامِ
u'زَعَمَ أَوَّلُ':Subject, #5: 5	زَعَمَ أَهْلُ
u'زَعَمَ بَائِعٌ':Subject, #2: 2	زَعَمَ الْأَوَّلُ
u'زَعْمٌ بَائِعٌ':Added, #2: 2	زَعَمَ الْبَائِعُ
u'زَعَمَ بَعْضٌ':Subject, #1: 1	زَعْمِ الْبَائِعِ
u'زَعَمَ بَقّار':Subject, #13: 13	زَعَمَ بَعْضُ
u'زَعَمَ تَحَتُّمٌ':Predicate, #1: 1	زَعَمَ الْبَقَّارُ
u'زَعَمَ ثَابِتٌ':Subject, #1: 1	زَعَمَ تَحَتُّمَ
u'زَعْمٌ جَاهِلِيٌّ':Added, #1: 1	زَعَمَ ثَابِتٌ
u'زَعْمٌ جَاهِلِيَّةٌ':Added, #1: 1	زَعْمُ الْجَاهِلِيَّةِ
u'زَعَمَ جَمَاعَةٌ':Subject, #1: 1	زَعْمُ الْجَاهِلِيَّةِ
u'زَعَمَ جمع':Subject, #1: 1	زَعَمَ جَمَاعَةٌ
u'زَعَمَ جَمْعٌ':Subject, #1: 1	زَعَمَ جَمْعُ
u'زَعَمَ حافِظٌ':Subject, #1: 1	زَعَمَ جَمْعُ
u'زَعَمَ حالِق':Subject, #1: 1	زَعَمَ الْحَافِظُ
u'زَعَمَ حَسَنٌ':Subject, #1: 1	زَعَمَ الْحَالِقُ
u'زَعَمَ حَقِيقٌ':Predicate, #1: 1	زَعَمَ الْحَسَنُ
u'زَعَمَ حَقِيقَةٌ':Predicate, #1: 1	زَعَمَ حَقِيقَةَ
u'زَعَمَ حِلٌّ':Predicate, #1: 1	زَعَمَ حَقِيقَةَ
u'زَعَمَ حِنْثٌ':Predicate, #3: 3	زَعَمَ حِلَّ
u'زَعَمَ خاصّ':Subject, #1: 1	زَعَمَ الْحِنْثَ
u'زَعَمَ خَصْمٌ':Subject, #1: 1	زَعَمَ خَاصٌّ
u'زَعَمَ خَلِيلٌ':Subject, #1: 1	زَعَمَ الْخَصْمُ
u'زَعَمَ رَافِعٌ':Subject, #1: 1	زَعَمَ الْخَلِيلُ
u'زَعَمَ رَافِعٌ':Subject, #2: 2	زَعَمَ رَافِعٌ
u'زَعَمَ رَاهِنٌ':Subject, #2: 2	زَعَمَ رَافِعُ
u'زَعَمَ رَبِيعٌ':Subject, #1: 1	زَعَمَ الرَّاهِنُ
u'زَعَمَ رَجُلٌ':Subject, #1: 1	زَعَمَ الرَّبِيعُ
u'زَعَمَ زاعِم':Subject, #4: 4	زَعَمَ رَجُلٌ
u'زَعْمٌ زاعِم':Added, #4: 4	زَعَمَ زَاعِمٌ
u'زَعَمَ زَوْجٌ':Subject, #2: 2	زَعْمِ الزَّاعِمِ
u'زَعَمَ زِيادَةٌ':Predicate, #2: 2	زَعَمَ الزَّوْجُ
u'زَعْمٌ سَارِقٌ':Added, #1: 1	زَعَمَ زِيَادَةَ
u'زَعَمَ شَارِحٌ':Subject, #2: 2	زَعْمِ السَّارِقِ
u'زَعَمَ شافِعِيّ':Subject, #1: 1	زَعَمَ الشَّارِحُ
u'زَعْمٌ شَاهِدٌ':Added, #1: 1	زَعَمَ الشَّافِعِيُّ
u'زَعْمٌ شَاهِدٌ':Added, #1: 1	زَعْمِ الشَّاهِدَيْنِ
u'زَعَمَ شُرَّاحٌ':Subject, #2: 2	زَعْمِ الشَّاهِدِ
u'زَعَمَ شَرِيكٌ':Subject, #1: 1	زَعَمَ شُرَّاحُهُ
u'زَعَمَ شَيْخٌ':Subject, #1: 1	زَعَمَ الشَّرِيكُ
u'زَعَمَ صَاحِبٌ':Subject, #1: 1	زَعَمَ الشَّيْخُ
u'زَعْمٌ صَدْرٌ':Added, #5: 5	زَعَمَ صَاحِبُ
u'زَعْمٌ طَاعِنٌ':Added, #1: 1	زَعْمُ صَدْرِ
u'زَعَمَ طَبَرِيّ':Subject, #1: 1	زَعْمِ الطَّاعِنِ
u'زَعَمَ عَبْدٌ':Subject, #1: 1	زَعَمَ الطَّبَرِيُّ
u'زَعْمٌ عَبْدٌ':Added, #1: 1	زَعَمَ عَبْدُ
u'زَعْمٌ عَرَبٌ':Added, #1: 1	زَعْمِ الْعَبْدِ
u'زَعَمَ عُرْوَةٌ':Subject, #1: 1	زَعْمِ الْعَرَبِ
u'زَعَمَ عَطَاءٌ':Subject, #1: 1	زَعَمَ عُرْوَةُ
u'زَعَمَ عُمَرٌ':Subject, #2: 2	زَعَمَ عَطَاءٌ
u'زَعْمٌ غَرِيمٌ':Added, #1: 1	زَعَمَ عُمَرُ
u'زَعَمَ غير':Predicate, #1: 1	زَعْمِ غَرِيمِهِ
u'زَعَمَ غَيْرٌ':Predicate, #1: 1	زَعَمَ غَيْرَ
u'زَعْمٌ غير':Added, #1: 1	زَعَمَ غَيْرَ
u'زَعْمٌ غَيْرٌ':Added, #1: 1	زَعْمُ غَيْرِهِ
u'زَعَمَ فساد':Predicate, #1: 1	زَعْمُ غَيْرِهِ
u'زَعَمَ فَسَادٌ':Predicate, #2: 2	زَعَمَ فَسَادَ
u'زَعَمَ فلان':Subject, #2: 2	زَعَمَ فَسَادَ
u'زَعَمَ فلان':Subject, #1: 1	زَعَمَ الشَّافِعِيُّ
u'زَعَمَ فُلاَنٌ':Subject, #1: 1	زَعَمَ الطَّبَرِيُّ
u'زَعَمَ قُرَيْشٌ':Subject, #1: 1	زَعَمَ فُلَانٌ
u'زَعَمَ قَوْمٌ':Subject, #1: 1	زَعَمَ قُرَيْشُ
u'زَعَمَ قَوْمٌ':Subject, #2: 2	زَعَمَ الْقَوْمُ
u'زَعَمَ كُفَّارٌ':Subject, #4: 4	زَعَمَ قَوْمٌ
u'زَعْمٌ كَفِيلٌ':Added, #1: 1	زَعَمَ الْكُفَّارُ
u'زَعَمَ لِصٌّ':Subject, #5: 5	زَعْمِ الْكَفِيلِ
u'زَعْمٌ مُجْتَهِد':Added, #1: 1	زَعَمَ اللِّصُّ
u'زَعَمَ مَجْدٌ':Subject, #2: 2	زَعْمِ الْمُجْتَهِدِ
u'زَعَمَ مُحَمَّدٌ':Subject, #1: 1	زَعَمَ الْمَجْدُ
u'زَعَمَ مُحَمَّدٌ':Subject, #1: 1	زَعَمَ مُحَمّدٌ
u'زَعْمٌ مُخَالَفَةٌ':Added, #1: 1	زَعَمَ مُحَمّدُ
u'زَعَمَ مَدِينٌ':Subject, #1: 1	زَعْمِ مُخَالَفَةِ
u'زَعَمَ مَدْيُونٌ':Subject, #1: 1	زَعَمَ الْمَدِينُ
u'زَعْمٌ مُرْتَهِنٌ':Added, #2: 2	زَعَمَ الْمَدْيُونُ
u'زَعَمَ مَطِيَّةٌ':Subject, #3: 3	زَعْمِ الْمُرْتَهِنِ
u'زَعْمٌ مُقْرِضٌ':Added, #1: 1	زَعَمَ مَطِيَّةُ
u'زَعَمَ مَقْطُوعٌ':Subject, #1: 1	زَعْمُ الْمُقْرِضِ
u'زَعْمٌ مُنْكَرٌ':Added, #1: 1	زَعَمَ الْمَقْطُوعُ
u'زَعْمٌ مُنْكِرٌ':Added, #1: 1	زَعْمُ الْمُنْكَرِ
u'زَعَمَ مُوجِبٌ':Subject, #4: 4	زَعْمِ الْمُنْكِرِ
u'زَعْمٌ مُودِعٌ':Added, #1: 1	زَعَمَ الْمُوجِبُ
u'زَعَمَ نَاسٌ':Subject, #1: 1	زَعْمِ الْمُودِعِ
u'زَعَمَ نَاسٌ':Subject, #1: 1	زَعَمَ النَّاسُ
u'زَعَمَ نُعْمَانُ':Subject, #1: 1	زَعَمَ نَاسٌ
u'زَعَمَ نَوَوِيٌّ':Subject, #1: 1	زَعَمَ النُّعْمَانُ
u'زَعَمَ وَارِثٌ':Subject, #1: 1	زَعَمَ النَّوَوِيُّ
u'زَعْمٌ وَالِدٌ':Added, #1: 1	زَعَمَ الْوَارِثُ
u'زَعَمَ وَرَثَةٌ':Subject, #1: 1	زَعْمِ وَالِدِهِ
u'زَعَمَ وَصِيٌّ':Subject, #1: 1	زَعَمَ الْوَرَثَةُ
u'زَعَمَ وَكِيلٌ':Subject, #1: 1	زَعَمَ الْوَصِيُّ
u'زَعْمٌ وَكِيلٌ':Added, #2: 2	زَعَمَ الْوَكِيلُ
u'زَعَمَ وَلِيٌّ':Subject, #1: 1	زَعْمِ الْوَكِيلِ
u'زَعْمٌ وَلِيٌّ':Added, #1: 1	زَعَمَ الْوَلِيُّ
u'زَعْمٌ وَلِيٌّ':Added, #1: 1	زَعْمَ الْوَلِيِّ
u'زَغَبٌ رِيشٌ':Added, #1: 1	زَعْمِ الْوَلِيِّ
u'زَغَبٌ رِيشٌ':Added, #1: 1	زَغَبَ الرِّيشِ
u'زَغَبٌ طَيْرٌ':Added, #1: 1	زَغَبِ الرِّيشِ
u'زَكَا زَرْعٌ':Subject, #1: 1	زَغَبِ الطّيْرِ
u'زَكَّى أحَدٌ':Predicate, #4: 4	زَكَا الزَّرْعُ
u'زَكَّى أحَدٌ':Subject, #2: 2	زَكَّى أَحَدَ
u'زَكَّى أرْضٌ':Predicate, #1: 1	زَكَّى أَحَدُ
u'زَكَّى أصل':Predicate, #1: 1	زَكَّى الْأَرْضَ
u'زَكَّى أًصْلٌ':Predicate, #1: 1	زَكَّى الْأَصْلَ
u'زَكَّى أَمْوَالٌ':Predicate, #1: 1	زَكَّى الْأَصْلَ
u'زَكَّى أَوَّلُ':Predicate, #1: 1	زَكَّى أَمْوَالَ
u'زَكَّى باقِي':Predicate, #1: 1	زَكَّى الْأَوَّلَ
u'زَكَّى بَائِعٌ':Subject, #4: 4	زَكَّى الْبَاقِيَ
u'زَكَّى بَعْضٌ':Predicate, #3: 3	زَكَّى الْبَائِعُ
u'زَكَّى تُسْعٌ':Predicate, #1: 1	زَكَّى بَعْضَ
u'زَكَّى ثَانِي':Predicate, #1: 1	زَكَّى تُسْعَ
u'زَكَّى ثَانِيَةٌ':Predicate, #1: 1	زَكَّى الثَّانِيَةَ
u'زَكَّى ثَلاثَةٌ':Predicate, #1: 1	زَكَّى الثَّانِيَةَ
u'زَكَّى ثَمَرَةٌ':Predicate, #1: 1	زَكَّى الثَّلَاثَةَ
u'زَكَّى ثَمَنٌ':Predicate, #1: 1	زَكَّى الثَّمَرَةَ
u'زَكَّى جَازٌ':Predicate, #8: 8	زَكَّى الثَّمَنَ
u'زَكَّى جَمِيع':Predicate, #2: 2	زَكَّى جَازَ
u'زَكَّى حُرٌّ':Subject, #3: 3	زَكَّى الْجَمِيعَ
u'زَكَّى دِينارٌ':Predicate, #1: 1	زَكَّى الْحُرُّ
u'زَكَّى رِبْحٌ':Predicate, #3: 3	زَكَّى الدِّينَارَ
u'زَكَّى رُبْعٌ':Predicate, #2: 2	زَكَّى الرِّبْحَ
u'زَكَّى رِقابٌ':Predicate, #2: 2	زَكَّى رُبْعَ
u'زَكَّى زائِدٌ':Predicate, #2: 2	زَكَّى الرِّقَابَ
u'زَكَّى سَيِّدٌ':Subject, #2: 2	زَكَّى الزَّائِدَ
u'زَكَّى شَاهِدٌ':Predicate, #1: 1	زَكَّى سَيِّدُ
u'زَكَّى شُهُودٌ':Predicate, #1: 1	زَكَّى الشَّاهِدَ
u'زَكَّى شُهُودٌ':Predicate, #1: 1	زَكَّى الشُّهُودَ
u'زَكَّى شُهُودٌ':Subject, #2: 2	زَكَّى شُهُودَ
u'زَكِيَ عند':Predicate, #2: 2	زَكَّى الشُّهُودُ
u'زَكَّى فَاضِلٌ':Predicate, #9: 9	أَزْكَى عِنْدَ
u'زَكَّى قِيمَةٌ':Predicate, #2: 2	زَكَّى الْفَاضِلَ
u'زَكَّى مَاشِي':Predicate, #2: 2	زَكَّى قِيمَةَ
u'زَكَّى مَالٌ':Predicate, #1: 1	زَكَّى مَاشِيَةً
u'زَكَّى مُدِيرٌ':Subject, #3: 3	زَكَّى الْمَالَ
u'زَكَّى مَرْدُودٌ':Subject, #1: 1	زَكَّى الْمُدِيرُ
u'زَكَّى مُسْتَخْرَجٌ':Predicate, #1: 1	زَكَّى الْمَرْدُودُ
u'زَكَّى مَقْبُوضٌ':Predicate, #1: 1	زَكَّى الْمُسْتَخْرَجَ
u'زَكَّى مَوْجُودٌ':Predicate, #1: 1	زَكَّى الْمَقْبُوضَ
u'زَكَّى نِصْفٌ':Predicate, #2: 2	زَكَّى الْمَوْجُودَ
u'زَكَّى نَقْدٌ':Predicate, #1: 1	زَكَّى النِّصْفَ
u'زَكَّى نَقْد':Predicate, #2: 2	زَكَّى النَّقْدَ
u'زَلَّ بَعْضٌ':Subject, #2: 2	زَكَّى النَّقْدَ
u'زَلَّةٌ عَالَمٌ':Added, #1: 1	زَلَّ بَعْضُ
u'زَلَّةٌ عَالِمٌ':Added, #1: 1	زَلَّةُ عَالَمٍ
u'زَلَّةٌ عَالِمٌ':Added, #1: 1	زَلَّةِ عَالِمٍ
u'زَلَّةٌ عَالِمٌ':Added, #2: 2	زَلَّةُ عَالِمٍ
u'زَلَّةٌ عَالِمٌ':Added, #4: 4	زَلَّةَ الْعَالِمِ
u'زَلَّةٌ عَالِمٌ':Added, #4: 4	زَلَّةِ الْعَالِمِ
u'زَلَّةٌ غير':Added, #7: 7	زَلَّةُ الْعَالِمِ
u'زَلَّةٌ غَيْرٌ':Added, #1: 1	زَلَّةِ غَيْرِهِ
u'زَلَّةٌ قَارِئٌ':Added, #1: 1	زَلَّةِ غَيْرِهِ
u'زَلَّةٌ قَلَمٌ':Added, #6: 6	زَلَّةِ الْقَارِئِ
u'زَلْزَلَةٌ أرْضٌ':Added, #3: 3	زَلَّةُ قَلَمٍ
u'زَلْزَلَةٌ سَاعَةٌ':Added, #1: 1	زَلْزَلَةِ الْأَرْضِ
u'زَلْزَلَةٌ قُلُوبٌ':Added, #2: 2	زَلْزَلَةَ السَّاعَةِ
u'زَلْزَلَةٌ كَيْلٌ':Added, #1: 1	زَلْزَلَةِ الْقُلُوبِ
u'زَلْزَلَةٌ مَكِيلٌ':Added, #1: 1	زَلْزَلَةِ الْكَيْلِ
u'زَلَّ قدم':Subject, #1: 1	زَلْزَلَةُ الْمَكِيلِ
u'زَلَّ قَدَمٌ':Subject, #1: 1	زَلَّ قَدَمُ
u'زَلَّ قَدَمٌ':Subject, #1: 1	زَلَّ قَدَمُ
u'زَلِقَ رِجْلٌ':Subject, #2: 2	زَلَّ قَدَمٌ
u'زَلَّ قَلَمٌ':Subject, #1: 1	زَلِقَ رِجْلُهُ
u'زَلِقَ مُسْتَعِيرٌ':Subject, #1: 1	زَلَّ قَلَمُهُ
u'زَلَقَ مُسْتَعِيرٌ':Subject, #1: 1	زَلِقَ الْمُسْتَعِيرُ
u'زَلَلٌ علماء':Added, #1: 1	زَلَقَ مُسْتَعِيرُ
u'زَلَلٌ عُلَمَاءُ':Added, #2: 2	زَلَلِ الْعُلَمَاءِ
u'زَلَلٌ علماء':Added, #2: 2	زَلَلِ الْعُلَمَاءِ
u'زَلَلٌ عُلَمَاءُ':Added, #3: 3	زَلَلَ الْعُلَمَاءِ
u'زَلَّ نَظَرٌ':Subject, #3: 3	زَلَلَ الْعُلَمَاءِ
u'زَمْزَمَ اِبْنٌ':Subject, #1: 1	زَلَّ نَظَرُهُ
u'زَمْزَمَ أَرْبَعُ':Predicate, #1: 1	زَمْزَمَ ابْنُ
u'زَمْزَمَ أفْضَلُ':Subject, #1: 1	زَمْزَمَ أَرْبَعَ
u'زَمْزَمَ حافِظٌ':Subject, #2: 2	زَمْزَمَ أَفْضَلُ
u'زَمْزَمَ حَديثٌ':Predicate, #1: 1	زَمْزَمَ الْحَافِظُ
u'زَمْزَمَ رَعْدٌ':Subject, #2: 2	زَمْزَمَ الْحَدِيثَ
u'زَمْزَمَ سِتٌّ':Predicate, #1: 1	زَمْزَمَ الرّعْدُ
u'زَمْزَمَ طعام':Subject, #1: 1	زَمْزَمَ سِتَّ
u'زَمْزَمَ طَعَامٌ':Subject, #1: 1	زَمْزَمَ طَعَامٌ
u'زَمْزَمَ غفر':Predicate, #1: 1	زَمْزَمَ طَعَامٌ
u'زَمْزَمَ غَفَرٌ':Predicate, #1: 1	زَمْزَمَ غَفَرَ
u'زَمْزَمَ قَالٌ':Predicate, #1: 1	زَمْزَمَ غَفَرَ
u'زَمْزَمَ مُخْتَلَفٌ':Subject, #4: 4	زَمْزَمَ قَالَ
u'زَمَلَ شَيْءٌ':Predicate, #1: 1	زَمْزَمَ مُخْتَلَفٌ
u'زَمِنَ رَجُلٌ':Subject, #1: 1	زَمَلَ الشَّيْءَ
u'زَمِنَ رِجْلٌ':Subject, #1: 1	زَمِنَ الرَّجُلُ
u'زَمِنَ قَالٌ':Predicate, #1: 1	زَمِنَ رِجْلُهُ
u'زَنْدٌ صَاحِبٌ':Added, #1: 1	زَمِنَ قَالَ
u'زَنْدٌ فِكْرٌ':Added, #1: 1	زَنْدَ صَاحِبِهِ
u'زَنْدٌ قَاطِعٌ':Added, #1: 1	زَنْدَ الْفِكْرِ
u'زَنَى اِبْنٌ':Subject, #1: 1	زَنْدُ الْقَاطِعِ
u'زَنَى أَسيرٌ':Subject, #3: 3	زَنَى ابْنُ
u'زَنَى أَكْثَرُ':Predicate, #2: 2	زَنَى الْأَسِيرُ
u'زَنَى بالِغٌ':Subject, #1: 1	زَنَى أَكْثَرَ
u'زَنَى بالِغٌ':Subject, #1: 1	زَنَى بَالِغٌ
u'زَنَى بِكْرٌ':Subject, #3: 3	زَنَى الْبَالِغُ
u'زَنَى بِكْرٌ':Subject, #2: 2	زَنَى الْبِكْرُ
u'زَنَى جَيْشٌ':Subject, #4: 4	زَنَى بِكْرٌ
u'زَنَى حالٌ':Predicate, #1: 1	زَنَى جَيْشٌ
u'زَنَى حُرٌّ':Subject, #1: 1	زَنَى حَالَ
u'زَنَى حُرٌّ':Subject, #1: 1	زَنَى حُرٌّ
u'زَنَى حَلالٌ':Subject, #2: 2	زَنَى الْحُرُّ
u'زَنَى دَخَلٌ':Predicate, #1: 1	زَنَى حَلَالٌ
u'زَنَى ذِمِّيٌّ':Subject, #1: 1	زَنَى دَخَلَ
u'زَنَى ذِمِّيٌّ':Subject, #5: 5	زَنَى الذِّمِّيُّ
u'زَنَى رَجُلٌ':Subject, #6: 6	زَنَى ذِمِّيٌّ
u'زَنَى رَجُلٌ':Subject, #11: 11	زَنَى رَجُلٌ
u'زَنَى سَفِيهٌ':Subject, #5: 5	زَنَى الرَّجُلُ
u'زَنَى صَائِمٌ':Subject, #1: 1	زَنَى السَّفِيهُ
u'زَنَى صَبِيٌّ':Subject, #1: 1	زَنَى الصَّائِمُ
u'زَنَى صَبِيٌّ':Subject, #4: 4	زَنَى الصَّبِيُّ
u'زَنَى عَبْدٌ':Subject, #4: 4	زَنَى صَبِيٌّ
u'زَنَى عَبْدٌ':Subject, #3: 3	زَنَى عَبْدُهُ
u'زَنَى عند':Predicate, #5: 5	زَنَى الْعَبْدُ
u'زَنَى غَرِيبٌ':Subject, #1: 1	زَنَى عِنْدَ
u'زَنَى غير':Predicate, #1: 1	زَنَى الْغَرِيبُ
u'زَنَى غَيْرٌ':Predicate, #2: 2	زَنَى غَيْرَ
u'زَنَى قَالٌ':Predicate, #2: 2	زَنَى غَيْرَ
u'زَنَى كَافِرٌ':Subject, #4: 4	زَنَى قَالَ
u'زَنَى كَافِرٌ':Subject, #1: 1	زَنَى الْكَافِرُ
u'زَنَى مُحْصَنٌ':Subject, #1: 1	زَنَى كَافِرٌ
u'زَنَى مرٌّ':Predicate, #4: 4	زَنَى مُحْصَنٌ
u'زَنَى مُرَاهِقٌ':Subject, #2: 2	زَنَى مَرَّةً
u'زَنَى مُرْتَدٌّ':Subject, #1: 1	زَنَى مُرَاهِقٌ
u'زَنَى مَرِيضٌ':Subject, #1: 1	زَنَى مُرْتَدٌّ
u'زَنَى مُسْلِمٌ':Subject, #3: 3	زَنَى الْمَرِيضُ
u'زَنَى مُسْلِمٌ':Subject, #2: 2	زَنَى الْمُسْلِمُ
u'زَنَى مَقْذُوفٌ':Subject, #2: 2	زَنَى مُسْلِمٌ
u'زَنَى مَقْطُوعٌ':Subject, #4: 4	زَنَى الْمَقْذُوفُ
u'زَنَى مُكْرَهٌ':Subject, #1: 1	زَنَى مَقْطُوعُ
u'زَنَى مُكْرَهٌ':Subject, #1: 1	زَنَى مُكْرَهٌ
u'زَنَى مَمْلُوكٌ':Subject, #2: 2	زَنَى الْمُكْرَهُ
u'زَنَى واحد':Subject, #1: 1	زَنَى مَمْلُوكُهُ
u'زَنَى وَاحِدٌ':Subject, #1: 1	زَنَى وَاحِدٌ
u'زَنَى يَوْمٌ':Predicate, #1: 1	زَنَى وَاحِدٌ
u'زُهْدٌ جُهَّالٌ':Added, #2: 2	زَنَى يَوْمَ
u'زُهْدٌ خَوَاصُّ':Added, #1: 1	زُهْدُ الْجُهَّالِ
u'زُهْدٌ خَوَاصّ':Added, #1: 1	زُهْدُ الْخَوَاصِّ
u'زُهْدٌ رَسُولٌ':Added, #1: 1	زُهْدُ الْخَوَاصِّ
u'زَهِدَ نَاسٌ':Subject, #1: 1	زُهْدُ رَسُولِ
u'زَهَرَ قَالٌ':Predicate, #1: 1	زَهِدَ النَّاسُ
u'زَهِرَ قَالٌ':Predicate, #8: 8	أَزْهَرَ قَالَ
u'زَهَقَ سَائِرٌ':Predicate, #8: 8	أَزْهَرَ قَالَ
u'زَهْوٌ حائِطٌ':Added, #1: 1	أَزْهَقَ سَائِرَ
u'زَهْوٌ قِنٌّ':Added, #1: 1	زَهْوُ الْحَائِطِ
u'زُهِيَ بَطَلٌ':Predicate, #1: 1	زَهْوَ قِنٍّ
u'زَوَّجَ أَبٌ':Subject, #1: 1	أَزْهَى بَطَلَ
u'زَوَّجَ أَبْعَدُ':Predicate, #25: 25	زَوَّجَ الْأَبُ
u'زَوَّجَ أَبْعَدُ':Subject, #1: 1	زَوَّجَ الْأَبْعَدَ
u'زَوَّجَ اِبْنٌ':Predicate, #10: 10	زَوَّجَ الْأَبْعَدُ
u'زَوَّجَ اِبْنٌ':Subject, #1: 1	زَوَّجَ ابْنَ
u'زَوْجٌ اِبْنٌ':Added, #2: 2	زَوَّجَ ابْنُ
u'زَوَّجَ اِبْنَة':Predicate, #2: 2	زَوْجُ ابْنِ
u'زَوْجٌ اِبْنَة':Added, #1: 1	زَوَّجَ ابْنَةَ
u'زَوْجٌ اِبْنَة':Added, #1: 1	زَوْجُ ابْنَةِ
u'زَوْجٌ اِبْنَة':Added, #1: 1	زَوْجَ ابْنَتِهِ
u'زَوَّجَ أَجْنَبِيٌّ':Subject, #1: 1	زَوْجِ ابْنَتِهِ
u'زَوَّجَ أَجْنَبِيٌّ':Subject, #1: 1	زَوَّجَ أَجْنَبِيٌّ
u'زَوْجٌ أَجْنَبِيٌّ':Added, #2: 2	زَوَّجَ الْأَجْنَبِيُّ
u'زَوَّجَ أحَدٌ':Subject, #4: 4	زَوْجٍ أَجْنَبِيٍّ
u'زَوَّجَ أحَدٌ':Subject, #1: 1	زَوَّجَ أَحَدٌ
u'زَوْجٌ أحَدٌ':Added, #4: 4	زَوَّجَ أَحَدُ
u'زَوَّجَ أَخٌ':Subject, #2: 2	زَوْجِ أَحَدٍ
u'زَوْجٌ أُخْتٌ':Added, #3: 3	زَوَّجَ الْأَخُ
u'زَوْجٌ أُخْتٌ':Added, #1: 1	زَوْجُ أُخْتِ
u'زَوْجٌ أُخْتٌ':Added, #1: 1	زَوْجِ أُخْتِهِ
u'زَوْجٌ أُخْتٌ':Added, #2: 2	زَوْجَ أُخْتِهِ
u'زَوَّجَ أَسْماءٌ':Predicate, #4: 4	زَوْجُ الْأُخْتِ
u'زَوَّجَ الْمَرْأَةُ':Predicate, #1: 1	زَوَّجَ أَسْمَاءَ
u'زَوْجٌ الْمَرْأَةُ':Added, #1: 1	زَوَّجَ الْمَرْأَةَ
u'زَوْجٌ الْمَرْأَةُ':Added, #1: 1	زَوْجِ الْمَرْأَةِ
u'زَوْجٌ الْمَرْأَةُ':Added, #5: 5	زَوْجَ الْمَرْأَةِ
u'زَوَّجَ أُمٌّ':Predicate, #7: 7	زَوْجُ الْمَرْأَةِ
u'زَوْجٌ أُمٌّ':Added, #15: 15	زَوَّجَ أُمَّ
u'زَوْجٌ أُمٌّ':Added, #11: 11	زَوْجِ الْأُمِّ
u'زَوْجٌ أُمٌّ':Added, #1: 1	زَوْجُ الْأُمِّ
u'زَوْجٌ أُمٌّ':Added, #1: 1	زَوْجِ أُمِّ
u'زَوْجٌ أُمٌّ':Added, #1: 1	زَوْجُ أُمِّهِ
u'زَوْجٌ أُمٌّ':Added, #3: 3	زَوْجَ الْأُمِّ
u'زَوْجٌ أُمٌّ':Added, #3: 3	زَوْجَ أُمِّهِ
u'زَوْجٌ أُمٌّ':Added, #4: 4	زَوْجَ أُمِّ
u'زَوْجٌ أُمٌّ':Added, #5: 5	زَوْجُ أُمِّ
u'زَوَّجَ إمَامٌ':Subject, #9: 9	زَوْجِ أُمِّهِ
u'زَوَّجَ أُمَّةٌ':Predicate, #1: 1	زَوَّجَ الْإِمَامُ
u'زَوَّجَ أمَةٌ':Predicate, #1: 1	زَوَّجَ أُمَّةَ
u'زَوَّجَ أمَةٌ':Predicate, #4: 4	زَوَّجَ الْأَمَةَ
u'زَوْجٌ أمَةٌ':Added, #6: 6	زَوَّجَ أَمَةَ
u'زَوْجٌ أمَةٌ':Added, #18: 18	زَوْجُ الْأَمَةِ
u'زَوْجٌ أمَةٌ':Added, #1: 1	زَوْجِ الْأَمَةِ
u'زَوْجٌ أمَةٌ':Added, #1: 1	زَوْجَ أَمَتِهِ
u'زَوْجٌ أمَةٌ':Added, #3: 3	زَوْجُ أَمَتِهِ
u'زَوْجٌ اِمْرَأَةٌ':Added, #4: 4	زَوْجَ الْأَمَةِ
u'زَوْجٌ بَائِنٌ':Added, #1: 1	زَوْجُ امْرَأَةٍ
u'زَوَّجَ بِكْرٌ':Predicate, #2: 2	زَوْجُ الْبَائِنِ
u'زَوْجٌ بِكْرٌ':Added, #6: 6	زَوَّجَ الْبِكْرَ
u'زَوَّجَ بِنْتٌ':Predicate, #2: 2	زَوْجُ الْبِكْرِ
u'زَوَّجَ بِنْتٌ':Predicate, #1: 1	زَوَّجَ الْبِنْتَ
u'زَوْجٌ بِنْتٌ':Added, #2: 2	زَوَّجَ بِنْتَ
u'زَوْجٌ بِنْتٌ':Added, #1: 1	زَوْجُ الْبِنْتِ
u'زَوْجٌ بِنْتٌ':Added, #1: 1	زَوْجُ بِنْتِ
u'زَوْجٌ بِنْتٌ':Added, #1: 1	زَوْجِ بِنْتِ
u'زَوْجٌ بِنْتٌ':Added, #2: 2	زَوْجِ الْبِنْتِ
u'زَوَّجَ ثَانِي':Predicate, #2: 2	زَوْجَ بِنْتِهِ
u'زَوْجٌ ثَوْرٌ':Added, #1: 1	زَوَّجَ الثَّانِيَ
u'زَوَّجَ ثَيِّبٌ':Predicate, #1: 1	زَوْجَ ثَوْرٍ
u'زَوَّجَ جَارِي':Predicate, #3: 3	زَوَّجَ الثَّيِّبَ
u'زَوَّجَ جَارِي':Predicate, #1: 1	زَوَّجَ جَارِيَةَ
u'زَوَّجَ جَارِيَةٌ':Predicate, #5: 5	زَوَّجَ الْجَارِيَةَ
u'زَوَّجَ جَارِيَةٌ':Predicate, #1: 1	زَوَّجَ جَارِيَةَ
u'زَوَّجَ جَازٌ':Predicate, #5: 5	زَوَّجَ الْجَارِيَةَ
u'زَوَّجَ جَمِيع':Predicate, #1: 1	زَوَّجَ جَازَ
u'زَوْجٌ جَمِيع':Added, #1: 1	زَوَّجَ الْجَمِيعَ
u'زَوْجٌ حاضِنٌ':Added, #2: 2	زَوْجِ الْجَمِيعِ
u'زَوَّجَ حاكِمٌ':Subject, #1: 1	زَوْجُ الْحَاضِنَةِ
u'زَوَّجَ حاكِمٌ':Subject, #1: 1	زَوَّجَ حَاكِمٌ
u'زَوْجٌ حامِلٌ':Added, #8: 8	زَوَّجَ الْحَاكِمُ
u'زَوْجٌ حُرٌّ':Added, #1: 1	زَوْجٍ حَامِلٍ
u'زَوْجٌ حُرٌّ':Added, #1: 1	زَوْجِ الْحُرَّةِ
u'زَوْجٌ حُرٌّ':Added, #1: 1	زَوْجُ حُرَّةٍ
u'زَوْجٌ حُرٌّ':Added, #2: 2	زَوْجُ الْحُرَّةِ
u'زَوْجٌ حَلالٌ':Added, #4: 4	زَوْجٍ حُرٍّ
u'زَوْجٌ حَمَامٌ':Added, #1: 1	زَوْجٍ حَلَالٍ
u'زَوْجٌ خُفٌّ':Added, #1: 1	زَوْجَ حَمَامٍ
u'زَوْجٌ ذِمِّيٌّ':Added, #1: 1	زَوْجُ خُفٍّ
u'زَوَّجَ رَاهِنٌ':Subject, #1: 1	زَوْجِ ذِمِّيَّةٍ
u'زَوْجٌ رَبَّةٌ':Added, #1: 1	زَوَّجَ الرَّاهِنُ
u'زَوْجٌ رَبَّةٌ':Added, #1: 1	زَوْجِ رَبَّةِ
u'زَوْجٌ رَجْعِيٌّ':Added, #2: 2	زَوْجَ رَبَّةِ
u'زَوْجٌ رَجْعِيٌّ':Added, #1: 1	زَوْجُ رَجْعِيَّةٍ
u'زَوْجٌ رَجْعِيَّةٌ':Added, #2: 2	زَوْجُ الرَّجْعِيَّةِ
u'زَوْجٌ رَجْعِيَّةٌ':Added, #1: 1	زَوْجُ رَجْعِيَّةٍ
u'زَوَّجَ رَجُلٌ':Subject, #2: 2	زَوْجُ الرَّجْعِيَّةِ
u'زَوَّجَ رَجُلٌ':Subject, #20: 20	زَوَّجَ الرَّجُلُ
u'زَوْجٌ رَسُولٌ':Added, #8: 8	زَوَّجَ رَجُلٌ
u'زَوْجٌ رَسُولٌ':Added, #1: 1	زَوْجُ رَسُولِ
u'زَوَّجَ رَقيقٌ':Predicate, #2: 2	زَوْجِ رَسُولِ
u'زَوَّجَ رَقيق':Predicate, #1: 1	زَوَّجَ الرَّقِيقَ
u'زَوْجٌ زانِي':Added, #1: 1	زَوَّجَ الرَّقِيقَ
u'زَوْجٌ زَيْدٌ':Added, #1: 1	زَوْجُ الزَّانِيَةِ
u'زَوْجٌ زَيْدٌ':Added, #1: 1	زَوْجُ زَيْدٍ
u'زَوْجٌ سَابِقٌ':Added, #1: 1	زَوْجِ زَيْدٍ
u'زَوَّجَ سُلْطَانٌ':Subject, #2: 2	زَوْجٍ سَابِقٍ
u'زَوْجٌ سُلْطَانٌ':Added, #2: 2	زَوَّجَ السُّلْطَانُ
u'زَوَّجَ سَيِّدٌ':Subject, #1: 1	زَوْجُ السُّلْطَانِ
u'زَوْجٌ سَيِّدٌ':Added, #4: 4	زَوَّجَ السَّيِّدُ
u'زَوْجٌ شَابٌّ':Added, #2: 2	زَوْجِ سَيِّدَتِهِ
u'زَوْجٌ صَاحِبٌ':Added, #1: 1	زَوْجِ الشَّابَّةِ
u'زَوَّجَ صَبِيٌّ':Predicate, #2: 2	زَوْجَ صَاحِبَةِ
u'زَوَّجَ صَرِيحٌ':Subject, #1: 1	زَوَّجَ الصَّبِيَّةَ
u'زَوَّجَ صَغِيرٌ':Predicate, #1: 1	زَوَّجَ صَرِيحٌ
u'زَوَّجَ صَغِيرٌ':Predicate, #1: 1	زَوَّجَ صَغِيرَةً
u'زَوَّجَ صَغِيرٌ':Predicate, #5: 5	زَوَّجَ الصَّغِيرَ
u'زَوَّجَ صَغِيرٌ':Subject, #6: 6	زَوَّجَ الصَّغِيرَةَ
u'زَوْجٌ صَغِيرٌ':Added, #1: 1	زَوَّجَ الصَّغِيرُ
u'زَوْجٌ صَغِيرٌ':Added, #2: 2	زَوْجُ الصَّغِيرَةِ
u'زَوْجٌ عَاقِلٌ':Added, #6: 6	زَوْجِ الصَّغِيرَةِ
u'زَوَّجَ عَائِشٌ':Predicate, #2: 2	زَوْجٍ عَاقِلٍ
u'زَوْجٌ عَبَّاسٌ':Added, #1: 1	زَوَّجَ عَائِشَةَ
u'زَوَّجَ عَبْدٌ':Predicate, #1: 1	زَوْجِ الْعَبّاسِ
u'زَوَّجَ عَبْدٌ':Predicate, #1: 1	زَوَّجَ عَبْدَ
u'زَوَّجَ عَبْدٌ':Subject, #3: 3	زَوَّجَ الْعَبْدَ
u'زَوْجٌ عَبْدٌ':Added, #1: 1	زَوَّجَ عَبْدٌ
u'زَوْجٌ عَبْدٌ':Added, #1: 1	زَوْجٍ عَبْدٍ
u'زَوَّجَ عَلِيٌّ':Predicate, #1: 1	زَوْجَ عَبْدِ
u'زَوَّجَ عَمٌّ':Subject, #1: 1	زَوَّجَ عَلِيَّ
u'زَوَّجَ غَاصِبٌ':Subject, #3: 3	زَوَّجَ الْعَمُّ
u'زَوَّجَ غير':Subject, #2: 2	زَوَّجَ الْغَاصِبُ
u'زَوَّجَ غَيْرٌ':Subject, #3: 3	زَوَّجَ غَيْرُ
u'زَوْجٌ غير':Added, #3: 3	زَوَّجَ غَيْرُ
u'زَوْجٌ غَيْرٌ':Added, #6: 6	زَوْجِ غَيْرِهِ
u'زَوْجٌ فَاعِلٌ':Added, #6: 6	زَوْجِ غَيْرِهِ
u'زَوَّجَ فُضُولِيٌّ':Predicate, #1: 1	زَوْجُ الْفَاعِلَةِ
u'زَوَّجَ فُضُولِيٌّ':Subject, #1: 1	زَوَّجَ الْفُضُولِيَّ
u'زَوَّجَ فُلاَنٌ':Predicate, #5: 5	زَوَّجَ فُضُولِيٌّ
u'زَوَّجَ فُلاَنٌ':Subject, #1: 1	زَوَّجَ فُلَانَةَ
u'زَوْجٌ فلان':Added, #5: 5	زَوَّجَ فُلَانٌ
u'زَوْجٌ كَافِرٌ':Added, #1: 1	زَوْجِ جَعْفَرٍ
u'زَوَّجَ كَبِيرٌ':Predicate, #1: 1	زَوْجِ الْكَافِرَةِ
u'زَوْجٌ كِتاب':Added, #2: 2	زَوَّجَ الْكَبِيرَةَ
u'زَوْجٌ كِتاب':Added, #1: 1	زَوْجَ الْكِتَابِيَّةِ
u'زَوْجٌ كِتاب':Added, #1: 1	زَوْجُ كِتَابِيَّةٍ
u'زَوْجٌ كِتابَة':Added, #7: 7	زَوْجُ الْكِتَابِيَّةِ
u'زَوْجٌ كِتابَة':Added, #1: 1	زَوْجَ الْكِتَابِيَّةِ
u'زَوْجٌ كِتابَة':Added, #1: 1	زَوْجُ كِتَابِيَّةٍ
u'زَوْجٌ كِتابِيّ':Added, #7: 7	زَوْجُ الْكِتَابِيَّةِ
u'زَوْجٌ كِتابِيّ':Added, #1: 1	زَوْجَ الْكِتَابِيَّةِ
u'زَوْجٌ كِتابِيّ':Added, #1: 1	زَوْجُ كِتَابِيَّةٍ
u'زَوَّجَ لَقِيطٌ':Predicate, #7: 7	زَوْجُ الْكِتَابِيَّةِ
u'زَوْجٌ مُتَحَيِّرٌ':Added, #1: 1	زَوَّجَ اللَّقِيطَةَ
u'زَوَّجَ مُجْبَرٌ':Predicate, #1: 1	زَوْجِ الْمُتَحَيِّرَةِ
u'زَوَّجَ مُجْبِرٌ':Subject, #2: 2	زَوَّجَ الْمُجْبَرَةَ
u'زَوَّجَ مَجْنُونٌ':Predicate, #1: 1	زَوَّجَ الْمُجْبِرُ
u'زَوْجٌ مَجْنُونٌ':Added, #1: 1	زَوَّجَ الْمَجْنُونَ
u'زَوْجٌ مَجُوسِيٌّ':Added, #2: 2	زَوْجُ الْمَجْنُونَةِ
u'زَوْجٌ مَجُوسِيَّةٌ':Added, #1: 1	زَوْجُ الْمَجُوسِيِّ
u'زَوْجٌ مَجُوسِيَّةٌ':Added, #1: 1	زَوْجِ الْمَجُوسِيَّةِ
u'زَوَّجَ مُحْرِمٌ':Predicate, #4: 4	زَوْجُ الْمَجُوسِيَّةِ
u'زَوَّجَ مُحْرِمٌ':Subject, #1: 1	زَوَّجَ مُحْرِمَةً
u'زَوَّجَ مُدَبَّرٌ':Predicate, #2: 2	زَوَّجَ الْمُحْرِمُ
u'زَوْجٌ مُرْتَدٌّ':Added, #2: 2	زَوَّجَ مُدَبَّرَةً
u'زَوْجٌ مُرْضِعٌ':Added, #1: 1	زَوْجِ الْمُرْتَدَّةِ
u'زَوْجٌ مُرْضِعٌ':Added, #1: 1	زَوْجُ الْمُرْضِعَةِ
u'زَوْجٌ مُرْضِعٌ':Added, #1: 1	زَوْجُ مُرْضِعَةٍ
u'زَوَّجَ مَرِيضٌ':Subject, #2: 2	زَوْجِ الْمُرْضِعَةِ
u'زَوْجٌ مُسْلِمٌ':Added, #1: 1	زَوَّجَ الْمَرِيضُ
u'زَوْجٌ مُسْلِمٌ':Added, #1: 1	زَوْجُ الْمُسْلِمَةِ
u'زَوْجٌ مُسْلِمٌ':Added, #1: 1	زَوْجُ مُسْلِمٍ
u'زَوْجٌ مَشْرِقِيٌّ':Added, #6: 6	زَوْجٍ مُسْلِمٍ
u'زَوْجٌ مَشْهُودٌ':Added, #1: 1	زَوْجُ الْمَشْرِقِيَّةِ
u'زَوْجٌ مُطَلَّقٌ':Added, #1: 1	زَوْجُ الْمَشْهُودِ
u'زَوْجٌ مُعْتَدٌّ':Added, #1: 1	زَوْجُ الْمُطَلَّقَةِ
u'زَوْجٌ مُعْتَقٌ':Added, #3: 3	زَوْجُ الْمُعْتَدَّةِ
u'زَوْجٌ مُعْسِرٌ':Added, #1: 1	زَوْجُ الْمُعْتَقَةِ
u'زَوْجٌ مَعِيبٌ':Added, #1: 1	زَوْجٍ مُعْسِرٍ
u'زَوْجٌ مُعَيَّنٌ':Added, #1: 1	زَوْجِ الْمَعِيبَةِ
u'زَوْجٌ مَغْصُوب':Added, #2: 2	زَوْجٍ مُعَيَّنٍ
u'زَوَّجَ مُكَاتَبَةٌ':Predicate, #1: 1	زَوْجُ مَغْصُوبَةٍ
u'زَوْجٌ مُكَلَّفٌ':Added, #1: 1	زَوَّجَ الْمُكَاتَبَةَ
u'زَوْجٌ مُنْكِرٌ':Added, #8: 8	زَوْجٍ مُكَلَّفٍ
u'زَوْجٌ مُوسِرٌ':Added, #1: 1	زَوْجُ الْمُنْكِرَةِ
u'زَوَّجَ نَبِيٌّ':Subject, #1: 1	زَوْجٍ مُوسِرٍ
u'زَوْجٌ نَبِيٌّ':Added, #2: 2	زَوَّجَ النَّبِيُّ
u'زَوْجٌ نَبِيٌّ':Added, #15: 15	زَوْجِ النَّبِيِّ
u'زَوْجٌ نَبِيٌّ':Added, #5: 5	زَوْجُ النَّبِيِّ
u'زَوْجٌ نَعْلٌ':Added, #7: 7	زَوْجَ النَّبِيِّ
u'زَوَّجَ واحد':Subject, #1: 1	زَوْجُ نَعْلٍ
u'زَوَّجَ وَاحِدٌ':Subject, #1: 1	زَوَّجَ وَاحِدٌ
u'زَوْجٌ واحد':Added, #1: 1	زَوَّجَ وَاحِدٌ
u'زَوْجٌ وَاحِدٌ':Added, #4: 4	زَوْجٍ وَاحِدٍ
u'زَوَّجَ وَصِيٌّ':Subject, #4: 4	زَوْجٍ وَاحِدٍ
u'زَوَّجَ وَصِيٌّ':Subject, #1: 1	زَوَّجَ الْوَصِيُّ
u'زَوَّجَ وَكِيلٌ':Subject, #1: 1	زَوَّجَ وَصِيٌّ
u'زَوَّجَ وَلِيٌّ':Subject, #2: 2	زَوَّجَ الْوَكِيلُ
u'زَوَّجَ وَلِيٌّ':Subject, #1: 1	زَوَّجَ وَلِيُّ
u'زَوْجٌ وهبة':Added, #5: 5	زَوَّجَ الْوَلِيُّ
u'زَوَّجَ يَتِيمٌ':Predicate, #1: 1	زَوْجٍ وَهِبَةٍ
u'زَوَّجَ يَتِيمٌ':Predicate, #1: 1	زَوَّجَ الْيَتِيمَ
u'زَوَّجَ يَهُودِيٌّ':Subject, #2: 2	زَوَّجَ الْيَتِيمَةَ
u'زَوَرٌ صَدْرٌ':Added, #1: 1	زَوَّجَ الْيَهُودِيُّ
u'زَوَّرَ قَوْمٌ':Subject, #1: 1	زَوَرِ الصَّدْرِ
u'زَوَى بَيْنٌ':Predicate, #1: 1	زَوَّرَ قَوْمٌ
u'زَيْدٌ اِبْنٌ':Added, #1: 1	زَوَى بَيْنَ
u'زَيْدٌ ثَابِتٌ':Added, #1: 1	زَيْدِ ابْنِ
u'زَيْدٌ جُمْهُورٌ':Added, #1: 1	زَيْدٍ ثَابِتٍ
u'زَيْدٌ حَرامٌ':Added, #1: 1	زَيْدِ الْجُمْهُورِ
u'زَيْدٌ خَيْرٌ':Added, #1: 1	زَيْدِ حَرَامٍ
u'زَيْدٌ خَيْرٌ':Added, #1: 1	زَيْدَ الْخَيْرِ
u'زَيْدٌ خَيْلٌ':Added, #2: 2	زَيْدُ الْخَيْرِ
u'زَيْدٌ خَيْلٌ':Added, #2: 2	زَيْدَ الْخَيْلِ
u'زَيْدٌ خَيْلٌ':Added, #2: 2	زَيْدِ الْخَيْلِ
u'زَيْدٌ سَنَةٌ':Added, #5: 5	زَيْدُ الْخَيْلِ
u'زَيْدٌ شمس':Added, #1: 1	زَيْدٍ سَنَةٍ
u'زَيْدٌ شَمْسٌ':Added, #1: 1	زَيْدُ الشَّمْسِ
u'زَيْدٌ لاَتٌ':Added, #1: 1	زَيْدُ الشَّمْسِ
u'زَيْغٌ شمس':Added, #3: 3	زَيْدِ اللّاتِ
u'زَيْغٌ شَمْسٌ':Added, #2: 2	زَيْغِ الشَّمْسِ
u'زَيَّفَ أَكْثَرُ':Predicate, #2: 2	زَيْغِ الشَّمْسِ
u'زَيْفٌ إيجَازٌ':Added, #1: 1	زَيَّفَ أَكْثَرَ
u'زَيَّفَ فلان':Predicate, #1: 1	زَيْفِ الْإِيجَازِ
u'زَيْفٌ قَصْدٌ':Added, #1: 1	زَيَّفَ الرَّازِيَّ
u'زَيْنٌ بُيُوتٌ':Added, #1: 1	زَيْفِ الْقَصْدِ
u'زَيْنٌ دِينٌ':Added, #1: 1	زَيْنُ الْبُيُوتِ
u'زَيْنٌ دَيْنٌ':Added, #1: 1	زَيْنَ الدِّينِ
u'زَيْنٌ دِينٌ':Added, #1: 1	زَيْنِ الدَّيْنِ
u'زَيْنٌ دِينٌ':Added, #27: 27	زَيْنُ الدِّينِ
u'زَيَّنَ رِجَالٌ':Predicate, #6: 6	زَيْنِ الدِّينِ
u'زَيْنٌ عَرَبٌ':Added, #1: 1	زَيَّنَ الرِّجَالَ
u'زَيَّنَ علم':Subject, #1: 1	زَيْنُ الْعَرَبِ
u'زَيَّنَ عِلْمٌ':Subject, #1: 1	زَيَّنَ الْعِلْمُ
u'زَيْنٌ علم':Added, #1: 1	زَيَّنَ الْعِلْمُ
u'زَيْنٌ عِلْمٌ':Added, #1: 1	زَيْنُ الْعِلْمِ
u'زَيْنٌ فَصَاحَةٌ':Added, #1: 1	زَيْنُ الْعِلْمِ
u'زَيْنٌ قُرْآنٌ':Added, #1: 1	زَيْنِ الْفَصَاحَةِ
u'زَيْنٌ مَحَافِلُ':Added, #1: 1	زَيْنُ الْقُرْآنِ
u'زَيْنٌ مِلَّةٌ':Added, #1: 1	زَيْنُ الْمَحَافِلِ
u'زَيَّنَ وُجُودٌ':Predicate, #3: 3	زَيْنُ الْمِلَّةِ
u'سَاءَ اِبْنٌ':Subject, #1: 1	زَيَّنَ الْوُجُودَ
u'سَاءَ أَجِيرٌ':Subject, #1: 1	أَسَاءَ ابْنُ
u'سَاءَ أدَب':Predicate, #1: 1	أَسَاءَ الْأَجِيرُ
u'سَاءَ أدَب':Subject, #6: 6	أَسَاءَ الْأَدَبَ
u'سَاءَ إمَامٌ':Subject, #1: 1	سَاءَ أَدَبُهُ
u'سَاءَ جَانِبٌ':Subject, #1: 1	أَسَاءَ الْإِمَامُ
u'سَاءَ حِفْظٌ':Subject, #1: 1	سَاءَ جَانِبُ
u'سَاءَ خلق':Subject, #2: 2	سَاءَ حِفْظُهُ
u'سَاءَ خُلُقٌ':Subject, #10: 10	سَاءَ خُلُقُهُ
u'سَاءَ خُلُق':Subject, #10: 10	سَاءَ خُلُقُهُ
u'سَاءَ خلق':Subject, #10: 10	سَاءَ خُلُقُهُ
u'سَاءَ خُلُقٌ':Subject, #1: 1	سَاءَ خُلُقُ
u'سَاءَ خُلُق':Subject, #1: 1	سَاءَ خُلُقُ
u'سَاءَ دِينٌ':Subject, #1: 1	سَاءَ خُلُقُ
u'سَاءَ زَوْجٌ':Subject, #1: 1	سَاءَ دِينُهُ
u'سَاءَ صَلاَةٌ':Predicate, #1: 1	أَسَاءَ الزَّوْجُ
u'سَاءَ ظَنٌّ':Predicate, #1: 1	أَسَاءَ الصَّلاَةَ
u'سَاءَ ظَنٌّ':Subject, #1: 1	أَسَاءَ الظَّنَّ
u'سَاءَ ظَنٌّ':Subject, #1: 1	سَاءَ الظَّنُّ
u'سَاءَ عَبْدٌ':Subject, #2: 2	سَاءَ ظَنُّهُ
u'سَاءَ عَمَلٌ':Predicate, #1: 1	أَسَاءَ عَبْدُهُ
u'سَاءَ عَمَلٌ':Subject, #1: 1	أَسَاءَ الْعَمَلَ
u'سَاءَ عَمَلٌ':Subject, #1: 1	سَاءَ عَمَلٌ
u'سَاءَ عَمَلٌ':Subject, #1: 1	سَاءَ عَمَلُ
u'سَاءَ غِذَاءٌ':Subject, #1: 1	سَاءَ عَمَلُهُ
u'سَاءَ فِعْلٌ':Subject, #1: 1	سَاءَ غِذَاءُ
u'سَاءَ فَهْمٌ':Subject, #1: 1	سَاءَ فِعْلُ
u'سَاءَ مِزَاجٌ':Subject, #1: 1	سَاءَ فَهْمُهُ
u'سَاءَ نَظَرٌ':Predicate, #1: 1	سَاءَ مِزَاجُهُ
u'سَاءَ وَتَرٌ':Predicate, #1: 1	أَسَاءَ النَّظَرَ
u'سَابَقَ بَيْنٌ':Predicate, #1: 1	أَسَاءَ وَتَرَكَ
u'سَابَقَ عَائِشٌ':Predicate, #9: 9	سَابَقَ بَيْنَ
u'سَابَقَ قَدَرٌ':Predicate, #1: 1	سَابَقَ عَائِشَةَ
u'سَادَ ثَعَالِبُ':Subject, #1: 1	سَابَقَ الْقَدَرَ
u'سَادَ قَبِيلَةٌ':Predicate, #1: 1	سَادَ الثَّعَالِبُ
u'سَادَ نَاسٌ':Subject, #1: 1	سَادَ الْقَبِيلَةَ
u'سَادَ نَذْلٌ':Subject, #1: 1	سَادَ النَّاسُ
u'سَارَ أحَدٌ':Subject, #1: 1	سَادَ نَذْلُ
u'سَارَ أقَلُّ':Predicate, #1: 1	سَارَ أَحَدٌ
u'سَارَ بَعْضٌ':Predicate, #1: 1	سَارَ أَقَلَّ
u'سَارَ ثَابِتٌ':Subject, #6: 6	سَارَ بَعْضَ
u'سَارَ ثَلاثَةٌ':Predicate, #2: 2	سَارَ ثَابِتُ
u'سَارَ حَسَنٌ':Subject, #6: 6	سَارَ ثَلَاثَةَ
u'سَارَ رَاجِعٌ':Subject, #1: 1	سَارَ الْحَسَنُ
u'سَارَ رَاكِبٌ':Subject, #1: 1	سَارَ رَاجِعُ
u'سَارَ رَجُلٌ':Subject, #3: 3	سَارَ رَاكِبٌ
u'سَارَ رَجُلٌ':Subject, #1: 1	سَارَ رَجُلٌ
u'سَارَّ رَسُولٌ':Predicate, #7: 7	سَارَ الرَّجُلُ
u'سَارَ رَسُولٌ':Subject, #1: 1	سَارَّ رَسُولَ
u'سَارَ سَواءٌ':Subject, #10: 10	سَارَ رَسُولُ
u'سَارَ عَبْدٌ':Subject, #2: 2	سَارَ سَوَاءٌ
u'سَارَ عَبْدٌ':Subject, #1: 1	سَارَ الْعَبْدُ
u'سَارَعَ خَلِيلٌ':Subject, #1: 1	سَارَ عَبْدُ
u'سَارَ عَسْكَرٌ':Subject, #1: 1	سَارَعَ الْخَلِيلُ
u'سَارَ عَقِبٌ':Predicate, #2: 2	سَارَ الْعَسْكَرُ
u'سَارَ عُمَرٌ':Subject, #2: 2	سَارَ عَقِبَ
u'سَارَ فَرَاسِخُ':Predicate, #1: 1	سَارَ عُمَرُ
u'سَارَ فُلْكٌ':Subject, #1: 1	سَارَ فَرَاسِخَ
u'سَارَ قَالٌ':Predicate, #1: 1	سَارَ الْفُلْكُ
u'سَارَ قول':Subject, #1: 1	سَارَ قَالَ
u'سَارَ قَوْلٌ':Subject, #1: 1	سَارَ الْقَوْلُ
u'سَارَ لَيْلٌ':Predicate, #1: 1	سَارَ الْقَوْلُ
u'سَارَ نَاسٌ':Subject, #1: 1	سَارَ لَيْلَةً
u'سَارَ نَاسٌ':Subject, #1: 1	سَارَ النّاسُ
u'سَارَ نِصْفٌ':Predicate, #1: 1	سَارَ النَّاسُ
u'سَاسَ أَمْرٌ':Predicate, #4: 4	سَارَ نِصْفَ
u'سَاطَ دَمٌ':Predicate, #1: 1	سَاسَ الْأَمْرَ
u'سَاعَدَ خَصْمٌ':Predicate, #1: 1	سَاطَ الدّمَ
u'سَاعَدَ قَدَرٌ':Subject, #1: 1	سَاعَدَ الْخَصْمَ
u'سَاعَدَ قلب':Subject, #1: 1	سَاعَدَ الْقَدَرُ
u'سَاعَدَ قَلْبٌ':Subject, #1: 1	سَاعَدَ قَلْبُهُ
u'سَاعَدَ قَلْب':Subject, #1: 1	سَاعَدَ قَلْبُهُ
u'سَاعَدَ نَاسٌ':Predicate, #1: 1	سَاعَدَ قَلْبُهُ
u'سَاغَ إِجْمَاعٌ':Subject, #1: 1	سَاعَدَ النَّاسَ
u'سَاغَ أخْذٌ':Subject, #1: 1	سَاغَ الْإِجْمَاعُ
u'سَاغَ اِرْتِجاع':Subject, #1: 1	سَاغَ أَخْذُهُ
u'سَاغَ إِنْكارٌ':Subject, #1: 1	سَاغَ ارْتِجَاعُهُ
u'سَاغَ تَأْخِيرٌ':Subject, #1: 1	سَاغَ الْإِنْكَارُ
u'سَاغَ تَسْمِيَة':Subject, #1: 1	سَاغَ تَأْخِيرُهُ
u'سَاغَ تَقْديرٌ':Subject, #2: 2	سَاغَ تَسْمِيَةُ
u'سَاغَ صَرْفٌ':Subject, #1: 1	سَاغَ تَقْدِيرُ
u'سَاغَ صَرْف':Subject, #1: 1	سَاغَ صَرْفُهُ
u'سَاغَ ضَمٌّ':Subject, #1: 1	سَاغَ صَرْفُهُ
u'سَاغَ طلب':Subject, #1: 1	سَاغَ ضَمُّهُ
u'سَاغَ طَلَبٌ':Subject, #1: 1	سَاغَ طَلَبُ
u'سَاغَ قَضَاءٌ':Subject, #1: 1	سَاغَ طَلَبُ
u'سَاغَ لُغَةٌ':Predicate, #1: 1	سَاغَ الْقَضَاءُ
u'سَاغَ وَصْفٌ':Subject, #1: 1	سَاغَ لُغَةَ
u'سَافَرَ آخِرُ':Subject, #2: 2	سَاغَ وَصْفُهُ
u'سَافَرَ أَرْبَعَةٌ':Predicate, #1: 1	سَافَرَ آخِرُ
u'سَافَرَ أقَلُّ':Predicate, #1: 1	سَافَرَ أَرْبَعَةَ
u'سَافَرَ أَوَّلُ':Predicate, #3: 3	سَافَرَ أَقَلَّ
u'سَافَرَ جَازٌ':Predicate, #1: 1	سَافَرَ أَوَّلَ
u'سَافَرَ جَمَاعَةٌ':Subject, #1: 1	سَافَرَ جَازَ
u'سَافَرَ حَكَمٌ':Subject, #2: 2	سَافَرَ جَمَاعَةٌ
u'سَافَرَ حَمَلٌ':Predicate, #1: 1	سَافَرَ الْحَكَمُ
u'سَافَرَ دونٌ':Predicate, #1: 1	سَافَرَ حَمَلَ
u'سَافَرَ ذكر':Predicate, #3: 3	سَافَرَ دُونَ
u'سَافَرَ ذَكَرٌ':Predicate, #1: 1	سَافَرَ ذَكَرَ
u'سَافَرَ رَجُلٌ':Subject, #1: 1	سَافَرَ ذَكَرَ
u'سَافَرَ رَجُلٌ':Subject, #1: 1	سَافَرَ الرّجُلُ
u'سَافَرَ رَسُولٌ':Subject, #3: 3	سَافَرَ الرَّجُلُ
u'سَافَرَ سَفَرٌ':Predicate, #6: 6	سَافَرَ رَسُولُ
u'سَافَرَ سَيِّدٌ':Subject, #2: 2	سَافَرَ سَفَرَ
u'سَافَرَ ضَرَبٌ':Predicate, #1: 1	سَافَرَ السَّيِّدُ
u'سَافَرَ ضَمِنٌ':Predicate, #1: 1	سَافَرَ ضَرَبَ
u'سَافَرَ عَبْدٌ':Subject, #1: 1	سَافَرَ ضَمِنَ
u'سَافَرَ غَاصِبٌ':Subject, #1: 1	سَافَرَ الْعَبْدُ
u'سَافَرَ غير':Predicate, #1: 1	سَافَرَ غَاصِبُ
u'سَافَرَ غَيْرٌ':Predicate, #1: 1	سَافَرَ غَيْرَ
u'سَافَرَ فلان':Subject, #1: 1	سَافَرَ غَيْرَ
u'سَافَرَ قَالٌ':Predicate, #1: 1	سَافَرَ مَكِّيٌّ
u'سَافَرَ قَصَرٌ':Predicate, #2: 2	سَافَرَ قَالَ
u'سَافَرَ مُدَّةٌ':Predicate, #1: 1	سَافَرَ قَصَرَ
u'سَافَرَ مُرْتَهِنٌ':Subject, #1: 1	سَافَرَ مُدَّةَ
u'سَافَرَ مَسَافَةٌ':Predicate, #1: 1	سَافَرَ الْمُرْتَهِنُ
u'سَافَرَ مُضَارِبٌ':Subject, #3: 3	سَافَرَ مَسَافَةَ
u'سَافَرَ مَكِّيّ':Subject, #1: 1	سَافَرَ الْمُضَارِبُ
u'سَافَرَ مُودَعٌ':Subject, #1: 1	سَافَرَ مَكِّيٌّ
u'سَافَرَ نَاسٌ':Subject, #1: 1	سَافَرَ الْمُودَعُ
u'سَافَرَ نَبِيٌّ':Subject, #1: 1	سَافَرَ نَاسٌ
u'سَافَرَ وَتَرٌ':Predicate, #1: 1	سَافَرَ النَّبِيُّ
u'سَافَرَ يَوْمٌ':Predicate, #1: 1	سَافَرَ وَتَرَكَ
u'سَاقَ إِبِلٌ':Predicate, #8: 8	سَافَرَ يَوْمَ
u'سَاقَ اِبْنٌ':Subject, #1: 1	سَاقَ الْإِبِلَ
u'سَاقَ أَحادِيثُ':Predicate, #1: 1	سَاقَ ابْنُ
u'سَاقَ إِسْنادٌ':Predicate, #1: 1	سَاقَ الأَحَادِيثَ
u'سَاقَ أَكْثَرُ':Predicate, #1: 1	سَاقَ الْإِسْنَادَ
u'سَاقَ أَمْرٌ':Predicate, #1: 1	سَاقَ أَكْثَرَ
u'سَاقَ بَحْثٌ':Predicate, #1: 1	سَاقَ الْأَمْرَ
u'سَاقَ بدن':Predicate, #1: 1	سَاقَ الْبَحْثَ
u'سَاقَ بُدْنٌ':Predicate, #1: 1	سَاقَ الْبُدْنَ
u'سَاقَ بَعْضٌ':Predicate, #1: 1	سَاقَ الْبُدْنَ
u'سَاقَ بَقَرٌ':Predicate, #1: 1	سَاقَ بَعْضَ
u'سَاقَ بَهيمٌ':Predicate, #1: 1	سَاقَ الْبَقَرَ
u'سَاقَ بَهِيمَةٌ':Predicate, #1: 1	سَاقَ الْبَهِيمَةَ
u'سَاقَ جَحْش':Predicate, #1: 1	سَاقَ الْبَهِيمَةَ
u'سَاقَ جمع':Predicate, #1: 1	سَاقَ الْجَحْشَ
u'سَاقَ جَمْعٌ':Predicate, #1: 1	سَاقَ الْجَمْعَ
u'سَاقَ حَديثٌ':Predicate, #1: 1	سَاقَ الْجَمْعَ
u'سَاقَ حَديثٌ':Predicate, #2: 2	سَاقَ حَدِيثَ
u'سَاقَ حِمَارٌ':Predicate, #6: 6	سَاقَ الْحَدِيثَ
u'سَاقَ حِمَارٌ':Predicate, #1: 1	سَاقَ حِمَارَ
u'سَاقَ دَابَّةٌ':Predicate, #2: 2	سَاقَ الْحِمَارَ
u'سَاقَ دَوَابُّ':Predicate, #5: 5	سَاقَ الدَّابَّةَ
u'سَاقَ رَسُولٌ':Subject, #1: 1	سَاقَ الدَّوَابَّ
u'سَاقَ رِوايَةٌ':Predicate, #2: 2	سَاقَ رَسُولُ
u'سَاقَ زَوْجٌ':Subject, #1: 1	سَاقَ رِوَايَةَ
u'سَاقَ غَنَمٌ':Predicate, #2: 2	سَاقَ الزَّوْجُ
u'سَاقَ قِصَّةٌ':Predicate, #1: 1	سَاقَ الْغَنَمَ
u'سَاقَ كَلاَمٌ':Predicate, #1: 1	سَاقَ قِصَّةَ
u'سَاقَ كَلاَمٌ':Predicate, #11: 11	سَاقَ الْكَلاَمَ
u'سَاقَ كَلْبٌ':Predicate, #2: 2	سَاقَ كَلَامَ
u'سَاقَ مَاءٌ':Predicate, #1: 1	سَاقَ الْكَلْبَ
u'سَاقَ مَالِكٌ':Subject, #2: 2	سَاقَ الْمَاءَ
u'سَاقَ مُتَمَتِّعٌ':Subject, #1: 1	سَاقَ مَالِكُ
u'سَاقَ مثل':Predicate, #3: 3	سَاقَ الْمُتَمَتِّعُ
u'سَاقَ مِثْلٌ':Predicate, #1: 1	سَاقَ مِثْلَ
u'سَاقَ مَقَالَةٌ':Predicate, #1: 1	سَاقَ مِثْلَ
u'سَاقَ مَهْرٌ':Predicate, #1: 1	سَاقَ مَقَالَةَ
u'سَاقَ مُوجِبٌ':Predicate, #1: 1	سَاقَ الْمَهْرَ
u'سَاقَ نَبِيٌّ':Subject, #1: 1	سَاقَ مُوجِبَ
u'سَاقَ نَصٌّ':Predicate, #1: 1	سَاقَ النَّبِيُّ
u'سَاقَ نُصُوصٌ':Predicate, #1: 1	سَاقَ النَّصَّ
u'سَاقَ نُصُوصٌ':Predicate, #1: 1	سَاقَ النُّصُوصَ
u'سَاقَ هَدَايَا':Subject, #1: 1	سَاقَ نُصُوصَ
u'سَاقَ هَدْيٌ':Predicate, #1: 1	سَاقَ هَدَايَاهُ
u'سَاقَ هَدْيٌ':Subject, #52: 52	سَاقَ الْهَدْيَ
u'سَاقَى أحَدٌ':Subject, #1: 1	سَاقَ الْهَدْيُ
u'سَاقَى أهْلٌ':Predicate, #3: 3	سَاقَى أَحَدُ
u'سَاقَى رَسُولٌ':Subject, #2: 2	سَاقَى أَهْلَ
u'سَاقَى غير':Predicate, #1: 1	سَاقَى رَسُولُ
u'سَاقَى غَيْرٌ':Predicate, #1: 1	سَاقَى غَيْرَ
u'سَاكَنَ أَبٌ':Predicate, #1: 1	سَاقَى غَيْرَ
u'سَاكَنَ دَاخِلٌ':Subject, #1: 1	سَاكَنَ الْأَبَ
u'سَأَلَ اِبْنٌ':Predicate, #1: 1	سَاكَنَ الدَّاخِلُ
u'سَأَلَ اِبْنٌ':Subject, #69: 69	سَأَلَ ابْنَ
u'سَأَلَ إِثْبَاتٌ':Predicate, #14: 14	سَأَلَ ابْنُ
u'سَأَلَ أحَدٌ':Subject, #1: 1	سَأَلَ إثْبَاتَ
u'سَأَلَ إِحْلاَفٌ':Predicate, #1: 1	سَأَلَ أَحَدٌ
u'سَأَلَ أَحْنَف':Predicate, #1: 1	سَأَلَ إحْلَافَ
u'سَأَلَ المُشْتَرِي':Predicate, #1: 1	سَأَلَ الأَحْنَفَ
u'سَأَلَ أُمٌّ':Predicate, #1: 1	سَأَلَ الْمُشْتَرِيَ
u'سَأَلَ إمَارَةٌ':Predicate, #2: 2	سَأَلَ أُمَّ
u'سَأَلَ إمَامٌ':Predicate, #1: 1	سَأَلَ الْإِمَارَةَ
u'سَأَلَ أَمْوَالٌ':Predicate, #3: 3	سَأَلَ الْإِمَامَ
u'سَالَ إِنْسانٌ':Subject, #1: 1	سَأَلَ أَمْوَالَ
u'سَأَلَ إِنْسانٌ':Subject, #1: 1	سَالَ إنْسَانُ
u'سَأَلَ أهْلٌ':Predicate, #2: 2	سَأَلَ إِنْسَانٌ
u'سَأَلَ أهْلٌ':Subject, #2: 2	سَأَلَ أَهْلَ
u'سَأَلَ بَائِعٌ':Predicate, #5: 5	سَأَلَ أَهْلُ
u'سَأَلَ بُخَارِيٌّ':Predicate, #4: 4	سَأَلَ الْبَائِعَ
u'سَأَلَ بِشْرٌ':Subject, #2: 2	سَأَلَ الْبُخَارِيَّ
u'سَأَلَ بَعْضٌ':Predicate, #1: 1	سَأَلَ بِشْرُ
u'سَأَلَ بَعْضٌ':Subject, #6: 6	سَأَلَ بَعْضَ
u'سَأَلَ بَعْضٌ':Subject, #1: 1	سَأَلَ بَعْضٌ
u'سَالَ بَوْلٌ':Subject, #1: 1	سَأَلَ بَعْضُ
u'سَالَ بَيْنٌ':Predicate, #1: 1	سَالَ بَوْلُهُ
u'سَأَلَ بَيِّنَةٌ':Predicate, #1: 1	سَالَ بَيْنَ
u'سَأَلَ تَافِهٌ':Predicate, #2: 2	سَأَلَ الْبَيِّنَةَ
u'سَأَلَ تَحْلِيف':Predicate, #1: 1	سَأَلَ التَّافِهَ
u'سَأَلَ تَفْتِيشٌ':Predicate, #1: 1	سَأَلَ التَّحْلِيفَ
u'سَأَلَ تَفَلُّت':Predicate, #1: 1	سَأَلَ تَفْتِيشَ
u'سَأَلَ تَوْبَةٌ':Predicate, #2: 2	سَأَلَ التَّفَلُّتَ
u'سَأَلَ تَوْقِيعٌ':Predicate, #1: 1	سَأَلَ التَّوْبَةَ
u'سَأَلَ ثَالِثٌ':Subject, #2: 2	سَأَلَ التَّوْقِيعَ
u'سَأَلَ ثَوابٌ':Predicate, #1: 1	سَأَلَ ثَالِثٌ
u'سَأَلَ جَابِرٌ':Predicate, #2: 2	سَأَلَ الثَّوَابَ
u'سَالَ جُرْحٌ':Subject, #3: 3	سَأَلَ جَابِرَ
u'سَأَلَ جَمَاعَةٌ':Predicate, #2: 2	سَالَ جُرْحُهُ
u'سَأَلَ حاجَةٌ':Predicate, #1: 1	سَأَلَ الْجَمَاعَةَ
u'سَأَلَ حاكِمٌ':Predicate, #1: 1	سَأَلَ الْحَاجَةَ
u'سَأَلَ حاكِمٌ':Subject, #1: 1	سَأَلَ الْحَاكِمَ
u'سَأَلَ حالٌ':Predicate, #5: 5	سَأَلَ الْحَاكِمُ
u'سَأَلَ حَرْبٌ':Subject, #1: 1	سَأَلَ حَالَ
u'سَأَلَ حَسَنٌ':Predicate, #1: 1	سَأَلَ حَرْبٌ
u'سَأَلَ حَكَمٌ':Predicate, #2: 2	سَأَلَ الْحَسَنَ
u'سَأَلَ حَنَفِيَّةٌ':Predicate, #1: 1	سَأَلَ الْحَكَمَ
u'سَأَلَ خَاطِبٌ':Subject, #1: 1	سَأَلَ الْحَنَفِيَّةَ
u'سَأَلَ خَصْمٌ':Subject, #1: 1	سَأَلَ الْخَاطِبُ
u'سَالَ دَمٌ':Subject, #3: 3	سَأَلَ الْخَصْمُ
u'سَالَ دَمٌ':Subject, #1: 1	سَالَ الدّمُ
u'سَالَ دَمٌ':Subject, #1: 1	سَالَ دَمُ
u'سَالَ دمع':Subject, #22: 22	سَالَ الدَّمُ
u'سَالَ دَمْعٌ':Subject, #1: 1	سَالَ دَمْعُهُ
u'سَالَ ذَهَبٌ':Subject, #1: 1	سَالَ دَمْعُهُ
u'سَأَلَ رَافِعٌ':Predicate, #1: 1	سَالَ الذَّهَبُ
u'سَأَلَ رَبُّ':Subject, #2: 2	سَأَلَ رَافِعَ
u'سَأَلَ رجعة':Predicate, #3: 3	سَأَلَ رَبّهُ
u'سَأَلَ رَجْعَةٌ':Predicate, #4: 4	سَأَلَ الرَّجْعَةَ
u'سَأَلَ رَجُلٌ':Predicate, #4: 4	سَأَلَ الرَّجْعَةَ
u'سَأَلَ رَجُلٌ':Predicate, #2: 2	سَأَلَ الرَّجُلَ
u'سَأَلَ رَجُلٌ':Subject, #3: 3	سَأَلَ رَجُلاً
u'سَأَلَ رَجُلٌ':Subject, #1: 1	سَأَلَ الرَّجُلُ
u'سَأَلَ رحمة':Predicate, #52: 52	سَأَلَ رَجُلٌ
u'سَأَلَ رَحْمَةٌ':Predicate, #1: 1	سَأَلَ الرَّحْمَةَ
u'سَأَلَ رُخْصَةٌ':Predicate, #1: 1	سَأَلَ الرَّحْمَةَ
u'سَأَلَ رَسُولٌ':Predicate, #2: 2	سَأَلَ الرُّخْصَةَ
u'سَأَلَ رَسُولٌ':Subject, #96: 96	سَأَلَ رَسُولَ
u'سَأَلَ رَشيدٌ':Subject, #7: 7	سَأَلَ رَسُولُ
u'سَالَ رعاف':Subject, #2: 2	سَأَلَ الرَّشِيدُ
u'سَالَ رُعافٌ':Subject, #1: 1	سَالَ رُعَافُهُ
u'سَأَلَ زانِي':Predicate, #1: 1	سَالَ رُعَافُهُ
u'سَأَلَ زَوْجٌ':Predicate, #1: 1	سَأَلَ الزَّانِيَ
u'سَأَلَ زَوْجٌ':Subject, #1: 1	سَأَلَ الزَّوْجَ
u'سَأَلَ زَيْدٌ':Predicate, #2: 2	سَأَلَ الزَّوْجُ
u'سَأَلَ سَالِمٌ':Predicate, #4: 4	سَأَلَ زَيْدَ
u'سَأَلَ سَائِبٌ':Predicate, #2: 2	سَأَلَ سَالِمَ
u'سَأَلَ سائِل':Subject, #1: 1	سَأَلَ السَّائِبَ
u'سَأَلَ سَائِلٌ':Subject, #12: 12	سَأَلَ سَائِلٌ
u'سَأَلَ سائِل':Subject, #12: 12	سَأَلَ سَائِلٌ
u'سَأَلَ سَائِلٌ':Subject, #2: 2	سَأَلَ السَّائِلُ
u'سَأَلَ سَعْدٌ':Predicate, #2: 2	سَأَلَ السَّائِلُ
u'سَأَلَ سَعِيدٌ':Predicate, #2: 2	سَأَلَ سَعْدَ
u'سَالَ سَقْفٌ':Subject, #5: 5	سَأَلَ سَعِيدَ
u'سَالَ سَيْل':Subject, #1: 1	سَالَ سَقْفُ
u'سَأَلَ شَابٌّ':Subject, #2: 2	سَالَ السَّيْلُ
u'سَأَلَ شافِعِيّ':Predicate, #1: 1	سَأَلَ شَابٌّ
u'سَأَلَ شافِعِيّ':Subject, #1: 1	سَأَلَ الشَّافِعِيَّ
u'سَأَلَ شَجَرَةٌ':Subject, #1: 1	سَأَلَ الشَّافِعِيُّ
u'سَأَلَ شَعْبِيٌّ':Predicate, #1: 1	سَأَلَ شَجَرَةُ
u'سَأَلَ شُهُودٌ':Predicate, #1: 1	سَأَلَ الشَّعْبِيَّ
u'سَأَلَ شَيْخٌ':Subject, #1: 1	سَأَلَ الشُّهُودَ
u'سَأَلَ شَيْخٌ':Subject, #1: 1	سَأَلَ الشَّيْخُ
u'سَأَلَ شَيْخٌ':Subject, #1: 1	سَأَلَ شَيْخٌ
u'سَأَلَ صَحَابَةٌ':Subject, #2: 2	سَأَلَ شَيْخُ
u'سَأَلَ صدقة':Predicate, #1: 1	سَأَلَ الصَّحَابَةُ
u'سَأَلَ صَدَقَةٌ':Predicate, #1: 1	سَأَلَ الصَّدَقَةَ
u'سَأَلَ صَفْوَان':Subject, #1: 1	سَأَلَ الصَّدَقَةَ
u'سَأَلَ طَبِيبٌ':Subject, #2: 2	سَأَلَ صَفْوَانُ
u'سَأَلَ عَاصِمٌ':Predicate, #1: 1	سَأَلَ طَبِيبٌ
u'سَأَلَ عَامِلٌ':Subject, #1: 1	سَأَلَ عَاصِمَ
u'سَأَلَ عَائِشٌ':Predicate, #2: 2	سَأَلَ الْعَامِلُ
u'سَأَلَ عَبْدٌ':Predicate, #14: 14	سَأَلَ عَائِشَةَ
u'سَأَلَ عَبْدٌ':Subject, #13: 13	سَأَلَ عَبْدَ
u'سَالَ عَرَقٌ':Subject, #2: 2	سَأَلَ عَبْدُ
u'سَأَلَ عُرْوَةٌ':Predicate, #1: 1	سَالَ الْعَرَقُ
u'سَأَلَ عَطَاءٌ':Subject, #2: 2	سَأَلَ عُرْوَةَ
u'سَأَلَ عَفْوٌ':Predicate, #1: 1	سَأَلَ عَطَاءٌ
u'سَأَلَ عقبة':Subject, #1: 1	سَأَلَ الْعَفْوَ
u'سَأَلَ عُقْبَةٌ':Subject, #1: 1	سَأَلَ عُقْبَةُ
u'سَأَلَ عَلْقَم':Subject, #1: 1	سَأَلَ عُقْبَةُ
u'سَأَلَ عَلْقَمَة':Subject, #1: 1	سَأَلَ عَلْقَمَةُ
u'سَأَلَ عَلِيٌّ':Subject, #1: 1	سَأَلَ عَلْقَمَةُ
u'سَأَلَ عَلِيٌّ':Subject, #1: 1	سَأَلَ عَلِيٌّ
u'سَأَلَ عُمَرٌ':Predicate, #1: 1	سَأَلَ عَلِيُّ
u'سَأَلَ عُمَرٌ':Subject, #8: 8	سَأَلَ عُمَرَ
u'سَأَلَ عَمَلٌ':Predicate, #3: 3	سَأَلَ عُمَرُ
u'سَأَلَ غَنَمٌ':Predicate, #1: 1	سَأَلَ الْعَمَلَ
u'سَأَلَ فقهاء':Predicate, #1: 1	سَأَلَ الْغَنَمَ
u'سَأَلَ فَقِيهٌ':Subject, #2: 2	سَأَلَ الْفُقَهَاءَ
u'سَأَلَ فلان':Predicate, #1: 1	سَأَلَ الْفَقِيهُ
u'سَأَلَ فلان':Predicate, #1: 1	سَأَلَ الشَّافِعِيَّ
u'سَأَلَ فلان':Predicate, #1: 1	سَأَلَ النّسّابَةَ
u'سَأَلَ فلان':Predicate, #1: 1	سَأَلَ بِلاَلاً
u'سَأَلَ فلان':Predicate, #1: 1	سَأَلَ جَعْفَرَ
u'سَأَلَ فلان':Predicate, #2: 2	سَأَلَ حُذَيْفَةَ
u'سَأَلَ فلان':Predicate, #2: 2	سَأَلَ سُفْيَانَ
u'سَأَلَ فلان':Subject, #5: 5	سَأَلَ عُثْمَانَ
u'سَأَلَ فلان':Subject, #1: 1	سَأَلَ الشَّافِعِيُّ
u'سَأَلَ فلان':Subject, #1: 1	سَأَلَ تَمِيمٌ
u'سَأَلَ فلان':Subject, #1: 1	سَأَلَ دَاوُدُ
u'سَأَلَ فلان':Subject, #1: 1	سَأَلَ مُعَاوِيَةُ
u'سَأَلَ فلان':Subject, #2: 2	سَأَلَ قَتَادَةُ
u'سَأَلَ قَاذِفٌ':Predicate, #2: 2	سَأَلَ هَارُونُ
u'سَأَلَ قَاسِمٌ':Predicate, #1: 1	سَأَلَ الْقَاذِفَ
u'سَأَلَ قَالٌ':Predicate, #3: 3	سَأَلَ الْقَاسِمَ
u'سَالَ قَالٌ':Predicate, #1: 1	سَأَلَ قَالَ
u'سَأَلَ قَتاد':Subject, #1: 1	سَالَ قَالَ
u'سَأَلَ قُتَيْبَةٌ':Predicate, #2: 2	سَأَلَ قَتَادَةُ
u'سَأَلَ قَضَاءٌ':Predicate, #1: 1	سَأَلَ قُتَيْبَةَ
u'سَالَ قَلِيلٌ':Subject, #1: 1	سَأَلَ الْقَضَاءَ
u'سَأَلَ كَافِرٌ':Subject, #1: 1	سَالَ الْقَلِيلُ
u'سَأَلَ كَعْبٌ':Predicate, #1: 1	سَأَلَ الْكَافِرُ
u'سَالَ لعاب':Subject, #1: 1	سَأَلَ كَعْبَ
u'سَالَ لُعَابٌ':Subject, #1: 1	سَالَ لُعَابُ
u'سَالَ لعاب':Subject, #1: 1	سَالَ لُعَابُ
u'سَالَ لُعَابٌ':Subject, #2: 2	سَالَ لُعَابُهُ
u'سَالَ مَاءٌ':Subject, #2: 2	سَالَ لُعَابُهُ
u'سَالَ مَاءٌ':Subject, #2: 2	سَالَ مَاءُ
u'سَأَلَ مَالِكٌ':Subject, #4: 4	سَالَ الْمَاءُ
u'سَأَلَ مُحَمَّدٌ':Predicate, #2: 2	سَأَلَ مَالِكٌ
u'سَأَلَ مُحَمَّدٌ':Subject, #1: 1	سَأَلَ مُحَمَّدَ
u'سَالَمَ حَيٌّ':Subject, #1: 1	سَأَلَ مُحَمَّدُ
u'سَالَمَ حَيَّاتٌ':Subject, #1: 1	سَالَمَ الْحَيّاتُ
u'سَالَمَ حَيَّةٌ':Subject, #1: 1	سَالَمَ الْحَيّاتُ
u'سَأَلَ مُدَّعِي':Predicate, #1: 1	سَالَمَ الْحَيّاتُ
u'سَأَلَ مَدِينٌ':Predicate, #4: 4	سَأَلَ الْمُدَّعِيَ
u'سَأَلَ مَدْيُونٌ':Predicate, #1: 1	سَأَلَ الْمَدِينَ
u'سَأَلَ مُرْتَدٌّ':Subject, #1: 1	سَأَلَ الْمَدْيُونَ
u'سَأَلَ مَسْكَنَةٌ':Predicate, #1: 1	سَأَلَ الْمُرْتَدُّ
u'سَأَلَ مُشْتَرِي':Predicate, #2: 2	سَأَلَ الْمَسْكَنَةَ
u'سَالَ مَطَرٌ':Subject, #1: 1	سَأَلَ الْمُشْتَرِيَ
u'سَأَلَ مُعاوِيَة':Subject, #1: 1	سَالَ مَطَرٌ
u'سَأَلَ مَقْذُوفٌ':Subject, #1: 1	سَأَلَ مُعَاوِيَةُ
u'سَأَلَ مَلاَئِكَةٌ':Predicate, #1: 1	سَأَلَ الْمَقْذُوفُ
u'سَالَ مَنْخَرٌ':Subject, #1: 1	سَأَلَ الْمَلَائِكَةَ
u'سَالَ مَنِيٌّ':Subject, #1: 1	سَالَ مَنْخَرَاهُ
u'سَأَلَ مُودِعٌ':Predicate, #1: 1	سَالَ الْمَنِيُّ
u'سَأَلَ نَاسٌ':Predicate, #1: 1	سَأَلَ الْمُودِعَ
u'سَأَلَ نَبِيٌّ':Predicate, #20: 20	سَأَلَ النَّاسَ
u'سَأَلَ نَبِيٌّ':Subject, #65: 65	سَأَلَ النَّبِيَّ
u'سَالَ نَجَسٌ':Subject, #2: 2	سَأَلَ النَّبِيُّ
u'سَأَلَ نَجْمٌ':Subject, #1: 1	سَالَ النَّجَسُ
u'سَأَلَ نَسّاب':Predicate, #1: 1	سَأَلَ نَجْمُ
u'سَأَلَ نُعْمَانُ':Predicate, #1: 1	سَأَلَ النّسّابَةَ
u'سَأَلَ وَالِدٌ':Predicate, #1: 1	سَأَلَ النُّعْمَانَ
u'سَالَ وَجَبٌ':Predicate, #1: 1	سَأَلَ الْوَالِدَ
u'سَأَلَ وَسَاطَةٌ':Predicate, #2: 2	سَالَ وَجَبَ
u'سَأَلَ وَصِيٌّ':Subject, #1: 1	سَأَلَ الْوَسَاطَةَ
u'سَأَلَ وَكِيلٌ':Predicate, #1: 1	سَأَلَ وَصِيٌّ
u'سَأَلَ وَكِيلٌ':Subject, #2: 2	سَأَلَ الْوَكِيلَ
u'سَأَلَ وَلَهٌ':Subject, #1: 1	سَأَلَ الْوَكِيلُ
u'سَأَلَ وَلِيٌّ':Subject, #11: 11	سَأَلَ وَلَهُ
u'سَأَلَ وَلِيٌّ':Subject, #1: 1	سَأَلَ الْوَلِيُّ
u'سَامَ بَائِعٌ':Subject, #1: 1	سَأَلَ وَلِيُّهُ
u'سَامَحَ شَرْعٌ':Subject, #2: 2	سَامَ الْبَائِعُ
u'سَامَى مُلُوكٌ':Predicate, #1: 1	سَامَحَ الشَّرْعُ
u'سَاوَمَ رَجُلٌ':Predicate, #1: 1	سَامَى الْمُلُوكَ
u'سَاوَمَ رَجُلٌ':Subject, #1: 1	سَاوَمَ رَجُلاً
u'سَاوَمَ شَفِيعٌ':Subject, #1: 1	سَاوَمَ الرَّجُلُ
u'سَاوَمَ وَكِيلٌ':Predicate, #3: 3	سَاوَمَ الشَّفِيعُ
u'سَاوَى اِبْنٌ':Subject, #1: 1	سَاوَمَ وَكِيلَ
u'سَاوَى أقَلُّ':Subject, #2: 2	سَاوَى ابْنُ
u'سَاوَى أَكْثَرُ':Predicate, #1: 1	سَاوَى الْأَقَلُّ
u'سَاوَى إمَامٌ':Subject, #1: 1	سَاوَى الْأَكْثَرَ
u'سَاوَى بَيْنٌ':Predicate, #1: 1	سَاوَى الْإِمَامُ
u'سَاوَى تارِك':Predicate, #2: 2	سَاوَى بَيْنَ
u'سَاوَى تُلولٌ':Predicate, #1: 1	سَاوَى التَّارِكِينَ
u'سَاوَى ثَمَرٌ':Predicate, #1: 1	سَاوَى التُّلُولَ
u'سَاوَى ثَمَنٌ':Predicate, #1: 1	سَاوَى الثَّمَرَ
u'سَاوَى حَقِيقِيٌّ':Predicate, #3: 3	سَاوَى الثَّمَنَ
u'سَاوَى دَيْنٌ':Subject, #1: 1	سَاوَى الْحَقِيقِيَّ
u'سَاوَى دَيْنٌ':Subject, #1: 1	سَاوَى الدَّيْنُ
u'سَاوَى رُبْعٌ':Predicate, #1: 1	سَاوَى دَيْنُهُ
u'سَاوَى رَهْنٌ':Subject, #1: 1	سَاوَى رُبْعَ
u'سَاوَى سَبْعٌ':Predicate, #1: 1	سَاوَى الرَّهْنُ
u'سَاوَى سَفِيهٌ':Subject, #1: 1	سَاوَى سَبْعَ
u'سَاوَى طعام':Predicate, #1: 1	سَاوَى السَّفِيهُ
u'سَاوَى طَعَامٌ':Predicate, #1: 1	سَاوَى الطَّعَامَ
u'سَاوَى ظِلٌّ':Subject, #1: 1	سَاوَى الطَّعَامَ
u'سَاوَى عَشْرٌ':Predicate, #1: 1	سَاوَى الظِّلُّ
u'سَاوَى قِيمَةٌ':Predicate, #1: 1	سَاوَى عَشْرَةً
u'سَاوَى قِيمَةٌ':Subject, #4: 4	سَاوَى قِيمَةَ
u'سَاوَى كَلاَمٌ':Predicate, #1: 1	سَاوَى قِيمَةُ
u'سَاوَى مَالٌ':Predicate, #1: 1	سَاوَى كَلَامَ
u'سَاوَى مَالٌ':Subject, #1: 1	سَاوَى مَالَ
u'سَاوَى مَالِكٌ':Subject, #1: 1	سَاوَى مَالُهُ
u'سَاوَى مَجَازٌ':Subject, #1: 1	سَاوَى مَالِكٌ
u'سَاوَى مُرْتَدٌّ':Subject, #2: 2	سَاوَى الْمَجَازُ
u'سَاوَى مَرَضٌ':Predicate, #1: 1	سَاوَى الْمُرْتَدُّ
u'سَاوَى مُسَافِرٌ':Predicate, #1: 1	سَاوَى مَرَضَ
u'سَاوَى نِصْفٌ':Predicate, #1: 1	سَاوَى الْمُسَافِرَ
u'سَاوَى نكاح':Subject, #1: 1	سَاوَى نِصْفَ
u'سَاوَى نِكَاحٌ':Subject, #1: 1	سَاوَى النِّكَاحُ
u'سَايَرَ بَعْضٌ':Predicate, #1: 1	سَاوَى النِّكَاحُ
u'سِبَاحَةٌ مَاءٌ':Added, #1: 1	سَايَرَ بَعْضَ
u'سَبَّ أَصْحَابٌ':Predicate, #1: 1	سِبَاحَةُ الْمَاءِ
u'سَبَّ أُمٌّ':Predicate, #5: 5	سَبَّ أَصْحَابَ
u'سَبَّ أَميرٌ':Predicate, #1: 1	سَبَّ أُمَّ
u'سَبَّ بَارِي':Predicate, #2: 2	سَبَّ الْأَمِيرَ
u'سَبَّبَ أسْبَابٌ':Predicate, #1: 1	سَبَّ الْبَارِيَ
u'سَبَّبَ أَسْبَابٌ':Predicate, #1: 1	سَبَّبَ الْأَسْبَابَ
u'سَبَّبَ ضَمَانٌ':Predicate, #1: 1	سَبَّبَ الْأَسْبَابَ
u'سَبَّحَ رَسُولٌ':Subject, #1: 1	سَبَّبَ الضَّمَانَ
u'سَبَّحَ سبحة':Predicate, #1: 1	سَبَّحَ رَسُولُ
u'سَبَّحَ سُبْحَةٌ':Predicate, #2: 2	سَبَّحَ سُبْحَةَ
u'سَبَّحَ مرٌّ':Predicate, #2: 2	سَبَّحَ سُبْحَةَ
u'سَبَّحَ مَكَانٌ':Predicate, #1: 1	سَبَّحَ مَرَّةً
u'سَبَّ خُلَفَاءُ':Predicate, #2: 2	سَبَّحَ مَكَانَ
u'سَبَّ دَهْرٌ':Predicate, #1: 1	سَبَّ الْخُلَفَاءَ
u'سَبَّ دِيَةٌ':Predicate, #1: 1	سَبَّ الدَّهْرَ
u'سَبْرٌ إِخْوَانٌ':Added, #1: 1	سَبَّ الدِّيَةَ
u'سَبْرٌ أئِمَّةٌ':Added, #1: 1	سَبْرُ الْإِخْوَانِ
u'سَبَّ رَسُولٌ':Predicate, #1: 1	سَبْرِ الْأَئِمَّةِ
u'سَبَّ رَسُولٌ':Predicate, #1: 1	سَبَّ الرَّسُولَ
u'سَبَرَ عواقب':Predicate, #5: 5	سَبَّ رَسُولَ
u'سَبَرَ عَوَاقِبُ':Predicate, #1: 1	سَبَرَ الْعَوَاقِبَ
u'سَبَرَ مَذَاهِبُ':Predicate, #1: 1	سَبَرَ الْعَوَاقِبَ
u'سَبْرٌ مُعْتَرِضٌ':Added, #1: 1	سَبَرَ مَذَاهِبَ
u'سَبْرٌ وُجُوهٌ':Added, #1: 1	سَبْرِ الْمُعْتَرِضِ
u'سَبَّ سَائِرٌ':Predicate, #1: 1	سَبْرِ وُجُوهِ
u'سَبَّ سَكْرَان':Subject, #1: 1	سَبَّ سَائِرَ
u'سَبَّ شَعْبِيٌّ':Predicate, #1: 1	سَبَّ سَكْرَانُ
u'سَبَّ شُهُودٌ':Predicate, #1: 1	سَبَّ الشَّعْبِيَّ
u'سَبَّ صَاحِبٌ':Predicate, #1: 1	سَبَّ الشُّهُودَ
u'سَبَّ صَحَابَةٌ':Predicate, #1: 1	سَبَّ صَاحِبَ
u'سَبْطٌ شَعْرٌ':Added, #2: 2	سَبَّ الصَّحَابَةَ
u'سَبْطٌ شِعْرٌ':Added, #1: 1	سَبْطُ الشّعْرِ
u'سَبْطٌ شَعَرٌ':Added, #1: 1	سَبْطُ الشّعْرِ
u'سَبْطٌ يَدٌ':Added, #2: 2	سَبْطَ الشَّعَرِ
u'سَبَّ عَائِشٌ':Predicate, #1: 1	سَبْطَ الْيَدَيْنِ
u'سَبَّ غير':Predicate, #5: 5	سَبَّ عَائِشَةَ
u'سَبَّ غَيْرٌ':Predicate, #1: 1	سَبَّ غَيْرَ
u'سَبَقَ اِبْنٌ':Predicate, #1: 1	سَبَّ غَيْرَ
u'سَبْقٌ اِبْنٌ':Added, #1: 1	سَبَقَ ابْنَ
u'سَبَقَ أَجَلٌ':Subject, #2: 2	سَبْقُ ابْنِ
u'سَبْقٌ إِجْمَالٌ':Added, #1: 1	سَبَقَ أَجَلُ
u'سَبَقَ أحَدٌ':Predicate, #1: 1	سَبْقِ إجْمَالٍ
u'سَبَقَ أحَدٌ':Subject, #1: 1	سَبَقَ الْأَحَدَ
u'سَبَقَ أحَدٌ':Subject, #2: 2	سَبَقَ أَحَدٌ
u'سَبْقٌ أحَدٌ':Added, #4: 4	سَبَقَ أَحَدُ
u'سَبَقَ إِحْرَازٌ':Subject, #2: 2	سَبْقَ أَحَدِ
u'سَبَقَ إِحْرَامٌ':Predicate, #1: 1	سَبَقَ إحْرَازُهُ
u'سَبَقَ اِخْتِيَارٌ':Subject, #1: 1	سَبَقَ الْإِحْرَامَ
u'سَبَقَ آخِرُ':Predicate, #1: 1	سَبَقَ اخْتِيَارُ
u'سَبْقٌ آخِرُ':Added, #2: 2	سَبَقَ آخِرَ
u'سَبَقَ أَخَصُّ':Subject, #1: 1	سَبْقِ آخِرِ
u'سَبَقَ إِذْنٌ':Subject, #4: 4	سَبَقَ أَخَصُّ
u'سَبَقَ إِرْسَالٌ':Subject, #1: 1	سَبَقَ الْإِذْنُ
u'سَبْقٌ إِرْسَالٌ':Added, #1: 1	سَبَقَ الْإِرْسَالُ
u'سَبَقَ اِسْتِبْدَادٌ':Subject, #2: 2	سَبْقَ الْإِرْسَالِ
u'سَبَقَ اِسْتِحْقَاقٌ':Subject, #1: 1	سَبَقَ اسْتِبْدَادُ
u'سَبْقٌ اِسْتِطاعَةٌ':Added, #1: 1	سَبَقَ اسْتِحْقَاقُ
u'سَبَقَ اِسْتِعْمالٌ':Subject, #1: 1	سَبْقِ اسْتِطَاعَةِ
u'سَبَقَ اِسْتِلْحاق':Subject, #1: 1	سَبَقَ اسْتِعْمَالُهُ
u'سَبَقَ إِسْلامٌ':Subject, #1: 1	سَبَقَ اسْتِلْحَاقُهُ
u'سَبْقٌ إِسْلامٌ':Added, #1: 1	سَبَقَ إسْلَامُ
u'سَبَقَ إِسْنادٌ':Subject, #1: 1	سَبْقِ إسْلَامِهِ
u'سَبْقٌ إِشْكالٌ':Added, #1: 1	سَبَقَ إسْنَادُهُ
u'سَبَقَ أصل':Subject, #1: 1	سَبْقِ إشْكَالٍ
u'سَبَقَ أًصْلٌ':Subject, #1: 1	سَبَقَ أَصْلُ
u'سَبَقَ أصل':Subject, #1: 1	سَبَقَ أَصْلُ
u'سَبَقَ أًصْلٌ':Subject, #1: 1	سَبَقَ أَصْلُهُ
u'سَبَقَ إِطْلاقٌ':Subject, #1: 1	سَبَقَ أَصْلُهُ
u'سَبَقَ اِعْتِبارٌ':Predicate, #1: 1	سَبَقَ إطْلَاقُ
u'سَبَقَ إقْرَارٌ':Subject, #1: 1	سَبَقَ اعْتِبَارَ
u'سَبَقَ إقْرَارٌ':Subject, #1: 1	سَبَقَ إقْرَارُهُ
u'سَبَقَ أَكْثَرُ':Predicate, #1: 1	سَبَقَ الْإِقْرَارُ
u'سَبَقَ أكْرَمُ':Subject, #1: 1	سَبَقَ أَكْثَرَ
u'سَبَقَ إمَامٌ':Predicate, #1: 1	سَبَقَ أَكْرَمُ
u'سَبَقَ إمَامٌ':Subject, #7: 7	سَبَقَ الْإِمَامَ
u'سَبَقَ إمَامٌ':Subject, #1: 1	سَبَقَ الْإِمَامُ
u'سَبْقٌ إمَامٌ':Added, #3: 3	سَبَقَ إمَامُهُ
u'سَبْقٌ إمَامٌ':Added, #1: 1	سَبْقَ إمَامِهِ
u'سَبَقَ اِمْتِناعٌ':Subject, #2: 2	سَبْقُ الْإِمَامِ
u'سَبْقٌ إِنْزالٌ':Added, #1: 1	سَبَقَ امْتِنَاعُ
u'سَبَقَ اِنْفِساخٌ':Predicate, #1: 1	سَبْقِ الْإِنْزَالِ
u'سَبَقَ اِنْقِسَامٌ':Subject, #1: 1	سَبَقَ انْفِسَاخَ
u'سَبْقٌ إِنْكارٌ':Added, #1: 1	سَبَقَ انْقِسَامُ
u'سَبَقَ أَوَّلُ':Predicate, #1: 1	سَبْقِ إنْكَارِهِ
u'سَبَقَ أَوَّلُ':Subject, #6: 6	سَبَقَ أَوَّلَ
u'سَبَقَ أَوَّلُ':Subject, #1: 1	سَبَقَ الْأَوَّلُ
u'سَبْقٌ أَوَّلُ':Added, #1: 1	سَبَقَ أَوَّلُ
u'سَبَقَ بَائِعٌ':Subject, #1: 1	سَبْقِ الْأَوَّلِ
u'سَبَقَ بسط':Subject, #2: 2	سَبَقَ الْبَائِعُ
u'سَبَقَ بَسْطٌ':Subject, #2: 2	سَبَقَ بَسْطُ
u'سَبَقَ بَعْضٌ':Subject, #2: 2	سَبَقَ بَسْطُ
u'سَبَقَ بِنَاءٌ':Subject, #1: 1	سَبَقَ بَعْضُ
u'سَبْقٌ بِنْتٌ':Added, #1: 1	سَبَقَ الْبِنَاءُ
u'سَبَقَ بَوْلٌ':Subject, #1: 1	سَبْقِ الْبِنْتِ
u'سَبْقٌ بَوْلٌ':Added, #1: 1	سَبَقَ بَوْلُهُ
u'سَبَقَ بَيَانٌ':Predicate, #1: 1	سَبْقِ بَوْلِهِ
u'سَبَقَ بَيَانٌ':Subject, #1: 1	سَبَقَ بَيَانَ
u'سَبَقَ بَيَانٌ':Subject, #19: 19	سَبَقَ بَيَانُهُ
u'سَبَقَ بَيْعٌ':Predicate, #7: 7	سَبَقَ بَيَانُ
u'سَبَّقَ بَيْنٌ':Predicate, #1: 1	سَبَقَ الْبَيْعَ
u'سَبَقَ تَارِيخٌ':Subject, #2: 2	سَبَّقَ بَيْنَ
u'سَبَقَ تَارِيخٌ':Subject, #1: 1	سَبَقَ تَارِيخٌ
u'سَبَقَ تَارِيخٌ':Subject, #1: 1	سَبَقَ تَارِيخُهُ
u'سَبْقٌ تَارِيخٌ':Added, #8: 8	سَبَقَ تَارِيخُ
u'سَبْقٌ تَارِيخٌ':Added, #1: 1	سَبْقِ التَّارِيخِ
u'سَبْقٌ تَارِيخٌ':Added, #3: 3	سَبْقِ تَارِيخِ
u'سَبْقٌ تَارِيخٌ':Added, #4: 4	سَبْقَ التَّارِيخِ
u'سَبَقَ تَثَبُّت':Subject, #7: 7	سَبْقُ التَّارِيخِ
u'سَبَقَ تَحْرِيرٌ':Subject, #1: 1	سَبَقَ التَّثَبُّتُ
u'سَبَقَ تَحْرِيرٌ':Subject, #1: 1	سَبَقَ تَحْرِيرُ
u'سَبَقَ تَحْرِيمٌ':Subject, #1: 1	سَبَقَ تَحْرِيرُهُ
u'سَبَقَ تَحْرِيمٌ':Subject, #1: 1	سَبَقَ تَحْرِيمُ
u'سَبْقٌ تَحْرِيمٌ':Added, #3: 3	سَبَقَ تَحْرِيمُهُ
u'سَبْقٌ تَحْرِيم':Added, #2: 2	سَبْقِ التَّحْرِيمِ
u'سَبْقٌ تَحَقُّقٌ':Added, #4: 4	سَبْقَ التَّحْرِيمَةِ
u'سَبَقَ تَخْرِيجٌ':Subject, #1: 1	سَبْقَ تَحَقُّقِهِ
u'سَبَقَ تَدْبِيرٌ':Subject, #1: 1	سَبَقَ تَخْرِيجُهُ
u'سَبَقَ تَرْتِيبٌ':Subject, #1: 1	سَبَقَ التَّدْبِيرُ
u'سَبَقَ تَرْجِيحٌ':Subject, #1: 1	سَبَقَ تَرْتِيبُهُ
u'سَبْقٌ تَرَدُّدٌ':Added, #2: 2	سَبَقَ تَرْجِيحُ
u'سَبَقَ تَزْوِيجٌ':Subject, #1: 1	سَبْقِ تَرَدُّدٍ
u'سَبَقَ تَصْرِيحٌ':Subject, #1: 1	سَبَقَ تَزْوِيجُ
u'سَبَقَ تَصْوِيرٌ':Subject, #4: 4	سَبَقَ التَّصْرِيحُ
u'سَبَقَ تَعَلُّقٌ':Subject, #1: 1	سَبَقَ تَصْوِيرُ
u'سَبَقَ تَعْلِيقٌ':Subject, #1: 1	سَبَقَ تَعَلُّقُهُ
u'سَبَقَ تَعْلِيقٌ':Subject, #1: 1	سَبَقَ تَعْلِيقُ
u'سَبْقٌ تَعْمِيمٌ':Added, #1: 1	سَبَقَ تَعْلِيقُهُ
u'سَبَقَ تَفْصِيلٌ':Subject, #1: 1	سَبْقَ التَّعْمِيمِ
u'سَبْقٌ تَقْديرٌ':Added, #1: 1	سَبَقَ تَفْصِيلُهُ
u'سَبَقَ تَقْريرٌ':Subject, #1: 1	سَبْقَ تَقْدِيرِ
u'سَبَقَ تَقْريرٌ':Subject, #15: 15	سَبَقَ تَقْرِيرُهُ
u'سَبْقٌ تَكْليفٌ':Added, #1: 1	سَبَقَ التَّقْرِيرُ
u'سَبَقَ تَمْثيلٌ':Subject, #1: 1	سَبْقُ تَكْلِيفٍ
u'سَبْقٌ تَهْدِيدٌ':Added, #1: 1	سَبَقَ التَّمْثِيلُ
u'سَبَقَ تَوْفِيقٌ':Subject, #1: 1	سَبْقِ التَّهْدِيدِ
u'سَبْقٌ تَوْقِيفٌ':Added, #1: 1	سَبَقَ التَّوْفِيقُ
u'سَبَقَ تَوْكِيلٌ':Subject, #1: 1	سَبْقُ التَّوْقِيفِ
u'سَبَقَ تَوْلِيَةٌ':Subject, #2: 2	سَبَقَ تَوْكِيلُ
u'سَبْقٌ تَوْلِيَةٌ':Added, #2: 2	سَبَقَ تَوْلِيَةُ
u'سَبَقَ تَوَهُّمٌ':Subject, #1: 1	سَبْقِ التَّوْلِيَةِ
u'سَبَقَ ثَالِثٌ':Subject, #1: 1	سَبَقَ تَوَهُّمُ
u'سَبْقٌ ثَالِثٌ':Added, #2: 2	سَبَقَ الثَّالِثُ
u'سَبْقٌ ثُبُوتٌ':Added, #1: 1	سَبْقُ الثَّالِثِ
u'سَبْقٌ ثُبُوتٌ':Added, #1: 1	سَبْقُ ثُبُوتِ
u'سَبَقَ ثَلاثَةٌ':Subject, #1: 1	سَبْقَ ثُبُوتِهِ
u'سَبَقَ ثَوابٌ':Subject, #1: 1	سَبَقَ ثَلَاثَةٌ
u'سَبْقٌ جُزْءٌ':Added, #1: 1	سَبَقَ الثَّوَابُ
u'سَبْقٌ جمعة':Added, #1: 1	سَبْقُ الْجُزْءِ
u'سَبْقٌ جُمُعَةٌ':Added, #1: 1	سَبْقِ الْجُمُعَةِ
u'سَبْقٌ جمعة':Added, #1: 1	سَبْقِ الْجُمُعَةِ
u'سَبَقَ جُمْلَةٌ':Subject, #1: 1	سَبْقُ جُمُعَتِهِ
u'سَبَقَ جَمِيلٌ':Subject, #1: 1	سَبَقَ جُمْلَةٌ
u'سَبَقَ جِنَايَةٌ':Subject, #1: 1	سَبَقَ جَمِيلُ
u'سَبَقَ جَوَابٌ':Predicate, #1: 1	سَبَقَ جِنَايَةٌ
u'سَبَقَ جَوَابٌ':Subject, #1: 1	سَبَقَ الْجَوَابَ
u'سَبَقَ جُوعٌ':Subject, #1: 1	سَبَقَ الْجَوَابُ
u'سَبَقَ حاجٌّ':Predicate, #1: 1	سَبَقَ جُوعٌ
u'سَبَقَ حاجٌّ':Subject, #3: 3	سَبَقَ الْحَاجَّ
u'سَبْقٌ حَجْرٌ':Added, #2: 2	سَبَقَ الْحَاجُّ
u'سَبَقَ حَدَثٌ':Subject, #2: 2	سَبْقَ الْحَجْرِ
u'سَبْقٌ حَدَثٌ':Added, #2: 2	سَبَقَ الْحَدَثُ
u'سَبْقٌ حَدَثٌ':Added, #1: 1	سَبْقُ حَدَثٍ
u'سَبْقٌ حَدَثٌ':Added, #1: 1	سَبْقُ حَدَثِهِ
u'سَبْقٌ حَدَثٌ':Added, #27: 27	سَبْقِ الْحَدَثِ
u'سَبْقٌ حَدَثٌ':Added, #2: 2	سَبْقُ الْحَدَثِ
u'سَبْقٌ حَدَثٌ':Added, #4: 4	سَبْقَ الْحَدَثِ
u'سَبَقَ حَديثٌ':Predicate, #4: 4	سَبْقِ حَدَثٍ
u'سَبَقَ حَديثٌ':Subject, #1: 1	سَبَقَ الْحَدِيثَ
u'سَبَقَ حَديثٌ':Subject, #1: 1	سَبَقَ الْحَدِيثُ
u'سَبَقَ حَديثٌ':Subject, #1: 1	سَبَقَ حَدِيثُ
u'سَبْقٌ حَرْفٌ':Added, #1: 1	سَبَقَ حَدِيثُهُ
u'سَبْقٌ حُرْمَةٌ':Added, #1: 1	سَبْقَ حَرْفِ
u'سَبْقٌ حُضورٌ':Added, #1: 1	سَبْقِ الْحُرْمَةِ
u'سَبْقٌ حُضُورٌ':Added, #2: 2	سَبْقِ حُضُورِهِ
u'سَبْقٌ حَظْر':Added, #2: 2	سَبْقِ حُضُورِهِ
u'سَبَقَ حَقٌّ':Predicate, #1: 1	سَبْقِ الْحَظْرِ
u'سَبَقَ حَقٌّ':Subject, #1: 1	سَبَقَ حَقَّ
u'سَبْقٌ حَقٌّ':Added, #1: 1	سَبَقَ حَقُّهُ
u'سَبَقَ حِكَايَةٌ':Subject, #1: 1	سَبْقُ الْحَقِّ
u'سَبَقَ حُكْمٌ':Predicate, #1: 1	سَبَقَ حِكَايَةُ
u'سَبَقَ حُكْمٌ':Subject, #1: 1	سَبَقَ حُكْمَ
u'سَبَقَ حُكْمٌ':Subject, #3: 3	سَبَقَ حُكْمُهُ
u'سَبَقَ حُكْمٌ':Subject, #4: 4	سَبَقَ حُكْمُ
u'سَبْقٌ حُكْمٌ':Added, #5: 5	سَبَقَ الْحُكْمُ
u'سَبْقٌ حُكْمٌ':Added, #1: 1	سَبْقُ حُكْمٍ
u'سَبَقَ حِلٌّ':Subject, #2: 2	سَبْقِ الْحُكْمِ
u'سَبَقَ حَلالٌ':Subject, #1: 1	سَبَقَ الْحِلُّ
u'سَبَقَ حول':Subject, #2: 2	سَبَقَ حَلَالٌ
u'سَبَقَ حَوْلٌ':Subject, #5: 5	سَبَقَ حَوْلُ
u'سَبَقَ خَبَرٌ':Subject, #5: 5	سَبَقَ حَوْلُ
u'سَبَقَ خَبَر':Subject, #1: 1	سَبَقَ خَبَرُ
u'سَبَقَ خِذْلاَنٌ':Subject, #1: 1	سَبَقَ خَبَرُ
u'سَبْقٌ خُرُوجٌ':Added, #1: 1	سَبَقَ الْخِذْلَانُ
u'سَبْقٌ خُصُومَةٌ':Added, #2: 2	سَبْقِ الْخُرُوجِ
u'سَبْقٌ خُصُومَةٌ':Added, #1: 1	سَبْقُ الْخُصُومَةِ
u'سَبْقٌ خَفَاءٌ':Added, #3: 3	سَبْقِ خُصُومَةٍ
u'سَبَقَ خِلاَفٌ':Subject, #1: 1	سَبْقِ خَفَاءٍ
u'سَبَقَ خِلاَفٌ':Subject, #3: 3	سَبَقَ خِلَافُهُ
u'سَبَقَ خِلاَفٌ':Subject, #4: 4	سَبَقَ خِلَافٌ
u'سَبْقٌ خِلاَفٌ':Added, #8: 8	سَبَقَ الْخِلَافُ
u'سَبْقٌ خِلاَفٌ':Added, #4: 4	سَبْقِ الْخِلَافِ
u'سَبْقٌ خُلَفَاءُ':Added, #8: 8	سَبْقِ خِلَافٍ
u'سَبْقٌ خَلَلٌ':Added, #1: 1	سَبْقَ الْخُلَفَاءِ
u'سَبْقٌ دَاعِي':Added, #1: 1	سَبْقَ خَلَلِ
u'سَبَقَ دِرْهَمٌ':Subject, #1: 1	سَبْقُ الدَّاعِيَةِ
u'سَبَقَ دِرْهَم':Subject, #3: 3	سَبَقَ دِرْهَمٌ
u'سَبَقَ دَليلٌ':Subject, #3: 3	سَبَقَ دِرْهَمٌ
u'سَبَقَ دَمٌ':Predicate, #1: 1	سَبَقَ الدَّلِيلُ
u'سَبَقَ دونٌ':Predicate, #1: 1	سَبَقَ دَمَ
u'سَبَقَ ذُبابٌ':Subject, #1: 1	سَبَقَ دُونَ
u'سَبَقَ ذكر':Subject, #1: 1	سَبَقَ الذُّبَابُ
u'سَبَقَ ذِكْرٌ':Subject, #11: 11	سَبَقَ ذِكْرُ
u'سَبَقَ ذِكْرٌ':Subject, #11: 11	سَبَقَ ذِكْرُ
u'سَبَقَ ذكر':Subject, #1: 1	سَبَقَ ذِكْرٌ
u'سَبَقَ ذِكْرٌ':Subject, #31: 31	سَبَقَ ذِكْرُهُ
u'سَبْقٌ ذكر':Added, #31: 31	سَبَقَ ذِكْرُهُ
u'سَبْقٌ ذِكْرٌ':Added, #1: 1	سَبْقِ الذِّكْرِ
u'سَبْقٌ ذكر':Added, #1: 1	سَبْقِ الذِّكْرِ
u'سَبْقٌ ذِكْرٌ':Added, #1: 1	سَبْقُ ذِكْرِهِ
u'سَبْقٌ ذكر':Added, #1: 1	سَبْقُ ذِكْرِهِ
u'سَبْقٌ ذِكْرٌ':Added, #2: 2	سَبْقِ ذِكْرِهِ
u'سَبَقَ ذِهْنٌ':Subject, #2: 2	سَبْقِ ذِكْرِهِ
u'سَبْقٌ ذِهْنٌ':Added, #3: 3	سَبَقَ الذِّهْنُ
u'سَبْقٌ رجعة':Added, #1: 1	سَبْقِ الذِّهْنِ
u'سَبْقٌ رَجْعَةٌ':Added, #1: 1	سَبْقَ الرَّجْعَةِ
u'سَبَقَ رَجُلٌ':Subject, #1: 1	سَبْقَ الرَّجْعَةِ
u'سَبَقَ رَجُلٌ':Subject, #1: 1	سَبَقَ الرَّجُلُ
u'سَبَقَ رَدٌّ':Subject, #1: 1	سَبَقَ رَجُلٌ
u'سَبَقَ رَدٌّ':Subject, #1: 1	سَبَقَ رَدُّ
u'سَبَقَ رِدَّةٌ':Predicate, #1: 1	سَبَقَ رَدُّهُ
u'سَبَقَ رَسُولٌ':Subject, #1: 1	سَبَقَ رِدَّةَ
u'سَبَّقَ رَسُولٌ':Subject, #1: 1	سَبَقَ رَسُولُهُ
u'سَبَقَ رَسُولٌ':Subject, #2: 2	سَبَّقَ رَسُولُ
u'سَبَقَ رَفيقٌ':Subject, #4: 4	سَبَقَ رَسُولُ
u'سَبَقَ رُكوعٌ':Predicate, #1: 1	سَبَقَ رَفِيقُهُ
u'سَبْقٌ رَهْنٌ':Added, #1: 1	سَبَقَ الرُّكُوعَ
u'سَبَقَ رَوْضَةٌ':Subject, #1: 1	سَبْقِ الرَّهْنِ
u'سَبْقٌ رُؤْيَةٌ':Added, #1: 1	سَبَقَ رَوْضَةٌ
u'سَبَقَ رِياضَةٌ':Subject, #1: 1	سَبْقِ رُؤْيَةٍ
u'سَبْقٌ زَمانٌ':Added, #1: 1	سَبَقَ رِيَاضَةُ
u'سَبَقَ زَمَنٌ':Subject, #1: 1	سَبْقُ زَمَانٍ
u'سَبَقَ زَوْجٌ':Subject, #2: 2	سَبَقَ زَمَنُ
u'سَبْقٌ زَوْجٌ':Added, #1: 1	سَبَقَ الزَّوْجُ
u'سَبَقَ سَبْيٌ':Subject, #1: 1	سَبْقَ الزَّوْجِ
u'سَبْقٌ سَفَهٌ':Added, #1: 1	سَبَقَ سَبْيُ
u'سَبَقَ سقط':Predicate, #1: 1	سَبْقَ سَفَهِهِ
u'سَبَقَ سَقَطٌ':Predicate, #1: 1	سَبَقَ سَقَطَ
u'سَبْقٌ شافِعِيّ':Added, #1: 1	سَبَقَ سَقَطَ
u'سَبَقَ شَخْصٌ':Subject, #1: 1	سَبْقُ الشَّافِعِيِّ
u'سَبَقَ شَرٌّ':Subject, #1: 1	سَبَقَ شَخْصٌ
u'سَبَقَ شِرَاءٌ':Subject, #1: 1	سَبَقَ الشَّرُّ
u'سَبْقٌ شِرَاءٌ':Added, #1: 1	سَبَقَ الشِّرَاءُ
u'سَبْقٌ شِرَاءٌ':Added, #1: 1	سَبْقَ شِرَاءِ
u'سَبَقَ شَرْطٌ':Subject, #1: 1	سَبْقُ شِرَاءِ
u'سَبْقٌ شَرْطٌ':Added, #1: 1	سَبَقَ الشَّرْطُ
u'سَبْقٌ شَرْطٌ':Added, #1: 1	سَبْقَ الشَّرْطِ
u'سَبَقَ شَرِيكٌ':Subject, #1: 1	سَبْقِ الشَّرْطِ
u'سَبْقٌ شُعُورٌ':Added, #1: 1	سَبَقَ الشَّرِيكُ
u'سَبْقٌ شَكٌّ':Added, #1: 1	سَبْقُ الشُّعُورِ
u'سَبْقٌ شَهَادَةٌ':Added, #1: 1	سَبْقَ الشَّكِّ
u'سَبْقٌ شَيْءٌ':Added, #1: 1	سَبْقِ شَهَادَةِ
u'سَبَقَ صَاحِبٌ':Predicate, #1: 1	سَبْقِ شَيْءٍ
u'سَبَقَ صَاحِبٌ':Subject, #1: 1	سَبَقَ صَاحِبَ
u'سَبَقَ صِحَّةٌ':Subject, #1: 1	سَبَقَ صَاحِبُهُ
u'سَبْقٌ صِفَةٌ':Added, #1: 1	سَبَقَ الصِّحَّةُ
u'سَبَقَ صَفْقَةٌ':Predicate, #1: 1	سَبْقُ الصِّفَاتِ
u'سَبَقَ ضَمٌّ':Predicate, #1: 1	سَبَقَ الصَّفْقَةَ
u'سَبَقَ ضَمَانٌ':Subject, #1: 1	سَبَقَ ضَمَّ
u'سَبْقٌ ضَمَانٌ':Added, #1: 1	سَبَقَ ضَمَانُ
u'سَبَقَ طَلاَقٌ':Subject, #2: 2	سَبْقِ ضَمَانٍ
u'سَبْقٌ طَلاَقٌ':Added, #2: 2	سَبَقَ الطَّلَاقُ
u'سَبَقَ عَبِيدٌ':Subject, #2: 2	سَبْقِ الطَّلَاقِ
u'سَبَقَ عتق':Predicate, #1: 1	سَبَقَ الْعَبِيدُ
u'سَبَقَ عتق':Subject, #1: 1	سَبَقَ عَتَقَ
u'سَبَقَ عِتْقٌ':Subject, #3: 3	سَبَقَ الْعِتْقُ
u'سَبْقٌ عتق':Added, #3: 3	سَبَقَ الْعِتْقُ
u'سَبْقٌ عِتْقٌ':Added, #1: 1	سَبْقُ عِتْقِ
u'سَبْقٌ عتق':Added, #1: 1	سَبْقُ عِتْقِ
u'سَبْقٌ عِتْقٌ':Added, #4: 4	سَبْقِ الْعِتْقِ
u'سَبَقَ عجز':Subject, #4: 4	سَبْقِ الْعِتْقِ
u'سَبَقَ عَجْزٌ':Subject, #1: 1	سَبَقَ عَجْزُ
u'سَبْقٌ عَدَالَةٌ':Added, #1: 1	سَبَقَ عَجْزُ
u'سَبْقٌ عَدَمٌ':Added, #1: 1	سَبْقُ الْعَدَالَةِ
u'سَبْقٌ عَذَابٌ':Added, #2: 2	سَبْقِ الْعَدَمِ
u'سَبَقَ عَقْدٌ':Subject, #1: 1	سَبْقِ عَذَابٍ
u'سَبْقٌ عَقْدٌ':Added, #1: 1	سَبَقَ الْعَقْدُ
u'سَبَقَ عَقْلٌ':Subject, #3: 3	سَبْقِ عَقْدِهِ
u'سَبْقٌ عِلَّةٌ':Added, #2: 2	سَبَقَ الْعَقْلُ
u'سَبَقَ علم':Subject, #1: 1	سَبْقِ الْعِلَّةِ
u'سَبَقَ عِلْمٌ':Subject, #1: 1	سَبَقَ الْعِلْمُ
u'سَبَقَ علم':Subject, #1: 1	سَبَقَ الْعِلْمُ
u'سَبَقَ عِلْمٌ':Subject, #1: 1	سَبَقَ عِلْمُ
u'سَبَقَ علم':Subject, #1: 1	سَبَقَ عِلْمُ
u'سَبَقَ عِلْمٌ':Subject, #1: 1	سَبَقَ عِلْمُهُ
u'سَبْقٌ علم':Added, #1: 1	سَبَقَ عِلْمُهُ
u'سَبْقٌ عِلْمٌ':Added, #1: 1	سَبْقَ عِلْمِهِ
u'سَبْقٌ علم':Added, #1: 1	سَبْقَ عِلْمِهِ
u'سَبْقٌ عِلْمٌ':Added, #2: 2	سَبْقُ الْعِلْمِ
u'سَبْقٌ علم':Added, #2: 2	سَبْقُ الْعِلْمِ
u'سَبْقٌ عِلْمٌ':Added, #3: 3	سَبْقِ الْعِلْمِ
u'سَبَقَ عُمَرٌ':Predicate, #3: 3	سَبْقِ الْعِلْمِ
u'سَبَقَ عند':Predicate, #1: 1	سَبَقَ عُمَرَ
u'سَبْقٌ عَهْدٌ':Added, #3: 3	سَبَقَ عِنْدَ
u'سَبْقٌ غُلاَمٌ':Added, #1: 1	سَبْقُ عَهْدٍ
u'سَبَقَ غير':Subject, #1: 1	سَبْقَ الْغُلَامِ
u'سَبَقَ غَيْرٌ':Subject, #5: 5	سَبَقَ غَيْرُ
u'سَبَقَ غير':Subject, #5: 5	سَبَقَ غَيْرُ
u'سَبَقَ غَيْرٌ':Subject, #7: 7	سَبَقَ غَيْرُهُ
u'سَبْقٌ غير':Added, #7: 7	سَبَقَ غَيْرُهُ
u'سَبْقٌ غَيْرٌ':Added, #1: 1	سَبْقِ غَيْرِهِ
u'سَبْقٌ فَرَسٌ':Added, #1: 1	سَبْقِ غَيْرِهِ
u'سَبَقَ فَضْلٌ':Predicate, #1: 1	سَبْقِ فَرَسٍ
u'سَبَقَ فِعْلٌ':Subject, #1: 1	سَبَقَ فَضْلَ
u'سَبَقَ فُلاَنٌ':Subject, #2: 2	سَبَقَ الْفِعْلُ
u'سَبْقٌ فلان':Added, #1: 1	سَبَقَ فُلَانٌ
u'سَبَقَ فَهْمٌ':Subject, #1: 1	سَبْقُ الشَّافِعِيِّ
u'سَبَقَ قَالٌ':Predicate, #1: 1	سَبَقَ فَهْمُهُ
u'سَبَقَ قتل':Subject, #11: 11	سَبَقَ قَالَ
u'سَبَقَ قَتْلٌ':Subject, #1: 1	سَبَقَ الْقَتْلُ
u'سَبَقَ قتل':Subject, #1: 1	سَبَقَ الْقَتْلُ
u'سَبَقَ قَتْلٌ':Subject, #2: 2	سَبَقَ قَتْلُ
u'سَبَقَ قُدُومٌ':Subject, #2: 2	سَبَقَ قَتْلُ
u'سَبَقَ قِسْمٌ':Subject, #1: 1	سَبَقَ الْقُدُومُ
u'سَبَقَ قصاص':Subject, #1: 1	سَبَقَ الْقِسْمُ
u'سَبَقَ قِصَاصٌ':Subject, #1: 1	سَبَقَ الْقِصَاصُ
u'سَبَقَ قَضَاءٌ':Predicate, #1: 1	سَبَقَ الْقِصَاصُ
u'سَبَقَ قَضَاءٌ':Subject, #1: 1	سَبَقَ الْقَضَاءَ
u'سَبْقٌ قَضَاءٌ':Added, #1: 1	سَبَقَ قَضَاءُ
u'سَبَقَ قَلَمٌ':Subject, #1: 1	سَبْقِ الْقَضَاءِ
u'سَبَقَ قَلَمٌ':Subject, #1: 1	سَبَقَ الْقَلَمُ
u'سَبْقٌ قَلَمٌ':Added, #1: 1	سَبَقَ قَلَمُهُ
u'سَبْقٌ قَلَمٌ':Added, #1: 1	سَبْقِ قَلَمٍ
u'سَبْقٌ قَلَمٌ':Added, #2: 2	سَبْقِ الْقَلَمِ
u'سَبَقَ قول':Subject, #70: 70	سَبْقُ قَلَمٍ
u'سَبَقَ قَوْلٌ':Subject, #1: 1	سَبَقَ قَوْلُهُ
u'سَبَقَ قول':Subject, #1: 1	سَبَقَ قَوْلُهُ
u'سَبَقَ قَوْلٌ':Subject, #2: 2	سَبَقَ الْقَوْلُ
u'سَبَقَ قول':Subject, #2: 2	سَبَقَ الْقَوْلُ
u'سَبَقَ قَوْلٌ':Subject, #8: 8	سَبَقَ قَوْلُ
u'سَبَقَ قَوْمٌ':Subject, #8: 8	سَبَقَ قَوْلُ
u'سَبْقٌ قَوْمٌ':Added, #1: 1	سَبَقَ الْقَوْمُ
u'سَبَقَ كِتَابٌ':Subject, #2: 2	سَبْقُ الْقَوْمِ
u'سَبَقَ كَلاَمٌ':Subject, #3: 3	سَبَقَ الْكِتَابُ
u'سَبَقَ كَلاَمٌ':Subject, #14: 14	سَبَقَ الْكَلَامُ
u'سَبَقَ كَلاَمٌ':Subject, #14: 14	سَبَقَ كَلَامُ
u'سَبَقَ لِسَانٌ':Subject, #1: 1	سَبَقَ كَلَامُهُ
u'سَبَقَ لِسَانٌ':Subject, #16: 16	سَبَقَ لِسَانُهُ
u'سَبْقٌ لِسَانٌ':Added, #1: 1	سَبَقَ لِسَانُ
u'سَبْقٌ لِسَانٌ':Added, #1: 1	سَبْقَ لِسَانٍ
u'سَبْقٌ لِسَانٌ':Added, #1: 1	سَبْقُ لِسَانٍ
u'سَبْقٌ لِسَانٌ':Added, #1: 1	سَبْقِ لِسَانٍ
u'سَبْقٌ لِسَانٌ':Added, #1: 1	سَبْقَ لِسَانِهِ
u'سَبْقٌ لِسَانٌ':Added, #1: 1	سَبْقُ لِسَانِهِ
u'سَبْقٌ لِسَانٌ':Added, #1: 1	سَبْقِ لِسَانِهِ
u'سَبْقٌ لِسَانٌ':Added, #2: 2	سَبْقَ اللِّسَانِ
u'سَبْقٌ لِسَانٌ':Added, #5: 5	سَبْقُ اللِّسَانِ
u'سَبْقٌ لُغَةٌ':Added, #6: 6	سَبْقِ اللِّسَانِ
u'سَبَقَ مَاءٌ':Subject, #1: 1	سَبْقِ اللُّغَاتِ
u'سَبَقَ مَاءٌ':Subject, #1: 1	سَبَقَ مَاءٌ
u'سَبَقَ مَاءٌ':Subject, #2: 2	سَبَقَ الْمَاءُ
u'سَبْقٌ مَاءٌ':Added, #3: 3	سَبَقَ مَاءُ
u'سَبْقٌ مَاءٌ':Added, #1: 1	سَبْقُ مَاءٍ
u'سَبْقٌ مَاءٌ':Added, #2: 2	سَبْقَ الْمَاءِ
u'سَبْقٌ مَاءٌ':Added, #2: 2	سَبْقُ مَاءِ
u'سَبْقٌ مَاءٌ':Added, #3: 3	سَبْقِ الْمَاءِ
u'سَبْقٌ مَادَّةٌ':Added, #6: 6	سَبْقِ مَاءِ
u'سَبْقٌ مِثَالٌ':Added, #1: 1	سَبْقِ مَادَّةٍ
u'سَبَقَ مثل':Subject, #2: 2	سَبْقِ مِثَالٍ
u'سَبَقَ مِثْلٌ':Subject, #6: 6	سَبَقَ مِثْلُهُ
u'سَبَقَ مَحَلٌّ':Subject, #6: 6	سَبَقَ مِثْلُهُ
u'سَبَقَ مُحَلِّل':Subject, #1: 1	سَبَقَ مَحَلُّهُ
u'سَبَقَ مُحَمَّدٌ':Subject, #2: 2	سَبَقَ الْمُحَلِّلُ
u'سَبَقَ مُخْرِجٌ':Subject, #3: 3	سَبَقَ مُحَمَّدٌ
u'سَبْقٌ مُخْرِجٌ':Added, #1: 1	سَبَقَ مُخْرِجُهُ
u'سَبَقَ مراد':Subject, #2: 2	سَبْقِ الْمُخْرِجِ
u'سَبَقَ مُرَادٌ':Subject, #1: 1	سَبَقَ مُرَادُهُ
u'سَبَقَ مَسْأَلَةٌ':Subject, #1: 1	سَبَقَ مُرَادُهُ
u'سَبَقَ مُصَنِّفٌ':Predicate, #1: 1	سَبَقَ مَسْأَلَةٌ
u'سَبَقَ مُصَوَّرٌ':Subject, #1: 1	سَبَقَ الْمُصَنِّفَ
u'سَبَقَ مُطْلَقٌ':Subject, #2: 2	سَبَقَ مُصَوَّرٌ
u'سَبْقٌ مَعْرِفَةٌ':Added, #1: 1	سَبَقَ مُطْلَقٌ
u'سَبْقٌ مَعْرِفَة':Added, #1: 1	سَبْقَ مَعْرِفَتِهِ
u'سَبْقٌ مَعْرِفَةٌ':Added, #1: 1	سَبْقَ مَعْرِفَتِهِ
u'سَبْقٌ مَعْرِفَة':Added, #4: 4	سَبْقِ مَعْرِفَةِ
u'سَبْقٌ مُقَسَّمٌ':Added, #4: 4	سَبْقِ مَعْرِفَةِ
u'سَبَقَ مِلْكٌ':Subject, #1: 1	سَبْقَ مُقَسَّمٍ
u'سَبْقٌ مِلْكٌ':Added, #2: 2	سَبَقَ الْمِلْكُ
u'سَبْقٌ مِلْكٌ':Added, #1: 1	سَبْقُ الْمِلْكِ
u'سَبْقٌ مِلْكٌ':Added, #1: 1	سَبْقُ مِلْكِ
u'سَبْقٌ مِلْكٌ':Added, #1: 1	سَبْقِ مِلْكٍ
u'سَبْقٌ مُمَاثِلٌ':Added, #1: 1	سَبْقِ مِلْكِهِ
u'سَبْقٌ مُمَاثِلٌ':Added, #1: 1	سَبْقُ الْمُمَاثِلِ
u'سَبَقَ مُنَاقِضٌ':Subject, #1: 1	سَبْقِ الْمُمَاثِلِ
u'سَبَقَ مَنْعٌ':Subject, #1: 1	سَبَقَ مُنَاقِضٌ
u'سَبَقَ مَنْعٌ':Subject, #1: 1	سَبَقَ مَنْعُ
u'سَبَقَ مَنِيٌّ':Subject, #2: 2	سَبَقَ الْمَنْعُ
u'سَبْقٌ مُوسِرٌ':Added, #1: 1	سَبَقَ الْمَنِيُّ
u'سَبَقَ نَصٌّ':Predicate, #1: 1	سَبْقِ الْمُوسِرِ
u'سَبَقَ نصاب':Subject, #1: 1	سَبَقَ نَصَّ
u'سَبَقَ نِصَابٌ':Subject, #1: 1	سَبَقَ نِصَابُ
u'سَبَقَ نَظِيرٌ':Subject, #1: 1	سَبَقَ نِصَابُ
u'سَبَقَ نُفُوذٌ':Subject, #2: 2	سَبَقَ نَظِيرُهُ
u'سَبَقَ نقل':Subject, #2: 2	سَبَقَ نُفُوذُ
u'سَبَقَ نَقْلٌ':Subject, #1: 1	سَبَقَ نَقْلُ
u'سَبَقَ نقل':Subject, #1: 1	سَبَقَ نَقْلُ
u'سَبَقَ نَقْلٌ':Subject, #2: 2	سَبَقَ نَقْلُهُ
u'سَبَقَ نكاح':Predicate, #2: 2	سَبَقَ نَقْلُهُ
u'سَبَقَ نِكَاحٌ':Predicate, #3: 3	سَبَقَ النِّكَاحَ
u'سَبْقٌ نكاح':Added, #3: 3	سَبَقَ النِّكَاحَ
u'سَبْقٌ نِكَاحٌ':Added, #1: 1	سَبْقَ النِّكَاحِ
u'سَبْقٌ نكاح':Added, #1: 1	سَبْقَ النِّكَاحِ
u'سَبْقٌ نِكَاحٌ':Added, #1: 1	سَبْقِ نِكَاحِهِ
u'سَبْقٌ نكاح':Added, #1: 1	سَبْقِ نِكَاحِهِ
u'سَبْقٌ نِكَاحٌ':Added, #3: 3	سَبْقَ نِكَاحِهِ
u'سَبْقٌ نِيَّةٌ':Added, #3: 3	سَبْقَ نِكَاحِهِ
u'سَبْقٌ نِيَّةٌ':Added, #1: 1	سَبْقُ النِّيَّةِ
u'سَبَقَ واحد':Subject, #3: 3	سَبْقِ النِّيَّةِ
u'سَبَقَ وَاحِدٌ':Subject, #2: 2	سَبَقَ وَاحِدٌ
u'سَبَقَ وَجْهٌ':Predicate, #2: 2	سَبَقَ وَاحِدٌ
u'سَبَقَ وُجُوبٌ':Subject, #1: 1	سَبَقَ وَجْهَ
u'سَبَقَ وُجُوبٌ':Subject, #2: 2	سَبَقَ الْوُجُوبُ
u'سَبَقَ وُجُوبٌ':Subject, #2: 2	سَبَقَ وُجُوبُ
u'سَبْقٌ وُجُوبٌ':Added, #4: 4	سَبَقَ وُجُوبُهُ
u'سَبْقٌ وُجُوبٌ':Added, #1: 1	سَبْقَ الْوُجُوبِ
u'سَبْقٌ وُجُوبٌ':Added, #1: 1	سَبْقِ الْوُجُوبِ
u'سَبْقٌ وُجُودٌ':Added, #2: 2	سَبْقُ الْوُجُوبِ
u'سَبْقٌ وُجُودٌ':Added, #1: 1	سَبْقَ الْوُجُودِ
u'سَبْقٌ وُجُودٌ':Added, #1: 1	سَبْقِ الْوُجُودِ
u'سَبَقَ وُجُوهٌ':Subject, #1: 1	سَبْقَ وُجُودِ
u'سَبَقَ وُرُودٌ':Subject, #1: 1	سَبَقَ وُجُوهُ
u'سَبَقَ وَضْعٌ':Subject, #1: 1	سَبَقَ وُرُودُهُ
u'سَبْقٌ وَضْعٌ':Added, #1: 1	سَبَقَ وَضْعُهُ
u'سَبْقٌ وَضْعٌ':Added, #1: 1	سَبْقَ وَضْعٍ
u'سَبَقَ وَعْدٌ':Subject, #1: 1	سَبْقِ وَضْعٍ
u'سَبَقَ وَقْتٌ':Subject, #1: 1	سَبَقَ الْوَعْدُ
u'سَبَقَ وقع':Predicate, #2: 2	سَبَقَ الْوَقْتُ
u'سَبَقَ وُقُوعٌ':Subject, #1: 1	سَبَقَ وَقَعَ
u'سَبَقَ وَهْمٌ':Subject, #1: 1	سَبَقَ وُقُوعُ
u'سَبَقَ وَهْمٌ':Subject, #1: 1	سَبَقَ الْوَهْمُ
u'سَبْقٌ يَدٌ':Added, #1: 1	سَبَقَ وَهْمُ
u'سَبَقَ يَمِينٌ':Predicate, #1: 1	سَبْقُ الْيَدِ
u'سَبَقَ يَمِينٌ':Predicate, #1: 1	سَبَقَ الْيَمِينَ
u'سَبَكَ فِضَّةٌ':Predicate, #2: 2	سَبَقَ يَمِينَ
u'سَبَّلَ إمَامٌ':Subject, #2: 2	سَبَكَ الْفِضَّةَ
u'سَبَّلَ إِنْسانٌ':Subject, #1: 1	سَبَّلَ الْإِمَامُ
u'سَبَّ مَشْهُودٌ':Subject, #1: 1	سَبَّلَ إنْسَانٌ
u'سَبَّ نَبِيٌّ':Predicate, #1: 1	سَبَّ الْمَشْهُودُ
u'سَبَّ واحد':Predicate, #14: 14	سَبَّ النَّبِيَّ
u'سَبَّ وَاحِدٌ':Predicate, #1: 1	سَبَّ وَاحِدَةً
u'سَبْيٌ أحَدٌ':Added, #1: 1	سَبَّ وَاحِدَةً
u'سَبْيٌ إمَارَةٌ':Added, #1: 1	سَبْي أَحَدِ
u'سَبْيٌ أهْلٌ':Added, #1: 1	سَبْيِ الْإِمَارَةِ
u'سَبَى ذِمِّيٌّ':Subject, #1: 1	سَبْيِ أَهْلِ
u'سَبَى ذِمِّيٌّ':Subject, #2: 2	سَبَى الذِّمِّيُّ
u'سَبْيٌ رَجُلٌ':Added, #2: 2	سَبَى ذِمِّيٌّ
u'سَبَى رَسُولٌ':Subject, #1: 1	سَبْيِ الرَّجُلِ
u'سَبَى صَفِيٌّ':Predicate, #6: 6	سَبَى رَسُولُ
u'سَبَى عَبْدٌ':Subject, #1: 1	سَبَى صَفِيَّةَ
u'سَبَى عَدُوٌّ':Predicate, #1: 1	سَبَى الْعَبْدُ
u'سَبَى عَدُوٌّ':Subject, #1: 1	سَبَى الْعَدُوَّ
u'سَبْيٌ عَرَبٌ':Added, #3: 3	سَبَى الْعَدُوُّ
u'سَبْيٌ عين':Added, #1: 1	سَبْيِ الْعَرَبِ
u'سَبْيٌ عَيْنٌ':Added, #1: 1	سَبْيِ عَيْنِ
u'سَبْيٌ عَيْن':Added, #1: 1	سَبْيِ عَيْنِ
u'سَبَى كُفَّارٌ':Subject, #1: 1	سَبْيِ عَيْنِ
u'سَبَى مُسْلِمٌ':Subject, #2: 2	سَبَى الْكُفَّارُ
u'سَبْيٌ مُشْتَبَهٌ':Added, #2: 2	سَبَى مُسْلِمٌ
u'سَبْيٌ نِساءٌ':Added, #1: 1	سَبْيِ مُشْتَبَهٍ
u'سَبْيٌ ولد':Added, #1: 1	سَبْيُ النِّسَاءِ
u'سَبْيٌ وَلَدٌ':Added, #1: 1	سَبْيُ الْوَلَدِ
u'سَتْرٌ أحَدٌ':Added, #1: 1	سَبْيُ الْوَلَدِ
u'سَتْرٌ أَمْرٌ':Added, #1: 1	سَتْرُ أَحَدِ
u'سَتْرٌ باقَةٌ':Added, #1: 1	سَتْرَ الْأَمْرِ
u'سَتْرٌ باقِي':Added, #1: 1	سَتْرَ بَاقِيهِ
u'سَتْرٌ بدن':Added, #1: 1	سَتْرَ بَاقِيهِ
u'سَتْرٌ بَدَنٌ':Added, #1: 1	سَتْرِ الْبَدَنِ
u'سَتْرٌ بدن':Added, #1: 1	سَتْرِ الْبَدَنِ
u'سَتْرٌ بَدَنٌ':Added, #1: 1	سَتْرُ بَدَنِهِ
u'سَتَرَ بَعْضٌ':Predicate, #1: 1	سَتْرُ بَدَنِهِ
u'سَتْرٌ بَعْضٌ':Added, #1: 1	سَتَرَ بَعْضَ
u'سَتْرٌ بَعْضٌ':Added, #1: 1	سَتْرَ الْبَعْضِ
u'سَتْرٌ بَعْضٌ':Added, #1: 1	سَتْرُ بَعْضِ
u'سَتْرٌ ثَوْبٌ':Added, #1: 1	سَتْرِ بَعْضِ
u'سَتْرٌ ثَوْبٌ':Added, #1: 1	سَتْرِ الثَّوْبِ
u'سَتْرٌ جُدْرَانٌ':Added, #1: 1	سَتْرِ ثَوْبٍ
u'سَتْرٌ جُرْمٌ':Added, #1: 1	سَتْرِ الْجُدْرَانِ
u'سَتْرٌ جُزْءٌ':Added, #1: 1	سَتْرُ جُرْمٍ
u'سَتْرٌ جَمِيع':Added, #2: 2	سَتْرُ جُزْءٍ
u'سَتْرٌ جِنَايَةٌ':Added, #2: 2	سَتْرُ الْجَمِيعِ
u'سَتْرٌ حيطانٌ':Added, #1: 1	سَتْرَ الْجِنَايَةِ
u'سَتْرٌ دُبُرٌ':Added, #1: 1	سَتْرَ الْحِيطَانِ
u'سَتْرٌ دُبُرٌ':Added, #2: 2	سَتْرُ الدُّبُرِ
u'سَتْرٌ ذَنْبٌ':Added, #2: 2	سَتْرِ الدُّبُرِ
u'سَتْرٌ رَأْسٌ':Added, #1: 1	سَتْرِ الذَّنْبِ
u'سَتْرٌ رَأْسٌ':Added, #1: 1	سَتْرَ رَأْسِ
u'سَتْرٌ رَأْسٌ':Added, #2: 2	سَتْرَ الرَّأْسِ
u'سَتْرٌ رَأْسٌ':Added, #2: 2	سَتْرَ رَأْسِهِ
u'سَتْرٌ رَأْسٌ':Added, #3: 3	سَتْرُ الرَّأْسِ
u'سَتْرٌ رَأْسٌ':Added, #3: 3	سَتْرُ رَأْسِ
u'سَتْرٌ رَأْسٌ':Added, #3: 3	سَتْرِ رَأْسِهِ
u'سَتْرٌ رَأْسٌ':Added, #4: 4	سَتْرُ رَأْسِهِ
u'سَتْرٌ رِجْلٌ':Added, #6: 6	سَتْرِ الرَّأْسِ
u'سَتْرٌ رِدَاءٌ':Added, #1: 1	سَتْرُ الرِّجْلِ
u'سَتَرَ رَسُولٌ':Subject, #1: 1	سَتْرَ الرِّدَاءِ
u'سَتَرَ سَرَاوِيلُ':Subject, #1: 1	سَتَرَ رَسُولُ
u'سَتْرٌ سَقْفٌ':Added, #1: 1	سَتَرَ السَّرَاوِيلُ
u'سَتْرٌ شَاهِدٌ':Added, #1: 1	سَتْرُ سَقْفِ
u'سَتْرٌ شَاهِدٌ':Added, #1: 1	سَتْرُ الشَّاهِدِ
u'سَتْرٌ شَرٌّ':Added, #1: 1	سَتْرِ الشَّاهِدِ
u'سَتَرَ ظَهْرٌ':Predicate, #1: 1	سَتْرُ الشَّرِّ
u'سَتْرٌ عادِم':Added, #1: 1	سَتَرَ ظَهْرَ
u'سَتْرٌ عِفَّةٌ':Added, #1: 1	سَتْرِ عَادِمٍ
u'سَتْرٌ عنق':Added, #1: 1	سَتْرِ الْعِفَّةِ
u'سَتْرٌ عُنُقٌ':Added, #1: 1	سَتْرَ الْعُنُقِ
u'سَتَرَ عَوْرَةٌ':Predicate, #1: 1	سَتْرَ الْعُنُقِ
u'سَتَرَ عَوْرَةٌ':Predicate, #2: 2	سَتَرَ الْعَوْرَةَ
u'سَتْرٌ عَوْرَةٌ':Added, #4: 4	سَتَرَ عَوْرَةَ
u'سَتْرٌ عَوْرَةٌ':Added, #1: 1	سَتْرَ عَوْرَةٍ
u'سَتْرٌ عَوْرَةٌ':Added, #1: 1	سَتْرَ عَوْرَةِ
u'سَتْرٌ عَوْرَةٌ':Added, #1: 1	سَتْرُ عَوْرَةِ
u'سَتْرٌ عَوْرَةٌ':Added, #1: 1	سَتْرِ عَوْرَةٍ
u'سَتْرٌ عَوْرَةٌ':Added, #1: 1	سَتْرِ عَوْرَةِ
u'سَتْرٌ عَوْرَةٌ':Added, #27: 27	سَتْرَ الْعَوْرَةِ
u'سَتْرٌ عَوْرَةٌ':Added, #2: 2	سَتْرَ عَوْرَتِهِ
u'سَتْرٌ عَوْرَةٌ':Added, #2: 2	سَتْرِ عَوْرَتِهِ
u'سَتْرٌ عَوْرَةٌ':Added, #45: 45	سَتْرُ الْعَوْرَةِ
u'سَتْرٌ عَوْرَةٌ':Added, #4: 4	سَتْرُ عَوْرَتِهِ
u'سَتْرٌ غير':Added, #78: 78	سَتْرِ الْعَوْرَةِ
u'سَتْرٌ غَيْرٌ':Added, #1: 1	سَتْرُ غَيْرِ
u'سَتْرٌ فَرْجٌ':Added, #1: 1	سَتْرُ غَيْرِ
u'سَتْرٌ فَرْجٌ':Added, #1: 1	سَتْرُ فَرْجِ
u'سَتْرٌ قَبْرٌ':Added, #2: 2	سَتْرُ الْفَرْجِ
u'سَتْرٌ قُبُلٌ':Added, #1: 1	سَتْرِ الْقَبْرِ
u'سَتْرٌ قَبِيحٌ':Added, #1: 1	سَتْرُ الْقُبُلِ
u'سَتَرَ قدم':Predicate, #1: 1	سَتْرِ الْقَبِيحِ
u'سَتَرَ قَدَمٌ':Predicate, #2: 2	سَتَرَ الْقَدَمَ
u'سَتْرٌ قمر':Added, #2: 2	سَتَرَ الْقَدَمَ
u'سَتْرٌ قمر':Added, #1: 1	سَتْرُ الْقَمَرِ
u'سَتْرٌ قَمَرٌ':Added, #1: 1	سَتْرِ الْقَمَرِ
u'سَتْرٌ قَمَرٌ':Added, #1: 1	سَتْرُ الْقَمَرِ
u'سَتْرٌ كعبة':Added, #1: 1	سَتْرِ الْقَمَرِ
u'سَتْرٌ كَعْبَةٌ':Added, #2: 2	سَتْرَ الْكَعْبَةِ
u'سَتْرٌ كعبة':Added, #2: 2	سَتْرَ الْكَعْبَةِ
u'سَتْرٌ كَعْبَةٌ':Added, #4: 4	سَتْرُ الْكَعْبَةِ
u'سَتْرٌ كَفٌّ':Added, #4: 4	سَتْرُ الْكَعْبَةِ
u'سَتَرَ مَحَلٌّ':Predicate, #1: 1	سَتْرُ الْكَفَّيْنِ
u'سَتْرٌ مَحَلٌّ':Added, #2: 2	سَتَرَ مَحَلَّ
u'سَتْرٌ مَحَلٌّ':Added, #1: 1	سَتْرَ مَحَلِّ
u'سَتَرَ مَعْرُوفٌ':Predicate, #1: 1	سَتْرُ مَحَلِّ
u'سَتْرٌ مَعْرُوفٌ':Added, #1: 1	سَتَرَ مَعْرُوفَ
u'سَتَرَ مَعْصِيَةٌ':Predicate, #1: 1	سَتْرَ الْمَعْرُوفِ
u'سَتْرٌ مَعْصِيَةٌ':Added, #2: 2	سَتَرَ الْمَعْصِيَةَ
u'سَتْرٌ مُفْسِدٌ':Added, #1: 1	سَتْرِ مَعْصِيَةٍ
u'سَتْرٌ مَفْسَدَةٌ':Added, #1: 1	سَتْرِ الْمُفْسِدِ
u'سَتْرٌ مَنْكِبٌ':Added, #1: 1	سَتْرِ الْمَفْسَدَةِ
u'سَتْرٌ مَنْكِبٌ':Added, #2: 2	سَتْرَ الْمَنْكِبَيْنِ
u'سَتْرٌ مَوْضِعٌ':Added, #5: 5	سَتْرِ الْمَنْكِبَيْنِ
u'سَتْرٌ نَعْشٌ':Added, #2: 2	سَتْرُ الْمَوْضِعِ
u'سَتْرٌ نَفْسٌ':Added, #2: 2	سَتْرُ نَعْشِ
u'سَتْرٌ نَفْسٌ':Added, #1: 1	سَتْرُ نَفْسِهِ
u'سَتْرٌ وَجْهٌ':Added, #1: 1	سَتْرِ نَفْسِهِ
u'سَتْرٌ وَجْهٌ':Added, #1: 1	سَتْرِ الْوَجْهِ
u'سِجَالٌ حَرْبٌ':Added, #2: 2	سَتْرُ وَجْهِهِ
u'سِجَالٌ قُرَبٌ':Added, #1: 1	سِجَالُ الْحَرْبِ
u'سَجَدَ أحَدٌ':Subject, #1: 1	سِجَالَ قُرَبِهِ
u'سَجَدَ آخِرُ':Predicate, #1: 1	سَجَدَ أَحَدٌ
u'سَجَدَ إمَامٌ':Subject, #1: 1	سَجَدَ آخِرَ
u'سَجَدَ إمَامٌ':Subject, #13: 13	سَجَدَ إمَامُهُ
u'سَجَدَ إمَامٌ':Subject, #19: 19	سَجَدَ الْإِمَامُ
u'سَجَدَ إِنْسانٌ':Subject, #1: 1	سَجَدَ إمَامٌ
u'سَجَدَ بسط':Predicate, #2: 2	سَجَدَ الْإِنْسَانُ
u'سَجَدَ بَطَلٌ':Predicate, #1: 1	سَجَدَ بَسَطَ
u'سَجَدَ بَيْنٌ':Predicate, #1: 1	سَجَدَ بَطَلَ
u'سجدة إِسْراءٌ':Added, #2: 2	سَجَدَ بَيْنَ
u'سَجْدَةٌ إِسْراءٌ':Added, #1: 1	سَجْدَةِ الْإِسْرَاءِ
u'سجدة أَعْرَافٌ':Added, #1: 1	سَجْدَةِ الْإِسْرَاءِ
u'سَجْدَةٌ أَعْرَافٌ':Added, #1: 1	سَجْدَةِ الْأَعْرَافِ
u'سجدة أَعْرَافٌ':Added, #1: 1	سَجْدَةِ الْأَعْرَافِ
u'سَجْدَةٌ أَعْرَافٌ':Added, #3: 3	سَجْدَةَ الْأَعْرَافِ
u'سجدة إمَامٌ':Added, #3: 3	سَجْدَةَ الْأَعْرَافِ
u'سَجْدَةٌ إمَامٌ':Added, #1: 1	سَجْدَةِ الْإِمَامِ
u'سجدة آيَةٌ':Added, #1: 1	سَجْدَةِ الْإِمَامِ
u'سَجْدَةٌ آيَةٌ':Added, #1: 1	سَجْدَةُ آيَةِ
u'سجدة تَحِيَّةٌ':Added, #1: 1	سَجْدَةُ آيَةِ
u'سَجْدَةٌ تَحِيَّةٌ':Added, #1: 1	سَجْدَةَ تَحِيَّةٍ
u'سجدة تِلاوَةٌ':Added, #1: 1	سَجْدَةَ تَحِيَّةٍ
u'سَجْدَةٌ تِلاوَةٌ':Added, #12: 12	سَجْدَةُ تِلَاوَةٍ
u'سجدة تِلاوَةٌ':Added, #12: 12	سَجْدَةُ تِلَاوَةٍ
u'سَجْدَةٌ تِلاوَةٌ':Added, #14: 14	سَجْدَةَ تِلَاوَةٍ
u'سجدة تِلاوَةٌ':Added, #14: 14	سَجْدَةَ تِلَاوَةٍ
u'سَجْدَةٌ تِلاوَةٌ':Added, #1: 1	سَجْدَةِ التِّلاَوَةِ
u'سجدة تِلاوَة':Added, #1: 1	سَجْدَةِ التِّلاَوَةِ
u'سَجْدَةٌ تِلاوَة':Added, #1: 1	سَجْدَةِ التِّلَاوِيَّةِ
u'سجدة تِلاوَةٌ':Added, #1: 1	سَجْدَةِ التِّلَاوِيَّةِ
u'سَجْدَةٌ تِلاوَةٌ':Added, #1: 1	سَجْدَةِ تِلَاوَةِ
u'سجدة تِلاوَةٌ':Added, #1: 1	سَجْدَةِ تِلَاوَةِ
u'سَجْدَةٌ تِلاوَةٌ':Added, #32: 32	سَجْدَةُ التِّلَاوَةِ
u'سجدة تِلاوَةٌ':Added, #32: 32	سَجْدَةُ التِّلَاوَةِ
u'سَجْدَةٌ تِلاوَةٌ':Added, #34: 34	سَجْدَةَ التِّلَاوَةِ
u'سجدة تِلاوَةٌ':Added, #34: 34	سَجْدَةَ التِّلَاوَةِ
u'سَجْدَةٌ تِلاوَةٌ':Added, #5: 5	سَجْدَةِ تِلَاوَةٍ
u'سجدة تِلاوَةٌ':Added, #5: 5	سَجْدَةِ تِلَاوَةٍ
u'سَجْدَةٌ تِلاوَةٌ':Added, #72: 72	سَجْدَةِ التِّلَاوَةِ
u'سجدة حَجٌّ':Added, #72: 72	سَجْدَةِ التِّلَاوَةِ
u'سَجْدَةٌ حَجٌّ':Added, #1: 1	سَجْدَةُ الْحَجِّ
u'سجدة ركعة':Added, #1: 1	سَجْدَةُ الْحَجِّ
u'سجدة ركعة':Added, #1: 1	سَجْدَةَ الرَّكْعَةِ
u'سَجْدَةٌ ركعة':Added, #1: 1	سَجْدَةِ الرَّكْعَةِ
u'سَجْدَةٌ ركعة':Added, #1: 1	سَجْدَةَ الرَّكْعَةِ
u'سجدة رَكْعَةٌ':Added, #1: 1	سَجْدَةِ الرَّكْعَةِ
u'سجدة رَكْعَةٌ':Added, #1: 1	سَجْدَةَ الرَّكْعَةِ
u'سَجْدَةٌ رَكْعَةٌ':Added, #1: 1	سَجْدَةِ الرَّكْعَةِ
u'سَجْدَةٌ رَكْعَةٌ':Added, #1: 1	سَجْدَةَ الرَّكْعَةِ
u'سجدة ركعة':Added, #1: 1	سَجْدَةِ الرَّكْعَةِ
u'سَجْدَةٌ ركعة':Added, #1: 1	سَجْدَةِ رَكْعَةٍ
u'سجدة رَكْعَةٌ':Added, #1: 1	سَجْدَةِ رَكْعَةٍ
u'سَجْدَةٌ رَكْعَةٌ':Added, #1: 1	سَجْدَةِ رَكْعَةٍ
u'سجدة رُكوعٌ':Added, #1: 1	سَجْدَةِ رَكْعَةٍ
u'سَجْدَةٌ رُكوعٌ':Added, #1: 1	سَجْدَةِ رُكُوعٍ
u'سجدة سَهْوٌ':Added, #1: 1	سَجْدَةِ رُكُوعٍ
u'سَجْدَةٌ سَهْوٌ':Added, #12: 12	سَجْدَةُ السَّهْوِ
u'سجدة سَهْوٌ':Added, #12: 12	سَجْدَةُ السَّهْوِ
u'سَجْدَةٌ سَهْوٌ':Added, #3: 3	سَجْدَةِ السَّهْوِ
u'سجدة سَهْوٌ':Added, #3: 3	سَجْدَةِ السَّهْوِ
u'سَجْدَةٌ سَهْوٌ':Added, #4: 4	سَجْدَةَ السَّهْوِ
u'سجدة شكر':Added, #4: 4	سَجْدَةَ السَّهْوِ
u'سجدة شُكْرٌ':Added, #1: 1	سَجْدَةَ الشُّكْرِ
u'سَجْدَةٌ شكر':Added, #1: 1	سَجْدَةَ الشُّكْرِ
u'سَجْدَةٌ شُكْرٌ':Added, #1: 1	سَجْدَةَ الشُّكْرِ
u'سجدة شُكْرٌ':Added, #1: 1	سَجْدَةَ الشُّكْرِ
u'سَجْدَةٌ شُكْرٌ':Added, #1: 1	سَجْدَةِ شُكْرٍ
u'سجدة شكر':Added, #1: 1	سَجْدَةِ شُكْرٍ
u'سجدة شُكْرٌ':Added, #6: 6	سَجْدَةِ الشُّكْرِ
u'سَجْدَةٌ شكر':Added, #6: 6	سَجْدَةِ الشُّكْرِ
u'سَجْدَةٌ شُكْرٌ':Added, #6: 6	سَجْدَةِ الشُّكْرِ
u'سجدة شكر':Added, #6: 6	سَجْدَةِ الشُّكْرِ
u'سجدة شُكْرٌ':Added, #8: 8	سَجْدَةُ الشُّكْرِ
u'سَجْدَةٌ شكر':Added, #8: 8	سَجْدَةُ الشُّكْرِ
u'سَجْدَةٌ شُكْرٌ':Added, #8: 8	سَجْدَةُ الشُّكْرِ
u'سجدة شُكْرٌ':Added, #8: 8	سَجْدَةُ الشُّكْرِ
u'سَجْدَةٌ شُكْرٌ':Added, #8: 8	سَجْدَةُ شُكْرٍ
u'سجدة صَلاَةٌ':Added, #8: 8	سَجْدَةُ شُكْرٍ
u'سَجْدَةٌ صَلاَةٌ':Added, #10: 10	سَجْدَةِ الصَّلَاةِ
u'سجدة صَلاَةٌ':Added, #10: 10	سَجْدَةِ الصَّلَاةِ
u'سَجْدَةٌ صَلاَةٌ':Added, #1: 1	سَجْدَةَ الصَّلَاةِ
u'سجدة صَلاَةٌ':Added, #1: 1	سَجْدَةَ الصَّلَاةِ
u'سَجْدَةٌ صَلاَةٌ':Added, #7: 7	سَجْدَةُ الصَّلَاةِ
u'سجدة صُلْب':Added, #7: 7	سَجْدَةُ الصَّلَاةِ
u'سَجْدَةٌ صُلْب':Added, #2: 2	سَجْدَةٍ صُلْبِيَّةٍ
u'سجدة صُلْبِيّ':Added, #2: 2	سَجْدَةٍ صُلْبِيَّةٍ
u'سَجْدَةٌ صُلْبِيّ':Added, #2: 2	سَجْدَةٍ صُلْبِيَّةٍ
u'سجدة فلان':Added, #2: 2	سَجْدَةٍ صُلْبِيَّةٍ
u'سَجْدَةٌ فلان':Added, #1: 1	سَجْدَةَ الصَّلَاتِيَّةِ
u'سجدة فلان':Added, #1: 1	سَجْدَةَ الصَّلَاتِيَّةِ
u'سَجْدَةٌ فلان':Added, #3: 3	سَجْدَةٍ صَلَاتِيَّةٍ
u'سجدة نَجْمٌ':Added, #3: 3	سَجْدَةٍ صَلَاتِيَّةٍ
u'سجدة نَجْمٌ':Added, #1: 1	سَجْدَةَ النَّجْمِ
u'سجدة نَجْمٌ':Added, #1: 1	سَجْدَةُ النَّجْمِ
u'سَجْدَةٌ نَجْمٌ':Added, #1: 1	سَجْدَةِ النَّجْمِ
u'سَجْدَةٌ نَجْمٌ':Added, #1: 1	سَجْدَةَ النَّجْمِ
u'سَجْدَةٌ نَجْمٌ':Added, #1: 1	سَجْدَةُ النَّجْمِ
u'سجدة نَمْلٌ':Added, #1: 1	سَجْدَةِ النَّجْمِ
u'سَجْدَةٌ نَمْلٌ':Added, #1: 1	سَجْدَةِ النَّمْلِ
u'سجدة واحد':Added, #1: 1	سَجْدَةِ النَّمْلِ
u'سجدة وَاحِدٌ':Added, #10: 10	سَجْدَةٍ وَاحِدَةٍ
u'سَجْدَةٌ واحد':Added, #10: 10	سَجْدَةٍ وَاحِدَةٍ
u'سَجْدَةٌ وَاحِدٌ':Added, #10: 10	سَجْدَةٍ وَاحِدَةٍ
u'سَجَدَ ثَالِثٌ':Predicate, #10: 10	سَجْدَةٍ وَاحِدَةٍ
u'سَجَدَ ثَانِي':Predicate, #1: 1	سَجَدَ الثَّالِثَةَ
u'سَجَدَ ثَانِي':Predicate, #1: 1	سَجَدَ ثَانِيَةً
u'سَجَدَ ثَانِيَةٌ':Predicate, #2: 2	سَجَدَ الثَّانِيَةَ
u'سَجَدَ جَخّ':Predicate, #2: 2	سَجَدَ الثَّانِيَةَ
u'سَجَدَ جمع':Predicate, #1: 1	سَجَدَ جَخَّ
u'سَجَدَ حَديثٌ':Predicate, #2: 2	سَجَدَ جَمَعَ
u'سَجَدَ دواة':Subject, #2: 2	سَجَدَ الْحَدِيثَ
u'سَجَدَ دَواةٌ':Subject, #2: 2	سَجَدَ الدَّوَاةُ
u'سَجَدَ دونٌ':Predicate, #2: 2	سَجَدَ الدَّوَاةُ
u'سَجَدَ رِجَالٌ':Subject, #1: 1	سَجَدَ دُونَ
u'سَجَدَ رَجُلٌ':Subject, #1: 1	سَجَدَ الرِّجَالُ
u'سَجَدَ رَسُولٌ':Subject, #1: 1	سَجَدَ الرَّجُلُ
u'سَجَدَ زَمانٌ':Predicate, #15: 15	سَجَدَ رَسُولُ
u'سَجَدَ سجدة':Predicate, #1: 1	سَجَدَ زَمَانَ
u'سَجَدَ سَجْدَةٌ':Predicate, #2: 2	سَجَدَ سَجْدَةَ
u'سَجَدَ سجدة':Predicate, #2: 2	سَجَدَ سَجْدَةَ
u'سَجَدَ سَجْدَةٌ':Predicate, #3: 3	سَجَدَ السَّجْدَةَ
u'سَجَدَ سُجُودٌ':Predicate, #3: 3	سَجَدَ السَّجْدَةَ
u'سَجَدَ سقط':Predicate, #1: 1	سَجَدَ سُجُودَ
u'سَجَدَ سَقَطٌ':Predicate, #2: 2	سَجَدَ سَقَطَ
u'سَجَدَ سَهْوٌ':Predicate, #2: 2	سَجَدَ سَقَطَ
u'سَجَدَ صَفٌّ':Subject, #1: 1	سَجَدَ السَّهْوَ
u'سَجَدَ صُلْب':Predicate, #8: 8	سَجَدَ الصَّفُّ
u'سَجَدَ صُلْبِيّ':Predicate, #1: 1	سَجَدَ صُلْبِيَّةً
u'سَجَدَ ضَمٌّ':Predicate, #1: 1	سَجَدَ صُلْبِيَّةً
u'سَجَدَ عَبْدٌ':Subject, #3: 3	سَجَدَ ضَمَّ
u'سَجَدَ عَقِبٌ':Predicate, #3: 3	سَجَدَ الْعَبْدُ
u'سَجَدَ عند':Predicate, #2: 2	سَجَدَ عَقِبَ
u'سَجَدَ غير':Subject, #3: 3	سَجَدَ عِنْدَ
u'سَجَدَ غَيْرٌ':Subject, #2: 2	سَجَدَ غَيْرُ
u'سَجَدَ قَارِئٌ':Subject, #2: 2	سَجَدَ غَيْرُ
u'سَجَدَ قَاعِدٌ':Subject, #2: 2	سَجَدَ الْقَارِئُ
u'سَجَدَ قَالٌ':Predicate, #2: 2	سَجَدَ الْقَاعِدُ
u'سَجَدَ قَدْرٌ':Predicate, #6: 6	سَجَدَ قَالَ
u'سَجَدَ لاَحِقٌ':Subject, #1: 1	سَجَدَ قَدْرَ
u'سَجَدَ مثل':Predicate, #2: 2	سَجَدَ اللَّاحِقُ
u'سَجَدَ مِثْلٌ':Predicate, #2: 2	سَجَدَ مِثْلَ
u'سَجَدَ مرٌّ':Predicate, #2: 2	سَجَدَ مِثْلَ
u'سَجَدَ مُسَافِرٌ':Subject, #4: 4	سَجَدَ مَرَّةً
u'سَجَدَ مُؤْمِنٌ':Subject, #1: 1	سَجَدَ الْمُسَافِرُ
u'سَجَدَ نَبِيٌّ':Subject, #1: 1	سَجَدَ الْمُؤْمِنُ
u'سَجَدَ واحد':Predicate, #2: 2	سَجَدَ النَّبِيُّ
u'سَجَدَ وَاحِدٌ':Predicate, #3: 3	سَجَدَ وَاحِدَةً
u'سَجَدَ واحد':Subject, #3: 3	سَجَدَ وَاحِدَةً
u'سَجَدَ وَاحِدٌ':Subject, #1: 1	سَجَدَ وَاحِدٌ
u'سَجَدَ وجهى':Predicate, #1: 1	سَجَدَ وَاحِدٌ
u'سَجَدَ يَوْمٌ':Predicate, #1: 1	سَجَدَ وَجْهِىَ
u'سَجَّى قَبْرٌ':Predicate, #1: 1	سَجَدَ يَوْمَ
u'سِحْرٌ أَصْحَابٌ':Added, #1: 1	سَجَّى قَبْرَ
u'سَحَرَ أهْلٌ':Predicate, #1: 1	سِحْرُ أَصْحَابِ
u'سِحْرٌ رِجَالٌ':Added, #1: 1	سَحَرَ أَهْلَ
u'سَحَرَ رَسُولٌ':Predicate, #1: 1	سِحْرِ الرِّجَالِ
u'سِحْرٌ سَحَرَةٌ':Added, #3: 3	سَحَرَ رَسُولَ
u'سَحَرَ مُحَمَّدٌ':Subject, #1: 1	سِحْرُ سَحَرَةِ
u'سَحَرَ نَبِيٌّ':Predicate, #1: 1	سَحَرَ مُحَمّدٌ
u'سحق سَعِيرٌ':Added, #1: 1	سَحَرَ النَّبِيَّ
u'سُحْقٌ سَعِيرٌ':Added, #1: 1	سُحْقِ السّعِيرِ
u'سَخَافَةٌ دِينٌ':Added, #1: 1	سُحْقِ السّعِيرِ
u'سَخَافَةٌ عَرَبٌ':Added, #1: 1	سَخَافَةِ دِينِهِ
u'سَخَّرَ بَحْرٌ':Predicate, #1: 1	سَخَافَةِ الْعَرَبِ
u'سَخِطَ تَعِسٌ':Predicate, #1: 1	سَخَّرَ الْبَحْرَ
u'سَخِطَ مَالِكٌ':Subject, #2: 2	سَخِطَ تَعِسَ
u'سُخْطٌ وَالِدٌ':Added, #2: 2	سَخِطَ الْمَالِكُ
u'سَخُفَ رَجُلٌ':Subject, #1: 1	سُخْطِ الْوَالِدَيْنِ
u'سُخْفٌ عَقْلٌ':Added, #1: 1	سَخُفَ الرَّجُلُ
u'سُخُونَةٌ رَأْسٌ':Added, #1: 1	سُخْفِ عَقْلِ
u'سُخُونَةٌ قلب':Added, #1: 1	سُخُونَةِ الرَّأْسِ
u'سُخُونَةٌ قَلْبٌ':Added, #1: 1	سُخُونَةِ الْقَلْبِ
u'سُخُونَةٌ قَلْب':Added, #1: 1	سُخُونَةِ الْقَلْبِ
u'سَدَادٌ رَغيبٌ':Added, #1: 1	سُخُونَةِ الْقَلْبِ
u'سَدَادٌ رَغيبٌ':Added, #1: 1	سَدَادُ الرَّغِيبِ
u'سَدَادٌ قَبْضٌ':Added, #1: 1	سَدَادِ الرَّغِيبِ
u'سَدَادٌ نَظَرٌ':Added, #1: 1	سَدَادِ الْقَبْضِ
u'سَدَّ أَنْهَارٌ':Predicate, #3: 3	سَدَادِ النَّظَرِ
u'سَدَّ أَوَّلُ':Predicate, #1: 1	سَدَّ أَنْهَارَ
u'سَدَّ بَابٌ':Predicate, #1: 1	سَدَّ الْأَوَّلَ
u'سَدَّ بَابٌ':Predicate, #1: 1	سَدَّ الْبَابَ
u'سَدَّ جُوعٌ':Predicate, #2: 2	سَدَّ بَابَ
u'سَدَّ حاجَةٌ':Predicate, #1: 1	سَدَّ الْجُوعَ
u'سَدَّدَ نَظَرٌ':Predicate, #1: 1	سَدَّ حَاجَةَ
u'سَدِرَ بَصَرٌ':Subject, #1: 1	سَدَّدَ النَّظَرَ
u'سَدَّ صَاحِبٌ':Subject, #1: 1	سَدِرَ بَصَرُهُ
u'سَدَّ طَرِيقٌ':Predicate, #1: 1	سَدَّ صَاحِبُ
u'سَدَّ عَرْضٌ':Predicate, #1: 1	سَدَّ الطَّرِيقَ
u'سَدَّ كَلْبٌ':Subject, #1: 1	سَدَّ عَرْضَ
u'سَدَلَ ثَوْبٌ':Predicate, #1: 1	سَدَّ كَلْبٌ
u'سَدَلَ نَبِيٌّ':Subject, #1: 1	سَدَلَ الثَّوْبَ
u'سَدَّ مَحَلٌّ':Predicate, #1: 1	سَدَلَ النَّبِيُّ
u'سَدَّ مَكَانٌ':Predicate, #1: 1	سَدَّ مَحَلَّ
u'سَدَّ نَبِيٌّ':Subject, #1: 1	سَدَّ الْمَكَانَ
u'سَدَّ نَقْبٌ':Predicate, #1: 1	سَدَّ النَّبِيُّ
u'سَرَّ أحَدٌ':Subject, #1: 1	سَدَّ النَّقْبَ
u'سَرَّ إمَامٌ':Subject, #1: 1	أَسَرَّ أَحَدٌ
u'سَرَّ حَديثٌ':Predicate, #1: 1	أَسَرَّ الْإِمَامُ
u'سَرَّحَ فلان':Predicate, #1: 1	أَسَرَّ الْحَدِيثَ
u'سَرْدٌ آثَارٌ':Added, #1: 1	سَرَّحَ الزُّبَيْرَ
u'سَرْدٌ أَقْوَالٌ':Added, #1: 1	سَرْدِ الْآثَارِ
u'سَرْدٌ أَقْوَالٌ':Added, #1: 1	سَرْدِ أَقْوَالِ
u'سَرْدٌ أَنْوَاعٌ':Added, #3: 3	سَرْدِ الْأَقْوَالِ
u'سَرَدَ تمام':Predicate, #1: 1	سَرْدِ أَنْوَاعِ
u'سَرَدَ تَمامٌ':Predicate, #1: 1	سَرَدَ تَمَامَ
u'سَرَدَ حَديثٌ':Predicate, #1: 1	سَرَدَ تَمَامَ
u'سَرْدٌ حَديثٌ':Added, #1: 1	سَرَدَ الْحَدِيثَ
u'سَرْدٌ خَمْسٌ':Added, #1: 1	سَرْدِ الْحَدِيثِ
u'سَرْدٌ رِواياتٌ':Added, #1: 1	سَرْدُ خَمْسٍ
u'سَرْدٌ صَوْمٌ':Added, #1: 1	سَرْدَ الرِّوَايَاتِ
u'سَرْدٌ صَوْمٌ':Added, #1: 1	سَرْدَ الصَّوْمِ
u'سَرْدٌ صِيَامٌ':Added, #1: 1	سَرْدُ الصَّوْمِ
u'سَرْدٌ قَصَصٌ':Added, #2: 2	سَرْدُ الصِّيَامِ
u'سَرْدٌ مِثْلِيٌّ':Added, #1: 1	سَرْدِ الْقَصَصِ
u'سَرَدَ مَسْأَلَةٌ':Predicate, #1: 1	سَرْدُ الْمِثْلِيَّاتِ
u'سَرْدٌ نَسَبٌ':Added, #1: 1	سَرَدَ الْمَسْأَلَةَ
u'سَرْدٌ نِسَبٌ':Added, #1: 1	سَرْدِ النّسَبِ
u'سَرْدٌ نُقُولٌ':Added, #1: 1	سَرْدِ النّسَبِ
u'سَرِعَ إِجَابَةٌ':Predicate, #2: 2	سَرْدِ النُّقُولِ
u'سَرِعَ أَسْرَعُ':Predicate, #1: 1	أَسْرَعَ الْإِجَابَةَ
u'سَرَّ عَبْدٌ':Subject, #1: 1	أَسْرَعَ أَسْرَعَ
u'سُرْعَةٌ إِجَابَةٌ':Added, #1: 1	أَسَرَّ عَبْدٌ
u'سُرْعَةٌ إِجَابَةٌ':Added, #1: 1	سُرْعَةِ الْإِجَابَةِ
u'سُرْعَةٌ بَيْعٌ':Added, #2: 2	سُرْعَةِ إجَابَةِ
u'سُرْعَةٌ تَجْهِيزٌ':Added, #1: 1	سُرْعَةِ الْبَيْعِ
u'سُرْعَةٌ جَوَابٌ':Added, #1: 1	سُرْعَةِ تَجْهِيزِهِ
u'سُرْعَةٌ جَوَابٌ':Added, #1: 1	سُرْعَةَ الْجَوَابِ
u'سُرْعَةٌ حَرَكَةٌ':Added, #1: 1	سُرْعَةُ الْجَوَابِ
u'سُرْعَةٌ حَرَكَةٌ':Added, #1: 1	سُرْعَةِ الْحَرَكَةِ
u'سُرْعَةٌ حِفْظٌ':Added, #1: 1	سُرْعَةِ حَرَكَتِهِ
u'سُرْعَةٌ حِفْظٌ':Added, #1: 1	سُرْعَةُ حِفْظِ
u'سُرْعَةٌ خُرُوجٌ':Added, #2: 2	سُرْعَةِ حِفْظِ
u'سُرْعَةٌ سُقُوطٌ':Added, #1: 1	سُرْعَةُ خُرُوجِ
u'سُرْعَةٌ عجلة':Added, #1: 1	سُرْعَةِ السُّقُوطِ
u'سُرْعَةٌ عَجَلَةٌ':Added, #1: 1	سُرْعَةِ الْعَجَلَةِ
u'سُرْعَةٌ فساد':Added, #1: 1	سُرْعَةِ الْعَجَلَةِ
u'سُرْعَةٌ فَسَادٌ':Added, #1: 1	سُرْعَةِ الْفَسَادِ
u'سُرْعَةٌ فَنَاءٌ':Added, #1: 1	سُرْعَةِ الْفَسَادِ
u'سُرْعَةٌ فَهْمٌ':Added, #1: 1	سُرْعَةَ فَنَاءِ
u'سُرْعَةٌ قيام':Added, #1: 1	سُرْعَةُ الْفَهْمِ
u'سُرْعَةٌ قِيَامٌ':Added, #1: 1	سُرْعَةَ قِيَامِهِ
u'سُرْعَةٌ مُرُورٌ':Added, #1: 1	سُرْعَةَ قِيَامِهِ
u'سُرْعَةٌ مَشْيٌ':Added, #1: 1	سُرْعَةِ مُرُورِهِ
u'سُرْعَةٌ نجاة':Added, #3: 3	سُرْعَةُ الْمَشْيِ
u'سُرْعَةٌ نَجَاةٌ':Added, #2: 2	سُرْعَةِ النَّجَاةِ
u'سُرْعَةٌ وُجُودٌ':Added, #2: 2	سُرْعَةِ النَّجَاةِ
u'سُرْعَةٌ وُقُوعٌ':Added, #1: 1	سُرْعَةُ الْوُجُودِ
u'سَرِعَ جَازٌ':Predicate, #1: 1	سُرْعَةُ وُقُوعِ
u'سَرِعَ سَيْرٌ':Predicate, #1: 1	أَسْرَعَ جَازَ
u'سَرَّ عُقَلاَءُ':Predicate, #1: 1	أَسْرَعَ السَّيْرَ
u'سَرِعَ نَاسٌ':Predicate, #1: 1	سَرَّ الْعُقَلَاءَ
u'سَرِعَ هضم':Predicate, #2: 2	أَسْرَعَ النَّاسَ
u'سَرِعَ هَضْمٌ':Predicate, #1: 1	أَسْرَعَ الْهَضْمَ
u'سَرِعَ وَجَبٌ':Predicate, #1: 1	أَسْرَعَ الْهَضْمَ
u'سَرَّ غير':Predicate, #2: 2	أَسْرَعَ وَجَبَ
u'سَرَّ غَيْرٌ':Predicate, #1: 1	أَسَرَّ غَيْرَ
u'سَرَقَ إِبِلٌ':Predicate, #1: 1	أَسَرَّ غَيْرَ
u'سَرَقَ أَبْوَابٌ':Predicate, #2: 2	سَرَقَ الْإِبِلَ
u'سَرَقَ أَجْنَبِيٌّ':Subject, #1: 1	سَرَقَ أَبْوَابَ
u'سَرَقَ أحَدٌ':Subject, #1: 1	سَرَقَ الْأَجْنَبِيُّ
u'سَرَقَ أحَدٌ':Subject, #1: 1	سَرَقَ أَحَدٌ
u'سَرَقَ إِحْيَاءٌ':Subject, #9: 9	سَرَقَ أَحَدُ
u'سَرَقَ أَخٌ':Subject, #1: 1	سَرَقَ إحْيَاءُ
u'سَرَقَ أقَلُّ':Predicate, #2: 2	سَرَقَ أَخٌ
u'سَرَقَ أَكْفَانٌ':Predicate, #3: 3	سَرَقَ أَقَلَّ
u'سَرَقَ أُمٌّ':Predicate, #1: 1	سَرَقَ أَكْفَانَ
u'سَرَقَ إِناءٌ':Predicate, #2: 2	سَرَقَ أُمَّ
u'سَرَقَ أهْلٌ':Predicate, #4: 4	سَرَقَ إنَاءَ
u'سَرَقَ أهْلٌ':Subject, #1: 1	سَرَقَ أَهْلَ
u'سَرَقَ بالِغٌ':Subject, #1: 1	سَرَقَ أَهْلُ
u'سَرَقَ بَائِعٌ':Subject, #1: 1	سَرَقَ الْبَالِغُ
u'سَرَقَ بَعْضٌ':Subject, #3: 3	سَرَقَ الْبَائِعُ
u'سَرَقَ بَعْضٌ':Subject, #2: 2	سَرَقَ بَعْضُ
u'سَرَقَ بَقَرٌ':Predicate, #6: 6	سَرَقَ بَعْضُهُ
u'سَرَقَ بَهيمٌ':Predicate, #8: 8	سَرَقَ بَقَرَةً
u'سَرَقَ بَهِيمَةٌ':Predicate, #1: 1	سَرَقَ الْبَهِيمَةَ
u'سَرقَةٌ أَبْوَابٌ':Added, #1: 1	سَرَقَ الْبَهِيمَةَ
u'سَرِقَةٌ أَبْوَابٌ':Added, #1: 1	سَرِقَةُ أَبْوَابِ
u'سَرقَةٌ أَبْوَابٌ':Added, #1: 1	سَرِقَةُ أَبْوَابِ
u'سَرِقَةٌ أَبْوَابٌ':Added, #2: 2	سَرِقَةَ أَبْوَابِ
u'سَرقَةٌ آلةٌ':Added, #2: 2	سَرِقَةَ أَبْوَابِ
u'سَرِقَةٌ آلةٌ':Added, #1: 1	سَرِقَةَ الْآلَةِ
u'سَرقَةٌ بَقَرٌ':Added, #1: 1	سَرِقَةَ الْآلَةِ
u'سَرقَةٌ بَقَرٌ':Added, #1: 1	سَرِقَةَ بَقَرَةٍ
u'سَرِقَةٌ بَقَرٌ':Added, #1: 1	سَرِقَةِ بَقَرَةٍ
u'سَرِقَةٌ بَقَرٌ':Added, #1: 1	سَرِقَةَ بَقَرَةٍ
u'سَرقَةٌ بَيَاضٌ':Added, #1: 1	سَرِقَةِ بَقَرَةٍ
u'سَرِقَةٌ بَيَاضٌ':Added, #1: 1	سَرِقَةِ الْبَيَاضِ
u'سَرقَةٌ تَافِهٌ':Added, #1: 1	سَرِقَةِ الْبَيَاضِ
u'سَرِقَةٌ تَافِهٌ':Added, #1: 1	سَرِقَةَ التَّافِهِ
u'سَرقَةٌ تَمْر':Added, #1: 1	سَرِقَةَ التَّافِهِ
u'سَرِقَةٌ تَمْر':Added, #1: 1	سَرِقَةِ التَّمْرِ
u'سَرقَةٌ ثَانِي':Added, #1: 1	سَرِقَةِ التَّمْرِ
u'سَرِقَةٌ ثَانِي':Added, #1: 1	سَرِقَةٍ ثَانِيَةٍ
u'سَرقَةٌ ثَانِيَةٌ':Added, #1: 1	سَرِقَةٍ ثَانِيَةٍ
u'سَرِقَةٌ ثَانِيَةٌ':Added, #1: 1	سَرِقَةٍ ثَانِيَةٍ
u'سَرقَةٌ ثَقِيلٌ':Added, #1: 1	سَرِقَةٍ ثَانِيَةٍ
u'سَرِقَةٌ ثَقِيلٌ':Added, #1: 1	سَرِقَةِ الثَّقِيلِ
u'سَرقَةٌ ثَلاثَةٌ':Added, #1: 1	سَرِقَةِ الثَّقِيلِ
u'سَرِقَةٌ ثَلاثَةٌ':Added, #1: 1	سَرِقَةِ ثَلَاثَةِ
u'سَرقَةٌ ثِمارٌ':Added, #1: 1	سَرِقَةِ ثَلَاثَةِ
u'سَرِقَةٌ ثِمارٌ':Added, #1: 1	سَرِقَةِ الثِّمَارِ
u'سَرقَةٌ ثَوْبٌ':Added, #1: 1	سَرِقَةِ الثِّمَارِ
u'سَرِقَةٌ ثَوْبٌ':Added, #1: 1	سَرِقَةِ الثَّوْبِ
u'سَرقَةٌ ثَوْبٌ':Added, #1: 1	سَرِقَةِ الثَّوْبِ
u'سَرقَةٌ ثَوْبٌ':Added, #1: 1	سَرِقَةَ ثَوْبٍ
u'سَرِقَةٌ ثَوْبٌ':Added, #1: 1	سَرِقَةُ ثَوْبٍ
u'سَرِقَةٌ ثَوْبٌ':Added, #1: 1	سَرِقَةَ ثَوْبٍ
u'سَرقَةٌ ثِيابٌ':Added, #1: 1	سَرِقَةُ ثَوْبٍ
u'سَرِقَةٌ ثِيابٌ':Added, #1: 1	سَرِقَةِ الثِّيَابِ
u'سَرقَةٌ جَامِعٌ':Added, #1: 1	سَرِقَةِ الثِّيَابِ
u'سَرِقَةٌ جَامِعٌ':Added, #1: 1	سَرِقَةِ الْجَامِعِ
u'سَرقَةٌ حُرٌّ':Added, #1: 1	سَرِقَةِ الْجَامِعِ
u'سَرِقَةٌ حُرٌّ':Added, #1: 1	سَرِقَةَ الْحُرِّ
u'سَرقَةٌ حُصُرٌ':Added, #1: 1	سَرِقَةَ الْحُرِّ
u'سَرِقَةٌ حُصُرٌ':Added, #1: 1	سَرِقَةِ حُصُرِهِ
u'سَرقَةٌ حَصِيرٌ':Added, #1: 1	سَرِقَةِ حُصُرِهِ
u'سَرِقَةٌ حَصِيرٌ':Added, #1: 1	سَرِقَةِ الْحَصِيرِ
u'سَرقَةٌ خَطْفٌ':Added, #1: 1	سَرِقَةِ الْحَصِيرِ
u'سَرِقَةٌ خَطْفٌ':Added, #1: 1	سَرِقَةُ الْخَطْفِ
u'سَرقَةٌ خَمْرٌ':Added, #1: 1	سَرِقَةُ الْخَطْفِ
u'سَرِقَةٌ خَمْرٌ':Added, #1: 1	سَرِقَةِ الْخَمْرِ
u'سَرقَةٌ دَرَاهِمُ':Added, #1: 1	سَرِقَةِ الْخَمْرِ
u'سَرِقَةٌ دَرَاهِمُ':Added, #1: 1	سَرِقَةِ الدَّرَاهِمِ
u'سَرقَةٌ دَفَاتِرُ':Added, #1: 1	سَرِقَةِ الدَّرَاهِمِ
u'سَرِقَةٌ دَفَاتِرُ':Added, #1: 1	سَرِقَةِ دَفَاتِرِ
u'سَرقَةٌ سَعَفٌ':Added, #1: 1	سَرِقَةِ دَفَاتِرِ
u'سَرقَةٌ سَعَفٌ':Added, #1: 1	سَرِقَةَ السَّعَفِ
u'سَرقَةٌ سَعَف':Added, #1: 1	سَرِقَةُ السَّعَفِ
u'سَرقَةٌ سَعَف':Added, #1: 1	سَرِقَةَ السَّعَفِ
u'سَرِقَةٌ سَعَفٌ':Added, #1: 1	سَرِقَةُ السَّعَفِ
u'سَرِقَةٌ سَعَفٌ':Added, #1: 1	سَرِقَةَ السَّعَفِ
u'سَرِقَةٌ سَعَف':Added, #1: 1	سَرِقَةُ السَّعَفِ
u'سَرِقَةٌ سَعَف':Added, #1: 1	سَرِقَةَ السَّعَفِ
u'سَرقَةٌ سَوادٌ':Added, #1: 1	سَرِقَةُ السَّعَفِ
u'سَرِقَةٌ سَوادٌ':Added, #1: 1	سَرِقَةَ السَّوَادِ
u'سَرقَةٌ شِطْرَنْجٌ':Added, #1: 1	سَرِقَةَ السَّوَادِ
u'سَرِقَةٌ شِطْرَنْجٌ':Added, #1: 1	سَرِقَةِ الشِّطْرَنْجِ
u'سَرقَةٌ شَيْءٌ':Added, #1: 1	سَرِقَةِ الشِّطْرَنْجِ
u'سَرِقَةٌ شَيْءٌ':Added, #1: 1	سَرِقَةُ الشَّيْءِ
u'سَرقَةٌ شَيْءٌ':Added, #1: 1	سَرِقَةُ الشَّيْءِ
u'سَرِقَةٌ شَيْءٌ':Added, #1: 1	سَرِقَةُ شَيْءٍ
u'سَرقَةٌ صَيْدٌ':Added, #1: 1	سَرِقَةُ شَيْءٍ
u'سَرِقَةٌ صَيْدٌ':Added, #1: 1	سَرِقَةِ الصَّيْدِ
u'سَرقَةٌ ضَيْفٌ':Added, #1: 1	سَرِقَةِ الصَّيْدِ
u'سَرِقَةٌ ضَيْفٌ':Added, #1: 1	سَرِقَةُ الضَّيْفِ
u'سَرقَةٌ طَوْقٌ':Added, #1: 1	سَرِقَةُ الضَّيْفِ
u'سَرِقَةٌ طَوْقٌ':Added, #1: 1	سَرِقَةَ الطَّوْقِ
u'سَرقَةٌ عَبْدٌ':Added, #1: 1	سَرِقَةَ الطَّوْقِ
u'سَرقَةٌ عَبْدٌ':Added, #1: 1	سَرِقَةَ عَبْدِ
u'سَرِقَةٌ عَبْدٌ':Added, #1: 1	سَرِقَةُ عَبْدِ
u'سَرِقَةٌ عَبْدٌ':Added, #1: 1	سَرِقَةَ عَبْدِ
u'سَرقَةٌ عَبْدٌ':Added, #1: 1	سَرِقَةُ عَبْدِ
u'سَرِقَةٌ عَبْدٌ':Added, #7: 7	سَرِقَةِ الْعَبْدِ
u'سَرقَةٌ عين':Added, #7: 7	سَرِقَةِ الْعَبْدِ
u'سَرقَةٌ عَيْنٌ':Added, #1: 1	سَرِقَةِ الْعَيْنِ
u'سَرقَةٌ عَيْن':Added, #1: 1	سَرِقَةِ الْعَيْنِ
u'سَرِقَةٌ عين':Added, #1: 1	سَرِقَةِ الْعَيْنِ
u'سَرِقَةٌ عَيْنٌ':Added, #1: 1	سَرِقَةِ الْعَيْنِ
u'سَرِقَةٌ عَيْن':Added, #1: 1	سَرِقَةِ الْعَيْنِ
u'سَرقَةٌ عين':Added, #1: 1	سَرِقَةِ الْعَيْنِ
u'سَرقَةٌ عَيْنٌ':Added, #1: 1	سَرِقَةَ عَيْنِهِ
u'سَرقَةٌ عَيْن':Added, #1: 1	سَرِقَةَ عَيْنِهِ
u'سَرِقَةٌ عين':Added, #1: 1	سَرِقَةَ عَيْنِهِ
u'سَرِقَةٌ عَيْنٌ':Added, #1: 1	سَرِقَةَ عَيْنِهِ
u'سَرِقَةٌ عَيْن':Added, #1: 1	سَرِقَةَ عَيْنِهِ
u'سَرقَةٌ قُطْنٌ':Added, #1: 1	سَرِقَةَ عَيْنِهِ
u'سَرِقَةٌ قُطْنٌ':Added, #1: 1	سَرِقَةِ الْقُطْنِ
u'سَرقَةٌ كَفَنٌ':Added, #1: 1	سَرِقَةِ الْقُطْنِ
u'سَرِقَةٌ كَفَنٌ':Added, #3: 3	سَرِقَةِ الْكَفَنِ
u'سَرقَةٌ كَلْبٌ':Added, #3: 3	سَرِقَةِ الْكَفَنِ
u'سَرِقَةٌ كَلْبٌ':Added, #1: 1	سَرِقَةُ الْكَلْبِ
u'سَرقَةٌ كَلْبٌ':Added, #1: 1	سَرِقَةُ الْكَلْبِ
u'سَرِقَةٌ كَلْبٌ':Added, #3: 3	سَرِقَةِ كَلْبٍ
u'سَرقَةٌ لُقْمَةٌ':Added, #3: 3	سَرِقَةِ كَلْبٍ
u'سَرقَةٌ لُقْمَةٌ':Added, #1: 1	سَرِقَةَ لُقْمَةٍ
u'سَرِقَةٌ لُقْمَةٌ':Added, #1: 1	سَرِقَةِ لُقْمَةٍ
u'سَرِقَةٌ لُقْمَةٌ':Added, #1: 1	سَرِقَةَ لُقْمَةٍ
u'سَرقَةٌ مَالٌ':Added, #1: 1	سَرِقَةِ لُقْمَةٍ
u'سَرِقَةٌ مَالٌ':Added, #1: 1	سَرِقَةِ مَالٍ
u'سَرقَةٌ مَالٌ':Added, #1: 1	سَرِقَةِ مَالٍ
u'سَرِقَةٌ مَالٌ':Added, #1: 1	سَرِقَةُ مَالِهِ
u'سَرقَةٌ مَالٌ':Added, #1: 1	سَرِقَةُ مَالِهِ
u'سَرِقَةٌ مَالٌ':Added, #5: 5	سَرِقَةِ مَالِ
u'سَرقَةٌ مُبَاحٌ':Added, #5: 5	سَرِقَةِ مَالِ
u'سَرِقَةٌ مُبَاحٌ':Added, #1: 1	سَرِقَةِ مُبَاحِ
u'سَرقَةٌ مَتَاعٌ':Added, #1: 1	سَرِقَةِ مُبَاحِ
u'سَرِقَةٌ مَتَاعٌ':Added, #2: 2	سَرِقَةَ مَتَاعٍ
u'سَرقَةٌ مُصْحَفٌ':Added, #2: 2	سَرِقَةَ مَتَاعٍ
u'سَرِقَةٌ مُصْحَفٌ':Added, #1: 1	سَرِقَةِ مُصْحَفٍ
u'سَرقَةٌ مُصْحَفٌ':Added, #1: 1	سَرِقَةِ مُصْحَفٍ
u'سَرِقَةٌ مُصْحَفٌ':Added, #4: 4	سَرِقَةِ الْمُصْحَفِ
u'سَرقَةٌ نَائِمٌ':Added, #4: 4	سَرِقَةِ الْمُصْحَفِ
u'سَرِقَةٌ نَائِمٌ':Added, #1: 1	سَرِقَةِ نَائِمٍ
u'سَرقَةٌ نَحْوٌ':Added, #1: 1	سَرِقَةِ نَائِمٍ
u'سَرِقَةٌ نَحْوٌ':Added, #1: 1	سَرِقَةَ نَحْوِ
u'سَرقَةٌ نصاب':Added, #1: 1	سَرِقَةَ نَحْوِ
u'سَرِقَةٌ نصاب':Added, #1: 1	سَرِقَةِ النِّصَابِ
u'سَرقَةٌ نِصَابٌ':Added, #1: 1	سَرِقَةِ النِّصَابِ
u'سَرِقَةٌ نِصَابٌ':Added, #1: 1	سَرِقَةِ النِّصَابِ
u'سَرقَةٌ نصاب':Added, #1: 1	سَرِقَةِ النِّصَابِ
u'سَرِقَةٌ نصاب':Added, #2: 2	سَرِقَةُ النِّصَابِ
u'سَرقَةٌ نِصَابٌ':Added, #2: 2	سَرِقَةُ النِّصَابِ
u'سَرِقَةٌ نِصَابٌ':Added, #2: 2	سَرِقَةُ النِّصَابِ
u'سَرقَةٌ نصاب':Added, #2: 2	سَرِقَةُ النِّصَابِ
u'سَرِقَةٌ نصاب':Added, #4: 4	سَرِقَةِ نِصَابٍ
u'سَرقَةٌ نِصَابٌ':Added, #4: 4	سَرِقَةِ نِصَابٍ
u'سَرِقَةٌ نِصَابٌ':Added, #4: 4	سَرِقَةِ نِصَابٍ
u'سَرقَةٌ نَفْسٌ':Added, #4: 4	سَرِقَةِ نِصَابٍ
u'سَرِقَةٌ نَفْسٌ':Added, #1: 1	سَرِقَةُ نَفْسِ
u'سَرقَةٌ وَدِيعٌ':Added, #1: 1	سَرِقَةُ نَفْسِ
u'سَرِقَةٌ وَدِيعٌ':Added, #1: 1	سَرِقَةِ الْوَدِيعَةِ
u'سَرقَةٌ وَدِيعَةٌ':Added, #1: 1	سَرِقَةِ الْوَدِيعَةِ
u'سَرِقَةٌ وَدِيعَةٌ':Added, #1: 1	سَرِقَةِ الْوَدِيعَةِ
u'سَرَقَ ثَالِثٌ':Predicate, #1: 1	سَرِقَةِ الْوَدِيعَةِ
u'سَرَقَ ثَانِي':Predicate, #1: 1	سَرَقَ ثَالِثَةً
u'سَرَقَ ثَلاثَةٌ':Predicate, #1: 1	سَرَقَ ثَانِيَةً
u'سَرَقَ ثَوْبٌ':Predicate, #2: 2	سَرَقَ ثَلَاثَةَ
u'سَرَقَ جلد':Predicate, #3: 3	سَرَقَ الثَّوْبَ
u'سَرَقَ جِلْدٌ':Predicate, #1: 1	سَرَقَ الْجِلْدَ
u'سَرَقَ جلد':Predicate, #1: 1	سَرَقَ الْجِلْدَ
u'سَرَقَ جُلُودٌ':Predicate, #1: 1	سَرَقَ جُلِدَ
u'سَرَقَ جَمَاعَةٌ':Subject, #1: 1	سَرَقَ جُلُودَ
u'سَرَقَ جُوَالِقٌ':Predicate, #1: 1	سَرَقَ جَمَاعَةٌ
u'سَرَقَ حِرْزٌ':Predicate, #2: 2	سَرَقَ الْجُوَالِقَ
u'سَرَقَ حُصُرٌ':Predicate, #1: 1	سَرَقَ الْحِرْزَ
u'سَرَقَ خامس':Predicate, #1: 1	سَرَقَ حُصُرَ
u'سَرَقَ خَامِسٌ':Predicate, #1: 1	سَرَقَ الْخَامِسَةَ
u'سَرَقَ خامس':Predicate, #1: 1	سَرَقَ الْخَامِسَةَ
u'سَرَقَ خَامِسٌ':Predicate, #1: 1	سَرَقَ خَامِسَةً
u'سَرَقَ خَمْرٌ':Predicate, #1: 1	سَرَقَ خَامِسَةً
u'سَرَقَ خَيْمَةٌ':Predicate, #1: 1	سَرَقَ الْخَمْرَ
u'سَرَقَ دَابَّةٌ':Predicate, #1: 1	سَرَقَ الْخَيْمَةَ
u'سَرَقَ دَرَاهِمُ':Predicate, #3: 3	سَرَقَ الدَّابَّةَ
u'سَرَقَ دَرَاهِمُ':Predicate, #2: 2	سَرَقَ الدَّرَاهِمَ
u'سَرَقَ دِرْهَمٌ':Predicate, #3: 3	سَرَقَ دَرَاهِمَ
u'سَرَقَ دِرْهَم':Predicate, #1: 1	سَرَقَ الدِّرْهَمَ
u'سَرَقَ دَنانيرُ':Predicate, #1: 1	سَرَقَ الدِّرْهَمَ
u'سَرَقَ دونٌ':Predicate, #5: 5	سَرَقَ دَنَانِيرَ
u'سَرَقَ ذِمِّيٌّ':Subject, #2: 2	سَرَقَ دُونَ
u'سَرَقَ ذِمِّيٌّ':Subject, #3: 3	سَرَقَ الذِّمِّيُّ
u'سَرَّ قِرَاءةٌ':Predicate, #4: 4	سَرَقَ ذِمِّيٌّ
u'سَرَقَ رَاهِنٌ':Subject, #1: 1	أَسَرَّ الْقِرَاءَةَ
u'سَرَقَ رُبْعٌ':Predicate, #1: 1	سَرَقَ الرَّاهِنُ
u'سَرَقَ رِتَاجٌ':Predicate, #4: 4	سَرَقَ رُبْعَ
u'سَرَقَ رَجُلٌ':Subject, #1: 1	سَرَقَ رِتَاجَ
u'سَرَقَ رَجُلٌ':Subject, #1: 1	سَرَقَ الرَّجُلُ
u'سَرَقَ رَدٌّ':Predicate, #5: 5	سَرَقَ رَجُلٌ
u'سَرَقَ رِدَاءٌ':Predicate, #1: 1	سَرَقَ رَدَّ
u'سَرَقَ رَقيقٌ':Subject, #3: 3	سَرَقَ رِدَاءَ
u'سَرَقَ رَقيق':Subject, #1: 1	سَرَقَ رَقِيقٌ
u'سَرَقَ سَارِقٌ':Subject, #1: 1	سَرَقَ رَقِيقٌ
u'سَرَقَ سَارِقٌ':Subject, #2: 2	سَرَقَ سَارِقٌ
u'سَرَقَ شَخْصٌ':Subject, #4: 4	سَرَقَ السَّارِقُ
u'سَرَقَ شَرِيكٌ':Subject, #1: 1	سَرَقَ شَخْصٌ
u'سَرَقَ شَيْءٌ':Predicate, #1: 1	سَرَقَ الشَّرِيكُ
u'سَرَقَ صَلِيبٌ':Predicate, #1: 1	سَرَقَ الشَّيْءَ
u'سَرَقَ ضَيْفٌ':Subject, #1: 1	سَرَقَ صَلِيبَ
u'سَرَقَ ضَيْفٌ':Subject, #1: 1	سَرَقَ ضَيْفٌ
u'سَرَقَ عَاقِلٌ':Subject, #2: 2	سَرَقَ الضَّيْفُ
u'سَرَقَ عَبْدٌ':Subject, #2: 2	سَرَقَ الْعَاقِلُ
u'سَرَقَ عَبْدٌ':Subject, #1: 1	سَرَقَ عَبْدٌ
u'سَرَقَ عَقْدٌ':Predicate, #7: 7	سَرَقَ الْعَبْدُ
u'سَرَقَ عند':Predicate, #1: 1	سَرَقَ عَقْدَ
u'سَرَقَ غَنَمٌ':Predicate, #5: 5	سَرَقَ عِنْدَ
u'سَرَقَ غير':Predicate, #1: 1	سَرَقَ الْغَنَمَ
u'سَرَقَ غَيْرٌ':Predicate, #1: 1	سَرَقَ غَيْرَ
u'سَرَقَ فرد':Predicate, #1: 1	سَرَقَ غَيْرَ
u'سَرَقَ فَرْدٌ':Predicate, #3: 3	سَرَقَ فَرْدَ
u'سَرَقَ فُلاَنٌ':Subject, #3: 3	سَرَقَ فَرْدَ
u'سَرَقَ قَالٌ':Predicate, #1: 1	سَرَقَ فُلَانٌ
u'سَرَقَ قَبَاءٌ':Predicate, #2: 2	سَرَقَ قَالَ
u'سَرَقَ قُرْطٌ':Predicate, #1: 1	سَرَقَ قَبَاءَ
u'سَرَقَ قَنَادِيلُ':Predicate, #1: 1	سَرَقَ قُرْطَ
u'سَرَقَ كَثِيرٌ':Predicate, #1: 1	سَرَقَ قَنَادِيلَ
u'سَرَقَ كَفَنٌ':Predicate, #1: 1	سَرَقَ الْكَثِيرَ
u'سَرَقَ كَفَنٌ':Predicate, #1: 1	سَرَقَ الْكَفَنَ
u'سَرَقَ كَلْبٌ':Subject, #1: 1	سَرَقَ كَفَنَ
u'سَرَقَ كَنْزٌ':Predicate, #2: 2	سَرَقَ الْكَلْبُ
u'سَرَقَ مَاءٌ':Predicate, #1: 1	سَرَقَ كَنْزَ
u'سَرَقَ مَاشِي':Predicate, #1: 1	سَرَقَ الْمَاءَ
u'سَرَقَ مَالٌ':Predicate, #1: 1	سَرَقَ مَاشِيَةً
u'سَرَقَ مَالٌ':Predicate, #16: 16	سَرَقَ مَالَ
u'سَرَقَ مَتَاعٌ':Predicate, #4: 4	سَرَقَ الْمَالَ
u'سَرَقَ مَحْمَلٌ':Predicate, #2: 2	سَرَقَ الْمَتَاعَ
u'سَرَقَ مَدْفُونٌ':Predicate, #1: 1	سَرَقَ الْمَحْمَلَ
u'سَرَقَ مَذْبُوحٌ':Predicate, #2: 2	سَرَقَ الْمَدْفُونَ
u'سَرَقَ مَذْبُوحٌ':Subject, #2: 2	سَرَقَ الْمَذْبُوحَ
u'سَرَقَ مَذْكُورٌ':Subject, #1: 1	سَرَقَ الْمَذْبُوحُ
u'سَرَقَ مرٌّ':Predicate, #1: 1	سَرَقَ مَذْكُورَةٌ
u'سَرَقَ مِرْآةٌ':Predicate, #3: 3	سَرَقَ مَرَّةً
u'سَرَقَ مُسْتَأْجِرٌ':Subject, #1: 1	سَرَقَ مِرْآةَ
u'سَرَقَ مَسْرُوقٌ':Subject, #2: 2	سَرَقَ الْمُسْتَأْجِرُ
u'سَرَقَ مُسْلِمٌ':Subject, #1: 1	سَرَقَ الْمَسْرُوقُ
u'سَرَقَ مُسْلِمٌ':Subject, #1: 1	سَرَقَ الْمُسْلِمُ
u'سَرَقَ مُصْحَفٌ':Predicate, #2: 2	سَرَقَ مُسْلِمٌ
u'سَرَقَ مِلْكٌ':Predicate, #1: 1	سَرَقَ الْمُصْحَفَ
u'سَرَقَ مَنَارٌ':Predicate, #1: 1	سَرَقَ مِلْكَ
u'سَرَقَ مُؤَجِّرٌ':Subject, #1: 1	سَرَقَ مَنَارَ
u'سَرَقَ نصاب':Predicate, #2: 2	سَرَقَ الْمُؤَجِّرُ
u'سَرَقَ نِصَابٌ':Predicate, #1: 1	سَرَقَ النِّصَابَ
u'سَرَقَ نصب':Predicate, #1: 1	سَرَقَ النِّصَابَ
u'سَرَقَ نصب':Predicate, #1: 1	سَرَقَ النَّصْبَ
u'سَرَقَ نَصْبٌ':Predicate, #1: 1	سَرَقَ النُّصُبَ
u'سَرَقَ نُصُبٌ':Predicate, #1: 1	سَرَقَ النَّصْبَ
u'سَرَقَ نِصْفٌ':Predicate, #1: 1	سَرَقَ النُّصُبَ
u'سَرَقَ نَفْسٌ':Predicate, #3: 3	سَرَقَ نِصْفَ
u'سَرَقَ هَدْيٌ':Predicate, #1: 1	سَرَقَ نَفْسَ
u'سَرَقَ واحد':Subject, #1: 1	سَرَقَ هَدْيَ
u'سَرَقَ وَاحِدٌ':Subject, #6: 6	سَرَقَ وَاحِدٌ
u'سَرَقَ وَجَبٌ':Predicate, #6: 6	سَرَقَ وَاحِدٌ
u'سَرَقَ ورق':Predicate, #1: 1	سَرَقَ وَجَبَ
u'سَرَقَ وَرَقٌ':Predicate, #1: 1	سَرَقَ الْوَرَقَ
u'سَرَقَ وَقْفٌ':Predicate, #1: 1	سَرَقَ الْوَرَقَ
u'سَرَّ قول':Predicate, #1: 1	سَرَقَ الْوَقْفَ
u'سَرَّ قَوْلٌ':Predicate, #1: 1	أَسَرَّ الْقَوْلَ
u'سَرَقَ ولد':Predicate, #1: 1	أَسَرَّ الْقَوْلَ
u'سَرَقَ وَلَدٌ':Predicate, #1: 1	سَرَقَ الْوَلَدَ
u'سَرَقَ وَلَهٌ':Subject, #1: 1	سَرَقَ الْوَلَدَ
u'سَرَقَ يَدٌ':Predicate, #5: 5	سَرَقَ وَلَهُ
u'سَرَّ كفر':Predicate, #1: 1	سَرَقَ يَدَ
u'سَرَّ كُفْرٌ':Predicate, #7: 7	أَسَرَّ الْكُفْرَ
u'سَرَّ مَالِكٌ':Subject, #7: 7	أَسَرَّ الْكُفْرَ
u'سَرَّ مَعْصِيَةٌ':Predicate, #1: 1	أَسَرَّ مَالِكٌ
u'سُرُورٌ إِنْسانٌ':Added, #1: 1	أَسَرَّ الْمَعْصِيَةَ
u'سُرُورٌ حادِثٌ':Added, #1: 1	سُرُورِ الْإِنْسَانِ
u'سُرُورٌ روحٌ':Added, #2: 2	سُرُورٍ حَادِثٍ
u'سُرُورٌ مُؤْمِنٌ':Added, #1: 1	سُرُورُ الرُّوحِ
u'سَرَى أثَرٌ':Subject, #1: 1	سُرُورِ الْمُؤْمِنِ
u'سَرَيَانٌ عتق':Added, #1: 1	سَرَى أَثَرُ
u'سَرَيَانٌ عِتْقٌ':Added, #1: 1	سَرَيَانِ الْعِتْقِ
u'سَرَيَانٌ نَجَاسَةٌ':Added, #1: 1	سَرَيَانِ الْعِتْقِ
u'سَرَيَانٌ نَجَاسَةٌ':Added, #1: 1	سَرَيَانَ النَّجَاسَةِ
u'سَرَى بَيْنٌ':Predicate, #1: 1	سَرَيَانُ النَّجَاسَةِ
u'سَرَى حَدَثٌ':Subject, #1: 1	سَرَى بَيْنَ
u'سَرَى حَدَثٌ':Subject, #1: 1	سَرَى حَدَثٌ
u'سَرَى حَقٌّ':Subject, #2: 2	سَرَى الْحَدَثُ
u'سَرَى حُكْمٌ':Subject, #1: 1	سَرَى حَقُّ
u'سَرَى رَسُولٌ':Subject, #1: 1	سَرَى حُكْمُ
u'سَرَى سقم':Subject, #1: 1	سَرَى رَسُولُ
u'سَرَى سَقَمٌ':Subject, #1: 1	سَرَى السَّقَمُ
u'سَرَى ضَمِنٌ':Predicate, #1: 1	سَرَى السَّقَمُ
u'سَرَى عتق':Subject, #1: 1	سَرَى ضَمِنَ
u'سَرَى عِتْقٌ':Subject, #1: 1	سَرَى عِتْقُ
u'سَرَى عتق':Subject, #1: 1	سَرَى عِتْقُ
u'سَرَى عِتْقٌ':Subject, #1: 1	سَرَى عِتْقُهُ
u'سَرَى عتق':Subject, #1: 1	سَرَى عِتْقُهُ
u'سَرَى عِتْقٌ':Subject, #5: 5	سَرَى الْعِتْقُ
u'سَرِيَ فلان':Predicate, #5: 5	سَرَى الْعِتْقُ
u'سَرَى قَطْعٌ':Subject, #2: 2	أَسْرَى مَكَّةَ
u'سَرِيَ مُسْلِمٌ':Predicate, #6: 6	سَرَى الْقَطْعُ
u'سَرِيَ مُسْلِمٌ':Predicate, #1: 1	أَسْرَى مُسْلِمِينَ
u'سَرِيَ مُشْرِك':Predicate, #6: 6	أَسْرَى الْمُسْلِمِينَ
u'سَرَى وَاجِبٌ':Subject, #2: 2	أَسْرَى الْمُشْرِكِينَ
u'سَطْحٌ بَائِعٌ':Added, #1: 1	سَرَى الْوَاجِبُ
u'سَطْحٌ بدن':Added, #1: 1	سَطْحِ الْبَائِعِ
u'سَطْحٌ بدن':Added, #1: 1	سَطْحَ الْبَدَنِ
u'سَطْحٌ بَدَنٌ':Added, #1: 1	سَطْحِ الْبَدَنِ
u'سَطْحٌ بَدَنٌ':Added, #1: 1	سَطْحَ الْبَدَنِ
u'سَطْحٌ بُروجٌ':Added, #1: 1	سَطْحِ الْبَدَنِ
u'سَطْحٌ بَيْتٌ':Added, #1: 1	سَطْحِ الْبُرُوجِ
u'سَطْحٌ بَيْتٌ':Added, #1: 1	سَطْحُ الْبَيْتِ
u'سَطْحٌ بَيْتٌ':Added, #1: 1	سَطْحِ الْبَيْتِ
u'سَطْحٌ جَارٌ':Added, #2: 2	سَطْحِ بَيْتٍ
u'سَطْحٌ جَارٌ':Added, #1: 1	سَطْحُ الْجَارِ
u'سَطْحٌ جَارٌ':Added, #1: 1	سَطْحِ الْجَارِ
u'سَطْحٌ جَارٌ':Added, #2: 2	سَطْحِ جَارٍ
u'سَطْحٌ جَبَلٌ':Added, #4: 4	سَطْحِ جَارِهِ
u'سَطْحٌ جَبْهَةٌ':Added, #1: 1	سَطْحُ الْجَبَلِ
u'سَطْحٌ جَسَدٌ':Added, #1: 1	سَطْحِ الْجَبْهَةِ
u'سَطْحٌ جلد':Added, #1: 1	سَطْحِ الْجَسَدِ
u'سَطْحٌ جِلْدٌ':Added, #2: 2	سَطْحِ الْجِلْدِ
u'سَطْحٌ حَرَمٌ':Added, #2: 2	سَطْحِ الْجِلْدِ
u'سَطْحٌ دَارٌ':Added, #1: 1	سَطْحِ الْحَرَمِ
u'سَطْحٌ دَارٌ':Added, #1: 1	سَطْحَ الدَّارِ
u'سَطْحٌ دَارٌ':Added, #1: 1	سَطْحِ دَارٍ
u'سَطْحٌ دَارٌ':Added, #1: 1	سَطْحِ دَارِ
u'سَطْحٌ دَارٌ':Added, #3: 3	سَطْحِ الدَّارِ
u'سَطْحٌ رَجُلٌ':Added, #7: 7	سَطْحِ دَارِهِ
u'سَطْحٌ سُفْلٌ':Added, #2: 2	سَطْحِ رَجُلٍ
u'سَطْحٌ صَاحِبٌ':Added, #3: 3	سَطْحُ السُّفْلِ
u'سَطْحٌ غُرْفَةٌ':Added, #1: 1	سَطْحِ صَاحِبِ
u'سَطْحٌ غير':Added, #1: 1	سَطْحِ غُرْفَةٍ
u'سَطْحٌ غَيْرٌ':Added, #5: 5	سَطْحِ غَيْرِهِ
u'سَطْحٌ فُلاَنٌ':Added, #5: 5	سَطْحِ غَيْرِهِ
u'سَطَّحَ قَبْرٌ':Predicate, #1: 1	سَطْحَ فُلَانٍ
u'سَطْحٌ قمر':Added, #1: 1	سَطَّحَ قَبْرَ
u'سَطْحٌ قَمَرٌ':Added, #1: 1	سَطْحُ قَمَرٍ
u'سَطْحٌ كعبة':Added, #1: 1	سَطْحُ قَمَرٍ
u'سَطْحٌ كَعْبَةٌ':Added, #8: 8	سَطْحِ الْكَعْبَةِ
u'سَطْحٌ كَنِيفٌ':Added, #8: 8	سَطْحِ الْكَعْبَةِ
u'سَطْحٌ مَحَلٌّ':Added, #1: 1	سَطْحِ الْكَنِيفِ
u'سَطْحٌ مَسْجِدٌ':Added, #1: 1	سَطْحِ مَحَلِّ
u'سَطْحٌ مَسْجِدٌ':Added, #1: 1	سَطْحِ مَسْجِدٍ
u'سَطْحٌ مَسْجِدٌ':Added, #21: 21	سَطْحِ الْمَسْجِدِ
u'سَطْحٌ مَنْزِلٌ':Added, #3: 3	سَطْحَ الْمَسْجِدِ
u'سَطْحٌ نَهْرٌ':Added, #1: 1	سَطْحِ مَنْزِلِهِ
u'سَطْحٌ نَهْرٌ':Added, #1: 1	سَطْحُ النَّهْرِ
u'سَطْحٌ وَجْهٌ':Added, #1: 1	سَطْحَ نَهْرٍ
u'سَطَعَ غبار':Subject, #1: 1	سَطْحِ الْوَجْهِ
u'سَطَعَ غُبَارٌ':Subject, #1: 1	سَطَعَ غُبَارُهُ
u'سَطَعَ فَجْرٌ':Subject, #1: 1	سَطَعَ غُبَارُهُ
u'سَطْوَةٌ اِنْتِقامٌ':Added, #2: 2	سَطَعَ الْفَجْرُ
u'سَطْوَةٌ جَبَابِرَةٌ':Added, #1: 1	سَطْوَةَ انْتِقَامِهِ
u'سَطْوَةٌ حُماةٌ':Added, #1: 1	سَطْوَةِ الْجَبَابِرَةِ
u'سَطْوَةٌ صَاحِبٌ':Added, #1: 1	سَطْوَةِ الْحُمَاةِ
u'سَطْوَةٌ عَدُوٌّ':Added, #1: 1	سَطْوَةِ صَاحِبِ
u'سَطْوَةٌ عقاب':Added, #1: 1	سَطْوَةِ الْعَدُوِّ
u'سَطْوَةٌ عِقَابٌ':Added, #1: 1	سَطْوَةَ الْعِقَابِ
u'سَطْوَةٌ عقاب':Added, #1: 1	سَطْوَةَ الْعِقَابِ
u'سَطْوَةٌ عِقَابٌ':Added, #1: 1	سَطْوَةَ عِقَابِهِ
u'سَطْوَةٌ لِسَانٌ':Added, #1: 1	سَطْوَةَ عِقَابِهِ
u'سَطْوَةٌ مَالِكٌ':Added, #1: 1	سَطْوَةَ لِسَانٍ
u'سَطْوَةٌ يَدٌ':Added, #1: 1	سَطْوَةِ مَالِكِهِ
u'سَعَادَةٌ اِبْنٌ':Added, #1: 1	سَطْوَةَ يَدٍ
u'سَعَادَةٌ الْمَرْءُ':Added, #2: 2	سَعَادَةِ ابْنِ
u'سَعَادَةٌ رَجُلٌ':Added, #7: 7	سَعَادَةِ الْمَرْءِ
u'سَعَادَةٌ قَوْمٌ':Added, #1: 1	سَعَادَةِ الرَّجُلِ
u'سَعَادَةٌ مُؤَبَّدٌ':Added, #1: 1	سَعَادَةِ الْقَوْمِ
u'سَعَادَةٌ وَكِيلٌ':Added, #1: 1	سَعَادَةٍ مُؤَبَّدَةٍ
u'سِعَايَةٌ حُرٌّ':Added, #1: 1	سَعَادَةِ وَكِيلِ
u'سِعَايَةٌ ضَمَانٌ':Added, #1: 1	سِعَايَةُ حُرٍّ
u'سِعَايَةٌ ضَمَانٌ':Added, #1: 1	سِعَايَةَ ضَمَانٍ
u'سِعَايَةٌ عَبْدٌ':Added, #1: 1	سِعَايَةُ ضَمَانٍ
u'سِعَايَةٌ عَبْدٌ':Added, #1: 1	سِعَايَةِ الْعَبْدِ
u'سِعَايَةٌ مِلْكٌ':Added, #6: 6	سِعَايَةَ الْعَبْدِ
u'سِعَايَةٌ مِلْكٌ':Added, #1: 1	سِعَايَةَ مِلْكٍ
u'سِعَايَةٌ نِصْفٌ':Added, #1: 1	سِعَايَةُ مِلْكٍ
u'سِعَايَةٌ ولد':Added, #1: 1	سِعَايَةِ النِّصْفِ
u'سِعَايَةٌ ولد':Added, #1: 1	سِعَايَةَ الْوَلَدِ
u'سِعَايَةٌ وَلَدٌ':Added, #1: 1	سِعَايَةِ الْوَلَدِ
u'سِعَايَةٌ وَلَدٌ':Added, #1: 1	سِعَايَةَ الْوَلَدِ
u'سَعَةٌ إبَاحَةٌ':Added, #1: 1	سِعَايَةِ الْوَلَدِ
u'سَعَةٌ أَحْوالٌ':Added, #1: 1	سَعَةِ الْإِبَاحَةِ
u'سَعَةٌ أحْوَالٌ':Added, #1: 1	سَعَةِ الْأَحْوَالِ
u'سَعَةٌ أخْلاقٌ':Added, #1: 1	سَعَةِ الْأَحْوَالِ
u'سَعَةٌ أَخْلاَقٌ':Added, #1: 1	سَعَةِ الْأَخْلَاقِ
u'سَعَةٌ إِسْلامٌ':Added, #1: 1	سَعَةِ الْأَخْلَاقِ
u'سَعَةٌ إِطْلاعٌ':Added, #1: 1	سَعَةُ الْإِسْلَامِ
u'سَعَةٌ اِطِّلاعٌ':Added, #1: 1	سَعَةِ إطْلَاعِهِ
u'سَعَةٌ أَقْطَارٌ':Added, #1: 1	سَعَةِ اطِّلَاعِهِ
u'سَعَةٌ أُمٌّ':Added, #1: 1	سَعَةَ أَقْطَارِ
u'سَعَةٌ بَلَدٌ':Added, #1: 1	سَعَةُ أُمِّ
u'سَعَةٌ خُفٌّ':Added, #3: 3	سَعَةِ الْبَلَدِ
u'سَعَةٌ دَارٌ':Added, #1: 1	سَعَةِ الْخُفِّ
u'سَعَةٌ رحمة':Added, #1: 1	سَعَةُ الدَّارِ
u'سَعَةٌ رَحْمَةٌ':Added, #1: 1	سَعَةِ الرَّحْمَةِ
u'سَعَةٌ رحمة':Added, #1: 1	سَعَةِ الرَّحْمَةِ
u'سَعَةٌ رَحْمَةٌ':Added, #1: 1	سَعَةِ رَحْمَةِ
u'سَعَةٌ سَفْحٌ':Added, #1: 1	سَعَةِ رَحْمَةِ
u'سَعَةٌ سَيِّدٌ':Added, #1: 1	سَعَةِ سَفْحِ
u'سَعَةٌ صَدْرٌ':Added, #1: 1	سَعَةِ السَّيِّدِ
u'سَعَةٌ طَرِيقٌ':Added, #1: 1	سَعَةِ الصَّدْرِ
u'سَعَةٌ طَرِيقٌ':Added, #1: 1	سَعَةُ الطَّرِيقِ
u'سَعَةٌ طَرِيقٌ':Added, #2: 2	سَعَةَ الطَّرِيقِ
u'سَعَةٌ علم':Added, #4: 4	سَعَةِ الطَّرِيقِ
u'سَعَةٌ عِلْمٌ':Added, #2: 2	سَعَةِ الْعِلْمِ
u'سَعَةٌ قدرة':Added, #2: 2	سَعَةِ الْعِلْمِ
u'سَعَةٌ قُدْرَةٌ':Added, #2: 2	سَعَةِ الْقُدْرَةِ
u'سَعَةٌ كِتْمَانٌ':Added, #2: 2	سَعَةِ الْقُدْرَةِ
u'سَعَةٌ كَرْمٌ':Added, #1: 1	سَعَةِ الْكِتْمَانِ
u'سَعَةٌ كَلاَمٌ':Added, #1: 1	سَعَةِ كَرْمِهِ
u'سَعَةٌ كُمٌّ':Added, #2: 2	سَعَةِ الْكَلَامِ
u'سَعَةٌ كُوَّةٌ':Added, #1: 1	سَعَةُ كُمِّ
u'سَعَةٌ مَسْجِدٌ':Added, #1: 1	سَعَةِ الْكُوَّةِ
u'سَعَةٌ مَنْزِلٌ':Added, #1: 1	سَعَةِ الْمَسْجِدِ
u'سَعَةٌ وَقْتٌ':Added, #1: 1	سَعَةُ الْمَنْزِلِ
u'سَعَةٌ وَقْتٌ':Added, #13: 13	سَعَةِ الْوَقْتِ
u'سَعْدٌ بِنْتٌ':Added, #2: 2	سَعَةُ الْوَقْتِ
u'سَعْدٌ خَيْرٌ':Added, #2: 2	سَعْدِ بِنْتِ
u'سَعْدٌ دِينٌ':Added, #1: 1	سَعْدِ الْخَيْرِ
u'سَعْدٌ دِينٌ':Added, #17: 17	سَعْدُ الدِّينِ
u'سَعْدٌ رَجَبٌ':Added, #1: 1	سَعْدِ الدِّينِ
u'سَعْدٌ سَوِيٌّ':Added, #1: 1	سَعْدُ رَجَبٍ
u'سَعْدٌ عَشِيرٌ':Added, #1: 1	سَعْدٍ سَوِيٍّ
u'سَعْدٌ عَشِيرٌ':Added, #15: 15	سَعْدِ الْعَشِيرَةِ
u'سَعْدٌ عَشِيرَةٌ':Added, #1: 1	سَعْدَ الْعَشِيرَةِ
u'سَعْدٌ عَشِيرَةٌ':Added, #15: 15	سَعْدِ الْعَشِيرَةِ
u'سَعْدٌ فلان':Added, #1: 1	سَعْدَ الْعَشِيرَةِ
u'سَعْدٌ فَلْج':Added, #1: 1	سَعْدِ تَمِيمٍ
u'سَعَدَ مَذْكُورٌ':Predicate, #2: 2	سَعْدِ الْفَلْجَةِ
u'سَعِدَ مَذْكُورٌ':Predicate, #1: 1	أَسْعَدَ الْمَذْكُورَ
u'سَعْدٌ نَاشِرٌ':Added, #1: 1	أَسْعَدَ الْمَذْكُورَ
u'سَعَّرَ إمَامٌ':Subject, #1: 1	سَعْدُ نَاشِرَةٍ
u'سَعَّرَ جَازٌ':Predicate, #3: 3	سَعَّرَ الْإِمَامُ
u'سَعَفٌ صُورٌ':Added, #1: 1	سَعَّرَ جَازَ
u'سَعَف صُورٌ':Added, #1: 1	سَعَفِ الصُّورِ
u'سَعَفٌ صُوَرٌ':Added, #1: 1	سَعَفِ الصُّورِ
u'سَعَف صُوَرٌ':Added, #1: 1	سَعَفِ الصُّورِ
u'سَعَفٌ طَرْفَاءُ':Added, #1: 1	سَعَفِ الصُّورِ
u'سَعَف طَرْفَاءُ':Added, #1: 1	سَعَفِ الطَّرْفَاءِ
u'سَعَفٌ نَخْلٌ':Added, #1: 1	سَعَفِ الطَّرْفَاءِ
u'سَعَف نَخْلٌ':Added, #1: 1	سَعَفِ النّخْلِ
u'سَعَفٌ نَخْلٌ':Added, #1: 1	سَعَفِ النّخْلِ
u'سَعَف نَخْلٌ':Added, #1: 1	سَعَفِ نَخْلٍ
u'سَعَفٌ نَخْلٌ':Added, #1: 1	سَعَفِ نَخْلٍ
u'سَعَف نَخْلٌ':Added, #2: 2	سَعَفِ النَّخْلِ
u'سَعَى أَرْبَعَةٌ':Predicate, #2: 2	سَعَفِ النَّخْلِ
u'سَعَى أكْبَرُ':Subject, #1: 1	سَعَى أَرْبَعَةَ
u'سَعَى أَوْلاَدٌ':Subject, #1: 1	سَعَى الْأَكْبَرُ
u'سَعَى بَعْضٌ':Predicate, #2: 2	سَعَى الْأَوْلَادُ
u'سَعَى بَعْضٌ':Subject, #1: 1	سَعَى بَعْضَ
u'سَعَى بَيْنٌ':Predicate, #1: 1	سَعَى بَعْضُ
u'سَعَى ثَالِثٌ':Subject, #13: 13	سَعَى بَيْنَ
u'سَعَى ثَلاثَةٌ':Predicate, #1: 1	سَعَى الثَّالِثُ
u'سَعَى حَيٌّ':Subject, #1: 1	سَعَى ثَلاَثَةَ
u'سَعَى رَجُلٌ':Subject, #1: 1	سَعَى الْحَيُّ
u'سَعَى رَسُولٌ':Subject, #1: 1	سَعَى رَجُلٌ
u'سَعَى شَخْصٌ':Subject, #4: 4	سَعَى رَسُولُ
u'سَعَى عَبْدٌ':Subject, #1: 1	سَعَى شَخْصٌ
u'سَعَى عَقِبٌ':Predicate, #20: 20	سَعَى الْعَبْدُ
u'سَعَى عَقِيبٌ':Predicate, #1: 1	سَعَى عَقِبَ
u'سَعَى مُتَمَتِّعٌ':Subject, #1: 1	سَعَى عَقِيبَ
u'سَعَى مُدَبَّرٌ':Subject, #1: 1	سَعَى الْمُتَمَتِّعُ
u'سَعَى مرٌّ':Predicate, #1: 1	سَعَى الْمُدَبَّرُ
u'سَعَى مُعْتَقٌ':Subject, #1: 1	سَعَى مَرَّةً
u'سَعَى نَاسٌ':Subject, #2: 2	سَعَى الْمُعْتَقُ
u'سَعَى نَبِيٌّ':Subject, #2: 2	سَعَى النَّاسُ
u'سَعَى ولد':Subject, #1: 1	سَعَى النَّبِيُّ
u'سَعَى وَلَدٌ':Subject, #14: 14	سَعَى الْوَلَدُ
u'سَعَى ولد':Subject, #14: 14	سَعَى الْوَلَدُ
u'سَعَى وَلَدٌ':Subject, #1: 1	سَعَى وَلَدُهُ
u'سَعَى ولد':Subject, #1: 1	سَعَى وَلَدُهُ
u'سَعَى وَلَدٌ':Subject, #2: 2	سَعَى وَلَدُ
u'سَعَى يَوْمٌ':Predicate, #2: 2	سَعَى وَلَدُ
u'سَفَاهَةٌ رَأْيٌ':Added, #3: 3	سَعَى يَوْمَ
u'سَفَاهَةٌ عَقْلٌ':Added, #3: 3	سَفَاهَةِ رَأْيِهِ
u'سفاه رَأْيٌ':Added, #1: 1	سَفَاهَةِ الْعَقْلِ
u'سَفَاهٌ رَأْيٌ':Added, #1: 1	سَفَاهُ رَأْيٍ
u'سَفْحٌ جَبَلٌ':Added, #1: 1	سَفَاهُ رَأْيٍ
u'سَفْحٌ جَبَلٌ':Added, #1: 1	سَفْحِ جَبَلِ
u'سَفْحٌ دَمٌ':Added, #4: 4	سَفْحِ الْجَبَلِ
u'سَفْحٌ مَاءٌ':Added, #1: 1	سَفْحُ دَمِهِ
u'سَفْحٌ مَاءٌ':Added, #1: 1	سَفْحَ الْمَاءِ
u'سَفْكٌ دَمٌ':Added, #7: 7	سَفْحِ الْمَاءِ
u'سَفْكٌ دَمٌ':Added, #1: 1	سَفْكَ الدَّمِ
u'سَفْكٌ دَمٌ':Added, #1: 1	سَفْكُ الدَّمِ
u'سَفْكٌ دَمٌ':Added, #1: 1	سَفْكَ دَمِ
u'سَفْكٌ دَمٌ':Added, #1: 1	سَفْكِ دَمِهِ
u'سَفْكٌ دَمٌ':Added, #2: 2	سَفْكَ دَمٍ
u'سَفْكٌ دَمٌ':Added, #2: 2	سَفْكِ دَمِ
u'سَفْكٌ دِماءٌ':Added, #4: 4	سَفْكُ دَمٍ
u'سَفْكٌ دِماءٌ':Added, #1: 1	سَفْكَ الدِّمَاءِ
u'سَفْكٌ دِماءٌ':Added, #1: 1	سَفْكِ الدِّمَاءِ
u'سَفَكَ مُحَمَّدٌ':Subject, #1: 1	سَفْكِ دِمَاءِ
u'سَفُلَ بَطَلٌ':Predicate, #1: 1	سَفَكَ مُحَمَّدٌ
u'سَفَلَ حَرامٌ':Subject, #1: 1	سَفُلَ بَطَلَ
u'سَفَلَ حُكْمٌ':Subject, #1: 1	سَفَلَ حَرَامٌ
u'سَفَلَ رُبُعٌ':Subject, #1: 1	سَفَلَ حُكْمُهُ
u'سَفَلَ فَرْعٌ':Subject, #1: 1	سَفَلَ الرُّبُعُ
u'سَفَلَ قَالٌ':Predicate, #1: 1	سَفَلَ الْفَرْعُ
u'سَفَهٌ الْمَرْأَةُ':Added, #2: 2	سَفَلَ قَالَ
u'سَفِهَ حَقٌّ':Predicate, #1: 1	سَفَهُ الْمَرْأَةِ
u'سَفَّهَ حَقٌّ':Predicate, #1: 1	سَفِهَ الْحَقَّ
u'سَفَهٌ دِينٌ':Added, #2: 2	سَفَّهَ الْحَقَّ
u'سَفَهٌ رَشيدٌ':Added, #2: 2	سَفَهِ الدِّينِ
u'سَفَهٌ طعام':Added, #1: 1	سَفَهُ رَشِيدٍ
u'سَفَهٌ طَعَامٌ':Added, #1: 1	سَفَهُ الطَّعَامِ
u'سَفَهٌ مَالٌ':Added, #1: 1	سَفَهُ الطَّعَامِ
u'سَفَهٌ مُقَارِنٌ':Added, #1: 1	سَفَهُ الْمَالِ
u'سَفَهٌ نَادِرَةٌ':Added, #1: 1	سَفَهٍ مُقَارِنٍ
u'سَفِهَ نَاسٌ':Predicate, #1: 1	سَفَهٍ نَادِرَةٍ
u'سَفَهٌ وَلِيٌّ':Added, #1: 1	سَفِهَ النَّاسَ
u'سُفُوحٌ دَمٌ':Added, #2: 2	سَفَهَ الْوَلِيِّ
u'سَقَرَ تَرْكٌ':Predicate, #1: 1	سُفُوحِ الدَّمِ
u'سُقِطَ أثَرٌ':Predicate, #1: 1	سَقَرَ تَرْكَ
u'سَقَطَ أثَرٌ':Subject, #1: 1	أَسْقَطَ أَثَرَ
u'سَقَطَ أثَرٌ':Subject, #1: 1	سَقَطَ أَثَرُ
u'سُقِطَ إِثْمٌ':Predicate, #1: 1	سَقَطَ أَثَرُهُ
u'سَقَطَ إِثْمٌ':Subject, #1: 1	أَسْقَطَ الْإِثْمَ
u'سُقِطَ أَجْرٌ':Predicate, #2: 2	سَقَطَ الْإِثْمُ
u'سَقَطَ أَجْرٌ':Subject, #1: 1	أَسْقَطَ الْأَجْرَ
u'سُقِطَ أَجَلٌ':Predicate, #14: 14	سَقَطَ الْأَجْرُ
u'سَقَطَ أَجَلٌ':Subject, #11: 11	أَسْقَطَ الْأَجَلَ
u'سَقَطَ اِحْتِرَامٌ':Subject, #2: 2	سَقَطَ الْأَجَلُ
u'سَقَطَ اِخْتِيَارٌ':Subject, #1: 1	سَقَطَ احْتِرَامُهُ
u'سَقَطَ اِخْتِيَارٌ':Subject, #1: 1	سَقَطَ اخْتِيَارُ
u'سَقَطَ أَخَوَاتٌ':Subject, #2: 2	سَقَطَ اخْتِيَارُهُ
u'سَقَطَ إِخْوَةٌ':Subject, #1: 1	سَقَطَ الْأَخَوَاتُ
u'سَقَطَ أدَب':Subject, #1: 1	سَقَطَ الْإِخْوَةُ
u'سَقَطَ إِذْنٌ':Subject, #1: 1	سَقَطَ الْأَدَبُ
u'سَقَطَ اِسْتِحْقَاقٌ':Subject, #1: 1	سَقَطَ إذْنُهُ
u'سَقَطَ اِسْتِحْقَاقٌ':Subject, #1: 1	سَقَطَ اسْتِحْقَاقُ
u'سَقَطَ اِسْتِمْتاعٌ':Subject, #4: 4	سَقَطَ اسْتِحْقَاقُهُ
u'سَقَطَ أَسْفَلُ':Subject, #1: 1	سَقَطَ اسْتِمْتَاعُهُ
u'سَقَطَ إِسْنادٌ':Subject, #1: 1	سَقَطَ الْأَسْفَلُ
u'سَقَطَ أسْنَانٌ':Subject, #1: 1	سَقَطَ إِسْنَادُ
u'سَقَطَ اِشْتِراطٌ':Subject, #1: 1	سَقَطَ أَسْنَانُهُ
u'سَقَطَ إِشْكالٌ':Subject, #2: 2	سَقَطَ اشْتِرَاطُ
u'سَقَطَ أُصْبُعٌ':Subject, #1: 1	سَقَطَ إشْكَالُ
u'سُقِطَ أصل':Predicate, #2: 2	سَقَطَ أُصْبُعٌ
u'سُقِطَ أًصْلٌ':Predicate, #1: 1	أَسْقَطَ أَصْلَ
u'سَقَطَ أصل':Subject, #1: 1	أَسْقَطَ أَصْلَ
u'سَقَطَ أًصْلٌ':Subject, #4: 4	سَقَطَ الْأَصْلُ
u'سَقَطَ أَصيلٌ':Subject, #4: 4	سَقَطَ الْأَصْلُ
u'سَقَطَ إِطْلاقٌ':Subject, #1: 1	سَقَطَ الْأَصِيلُ
u'سُقِطَ اِعْتِبارٌ':Predicate, #3: 3	سَقَطَ الْإِطْلَاقُ
u'سَقَطَ اِعْتِبارٌ':Subject, #4: 4	أَسْقَطَ اعْتِبَارَ
u'سَقَطَ اِعْتِبارٌ':Subject, #35: 35	سَقَطَ اعْتِبَارُ
u'سَقَطَ اِعْتِراضٌ':Subject, #7: 7	سَقَطَ اعْتِبَارُهُ
u'سَقَطَ إقْرَارٌ':Subject, #3: 3	سَقَطَ اعْتِرَاضُ
u'سَقَطَ أقَلُّ':Subject, #4: 4	سَقَطَ إقْرَارُهُ
u'سَقَطَ أَكْثَرُ':Subject, #1: 1	سَقَطَ الْأَقَلُّ
u'سُقِطَ أُمٌّ':Predicate, #2: 2	سَقَطَ أَكْثَرُ
u'سَقَطَ أَمْرٌ':Subject, #1: 1	أَسْقَطَ أُمَّ
u'سَقَطَ أَمْرٌ':Subject, #1: 1	سَقَطَ الْأَمْرُ
u'سَقَطَ إِنْسانٌ':Subject, #1: 1	سَقَطَ أَمْرٌ
u'سَقَطَ إِنْكارٌ':Subject, #2: 2	سَقَطَ إنْسَانٌ
u'سُقِطَ أَوَّلُ':Predicate, #1: 1	سَقَطَ الْإِنْكَارُ
u'سَقَطَ أَوَّلُ':Subject, #2: 2	أَسْقَطَ الْأَوَّلَ
u'سَقَطَ أَوَّلُ':Subject, #1: 1	سَقَطَ أَوَّلُهُ
u'سَقَطَ إِيجَابٌ':Subject, #2: 2	سَقَطَ الْأَوَّلُ
u'سَقَطَ بَدَلٌ':Predicate, #1: 1	سَقَطَ إيجَابُ
u'سُقِطَ بَعْضٌ':Predicate, #1: 1	سَقَطَ بَدَلَ
u'سَقَطَ بَعْضٌ':Subject, #5: 5	أَسْقَطَ بَعْضَ
u'سَقَطَ بَعْضٌ':Subject, #6: 6	سَقَطَ بَعْضُ
u'سَقَطَ بَعيرٌ':Subject, #6: 6	سَقَطَ بَعْضُهُ
u'سَقَطَ بَيَانٌ':Subject, #1: 1	سَقَطَ الْبَعِيرُ
u'سَقَطَ بَيْتٌ':Subject, #1: 1	سَقَطَ بَيَانُ
u'سَقَطَ بَيْنٌ':Predicate, #1: 1	سَقَطَ بَيْتٌ
u'سَقَطَ تَابِعٌ':Subject, #3: 3	سَقَطَ بَيْنَ
u'سَقَطَ تَأْبِيدٌ':Subject, #1: 1	سَقَطَ التَّابِعُ
u'سَقَطَ تَبَرُّعٌ':Subject, #1: 1	سَقَطَ التَّأْبِيدُ
u'سَقَطَ تَبَع':Subject, #1: 1	سَقَطَ تَبَرُّعُهُ
u'سَقَطَ تَحَالُفٌ':Subject, #1: 1	سَقَطَ التَّبَعُ
u'سَقَطَ تَحْرِيمٌ':Subject, #1: 1	سَقَطَ التَّحَالُفُ
u'سُقِطَ تَحِيَّةٌ':Predicate, #1: 1	سَقَطَ تَحْرِيمُهُ
u'سَقَطَ تُرَابٌ':Subject, #1: 1	أَسْقَطَ تَحِيَّةَ
u'سَقَطَ تَرْتِيبٌ':Subject, #1: 1	سَقَطَ التُّرَابُ
u'سَقَطَ تُسْعٌ':Subject, #16: 16	سَقَطَ التَّرْتِيبُ
u'سُقِطَ تَصَدُّقٌ':Predicate, #1: 1	سَقَطَ تُسْعُ
u'سَقَطَ تَعْزِير':Subject, #1: 1	أَسْقَطَ التَّصَدُّقَ
u'سَقَطَ تَعْزِير':Subject, #1: 1	سَقَطَ التَّعْزِيرُ
u'سَقَطَ تَعْيِينٌ':Subject, #1: 1	سَقَطَ تَعْزِيرُ
u'سَقَطَ تَفاوُت':Subject, #1: 1	سَقَطَ التَّعْيِينُ
u'سَقَطَ تَقْديمٌ':Subject, #1: 1	سَقَطَ التَّفَاوُتُ
u'سُقِطَ تَقَوُّمٌ':Predicate, #1: 1	سَقَطَ التَّقْدِيمُ
u'سَقَطَ تَقْيِيد':Subject, #2: 2	أَسْقَطَ تَقَوُّمَ
u'سَقَطَ تَكَلُّفٌ':Subject, #1: 1	سَقَطَ التَّقْيِيدُ
u'سَقَطَ تَكْليفٌ':Subject, #1: 1	سَقَطَ التَّكَلُّفُ
u'سَقَطَ تَكْليفٌ':Subject, #1: 1	سَقَطَ التَّكْلِيفُ
u'سَقَطَ تَمْلِيك':Subject, #1: 1	سَقَطَ تَكْلِيفُهُ
u'سَقَطَ تَمْييزٌ':Subject, #1: 1	سَقَطَ التَّمْلِيكُ
u'سَقَطَ تَنجُّسٌ':Subject, #2: 2	سَقَطَ تَمْيِيزُهُ
u'سَقَطَ تَوابِعُ':Subject, #1: 1	سَقَطَ التَّنَجُّسُ
u'سَقَطَ تَوَابِعُ':Subject, #1: 1	سَقَطَ تَوَابِعُ
u'سَقَطَ تَوْقِيت':Subject, #1: 1	سَقَطَ تَوَابِعُ
u'سَقَطَ تَوَهُّمٌ':Subject, #3: 3	سَقَطَ التَّوْقِيتُ
u'سَقَطَ ثَالِثٌ':Subject, #1: 1	سَقَطَ تَوَهُّمُ
u'سُقِطَ ثَمَنٌ':Predicate, #1: 1	سَقَطَ ثَالِثٌ
u'سَقَطَ ثَمَنٌ':Subject, #1: 1	أَسْقَطَ الثَّمَنَ
u'سَقَطَ ثَوْبٌ':Subject, #12: 12	سَقَطَ الثَّمَنُ
u'سَقَطَ جِدار':Subject, #1: 1	سَقَطَ ثَوْبٌ
u'سَقَطَ جِدار':Subject, #1: 1	سَقَطَ جِدَارٌ
u'سَقَطَ جِدار':Subject, #1: 1	سَقَطَ جِدَارُهُ
u'سَقَطَ جِذْعٌ':Subject, #5: 5	سَقَطَ الْجِدَارُ
u'سُقِطَ جَزَاءٌ':Predicate, #2: 2	سَقَطَ الْجِذْعُ
u'سَقَطَ جَزَاءٌ':Subject, #1: 1	أَسْقَطَ الْجَزَاءَ
u'سُقِطَ جِزْيَةٌ':Predicate, #2: 2	سَقَطَ الْجَزَاءُ
u'سَقَطَ جلد':Subject, #1: 1	أَسْقَطَ الْجِزْيَةَ
u'سَقَطَ جِلْدٌ':Subject, #2: 2	سَقَطَ جِلْدُهُ
u'سُقِطَ جَمَاعَةٌ':Predicate, #2: 2	سَقَطَ جِلْدُهُ
u'سُقِطَ جمعة':Predicate, #1: 1	أَسْقَطَ الْجَمَاعَةَ
u'سُقِطَ جُمُعَةٌ':Predicate, #1: 1	أَسْقَطَ الْجُمُعَةَ
u'سَقَطَ جَمَلٌ':Subject, #1: 1	أَسْقَطَ الْجُمُعَةَ
u'سَقَطَ جَمِيع':Subject, #1: 1	سَقَطَ الْجَمَلُ
u'سَقَطَ جناح':Subject, #2: 2	سَقَطَ الْجَمِيعُ
u'سَقَطَ جَنَاحٌ':Subject, #1: 1	سَقَطَ الْجَنَاحُ
u'سَقَطَ جناح':Subject, #1: 1	سَقَطَ الْجَنَاحُ
u'سَقَطَ جَنَاحٌ':Subject, #1: 1	سَقَطَ جَنَاحُهُ
u'سُقِطَ جِنَايَةٌ':Predicate, #1: 1	سَقَطَ جَنَاحُهُ
u'سَقَطَ جَنِينٌ':Subject, #1: 1	أَسْقَطَ الْجِنَايَةَ
u'سَقَطَ جَوَازٌ':Subject, #3: 3	سَقَطَ الْجَنِينُ
u'سُقِطَ جَوْدَةٌ':Predicate, #1: 1	سَقَطَ الْجَوَازُ
u'سَقَطَ حاجِبٌ':Subject, #1: 1	أَسْقَطَ الْجَوْدَةَ
u'سَقَطَ حالَةٌ':Predicate, #1: 1	سَقَطَ حَاجِبَاهُ
u'سَقَطَ حائِطٌ':Subject, #1: 1	سَقَطَ حَالَةَ
u'سَقَطَ حائِطٌ':Subject, #1: 1	سَقَطَ حَائِطُ
u'سَقَطَ حائِطٌ':Subject, #1: 1	سَقَطَ حَائِطُهُ
u'سَقَطَ حائِطٌ':Subject, #31: 31	سَقَطَ الْحَائِطُ
u'سَقَطَ حَبٌّ':Subject, #5: 5	سَقَطَ حَائِطٌ
u'سَقَطَ حَبْسٌ':Subject, #1: 1	سَقَطَ الْحَبُّ
u'سَقَطَ حَجٌّ':Subject, #3: 3	سَقَطَ الْحَبْسُ
u'سَقَطَ حَجَرٌ':Subject, #3: 3	سَقَطَ الْحَجُّ
u'سُقِطَ حَدٌّ':Predicate, #1: 1	سَقَطَ الْحَجَرُ
u'سَقَطَ حَدٌّ':Subject, #1: 1	أَسْقَطَ الْحَدَّ
u'سَقَطَ حَدٌّ':Subject, #1: 1	سَقَطَ حَدٌّ
u'سَقَطَ حَدٌّ':Subject, #5: 5	سَقَطَ حَدُّ
u'سَقَطَ حَديثٌ':Subject, #80: 80	سَقَطَ الْحَدُّ
u'سُقِطَ حَرَجٌ':Predicate, #1: 1	سَقَطَ حَدِيثٌ
u'سَقَطَ حَرَجٌ':Subject, #4: 4	أَسْقَطَ الْحَرَجَ
u'سَقَطَ حَرَجٌ':Subject, #1: 1	سَقَطَ حَرَجُ
u'سُقِطَ حُرْمَةٌ':Predicate, #7: 7	سَقَطَ الْحَرَجُ
u'سَقَطَ حِصَّةٌ':Subject, #1: 1	أَسْقَطَ حُرْمَةَ
u'سَقَطَ حُضورٌ':Subject, #10: 10	سَقَطَ حِصَّتُهُ
u'سَقَطَ حُضُورٌ':Subject, #2: 2	سَقَطَ الْحُضُورُ
u'سَقَطَ حَظٌّ':Subject, #2: 2	سَقَطَ الْحُضُورُ
u'سَقَطَ حَظٌّ':Subject, #1: 1	سَقَطَ حَظُّ
u'سُقِطَ حَقٌّ':Predicate, #2: 2	سَقَطَ حَظُّهُ
u'سَقَطَ حَقٌّ':Subject, #5: 5	أَسْقَطَ حَقَّ
u'سَقَطَ حَقٌّ':Subject, #3: 3	سَقَطَ الْحَقُّ
u'سَقَطَ حَقٌّ':Subject, #48: 48	سَقَطَ حَقُّ
u'سُقِطَ حِكَايَةٌ':Predicate, #52: 52	سَقَطَ حَقُّهُ
u'سُقِطَ حُكْمٌ':Predicate, #1: 1	أَسْقَطَ حِكَايَةَ
u'سَقَطَ حُكْمٌ':Subject, #2: 2	أَسْقَطَ حُكْمَ
u'سَقَطَ حُكْمٌ':Subject, #14: 14	سَقَطَ حُكْمُ
u'سَقَطَ حُكْمٌ':Subject, #1: 1	سَقَطَ الْحُكْمُ
u'سَقَطَ حِمَارٌ':Subject, #7: 7	سَقَطَ حُكْمُهُ
u'سَقَطَ حِمْلٌ':Subject, #1: 1	سَقَطَ حِمَارُهُ
u'سَقَطَ حُمُولَةٌ':Subject, #1: 1	سَقَطَ حِمْلٌ
u'سَقَطَ حَيَوَانٌ':Subject, #1: 1	سَقَطَ حُمُولَتُهُ
u'سُقِطَ خَالِصٌ':Predicate, #1: 1	سَقَطَ حَيَوَانُ
u'سَقَطَ خراج':Subject, #1: 1	أَسْقَطَ خَالِصَ
u'سَقَطَ خَرَاجٌ':Subject, #1: 1	سَقَطَ خَرَاجُ
u'سَقَطَ خراج':Subject, #1: 1	سَقَطَ خَرَاجُ
u'سَقَطَ خَرَاجٌ':Subject, #5: 5	سَقَطَ الْخَرَاجُ
u'سُقِطَ خُصُومَةٌ':Predicate, #5: 5	سَقَطَ الْخَرَاجُ
u'سَقَطَ خِطَامٌ':Subject, #1: 1	أَسْقَطَ الْخُصُومَةَ
u'سَقَطَ خَمْرٌ':Subject, #1: 1	سَقَطَ الْخِطَامُ
u'سَقَطَ خُمُسٌ':Subject, #4: 4	سَقَطَ الْخَمْرُ
u'سَقَطَ خَمْسَةٌ':Subject, #1: 1	سَقَطَ الْخُمُسُ
u'سُقِطَ خيار':Predicate, #1: 1	سَقَطَ خَمْسَةٌ
u'سُقِطَ خِيَارٌ':Predicate, #10: 10	أَسْقَطَ الْخِيَارَ
u'سُقِطَ خيار':Predicate, #10: 10	أَسْقَطَ الْخِيَارَ
u'سُقِطَ خِيَارٌ':Predicate, #4: 4	أَسْقَطَ خِيَارَ
u'سَقَطَ خيار':Subject, #4: 4	أَسْقَطَ خِيَارَ
u'سَقَطَ خِيَارٌ':Subject, #21: 21	سَقَطَ الْخِيَارُ
u'سَقَطَ خيار':Subject, #21: 21	سَقَطَ الْخِيَارُ
u'سَقَطَ خِيَارٌ':Subject, #38: 38	سَقَطَ خِيَارُهُ
u'سَقَطَ خيار':Subject, #38: 38	سَقَطَ خِيَارُهُ
u'سَقَطَ خِيَارٌ':Subject, #6: 6	سَقَطَ خِيَارُ
u'سَقَطَ خِيرَةٌ':Subject, #6: 6	سَقَطَ خِيَارُ
u'سَقَطَ دَاخِلٌ':Subject, #1: 1	سَقَطَ خِيرَةُ
u'سُقِطَ دِرْهَمٌ':Predicate, #1: 1	سَقَطَ الدَّاخِلُ
u'سُقِطَ دِرْهَم':Predicate, #1: 1	أَسْقَطَ الدِّرْهَمَ
u'سَقَطَ دَلالَةٌ':Subject, #1: 1	أَسْقَطَ الدِّرْهَمَ
u'سَقَطَ دَمٌ':Subject, #1: 1	سَقَطَ دَلَالَةُ
u'سَقَطَ دَمٌ':Subject, #3: 3	سَقَطَ دَمُ
u'سَقَطَ دَواءٌ':Subject, #5: 5	سَقَطَ الدَّمُ
u'سَقَطَ دُودٌ':Subject, #1: 1	سَقَطَ الدَّوَاءُ
u'سُقِطَ دَيْنٌ':Predicate, #1: 1	سَقَطَ الدُّودُ
u'سَقَطَ دَيْنٌ':Subject, #3: 3	أَسْقَطَ الدَّيْنَ
u'سَقَطَ دَيْنٌ':Subject, #39: 39	سَقَطَ الدَّيْنُ
u'سَقَطَ دَيْنٌ':Subject, #6: 6	سَقَطَ دَيْنُ
u'سَقَطَ دِينارٌ':Subject, #6: 6	سَقَطَ دَيْنُهُ
u'سَقَطَ ذُبابٌ':Subject, #1: 1	سَقَطَ دِينَارٌ
u'سَقَطَ ذُبابٌ':Subject, #1: 1	سَقَطَ الذُّبَابُ
u'سُقِطَ ذكر':Predicate, #1: 1	سَقَطَ ذُبَابٌ
u'سُقِطَ ذِكْرٌ':Predicate, #1: 1	أَسْقَطَ ذِكْرَ
u'سَقَطَ ذكر':Subject, #1: 1	أَسْقَطَ ذِكْرَ
u'سَقَطَ ذِكْرٌ':Subject, #1: 1	سَقَطَ ذِكْرُ
u'سَقَطَ ذكر':Subject, #1: 1	سَقَطَ ذِكْرُ
u'سَقَطَ ذكر':Subject, #1: 1	سَقَطَ ذَكَرُهُ
u'سَقَطَ ذَكَرٌ':Subject, #1: 1	سَقَطَ ذِكْرُهُ
u'سَقَطَ ذِكْرٌ':Subject, #1: 1	سَقَطَ ذَكَرُهُ
u'سَقَطَ ذُكورَةٌ':Subject, #1: 1	سَقَطَ ذِكْرُهُ
u'سُقِطَ رابع':Predicate, #1: 1	سَقَطَ الذُّكُورَةُ
u'سُقِطَ رَابِعٌ':Predicate, #1: 1	أَسْقَطَ الرَّابِعَ
u'سَقَطَ رُبُعٌ':Subject, #1: 1	أَسْقَطَ الرَّابِعَ
u'سَقَطَ رُبْعٌ':Subject, #1: 1	سَقَطَ رُبُعُ
u'سَقَطَ رَجُلٌ':Subject, #2: 2	سَقَطَ رُبْعُ
u'سَقَطَ رِجْلٌ':Subject, #1: 1	سَقَطَ الرَّجُلُ
u'سَقَطَ رُجُوعٌ':Subject, #1: 1	سَقَطَ رِجْلَاهُ
u'سَقَطَ رَدٌّ':Subject, #9: 9	سَقَطَ الرُّجُوعُ
u'سَقَطَ رَدٌّ':Subject, #1: 1	سَقَطَ رَدُّهُ
u'سَقَطَ رِدَاءٌ':Subject, #7: 7	سَقَطَ الرَّدُّ
u'سَقَطَ رِدَاءٌ':Subject, #1: 1	سَقَطَ الرّدَاءُ
u'سَقَطَ رَسُولٌ':Subject, #1: 1	سَقَطَ الرِّدَاءُ
u'سُقِطَ رِطْلٌ':Predicate, #3: 3	سَقَطَ رَسُولُ
u'سَقَطَ رَمْيٌ':Subject, #1: 1	أَسْقَطَ الرِّطْلَ
u'سُقِطَ رَهْنٌ':Predicate, #1: 1	سَقَطَ الرَّمْيُ
u'سَقَطَ رَهْنٌ':Subject, #1: 1	أَسْقَطَ الرَّهْنَ
u'سَقَطَ زائِدٌ':Subject, #1: 1	سَقَطَ الرَّهْنُ
u'سُقِطَ زَكاةٌ':Predicate, #1: 1	سَقَطَ الزَّائِدُ
u'سَقَطَ زَكاةٌ':Subject, #1: 1	أَسْقَطَ الزَّكَاةَ
u'سَقَطَ زَكاةٌ':Subject, #2: 2	سَقَطَ زَكَاتُهُ
u'سَقَطَ ساباط':Subject, #3: 3	سَقَطَ زَكَاةُ
u'سَقَطَ سَاتِرٌ':Subject, #1: 1	سَقَطَ السَّابَاطُ
u'سَقَطَ سَاقِطٌ':Subject, #3: 3	سَقَطَ سَاتِرُ
u'سَقَطَ سُجُودٌ':Subject, #1: 1	سَقَطَ السَّاقِطُ
u'سَقَطَ سُجُودٌ':Subject, #1: 1	سَقَطَ سُجُودُ
u'سَقَطَ سَرْجٌ':Subject, #2: 2	سَقَطَ السُّجُودُ
u'سَقَطَ سُفْلٌ':Subject, #1: 1	سَقَطَ سَرْجُ
u'سَقَطَ سقط':Predicate, #2: 2	سَقَطَ السُّفْلُ
u'سَقَطَ سَقَطٌ':Predicate, #5: 5	سَقَطَ سَقَطَ
u'سَقَطَ سُقُوطٌ':Predicate, #5: 5	سَقَطَ سَقَطَ
u'سَقَطَ سِلاَحٌ':Subject, #1: 1	سَقَطَ سُقُوطَ
u'سَقَطَ سَمَاءٌ':Subject, #1: 1	سَقَطَ السِّلَاحُ
u'سَقَطَ سِنٌّ':Subject, #2: 2	سَقَطَ السّمَاءُ
u'سَقَطَ سِنٌّ':Subject, #1: 1	سَقَطَ سِنٌّ
u'سَقَطَ سَهْمٌ':Subject, #1: 1	سَقَطَ سِنُّهُ
u'سَقَطَ سَهْمٌ':Subject, #1: 1	سَقَطَ السَّهْمُ
u'سَقَطَ سَهْمٌ':Subject, #3: 3	سَقَطَ سَهْمُهُ
u'سَقَطَ سُؤَالٌ':Subject, #5: 5	سَقَطَ سَهْمُ
u'سَقَطَ سَوْطٌ':Subject, #1: 1	سَقَطَ السُّؤَالُ
u'سَقَطَ سَيْفٌ':Subject, #1: 1	سَقَطَ سَوْطُ
u'سَقَطَ شَرْطٌ':Subject, #1: 1	سَقَطَ سَيْفٌ
u'سَقَطَ شَرْطٌ':Subject, #1: 1	سَقَطَ شَرْطٌ
u'سَقَطَ شَعْرٌ':Subject, #1: 1	سَقَطَ شَرْطُ
u'سُقِطَ شفعة':Predicate, #2: 2	سَقَطَ شَعْرُهُ
u'سُقِطَ شُفْعَةٌ':Predicate, #1: 1	أَسْقَطَ الشُّفْعَةَ
u'سَقَطَ شَوْطٌ':Subject, #1: 1	أَسْقَطَ الشُّفْعَةَ
u'سَقَطَ شَيْءٌ':Subject, #1: 1	سَقَطَ الشَّوْطُ
u'سَقَطَ صَدْرٌ':Subject, #3: 3	سَقَطَ شَيْءٌ
u'سَقَطَ صَفِيٌّ':Subject, #3: 3	سَقَطَ صَدْرُهُ
u'سَقَطَ صلْبٌ':Subject, #4: 4	سَقَطَ الصَّفِيُّ
u'سَقَطَ صَلْبٌ':Subject, #1: 1	سَقَطَ الصَّلْبُ
u'سَقَطَ ضَرُورَةٌ':Predicate, #1: 1	سَقَطَ الصَّلْبُ
u'سَقَطَ ضَمٌّ':Subject, #2: 2	سَقَطَ ضَرُورَةَ
u'سُقِطَ ضَمَانٌ':Predicate, #1: 1	سَقَطَ ضَمّهُ
u'سَقَطَ ضَمَانٌ':Subject, #2: 2	أَسْقَطَ الضَّمَانَ
u'سَقَطَ ضَمَانٌ':Subject, #19: 19	سَقَطَ الضَّمَانُ
u'سَقَطَ ضَمِنٌ':Predicate, #1: 1	سَقَطَ ضَمَانُ
u'سَقَطَ طَائِرٌ':Subject, #2: 2	سَقَطَ ضَمِنَ
u'سَقَطَ طِفْلٌ':Subject, #1: 1	سَقَطَ طَائِرٌ
u'سُقِطَ طَلاَقٌ':Predicate, #1: 1	سَقَطَ طِفْلٌ
u'سَقَطَ طلب':Subject, #1: 1	أَسْقَطَ الطَّلَاقَ
u'سَقَطَ طَلَبٌ':Subject, #1: 1	سَقَطَ الطَّلَبُ
u'سَقَطَ طلب':Subject, #1: 1	سَقَطَ الطَّلَبُ
u'سَقَطَ طَلَبٌ':Subject, #1: 1	سَقَطَ طَلَبُ
u'سَقَطَ طَوْعٌ':Subject, #1: 1	سَقَطَ طَلَبُ
u'سَقَطَ ظهار':Subject, #1: 1	سَقَطَ الطَّوْعُ
u'سَقَطَ ظهار':Subject, #1: 1	سَقَطَ الظِّهَارُ
u'سُقِطَ ظُهْرٌ':Predicate, #1: 1	سَقَطَ ظِهَارُ
u'سَقَطَ عَادٌ':Predicate, #1: 1	أَسْقَطَ الظُّهْرَ
u'سُقِطَ عَبْدٌ':Predicate, #1: 1	سَقَطَ عَادَ
u'سُقِطَ عَدَالَةٌ':Predicate, #2: 2	أَسْقَطَ عَبْدَ
u'سَقَطَ عُشْرٌ':Subject, #1: 1	أَسْقَطَ الْعَدَالَةَ
u'سَقَطَ عُشْرٌ':Subject, #1: 1	سَقَطَ الْعُشْرُ
u'سَقَطَ عُشْرٌ':Subject, #1: 1	سَقَطَ عُشْرٌ
u'سَقَطَ عِشْرُون':Predicate, #1: 1	سَقَطَ عُشْرُ
u'سُقِطَ عَصْرٌ':Predicate, #1: 1	سَقَطَ عِشْرُونَ
u'سُقِطَ عِصْمَةٌ':Predicate, #1: 1	أَسْقَطَ الْعَصْرَ
u'سَقَطَ عُضْوٌ':Subject, #1: 1	أَسْقَطَ عِصْمَةَ
u'سَقَطَ عُضْوٌ':Subject, #1: 1	سَقَطَ عُضْوٌ
u'سُقِطَ عُقُوبَةٌ':Predicate, #2: 2	سَقَطَ الْعُضْوُ
u'سَقَطَ علم':Predicate, #1: 1	أَسْقَطَ عُقُوبَةَ
u'سَقَطَ عُلْوٌ':Subject, #1: 1	سَقَطَ عَلِمَ
u'سَقَطَ عُلُوٌّ':Subject, #2: 2	سَقَطَ الْعُلْوُ
u'سَقَطَ عَمَلٌ':Subject, #3: 3	سَقَطَ الْعُلُوُّ
u'سَقَطَ غَرَضٌ':Subject, #2: 2	سَقَطَ الْعَمَلُ
u'سَقَطَ غُسْلٌ':Subject, #1: 1	سَقَطَ غَرَضُهُ
u'سَقَطَ غَسْلٌ':Subject, #1: 1	سَقَطَ غُسْلُ
u'سَقَطَ غُسْلٌ':Subject, #1: 1	سَقَطَ غَسْلُهُ
u'سَقَطَ غَسْلٌ':Subject, #3: 3	سَقَطَ الْغُسْلُ
u'سُقِطَ غِشٌّ':Predicate, #3: 3	سَقَطَ غَسْلُ
u'سُقِطَ فاء':Predicate, #2: 2	أَسْقَطَ الْغِشَّ
u'سُقِطَ فَرْضٌ':Predicate, #1: 1	أَسْقَطَ الْفَاءَ
u'سُقِطَ فَرْضٌ':Predicate, #1: 1	أَسْقَطَ فَرْضَ
u'سَقَطَ فَرْضٌ':Subject, #3: 3	أَسْقَطَ الْفَرْضَ
u'سَقَطَ فَرْضٌ':Subject, #13: 13	سَقَطَ فَرْضُ
u'سَقَطَ فَرْضٌ':Subject, #33: 33	سَقَطَ الْفَرْضُ
u'سَقَطَ فَرْوَةٌ':Subject, #4: 4	سَقَطَ فَرْضُهُ
u'سُقِطَ فَسْخٌ':Predicate, #1: 1	سَقَطَ فَرْوَةُ
u'سَقَطَ فَسْخٌ':Subject, #1: 1	أَسْقَطَ الْفَسْخَ
u'سُقِطَ فِعْلٌ':Predicate, #3: 3	سَقَطَ الْفَسْخُ
u'سَقَطَ فَمٌ':Subject, #1: 1	أَسْقَطَ الْفِعْلَ
u'سَقَطَ قَادِرٌ':Subject, #1: 1	سَقَطَ فَمُهُ
u'سَقَطَ قَالٌ':Predicate, #2: 2	سَقَطَ قَادِرٌ
u'سَقَطَ قَبْضٌ':Subject, #2: 2	سَقَطَ قَالَ
u'سُقِطَ قتل':Predicate, #2: 2	سَقَطَ الْقَبْضُ
u'سُقِطَ قَتْلٌ':Predicate, #1: 1	أَسْقَطَ الْقَتْلَ
u'سَقَطَ قتل':Subject, #1: 1	أَسْقَطَ الْقَتْلَ
u'سَقَطَ قَتْلٌ':Subject, #1: 1	سَقَطَ قَتْلُهُ
u'سَقَطَ قتل':Subject, #1: 1	سَقَطَ قَتْلُهُ
u'سَقَطَ قَتْلٌ':Subject, #4: 4	سَقَطَ الْقَتْلُ
u'سُقِطَ قَدْرٌ':Predicate, #4: 4	سَقَطَ الْقَتْلُ
u'سَقَطَ قَدْرٌ':Subject, #2: 2	أَسْقَطَ قَدْرَ
u'سَقَطَ قَسام':Subject, #1: 1	سَقَطَ قَدْرُ
u'سَقَطَ قَسامَة':Subject, #1: 1	سَقَطَ الْقَسَامَةُ
u'سَقَطَ قِسْطٌ':Subject, #1: 1	سَقَطَ الْقَسَامَةُ
u'سَقَطَ قِسْطٌ':Subject, #1: 1	سَقَطَ الْقِسْطُ
u'سَقَطَ قِسْطٌ':Subject, #1: 1	سَقَطَ قِسْطٌ
u'سُقِطَ قصاص':Predicate, #2: 2	سَقَطَ قِسْطُ
u'سُقِطَ قِصَاصٌ':Predicate, #2: 2	أَسْقَطَ الْقِصَاصَ
u'سَقَطَ قصاص':Subject, #2: 2	أَسْقَطَ الْقِصَاصَ
u'سَقَطَ قِصَاصٌ':Subject, #2: 2	سَقَطَ قِصَاصُ
u'سَقَطَ قصاص':Subject, #2: 2	سَقَطَ قِصَاصُ
u'سَقَطَ قِصَاصٌ':Subject, #49: 49	سَقَطَ الْقِصَاصُ
u'سُقِطَ قَضَاءٌ':Predicate, #49: 49	سَقَطَ الْقِصَاصُ
u'سَقَطَ قَضَاءٌ':Subject, #2: 2	أَسْقَطَ الْقَضَاءَ
u'سَقَطَ قَضَاءٌ':Subject, #1: 1	سَقَطَ قَضَاءُ
u'سَقَطَ قَطْعٌ':Subject, #4: 4	سَقَطَ الْقَضَاءُ
u'سَقَطَ قَطْعٌ':Subject, #13: 13	سَقَطَ الْقَطْعُ
u'سَقَطَ قلب':Subject, #1: 1	سَقَطَ قَطْعُهُ
u'سَقَطَ قَلْبٌ':Subject, #1: 1	سَقَطَ قَلْبُ
u'سَقَطَ قَلْب':Subject, #1: 1	سَقَطَ قَلْبُ
u'سُقِطَ قَوَد':Predicate, #1: 1	سَقَطَ قَلْبُ
u'سَقَطَ قَوَد':Subject, #1: 1	أَسْقَطَ الْقَوَدَ
u'سَقَطَ قول':Subject, #10: 10	سَقَطَ الْقَوَدُ
u'سَقَطَ قَوْلٌ':Subject, #1: 1	سَقَطَ قَوْلُ
u'سَقَطَ قول':Subject, #1: 1	سَقَطَ قَوْلُ
u'سَقَطَ قَوْلٌ':Subject, #2: 2	سَقَطَ الْقَوْلُ
u'سَقَطَ قول':Subject, #2: 2	سَقَطَ الْقَوْلُ
u'سَقَطَ قَوْلٌ':Subject, #5: 5	سَقَطَ قَوْلُهُ
u'سَقَطَ قيام':Subject, #5: 5	سَقَطَ قَوْلُهُ
u'سَقَطَ قِيَامٌ':Subject, #2: 2	سَقَطَ الْقِيَامُ
u'سَقَطَ قيام':Subject, #2: 2	سَقَطَ الْقِيَامُ
u'سَقَطَ قِيَامٌ':Subject, #2: 2	سَقَطَ قِيَامُهُ
u'سُقِطَ قَيْدٌ':Predicate, #2: 2	سَقَطَ قِيَامُهُ
u'سُقِطَ كِتَابٌ':Predicate, #1: 1	أَسْقَطَ قَيْدَ
u'سَقَطَ كِرَاءٌ':Subject, #1: 1	أَسْقَطَ الْكِتَابَ
u'سُقِطَ كُسُورٌ':Predicate, #1: 1	سَقَطَ كِرَاءُ
u'سُقِطَ كَلاَمٌ':Predicate, #1: 1	أَسْقَطَ الْكُسُورَ
u'سَقَطَ كَلاَمٌ':Subject, #1: 1	أَسْقَطَ الْكَلَامَ
u'سَقَطَ لَحْمٌ':Subject, #1: 1	سَقَطَ الْكَلَامُ
u'سَقَطَ لعان':Subject, #1: 1	سَقَطَ اللَّحْمُ
u'سُقِطَ لَفْظٌ':Predicate, #11: 11	سَقَطَ اللِّعَانُ
u'سَقَطَ لَفْظٌ':Subject, #1: 1	أَسْقَطَ لَفْظَ
u'سُقِطَ لَفْظَةٌ':Predicate, #5: 5	سَقَطَ لَفْظُ
u'سَقَطَ لَفْظَةٌ':Subject, #1: 1	أَسْقَطَ لَفْظَةَ
u'سَقَطَ لُقْمَةٌ':Subject, #1: 1	سَقَطَ لَفْظَةُ
u'سَقَطَ لِوَاءٌ':Subject, #1: 1	سَقَطَ لُقْمَةُ
u'سَقَطَ مَالٌ':Subject, #1: 1	سَقَطَ اللِّوَاءُ
u'سَقَطَ مَبِيتٌ':Subject, #1: 1	سَقَطَ مَالُهُ
u'سَقَطَ مَجَازٌ':Subject, #2: 2	سَقَطَ مَبِيتُهُ
u'سَقَطَ مُرَاعَاةٌ':Subject, #2: 2	سَقَطَ الْمَجَازُ
u'سَقَطَ مُعْظَمٌ':Subject, #2: 2	سَقَطَ مُرَاعَاةُ
u'سُقِطَ مُفْسِدٌ':Predicate, #2: 2	سَقَطَ مُعْظَمُ
u'سَقَطَ مَفْهُومٌ':Subject, #3: 3	أَسْقَطَ الْمُفْسِدَ
u'سَقَطَ مَقَالٌ':Subject, #1: 1	سَقَطَ الْمَفْهُومُ
u'سَقَطَ مُقَدِّمٌ':Subject, #1: 1	سَقَطَ مَقَالُ
u'سُقِطَ مُلاَزَمَةٌ':Predicate, #1: 1	سَقَطَ مُقَدِّمُ
u'سَقَطَ مِلْكٌ':Subject, #1: 1	أَسْقَطَ الْمُلَازَمَةَ
u'سَقَطَ مِلْكٌ':Subject, #1: 1	سَقَطَ مِلْكُ
u'سَقَطَ مَنْصُوصٌ':Subject, #2: 2	سَقَطَ مِلْكُهُ
u'سَقَطَ مَهْرٌ':Subject, #1: 1	سَقَطَ الْمَنْصُوصُ
u'سَقَطَ مَهْرٌ':Subject, #21: 21	سَقَطَ الْمَهْرُ
u'سَقَطَ مَهْرٌ':Subject, #3: 3	سَقَطَ مَهْرٌ
u'سَقَطَ مُوجِبٌ':Subject, #3: 3	سَقَطَ مَهْرُ
u'سَقَطَ مِيزَابٌ':Subject, #1: 1	سَقَطَ مُوجِبُهُ
u'سَقَطَ مِيزَابٌ':Subject, #1: 1	سَقَطَ مِيزَابُهُ
u'سَقَطَ نذر':Subject, #3: 3	سَقَطَ الْمِيزَابُ
u'سَقَطَ نَذْرٌ':Subject, #2: 2	سَقَطَ النَّذْرُ
u'سَقَطَ نِسْبَةٌ':Subject, #2: 2	سَقَطَ النَّذْرُ
u'سَقَطَ نِصْفٌ':Subject, #1: 1	سَقَطَ نِسْبَةُ
u'سَقَطَ نِصْفٌ':Subject, #1: 1	سَقَطَ النِّصْفُ
u'سَقَطَ نِصْفٌ':Subject, #1: 1	سَقَطَ نِصْفُهُ
u'سَقَطَ نَصِيبٌ':Subject, #21: 21	سَقَطَ نِصْفُ
u'سَقَطَ نَصِيبٌ':Subject, #2: 2	سَقَطَ نَصِيبُهُ
u'سَقَطَ نُطْقٌ':Subject, #4: 4	سَقَطَ نَصِيبُ
u'سَقَطَ نكاح':Subject, #1: 1	سَقَطَ النُّطْقُ
u'سَقَطَ نِكَاحٌ':Subject, #1: 1	سَقَطَ النِّكَاحُ
u'سَقَطَ نَهْيٌ':Subject, #1: 1	سَقَطَ النِّكَاحُ
u'سُقِطَ هاء':Predicate, #2: 2	سَقَطَ النَّهْيُ
u'سَقَطَ وَاجِبٌ':Subject, #2: 2	أَسْقَطَ الْهَاءَ
u'سَقَطَ واحد':Subject, #4: 4	سَقَطَ الْوَاجِبُ
u'سَقَطَ وَاحِدٌ':Subject, #2: 2	سَقَطَ وَاحِدٌ
u'سَقَطَ وَجَبٌ':Predicate, #2: 2	سَقَطَ وَاحِدٌ
u'سُقِطَ وُجُوبٌ':Predicate, #1: 1	سَقَطَ وَجَبَ
u'سُقِطَ وُجُوبٌ':Predicate, #1: 1	أَسْقَطَ الْوُجُوبَ
u'سَقَطَ وُجُوبٌ':Subject, #1: 1	أَسْقَطَ وُجُوبَ
u'سَقَطَ وُجُوبٌ':Subject, #10: 10	سَقَطَ وُجُوبُهُ
u'سَقَطَ وُجُوبٌ':Subject, #4: 4	سَقَطَ وُجُوبُ
u'سَقَطَ وَسِيلَةٌ':Subject, #6: 6	سَقَطَ الْوُجُوبُ
u'سَقَطَ وُضُوءٌ':Subject, #1: 1	سَقَطَ الْوَسِيلَةُ
u'سَقَطَ وَقْتٌ':Subject, #1: 1	سَقَطَ الْوُضُوءُ
u'سَقَطَ ولد':Subject, #1: 1	سَقَطَ الْوَقْتُ
u'سَقَطَ وَلَدٌ':Subject, #1: 1	سَقَطَ وَلَدُ
u'سَقَطَ ولد':Subject, #1: 1	سَقَطَ وَلَدُ
u'سَقَطَ وَلَدٌ':Subject, #2: 2	سَقَطَ الْوَلَدُ
u'سَقَطَ وَلَهٌ':Subject, #2: 2	سَقَطَ الْوَلَدُ
u'سُقِطَ يَمِينٌ':Predicate, #1: 1	سَقَطَ وَلَهُ
u'سَقَطَ يَمِينٌ':Subject, #1: 1	أَسْقَطَ الْيَمِينَ
u'سُقِطَ يَوْمٌ':Predicate, #6: 6	سَقَطَ الْيَمِينُ
u'سَقْفٌ بَيْتٌ':Added, #4: 4	أَسْقَطَ الْيَوْمَ
u'سَقْفٌ بَيْتٌ':Added, #1: 1	سَقْفُ الْبَيْتِ
u'سَقْفٌ بَيْتٌ':Added, #1: 1	سَقْفِ بَيْتِهِ
u'سَقْفٌ بَيْتٌ':Added, #2: 2	سَقْفِ بَيْتٍ
u'سَقْفٌ بَيْتٌ':Added, #2: 2	سَقْفُ بَيْتِهِ
u'سَقْفٌ بَيْتٌ':Added, #3: 3	سَقْفُ بَيْتٍ
u'سَقْفٌ حَلْقٌ':Added, #6: 6	سَقْفِ الْبَيْتِ
u'سَقْفٌ دَارٌ':Added, #1: 1	سَقْفِ حَلْقِهِ
u'سَقْفٌ دَارٌ':Added, #1: 1	سَقْفُ الدَّارِ
u'سَقْفٌ سُفْلٌ':Added, #1: 1	سَقْفِ الدَّارِ
u'سَقْفٌ سُفْلٌ':Added, #1: 1	سَقْفَ السُّفْلِ
u'سَقْفٌ سُوقٌ':Added, #1: 1	سَقْفُ السُّفْلِ
u'سَقْفٌ سُوقٌ':Added, #1: 1	سَقْفُ السُّوقِ
u'سَقْفٌ عُلْوٌ':Added, #1: 1	سَقْفِ السُّوقِ
u'سَقْفٌ عُلْوٌ':Added, #1: 1	سَقْفِ الْعُلْوِ
u'سَقْفٌ فَمٌ':Added, #1: 1	سَقْفَ عُلْوِهِ
u'سَقْفٌ قَبْرٌ':Added, #1: 1	سَقْفِ الْفَمِ
u'سَقْفٌ قَبْرٌ':Added, #1: 1	سَقْفَ الْقَبْرِ
u'سَقْفٌ كعبة':Added, #1: 1	سَقْفِ الْقَبْرِ
u'سَقْفٌ كَعْبَةٌ':Added, #1: 1	سَقْفِ الْكَعْبَةِ
u'سَقْفٌ مَسْجِدٌ':Added, #1: 1	سَقْفِ الْكَعْبَةِ
u'سَقْفٌ مَسْجِدٌ':Added, #1: 1	سَقْفُ الْمَسْجِدِ
u'سَقْفٌ مُمَوَّهٌ':Added, #1: 1	سَقْفِ الْمَسْجِدِ
u'سَقْفٌ نَفْسٌ':Added, #1: 1	سَقْفٍ مُمَوَّهٍ
u'سَقْفٌ واحد':Added, #1: 1	سَقْفِ نَفْسِهِ
u'سَقْفٌ وَاحِدٌ':Added, #3: 3	سَقْفٍ وَاحِدٍ
u'سَقِمَ بدن':Subject, #3: 3	سَقْفٍ وَاحِدٍ
u'سَقِمَ بَدَنٌ':Subject, #1: 1	سَقِمَ بَدَنُهُ
u'سقم سَقِيمٌ':Added, #1: 1	سَقِمَ بَدَنُهُ
u'سَقَمٌ سَقِيمٌ':Added, #1: 1	سَقَمُ السَّقِيمِ
u'سقم صَحِيحٌ':Added, #1: 1	سَقَمُ السَّقِيمِ
u'سَقَمٌ صَحِيحٌ':Added, #1: 1	سَقَمُ الصَّحِيحِ
u'سُقُوطٌ أَبٌ':Added, #1: 1	سَقَمُ الصَّحِيحِ
u'سُقُوطٌ إِثْمٌ':Added, #1: 1	سُقُوطَ الْأَبِ
u'سُقُوطٌ إِثْمٌ':Added, #1: 1	سُقُوطَ الْإِثْمِ
u'سُقُوطٌ إِثْمٌ':Added, #5: 5	سُقُوطُ الْإِثْمِ
u'سُقُوطٌ أَجْرٌ':Added, #7: 7	سُقُوطِ الْإِثْمِ
u'سُقُوطٌ أَجَلٌ':Added, #1: 1	سُقُوطَ الْأَجْرِ
u'سُقُوطٌ أَجَلٌ':Added, #1: 1	سُقُوطَ الْأَجَلِ
u'سُقُوطٌ أحَدٌ':Added, #1: 1	سُقُوطُ الْأَجَلِ
u'سُقُوطٌ أَحْكَامٌ':Added, #1: 1	سُقُوطِ أَحَدِ
u'سُقُوطٌ أَدَاءٌ':Added, #1: 1	سُقُوطِ أَحْكَامِهِ
u'سُقُوطٌ أَدَاءٌ':Added, #1: 1	سُقُوطِ أَدَاءِ
u'سُقُوطٌ اِسْتِعْمالٌ':Added, #1: 1	سُقُوطُ الْأَدَاءِ
u'سُقُوطٌ اِسْتِعْمالٌ':Added, #1: 1	سُقُوطِ اسْتِعْمَالِ
u'سُقُوطٌ اِسْتِقْبالٌ':Added, #3: 3	سُقُوطُ اسْتِعْمَالِهِ
u'سُقُوطٌ أسْنَانٌ':Added, #1: 1	سُقُوطُ اسْتِقْبَالِ
u'سُقُوطٌ اِشْتِراطٌ':Added, #1: 1	سُقُوطِ الْأَسْنَانِ
u'سُقُوطٌ إِشْكالٌ':Added, #1: 1	سُقُوطِ اشْتِرَاطِ
u'سُقُوطٌ أَصابِعُ':Added, #1: 1	سُقُوطُ الْإِشْكَالِ
u'سُقُوطٌ أصل':Added, #3: 3	سُقُوطَ أَصَابِعِهِ
u'سُقُوطٌ أًصْلٌ':Added, #2: 2	سُقُوطَ أَصْلِ
u'سُقُوطٌ أصل':Added, #2: 2	سُقُوطَ أَصْلِ
u'سُقُوطٌ أًصْلٌ':Added, #2: 2	سُقُوطِ الْأَصْلِ
u'سُقُوطٌ اِعْتِبارٌ':Added, #2: 2	سُقُوطِ الْأَصْلِ
u'سُقُوطٌ اِعْتِبارٌ':Added, #1: 1	سُقُوطَ اعْتِبَارِ
u'سُقُوطٌ اِعْتِبارٌ':Added, #1: 1	سُقُوطُ اعْتِبَارِ
u'سُقُوطٌ اِعْتِبارٌ':Added, #3: 3	سُقُوطِ اعْتِبَارِ
u'سُقُوطٌ إِلْزَامٌ':Added, #3: 3	سُقُوطَ اعْتِبَارِهِ
u'سُقُوطٌ أَمْرٌ':Added, #1: 1	سُقُوطُ الْإِلْزَامِ
u'سُقُوطٌ أَمْرٌ':Added, #1: 1	سُقُوطَ الْأَمْرِ
u'سُقُوطٌ أَوَّلُ':Added, #1: 1	سُقُوطِ الْأَمْرِ
u'سُقُوطٌ أَوَّلُ':Added, #1: 1	سُقُوطُ الْأَوَّلِ
u'سُقُوطٌ إِيجَابٌ':Added, #1: 1	سُقُوطِ الْأَوَّلِ
u'سُقُوطٌ بَحْثٌ':Added, #1: 1	سُقُوطِ الْإِيجَابِ
u'سُقُوطٌ بِدَعٌ':Added, #1: 1	سُقُوطُ الْبَحْثِ
u'سُقُوطٌ بَدَلٌ':Added, #1: 1	سُقُوطُ الْبِدَعِ
u'سُقُوطٌ بَدَلٌ':Added, #1: 1	سُقُوطَ الْبَدَلِ
u'سُقُوطٌ بدنة':Added, #1: 1	سُقُوطِ الْبَدَلِ
u'سُقُوطٌ بَعْضٌ':Added, #2: 2	سُقُوطُ الْبَدَنَةِ
u'سُقُوطٌ بَعْضٌ':Added, #1: 1	سُقُوطَ بَعْضِ
u'سُقُوطٌ بَعْضٌ':Added, #1: 1	سُقُوطُ بَعْضِ
u'سُقُوطٌ بَعْضٌ':Added, #1: 1	سُقُوطِ بَعْضٍ
u'سُقُوطٌ تَبِعَةٌ':Added, #2: 2	سُقُوطِ بَعْضِ
u'سُقُوطٌ تَتَابُعٌ':Added, #1: 1	سُقُوطَ تَبِعَاتِ
u'سُقُوطٌ تَحْلِيلٌ':Added, #1: 1	سُقُوطِ التَّتَابُعِ
u'سُقُوطٌ تَرْتِيبٌ':Added, #1: 1	سُقُوطِ التَّحْلِيلِ
u'سُقُوطٌ تَرْتِيبٌ':Added, #3: 3	سُقُوطُ التَّرْتِيبِ
u'سُقُوطٌ تَرْتِيبٌ':Added, #5: 5	سُقُوطَ التَّرْتِيبِ
u'سُقُوطٌ تَسْلِيمٌ':Added, #7: 7	سُقُوطِ التَّرْتِيبِ
u'سُقُوطٌ تَسْمِيَة':Added, #1: 1	سُقُوطِ تَسْلِيمِ
u'سُقُوطٌ تَعَبُّدٌ':Added, #1: 1	سُقُوطِ التَّسْمِيَةِ
u'سُقُوطٌ تَعْيِينٌ':Added, #2: 2	سُقُوطِ التَّعَبُّدِ
u'سُقُوطٌ تَغْرِيبٌ':Added, #2: 2	سُقُوطِ التَّعْيِينِ
u'سُقُوطٌ تَقَوُّمٌ':Added, #1: 1	سُقُوطِ التَّغْرِيبِ
u'سُقُوطٌ تَقَوُّمٌ':Added, #1: 1	سُقُوطُ التَّقَوُّمِ
u'سُقُوطٌ تَقَوُّمٌ':Added, #2: 2	سُقُوطِ تَقَوُّمِهِ
u'سُقُوطٌ تَقَوُّمٌ':Added, #4: 4	سُقُوطِ التَّقَوُّمِ
u'سُقُوطٌ تَكْرارٌ':Added, #5: 5	سُقُوطَ التَّقَوُّمِ
u'سُقُوطٌ تَكْليفٌ':Added, #1: 1	سُقُوطَ التَّكْرَارِ
u'سُقُوطٌ تَكْليفٌ':Added, #1: 1	سُقُوطُ التَّكْلِيفِ
u'سُقُوطٌ تَنجُّسٌ':Added, #2: 2	سُقُوطِ التَّكْلِيفِ
u'سُقُوطٌ تَهْلِيلٌ':Added, #1: 1	سُقُوطَ التَّنَجُّسِ
u'سُقُوطٌ تَوْثِقَة':Added, #1: 1	سُقُوطِ التَّهْلِيلِ
u'سُقُوطٌ ثَالِثٌ':Added, #1: 1	سُقُوطُ تَوْثِقَةٍ
u'سُقُوطٌ ثَانِي':Added, #1: 1	سُقُوطُ الثَّالِثِ
u'سُقُوطٌ ثَانِيَةٌ':Added, #1: 1	سُقُوطِ الثَّانِيَةِ
u'سُقُوطٌ ثَمَنٌ':Added, #1: 1	سُقُوطِ الثَّانِيَةِ
u'سُقُوطٌ ثَمَنٌ':Added, #1: 1	سُقُوطُ الثَّمَنِ
u'سُقُوطٌ ثُمْنٌ':Added, #1: 1	سُقُوطِ الثَّمَنِ
u'سُقُوطٌ ثَوابٌ':Added, #1: 1	سُقُوطُ ثُمْنِ
u'سُقُوطٌ ثَوابٌ':Added, #1: 1	سُقُوطُ الثَّوَابِ
u'سُقُوطٌ ثَوْبٌ':Added, #1: 1	سُقُوطُ ثَوَابِ
u'سُقُوطٌ ثِيابٌ':Added, #1: 1	سُقُوطِ الثَّوْبِ
u'سُقُوطٌ جَاهٌ':Added, #1: 1	سُقُوطِ ثِيَابِهِ
u'سُقُوطٌ جَبِيرَة':Added, #1: 1	سُقُوطِ جَاهٍ
u'سُقُوطٌ جِدار':Added, #1: 1	سُقُوطِ الْجَبِيرَةِ
u'سُقُوطٌ جِدار':Added, #1: 1	سُقُوطُ جِدَارٍ
u'سُقُوطٌ جُزْءٌ':Added, #1: 1	سُقُوطُ جِدَارِ
u'سُقُوطٌ جَزَاءٌ':Added, #1: 1	سُقُوطُ جُزْءٍ
u'سُقُوطٌ جِزْيَةٌ':Added, #1: 1	سُقُوطَ الْجَزَاءِ
u'سُقُوطٌ جِزْيَةٌ':Added, #1: 1	سُقُوطُ جِزْيَةِ
u'سُقُوطٌ جلد':Added, #3: 3	سُقُوطِ الْجِزْيَةِ
u'سُقُوطٌ جَلْدٌ':Added, #1: 1	سُقُوطَ الْجَلْدِ
u'سُقُوطٌ جمعة':Added, #1: 1	سُقُوطَ الْجَلْدِ
u'سُقُوطٌ جمعة':Added, #1: 1	سُقُوطَ الْجُمُعَةِ
u'سُقُوطٌ جمعة':Added, #1: 1	سُقُوطُ الْجُمُعَةِ
u'سُقُوطٌ جُمُعَةٌ':Added, #1: 1	سُقُوطِ الْجُمُعَةِ
u'سُقُوطٌ جُمُعَةٌ':Added, #1: 1	سُقُوطَ الْجُمُعَةِ
u'سُقُوطٌ جُمُعَةٌ':Added, #1: 1	سُقُوطُ الْجُمُعَةِ
u'سُقُوطٌ جمعة':Added, #1: 1	سُقُوطِ الْجُمُعَةِ
u'سُقُوطٌ جُمُعَةٌ':Added, #1: 1	سُقُوطِ جُمُعَةٍ
u'سُقُوطٌ جَمِيع':Added, #1: 1	سُقُوطِ جُمُعَةٍ
u'سُقُوطٌ جِنْسٌ':Added, #1: 1	سُقُوطَ الْجَمِيعِ
u'سُقُوطٌ جِنْسٌ':Added, #1: 1	سُقُوطَ الْجِنْسِ
u'سُقُوطٌ حائِطٌ':Added, #1: 1	سُقُوطُ الْجِنْسِ
u'سُقُوطٌ حائِطٌ':Added, #1: 1	سُقُوطُ الْحَائِطِ
u'سُقُوطٌ حَبٌّ':Added, #3: 3	سُقُوطِ الْحَائِطِ
u'سُقُوطٌ حَبَّةٌ':Added, #1: 1	سُقُوطِ الْحَبَّةِ
u'سُقُوطٌ حَبْسٌ':Added, #1: 1	سُقُوطِ الْحَبَّةِ
u'سُقُوطٌ حَجٌّ':Added, #1: 1	سُقُوطِ حَبْسِ
u'سُقُوطٌ حَجٌّ':Added, #2: 2	سُقُوطُ الْحَجِّ
u'سُقُوطٌ حُجَّةٌ':Added, #2: 2	سُقُوطِ الْحَجِّ
u'سُقُوطٌ حَدٌّ':Added, #1: 1	سُقُوطُ الْحُجَّةِ
u'سُقُوطٌ حَدٌّ':Added, #10: 10	سُقُوطَ الْحَدِّ
u'سُقُوطٌ حَدٌّ':Added, #13: 13	سُقُوطُ الْحَدِّ
u'سُقُوطٌ حَدٌّ':Added, #1: 1	سُقُوطُ حَدٍّ
u'سُقُوطٌ حَدٌّ':Added, #1: 1	سُقُوطِ حَدِّهِ
u'سُقُوطٌ حَدٌّ':Added, #22: 22	سُقُوطِ الْحَدِّ
u'سُقُوطٌ حَدٌّ':Added, #2: 2	سُقُوطِ حَدٍّ
u'سُقُوطٌ حَدٌّ':Added, #5: 5	سُقُوطُ حَدِّ
u'سُقُوطٌ حَدَثٌ':Added, #8: 8	سُقُوطِ حَدِّ
u'سُقُوطٌ حَرَجٌ':Added, #1: 1	سُقُوطِ الْحَدَثِ
u'سُقُوطٌ حَرَجٌ':Added, #1: 1	سُقُوطَ الْحَرَجِ
u'سُقُوطٌ حَرَكَةٌ':Added, #1: 1	سُقُوطُ الْحَرَجِ
u'سُقُوطٌ حُرُمَةٌ':Added, #1: 1	سُقُوطَ الْحَرَكَةِ
u'سُقُوطٌ حُرْمَةٌ':Added, #1: 1	سُقُوطَ الْحُرُمَاتِ
u'سُقُوطٌ حُرْمَةٌ':Added, #1: 1	سُقُوطُ الْحُرْمَةِ
u'سُقُوطٌ حِصَّةٌ':Added, #1: 1	سُقُوطِ الْحُرْمَةِ
u'سُقُوطٌ حِصَّةٌ':Added, #1: 1	سُقُوطِ حِصَّةِ
u'سُقُوطٌ حَقٌّ':Added, #1: 1	سُقُوطِ حِصَّتِهِ
u'سُقُوطٌ حَقٌّ':Added, #16: 16	سُقُوطِ حَقِّ
u'سُقُوطٌ حَقٌّ':Added, #2: 2	سُقُوطُ الْحَقِّ
u'سُقُوطٌ حَقٌّ':Added, #2: 2	سُقُوطِ الْحَقِّ
u'سُقُوطٌ حَقٌّ':Added, #2: 2	سُقُوطُ حَقِّهِ
u'سُقُوطٌ حَقٌّ':Added, #3: 3	سُقُوطَ حَقِّهِ
u'سُقُوطٌ حَقٌّ':Added, #3: 3	سُقُوطِ حَقِّهِ
u'سُقُوطٌ حَقٌّ':Added, #5: 5	سُقُوطَ حَقِّ
u'سُقُوطٌ حُكْمٌ':Added, #6: 6	سُقُوطُ حَقِّ
u'سُقُوطٌ حُكْمٌ':Added, #1: 1	سُقُوطِ حُكْمِ
u'سُقُوطٌ حُكْمٌ':Added, #2: 2	سُقُوطَ حُكْمِ
u'سُقُوطٌ حُكُومَةٌ':Added, #2: 2	سُقُوطِ حُكْمِهِ
u'سُقُوطٌ خَبَرٌ':Added, #1: 1	سُقُوطِ الْحُكُومَةِ
u'سُقُوطٌ خَبَر':Added, #1: 1	سُقُوطِ الْخَبَرِ
u'سُقُوطٌ خِطَابٌ':Added, #1: 1	سُقُوطِ الْخَبَرِ
u'سُقُوطٌ خِطَابٌ':Added, #1: 1	سُقُوطُ الْخِطَابِ
u'سُقُوطٌ خِطَابٌ':Added, #1: 1	سُقُوطِ خِطَابِ
u'سُقُوطٌ خطر':Added, #4: 4	سُقُوطِ الْخِطَابِ
u'سُقُوطٌ خَطَرٌ':Added, #6: 6	سُقُوطَ خَطَرِ
u'سُقُوطٌ خيار':Added, #6: 6	سُقُوطَ خَطَرِ
u'سُقُوطٌ خِيَارٌ':Added, #18: 18	سُقُوطِ الْخِيَارِ
u'سُقُوطٌ خيار':Added, #18: 18	سُقُوطِ الْخِيَارِ
u'سُقُوطٌ خِيَارٌ':Added, #1: 1	سُقُوطُ الْخِيَارِ
u'سُقُوطٌ خيار':Added, #1: 1	سُقُوطُ الْخِيَارِ
u'سُقُوطٌ خِيَارٌ':Added, #1: 1	سُقُوطَ خِيَارِ
u'سُقُوطٌ خيار':Added, #1: 1	سُقُوطَ خِيَارِ
u'سُقُوطٌ خيار':Added, #1: 1	سُقُوطَ خِيَارِهِ
u'سُقُوطٌ خيار':Added, #1: 1	سُقُوطُ خِيَارِهِ
u'سُقُوطٌ خِيَارٌ':Added, #1: 1	سُقُوطِ خِيَارِهِ
u'سُقُوطٌ خِيَارٌ':Added, #1: 1	سُقُوطَ خِيَارِهِ
u'سُقُوطٌ خِيَارٌ':Added, #1: 1	سُقُوطُ خِيَارِهِ
u'سُقُوطٌ خيار':Added, #1: 1	سُقُوطِ خِيَارِهِ
u'سُقُوطٌ خِيَارٌ':Added, #2: 2	سُقُوطُ خِيَارِ
u'سُقُوطٌ خيار':Added, #2: 2	سُقُوطُ خِيَارِ
u'سُقُوطٌ خِيَارٌ':Added, #5: 5	سُقُوطَ الْخِيَارِ
u'سُقُوطٌ خيار':Added, #5: 5	سُقُوطَ الْخِيَارِ
u'سُقُوطٌ خِيَارٌ':Added, #5: 5	سُقُوطِ خِيَارِ
u'سُقُوطٌ دَابَّةٌ':Added, #5: 5	سُقُوطِ خِيَارِ
u'سُقُوطٌ دُرٌّ':Added, #1: 1	سُقُوطُ الدَّابَّةِ
u'سُقُوطٌ دُرَّةٌ':Added, #1: 1	سُقُوطَ الدُّرَّةِ
u'سُقُوطٌ دَمٌ':Added, #1: 1	سُقُوطَ الدُّرَّةِ
u'سُقُوطٌ دَمٌ':Added, #1: 1	سُقُوطُ دَمِ
u'سُقُوطٌ دَمٌ':Added, #1: 1	سُقُوطِ دَمِهِ
u'سُقُوطٌ دَمٌ':Added, #3: 3	سُقُوطُ الدَّمِ
u'سُقُوطٌ دَمٌ':Added, #5: 5	سُقُوطِ دَمِ
u'سُقُوطٌ دُودٌ':Added, #6: 6	سُقُوطِ الدَّمِ
u'سُقُوطٌ دَيْنٌ':Added, #1: 1	سُقُوطُ الدُّودِ
u'سُقُوطٌ دَيْنٌ':Added, #14: 14	سُقُوطَ الدَّيْنِ
u'سُقُوطٌ دَيْنٌ':Added, #1: 1	سُقُوطُ دَيْنٍ
u'سُقُوطٌ دَيْنٌ':Added, #1: 1	سُقُوطَ دَيْنِهِ
u'سُقُوطٌ دَيْنٌ':Added, #2: 2	سُقُوطِ دَيْنِ
u'سُقُوطٌ دَيْنٌ':Added, #6: 6	سُقُوطُ الدَّيْنِ
u'سُقُوطٌ دِينارٌ':Added, #6: 6	سُقُوطِ الدَّيْنِ
u'سُقُوطٌ ذُنُوبٌ':Added, #1: 1	سُقُوطِ الدِّينَارِ
u'سُقُوطٌ رباط':Added, #1: 1	سُقُوطِ الذُّنُوبِ
u'سُقُوطٌ رِبَاطٌ':Added, #1: 1	سُقُوطِ الرِّبَاطِ
u'سُقُوطٌ رُبْعٌ':Added, #1: 1	سُقُوطِ الرِّبَاطِ
u'سُقُوطٌ رجعة':Added, #1: 1	سُقُوطِ رُبْعِ
u'سُقُوطٌ رَجْعَةٌ':Added, #1: 1	سُقُوطُ الرَّجْعَةِ
u'سُقُوطٌ رِجْلٌ':Added, #1: 1	سُقُوطُ الرَّجْعَةِ
u'سُقُوطٌ رِجْلٌ':Added, #1: 1	سُقُوطَ رِجْلِهِ
u'سُقُوطٌ رُجُوعٌ':Added, #1: 1	سُقُوطِ رِجْلِهِ
u'سُقُوطٌ رِزْقٌ':Added, #3: 3	سُقُوطُ الرُّجُوعِ
u'سُقُوطٌ رضاع':Added, #3: 3	سُقُوطَ رِزْقِهِ
u'سُقُوطٌ رِقٌّ':Added, #1: 1	سُقُوطِ الرَّضَاعِ
u'سُقُوطٌ رُكْن':Added, #1: 1	سُقُوطَ الرِّقِّ
u'سُقُوطٌ رُكْنِيّ':Added, #1: 1	سُقُوطِ رُكْنِيَّةِ
u'سُقُوطٌ رَمْيٌ':Added, #1: 1	سُقُوطِ رُكْنِيَّةِ
u'سُقُوطٌ رواضع':Added, #1: 1	سُقُوطُ الرَّمْيِ
u'سُقُوطٌ رَوَاضِعُ':Added, #1: 1	سُقُوطُ الرَّوَاضِعِ
u'سُقُوطٌ رِوايَةٌ':Added, #1: 1	سُقُوطُ الرَّوَاضِعِ
u'سُقُوطٌ زَكاةٌ':Added, #1: 1	سُقُوطِ رِوَايَةٍ
u'سُقُوطٌ زَكاةٌ':Added, #10: 10	سُقُوطِ الزَّكَاةِ
u'سُقُوطٌ زَكاةٌ':Added, #1: 1	سُقُوطُ زَكَاةِ
u'سُقُوطٌ زَكاةٌ':Added, #2: 2	سُقُوطِ زَكَاةِ
u'سُقُوطٌ زَكاةٌ':Added, #3: 3	سُقُوطَ الزَّكَاةِ
u'سُقُوطٌ زِيادَةٌ':Added, #3: 3	سُقُوطُ الزَّكَاةِ
u'سُقُوطٌ سَالِبٌ':Added, #1: 1	سُقُوطُ الزِّيَادَةِ
u'سُقُوطٌ سَبَبٌ':Added, #1: 1	سُقُوطَ السَّالِبَةِ
u'سُقُوطٌ سُجُودٌ':Added, #1: 1	سُقُوطِ سَبَبِ
u'سُقُوطٌ سُجُودٌ':Added, #1: 1	سُقُوطِ السُّجُودِ
u'سُقُوطٌ سُجُودٌ':Added, #1: 1	سُقُوطَ سُجُودِ
u'سُقُوطٌ سِعَايَةٌ':Added, #2: 2	سُقُوطِ سُجُودِ
u'سُقُوطٌ سُفْلٌ':Added, #1: 1	سُقُوطُ السِّعَايَةِ
u'سُقُوطٌ سلام':Added, #1: 1	سُقُوطُ السُّفْلِ
u'سُقُوطٌ سَلاَمٌ':Added, #1: 1	سُقُوطُ السَّلَامِ
u'سُقُوطٌ سِنٌّ':Added, #1: 1	سُقُوطُ السَّلَامِ
u'سُقُوطٌ سِنٌّ':Added, #1: 1	سُقُوطِ السِّنِّ
u'سُقُوطٌ سَهْمٌ':Added, #2: 2	سُقُوطِ سِنِّ
u'سُقُوطٌ سَهْمٌ':Added, #1: 1	سُقُوطُ سَهْمِهِ
u'سُقُوطٌ شَرَائِطُ':Added, #2: 2	سُقُوطِ سَهْمِ
u'سُقُوطٌ شَطْرٌ':Added, #1: 1	سُقُوطِ الشَّرَائِطِ
u'سُقُوطٌ شَطْرٌ':Added, #1: 1	سُقُوطَ شَطْرِ
u'سُقُوطٌ شَطْرٌ':Added, #1: 1	سُقُوطِ شَطْرٍ
u'سُقُوطٌ شَطْرٌ':Added, #1: 1	سُقُوطِ شَطْرِهِ
u'سُقُوطٌ شَطْرٌ':Added, #2: 2	سُقُوطِ الشَّطْرِ
u'سُقُوطٌ شفعة':Added, #2: 2	سُقُوطِ شَطْرِ
u'سُقُوطٌ شُفْعَةٌ':Added, #1: 1	سُقُوطَ الشُّفْعَةِ
u'سُقُوطٌ شفعة':Added, #1: 1	سُقُوطَ الشُّفْعَةِ
u'سُقُوطٌ شُفْعَةٌ':Added, #2: 2	سُقُوطُ الشُّفْعَةِ
u'سُقُوطٌ شفعة':Added, #2: 2	سُقُوطُ الشُّفْعَةِ
u'سُقُوطٌ شُفْعَةٌ':Added, #2: 2	سُقُوطِ شُفْعَتِهِ
u'سُقُوطٌ شفعة':Added, #2: 2	سُقُوطِ شُفْعَتِهِ
u'سُقُوطٌ شُفْعَةٌ':Added, #3: 3	سُقُوطِ الشُّفْعَةِ
u'سُقُوطٌ شفق':Added, #3: 3	سُقُوطِ الشُّفْعَةِ
u'سُقُوطٌ شَفَقٌ':Added, #2: 2	سُقُوطِ الشَّفَقِ
u'سُقُوطٌ شَهَادَةٌ':Added, #2: 2	سُقُوطِ الشَّفَقِ
u'سُقُوطٌ شَهْوَةٌ':Added, #1: 1	سُقُوطَ الشَّهَادَةِ
u'سُقُوطٌ شَيْءٌ':Added, #1: 1	سُقُوطِ الشَّهْوَةِ
u'سُقُوطٌ شَيْءٌ':Added, #1: 1	سُقُوطَ الشَّيْءِ
u'سُقُوطٌ شَيْءٌ':Added, #1: 1	سُقُوطُ الشَّيْءِ
u'سُقُوطٌ شَيْءٌ':Added, #1: 1	سُقُوطِ الشَّيْءِ
u'سُقُوطٌ شَيْءٌ':Added, #2: 2	سُقُوطِ شَيْءٍ
u'سُقُوطٌ شَيْءٌ':Added, #3: 3	سُقُوطُ شَيْءٍ
u'سُقُوطٌ صَاحِبٌ':Added, #5: 5	سُقُوطَ شَيْءٍ
u'سُقُوطٌ صداق':Added, #1: 1	سُقُوطِ صَاحِبِهِ
u'سُقُوطٌ صَدَاقٌ':Added, #1: 1	سُقُوطَ الصَّدَاقِ
u'سُقُوطٌ صدقة':Added, #1: 1	سُقُوطَ الصَّدَاقِ
u'سُقُوطٌ صَدَقَةٌ':Added, #1: 1	سُقُوطَ صَدَقَةِ
u'سُقُوطٌ صَرْحٌ':Added, #1: 1	سُقُوطَ صَدَقَةِ
u'سُقُوطٌ صَلاَةٌ':Added, #1: 1	سُقُوطِ صَرْحِ
u'سُقُوطٌ صَلاَةٌ':Added, #1: 1	سُقُوطَ الصَّلَاةِ
u'سُقُوطٌ صَلاَةٌ':Added, #1: 1	سُقُوطُ صَلَاةِ
u'سُقُوطٌ صَوْمٌ':Added, #3: 3	سُقُوطُ الصَّلَاةِ
u'سُقُوطٌ ضَحِيَّةٌ':Added, #1: 1	سُقُوطِ الصَّوْمِ
u'سُقُوطٌ ضَمَانٌ':Added, #1: 1	سُقُوطُ الضَّحِيَّةِ
u'سُقُوطٌ ضَمَانٌ':Added, #10: 10	سُقُوطَ الضَّمَانِ
u'سُقُوطٌ ضَمَانٌ':Added, #1: 1	سُقُوطَ ضَمَانِ
u'سُقُوطٌ ضَمَانٌ':Added, #4: 4	سُقُوطِ الضَّمَانِ
u'سُقُوطٌ طَائِفٌ':Added, #7: 7	سُقُوطُ الضَّمَانِ
u'سُقُوطٌ طلب':Added, #1: 1	سُقُوطُ طَائِفَةٍ
u'سُقُوطٌ طَلَبٌ':Added, #2: 2	سُقُوطَ الطَّلَبِ
u'سُقُوطٌ طلب':Added, #2: 2	سُقُوطَ الطَّلَبِ
u'سُقُوطٌ طَلَبٌ':Added, #3: 3	سُقُوطُ الطَّلَبِ
u'سُقُوطٌ طلب':Added, #3: 3	سُقُوطُ الطَّلَبِ
u'سُقُوطٌ طَلَبٌ':Added, #4: 4	سُقُوطِ الطَّلَبِ
u'سُقُوطٌ عِبَادَةٌ':Added, #4: 4	سُقُوطِ الطَّلَبِ
u'سُقُوطٌ عَدَالَةٌ':Added, #2: 2	سُقُوطِ الْعِبَادَةِ
u'سُقُوطٌ عِدَّةٌ':Added, #1: 1	سُقُوطِ الْعَدَالَةِ
u'سُقُوطٌ عَدَدٌ':Added, #3: 3	سُقُوطِ الْعِدَّةِ
u'سُقُوطٌ عِشْرَةٌ':Added, #1: 1	سُقُوطُ الْعَدَدِ
u'سُقُوطٌ عِصْمَةٌ':Added, #1: 1	سُقُوطِ الْعِشْرَةِ
u'سُقُوطٌ عِصْمَةٌ':Added, #3: 3	سُقُوطَ الْعِصْمَةِ
u'سُقُوطٌ عِصْمَةٌ':Added, #3: 3	سُقُوطَ عِصْمَةِ
u'سُقُوطٌ عِصْمَةٌ':Added, #5: 5	سُقُوطِ الْعِصْمَةِ
u'سُقُوطٌ عقر':Added, #6: 6	سُقُوطُ الْعِصْمَةِ
u'سُقُوطٌ عُقْرٌ':Added, #1: 1	سُقُوطِ الْعُقْرِ
u'سُقُوطٌ عَلَقَةٌ':Added, #1: 1	سُقُوطِ الْعُقْرِ
u'سُقُوطٌ عمرة':Added, #1: 1	سُقُوطِ الْعَلَقَةِ
u'سُقُوطٌ عُمْرَةٌ':Added, #1: 1	سُقُوطُ الْعُمْرَةِ
u'سُقُوطٌ عِوَضٌ':Added, #1: 1	سُقُوطُ الْعُمْرَةِ
u'سُقُوطٌ غَايَةٌ':Added, #1: 1	سُقُوطُ الْعِوَضِ
u'سُقُوطٌ غَسْلٌ':Added, #1: 1	سُقُوطِ الْغَايَةِ
u'سُقُوطٌ غَسْلٌ':Added, #1: 1	سُقُوطَ غَسْلِ
u'سُقُوطٌ غَسْلٌ':Added, #1: 1	سُقُوطُ غَسْلِ
u'سُقُوطٌ غُسْلٌ':Added, #1: 1	سُقُوطَ غَسْلِهِ
u'سُقُوطٌ غُسْلٌ':Added, #1: 1	سُقُوطِ غُسْلِهِ
u'سُقُوطٌ غير':Added, #3: 3	سُقُوطَ الْغُسْلِ
u'سُقُوطٌ غَيْرٌ':Added, #1: 1	سُقُوطُ غَيْرِهِ
u'سُقُوطٌ فَاتِحٌ':Added, #1: 1	سُقُوطُ غَيْرِهِ
u'سُقُوطٌ فَاتِحَةٌ':Added, #1: 1	سُقُوطِ الْفَاتِحَةِ
u'سُقُوطٌ فَرْضٌ':Added, #1: 1	سُقُوطِ الْفَاتِحَةِ
u'سُقُوطٌ فَرْضٌ':Added, #1: 1	سُقُوطَ فَرْضٍ
u'سُقُوطٌ فَرْضٌ':Added, #1: 1	سُقُوطَ فَرْضِ
u'سُقُوطٌ فَرْضٌ':Added, #3: 3	سُقُوطُ فَرْضِ
u'سُقُوطٌ فَرْضٌ':Added, #4: 4	سُقُوطَ الْفَرْضِ
u'سُقُوطٌ فَرْضٌ':Added, #5: 5	سُقُوطِ فَرْضِ
u'سُقُوطٌ فَرْضٌ':Added, #7: 7	سُقُوطُ الْفَرْضِ
u'سُقُوطٌ فلان':Added, #9: 9	سُقُوطِ الْفَرْضِ
u'سُقُوطٌ قَبْضٌ':Added, #1: 1	سُقُوطِ رُكْنِيَّةِ
u'سُقُوطٌ قتل':Added, #2: 2	سُقُوطِ الْقَبْضِ
u'سُقُوطٌ قَتْلٌ':Added, #1: 1	سُقُوطِ الْقَتْلِ
u'سُقُوطٌ قَدْرٌ':Added, #1: 1	سُقُوطِ الْقَتْلِ
u'سُقُوطٌ قِرَانٌ':Added, #1: 1	سُقُوطَ قَدْرٍ
u'سُقُوطٌ قُرْصٌ':Added, #1: 1	سُقُوطَ الْقِرَانِ
u'سُقُوطٌ قَسَمٌ':Added, #1: 1	سُقُوطِ قُرْصِ
u'سُقُوطٌ قسمة':Added, #1: 1	سُقُوطُ الْقَسَمِ
u'سُقُوطٌ قِسْمَةٌ':Added, #1: 1	سُقُوطُ الْقِسْمَةِ
u'سُقُوطٌ قصاص':Added, #1: 1	سُقُوطُ الْقِسْمَةِ
u'سُقُوطٌ قِصَاصٌ':Added, #12: 12	سُقُوطِ الْقِصَاصِ
u'سُقُوطٌ قصاص':Added, #12: 12	سُقُوطِ الْقِصَاصِ
u'سُقُوطٌ قصاص':Added, #2: 2	سُقُوطَ الْقِصَاصِ
u'سُقُوطٌ قِصَاصٌ':Added, #2: 2	سُقُوطُ الْقِصَاصِ
u'سُقُوطٌ قِصَاصٌ':Added, #2: 2	سُقُوطَ الْقِصَاصِ
u'سُقُوطٌ قَصْرٌ':Added, #2: 2	سُقُوطُ الْقِصَاصِ
u'سُقُوطٌ قَضَاءٌ':Added, #1: 1	سُقُوطِ الْقَصْرِ
u'سُقُوطٌ قَضَاءٌ':Added, #11: 11	سُقُوطِ الْقَضَاءِ
u'سُقُوطٌ قَضَاءٌ':Added, #1: 1	سُقُوطُ قَضَاءِ
u'سُقُوطٌ قَضَاءٌ':Added, #7: 7	سُقُوطَ الْقَضَاءِ
u'سُقُوطٌ قَطْعٌ':Added, #7: 7	سُقُوطُ الْقَضَاءِ
u'سُقُوطٌ قَطْعٌ':Added, #1: 1	سُقُوطُ الْقَطْعِ
u'سُقُوطٌ قَوَد':Added, #4: 4	سُقُوطِ الْقَطْعِ
u'سُقُوطٌ قَوَد':Added, #1: 1	سُقُوطِ الْقَوَدِ
u'سُقُوطٌ قَوَد':Added, #2: 2	سُقُوطُ الْقَوَدِ
u'سُقُوطٌ قول':Added, #6: 6	سُقُوطَ الْقَوَدِ
u'سُقُوطٌ قول':Added, #1: 1	سُقُوطُ قَوْلِهِ
u'سُقُوطٌ قَوْلٌ':Added, #1: 1	سُقُوطِ قَوْلِهِ
u'سُقُوطٌ قَوْلٌ':Added, #1: 1	سُقُوطُ قَوْلِهِ
u'سُقُوطٌ قيام':Added, #1: 1	سُقُوطِ قَوْلِهِ
u'سُقُوطٌ قِيَامٌ':Added, #1: 1	سُقُوطُ الْقِيَامِ
u'سُقُوطٌ قيام':Added, #1: 1	سُقُوطُ الْقِيَامِ
u'سُقُوطٌ قِيَامٌ':Added, #1: 1	سُقُوطَ قِيَامِ
u'سُقُوطٌ قيام':Added, #1: 1	سُقُوطَ قِيَامِ
u'سُقُوطٌ قِيَامٌ':Added, #2: 2	سُقُوطَ الْقِيَامِ
u'سُقُوطٌ قِيمَةٌ':Added, #2: 2	سُقُوطَ الْقِيَامِ
u'سُقُوطٌ قِيمَةٌ':Added, #1: 1	سُقُوطُ الْقِيمَةِ
u'سُقُوطٌ كِتَابَةٌ':Added, #1: 1	سُقُوطِ قِيمَةِ
u'سُقُوطٌ كَفٌّ':Added, #2: 2	سُقُوطِ الْكِتَابَةِ
u'سُقُوطٌ كَفَّارٌ':Added, #1: 1	سُقُوطِ الْكَفِّ
u'سُقُوطٌ كَفَّارٌ':Added, #2: 2	سُقُوطَ الْكَفَّارَةِ
u'سُقُوطٌ كَفَّارَةٌ':Added, #4: 4	سُقُوطِ الْكَفَّارَةِ
u'سُقُوطٌ كَفَّارَةٌ':Added, #2: 2	سُقُوطَ الْكَفَّارَةِ
u'سُقُوطٌ كُلْفَةٌ':Added, #4: 4	سُقُوطِ الْكَفَّارَةِ
u'سُقُوطٌ لاَزِمٌ':Added, #2: 2	سُقُوطِ كُلْفَةٍ
u'سُقُوطٌ لَفْظٌ':Added, #1: 1	سُقُوطِ اللَّازِمِ
u'سُقُوطٌ لَفْظَةٌ':Added, #1: 1	سُقُوطِ لَفْظِ
u'سُقُوطٌ لَفْظَةٌ':Added, #1: 1	سُقُوطُ لَفْظَةٍ
u'سُقُوطٌ لهاة':Added, #1: 1	سُقُوطُ لَفْظَةِ
u'سُقُوطٌ لَهَاةٌ':Added, #1: 1	سُقُوطِ اللَّهَاةِ
u'سُقُوطٌ مَالٌ':Added, #1: 1	سُقُوطِ اللَّهَاةِ
u'سُقُوطٌ مَالِيٌّ':Added, #1: 1	سُقُوطِ الْمَالِ
u'سُقُوطٌ مَالِيٌّ':Added, #1: 1	سُقُوطِ الْمَالِيَّةِ
u'سُقُوطٌ مَانِعٌ':Added, #3: 3	سُقُوطُ الْمَالِيَّةِ
u'سُقُوطٌ مَائِعٌ':Added, #1: 1	سُقُوطِ الْمَانِعِ
u'سُقُوطٌ مَبِيتٌ':Added, #1: 1	سُقُوطِ مَائِعِ
u'سُقُوطٌ متبوع':Added, #2: 2	سُقُوطِ الْمَبِيتِ
u'سُقُوطٌ مُتْعَةٌ':Added, #1: 1	سُقُوطَ الْمَتْبُوعِ
u'سُقُوطٌ مَحَلٌّ':Added, #3: 3	سُقُوطِ الْمُتْعَةِ
u'سُقُوطٌ مَحْمَلٌ':Added, #1: 1	سُقُوطِ الْمَحَلِّ
u'سُقُوطٌ مُرَاعَاةٌ':Added, #1: 1	سُقُوطُ الْمَحْمَلِ
u'سُقُوطٌ مُرُوءةٌ':Added, #1: 1	سُقُوطِ مُرَاعَاةِ
u'سُقُوطٌ مَسْكَنٌ':Added, #2: 2	سُقُوطِ الْمُرُوءَةِ
u'سُقُوطٌ مَشْرُوطٌ':Added, #1: 1	سُقُوطِ الْمَسْكَنِ
u'سُقُوطٌ مَضْمَضَةٌ':Added, #1: 1	سُقُوطِ الْمَشْرُوطِ
u'سُقُوطٌ مُطَالَبٌ':Added, #1: 1	سُقُوطُ الْمَضْمَضَةِ
u'سُقُوطٌ مُطَالَبٌ':Added, #1: 1	سُقُوطَ الْمُطَالَبَةِ
u'سُقُوطٌ مُطَالَبٌ':Added, #1: 1	سُقُوطِ الْمُطَالَبَةِ
u'سُقُوطٌ مُطَالَبٌ':Added, #1: 1	سُقُوطَ مُطَالَبَةِ
u'سُقُوطٌ مُطَالَبٌ':Added, #1: 1	سُقُوطَ مُطَالَبَتِهِ
u'سُقُوطٌ مُطَالَبَةٌ':Added, #4: 4	سُقُوطُ الْمُطَالَبَةِ
u'سُقُوطٌ مُطَالَبَةٌ':Added, #1: 1	سُقُوطَ الْمُطَالَبَةِ
u'سُقُوطٌ مُطَالَبَةٌ':Added, #1: 1	سُقُوطِ الْمُطَالَبَةِ
u'سُقُوطٌ مُطَالَبَةٌ':Added, #1: 1	سُقُوطَ مُطَالَبَةِ
u'سُقُوطٌ مُطَالَبَةٌ':Added, #1: 1	سُقُوطَ مُطَالَبَتِهِ
u'سُقُوطٌ مَقَرٌّ':Added, #4: 4	سُقُوطُ الْمُطَالَبَةِ
u'سُقُوطٌ مِلْكٌ':Added, #1: 1	سُقُوطَ الْمَقَرِّ
u'سُقُوطٌ مِلْكٌ':Added, #1: 1	سُقُوطَ الْمِلْكِ
u'سُقُوطٌ مَنْزِلٌ':Added, #1: 1	سُقُوطُ مِلْكِ
u'سُقُوطٌ مَنْزِلَةٌ':Added, #1: 1	سُقُوطَ الْمَنْزِلِ
u'سُقُوطٌ مَهْرٌ':Added, #1: 1	سُقُوطِ الْمَنْزِلَةِ
u'سُقُوطٌ مَهْرٌ':Added, #1: 1	سُقُوطُ الْمَهْرِ
u'سُقُوطٌ مَهْرٌ':Added, #1: 1	سُقُوطِ مَهْرِ
u'سُقُوطٌ مَهْرٌ':Added, #7: 7	سُقُوطَ الْمَهْرِ
u'سُقُوطٌ مُوالاة':Added, #8: 8	سُقُوطِ الْمَهْرِ
u'سُقُوطٌ مُؤَذِّنٌ':Added, #1: 1	سُقُوطِ الْمُوَالَاةِ
u'سُقُوطٌ مَوْضِعٌ':Added, #1: 1	سُقُوطِ الْمُؤَذِّنِ
u'سُقُوطٌ مُؤَكَّدٌ':Added, #1: 1	سُقُوطِ مَوْضِعِ
u'سُقُوطٌ نَجَاسَةٌ':Added, #1: 1	سُقُوطِ الْمُؤَكَّدِ
u'سُقُوطٌ نَجَاسَةٌ':Added, #1: 1	سُقُوطُ نَجَاسَةِ
u'سُقُوطٌ نَجَاسَةٌ':Added, #2: 2	سُقُوطَ النَّجَاسَةِ
u'سُقُوطٌ نَجَاسَةٌ':Added, #2: 2	سُقُوطُ النَّجَاسَةِ
u'سُقُوطٌ نَجَاسَةٌ':Added, #2: 2	سُقُوطِ نَجَاسَةِ
u'سُقُوطٌ نَجْمٌ':Added, #5: 5	سُقُوطِ النَّجَاسَةِ
u'سُقُوطٌ نِصْفٌ':Added, #1: 1	سُقُوطُ نَجْمٍ
u'سُقُوطٌ نِصْفٌ':Added, #2: 2	سُقُوطِ النِّصْفِ
u'سُقُوطٌ نِصْفٌ':Added, #2: 2	سُقُوطَ نِصْفِ
u'سُقُوطٌ نَظَرٌ':Added, #8: 8	سُقُوطِ نِصْفِ
u'سُقُوطٌ نَفَقَةٌ':Added, #1: 1	سُقُوطَ النَّظَرِ
u'سُقُوطٌ نَفَقَةٌ':Added, #1: 1	سُقُوط النَّفَقَةِ
u'سُقُوطٌ نَفَقَةٌ':Added, #1: 1	سُقُوطُ نَفَقَتِهِ
u'سُقُوطٌ نَفَقَةٌ':Added, #2: 2	سُقُوطُ النَّفَقَةِ
u'سُقُوطٌ نَفَقَةٌ':Added, #2: 2	سُقُوطِ نَفَقَةِ
u'سُقُوطٌ نَفَقَةٌ':Added, #2: 2	سُقُوطِ نَفَقَتِهِ
u'سُقُوطٌ نَفَقَةٌ':Added, #8: 8	سُقُوطَ النَّفَقَةِ
u'سُقُوطٌ نَقْدٌ':Added, #8: 8	سُقُوطِ النَّفَقَةِ
u'سُقُوطٌ نَقْد':Added, #1: 1	سُقُوطَ نَقْدِ
u'سُقُوطٌ نِيَّةٌ':Added, #1: 1	سُقُوطَ نَقْدِ
u'سُقُوطٌ هَيْبَةٌ':Added, #1: 1	سُقُوطَ النِّيَّةِ
u'سُقُوطٌ وَاجِبٌ':Added, #1: 1	سُقُوطُ الْهَيْبَةِ
u'سُقُوطٌ وَاجِبٌ':Added, #1: 1	سُقُوطُ الْوَاجِبَاتِ
u'سُقُوطٌ وَاجِبٌ':Added, #3: 3	سُقُوطِ الْوَاجِبِ
u'سُقُوطٌ وَثِيقٌ':Added, #8: 8	سُقُوطُ الْوَاجِبِ
u'سُقُوطٌ وَجْهٌ':Added, #1: 1	سُقُوطِ الْوَثِيقَةِ
u'سُقُوطٌ وُجُوبٌ':Added, #1: 1	سُقُوطُ الْوَجْهِ
u'سُقُوطٌ وُجُوبٌ':Added, #1: 1	سُقُوطَ الْوُجُوبِ
u'سُقُوطٌ وُجُوبٌ':Added, #1: 1	سُقُوطَ وُجُوبِ
u'سُقُوطٌ وُجُوبٌ':Added, #2: 2	سُقُوطُ وُجُوبِ
u'سُقُوطٌ وُجُوبٌ':Added, #2: 2	سُقُوطِ وُجُوبِ
u'سُقُوطٌ وَرَقَةٌ':Added, #3: 3	سُقُوطِ الْوُجُوبِ
u'سُقُوطٌ وَصْفٌ':Added, #1: 1	سُقُوطِ الْوَرَقَةِ
u'سُقُوطٌ وَقْتٌ':Added, #1: 1	سُقُوطُ وَصْفٍ
u'سُقُوطٌ ولد':Added, #2: 2	سُقُوطِ الْوَقْتِ
u'سُقُوطٌ وَلَدٌ':Added, #1: 1	سُقُوطَ الْوَلَدِ
u'سُقُوطٌ وَلِيٌّ':Added, #1: 1	سُقُوطَ الْوَلَدِ
u'سُقُوطٌ يَدٌ':Added, #1: 1	سُقُوطُ الْوَلِيِّ
u'سُقُوطٌ يَدٌ':Added, #1: 1	سُقُوطَ الْيَدِ
u'سُقُوطٌ يَمِينٌ':Added, #1: 1	سُقُوطِ الْيَدِ
u'سُقُوفٌ جِيرَانٌ':Added, #1: 1	سُقُوطِ الْيَمِينِ
u'سُقُوفٌ دَارٌ':Added, #1: 1	سُقُوفِ الْجِيرَانِ
u'سُقُوفٌ دَارٌ':Added, #1: 1	سُقُوفُ الدَّارِ
u'سُقُوفٌ دُورٌ':Added, #1: 1	سُقُوفِ الدَّارِ
u'سَقْيٌ أَرَاضِي':Added, #2: 2	سُقُوفُ الدُّورِ
u'سَقَى أرْضٌ':Predicate, #1: 1	سَقْيِ الْأَرَاضِيِ
u'سَقَى أرْضٌ':Predicate, #3: 3	سَقَى أَرْضَ
u'سَقْيٌ أرْضٌ':Added, #4: 4	سَقَى الْأَرْضَ
u'سَقْيٌ أرْضٌ':Added, #1: 1	سَقْيُ أَرْضٍ
u'سَقْيٌ أرْضٌ':Added, #1: 1	سَقْيُ أَرْضِ
u'سَقْيٌ أرْضٌ':Added, #1: 1	سَقْيِ أَرْضٍ
u'سَقْيٌ أرْضٌ':Added, #1: 1	سَقْيَ الْأَرْضِ
u'سَقْيٌ أرْضٌ':Added, #2: 2	سَقْيَ أَرْضِ
u'سَقْيٌ أرْضٌ':Added, #2: 2	سَقْيِ أَرْضِ
u'سَقْيٌ أرْضٌ':Added, #2: 2	سَقْيُ أَرْضِهِ
u'سَقْيٌ أرْضٌ':Added, #3: 3	سَقْيَ أَرْضِهِ
u'سَقْيٌ أرْضٌ':Added, #3: 3	سَقْيُ الْأَرْضِ
u'سَقْيٌ أرْضٌ':Added, #6: 6	سَقْيِ أَرْضِهِ
u'سَقَى أَشْجَارٌ':Predicate, #8: 8	سَقْيِ الْأَرْضِ
u'سَقْيٌ أَشْجَارٌ':Added, #1: 1	سَقَى الْأَشْجَارَ
u'سَقَى أَوَّلُ':Subject, #2: 2	سَقْيِ الْأَشْجَارِ
u'سَقْيٌ بُسْتانٌ':Added, #2: 2	سَقَى الْأَوَّلُ
u'سَقْيٌ بَهيمٌ':Added, #2: 2	سَقْيُ الْبُسْتَانِ
u'سَقْيٌ بَهِيمَةٌ':Added, #1: 1	سَقْيُ الْبَهِيمَةِ
u'سَقْيٌ ثَمَرَةٌ':Added, #1: 1	سَقْيُ الْبَهِيمَةِ
u'سَقْيٌ ثَمَرَةٌ':Added, #1: 1	سَقْيِ الثَّمَرَةِ
u'سَقْيٌ ثَمَرَةٌ':Added, #2: 2	سَقْيُ ثَمَرَةٍ
u'سَقَى جَزِيرَةٌ':Predicate, #3: 3	سَقْيُ الثَّمَرَةِ
u'سَقْيٌ جَمِيع':Added, #1: 1	سَقَى الْجَزِيرَةَ
u'سَقْيٌ حادِثٌ':Added, #1: 1	سَقْيِ الْجَمِيعِ
u'سَقْيٌ حائِطٌ':Added, #1: 1	سَقْيِ الْحَادِثِ
u'سَقْيٌ حائِطٌ':Added, #1: 1	سَقْيُ الْحَائِطِ
u'سَقْيٌ حَديقَةٌ':Added, #1: 1	سَقْيِ الْحَائِطِ
u'سَقَى حِنْطَةٌ':Predicate, #1: 1	سَقْيِ الْحَدِيقَةِ
u'سَقْيٌ حَيَوَانٌ':Added, #1: 1	سَقَى الْحِنْطَةَ
u'سَقْيٌ دَابَّةٌ':Added, #1: 1	سَقْيُ حَيَوَانٍ
u'سَقْيٌ دَوَابُّ':Added, #1: 1	سَقْيُ الدَّابَّةِ
u'سَقْيٌ دَوَابُّ':Added, #1: 1	سَقْيُ الدَّوَابِّ
u'سَقْيٌ دَوَابُّ':Added, #2: 2	سَقْيَ الدَّوَابِّ
u'سَقْيٌ رَبُّ':Added, #2: 2	سَقْيِ الدَّوَابِّ
u'سَقَى رَبِيعٌ':Subject, #1: 1	سَقْيَ رَبِّ
u'سَقَى رَجُلٌ':Predicate, #3: 3	سَقَى الرَّبِيعُ
u'سَقَى رَجُلٌ':Subject, #1: 1	سَقَى رَجُلاً
u'سَقَى رَجُلٌ':Subject, #1: 1	سَقَى الرَّجُلُ
u'سَقَى زَرْعٌ':Predicate, #1: 1	سَقَى رَجُلٌ
u'سَقَى زَرْعٌ':Predicate, #1: 1	سَقَى الزَّرْعَ
u'سَقْيٌ زَرْعٌ':Added, #1: 1	سَقَى زَرْعَ
u'سَقْيٌ زَرْعٌ':Added, #1: 1	سَقْيِ الزَّرْعِ
u'سَقْيٌ زَرْعٌ':Added, #1: 1	سَقْيِ زَرْعِهِ
u'سَقْيٌ زَرْعٌ':Added, #2: 2	سَقْيُ الزَّرْعِ
u'سَقْيٌ سَخْلَة':Added, #2: 2	سَقْيِ زَرْعٍ
u'سَقْيٌ سِكِّينٌ':Added, #1: 1	سَقْيِ السَّخْلَةِ
u'سَقْيٌ سَمَاءٌ':Added, #1: 1	سَقْيِ السِّكِّينِ
u'سَقْيٌ سُيوحٌ':Added, #1: 1	سَقْيِ سَمَاءٍ
u'سَقَى شَاةٌ':Predicate, #1: 1	سَقْيُ السُّيُوحِ
u'سَقْيٌ شَجَرٌ':Added, #1: 1	سَقَى الشَّاةَ
u'سَقْيٌ شَجَرٌ':Added, #1: 1	سَقْيُ الشَّجَرِ
u'سَقْيٌ شَجَرٌ':Added, #1: 1	سَقْيِ الشَّجَرِ
u'سَقْيٌ شَجَرَةٌ':Added, #2: 2	سَقْيِ شَجَرٍ
u'سَقْيٌ شَيْءٌ':Added, #1: 1	سَقْيِ شَجَرَةٍ
u'سَقْيٌ صَبِيٌّ':Added, #1: 1	سَقْيُ شَيْءٍ
u'سَقْيٌ طَبِيبٌ':Added, #1: 1	سَقْيُ الصَّبِيِّ
u'سَقَى عَالِي':Predicate, #1: 1	سَقْيِ طَبِيبٍ
u'سَقْيٌ عَالِي':Added, #1: 1	سَقَى الْعَالِيَةَ
u'سَقْيٌ عَامِلٌ':Added, #1: 1	سَقْيُ الْعَالِيَةِ
u'سَقْيٌ عَامِلٌ':Added, #1: 1	سَقْيُ الْعَامِلِ
u'سَقَى عُمَرٌ':Predicate, #1: 1	سَقْيِ الْعَامِلِ
u'سَقَى غَرْبٌ':Subject, #1: 1	سَقَى عُمَرَ
u'سَقَى غير':Predicate, #2: 2	سَقَى الْغَرْبُ
u'سَقَى غَيْرٌ':Predicate, #1: 1	سَقَى غَيْرَ
u'سَقَى قَالٌ':Predicate, #1: 1	سَقَى غَيْرَ
u'سَقْيٌ كَلَأٌ':Added, #1: 1	سَقَى قَالَ
u'سَقَى كَلْبٌ':Predicate, #1: 1	سَقْيَ الْكَلَأِ
u'سَقْيٌ لبن':Added, #1: 1	سَقَى الْكَلْبَ
u'سَقْيٌ لَبَنٌ':Added, #1: 1	سَقْيُ اللَّبَنِ
u'سَقْيٌ مَاءٌ':Added, #1: 1	سَقْيُ اللَّبَنِ
u'سَقْيٌ مَاءٌ':Added, #2: 2	سَقْيَ الْمَاءِ
u'سَقْيٌ مَاءٌ':Added, #4: 4	سَقْيِ الْمَاءِ
u'سَقْيٌ مَاشِي':Added, #5: 5	سَقْيُ الْمَاءِ
u'سَقْيٌ مَاشِيَةٌ':Added, #1: 1	سَقْيَ مَاشِيَةٍ
u'سَقْيٌ مُرْتَفِعٌ':Added, #1: 1	سَقْيَ مَاشِيَةٍ
u'سَقْيٌ مَزَارِعُ':Added, #1: 1	سَقْيِ الْمُرْتَفِعِ
u'سَقْيٌ مِلْكٌ':Added, #1: 1	سَقْيِ الْمَزَارِعِ
u'سَقْيٌ مِلْكٌ':Added, #1: 1	سَقْيُ مِلْكِ
u'سَقْيٌ مواشي':Added, #2: 2	سَقْيِ مِلْكِهِ
u'سَقْيٌ مَوَاشِي':Added, #1: 1	سَقْيُ مَوَاشِيهِ
u'سَقْيٌ نبات':Added, #1: 1	سَقْيُ مَوَاشِيهِ
u'سَقْيٌ نَبَاتٌ':Added, #2: 2	سَقْيِ النَّبَاتِ
u'سَقْيٌ نَبِيٌّ':Added, #2: 2	سَقْيِ النَّبَاتِ
u'سَقْيٌ نَخْلٌ':Added, #1: 1	سَقْيِ النَّبِيِّ
u'سَقْيٌ نخلة':Added, #1: 1	سَقْيُ النَّخْلِ
u'سَقْيٌ نَخْلَةٌ':Added, #1: 1	سَقْيُ نَخْلَةٍ
u'سَقَى نِصْفٌ':Predicate, #1: 1	سَقْيُ نَخْلَةٍ
u'سَقْيٌ نَصِيبٌ':Added, #1: 1	سَقَى نِصْفَ
u'سَقْيٌ نَصِيبٌ':Added, #1: 1	سَقْيُ نَصِيبِ
u'سَكْبٌ أَنْهُرٌ':Added, #1: 1	سَقْيُ نَصِيبِهِ
u'سَكَبَ مُؤَذِّنٌ':Subject, #3: 3	سَكْبِ الْأَنْهُرِ
u'سَكَتَ أَبٌ':Subject, #1: 1	سَكَبَ الْمُؤَذِّنُ
u'سَكَتَ اِبْنٌ':Subject, #1: 1	سَكَتَ الْأَبُ
u'سَكَتَ أَصْحَابٌ':Subject, #1: 1	سَكَتَ ابْنُ
u'سَكَتَ إمَامٌ':Subject, #1: 1	سَكَتَ الْأَصْحَابُ
u'سَكَتَ آمِرٌ':Subject, #2: 2	سَكَتَ إمَامُهُ
u'سَكَتَ بَيْنٌ':Predicate, #1: 1	سَكَتَ الْآمِرُ
u'سَكَتَ جَازٌ':Predicate, #2: 2	سَكَتَ بَيْنَ
u'سَكَتَ جَاهِلٌ':Subject, #1: 1	سَكَتَ جَازَ
u'سَكَتَ جُمْهُورٌ':Subject, #1: 1	سَكَتَ الْجَاهِلُ
u'سَكَتَ حاكِمٌ':Subject, #1: 1	سَكَتَ الْجُمْهُورُ
u'سَكَتَ حالَةٌ':Predicate, #1: 1	سَكَتَ الْحَاكِمُ
u'سَكَتَ حَمِيل':Subject, #1: 1	سَكَتَ حَالَةَ
u'سَكَتَ خَصْمٌ':Subject, #1: 1	سَكَتَ الْحَمِيلُ
u'سَكَتَ دَلٌّ':Predicate, #1: 1	سَكَتَ الْخَصْمُ
u'سَكَتَ دَهْرٌ':Subject, #1: 1	سَكَتَ دَلَّ
u'سَكَتَ ذكر':Predicate, #1: 1	سَكَتَ الدَّهْرُ
u'سَكَتَ ذَكَرٌ':Predicate, #1: 1	سَكَتَ ذَكَرَ
u'سَكَتَ رَجُلٌ':Subject, #1: 1	سَكَتَ ذَكَرَ
u'سَكَتَ رَسُولٌ':Subject, #1: 1	سَكَتَ الرَّجُلُ
u'سَكَتَ زَوْجٌ':Subject, #1: 1	سَكَتَ رَسُولُ
u'سَكَتَ سَائِرٌ':Subject, #1: 1	سَكَتَ الزَّوْجُ
u'سَكَتَ شَارِعٌ':Subject, #1: 1	سَكَتَ سَائِرُ
u'سَكَتَ شَرْعٌ':Subject, #1: 1	سَكَتَ الشَّارِعُ
u'سَكَتَ طَالِبٌ':Subject, #1: 1	سَكَتَ الشَّرْعُ
u'سَكَتَ عَقِبٌ':Predicate, #1: 1	سَكَتَ الطَّالِبُ
u'سَكَتَ علماء':Subject, #1: 1	سَكَتَ عَقِبَ
u'سَكَتَ عُلَمَاءُ':Subject, #1: 1	سَكَتَ عُلَمَاءُ
u'سَكَتَ عند':Predicate, #1: 1	سَكَتَ عُلَمَاءُ
u'سَكَتَ فُرُوعٌ':Subject, #2: 2	سَكَتَ عِنْدَ
u'سَكَتَ فلان':Subject, #1: 1	سَكَتَ الْفُرُوعُ
u'سَكَتَ قَارِئٌ':Subject, #1: 1	سَكَتَ عُثْمَانُ
u'سَكَتَ قَالٌ':Predicate, #1: 1	سَكَتَ الْقَارِئُ
u'سَكَتَ مَالِكٌ':Subject, #3: 3	سَكَتَ قَالَ
u'سَكَتَ مُرْتَهِنٌ':Subject, #1: 1	سَكَتَ الْمَالِكُ
u'سَكَتَ مُصَنِّفٌ':Subject, #1: 1	سَكَتَ الْمُرْتَهِنُ
u'سَكَتَ مُعْتَرِضٌ':Subject, #25: 25	سَكَتَ الْمُصَنِّفُ
u'سَكَتَ مُؤَذِّنٌ':Subject, #1: 1	سَكَتَ الْمُعْتَرِضُ
u'سَكَتَ نَبِيٌّ':Subject, #8: 8	سَكَتَ الْمُؤَذِّنُ
u'سَكَتَ نَوَوِيٌّ':Subject, #2: 2	سَكَتَ النَّبِيُّ
u'سَكَتَ وقع':Predicate, #1: 1	سَكَتَ النَّوَوِيُّ
u'سَكَتَ وَكِيلٌ':Subject, #1: 1	سَكَتَ وَقَعَ
u'سكر أَنْهَارٌ':Added, #1: 1	سَكَتَ وَكِيلُ
u'سُكْرٌ أَنْهَارٌ':Added, #1: 1	سُكْرُ الْأَنْهَارِ
u'سكرة مَوْتٌ':Added, #1: 1	سُكْرُ الْأَنْهَارِ
u'سَكْرَةٌ مَوْتٌ':Added, #2: 2	سَكْرَةُ الْمَوْتِ
u'سكر خَمْرٌ':Added, #2: 2	سَكْرَةُ الْمَوْتِ
u'سكر خَمْرٌ':Added, #1: 1	سُكْرُ الْخَمْرِ
u'سُكْرٌ خَمْرٌ':Added, #1: 1	سُكْرِ الْخَمْرِ
u'سُكْرٌ خَمْرٌ':Added, #1: 1	سُكْرُ الْخَمْرِ
u'سَكِرَ ذِمِّيٌّ':Subject, #1: 1	سُكْرِ الْخَمْرِ
u'سكر عَقَارٌ':Added, #4: 4	سَكِرَ الذِّمِّيُّ
u'سُكْرٌ عَقَارٌ':Added, #1: 1	سُكْرِ الْعَقَارِ
u'سَكِرَ قَالٌ':Predicate, #1: 1	سُكْرِ الْعَقَارِ
u'سَكَرَ نَهْرٌ':Predicate, #3: 3	سَكِرَ قَالَ
u'سكر نَوْمٌ':Added, #2: 2	سَكَرَ النَّهْرَ
u'سُكْرٌ نَوْمٌ':Added, #1: 1	سُكْرِ النَّوْمِ
u'سَكِرَ وَكِيلٌ':Subject, #1: 1	سُكْرِ النَّوْمِ
u'سَكَنَ أَجْنَبِيٌّ':Subject, #1: 1	سَكِرَ الْوَكِيلُ
u'سَكَنَ أقَلُّ':Predicate, #2: 2	سَكَنَ أَجْنَبِيٌّ
u'سَكَنَ أقَلُّ':Subject, #1: 1	سَكَنَ أَقَلَّ
u'سَكَنَ أَكْثَرُ':Predicate, #1: 1	سَكَنَ الْأَقَلُّ
u'سَكَّنَ ألف':Predicate, #1: 1	سَكَنَ أَكْثَرَ
u'سَكَّنَ ألْفٌ':Predicate, #1: 1	سَكَّنَ الْأَلْفَ
u'سَكَّنَ أَلْفٌ':Predicate, #1: 1	سَكَّنَ الْأَلْفَ
u'سَكَنَ ألَمٌ':Subject, #1: 1	سَكَّنَ الْأَلْفَ
u'سَكَنَ أهْلٌ':Subject, #1: 1	سَكَنَ أَلَمُهُ
u'سَكَنَ أَوَّلُ':Subject, #1: 1	سَكَنَ أَهْلُ
u'سَكَنَ بادِي':Predicate, #1: 1	سَكَنَ أَوَّلُ
u'سَكَنَ بَادِيَةٌ':Predicate, #3: 3	سَكَنَ الْبَادِيَةَ
u'سَكَنَ بَعْضٌ':Predicate, #3: 3	سَكَنَ الْبَادِيَةَ
u'سَكَنَ بَعْضٌ':Subject, #1: 1	سَكَنَ بَعْضَ
u'سَكَنَ بَعْضٌ':Subject, #1: 1	سَكَنَ الْبَعْضُ
u'سَكَنَ ثَغْرٌ':Predicate, #2: 2	سَكَنَ بَعْضُ
u'سَكَنَ جِبَالٌ':Predicate, #1: 1	سَكَنَ الثَّغْرَ
u'سَكَنَ حَرْبٌ':Subject, #1: 1	سَكَنَ الْجِبَالَ
u'سَكَّنَ حَرْفٌ':Predicate, #1: 1	سَكَنَ الْحَرْبُ
u'سَكَنَ حِصَّةٌ':Subject, #1: 1	سَكَّنَ حَرْفَ
u'سَكَنَ دَارٌ':Predicate, #1: 1	سَكَنَ حِصَّتُهُ
u'سَكَنَ دَارٌ':Predicate, #10: 10	سَكَنَ الدَّارَ
u'سَكَنٌ دَارٌ':Added, #4: 4	سَكَنَ دَارَ
u'سَكَنَ دِمَشْقُ':Predicate, #1: 1	سَكَنَ دَارِهِ
u'سَكَنَ رَجُلٌ':Subject, #1: 1	سَكَنَ دِمَشْقَ
u'سَكَنَ رَجُلٌ':Subject, #1: 1	سَكَنَ الرَّجُلُ
u'سَكَنَ سُدَّةٌ':Predicate, #1: 1	سَكَنَ رَجُلٌ
u'سَكَنَ سَواءٌ':Subject, #1: 1	سَكَنَ السُّدَّةَ
u'سَكَنَ شَرِيكٌ':Subject, #1: 1	سَكَنَ سَوَاءٌ
u'سَكَنَ صَاحِبٌ':Subject, #1: 1	سَكَنَ الشَّرِيكُ
u'سَكَنَ صُدَاعٌ':Subject, #2: 2	سَكَنَ صَاحِبُ
u'سَكَنَ صُدَاعٌ':Subject, #1: 1	سَكَنَ الصُّدَاعُ
u'سَكَّنَ عَطَشٌ':Predicate, #1: 1	سَكَنَ صُدَاعُهُ
u'سَكَنَ غضب':Subject, #1: 1	سَكَّنَ الْعَطَشَ
u'سَكَنَ غَضَبٌ':Subject, #1: 1	سَكَنَ غَضَبُهُ
u'سَكَنَ غير':Predicate, #1: 1	سَكَنَ غَضَبُهُ
u'سَكَنَ غَيْرٌ':Predicate, #1: 1	سَكَنَ غَيْرَ
u'سَكَنَ فَقِيرٌ':Subject, #1: 1	سَكَنَ غَيْرَ
u'سَكَنَ فلان':Subject, #1: 1	سَكَنَ الْفَقِيرُ
u'سَكَنَ فُلاَنٌ':Subject, #1: 1	سَكَنَ عَقِيلٌ
u'سَكَنَ قَالٌ':Predicate, #1: 1	سَكَنَ فُلَانٌ
u'سَكَنَ قَلِيلٌ':Predicate, #1: 1	سَكَنَ قَالَ
u'سَكَنَ مَدِينٌ':Predicate, #1: 1	سَكَنَ الْقَلِيلَ
u'سَكَنَ مَدِينَةٌ':Predicate, #2: 2	سَكَنَ الْمَدِينَةَ
u'سَكَنَ مُرْتَهِنٌ':Subject, #2: 2	سَكَنَ الْمَدِينَةَ
u'سَكَنَ مُسْتَأْجِرٌ':Subject, #2: 2	سَكَنَ الْمُرْتَهِنُ
u'سَكَنٌ مُسْتَأْجِرٌ':Added, #7: 7	سَكَنَ الْمُسْتَأْجِرُ
u'سَكَنَ مِصْرٌ':Predicate, #1: 1	سَكَنُ الْمُسْتَأْجِرِ
u'سَكَنَ مَعْدِنٌ':Subject, #1: 1	سَكَنَ الْمِصْرَ
u'سَكَنَ مُنْتِنٌ':Subject, #1: 1	سَكَنَ الْمَعْدِنُ
u'سَكَنَ مَوْجٌ':Subject, #1: 1	سَكَنَ مُنْتِنُهُ
u'سَكَنَ مَوْضِعٌ':Predicate, #3: 3	سَكَنَ الْمَوْجُ
u'سَكَنَ نَصٌّ':Predicate, #1: 1	سَكَنَ الْمَوْضِعَ
u'سَكَنَ نِصْفٌ':Predicate, #1: 1	سَكَنَ نَصَّ
u'سَكَنَ نِصْفٌ':Predicate, #1: 1	سَكَنَ نِصْفَ
u'سَكَنَ نِصْفٌ':Subject, #2: 2	سَكَنَ النِّصْفَ
u'سَكَنَ نَظَرٌ':Subject, #1: 1	سَكَنَ النِّصْفُ
u'سَكَّنَ هاء':Predicate, #1: 1	سَكَنَ النَّظَرُ
u'سَكَنَ واحد':Subject, #1: 1	سَكَّنَ الْهَاءَ
u'سَكَنَ وَاحِدٌ':Subject, #2: 2	سَكَنَ وَاحِدٌ
u'سَكَنَ وَجَبٌ':Predicate, #2: 2	سَكَنَ وَاحِدٌ
u'سَكَنَ وَجَعٌ':Subject, #1: 1	سَكَنَ وَجَبَ
u'سُكْنَى أَبٌ':Added, #1: 1	سَكَنَ الْوَجَعُ
u'سُكْنَى أَشْهُرٌ':Added, #1: 1	سُكْنَى الْأَبِ
u'سُكْنَى أصل':Added, #1: 1	سُكْنَى الْأَشْهُرِ
u'سُكْنَى أًصْلٌ':Added, #1: 1	سُكْنَى الْأَصْلِ
u'سُكْنَى أُمٌّ':Added, #1: 1	سُكْنَى الْأَصْلِ
u'سُكْنَى بَعْضٌ':Added, #1: 1	سُكْنَى أُمِّ
u'سُكْنَى بَعيدٌ':Added, #1: 1	سُكْنَى بَعْضٍ
u'سُكْنَى بَقِيَّةٌ':Added, #1: 1	سُكْنَى الْبَعِيدِ
u'سُكْنَى بَلَدٌ':Added, #1: 1	سُكْنَى بَقِيَّةِ
u'سُكْنَى بَيْتٌ':Added, #1: 1	سُكْنَى بَلَدِ
u'سُكْنَى بَيْتٌ':Added, #1: 1	سُكْنَى الْبَيْتِ
u'سُكْنَى بُيُوتٌ':Added, #9: 9	سُكْنَى بَيْتٍ
u'سُكْنَى بُيُوتٌ':Added, #1: 1	سُكْنَى الْبُيُوتِ
u'سُكْنَى ثَلاثَةٌ':Added, #3: 3	سُكْنَى بُيُوتِ
u'سُكْنَى ثَلاثَةٌ':Added, #1: 1	سُكْنَى الثَّلَاثَةِ
u'سُكْنَى جِبَالٌ':Added, #1: 1	سُكْنَى ثَلَاثَةِ
u'سُكْنَى حاجٌّ':Added, #1: 1	سُكْنَى الْجِبَالِ
u'سُكْنَى حانوتٌ':Added, #1: 1	سُكْنَى الْحَاجِّ
u'سُكْنَى خَانٌ':Added, #1: 1	سُكْنَى الْحَانُوتِ
u'سُكْنَى دَارٌ':Added, #2: 2	سُكْنَى الْخَانِ
u'سُكْنَى دَارٌ':Added, #12: 12	سُكْنَى دَارِهِ
u'سُكْنَى دَارٌ':Added, #1: 1	سُكْنَى دَارَيْنِ
u'سُكْنَى دَارٌ':Added, #20: 20	سُكْنَى الدَّارِ
u'سُكْنَى دَارٌ':Added, #27: 27	سُكْنَى دَارٍ
u'سُكْنَى زَوْجٌ':Added, #2: 2	سُكْنَى دَارِ
u'سُكْنَى زَوْجَةٌ':Added, #2: 2	سُكْنَى الزَّوْجِ
u'سُكْنَى سَاعَةٌ':Added, #1: 1	سُكْنَى الزَّوْجَةِ
u'سُكْنَى سَاكِنٌ':Added, #1: 1	سُكْنَى سَاعَةٍ
u'سُكْنَى سُفْلٌ':Added, #2: 2	سُكْنَى السَّاكِنِ
u'سُكْنَى شَهْرٌ':Added, #2: 2	سُكْنَى السُّفْلِ
u'سُكْنَى غير':Added, #1: 1	سُكْنَى شَهْرَيْنِ
u'سُكْنَى غَيْرٌ':Added, #1: 1	سُكْنَى غَيْرِهِ
u'سُكْنَى فُلاَنٌ':Added, #1: 1	سُكْنَى غَيْرِهِ
u'سُكْنَى قَرْيَةٌ':Added, #2: 2	سُكْنَى فُلَانٍ
u'سُكْنَى قَوْمٌ':Added, #1: 1	سُكْنَى الْقَرْيَةِ
u'سُكْنَى مثل':Added, #1: 1	سُكْنَى قَوْمٍ
u'سُكْنَى مِثْلٌ':Added, #1: 1	سُكْنَى مِثْلِهِ
u'سُكْنَى مُحَكَّمٌ':Added, #1: 1	سُكْنَى مِثْلِهِ
u'سُكْنَى مَدْرَسَةٌ':Added, #1: 1	سُكْنَى مُحَكَّمٍ
u'سُكْنَى مَدِينٌ':Added, #1: 1	سُكْنَى الْمَدْرَسَةِ
u'سُكْنَى مَدِينَةٌ':Added, #6: 6	سُكْنَى الْمَدِينَةِ
u'سُكْنَى مُسْتَحَقٌّ':Added, #6: 6	سُكْنَى الْمَدِينَةِ
u'سُكْنَى مُطَلَّقٌ':Added, #1: 1	سُكْنَى الْمُسْتَحَقِّ
u'سُكْنَى مُعْتَدٌّ':Added, #1: 1	سُكْنَى الْمُطَلَّقَةِ
u'سُكْنَى مَكَانٌ':Added, #4: 4	سُكْنَى الْمُعْتَدَّةِ
u'سُكْنَى مَنْزِلٌ':Added, #1: 1	سُكْنَى الْمَكَانِ
u'سُكْنَى مَنْزِلٌ':Added, #1: 1	سُكْنَى الْمَنْزِلِ
u'سُكْنَى مَوْضِعٌ':Added, #1: 1	سُكْنَى مَنْزِلٍ
u'سُكْنَى مُوَكِّلٌ':Added, #1: 1	سُكْنَى مَوْضِعِهِ
u'سُكْنَى نَاسٌ':Added, #1: 1	سُكْنَى الْمُوَكِّلِ
u'سُكْنَى نَصْرَانِيٌّ':Added, #1: 1	سُكْنَى النَّاسِ
u'سُكْنَى نِصْفٌ':Added, #1: 1	سُكْنَى نَصْرَانِيٍّ
u'سُكْنَى نَصِيبٌ':Added, #1: 1	سُكْنَى نِصْفِ
u'سُكْنَى نَفْسٌ':Added, #1: 1	سُكْنَى نَصِيبِهِ
u'سُكْنَى هِبَةٌ':Added, #2: 2	سُكْنَى نَفْسِهِ
u'سُكْنَى واحد':Added, #1: 1	سُكْنَى هِبَةٍ
u'سُكْنَى وَاحِدٌ':Added, #5: 5	سُكْنَى وَاحِدٍ
u'سُكْنَى وَاقِفٌ':Added, #5: 5	سُكْنَى وَاحِدٍ
u'سُكْنَى وَقْفٌ':Added, #1: 1	سُكْنَى الْوَاقِفِ
u'سُكْنَى وَكِيلٌ':Added, #1: 1	سُكْنَى الْوَقْفِ
u'سُكْنَى ولد':Added, #1: 1	سُكْنَى الْوَكِيلِ
u'سُكْنَى وَلَدٌ':Added, #1: 1	سُكْنَى الْوَلَدِ
u'سُكْنَى ولد':Added, #1: 1	سُكْنَى الْوَلَدِ
u'سُكْنَى وَلَدٌ':Added, #4: 4	سُكْنَى وَلَدِهِ
u'سُكُوتٌ أَبٌ':Added, #4: 4	سُكْنَى وَلَدِهِ
u'سُكُوتٌ أَبٌ':Added, #1: 1	سُكُوتَ الْأَبِ
u'سُكُوتٌ أصل':Added, #1: 1	سُكُوتُ الْأَبِ
u'سُكُوتٌ أًصْلٌ':Added, #1: 1	سُكُوتِ الْأَصْلِ
u'سُكُوتٌ الْمَرْأَةُ':Added, #1: 1	سُكُوتِ الْأَصْلِ
u'سُكُوتٌ إمَامٌ':Added, #1: 1	سُكُوتَ الْمَرْأَةِ
u'سُكُوتٌ بِكْرٌ':Added, #2: 2	سُكُوتِ الْإِمَامِ
u'سُكُوتٌ بِكْرٌ':Added, #1: 1	سُكُوتُ بِكْرٍ
u'سُكُوتٌ بِكْرٌ':Added, #5: 5	سُكُوتَ الْبِكْرِ
u'سُكُوتٌ ثَيِّبٌ':Added, #5: 5	سُكُوتُ الْبِكْرِ
u'سُكُوتٌ ثَيِّبٌ':Added, #1: 1	سُكُوتُ الثَّيِّبِ
u'سُكُوتٌ جُمْهُورٌ':Added, #1: 1	سُكُوتِ الثَّيِّبِ
u'سُكُوتٌ خَوَاصُّ':Added, #1: 1	سُكُوتُ الْجُمْهُورِ
u'سُكُوتٌ خَوَاصّ':Added, #1: 1	سُكُوتُ الْخَوَاصِّ
u'سُكُوتٌ رَاهِنٌ':Added, #1: 1	سُكُوتُ الْخَوَاصِّ
u'سُكُوتٌ رَغْوَةٌ':Added, #1: 1	سُكُوتُ الرَّاهِنِ
u'سُكُوتٌ زَوْجٌ':Added, #1: 1	سُكُوتِ رَغْوَتِهِ
u'سُكُوتٌ زَوْجٌ':Added, #1: 1	سُكُوتَ الزَّوْجِ
u'سُكُوتٌ زَوْجٌ':Added, #1: 1	سُكُوتُ الزَّوْجِ
u'سُكُوتٌ سَاكِتٌ':Added, #1: 1	سُكُوتِ الزَّوْجِ
u'سُكُوتٌ شَارِعٌ':Added, #1: 1	سُكُوتِ السَّاكِتِ
u'سُكُوتٌ شَفِيعٌ':Added, #1: 1	سُكُوتَ الشَّارِعِ
u'سُكُوتٌ شَفِيعٌ':Added, #1: 1	سُكُوتُ الشَّفِيعِ
u'سُكُوتٌ شَيْخٌ':Added, #2: 2	سُكُوتِ الشَّفِيعِ
u'سُكُوتٌ صَاحِبٌ':Added, #2: 2	سُكُوتَ الشَّيْخَيْنِ
u'سُكُوتٌ صَحَابَةٌ':Added, #1: 1	سُكُوتُ صَاحِبِ
u'سُكُوتٌ عَالِمٌ':Added, #1: 1	سُكُوتِ الصَّحَابَةِ
u'سُكُوتٌ علماء':Added, #1: 1	سُكُوتِ الْعَالِمِ
u'سُكُوتٌ عُلَمَاءُ':Added, #1: 1	سُكُوتِ الْعُلَمَاءِ
u'سُكُوتٌ غُلاَمٌ':Added, #1: 1	سُكُوتِ الْعُلَمَاءِ
u'سُكُوتٌ غير':Added, #1: 1	سُكُوتِ الْغُلَامِ
u'سُكُوتٌ غَيْرٌ':Added, #1: 1	سُكُوتِ غَيْرِهِ
u'سُكُوتٌ فَرْعٌ':Added, #1: 1	سُكُوتِ غَيْرِهِ
u'سُكُوتٌ مَالِكٌ':Added, #1: 1	سُكُوتَ الْفَرْعِ
u'سُكُوتٌ مُتَكَلِّمٌ':Added, #1: 1	سُكُوتُ الْمَالِكِ
u'سُكُوتٌ مُصَنِّفٌ':Added, #1: 1	سُكُوتُ الْمُتَكَلِّمِ
u'سُكُوتٌ مُفَوَّضٌ':Added, #1: 1	سُكُوتُ الْمُصَنِّفِ
u'سُكُوتٌ مُوَكِّلٌ':Added, #1: 1	سُكُوتُ الْمُفَوَّضِ
u'سُكُوتٌ مُوَكِّلٌ':Added, #1: 1	سُكُوتَ الْمُوَكِّلِ
u'سُكُوتٌ مُوَكِّلٌ':Added, #1: 1	سُكُوتُ الْمُوَكِّلِ
u'سُكُوتٌ نَبِيٌّ':Added, #1: 1	سُكُوتِ الْمُوَكِّلِ
u'سُكُوتٌ وَصِيٌّ':Added, #3: 3	سُكُوتُ النَّبِيِّ
u'سُكُوتٌ وَكِيلٌ':Added, #1: 1	سُكُوتِ الْوَصِيِّ
u'سُكُوتٌ وَلِيٌّ':Added, #1: 1	سُكُوتُ الْوَكِيلِ
u'سُكُوتٌ يَسِيرٌ':Added, #1: 1	سُكُوتُ الْوَلِيِّ
u'سُكُونٌ ألَمٌ':Added, #1: 1	سُكُوتٍ يَسِيرٍ
u'سُكُونٌ ألَمٌ':Added, #1: 1	سُكُونَ الْأَلَمِ
u'سُكُونٌ ألَمٌ':Added, #1: 1	سُكُونِ الْأَلَمِ
u'سُكُونٌ باء':Added, #1: 1	سُكُونِ أَلَمِهِ
u'سُكُونٌ ضاد':Added, #1: 1	سُكُونُ الْبَاءِ
u'سُكُونٌ عين':Added, #1: 1	سُكُونِ الضَّادِ
u'سُكُونٌ عَيْنٌ':Added, #1: 1	سُكُونِ الْعَيْنِ
u'سُكُونٌ عَيْن':Added, #1: 1	سُكُونِ الْعَيْنِ
u'سُكُونٌ قلب':Added, #1: 1	سُكُونِ الْعَيْنِ
u'سُكُونٌ قلب':Added, #1: 1	سُكُونُ الْقَلْبِ
u'سُكُونٌ قَلْبٌ':Added, #1: 1	سُكُونِ الْقَلْبِ
u'سُكُونٌ قَلْبٌ':Added, #1: 1	سُكُونُ الْقَلْبِ
u'سُكُونٌ قَلْب':Added, #1: 1	سُكُونِ الْقَلْبِ
u'سُكُونٌ قَلْب':Added, #1: 1	سُكُونُ الْقَلْبِ
u'سُكُونٌ لاَمٌ':Added, #1: 1	سُكُونِ الْقَلْبِ
u'سُكُونٌ نَاسٌ':Added, #2: 2	سُكُونِ اللَّامِ
u'سُكُونٌ نفار':Added, #1: 1	سُكُونِ النَّاسِ
u'سُكُونٌ نِفَارٌ':Added, #1: 1	سُكُونِ نِفَارِهِ
u'سُكُونٌ نَفْسٌ':Added, #1: 1	سُكُونِ نِفَارِهِ
u'سُكُونٌ نَفْسٌ':Added, #1: 1	سُكُونَ النَّفْسِ
u'سُكُونٌ نَفْسٌ':Added, #2: 2	سُكُونِ نَفْسِهِ
u'سُكُونٌ نَفْسٌ':Added, #4: 4	سُكُونُ النَّفْسِ
u'سَلَا أُمٌّ':Predicate, #5: 5	سُكُونِ النَّفْسِ
u'سلام إمَامٌ':Added, #2: 2	سَلَا أُمَّ
u'سَلاَمٌ إمَامٌ':Added, #3: 3	سَلاَمِ الإِمَامِ
u'سَلاَمَةٌ بِنْتٌ':Added, #3: 3	سَلاَمِ الإِمَامِ
u'سَلْبٌ اِبْنٌ':Added, #1: 1	سَلاَمَةَ بِنْتِ
u'سلب أَجْرٌ':Predicate, #1: 1	سَلْبُ ابْنِ
u'سَلَبَ أَجْرٌ':Predicate, #1: 1	سَلَبَ الْأَجْرَ
u'سَلْبٌ أَحْكَامٌ':Added, #1: 1	سَلَبَ الْأَجْرَ
u'سَلْبٌ آدَمِيٌّ':Added, #1: 1	سَلْبِ أَحْكَامِهِ
u'سَلَبٌ أَسيرٌ':Added, #1: 1	سَلْبُ الْآدَمِيَّةِ
u'سلب إِمْكانٌ':Predicate, #1: 1	سَلَبِ الأَسِيرِ
u'سَلَبَ إِمْكانٌ':Predicate, #1: 1	سَلَبَ الْإِمْكَانَ
u'سَلْبٌ أَمْوَالٌ':Added, #1: 1	سَلَبَ الْإِمْكَانَ
u'سَلْبٌ إِنْسانٌ':Added, #2: 2	سَلْبِ الْأَمْوَالِ
u'سَلْبٌ إِنْسانٌ':Added, #1: 1	سَلْبَ الْإِنْسَانِ
u'سَلْبٌ أَهْلِيٌّ':Added, #1: 1	سَلْبِ الْإِنْسَانِ
u'سَلْبٌ أهْلِيَّةٌ':Added, #1: 1	سَلْبُ أَهْلِيَّةِ
u'سَلَبٌ أَوَّلُ':Added, #1: 1	سَلْبُ أَهْلِيَّةِ
u'سَلْبٌ إيمَانٌ':Added, #4: 4	سَلَبُ الْأَوَّلِ
u'سَلَبٌ براءٌ':Added, #1: 1	سَلْبُ الْإِيمَانِ
u'سَلَبٌ بَراءٌ':Added, #1: 1	سَلَبُ الْبَرَاءِ
u'سَلَبٌ براءٌ':Added, #1: 1	سَلَبُ الْبَرَاءِ
u'سَلَبٌ بَراءٌ':Added, #4: 4	سَلَبَ الْبَرَاءِ
u'سَلَبٌ بِطْريقٌ':Added, #4: 4	سَلَبَ الْبَرَاءِ
u'سَلْبٌ تَسْوِيَةٌ':Added, #1: 1	سَلَبَ الْبِطْرِيقِ
u'سَلْبٌ تَكاليفُ':Added, #1: 1	سَلْبِ التَّسْوِيَةِ
u'سَلْبٌ تَكالِيفُ':Added, #1: 1	سَلْبِ التَّكَالِيفِ
u'سَلْبٌ تَوَصُّلٌ':Added, #1: 1	سَلْبِ التَّكَالِيفِ
u'سَلْبٌ ثِيابٌ':Added, #1: 1	سَلْبَ التَّوَصُّلِ
u'سلب جُزْئِيٌّ':Predicate, #1: 1	سَلْبُ ثِيَابِهِ
u'سَلَبَ جُزْئِيٌّ':Predicate, #1: 1	سَلَبَ الْجُزْئِيَّ
u'سَلَبٌ جَوَازٌ':Added, #1: 1	سَلَبَ الْجُزْئِيَّ
u'سَلْبٌ جَوَازٌ':Added, #1: 1	سَلَبِ الْجَوَازِ
u'سَلْبٌ حَرَكَةٌ':Added, #1: 1	سَلْبِ الْجَوَازِ
u'سَلْبٌ حَرَكَةٌ':Added, #1: 1	سَلْبُ الْحَرَكَةِ
u'سَلْبٌ حُكْمٌ':Added, #3: 3	سَلْبِ الْحَرَكَةِ
u'سَلْبٌ حُكْمٌ':Added, #1: 1	سَلْبِ الْحُكْمِ
u'سلب خَمْرٌ':Predicate, #3: 3	سَلْبَ الْحُكْمِ
u'سَلَبَ خَمْرٌ':Predicate, #1: 1	سَلَبَ الْخَمْرَ
u'سَلَبٌ رَجُلٌ':Added, #1: 1	سَلَبَ الْخَمْرَ
u'سَلْبٌ سَائِرٌ':Added, #2: 2	سَلَبَ رَجُلٍ
u'سَلْبٌ سَبْقٌ':Added, #1: 1	سَلْبَ سَائِرِ
u'سَلْبٌ سَلْبٌ':Added, #1: 1	سَلْبِ سَبْقِ
u'سَلْبٌ شَرْعِيٌّ':Added, #1: 1	سَلْبَ السَّلْبِ
u'سَلْبٌ شَيْءٌ':Added, #1: 1	سَلْبُ شَرْعِيَّتِهِ
u'سَلَبٌ صُعْلُوكٌ':Added, #1: 1	سَلْبِ الشَّيْءِ
u'سَلْبٌ صِفَةٌ':Added, #1: 1	سَلَبِ الصُّعْلُوكِ
u'سلب ضَرَرٌ':Predicate, #1: 1	سَلْبُ الصِّفَةِ
u'سَلَبَ ضَرَرٌ':Predicate, #2: 2	سَلَبَ الضَّرَرَ
u'سَلْبٌ طَهُور':Added, #2: 2	سَلَبَ الضَّرَرَ
u'سَلْبٌ طَهُور':Added, #1: 1	سَلْبِ طَهُورِيَّةِ
u'سَلْبٌ طَهُور':Added, #2: 2	سَلْبَ الطَّهُورِيَّةِ
u'سَلْبٌ عَبْدٌ':Added, #3: 3	سَلْبُ الطَّهُورِيَّةِ
u'سَلْبٌ عَدَالَةٌ':Added, #1: 1	سَلْبُ الْعَبْدِ
u'سَلْبٌ عَدَمٌ':Added, #1: 1	سَلْبُ الْعَدَالَةِ
u'سَلْبٌ عِلَّةٌ':Added, #2: 2	سَلْبُ الْعَدَمِ
u'سَلْبٌ علم':Added, #2: 2	سَلْبُ الْعِلَّةِ
u'سَلْبٌ عِلْمٌ':Added, #1: 1	سَلْبِ الْعِلْمِ
u'سَلْبٌ عُمُومٌ':Added, #1: 1	سَلْبِ الْعِلْمِ
u'سَلْبٌ عُمُومٌ':Added, #1: 1	سَلْبُ عُمُومِ
u'سَلْبٌ عُمُومٌ':Added, #2: 2	سَلْبِ الْعُمُومِ
u'سَلْبٌ عُمُومٌ':Added, #3: 3	سَلْبَ الْعُمُومِ
u'سَلَبٌ قَاتِلٌ':Added, #4: 4	سَلْبُ الْعُمُومِ
u'سَلَبٌ قَتِيلٌ':Added, #2: 2	سَلَبُ الْقَاتِلِ
u'سَلَبٌ قَتِيلٌ':Added, #1: 1	سَلَبَ الْقَتِيلِ
u'سَلَبٌ قَتِيلٌ':Added, #1: 1	سَلَبُ قَتِيلِهِ
u'سَلَبٌ قَتِيلٌ':Added, #1: 1	سَلَبِ قَتِيلِهِ
u'سَلَبٌ قَتِيلٌ':Added, #2: 2	سَلَبِ الْقَتِيلِ
u'سَلَبٌ قَتِيلٌ':Added, #2: 2	سَلَبَ قَتِيلِهِ
u'سَلْبٌ قدرة':Added, #3: 3	سَلَبُ الْقَتِيلِ
u'سَلْبٌ قُدْرَةٌ':Added, #1: 1	سَلْبَ الْقُدْرَةِ
u'سلب قَلَنْسُوَةٌ':Predicate, #1: 1	سَلْبَ الْقُدْرَةِ
u'سَلَبَ قَلَنْسُوَةٌ':Predicate, #1: 1	سَلَبَ قَلَنْسُوَةَ
u'سلب قيام':Predicate, #1: 1	سَلَبَ قَلَنْسُوَةَ
u'سلب قِيَامٌ':Predicate, #1: 1	سَلَبَ الْقِيَامَ
u'سَلَبَ قيام':Predicate, #1: 1	سَلَبَ الْقِيَامَ
u'سَلَبَ قِيَامٌ':Predicate, #1: 1	سَلَبَ الْقِيَامَ
u'سَلْبٌ قيام':Added, #1: 1	سَلَبَ الْقِيَامَ
u'سَلْبٌ قيام':Added, #1: 1	سَلْبَ الْقِيَامِ
u'سَلْبٌ قِيَامٌ':Added, #1: 1	سَلْبُ الْقِيَامِ
u'سَلْبٌ قِيَامٌ':Added, #1: 1	سَلْبَ الْقِيَامِ
u'سَلْبٌ كُلِّيٌّ':Added, #1: 1	سَلْبُ الْقِيَامِ
u'سلب مَجْمُوعٌ':Predicate, #1: 1	سَلْبَ الْكُلِّيِّ
u'سَلَبَ مَجْمُوعٌ':Predicate, #1: 1	سَلَبَ الْمَجْمُوعَ
u'سلب مَحَلٌّ':Subject, #1: 1	سَلَبَ الْمَجْمُوعَ
u'سَلَبَ مَحَلٌّ':Subject, #1: 1	سَلَبَ مَحَلُّ
u'سَلَبٌ مَرْحَبٌ':Added, #1: 1	سَلَبَ مَحَلُّ
u'سَلَبٌ مَقْتُولٌ':Added, #1: 1	سَلَبَ مَرْحَبٍ
u'سَلَبٌ مَقْتُولٌ':Added, #1: 1	سَلَبِ مَقْتُولِهِ
u'سَلَبٌ مَقْتُولٌ':Added, #2: 2	سَلَبَ الْمَقْتُولِ
u'سَلْبٌ نَظَرٌ':Added, #2: 2	سَلَبِ الْمَقْتُولِ
u'سَلْبٌ نَفْسٌ':Added, #1: 1	سَلْبَ النَّظَرِ
u'سَلْبٌ نَفْسٌ':Added, #1: 1	سَلْبِ نَفْسِ
u'سَلْبٌ وِلاَيَةٌ':Added, #4: 4	سَلْبِ النَّفْسِ
u'سَلْبٌ وِلاَيَةٌ':Added, #1: 1	سَلْبَ وِلَايَتِهِ
u'سَلْبٌ وِلاَيَةٌ':Added, #2: 2	سَلْبِ الْوِلَايَةِ
u'سَلْبٌ وِلاَيَةٌ':Added, #2: 2	سَلْبَ وِلَايَةِ
u'سَلْبٌ وِلاَيَةٌ':Added, #2: 2	سَلْبُ وِلَايَتِهِ
u'سَلْبٌ وِلاَيَةٌ':Added, #3: 3	سَلْبِ وِلَايَتِهِ
u'سَلْبٌ وِلاَيَةٌ':Added, #4: 4	سَلْبُ الْوِلَايَةِ
u'سَلَتَ دَمٌ':Predicate, #4: 4	سَلْبِ وِلَايَةِ
u'سَلَتَ عَرَقٌ':Predicate, #3: 3	سَلَتَ الدَّمَ
u'سَلْحٌ عقاب':Added, #1: 1	سَلَتَ الْعَرَقَ
u'سَلْحٌ عُقَابٌ':Added, #1: 1	سَلْحَ الْعُقَابِ
u'سَلْخٌ أَدِيمٌ':Added, #1: 1	سَلْحَ الْعُقَابِ
u'سَلْخٌ بَهيمٌ':Added, #1: 1	سَلْخَ الْأَدِيمِ
u'سَلْخٌ بَهِيمَةٌ':Added, #1: 1	سَلْخِ الْبَهِيمَةِ
u'سَلَخَ جلد':Predicate, #1: 1	سَلْخِ الْبَهِيمَةِ
u'سَلَخَ جِلْدٌ':Predicate, #1: 1	سَلَخَ جِلْدَ
u'سَلْخٌ جلد':Added, #1: 1	سَلَخَ جِلْدَ
u'سَلْخٌ جِلْدٌ':Added, #2: 2	سَلْخُ الْجِلْدِ
u'سَلْخٌ حَيْضَةٌ':Added, #2: 2	سَلْخُ الْجِلْدِ
u'سَلَخَ دَابَّةٌ':Predicate, #1: 1	سَلْخِ حَيْضَةٍ
u'سَلَخَ سَنَةٌ':Predicate, #1: 1	سَلَخَ دَابَّةَ
u'سَلَخَ شَاةٌ':Predicate, #1: 1	سَلَخَ السَّنَةَ
u'سَلْخٌ شَاةٌ':Added, #1: 1	سَلَخَ الشَّاةَ
u'سَلْخٌ شَهْرٌ':Added, #1: 1	سَلْخِ شَاةٍ
u'سَلْخٌ شَهْرٌ':Added, #1: 1	سَلْخِ شَهْرِ
u'سَلْخٌ شَهْرٌ':Added, #3: 3	سَلْخَ شَهْرِ
u'سَلْخٌ طُهْرٌ':Added, #4: 4	سَلْخُ شَهْرِ
u'سَلَّ رَسُولٌ':Subject, #1: 1	سَلْخِ طُهْرٍ
u'سَلِسَ بَوْلٌ':Subject, #1: 1	سَلَّ رَسُولُ
u'سَلُسَ بَوْلٌ':Subject, #2: 2	سَلِسَ بَوْلُهُ
u'سَلَسٌ بَوْلٌ':Added, #3: 3	سَلُسَ بَوْلُهُ
u'سَلَسٌ بَوْلٌ':Added, #38: 38	سَلَسُ الْبَوْلِ
u'سَلَسٌ بَوْلٌ':Added, #3: 3	سَلَسَ الْبَوْلِ
u'سَلَسٌ بَوْلٌ':Added, #5: 5	سَلَسِ الْبَوْلِ
u'سَلَسٌ حَدْسٌ':Added, #5: 5	سَلَسُ بَوْلٍ
u'سَلَسٌ قَهْقَه':Added, #1: 1	سَلَسِ الْحَدْسِ
u'سَلَسٌ قَهْقَه':Added, #1: 1	سَلَسُ الْقَهْقَهَةِ
u'سَلَسٌ قَهْقَهَة':Added, #1: 1	سَلَسِ الْقَهْقَهَةِ
u'سَلَسٌ قَهْقَهَة':Added, #1: 1	سَلَسُ الْقَهْقَهَةِ
u'سَلَسٌ مَنِيٌّ':Added, #1: 1	سَلَسِ الْقَهْقَهَةِ
u'سَلَسٌ مَنِيٌّ':Added, #1: 1	سَلَسِ الْمَنِيِّ
u'سَلَّ سَيْفٌ':Predicate, #2: 2	سَلَسُ الْمَنِيِّ
u'سَلَّطَ رَاهِنٌ':Subject, #1: 1	سَلَّ سَيْفَ
u'سَلَّطَ زَوْجٌ':Predicate, #3: 3	سَلَّطَ الرَّاهِنُ
u'سَلَّطَ عَدْلٌ':Predicate, #1: 1	سَلَّطَ الزَّوْجَ
u'سَلَّطَ قَاضِي':Predicate, #1: 1	سَلَّطَ الْعَدْلَ
u'سَلَّطَ مُرْتَهِنٌ':Predicate, #1: 1	سَلَّطَ الْقَاضِيَ
u'سَلَّطَ مُرْتَهِنٌ':Subject, #1: 1	سَلَّطَ الْمُرْتَهِنَ
u'سَلَّطَ مُسْتَعِيرٌ':Subject, #1: 1	سَلَّطَ الْمُرْتَهِنُ
u'سَلْطَنَةٌ اِبْنٌ':Added, #1: 1	سَلَّطَ الْمُسْتَعِيرُ
u'سَلْطَنَةٌ بَيْعٌ':Added, #1: 1	سَلْطَنَةِ ابْنٍ
u'سَلْطَنَةٌ تَصَرُّفٌ':Added, #1: 1	سَلْطَنَةَ الْبَيْعِ
u'سَلْطَنَةٌ رجعة':Added, #1: 1	سَلْطَنَةَ التَّصَرُّفِ
u'سَلْطَنَةٌ رَجْعَةٌ':Added, #1: 1	سَلْطَنَةُ الرَّجْعَةِ
u'سَلْطَنَةٌ رُجُوعٌ':Added, #1: 1	سَلْطَنَةُ الرَّجْعَةِ
u'سَلْطَنَةٌ رَدٌّ':Added, #1: 1	سَلْطَنَةُ الرُّجُوعِ
u'سَلْطَنَةٌ رَدٌّ':Added, #1: 1	سَلْطَنَةُ الرَّدِّ
u'سَلْطَنَةٌ زَوْجٌ':Added, #1: 1	سَلْطَنَةِ الرَّدِّ
u'سَلْطَنَةٌ سَيِّدٌ':Added, #1: 1	سَلْطَنَةِ الزَّوْجِ
u'سَلْطَنَةٌ سَيِّدٌ':Added, #1: 1	سَلْطَنَةِ السَّيِّدِ
u'سَلْطَنَةٌ صَوْمٌ':Added, #1: 1	سَلْطَنَةِ سَيِّدِهِ
u'سَلْطَنَةٌ كَافِرٌ':Added, #1: 1	سَلْطَنَةُ الصَّوْمِ
u'سَلْطَنَةٌ مَلِكٌ':Added, #1: 1	سَلْطَنَةِ الْكَافِرِ
u'سَلْطَنَةٌ مَوْجُودٌ':Added, #1: 1	سَلْطَنَةِ الْمَلِكِ
u'سَلْطَنَةٌ نكاح':Added, #1: 1	سَلْطَنَةٍ مَوْجُودَةٍ
u'سَلْطَنَةٌ نِكَاحٌ':Added, #2: 2	سَلْطَنَةِ النِّكَاحِ
u'سَلْطَنَةٌ ولد':Added, #2: 2	سَلْطَنَةِ النِّكَاحِ
u'سَلْطَنَةٌ وَلَدٌ':Added, #2: 2	سَلْطَنَةِ الْوَلَدِ
u'سَلَّطَ وَكِيلٌ':Predicate, #2: 2	سَلْطَنَةِ الْوَلَدِ
u'سَلَفٌ أُجْرَةٌ':Added, #1: 1	سَلَّطَ الْوَكِيلَ
u'سَلَفٌ أحَدٌ':Added, #1: 1	سَلَفُ الْأُجْرَةِ
u'سَلَفَ أخْذٌ':Subject, #1: 1	سَلَفَ أَحَدِ
u'سَلَفٌ أُمَّةٌ':Added, #1: 1	سَلَفَ أَخْذُهُ
u'سَلَفٌ أُمَّةٌ':Added, #3: 3	سَلَفُ الْأُمَّةِ
u'سَلَّفَ بَائِعٌ':Predicate, #4: 4	سَلَفِ الْأُمَّةِ
u'سَلَفٌ بِكْرٌ':Added, #1: 1	سَلَّفَ الْبَائِعَ
u'سَلَفَ بَيَانٌ':Subject, #1: 1	سَلَفِ بِكْرٍ
u'سَلَفَ تَحْقِيقٌ':Subject, #4: 4	سَلَفَ بَيَانُهُ
u'سَلَفٌ زَريعَةٌ':Added, #1: 1	سَلَفَ تَحْقِيقُهُ
u'سَلَفٌ طعام':Added, #1: 1	سَلَفِ الزَّرِيعَةِ
u'سَلَفٌ طَعَامٌ':Added, #1: 1	سَلَفُ الطَّعَامِ
u'سَلَّفَ عَامِلٌ':Subject, #1: 1	سَلَفُ الطَّعَامِ
u'سَلَفٌ عَمَلٌ':Added, #1: 1	سَلَّفَ الْعَامِلُ
u'سَلَفٌ مَالٌ':Added, #1: 1	سَلَفُ عَمَلِهِ
u'سَلَفٌ مُقَوَّمٌ':Added, #1: 1	سَلَفُ مَالِهِ
u'سَلَفَ نَصٌّ':Subject, #1: 1	سَلَفُ مُقَوَّمٍ
u'سَلَفَ وَجْهٌ':Subject, #1: 1	سَلَفَ نَصُّهُ
u'سلق بيض':Added, #1: 1	سَلَفَ وَجْهُهُ
u'سَلْقٌ بيض':Added, #1: 1	سَلْقِ الْبَيْضِ
u'سَلَكَ أَبْعَدُ':Predicate, #1: 1	سَلْقِ الْبَيْضِ
u'سَلَكَ إضْمارٌ':Predicate, #4: 4	سَلَكَ أَبْعَدَ
u'سَلَكَ أقْرَبُ':Predicate, #1: 1	سَلَكَ الْإِضْمَارَ
u'سَلَكَ أقْصَرُ':Predicate, #1: 1	سَلَكَ الْأَقْرَبَ
u'سَلَكَ بَيْنٌ':Predicate, #2: 2	سَلَكَ الْأَقْصَرَ
u'سَلَكَ تَنَزُّلٌ':Predicate, #1: 1	سَلَكَ بَيْنَ
u'سَلَكَ جَادٌّ':Predicate, #1: 1	سَلَكَ التَّنَزُّلَ
u'سَلَكَ جَادَّةٌ':Predicate, #2: 2	سَلَكَ الْجَادَّةَ
u'سَلَكَ رَاهِبٌ':Subject, #2: 2	سَلَكَ الْجَادَّةَ
u'سَلَكَ سَبِيلٌ':Predicate, #2: 2	سَلَكَ رَاهِبٌ
u'سَلَكَ طَرِيقٌ':Predicate, #3: 3	سَلَكَ سَبِيلَ
u'سَلَكَ طَرِيقٌ':Predicate, #2: 2	سَلَكَ طَرِيقَ
u'سَلَكَ عَكْسٌ':Subject, #7: 7	سَلَكَ الطَّرِيقَ
u'سَلَكَ غير':Predicate, #1: 1	سَلَكَ عَكْسُ
u'سَلَكَ غَيْرٌ':Predicate, #1: 1	سَلَكَ غَيْرَ
u'سَلَكَ فَجٌّ':Predicate, #1: 1	سَلَكَ غَيْرَ
u'سَلَكَ فَرْشٌ':Predicate, #2: 2	سَلَكَ فَجَّ
u'سَلَكَ مُحَقِّقٌ':Subject, #1: 1	سَلَكَ الْفَرْشَ
u'سَلَكَ مَسَالِكُ':Predicate, #1: 1	سَلَكَ الْمُحَقِّقُ
u'سَلَكَ نَاسٌ':Subject, #1: 1	سَلَكَ مَسَالِكَ
u'سَلَكَ نَاسٌ':Subject, #1: 1	سَلَكَ النّاسُ
u'سَلَّمَ أَبٌ':Subject, #7: 7	سَلَكَ النَّاسُ
u'سَلِمَ اِبْنٌ':Predicate, #2: 2	سَلَّمَ الْأَبُ
u'سَلَّمَ اِبْنٌ':Subject, #1: 1	أَسْلَمَ ابْنَ
u'سَلَّمَ إِجْمَاعٌ':Predicate, #1: 1	سَلَّمَ ابْنُ
u'سَلِمَ أحَدٌ':Subject, #1: 1	سَلَّمَ الْإِجْمَاعَ
u'سَلَّمَ أحَدٌ':Subject, #1: 1	سَلِمَ أَحَدٌ
u'سَلَّمَ أَخٌ':Subject, #3: 3	سَلَّمَ أَحَدُ
u'سَلِمَ آدَمُ':Predicate, #1: 1	سَلَّمَ الْأَخُ
u'سَلِمَ إِشْكالٌ':Subject, #1: 1	أَسْلَمَ آدَمَ
u'سَلِمَ أصل':Subject, #1: 1	سَلِمَ الْإِشْكَالُ
u'سَلِمَ أًصْلٌ':Subject, #2: 2	سَلِمَ أَصْلُ
u'سَلَّمَ أَصيلٌ':Subject, #2: 2	سَلِمَ أَصْلُ
u'سَلَّمَ إِطْعامٌ':Predicate, #1: 1	سَلَّمَ الْأَصِيلُ
u'سَلَّمَ اِعْتِبارٌ':Predicate, #2: 2	سَلَّمَ الْإِطْعَامَ
u'سَلِمَ اِعْتِبارٌ':Subject, #1: 1	سَلَّمَ اعْتِبَارَ
u'سَلِمَ إِعْلاءٌ':Predicate, #1: 1	سَلِمَ اعْتِبَارُ
u'سَلِمَ أَكْثَرُ':Subject, #1: 1	أَسْلَمَ إعْلَاءَ
u'سَلَّمَ ألف':Predicate, #1: 1	سَلِمَ أَكْثَرُ
u'سَلَّمَ ألْفٌ':Predicate, #1: 1	سَلَّمَ الْأَلْفَ
u'سَلَّمَ أَلْفٌ':Predicate, #1: 1	سَلَّمَ الْأَلْفَ
u'سَلَّمَ أُمٌّ':Predicate, #1: 1	سَلَّمَ الْأَلْفَ
u'سَلَّمَ إمَامٌ':Subject, #1: 1	سَلَّمَ الْأُمَّ
u'سَلَّمَ إمَامٌ':Subject, #12: 12	سَلَّمَ إمَامُهُ
u'سَلَّمَ إمَامٌ':Subject, #1: 1	سَلَّمَ إمَامُ
u'سَلَّمَ إمَامٌ':Subject, #4: 4	سَلَّمَ إمَامٌ
u'سَلَّمَ إمَامٌ':Subject, #67: 67	سَلَّمَ الْإِمَامُ
u'سَلِمَ أمَةٌ':Predicate, #9: 9	سَلَّمَ الإِمَامُ
u'سَلَّمَ أمَةٌ':Predicate, #1: 1	أَسْلَمَ الْأَمَةَ
u'سَلَّمَ أَمْرٌ':Predicate, #1: 1	سَلَّمَ الْأَمَةَ
u'سَلَّمَ إِمْكانٌ':Predicate, #1: 1	سَلَّمَ الْأَمْرَ
u'سَلَّمَ أُمِّيٌّ':Subject, #1: 1	سَلَّمَ الْإِمْكَانَ
u'سَلِمَ اِنْتِفاء':Subject, #1: 1	سَلَّمَ الْأُمِّيُّ
u'سَلَّمَ إِنْسانٌ':Subject, #1: 1	سَلِمَ انْتِفَاءُ
u'سَلِمَ أَوَّلُ':Subject, #1: 1	سَلَّمَ إنْسَانٌ
u'سَلَّمَ باقِي':Predicate, #2: 2	سَلِمَ أَوَّلُهُ
u'سَلَّمَ بالِغٌ':Subject, #2: 2	سَلَّمَ الْبَاقِيَ
u'سَلَّمَ بالِغٌ':Subject, #1: 1	سَلَّمَ بَالِغٌ
u'سَلِمَ بَانٌ':Predicate, #3: 3	سَلَّمَ الْبَالِغُ
u'سَلَّمَ بَائِعٌ':Predicate, #3: 3	أَسْلَمَ بَانَ
u'سَلَّمَ بَائِعٌ':Subject, #1: 1	سَلَّمَ الْبَائِعَ
u'سَلَّمَ بَدَلٌ':Predicate, #12: 12	سَلَّمَ الْبَائِعُ
u'سَلِمَ بَطَلٌ':Predicate, #1: 1	سَلَّمَ الْبَدَلَ
u'سَلَّمَ بَعْضٌ':Predicate, #3: 3	أَسْلَمَ بَطَلَ
u'سَلَّمَ بَعْضٌ':Predicate, #2: 2	سَلَّمَ الْبَعْضَ
u'سَلَّمَ بَعْضٌ':Subject, #3: 3	سَلَّمَ بَعْضَ
u'سَلَّمَ بَقاءٌ':Predicate, #1: 1	سَلَّمَ بَعْضُ
u'سَلَّمَ بَقَرٌ':Predicate, #1: 1	سَلَّمَ بَقَاءَ
u'سَلَّمَ بَقِيَّةٌ':Subject, #1: 1	سَلَّمَ بَقَرَةً
u'سَلَّمَ بِنْتٌ':Predicate, #2: 2	سَلَّمَ بَقِيَّةُ
u'سَلِمَ بيض':Predicate, #2: 2	سَلَّمَ الْبِنْتَ
u'سَلَّمَ بَيْعٌ':Predicate, #7: 7	أَسْلَمَ بَيْضَ
u'سَلِمَ بَيْنٌ':Predicate, #3: 3	سَلَّمَ الْبَيْعَ
u'سَلِمَ تَزْوِيرٌ':Subject, #1: 1	أَسْلَمَ بَيْنَ
u'سَلَّمَ تَسْلِيم':Predicate, #1: 1	سَلِمَ التَّزْوِيرُ
u'سَلَّمَ تَسْلِيم':Predicate, #1: 1	سَلَّمَ التَّسْلِيمَةَ
u'سَلَّمَ تَعْيِينٌ':Predicate, #2: 2	سَلَّمَ تَسْلِيمَةً
u'سَلَّمَ تِلْقاءٌ':Predicate, #1: 1	سَلَّمَ تَعْيِينَ
u'سَلَّمَ تَنَاقُضٌ':Predicate, #3: 3	سَلَّمَ تِلْقَاءَ
u'سَلِمَ ثُبُوتٌ':Subject, #1: 1	سَلَّمَ التَّنَاقُضَ
u'سَلِمَ ثَلاثَةٌ':Subject, #1: 1	سَلِمَ ثُبُوتُهُ
u'سَلَّمَ ثَمَنٌ':Predicate, #1: 1	سَلِمَ ثَلَاثَةُ
u'سَلِمَ ثَمَنٌ':Subject, #11: 11	سَلَّمَ الثَّمَنَ
u'سَلَّمَ ثَوْبٌ':Predicate, #1: 1	سَلِمَ الثَّمَنُ
u'سَلَّمَ ثِيابٌ':Predicate, #4: 4	سَلَّمَ الثَّوْبَ
u'سَلَّمَ جَارٌ':Subject, #1: 1	سَلَّمَ ثِيَابَ
u'سَلَّمَ جَارِي':Predicate, #1: 1	سَلَّمَ الْجَارُ
u'سَلِمَ جَارِي':Predicate, #1: 1	سَلَّمَ الْجَارِيَةَ
u'سَلَّمَ جَارِيَةٌ':Predicate, #6: 6	أَسْلَمَ جَارِيَةً
u'سَلَّمَ جَازٌ':Predicate, #1: 1	سَلَّمَ الْجَارِيَةَ
u'سَلِمَ جَازٌ':Predicate, #2: 2	سَلَّمَ جَازَ
u'سَلَّمَ جُثَّة':Predicate, #6: 6	أَسْلَمَ جَازَ
u'سَلَّمَ جَسَدٌ':Predicate, #1: 1	سَلَّمَ الْجُثَّةَ
u'سَلَّمَ جُمْهُورٌ':Subject, #1: 1	سَلَّمَ الْجَسَدَ
u'سَلَّمَ حادٌّ':Subject, #1: 1	سَلَّمَ الْجُمْهُورُ
u'سَلَّمَ حاضِرٌ':Predicate, #1: 1	سَلَّمَ الْحَادُّ
u'سَلَّمَ حاضِرٌ':Subject, #1: 1	سَلَّمَ الْحَاضِرَ
u'سَلِمَ حالٌ':Predicate, #1: 1	سَلَّمَ الْحَاضِرُ
u'سَلَمَ حالٌ':Predicate, #1: 1	أَسْلَمَ حَالَ
u'سَلَّمَ حائِطٌ':Predicate, #1: 1	سَلَمَ حَالَ
u'سَلَّمَ حَدٌّ':Subject, #1: 1	سَلَّمَ الْحَائِطَ
u'سَلَّمَ حَديثٌ':Predicate, #1: 1	سَلَّمَ الْحَدُّ
u'سَلَّمَ حَسَنٌ':Subject, #1: 1	سَلَّمَ الْحَدِيثَ
u'سَلِمَ حَصْرٌ':Subject, #1: 1	سَلَّمَ الْحَسَنُ
u'سَلَّمَ حَطَبٌ':Predicate, #1: 1	سَلِمَ حَصْرُهُ
u'سَلَّمَ حَقِيقٌ':Predicate, #1: 1	سَلَّمَ الْحَطَبَ
u'سَلَّمَ حَقِيقَةٌ':Predicate, #1: 1	سَلَّمَ حَقِيقَةَ
u'سَلِمَ حُكْمٌ':Predicate, #1: 1	سَلَّمَ حَقِيقَةَ
u'سَلَّمَ حُكْمٌ':Predicate, #1: 1	أَسْلَمَ حُكْمَ
u'سَلِمَ حُكْمٌ':Subject, #1: 1	سَلَّمَ الْحُكْمَ
u'سَلِمَ حَلٌّ':Predicate, #1: 1	سَلِمَ الْحُكْمُ
u'سَلَّمَ حِمَارٌ':Predicate, #2: 2	أَسْلَمَ حَلَّ
u'سَلَّمَ حَمَّامٌ':Predicate, #1: 1	سَلَّمَ الْحِمَارَ
u'سَلِمَ حَمْلٌ':Subject, #1: 1	سَلَّمَ الْحَمَّامَ
u'سَلِمَ حِنْطَةٌ':Predicate, #1: 1	سَلِمَ الْحَمْلُ
u'سَلَّمَ خَارِجٌ':Predicate, #1: 1	أَسْلَمَ الْحِنْطَةَ
u'سَلَّمَ خَصْمٌ':Subject, #1: 1	سَلَّمَ الْخَارِجَ
u'سَلَّمَ خَلِيطٌ':Subject, #2: 2	سَلَّمَ الْخَصْمُ
u'سَلَّمَ خُمُسٌ':Predicate, #1: 1	سَلَّمَ الْخَلِيطُ
u'سَلِمَ خَمْسٌ':Predicate, #1: 1	سَلَّمَ الْخُمُسَ
u'سَلِمَ خَوْفٌ':Predicate, #2: 2	أَسْلَمَ خَمْسَ
u'سَلَّمَ دَابَّةٌ':Predicate, #1: 1	أَسْلَمَ خَوْفَ
u'سَلَّمَ دَاخِلٌ':Subject, #1: 1	سَلَّمَ الدَّابَّةَ
u'سَلَّمَ دَارٌ':Predicate, #1: 1	سَلَّمَ دَاخِلٌ
u'سَلَّمَ دَافِعٌ':Subject, #13: 13	سَلَّمَ الدَّارَ
u'سَلَّمَ دَخَلٌ':Predicate, #1: 1	سَلَّمَ الدَّافِعُ
u'سَلِمَ دَرَاهِمُ':Predicate, #1: 1	سَلَّمَ دَخَلَ
u'سَلِمَ دَرَاهِمُ':Predicate, #3: 3	أَسْلَمَ الدَّرَاهِمَ
u'سَلِمَ دَلالَةٌ':Subject, #6: 6	أَسْلَمَ دَرَاهِمَ
u'سَلَّمَ دَليلٌ':Predicate, #1: 1	سَلِمَ دَلَالَتُهُ
u'سَلَّمَ دَيْنٌ':Predicate, #1: 1	سَلَّمَ الدَّلِيلَ
u'سَلَّمَ ذاكِرٌ':Subject, #1: 1	سَلَّمَ الدَّيْنَ
u'سَلَّمَ ذِمِّيٌّ':Subject, #1: 1	سَلَّمَ ذَاكِرٌ
u'سَلَّمَ رَبُّ':Subject, #3: 3	سَلَّمَ الذِّمِّيُّ
u'سَلَّمَ رَجُلٌ':Subject, #2: 2	سَلَّمَ رَبُّ
u'سَلَّمَ رَدٌّ':Predicate, #4: 4	سَلَّمَ الرَّجُلُ
u'سَلِمَ رَدٌّ':Subject, #1: 1	سَلَّمَ رَدَّ
u'سَلِمَ رَسُولٌ':Predicate, #1: 1	سَلِمَ رَدُّهُ
u'سَلَّمَ رَسُولٌ':Subject, #1: 1	أَسْلَمَ رَسُولَ
u'سَلَّمَ رَمَكَة':Predicate, #10: 10	سَلَّمَ رَسُولُ
u'سَلَّمَ رَهْنٌ':Predicate, #1: 1	سَلَّمَ الرَّمَكَةَ
u'سَلَّمَ سَاكِتٌ':Subject, #2: 2	سَلَّمَ الرَّهْنَ
u'سَلِمَ سقط':Predicate, #1: 1	سَلَّمَ السَّاكِتُ
u'سَلِمَ سَقَطٌ':Predicate, #5: 5	أَسْلَمَ سَقَطَ
u'سَلِمَ سَيْفٌ':Predicate, #5: 5	أَسْلَمَ سَقَطَ
u'سَلِمَ شَاهِدٌ':Subject, #2: 2	أَسْلَمَ السَّيْفَ
u'سَلَّمَ شركاء':Subject, #1: 1	سَلِمَ شَاهِدٌ
u'سَلَّمَ شَرِيكٌ':Subject, #1: 1	سَلَّمَ شُرَكَاءُ
u'سَلَّمَ شَرِيكٌ':Subject, #10: 10	سَلَّمَ الشَّرِيكُ
u'سَلَّمَ شفعة':Predicate, #1: 1	سَلَّمَ شَرِيكُهُ
u'سَلَّمَ شُفْعَةٌ':Predicate, #1: 1	سَلَّمَ شُفْعَةَ
u'سَلَّمَ شفعة':Predicate, #1: 1	سَلَّمَ شُفْعَةَ
u'سَلَّمَ شُفْعَةٌ':Predicate, #31: 31	سَلَّمَ الشُّفْعَةَ
u'سَلَّمَ شَفِيعٌ':Subject, #31: 31	سَلَّمَ الشُّفْعَةَ
u'سَلِمَ شُمُول':Subject, #13: 13	سَلَّمَ الشَّفِيعُ
u'سَلَّمَ شُهُودٌ':Subject, #1: 1	سَلِمَ الشُّمُولُ
u'سَلَّمَ صَاحِبٌ':Subject, #1: 1	سَلَّمَ الشُّهُودُ
u'سَلَّمَ صَبِيٌّ':Subject, #2: 2	سَلَّمَ صَاحِبُ
u'سَلَّمَ صِحَّةٌ':Predicate, #1: 1	سَلَّمَ صَبِيٌّ
u'سَلَّمَ صِحَّةٌ':Predicate, #1: 1	سَلَّمَ الصِّحَّةَ
u'سَلِمَ صدق':Subject, #1: 1	سَلَّمَ صِحَّةَ
u'سَلِمَ صِدْقٌ':Subject, #1: 1	سَلِمَ صِدْقُهُ
u'سَلَّمَ صَغِيرٌ':Predicate, #1: 1	سَلِمَ صِدْقُهُ
u'سَلِمَ صَفْوَان':Predicate, #1: 1	سَلَّمَ الصَّغِيرَةَ
u'سَلَّمَ صُوفٌ':Predicate, #1: 1	أَسْلَمَ صَفْوَانَ
u'سَلِمَ ضَالٌّ':Predicate, #2: 2	سَلَّمَ الصُّوفَ
u'سَلِمَ عَادٌ':Predicate, #1: 1	أَسْلَمَ الضَّالَّةَ
u'سَلِمَ عَامٌ':Predicate, #2: 2	أَسْلَمَ عَادَ
u'سَلَّمَ عَبْدٌ':Predicate, #6: 6	أَسْلَمَ عَامَ
u'سَلَّمَ عَبْدٌ':Subject, #6: 6	سَلَّمَ الْعَبْدَ
u'سَلَّمَ عَبْدٌ':Subject, #1: 1	سَلَّمَ عَبْدٌ
u'سَلَّمَ عَبْدٌ':Subject, #3: 3	سَلَّمَ الْعَبْدُ
u'سَلِمَ عَبْدٌ':Subject, #3: 3	سَلَّمَ عَبْدُ
u'سَلَّمَ عَدْلٌ':Subject, #5: 5	سَلِمَ الْعَبْدُ
u'سَلَّمَ عَدَمٌ':Predicate, #2: 2	سَلَّمَ الْعَدْلُ
u'سَلِمَ عَدَمٌ':Subject, #2: 2	سَلَّمَ عَدَمَ
u'سَلَّمَ عرف':Subject, #3: 3	سَلِمَ عَدَمُ
u'سَلَّمَ عُرْفٌ':Subject, #1: 1	سَلَّمَ الْعُرْفُ
u'سَلِمَ عَشْرٌ':Predicate, #1: 1	سَلَّمَ الْعُرْفُ
u'سَلِمَ عصم':Predicate, #1: 1	أَسْلَمَ عَشْرَةَ
u'سَلَّمَ عَقَارٌ':Predicate, #2: 2	أَسْلَمَ عَصَمَ
u'سَلَّمَ عَقِبٌ':Predicate, #1: 1	سَلَّمَ الْعَقَارَ
u'سَلَّمَ عَمَلٌ':Predicate, #1: 1	سَلَّمَ عَقِبَ
u'سَلَّمَ عند':Predicate, #1: 1	سَلَّمَ الْعَمَلَ
u'سَلِمَ عند':Predicate, #1: 1	سَلَّمَ عِنْدَ
u'سَلَّمَ عِوَضٌ':Predicate, #5: 5	أَسْلَمَ عِنْدَ
u'سَلَّمَ عين':Predicate, #2: 2	سَلَّمَ الْعِوَضَ
u'سَلَّمَ عَيْنٌ':Predicate, #2: 2	سَلَّمَ الْعَيْنَ
u'سَلَّمَ عَيْن':Predicate, #2: 2	سَلَّمَ الْعَيْنَ
u'سَلَّمَ غَائِبٌ':Subject, #2: 2	سَلَّمَ الْعَيْنَ
u'سَلِمَ غَلَّةٌ':Predicate, #2: 2	سَلَّمَ الْغَائِبُ
u'سَلَّمَ غَلَّةٌ':Predicate, #1: 1	أَسْلَمَ الْغَلَّةَ
u'سَلِمَ غير':Predicate, #1: 1	سَلَّمَ الْغَلَّةَ
u'سَلِمَ غَيْرٌ':Predicate, #1: 1	أَسْلَمَ غَيْرَ
u'سَلَّمَ غير':Predicate, #1: 1	أَسْلَمَ غَيْرَ
u'سَلَّمَ غَيْرٌ':Predicate, #1: 1	سَلَّمَ غَيْرَ
u'سَلَّمَ فَزارَة':Subject, #1: 1	سَلَّمَ غَيْرَ
u'سَلَّمَ فُسْطَاطٌ':Predicate, #1: 1	سَلَّمَ فَزَارَةُ
u'سَلَّمَ فَضْلٌ':Predicate, #1: 1	سَلَّمَ الْفُسْطَاطَ
u'سَلَّمَ فلان':Subject, #1: 1	سَلَّمَ الْفَضْلَ
u'سَلِمَ فُلُوسٌ':Predicate, #1: 1	سَلَّمَ فَزَارَةُ
u'سَلِمَ قَالٌ':Predicate, #2: 2	أَسْلَمَ الْفُلُوسَ
u'سَلِمَ قَالٌ':Predicate, #1: 1	سَلِمَ قَالَ
u'سَلَّمَ قَالٌ':Predicate, #21: 21	أَسْلَمَ قَالَ
u'سَلِمَ قَبْضٌ':Subject, #25: 25	سَلَّمَ قَالَ
u'سَلَّمَ قطعة':Predicate, #1: 1	سَلِمَ قَبْضُ
u'سَلَّمَ قِطْعَةٌ':Predicate, #1: 1	سَلَّمَ الْقِطْعَةَ
u'سَلِمَ قول':Subject, #1: 1	سَلَّمَ الْقِطْعَةَ
u'سَلِمَ قَوْلٌ':Subject, #2: 2	سَلِمَ قَوْلُ
u'سَلَّمَ قَوْمٌ':Subject, #2: 2	سَلِمَ قَوْلُ
u'سَلِمَ قِيَاسٌ':Subject, #2: 2	سَلَّمَ الْقَوْمُ
u'سَلَّمَ كَفِيلٌ':Subject, #1: 1	سَلِمَ قِيَاسُ
u'سَلِمَ كَوْنٌ':Subject, #5: 5	سَلَّمَ الْكَفِيلُ
u'سَلَّمَ لَفْظٌ':Subject, #2: 2	سَلِمَ كَوْنُ
u'سَلَّمَ مَالٌ':Predicate, #1: 1	سَلَّمَ لَفْظُ
u'سَلِمَ مَالٌ':Subject, #6: 6	سَلَّمَ الْمَالَ
u'سَلَّمَ مَأْمُورٌ':Subject, #1: 1	سَلِمَ الْمَالُ
u'سَلَّمَ مَبِيعٌ':Predicate, #1: 1	سَلَّمَ الْمَأْمُورُ
u'سَلِمَ مَبِيعٌ':Predicate, #16: 16	سَلَّمَ الْمَبِيعَ
u'سَلَّمَ مَتَاعٌ':Predicate, #2: 2	أَسْلَمَ الْمَبِيعَ
u'سَلَّمَ مُتَطَوِّعٌ':Subject, #1: 1	سَلَّمَ الْمَتَاعَ
u'سَلَّمَ مُتَقَدِّمٌ':Predicate, #1: 1	سَلَّمَ الْمُتَطَوِّعُ
u'سَلِمَ مَحَلٌّ':Subject, #1: 1	سَلَّمَ الْمُتَقَدِّمَ
u'سَلَّمَ مَدْلُولٌ':Predicate, #1: 1	سَلِمَ الْمَحَلُّ
u'سَلَّمَ مَدْيُونٌ':Subject, #1: 1	سَلَّمَ مَدْلُولَ
u'سَلَّمَ مرٌّ':Predicate, #1: 1	سَلَّمَ الْمَدْيُونُ
u'سَلَّمَ مُرْتَهِنٌ':Subject, #1: 1	سَلَّمَ مَرَّةً
u'سَلَّمَ مَرْدُودٌ':Predicate, #1: 1	سَلَّمَ الْمُرْتَهِنُ
u'سَلِمَ مُرْسَلٌ':Predicate, #1: 1	سَلَّمَ الْمَرْدُودَ
u'سَلَّمَ مُسَافِرٌ':Subject, #1: 1	أَسْلَمَ مُرْسَلاً
u'سَلَّمَ مَسْأَلَةٌ':Predicate, #1: 1	سَلَّمَ مُسَافِرٌ
u'سَلَّمَ مَسْبُوق':Subject, #1: 1	سَلَّمَ الْمَسْأَلَةَ
u'سَلَّمَ مَسْجِدٌ':Predicate, #3: 3	سَلَّمَ الْمَسْبُوقُ
u'سَلَّمَ مُسْلِمٌ':Subject, #1: 1	سَلَّمَ الْمَسْجِدَ
u'سَلَّمَ مُسْلِمٌ':Subject, #1: 1	سَلَّمَ الْمُسْلِمُ
u'سَلَّمَ مُعْتَرِضٌ':Subject, #1: 1	سَلَّمَ مُسْلِمٌ
u'سَلَّمَ مَعْقُودٌ':Predicate, #1: 1	سَلَّمَ الْمُعْتَرِضُ
u'سَلَّمَ مَغْصُوب':Predicate, #1: 1	سَلَّمَ الْمَعْقُودَ
u'سَلَّمَ مُقَارَنٌ':Predicate, #1: 1	سَلَّمَ الْمَغْصُوبَ
u'سَلَّمَ مُقَارَنَةٌ':Predicate, #1: 1	سَلَّمَ مُقَارَنَةَ
u'سَلَّمَ مَقْبُوضٌ':Predicate, #1: 1	سَلَّمَ مُقَارَنَةَ
u'سَلَّمَ مَكْفُولٌ':Predicate, #2: 2	سَلَّمَ الْمَقْبُوضَ
u'سَلَّمَ مَكْفُولٌ':Subject, #3: 3	سَلَّمَ الْمَكْفُولَ
u'سَلَّمَ مِلْكٌ':Predicate, #6: 6	سَلَّمَ الْمَكْفُولُ
u'سَلَّمَ مَنْقُوض':Predicate, #1: 1	سَلَّمَ الْمِلْكَ
u'سَلَّمَ مَهْرٌ':Predicate, #1: 1	سَلَّمَ الْمَنْقُوضَ
u'سَلَّمَ مُوجِبٌ':Predicate, #1: 1	سَلَّمَ الْمَهْرَ
u'سَلَّمَ مُؤَجَّرٌ':Predicate, #1: 1	سَلَّمَ مُوجِبَ
u'سَلَّمَ مُؤَجِّرٌ':Subject, #1: 1	سَلَّمَ الْمُؤَجَّرَ
u'سَلَّمَ مُودَعٌ':Subject, #3: 3	سَلَّمَ الْمُؤَجِّرُ
u'سَلِمَ مَوْصُولٌ':Predicate, #1: 1	سَلَّمَ الْمُودَعُ
u'سَلَّمَ مُؤْمِنٌ':Subject, #1: 1	أَسْلَمَ مَوْصُولاً
u'سَلِمَ نَاسٌ':Subject, #1: 1	سَلَّمَ الْمُؤْمِنُ
u'سَلَّمَ نَاظِرٌ':Subject, #3: 3	سَلِمَ النَّاسُ
u'سَلَّمَ نَبِيٌّ':Subject, #1: 1	سَلَّمَ النَّاظِرُ
u'سَلِمَ نَخْلٌ':Predicate, #5: 5	سَلَّمَ النَّبِيُّ
u'سَلَّمَ نَصٌّ':Predicate, #1: 1	أَسْلَمَ النَّخْلَ
u'سَلَّمَ نِصْفٌ':Predicate, #1: 1	سَلَّمَ نَصَّ
u'سَلَّمَ نِصْفٌ':Predicate, #1: 1	سَلَّمَ النِّصْفَ
u'سَلِمَ نَصْلٌ':Predicate, #1: 1	سَلَّمَ نِصْفَ
u'سَلَّمَ نَظَرٌ':Predicate, #1: 1	أَسْلَمَ النَّصْلَ
u'سَلِمَ نَفَذٌ':Predicate, #1: 1	سَلَّمَ نَظَرَ
u'سَلَّمَ نَفْسٌ':Predicate, #8: 8	أَسْلَمَ نَفَذَ
u'سَلَّمَ نَفَقَةٌ':Predicate, #1: 1	سَلَّمَ نَفْسَ
u'سَلِمَ نقار':Predicate, #1: 1	سَلَّمَ النَّفَقَةَ
u'سَلِمَ نقرة':Predicate, #2: 2	أَسْلَمَ نُقَارَ
u'سَلِمَ نُقْرَةٌ':Predicate, #1: 1	أَسْلَمَ نُقْرَةَ
u'سَلَّمَ نَقْضٌ':Predicate, #1: 1	أَسْلَمَ نُقْرَةَ
u'سَلِمَ نُقُودٌ':Predicate, #1: 1	سَلَّمَ النَّقْضَ
u'سَلَّمَ واحد':Predicate, #1: 1	أَسْلَمَ النُّقُودَ
u'سَلَّمَ وَاحِدٌ':Predicate, #1: 1	سَلَّمَ وَاحِدَةً
u'سَلَّمَ واحد':Subject, #1: 1	سَلَّمَ وَاحِدَةً
u'سَلَّمَ وَاحِدٌ':Subject, #7: 7	سَلَّمَ وَاحِدٌ
u'سَلَّمَ وَاقِفٌ':Subject, #7: 7	سَلَّمَ وَاحِدٌ
u'سَلِمَ وَجَبٌ':Predicate, #1: 1	سَلَّمَ الْوَاقِفُ
u'سَلِمَ وُجُودٌ':Subject, #3: 3	أَسْلَمَ وَجَبَ
u'سَلَّمَ وَدِيعٌ':Predicate, #1: 1	سَلِمَ وُجُودُ
u'سَلَّمَ وَدِيعَةٌ':Predicate, #2: 2	سَلَّمَ الْوَدِيعَةَ
u'سَلِمَ وُقُوعٌ':Subject, #2: 2	سَلَّمَ الْوَدِيعَةَ
u'سَلَّمَ وَكِيلٌ':Subject, #1: 1	سَلِمَ وُقُوعُهُ
u'سَلَّمَ ولد':Predicate, #4: 4	سَلَّمَ الْوَكِيلُ
u'سَلَّمَ وَلَدٌ':Predicate, #2: 2	سَلَّمَ الْوَلَدَ
u'سَلِمَ ولد':Subject, #2: 2	سَلَّمَ الْوَلَدَ
u'سَلِمَ وَلَدٌ':Subject, #2: 2	سَلِمَ الْوَلَدُ
u'سَلَّمَ وَلِيٌّ':Subject, #2: 2	سَلِمَ الْوَلَدُ
u'سَلِمَ يَوْمٌ':Predicate, #1: 1	سَلَّمَ الْوَلِيُّ
u'سَلِمَ يَوْمٌ':Predicate, #1: 1	أَسْلَمَ الْيَوْمَ
u'سُلُوكٌ أحَدٌ':Added, #4: 4	أَسْلَمَ يَوْمَ
u'سُلُوك أحَدٌ':Added, #1: 1	سُلُوكِ أَحَدِ
u'سُلُوكٌ أدَب':Added, #1: 1	سُلُوكِ أَحَدِ
u'سُلُوكٌ أدَب':Added, #1: 1	سُلُوكُ الْأَدَبِ
u'سُلُوك أدَب':Added, #1: 1	سُلُوكِ الْأَدَبِ
u'سُلُوك أدَب':Added, #1: 1	سُلُوكُ الْأَدَبِ
u'سُلُوكٌ أرْضٌ':Added, #1: 1	سُلُوكِ الْأَدَبِ
u'سُلُوك أرْضٌ':Added, #1: 1	سُلُوكُ أَرْضِ
u'سُلُوكٌ أَطْوَلُ':Added, #1: 1	سُلُوكُ أَرْضِ
u'سُلُوك أَطْوَلُ':Added, #2: 2	سُلُوكُ أَطْوَلِ
u'سُلُوكٌ بَرٌّ':Added, #2: 2	سُلُوكُ أَطْوَلِ
u'سُلُوك بَرٌّ':Added, #1: 1	سُلُوكُ بَرٍّ
u'سُلُوكٌ جَادٌّ':Added, #1: 1	سُلُوكُ بَرٍّ
u'سُلُوك جَادٌّ':Added, #1: 1	سُلُوكِ جَادَّةِ
u'سُلُوكٌ جَادَّةٌ':Added, #1: 1	سُلُوكِ جَادَّةِ
u'سُلُوك جَادَّةٌ':Added, #1: 1	سُلُوكِ جَادَّةِ
u'سُلُوكٌ ذكر':Added, #1: 1	سُلُوكِ جَادَّةِ
u'سُلُوك ذكر':Added, #2: 2	سُلُوكِ الذَّكَرِ
u'سُلُوكٌ ذَكَرٌ':Added, #2: 2	سُلُوكِ الذَّكَرِ
u'سُلُوك ذَكَرٌ':Added, #2: 2	سُلُوكِ الذَّكَرِ
u'سُلُوكٌ سَابِلٌ':Added, #2: 2	سُلُوكِ الذَّكَرِ
u'سُلُوك سَابِلٌ':Added, #1: 1	سُلُوكُ السَّابِلَةِ
u'سُلُوكٌ سَبِيلٌ':Added, #1: 1	سُلُوكُ السَّابِلَةِ
u'سُلُوكٌ سَبِيلٌ':Added, #1: 1	سُلُوك سَبِيلِ
u'سُلُوكٌ سَبِيلٌ':Added, #1: 1	سُلُوكَ سَبِيلٍ
u'سُلُوك سَبِيلٌ':Added, #1: 1	سُلُوكِ سَبِيلِ
u'سُلُوك سَبِيلٌ':Added, #1: 1	سُلُوك سَبِيلِ
u'سُلُوك سَبِيلٌ':Added, #1: 1	سُلُوكَ سَبِيلٍ
u'سُلُوكٌ سَبِيلٌ':Added, #1: 1	سُلُوكِ سَبِيلِ
u'سُلُوك سَبِيلٌ':Added, #4: 4	سُلُوكَ سَبِيلِ
u'سُلُوكٌ سَواءٌ':Added, #4: 4	سُلُوكَ سَبِيلِ
u'سُلُوك سَواءٌ':Added, #1: 1	سُلُوكِ سَوَاءِ
u'سُلُوكٌ سِياسَةٌ':Added, #1: 1	سُلُوكِ سَوَاءِ
u'سُلُوك سِياسَةٌ':Added, #2: 2	سُلُوكُ السِّيَاسَةِ
u'سُلُوكٌ شَرْعِيٌّ':Added, #2: 2	سُلُوكُ السِّيَاسَةِ
u'سُلُوك شَرْعِيٌّ':Added, #1: 1	سُلُوكٍ شَرْعِيٍّ
u'سُلُوكٌ صِرَاطٌ':Added, #1: 1	سُلُوكٍ شَرْعِيٍّ
u'سُلُوك صِرَاطٌ':Added, #1: 1	سُلُوكِ صِرَاطِهِ
u'سُلُوكٌ صَوْبٌ':Added, #1: 1	سُلُوكِ صِرَاطِهِ
u'سُلُوك صَوْبٌ':Added, #1: 1	سُلُوكُ صَوْبِ
u'سُلُوكٌ طَرِيقٌ':Added, #1: 1	سُلُوكُ صَوْبِ
u'سُلُوكٌ طَرِيقٌ':Added, #1: 1	سُلُوكَ الطَّرِيقِ
u'سُلُوك طَرِيقٌ':Added, #1: 1	سُلُوكِ الطَّرِيقِ
u'سُلُوك طَرِيقٌ':Added, #1: 1	سُلُوكَ الطَّرِيقِ
u'سُلُوكٌ طَرِيقٌ':Added, #1: 1	سُلُوكِ الطَّرِيقِ
u'سُلُوك طَرِيقٌ':Added, #1: 1	سُلُوكُ طَرِيقٍ
u'سُلُوكٌ طَرِيقٌ':Added, #1: 1	سُلُوكُ طَرِيقٍ
u'سُلُوك طَرِيقٌ':Added, #2: 2	سُلُوكُ الطَّرِيقِ
u'سُلُوكٌ طَرِيقٌ':Added, #2: 2	سُلُوكُ الطَّرِيقِ
u'سُلُوكٌ طَرِيقٌ':Added, #2: 2	سُلُوكَ طَرِيقٍ
u'سُلُوك طَرِيقٌ':Added, #2: 2	سُلُوكَ طَرِيقِ
u'سُلُوك طَرِيقٌ':Added, #2: 2	سُلُوكَ طَرِيقٍ
u'سُلُوكٌ طَرِيقٌ':Added, #2: 2	سُلُوكَ طَرِيقِ
u'سُلُوكٌ طَرِيقٌ':Added, #3: 3	سُلُوكُ طَرِيقِ
u'سُلُوك طَرِيقٌ':Added, #3: 3	سُلُوكِ طَرِيقٍ
u'سُلُوك طَرِيقٌ':Added, #3: 3	سُلُوكُ طَرِيقِ
u'سُلُوكٌ طَرِيقٌ':Added, #3: 3	سُلُوكِ طَرِيقٍ
u'سُلُوك طَرِيقٌ':Added, #5: 5	سُلُوكِ طَرِيقِ
u'سُلُوكٌ طَرِيقَةٌ':Added, #5: 5	سُلُوكِ طَرِيقِ
u'سُلُوك طَرِيقَةٌ':Added, #1: 1	سُلُوكِ الطَّرِيقَةِ
u'سُلُوكٌ طَرِيقَةٌ':Added, #1: 1	سُلُوكِ الطَّرِيقَةِ
u'سُلُوك طَرِيقَةٌ':Added, #1: 1	سُلُوكِ طَرِيقَتِهِ
u'سُلُوكٌ عقبة':Added, #1: 1	سُلُوكِ طَرِيقَتِهِ
u'سُلُوك عقبة':Added, #1: 1	سُلُوكَ الْعَقَبَةِ
u'سُلُوكٌ عَقَبَةٌ':Added, #1: 1	سُلُوكَ الْعَقَبَةِ
u'سُلُوك عَقَبَةٌ':Added, #1: 1	سُلُوكَ الْعَقَبَةِ
u'سُلُوكٌ مَسْلَكٌ':Added, #1: 1	سُلُوكَ الْعَقَبَةِ
u'سُلُوك مَسْلَكٌ':Added, #1: 1	سُلُوكُ مَسْلَكِ
u'سُلُوكٌ نَفْسٌ':Added, #1: 1	سُلُوكُ مَسْلَكِ
u'سُلُوك نَفْسٌ':Added, #1: 1	سُلُوكَ النَّفْسِ
u'سُلُوكٌ نَفْسٌ':Added, #1: 1	سُلُوكَ النَّفْسِ
u'سُلُوك نَفْسٌ':Added, #1: 1	سُلُوكُ نَفْسِ
u'سُلُوكٌ يَقِينٌ':Added, #1: 1	سُلُوكُ نَفْسِ
u'سُلُوك يَقِينٌ':Added, #1: 1	سُلُوكِ الْيَقِينِ
u'سَمَاحَةٌ نَفْسٌ':Added, #1: 1	سُلُوكِ الْيَقِينِ
u'سَمَاعٌ اِبْنٌ':Added, #1: 1	سَمَاحَةُ النَّفْسِ
u'سَمَاعٌ اِبْنٌ':Added, #4: 4	سَمَاعَ ابْنِ
u'سَمَاعٌ اِبْنٌ':Added, #80: 80	سَمَاعِ ابْنِ
u'سَمَاعٌ أخْبَارٌ':Added, #9: 9	سَمَاعُ ابْنِ
u'سَمَاعٌ أَخْبَارٌ':Added, #1: 1	سَمَاعِ أَخْبَارِ
u'سَمَاعٌ أَذَانٌ':Added, #1: 1	سَمَاعِ أَخْبَارِ
u'سَمَاعٌ أَذَانٌ':Added, #2: 2	سَمَاعُ الْأَذَانِ
u'سَمَاعٌ اِسْمٌ':Added, #3: 3	سَمَاعِ الْأَذَانِ
u'سَمَاعٌ أَشْعَارٌ':Added, #3: 3	سَمَاعِ اسْمِهِ
u'سَمَاعٌ أَشْيَاءٌ':Added, #1: 1	سَمَاعَ الْأَشْعَارِ
u'سَمَاعٌ أَكْثَرُ':Added, #3: 3	سَمَاعِ الْأَشْيَاءِ
u'سَمَاعٌ أَمْرٌ':Added, #1: 1	سَمَاعُ الْأَكْثَرِ
u'سَمَاعٌ أَمْرٌ':Added, #1: 1	سَمَاعِ الْأَمْرِ
u'سَمَاعٌ إِنْشادٌ':Added, #1: 1	سَمَاعِ أَمْرِ
u'سَمَاعٌ إِنْعامٌ':Added, #1: 1	سَمَاعُ الْإِنْشَادِ
u'سَمَاعٌ أهْلٌ':Added, #1: 1	سَمَاعُ الْإِنْعَامِ
u'سَمَاعٌ أهْلٌ':Added, #1: 1	سَمَاعُ أَهْلِ
u'سَمَاعٌ أَوْتَارٌ':Added, #2: 2	سَمَاعِ أَهْلِ
u'سَمَاعٌ أَوْتَارٌ':Added, #1: 1	سَمَاعِ الْأَوْتَارِ
u'سَمَاعٌ أَوَّلُ':Added, #2: 2	سَمَاعُ الْأَوْتَارِ
u'سَمَاعٌ آيَةٌ':Added, #2: 2	سَمَاعُ أَوَّلِ
u'سَمَاعٌ آيَةٌ':Added, #1: 1	سَمَاعَ الْآيَةِ
u'سَمَاعٌ آيَةٌ':Added, #1: 1	سَمَاعُ آيَةِ
u'سَمَاعٌ آيَةٌ':Added, #1: 1	سَمَاعِ آيَةٍ
u'سَمَاعٌ بَاطِلٌ':Added, #1: 1	سَمَاعِ آيَةِ
u'سَمَاعٌ بَعْضٌ':Added, #1: 1	سَمَاعَ الْبَاطِلِ
u'سَمَاعٌ بَعْضٌ':Added, #1: 1	سَمَاعِ الْبَعْضِ
u'سَمَاعٌ بَيْعٌ':Added, #1: 1	سَمَاعِ بَعْضِ
u'سَمَاعٌ بَيِّنَةٌ':Added, #2: 2	سَمَاعِ الْبَيْعِ
u'سَمَاعٌ بَيِّنَةٌ':Added, #12: 12	سَمَاعُ الْبَيِّنَةِ
u'سَمَاعٌ بَيِّنَةٌ':Added, #1: 1	سَمَاعَ بَيِّنَةٍ
u'سَمَاعٌ بَيِّنَةٌ':Added, #1: 1	سَمَاعِ بَيِّنَةٍ
u'سَمَاعٌ بَيِّنَةٌ':Added, #1: 1	سَمَاعَ بَيِّنَتِهِ
u'سَمَاعٌ بَيِّنَةٌ':Added, #29: 29	سَمَاعِ الْبَيِّنَةِ
u'سَمَاعٌ بَيِّنَةٌ':Added, #2: 2	سَمَاعُ بَيِّنَةٍ
u'سَمَاعٌ بَيِّنَةٌ':Added, #2: 2	سَمَاعِ بَيِّنَةِ
u'سَمَاعٌ بَيِّنَةٌ':Added, #4: 4	سَمَاعِ بَيِّنَتِهِ
u'سَمَاعٌ تَبْدِيلٌ':Added, #8: 8	سَمَاعَ الْبَيِّنَةِ
u'سَمَاعٌ تَكْبيرٌ':Added, #1: 1	سَمَاعِ تَبْدِيلِ
u'سَمَاعٌ تَكْبيرٌ':Added, #1: 1	سَمَاعِ تَكْبِيرٍ
u'سَمَاعٌ تِلاوَةٌ':Added, #2: 2	سَمَاعِ التَّكْبِيرِ
u'سَمَاعٌ تَلْبيَةٌ':Added, #1: 1	سَمَاعِ التِّلَاوَةِ
u'سَمَاعٌ تَلْقيبٌ':Added, #2: 2	سَمَاعِ تَلْبِيَةِ
u'سَمَاعٌ جَرِيرٌ':Added, #1: 1	سَمَاعَ التّلْقِيبِ
u'سَمَاعٌ جُزْءٌ':Added, #1: 1	سَمَاعَ جَرِيرٍ
u'سَمَاعٌ جمعة':Added, #1: 1	سَمَاعِ جُزْءٍ
u'سَمَاعٌ جُمُعَةٌ':Added, #1: 1	سَمَاعِ الْجُمُعَةِ
u'سَمَاعٌ جَمِيع':Added, #1: 1	سَمَاعِ الْجُمُعَةِ
u'سَمَاعٌ جهر':Added, #1: 1	سَمَاعِ الْجَمِيعِ
u'سَمَاعٌ جَهْرٌ':Added, #1: 1	سَمَاعُ الْجَهْرِ
u'سَمَاعٌ حادِثٌ':Added, #1: 1	سَمَاعُ الْجَهْرِ
u'سَمَاعٌ حادِثٌ':Added, #1: 1	سَمَاعِ الْحَادِثَةِ
u'سَمَاعٌ حُجَّةٌ':Added, #1: 1	سَمَاعِ حَادِثَةٍ
u'سَمَاعٌ حُجَّةٌ':Added, #2: 2	سَمَاعَ الْحُجَّةِ
u'سَمَاعٌ حَديثٌ':Added, #3: 3	سَمَاعِ الْحُجَّةِ
u'سَمَاعٌ حَديثٌ':Added, #1: 1	سَمَاعِ الْحَدِيثِ
u'سَمَاعٌ حَسَنٌ':Added, #3: 3	سَمَاعُ الْحَدِيثِ
u'سَمَاعٌ حَسَنٌ':Added, #3: 3	سَمَاعُ الْحَسَنِ
u'سَمَاعٌ حَسَنٌ':Added, #4: 4	سَمَاعَ الْحَسَنِ
u'سَمَاعٌ حَقِيقٌ':Added, #5: 5	سَمَاعِ الْحَسَنِ
u'سَمَاعٌ حَقِيقَةٌ':Added, #2: 2	سَمَاعِ الْحَقِيقَةِ
u'سَمَاعٌ حَكَمٌ':Added, #2: 2	سَمَاعِ الْحَقِيقَةِ
u'سَمَاعٌ حُكْمٌ':Added, #1: 1	سَمَاعَ الْحَكَمِ
u'سَمَاعٌ خَبَرٌ':Added, #1: 1	سَمَاعُ الْحُكْمِ
u'سَمَاعٌ خَبَر':Added, #1: 1	سَمَاعِ الْخَبَرِ
u'سَمَاعٌ خُصُومَةٌ':Added, #1: 1	سَمَاعِ الْخَبَرِ
u'سَمَاعٌ خُصُومَةٌ':Added, #1: 1	سَمَاعِ خُصُومَةِ
u'سَمَاعٌ خُصُومَةٌ':Added, #1: 1	سَمَاعِ خُصُومَتِهِ
u'سَمَاعٌ خِطَابٌ':Added, #2: 2	سَمَاعِ الْخُصُومَةِ
u'سَمَاعٌ خِطَابٌ':Added, #1: 1	سَمَاعُ الْخِطَابِ
u'سَمَاعٌ خطبة':Added, #1: 1	سَمَاعِ خِطَابِهِ
u'سَمَاعٌ خُطْبَةٌ':Added, #2: 2	سَمَاعُ الْخُطْبَةِ
u'سَمَاعٌ خطبة':Added, #2: 2	سَمَاعُ الْخُطْبَةِ
u'سَمَاعٌ خُطْبَةٌ':Added, #3: 3	سَمَاعِ الْخُطْبَةِ
u'سَمَاعٌ خطبة':Added, #3: 3	سَمَاعِ الْخُطْبَةِ
u'سَمَاعٌ خُطْبَةٌ':Added, #5: 5	سَمَاعَ الْخُطْبَةِ
u'سَمَاعٌ خَيْرٌ':Added, #5: 5	سَمَاعَ الْخُطْبَةِ
u'سَمَاعٌ ذكر':Added, #2: 2	سَمَاعِ الْخَيْرِ
u'سَمَاعٌ ذِكْرٌ':Added, #5: 5	سَمَاعِ ذِكْرِهِ
u'سَمَاعٌ رَفَثِ':Added, #5: 5	سَمَاعِ ذِكْرِهِ
u'سَمَاعٌ رَفَث':Added, #1: 1	سَمَاعُ الرَّفَثِ
u'سَمَاعٌ زائِدٌ':Added, #1: 1	سَمَاعُ الرَّفَثِ
u'سَمَاعٌ زِيادَةٌ':Added, #1: 1	سَمَاعِ الزَّائِدَةِ
u'سَمَاعٌ زَيْدٌ':Added, #1: 1	سَمَاعِ الزِّيَادَةِ
u'سَمَاعٌ سَائِرٌ':Added, #1: 1	سَمَاعِ زَيْدٍ
u'سَمَاعٌ سُلْطَانٌ':Added, #1: 1	سَمَاعُ سَائِرِ
u'سَمَاعٌ سُنَّةٌ':Added, #1: 1	سَمَاعِ السُّلْطَانِ
u'سَمَاعٌ سُؤَالٌ':Added, #1: 1	سَمَاعُ السُّنَّةِ
u'سَمَاعٌ سَيِّدٌ':Added, #1: 1	سَمَاعَ سُؤَالِ
u'سَمَاعٌ شَاهِدٌ':Added, #1: 1	سَمَاعِ السَّيِّدِ
u'سَمَاعٌ شَاهِدٌ':Added, #1: 1	سَمَاعِ الشَّاهِدِ
u'سَمَاعٌ شَاهِدٌ':Added, #1: 1	سَمَاعِ الشَّاهِدَيْنِ
u'سَمَاعٌ شَهَادَةٌ':Added, #4: 4	سَمَاعُ الشَّاهِدَيْنِ
u'سَمَاعٌ شَهَادَةٌ':Added, #1: 1	سَمَاعَ شَهَادَةٍ
u'سَمَاعٌ شَهَادَةٌ':Added, #1: 1	سَمَاعُ شَهَادَتِهِ
u'سَمَاعٌ شَهَادَةٌ':Added, #3: 3	سَمَاعَ الشَّهَادَةِ
u'سَمَاعٌ شَهَادَةٌ':Added, #3: 3	سَمَاعُ الشَّهَادَةِ
u'سَمَاعٌ شَهَادَةٌ':Added, #3: 3	سَمَاعِ شَهَادَةٍ
u'سَمَاعٌ شَهَادَةٌ':Added, #4: 4	سَمَاعِ شَهَادَةِ
u'سَمَاعٌ شُهُودٌ':Added, #6: 6	سَمَاعِ الشَّهَادَةِ
u'سَمَاعٌ شُهُودٌ':Added, #1: 1	سَمَاعَ الشُّهُودِ
u'سَمَاعٌ شَيْءٌ':Added, #4: 4	سَمَاعُ الشُّهُودِ
u'سَمَاعٌ شَيْءٌ':Added, #1: 1	سَمَاعَ الشَّيْءِ
u'سَمَاعٌ شَيْءٌ':Added, #1: 1	سَمَاعَ شَيْءٍ
u'سَمَاعٌ شَيْخٌ':Added, #2: 2	سَمَاعِ شَيْءٍ
u'سَمَاعٌ شَيْخٌ':Added, #1: 1	سَمَاعُ الشَّيْخِ
u'سَمَاعٌ صَغِيرٌ':Added, #2: 2	سَمَاعِ الشَّيْخِ
u'سَمَاعٌ صَوْتٌ':Added, #1: 1	سَمَاعِ الصَّغِيرِ
u'سَمَاعٌ صَوْتٌ':Added, #1: 1	سَمَاعُ الصَّوْتِ
u'سَمَاعٌ صَوْتٌ':Added, #1: 1	سَمَاعِ الصَّوْتِ
u'سَمَاعٌ صَوْتٌ':Added, #1: 1	سَمَاعُ صَوْتٍ
u'سَمَاعٌ صَوْتٌ':Added, #3: 3	سَمَاعُ صَوْتِ
u'سَمَاعٌ صِيَاحٌ':Added, #5: 5	سَمَاعِ صَوْتِهِ
u'سَمَاعٌ طَبْلٌ':Added, #1: 1	سَمَاعِ صِيَاحِ
u'سَمَاعٌ عَامٌّ':Added, #1: 1	سَمَاعِ طَبْلٍ
u'سَمَاعٌ عَبْدٌ':Added, #3: 3	سَمَاعِ الْعَامِّ
u'سَمَاعٌ عَبْدٌ':Added, #1: 1	سَمَاعُ عَبْدِ
u'سَمَاعٌ عَدَدٌ':Added, #3: 3	سَمَاعِ عَبْدِ
u'سَمَاعٌ عَدَدٌ':Added, #1: 1	سَمَاعِ الْعَدَدِ
u'سَمَاعٌ عَطَاءٌ':Added, #2: 2	سَمَاعَ الْعَدَدِ
u'سَمَاعٌ عِلَّةٌ':Added, #1: 1	سَمَاعُ عَطَاءٍ
u'سَمَاعٌ علم':Added, #1: 1	سَمَاعِ الْعِلَّةِ
u'سَمَاعٌ عِلْمٌ':Added, #1: 1	سَمَاعِ الْعِلْمِ
u'سَمَاعٌ عَلِيٌّ':Added, #1: 1	سَمَاعِ الْعِلْمِ
u'سَمَاعٌ عُمُومٌ':Added, #1: 1	سَمَاعِ عَلِيٍّ
u'سَمَاعٌ عُمُومٌ':Added, #1: 1	سَمَاعِ الْعُمُومِ
u'سَمَاعٌ عُودٌ':Added, #1: 1	سَمَاعِ عُمُومِ
u'سَمَاعٌ غَالِبٌ':Added, #1: 1	سَمَاعَ الْعُودِ
u'سَمَاعٌ غَائِبٌ':Added, #1: 1	سَمَاعَ غَالِبٍ
u'سَمَاعٌ غناء':Added, #1: 1	سَمَاعِ الْغَائِبِ
u'سَمَاعٌ غِنَاءٌ':Added, #1: 1	سَمَاعِ الْغِنَاءِ
u'سَمَاعٌ غِنَاءٌ':Added, #1: 1	سَمَاعِ الْغِنَاءِ
u'سَمَاعٌ غناء':Added, #1: 1	سَمَاعِ غِنَاءٍ
u'سَمَاعٌ غِنَاءٌ':Added, #2: 2	سَمَاعُ الْغِنَاءِ
u'سَمَاعٌ غَيْبَةٌ':Added, #2: 2	سَمَاعُ الْغِنَاءِ
u'سَمَاعٌ غير':Added, #1: 1	سَمَاعِ الْغَيْبَةِ
u'سَمَاعٌ غَيْرٌ':Added, #1: 1	سَمَاعُ الْغَيْرِ
u'سَمَاعٌ غير':Added, #1: 1	سَمَاعُ الْغَيْرِ
u'سَمَاعٌ غَيْرٌ':Added, #1: 1	سَمَاعَ غَيْرِهِ
u'سَمَاعٌ غير':Added, #1: 1	سَمَاعَ غَيْرِهِ
u'سَمَاعٌ غَيْرٌ':Added, #2: 2	سَمَاعُ غَيْرِهِ
u'سَمَاعٌ فَأْلٌ':Added, #2: 2	سَمَاعُ غَيْرِهِ
u'سَمَاعٌ فُحْشٌ':Added, #1: 1	سَمَاعَ الْفَأْلِ
u'سَمَاعٌ فلان':Added, #1: 1	سَمَاعَ الْفُحْشِ
u'سَمَاعٌ فلان':Added, #1: 1	سَمَاعِ شُعَيْبٍ
u'سَمَاعٌ فلان':Added, #1: 1	سَمَاعِ شُعَيْبِ
u'سَمَاعٌ قَاتِلٌ':Added, #1: 1	سَمَاعَ مَكْحُولٍ
u'سَمَاعٌ قَارِئٌ':Added, #1: 1	سَمَاعُ الْقَاتِلِ
u'سَمَاعٌ قِرَاءةٌ':Added, #1: 1	سَمَاعِ الْقَارِئِ
u'سَمَاعٌ قُرْآنٌ':Added, #2: 2	سَمَاعِ قِرَاءَةِ
u'سَمَاعٌ قُرْآنٌ':Added, #1: 1	سَمَاعُ الْقُرْآنِ
u'سَمَاعٌ قُرْآنٌ':Added, #5: 5	سَمَاعَ الْقُرْآنِ
u'سَمَاعٌ قَرِينٌ':Added, #7: 7	سَمَاعِ الْقُرْآنِ
u'سَمَاعٌ قول':Added, #2: 2	سَمَاعِ الْقَرِينَيْنِ
u'سَمَاعٌ قَوْلٌ':Added, #1: 1	سَمَاعُ الْقَوْلِ
u'سَمَاعٌ قول':Added, #1: 1	سَمَاعُ الْقَوْلِ
u'سَمَاعٌ قَوْلٌ':Added, #1: 1	سَمَاعِ قَوْلِ
u'سَمَاعٌ قول':Added, #1: 1	سَمَاعِ قَوْلِ
u'سَمَاعٌ قَوْلٌ':Added, #2: 2	سَمَاعُ قَوْلِ
u'سَمَاعٌ قَيْنٌ':Added, #2: 2	سَمَاعُ قَوْلِ
u'سَمَاعٌ قَيْنَةٌ':Added, #1: 1	سَمَاعُ الْقَيْنَاتِ
u'سَمَاعٌ كَلاَمٌ':Added, #1: 1	سَمَاعُ الْقَيْنَاتِ
u'سَمَاعٌ كَلاَمٌ':Added, #1: 1	سَمَاعُ الْكَلَامِ
u'سَمَاعٌ كَلاَمٌ':Added, #1: 1	سَمَاعُ كَلَامِ
u'سَمَاعٌ كَلاَمٌ':Added, #1: 1	سَمَاعِ كَلَامِهِ
u'سَمَاعٌ كَلاَمٌ':Added, #3: 3	سَمَاعَ كَلَامِ
u'سَمَاعٌ كَلِمَةٌ':Added, #5: 5	سَمَاعِ كَلَامِ
u'سَمَاعٌ لَفْظٌ':Added, #1: 1	سَمَاعُ كَلِمَةِ
u'سَمَاعٌ مَبْسُوطٌ':Added, #7: 7	سَمَاعِ اللَّفْظِ
u'سَمَاعٌ مُتَصَوِّفٌ':Added, #1: 1	سَمَاعِ الْمَبْسُوطِ
u'سَمَاعٌ مُتَعَاقِدٌ':Added, #1: 1	سَمَاعُ الْمُتَصَوِّفَةِ
u'سَمَاعٌ مُجَاهِدٌ':Added, #1: 1	سَمَاعُ الْمُتَعَاقِدَيْنِ
u'سَمَاعٌ مُجَاهِدٌ':Added, #1: 1	سَمَاعَ مُجَاهِدٍ
u'سَمَاعٌ مُحَرَّمٌ':Added, #1: 1	سَمَاعِ مُجَاهِدٍ
u'سَمَاعٌ مُحَمَّدٌ':Added, #1: 1	سَمَاعِ مُحَرَّمٍ
u'سَمَاعٌ مُحَمَّدٌ':Added, #1: 1	سَمَاعِ مُحَمَّدٍ
u'سَمَاعٌ مَخْصُوصٌ':Added, #4: 4	سَمَاعِ مُحَمَّدِ
u'سَمَاعٌ مَدَافِعُ':Added, #1: 1	سَمَاعِ الْمَخْصُوصِ
u'سَمَاعٌ مُطْرِبٌ':Added, #1: 1	سَمَاعُ الْمَدَافِعِ
u'سَمَاعٌ مُقَيِّدٌ':Added, #1: 1	سَمَاعِ الْمُطْرِبَاتِ
u'سَمَاعٌ مَكْحُول':Added, #1: 1	سَمَاعِ الْمُقَيِّدِ
u'سَمَاعٌ مُكَلَّفٌ':Added, #1: 1	سَمَاعَ مَكْحُولٍ
u'سَمَاعٌ مَنْظُورٌ':Added, #1: 1	سَمَاعَ الْمُكَلَّفِ
u'سَمَاعٌ مَنْعٌ':Added, #1: 1	سَمَاعُ الْمَنْظُورِ
u'سَمَاعٌ مَوَاعِظُ':Added, #2: 2	سَمَاعُ الْمَنْعِ
u'سَمَاعٌ مَوْثُوقٌ':Added, #1: 1	سَمَاعِ الْمَوَاعِظِ
u'سَمَاعٌ مُؤَذِّنٌ':Added, #1: 1	سَمَاعِ مَوْثُوقٍ
u'سَمَاعٌ نَاسِخٌ':Added, #1: 1	سَمَاعُ الْمُؤَذِّنِ
u'سَمَاعٌ نَاسِخ':Added, #1: 1	سَمَاعِ النَّاسِخِ
u'سَمَاعٌ نِدَاءٌ':Added, #1: 1	سَمَاعِ النَّاسِخِ
u'سَمَاعٌ نِدَاءٌ':Added, #1: 1	سَمَاعِ نِدَاءِ
u'سَمَاعٌ نِدَاءٌ':Added, #2: 2	سَمَاعُ النِّدَاءِ
u'سَمَاعٌ نَفْسٌ':Added, #6: 6	سَمَاعِ النِّدَاءِ
u'سَمَاعٌ نكاح':Added, #1: 1	سَمَاعِ نَفْسِهِ
u'سَمَاعٌ نِكَاحٌ':Added, #1: 1	سَمَاعُ النِّكَاحِ
u'سَمَاعٌ هشام':Added, #1: 1	سَمَاعُ النِّكَاحِ
u'سَمَاعٌ هِشَامٌ':Added, #2: 2	سَمَاعَ هِشَامٍ
u'سَمَاعٌ وَعْظٌ':Added, #2: 2	سَمَاعَ هِشَامٍ
u'سَمَاعٌ وَلِيٌّ':Added, #1: 1	سَمَاعِ الْوَعْظِ
u'سِمَةٌ إمَامٌ':Added, #1: 1	سَمَاعَ الْوَلِيِّ
u'سِمَةٌ تَخْيِيرٌ':Added, #1: 1	سِمَةُ الْإِمَامِ
u'سِمَةٌ خَسَاسَةٌ':Added, #1: 1	سِمَةُ التَّخْيِيرِ
u'سِمَةٌ شرب':Added, #1: 1	سِمَةِ خَسَاسَةِ
u'سِمَةٌ شُرْبٌ':Added, #1: 1	سِمَةَ الشُّرْبِ
u'سِمَةٌ عجز':Added, #1: 1	سِمَةَ الشُّرْبِ
u'سِمَةٌ عَجْزٌ':Added, #1: 1	سِمَةُ الْعَجْزِ
u'سِمَةٌ عَدَالَةٌ':Added, #1: 1	سِمَةُ الْعَجْزِ
u'سِمَةٌ فِسْقٌ':Added, #1: 1	سِمَةِ الْعَدَالَةِ
u'سِمَةٌ قدرة':Added, #1: 1	سِمَةُ الْفِسْقِ
u'سِمَةٌ قُدْرَةٌ':Added, #1: 1	سِمَةُ الْقُدْرَةِ
u'سَمْتٌ أَصْلِيٌّ':Added, #1: 1	سِمَةُ الْقُدْرَةِ
u'سَمْتٌ أهْلٌ':Added, #1: 1	سَمْتِ الْأَصْلِيَّةِ
u'سَمْتٌ بِنَاءٌ':Added, #1: 1	سَمْتِ أَهْلِ
u'سَمْتٌ جِهَةٌ':Added, #1: 1	سَمْتِ الْبِنَاءِ
u'سَمْتٌ حَسَنٌ':Added, #1: 1	سَمْتُ الْجِهَةِ
u'سَمْتٌ ذِراعٌ':Added, #2: 2	سَمْتٍ حَسَنٍ
u'سَمْتٌ سَاقٌ':Added, #1: 1	سَمْتِ الذِّرَاعِ
u'سَمْتٌ علماء':Added, #1: 1	سَمْتِ السَّاقِ
u'سَمْتٌ عُلَمَاءُ':Added, #1: 1	سَمْتِ الْعُلَمَاءِ
u'سَمْتٌ قِبْلَةٌ':Added, #1: 1	سَمْتِ الْعُلَمَاءِ
u'سَمْتٌ قَصْدٌ':Added, #1: 1	سَمْتِ الْقِبْلَةِ
u'سَمْتٌ كعبة':Added, #1: 1	سَمْتِ الْقَصْدِ
u'سَمْتٌ كَعْبَةٌ':Added, #1: 1	سَمْتِ الْكَعْبَةِ
u'سَمْتٌ كَفٌّ':Added, #1: 1	سَمْتِ الْكَعْبَةِ
u'سَمْتٌ واحد':Added, #1: 1	سَمْتِ الْكَفِّ
u'سَمْتٌ وَاحِدٌ':Added, #1: 1	سَمْتٍ وَاحِدٍ
u'سَمَحَ اِبْنٌ':Subject, #1: 1	سَمْتٍ وَاحِدٍ
u'سَمَحَ أحَدٌ':Subject, #1: 1	سَمَحَ ابْنُ
u'سَمَّرَ بَابٌ':Predicate, #1: 1	سَمَحَ أَحَدٌ
u'سَمْطٌ حكمة':Added, #1: 1	سَمَّرَ الْبَابَ
u'سَمْطٌ حِكْمَةٌ':Added, #1: 1	سَمْطُ الْحِكْمَةِ
u'سَمِعَ اِبْنٌ':Predicate, #1: 1	سَمْطُ الْحِكْمَةِ
u'سَمِعَ اِبْنٌ':Subject, #97: 97	سَمِعَ ابْنَ
u'سَمْعٌ اِبْنٌ':Added, #92: 92	سَمِعَ ابْنُ
u'سَمِعَ أحَدٌ':Subject, #2: 2	سَمْعُ ابْنِ
u'سَمِعَ أحَدٌ':Subject, #1: 1	سَمِعَ أَحَدُ
u'سَمْعٌ أحَدٌ':Added, #3: 3	سَمِعَ أَحَدٌ
u'سَمِعَ أَحْنَف':Subject, #1: 1	سَمْعِ أَحَدِ
u'سَمِعَ اِخْتِلاَفٌ':Predicate, #1: 1	سَمِعَ الْأَحْنَفُ
u'سَمِعَ آخِرُ':Predicate, #1: 1	سَمِعَ اخْتِلَافَ
u'سَمِعَ أَخِيرٌ':Predicate, #3: 3	سَمِعَ آخِرَ
u'سَمِعَ أَذَانٌ':Predicate, #1: 1	سَمِعَ الْأَخِيرَ
u'سَمِعَ أَذَانٌ':Predicate, #11: 11	سَمِعَ أَذَانَ
u'سَمِعَ آذَانٌ':Predicate, #25: 25	سَمِعَ الْأَذَانَ
u'سَمِعَ أَذَانٌ':Predicate, #3: 3	سَمِعَ الْآذَانَ
u'سَمْعٌ آذَانٌ':Added, #4: 4	سَمِعَ الأَذَانَ
u'سَمِعَ إِذْنٌ':Predicate, #1: 1	سَمْعُ الْآذَانِ
u'سَمْعٌ أرْضٌ':Added, #2: 2	سَمِعَ الْإِذْنَ
u'سَمِعَ اِسْمٌ':Predicate, #1: 1	سَمْعِ الْأَرْضِ
u'سَمِعَ أسْوَد':Predicate, #5: 5	سَمِعَ اسْمَ
u'سَمِعَ أَشْهَب':Subject, #1: 1	سَمِعَ الأَسْوَدَ
u'سَمِعَ أَصْحَابٌ':Subject, #10: 10	سَمِعَ أَشْهَبُ
u'سَمِعَ أعْرَابِيٌّ':Predicate, #1: 1	سَمِعَ أَصْحَابُ
u'سَمِعَ إقامَةٌ':Predicate, #1: 1	سَمِعَ الْأَعْرَابِيَّ
u'سَمِعَ إقامَةٌ':Predicate, #4: 4	سَمِعَ الإِقَامَةَ
u'سَمِعَ إقْرَارٌ':Predicate, #5: 5	سَمِعَ الْإِقَامَةَ
u'سَمِعَ إقْرَارٌ':Predicate, #2: 2	سَمِعَ الْإِقْرَارَ
u'سَمِعَ إكْثَارٌ':Predicate, #7: 7	سَمِعَ إقْرَارَ
u'سَمِعَ أُمٌّ':Predicate, #1: 1	سَمِعَ إِكْثَارَ
u'سَمِعَ إمَامٌ':Predicate, #4: 4	سَمِعَ أُمَّ
u'سَمَّعَ إمَامٌ':Predicate, #1: 1	سَمِعَ الْإِمَامَ
u'سَمِعَ إمَامٌ':Subject, #1: 1	سَمَّعَ الْإِمَامَ
u'سَمِعَ أَميرٌ':Subject, #3: 3	سَمِعَ الْإِمَامُ
u'سَمِعَ أُناسٌ':Subject, #1: 1	سَمِعَ الْأَمِيرُ
u'سَمِعَ اِنْتِسابٌ':Predicate, #1: 1	سَمِعَ أُنَاسٌ
u'سَمِعَ أهْلٌ':Predicate, #1: 1	سَمِعَ انْتِسَابَ
u'سَمِعَ أهْلٌ':Predicate, #2: 2	أَسْمَعَ أَهْلَ
u'سَمِعَ أهْلٌ':Subject, #4: 4	سَمِعَ أَهْلَ
u'سَمِعَ أَوَّلُ':Predicate, #4: 4	سَمِعَ أَهْلُ
u'سَمِعَ أَوَّلُ':Predicate, #1: 1	سَمِعَ الْأَوَّلَ
u'سَمِعَ آيَةٌ':Predicate, #2: 2	سَمِعَ أَوَّلَ
u'سَمِعَ آيَةٌ':Predicate, #1: 1	سَمِعَ الْآيَةَ
u'سَمِعَ إِيجَابٌ':Predicate, #4: 4	سَمِعَ آيَةَ
u'سَمِعَ أَيْنٌ':Predicate, #1: 1	سَمِعَ الْإِيجَابَ
u'سَمِعَ بَائِعٌ':Subject, #1: 1	سَمِعَ أَيْنَ
u'سَمِعَ براءٌ':Predicate, #1: 1	سَمِعَ الْبَائِعُ
u'سَمِعَ بَراءٌ':Predicate, #1: 1	سَمِعَ الْبَرَاءَ
u'سَمِعَ بُسْرٌ':Predicate, #1: 1	سَمِعَ الْبَرَاءَ
u'سَمِعَ بَعْضٌ':Predicate, #1: 1	سَمِعَ بُسْرَ
u'سَمِعَ بَعْضٌ':Predicate, #1: 1	أَسْمَعَ بَعْضَ
u'سَمِعَ بَعْضٌ':Subject, #6: 6	سَمِعَ بَعْضَ
u'سَمِعَ بُغامٌ':Predicate, #1: 1	سَمِعَ بَعْضُ
u'سَمِعَ بُكاءٌ':Predicate, #1: 1	سَمِعَ بُغَامَ
u'سَمِعَ بَيْعٌ':Predicate, #2: 2	سَمِعَ بُكَاءَ
u'سَمِعَ بَيِّنَةٌ':Predicate, #4: 4	سَمِعَ الْبَيْعَ
u'سَمِعَ بَيِّنَةٌ':Predicate, #2: 2	سَمِعَ بَيِّنَةَ
u'سَمِعَ تَأْمِينٌ':Predicate, #9: 9	سَمِعَ الْبَيِّنَةَ
u'سَمِعَ تَصْفِيقٌ':Predicate, #1: 1	سَمِعَ تَأْمِينَ
u'سَمِعَ تَعْظِيمٌ':Predicate, #1: 1	سَمِعَ التَّصْفِيقَ
u'سَمِعَ تَكْبيرٌ':Predicate, #1: 1	سَمِعَ تَعْظِيمَ
u'سَمِعَ تَكْبيرٌ':Predicate, #1: 1	سَمِعَ تَكْبِيرَ
u'سَمِعَ تَكْليفٌ':Predicate, #5: 5	سَمِعَ التَّكْبِيرَ
u'سَمِعَ ثَانِي':Predicate, #1: 1	سَمِعَ التَّكْلِيفَ
u'سَمِعَ ثَعْلَبٌ':Predicate, #1: 1	سَمِعَ الثَّانِيَ
u'سَمِعَ جَابِرٌ':Predicate, #1: 1	سَمِعَ ثَعْلَبَةَ
u'سَمِعَ جَابِرٌ':Subject, #70: 70	سَمِعَ جَابِرَ
u'سَمِعَ جَامِعٌ':Predicate, #1: 1	سَمِعَ جَابِرٌ
u'سَمِعَ جَبَّارٌ':Predicate, #1: 1	سَمِعَ جَامِعَ
u'سَمِعَ جَلَبَةٌ':Predicate, #2: 2	سَمِعَ جَبَّارَ
u'سَمِعَ جَمِيع':Predicate, #3: 3	سَمِعَ جَلَبَةَ
u'سَمِعَ جَمِيلٌ':Predicate, #1: 1	سَمِعَ الْجَمِيعَ
u'سَمِعَ جَوَابٌ':Predicate, #1: 1	سَمِعَ جَمِيلَ
u'سَمِعَ جَوَابٌ':Predicate, #1: 1	سَمِعَ الْجَوَابَ
u'سَمِعَ حارِثٌ':Predicate, #1: 1	سَمِعَ جَوَابَ
u'سَمِعَ حاطِبٌ':Predicate, #3: 3	سَمِعَ الْحَارِثَ
u'سَمِعَ حاكِمٌ':Predicate, #1: 1	سَمِعَ حَاطِبَ
u'سَمِعَ حُجَّةٌ':Predicate, #2: 2	سَمِعَ الْحَاكِمَ
u'سَمِعَ حَديثٌ':Predicate, #3: 3	سَمِعَ الْحُجَّةَ
u'سَمِعَ حَديثٌ':Predicate, #3: 3	سَمِعَ حَدِيثَ
u'سَمِعَ حُرْمَةٌ':Predicate, #9: 9	سَمِعَ الْحَدِيثَ
u'سَمِعَ حَرْمَلَة':Predicate, #1: 1	سَمِعَ حُرْمَةَ
u'سَمِعَ حَسَنٌ':Predicate, #2: 2	سَمِعَ حَرْمَلَةَ
u'سَمِعَ حَسَنٌ':Subject, #4: 4	سَمِعَ الْحَسَنَ
u'سَمِعَ حُطَمَةٌ':Predicate, #1: 1	سَمِعَ الْحَسَنُ
u'سَمِعَ حَكَمٌ':Predicate, #1: 1	سَمِعَ حُطَمَةَ
u'سَمِعَ حَكِيمٌ':Predicate, #1: 1	سَمِعَ الْحَكَمَ
u'سَمِعَ حَكِيمٌ':Subject, #1: 1	سَمِعَ حَكِيمَ
u'سَمِعَ حَمْحَم':Predicate, #1: 1	سَمِعَ حَكِيمُ
u'سَمِعَ حَمْحَمَة':Predicate, #1: 1	سَمِعَ حَمْحَمَةَ
u'سَمِعَ حَمْدٌ':Predicate, #1: 1	سَمِعَ حَمْحَمَةَ
u'سَمِعَ حَنْظَلٌ':Predicate, #1: 1	سَمِعَ حَمْدَ
u'سَمِعَ حَيٌّ':Predicate, #1: 1	سَمِعَ حَنْظَلَةَ
u'سَمِعَ حَيٌّ':Predicate, #1: 1	سَمِعَ الْحَيَّ
u'سَمِعَ خَالِدٌ':Predicate, #3: 3	سَمِعَ حَيَّ
u'سَمِعَ خَبَرٌ':Predicate, #1: 1	سَمِعَ خَالِدَ
u'سَمِعَ خَبَر':Predicate, #1: 1	سَمِعَ خَبَرَ
u'سَمِعَ خَرِيرٌ':Predicate, #1: 1	سَمِعَ خَبَرَ
u'سَمِعَ خَصْمٌ':Subject, #1: 1	سَمِعَ خَرِيرَ
u'سَمِعَ خُصُومَةٌ':Predicate, #1: 1	سَمِعَ الْخَصْمُ
u'سَمِعَ خطبة':Predicate, #1: 1	سَمِعَ الْخُصُومَةَ
u'سَمِعَ خُطْبَةٌ':Predicate, #2: 2	سَمِعَ الْخُطْبَةَ
u'سَمِعَ دُرٌّ':Predicate, #2: 2	سَمِعَ الْخُطْبَةَ
u'سَمِعَ دُرَّةٌ':Predicate, #1: 1	سَمِعَ دُرَّةَ
u'سَمِعَ دُفٌّ':Predicate, #1: 1	سَمِعَ دُرَّةَ
u'سَمِعَ ذَرٌّ':Predicate, #1: 1	سَمِعَ الدُّفَّ
u'سَمِعَ ذكر':Predicate, #1: 1	سَمِعَ ذَرَّ
u'سَمِعَ ذِكْرٌ':Predicate, #1: 1	سَمِعَ الذِّكْرَ
u'سَمِعَ ذكر':Predicate, #1: 1	سَمِعَ الذِّكْرَ
u'سَمِعَ ذِكْرٌ':Predicate, #2: 2	سَمِعَ ذِكْرَ
u'سَمِعَ رَافِعٌ':Predicate, #2: 2	سَمِعَ ذِكْرَ
u'سَمِعَ رَبِيعَةٌ':Predicate, #4: 4	سَمِعَ رَافِعَ
u'سَمِعَ رَجُلٌ':Predicate, #5: 5	سَمِعَ رَبِيعَةَ
u'سَمِعَ رَجُلٌ':Subject, #29: 29	سَمِعَ رَجُلاً
u'سَمِعَ رَجُلٌ':Subject, #1: 1	سَمِعَ الرَّجُلُ
u'سَمِعَ رَسُولٌ':Predicate, #5: 5	سَمِعَ رَجُلٌ
u'سَمِعَ رَسُولٌ':Subject, #121: 121	سَمِعَ رَسُولَ
u'سَمِعَ رَعْدٌ':Predicate, #14: 14	سَمِعَ رَسُولُ
u'سَمِعَ رُغاءٌ':Predicate, #8: 8	سَمِعَ الرَّعْدَ
u'سَمِعَ رَغْوَةٌ':Predicate, #2: 2	سَمِعَ رُغَاءَ
u'سَمِعَ زَجَلٌ':Predicate, #1: 1	سَمِعَ الرَّغْوَةَ
u'سَمِعَ زِرٌّ':Predicate, #1: 1	سَمِعَ زَجَلَ
u'سَمِعَ زرعة':Predicate, #1: 1	سَمِعَ زِرَّ
u'سَمِعَ زَيْدٌ':Predicate, #1: 1	سَمِعَ زُرْعَةَ
u'سَمِعَ سَالِمٌ':Predicate, #11: 11	سَمِعَ زَيْدَ
u'سَمِعَ سَائِبٌ':Predicate, #4: 4	سَمِعَ سَالِمَ
u'سَمِعَ سَطِيح':Subject, #2: 2	سَمِعَ السَّائِبَ
u'سَمِعَ سَعْدٌ':Predicate, #1: 1	سَمِعَ سَطِيحٌ
u'سَمِعَ سَعْدٌ':Subject, #5: 5	سَمِعَ سَعْدَ
u'سَمِعَ سَعِيدٌ':Predicate, #1: 1	سَمِعَ سَعْدٌ
u'سَمِعَ سلمة':Predicate, #23: 23	سَمِعَ سَعِيدَ
u'سَمِعَ سمرة':Predicate, #2: 2	سَمِعَ سَلَمَةَ
u'سَمِعَ سَهْلٌ':Predicate, #1: 1	سَمِعَ سَمُرَةَ
u'سَمِعَ سُهَيْلٌ':Predicate, #10: 10	سَمِعَ سَهْلَ
u'سَمِعَ سُورَةٌ':Predicate, #1: 1	سَمِعَ سُهَيْلَ
u'سَمِعَ شَاهِدٌ':Subject, #1: 1	سَمِعَ سُورَةَ
u'سَمِعَ شَاهِدٌ':Subject, #1: 1	سَمِعَ الشَّاهِدُ
u'سَمِعَ شِرَاءٌ':Predicate, #1: 1	سَمِعَ شَاهِدٌ
u'سَمِعَ شَرْعِيٌّ':Predicate, #3: 3	سَمِعَ الشِّرَاءَ
u'سَمِعَ شَرِيدٌ':Predicate, #1: 1	سَمِعَ شَرْعِيَّةَ
u'سَمِعَ شَرِيكٌ':Subject, #1: 1	سَمِعَ الشَّرِيدَ
u'سَمِعَ شِعْرٌ':Predicate, #1: 1	سَمِعَ الشَّرِيكُ
u'سَمِعَ شُهُودٌ':Subject, #1: 1	سَمِعَ شِعْرَ
u'سَمِعَ شيب':Subject, #4: 4	سَمِعَ الشُّهُودُ
u'سَمِعَ شَيْخٌ':Subject, #1: 1	سَمِعَ الشُّيُبُ
u'سَمِعَ صَارِخٌ':Predicate, #1: 1	سَمِعَ الشَّيْخُ
u'سَمِعَ صَالِحٌ':Predicate, #3: 3	سَمِعَ الصَّارِخَ
u'سَمِعَ صَالِح':Predicate, #1: 1	سَمِعَ صَالِحَ
u'سَمِعَ صَاهِلٌ':Predicate, #1: 1	سَمِعَ صَالِحَ
u'سَمِعَ صَائِحٌ':Predicate, #1: 1	سَمِعَ صَاهِلَةَ
u'سَمِعَ صَبِيٌّ':Predicate, #1: 1	سَمِعَ صَائِحَةً
u'سَمِعَ صدقة':Subject, #1: 1	سَمِعَ الصَّبِيَّ
u'سَمِعَ صَدَقَةٌ':Subject, #1: 1	سَمِعَ صَدَقَةُ
u'سَمِعَ صَرِيفٌ':Predicate, #1: 1	سَمِعَ صَدَقَةُ
u'سَمِعَ صَعْبٌ':Predicate, #1: 1	سَمِعَ صَرِيفَ
u'سَمِعَ صَفْوَان':Predicate, #1: 1	سَمِعَ الصَّعْبَ
u'سَمِعَ صِهْرٌ':Subject, #2: 2	سَمِعَ صَفْوَانَ
u'سَمِعَ صَوْتٌ':Predicate, #1: 1	سَمِعَ صِهْرُهُ
u'سَمِعَ صَوْتٌ':Predicate, #10: 10	سَمِعَ صَوْتَ
u'سَمِعَ صَوْتٌ':Predicate, #1: 1	سَمِعَ الصّوْتَ
u'سَمْعٌ صَوْتٌ':Added, #1: 1	سَمِعَ صَوْتَكَ
u'سَمِعَ ضحك':Predicate, #2: 2	سَمْعَ صَوْتِهِ
u'سَمِعَ ضَحِكٌ':Predicate, #1: 1	سَمِعَ ضَحِكَ
u'سَمْعٌ طِفْلٌ':Added, #1: 1	سَمِعَ ضَحِكَ
u'سَمِعَ طَلْحٌ':Predicate, #1: 1	سَمْعَ طِفْلٍ
u'سَمِعَ طلحة':Predicate, #4: 4	سَمِعَ طَلْحَةَ
u'سَمِعَ عَاصِمٌ':Predicate, #4: 4	سَمِعَ طَلْحَةَ
u'سَمِعَ عَائِشٌ':Predicate, #1: 1	سَمِعَ عَاصِمَ
u'سَمِعَ عَبَّاسٌ':Subject, #13: 13	سَمِعَ عَائِشَةَ
u'سَمِعَ عَبْدٌ':Predicate, #1: 1	سَمِعَ الْعَبّاسُ
u'سَمِعَ عَبْدٌ':Subject, #70: 70	سَمِعَ عَبْدَ
u'سَمِعَ عُرْوَةٌ':Predicate, #2: 2	سَمِعَ عَبْدُ
u'سَمِعَ عَطَاءٌ':Predicate, #14: 14	سَمِعَ عُرْوَةَ
u'سَمِعَ عَطِيَّةٌ':Predicate, #2: 2	سَمِعَ عَطَاءَ
u'سَمِعَ عَفِيفٌ':Predicate, #1: 1	سَمِعَ عَطِيَّةَ
u'سَمِعَ عقبة':Predicate, #1: 1	سَمِعَ عَفِيفَ
u'سَمِعَ عُقْبَةٌ':Predicate, #27: 27	سَمِعَ عُقْبَةَ
u'سَمِعَ عَلاءٌ':Predicate, #27: 27	سَمِعَ عُقْبَةَ
u'سَمِعَ عَلْقَم':Predicate, #1: 1	سَمِعَ الْعَلاَءَ
u'سَمِعَ عَلْقَمَة':Predicate, #5: 5	سَمِعَ عَلْقَمَةَ
u'سَمِعَ عَلِيٌّ':Predicate, #5: 5	سَمِعَ عَلْقَمَةَ
u'سَمِعَ عُمَرٌ':Predicate, #2: 2	سَمِعَ عَلِيَّ
u'سَمِعَ عُمَرٌ':Subject, #32: 32	سَمِعَ عُمَرَ
u'سَمِعَ عمرة':Predicate, #6: 6	سَمِعَ عُمَرُ
u'سَمِعَ عند':Predicate, #1: 1	سَمِعَ عَمْرَةَ
u'سَمِعَ فَاطِمٌ':Predicate, #1: 1	سَمِعَ عِنْدَ
u'سَمِعَ فَرَزْدَقٌ':Predicate, #1: 1	سَمِعَ فَاطِمَةَ
u'سَمِعَ فَرْعٌ':Predicate, #1: 1	سَمِعَ الْفَرَزْدَقَ
u'سَمِعَ فَرْوَةٌ':Predicate, #1: 1	سَمِعَ الْفَرْعَ
u'سَمِعَ فَضِيلٌ':Predicate, #2: 2	سَمِعَ فَرْوَةَ
u'سَمِعَ فَضِيلَةٌ':Predicate, #1: 1	سَمِعَ فَضِيلَةَ
u'سَمِعَ فلان':Predicate, #1: 1	سَمِعَ فَضِيلَةَ
u'سَمِعَ فلان':Predicate, #12: 12	سَمِعَ عُثْمَانَ
u'سَمِعَ فلان':Predicate, #1: 1	سَمِعَ تَمِيمَ
u'سَمِعَ فلان':Predicate, #1: 1	سَمِعَ جُبَيْرَ
u'سَمِعَ فلان':Predicate, #1: 1	سَمِعَ حُذَيْفَةَ
u'سَمِعَ فلان':Predicate, #2: 2	سَمِعَ الزُّبَيْرَ
u'سَمِعَ فلان':Predicate, #2: 2	سَمِعَ حَرْمَلَةَ
u'سَمِعَ فلان':Predicate, #2: 2	سَمِعَ زِيَادَ
u'سَمِعَ فلان':Predicate, #2: 2	سَمِعَ مَكْحُولاً
u'سَمِعَ فلان':Predicate, #3: 3	سَمِعَ قَتَادَةَ
u'سَمِعَ فلان':Predicate, #5: 5	سَمِعَ سُفْيَانَ
u'سَمِعَ فلان':Subject, #6: 6	سَمِعَ مُعَاوِيَةَ
u'سَمِعَ فلان':Subject, #1: 1	سَمِعَ حُذَيْفَةُ
u'سَمْعٌ قَابِلٌ':Added, #1: 1	سَمِعَ قَتَادَةُ
u'سَمِعَ قَاسِمٌ':Predicate, #1: 1	سَمْعَ قَابِلٍ
u'سَمِعَ قَاصٌّ':Predicate, #5: 5	سَمِعَ الْقَاسِمَ
u'سَمِعَ قَالٌ':Predicate, #1: 1	سَمِعَ قَاصَّ
u'سَمِعَ قَائِلٌ':Predicate, #2: 2	سَمِعَ قَالَ
u'سَمِعَ قَتاد':Predicate, #2: 2	سَمِعَ قَائِلَةً
u'سَمِعَ قَتاد':Subject, #3: 3	سَمِعَ قَتَادَةَ
u'سَمِعَ قِرَاءةٌ':Predicate, #1: 1	سَمِعَ قَتَادَةُ
u'سَمِعَ قَزَع':Predicate, #7: 7	سَمِعَ قِرَاءَةَ
u'سَمِعَ قِصَّةٌ':Predicate, #1: 1	سَمِعَ قَزَعَةَ
u'سَمِعَ قَضَاءٌ':Predicate, #1: 1	سَمِعَ قِصَّةَ
u'سَمِعَ قول':Predicate, #1: 1	سَمِعَ قَضَاءَ
u'سَمِعَ قَوْلٌ':Predicate, #13: 13	سَمِعَ قَوْلَ
u'سَمِعَ قول':Predicate, #13: 13	سَمِعَ قَوْلَ
u'سَمِعَ قَوْلٌ':Predicate, #1: 1	سَمِعَ الْقَوْلَ
u'سَمِعَ قَوْمٌ':Predicate, #1: 1	سَمِعَ الْقَوْلَ
u'سَمْعٌ كَاتِبٌ':Added, #1: 1	سَمِعَ الْقَوْمَ
u'سَمِعَ كَعْبٌ':Subject, #1: 1	سَمْعِ الْكَاتِبِ
u'سَمِعَ كَلاَمٌ':Predicate, #1: 1	سَمِعَ كَعْبٌ
u'سَمِعَ كَلاَمٌ':Predicate, #1: 1	سَمِعَ الْكَلَامَ
u'سَمِعَ لَفْظٌ':Predicate, #8: 8	سَمِعَ كَلَامَ
u'سَمِعَ مَالِكٌ':Predicate, #3: 3	سَمِعَ لَفْظَ
u'سَمِعَ مُبَايَعَةٌ':Predicate, #4: 4	سَمِعَ مَالِكَ
u'سَمِعَ مُجَاهِدٌ':Subject, #1: 1	سَمِعَ الْمُبَايَعَةَ
u'سَمِعَ مَجْنُونٌ':Subject, #1: 1	سَمِعَ مُجَاهِدٌ
u'سَمِعَ مُحْتَسِبٌ':Subject, #1: 1	سَمِعَ الْمَجْنُونُ
u'سَمِعَ مُحَكَّمٌ':Subject, #1: 1	سَمِعَ الْمُحْتَسِبُ
u'سَمِعَ مُحَمَّدٌ':Predicate, #1: 1	سَمِعَ الْمُحَكَّمُ
u'سَمِعَ مُخَاطَبٌ':Subject, #8: 8	سَمِعَ مُحَمَّدَ
u'سَمِعَ مرٌّ':Predicate, #1: 1	سَمِعَ الْمُخَاطَبُ
u'سَمِعَ مُسْتَأْجِرٌ':Subject, #1: 1	سَمِعَ مُرَّةَ
u'سَمِعَ مَسْعُودٌ':Predicate, #1: 1	سَمِعَ الْمُسْتَأْجِرُ
u'سَمِعَ مُسْلِمٌ':Predicate, #1: 1	سَمِعَ مَسْعُودَ
u'سَمِعَ مُعَارَضَةٌ':Predicate, #2: 2	سَمِعَ مُسْلِمَ
u'سَمِعَ مُعاوِيَة':Predicate, #1: 1	سَمِعَ الْمُعَارَضَةَ
u'سَمِعَ مِقْدَامٌ':Predicate, #6: 6	سَمِعَ مُعَاوِيَةَ
u'سَمِعَ مَكْحُول':Predicate, #3: 3	سَمِعَ الْمِقْدَامَ
u'سَمِعَ مَكْرُوهٌ':Predicate, #2: 2	سَمِعَ مَكْحُولاً
u'سَمِعَ مُنَادِي':Predicate, #1: 1	سَمِعَ الْمَكْرُوهَ
u'سَمِعَ مُنَادِي':Predicate, #1: 1	سَمِعَ مُنَادِيَ
u'سَمِعَ مَنْسُوخٌ':Predicate, #2: 2	سَمِعَ الْمُنَادِيَ
u'سَمِعَ مُنْكَرٌ':Predicate, #1: 1	سَمِعَ الْمَنْسُوخَ
u'سَمِعَ مُؤَذِّنٌ':Predicate, #1: 1	سَمِعَ الْمُنْكَرَ
u'سَمِعَ مَوْعِظَةٌ':Predicate, #13: 13	سَمِعَ الْمُؤَذِّنَ
u'سَمِعَ مُؤَمَّلٌ':Subject, #1: 1	سَمِعَ الْمَوْعِظَةَ
u'سَمِعَ نَاسٌ':Predicate, #1: 1	سَمِعَ مُؤَمَّلٌ
u'سَمِعَ نَاسٌ':Predicate, #1: 1	أَسْمَعَ النَّاسَ
u'سَمِعَ نَاسٌ':Subject, #2: 2	سَمِعَ النَّاسَ
u'سَمِعَ نَاسِخٌ':Predicate, #1: 1	سَمِعَ النّاسُ
u'سَمِعَ نَاسِخ':Predicate, #1: 1	سَمِعَ النَّاسِخَ
u'سَمِعَ نَائِحٌ':Predicate, #1: 1	سَمِعَ النَّاسِخَ
u'سَمِعَ نَبِيٌّ':Predicate, #1: 1	سَمِعَ نَائِحَةً
u'سَمِعَ نَبِيٌّ':Subject, #55: 55	سَمِعَ النَّبِيَّ
u'سَمِعَ نِدَاءٌ':Predicate, #7: 7	سَمِعَ النَّبِيُّ
u'سَمِعَ نِدَاءٌ':Predicate, #3: 3	سَمِعَ نِدَاءَ
u'سَمِعَ نِساءٌ':Predicate, #52: 52	سَمِعَ النِّدَاءَ
u'سَمِعَ نَهْيٌ':Predicate, #1: 1	سَمِعَ نِسَاءَ
u'سَمِعَ هَاتِفٌ':Predicate, #1: 1	سَمِعَ النَّهْيَ
u'سَمِعَ هَاتِفٌ':Predicate, #1: 1	سَمِعَ الْهَاتِفَ
u'سَمِعَ هُبَيْرَة':Predicate, #2: 2	سَمِعَ الْهَاتِفَةَ
u'سَمِعَ هشام':Predicate, #1: 1	سَمِعَ هُبَيْرَةَ
u'سَمِعَ هِشَامٌ':Predicate, #1: 1	سَمِعَ هِشَامَ
u'سَمِعَ هَمْهَم':Predicate, #1: 1	سَمِعَ هِشَامَ
u'سَمِعَ هَمْهَم':Predicate, #1: 1	سَمِعَ هَمْهَمَةً
u'سَمِعَ هَمْهَمَة':Predicate, #1: 1	سَمِعَ هَمْهَمَةَ
u'سَمْعٌ وَشْمٌ':Added, #1: 1	سَمِعَ هَمْهَمَةَ
u'سَمِعَ وقع':Predicate, #1: 1	سَمْعٍ وَشْمٍ
u'سَمِعَ وَقْعٌ':Predicate, #2: 2	سَمِعَ وَقْعَ
u'سَمِعَ وَلِيدٌ':Predicate, #2: 2	سَمِعَ وَقْعَ
u'سَمِعَ يَعْقُوبٌ':Predicate, #1: 1	سَمِعَ الْوَلِيدَ
u'سَمِعَ يَهُودِيٌّ':Predicate, #1: 1	سَمِعَ يَعْقُوبَ
u'سَمْكٌ بَيْتٌ':Added, #2: 2	سَمِعَ الْيَهُودِيَّ
u'سَمَكَ سَمَاءٌ':Predicate, #1: 1	سَمْكَ بَيْتِهِ
u'سَمَلَ أَعْيُنٌ':Predicate, #1: 1	سَمَكَ السّمَاءَ
u'سَمَلَ رَسُولٌ':Subject, #1: 1	سَمَلَ أَعْيُنَ
u'سَمَّلَ نَبِيٌّ':Subject, #2: 2	سَمَلَ رَسُولُ
u'سَمَّى اِبْنٌ':Predicate, #1: 1	سَمَّلَ النَّبِيُّ
u'سَمَّى أَبْيَض':Predicate, #1: 1	سَمَّى ابْنَ
u'سَمَّى أُجْرَةٌ':Predicate, #1: 1	سَمَّى أَبْيَضَ
u'سَمَّى أحَدٌ':Predicate, #1: 1	سَمَّى الْأُجْرَةَ
u'سَمَّى أَذَانٌ':Predicate, #1: 1	سَمَّى أَحَدَ
u'سَمَّى أرْضٌ':Predicate, #1: 1	سَمَّى الْأَذَانَ
u'سَمَّى إِسْلامٌ':Predicate, #1: 1	سَمَّى الْأَرْضَ
u'سَمَّى أصل':Predicate, #3: 3	سَمَّى الْإِسْلَامَ
u'سَمَّى أًصْلٌ':Predicate, #1: 1	سَمَّى الْأَصْلَ
u'سَمَّى أقَلُّ':Predicate, #1: 1	سَمَّى الْأَصْلَ
u'سَمَّى أَكْثَرُ':Predicate, #3: 3	سَمَّى أَقَلَّ
u'سَمَّى ألف':Predicate, #1: 1	سَمَّى أَكْثَرَ
u'سَمَّى ألْفٌ':Predicate, #3: 3	سَمَّى الْأَلْفَ
u'سَمَّى أَلْفٌ':Predicate, #3: 3	سَمَّى الْأَلْفَ
u'سَمَّى الْمَرْأَةُ':Predicate, #3: 3	سَمَّى الْأَلْفَ
u'سَمَّى إلْهَامٌ':Predicate, #1: 1	سَمَّى الْمَرْأَةَ
u'سَمَّى أَمْرٌ':Predicate, #1: 1	سَمَّى إلْهَامَ
u'سَمَّى آمِرٌ':Subject, #1: 1	سَمَّى الْأَمْرَ
u'سَمَّى أهْلٌ':Subject, #1: 1	سَمَّى الْآمِرُ
u'سَمَّى أَوَّلُ':Predicate, #1: 1	سَمَّى أَهْلُ
u'سَمَّى أَوَّلُ':Subject, #1: 1	سَمَّى الْأَوَّلَ
u'سَمَّى بَائِعٌ':Subject, #1: 1	سَمَّى الْأَوَّلُ
u'سَمَّى بَلَدٌ':Predicate, #1: 1	سَمَّى الْبَائِعُ
u'سَمَّى بِنْتٌ':Predicate, #1: 1	سَمَّى الْبَلَدَ
u'سَمَّى بَيْتٌ':Predicate, #1: 1	سَمَّى الْبِنْتَ
u'سَمَّى بَيْتٌ':Predicate, #1: 1	سَمَّى الْبَيْتَ
u'سَمَّى بَيْنٌ':Predicate, #1: 1	سَمَّى بَيْتَ
u'سَمَّى تارِك':Predicate, #1: 1	سَمَّى بَيْنَ
u'سَمَّى تَأْكِيدٌ':Predicate, #1: 1	سَمَّى تَارِكَ
u'سَمَّى ثَمَرٌ':Predicate, #1: 1	سَمَّى التَّأْكِيدَ
u'سَمَّى ثَمَنٌ':Predicate, #1: 1	سَمَّى الثَّمَرَ
u'سَمَّى ثَمَنٌ':Predicate, #2: 2	سَمَّى ثَمَنَ
u'سَمَّى ثَوابٌ':Predicate, #4: 4	سَمَّى الثَّمَنَ
u'سَمَّى ثَوْبٌ':Predicate, #1: 1	سَمَّى الثَّوَابَ
u'سَمَّى جَزَاءٌ':Predicate, #1: 1	سَمَّى الثَّوْبَ
u'سَمَّى جَمَاعَةٌ':Subject, #1: 1	سَمَّى الْجَزَاءَ
u'سَمَّى جُمْلَةٌ':Predicate, #1: 1	سَمَّى جَمَاعَةٌ
u'سَمَّى جُمْلَةٌ':Predicate, #2: 2	سَمَّى الْجُمْلَةَ
u'سَمَّى جِنْسٌ':Predicate, #8: 8	سَمَّى جُمْلَةَ
u'سَمَّى حالَةٌ':Predicate, #4: 4	سَمَّى جِنْسَ
u'سَمَّى حَذْف':Predicate, #1: 1	سَمَّى حَالَةَ
u'سَمَّى حَرْبٌ':Predicate, #1: 1	سَمَّى الْحَذْفَ
u'سَمَّى حَسَنٌ':Predicate, #1: 1	سَمَّى الْحَرْبَ
u'سَمَّى حَفْرٌ':Predicate, #1: 1	سَمَّى الْحَسَنَ
u'سَمَّى خَاطِبٌ':Subject, #1: 1	سَمَّى الْحَفْرَ
u'سَمَّى خَمْرٌ':Predicate, #1: 1	سَمَّى الْخَاطِبُ
u'سَمَّى دَافِعٌ':Subject, #2: 2	سَمَّى الْخَمْرَ
u'سَمَّى دَرَاهِمُ':Predicate, #1: 1	سَمَّى الدَّافِعُ
u'سَمَّى دونٌ':Predicate, #3: 3	سَمَّى الدَّرَاهِمَ
u'سَمَّى رَافِعٌ':Subject, #1: 1	سَمَّى دُونَ
u'سَمَّى رجعة':Predicate, #1: 1	سَمَّى رَافِعُ
u'سَمَّى رَجْعَةٌ':Predicate, #3: 3	سَمَّى الرَّجْعَةَ
u'سَمَّى رَجُلٌ':Subject, #3: 3	سَمَّى الرَّجْعَةَ
u'سَمَّى رُجُوعٌ':Predicate, #2: 2	سَمَّى الرَّجُلُ
u'سَمَّى رَسُولٌ':Subject, #1: 1	سَمَّى الرُّجُوعَ
u'سَمَّى رُطَبٌ':Predicate, #6: 6	سَمَّى رَسُولُ
u'سَمَّى زانِي':Predicate, #1: 1	سَمَّى الرُّطَبَ
u'سَمَّى زائِرٌ':Predicate, #1: 1	سَمَّى الزَّانِيَ
u'سَمَّى زَوْجٌ':Subject, #1: 1	سَمَّى زَائِرَ
u'سَمَّى زَوْجَةٌ':Predicate, #1: 1	سَمَّى الزَّوْجُ
u'سَمَّى سَارِقٌ':Predicate, #1: 1	سَمَّى الزَّوْجَةَ
u'سَمَّى سَنَةٌ':Predicate, #1: 1	سَمَّى السَّارِقَ
u'سَمَّى شَاةٌ':Predicate, #1: 1	سَمَّى السَّنَةَ
u'سَمَّى شَارِبٌ':Predicate, #1: 1	سَمَّى الشَّاةَ
u'سَمَّى شافِعِيّ':Subject, #1: 1	سَمَّى شَارِبَ
u'سَمَّى شَتْم':Predicate, #1: 1	سَمَّى الشَّافِعِيُّ
u'سَمَّى شَجَرَةٌ':Predicate, #1: 1	سَمَّى الشَّتْمَةَ
u'سَمَّى شمس':Predicate, #1: 1	سَمَّى الشَّجَرَةَ
u'سَمَّى شَمْسٌ':Predicate, #1: 1	سَمَّى الشَّمْسَ
u'سَمَّى شَيْءٌ':Predicate, #1: 1	سَمَّى الشَّمْسَ
u'سَمَّى صَاحِبٌ':Subject, #1: 1	سَمَّى الشَّيْءَ
u'سَمَّى صَاحِبٌ':Subject, #1: 1	سَمَّى صَاحِبُ
u'سَمَّى صداق':Predicate, #1: 1	سَمَّى صَاحِبُهُ
u'سَمَّى صَدَاقٌ':Predicate, #1: 1	سَمَّى الصَّدَاقَ
u'سَمَّى صداق':Predicate, #1: 1	سَمَّى الصَّدَاقَ
u'سَمَّى صَدَاقٌ':Predicate, #1: 1	سَمَّى صَدَاقَ
u'سَمَّى ضَرْبٌ':Predicate, #1: 1	سَمَّى صَدَاقَ
u'سَمَّى طعام':Predicate, #1: 1	سَمَّى الضَّرْبَ
u'سَمَّى طَعَامٌ':Predicate, #6: 6	سَمَّى الطَّعَامَ
u'سَمَّى طَلاَقٌ':Predicate, #6: 6	سَمَّى الطَّعَامَ
u'سَمَّى ظاهِرٌ':Predicate, #1: 1	سَمَّى الطَّلَاقَ
u'سَمَّى عَبْدٌ':Predicate, #1: 1	سَمَّى الظَّاهِرَ
u'سَمَّى عِدَّةٌ':Predicate, #1: 1	سَمَّى عَبْدَ
u'سَمَّى عَدَدٌ':Predicate, #1: 1	سَمَّى الْعِدَّةَ
u'سَمَّى عَدَدٌ':Predicate, #1: 1	سَمَّى الْعَدَدَ
u'سَمَّى عِشَاءٌ':Predicate, #2: 2	سَمَّى عَدَدَ
u'سَمَّى عَشْرٌ':Predicate, #1: 1	سَمَّى الْعِشَاءَ
u'سَمَّى عُمَرٌ':Subject, #1: 1	سَمَّى عَشْرَةً
u'سَمَّى عند':Predicate, #3: 3	سَمَّى عُمَرُ
u'سَمَّى عِوَضٌ':Predicate, #3: 3	سَمَّى عِنْدَ
u'سَمَّى عُيُوبٌ':Predicate, #1: 1	سَمَّى الْعِوَضَ
u'سَمَّى غَالِبٌ':Predicate, #1: 1	سَمَّى الْعُيُوبَ
u'سَمَّى غير':Subject, #1: 1	سَمَّى غَالِبَ
u'سَمَّى غَيْرٌ':Subject, #1: 1	سَمَّى غَيْرُهُ
u'سَمَّى فِدْيَةٌ':Predicate, #1: 1	سَمَّى غَيْرُهُ
u'سَمَّى فَرَسٌ':Predicate, #1: 1	سَمَّى الْفِدْيَةَ
u'سَمَّى فِعْلٌ':Predicate, #1: 1	سَمَّى الْفَرَسَ
u'سَمَّى فقهاء':Subject, #1: 1	سَمَّى الْفِعْلَ
u'سَمَّى فلان':Subject, #1: 1	سَمَّى الْفُقَهَاءُ
u'سَمَّى فُلاَنٌ':Subject, #1: 1	سَمَّى الشَّافِعِيُّ
u'سَمَّى قَابِلٌ':Subject, #1: 1	سَمَّى فُلَانَةُ
u'سَمَّى قَدْرٌ':Predicate, #1: 1	سَمَّى الْقَابِلُ
u'سَمَّى قِيمَةٌ':Predicate, #1: 1	سَمَّى قَدْرَ
u'سَمَّى كَافِرٌ':Predicate, #1: 1	سَمَّى الْقِيمَةَ
u'سَمَّى كِتَابٌ':Predicate, #1: 1	سَمَّى الْكَافِرَ
u'سَمَّى كَتَّانٌ':Predicate, #1: 1	سَمَّى كِتَابَ
u'سَمَّى كعبة':Predicate, #1: 1	سَمَّى الْكَتَّانَ
u'سَمَّى كَعْبَةٌ':Predicate, #2: 2	سَمَّى الْكَعْبَةَ
u'سَمَّى كَلاَمٌ':Predicate, #2: 2	سَمَّى الْكَعْبَةَ
u'سَمَّى مَالٌ':Predicate, #1: 1	سَمَّى الْكَلَامَ
u'سَمَّى مَبِيتٌ':Predicate, #1: 1	سَمَّى الْمَالَ
u'سَمَّى مَبِيعٌ':Predicate, #1: 1	سَمَّى الْمَبِيتَ
u'سَمَّى مثل':Predicate, #2: 2	سَمَّى الْمَبِيعَ
u'سَمَّى مِثْلٌ':Predicate, #1: 1	سَمَّى الْمِثْلَ
u'سَمَّى مثل':Predicate, #1: 1	سَمَّى الْمِثْلَ
u'سَمَّى مِثْلٌ':Predicate, #1: 1	سَمَّى مِثْلَ
u'سَمَّى مَجْهُولٌ':Predicate, #1: 1	سَمَّى مِثْلَ
u'سَمَّى مَحَلٌّ':Predicate, #1: 1	سَمَّى مَجْهُولَ
u'سَمَّى مَدْعُوٌّ':Predicate, #1: 1	سَمَّى الْمَحَلَّ
u'سَمَّى مَدِينٌ':Predicate, #1: 1	سَمَّى الْمَدْعُوَّ
u'سَمَّى مَدِينَةٌ':Predicate, #5: 5	سَمَّى الْمَدِينَةَ
u'سَمَّى مَسَاجِدُ':Predicate, #5: 5	سَمَّى الْمَدِينَةَ
u'سَمَّى مُسِنٌّ':Predicate, #1: 1	سَمَّى الْمَسَاجِدَ
u'سَمَّى مَسِيحٌ':Predicate, #1: 1	سَمَّى الْمُسِنَّةَ
u'سَمَّى مَصَالِحُ':Predicate, #1: 1	سَمَّى الْمَسِيحَ
u'سَمَّى مُصَنِّفٌ':Subject, #1: 1	سَمَّى الْمَصَالِحَ
u'سَمَّى مَطْمُورٌ':Predicate, #1: 1	سَمَّى الْمُصَنِّفُ
u'سَمَّى مُعْتَزِلٌ':Subject, #1: 1	سَمَّى الْمَطْمُورَةَ
u'سَمَّى مُعْتَزِلَةٌ':Subject, #1: 1	سَمَّى الْمُعْتَزِلَةُ
u'سَمَّى مَلْبَنٌ':Predicate, #1: 1	سَمَّى الْمُعْتَزِلَةُ
u'سَمَّى مَهْرٌ':Predicate, #1: 1	سَمَّى الْمَلْبَنَ
u'سَمَّى مَهْرٌ':Predicate, #1: 1	سَمَّى مَهْرَ
u'سَمَّى مَوْجُودٌ':Predicate, #2: 2	سَمَّى الْمَهْرَ
u'سَمَّى مَوْضِعٌ':Predicate, #1: 1	سَمَّى الْمَوْجُودِينَ
u'سَمَّى مَوْقِفٌ':Predicate, #1: 1	سَمَّى مَوْضِعَ
u'سَمَّى مُوَكِّلٌ':Predicate, #1: 1	سَمَّى الْمَوْقِفَ
u'سَمَّى مُوَكِّلٌ':Subject, #3: 3	سَمَّى الْمُوَكِّلَ
u'سَمَّى نَبِيٌّ':Subject, #4: 4	سَمَّى الْمُوَكِّلُ
u'سَمَّى نذر':Predicate, #1: 1	سَمَّى النَّبِيُّ
u'سَمَّى نَذْرٌ':Predicate, #1: 1	سَمَّى النَّذْرَ
u'سَمَّى نِساءٌ':Predicate, #1: 1	سَمَّى النَّذْرَ
u'سَمَّى نَصْرَانِيٌّ':Subject, #1: 1	سَمَّى النِّسَاءَ
u'سَمَّى نَوْعٌ':Predicate, #2: 2	سَمَّى النَّصْرَانِيُّ
u'سَمَّى نَوْعٌ':Predicate, #1: 1	سَمَّى النَّوْعَ
u'سَمَّى هَدِيٌّ':Predicate, #1: 1	سَمَّى نَوْعَ
u'سَمَّى هَدِيَّةٌ':Predicate, #1: 1	سَمَّى الْهَدِيَّةَ
u'سَمَّى واحد':Subject, #1: 1	سَمَّى الْهَدِيَّةَ
u'سَمَّى وَاحِدٌ':Subject, #2: 2	سَمَّى وَاحِدٌ
u'سَمَّى وَاقِفٌ':Predicate, #2: 2	سَمَّى وَاحِدٌ
u'سَمَّى وَصِيٌّ':Predicate, #1: 1	سَمَّى الْوَاقِفَ
u'سَمَّى وَصِيفٌ':Subject, #1: 1	سَمَّى الْوَصِيَّ
u'سَمَّى وَقْتٌ':Predicate, #1: 1	سَمَّى الْوَصِيفُ
u'سَمَّى ولد':Predicate, #3: 3	سَمَّى الْوَقْتَ
u'سَمَّى وَلَدٌ':Predicate, #1: 1	سَمَّى وَلَدَ
u'سَمَّى يَوْمٌ':Predicate, #1: 1	سَمَّى وَلَدَ
u'سَنَا بِنْتٌ':Subject, #1: 1	سَمَّى يَوْمَ
u'سَنْبَلَ حالَةٌ':Predicate, #1: 1	سَنَا بِنْتُ
u'سَنْبَلَ حَبٌّ':Subject, #1: 1	سَنْبَلَ حَالَةَ
u'سَنَّ رَسُولٌ':Predicate, #1: 1	سَنْبَلَ الْحَبُّ
u'سَنَّ رَسُولٌ':Subject, #1: 1	أَسَنَّ رَسُولَ
u'سَنَّ رَسُولٌ':Subject, #12: 12	سَنَّ رَسُولُ
u'سَنَّ رَسُولٌ':Subject, #1: 1	أَسَنَّ رَسُولُ
u'سَنَّ سُنَّةٌ':Predicate, #2: 2	سَنَّ الرَّسُولُ
u'سَنَّ صَغِيرٌ':Predicate, #8: 8	سَنَّ سُنَّةَ
u'سَنَّ صَلاَةٌ':Predicate, #1: 1	سَنَّ صَغِيرَةً
u'سَنَّ فلان':Subject, #1: 1	سَنَّ الصَّلاَةَ
u'سَنَّ قتل':Predicate, #1: 1	أَسَنَّ عَقِيلٌ
u'سَنَّ قَتْلٌ':Predicate, #10: 10	سَنَّ الْقَتْلَ
u'سَهَا أحَدٌ':Subject, #10: 10	سَنَّ الْقَتْلَ
u'سَهَا إمَامٌ':Subject, #1: 1	سَهَا أَحَدٌ
u'سَهَا إمَامٌ':Subject, #17: 17	سَهَا الْإِمَامُ
u'سَهَا إمَامٌ':Subject, #1: 1	سَهَا الإِمَامُ
u'سَهَا إمَامٌ':Subject, #1: 1	سَهَا إمَامُ
u'سَهَا إمَامٌ':Subject, #2: 2	سَهَا إمَامٌ
u'سَهَا أَوَّلُ':Subject, #6: 6	سَهَا إمَامُهُ
u'سَهَا بَيْنٌ':Predicate, #3: 3	سَهَا الْأَوَّلُ
u'سَهَا حالٌ':Predicate, #1: 1	سَهَا بَيْنَ
u'سَهَا حَنْبَلٌ':Subject, #1: 1	سَهَا حَالَ
u'سَهَا خَلْفٌ':Predicate, #1: 1	سَهَا حَنْبَلٌ
u'سَهَا خَلِيفَةٌ':Subject, #1: 1	سَهَا خَلْفَ
u'سَهَا خَلِيفَةٌ':Subject, #1: 1	سَهَا الْخَلِيفَةُ
u'سَهَا رَجُلٌ':Subject, #3: 3	سَهَا خَلِيفَتُهُ
u'سَهَا زادٌ':Predicate, #1: 1	سَهَا الرَّجُلُ
u'سَهَا صَاحِبٌ':Subject, #2: 2	سَهَا زَادَ
u'سَهَا قَالٌ':Predicate, #1: 1	سَهَا صَاحِبُ
u'سَهَا مُنْفَرِدٌ':Subject, #1: 1	سَهَا قَالَ
u'سَهَا نَبِيٌّ':Subject, #3: 3	سَهَا الْمُنْفَرِدُ
u'سَهَا وَقْتٌ':Predicate, #1: 1	سَهَا النَّبِيُّ
u'سَهَّلَ إمَامٌ':Subject, #1: 1	سَهَا وَقْتَ
u'سَهُلَ أَمْرٌ':Subject, #2: 2	سَهَّلَ الْإِمَامُ
u'سَهُلَ أَمْرٌ':Subject, #1: 1	سَهُلَ أَمْرُ
u'سَهُلَ تَحْصِيلٌ':Subject, #2: 2	سَهُلَ الْأَمْرُ
u'سَهُلَ تَطْبِيقٌ':Subject, #1: 1	سَهُلَ تَحْصِيلُهُ
u'سَهُلَ تَمْييزٌ':Subject, #1: 1	سَهُلَ تَطْبِيقُ
u'سَهُلَ تَنَاوُلٌ':Subject, #1: 1	سَهُلَ تَمْيِيزُهُ
u'سَهَّلَ سَبِيلٌ':Predicate, #2: 2	سَهُلَ تَنَاوُلُهُ
u'سَهَّلَ شَارِعٌ':Subject, #1: 1	سَهَّلَ سَبِيلَ
u'سَهُلَ عَدٌّ':Subject, #1: 1	سَهَّلَ الشَّارِعُ
u'سَهُلَ عُدُولٌ':Subject, #1: 1	سَهُلَ عَدُّهُ
u'سَهَمَ زَيْدٌ':Subject, #1: 1	سَهُلَ الْعُدُولُ
u'سَهَمَ يَوْمٌ':Predicate, #1: 1	سَهَمَ زَيْدٌ
u'سَهْوٌ إمَامٌ':Added, #2: 2	أَسْهَمَ يَوْمَ
u'سَهْوٌ إمَامٌ':Added, #2: 2	سَهْوِ إمَامِهِ
u'سَهْوٌ إمَامٌ':Added, #4: 4	سَهْوُ إمَامِهِ
u'سَهْوٌ أَمْرٌ':Added, #6: 6	سَهْوُ الْإِمَامِ
u'سَهْوٌ إِنْسانٌ':Added, #1: 1	سَهْوُ الْأَمْرِ
u'سَهْوٌ زِيادَةٌ':Added, #1: 1	سَهْوَ الْإِنْسَانِ
u'سَهْوٌ شَكٌّ':Added, #1: 1	سَهْوِ الزِّيَادَةِ
u'سَهْوٌ شَيْخٌ':Added, #1: 1	سَهْوِ الشَّكِّ
u'سَهْوٌ صَلاَةٌ':Added, #1: 1	سَهْوُ الشَّيْخِ
u'سَهْوٌ طَائِفٌ':Added, #1: 1	سَهْوَ صَلَاةٍ
u'سَهْوٌ كَاتِبٌ':Added, #1: 1	سَهْوَ الطَّائِفَةِ
u'سَهْوٌ مُخَالِفٌ':Added, #3: 3	سَهْوِ الْكَاتِبِ
u'سَهْوٌ نَاسِخٌ':Added, #1: 1	سَهْوُ الْمُخَالِفِ
u'سَهْوٌ نَاسِخ':Added, #1: 1	سَهْوِ النَّاسِخِ
u'سَهْوٌ نَبِيٌّ':Added, #1: 1	سَهْوِ النَّاسِخِ
u'سُؤَالٌ اِبْنٌ':Added, #1: 1	سَهْوِ النَّبِيِّ
u'سُؤَالٌ اِبْنٌ':Added, #1: 1	سُؤَالَ ابْنِ
u'سُؤَالٌ اِبْنٌ':Added, #1: 1	سُؤَالِ ابْنِ
u'سُؤَالٌ آحَادٌ':Added, #2: 2	سُؤَالُ ابْنِ
u'سُؤَالٌ أحَدٌ':Added, #1: 1	سُؤَالِ آحَادِ
u'سُؤَالٌ أَحْكَامٌ':Added, #1: 1	سُؤَالِ أَحَدٍ
u'سُؤَالٌ أَخٌ':Added, #1: 1	سُؤَالِ الْأَحْكَامِ
u'سُؤَالٌ اِخْتِلاَفٌ':Added, #1: 1	سُؤَالِ الْأَخِ
u'سُؤَالٌ اِخْتِلاَفٌ':Added, #1: 1	سُؤَالَ اخْتِلَافِ
u'سُؤَالٌ أرْضٌ':Added, #1: 1	سُؤَالِ اخْتِلَافِ
u'سُؤَالٌ اِسْتِخْبَارٌ':Added, #1: 1	سُؤَالِ الْأَرْضِ
u'سُؤَالٌ أَطْفَالٌ':Added, #2: 2	سُؤَالَ اسْتِخْبَارٍ
u'سُؤَالٌ اِعْتِراضٌ':Added, #1: 1	سُؤَالِ الْأَطْفَالِ
u'سُؤَالٌ الْمَرْءُ':Added, #1: 1	سُؤَالَ اعْتِرَاضٍ
u'سُؤَالٌ الْمَرْأَةُ':Added, #1: 1	سُؤَالِ الْمَرْءِ
u'سُؤَالٌ الْمَرْأَةُ':Added, #1: 1	سُؤَالَ الْمَرْأَةِ
u'سُؤَالٌ أُمٌّ':Added, #2: 2	سُؤَالُ الْمَرْأَةِ
u'سُؤَالٌ أُمٌّ':Added, #1: 1	سُؤَالُ أُمِّ
u'سُؤَالٌ إمَارَةٌ':Added, #1: 1	سُؤَالِ أُمِّ
u'سُؤَالٌ إمَامٌ':Added, #1: 1	سُؤَالُ الْإِمَارَةِ
u'سُؤَالٌ أهْلٌ':Added, #1: 1	سُؤَالِ الْإِمَامِ
u'سُؤَالٌ أهْلٌ':Added, #1: 1	سُؤَالُ أَهْلِ
u'سُؤَالٌ بَائِعٌ':Added, #1: 1	سُؤَالِ أَهْلِ
u'سُؤَالٌ بَائِعٌ':Added, #1: 1	سُؤَالَ الْبَائِعِ
u'سُؤَالٌ بَخِيلٌ':Added, #1: 1	سُؤَالِ الْبَائِعِ
u'سُؤَالٌ بَعْضٌ':Added, #1: 1	سُؤَالِ بَخِيلِ
u'سُؤَالٌ بَعْضٌ':Added, #1: 1	سُؤَالَ بَعْضِ
u'سُؤَالٌ بَعْضٌ':Added, #1: 1	سُؤَالُ بَعْضِ
u'سُؤَالٌ بعوثٌ':Added, #2: 2	سُؤَالُ الْبَعْضِ
u'سُؤَالٌ تَرْدِيدٌ':Added, #1: 1	سُؤَالِ الْبُعُوثِ
u'سُؤَالٌ تَرْدِيدٌ':Added, #1: 1	سُؤَالُ التَّرْدِيدِ
u'سُؤَالٌ تَرْكِيبٌ':Added, #1: 1	سُؤَالُ تَرْدِيدٍ
u'سُؤَالٌ تَعْدَادٌ':Added, #1: 1	سُؤَالُ التَّرْكِيبِ
u'سُؤَالٌ تَعَدِّي':Added, #1: 1	سُؤَالُ تَعْدَادِ
u'سُؤَالٌ تَعْدِيَة':Added, #1: 1	سُؤَالُ التَّعَدِّيَةِ
u'سُؤَالٌ تَعَنُّت':Added, #1: 1	سُؤَالُ التَّعْدِيَةِ
u'سُؤَالٌ تَعْيِينٌ':Added, #1: 1	سُؤَالَ التَّعَنُّتِ
u'سُؤَالٌ تَقْسِيمٌ':Added, #1: 1	سُؤَالُ التَّعْيِينِ
u'سُؤَالٌ تَوْبِيخٌ':Added, #1: 1	سُؤَالُ التَّقْسِيمِ
u'سُؤَالٌ تَوْفِيقٌ':Added, #1: 1	سُؤَالُ تَوْبِيخٍ
u'سُؤَالٌ تَيْسيرٌ':Added, #1: 1	سُؤَالَ التَّوْفِيقِ
u'سُؤَالٌ تَيْسيرٌ':Added, #1: 1	سُؤَالَ التَّيْسِيرِ
u'سُؤَالٌ جَاهِلٌ':Added, #1: 1	سُؤَالِ التَّيْسِيرِ
u'سُؤَالٌ جَمِيع':Added, #1: 1	سُؤَالُ جَاهِلٍ
u'سُؤَالٌ حاكِمٌ':Added, #1: 1	سُؤَالِ الْجَمِيعِ
u'سُؤَالٌ حُرِّيَّةٌ':Added, #2: 2	سُؤَالِ الْحَاكِمِ
u'سُؤَالٌ حَلْقٌ':Added, #2: 2	سُؤَالِ حُرِّيَّتِهِ
u'سُؤَالٌ حَنَفِيَّةٌ':Added, #1: 1	سُؤَالَ الْحَلْقِ
u'سُؤَالٌ خَصْمٌ':Added, #1: 1	سُؤَالُ الْحَنَفِيَّةِ
u'سُؤَالٌ خُلْعٌ':Added, #1: 1	سُؤَالُ خَصْمِهِ
u'سُؤَالٌ خلق':Added, #1: 1	سُؤَالِ الْخُلْعِ
u'سُؤَالٌ خَلْقٌ':Added, #1: 1	سُؤَالِ الْخَلْقِ
u'سُؤَالٌ رَبُّ':Added, #1: 1	سُؤَالِ الْخَلْقِ
u'سُؤَالٌ رِجَالٌ':Added, #1: 1	سُؤَال رَبِّ
u'سُؤَالٌ رَجُلٌ':Added, #1: 1	سُؤَالُ الرِّجَالِ
u'سُؤَالٌ رِزْقٌ':Added, #1: 1	سُؤَالُ الرَّجُلِ
u'سُؤَالٌ رَسُولٌ':Added, #1: 1	سُؤَالَ الرِّزْقِ
u'سُؤَالٌ زَيْدٌ':Added, #1: 1	سُؤَالِ الرَّسُولِ
u'سُؤَالٌ سائِل':Added, #2: 2	سُؤَالُ زَيْدٍ
u'سُؤَالٌ سَائِلٌ':Added, #1: 1	سُؤَالَ سَائِلٍ
u'سُؤَالٌ سائِل':Added, #1: 1	سُؤَالَ سَائِلٍ
u'سُؤَالٌ سائِل':Added, #2: 2	سُؤَالَ السَّائِلِ
u'سُؤَالٌ سَائِلٌ':Added, #2: 2	سُؤَالُ السَّائِلِ
u'سُؤَالٌ سَائِلٌ':Added, #2: 2	سُؤَالَ السَّائِلِ
u'سُؤَالٌ سائِل':Added, #2: 2	سُؤَالُ السَّائِلِ
u'سُؤَالٌ سَائِلٌ':Added, #3: 3	سُؤَالِ سَائِلٍ
u'سُؤَالٌ سائِل':Added, #3: 3	سُؤَالِ سَائِلٍ
u'سُؤَالٌ سَائِلٌ':Added, #6: 6	سُؤَالِ السَّائِلِ
u'سُؤَالٌ سُلْطَانٌ':Added, #6: 6	سُؤَالِ السَّائِلِ
u'سُؤَالٌ سلمة':Added, #1: 1	سُؤَالُ السُّلْطَانِ
u'سُؤَالٌ شَاهِدٌ':Added, #1: 1	سُؤَالِ سَلَمَةِ
u'سُؤَالٌ شَفِيعٌ':Added, #1: 1	سُؤَالَ الشَّاهِدَيْنِ
u'سُؤَالٌ شَهَادَةٌ':Added, #1: 1	سُؤَالِ شَفِيعِ
u'سُؤَالٌ شُهُودٌ':Added, #1: 1	سُؤَالَ شَهَادَةٍ
u'سُؤَالٌ شَيْءٌ':Added, #1: 1	سُؤَالُ الشُّهُودِ
u'سُؤَالٌ شَيْءٌ':Added, #1: 1	سُؤَالُ الشَّيْءِ
u'سُؤَالٌ شَيْخٌ':Added, #1: 1	سُؤَالِ الشَّيْءِ
u'سُؤَالٌ ضِيَافَةٌ':Added, #1: 1	سُؤَالُ الشَّيْخِ
u'سُؤَالٌ طعام':Added, #1: 1	سُؤَالُ الضِّيَافَةِ
u'سُؤَالٌ طعام':Added, #1: 1	سُؤَالَ الطَّعَامِ
u'سُؤَالٌ طَعَامٌ':Added, #1: 1	سُؤَالُ الطَّعَامِ
u'سُؤَالٌ طَعَامٌ':Added, #1: 1	سُؤَالَ الطَّعَامِ
u'سُؤَالٌ طَلاَقٌ':Added, #1: 1	سُؤَالُ الطَّعَامِ
u'سُؤَالٌ طَلاَقٌ':Added, #13: 13	سُؤَالِ الطَّلَاقِ
u'سُؤَالٌ طَلاَقٌ':Added, #2: 2	سُؤَالَ الطَّلَاقِ
u'سُؤَالٌ عَاصِمٌ':Added, #2: 2	سُؤَالُ الطَّلَاقِ
u'سُؤَالٌ عَافِي':Added, #1: 1	سُؤَالَ عَاصِمِ
u'سُؤَالٌ عَافِيَةٌ':Added, #1: 1	سُؤَالَ الْعَافِيَةِ
u'سُؤَالٌ عَالِمٌ':Added, #1: 1	سُؤَالَ الْعَافِيَةِ
u'سُؤَالٌ عَبْدٌ':Added, #1: 1	سُؤَالَ الْعَالِمِ
u'سُؤَالٌ عَدَمٌ':Added, #2: 2	سُؤَالِ الْعَبْدِ
u'سُؤَالٌ عَدَمٌ':Added, #1: 1	سُؤَالِ عَدَمِ
u'سُؤَالٌ عَكْسٌ':Added, #2: 2	سُؤَالَ عَدَمِ
u'سُؤَالٌ علماء':Added, #1: 1	سُؤَالُ الْعَكْسِ
u'سُؤَالٌ عُلَمَاءُ':Added, #2: 2	سُؤَالُ الْعُلَمَاءِ
u'سُؤَالٌ غَرِيمٌ':Added, #2: 2	سُؤَالُ الْعُلَمَاءِ
u'سُؤَالٌ غَرِيمٌ':Added, #1: 1	سُؤَالِ الْغَرِيمِ
u'سُؤَالٌ غُفْرَانٌ':Added, #1: 1	سُؤَالَ غَرِيمِ
u'سُؤَالٌ غَنِيٌّ':Added, #1: 1	سُؤَالِ الْغُفْرَانِ
u'سُؤَالٌ غير':Added, #1: 1	سُؤَالُ الْغَنِيِّ
u'سُؤَالٌ غَيْرٌ':Added, #1: 1	سُؤَالُ الْغَيْرِ
u'سُؤَالٌ غير':Added, #1: 1	سُؤَالُ الْغَيْرِ
u'سُؤَالٌ غَيْرٌ':Added, #3: 3	سُؤَالُ غَيْرِهِ
u'سُؤَالٌ فرق':Added, #3: 3	سُؤَالُ غَيْرِهِ
u'سُؤَالٌ فَرْقٌ':Added, #2: 2	سُؤَالُ الْفَرْقِ
u'سُؤَالٌ قَبْرٌ':Added, #2: 2	سُؤَالُ الْفَرْقِ
u'سُؤَالٌ قُبُورٌ':Added, #1: 1	سُؤَالَ الْقَبْرِ
u'سُؤَالٌ قلب':Added, #1: 1	سُؤَالَ الْقُبُورِ
u'سُؤَالٌ قَلْبٌ':Added, #1: 1	سُؤَالُ الْقَلْبِ
u'سُؤَالٌ قَلْب':Added, #1: 1	سُؤَالُ الْقَلْبِ
u'سُؤَالٌ قُوتٌ':Added, #1: 1	سُؤَالُ الْقَلْبِ
u'سُؤَالٌ كَاتِبٌ':Added, #1: 1	سُؤَالُ قُوتِ
u'سُؤَالٌ كَافِرٌ':Added, #1: 1	سُؤَالِ كَاتِبِهِ
u'سُؤَالٌ كَسْرٌ':Added, #1: 1	سُؤَالُ الْكَافِرِ
u'سُؤَالٌ كَسْرٌ':Added, #1: 1	سُؤَالَ الْكَسْرِ
u'سُؤَالٌ كِفَايَةٌ':Added, #2: 2	سُؤَالِ الْكَسْرِ
u'سُؤَالٌ كفر':Added, #2: 2	سُؤَالِ كِفَايَتِهِ
u'سُؤَالٌ كُفْرٌ':Added, #1: 1	سُؤَالَ الْكُفْرِ
u'سُؤَالٌ مَالِكٌ':Added, #1: 1	سُؤَالَ الْكُفْرِ
u'سُؤَالٌ مَالِكٌ':Added, #1: 1	سُؤَالِ الْمَالِكِ
u'سُؤَالٌ مُزَاحَمَةٌ':Added, #1: 1	سُؤَالَ مَالِكٍ
u'سُؤَالٌ مَسَاجِدُ':Added, #1: 1	سُؤَالَ الْمُزَاحَمَةِ
u'سُؤَالٌ مَسْجِدٌ':Added, #1: 1	سُؤَال الْمَسَاجِدِ
u'سُؤَالٌ مَسْجِدٌ':Added, #1: 1	سُؤَالَ الْمَسْجِدِ
u'سُؤَالٌ مُطَالَبٌ':Added, #1: 1	سُؤَالِ الْمَسْجِدِ
u'سُؤَالٌ مُطَالَبَةٌ':Added, #2: 2	سُؤَالُ الْمُطَالَبَةِ
u'سُؤَالٌ مُعَارَضَةٌ':Added, #2: 2	سُؤَالُ الْمُطَالَبَةِ
u'سُؤَالٌ مُعَارَضَةٌ':Added, #1: 1	سُؤَالَ الْمُعَارَضَةِ
u'سُؤَالٌ مُعَارَضَةٌ':Added, #1: 1	سُؤَالُ الْمُعَارَضَةِ
u'سُؤَالٌ مُعْتَرِضٌ':Added, #3: 3	سُؤَالِ الْمُعَارَضَةِ
u'سُؤَالٌ مَعْزُولٌ':Added, #1: 1	سُؤَالُ الْمُعْتَرِضِ
u'سُؤَالٌ مَغْفِرَةٌ':Added, #1: 1	سُؤَالُ الْمَعْزُولِ
u'سُؤَالٌ مَغْفِرَةٌ':Added, #2: 2	سُؤَالَ الْمَغْفِرَةِ
u'سُؤَالٌ مَغْفِرَةٌ':Added, #2: 2	سُؤَالُ الْمَغْفِرَةِ
u'سُؤَالٌ مُقَدَّرٌ':Added, #2: 2	سُؤَالِ الْمَغْفِرَةِ
u'سُؤَالٌ مَلاَئِكَةٌ':Added, #17: 17	سُؤَالٍ مُقَدَّرٍ
u'سُؤَالٌ مَلَكٌ':Added, #1: 1	سُؤَالِ الْمَلَائِكَةِ
u'سُؤَالٌ مِلْكٌ':Added, #1: 1	سُؤَالَ الْمَلَكَيْنِ
u'سُؤَالٌ مَلَكٌ':Added, #1: 1	سُؤَالَ مِلْكِ
u'سُؤَالٌ مَلَكٌ':Added, #2: 2	سُؤَالُ الْمَلَكَيْنِ
u'سُؤَالٌ مُنَافِقٌ':Added, #8: 8	سُؤَالِ الْمَلَكَيْنِ
u'سُؤَالٌ مُنْكَرٌ':Added, #1: 1	سُؤَالِ الْمُنَافِقِ
u'سُؤَالٌ مُنْكِرٌ':Added, #1: 1	سُؤَالِ مُنْكَرٍ
u'سُؤَالٌ مُودَعٌ':Added, #1: 1	سُؤَالُ مُنْكِرٍ
u'سُؤَالٌ نَاسٌ':Added, #1: 1	سُؤَالَ الْمُودَعِ
u'سُؤَالٌ نَاسٌ':Added, #2: 2	سُؤَالَ النَّاسِ
u'سُؤَالٌ نَاسٌ':Added, #2: 2	سُؤَالُ النَّاسِ
u'سُؤَالٌ نَبِيٌّ':Added, #2: 2	سُؤَالِ النَّاسِ
u'سُؤَالٌ نَبِيٌّ':Added, #2: 2	سُؤَالُ النَّبِيِّ
u'سُؤَالٌ نَحْرٌ':Added, #2: 2	سُؤَالِ النَّبِيِّ
u'سُؤَالٌ واحد':Added, #1: 1	سُؤَالِ النَّحْرِ
u'سُؤَالٌ وَاحِدٌ':Added, #4: 4	سُؤَالٍ وَاحِدٍ
u'سُؤَالٌ وَجْهٌ':Added, #4: 4	سُؤَالٍ وَاحِدٍ
u'سُؤَالٌ وِلاَيَةٌ':Added, #1: 1	سُؤَالَ وَجْهِ
u'سُؤَالٌ يهود':Added, #1: 1	سُؤَالَ وِلَايَةٍ
u'سُؤَالٌ يَهُودٌ':Added, #1: 1	سُؤَالُ الْيَهُودِ
u'سَوَّدَ أنَامِلُ':Predicate, #1: 1	سُؤَالُ الْيَهُودِ
u'سود حَدَقٌ':Added, #2: 2	سَوَّدَ أَنَامِلَ
u'سُودٌ حَدَقٌ':Added, #1: 1	سُودِ الْحَدَقِ
u'سود حَدَق':Added, #1: 1	سُودِ الْحَدَقِ
u'سُودٌ حَدَق':Added, #1: 1	سُودِ الْحَدَقَةِ
u'سود حَدَقَة':Added, #1: 1	سُودِ الْحَدَقَةِ
u'سُودٌ حَدَقَة':Added, #1: 1	سُودِ الْحَدَقَةِ
u'سَوَّدَ صَحِيفَةٌ':Predicate, #1: 1	سُودِ الْحَدَقَةِ
u'سَوَّدَ كَفٌّ':Predicate, #1: 1	سَوَّدَ الصَّحِيفَةَ
u'سود كلاب':Added, #1: 1	سَوَّدَ كَفَّ
u'سُودٌ كلاب':Added, #1: 1	سُودِ الْكِلَابِ
u'سود كِلاَبٌ':Added, #1: 1	سُودِ الْكِلَابِ
u'سُودٌ كِلاَبٌ':Added, #1: 1	سُودِ الْكِلَابِ
u'سَوْرَةٌ اِبْنٌ':Added, #1: 1	سُودِ الْكِلَابِ
u'سَوْرَةٌ جُوعٌ':Added, #1: 1	سَوْرَةَ ابْنِ
u'سَوْرَةٌ حُزْنٌ':Added, #1: 1	سَوْرَةَ الْجُوعِ
u'سَوْرَةٌ خِلاَفٌ':Added, #1: 1	سَوْرَةَ حُزْنِهِ
u'سَوْرَةٌ مُتَطَاوِلٌ':Added, #1: 1	سَوْرَةُ الْخِلَافِ
u'سوسَةٌ شَيْطَانٌ':Added, #2: 2	سَوْرَةُ الْمُتَطَاوِلِ
u'سوسَةٌ شَيْطَانٌ':Added, #1: 1	وَسْوَسَةِ الشّيْطَانِ
u'سوسَةٌ ظاهِرٌ':Added, #2: 2	وَسْوَسَةِ الشَّيْطَانِ
u'سوسَةٌ ظاهِرَة':Added, #1: 1	وَسْوَسَةٍ ظَاهِرَةٍ
u'سوسَةٌ نَفْسٌ':Added, #1: 1	وَسْوَسَةٍ ظَاهِرَةٍ
u'سوسَةٌ نَفْسٌ':Added, #1: 1	وَسْوَسَةُ النَّفْسِ
u'سَوْطٌ أدَب':Added, #1: 1	وَسْوَسَةِ النَّفْسِ
u'سَوْطٌ حَدٌّ':Added, #1: 1	سَوْطُ الْأَدَبِ
u'سَوْطٌ حُرٌّ':Added, #2: 2	سَوْطُ الْحَدِّ
u'سَوْطٌ عَبْدٌ':Added, #1: 1	سَوْطِ الْحُرِّ
u'سَوْطٌ عَبْدٌ':Added, #1: 1	سَوْطُ الْعَبْدِ
u'سَوْطٌ واحد':Added, #1: 1	سَوْطُ عَبْدٍ
u'سَوْطٌ وَاحِدٌ':Added, #1: 1	سَوْطٍ وَاحِدٍ
u'سَوَّغَ اِجْتِهَادٌ':Predicate, #1: 1	سَوْطٍ وَاحِدٍ
u'سَوَّغَ اِسْتِعْمالٌ':Predicate, #1: 1	سَوَّغَ اجْتِهَادَ
u'سَوَّغَ أَكْثَرُ':Subject, #1: 1	سَوَّغَ اسْتِعْمَالَ
u'سَوَّغَ تَكَلُّمٌ':Predicate, #1: 1	سَوَّغَ الْأَكْثَرُ
u'سَوَّلَ شَيْطَانٌ':Subject, #1: 1	سَوَّغَ التَّكَلُّمَ
u'سَوَّى اِبْنٌ':Subject, #1: 1	سَوَّلَ الشَّيْطَانُ
u'سَوَّى آدَمِيٌّ':Subject, #1: 1	سَوَّى ابْنُ
u'سَوَّى أرْضٌ':Predicate, #1: 1	سَوَّى الْآدَمِيُّ
u'سَوَّى أَصْحَابٌ':Subject, #2: 2	سَوَّى الْأَرْضَ
u'سَوَّى أصل':Subject, #1: 1	سَوَّى الْأَصْحَابُ
u'سَوَّى أًصْلٌ':Subject, #2: 2	سَوَّى الْأَصْلُ
u'سَوَّى بَعْضٌ':Subject, #2: 2	سَوَّى الْأَصْلُ
u'سَوَّى بَيْنٌ':Predicate, #2: 2	سَوَّى بَعْضُ
u'سَوَّى رَسُولٌ':Subject, #63: 63	سَوَّى بَيْنَ
u'سَوَّى شَارِعٌ':Subject, #1: 1	سَوَّى رَسُولُ
u'سَوَّى شَرْعٌ':Subject, #1: 1	سَوَّى الشَّارِعُ
u'سَوَّى شَيْخٌ':Subject, #1: 1	سَوَّى الشَّرْعُ
u'سَوَّى صَاحِبٌ':Subject, #3: 3	سَوَّى الشَّيْخُ
u'سَوَّى فخر':Subject, #1: 1	سَوَّى صَاحِبُ
u'سَوَّى فَخْرٌ':Subject, #2: 2	سَوَّى فَخْرُ
u'سَوَّى قَبْرٌ':Predicate, #2: 2	سَوَّى فَخْرُ
u'سَوَّى كَثِيبٌ':Predicate, #1: 1	سَوَّى الْقَبْرَ
u'سَوَّى لبن':Predicate, #1: 1	سَوَّى الْكَثِيبَ
u'سَوَّى لَبِنٌ':Predicate, #1: 1	سَوَّى اللَّبِنَ
u'سَوَّى لُحُودٌ':Predicate, #1: 1	سَوَّى اللَّبِنَ
u'سَوَّى مُصَنِّفٌ':Subject, #1: 1	سَوَّى لُحُودَ
u'سَوَّى وَاقِفٌ':Subject, #4: 4	سَوَّى الْمُصَنِّفُ
u'سَيَّبَ سَوَائِبُ':Predicate, #2: 2	سَوَّى الْوَاقِفُ
u'سَيْرٌ إِبِلٌ':Added, #7: 7	سَيَّبَ السَّوَائِبَ
u'سَيْرٌ إِبِلٌ':Added, #1: 1	سَيْرُ الْإِبِلِ
u'سَيْرٌ اِبْنٌ':Added, #2: 2	سَيْرَ الْإِبِلِ
u'سَيْرٌ بَحْرٌ':Added, #1: 1	سَيْرِ ابْنِ
u'سَيْرٌ بَحْرٌ':Added, #1: 1	سَيْرَ الْبَحْرِ
u'سَيْرٌ بَرٌّ':Added, #2: 2	سَيْرُ الْبَحْرِ
u'سَيْرٌ بَريدٌ':Added, #2: 2	سَيْرَ الْبَرِّ
u'سَيْرٌ بَطِيئة':Added, #1: 1	سَيْرُ الْبَرِيدِ
u'سَيْرٌ بَقَرٌ':Added, #1: 1	سَيْرَ بَطِيئَةِ
u'سَيْرٌ ثَلاثَةٌ':Added, #1: 1	سَيْرُ الْبَقَرِ
u'سَيْرٌ ثَلاثَةٌ':Added, #1: 1	سَيْرِ الثَّلَاثَةِ
u'سَيْرٌ جَيْشٌ':Added, #1: 1	سَيْرِ ثَلَاثَةِ
u'سَيْرٌ دَابَّةٌ':Added, #1: 1	سَيْرَ الْجَيْشِ
u'سَيْرٌ دَابَّةٌ':Added, #17: 17	سَيْرَ الدَّابَّةِ
u'سَيْرٌ دَوَابُّ':Added, #3: 3	سَيْرِ الدَّابَّةِ
u'سَيْرٌ رفقة':Added, #1: 1	سَيْرُ الدَّوَابِّ
u'سَيْرٌ رُفْقَةٌ':Added, #1: 1	سَيْرِ الرُّفْقَةِ
u'سَيْرٌ زَيْدٌ':Added, #1: 1	سَيْرِ الرُّفْقَةِ
u'سَيْرٌ سَحَرٌ':Added, #1: 1	سَيْرِ زَيْدٍ
u'سَيْرٌ سَفِينَةٌ':Added, #1: 1	سَيْرُ السَّحَرِ
u'سَيْرٌ سَفِينَةٌ':Added, #1: 1	سَيْرَ السَّفِينَةِ
u'سَيْرٌ شمس':Added, #1: 1	سَيْرِ السَّفِينَةِ
u'سَيْرٌ شَمْسٌ':Added, #2: 2	سَيْرَ الشَّمْسِ
u'سَيَّرَ صَبِيٌّ':Subject, #2: 2	سَيْرَ الشَّمْسِ
u'سَيْرٌ عجلة':Added, #1: 1	سَيَّرَ الصَّبِيُّ
u'سَيْرٌ عَجَلَةٌ':Added, #1: 1	سَيْرُ الْعَجَلَةِ
u'سَيْرٌ فَرَسٌ':Added, #1: 1	سَيْرُ الْعَجَلَةِ
u'سَيْرٌ فَرَسٌ':Added, #1: 1	سَيْرُ الْفَرَسِ
u'سَيْرٌ كُتُبٌ':Added, #1: 1	سَيْرِ الْفَرَسِ
u'سَيْرٌ لَيْلٌ':Added, #1: 1	سَيْرِ الْكُتُبِ
u'سَيْرٌ لَيْلٌ':Added, #1: 1	سَيْرُ اللَّيْلِ
u'سَيْرٌ مُدَّةٌ':Added, #1: 1	سَيْرِ اللَّيْلِ
u'سَيْرٌ مَطِيَّةٌ':Added, #1: 1	سَيْرِ مُدَّةِ
u'سَيْرٌ مُوَكَّلٌ':Added, #1: 1	سَيْرَ مَطِيَّةِ
u'سَيْرٌ نَاسٌ':Added, #1: 1	سَيْرُ الْمُوَكَّلِ
u'سَيْرٌ نهار':Added, #1: 1	سَيْرِ النَّاسِ
u'سَيْرٌ نَهَارٌ':Added, #1: 1	سَيْرُ النَّهَارِ
u'سَيْرٌ يَوْمٌ':Added, #1: 1	سَيْرُ النَّهَارِ
u'شَاءَ أَبٌ':Predicate, #1: 1	سَيْرُ يَوْمَيْنِ
u'شَاءَ أُجْرَةٌ':Predicate, #1: 1	شَاءَ الْأَبَ
u'شَاءَ أَجْنَبِيٌّ':Subject, #1: 1	شَاءَ أُجْرَةَ
u'شَاءَ أحَدٌ':Subject, #2: 2	شَاءَ الْأَجْنَبِيُّ
u'شَاءَ أخْذٌ':Predicate, #1: 1	شَاءَ أَحَدٌ
u'شَاءَ أَرْبَعُ':Subject, #1: 1	شَاءَ أَخْذَ
u'شَاءَ اِسْتَثْبَت':Predicate, #1: 1	شَاءَ أَرْبَعُ
u'شَاءَ اِصْطاد':Predicate, #1: 1	شَاءَ اسْتَثْبَتَ
u'شَاءَ أَصيلٌ':Predicate, #1: 1	شَاءَ اصْطَادَ
u'شَاءَ أقْرَع':Predicate, #2: 2	شَاءَ الْأَصِيلَ
u'شَاءَ أكل':Predicate, #6: 6	شَاءَ أَقْرَعَ
u'شَاءَ أَكْمَلُ':Predicate, #2: 2	شَاءَ أَكَلَ
u'شَاءَ المُشْتَرِي':Predicate, #2: 2	شَاءَ أَكْمَلَ
u'شَاءَ إمَامٌ':Subject, #1: 1	شَاءَ الْمُشْتَرِيَ
u'شَاءَ آمِرٌ':Subject, #21: 21	شَاءَ الْإِمَامُ
u'شَاءَ أَمْس':Predicate, #1: 1	شَاءَ الْآمِرُ
u'شَاءَ أهْلٌ':Subject, #36: 36	شَاءَ أَمْسَكَ
u'شَاءَ أوْسَطُ':Subject, #1: 1	شَاءَ أَهْلُ
u'شَاءَ أَوْلِيَاءُ':Subject, #1: 1	شَاءَ الْأَوْسَطُ
u'شَاءَ بَاعٌ':Predicate, #4: 4	شَاءَ الْأَوْلِيَاءُ
u'شَاءَ بَائِعٌ':Subject, #3: 3	شَاءَ بَاعَ
u'شَاءَ بَرٌّ':Predicate, #11: 11	شَاءَ الْبَائِعُ
u'شَاءَ تَدْبِيرٌ':Predicate, #2: 2	شَاءَ بَرَّ
u'شَاءَ ثَالِثٌ':Subject, #1: 1	شَاءَ التَّدْبِيرَ
u'شَاءَ ثَمَنٌ':Predicate, #1: 1	شَاءَ الثَّالِثُ
u'شَاءَ جَازٌ':Predicate, #2: 2	شَاءَ الثَّمَنَ
u'شَاءَ جمع':Predicate, #4: 4	شَاءَ جَازَ
u'شَاءَ جِنٌّ':Subject, #2: 2	شَاءَ جَمَعَ
u'شَاءَ جهر':Predicate, #2: 2	شَاءَ الْجِنُّ
u'شَاءَ جهر':Predicate, #15: 15	شَاءَ جَهَرَ
u'شَاءَ جَهْرٌ':Predicate, #1: 1	شَاءَ الْجَهْرَ
u'شَاءَ حَجٌّ':Predicate, #1: 1	شَاءَ الْجَهْرَ
u'شَاءَ حَضَرٌ':Predicate, #3: 3	شَاءَ حَجَّ
u'شَاءَ حَكَمٌ':Predicate, #1: 1	شَاءَ حَضَرَ
u'شَاءَ حَكِيمٌ':Subject, #8: 8	شَاءَ حَكَمَ
u'شَاءَ حَلٌّ':Subject, #1: 1	شَاءَ الْحَكِيمُ
u'شَاءَ حِلٌّ':Subject, #1: 1	شَاءَ حَلُّهُ
u'شَاءَ حَمَلٌ':Predicate, #1: 1	شَاءَ حِلُّهُ
u'شَاءَ خَلْفٌ':Predicate, #1: 1	شَاءَ حَمَلَ
u'شَاءَ خَمْسٌ':Predicate, #1: 1	شَاءَ خَلْفَ
u'شَاءَ خَمْسَةٌ':Predicate, #2: 2	شَاءَ خَمْسَ
u'شَاءَ دَافِعٌ':Subject, #1: 1	شَاءَ خَمْسَةَ
u'شَاءَ دَائِنٌ':Subject, #3: 3	شَاءَ الدَّافِعُ
u'شَاءَ دَخَلٌ':Predicate, #1: 1	شَاءَ الدَّائِنُ
u'شَاءَ دفع':Predicate, #4: 4	شَاءَ دَخَلَ
u'شَاءَ ذكر':Predicate, #33: 33	شَاءَ دَفَعَ
u'شَاءَ ذَكَرٌ':Predicate, #1: 1	شَاءَ ذَكَرَ
u'شَاءَ ذَهَبٌ':Predicate, #1: 1	شَاءَ ذَكَرَ
u'شَاءَ رَاجِعٌ':Predicate, #4: 4	شَاءَ ذَهَبَ
u'شَاءَ رَاهِنٌ':Predicate, #1: 1	شَاءَ رَاجِعَ
u'شَاءَ رَاهِنٌ':Subject, #2: 2	شَاءَ الرَّاهِنَ
u'شَاءَ رَبُّ':Subject, #10: 10	شَاءَ الرَّاهِنُ
u'شَاءَ رُبْعٌ':Predicate, #17: 17	شَاءَ رَبُّ
u'شَاءَ رَجُلٌ':Subject, #1: 1	شَاءَ رُبْعَ
u'شَاءَ رَجُلٌ':Subject, #1: 1	شَاءَ الرَّجُلُ
u'شَاءَ رَدٌّ':Predicate, #1: 1	شَاءَ رَجُلٌ
u'شَاءَ ركب':Predicate, #59: 59	شَاءَ رَدَّ
u'شَاءَ زادٌ':Predicate, #3: 3	شَاءَ رَكِبَ
u'شَاءَ زَوْجٌ':Subject, #9: 9	شَاءَ زَادَ
u'شَاءَ زَيْدٌ':Subject, #6: 6	شَاءَ الزَّوْجُ
u'شَاءَ سَاعَةٌ':Predicate, #24: 24	شَاءَ زَيْدٌ
u'شَاءَ سَاكِتٌ':Subject, #2: 2	شَاءَ سَاعَةَ
u'شَاءَ سَامِعٌ':Subject, #1: 1	شَاءَ السَّاكِتُ
u'شَاءَ سَواءٌ':Subject, #1: 1	شَاءَ السَّامِعُ
u'شَاءَ سَيِّدٌ':Subject, #1: 1	شَاءَ سَوَاءٌ
u'شَاءَ سَيِّدٌ':Subject, #1: 1	شَاءَ السَّيِّدُ
u'شَاءَ شَرِيكٌ':Subject, #2: 2	شَاءَ سَيِّدُهُ
u'شَاءَ شَرِيكٌ':Subject, #1: 1	شَاءَ شَرِيكُ
u'شَاءَ شَقٌّ':Predicate, #4: 4	شَاءَ الشَّرِيكُ
u'شَاءَ صَاحِبٌ':Subject, #1: 1	شَاءَ شَقَّ
u'شَاءَ صَاحِبٌ':Subject, #12: 12	شَاءَ صَاحِبُ
u'شَاءَ صبر':Predicate, #2: 2	شَاءَ صَاحِبُهُ
u'شَاءَ صَرْفٌ':Predicate, #21: 21	شَاءَ صَبَرَ
u'شَاءَ صَرْف':Predicate, #1: 1	شَاءَ الصَّرْفَ
u'شَاءَ صنع':Predicate, #1: 1	شَاءَ الصَّرْفَ
u'شَاءَ صِيَامٌ':Predicate, #2: 2	شَاءَ صَنَعَ
u'شَاءَ ضَرَبٌ':Predicate, #1: 1	شَاءَ الصِّيَامَ
u'شَاءَ ضَمٌّ':Predicate, #1: 1	شَاءَ ضَرَبَ
u'شَاءَ ضَمِنٌ':Predicate, #2: 2	شَاءَ ضَمَّ
u'شَاءَ طَافٌ':Predicate, #53: 53	شَاءَ ضَمِنَ
u'شَاءَ طَالِبٌ':Subject, #1: 1	شَاءَ طَافَ
u'شَاءَ طَاهِرٌ':Predicate, #2: 2	شَاءَ الطَّالِبُ
u'شَاءَ طلب':Predicate, #1: 1	شَاءَ طَاهِرَةً
u'شَاءَ طَلَبٌ':Predicate, #2: 2	شَاءَ طَلَبَ
u'شَاءَ عَادٌ':Predicate, #2: 2	شَاءَ طَلَبَ
u'شَاءَ عَبْدٌ':Subject, #8: 8	شَاءَ عَادَ
u'شَاءَ عتق':Predicate, #2: 2	شَاءَ الْعَبْدُ
u'شَاءَ عِتْقٌ':Predicate, #5: 5	شَاءَ الْعِتْقَ
u'شَاءَ عجز':Predicate, #5: 5	شَاءَ الْعِتْقَ
u'شَاءَ عُدٌّ':Predicate, #4: 4	شَاءَ عَجَزَ
u'شَاءَ عَدْلٌ':Subject, #1: 1	شَاءَ عُدَّ
u'شَاءَ عَدَمٌ':Predicate, #3: 3	شَاءَ الْعَدْلُ
u'شَاءَ عرف':Predicate, #1: 1	شَاءَ عَدَمَ
u'شَاءَ عَمَلٌ':Predicate, #1: 1	شَاءَ عَرَفَ
u'شَاءَ عُمُومٌ':Predicate, #1: 1	شَاءَ عَمَلَ
u'شَاءَ عند':Predicate, #1: 1	شَاءَ الْعُمُومَ
u'شَاءَ عين':Predicate, #10: 10	شَاءَ عِنْدَ
u'شَاءَ عَيْنٌ':Predicate, #1: 1	شَاءَ عَيْنَ
u'شَاءَ عَيْن':Predicate, #1: 1	شَاءَ عَيْنَ
u'شَاءَ غَاصِبٌ':Subject, #1: 1	شَاءَ عَيْنَ
u'شَاءَ غرماء':Subject, #1: 1	شَاءَ الْغَاصِبُ
u'شَاءَ غَرِيمٌ':Subject, #4: 4	شَاءَ الْغُرَمَاءُ
u'شَاءَ غفر':Predicate, #1: 1	شَاءَ الْغَرِيمُ
u'شَاءَ غَفَرٌ':Predicate, #20: 20	شَاءَ غَفَرَ
u'شَاءَ غير':Predicate, #20: 20	شَاءَ غَفَرَ
u'شَاءَ غَيْرٌ':Predicate, #7: 7	شَاءَ غَيْرَ
u'شَاءَ فَسْخٌ':Predicate, #7: 7	شَاءَ غَيْرَ
u'شَاءَ فُلاَنٌ':Subject, #2: 2	شَاءَ فَسْخَ
u'شَاءَ فُلاَنٌ':Subject, #1: 1	شَاءَ فُلاَنٌ
u'شَاءَ قَابِضٌ':Predicate, #55: 55	شَاءَ فُلَانٌ
u'شَاءَ قَالٌ':Predicate, #1: 1	شَاءَ الْقَابِضَ
u'شَاءَ قِبَلٌ':Predicate, #38: 38	شَاءَ قَالَ
u'شَاءَ قتل':Predicate, #1: 1	شَاءَ قِبَلَ
u'شَاءَ قَرَوِيٌّ':Subject, #9: 9	شَاءَ قَتَلَ
u'شَاءَ قنع':Predicate, #1: 1	شَاءَ الْقَرَوِيُّ
u'شَاءَ قِيَادٌ':Predicate, #2: 2	شَاءَ قَنَعَ
u'شَاءَ كَاتِبٌ':Subject, #1: 1	شَاءَ قِيَادَ
u'شَاءَ كَفِيلٌ':Predicate, #2: 2	شَاءَ الْكَاتِبُ
u'شَاءَ كَفِيلٌ':Subject, #1: 1	شَاءَ الْكَفِيلَ
u'شَاءَ مَالٌ':Predicate, #1: 1	شَاءَ الْكَفِيلُ
u'شَاءَ مَالِكٌ':Subject, #2: 2	شَاءَ مَالَ
u'شَاءَ مَالِكٌ':Subject, #1: 1	شَاءَ مَالِكُهُ
u'شَاءَ مُباهَلَة':Predicate, #6: 6	شَاءَ الْمَالِكُ
u'شَاءَ مثل':Subject, #1: 1	شَاءَ الْمُبَاهَلَةَ
u'شَاءَ مِثْلٌ':Subject, #1: 1	شَاءَ مِثْلُ
u'شَاءَ مَجْنِيٌّ':Subject, #1: 1	شَاءَ مِثْلُ
u'شَاءَ مُخَاطَبٌ':Subject, #1: 1	شَاءَ الْمَجْنِيُّ
u'شَاءَ مُدَبِّرٌ':Subject, #2: 2	شَاءَ الْمُخَاطَبُ
u'شَاءَ مرٌّ':Predicate, #2: 2	شَاءَ الْمُدَبِّرُ
u'شَاءَ مُرْتَهِنٌ':Predicate, #11: 11	شَاءَ مَرَّةً
u'شَاءَ مُرْتَهِنٌ':Subject, #1: 1	شَاءَ الْمُرْتَهِنَ
u'شَاءَ مُزَارِعٌ':Predicate, #6: 6	شَاءَ الْمُرْتَهِنُ
u'شَاءَ مُسَافِرٌ':Subject, #1: 1	شَاءَ الْمُزَارِعَ
u'شَاءَ مَسْبُوق':Subject, #1: 1	شَاءَ الْمُسَافِرُ
u'شَاءَ مُسْتَبْضِع':Predicate, #1: 1	شَاءَ مَسْبُوقٌ
u'شَاءَ مُسْتَحِقٌّ':Subject, #1: 1	شَاءَ الْمُسْتَبْضِعَ
u'شَاءَ مُسْتَعِيرٌ':Subject, #5: 5	شَاءَ الْمُسْتَحِقُّ
u'شَاءَ مُشْتَرِي':Predicate, #1: 1	شَاءَ الْمُسْتَعِيرُ
u'شَاءَ مُصَدِّقٌ':Subject, #1: 1	شَاءَ الْمُشْتَرِيَ
u'شَاءَ مُضَارِبٌ':Subject, #1: 1	شَاءَ الْمُصَدِّقُ
u'شَاءَ مَطْلُوبٌ':Subject, #4: 4	شَاءَ الْمُضَارِبُ
u'شَاءَ مُعْتَقٌ':Predicate, #1: 1	شَاءَ الْمَطْلُوبُ
u'شَاءَ مُعْتَقٌ':Subject, #1: 1	شَاءَ الْمُعْتَقَ
u'شَاءَ مُعِير':Subject, #2: 2	شَاءَ الْمُعْتَقُ
u'شَاءَ مُقْرِضٌ':Subject, #5: 5	شَاءَ الْمُعِيرُ
u'شَاءَ مُقَلِّدٌ':Subject, #1: 1	شَاءَ الْمُقْرِضُ
u'شَاءَ مُقَيَّدٌ':Subject, #1: 1	شَاءَ الْمُقَلِّدُ
u'شَاءَ مُكْرِهٌ':Predicate, #1: 1	شَاءَ مُقَيَّدَةٌ
u'شَاءَ مَمْنُوعٌ':Subject, #2: 2	شَاءَ الْمُكْرِهَ
u'شَاءَ مُمَيِّزٌ':Predicate, #1: 1	شَاءَ مَمْنُوعٌ
u'شَاءَ مُمَيِّزٌ':Subject, #1: 1	شَاءَ مُمَيِّزَ
u'شَاءَ مَنٌّ':Predicate, #1: 1	شَاءَ مُمَيِّزٌ
u'شَاءَ مُنْكِرٌ':Subject, #5: 5	شَاءَ مَنَّ
u'شَاءَ مَوْهُوبٌ':Predicate, #3: 3	شَاءَ الْمُنْكِرُ
u'شَاءَ مَوْهُوبٌ':Subject, #1: 1	شَاءَ الْمَوْهُوبَ
u'شَاءَ نَاسٌ':Subject, #1: 1	شَاءَ الْمَوْهُوبُ
u'شَاءَ نَبِيٌّ':Subject, #1: 1	شَاءَ النَّاسُ
u'شَاءَ نَزَلٌ':Predicate, #1: 1	شَاءَ النَّبِيُّ
u'شَاءَ نَظَرٌ':Predicate, #1: 1	شَاءَ نَزَلَ
u'شَاءَ نَفَلٌ':Predicate, #1: 1	شَاءَ نَظَرَ
u'شَاءَ نُقْصَانٌ':Predicate, #1: 1	شَاءَ نَفَلَ
u'شَاءَ نَقْضٌ':Predicate, #1: 1	شَاءَ نُقْصَانَ
u'شَاءَ نقل':Predicate, #1: 1	شَاءَ نَقْضَ
u'شَاءَ نَقَلٌ':Predicate, #1: 1	شَاءَ نَقَلَ
u'شَاءَ نَوىً':Predicate, #1: 1	شَاءَ نَقَلَ
u'شَاءَ نَوًى':Predicate, #1: 1	شَاءَ نَوَىَ
u'شَاءَ واحد':Predicate, #1: 1	شَاءَ نَوَىَ
u'شَاءَ وَاحِدٌ':Predicate, #1: 1	شَاءَ وَاحِدَةً
u'شَاءَ وَارِثٌ':Subject, #1: 1	شَاءَ وَاحِدَةً
u'شَاءَ وَارِثٌ':Subject, #1: 1	شَاءَ الْوَارِثُ
u'شَاءَ وَاقِفٌ':Subject, #1: 1	شَاءَ وَارِثُهُ
u'شَاءَ وَرَثَةٌ':Subject, #1: 1	شَاءَ الْوَاقِفُ
u'شَاءَ وَرَثَةٌ':Subject, #1: 1	شَاءَ الْوَرَثَةُ
u'شَاءَ وصل':Predicate, #1: 1	شَاءَ وَرَثَةُ
u'شَاءَ وَطْءٌ':Predicate, #1: 1	شَاءَ وَصَلَ
u'شَاءَ وُقُوعٌ':Predicate, #1: 1	شَاءَ وَطْءَ
u'شَاءَ وَكِيلٌ':Predicate, #1: 1	شَاءَ وُقُوعَ
u'شَاءَ وَكِيلٌ':Subject, #1: 1	شَاءَ الْوَكِيلَ
u'شَاءَ وَلَهٌ':Subject, #1: 1	شَاءَ الْوَكِيلُ
u'شَاءَ وَلِيٌّ':Subject, #3: 3	شَاءَ وَلَهُ
u'شَاءَ وَلِيٌّ':Subject, #1: 1	شَاءَ وَلِيُّ
u'شَاءَ يَوْمٌ':Predicate, #3: 3	شَاءَ الْوَلِيُّ
u'شَابَ دَرَاهِمُ':Predicate, #2: 2	شَاءَ يَوْمَ
u'شَابَ رَأْسٌ':Subject, #1: 1	شَابَ الدَّرَاهِمَ
u'شَابَ رَأْسٌ':Subject, #2: 2	شَابَ رَأْسُ
u'شَابَهَ بَقَرٌ':Predicate, #2: 2	شَابَ رَأْسُهُ
u'شَابَهَ حالٌ':Subject, #1: 1	شَابَهَ الْبَقَرَ
u'شَابَهَ دُعَاءٌ':Predicate, #1: 1	شَابَهَ حَالُهُ
u'شَابَهَ فَرْعٌ':Subject, #1: 1	شَابَهَ الدُّعَاءَ
u'شَارَ أَبٌ':Predicate, #1: 1	شَابَهَ الْفَرْعُ
u'شَارَ اِبْنٌ':Subject, #4: 4	شَارَكَ الْأَبَ
u'شَارَ أَجْنَبِيٌّ':Predicate, #23: 23	أَشَارَ ابْنُ
u'شَارَ أَصْحَابٌ':Subject, #1: 1	شَارَكَ الْأَجْنَبِيَّ
u'شَارَ أصل':Predicate, #2: 2	أَشَارَ الْأَصْحَابُ
u'شَارَ أًصْلٌ':Predicate, #1: 1	شَارَكَ الْأَصْلَ
u'شَارَ أصل':Subject, #1: 1	شَارَكَ الْأَصْلَ
u'شَارَ أًصْلٌ':Subject, #1: 1	أَشَارَ الْأَصْلُ
u'شَارَ إمَامٌ':Predicate, #1: 1	أَشَارَ الْأَصْلُ
u'شَارَ إمَامٌ':Subject, #1: 1	شَارَكَ الْإِمَامَ
u'شَارَ إمَامٌ':Subject, #1: 1	أَشَارَ إمَامُ
u'شَارَ أَوَّلُ':Predicate, #8: 8	أَشَارَ الْإِمَامُ
u'شَارَ بُخَارِيٌّ':Subject, #2: 2	شَارَكَ الْأَوَّلَ
u'شَارَ بَعْضٌ':Subject, #1: 1	أَشَارَ الْبُخَارِيُّ
u'شَارَ بَهائِمُ':Predicate, #5: 5	أَشَارَ بَعْضُ
u'شَارَ جَلاَلٌ':Subject, #1: 1	شَارَكَ الْبَهَائِمَ
u'شَارَ حاضِرٌ':Subject, #1: 1	أَشَارَ الْجَلَالُ
u'شَارَ حاكِمٌ':Subject, #1: 1	أَشَارَ حَاضِرٌ
u'شَارَ حَديثٌ':Subject, #3: 3	أَشَارَ الْحَاكِمُ
u'شَارَ حُرٌّ':Predicate, #1: 1	أَشَارَ الْحَدِيثُ
u'شَارَ خَاطِئٌ':Predicate, #1: 1	شَارَكَ الْحُرَّ
u'شَارَ رَسُولٌ':Subject, #1: 1	شَارَكَ الْخَاطِئَ
u'شَارَ زَوْجٌ':Predicate, #13: 13	أَشَارَ رَسُولُ
u'شَارَ زَوْجٌ':Subject, #1: 1	شَارَكَ الزَّوْجَ
u'شَارَ سائِل':Subject, #1: 1	أَشَارَ الزَّوْجُ
u'شَارَ سَائِلٌ':Subject, #2: 2	أَشَارَ السَّائِلُ
u'شَارَ سَهْمٌ':Predicate, #2: 2	أَشَارَ السَّائِلُ
u'شَارَ سَيِّدٌ':Subject, #2: 2	شَارَكَ السَّهْمَ
u'شَارَ شَارِحٌ':Subject, #1: 1	أَشَارَ السَّيِّدُ
u'شَارَ شافِعِيّ':Subject, #2: 2	أَشَارَ الشَّارِحُ
u'شَارَ شمس':Subject, #6: 6	أَشَارَ الشَّافِعِيُّ
u'شَارَ شَمْسٌ':Subject, #3: 3	أَشَارَ شَمْسُ
u'شَارَ شُهُودٌ':Subject, #3: 3	أَشَارَ شَمْسُ
u'شَارَ شَيْبانِيّ':Subject, #1: 1	أَشَارَ الشُّهُودُ
u'شَارَ شَيْخٌ':Subject, #1: 1	أَشَارَ الشَّيْبَانِيُّ
u'شَارَ شَيْخٌ':Subject, #1: 1	أَشَارَ شَيْخُ
u'شَارَ صَاحِبٌ':Predicate, #8: 8	أَشَارَ الشَّيْخُ
u'شَارَ صَاحِبٌ':Subject, #1: 1	شَارَكَ صَاحِبَ
u'شَارَ صَبِيٌّ':Predicate, #9: 9	أَشَارَ صَاحِبُ
u'شَارَ صَدْرٌ':Subject, #1: 1	شَارَكَ الصَّبِيَّ
u'شَارَ صِدِّيقٌ':Subject, #1: 1	أَشَارَ الصَّدْرُ
u'شَارَ طَبَرِيّ':Subject, #3: 3	أَشَارَ الصِّدِّيقُ
u'شَارَ طَبِيبٌ':Subject, #1: 1	أَشَارَ الطَّبَرِيُّ
u'شَارَ ظَهيرٌ':Subject, #1: 1	أَشَارَ الطَّبِيبُ
u'شَارَ عَارِفٌ':Subject, #3: 3	أَشَارَ ظَهِيرُ
u'شَارَ عَسَلٌ':Predicate, #1: 1	أَشَارَ الْعَارِفُ
u'شَارَ عَلِيٌّ':Subject, #1: 1	شَارَ الْعَسَلَ
u'شَارَ عَلِيٌّ':Subject, #1: 1	أَشَارَ عَلِيُّ
u'شَارَ عُمَرٌ':Subject, #3: 3	أَشَارَ عَلِيٌّ
u'شَارَ غرماء':Predicate, #6: 6	أَشَارَ عُمَرُ
u'شَارَ غير':Predicate, #2: 2	شَارَكَ الْغُرَمَاءَ
u'شَارَ غَيْرٌ':Predicate, #2: 2	شَارَكَ الْغَيْرَ
u'شَارَ فخر':Subject, #2: 2	شَارَكَ الْغَيْرَ
u'شَارَ فَخْرٌ':Subject, #3: 3	أَشَارَ فَخْرُ
u'شَارَ فَرَسٌ':Subject, #3: 3	أَشَارَ فَخْرُ
u'شَارَفَ فلان':Predicate, #1: 1	أَشَارَ الْفَرَسُ
u'شَارَ فلان':Subject, #1: 1	شَارَفَ مَكَّةَ
u'شَارَ فلان':Subject, #1: 1	أَشَارَ الطَّبَرِيُّ
u'شَارَ قَالٌ':Predicate, #6: 6	أَشَارَ الشَّافِعِيُّ
u'شَارَ قول':Subject, #1: 1	أَشَارَ قَالَ
u'شَارَ قَوْلٌ':Subject, #2: 2	أَشَارَ قَوْلُهُ
u'شَارَكَ أَبٌ':Predicate, #2: 2	أَشَارَ قَوْلُهُ
u'شَارَكَ أَجْنَبِيٌّ':Predicate, #4: 4	شَارَكَ الْأَبَ
u'شَارَكَ أصل':Predicate, #1: 1	شَارَكَ الْأَجْنَبِيَّ
u'شَارَكَ أًصْلٌ':Predicate, #1: 1	شَارَكَ الْأَصْلَ
u'شَارَكَ إمَامٌ':Predicate, #1: 1	شَارَكَ الْأَصْلَ
u'شَارَكَ أَوَّلُ':Predicate, #1: 1	شَارَكَ الْإِمَامَ
u'شَارَكَ بَهائِمُ':Predicate, #2: 2	شَارَكَ الْأَوَّلَ
u'شَارَكَ تَطَوُّعٌ':Subject, #1: 1	شَارَكَ الْبَهَائِمَ
u'شَارَكَ حُرٌّ':Predicate, #1: 1	شَارَكَ التَّطَوُّعُ
u'شَارَكَ خَاطِئٌ':Predicate, #1: 1	شَارَكَ الْحُرَّ
u'شَارَكَ زَوْجٌ':Predicate, #1: 1	شَارَكَ الْخَاطِئَ
u'شَارَكَ سَهْمٌ':Predicate, #1: 1	شَارَكَ الزَّوْجَ
u'شَارَكَ صَاحِبٌ':Predicate, #2: 2	شَارَكَ السَّهْمَ
u'شَارَكَ صَبِيٌّ':Predicate, #1: 1	شَارَكَ صَاحِبَ
u'شَارَكَ عَبْدٌ':Subject, #1: 1	شَارَكَ الصَّبِيَّ
u'شَارَكَ عجم':Subject, #1: 1	شَارَكَ الْعَبْدُ
u'شَارَكَ عَجَمٌ':Subject, #1: 1	شَارَكَ الْعَجَمُ
u'شَارَكَ غرماء':Predicate, #1: 1	شَارَكَ الْعَجَمُ
u'شَارَكَ غرماء':Subject, #2: 2	شَارَكَ الْغُرَمَاءَ
u'شَارَكَ غير':Predicate, #1: 1	شَارَكَ غُرَمَاءُ
u'شَارَكَ غَيْرٌ':Predicate, #2: 2	شَارَكَ الْغَيْرَ
u'شَارَكَ كَلْبٌ':Subject, #2: 2	شَارَكَ الْغَيْرَ
u'شَارَكَ كَلْبٌ':Subject, #1: 1	شَارَكَ كَلْبٌ
u'شَارَكَ مُحَدَّدٌ':Predicate, #1: 1	شَارَكَ كَلْبُ
u'شَارَكَ مدد':Subject, #1: 1	شَارَكَ الْمُحَدَّدَ
u'شَارَكَ مَدَدٌ':Subject, #1: 1	شَارَكَ الْمَدَدُ
u'شَارَكَ مراد':Predicate, #1: 1	شَارَكَ الْمَدَدُ
u'شَارَكَ مُرَادٌ':Predicate, #1: 1	شَارَكَ الْمُرَادَ
u'شَارَكَ مُسْلِمٌ':Subject, #1: 1	شَارَكَ الْمُرَادَ
u'شَارَكَ مُصَدِّقٌ':Predicate, #2: 2	شَارَكَ الْمُسْلِمُ
u'شَارَكَ مُضَارِبٌ':Subject, #2: 2	شَارَكَ الْمُصَدِّقِينَ
u'شَارَكَ مَقْضِيّ':Subject, #1: 1	شَارَكَ الْمُضَارِبُ
u'شَارَكَ مَوْجُودٌ':Predicate, #1: 1	شَارَكَ الْمَقْضِيُّ
u'شَارَكَ واحد':Subject, #1: 1	شَارَكَ الْمَوْجُودِينَ
u'شَارَكَ وَاحِدٌ':Subject, #1: 1	شَارَكَ وَاحِدٌ
u'شَارَكَ وَقْفٌ':Predicate, #1: 1	شَارَكَ وَاحِدٌ
u'شَارَ مَالِكٌ':Subject, #1: 1	شَارَكَ الْوَقْفَ
u'شَارَ مُبَرِّدٌ':Subject, #2: 2	أَشَارَ مَالِكٌ
u'شَارَ مثل':Predicate, #1: 1	أَشَارَ الْمُبَرِّدُ
u'شَارَ مِثْلٌ':Predicate, #1: 1	أَشَارَ مِثْلَ
u'شَارَ مُحَدَّدٌ':Predicate, #1: 1	أَشَارَ مِثْلَ
u'شَارَ مُحْرِمٌ':Subject, #1: 1	شَارَكَ الْمُحَدَّدَ
u'شَارَ مُحَقِّقٌ':Subject, #3: 3	أَشَارَ الْمُحْرِمُ
u'شَارَ مُحَمَّدٌ':Subject, #1: 1	أَشَارَ الْمُحَقِّقُ
u'شَارَ مراد':Predicate, #32: 32	أَشَارَ مُحَمَّدٌ
u'شَارَ مُرَادٌ':Predicate, #1: 1	شَارَكَ الْمُرَادَ
u'شَارَ مُسْلِمٌ':Subject, #1: 1	شَارَكَ الْمُرَادَ
u'شَارَ مُصَدِّقٌ':Predicate, #2: 2	أَشَارَ مُسْلِمٌ
u'شَارَ مُصَنِّفٌ':Subject, #2: 2	شَارَكَ الْمُصَدِّقِينَ
u'شَارَ مَوْجُودٌ':Predicate, #60: 60	أَشَارَ الْمُصَنِّفُ
u'شَارَ مُؤَلِّفٌ':Subject, #1: 1	شَارَكَ الْمَوْجُودِينَ
u'شَارَ نَاطِقٌ':Subject, #8: 8	أَشَارَ الْمُؤَلِّفُ
u'شَارَ نَبِيٌّ':Subject, #1: 1	أَشَارَ نَاطِقٌ
u'شَارَ نَوَوِيٌّ':Subject, #8: 8	أَشَارَ النَّبِيُّ
u'شَارَ وَالِدٌ':Subject, #2: 2	أَشَارَ النَّوَوِيُّ
u'شَارَ وقع':Predicate, #1: 1	أَشَارَ الْوَالِدُ
u'شَارَ وَقْفٌ':Predicate, #1: 1	أَشَارَ وَقَعَ
u'شَارَ وَلِيٌّ':Subject, #1: 1	شَارَكَ الْوَقْفَ
u'شَاطَرَ خَالِدٌ':Predicate, #2: 2	أَشَارَ الْوَلِيُّ
u'شَاعَ اِسْتِعْمالٌ':Subject, #1: 1	شَاطَرَ خَالِدَ
u'شَاعَ إِطْلاقٌ':Subject, #1: 1	شَاعَ اسْتِعْمَالُهُ
u'شَاعَ بَيْنٌ':Predicate, #1: 1	شَاعَ إطْلَاقُ
u'شَاعَ حُبٌّ':Subject, #2: 2	شَاعَ بَيْنَ
u'شَاعَ عتق':Subject, #1: 1	شَاعَ حُبُّهُ
u'شَاعَ عِتْقٌ':Subject, #6: 6	شَاعَ الْعِتْقُ
u'شَاعَ عُرْفِيٌّ':Subject, #6: 6	شَاعَ الْعِتْقُ
u'شَاعَ عند':Predicate, #1: 1	شَاعَ الْعُرْفِيُّ
u'شَاعَ لَفْظٌ':Subject, #2: 2	شَاعَ عِنْدَ
u'شَاعَ نَسَبٌ':Subject, #1: 1	شَاعَ لَفْظٌ
u'شَافَهَ مَعْصُومٌ':Predicate, #1: 1	شَاعَ نَسَبُهُ
u'شَاقَّ شَقٌّ':Predicate, #1: 1	شَافَهَ الْمَعْصُومَ
u'شَاكَلَ بيوع':Predicate, #4: 4	شَاقَّ شَقَّ
u'شَالَ حَجَرٌ':Predicate, #1: 1	شَاكَلَ الْبُيُوعَ
u'شَاهَدَ أَصْحَابٌ':Predicate, #1: 1	شَالَ الْحَجَرَ
u'شَاهَدَ جَمَّالٌ':Subject, #2: 2	شَاهَدَ أَصْحَابَ
u'شَاهَدَ حَرَكَةٌ':Predicate, #2: 2	شَاهَدَ الْجَمَّالُ
u'شَاهَدَ خطبة':Predicate, #1: 1	شَاهَدَ حَرَكَةَ
u'شَاهَدَ خُطْبَةٌ':Predicate, #2: 2	شَاهَدَ خُطْبَةَ
u'شَاهَدَ دونٌ':Predicate, #2: 2	شَاهَدَ خُطْبَةَ
u'شَاهَدَ سَبَبٌ':Predicate, #1: 1	شَاهَدَ دُونَ
u'شَاهَدَ عرف':Predicate, #1: 1	شَاهَدَ سَبَبَ
u'شَاهَدَ عُرْفٌ':Predicate, #1: 1	شَاهَدَ الْعُرْفَ
u'شَاهَدَ فلان':Predicate, #1: 1	شَاهَدَ الْعُرْفَ
u'شَاهَدَ قَبْرٌ':Predicate, #1: 1	شَاهَدَ عُثْمَانَ
u'شَاهَدَ مَزْرُوعٌ':Predicate, #2: 2	شَاهَدَ قَبْرَ
u'شَاهَدَ نَاسٌ':Subject, #1: 1	شَاهَدَ الْمَزْرُوعَ
u'شَاهَدَ نَبِيٌّ':Predicate, #1: 1	شَاهَدَ النَّاسُ
u'شَاهَدَ نَظَافَةٌ':Predicate, #1: 1	شَاهَدَ النَّبِيَّ
u'شَاوَرَ اِبْنٌ':Predicate, #1: 1	شَاهَدَ نَظَافَةَ
u'شَاوَرَ رَسُولٌ':Predicate, #1: 1	شَاوَرَ ابْنَ
u'شَاوَرَ رَسُولٌ':Subject, #1: 1	شَاوَرَ رَسُولَ
u'شَاوَرَ صَحَابَةٌ':Predicate, #1: 1	شَاوَرَ رَسُولُ
u'شَاوَرَ عَبْدٌ':Subject, #3: 3	شَاوَرَ الصَّحَابَةَ
u'شَاوَرَ عُمَرٌ':Predicate, #1: 1	شَاوَرَ عَبْدُ
u'شَاوَرَ عُمَرٌ':Subject, #1: 1	شَاوَرَ عُمَرَ
u'شَاوَرَ نَبِيٌّ':Subject, #1: 1	شَاوَرَ عُمَرُ
u'شَبابٌ الْمَرْأَةُ':Added, #1: 1	شَاوَرَ النَّبِيُّ
u'شَبَابٌ الْمَرْأَةُ':Added, #1: 1	شَبَابَ الْمَرْأَةِ
u'شَبابٌ أُمَّةٌ':Added, #1: 1	شَبَابَ الْمَرْأَةِ
u'شَبَابٌ أُمَّةٌ':Added, #1: 1	شَبَابِ أُمَّةِ
u'شَبابٌ أهْلٌ':Added, #1: 1	شَبَابِ أُمَّةِ
u'شَبَابٌ أهْلٌ':Added, #3: 3	شَبَابِ أَهْلِ
u'شَبابٌ حَيٌّ':Added, #3: 3	شَبَابِ أَهْلِ
u'شَبَابٌ حَيٌّ':Added, #1: 1	شَبَابَ الْحَيِّ
u'شَبابٌ خصيان':Added, #1: 1	شَبَابَ الْحَيِّ
u'شَبَابٌ خصيان':Added, #1: 1	شَبَابِ الْخُصْيَانِ
u'شَبابٌ زَمانٌ':Added, #1: 1	شَبَابِ الْخُصْيَانِ
u'شَبَابٌ زَمانٌ':Added, #1: 1	شَبَابُ الزَّمَانِ
u'شَبابٌ قُرَيْشٌ':Added, #1: 1	شَبَابُ الزَّمَانِ
u'شَبابٌ قُرَيْشٌ':Added, #1: 1	شَبَابَ قُرَيْشٍ
u'شَبَابٌ قُرَيْشٌ':Added, #1: 1	شَبَابُ قُرَيْشٍ
u'شَبَابٌ قُرَيْشٌ':Added, #1: 1	شَبَابَ قُرَيْشٍ
u'شَبابٌ قُرَيْشٌ':Added, #1: 1	شَبَابُ قُرَيْشٍ
u'شَبَابٌ قُرَيْشٌ':Added, #2: 2	شَبَابِ قُرَيْشٍ
u'شَبابٌ قَوْمٌ':Added, #2: 2	شَبَابِ قُرَيْشٍ
u'شَبَابٌ قَوْمٌ':Added, #2: 2	شَبَابِ قَوْمِهِ
u'شُبَّانٌ أَصْحَابٌ':Added, #2: 2	شَبَابِ قَوْمِهِ
u'شُبَّانٌ صَحَابَةٌ':Added, #1: 1	شُبَّانُ أَصْحَابِهِ
u'شَبَّبَ نَارٌ':Predicate, #1: 1	شُبَّانِ الصَّحَابَةِ
u'شَبَّ صَغِيرٌ':Subject, #1: 1	شَبَّبَ النَّارَ
u'شَبَّ طَوْقٌ':Subject, #1: 1	شَبَّ الصَّغِيرُ
u'شِبَعٌ بَطْنٌ':Added, #1: 1	شَبَّ طَوْقُ
u'شَبِعَ حَرَكَةٌ':Predicate, #1: 1	شِبَعُ الْبَطْنِ
u'شَبِعَ رَجُلٌ':Subject, #1: 1	أَشْبَعَ حَرَكَةَ
u'شَبِعَ رَسُولٌ':Subject, #1: 1	شَبِعَ الرَّجُلُ
u'شَبِعَ رقد':Predicate, #2: 2	شَبِعَ رَسُولُ
u'شَبِعَ قَوْمٌ':Subject, #1: 1	شَبِعَ رَقَدَ
u'شَبِعَ كَلاَمٌ':Predicate, #1: 1	شَبِعَ قَوْمٌ
u'شِبَعٌ لَحْمٌ':Added, #1: 1	أَشْبَعَ الْكَلَامَ
u'شِبَعٌ يَوْمٌ':Added, #1: 1	شِبَعِ لَحْمِهِ
u'شَبَّ غُلاَمٌ':Subject, #2: 2	شِبَعُ يَوْمٍ
u'شَبَّكَ بَيْنٌ':Predicate, #1: 1	شَبَّ الْغُلاَمُ
u'شَبَّكَ رَسُولٌ':Subject, #2: 2	شَبَّكَ بَيْنَ
u'شَبَّ نِيَرانٌ':Subject, #2: 2	شَبَّكَ رَسُولُ
u'شَبَّ نِيرَانٌ':Subject, #1: 1	شَبَّ نِيرَانُ
u'شَبَّهَ أسْمَاعٌ':Predicate, #1: 1	شَبَّ نِيرَانُ
u'شَبَّهَ أُمٌّ':Predicate, #1: 1	شَبَّهَ أَسْمَاعَ
u'شَبَّهَ إمَامٌ':Subject, #1: 1	شَبَّهَ أُمَّ
u'شَبَّهَ تَلَبُّسٌ':Predicate, #1: 1	شَبَّهَ الْإِمَامُ
u'شَبَّهَ ثَانِي':Predicate, #1: 1	شَبَّهَ التَّلَبُّسَ
u'شَبَّهَ ثَانِيَةٌ':Predicate, #1: 1	شَبَّهَ الثَّانِيَةَ
u'شَبَّهَ جُمْلَةٌ':Predicate, #1: 1	شَبَّهَ الثَّانِيَةَ
u'شَبَّهَ جَوَابٌ':Predicate, #2: 2	شَبَّهَ جُمْلَةَ
u'شَبَّهَ حالٌ':Predicate, #1: 1	شَبَّهَ جَوَابَ
u'شَبَّهَ خُرُوجٌ':Predicate, #1: 1	شَبَّهَ حَالَ
u'شَبَّهَ رَاجِعٌ':Predicate, #1: 1	شَبَّهَ خُرُوجَ
u'شَبَّهَ رَسُولٌ':Subject, #1: 1	شَبَّهَ الرَّاجِعَ
u'شَبَّهَ رُكوبٌ':Predicate, #2: 2	شَبَّهَ رَسُولُ
u'شَبَّهَ سِتْرٌ':Predicate, #1: 1	شَبَّهَ رُكُوبَ
u'شَبَّهَ سلام':Predicate, #1: 1	شَبَّهَ السِّتْرَ
u'شَبَّهَ سَلاَمٌ':Predicate, #1: 1	شَبَّهَ السَّلَامَ
u'شَبَّهَ طَلاَقٌ':Predicate, #1: 1	شَبَّهَ السَّلَامَ
u'شَبَّهَ طواف':Predicate, #3: 3	شَبَّهَ الطَّلَاقَ
u'شَبَّهَ طَوَافٌ':Predicate, #4: 4	شَبَّهَ الطَّوَافَ
u'شَبَّهَ عَامٌّ':Predicate, #4: 4	شَبَّهَ الطَّوَافَ
u'شَبَّهَ عَلِيٌّ':Subject, #1: 1	شَبَّهَ الْعَامَّ
u'شَبَّهَ غُسْلٌ':Predicate, #1: 1	شَبَّهَ عَلِيٌّ
u'شَبَّهَ فَوَاتٌ':Predicate, #1: 1	شَبَّهَ الْغُسْلَ
u'شَبَّهَ قُلُوبٌ':Predicate, #1: 1	شَبَّهَ الْفَوَاتَ
u'شَبَّهَ قيام':Predicate, #1: 1	شَبَّهَ قُلُوبَ
u'شَبَّهَ قِيَامٌ':Predicate, #1: 1	شَبَّهَ الْقِيَامَ
u'شَبَّهَ مُحَرَّمٌ':Predicate, #1: 1	شَبَّهَ الْقِيَامَ
u'شَبَّهَ نَبِيٌّ':Subject, #1: 1	شَبَّهَ مُحَرَّمَةً
u'شَبَّهَ وَاقِعٌ':Predicate, #2: 2	شَبَّهَ النَّبِيُّ
u'شَبَّهَ وَقْفٌ':Predicate, #2: 2	شَبَّهَ الْوَاقِعَ
u'شَتَاتٌ رَأْيٌ':Added, #1: 1	شَبَّهَ الْوَقْفَ
u'شَتَاتٌ شَمْلٌ':Added, #1: 1	شَتَاتَ الرَّأْيِ
u'شَتَاتٌ شِمْلٌ':Added, #1: 1	شَتَاتِ الشّمْلِ
u'شَتَاتٌ قلب':Added, #1: 1	شَتَاتِ الشّمْلِ
u'شَتَاتٌ قَلْبٌ':Added, #1: 1	شَتَاتِ الْقَلْبِ
u'شَتَاتٌ قَلْب':Added, #1: 1	شَتَاتِ الْقَلْبِ
u'شَتَاتٌ نَظَرٌ':Added, #1: 1	شَتَاتِ الْقَلْبِ
u'شَتَمَ أحَدٌ':Subject, #1: 1	شَتَاتَ النَّظَرَيْنِ
u'شَتْمٌ أَعْرَاضٌ':Added, #1: 1	شَتَمَ أَحَدُ
u'شَتْمٌ أهْلٌ':Added, #1: 1	شَتْمُ الأَعْرَاضِ
u'شَتَمَ حَقٌّ':Predicate, #1: 1	شَتْمِ أَهْلِ
u'شَتْمٌ خَادِمٌ':Added, #1: 1	شَتَمَ الْحَقَّ
u'شَتْمٌ خَادِمٌ':Added, #1: 1	شَتْمُ الْخَادِمِ
u'شَتَمَ خَيْرٌ':Predicate, #1: 1	شَتْمِ الْخَادِمِ
u'شَتَمَ رَبُّ':Predicate, #1: 1	شَتَمَ خَيْرَ
u'شَتَمَ رَجُلٌ':Subject, #1: 1	شَتَمَ الرَّبَّ
u'شَتْمٌ رَجُلٌ':Added, #1: 1	شَتَمَ رَجُلٌ
u'شَتَمَ عُمَرٌ':Predicate, #3: 3	شَتْمُ الرَّجُلِ
u'شَتَمَ غير':Predicate, #1: 1	شَتَمَ عُمَرَ
u'شَتَمَ غَيْرٌ':Predicate, #1: 1	شَتَمَ غَيْرَ
u'شَتْمٌ لَئِيمٌ':Added, #1: 1	شَتَمَ غَيْرَ
u'شَتْمٌ مُحَمَّدٌ':Added, #1: 1	شَتْمِ اللَّئِيمِ
u'شَتْمٌ نَبِيٌّ':Added, #1: 1	شَتْمِ مُحَمَّدٍ
u'شَتْمٌ نَبِيٌّ':Added, #1: 1	شَتْمَ النَّبِيِّ
u'شَتْمٌ نَصْرَانِيٌّ':Added, #1: 1	شَتْمِ النَّبِيِّ
u'شَتَّى آخِرُ':Predicate, #1: 1	شَتْمَ النَّصْرَانِيِّ
u'شَتَّى أُمُورٌ':Subject, #6: 6	شَتَّى آخِرَ
u'شَتَّى بَوْنٌ':Subject, #1: 1	شَتَّى أُمُورُهُ
u'شَتَّى بيوع':Added, #1: 1	شَتَّى بَوْنُ
u'شَتَّى جمع':Predicate, #1: 1	شَتَّى الْبُيُوعِ
u'شَتَّى خَيْرٌ':Subject, #1: 1	شَتَّى جَمَعَ
u'شَتَّى غير':Predicate, #1: 1	شَتَّى خَيْرٌ
u'شَتَّى غَيْرٌ':Predicate, #1: 1	شَتَّى غَيْرَ
u'شَتَّى قَالٌ':Predicate, #1: 1	شَتَّى غَيْرَ
u'شَتَّى مثل':Subject, #1: 1	شَتَّى قَالَ
u'شَتَّى مِثْلٌ':Subject, #1: 1	شَتَّى مِثْلُ
u'شَتَّى مُخْتَلِفٌ':Subject, #1: 1	شَتَّى مِثْلُ
u'شَتَّى مَسْأَلَةٌ':Subject, #1: 1	شَتَّى مُخْتَلِفَةٌ
u'شَتَّى وَتَرٌ':Predicate, #1: 1	شَتَّى مَسْأَلَةٌ
u'شَجَاعَةٌ شجعان':Added, #1: 1	شَتَّى وَتَرَكَ
u'شَجَاعَةٌ نَفْسٌ':Added, #1: 1	شَجَاعَةِ الشُّجْعَانِ
u'شجَاعٌ شجعان':Added, #1: 1	شَجَاعَةُ نَفْسِهِ
u'شجَاعٌ نَفْسٌ':Added, #1: 1	شَجَاعَةِ الشُّجْعَانِ
u'شَجَّ إِنْسانٌ':Subject, #1: 1	شَجَاعَةُ نَفْسِهِ
u'شَجَّ بادِئٌ':Predicate, #1: 1	شَجَّ إنْسَانٌ
u'شَجَّ حُرٌّ':Subject, #1: 1	شَجَّ الْبَادِئَ
u'شَجَّ رَأْسٌ':Predicate, #1: 1	شَجَّ حُرٌّ
u'شَجَرَ بَيْنٌ':Predicate, #1: 1	شَجَّ رَأْسَ
u'شَجَّ رَجُلٌ':Subject, #1: 1	شَجَرَ بَيْنَ
u'شَجَّ زَيْدٌ':Subject, #1: 1	شَجَّ رَجُلٌ
u'شَجَّ عَبْدٌ':Predicate, #1: 1	شَجَّ زَيْدٌ
u'شَجَّ لاَحِقٌ':Predicate, #3: 3	شَجَّ عَبْدَ
u'شَجَّ لاَحِقٌ':Subject, #1: 1	شَجَّ اللَّاحِقَ
u'شَجَّ مَطْلُوبٌ':Predicate, #2: 2	شَجَّ اللَّاحِقُ
u'شَجَّ مَطْلُوبٌ':Subject, #1: 1	شَجَّ الْمَطْلُوبَ
u'شُجُونٌ أَحادِيثُ':Added, #1: 1	شَجَّ الْمَطْلُوبُ
u'شَحُبَ وَجْهٌ':Subject, #1: 1	شُجُونَ الْأَحَادِيثِ
u'شَحَّ جَمِيع':Subject, #1: 1	شَحُبَ وَجْهٌ
u'شَحَذَ سِكِّينٌ':Predicate, #1: 1	شَحَّ الْجَمِيعُ
u'شَحَّ زَمانٌ':Subject, #1: 1	شَحَذَ السِّكِّينَ
u'شَحْمٌ بَطٌّ':Added, #1: 1	شَحَّ الزَّمَانُ
u'شَحْمٌ بَطْنٌ':Added, #1: 1	شَحْمِ الْبَطِّ
u'شَحْمٌ بَطْنٌ':Added, #4: 4	شَحْمَ الْبَطْنِ
u'شَحْمٌ بَطْنٌ':Added, #4: 4	شَحْمِ الْبَطْنِ
u'شَحْمٌ بَقَرٌ':Added, #5: 5	شَحْمُ الْبَطْنِ
u'شَحْمٌ ثَوْرٌ':Added, #1: 1	شَحْمَ الْبَقَرِ
u'شَحْمٌ جَنْبٌ':Added, #1: 1	شَحْمَ ثَوْرٍ
u'شَحْمٌ حَنْظَلٌ':Added, #1: 1	شَحْمُ الْجَنْبِ
u'شَحْمٌ خِنْزِيرٌ':Added, #1: 1	شَحْمِ الْحَنْظَلِ
u'شَحْمٌ خِنْزِيرٌ':Added, #1: 1	شَحْمَ الْخِنْزِيرِ
u'شَحْمٌ ظَهْرٌ':Added, #1: 1	شَحْمِ الْخِنْزِيرِ
u'شَحْمٌ ظَهْرٌ':Added, #16: 16	شَحْمَ الظَّهْرِ
u'شَحْمٌ كُلْيَةٌ':Added, #3: 3	شَحْمِ الظَّهْرِ
u'شَحْمٌ لَحْمٌ':Added, #1: 1	شَحْمُ الْكُلْيَةِ
u'شَحْمٌ مَيْتٌ':Added, #1: 1	شَحْمُ اللَّحْمِ
u'شَحْمٌ مَيْتٌ':Added, #1: 1	شَحْمِ الْمَيْتَةِ
u'شَحْمٌ مَيْتَةٌ':Added, #2: 2	شَحْمُ الْمَيْتَةِ
u'شَحْمٌ مَيْتَةٌ':Added, #1: 1	شَحْمِ الْمَيْتَةِ
u'شَحْمٌ مَيْتَةٌ':Added, #1: 1	شَحْمِ مَيْتَةٍ
u'شَحْمٌ نَخْلٌ':Added, #2: 2	شَحْمُ الْمَيْتَةِ
u'شَحْنٌ بَقِيَّةٌ':Added, #3: 3	شَحْمُ النَّخْلِ
u'شَحَّ وَارِثٌ':Subject, #1: 1	شَحْنِ بَقِيَّةِ
u'شَحَّ وَرَثَةٌ':Subject, #1: 1	شَحَّ الْوَارِثُ
u'شُحُومٌ آذَانٌ':Added, #1: 1	شَحَّ الْوَرَثَةُ
u'شُحُومٌ طَيْرٌ':Added, #1: 1	شُحُومَ الآذَانِ
u'شُحُومٌ غَنَمٌ':Added, #1: 1	شُحُومِ الطَّيْرِ
u'شُحُومٌ مَيْتٌ':Added, #1: 1	شُحُومَ الْغَنَمِ
u'شُحُومٌ مَيْتٌ':Added, #1: 1	شُحُومِ الْمَيْتَةِ
u'شُحُومٌ مَيْتَةٌ':Added, #4: 4	شُحُومَ الْمَيْتَةِ
u'شُحُومٌ مَيْتَةٌ':Added, #1: 1	شُحُومِ الْمَيْتَةِ
u'شُحُومٌ يهود':Added, #4: 4	شُحُومَ الْمَيْتَةِ
u'شُحُومٌ يهود':Added, #1: 1	شُحُومُ الْيَهُودِ
u'شُحُومٌ يَهُودٌ':Added, #1: 1	شُحُومِ الْيَهُودِ
u'شُحُومٌ يَهُودٌ':Added, #1: 1	شُحُومُ الْيَهُودِ
u'شَخَبَ دَمٌ':Subject, #1: 1	شُحُومِ الْيَهُودِ
u'شَخَصَ بَصَرٌ':Subject, #1: 1	شَخَبَ دَمُهُ
u'شَخْصِيَّةٌ حُكْمٌ':Added, #3: 3	شَخَصَ بَصَرُهُ
u'شَخْصِيٌّ حُكْمٌ':Added, #1: 1	شَخْصِيَّةَ الْحُكْمِ
u'شَدَّ إِزَارٌ':Predicate, #1: 1	شَخْصِيَّةَ الْحُكْمِ
u'شَدَّ أسْنَانٌ':Predicate, #1: 1	شَدَّ الْإِزَارَ
u'شَدَّ أفْضَلُ':Subject, #1: 1	شَدَّ أَسْنَانَ
u'شَدَّ بَائِعٌ':Subject, #1: 1	أَشَدَّ أَفْضَلُ
u'شِدَّةٌ اِتِّصَالٌ':Added, #1: 1	شَدَّ الْبَائِعُ
u'شِدَّةٌ اِحْتِيَاجٌ':Added, #2: 2	شِدَّةُ اتِّصَالِ
u'شِدَّةٌ اِخْتِلاَفٌ':Added, #2: 2	شِدَّةِ احْتِيَاجِ
u'شِدَّةٌ إِسْراعٌ':Added, #1: 1	شِدَّةُ اخْتِلَافِ
u'شِدَّةٌ إِسْراعٌ':Added, #1: 1	شِدَّةَ الإِسْرَاعِ
u'شِدَّةٌ إِسْراعٌ':Added, #1: 1	شِدَّةِ الإِسْرَاعِ
u'شِدَّةٌ إقْبالٌ':Added, #1: 1	شِدَّةُ الْإِسْرَاعِ
u'شِدَّةٌ اِلْتِفَاتٌ':Added, #1: 1	شِدَّةِ الْإِقْبَالِ
u'شِدَّةٌ ألَمٌ':Added, #1: 1	شِدَّةَ الْتِفَاتِهِ
u'شِدَّةٌ ألَمٌ':Added, #1: 1	شِدَّةُ الْأَلَمِ
u'شِدَّةٌ ألَمٌ':Added, #1: 1	شِدَّةِ أَلَمِهِ
u'شِدَّةٌ أَمْرٌ':Added, #3: 3	شِدَّةِ الْأَلَمِ
u'شِدَّةٌ أَمَلٌ':Added, #1: 1	شِدَّةِ أَمْرِ
u'شِدَّةٌ بَأسٌ':Added, #1: 1	شِدَّةِ الْأَمَلِ
u'شِدَّةٌ بَأسٌ':Added, #1: 1	شِدَّةِ الْبَأْسِ
u'شِدَّةٌ بَحْثٌ':Added, #1: 1	شِدَّةِ بَأْسِهِ
u'شِدَّةٌ بَرْدٌ':Added, #1: 1	شِدَّةِ الْبَحْثِ
u'شِدَّةٌ بَرْدٌ':Added, #11: 11	شِدَّةِ الْبَرْدِ
u'شِدَّةٌ بَرْدٌ':Added, #1: 1	شِدَّةُ الْبَرْدِ
u'شِدَّةٌ بَرْدٌ':Added, #1: 1	شِدَّةُ بَرْدِ
u'شِدَّةٌ بَرْدٌ':Added, #1: 1	شِدَّةِ بَرْدٍ
u'شِدَّةٌ بُغْضٌ':Added, #1: 1	شِدَّةُ بَرْدِهِ
u'شِدَّةٌ بُغْضٌ':Added, #1: 1	شِدَّةُ الْبُغْضِ
u'شِدَّةٌ بَيَاضٌ':Added, #1: 1	شِدَّةِ بُغْضِ
u'شِدَّةٌ تَحَامُلٌ':Added, #2: 2	شِدَّةَ بَيَاضِ
u'شِدَّةٌ تَحَرِّي':Added, #1: 1	شِدَّةِ تَحَامُلِهِ
u'شِدَّةٌ تَحْرِيمٌ':Added, #1: 1	شِدَّةِ تَحَرِّيهِ
u'شِدَّةٌ تَعَجُّبٌ':Added, #1: 1	شِدَّةَ التَّحْرِيمِ
u'شِدَّةٌ تَعْجِيل':Added, #2: 2	شِدَّةِ التَّعَجُّبِ
u'شِدَّةٌ تَعْزِير':Added, #1: 1	شِدَّةِ التَّعْجِيلِ
u'شِدَّةٌ تَعَلُّقٌ':Added, #1: 1	شِدَّةِ التَّعْزِيرِ
u'شِدَّةٌ تَعَلُّقٌ':Added, #1: 1	شِدَّةِ التَّعَلُّقِ
u'شِدَّةٌ تَغْرِير':Added, #1: 1	شِدَّةُ تَعَلُّقِهِ
u'شِدَّةٌ تَفْرِيقٌ':Added, #1: 1	شِدَّةِ التَّغْرِيرِ
u'شِدَّةٌ تَوَاضُعٌ':Added, #1: 1	شِدَّةُ تَفْرِيقِهِ
u'شِدَّةٌ تَوَقُّدٌ':Added, #1: 1	شِدَّةِ تَوَاضُعِهِ
u'شِدَّةٌ جزع':Added, #1: 1	شِدَّةُ تَوَقُّدِ
u'شِدَّةٌ جَزَعٌ':Added, #2: 2	شِدَّةِ الْجَزَعِ
u'شِدَّةٌ جهل':Added, #2: 2	شِدَّةِ الْجَزَعِ
u'شِدَّةٌ جَهْلٌ':Added, #3: 3	شِدَّةُ الْجَهْلِ
u'شِدَّةٌ جُوعٌ':Added, #3: 3	شِدَّةُ الْجَهْلِ
u'شِدَّةٌ حاجَةٌ':Added, #2: 2	شِدَّةِ الْجُوعِ
u'شِدَّةٌ حاجَةٌ':Added, #1: 1	شِدَّةُ الْحَاجَةِ
u'شِدَّةٌ حاجَةٌ':Added, #1: 1	شِدَّةِ حَاجَةٍ
u'شِدَّةٌ حالٌ':Added, #6: 6	شِدَّةِ الْحَاجَةِ
u'شِدَّةٌ حُبٌّ':Added, #1: 1	شِدَّةِ حَالِ
u'شِدَّةٌ حُبٌّ':Added, #1: 1	شِدَّةِ الْحُبِّ
u'شِدَّةٌ حَرٌّ':Added, #1: 1	شِدَّةِ حُبِّهِ
u'شَدَّةٌ حَرٌّ':Added, #10: 10	شِدَّةِ حَرٍّ
u'شِدَّةٌ حُرٌّ':Added, #1: 1	شَدَّةَ الْحَرِّ
u'شِدَّةٌ حَرٌّ':Added, #1: 1	شِدَّةِ الْحُرِّ
u'شَدَّةٌ حَرٌّ':Added, #27: 27	شِدَّةَ الْحَرِّ
u'شِدَّةٌ حَرٌّ':Added, #2: 2	شَدَّةِ الْحَرِّ
u'شِدَّةٌ حَرٌّ':Added, #2: 2	شِدَّةِ حَرِّ
u'شِدَّةٌ حَرٌّ':Added, #3: 3	شِدَّةِ حَرِّهِ
u'شِدَّةٌ حَرٌّ':Added, #45: 45	شِدَّةِ الْحَرِّ
u'شِدَّةٌ حَرارَةٌ':Added, #5: 5	شِدَّةُ الْحَرِّ
u'شِدَّةٌ حَرْبٌ':Added, #1: 1	شِدَّةُ الْحَرَارَةِ
u'شِدَّةٌ حِرْصٌ':Added, #4: 4	شِدَّةِ الْحَرْبِ
u'شِدَّةٌ حِرْصٌ':Added, #1: 1	شِدَّةُ الْحِرْصِ
u'شِدَّةٌ حِرْصٌ':Added, #1: 1	شِدَّةِ الْحِرْصِ
u'شِدَّةٌ حِرْصٌ':Added, #1: 1	شِدَّةِ حِرْصِ
u'شِدَّةٌ حَرَكَةٌ':Added, #1: 1	شِدَّةِ حِرْصِهِ
u'شِدَّةٌ حساب':Added, #1: 1	شِدَّةُ الْحَرَكَةِ
u'شِدَّةٌ حِسَابٌ':Added, #1: 1	شِدَّةُ الْحِسَابِ
u'شِدَّةٌ حساب':Added, #1: 1	شِدَّةُ الْحِسَابِ
u'شِدَّةٌ حِسَابٌ':Added, #3: 3	شِدَّةِ الْحِسَابِ
u'شِدَّةٌ حقد':Added, #3: 3	شِدَّةِ الْحِسَابِ
u'شِدَّةٌ حِقد':Added, #1: 1	شِدَّةُ حِقْدِهِ
u'شِدَّةٌ حِقْدٌ':Added, #1: 1	شِدَّةُ حِقْدِهِ
u'شِدَّةٌ حَلاَوَةٌ':Added, #1: 1	شِدَّةُ حِقْدِهِ
u'شِدَّةٌ حَيَاءٌ':Added, #1: 1	شِدَّةِ حَلاَوَتِهِ
u'شِدَّةٌ خِلاَفٌ':Added, #1: 1	شِدَّةُ حَيَاءِ
u'شِدَّةٌ خَوْفٌ':Added, #1: 1	شِدَّةِ الْخِلَافِ
u'شِدَّةٌ خَوْفٌ':Added, #1: 1	شِدَّةُ الْخَوْفِ
u'شِدَّةٌ خَوْفٌ':Added, #1: 1	شِدَّةَ خَوْفٍ
u'شِدَّةٌ رَائِحٌ':Added, #34: 34	شِدَّةِ الْخَوْفِ
u'شِدَّةٌ رَائِحَةٌ':Added, #1: 1	شِدَّةُ الرَّائِحَةِ
u'شِدَّةٌ رَمْضاءُ':Added, #1: 1	شِدَّةُ الرَّائِحَةِ
u'شِدَّةٌ ريحٌ':Added, #1: 1	شِدَّةَ الرَّمْضَاءِ
u'شِدَّةٌ ريحٌ':Added, #1: 1	شِدَّةُ الرِّيحِ
u'شِدَّةٌ ريحٌ':Added, #1: 1	شِدَّةِ الرِّيحِ
u'شِدَّةٌ سَاعِدٌ':Added, #2: 2	شِدَّةِ رِيحٍ
u'شِدَّةٌ سُرُورٌ':Added, #1: 1	شِدَّةِ السَّاعِدِ
u'شِدَّةٌ سَوادٌ':Added, #1: 1	شِدَّةِ السُّرُورِ
u'شِدَّةٌ سَوادٌ':Added, #2: 2	شِدَّةُ سَوَادِ
u'شِدَّةٌ شَهْوَةٌ':Added, #2: 2	شِدَّةِ سَوَادِ
u'شِدَّةٌ شَهْوَةٌ':Added, #1: 1	شِدَّةُ شَهْوَةِ
u'شِدَّةٌ صَبْوَةٌ':Added, #1: 1	شِدَّةِ شَهْوَةٍ
u'شِدَّةٌ صرخة':Added, #1: 1	شِدَّةِ الصَّبْوَةِ
u'شِدَّةٌ صَرْخَةٌ':Added, #1: 1	شِدَّةِ صَرْخَتِهِ
u'شِدَّةٌ ضَرْبٌ':Added, #1: 1	شِدَّةِ صَرْخَتِهِ
u'شِدَّةٌ ضَرْبٌ':Added, #1: 1	شِدَّةِ الضَّرْبِ
u'شِدَّةٌ ضَرَرٌ':Added, #1: 1	شِدَّةِ ضَرْبِهِ
u'شِدَّةٌ ضَرَرٌ':Added, #1: 1	شِدَّةِ الضَّرَرِ
u'شِدَّةٌ ضَرُورَةٌ':Added, #2: 2	شِدَّةُ الضَّرَرِ
u'شِدَّةٌ ضَنٌّ':Added, #2: 2	شِدَّةِ الضَّرُورَةِ
u'شِدَّةٌ ضَوْءٌ':Added, #1: 1	شِدَّةِ ضَنِّهِ
u'شِدَّةٌ ضِيقٌ':Added, #1: 1	شِدَّةِ الضَّوْءِ
u'شِدَّةٌ طَرِيقٌ':Added, #1: 1	شِدَّةُ الضِّيقِ
u'شِدَّةٌ ظَلامٌ':Added, #1: 1	شِدَّةِ طَرِيقِهِ
u'شِدَّةٌ ظلمة':Added, #1: 1	شِدَّةِ الظَّلَامِ
u'شِدَّةٌ ظُلْمَةٌ':Added, #2: 2	شِدَّةِ الظُّلْمَةِ
u'شِدَّةٌ ظُهورٌ':Added, #2: 2	شِدَّةِ الظُّلْمَةِ
u'شِدَّةٌ عِبَادَةٌ':Added, #1: 1	شِدَّةُ ظُهُورِ
u'شِدَّةٌ عَجَف':Added, #1: 1	شِدَّةَ الْعِبَادَةِ
u'شِدَّةٌ عَدْوٌ':Added, #1: 1	شِدَّةِ الْعَجَفِ
u'شِدَّةٌ عَدْوٌ':Added, #1: 1	شِدَّةُ الْعَدْوِ
u'شِدَّةٌ عَدْوٌ':Added, #1: 1	شِدَّةُ عَدْوِهِ
u'شِدَّةٌ عَذَابٌ':Added, #2: 2	شِدَّةِ عَدْوِهِ
u'شِدَّةٌ عَذَابٌ':Added, #1: 1	شِدَّةِ عَذَابِ
u'شِدَّةٌ عَذَابٌ':Added, #2: 2	شِدَّةُ الْعَذَابِ
u'شِدَّةٌ عُطاس':Added, #2: 2	شِدَّةِ الْعَذَابِ
u'شِدَّةٌ عِنَايَةٌ':Added, #1: 1	شِدَّةَ الْعُطَاسِ
u'شِدَّةٌ عِنَايَةٌ':Added, #1: 1	شِدَّةِ الْعِنَايَةِ
u'شِدَّةٌ غَرَرٌ':Added, #1: 1	شِدَّةُ عِنَايَةٍ
u'شِدَّةٌ غَرَرٌ':Added, #1: 1	شِدَّةُ الْغَرَرِ
u'شِدَّةٌ غضب':Added, #1: 1	شِدَّةِ الْغَرَرِ
u'شِدَّةٌ غَضَبٌ':Added, #1: 1	شِدَّةِ الْغَضَبِ
u'شِدَّةٌ غَلَسٌ':Added, #1: 1	شِدَّةِ الْغَضَبِ
u'شِدَّةٌ غُلْمَةٌ':Added, #3: 3	شِدَّةِ الْغَلَسِ
u'شِدَّةٌ غُلْمَةٌ':Added, #1: 1	شِدَّةَ الْغُلْمَةِ
u'شِدَّةٌ غَيْرَةٌ':Added, #1: 1	شِدَّةُ الْغُلْمَةِ
u'شِدَّةٌ غَيْرَةٌ':Added, #1: 1	شِدَّةِ الْغَيْرَةِ
u'شِدَّةٌ غَيْظٌ':Added, #1: 1	شِدَّةِ غَيْرَتِهِ
u'شِدَّةٌ غَيْظٌ':Added, #1: 1	شِدَّةُ الْغَيْظِ
u'شِدَّةٌ فَاقَةٌ':Added, #1: 1	شِدَّةِ غَيْظٍ
u'شِدَّةٌ فرح':Added, #1: 1	شِدَّةِ فَاقَتِهِ
u'شِدَّةٌ فَرَحٌ':Added, #3: 3	شِدَّةِ الْفَرَحِ
u'شِدَّةٌ فَزَعٌ':Added, #3: 3	شِدَّةِ الْفَرَحِ
u'شِدَّةٌ فقر':Added, #1: 1	شِدَّةِ الْفَزَعِ
u'شِدَّةٌ فَقْرٌ':Added, #1: 1	شِدَّةِ فَقْرِهِ
u'شِدَّةٌ قَبُولٌ':Added, #1: 1	شِدَّةِ فَقْرِهِ
u'شِدَّةٌ قتال':Added, #1: 1	شِدَّة قَبُولِ
u'شِدَّةٌ قِتَالٌ':Added, #1: 1	شِدَّةِ الْقِتَالِ
u'شِدَّةٌ قتل':Added, #1: 1	شِدَّةِ الْقِتَالِ
u'شِدَّةٌ قَتْلٌ':Added, #2: 2	شِدَّةِ الْقَتْلِ
u'شِدَّةٌ قِشْرٌ':Added, #2: 2	شِدَّةِ الْقَتْلِ
u'شِدَّةٌ قلب':Added, #1: 1	شِدَّةِ الْقِشْرِ
u'شِدَّةٌ قَلْبٌ':Added, #1: 1	شِدَّةُ الْقَلْبِ
u'شِدَّةٌ قَلْب':Added, #1: 1	شِدَّةُ الْقَلْبِ
u'شِدَّةٌ قُوَّةٌ':Added, #1: 1	شِدَّةُ الْقَلْبِ
u'شِدَّةٌ قُوَّة':Added, #1: 1	شِدَّةِ قُوَّةِ
u'شِدَّةٌ قَوْسٌ':Added, #1: 1	شِدَّةِ قُوَّةِ
u'شِدَّةٌ قيام':Added, #1: 1	شِدَّةِ الْقَوْسِ
u'شِدَّةٌ قِيَامٌ':Added, #1: 1	شِدَّةِ الْقِيَامِ
u'شِدَّةٌ كَدْحٌ':Added, #1: 1	شِدَّةِ الْقِيَامِ
u'شِدَّةٌ كَرَاهَةٌ':Added, #1: 1	شِدَّةُ الْكَدْحِ
u'شِدَّةٌ لَهْوٌ':Added, #1: 1	شِدَّةِ الْكَرَاهَةِ
u'شِدَّةٌ مُتَابَعٌ':Added, #1: 1	شِدَّةِ اللَّهْوِ
u'شِدَّةٌ مُتَابَعَةٌ':Added, #1: 1	شِدَّةِ مُتَابَعَتِهِ
u'شِدَّةٌ مُثَابَرَةٌ':Added, #1: 1	شِدَّةِ مُتَابَعَتِهِ
u'شِدَّةٌ مجَاعَةٌ':Added, #1: 1	شِدَّةُ الْمُثَابَرَةِ
u'شِدَّةٌ مُخَالَطَةٌ':Added, #1: 1	شِدَّةِ الْمَجَاعَةِ
u'شِدَّةٌ مَرَضٌ':Added, #1: 1	شِدَّةُ الْمُخَالَطَةِ
u'شِدَّةٌ مَرَضٌ':Added, #1: 1	شِدَّةِ الْمَرَضِ
u'شِدَّةٌ مَشَقَّةٌ':Added, #1: 1	شِدَّةِ مَرَضٍ
u'شِدَّةٌ مَشَقَّةٌ':Added, #1: 1	شِدَّةُ الْمَشَقَّةِ
u'شِدَّةٌ ميل':Added, #1: 1	شِدَّةِ الْمَشَقَّةِ
u'شِدَّةٌ مِيلٌ':Added, #1: 1	شِدَّةُ الْمِيلِ
u'شِدَّةٌ ميل':Added, #1: 1	شِدَّةُ الْمِيلِ
u'شِدَّةٌ مَيْلٌ':Added, #1: 1	شِدَّةِ مَيْلِ
u'شِدَّةٌ نَزْعٌ':Added, #1: 1	شِدَّةِ مَيْلِ
u'شِدَّةٌ نَفْسٌ':Added, #1: 1	شِدَّةِ النَّزْعِ
u'شِدَّةٌ نَقْدٌ':Added, #1: 1	شِدَّةِ النَّفْسِ
u'شِدَّةٌ نَقْد':Added, #1: 1	شِدَّةِ نَقْدِهِ
u'شِدَّةٌ وَجْدٌ':Added, #1: 1	شِدَّةِ نَقْدِهِ
u'شِدَّةٌ وَجَعٌ':Added, #3: 3	شِدَّةِ وَجْدِ
u'شِدَّةٌ وَجَعٌ':Added, #1: 1	شِدَّةُ وَجَعٍ
u'شِدَّةٌ وَجَعٌ':Added, #1: 1	شِدَّةِ وَجَعِهِ
u'شِدَّةٌ وَحْلٌ':Added, #2: 2	شِدَّةِ الْوَجَعِ
u'شِدَّةٌ وَطْءٌ':Added, #1: 1	شِدَّةُ وَحْلٍ
u'شِدَّةٌ وَعِيدٌ':Added, #1: 1	شِدَّةُ وَطْءِ
u'شَدَّ تَعْجِيل':Predicate, #2: 2	شِدَّةِ الْوَعِيدِ
u'شَدَّ حَرٌّ':Predicate, #1: 1	أَشَدَّ تَعْجِيلاً
u'شَدَّدَ أَمْرٌ':Predicate, #1: 1	أَشَدَّ حَرَّ
u'شَدَّدَ باء':Predicate, #9: 9	شَدَّدَ الْأَمْرَ
u'شَدَّدَ راء':Predicate, #1: 1	شَدَّدَ الْبَاءَ
u'شَدَّ دَرَاهِمُ':Predicate, #1: 1	شَدَّدَ الرَّاءَ
u'شَدَّدَ صَحَابَةٌ':Subject, #1: 1	شَدَّ دَرَاهِمَ
u'شَدَّدَ علماء':Subject, #1: 1	شَدَّدَ الصَّحَابَةُ
u'شَدَّدَ عُلَمَاءُ':Subject, #1: 1	شَدَّدَ الْعُلَمَاءُ
u'شَدَّدَ مَالِكٌ':Subject, #1: 1	شَدَّدَ الْعُلَمَاءُ
u'شَدَّدَ نَكِيرٌ':Predicate, #4: 4	شَدَّدَ مَالِكٌ
u'شَدَّ رِجْلٌ':Predicate, #1: 1	شَدَّدَ النَّكِيرَ
u'شَدَّ رَجُلٌ':Subject, #1: 1	شَدَّ رِجْلَ
u'شَدَّ زُنَّارٌ':Predicate, #1: 1	شَدَّ الرَّجُلُ
u'شَدَّ سَرَاوِيلُ':Predicate, #2: 2	شَدَّ الزُّنَّارَ
u'شَدَّ صَوْتٌ':Predicate, #1: 1	شَدَّ السَّرَاوِيلَ
u'شَدَّ طعام':Predicate, #1: 1	أَشَدَّ صَوْتَكَ
u'شَدَّ طَعَامٌ':Predicate, #1: 1	شَدَّ الطَّعَامَ
u'شَدَّ عَضُدٌ':Predicate, #1: 1	شَدَّ الطَّعَامَ
u'شَدَّ عَظْمٌ':Predicate, #1: 1	شَدَّ عَضُدَ
u'شَدَّ فلان':Subject, #2: 2	شَدَّ الْعَظْمَ
u'شَدَّ فلان':Subject, #1: 1	شَدَّ الْقَصَّابُ
u'شَدَّ قَصّاب':Subject, #1: 1	شَدَّ عُثْمَانُ
u'شَدَّ كَسِيرٌ':Subject, #1: 1	شَدَّ الْقَصَّابُ
u'شَدَّ لفائف':Predicate, #1: 1	شَدَّ الْكَسِيرُ
u'شَدَّ لَفَائِفُ':Predicate, #1: 1	شَدَّ لَفَائِفَ
u'شَدَّ مَسْأَلَةٌ':Predicate, #1: 1	شَدَّ لَفَائِفَ
u'شَدَّ مِئْزَرُ':Predicate, #1: 1	أَشَدَّ مَسْأَلَتَكَ
u'شَدَّ نَحْوٌ':Predicate, #1: 1	شَدَّ الْمِئْزَرَ
u'شَدَّ وَجَعٌ':Predicate, #1: 1	شَدَّ نَحْوَ
u'شَدَّ وسط':Predicate, #1: 1	أَشَدَّ وَجَعَ
u'شَدَّ وَسَطٌ':Predicate, #1: 1	شَدَّ وَسَطَكَ
u'شَذَّ بَعيرٌ':Subject, #1: 1	شَدَّ وَسَطَكَ
u'شَذَّ شَيْءٌ':Subject, #2: 2	شَذَّ الْبَعِيرُ
u'شَذَّ قَوْمٌ':Subject, #1: 1	شَذَّ شَيْءٌ
u'شِرَاءٌ أَبٌ':Added, #1: 1	شَذَّ قَوْمٌ
u'شِرَاءٌ أَبٌ':Added, #4: 4	شِرَاءُ الْأَبِ
u'شِرَاءٌ أَبْزَارٌ':Added, #4: 4	شِرَاءِ الْأَبِ
u'شِرَاءٌ اِبْنٌ':Added, #1: 1	شِرَاءَ الْأَبْزَارِ
u'شِرَاءٌ أَجْنَبِيٌّ':Added, #1: 1	شِرَاءِ ابْنِهِ
u'شِرَاءٌ أَجْنَبِيٌّ':Added, #1: 1	شِرَاءَ الْأَجْنَبِيِّ
u'شِرَاءٌ أَحْرارٌ':Added, #2: 2	شِرَاءُ الْأَجْنَبِيِّ
u'شِرَاءٌ أَدَوَاتٌ':Added, #1: 1	شِرَاءَ الْأَحْرَارِ
u'شِرَاءٌ أرْضٌ':Added, #2: 2	شِرَاءِ الْأَدَوَاتِ
u'شِرَاءٌ أرْضٌ':Added, #1: 1	شِرَاءُ أَرْضِ
u'شِرَاءٌ أرْضٌ':Added, #1: 1	شِرَاءِ أَرْضٍ
u'شِرَاءٌ أرْضٌ':Added, #1: 1	شِرَاءُ الأَرْضِ
u'شِرَاءٌ أرْضٌ':Added, #2: 2	شِرَاءَ أَرْضِ
u'شِرَاءٌ أرْضٌ':Added, #2: 2	شِرَاءِ أَرْضِ
u'شِرَاءٌ أرْضٌ':Added, #3: 3	شِرَاءِ الْأَرْضِ
u'شِرَاءٌ أَرِقَّاءُ':Added, #8: 8	شِرَاءُ الْأَرْضِ
u'شِرَاءٌ أَشْيَاءٌ':Added, #1: 1	شِرَاءِ الْأَرِقَّاءِ
u'شِرَاءٌ أصل':Added, #1: 1	شِرَاءِ الْأَشْيَاءِ
u'شِرَاءٌ أصل':Added, #1: 1	شِرَاءُ أَصْلِ
u'شِرَاءٌ أًصْلٌ':Added, #1: 1	شِرَاءِ أَصْلِ
u'شِرَاءٌ أًصْلٌ':Added, #1: 1	شِرَاءُ أَصْلِ
u'شِرَاءٌ أعْيانٌ':Added, #1: 1	شِرَاءِ أَصْلِ
u'شِرَاءٌ أَعْيَانٌ':Added, #1: 1	شِرَاءِ الْأَعْيَانِ
u'شِرَاءٌ الْمَرْءُ':Added, #1: 1	شِرَاءِ الْأَعْيَانِ
u'شِرَاءٌ الْمَرْأَةُ':Added, #1: 1	شِرَاءِ الْمَرْءِ
u'شِرَاءٌ الْمَرْأَةُ':Added, #1: 1	شِرَاءَ الْمَرْأَةِ
u'شِرَاءٌ الْمَرْأَةُ':Added, #1: 1	شِرَاءُ الْمَرْأَةِ
u'شِرَاءٌ أمَةٌ':Added, #1: 1	شِرَاءِ الْمَرْأَةِ
u'شِرَاءٌ أمَةٌ':Added, #1: 1	شِرَاءُ الْأَمَةِ
u'شِرَاءٌ أمَةٌ':Added, #1: 1	شِرَاءُ أَمَةِ
u'شِرَاءٌ أمَةٌ':Added, #2: 2	شِرَاءَ الْأَمَةِ
u'شِرَاءٌ أمَةٌ':Added, #2: 2	شِرَاءَ أَمَةٍ
u'شِرَاءٌ أمَةٌ':Added, #3: 3	شِرَاءُ أَمَةٍ
u'شِرَاءٌ أمَةٌ':Added, #5: 5	شِرَاءِ الْأَمَةِ
u'شِرَاءٌ أَمْتِعَةٌ':Added, #5: 5	شِرَاءِ أَمَةٍ
u'شِرَاءٌ أَوَّلُ':Added, #1: 1	شِرَاءَ الْأَمْتِعَةِ
u'شِرَاءٌ أَوَّلُ':Added, #3: 3	شِرَاءَ الْأَوَّلِ
u'شِرَاءٌ أَوْلاَدٌ':Added, #3: 3	شِرَاءُ الْأَوَّلِ
u'شِرَاءٌ أَوْلاَدٌ':Added, #1: 1	شِرَاءِ أَوْلَادِ
u'شِرَاءٌ بالِغٌ':Added, #2: 2	شِرَاءُ أَوْلَادِ
u'شِرَاءٌ بَائِعٌ':Added, #2: 2	شِرَاءُ بَالِغٍ
u'شِرَاءٌ بَائِعٌ':Added, #1: 1	شِرَاءِ الْبَائِعِ
u'شِرَاءٌ بَدَلٌ':Added, #2: 2	شِرَاءُ الْبَائِعِ
u'شِرَاءٌ بُرٌّ':Added, #1: 1	شِرَاءُ بَدَلِ
u'شِرَاءٌ بُرٌّ':Added, #1: 1	شِرَاءُ الْبُرِّ
u'شِرَاءٌ بُرٌّ':Added, #1: 1	شِرَاءُ بُرٍّ
u'شِرَاءٌ بَراءةٌ':Added, #2: 2	شِرَاءِ الْبُرِّ
u'شِرَاءٌ بَزّ':Added, #1: 1	شِرَاءُ الْبَرَاءَاتِ
u'شِرَاءٌ بُسْتانٌ':Added, #3: 3	شِرَاءِ الْبَزِّ
u'شِرَاءٌ بَعْضٌ':Added, #1: 1	شِرَاءُ الْبُسْتَانِ
u'شِرَاءٌ بَعْضٌ':Added, #1: 1	شِرَاءَ بَعْضِ
u'شِرَاءٌ بَعْضٌ':Added, #1: 1	شِرَاءُ بَعْضِ
u'شِرَاءٌ بَعْضٌ':Added, #1: 1	شِرَاءُ بَعْضِهِ
u'شِرَاءٌ بَعْضٌ':Added, #2: 2	شِرَاءِ الْبَعْضِ
u'شِرَاءٌ بَقَرٌ':Added, #3: 3	شِرَاءَ الْبَعْضِ
u'شِرَاءٌ بَقَرٌ':Added, #1: 1	شِرَاءِ بَقَرٍ
u'شِرَاءٌ بَقْلٌ':Added, #1: 1	شِرَاءِ بَقَرَةٍ
u'شِرَاءٌ بِنْتٌ':Added, #1: 1	شِرَاءِ الْبَقْلِ
u'شِرَاءٌ بِنْتٌ':Added, #1: 1	شِرَاءَ بِنْتِ
u'شِرَاءٌ بِنْتٌ':Added, #1: 1	شِرَاءُ بِنْتِ
u'شِرَاءٌ بَيْتٌ':Added, #2: 2	شِرَاءِ بِنْتِ
u'شِرَاءٌ تَاجِرٌ':Added, #1: 1	شِرَاءَ بَيْتٍ
u'شِرَاءٌ تِبْرٌ':Added, #1: 1	شِرَاءُ التَّاجِرِ
u'شِرَاءٌ تُرَابٌ':Added, #1: 1	شِرَاءُ تِبْرِ
u'شِرَاءٌ تُرَابٌ':Added, #1: 1	شِرَاءُ التُّرَابِ
u'شِرَاءٌ تَوَابِلُ':Added, #1: 1	شِرَاءِ التُّرَابِ
u'شِرَاءٌ تَوْكِيلٌ':Added, #1: 1	شِرَاءِ التَّوَابِلِ
u'شِرَاءٌ ثَانِي':Added, #1: 1	شِرَاءِ التَّوْكِيلِ
u'شِرَاءٌ ثَانِيَةٌ':Added, #1: 1	شِرَاءِ الثَّانِيَةِ
u'شِرَاءٌ ثَلْجٌ':Added, #1: 1	شِرَاءِ الثَّانِيَةِ
u'شِرَاءٌ ثَمَرٌ':Added, #1: 1	شِرَاءِ ثَلْجٍ
u'شِرَاءٌ ثَمَرٌ':Added, #1: 1	شِرَاءُ الثَّمَرِ
u'شِرَاءٌ ثَمَرَةٌ':Added, #1: 1	شِرَاءِ ثَمَرِ
u'شِرَاءٌ ثَمَرَةٌ':Added, #1: 1	شِرَاءِ ثَمَرَةِ
u'شِرَاءٌ ثَمَرَةٌ':Added, #2: 2	شِرَاءُ ثَمَرَةِ
u'شِرَاءٌ ثَوْبٌ':Added, #3: 3	شِرَاءِ الثَّمَرَةِ
u'شِرَاءٌ ثَوْبٌ':Added, #1: 1	شِرَاءِ ثَوْبٍ
u'شِرَاءٌ ثَوْبٌ':Added, #2: 2	شِرَاءَ الثَّوْبِ
u'شِرَاءٌ ثَوْبٌ':Added, #2: 2	شِرَاءَ ثَوْبٍ
u'شِرَاءٌ ثَوْبٌ':Added, #3: 3	شِرَاءُ الثَّوْبِ
u'شِرَاءٌ ثَوْبٌ':Added, #3: 3	شِرَاءِ الثَّوْبِ
u'شِرَاءٌ ثِيابٌ':Added, #4: 4	شِرَاءُ ثَوْبٍ
u'شِرَاءٌ جَارِي':Added, #1: 1	شِرَاءَ الثِّيَابِ
u'شِرَاءٌ جَارِي':Added, #10: 10	شِرَاءِ جَارِيَةٍ
u'شِرَاءٌ جَارِي':Added, #1: 1	شِرَاءُ جَارِيَةٍ
u'شِرَاءٌ جَارِي':Added, #2: 2	شِرَاءِ الْجَارِيَةِ
u'شِرَاءٌ جَارِي':Added, #4: 4	شِرَاءُ الْجَارِيَةِ
u'شِرَاءٌ جَارِيَةٌ':Added, #5: 5	شِرَاءَ جَارِيَةٍ
u'شِرَاءٌ جَارِيَةٌ':Added, #10: 10	شِرَاءِ جَارِيَةٍ
u'شِرَاءٌ جَارِيَةٌ':Added, #1: 1	شِرَاءُ جَارِيَةٍ
u'شِرَاءٌ جَارِيَةٌ':Added, #2: 2	شِرَاءِ الْجَارِيَةِ
u'شِرَاءٌ جَارِيَةٌ':Added, #4: 4	شِرَاءُ الْجَارِيَةِ
u'شِرَاءٌ جَاهِلٌ':Added, #5: 5	شِرَاءَ جَارِيَةٍ
u'شِرَاءٌ جَحْش':Added, #1: 1	شِرَاءِ الْجَاهِلِ
u'شِرَاءٌ جُلُودٌ':Added, #1: 1	شِرَاءِ جَحْشٍ
u'شِرَاءٌ جَمْدٌ':Added, #1: 1	شِرَاءُ الْجُلُودِ
u'شِرَاءٌ جَمْدٌ':Added, #1: 1	شِرَاءِ الْجَمْدِ
u'شِرَاءٌ جُمْلَةٌ':Added, #1: 1	شِرَاءِ جَمْدٍ
u'شِرَاءٌ جَمِيع':Added, #1: 1	شِرَاءِ الْجُمْلَةِ
u'شِرَاءٌ جَمِيع':Added, #1: 1	شِرَاءَ الْجَمِيعِ
u'شِرَاءٌ جِنَانٌ':Added, #1: 1	شِرَاءُ الْجَمِيعِ
u'شِرَاءٌ جهاز':Added, #1: 1	شِرَاءَ جِنَانٍ
u'شِرَاءٌ جهاز':Added, #1: 1	شِرَاءُ جِهَازٍ
u'شِرَاءٌ جهاز':Added, #1: 1	شِرَاءِ جَهَازٍ
u'شِرَاءٌ جِهَازٌ':Added, #1: 1	شِرَاءِ جِهَازٍ
u'شِرَاءٌ جِهَازٌ':Added, #1: 1	شِرَاءُ جِهَازٍ
u'شِرَاءٌ حاجَةٌ':Added, #1: 1	شِرَاءِ جِهَازٍ
u'شِرَاءٌ حائِطٌ':Added, #1: 1	شِرَاءِ حَاجَةٍ
u'شِرَاءٌ حائِطٌ':Added, #1: 1	شِرَاءِ الْحَائِطِ
u'شِرَاءٌ حَبٌّ':Added, #2: 2	شِرَاءَ الْحَائِطِ
u'شِرَاءٌ حَديقَةٌ':Added, #1: 1	شِرَاءَ الْحَبِّ
u'شِرَاءٌ حَشِيشٌ':Added, #1: 1	شِرَاءِ الْحَدِيقَةِ
u'شِرَاءٌ حِصْرِمٌ':Added, #1: 1	شِرَاءَ الْحَشِيشِ
u'شِرَاءٌ حَصِيرٌ':Added, #1: 1	شِرَاءُ الْحِصْرِمِ
u'شِرَاءٌ حِنْطَةٌ':Added, #1: 1	شِرَاءِ حَصِيرٍ
u'شِرَاءٌ حِنْطَةٌ':Added, #1: 1	شِرَاءِ الْحِنْطَةِ
u'شِرَاءٌ حَوائِجُ':Added, #1: 1	شِرَاءِ حِنْطَةٍ
u'شِرَاءٌ حَوائِجُ':Added, #1: 1	شِرَاءَ الْحَوَائِجِ
u'شِرَاءٌ حُوتٌ':Added, #1: 1	شِرَاءِ الْحَوَائِجِ
u'شِرَاءٌ حَيَوَانٌ':Added, #1: 1	شِرَاءَ الْحُوتِ
u'شِرَاءٌ خَادِمٌ':Added, #2: 2	شِرَاءِ الْحَيَوَانِ
u'شِرَاءٌ خَادِمٌ':Added, #1: 1	شِرَاءُ خَادِمٍ
u'شِرَاءٌ خُبْزٌ':Added, #1: 1	شِرَاءِ خَادِمَةٍ
u'شِرَاءٌ خُبْزٌ':Added, #1: 1	شِرَاءِ الْخُبْزِ
u'شِرَاءٌ خِلْف':Added, #1: 1	شِرَاءِ خُبْزٍ
u'شِرَاءٌ خِلْف':Added, #1: 1	شِرَاءَ الْخِلْفَةِ
u'شِرَاءٌ خِلْفَة':Added, #1: 1	شِرَاءُ الْخِلْفَةِ
u'شِرَاءٌ خِلْفَة':Added, #1: 1	شِرَاءَ الْخِلْفَةِ
u'شِرَاءٌ خَمْرٌ':Added, #1: 1	شِرَاءُ الْخِلْفَةِ
u'شِرَاءٌ خَمْرٌ':Added, #1: 1	شِرَاءُ الْخَمْرِ
u'شِرَاءٌ خَمْسَةٌ':Added, #2: 2	شِرَاءِ خَمْرٍ
u'شِرَاءٌ دَابَّةٌ':Added, #1: 1	شِرَاءُ خَمْسَةِ
u'شِرَاءٌ دَابَّةٌ':Added, #1: 1	شِرَاءِ الدَّابَّةِ
u'شِرَاءٌ دَارٌ':Added, #1: 1	شِرَاءِ دَابَّةٍ
u'شِرَاءٌ دَارٌ':Added, #2: 2	شِرَاءُ الدَّارِ
u'شِرَاءٌ دَارٌ':Added, #3: 3	شِرَاءُ دَارٍ
u'شِرَاءٌ دَارٌ':Added, #4: 4	شِرَاءِ دَارٍ
u'شِرَاءٌ دَارٌ':Added, #5: 5	شِرَاءَ الدَّارِ
u'شِرَاءٌ دَارٌ':Added, #5: 5	شِرَاءَ دَارٍ
u'شِرَاءٌ دُهْنٌ':Added, #6: 6	شِرَاءِ الدَّارِ
u'شِرَاءٌ دُهْنٌ':Added, #1: 1	شِرَاءُ الدُّهْنِ
u'شِرَاءٌ دُورٌ':Added, #1: 1	شِرَاءِ الدُّهْنِ
u'شِرَاءٌ دَيْنٌ':Added, #2: 2	شِرَاءُ دُورِ
u'شِرَاءٌ دَيْنٌ':Added, #1: 1	شِرَاءَ الدَّيْنِ
u'شِرَاءٌ ذِراعٌ':Added, #2: 2	شِرَاءُ دَيْنٍ
u'شِرَاءٌ ذُكورٌ':Added, #1: 1	شِرَاءَ ذِرَاعٍ
u'شِرَاءٌ ذِمِّيٌّ':Added, #2: 2	شِرَاءِ الذُّكُورِ
u'شِرَاءٌ ذِمِّيٌّ':Added, #2: 2	شِرَاءِ الذِّمِّيِّ
u'شِرَاءٌ رَاحِلٌ':Added, #3: 3	شِرَاءُ الذِّمِّيِّ
u'شِرَاءٌ رَاحِلَةٌ':Added, #1: 1	شِرَاءُ الرَّاحِلَةِ
u'شِرَاءٌ رَبُّ':Added, #1: 1	شِرَاءُ الرَّاحِلَةِ
u'شِرَاءٌ رَبُّ':Added, #2: 2	شِرَاءُ رَبِّ
u'شِرَاءٌ رَجُلٌ':Added, #6: 6	شِرَاءِ رَبِّ
u'شِرَاءٌ رَجُلٌ':Added, #1: 1	شِرَاءِ الرَّجُلِ
u'شِرَاءٌ رَجُلٌ':Added, #2: 2	شِرَاءَ الرَّجُلِ
u'شِرَاءٌ رِقابٌ':Added, #5: 5	شِرَاءُ الرَّجُلِ
u'شِرَاءٌ رَقَبَةٌ':Added, #1: 1	شِرَاءُ الرِّقَابِ
u'شِرَاءٌ رَقَبَةٌ':Added, #1: 1	شِرَاءُ الرَّقَبَةِ
u'شِرَاءٌ رَقَبَةٌ':Added, #1: 1	شِرَاءِ الرَّقَبَةِ
u'شِرَاءٌ رَقيقٌ':Added, #1: 1	شِرَاءِ رَقَبَةٍ
u'شِرَاءٌ رَقيق':Added, #1: 1	شِرَاءَ الرَّقِيقِ
u'شِرَاءٌ رَقيقٌ':Added, #1: 1	شِرَاءَ الرَّقِيقِ
u'شِرَاءٌ رَقيق':Added, #2: 2	شِرَاءِ الرَّقِيقِ
u'شِرَاءٌ رَقيقٌ':Added, #2: 2	شِرَاءِ الرَّقِيقِ
u'شِرَاءٌ رَقيق':Added, #2: 2	شِرَاءِ رَقِيقٍ
u'شِرَاءٌ رَقيقٌ':Added, #2: 2	شِرَاءِ رَقِيقٍ
u'شِرَاءٌ رَقيق':Added, #3: 3	شِرَاءُ الرَّقِيقِ
u'شِرَاءٌ زادٌ':Added, #3: 3	شِرَاءُ الرَّقِيقِ
u'شِرَاءٌ زائِدٌ':Added, #1: 1	شِرَاءُ الزَّادِ
u'شِرَاءٌ زِبْلٌ':Added, #3: 3	شِرَاءِ الزَّائِدِ
u'شِرَاءٌ زَرْعٌ':Added, #1: 1	شِرَاءِ الزِّبْلِ
u'شِرَاءٌ زَكاةٌ':Added, #1: 1	شِرَاءِ الزَّرْعِ
u'شِرَاءٌ زَوْجٌ':Added, #4: 4	شِرَاءُ زَكَاتِهِ
u'شِرَاءٌ زَوْجٌ':Added, #1: 1	شِرَاءُ الزَّوْجِ
u'شِرَاءٌ زَوْجَةٌ':Added, #3: 3	شِرَاءِ الزَّوْجِ
u'شِرَاءٌ زَوْجَةٌ':Added, #1: 1	شِرَاءِ الزَّوْجَةِ
u'شِرَاءٌ زَوْجَةٌ':Added, #1: 1	شِرَاءِ زَوْجَةِ
u'شِرَاءٌ زَيْتونٌ':Added, #1: 1	شِرَاءَ زَوْجَتِهِ
u'شِرَاءٌ سَاعَةٌ':Added, #1: 1	شِرَاءُ زَيْتُونٍ
u'شِرَاءٌ سِباعٌ':Added, #2: 2	شِرَاءُ السَّاعَةِ
u'شِرَاءٌ سَبْيٌ':Added, #1: 1	شِرَاءُ السِّبَاعِ
u'شِرَاءٌ سترة':Added, #1: 1	شِرَاءِ السَّبْيِ
u'شِرَاءٌ سُتْرَةٌ':Added, #2: 2	شِرَاءُ السُّتْرَةِ
u'شِرَاءٌ سَفِينَةٌ':Added, #2: 2	شِرَاءُ السُّتْرَةِ
u'شِرَاءٌ سِلاَحٌ':Added, #2: 2	شِرَاءُ السَّفِينَةِ
u'شِرَاءٌ سُلْطَانٌ':Added, #1: 1	شِرَاءِ السِّلَاحِ
u'شِرَاءٌ سِلَعٌ':Added, #1: 1	شِرَاءِ السُّلْطَانِ
u'شِرَاءٌ سِلْعَةٌ':Added, #1: 1	شِرَاءِ السِّلَعِ
u'شِرَاءٌ سِلْعَةٌ':Added, #10: 10	شِرَاءِ سِلْعَةٍ
u'شِرَاءٌ سِلْعَةٌ':Added, #1: 1	شِرَاءَ سِلْعَةٍ
u'شِرَاءٌ سِلْعَةٌ':Added, #2: 2	شِرَاءُ سِلْعَةٍ
u'شِرَاءٌ سَلِيمٌ':Added, #3: 3	شِرَاءِ السِّلْعَةِ
u'شِرَاءٌ سُنْبُلٌ':Added, #1: 1	شِرَاءُ السَّلِيمِ
u'شِرَاءٌ سَهْمٌ':Added, #1: 1	شِرَاءُ السُّنْبُلِ
u'شِرَاءٌ سَيِّدٌ':Added, #1: 1	شِرَاءِ سَهْمٍ
u'شِرَاءٌ شَاةٌ':Added, #4: 4	شِرَاءُ السَّيِّدِ
u'شِرَاءٌ شَجَرٌ':Added, #3: 3	شِرَاءِ شَاةٍ
u'شِرَاءٌ شَجَرٌ':Added, #1: 1	شِرَاءَ الشَّجَرِ
u'شِرَاءٌ شَجَرَةٌ':Added, #1: 1	شِرَاءِ الشَّجَرِ
u'شِرَاءٌ شرب':Added, #2: 2	شِرَاءُ الشَّجَرَةِ
u'شِرَاءٌ شِرْبٌ':Added, #1: 1	شِرَاءُ الشِّرْبِ
u'شِرَاءٌ شَرِيكٌ':Added, #1: 1	شِرَاءُ الشِّرْبِ
u'شِرَاءٌ شَفِيعٌ':Added, #1: 1	شِرَاءَ الشَّرِيكِ
u'شِرَاءٌ شَيْءٌ':Added, #1: 1	شِرَاءَ الشَّفِيعِ
u'شِرَاءٌ شَيْءٌ':Added, #11: 11	شِرَاءِ شَيْءٍ
u'شِرَاءٌ شَيْءٌ':Added, #1: 1	شِرَاءَ الشَّيْءِ
u'شِرَاءٌ شَيْءٌ':Added, #1: 1	شِرَاءُ الشَّيْءِ
u'شِرَاءٌ شَيْءٌ':Added, #5: 5	شِرَاءَ شَيْءٍ
u'شِرَاءٌ شِيَاهٌ':Added, #6: 6	شِرَاءُ شَيْءٍ
u'شِرَاءٌ صَاحِبٌ':Added, #1: 1	شِرَاءَ شِيَاهٍ
u'شِرَاءٌ صَاعٌ':Added, #2: 2	شِرَاءِ صَاحِبِ
u'شِرَاءٌ صبرة':Added, #1: 1	شِرَاءُ الصَّاعِ
u'شِرَاءٌ صُبْرَةٌ':Added, #1: 1	شِرَاءُ صُبْرَةٍ
u'شِرَاءٌ صدقة':Added, #1: 1	شِرَاءُ صُبْرَةٍ
u'شِرَاءٌ صَدَقَةٌ':Added, #1: 1	شِرَاءِ الصَّدَقَةِ
u'شِرَاءٌ صدقة':Added, #1: 1	شِرَاءِ الصَّدَقَةِ
u'شِرَاءٌ صَدَقَةٌ':Added, #1: 1	شِرَاءُ صَدَقَتِهِ
u'شِرَاءٌ صَدَقَةٌ':Added, #1: 1	شِرَاءُ صَدَقَتِهِ
u'شِرَاءٌ صغار':Added, #2: 2	شِرَاءِ الصَّدَقَاتِ
u'شِرَاءٌ صَيْدٌ':Added, #1: 1	شِرَاءِ صِغَارِ
u'شِرَاءٌ صَيْدٌ':Added, #1: 1	شِرَاءِ صَيْدٍ
u'شِرَاءٌ صَيْدٌ':Added, #2: 2	شِرَاءَ الصَّيْدِ
u'شِرَاءٌ طَرِيقٌ':Added, #2: 2	شِرَاءُ صَيْدٍ
u'شِرَاءٌ طعام':Added, #1: 1	شِرَاءُ طَرِيقٍ
u'شِرَاءٌ طَعَامٌ':Added, #2: 2	شِرَاءِ طَعَامٍ
u'شِرَاءٌ طعام':Added, #2: 2	شِرَاءِ طَعَامٍ
u'شِرَاءٌ طَعَامٌ':Added, #3: 3	شِرَاءَ الطَّعَامِ
u'شِرَاءٌ طعام':Added, #3: 3	شِرَاءَ الطَّعَامِ
u'شِرَاءٌ طَعَامٌ':Added, #8: 8	شِرَاءِ الطَّعَامِ
u'شِرَاءٌ ظَرْفٌ':Added, #8: 8	شِرَاءِ الطَّعَامِ
u'شِرَاءٌ عَامِلٌ':Added, #1: 1	شِرَاءِ الظَّرْفِ
u'شِرَاءٌ عَبْدٌ':Added, #3: 3	شِرَاءِ الْعَامِلِ
u'شِرَاءٌ عَبْدٌ':Added, #10: 10	شِرَاءِ الْعَبْدِ
u'شِرَاءٌ عَبْدٌ':Added, #1: 1	شِرَاءُ عَبْدٍ
u'شِرَاءٌ عَبْدٌ':Added, #2: 2	شِرَاءَ عَبْدِهِ
u'شِرَاءٌ عَبْدٌ':Added, #3: 3	شِرَاءَ عَبْدٍ
u'شِرَاءٌ عَبْدٌ':Added, #4: 4	شِرَاءُ الْعَبْدِ
u'شِرَاءٌ عَبْدٌ':Added, #6: 6	شِرَاءَ الْعَبْدِ
u'شِرَاءٌ عَبِيدٌ':Added, #8: 8	شِرَاءِ عَبْدٍ
u'شِرَاءٌ عَبِيدٌ':Added, #1: 1	شِرَاءِ الْعَبِيدِ
u'شِرَاءٌ عَرْصَةٌ':Added, #1: 1	شِرَاءِ عَبِيدٍ
u'شِرَاءٌ عَرَضٌ':Added, #1: 1	شِرَاءُ عَرْصَةٍ
u'شِرَاءٌ عَرْضٌ':Added, #1: 1	شِرَاءُ عَرَضٍ
u'شِرَاءٌ عَصَافِيرُ':Added, #1: 1	شِرَاءُ عَرْضٍ
u'شِرَاءٌ عَقَارٌ':Added, #1: 1	شِرَاءُ الْعَصَافِيرِ
u'شِرَاءٌ عَقَارٌ':Added, #1: 1	شِرَاءِ الْعَقَارِ
u'شِرَاءٌ عَقَارٌ':Added, #1: 1	شِرَاء عَقَارٍ
u'شِرَاءٌ عَقَارٌ':Added, #1: 1	شِرَاءُ عَقَارٍ
u'شِرَاءٌ عِمَارَةٌ':Added, #5: 5	شِرَاءِ عَقَارٍ
u'شِرَاءٌ عمياء':Added, #1: 1	شِرَاءُ عِمَارَةِ
u'شِرَاءٌ عِنَبٌ':Added, #2: 2	شِرَاءُ الْعَمْيَاءِ
u'شِرَاءٌ عِنَبٌ':Added, #1: 1	شِرَاءِ الْعِنَبِ
u'شِرَاءٌ عين':Added, #2: 2	شِرَاءَ الْعِنَبِ
u'شِرَاءٌ عَيْنٌ':Added, #1: 1	شِرَاءَ الْعَيْنِ
u'شِرَاءٌ عَيْن':Added, #1: 1	شِرَاءَ الْعَيْنِ
u'شِرَاءٌ عين':Added, #1: 1	شِرَاءَ الْعَيْنِ
u'شِرَاءٌ عَيْنٌ':Added, #1: 1	شِرَاءُ عَيْنِ
u'شِرَاءٌ عَيْنٌ':Added, #1: 1	شِرَاءُ عَيْنِ
u'شِرَاءٌ عَيْن':Added, #1: 1	شِرَاءِ عَيْنٍ
u'شِرَاءٌ عَيْن':Added, #1: 1	شِرَاءُ عَيْنِ
u'شِرَاءٌ عين':Added, #1: 1	شِرَاءِ عَيْنٍ
u'شِرَاءٌ عَيْنٌ':Added, #5: 5	شِرَاءِ الْعَيْنِ
u'شِرَاءٌ عَيْن':Added, #5: 5	شِرَاءِ الْعَيْنِ
u'شِرَاءٌ غَاصِبٌ':Added, #5: 5	شِرَاءِ الْعَيْنِ
u'شِرَاءٌ غَائِبٌ':Added, #1: 1	شِرَاءِ الْغَاصِبِ
u'شِرَاءٌ غَنَائِمُ':Added, #1: 1	شِرَاءِ الْغَائِبِ
u'شِرَاءٌ غير':Added, #1: 1	شِرَاءِ الْغَنَائِمِ
u'شِرَاءٌ غَيْرٌ':Added, #1: 1	شِرَاءِ الْغَيْرِ
u'شِرَاءٌ غير':Added, #1: 1	شِرَاءِ الْغَيْرِ
u'شِرَاءٌ غَيْرٌ':Added, #4: 4	شِرَاءُ غَيْرِ
u'شِرَاءٌ غير':Added, #4: 4	شِرَاءُ غَيْرِ
u'شِرَاءٌ غَيْرٌ':Added, #5: 5	شِرَاءُ غَيْرِهِ
u'شِرَاءٌ غير':Added, #5: 5	شِرَاءُ غَيْرِهِ
u'شِرَاءٌ غَيْرٌ':Added, #6: 6	شِرَاءِ غَيْرِهِ
u'شِرَاءٌ فَاسِدٌ':Added, #6: 6	شِرَاءِ غَيْرِهِ
u'شِرَاءٌ فَاسِدٌ':Added, #1: 1	شِرَاءٍ فَاسِدٍ
u'شِرَاءٌ فُضُولِيٌّ':Added, #1: 1	شِرَاءِ فَاسِدٍ
u'شِرَاءٌ فُضُولِيٌّ':Added, #1: 1	شِرَاءَ فُضُولِيٍّ
u'شِرَاءٌ فُضُولِيٌّ':Added, #2: 2	شِرَاءَ الْفُضُولِيِّ
u'شِرَاءٌ فُضُولِيٌّ':Added, #3: 3	شِرَاءُ فُضُولِيٍّ
u'شِرَاءٌ فُضُولِيٌّ':Added, #5: 5	شِرَاءِ الْفُضُولِيِّ
u'شِرَاءٌ فُلاَنٌ':Added, #6: 6	شِرَاءُ الْفُضُولِيِّ
u'شِرَاءٌ فُولٌ':Added, #1: 1	شِرَاءِ فُلَانٍ
u'شِرَاءٌ فُولٌ':Added, #1: 1	شِرَاءُ الْفُولِ
u'شِرَاءٌ قَابِضٌ':Added, #1: 1	شِرَاءِ الْفُولِ
u'شِرَاءٌ قَدْرٌ':Added, #1: 1	شِرَاءِ الْقَابِضِ
u'شِرَاءٌ قرار':Added, #1: 1	شِرَاءِ قَدْرِ
u'شِرَاءٌ قَرَارٌ':Added, #1: 1	شِرَاءِ الْقَرَارِ
u'شِرَاءٌ قَرِيبٌ':Added, #1: 1	شِرَاءِ الْقَرَارِ
u'شِرَاءٌ قَرِيبٌ':Added, #13: 13	شِرَاءَ الْقَرِيبِ
u'شِرَاءٌ قَرِيبٌ':Added, #4: 4	شِرَاءُ الْقَرِيبِ
u'شِرَاءٌ قَرْيَةٌ':Added, #8: 8	شِرَاءِ الْقَرِيبِ
u'شِرَاءٌ قَصِيلٌ':Added, #1: 1	شِرَاءِ الْقَرْيَةِ
u'شِرَاءٌ قُوتٌ':Added, #2: 2	شِرَاءُ قَصِيلِ
u'شِرَاءٌ كَافِرٌ':Added, #1: 1	شِرَاءُ قُوتِهِ
u'شِرَاءٌ كَافِرٌ':Added, #1: 1	شِرَاءَ الْكَافِرِ
u'شِرَاءٌ كَافِرٌ':Added, #1: 1	شِرَاءُ الْكَافِرِ
u'شِرَاءٌ كُتُبٌ':Added, #4: 4	شِرَاءِ الْكَافِرِ
u'شِرَاءٌ كُتُبٌ':Added, #1: 1	شِرَاءُ كُتُبِ
u'شِرَاءٌ كَثِيرٌ':Added, #1: 1	شِرَاءِ كُتُبِ
u'شِرَاءٌ كَفَنٌ':Added, #2: 2	شِرَاءِ كَثِيرِ
u'شِرَاءٌ كَفَنٌ':Added, #1: 1	شِرَاءِ كَفَنِ
u'شِرَاءٌ كَلْبٌ':Added, #4: 4	شِرَاءِ الْكَفَنِ
u'شِرَاءٌ لبن':Added, #1: 1	شِرَاءِ كَلْبٍ
u'شِرَاءٌ لَبَنٌ':Added, #1: 1	شِرَاءِ اللَّبَنِ
u'شِرَاءٌ لبن':Added, #1: 1	شِرَاءِ اللَّبَنِ
u'شِرَاءٌ لبن':Added, #1: 1	شِرَاءَ لَبَنِ
u'شِرَاءٌ لَبَنٌ':Added, #1: 1	شِرَاءُ لَبَنِ
u'شِرَاءٌ لَبَنٌ':Added, #1: 1	شِرَاءَ لَبَنِ
u'شِرَاءٌ لَبَنٌ':Added, #1: 1	شِرَاءُ لَبَنٍ
u'شِرَاءٌ لَحْمٌ':Added, #1: 1	شِرَاءُ لَبَنِ
u'شِرَاءٌ لَحْمٌ':Added, #1: 1	شِرَاءِ اللَّحْمِ
u'شِرَاءٌ لَحْمٌ':Added, #1: 1	شِرَاءُ لَحْمِ
u'شِرَاءٌ لَحْمٌ':Added, #2: 2	شِرَاءُ اللَّحْمِ
u'شِرَاءٌ لَيْلٌ':Added, #2: 2	شِرَاءُ لَحْمٍ
u'شِرَاءٌ مَاءٌ':Added, #1: 1	شِرَاءِ لَيْلَةٍ
u'شِرَاءٌ مَاءٌ':Added, #14: 14	شِرَاءُ الْمَاءِ
u'شِرَاءٌ مَاءٌ':Added, #14: 14	شِرَاءِ الْمَاءِ
u'شِرَاءٌ مَاءٌ':Added, #1: 1	شِرَاءُ مَاءٍ
u'شِرَاءٌ مَاءٌ':Added, #3: 3	شِرَاءِ مَاءٍ
u'شِرَاءٌ مَأْكُولٌ':Added, #4: 4	شِرَاءَ الْمَاءِ
u'شِرَاءٌ مَالٌ':Added, #1: 1	شِرَاءِ الْمَأْكُولِ
u'شِرَاءٌ مَالٌ':Added, #1: 1	شِرَاءُ الْمَالِ
u'شِرَاءٌ مَالٌ':Added, #1: 1	شِرَاءَ مَالِ
u'شِرَاءٌ مَالٌ':Added, #1: 1	شِرَاءِ مَالٍ
u'شِرَاءٌ مَالِكٌ':Added, #1: 1	شِرَاءِ مَالِ
u'شِرَاءٌ مَأْمُورٌ':Added, #2: 2	شِرَاءِ الْمَالِكِ
u'شِرَاءٌ مُبْتَدَأٌ':Added, #1: 1	شِرَاءِ الْمَأْمُورِ
u'شِرَاءٌ مُبْتَدَأٌ':Added, #1: 1	شِرَاءٍ مُبْتَدَأٍ
u'شِرَاءٌ مَبِيعٌ':Added, #1: 1	شِرَاءِ مُبْتَدَأٍ
u'شِرَاءٌ مَتَاعٌ':Added, #5: 5	شِرَاءِ الْمَبِيعِ
u'شِرَاءٌ مَتَاعٌ':Added, #1: 1	شِرَاءِ الْمَتَاعِ
u'شِرَاءٌ مَتَاعٌ':Added, #1: 1	شِرَاءِ مَتَاعِ
u'شِرَاءٌ مَتَاعٌ':Added, #2: 2	شِرَاءَ الْمَتَاعِ
u'شِرَاءٌ مثل':Added, #2: 2	شِرَاءُ الْمَتَاعِ
u'شِرَاءٌ مثل':Added, #1: 1	شِرَاءُ مِثْلِهِ
u'شِرَاءٌ مِثْلٌ':Added, #1: 1	شِرَاءِ مِثْلِهِ
u'شِرَاءٌ مِثْلٌ':Added, #1: 1	شِرَاءُ مِثْلِهِ
u'شِرَاءٌ مُحْتَكِرٌ':Added, #1: 1	شِرَاءِ مِثْلِهِ
u'شِرَاءٌ مَحْجُورٌ':Added, #2: 2	شِرَاءُ مُحْتَكِرٍ
u'شِرَاءٌ مَحْدُودٌ':Added, #1: 1	شِرَاءُ مَحْجُورِهِ
u'شِرَاءٌ مَحْدُودٌ':Added, #1: 1	شِرَاءِ الْمَحْدُودِ
u'شِرَاءٌ مَحْرَمٌ':Added, #1: 1	شِرَاءُ مَحْدُودَاتٍ
u'شِرَاءٌ مَحَلٌّ':Added, #1: 1	شِرَاءِ مَحْرَمِهِ
u'شِرَاءٌ مُرْتَدٌّ':Added, #1: 1	شِرَاءَ مَحَلٍّ
u'شِرَاءٌ مِرْواح':Added, #1: 1	شِرَاءُ الْمُرْتَدِّ
u'شِرَاءٌ مَرِيضٌ':Added, #1: 1	شِرَاءُ الْمِرْوَاحِ
u'شِرَاءٌ مَرِيضٌ':Added, #1: 1	شِرَاءَ الْمَرِيضِ
u'شِرَاءٌ مُسَافِرٌ':Added, #1: 1	شِرَاءِ الْمَرِيضَةِ
u'شِرَاءٌ مَسْكَنٌ':Added, #1: 1	شِرَاءِ الْمُسَافِرِ
u'شِرَاءٌ مَسْكَنٌ':Added, #1: 1	شِرَاءِ الْمَسْكَنِ
u'شِرَاءٌ مُسْلِمٌ':Added, #1: 1	شِرَاءِ مَسْكَنٍ
u'شِرَاءٌ مُسْلِمٌ':Added, #1: 1	شِرَاءَ الْمُسْلِمِ
u'شِرَاءٌ مُسْلِمٌ':Added, #1: 1	شِرَاءُ مُسْلِمٍ
u'شِرَاءٌ مُسْلِمٌ':Added, #2: 2	شِرَاءِ الْمُسْلِمِ
u'شِرَاءٌ مُسْلِمٌ':Added, #3: 3	شِرَاءِ مُسْلِمٍ
u'شِرَاءٌ مَصَاحِفُ':Added, #4: 4	شِرَاءُ الْمُسْلِمِ
u'شِرَاءٌ مُصْحَفٌ':Added, #1: 1	شِرَاءَ الْمَصَاحِفِ
u'شِرَاءٌ مُصْحَفٌ':Added, #1: 1	شِرَاءَ الْمُصْحَفِ
u'شِرَاءٌ مُصلَّيَاتٌ':Added, #2: 2	شِرَاءِ الْمُصْحَفِ
u'شِرَاءٌ مُضَارِبٌ':Added, #1: 1	شِرَاءُ الْمُصَلَّيَاتِ
u'شِرَاءٌ مَعِيبٌ':Added, #6: 6	شِرَاءِ الْمُضَارِبِ
u'شِرَاءٌ مَعِيبٌ':Added, #1: 1	شِرَاءَ الْمَعِيبِ
u'شِرَاءٌ مَعِيبٌ':Added, #2: 2	شِرَاءِ الْمَعِيبِ
u'شِرَاءٌ مَعِيبٌ':Added, #3: 3	شِرَاءُ مَعِيبٍ
u'شِرَاءٌ مُعَيَّنٌ':Added, #4: 4	شِرَاءُ الْمَعِيبِ
u'شِرَاءٌ مُعَيَّنٌ':Added, #2: 2	شِرَاءٍ مُعَيَّنٍ
u'شِرَاءٌ مَغْصُوب':Added, #2: 2	شِرَاءِ مُعَيَّنٍ
u'شِرَاءٌ مُغَنِّي':Added, #1: 1	شِرَاءِ الْمَغْصُوبِ
u'شِرَاءٌ مُكْرَهٌ':Added, #1: 1	شِرَاءِ الْمُغَنِّيَاتِ
u'شِرَاءٌ مِلْحَفَةٌ':Added, #1: 1	شِرَاءِ الْمُكْرَهِ
u'شِرَاءٌ مَمْلُوكٌ':Added, #2: 2	شِرَاءَ مِلْحَفَةٍ
u'شِرَاءٌ مَنَافِعُ':Added, #1: 1	شِرَاءُ مَمْلُوكَيْنِ
u'شِرَاءٌ مَنَافِعُ':Added, #1: 1	شِرَاءُ الْمَنَافِعِ
u'شِرَاءٌ مُوَرِّث':Added, #1: 1	شِرَاءِ الْمَنَافِعِ
u'شِرَاءٌ مَوْزُونٌ':Added, #1: 1	شِرَاءِ الْمُوَرِّثِ
u'شِرَاءٌ مُوَكِّلٌ':Added, #1: 1	شِرَاءُ الْمَوْزُونِ
u'شِرَاءٌ نَاظِرٌ':Added, #1: 1	شِرَاءِ الْمُوَكِّلِ
u'شِرَاءٌ نُحَاسٌ':Added, #2: 2	شِرَاءُ النَّاظِرِ
u'شِرَاءٌ نَحْلٌ':Added, #1: 1	شِرَاءِ النُّحَاسِ
u'شِرَاءٌ نِساءٌ':Added, #1: 1	شِرَاءُ النَّحْلِ
u'شِرَاءٌ نَسَمٌ':Added, #2: 2	شِرَاءُ النِّسَاءِ
u'شِرَاءٌ نِصْفٌ':Added, #1: 1	شِرَاءِ النَّسَمِ
u'شِرَاءٌ نِصْفٌ':Added, #1: 1	شِرَاءَ النِّصْفِ
u'شِرَاءٌ نِصْفٌ':Added, #1: 1	شِرَاءُ النِّصْفِ
u'شِرَاءٌ نَصِيبٌ':Added, #1: 1	شِرَاءِ النِّصْفِ
u'شِرَاءٌ نَصِيبٌ':Added, #1: 1	شِرَاءَ نَصِيبِ
u'شِرَاءٌ نَعْجَةٌ':Added, #1: 1	شِرَاءَ نَصِيبِهِ
u'شِرَاءٌ نَعْلٌ':Added, #1: 1	شِرَاءَ النَّعْجَةِ
u'شِرَاءٌ نَعْلٌ':Added, #1: 1	شِرَاءِ النَّعْلَيْنِ
u'شِرَاءٌ نَفْسٌ':Added, #1: 1	شِرَاءُ نَعْلٍ
u'شِرَاءٌ نَفْسٌ':Added, #15: 15	شِرَاءِ نَفْسِهِ
u'شِرَاءٌ نَوْعٌ':Added, #1: 1	شِرَاءَ نَفْسِهِ
u'شِرَاءٌ وَاجِبٌ':Added, #1: 1	شِرَاءُ نَوْعٍ
u'شِرَاءٌ واحد':Added, #1: 1	شِرَاءُ وَاجِبِ
u'شِرَاءٌ وَاحِدٌ':Added, #1: 1	شِرَاءُ الْوَاحِدَةِ
u'شِرَاءٌ واحد':Added, #1: 1	شِرَاءُ الْوَاحِدَةِ
u'شِرَاءٌ واحد':Added, #1: 1	شِرَاءٍ وَاحِدٍ
u'شِرَاءٌ وَاحِدٌ':Added, #1: 1	شِرَاءُ وَاحِدٍ
u'شِرَاءٌ وَاحِدٌ':Added, #1: 1	شِرَاءٍ وَاحِدٍ
u'شِرَاءٌ واحد':Added, #1: 1	شِرَاءُ وَاحِدٍ
u'شِرَاءٌ وَاحِدٌ':Added, #1: 1	شِرَاءُ وَاحِدَةٍ
u'شِرَاءٌ وَارِثٌ':Added, #1: 1	شِرَاءُ وَاحِدَةٍ
u'شِرَاءٌ وَارِثٌ':Added, #1: 1	شِرَاءَ وَارِثِ
u'شِرَاءٌ وَارِثٌ':Added, #1: 1	شِرَاءُ وَارِثٍ
u'شِرَاءٌ وَارِثٌ':Added, #1: 1	شِرَاءِ وَارِثِ
u'شِرَاءٌ وُجُوهٌ':Added, #3: 3	شِرَاءُ وَارِثِ
u'شِرَاءٌ وَدِيعٌ':Added, #1: 1	شِرَاءُ وُجُوهِ
u'شِرَاءٌ وَدِيعَةٌ':Added, #1: 1	شِرَاءَ الْوَدِيعَةِ
u'شِرَاءٌ وسط':Added, #1: 1	شِرَاءَ الْوَدِيعَةِ
u'شِرَاءٌ وَسَطٌ':Added, #1: 1	شِرَاءُ الْوَسَطِ
u'شِرَاءٌ وَصِيٌّ':Added, #1: 1	شِرَاءُ الْوَسَطِ
u'شِرَاءٌ وَصِيٌّ':Added, #4: 4	شِرَاءُ الْوَصِيِّ
u'شِرَاءٌ وَكِيلٌ':Added, #5: 5	شِرَاءِ الْوَصِيِّ
u'شِرَاءٌ وَكِيلٌ':Added, #11: 11	شِرَاءِ الْوَكِيلِ
u'شِرَاءٌ وَكِيلٌ':Added, #5: 5	شِرَاءَ الْوَكِيلِ
u'شِرَاءٌ ولد':Added, #6: 6	شِرَاءُ الْوَكِيلِ
u'شِرَاءٌ وَلَدٌ':Added, #1: 1	شِرَاءُ وَلَدِ
u'شِرَاءٌ وَلِيٌّ':Added, #1: 1	شِرَاءُ وَلَدِ
u'شِرَاءٌ وَلِيٌّ':Added, #1: 1	شِرَاءَ الْوَلِيِّ
u'شِرَاءٌ وَلِيٌّ':Added, #1: 1	شِرَاءُ وَلِيٍّ
u'شِرَاءٌ يَسِيرٌ':Added, #1: 1	شِرَاءُ وَلِيِّ
u'شراف أشراف':Added, #1: 1	شِرَاءِ الْيَسِيرِ
u'شراف أَشْرَافٌ':Added, #3: 3	أَشْرَافِ الْأَشْرَافِ
u'شراف أهْلٌ':Added, #3: 3	أَشْرَافِ الْأَشْرَافِ
u'شراف عَبْدٌ':Added, #1: 1	أَشْرَافِ أَهْلِ
u'شراف عَرَبٌ':Added, #1: 1	أَشْرَافُ عَبْدِ
u'شراف عَرَبٌ':Added, #1: 1	أَشْرَافُ الْعَرَبِ
u'شراف قُرَيْشٌ':Added, #3: 3	أَشْرَافِ الْعَرَبِ
u'شراف قُرَيْشٌ':Added, #1: 1	أَشْرَافُ قُرَيْشٍ
u'شراف قُرَيْشٌ':Added, #3: 3	أَشْرَافَ قُرَيْشٍ
u'شراف قَوْمٌ':Added, #6: 6	أَشْرَافِ قُرَيْشٍ
u'شراف قَوْمٌ':Added, #1: 1	أَشْرَافِ الْقَوْمِ
u'شراف نَاسٌ':Added, #2: 2	أَشْرَافُ قَوْمِهِ
u'شراف نَاسٌ':Added, #1: 1	أَشْرَافَ النَّاسِ
u'شراف نَاسٌ':Added, #2: 2	أَشْرَافِ النّاسِ
u'شراف نَاسٌ':Added, #2: 2	أَشْرَافِ النَّاسِ
u'شراف يمن':Added, #3: 3	أَشْرَافُ النَّاسِ
u'شراف يَمَنُ':Added, #2: 2	أَشْرَافِ الْيَمَنِ
u'شرب اِبْنٌ':Added, #2: 2	أَشْرَافِ الْيَمَنِ
u'شُرْبٌ اِبْنٌ':Added, #1: 1	شُرْبِ ابْنِ
u'شَرِبَ أَبْوَالٌ':Predicate, #1: 1	شُرْبِ ابْنِ
u'شرب أَبْوَالٌ':Added, #1: 1	شَرِبَ الْأَبْوَالَ
u'شُرْبٌ أَبْوَالٌ':Added, #2: 2	شُرْبُ أَبْوَالِ
u'شرب أَبْوَالٌ':Added, #2: 2	شُرْبُ أَبْوَالِ
u'شُرْبٌ أَبْوَالٌ':Added, #4: 4	شُرْبِ أَبْوَالِ
u'شرب آدَمِيٌّ':Added, #4: 4	شُرْبِ أَبْوَالِ
u'شُرْبٌ آدَمِيٌّ':Added, #1: 1	شُرْبِ الْآدَمِيِّ
u'شرب أَدْوِيَةٌ':Added, #1: 1	شُرْبِ الْآدَمِيِّ
u'شُرْبٌ أَدْوِيَةٌ':Added, #1: 1	شُرْبُ الْأَدْوِيَةِ
u'شرب أرْضٌ':Added, #1: 1	شُرْبُ الْأَدْوِيَةِ
u'شُرْبٌ أرْضٌ':Added, #1: 1	شُرْبِ أَرْضِهِ
u'شرب أرْضٌ':Added, #1: 1	شُرْبِ أَرْضِهِ
u'شرب أرْضٌ':Added, #1: 1	شُرْبُ الْأَرْضِ
u'شُرْبٌ أرْضٌ':Added, #1: 1	شِرْبُ الْأَرْضِ
u'شِرْبٌ أرْضٌ':Added, #1: 1	شُرْبُ الْأَرْضِ
u'شرب أرْضٌ':Added, #1: 1	شِرْبُ الْأَرْضِ
u'شِرْبٌ أرْضٌ':Added, #2: 2	شِرْبِ أَرْضٍ
u'شرب أرْضٌ':Added, #2: 2	شِرْبِ أَرْضٍ
u'شُرْبٌ أرْضٌ':Added, #2: 2	شُرْبَ أَرْضِهِ
u'شرب أَشْرِبَةٌ':Added, #2: 2	شُرْبَ أَرْضِهِ
u'شُرْبٌ أَشْرِبَةٌ':Added, #1: 1	شُرْبِ الْأَشْرِبَةِ
u'شرب أَشْيَاءٌ':Added, #1: 1	شُرْبِ الْأَشْرِبَةِ
u'شُرْبٌ أَشْيَاءٌ':Added, #1: 1	شُرْبُ الْأَشْيَاءِ
u'شرب أصل':Added, #1: 1	شُرْبُ الْأَشْيَاءِ
u'شرب أصل':Added, #1: 1	شُرْبِ الْأَصْلِ
u'شرب أًصْلٌ':Added, #1: 1	شِرْبِ الْأَصْلِ
u'شرب أًصْلٌ':Added, #1: 1	شُرْبِ الْأَصْلِ
u'شُرْبٌ أصل':Added, #1: 1	شِرْبِ الْأَصْلِ
u'شِرْبٌ أصل':Added, #1: 1	شُرْبِ الْأَصْلِ
u'شُرْبٌ أًصْلٌ':Added, #1: 1	شِرْبِ الْأَصْلِ
u'شِرْبٌ أًصْلٌ':Added, #1: 1	شُرْبِ الْأَصْلِ
u'شرب أفيُونٌ':Added, #1: 1	شِرْبِ الْأَصْلِ
u'شُرْبٌ أفيُونٌ':Added, #1: 1	شُرْبِ الْأَفْيُونِ
u'شرب أَلْبَانٌ':Added, #1: 1	شُرْبِ الْأَفْيُونِ
u'شُرْبٌ أَلْبَانٌ':Added, #1: 1	شُرْبَ أَلْبَانِ
u'شرب أَلْبَانٌ':Added, #1: 1	شُرْبَ أَلْبَانِ
u'شُرْبٌ أَلْبَانٌ':Added, #4: 4	شُرْبِ أَلْبَانِ
u'شرب إِنْسانٌ':Added, #4: 4	شُرْبِ أَلْبَانِ
u'شِرْبٌ إِنْسانٌ':Added, #3: 3	شِرْبَ إنْسَانٍ
u'شرب أهْلٌ':Added, #3: 3	شِرْبَ إنْسَانٍ
u'شِرْبٌ أهْلٌ':Added, #1: 1	شِرْبُ أَهْلِ
u'شَرِبَ بَعْضٌ':Predicate, #1: 1	شِرْبُ أَهْلِ
u'شرب بَعْضٌ':Added, #1: 1	شَرِبَ بَعْضَ
u'شُرْبٌ بَعْضٌ':Added, #1: 1	شُرْبُ الْبَعْضِ
u'شرب بَعْضٌ':Added, #1: 1	شُرْبُ الْبَعْضِ
u'شرب بَعْضٌ':Added, #1: 1	شُرْبَ بَعْضِ
u'شُرْبٌ بَعْضٌ':Added, #1: 1	شُرْبِ بَعْضِ
u'شُرْبٌ بَعْضٌ':Added, #1: 1	شُرْبَ بَعْضِ
u'شرب بَعْضٌ':Added, #1: 1	شُرْبِ بَعْضِ
u'شُرْبٌ بَعْضٌ':Added, #1: 1	شُرْبِ بَعْضِهِ
u'شَرِبَ بَنْجٌ':Predicate, #1: 1	شُرْبِ بَعْضِهِ
u'شرب بَنْجٌ':Added, #3: 3	شَرِبَ الْبَنْجَ
u'شُرْبٌ بَنْجٌ':Added, #2: 2	شُرْبِ الْبَنْجِ
u'شَرِبَ بَوْلٌ':Predicate, #2: 2	شُرْبِ الْبَنْجِ
u'شرب بَوْلٌ':Added, #1: 1	شَرِبَ الْبَوْلَ
u'شُرْبٌ بَوْلٌ':Added, #1: 1	شُرْبُ الْبَوْلِ
u'شرب بَوْلٌ':Added, #1: 1	شُرْبُ الْبَوْلِ
u'شُرْبٌ بَوْلٌ':Added, #2: 2	شُرْبُ بَوْلِ
u'شربة دَواءٌ':Added, #2: 2	شُرْبُ بَوْلِ
u'شَرْبَةٌ دَواءٌ':Added, #1: 1	شَرْبَةَ دَوَاءٍ
u'شربة سَوِيق':Added, #1: 1	شَرْبَةَ دَوَاءٍ
u'شَرْبَةٌ سَوِيق':Added, #1: 1	شَرْبَةِ سَوِيقٍ
u'شربة عَسَلٌ':Added, #1: 1	شَرْبَةِ سَوِيقٍ
u'شَرْبَةٌ عَسَلٌ':Added, #1: 1	شَرْبَةٍ عَسَلٍ
u'شربة عَسَلٌ':Added, #1: 1	شَرْبَةٍ عَسَلٍ
u'شربة عَسَلٌ':Added, #2: 2	شَرْبَةَ عَسَلٍ
u'شَرْبَةٌ عَسَلٌ':Added, #2: 2	شَرْبَةُ عَسَلٍ
u'شَرْبَةٌ عَسَلٌ':Added, #2: 2	شَرْبَةَ عَسَلٍ
u'شربة عَسَلٌ':Added, #2: 2	شَرْبَةُ عَسَلٍ
u'شَرْبَةٌ عَسَلٌ':Added, #6: 6	شَرْبَةِ عَسَلٍ
u'شربة لَبَنٌ':Added, #6: 6	شَرْبَةِ عَسَلٍ
u'شَرْبَةٌ لَبَنٌ':Added, #1: 1	شَرْبَةُ لَبَنٍ
u'شربة مَاءٌ':Added, #1: 1	شَرْبَةُ لَبَنٍ
u'شربة مَاءٌ':Added, #3: 3	شَرْبَةَ مَاءٍ
u'شَرْبَةٌ مَاءٌ':Added, #3: 3	شَرْبَةِ مَاءٍ
u'شَرْبَةٌ مَاءٌ':Added, #3: 3	شَرْبَةَ مَاءٍ
u'شَرِبَ تِسْعَةٌ':Predicate, #3: 3	شَرْبَةِ مَاءٍ
u'شرب جَلّاب':Added, #1: 1	شَرِبَ تِسْعَةَ
u'شُرْبٌ جَلّاب':Added, #1: 1	شُرْبِ الْجَلَّابِ
u'شرب جَمِيع':Added, #1: 1	شُرْبِ الْجَلَّابِ
u'شُرْبٌ جَمِيع':Added, #1: 1	شُرْبُ الْجَمِيعِ
u'شرب حَشِيشٌ':Added, #1: 1	شُرْبُ الْجَمِيعِ
u'شُرْبٌ حَشِيشٌ':Added, #1: 1	شُرْبَ الْحَشِيشِ
u'شَرِبَ حلاب':Predicate, #1: 1	شُرْبَ الْحَشِيشِ
u'شرب حَمِيمٌ':Added, #2: 2	شَرِبَ حِلَابَ
u'شرب حَمِيمٌ':Added, #1: 1	شُرْبَ الْحَمِيمِ
u'شُرْبٌ حَمِيمٌ':Added, #1: 1	شُرْبِ الْحَمِيمِ
u'شُرْبٌ حَمِيمٌ':Added, #1: 1	شُرْبَ الْحَمِيمِ
u'شرب حَيَوَانٌ':Added, #1: 1	شُرْبِ الْحَمِيمِ
u'شرب حَيَوَانٌ':Added, #1: 1	شُرْبَ الْحَيَوَانِ
u'شُرْبٌ حَيَوَانٌ':Added, #1: 1	شُرْبُ الْحَيَوَانِ
u'شُرْبٌ حَيَوَانٌ':Added, #1: 1	شُرْبَ الْحَيَوَانِ
u'شَرِبَ خَمْرٌ':Predicate, #1: 1	شُرْبُ الْحَيَوَانِ
u'شرب خَمْرٌ':Added, #109: 109	شَرِبَ الْخَمْرَ
u'شُرْبٌ خَمْرٌ':Added, #1: 1	شُرْبَ خَمْرٍ
u'شرب خَمْرٌ':Added, #1: 1	شُرْبَ خَمْرٍ
u'شُرْبٌ خَمْرٌ':Added, #21: 21	شُرْبِ خَمْرٍ
u'شرب خَمْرٌ':Added, #21: 21	شُرْبِ خَمْرٍ
u'شُرْبٌ خَمْرٌ':Added, #22: 22	شُرْبُ الْخَمْرِ
u'شرب خَمْرٌ':Added, #22: 22	شُرْبُ الْخَمْرِ
u'شُرْبٌ خَمْرٌ':Added, #30: 30	شُرْبَ الْخَمْرِ
u'شرب خَمْرٌ':Added, #30: 30	شُرْبَ الْخَمْرِ
u'شُرْبٌ خَمْرٌ':Added, #88: 88	شُرْبِ الْخَمْرِ
u'شرب دُخَانٌ':Added, #88: 88	شُرْبِ الْخَمْرِ
u'شُرْبٌ دُخَانٌ':Added, #1: 1	شُرْبِ الدُّخَانِ
u'شَرِبَ دُرْدِيٌّ':Predicate, #1: 1	شُرْبِ الدُّخَانِ
u'شرب دُرْدِيٌّ':Added, #1: 1	شَرِبَ دُرْدِيَّ
u'شُرْبٌ دُرْدِيٌّ':Added, #1: 1	شُرْبِ الدُّرْدِيِّ
u'شرب دُرْدِيٌّ':Added, #1: 1	شُرْبِ الدُّرْدِيِّ
u'شُرْبٌ دُرْدِيٌّ':Added, #4: 4	شُرْبُ دُرْدِيِّ
u'شَرِبَ دَمٌ':Predicate, #4: 4	شُرْبُ دُرْدِيِّ
u'شَرِبَ دَمٌ':Predicate, #1: 1	شَرِبَ الدَّمَ
u'شرب دَمٌ':Added, #4: 4	شَرِبَ دَمَ
u'شُرْبٌ دَمٌ':Added, #1: 1	شُرْبُ الدَّمِ
u'شرب دَمٌ':Added, #1: 1	شُرْبُ الدَّمِ
u'شُرْبٌ دَمٌ':Added, #1: 1	شُرْبِ دَمِهِ
u'شرب دَمٌ':Added, #1: 1	شُرْبِ دَمِهِ
u'شُرْبٌ دَمٌ':Added, #3: 3	شُرْبِ الدَّمِ
u'شرب دَواءٌ':Added, #3: 3	شُرْبِ الدَّمِ
u'شُرْبٌ دَواءٌ':Added, #1: 1	شُرْبُ الدَّوَاءِ
u'شرب دَواءٌ':Added, #1: 1	شُرْبُ الدَّوَاءِ
u'شُرْبٌ دَواءٌ':Added, #1: 1	شُرْبُ دَوَاءِ
u'شرب دَواءٌ':Added, #1: 1	شُرْبُ دَوَاءِ
u'شُرْبٌ دَواءٌ':Added, #3: 3	شُرْبِ الدَّوَاءِ
u'شرب دَواءٌ':Added, #3: 3	شُرْبِ الدَّوَاءِ
u'شرب دَواءٌ':Added, #5: 5	شُرْبُ دَوَاءٍ
u'شُرْبٌ دَواءٌ':Added, #5: 5	شُرْبِ دَوَاءٍ
u'شُرْبٌ دَواءٌ':Added, #5: 5	شُرْبُ دَوَاءٍ
u'شَرِبَ رَجُلٌ':Subject, #5: 5	شُرْبِ دَوَاءٍ
u'شرب رَجُلٌ':Added, #3: 3	شَرِبَ رَجُلٌ
u'شِرْبٌ رَجُلٌ':Added, #2: 2	شِرْبَ رَجُلٍ
u'شرب رَحِيق':Added, #2: 2	شِرْبَ رَجُلٍ
u'شُرْبٌ رَحِيق':Added, #1: 1	شُرْبِ الرَّحِيقِ
u'شَرِبَ رَسُولٌ':Subject, #1: 1	شُرْبِ الرَّحِيقِ
u'شرب رَضيعٌ':Added, #1: 1	شَرِبَ رَسُولُ
u'شُرْبٌ رَضيعٌ':Added, #1: 1	شُرْبُ الرَّضِيعِ
u'شَرِبَ رُطَبٌ':Subject, #1: 1	شُرْبُ الرَّضِيعِ
u'شَرِبَ سُحُبٌ':Subject, #1: 1	شَرِبَ الرُّطَبُ
u'شَرِبَ سكر':Predicate, #1: 1	شَرِبَ السُّحُبُ
u'شرب شَرَابٌ':Added, #7: 7	شَرِبَ سَكِرَ
u'شُرْبٌ شَرَابٌ':Added, #1: 1	شُرْبِ الشَّرَابِ
u'شرب شَرَابٌ':Added, #1: 1	شُرْبِ الشَّرَابِ
u'شُرْبٌ شَرَابٌ':Added, #1: 1	شُرْبُ شَرَابٍ
u'شَرِبَ شربة':Predicate, #1: 1	شُرْبُ شَرَابٍ
u'شَرِبَ شَرْبَةٌ':Predicate, #1: 1	شَرِبَ شَرْبَةَ
u'شَرِبَ شِفَاءٌ':Predicate, #1: 1	شَرِبَ شَرْبَةَ
u'شرب شَيْءٌ':Added, #2: 2	شَرِبَ الشّفَاءَ
u'شُرْبٌ شَيْءٌ':Added, #2: 2	شُرْبِ شَيْءٍ
u'شرب صَاحِبٌ':Added, #2: 2	شُرْبِ شَيْءٍ
u'شِرْبٌ صَاحِبٌ':Added, #1: 1	شِرْبَ صَاحِبِهِ
u'شَرِبَ صَبِيٌّ':Subject, #1: 1	شِرْبَ صَاحِبِهِ
u'شَرِبَ صَبِيٌّ':Subject, #1: 1	شَرِبَ الصَّبِيُّ
u'شَرِبَ صِبْيَانٌ':Subject, #1: 1	شَرِبَ صَبِيٌّ
u'شَرِبَ صَغِيرٌ':Subject, #1: 1	شَرِبَ صِبْيَانٌ
u'شرب ضَيْعَةٌ':Added, #1: 1	شَرِبَ الصَّغِيرُ
u'شُرْبٌ ضَيْعَةٌ':Added, #1: 1	شُرْبُ الضَّيْعَةِ
u'شرب ضَيْعَةٌ':Added, #1: 1	شُرْبُ الضَّيْعَةِ
u'شِرْبٌ ضَيْعَةٌ':Added, #2: 2	شِرْبُ الضَّيْعَةِ
u'شرب طَاهِرٌ':Added, #2: 2	شِرْبُ الضَّيْعَةِ
u'شُرْبٌ طَاهِرٌ':Added, #1: 1	شُرْبُ الطَّاهِرِ
u'شرب طِفْلٌ':Added, #1: 1	شُرْبُ الطَّاهِرِ
u'شُرْبٌ طِفْلٌ':Added, #1: 1	شُرْبِ طِفْلٍ
u'شَرِبَ طِلاَءٌ':Predicate, #1: 1	شُرْبِ طِفْلٍ
u'شَرِبَ عَادٌ':Predicate, #1: 1	شَرِبَ الطِّلاَءَ
u'شَرِبَ عَبْدٌ':Subject, #1: 1	شَرِبَ عَادَ
u'شَرِبَ عتق':Predicate, #1: 1	شَرِبَ عَبْدُ
u'شرب عَسَلٌ':Added, #1: 1	شَرِبَ عَتَقَ
u'شُرْبٌ عَسَلٌ':Added, #1: 1	شُرْبَ الْعَسَلِ
u'شرب عَسَلٌ':Added, #1: 1	شُرْبَ الْعَسَلِ
u'شُرْبٌ عَسَلٌ':Added, #5: 5	شُرْبِ الْعَسَلِ
u'شرب عَصِيرٌ':Added, #5: 5	شُرْبِ الْعَسَلِ
u'شُرْبٌ عَصِيرٌ':Added, #1: 1	شُرْبُ الْعَصِيرِ
u'شَرِبَ عُمَرٌ':Subject, #1: 1	شُرْبُ الْعَصِيرِ
u'شرب عين':Added, #1: 1	شَرِبَ عُمَرُ
u'شرب عَيْنٌ':Added, #1: 1	شِرْبُ الْعَيْنِ
u'شرب عَيْن':Added, #1: 1	شِرْبُ الْعَيْنِ
u'شِرْبٌ عين':Added, #1: 1	شِرْبُ الْعَيْنِ
u'شِرْبٌ عَيْنٌ':Added, #1: 1	شِرْبُ الْعَيْنِ
u'شِرْبٌ عَيْن':Added, #1: 1	شِرْبُ الْعَيْنِ
u'شَرِبَ غَالِبٌ':Subject, #1: 1	شِرْبُ الْعَيْنِ
u'شَرِبَ غير':Predicate, #1: 1	شَرِبَ غَالِبُ
u'شَرِبَ غَيْرٌ':Predicate, #1: 1	شَرِبَ غَيْرَ
u'شرب غير':Added, #1: 1	شَرِبَ غَيْرَ
u'شرب غَيْرٌ':Added, #2: 2	شُرْبَ غَيْرِ
u'شُرْبٌ غير':Added, #2: 2	شُرْبَ غَيْرِ
u'شُرْبٌ غَيْرٌ':Added, #2: 2	شُرْبَ غَيْرِ
u'شرب غير':Added, #2: 2	شُرْبَ غَيْرِ
u'شرب غَيْرٌ':Added, #3: 3	شِرْبِ غَيْرِهِ
u'شِرْبٌ غير':Added, #3: 3	شِرْبِ غَيْرِهِ
u'شِرْبٌ غَيْرٌ':Added, #3: 3	شِرْبِ غَيْرِهِ
u'شرب فَاضِلٌ':Added, #3: 3	شِرْبِ غَيْرِهِ
u'شُرْبٌ فَاضِلٌ':Added, #1: 1	شُرْبُ فَاضِلِ
u'شَرِبَ فَضْلٌ':Predicate, #1: 1	شُرْبُ فَاضِلِ
u'شَرِبَ فُلاَنٌ':Subject, #1: 1	شَرِبَ فَضْلَ
u'شَرِبَ قَالٌ':Predicate, #1: 1	شَرِبَ فُلَانٌ
u'شَرِبَ قَدْرٌ':Predicate, #2: 2	شَرِبَ قَالَ
u'شرب قِسْطٌ':Added, #1: 1	شَرِبَ قَدْرَ
u'شُرْبٌ قِسْطٌ':Added, #1: 1	شُرْبَ الْقِسْطِ
u'شرب قَطْرَةٌ':Added, #1: 1	شُرْبَ الْقِسْطِ
u'شرب قَطْرَةٌ':Added, #1: 1	شُرْبَ الْقَطْرَةِ
u'شُرْبٌ قَطْرَةٌ':Added, #1: 1	شُرْبِ الْقَطْرَةِ
u'شُرْبٌ قَطْرَةٌ':Added, #1: 1	شُرْبَ الْقَطْرَةِ
u'شرب قَطْرَةٌ':Added, #1: 1	شُرْبِ الْقَطْرَةِ
u'شُرْبٌ قَطْرَةٌ':Added, #2: 2	شُرْبُ الْقَطْرَةِ
u'شرب قَطْرَةٌ':Added, #2: 2	شُرْبُ الْقَطْرَةِ
u'شرب قَطْرَةٌ':Added, #2: 2	شُرْبَ قَطْرَةٍ
u'شُرْبٌ قَطْرَةٌ':Added, #2: 2	شُرْبُ قَطْرَةٍ
u'شُرْبٌ قَطْرَةٌ':Added, #2: 2	شُرْبَ قَطْرَةٍ
u'شرب قَلِيلٌ':Added, #2: 2	شُرْبُ قَطْرَةٍ
u'شُرْبٌ قَلِيلٌ':Added, #1: 1	شُرْبِ الْقَلِيلِ
u'شرب قَلِيلٌ':Added, #1: 1	شُرْبِ الْقَلِيلِ
u'شُرْبٌ قَلِيلٌ':Added, #1: 1	شُرْبُ قَلِيلِهِ
u'شرب قَلِيلٌ':Added, #1: 1	شُرْبُ قَلِيلِهِ
u'شُرْبٌ قَلِيلٌ':Added, #4: 4	شُرْبُ الْقَلِيلِ
u'شَرِبَ قَوْمٌ':Subject, #4: 4	شُرْبُ الْقَلِيلِ
u'شرب كَأْسٌ':Added, #1: 1	شَرِبَ قَوْمٌ
u'شُرْبٌ كَأْسٌ':Added, #2: 2	شُرْبِ الْكَأْسِ
u'شرب كَثِيرٌ':Added, #2: 2	شُرْبِ الْكَأْسِ
u'شُرْبٌ كَثِيرٌ':Added, #2: 2	شُرْبِ الْكَثِيرِ
u'شرب كلاب':Added, #2: 2	شُرْبِ الْكَثِيرِ
u'شُرْبٌ كلاب':Added, #1: 1	شُرْبِ الْكِلَابِ
u'شرب كِلاَبٌ':Added, #1: 1	شُرْبِ الْكِلَابِ
u'شُرْبٌ كِلاَبٌ':Added, #1: 1	شُرْبِ الْكِلَابِ
u'شَرِبَ كَلْبٌ':Subject, #1: 1	شُرْبِ الْكِلَابِ
u'شرب كَلْبٌ':Added, #7: 7	شَرِبَ الْكَلْبُ
u'شرب كَلْبٌ':Added, #1: 1	شُرْبُ الْكَلْبِ
u'شُرْبٌ كَلْبٌ':Added, #1: 1	شُرْبِ الْكَلْبِ
u'شُرْبٌ كَلْبٌ':Added, #1: 1	شُرْبُ الْكَلْبِ
u'شَرِبَ لبن':Predicate, #1: 1	شُرْبِ الْكَلْبِ
u'شَرِبَ لَبَنٌ':Predicate, #1: 1	شَرِبَ اللَّبَنَ
u'شَرِبَ لبن':Predicate, #1: 1	شَرِبَ اللَّبَنَ
u'شَرِبَ لَبَنٌ':Predicate, #1: 1	شَرِبَ لَبَنَ
u'شرب لبن':Added, #1: 1	شَرِبَ لَبَنَ
u'شرب لبن':Added, #1: 1	شُرْبَ لَبَنِ
u'شُرْبٌ لبن':Added, #1: 1	شُرْبِ لَبَنِ
u'شُرْبٌ لبن':Added, #1: 1	شُرْبَ لَبَنِ
u'شرب لَبَنٌ':Added, #1: 1	شُرْبِ لَبَنِ
u'شرب لَبَنٌ':Added, #1: 1	شُرْبَ لَبَنِ
u'شُرْبٌ لَبَنٌ':Added, #1: 1	شُرْبِ لَبَنِ
u'شُرْبٌ لَبَنٌ':Added, #1: 1	شُرْبَ لَبَنِ
u'شرب لبن':Added, #1: 1	شُرْبِ لَبَنِ
u'شرب لبن':Added, #3: 3	شُرْبَ اللَّبَنِ
u'شُرْبٌ لبن':Added, #3: 3	شُرْبُ اللَّبَنِ
u'شُرْبٌ لبن':Added, #3: 3	شُرْبَ اللَّبَنِ
u'شرب لَبَنٌ':Added, #3: 3	شُرْبُ اللَّبَنِ
u'شرب لَبَنٌ':Added, #3: 3	شُرْبَ اللَّبَنِ
u'شُرْبٌ لَبَنٌ':Added, #3: 3	شُرْبُ اللَّبَنِ
u'شُرْبٌ لَبَنٌ':Added, #3: 3	شُرْبَ اللَّبَنِ
u'شرب لبن':Added, #3: 3	شُرْبُ اللَّبَنِ
u'شُرْبٌ لبن':Added, #5: 5	شُرْبِ اللَّبَنِ
u'شرب لَبَنٌ':Added, #5: 5	شُرْبِ اللَّبَنِ
u'شُرْبٌ لَبَنٌ':Added, #5: 5	شُرْبِ اللَّبَنِ
u'شَرِبَ لَوْنٌ':Predicate, #5: 5	شُرْبِ اللَّبَنِ
u'شَرِبَ مَاءٌ':Predicate, #1: 1	شَرِبَ لَوْنَ
u'شَرِبَ مَاءٌ':Predicate, #14: 14	شَرِبَ الْمَاءَ
u'شَرِبَ مَاءٌ':Predicate, #1: 1	أَشْرَبَ الْمَاءَ
u'شرب مَاءٌ':Added, #3: 3	شَرِبَ مَاءَ
u'شُرْبٌ مَاءٌ':Added, #19: 19	شُرْبِ الْمَاءِ
u'شرب مَاءٌ':Added, #19: 19	شُرْبِ الْمَاءِ
u'شرب مَاءٌ':Added, #1: 1	شُرْبَ مَاءِ
u'شرب مَاءٌ':Added, #1: 1	شُرْبُ مَاءٍ
u'شرب مَاءٌ':Added, #1: 1	شُرْبُ مَاءِ
u'شُرْبٌ مَاءٌ':Added, #1: 1	شُرْبِ مَاءٍ
u'شُرْبٌ مَاءٌ':Added, #1: 1	شُرْبَ مَاءِ
u'شُرْبٌ مَاءٌ':Added, #1: 1	شُرْبُ مَاءٍ
u'شُرْبٌ مَاءٌ':Added, #1: 1	شُرْبُ مَاءِ
u'شرب مَاءٌ':Added, #1: 1	شُرْبِ مَاءٍ
u'شُرْبٌ مَاءٌ':Added, #3: 3	شُرْبِ مَاءِ
u'شرب مَاءٌ':Added, #3: 3	شُرْبِ مَاءِ
u'شُرْبٌ مَاءٌ':Added, #5: 5	شُرْبَ الْمَاءِ
u'شرب مَاءٌ':Added, #5: 5	شُرْبَ الْمَاءِ
u'شُرْبٌ مَاءٌ':Added, #8: 8	شُرْبُ الْمَاءِ
u'شرب مَاشِي':Added, #8: 8	شُرْبُ الْمَاءِ
u'شُرْبٌ مَاشِي':Added, #1: 1	شُرْبِ الْمَاشِيَةِ
u'شرب مَاشِيَةٌ':Added, #1: 1	شُرْبِ الْمَاشِيَةِ
u'شُرْبٌ مَاشِيَةٌ':Added, #1: 1	شُرْبِ الْمَاشِيَةِ
u'شَرِبَ مُثَلَّثٌ':Predicate, #1: 1	شُرْبِ الْمَاشِيَةِ
u'شرب مُثَلَّثٌ':Added, #1: 1	شَرِبَ الْمُثَلَّثَ
u'شُرْبٌ مُثَلَّثٌ':Added, #3: 3	شُرْبُ الْمُثَلَّثِ
u'شرب مُحَرَّمٌ':Added, #3: 3	شُرْبُ الْمُثَلَّثِ
u'شُرْبٌ مُحَرَّمٌ':Added, #2: 2	شُرْبِ الْمُحَرَّمِ
u'شرب مَدِيدٌ':Added, #2: 2	شُرْبِ الْمُحَرَّمِ
u'شُرْبٌ مَدِيدٌ':Added, #2: 2	شُرْبُ الْمَدِيدِ
u'شَرِبَ مَرَقٌ':Predicate, #2: 2	شُرْبُ الْمَدِيدِ
u'شرب مُسْتَعْمَلٌ':Added, #1: 1	شَرِبَ الْمَرَقَ
u'شُرْبٌ مُسْتَعْمَلٌ':Added, #1: 1	شُرْبِ الْمُسْتَعْمَلِ
u'شَرِبَ مُسْكِرٌ':Predicate, #1: 1	شُرْبِ الْمُسْتَعْمَلِ
u'شرب مُسْكِرٌ':Added, #7: 7	شَرِبَ الْمُسْكِرَ
u'شُرْبٌ مُسْكِرٌ':Added, #1: 1	شُرْبِ مُسْكِرٍ
u'شرب مُسْكِرٌ':Added, #1: 1	شُرْبِ مُسْكِرٍ
u'شرب مُسْكِرٌ':Added, #3: 3	شُرْبَ الْمُسْكِرِ
u'شُرْبٌ مُسْكِرٌ':Added, #3: 3	شُرْبُ الْمُسْكِرِ
u'شُرْبٌ مُسْكِرٌ':Added, #3: 3	شُرْبَ الْمُسْكِرِ
u'شرب مُسْكِرٌ':Added, #3: 3	شُرْبُ الْمُسْكِرِ
u'شُرْبٌ مُسْكِرٌ':Added, #5: 5	شُرْبِ الْمُسْكِرِ
u'شرب مُسْلِمٌ':Added, #5: 5	شُرْبِ الْمُسْكِرِ
u'شُرْبٌ مُسْلِمٌ':Added, #2: 2	شُرْبُ مُسْلِمٍ
u'شرب مَشْرُوبٌ':Added, #2: 2	شُرْبُ مُسْلِمٍ
u'شُرْبٌ مَشْرُوبٌ':Added, #1: 1	شُرْبِ مَشْرُوبٍ
u'شرب مُصَنَّفٌ':Added, #1: 1	شُرْبِ مَشْرُوبٍ
u'شُرْبٌ مُصَنَّفٌ':Added, #1: 1	شُرْبُ الْمُصَنَّفِ
u'شِرْبٌ مَعْلُومٌ':Added, #1: 1	شُرْبُ الْمُصَنَّفِ
u'شرب مُكْرَهٌ':Added, #1: 1	شِرْبٍ مَعْلُومٍ
u'شُرْبٌ مُكْرَهٌ':Added, #1: 1	شُرْبُ الْمُكْرَهِ
u'شرب نَاقَةٌ':Added, #1: 1	شُرْبُ الْمُكْرَهِ
u'شرب نَاقَة':Added, #1: 1	شُرْبِ النَّاقَةِ
u'شُرْبٌ نَاقَةٌ':Added, #1: 1	شُرْبِ النَّاقَةِ
u'شُرْبٌ نَاقَة':Added, #1: 1	شُرْبِ النَّاقَةِ
u'شَرِبَ نَبِيٌّ':Subject, #1: 1	شُرْبِ النَّاقَةِ
u'شَرِبَ نَبِيذٌ':Predicate, #1: 1	شَرِبَ النَّبِيُّ
u'شرب نَبِيذٌ':Added, #8: 8	شَرِبَ النَّبِيذَ
u'شُرْبٌ نَبِيذٌ':Added, #3: 3	شُرْبِ النَّبِيذِ
u'شرب نَبِيذٌ':Added, #3: 3	شُرْبِ النَّبِيذِ
u'شُرْبٌ نَبِيذٌ':Added, #5: 5	شُرْبُ النَّبِيذِ
u'شرب نَجِسٌ':Added, #5: 5	شُرْبُ النَّبِيذِ
u'شُرْبٌ نَجِسٌ':Added, #1: 1	شُرْبَ النَّجِسِ
u'شرب نَخْلٌ':Added, #1: 1	شُرْبَ النَّجِسِ
u'شُرْبٌ نَخْلٌ':Added, #2: 2	شُرْبِ النَّخْلِ
u'شَرِبَ نَفَرٌ':Subject, #2: 2	شُرْبِ النَّخْلِ
u'شرب نَهْرٌ':Added, #1: 1	شَرِبَ نَفَرٌ
u'شِرْبٌ نَهْرٌ':Added, #1: 1	شِرْبِ نَهْرٍ
u'شرب هيم':Added, #1: 1	شِرْبِ نَهْرٍ
u'شُرْبٌ هيم':Added, #1: 1	شُرْبَ الْهِيمِ
u'شرب واحد':Added, #1: 1	شُرْبَ الْهِيمِ
u'شُرْبٌ واحد':Added, #1: 1	شُرْبِ الْوَاحِدِ
u'شرب وَاحِدٌ':Added, #1: 1	شُرْبِ الْوَاحِدِ
u'شُرْبٌ وَاحِدٌ':Added, #1: 1	شُرْبِ الْوَاحِدِ
u'شرب ولد':Added, #1: 1	شُرْبِ الْوَاحِدِ
u'شُرْبٌ ولد':Added, #1: 1	شُرْبَ الْوَلَدِ
u'شرب وَلَدٌ':Added, #1: 1	شُرْبَ الْوَلَدِ
u'شُرْبٌ وَلَدٌ':Added, #1: 1	شُرْبَ الْوَلَدِ
u'شَرِبَ يَسِيرٌ':Predicate, #1: 1	شُرْبَ الْوَلَدِ
u'شَرَّ بَيْنٌ':Predicate, #1: 1	شَرِبَ الْيَسِيرَ
u'شرب يَوْمٌ':Added, #1: 1	شَرَّكَ بَيْنَ
u'شِرْبٌ يَوْمٌ':Added, #1: 1	شِرْبَ يَوْمٍ
u'شرب يَوْمٌ':Added, #1: 1	شِرْبَ يَوْمٍ
u'شِرْبٌ يَوْمٌ':Added, #1: 1	شِرْبَ يَوْمَيْنِ
u'شرب يَوْمٌ':Added, #1: 1	شِرْبَ يَوْمَيْنِ
u'شِرْبٌ يَوْمٌ':Added, #2: 2	شِرْبِ يَوْمٍ
u'شرب يَوْمٌ':Added, #2: 2	شِرْبِ يَوْمٍ
u'شِرْبٌ يَوْمٌ':Added, #7: 7	شِرْبُ يَوْمٍ
u'شَرَحَ اِبْنٌ':Subject, #7: 7	شِرْبُ يَوْمٍ
u'شَرْحٌ اِبْنٌ':Added, #2: 2	شَرَحَ ابْنُ
u'شَرْحٌ اِبْنٌ':Added, #12: 12	شَرْحُ ابْنِ
u'شَرْحٌ أبْيَاتٌ':Added, #29: 29	شَرْحِ ابْنِ
u'شَرْحٌ آثَارٌ':Added, #1: 1	شَرْحِ أَبْيَاتِ
u'شَرْحٌ إجَارَةٌ':Added, #25: 25	شَرْحِ الْآثَارِ
u'شَرْحٌ أَحْكَامٌ':Added, #1: 1	شَرْحِ الْإِجَارَاتِ
u'شَرْحٌ اِخْتِلاَفٌ':Added, #1: 1	شَرْحِ الْأَحْكَامِ
u'شَرْحٌ اِخْتِيَارٌ':Added, #1: 1	شَرْحِ اخْتِلَافِ
u'شَرْحٌ أدَب':Added, #1: 1	شَرْحِ اخْتِيَارِ
u'شَرْحٌ أدَب':Added, #2: 2	شَرْحُ أَدَبِ
u'شَرَحَ إِرْشَادٌ':Predicate, #99: 99	شَرْحِ أَدَبِ
u'شَرْحٌ إِرْشَادٌ':Added, #2: 2	شَرَحَ الْإِرْشَادَ
u'شَرْحٌ إِرْشَادٌ':Added, #160: 160	شَرْحِ الْإِرْشَادِ
u'شَرْحٌ إِرْشَادٌ':Added, #1: 1	شَرْحِ إرْشَادِ
u'شَرْحٌ إِرْشَادٌ':Added, #1: 1	شَرْح إرْشَادِهِ
u'شَرْحٌ إِرْشَادٌ':Added, #38: 38	شَرْحِ إرْشَادِهِ
u'شَرْحٌ أُسْتَاذٌ':Added, #4: 4	شَرْح الْإِرْشَادِ
u'شَرْحٌ أَسْماءٌ':Added, #1: 1	شَرْحِ الْأُسْتَاذِ
u'شَرْحٌ أَسْماءٌ':Added, #1: 1	شَرْحِ أَسْمَاءِ
u'شَرْحٌ أشباه':Added, #3: 3	شَرْحِ الْأَسْمَاءِ
u'شَرْحٌ أشْبَاهٌ':Added, #2: 2	شَرْحِ الْأَشْبَاهِ
u'شَرْحٌ أَشْبَاهٌ':Added, #2: 2	شَرْحِ الْأَشْبَاهِ
u'شَرْحٌ اِشْتِراطٌ':Added, #2: 2	شَرْحِ الْأَشْبَاهِ
u'شَرَحَ أُصولٌ':Predicate, #1: 1	شَرْحِ اشْتِرَاطِ
u'شَرْحٌ أُصولٌ':Added, #1: 1	شَرَحَ أُصُولَ
u'شَرْحٌ أُصولٌ':Added, #15: 15	شَرْحِ أُصُولِ
u'شَرْحٌ أَعْمَالٌ':Added, #1: 1	شَرْحِ الْأُصُولِ
u'شَرْحٌ أَقْضِيَةٌ':Added, #1: 1	شَرْحِ الْأَعْمَالِ
u'شَرْحٌ أَلْفَاظٌ':Added, #1: 1	شَرْحِ الْأَقْضِيَةِ
u'شَرْحٌ أَلْفِيَّةٌ':Added, #1: 1	شَرْحَ أَلْفَاظِهِ
u'شَرْحٌ أَلْفِيَّةٌ':Added, #1: 1	شَرْحِ أَلْفِيَّةِ
u'شَرْحٌ أَلْفِيَّةٌ':Added, #1: 1	شَرْحِ أَلْفِيَّتِهِ
u'شَرْحٌ إِلْمَامٌ':Added, #3: 3	شَرْحِ الْأَلْفِيَّةِ
u'شَرْحٌ إمَامٌ':Added, #38: 38	شَرْحِ الْإِلْمَامِ
u'شَرْحٌ إمَامٌ':Added, #1: 1	شَرْحُ الْإِمَامِ
u'شَرْحٌ أمثال':Added, #1: 1	شَرْحِ الْإِمَامِ
u'شَرْحٌ أَمْثَالٌ':Added, #1: 1	شَرْحِ الْأَمْثَالِ
u'شَرْحٌ آيَةٌ':Added, #1: 1	شَرْحِ الْأَمْثَالِ
u'شَرْحٌ آيَةٌ':Added, #1: 1	شَرْحَ الْآيَةِ
u'شَرْحٌ أَيْمَانٌ':Added, #1: 1	شَرْحِ آيَةِ
u'شَرَحَ بَابٌ':Predicate, #1: 1	شَرْحِ أَيْمَانِ
u'شَرْحٌ بُخَارِيٌّ':Added, #1: 1	شَرَحَ بَابَ
u'شَرْحٌ بَدِيعٌ':Added, #62: 62	شَرْحِ الْبُخَارِيِّ
u'شَرْحٌ بُرْهانٌ':Added, #19: 19	شَرْحِ الْبَدِيعِ
u'شَرْحٌ بُرْهَانٌ':Added, #33: 33	شَرْحِ الْبُرْهَانِ
u'شَرْحٌ بَقِيَّةٌ':Added, #33: 33	شَرْحِ الْبُرْهَانِ
u'شَرْحٌ بَهْجَةٌ':Added, #1: 1	شَرْحِ الْبَقِيَّةِ
u'شَرْحٌ بَيْتٌ':Added, #106: 106	شَرْحِ الْبَهْجَةِ
u'شَرْحٌ بَيْتٌ':Added, #1: 1	شَرْحُ بَيْتِ
u'شَرْحٌ بيوع':Added, #1: 1	شَرْحِ بَيْتِ
u'شَرْحٌ بيوع':Added, #1: 1	شَرْحِ الْبُيُوعِ
u'شَرْحٌ تَحْرِيرٌ':Added, #1: 1	شَرْحِ بُيُوعِ
u'شَرْحٌ تَحْصِيلٌ':Added, #9: 9	شَرْحِ التَّحْرِيرِ
u'شَرْحٌ تُحْفَةٌ':Added, #1: 1	شَرْحِ التَّحْصِيلِ
u'شَرْحٌ تُحْفَةٌ':Added, #1: 1	شَرْحِ التُّحْفَةِ
u'شَرْحٌ تَخْلِيصٌ':Added, #2: 2	شَرْحِ تُحْفَةِ
u'شَرْحٌ تَرْتِيبٌ':Added, #1: 1	شَرْحِ التَّخْلِيصِ
u'شَرْحٌ تَسْهِيلٌ':Added, #17: 17	شَرْحِ التَّرْتِيبِ
u'شَرْحٌ تَسْهِيلٌ':Added, #2: 2	شَرْح التَّسْهِيلِ
u'شَرْحٌ تَقْريبٌ':Added, #7: 7	شَرْحِ التَّسْهِيلِ
u'شَرْحٌ تَقْويمٌ':Added, #1: 1	شَرْحِ التَّقْرِيبِ
u'شَرْحٌ تَكْمِلَةٌ':Added, #1: 1	شَرْحِ التَّقْوِيمِ
u'شَرْحٌ تَكْمِلَةٌ':Added, #1: 1	شَرْحِ تَكْمِلَةِ
u'شَرْحٌ تَلْخيصٌ':Added, #3: 3	شَرْحِ التَّكْمِلَةِ
u'شَرْحٌ تَلْخيصٌ':Added, #36: 36	شَرْحِ تَلْخِيصِ
u'شَرْحٌ تَلْقِين':Added, #46: 46	شَرْحِ التَّلْخِيصِ
u'شَرْحٌ تَنْبِيه':Added, #2: 2	شَرْحِ التَّلْقِينِ
u'شَرْحٌ تَنْبِيه':Added, #1: 1	شَرْح التَّنْبِيهِ
u'شَرْحٌ تَنْبِيه':Added, #1: 1	شَرْحُ التَّنْبِيهِ
u'شَرْحٌ تَنْقِيحٌ':Added, #24: 24	شَرْحِ التَّنْبِيهِ
u'شَرْحٌ تَنْقِيحٌ':Added, #3: 3	شَرْحِ تَنْقِيحِ
u'شَرْحٌ تَنْوِيرٌ':Added, #5: 5	شَرْحِ التَّنْقِيحِ
u'شَرْحٌ تَنْوِيرٌ':Added, #10: 10	شَرْحِ التَّنْوِيرِ
u'شَرْحٌ تَنْوِيرٌ':Added, #1: 1	شَرْحُ التَّنْوِيرِ
u'شَرْحٌ تَوْضِيحٌ':Added, #5: 5	شَرْحِ تَنْوِيرِ
u'شَرْحٌ ثُبُوتٌ':Added, #1: 1	شَرْحِ التَّوْضِيحِ
u'شَرْحٌ جَامِعٌ':Added, #3: 3	شَرْحُ ثُبُوتِ
u'شَرْحٌ جَامِعٌ':Added, #322: 322	شَرْحِ الْجَامِعِ
u'شَرْحٌ جَامِعٌ':Added, #3: 3	شَرْحُ الْجَامِعِ
u'شَرْحٌ جَدَلٌ':Added, #4: 4	شَرْح الْجَامِعِ
u'شَرْحٌ جَزَائِرِيٌّ':Added, #1: 1	شَرْحِ جَدَلِهِ
u'شَرْحٌ جَصَّاصٌ':Added, #1: 1	شَرْحِ الْجَزَائِرِيَّةِ
u'شَرْحٌ جَلّاب':Added, #1: 1	شَرْحِ الْجَصَّاصِ
u'شَرْحٌ جَلاَلٌ':Added, #3: 3	شَرْحِ الْجَلَّابِ
u'شَرْحٌ جمع':Added, #2: 2	شَرْحِ الْجَلَالِ
u'شَرْحٌ جَمْعٌ':Added, #6: 6	شَرْحِ جَمْعِ
u'شَرْحٌ جُمَلٌ':Added, #6: 6	شَرْحِ جَمْعِ
u'شَرْحٌ جُمَلٌ':Added, #10: 10	شَرْحِ الْجُمَلِ
u'شَرْحٌ جَوَاهِرُ':Added, #1: 1	شَرْحِ جُمَلِ
u'شَرْحٌ جَوْهَرٌ':Added, #1: 1	شَرْحِ الْجَوَاهِرِ
u'شَرْحٌ جَوْهَرٌ':Added, #1: 1	شَرْحِ جَوْهَرَتِهِ
u'شَرْحٌ حافِظٌ':Added, #2: 2	شَرْحِ الْجَوْهَرَةِ
u'شَرْحٌ حَديثٌ':Added, #1: 1	شَرْحِ الْحَافِظِ
u'شَرْحٌ حَديثٌ':Added, #1: 1	شَرْحُ الْحَدِيثِ
u'شَرْحٌ حَديثٌ':Added, #65: 65	شَرْحِ الْحَدِيثِ
u'شَرْحٌ حَمْدٌ':Added, #6: 6	شَرْحِ حَدِيثِ
u'شَرْحٌ حِيَلٌ':Added, #1: 1	شَرْحُ الْحَمْدِ
u'شَرْحٌ حِيَلٌ':Added, #2: 2	شَرْحِ الْحِيَلِ
u'شَرْحٌ خَبَرٌ':Added, #4: 4	شَرْحِ حِيَلِ
u'شَرْحٌ خَبَر':Added, #1: 1	شَرْحِ الْخَبَرِ
u'شَرْحٌ خِصَالٌ':Added, #1: 1	شَرْحِ الْخَبَرِ
u'شَرْحٌ خُطَبٌ':Added, #1: 1	شَرْحِ الْخِصَالِ
u'شَرْحٌ خطبة':Added, #1: 1	شَرْحِ الْخُطَبِ
u'شَرْحٌ خُطْبَةٌ':Added, #1: 1	شَرْحِ الْخُطْبَةِ
u'شَرْحٌ خطبة':Added, #1: 1	شَرْحِ الْخُطْبَةِ
u'شَرْحٌ خُطْبَةٌ':Added, #8: 8	شَرْحِ خُطْبَةِ
u'شَرْحٌ خَطِيبٌ':Added, #8: 8	شَرْحِ خُطْبَةِ
u'شَرْحٌ خُلاصَة':Added, #1: 1	شَرْحِ الْخَطِيبِ
u'شَرْحٌ دُرٌّ':Added, #1: 1	شَرْحِ الْخُلَاصَةِ
u'شَرْحٌ دُرَرٌ':Added, #1: 1	شَرْحِ الدُّرِّ
u'شَرْحٌ دُرَرٌ':Added, #24: 24	شَرْحِ الدُّرَرِ
u'شَرْحٌ دِيَةٌ':Added, #7: 7	شَرْحِ دُرَرِ
u'شَرْحٌ رِسَالَةٌ':Added, #2: 2	شَرْحِ دِيَاتِ
u'شَرَحَ رَسُولٌ':Subject, #15: 15	شَرْحِ الرِّسَالَةِ
u'شَرْحٌ رَوْضٌ':Added, #1: 1	شَرَحَ رَسُولُ
u'شَرْحٌ رَوْضٌ':Added, #1: 1	شَرْحُ رَوْضِ
u'شَرْحٌ رَوْضٌ':Added, #1: 1	شَرْحِ رَوْضِ
u'شَرْحٌ رَوْضٌ':Added, #2: 2	شَرْح الرَّوْضِ
u'شَرْحٌ رَوْضَةٌ':Added, #57: 57	شَرْحِ الرَّوْضِ
u'شَرْحٌ زادٌ':Added, #1: 1	شَرْحِ الرَّوْضَةِ
u'شَرْحٌ زُبَدٌ':Added, #3: 3	شَرْحِ زَادِ
u'شَرْحٌ زِيادَةٌ':Added, #1: 1	شَرْحِ الزُّبَدِ
u'شَرْحٌ زِيادَةٌ':Added, #2: 2	شَرْحِ زِيَادَاتِ
u'شَرْحٌ سَبَبٌ':Added, #52: 52	شَرْحِ الزِّيَادَاتِ
u'شَرْحٌ سِرَاجٌ':Added, #1: 1	شَرْحِ السَّبَبِ
u'شَرْحٌ سِراج':Added, #2: 2	شَرْحِ السِّرَاجِ
u'شَرْحٌ سُنَّةٌ':Added, #2: 2	شَرْحِ السِّرَاجِيَّةِ
u'شَرْحٌ سُنَّةٌ':Added, #12: 12	شَرْحِ السُّنَّةِ
u'شَرْحٌ سِيَرٌ':Added, #1: 1	شَرْحُ السُّنَّةِ
u'شَرْحٌ سِيَرٌ':Added, #1: 1	شَرْحُ السِّيَرِ
u'شَرْحٌ سيرَةٌ':Added, #30: 30	شَرْحِ السِّيَرِ
u'شَرْحٌ شَارِحٌ':Added, #1: 1	شَرْحِ سِيرَةِ
u'شَرْحٌ شَافِي':Added, #9: 9	شَرْحُ الشَّارِحِ
u'شَرْحٌ شرعة':Added, #3: 3	شَرْحِ الشَّافِيَةِ
u'شَرْحٌ شِرْعَةٌ':Added, #1: 1	شَرْحِ الشِّرْعَةِ
u'شَرْحٌ شُرُوطٌ':Added, #1: 1	شَرْحِ الشِّرْعَةِ
u'شَرْحٌ شِعْرٌ':Added, #1: 1	شَرْحِ شُرُوطِ
u'شَرْحٌ شِعْرٌ':Added, #1: 1	شَرْحِ شِعْرٍ
u'شَرْحٌ شِعْرٌ':Added, #2: 2	شَرْحُ شِعْرِ
u'شَرْحٌ شِفَاءٌ':Added, #5: 5	شَرْحِ شِعْرِ
u'شَرْحٌ شَمَائِلُ':Added, #2: 2	شَرْحِ الشِّفَاءِ
u'شَرْحٌ شمس':Added, #3: 3	شَرْحِ الشَّمَائِلِ
u'شَرْحٌ شَمْسٌ':Added, #1: 1	شَرْحِ شَمْسِ
u'شَرْحٌ شَمْسِيٌّ':Added, #1: 1	شَرْحِ شَمْسِ
u'شَرْحٌ شِهَابٌ':Added, #1: 1	شَرْحِ الشَّمْسِيَّةِ
u'شَرْحٌ شَهِيدٌ':Added, #2: 2	شَرْحِ الشِّهَابِ
u'شَرَحَ شَيْخٌ':Subject, #1: 1	شَرْحِ الشَّهِيدِ
u'شَرْحٌ شَيْخٌ':Added, #1: 1	شَرَحَ شَيْخُ
u'شَرْحٌ شَيْخٌ':Added, #1: 1	شَرْحُ الشَّيْخِ
u'شَرْحٌ شَيْخٌ':Added, #40: 40	شَرْحِ الشَّيْخِ
u'شَرْحٌ صَاحِبٌ':Added, #5: 5	شَرْحِ شَيْخِ
u'شَرْحٌ صَحِيحٌ':Added, #1: 1	شَرْحُ صَاحِبِ
u'شَرْحٌ صَحِيحٌ':Added, #11: 11	شَرْحِ الصَّحِيحِ
u'شَرْحٌ صَحِيحٌ':Added, #12: 12	شَرْحِ الصَّحِيحَيْنِ
u'شَرَحَ صَدْرٌ':Predicate, #2: 2	شَرْحِ صَحِيحِ
u'شَرْحٌ صَدْرٌ':Added, #6: 6	شَرَحَ صَدْرَ
u'شَرْحٌ صَدْرٌ':Added, #1: 1	شَرْحِ صَدْرِ
u'شَرْحٌ صُورَةٌ':Added, #4: 4	شَرْحِ الصَّدْرِ
u'شَرْحٌ صَوْمٌ':Added, #1: 1	شَرْحُ الصُّورَةِ
u'شَرْحٌ ظَهيرٌ':Added, #1: 1	شَرْحِ صَوْمِهِ
u'شَرَحَ عُبَابٌ':Predicate, #1: 1	شَرْحِ ظَهِيرِ
u'شَرْحٌ عُبَابٌ':Added, #1: 1	شَرَحَ الْعُبَابَ
u'شَرْحٌ عُبَابٌ':Added, #173: 173	شَرْحِ الْعُبَابِ
u'شَرْحٌ عِبَادَةٌ':Added, #4: 4	شَرْح الْعُبَابِ
u'شَرْحٌ عُدَّةٌ':Added, #1: 1	شَرْحِ الْعِبَادَاتِ
u'شَرْحٌ عرضة':Added, #1: 1	شَرْحِ الْعُدَّةِ
u'شَرْحٌ عُرْضَةٌ':Added, #1: 1	شَرْحِ الْعُرْضَةِ
u'شَرْحٌ عَضُدٌ':Added, #1: 1	شَرْحِ الْعُرْضَةِ
u'شَرْحٌ عَضُدٌ':Added, #1: 1	شَرْحِ الْعَضُدِ
u'شَرْحٌ عَقَائِدُ':Added, #2: 2	شَرْحِ عَضُدِ
u'شَرْحٌ عَقِيدَةٌ':Added, #6: 6	شَرْحِ الْعَقَائِدِ
u'شَرْحٌ علماء':Added, #1: 1	شَرْحِ عَقِيدَتِهِ
u'شَرْحٌ عُلَمَاءُ':Added, #1: 1	شَرْحُ الْعُلَمَاءِ
u'شَرْحٌ عُمَدٌ':Added, #1: 1	شَرْحُ الْعُلَمَاءِ
u'شَرْحٌ عُمْدَةٌ':Added, #1: 1	شَرْحِ الْعُمَدِ
u'شَرْحٌ عُمْدَةٌ':Added, #1: 1	شَرْحِ عُمْدَةِ
u'شَرْحٌ عُنْوَانٌ':Added, #52: 52	شَرْحِ الْعُمْدَةِ
u'شَرْحٌ عُيُونٌ':Added, #23: 23	شَرْحِ الْعُنْوَانِ
u'شَرْحٌ غَايَةٌ':Added, #1: 1	شَرْحِ عُيُونِ
u'شَرْحٌ غَرَرٌ':Added, #2: 2	شَرْحِ الْغَايَةِ
u'شَرْحٌ غُرَرٌ':Added, #1: 1	شَرْحُ الْغَرَرِ
u'شَرْحٌ غُسْلٌ':Added, #1: 1	شَرْحِ الْغُرَرِ
u'شَرْحٌ غير':Added, #1: 1	شَرْحِ الْغُسْلِ
u'شَرْحٌ غَيْرٌ':Added, #1: 1	شَرْحِ غَيْرِ
u'شَرْحٌ فَارِسِيٌّ':Added, #1: 1	شَرْحِ غَيْرِ
u'شَرْحٌ فَرَائِضُ':Added, #10: 10	شَرْحِ الْفَارِسِيِّ
u'شَرْحٌ فَرَائِضُ':Added, #2: 2	شَرْحِ فَرَائِضِ
u'شَرْحٌ فُرُوعٌ':Added, #3: 3	شَرْحِ الْفَرَائِضِ
u'شَرْحٌ فُصُولٌ':Added, #4: 4	شَرْحِ الْفُرُوعِ
u'شَرْحٌ فَصِيحٌ':Added, #1: 1	شَرْحِ الْفُصُولِ
u'شَرْحٌ فلان':Added, #5: 5	شَرْحِ الْفَصِيحِ
u'شَرْحٌ فلان':Added, #10: 10	شَرْحِ الْحَارِثِيِّ
u'شَرْحٌ فلان':Added, #2: 2	شَرْحِ السِّرَاجِيَّةِ
u'شَرْحٌ قِصَّةٌ':Added, #7: 7	شَرْحِ التِّرْمِذِيِّ
u'شَرْحٌ قَصِيدٌ':Added, #1: 1	شَرْحَ قِصّةِ
u'شَرْحٌ قَصِيدٌ':Added, #1: 1	شَرْحُ قَصِيدَةِ
u'شَرْحٌ قَوَاعِدُ':Added, #3: 3	شَرْحِ قَصِيدَةِ
u'شَرْحٌ قول':Added, #1: 1	شَرْحِ الْقَوَاعِدِ
u'شَرْحٌ قَوْلٌ':Added, #111: 111	شَرْحِ قَوْلِهِ
u'شَرْحٌ قول':Added, #111: 111	شَرْحِ قَوْلِهِ
u'شَرْحٌ قَوْلٌ':Added, #1: 1	شَرْحَ قَوْلِهِ
u'شَرْحٌ قول':Added, #1: 1	شَرْحَ قَوْلِهِ
u'شَرْحٌ قَوْلٌ':Added, #21: 21	شَرْحِ قَوْلِ
u'شَرْحٌ قول':Added, #21: 21	شَرْحِ قَوْلِ
u'شَرْحٌ قَوْلٌ':Added, #2: 2	شَرْحُ قَوْلِ
u'شَرْحٌ كَافِي':Added, #2: 2	شَرْحُ قَوْلِ
u'شَرْحٌ كَافِي':Added, #10: 10	شَرْحِ الْكَافِيَةِ
u'شَرْحٌ كِتَابٌ':Added, #1: 1	شَرْحِ كَافِيَةِ
u'شَرْحٌ كِتَابٌ':Added, #1: 1	شَرْحَ كِتَابِ
u'شَرْحٌ كِتَابٌ':Added, #1: 1	شَرْحِ كِتَابِهِ
u'شَرْحٌ كِتَابٌ':Added, #2: 2	شَرْحُ كِتَابِ
u'شَرْحٌ كِتَابٌ':Added, #4: 4	شَرْحِ الْكِتَابِ
u'شَرْحٌ كِفَايَةٌ':Added, #62: 62	شَرْحِ كِتَابِ
u'شَرْحٌ كِفَايَةٌ':Added, #26: 26	شَرْحِ الْكِفَايَةِ
u'شَرْحٌ كَلِمَةٌ':Added, #3: 3	شَرْحِ كِفَايَتِهِ
u'شَرْحٌ كَنْزٌ':Added, #1: 1	شَرْحِ الْكَلِمَةِ
u'شَرْحٌ كَنْزٌ':Added, #1: 1	شَرْح الْكَنْزِ
u'شَرْحٌ كَنْزٌ':Added, #1: 1	شَرْحُ الْكَنْزِ
u'شَرْحٌ كَنْزٌ':Added, #2: 2	شَرْحِ كَنْزِ
u'شَرْحٌ كَوْنٌ':Added, #62: 62	شَرْحِ الْكَنْزِ
u'شَرْحٌ لاَمِعٌ':Added, #1: 1	شَرْحِ كَوْنِ
u'شَرْحٌ لُبَابٌ':Added, #2: 2	شَرْحِ اللَّامِعِ
u'شَرْحٌ لُبَابٌ':Added, #1: 1	شَرْحَ اللُّبَابِ
u'شَرْحٌ لُبَابٌ':Added, #1: 1	شَرْحِ لُبَابِ
u'شَرْحٌ لُبَابٌ':Added, #5: 5	شَرْحُ اللُّبَابِ
u'شَرْحٌ لطائف':Added, #65: 65	شَرْحِ اللُّبَابِ
u'شَرْحٌ لُغَةٌ':Added, #1: 1	شَرْحِ لَطَائِفِ
u'شَرْحٌ لَفْظٌ':Added, #1: 1	شَرْحِ لُغَاتٍ
u'شَرْحٌ لَفْظَةٌ':Added, #1: 1	شَرْحُ اللّفْظِ
u'شَرْحٌ لمع':Added, #1: 1	شَرْحَ اللَّفْظَةِ
u'شَرْحٌ مَبْسُوطٌ':Added, #23: 23	شَرْحِ اللُّمَعِ
u'شَرْحٌ مَجْدٌ':Added, #52: 52	شَرْحِ الْمَبْسُوطِ
u'شَرْحٌ مُجَرَّدٌ':Added, #12: 12	شَرْحِ الْمَجْدِ
u'شَرْحٌ مَجْمَعٌ':Added, #3: 3	شَرْحِ الْمُجَرَّدِ
u'شَرْحٌ مَجْمَعٌ':Added, #135: 135	شَرْحِ الْمَجْمَعِ
u'شَرْحٌ مُجْمَعٌ':Added, #17: 17	شَرْحِ مَجْمَعِ
u'شَرْحٌ مَحَبَّةٌ':Added, #2: 2	شَرْحِ الْمُجْمَعِ
u'شَرْحٌ مُحَرَّرٌ':Added, #1: 1	شَرْحِ الْمَحَبّةِ
u'شَرْحٌ مَحْصُولٌ':Added, #16: 16	شَرْحِ الْمُحَرَّرِ
u'شَرْحٌ مَحَلٌّ':Added, #31: 31	شَرْحِ الْمَحْصُولِ
u'شَرْحٌ مُخْتَارٌ':Added, #1: 1	شَرْحِ الْمَحَلَّيْنِ
u'شَرْحٌ مُخْتَصَرٌ':Added, #171: 171	شَرْحِ الْمُخْتَارِ
u'شَرْحٌ مُخْتَصَرٌ':Added, #13: 13	شَرْحِ الْمُخْتَصَرِ
u'شَرْحٌ مُخْتَصَرٌ':Added, #1: 1	شَرْحُ الْمُخْتَصَرِ
u'شَرْحٌ مُخْتَصَرٌ':Added, #1: 1	شَرْحُ مُخْتَصَرِ
u'شَرْحٌ مُخْتَصَرٌ':Added, #3: 3	شَرْحِ مُخْتَصَرِهِ
u'شَرْحٌ مُخْتَلَفٌ':Added, #58: 58	شَرْحِ مُخْتَصَرِ
u'شَرْحٌ مُخْتَلِفٌ':Added, #1: 1	شَرْحِ الْمُخْتَلَفَاتِ
u'شَرْحٌ مُدَوَّنٌ':Added, #1: 1	شَرْحِ مُخْتَلِفَاتِهِ
u'شَرْحٌ مُدَوَّنَةٌ':Added, #3: 3	شَرْحِ الْمُدَوَّنَةِ
u'شَرْحٌ مُذَهَّبٌ':Added, #3: 3	شَرْحِ الْمُدَوَّنَةِ
u'شَرْحٌ مَذْهَبٌ':Added, #1: 1	شَرْحِ الْمُذَهَّبِ
u'شَرْحٌ مراد':Added, #24: 24	شَرْحِ الْمَذْهَبِ
u'شَرْحٌ مُرَادٌ':Added, #1: 1	شَرْحِ الْمُرَادِ
u'شَرْحٌ مَسْأَلَةٌ':Added, #1: 1	شَرْحِ الْمُرَادِ
u'شَرْحٌ مَسْأَلَةٌ':Added, #1: 1	شَرْحِ الْمَسْأَلَةِ
u'شَرْحٌ مَسَائِلُ':Added, #2: 2	شَرْحِ مَسْأَلَةِ
u'شَرْحٌ مُسْلِمٌ':Added, #1: 1	شَرْحِ مَسَائِلِ
u'شَرْحٌ مُسْلِمٌ':Added, #1: 1	شَرْح مُسْلِمٍ
u'شَرْحٌ مُسْلِمٌ':Added, #1: 1	شَرْحَ مُسْلِمٍ
u'شَرْحٌ مُسْلِمٌ':Added, #2: 2	شَرْحِ مُسْلِمِ
u'شَرْحٌ مُسْنَدٌ':Added, #336: 336	شَرْحِ مُسْلِمٍ
u'شَرْحٌ مُسْنَدٌ':Added, #3: 3	شَرْحِ مُسْنَدِ
u'شَرْحٌ مَشَارِقُ':Added, #5: 5	شَرْحِ الْمُسْنَدِ
u'شَرْحٌ مَشَارِقُ':Added, #1: 1	شَرْحِ مَشَارِقِ
u'شَرْحٌ مِشْكَاةٌ':Added, #5: 5	شَرْحِ الْمَشَارِقِ
u'شَرْحٌ مُشْكِلٌ':Added, #1: 1	شَرْحِ مِشْكَاةِ
u'شَرْحٌ مُشْكِلٌ':Added, #1: 1	شَرْحِ مُشْكِلِ
u'شَرْحٌ مَصَابِيحُ':Added, #3: 3	شَرْحِ الْمُشْكِلَيْنِ
u'شَرْحٌ مُصَنِّفٌ':Added, #4: 4	شَرْحِ الْمَصَابِيحِ
u'شَرْحٌ مُصَنِّفٌ':Added, #1: 1	شَرْحُ الْمُصَنِّفِ
u'شَرْحٌ مُطِيعٌ':Added, #5: 5	شَرْحِ الْمُصَنِّفِ
u'شَرْحٌ مَعَالِمُ':Added, #1: 1	شَرْحِ الْمُطِيعِ
u'شَرْحٌ مِفْتَاحٌ':Added, #1: 1	شَرْحِ الْمَعَالِمِ
u'شَرْحٌ مُفَصَّلٌ':Added, #4: 4	شَرْحِ الْمِفْتَاحِ
u'شَرْحٌ مَقَاصِدُ':Added, #14: 14	شَرْحِ الْمُفَصَّلِ
u'شَرْحٌ مَقَاصِدُ':Added, #13: 13	شَرْحِ الْمَقَاصِدِ
u'شَرْحٌ مَقَالٌ':Added, #1: 1	شَرْحِ مَقَاصِدِهِ
u'شَرْحٌ مَقَالَةٌ':Added, #1: 1	شَرْحِ مَقَالَاتِ
u'شَرْحٌ مُقْتَرَحٌ':Added, #1: 1	شَرْحِ مَقَالَاتِ
u'شَرْحٌ مُقْتَرِحٌ':Added, #1: 1	شَرْحِ الْمُقْتَرَحِ
u'شَرْحٌ مُقَدِّمٌ':Added, #1: 1	شَرْحِ الْمُقْتَرِحِ
u'شَرْحٌ مُقَدِّمٌ':Added, #2: 2	شَرْحِ الْمُقَدِّمَةِ
u'شَرْحٌ مُقَدِّمَةٌ':Added, #5: 5	شَرْحِ مُقَدِّمَةِ
u'شَرْحٌ مُقَدِّمَةٌ':Added, #2: 2	شَرْحِ الْمُقَدِّمَةِ
u'شَرْحٌ مُقْنِعٌ':Added, #5: 5	شَرْحِ مُقَدِّمَةِ
u'شَرْحٌ مَقُولٌ':Added, #10: 10	شَرْحِ الْمُقْنِعِ
u'شَرْحٌ مَنَارٌ':Added, #2: 2	شَرْحِ الْمَقُولَةِ
u'شَرْحٌ مَنَارٌ':Added, #1: 1	شَرْحُ الْمَنَارِ
u'شَرْحٌ مَنَاسِكُ':Added, #25: 25	شَرْحِ الْمَنَارِ
u'شَرْحٌ مَنَاسِكُ':Added, #1: 1	شَرْحِ مَنَاسِكِهِ
u'شَرْحٌ مَنَاسِكُ':Added, #3: 3	شَرْحِ الْمَنَاسِكِ
u'شَرْحٌ مُنْتَخَبٌ':Added, #5: 5	شَرْحِ مَنَاسِكِ
u'شَرْحٌ مِنَحٌ':Added, #1: 1	شَرْحِ الْمُنْتَخَبِ
u'شَرْحٌ مَنْسَكٌ':Added, #1: 1	شَرْحِ الْمِنَحِ
u'شَرْحٌ مَنْسَك':Added, #1: 1	شَرْحُ الْمَنْسَكِ
u'شَرْحٌ مَنْسَكٌ':Added, #1: 1	شَرْحُ الْمَنْسَكِ
u'شَرْحٌ مَنْسَك':Added, #2: 2	شَرْحِ الْمَنْسَكِ
u'شَرْحٌ مَنْسَكٌ':Added, #2: 2	شَرْحِ الْمَنْسَكِ
u'شَرْحٌ مَنْسَك':Added, #5: 5	شَرْحِ مَنْسَكِهِ
u'شَرْحٌ مَنْظُومٌ':Added, #5: 5	شَرْحِ مَنْسَكِهِ
u'شَرْحٌ مَنْظُومٌ':Added, #14: 14	شَرْحِ مَنْظُومَةِ
u'شَرْحٌ مَنْظُومٌ':Added, #1: 1	شَرْحَ الْمَنْظُومَةِ
u'شَرْحٌ مَنْظُومٌ':Added, #1: 1	شَرْحِ مَنْظُومَةٍ
u'شَرْحٌ مَنْظُومٌ':Added, #1: 1	شَرْحِ مَنْظُومَتِهِ
u'شَرْحٌ مُنْفَرِجٌ':Added, #32: 32	شَرْحِ الْمَنْظُومَةِ
u'شَرَحَ مِنْهَاجٌ':Predicate, #1: 1	شَرْحِ الْمُنْفَرِجَةِ
u'شَرْحٌ مِنْهَاجٌ':Added, #1: 1	شَرَحَ الْمِنْهَاجَ
u'شَرْحٌ مِنْهَاجٌ':Added, #2: 2	شَرْحِ مِنْهَاجِ
u'شَرْحٌ مِنْهَاجٌ':Added, #3: 3	شَرْح الْمِنْهَاجِ
u'شَرْحٌ مُنْيَةٌ':Added, #85: 85	شَرْحِ الْمِنْهَاجِ
u'شَرْحٌ مُنْيَةٌ':Added, #106: 106	شَرْحِ مُنْيَةِ
u'شَرْحٌ مُهَذَّبٌ':Added, #149: 149	شَرْحِ الْمُنْيَةِ
u'شَرْحٌ مُهَذِّبٌ':Added, #3: 3	شَرْحُ الْمُهَذَّبِ
u'شَرْحٌ مُهَذَّبٌ':Added, #3: 3	شَرْحِ الْمُهَذِّبِ
u'شَرْحٌ مُهَذَّبٌ':Added, #4: 4	شَرْحَ الْمُهَذَّبِ
u'شَرْحٌ مُهَذَّبٌ':Added, #513: 513	شَرْحِ الْمُهَذَّبِ
u'شَرْحٌ مَوَاقِفُ':Added, #6: 6	شَرْح الْمُهَذَّبِ
u'شَرْحٌ مُوجَزٌ':Added, #8: 8	شَرْحِ الْمَوَاقِفِ
u'شَرْحٌ مُوَطَّأٌ':Added, #1: 1	شَرْحِ الْمُوجَزِ
u'شَرْحٌ مُوَطَّأٌ':Added, #1: 1	شَرْحِ مُوَطَّأِ
u'شَرْحٌ نَافِعٌ':Added, #2: 2	شَرْحِ الْمُوَطَّأِ
u'شَرْحٌ نَافِعٌ':Added, #1: 1	شَرْحُ النَّافِعِ
u'شَرْحٌ نَظْمٌ':Added, #4: 4	شَرْحِ النَّافِعِ
u'شَرْحٌ نَظْمٌ':Added, #2: 2	شَرْحِ النَّظْمِ
u'شَرْحٌ نَفَقَةٌ':Added, #5: 5	شَرْحِ نَظْمِ
u'شَرْحٌ نُقايَة':Added, #1: 1	شَرْحِ النَّفَقَاتِ
u'شَرْحٌ نَقْل':Added, #80: 80	شَرْحِ النُّقَايَةِ
u'شَرْحٌ نَقْلَة':Added, #1: 1	شَرْحِ النَّقْلِيَّةِ
u'شَرْحٌ نَقْلِيّ':Added, #1: 1	شَرْحِ النَّقْلِيَّةِ
u'شَرْحٌ نكاح':Added, #1: 1	شَرْحِ النَّقْلِيَّةِ
u'شَرْحٌ نِكَاحٌ':Added, #1: 1	شَرْحِ النِّكَاحِ
u'شَرْحٌ نَوَازِلُ':Added, #1: 1	شَرْحِ النِّكَاحِ
u'شَرْحٌ نُورٌ':Added, #1: 1	شَرْحِ النَّوَازِلِ
u'شَرْحٌ نَوَوِيٌّ':Added, #2: 2	شَرْحِ نُورِ
u'شَرْحٌ هِدَايَةٌ':Added, #1: 1	شَرْحِ النَّوَوِيَّةِ
u'شَرْحٌ هَدِيٌّ':Added, #259: 259	شَرْحِ الْهِدَايَةِ
u'شَرْحٌ هَدِيٌّ':Added, #1: 1	شَرْحِ الْهَدِيَّةِ
u'شَرْحٌ هَدِيَّةٌ':Added, #2: 2	شَرْحِ هَدِيَّةِ
u'شَرْحٌ هَدِيَّةٌ':Added, #1: 1	شَرْحِ الْهَدِيَّةِ
u'شَرْحٌ وَجْهٌ':Added, #2: 2	شَرْحِ هَدِيَّةِ
u'شَرْحٌ وَجِيزٌ':Added, #1: 1	شَرْحُ الْوَجْهِ
u'شَرْحٌ وَسِيطٌ':Added, #27: 27	شَرْحِ الْوَجِيزِ
u'شَرْحٌ وِقَايَةٌ':Added, #22: 22	شَرْحِ الْوَسِيطِ
u'شَرْحٌ وَقْتٌ':Added, #62: 62	شَرْحِ الْوِقَايَةِ
u'شَرْخٌ شَبابٌ':Added, #1: 1	شَرْحُ وَقْتِ
u'شَرْخٌ شَبابٌ':Added, #1: 1	شَرْخَ الشَّبَابِ
u'شَرْخٌ شَبَابٌ':Added, #1: 1	شَرْخُ الشَّبَابِ
u'شَرْخٌ شَبَابٌ':Added, #1: 1	شَرْخَ الشَّبَابِ
u'شَرَدَ بَعيرٌ':Subject, #1: 1	شَرْخُ الشَّبَابِ
u'شَرْطٌ إبَاحَةٌ':Added, #1: 1	شَرَدَ الْبَعِيرُ
u'شَرْطٌ إبَاحَةٌ':Added, #1: 1	شَرْطُ الْإِبَاحَةِ
u'شَرْطٌ إبَاحَةٌ':Added, #2: 2	شَرْطُ إبَاحَةِ
u'شَرْطٌ اِبْتِداءٌ':Added, #2: 2	شَرْطُ إبَاحَتِهِ
u'شَرْطٌ اِبْتِداءٌ':Added, #1: 1	شَرْطُ ابْتِدَاءٍ
u'شَرْطٌ إبدالٌ':Added, #2: 2	شَرْطُ ابْتِدَاءِ
u'شَرْطٌ إبدالٌ':Added, #1: 1	شَرْطَ الْإِبْدَالِ
u'شَرَطَ إِبْقَاءٌ':Predicate, #2: 2	شَرْطِ الْإِبْدَالِ
u'شَرَطَ إِبْقَاءٌ':Predicate, #1: 1	شَرَطَ إبْقَاءَ
u'شَرَطَ اِبْنٌ':Subject, #5: 5	شَرَطَ الْإِبْقَاءَ
u'شَرْطٌ اِبْنٌ':Added, #4: 4	شَرَطَ ابْنُ
u'شَرْطٌ اِبْنٌ':Added, #1: 1	شَرْطَ ابْنِ
u'شَرَطَ اِتِّحَادٌ':Predicate, #1: 1	شَرْطِ ابْنِ
u'شَرْطٌ إتْمَامٌ':Added, #2: 2	شَرَطَ اتِّحَادَ
u'شَرْطٌ إِتْيانٌ':Added, #1: 1	شَرْطُ الْإِتْمَامِ
u'شَرْطٌ إِثْبَاتٌ':Added, #2: 2	شَرْطِ الْإِتْيَانِ
u'شَرْطٌ إِثْبَاتٌ':Added, #1: 1	شَرْطِ إثْبَاتِ
u'شَرْطٌ إِثْبَاتٌ':Added, #1: 1	شَرْطُ الْإِثْبَاتِ
u'شَرْطٌ إجَارَةٌ':Added, #2: 2	شَرْطُ إثْبَاتِ
u'شَرْطٌ إجَارَةٌ':Added, #1: 1	شَرْطَ إجَارَةِ
u'شَرْطٌ إجَازَةٌ':Added, #1: 1	شَرْطِ الْإِجَارَةِ
u'شَرْطٌ إجَازَةٌ':Added, #1: 1	شَرْطُ الْإِجَازَةِ
u'شَرَطَ اِجْتِمَاعٌ':Predicate, #4: 4	شَرْطِ الْإِجَازَةِ
u'شَرَطَ آجُرٌّ':Predicate, #2: 2	شَرَطَ اجْتِمَاعَ
u'شَرَطَ أَجْرٌ':Predicate, #1: 1	شَرَطَ الْآجُرَّ
u'شَرْطٌ إِجْرَاءٌ':Added, #1: 1	شَرَطَ الْأَجْرَ
u'شَرَطَ أُجْرَةٌ':Predicate, #2: 2	شَرْطُ إجْرَاءِ
u'شَرْطٌ أُجْرَةٌ':Added, #1: 1	شَرَطَ الْأُجْرَةَ
u'شَرْطٌ أُجْرَةٌ':Added, #1: 1	شَرْطَ الْأُجْرَةِ
u'شَرْطٌ أُجْرَةٌ':Added, #1: 1	شَرْطِ الْأُجْرَةِ
u'شَرْطٌ إِجْزَاءٌ':Added, #2: 2	شَرْطِ أُجْرَةٍ
u'شَرْطٌ إِجْزَاءٌ':Added, #1: 1	شَرْطَ إجْزَاءِ
u'شَرَطَ أَجَلٌ':Predicate, #1: 1	شَرْطَ الْإِجْزَاءِ
u'شَرْطٌ أَجَلٌ':Added, #2: 2	شَرَطَ الْأَجَلَ
u'شَرْطٌ أَجَلٌ':Added, #1: 1	شَرْطَ الْأَجَلِ
u'شَرْطٌ أَجَلٌ':Added, #1: 1	شَرْطِ الْأَجَلِ
u'شَرْطٌ إِجْمَاعٌ':Added, #3: 3	شَرْطُ الْأَجَلِ
u'شَرْطٌ أَجْوَدُ':Added, #1: 1	شَرْطُ الْإِجْمَاعِ
u'شَرْطٌ أَجِيرٌ':Added, #2: 2	شَرْطُ الْأَجْوَدِ
u'شَرَطَ أحَدٌ':Predicate, #1: 1	شَرْطُ الْأَجِيرِ
u'شَرَطَ أحَدٌ':Subject, #1: 1	شَرَطَ أَحَدَ
u'شَرَطَ أحَدٌ':Subject, #1: 1	شَرَطَ أَحَدٌ
u'شَرْطٌ أحَدٌ':Added, #3: 3	شَرَطَ أَحَدُ
u'شَرَطَ إِحْرَامٌ':Predicate, #1: 1	شَرْطِ أَحَدِ
u'شَرْطٌ إِحْرَامٌ':Added, #3: 3	شَرَطَ الْإِحْرَامَ
u'شَرْطٌ إحْضَارٌ':Added, #1: 1	شَرْطُ الْإِحْرَامِ
u'شَرَطَ أخْذٌ':Predicate, #1: 1	شَرْطِ إحْضَارِهِ
u'شَرْطٌ أخْذٌ':Added, #1: 1	شَرَطَ أَخْذَ
u'شَرْطٌ إِخْرَاجٌ':Added, #1: 1	شَرْطُ أَخْذِ
u'شَرَطَ أَدَاءٌ':Predicate, #1: 1	شَرْطُ إخْرَاجِهِ
u'شَرْطٌ أَدَاءٌ':Added, #1: 1	شَرَطَ أَدَاءَ
u'شَرْطٌ أَدَاءٌ':Added, #12: 12	شَرْطُ الْأَدَاءِ
u'شَرْطٌ أَدَاءٌ':Added, #1: 1	شَرْطِ أَدَاءِ
u'شَرْطٌ أَدَاءٌ':Added, #3: 3	شَرْطِ الْأَدَاءِ
u'شَرْطٌ أَدَاءٌ':Added, #4: 4	شَرْطَ الْأَدَاءِ
u'شَرَطَ إدْخَالٌ':Predicate, #5: 5	شَرْطُ أَدَاءِ
u'شَرْطٌ إدْخَالٌ':Added, #1: 1	شَرَطَ إدْخَالَ
u'شَرَطَ إِدْرَاكٌ':Predicate, #1: 1	شَرْطِ الْإِدْخَالِ
u'شَرَطَ إِدْمَانٌ':Predicate, #1: 1	شَرَطَ إدْرَاكَ
u'شَرْطٌ أَذَانٌ':Added, #3: 3	شَرَطَ الْإِدْمَانَ
u'شَرَطَ إِذْنٌ':Predicate, #1: 1	شَرْطَ أَذَانِ
u'شَرْطٌ إِذْنٌ':Added, #1: 1	شَرَطَ الْإِذْنَ
u'شَرْطٌ إِذْنٌ':Added, #1: 1	شَرْطُ الْإِذْنِ
u'شَرَطَ إِرْثٌ':Predicate, #1: 1	شَرْطِ الْإِذْنِ
u'شَرْطٌ إِرْثٌ':Added, #1: 1	شَرَطَ الْإِرْثَ
u'شَرْطٌ إِرْثٌ':Added, #1: 1	شَرْطَ إرْثِ
u'شَرْطٌ إِرْثٌ':Added, #1: 1	شَرْطِ إرْثِ
u'شَرْطٌ إِرْثٌ':Added, #1: 1	شَرْطَ الْإِرْثِ
u'شَرَطَ أَرْدَأَ':Predicate, #3: 3	شَرْطِ الْإِرْثِ
u'شَرَطَ اِسْتِبْدَالٌ':Predicate, #1: 1	شَرَطَ الْأَرْدَأَ
u'شَرْطٌ اِسْتِحْقَاقٌ':Added, #1: 1	شَرَطَ اسْتِبْدَالَ
u'شَرْطٌ اِسْتِحْقَاقٌ':Added, #1: 1	شَرْطُ اسْتِحْقَاقِ
u'شَرْطٌ اِسْتِدَامَةٌ':Added, #1: 1	شَرْطُ اسْتِحْقَاقِهِ
u'شَرْطٌ اِسْتِعْمالٌ':Added, #1: 1	شَرْطِ اسْتِدَامَةٍ
u'شَرْطٌ اِسْتِعْمالٌ':Added, #1: 1	شَرْطَ اسْتِعْمَالِ
u'شَرَطَ اِسْتِقْلالٌ':Predicate, #1: 1	شَرْطَ اسْتِعْمَالِهِ
u'شَرْطٌ اِسْتِلْزامٌ':Added, #1: 1	شَرَطَ اسْتِقْلَالَ
u'شَرْطٌ اِسْتِمْرارٌ':Added, #1: 1	شَرْطُ اسْتِلْزَامِهِ
u'شَرْطٌ اِسْتِمْرارٌ':Added, #1: 1	شَرْطُ اسْتِمْرَارِ
u'شَرْطٌ اِسْتِناد':Added, #1: 1	شَرْطِ اسْتِمْرَارٍ
u'شَرْطٌ اِسْتِواءٌ':Added, #2: 2	شَرْطِ اسْتِنَادِ
u'شَرَطَ اِسْتِئْجَارٌ':Predicate, #1: 1	شَرْطِ اسْتِوَاءِ
u'شَرَطَ اِسْتيعابٌ':Predicate, #1: 1	شَرَطَ اسْتِئْجَارَ
u'شَرَطَ اِسْتيفاءٌ':Predicate, #1: 1	شَرَطَ اسْتِيعَابَ
u'شَرْطٌ اِسْتيفاءٌ':Added, #1: 1	شَرَطَ اسْتِيفَاءَ
u'شَرَطَ إِسْقاطٌ':Predicate, #1: 1	شَرْطِ اسْتِيفَاءِ
u'شَرْطٌ إِسْقاطٌ':Added, #2: 2	شَرَطَ إسْقَاطَ
u'شَرْطٌ إِسْقاطٌ':Added, #1: 1	شَرْطُ إسْقَاطِ
u'شَرَطَ إِسْلامٌ':Predicate, #2: 2	شَرْطِ إسْقَاطِ
u'شَرْطٌ إِسْلامٌ':Added, #3: 3	شَرَطَ الْإِسْلَامَ
u'شَرْطٌ إِسْلامٌ':Added, #1: 1	شَرْطِ الإِسْلاَمِ
u'شَرْطٌ اِسْمٌ':Added, #1: 1	شَرْطِ الْإِسْلَامِ
u'شَرْطٌ إِسْهامٌ':Added, #2: 2	شَرْطِ اسْمِ
u'شَرَطَ إِشْراكٌ':Predicate, #1: 1	شَرْطِ الْإِسْهَامِ
u'شَرْطٌ إصابَةٌ':Added, #1: 1	شَرَطَ الْإِشْرَاكَ
u'شَرْطٌ أصل':Added, #2: 2	شَرْطُ إصَابَةٍ
u'شَرْطٌ أًصْلٌ':Added, #1: 1	شَرْطِ أَصْلِ
u'شَرْطٌ إضافَةٌ':Added, #1: 1	شَرْطِ أَصْلِ
u'شَرْطٌ إِطْعامٌ':Added, #1: 1	شَرْطَ الْإِضَافَةِ
u'شَرْطٌ إِعادَةٌ':Added, #1: 1	شَرْطُ الْإِطْعَامِ
u'شَرْطٌ إِعانَةٌ':Added, #1: 1	شَرْطَ الْإِعَادَةِ
u'شَرْطٌ إِعْتاقٌ':Added, #1: 1	شَرْطُ الْإِعَانَةِ
u'شَرَطَ اِعْتِبارٌ':Predicate, #1: 1	شَرْطُ إعْتَاقِ
u'شَرْطٌ اِعْتِبارٌ':Added, #1: 1	شَرَطَ اعْتِبَارَ
u'شَرْطٌ اِعْتِبارٌ':Added, #1: 1	شَرْطَ اعْتِبَارِ
u'شَرْطٌ اِعْتِبارٌ':Added, #2: 2	شَرْطُ اعْتِبَارِ
u'شَرَطَ إعْطَاءٌ':Predicate, #2: 2	شَرْطِ اعْتِبَارِهِ
u'شَرَطَ إعْلاَمٌ':Predicate, #1: 1	شَرَطَ إعْطَاءَ
u'شَرَطَ أَغْرَاسٌ':Predicate, #2: 2	شَرَطَ إعْلَامَ
u'شَرْطٌ إفَادَةٌ':Added, #2: 2	شَرَطَ الْأَغْرَاسَ
u'شَرْطٌ اِفْتِتَاحٌ':Added, #1: 1	شَرْطُ إفَادَتِهِ
u'شَرْطٌ أفْضَلِيَّةٌ':Added, #2: 2	شَرْطُ افْتِتَاحِ
u'شَرْطٌ إقامَةٌ':Added, #1: 1	شَرْطُ أَفْضَلِيَّةِ
u'شَرْطٌ إقامَةٌ':Added, #1: 1	شَرْطِ إقَامَةِ
u'شَرْطٌ إقْرَارٌ':Added, #2: 2	شَرْطُ إقَامَةِ
u'شَرَطَ أقَلُّ':Predicate, #1: 1	شَرْطُ الْإِقْرَارِ
u'شَرْطٌ أقَلُّ':Added, #2: 2	شَرَطَ الْأَقَلَّ
u'شَرَطَ أَكْثَرُ':Predicate, #2: 2	شَرْطِ الْأَقَلِّ
u'شَرَطَ أَكْثَرُ':Predicate, #2: 2	شَرَطَ أَكْثَرَ
u'شَرْطٌ إكْرَاهٌ':Added, #2: 2	شَرَطَ الْأَكْثَرَ
u'شَرْطٌ إكْرَاهٌ':Added, #2: 2	شَرْطِ الْإِكْرَاهِ
u'شَرْطٌ أكل':Added, #3: 3	شَرْطُ الْإِكْرَاهِ
u'شَرْطٌ أَكْلٌ':Added, #1: 1	شَرْطِ أَكْلِ
u'شَرْطٌ اِلْتِزَامٌ':Added, #1: 1	شَرْطِ أَكْلِ
u'شَرْطٌ إلْحَاقٌ':Added, #1: 1	شَرْطِ الْتِزَامِ
u'شَرَطَ إِلْزَامٌ':Predicate, #1: 1	شَرْطُ إلْحَاقِ
u'شَرَطَ ألف':Predicate, #1: 1	شَرَطَ إلْزَامَ
u'شَرَطَ ألْفٌ':Predicate, #5: 5	شَرَطَ الْأَلْفَ
u'شَرَطَ أَلْفٌ':Predicate, #5: 5	شَرَطَ الْأَلْفَ
u'شَرْطٌ ألْفٌ':Added, #5: 5	شَرَطَ الْأَلْفَ
u'شَرْطٌ ألْفٌ':Added, #1: 1	شَرْطَ الْأَلْفَيْنِ
u'شَرْطٌ ألْفٌ':Added, #1: 1	شَرْطُ الْأَلْفَيْنِ
u'شَرْطٌ أَلْفٌ':Added, #2: 2	شَرْطِ أَلْفٍ
u'شَرَطَ إمَامٌ':Subject, #2: 2	شَرْطِ أَلْفٍ
u'شَرَطَ إمَامٌ':Subject, #1: 1	شَرَطَ إمَامُ
u'شَرْطٌ إمَامٌ':Added, #5: 5	شَرَطَ الْإِمَامُ
u'شَرْطٌ إمَامٌ':Added, #2: 2	شَرْطَ الْإِمَامِ
u'شَرْطٌ إمَامٌ':Added, #2: 2	شَرْطُ الْإِمَامِ
u'شَرَطَ أمَانٌ':Predicate, #2: 2	شَرْطِ الْإِمَامِ
u'شَرَطَ أمَانٌ':Predicate, #1: 1	شَرَطَ أَمَانَ
u'شَرْطٌ أمَانٌ':Added, #2: 2	شَرَطَ الْأَمَانَ
u'شَرْطٌ أمَانٌ':Added, #1: 1	شَرْطَ الْأَمَانِ
u'شَرَطَ أمَةٌ':Predicate, #1: 1	شَرْطِ الْأَمَانِ
u'شَرْطٌ اِمْتِناعٌ':Added, #1: 1	شَرَطَ الْأَمَةَ
u'شَرَطَ آمِرٌ':Subject, #1: 1	شَرْطِ امْتِنَاعِ
u'شَرْطٌ أَمْرٌ':Added, #1: 1	شَرَطَ الْآمِرُ
u'شَرْطٌ أَمْرٌ':Added, #1: 1	شَرْطَ الْأَمْرِ
u'شَرْطٌ إِمْضاءٌ':Added, #3: 3	شَرْطِ الْأَمْرِ
u'شَرْطٌ إِمْكانٌ':Added, #1: 1	شَرْطِ إمْضَاءِ
u'شَرْطٌ أَمْنٌ':Added, #1: 1	شَرْطُ الْإِمْكَانِ
u'شَرْطٌ إِنابَةٌ':Added, #1: 1	شَرْطِ الْأَمْنِ
u'شَرْطٌ إِنْتاجٌ':Added, #1: 1	شَرْطَ إنَابَةِ
u'شَرْطٌ إِنْتاجٌ':Added, #1: 1	شَرْطَ الْإِنْتَاجِ
u'شَرْطٌ اِنْتِفاء':Added, #1: 1	شَرْطَ إنْتَاجِ
u'شَرْطٌ اِنْتِفاعٌ':Added, #2: 2	شَرْطُ انْتِفَاءِ
u'شَرْطٌ اِنْتِقالٌ':Added, #1: 1	شَرْطِ انْتِفَاعِ
u'شَرْطٌ اِنْحِلالٌ':Added, #1: 1	شَرْطِ انْتِقَالِ
u'شَرْطٌ اِنْحِلالٌ':Added, #2: 2	شَرْطِ انْحِلَالِ
u'شَرَطَ إِنْزالٌ':Predicate, #3: 3	شَرْطُ انْحِلَالِ
u'شَرْطٌ إِنْزالٌ':Added, #1: 1	شَرَطَ الْإِنْزَالَ
u'شَرْطٌ أَنْصِبَاءُ':Added, #1: 1	شَرْطُ الْإِنْزَالِ
u'شَرْطٌ اِنْعِقَادٌ':Added, #1: 1	شَرْطِ الْأَنْصِبَاءِ
u'شَرْطٌ اِنْعِقَادٌ':Added, #1: 1	شَرْطُ انْعِقَادٍ
u'شَرْطٌ اِنْعِقَادٌ':Added, #1: 1	شَرْطِ انْعِقَادِ
u'شَرْطٌ اِنْعِقَادٌ':Added, #3: 3	شَرْطُ انْعِقَادِهِ
u'شَرْطٌ اِنْعِقَادٌ':Added, #6: 6	شَرْطَ انْعِقَادِ
u'شَرْطٌ إِنْفاقٌ':Added, #9: 9	شَرْطُ انْعِقَادِ
u'شَرَطَ اِنْقِرَاضٌ':Predicate, #1: 1	شَرْطُ الْإِنْفَاقِ
u'شَرْطٌ اِنْقِرَاضٌ':Added, #1: 1	شَرَطَ انْقِرَاضَ
u'شَرْطٌ اِنْقِرَاضٌ':Added, #1: 1	شَرْطَ انْقِرَاضِ
u'شَرْطٌ إِنْكارٌ':Added, #1: 1	شَرْطِ انْقِرَاضِ
u'شَرَطَ إهْدَاءٌ':Predicate, #1: 1	شَرْطِ إنْكَارِ
u'شَرْطٌ إهْدَاءٌ':Added, #1: 1	شَرَطَ الْإِهْدَاءَ
u'شَرَطَ أهْلٌ':Subject, #1: 1	شَرْطُ إهْدَاءِ
u'شَرْطٌ أَهْلِيٌّ':Added, #1: 1	شَرَطَ أَهْلُ
u'شَرْطٌ أهْلِيَّةٌ':Added, #3: 3	شَرْطُ الْأَهْلِيَّةِ
u'شَرَطَ أَوَّلُ':Subject, #3: 3	شَرْطُ الْأَهْلِيَّةِ
u'شَرْطٌ أَوَّلُ':Added, #2: 2	شَرَطَ الْأَوَّلُ
u'شَرْطٌ أَوَّلُ':Added, #1: 1	شَرْطُ الْأَوَّلِ
u'شَرَطَ أَوْلاَدٌ':Predicate, #1: 1	شَرْطِ الْأَوَّلِ
u'شَرَطَ أَوْلَوِيٌّ':Predicate, #1: 1	شَرَطَ الْأَوْلَادَ
u'شَرْطٌ أَوْلَوِيٌّ':Added, #1: 1	شَرَطَ أَوْلَوِيَّةَ
u'شَرْطٌ أَوْلَوِيٌّ':Added, #1: 1	شَرْطَ الْأَوْلَوِيَّةِ
u'شَرَطَ أئِمَّةٌ':Subject, #7: 7	شَرْطُ الْأَوْلَوِيَّةِ
u'شَرْطٌ أئِمَّةٌ':Added, #1: 1	شَرَطَ الْأَئِمَّةُ
u'شَرْطٌ إِيجَابٌ':Added, #1: 1	شَرْطِ أَئِمَّةِ
u'شَرَطَ إيمَانٌ':Predicate, #1: 1	شَرْطُ إيجَابِ
u'شَرْطٌ أَيْمَانٌ':Added, #1: 1	شَرَطَ الْإِيمَانَ
u'شَرْطٌ إيمَانٌ':Added, #1: 1	شَرْطَ الْأَيْمَانِ
u'شَرْطٌ إيمَانٌ':Added, #1: 1	شَرْطَ الْإِيمَانِ
u'شَرَطَ بَائِعٌ':Subject, #2: 2	شَرْطِ الْإِيمَانِ
u'شَرْطٌ بَائِعٌ':Added, #9: 9	شَرَطَ الْبَائِعُ
u'شَرْطٌ بَائِعٌ':Added, #1: 1	شَرْطُ بَائِعٍ
u'شَرْطٌ بَائِعٌ':Added, #3: 3	شَرْطُ الْبَائِعِ
u'شَرْطٌ بَحْثٌ':Added, #4: 4	شَرْطِ الْبَائِعِ
u'شَرْطٌ بُخَارِيٌّ':Added, #1: 1	شَرْطِ الْبَحْثِ
u'شَرْطٌ بُخَارِيٌّ':Added, #1: 1	شَرْط الْبُخَارِيِّ
u'شَرَطٌ بِدَايَةٌ':Added, #53: 53	شَرْطِ الْبُخَارِيِّ
u'شَرَطَ بَدَلٌ':Predicate, #1: 1	شَرَطَ الْبِدَايَةِ
u'شَرْطٌ بَدَلٌ':Added, #1: 1	شَرَطَ الْبَدَلَ
u'شَرَطَ بَذْرٌ':Predicate, #1: 1	شَرْطُ الْبَدَلِ
u'شَرْطٌ بِرٌّ':Added, #4: 4	شَرَطَ الْبَذْرَ
u'شَرْطٌ بِرٌّ':Added, #11: 11	شَرْطَ الْبِرِّ
u'شَرْطٌ بِرٌّ':Added, #13: 13	شَرْطِ الْبِرِّ
u'شَرْطٌ بَرٌّ':Added, #16: 16	شَرْطُ الْبِرِّ
u'شَرْطٌ بَرٌّ':Added, #1: 1	شَرْطَ الْبَرِّ
u'شَرْطٌ بِرٌّ':Added, #1: 1	شَرْطُ بَرِّهِ
u'شَرْطٌ بَرٌّ':Added, #2: 2	شَرْطِ بِرِّهِ
u'شَرْطٌ بِرٌّ':Added, #3: 3	شَرْطِ الْبَرِّ
u'شَرْطٌ بِرٌّ':Added, #5: 5	شَرْطَ بِرِّهِ
u'شَرَطَ بَراءةٌ':Predicate, #8: 8	شَرْطُ بِرِّهِ
u'شَرَطَ بَراءةٌ':Predicate, #13: 13	شَرَطَ الْبَرَاءَةَ
u'شَرْطٌ بَراءةٌ':Added, #3: 3	شَرَطَ بَرَاءَةَ
u'شَرْطٌ بَراءةٌ':Added, #1: 1	شَرْطُ بَرَاءَةِ
u'شَرْطٌ بَراءةٌ':Added, #2: 2	شَرْطَ الْبَرَاءَةِ
u'شَرْطٌ بَراءةٌ':Added, #5: 5	شَرْطُ الْبَرَاءَةِ
u'شَرَطَ بَعْثٌ':Predicate, #5: 5	شَرْطِ الْبَرَاءَةِ
u'شَرَطَ بَعْضٌ':Predicate, #1: 1	شَرَطَ الْبَعْثَ
u'شَرَطَ بَعْضٌ':Predicate, #7: 7	شَرَطَ بَعْضَ
u'شَرَطَ بَعْضٌ':Subject, #8: 8	شَرَطَ الْبَعْضَ
u'شَرْطٌ بَعْضٌ':Added, #4: 4	شَرَطَ بَعْضُ
u'شَرْطٌ بَعْضٌ':Added, #1: 1	شَرْطَ بَعْضِ
u'شَرْطٌ بَقاءٌ':Added, #1: 1	شَرْطِ بَعْضِ
u'شَرْطٌ بَقاءٌ':Added, #1: 1	شَرْطَ الْبَقَاءِ
u'شَرْطٌ بَقاءٌ':Added, #1: 1	شَرْطِ الْبَقَاءِ
u'شَرْطٌ بَقاءٌ':Added, #3: 3	شَرْطُ بَقَاءِ
u'شَرَطَ بَقَرٌ':Predicate, #6: 6	شَرْطُ الْبَقَاءِ
u'شَرْطٌ بَقَرٌ':Added, #5: 5	شَرَطَ الْبَقَرَ
u'شَرَطَ بَقِيَّةٌ':Predicate, #2: 2	شَرْطِ الْبَقَرِ
u'شَرَطَ بَقِيَّةٌ':Predicate, #1: 1	شَرَطَ الْبَقِيَّةَ
u'شَرْطٌ بِكْرٌ':Added, #1: 1	شَرَطَ بَقِيَّةَ
u'شَرَطَ بِنَاءٌ':Predicate, #2: 2	شَرْطِ بِكْرٍ
u'شَرْطٌ بِنَاءٌ':Added, #1: 1	شَرَطَ الْبِنَاءَ
u'شَرْطٌ بِنَاءٌ':Added, #1: 1	شَرْطِ الْبِنَاءِ
u'شَرَطَ بَيْعٌ':Predicate, #2: 2	شَرْطَ الْبِنَاءِ
u'شَرْطٌ بَيْعٌ':Added, #2: 2	شَرَطَ الْبَيْعَ
u'شَرْطٌ بَيْعٌ':Added, #1: 1	شَرْطُ الْبَيْعِ
u'شَرْطٌ بَيْعٌ':Added, #1: 1	شَرْطَ بَيْعِهِ
u'شَرْطٌ بَيْعٌ':Added, #2: 2	شَرْطِ الْبَيْعِ
u'شَرْطٌ بَيْعٌ':Added, #2: 2	شَرْطِ بَيْعِ
u'شَرْطٌ بَيْعٌ':Added, #5: 5	شَرْطَ الْبَيْعِ
u'شَرْطٌ بَيْعَةٌ':Added, #6: 6	شَرْطُ بَيْعِ
u'شَرْطٌ بَيِّنَةٌ':Added, #1: 1	شَرْطِ الْبَيْعَةِ
u'شَرْطٌ بَيِّنَةٌ':Added, #1: 1	شَرْطُ بَيِّنَةِ
u'شَرْطٌ تَأْثِيرٌ':Added, #1: 1	شَرْطِ بَيِّنَةٍ
u'شَرْطٌ تَأْثِيرٌ':Added, #1: 1	شَرْطَ تَأْثِيرِ
u'شَرَطَ تَأْجِيلٌ':Predicate, #2: 2	شَرْطُ تَأْثِيرِ
u'شَرْطٌ تَأْجِيلٌ':Added, #2: 2	شَرَطَ التَّأْجِيلَ
u'شَرْطٌ تَأْجِيلٌ':Added, #1: 1	شَرْطِ التَّأْجِيلِ
u'شَرَطَ تَأْخِيرٌ':Predicate, #2: 2	شَرْطُ التَّأْجِيلِ
u'شَرْطٌ تَأْخِيرٌ':Added, #1: 1	شَرَطَ تَأْخِيرَ
u'شَرْطٌ تَأَكُّدٌ':Added, #1: 1	شَرْطِ تَأْخِيرِ
u'شَرْطٌ تَبَع':Added, #1: 1	شَرْطَ تَأَكُّدِ
u'شَرْطٌ تَبَعِيّ':Added, #1: 1	شَرْطُ التَّبَعِيَّةِ
u'شَرْطٌ تَبَعِيَّة':Added, #1: 1	شَرْطُ التَّبَعِيَّةِ
u'شَرَطَ تَبْلِيغٌ':Predicate, #1: 1	شَرْطُ التَّبَعِيَّةِ
u'شَرْطٌ تَبْلِيغٌ':Added, #1: 1	شَرَطَ تَبْلِيغَ
u'شَرَطَ تِبْن':Predicate, #1: 1	شَرْطُ تَبْلِيغِ
u'شَرْطٌ تِبْن':Added, #1: 1	شَرَطَ التِّبْنَ
u'شَرَطَ تَتَابُعٌ':Predicate, #1: 1	شَرْطُ التِّبْنِ
u'شَرْطٌ تَتَابُعٌ':Added, #10: 10	شَرَطَ التَّتَابُعَ
u'شَرَطَ تَحَالُفٌ':Predicate, #1: 1	شَرْطِ التَّتَابُعِ
u'شَرْطٌ تَحَالُفٌ':Added, #1: 1	شَرَطَ التَّحَالُفَ
u'شَرْطٌ تَحَالُفٌ':Added, #2: 2	شَرْطُ التَّحَالُفِ
u'شَرَطَ تَحْدِيدٌ':Predicate, #3: 3	شَرْطَ التَّحَالُفِ
u'شَرْطٌ تَحْدِيدٌ':Added, #1: 1	شَرَطَ التَّحْدِيدَ
u'شَرْطٌ تَحْرِيمٌ':Added, #1: 1	شَرْطُ التَّحْدِيدِ
u'شَرْطٌ تَحْرِيمٌ':Added, #1: 1	شَرْطَ التَّحْرِيمِ
u'شَرْطٌ تَحَقُّقٌ':Added, #2: 2	شَرْطُ التَّحْرِيمِ
u'شَرْطٌ تَحْكِيمٌ':Added, #3: 3	شَرْطُ تَحَقُّقِ
u'شَرَطَ تَحَلُّلٌ':Predicate, #1: 1	شَرْطُ التَّحْكِيمِ
u'شَرْطٌ تَحَلُّلٌ':Added, #3: 3	شَرَطَ التَّحَلُّلَ
u'شَرْطٌ تَحْلِيف':Added, #1: 1	شَرْطِ التَّحَلُّلِ
u'شَرَطَ تَحْلِيلٌ':Predicate, #1: 1	شَرْطُ التَّحْلِيفِ
u'شَرْطٌ تَحْلِيلٌ':Added, #1: 1	شَرَطَ التَّحْلِيلَ
u'شَرْطٌ تَحَمُّلٌ':Added, #1: 1	شَرْطُ التَّحْلِيلِ
u'شَرْطٌ تَحَمُّلٌ':Added, #1: 1	شَرْطَ تَحَمُّلِ
u'شَرْطٌ تَخْرِيجٌ':Added, #1: 1	شَرْطُ تَحَمُّلِ
u'شَرْطٌ تَخْصِيصٌ':Added, #1: 1	شَرْطَ التَّخْرِيجِ
u'شَرْطٌ تَخْصِيصٌ':Added, #1: 1	شَرْطَ التَّخْصِيصِ
u'شَرْطٌ تَخْصِيصٌ':Added, #1: 1	شَرْطِ التَّخْصِيصِ
u'شَرْطٌ تَدْبِيرٌ':Added, #2: 2	شَرْطُ التَّخْصِيصِ
u'شَرْطٌ تَدْبِيرٌ':Added, #1: 1	شَرْطُ التَّدْبِيرِ
u'شَرْطٌ تَدْرِيسٌ':Added, #1: 1	شَرْطِ التَّدْبِيرِ
u'شَرَطَ تَرْتِيبٌ':Predicate, #1: 1	شَرْطِ التَّدْرِيسِ
u'شَرْطٌ تَرْتِيبٌ':Added, #1: 1	شَرَطَ التَّرْتِيبَ
u'شَرَطَ تَرْصِيعٌ':Predicate, #1: 1	شَرْطِ تَرْتِيبٍ
u'شَرَطَ تَرْكٌ':Predicate, #1: 1	شَرَطَ التَّرْصِيعَ
u'شَرْطٌ تَرْكٌ':Added, #4: 4	شَرَطَ تَرْكَ
u'شَرْطٌ تَرْكٌ':Added, #1: 1	شَرْطَ التَّرْكِ
u'شَرْطٌ تَرْكٌ':Added, #1: 1	شَرْطِ التَّرْكِ
u'شَرْطٌ تَرْكٌ':Added, #1: 1	شَرْطُ تَرْكِ
u'شَرْطٌ تَرْكِيبٌ':Added, #1: 1	شَرْطِ تَرْكِ
u'شَرَطَ تَزَوُّجٌ':Predicate, #1: 1	شَرْطِ التَّرْكِيبِ
u'شَرَطَ تَزَوُّجٌ':Predicate, #1: 1	شَرَطَ تَزَوُّجَ
u'شَرْطٌ تَزَوُّجٌ':Added, #3: 3	شَرَطَ التَّزَوُّجَ
u'شَرَطَ تَزْوِيجٌ':Predicate, #1: 1	شَرْطَ التَّزَوُّجِ
u'شَرْطٌ تَزْوِيجٌ':Added, #1: 1	شَرَطَ تَزْوِيجَ
u'شَرْطٌ تَسَبُّبٌ':Added, #1: 1	شَرْطَ تَزْوِيجِ
u'شَرْطٌ تَسْبِيحٌ':Added, #1: 1	شَرْطِ التَّسَبُّبِ
u'شَرَطَ تَسْلِيمٌ':Predicate, #1: 1	شَرْطِ التَّسْبِيحِ
u'شَرْطٌ تَسْلِيمٌ':Added, #4: 4	شَرَطَ التَّسْلِيمَ
u'شَرْطٌ تَسْلِيمٌ':Added, #1: 1	شَرْطِ التَّسْلِيمِ
u'شَرْطٌ تَسْلِيمٌ':Added, #1: 1	شَرْطُ تَسْلِيمِهِ
u'شَرْطٌ تَسْمِيَة':Added, #2: 2	شَرْطُ التَّسْلِيمِ
u'شَرْطٌ تَشْرِيك':Added, #1: 1	شَرْطَ تَسْمِيَةِ
u'شَرْطٌ تَصَدُّقٌ':Added, #1: 1	شَرْطِ التَّشْرِيكِ
u'شَرَطٌ تَصْدِيقٌ':Added, #1: 1	شَرْطِ تَصَدُّقِهِ
u'شَرَطَ تَصَرُّفٌ':Predicate, #1: 1	شَرَطَ تَصْدِيقِهِ
u'شَرْطٌ تَصَرُّفٌ':Added, #1: 1	شَرَطَ التَّصَرُّفَ
u'شَرْطٌ تَضْمِين':Added, #1: 1	شَرْطُ التَّصَرُّفِ
u'شَرْطٌ تَضْمِين':Added, #1: 1	شَرْطَ التَّضْمِينِ
u'شَرْطٌ تَضْمِينٌ':Added, #1: 1	شَرْطُ التَّضْمِينِ
u'شَرْطٌ تَعَارُضٌ':Added, #1: 1	شَرْطَ تَضْمِينِ
u'شَرْطٌ تَعْبِيرٌ':Added, #1: 1	شَرْطَ التَّعَارُضِ
u'شَرَطَ تَعْجِيل':Predicate, #1: 1	شَرْطَ التَّعْبِيرِ
u'شَرَطَ تَعْجِيل':Predicate, #4: 4	شَرَطَ تَعْجِيلَ
u'شَرْطٌ تَعْجِيل':Added, #5: 5	شَرَطَ التَّعْجِيلَ
u'شَرْطٌ تَعْجِيل':Added, #2: 2	شَرْطُ التَّعْجِيلِ
u'شَرْطٌ تَعْجِيل':Added, #4: 4	شَرْطِ التَّعْجِيلِ
u'شَرْطٌ تَعَدُّدٌ':Added, #6: 6	شَرْطَ التَّعْجِيلِ
u'شَرَطَ تَعْرِيفٌ':Predicate, #1: 1	شَرْطِ التَّعَدُّدِ
u'شَرْطٌ تَعْرِيفٌ':Added, #1: 1	شَرَطَ التَّعْرِيفَ
u'شَرْطٌ تَعَلُّقٌ':Added, #1: 1	شَرْطَ التَّعْرِيفِ
u'شَرْطٌ تَعْلِيلٌ':Added, #1: 1	شَرْطُ التَّعَلُّقِ
u'شَرْطٌ تَعْلِيمٌ':Added, #1: 1	شَرْطُ التَّعْلِيلِ
u'شَرْطٌ تَعْيِينٌ':Added, #1: 1	شَرْطِ تَعْلِيمِهِ
u'شَرْطٌ تَعْيِينٌ':Added, #1: 1	شَرْطَ التَّعْيِينِ
u'شَرْطٌ تَغْسِيلٌ':Added, #2: 2	شَرْطُ تَعْيِينِهِ
u'شَرْطٌ تَغْيِيرٌ':Added, #1: 1	شَرْطَ التَّغْسِيلِ
u'شَرَطَ تَفَاضُلٌ':Predicate, #1: 1	شَرْطِ التَّغْيِيرِ
u'شَرْطٌ تَفَاضُلٌ':Added, #3: 3	شَرَطَ التَّفَاضُلَ
u'شَرَطَ تَفاوُت':Predicate, #4: 4	شَرْطُ التَّفَاضُلِ
u'شَرْطٌ تَفاوُت':Added, #1: 1	شَرَطَ التَّفَاوُتَ
u'شَرَطَ تَفَرُّدٌ':Predicate, #1: 1	شَرْطِ التَّفَاوُتِ
u'شَرَطَ تَفْرِيقٌ':Predicate, #1: 1	شَرَطَ تَفَرُّدَ
u'شَرْطٌ تَفْرِيقٌ':Added, #1: 1	شَرَطَ التَّفْرِيقَ
u'شَرْطٌ تَفْرِيقٌ':Added, #1: 1	شَرْطَ التَّفْرِيقِ
u'شَرَطَ تَفْصِيلٌ':Predicate, #1: 1	شَرْطِ التَّفْرِيقِ
u'شَرْطٌ تَفْصِيلٌ':Added, #1: 1	شَرَطَ التَّفْصِيلَ
u'شَرْطٌ تَفْوِيت':Added, #1: 1	شَرْطُ التَّفْصِيلِ
u'شَرْطٌ تَقابُض':Added, #1: 1	شَرْطُ التَّفْوِيتِ
u'شَرْطٌ تَقَابُلٌ':Added, #2: 2	شَرْطُ التَّقَابُضِ
u'شَرَطَ تَقْديمٌ':Predicate, #1: 1	شَرْطِ التَّقَابُلِ
u'شَرْطٌ تَقْديمٌ':Added, #1: 1	شَرَطَ تَقْدِيمَ
u'شَرْطٌ تَقْديمٌ':Added, #1: 1	شَرْطُ التَّقْدِيمِ
u'شَرْطٌ تَقْديمٌ':Added, #1: 1	شَرْطِ التَّقْدِيمِ
u'شَرْطٌ تَقْديمٌ':Added, #1: 1	شَرْطِ تَقْدِيمِهِ
u'شَرَطَ تَقْريبٌ':Predicate, #2: 2	شَرْطِ تَقْدِيمِ
u'شَرَطَ تَقْريرٌ':Predicate, #1: 1	شَرَطَ التَّقْرِيبَ
u'شَرَطَ تَكْرارٌ':Predicate, #2: 2	شَرَطَ التَّقْرِيرَ
u'شَرْطٌ تَكْفيرٌ':Added, #1: 1	شَرَطَ التَّكْرَارَ
u'شَرْطٌ تَكْليفٌ':Added, #1: 1	شَرْطُ التَّكْفِيرِ
u'شَرْطٌ تَكْليفٌ':Added, #10: 10	شَرْطُ التَّكْلِيفِ
u'شَرْطٌ تَكْليفٌ':Added, #2: 2	شَرْطِ التَّكْلِيفِ
u'شَرْطٌ تَكْميلٌ':Added, #7: 7	شَرْطَ التَّكْلِيفِ
u'شَرْطٌ تَلَف':Added, #2: 2	شَرْطُ تَكْمِيلِ
u'شَرْطٌ تمام':Added, #1: 1	شَرْطَ التَّلَفِ
u'شَرْطٌ تَمامٌ':Added, #1: 1	شَرْطَ تَمَامِ
u'شَرْطٌ تمام':Added, #1: 1	شَرْطَ تَمَامِ
u'شَرْطٌ تَمامٌ':Added, #5: 5	شَرْطُ تَمَامِ
u'شَرْطٌ تَمَتُّعٌ':Added, #5: 5	شَرْطُ تَمَامِ
u'شَرْطٌ تَمَتُّعٌ':Added, #2: 2	شَرْطَ التَّمَتُّعِ
u'شَرْطٌ تَمَكُّنٌ':Added, #2: 2	شَرْطِ التَّمَتُّعِ
u'شَرْطٌ تَمْكِينٌ':Added, #1: 1	شَرْطُ التَّمَكُّنِ
u'شَرْطٌ تَمْكِينٌ':Added, #1: 1	شَرْطِ تَمْكِينِ
u'شَرْطٌ تَمَلُّك':Added, #1: 1	شَرْطَ تَمْكِينِهِ
u'شَرْطٌ تَمْييزٌ':Added, #1: 1	شَرْطِ التَّمَلُّكِ
u'شَرْطٌ تَمْييزٌ':Added, #1: 1	شَرْطُ التَّمْيِيزِ
u'شَرْطٌ تَمْييزٌ':Added, #1: 1	شَرْطَ تَمْيِيزٍ
u'شَرْطٌ تَمْييزٌ':Added, #1: 1	شَرْطُ تَمْيِيزٍ
u'شَرْطٌ تَمْييزٌ':Added, #2: 2	شَرْطَ التَّمْيِيزِ
u'شَرْطٌ تَمْييزٌ':Added, #3: 3	شَرْطِ التَّمْيِيزِ
u'شَرْطٌ تَنْجِيمٌ':Added, #3: 3	شَرْطِ تَمْيِيزٍ
u'شَرْطٌ تَنْقِيةٌ':Added, #2: 2	شَرْطِ التَّنْجِيمِ
u'شَرَطَ تَوَاتُرٌ':Predicate, #1: 1	شَرْطُ التَّنْقِيَةِ
u'شَرْطٌ تَوَاتُرٌ':Added, #1: 1	شَرَطَ التَّوَاتُرَ
u'شَرْطٌ تَوَاتُرٌ':Added, #1: 1	شَرْطَ التَّوَاتُرِ
u'شَرْطٌ تَوْبَةٌ':Added, #1: 1	شَرْطُ التَّوَاتُرِ
u'شَرْطٌ تَوْبَةٌ':Added, #1: 1	شَرْطُ التَّوْبَةِ
u'شَرْطٌ تَوْزِيعٌ':Added, #2: 2	شَرْطِ التَّوْبَةِ
u'شَرْطٌ تَوَقُّفٌ':Added, #1: 1	شَرْطُ التَّوْزِيعِ
u'شَرْطٌ تَوْقِيت':Added, #1: 1	شَرْطَ التَّوَقُّفِ
u'شَرْطٌ تَوَكُّلٌ':Added, #1: 1	شَرْطِ التَّوْقِيتِ
u'شَرْطٌ تَوْلِيَةٌ':Added, #1: 1	شَرْطُ التَّوَكُّلِ
u'شَرْطٌ تَوْلِيَةٌ':Added, #1: 1	شَرْطُ التَّوْلِيَةِ
u'شَرْطٌ تَيْبيسٌ':Added, #1: 1	شَرْطِ التَّوْلِيَةِ
u'شَرْطٌ تَيَمُّمٌ':Added, #1: 1	شَرْطِ التَّيْبِيسِ
u'شَرْطٌ تَيَمُّمٌ':Added, #1: 1	شَرْطَ التَّيَمُّمِ
u'شَرْطٌ تَيَمُّمٌ':Added, #1: 1	شَرْطُ التَّيَمُّمِ
u'شَرْطٌ ثَالِثٌ':Added, #2: 2	شَرْطِ التَّيَمُّمِ
u'شَرْطٌ ثُبُوتٌ':Added, #2: 2	شَرْطٍ ثَالِثٍ
u'شَرْطٌ ثُبُوتٌ':Added, #1: 1	شَرْطِ ثُبُوتِ
u'شَرْطٌ ثُبُوتٌ':Added, #2: 2	شَرْطَ ثُبُوتِهِ
u'شَرْطٌ ثُبُوتٌ':Added, #3: 3	شَرْطِ ثُبُوتِهِ
u'شَرَطَ ثَلاثُ':Predicate, #6: 6	شَرْطُ ثُبُوتِ
u'شَرْطٌ ثَلاثُ':Added, #1: 1	شَرَطَ الثَّلَاثَ
u'شَرَطَ ثَلاثَةٌ':Predicate, #1: 1	شَرْطُ الثَّلَاثِ
u'شَرَطَ ثَمَرَةٌ':Predicate, #1: 1	شَرَطَ ثَلَاثَةَ
u'شَرَطَ ثَمَرَةٌ':Predicate, #1: 1	شَرَطَ الثَّمَرَةَ
u'شَرْطٌ ثَمَرَةٌ':Added, #1: 1	شَرَطَ ثَمَرَةَ
u'شَرَطَ ثَمَنٌ':Predicate, #1: 1	شَرْطِ الثَّمَرَةِ
u'شَرْطٌ ثَمَنٌ':Added, #1: 1	شَرَطَ الثَّمَنَ
u'شَرْطٌ ثَوابٌ':Added, #1: 1	شَرْطِ الثَّمَنِ
u'شَرْطٌ ثَوابٌ':Added, #2: 2	شَرْطُ الثَّوَابِ
u'شَرْطٌ ثَوابٌ':Added, #2: 2	شَرْطِ الثَّوَابِ
u'شَرْطٌ جَارِحٌ':Added, #2: 2	شَرْطَ ثَوَابٍ
u'شَرْطٌ جَبِيرَة':Added, #1: 1	شَرْطُ الْجَارِحِ
u'شَرَطَ جِدٌّ':Predicate, #1: 1	شَرْطَ الْجَبِيرَةِ
u'شَرْطٌ جِدٌّ':Added, #1: 1	شَرَطَ جِدَّ
u'شَرَطَ جداد':Predicate, #1: 1	شَرْطُ الْجِدِّ
u'شَرْطٌ جَدَاوِلُ':Added, #1: 1	شَرَطَ الْجَدَادَ
u'شَرْطٌ جَذٌّ':Added, #1: 1	شَرْطِ الْجَدَاوِلِ
u'شَرْطٌ جَرَيان':Added, #3: 3	شَرْطِ الْجَذِّ
u'شَرَطَ جَزّ':Predicate, #3: 3	شَرْطُ جَرَيَانِ
u'شَرْطٌ جُزْءٌ':Added, #1: 1	شَرَطَ الْجَزَّ
u'شَرْطٌ جَزَاءٌ':Added, #1: 1	شَرْطُ جُزْءٍ
u'شَرْطٌ جُعَلٌ':Added, #1: 1	شَرْطُ الْجَزَاءِ
u'شَرْطٌ جُعَلٌ':Added, #1: 1	شَرْطُ الْجُعَلِ
u'شَرْطٌ جَمَاعَةٌ':Added, #1: 1	شَرْطِ الْجُعَلِ
u'شَرْطٌ جَمَاعَةٌ':Added, #1: 1	شَرْطُ الْجَمَاعَةِ
u'شَرَطَ جَمَالٌ':Predicate, #2: 2	شَرْطِ الْجَمَاعَةِ
u'شَرْطٌ جمع':Added, #1: 1	شَرَطَ الْجَمَالَ
u'شَرْطٌ جَمْعٌ':Added, #1: 1	شَرْطِ الْجَمْعِ
u'شَرْطٌ جمع':Added, #1: 1	شَرْطِ الْجَمْعِ
u'شَرْطٌ جَمْعٌ':Added, #2: 2	شَرْطُ الْجَمْعِ
u'شَرْطٌ جمعة':Added, #2: 2	شَرْطُ الْجَمْعِ
u'شَرْطٌ جُمُعَةٌ':Added, #2: 2	شَرْطَ الْجُمُعَةِ
u'شَرْطٌ جمعة':Added, #2: 2	شَرْطَ الْجُمُعَةِ
u'شَرْطٌ جُمُعَةٌ':Added, #3: 3	شَرْطِ الْجُمُعَةِ
u'شَرْطٌ جمعة':Added, #3: 3	شَرْطِ الْجُمُعَةِ
u'شَرْطٌ جُمُعَةٌ':Added, #9: 9	شَرْطُ الْجُمُعَةِ
u'شَرْطٌ جُمْلَةٌ':Added, #9: 9	شَرْطُ الْجُمُعَةِ
u'شَرْطٌ جَوَابٌ':Added, #1: 1	شَرْطِ جُمْلَةٍ
u'شَرْطٌ جَوَازٌ':Added, #1: 1	شَرْطَ جَوَابِهِ
u'شَرْطٌ جَوَازٌ':Added, #11: 11	شَرْطُ الْجَوَازِ
u'شَرْطٌ جَوَازٌ':Added, #11: 11	شَرْطِ جَوَازِ
u'شَرْطٌ جَوَازٌ':Added, #1: 1	شَرْطَ جَوَازِهِ
u'شَرْطٌ جَوَازٌ':Added, #23: 23	شَرْطُ جَوَازِ
u'شَرْطٌ جَوَازٌ':Added, #2: 2	شَرْطِ جَوَازِهِ
u'شَرْطٌ جَوَازٌ':Added, #6: 6	شَرْطِ الْجَوَازِ
u'شَرْطٌ جَوَازٌ':Added, #6: 6	شَرْطَ جَوَازِ
u'شَرْطٌ جَوَازٌ':Added, #6: 6	شَرْطُ جَوَازِهِ
u'شَرَطَ حارِثٌ':Subject, #7: 7	شَرْطَ الْجَوَازِ
u'شَرْطٌ حائِطٌ':Added, #1: 1	شَرَطَ الْحَارِثُ
u'شَرَطَ حَبٌّ':Predicate, #1: 1	شَرْطُ الْحَائِطِ
u'شَرْطٌ حَبْسٌ':Added, #1: 1	شَرَطَ الْحَبَّ
u'شَرَطَ حَجَّام':Subject, #1: 1	شَرْطِ حَبْسِهِ
u'شَرْطٌ حَدٌّ':Added, #1: 1	شَرَطَ الْحَجَّامُ
u'شَرْطٌ حَدٌّ':Added, #1: 1	شَرْطُ الْحَدِّ
u'شَرْطٌ حَدٌّ':Added, #1: 1	شَرْطَ حَدِّ
u'شَرْطٌ حَدٌّ':Added, #2: 2	شَرْطِ الْحَدِّ
u'شَرْطٌ حُرْمَةٌ':Added, #3: 3	شَرْطَ الْحَدِّ
u'شَرْطٌ حُرْمَةٌ':Added, #1: 1	شَرْطَ الْحُرْمَةِ
u'شَرْطٌ حُرْمَةٌ':Added, #1: 1	شَرْطُ الْحُرْمَةِ
u'شَرَطَ حُرِّيَّةٌ':Predicate, #1: 1	شَرْطُ حُرْمَةِ
u'شَرَطَ حُرِّيَّةٌ':Predicate, #1: 1	شَرَطَ حُرِّيَّةَ
u'شَرْطٌ حُرِّيَّةٌ':Added, #6: 6	شَرَطَ الْحُرِّيَّةَ
u'شَرْطٌ حُرِّيَّةٌ':Added, #1: 1	شَرْطَ الْحُرِّيَّةِ
u'شَرْطٌ حُرِّيَّةٌ':Added, #1: 1	شَرْطَ حُرِّيَّةٍ
u'شَرْطٌ حُرِّيَّةٌ':Added, #1: 1	شَرْطُ حُرِّيَّةٍ
u'شَرْطٌ حُرِّيَّةٌ':Added, #1: 1	شَرْطُ حُرِّيَّتِهِ
u'شَرْطٌ حِسٌّ':Added, #2: 2	شَرْطُ الْحُرِّيَّةِ
u'شَرْطٌ حَسَنٌ':Added, #1: 1	شَرْطِ الْحِسِّ
u'شَرَطَ حَصَادٌ':Predicate, #2: 2	شَرْطِ الْحَسَنِ
u'شَرْطٌ حَصَادٌ':Added, #1: 1	شَرَطَ الْحَصَادَ
u'شَرْطٌ حَصَادٌ':Added, #1: 1	شَرْطَ الْحَصَادِ
u'شَرْطٌ حَصَادٌ':Added, #1: 1	شَرْطُ الْحَصَادِ
u'شَرْطٌ حُصُول':Added, #1: 1	شَرْطِ الْحَصَادِ
u'شَرْطٌ حُصُول':Added, #1: 1	شَرْطَ حُصُولِ
u'شَرْطٌ حَضَانَةٌ':Added, #2: 2	شَرْطِ حُصُولِ
u'شَرْطٌ حَضَانَةٌ':Added, #1: 1	شَرْطُ الْحَضَانَةِ
u'شَرَطَ حضرة':Predicate, #1: 1	شَرْطُ حَضَانَةِ
u'شَرَطَ حَضْرَةٌ':Predicate, #2: 2	شَرَطَ حَضْرَةَ
u'شَرَطَ حِفْظٌ':Predicate, #2: 2	شَرَطَ حَضْرَةَ
u'شَرْطٌ حَقٌّ':Added, #2: 2	شَرَطَ الْحِفْظَ
u'شَرْطٌ حَقٌّ':Added, #1: 1	شَرْطَ حَقِّهِ
u'شَرَطَ حُكْمٌ':Predicate, #3: 3	شَرْطِ حَقِّهِ
u'شَرْطٌ حُكْمٌ':Added, #1: 1	شَرَطَ حُكْمَ
u'شَرْطٌ حُكْمٌ':Added, #1: 1	شَرْطِ حُكْمِ
u'شَرْطٌ حُكْمٌ':Added, #2: 2	شَرْطُ الْحُكْمِ
u'شَرْطٌ حُكْمٌ':Added, #5: 5	شَرْطَ الْحُكْمِ
u'شَرْطٌ حِلٌّ':Added, #5: 5	شَرْطِ الْحُكْمِ
u'شَرْطٌ حِلٌّ':Added, #1: 1	شَرْطَ الْحِلِّ
u'شَرْطٌ حِلٌّ':Added, #1: 1	شَرْطِ الْحِلِّ
u'شَرْطٌ حِلٌّ':Added, #1: 1	شَرْطِ حِلِّ
u'شَرْطٌ حِلٌّ':Added, #1: 1	شَرْطَ حِلِّهِ
u'شَرْطٌ حِلٌّ':Added, #2: 2	شَرْطُ الْحِلِّ
u'شَرْطٌ حِلٌّ':Added, #2: 2	شَرْطُ حِلِّهِ
u'شَرْطٌ حِلٌّ':Added, #2: 2	شَرْطِ حِلِّهِ
u'شَرَطَ حُلُولٌ':Predicate, #3: 3	شَرْطُ حِلِّ
u'شَرْطٌ حُلُولٌ':Added, #1: 1	شَرَطَ الْحُلُولَ
u'شَرَطَ حَمْلٌ':Predicate, #2: 2	شَرْطِ حُلُولِ
u'شَرْطٌ حَمْلٌ':Added, #4: 4	شَرَطَ الْحَمْلَ
u'شَرْطٌ حَمْلٌ':Added, #1: 1	شَرْطُ حَمْلِ
u'شَرْطٌ حَمْلٌ':Added, #1: 1	شَرْطِ حَمْلِ
u'شَرْطٌ حَمْلٌ':Added, #1: 1	شَرْطُ حَمْلِهِ
u'شَرَطَ حَمِيل':Subject, #2: 2	شَرْطُ الْحَمْلِ
u'شَرَطَ حَمِيل':Subject, #1: 1	شَرَطَ الْحَمِيلُ
u'شَرَطَ حِنْثٌ':Predicate, #1: 1	شَرَطَ حَمِيلُ
u'شَرْطٌ حِنْثٌ':Added, #1: 1	شَرَطَ الْحِنْثَ
u'شَرْطٌ حِنْثٌ':Added, #12: 12	شَرْطُ حِنْثِهِ
u'شَرْطٌ حِنْثٌ':Added, #19: 19	شَرْطَ حِنْثِهِ
u'شَرْطٌ حِنْثٌ':Added, #24: 24	شَرْطِ الْحِنْثِ
u'شَرْطٌ حِنْثٌ':Added, #3: 3	شَرْطِ حِنْثِهِ
u'شَرْطٌ حِنْثٌ':Added, #42: 42	شَرْطُ الْحِنْثِ
u'شَرَطَ حَنَفِيَّةٌ':Subject, #45: 45	شَرْطَ الْحِنْثِ
u'شَرْطٌ حَوَالَةٌ':Added, #1: 1	شَرَطَ الْحَنَفِيَّةُ
u'شَرْطٌ حَوَالَةٌ':Added, #1: 1	شَرْطَ الْحَوَالَةِ
u'شَرْطٌ حَوْزٌ':Added, #2: 2	شَرْطُ الْحَوَالَةِ
u'شَرْطٌ حول':Added, #1: 1	شَرْطُ الْحَوْزِ
u'شَرْطٌ حَوْلٌ':Added, #1: 1	شَرْطُ الْحَوْلِ
u'شَرْطٌ حَيَاةٌ':Added, #1: 1	شَرْطُ الْحَوْلِ
u'شَرْطٌ خَارِجٌ':Added, #1: 1	شَرْطَ الْحَيَاةِ
u'شَرَطَ خَبَرٌ':Predicate, #1: 1	شَرْطِ الْخَارِجِ
u'شَرَطَ خَبَر':Predicate, #1: 1	شَرَطَ خَبَرَ
u'شَرَطَ خدمة':Predicate, #1: 1	شَرَطَ خَبَرَ
u'شَرَطَ خِدْمَةٌ':Predicate, #1: 1	شَرَطَ الْخِدْمَةَ
u'شَرَطَ خراج':Predicate, #1: 1	شَرَطَ الْخِدْمَةَ
u'شَرَطَ خَرَاجٌ':Predicate, #1: 1	شَرَطَ الْخَرَاجَ
u'شَرْطٌ خراج':Added, #1: 1	شَرَطَ الْخَرَاجَ
u'شَرْطٌ خَرَاجٌ':Added, #1: 1	شَرْطُ خَرَاجٍ
u'شَرْطٌ خرق':Added, #1: 1	شَرْطُ خَرَاجٍ
u'شَرْطٌ خَرْقٌ':Added, #1: 1	شَرْطِ الْخَرْقِ
u'شَرَطَ خُرُوجٌ':Predicate, #1: 1	شَرْطِ الْخَرْقِ
u'شَرْطٌ خُرُوجٌ':Added, #7: 7	شَرَطَ الْخُرُوجَ
u'شَرْطٌ خُرُوجٌ':Added, #1: 1	شَرْطَ الْخُرُوجِ
u'شَرْطٌ خُرُوجٌ':Added, #1: 1	شَرْطُ الْخُرُوجِ
u'شَرْطٌ خُرُوجٌ':Added, #1: 1	شَرْطَ خُرُوجِهِ
u'شَرْطٌ خطبة':Added, #1: 1	شَرْطِ خُرُوجِهِ
u'شَرْطٌ خُطْبَةٌ':Added, #1: 1	شَرْطُ الْخُطْبَةِ
u'شَرْطٌ خُفٌّ':Added, #1: 1	شَرْطُ الْخُطْبَةِ
u'شَرَطَ خلاص':Predicate, #1: 1	شَرْطُ الْخُفِّ
u'شَرَطَ خَلاَصٌ':Predicate, #1: 1	شَرَطَ الْخَلاَصَ
u'شَرَطَ خِلاَفٌ':Predicate, #1: 1	شَرَطَ الْخَلاَصَ
u'شَرْطٌ خلط':Added, #2: 2	شَرَطَ خِلَافَ
u'شَرَطَ خَلَفٌ':Predicate, #1: 1	شَرْطُ الْخَلْطِ
u'شَرَطَ خَلَفٌ':Predicate, #1: 1	شَرَطَ الْخَلَفَ
u'شَرْطٌ خَلَفٌ':Added, #1: 1	شَرَطَ خَلَفَ
u'شَرْطٌ خَلَفٌ':Added, #1: 1	شَرْطَ الْخَلَفِ
u'شَرْطٌ خَلَفٌ':Added, #1: 1	شَرْطِ خَلَفِهِ
u'شَرْطٌ خَلْفِيٌّ':Added, #3: 3	شَرْطِ الْخَلَفِ
u'شَرَطَ خُلُوصٌ':Predicate, #5: 5	شَرْطَ الْخَلْفِيَّةِ
u'شَرْطٌ خُلُوصٌ':Added, #2: 2	شَرَطَ خُلُوصَ
u'شَرْطٌ خَلِيط':Added, #2: 2	شَرْطِ الْخُلُوصِ
u'شَرْطٌ خَلِيفَةٌ':Added, #1: 1	شَرْطِ الْخَلِيطَيْنِ
u'شَرَطَ خيار':Predicate, #1: 1	شَرْطَ الْخَلِيفَةِ
u'شَرَطَ خِيَارٌ':Predicate, #4: 4	شَرَطَ خِيَارَ
u'شَرَطَ خيار':Predicate, #4: 4	شَرَطَ خِيَارَ
u'شَرَطَ خِيَارٌ':Predicate, #53: 53	شَرَطَ الْخِيَارَ
u'شَرَطَ خيار':Subject, #53: 53	شَرَطَ الْخِيَارَ
u'شَرَطَ خِيَارٌ':Subject, #1: 1	شَرَطَ الْخِيَارُ
u'شَرْطٌ خيار':Added, #1: 1	شَرَطَ الْخِيَارُ
u'شَرْطٌ خِيَارٌ':Added, #15: 15	شَرْطَ الْخِيَارِ
u'شَرَطٌ خيار':Added, #15: 15	شَرْطَ الْخِيَارِ
u'شَرَطٌ خِيَارٌ':Added, #1: 1	شَرَطَ الْخِيَارِ
u'شَرْطٌ خيار':Added, #1: 1	شَرَطَ الْخِيَارِ
u'شَرْطٌ خيار':Added, #1: 1	شَرْطَ خِيَارٍ
u'شَرْطٌ خيار':Added, #1: 1	شَرْطُ خِيَارِ
u'شَرْطٌ خِيَارٌ':Added, #1: 1	شَرْطِ خِيَارٍ
u'شَرْطٌ خِيَارٌ':Added, #1: 1	شَرْطَ خِيَارٍ
u'شَرْطٌ خِيَارٌ':Added, #1: 1	شَرْطُ خِيَارِ
u'شَرْطٌ خيار':Added, #1: 1	شَرْطِ خِيَارٍ
u'شَرْطٌ خِيَارٌ':Added, #2: 2	شَرْطِ خِيَارِ
u'شَرْطٌ خيار':Added, #2: 2	شَرْطِ خِيَارِ
u'شَرْطٌ خِيَارٌ':Added, #46: 46	شَرْطِ الْخِيَارِ
u'شَرْطٌ خيار':Added, #46: 46	شَرْطِ الْخِيَارِ
u'شَرْطٌ خِيَارٌ':Added, #48: 48	شَرْطُ الْخِيَارِ
u'شَرْطٌ خيار':Added, #48: 48	شَرْطُ الْخِيَارِ
u'شَرْطٌ خِيَارٌ':Added, #4: 4	شَرْطُ خِيَارٍ
u'شَرَطَ دَابَّةٌ':Predicate, #4: 4	شَرْطُ خِيَارٍ
u'شَرَطَ دُخُولٌ':Predicate, #1: 1	شَرَطَ الدَّابَّةَ
u'شَرْطٌ دُخُولٌ':Added, #2: 2	شَرَطَ دُخُولَ
u'شَرْطٌ دُخُولٌ':Added, #2: 2	شَرْطَ الدُّخُولِ
u'شَرْطٌ دُخُولٌ':Added, #2: 2	شَرْطُ دُخُولِهِ
u'شَرَطَ دفع':Predicate, #2: 2	شَرْطِ دُخُولِهِ
u'شَرَطَ دَفْعٌ':Predicate, #2: 2	شَرَطَ الدَّفْعَ
u'شَرْطٌ دَلالَةٌ':Added, #2: 2	شَرَطَ الدَّفْعَ
u'شَرْطٌ دَلالَةٌ':Added, #1: 1	شَرْطَ الدَّلَالَةِ
u'شَرْطٌ دَلالَةٌ':Added, #1: 1	شَرْطِ الدَّلَالَةِ
u'شَرْطٌ دَلالَةٌ':Added, #1: 1	شَرْطَ دَلَالَةِ
u'شَرْطٌ دَليلٌ':Added, #1: 1	شَرْطَ دَلَالَتِهِ
u'شَرْطٌ دَليلٌ':Added, #1: 1	شَرْطَ الدَّلِيلِ
u'شَرْطٌ دَليلٌ':Added, #1: 1	شَرْطِ الدَّلِيلِ
u'شَرْطٌ دَناءةٌ':Added, #1: 1	شَرْطَ دَلِيلِ
u'شَرْطٌ دَوامٌ':Added, #1: 1	شَرْطُ الدَّنَاءَةِ
u'شَرْطٌ دَوامٌ':Added, #1: 1	شَرْطُ الدَّوَامِ
u'شَرْطٌ دَوامٌ':Added, #1: 1	شَرْطَ دَوَامِ
u'شَرَطَ دَيْنٌ':Subject, #1: 1	شَرْطِ دَوَامِ
u'شَرْطٌ دَيْنٌ':Added, #2: 2	شَرَطَ دَيْنٌ
u'شَرَطَ ذَرْعٌ':Predicate, #1: 1	شَرْطِ الدَّيْنِ
u'شَرْطٌ ذَكاةٌ':Added, #1: 1	شَرَطَ الذَّرْعَ
u'شَرْطٌ ذَكاةٌ':Added, #1: 1	شَرْطُ الذَّكَاةِ
u'شَرَطَ ذكر':Predicate, #1: 1	شَرْطِ الذَّكَاةِ
u'شَرَطَ ذِكْرٌ':Predicate, #1: 1	شَرَطَ ذِكْرَ
u'شَرْطٌ ذكر':Added, #1: 1	شَرَطَ ذِكْرَ
u'شَرْطٌ ذِكْرٌ':Added, #2: 2	شَرْطِ ذِكْرِ
u'شَرَطَ ذَوْقٌ':Predicate, #2: 2	شَرْطِ ذِكْرِ
u'شَرْطٌ رابع':Added, #1: 1	شَرَطَ ذَوْقَ
u'شَرْطٌ رَابِعٌ':Added, #1: 1	شَرْطٍ رَابِعٍ
u'شَرَطَ رَاهِنٌ':Subject, #1: 1	شَرْطٍ رَابِعٍ
u'شَرَطَ رَبُّ':Subject, #4: 4	شَرَطَ الرَّاهِنُ
u'شَرْطٌ رَبُّ':Added, #14: 14	شَرَطَ رَبُّ
u'شَرَطَ رِبْحٌ':Predicate, #1: 1	شَرْطَ رَبِّ
u'شَرَطَ رِبْحٌ':Predicate, #1: 1	شَرَطَ رِبْحَ
u'شَرْطٌ رِبْحٌ':Added, #5: 5	شَرَطَ الرِّبْحَ
u'شَرْطٌ رِبْحٌ':Added, #1: 1	شَرْطُ الرِّبْحِ
u'شَرَطَ رُبْعٌ':Predicate, #3: 3	شَرْطِ الرِّبْحِ
u'شَرْطٌ رَبِيبَةٌ':Added, #1: 1	شَرَطَ الرُّبْعَ
u'شَرَطَ رجعة':Predicate, #1: 1	شَرْطَ الرَّبِيبَةِ
u'شَرَطَ رَجْعَةٌ':Predicate, #1: 1	شَرَطَ الرَّجْعَةَ
u'شَرْطٌ رجعة':Added, #1: 1	شَرَطَ الرَّجْعَةَ
u'شَرْطٌ رجعة':Added, #1: 1	شَرْطَ الرَّجْعَةِ
u'شَرْطٌ رَجْعَةٌ':Added, #1: 1	شَرْطِ الرَّجْعَةِ
u'شَرْطٌ رَجْعَةٌ':Added, #1: 1	شَرْطَ الرَّجْعَةِ
u'شَرْطٌ رجعة':Added, #1: 1	شَرْطِ الرَّجْعَةِ
u'شَرْطٌ رَجْعَةٌ':Added, #1: 1	شَرْطُ رَجْعَةٍ
u'شَرْطٌ رجعة':Added, #1: 1	شَرْطُ رَجْعَةٍ
u'شَرْطٌ رَجْعَةٌ':Added, #2: 2	شَرْطُ الرَّجْعَةِ
u'شَرْطٌ رَجْمٌ':Added, #2: 2	شَرْطُ الرَّجْعَةِ
u'شَرْطٌ رَجْمٌ':Added, #1: 1	شَرْطِ الرَّجْمِ
u'شَرَطَ رُجُوعٌ':Predicate, #3: 3	شَرْطُ الرَّجْمِ
u'شَرْطٌ رُجُوعٌ':Added, #15: 15	شَرَطَ الرُّجُوعَ
u'شَرْطٌ رُجُوعٌ':Added, #1: 1	شَرْطَ الرُّجُوعِ
u'شَرْطٌ رُجُوعٌ':Added, #4: 4	شَرْطُ الرُّجُوعِ
u'شَرْطٌ رُخْصَةٌ':Added, #8: 8	شَرْطِ الرُّجُوعِ
u'شَرَطَ رَدٌّ':Predicate, #1: 1	شَرْطِ الرُّخْصَةِ
u'شَرْطٌ رَدٌّ':Added, #4: 4	شَرَطَ رَدَّ
u'شَرْطٌ رَدٌّ':Added, #1: 1	شَرْطَ الرَّدِّ
u'شَرْطٌ رَدٌّ':Added, #1: 1	شَرْطِ الرَّدِّ
u'شَرْطٌ رَدٌّ':Added, #1: 1	شَرْطُ رَدِّ
u'شَرْطٌ رَدٌّ':Added, #1: 1	شَرْطِ رَدِّ
u'شَرَطَ رَسُولٌ':Subject, #1: 1	شَرْطُ رَدِّهِ
u'شَرَطَ رَسُولٌ':Subject, #2: 2	شَرَطَ الرَّسُولُ
u'شَرْطٌ رَقَبَةٌ':Added, #2: 2	شَرَطَ رَسُولُ
u'شَرْطٌ رُكْنٌ':Added, #1: 1	شَرْطُ الرَّقَبَةِ
u'شَرْطٌ رُكْن':Added, #1: 1	شَرْطَ الرُّكْنِ
u'شَرْطٌ رَمَلٌ':Added, #1: 1	شَرْطَ الرُّكْنِ
u'شَرَطَ رَهْنٌ':Predicate, #1: 1	شَرْطِ الرَّمَلِ
u'شَرَطَ رَهْنٌ':Predicate, #1: 1	شَرَطَ الرَّهْنَ
u'شَرْطٌ رَهْنٌ':Added, #1: 1	شَرَطَ رَهْنَ
u'شَرْطٌ رَهْنٌ':Added, #1: 1	شَرْطِ رَهْنٍ
u'شَرْطٌ رَهْنٌ':Added, #1: 1	شَرْطِ رَهْنِ
u'شَرْطٌ رَهْنٌ':Added, #2: 2	شَرْطَ الرَّهْنِ
u'شَرْطٌ رَهْنٌ':Added, #2: 2	شَرْطِ الرَّهْنِ
u'شَرْطٌ رَهْنٌ':Added, #2: 2	شَرْطُ رَهْنِ
u'شَرْطٌ رِوايَةٌ':Added, #4: 4	شَرْطُ الرَّهْنِ
u'شَرْطٌ رِوايَةٌ':Added, #1: 1	شَرْطَ الرِّوَايَةِ
u'شَرَطَ رُؤْيَةٌ':Predicate, #1: 1	شَرْطِ الرِّوَايَةِ
u'شَرْطٌ رُؤْيَةٌ':Added, #3: 3	شَرَطَ رُؤْيَةَ
u'شَرَطَ زائِدٌ':Predicate, #1: 1	شَرْطُ رُؤْيَةِ
u'شَرْطٌ زائِدٌ':Added, #1: 1	شَرَطَ الزَّائِدَ
u'شَرْطٌ زَرْعٌ':Added, #8: 8	شَرْطٍ زَائِدٍ
u'شَرْطٌ زَكاةٌ':Added, #1: 1	شَرْطُ زَرْعِ
u'شَرْطٌ زَكاةٌ':Added, #1: 1	شَرْطُ الزَّكَاةِ
u'شَرْطٌ زَكاةٌ':Added, #1: 1	شَرْطِ الزَّكَاةِ
u'شَرْطٌ زَكاةٌ':Added, #1: 1	شَرْطِ زَكَاةِ
u'شَرْطٌ زَوالٌ':Added, #1: 1	شَرْطُ زَكَاتِهِ
u'شَرْطٌ زَوالٌ':Added, #1: 1	شَرْطَ زَوَالِ
u'شَرَطَ زَوْجٌ':Subject, #1: 1	شَرْطُ زَوَالِ
u'شَرَطَ زَوْجٌ':Subject, #2: 2	شَرَطَ زَوْجُ
u'شَرْطٌ زَوْجٌ':Added, #6: 6	شَرَطَ الزَّوْجُ
u'شَرَطَ زِيادَةٌ':Predicate, #1: 1	شَرْطَ الزَّوْجِ
u'شَرَطَ زِيادَةٌ':Predicate, #1: 1	شَرَطَ الزِّيَادَةَ
u'شَرْطٌ زِيادَةٌ':Added, #4: 4	شَرَطَ زِيَادَةَ
u'شَرْطٌ زِيادَةٌ':Added, #3: 3	شَرْطِ الزِّيَادَةِ
u'شَرْطٌ سائِل':Added, #3: 3	شَرْطُ زِيَادَةٍ
u'شَرْطٌ سَائِلٌ':Added, #1: 1	شَرْطِ السَّائِلِ
u'شَرْطٌ سَبَبٌ':Added, #1: 1	شَرْطِ السَّائِلِ
u'شَرْطٌ سَبَبٌ':Added, #1: 1	شَرْطُ السَّبَبِ
u'شَرْطٌ سَبَبٌ':Added, #1: 1	شَرْطِ السَّبَبِ
u'شَرْطٌ سَبَبِيَّةٌ':Added, #1: 1	شَرْطُ سَبَبِهِ
u'شَرْطٌ سَبَبِيَّةٌ':Added, #1: 1	شَرْطُ سَبَبِيَّتِهِ
u'شَرَطَ سَبْعٌ':Predicate, #1: 1	شَرْطِ سَبَبِيَّتِهِ
u'شَرَطَ سَبَقٌ':Predicate, #1: 1	شَرَطَ السَّبْعَ
u'شَرْطٌ سَبْقٌ':Added, #1: 1	شَرَطَ السَّبَقَ
u'شَرْطٌ سُجُودٌ':Added, #1: 1	شَرْطُ السَّبْقِ
u'شَرَطَ سِرْقِين':Predicate, #1: 1	شَرْطِ السُّجُودِ
u'شَرْطٌ سَعَةٌ':Added, #1: 1	شَرَطَ السِّرْقِينَ
u'شَرَطَ سُقُوطٌ':Predicate, #1: 1	شَرْطَ السَّعَةِ
u'شَرْطٌ سُقُوطٌ':Added, #1: 1	شَرَطَ سُقُوطَ
u'شَرْطٌ سُقُوطٌ':Added, #1: 1	شَرْطُ السُّقُوطِ
u'شَرَطَ سَقْيٌ':Predicate, #2: 2	شَرْطِ السُّقُوطِ
u'شَرْطٌ سَقْيٌ':Added, #4: 4	شَرَطَ السَّقْيَ
u'شَرَطَ سَلاَمَةٌ':Predicate, #1: 1	شَرْطَ السَّقْيِ
u'شَرْطٌ سَلاَمَةٌ':Added, #3: 3	شَرَطَ السَّلَامَةَ
u'شَرَطَ سُلْطَانٌ':Subject, #1: 1	شَرْطِ سَلَامَتِهِ
u'شَرْطٌ سَلَفٌ':Added, #1: 1	شَرَطَ السُّلْطَانُ
u'شَرْطٌ سَلَفٌ':Added, #1: 1	شَرْطِ سَلَفِ
u'شَرْطٌ سَلَمٌ':Added, #2: 2	شَرْطُ السَّلَفِ
u'شَرْطٌ سَلَمٌ':Added, #1: 1	شَرْطَ السَّلَمِ
u'شَرْطٌ سَلَمٌ':Added, #3: 3	شَرْطِ السَّلَمِ
u'شَرْطٌ سَمَاعٌ':Added, #5: 5	شَرْطُ السَّلَمِ
u'شَرْطٌ سَمَاعٌ':Added, #2: 2	شَرْطِ سَمَاعِ
u'شَرْطٌ سُنِّيٌّ':Added, #3: 3	شَرْطَ سَمَاعِ
u'شَرَطَ سَيِّدٌ':Subject, #1: 1	شَرْطُ السُّنِّيَّةِ
u'شَرَطَ سَيَلانٌ':Predicate, #1: 1	شَرَطَ السَّيِّدُ
u'شَرْطٌ سَيَلانٌ':Added, #1: 1	شَرَطَ سَيَلَانَ
u'شَرْطٌ شُبْهَةٌ':Added, #1: 1	شَرْطِ السَّيَلَانِ
u'شَرَطَ شِرَاءٌ':Predicate, #1: 1	شَرْطُ الشُّبْهَةِ
u'شَرَطٌ شَرْطٌ':Added, #3: 3	شَرَطَ الشِّرَاءَ
u'شَرَطٌ شَرْطٌ':Added, #1: 1	شَرَطَ الشَّرْطَيْنِ
u'شَرْطٌ شَرْطٌ':Added, #1: 1	شَرَطَ شَرْطَيْنِ
u'شَرَطَ شَرْعٌ':Subject, #2: 2	شَرْطُ الشَّرْطِ
u'شَرْطٌ شَرْعٌ':Added, #1: 1	شَرَطَ الشَّرْعُ
u'شَرْطٌ شركة':Added, #5: 5	شَرْطِ الشَّرْعِ
u'شَرْطٌ شَرِكَةٌ':Added, #1: 1	شَرْطِ شَرِكَةٍ
u'شَرْطٌ شُمُول':Added, #1: 1	شَرْطِ شَرِكَةٍ
u'شَرَطَ شَهَادَةٌ':Predicate, #1: 1	شَرْطَ شُمُولِ
u'شَرْطٌ شَهَادَةٌ':Added, #2: 2	شَرَطَ الشَّهَادَةَ
u'شَرْطٌ شَهَادَةٌ':Added, #1: 1	شَرْطَ الشَّهَادَةِ
u'شَرْطٌ شَهَادَةٌ':Added, #1: 1	شَرْطُ الشَّهَادَةِ
u'شَرْطٌ شَهَادَةٌ':Added, #1: 1	شَرْطِ الشَّهَادَةِ
u'شَرْطٌ شَهَادَةٌ':Added, #1: 1	شَرْطُ شَهَادَةِ
u'شَرْطٌ شَهْوَةٌ':Added, #1: 1	شَرْطِ شَهَادَةِ
u'شَرْطٌ شُهُودٌ':Added, #1: 1	شَرْطِ الشَّهْوَةِ
u'شَرْطٌ شَيْءٌ':Added, #2: 2	شَرْطِ الشُّهُودِ
u'شَرْطٌ شَيْءٌ':Added, #1: 1	شَرْطُ الشَّيْءِ
u'شَرْطٌ شَيْءٌ':Added, #1: 1	شَرْطِ الشَّيْءِ
u'شَرْطٌ شَيْءٌ':Added, #1: 1	شَرْطِ شَيْءٍ
u'شَرْطٌ شَيْءٌ':Added, #2: 2	شَرْطُ شَيْءٍ
u'شَرَطَ شَيْخٌ':Subject, #5: 5	شَرْطَ الشَّيْءِ
u'شَرْطٌ شَيْخٌ':Added, #2: 2	شَرَطَ الشَّيْخُ
u'شَرَطَ صَاحِبٌ':Subject, #113: 113	شَرْطِ الشَّيْخَيْنِ
u'شَرْطٌ صَالِحٌ':Added, #4: 4	شَرَطَ صَاحِبُ
u'شَرْطٌ صَالِح':Added, #1: 1	شَرْطٍ صَالِحٍ
u'شَرْطٌ صَبْغٌ':Added, #1: 1	شَرْطٍ صَالِحٍ
u'شَرْطٌ صحبة':Added, #1: 1	شَرْطُ صَبْغِهِ
u'شَرْطٌ صُحْبَةٌ':Added, #1: 1	شَرْطُ الصُّحْبَةِ
u'شَرَطَ صِحَّةٌ':Predicate, #1: 1	شَرْطُ الصُّحْبَةِ
u'شَرْطٌ صِحَّةٌ':Added, #1: 1	شَرَطَ الصِّحَّةَ
u'شَرْطٌ صِحَّةٌ':Added, #13: 13	شَرْطُ الصِّحَّةِ
u'شَرْطٌ صِحَّةٌ':Added, #1: 1	شَرْط الصِّحَّةِ
u'شَرْطٌ صِحَّةٌ':Added, #1: 1	شَرْطَ صِحَّتِهِ
u'شَرْطٌ صِحَّةٌ':Added, #2: 2	شَرْطَ الصِّحَّةِ
u'شَرْطٌ صِحَّةٌ':Added, #2: 2	شَرْطَ صِحَّةٍ
u'شَرْطٌ صِحَّةٌ':Added, #2: 2	شَرْطُ صِحَّةٍ
u'شَرْطٌ صِحَّةٌ':Added, #32: 32	شَرْطَ صِحَّةِ
u'شَرْطٌ صِحَّةٌ':Added, #42: 42	شَرْطِ صِحَّةِ
u'شَرْطٌ صِحَّةٌ':Added, #44: 44	شَرْطُ صِحَّةِ
u'شَرْطٌ صِحَّةٌ':Added, #5: 5	شَرْطِ صِحَّتِهِ
u'شَرْطٌ صِحَّةٌ':Added, #7: 7	شَرْطِ الصِّحَّةِ
u'شَرْطٌ صَحِيحٌ':Added, #7: 7	شَرْطُ صِحَّتِهِ
u'شَرْطٌ صَحِيحٌ':Added, #2: 2	شَرْطِ الصَّحِيحَيْنِ
u'شَرَطَ صداق':Predicate, #8: 8	شَرْطِ الصَّحِيحِ
u'شَرَطَ صَدَاقٌ':Predicate, #2: 2	شَرَطَ الصَّدَاقَ
u'شَرْطٌ صداق':Added, #2: 2	شَرَطَ الصَّدَاقَ
u'شَرْطٌ صَدَاقٌ':Added, #1: 1	شَرْطِ الصَّدَاقِ
u'شَرْطٌ صدق':Added, #1: 1	شَرْطِ الصَّدَاقِ
u'شَرْطٌ صِدْقٌ':Added, #2: 2	شَرْطُ صِدْقِ
u'شَرْطٌ صدقة':Added, #2: 2	شَرْطُ صِدْقِ
u'شَرْطٌ صَدَقَةٌ':Added, #1: 1	شَرْطُ صَدَقَةِ
u'شَرَطَ صَرْفٌ':Predicate, #1: 1	شَرْطُ صَدَقَةِ
u'شَرَطَ صَرْف':Predicate, #1: 1	شَرَطَ صَرْفَ
u'شَرْطٌ صَرْفٌ':Added, #1: 1	شَرَطَ صَرْفَ
u'شَرْطٌ صَرْف':Added, #1: 1	شَرْطَ الصَّرْفِ
u'شَرْطٌ صَرْفٌ':Added, #1: 1	شَرْطَ الصَّرْفِ
u'شَرْطٌ صَرْف':Added, #1: 1	شَرْطِ صَرْفِ
u'شَرَطَ صِغَرٌ':Predicate, #1: 1	شَرْطِ صَرْفِ
u'شَرَطَ صِفَةٌ':Predicate, #1: 1	شَرَطَ صِغَرَ
u'شَرْطٌ صَلاَةٌ':Added, #1: 1	شَرَطَ صِفَةَ
u'شَرْطٌ صَلاَةٌ':Added, #11: 11	شَرْطُ الصَّلَاةِ
u'شَرْطٌ صَلاَةٌ':Added, #11: 11	شَرْطِ الصَّلَاةِ
u'شَرْطٌ صَلاَةٌ':Added, #1: 1	شَرْطُ صَلَاةٍ
u'شَرْطٌ صَلاَةٌ':Added, #1: 1	شَرْطُ صَلَاةِ
u'شَرْطٌ صِلَةٌ':Added, #4: 4	شَرْطَ الصَّلَاةِ
u'شَرْطٌ صَوْمٌ':Added, #1: 1	شَرْطَ الصِّلَةِ
u'شَرْطٌ صَوْمٌ':Added, #1: 1	شَرْطَ الصَّوْمِ
u'شَرْطٌ صَوْمٌ':Added, #1: 1	شَرْطِ الصَّوْمِ
u'شَرَطَ ضَامِنٌ':Subject, #2: 2	شَرْطُ الصَّوْمِ
u'شَرْطٌ ضَامِنٌ':Added, #1: 1	شَرَطَ الضَّامِنُ
u'شَرَطَ ضَرَرٌ':Predicate, #1: 1	شَرْطُ الضَّامِنِ
u'شَرَطَ ضِعْفٌ':Predicate, #1: 1	شَرَطَ الضَّرَرَ
u'شَرَطَ ضَمٌّ':Predicate, #1: 1	شَرَطَ الضِّعْفَ
u'شَرْطٌ ضَمٌّ':Added, #1: 1	شَرَطَ ضَمَّ
u'شَرْطٌ ضَمٌّ':Added, #1: 1	شَرْطِ الضَّمِّ
u'شَرَطَ ضَمَانٌ':Predicate, #1: 1	شَرْطُ ضَمِّهِ
u'شَرْطٌ ضَمَانٌ':Added, #3: 3	شَرَطَ الضَّمَانَ
u'شَرْطٌ ضَمَانٌ':Added, #1: 1	شَرْطَ ضَمَانِ
u'شَرْطٌ ضَمَانٌ':Added, #1: 1	شَرْطُ ضَمَانِ
u'شَرْطٌ ضَمَانٌ':Added, #1: 1	شَرْطِ ضَمَانِ
u'شَرْطٌ ضَمَانٌ':Added, #2: 2	شَرْطَ الضَّمَانِ
u'شَرْطٌ ضَمَانٌ':Added, #2: 2	شَرْطُ الضَّمَانِ
u'شَرَطَ ضِيَافَةٌ':Predicate, #5: 5	شَرْطِ الضَّمَانِ
u'شَرَطَ طَائِرٌ':Predicate, #2: 2	شَرَطَ الضِّيَافَةَ
u'شَرْطٌ طحن':Added, #5: 5	شَرَطَ الطَّائِرَ
u'شَرَطَ طَلاَقٌ':Predicate, #1: 1	شَرْطَ الطَّحْنِ
u'شَرْطٌ طَلاَقٌ':Added, #1: 1	شَرَطَ الطَّلَاقَ
u'شَرْطٌ طَلاَقٌ':Added, #10: 10	شَرْطَ الطَّلَاقِ
u'شَرْطٌ طَلاَقٌ':Added, #10: 10	شَرْطُ الطَّلَاقِ
u'شَرْطٌ طَلاَقٌ':Added, #10: 10	شَرْطِ الطَّلَاقِ
u'شَرْطٌ طَلاَقٌ':Added, #1: 1	شَرْطِ طَلَاقِ
u'شَرَطَ طلب':Predicate, #4: 4	شَرْطُ طَلَاقِ
u'شَرَطَ طَلَبٌ':Predicate, #1: 1	شَرَطَ طَلَبَ
u'شَرْطٌ طلب':Added, #1: 1	شَرَطَ طَلَبَ
u'شَرْطٌ طَلَبٌ':Added, #1: 1	شَرْطَ الطَّلَبِ
u'شَرْطٌ طَهَارَةٌ':Added, #1: 1	شَرْطَ الطَّلَبِ
u'شَرْطٌ طَهَارَةٌ':Added, #1: 1	شَرْطَ الطَّهَارَةِ
u'شَرْطٌ طَهَارَةٌ':Added, #1: 1	شَرْطِ الطَّهَارَةِ
u'شَرْطٌ طَهَارَةٌ':Added, #1: 1	شَرْطُ طَهَارَةِ
u'شَرْطٌ طِيبٌ':Added, #1: 1	شَرْطِ طَهَارَةِ
u'شَرْطٌ طَيِّبٌ':Added, #1: 1	شَرْطَ الطِّيبِ
u'شَرْطٌ ظُهورٌ':Added, #1: 1	شَرْطَ الطَّيِّبِ
u'شَرْطٌ ظُهورٌ':Added, #1: 1	شَرْطُ الظُّهُورِ
u'شَرْطٌ ظُهورٌ':Added, #1: 1	شَرْطَ ظُهُورِ
u'شَرْطٌ عَادَةٌ':Added, #1: 1	شَرْطُ ظُهُورِ
u'شَرْطٌ عارِيَّةٌ':Added, #1: 1	شَرْطِ عَادَةٍ
u'شَرَطَ عَاقِدٌ':Subject, #1: 1	شَرْطُ عَارِيَّةِ
u'شَرْطٌ عَاقِدٌ':Added, #1: 1	شَرَطَ الْعَاقِدُ
u'شَرْطٌ عَامٌّ':Added, #1: 1	شَرْطُ الْعَاقِدِ
u'شَرَطَ عَامِلٌ':Subject, #1: 1	شَرْطِ الْعَامِّ
u'شَرْطٌ عَامِلٌ':Added, #6: 6	شَرَطَ الْعَامِلُ
u'شَرْطٌ عَامِلٌ':Added, #1: 1	شَرْطُ الْعَامِلِ
u'شَرْطٌ عِبَادَةٌ':Added, #1: 1	شَرْطِ الْعَامِلِ
u'شَرْطٌ عِبَادَةٌ':Added, #1: 1	شَرْطُ الْعِبَادَاتِ
u'شَرْطٌ عِبَادَةٌ':Added, #1: 1	شَرْطِ الْعِبَادَاتِ
u'شَرْطٌ عِبَادَةٌ':Added, #1: 1	شَرْطُ الْعِبَادَةِ
u'شَرْطٌ عِبَادَةٌ':Added, #2: 2	شَرْطَ الْعِبَادَاتِ
u'شَرَطَ عتق':Predicate, #9: 9	شَرْطِ الْعِبَادَةِ
u'شَرَطَ عِتْقٌ':Predicate, #1: 1	شَرَطَ عِتْقَ
u'شَرَطَ عتق':Predicate, #1: 1	شَرَطَ عِتْقَ
u'شَرَطَ عِتْقٌ':Predicate, #2: 2	شَرَطَ الْعِتْقَ
u'شَرْطٌ عتق':Added, #2: 2	شَرَطَ الْعِتْقَ
u'شَرْطٌ عِتْقٌ':Added, #11: 11	شَرْطُ الْعِتْقِ
u'شَرْطٌ عتق':Added, #11: 11	شَرْطُ الْعِتْقِ
u'شَرْطٌ عِتْقٌ':Added, #19: 19	شَرْطَ الْعِتْقِ
u'شَرْطٌ عتق':Added, #19: 19	شَرْطَ الْعِتْقِ
u'شَرْطٌ عِتْقٌ':Added, #1: 1	شَرْطَ عِتْقِ
u'شَرْطٌ عتق':Added, #1: 1	شَرْطَ عِتْقِ
u'شَرْطٌ عِتْقٌ':Added, #24: 24	شَرْطِ الْعِتْقِ
u'شَرْطٌ عتق':Added, #24: 24	شَرْطِ الْعِتْقِ
u'شَرْطٌ عِتْقٌ':Added, #2: 2	شَرْطُ عِتْقِ
u'شَرْطٌ عتق':Added, #2: 2	شَرْطُ عِتْقِ
u'شَرْطٌ عتق':Added, #3: 3	شَرْطَ عِتْقِهِ
u'شَرْطٌ عِتْقٌ':Added, #3: 3	شَرْطِ عِتْقِهِ
u'شَرْطٌ عِتْقٌ':Added, #3: 3	شَرْطَ عِتْقِهِ
u'شَرَطَ عجز':Predicate, #3: 3	شَرْطِ عِتْقِهِ
u'شَرَطَ عَجْزٌ':Predicate, #1: 1	شَرَطَ الْعَجْزَ
u'شَرَطَ عجز':Predicate, #1: 1	شَرَطَ الْعَجْزَ
u'شَرَطَ عَجْزٌ':Predicate, #1: 1	شَرَطَ عَجْزَ
u'شَرْطٌ عجز':Added, #1: 1	شَرَطَ عَجْزَ
u'شَرْطٌ عَجْزٌ':Added, #1: 1	شَرْطُ الْعَجْزِ
u'شَرَطَ عَدَالَةٌ':Predicate, #1: 1	شَرْطُ الْعَجْزِ
u'شَرْطٌ عَدَالَةٌ':Added, #3: 3	شَرَطَ الْعَدَالَةَ
u'شَرْطٌ عَدَالَةٌ':Added, #1: 1	شَرْطَ الْعَدَالَةِ
u'شَرْطٌ عَدَالَةٌ':Added, #2: 2	شَرْطُ الْعَدَالَةِ
u'شَرَطَ عَدَدٌ':Predicate, #3: 3	شَرْطِ الْعَدَالَةِ
u'شَرَطَ عَدَمٌ':Predicate, #2: 2	شَرَطَ الْعَدَدَ
u'شَرَطَ عَدَمٌ':Predicate, #19: 19	شَرَطَ عَدَمَ
u'شَرَطٌ عَدَمٌ':Added, #1: 1	شَرَطَ الْعَدَمَ
u'شَرْطٌ عَدَمٌ':Added, #1: 1	شَرَطَ عَدَمِ
u'شَرْطٌ عَدَمٌ':Added, #1: 1	شَرْطِ عَدَمِهِ
u'شَرْطٌ عَدَمٌ':Added, #4: 4	شَرْطَ عَدَمِ
u'شَرْطٌ عَدَمٌ':Added, #5: 5	شَرْطِ عَدَمِ
u'شَرْطٌ عُدُولٌ':Added, #7: 7	شَرْطُ عَدَمِ
u'شَرَطَ عَذْرَاءُ':Predicate, #1: 1	شَرْطُ الْعُدُولِ
u'شَرَطَ عَرْضٌ':Predicate, #1: 1	شَرَطَ عَذْرَاءَ
u'شَرَطَ عزل':Predicate, #1: 1	شَرَطَ الْعَرْضَ
u'شَرْطٌ عَزْمٌ':Added, #1: 1	شَرَطَ عَزْلَ
u'شَرْطٌ عطف':Added, #1: 1	شَرْطِ الْعَزْمِ
u'شَرْطٌ عَطْفٌ':Added, #1: 1	شَرْطُ الْعَطْفِ
u'شَرْطٌ عَقْدٌ':Added, #1: 1	شَرْطُ الْعَطْفِ
u'شَرْطٌ عَقْدٌ':Added, #2: 2	شَرْطَ الْعَقْدِ
u'شَرْطٌ عَقْدٌ':Added, #2: 2	شَرْطِ عَقْدٍ
u'شَرْطٌ عَقْدٌ':Added, #4: 4	شَرْطِ الْعَقْدِ
u'شَرْطٌ عَقْدٌ':Added, #4: 4	شَرْطُ عَقْدِهِ
u'شَرْطٌ عَقْدٌ':Added, #5: 5	شَرْطُ الْعَقْدِ
u'شَرْطٌ عَقْلٌ':Added, #6: 6	شَرْطُ عَقْدٍ
u'شَرْطٌ عَقْلٌ':Added, #1: 1	شَرْطُ الْعَقْلِ
u'شَرْطٌ عِلَّةٌ':Added, #1: 1	شَرْطِ الْعَقْلِ
u'شَرْطٌ عِلَّةٌ':Added, #1: 1	شَرْطُ الْعِلَّةِ
u'شَرْطٌ عِلَّةٌ':Added, #1: 1	شَرْطِ الْعِلَّةِ
u'شَرْطٌ عِلَّةٌ':Added, #3: 3	شَرْطَ الْعِلَّةِ
u'شَرَطَ عَلَفٌ':Predicate, #3: 3	شَرْطُ عِلَّةٍ
u'شَرَطَ علم':Predicate, #1: 1	شَرَطَ الْعَلَفَ
u'شَرَطَ عِلْمٌ':Predicate, #2: 2	شَرَطَ الْعِلْمَ
u'شَرْطٌ علم':Added, #2: 2	شَرَطَ الْعِلْمَ
u'شَرْطٌ عِلْمٌ':Added, #1: 1	شَرْطَ الْعِلْمِ
u'شَرْطٌ علم':Added, #1: 1	شَرْطَ الْعِلْمِ
u'شَرْطٌ عِلْمٌ':Added, #1: 1	شَرْطِ عِلْمٍ
u'شَرْطٌ علم':Added, #1: 1	شَرْطِ عِلْمٍ
u'شَرْطٌ علم':Added, #2: 2	شَرْطُ الْعِلْمِ
u'شَرْطٌ عِلْمٌ':Added, #2: 2	شَرْطِ الْعِلْمِ
u'شَرْطٌ عِلْمٌ':Added, #2: 2	شَرْطُ الْعِلْمِ
u'شَرَطَ عِمَارَةٌ':Predicate, #2: 2	شَرْطِ الْعِلْمِ
u'شَرْطٌ عِمَارَةٌ':Added, #2: 2	شَرَطَ الْعِمَارَةَ
u'شَرْطٌ عِمَارَةٌ':Added, #1: 1	شَرْطَ عِمَارَةِ
u'شَرْطٌ عِمَارَةٌ':Added, #2: 2	شَرْطَ الْعِمَارَةِ
u'شَرَطَ عَمَلٌ':Predicate, #2: 2	شَرْطُ الْعِمَارَةِ
u'شَرَطَ عَمَلٌ':Predicate, #11: 11	شَرَطَ عَمَلَ
u'شَرْطٌ عَمَلٌ':Added, #7: 7	شَرَطَ الْعَمَلَ
u'شَرْطٌ عَمَلٌ':Added, #1: 1	شَرْطُ عَمَلٍ
u'شَرْطٌ عَمَلٌ':Added, #1: 1	شَرْطُ عَمَلِ
u'شَرْطٌ عَمَلٌ':Added, #1: 1	شَرْطِ عَمَلٍ
u'شَرْطٌ عَمَلٌ':Added, #1: 1	شَرْطَ عَمَلِهِ
u'شَرَطٌ عَمَلٌ':Added, #1: 1	شَرْطُ عَمَلِهِ
u'شَرْطٌ عَمَلٌ':Added, #1: 1	شَرَطَ عَمَلَيْنِ
u'شَرْطٌ عَمَلٌ':Added, #4: 4	شَرْطِ الْعَمَلِ
u'شَرْطٌ عَمَلٌ':Added, #6: 6	شَرْطَ الْعَمَلِ
u'شَرْطٌ عُمُومٌ':Added, #6: 6	شَرْطُ الْعَمَلِ
u'شَرَطَ عند':Predicate, #1: 1	شَرْطِ الْعُمُومِ
u'شَرَطَ عُهْدَةٌ':Predicate, #8: 8	شَرَطَ عِنْدَ
u'شَرْطٌ عَوْدٌ':Added, #1: 1	شَرَطَ الْعُهْدَةَ
u'شَرَطَ عِوَضٌ':Predicate, #1: 1	شَرْطِ عَوْدِ
u'شَرْطٌ عِوَضٌ':Added, #3: 3	شَرَطَ الْعِوَضَ
u'شَرْطٌ عِوَضٌ':Added, #1: 1	شَرْطَ عِوَضٍ
u'شَرْطٌ عِوَضٌ':Added, #1: 1	شَرْطُ عِوَضٍ
u'شَرْطٌ عِوَضٌ':Added, #1: 1	شَرْطِ عِوَضٍ
u'شَرْطٌ عِوَضٌ':Added, #1: 1	شَرْطِ عِوَضِ
u'شَرْطٌ عِوَضٌ':Added, #3: 3	شَرْطَ الْعِوَضِ
u'شَرْطٌ عِوَضٌ':Added, #3: 3	شَرْطُ الْعِوَضِ
u'شَرْطٌ غِذَاءٌ':Added, #8: 8	شَرْطِ الْعِوَضِ
u'شَرَطَ غَسْلٌ':Predicate, #1: 1	شَرْطُ الْغِذَاءِ
u'شَرْطٌ غَسْلٌ':Added, #1: 1	شَرَطَ الْغَسْلَ
u'شَرَطَ غَلَّةٌ':Predicate, #1: 1	شَرْطُ غَسْلِهِ
u'شَرْطٌ غَلَّةٌ':Added, #2: 2	شَرَطَ الْغَلَّةَ
u'شَرْطٌ غَلَّةٌ':Added, #1: 1	شَرْطَ الْغَلَّةِ
u'شَرْطٌ غير':Added, #1: 1	شَرْطُ غَلَّتِهِ
u'شَرْطٌ غَيْرٌ':Added, #1: 1	شَرْطُ الْغَيْرِ
u'شَرْطٌ فَاسِدٌ':Added, #1: 1	شَرْطُ الْغَيْرِ
u'شَرَطَ فَاضِلٌ':Predicate, #14: 14	شَرْطٍ فَاسِدٍ
u'شَرْطٌ فَائِدَةٌ':Added, #1: 1	شَرَطَ الْفَاضِلَ
u'شَرْطٌ فرار':Added, #1: 1	شَرْطُ الْفَائِدَةِ
u'شَرْطٌ فِرَارٌ':Added, #1: 1	شَرْطِ الْفِرَارِ
u'شَرْطٌ فُرْقَةٌ':Added, #1: 1	شَرْطِ الْفِرَارِ
u'شَرْطٌ فَسْخٌ':Added, #1: 1	شَرْطَ الْفُرْقَةِ
u'شَرْطٌ فَصْلٌ':Added, #1: 1	شَرْطَ الْفَسْخِ
u'شَرْطٌ فَضْلٌ':Added, #1: 1	شَرْطُ الْفَصْلِ
u'شَرْطٌ فِعْلٌ':Added, #1: 1	شَرْطُ الْفَضْلِ
u'شَرْطٌ فِعْلٌ':Added, #1: 1	شَرْطِ الْفِعْلِ
u'شَرْطٌ فِعْلٌ':Added, #1: 1	شَرْطَ فِعْلِهِ
u'شَرْطٌ فِعْلٌ':Added, #1: 1	شَرْطُ فِعْلِهِ
u'شَرْطٌ فَقْدٌ':Added, #2: 2	شَرْطُ الْفِعْلِ
u'شَرْطٌ فقر':Added, #1: 1	شَرْطُ الْفَقْدِ
u'شَرْطٌ فَقْرٌ':Added, #1: 1	شَرْطُ الْفَقْرِ
u'شَرْطٌ فَقِيرٌ':Added, #1: 1	شَرْطُ الْفَقْرِ
u'شَرْطٌ فِكَاكٌ':Added, #1: 1	شَرْطُ الْفَقِيرِ
u'شَرَطَ فُلاَنٌ':Subject, #1: 1	شَرْطِ الْفِكَاكِ
u'شَرْطٌ فَهْمٌ':Added, #3: 3	شَرَطَ فُلَانٌ
u'شَرْطٌ فَيْئَةٌ':Added, #1: 1	شَرْطَ فَهْمِ
u'شَرْطٌ قَاعِدٌ':Added, #1: 1	شَرْطِ الْفَيْئَةِ
u'شَرَطَ قَبْضٌ':Predicate, #1: 1	شَرْطَ الْقَاعِدَةِ
u'شَرَطَ قَبْضٌ':Predicate, #1: 1	شَرَطَ قَبْضَ
u'شَرْطٌ قَبْضٌ':Added, #4: 4	شَرَطَ الْقَبْضَ
u'شَرْطٌ قَبْضٌ':Added, #2: 2	شَرْطِ الْقَبْضِ
u'شَرَطَ قَبُولٌ':Predicate, #2: 2	شَرْطِ قَبْضِ
u'شَرْطٌ قَبُولٌ':Added, #1: 1	شَرَطَ قَبُولَ
u'شَرْطٌ قَبُولٌ':Added, #1: 1	شَرْطُ الْقَبُولِ
u'شَرْطٌ قَبُولٌ':Added, #1: 1	شَرْطُ قَبُولِهِ
u'شَرْطٌ قَبُولٌ':Added, #2: 2	شَرْطِ الْقَبُولِ
u'شَرْطٌ قَبُولٌ':Added, #3: 3	شَرْطَ الْقَبُولِ
u'شَرْطٌ قَبُولٌ':Added, #5: 5	شَرْطَ قَبُولِ
u'شَرْطٌ قَبُولٌ':Added, #5: 5	شَرْطِ قَبُولِ
u'شَرْطٌ قتال':Added, #9: 9	شَرْطُ قَبُولِ
u'شَرْطٌ قِتَالٌ':Added, #1: 1	شَرْطُ قِتَالِ
u'شَرْطٌ قتل':Added, #1: 1	شَرْطُ قِتَالِ
u'شَرْطٌ قَتْلٌ':Added, #1: 1	شَرْطِ قَتْلِ
u'شَرْطٌ قتل':Added, #1: 1	شَرْطِ قَتْلِ
u'شَرْطٌ قَتْلٌ':Added, #2: 2	شَرْطُ الْقَتْلِ
u'شَرَطَ قِرَاءةٌ':Predicate, #2: 2	شَرْطُ الْقَتْلِ
u'شَرَطَ قِرَاءةٌ':Predicate, #1: 1	شَرَطَ قِرَاءَةَ
u'شَرْطٌ قرار':Added, #2: 2	شَرَطَ الْقِرَاءَةَ
u'شَرْطٌ قَرَارٌ':Added, #1: 1	شَرْطِ الْقَرَارِ
u'شَرَطَ قِرَانٌ':Predicate, #1: 1	شَرْطِ الْقَرَارِ
u'شَرَطَ قُرْبٌ':Predicate, #1: 1	شَرَطَ الْقِرَانَ
u'شَرْطٌ قَرْضٌ':Added, #1: 1	شَرَطَ قُرْبَ
u'شَرْطٌ قَرِيبٌ':Added, #1: 1	شَرْطُ قَرْضٍ
u'شَرْطٌ قسمة':Added, #1: 1	شَرْطُ قَرِيبِ
u'شَرْطٌ قسمة':Added, #1: 1	شَرْطَ قِسْمَةِ
u'شَرْطٌ قِسْمَةٌ':Added, #1: 1	شَرْطِ قِسْمَةٍ
u'شَرْطٌ قِسْمَةٌ':Added, #1: 1	شَرْطَ قِسْمَةِ
u'شَرْطٌ قُصَارَةٌ':Added, #1: 1	شَرْطِ قِسْمَةٍ
u'شَرْطٌ قصاص':Added, #1: 1	شَرْطِ الْقُصَارَةِ
u'شَرْطٌ قصاص':Added, #2: 2	شَرْطُ الْقِصَاصِ
u'شَرْطٌ قِصَاصٌ':Added, #2: 2	شَرْطِ الْقِصَاصِ
u'شَرْطٌ قِصَاصٌ':Added, #2: 2	شَرْطُ الْقِصَاصِ
u'شَرَطَ قَصْدٌ':Predicate, #2: 2	شَرْطِ الْقِصَاصِ
u'شَرْطٌ قَصْرٌ':Added, #1: 1	شَرَطَ الْقَصْدَ
u'شَرْطٌ قَصْرٌ':Added, #2: 2	شَرْطُ الْقَصْرِ
u'شَرَطَ قَضَاءٌ':Predicate, #2: 2	شَرْطِ الْقَصْرِ
u'شَرْطٌ قَضَاءٌ':Added, #1: 1	شَرَطَ الْقَضَاءَ
u'شَرْطٌ قَضَاءٌ':Added, #1: 1	شَرْطَ الْقَضَاءِ
u'شَرْطٌ قَضَاءٌ':Added, #2: 2	شَرْطِ الْقَضَاءِ
u'شَرَطَ قَطْعٌ':Predicate, #7: 7	شَرْطُ الْقَضَاءِ
u'شَرَطَ قَطْعٌ':Predicate, #13: 13	شَرَطَ الْقَطْعَ
u'شَرْطٌ قَطْعٌ':Added, #3: 3	شَرَطَ قَطْعَ
u'شَرْطٌ قَطْعٌ':Added, #1: 1	شَرْطَ قَطْعِ
u'شَرْطٌ قَطْعٌ':Added, #1: 1	شَرْطُ قَطْعِ
u'شَرْطٌ قَطْعٌ':Added, #1: 1	شَرْطِ قَطْعٍ
u'شَرْطٌ قَطْعٌ':Added, #34: 34	شَرْطِ الْقَطْعِ
u'شَرْطٌ قَطْعٌ':Added, #3: 3	شَرْطِ قَطْعِ
u'شَرْطٌ قَطْعٌ':Added, #3: 3	شَرْطِ قَطْعِهِ
u'شَرْطٌ قَطْعٌ':Added, #4: 4	شَرْطَ الْقَطْعِ
u'شَرْطٌ قلب':Added, #7: 7	شَرْطُ الْقَطْعِ
u'شَرْطٌ قَلْبٌ':Added, #1: 1	شَرْطَ الْقَلْبِ
u'شَرْطٌ قَلْب':Added, #1: 1	شَرْطَ الْقَلْبِ
u'شَرْطٌ قلب':Added, #1: 1	شَرْطَ الْقَلْبِ
u'شَرْطٌ قَلْبٌ':Added, #1: 1	شَرْطُ قَلْبِهِ
u'شَرْطٌ قَلْب':Added, #1: 1	شَرْطُ قَلْبِهِ
u'شَرَطَ قِمَارٌ':Predicate, #1: 1	شَرْطُ قَلْبِهِ
u'شَرْطٌ قول':Added, #1: 1	شَرَطَ الْقِمَارَ
u'شَرْطٌ قول':Added, #1: 1	شَرْطَ الْقَوْلِ
u'شَرْطٌ قَوْلٌ':Added, #1: 1	شَرْطِ الْقَوْلِ
u'شَرْطٌ قَوْلٌ':Added, #1: 1	شَرْطَ الْقَوْلِ
u'شَرْطٌ قَوْلٌ':Added, #1: 1	شَرْطِ الْقَوْلِ
u'شَرَطَ قَوْمٌ':Subject, #1: 1	شَرْطَ الْقَوْلَيْنِ
u'شَرْطٌ قَوِيٌّ':Added, #3: 3	شَرَطَ قَوْمٌ
u'شَرْطٌ قِيَاسٌ':Added, #1: 1	شَرْطَ الْقَوِيِّ
u'شَرْطٌ قِيَاسٌ':Added, #3: 3	شَرْطُ الْقِيَاسِ
u'شَرْطٌ قِيَاسٌ':Added, #6: 6	شَرْطَ الْقِيَاسِ
u'شَرَطَ قيام':Predicate, #6: 6	شَرْطِ الْقِيَاسِ
u'شَرَطَ قِيَامٌ':Predicate, #1: 1	شَرَطَ الْقِيَامَ
u'شَرَطَ قيام':Predicate, #1: 1	شَرَطَ الْقِيَامَ
u'شَرَطَ قِيَامٌ':Predicate, #4: 4	شَرَطَ قِيَامَ
u'شَرْطٌ قيام':Added, #4: 4	شَرَطَ قِيَامَ
u'شَرْطٌ قيام':Added, #2: 2	شَرْطُ قِيَامِ
u'شَرْطٌ قِيَامٌ':Added, #2: 2	شَرْطِ قِيَامِ
u'شَرْطٌ قِيَامٌ':Added, #2: 2	شَرْطُ قِيَامِ
u'شَرْطٌ قَيْدٌ':Added, #2: 2	شَرْطِ قِيَامِ
u'شَرَطَ كَافِرٌ':Subject, #1: 1	شَرْطُ قَيْدِ
u'شَرْطٌ كِتَابٌ':Added, #1: 1	شَرَطَ الْكَافِرُ
u'شَرْطٌ كِتَابٌ':Added, #1: 1	شَرْطِ كِتَابِ
u'شَرْطٌ كِتَابٌ':Added, #2: 2	شَرْطُ كِتَابِ
u'شَرْطٌ كِتَابَةٌ':Added, #4: 4	شَرْطِ الْكِتَابِ
u'شَرْطٌ كذب':Added, #2: 2	شَرْطِ الْكِتَابَةِ
u'شَرْطٌ كَذِبٌ':Added, #1: 1	شَرْطُ الْكَذِبِ
u'شَرَطَ كَرَامَةٌ':Predicate, #1: 1	شَرْطُ الْكَذِبِ
u'شَرْطٌ كَرَاهَةٌ':Added, #1: 1	شَرَطَ الْكَرَامَةَ
u'شَرَطَ كَفَاءةٌ':Predicate, #1: 1	شَرْطَ الْكَرَاهَةِ
u'شَرْطٌ كَفَاءةٌ':Added, #1: 1	شَرَطَ الْكَفَاءَةَ
u'شَرَطَ كَفَالَةٌ':Predicate, #1: 1	شَرْطُ الْكَفَاءَةِ
u'شَرَطَ كَفَالَةٌ':Predicate, #1: 1	شَرَطَ الْكَفَالَةَ
u'شَرْطٌ كَفَالَةٌ':Added, #2: 2	شَرَطَ كَفَالَةَ
u'شَرْطٌ كَفَالَةٌ':Added, #1: 1	شَرْطِ كَفَالَةٍ
u'شَرْطٌ كَفَالَةٌ':Added, #2: 2	شَرْطِ الْكَفَالَةِ
u'شَرَطَ كَفِيلٌ':Subject, #3: 3	شَرْطُ الْكَفَالَةِ
u'شَرْطٌ كَفِيلٌ':Added, #1: 1	شَرَطَ الْكَفِيلُ
u'شَرْطٌ كَلاَمٌ':Added, #1: 1	شَرْطِ الْكَفِيلِ
u'شَرْطٌ كَلاَمٌ':Added, #1: 1	شَرْطَ الْكَلَامِ
u'شَرْطٌ كَمَالٌ':Added, #1: 1	شَرْطِ الْكَلَامِ
u'شَرْطٌ كَمَالٌ':Added, #3: 3	شَرْطُ الْكَمَالِ
u'شَرَطَ كَوْنٌ':Predicate, #3: 3	شَرْطُ كَمَالٍ
u'شَرَطَ كَوْنٌ':Subject, #11: 11	شَرَطَ كَوْنَ
u'شَرْطٌ كَوْنٌ':Added, #1: 1	شَرَطَ كَوْنُهُ
u'شَرْطٌ كَوْنٌ':Added, #2: 2	شَرْطُ كَوْنِ
u'شَرْطٌ كَوْنٌ':Added, #4: 4	شَرْطِ كَوْنِ
u'شَرْطٌ كَوْنٌ':Added, #4: 4	شَرْطُ كَوْنِهِ
u'شَرْطٌ كَوْنٌ':Added, #5: 5	شَرْطَ كَوْنِ
u'شَرْطٌ كَوْنٌ':Added, #5: 5	شَرْطَ كَوْنِهِ
u'شَرْطٌ لاَزِمٌ':Added, #5: 5	شَرْطِ كَوْنِهِ
u'شَرْطٌ لُزُومٌ':Added, #1: 1	شَرْطُ اللَّازِمِ
u'شَرْطٌ لُزُومٌ':Added, #1: 1	شَرْطُ لُزُومٍ
u'شَرْطٌ لُزُومٌ':Added, #1: 1	شَرْطُ لُزُومِهِ
u'شَرْطٌ لُزُومٌ':Added, #1: 1	شَرْطِ لُزُومِهِ
u'شَرْطٌ لُزُومٌ':Added, #2: 2	شَرْطَ لُزُومِ
u'شَرْطٌ لُزُومٌ':Added, #3: 3	شَرْطَ اللُّزُومِ
u'شَرْطٌ لُزُومٌ':Added, #3: 3	شَرْطُ لُزُومِ
u'شَرْطٌ لعان':Added, #7: 7	شَرْطُ اللُّزُومِ
u'شَرْطٌ لعان':Added, #1: 1	شَرْطِ اللِّعَانِ
u'شَرْطٌ لَفْظِيٌّ':Added, #4: 4	شَرْطُ اللِّعَانِ
u'شَرْطٌ لَمْسٌ':Added, #1: 1	شَرْطٍ لَفْظِيٍّ
u'شَرْطٌ مَاسٌّ':Added, #1: 1	شَرْطَ اللَّمْسِ
u'شَرَطَ مَالٌ':Predicate, #1: 1	شَرْطَ الْمَاسِّ
u'شَرْطٌ مَالٌ':Added, #2: 2	شَرَطَ الْمَالَ
u'شَرْطٌ مَالٌ':Added, #1: 1	شَرْطُ الْمَالِ
u'شَرَطَ مَالِكٌ':Subject, #1: 1	شَرْطِ الْمَالِ
u'شَرَطَ مَالِكٌ':Subject, #1: 1	شَرَطَ مَالِكٌ
u'شَرْطٌ مَالِكٌ':Added, #3: 3	شَرَطَ الْمَالِكُ
u'شَرْطٌ مُبَالَغَةٌ':Added, #1: 1	شَرْطِ الْمَالِكِ
u'شَرْطٌ مَبْدَأٌ':Added, #1: 1	شَرْطُ الْمُبَالَغَةِ
u'شَرَطَ مَبِيتٌ':Predicate, #1: 1	شَرْطِ مَبْدَأِ
u'شَرْطٌ متبوع':Added, #1: 1	شَرَطَ الْمَبِيتَ
u'شَرْطٌ مُتَقَدِّمٌ':Added, #1: 1	شَرْطِ مَتْبُوعِهِ
u'شَرْطٌ مُتَكَرِّرٌ':Added, #1: 1	شَرْطٍ مُتَقَدِّمٍ
u'شَرَطٌ مُتَوَلِّي':Added, #2: 2	شَرْطٍ مُتَكَرِّرٍ
u'شَرْطٌ مَجَازٌ':Added, #1: 1	شَرَطَ مُتَوَلِّيهِ
u'شَرْطٌ مُجْتَهِد':Added, #1: 1	شَرْطِ الْمَجَازِ
u'شَرْطٌ مَجْهُولٌ':Added, #3: 3	شَرْطِ الْمُجْتَهِدِ
u'شَرْطٌ مُحَاسَبَةٌ':Added, #3: 3	شَرْطٍ مَجْهُولٍ
u'شَرْطٌ مَحْذُوفٌ':Added, #1: 1	شَرْطِ الْمُحَاسَبَةِ
u'شَرَطَ مُحْرِمٌ':Subject, #1: 1	شَرْطٍ مَحْذُوفٍ
u'شَرْطٌ مَحْضٌ':Added, #1: 1	شَرَطَ الْمُحْرِمُ
u'شَرْطٌ مُحَكَّمٌ':Added, #3: 3	شَرْطٍ مَحْضٍ
u'شَرْطٌ مُحَلِّل':Added, #1: 1	شَرْطِ الْمُحَكَّمِ
u'شَرْطٌ مَحَلِّيٌّ':Added, #1: 1	شَرْطُ الْمُحَلِّلِ
u'شَرْطٌ مَحَلِّيَّةٌ':Added, #1: 1	شَرْطُ الْمَحَلِّيَّةِ
u'شَرَطَ مُحَمَّدٌ':Subject, #1: 1	شَرْطُ الْمَحَلِّيَّةِ
u'شَرَطَ مَحْمِلٌ':Predicate, #2: 2	شَرَطَ مُحَمَّدٌ
u'شَرَطَ مُحِيل':Subject, #1: 1	شَرَطَ الْمَحْمِلَ
u'شَرْطٌ مُخَالَفَةٌ':Added, #1: 1	شَرَطَ الْمُحِيلُ
u'شَرْطٌ مَدْرَسَةٌ':Added, #2: 2	شَرْطِ مُخَالَفَةِ
u'شَرَطَ مُرْتَهِنٌ':Subject, #1: 1	شَرْطُ الْمَدْرَسَةِ
u'شَرَطَ مَرَمَّة':Predicate, #5: 5	شَرَطَ الْمُرْتَهِنُ
u'شَرْطٌ مَرْهُونٌ':Added, #2: 2	شَرَطَ الْمَرَمَّةَ
u'شَرْطٌ مَرْهُونٌ':Added, #1: 1	شَرْطُ الْمَرْهُونِ
u'شَرَطَ مُزَارِعٌ':Subject, #3: 3	شَرْطِ الْمَرْهُونِ
u'شَرْطٌ مُساقاة':Added, #2: 2	شَرَطَ الْمُزَارِعُ
u'شَرْطٌ مَسَالِكُ':Added, #1: 1	شَرْطَ مُسَاقَاةِ
u'شَرَطَ مُسَاوَاةٌ':Predicate, #1: 1	شَرْطُ الْمَسَالِكِ
u'شَرْطٌ مُسْتَأْنَفٌ':Added, #4: 4	شَرَطَ الْمُسَاوَاةَ
u'شَرْطٌ مُسْتَعَارٌ':Added, #1: 1	شَرْطٍ مُسْتَأْنَفٍ
u'شَرْطٌ مُسْتَعَارٌ':Added, #1: 1	شَرْطِ الْمُسْتَعَارِ
u'شَرْطٌ مُسْتَعْمَلٌ':Added, #1: 1	شَرْطٍ مُسْتَعَارٍ
u'شَرَطَ مُسْتَعِيرٌ':Subject, #1: 1	شَرْطُ الْمُسْتَعْمَلِ
u'شَرْطٌ مُسْتَقْبَلٌ':Added, #1: 1	شَرَطَ الْمُسْتَعِيرُ
u'شَرَطَ مَسْحٌ':Predicate, #5: 5	شَرْطٍ مُسْتَقْبَلٍ
u'شَرْطٌ مَسْحٌ':Added, #1: 1	شَرَطَ الْمَسْحَ
u'شَرَطَ مُسْلِمٌ':Predicate, #1: 1	شَرْطِ الْمَسْحِ
u'شَرَطَ مُسْلِمٌ':Subject, #1: 1	شَرَطَ مُسْلِمَةً
u'شَرْطٌ مُسْلِمٌ':Added, #2: 2	شَرَطَ مُسْلِمٌ
u'شَرْطٌ مُسْلِمٌ':Added, #232: 232	شَرْطِ مُسْلِمٍ
u'شَرْطٌ مَسِيسٌ':Added, #2: 2	شَرْطِ مُسْلِمِ
u'شَرْطٌ مُشْتَقٌّ':Added, #1: 1	شَرْطُ الْمَسِيسِ
u'شَرَطَ مَشِيئَةٌ':Predicate, #1: 1	شَرْطِ الْمُشْتَقِّ
u'شَرْطٌ مَشِيئَةٌ':Added, #2: 2	شَرَطَ الْمَشِيئَةَ
u'شَرْطٌ مَشِيئَةٌ':Added, #1: 1	شَرْطُ الْمَشِيئَةِ
u'شَرْطٌ مُصَالَحَةٌ':Added, #3: 3	شَرْطَ الْمَشِيئَةِ
u'شَرْطٌ مِصْرٌ':Added, #1: 1	شَرْطُ الْمُصَالَحَةِ
u'شَرَطَ مُصَنِّفٌ':Subject, #1: 1	شَرْطُ الْمِصْرِ
u'شَرَطَ مُضَارِبٌ':Subject, #4: 4	شَرَطَ الْمُصَنِّفُ
u'شَرْطٌ مُضَارِبٌ':Added, #9: 9	شَرَطَ الْمُضَارِبُ
u'شَرْطٌ مُضَارَبَةٌ':Added, #1: 1	شَرْطِ الْمُضَارِبِ
u'شَرَطَ مَضَرَّةٌ':Predicate, #1: 1	شَرْطِ الْمُضَارَبَةِ
u'شَرْطٌ مَضْمَضَةٌ':Added, #1: 1	شَرَطَ الْمَضَرَّةَ
u'شَرْطٌ مُطَالَبٌ':Added, #1: 1	شَرْطِ الْمَضْمَضَةِ
u'شَرْطٌ مُطَالَبَةٌ':Added, #1: 1	شَرْطُ مُطَالَبَةِ
u'شَرْطٌ مُطْلَقٌ':Added, #1: 1	شَرْطُ مُطَالَبَةِ
u'شَرْطٌ مَطْلُوبٌ':Added, #1: 1	شَرْطِ مُطْلَقِ
u'شَرْطٌ مَطْلُوبٌ':Added, #1: 1	شَرْطَ الْمَطْلُوبِ
u'شَرْطٌ مُظَاهَرَةٌ':Added, #1: 1	شَرْطِ الْمَطْلُوبِ
u'شَرْطٌ مُعارِضٌ':Added, #1: 1	شَرْطُ الْمُظَاهَرَةِ
u'شَرَطَ مَعَالِيقُ':Predicate, #1: 1	شَرْطِ الْمُعَارِضِ
u'شَرْطٌ مُعْتَبَرٌ':Added, #1: 1	شَرَطَ الْمَعَالِيقَ
u'شَرَطَ مَعْدُومٌ':Predicate, #1: 1	شَرْطِ مُعْتَبَرٍ
u'شَرْطٌ مُعَرَّفٌ':Added, #1: 1	شَرَطَ الْمَعْدُومَ
u'شَرَطَ مَعْرُوفٌ':Predicate, #1: 1	شَرْطُ الْمُعَرَّفِ
u'شَرْطٌ مَعْقُودٌ':Added, #1: 1	شَرَطَ الْمَعْرُوفَ
u'شَرَطَ مُعَلِّمٌ':Subject, #1: 1	شَرْطِ الْمَعْقُودِ
u'شَرْطٌ مَعْلُولٌ':Added, #1: 1	شَرَطَ الْمُعَلِّمُ
u'شَرَطَ مَعْلُومٌ':Predicate, #1: 1	شَرْطُ الْمَعْلُولِ
u'شَرَطَ مُعِير':Subject, #1: 1	شَرَطَ الْمَعْلُومَ
u'شَرْطٌ مُفْسِدٌ':Added, #2: 2	شَرَطَ الْمُعِيرُ
u'شَرْطٌ مُقَاصَّةٌ':Added, #4: 4	شَرْطٍ مُفْسِدٍ
u'شَرْطٌ مُقَدَّرٌ':Added, #1: 1	شَرْطُ الْمُقَاصَّةِ
u'شَرْطٌ مُقَدَّمٌ':Added, #1: 1	شَرْطٍ مُقَدَّرٍ
u'شَرْطٌ مَقْدُورٌ':Added, #1: 1	شَرْطَ الْمُقَدَّمِ
u'شَرْطٌ مَقْذُوفٌ':Added, #1: 1	شَرْطٍ مَقْدُورٍ
u'شَرْطٌ مُقَيَّدٌ':Added, #1: 1	شَرْطَ الْمَقْذُوفِ
u'شَرْطٌ مَكَانٌ':Added, #1: 1	شَرْطٍ مُقَيَّدٍ
u'شَرْطٌ مَكَانٌ':Added, #1: 1	شَرْطَ الْمَكَانِ
u'شَرْطٌ مُكَسَّرٌ':Added, #1: 1	شَرْطُ مَكَانِهِ
u'شَرَطَ مِكْيَالٌ':Predicate, #1: 1	شَرْطُ الْمُكَسَّرِ
u'شَرْطٌ مُلْحَقٌ':Added, #2: 2	شَرَطَ مِكْيَالَ
u'شَرَطَ مِلْكٌ':Predicate, #1: 1	شَرْطُ مُلْحَقِ
u'شَرْطٌ مِلْكٌ':Added, #1: 1	شَرَطَ الْمِلْكَ
u'شَرَطَ مَمَرٌّ':Predicate, #1: 1	شَرْطُ الْمِلْكِ
u'شَرْطٌ مَنْذُور':Added, #1: 1	شَرَطَ الْمَمَرَّ
u'شَرَطَ مَنْعٌ':Predicate, #1: 1	شَرْطَ الْمَنْذُورِ
u'شَرَطَ مَنْعٌ':Predicate, #1: 1	شَرَطَ الْمَنْعَ
u'شَرَطَ مَنْفَعَةٌ':Predicate, #1: 1	شَرَطَ مَنْعَ
u'شَرْطٌ مَنْفَعَةٌ':Added, #1: 1	شَرَطَ مَنْفَعَةَ
u'شَرْطٌ مَنْفَعَةٌ':Added, #1: 1	شَرْطَ مَنْفَعَةِ
u'شَرْطٌ مَنْفَعَةٌ':Added, #1: 1	شَرْطُ مَنْفَعَةٍ
u'شَرْطٌ مَنْفَعَةٌ':Added, #1: 1	شَرْطُ مَنْفَعَةِ
u'شَرْطٌ مَنْفَعَةٌ':Added, #1: 1	شَرْطِ مَنْفَعَةٍ
u'شَرْطٌ مَنْفَعَةٌ':Added, #2: 2	شَرْطِ الْمَنْفَعَةِ
u'شَرْطٌ مَنْفَعَةٌ':Added, #2: 2	شَرْطُ مَنْفَعَتِهِ
u'شَرْطٌ مُنْقَطِعٌ':Added, #3: 3	شَرْطُ الْمَنْفَعَةِ
u'شَرْطٌ مُهَادَنَةٌ':Added, #1: 1	شَرْطِ الْمُنْقَطِعِ
u'شَرْطٌ مُؤَثِّرٌ':Added, #1: 1	شَرْطِ الْمُهَادَنَةِ
u'شَرْطٌ مُوجَبٌ':Added, #1: 1	شَرْطُ الْمُؤَثِّرِ
u'شَرْطٌ مُوجِبٌ':Added, #1: 1	شَرْطُ مُوجَبِ
u'شَرَطَ مُؤَجِّرٌ':Subject, #1: 1	شَرْطُ مُوجِبِ
u'شَرَطَ مُودِعٌ':Subject, #4: 4	شَرَطَ الْمُؤَجِّرُ
u'شَرْطٌ مُؤَذِّنٌ':Added, #1: 1	شَرَطَ الْمُودِعُ
u'شَرْطٌ مَوْقُوفٌ':Added, #1: 1	شَرْطُ الْمُؤَذِّنِ
u'شَرْطٌ مَوْقُوفٌ':Added, #1: 1	شَرْطَ الْمَوْقُوفِ
u'شَرْطٌ مُوَكِّلٌ':Added, #1: 1	شَرْطُ الْمَوْقُوفِ
u'شَرْطٌ مُوَكِّلٌ':Added, #1: 1	شَرْطَ الْمُوَكِّلِ
u'شَرَطَ ناذِر':Subject, #3: 3	شَرْطُ الْمُوَكِّلِ
u'شَرْطٌ ناذِر':Added, #2: 2	شَرَطَ النَّاذِرُ
u'شَرْطٌ نَاسِخٌ':Added, #1: 1	شَرْطِ النَّاذِرِ
u'شَرْطٌ نَاسِخ':Added, #1: 1	شَرْطَ النَّاسِخِ
u'شَرْطٌ نَاظِمٌ':Added, #1: 1	شَرْطَ النَّاسِخِ
u'شَرَطَ نَبِيٌّ':Subject, #1: 1	شَرْطُ النَّاظِمِ
u'شَرْطٌ نذر':Added, #1: 1	شَرَطَ النَّبِيُّ
u'شَرْطٌ نذر':Added, #1: 1	شَرْطَ النَّذْرِ
u'شَرْطٌ نَذْرٌ':Added, #1: 1	شَرْطُ النَّذْرِ
u'شَرْطٌ نَذْرٌ':Added, #1: 1	شَرْطَ النَّذْرِ
u'شَرَطَ نَزْعٌ':Predicate, #1: 1	شَرْطُ النَّذْرِ
u'شَرَطَ نُزُولٌ':Predicate, #1: 1	شَرَطَ نَزْعَ
u'شَرْطٌ نَسَبٌ':Added, #2: 2	شَرَطَ نُزُولَ
u'شَرْطٌ نَسَبٌ':Added, #1: 1	شَرْطُ النَّسَبِ
u'شَرْطٌ نَسَبٌ':Added, #1: 1	شَرْطِ النَّسَبِ
u'شَرْطٌ نِسْبَةٌ':Added, #2: 2	شَرْطِ نَسَبِ
u'شَرْطٌ نصاب':Added, #1: 1	شَرْطُ النِّسْبَةِ
u'شَرْطٌ نِصَابٌ':Added, #1: 1	شَرْطِ النِّصَابِ
u'شَرْطٌ نصاب':Added, #1: 1	شَرْطِ النِّصَابِ
u'شَرْطٌ نِصَابٌ':Added, #3: 3	شَرْطِ نِصَابٍ
u'شَرْطٌ نصرة':Added, #3: 3	شَرْطِ نِصَابٍ
u'شَرْطٌ نُصْرَةٌ':Added, #1: 1	شَرْطُ النُّصْرَةِ
u'شَرَطَ نِصْفٌ':Predicate, #1: 1	شَرْطُ النُّصْرَةِ
u'شَرْطٌ نِصْفٌ':Added, #1: 1	شَرَطَ النِّصْفَ
u'شَرْطٌ نِصْفٌ':Added, #1: 1	شَرْطِ النِّصْفِ
u'شَرَطَ نُطْقٌ':Predicate, #6: 6	شَرْطَ النِّصْفِ
u'شَرَطَ نَظَرٌ':Predicate, #1: 1	شَرَطَ النُّطْقَ
u'شَرْطٌ نَظَرٌ':Added, #8: 8	شَرَطَ النَّظَرَ
u'شَرْطٌ نَظَرٌ':Added, #1: 1	شَرْطَ النَّظَرِ
u'شَرْطٌ نَظَرٌ':Added, #1: 1	شَرْطِ النَّظَرِ
u'شَرْطٌ نَظَرٌ':Added, #1: 1	شَرْطُ نَظَرٍ
u'شَرْطٌ نَظَرٌ':Added, #1: 1	شَرْطِ نَظَرِهِ
u'شَرْطٌ نفاذ':Added, #5: 5	شَرْطُ النَّظَرِ
u'شَرْطٌ نَفَاذٌ':Added, #15: 15	شَرْطُ النَّفَاذِ
u'شَرْطٌ نفاذ':Added, #15: 15	شَرْطُ النَّفَاذِ
u'شَرْطٌ نفاذ':Added, #1: 1	شَرْطَ نَفَاذِ
u'شَرْطٌ نَفَاذٌ':Added, #1: 1	شَرْطُ نَفَاذٍ
u'شَرْطٌ نَفَاذٌ':Added, #1: 1	شَرْطَ نَفَاذِ
u'شَرْطٌ نفاذ':Added, #1: 1	شَرْطُ نَفَاذٍ
u'شَرْطٌ نَفَاذٌ':Added, #2: 2	شَرْطُ نَفَاذِ
u'شَرْطٌ نَفْسٌ':Added, #2: 2	شَرْطُ نَفَاذِ
u'شَرَطَ نَفَقَةٌ':Predicate, #1: 1	شَرْطُ نَفْسِ
u'شَرْطٌ نَفَقَةٌ':Added, #2: 2	شَرَطَ النَّفَقَةَ
u'شَرْطٌ نُفُوذٌ':Added, #3: 3	شَرْطُ نَفَقَةِ
u'شَرْطٌ نُفُوذٌ':Added, #1: 1	شَرْطُ النُّفُوذِ
u'شَرْطٌ نُفُوذٌ':Added, #1: 1	شَرْطَ نُفُوذِ
u'شَرَطَ نَفْيٌ':Predicate, #2: 2	شَرْطُ نُفُوذِ
u'شَرْطٌ نَفْيٌ':Added, #5: 5	شَرَطَ نَفْيَ
u'شَرْطٌ نَفْيٌ':Added, #2: 2	شَرْطِ نَفْيِ
u'شَرَطَ نَقْدٌ':Predicate, #3: 3	شَرْطُ نَفْيِ
u'شَرَطَ نَقْد':Predicate, #1: 1	شَرَطَ نَقْدَ
u'شَرَطَ نَقْدٌ':Predicate, #1: 1	شَرَطَ نَقْدَ
u'شَرَطَ نَقْد':Predicate, #2: 2	شَرَطَ النَّقْدَ
u'شَرْطٌ نَقْدٌ':Added, #2: 2	شَرَطَ النَّقْدَ
u'شَرْطٌ نَقْد':Added, #1: 1	شَرْطِ النَّقْدِ
u'شَرْطٌ نَقْدٌ':Added, #1: 1	شَرْطِ النَّقْدِ
u'شَرْطٌ نَقْدٌ':Added, #1: 1	شَرْطُ نَقْدِ
u'شَرْطٌ نَقْد':Added, #1: 1	شَرْطِ نَقْدِ
u'شَرْطٌ نَقْد':Added, #1: 1	شَرْطُ نَقْدِ
u'شَرْطٌ نَقْدٌ':Added, #1: 1	شَرْطِ نَقْدِ
u'شَرْطٌ نَقْد':Added, #2: 2	شَرْطُ النَّقْدِ
u'شَرْطٌ نَقْصٌ':Added, #2: 2	شَرْطُ النَّقْدِ
u'شَرْطٌ نقل':Added, #1: 1	شَرْطُ النَّقْصِ
u'شَرْطٌ نَقْلٌ':Added, #1: 1	شَرْطُ النَّقْلِ
u'شَرْطٌ نقل':Added, #1: 1	شَرْطُ النَّقْلِ
u'شَرْطٌ نَقْلٌ':Added, #2: 2	شَرْطِ نَقْلِ
u'شَرَطَ نكاح':Predicate, #2: 2	شَرْطِ نَقْلِ
u'شَرَطَ نِكَاحٌ':Predicate, #1: 1	شَرَطَ نِكَاحَ
u'شَرْطٌ نكاح':Added, #1: 1	شَرَطَ نِكَاحَ
u'شَرْطٌ نِكَاحٌ':Added, #1: 1	شَرْطُ النِّكَاحِ
u'شَرْطٌ نكاح':Added, #1: 1	شَرْطُ النِّكَاحِ
u'شَرْطٌ نِكَاحٌ':Added, #1: 1	شَرْطُ نِكَاحِ
u'شَرْطٌ نكاح':Added, #1: 1	شَرْطُ نِكَاحِ
u'شَرْطٌ نِكَاحٌ':Added, #6: 6	شَرْطِ النِّكَاحِ
u'شَرْطٌ نَهْيٌ':Added, #6: 6	شَرْطِ النِّكَاحِ
u'شَرْطٌ نَوْعٌ':Added, #1: 1	شَرْطِ النَّهْيِ
u'شَرَطَ نِيَّةٌ':Predicate, #1: 1	شَرْطُ نَوْعِ
u'شَرَطَ نِيَّةٌ':Predicate, #1: 1	شَرَطَ نِيَّةَ
u'شَرْطٌ نِيَّةٌ':Added, #4: 4	شَرَطَ النِّيَّةَ
u'شَرْطٌ نِيَّةٌ':Added, #1: 1	شَرْطِ نِيَّةِ
u'شَرْطٌ نِيَّةٌ':Added, #2: 2	شَرْطَ النِّيَّةِ
u'شَرْطٌ نِيَّةٌ':Added, #2: 2	شَرْطِ النِّيَّةِ
u'شَرَطَ هِبَةٌ':Predicate, #3: 3	شَرْطُ النِّيَّةِ
u'شَرْطٌ هِبَةٌ':Added, #2: 2	شَرَطَ الْهِبَةَ
u'شَرْطٌ هِبَةٌ':Added, #1: 1	شَرْط الْهِبَةِ
u'شَرْطٌ هِبَةٌ':Added, #1: 1	شَرْطُ الْهِبَةِ
u'شَرْطٌ هِبَةٌ':Added, #1: 1	شَرْطَ هِبَةٍ
u'شَرْطٌ هِبَةٌ':Added, #3: 3	شَرْطِ هِبَةٍ
u'شَرْطٌ هُبُوبٌ':Added, #4: 4	شَرْطِ الْهِبَةِ
u'شَرْطٌ هجرة':Added, #1: 1	شَرْطِ هُبُوبِ
u'شَرْطٌ هجرة':Added, #1: 1	شَرْطَ الْهِجْرَةِ
u'شَرْطٌ هِجْرَةٌ':Added, #1: 1	شَرْطِ الْهِجْرَةِ
u'شَرْطٌ هِجْرَةٌ':Added, #1: 1	شَرْطَ الْهِجْرَةِ
u'شَرْطٌ هَدِيٌّ':Added, #1: 1	شَرْطِ الْهِجْرَةِ
u'شَرْطٌ هَدِيَّةٌ':Added, #1: 1	شَرْطَ الْهَدِيَّةِ
u'شَرْطٌ وَاجِبٌ':Added, #1: 1	شَرْطَ الْهَدِيَّةِ
u'شَرْطٌ واحد':Added, #1: 1	شَرْطُ الْوَاجِبِ
u'شَرْطٌ وَاحِدٌ':Added, #3: 3	شَرْطٍ وَاحِدٍ
u'شَرْطٌ وَاقِعٌ':Added, #3: 3	شَرْطٍ وَاحِدٍ
u'شَرَطَ وَاقِفٌ':Subject, #1: 1	شَرْطٍ وَاقِعٍ
u'شَرَطَ وَاقِفٌ':Subject, #1: 1	شَرَطَ وَاقِفُهُ
u'شَرَطَ وَاقِفٌ':Subject, #4: 4	شَرَطَ وَاقِفُ
u'شَرَطٌ وَاقِفٌ':Added, #85: 85	شَرَطَ الْوَاقِفُ
u'شَرْطٌ وَاقِفٌ':Added, #1: 1	شَرَطَ الْوَاقِفِ
u'شَرْطٌ وَاقِفٌ':Added, #1: 1	شَرْطٍ وَاقِفٍ
u'شَرْطٌ وَاقِفٌ':Added, #1: 1	شَرْطَ وَاقِفٍ
u'شَرْطٌ وَاقِفٌ':Added, #1: 1	شَرْطِ وَاقِفٍ
u'شَرْطٌ وَاقِفٌ':Added, #1: 1	شَرْطَ وَاقِفِهِ
u'شَرْطٌ وَاقِفٌ':Added, #1: 1	شَرْطُ وَاقِفِهِ
u'شَرْطٌ وَاقِفٌ':Added, #2: 2	شَرْطُ وَاقِفٍ
u'شَرْطٌ وَاقِفٌ':Added, #31: 31	شَرْطَ الْوَاقِفِ
u'شَرْطٌ وَاقِفٌ':Added, #36: 36	شَرْطُ الْوَاقِفِ
u'شَرَطَ وُجُوبٌ':Predicate, #54: 54	شَرْطِ الْوَاقِفِ
u'شَرَطَ وُجُوبٌ':Predicate, #1: 1	شَرَطَ الْوُجُوبَ
u'شَرْطٌ وُجُوبٌ':Added, #1: 1	شَرَطَ وُجُوبَ
u'شَرْطٌ وُجُوبٌ':Added, #16: 16	شَرْطَ وُجُوبِ
u'شَرْطٌ وُجُوبٌ':Added, #1: 1	شَرْطَ وُجُوبٍ
u'شَرْطٌ وُجُوبٌ':Added, #1: 1	شَرْطَ وُجُوبِهِ
u'شَرْطٌ وُجُوبٌ':Added, #28: 28	شَرْطُ الْوُجُوبِ
u'شَرْطٌ وُجُوبٌ':Added, #29: 29	شَرْطُ وُجُوبِ
u'شَرْطٌ وُجُوبٌ':Added, #2: 2	شَرْطُ وُجُوبِهِ
u'شَرْطٌ وُجُوبٌ':Added, #3: 3	شَرْطُ وُجُوبٍ
u'شَرْطٌ وُجُوبٌ':Added, #3: 3	شَرْطِ وُجُوبِهِ
u'شَرْطٌ وُجُوبٌ':Added, #6: 6	شَرْطِ الْوُجُوبِ
u'شَرْطٌ وُجُوبٌ':Added, #7: 7	شَرْطِ وُجُوبِ
u'شَرْطٌ وُجُودٌ':Added, #9: 9	شَرْطَ الْوُجُوبِ
u'شَرْطٌ وُجُودٌ':Added, #2: 2	شَرْطِ وُجُودِهِ
u'شَرْطٌ وُجُودٌ':Added, #3: 3	شَرْطِ وُجُودِ
u'شَرْطٌ وَرَعٌ':Added, #4: 4	شَرْطِ الْوُجُودِ
u'شَرْطٌ وَزْنٌ':Added, #1: 1	شَرْطُ الْوَرَعِ
u'شَرْطٌ وَزْنٌ':Added, #1: 1	شَرْطُ الْوَزْنِ
u'شَرْطٌ وَزْنٌ':Added, #1: 1	شَرْطُ وَزْنِهِ
u'شَرْطٌ وَصْفٌ':Added, #1: 1	شَرْطِ وَزْنِهِ
u'شَرْطٌ وصل':Added, #1: 1	شَرْطُ الْوَصْفِ
u'شَرْطٌ وَصْلٌ':Added, #1: 1	شَرْطُ وَصْلِهِ
u'شَرَطَ وَضْعٌ':Predicate, #1: 1	شَرْطُ وَصْلِهِ
u'شَرْطٌ وَضْعٌ':Added, #2: 2	شَرَطَ وَضْعَ
u'شَرْطٌ وَضْعٌ':Added, #1: 1	شَرْطُ الْوَضْعِ
u'شَرْطٌ وَضْعٌ':Added, #1: 1	شَرْطِ وَضْعِ
u'شَرْطٌ وُضُوءٌ':Added, #5: 5	شَرْطِ الْوَضْعِ
u'شَرْطٌ وُضُوءٌ':Added, #1: 1	شَرْطُ الْوُضُوءِ
u'شَرْطٌ وَضِيعٌ':Added, #1: 1	شَرْطِ الْوُضُوءِ
u'شَرَطَ وَطْءٌ':Predicate, #2: 2	شَرْطِ الْوَضِيعَةِ
u'شَرْطٌ وَطْءٌ':Added, #1: 1	شَرَطَ وَطْءَ
u'شَرْطٌ وَطْءٌ':Added, #1: 1	شَرْطُ الْوَطْءِ
u'شَرْطٌ وَطْءٌ':Added, #1: 1	شَرْطِ الْوَطْءِ
u'شَرْطٌ وَطَنٌ':Added, #1: 1	شَرْطُ وَطْءِ
u'شَرَطَ وَفَاءٌ':Predicate, #2: 2	شَرْطِ وَطَنِ
u'شَرْطٌ وَفَاءٌ':Added, #2: 2	شَرَطَ الْوَفَاءَ
u'شَرْطٌ وِفَاقٌ':Added, #2: 2	شَرْطِ الْوَفَاءِ
u'شَرَطَ وَقْتٌ':Predicate, #1: 1	شَرْطُ وِفَاقٍ
u'شَرَطَ وَقْفٌ':Predicate, #3: 3	شَرَطَ وَقْتَ
u'شَرْطٌ وَقْفٌ':Added, #1: 1	شَرَطَ وَقْفَ
u'شَرْطٌ وُقُوعٌ':Added, #3: 3	شَرْطِ الْوَقْفِ
u'شَرْطٌ وُقُوعٌ':Added, #1: 1	شَرْطِ الْوُقُوعِ
u'شَرْطٌ وُقُوعٌ':Added, #2: 2	شَرْطَ الْوُقُوعِ
u'شَرْطٌ وُقُوعٌ':Added, #2: 2	شَرْطِ وُقُوعِهِ
u'شَرْطٌ وُقُوعٌ':Added, #3: 3	شَرْطُ الْوُقُوعِ
u'شَرْطٌ وُقُوعٌ':Added, #3: 3	شَرْطُ وُقُوعِهِ
u'شَرْطٌ وُقُوعٌ':Added, #5: 5	شَرْطِ وُقُوعِ
u'شَرْطٌ وُقُوعٌ':Added, #7: 7	شَرْطَ وُقُوعِ
u'شَرْطٌ وُقُوفٌ':Added, #7: 7	شَرْطُ وُقُوعِ
u'شَرَطَ وَكِيلٌ':Subject, #1: 1	شَرْطَ الْوُقُوفِ
u'شَرْطٌ وَكِيلٌ':Added, #4: 4	شَرَطَ الْوَكِيلُ
u'شَرَطَ وَلاَءٌ':Predicate, #2: 2	شَرْطِ الْوَكِيلِ
u'شَرْطٌ وَلاَءٌ':Added, #1: 1	شَرَطَ الْوَلَاءَ
u'شَرْطٌ وِلاَدَةٌ':Added, #2: 2	شَرْطَ الْوَلَاءِ
u'شَرَطَ وِلاَيَةٌ':Predicate, #1: 1	شَرْطِ الْوِلَادَةِ
u'شَرَطَ وِلاَيَةٌ':Predicate, #1: 1	شَرَطَ وِلَايَةَ
u'شَرْطٌ وِلاَيَةٌ':Added, #6: 6	شَرَطَ الْوِلَايَةَ
u'شَرْطٌ وِلاَيَةٌ':Added, #1: 1	شَرْطَ الْوِلَايَةِ
u'شَرْطٌ وِلاَيَةٌ':Added, #1: 1	شَرْطَ وِلَايَةِ
u'شَرَطَ وَلِيٌّ':Predicate, #1: 1	شَرْطُ وِلَايَةِ
u'شَرَطَ وَلِيٌّ':Subject, #1: 1	شَرَطَ الْوَلِيَّ
u'شَرْطٌ وَلِيٌّ':Added, #1: 1	شَرَطَ الْوَلِيُّ
u'شَرْطٌ وَلِيٌّ':Added, #1: 1	شَرْطَ الْوَلِيِّ
u'شَرْطٌ وَلِيٌّ':Added, #1: 1	شَرْطُ الْوَلِيِّ
u'شَرْطٌ وَلِيٌّ':Added, #1: 1	شَرْطَ وَلِيِّ
u'شَرْطٌ يَقِينٌ':Added, #1: 1	شَرْطِ وَلِيِّ
u'شَرْطٌ يَمِينٌ':Added, #1: 1	شَرْطِ الْيَقِينِ
u'شَرْطٌ يَمِينٌ':Added, #1: 1	شَرْطَ يَمِينٍ
u'شَرْطٌ يَمِينٌ':Added, #2: 2	شَرْطَ الْيَمِينِ
u'شَرْطٌ يَمِينٌ':Added, #3: 3	شَرْطُ الْيَمِينِ
u'شَرَطَ يَوْمٌ':Predicate, #4: 4	شَرْطِ الْيَمِينِ
u'شَرَعَ اِبْتِغَاءٌ':Predicate, #1: 1	شَرَطَ الْيَوْمَ
u'شَرَعَ أَجِيرٌ':Subject, #3: 3	شَرَعَ ابْتِغَاءَ
u'شَرْعٌ أَحْكَامٌ':Added, #1: 1	شَرَعَ الْأَجِيرُ
u'شَرْعٌ أخْذٌ':Added, #3: 3	شَرْعِ الْأَحْكَامِ
u'شَرَعَ إمَامٌ':Subject, #1: 1	شَرْعِ أَخْذِ
u'شَرَعَ بَيَانٌ':Subject, #8: 8	شَرَعَ الْإِمَامُ
u'شَرَعَ بَيْعٌ':Predicate, #1: 1	شَرَعَ بَيَانٌ
u'شَرْعٌ بَيْعٌ':Added, #1: 1	شَرَعَ الْبَيْعَ
u'شَرْعٌ تَحَلُّلٌ':Added, #1: 1	شَرْعِ الْبَيْعِ
u'شَرْعٌ تَحْلِيلٌ':Added, #1: 1	شَرْعَ التَّحَلُّلِ
u'شَرَعَ تَقْديمٌ':Predicate, #1: 1	شَرْعِ التَّحْلِيلِ
u'شَرَعَ تَيَمُّمٌ':Predicate, #1: 1	شَرَعَ تَقْدِيمَ
u'شَرْعٌ جِزْيَةٌ':Added, #1: 1	شَرَعَ التَّيَمُّمَ
u'شَرَعَ حَدٌّ':Predicate, #1: 1	شَرْعِ الْجِزْيَةِ
u'شَرْعٌ حَدٌّ':Added, #2: 2	شَرَعَ حَدَّ
u'شَرَعَ حُكْمٌ':Subject, #1: 1	شَرْعِ الْحَدِّ
u'شَرْعٌ حُكْمٌ':Added, #1: 1	شَرَعَ الْحُكْمُ
u'شَرْعٌ حُكْمٌ':Added, #13: 13	شَرْعِ الْحُكْمِ
u'شَرْعٌ حُكْمٌ':Added, #1: 1	شَرْعَ الْحُكْمِ
u'شَرْعٌ حُكْمٌ':Added, #2: 2	شَرْعُ الْحُكْمِ
u'شَرَعَ حَمْدٌ':Predicate, #2: 2	شَرْعَ حُكْمٍ
u'شَرْعٌ حَوَالَةٌ':Added, #1: 1	شَرَعَ الْحَمْدَ
u'شَرَعَ خَصْمٌ':Subject, #1: 1	شَرْعِ الْحَوَالَةِ
u'شَرَعَ خَطِيبٌ':Subject, #1: 1	شَرَعَ الْخَصْمُ
u'شَرَعَ خَطِيبٌ':Subject, #1: 1	شَرَعَ خَطِيبُ
u'شَرْعٌ خيار':Added, #2: 2	شَرَعَ الْخَطِيبُ
u'شَرْعٌ خِيَارٌ':Added, #1: 1	شَرْعَ خِيَارِ
u'شَرْعٌ خيار':Added, #1: 1	شَرْعَ خِيَارِ
u'شَرْعٌ خِيَارٌ':Added, #2: 2	شَرْعَ الْخِيَارِ
u'شَرَعَ دِينٌ':Predicate, #2: 2	شَرْعَ الْخِيَارِ
u'شَرْعٌ ذَبائِحُ':Added, #1: 1	شَرَعَ الدِّينَ
u'شَرْعٌ رُجُوعٌ':Added, #1: 1	شَرْعِ الذَّبَائِحِ
u'شَرْعٌ رُخْصَةٌ':Added, #1: 1	شَرْعِ الرُّجُوعِ
u'شَرْعٌ زاجِرٌ':Added, #1: 1	شَرْعُ الرُّخْصَةِ
u'شَرْعٌ زَكاةٌ':Added, #5: 5	شَرْعِ الزَّاجِرِ
u'شَرْعٌ زواجر':Added, #2: 2	شَرْعِ الزَّكَاةِ
u'شَرَعَ سِكَّةٌ':Predicate, #2: 2	شَرْعِ الزَّوَاجِرِ
u'شَرَعَ شَارِعٌ':Subject, #1: 1	شَرَعَ السِّكَّةَ
u'شَرْعٌ شَارِعٌ':Added, #1: 1	شَرَعَ الشَّارِعُ
u'شَرَعَ شَخْصٌ':Subject, #1: 1	شَرْعِ الشَّارِعِ
u'شَرْعٌ شفعة':Added, #1: 1	شَرَعَ الشَّخْصُ
u'شَرْعٌ شُفْعَةٌ':Added, #1: 1	شَرْعِ الشُّفْعَةِ
u'شَرَعَ صَاحِبٌ':Subject, #1: 1	شَرْعِ الشُّفْعَةِ
u'شَرْعٌ صَلاَةٌ':Added, #1: 1	شَرَعَ صَاحِبُ
u'شَرَعَ صَوْمٌ':Predicate, #1: 1	شَرْعُ الصَّلاَةِ
u'شَرْعٌ عُقُوبَةٌ':Added, #1: 1	شَرَعَ الصَّوْمَ
u'شَرَعَ غَائِبٌ':Subject, #1: 1	شَرْعَ الْعُقُوبَةِ
u'شَرْعٌ غَسْلٌ':Added, #2: 2	شَرَعَ غَائِبٌ
u'شَرَعَ فُلاَنٌ':Subject, #1: 1	شَرْعِ غَسْلِ
u'شَرَعَ قَاسِمٌ':Subject, #1: 1	شَرَعَ فُلَانٌ
u'شَرْعٌ قتال':Added, #1: 1	شَرَعَ الْقَاسِمُ
u'شَرْعٌ قِتَالٌ':Added, #1: 1	شَرْعِ الْقِتَالِ
u'شَرَعَ قِرَانٌ':Predicate, #1: 1	شَرْعِ الْقِتَالِ
u'شَرَعَ قَسام':Predicate, #1: 1	شَرَعَ الْقِرَانَ
u'شَرَعَ قَسامَة':Predicate, #1: 1	شَرَعَ الْقَسَامَةَ
u'شَرَعَ قصاص':Predicate, #1: 1	شَرَعَ الْقَسَامَةَ
u'شَرَعَ قِصَاصٌ':Predicate, #1: 1	شَرَعَ الْقِصَاصَ
u'شَرْعٌ قصاص':Added, #1: 1	شَرَعَ الْقِصَاصَ
u'شَرْعٌ قِصَاصٌ':Added, #1: 1	شَرْعِ الْقِصَاصِ
u'شَرْعٌ قَصْرٌ':Added, #1: 1	شَرْعِ الْقِصَاصِ
u'شَرْعٌ قِيَاسٌ':Added, #1: 1	شَرْعِ الْقَصْرِ
u'شَرْعٌ كَفَّارٌ':Added, #2: 2	شَرْعِ الْقِيَاسِ
u'شَرْعٌ كَفَّارٌ':Added, #1: 1	شَرْعَ الْكَفَّارَةِ
u'شَرْعٌ كَفَّارَةٌ':Added, #1: 1	شَرْعُ الْكَفَّارَةِ
u'شَرْعٌ كَفَّارَةٌ':Added, #1: 1	شَرْعَ الْكَفَّارَةِ
u'شَرْعٌ مُبْتَدَأٌ':Added, #1: 1	شَرْعُ الْكَفَّارَةِ
u'شَرْعٌ مُتْعَةٌ':Added, #3: 3	شَرْعٍ مُبْتَدَأٍ
u'شَرْعٌ مُتَقَدِّمٌ':Added, #1: 1	شَرْعِ الْمُتْعَةِ
u'شَرْعٌ مُحَمَّدٌ':Added, #1: 1	شَرْعٍ مُتَقَدِّمٍ
u'شَرَعَ مُسَافِرٌ':Subject, #1: 1	شَرْعُ مُحَمَّدٍ
u'شَرَعَ مُصَنِّفٌ':Subject, #1: 1	شَرَعَ الْمُسَافِرُ
u'شَرْعٌ مُغَلَّظ':Added, #1: 1	شَرَعَ الْمُصَنِّفُ
u'شَرْعٌ مُنَاظَرَةٌ':Added, #1: 1	شَرْعٍ مُغَلَّظٍ
u'شَرْعٌ مُنَاظَرَةٌ':Added, #1: 1	شَرْعَ الْمُنَاظَرَةِ
u'شَرْعٌ مَوَارِيثُ':Added, #1: 1	شَرْعِ الْمُنَاظَرَةِ
u'شَرَعَ مُؤَلِّفٌ':Subject, #1: 1	شَرْعِ الْمَوَارِيثِ
u'شَرَعَ نَبِيٌّ':Subject, #1: 1	شَرَعَ الْمُؤَلِّفُ
u'شَرَعَ نَصْرَانِيٌّ':Subject, #1: 1	شَرَعَ النَّبِيُّ
u'شَرْعٌ نكاح':Added, #1: 1	شَرَعَ النَّصْرَانِيُّ
u'شَرْعٌ نِكَاحٌ':Added, #1: 1	شَرْعِ النِّكَاحِ
u'شَرْعٌ وَصِيٌّ':Added, #1: 1	شَرْعِ النِّكَاحِ
u'شَرْعٌ وَصِيَّةٌ':Added, #2: 2	شَرْعِ الْوَصِيَّةِ
u'شَرْعٌ وَضْعٌ':Added, #2: 2	شَرْعِ الْوَصِيَّةِ
u'شرف أخْلاقٌ':Added, #1: 1	شَرْعَ الْوَضْعِ
u'شرف أَخْلاَقٌ':Added, #1: 1	شَرَفَ الْأَخْلَاقِ
u'شَرَفٌ أخْلاقٌ':Added, #1: 1	شَرَفَ الْأَخْلَاقِ
u'شَرَفٌ أَخْلاَقٌ':Added, #1: 1	شَرَفَ الْأَخْلَاقِ
u'شرف إِسْلامٌ':Added, #1: 1	شَرَفَ الْأَخْلَاقِ
u'شَرَفٌ إِسْلامٌ':Added, #1: 1	شَرَفَ إسْلَامِ
u'شرف إِسْلامٌ':Added, #1: 1	شَرَفَ إسْلَامِ
u'شرف إِسْلامٌ':Added, #1: 1	شَرَفَ الْإِسْلَامِ
u'شَرَفٌ إِسْلامٌ':Added, #1: 1	شَرَفِ الْإِسْلَامِ
u'شَرَفٌ إِسْلامٌ':Added, #1: 1	شَرَفَ الْإِسْلَامِ
u'شرف إِسْلامٌ':Added, #1: 1	شَرَفِ الْإِسْلَامِ
u'شَرَفٌ إِسْلامٌ':Added, #3: 3	شَرَفُ الْإِسْلَامِ
u'شرف أَصْحَابٌ':Added, #3: 3	شَرَفُ الْإِسْلَامِ
u'شَرَفٌ أَصْحَابٌ':Added, #1: 1	شَرَفِ أَصْحَابِ
u'شرف إضافَةٌ':Added, #1: 1	شَرَفِ أَصْحَابِ
u'شَرَفٌ إضافَةٌ':Added, #1: 1	شَرَفَ الْإِضَافَةِ
u'شَرَّفَ أهْلٌ':Predicate, #1: 1	شَرَفَ الْإِضَافَةِ
u'شرف أئِمَّةٌ':Added, #1: 1	شَرَّفَ أَهْلَ
u'شَرَفٌ أئِمَّةٌ':Added, #1: 1	شَرَفِ الْأَئِمَّةِ
u'شرف أئِمَّةٌ':Added, #1: 1	شَرَفِ الْأَئِمَّةِ
u'شَرَفٌ أئِمَّةٌ':Added, #2: 2	شَرَفُ الْأَئِمَّةِ
u'شرف بُقْعَةٌ':Added, #2: 2	شَرَفُ الْأَئِمَّةِ
u'شَرَفٌ بُقْعَةٌ':Added, #1: 1	شَرَفِ الْبُقْعَةِ
u'شرف بَيْداءُ':Added, #1: 1	شَرَفِ الْبُقْعَةِ
u'شَرَفٌ بَيْداءُ':Added, #1: 1	شَرَفَ الْبَيْدَاءِ
u'شرف بَيْداءُ':Added, #1: 1	شَرَفَ الْبَيْدَاءِ
u'شَرَفٌ بَيْداءُ':Added, #5: 5	شَرَفِ الْبَيْدَاءِ
u'شرف تَلَف':Added, #5: 5	شَرَفِ الْبَيْدَاءِ
u'شَرَفٌ تَلَف':Added, #2: 2	شَرَفِ التَّلَفِ
u'شرف حالٌ':Added, #2: 2	شَرَفِ التَّلَفِ
u'شَرَفٌ حالٌ':Added, #1: 1	شَرَفِ الْحَالِ
u'شرف حُرٌّ':Added, #1: 1	شَرَفِ الْحَالِ
u'شَرَفٌ حُرٌّ':Added, #1: 1	شَرَفُ الْحُرِّ
u'شرف حُرٌّ':Added, #1: 1	شَرَفُ الْحُرِّ
u'شَرَفٌ حُرٌّ':Added, #1: 1	شَرَفُ الْحُرَّةِ
u'شرف حُرِّيَّةٌ':Added, #1: 1	شَرَفُ الْحُرَّةِ
u'شَرَفٌ حُرِّيَّةٌ':Added, #10: 10	شَرَفَ الْحُرِّيَّةِ
u'شرف حُرِّيَّةٌ':Added, #10: 10	شَرَفَ الْحُرِّيَّةِ
u'شَرَفٌ حُرِّيَّةٌ':Added, #2: 2	شَرَفُ الْحُرِّيَّةِ
u'شرف حُرِّيَّةٌ':Added, #2: 2	شَرَفُ الْحُرِّيَّةِ
u'شَرَفٌ حُرِّيَّةٌ':Added, #7: 7	شَرَفِ الْحُرِّيَّةِ
u'شرف حَسَبٌ':Added, #7: 7	شَرَفِ الْحُرِّيَّةِ
u'شرف حَسَبٌ':Added, #1: 1	شَرَفَ الْحَسَبِ
u'شرف حَسَبٌ':Added, #1: 1	شَرَفُ الْحَسَبِ
u'شَرَفٌ حَسَبٌ':Added, #1: 1	شَرَفِ الْحَسَبِ
u'شَرَفٌ حَسَبٌ':Added, #1: 1	شَرَفَ الْحَسَبِ
u'شَرَفٌ حَسَبٌ':Added, #1: 1	شَرَفُ الْحَسَبِ
u'شرف حَيَاةٌ':Added, #1: 1	شَرَفِ الْحَسَبِ
u'شَرَفٌ حَيَاةٌ':Added, #1: 1	شَرَفَ الْحَيَاةِ
u'شرف دِينٌ':Added, #1: 1	شَرَفَ الْحَيَاةِ
u'شَرَفٌ دِينٌ':Added, #12: 12	شَرَفُ الدِّينِ
u'شرف دِينٌ':Added, #12: 12	شَرَفُ الدِّينِ
u'شَرَفٌ دِينٌ':Added, #1: 1	شَرَفَ الدِّينِ
u'شرف دِينٌ':Added, #1: 1	شَرَفَ الدِّينِ
u'شَرَفٌ دِينٌ':Added, #6: 6	شَرَفِ الدِّينِ
u'شرف زَمانٌ':Added, #6: 6	شَرَفِ الدِّينِ
u'شَرَفٌ زَمانٌ':Added, #1: 1	شَرَفَ الزَّمَانِ
u'شرف زَوالٌ':Added, #1: 1	شَرَفَ الزَّمَانِ
u'شَرَفٌ زَوالٌ':Added, #23: 23	شَرَفِ الزَّوَالِ
u'شرف سُقُوطٌ':Added, #23: 23	شَرَفِ الزَّوَالِ
u'شَرَفٌ سُقُوطٌ':Added, #21: 21	شَرَفِ السُّقُوطِ
u'شرف سَلْبٌ':Added, #21: 21	شَرَفِ السُّقُوطِ
u'شَرَفٌ سَلْبٌ':Added, #1: 1	شَرَفَ السَّلْبِ
u'شرف سُورَةٌ':Added, #1: 1	شَرَفَ السَّلْبِ
u'شَرَفٌ سُورَةٌ':Added, #1: 1	شَرَفِ السُّورَةِ
u'شرف صحبة':Added, #1: 1	شَرَفِ السُّورَةِ
u'شَرَفٌ صحبة':Added, #1: 1	شَرَفُ الصُّحْبَةِ
u'شرف صُحْبَةٌ':Added, #1: 1	شَرَفُ الصُّحْبَةِ
u'شَرَفٌ صُحْبَةٌ':Added, #1: 1	شَرَفُ الصُّحْبَةِ
u'شرف عِفَّةٌ':Added, #1: 1	شَرَفُ الصُّحْبَةِ
u'شَرَفٌ عِفَّةٌ':Added, #1: 1	شَرَفُ الْعِفَّةِ
u'شرف عَقَارٌ':Added, #1: 1	شَرَفُ الْعِفَّةِ
u'شَرَفٌ عَقَارٌ':Added, #2: 2	شَرَفِ الْعَقَارِ
u'شرف عَقْلٌ':Added, #2: 2	شَرَفِ الْعَقَارِ
u'شَرَفٌ عَقْلٌ':Added, #1: 1	شَرَفُ الْعَقْلِ
u'شرف علم':Added, #1: 1	شَرَفُ الْعَقْلِ
u'شَرَفٌ علم':Added, #1: 1	شَرَفُ الْعِلْمِ
u'شرف عِلْمٌ':Added, #1: 1	شَرَفُ الْعِلْمِ
u'شَرَفٌ عِلْمٌ':Added, #1: 1	شَرَفُ الْعِلْمِ
u'شرف علم':Added, #1: 1	شَرَفُ الْعِلْمِ
u'شَرَفٌ علم':Added, #2: 2	شَرَفِ عِلْمِ
u'شرف عِلْمٌ':Added, #2: 2	شَرَفِ عِلْمِ
u'شَرَفٌ عِلْمٌ':Added, #2: 2	شَرَفِ عِلْمِ
u'شرف علم':Added, #2: 2	شَرَفِ عِلْمِ
u'شَرَفٌ علم':Added, #6: 6	شَرَفَ الْعِلْمِ
u'شرف عِلْمٌ':Added, #6: 6	شَرَفَ الْعِلْمِ
u'شَرَفٌ عِلْمٌ':Added, #6: 6	شَرَفَ الْعِلْمِ
u'شرف عُلُومٌ':Added, #6: 6	شَرَفَ الْعِلْمِ
u'شَرَفٌ عُلُومٌ':Added, #1: 1	شَرَفُ الْعُلُومِ
u'شرف فقر':Added, #1: 1	شَرَفُ الْعُلُومِ
u'شَرَفٌ فقر':Added, #1: 1	شَرَفِ الْفَقْرِ
u'شرف فَقْرٌ':Added, #1: 1	شَرَفِ الْفَقْرِ
u'شَرَفٌ فَقْرٌ':Added, #1: 1	شَرَفِ الْفَقْرِ
u'شَرَفَ فلان':Predicate, #1: 1	شَرَفِ الْفَقْرِ
u'شرف فَوَاتٌ':Added, #1: 1	شَرَفَ مَكّةَ
u'شَرَفٌ فَوَاتٌ':Added, #4: 4	شَرَفِ الْفَوَاتِ
u'شرف قَطْعٌ':Added, #4: 4	شَرَفِ الْفَوَاتِ
u'شَرَفٌ قَطْعٌ':Added, #3: 3	شَرَفِ الْقَطْعِ
u'شرف كَرِيمٌ':Added, #3: 3	شَرَفِ الْقَطْعِ
u'شَرَفٌ كَرِيمٌ':Added, #1: 1	شَرَفُ الْكَرِيمِ
u'شَرُفَ مَالِكٌ':Subject, #1: 1	شَرَفُ الْكَرِيمِ
u'شرف مَجَالِسُ':Added, #1: 1	شَرُفَ مَالِكٌ
u'شَرَفٌ مَجَالِسُ':Added, #1: 1	شَرَفِ الْمَجَالِسِ
u'شرف مَجْلِسٌ':Added, #1: 1	شَرَفِ الْمَجَالِسِ
u'شَرَفٌ مَجْلِسٌ':Added, #1: 1	شَرَفِ الْمَجْلِسِ
u'شَرُفَ مَجْنِيٌّ':Subject, #1: 1	شَرَفِ الْمَجْلِسِ
u'شرف مَحَلٌّ':Added, #1: 1	شَرُفَ الْمَجْنِيُّ
u'شَرَفٌ مَحَلٌّ':Added, #1: 1	شَرَفُ مَحَلِّهِ
u'شرف مَحَلٌّ':Added, #1: 1	شَرَفُ مَحَلِّهِ
u'شَرَفٌ مَحَلٌّ':Added, #2: 2	شَرَفِ الْمَحَلِّ
u'شرف مَخْلُوقٌ':Added, #2: 2	شَرَفِ الْمَحَلِّ
u'شَرَفٌ مَخْلُوقٌ':Added, #1: 1	شَرَفَ الْمَخْلُوقَاتِ
u'شرف مُسْلِمٌ':Added, #1: 1	شَرَفَ الْمَخْلُوقَاتِ
u'شَرَفٌ مُسْلِمٌ':Added, #1: 1	شَرَفِ الْمُسْلِمِ
u'شرف مَطْلُوبٌ':Added, #1: 1	شَرَفِ الْمُسْلِمِ
u'شَرَفٌ مَطْلُوبٌ':Added, #1: 1	شَرَفَ الْمَطْلُوبِ
u'شرف مَعْقُودٌ':Added, #1: 1	شَرَفَ الْمَطْلُوبِ
u'شَرَفٌ مَعْقُودٌ':Added, #1: 1	شَرَفِ الْمَعْقُودِ
u'شرف مُقَدِّمٌ':Added, #1: 1	شَرَفِ الْمَعْقُودِ
u'شَرَفٌ مُقَدِّمٌ':Added, #1: 1	شَرَفِ الْمُقَدِّمَاتِ
u'شرف مُقَدِّمَةٌ':Added, #1: 1	شَرَفِ الْمُقَدِّمَاتِ
u'شَرَفٌ مُقَدِّمَةٌ':Added, #1: 1	شَرَفِ الْمُقَدِّمَاتِ
u'شرف مَكَانٌ':Added, #1: 1	شَرَفِ الْمُقَدِّمَاتِ
u'شَرَفٌ مَكَانٌ':Added, #1: 1	شَرَفَ الْمَكَانِ
u'شرف مَكْسَبٌ':Added, #1: 1	شَرَفَ الْمَكَانِ
u'شَرَفٌ مَكْسَبٌ':Added, #1: 1	شَرَفِ الْمَكْسَبِ
u'شرف مَلَكٌ':Added, #1: 1	شَرَفِ الْمَكْسَبِ
u'شَرَفٌ مَلَكٌ':Added, #1: 1	شَرَفِ الْمَلَكَيْنِ
u'شرف مَنَازِلُ':Added, #1: 1	شَرَفِ الْمَلَكَيْنِ
u'شَرَفٌ مَنَازِلُ':Added, #1: 1	شَرَفَ الْمَنَازِلِ
u'شرف مَنْزِلَةٌ':Added, #1: 1	شَرَفَ الْمَنَازِلِ
u'شَرَفٌ مَنْزِلَةٌ':Added, #1: 1	شَرَفَ الْمَنْزِلَةِ
u'شرف مَنْزِلَةٌ':Added, #1: 1	شَرَفَ الْمَنْزِلَةِ
u'شَرَفٌ مَنْزِلَةٌ':Added, #1: 1	شَرَفِ مَنْزِلَتِهِ
u'شرف نَسَبٌ':Added, #1: 1	شَرَفِ مَنْزِلَتِهِ
u'شَرَفٌ نَسَبٌ':Added, #1: 1	شَرَفَ النَّسَبِ
u'شرف نَسَبٌ':Added, #1: 1	شَرَفَ النَّسَبِ
u'شَرَفٌ نَسَبٌ':Added, #1: 1	شَرَفُ نَسَبِهِ
u'شرف نَسَبٌ':Added, #1: 1	شَرَفُ نَسَبِهِ
u'شَرَفٌ نَسَبٌ':Added, #5: 5	شَرَفِ النَّسَبِ
u'شرف نَفْسٌ':Added, #5: 5	شَرَفِ النَّسَبِ
u'شَرَفٌ نَفْسٌ':Added, #1: 1	شَرَفِ النَّفْسِ
u'شرف نَفْسٌ':Added, #1: 1	شَرَفِ النَّفْسِ
u'شَرَفٌ نَفْسٌ':Added, #5: 5	شَرَفُ النَّفْسِ
u'شرف نَقْضٌ':Added, #5: 5	شَرَفُ النَّفْسِ
u'شَرَفٌ نَقْضٌ':Added, #1: 1	شَرَفِ النَّقْضِ
u'شرف هلاك':Added, #1: 1	شَرَفِ النَّقْضِ
u'شَرَفٌ هلاك':Added, #4: 4	شَرَفِ الْهَلَاكِ
u'شرف هَلاَكٌ':Added, #4: 4	شَرَفِ الْهَلَاكِ
u'شَرَفٌ هَلاَكٌ':Added, #4: 4	شَرَفِ الْهَلَاكِ
u'شرف وَالِدٌ':Added, #4: 4	شَرَفِ الْهَلَاكِ
u'شَرَفٌ وَالِدٌ':Added, #1: 1	شَرَفِ الْوَالِدَيْنِ
u'شرف وُجُوبٌ':Added, #1: 1	شَرَفِ الْوَالِدَيْنِ
u'شَرَفٌ وُجُوبٌ':Added, #1: 1	شَرَفِ الْوُجُوبِ
u'شرف وَقْتٌ':Added, #1: 1	شَرَفِ الْوُجُوبِ
u'شَرَفٌ وَقْتٌ':Added, #3: 3	شَرَفِ الْوَقْتِ
u'شرف وَلاَءٌ':Added, #3: 3	شَرَفِ الْوَقْتِ
u'شَرَفٌ وَلاَءٌ':Added, #1: 1	شَرَفَ الْوَلَاءِ
u'شَرِكَ إِخْوَةٌ':Predicate, #1: 1	شَرَفَ الْوَلَاءِ
u'شَرِكَ بَيْنٌ':Predicate, #1: 1	أَشْرَكَ الإِخْوَةَ
u'شَرَّكَ بَيْنٌ':Predicate, #1: 1	شَرِكَ بَيْنَ
u'شَرِكَ بَيْنٌ':Predicate, #1: 1	شَرَّكَ بَيْنَ
u'شركة أبدانٌ':Added, #3: 3	أَشْرَكَ بَيْنَ
u'شركة أبدانٌ':Added, #1: 1	شَرِكَةَ أَبْدَانٍ
u'شَرِكَةٌ أبدانٌ':Added, #1: 1	شَرِكَةِ أَبْدَانٍ
u'شَرِكَةٌ أبدانٌ':Added, #1: 1	شَرِكَةَ أَبْدَانٍ
u'شركة أبدانٌ':Added, #1: 1	شَرِكَةِ أَبْدَانٍ
u'شِرْكَةٌ أبدانٌ':Added, #1: 1	شِرْكَةُ الْأَبْدَانِ
u'شركة أبدانٌ':Added, #1: 1	شِرْكَةُ الْأَبْدَانِ
u'شركة أبدانٌ':Added, #2: 2	شَرِكَةَ الْأَبْدَانِ
u'شركة أبدانٌ':Added, #2: 2	شَرِكَةُ الْأَبَدَانِ
u'شَرِكَةٌ أبدانٌ':Added, #2: 2	شَرِكَةِ الْأَبَدَانِ
u'شَرِكَةٌ أبدانٌ':Added, #2: 2	شَرِكَةَ الْأَبْدَانِ
u'شَرِكَةٌ أبدانٌ':Added, #2: 2	شَرِكَةُ الْأَبَدَانِ
u'شركة أبدانٌ':Added, #2: 2	شَرِكَةِ الْأَبَدَانِ
u'شَرِكَةٌ أبدانٌ':Added, #3: 3	شَرِكَةُ الْأَبْدَانِ
u'شركة أبدانٌ':Added, #3: 3	شَرِكَةُ الْأَبْدَانِ
u'شَرِكَةٌ أبدانٌ':Added, #7: 7	شَرِكَةِ الْأَبْدَانِ
u'شركة أجَانِبُ':Added, #7: 7	شَرِكَةِ الْأَبْدَانِ
u'شَرِكَةٌ أجَانِبُ':Added, #2: 2	شَرِكَةَ الْأَجَانِبِ
u'شركة أَجْنَبِيٌّ':Added, #2: 2	شَرِكَةَ الْأَجَانِبِ
u'شَرِكَةٌ أَجْنَبِيٌّ':Added, #2: 2	شَرِكَةَ الْأَجْنَبِيِّ
u'شركة إِرْثٌ':Added, #2: 2	شَرِكَةَ الْأَجْنَبِيِّ
u'شَرِكَةٌ إِرْثٌ':Added, #2: 2	شَرِكَةُ الْإِرْثِ
u'شركة أصل':Added, #2: 2	شَرِكَةُ الْإِرْثِ
u'شركة أًصْلٌ':Added, #3: 3	شَرِكَةِ الْأَصْلِ
u'شَرِكَةٌ أصل':Added, #3: 3	شَرِكَةِ الْأَصْلِ
u'شَرِكَةٌ أًصْلٌ':Added, #3: 3	شَرِكَةِ الْأَصْلِ
u'شركة أَعْمَالٌ':Added, #3: 3	شَرِكَةِ الْأَصْلِ
u'شَرِكَةٌ أَعْمَالٌ':Added, #1: 1	شَرِكَةُ الْأَعْمَالِ
u'شركة أعْيانٌ':Added, #1: 1	شَرِكَةُ الْأَعْمَالِ
u'شركة أَعْيَانٌ':Added, #1: 1	شَرِكَةِ الْأَعْيَانِ
u'شَرِكَةٌ أعْيانٌ':Added, #1: 1	شَرِكَةِ الْأَعْيَانِ
u'شَرِكَةٌ أَعْيَانٌ':Added, #1: 1	شَرِكَةِ الْأَعْيَانِ
u'شركة أَمْلاكٌ':Added, #1: 1	شَرِكَةِ الْأَعْيَانِ
u'شركة أَمْلاكٌ':Added, #1: 1	شَرِكَةَ أَمْلَاكٍ
u'شركة أَمْلاكٌ':Added, #1: 1	شَرِكَةُ أَمْلَاكٍ
u'شركة أَمْلاكٌ':Added, #1: 1	شَرِكَةِ أَمْلَاكٍ
u'شركة أَمْلاَكٌ':Added, #1: 1	شِرْكَةُ أَمْلَاكٍ
u'شركة أَمْلاَكٌ':Added, #1: 1	شَرِكَةَ أَمْلَاكٍ
u'شركة أَمْلاَكٌ':Added, #1: 1	شَرِكَةُ أَمْلَاكٍ
u'شركة أَمْلاَكٌ':Added, #1: 1	شَرِكَةِ أَمْلَاكٍ
u'شَرِكَةٌ أَمْلاكٌ':Added, #1: 1	شِرْكَةُ أَمْلَاكٍ
u'شَرِكَةٌ أَمْلاكٌ':Added, #1: 1	شَرِكَةَ أَمْلَاكٍ
u'شَرِكَةٌ أَمْلاكٌ':Added, #1: 1	شَرِكَةُ أَمْلَاكٍ
u'شِرْكَةٌ أَمْلاكٌ':Added, #1: 1	شَرِكَةِ أَمْلَاكٍ
u'شَرِكَةٌ أَمْلاَكٌ':Added, #1: 1	شِرْكَةُ أَمْلَاكٍ
u'شَرِكَةٌ أَمْلاَكٌ':Added, #1: 1	شَرِكَةَ أَمْلَاكٍ
u'شَرِكَةٌ أَمْلاَكٌ':Added, #1: 1	شَرِكَةُ أَمْلَاكٍ
u'شِرْكَةٌ أَمْلاَكٌ':Added, #1: 1	شَرِكَةِ أَمْلَاكٍ
u'شركة أَمْلاكٌ':Added, #1: 1	شِرْكَةُ أَمْلَاكٍ
u'شركة أَمْلاَكٌ':Added, #2: 2	شَرِكَةَ الْأَمْلَاكِ
u'شَرِكَةٌ أَمْلاكٌ':Added, #2: 2	شَرِكَةَ الْأَمْلَاكِ
u'شَرِكَةٌ أَمْلاَكٌ':Added, #2: 2	شَرِكَةَ الْأَمْلَاكِ
u'شركة أَمْوَالٌ':Added, #2: 2	شَرِكَةَ الْأَمْلَاكِ
u'شَرِكَةٌ أَمْوَالٌ':Added, #2: 2	شَرِكَةُ الْأَمْوَالِ
u'شركة أَمْوَالٌ':Added, #2: 2	شَرِكَةُ الْأَمْوَالِ
u'شَرِكَةٌ أَمْوَالٌ':Added, #5: 5	شَرِكَةِ الْأَمْوَالِ
u'شركة أهْلٌ':Added, #5: 5	شَرِكَةِ الْأَمْوَالِ
u'شَرِكَةٌ أهْلٌ':Added, #1: 1	شَرِكَةُ أَهْلِ
u'شركة أَوَّلُ':Added, #1: 1	شَرِكَةُ أَهْلِ
u'شَرِكَةٌ أَوَّلُ':Added, #1: 1	شَرِكَةِ الْأَوَّلَيْنِ
u'شركة أَوَّلُ':Added, #1: 1	شَرِكَةِ الْأَوَّلَيْنِ
u'شَرِكَةٌ أَوَّلُ':Added, #4: 4	شَرِكَةِ الْأَوَّلِ
u'شركة بَائِعٌ':Added, #4: 4	شَرِكَةِ الْأَوَّلِ
u'شَرِكَةٌ بَائِعٌ':Added, #1: 1	شَرِكَةَ الْبَائِعِ
u'شركة بَزّاز':Added, #1: 1	شَرِكَةَ الْبَائِعِ
u'شَرِكَةٌ بَزّاز':Added, #3: 3	شَرِكَةِ الْبَزَّازِيَّةِ
u'شركة بَزّازَة':Added, #3: 3	شَرِكَةِ الْبَزَّازِيَّةِ
u'شَرِكَةٌ بَزّازَة':Added, #3: 3	شَرِكَةِ الْبَزَّازِيَّةِ
u'شركة بَقِيَّةٌ':Added, #3: 3	شَرِكَةِ الْبَزَّازِيَّةِ
u'شَرِكَةٌ بَقِيَّةٌ':Added, #2: 2	شَرِكَةَ الْبَقِيَّةِ
u'شركة تَقَبُّلٌ':Added, #2: 2	شَرِكَةَ الْبَقِيَّةِ
u'شَرِكَةٌ تَقَبُّلٌ':Added, #2: 2	شَرِكَةَ تَقَبُّلٍ
u'شركة تَقَبُّلٌ':Added, #2: 2	شَرِكَةَ تَقَبُّلٍ
u'شركة تَقَبُّلٌ':Added, #4: 4	شَرِكَةَ التَّقَبُّلِ
u'شَرِكَةٌ تَقَبُّلٌ':Added, #4: 4	شَرِكَةِ التَّقَبُّلِ
u'شَرِكَةٌ تَقَبُّلٌ':Added, #4: 4	شَرِكَةَ التَّقَبُّلِ
u'شركة تَقَبُّلٌ':Added, #4: 4	شَرِكَةِ التَّقَبُّلِ
u'شَرِكَةٌ تَقَبُّلٌ':Added, #8: 8	شَرِكَةُ التَّقَبُّلِ
u'شركة جَارِحٌ':Added, #8: 8	شَرِكَةُ التَّقَبُّلِ
u'شَرِكَةٌ جَارِحٌ':Added, #1: 1	شَرِكَةِ جَارِحٍ
u'شركة جَبْرٌ':Added, #1: 1	شَرِكَةِ جَارِحٍ
u'شَرِكَةٌ جَبْرٌ':Added, #1: 1	شَرِكَةُ جَبْرٍ
u'شركة حَقٌّ':Added, #1: 1	شَرِكَةُ جَبْرٍ
u'شَرِكَةٌ حَقٌّ':Added, #1: 1	شَرِكَةَ الْحَقِّ
u'شركة حَمْلٌ':Added, #1: 1	شَرِكَةَ الْحَقِّ
u'شِرْكَةٌ حَمْلٌ':Added, #1: 1	شِرْكَةِ حَمْلٍ
u'شركة خَاطِئٌ':Added, #1: 1	شِرْكَةِ حَمْلٍ
u'شَرِكَةٌ خَاطِئٌ':Added, #1: 1	شَرِكَةَ الْخَاطِئِ
u'شركة ذِمَمٌ':Added, #1: 1	شَرِكَةَ الْخَاطِئِ
u'شَرِكَةٌ ذِمَمٌ':Added, #1: 1	شَرِكَةِ الذِّمَمِ
u'شركة رَبُّ':Added, #1: 1	شَرِكَةِ الذِّمَمِ
u'شَرِكَةٌ رَبُّ':Added, #1: 1	شَرِكَةِ رَبِّ
u'شركة سَهْمٌ':Added, #1: 1	شَرِكَةِ رَبِّ
u'شَرِكَةٌ سَهْمٌ':Added, #1: 1	شَرِكَةِ السَّهْمِ
u'شركة سُؤَالٌ':Added, #1: 1	شَرِكَةِ السَّهْمِ
u'شَرِكَةٌ سُؤَالٌ':Added, #1: 1	شَرِكَةُ السُّؤَالِ
u'شركة شَاهِدٌ':Added, #1: 1	شَرِكَةُ السُّؤَالِ
u'شَرِكَةٌ شَاهِدٌ':Added, #1: 1	شَرِكَةِ الشَّاهِدِ
u'شركة شَخْصٌ':Added, #1: 1	شَرِكَةِ الشَّاهِدِ
u'شَرِكَةٌ شَخْصٌ':Added, #1: 1	شَرِكَةِ شَخْصَيْنِ
u'شركة شرب':Added, #1: 1	شَرِكَةِ شَخْصَيْنِ
u'شركة شِرْبٌ':Added, #1: 1	شِرْكَةُ الشِّرْبِ
u'شِرْكَةٌ شرب':Added, #1: 1	شِرْكَةُ الشِّرْبِ
u'شِرْكَةٌ شِرْبٌ':Added, #1: 1	شِرْكَةُ الشِّرْبِ
u'شركة شُهُودٌ':Added, #1: 1	شِرْكَةُ الشِّرْبِ
u'شَرِكَةٌ شُهُودٌ':Added, #1: 1	شَرِكَةُ الشُّهُودِ
u'شركة شُهُودٌ':Added, #1: 1	شَرِكَةُ الشُّهُودِ
u'شَرِكَةٌ شُهُودٌ':Added, #1: 1	شَرِكَةُ شُهُودٍ
u'شركة صَاحِبٌ':Added, #1: 1	شَرِكَةُ شُهُودٍ
u'شِرْكَةٌ صَاحِبٌ':Added, #1: 1	شِرْكَةَ صَاحِبِهِ
u'شركة صَبِيٌّ':Added, #1: 1	شِرْكَةَ صَاحِبِهِ
u'شَرِكَةٌ صَبِيٌّ':Added, #1: 1	شَرِكَةِ صَبِيٍّ
u'شركة صنائع':Added, #1: 1	شَرِكَةِ صَبِيٍّ
u'شَرِكَةٌ صنائع':Added, #1: 1	شَرِكَةَ الصَّنَائِعِ
u'شركة صَنَائِعُ':Added, #1: 1	شَرِكَةَ الصَّنَائِعِ
u'شَرِكَةٌ صَنَائِعُ':Added, #1: 1	شَرِكَةَ الصَّنَائِعِ
u'شركة صنائع':Added, #1: 1	شَرِكَةَ الصَّنَائِعِ
u'شَرِكَةٌ صنائع':Added, #3: 3	شَرِكَةِ الصَّنَائِعِ
u'شركة صَنَائِعُ':Added, #3: 3	شَرِكَةِ الصَّنَائِعِ
u'شَرِكَةٌ صَنَائِعُ':Added, #3: 3	شَرِكَةِ الصَّنَائِعِ
u'شركة صنائع':Added, #3: 3	شَرِكَةِ الصَّنَائِعِ
u'شَرِكَةٌ صنائع':Added, #6: 6	شَرِكَةُ الصَّنَائِعِ
u'شركة صَنَائِعُ':Added, #6: 6	شَرِكَةُ الصَّنَائِعِ
u'شَرِكَةٌ صَنَائِعُ':Added, #6: 6	شَرِكَةُ الصَّنَائِعِ
u'شركة طَالِبٌ':Added, #6: 6	شَرِكَةُ الصَّنَائِعِ
u'شَرِكَةٌ طَالِبٌ':Added, #1: 1	شَرِكَةَ الطَّالِبِ
u'شركة عَامٌّ':Added, #1: 1	شَرِكَةَ الطَّالِبِ
u'شَرِكَةٌ عَامٌّ':Added, #1: 1	شَرِكَةٍ عَامَّةٍ
u'شركة عَامِلٌ':Added, #1: 1	شَرِكَةٍ عَامَّةٍ
u'شركة عَامِلٌ':Added, #1: 1	شَرِكَةَ الْعَامِلِ
u'شَرِكَةٌ عَامِلٌ':Added, #1: 1	شَرِكَةُ الْعَامِلِ
u'شَرِكَةٌ عَامِلٌ':Added, #1: 1	شَرِكَةَ الْعَامِلِ
u'شركة عَبْدٌ':Added, #1: 1	شَرِكَةُ الْعَامِلِ
u'شَرِكَةٌ عَبْدٌ':Added, #1: 1	شَرِكَةُ عَبْدٍ
u'شركة عَدُوٌّ':Added, #1: 1	شَرِكَةُ عَبْدٍ
u'شَرِكَةٌ عَدُوٌّ':Added, #1: 1	شَرِكَةَ الْعَدُوِّ
u'شركة عَسْكَرٌ':Added, #1: 1	شَرِكَةَ الْعَدُوِّ
u'شَرِكَةٌ عَسْكَرٌ':Added, #1: 1	شَرِكَةِ الْعَسْكَرِ
u'شركة عَقْدٌ':Added, #1: 1	شَرِكَةِ الْعَسْكَرِ
u'شَرِكَةٌ عَقْدٌ':Added, #2: 2	شَرِكَةَ الْعَقْدِ
u'شركة عَقْدٌ':Added, #2: 2	شَرِكَةَ الْعَقْدِ
u'شَرِكَةٌ عَقْدٌ':Added, #4: 4	شَرِكَةُ الْعَقْدِ
u'شركة عَقْدٌ':Added, #4: 4	شَرِكَةُ الْعَقْدِ
u'شَرِكَةٌ عَقْدٌ':Added, #5: 5	شَرِكَةَ عَقْدٍ
u'شركة عَقْدٌ':Added, #5: 5	شَرِكَةَ عَقْدٍ
u'شَرِكَةٌ عَقْدٌ':Added, #6: 6	شَرِكَةِ الْعَقْدِ
u'شركة عَقْدٌ':Added, #6: 6	شَرِكَةِ الْعَقْدِ
u'شَرِكَةٌ عَقْدٌ':Added, #7: 7	شَرِكَةُ عَقْدٍ
u'شركة عُقُودٌ':Added, #7: 7	شَرِكَةُ عَقْدٍ
u'شِرْكَةٌ عُقُودٌ':Added, #1: 1	شِرْكَةُ الْعُقُودِ
u'شركة عُقُودٌ':Added, #1: 1	شِرْكَةُ الْعُقُودِ
u'شَرِكَةٌ عُقُودٌ':Added, #1: 1	شَرِكَةُ عُقُودٍ
u'شركة عُقُودٌ':Added, #1: 1	شَرِكَةُ عُقُودٍ
u'شَرِكَةٌ عُقُودٌ':Added, #3: 3	شَرِكَةُ الْعُقُودِ
u'شركة عَمَلٌ':Added, #3: 3	شَرِكَةُ الْعُقُودِ
u'شَرِكَةٌ عَمَلٌ':Added, #1: 1	شَرِكَةُ الْعَمَلِ
u'شركة عَمَلٌ':Added, #1: 1	شَرِكَةُ الْعَمَلِ
u'شَرِكَةٌ عَمَلٌ':Added, #1: 1	شَرِكَةَ عَمَلٍ
u'شركة عَنَانٌ':Added, #1: 1	شَرِكَةَ عَمَلٍ
u'شَرِكَةٌ عَنَانٌ':Added, #13: 13	شَرِكَةَ عَنَانٍ
u'شركة عِنان':Added, #13: 13	شَرِكَةَ عَنَانٍ
u'شركة عِنَانٌ':Added, #1: 1	شِرْكَةِ الْعِنَانِ
u'شِرْكَةٌ عِنان':Added, #1: 1	شِرْكَةِ الْعِنَانِ
u'شِرْكَةٌ عِنَانٌ':Added, #1: 1	شِرْكَةِ الْعِنَانِ
u'شركة عِنان':Added, #1: 1	شِرْكَةِ الْعِنَانِ
u'شركة عَنَانٌ':Added, #1: 1	شِرْكَةَ عِنَانٍ
u'شركة عِنَانٌ':Added, #1: 1	شَرِكَةُ عَنَانٍ
u'شِرْكَةٌ عِنان':Added, #1: 1	شِرْكَةَ عِنَانٍ
u'شَرِكَةٌ عَنَانٌ':Added, #1: 1	شِرْكَةَ عِنَانٍ
u'شِرْكَةٌ عِنَانٌ':Added, #1: 1	شَرِكَةُ عَنَانٍ
u'شركة عِنان':Added, #1: 1	شِرْكَةَ عِنَانٍ
u'شركة عِنَانٌ':Added, #27: 27	شَرِكَةِ الْعِنَانِ
u'شَرِكَةٌ عِنان':Added, #27: 27	شَرِكَةِ الْعِنَانِ
u'شَرِكَةٌ عِنَانٌ':Added, #27: 27	شَرِكَةِ الْعِنَانِ
u'شركة عِنان':Added, #27: 27	شَرِكَةِ الْعِنَانِ
u'شركة عَنَانٌ':Added, #2: 2	شِرْكَةَ الْعِنَانِ
u'شركة عَنَانٌ':Added, #2: 2	شَرِكَةَ الْعَنَانِ
u'شركة عِنَانٌ':Added, #2: 2	شَرِكَةُ الْعَنَانِ
u'شِرْكَةٌ عِنان':Added, #2: 2	شِرْكَةَ الْعِنَانِ
u'شَرِكَةٌ عَنَانٌ':Added, #2: 2	شِرْكَةَ الْعِنَانِ
u'شَرِكَةٌ عَنَانٌ':Added, #2: 2	شَرِكَةَ الْعَنَانِ
u'شِرْكَةٌ عِنَانٌ':Added, #2: 2	شَرِكَةُ الْعَنَانِ
u'شركة عِنان':Added, #2: 2	شِرْكَةَ الْعِنَانِ
u'شركة عِنَانٌ':Added, #3: 3	شَرِكَةِ عِنَانٍ
u'شَرِكَةٌ عِنان':Added, #3: 3	شَرِكَةِ عِنَانٍ
u'شَرِكَةٌ عِنَانٌ':Added, #3: 3	شَرِكَةِ عِنَانٍ
u'شركة عِنان':Added, #3: 3	شَرِكَةِ عِنَانٍ
u'شركة عِنَانٌ':Added, #49: 49	شَرِكَةَ عِنَانٍ
u'شَرِكَةٌ عِنان':Added, #49: 49	شَرِكَةَ عِنَانٍ
u'شَرِكَةٌ عِنَانٌ':Added, #49: 49	شَرِكَةَ عِنَانٍ
u'شركة عِنان':Added, #49: 49	شَرِكَةَ عِنَانٍ
u'شركة عِنَانٌ':Added, #5: 5	شَرِكَةُ عِنَانٍ
u'شَرِكَةٌ عِنان':Added, #5: 5	شَرِكَةُ عِنَانٍ
u'شَرِكَةٌ عِنَانٌ':Added, #5: 5	شَرِكَةُ عِنَانٍ
u'شركة عِنان':Added, #5: 5	شَرِكَةُ عِنَانٍ
u'شركة عَنَانٌ':Added, #6: 6	شَرِكَةَ الْعِنَانِ
u'شركة عِنَانٌ':Added, #6: 6	شَرِكَةِ الْعَنَانِ
u'شَرِكَةٌ عِنان':Added, #6: 6	شَرِكَةَ الْعِنَانِ
u'شَرِكَةٌ عَنَانٌ':Added, #6: 6	شَرِكَةَ الْعِنَانِ
u'شَرِكَةٌ عِنَانٌ':Added, #6: 6	شَرِكَةِ الْعَنَانِ
u'شركة عِنان':Added, #6: 6	شَرِكَةَ الْعِنَانِ
u'شركة عِنَانٌ':Added, #9: 9	شَرِكَةُ الْعِنَانِ
u'شَرِكَةٌ عِنان':Added, #9: 9	شَرِكَةُ الْعِنَانِ
u'شَرِكَةٌ عِنَانٌ':Added, #9: 9	شَرِكَةُ الْعِنَانِ
u'شركة عين':Added, #9: 9	شَرِكَةُ الْعِنَانِ
u'شركة عَيْنٌ':Added, #1: 1	شَرِكَةِ الْعَيْنِ
u'شركة عَيْن':Added, #1: 1	شَرِكَةِ الْعَيْنِ
u'شَرِكَةٌ عين':Added, #1: 1	شَرِكَةِ الْعَيْنِ
u'شَرِكَةٌ عَيْنٌ':Added, #1: 1	شَرِكَةِ الْعَيْنِ
u'شَرِكَةٌ عَيْن':Added, #1: 1	شَرِكَةِ الْعَيْنِ
u'شركة عُيُونٌ':Added, #1: 1	شَرِكَةِ الْعَيْنِ
u'شَرِكَةٌ عُيُونٌ':Added, #1: 1	شَرِكَةِ الْعُيُونِ
u'شركة غير':Added, #1: 1	شَرِكَةِ الْعُيُونِ
u'شركة غَيْرٌ':Added, #1: 1	شَرِكَةِ الْغَيْرِ
u'شَرِكَةٌ غير':Added, #1: 1	شَرِكَةِ الْغَيْرِ
u'شَرِكَةٌ غَيْرٌ':Added, #1: 1	شَرِكَةِ الْغَيْرِ
u'شركة غير':Added, #1: 1	شَرِكَةِ الْغَيْرِ
u'شركة غير':Added, #2: 2	شَرِكَةَ غَيْرِهِ
u'شركة غَيْرٌ':Added, #2: 2	شَرِكَةِ غَيْرِهِ
u'شركة غَيْرٌ':Added, #2: 2	شَرِكَةَ غَيْرِهِ
u'شَرِكَةٌ غير':Added, #2: 2	شَرِكَةِ غَيْرِهِ
u'شَرِكَةٌ غير':Added, #2: 2	شَرِكَةَ غَيْرِهِ
u'شَرِكَةٌ غَيْرٌ':Added, #2: 2	شَرِكَةِ غَيْرِهِ
u'شَرِكَةٌ غَيْرٌ':Added, #2: 2	شَرِكَةَ غَيْرِهِ
u'شركة فَاسِدٌ':Added, #2: 2	شَرِكَةِ غَيْرِهِ
u'شَرِكَةٌ فَاسِدٌ':Added, #3: 3	شَرِكَةٍ فَاسِدَةٍ
u'شركة فلان':Added, #3: 3	شَرِكَةٍ فَاسِدَةٍ
u'شَرِكَةٌ فلان':Added, #3: 3	شَرِكَةِ الْبَزَّازِيَّةِ
u'شركة كَلْبٌ':Added, #3: 3	شَرِكَةِ الْبَزَّازِيَّةِ
u'شَرِكَةٌ كَلْبٌ':Added, #1: 1	شَرِكَةِ كَلْبِ
u'شركة مَاءٌ':Added, #1: 1	شَرِكَةِ كَلْبِ
u'شَرِكَةٌ مَاءٌ':Added, #1: 1	شَرِكَةِ الْمَاءِ
u'شركة مَالٌ':Added, #1: 1	شَرِكَةِ الْمَاءِ
u'شَرِكَةٌ مَالٌ':Added, #1: 1	شَرِكَةِ الْمَالِ
u'شركة مَالٌ':Added, #1: 1	شَرِكَةِ الْمَالِ
u'شَرِكَةٌ مَالٌ':Added, #1: 1	شَرِكَةِ مَالِ
u'شركة مدد':Added, #1: 1	شَرِكَةِ مَالِ
u'شركة مدد':Added, #2: 2	شَرِكَةُ الْمَدَدِ
u'شركة مَدَدٌ':Added, #2: 2	شَرِكَةِ الْمَدَدِ
u'شركة مَدَدٌ':Added, #2: 2	شَرِكَةُ الْمَدَدِ
u'شَرِكَةٌ مدد':Added, #2: 2	شَرِكَةِ الْمَدَدِ
u'شَرِكَةٌ مدد':Added, #2: 2	شَرِكَةُ الْمَدَدِ
u'شَرِكَةٌ مَدَدٌ':Added, #2: 2	شَرِكَةِ الْمَدَدِ
u'شَرِكَةٌ مَدَدٌ':Added, #2: 2	شَرِكَةُ الْمَدَدِ
u'شركة مَشْهُودٌ':Added, #2: 2	شَرِكَةِ الْمَدَدِ
u'شَرِكَةٌ مَشْهُودٌ':Added, #1: 1	شَرِكَةَ الْمَشْهُودِ
u'شركة مُضَارِبٌ':Added, #1: 1	شَرِكَةَ الْمَشْهُودِ
u'شَرِكَةٌ مُضَارِبٌ':Added, #2: 2	شَرِكَةِ الْمُضَارِبِ
u'شركة مُعَلِّمٌ':Added, #2: 2	شَرِكَةِ الْمُضَارِبِ
u'شَرِكَةٌ مُعَلِّمٌ':Added, #1: 1	شَرِكَةُ الْمُعَلِّمَيْنِ
u'شركة مُفَاوَضَةٌ':Added, #1: 1	شَرِكَةُ الْمُعَلِّمَيْنِ
u'شَرِكَةٌ مُفَاوَضَةٌ':Added, #11: 11	شَرِكَةُ الْمُفَاوَضَةِ
u'شركة مُفَاوَضَةٌ':Added, #11: 11	شَرِكَةُ الْمُفَاوَضَةِ
u'شَرِكَةٌ مُفَاوَضَةٌ':Added, #1: 1	شَرِكَةِ مُفَاوَضَةٍ
u'شركة مُفَاوَضَةٌ':Added, #1: 1	شَرِكَةِ مُفَاوَضَةٍ
u'شَرِكَةٌ مُفَاوَضَةٌ':Added, #2: 2	شَرِكَةُ مُفَاوَضَةٍ
u'شركة مُفَاوَضَةٌ':Added, #2: 2	شَرِكَةُ مُفَاوَضَةٍ
u'شَرِكَةٌ مُفَاوَضَةٌ':Added, #31: 31	شَرِكَةَ مُفَاوَضَةٍ
u'شركة مُفَاوَضَةٌ':Added, #31: 31	شَرِكَةَ مُفَاوَضَةٍ
u'شِرْكَةٌ مُفَاوَضَةٌ':Added, #3: 3	شِرْكَةُ الْمُفَاوَضَةِ
u'شركة مُفَاوَضَةٌ':Added, #3: 3	شِرْكَةُ الْمُفَاوَضَةِ
u'شركة مُفَاوَضَةٌ':Added, #5: 5	شَرِكَةَ الْمُفَاوَضَةِ
u'شَرِكَةٌ مُفَاوَضَةٌ':Added, #5: 5	شَرِكَةِ الْمُفَاوَضَةِ
u'شَرِكَةٌ مُفَاوَضَةٌ':Added, #5: 5	شَرِكَةَ الْمُفَاوَضَةِ
u'شركة مِلْكٌ':Added, #5: 5	شَرِكَةِ الْمُفَاوَضَةِ
u'شَرِكَةٌ مِلْكٌ':Added, #13: 13	شَرِكَةَ مِلْكٍ
u'شركة مِلْكٌ':Added, #13: 13	شَرِكَةَ مِلْكٍ
u'شَرِكَةٌ مِلْكٌ':Added, #14: 14	شَرِكَةُ مِلْكٍ
u'شركة مِلْكٌ':Added, #14: 14	شَرِكَةُ مِلْكٍ
u'شركة مِلْكٌ':Added, #1: 1	شَرِكَةِ مِلْكٍ
u'شَرِكَةٌ مِلْكٌ':Added, #1: 1	شِرْكَةَ مِلْكٍ
u'شِرْكَةٌ مِلْكٌ':Added, #1: 1	شَرِكَةِ مِلْكٍ
u'شركة مِلْكٌ':Added, #1: 1	شِرْكَةَ مِلْكٍ
u'شَرِكَةٌ مِلْكٌ':Added, #2: 2	شَرِكَةِ الْمِلْكِ
u'شركة مِلْكٌ':Added, #2: 2	شَرِكَةِ الْمِلْكِ
u'شركة مِلْكٌ':Added, #3: 3	شَرِكَةَ الْمِلْكِ
u'شَرِكَةٌ مِلْكٌ':Added, #3: 3	شَرِكَةُ الْمِلْكِ
u'شَرِكَةٌ مِلْكٌ':Added, #3: 3	شَرِكَةَ الْمِلْكِ
u'شركة مِيرَاثٌ':Added, #3: 3	شَرِكَةُ الْمِلْكِ
u'شَرِكَةٌ مِيرَاثٌ':Added, #1: 1	شَرِكَةَ مِيرَاثٍ
u'شركة نَفْسٌ':Added, #1: 1	شَرِكَةَ مِيرَاثٍ
u'شَرِكَةٌ نَفْسٌ':Added, #1: 1	شَرِكَةِ نَفْسِهِ
u'شركة نَهْرٌ':Added, #1: 1	شَرِكَةِ نَفْسِهِ
u'شَرِكَةٌ نَهْرٌ':Added, #1: 1	شَرِكَةَ النَّهْرِ
u'شركة وَارِثٌ':Added, #1: 1	شَرِكَةَ النَّهْرِ
u'شَرِكَةٌ وَارِثٌ':Added, #2: 2	شَرِكَةَ الْوَارِثِ
u'شركة وَاقِعٌ':Added, #2: 2	شَرِكَةَ الْوَارِثِ
u'شَرِكَةٌ وَاقِعٌ':Added, #1: 1	شَرِكَةِ وَاقِعَاتِهِ
u'شركة وُجُوهٌ':Added, #1: 1	شَرِكَةِ وَاقِعَاتِهِ
u'شَرِكَةٌ وُجُوهٌ':Added, #15: 15	شَرِكَةِ الْوُجُوهِ
u'شركة وُجُوهٌ':Added, #15: 15	شَرِكَةِ الْوُجُوهِ
u'شَرِكَةٌ وُجُوهٌ':Added, #19: 19	شَرِكَةُ الْوُجُوهِ
u'شركة وُجُوهٌ':Added, #19: 19	شَرِكَةُ الْوُجُوهِ
u'شَرِكَةٌ وُجُوهٌ':Added, #2: 2	شَرِكَةُ وُجُوهٍ
u'شركة وُجُوهٌ':Added, #2: 2	شَرِكَةُ وُجُوهٍ
u'شَرِكَةٌ وُجُوهٌ':Added, #3: 3	شَرِكَةَ وُجُوهٍ
u'شركة وُجُوهٌ':Added, #3: 3	شَرِكَةَ وُجُوهٍ
u'شَرِكَةٌ وُجُوهٌ':Added, #5: 5	شَرِكَةَ الْوُجُوهِ
u'شركة وَرَثَةٌ':Added, #5: 5	شَرِكَةَ الْوُجُوهِ
u'شَرِكَةٌ وَرَثَةٌ':Added, #2: 2	شَرِكَةِ الْوَرَثَةِ
u'شركة وَقْفٌ':Added, #2: 2	شَرِكَةِ الْوَرَثَةِ
u'شَرِكَةٌ وَقْفٌ':Added, #1: 1	شَرِكَةِ وَقْفٍ
u'شَرِكَ ثَالِثٌ':Predicate, #1: 1	شَرِكَةِ وَقْفٍ
u'شَرِكَ جَازٌ':Predicate, #2: 2	أَشْرَكَ الثَّالِثَ
u'شَرِكَ حَديثٌ':Predicate, #1: 1	أَشْرَكَ جَازَ
u'شَرِكَ رابع':Predicate, #3: 3	أَشْرَكَ الْحَدِيثَ
u'شَرِكَ رَابِعٌ':Predicate, #1: 1	أَشْرَكَ الرَّابِعَةَ
u'شَرِكَ سِتٌّ':Predicate, #1: 1	أَشْرَكَ الرَّابِعَةَ
u'شَرِكَ شافِعِيّ':Subject, #1: 1	أَشْرَكَ سِتَّةً
u'شَرِكَ طوال':Predicate, #1: 1	شَرِكَ الشَّافِعِيُّ
u'شَرِكَ غَائِبٌ':Subject, #1: 1	أَشْرَكَ طَوَالَ
u'شَرِكَ غير':Predicate, #1: 1	شَرِكَ الْغَائِبُ
u'شَرِكَ غَيْرٌ':Predicate, #1: 1	أَشْرَكَ غَيْرَهُنَّ
u'شَرِكَ فلان':Subject, #1: 1	أَشْرَكَ غَيْرَهُنَّ
u'شَرِكَ قَوْمٌ':Predicate, #1: 1	شَرِكَ الشَّافِعِيُّ
u'شُرُوحٌ أَسْلافٌ':Added, #1: 1	أَشْرَكَ الْقَوْمَ
u'شُرُوحٌ أَسْلاَفٌ':Added, #1: 1	شُرُوحُ الْأَسْلَافِ
u'شُرُوحٌ أُصولٌ':Added, #1: 1	شُرُوحُ الْأَسْلَافِ
u'شُرُوحٌ أَلْفِيَّةٌ':Added, #1: 1	شُرُوحَ أُصُولِهِ
u'شُرُوحٌ بَدِيعٌ':Added, #1: 1	شُرُوحِ الْأَلْفِيَّةِ
u'شُرُوحٌ جَامِعٌ':Added, #1: 1	شُرُوحِ الْبَدِيعِ
u'شُرُوحٌ زِيادَةٌ':Added, #25: 25	شُرُوحِ الْجَامِعِ
u'شُرُوحٌ فِقْهٌ':Added, #1: 1	شُرُوحِ الزِّيَادَاتِ
u'شُرُوحٌ كَافِي':Added, #1: 1	شُرُوحِ الْفِقْهِ
u'شُرُوحٌ كَنْزٌ':Added, #1: 1	شُرُوحِ الْكَافِيَةِ
u'شُرُوحٌ مَجْمَعٌ':Added, #1: 1	شُرُوحِ الْكَنْزِ
u'شُرُوحٌ مُخْتَصَرٌ':Added, #3: 3	شُرُوحِ الْمَجْمَعِ
u'شُرُوحٌ مِفْتَاحٌ':Added, #1: 1	شُرُوحِ الْمُخْتَصَرِ
u'شُرُوحٌ مِنْهَاجٌ':Added, #3: 3	شُرُوحِ الْمِفْتَاحِ
u'شُرُوحٌ نَحْوٌ':Added, #1: 1	شُرُوحِ الْمِنْهَاجِ
u'شُرُوحٌ هِدَايَةٌ':Added, #1: 1	شُرُوحِ النَّحْوِ
u'شُرُوحٌ هِدَايَةٌ':Added, #18: 18	شُرُوحِ الْهِدَايَةِ
u'شُرُوحٌ وِقَايَةٌ':Added, #1: 1	شُرُوحُ الْهِدَايَةِ
u'شُرُودٌ دَابَّةٌ':Added, #2: 2	شُرُوحِ الْوِقَايَةِ
u'شُرُورٌ نَاسٌ':Added, #2: 2	شُرُودَ الدَّابَّةِ
u'شُرُوطٌ إِبَانَةٌ':Added, #1: 1	شُرُورَ النَّاسِ
u'شُرُوطٌ إجَارَةٌ':Added, #1: 1	شُرُوطِ الْإِبَانَةِ
u'شُرُوطٌ إجَارَةٌ':Added, #1: 1	شُرُوطُ إجَارَةٍ
u'شُرُوطٌ إجَارَةٌ':Added, #2: 2	شُرُوطُ الْإِجَارَةِ
u'شُرُوطٌ إِجْبَارٌ':Added, #2: 2	شُرُوطِ الْإِجَارَةِ
u'شُرُوطٌ إِجْزَاءٌ':Added, #1: 1	شُرُوطِ إجْبَارِ
u'شُرُوطٌ أخْذٌ':Added, #2: 2	شُرُوطُ الْإِجْزَاءِ
u'شُرُوطٌ أَدَاءٌ':Added, #1: 1	شُرُوطِ الْأَخْذِ
u'شُرُوطٌ أَدَاءٌ':Added, #1: 1	شُرُوطُ أَدَاءٍ
u'شُرُوطٌ أَدَاءٌ':Added, #2: 2	شُرُوطُ الْأَدَاءِ
u'شُرُوطٌ أَدَاءٌ':Added, #2: 2	شُرُوطِ الْأَدَاءِ
u'شُرُوطٌ إِرْثٌ':Added, #3: 3	شُرُوطِ أَدَاءِ
u'شُرُوطٌ اِسْتِطاعَةٌ':Added, #1: 1	شُرُوطِ الْإِرْثِ
u'شُرُوطٌ إِسْلامٌ':Added, #1: 1	شُرُوطِ اسْتِطَاعَةِ
u'شُرُوطٌ أصل':Added, #2: 2	شُرُوطُ الْإِسْلَامِ
u'شُرُوطٌ أًصْلٌ':Added, #8: 8	شُرُوطِ الْأَصْلِ
u'شُرُوطٌ اِعْتِبارٌ':Added, #8: 8	شُرُوطِ الْأَصْلِ
u'شُرُوطٌ إفْتَاءٌ':Added, #1: 1	شُرُوطُ اعْتِبَارِ
u'شُرُوطٌ إكْرَاهٌ':Added, #1: 1	شُرُوطِ الْإِفْتَاءِ
u'شُرُوطٌ إكْرَاهٌ':Added, #1: 1	شُرُوطَ الْإِكْرَاهِ
u'شُرُوطٌ إكْرَاهٌ':Added, #1: 1	شُرُوطِ الْإِكْرَاهِ
u'شُرُوطٌ إمَارَةٌ':Added, #2: 2	شُرُوطُ الْإِكْرَاهِ
u'شُرُوطٌ إمَارَةٌ':Added, #1: 1	شُرُوطِ الْإِمَارَةِ
u'شُرُوطٌ إمَامَةٌ':Added, #3: 3	شُرُوطُ الْإِمَارَةِ
u'شُرُوطٌ إمَامَةٌ':Added, #3: 3	شُرُوطُ الْإِمَامَةِ
u'شُرُوطٌ اِمْتِناعٌ':Added, #6: 6	شُرُوطِ الْإِمَامَةِ
u'شُرُوطٌ إِمْكانٌ':Added, #1: 1	شُرُوطِ امْتِنَاعِ
u'شُرُوطٌ أَميرٌ':Added, #1: 1	شُرُوطِ الْإِمْكَانِ
u'شُرُوطٌ اِنْعِقَادٌ':Added, #1: 1	شُرُوطِ أَمِيرِ
u'شُرُوطٌ إِنْفاقٌ':Added, #1: 1	شُرُوطِ انْعِقَادِ
u'شُرُوطٌ إِنْكارٌ':Added, #1: 1	شُرُوطِ الْإِنْفَاقِ
u'شُرُوطٌ إهْدَارٌ':Added, #1: 1	شُرُوطِ الْإِنْكَارِ
u'شُرُوطٌ أَيْمَانٌ':Added, #1: 1	شُرُوطُ الْإِهْدَارِ
u'شُرُوطٌ بَراءةٌ':Added, #2: 2	شُرُوطِ الْأَيْمَانِ
u'شُرُوطٌ بَراءةٌ':Added, #1: 1	شُرُوطَ الْبَرَاءَةِ
u'شُرُوطٌ بِنَاءٌ':Added, #1: 1	شُرُوطُ الْبَرَاءَةِ
u'شُرُوطٌ بَيْعٌ':Added, #2: 2	شُرُوطِ الْبِنَاءِ
u'شُرُوطٌ بَيْعٌ':Added, #19: 19	شُرُوطِ الْبَيْعِ
u'شُرُوطٌ بَيْعٌ':Added, #1: 1	شُرُوطَ بَيْعِ
u'شُرُوطٌ بَيْعٌ':Added, #1: 1	شُرُوطِ بَيْعِ
u'شُرُوطٌ بَيْعٌ':Added, #3: 3	شُرُوطَ الْبَيْعِ
u'شُرُوطٌ بَيْعَةٌ':Added, #9: 9	شُرُوطُ الْبَيْعِ
u'شُرُوطٌ تَجْرِبَةٌ':Added, #1: 1	شُرُوطُ الْبَيْعَةِ
u'شُرُوطٌ تَحْرِيمٌ':Added, #1: 1	شُرُوطُ التَّجْرِبَةِ
u'شُرُوطٌ تَحْلِيلٌ':Added, #1: 1	شُرُوطِ التَّحْرِيمِ
u'شُرُوطٌ تَحَمُّلٌ':Added, #2: 2	شُرُوطِ التَّحْلِيلِ
u'شُرُوطٌ تَخْيِيرٌ':Added, #1: 1	شُرُوطِ التَّحَمُّلِ
u'شُرُوطٌ تَخْيِيرٌ':Added, #1: 1	شُرُوطِ التَّخْيِيرِ
u'شُرُوطٌ تَزَوُّجٌ':Added, #2: 2	شُرُوطُ التَّخْيِيرِ
u'شُرُوطٌ تَزَوُّجٌ':Added, #1: 1	شُرُوطُ تَزَوُّجِ
u'شُرُوطٌ تِسْعَةٌ':Added, #1: 1	شُرُوطِ تَزَوُّجِ
u'شُرُوطٌ تَشَهُّدٌ':Added, #1: 1	شُرُوطٍ تِسْعَةٍ
u'شُرُوطٌ تَعْجِيل':Added, #1: 1	شُرُوطُ التَّشَهُّدِ
u'شُرُوطٌ تَعْلِيلٌ':Added, #1: 1	شُرُوطُ التَّعْجِيلِ
u'شُرُوطٌ تَغْسِيلٌ':Added, #1: 1	شُرُوطَ التَّعْلِيلِ
u'شُرُوطٌ تَغْيِيرٌ':Added, #1: 1	شُرُوطِ التَّغْسِيلِ
u'شُرُوطٌ تَقْديمٌ':Added, #1: 1	شُرُوطِ تَغْيِيرِهِ
u'شُرُوطٌ تَقْليدٌ':Added, #1: 1	شُرُوطُ التَّقْدِيمِ
u'شُرُوطٌ تَقْليد':Added, #1: 1	شُرُوطُ التَّقْلِيدِ
u'شُرُوطٌ تَقْليدٌ':Added, #1: 1	شُرُوطُ التَّقْلِيدِ
u'شُرُوطٌ تَقْليد':Added, #4: 4	شُرُوطِ التَّقْلِيدِ
u'شُرُوطٌ تَكْليفٌ':Added, #4: 4	شُرُوطِ التَّقْلِيدِ
u'شُرُوطٌ تَمَتُّعٌ':Added, #1: 1	شُرُوطَ التَّكْلِيفِ
u'شُرُوطٌ تَمْييزٌ':Added, #1: 1	شُرُوطِ التَّمَتُّعِ
u'شُرُوطٌ تَمْييزٌ':Added, #12: 12	شُرُوطِ التَّمْيِيزِ
u'شُرُوطٌ تَمْييزٌ':Added, #1: 1	شُرُوطَ تَمْيِيزِ
u'شُرُوطٌ تَنَاقُضٌ':Added, #3: 3	شُرُوطُ التَّمْيِيزِ
u'شُرُوطٌ تَوَاتُرٌ':Added, #1: 1	شُرُوطَ التَّنَاقُضِ
u'شُرُوطٌ تَوَاتُرٌ':Added, #1: 1	شُرُوطَ التَّوَاتُرِ
u'شُرُوطٌ تَوْبَةٌ':Added, #1: 1	شُرُوطِ التَّوَاتُرِ
u'شُرُوطٌ تَوْبَةٌ':Added, #1: 1	شُرُوطُ التَّوْبَةِ
u'شُرُوطٌ تَوْبَةٌ':Added, #3: 3	شُرُوطَ التَّوْبَةِ
u'شُرُوطٌ ثُبُوتٌ':Added, #3: 3	شُرُوطِ التَّوْبَةِ
u'شُرُوطٌ ثَلاثَةٌ':Added, #1: 1	شُرُوطِ ثُبُوتِ
u'شُرُوطٌ ثَمَنٌ':Added, #2: 2	شُرُوطٍ ثَلَاثَةٍ
u'شُرُوطٌ جمعة':Added, #1: 1	شُرُوطُ الثَّمَنِ
u'شُرُوطٌ جُمُعَةٌ':Added, #3: 3	شُرُوطِ الْجُمُعَةِ
u'شُرُوطٌ جمعة':Added, #3: 3	شُرُوطِ الْجُمُعَةِ
u'شُرُوطٌ جُمُعَةٌ':Added, #4: 4	شُرُوطُ الْجُمُعَةِ
u'شُرُوطٌ جهاد':Added, #4: 4	شُرُوطُ الْجُمُعَةِ
u'شُرُوطٌ جِهَادٌ':Added, #1: 1	شُرُوطُ الْجِهَادِ
u'شُرُوطٌ جَوَازٌ':Added, #1: 1	شُرُوطُ الْجِهَادِ
u'شُرُوطٌ جَوَازٌ':Added, #1: 1	شُرُوطَ الْجَوَازِ
u'شُرُوطٌ جَوَازٌ':Added, #1: 1	شُرُوطِ الْجَوَازِ
u'شُرُوطٌ جَوَازٌ':Added, #1: 1	شُرُوطُ جَوَازٍ
u'شُرُوطٌ جَوَازٌ':Added, #1: 1	شُرُوطُ جَوَازِ
u'شُرُوطٌ جَوَازٌ':Added, #1: 1	شُرُوطِ جَوَازِهِ
u'شُرُوطٌ حاضِنٌ':Added, #4: 4	شُرُوطِ جَوَازِ
u'شُرُوطٌ حَجٌّ':Added, #1: 1	شُرُوطِ الْحَاضِنِ
u'شُرُوطٌ حَجٌّ':Added, #1: 1	شُرُوطُ الْحَجِّ
u'شُرُوطٌ حُجَّة':Added, #2: 2	شُرُوطَ الْحَجِّ
u'شُرُوطٌ حُجِّيَّة':Added, #1: 1	شُرُوطُ حُجِّيَّةِ
u'شُرُوطٌ حَدٌّ':Added, #1: 1	شُرُوطُ حُجِّيَّةِ
u'شُرُوطٌ حَدٌّ':Added, #2: 2	شُرُوطُ الْحَدِّ
u'شُرُوطٌ حَرْبٌ':Added, #2: 2	شُرُوطِ حَدِّ
u'شُرُوطٌ حَضَانَةٌ':Added, #1: 1	شُرُوطَ الْحَرْبِ
u'شُرُوطٌ حُضورٌ':Added, #1: 1	شُرُوطِ الْحَضَانَةِ
u'شُرُوطٌ حُضُورٌ':Added, #1: 1	شُرُوطُ الْحُضُورِ
u'شُرُوطٌ حُكْمٌ':Added, #1: 1	شُرُوطُ الْحُضُورِ
u'شُرُوطٌ حُكْمٌ':Added, #1: 1	شُرُوطَ الْحُكْمِ
u'شُرُوطٌ حِلٌّ':Added, #9: 9	شُرُوطِ حُكْمِ
u'شُرُوطٌ حَمْلٌ':Added, #3: 3	شُرُوطِ حِلِّ
u'شُرُوطٌ حَوَالَةٌ':Added, #1: 1	شُرُوطُ حَمْلِ
u'شُرُوطٌ حَوَالَةٌ':Added, #1: 1	شُرُوطَ الْحَوَالَةِ
u'شُرُوطٌ حِيازَة':Added, #1: 1	شُرُوطِ الْحَوَالَةِ
u'شُرُوطٌ خطبة':Added, #2: 2	شُرُوطِ حِيَازَةِ
u'شُرُوطٌ خُطْبَةٌ':Added, #1: 1	شُرُوطُ خُطْبَةِ
u'شُرُوطٌ خطبة':Added, #1: 1	شُرُوطُ خُطْبَةِ
u'شُرُوطٌ خُطْبَةٌ':Added, #2: 2	شُرُوطِ الْخُطْبَةِ
u'شُرُوطٌ خِلاَفَةٌ':Added, #2: 2	شُرُوطِ الْخُطْبَةِ
u'شُرُوطٌ دُعَاءٌ':Added, #1: 1	شُرُوطِ الْخِلَافَةِ
u'شُرُوطٌ دَلالَةٌ':Added, #1: 1	شُرُوطَ الدُّعَاءِ
u'شُرُوطٌ دَليلٌ':Added, #1: 1	شُرُوطِ الدَّلَالَةِ
u'شُرُوطٌ رَأْيٌ':Added, #1: 1	شُرُوطَ الدَّلِيلِ
u'شُرُوطٌ رجعة':Added, #1: 1	شُرُوطَ الرَّأْيِ
u'شُرُوطٌ رَجْعَةٌ':Added, #1: 1	شُرُوطِ الرَّجْعَةِ
u'شُرُوطٌ رُجُوعٌ':Added, #1: 1	شُرُوطِ الرَّجْعَةِ
u'شُرُوطٌ رُجُوعٌ':Added, #1: 1	شُرُوطِ الرُّجُوعِ
u'شُرُوطٌ رَدٌّ':Added, #1: 1	شُرُوطِ رُجُوعِهِ
u'شُرُوطٌ رُكْنٌ':Added, #4: 4	شُرُوطِ الرَّدِّ
u'شُرُوطٌ رُكْن':Added, #1: 1	شُرُوطِ الرُّكْنِ
u'شُرُوطٌ زَكاةٌ':Added, #1: 1	شُرُوطِ الرُّكْنِ
u'شُرُوطٌ سَائِرٌ':Added, #1: 1	شُرُوطِ الزَّكَاةِ
u'شُرُوطٌ سَائِرٌ':Added, #1: 1	شُرُوطُ سَائِرِ
u'شُرُوطٌ سَبَقٌ':Added, #1: 1	شُرُوطِ سَائِرِ
u'شُرُوطٌ سَلَمٌ':Added, #1: 1	شُرُوطِ السَّبَقِ
u'شُرُوطٌ سَلَمٌ':Added, #2: 2	شُرُوطَ السَّلَمِ
u'شُرُوطٌ سُؤَالٌ':Added, #7: 7	شُرُوطِ السَّلَمِ
u'شُرُوطٌ سِياسَةٌ':Added, #1: 1	شُرُوطِ السُّؤَالِ
u'شُرُوطٌ شركة':Added, #1: 1	شُرُوطِ السِّيَاسَةِ
u'شُرُوطٌ شَرِكَةٌ':Added, #1: 1	شُرُوطِ شَرِكَةِ
u'شُرُوطٌ شَهَادَةٌ':Added, #1: 1	شُرُوطِ شَرِكَةِ
u'شُرُوطٌ شَهَادَةٌ':Added, #4: 4	شُرُوطِ الشَّهَادَةِ
u'شُرُوطٌ صِحَّةٌ':Added, #8: 8	شُرُوطُ الشَّهَادَةِ
u'شُرُوطٌ صِحَّةٌ':Added, #11: 11	شُرُوطِ صِحَّةِ
u'شُرُوطٌ صِحَّةٌ':Added, #1: 1	شُرُوطُ الصِّحَّةِ
u'شُرُوطٌ صِحَّةٌ':Added, #1: 1	شُرُوطِ صِحَّةٍ
u'شُرُوطٌ صِحَّةٌ':Added, #2: 2	شُرُوطَ الصِّحَّةِ
u'شُرُوطٌ صِحَّةٌ':Added, #2: 2	شُرُوطَ صِحَّةِ
u'شُرُوطٌ صِحَّةٌ':Added, #2: 2	شُرُوطُ صِحَّةٍ
u'شُرُوطٌ صِحَّةٌ':Added, #2: 2	شُرُوطُ صِحَّةِ
u'شُرُوطٌ صِحَّةٌ':Added, #2: 2	شُرُوطِ صِحّةِ
u'شُرُوطٌ صِحَّةٌ':Added, #2: 2	شُرُوطُ صِحَّتِهِ
u'شُرُوطٌ صِحَّةٌ':Added, #2: 2	شُرُوطِ صِحَّتِهِ
u'شُرُوطٌ صداق':Added, #4: 4	شُرُوطِ الصِّحَّةِ
u'شُرُوطٌ صَدَاقٌ':Added, #1: 1	شُرُوطِ الصَّدَاقِ
u'شُرُوطٌ صَلاَةٌ':Added, #1: 1	شُرُوطِ الصَّدَاقِ
u'شُرُوطٌ صَلاَةٌ':Added, #1: 1	شُرُوطَ الصَّلَاةِ
u'شُرُوطٌ صَلاَةٌ':Added, #1: 1	شُرُوطِ صَلَاةِ
u'شُرُوطٌ صَلاَةٌ':Added, #3: 3	شُرُوطُ الصَّلَاةِ
u'شُرُوطٌ صلح':Added, #90: 90	شُرُوطِ الصَّلَاةِ
u'شُرُوطٌ صلح':Added, #1: 1	شُرُوطَ الصّلْحِ
u'شُرُوطٌ صُلْحٌ':Added, #1: 1	شُرُوطُ الصُّلْحِ
u'شُرُوطٌ صُلْحٌ':Added, #1: 1	شُرُوطَ الصّلْحِ
u'شُرُوطٌ صَوْمٌ':Added, #1: 1	شُرُوطُ الصُّلْحِ
u'شُرُوطٌ صَوْمٌ':Added, #1: 1	شُرُوطَ الصَّوْمِ
u'شُرُوطٌ صِيَامٌ':Added, #2: 2	شُرُوطِ الصَّوْمِ
u'شُرُوطٌ طَاعَةٌ':Added, #1: 1	شُرُوطِ الصِّيَامِ
u'شُرُوطٌ طَلاَقٌ':Added, #1: 1	شُرُوطَ الطَّاعَاتِ
u'شُرُوطٌ طواف':Added, #1: 1	شُرُوطِ الطَّلَاقِ
u'شُرُوطٌ طَوَافٌ':Added, #2: 2	شُرُوطُ الطَّوَافِ
u'شُرُوطٌ طواف':Added, #2: 2	شُرُوطُ الطَّوَافِ
u'شُرُوطٌ طَوَافٌ':Added, #9: 9	شُرُوطِ الطَّوَافِ
u'شُرُوطٌ ظَهِير':Added, #9: 9	شُرُوطِ الطَّوَافِ
u'شُرُوطٌ ظَهِيرَة':Added, #1: 1	شُرُوطِ الظَّهِيرِيَّةِ
u'شُرُوطٌ عِبَادَةٌ':Added, #1: 1	شُرُوطِ الظَّهِيرِيَّةِ
u'شُرُوطٌ عَدٌّ':Added, #1: 1	شُرُوطِ الْعِبَادَاتِ
u'شُرُوطٌ عَقْدٌ':Added, #1: 1	شُرُوطِ الْعَدِّ
u'شُرُوطٌ عَقْدٌ':Added, #1: 1	شُرُوطِ عَقْدِهِ
u'شُرُوطٌ عُقُودٌ':Added, #4: 4	شُرُوطِ الْعَقْدِ
u'شُرُوطٌ عِلَّةٌ':Added, #1: 1	شُرُوطُ الْعُقُودِ
u'شُرُوطٌ عِوَضٌ':Added, #16: 16	شُرُوطِ الْعِلَّةِ
u'شُرُوطٌ فَرْعٌ':Added, #1: 1	شُرُوطِ عِوَضِ
u'شُرُوطٌ فَسْخٌ':Added, #13: 13	شُرُوطِ الْفَرْعِ
u'شُرُوطٌ فَوْرٌ':Added, #1: 1	شُرُوطُ الْفَسْخِ
u'شُرُوطٌ قَاعِدٌ':Added, #1: 1	شُرُوطُ الْفَوْرِ
u'شُرُوطٌ قَبُولٌ':Added, #1: 1	شُرُوطِ قَاعِدَةِ
u'شُرُوطٌ قتل':Added, #1: 1	شُرُوطِ قَبُولِهِ
u'شُرُوطٌ قَتْلٌ':Added, #1: 1	شُرُوطِ الْقَتْلِ
u'شُرُوطٌ قُدْوَةٌ':Added, #1: 1	شُرُوطِ الْقَتْلِ
u'شُرُوطٌ قُدْوَةٌ':Added, #1: 1	شُرُوطَ الْقُدْوَةِ
u'شُرُوطٌ قراض':Added, #2: 2	شُرُوطِ الْقُدْوَةِ
u'شُرُوطٌ قَرْضٌ':Added, #1: 1	شُرُوطِ الْقِرَاضِ
u'شُرُوطٌ قَسام':Added, #1: 1	شُرُوطِ الْقَرْضِ
u'شُرُوطٌ قَسامَة':Added, #1: 1	شُرُوط الْقَسَامَةِ
u'شُرُوطٌ قسمة':Added, #1: 1	شُرُوط الْقَسَامَةِ
u'شُرُوطٌ قِسْمَةٌ':Added, #1: 1	شُرُوطِ الْقِسْمَةِ
u'شُرُوطٌ قسمة':Added, #1: 1	شُرُوطِ الْقِسْمَةِ
u'شُرُوطٌ قِسْمَةٌ':Added, #1: 1	شُرُوطِ قِسْمَةِ
u'شُرُوطٌ قصاص':Added, #1: 1	شُرُوطِ قِسْمَةِ
u'شُرُوطٌ قِصَاصٌ':Added, #3: 3	شُرُوطَ الْقِصَاصِ
u'شُرُوطٌ قصاص':Added, #3: 3	شُرُوطَ الْقِصَاصِ
u'شُرُوطٌ قِصَاصٌ':Added, #5: 5	شُرُوطِ الْقِصَاصِ
u'شُرُوطٌ قَصْرٌ':Added, #5: 5	شُرُوطِ الْقِصَاصِ
u'شُرُوطٌ قَضَاءٌ':Added, #1: 1	شُرُوطِ الْقَصْرِ
u'شُرُوطٌ قَضَاءٌ':Added, #1: 1	شُرُوطُ الْقَضَاءِ
u'شُرُوطٌ قَضَاءٌ':Added, #2: 2	شُرُوطَ الْقَضَاءِ
u'شُرُوطٌ قَوَد':Added, #3: 3	شُرُوطِ الْقَضَاءِ
u'شُرُوطٌ قِيَاسٌ':Added, #2: 2	شُرُوطِ الْقَوَدِ
u'شُرُوطٌ قِيَاسٌ':Added, #1: 1	شُرُوطُ الْقِيَاسِ
u'شُرُوطٌ قيام':Added, #3: 3	شُرُوطِ الْقِيَاسِ
u'شُرُوطٌ قِيَامٌ':Added, #1: 1	شُرُوطِ الْقِيَامِ
u'شُرُوطٌ كَرَمٌ':Added, #1: 1	شُرُوطِ الْقِيَامِ
u'شُرُوطٌ كفاء':Added, #1: 1	شُرُوطِ الْكَرَمِ
u'شُرُوطٌ كِفَاءٌ':Added, #1: 1	شُرُوطِ الْكِفَاءِ
u'شُرُوطٌ كَفَاءةٌ':Added, #1: 1	شُرُوطِ الْكِفَاءِ
u'شُرُوطٌ كَفَّارٌ':Added, #6: 6	شُرُوطِ الْكَفَاءَةِ
u'شُرُوطٌ كَفَّارٌ':Added, #1: 1	شُرُوطُ الْكَفَّارَاتِ
u'شُرُوطٌ كَفَّارٌ':Added, #1: 1	شُرُوطَ الْكَفَّارَةِ
u'شُرُوطٌ كَفَّارَةٌ':Added, #1: 1	شُرُوطِ الْكَفَّارَةِ
u'شُرُوطٌ كَفَّارَةٌ':Added, #1: 1	شُرُوطُ الْكَفَّارَاتِ
u'شُرُوطٌ كَفَّارَةٌ':Added, #1: 1	شُرُوطَ الْكَفَّارَةِ
u'شُرُوطٌ كَمَالٌ':Added, #1: 1	شُرُوطِ الْكَفَّارَةِ
u'شُرُوطٌ كَوْنٌ':Added, #1: 1	شُرُوطُ الْكَمَالِ
u'شُرُوطٌ مُبَاشِرٌ':Added, #1: 1	شُرُوطُ كَوْنِهِ
u'شُرُوطٌ مَبِيعٌ':Added, #1: 1	شُرُوطِ الْمُبَاشِرِ
u'شُرُوطٌ مَبِيعٌ':Added, #2: 2	شُرُوطُ الْمَبِيعِ
u'شُرُوطٌ مُتْعَةٌ':Added, #3: 3	شُرُوطِ الْمَبِيعِ
u'شُرُوطٌ مُتَوَاتِرٌ':Added, #1: 1	شُرُوطِ الْمُتْعَةِ
u'شُرُوطٌ مُجْتَهِد':Added, #3: 3	شُرُوطُ الْمُتَوَاتِرِ
u'شُرُوطٌ مَحْرَمٌ':Added, #1: 1	شُرُوطِ الْمُجْتَهِدِ
u'شُرُوطٌ مَذْهَبٌ':Added, #1: 1	شُرُوطَ الْمَحْرَمِ
u'شُرُوطٌ مُرُوءةٌ':Added, #1: 1	شُرُوطُ الْمَذْهَبِ
u'شُرُوطٌ مُرُوءةٌ':Added, #2: 2	شُرُوطُ الْمُرُوءَةِ
u'شُرُوطٌ مُساقاة':Added, #5: 5	شُرُوطِ الْمُرُوءَةِ
u'شُرُوطٌ مَسْجِدٌ':Added, #2: 2	شُرُوطِ الْمُسَاقَاةِ
u'شُرُوطٌ مَسْجِدٌ':Added, #1: 1	شُرُوطُ الْمَسْجِدِ
u'شُرُوطٌ مَسْرُوقٌ':Added, #1: 1	شُرُوطِ الْمَسْجِدِ
u'شُرُوطٌ مَصَالِحُ':Added, #3: 3	شُرُوطِ الْمَسْرُوقِ
u'شُرُوطٌ مَصِيد':Added, #1: 1	شُرُوطِ الْمَصَالِحِ
u'شُرُوطٌ مُضَارَبَةٌ':Added, #1: 1	شُرُوطَ الْمَصِيدِ
u'شُرُوطٌ مَضْمُونٌ':Added, #1: 1	شُرُوطِ الْمُضَارَبَةِ
u'شُرُوطٌ مُطْلَقٌ':Added, #1: 1	شُرُوطِ الْمَضْمُونِ
u'شُرُوطٌ مَعْرُوفٌ':Added, #1: 1	شُرُوطِ مُطْلَقِ
u'شُرُوطٌ مَعْرُوفٌ':Added, #1: 1	شُرُوطُ الْمَعْرُوفِ
u'شُرُوطٌ مُفَاوَضَةٌ':Added, #2: 2	شُرُوطِ الْمَعْرُوفِ
u'شُرُوطٌ مَفْعُولٌ':Added, #2: 2	شُرُوطِ الْمُفَاوَضَةِ
u'شُرُوطٌ مُفْلِسٌ':Added, #1: 1	شُرُوطِ الْمَفْعُولِ
u'شُرُوطٌ مَفْهُومٌ':Added, #1: 1	شُرُوطَ الْمُفْلِسِ
u'شُرُوطٌ مُكَلَّفٌ':Added, #2: 2	شُرُوطُ مَفْهُومِ
u'شُرُوطٌ مَنْفَعَةٌ':Added, #1: 1	شُرُوطُ الْمُكَلَّفِ
u'شُرُوطٌ نَاظِرٌ':Added, #1: 1	شُرُوطِ الْمَنْفَعَةِ
u'شُرُوطٌ نُسَخٌ':Added, #1: 1	شُرُوطِ النَّاظِرِ
u'شُرُوطٌ نُفُوذٌ':Added, #2: 2	شُرُوطَ النُّسَخِ
u'شُرُوطٌ نَفْيٌ':Added, #1: 1	شُرُوطِ النُّفُوذِ
u'شُرُوطٌ نكاح':Added, #1: 1	شُرُوطُ النَّفْيِ
u'شُرُوطٌ نكاح':Added, #1: 1	شُرُوطَ نِكَاحِ
u'شُرُوطٌ نِكَاحٌ':Added, #1: 1	شُرُوطُ نِكَاحِ
u'شُرُوطٌ نِكَاحٌ':Added, #1: 1	شُرُوطَ نِكَاحِ
u'شُرُوطٌ نكاح':Added, #1: 1	شُرُوطُ نِكَاحِ
u'شُرُوطٌ نِكَاحٌ':Added, #2: 2	شُرُوطَ النِّكَاحِ
u'شُرُوطٌ نكاح':Added, #2: 2	شُرُوطَ النِّكَاحِ
u'شُرُوطٌ نِكَاحٌ':Added, #6: 6	شُرُوطِ النِّكَاحِ
u'شُرُوطٌ نَوَازِلُ':Added, #6: 6	شُرُوطِ النِّكَاحِ
u'شُرُوطٌ هِبَةٌ':Added, #1: 1	شُرُوطِ النَّوَازِلِ
u'شُرُوطٌ هِبَةٌ':Added, #1: 1	شُرُوطُ الْهِبَةِ
u'شُرُوطٌ وَاقِعٌ':Added, #2: 2	شُرُوطِ الْهِبَةِ
u'شُرُوطٌ وَاقِعَةٌ':Added, #1: 1	شُرُوطَ الْوَاقِعَةِ
u'شُرُوطٌ وَاقِفٌ':Added, #1: 1	شُرُوطَ الْوَاقِعَةِ
u'شُرُوطٌ وَاقِفٌ':Added, #1: 1	شُرُوط الْوَاقِفِ
u'شُرُوطٌ وَاقِفٌ':Added, #2: 2	شُرُوطُ الْوَاقِفِ
u'شُرُوطٌ وَاقِفٌ':Added, #4: 4	شُرُوطَ الْوَاقِفِ
u'شُرُوطٌ وُجُوبٌ':Added, #5: 5	شُرُوطِ الْوَاقِفِ
u'شُرُوطٌ وُجُوبٌ':Added, #1: 1	شُرُوطُ الْوُجُوبِ
u'شُرُوطٌ وُجُوبٌ':Added, #2: 2	شُرُوطَ الْوُجُوبِ
u'شُرُوطٌ وُجُوبٌ':Added, #2: 2	شُرُوطِ وُجُوبٍ
u'شُرُوطٌ وُجُوبٌ':Added, #3: 3	شُرُوطِ الْوُجُوبِ
u'شُرُوطٌ وُجُوبٌ':Added, #3: 3	شُرُوطُ وُجُوبِ
u'شُرُوطٌ وُجُودٌ':Added, #8: 8	شُرُوطِ وُجُوبِ
u'شُرُوطٌ وَصِيٌّ':Added, #1: 1	شُرُوطِ وُجُودِ
u'شُرُوطٌ وُضُوءٌ':Added, #1: 1	شُرُوطُ الْوَصِيِّ
u'شُرُوطٌ وُضُوءٌ':Added, #1: 1	شُرُوطُ الْوُضُوءِ
u'شُرُوطٌ وَطْءٌ':Added, #4: 4	شُرُوطِ الْوُضُوءِ
u'شُرُوطٌ وَقْفٌ':Added, #1: 1	شُرُوطُ وَطْءِ
u'شُرُوطٌ وَقْفٌ':Added, #1: 1	شُرُوطُ الْوَقْفِ
u'شُرُوطٌ وَقْفٌ':Added, #2: 2	شُرُوطَ الْوَقْفِ
u'شُرُوطٌ وُقُوعٌ':Added, #2: 2	شُرُوطِ الْوَقْفِ
u'شُرُوطٌ وِلاَيَةٌ':Added, #1: 1	شُرُوطُ وُقُوعِ
u'شُرُوطٌ وِلاَيَةٌ':Added, #1: 1	شُرُوطُ الْوِلَايَةِ
u'شُرُوطٌ وِلاَيَةٌ':Added, #1: 1	شُرُوطِ وِلَايَةِ
u'شُرُوطٌ وَلِيٌّ':Added, #2: 2	شُرُوطِ الْوِلَايَةِ
u'شُرُوطٌ وَلِيٌّ':Added, #1: 1	شُرُوطَ الْوَلِيِّ
u'شُرُوطٌ وَلِيٌّ':Added, #1: 1	شُرُوطُ الْوَلِيِّ
u'شُرُوطٌ وَلِيٌّ':Added, #1: 1	شُرُوطِ الْوَلِيِّ
u'شُرُوعٌ إمَامٌ':Added, #1: 1	شُرُوطِ وَلِيِّ
u'شُرُوعٌ إمَامٌ':Added, #2: 2	شُرُوعَ الْإِمَامِ
u'شُرُوعٌ خَطِيبٌ':Added, #5: 5	شُرُوعِ الْإِمَامِ
u'شُرُوعٌ ظِلٌّ':Added, #1: 1	شُرُوعِ الْخَطِيبِ
u'شُرُوعٌ عَامِلٌ':Added, #1: 1	شُرُوعِ الظِّلِّ
u'شُرُوعٌ قَارِئٌ':Added, #1: 1	شُرُوعِ الْعَامِلِ
u'شُرُوعٌ قَارِئٌ':Added, #1: 1	شُرُوعُ الْقَارِئِ
u'شُرُوعٌ مُؤَذِّنٌ':Added, #1: 1	شُرُوعِ الْقَارِئِ
u'شَرِيَ أَمْرٌ':Subject, #1: 1	شُرُوعِ الْمُؤَذِّنِ
u'شَرَى بِزْرٌ':Predicate, #2: 2	شَرِيَ الْأَمْرُ
u'شَرَى بَقَرٌ':Predicate, #3: 3	شَرَى بِزْرَ
u'شَرِيَ جلد':Subject, #1: 1	شَرَى بَقَرَةً
u'شَرِيَ جِلْدٌ':Subject, #1: 1	شَرِيَ جِلْدُ
u'شَرَى حَبٌّ':Predicate, #1: 1	شَرِيَ جِلْدُ
u'شَرَى دَجاج':Predicate, #1: 1	شَرَى حَبَّ
u'شَرَى طَلاَقٌ':Predicate, #1: 1	شَرَى الدَّجَاجَةَ
u'شَرَى عُلُوٌّ':Predicate, #1: 1	شَرَى الطَّلَاقَ
u'شَرَى مَبِيعٌ':Predicate, #1: 1	شَرَى عُلُوَّ
u'شَرَى نِصْفٌ':Predicate, #1: 1	شَرَى الْمَبِيعَ
u'شَطْرٌ آيَةٌ':Added, #1: 1	شَرَى نِصْفَ
u'شَطْرٌ آيَةٌ':Added, #1: 1	شَطْرَ آيَةٍ
u'شَطْرٌ إيمَانٌ':Added, #1: 1	شَطْرُ آيَةٍ
u'شَطْرٌ إيمَانٌ':Added, #2: 2	شَطْرُ الإِيمَانِ
u'شَطْرٌ بَيْتٌ':Added, #6: 6	شَطْرُ الْإِيمَانِ
u'شَطْرٌ بَيْتٌ':Added, #1: 1	شَطْرَ بَيْتٍ
u'شَطْرٌ بَيِّنَةٌ':Added, #1: 1	شَطْرُ بَيْتٍ
u'شَطْرٌ تَمْرٌ':Added, #1: 1	شَطْرَ الْبَيِّنَةِ
u'شَطْرٌ جَمْعٌ':Added, #1: 1	شَطْرَ تَمْرٍ
u'شَطْرٌ حالَةٌ':Added, #2: 2	شَطْرَ جَمْعٍ
u'شَطْرٌ حُسْنٌ':Added, #2: 2	شَطْرُ حَالَةِ
u'شَطْرٌ حُسْنٌ':Added, #1: 1	شَطْرُ الْحُسْنِ
u'شَطْرٌ حَقٌّ':Added, #2: 2	شَطْرَ الْحُسْنِ
u'شَطْرٌ دِينٌ':Added, #1: 1	شَطْرَ الْحَقِّ
u'شَطْرٌ سَنَةٌ':Added, #2: 2	شَطْرِ دِينِهِ
u'شَطْرٌ شَرْطٌ':Added, #1: 1	شَطْرُ السَّنَةِ
u'شَطْرٌ شَهَادَةٌ':Added, #2: 2	شَطْرَ الشَّرْطِ
u'شَطْرٌ شَيْءٌ':Added, #1: 1	شَطْرِ الشَّهَادَةِ
u'شَطْرٌ صداق':Added, #1: 1	شَطْرُ الشَّيْءِ
u'شَطْرٌ صَدَاقٌ':Added, #1: 1	شَطْرَ الصَّدَاقِ
u'شَطْرٌ صَلاَةٌ':Added, #1: 1	شَطْرَ الصَّدَاقِ
u'شَطْرٌ صَلاَةٌ':Added, #14: 14	شَطْرِ الصَّلَاةِ
u'شَطْرٌ صَلاَةٌ':Added, #1: 1	شَطْرَ الصَّلاةِ
u'شَطْرٌ صَلاَةٌ':Added, #1: 1	شَطْرَ الصَّلاَةِ
u'شَطْرٌ صَلاَةٌ':Added, #2: 2	شَطْرُ الصَّلَاةِ
u'شَطْرٌ صَلاَحٌ':Added, #7: 7	شَطْرَ الصَّلَاةِ
u'شَطْرٌ ظُهْرٌ':Added, #1: 1	شَطْرَ صَلَاحِهِ
u'شَطْرٌ عَدَدٌ':Added, #1: 1	شَطْرَ الظُّهْرِ
u'شَطْرٌ عَقْدٌ':Added, #1: 1	شَطْرِ عَدَدِ
u'شَطْرٌ عَقْدٌ':Added, #12: 12	شَطْرُ الْعَقْدِ
u'شَطْرٌ عَقْدٌ':Added, #1: 1	شَطْرِ الْعَقْدِ
u'شَطْرٌ عَقْدٌ':Added, #1: 1	شَطْرُ عَقْدِهِ
u'شَطْرٌ عِلَّةٌ':Added, #8: 8	شَطْرَ الْعَقْدِ
u'شَطْرٌ عِلَّةٌ':Added, #1: 1	شَطْرَ الْعِلَّةِ
u'شَطْرٌ عِلَّةٌ':Added, #1: 1	شَطْرُ عِلَّةِ
u'شَطْرٌ عِلَّةٌ':Added, #2: 2	شَطْرِ الْعِلَّةِ
u'شَطْرٌ علم':Added, #4: 4	شَطْرُ الْعِلَّةِ
u'شَطْرٌ عِلْمٌ':Added, #1: 1	شَطْرَ الْعِلْمِ
u'شَطْرٌ فساد':Added, #1: 1	شَطْرَ الْعِلْمِ
u'شَطْرٌ فَسَادٌ':Added, #1: 1	شَطْرَ فَسَادِهِ
u'شَطْرٌ قدم':Added, #1: 1	شَطْرَ فَسَادِهِ
u'شَطْرٌ قَدَمٌ':Added, #2: 2	شَطْرِ الْقَدَمِ
u'شَطْرٌ كعبة':Added, #2: 2	شَطْرِ الْقَدَمِ
u'شَطْرٌ كَعْبَةٌ':Added, #2: 2	شَطْرِ الْكَعْبَةِ
u'شَطْرٌ كَلِمَةٌ':Added, #2: 2	شَطْرِ الْكَعْبَةِ
u'شَطْرٌ كَلِمَةٌ':Added, #1: 1	شَطْرُ الْكَلِمَةِ
u'شَطْرٌ كَلِمَةٌ':Added, #1: 1	شَطْرُ كَلِمَةٍ
u'شَطْرٌ كَلِمَةٌ':Added, #1: 1	شَطْرِ كَلِمَةٍ
u'شَطْرٌ لَيْلٌ':Added, #4: 4	شَطْرَ كَلِمَةٍ
u'شَطْرٌ لَيْلٌ':Added, #12: 12	شَطْرِ اللَّيْلِ
u'شَطْرٌ لَيْلٌ':Added, #1: 1	شَطْرَ اللَّيْلِ
u'شَطْرٌ مَالٌ':Added, #7: 7	شَطْرُ اللَّيْلِ
u'شَطْرٌ مَالٌ':Added, #1: 1	شَطْرِ مَالِهِ
u'شَطْرٌ مَالٌ':Added, #3: 3	شَطْرَ مَالِهِ
u'شَطْرٌ مِدَادٌ':Added, #3: 3	شَطْرُ مَالِهِ
u'شَطْرٌ مَسَائِلُ':Added, #1: 1	شَطْرِ الْمِدَادِ
u'شَطْرٌ مَسْجِدٌ':Added, #1: 1	شَطْرُ الْمَسَائِلِ
u'شَطْرٌ مَغْرِبٌ':Added, #21: 21	شَطْرَ الْمَسْجِدِ
u'شَطْرٌ مَهْرٌ':Added, #1: 1	شَطْرُ الْمَغْرِبِ
u'شَطْرٌ مَهْرٌ':Added, #1: 1	شَطْرِ الْمَهْرِ
u'شَطْرٌ مَهْرٌ':Added, #1: 1	شَطْرُ مَهْرِ
u'شَطْرٌ نَخْلٌ':Added, #1: 1	شَطْرِ مَهْرِ
u'شَطْرٌ وَاجِبٌ':Added, #1: 1	شَطْرِ نَخْلِ
u'شَطْرٌ وَسْقٌ':Added, #1: 1	شَطْرُ الْوَاجِبِ
u'شَطَّ مَزَارٌ':Subject, #2: 2	شَطْرَ وَسْقٍ
u'شُطُوطٌ أَنْهَارٌ':Added, #1: 1	شَطَّ الْمَزَارُ
u'شَظِيَ عَظْمٌ':Subject, #1: 1	شُطُوطِ الْأَنْهَارِ
u'شَظِيَ قَوْمٌ':Subject, #1: 1	شَظِيَ الْعَظْمُ
u'شعار أهْلٌ':Added, #1: 1	شَظِيَ الْقَوْمُ
u'شعار بَدْرٌ':Added, #1: 1	أَشْعَارِ أَهْلِ
u'شعار بَعْضٌ':Added, #2: 2	أَشْعَارِ بَدْرٍ
u'شعار جَاهِلِيٌّ':Added, #1: 1	أَشْعَارِ بَعْضِ
u'شعار جَاهِلِيَّةٌ':Added, #1: 1	أَشْعَارِ الْجَاهِلِيَّةِ
u'شعار جبناء':Added, #1: 1	أَشْعَارِ الْجَاهِلِيَّةِ
u'شعار سِيَرٌ':Added, #1: 1	أَشْعَارِ الْجُبَنَاءِ
u'شعار سيرَةٌ':Added, #2: 2	أَشْعَارِ السّيَرِ
u'شعار ضرار':Added, #1: 1	أَشْعَارِ السّيرَةِ
u'شعار عَرَبٌ':Added, #1: 1	أَشْعَارِ ضِرَارٍ
u'شعار عَرَبٌ':Added, #2: 2	أَشْعَارِ الْعَرَبِ
u'شعار قدماء':Added, #3: 3	أَشْعَارُ الْعَرَبِ
u'شعار كَلاَمٌ':Added, #1: 1	أَشْعَارِ الْقُدَمَاءِ
u'شعار يَوْمٌ':Added, #1: 1	أَشْعَارِ كَلَامِ
u'شعث حاجٌّ':Added, #3: 3	أَشْعَارِ يَوْمِ
u'شَعَثٌ حاجٌّ':Added, #1: 1	شَعَثِ الْحَاجِّ
u'شَعِثَ رَأْسٌ':Subject, #1: 1	شَعَثِ الْحَاجِّ
u'شَعْرٌ إِبْطٌ':Added, #1: 1	شَعِثَ رَأْسُهُ
u'شَعْرٌ إِبْطٌ':Added, #1: 1	شَعْرَ الْإِبْطِ
u'شَعْرٌ إِبْطٌ':Added, #1: 1	شَعْرِ الْإِبْطِ
u'شِعْرٌ اِبْنٌ':Added, #2: 2	شَعْرَ إبْطِهِ
u'شِعْرٌ اِبْنٌ':Added, #14: 14	شِعْرُ ابْنِ
u'شِعْرٌ اِبْنٌ':Added, #2: 2	شِعْرَ ابْنِ
u'شِعْرٌ أَجْدَع':Added, #6: 6	شِعْرِ ابْنِ
u'شَعْرٌ أَجْفَانٌ':Added, #1: 1	شِعْرِ الْأَجْدَعِ
u'شَعْرٌ أَجْنَبِيٌّ':Added, #2: 2	شَعْرِ الْأَجْفَانِ
u'شَعْرٌ أَجْنَبِيٌّ':Added, #1: 1	شَعْرِ الْأَجْنَبِيَّةِ
u'شَعْرٌ آدَمِيٌّ':Added, #2: 2	شَعْرِ أَجْنَبِيَّةٍ
u'شَعْرٌ آدَمِيٌّ':Added, #1: 1	شَعْرَ آدَمِيٍّ
u'شَعْرٌ آدَمِيٌّ':Added, #2: 2	شَعْرِ الْآدَمِيِّ
u'شَعْرٌ آدَمِيٌّ':Added, #3: 3	شَعْرِ آدَمِيٍّ
u'شَعْرٌ آدَمِيٌّ':Added, #3: 3	شَعْرَ الْآدَمِيِّ
u'شِعْرٌ أَدِيبٌ':Added, #3: 3	شَعْرُ الْآدَمِيِّ
u'شَعْرٌ أَسْفَلُ':Added, #1: 1	شِعْرِ الْأَدِيبِ
u'شِعْرٌ أسْوَد':Added, #1: 1	شَعْرُ أَسْفَلِ
u'شِعْرٌ أسْوَد':Added, #1: 1	شِعْرُ الْأَسْوَدِ
u'شَعَرٌ الْمَرْأَةُ':Added, #1: 1	شِعْرِ الْأَسْوَدِ
u'شَعْرٌ الْمَرْأَةُ':Added, #1: 1	شَعَرُ الْمَرْأَةِ
u'شَعْرٌ الْمَرْأَةُ':Added, #1: 1	شَعْرِ الْمَرْأَةِ
u'شَعْرٌ أُمٌّ':Added, #4: 4	شَعْرُ الْمَرْأَةِ
u'شَعْرٌ أُمٌّ':Added, #1: 1	شَعْرِ أُمِّ
u'شَعْرٌ أمَةٌ':Added, #1: 1	شَعْرِ أُمِّهِ
u'شَعْرٌ أمَةٌ':Added, #1: 1	شَعْرِ الْأَمَةِ
u'شَعَرٌ اِمْرَأَةٌ':Added, #2: 2	شَعْرِ أَمَةٍ
u'شَعْرٌ اِمْرَأَةٌ':Added, #1: 1	شَعَرَ امْرَأَةٍ
u'شِعْرٌ اِمْرَأَةٌ':Added, #1: 1	شَعْرَ امْرَأَةٍ
u'شَعْرٌ إِنْسانٌ':Added, #1: 1	شِعْرَ امْرَأَةٍ
u'شَعْرٌ إِنْسانٌ':Added, #1: 1	شَعْرَ إنْسَانٍ
u'شَعْرٌ أَنْفٌ':Added, #2: 2	شَعْرُ الْإِنْسَانِ
u'شَعْرٌ أَنْفٌ':Added, #1: 1	شَعْرُ الْأَنْفِ
u'شَعْرٌ أَنْفٌ':Added, #2: 2	شَعْرِ الْأَنْفِ
u'شَعْرٌ بَاطن':Added, #4: 4	شَعْرَ الْأَنْفِ
u'شَعْرٌ باطِنٌ':Added, #2: 2	شَعْرِ بَاطِنِ
u'شَعْرٌ بدن':Added, #2: 2	شَعْرِ بَاطِنِ
u'شَعْرٌ بَدَنٌ':Added, #1: 1	شَعْرَ الْبَدَنِ
u'شَعْرٌ بدن':Added, #1: 1	شَعْرَ الْبَدَنِ
u'شَعْرٌ بدن':Added, #1: 1	شَعْرُ بَدَنِهِ
u'شَعْرٌ بَدَنٌ':Added, #1: 1	شَعْرِ بَدَنِهِ
u'شَعْرٌ بَدَنٌ':Added, #1: 1	شَعْرُ بَدَنِهِ
u'شَعْرٌ بدن':Added, #1: 1	شَعْرِ بَدَنِهِ
u'شَعْرٌ بَدَنٌ':Added, #2: 2	شَعْرِ الْبَدَنِ
u'شَعْرٌ بدن':Added, #2: 2	شَعْرِ الْبَدَنِ
u'شَعْرٌ بَدَنٌ':Added, #2: 2	شَعْرَ بَدَنِهِ
u'شَعْرٌ بِرْذَوْنٌ':Added, #2: 2	شَعْرَ بَدَنِهِ
u'شَعْرٌ بَطْنٌ':Added, #3: 3	شَعْرِ الْبِرْذَوْنِ
u'شَعْرٌ بَعْضٌ':Added, #2: 2	شَعْرِ بَطْنِ
u'شَعْرٌ بَعْضٌ':Added, #1: 1	شَعْرَ بَعْضِ
u'شَعْرٌ بَغْلٌ':Added, #1: 1	شَعْرِ بَعْضِ
u'شَعْرٌ بَقِيَّةٌ':Added, #1: 1	شَعْرِ بَغْلٍ
u'شَعْرٌ بَقِيَّةٌ':Added, #2: 2	شَعْرُ بَقِيَّةِ
u'شَعْرٌ بَهيمٌ':Added, #3: 3	شَعْرِ بَقِيَّةِ
u'شَعْرٌ بَهيمٌ':Added, #1: 1	شَعْرَ الْبَهِيمَةِ
u'شَعْرٌ بَهِيمَةٌ':Added, #1: 1	شَعْرِ الْبَهِيمَةِ
u'شَعْرٌ بَهِيمَةٌ':Added, #1: 1	شَعْرَ الْبَهِيمَةِ
u'شِعْرٌ تَامٌّ':Added, #1: 1	شَعْرِ الْبَهِيمَةِ
u'شَعْرٌ ثَلاثُ':Added, #1: 1	شِعْرٍ تَامٍّ
u'شَعَرٌ ثَلاثَةٌ':Added, #1: 1	شَعْرَ ثَلَاثِ
u'شَعْرٌ جَارِي':Added, #1: 1	شَعَرِ الثَّلَاثَةِ
u'شَعْرٌ جَارِيَةٌ':Added, #1: 1	شَعْرَ جَارِيَتِهِ
u'شَعْرٌ جَبْهَةٌ':Added, #1: 1	شَعْرَ جَارِيَتِهِ
u'شَعْرٌ جَسَدٌ':Added, #1: 1	شَعْرَ جَبْهَةِ
u'شَعْرٌ جَسَدٌ':Added, #1: 1	شَعْرُ الْجَسَدِ
u'شَعْرٌ جَسَدٌ':Added, #1: 1	شَعْرِ جَسَدِهِ
u'شَعْرٌ جَفْنٌ':Added, #3: 3	شَعْرِ الْجَسَدِ
u'شِعْرٌ جَوْنٌ':Added, #1: 1	شَعْرِ جَفْنِ
u'شِعْرٌ جَوْنٌ':Added, #1: 1	شِعْرَ الْجَوْنِ
u'شَعْرٌ حاجِبٌ':Added, #1: 1	شِعْرُ الْجَوْنِ
u'شَعْرٌ حاجِبٌ':Added, #1: 1	شَعْرَ الْحَاجِبِ
u'شَعْرٌ حاجِبٌ':Added, #1: 1	شَعْرُ الْحَاجِبِ
u'شَعْرٌ حاجِبٌ':Added, #1: 1	شَعْرُ حَاجِبِهِ
u'شَعْرٌ حاجِبٌ':Added, #2: 2	شَعْرِ الْحَاجِبِ
u'شِعْرٌ حارِثٌ':Added, #3: 3	شَعْرِ الْحَاجِبَيْنِ
u'شِعْرٌ حارِثٌ':Added, #1: 1	شِعْرَ الْحَارِثِ
u'شِعْرٌ حارِثٌ':Added, #1: 1	شِعْرِ الْحَارِثِ
u'شَعْرٌ حَسَنٌ':Added, #3: 3	شِعْرُ الْحَارِثِ
u'شَعْرٌ حَسَنٌ':Added, #1: 1	شَعْرَ حَسَنٍ
u'شَعَرٌ حَسَنٌ':Added, #2: 2	شَعْرَ الْحَسَنِ
u'شَعْرٌ حَلالٌ':Added, #2: 2	شَعَرَ حَسَنٍ
u'شَعْرٌ حَلْقٌ':Added, #1: 1	شَعْرِ الْحَلَالِ
u'شَعْرٌ حَلْقٌ':Added, #1: 1	شَعْرَ حَلْقِهِ
u'شِعْرٌ حَمَاسَةٌ':Added, #1: 1	شَعْرِ حَلْقِهِ
u'شَعَرٌ حَيَوَانٌ':Added, #1: 1	شِعْرِ الْحَمَاسَةِ
u'شَعْرٌ حَيَوَانٌ':Added, #1: 1	شَعَرُ الْحَيَوَانِ
u'شَعْرٌ حَيَوَانٌ':Added, #2: 2	شَعْرِ الْحَيَوَانِ
u'شِعْرٌ خَالٌ':Added, #2: 2	شَعْرِ حَيَوَانٍ
u'شَعْرٌ ختنة':Added, #1: 1	شِعْرٍ خَالٍ
u'شَعْرٌ خَتَنَةٌ':Added, #1: 1	شَعْرِ خَتَنَتِهِ
u'شَعْرٌ خَدٌّ':Added, #1: 1	شَعْرِ خَتَنَتِهِ
u'شِعْرٌ خَدِيج':Added, #1: 1	شَعْرُ الْخَدِّ
u'شَعَرٌ خِنْزِيرٌ':Added, #1: 1	شِعْرُ خَدِيجٍ
u'شَعْرٌ خِنْزِيرٌ':Added, #1: 1	شَعَرِ الْخِنْزِيرِ
u'شَعْرٌ خِنْزِيرٌ':Added, #1: 1	شَعْرُ الْخِنْزِيرِ
u'شَعْرٌ خِنْزِيرٌ':Added, #3: 3	شَعْرَ الْخِنْزِيرِ
u'شَعْرٌ ذقن':Added, #5: 5	شَعْرِ الْخِنْزِيرِ
u'شَعْرٌ ذَقَنٌ':Added, #2: 2	شَعْرِ الذَّقَنِ
u'شَعْرٌ ذَنَبٌ':Added, #2: 2	شَعْرِ الذَّقَنِ
u'شَعْرٌ رَأْسٌ':Added, #1: 1	شَعْرِ الذَّنَبِ
u'شَعْرٌ رَأْسٌ':Added, #14: 14	شَعْرُ رَأْسِهِ
u'شَعَرٌ رَأْسٌ':Added, #1: 1	شَعْرُ رَأْسٍ
u'شَعَرٌ رَأْسٌ':Added, #1: 1	شَعَرُ رَأْسِهِ
u'شَعْرٌ رَأْسٌ':Added, #1: 1	شَعَرِ رَأْسِهِ
u'شَعْرٌ رَأْسٌ':Added, #29: 29	شَعْرِ رَأْسِهِ
u'شَعْرٌ رَأْسٌ':Added, #2: 2	شَعْرِ الرّأْسِ
u'شَعْرٌ رَأْسٌ':Added, #2: 2	شَعْرَ رَأْسِ
u'شَعْرٌ رَأْسٌ':Added, #2: 2	شَعْرُ رَأْسِ
u'شَعَرٌ رَأْسٌ':Added, #2: 2	شَعْرِ رَأْسِ
u'شَعْرٌ رَأْسٌ':Added, #2: 2	شَعَرَ رَأْسِهِ
u'شَعَرٌ رَأْسٌ':Added, #38: 38	شَعْرِ الرَّأْسِ
u'شَعْرٌ رَأْسٌ':Added, #3: 3	شَعَرِ الرَّأْسِ
u'شَعْرٌ رَأْسٌ':Added, #3: 3	شَعْرَ الرَّأْسِ
u'شَعْرٌ رَأْسٌ':Added, #5: 5	شَعْرُ الرَّأْسِ
u'شَعْرٌ رَأْسِيٌّ':Added, #8: 8	شَعْرَ رَأْسِهِ
u'شَعْرٌ رُبْعٌ':Added, #1: 1	شَعْرَ رَأْسِيِّ
u'شَعْرٌ رُبْعٌ':Added, #1: 1	شَعْرِ الرُّبْعِ
u'شَعْرٌ رَسُولٌ':Added, #2: 2	شَعْرِ رُبْعِ
u'شَعْرٌ رَسُولٌ':Added, #1: 1	شَعْرَ رَسُولِ
u'شَعْرٌ رَسُولٌ':Added, #3: 3	شَعْرِ رَسُولِ
u'شِعْرٌ زَيْدٌ':Added, #4: 4	شَعْرُ رَسُولِ
u'شِعْرٌ زَيْدٌ':Added, #1: 1	شِعْرَ زَيْدِ
u'شَعْرٌ سَاعِدٌ':Added, #1: 1	شِعْرِ زَيْدٍ
u'شَعْرٌ سَاقٌ':Added, #1: 1	شَعْرَ السَّاعِدِ
u'شَعْرٌ سَائِرٌ':Added, #1: 1	شَعْرِ سَاقِ
u'شَعْرٌ سِباعٌ':Added, #1: 1	شَعْرُ سَائِرِ
u'شِعْرٌ سِماكٌ':Added, #1: 1	شَعْرِ سِبَاعِ
u'شِعْرٌ سَوادٌ':Added, #1: 1	شِعْرُ سِمَاكٍ
u'شَعَرٌ سَيِّدٌ':Added, #1: 1	شِعْرِ سَوَادٍ
u'شَعْرٌ سَيِّدٌ':Added, #1: 1	شَعَرِ سَيِّدَتِهِ
u'شَعْرٌ سَيِّدٌ':Added, #1: 1	شَعْرِ سَيِّدَتِهِ
u'شَعْرٌ شَارِبٌ':Added, #3: 3	شَعْرِ السَّيِّدَةِ
u'شَعْرٌ شَارِبٌ':Added, #1: 1	شَعْرَ الشَّارِبِ
u'شَعْرٌ شَخْصٌ':Added, #3: 3	شَعْرِ الشَّارِبِ
u'شَعْرٌ شُعرَاءُ':Added, #1: 1	شَعْرُ شَخْصٍ
u'شَعْرٌ شُعَرَاءُ':Added, #1: 1	شَعْرِ شُعَرَاءِ
u'شَعْرٌ صَدْرٌ':Added, #1: 1	شَعْرِ شُعَرَاءِ
u'شَعَرٌ صَدْرٌ':Added, #1: 1	شَعْرُ الصَّدْرِ
u'شَعْرٌ صَدْرٌ':Added, #1: 1	شَعَرَ صَدْرِهِ
u'شَعْرٌ صَدْرٌ':Added, #1: 1	شَعْرِ صَدْرِهِ
u'شَعْرٌ صَدْرٌ':Added, #3: 3	شَعْرَ صَدْرِهِ
u'شَعْرٌ صُدْغٌ':Added, #6: 6	شَعْرِ الصَّدْرِ
u'شَعْرٌ صُدْغٌ':Added, #1: 1	شَعْرَ الصُّدْغَيْنِ
u'شَعْرٌ صُدْغٌ':Added, #1: 1	شَعْرُ الصُّدْغَيْنِ
u'شِعْرٌ ضرار':Added, #1: 1	شَعْرِ الصُّدْغَيْنِ
u'شِعْرٌ ضرار':Added, #1: 1	شِعْرَ ضِرَارِ
u'شِعْرٌ ضرار':Added, #1: 1	شِعْرُ ضِرَارِ
u'شِعْرٌ ضرار':Added, #3: 3	شِعْرِ ضِرَارٍ
u'شِعْرٌ طَالِبٌ':Added, #5: 5	شِعْرُ ضِرَارٍ
u'شَعْرٌ ظَهْرٌ':Added, #1: 1	شِعْرُ طَالِبٍ
u'شَعْرٌ عَانَةٌ':Added, #1: 1	شَعْرِ ظَهْرِ
u'شَعْرٌ عَانَةٌ':Added, #1: 1	شَعْرَ الْعَانَةِ
u'شَعْرٌ عَانَةٌ':Added, #1: 1	شَعْرَ عَانَتِهِ
u'شَعْرٌ عَانَةٌ':Added, #1: 1	شَعْرِ عَانَتِهِ
u'شَعْرٌ عَانَةٌ':Added, #4: 4	شَعْرُ عَانَتِهِ
u'شِعْرٌ عَبَّاسٌ':Added, #9: 9	شَعْرِ الْعَانَةِ
u'شِعْرٌ عَبَّاسٌ':Added, #1: 1	شِعْرُ الْعَبَّاسِ
u'شِعْرٌ عَبَّاسٌ':Added, #1: 1	شِعْرَ عَبّاسِ
u'شِعْرٌ عَبَّاسٌ':Added, #1: 1	شِعْرُ عَبّاسٍ
u'شَعَرٌ عَبْدٌ':Added, #2: 2	شِعْرَ عَبّاسٍ
u'شَعْرٌ عَبْدٌ':Added, #1: 1	شَعَرِ الْعَبْدِ
u'شَعْرٌ عَبْدٌ':Added, #1: 1	شَعْرُ الْعَبْدِ
u'شِعْرٌ عَبْدٌ':Added, #1: 1	شَعْرِ الْعَبْدِ
u'شَعْرٌ عَبْدٌ':Added, #1: 1	شِعْرَ عَبْدِ
u'شِعْرٌ عَبْدٌ':Added, #1: 1	شَعْرِ عَبْدِهِ
u'شَعْرٌ عَبِيدٌ':Added, #3: 3	شِعْرِ عَبْدِ
u'شَعْرٌ عِذَارٌ':Added, #1: 1	شَعْرِ الْعَبِيدِ
u'شِعْرٌ عَرَبٌ':Added, #1: 1	شَعْرِ الْعِذَارَيْنِ
u'شَعْرٌ عَظْمٌ':Added, #1: 1	شِعْرَ الْعَرَبِ
u'شَعْرٌ عَنْزٌ':Added, #1: 1	شَعْرِ الْعَظْمِ
u'شَعْرٌ عَنْفَقَةٌ':Added, #3: 3	شَعْرِ الْعَنْزِ
u'شَعْرٌ عين':Added, #1: 1	شَعْرُ الْعَنْفَقَةِ
u'شَعْرٌ عَيْنٌ':Added, #1: 1	شَعْرُ عَيْنِهِ
u'شَعْرٌ عَيْن':Added, #1: 1	شَعْرُ عَيْنِهِ
u'شَعْرٌ عين':Added, #1: 1	شَعْرُ عَيْنِهِ
u'شَعْرٌ عَيْنٌ':Added, #2: 2	شَعْرِ الْعَيْنِ
u'شَعْرٌ عَيْن':Added, #2: 2	شَعْرِ الْعَيْنِ
u'شِعْرٌ غُلاَمٌ':Added, #2: 2	شَعْرِ الْعَيْنِ
u'شَعْرٌ غَنَمٌ':Added, #1: 1	شِعْرُ غُلَامٍ
u'شَعْرٌ غير':Added, #2: 2	شَعْرِ غَنَمِ
u'شَعْرٌ غَيْرٌ':Added, #1: 1	شَعْرَ غَيْرِ
u'شِعْرٌ غير':Added, #1: 1	شَعْرَ غَيْرِ
u'شِعْرٌ غَيْرٌ':Added, #1: 1	شِعْرَ غَيْرِهِ
u'شَعْرٌ غير':Added, #1: 1	شِعْرَ غَيْرِهِ
u'شَعْرٌ غير':Added, #3: 3	شَعْرُ غَيْرِ
u'شَعْرٌ غَيْرٌ':Added, #3: 3	شَعْرِ غَيْرِ
u'شَعْرٌ غَيْرٌ':Added, #3: 3	شَعْرُ غَيْرِ
u'شَعْرٌ غير':Added, #3: 3	شَعْرِ غَيْرِ
u'شَعْرٌ غَيْرٌ':Added, #4: 4	شَعْرِ غَيْرِهِ
u'شَعْرٌ فَرْجٌ':Added, #4: 4	شَعْرِ غَيْرِهِ
u'شِعْرٌ فَرَزْدَقٌ':Added, #1: 1	شَعْرِ الْفَرْجِ
u'شِعْرٌ فَرَزْدَقٌ':Added, #1: 1	شِعْرُ الْفَرَزْدَقِ
u'شِعْرٌ فلان':Added, #1: 1	شِعْرِ الْفَرَزْدَقِ
u'شِعْرٌ فلان':Added, #1: 1	شِعْرَ الزّبَيْرِ
u'شِعْرٌ فلان':Added, #1: 1	شِعْرُ بِلَالٍ
u'شِعْرٌ فلان':Added, #1: 1	شِعْرَ تَمِيمِ
u'شِعْرٌ فلان':Added, #1: 1	شِعْرُ تَمِيمٍ
u'شَعْرٌ فُلاَنٌ':Added, #1: 1	شِعْرِ تَمِيمٍ
u'شِعْرٌ فلان':Added, #1: 1	شَعْرَ فُلَانٍ
u'شِعْرٌ قَيْس':Added, #1: 1	شِعْرُ قَيْسٍ
u'شَعْرٌ كَافِرٌ':Added, #1: 1	شِعْرُ قَيْسٍ
u'شَعْرٌ كَافِرٌ':Added, #1: 1	شَعْرَ الْكَافِرِ
u'شِعْرٌ كَعْبٌ':Added, #2: 2	شَعْرِ الْكَافِرَةِ
u'شِعْرٌ كَعْبٌ':Added, #16: 16	شِعْرُ كَعْبٍ
u'شِعْرٌ كَعْبٌ':Added, #1: 1	شِعْرَ كَعْبِ
u'شِعْرٌ كَعْبٌ':Added, #2: 2	شِعْرُ كَعْبِ
u'شِعْرٌ كَعْبٌ':Added, #5: 5	شِعْرَ كَعْبٍ
u'شَعَرٌ كفر':Added, #9: 9	شِعْرِ كَعْبٍ
u'شَعَرٌ كُفْرٌ':Added, #2: 2	شَعَرَ الْكُفْرِ
u'شَعْرٌ كفر':Added, #2: 2	شَعَرَ الْكُفْرِ
u'شَعْرٌ كُفْرٌ':Added, #5: 5	شَعْرَ الْكُفْرِ
u'شِعْرٌ كَفَرَةٌ':Added, #5: 5	شَعْرَ الْكُفْرِ
u'شَعْرٌ كَلْبٌ':Added, #1: 1	شِعْرِ الْكَفَرَةِ
u'شَعْرٌ كَلْبٌ':Added, #1: 1	شَعْرُ الْكَلْبِ
u'شَعْرٌ كَلْبٌ':Added, #1: 1	شَعْرَ كَلْبٍ
u'شَعْرٌ لَحْيٌ':Added, #2: 2	شَعْرِ الْكَلْبِ
u'شَعْرٌ لِحْيَةٌ':Added, #1: 1	شَعْرُ اللَّحْيَيْنِ
u'شَعَرٌ لِحْيَةٌ':Added, #11: 11	شَعْرِ اللِّحْيَةِ
u'شَعْرٌ لِحْيَةٌ':Added, #1: 1	شَعَرِ اللِّحْيَةِ
u'شَعَرٌ لِحْيَةٌ':Added, #1: 1	شَعْرُ اللِّحْيَةِ
u'شَعْرٌ لِحْيَةٌ':Added, #1: 1	شَعَرِ لِحْيَتِهِ
u'شَعْرٌ لِحْيَةٌ':Added, #1: 1	شَعْرِ لِحْيَتِهِ
u'شَعْرٌ مَأْكُولٌ':Added, #2: 2	شَعْرَ لِحْيَتِهِ
u'شَعْرٌ مَأْكُولٌ':Added, #1: 1	شَعْرُ الْمَأْكُولِ
u'شَعَرٌ مَأْكُولٌ':Added, #1: 1	شَعْرِ الْمَأْكُولِ
u'شَعْرٌ مَأْكُولٌ':Added, #1: 1	شَعَرُ مَأْكُولٍ
u'شِعْرٌ مَالِكٌ':Added, #1: 1	شَعْرَ مَأْكُولٍ
u'شِعْرٌ مَالِكٌ':Added, #1: 1	شِعْرُ مَالِكِ
u'شِعْرٌ مُبَاحٌ':Added, #2: 2	شِعْرِ مَالِكِ
u'شَعَرَ مَجَازٌ':Subject, #2: 2	شِعْرٍ مُبَاحٍ
u'شَعْرٌ مُحْرِمٌ':Added, #1: 1	شَعَرَ مَجَازٌ
u'شَعْرٌ مُحْرِمٌ':Added, #1: 1	شَعْرَ مُحْرِمٍ
u'شَعْرٌ مُحْرِمٌ':Added, #1: 1	شَعْرُ مُحْرِمٍ
u'شِعْرٌ مُسَافِرٌ':Added, #3: 3	شَعْرَ الْمُحْرِمِ
u'شِعْرٌ مُسَافِرٌ':Added, #1: 1	شِعْرَ مُسَافِرِ
u'شِعْرٌ مَطْرُودٌ':Added, #1: 1	شِعْرِ مُسَافِرٍ
u'شِعْرٌ مَعْبَدٌ':Added, #2: 2	شِعْرٍ مَطْرُودٍ
u'شَعْرٌ معز':Added, #1: 1	شِعْرَ مَعْبَدٍ
u'شَعْرٌ مَعْزٌ':Added, #1: 1	شَعْرُ الْمَعْزِ
u'شِعْرٌ مَعْقِلٌ':Added, #1: 1	شَعْرُ الْمَعْزِ
u'شِعْرٌ مُفْرَدٌ':Added, #1: 1	شِعْرِ مَعْقِلٍ
u'شَعْرٌ مُقَدَّمٌ':Added, #1: 1	شِعْرٍ مُفْرَدٍ
u'شَعْرٌ مُقَدِّمٌ':Added, #1: 1	شَعْرُ مُقَدَّمِ
u'شَعْرٌ مَنَابِتُ':Added, #1: 1	شَعْرُ مُقَدِّمِ
u'شِعْرٌ مَنْظُومٌ':Added, #1: 1	شَعْرِ مَنَابِتِ
u'شَعْرٌ مَيْتٌ':Added, #1: 1	شِعْرٍ مَنْظُومٍ
u'شَعْرٌ مَيْتٌ':Added, #1: 1	شَعْرَ الْمَيْتَةِ
u'شَعْرٌ مَيْتَةٌ':Added, #5: 5	شَعْرُ الْمَيْتَةِ
u'شَعْرٌ مَيْتَةٌ':Added, #1: 1	شَعْرَ الْمَيْتَةِ
u'شِعْرٌ نَابِغٌ':Added, #5: 5	شَعْرُ الْمَيْتَةِ
u'شَعْرٌ نَافِعٌ':Added, #1: 1	شِعْرِ النّابِغَةِ
u'شَعْرٌ نَائِمٌ':Added, #1: 1	شَعْرٍ نَافِعٍ
u'شَعْرٌ نَبِيٌّ':Added, #1: 1	شَعْرَ نَائِمٍ
u'شَعْرٌ نَبِيٌّ':Added, #1: 1	شَعْرُ النَّبِيِّ
u'شَعْرٌ نَبِيٌّ':Added, #2: 2	شَعْرَ النَّبِيِّ
u'شَعْرٌ نَصْرٌ':Added, #3: 3	شَعْرِ النَّبِيِّ
u'شَعْرٌ نَفْسٌ':Added, #1: 1	شَعْرَ نَصْرِ
u'شِعْرٌ هجرة':Added, #1: 1	شَعْرَ نَفْسِهِ
u'شِعْرٌ هِجْرَةٌ':Added, #2: 2	شِعْرِ الْهِجْرَةِ
u'شِعْرٌ هَجْوٌ':Added, #2: 2	شِعْرِ الْهِجْرَةِ
u'شَعْرٌ هِرٌّ':Added, #1: 1	شِعْرِ الْهَجْوِ
u'شَعْرٌ هِرٌّ':Added, #1: 1	شَعْرُ الْهِرِّ
u'شَعْرٌ هِرٌّ':Added, #1: 1	شَعْرِ الْهِرِّ
u'شِعْرٌ هِنْدٌ':Added, #1: 1	شَعْرُ هِرٍّ
u'شِعْرٌ هِنْدٌ':Added, #1: 1	شِعْرِ هِنْدٍ
u'شَعْرٌ واحد':Added, #2: 2	شِعْرُ هِنْدٍ
u'شَعْرٌ وَاحِدٌ':Added, #1: 1	شَعْرَ وَاحِدَةٍ
u'شَعَرٌ وَجْهٌ':Added, #1: 1	شَعْرَ وَاحِدَةٍ
u'شَعْرٌ وَجْهٌ':Added, #1: 1	شَعَرِ الْوَجْهِ
u'شَعْرٌ وَجْهٌ':Added, #1: 1	شَعْرِ وَجْهِهِ
u'شَعْرٌ وَجْهٌ':Added, #2: 2	شَعْرُ وَجْهِهِ
u'شَعْرٌ وَلَدٌ':Added, #3: 3	شَعْرِ الْوَجْهِ
u'شَعَلَ طرف':Predicate, #1: 1	شَعْرِ وَلَدٍ
u'شَعِلَ طرف':Predicate, #1: 1	أَشْعَلَ طَرَفَ
u'شَعَلَ طَرَفٌ':Predicate, #1: 1	أَشْعَلَ طَرَفَ
u'شَعِلَ طَرَفٌ':Predicate, #1: 1	أَشْعَلَ طَرَفَ
u'شُعُورٌ إِنْسانٌ':Added, #1: 1	أَشْعَلَ طَرَفَ
u'شُعُورٌ أَنْفُسٌ':Added, #3: 3	شُعُورِ الْإِنْسَانِ
u'شُعُورٌ أهْلٌ':Added, #1: 1	شُعُورِ الْأَنْفُسِ
u'شُعُورٌ بدن':Added, #1: 1	شُعُورِ أَهْلِ
u'شُعُورٌ بَدَنٌ':Added, #1: 1	شُعُورِ بَدَنِهِ
u'شُعُورٌ حَبَشَة':Added, #1: 1	شُعُورِ بَدَنِهِ
u'شُعُورٌ ذِهْنٌ':Added, #1: 1	شُعُورِ الْحَبَشَةِ
u'شُعُورٌ غَنَمٌ':Added, #1: 1	شُعُورِ الذِّهْنِ
u'شُعُورٌ مَالِكٌ':Added, #2: 2	شُعُورِ غَنَمِ
u'شُعُورٌ نِساءٌ':Added, #1: 1	شُعُورِ الْمَالِكِ
u'شُعُورٌ نُفُوسٌ':Added, #2: 2	شُعُورِ النِّسَاءِ
u'شُعُورٌ وَجْهٌ':Added, #1: 1	شُعُورُ النُّفُوسِ
u'شَغَبٌ خَصْمٌ':Added, #2: 2	شُعُورِ الْوَجْهِ
u'شَغَبٌ سائِل':Added, #2: 2	شَغَبِ الْخَصْمِ
u'شَغَبٌ سَائِلٌ':Added, #1: 1	شَغَبِ السَّائِلِ
u'شَغَبٌ مُبْتَدِعٌ':Added, #1: 1	شَغَبِ السَّائِلِ
u'شَغَرَ كَلْبٌ':Subject, #1: 1	شَغَبِ الْمُبْتَدِعَةِ
u'شَغَفٌ جِبَالٌ':Added, #3: 3	شَغَرَ الْكَلْبُ
u'شَغَفٌ نُفُوسٌ':Added, #1: 1	شَغَفَ الْجِبَالِ
u'شَغَلَ أرْضٌ':Predicate, #1: 1	شَغَفَ النُّفُوسِ
u'شُغْلٌ بالٌ':Added, #1: 1	شَغَلَ الْأَرْضَ
u'شُغْلٌ بالٌ':Added, #1: 1	شُغْلُ الْبَالِ
u'شُغْل بالٌ':Added, #1: 1	شُغْلِ الْبَالِ
u'شُغْل بالٌ':Added, #1: 1	شُغْلُ الْبَالِ
u'شُغْلٌ بَالٌ':Added, #1: 1	شُغْلِ الْبَالِ
u'شُغْلٌ بَالٌ':Added, #1: 1	شُغْلُ الْبَالِ
u'شُغْل بَالٌ':Added, #1: 1	شُغْلِ الْبَالِ
u'شُغْل بَالٌ':Added, #1: 1	شُغْلُ الْبَالِ
u'شَغَلَ حَقٌّ':Predicate, #1: 1	شُغْلِ الْبَالِ
u'شُغْلٌ حَواسٌّ':Added, #1: 1	شَغَلَ حَقَّ
u'شُغْل حَواسٌّ':Added, #1: 1	شُغْلِ الْحَوَاسِّ
u'شُغْلٌ حَوَاسُّ':Added, #1: 1	شُغْلِ الْحَوَاسِّ
u'شُغْل حَوَاسُّ':Added, #1: 1	شُغْلِ الْحَوَاسِّ
u'شَغَلَ دَارٌ':Predicate, #1: 1	شُغْلِ الْحَوَاسِّ
u'شُغْلٌ ذِمَّةٌ':Added, #1: 1	شَغَلَ الدَّارَ
u'شُغْل ذِمَّةٌ':Added, #1: 1	شُغْلَ ذِمَّةٍ
u'شُغْلٌ ذِمَّةٌ':Added, #1: 1	شُغْلَ ذِمَّةٍ
u'شُغْل ذِمَّةٌ':Added, #3: 3	شُغْلِ الذِّمَّةِ
u'شُغْلٌ رحم':Added, #3: 3	شُغْلِ الذِّمَّةِ
u'شُغْل رحم':Added, #1: 1	شُغْلِ الرَّحِمِ
u'شُغْلٌ رَحِمٌ':Added, #1: 1	شُغْلِ الرَّحِمِ
u'شُغْل رَحِمٌ':Added, #1: 1	شُغْلِ الرَّحِمِ
u'شَغَلَ رَسُولٌ':Predicate, #1: 1	شُغْلِ الرَّحِمِ
u'شُغْلٌ زَمانٌ':Added, #1: 1	شَغَلَ رَسُولَ
u'شُغْل زَمانٌ':Added, #1: 1	شُغْلِ الزَّمَانِ
u'شُغْلٌ سَمْعٌ':Added, #1: 1	شُغْلِ الزَّمَانِ
u'شُغْل سَمْعٌ':Added, #1: 1	شُغْلُ السَّمْعِ
u'شَغَلَ طَرِيقٌ':Predicate, #1: 1	شُغْلُ السَّمْعِ
u'شَغَلَ ظَرْفٌ':Predicate, #3: 3	شَغَلَ الطَّرِيقَ
u'شَغَلَ ظَرْفٌ':Predicate, #1: 1	أَشْغَلَ ظَرْفَ
u'شُغْلٌ عين':Added, #1: 1	شَغَلَ ظَرْفَ
u'شُغْل عين':Added, #1: 1	شُغْلُ الْعَيْنِ
u'شُغْلٌ عَيْنٌ':Added, #1: 1	شُغْلُ الْعَيْنِ
u'شُغْلٌ عَيْن':Added, #1: 1	شُغْلُ الْعَيْنِ
u'شُغْل عَيْنٌ':Added, #1: 1	شُغْلُ الْعَيْنِ
u'شُغْل عَيْن':Added, #1: 1	شُغْلُ الْعَيْنِ
u'شُغْلٌ قلب':Added, #1: 1	شُغْلُ الْعَيْنِ
u'شُغْل قلب':Added, #1: 1	شُغْلُ الْقَلْبِ
u'شُغْلٌ قَلْبٌ':Added, #1: 1	شُغْلُ الْقَلْبِ
u'شُغْلٌ قَلْب':Added, #1: 1	شُغْلُ الْقَلْبِ
u'شُغْل قَلْبٌ':Added, #1: 1	شُغْلُ الْقَلْبِ
u'شُغْل قَلْب':Added, #1: 1	شُغْلُ الْقَلْبِ
u'شُغْلٌ قَلْبٌ':Added, #1: 1	شُغْلُ الْقَلْبِ
u'شُغْلٌ قَلْب':Added, #1: 1	شُغْلُ قَلْبٍ
u'شُغْل قَلْبٌ':Added, #1: 1	شُغْلُ قَلْبٍ
u'شُغْل قَلْب':Added, #1: 1	شُغْلُ قَلْبٍ
u'شُغْلٌ قلب':Added, #1: 1	شُغْلُ قَلْبٍ
u'شُغْلٌ قلب':Added, #1: 1	شُغْلَ قَلْبِهِ
u'شُغْلٌ قلب':Added, #1: 1	شُغْلُ قَلْبِهِ
u'شُغْل قلب':Added, #1: 1	شُغْلِ قَلْبِهِ
u'شُغْل قلب':Added, #1: 1	شُغْلَ قَلْبِهِ
u'شُغْل قلب':Added, #1: 1	شُغْلُ قَلْبِهِ
u'شُغْلٌ قَلْبٌ':Added, #1: 1	شُغْلِ قَلْبِهِ
u'شُغْلٌ قَلْبٌ':Added, #1: 1	شُغْلَ قَلْبِهِ
u'شُغْلٌ قَلْبٌ':Added, #1: 1	شُغْلُ قَلْبِهِ
u'شُغْلٌ قَلْب':Added, #1: 1	شُغْلِ قَلْبِهِ
u'شُغْلٌ قَلْب':Added, #1: 1	شُغْلَ قَلْبِهِ
u'شُغْلٌ قَلْب':Added, #1: 1	شُغْلُ قَلْبِهِ
u'شُغْل قَلْبٌ':Added, #1: 1	شُغْلِ قَلْبِهِ
u'شُغْل قَلْبٌ':Added, #1: 1	شُغْلَ قَلْبِهِ
u'شُغْل قَلْبٌ':Added, #1: 1	شُغْلُ قَلْبِهِ
u'شُغْل قَلْب':Added, #1: 1	شُغْلِ قَلْبِهِ
u'شُغْل قَلْب':Added, #1: 1	شُغْلَ قَلْبِهِ
u'شُغْل قَلْب':Added, #1: 1	شُغْلُ قَلْبِهِ
u'شُغْلٌ قلب':Added, #1: 1	شُغْلِ قَلْبِهِ
u'شُغْل قلب':Added, #2: 2	شُغْلِ الْقَلْبِ
u'شُغْلٌ قَلْبٌ':Added, #2: 2	شُغْلِ الْقَلْبِ
u'شُغْلٌ قَلْب':Added, #2: 2	شُغْلِ الْقَلْبِ
u'شُغْل قَلْبٌ':Added, #2: 2	شُغْلِ الْقَلْبِ
u'شُغْل قَلْب':Added, #2: 2	شُغْلِ الْقَلْبِ
u'شَغَلَ مَالٌ':Predicate, #2: 2	شُغْلِ الْقَلْبِ
u'شُغْلٌ مَالٌ':Added, #1: 1	شَغَلَ الْمَالَ
u'شُغْل مَالٌ':Added, #2: 2	شُغْلِ الْمَالِ
u'شُغْلٌ مَبِيعٌ':Added, #2: 2	شُغْلِ الْمَالِ
u'شُغْل مَبِيعٌ':Added, #1: 1	شُغْلُ الْمَبِيعِ
u'شُغْلٌ مَعِيشَةٌ':Added, #1: 1	شُغْلُ الْمَبِيعِ
u'شُغْل مَعِيشَةٌ':Added, #1: 1	شُغْلِ الْمَعِيشَةِ
u'شُغْلٌ مُعَيَّنٌ':Added, #1: 1	شُغْلِ الْمَعِيشَةِ
u'شُغْل مُعَيَّنٌ':Added, #2: 2	شُغْلٍ مُعَيَّنٍ
u'شَغَلَ مِقْدَارٌ':Predicate, #2: 2	شُغْلٍ مُعَيَّنٍ
u'شُغْلٌ مِلْكٌ':Added, #1: 1	شَغَلَ مِقْدَارَ
u'شُغْل مِلْكٌ':Added, #1: 1	شُغْلَ مِلْكِ
u'شُغْلٌ نَاسٌ':Added, #1: 1	شُغْلَ مِلْكِ
u'شُغْل نَاسٌ':Added, #1: 1	شُغْلَ النّاسِ
u'شُغْلٌ نَفْسٌ':Added, #1: 1	شُغْلَ النّاسِ
u'شُغْل نَفْسٌ':Added, #1: 1	شُغْلِ النَّفْسِ
u'شَغَلَ هَوَاءٌ':Predicate, #1: 1	شُغْلِ النَّفْسِ
u'شَغَلَ هَوَاءٌ':Predicate, #1: 1	أَشْغَلَ هَوَاءَ
u'شَغَلَ هَوَاءٌ':Predicate, #1: 1	شَغَلَ الْهَوَاءَ
u'شَغَلَ وَقْتٌ':Predicate, #1: 1	شَغَلَ هَوَاءَ
u'شِفَاءٌ أَمْرَاضٌ':Added, #2: 2	شَغَلَ الْوَقْتَ
u'شِفَاءٌ دَائِمٌ':Added, #1: 1	شِفَاءِ الْأَمْرَاضِ
u'شِفَاءٌ عَلِيلٌ':Added, #2: 2	شِفَاءُ دَائِمِ
u'شِفَاءٌ عَلِيلٌ':Added, #13: 13	شِفَاءِ الْعَلِيلِ
u'شِفَاءٌ عَيٌّ':Added, #1: 1	شِفَاءُ الْعَلِيلِ
u'شِفَاءٌ عِيٌّ':Added, #1: 1	شِفَاءُ الْعَيِّ
u'شِفَاءٌ عين':Added, #6: 6	شِفَاءُ الْعِيِّ
u'شِفَاءٌ عَيْنٌ':Added, #1: 1	شِفَاءُ الْعَيْنِ
u'شِفَاءٌ عَيْن':Added, #1: 1	شِفَاءُ الْعَيْنِ
u'شِفَاءٌ غَلِيلٌ':Added, #1: 1	شِفَاءُ الْعَيْنِ
u'شِفَاءٌ غَلِيلٌ':Added, #1: 1	شِفَاءَ الْغَلِيلِ
u'شِفَاءٌ غَيْظٌ':Added, #3: 3	شِفَاءِ الْغَلِيلِ
u'شِفَاءٌ قَوْمٌ':Added, #1: 1	شِفَاءَ الْغَيْظِ
u'شِفَاءٌ كَافِرٌ':Added, #1: 1	شِفَاءُ قَوْمٍ
u'شِفَاءٌ مَرِيضٌ':Added, #1: 1	شِفَاءُ الْكَافِرِ
u'شِفَاءٌ مَرِيضٌ':Added, #1: 1	شِفَاءَ مَرِيضِهِ
u'شَفَاعَةٌ أحَدٌ':Added, #2: 2	شِفَاءُ الْمَرِيضِ
u'شَفَاعَةٌ رَسُولٌ':Added, #1: 1	شَفَاعَةِ أَحَدٍ
u'شَفَاعَةٌ مُحَمَّدٌ':Added, #1: 1	شَفَاعَةَ رَسُولِ
u'شَفَاعَةٌ مُحَمَّدٌ':Added, #1: 1	شَفَاعَةَ مُحَمَّدٍ
u'شَفَاعَةٌ مُحَمَّدٌ':Added, #2: 2	شَفَاعَةِ مُحَمَّدٍ
u'شَفَاعَةٌ نَبِيٌّ':Added, #4: 4	شَفَاعَةُ مُحَمَّدٍ
u'شَفَاعَةٌ نُعْمَانُ':Added, #2: 2	شَفَاعَةَ النَّبِيِّ
u'شَفَاعَةٌ ولد':Added, #1: 1	شَفَاعَةَ النّعْمَانِ
u'شَفَاعَةٌ وَلَدٌ':Added, #1: 1	شَفَاعَةَ وَلَدِهِ
u'شفاع عَشْرٌ':Added, #1: 1	شَفَاعَةَ وَلَدِهِ
u'شَفَّ ثَوْبٌ':Subject, #1: 1	أَشْفَاعِ الْعَشْرِ
u'شَفْعٌ أَذَانٌ':Added, #1: 1	شَفَّ الثَّوْبُ
u'شَفْعٌ إقامَةٌ':Added, #1: 1	شَفْعُ الْأَذَانِ
u'شَفَعَ إمَامٌ':Subject, #1: 1	شَفْعُ الْإِقَامَةِ
u'شَفْعٌ تَرْوِيحَةٌ':Added, #1: 1	شَفَعَ الْإِمَامُ
u'شَفْعٌ تَرْوِيحَة':Added, #1: 1	شَفْعِ التَّرْوِيحَةِ
u'شَفْعٌ تَطَوُّعٌ':Added, #1: 1	شَفْعِ التَّرْوِيحَةِ
u'شَفْعٌ رهبة':Added, #2: 2	شَفْعِ التَّطَوُّعِ
u'شَفْعٌ رَهْبَةٌ':Added, #1: 1	شَفْعِ الرَّهْبَةِ
u'شَفَعَ شَرِيكٌ':Subject, #1: 1	شَفْعِ الرَّهْبَةِ
u'شَفْعٌ صَلاَةٌ':Added, #1: 1	شَفَعَ الشَّرِيكُ
u'شَفْعٌ غُسْلٌ':Added, #2: 2	شَفْعِ صَلَاةٍ
u'شَفَعَ مَغْرِبٌ':Predicate, #1: 1	شَفْعِ غُسْلِهِ
u'شَفْعٌ مُنْفَصِلٌ':Added, #1: 1	شَفَعَ الْمَغْرِبَ
u'شَفَعَ مُوَكِّلٌ':Subject, #3: 3	شَفْعٍ مُنْفَصِلٍ
u'شَفْعٌ وَارِثٌ':Added, #1: 1	شَفَعَ الْمُوَكِّلُ
u'شفق لَيْلٌ':Added, #1: 1	شَفْعِ الْوَارِثِ
u'شَفَقٌ لَيْلٌ':Added, #1: 1	شَفَقُ اللَّيْلِ
u'شَفَّ مُؤَمَّلٌ':Predicate, #1: 1	شَفَقُ اللَّيْلِ
u'شَفَى رَحْمَن':Subject, #1: 1	شَفَّ الْمُؤَمَّلَ
u'شَفِيَ عَيٌّ':Predicate, #1: 1	شَفَى الرّحْمَنُ
u'شَفَى غَيْظٌ':Subject, #1: 1	أَشْفَى الْعَيَّ
u'شَفَى فلان':Subject, #1: 1	شَفَى غَيْظُهُ
u'شَفَى نَفْسٌ':Predicate, #1: 1	شَفَى الرّحْمَنُ
u'شَفَى نَفْسٌ':Predicate, #1: 1	شَفَى النّفْسَ
u'شَفِيَ وَرِعٌ':Predicate, #2: 2	شَفَى النَّفْسَ
u'شَقَاءٌ أَمْرَاضٌ':Added, #1: 1	أَشْفَى وَرِعَ
u'شَقَاءٌ جمع':Added, #1: 1	شَقَاءِ الْأَمْرَاضِ
u'شَقَاءٌ جَمْعٌ':Added, #1: 1	شَقَاءِ جَمْعِهِ
u'شَقَاءٌ عَيْشٌ':Added, #1: 1	شَقَاءِ جَمْعِهِ
u'شَقَّ اِبْنٌ':Subject, #1: 1	شَقَاءِ الْعَيْشِ
u'شَقَّ إِزَالَةٌ':Subject, #1: 1	شَقَّ ابْنُ
u'شَقَّ اِسْتِثْنَاءٌ':Subject, #2: 2	شَقَّ إزَالَتُهُ
u'شَقَّ اِعْتِبارٌ':Subject, #1: 1	شَقَّ اسْتِثْنَاءُ
u'شَقَّ إكْرَامٌ':Subject, #1: 1	شَقَّ اعْتِبَارُهُ
u'شَقَّ أَمْرٌ':Subject, #2: 2	شَقَّ إكْرَامُهُ
u'شَقَاوَةٌ مُخَلَّدٌ':Added, #1: 1	شَقَّ أَمْرُهُ
u'شَقَّ بَصَرٌ':Subject, #1: 1	شَقَاوَةٍ مُخَلَّدَةٍ
u'شَقَّ بَطْنٌ':Predicate, #1: 1	شَقَّ بَصَرُهُ
u'شَقَّ بَطْنٌ':Predicate, #3: 3	شَقَّ بَطْنَ
u'شَقَّ تَأْخِيرٌ':Subject, #5: 5	شَقَّ الْبَطْنَ
u'شَقَّ تَحَرُّزٌ':Subject, #1: 1	شَقَّ التَّأْخِيرُ
u'شَقَّ تَحْصِيلٌ':Subject, #3: 3	شَقَّ التَّحَرُّزُ
u'شَقَّ تَعَهُّدٌ':Subject, #1: 1	شَقَّ تَحْصِيلُهُ
u'شَقَّ ثَوْبٌ':Predicate, #1: 1	شَقَّ تَعَهُّدُ
u'شَقَّ جَازٌ':Predicate, #2: 2	شَقَّ الثَّوْبَ
u'شَقَّ جُبْنٌ':Predicate, #1: 1	شَقَّ جَازَ
u'شَقَّ جُوَالِقٌ':Predicate, #1: 1	شَقَّ الْجُبْنَ
u'شَقَّ جُيُوبٌ':Predicate, #2: 2	شَقَّ الْجُوَالِقَ
u'شَقَّ حافٌّ':Predicate, #1: 1	شَقَّ الْجُيُوبَ
u'شَقَّ حافَّةٌ':Predicate, #1: 1	شَقَّ حَافَّةَ
u'شَقَّ حَمْلٌ':Predicate, #1: 1	شَقَّ حَافَّةَ
u'شَقَّ حِمْلٌ':Predicate, #1: 1	شَقَّ الْحَمْلَ
u'شَقَّ دلك':Subject, #2: 2	شَقَّ الْحِمْلَ
u'شَقَّ دَلْكٌ':Subject, #1: 1	شَقَّ دَلْكُهُ
u'شَقَّ ذِئْبٌ':Subject, #1: 1	شَقَّ دَلْكُهُ
u'شَقَّ رَفْعٌ':Subject, #3: 3	شَقَّ الذِّئْبُ
u'شَقَّ رَمْيٌ':Subject, #3: 3	شَقَّ رَفْعُهُ
u'شَقَّ زِقٌّ':Predicate, #1: 1	شَقَّ رَمْيُهُ
u'شَقَّ سَيْفٌ':Subject, #2: 2	شَقَّ زِقَّ
u'شَقَّ شَقٌّ':Predicate, #1: 1	شَقَّ السَّيْفُ
u'شَقَّ صَوْنٌ':Subject, #1: 1	شَقَّ شَقَّ
u'شَقَّ عَدَدٌ':Subject, #1: 1	شَقَّ صَوْنُهُ
u'شَقَّ علم':Subject, #1: 1	شَقَّ عَدَدُهُ
u'شَقَّ عِلْمٌ':Subject, #2: 2	شَقَّ عِلْمُهُ
u'شَقَّ غَسْلٌ':Subject, #2: 2	شَقَّ عِلْمُهُ
u'شَقَّ كَفٌّ':Predicate, #1: 1	شَقَّ غَسْلُهُ
u'شَقَّ كَلْبٌ':Subject, #1: 1	شَقَّ الْكَفَّ
u'شَقَّ كَيٌّ':Subject, #1: 1	شَقَّ الْكَلْبُ
u'شَقَّ لَفْظٌ':Subject, #1: 1	شَقَّ الْكَيُّ
u'شَقَّ مَسْحٌ':Subject, #1: 1	شَقَّ لَفْظُهُ
u'شَقَّ مَسْحٌ':Subject, #1: 1	شَقَّ مَسْحُ
u'شَقَّ نقل':Subject, #1: 1	شَقَّ مَسْحُهُ
u'شَقَّ نَقْلٌ':Subject, #1: 1	شَقَّ نَقْلُ
u'شَقَّ نقل':Subject, #1: 1	شَقَّ نَقْلُ
u'شَقَّ نَقْلٌ':Subject, #1: 1	شَقَّ نَقْلُهُ
u'شُقُوقٌ بِنَاءٌ':Added, #1: 1	شَقَّ نَقْلُهُ
u'شُقُوقٌ رِجْلٌ':Added, #2: 2	شُقُوقِ الْبِنَاءِ
u'شَكَا أَصْحَابٌ':Subject, #2: 2	شُقُوقِ الرِّجْلِ
u'شَكَا أهْلٌ':Subject, #2: 2	شَكَا أَصْحَابُ
u'شَكَّ اِبْنٌ':Subject, #1: 1	شَكَا أَهْلُ
u'شَكَّ أَثْناءُ':Predicate, #6: 6	شَكَّ ابْنُ
u'شَكَا خَالِدٌ':Subject, #1: 1	شَكَّ أَثْنَاءَ
u'شَكَا رَجُلٌ':Subject, #1: 1	شَكَا خَالِدُ
u'شَكَا رَسُولٌ':Subject, #2: 2	شَكَا رَجُلٌ
u'شَكَا زَوْجٌ':Subject, #1: 1	شَكَا الرَّسُولُ
u'شَكَا ضِفْدَعٌ':Subject, #1: 1	شَكَا الزَّوْجُ
u'شَكَّ أفْضَلُ':Subject, #1: 1	شَكَا الضِّفْدَعُ
u'شَكَا فقر':Predicate, #1: 1	شَكَّ أَفْضَلُ
u'شَكَا فَقْرٌ':Predicate, #1: 1	شَكَا الْفَقْرَ
u'شَكَّ أقْرَبُ':Subject, #1: 1	شَكَا الْفَقْرَ
u'شَكَا قَوْمٌ':Subject, #1: 1	شَكَّ أَقْرَبُ
u'شَكَا قَوْمٌ':Subject, #1: 1	شَكَا قَوْمٌ
u'شَكَا كَثْرَةٌ':Predicate, #1: 1	شَكَا قَوْمُهُ
u'شكال لعان':Added, #1: 1	شَكَا كَثْرَةَ
u'شَكَّ إمَامٌ':Subject, #1: 1	أَشْكَالَ اللِّعَانِ
u'شَكَا نَاسٌ':Subject, #3: 3	شَكَّ الْإِمَامُ
u'شَكَا نَاسٌ':Subject, #2: 2	شَكَا نَاسٌ
u'شَكَّ إِنْسانٌ':Subject, #4: 4	شَكَا النَّاسُ
u'شَكَا وَجَعٌ':Predicate, #1: 1	شَكَّ إنْسَانٌ
u'شَكَا وَرَثَةٌ':Subject, #1: 1	شَكَا وَجَعَ
u'شَكَا وَصِيٌّ':Subject, #2: 2	شَكَا الْوَرَثَةُ
u'شَكَّ بَائِعٌ':Subject, #1: 1	شَكَا الْوَصِيُّ
u'شَكَّ بَيْنٌ':Predicate, #1: 1	شَكَّ الْبَائِعُ
u'شَكَّ تَكْرارٌ':Subject, #1: 1	شَكَّ بَيْنَ
u'شَكَّ جَازٌ':Predicate, #1: 1	شَكَّ تَكْرَارٌ
u'شَكَّ حَمَلٌ':Predicate, #1: 1	شَكَّ جَازَ
u'شَكَّ خَطِيبٌ':Subject, #1: 1	شَكَّ حَمَلَ
u'شَكَّ خَلْفٌ':Predicate, #1: 1	شَكَّ الْخَطِيبُ
u'شكر إلَهٌ':Added, #3: 3	شَكَّ خَلْفَ
u'شُكْرٌ إلَهٌ':Added, #2: 2	شُكْرُ الْإِلَهِ
u'شكر أوائل':Added, #2: 2	شُكْرُ الْإِلَهِ
u'شُكْرٌ أوائل':Added, #1: 1	شُكْرِ الْأَوَائِلِ
u'شَكَّ رَبِيعٌ':Subject, #1: 1	شُكْرِ الْأَوَائِلِ
u'شَكَّ رَجُلٌ':Subject, #1: 1	شَكَّ الرَّبِيعُ
u'شَكَّ رَجُلٌ':Subject, #2: 2	شَكَّ الرَّجُلُ
u'شَكَرَ حَمَامَةٌ':Predicate, #2: 2	شَكَّ رَجُلٌ
u'شكر شَكُورٌ':Added, #3: 3	شَكَرَ الْحَمَامَةَ
u'شُكْرٌ شَكُورٌ':Added, #2: 2	شُكْرِ الشَّكُورِ
u'شكر صَنِيعٌ':Added, #2: 2	شُكْرِ الشَّكُورِ
u'شُكْرٌ صَنِيعٌ':Added, #1: 1	شُكْرِ الصَّنِيعَةِ
u'شكر صَنِيعَةٌ':Added, #1: 1	شُكْرِ الصَّنِيعَةِ
u'شُكْرٌ صَنِيعَةٌ':Added, #1: 1	شُكْرِ الصَّنِيعَةِ
u'شكر عَبْدٌ':Added, #1: 1	شُكْرِ الصَّنِيعَةِ
u'شُكْرٌ عَبْدٌ':Added, #1: 1	شُكْرُ الْعَبْدِ
u'شكر عَبْدٌ':Added, #1: 1	شُكْرُ الْعَبْدِ
u'شُكْرٌ عَبْدٌ':Added, #3: 3	شُكْرَ الْعَبْدِ
u'شكر فَقِيرٌ':Added, #3: 3	شُكْرَ الْعَبْدِ
u'شُكْرٌ فَقِيرٌ':Added, #1: 1	شُكْرِ الْفَقِيرِ
u'شكر قَوْمٌ':Added, #1: 1	شُكْرِ الْفَقِيرِ
u'شُكْرٌ قَوْمٌ':Added, #1: 1	شُكْرُ الْقَوْمِ
u'شكر لَيْلٌ':Added, #1: 1	شُكْرُ الْقَوْمِ
u'شُكْرٌ لَيْلٌ':Added, #1: 1	شُكْرَ لَيْلَتِهِ
u'شكر مُعْتَرِفٌ':Added, #1: 1	شُكْرَ لَيْلَتِهِ
u'شُكْرٌ مُعْتَرِفٌ':Added, #1: 1	شُكْرَ مُعْتَرِفٍ
u'شَكَرَ مَعْرُوفٌ':Predicate, #1: 1	شُكْرَ مُعْتَرِفٍ
u'شكر مَعْرُوفٌ':Added, #1: 1	شَكَرَ مَعْرُوفَ
u'شُكْرٌ مَعْرُوفٌ':Added, #1: 1	شُكْرِ الْمَعْرُوفِ
u'شكر نِعَمٌ':Added, #1: 1	شُكْرِ الْمَعْرُوفِ
u'شُكْرٌ نِعَمٌ':Added, #1: 1	شُكْرِ النِّعَمِ
u'شكر نِعَمٌ':Added, #1: 1	شُكْرِ النِّعَمِ
u'شُكْرٌ نِعَمٌ':Added, #3: 3	شُكْرِ نِعَمِهِ
u'شكر نعمة':Added, #3: 3	شُكْرِ نِعَمِهِ
u'شُكْرٌ نعمة':Added, #1: 1	شُكْرَ النِّعْمَةِ
u'شكر نِعْمَةٌ':Added, #1: 1	شُكْرَ النِّعْمَةِ
u'شُكْرٌ نِعْمَةٌ':Added, #1: 1	شُكْرَ النِّعْمَةِ
u'شكر نعمة':Added, #1: 1	شُكْرَ النِّعْمَةِ
u'شكر نعمة':Added, #1: 1	شُكْرَ نِعْمَتِهِ
u'شُكْرٌ نعمة':Added, #1: 1	شُكْرِ نِعْمَتِهِ
u'شُكْرٌ نعمة':Added, #1: 1	شُكْرَ نِعْمَتِهِ
u'شكر نِعْمَةٌ':Added, #1: 1	شُكْرِ نِعْمَتِهِ
u'شكر نِعْمَةٌ':Added, #1: 1	شُكْرَ نِعْمَتِهِ
u'شُكْرٌ نِعْمَةٌ':Added, #1: 1	شُكْرِ نِعْمَتِهِ
u'شُكْرٌ نِعْمَةٌ':Added, #1: 1	شُكْرَ نِعْمَتِهِ
u'شكر نعمة':Added, #1: 1	شُكْرِ نِعْمَتِهِ
u'شُكْرٌ نعمة':Added, #2: 2	شُكْرَ نِعْمَةِ
u'شكر نِعْمَةٌ':Added, #2: 2	شُكْرَ نِعْمَةِ
u'شُكْرٌ نِعْمَةٌ':Added, #2: 2	شُكْرَ نِعْمَةِ
u'شكر نعمة':Added, #2: 2	شُكْرَ نِعْمَةِ
u'شُكْرٌ نعمة':Added, #3: 3	شُكْرِ النِّعْمَةِ
u'شكر نِعْمَةٌ':Added, #3: 3	شُكْرِ النِّعْمَةِ
u'شُكْرٌ نِعْمَةٌ':Added, #3: 3	شُكْرِ النِّعْمَةِ
u'شكر نعمة':Added, #3: 3	شُكْرِ النِّعْمَةِ
u'شُكْرٌ نعمة':Added, #4: 4	شُكْرُ النِّعْمَةِ
u'شكر نِعْمَةٌ':Added, #4: 4	شُكْرُ النِّعْمَةِ
u'شُكْرٌ نِعْمَةٌ':Added, #4: 4	شُكْرُ النِّعْمَةِ
u'شكر نعمة':Added, #4: 4	شُكْرُ النِّعْمَةِ
u'شُكْرٌ نعمة':Added, #4: 4	شُكْرِ نِعْمَةِ
u'شكر نِعْمَةٌ':Added, #4: 4	شُكْرِ نِعْمَةِ
u'شُكْرٌ نِعْمَةٌ':Added, #4: 4	شُكْرِ نِعْمَةِ
u'شكر نعمة':Added, #4: 4	شُكْرِ نِعْمَةِ
u'شُكْرٌ نعمة':Added, #6: 6	شُكْرُ نِعْمَةِ
u'شكر نِعْمَةٌ':Added, #6: 6	شُكْرُ نِعْمَةِ
u'شُكْرٌ نِعْمَةٌ':Added, #6: 6	شُكْرُ نِعْمَةِ
u'شكر يَوْمٌ':Added, #6: 6	شُكْرُ نِعْمَةِ
u'شُكْرٌ يَوْمٌ':Added, #1: 1	شُكْرَ يَوْمِهِ
u'شَكَّ سلمة':Subject, #1: 1	شُكْرَ يَوْمِهِ
u'شَكَّ سَيِّدٌ':Subject, #1: 1	شَكَّ سَلَمَةُ
u'شَكَّ شُعْبَةٌ':Subject, #1: 1	شَكَّ السَّيِّدُ
u'شَكَّ شُهُودٌ':Subject, #8: 8	شَكَّ شُعْبَةُ
u'شَكَّ صَائِمٌ':Subject, #1: 1	شَكَّ الشُّهُودُ
u'شَكَّ عَبْدٌ':Subject, #1: 1	شَكَّ الصَّائِمُ
u'شَكَّ عَقِيبٌ':Predicate, #5: 5	شَكَّ عَبْدُ
u'شَكَّ عند':Predicate, #1: 1	شَكَّ عَقِيبَ
u'شَكَّ فلان':Subject, #2: 2	شَكَّ عِنْدَ
u'شَكَّ فلان':Subject, #1: 1	شَكَّ مُعَاوِيَةُ
u'شَكَّ فلان':Subject, #2: 2	شَكَّ زُهَيْرٌ
u'شَكَّ فلان':Subject, #2: 2	شَكَّ عُثْمَانُ
u'شَكَّ فلان':Subject, #2: 2	شَكَّ عَوْفٌ
u'شَكَّ فلان':Subject, #2: 2	شَكَّ قَيْسٌ
u'شَكَّ فلان':Subject, #3: 3	شَكَّ دَاوُدُ
u'شَكَّ قَاتِلٌ':Subject, #4: 4	شَكَّ سُفْيَانُ
u'شَكَّ قَارِئٌ':Subject, #1: 1	شَكَّ قَاتِلُهُ
u'شَكَّ قَالٌ':Predicate, #2: 2	شَكَّ الْقَارِئُ
u'شَكَّ قَيْس':Subject, #2: 2	شَكَّ قَالَ
u'شَكَّ كَاتِبٌ':Subject, #2: 2	شَكَّ قَيْسٌ
u'شَكَّكَ بَعْضٌ':Subject, #1: 1	شَكَّ كَاتِبُ
u'شَكِلَ أقْرَع':Predicate, #1: 1	شَكَّكَ بَعْضُ
u'شَكْلٌ باء':Added, #1: 1	أَشْكَلَ أَقْرَعَ
u'شَكْلٌ خُفٌّ':Added, #1: 1	شَكْلِ الْبَاءِ
u'شَكْلٌ ذكر':Added, #2: 2	شَكْلِ الْخُفِّ
u'شَكْلٌ ذَكَرٌ':Added, #1: 1	شَكْلُ ذَكَرِ
u'شَكْلٌ راء':Added, #1: 1	شَكْلُ ذَكَرِ
u'شَكْلٌ شَيْءٌ':Added, #1: 1	شَكْلِ الرَّاءِ
u'شَكِلَ فرق':Predicate, #1: 1	شَكْلِ الشَّيْءِ
u'شَكِلَ فَرْقٌ':Predicate, #1: 1	أَشْكَلَ الْفَرْقَ
u'شَكْلٌ مَخْرُوطٌ':Added, #1: 1	أَشْكَلَ الْفَرْقَ
u'شَكْلٌ مِزْمَارٌ':Added, #1: 1	شَكْلٍ مَخْرُوطٍ
u'شَكْلٌ مُصْحَفٌ':Added, #1: 1	شَكْلَ الْمِزْمَارِ
u'شَكْلٌ مِيلٌ':Added, #1: 1	شَكْلِ الْمُصْحَفِ
u'شَكْلٌ هِلاَلٌ':Added, #1: 1	شَكْلِ الْمِيلَيْنِ
u'شَكِلَ وَقْتٌ':Predicate, #1: 1	شَكْلِ الْهِلَالِ
u'شَكَّ مَاسِحٌ':Subject, #1: 1	أَشْكَلَ وَقْتَ
u'شَكَّ مَالِكٌ':Subject, #1: 1	شَكَّ مَاسِحُ
u'شَكَّ مُدْرِكٌ':Subject, #2: 2	شَكَّ مَالِكٌ
u'شَكَّ مُسَافِرٌ':Subject, #1: 1	شَكَّ مُدْرِكُ
u'شَكَّ مُسَافِرٌ':Subject, #1: 1	شَكَّ الْمُسَافِرُ
u'شَكَّ مِسْعَرٌ':Subject, #3: 3	شَكَّ مُسَافِرٌ
u'شَكَّ مُعاوِيَة':Subject, #1: 1	شَكَّ مِسْعَرٌ
u'شَكَّ مَنْصُورٌ':Subject, #1: 1	شَكَّ مُعَاوِيَةُ
u'شَكَّ نَاسٌ':Subject, #2: 2	شَكَّ مَنْصُورٌ
u'شَكَّ نَاظِرٌ':Subject, #3: 3	شَكَّ النَّاسُ
u'شَكَّ نِساءٌ':Subject, #1: 1	شَكَّ النَّاظِرُ
u'شَكَّ هشام':Subject, #1: 1	شَكَّ النِّسَاءُ
u'شَكَّ هِشَامٌ':Subject, #2: 2	شَكَّ هِشَامٌ
u'شَكَّ وَجَبٌ':Predicate, #2: 2	شَكَّ هِشَامٌ
u'شَكْوَى رَسُولٌ':Added, #3: 3	شَكَّ وَجَبَ
u'شَكْوَى ظالِمٌ':Added, #1: 1	شَكْوَى رَسُولِ
u'شَكْوَى مَرِيضٌ':Added, #1: 1	شَكْوَى ظَالِمٍ
u'شَكَّ يَعْقُوبٌ':Subject, #2: 2	شَكْوَى الْمَرِيضِ
u'شَلَّ أَنْفٌ':Predicate, #1: 1	شَكَّ يَعْقُوبُ
u'شل بَعْضٌ':Added, #1: 1	أَشَلَّ الْأَنْفَ
u'شَلَّ دِيَةٌ':Subject, #1: 1	فَشَلُ بَعْضِ
u'شَلَلٌ أَنْفٌ':Added, #1: 1	أَشَلَّ دِيَةٌ
u'شَلَلٌ عُضْوٌ':Added, #1: 1	شَلَلِ أَنْفٍ
u'شَلَلٌ عُضْوٌ':Added, #1: 1	شَلَلَ الْعُضْوِ
u'شَلَلٌ عُضْوٌ':Added, #1: 1	شَلَلِ عُضْوٍ
u'شَلَلٌ يَدٌ':Added, #2: 2	شَلَلِ الْعُضْوِ
u'شَلَلٌ يَدٌ':Added, #1: 1	شَلَلِ الْيَدِ
u'شَلَّ مَارِنٌ':Predicate, #1: 1	شَلَلِ الْيَدَيْنِ
u'شَمَاتَةٌ أَعْدَاءٌ':Added, #2: 2	أَشَلَّ الْمَارِنَ
u'شَمَاتَةٌ أَعْدَاءٌ':Added, #1: 1	شَمَاتَةُ أَعْدَاءٍ
u'شَمَاتَةٌ أَعْدَاءٌ':Added, #2: 2	شَمَاتَةُ الْأَعْدَاءِ
u'شَمَّ إمَامٌ':Subject, #2: 2	شَمَاتَةِ الْأَعْدَاءِ
u'شَمَّ بَوْلٌ':Predicate, #1: 1	شَمَّ الْإِمَامُ
u'شَمِتَ أَعْدَاءٌ':Predicate, #1: 1	شَمَّ الْبَوْلَ
u'شَمَّ تُرْبَةٌ':Predicate, #1: 1	أَشْمَتَ الْأَعْدَاءَ
u'شَمِتَ شَوَامِتُ':Subject, #2: 2	شَمَّ تُرْبَةَ
u'شَمَّ رَائِحٌ':Predicate, #1: 1	شَمِتَ الشَّوَامِتُ
u'شَمَّ رَائِحَةٌ':Predicate, #1: 1	شَمَّ الرَّائِحَةَ
u'شَمَّرَ ذَيْلٌ':Predicate, #1: 1	شَمَّ الرَّائِحَةَ
u'شَمَّرَ مِئْزَرُ':Predicate, #1: 1	شَمَّرَ الذَّيْلَ
u'شَمَّ روائح':Predicate, #1: 1	شَمَّرَ الْمِئْزَرَ
u'شَمَّ رَوائِحُ':Predicate, #1: 1	شَمَّ رَوَائِحَ
u'شَمَّ رَوَائِحُ':Predicate, #1: 1	شَمَّ رَوَائِحَ
u'شَمَّ ريحٌ':Predicate, #1: 1	شَمَّ رَوَائِحَ
u'شَمَّسَ ثَوْبٌ':Predicate, #1: 1	شَمَّ الرِّيحَ
u'شَمَّ طِيبٌ':Predicate, #1: 1	شَمَّسَ ثَوْبَ
u'شَمِلَ أَبٌ':Predicate, #1: 1	شَمَّ الطِّيبَ
u'شَمِلَ إجَارَةٌ':Predicate, #1: 1	شَمِلَ الْأَبَ
u'شَمَلَ أَدَاءٌ':Predicate, #1: 1	شَمِلَ إجَارَةَ
u'شَمِلَ أَذَانٌ':Predicate, #1: 1	شَمَلَ الْأَدَاءَ
u'شَمَلَ إِسْلامٌ':Subject, #1: 1	شَمِلَ أَذَانَ
u'شَمِلَ أَشْجَارٌ':Predicate, #1: 1	شَمَلَ إسْلَامُهُ
u'شَمِلَ إِطْلاقٌ':Predicate, #2: 2	شَمِلَ الْأَشْجَارَ
u'شَمِلَ إِطْلاقٌ':Subject, #1: 1	شَمِلَ إطْلَاقَ
u'شَمَلَ إِطْلاقٌ':Subject, #1: 1	شَمِلَ إطْلَاقُ
u'شَمِلَ إِطْلاقٌ':Subject, #2: 2	شَمَلَ إطْلَاقُهُ
u'شَمِلَ أَغْصَانٌ':Predicate, #3: 3	شَمِلَ إطْلَاقُهُ
u'شَمِلَ المُشْتَرِي':Predicate, #2: 2	شَمِلَ الْأَغْصَانَ
u'شَمِلَ إمَامٌ':Subject, #1: 1	شَمِلَ الْمُشْتَرِيَ
u'شَمِلَ أمَانَةٌ':Predicate, #1: 1	شَمِلَ الْإِمَامُ
u'شَمِلَ بَصيرٌ':Subject, #1: 1	شَمِلَ الْأَمَانَةَ
u'شَمَلَ بَعْضٌ':Predicate, #1: 1	شَمِلَ الْبَصِيرُ
u'شَمِلَ بَقاءٌ':Predicate, #1: 1	شَمَلَ بَعْضَ
u'شَمِلَ بَيْعٌ':Predicate, #1: 1	شَمِلَ بَقَاءَ
u'شَمِلَ بَيْعٌ':Predicate, #1: 1	شَمِلَ الْبَيْعَ
u'شَمِلَ تَحْرِيمٌ':Predicate, #1: 1	شَمِلَ بَيْعَ
u'شَمَلَ تَحْرِيمٌ':Predicate, #1: 1	شَمِلَ التَّحْرِيمَ
u'شَمِلَ تَضْعِيفٌ':Subject, #1: 1	شَمَلَ تَحْرِيمَ
u'شَمَلَ تَعْبِيرٌ':Subject, #1: 1	شَمِلَ تَضْعِيفُ
u'شَمِلَ تَمْلِيكٌ':Predicate, #1: 1	شَمَلَ تَعْبِيرُهُ
u'شَمِلَ جَائِزٌ':Predicate, #1: 1	شَمِلَ تَمْلِيكَ
u'شَمْلٌ جَمَاعَةٌ':Added, #1: 1	شَمِلَ الْجَائِزَ
u'شَمِلَ جَمِيع':Predicate, #1: 1	شَمْلِ الْجَمَاعَةِ
u'شَمِلَ حَديثٌ':Subject, #1: 1	شَمِلَ الْجَمِيعَ
u'شَمَلَ حَلْقٌ':Predicate, #1: 1	شَمِلَ الْحَدِيثُ
u'شَمِلَ خَطَأٌ':Predicate, #1: 1	شَمَلَ الْحَلْقَ
u'شَمَلَ خلق':Predicate, #1: 1	شَمِلَ خَطَأَ
u'شَمَلَ خَلْقٌ':Predicate, #1: 1	شَمَلَ الْخَلْقَ
u'شَمَلَ دُبُرٌ':Predicate, #1: 1	شَمَلَ الْخَلْقَ
u'شَمِلَ دَيْنٌ':Predicate, #1: 1	شَمَلَ دُبُرَ
u'شَمْلٌ دِينٌ':Added, #1: 1	شَمِلَ دَيْنَ
u'شَمَلَ ذكر':Predicate, #1: 1	شَمْلِ الدِّينِ
u'شَمَلَ ذَكَرٌ':Predicate, #1: 1	شَمَلَ الذَّكَرَ
u'شَمَلَ ذِمِّيٌّ':Predicate, #1: 1	شَمَلَ الذَّكَرَ
u'شَمِلَ زَوالٌ':Subject, #1: 1	شَمَلَ الذِّمِّيَّ
u'شَمِلَ سَكْرَان':Predicate, #1: 1	شَمِلَ زَوَالُ
u'شَمَلَ سَواءٌ':Subject, #1: 1	شَمِلَ السَّكْرَانَ
u'شَمِلَ شِرَاءٌ':Predicate, #1: 1	شَمَلَ سَوَاءٌ
u'شَمِلَ شَعْرٌ':Predicate, #1: 1	شَمِلَ الشِّرَاءَ
u'شَمَلَ صَبِيٌّ':Predicate, #1: 1	شَمِلَ الشَّعْرَ
u'شَمِلَ صغائر':Predicate, #1: 1	شَمَلَ الصَّبِيَّ
u'شَمِلَ صَغَائِرُ':Predicate, #1: 1	شَمِلَ الصَّغَائِرَ
u'شَمِلَ طَاهِرٌ':Predicate, #1: 1	شَمِلَ الصَّغَائِرَ
u'شَمِلَ عَبْدٌ':Predicate, #1: 1	شَمِلَ الطَّاهِرَ
u'شَمِلَ عَجَمِيٌّ':Predicate, #1: 1	شَمِلَ الْعَبْدَ
u'شَمِلَ عَدَمٌ':Predicate, #1: 1	شَمِلَ الْعَجَمِيَّ
u'شَمِلَ عَيْبٌ':Predicate, #1: 1	شَمِلَ عَدَمَ
u'شَمَلَ غَصْبٌ':Predicate, #1: 1	شَمِلَ الْعَيْبَ
u'شَمِلَ غير':Predicate, #1: 1	شَمَلَ الْغَصْبَ
u'شَمِلَ غَيْرٌ':Predicate, #1: 1	شَمِلَ غَيْرَ
u'شَمِلَ فَرْضٌ':Predicate, #1: 1	شَمِلَ غَيْرَ
u'شَمِلَ قتل':Predicate, #1: 1	شَمِلَ فَرْضَ
u'شَمِلَ قَتْلٌ':Predicate, #1: 1	شَمِلَ قَتْلَ
u'شَمِلَ قَضَاءٌ':Subject, #1: 1	شَمِلَ قَتْلَ
u'شَمِلَ قول':Predicate, #1: 1	شَمِلَ قَضَاءُ
u'شَمِلَ قَوْلٌ':Predicate, #1: 1	شَمِلَ الْقَوْلَ
u'شَمِلَ قول':Subject, #1: 1	شَمِلَ الْقَوْلَ
u'شَمِلَ قَوْلٌ':Subject, #3: 3	شَمِلَ قَوْلُ
u'شَمِلَ قول':Subject, #3: 3	شَمِلَ قَوْلُ
u'شَمِلَ قَوْلٌ':Subject, #40: 40	شَمِلَ قَوْلُهُ
u'شَمَلَ قول':Subject, #40: 40	شَمِلَ قَوْلُهُ
u'شَمَلَ قَوْلٌ':Subject, #5: 5	شَمَلَ قَوْلُهُ
u'شَمِلَ قِيَاسٌ':Predicate, #5: 5	شَمَلَ قَوْلُهُ
u'شَمَلَ كَلاَمٌ':Subject, #1: 1	شَمِلَ الْقِيَاسَ
u'شَمِلَ كَلاَمٌ':Subject, #10: 10	شَمَلَ كَلَامُهُ
u'شَمِلَ كَلاَمٌ':Subject, #18: 18	شَمِلَ كَلَامُ
u'شَمَلَ كَلاَمٌ':Subject, #32: 32	شَمِلَ كَلَامُهُ
u'شَمِلَ لَقِيطٌ':Predicate, #6: 6	شَمَلَ كَلَامُ
u'شَمِلَ مَاءٌ':Predicate, #1: 1	شَمِلَ اللَّقِيطَ
u'شَمِلَ مَالٌ':Predicate, #1: 1	شَمِلَ الْمَاءَ
u'شَمِلَ مُتَّصِلٌ':Predicate, #1: 1	شَمِلَ الْمَالَ
u'شَمِلَ مَجْنِيٌّ':Predicate, #1: 1	شَمِلَ الْمُتَّصِلَ
u'شَمَلَ مُدَبَّرٌ':Predicate, #1: 1	شَمِلَ الْمَجْنِيَّ
u'شَمَلَ مُدَبَّرٌ':Subject, #1: 1	شَمَلَ الْمُدَبَّرَ
u'شَمِلَ مَسَائِلُ':Predicate, #1: 1	شَمَلَ مُدَبَّرُ
u'شَمِلَ مُشْتَرِي':Predicate, #1: 1	شَمِلَ مَسَائِلَ
u'شَمِلَ مُعَارٌ':Predicate, #1: 1	شَمِلَ الْمُشْتَرِيَ
u'شَمِلَ مَغْصُوب':Predicate, #1: 1	شَمِلَ الْمُعَارَ
u'شَمِلَ مَفْهُومٌ':Subject, #1: 1	شَمِلَ الْمَغْصُوبَ
u'شَمِلَ مُنْفَرِدٌ':Predicate, #1: 1	شَمِلَ الْمَفْهُومُ
u'شَمِلَ مَهْرٌ':Predicate, #1: 1	شَمِلَ الْمُنْفَرِدَ
u'شَمِلَ نِساءٌ':Predicate, #1: 1	شَمِلَ مَهْرَ
u'شَمِلَ وَاجِبٌ':Predicate, #1: 1	شَمِلَ النِّسَاءَ
u'شَمَلَ وُضُوءٌ':Subject, #1: 1	شَمِلَ الْوَاجِبَ
u'شَمِلَ وُضُوءٌ':Subject, #1: 1	شَمَلَ الْوُضُوءُ
u'شَمَلَ وَطْءٌ':Subject, #1: 1	شَمِلَ الْوُضُوءُ
u'شَمِلَ وَكِيلٌ':Predicate, #1: 1	شَمَلَ وَطْءُ
u'شَمِلَ ولد':Predicate, #1: 1	شَمِلَ وَكِيلَ
u'شَمِلَ وَلَدٌ':Predicate, #3: 3	شَمِلَ وَلَدَ
u'شَمَّ وَرْدٌ':Predicate, #3: 3	شَمِلَ وَلَدَ
u'شَمَّ يَاسَمِينٌ':Predicate, #1: 1	شَمَّ وَرْدَ
u'شَنَآنٌ قَوْمٌ':Added, #1: 1	شَمَّ الْيَاسَمِينَ
u'شَنَّعَ أهْلٌ':Subject, #5: 5	شَنَآنُ قَوْمٍ
u'شَنَّعَ بَعْضٌ':Subject, #1: 1	شَنَّعَ أَهْلُ
u'شَنَّعَ صَاحِبٌ':Subject, #2: 2	شَنَّعَ بَعْضُ
u'شَنَّعَ علماء':Subject, #1: 1	شَنَّعَ صَاحِبُ
u'شَنَّعَ عُلَمَاءُ':Subject, #1: 1	شَنَّعَ الْعُلَمَاءُ
u'شَنَّ غَارَةٌ':Predicate, #1: 1	شَنَّعَ الْعُلَمَاءُ
u'شَهَادَةٌ أَبٌ':Added, #2: 2	شَنَّ الْغَارَةَ
u'شَهَادَةٌ أَبٌ':Added, #1: 1	شَهَادَةُ أَبٍ
u'شَهَادَةٌ أَبٌ':Added, #1: 1	شَهَادَةَ الْأَبِ
u'شَهَادَةٌ أَبٌ':Added, #4: 4	شَهَادَةِ الْأَبِ
u'شَهَادَةٌ آباءٌ':Added, #5: 5	شَهَادَةُ الْأَبِ
u'شَهَادَةٌ اِبْنٌ':Added, #1: 1	شَهَادَةِ الْآبَاءِ
u'شَهَادَةٌ اِبْنٌ':Added, #1: 1	شَهَادَةَ ابْنِ
u'شَهَادَةٌ اِبْنٌ':Added, #1: 1	شَهَادَةِ ابْنِ
u'شَهَادَةٌ اِبْنٌ':Added, #1: 1	شَهَادَةُ ابْنِهِ
u'شَهَادَةٌ أجَانِبُ':Added, #3: 3	شَهَادَةُ ابْنِ
u'شَهَادَةٌ أَجْنَبِيٌّ':Added, #1: 1	شَهَادَةُ الْأَجَانِبِ
u'شَهَادَةٌ أَجْنَبِيٌّ':Added, #1: 1	شَهَادَةُ الْأَجْنَبِيَّيْنِ
u'شَهَادَةٌ أَجِيرٌ':Added, #2: 2	شَهَادَةِ الْأَجْنَبِيَّيْنِ
u'شَهَادَةٌ أَجِيرٌ':Added, #1: 1	شَهَادَةِ الْأَجِيرِ
u'شَهَادَةٌ أَجِيرٌ':Added, #2: 2	شَهَادَةَ الْأَجِيرِ
u'شَهَادَةٌ أحَدٌ':Added, #4: 4	شَهَادَةُ الْأَجِيرِ
u'شَهَادَةٌ أحَدٌ':Added, #11: 11	شَهَادَةُ أَحَدِ
u'شَهَادَةٌ أحَدٌ':Added, #1: 1	شَهَادَة أَحَدِ
u'شَهَادَةٌ أحَدٌ':Added, #2: 2	شَهَادَةَ أَحَدٍ
u'شَهَادَةٌ أحَدٌ':Added, #2: 2	شَهَادَةَ أَحَدِ
u'شَهَادَةٌ أحَدٌ':Added, #2: 2	شَهَادَةِ أَحَدٍ
u'شَهَادَةٌ أحَدٌ':Added, #2: 2	شَهَادَةِ أَحَدِ
u'شَهَادَةٌ أَحْيَاءٌ':Added, #6: 6	شَهَادَةُ أَحَدٍ
u'شَهَادَةٌ أَخٌ':Added, #1: 1	شَهَادَةَ الْأَحْيَاءِ
u'شَهَادَةٌ أَخٌ':Added, #10: 10	شَهَادَةُ الْأَخِ
u'شَهَادَةٌ أَخٌ':Added, #1: 1	شَهَادَةِ الأَخِ
u'شَهَادَةٌ أَخٌ':Added, #2: 2	شَهَادَةَ الأَخِ
u'شَهَادَةٌ أَخٌ':Added, #3: 3	شَهَادَةَ الْأَخِ
u'شَهَادَةٌ أخرَس':Added, #3: 3	شَهَادَةِ الْأَخِ
u'شَهَادَةٌ أخرَس':Added, #2: 2	شَهَادَةِ الْأَخْرَسِ
u'شَهَادَةٌ أَدَاءٌ':Added, #4: 4	شَهَادَةُ الْأَخْرَسِ
u'شَهَادَةٌ أَدَاءٌ':Added, #1: 1	شَهَادَةَ الْأَدَاءِ
u'شَهَادَةٌ أرْبَابٌ':Added, #2: 2	شَهَادَةُ الْأَدَاءِ
u'شَهَادَةٌ أَرْبَعُ':Added, #2: 2	شَهَادَةُ أَرْبَابِ
u'شَهَادَةٌ أَرْبَعُ':Added, #1: 1	شَهَادَةَ الْأَرْبَعِ
u'شَهَادَةٌ أَرْبَعُ':Added, #1: 1	شَهَادَةِ الْأَرْبَعِ
u'شَهَادَةٌ أَرْبَعُ':Added, #2: 2	شَهَادَةُ أَرْبَعِ
u'شَهَادَةٌ أَرْبَعَةٌ':Added, #6: 6	شَهَادَةُ الْأَرْبَعِ
u'شَهَادَةٌ أَرْبَعَةٌ':Added, #10: 10	شَهَادَةِ أَرْبَعَةٍ
u'شَهَادَةٌ أَرْبَعَةٌ':Added, #1: 1	شَهَادَةَ الْأَرْبَعَةِ
u'شَهَادَةٌ أَرْبَعَةٌ':Added, #2: 2	شَهَادَةُ أَرْبَعَةٍ
u'شَهَادَةٌ أَرْبَعَةٌ':Added, #2: 2	شَهَادَةِ الْأَرْبَعَةِ
u'شَهَادَةٌ أَرْبَعَةٌ':Added, #3: 3	شَهَادَةُ أَرْبَعَةِ
u'شَهَادَةٌ أَسْبَقُ':Added, #3: 3	شَهَادَةُ الْأَرْبَعَةِ
u'شَهَادَةٌ أُسْتَاذٌ':Added, #1: 1	شَهَادَةِ أَسْبَقِ
u'شَهَادَةٌ اِسْتِفاضَةٌ':Added, #1: 1	شَهَادَةُ الْأُسْتَاذِ
u'شَهَادَةٌ أشراف':Added, #2: 2	شَهَادَةُ اسْتِفَاضَةٍ
u'شَهَادَةٌ أَشْرَافٌ':Added, #1: 1	شَهَادَةُ الْأَشْرَافِ
u'شَهَادَةٌ أَصْحَابٌ':Added, #1: 1	شَهَادَةُ الْأَشْرَافِ
u'شَهَادَةٌ أَصْحَابٌ':Added, #1: 1	شَهَادَةِ أَصْحَابِ
u'شَهَادَةٌ أصل':Added, #3: 3	شَهَادَةُ أَصْحَابِ
u'شَهَادَةٌ أًصْلٌ':Added, #1: 1	شَهَادَةِ أَصْلِ
u'شَهَادَةٌ أصل':Added, #1: 1	شَهَادَةِ أَصْلِ
u'شَهَادَةٌ أًصْلٌ':Added, #27: 27	شَهَادَةِ الْأَصْلِ
u'شَهَادَةٌ أًصْلٌ':Added, #27: 27	شَهَادَةِ الْأَصْلِ
u'شَهَادَةٌ أًصْلٌ':Added, #2: 2	شَهَادَةُ أَصْلٍ
u'شَهَادَةٌ أًصْلٌ':Added, #3: 3	شَهَادَةِ أَصْلَيْنِ
u'شَهَادَةٌ أصل':Added, #5: 5	شَهَادَةِ أَصْلٍ
u'شَهَادَةٌ أًصْلٌ':Added, #5: 5	شَهَادَةُ الْأَصْلِ
u'شَهَادَةٌ أصل':Added, #5: 5	شَهَادَةُ الْأَصْلِ
u'شَهَادَةٌ أًصْلٌ':Added, #8: 8	شَهَادَةَ الْأَصْلِ
u'شَهَادَةٌ أَصَمّ':Added, #8: 8	شَهَادَةَ الْأَصْلِ
u'شَهَادَةٌ أُصولٌ':Added, #3: 3	شَهَادَةُ الْأَصَمِّ
u'شَهَادَةٌ أُصولٌ':Added, #11: 11	شَهَادَةَ الْأُصُولِ
u'شَهَادَةٌ أُصولٌ':Added, #13: 13	شَهَادَةِ الْأُصُولِ
u'شَهَادَةٌ أعْرَابِيٌّ':Added, #5: 5	شَهَادَةُ الْأُصُولِ
u'شَهَادَةٌ أعْرَابِيٌّ':Added, #1: 1	شَهَادَةَ الْأَعْرَابِيِّ
u'شَهَادَةٌ أعْوَر':Added, #1: 1	شَهَادَةِ الْأَعْرَابِيِّ
u'شَهَادَةٌ إِفْطارٌ':Added, #1: 1	شَهَادَةُ الْأَعْوَرِ
u'شَهَادَةٌ إِفْطارٌ':Added, #1: 1	شَهَادَةِ الإِفْطَارِ
u'شَهَادَةٌ أَكْثَرُ':Added, #1: 1	شَهَادَةَ الْإِفْطَارِ
u'شَهَادَةٌ الْمَرْءُ':Added, #1: 1	شَهَادَةُ الْأَكْثَرِ
u'شَهَادَةٌ الْمَرْءُ':Added, #1: 1	شَهَادَةَ الْمَرْءِ
u'شَهَادَةٌ الْمَرْأَةُ':Added, #2: 2	شَهَادَةُ الْمَرْءِ
u'شَهَادَةٌ الْمَرْأَةُ':Added, #3: 3	شَهَادَةِ الْمَرْأَةِ
u'شَهَادَةٌ الْمَرْأَةُ':Added, #6: 6	شَهَادَةَ الْمَرْأَةِ
u'شَهَادَةٌ أُمٌّ':Added, #8: 8	شَهَادَةُ الْمَرْأَةِ
u'شَهَادَةٌ أُمٌّ':Added, #1: 1	شَهَادَةَ الْأُمِّ
u'شَهَادَةٌ أُمٌّ':Added, #1: 1	شَهَادَةُ أُمِّهِ
u'شَهَادَةٌ آمِرٌ':Added, #2: 2	شَهَادَةُ أُمِّ
u'شَهَادَةٌ أَمْرٌ':Added, #1: 1	شَهَادَةُ الْآمِرِ
u'شَهَادَةٌ اِمْرَأَةٌ':Added, #1: 1	شَهَادَةِ أَمْرٍ
u'شَهَادَةٌ اِمْرَأَةٌ':Added, #19: 19	شَهَادَةُ امْرَأَةٍ
u'شَهَادَةٌ اِمْرَأَةٌ':Added, #1: 1	شَهَادَةَ امْرَأَةٍ
u'شَهَادَةٌ أَمينٌ':Added, #8: 8	شَهَادَةِ امْرَأَةٍ
u'شَهَادَةٌ إِناثٌ':Added, #1: 1	شَهَادَةُ الْأَمِينِ
u'شَهَادَةٌ إِنْسانٌ':Added, #1: 1	شَهَادَةُ الْإِنَاثِ
u'شَهَادَةٌ إِنْسانٌ':Added, #2: 2	شَهَادَةَ الْإِنْسَانِ
u'شَهَادَةٌ إِنْسانٌ':Added, #3: 3	شَهَادَةُ الْإِنْسَانِ
u'شَهَادَةٌ أهْلٌ':Added, #3: 3	شَهَادَةِ الْإِنْسَانِ
u'شَهَادَةٌ أهْلٌ':Added, #15: 15	شَهَادَةِ أَهْلِ
u'شَهَادَةٌ أهْلٌ':Added, #17: 17	شَهَادَةَ أَهْلِ
u'شَهَادَةٌ أَوَّلُ':Added, #28: 28	شَهَادَةُ أَهْلِ
u'شَهَادَةٌ أَوَّلُ':Added, #1: 1	شَهَادَةَ الْأَوَّلِ
u'شَهَادَةٌ أَوْلاَدٌ':Added, #4: 4	شَهَادَةِ الْأَوَّلِ
u'شَهَادَةٌ بادِي':Added, #1: 1	شَهَادَةُ أَوْلَادِ
u'شَهَادَةٌ بَادِيَةٌ':Added, #1: 1	شَهَادَةِ الْبَادِيَةِ
u'شَهَادَةٌ بَائِعٌ':Added, #1: 1	شَهَادَةِ الْبَادِيَةِ
u'شَهَادَةٌ بَائِعٌ':Added, #1: 1	شَهَادَةَ الْبَائِعِ
u'شَهَادَةٌ بَائِعٌ':Added, #2: 2	شَهَادَةُ بَائِعِ
u'شَهَادَةٌ بَخِيلٌ':Added, #5: 5	شَهَادَةُ الْبَائِعِ
u'شَهَادَةٌ بَخِيلٌ':Added, #1: 1	شَهَادَةُ الْبَخِيلِ
u'شَهَادَةٌ بَدَوِيٌّ':Added, #2: 2	شَهَادَةَ الْبَخِيلِ
u'شَهَادَةٌ بَدَوِيٌّ':Added, #1: 1	شَهَادَةِ الْبَدَوِيِّ
u'شَهَادَةٌ بَصيرٌ':Added, #4: 4	شَهَادَةُ الْبَدَوِيِّ
u'شَهَادَةٌ بَعْضٌ':Added, #1: 1	شَهَادَةُ الْبَصِيرِ
u'شَهَادَةٌ بَعْضٌ':Added, #1: 1	شَهَادَةُ الْبَعْضِ
u'شَهَادَةٌ بَعْضٌ':Added, #2: 2	شَهَادَةَ بَعْضِ
u'شَهَادَةٌ بُغاةٌ':Added, #4: 4	شَهَادَةُ بَعْضِ
u'شَهَادَةٌ بِنْتٌ':Added, #1: 1	شَهَادَةَ الْبُغَاةِ
u'شَهَادَةٌ بِنْتٌ':Added, #1: 1	شَهَادَةَ الْبِنْتِ
u'شَهَادَةٌ بَيِّنَةٌ':Added, #1: 1	شَهَادَةُ الْبِنْتِ
u'شَهَادَةٌ بَيِّنَةٌ':Added, #1: 1	شَهَادَةِ بَيِّنَةِ
u'شَهَادَةٌ بَيِّنَةٌ':Added, #3: 3	شَهَادَةَ الْبَيِّنَةِ
u'شَهَادَةٌ بَيِّنَةٌ':Added, #4: 4	شَهَادَةِ الْبَيِّنَةِ
u'شَهَادَةٌ تارِك':Added, #6: 6	شَهَادَةُ الْبَيِّنَةِ
u'شَهَادَةٌ تَائِبٌ':Added, #1: 1	شَهَادَةُ تَارِكِ
u'شَهَادَةٌ تُجَّارٌ':Added, #2: 2	شَهَادَةُ التَّائِبِ
u'شَهَادَةٌ تَضْحِيَةٌ':Added, #1: 1	شَهَادَةُ التُّجَّارِ
u'شَهَادَةٌ تَقْويمٌ':Added, #1: 1	شَهَادَةِ التَّضْحِيَةِ
u'شَهَادَةٌ تِلْميذٌ':Added, #2: 2	شَهَادَةِ التَّقْوِيمِ
u'شَهَادَةٌ تَوْكِيلٌ':Added, #1: 1	شَهَادَةَ التِّلْمِيذِ
u'شَهَادَةٌ ثَانِي':Added, #1: 1	شَهَادَةِ التَّوْكِيلِ
u'شَهَادَةٌ ثَانِيَةٌ':Added, #1: 1	شَهَادَةُ الثَّانِيَةِ
u'شَهَادَةٌ ثِقَةٌ':Added, #1: 1	شَهَادَةُ الثَّانِيَةِ
u'شَهَادَةٌ ثَلاثَةٌ':Added, #1: 1	شَهَادَةُ الثِّقَةِ
u'شَهَادَةٌ جَمَاعَةٌ':Added, #3: 3	شَهَادَةِ ثَلَاثَةٍ
u'شَهَادَةٌ جَمَاعَةٌ':Added, #1: 1	شَهَادَةَ جَمَاعَةٍ
u'شَهَادَةٌ جَمَاعَةٌ':Added, #1: 1	شَهَادَةُ جَمَاعَةِ
u'شَهَادَةٌ جَمْعٌ':Added, #2: 2	شَهَادَةِ جَمَاعَةٍ
u'شَهَادَةٌ جُنْدٌ':Added, #2: 2	شَهَادَةُ جَمْعٍ
u'شَهَادَةٌ جَهْم':Added, #1: 1	شَهَادَةُ الْجُنْدِ
u'شَهَادَةٌ حارِسٌ':Added, #1: 1	شَهَادَةَ الْجَهْمِيَّةِ
u'شَهَادَةٌ حاكِمٌ':Added, #1: 1	شَهَادَةِ الْحَارِسِ
u'شَهَادَةٌ حاكِمٌ':Added, #1: 1	شَهَادَةِ الْحَاكِمِ
u'شَهَادَةٌ حائِكٌ':Added, #2: 2	شَهَادَةُ الْحَاكِمِ
u'شَهَادَةٌ حَجَّام':Added, #3: 3	شَهَادَةِ الْحَائِكِ
u'شَهَادَةٌ حَديثٌ':Added, #1: 1	شَهَادَةِ الْحَجَّامِ
u'شَهَادَةٌ حُرٌّ':Added, #1: 1	شَهَادَةُ الْحَدِيثِ
u'شَهَادَةٌ حُرٌّ':Added, #1: 1	شَهَادَةَ الْحُرِّ
u'شَهَادَةٌ حِسٌّ':Added, #1: 1	شَهَادَةُ الْحُرَّةِ
u'شَهَادَةٌ حِسْبَةٌ':Added, #1: 1	شَهَادَةَ الْحِسِّ
u'شَهَادَةٌ حِسْبَةٌ':Added, #13: 13	شَهَادَةُ الْحِسْبَةِ
u'شَهَادَةٌ حِسْبَةٌ':Added, #3: 3	شَهَادَةَ الْحِسْبَةِ
u'شَهَادَةٌ حَسَنٌ':Added, #5: 5	شَهَادَةِ الْحِسْبَةِ
u'شَهَادَةٌ حُضورٌ':Added, #1: 1	شَهَادَةِ الْحَسَنِ
u'شَهَادَةٌ حُضُورٌ':Added, #1: 1	شَهَادَةِ الْحُضُورِ
u'شَهَادَةٌ حَقٌّ':Added, #1: 1	شَهَادَةِ الْحُضُورِ
u'شَهَادَةٌ حَقٌّ':Added, #1: 1	شَهَادَةِ الْحَقِّ
u'شَهَادَةٌ حَقٌّ':Added, #2: 2	شَهَادَةُ الْحَقِّ
u'شَهَادَةٌ حُكْمٌ':Added, #4: 4	شَهَادَةَ الْحَقِّ
u'شَهَادَةٌ خَائِنٌ':Added, #1: 1	شَهَادَةُ الْحُكْمِ
u'شَهَادَةٌ خَائِنٌ':Added, #12: 12	شَهَادَةُ خَائِنٍ
u'شَهَادَةٌ خَائِنٌ':Added, #1: 1	شَهَادَةَ الْخَائِنِ
u'شَهَادَةٌ خُدَّامٌ':Added, #1: 1	شَهَادَةُ الْخَائِنِ
u'شَهَادَةٌ خِزَانَةٌ':Added, #1: 1	شَهَادَةَ خُدَّامِهِ
u'شَهَادَةٌ خَصْمٌ':Added, #1: 1	شَهَادَةِ الْخِزَانَةِ
u'شَهَادَةٌ خَصْمٌ':Added, #13: 13	شَهَادَةُ خَصْمٍ
u'شَهَادَةٌ خَصْمٌ':Added, #1: 1	شَهَادَةُ الْخَصْمِ
u'شَهَادَةٌ خُصُومَةٌ':Added, #1: 1	شَهَادَةَ خَصْمٍ
u'شَهَادَةٌ خَطابَة':Added, #1: 1	شَهَادَةِ الْخُصُومَةِ
u'شَهَادَةٌ خوارج':Added, #2: 2	شَهَادَةِ الْخَطَابِيَّةِ
u'شَهَادَةٌ خَوَارِجُ':Added, #1: 1	شَهَادَةِ الْخَوَارِجِ
u'شَهَادَةٌ دَاعِرٌ':Added, #1: 1	شَهَادَةِ الْخَوَارِجِ
u'شَهَادَةٌ دَائِنٌ':Added, #1: 1	شَهَادَةُ الدَّاعِرِ
u'شَهَادَةٌ دُخُولٌ':Added, #2: 2	شَهَادَةَ الدَّائِنِ
u'شَهَادَةٌ دِيوانٌ':Added, #1: 1	شَهَادَةِ الدُّخُولِ
u'شَهَادَةٌ ذِمَّةٌ':Added, #2: 2	شَهَادَةُ دِيوَانِ
u'شَهَادَةٌ ذِمِّيٌّ':Added, #1: 1	شَهَادَةِ الذِّمَّةِ
u'شَهَادَةٌ ذِمِّيٌّ':Added, #1: 1	شَهَادَةَ الذِّمِّيِّ
u'شَهَادَةٌ ذِمِّيٌّ':Added, #1: 1	شَهَادَةِ الذِّمِّيَّيْنِ
u'شَهَادَةٌ ذِمِّيٌّ':Added, #1: 1	شَهَادَةُ ذِمِّيَّيْنِ
u'شَهَادَةٌ ذِمِّيٌّ':Added, #7: 7	شَهَادَةِ الذِّمِّيِّ
u'شَهَادَةٌ رَاهِنٌ':Added, #8: 8	شَهَادَةُ الذِّمِّيِّ
u'شَهَادَةٌ رَاهِنٌ':Added, #1: 1	شَهَادَةُ الرَّاهِنَيْنِ
u'شَهَادَةٌ رَبُّ':Added, #1: 1	شَهَادَةِ الرَّاهِنَيْنِ
u'شَهَادَةٌ رَبِيبٌ':Added, #3: 3	شَهَادَةُ رَبِّ
u'شَهَادَةٌ رِجَالٌ':Added, #1: 1	شَهَادَةُ الرَّبِيبِ
u'شَهَادَةٌ رِجَالٌ':Added, #11: 11	شَهَادَةِ الرِّجَالِ
u'شَهَادَةٌ رِجَالٌ':Added, #1: 1	شَهَادَةَ الرِّجَالِ
u'شَهَادَةٌ رَجُلٌ':Added, #2: 2	شَهَادَةُ الرِّجَالِ
u'شَهَادَةٌ رَجُلٌ':Added, #10: 10	شَهَادَةَ رَجُلَيْنِ
u'شَهَادَةٌ رَجُلٌ':Added, #14: 14	شَهَادَةِ رَجُلٍ
u'شَهَادَةٌ رَجُلٌ':Added, #17: 17	شَهَادَةُ الرَّجُلِ
u'شَهَادَةٌ رَجُلٌ':Added, #19: 19	شَهَادَةُ رَجُلٍ
u'شَهَادَةٌ رَجُلٌ':Added, #21: 21	شَهَادَةَ رَجُلٍ
u'شَهَادَةٌ رَجُلٌ':Added, #21: 21	شَهَادَةِ رَجُلَيْنِ
u'شَهَادَةٌ رَجُلٌ':Added, #39: 39	شَهَادَةُ رَجُلَيْنِ
u'شَهَادَةٌ رَجُلٌ':Added, #5: 5	شَهَادَةَ الرَّجُلِ
u'شَهَادَةٌ رُجُوعٌ':Added, #9: 9	شَهَادَةِ الرَّجُلِ
u'شَهَادَةٌ رَسُولٌ':Added, #1: 1	شَهَادَةُ الرُّجُوعِ
u'شَهَادَةٌ رضاع':Added, #2: 2	شَهَادَةُ الرَّسُولِ
u'شَهَادَةٌ رضاع':Added, #1: 1	شَهَادَةِ الرَّضَاعِ
u'شَهَادَةٌ رَعِيَّةٌ':Added, #2: 2	شَهَادَةُ الرَّضَاعِ
u'شَهَادَةٌ رَقَّاصٌ':Added, #2: 2	شَهَادَةُ الرَّعِيَّةِ
u'شَهَادَةٌ رَئِيسٌ':Added, #1: 1	شَهَادَةُ الرَّقَّاصِ
u'شَهَادَةٌ زائِدٌ':Added, #2: 2	شَهَادَةَ الرَّئِيسِ
u'شَهَادَةٌ زَوْجٌ':Added, #2: 2	شَهَادَةُ الزَّائِدِ
u'شَهَادَةٌ زَوْجٌ':Added, #1: 1	شَهَادَةُ الزَّوْجَيْنِ
u'شَهَادَةٌ زَوْجٌ':Added, #1: 1	شَهَادَةُ زَوْجٍ
u'شَهَادَةٌ زَوْجٌ':Added, #3: 3	شَهَادَةَ الزَّوْجِ
u'شَهَادَةٌ زُورٌ':Added, #9: 9	شَهَادَةُ الزَّوْجِ
u'شَهَادَةٌ زُورٌ':Added, #19: 19	شَهَادَةُ الزُّورِ
u'شَهَادَةٌ زُورٌ':Added, #1: 1	شَهَادَةٍ زُورٍ
u'شَهَادَةٌ زُورٌ':Added, #26: 26	شَهَادَةِ الزُّورِ
u'شَهَادَةٌ زُورٌ':Added, #3: 3	شَهَادَةُ زُورٍ
u'شَهَادَةٌ زُورٌ':Added, #3: 3	شَهَادَةِ زُورٍ
u'شَهَادَةٌ سَبْيٌ':Added, #7: 7	شَهَادَةَ الزُّورِ
u'شَهَادَةٌ سَمَاعٌ':Added, #1: 1	شَهَادَةُ السَّبْيِ
u'شَهَادَةٌ سَمَاعٌ':Added, #12: 12	شَهَادَةُ السَّمَاعِ
u'شَهَادَةٌ سَمَاعٌ':Added, #1: 1	شَهَادَةَ السَّمَاعِ
u'شَهَادَةٌ سُؤَالٌ':Added, #6: 6	شَهَادَةِ السَّمَاعِ
u'شَهَادَةٌ سُؤَالٌ':Added, #1: 1	شَهَادَةَ السُّؤَالِ
u'شَهَادَةٌ سَيِّدٌ':Added, #1: 1	شَهَادَةُ السُّؤَالِ
u'شَهَادَةٌ شَارِبٌ':Added, #4: 4	شَهَادَةُ السَّيِّدِ
u'شَهَادَةٌ شَارِعٌ':Added, #1: 1	شَهَادَةُ شَارِبِ
u'شَهَادَةٌ شَاعِر':Added, #1: 1	شَهَادَةِ الشَّارِعِ
u'شَهَادَةٌ شَاهِدٌ':Added, #2: 2	شَهَادَةُ الشَّاعِرِ
u'شَهَادَةٌ شَاهِدٌ':Added, #10: 10	شَهَادَةِ الشَّاهِدَيْنِ
u'شَهَادَةٌ شَاهِدٌ':Added, #11: 11	شَهَادَةُ الشَّاهِدِ
u'شَهَادَةٌ شَاهِدٌ':Added, #12: 12	شَهَادَةِ الشَّاهِدِ
u'شَهَادَةٌ شَاهِدٌ':Added, #1: 1	شَهَادَةُ شَاهِدٍ
u'شَهَادَةٌ شَاهِدٌ':Added, #1: 1	شَهَادَةُ شَاهِدِ
u'شَهَادَةٌ شَاهِدٌ':Added, #1: 1	شَهَادَةِ شَاهِدِهِ
u'شَهَادَةٌ شَاهِدٌ':Added, #20: 20	شَهَادَةِ شَاهِدَيْنِ
u'شَهَادَةٌ شَاهِدٌ':Added, #2: 2	شَهَادَةَ الشَّاهِدَيْنِ
u'شَهَادَةٌ شَاهِدٌ':Added, #2: 2	شَهَادَةَ شَاهِدَيْنِ
u'شَهَادَةٌ شَاهِدٌ':Added, #3: 3	شَهَادَةُ الشَّاهِدَيْنِ
u'شَهَادَةٌ شَاهِدٌ':Added, #6: 6	شَهَادَةِ شَاهِدٍ
u'شَهَادَةٌ شَاهِدٌ':Added, #7: 7	شَهَادَةُ شَاهِدَيْنِ
u'شَهَادَةٌ شَخْصٌ':Added, #8: 8	شَهَادَةَ الشَّاهِدِ
u'شَهَادَةٌ شَرْطٌ':Added, #1: 1	شَهَادَةُ شَخْصٍ
u'شَهَادَةٌ شَرْطٌ':Added, #1: 1	شَهَادَةِ الشَّرْطِ
u'شَهَادَةٌ شَرْعٌ':Added, #1: 1	شَهَادَةُ شَرْطِ
u'شَهَادَةٌ شَرْعِيٌّ':Added, #1: 1	شَهَادَةِ الشَّرْعِ
u'شَهَادَةٌ شَرِيكٌ':Added, #1: 1	شَهَادَةٍ شَرْعِيَّةٍ
u'شَهَادَةٌ شَرِيكٌ':Added, #2: 2	شَهَادَةِ الشَّرِيكِ
u'شَهَادَةٌ شُعرَاءُ':Added, #4: 4	شَهَادَةُ الشَّرِيكِ
u'شَهَادَةٌ شُعَرَاءُ':Added, #1: 1	شَهَادَةِ الشُّعَرَاءِ
u'شَهَادَةٌ شَفِيعٌ':Added, #1: 1	شَهَادَةِ الشُّعَرَاءِ
u'شَهَادَةٌ شَفِيعٌ':Added, #1: 1	شَهَادَةُ الشَّفِيعِ
u'شَهَادَةٌ شُهُودٌ':Added, #1: 1	شَهَادَةُ الشَّفِيعَيْنِ
u'شَهَادَةٌ شُهُودٌ':Added, #12: 12	شَهَادَةَ الشُّهُودِ
u'شَهَادَةٌ شُهُودٌ':Added, #17: 17	شَهَادَةِ الشُّهُودِ
u'شَهَادَةٌ شُهُودٌ':Added, #1: 1	شَهَادَةِ شُهُودٍ
u'شَهَادَةٌ شُهُودٌ':Added, #1: 1	شَهَادَةُ شُهُودِهِ
u'شَهَادَةٌ شُهُودٌ':Added, #1: 1	شَهَادَةِ شُهُودِهِ
u'شَهَادَةٌ شُهُودٌ':Added, #3: 3	شَهَادَةَ شُهُودِ
u'شَهَادَةٌ شُهُودٌ':Added, #3: 3	شَهَادَةِ شُهُودِ
u'شَهَادَةٌ شُهُودٌ':Added, #3: 3	شَهَادَةَ شُهُودِهِ
u'شَهَادَةٌ شُهُودٌ':Added, #4: 4	شَهَادَةَ شُهُودٍ
u'شَهَادَةٌ شُهُودٌ':Added, #5: 5	شَهَادَةُ شُهُودٍ
u'شَهَادَةٌ شُهُودٌ':Added, #7: 7	شَهَادَةُ الشُّهُودِ
u'شَهَادَةٌ شَيْخٌ':Added, #7: 7	شَهَادَةُ شُهُودِ
u'شَهَادَةٌ شَيْخٌ':Added, #1: 1	شَهَادَةَ شَيْخٍ
u'شَهَادَةٌ صَاحِبٌ':Added, #1: 1	شَهَادَةُ شَيْخٍ
u'شَهَادَةٌ صَاحِبٌ':Added, #2: 2	شَهَادَةُ صَاحِبِ
u'شَهَادَةٌ صَاحِبٌ':Added, #2: 2	شَهَادَةِ صَاحِبِهِ
u'شَهَادَةٌ صَبِيٌّ':Added, #3: 3	شَهَادَةُ صَاحِبِهِ
u'شَهَادَةٌ صِبْيَانٌ':Added, #1: 1	شَهَادَةُ الصَّبِيَّيْنِ
u'شَهَادَةٌ صُبْيَانٌ':Added, #11: 11	شَهَادَةُ الصِّبْيَانِ
u'شَهَادَةٌ صِبْيَانٌ':Added, #1: 1	شَهَادَةُ الصّبْيَانِ
u'شَهَادَةٌ صِبْيَانٌ':Added, #1: 1	شَهَادَةُ الصّبْيَانِ
u'شَهَادَةٌ صِبْيَانٌ':Added, #3: 3	شَهَادَةِ الصِّبْيَانِ
u'شَهَادَةٌ صِدْقٌ':Added, #4: 4	شَهَادَةَ الصِّبْيَانِ
u'شَهَادَةٌ صَدِيقٌ':Added, #1: 1	شَهَادَةَ صِدْقٍ
u'شَهَادَةٌ صَرِيحٌ':Added, #5: 5	شَهَادَةُ الصَّدِيقِ
u'شَهَادَةٌ صغار':Added, #1: 1	شَهَادَةٍ صَرِيحَةٍ
u'شَهَادَةٌ طَبِيبٌ':Added, #1: 1	شَهَادَةُ الصِّغَارِ
u'شَهَادَةٌ طَبِيبٌ':Added, #1: 1	شَهَادَةِ الطَّبِيبِ
u'شَهَادَةٌ طُفَيْلِيٌّ':Added, #1: 1	شَهَادَةَ طَبِيبَيْنِ
u'شَهَادَةٌ طَلاَقٌ':Added, #4: 4	شَهَادَةُ الطُّفَيْلِيِّ
u'شَهَادَةٌ ظاهِرٌ':Added, #2: 2	شَهَادَةِ الطَّلَاقِ
u'شَهَادَةٌ ظَنِينٌ':Added, #2: 2	شَهَادَةِ الظَّاهِرِ
u'شَهَادَةٌ عَادَةٌ':Added, #1: 1	شَهَادَةِ الظَّنِينِ
u'شَهَادَةٌ عَاصِبٌ':Added, #3: 3	شَهَادَةِ الْعَادَةِ
u'شَهَادَةٌ عَاقِلٌ':Added, #1: 1	شَهَادَةُ الْعَاصِبَيْنِ
u'شَهَادَةٌ عَبَّاسٌ':Added, #1: 1	شَهَادَةُ الْعَاقِلَةِ
u'شَهَادَةٌ عَبْدٌ':Added, #1: 1	شَهَادَةُ الْعَبّاسِ
u'شَهَادَةٌ عَبْدٌ':Added, #1: 1	شَهَادَةَ عَبْدِ
u'شَهَادَةٌ عَبْدٌ':Added, #1: 1	شَهَادَةُ عَبْدِ
u'شَهَادَةٌ عَبْدٌ':Added, #1: 1	شَهَادَةِ عَبْدٍ
u'شَهَادَةٌ عَبْدٌ':Added, #1: 1	شَهَادَةِ عَبْدَيْنِ
u'شَهَادَةٌ عَبْدٌ':Added, #3: 3	شَهَادَةَ الْعَبْدِ
u'شَهَادَةٌ عَبْدٌ':Added, #3: 3	شَهَادَةُ عَبْدٍ
u'شَهَادَةٌ عَبْدٌ':Added, #7: 7	شَهَادَةِ الْعَبْدِ
u'شَهَادَةٌ عَبِيدٌ':Added, #8: 8	شَهَادَةُ الْعَبْدِ
u'شَهَادَةٌ عَبِيدٌ':Added, #1: 1	شَهَادَةِ الْعَبِيدِ
u'شَهَادَةٌ عَبِيدٌ':Added, #2: 2	شَهَادَةَ الْعَبِيدِ
u'شَهَادَةٌ عتق':Added, #3: 3	شَهَادَةُ الْعَبِيدِ
u'شَهَادَةٌ عِتْقٌ':Added, #1: 1	شَهَادَةِ عِتْقِ
u'شَهَادَةٌ عَتِيقٌ':Added, #1: 1	شَهَادَةِ عِتْقِ
u'شَهَادَةٌ عَتِيقٌ':Added, #1: 1	شَهَادَةُ الْعَتِيقِ
u'شَهَادَةٌ عَدَدٌ':Added, #1: 1	شَهَادَةِ عَتِيقِ
u'شَهَادَةٌ عَدْلٌ':Added, #1: 1	شَهَادَةِ عَدَدٍ
u'شَهَادَةٌ عَدْلٌ':Added, #10: 10	شَهَادَةِ عَدْلَيْنِ
u'شَهَادَةٌ عَدْلٌ':Added, #1: 1	شَهَادَةُ الْعَدْلَيْنِ
u'شَهَادَةٌ عَدْلٌ':Added, #1: 1	شَهَادَةَ عَدْلٍ
u'شَهَادَةٌ عَدْلٌ':Added, #2: 2	شَهَادَةَ الْعَدْلِ
u'شَهَادَةٌ عَدْلٌ':Added, #2: 2	شَهَادَةِ الْعَدْلَيْنِ
u'شَهَادَةٌ عَدْلٌ':Added, #2: 2	شَهَادَةِ عَدْلٍ
u'شَهَادَةٌ عَدْلٌ':Added, #3: 3	شَهَادَةُ عَدْلٍ
u'شَهَادَةٌ عَدْلٌ':Added, #6: 6	شَهَادَةُ الْعَدْلِ
u'شَهَادَةٌ عَدْلٌ':Added, #6: 6	شَهَادَةِ الْعَدْلِ
u'شَهَادَةٌ عَدُوٌّ':Added, #6: 6	شَهَادَةُ عَدْلَيْنِ
u'شَهَادَةٌ عَدُوٌّ':Added, #3: 3	شَهَادَةِ الْعَدُوِّ
u'شَهَادَةٌ عَدُوٌّ':Added, #5: 5	شَهَادَةَ الْعَدُوِّ
u'شَهَادَةٌ عُدُولٌ':Added, #6: 6	شَهَادَةُ الْعَدُوِّ
u'شَهَادَةٌ عُدُولٌ':Added, #1: 1	شَهَادَةِ الْعُدُولِ
u'شَهَادَةٌ عِلَّةٌ':Added, #3: 3	شَهَادَةُ الْعُدُولِ
u'شَهَادَةٌ عُمَّالٌ':Added, #1: 1	شَهَادَةُ الْعِلَّةِ
u'شَهَادَةٌ عَمَلٌ':Added, #1: 1	شَهَادَةَ الْعُمَّالِ
u'شَهَادَةٌ غَاصِبٌ':Added, #1: 1	شَهَادَةِ عَمَلٍ
u'شَهَادَةٌ غَاصِبٌ':Added, #1: 1	شَهَادَةُ الْغَاصِبَيْنِ
u'شَهَادَةٌ غرماء':Added, #1: 1	شَهَادَةُ غَاصِبٍ
u'شَهَادَةٌ غَرِيمٌ':Added, #1: 1	شَهَادَةِ الْغُرَمَاءِ
u'شَهَادَةٌ غَرِيمٌ':Added, #1: 1	شَهَادَةَ الْغَرِيمَيْنِ
u'شَهَادَةٌ غَرِيمٌ':Added, #1: 1	شَهَادَةُ الْغَرِيمَيْنِ
u'شَهَادَةٌ غُلاَمٌ':Added, #2: 2	شَهَادَةِ الْغَرِيمِ
u'شَهَادَةٌ غير':Added, #1: 1	شَهَادَةِ الْغُلاَمِ
u'شَهَادَةٌ غَيْرٌ':Added, #1: 1	شَهَادَةَ غَيْرِ
u'شَهَادَةٌ غير':Added, #1: 1	شَهَادَةَ غَيْرِ
u'شَهَادَةٌ غير':Added, #2: 2	شَهَادَةُ غَيْرِ
u'شَهَادَةٌ غَيْرٌ':Added, #2: 2	شَهَادَةِ غَيْرِ
u'شَهَادَةٌ غَيْرٌ':Added, #2: 2	شَهَادَةُ غَيْرِ
u'شَهَادَةٌ غير':Added, #2: 2	شَهَادَةِ غَيْرِ
u'شَهَادَةٌ غَيْرٌ':Added, #7: 7	شَهَادَةِ غَيْرِهِ
u'شَهَادَةٌ فَاسِقٌ':Added, #7: 7	شَهَادَةِ غَيْرِهِ
u'شَهَادَةٌ فَاسِقٌ':Added, #1: 1	شَهَادَةِ فَاسِقٍ
u'شَهَادَةٌ فَاسِقٌ':Added, #1: 1	شَهَادَةَ فَاسِقَيْنِ
u'شَهَادَةٌ فَاسِقٌ':Added, #1: 1	شَهَادَةِ فَاسِقَيْنِ
u'شَهَادَةٌ فَاسِقٌ':Added, #2: 2	شَهَادَةُ الْفَاسِقِ
u'شَهَادَةٌ فَاسِقٌ':Added, #2: 2	شَهَادَةُ فَاسِقٍ
u'شَهَادَةٌ فَاسِقٌ':Added, #3: 3	شَهَادَةَ الْفَاسِقِ
u'شَهَادَةٌ فَاعِلٌ':Added, #8: 8	شَهَادَةِ الْفَاسِقِ
u'شَهَادَةٌ فرد':Added, #1: 1	شَهَادَةِ الْفَاعِلِ
u'شَهَادَةٌ فَرْدٌ':Added, #1: 1	شَهَادَةِ الْفَرْدِ
u'شَهَادَةٌ فَرْدٌ':Added, #1: 1	شَهَادَةِ الْفَرْدِ
u'شَهَادَةٌ فرد':Added, #1: 1	شَهَادَةَ فَرْدٍ
u'شَهَادَةٌ فَرْدٌ':Added, #5: 5	شَهَادَةَ الْفَرْدِ
u'شَهَادَةٌ فَرْدٌ':Added, #5: 5	شَهَادَةَ الْفَرْدِ
u'شَهَادَةٌ فَرْعٌ':Added, #6: 6	شَهَادَةُ فَرْدٍ
u'شَهَادَةٌ فَرْعٌ':Added, #15: 15	شَهَادَةُ الْفَرْعِ
u'شَهَادَةٌ فَرْعٌ':Added, #15: 15	شَهَادَةِ الْفَرْعِ
u'شَهَادَةٌ فَرْعٌ':Added, #1: 1	شَهَادَةَ الْفَرْعَيْنِ
u'شَهَادَةٌ فَرْعٌ':Added, #1: 1	شَهَادَةُ الْفَرْعَيْنِ
u'شَهَادَةٌ فَرْعٌ':Added, #1: 1	شَهَادَةُ فَرْعٍ
u'شَهَادَةٌ فَرْعٌ':Added, #1: 1	شَهَادَةِ فَرْعٍ
u'شَهَادَةٌ فُرُوعٌ':Added, #7: 7	شَهَادَةَ الْفَرْعِ
u'شَهَادَةٌ فُرُوعٌ':Added, #3: 3	شَهَادَةَ الْفُرُوعِ
u'شَهَادَةٌ فُرُوعٌ':Added, #7: 7	شَهَادَةِ الْفُرُوعِ
u'شَهَادَةٌ فَرِيقٌ':Added, #8: 8	شَهَادَةُ الْفُرُوعِ
u'شَهَادَةٌ فَرِيقٌ':Added, #1: 1	شَهَادَةَ الْفَرِيقِ
u'شَهَادَةٌ فَرِيقٌ':Added, #1: 1	شَهَادَةَ الْفَرِيقَيْنِ
u'شَهَادَةٌ فَرِيقٌ':Added, #1: 1	شَهَادَةُ الْفَرِيقَيْنِ
u'شَهَادَةٌ فَرِيقٌ':Added, #2: 2	شَهَادَةِ الْفَرِيقَيْنِ
u'شَهَادَةٌ فَرِيقٌ':Added, #5: 5	شَهَادَةُ الْفَرِيقِ
u'شَهَادَةٌ فُسَّاقٌ':Added, #8: 8	شَهَادَةِ الْفَرِيقِ
u'شَهَادَةٌ فِطْرٌ':Added, #1: 1	شَهَادَةِ الْفُسَّاقِ
u'شَهَادَةٌ فقهاء':Added, #1: 1	شَهَادَةِ الْفِطْرِ
u'شَهَادَةٌ فقهاء':Added, #1: 1	شَهَادَةَ الْفُقَهَاءِ
u'شَهَادَةٌ فقهاء':Added, #1: 1	شَهَادَةِ الْفُقَهَاءِ
u'شَهَادَةٌ فُلاَنٌ':Added, #2: 2	شَهَادَةُ الْفُقَهَاءِ
u'شَهَادَةٌ فُلاَنٌ':Added, #1: 1	شَهَادَةُ فُلَانٍ
u'شَهَادَةٌ فُلاَنٌ':Added, #2: 2	شَهَادَةَ فُلَانٍ
u'شَهَادَةٌ قَابِلٌ':Added, #9: 9	شَهَادَةِ فُلَانٍ
u'شَهَادَةٌ قَابِلٌ':Added, #12: 12	شَهَادَةَ الْقَابِلَةِ
u'شَهَادَةٌ قَابِلٌ':Added, #15: 15	شَهَادَةُ الْقَابِلَةِ
u'شَهَادَةٌ قَاذِفٌ':Added, #9: 9	شَهَادَةِ الْقَابِلَةِ
u'شَهَادَةٌ قَاذِفٌ':Added, #1: 1	شَهَادَةُ قَاذِفِ
u'شَهَادَةٌ قَاذِفٌ':Added, #2: 2	شَهَادَةَ الْقَاذِفِ
u'شَهَادَةٌ قَاذِفٌ':Added, #3: 3	شَهَادَةُ الْقَاذِفِ
u'شَهَادَةٌ قَارِئٌ':Added, #8: 8	شَهَادَةِ الْقَاذِفِ
u'شَهَادَةٌ قَاسِمٌ':Added, #1: 1	شَهَادَةُ الْقَارِئِ
u'شَهَادَةٌ قَاسِمٌ':Added, #1: 1	شَهَادَةَ الْقَاسِمَيْنِ
u'شَهَادَةٌ قَاسِمٌ':Added, #2: 2	شَهَادَةُ الْقَاسِمِ
u'شَهَادَةٌ قَانِعٌ':Added, #2: 2	شَهَادَةُ الْقَاسِمَيْنِ
u'شَهَادَةٌ قَائِمٌ':Added, #1: 1	شَهَادَةَ الْقَانِعِ
u'شَهَادَةٌ قَائِمَةٌ':Added, #1: 1	شَهَادَةٍ قَائِمَةٍ
u'شَهَادَةٌ قِبْلَةٌ':Added, #1: 1	شَهَادَةٍ قَائِمَةٍ
u'شَهَادَةٌ قذف':Added, #1: 1	شَهَادَةُ الْقِبْلَةِ
u'شَهَادَةٌ قَذْفٌ':Added, #1: 1	شَهَادَةِ الْقَذْفِ
u'شَهَادَةٌ قذفة':Added, #1: 1	شَهَادَةِ الْقَذْفِ
u'شَهَادَةٌ قَرَوِيٌّ':Added, #1: 1	شَهَادَةِ الْقَذَفَةِ
u'شَهَادَةٌ قلب':Added, #1: 1	شَهَادَةُ الْقَرَوِيِّ
u'شَهَادَةٌ قلب':Added, #1: 1	شَهَادَةُ الْقَلْبِ
u'شَهَادَةٌ قَلْبٌ':Added, #1: 1	شَهَادَةِ الْقَلْبِ
u'شَهَادَةٌ قَلْبٌ':Added, #1: 1	شَهَادَةُ الْقَلْبِ
u'شَهَادَةٌ قَلْب':Added, #1: 1	شَهَادَةِ الْقَلْبِ
u'شَهَادَةٌ قَلْب':Added, #1: 1	شَهَادَةُ الْقَلْبِ
u'شَهَادَةٌ قَوْمٌ':Added, #1: 1	شَهَادَةِ الْقَلْبِ
u'شَهَادَةٌ قَوْمٌ':Added, #2: 2	شَهَادَةُ الْقَوْمِ
u'شَهَادَةٌ قِيمَةٌ':Added, #3: 3	شَهَادَةِ قَوْمٍ
u'شَهَادَةٌ كَاتِبٌ':Added, #1: 1	شَهَادَةَ قِيمَةٍ
u'شَهَادَةٌ كَافِرٌ':Added, #1: 1	شَهَادَةُ كَاتِبِهِ
u'شَهَادَةٌ كَافِرٌ':Added, #1: 1	شَهَادَةُ الْكَافِرَةِ
u'شَهَادَةٌ كَافِرٌ':Added, #1: 1	شَهَادَةُ الْكَافِرَيْنِ
u'شَهَادَةٌ كَافِرٌ':Added, #1: 1	شَهَادَةُ كَافِرَيْنِ
u'شَهَادَةٌ كَافِرٌ':Added, #2: 2	شَهَادَةُ كَافِرٍ
u'شَهَادَةٌ كَافِرٌ':Added, #3: 3	شَهَادَةِ الْكَافِرِ
u'شَهَادَةٌ كَافِرٌ':Added, #3: 3	شَهَادَةِ كَافِرٍ
u'شَهَادَةٌ كَافِرٌ':Added, #4: 4	شَهَادَةَ الْكَافِرِ
u'شَهَادَةٌ كِتَابٌ':Added, #6: 6	شَهَادَةُ الْكَافِرِ
u'شَهَادَةٌ كُفَّارٌ':Added, #1: 1	شَهَادَةُ الْكِتَابِ
u'شَهَادَةٌ كُفَّارٌ':Added, #1: 1	شَهَادَةَ الْكُفَّارِ
u'شَهَادَةٌ كُفَّارٌ':Added, #1: 1	شَهَادَةِ الْكُفَّارِ
u'شَهَادَةٌ لاَعِبٌ':Added, #2: 2	شَهَادَةُ الْكُفَّارِ
u'شَهَادَةٌ لِسَانٌ':Added, #1: 1	شَهَادَةُ اللَّاعِبِ
u'شَهَادَةٌ مُبْتَدِعٌ':Added, #1: 1	شَهَادَةُ اللِّسَانِ
u'شَهَادَةٌ مُتَّهَمٌ':Added, #2: 2	شَهَادَةُ الْمُبْتَدِعِ
u'شَهَادَةٌ مُتَّهَمٌ':Added, #1: 1	شَهَادَةَ الْمُتَّهَمِ
u'شَهَادَةٌ مُتَّهَمٌ':Added, #1: 1	شَهَادَةِ الْمُتَّهَمِ
u'شَهَادَةٌ مُتَّهَمٌ':Added, #1: 1	شَهَادَةُ مُتَّهَمٍ
u'شَهَادَةٌ مُجَرَّبٌ':Added, #3: 3	شَهَادَةُ الْمُتَّهَمِ
u'شَهَادَةٌ مَحَارِمُ':Added, #2: 2	شَهَادَةُ مُجَرَّبٍ
u'شَهَادَةٌ مَحْدُودٌ':Added, #1: 1	شَهَادَةُ الْمَحَارِمِ
u'شَهَادَةٌ مَحْدُودٌ':Added, #1: 1	شَهَادَةُ مَحْدُودٍ
u'شَهَادَةٌ مَحْدُودٌ':Added, #3: 3	شَهَادَةَ الْمَحْدُودِ
u'شَهَادَةٌ مَحْدُودٌ':Added, #5: 5	شَهَادَةِ الْمَحْدُودِ
u'شَهَادَةٌ مُخْتَبِئٌ':Added, #8: 8	شَهَادَةُ الْمَحْدُودِ
u'شَهَادَةٌ مُخْتَبِئٌ':Added, #1: 1	شَهَادَةَ الْمُخْتَبِئِ
u'شَهَادَةٌ مُخْتَبِئٌ':Added, #1: 1	شَهَادَةِ الْمُخْتَبِئِ
u'شَهَادَةٌ مُخَنَّث':Added, #1: 1	شَهَادَةَ مُخْتَبِئٍ
u'شَهَادَةٌ مُخَنَّث':Added, #2: 2	شَهَادَةُ الْمُخَنَّثِ
u'شَهَادَةٌ مُدَاوِمٌ':Added, #2: 2	شَهَادَةُ مُخَنَّثٍ
u'شَهَادَةٌ مُدْمِنٌ':Added, #2: 2	شَهَادَةُ الْمُدَاوِمِ
u'شَهَادَةٌ مَدْيُونٌ':Added, #3: 3	شَهَادَةُ مُدْمِنِ
u'شَهَادَةٌ مُرَاهِقٌ':Added, #1: 1	شَهَادَةُ الْمَدْيُونِ
u'شَهَادَةٌ مُرْتَدٌّ':Added, #1: 1	شَهَادَةُ الْمُرَاهِقِ
u'شَهَادَةٌ مُرْتَدٌّ':Added, #1: 1	شَهَادَةِ مُرْتَدٍّ
u'شَهَادَةٌ مُرْتَهِنٌ':Added, #2: 2	شَهَادَةُ الْمُرْتَدِّ
u'شَهَادَةٌ مُرْضِعٌ':Added, #1: 1	شَهَادَةُ الْمُرْتَهِنِ
u'شَهَادَةٌ مُرُورٌ':Added, #1: 1	شَهَادَةُ الْمُرْضِعَةِ
u'شَهَادَةٌ مُزَارِعٌ':Added, #1: 1	شَهَادَةُ الْمُرُورِ
u'شَهَادَةٌ مُسْتَأْجِرٌ':Added, #2: 2	شَهَادَةُ الْمُزَارِعِ
u'شَهَادَةٌ مُسْتَحِقٌّ':Added, #3: 3	شَهَادَةُ الْمُسْتَأْجِرِ
u'شَهَادَةٌ مُسَخَّرٌ':Added, #1: 1	شَهَادَةُ الْمُسْتَحِقِّ
u'شَهَادَةٌ مُسْلِمٌ':Added, #1: 1	شَهَادَةَ مُسَخَّرَةِ
u'شَهَادَةٌ مُسْلِمٌ':Added, #1: 1	شَهَادَةَ الْمُسْلِمِ
u'شَهَادَةٌ مُسْلِمٌ':Added, #1: 1	شَهَادَةِ الْمُسْلِمِ
u'شَهَادَةٌ مُسْلِمٌ':Added, #1: 1	شَهَادَةَ الْمُسْلِمَيْنِ
u'شَهَادَةٌ مُسْلِمٌ':Added, #1: 1	شَهَادَةُ الْمُسْلِمَيْنِ
u'شَهَادَةٌ مُسْلِمٌ':Added, #1: 1	شَهَادَةُ مُسْلِمٍ
u'شَهَادَةٌ مُسْلِمٌ':Added, #2: 2	شَهَادَةُ الْمُسْلِمِ
u'شَهَادَةٌ مُصَدِّقٌ':Added, #5: 5	شَهَادَةِ مُسْلِمَيْنِ
u'شَهَادَةٌ مُضَارِبٌ':Added, #4: 4	شَهَادَةُ الْمُصَدِّقِ
u'شَهَادَةٌ مُطَّلِعٌ':Added, #1: 1	شَهَادَةُ الْمُضَارِبِ
u'شَهَادَةٌ مُعْتَزِلٌ':Added, #1: 1	شَهَادَةُ مُطَّلِعٍ
u'شَهَادَةٌ مُعْتَزِلَةٌ':Added, #2: 2	شَهَادَةُ الْمُعْتَزِلَةِ
u'شَهَادَةٌ مُعْتَقٌ':Added, #2: 2	شَهَادَةُ الْمُعْتَزِلَةِ
u'شَهَادَةٌ مَعْتُوهٌ':Added, #1: 1	شَهَادَةُ الْمُعْتَقِ
u'شَهَادَةٌ مَعْرُوفٌ':Added, #1: 1	شَهَادَةُ مَعْتُوهٍ
u'شَهَادَةٌ مَعْزُولٌ':Added, #1: 1	شَهَادَةُ الْمَعْرُوفِ
u'شَهَادَةٌ مُعَلِّمٌ':Added, #1: 1	شَهَادَةُ الْمَعْزُولِ
u'شَهَادَةٌ مُعْلِنٌ':Added, #1: 1	شَهَادَةُ مُعَلِّمِ
u'شَهَادَةٌ مُعَيَّنٌ':Added, #1: 1	شَهَادَةِ الْمُعْلِنِ
u'شَهَادَةٌ مُغَفَّلٌ':Added, #3: 3	شَهَادَةٍ مُعَيَّنَةٍ
u'شَهَادَةٌ مُغَفَّلٌ':Added, #1: 1	شَهَادَةَ الْمُغَفَّلِ
u'شَهَادَةٌ مُغَفَّلٌ':Added, #1: 1	شَهَادَةُ مُغَفَّلٍ
u'شَهَادَةٌ مُغَنِّي':Added, #2: 2	شَهَادَةُ الْمُغَفَّلِ
u'شَهَادَةٌ مُقَامِرٌ':Added, #1: 1	شَهَادَةُ مُغَنِّيَةٍ
u'شَهَادَةٌ مَقْطُوعٌ':Added, #1: 1	شَهَادَةُ الْمُقَامِرِ
u'شَهَادَةٌ مَقْطُوعٌ':Added, #1: 1	شَهَادَةِ الْمَقْطُوعِ
u'شَهَادَةٌ مُلاَزَمَةٌ':Added, #1: 1	شَهَادَةِ مَقْطُوعٍ
u'شَهَادَةٌ مِلَّةٌ':Added, #1: 1	شَهَادَةٍ مُلَازَمَةٍ
u'شَهَادَةٌ مُلْتَقِط':Added, #3: 3	شَهَادَةُ مِلَّةٍ
u'شَهَادَةٌ مَمْلُوكٌ':Added, #1: 1	شَهَادَةُ مُلْتَقِطِ
u'شَهَادَةٌ مَمْلُوكٌ':Added, #1: 1	شَهَادَةُ مَمْلُوكٍ
u'شَهَادَةٌ مُودِعٌ':Added, #2: 2	شَهَادَةُ الْمَمْلُوكِ
u'شَهَادَةٌ مَوْلًى':Added, #2: 2	شَهَادَةُ الْمُودِعِ
u'شَهَادَةٌ نَاظِرٌ':Added, #1: 1	شَهَادَةُ الْمَوْلَيَيْنِ
u'شَهَادَةٌ نَائِحٌ':Added, #1: 1	شَهَادَةِ النَّاظِرِ
u'شَهَادَةٌ نَخَّاسٌ':Added, #2: 2	شَهَادَةُ النَّائِحَةِ
u'شَهَادَةٌ نِساءٌ':Added, #2: 2	شَهَادَةُ النَّخَّاسِ
u'شَهَادَةٌ نِساءٌ':Added, #14: 14	شَهَادَةَ النِّسَاءِ
u'شَهَادَةٌ نِساءٌ':Added, #18: 18	شَهَادَةِ النِّسَاءِ
u'شَهَادَةٌ نِسْوَةٌ':Added, #84: 84	شَهَادَةُ النِّسَاءِ
u'شَهَادَةٌ نِسْوَةٌ':Added, #1: 1	شَهَادَةَ النِّسْوَةِ
u'شَهَادَةٌ نِسْوَةٌ':Added, #2: 2	شَهَادَةُ النِّسْوَةِ
u'شَهَادَةٌ نصاب':Added, #3: 3	شَهَادَةِ النِّسْوَةِ
u'شَهَادَةٌ نِصَابٌ':Added, #1: 1	شَهَادَةِ النِّصَابِ
u'شَهَادَةٌ نَصْرَانِيٌّ':Added, #1: 1	شَهَادَةِ النِّصَابِ
u'شَهَادَةٌ نَفْسٌ':Added, #1: 1	شَهَادَةَ النَّصْرَانِيِّ
u'شَهَادَةٌ نَفْيٌ':Added, #12: 12	شَهَادَةِ نَفْسِهِ
u'شَهَادَةٌ نَفْيٌ':Added, #1: 1	شَهَادَةَ نَفْيٍ
u'شَهَادَةٌ نَفْيٌ':Added, #2: 2	شَهَادَةَ النَّفْيِ
u'شَهَادَةٌ نَفْيٌ':Added, #4: 4	شَهَادَةِ النَّفْيِ
u'شَهَادَةٌ نقل':Added, #6: 6	شَهَادَةُ نَفْيٍ
u'شَهَادَةٌ نَقْلٌ':Added, #1: 1	شَهَادَةِ النَّقْلِ
u'شَهَادَةٌ نكاح':Added, #1: 1	شَهَادَةِ النَّقْلِ
u'شَهَادَةٌ نِكَاحٌ':Added, #1: 1	شَهَادَةِ نِكَاحٍ
u'شَهَادَةٌ هِلاَلٌ':Added, #1: 1	شَهَادَةِ نِكَاحٍ
u'شَهَادَةٌ واحد':Added, #1: 1	شَهَادَةِ الْهِلَالِ
u'شَهَادَةٌ وَاحِدٌ':Added, #12: 12	شَهَادَةِ وَاحِدٍ
u'شَهَادَةٌ واحد':Added, #12: 12	شَهَادَةِ وَاحِدٍ
u'شَهَادَةٌ وَاحِدٌ':Added, #14: 14	شَهَادَةُ وَاحِدٍ
u'شَهَادَةٌ واحد':Added, #14: 14	شَهَادَةُ وَاحِدٍ
u'شَهَادَةٌ وَاحِدٌ':Added, #16: 16	شَهَادَةُ الْوَاحِدِ
u'شَهَادَةٌ واحد':Added, #16: 16	شَهَادَةُ الْوَاحِدِ
u'شَهَادَةٌ وَاحِدٌ':Added, #17: 17	شَهَادَةَ الْوَاحِدِ
u'شَهَادَةٌ واحد':Added, #17: 17	شَهَادَةَ الْوَاحِدِ
u'شَهَادَةٌ وَاحِدٌ':Added, #1: 1	شَهَادَةُ الْوَاحِدَةِ
u'شَهَادَةٌ واحد':Added, #1: 1	شَهَادَةُ الْوَاحِدَةِ
u'شَهَادَةٌ واحد':Added, #1: 1	شَهَادَةٍ وَاحِدَةٍ
u'شَهَادَةٌ وَاحِدٌ':Added, #1: 1	شَهَادَةُ وَاحِدَةٍ
u'شَهَادَةٌ وَاحِدٌ':Added, #1: 1	شَهَادَةٍ وَاحِدَةٍ
u'شَهَادَةٌ واحد':Added, #1: 1	شَهَادَةُ وَاحِدَةٍ
u'شَهَادَةٌ وَاحِدٌ':Added, #5: 5	شَهَادَةَ وَاحِدٍ
u'شَهَادَةٌ واحد':Added, #5: 5	شَهَادَةَ وَاحِدٍ
u'شَهَادَةٌ وَاحِدٌ':Added, #8: 8	شَهَادَةِ الْوَاحِدِ
u'شَهَادَةٌ وَارِثٌ':Added, #8: 8	شَهَادَةِ الْوَاحِدِ
u'شَهَادَةٌ وَارِثٌ':Added, #1: 1	شَهَادَةَ الْوَارِثِ
u'شَهَادَةٌ وَارِثٌ':Added, #1: 1	شَهَادَةِ الْوَارِثِ
u'شَهَادَةٌ وَارِثٌ':Added, #1: 1	شَهَادَةُ وَارِثٍ
u'شَهَادَةٌ وَارِثٌ':Added, #1: 1	شَهَادَةِ وَارِثٍ
u'شَهَادَةٌ وَارِثٌ':Added, #2: 2	شَهَادَةُ الْوَارِثَيْنِ
u'شَهَادَةٌ وَالِدٌ':Added, #3: 3	شَهَادَةُ الْوَارِثِ
u'شَهَادَةٌ وَالِدٌ':Added, #1: 1	شَهَادَةَ الْوَالِدِ
u'شَهَادَةٌ وَالِدٌ':Added, #2: 2	شَهَادَةِ الْوَالِدِ
u'شَهَادَةٌ وَالِدٌ':Added, #3: 3	شَهَادَةُ الْوَالِدَيْنِ
u'شَهَادَةٌ وَدِيعٌ':Added, #9: 9	شَهَادَةُ الْوَالِدِ
u'شَهَادَةٌ وَرَثَةٌ':Added, #1: 1	شَهَادَةُ الْوَدِيعِ
u'شَهَادَةٌ وَصِيٌّ':Added, #1: 1	شَهَادَةُ الْوَرَثَةِ
u'شَهَادَةٌ وَصِيٌّ':Added, #1: 1	شَهَادَةُ الْوَصِيَّيْنِ
u'شَهَادَةٌ وَصِيٌّ':Added, #1: 1	شَهَادَةِ الْوَصِيَّيْنِ
u'شَهَادَةٌ وَقْفٌ':Added, #4: 4	شَهَادَةُ الْوَصِيِّ
u'شَهَادَةٌ وكلاء':Added, #1: 1	شَهَادَةِ وَقْفٍ
u'شَهَادَةٌ وَكِيلٌ':Added, #1: 1	شَهَادَةِ وُكَلَاءِ
u'شَهَادَةٌ وَكِيلٌ':Added, #1: 1	شَهَادَةَ الْوَكِيلِ
u'شَهَادَةٌ وَكِيلٌ':Added, #1: 1	شَهَادَةِ الْوَكِيلِ
u'شَهَادَةٌ وَكِيلٌ':Added, #1: 1	شَهَادَةُ الْوَكِيلَيْنِ
u'شَهَادَةٌ وَكِيلٌ':Added, #1: 1	شَهَادَةَ وَكِيلِهِ
u'شَهَادَةٌ ولد':Added, #3: 3	شَهَادَةُ الْوَكِيلِ
u'شَهَادَةٌ وَلَدٌ':Added, #18: 18	شَهَادَةُ الْوَلَدِ
u'شَهَادَةٌ ولد':Added, #18: 18	شَهَادَةُ الْوَلَدِ
u'شَهَادَةٌ وَلَدٌ':Added, #1: 1	شَهَادَة الْوَلَدِ
u'شَهَادَةٌ ولد':Added, #1: 1	شَهَادَة الْوَلَدِ
u'شَهَادَةٌ وَلَدٌ':Added, #1: 1	شَهَادَةَ وَلَدِ
u'شَهَادَةٌ وَلَدٌ':Added, #1: 1	شَهَادَةَ وَلَدِ
u'شَهَادَةٌ ولد':Added, #1: 1	شَهَادَةُ وَلَدٍ
u'شَهَادَةٌ وَلَدٌ':Added, #1: 1	شَهَادَةَ وَلَدِهِ
u'شَهَادَةٌ ولد':Added, #1: 1	شَهَادَةَ وَلَدِهِ
u'شَهَادَةٌ وَلَدٌ':Added, #2: 2	شَهَادَةُ وَلَدِهِ
u'شَهَادَةٌ ولد':Added, #2: 2	شَهَادَةُ وَلَدِهِ
u'شَهَادَةٌ وَلَدٌ':Added, #5: 5	شَهَادَةِ وَلَدِ
u'شَهَادَةٌ ولد':Added, #5: 5	شَهَادَةِ وَلَدِ
u'شَهَادَةٌ وَلَدٌ':Added, #6: 6	شَهَادَةِ الْوَلَدِ
u'شَهَادَةٌ ولد':Added, #6: 6	شَهَادَةِ الْوَلَدِ
u'شَهَادَةٌ وَلَدٌ':Added, #6: 6	شَهَادَةُ وَلَدِ
u'شَهَادَةٌ وَلِيٌّ':Added, #6: 6	شَهَادَةُ وَلَدِ
u'شَهَادَةٌ وَلِيٌّ':Added, #1: 1	شَهَادَةَ الْوَلِيِّ
u'شَهَادَةٌ يَمِينٌ':Added, #1: 1	شَهَادَةُ وَلِيٍّ
u'شَهَادَةٌ يهود':Added, #1: 1	شَهَادَةِ الْيَمِينِ
u'شَهَادَةٌ يَهُودٌ':Added, #1: 1	شَهَادَةَ الْيَهُودِ
u'شَهَامَةٌ رِجَالٌ':Added, #1: 1	شَهَادَةَ الْيَهُودِ
u'شَهِدَ أَبٌ':Subject, #2: 2	شَهَامَةِ الرِّجَالِ
u'شَهِدَ أَبٌ':Subject, #1: 1	شَهِدَ أَبُ
u'شَهِدَ اِبْنٌ':Predicate, #4: 4	شَهِدَ الْأَبُ
u'شَهِدَ اِبْنٌ':Subject, #2: 2	شَهِدَ ابْنَ
u'شَهِدَ اِبْنٌ':Subject, #4: 4	شَهِدَ ابْنَاهُ
u'شَهِدَ أَبْنَاءٌ':Subject, #8: 8	شَهِدَ ابْنُ
u'شَهِدَ أَجِيرٌ':Subject, #1: 1	شَهِدَ أَبْنَاءُ
u'شَهِدَ أحَدٌ':Subject, #1: 1	شَهِدَ الْأَجِيرُ
u'شَهِدَ أحَدٌ':Subject, #37: 37	شَهِدَ أَحَدُ
u'شَهِدَ إِحْرَازٌ':Predicate, #4: 4	شَهِدَ أَحَدٌ
u'شَهِدَ أَرْبَعُ':Subject, #2: 2	شَهِدَ الْإِحْرَازَ
u'شَهِدَ أَرْبَعَةٌ':Subject, #4: 4	شَهِدَ أَرْبَعُ
u'شَهِدَ أَرْبَعَةٌ':Subject, #1: 1	شَهِدَ الْأَرْبَعَةُ
u'شَهِدَ أَرْبَعَةٌ':Subject, #4: 4	شَهِدَ أَرْبَعَةُ
u'شَهِدَ أُصولٌ':Subject, #96: 96	شَهِدَ أَرْبَعَةٌ
u'شَهِدَ أعْرَابِيٌّ':Subject, #3: 3	شَهِدَ الْأُصُولُ
u'شَهِدَ أَفْرَادٌ':Subject, #2: 2	شَهِدَ الْأَعْرَابِيُّ
u'شَهِدَ أقَلُّ':Subject, #1: 1	شَهِدَ أَفْرَادُ
u'شَهِدَ إمَامٌ':Subject, #1: 1	شَهِدَ أَقَلُّ
u'شَهِدَ أَمينٌ':Subject, #1: 1	شَهِدَ الْإِمَامُ
u'شَهِدَ إِنْسانٌ':Subject, #2: 2	شَهِدَ الْأَمِينُ
u'شَهِدَ أهْلٌ':Subject, #1: 1	شَهِدَ إنْسَانٌ
u'شَهِدَ أَوَّلُ':Subject, #3: 3	شَهِدَ أَهْلُ
u'شَهِدَ بَائِعٌ':Subject, #2: 2	شَهِدَ الْأَوَّلُ
u'شَهِدَ بَعْضٌ':Predicate, #2: 2	شَهِدَ الْبَائِعُ
u'شَهِدَ بَعْضٌ':Subject, #1: 1	شَهِدَ بَعْضَ
u'شَهِدَ بَعْضٌ':Subject, #2: 2	شَهِدَ الْبَعْضُ
u'شَهِدَ بَيْعَةٌ':Predicate, #7: 7	شَهِدَ بَعْضُ
u'شَهِدَ تَكْبِير':Predicate, #1: 1	شَهِدَ بَيْعَةَ
u'شَهِدَ ثَالِثٌ':Subject, #1: 1	شَهِدَ التَّكْبِيرَةَ
u'شَهِدَ ثَانِي':Predicate, #1: 1	شَهِدَ الثَّالِثُ
u'شَهِدَ ثَلاثَةٌ':Subject, #1: 1	شَهِدَ ثَانِيَةً
u'شَهِدَ ثَلاثَةٌ':Subject, #21: 21	شَهِدَ ثَلَاثَةٌ
u'شَهِدَ جسر':Predicate, #2: 2	شَهِدَ ثَلَاثَةُ
u'شَهِدَ جِسْرٌ':Predicate, #1: 1	شَهِدَ الْجِسْرَ
u'شَهِدَ جَمَاعَةٌ':Subject, #1: 1	شَهِدَ الْجِسْرَ
u'شَهِدَ جَمْعٌ':Subject, #3: 3	شَهِدَ جَمَاعَةٌ
u'شَهُدَ جمعة':Predicate, #1: 1	شَهِدَ جَمْعٌ
u'شَهِدَ جمعة':Predicate, #1: 1	أَشْهَدَ الْجُمُعَةَ
u'شَهُدَ جُمُعَةٌ':Predicate, #1: 1	أَشْهَدَ الْجُمُعَةَ
u'شَهِدَ جُمُعَةٌ':Predicate, #1: 1	أَشْهَدَ الْجُمُعَةَ
u'شَهِدَ جمعة':Predicate, #1: 1	أَشْهَدَ الْجُمُعَةَ
u'شَهِدَ جُمُعَةٌ':Predicate, #4: 4	شَهِدَ الْجُمُعَةَ
u'شَهِدَ جَنَازَةٌ':Predicate, #4: 4	شَهِدَ الْجُمُعَةَ
u'شَهِدَ جَنَازَةٌ':Predicate, #1: 1	شَهِدَ الْجَنَازَةَ
u'شَهِدَ حالٌ':Predicate, #1: 1	شَهِدَ جَنَازَةَ
u'شَهِدَ حَرْبٌ':Predicate, #1: 1	شَهِدَ الْحَالَ
u'شَهِدَ حَقٌّ':Predicate, #2: 2	شَهِدَ الْحَرْبَ
u'شَهِدَ حَقٌّ':Subject, #1: 1	شَهِدَ الْحَقَّ
u'شَهِدَ حَكَمٌ':Subject, #1: 1	شَهِدَ الْحَقُّ
u'شَهِدَ حِلْفٌ':Predicate, #1: 1	شَهِدَ الْحَكَمُ
u'شَهِدَ خطبة':Predicate, #1: 1	شَهِدَ حِلْفَ
u'شَهِدَ خُطْبَةٌ':Predicate, #19: 19	شَهِدَ الْخُطْبَةَ
u'شَهِدَ خطبة':Predicate, #19: 19	شَهِدَ الْخُطْبَةَ
u'شَهِدَ خُطْبَةٌ':Predicate, #4: 4	شَهِدَ خُطْبَةَ
u'شَهِدَ خَلِيفَةٌ':Subject, #4: 4	شَهِدَ خُطْبَةَ
u'شَهِدَ خَمْسَةٌ':Subject, #1: 1	شَهِدَ الْخَلِيفَةُ
u'شَهِدَ دفن':Predicate, #1: 1	شَهِدَ خَمْسَةٌ
u'شَهِدَ دَفْنٌ':Predicate, #5: 5	شَهِدَ دَفْنَ
u'شَهِدَ دونٌ':Predicate, #5: 5	شَهِدَ دَفْنَ
u'شَهِدَ رِجَالٌ':Subject, #3: 3	شَهِدَ دُونَ
u'شَهِدَ رِجَالٌ':Subject, #1: 1	شَهِدَ الرِّجَالُ
u'شَهِدَ رَجُلٌ':Subject, #1: 1	شَهِدَ رِجَالٌ
u'شَهِدَ رَجُلٌ':Subject, #11: 11	شَهِدَ الرَّجُلُ
u'شَهِدَ رَسُولٌ':Predicate, #55: 55	شَهِدَ رَجُلٌ
u'شَهِدَ رَسُولٌ':Subject, #6: 6	شَهِدَ رَسُولَ
u'شَهِدَ رَسُولٌ':Subject, #1: 1	شَهِدَ الرّسُولُ
u'شَهِدَ رَسُولٌ':Subject, #1: 1	شَهِدَ الرَّسُولُ
u'شَهِدَ زَوْجٌ':Subject, #3: 3	شَهِدَ رَسُولُ
u'شَهِدَ سَاحِرٌ':Subject, #5: 5	شَهِدَ الزَّوْجُ
u'شَهِدَ سِتٌّ':Subject, #1: 1	شَهِدَ سَاحِرٌ
u'شَهُدَ سقط':Predicate, #3: 3	شَهِدَ سِتَّةٌ
u'شَهِدَ سقط':Predicate, #1: 1	أَشْهَدَ سَقَطَ
u'شَهُدَ سَقَطٌ':Predicate, #1: 1	أَشْهَدَ سَقَطَ
u'شَهِدَ سَقَطٌ':Predicate, #1: 1	أَشْهَدَ سَقَطَ
u'شَهِدَ سُهَيْلٌ':Subject, #1: 1	أَشْهَدَ سَقَطَ
u'شَهِدَ شَاهِدٌ':Subject, #1: 1	شَهِدَ سُهَيْلٌ
u'شَهِدَ شَاهِدٌ':Subject, #39: 39	شَهِدَ شَاهِدٌ
u'شَهِدَ شرب':Predicate, #8: 8	شَهِدَ الشَّاهِدُ
u'شَهِدَ شُرْبٌ':Predicate, #2: 2	شَهِدَ شُرْبَ
u'شَهِدَ شَرْعٌ':Subject, #2: 2	شَهِدَ شُرْبَ
u'شَهِدَ شَفِيعٌ':Subject, #4: 4	شَهِدَ الشَّرْعُ
u'شَهِدَ شَهَادَةٌ':Predicate, #2: 2	شَهِدَ الشَّفِيعُ
u'شَهِدَ شَهْرٌ':Predicate, #1: 1	شَهِدَ شَهَادَةَ
u'شَهِدَ شُهُودٌ':Subject, #1: 1	شَهِدَ الشَّهْرَ
u'شَهِدَ شُهُودٌ':Subject, #121: 121	شَهِدَ الشُّهُودُ
u'شَهِدَ شُهُودٌ':Subject, #28: 28	شَهِدَ شُهُودُ
u'شَهِدَ شُهُودٌ':Subject, #6: 6	شَهِدَ شُهُودُهُ
u'شَهِدَ صَبِيٌّ':Subject, #7: 7	شَهِدَ شُهُودٌ
u'شَهِدَ صَبِيٌّ':Subject, #1: 1	شَهِدَ الصَّبِيُّ
u'شَهِدَ صَلاَةٌ':Predicate, #1: 1	شَهِدَ صَبِيٌّ
u'شَهِدَ صَلاَةٌ':Predicate, #1: 1	شَهِدَ الصَّلاَةَ
u'شَهِدَ صَلاَةٌ':Predicate, #1: 1	شَهِدَ صَلاَةَ
u'شَهِدَ عَامِّيٌّ':Subject, #3: 3	شَهِدَ الصَّلَاةَ
u'شَهِدَ عَبَّاسٌ':Subject, #1: 1	شَهِدَ عَامِّيٌّ
u'شَهِدَ عَبْدٌ':Predicate, #1: 1	شَهِدَ الْعَبَّاسُ
u'شَهِدَ عَبْدٌ':Subject, #3: 3	شَهِدَ عَبْدَ
u'شَهِدَ عَبْدٌ':Subject, #1: 1	شَهِدَ عَبْدٌ
u'شَهِدَ عَبْدٌ':Subject, #3: 3	شَهِدَ عَبْدُ
u'شَهِدَ عَتِيقٌ':Subject, #4: 4	شَهِدَ الْعَبْدُ
u'شَهِدَ عَدَدٌ':Subject, #1: 1	شَهِدَ عَتِيقُ
u'شَهِدَ عَدْلٌ':Subject, #2: 2	شَهِدَ عَدَدٌ
u'شَهِدَ عَدْلٌ':Subject, #3: 3	شَهِدَ الْعَدْلُ
u'شَهِدَ عُدُولٌ':Subject, #7: 7	شَهِدَ عَدْلٌ
u'شَهِدَ عرف':Subject, #1: 1	شَهِدَ الْعُدُولُ
u'شَهِدَ عُرْفٌ':Subject, #1: 1	شَهِدَ الْعُرْفُ
u'شَهِدَ عزل':Predicate, #1: 1	شَهِدَ الْعُرْفُ
u'شَهِدَ عقبة':Predicate, #1: 1	شَهِدَ عَزْلَ
u'شَهِدَ عَقَبَةٌ':Predicate, #9: 9	شَهِدَ الْعَقَبَةَ
u'شَهِدَ عُمَرٌ':Predicate, #9: 9	شَهِدَ الْعَقَبَةَ
u'شَهِدَ عُمَرٌ':Subject, #1: 1	شَهِدَ عُمَرَ
u'شَهُدَ عند':Predicate, #1: 1	شَهِدَ عُمَرُ
u'شَهِدَ عند':Predicate, #12: 12	أَشْهَدَ عِنْدَ
u'شَهِدَ عند':Predicate, #12: 12	أَشْهَدَ عِنْدَ
u'شَهِدَ عِيدٌ':Predicate, #42: 42	شَهِدَ عِنْدَ
u'شَهِدَ غرماء':Subject, #4: 4	شَهِدَ الْعِيدَ
u'شَهِدَ غير':Subject, #1: 1	شَهِدَ غُرَمَاءُ
u'شَهِدَ غَيْرٌ':Subject, #1: 1	شَهِدَ غَيْرُ
u'شَهِدَ غير':Subject, #1: 1	شَهِدَ غَيْرُ
u'شَهِدَ غَيْرٌ':Subject, #1: 1	شَهِدَ غَيْرُهُ
u'شَهِدَ فَاسِقٌ':Subject, #1: 1	شَهِدَ غَيْرُهُ
u'شَهِدَ فَاسِقٌ':Subject, #2: 2	شَهِدَ الْفَاسِقُ
u'شَهِدَ فَتْحٌ':Predicate, #3: 3	شَهِدَ فَاسِقٌ
u'شَهِدَ فِدَاءٌ':Predicate, #4: 4	شَهِدَ فَتْحَ
u'شَهِدَ فَرْعٌ':Subject, #1: 1	شَهِدَ الْفِدَاءَ
u'شَهِدَ فُرُوعٌ':Subject, #2: 2	شَهِدَ الْفَرْعُ
u'شَهِدَ فَرِيقٌ':Subject, #4: 4	شَهِدَ الْفُرُوعُ
u'شَهِدَ فُسَّاقٌ':Subject, #4: 4	شَهِدَ الْفَرِيقُ
u'شَهِدَ فلان':Predicate, #2: 2	شَهِدَ فُسَّاقٌ
u'شَهِدَ فلان':Predicate, #1: 1	شَهِدَ الْقَادِسِيَّةَ
u'شَهِدَ فلان':Subject, #2: 2	شَهِدَ خَيْبَرَ
u'شَهِدَ فلان':Subject, #1: 1	شَهِدَ التِّرْمِذِيُّ
u'شَهِدَ فُلاَنٌ':Subject, #1: 1	شَهِدَ عُثْمَانُ
u'شَهِدَ قادِس':Predicate, #7: 7	شَهِدَ فُلَانٌ
u'شَهِدَ قَاذِفٌ':Subject, #1: 1	شَهِدَ الْقَادِسِيَّةَ
u'شَهِدَ قَاسِمٌ':Subject, #1: 1	شَهِدَ الْقَاذِفُ
u'شَهِدَ قَاسِمٌ':Subject, #2: 2	شَهِدَ قَاسِمُ
u'شَهُدَ قَالٌ':Predicate, #4: 4	شَهِدَ قَاسِمٌ
u'شَهِدَ قَالٌ':Predicate, #3: 3	أَشْهَدَ قَالَ
u'شَهِدَ قتال':Predicate, #3: 3	أَشْهَدَ قَالَ
u'شَهِدَ قِتَالٌ':Predicate, #10: 10	شَهِدَ الْقِتَالَ
u'شَهِدَ قِرَاءةٌ':Predicate, #10: 10	شَهِدَ الْقِتَالَ
u'شَهِدَ قَرَابَةٌ':Subject, #1: 1	شَهِدَ قِرَاءَةَ
u'شَهِدَ قِصَّةٌ':Predicate, #1: 1	شَهِدَ الْقَرَابَةُ
u'شَهِدَ قَضَاءٌ':Predicate, #1: 1	شَهِدَ الْقِصَّةَ
u'شَهِدَ قلب':Subject, #3: 3	شَهِدَ قَضَاءَ
u'شَهِدَ قَلْبٌ':Subject, #1: 1	شَهِدَ قَلْبُهُ
u'شَهِدَ قَلْب':Subject, #1: 1	شَهِدَ قَلْبُهُ
u'شَهِدَ قَوَابِلُ':Subject, #1: 1	شَهِدَ قَلْبُهُ
u'شَهِدَ قَوْمٌ':Subject, #2: 2	شَهِدَ الْقَوَابِلُ
u'شَهِدَ كَافِرٌ':Subject, #9: 9	شَهِدَ قَوْمٌ
u'شَهِدَ كِتَابٌ':Predicate, #1: 1	شَهِدَ كَافِرٌ
u'شَهِدَ مثل':Predicate, #1: 1	شَهِدَ كِتَابَ
u'شَهِدَ مِثْلٌ':Predicate, #1: 1	شَهِدَ مِثْلَ
u'شَهِدَ مَجْلِسٌ':Predicate, #1: 1	شَهِدَ مِثْلَ
u'شَهِدَ مَدْيُونٌ':Subject, #1: 1	شَهِدَ الْمَجْلِسَ
u'شَهِدَ مرٌّ':Predicate, #1: 1	شَهِدَ الْمَدْيُونُ
u'شَهِدَ مَشَاهِدُ':Predicate, #1: 1	شَهِدَ مَرَّةً
u'شَهِدَ مَشْهُودٌ':Subject, #1: 1	شَهِدَ الْمَشَاهِدَ
u'شَهِدَ مَغَازِي':Predicate, #2: 2	شَهِدَ الْمَشْهُودُ
u'شَهِدَ مَقْضِيّ':Subject, #1: 1	شَهِدَ الْمَغَازِيَ
u'شَهُدَ مَكْفُولٌ':Predicate, #1: 1	شَهِدَ الْمَقْضِيُّ
u'شَهِدَ مَكْفُولٌ':Predicate, #1: 1	أَشْهَدَ الْمَكْفُولَ
u'شَهِدَ مَلِكٌ':Predicate, #1: 1	أَشْهَدَ الْمَكْفُولَ
u'شَهِدَ مَنَاسِكُ':Predicate, #2: 2	شَهِدَ الْمَلِكَ
u'شَهِدَ مَنْحَر':Predicate, #2: 2	شَهِدَ الْمَنَاسِكَ
u'شَهِدَ مَهْرٌ':Subject, #1: 1	شَهِدَ الْمَنْحَرَ
u'شَهِدَ مُودِعٌ':Subject, #2: 2	شَهِدَ مَهْرُ
u'شَهِدَ مَوْضُوعٌ':Subject, #2: 2	شَهِدَ الْمُودِعُ
u'شَهِدَ نَاسٌ':Predicate, #1: 1	شَهِدَ مَوْضُوعٌ
u'شَهِدَ نَبِيٌّ':Predicate, #1: 1	شَهِدَ النَّاسَ
u'شَهِدَ نَبِيٌّ':Subject, #4: 4	شَهِدَ النَّبِيَّ
u'شَهِدَ نِساءٌ':Subject, #1: 1	شَهِدَ النَّبِيُّ
u'شَهِدَ نصاب':Subject, #4: 4	شَهِدَ النِّسَاءُ
u'شَهِدَ نِصَابٌ':Subject, #1: 1	شَهِدَ النِّصَابُ
u'شَهِدَ نَصْرَانِيٌّ':Subject, #1: 1	شَهِدَ النِّصَابُ
u'شَهِدَ نكاح':Predicate, #1: 1	شَهِدَ النَّصْرَانِيُّ
u'شَهِدَ نِكَاحٌ':Predicate, #1: 1	شَهِدَ النِّكَاحَ
u'شَهِدَ واحد':Subject, #1: 1	شَهِدَ النِّكَاحَ
u'شَهِدَ وَاحِدٌ':Subject, #1: 1	شَهِدَ الْوَاحِدُ
u'شَهِدَ واحد':Subject, #1: 1	شَهِدَ الْوَاحِدُ
u'شَهِدَ وَاحِدٌ':Subject, #48: 48	شَهِدَ وَاحِدٌ
u'شَهِدَ وَارِثٌ':Subject, #48: 48	شَهِدَ وَاحِدٌ
u'شَهِدَ وَاقِعٌ':Predicate, #1: 1	شَهِدَ الْوَارِثُ
u'شَهِدَ وَاقِعٌ':Subject, #4: 4	شَهِدَ الْوَاقِعَةَ
u'شَهِدَ وَاقِعَةٌ':Predicate, #1: 1	شَهِدَ الْوَاقِعُ
u'شَهِدَ وَالِدٌ':Subject, #4: 4	شَهِدَ الْوَاقِعَةَ
u'شَهُدَ وَتَرٌ':Predicate, #3: 3	شَهِدَ الْوَالِدُ
u'شَهِدَ وَتَرٌ':Predicate, #1: 1	أَشْهَدَ وَتَرَكَ
u'شَهِدَ وَصِيٌّ':Subject, #1: 1	أَشْهَدَ وَتَرَكَ
u'شَهِدَ وَقْتٌ':Predicate, #2: 2	شَهِدَ الْوَصِيُّ
u'شَهُدَ وَقْتٌ':Predicate, #1: 1	شَهِدَ وَقْتَ
u'شَهِدَ وَقْتٌ':Predicate, #8: 8	أَشْهَدَ وَقْتَ
u'شَهِدَ وقعة':Predicate, #8: 8	أَشْهَدَ وَقْتَ
u'شَهِدَ وَقْعَةٌ':Predicate, #35: 35	شَهِدَ الْوَقْعَةَ
u'شَهِدَ وقعة':Subject, #35: 35	شَهِدَ الْوَقْعَةَ
u'شَهِدَ وَقْعَةٌ':Subject, #1: 1	شَهِدَ الْوَقْعَةُ
u'شَهِدَ يَمَامٌ':Predicate, #1: 1	شَهِدَ الْوَقْعَةُ
u'شَهِدَ يَوْمٌ':Predicate, #1: 1	شَهِدَ الْيَمَامَةَ
u'شَهَرَ أَبٌ':Subject, #2: 2	شَهِدَ يَوْمَ
u'شَهَرَ اِبْنٌ':Subject, #2: 2	شَهَرَ الْأَبُ
u'شَهْرٌ اللهُ':Added, #1: 1	شَهَرَ ابْنُ
u'شَهْرٌ أَمْرٌ':Added, #1: 1	شَهْرُ اللهِ
u'شَهْرٌ بِيدٌ':Added, #1: 1	شَهْرُ الْأَمْرِ
u'شَهْرٌ تَمْييزٌ':Added, #1: 1	شَهْر بِيَدِ
u'شَهْرٌ ثِيابٌ':Added, #1: 1	شَهْرِ التَّمْيِيزِ
u'شَهْرٌ حَجٌّ':Added, #1: 1	شَهْرِ الثِّيَابِ
u'شَهْرٌ حِجَّةٌ':Added, #1: 1	شَهْرِ الْحَجِّ
u'شَهْرٌ حِجَّةٌ':Added, #1: 1	شَهْرُ الْحِجَّةِ
u'شَهْرٌ حَرامٌ':Added, #1: 1	شَهْرِ الْحِجَّةِ
u'شَهْرٌ حَرامٌ':Added, #10: 10	شَهْرٍ حَرَامٍ
u'شَهْرٌ حَرْثٌ':Added, #1: 1	شَهْرِ الْحَرَامِ
u'شَهْرٌ حَلالٌ':Added, #1: 1	شَهْرُ الْحَرْثِ
u'شَهْرٌ حَيْضٌ':Added, #1: 1	شَهْرٍ حَلَالٍ
u'شَهَرَ خِلاَفٌ':Predicate, #1: 1	شَهْرِ الْحَيْضِ
u'شَهْرٌ رَبِيعٌ':Added, #1: 1	شَهَرَ خِلَافَ
u'شَهْرٌ رَبِيعٌ':Added, #1: 1	شَهْرِ رَبِيعِ
u'شَهْرٌ رَبِيعٌ':Added, #25: 25	شَهْرِ رَبِيعٍ
u'شَهْرٌ رَبِيعٌ':Added, #3: 3	شَهْرُ رَبِيعٍ
u'شَهْرٌ رَجَبٌ':Added, #8: 8	شَهْرَ رَبِيعٍ
u'شَهْرٌ رَجَبٌ':Added, #2: 2	شَهْرُ رَجَبٍ
u'شَهَرَ رَجُلٌ':Subject, #3: 3	شَهْرِ رَجَبٍ
u'شَهْرٌ رَمَضانُ':Added, #1: 1	شَهَرَ رَجُلٌ
u'شَهْرٌ زَكاةٌ':Added, #1: 1	شَهْرِ رَمَضَانِ
u'شَهْرٌ سادس':Added, #2: 2	شَهْرُ زَكَاتِهِ
u'شَهْرٌ سَادِسٌ':Added, #1: 1	شَهْرٍ سَادِسٍ
u'شَهْرٌ سَبْعَةٌ':Added, #1: 1	شَهْرٍ سَادِسٍ
u'شَهْرٌ سِتٌّ':Added, #1: 1	شَهْرِ السَّبْعَةِ
u'شَهَرَ سِلاَحٌ':Predicate, #1: 1	شَهْرِ السِّتَّةِ
u'شَهْرٌ سِلاَحٌ':Added, #1: 1	شَهَرَ السِّلَاحَ
u'شَهْرٌ سِلاَحٌ':Added, #1: 1	شَهْرَ السِّلَاحِ
u'شَهْرٌ سَنَةٌ':Added, #6: 6	شَهْرِ السِّلَاحِ
u'شَهْرٌ شَوَّالٌ':Added, #1: 1	شَهْرِ سَنَةٍ
u'شَهْرٌ شَوَّالٌ':Added, #1: 1	شَهْرَ شَوّالٍ
u'شَهْرٌ صبر':Added, #2: 2	شَهْرِ شَوَّالٍ
u'شَهْرٌ صَبْرٌ':Added, #1: 1	شَهْرُ الصَّبْرِ
u'شَهْرٌ صبر':Added, #1: 1	شَهْرُ الصَّبْرِ
u'شَهْرٌ صَبْرٌ':Added, #2: 2	شَهْرِ الصَّبْرِ
u'شَهْرٌ صبر':Added, #2: 2	شَهْرِ الصَّبْرِ
u'شَهْرٌ صَبْرٌ':Added, #5: 5	شَهْرَ الصَّبْرِ
u'شَهْرٌ صفر':Added, #5: 5	شَهْرَ الصَّبْرِ
u'شَهْرٌ صَفَرٌ':Added, #1: 1	شَهْرَ صَفَرٍ
u'شَهْرٌ صَوْمٌ':Added, #1: 1	شَهْرَ صَفَرٍ
u'شَهَرَ فَاكِهَانِيٌّ':Subject, #1: 1	شَهْرِ الصَّوْمِ
u'شَهْرٌ فلان':Added, #1: 1	شَهَرَ الْفَاكِهَانِيُّ
u'شَهْرٌ قَضَاءٌ':Added, #1: 1	شَهْر بِيَرُونِ
u'شَهْرٌ كَامِلٌ':Added, #1: 1	شَهْرُ الْقَضَاءِ
u'شَهْرٌ لِبَاسٌ':Added, #2: 2	شَهْرٍ كَامِلٍ
u'شَهْرٌ مُتَتَابِعٌ':Added, #1: 1	شَهْرِ اللِّبَاسِ
u'شَهْرٌ مُتَّصِلٌ':Added, #5: 5	شَهْرٍ مُتَتَابِعٍ
u'شَهْرٌ مُتَفَرِّقٌ':Added, #1: 1	شَهْرٍ مُتَّصِلٍ
u'شَهَرَ مَجْنُونٌ':Subject, #1: 1	شَهْرٍ مُتَفَرِّقٍ
u'شَهْرٌ مُحَرَّمٌ':Added, #4: 4	شَهَرَ الْمَجْنُونُ
u'شَهْرٌ مُحَرَّمٌ':Added, #1: 1	شَهْرَ الْمُحَرّمِ
u'شَهْرٌ مُحَرَّمٌ':Added, #1: 1	شَهْرَ الْمُحَرَّمِ
u'شَهْرٌ مُحْرِمٌ':Added, #1: 1	شَهْرُ الْمُحَرّمِ
u'شَهْرٌ مُحَرَّمٌ':Added, #1: 1	شَهْرَ الْمُحْرِمِ
u'شَهْرٌ مُحَرَّمٌ':Added, #1: 1	شَهْرُ مُحَرَّمٍ
u'شَهْرٌ مُطْلَقٌ':Added, #2: 2	شَهْرِ الْمُحَرّمِ
u'شَهْرٌ مَعْلُومٌ':Added, #6: 6	شَهْرٍ مُطْلَقٍ
u'شَهْرٌ مُعَيَّنٌ':Added, #1: 1	شَهْرٍ مَعْلُومٍ
u'شَهْرٌ مَوْصُوفٌ':Added, #11: 11	شَهْرٍ مُعَيَّنٍ
u'شَهْرٌ نَبِيٌّ':Added, #1: 1	شَهْرٍ مَوْصُوفٍ
u'شَهْرٌ نَذْرٌ':Added, #2: 2	شَهْرَ النَّبِيِّ
u'شَهْرٌ واحد':Added, #1: 1	شَهْرِ نَذْرٍ
u'شَهْرٌ وَاحِدٌ':Added, #20: 20	شَهْرٍ وَاحِدٍ
u'شَهْرٌ وَطْءٌ':Added, #20: 20	شَهْرٍ وَاحِدٍ
u'شَهْرٌ وُقُوعٌ':Added, #1: 1	شَهْرِ الْوَطْءِ
u'شَهَوَاتٌ أَنْفُسٌ':Added, #1: 1	شَهْرَ وُقُوعِ
u'شَهَوَاتٌ حِسٌّ':Added, #1: 1	شَهَوَاتِ الْأَنْفُسِ
u'شَهَوَاتٌ غَيٌّ':Added, #1: 1	شَهَوَاتُ الْحِسِّ
u'شَهَوَاتٌ نَفْسٌ':Added, #1: 1	شَهَوَاتِ الْغَيِّ
u'شَهَوَاتٌ نَفْسٌ':Added, #1: 1	شَهَوَاتُ النَّفْسِ
u'شَهَوَاتٌ نُفُوسٌ':Added, #2: 2	شَهَوَاتِ النَّفْسِ
u'شَهْوَةٌ أَشْيَاءٌ':Added, #1: 1	شَهَوَاتِ النُّفُوسِ
u'شَهْوَةٌ أكل':Added, #1: 1	شَهْوَةُ الْأَشْيَاءِ
u'شَهْوَةٌ أَكْلٌ':Added, #1: 1	شَهْوَةُ الْأَكْلِ
u'شَهْوَةٌ الْمَرْأَةُ':Added, #1: 1	شَهْوَةُ الْأَكْلِ
u'شَهْوَةٌ إِنْزالٌ':Added, #2: 2	شَهْوَةُ الْمَرْأَةِ
u'شَهْوَةٌ بَطْنٌ':Added, #1: 1	شَهْوَةُ الْإِنْزَالِ
u'شَهْوَةٌ بَطْنٌ':Added, #2: 2	شَهْوَةَ الْبَطْنِ
u'شَهْوَةٌ بَطْنٌ':Added, #2: 2	شَهْوَةُ الْبَطْنِ
u'شَهْوَةٌ جَاهٌ':Added, #6: 6	شَهْوَةِ الْبَطْنِ
u'شَهْوَةٌ جماع':Added, #3: 3	شَهْوَةِ الْجَاهِ
u'شَهْوَةٌ جِمَاعٌ':Added, #1: 1	شَهْوَةِ الْجِمَاعِ
u'شَهْوَةٌ جماع':Added, #1: 1	شَهْوَةِ الْجِمَاعِ
u'شَهْوَةٌ جِمَاعٌ':Added, #5: 5	شَهْوَةَ الْجِمَاعِ
u'شَهْوَةٌ ذكر':Added, #5: 5	شَهْوَةَ الْجِمَاعِ
u'شَهْوَةٌ ذَكَرٌ':Added, #1: 1	شَهْوَةِ الذَّكَرِ
u'شَهْوَةٌ رِجَالٌ':Added, #1: 1	شَهْوَةِ الذَّكَرِ
u'شَهْوَةٌ رَجُلٌ':Added, #1: 1	شَهْوَةِ الرِّجَالِ
u'شَهْوَةٌ زَهْرَةٌ':Added, #2: 2	شَهْوَةِ الرَّجُلِ
u'شَهْوَةٌ زِيادَةٌ':Added, #1: 1	شَهْوَةِ زَهْرَةٍ
u'شَهْوَةٌ سَاعَةٌ':Added, #1: 1	شَهْوَةُ الزِّيَادَةِ
u'شَهْوَةٌ شَبابٌ':Added, #2: 2	شَهْوَةِ سَاعَةٍ
u'شَهْوَةٌ شَبَابٌ':Added, #1: 1	شَهْوَةِ الشَّبَابِ
u'شَهْوَةٌ ضراب':Added, #1: 1	شَهْوَةِ الشَّبَابِ
u'شَهْوَةٌ طعام':Added, #1: 1	شَهْوَةِ الضِّرَابِ
u'شَهْوَةٌ طَعَامٌ':Added, #2: 2	شَهْوَةِ الطَّعَامِ
u'شَهْوَةٌ طعام':Added, #2: 2	شَهْوَةِ الطَّعَامِ
u'شَهْوَةٌ طَعَامٌ':Added, #3: 3	شَهْوَةَ الطَّعَامِ
u'شَهْوَةٌ غِذَاءٌ':Added, #3: 3	شَهْوَةَ الطَّعَامِ
u'شَهْوَةٌ فَرْجٌ':Added, #2: 2	شَهْوَةِ الْغِذَاءِ
u'شَهْوَةٌ فَرْجٌ':Added, #1: 1	شَهْوَةُ الْفَرْجِ
u'شَهْوَةٌ مُبَاشَرَةٌ':Added, #1: 1	شَهْوَةِ الْفَرْجِ
u'شَهْوَةٌ مُتَعَلِّمٌ':Added, #1: 1	شَهْوَةِ الْمُبَاشَرَةِ
u'شَهْوَةٌ مَحَلٌّ':Added, #1: 1	شَهْوَةَ الْمُتَعَلِّمِ
u'شَهْوَةٌ نِساءٌ':Added, #1: 1	شَهْوَةِ الْمَحَلِّ
u'شَهْوَةٌ نِساءٌ':Added, #1: 1	شَهْوَةَ النّسَاءِ
u'شَهْوَةٌ نَفْسٌ':Added, #1: 1	شَهْوَةَ النِّسَاءِ
u'شَهْوَةٌ وَطْءٌ':Added, #3: 3	شَهْوَةِ النَّفْسِ
u'شَهْوَةٌ يهود':Added, #1: 1	شَهْوَةِ الْوَطْءِ
u'شَهْوَةٌ يَهُودٌ':Added, #1: 1	شَهْوَةُ الْيَهُودِ
u'شُهُودٌ اِبْنٌ':Added, #1: 1	شَهْوَةُ الْيَهُودِ
u'شُهُودٌ أَجْنَبِيٌّ':Added, #1: 1	شُهُودُ ابْنِ
u'شُهُودٌ أحَدٌ':Added, #1: 1	شُهُودُ الْأَجْنَبِيِّ
u'شُهُودٌ إِحْرَازٌ':Added, #1: 1	شُهُودُ أَحَدِ
u'شُهُودٌ أَخٌ':Added, #2: 2	شُهُودَ إحْرَازِ
u'شُهُودٌ أَرْبَعَةٌ':Added, #2: 2	شُهُودُ الْأَخِ
u'شُهُودٌ إصابَةٌ':Added, #1: 1	شُهُودٍ أَرْبَعَةٍ
u'شُهُودٌ أصل':Added, #3: 3	شُهُودُ الْإِصَابَةِ
u'شُهُودٌ أًصْلٌ':Added, #17: 17	شُهُودِ الْأَصْلِ
u'شُهُودٌ أصل':Added, #17: 17	شُهُودِ الْأَصْلِ
u'شُهُودٌ أًصْلٌ':Added, #1: 1	شُهُودِ أَصْلِهِ
u'شُهُودٌ أصل':Added, #1: 1	شُهُودِ أَصْلِهِ
u'شُهُودٌ أًصْلٌ':Added, #24: 24	شُهُودُ الْأَصْلِ
u'شُهُودٌ أصل':Added, #24: 24	شُهُودُ الْأَصْلِ
u'شُهُودٌ أًصْلٌ':Added, #6: 6	شُهُودَ الْأَصْلِ
u'شُهُودٌ أُصولٌ':Added, #6: 6	شُهُودَ الْأَصْلِ
u'شُهُودٌ أُصولٌ':Added, #1: 1	شُهُودَ الْأُصُولِ
u'شُهُودٌ أَعْيَادٌ':Added, #1: 1	شُهُودُ الْأُصُولِ
u'شُهُودٌ إكْرَاهٌ':Added, #2: 2	شُهُودُ أَعْيَادِ
u'شُهُودٌ أُمٌّ':Added, #1: 1	شُهُودِ الْإِكْرَاهِ
u'شُهُودٌ أُمٌّ':Added, #1: 1	شُهُودُ الْأُمِّ
u'شُهُودٌ أمَةٌ':Added, #1: 1	شُهُودِ الْأُمِّ
u'شُهُودٌ اِنْجِلاءٌ':Added, #1: 1	شُهُودُ الْأَمَةِ
u'شُهُودٌ أَوْقَافٌ':Added, #1: 1	شُهُودَ انْجِلَاءِ
u'شُهُودٌ أَوَّلُ':Added, #1: 1	شُهُودِ الْأَوْقَافِ
u'شُهُودٌ أَوَّلُ':Added, #2: 2	شُهُودِ الْأَوَّلِ
u'شُهُودٌ إيقَاعٌ':Added, #3: 3	شُهُودُ الْأَوَّلِ
u'شُهُودٌ بَائِعٌ':Added, #1: 1	شُهُودِ الْإِيقَاعِ
u'شُهُودٌ بَدْرٌ':Added, #1: 1	شُهُودُ الْبَائِعِ
u'شُهُودٌ بَراءةٌ':Added, #1: 1	شُهُودُ بَدْرٍ
u'شُهُودٌ بَراءةٌ':Added, #1: 1	شُهُودَ الْبَرَاءَةِ
u'شُهُودٌ بَراءةٌ':Added, #1: 1	شُهُودُ الْبَرَاءَةِ
u'شُهُودٌ بَراءةٌ':Added, #1: 1	شُهُودِ الْبَرَاءَةِ
u'شُهُودٌ بَعْضٌ':Added, #1: 1	شُهُودُ بَرَاءَةِ
u'شُهُودٌ بَيَانٌ':Added, #1: 1	شُهُودُ بَعْضِ
u'شُهُودٌ بَيْعٌ':Added, #1: 1	شُهُودِ بَيَانِهِ
u'شُهُودٌ بَيْعٌ':Added, #1: 1	شُهُودَ الْبَيْعِ
u'شُهُودٌ تَأْجِيلٌ':Added, #1: 1	شُهُودِ الْبَيْعِ
u'شُهُودٌ تَحْقِيقٌ':Added, #1: 1	شُهُودَ التَّأْجِيلِ
u'شُهُودٌ تَدْبِيرٌ':Added, #1: 1	شُهُودُ تَحْقِيقِ
u'شُهُودٌ تَزْكِيَةٌ':Added, #1: 1	شُهُودُ التَّدْبِيرِ
u'شُهُودٌ تَعْزِير':Added, #2: 2	شُهُودُ تَزْكِيَةٍ
u'شُهُودٌ تَعْلِيقٌ':Added, #1: 1	شُهُودُ التَّعْزِيرِ
u'شُهُودٌ تَعْلِيقٌ':Added, #1: 1	شُهُودَ التَّعْلِيقِ
u'شُهُودٌ تَعْلِيقٌ':Added, #1: 1	شُهُودُ تَعْلِيقِ
u'شُهُودٌ تَعْلِيقٌ':Added, #4: 4	شُهُودُ التَّعْلِيقِ
u'شُهُودٌ تَفْوِيضٌ':Added, #4: 4	شُهُودِ التَّعْلِيقِ
u'شُهُودٌ تَوْكِيلٌ':Added, #2: 2	شُهُودِ التَّفْوِيضِ
u'شُهُودٌ ثَالِثٌ':Added, #2: 2	شُهُودِ التَّوْكِيلِ
u'شُهُودٌ ثَالِثٌ':Added, #1: 1	شُهُودِ الثَّالِثِ
u'شُهُودٌ ثَلاثُ':Added, #3: 3	شُهُودُ الثَّالِثِ
u'شُهُودٌ جُزْءٌ':Added, #3: 3	شُهُودِ الثَّلَاثِ
u'شُهُودٌ جَلْدٌ':Added, #3: 3	شُهُودُ جُزْءٍ
u'شُهُودٌ جمعة':Added, #1: 1	شُهُودِ جَلْدٍ
u'شُهُودٌ جُمُعَةٌ':Added, #3: 3	شُهُودِ الْجُمُعَةِ
u'شُهُودٌ جمعة':Added, #3: 3	شُهُودِ الْجُمُعَةِ
u'شُهُودٌ جُمُعَةٌ':Added, #4: 4	شُهُودُ الْجُمُعَةِ
u'شُهُودٌ جَنَائِزُ':Added, #4: 4	شُهُودُ الْجُمُعَةِ
u'شُهُودٌ جَنَائِزُ':Added, #1: 1	شُهُودَ الْجَنَائِزِ
u'شُهُودٌ جَنَائِزُ':Added, #1: 1	شُهُودِ الْجَنَائِزِ
u'شُهُودٌ جِنَايَةٌ':Added, #2: 2	شُهُودُ الْجَنَائِزِ
u'شُهُودٌ جِنَايَةٌ':Added, #1: 1	شُهُودُ الْجِنَايَةِ
u'شُهُودٌ جِنَايَةٌ':Added, #1: 1	شُهُودِ جِنَايَةٍ
u'شُهُودٌ حاكِمٌ':Added, #2: 2	شُهُودِ الْجِنَايَةِ
u'شُهُودٌ حَدٌّ':Added, #2: 2	شُهُودِ الْحَاكِمِ
u'شُهُودٌ حِسْبَةٌ':Added, #1: 1	شُهُودِ الْحَدِّ
u'شُهُودٌ حَقٌّ':Added, #1: 1	شُهُودُ حِسْبَةٍ
u'شُهُودٌ حُكْمٌ':Added, #1: 1	شُهُودِ الْحَقِّ
u'شُهُودٌ حَيَاةٌ':Added, #1: 1	شُهُودِ الْحُكْمِ
u'شُهُودٌ خَارِجٌ':Added, #2: 2	شُهُودِ الْحَيَاةِ
u'شُهُودٌ خطبة':Added, #1: 1	شُهُودُ الْخَارِجِ
u'شُهُودٌ خطبة':Added, #1: 1	شُهُودُ الْخُطْبَةِ
u'شُهُودٌ خُطْبَةٌ':Added, #1: 1	شُهُودِ الْخُطْبَةِ
u'شُهُودٌ خُطْبَةٌ':Added, #1: 1	شُهُودُ الْخُطْبَةِ
u'شُهُودٌ دُخُولٌ':Added, #1: 1	شُهُودِ الْخُطْبَةِ
u'شُهُودٌ دُخُولٌ':Added, #2: 2	شُهُودَ الدُّخُولِ
u'شُهُودٌ دُخُولٌ':Added, #5: 5	شُهُودُ الدُّخُولِ
u'شُهُودٌ ذِمِّيٌّ':Added, #8: 8	شُهُودِ الدُّخُولِ
u'شُهُودٌ ذِمِّيٌّ':Added, #12: 12	شُهُودُ الذِّمِّيِّ
u'شُهُودٌ رَبُّ':Added, #1: 1	شُهُودَ الذِّمِّيِّ
u'شُهُودٌ رَبُّ':Added, #1: 1	شُهُودِ رَبِّ
u'شُهُودٌ رَجُلٌ':Added, #1: 1	شُهُودِ رَبِّهِ
u'شُهُودٌ زَوْجٌ':Added, #1: 1	شُهُودُ الرَّجُلِ
u'شُهُودٌ زَوْجٌ':Added, #1: 1	شُهُودَ الزَّوْجِ
u'شُهُودٌ زُورٌ':Added, #1: 1	شُهُودُ الزَّوْجِ
u'شُهُودٌ زُورٌ':Added, #1: 1	شُهُودُ الزُّورِ
u'شُهُودٌ زُورٌ':Added, #1: 1	شُهُودِ الزُّورِ
u'شُهُودٌ زُورٌ':Added, #3: 3	شُهُودُ زُورٍ
u'شُهُودٌ سِرٌّ':Added, #6: 6	شُهُودَ زُورٍ
u'شُهُودٌ شَاهِدٌ':Added, #1: 1	شُهُودِ السِّرِّ
u'شُهُودٌ شِرَاءٌ':Added, #1: 1	شُهُودُ الشَّاهِدَيْنِ
u'شُهُودٌ شَرْطٌ':Added, #3: 3	شُهُودُ الشِّرَاءِ
u'شُهُودٌ شَرْطٌ':Added, #14: 14	شُهُودِ الشَّرْطِ
u'شُهُودٌ شَرْطٌ':Added, #4: 4	شُهُودَ الشَّرْطِ
u'شُهُودٌ شَرِيكٌ':Added, #5: 5	شُهُودُ الشَّرْطِ
u'شُهُودٌ شَهَادَةٌ':Added, #1: 1	شُهُودُ الشَّرِيكَيْنِ
u'شُهُودٌ شَهْرٌ':Added, #1: 1	شُهُودُ شَهَادَةِ
u'شُهُودٌ شَهْرٌ':Added, #11: 11	شُهُودُ الشَّهْرِ
u'شُهُودٌ شَهْرٌ':Added, #1: 1	شُهُودَ الشَّهْرِ
u'شُهُودٌ صَاحِبٌ':Added, #4: 4	شُهُودِ الشَّهْرِ
u'شُهُودٌ صَاحِبٌ':Added, #1: 1	شُهُودَ صَاحِبِ
u'شُهُودٌ صِفَةٌ':Added, #3: 3	شُهُودُ صَاحِبِ
u'شُهُودٌ صَلاَةٌ':Added, #1: 1	شُهُودِ الصِّفَةِ
u'شُهُودٌ ضِغْنٌ':Added, #1: 1	شُهُودُ صَلَاةِ
u'شُهُودٌ طَلاَقٌ':Added, #1: 1	شُهُودُ ضِغْنٍ
u'شُهُودٌ طَلاَقٌ':Added, #1: 1	شُهُودِ طَلَاقِ
u'شُهُودٌ طَلاَقٌ':Added, #2: 2	شُهُودَ الطَّلَاقِ
u'شُهُودٌ طَلاَقٌ':Added, #2: 2	شُهُودُ طَلَاقٍ
u'شُهُودٌ طَلاَقٌ':Added, #4: 4	شُهُودُ الطَّلَاقِ
u'شُهُودٌ عَامٌّ':Added, #5: 5	شُهُودِ الطَّلَاقِ
u'شُهُودٌ عَامِلٌ':Added, #1: 1	شُهُودَ الْعَامَّةِ
u'شُهُودٌ عَبْدٌ':Added, #1: 1	شُهُودُ الْعَامِلِ
u'شُهُودٌ عَبْدٌ':Added, #1: 1	شُهُودُ الْعَبْدَيْنِ
u'شُهُودٌ عتق':Added, #5: 5	شُهُودُ الْعَبْدِ
u'شُهُودٌ عِتْقٌ':Added, #2: 2	شُهُودَ الْعِتْقِ
u'شُهُودٌ عتق':Added, #2: 2	شُهُودَ الْعِتْقِ
u'شُهُودٌ عِتْقٌ':Added, #5: 5	شُهُودُ الْعِتْقِ
u'شُهُودٌ عتق':Added, #5: 5	شُهُودُ الْعِتْقِ
u'شُهُودٌ عِتْقٌ':Added, #7: 7	شُهُودِ الْعِتْقِ
u'شُهُودٌ عتمة':Added, #7: 7	شُهُودِ الْعِتْقِ
u'شُهُودٌ عَتَمَةٌ':Added, #1: 1	شُهُودَ الْعَتَمَةِ
u'شُهُودٌ عُدُولٌ':Added, #1: 1	شُهُودَ الْعَتَمَةِ
u'شُهُودٌ عِشَاءٌ':Added, #5: 5	شُهُودٍ عُدُولٍ
u'شُهُودٌ عَقْدٌ':Added, #1: 1	شُهُودُ الْعِشَاءِ
u'شُهُودٌ عِلَّةٌ':Added, #3: 3	شُهُودِ الْعَقْدِ
u'شُهُودٌ عِلَّةٌ':Added, #1: 1	شُهُودُ الْعِلَّةِ
u'شُهُودٌ عِلَّةٌ':Added, #1: 1	شُهُودِ الْعِلَّةِ
u'شُهُودٌ عِلَّةٌ':Added, #1: 1	شُهُودُ عِلَّةٍ
u'شُهُودٌ عِيدٌ':Added, #2: 2	شُهُودَ الْعِلَّةِ
u'شُهُودٌ عِيدٌ':Added, #1: 1	شُهُودُ عِيدٍ
u'شُهُودٌ غَاصِبٌ':Added, #1: 1	شُهُودِ عِيدٍ
u'شُهُودٌ غَرِيمٌ':Added, #1: 1	شُهُودُ الْغَاصِبِ
u'شُهُودٌ فَرْعٌ':Added, #1: 1	شُهُودُ الْغَرِيمِ
u'شُهُودٌ فَرْعٌ':Added, #12: 12	شُهُودِ الْفَرْعِ
u'شُهُودٌ فَرْعٌ':Added, #16: 16	شُهُودُ الْفَرْعِ
u'شُهُودٌ فَرْعٌ':Added, #1: 1	شُهُودِ فَرْعِ
u'شُهُودٌ فَرْعٌ':Added, #3: 3	شُهُودُ فَرْعٍ
u'شُهُودٌ فُرُوعٌ':Added, #5: 5	شُهُودَ الْفَرْعِ
u'شُهُودٌ فُرُوعٌ':Added, #1: 1	شُهُودَ الْفُرُوعِ
u'شُهُودٌ فُرُوعٌ':Added, #2: 2	شُهُودُ الْفُرُوعِ
u'شُهُودٌ فَرِيقٌ':Added, #2: 2	شُهُودِ الْفُرُوعِ
u'شُهُودٌ قتال':Added, #2: 2	شُهُودُ الْفَرِيقَيْنِ
u'شُهُودٌ قِتَالٌ':Added, #1: 1	شُهُودُ الْقِتَالِ
u'شُهُودٌ قتال':Added, #1: 1	شُهُودُ الْقِتَالِ
u'شُهُودٌ قِتَالٌ':Added, #2: 2	شُهُودِ الْقِتَالِ
u'شُهُودٌ قتل':Added, #2: 2	شُهُودِ الْقِتَالِ
u'شُهُودٌ قَتْلٌ':Added, #1: 1	شُهُودِ قَتْلِ
u'شُهُودٌ قَتْلٌ':Added, #1: 1	شُهُودِ قَتْلٍ
u'شُهُودٌ قتل':Added, #1: 1	شُهُودِ قَتْلِ
u'شُهُودٌ قَتْلٌ':Added, #2: 2	شُهُودُ الْقَتْلِ
u'شُهُودٌ قتل':Added, #2: 2	شُهُودُ الْقَتْلِ
u'شُهُودٌ قَتْلٌ':Added, #4: 4	شُهُودِ الْقَتْلِ
u'شُهُودٌ قذف':Added, #4: 4	شُهُودِ الْقَتْلِ
u'شُهُودٌ قَذْفٌ':Added, #1: 1	شُهُودُ الْقَذْفِ
u'شُهُودٌ قذف':Added, #1: 1	شُهُودُ الْقَذْفِ
u'شُهُودٌ قَذْفٌ':Added, #2: 2	شُهُودِ الْقَذْفِ
u'شُهُودٌ قَرَابَةٌ':Added, #2: 2	شُهُودِ الْقَذْفِ
u'شُهُودٌ قَرْضٌ':Added, #2: 2	شُهُودُ الْقَرَابَةِ
u'شُهُودٌ قصاص':Added, #1: 1	شُهُودَ قَرْضٍ
u'شُهُودٌ قِصَاصٌ':Added, #1: 1	شُهُودَ الْقِصَاصِ
u'شُهُودٌ قصاص':Added, #1: 1	شُهُودَ الْقِصَاصِ
u'شُهُودٌ قِصَاصٌ':Added, #2: 2	شُهُودُ الْقِصَاصِ
u'شُهُودٌ قصاص':Added, #2: 2	شُهُودُ الْقِصَاصِ
u'شُهُودٌ قِصَاصٌ':Added, #6: 6	شُهُودِ الْقِصَاصِ
u'شُهُودٌ قَوَد':Added, #6: 6	شُهُودِ الْقِصَاصِ
u'شُهُودٌ قَوَد':Added, #1: 1	شُهُودَ الْقَوَدِ
u'شُهُودٌ قَوَد':Added, #1: 1	شُهُودُ الْقَوَدِ
u'شُهُودٌ كَبِيرٌ':Added, #1: 1	شُهُودُ قَوَدٍ
u'شُهُودٌ كِتَابٌ':Added, #1: 1	شُهُودِ الْكَبِيرِ
u'شُهُودٌ كِتَابٌ':Added, #1: 1	شُهُودَ الْكِتَابِ
u'شُهُودٌ كِتَابٌ':Added, #1: 1	شُهُودِ الْكِتَابِ
u'شُهُودٌ كِتَابَةٌ':Added, #4: 4	شُهُودُ الْكِتَابِ
u'شُهُودٌ كِتَابَةٌ':Added, #1: 1	شُهُودُ كِتَابَةٍ
u'شُهُودٌ لَيْلٌ':Added, #1: 1	شُهُودِ كِتَابَةٍ
u'شُهُودٌ مَالٌ':Added, #1: 1	شُهُودِ لَيْلَةِ
u'شُهُودٌ مَالٌ':Added, #1: 1	شُهُودُ الْمَالِ
u'شُهُودٌ مَالِكٌ':Added, #1: 1	شُهُودُ مَالٍ
u'شُهُودٌ مُسْتَحِقٌّ':Added, #2: 2	شُهُودُ الْمَالِكِ
u'شُهُودٌ مُضَارَبَةٌ':Added, #1: 1	شُهُودَ الْمُسْتَحِقِّ
u'شُهُودٌ مَعْرِفَةٌ':Added, #1: 1	شُهُودُ الْمُضَارَبَةِ
u'شُهُودٌ مَعْرِفَة':Added, #1: 1	شُهُودِ الْمَعْرِفَةِ
u'شُهُودٌ مَلاَئِكَةٌ':Added, #1: 1	شُهُودِ الْمَعْرِفَةِ
u'شُهُودٌ مَلاَئِكَةٌ':Added, #1: 1	شُهُودَ الْمَلَائِكَةِ
u'شُهُودٌ مَوْتٌ':Added, #1: 1	شُهُودُ الْمَلَائِكَةِ
u'شُهُودٌ نَاسٌ':Added, #2: 2	شُهُودِ مَوْتِ
u'شُهُودٌ نَسَبٌ':Added, #1: 1	شُهُودَ النَّاسِ
u'شُهُودٌ نَصْرَانِيٌّ':Added, #1: 1	شُهُودُ النَّسَبِ
u'شُهُودٌ نكاح':Added, #1: 1	شُهُودُ النَّصْرَانِيِّ
u'شُهُودٌ نِكَاحٌ':Added, #12: 12	شُهُودِ النِّكَاحِ
u'شُهُودٌ نكاح':Added, #12: 12	شُهُودِ النِّكَاحِ
u'شُهُودٌ نِكَاحٌ':Added, #5: 5	شُهُودَ النِّكَاحِ
u'شُهُودٌ نكاح':Added, #5: 5	شُهُودَ النِّكَاحِ
u'شُهُودٌ نِكَاحٌ':Added, #9: 9	شُهُودُ النِّكَاحِ
u'شُهُودٌ واحد':Added, #9: 9	شُهُودُ النِّكَاحِ
u'شُهُودٌ وَاحِدٌ':Added, #3: 3	شُهُودِ الْوَاحِدَةِ
u'شُهُودٌ وُجُودٌ':Added, #3: 3	شُهُودِ الْوَاحِدَةِ
u'شُهُودٌ وَقْتٌ':Added, #1: 1	شُهُودِ وُجُودِ
u'شُهُودٌ وقعة':Added, #1: 1	شُهُودُ الْوَقْتِ
u'شُهُودٌ وَقْعَةٌ':Added, #3: 3	شُهُودُ الْوَقْعَةِ
u'شُهُودٌ وقعة':Added, #3: 3	شُهُودُ الْوَقْعَةِ
u'شُهُودٌ وَقْعَةٌ':Added, #7: 7	شُهُودِ الْوَقْعَةِ
u'شُهُودٌ وَكِيلٌ':Added, #7: 7	شُهُودِ الْوَقْعَةِ
u'شُهُودٌ وَكِيلٌ':Added, #1: 1	شُهُودَ الْوَكِيلِ
u'شُهُودٌ ولد':Added, #1: 1	شُهُودِ الْوَكِيلِ
u'شُهُودٌ وَلَدٌ':Added, #1: 1	شُهُودِ الْوَلَدِ
u'شُهُودٌ يَمِينٌ':Added, #1: 1	شُهُودِ الْوَلَدِ
u'شُهُودٌ يَمِينٌ':Added, #1: 1	شُهُودُ يَمِينٍ
u'شُهُودٌ يَمِينٌ':Added, #2: 2	شُهُودَ الْيَمِينِ
u'شُهُودٌ يَمِينٌ':Added, #4: 4	شُهُودُ الْيَمِينِ
u'شَهِيَ عند':Predicate, #5: 5	شُهُودِ الْيَمِينِ
u'شَوْطٌ رَفْضٌ':Added, #1: 1	أَشْهَى عِنْدَكَ
u'شَوْطٌ واحد':Added, #1: 1	شَوْطِ رَفْضِهِ
u'شَوْطٌ وَاحِدٌ':Added, #1: 1	شَوْطٍ وَاحِدٍ
u'شَوَى بيض':Predicate, #1: 1	شَوْطٍ وَاحِدٍ
u'شَوَى لَحْمٌ':Predicate, #2: 2	شَوَى بَيْضَ
u'شَوَى مُحْرِمٌ':Subject, #1: 1	شَوَى اللَّحْمَ
u'شَوَى مُحْرِمٌ':Subject, #1: 1	شَوَى الْمُحْرِمُ
u'شَيْبَةٌ أُمٌّ':Added, #1: 1	شَوَى مُحْرِمٌ
u'شَيْبَةٌ بِنْتٌ':Added, #1: 1	شَيْبَةَ أُمِّ
u'شَيْبَةٌ حجبة':Added, #1: 1	شَيْبَةَ بِنْتِ
u'شَيْبَةٌ حَمْدٌ':Added, #1: 1	شَيْبَةَ حَجَبَةِ
u'شَيْبَةٌ حَمْدٌ':Added, #1: 1	شَيْبَةُ الْحَمْدِ
u'شَيْبَةٌ حَمْدٌ':Added, #2: 2	شَيْبَةَ الْحَمْدِ
u'شَيْبَةٌ شَيْخٌ':Added, #3: 3	شَيْبَةِ الْحَمْدِ
u'شَيْبَةٌ عَبْدٌ':Added, #1: 1	شَيْبَةَ شَيْخِ
u'شيب ذَوائِبُ':Added, #2: 2	شَيْبَةَ عَبْدِ
u'شَيْبٌ ذَوائِبُ':Added, #1: 1	شَيْبُ الذّوَائِبِ
u'شيب رَسُولٌ':Added, #1: 1	شَيْبُ الذّوَائِبِ
u'شَيْبٌ رَسُولٌ':Added, #1: 1	شَيْبِ رَسُولِ
u'شيب نَاصِيَةٌ':Added, #1: 1	شَيْبِ رَسُولِ
u'شَيْبٌ نَاصِيَةٌ':Added, #1: 1	شَيْبُ النَّاصِيَةِ
u'شَيْنٌ جُرْحٌ':Added, #1: 1	شَيْبُ النَّاصِيَةِ
u'شَيْنٌ دِينٌ':Added, #1: 1	شَيْنَ الْجُرْحِ
u'صَابَ أَبٌ':Predicate, #1: 1	شَيْنَ الدِّينِ
u'صَابَ اِبْنٌ':Predicate, #1: 1	أَصَابَ الْأَبَ
u'صَابَ أَجِيرٌ':Subject, #6: 6	أَصَابَ ابْنَ
u'صَابَ أحَدٌ':Predicate, #1: 1	أَصَابَ الْأَجِيرُ
u'صَابَ أحَدٌ':Subject, #2: 2	أَصَابَ أَحَدَ
u'صَابَ أَحْيَاءٌ':Predicate, #1: 1	أَصَابَ أَحَدُ
u'صَابَ أَرَاضِي':Predicate, #1: 1	أَصَابَ الْأَحْيَاءَ
u'صَابَ أَرْبَعُ':Predicate, #2: 2	أَصَابَ الْأَرَاضِيَ
u'صَابَ أَرْبَعَةٌ':Predicate, #1: 1	أَصَابَ الْأَرْبَعَ
u'صَابَ أرْضٌ':Predicate, #1: 1	أَصَابَ الْأَرْبَعَةَ
u'صَابَ أرْضٌ':Predicate, #1: 1	أَصَابَ الأَرْضَ
u'صَابَ أَسْفَلُ':Predicate, #8: 8	أَصَابَ الْأَرْضَ
u'صَابَ إِسْنادٌ':Predicate, #1: 1	أَصَابَ الْأَسْفَلَ
u'صَابَ أَصْحَابٌ':Predicate, #1: 1	أَصَابَ الإِسْنَادَ
u'صَابَ أصل':Predicate, #1: 1	أَصَابَ أَصْحَابَ
u'صَابَ أًصْلٌ':Predicate, #5: 5	أَصَابَ الْأَصْلَ
u'صَابَ أعْيانٌ':Subject, #5: 5	أَصَابَ الْأَصْلَ
u'صَابَ أَعْيَانٌ':Subject, #1: 1	أَصَابَ الْأَعْيَانُ
u'صَابَ أقرباء':Predicate, #1: 1	أَصَابَ الْأَعْيَانُ
u'صَابَ ألف':Predicate, #1: 1	أَصَابَ الْأَقْرِبَاءَ
u'صَابَ ألْفٌ':Predicate, #1: 1	أَصَابَ الْأَلْفَ
u'صَابَ أَلْفٌ':Predicate, #1: 1	أَصَابَ الْأَلْفَ
u'صَابَ ألف':Subject, #1: 1	أَصَابَ الْأَلْفَ
u'صَابَ ألْفٌ':Subject, #1: 1	أَصَابَ الْأَلْفُ
u'صَابَ أَلْفٌ':Subject, #1: 1	أَصَابَ الْأَلْفُ
u'صَابَ أُمٌّ':Predicate, #1: 1	أَصَابَ الْأَلْفُ
u'صَابَ أُمٌّ':Subject, #8: 8	أَصَابَ الْأُمَّ
u'صَابَ إمَامٌ':Predicate, #1: 1	أَصَابَ أُمّهُ
u'صَابَ إمَامٌ':Subject, #1: 1	أَصَابَ الْإِمَامَ
u'صَابَ أمَانَةٌ':Predicate, #2: 2	أَصَابَ الْإِمَامُ
u'صَابَ أُمَمٌ':Predicate, #1: 1	أَصَابَ الْأَمَانَةَ
u'صَابَ أموات':Predicate, #1: 1	أَصَابَ الْأُمَمَ
u'صَابَ أَميرٌ':Subject, #1: 1	أَصَابَ الْأَمْوَاتَ
u'صَابَ إِناءٌ':Predicate, #1: 1	أَصَابَ الْأَمِيرُ
u'صَابَ إِناثٌ':Predicate, #1: 1	أَصَابَ الْإِنَاءَ
u'صَابَ أنصار':Predicate, #1: 1	أَصَابَ الْإِنَاثَ
u'صَابَ أَنْصارٌ':Predicate, #1: 1	أَصَابَ الأَنْصَارَ
u'صَابَ أَنْصَارٌ':Predicate, #1: 1	أَصَابَ الأَنْصَارَ
u'صَابَ أهْلٌ':Predicate, #1: 1	أَصَابَ الأَنْصَارَ
u'صَابَ أهْلٌ':Subject, #5: 5	أَصَابَ أَهْلَ
u'صَابَ أوانِي':Predicate, #7: 7	أَصَابَ أَهْلُ
u'صَابَ أَوَّلُ':Predicate, #1: 1	أَصَابَ أَوَانِيَ
u'صَابَ أَوَّلُ':Subject, #1: 1	أَصَابَ الْأَوَّلَ
u'صَابَ أَوْلاَدٌ':Predicate, #1: 1	أَصَابَ الْأَوَّلُ
u'صَابَ أَوْلاَدٌ':Subject, #1: 1	أَصَابَ أَوْلَادَ
u'صَابَ بدن':Predicate, #1: 1	أَصَابَ الْأَوْلَادُ
u'صَابَ بَدَنٌ':Predicate, #2: 2	أَصَابَ الْبَدَنَ
u'صَابَ بدن':Predicate, #2: 2	أَصَابَ الْبَدَنَ
u'صَابَ بَدَنٌ':Predicate, #2: 2	أَصَابَ بَدَنَ
u'صَابَ بَعْضٌ':Predicate, #2: 2	أَصَابَ بَدَنَ
u'صَابَ بَعْضٌ':Subject, #2: 2	أَصَابَ بَعْضَ
u'صَابَ بَعيرٌ':Predicate, #2: 2	أَصَابَ الْبَعْضُ
u'صَابَ بَعيرٌ':Subject, #1: 1	أَصَابَ الْبَعِيرَ
u'صَابَ بِنَاءٌ':Predicate, #1: 1	أَصَابَ الْبَعِيرُ
u'صَابَ بِنْتٌ':Predicate, #4: 4	أَصَابَ الْبِنَاءَ
u'صَابَ بَوْلٌ':Predicate, #6: 6	أَصَابَ بِنْتَ
u'صَابَ بَوْلٌ':Subject, #1: 1	أَصَابَ الْبَوْلَ
u'صَابَ بَوْلٌ':Subject, #1: 1	أَصَابَ بَوْلُ
u'صَابَ بَيْتٌ':Predicate, #2: 2	أَصَابَ الْبَوْلُ
u'صَابَ بيض':Predicate, #1: 1	أَصَابَ الْبَيْتَ
u'صَابَ بَيْنٌ':Predicate, #1: 1	أَصَابَ بَيْضَ
u'صَابَ تُرَابٌ':Subject, #1: 1	أَصَابَ بَيْنَ
u'صَابَ تِسْعَةٌ':Predicate, #1: 1	أَصَابَ التُّرَابُ
u'صَابَ تَفْسِيرٌ':Predicate, #1: 1	أَصَابَ تِسْعَةَ
u'صَابَ ثَابِتٌ':Predicate, #1: 1	أَصَابَ التَّفْسِيرَ
u'صَابَ ثَابِتٌ':Subject, #1: 1	أَصَابَ الثَّابِتَ
u'صَابَ ثَانِي':Predicate, #4: 4	أَصَابَ الثَّابِتُ
u'صَابَ ثَمَرٌ':Predicate, #1: 1	أَصَابَ الثَّانِيَ
u'صَابَ ثَمَرَةٌ':Predicate, #1: 1	أَصَابَ الثَّمَرَ
u'صَابَ ثَمَنٌ':Subject, #3: 3	أَصَابَ الثَّمَرَةَ
u'صَابَ ثَوْبٌ':Predicate, #2: 2	أَصَابَ ثَمَنُ
u'صَابَ ثَوْبٌ':Predicate, #29: 29	أَصَابَ الثَّوْبَ
u'صَابَ ثَوْبٌ':Subject, #7: 7	أَصَابَ ثَوْبَ
u'صَابَ جَارِي':Predicate, #2: 2	أَصَابَ الثَّوْبُ
u'صَابَ جَارِي':Predicate, #3: 3	أَصَابَ الْجَارِيَةَ
u'صَابَ جَارِيَةٌ':Predicate, #3: 3	أَصَابَ جَارِيَةً
u'صَابَ جُبّةٌ':Predicate, #3: 3	أَصَابَ الْجَارِيَةَ
u'صَابَ جُرْحٌ':Predicate, #1: 1	أَصَابَ جُبَّةَ
u'صَابَ جلد':Predicate, #1: 1	أَصَابَ الْجُرْحَ
u'صَابَ جِلْدٌ':Predicate, #1: 1	أَصَابَ جِلْدَ
u'صَابَ جلد':Predicate, #1: 1	أَصَابَ جِلْدَ
u'صَابَ جِلْدٌ':Predicate, #2: 2	أَصَابَ الْجِلْدَ
u'صَابَ جَمَاجِمُ':Predicate, #2: 2	أَصَابَ الْجِلْدَ
u'صَابَ جَوَاهِرُ':Predicate, #1: 1	أَصَابَ الْجَمَاجِمَ
u'صَابَ جَيْشٌ':Subject, #1: 1	أَصَابَ جَوَاهِرَ
u'صَابَ حائِطٌ':Predicate, #1: 1	أَصَابَ الْجَيْشُ
u'صَابَ حائِطٌ':Subject, #1: 1	أَصَابَ الْحَائِطَ
u'صَابَ حَبٌّ':Predicate, #1: 1	أَصَابَ الْحَائِطُ
u'صَابَ حَبَّةٌ':Predicate, #1: 1	أَصَابَ حَبَّةَ
u'صَابَ حَجَرٌ':Predicate, #1: 1	أَصَابَ حَبَّةَ
u'صَابَ حَجَرٌ':Subject, #2: 2	أَصَابَ الْحَجَرَ
u'صَابَ حَدٌّ':Predicate, #1: 1	أَصَابَ الْحَجَرُ
u'صَابَ حَديدٌ':Subject, #1: 1	أَصَابَ الْحَدَّ
u'صَابَ حِصَّةٌ':Predicate, #1: 1	أَصَابَ الْحَدِيدُ
u'صَابَ حَقٌّ':Predicate, #7: 7	أَصَابَ حِصَّةَ
u'صَابَ حَقِيبَةٌ':Predicate, #12: 12	أَصَابَ الْحَقَّ
u'صَابَ حَلالٌ':Predicate, #2: 2	أَصَابَ الْحَقِيبَةَ
u'صَابَ حَلالٌ':Subject, #1: 1	أَصَابَ الْحَلاَلَ
u'صَابَ حَلالٌ':Subject, #1: 1	أَصَابَ الْحَلاَلُ
u'صَابَ حَلالٌ':Subject, #2: 2	أَصَابَ الْحَلَالُ
u'صَابَ حِمَارٌ':Predicate, #2: 2	أَصَابَ حَلَالٌ
u'صَابَ خدمة':Predicate, #2: 2	أَصَابَ حِمَارَ
u'صَابَ خِدْمَةٌ':Predicate, #1: 1	أَصَابَ الْخِدْمَةَ
u'صَابَ خُسْران':Predicate, #1: 1	أَصَابَ الْخِدْمَةَ
u'صَابَ خُفٌّ':Predicate, #1: 1	أَصَابَ الْخُسْرَانَ
u'صَابَ خُفٌّ':Predicate, #2: 2	أَصَابَ خُفَّ
u'صَابَ خَمْسٌ':Predicate, #4: 4	أَصَابَ الْخُفَّ
u'صَابَ خوارج':Subject, #1: 1	أَصَابَ خَمْسَ
u'صَابَ خَوَارِجُ':Subject, #2: 2	أَصَابَ الْخَوَارِجُ
u'صَابَ دَجاج':Predicate, #2: 2	أَصَابَ الْخَوَارِجُ
u'صَابَ دَرَاهِمُ':Predicate, #1: 1	أَصَابَ الدَّجَاجَةَ
u'صَابَ دَمٌ':Predicate, #1: 1	أَصَابَ الدَّرَاهِمَ
u'صَابَ دِماغٌ':Predicate, #1: 1	أَصَابَ الدَّمَ
u'صَابَ دَنانيرُ':Predicate, #1: 1	أَصَابَ الدِّمَاغَ
u'صَابَ دونٌ':Predicate, #2: 2	أَصَابَ الدَّنَانِيرَ
u'صَابَ دِيَةٌ':Predicate, #1: 1	أَصَابَ دُونَ
u'صَابَ دِينارٌ':Subject, #1: 1	أَصَابَ الدِّيَةَ
u'صَابَ ذُكورٌ':Predicate, #1: 1	أَصَابَ الدِّينَارُ
u'صَابَ ذَهَبٌ':Predicate, #1: 1	أَصَابَ الذُّكُورَ
u'صَابَ ذَهَبٌ':Subject, #1: 1	أَصَابَ الذَّهَبَ
u'صَابَ رَاحِلٌ':Predicate, #1: 1	أَصَابَ الذَّهَبُ
u'صَابَ رَاحِلَةٌ':Predicate, #1: 1	أَصَابَ الرَّاحِلَةَ
u'صَابَ رَأْسٌ':Subject, #1: 1	أَصَابَ الرَّاحِلَةَ
u'صَابَ رَبُّ':Predicate, #3: 3	أَصَابَ رَأْسُهُ
u'صَابَ رَجُلٌ':Predicate, #1: 1	أَصَابَ رَبَّ
u'صَابَ رِجْلٌ':Predicate, #1: 1	أَصَابَ الرَّجُلَ
u'صَابَ رَجُلٌ':Subject, #1: 1	أَصَابَ رِجْلَكَ
u'صَابَ رَجُلٌ':Subject, #2: 2	أَصَابَ الرَّجُلُ
u'صَابَ رَسُولٌ':Predicate, #2: 2	أَصَابَ رَجُلٌ
u'صَابَ رَسُولٌ':Subject, #1: 1	أَصَابَ رَسُولَ
u'صَابَ رَقَبَةٌ':Predicate, #3: 3	أَصَابَ رَسُولُ
u'صَابَ رَقيقٌ':Predicate, #2: 2	أَصَابَ الرَّقَبَةَ
u'صَابَ رَقيق':Predicate, #1: 1	أَصَابَ الرَّقِيقَ
u'صَابَ زَرْعٌ':Predicate, #1: 1	أَصَابَ الرَّقِيقَ
u'صَابَ زَرْعٌ':Predicate, #1: 1	أَصَابَ زَرْعَ
u'صَابَ زَوْجٌ':Predicate, #9: 9	أَصَابَ الزَّرْعَ
u'صَابَ زِيادَةٌ':Predicate, #1: 1	أَصَابَ الزَّوْجَ
u'صَابَ زَيْتٌ':Predicate, #1: 1	أَصَابَ الزِّيَادَةَ
u'صَابَ زَيْدٌ':Subject, #1: 1	أَصَابَ الزَّيْتَ
u'صَابَ زَيْنَبٌ':Predicate, #1: 1	أَصَابَ زَيْدٌ
u'صَابَ سَاقِطٌ':Predicate, #1: 1	أَصَابَ زَيْنَبَ
u'صَابَ سِتٌّ':Predicate, #2: 2	أَصَابَ السَّاقِطَ
u'صَابَ سَقْفٌ':Predicate, #2: 2	أَصَابَ سِتَّةً
u'صَابَ سِلْعَةٌ':Predicate, #1: 1	أَصَابَ السَّقْفَ
u'صَابَ سُنَّةٌ':Predicate, #3: 3	أَصَابَ السِّلْعَةَ
u'صَابَ سَهْمٌ':Subject, #3: 3	أَصَابَ السُّنَّةَ
u'صَابَ سَهْمٌ':Subject, #1: 1	أَصَابَ السّهْمُ
u'صَابَ سَهْمٌ':Subject, #1: 1	أَصَابَ سَهْمٌ
u'صَابَ سَهْمٌ':Subject, #2: 2	أَصَابَ سَهْمُ
u'صَابَ سَهْمٌ':Subject, #4: 4	أَصَابَ سَهْمُهُ
u'صَابَ سُهَيْلٌ':Predicate, #9: 9	أَصَابَ السَّهْمُ
u'صَابَ سَيِّدٌ':Subject, #1: 1	أَصَابَ سُهَيْلاً
u'صَابَ سَيْفٌ':Subject, #2: 2	أَصَابَ السَّيِّدُ
u'صَابَ شَاةٌ':Predicate, #1: 1	أَصَابَ السّيْفُ
u'صَابَ شَاعِر':Subject, #1: 1	أَصَابَ الشَّاةَ
u'صَابَ شَهْرٌ':Predicate, #1: 1	أَصَابَ الشَّاعِرُ
u'صَابَ صَاحِبٌ':Predicate, #1: 1	أَصَابَ شَهْرَ
u'صَابَ صَاحِبٌ':Subject, #2: 2	أَصَابَ صَاحِبَ
u'صَابَ صَاحِبٌ':Subject, #1: 1	أَصَابَ صَاحِبُ
u'صَابَ صَبِيٌّ':Predicate, #1: 1	أَصَابَ صَاحِبُهُ
u'صَابَ صَبِيٌّ':Subject, #1: 1	أَصَابَ الصَّبِيَّ
u'صَابَ صَغِيرٌ':Subject, #3: 3	أَصَابَ الصَّبِيُّ
u'صَابَ صَيْدٌ':Predicate, #1: 1	أَصَابَ الصَّغِيرُ
u'صَابَ صَيْدٌ':Predicate, #1: 1	أَصَابَ صَيْدَ
u'صَابَ صَيْدٌ':Subject, #7: 7	أَصَابَ الصَّيْدَ
u'صَابَ ضَرْبٌ':Predicate, #1: 1	أَصَابَ الصَّيْدُ
u'صَابَ طرف':Predicate, #1: 1	أَصَابَ الضَّرْبَ
u'صَابَ طَرَفٌ':Predicate, #2: 2	أَصَابَ طَرَفَ
u'صَابَ طرف':Subject, #2: 2	أَصَابَ طَرَفَ
u'صَابَ طَرَفٌ':Subject, #1: 1	أَصَابَ الطَّرَفُ
u'صَابَ طَرِيقٌ':Predicate, #1: 1	أَصَابَ الطَّرَفُ
u'صَابَ طِينٌ':Subject, #1: 1	أَصَابَ طَرِيقَ
u'صَابَ ظِلْفٌ':Predicate, #1: 1	أَصَابَ الطِّينُ
u'صَابَ عِبَادٌ':Subject, #1: 1	أَصَابَ الظِّلْفَ
u'صَابَ عَبْدٌ':Predicate, #1: 1	أَصَابَ الْعِبَادُ
u'صَابَ عتق':Predicate, #3: 3	أَصَابَ الْعَبْدَ
u'صَابَ عِتْقٌ':Predicate, #6: 6	أَصَابَ الْعِتْقَ
u'صَابَ عتق':Subject, #6: 6	أَصَابَ الْعِتْقَ
u'صَابَ عِتْقٌ':Subject, #1: 1	أَصَابَ الْعِتْقُ
u'صَابَ عَذَابٌ':Subject, #1: 1	أَصَابَ الْعِتْقُ
u'صَابَ عَرْصَةٌ':Predicate, #2: 2	أَصَابَ الْعَذَابُ
u'صَابَ عَسْكَرٌ':Subject, #1: 1	أَصَابَ الْعَرْصَةَ
u'صَابَ عُضْوٌ':Predicate, #1: 1	أَصَابَ الْعَسْكَرُ
u'صَابَ عقر':Predicate, #1: 1	أَصَابَ الْعُضْوَ
u'صَابَ عُقْرٌ':Predicate, #1: 1	أَصَابَ الْعُقْرَ
u'صَابَ عَقُورٌ':Predicate, #1: 1	أَصَابَ الْعُقْرَ
u'صَابَ عَلَقَةٌ':Predicate, #1: 1	أَصَابَ الْعَقُورَ
u'صَابَ عَلِيٌّ':Subject, #1: 1	أَصَابَ الْعَلَقَةَ
u'صَابَ عُمَرٌ':Subject, #1: 1	أَصَابَ عَلِيٌّ
u'صَابَ عَمَلٌ':Subject, #3: 3	أَصَابَ عُمَرُ
u'صَابَ عنق':Predicate, #1: 1	أَصَابَ الْعَمَلُ
u'صَابَ عُنُقٌ':Predicate, #1: 1	أَصَابَ عُنُقَ
u'صَابَ عَيْبٌ':Subject, #1: 1	أَصَابَ عُنُقَ
u'صَابَ عِيرٌ':Predicate, #1: 1	أَصَابَ الْعَيْبُ
u'صَابَ عين':Predicate, #1: 1	أَصَابَ عِيرَ
u'صَابَ عَيْنٌ':Predicate, #3: 3	أَصَابَ عَيْنَ
u'صَابَ عَيْن':Predicate, #3: 3	أَصَابَ عَيْنَ
u'صَابَ غبار':Subject, #3: 3	أَصَابَ عَيْنَ
u'صَابَ غُبَارٌ':Subject, #2: 2	أَصَابَ الْغُبَارُ
u'صَابَ غَرَضٌ':Predicate, #2: 2	أَصَابَ الْغُبَارُ
u'صَابَ غرماء':Predicate, #3: 3	أَصَابَ الْغَرَضَ
u'صَابَ غُلاَمٌ':Subject, #1: 1	أَصَابَ الْغُرَمَاءَ
u'صَابَ غِلْمَانٌ':Subject, #1: 1	أَصَابَ الْغُلاَمُ
u'صَابَ غير':Predicate, #1: 1	أَصَابَ غِلْمَانُ
u'صَابَ غَيْرٌ':Predicate, #5: 5	أَصَابَ غَيْرَ
u'صَابَ غير':Subject, #5: 5	أَصَابَ غَيْرَ
u'صَابَ غَيْرٌ':Subject, #1: 1	أَصَابَ غَيْرُ
u'صَابَ غير':Subject, #1: 1	أَصَابَ غَيْرُ
u'صَابَ غَيْرٌ':Subject, #1: 1	أَصَابَ غَيْرُهُ
u'صَابَ فَاحِشٌ':Predicate, #1: 1	أَصَابَ غَيْرُهُ
u'صَابَ فَارِغٌ':Predicate, #1: 1	أَصَابَ فَاحِشَةً
u'صَابَ فَرْخٌ':Predicate, #3: 3	أَصَابَ الْفَارِغَ
u'صَابَ فِرْدَوْسٌ':Predicate, #1: 1	أَصَابَ فَرْخَ
u'صَابَ فَرَسٌ':Predicate, #1: 1	أَصَابَ الْفِرْدَوْسَ
u'صَابَ فَرِيقٌ':Predicate, #1: 1	أَصَابَ الْفَرَسَ
u'صَابَ فطرة':Predicate, #1: 1	أَصَابَ فَرِيقَ
u'صَابَ فِطْرَةٌ':Predicate, #3: 3	أَصَابَ الْفِطْرَةَ
u'صَابَ فقراء':Predicate, #3: 3	أَصَابَ الْفِطْرَةَ
u'صَابَ فلان':Predicate, #3: 3	أَصَابَ الْفُقَرَاءَ
u'صَابَ فَمٌ':Subject, #1: 1	أَصَابَ عُثْمَانَ
u'صَابَ قِبْلَةٌ':Predicate, #1: 1	أَصَابَ فَمُ
u'صَابَ قَرَابَةٌ':Predicate, #14: 14	أَصَابَ الْقِبْلَةَ
u'صَابَ قُرَبٌ':Predicate, #4: 4	أَصَابَ قَرَابَةَ
u'صَابَ قُرَبٌ':Subject, #1: 1	أَصَابَ الْقُرَبَ
u'صَابَ قَفِيز':Subject, #1: 1	أَصَابَ الْقُرَبُ
u'صَابَ قَوْمٌ':Subject, #1: 1	أَصَابَ الْقَفِيزُ
u'صَابَ قِيمَةٌ':Predicate, #1: 1	أَصَابَ الْقَوْمُ
u'صَابَ قِيمَةٌ':Predicate, #10: 10	أَصَابَ قِيمَةَ
u'صَابَ كَلْبٌ':Subject, #4: 4	أَصَابَ الْقِيمَةَ
u'صَابَ كَلْبٌ':Subject, #2: 2	أَصَابَ كَلْبُ
u'صَابَ كُمٌّ':Predicate, #3: 3	أَصَابَ الْكَلْبُ
u'صَابَ كُوزٌ':Predicate, #1: 1	أَصَابَ الْكُمَّ
u'صَابَ لبن':Predicate, #1: 1	أَصَابَ الْكُوزَ
u'صَابَ لَبَنٌ':Predicate, #1: 1	أَصَابَ اللَّبَنَ
u'صَابَ لِثَةٌ':Predicate, #1: 1	أَصَابَ اللَّبَنَ
u'صَابَ لِصٌّ':Subject, #1: 1	أَصَابَ اللِّثَةَ
u'صَابَ لَطِيم':Predicate, #1: 1	أَصَابَ اللِّصُّ
u'صَابَ لعاب':Subject, #1: 1	أَصَابَ لَطِيمَةً
u'صَابَ لُعَابٌ':Subject, #1: 1	أَصَابَ لُعَابُ
u'صَابَ مَاءٌ':Predicate, #1: 1	أَصَابَ لُعَابُ
u'صَابَ مَاءٌ':Subject, #7: 7	أَصَابَ الْمَاءَ
u'صَابَ مَالٌ':Predicate, #7: 7	أَصَابَ الْمَاءُ
u'صَابَ مَالٌ':Predicate, #1: 1	أَصَابَ مَالاً
u'صَابَ مَبِيعٌ':Predicate, #2: 2	أَصَابَ الْمَالَ
u'صَابَ مثل':Predicate, #1: 1	أَصَابَ الْمَبِيعَ
u'صَابَ مِثْلٌ':Predicate, #1: 1	أَصَابَ مِثْلَ
u'صَابَ مُحَابَاةٌ':Predicate, #1: 1	أَصَابَ مِثْلَ
u'صَابَ مُحْتَاجٌ':Predicate, #5: 5	أَصَابَ الْمُحَابَاةَ
u'صَابَ مُحْرِمٌ':Predicate, #1: 1	أَصَابَ الْمُحْتَاجِينَ
u'صَابَ مُحْرِمٌ':Subject, #1: 1	أَصَابَ الْمُحْرِمَ
u'صَابَ مُحْرِمٌ':Subject, #2: 2	أَصَابَ مُحْرِمٌ
u'صَابَ مَحَلٌّ':Predicate, #3: 3	أَصَابَ الْمُحْرِمُ
u'صَابَ مَدْيُونٌ':Predicate, #1: 1	أَصَابَ الْمَحَلَّ
u'صَابَ مَذْبَحٌ':Predicate, #1: 1	أَصَابَ الْمَدْيُونَ
u'صَابَ مَرِيضٌ':Predicate, #3: 3	أَصَابَ الْمَذْبَحَ
u'صَابَ مُزَارِعٌ':Subject, #1: 1	أَصَابَ الْمَرِيضَ
u'صَابَ مُسْتَحَقٌّ':Predicate, #2: 2	أَصَابَ الْمُزَارِعُ
u'صَابَ مُسْتَحِقٌّ':Predicate, #1: 1	أَصَابَ الْمُسْتَحَقَّ
u'صَابَ مُسْلِمٌ':Predicate, #3: 3	أَصَابَ الْمُسْتَحِقَّ
u'صَابَ مُسْلِمٌ':Predicate, #1: 1	أَصَابَ الْمُسْلِمَ
u'صَابَ مُسْلِمٌ':Predicate, #1: 1	أَصَابَ الْمُسْلِمِينَ
u'صَابَ مُسْلِمٌ':Subject, #4: 4	أَصَابَ مُسْلِمَةً
u'صَابَ مَسْمُوعٌ':Predicate, #1: 1	أَصَابَ الْمُسْلِمُ
u'صَابَ مُضَارِبٌ':Predicate, #2: 2	أَصَابَ الْمَسْمُوعَ
u'صَابَ مُضَارِبٌ':Subject, #1: 1	أَصَابَ الْمُضَارِبَ
u'صَابَ مَضْمُونٌ':Predicate, #1: 1	أَصَابَ الْمُضَارِبُ
u'صَابَ مَعِدَةٌ':Predicate, #1: 1	أَصَابَ الْمَضْمُونَ
u'صَابَ مَعْدِنٌ':Predicate, #1: 1	أَصَابَ الْمَعِدَةَ
u'صَابَ مِعْراض':Predicate, #1: 1	أَصَابَ مَعْدِنَ
u'صَابَ مِعْراض':Subject, #1: 1	أَصَابَ الْمِعْرَاضَ
u'صَابَ مَعْمُولٌ':Subject, #1: 1	أَصَابَ الْمِعْرَاضُ
u'صَابَ مَقْتَلٌ':Predicate, #1: 1	أَصَابَ الْمَعْمُولُ
u'صَابَ مُقَدَّمٌ':Subject, #2: 2	أَصَابَ الْمَقْتَلَ
u'صَابَ مَنِيٌّ':Subject, #1: 1	أَصَابَ الْمُقَدَّمَةُ
u'صَابَ مَهْرٌ':Predicate, #1: 1	أَصَابَ الْمَنِيُّ
u'صَابَ مَهْرٌ':Predicate, #6: 6	أَصَابَ الْمَهْرَ
u'صَابَ مَوْتٌ':Subject, #9: 9	أَصَابَ مَهْرَ
u'صَابَ مَوْضِعٌ':Predicate, #1: 1	أَصَابَ الْمَوْتُ
u'صَابَ مَوْضِعٌ':Predicate, #2: 2	أَصَابَ الْمَوْضِعَ
u'صَابَ مَوْضُوعٌ':Subject, #5: 5	أَصَابَ مَوْضِعَ
u'صَابَ مُؤْمِنٌ':Predicate, #1: 1	أَصَابَ الْمَوْضُوعُ
u'صَابَ مُؤْمِنٌ':Predicate, #1: 1	أَصَابَ الْمُؤْمِنِينَ
u'صَابَ نَاسٌ':Predicate, #2: 2	أَصَابَ الْمُؤْمِنَ
u'صَابَ نَاسٌ':Subject, #15: 15	أَصَابَ النَّاسَ
u'صَابَ نَاسٌ':Subject, #1: 1	أَصَابَ النّاسُ
u'صَابَ نَائِبٌ':Subject, #4: 4	أَصَابَ النَّاسُ
u'صَابَ نَبِيٌّ':Subject, #1: 1	أَصَابَ النَّائِبُ
u'صَابَ نَخْلٌ':Predicate, #1: 1	أَصَابَ النَّبِيُّ
u'صَابَ نِساءٌ':Predicate, #1: 1	أَصَابَ النَّخْلَ
u'صَابَ نُسُكٌ':Predicate, #2: 2	أَصَابَ النِّسَاءَ
u'صَابَ نَسْلٌ':Predicate, #5: 5	أَصَابَ النُّسُكَ
u'صَابَ نِصْفٌ':Predicate, #1: 1	أَصَابَ النَّسْلَ
u'صَابَ نَصِيبٌ':Predicate, #1: 1	أَصَابَ النِّصْفَ
u'صَابَ نَقْصٌ':Predicate, #1: 1	أَصَابَ نَصِيبَ
u'صَابَ نُقْصَانٌ':Predicate, #1: 1	أَصَابَ النَّقْصَ
u'صَابَ نَمَاءٌ':Predicate, #1: 1	أَصَابَ النُّقْصَانَ
u'صَابَ هَدَفٌ':Predicate, #4: 4	أَصَابَ النَّمَاءَ
u'صَابَ واحد':Predicate, #1: 1	أَصَابَ الْهَدَفَ
u'صَابَ وَاحِدٌ':Predicate, #1: 1	أَصَابَ الْوَاحِدَ
u'صَابَ واحد':Subject, #1: 1	أَصَابَ الْوَاحِدَ
u'صَابَ وَاحِدٌ':Subject, #2: 2	أَصَابَ وَاحِدٌ
u'صَابَ وَجَبٌ':Predicate, #2: 2	أَصَابَ وَاحِدٌ
u'صَابَ وَجْهٌ':Predicate, #1: 1	أَصَابَ وَجَبَ
u'صَابَ وُجُوبٌ':Predicate, #6: 6	أَصَابَ وَجْهَ
u'صَابَ وَرَثَةٌ':Subject, #1: 1	أَصَابَ وُجُوبَ
u'صَابَ وَصِيفٌ':Subject, #2: 2	أَصَابَ الْوَرَثَةُ
u'صَابَ وَكِيلٌ':Subject, #1: 1	أَصَابَ الْوَصِيفُ
u'صَابَ ولد':Predicate, #1: 1	أَصَابَ الْوَكِيلُ
u'صَابَ وَلَدٌ':Predicate, #4: 4	أَصَابَ الْوَلَدَ
u'صَابَ ولد':Predicate, #4: 4	أَصَابَ الْوَلَدَ
u'صَابَ وَلَدٌ':Predicate, #8: 8	أَصَابَ وَلَدَ
u'صَابَ ولد':Subject, #8: 8	أَصَابَ وَلَدَ
u'صَابَ وَلَدٌ':Subject, #2: 2	أَصَابَ الْوَلَدُ
u'صَابَ وَلِيدٌ':Predicate, #2: 2	أَصَابَ الْوَلَدُ
u'صَاحَ إِنْسانٌ':Subject, #1: 1	أَصَابَ الْوَلِيدَ
u'صَاحَبَ نَبِيٌّ':Predicate, #1: 1	صَاحَ إنْسَانٌ
u'صَاحَبَ نِيَّةٌ':Predicate, #2: 2	صَاحَبَ النَّبِيَّ
u'صَاحَ دِيكٌ':Subject, #1: 1	صَاحَبَ نِيَّةَ
u'صَاحَ صَاحِبٌ':Subject, #1: 1	صَاحَ الدِّيكُ
u'صَاحَ عَقْعَقٌ':Subject, #1: 1	صَاحَ صَاحِبُهُ
u'صَاحَ غُرَابٌ':Subject, #1: 1	صَاحَ الْعَقْعَقُ
u'صَاحَ مثل':Predicate, #1: 1	صَاحَ الْغُرَابُ
u'صَاحَ مِثْلٌ':Predicate, #2: 2	صَاحَ مِثْلَ
u'صَادَ حِمَارٌ':Predicate, #2: 2	صَاحَ مِثْلَ
u'صَادَ سَمَكٌ':Predicate, #1: 1	صَادَ الْحِمَارَ
u'صَادَ غير':Predicate, #1: 1	صَادَ سَمَكَةً
u'صَادَ غَيْرٌ':Predicate, #1: 1	صَادَ غَيْرَ
u'صَادَفَ إِحْرَامٌ':Predicate, #1: 1	صَادَ غَيْرَ
u'صَادَفَ إِذْنٌ':Predicate, #1: 1	صَادَفَ إحْرَامَ
u'صَادَفَ إِذْنٌ':Subject, #1: 1	صَادَفَ الْإِذْنَ
u'صَادَفَ الْمَرْأَةُ':Predicate, #1: 1	صَادَفَ الْإِذْنُ
u'صَادَفَ اِنْقِضاءٌ':Predicate, #1: 1	صَادَفَ الْمَرْأَةَ
u'صَادَفَ بَطْنٌ':Subject, #1: 1	صَادَفَ انْقِضَاءَ
u'صَادَفَ تَحْرِيمٌ':Predicate, #1: 1	صَادَفَ بَطْنُهُ
u'صَادَفَ تَصَرُّفٌ':Subject, #2: 2	صَادَفَ التَّحْرِيمَ
u'صَادَفَ جواري':Predicate, #1: 1	صَادَفَ تَصَرُّفُهُ
u'صَادَفَ جَوَارِي':Predicate, #1: 1	صَادَفَ الْجَوَارِيَ
u'صَادَفَ حادِي':Predicate, #1: 1	صَادَفَ الْجَوَارِيَ
u'صَادَفَ حُرْمَةٌ':Predicate, #1: 1	صَادَفَ الْحَادِيَ
u'صَادَفَ حَقٌّ':Predicate, #2: 2	صَادَفَ حُرْمَةَ
u'صَادَفَ حَقٌّ':Predicate, #1: 1	صَادَفَ حَقَّ
u'صَادَفَ خَالِصٌ':Predicate, #3: 3	صَادَفَ الْحَقَّ
u'صَادَفَ خِطَابٌ':Subject, #1: 1	صَادَفَ خَالِصَ
u'صَادَ فِرَاخٌ':Predicate, #1: 1	صَادَفَ الْخِطَابُ
u'صَادَفَ رَأْيٌ':Predicate, #1: 1	صَادَ الْفِرَاخَ
u'صَادَفَ زَمانٌ':Predicate, #1: 1	صَادَفَ رَأْيَ
u'صَادَفَ زَوالٌ':Predicate, #1: 1	صَادَفَ زَمَانَ
u'صَادَفَ سابع':Predicate, #1: 1	صَادَفَ زَوَالَ
u'صَادَفَ سَابعٌ':Predicate, #1: 1	صَادَفَ السَّابِعَ
u'صَادَفَ شُرُوطٌ':Predicate, #1: 1	صَادَفَ السَّابِعَ
u'صَادَفَ صدق':Predicate, #1: 1	صَادَفَ الشُّرُوطَ
u'صَادَفَ صِدْقٌ':Predicate, #1: 1	صَادَفَ صِدْقَ
u'صَادَفَ صَكٌّ':Predicate, #1: 1	صَادَفَ صِدْقَ
u'صَادَفَ صَلاَةٌ':Predicate, #1: 1	صَادَفَ الصَّكَّ
u'صَادَفَ صَوْمٌ':Predicate, #1: 1	صَادَفَ الصَّلَاةَ
u'صَادَفَ صَوْمٌ':Subject, #2: 2	صَادَفَ الصَّوْمَ
u'صَادَفَ صَوْمٌ':Subject, #1: 1	صَادَفَ صَوْمُ
u'صَادَفَ عَاشِرٌ':Predicate, #1: 1	صَادَفَ صَوْمُهُ
u'صَادَفَ عجز':Predicate, #1: 1	صَادَفَ الْعَاشِرَ
u'صَادَفَ عَجُزٌ':Predicate, #1: 1	صَادَفَ الْعَجُزَ
u'صَادَفَ عَقْدٌ':Subject, #1: 1	صَادَفَ الْعَجُزَ
u'صَادَفَ عَمَلٌ':Predicate, #1: 1	صَادَفَ عَقْدُهُ
u'صَادَفَ عين':Predicate, #1: 1	صَادَفَ الْعَمَلَ
u'صَادَفَ عَيْنٌ':Predicate, #1: 1	صَادَفَ عَيْنَ
u'صَادَفَ عَيْن':Predicate, #1: 1	صَادَفَ عَيْنَ
u'صَادَفَ غير':Predicate, #1: 1	صَادَفَ عَيْنَ
u'صَادَفَ غَيْرٌ':Predicate, #1: 1	صَادَفَ غَيْرَ
u'صَادَفَ فقر':Predicate, #1: 1	صَادَفَ غَيْرَ
u'صَادَفَ فَقْرٌ':Predicate, #1: 1	صَادَفَ الْفَقْرَ
u'صَادَفَ قتل':Subject, #1: 1	صَادَفَ الْفَقْرَ
u'صَادَفَ قَتْلٌ':Subject, #1: 1	صَادَفَ الْقَتْلُ
u'صَادَفَ قرع':Subject, #1: 1	صَادَفَ الْقَتْلُ
u'صَادَفَ قَرْعٌ':Subject, #1: 1	صَادَفَ الْقَرْعُ
u'صَادَفَ مُدَبَّرٌ':Predicate, #1: 1	صَادَفَ الْقَرْعُ
u'صَادَفَ مَذْبَحٌ':Predicate, #2: 2	صَادَفَ الْمُدَبَّرَ
u'صَادَفَ مِلْكٌ':Predicate, #1: 1	صَادَفَ الْمَذْبَحَ
u'صَادَفَ مِلْكٌ':Predicate, #1: 1	صَادَفَ الْمِلْكَ
u'صَادَفَ مَوْضِعٌ':Predicate, #7: 7	صَادَفَ مِلْكَ
u'صَادَفَ نَاظِرٌ':Subject, #1: 1	صَادَفَ مَوْضِعَ
u'صَادَفَ نِيَّةٌ':Predicate, #1: 1	صَادَفَ النَّاظِرُ
u'صَادَفَ وَقْتٌ':Predicate, #1: 1	صَادَفَ النِّيَّةَ
u'صَادَفَ وَقْتٌ':Predicate, #3: 3	صَادَفَ الْوَقْتَ
u'صَادَفَ يَوْمٌ':Predicate, #3: 3	صَادَفَ وَقْتَ
u'صَادَقَ شُهُودٌ':Predicate, #1: 1	صَادَفَ يَوْمَ
u'صَادَ كَلْبٌ':Subject, #1: 1	صَادَقَ الشُّهُودَ
u'صَادَ مَجُوسِيٌّ':Subject, #2: 2	صَادَ الْكَلْبُ
u'صَادَ مُحْرِمٌ':Subject, #1: 1	صَادَ الْمَجُوسِيُّ
u'صَادَ مُحَمَّدٌ':Subject, #2: 2	صَادَ الْمُحْرِمُ
u'صَادَ مُسْلِمٌ':Subject, #1: 1	صَادَ مُحَمَّدٌ
u'صَادَ مُسْلِمٌ':Subject, #1: 1	صَادَ مُسْلِمٌ
u'صَادَمَ شَرْعٌ':Predicate, #2: 2	صَادَ الْمُسْلِمُ
u'صَادَمَ هَوَاءٌ':Predicate, #1: 1	صَادَمَ الشَّرْعَ
u'صَادَ نَحْوٌ':Predicate, #1: 1	صَادَمَ الْهَوَاءَ
u'صَادَ هِرٌّ':Subject, #1: 1	صَادَ نَحْوَ
u'صَارَ إِبْطَالٌ':Subject, #1: 1	صَادَ هِرٌّ
u'صَارَ أَبْعَدُ':Predicate, #1: 1	صَارَ الْإِبْطَالُ
u'صَارَ إبْلِيسُ':Subject, #1: 1	صَارَ أَبْعَدَ
u'صَارَ اِبْنٌ':Predicate, #1: 1	صَارَ إِبْلِيسُ
u'صَارَ اِبْنٌ':Subject, #1: 1	صَارَ ابْنَ
u'صَارَ إِتْلاَفٌ':Subject, #2: 2	صَارَ ابْنُ
u'صَارَ أَجَلٌ':Subject, #1: 1	صَارَ الْإِتْلَافُ
u'صَارَ إِجْمَاعٌ':Subject, #1: 1	صَارَ الْأَجَلُ
u'صَارَ أَجْنَبِيٌّ':Subject, #2: 2	صَارَ الْإِجْمَاعُ
u'صَارَ أحَدٌ':Subject, #1: 1	صَارَ الْأَجْنَبِيُّ
u'صَارَ أَحْدَب':Predicate, #1: 1	صَارَ أَحَدُ
u'صَارَ إِحْرَامٌ':Subject, #1: 1	صَارَ أَحْدَبَ
u'صَارَ أَحَقُّ':Predicate, #1: 1	صَارَ الْإِحْرَامُ
u'صَارَ أحْمَر':Predicate, #20: 20	صَارَ أَحَقَّ
u'صَارَ أَخٌ':Subject, #1: 1	صَارَ أَحْمَرَ
u'صَارَ أخْذٌ':Subject, #2: 2	صَارَ الْأَخُ
u'صَارَ إِخْرَاجٌ':Subject, #2: 2	صَارَ أَخْذُهُ
u'صَارَ أَخَصُّ':Predicate, #1: 1	صَارَ إخْرَاجُ
u'صَارَ أَدَاءٌ':Subject, #3: 3	صَارَ أَخَصَّ
u'صَارَ إِذْنٌ':Subject, #1: 1	صَارَ أَدَاءُ
u'صَارَ اِسْتِعْمالٌ':Subject, #1: 1	صَارَ الْإِذْنُ
u'صَارَ اِسْمٌ':Subject, #1: 1	صَارَ اسْتِعْمَالُهُ
u'صَارَ أُسْوَةٌ':Predicate, #1: 1	صَارَ اسْمُهُ
u'صَارَ أسْوَد':Predicate, #1: 1	صَارَ أُسْوَةَ
u'صَارَ أَسيرٌ':Predicate, #1: 1	صَارَ أَسْوَدَ
u'صَارَ أَسيرٌ':Subject, #1: 1	صَارَ أَسِيرَ
u'صَارَ أصل':Subject, #2: 2	صَارَ الْأَسِيرُ
u'صَارَ أًصْلٌ':Subject, #5: 5	صَارَ الْأَصْلُ
u'صَارَ أظهر':Subject, #5: 5	صَارَ الْأَصْلُ
u'صَارَ اِعْتِقادٌ':Subject, #1: 1	صَارَ الْأَظْهَرُ
u'صَارَ إعْزَازٌ':Subject, #1: 1	صَارَ اعْتِقَادُ
u'صَارَ إقْرَارٌ':Subject, #1: 1	صَارَ الْإِعْزَازُ
u'صَارَ أقَلُّ':Predicate, #1: 1	صَارَ إقْرَارُهُ
u'صَارَ أَكْثَرُ':Predicate, #1: 1	صَارَ أَقَلَّ
u'صَارَ أَكْثَرُ':Subject, #1: 1	صَارَ الْأَكْثَرَ
u'صَارَ أَكْثَرُ':Subject, #1: 1	صَارَ أَكْثَرُ
u'صَارَ أَلْثَغ':Predicate, #2: 2	صَارَ الْأَكْثَرُ
u'صَارَ أُمٌّ':Predicate, #4: 4	صَارَ أَلْثَغَ
u'صَارَ إمَامٌ':Predicate, #5: 5	صَارَ أُمَّ
u'صَارَ إمَامٌ':Subject, #1: 1	صَارَ إمَامَ
u'صَارَ أَمْرٌ':Subject, #2: 2	صَارَ الْإِمَامُ
u'صَارَ آمِرٌ':Subject, #16: 16	صَارَ الْأَمْرُ
u'صَارَ أَمْرٌ':Subject, #1: 1	صَارَ الْآمِرُ
u'صَارَ إِمْضاءٌ':Subject, #1: 1	صَارَ الأَمْرُ
u'صَارَ أَمْلَس':Predicate, #1: 1	صَارَ إمْضَاءُ
u'صَارَ أُمِّيٌّ':Subject, #1: 1	صَارَ أَمْلَسَ
u'صَارَ أهْلٌ':Subject, #2: 2	صَارَ الْأُمِّيُّ
u'صَارَ أَوَّلُ':Predicate, #3: 3	صَارَ أَهْلُ
u'صَارَ أَوَّلُ':Subject, #1: 1	صَارَ أَوَّلَ
u'صَارَ أَوْلاَدٌ':Subject, #4: 4	صَارَ الْأَوَّلُ
u'صَارَ إيمَانٌ':Subject, #1: 1	صَارَ أَوْلَادُ
u'صَارَ بَائِعٌ':Subject, #2: 2	صَارَ إيمَانُهُ
u'صَارَ بَدَلٌ':Subject, #6: 6	صَارَ الْبَائِعُ
u'صَارَ بدن':Subject, #1: 1	صَارَ الْبَدَلُ
u'صَارَ بَدَنٌ':Subject, #1: 1	صَارَ الْبَدَنُ
u'صَارَ بَعْضٌ':Subject, #1: 1	صَارَ الْبَدَنُ
u'صَارَ بَلاءٌ':Subject, #7: 7	صَارَ بَعْضُ
u'صَارَ بِنَاءٌ':Subject, #1: 1	صَارَ الْبَلَاءُ
u'صَارَ بَيْعٌ':Subject, #1: 1	صَارَ الْبِنَاءُ
u'صَارَ تَحَدُّثٌ':Subject, #1: 1	صَارَ الْبَيْعُ
u'صَارَ تَدْبِيرٌ':Subject, #1: 1	صَارَ التَّحَدُّثُ
u'صَارَ تُرَابٌ':Subject, #1: 1	صَارَ التَّدْبِيرُ
u'صَارَ تَرْكٌ':Subject, #1: 1	صَارَ التُّرَابُ
u'صَارَ تَرْكٌ':Subject, #2: 2	صَارَ تَرْكُهُ
u'صَارَ تَشْرِيعٌ':Subject, #3: 3	صَارَ تَرْكُ
u'صَارَ تَصْدِيقٌ':Subject, #1: 1	صَارَ التَّشْرِيعُ
u'صَارَ تَطْلِيقٌ':Subject, #1: 1	صَارَ التَّصْدِيقُ
u'صَارَ تَفاوُت':Subject, #1: 1	صَارَ التَّطْلِيقُ
u'صَارَ تَقْديرٌ':Subject, #1: 1	صَارَ التَّفَاوُتُ
u'صَارَ تَقْديرٌ':Subject, #1: 1	صَارَ التَّقْدِيرُ
u'صَارَ ثَابِتٌ':Subject, #1: 1	صَارَ تَقْدِيرُ
u'صَارَ ثَالِثٌ':Subject, #1: 1	صَارَ الثَّابِتُ
u'صَارَ ثَرِيدٌ':Subject, #3: 3	صَارَ الثَّالِثُ
u'صَارَ ثَلاثَةٌ':Predicate, #1: 1	صَارَ الثَّرِيدُ
u'صَارَ ثَمانِيَةٌ':Predicate, #1: 1	صَارَ ثَلَاثَةَ
u'صَارَ ثَمَنٌ':Subject, #1: 1	صَارَ ثَمَانِيَةَ
u'صَارَ ثَمَنٌ':Subject, #11: 11	صَارَ الثَّمَنُ
u'صَارَ ثَوْبٌ':Subject, #1: 1	صَارَ ثَمَنُهُ
u'صَارَ ثَوْبٌ':Subject, #1: 1	صَارَ ثَوْبٌ
u'صَارَ جَاهِلٌ':Subject, #2: 2	صَارَ الثَّوْبُ
u'صَارَ جَبَلٌ':Subject, #1: 1	صَارَ الْجَاهِلُ
u'صَارَ جُزْءٌ':Subject, #1: 1	صَارَ الْجَبَلُ
u'صَارَ جلد':Subject, #1: 1	صَارَ جُزْءٌ
u'صَارَ جِلْدٌ':Subject, #1: 1	صَارَ جِلْدُهُ
u'صَارَ جَمَاعَةٌ':Subject, #1: 1	صَارَ جِلْدُهُ
u'صَارَ جمع':Subject, #3: 3	صَارَ جَمَاعَةٌ
u'صَارَ جَمْعٌ':Subject, #1: 1	صَارَ الْجَمْعُ
u'صَارَ جُمْهُورٌ':Subject, #1: 1	صَارَ الْجَمْعُ
u'صَارَ جَمِيع':Subject, #1: 1	صَارَ جُمْهُورُ
u'صَارَ جهل':Subject, #4: 4	صَارَ الْجَمِيعُ
u'صَارَ جَهْلٌ':Subject, #1: 1	صَارَ الْجَهْلُ
u'صَارَ جَوَابٌ':Subject, #1: 1	صَارَ الْجَهْلُ
u'صَارَ حادِثٌ':Predicate, #1: 1	صَارَ الْجَوَابُ
u'صَارَ حاصِلٌ':Subject, #1: 1	صَارَ حَادِثَةَ
u'صَارَ حالٌ':Subject, #1: 1	صَارَ الْحَاصِلُ
u'صَارَ حالٌ':Subject, #1: 1	صَارَ حَالُ
u'صَارَ حالٌ':Subject, #1: 1	صَارَ حَالُهُ
u'صَارَ حامِلٌ':Predicate, #4: 4	صَارَ الْحَالُ
u'صَارَ حائِطٌ':Subject, #1: 1	صَارَ حَامِلَ
u'صَارَ حَبٌّ':Subject, #1: 1	صَارَ الْحَائِطُ
u'صَارَ حَجٌّ':Subject, #1: 1	صَارَ الْحَبُّ
u'صَارَ حَجٌّ':Subject, #1: 1	صَارَ الْحَجُّ
u'صَارَ حَديثٌ':Subject, #1: 1	صَارَ حَجُّهُ
u'صَارَ حُرٌّ':Subject, #5: 5	صَارَ الْحَدِيثُ
u'صَارَ حَقٌّ':Predicate, #1: 1	صَارَ الْحُرُّ
u'صَارَ حَقٌّ':Subject, #1: 1	صَارَ حَقَّ
u'صَارَ حَقٌّ':Subject, #2: 2	صَارَ الْحَقُّ
u'صَارَ حُكْمٌ':Subject, #3: 3	صَارَ حَقُّ
u'صَارَ حُكْمٌ':Subject, #14: 14	صَارَ حُكْمُهُ
u'صَارَ حُكْمٌ':Subject, #1: 1	صَارَ الْحُكْمُ
u'صَارَ حَمْلٌ':Subject, #1: 1	صَارَ حُكْمُ
u'صَارَ حَيٌّ':Subject, #1: 1	صَارَ الْحَمْلُ
u'صَارَ خَارِجٌ':Predicate, #1: 1	صَارَ الْحَيُّ
u'صَارَ خَبَرٌ':Subject, #1: 1	صَارَ خَارِجَ
u'صَارَ خَبَر':Subject, #2: 2	صَارَ الْخَبَرُ
u'صَارَ خُرُوجٌ':Subject, #2: 2	صَارَ الْخَبَرُ
u'صَارَ خُرُوجٌ':Subject, #1: 1	صَارَ خُرُوجُ
u'صَارَ خِلاَفٌ':Subject, #2: 2	صَارَ الْخُرُوجُ
u'صَارَ خَلَلٌ':Subject, #1: 1	صَارَ الْخِلَافُ
u'صَارَ خَمْرٌ':Subject, #1: 1	صَارَ الْخَلَلُ
u'صَارَ خَمْسَةٌ':Predicate, #8: 8	صَارَ الْخَمْرُ
u'صَارَ خَمِيسٌ':Subject, #1: 1	صَارَ خَمْسَةَ
u'صَارَ خيار':Subject, #1: 1	صَارَ الْخَمِيسُ
u'صَارَ خِيَارٌ':Subject, #1: 1	صَارَ الْخِيَارُ
u'صَارَ دُعَاءٌ':Subject, #1: 1	صَارَ الْخِيَارُ
u'صَارَ دَليلٌ':Subject, #2: 2	صَارَ الدُّعَاءُ
u'صَارَ دَمٌ':Subject, #2: 2	صَارَ الدَّلِيلُ
u'صَارَ دَمٌ':Subject, #1: 1	صَارَ دَمُ
u'صَارَ دَمٌ':Subject, #2: 2	صَارَ الدَّمُ
u'صَارَ دمع':Subject, #2: 2	صَارَ دَمُهُ
u'صَارَ دَمْعٌ':Subject, #1: 1	صَارَ الدّمْعُ
u'صَارَ دهماء':Subject, #1: 1	صَارَ الدّمْعُ
u'صَارَ دَهْماءُ':Subject, #1: 1	صَارَ الدَّهْمَاءُ
u'صَارَ دَيْنٌ':Subject, #1: 1	صَارَ الدَّهْمَاءُ
u'صَارَ دَيْنٌ':Subject, #1: 1	صَارَ دَيْنُ
u'صَارَ دِينارٌ':Subject, #5: 5	صَارَ الدَّيْنُ
u'صَارَ ذَكاةٌ':Subject, #1: 1	صَارَ الدِّينَارُ
u'صَارَ ذكر':Subject, #1: 1	صَارَ ذَكَاتُهُ
u'صَارَ ذُكْرٌ':Subject, #1: 1	صَارَ الذّكْرُ
u'صَارَ ذِكْرٌ':Subject, #1: 1	صَارَ الذّكْرُ
u'صَارَ ذكر':Subject, #1: 1	صَارَ الذّكْرُ
u'صَارَ ذِكْرٌ':Subject, #1: 1	صَارَ ذِكْرُهُ
u'صَارَ ذكر':Subject, #1: 1	صَارَ ذِكْرُهُ
u'صَارَ ذِكْرٌ':Subject, #3: 3	صَارَ ذِكْرُ
u'صَارَ رَأْسٌ':Subject, #3: 3	صَارَ ذِكْرُ
u'صَارَ رُبْعٌ':Subject, #4: 4	صَارَ رَأْسُ
u'صَارَ رَجُلٌ':Subject, #2: 2	صَارَ رُبْعُ
u'صَارَ رَدٌّ':Subject, #2: 2	صَارَ الرَّجُلُ
u'صَارَ رَسُولٌ':Subject, #1: 1	صَارَ رَدُّ
u'صَارَ رَهْنٌ':Subject, #1: 1	صَارَ الرَّسُولُ
u'صَارَ زَارِعٌ':Subject, #3: 3	صَارَ الرَّهْنُ
u'صَارَ زائِلٌ':Predicate, #1: 1	صَارَ الزَّارِعُ
u'صَارَ زَرْعٌ':Subject, #1: 1	صَارَ زَائِلَ
u'صَارَ زَوْجٌ':Subject, #4: 4	صَارَ الزَّرْعُ
u'صَارَ سَبَبٌ':Subject, #2: 2	صَارَ الزَّوْجُ
u'صَارَ سَبْيٌ':Subject, #1: 1	صَارَ السَّبَبُ
u'صَارَ سِتٌّ':Predicate, #1: 1	صَارَ السَّبْيُ
u'صَارَ سَفِيهٌ':Subject, #1: 1	صَارَ سِتَّةً
u'صَارَ سَكْرَان':Subject, #2: 2	صَارَ السَّفِيهُ
u'صَارَ سلمة':Subject, #1: 1	صَارَ السَّكْرَانُ
u'صَارَ سَمَكٌ':Subject, #1: 1	صَارَ سَلَمَةُ
u'صَارَ سَيْفٌ':Subject, #1: 1	صَارَ السَّمَكُ
u'صَارَ سَيْل':Subject, #1: 1	صَارَ السَّيْفُ
u'صَارَ شافِعِيّ':Subject, #1: 1	صَارَ السَّيْلُ
u'صَارَ شَاهِدٌ':Subject, #2: 2	صَارَ الشَّافِعِيُّ
u'صَارَ شَاهِدٌ':Subject, #1: 1	صَارَ الشَّاهِدُ
u'صَارَ شُحٌّ':Subject, #1: 1	صَارَ شَاهِدُ
u'صَارَ شَخْصٌ':Subject, #1: 1	صَارَ الشُّحُّ
u'صَارَ شَرْطٌ':Subject, #2: 2	صَارَ الشَّخْصُ
u'صَارَ شَرْعٌ':Subject, #1: 1	صَارَ الشَّرْطُ
u'صَارَ شعار':Predicate, #1: 1	صَارَ الشَّرْعُ
u'صَارَ شِعَارٌ':Predicate, #1: 1	صَارَ شِعَارَ
u'صَارَ شُهُودٌ':Subject, #1: 1	صَارَ شِعَارَ
u'صَارَ صَاحِبٌ':Predicate, #1: 1	صَارَ الشُّهُودُ
u'صَارَ صَاحِبٌ':Subject, #12: 12	صَارَ صَاحِبَ
u'صَارَ صَاحِبٌ':Subject, #1: 1	صَارَ صَاحِبُ
u'صَارَ صَبِيٌّ':Subject, #1: 1	صَارَ صَاحِبُهُ
u'صَارَ صَحْرَاءُ':Predicate, #3: 3	صَارَ الصَّبِيُّ
u'صَارَ صَرْفٌ':Subject, #1: 1	صَارَ صَحْرَاءَ
u'صَارَ صَرْف':Subject, #1: 1	صَارَ صَرْفُ
u'صَارَ صَغِيرٌ':Predicate, #1: 1	صَارَ صَرْفُ
u'صَارَ صِفَةٌ':Subject, #2: 2	صَارَ صَغِيرَةً
u'صَارَ صَلاَةٌ':Subject, #1: 1	صَارَ صِفَةُ
u'صَارَ صَوْمٌ':Subject, #1: 1	صَارَ صَلَاةُ
u'صَارَ صَيْدٌ':Predicate, #3: 3	صَارَ الصَّوْمُ
u'صَارَ ضَامِنٌ':Subject, #1: 1	صَارَ صَيْدَ
u'صَارَ ضحك':Subject, #1: 1	صَارَ الضَّامِنُ
u'صَارَ ضَحِكٌ':Subject, #1: 1	صَارَ الضَّحِكُ
u'صَارَ ضَمَانٌ':Subject, #1: 1	صَارَ الضَّحِكُ
u'صَارَ ضَمَانٌ':Subject, #1: 1	صَارَ الضَّمَانُ
u'صَارَ ضَيَاعٌ':Subject, #1: 1	صَارَ ضَمَانُهُ
u'صَارَ طحن':Subject, #1: 1	صَارَ الضَّيَاعُ
u'صَارَ طَرِيقٌ':Subject, #1: 1	صَارَ الطَّحْنُ
u'صَارَ طعام':Subject, #1: 1	صَارَ الطَّرِيقُ
u'صَارَ طَعَامٌ':Subject, #1: 1	صَارَ طَعَامُهُ
u'صَارَ طَلاَقٌ':Subject, #1: 1	صَارَ طَعَامُهُ
u'صَارَ طِينٌ':Subject, #4: 4	صَارَ الطَّلَاقُ
u'صَارَ ظاهِرٌ':Subject, #1: 1	صَارَ الطِّينُ
u'صَارَ ظاهِرٌ':Subject, #1: 1	صَارَ ظَاهِرُهُ
u'صَارَ ظِلٌّ':Subject, #3: 3	صَارَ الظَّاهِرُ
u'صَارَ ظِلٌّ':Subject, #1: 1	صَارَ ظِلُّهُ
u'صَارَ ظِلٌّ':Subject, #35: 35	صَارَ ظِلُّ
u'صَارَ ظَهْرٌ':Subject, #9: 9	صَارَ الظِّلُّ
u'صَارَعَ أَحْداثٌ':Predicate, #1: 1	صَارَ ظَهْرُهُ
u'صَارَعَ أَحْدَاثٌ':Predicate, #1: 1	صَارَعَ الْأَحْدَاثَ
u'صَارَ عَامٌّ':Subject, #1: 1	صَارَعَ الْأَحْدَاثَ
u'صَارَ عِبَارَةٌ':Subject, #3: 3	صَارَ عَامَّةُ
u'صَارَ عَبْدٌ':Predicate, #1: 1	صَارَ عِبَارَةٌ
u'صَارَ عَبْدٌ':Subject, #1: 1	صَارَ عَبْدَ
u'صَارَ عتق':Subject, #16: 16	صَارَ الْعَبْدُ
u'صَارَ عِتْقٌ':Subject, #1: 1	صَارَ عِتْقُهُ
u'صَارَ عَتِيقٌ':Subject, #1: 1	صَارَ عِتْقُهُ
u'صَارَ عَدَدٌ':Subject, #1: 1	صَارَ الْعَتِيقُ
u'صَارَ عَدَمٌ':Subject, #1: 1	صَارَ الْعَدَدُ
u'صَارَ عِرْضٌ':Subject, #1: 1	صَارَ الْعَدَمُ
u'صَارَ عرف':Subject, #1: 1	صَارَ عِرْضُهُ
u'صَارَ عُرْفٌ':Subject, #1: 1	صَارَ الْعُرْفُ
u'صَارَ عرف':Subject, #1: 1	صَارَ الْعُرْفُ
u'صَارَ عُرْفٌ':Subject, #1: 1	صَارَ عُرْفُ
u'صَارَ عُشْرٌ':Subject, #1: 1	صَارَ عُرْفُ
u'صَارَ عَصِيرٌ':Subject, #1: 1	صَارَ الْعُشْرُ
u'صَارَ عطف':Predicate, #1: 1	صَارَ الْعَصِيرُ
u'صَارَ عَطْفٌ':Predicate, #1: 1	صَارَ عَطْفَ
u'صَارَ عَظْمٌ':Subject, #1: 1	صَارَ عَطْفَ
u'صَارَ عَقْدٌ':Subject, #1: 1	صَارَ الْعَظْمُ
u'صَارَ عِلَّةٌ':Subject, #2: 2	صَارَ الْعَقْدُ
u'صَارَ علماء':Subject, #2: 2	صَارَ عِلَّتُهُ
u'صَارَ عُلَمَاءُ':Subject, #1: 1	صَارَ الْعُلَمَاءُ
u'صَارَ عُمَرٌ':Subject, #1: 1	صَارَ الْعُلَمَاءُ
u'صَارَ عَمَلٌ':Subject, #1: 1	صَارَ عُمَرُ
u'صَارَ عَمَلٌ':Subject, #1: 1	صَارَ الْعَمَلُ
u'صَارَ عَمَلٌ':Subject, #2: 2	صَارَ عَمَلُ
u'صَارَ عِنَبٌ':Subject, #3: 3	صَارَ عَمَلُهُ
u'صَارَعَ نَبِيٌّ':Predicate, #2: 2	صَارَ الْعِنَبُ
u'صَارَعَ نَبِيٌّ':Subject, #1: 1	صَارَعَ النَّبِيَّ
u'صَارَ عند':Predicate, #3: 3	صَارَعَ النَّبِيُّ
u'صَارَ عَيْبٌ':Subject, #6: 6	صَارَ عِنْدَ
u'صَارَ عَيْشٌ':Subject, #1: 1	صَارَ الْعَيْبُ
u'صَارَ غَالِبٌ':Subject, #2: 2	صَارَ عَيْشُهُ
u'صَارَ غَائِبٌ':Subject, #1: 1	صَارَ الْغَالِبُ
u'صَارَ غُرْمٌ':Subject, #1: 1	صَارَ الْغَائِبُ
u'صَارَ غَزَالٌ':Predicate, #1: 1	صَارَ غُرْمُ
u'صَارَ غَسْلٌ':Subject, #1: 1	صَارَ الْغَزَالَ
u'صَارَ غُلاَمٌ':Subject, #1: 1	صَارَ الْغَسْلُ
u'صَارَ غير':Predicate, #2: 2	صَارَ الْغُلَامُ
u'صَارَ غَيْرٌ':Predicate, #11: 11	صَارَ غَيْرَ
u'صَارَ غير':Subject, #11: 11	صَارَ غَيْرَ
u'صَارَ غَيْرٌ':Subject, #2: 2	صَارَ غَيْرُهُ
u'صَارَ فَرْضٌ':Predicate, #2: 2	صَارَ غَيْرُهُ
u'صَارَ فَرْضٌ':Subject, #7: 7	صَارَ فَرْضَ
u'صَارَ فَرْعٌ':Subject, #3: 3	صَارَ فَرْضُهُ
u'صَارَ فَصِيلٌ':Subject, #1: 1	صَارَ الْفَرْعُ
u'صَارَ فُضُولِيٌّ':Subject, #1: 1	صَارَ الْفَصِيلُ
u'صَارَ فِطْرٌ':Subject, #1: 1	صَارَ الْفُضُولِيُّ
u'صَارَ فِعْلٌ':Subject, #1: 1	صَارَ الْفِطْرُ
u'صَارَ فِعْلٌ':Subject, #1: 1	صَارَ الْفِعْلُ
u'صَارَ فِقْهٌ':Subject, #1: 1	صَارَ فِعْلُ
u'صَارَ فقهاء':Subject, #3: 3	صَارَ الْفِقْهُ
u'صَارَ فلان':Subject, #1: 1	صَارَ الْفُقَهَاءُ
u'صَارَفَ وَكِيلٌ':Subject, #2: 2	صَارَ الشَّافِعِيُّ
u'صَارَ فَيْءٌ':Subject, #1: 1	صَارَفَ الْوَكِيلُ
u'صَارَ قتل':Subject, #2: 2	صَارَ الْفَيْءُ
u'صَارَ قَتْلٌ':Subject, #3: 3	صَارَ الْقَتْلُ
u'صَارَ قُدَّامٌ':Predicate, #3: 3	صَارَ الْقَتْلُ
u'صَارَ قَدْرٌ':Subject, #1: 1	صَارَ قُدَّامَ
u'صَارَ قذف':Subject, #1: 1	صَارَ قَدْرُ
u'صَارَ قَذْفٌ':Subject, #1: 1	صَارَ الْقَذْفُ
u'صَارَ قرار':Subject, #1: 1	صَارَ الْقَذْفُ
u'صَارَ قَرَارٌ':Subject, #1: 1	صَارَ قَرَارُ
u'صَارَ قُرْصٌ':Subject, #1: 1	صَارَ قَرَارُ
u'صَارَ قصاص':Subject, #2: 2	صَارَ الْقُرْصُ
u'صَارَ قِصَاصٌ':Subject, #1: 1	صَارَ الْقِصَاصُ
u'صَارَ قَضَاءٌ':Subject, #1: 1	صَارَ الْقِصَاصُ
u'صَارَ قلب':Subject, #1: 1	صَارَ الْقَضَاءُ
u'صَارَ قَلْبٌ':Subject, #1: 1	صَارَ الْقَلْبُ
u'صَارَ قَلْب':Subject, #1: 1	صَارَ الْقَلْبُ
u'صَارَ قلب':Subject, #1: 1	صَارَ الْقَلْبُ
u'صَارَ قَلْبٌ':Subject, #1: 1	صَارَ قَلْبُ
u'صَارَ قَلْب':Subject, #1: 1	صَارَ قَلْبُ
u'صَارَ قول':Subject, #1: 1	صَارَ قَلْبُ
u'صَارَ قَوْلٌ':Subject, #1: 1	صَارَ الْقَوْلُ
u'صَارَ قول':Subject, #1: 1	صَارَ الْقَوْلُ
u'صَارَ قَوْلٌ':Subject, #4: 4	صَارَ قَوْلُهُ
u'صَارَ قِيَاسٌ':Subject, #4: 4	صَارَ قَوْلُهُ
u'صَارَ قيام':Subject, #1: 1	صَارَ الْقِيَاسُ
u'صَارَ قِيَامٌ':Subject, #1: 1	صَارَ قِيَامُهُ
u'صَارَ قِيمَةٌ':Subject, #1: 1	صَارَ قِيَامُهُ
u'صَارَ كِرْباس':Subject, #1: 1	صَارَ قِيمَةُ
u'صَارَ كَسْبٌ':Subject, #1: 1	صَارَ الْكِرْبَاسُ
u'صَارَ كَفِيلٌ':Subject, #1: 1	صَارَ الْكَسْبُ
u'صَارَ كَلاَمٌ':Subject, #1: 1	صَارَ الْكَفِيلُ
u'صَارَ كَلاَمٌ':Subject, #2: 2	صَارَ الْكَلَامُ
u'صَارَ لاَزِمٌ':Subject, #3: 3	صَارَ كَلَامُهُ
u'صَارَ لبن':Subject, #1: 1	صَارَ اللَّازِمُ
u'صَارَ لَبَنٌ':Subject, #2: 2	صَارَ اللَّبَنُ
u'صَارَ لحاق':Subject, #2: 2	صَارَ اللَّبَنُ
u'صَارَ لِحَاقٌ':Subject, #1: 1	صَارَ اللِّحَاقُ
u'صَارَ لعان':Subject, #1: 1	صَارَ اللِّحَاقُ
u'صَارَ لَفْظٌ':Subject, #1: 1	صَارَ اللِّعَانُ
u'صَارَ مَاءٌ':Subject, #4: 4	صَارَ اللَّفْظُ
u'صَارَ مَالٌ':Predicate, #30: 30	صَارَ الْمَاءُ
u'صَارَ مَالٌ':Subject, #1: 1	صَارَ مَالَ
u'صَارَ مَالٌ':Subject, #12: 12	صَارَ الْمَالُ
u'صَارَ مَالٌ':Subject, #2: 2	صَارَ مَالُ
u'صَارَ مَأْمُورٌ':Subject, #8: 8	صَارَ مَالُهُ
u'صَارَ مَأْمُولٌ':Predicate, #2: 2	صَارَ الْمَأْمُورُ
u'صَارَ مَائِعٌ':Subject, #1: 1	صَارَ مَأْمُولَ
u'صَارَ مُبَاحٌ':Predicate, #1: 1	صَارَ الْمَائِعُ
u'صَارَ مَبْنِيٌّ':Subject, #1: 1	صَارَ مُبَاحَ
u'صَارَ مَبِيعٌ':Subject, #1: 1	صَارَ الْمَبْنِيُّ
u'صَارَ مُتَعَقِّلٌ':Predicate, #1: 1	صَارَ الْمَبِيعُ
u'صَارَ مُتَعَلِّقٌ':Subject, #1: 1	صَارَ مُتَعَقِّلَ
u'صَارَ مثل':Predicate, #1: 1	صَارَ الْمُتَعَلِّقُ
u'صَارَ مِثْلٌ':Predicate, #6: 6	صَارَ مِثْلَ
u'صَارَ مِثْلِيٌّ':Subject, #6: 6	صَارَ مِثْلَ
u'صَارَ مَجَازٌ':Subject, #6: 6	صَارَ الْمِثْلِيُّ
u'صَارَ مَجْمُوعٌ':Subject, #1: 1	صَارَ الْمَجَازُ
u'صَارَ مَجْمُوعٌ':Subject, #2: 2	صَارَ مَجْمُوعُ
u'صَارَ مَجْهُولٌ':Subject, #3: 3	صَارَ الْمَجْمُوعُ
u'صَارَ مُحَرَّمٌ':Subject, #1: 1	صَارَ مَجْهُولُ
u'صَارَ مَحَلٌّ':Subject, #1: 1	صَارَ الْمُحَرَّمُ
u'صَارَ مَحَلٌّ':Subject, #1: 1	صَارَ مَحَلُّ
u'صَارَ مُحَمَّدٌ':Subject, #1: 1	صَارَ مَحَلُّهُ
u'صَارَ مُخَالِفٌ':Predicate, #1: 1	صَارَ مُحَمَّدٌ
u'صَارَ مُدَبَّرٌ':Subject, #1: 1	صَارَ مُخَالِفَ
u'صَارَ مَدْلُولٌ':Subject, #2: 2	صَارَ الْمُدَبَّرُ
u'صَارَ مَذْبُوحٌ':Subject, #1: 1	صَارَ مَدْلُولُهُ
u'صَارَ مراد':Subject, #1: 1	صَارَ الْمَذْبُوحُ
u'صَارَ مُرَادٌ':Subject, #1: 1	صَارَ مُرَادُ
u'صَارَ مراد':Subject, #1: 1	صَارَ مُرَادُ
u'صَارَ مُرَادٌ':Subject, #3: 3	صَارَ الْمُرَادُ
u'صَارَ مُرْتَهِنٌ':Subject, #3: 3	صَارَ الْمُرَادُ
u'صَارَ مَسْبُوق':Subject, #7: 7	صَارَ الْمُرْتَهِنُ
u'صَارَ مُسْتَجَابٌ':Predicate, #1: 1	صَارَ الْمَسْبُوقُ
u'صَارَ مُسْتَحَقٌّ':Predicate, #1: 1	صَارَ مُسْتَجَابَ
u'صَارَ مُسْتَعْمَلٌ':Predicate, #2: 2	صَارَ مُسْتَحَقَّ
u'صَارَ مُسْتَعِيرٌ':Subject, #1: 1	صَارَ مُسْتَعْمَلاً
u'صَارَ مَسْلَكٌ':Subject, #1: 1	صَارَ الْمُسْتَعِيرُ
u'صَارَ مُسَلَّمٌ':Subject, #3: 3	صَارَ مَسْلَكُ
u'صَارَ مُسْلِمٌ':Subject, #1: 1	صَارَ الْمُسَلَّمُ
u'صَارَ مَسْلُوبٌ':Predicate, #1: 1	صَارَ الْمُسْلِمُ
u'صَارَ مَصْبُوغ':Subject, #1: 1	صَارَ مَسْلُوبَ
u'صَارَ مُصْحَفٌ':Subject, #1: 1	صَارَ الْمَصْبُوغُ
u'صَارَ مَصْدَرٌ':Subject, #1: 1	صَارَ الْمُصْحَفُ
u'صَارَ مَصْرِفٌ':Subject, #1: 1	صَارَ الْمَصْدَرُ
u'صَارَ مَضْرُوبٌ':Subject, #1: 1	صَارَ مَصْرِفُهُ
u'صَارَ مَطْلُوبٌ':Subject, #1: 1	صَارَ الْمَضْرُوبُ
u'صَارَ مُعْظَمٌ':Subject, #1: 1	صَارَ الْمَطْلُوبُ
u'صَارَ مُعْظَمٌ':Subject, #1: 1	صَارَ مُعْظَمُ
u'صَارَ مَعْقُودٌ':Subject, #2: 2	صَارَ الْمُعْظَمُ
u'صَارَ مَعْلُولٌ':Predicate, #1: 1	صَارَ الْمَعْقُودُ
u'صَارَ مُعَيَّنٌ':Subject, #1: 1	صَارَ مَعْلُولَ
u'صَارَ مَغْصُوب':Subject, #1: 1	صَارَ الْمُعَيَّنُ
u'صَارَ مَغْلُوبٌ':Subject, #1: 1	صَارَ الْمَغْصُوبُ
u'صَارَ مَغْنَمٌ':Subject, #1: 1	صَارَ الْمَغْلُوبُ
u'صَارَ مَقْبُوضٌ':Subject, #1: 1	صَارَ الْمَغْنَمُ
u'صَارَ مَقْتُولٌ':Predicate, #1: 1	صَارَ الْمَقْبُوضُ
u'صَارَ مَقْتُولٌ':Subject, #1: 1	صَارَ مَقْتُولاً
u'صَارَ مِقْدَارٌ':Subject, #1: 1	صَارَ الْمَقْتُولُ
u'صَارَ مَكَانٌ':Predicate, #1: 1	صَارَ مِقْدَارُ
u'صَارَ مِلْكٌ':Predicate, #1: 1	صَارَ مَكَانَ
u'صَارَ مُلْكٌ':Subject, #1: 1	صَارَ مِلْكَ
u'صَارَ مِلْكٌ':Subject, #1: 1	صَارَ الْمُلْكُ
u'صَارَ مِلْكٌ':Subject, #1: 1	صَارَ مِلْكُهُ
u'صَارَ مَمْلُوكٌ':Subject, #5: 5	صَارَ الْمِلْكُ
u'صَارَ مَنْظُورٌ':Subject, #1: 1	صَارَ الْمَمْلُوكُ
u'صَارَ مُنْفَرِدٌ':Subject, #3: 3	صَارَ الْمَنْظُورُ
u'صَارَ مَنْفَعَةٌ':Subject, #1: 1	صَارَ الْمُنْفَرِدُ
u'صَارَ مُنْقَطِعٌ':Predicate, #1: 1	صَارَ الْمَنْفَعَةُ
u'صَارَ مَهْرٌ':Subject, #2: 2	صَارَ مُنْقَطِعَ
u'صَارَ مَوَاتٌ':Subject, #1: 1	صَارَ الْمَهْرُ
u'صَارَ مُؤَخِّرٌ':Subject, #1: 1	صَارَ الْمَوَاتُ
u'صَارَ مُوسِرٌ':Subject, #1: 1	صَارَ الْمُؤَخِّرُ
u'صَارَ مَوْضِعٌ':Predicate, #1: 1	صَارَ الْمُوسِرُ
u'صَارَ مَوْقُوذ':Predicate, #1: 1	صَارَ مَوْضِعَ
u'صَارَ مُوَكِّلٌ':Subject, #1: 1	صَارَ مَوْقُوذَةً
u'صَارَ مِيقَاتٌ':Subject, #1: 1	صَارَ الْمُوَكِّلُ
u'صَارَ نَاسٌ':Subject, #1: 1	صَارَ مِيقَاتُهُ
u'صَارَ نَائِبٌ':Subject, #2: 2	صَارَ النَّاسُ
u'صَارَ نَتِيجَةٌ':Predicate, #1: 1	صَارَ النَّائِبُ
u'صَارَ نَحْوٌ':Subject, #1: 1	صَارَ نَتِيجَةَ
u'صَارَ نصاب':Subject, #2: 2	صَارَ النَّحْوُ
u'صَارَ نِصَابٌ':Subject, #1: 1	صَارَ النِّصَابُ
u'صَارَ نِصْفٌ':Subject, #1: 1	صَارَ النِّصَابُ
u'صَارَ نِصْفٌ':Subject, #10: 10	صَارَ نِصْفُ
u'صَارَ نِصْفٌ':Subject, #2: 2	صَارَ النِّصْفُ
u'صَارَ نَصِيبٌ':Subject, #2: 2	صَارَ نِصْفُهُ
u'صَارَ نَصِيبٌ':Subject, #10: 10	صَارَ نَصِيبُهُ
u'صَارَ نَظِيرٌ':Predicate, #6: 6	صَارَ نَصِيبُ
u'صَارَ نَقْصٌ':Subject, #1: 1	صَارَ نَظِيرَ
u'صَارَ نكاح':Subject, #1: 1	صَارَ النَّقْصُ
u'صَارَ نِكَاحٌ':Subject, #4: 4	صَارَ النِّكَاحُ
u'صَارَ نَهْرٌ':Subject, #4: 4	صَارَ النِّكَاحُ
u'صَارَ وَاجِبٌ':Predicate, #1: 1	صَارَ النَّهْرُ
u'صَارَ واحد':Subject, #3: 3	صَارَ وَاجِبَ
u'صَارَ وَاحِدٌ':Subject, #1: 1	صَارَ الْوَاحِدُ
u'صَارَ وُجُوبٌ':Subject, #1: 1	صَارَ الْوَاحِدُ
u'صَارَ وُجُوبٌ':Subject, #1: 1	صَارَ وُجُوبُهُ
u'صَارَ وُجُودٌ':Subject, #3: 3	صَارَ الْوُجُوبُ
u'صَارَ وُجُودٌ':Subject, #5: 5	صَارَ وُجُودُ
u'صَارَ وَزْنٌ':Predicate, #5: 5	صَارَ وُجُودُهُ
u'صَارَ وَزْنٌ':Subject, #1: 1	صَارَ وَزْنَ
u'صَارَ وسط':Predicate, #1: 1	صَارَ وَزْنُهُ
u'صَارَ وَسَطٌ':Predicate, #1: 1	صَارَ وَسَطَ
u'صَارَ وَصْفٌ':Subject, #1: 1	صَارَ وَسَطَ
u'صَارَ وَصِيٌّ':Subject, #1: 1	صَارَ الْوَصْفُ
u'صَارَ وُضُوءٌ':Subject, #1: 1	صَارَ وَصِيُّ
u'صَارَ وَطْءٌ':Subject, #1: 1	صَارَ الْوُضُوءُ
u'صَارَ وَظِيفٌ':Predicate, #1: 1	صَارَ الْوَطْءُ
u'صَارَ وَظِيفَةٌ':Predicate, #1: 1	صَارَ وَظِيفَةَ
u'صَارَ وَعْدٌ':Subject, #1: 1	صَارَ وَظِيفَةَ
u'صَارَ وَقْتٌ':Subject, #1: 1	صَارَ وَعْدُهُ
u'صَارَ وَقْتٌ':Subject, #2: 2	صَارَ الْوَقْتُ
u'صَارَ وَقْفٌ':Subject, #2: 2	صَارَ وَقْتُ
u'صَارَ وَكِيلٌ':Predicate, #4: 4	صَارَ الْوَقْفُ
u'صَارَ وَكِيلٌ':Subject, #1: 1	صَارَ وَكِيلَ
u'صَارَ ولد':Subject, #4: 4	صَارَ الْوَكِيلُ
u'صَارَ وَلَدٌ':Subject, #2: 2	صَارَ الْوَلَدُ
u'صَارَ ولد':Subject, #2: 2	صَارَ الْوَلَدُ
u'صَارَ وَلَدٌ':Subject, #4: 4	صَارَ وَلَدُهُ
u'صَارَ وَلِيٌّ':Subject, #4: 4	صَارَ وَلَدُهُ
u'صَارَ يَوْمٌ':Predicate, #1: 1	صَارَ الْوَلِيُّ
u'صَارَ يَوْمٌ':Subject, #1: 1	صَارَ يَوْمَ
u'صَاعَ عُمَرٌ':Predicate, #1: 1	صَارَ الْيَوْمُ
u'صَاغَ فِضَّةٌ':Predicate, #2: 2	صَاعَ عُمَرَ
u'صَافَحَ نَبِيٌّ':Subject, #1: 1	صَاغَ الْفِضَّةَ
u'صَالَحَ أَبٌ':Predicate, #2: 2	صَافَحَ النَّبِيُّ
u'صَالَحَ أَبٌ':Subject, #1: 1	صَالَحَ الْأَبَ
u'صَالَحَ أَجْنَبِيٌّ':Subject, #2: 2	صَالَحَ الْأَبُ
u'صَالَحَ أَجْنَبِيٌّ':Subject, #1: 1	صَالَحَ أَجْنَبِيٌّ
u'صَالَحَ أحَدٌ':Predicate, #5: 5	صَالَحَ الْأَجْنَبِيُّ
u'صَالَحَ أحَدٌ':Subject, #1: 1	صَالَحَ أَحَدَ
u'صَالَحَ إِسْكافٌ':Subject, #5: 5	صَالَحَ أَحَدُ
u'صَالَحَ أَصيلٌ':Subject, #1: 1	صَالَحَ الْإِسْكَافُ
u'صَالَحَ إمَامٌ':Predicate, #2: 2	صَالَحَ الْأَصِيلُ
u'صَالَحَ إمَامٌ':Subject, #1: 1	صَالَحَ الْإِمَامَ
u'صَالَحَ آمِرٌ':Subject, #3: 3	صَالَحَ الْإِمَامُ
u'صَالَحَ أهْلٌ':Predicate, #1: 1	صَالَحَ الْآمِرُ
u'صَالَحَ أَوْلِيَاءُ':Predicate, #10: 10	صَالَحَ أَهْلَ
u'صَالَحَ أَوْلِيَاءُ':Predicate, #1: 1	صَالَحَ الْأَوْلِيَاءَ
u'صَالَحَ أَوْلِيَاءُ':Subject, #1: 1	صَالَحَ أَوْلِيَاءَ
u'صَالَحَ بَائِعٌ':Predicate, #1: 1	صَالَحَ الْأَوْلِيَاءُ
u'صَالَحَ بَائِعٌ':Subject, #3: 3	صَالَحَ الْبَائِعَ
u'صَالَحَ بَعْضٌ':Subject, #1: 1	صَالَحَ الْبَائِعُ
u'صَالَحَ جَازٌ':Predicate, #1: 1	صَالَحَ بَعْضُ
u'صَالَحَ جَانِي':Predicate, #1: 1	صَالَحَ جَازَ
u'صَالَحَ حاضِرٌ':Subject, #1: 1	صَالَحَ الْجَانِيَ
u'صَالَحَ حائِكٌ':Predicate, #1: 1	صَالَحَ الْحَاضِرُ
u'صَالَحَ حَسَنٌ':Subject, #1: 1	صَالَحَ الْحَائِكَ
u'صَالَحَ حَطِيطَةٌ':Predicate, #1: 1	صَالَحَ الْحَسَنُ
u'صَالَحَ خَالِدٌ':Subject, #1: 1	صَالَحَ الْحَطِيطَةَ
u'صَالَحَ خَمْسَةٌ':Subject, #1: 1	صَالَحَ خَالِدُ
u'صَالَحَ رَاهِنٌ':Subject, #1: 1	صَالَحَ خَمْسَةٌ
u'صَالَحَ رَبُّ':Predicate, #1: 1	صَالَحَ الرَّاهِنُ
u'صَالَحَ رِجَالٌ':Predicate, #1: 1	صَالَحَ رَبَّ
u'صَالَحَ رَجُلٌ':Predicate, #1: 1	صَالَحَ رِجَالاً
u'صَالَحَ رَجُلٌ':Subject, #1: 1	صَالَحَ الرَّجُلَ
u'صَالَحَ رَجُلٌ':Subject, #2: 2	صَالَحَ رَجُلٌ
u'صَالَحَ رَسُولٌ':Subject, #5: 5	صَالَحَ الرَّجُلُ
u'صَالَحَ سَفِيهٌ':Subject, #6: 6	صَالَحَ رَسُولُ
u'صَالَحَ سُهَيْلٌ':Predicate, #2: 2	صَالَحَ السَّفِيهُ
u'صَالَحَ شَارِبٌ':Predicate, #1: 1	صَالَحَ سُهَيْلَ
u'صَالَحَ صَاحِبٌ':Predicate, #2: 2	صَالَحَ شَارِبَ
u'صَالَحَ صَبَّاغٌ':Subject, #2: 2	صَالَحَ صَاحِبَ
u'صَالَحَ ضَامِنٌ':Subject, #1: 1	صَالَحَ الصَّبَّاغُ
u'صَالَحَ طَالِبٌ':Predicate, #1: 1	صَالَحَ الضَّامِنُ
u'صَالَحَ عَبْدٌ':Predicate, #3: 3	صَالَحَ الطَّالِبَ
u'صَالَحَ عَبْدٌ':Subject, #1: 1	صَالَحَ الْعَبْدَ
u'صَالَحَ عُمَرٌ':Subject, #4: 4	صَالَحَ الْعَبْدُ
u'صَالَحَ غَاصِبٌ':Predicate, #2: 2	صَالَحَ عُمَرُ
u'صَالَحَ غير':Subject, #1: 1	صَالَحَ الْغَاصِبَ
u'صَالَحَ غَيْرٌ':Subject, #1: 1	صَالَحَ غَيْرُ
u'صَالَحَ فُضُولِيٌّ':Subject, #1: 1	صَالَحَ غَيْرُ
u'صَالَحَ فَقِيرٌ':Subject, #2: 2	صَالَحَ الْفُضُولِيُّ
u'صَالَحَ فلان':Predicate, #1: 1	صَالَحَ الْفَقِيرُ
u'صَالَحَ قَاتِلٌ':Subject, #1: 1	صَالَحَ تُمَاضِرَ
u'صَالَحَ كَفِيلٌ':Subject, #3: 3	صَالَحَ الْقَاتِلُ
u'صَالَحَ مَأْمُورٌ':Subject, #21: 21	صَالَحَ الْكَفِيلُ
u'صَالَحَ مُتْلِفٌ':Subject, #1: 1	صَالَحَ الْمَأْمُورُ
u'صَالَحَ مَجْرُوحٌ':Subject, #1: 1	صَالَحَ مُتْلِفُ
u'صَالَحَ مُحْتَالٌ':Subject, #1: 1	صَالَحَ الْمَجْرُوحُ
u'صَالَحَ مُحِيل':Subject, #1: 1	صَالَحَ الْمُحْتَالُ
u'صَالَحَ مُدَّعِي':Predicate, #2: 2	صَالَحَ الْمُحِيلُ
u'صَالَحَ مَدْيُونٌ':Predicate, #2: 2	صَالَحَ الْمُدَّعِيَ
u'صَالَحَ مَرِيضٌ':Subject, #1: 1	صَالَحَ الْمَدْيُونَ
u'صَالَحَ مُسْتَحِقٌّ':Predicate, #1: 1	صَالَحَ الْمَرِيضُ
u'صَالَحَ مُسْلِمٌ':Subject, #1: 1	صَالَحَ الْمُسْتَحِقَّ
u'صَالَحَ مَطْلُوبٌ':Predicate, #1: 1	صَالَحَ الْمُسْلِمُ
u'صَالَحَ مَغْصُوب':Subject, #1: 1	صَالَحَ الْمَطْلُوبَ
u'صَالَحَ مَقْطُوعٌ':Subject, #1: 1	صَالَحَ الْمَغْصُوبُ
u'صَالَحَ مَلِكٌ':Predicate, #1: 1	صَالَحَ مَقْطُوعٌ
u'صَالَحَ نَبِيٌّ':Subject, #1: 1	صَالَحَ مَلِكَ
u'صَالَحَ وَرَثَةٌ':Predicate, #4: 4	صَالَحَ النَّبِيُّ
u'صَالَحَ وَرَثَةٌ':Subject, #1: 1	صَالَحَ وَرَثَةَ
u'صَالَحَ وَصِيٌّ':Predicate, #3: 3	صَالَحَ الْوَرَثَةُ
u'صَالَحَ وَصِيٌّ':Subject, #1: 1	صَالَحَ الْوَصِيَّ
u'صَالَحَ وَكِيلٌ':Predicate, #1: 1	صَالَحَ الْوَصِيُّ
u'صَالَحَ وَكِيلٌ':Subject, #3: 3	صَالَحَ الْوَكِيلَ
u'صَالَحَ وَكِيلٌ':Subject, #1: 1	صَالَحَ وَكِيلُ
u'صَالَحَ وَلِيٌّ':Subject, #2: 2	صَالَحَ الْوَكِيلُ
u'صَالَحَ وَلِيٌّ':Subject, #1: 1	صَالَحَ الْوَلِيُّ
u'صَالَحَ وَلِيٌّ':Subject, #1: 1	صَالَحَ وَلِيُّهُ
u'صَالَ سَبْعٌ':Subject, #3: 3	صَالَحَ وَلِيُّ
u'صَالَ سَبُعٌ':Subject, #1: 1	صَالَ السَّبْعُ
u'صَالَ صَيْدٌ':Subject, #3: 3	صَالَ السَّبُعُ
u'صَالَ قَوْمٌ':Subject, #2: 2	صَالَ الصَّيْدُ
u'صَالَ مَبِيعٌ':Subject, #1: 1	صَالَ قَوْمٌ
u'صَالَ مَغْصُوب':Subject, #1: 1	صَالَ الْمَبِيعُ
u'صَامَ أبَدٌ':Predicate, #1: 1	صَالَ الْمَغْصُوبُ
u'صَامَ أبَدٌ':Predicate, #1: 1	صَامَ الْأَبَدَ
u'صَامَ أحَدٌ':Subject, #4: 4	صَامَ الأَبَدَ
u'صَامَ أَرْبَعَةٌ':Predicate, #2: 2	صَامَ أَحَدٌ
u'صَامَ اِزْداد':Predicate, #5: 5	صَامَ أَرْبَعَةَ
u'صَامَ أهْلٌ':Subject, #2: 2	صَامَ ازْدَادَ
u'صَامَ أيَّامٌ':Predicate, #8: 8	صَامَ أَهْلُ
u'صَامَ أَيَّامٌ':Predicate, #1: 1	صَامَ الْأَيَّامَ
u'صَامَ أيَّامٌ':Predicate, #1: 1	صَامَ الْأَيَّامَ
u'صَامَ أَيَّامٌ':Predicate, #8: 8	صَامَ أَيَّامَ
u'صَامَ ثَانِي':Predicate, #8: 8	صَامَ أَيَّامَ
u'صَامَ ثَلاثَةٌ':Predicate, #1: 1	صَامَ الثَّانِيَ
u'صَامَ ثَلاثَةٌ':Predicate, #1: 1	صَامَ الثَّلَاثَةَ
u'صَامَ ثَمانِيَةٌ':Predicate, #30: 30	صَامَ ثَلَاثَةَ
u'صَامَ جمعة':Predicate, #2: 2	صَامَ ثَمَانِيَةَ
u'صَامَ جُمُعَةٌ':Predicate, #1: 1	صَامَ الْجُمُعَةَ
u'صَامَ حَديثٌ':Predicate, #1: 1	صَامَ الْجُمُعَةَ
u'صَامَ خَمْسَةٌ':Predicate, #1: 1	صَامَ الْحَدِيثَ
u'صَامَ دَهْرٌ':Predicate, #3: 3	صَامَ خَمْسَةَ
u'صَامَ رَجُلٌ':Subject, #16: 16	صَامَ الدَّهْرَ
u'صَامَ رَسُولٌ':Subject, #3: 3	صَامَ رَجُلٌ
u'صَامَ رَمَضانُ':Predicate, #6: 6	صَامَ رَسُولُ
u'صَامَ سَبْعَةٌ':Predicate, #47: 47	صَامَ رَمَضَانَ
u'صَامَ سَبْعَةٌ':Predicate, #1: 1	صَامَ السَّبْعَةَ
u'صَامَ سِتٌّ':Predicate, #1: 1	صَامَ سَبْعَةَ
u'صَامَ سَنَةٌ':Predicate, #4: 4	صَامَ سِتَّةَ
u'صَامَ شَعْبَانُ':Predicate, #2: 2	صَامَ السَّنَةَ
u'صَامَ شَهْرٌ':Predicate, #5: 5	صَامَ شَعْبَانَ
u'صَامَ شَهْرٌ':Predicate, #2: 2	صَامَ شَهْرَ
u'صَامَ شَوَّالٌ':Predicate, #3: 3	صَامَ الشَّهْرَ
u'صَامَ صَاعٌ':Subject, #1: 1	صَامَ شَوَّالَ
u'صَامَ صَبِيٌّ':Subject, #1: 1	صَامَ صَاعُ
u'صَامَ صَوْمٌ':Predicate, #1: 1	صَامَ الصَّبِيُّ
u'صَامَ عَاجِزٌ':Subject, #1: 1	صَامَ الصَّوْمَ
u'صَامَ عَاشُورَاءُ':Predicate, #1: 1	صَامَ الْعَاجِزُ
u'صَامَ عَامٌ':Predicate, #3: 3	صَامَ عَاشُورَاءَ
u'صَامَ عَبْدٌ':Subject, #1: 1	صَامَ الْعَامَ
u'صَامَ عَشْرٌ':Predicate, #3: 3	صَامَ الْعَبْدُ
u'صَامَ عَشْرٌ':Predicate, #1: 1	صَامَ عَشْرَةً
u'صَامَ عِيدٌ':Predicate, #4: 4	صَامَ عَشْرَةَ
u'صَامَ غير':Subject, #2: 2	صَامَ الْعِيدَ
u'صَامَ غَيْرٌ':Subject, #1: 1	صَامَ غَيْرُهُ
u'صَامَ فَرَسٌ':Subject, #1: 1	صَامَ غَيْرُهُ
u'صَامَ فَقِيرٌ':Subject, #1: 1	صَامَ الْفَرَسُ
u'صَامَ فُلاَنٌ':Subject, #1: 1	صَامَ الْفَقِيرُ
u'صَامَ قَرِيبٌ':Subject, #2: 2	صَامَ فُلاَنٌ
u'صَامَ قَضَاءٌ':Predicate, #2: 2	صَامَ الْقَرِيبُ
u'صَامَ مُتَمَتِّعٌ':Subject, #1: 1	صَامَ قَضَاءَ
u'صَامَ مَرِيضٌ':Subject, #2: 2	صَامَ الْمُتَمَتِّعُ
u'صَامَ مُسَافِرٌ':Subject, #2: 2	صَامَ الْمَرِيضُ
u'صَامَ مُعْسِرٌ':Subject, #2: 2	صَامَ الْمُسَافِرُ
u'صَامَ مُفْسِدٌ':Subject, #3: 3	صَامَ الْمُعْسِرُ
u'صَامَ مَكَانٌ':Predicate, #1: 1	صَامَ الْمُفْسِدُ
u'صَامَ نهار':Subject, #4: 4	صَامَ مَكَانَ
u'صَامَ نَهَارٌ':Subject, #1: 1	صَامَ النَّهَارُ
u'صَامَ وَجَبٌ':Predicate, #1: 1	صَامَ النَّهَارُ
u'صَامَ يَوْمٌ':Predicate, #1: 1	صَامَ وَجَبَ
u'صَامَ يَوْمٌ':Predicate, #22: 22	صَامَ يَوْمَ
u'صَانَ إِحْرَامٌ':Predicate, #2: 2	صَامَ الْيَوْمَ
u'صَانَ حَرائِرُ':Predicate, #1: 1	صَانَ الْإِحْرَامَ
u'صَانَ حَرَائِرُ':Predicate, #1: 1	صَانَ الْحَرَائِرَ
u'صَانَ خَلْوَةٌ':Predicate, #1: 1	صَانَ الْحَرَائِرَ
u'صَانَ شَرْعٌ':Subject, #1: 1	صَانَ خَلْوَةَ
u'صَبَابَةٌ وَجْدٌ':Added, #2: 2	صَانَ الشَّرْعُ
u'صَبَأَ ثُمام':Subject, #1: 1	صَبَابَةَ وَجْدٍ
u'صَبَاحَةٌ وَجْهٌ':Added, #1: 1	صَبَأَ ثُمَامَةُ
u'صَبَاحَةٌ وَجْهٌ':Added, #1: 1	صَبَاحَةَ الْوَجْهِ
u'صَبَا عُمَرٌ':Subject, #1: 1	صَبَاحَةِ الْوَجْهِ
u'صَبَأَ عُمَرٌ':Subject, #1: 1	صَبَا عُمَرُ
u'صَبَأَ قَالٌ':Predicate, #4: 4	صَبَأَ عُمَرُ
u'صَبَا قَالٌ':Predicate, #1: 1	صَبَأَ قَالَ
u'صَبَّ بَائِعٌ':Subject, #1: 1	صَبَا قَالَ
u'صَبَّ ثَانِي':Predicate, #2: 2	صَبَّ الْبَائِعُ
u'صَبَحَ خَبِيث':Predicate, #1: 1	صَبَّ الثَّانِيَ
u'صَبِحَ خَبِيث':Predicate, #6: 6	أَصْبَحَ خَبِيثَ
u'صَبَحَ دَخَلٌ':Predicate, #6: 6	أَصْبَحَ خَبِيثَ
u'صَبِحَ دَخَلٌ':Predicate, #3: 3	أَصْبَحَ دَخَلَ
u'صَبَحَ ذكر':Predicate, #3: 3	أَصْبَحَ دَخَلَ
u'صَبِحَ ذكر':Predicate, #1: 1	أَصْبَحَ ذَكَرَ
u'صَبَحَ ذَكَرٌ':Predicate, #1: 1	أَصْبَحَ ذَكَرَ
u'صَبِحَ ذَكَرٌ':Predicate, #1: 1	أَصْبَحَ ذَكَرَ
u'صَبَحَ ذكرة':Predicate, #1: 1	أَصْبَحَ ذَكَرَ
u'صَبِحَ ذكرة':Predicate, #1: 1	أَصْبَحَ ذَكَرْتهنَّ
u'صَبَّحَ رَسُولٌ':Subject, #1: 1	أَصْبَحَ ذَكَرْتهنَّ
u'صَبَحَ ركب':Predicate, #2: 2	صَبَّحَ رَسُولُ
u'صَبِحَ ركب':Predicate, #3: 3	أَصْبَحَ رَكِبَ
u'صَبَحَ شرب':Predicate, #3: 3	أَصْبَحَ رَكِبَ
u'صَبِحَ شرب':Predicate, #2: 2	أَصْبَحَ شَرِبَ
u'صَبَحَ عرف':Predicate, #2: 2	أَصْبَحَ شَرِبَ
u'صَبِحَ عرف':Predicate, #1: 1	أَصْبَحَ عَرَفَ
u'صَبَحَ عند':Predicate, #1: 1	أَصْبَحَ عَرَفَ
u'صَبِحَ عند':Predicate, #2: 2	أَصْبَحَ عِنْدَ
u'صَبَحَ غير':Predicate, #2: 2	أَصْبَحَ عِنْدَ
u'صَبِحَ غير':Predicate, #6: 6	أَصْبَحَ غَيْرَ
u'صَبَحَ غَيْرٌ':Predicate, #6: 6	أَصْبَحَ غَيْرَ
u'صَبِحَ غَيْرٌ':Predicate, #6: 6	أَصْبَحَ غَيْرَ
u'صَبَّحَ فلان':Predicate, #6: 6	أَصْبَحَ غَيْرَ
u'صَبَحَ قَالٌ':Predicate, #1: 1	صَبَّحَ خَيْبَرَ
u'صَبِحَ قَالٌ':Predicate, #9: 9	أَصْبَحَ قَالَ
u'صَبَّحَ نَبِيٌّ':Subject, #9: 9	أَصْبَحَ قَالَ
u'صَبَّ حِنْطَةٌ':Predicate, #1: 1	صَبَّحَ النَّبِيُّ
u'صَبَحَ نَظَرٌ':Predicate, #2: 2	صَبَّ الْحِنْطَةَ
u'صَبِحَ نَظَرٌ':Predicate, #1: 1	أَصْبَحَ نَظَرَ
u'صَبَحَ وقع':Predicate, #1: 1	أَصْبَحَ نَظَرَ
u'صَبِحَ وقع':Predicate, #1: 1	أَصْبَحَ وَقَعَ
u'صَبَحَ يَوْمٌ':Predicate, #1: 1	أَصْبَحَ وَقَعَ
u'صَبِحَ يَوْمٌ':Predicate, #5: 5	أَصْبَحَ الْيَوْمَ
u'صَبَحَ يَوْمٌ':Predicate, #5: 5	أَصْبَحَ الْيَوْمَ
u'صَبِحَ يَوْمٌ':Predicate, #8: 8	أَصْبَحَ يَوْمَ
u'صَبَّ خَمْرٌ':Predicate, #8: 8	أَصْبَحَ يَوْمَ
u'صَبَّ دَلْوٌ':Predicate, #1: 1	صَبَّ الْخَمْرَ
u'صَبَّ دُهْنٌ':Predicate, #3: 3	صَبَّ الدَّلْوَ
u'صَبَّ دَواءٌ':Predicate, #4: 4	صَبَّ الدُّهْنَ
u'صبر اِسْتِطاعَةٌ':Added, #2: 2	صَبَّ الدَّوَاءَ
u'صَبْرٌ اِسْتِطاعَةٌ':Added, #1: 1	صَبْرَ اسْتِطَاعَةٍ
u'صبر أيَّامٌ':Added, #1: 1	صَبْرَ اسْتِطَاعَةٍ
u'صبر أَيَّامٌ':Added, #1: 1	صَبْرُ أَيَّامِ
u'صَبْرٌ أيَّامٌ':Added, #1: 1	صَبْرُ أَيَّامِ
u'صَبْرٌ أَيَّامٌ':Added, #1: 1	صَبْرُ أَيَّامِ
u'صبر بَهائِمُ':Added, #1: 1	صَبْرُ أَيَّامِ
u'صَبْرٌ بَهائِمُ':Added, #1: 1	صَبْرِ الْبَهَائِمِ
u'صَبَّ رَجُلٌ':Subject, #1: 1	صَبْرِ الْبَهَائِمِ
u'صبر خَصْمٌ':Added, #1: 1	صَبَّ رَجُلٌ
u'صَبْرٌ خَصْمٌ':Added, #1: 1	صَبْرِ الْخَصْمِ
u'صبر دَابَّةٌ':Added, #1: 1	صَبْرِ الْخَصْمِ
u'صَبْرٌ دَابَّةٌ':Added, #3: 3	صَبْرِ الدَّابَّةِ
u'صبر روحٌ':Added, #3: 3	صَبْرِ الدَّابَّةِ
u'صَبْرٌ روحٌ':Added, #4: 4	صَبْرِ الرُّوحِ
u'صبر ضَرٌّ':Added, #4: 4	صَبْرِ الرُّوحِ
u'صَبْرٌ ضَرٌّ':Added, #1: 1	صَبْرِ ضَرٍّ
u'صَبَرَ ظَمْآن':Subject, #1: 1	صَبْرِ ضَرٍّ
u'صَبَرَ فُلاَنٌ':Subject, #1: 1	صَبَرَ الظَّمْآنُ
u'صبر فلان':Added, #1: 1	صَبَرَ فُلَانٌ
u'صَبْرٌ فلان':Added, #1: 1	صَبْرَ الزُّبَيْرِ
u'صَبَرَ قَدَرٌ':Predicate, #1: 1	صَبْرَ الزُّبَيْرِ
u'صبر كَافِرٌ':Added, #1: 1	صَبَرَ قَدَرَ
u'صَبْرٌ كَافِرٌ':Added, #1: 1	صَبْرِ الْكَافِرِ
u'صبر مَحَلٌّ':Added, #1: 1	صَبْرِ الْكَافِرِ
u'صَبْرٌ مَحَلٌّ':Added, #1: 1	صَبْرِ الْمَحَلِّ
u'صبر مُسَافِرٌ':Added, #1: 1	صَبْرِ الْمَحَلِّ
u'صَبْرٌ مُسَافِرٌ':Added, #1: 1	صَبْرِ الْمُسَافِرِ
u'صبر مُكْرَهٌ':Added, #1: 1	صَبْرِ الْمُسَافِرِ
u'صَبْرٌ مُكْرَهٌ':Added, #1: 1	صَبْرِ الْمُكْرَهِ
u'صبر نَاسٌ':Added, #1: 1	صَبْرِ الْمُكْرَهِ
u'صَبْرٌ نَاسٌ':Added, #1: 1	صَبْرِ النَّاسِ
u'صَبَرَ وَلِيٌّ':Subject, #1: 1	صَبْرِ النَّاسِ
u'صبر وَلِيٌّ':Added, #1: 1	صَبَرَ وَلِيُّ
u'صَبْرٌ وَلِيٌّ':Added, #1: 1	صَبْرُ الْوَلِيِّ
u'صبر يَمِينٌ':Added, #1: 1	صَبْرُ الْوَلِيِّ
u'صَبْرٌ يَمِينٌ':Added, #1: 1	صَبْرَ الْيَمِينِ
u'صَبَّ سَوِيق':Predicate, #1: 1	صَبْرَ الْيَمِينِ
u'صَبْغٌ إِنْسانٌ':Added, #1: 1	صَبَّ السَّوِيقَ
u'صَبَغَ ثَوْبٌ':Predicate, #2: 2	صَبْغِ إنْسَانٍ
u'صَبَغَ ثَوْبٌ':Predicate, #15: 15	صَبَغَ الثَّوْبَ
u'صَبْغٌ ثَوْبٌ':Added, #1: 1	صَبَغَ ثَوْبَ
u'صَبْغٌ ثَوْبٌ':Added, #12: 12	صَبْغِ الثَّوْبِ
u'صَبْغٌ ثَوْبٌ':Added, #1: 1	صَبْغِ ثَوْبٍ
u'صَبْغٌ ثِيابٌ':Added, #2: 2	صَبْغِ ثَوْبِهِ
u'صَبْغٌ حِبْرٌ':Added, #1: 1	صَبْغُ الثِّيَابِ
u'صَبْغٌ خُبْزٌ':Added, #1: 1	صَبْغَ الْحِبْرِ
u'صَبَغَ رَاهِنٌ':Subject, #1: 1	صَبْغُ الْخُبْزِ
u'صَبْغٌ شَيْءٌ':Added, #1: 1	صَبَغَ الرَّاهِنُ
u'صَبْغٌ شيب':Added, #1: 1	صَبْغِ شَيْءٍ
u'صَبْغٌ شَيْبٌ':Added, #1: 1	صَبْغِ الشَّيْبِ
u'صَبَغَ صَبَّاغٌ':Subject, #1: 1	صَبْغِ الشَّيْبِ
u'صَبَغَ غَاصِبٌ':Subject, #1: 1	صَبَغَ الصَّبَّاغُ
u'صَبْغٌ غير':Added, #1: 1	صَبَغَ الْغَاصِبُ
u'صَبْغٌ غَيْرٌ':Added, #1: 1	صَبْغِ غَيْرِهِ
u'صَبَغَ فَمٌ':Predicate, #1: 1	صَبْغِ غَيْرِهِ
u'صَبْغٌ قَائِمٌ':Added, #1: 1	صَبَغَ الْفَمَ
u'صَبَغَ مَغْصُوب':Predicate, #1: 1	صَبْغٍ قَائِمٍ
u'صَبَغَ مُفْلِسٌ':Subject, #3: 3	صَبَغَ الْمَغْصُوبَ
u'صَبَغَ ولد':Subject, #1: 1	صَبَغَ الْمُفْلِسُ
u'صَبَغَ وَلَدٌ':Subject, #1: 1	صَبَغَ الْوَلَدُ
u'صَبَّ غير':Predicate, #1: 1	صَبَغَ الْوَلَدُ
u'صَبَّ غَيْرٌ':Predicate, #1: 1	صَبَّ غَيْرَ
u'صَبْغٌ يهود':Added, #1: 1	صَبَّ غَيْرَ
u'صَبْغٌ يَهُودٌ':Added, #1: 1	صَبْغِ الْيَهُودِ
u'صَبَّ لبن':Predicate, #1: 1	صَبْغِ الْيَهُودِ
u'صَبَّ لَبَنٌ':Predicate, #1: 1	صَبَّ اللَّبَنَ
u'صَبَّ مَاءٌ':Predicate, #1: 1	صَبَّ اللَّبَنَ
u'صَبَّ مَاءٌ':Predicate, #29: 29	صَبَّ الْمَاءَ
u'صَبِيبٌ رحمة':Added, #2: 2	صَبَّ مَاءَ
u'صَبِيبٌ رَحْمَةٌ':Added, #1: 1	صَبِيبَ الرَّحْمَةِ
u'صَحَّ أَبٌ':Subject, #1: 1	صَبِيبَ الرَّحْمَةِ
u'صَحَّ إِبْطَالٌ':Subject, #1: 1	صَحَّ الْأَبُ
u'صَحَّ إِبْطَالٌ':Subject, #1: 1	صَحَّ إبْطَالُ
u'صَحَّ إجَارَةٌ':Subject, #1: 1	صَحَّ إبْطَالُهُ
u'صَحَّ اِجْتِمَاعٌ':Subject, #2: 2	صَحَّ إجَارَةُ
u'صَحَّ اِجْتِهَادٌ':Subject, #1: 1	صَحَّ اجْتِمَاعُهُ
u'صَحَّ إِجْرَاءٌ':Subject, #3: 3	صَحَّ اجْتِهَادُهُ
u'صَحَّ إِجْمَاعٌ':Subject, #1: 1	صَحَّ إجْرَاءُ
u'صَحَّ إِجْمَاعٌ':Subject, #1: 1	صَحَّ إجْمَاعٌ
u'صَحَّ إِجْمَاعٌ':Subject, #2: 2	صَحَّ إجْمَاعُ
u'صَحَّ أجمل':Predicate, #3: 3	صَحَّ الْإِجْمَاعُ
u'صَحَّ أحَدٌ':Subject, #1: 1	صَحَّ أَجْمَلَ
u'صَحَّ إِحْرَازٌ':Subject, #1: 1	صَحَّ أَحَدُ
u'صَحَّ إِحْرَامٌ':Subject, #1: 1	صَحَّ إحْرَازُهُ
u'صَحَّ إِحْرَامٌ':Subject, #1: 1	صَحَّ إحْرَامُ
u'صَحَّ إِحْرَامٌ':Subject, #2: 2	صَحَّ الْإِحْرَامُ
u'صَحَّ اِخْتِيَارٌ':Subject, #7: 7	صَحَّ إحْرَامُهُ
u'صَحَّ أخْذٌ':Subject, #3: 3	صَحَّ اخْتِيَارُهُ
u'صَحَّ إِخْرَاجٌ':Subject, #2: 2	صَحَّ أَخْذُ
u'صَحَّ أَدَاءٌ':Subject, #1: 1	صَحَّ إخْرَاجُهُ
u'صَحَّ أَدَاءٌ':Subject, #3: 3	صَحَّ الْأَدَاءُ
u'صَحَّ أَذَانٌ':Subject, #4: 4	صَحَّ أَدَاءُ
u'صَحَّ أَذَانٌ':Subject, #1: 1	صَحَّ أَذَانُ
u'صَحَّ إِذْنٌ':Subject, #3: 3	صَحَّ أَذَانُهُ
u'صَحَّ إِذْنٌ':Subject, #1: 1	صَحَّ إذْنُ
u'صَحَّ إِذْنٌ':Subject, #2: 2	صَحَّ إذْنُهُ
u'صَحَّ إِرَادَةٌ':Subject, #7: 7	صَحَّ الْإِذْنُ
u'صَحَّ اِرْتِفَاعٌ':Subject, #2: 2	صَحَّ إرَادَةُ
u'صَحَّ اِسْتِثْنَاءٌ':Subject, #1: 1	صَحَّ ارْتِفَاعُ
u'صَحَّ اِسْتِخْرَاجٌ':Subject, #7: 7	صَحَّ اسْتِثْنَاءُ
u'صَحَّ اِسْتِعانَةٌ':Subject, #1: 1	صَحَّ اسْتِخْرَاجُ
u'صَحَّ اِسْتِعْمالٌ':Subject, #1: 1	صَحَّ اسْتِعَانَةُ
u'صَحَّ اِسْتِقْراض':Subject, #2: 2	صَحَّ اسْتِعْمَالُهُ
u'صَحَّ اِسْتِئْجَارٌ':Subject, #1: 1	صَحَّ اسْتِقْرَاضُهُ
u'صَحَّ اِسْتِيلاد':Subject, #2: 2	صَحَّ اسْتِئْجَارُ
u'صَحَّ اِسْتِيلاد':Subject, #1: 1	صَحَّ اسْتِيلَادُ
u'صَحَّ إِسْقاطٌ':Subject, #1: 1	صَحَّ اسْتِيلَادُهُ
u'صَحَّ إِسْقاطٌ':Subject, #1: 1	صَحَّ إسْقَاطُهُ
u'صَحَّ إِسْلامٌ':Subject, #4: 4	صَحَّ الْإِسْقَاطُ
u'صَحَّ إِسْلامٌ':Subject, #13: 13	صَحَّ إسْلَامُهُ
u'صَحَّ إِسْلامٌ':Subject, #1: 1	صَحَّ الْإِسْلَامُ
u'صَحَّ إِسْنادٌ':Subject, #2: 2	صَحَّ إسْلَامُ
u'صَحَّ إِسْنادٌ':Subject, #1: 1	صَحَّ إسْنَادُ
u'صَحَّ إِسْنادٌ':Subject, #1: 1	صَحَّ إسْنَادُهُ
u'صَحَّ اِشْتِراطٌ':Subject, #3: 3	صَحَّ إِسْنَادُهُ
u'صَحَّ اِشْتِراطٌ':Subject, #1: 1	صَحَّ اشْتِرَاطُهُ
u'صَحَّ إضافَةٌ':Subject, #3: 3	صَحَّ اشْتِرَاطُ
u'صَحَّ إضافَةٌ':Subject, #1: 1	صَحَّ إضَافَتُهُ
u'صَحَّ إِطْلاقٌ':Subject, #5: 5	صَحَّ إضَافَةُ
u'صَحَّ إِطْلاقٌ':Subject, #2: 2	صَحَّ إطْلَاقُ
u'صَحَّ إِعْتاقٌ':Subject, #2: 2	صَحَّ الْإِطْلَاقُ
u'صَحَّ إِعْتاقٌ':Subject, #1: 1	صَحَّ إعْتَاقُ
u'صَحَّ اِعْتِكافٌ':Subject, #8: 8	صَحَّ إعْتَاقُهُ
u'صَحَّ إعْرَاضٌ':Subject, #1: 1	صَحَّ اعْتِكَافُهُ
u'صَحَّ إغْنَاءٌ':Subject, #2: 2	صَحَّ إعْرَاضُهُ
u'صَحَا قَالٌ':Predicate, #1: 1	صَحَّ الْإِغْنَاءُ
u'صَحَّ اِقْتِداءٌ':Subject, #3: 3	صَحَا قَالَ
u'صَحَّ إقْرَارٌ':Subject, #11: 11	صَحَّ اقْتِدَاءُ
u'صَحَّ إقْرَارٌ':Subject, #30: 30	صَحَّ الْإِقْرَارُ
u'صَحَّ إقْرَارٌ':Subject, #5: 5	صَحَّ إقْرَارُ
u'صَحَّ إقْطَاعٌ':Subject, #87: 87	صَحَّ إقْرَارُهُ
u'صَحَّ إقْطَاعٌ':Subject, #1: 1	صَحَّ إقْطَاعُهُ
u'صَحَّ أَكْثَرُ':Predicate, #2: 2	صَحَّ الْإِقْطَاعُ
u'صَحَّ أَكْثَرُ':Subject, #1: 1	صَحَّ أَكْثَرَ
u'صَحَّ اِلْتِزَامٌ':Subject, #1: 1	صَحَّ الْأَكْثَرُ
u'صَحَّ إلْحَاقٌ':Subject, #3: 3	صَحَّ الْتِزَامُهُ
u'صَحَّ إلْحَاقٌ':Subject, #1: 1	صَحَّ الْإِلْحَاقُ
u'صَحَّ إِلْزَامٌ':Subject, #1: 1	صَحَّ إلْحَاقُهُ
u'صَحَّ إمَامٌ':Subject, #1: 1	صَحَّ الْإِلْزَامُ
u'صَحَّ أمَانٌ':Subject, #1: 1	صَحَّ الْإِمَامُ
u'صَحَّ أَمْرٌ':Subject, #2: 2	صَحَّ أَمَانُهُ
u'صَحَّ أَمْرٌ':Subject, #2: 2	صَحَّ أَمْرُهُ
u'صَحَّ إِمْضاءٌ':Subject, #7: 7	صَحَّ الْأَمْرُ
u'صَحَّ إِنابَةٌ':Subject, #1: 1	صَحَّ الْإِمْضَاءُ
u'صَحَّ اِنْعِقَادٌ':Subject, #1: 1	صَحَّ إنَابَتُهُ
u'صَحَّ إِنْكارٌ':Subject, #2: 2	صَحَّ انْعِقَادُ
u'صَحَّ إِنْكارٌ':Subject, #1: 1	صَحَّ الْإِنْكَارُ
u'صَحَّ أَوَّلُ':Subject, #1: 1	صَحَّ إنْكَارُهُ
u'صَحَّ إِيجَابٌ':Subject, #8: 8	صَحَّ الْأَوَّلُ
u'صَحَّ إِيجَابٌ':Subject, #1: 1	صَحَّ الْإِيجَابَاتُ
u'صَحَّ إِيدَاعٌ':Subject, #4: 4	صَحَّ الْإِيجَابُ
u'صَحَّ إِيدَاعٌ':Subject, #1: 1	صَحَّ الْإِيدَاعُ
u'صَحَّ إيرَادٌ':Subject, #1: 1	صَحَّ إيدَاعُهُ
u'صَحَّ إيقَاعٌ':Subject, #3: 3	صَحَّ إيرَادُ
u'صَحَّ إيقَاعٌ':Subject, #1: 1	صَحَّ الْإِيقَاعُ
u'صَحَّ إيمَانٌ':Subject, #1: 1	صَحَّ إيقَاعُهُ
u'صَحَّ إيمَانٌ':Subject, #1: 1	صَحَّ إيمَانُ
u'صَحِبَ أَصْحَابٌ':Predicate, #1: 1	صَحَّ إيمَانُهُ
u'صحبة اِبْنٌ':Added, #2: 2	صَحِبَ أَصْحَابَ
u'صُحْبَةٌ اِبْنٌ':Added, #2: 2	صُحْبَةِ ابْنِ
u'صحبة أخيار':Added, #2: 2	صُحْبَةِ ابْنِ
u'صحبة أَخْيَارٌ':Added, #2: 2	صُحْبَةُ الْأَخْيَارِ
u'صُحْبَةٌ أخيار':Added, #2: 2	صُحْبَةُ الْأَخْيَارِ
u'صُحْبَةٌ أَخْيَارٌ':Added, #2: 2	صُحْبَةُ الْأَخْيَارِ
u'صحبة أهْلٌ':Added, #2: 2	صُحْبَةُ الْأَخْيَارِ
u'صُحْبَةٌ أهْلٌ':Added, #1: 1	صُحْبَةُ أَهْلِ
u'صحبة أَوَّلُ':Added, #1: 1	صُحْبَةُ أَهْلِ
u'صُحْبَةٌ أَوَّلُ':Added, #2: 2	صُحْبَةُ الْأَوَّلِ
u'صحبة جُهَّالٌ':Added, #2: 2	صُحْبَةُ الْأَوَّلِ
u'صُحْبَةٌ جُهَّالٌ':Added, #1: 1	صُحْبَةُ الْجُهَّالِ
u'صحبة رَافِعٌ':Added, #1: 1	صُحْبَةُ الْجُهَّالِ
u'صُحْبَةٌ رَافِعٌ':Added, #1: 1	صُحْبَةَ رَافِعِ
u'صحبة رِجَالٌ':Added, #1: 1	صُحْبَةَ رَافِعِ
u'صُحْبَةٌ رِجَالٌ':Added, #1: 1	صُحْبَةَ الرِّجَالِ
u'صحبة رَسُولٌ':Added, #1: 1	صُحْبَةَ الرِّجَالِ
u'صُحْبَةٌ رَسُولٌ':Added, #1: 1	صُحْبَةِ رَسُولِ
u'صحبة ركب':Added, #1: 1	صُحْبَةِ رَسُولِ
u'صحبة رَكْبٌ':Added, #2: 2	صُحْبَةَ الرَّكْبِ
u'صُحْبَةٌ ركب':Added, #2: 2	صُحْبَةَ الرَّكْبِ
u'صُحْبَةٌ رَكْبٌ':Added, #2: 2	صُحْبَةَ الرَّكْبِ
u'صحبة زَوْجٌ':Added, #2: 2	صُحْبَةَ الرَّكْبِ
u'صُحْبَةٌ زَوْجٌ':Added, #1: 1	صُحْبَةُ زَوْجٍ
u'صحبة سُلْطَانٌ':Added, #1: 1	صُحْبَةُ زَوْجٍ
u'صُحْبَةٌ سُلْطَانٌ':Added, #1: 1	صُحْبَةِ السُّلْطَانِ
u'صحبة صِدِّيقٌ':Added, #1: 1	صُحْبَةِ السُّلْطَانِ
u'صُحْبَةٌ صِدِّيقٌ':Added, #1: 1	صُحْبَةَ الصِّدِّيقِ
u'صحبة طَبْخٌ':Added, #1: 1	صُحْبَةَ الصِّدِّيقِ
u'صُحْبَةٌ طَبْخٌ':Added, #1: 1	صُحْبَةِ طَبْخِ
u'صحبة علماء':Added, #1: 1	صُحْبَةِ طَبْخِ
u'صُحْبَةٌ علماء':Added, #1: 1	صُحْبَةِ الْعُلَمَاءِ
u'صحبة عُلَمَاءُ':Added, #1: 1	صُحْبَةِ الْعُلَمَاءِ
u'صُحْبَةٌ عُلَمَاءُ':Added, #1: 1	صُحْبَةِ الْعُلَمَاءِ
u'صحبة فَاسِقٌ':Added, #1: 1	صُحْبَةِ الْعُلَمَاءِ
u'صُحْبَةٌ فَاسِقٌ':Added, #1: 1	صُحْبَةُ الْفَاسِقِ
u'صحبة فَقِيهٌ':Added, #1: 1	صُحْبَةُ الْفَاسِقِ
u'صُحْبَةٌ فَقِيهٌ':Added, #1: 1	صُحْبَةُ الْفَقِيهِ
u'صحبة قَضَاءٌ':Added, #1: 1	صُحْبَةُ الْفَقِيهِ
u'صُحْبَةٌ قَضَاءٌ':Added, #1: 1	صُحْبَةِ الْقَضَاءِ
u'صحبة لَذَّةٌ':Added, #1: 1	صُحْبَةِ الْقَضَاءِ
u'صُحْبَةٌ لَذَّةٌ':Added, #1: 1	صُحْبَةُ اللَّذَّاتِ
u'صحبة مَجْنُونٌ':Added, #1: 1	صُحْبَةُ اللَّذَّاتِ
u'صُحْبَةٌ مَجْنُونٌ':Added, #1: 1	صُحْبَةِ الْمَجْنُونَةِ
u'صحبة مَعْرُوفٌ':Added, #1: 1	صُحْبَةِ الْمَجْنُونَةِ
u'صُحْبَةٌ مَعْرُوفٌ':Added, #1: 1	صُحْبَةِ مَعْرُوفٍ
u'صحبة مَلاَئِكَةٌ':Added, #1: 1	صُحْبَةِ مَعْرُوفٍ
u'صُحْبَةٌ مَلاَئِكَةٌ':Added, #1: 1	صُحْبَةِ الْمَلَائِكَةِ
u'صحبة مُلُوكٌ':Added, #1: 1	صُحْبَةِ الْمَلَائِكَةِ
u'صُحْبَةٌ مُلُوكٌ':Added, #1: 1	صُحْبَةِ الْمُلُوكِ
u'صحبة نَبِيٌّ':Added, #1: 1	صُحْبَةِ الْمُلُوكِ
u'صُحْبَةٌ نَبِيٌّ':Added, #1: 1	صُحْبَةِ النَّبِيِّ
u'صحبة نَبِيٌّ':Added, #1: 1	صُحْبَةِ النَّبِيِّ
u'صُحْبَةٌ نَبِيٌّ':Added, #2: 2	صُحْبَةَ النَّبِيِّ
u'صحبة نِساءٌ':Added, #2: 2	صُحْبَةَ النَّبِيِّ
u'صُحْبَةٌ نِساءٌ':Added, #1: 1	صُحْبَةَ النِّسَاءِ
u'صَحِبَ تَوَاتُرٌ':Subject, #1: 1	صُحْبَةَ النِّسَاءِ
u'صَحَّ بدن':Subject, #1: 1	صَحِبَ التَّوَاتُرُ
u'صَحَّ بَدَنٌ':Subject, #1: 1	صَحَّ الْبَدَنُ
u'صَحَّ بَذْلٌ':Subject, #1: 1	صَحَّ الْبَدَنُ
u'صَحِبَ رَافِعٌ':Predicate, #1: 1	صَحَّ بَذْلُهُ
u'صَحِبَ رَجُلٌ':Predicate, #1: 1	صَحِبَ رَافِعَ
u'صَحِبَ رَسُولٌ':Predicate, #1: 1	صَحِبَ رَجُلاً
u'صَحِبَ رَسُولٌ':Subject, #4: 4	صَحِبَ رَسُولَ
u'صَحِبَ شافِعِيّ':Predicate, #1: 1	صَحِبَ رَسُولُ
u'صَحِبَ صَحَابِيٌّ':Predicate, #1: 1	صَحِبَ الشَّافِعِيَّ
u'صَحَّ بَطَلٌ':Predicate, #1: 1	صَحِبَ الصَّحَابِيَّ
u'صَحِبَ عَبْدٌ':Predicate, #1: 1	صَحَّ بَطَلَ
u'صَحَّ بَعْضٌ':Subject, #1: 1	صَحِبَ عَبْدَ
u'صَحِبَ عُمَرٌ':Predicate, #1: 1	صَحَّ بَعْضُ
u'صَحِبَ فلان':Predicate, #1: 1	صَحِبَ عُمَرَ
u'صَحَّ بِنَاءٌ':Subject, #1: 1	صَحِبَ الشَّافِعِيَّ
u'صَحِبَ نَبِيٌّ':Predicate, #3: 3	صَحَّ بِنَاءُ
u'صَحِبَ نَبِيٌّ':Predicate, #1: 1	صَحِبَ َالنَّبِيَّ
u'صَحَّ بَيَانٌ':Subject, #6: 6	صَحِبَ النَّبِيَّ
u'صَحَّ بَيَانٌ':Subject, #1: 1	صَحَّ الْبَيَانُ
u'صَحَّ بَيْعٌ':Subject, #2: 2	صَحَّ بَيَانُهُ
u'صَحَّ بَيْعٌ':Subject, #146: 146	صَحَّ الْبَيْعُ
u'صَحَّ بَيْعٌ':Subject, #18: 18	صَحَّ بَيْعُ
u'صَحَّ بَيْعٌ':Subject, #2: 2	صَحَّ بَيْعٌ
u'صِحَّةٌ إبَاحَةٌ':Added, #30: 30	صَحَّ بَيْعُهُ
u'صِحَّةٌ إِبَانَةٌ':Added, #1: 1	صِحَّةَ الْإِبَاحَةِ
u'صِحَّةٌ اِبْتِيَاعٌ':Added, #1: 1	صِحَّةِ الْإِبَانَةِ
u'صِحَّةٌ أبدانٌ':Added, #1: 1	صِحَّةِ الاِبْتِيَاعِ
u'صِحَّةٌ اِتِّصَالٌ':Added, #1: 1	صِحَّةِ الْأَبَدَانِ
u'صِحَّةٌ إِثْبَاتٌ':Added, #1: 1	صِحَّةُ اتِّصَالٍ
u'صِحَّةٌ إجَارَةٌ':Added, #1: 1	صِحَّةِ إثْبَاتِهِ
u'صِحَّةٌ إجَارَةٌ':Added, #10: 10	صِحَّةُ الْإِجَارَةِ
u'صِحَّةٌ إجَارَةٌ':Added, #12: 12	صِحَّةِ الْإِجَارَةِ
u'صِحَّةٌ إجَارَةٌ':Added, #1: 1	صِحَّةَ إجَارَتِهِ
u'صِحَّةٌ إجَارَةٌ':Added, #1: 1	صِحَّةُ إجَارَتِهِ
u'صِحَّةٌ إجَارَةٌ':Added, #2: 2	صِحَّةُ الْإِجَارَاتِ
u'صِحَّةٌ إجَارَةٌ':Added, #3: 3	صِحَّةَ إجَارَةِ
u'صِحَّةٌ إجَارَةٌ':Added, #3: 3	صِحَّةُ إجَارَةِ
u'صِحَّةٌ إجَارَةٌ':Added, #3: 3	صِحَّةِ إجَارَةِ
u'صِحَّةٌ إجَازَةٌ':Added, #5: 5	صِحَّةَ الْإِجَارَةِ
u'صِحَّةٌ إجَازَةٌ':Added, #1: 1	صِحَّةَ إجَازَةِ
u'صِحَّةٌ إجَازَةٌ':Added, #1: 1	صِحَّةُ إجَازَتِهِ
u'صِحَّةٌ إجَازَةٌ':Added, #1: 1	صِحَّةِ إجَازَتِهِ
u'صِحَّةٌ إجَازَةٌ':Added, #2: 2	صِحَّةَ الْإِجَازَةِ
u'صِحَّةٌ اِجْتِهَادٌ':Added, #4: 4	صِحَّةِ الْإِجَازَةِ
u'صِحَّةٌ إِجْرَاءٌ':Added, #1: 1	صِحَّةِ اجْتِهَادِهِ
u'صِحَّةٌ أَجَلٌ':Added, #1: 1	صِحَّةُ إجْرَاءِ
u'صِحَّةٌ إِجْمَاعٌ':Added, #1: 1	صِحَّةَ الْأَجَلِ
u'صِحَّةٌ إِجْمَاعٌ':Added, #1: 1	صِحَّةُ إجْمَاعِ
u'صِحَّةٌ إِجْمَاعٌ':Added, #1: 1	صِحَّةَ الْإِجْمَاعِ
u'صِحَّةٌ إِجْمَاعٌ':Added, #2: 2	صِحَّةُ الْإِجْمَاعِ
u'صِحَّةٌ أَجْنَبِيٌّ':Added, #5: 5	صِحَّةِ الْإِجْمَاعِ
u'صِحَّةٌ أَجْوِبَةٌ':Added, #1: 1	صِحَّةِ الْأَجْنَبِيِّ
u'صِحَّةٌ أَحادِيثُ':Added, #1: 1	صِحَّةُ الْأَجْوِبَةِ
u'صِحَّةٌ أَحادِيثُ':Added, #1: 1	صِحَّةُ الْأَحَادِيثِ
u'صِحَّةٌ أَحادِيثُ':Added, #1: 1	صِحَّةِ الْأَحَادِيثِ
u'صِحَّةٌ إِحالَةٌ':Added, #2: 2	صِحَّةَ الْأَحَادِيثِ
u'صِحَّةٌ إِحْدَاثٌ':Added, #1: 1	صِحَّةُ الْإِحَالَةِ
u'صِحَّةٌ إِحْرَامٌ':Added, #1: 1	صِحَّةِ إحْدَاثِهِ
u'صِحَّةٌ إِحْرَامٌ':Added, #1: 1	صِحَّةِ إحْرَامِهِ
u'صِحَّةٌ إِحْرَامٌ':Added, #2: 2	صِحَّةِ إحْرَامِ
u'صِحَّةٌ إِحْرَامٌ':Added, #2: 2	صِحَّةُ إحْرَامِهِ
u'صِحَّةٌ إِخَاءٌ':Added, #3: 3	صِحَّةَ الْإِحْرَامِ
u'صِحَّةٌ أخْبَارٌ':Added, #1: 1	صِحَّةِ الْإِخَاءِ
u'صِحَّةٌ أَخْبَارٌ':Added, #1: 1	صِحَّةِ الْأَخْبَارِ
u'صِحَّةٌ إِخْبَارٌ':Added, #1: 1	صِحَّةِ الْأَخْبَارِ
u'صِحَّةٌ اِخْتِيَارٌ':Added, #3: 3	صِحَّةِ الْإِخْبَارِ
u'صِحَّةٌ اِخْتِيَارٌ':Added, #1: 1	صِحَّةِ اخْتِيَارِهِ
u'صِحَّةٌ أخْذٌ':Added, #2: 2	صِحَّةَ اخْتِيَارِ
u'صِحَّةٌ أخْذٌ':Added, #1: 1	صِحَّةُ أَخْذِ
u'صِحَّةٌ أخْذٌ':Added, #2: 2	صِحَّةِ أَخْذِ
u'صِحَّةٌ أَدَاءٌ':Added, #2: 2	صِحَّةِ الْأَخْذِ
u'صِحَّةٌ أَدَاءٌ':Added, #1: 1	صِحَّةَ الْأَدَاءِ
u'صِحَّةٌ أَدَاءٌ':Added, #2: 2	صِحَّةَ أَدَاءِ
u'صِحَّةٌ أَدَاءٌ':Added, #2: 2	صِحَّةِ أَدَاءِ
u'صِحَّةٌ أَدَاءٌ':Added, #5: 5	صِحَّةُ الْأَدَاءِ
u'صِحَّةٌ إدْخَالٌ':Added, #5: 5	صِحَّةِ الْأَدَاءِ
u'صِحَّةٌ اِدِّعَاءٌ':Added, #1: 1	صِحَّةِ الْإِدْخَالِ
u'صِحَّةٌ أَذَانٌ':Added, #1: 1	صِحَّةُ ادِّعَاءِ
u'صِحَّةٌ آذَانٌ':Added, #1: 1	صِحَّةُ أَذَانِهِ
u'صِحَّةٌ أَذَانٌ':Added, #1: 1	صِحَّةُ الْآذَانِ
u'صِحَّةٌ أَذَانٌ':Added, #1: 1	صِحَّةُ الْأَذَانِ
u'صِحَّةٌ إِذْنٌ':Added, #3: 3	صِحَّةِ أَذَانِهِ
u'صِحَّةٌ إِرَادَةٌ':Added, #6: 6	صِحَّةِ الْإِذْنِ
u'صِحَّةٌ إِرَادَةٌ':Added, #1: 1	صِحَّةَ إرَادَةِ
u'صِحَّةٌ إِرَادَةٌ':Added, #1: 1	صِحَّةُ إرَادَةِ
u'صِحَّةٌ إِرَادَةٌ':Added, #1: 1	صِحَّةِ إرَادَتِهِ
u'صِحَّةٌ أَرْبَعُ':Added, #3: 3	صِحَّةِ إرَادَةِ
u'صِحَّةٌ إِرْسَالٌ':Added, #1: 1	صِحَّةَ الْأَرْبَعِ
u'صِحَّةٌ أسْبَابٌ':Added, #1: 1	صِحَّةِ الْإِرْسَالِ
u'صِحَّةٌ أسْبَابٌ':Added, #1: 1	صِحَّةُ الْأَسْبَابِ
u'صِحَّةٌ أَسْبَابٌ':Added, #1: 1	صِحَّةِ الْأَسْبَابِ
u'صِحَّةٌ أَسْبَابٌ':Added, #1: 1	صِحَّةُ الْأَسْبَابِ
u'صِحَّةٌ اِسْتِثْنَاءٌ':Added, #1: 1	صِحَّةِ الْأَسْبَابِ
u'صِحَّةٌ اِسْتِثْنَاءٌ':Added, #1: 1	صِحَّةَ اسْتِثْنَاءِ
u'صِحَّةٌ اِسْتِثْنَاءٌ':Added, #5: 5	صِحَّةِ اسْتِثْنَاءِ
u'صِحَّةٌ اِسْتِعارَةٌ':Added, #8: 8	صِحَّةُ اسْتِثْنَاءِ
u'صِحَّةٌ اِسْتِعْمالٌ':Added, #1: 1	صِحَّةُ اسْتِعَارَةِ
u'صِحَّةٌ اِسْتِعْمالٌ':Added, #1: 1	صِحَّةِ اسْتِعْمَالِ
u'صِحَّةٌ اِسْتِعْمالٌ':Added, #1: 1	صِحَّةُ اسْتِعْمَالِهِ
u'صِحَّةٌ اِسْتِقْلالٌ':Added, #2: 2	صِحَّةِ اسْتِعْمَالِهِ
u'صِحَّةٌ اِسْتِلْحاق':Added, #1: 1	صِحَّةِ اسْتِقْلَالِ
u'صِحَّةٌ اِسْتِلْحاق':Added, #1: 1	صِحَّةُ اسْتِلْحَاقِ
u'صِحَّةٌ اِسْتِنابَة':Added, #1: 1	صِحَّةِ اسْتِلْحَاقِ
u'صِحَّةٌ اِسْتِئْجَارٌ':Added, #2: 2	صِحَّةُ اسْتِنَابَةِ
u'صِحَّةٌ اِسْتِئْجَارٌ':Added, #1: 1	صِحَّةِ اسْتِئْجَارِ
u'صِحَّةٌ اِسْتِيلاد':Added, #1: 1	صِحَّةَ اسْتِئْجَارِهِ
u'صِحَّةٌ إِسْقاطٌ':Added, #1: 1	صِحَّةُ اسْتِيلَادِ
u'صِحَّةٌ إِسْقاطٌ':Added, #1: 1	صِحَّةِ الْإِسْقَاطِ
u'صِحَّةٌ إِسْلامٌ':Added, #2: 2	صِحَّةِ إسْقَاطِ
u'صِحَّةٌ إِسْلامٌ':Added, #12: 12	صِحَّةِ إسْلَامِهِ
u'صِحَّةٌ إِسْلامٌ':Added, #1: 1	صِحَّةَ إسْلَامِ
u'صِحَّةٌ إِسْلامٌ':Added, #1: 1	صِحَّةُ إسْلَامِ
u'صِحَّةٌ إِسْلامٌ':Added, #1: 1	صِحَّةَ إسْلَامِهِ
u'صِحَّةٌ إِسْلامٌ':Added, #3: 3	صِحَّةِ إسْلَامِ
u'صِحَّةٌ إِسْلامٌ':Added, #3: 3	صِحَّةِ الْإِسْلَامِ
u'صِحَّةٌ إِسْنادٌ':Added, #6: 6	صِحَّةُ إسْلَامِهِ
u'صِحَّةٌ إِسْنادٌ':Added, #1: 1	صِحَّةَ إسْنَادِ
u'صِحَّةٌ إِسْنادٌ':Added, #1: 1	صِحَّةُ إسْنَادِ
u'صِحَّةٌ إِسْنادٌ':Added, #1: 1	صِحَّةِ إسْنَادِهِ
u'صِحَّةٌ إِسْنادٌ':Added, #1: 1	صِحَّةِ إِسْنَادِهِ
u'صِحَّةٌ إِسْنادٌ':Added, #1: 1	صِحَّةُ الْإِسْنَادِ
u'صِحَّةٌ أسْنَانٌ':Added, #3: 3	صِحَّةِ الْإِسْنَادِ
u'صِحَّةٌ اِشْتِراطٌ':Added, #1: 1	صِحَّةِ الْأَسْنَانِ
u'صِحَّةٌ اِشْتِراطٌ':Added, #1: 1	صِحَّةِ اشْتِرَاطٍ
u'صِحَّةٌ اِشْتِراطٌ':Added, #3: 3	صِحَّةَ اشْتِرَاطِ
u'صِحَّةٌ اِشْتِراطٌ':Added, #3: 3	صِحَّةُ اشْتِرَاطِ
u'صِحَّةٌ أصل':Added, #4: 4	صِحَّةِ اشْتِرَاطِ
u'صِحَّةٌ أًصْلٌ':Added, #1: 1	صِحَّةُ أَصْلِ
u'صِحَّةٌ أصل':Added, #1: 1	صِحَّةُ أَصْلِ
u'صِحَّةٌ أًصْلٌ':Added, #2: 2	صِحَّةَ الْأَصْلِ
u'صِحَّةٌ أُصولٌ':Added, #2: 2	صِحَّةَ الْأَصْلِ
u'صِحَّةٌ إضافَةٌ':Added, #1: 1	صِحَّةِ أُصُولِهِ
u'صِحَّةٌ إضافَةٌ':Added, #1: 1	صِحَّةِ إضَافَةِ
u'صِحَّةٌ إضافَةٌ':Added, #1: 1	صِحَّةِ إضَافَتِهِ
u'صِحَّةٌ إضافَةٌ':Added, #1: 1	صِحَّةُ الْإِضَافَةِ
u'صِحَّةٌ إضافَةٌ':Added, #3: 3	صِحَّةَ إضَافَةِ
u'صِحَّةٌ إِطْعامٌ':Added, #3: 3	صِحَّةِ الْإِضَافَةِ
u'صِحَّةٌ إِطْلاقٌ':Added, #1: 1	صِحَّةِ إطْعَامِهِ
u'صِحَّةٌ إِطْلاقٌ':Added, #1: 1	صِحَّةَ إطْلَاقِهِ
u'صِحَّةٌ إِطْلاقٌ':Added, #1: 1	صِحَّةَ الْإِطْلَاقِ
u'صِحَّةٌ إِطْلاقٌ':Added, #1: 1	صِحَّةُ الْإِطْلَاقِ
u'صِحَّةٌ إِطْلاقٌ':Added, #1: 1	صِحَّةِ الْإِطْلَاقَيْنِ
u'صِحَّةٌ إِطْلاقٌ':Added, #2: 2	صِحَّةَ إطْلَاقِ
u'صِحَّةٌ إِطْلاقٌ':Added, #3: 3	صِحَّةُ إطْلَاقِهِ
u'صِحَّةٌ إِطْلاقٌ':Added, #6: 6	صِحَّةِ إطْلَاقِهِ
u'صِحَّةٌ إِطْلاقٌ':Added, #6: 6	صِحَّةِ الْإِطْلَاقِ
u'صِحَّةٌ أَظْفارٌ':Added, #7: 7	صِحَّةِ إطْلَاقِ
u'صِحَّةٌ إِعادَةٌ':Added, #1: 1	صِحَّةَ الْأَظْفَارِ
u'صِحَّةٌ إِعارَةٌ':Added, #1: 1	صِحَّةُ إعَادَةِ
u'صِحَّةٌ إِعارَةٌ':Added, #1: 1	صِحَّةُ إعَارَةِ
u'صِحَّةٌ إِعْتاقٌ':Added, #3: 3	صِحَّةِ إعَارَةِ
u'صِحَّةٌ إِعْتاقٌ':Added, #1: 1	صِحَّةَ إعْتَاقِ
u'صِحَّةٌ إِعْتاقٌ':Added, #1: 1	صِحَّةِ إعْتَاقِ
u'صِحَّةٌ إِعْتاقٌ':Added, #1: 1	صِحَّةِ إعْتَاقِهِ
u'صِحَّةٌ إِعْتاقٌ':Added, #1: 1	صِحَّةِ الْإِعْتَاقِ
u'صِحَّةٌ اِعْتِبارٌ':Added, #3: 3	صِحَّةَ الْإِعْتَاقِ
u'صِحَّةٌ اِعْتِبارٌ':Added, #1: 1	صِحَّةَ اعْتِبَارِ
u'صِحَّةٌ اِعْتِبارٌ':Added, #1: 1	صِحَّةِ اعْتِبَارِهِ
u'صِحَّةٌ اِعْتِذارٌ':Added, #3: 3	صِحَّةِ اعْتِبَارِ
u'صِحَّةٌ اِعْتِراضٌ':Added, #1: 1	صِحَّةِ اعْتِذَارِ
u'صِحَّةٌ اِعْتِصارٌ':Added, #1: 1	صِحَّةِ اعْتِرَاضِهِ
u'صِحَّةٌ اِعْتِكافٌ':Added, #1: 1	صِحَّةُ اعْتِصَارِ
u'صِحَّةٌ اِعْتِمادٌ':Added, #1: 1	صِحَّةِ اعْتِكَافِهِ
u'صِحَّةٌ إِعْرابٌ':Added, #1: 1	صِحَّةُ اعْتِمَادِ
u'صِحَّةٌ إعْرَاضٌ':Added, #1: 1	صِحَّةِ الْإِعْرَابِ
u'صِحَّةٌ إعْرَاضٌ':Added, #1: 1	صِحَّةُ إعْرَاضِهِ
u'صِحَّةٌ إعْرَاضٌ':Added, #2: 2	صِحَّةَ إعْرَاضِهِ
u'صِحَّةٌ أَعْمَالٌ':Added, #2: 2	صِحَّةِ إعْرَاضِهِ
u'صِحَّةٌ أَعْمَالٌ':Added, #1: 1	صِحَّةُ أَعْمَالِ
u'صِحَّةٌ إفْتَاءٌ':Added, #1: 1	صِحَّةَ الْأَعْمَالِ
u'صِحَّةٌ إِفْرَادٌ':Added, #1: 1	صِحَّةُ إفْتَاءِ
u'صِحَّةٌ إقالَةٌ':Added, #1: 1	صِحَّةِ إفْرَادِهِ
u'صِحَّةٌ إقالَةٌ':Added, #3: 3	صِحَّةِ الْإِقَالَةِ
u'صِحَّةٌ إقالَةٌ':Added, #5: 5	صِحَّةُ الْإِقَالَةِ
u'صِحَّةٌ إقامَةٌ':Added, #6: 6	صِحَّةَ الْإِقَالَةِ
u'صِحَّةٌ إقامَةٌ':Added, #1: 1	صِحَّةُ إقَامَةِ
u'صِحَّةٌ إقامَةٌ':Added, #1: 1	صِحَّةِ إقَامَةِ
u'صِحَّةٌ إقامَةٌ':Added, #1: 1	صِحَّةُ إقَامَتِهِ
u'صِحَّةٌ اِقْتِداءٌ':Added, #1: 1	صِحَّةِ الْإِقَامَةِ
u'صِحَّةٌ اِقْتِداءٌ':Added, #1: 1	صِحَّةَ اقْتِدَاءِ
u'صِحَّةٌ اِقْتِداءٌ':Added, #1: 1	صِحَّةُ اقْتِدَاءِ
u'صِحَّةٌ اِقْتِرَاضٌ':Added, #7: 7	صِحَّةِ اقْتِدَاءِ
u'صِحَّةٌ إقْرَارٌ':Added, #1: 1	صِحَّةُ اقْتِرَاضِ
u'صِحَّةٌ إقْرَارٌ':Added, #11: 11	صِحَّةِ إقْرَارِهِ
u'صِحَّةٌ إقْرَارٌ':Added, #30: 30	صِحَّةِ الْإِقْرَارِ
u'صِحَّةٌ إقْرَارٌ':Added, #33: 33	صِحَّةَ الْإِقْرَارِ
u'صِحَّةٌ إقْرَارٌ':Added, #4: 4	صِحَّةَ إقْرَارِ
u'صِحَّةٌ إقْرَارٌ':Added, #4: 4	صِحَّةُ إقْرَارِهِ
u'صِحَّةٌ إقْرَارٌ':Added, #8: 8	صِحَّةُ الْإِقْرَارِ
u'صِحَّةٌ إقْرَارٌ':Added, #9: 9	صِحَّةِ إقْرَارِ
u'صِحَّةٌ إِقْراضٌ':Added, #9: 9	صِحَّةَ إقْرَارِهِ
u'صِحَّةٌ إِقْراضٌ':Added, #1: 1	صِحَّةَ إقْرَاضِ
u'صِحَّةٌ إِقْراضٌ':Added, #1: 1	صِحَّةُ إقْرَاضِ
u'صِحَّةٌ إقْطَاعٌ':Added, #1: 1	صِحَّةِ الْإِقْرَاضِ
u'صِحَّةٌ أَكْثَرُ':Added, #3: 3	صِحَّةِ الْإِقْطَاعِ
u'صِحَّةٌ اِلْتِقَاطٌ':Added, #1: 1	صِحَّةِ أَكْثَرِ
u'صِحَّةٌ اِلْتِقَاطٌ':Added, #2: 2	صِحَّةِ الْتِقَاطِ
u'صِحَّةٌ إلْحَاقٌ':Added, #3: 3	صِحَّةِ الْتِقَاطِهِ
u'صِحَّةٌ إلْحَاقٌ':Added, #1: 1	صِحَّةَ الْإِلْحَاقِ
u'صِحَّةٌ أَلْسِنَةٌ':Added, #1: 1	صِحَّةِ إلْحَاقِ
u'صِحَّةٌ إِلْمَامٌ':Added, #1: 1	صِحَّةِ الْأَلْسِنَةِ
u'صِحَّةٌ إِلْمَامٌ':Added, #1: 1	صِحَّةَ الْإِلْمَامِ
u'صِحَّةٌ إمَامَةٌ':Added, #2: 2	صِحَّةَ إلْمَامِهِ
u'صِحَّةٌ إمَامَةٌ':Added, #12: 12	صِحَّةِ إمَامَتِهِ
u'صِحَّةٌ إمَامَةٌ':Added, #2: 2	صِحَّةِ الْإِمَامَةِ
u'صِحَّةٌ إمَامَةٌ':Added, #2: 2	صِحَّةَ إمَامَةِ
u'صِحَّةٌ إمَامَةٌ':Added, #3: 3	صِحَّةَ إمَامَتِهِ
u'صِحَّةٌ إمَامَةٌ':Added, #4: 4	صِحَّةُ إمَامَتِهِ
u'صِحَّةٌ إمَامَةٌ':Added, #7: 7	صِحَّةُ إمَامَةِ
u'صِحَّةٌ أمَانٌ':Added, #8: 8	صِحَّةِ إمَامَةِ
u'صِحَّةٌ أمَانٌ':Added, #1: 1	صِحَّةَ الْأَمَانِ
u'صِحَّةٌ أمَانٌ':Added, #1: 1	صِحَّةَ أَمَانِ
u'صِحَّةٌ أمَانٌ':Added, #2: 2	صِحَّةِ أَمَانِ
u'صِحَّةٌ أمَانٌ':Added, #2: 2	صِحَّةِ أَمَانِهِ
u'صِحَّةٌ أَمْرٌ':Added, #3: 3	صِحَّةِ الْأَمَانِ
u'صِحَّةٌ أَمْرٌ':Added, #1: 1	صِحَّةَ الْأَمْرِ
u'صِحَّةٌ أَمْرٌ':Added, #1: 1	صِحَّةُ الْأَمْرِ
u'صِحَّةٌ آمِرٌ':Added, #1: 1	صِحَّةَ أَمْرِ
u'صِحَّةٌ أَمْرٌ':Added, #2: 2	صِحَّةَ الْآمِرِ
u'صِحَّةٌ أُمِّيٌّ':Added, #7: 7	صِحَّةِ الْأَمْرِ
u'صِحَّةٌ أُمِّيَّةٌ':Added, #1: 1	صِحَّةِ أُمِّيَّةِ
u'صِحَّةٌ إِنابَةٌ':Added, #1: 1	صِحَّةِ أُمِّيَّةِ
u'صِحَّةٌ اِنْتِقالٌ':Added, #1: 1	صِحَّةُ الْإِنَابَةِ
u'صِحَّةٌ اِنْضِمامٌ':Added, #1: 1	صِحَّةِ انْتِقَالِهِ
u'صِحَّةٌ اِنْضِمامٌ':Added, #1: 1	صِحَّةُ انْضِمَامِ
u'صِحَّةٌ اِنْطِلاقٌ':Added, #1: 1	صِحَّةِ انْضِمَامِ
u'صِحَّةٌ اِنْعِقَادٌ':Added, #1: 1	صِحَّةِ انْطِلَاقِ
u'صِحَّةٌ اِنْعِقَادٌ':Added, #1: 1	صِحَّةُ انْعِقَادِ
u'صِحَّةٌ إِنْكارٌ':Added, #2: 2	صِحَّةِ انْعِقَادِ
u'صِحَّةٌ أَوَّلُ':Added, #1: 1	صِحَّةِ الْإِنْكَارِ
u'صِحَّةٌ أَوَّلُ':Added, #1: 1	صِحَّةَ الْأَوَّلِ
u'صِحَّةٌ آيَةٌ':Added, #1: 1	صِحَّةِ الْأَوَّلِ
u'صِحَّةٌ إِيجَابٌ':Added, #1: 1	صِحَّةُ الْآيَةِ
u'صِحَّةٌ إِيجَابٌ':Added, #1: 1	صِحَّةُ الْإِيجَابِ
u'صِحَّةٌ إِيجَابٌ':Added, #1: 1	صِحَّةِ إيجَابِهِ
u'صِحَّةٌ إِيجَابٌ':Added, #2: 2	صِحَّةَ الْإِيجَابِ
u'صِحَّةٌ إيقَاعٌ':Added, #2: 2	صِحَّةِ الْإِيجَابِ
u'صِحَّةٌ إيقَاعٌ':Added, #1: 1	صِحَّةُ إيقَاعِ
u'صِحَّةٌ إيقَاعٌ':Added, #3: 3	صِحَّةَ الْإِيقَاعِ
u'صِحَّةٌ إيمَانٌ':Added, #3: 3	صِحَّةِ إيقَاعِ
u'صِحَّةٌ إيمَانٌ':Added, #1: 1	صِحَّةَ الْإِيمَانِ
u'صِحَّةٌ إيمَانٌ':Added, #1: 1	صِحَّةُ الْإِيمَانِ
u'صِحَّةٌ إيمَانٌ':Added, #2: 2	صِحَّةِ إيمَانِ
u'صِحَّةٌ إيمَانٌ':Added, #4: 4	صِحَّةِ إيمَانِهِ
u'صِحَّةٌ بَاطن':Added, #7: 7	صِحَّةِ الْإِيمَانِ
u'صِحَّةٌ باطِنٌ':Added, #1: 1	صِحَّةُ بَاطِنِهِ
u'صِحَّةٌ بِدْعَةٌ':Added, #1: 1	صِحَّةُ بَاطِنِهِ
u'صِحَّةٌ بَدَلٌ':Added, #1: 1	صِحَّةِ الْبِدْعَةِ
u'صِحَّةٌ بدن':Added, #1: 1	صِحَّةُ بَدَلِ
u'صِحَّةٌ بَدَنٌ':Added, #10: 10	صِحَّةِ بَدَنِهِ
u'صِحَّةٌ بدن':Added, #10: 10	صِحَّةِ بَدَنِهِ
u'صِحَّةٌ بَدَنٌ':Added, #1: 1	صِحَّةَ الْبَدَنِ
u'صِحَّةٌ بدن':Added, #1: 1	صِحَّةَ الْبَدَنِ
u'صِحَّةٌ بَدَنٌ':Added, #1: 1	صِحَّةُ بَدَنِهِ
u'صِحَّةٌ بدن':Added, #1: 1	صِحَّةُ بَدَنِهِ
u'صِحَّةٌ بَدَنٌ':Added, #2: 2	صِحَّةُ الْبَدَنِ
u'صِحَّةٌ بدن':Added, #2: 2	صِحَّةُ الْبَدَنِ
u'صِحَّةٌ بَدَنٌ':Added, #6: 6	صِحَّةِ الْبَدَنِ
u'صِحَّةٌ بَذْلٌ':Added, #6: 6	صِحَّةِ الْبَدَنِ
u'صِحَّةٌ براءٌ':Added, #1: 1	صِحَّةِ الْبَذْلِ
u'صِحَّةٌ بَراءٌ':Added, #1: 1	صِحَّة الْبَرَاءِ
u'صِحَّةٌ بَراءةٌ':Added, #1: 1	صِحَّة الْبَرَاءِ
u'صِحَّةٌ بَراءةٌ':Added, #12: 12	صِحَّةِ الْبَرَاءَةِ
u'صِحَّةٌ بَراءةٌ':Added, #1: 1	صِحَّة الْبَرَاءَةِ
u'صِحَّةٌ بَعْضٌ':Added, #2: 2	صِحَّةُ الْبَرَاءَةِ
u'صِحَّةٌ بِنَاءٌ':Added, #1: 1	صِحَّةِ بَعْضِ
u'صِحَّةٌ بِنَاءٌ':Added, #1: 1	صِحَّةَ الْبِنَاءِ
u'صِحَّةٌ بِنَاءٌ':Added, #1: 1	صِحَّةُ الْبِنَاءِ
u'صِحَّةٌ بَيْعٌ':Added, #3: 3	صِحَّةِ الْبِنَاءِ
u'صِحَّةٌ بَيْعٌ':Added, #16: 16	صِحَّةِ بَيْعِهِ
u'صِحَّةٌ بَيْعٌ':Added, #1: 1	صِحَّة الْبَيْعِ
u'صِحَّةٌ بَيْعٌ':Added, #1: 1	صِحَّة بَيْعِ
u'صِحَّةٌ بَيْعٌ':Added, #1: 1	صِحَّةُ بَيْعٍ
u'صِحَّةٌ بَيْعٌ':Added, #26: 26	صِحَّةَ الْبَيْعِ
u'صِحَّةٌ بَيْعٌ':Added, #26: 26	صِحَّةُ الْبَيْعِ
u'صِحَّةٌ بَيْعٌ':Added, #29: 29	صِحَّةِ بَيْعِ
u'صِحَّةٌ بَيْعٌ':Added, #2: 2	صِحَّةِ بَيْعٍ
u'صِحَّةٌ بَيْعٌ':Added, #3: 3	صِحَّةَ بَيْعِهِ
u'صِحَّةٌ بَيْعٌ':Added, #75: 75	صِحَّةِ الْبَيْعِ
u'صِحَّةٌ بَيْعٌ':Added, #8: 8	صِحَّةَ بَيْعِ
u'صِحَّةٌ بَيْعٌ':Added, #8: 8	صِحَّةُ بَيْعِهِ
u'صِحَّةٌ تَأْجِيلٌ':Added, #9: 9	صِحَّةُ بَيْعِ
u'صِحَّةٌ تَأْجِيلٌ':Added, #1: 1	صِحَّةَ التَّأْجِيلِ
u'صِحَّةٌ تَأْجِيلٌ':Added, #1: 1	صِحَّةَ تَأْجِيلِهِ
u'صِحَّةٌ تَأْكِيدٌ':Added, #3: 3	صِحَّةِ تَأْجِيلِ
u'صِحَّةٌ تَبَرُّعٌ':Added, #1: 1	صِحَّةُ التَّأْكِيدِ
u'صِحَّةٌ تَبَرُّعٌ':Added, #1: 1	صِحَّةَ التَّبَرُّعَاتِ
u'صِحَّةٌ تَبَرُّعٌ':Added, #1: 1	صِحَّة تَبَرُّعِ
u'صِحَّةٌ تَبَرُّعٌ':Added, #1: 1	صِحَّةُ تَبَرُّعِ
u'صِحَّةٌ تَبَرُّعٌ':Added, #1: 1	صِحَّة تَبَرُّعِهِ
u'صِحَّةٌ تَبَرُّعٌ':Added, #2: 2	صِحَّةَ تَبَرُّعِ
u'صِحَّةٌ تَبَرُّعٌ':Added, #2: 2	صِحَّةُ تَبَرُّعِهِ
u'صِحَّةٌ تَبَرُّعٌ':Added, #3: 3	صِحَّةِ تَبَرُّعِهِ
u'صِحَّةٌ تَبْعِيض':Added, #7: 7	صِحَّةِ تَبَرُّعِ
u'صِحَّةٌ تَثْنِيَةٌ':Added, #1: 1	صِحَّةِ تَبْعِيضِ
u'صِحَّةٌ تَجْدِيدٌ':Added, #1: 1	صِحَّةِ التَّثْنِيَةِ
u'صِحَّةٌ تَجَوُّزٌ':Added, #1: 1	صِحَّةِ تَجْدِيدِ
u'صِحَّةٌ تَحْرِيمٌ':Added, #1: 1	صِحَّةِ التَّجَوُّزِ
u'صِحَّةٌ تَحَمُّلٌ':Added, #1: 1	صِحَّةَ تَحْرِيمِ
u'صِحَّةٌ تَحَمُّلٌ':Added, #1: 1	صِحَّةَ تَحَمُّلِ
u'صِحَّةٌ تَحَمُّلٌ':Added, #1: 1	صِحَّةِ تَحَمُّلِ
u'صِحَّةٌ تَخْصِيصٌ':Added, #3: 3	صِحَّةِ التَّحَمُّلِ
u'صِحَّةٌ تَخْلِيَة':Added, #2: 2	صِحَّةِ التَّخْصِيصِ
u'صِحَّةٌ تَدْبِيرٌ':Added, #1: 1	صِحَّةِ تَخْلِيَةِ
u'صِحَّةٌ تَدْبِيرٌ':Added, #1: 1	صِحَّةَ التَّدْبِيرِ
u'صِحَّةٌ تَدْبِيرٌ':Added, #1: 1	صِحَّةُ التَّدْبِيرِ
u'صِحَّةٌ تَدْبِيرٌ':Added, #2: 2	صِحَّةَ تَدْبِيرِهِ
u'صِحَّةٌ تَذْكِيَةٌ':Added, #3: 3	صِحَّةِ التَّدْبِيرِ
u'صِحَّةٌ تَذْكِيَةٌ':Added, #1: 1	صِحَّةُ التَّذْكِيَةِ
u'صِحَّةٌ تَرْتِيبٌ':Added, #1: 1	صِحَّةِ تَذْكِيَةِ
u'صِحَّةٌ تَرْجَمَةٌ':Added, #2: 2	صِحَّةِ تَرْتِيبِهِ
u'صِحَّةٌ تَرْكِيبٌ':Added, #1: 1	صِحَّةِ التَّرْجَمَةِ
u'صِحَّةٌ تَرْكِيبٌ':Added, #1: 1	صِحَّةِ التَّرْكِيبِ
u'صِحَّةٌ تَرْكِيبٌ':Added, #1: 1	صِحَّةِ تَرْكِيبِ
u'صِحَّةٌ تَزْكِيَةٌ':Added, #2: 2	صِحَّةُ التَّرْكِيبِ
u'صِحَّةٌ تَزَوُّجٌ':Added, #2: 2	صِحَّةِ التَّزْكِيَةِ
u'صِحَّةٌ تَزْوِيجٌ':Added, #2: 2	صِحَّةِ التَّزَوُّجِ
u'صِحَّةٌ تَزْوِيجٌ':Added, #1: 1	صِحَّةِ التَّزْوِيجِ
u'صِحَّةٌ تَزْوِيجٌ':Added, #1: 1	صِحَّةُ تَزْوِيجِ
u'صِحَّةٌ تَزْوِيجٌ':Added, #2: 2	صِحَّةَ تَزْوِيجِ
u'صِحَّةٌ تَزْوِيجٌ':Added, #2: 2	صِحَّةِ تَزْوِيجِهِ
u'صِحَّةٌ تَسْلِيمٌ':Added, #5: 5	صِحَّةِ تَزْوِيجِ
u'صِحَّةٌ تَسْلِيمٌ':Added, #1: 1	صِحَّةَ التَّسْلِيمِ
u'صِحَّةٌ تَسْلِيمٌ':Added, #1: 1	صِحَّةِ تَسْلِيمِ
u'صِحَّةٌ تَسْمِيَة':Added, #3: 3	صِحَّةِ التَّسْلِيمِ
u'صِحَّةٌ تَسْمِيَة':Added, #16: 16	صِحَّةَ التَّسْمِيَةِ
u'صِحَّةٌ تَسْمِيَة':Added, #18: 18	صِحَّةِ التَّسْمِيَةِ
u'صِحَّةٌ تَسْمِيَة':Added, #1: 1	صِحَّةِ تَسْمِيَةِ
u'صِحَّةٌ تَسْوِيغ':Added, #3: 3	صِحَّةُ التَّسْمِيَةِ
u'صِحَّةٌ تَشْبِيه':Added, #1: 1	صِحَّةُ تَسْوِيغِ
u'صِحَّةٌ تَشْبِيه':Added, #1: 1	صِحَّةَ التَّشْبِيهِ
u'صِحَّةٌ تَشْبِيه':Added, #1: 1	صِحَّةُ التَّشْبِيهِ
u'صِحَّةٌ تَصَدُّقٌ':Added, #1: 1	صِحَّةِ التَّشْبِيهِ
u'صِحَّةٌ تَصْدِيقٌ':Added, #1: 1	صِحَّةِ التَّصَدُّقِ
u'صِحَّةٌ تَصَرُّفٌ':Added, #1: 1	صِحَّةِ التَّصْدِيقِ
u'صِحَّةٌ تَصَرُّفٌ':Added, #10: 10	صِحَّةِ تَصَرُّفِ
u'صِحَّةٌ تَصَرُّفٌ':Added, #10: 10	صِحَّةُ تَصَرُّفِهِ
u'صِحَّةٌ تَصَرُّفٌ':Added, #11: 11	صِحَّةِ التَّصَرُّفِ
u'صِحَّةٌ تَصَرُّفٌ':Added, #11: 11	صِحَّةِ تَصَرُّفِهِ
u'صِحَّةٌ تَصَرُّفٌ':Added, #13: 13	صِحَّةَ التَّصَرُّفِ
u'صِحَّةٌ تَصَرُّفٌ':Added, #1: 1	صِحَّةُ تَصَرُّفَاتِهِ
u'صِحَّةٌ تَصَرُّفٌ':Added, #1: 1	صِحَّةِ تَصَرُّفَاتِهِ
u'صِحَّةٌ تَصَرُّفٌ':Added, #1: 1	صِحَّة تَصَرُّفِهِ
u'صِحَّةٌ تَصَرُّفٌ':Added, #2: 2	صِحَّةِ التَّصَرُّفَاتِ
u'صِحَّةٌ تَصَرُّفٌ':Added, #2: 2	صِحَّةُ تَصَرُّفِ
u'صِحَّةٌ تَطَوُّعٌ':Added, #6: 6	صِحَّةُ التَّصَرُّفِ
u'صِحَّةٌ تَعْبِيرٌ':Added, #2: 2	صِحَّةِ التَّطَوُّعِ
u'صِحَّةٌ تَعْجِيل':Added, #1: 1	صِحَّةِ التَّعْبِيرِ
u'صِحَّةٌ تَعْجِيل':Added, #2: 2	صِحَّةَ تَعْجِيلِ
u'صِحَّةٌ تَعْرِيفٌ':Added, #7: 7	صِحَّةِ التَّعْجِيلِ
u'صِحَّةٌ تَعَلُّقٌ':Added, #1: 1	صِحَّةِ التَّعْرِيفِ
u'صِحَّةٌ تَعَلُّقٌ':Added, #1: 1	صِحَّةُ تَعَلُّقِ
u'صِحَّةٌ تَعَلُّقٌ':Added, #1: 1	صِحَّةِ تَعَلُّقِهِ
u'صِحَّةٌ تَعْلِيقٌ':Added, #2: 2	صِحَّةِ تَعَلُّقِ
u'صِحَّةٌ تَعْلِيقٌ':Added, #12: 12	صِحَّةِ التَّعْلِيقِ
u'صِحَّةٌ تَعْلِيقٌ':Added, #13: 13	صِحَّةِ تَعْلِيقِ
u'صِحَّةٌ تَعْلِيقٌ':Added, #1: 1	صِحَّةِ تَعْلِيقٍ
u'صِحَّةٌ تَعْلِيقٌ':Added, #1: 1	صِحَّةُ تَعْلِيقِهِ
u'صِحَّةٌ تَعْلِيقٌ':Added, #2: 2	صِحَّةَ التَّعْلِيقِ
u'صِحَّةٌ تَعْلِيقٌ':Added, #2: 2	صِحَّةُ التَّعْلِيقِ
u'صِحَّةٌ تَعْلِيقٌ':Added, #2: 2	صِحَّةَ تَعْلِيقِ
u'صِحَّةٌ تَعْلِيقٌ':Added, #2: 2	صِحَّةُ تَعْلِيقِ
u'صِحَّةٌ تَعْلِيلٌ':Added, #9: 9	صِحَّةِ تَعْلِيقِهِ
u'صِحَّةٌ تَعْلِيلٌ':Added, #1: 1	صِحَّةُ التَّعْلِيلِ
u'صِحَّةٌ تَعْلِيلٌ':Added, #1: 1	صِحَّةَ تَعْلِيلِهِ
u'صِحَّةٌ تَعْلِيلٌ':Added, #1: 1	صِحَّةُ تَعْلِيلِهِ
u'صِحَّةٌ تَعْلِيلٌ':Added, #2: 2	صِحَّةَ التَّعْلِيلِ
u'صِحَّةٌ تَعْوِيضٌ':Added, #6: 6	صِحَّةِ التَّعْلِيلِ
u'صِحَّةٌ تَغَايُرٌ':Added, #1: 1	صِحَّةَ التَّعْوِيضِ
u'صِحَّةٌ تَفْرِقَة':Added, #1: 1	صِحَّةِ التَّغَايُرِ
u'صِحَّةٌ تَفْرِيقٌ':Added, #2: 2	صِحَّةُ التَّفْرِقَةِ
u'صِحَّةٌ تَفْرِيقٌ':Added, #1: 1	صِحَّةِ التَّفْرِيقِ
u'صِحَّةٌ تَفْسِيرٌ':Added, #1: 1	صِحَّةِ تَفْرِيقِ
u'صِحَّةٌ تَفْسِيرٌ':Added, #1: 1	صِحَّةُ التَّفْسِيرِ
u'صِحَّةٌ تَفْصِيلٌ':Added, #1: 1	صِحَّةِ تَفْسِيرِ
u'صِحَّةٌ تَفْوِيت':Added, #1: 1	صِحَّةُ التَّفْصِيلِ
u'صِحَّةٌ تَقْديرٌ':Added, #1: 1	صِحَّةِ التَّفْوِيتِ
u'صِحَّةٌ تَقْديمٌ':Added, #1: 1	صِحَّةَ التَّقْدِيرِ
u'صِحَّةٌ تَقْريرٌ':Added, #1: 1	صِحَّةِ تَقْدِيمِهِ
u'صِحَّةٌ تَقْسِيمٌ':Added, #5: 5	صِحَّةِ تَقْرِيرِ
u'صِحَّةٌ تَقْسِيمٌ':Added, #1: 1	صِحَّةِ تَقْسِيمِ
u'صِحَّةٌ تَقْسِيمٌ':Added, #1: 1	صِحَّةِ تَقْسِيمِهِ
u'صِحَّةٌ تَقْليدٌ':Added, #2: 2	صِحَّةُ التَّقْسِيمِ
u'صِحَّةٌ تَقْليد':Added, #1: 1	صِحَّةِ التَّقْلِيدِ
u'صِحَّةٌ تَقْليدٌ':Added, #1: 1	صِحَّةِ التَّقْلِيدِ
u'صِحَّةٌ تَقْليد':Added, #1: 1	صِحَّةِ تَقْلِيدِ
u'صِحَّةٌ تَقْليدٌ':Added, #1: 1	صِحَّةِ تَقْلِيدِ
u'صِحَّةٌ تَقْليد':Added, #1: 1	صِحَّةَ تَقْلِيدِهِ
u'صِحَّةٌ تَكَفُّلٌ':Added, #1: 1	صِحَّةَ تَقْلِيدِهِ
u'صِحَّةٌ تَكْفيرٌ':Added, #1: 1	صِحَّةَ التَّكَفُّلِ
u'صِحَّةٌ تَكْفيلٌ':Added, #1: 1	صِحَّةِ التَّكْفِيرِ
u'صِحَّةٌ تَكَلُّمٌ':Added, #1: 1	صِحَّةَ التَّكْفِيلِ
u'صِحَّةٌ تَكَلُّمٌ':Added, #1: 1	صِحَّةُ التَّكَلُّمِ
u'صِحَّةٌ تَكْليفٌ':Added, #3: 3	صِحَّةِ التَّكَلُّمِ
u'صِحَّةٌ تَكْليفٌ':Added, #11: 11	صِحَّةِ التَّكْلِيفِ
u'صِحَّةٌ تَمَتُّعٌ':Added, #2: 2	صِحَّةَ التَّكْلِيفِ
u'صِحَّةٌ تَمَتُّعٌ':Added, #1: 1	صِحَّةِ تَمَتُّعِهِ
u'صِحَّةٌ تَمَتُّعٌ':Added, #3: 3	صِحَّةُ التَّمَتُّعِ
u'صِحَّةٌ تَمَلُّكٌ':Added, #4: 4	صِحَّةَ التَّمَتُّعِ
u'صِحَّةٌ تَمَلُّكٌ':Added, #1: 1	صِحَّةِ تَمَلُّكِ
u'صِحَّةٌ تَمَلُّكٌ':Added, #1: 1	صِحَّةُ تَمَلُّكِهِ
u'صِحَّةٌ تَمْلِيك':Added, #2: 2	صِحَّةِ تَمَلُّكِهِ
u'صِحَّةٌ تَمْلِيكٌ':Added, #1: 1	صِحَّةِ التَّمْلِيكِ
u'صِحَّةٌ تَنْجِيزٌ':Added, #1: 1	صِحَّةَ تَمْلِيكِ
u'صِحَّةٌ تَوْبَةٌ':Added, #1: 1	صِحَّةِ التَّنْجِيزِ
u'صِحَّةٌ تَوْبَةٌ':Added, #13: 13	صِحَّةِ التَّوْبَةِ
u'صِحَّةٌ تَوْبَةٌ':Added, #2: 2	صِحَّةَ تَوْبَتِهِ
u'صِحَّةٌ تَوْبَةٌ':Added, #2: 2	صِحَّةُ تَوْبَتِهِ
u'صِحَّةٌ تَوْبَةٌ':Added, #3: 3	صِحَّةُ التَّوْبَةِ
u'صِحَّةٌ تَوْبَةٌ':Added, #3: 3	صِحَّةِ تَوْبَةِ
u'صِحَّةٌ تَوْبَةٌ':Added, #4: 4	صِحَّةَ التَّوْبَةِ
u'صِحَّةٌ تَوَكُّلٌ':Added, #5: 5	صِحَّةِ تَوْبَتِهِ
u'صِحَّةٌ تَوْكِيلٌ':Added, #2: 2	صِحَّةِ تَوَكُّلِ
u'صِحَّةٌ تَوْكِيلٌ':Added, #18: 18	صِحَّةِ التَّوْكِيلِ
u'صِحَّةٌ تَوْكِيلٌ':Added, #2: 2	صِحَّةَ التَّوْكِيلِ
u'صِحَّةٌ تَوْكِيلٌ':Added, #2: 2	صِحَّةُ تَوْكِيلِ
u'صِحَّةٌ تَوْكِيلٌ':Added, #2: 2	صِحَّةِ تَوْكِيلٍ
u'صِحَّةٌ تَوْكِيلٌ':Added, #2: 2	صِحَّةِ تَوْكِيلِهِ
u'صِحَّةٌ تَوْكِيلٌ':Added, #4: 4	صِحَّةُ التَّوْكِيلِ
u'صِحَّةٌ تَوْلِيَةٌ':Added, #6: 6	صِحَّةِ تَوْكِيلِ
u'صِحَّةٌ تَوْلِيَةٌ':Added, #2: 2	صِحَّةِ تَوْلِيَةِ
u'صِحَّةٌ تَوْلِيَةٌ':Added, #2: 2	صِحَّةِ تَوْلِيَتِهِ
u'صِحَّةٌ تَيَمُّمٌ':Added, #4: 4	صِحَّةِ التَّوْلِيَةِ
u'صِحَّةٌ تَيَمُّمٌ':Added, #10: 10	صِحَّةِ التَّيَمُّمِ
u'صِحَّةٌ تَيَمُّمٌ':Added, #1: 1	صِحَّةَ التَّيَمُّمِ
u'صِحَّةٌ تَيَمُّمٌ':Added, #1: 1	صِحَّةُ تَيَمُّمِهِ
u'صِحَّةٌ تَيَمُّمٌ':Added, #2: 2	صِحَّةِ تَيَمُّمِ
u'صِحَّةٌ ثَانِي':Added, #3: 3	صِحَّةِ تَيَمُّمِهِ
u'صِحَّةٌ ثَانِيَةٌ':Added, #1: 1	صِحَّةِ الثَّانِيَةِ
u'صِحَّةٌ ثُبُوتٌ':Added, #1: 1	صِحَّةِ الثَّانِيَةِ
u'صِحَّةٌ ثُبُوتٌ':Added, #1: 1	صِحَّةِ الثُّبُوتِ
u'صِحَّةٌ ثُبُوتٌ':Added, #1: 1	صِحَّةِ ثُبُوتِ
u'صِحَّةٌ ثُبُوتٌ':Added, #1: 1	صِحَّةَ ثُبُوتِهِ
u'صِحَّةٌ ثَمَنٌ':Added, #1: 1	صِحَّةِ ثُبُوتِهِ
u'صِحَّةٌ جَزَاءٌ':Added, #1: 1	صِحَّةَ الثَّمَنِ
u'صِحَّةٌ جِسْمٌ':Added, #5: 5	صِحَّةِ الْجَزَاءِ
u'صِحَّةٌ جمع':Added, #1: 1	صِحَّةُ الْجِسْمِ
u'صِحَّةٌ جَمْعٌ':Added, #2: 2	صِحَّةَ الْجَمْعِ
u'صِحَّةٌ جمع':Added, #2: 2	صِحَّةَ الْجَمْعِ
u'صِحَّةٌ جَمْعٌ':Added, #5: 5	صِحَّةِ الْجَمْعِ
u'صِحَّةٌ جمعة':Added, #5: 5	صِحَّةِ الْجَمْعِ
u'صِحَّةٌ جُمُعَةٌ':Added, #10: 10	صِحَّةِ الْجُمُعَةِ
u'صِحَّةٌ جمعة':Added, #10: 10	صِحَّةِ الْجُمُعَةِ
u'صِحَّةٌ جُمُعَةٌ':Added, #1: 1	صِحَّةِ جُمُعَةِ
u'صِحَّةٌ جمعة':Added, #1: 1	صِحَّةِ جُمُعَةِ
u'صِحَّةٌ جمعة':Added, #1: 1	صِحَّةَ جُمُعَتِهِ
u'صِحَّةٌ جُمُعَةٌ':Added, #2: 2	صِحَّةَ الْجُمُعَةِ
u'صِحَّةٌ جَمِيع':Added, #2: 2	صِحَّةَ الْجُمُعَةِ
u'صِحَّةٌ جِنْسٌ':Added, #1: 1	صِحَّةِ الْجَمِيعِ
u'صِحَّةٌ جَوَابٌ':Added, #1: 1	صِحَّةُ جِنْسِ
u'صِحَّةٌ جَوَابٌ':Added, #1: 1	صِحَّةُ الْجَوَابِ
u'صِحَّةٌ جَوَابٌ':Added, #1: 1	صِحَّةُ جَوَابِ
u'صِحَّةٌ جَوَابٌ':Added, #2: 2	صِحَّةِ جَوَابِ
u'صِحَّةٌ جوارح':Added, #3: 3	صِحَّةِ الْجَوَابِ
u'صِحَّةٌ جَوَارِحُ':Added, #5: 5	صِحَّةُ الْجَوَارِحِ
u'صِحَّةٌ جَوَازٌ':Added, #5: 5	صِحَّةُ الْجَوَارِحِ
u'صِحَّةٌ جَوَازٌ':Added, #1: 1	صِحَّةُ جَوَازِ
u'صِحَّةٌ حَجٌّ':Added, #2: 2	صِحَّةِ جَوَازِ
u'صِحَّةٌ حَجٌّ':Added, #1: 1	صِحَّةُ الْحَجِّ
u'صِحَّةٌ حَجٌّ':Added, #1: 1	صِحَّةُ حَجِّ
u'صِحَّةٌ حَجٌّ':Added, #2: 2	صِحَّةِ الْحَجِّ
u'صِحَّةٌ حِجاجٌ':Added, #3: 3	صِحَّةِ حَجِّ
u'صِحَّةٌ حَدٌّ':Added, #1: 1	صِحَّةِ الْحِجَاجِ
u'صِحَّةٌ حَدٌّ':Added, #1: 1	صِحَّةُ الْحَدِّ
u'صِحَّةٌ حَدَق':Added, #2: 2	صِحَّةِ الْحَدِّ
u'صِحَّةٌ حَدَقَة':Added, #1: 1	صِحَّةِ الْحَدَقَةِ
u'صِحَّةٌ حَديثٌ':Added, #1: 1	صِحَّةِ الْحَدَقَةِ
u'صِحَّةٌ حَديثٌ':Added, #13: 13	صِحَّةِ الْحَدِيثِ
u'صِحَّةٌ حَديثٌ':Added, #1: 1	صِحَّةَ الْحَدِيثِ
u'صِحَّةٌ حَديثٌ':Added, #1: 1	صِحَّةِ حَدِيثٍ
u'صِحَّةٌ حَديثٌ':Added, #2: 2	صِحَّةِ حَدِيثِ
u'صِحَّةٌ حَطّ':Added, #3: 3	صِحَّةُ الْحَدِيثِ
u'صِحَّةٌ حَطّ':Added, #1: 1	صِحَّةَ الْحَطِّ
u'صِحَّةٌ حِفْظٌ':Added, #1: 1	صِحَّةِ الْحَطِّ
u'صِحَّةٌ حَقِيقٌ':Added, #1: 1	صِحَّةِ حِفْظِ
u'صِحَّةٌ حَقِيقَةٌ':Added, #1: 1	صِحَّةُ الْحَقِيقَةِ
u'صِحَّةٌ حُكْمٌ':Added, #1: 1	صِحَّةُ الْحَقِيقَةِ
u'صِحَّةٌ حُكْمٌ':Added, #12: 12	صِحَّةِ الْحُكْمِ
u'صِحَّةٌ حُكْمٌ':Added, #1: 1	صِحَّةُ حُكْمِ
u'صِحَّةٌ حُكْمٌ':Added, #2: 2	صِحَّةِ حُكْمِ
u'صِحَّةٌ حُكْمٌ':Added, #2: 2	صِحَّةِ حُكْمِهِ
u'صِحَّةٌ حَمْلٌ':Added, #5: 5	صِحَّةَ الْحُكْمِ
u'صِحَّةٌ حَمْلٌ':Added, #1: 1	صِحَّةُ الْحَمْلِ
u'صِحَّةٌ حَوَالَةٌ':Added, #1: 1	صِحَّةُ حَمْلِهِ
u'صِحَّةٌ حَوَالَةٌ':Added, #1: 1	صِحَّةَ الْحَوَالَةِ
u'صِحَّةٌ حَوَالَةٌ':Added, #5: 5	صِحَّةِ الْحَوَالَةِ
u'صِحَّةٌ حَوْزٌ':Added, #6: 6	صِحَّةُ الْحَوَالَةِ
u'صِحَّةٌ حَوْزٌ':Added, #1: 1	صِحَّةَ حَوْزِ
u'صِحَّةٌ حِيازَة':Added, #1: 1	صِحَّةُ حَوْزِ
u'صِحَّةٌ خَبَرٌ':Added, #1: 1	صِحَّةُ حِيَازَةِ
u'صِحَّةٌ خَبَر':Added, #1: 1	صِحَّةُ الْخَبَرِ
u'صِحَّةٌ خَبَرٌ':Added, #1: 1	صِحَّةُ الْخَبَرِ
u'صِحَّةٌ خَبَر':Added, #1: 1	صِحَّةِ خَبَرِ
u'صِحَّةٌ خَبَرٌ':Added, #1: 1	صِحَّةِ خَبَرِ
u'صِحَّةٌ خَبَر':Added, #2: 2	صِحَّةَ الْخَبَرِ
u'صِحَّةٌ خَبَرٌ':Added, #2: 2	صِحَّةَ الْخَبَرِ
u'صِحَّةٌ خَبَر':Added, #9: 9	صِحَّةِ الْخَبَرِ
u'صِحَّةٌ خراج':Added, #9: 9	صِحَّةِ الْخَبَرِ
u'صِحَّةٌ خَرَاجٌ':Added, #1: 1	صِحَّةُ الْخَرَاجِ
u'صِحَّةٌ خَطٌّ':Added, #1: 1	صِحَّةُ الْخَرَاجِ
u'صِحَّةٌ خطبة':Added, #1: 1	صِحَّةَ خَطِّهِ
u'صِحَّةٌ خُطْبَةٌ':Added, #1: 1	صِحَّةُ خُطْبَةِ
u'صِحَّةٌ خطبة':Added, #1: 1	صِحَّةُ خُطْبَةِ
u'صِحَّةٌ خُطْبَةٌ':Added, #1: 1	صِحَّةِ خُطْبَتِهِ
u'صِحَّةٌ خطبة':Added, #1: 1	صِحَّةِ خُطْبَتِهِ
u'صِحَّةٌ خُطْبَةٌ':Added, #2: 2	صِحَّةِ خُطْبَةِ
u'صِحَّةٌ خطبة':Added, #2: 2	صِحَّةِ خُطْبَةِ
u'صِحَّةٌ خُطْبَةٌ':Added, #4: 4	صِحَّةِ الْخُطْبَةِ
u'صِحَّةٌ خِلاَفٌ':Added, #4: 4	صِحَّةِ الْخُطْبَةِ
u'صِحَّةٌ خِلاَفٌ':Added, #1: 1	صِحَّةَ خِلَافِهِ
u'صِحَّةٌ خِلاَفَةٌ':Added, #3: 3	صِحَّةِ الْخِلَافِ
u'صِحَّةٌ خِلاَفَةٌ':Added, #1: 1	صِحَّةِ خِلَافَةِ
u'صِحَّةٌ خلط':Added, #1: 1	صِحَّةَ خِلَافَتِهِ
u'صِحَّةٌ خَلْعٌ':Added, #1: 1	صِحَّةِ الْخَلْطِ
u'صِحَّةٌ خُلْعٌ':Added, #1: 1	صِحَّةِ خَلْعِ
u'صِحَّةٌ خُلْعٌ':Added, #1: 1	صِحَّةَ خُلْعِ
u'صِحَّةٌ خُلْعٌ':Added, #2: 2	صِحَّةُ الْخُلْعِ
u'صِحَّةٌ خُلْعٌ':Added, #3: 3	صِحَّةَ الْخُلْعِ
u'صِحَّةٌ خُلْعٌ':Added, #3: 3	صِحَّةِ الْخُلْعِ
u'صِحَّةٌ خَلْوَةٌ':Added, #4: 4	صِحَّةِ خُلْعِ
u'صِحَّةٌ خَلْوَةٌ':Added, #15: 15	صِحَّةَ الْخَلْوَةِ
u'صِحَّةٌ خَلْوَةٌ':Added, #1: 1	صِحَّةِ خَلْوَتِهِ
u'صِحَّةٌ خَلْوَةٌ':Added, #2: 2	صِحَّةِ خَلْوَةِ
u'صِحَّةٌ خيار':Added, #3: 3	صِحَّةِ الْخَلْوَةِ
u'صِحَّةٌ خِيَارٌ':Added, #1: 1	صِحَّةِ الْخِيَارِ
u'صِحَّةٌ خيار':Added, #1: 1	صِحَّةِ الْخِيَارِ
u'صِحَّةٌ خِيَارٌ':Added, #2: 2	صِحَّةِ خِيَارِ
u'صِحَّةٌ دُخُولٌ':Added, #2: 2	صِحَّةِ خِيَارِ
u'صِحَّةٌ دُخُولٌ':Added, #1: 1	صِحَّةُ الدُّخُولِ
u'صِحَّةٌ دُعَاءٌ':Added, #1: 1	صِحَّةِ دُخُولِ
u'صِحَّةٌ دَعْوَةٌ':Added, #1: 1	صِحَّةَ الدُّعَاءِ
u'صِحَّةٌ دَعْوَةٌ':Added, #1: 1	صِحَّةُ دَعْوَةِ
u'صِحَّةٌ دَعْوَةٌ':Added, #2: 2	صِحَّةِ الدَّعْوَةِ
u'صِحَّةٌ دَعْوَةٌ':Added, #2: 2	صِحَّةَ دَعْوَةِ
u'صِحَّةٌ دَعْوَةٌ':Added, #2: 2	صِحَّةَ دَعْوَتِهِ
u'صِحَّةٌ دَعْوَةٌ':Added, #2: 2	صِحَّةُ دَعْوَتِهِ
u'صِحَّةٌ دفع':Added, #5: 5	صِحَّةِ دَعْوَتِهِ
u'صِحَّةٌ دَفْعٌ':Added, #1: 1	صِحَّةِ الدَّفْعِ
u'صِحَّةٌ دفع':Added, #1: 1	صِحَّةِ الدَّفْعِ
u'صِحَّةٌ دَفْعٌ':Added, #1: 1	صِحَّةُ دَفْعِ
u'صِحَّةٌ دَلالَةٌ':Added, #1: 1	صِحَّةُ دَفْعِ
u'صِحَّةٌ دَلالَةٌ':Added, #1: 1	صِحَّةِ الدَّلَالَةِ
u'صِحَّةٌ دَليلٌ':Added, #1: 1	صِحَّةِ دَلَالَةِ
u'صِحَّةٌ دَليلٌ':Added, #1: 1	صِحَّةَ دَلِيلِ
u'صِحَّةٌ دَليلٌ':Added, #1: 1	صِحَّةِ دَلِيلِ
u'صِحَّةٌ دَليلٌ':Added, #1: 1	صِحَّةِ دَلِيلِهِ
u'صِحَّةٌ دَليلٌ':Added, #3: 3	صِحَّةَ الدَّلِيلِ
u'صِحَّةٌ دَواعِي':Added, #3: 3	صِحَّةِ الدَّلِيلِ
u'صِحَّةٌ دَوَاعِي':Added, #1: 1	صِحَّةَ دَوَاعِيهِ
u'صِحَّةٌ دَوْرٌ':Added, #1: 1	صِحَّةَ دَوَاعِيهِ
u'صِحَّةٌ دَوْرٌ':Added, #1: 1	صِحَّةُ الدَّوْرِ
u'صِحَّةٌ دَوْرٌ':Added, #20: 20	صِحَّةِ الدَّوْرِ
u'صِحَّةٌ دِينٌ':Added, #2: 2	صِحَّةَ الدَّوْرِ
u'صِحَّةٌ ذَكاةٌ':Added, #1: 1	صِحَّةِ دِينِ
u'صِحَّةٌ ذَكاةٌ':Added, #1: 1	صِحَّةِ الذَّكَاةِ
u'صِحَّةٌ ذَكاةٌ':Added, #1: 1	صِحَّةُ ذَكَاةِ
u'صِحَّةٌ ذكر':Added, #3: 3	صِحَّةِ ذَكَاةِ
u'صِحَّةٌ ذِكْرٌ':Added, #1: 1	صِحَّةُ ذِكْرِ
u'صِحَّةٌ ذِمَّةٌ':Added, #1: 1	صِحَّةُ ذِكْرِ
u'صِحَّةٌ ذِهْنٌ':Added, #1: 1	صِحَّةِ الذِّمَّةِ
u'صِحَّةٌ رَأْيٌ':Added, #1: 1	صِحَّةَ الذِّهْنِ
u'صِحَّةٌ رَأْيٌ':Added, #1: 1	صِحَّةُ الرَّأْيِ
u'صِحَّةٌ رجعة':Added, #1: 1	صِحَّةِ الرَّأْيِ
u'صِحَّةٌ رَجْعَةٌ':Added, #1: 1	صِحَّةُ رَجْعَةِ
u'صِحَّةٌ رجعة':Added, #1: 1	صِحَّةُ رَجْعَةِ
u'صِحَّةٌ رَجْعَةٌ':Added, #2: 2	صِحَّةُ الرَّجْعَةِ
u'صِحَّةٌ رجعة':Added, #2: 2	صِحَّةُ الرَّجْعَةِ
u'صِحَّةٌ رَجْعَةٌ':Added, #3: 3	صِحَّةَ الرَّجْعَةِ
u'صِحَّةٌ رجعة':Added, #3: 3	صِحَّةَ الرَّجْعَةِ
u'صِحَّةٌ رَجْعَةٌ':Added, #6: 6	صِحَّةِ الرَّجْعَةِ
u'صِحَّةٌ رُجُوعٌ':Added, #6: 6	صِحَّةِ الرَّجْعَةِ
u'صِحَّةٌ رُجُوعٌ':Added, #11: 11	صِحَّةِ الرُّجُوعِ
u'صِحَّةٌ رُجُوعٌ':Added, #1: 1	صِحَّةَ الرُّجُوعِ
u'صِحَّةٌ رُجُوعٌ':Added, #1: 1	صِحَّةُ الرُّجُوعِ
u'صِحَّةٌ رُجُوعٌ':Added, #1: 1	صِحَّةِ رُجُوعِ
u'صِحَّةٌ رَدٌّ':Added, #1: 1	صِحَّةِ رُجُوعِهِ
u'صِحَّةٌ رَدٌّ':Added, #1: 1	صِحَّةُ الرَّدِّ
u'صِحَّةٌ رِدَّةٌ':Added, #5: 5	صِحَّةِ الرَّدِّ
u'صِحَّةٌ رِدَّةٌ':Added, #1: 1	صِحَّةُ رِدَّتِهِ
u'صِحَّةٌ رَفْعٌ':Added, #1: 1	صِحَّةِ رِدَّتِهِ
u'صِحَّةٌ رَفْعٌ':Added, #1: 1	صِحَّةُ الرَّفْعِ
u'صِحَّةٌ رَفْعٌ':Added, #1: 1	صِحَّةَ رَفْعِ
u'صِحَّةٌ ركعة':Added, #1: 1	صِحَّةَ رَفْعِهِ
u'صِحَّةٌ رَكْعَةٌ':Added, #2: 2	صِحَّةِ الرَّكْعَةِ
u'صِحَّةٌ رَهْنٌ':Added, #2: 2	صِحَّةِ الرَّكْعَةِ
u'صِحَّةٌ رَهْنٌ':Added, #1: 1	صِحَّةَ رَهْنِ
u'صِحَّةٌ رَهْنٌ':Added, #1: 1	صِحَّةِ رَهْنِ
u'صِحَّةٌ رَهْنٌ':Added, #1: 1	صِحَّةَ رَهْنِهِ
u'صِحَّةٌ رَهْنٌ':Added, #2: 2	صِحَّةِ رَهْنِهِ
u'صِحَّةٌ رَهْنٌ':Added, #3: 3	صِحَّةُ الرَّهْنِ
u'صِحَّةٌ رَهْنٌ':Added, #6: 6	صِحَّةُ رَهْنِهِ
u'صِحَّةٌ رَهْنٌ':Added, #8: 8	صِحَّةَ الرَّهْنِ
u'صِحَّةٌ رِوايَةٌ':Added, #8: 8	صِحَّةِ الرَّهْنِ
u'صِحَّةٌ رِوايَةٌ':Added, #1: 1	صِحَّةِ رِوَايَتِهِ
u'صِحَّةٌ رِوايَةٌ':Added, #2: 2	صِحَّةَ الرِّوَايَةِ
u'صِحَّةٌ رِوايَةٌ':Added, #2: 2	صِحَّةِ رِوَايَةِ
u'صِحَّةٌ رُؤْيَةٌ':Added, #5: 5	صِحَّةِ الرِّوَايَةِ
u'صِحَّةٌ زائِدٌ':Added, #1: 1	صِحَّةِ الرُّؤْيَةِ
u'صِحَّةٌ زَكاةٌ':Added, #1: 1	صِحَّةِ الزَّائِدِ
u'صِحَّةٌ زِيادَةٌ':Added, #1: 1	صِحَّةِ الزَّكَاةِ
u'صِحَّةٌ زِيادَةٌ':Added, #1: 1	صِحَّةَ الزِّيَادَةِ
u'صِحَّةٌ زِيادَةٌ':Added, #1: 1	صِحَّةُ الزِّيَادَةِ
u'صِحَّةٌ زَيْدٌ':Added, #3: 3	صِحَّةِ الزِّيَادَةِ
u'صِحَّةٌ سَائِرٌ':Added, #1: 1	صِحَّةَ زَيْدٍ
u'صِحَّةٌ سَائِرٌ':Added, #1: 1	صِحَّةَ سَائِرِ
u'صِحَّةٌ سَبَبٌ':Added, #2: 2	صِحَّةِ سَائِرِ
u'صِحَّةٌ سَبَبِيَّةٌ':Added, #4: 4	صِحَّةِ السَّبَبِ
u'صِحَّةٌ سِجِلٌّ':Added, #1: 1	صِحَّةِ السَّبَبِيَّةِ
u'صِحَّةٌ سُجُودٌ':Added, #1: 1	صِحَّةِ السِّجِلِّ
u'صِحَّةٌ سلام':Added, #1: 1	صِحَّةَ السُّجُودِ
u'صِحَّةٌ سَلاَمٌ':Added, #1: 1	صِحَّةَ سَلَامِهِ
u'صِحَّةٌ سَلْطَنَةٌ':Added, #1: 1	صِحَّةَ سَلَامِهِ
u'صِحَّةٌ سَلَفٌ':Added, #1: 1	صِحَّةُ سَلْطَنَةِ
u'صِحَّةٌ سَلَمٌ':Added, #1: 1	صِحَّةُ السَّلَفِ
u'صِحَّةٌ سَلَمٌ':Added, #19: 19	صِحَّةِ السَّلَمِ
u'صِحَّةٌ سَلَمٌ':Added, #1: 1	صِحَّة السَّلَمِ
u'صِحَّةٌ سَلَمٌ':Added, #1: 1	صِحَّةَ سَلَمِ
u'صِحَّةٌ سَلَمٌ':Added, #4: 4	صِحَّةَ السَّلَمِ
u'صِحَّةٌ سَمَاعٌ':Added, #7: 7	صِحَّةُ السَّلَمِ
u'صِحَّةٌ سَمَاعٌ':Added, #1: 1	صِحَّةِ السَّمَاعِ
u'صِحَّةٌ سَمَاعٌ':Added, #1: 1	صِحَّةُ سَمَاعِ
u'صِحَّةٌ سَمَاعٌ':Added, #4: 4	صِحَّةِ سَمَاعِ
u'صِحَّةٌ سَنَدٌ':Added, #4: 4	صِحَّةِ سَمَاعِهِ
u'صِحَّةٌ سَنَدٌ':Added, #1: 1	صِحَّةُ السَّنَدِ
u'صِحَّةٌ سَنَدٌ':Added, #1: 1	صِحَّةُ سَنَدِهِ
u'صِحَّةٌ سَنَدٌ':Added, #1: 1	صِحَّةِ سَنَدِهِ
u'صِحَّةٌ سَيِّدٌ':Added, #2: 2	صِحَّةِ السَّنَدِ
u'صِحَّةٌ شِرَاءٌ':Added, #1: 1	صِحَّةِ السَّيِّدِ
u'صِحَّةٌ شِرَاءٌ':Added, #1: 1	صِحَّةَ الشِّرَاءِ
u'صِحَّةٌ شِرَاءٌ':Added, #3: 3	صِحَّةِ الشِّرَاءِ
u'صِحَّةٌ شِرَاءٌ':Added, #4: 4	صِحَّةِ شِرَاءِ
u'صِحَّةٌ شَرْطٌ':Added, #5: 5	صِحَّةُ الشِّرَاءِ
u'صِحَّةٌ شَرْطٌ':Added, #1: 1	صِحَّةُ شَرْطِ
u'صِحَّةٌ شَرْطٌ':Added, #1: 1	صِحَّةِ شَرْطِهِ
u'صِحَّةٌ شَرْطٌ':Added, #2: 2	صِحَّةِ شَرْطِ
u'صِحَّةٌ شَرْطٌ':Added, #4: 4	صِحَّةَ شَرْطِ
u'صِحَّةٌ شَرْطٌ':Added, #5: 5	صِحَّةِ الشَّرْطِ
u'صِحَّةٌ شَرْطٌ':Added, #7: 7	صِحَّةَ الشَّرْطِ
u'صِحَّةٌ شَرْعٌ':Added, #8: 8	صِحَّةُ الشَّرْطِ
u'صِحَّةٌ شَرْعِيٌّ':Added, #1: 1	صِحَّةِ الشَّرْعِ
u'صِحَّةٌ شركة':Added, #1: 1	صِحَّةِ شَرْعِيَّةٍ
u'صِحَّةٌ شَرِكَةٌ':Added, #1: 1	صِحَّةَ الشَّرِكَةِ
u'صِحَّةٌ شركة':Added, #1: 1	صِحَّةَ الشَّرِكَةِ
u'صِحَّةٌ شَرِكَةٌ':Added, #1: 1	صِحَّةَ شَرِكَةِ
u'صِحَّةٌ شركة':Added, #1: 1	صِحَّةَ شَرِكَةِ
u'صِحَّةٌ شَرِكَةٌ':Added, #3: 3	صِحَّةِ الشَّرِكَةِ
u'صِحَّةٌ شُرُوطٌ':Added, #3: 3	صِحَّةِ الشَّرِكَةِ
u'صِحَّةٌ شُرُوعٌ':Added, #1: 1	صِحَّةِ شُرُوطِهِ
u'صِحَّةٌ شُرُوعٌ':Added, #1: 1	صِحَّةِ شُرُوعٍ
u'صِحَّةٌ شُرُوعٌ':Added, #1: 1	صِحَّةِ شُرُوعِ
u'صِحَّةٌ شُرُوعٌ':Added, #25: 25	صِحَّةِ الشُّرُوعِ
u'صِحَّةٌ شُرُوعٌ':Added, #4: 4	صِحَّةُ الشُّرُوعِ
u'صِحَّةٌ شُرُوعٌ':Added, #4: 4	صِحَّةِ شُرُوعِهِ
u'صِحَّةٌ شفعة':Added, #8: 8	صِحَّةَ الشُّرُوعِ
u'صِحَّةٌ شُفْعَةٌ':Added, #1: 1	صِحَّةِ الشُّفْعَةِ
u'صِحَّةٌ شَهَادَةٌ':Added, #1: 1	صِحَّةِ الشُّفْعَةِ
u'صِحَّةٌ شَهَادَةٌ':Added, #1: 1	صِحَّةُ الشَّهَادَةِ
u'صِحَّةٌ شَهَادَةٌ':Added, #2: 2	صِحَّةِ شَهَادَتِهِ
u'صِحَّةٌ شَهَادَةٌ':Added, #3: 3	صِحَّةَ الشَّهَادَةِ
u'صِحَّةٌ شَهَادَةٌ':Added, #3: 3	صِحَّةِ شَهَادَةِ
u'صِحَّةٌ شَيْءٌ':Added, #4: 4	صِحَّةِ الشَّهَادَةِ
u'صِحَّةٌ صَحِيحٌ':Added, #1: 1	صِحَّةِ الشَّيْءِ
u'صِحَّةٌ صداق':Added, #2: 2	صِحَّةَ الصَّحِيحِ
u'صِحَّةٌ صَدَاقٌ':Added, #1: 1	صِحَّةَ صَدَاقِهِ
u'صِحَّةٌ صداق':Added, #1: 1	صِحَّةَ صَدَاقِهِ
u'صِحَّةٌ صَدَاقٌ':Added, #2: 2	صِحَّةُ الصَّدَاقِ
u'صِحَّةٌ صدقة':Added, #2: 2	صِحَّةُ الصَّدَاقِ
u'صِحَّةٌ صَدَقَةٌ':Added, #1: 1	صِحَّةِ الصَّدَقَةِ
u'صِحَّةٌ صَرْفٌ':Added, #1: 1	صِحَّةِ الصَّدَقَةِ
u'صِحَّةٌ صَرْف':Added, #1: 1	صِحَّةَ الصَّرْفِ
u'صِحَّةٌ صَرْفٌ':Added, #1: 1	صِحَّةَ الصَّرْفِ
u'صِحَّةٌ صَرْف':Added, #1: 1	صِحَّةَ صَرْفِ
u'صِحَّةٌ صَرْفٌ':Added, #1: 1	صِحَّةَ صَرْفِ
u'صِحَّةٌ صَرْف':Added, #1: 1	صِحَّةُ صَرْفِهِ
u'صِحَّةٌ صَرْفٌ':Added, #1: 1	صِحَّةُ صَرْفِهِ
u'صِحَّةٌ صَرْف':Added, #2: 2	صِحَّةِ الصَّرْفِ
u'صِحَّةٌ صِفَةٌ':Added, #2: 2	صِحَّةِ الصَّرْفِ
u'صِحَّةٌ صَلاَةٌ':Added, #1: 1	صِحَّةُ الصِّفَةِ
u'صِحَّةٌ صَلاَةٌ':Added, #12: 12	صِحَّةَ الصَّلَاةِ
u'صِحَّةٌ صَلاَةٌ':Added, #19: 19	صِحَّةُ الصَّلَاةِ
u'صِحَّةٌ صَلاَةٌ':Added, #19: 19	صِحَّةِ صَلَاتِهِ
u'صِحَّةٌ صَلاَةٌ':Added, #1: 1	صِحَّةِ الصَّلاَةِ
u'صِحَّةٌ صَلاَةٌ':Added, #1: 1	صِحَّةُ صَلَاةٍ
u'صِحَّةٌ صَلاَةٌ':Added, #26: 26	صِحَّةِ صَلَاةِ
u'صِحَّةٌ صَلاَةٌ':Added, #2: 2	صِحَّةَ صَلَاةٍ
u'صِحَّةٌ صَلاَةٌ':Added, #4: 4	صِحَّةَ صَلَاةِ
u'صِحَّةٌ صَلاَةٌ':Added, #4: 4	صِحَّةَ صَلَاتِهِ
u'صِحَّةٌ صَلاَةٌ':Added, #53: 53	صِحَّةِ الصَّلَاةِ
u'صِحَّةٌ صَلاَةٌ':Added, #7: 7	صِحَّةُ صَلَاةِ
u'صِحَّةٌ صلح':Added, #8: 8	صِحَّةُ صَلَاتِهِ
u'صِحَّةٌ صُلْحٌ':Added, #1: 1	صِحَّة الصُّلْحِ
u'صِحَّةٌ صلح':Added, #1: 1	صِحَّة الصُّلْحِ
u'صِحَّةٌ صُلْحٌ':Added, #3: 3	صِحَّةَ الصُّلْحِ
u'صِحَّةٌ صلح':Added, #3: 3	صِحَّةَ الصُّلْحِ
u'صِحَّةٌ صُلْحٌ':Added, #4: 4	صِحَّةُ الصُّلْحِ
u'صِحَّةٌ صلح':Added, #4: 4	صِحَّةُ الصُّلْحِ
u'صِحَّةٌ صُلْحٌ':Added, #6: 6	صِحَّةِ الصُّلْحِ
u'صِحَّةٌ صَلَوَاتٌ':Added, #6: 6	صِحَّةِ الصُّلْحِ
u'صِحَّةٌ صُورَةٌ':Added, #2: 2	صِحَّةِ الصَّلَوَاتِ
u'صِحَّةٌ صَوْغٌ':Added, #1: 1	صِحَّةِ الصُّورَةِ
u'صِحَّةٌ صَوْمٌ':Added, #1: 1	صِحَّةُ صَوْغِ
u'صِحَّةٌ صَوْمٌ':Added, #1: 1	صِحَّةُ الصَّوْمِ
u'صِحَّةٌ صَوْمٌ':Added, #1: 1	صِحَّةَ صَوْمٍ
u'صِحَّةٌ صَوْمٌ':Added, #2: 2	صِحَّةِ صَوْمِهِ
u'صِحَّةٌ صَوْمٌ':Added, #3: 3	صِحَّةَ صَوْمِ
u'صِحَّةٌ صَوْمٌ':Added, #3: 3	صِحَّةُ صَوْمِ
u'صِحَّةٌ صَوْمٌ':Added, #5: 5	صِحَّةَ الصَّوْمِ
u'صِحَّةٌ صَوْمٌ':Added, #6: 6	صِحَّةِ الصَّوْمِ
u'صِحَّةٌ صِيَامٌ':Added, #6: 6	صِحَّةِ صَوْمِ
u'صِحَّةٌ صِيَامٌ':Added, #1: 1	صِحَّةِ صِيَامِ
u'صِحَّةٌ صِيغَةٌ':Added, #1: 1	صِحَّةِ صِيَامِهِ
u'صِحَّةٌ صِيغَةٌ':Added, #1: 1	صِحَّةَ الصِّيغَةِ
u'صِحَّةٌ صِيغَةٌ':Added, #1: 1	صِحَّةِ الصِّيغَةِ
u'صِحَّةٌ ضَمٌّ':Added, #2: 2	صِحَّةُ الصِّيغَةِ
u'صِحَّةٌ ضَمٌّ':Added, #1: 1	صِحَّةَ الضَّمِّ
u'صِحَّةٌ ضَمَانٌ':Added, #1: 1	صِحَّةِ ضَمِّ
u'صِحَّةٌ ضَمَانٌ':Added, #13: 13	صِحَّةِ ضَمَانِ
u'صِحَّةٌ ضَمَانٌ':Added, #2: 2	صِحَّةُ الضَّمَانِ
u'صِحَّةٌ ضَمَانٌ':Added, #2: 2	صِحَّةَ ضَمَانِهِ
u'صِحَّةٌ ضَمَانٌ':Added, #3: 3	صِحَّةَ الضَّمَانِ
u'صِحَّةٌ ضَمَانٌ':Added, #4: 4	صِحَّةُ ضَمَانِ
u'صِحَّةٌ ضَمَانٌ':Added, #5: 5	صِحَّةَ ضَمَانِ
u'صِحَّةٌ ضَمَانٌ':Added, #8: 8	صِحَّةِ ضَمَانِهِ
u'صِحَّةٌ طَبِيعَةٌ':Added, #9: 9	صِحَّةِ الضَّمَانِ
u'صِحَّةٌ طَرِيقٌ':Added, #1: 1	صِحَّةِ الطَّبِيعَةِ
u'صِحَّةٌ طَلاَقٌ':Added, #2: 2	صِحَّةِ طَرِيقِهِ
u'صِحَّةٌ طَلاَقٌ':Added, #1: 1	صِحَّةَ الطَّلَاقِ
u'صِحَّةٌ طَلاَقٌ':Added, #1: 1	صِحَّةِ طَلَاقِ
u'صِحَّةٌ طَلاَقٌ':Added, #1: 1	صِحَّةِ طَلاَقِهِ
u'صِحَّةٌ طَلاَقٌ':Added, #2: 2	صِحَّةُ الطَّلَاقِ
u'صِحَّةٌ طَلاَقٌ':Added, #2: 2	صِحَّةِ الطَّلَاقِ
u'صِحَّةٌ طلب':Added, #4: 4	صِحَّةِ طَلَاقِهِ
u'صِحَّةٌ طَلَبٌ':Added, #1: 1	صِحَّةِ طَلَبِهِ
u'صِحَّةٌ طَهَارَةٌ':Added, #1: 1	صِحَّةِ طَلَبِهِ
u'صِحَّةٌ طَهَارَةٌ':Added, #1: 1	صِحَّةِ طَهَارَةِ
u'صِحَّةٌ طَهَارَةٌ':Added, #2: 2	صِحَّةَ الطَّهَارَةِ
u'صِحَّةٌ طهر':Added, #2: 2	صِحَّةِ طَهَارَتِهِ
u'صِحَّةٌ طُهْرٌ':Added, #1: 1	صِحَّةِ الطُّهْرِ
u'صِحَّةٌ طهر':Added, #1: 1	صِحَّةِ الطُّهْرِ
u'صِحَّةٌ طُهْرٌ':Added, #1: 1	صِحَّةَ طُهْرِ
u'صِحَّةٌ طواف':Added, #1: 1	صِحَّةَ طُهْرِ
u'صِحَّةٌ طَوَافٌ':Added, #1: 1	صِحَّةُ طَوَافِ
u'صِحَّةٌ طواف':Added, #1: 1	صِحَّةُ طَوَافِ
u'صِحَّةٌ طَوَافٌ':Added, #1: 1	صِحَّةِ طَوَافِهِ
u'صِحَّةٌ طواف':Added, #1: 1	صِحَّةِ طَوَافِهِ
u'صِحَّةٌ طواف':Added, #2: 2	صِحَّةُ الطَّوَافِ
u'صِحَّةٌ طَوَافٌ':Added, #2: 2	صِحَّةِ الطَّوَافِ
u'صِحَّةٌ طَوَافٌ':Added, #2: 2	صِحَّةُ الطَّوَافِ
u'صِحَّةٌ ظاهِرٌ':Added, #2: 2	صِحَّةِ الطَّوَافِ
u'صِحَّةٌ ظَنٌّ':Added, #3: 3	صِحَّةِ الظَّاهِرِ
u'صِحَّةٌ ظَنٌّ':Added, #1: 1	صِحَّةُ الظَّنِّ
u'صِحَّةٌ ظهار':Added, #1: 1	صِحَّةُ ظَنِّهِ
u'صِحَّةٌ ظهار':Added, #1: 1	صِحَّةُ الظِّهَارِ
u'صِحَّةٌ ظهار':Added, #1: 1	صِحَّةَ ظِهَارِ
u'صِحَّةٌ ظهار':Added, #1: 1	صِحَّةُ ظِهَارِ
u'صِحَّةٌ ظهار':Added, #1: 1	صِحَّةِ ظِهَارِهِ
u'صِحَّةٌ ظهار':Added, #2: 2	صِحَّةِ الظِّهَارِ
u'صِحَّةٌ ظُهْرٌ':Added, #2: 2	صِحَّةِ ظِهَارِ
u'صِحَّةٌ ظُهْرٌ':Added, #1: 1	صِحَّةَ الظُّهْرِ
u'صِحَّةٌ عِبَادَةٌ':Added, #1: 1	صِحَّةِ ظُهْرِهِ
u'صِحَّةٌ عِبَادَةٌ':Added, #1: 1	صِحَّةُ الْعِبَادَاتِ
u'صِحَّةٌ عِبَادَةٌ':Added, #1: 1	صِحَّةِ الْعِبَادَاتِ
u'صِحَّةٌ عِبَادَةٌ':Added, #1: 1	صِحَّةَ عِبَادَاتِهِ
u'صِحَّةٌ عِبَادَةٌ':Added, #1: 1	صِحَّةُ عِبَادَةِ
u'صِحَّةٌ عِبَادَةٌ':Added, #1: 1	صِحَّةُ عِبَادَتِهِ
u'صِحَّةٌ عِبَادَةٌ':Added, #2: 2	صِحَّةُ الْعِبَادَةِ
u'صِحَّةٌ عِبَادَةٌ':Added, #2: 2	صِحَّةِ عِبَادَتِهِ
u'صِحَّةٌ عِبَارَةٌ':Added, #4: 4	صِحَّةِ الْعِبَادَةِ
u'صِحَّةٌ عِبَارَةٌ':Added, #1: 1	صِحَّةَ الْعِبَارَةِ
u'صِحَّةٌ عِبَارَةٌ':Added, #1: 1	صِحَّةُ الْعِبَارَةِ
u'صِحَّةٌ عَبْدٌ':Added, #2: 2	صِحَّةُ عِبَارَتِهِ
u'صِحَّةٌ عتاق':Added, #1: 1	صِحَّةِ الْعَبْدِ
u'صِحَّةٌ عتق':Added, #1: 1	صِحَّةَ الْعَتَاقِ
u'صِحَّةٌ عتق':Added, #1: 1	صِحَّةَ الْعِتْقِ
u'صِحَّةٌ عِتْقٌ':Added, #1: 1	صِحَّةُ الْعِتْقِ
u'صِحَّةٌ عِتْقٌ':Added, #1: 1	صِحَّةَ الْعِتْقِ
u'صِحَّةٌ عتق':Added, #1: 1	صِحَّةُ الْعِتْقِ
u'صِحَّةٌ عِتْقٌ':Added, #1: 1	صِحَّةُ عِتْقِ
u'صِحَّةٌ عتق':Added, #1: 1	صِحَّةُ عِتْقِ
u'صِحَّةٌ عِتْقٌ':Added, #2: 2	صِحَّةُ عِتْقِهِ
u'صِحَّةٌ عتق':Added, #2: 2	صِحَّةُ عِتْقِهِ
u'صِحَّةٌ عِتْقٌ':Added, #3: 3	صِحَّةِ الْعِتْقِ
u'صِحَّةٌ عتق':Added, #3: 3	صِحَّةِ الْعِتْقِ
u'صِحَّةٌ عِتْقٌ':Added, #3: 3	صِحَّةِ عِتْقِهِ
u'صِحَّةٌ عتق':Added, #3: 3	صِحَّةِ عِتْقِهِ
u'صِحَّةٌ عتق':Added, #5: 5	صِحَّةَ عِتْقِ
u'صِحَّةٌ عِتْقٌ':Added, #5: 5	صِحَّةِ عِتْقِ
u'صِحَّةٌ عِتْقٌ':Added, #5: 5	صِحَّةَ عِتْقِ
u'صِحَّةٌ عتق':Added, #5: 5	صِحَّةِ عِتْقِ
u'صِحَّةٌ عِتْقٌ':Added, #5: 5	صِحَّةَ عِتْقِهِ
u'صِحَّةٌ عزل':Added, #5: 5	صِحَّةَ عِتْقِهِ
u'صِحَّةٌ عزل':Added, #2: 2	صِحَّةِ عَزْلِهِ
u'صِحَّةٌ عِشَاءٌ':Added, #4: 4	صِحَّةِ عَزْلِ
u'صِحَّةٌ عَصْرٌ':Added, #1: 1	صِحَّةِ الْعِشَاءِ
u'صِحَّةٌ عُضْوٌ':Added, #3: 3	صِحَّةِ الْعَصْرِ
u'صِحَّةٌ عطف':Added, #1: 1	صِحَّةِ الْعُضْوِ
u'صِحَّةٌ عَطْفٌ':Added, #1: 1	صِحَّةِ عَطْفِهِ
u'صِحَّةٌ عَفْوٌ':Added, #1: 1	صِحَّةِ عَطْفِهِ
u'صِحَّةٌ عَفْوٌ':Added, #2: 2	صِحَّةَ الْعَفْوِ
u'صِحَّةٌ عَفْوٌ':Added, #2: 2	صِحَّةِ عَفْوِهِ
u'صِحَّةٌ عَفْوٌ':Added, #3: 3	صِحَّةِ الْعَفْوِ
u'صِحَّةٌ عَقْدٌ':Added, #5: 5	صِحَّةِ عَفْوِ
u'صِحَّةٌ عَقْدٌ':Added, #15: 15	صِحَّةُ الْعَقْدِ
u'صِحَّةٌ عَقْدٌ':Added, #1: 1	صِحَّةَ عَقْدِ
u'صِحَّةٌ عَقْدٌ':Added, #1: 1	صِحَّةُ عَقْدِهِ
u'صِحَّةٌ عَقْدٌ':Added, #1: 1	صِحَّةِ عَقْدِهِ
u'صِحَّةٌ عَقْدٌ':Added, #29: 29	صِحَّةَ الْعَقْدِ
u'صِحَّةٌ عَقْدٌ':Added, #2: 2	صِحَّةِ الْعَقْدَيْنِ
u'صِحَّةٌ عَقْدٌ':Added, #2: 2	صِحَّةُ عَقْدِ
u'صِحَّةٌ عَقْدٌ':Added, #2: 2	صِحَّةِ عَقْدٍ
u'صِحَّةٌ عَقْدٌ':Added, #74: 74	صِحَّةِ الْعَقْدِ
u'صِحَّةٌ عَقْلٌ':Added, #7: 7	صِحَّةِ عَقْدِ
u'صِحَّةٌ عَقْلٌ':Added, #1: 1	صِحَّةُ عَقْلِهِ
u'صِحَّةٌ عُقُودٌ':Added, #8: 8	صِحَّةِ عَقْلِهِ
u'صِحَّةٌ عُقُودٌ':Added, #1: 1	صِحَّةِ عُقُودِهِ
u'صِحَّةٌ عَقِيدَةٌ':Added, #5: 5	صِحَّةِ الْعُقُودِ
u'صِحَّةٌ عِلَّةٌ':Added, #1: 1	صِحَّةِ الْعَقِيدَةِ
u'صِحَّةٌ عِلَّةٌ':Added, #13: 13	صِحَّةِ الْعِلَّةِ
u'صِحَّةٌ عِلَّةٌ':Added, #1: 1	صِحَّةَ الْعِلَّةِ
u'صِحَّةٌ عِلَّةٌ':Added, #1: 1	صِحَّةُ الْعِلَّةِ
u'صِحَّةٌ عِلَلٌ':Added, #1: 1	صِحَّةِ عِلَّتِهِ
u'صِحَّةٌ عِلِّيٌّ':Added, #1: 1	صِحَّةِ الْعِلَلِ
u'صِحَّةٌ عِلِّيٌّ':Added, #1: 1	صِحَّةَ الْعِلِّيَّةِ
u'صِحَّةٌ عِلِّيٌّ':Added, #1: 1	صِحَّةُ الْعِلِّيَّةِ
u'صِحَّةٌ عمرة':Added, #6: 6	صِحَّةِ الْعِلِّيَّةِ
u'صِحَّةٌ عُمْرَةٌ':Added, #1: 1	صِحَّةُ الْعُمْرَةِ
u'صِحَّةٌ عمرة':Added, #1: 1	صِحَّةُ الْعُمْرَةِ
u'صِحَّةٌ عُمْرَةٌ':Added, #1: 1	صِحَّةِ عُمْرَةِ
u'صِحَّةٌ عَمَلٌ':Added, #1: 1	صِحَّةِ عُمْرَةِ
u'صِحَّةٌ عَمَلٌ':Added, #1: 1	صِحَّةَ عَمَلٍ
u'صِحَّةٌ عَمَلٌ':Added, #2: 2	صِحَّةَ الْعَمَلِ
u'صِحَّةٌ عُمُومٌ':Added, #3: 3	صِحَّةِ الْعَمَلِ
u'صِحَّةٌ عَهْدٌ':Added, #1: 1	صِحَّةَ عُمُومِهِ
u'صِحَّةٌ عَهْدٌ':Added, #1: 1	صِحَّةِ الْعَهْدِ
u'صِحَّةٌ عِوَضٌ':Added, #1: 1	صِحَّةَ عَهْدِ
u'صِحَّةٌ عَوْل':Added, #1: 1	صِحَّةَ الْعِوَضِ
u'صِحَّةٌ عين':Added, #1: 1	صِحَّةُ الْعَوْلِ
u'صِحَّةٌ عَيْنٌ':Added, #1: 1	صِحَّةِ الْعَيْنِ
u'صِحَّةٌ عَيْن':Added, #1: 1	صِحَّةِ الْعَيْنِ
u'صِحَّةٌ عين':Added, #1: 1	صِحَّةِ الْعَيْنِ
u'صِحَّةٌ عَيْنٌ':Added, #2: 2	صِحَّةَ الْعَيْنِ
u'صِحَّةٌ عَيْن':Added, #2: 2	صِحَّةَ الْعَيْنِ
u'صِحَّةٌ غَسْلٌ':Added, #2: 2	صِحَّةَ الْعَيْنِ
u'صِحَّةٌ غَسْلٌ':Added, #1: 1	صِحَّةَ الْغَسْلِ
u'صِحَّةٌ غُسْلٌ':Added, #1: 1	صِحَّةِ غَسْلِ
u'صِحَّةٌ غُسْلٌ':Added, #1: 1	صِحَّةُ غُسْلِ
u'صِحَّةٌ غُسْلٌ':Added, #2: 2	صِحَّةَ الْغُسْلِ
u'صِحَّةٌ غُسْلٌ':Added, #2: 2	صِحَّةُ الْغُسْلِ
u'صِحَّةٌ غُسْلٌ':Added, #2: 2	صِحَّةِ غُسْلِ
u'صِحَّةٌ غير':Added, #6: 6	صِحَّةِ الْغُسْلِ
u'صِحَّةٌ غَيْرٌ':Added, #1: 1	صِحَّةِ الْغَيْرِ
u'صِحَّةٌ فَجْرٌ':Added, #1: 1	صِحَّةِ الْغَيْرِ
u'صِحَّةٌ فِرَاشٌ':Added, #2: 2	صِحَّةَ الْفَجْرِ
u'صِحَّةٌ فراغ':Added, #1: 1	صِحَّةَ الْفِرَاشِ
u'صِحَّةٌ فَرَاغٌ':Added, #1: 1	صِحَّةِ الْفَرَاغِ
u'صِحَّةٌ فَرْضٌ':Added, #1: 1	صِحَّةِ الْفَرَاغِ
u'صِحَّةٌ فَرْضٌ':Added, #1: 1	صِحَّةِ الْفَرْضِ
u'صِحَّةٌ فَرْعٌ':Added, #1: 1	صِحَّةِ فَرْضِ
u'صِحَّةٌ فَرْعٌ':Added, #1: 1	صِحَّةُ الْفَرْعِ
u'صِحَّةٌ فَسْخٌ':Added, #3: 3	صِحَّةِ الْفَرْعِ
u'صِحَّةٌ فَسْخٌ':Added, #1: 1	صِحَّةَ الْفَسْخِ
u'صِحَّةٌ فَسْخٌ':Added, #1: 1	صِحَّةِ الْفَسْخِ
u'صِحَّةٌ فِعْلٌ':Added, #3: 3	صِحَّةِ فَسْخِ
u'صِحَّةٌ فِعْلٌ':Added, #1: 1	صِحَّةِ الْفِعْلَيْنِ
u'صِحَّةٌ فِعْلٌ':Added, #1: 1	صِحَّةُ فِعْلِهِ
u'صِحَّةٌ فَهْمٌ':Added, #2: 2	صِحَّةِ فِعْلِهِ
u'صِحَّةٌ فَيْءٌ':Added, #1: 1	صِحَّةِ فَهْمِ
u'صِحَّةٌ قَبْضٌ':Added, #2: 2	صِحَّةِ الْفَيْءِ
u'صِحَّةٌ قَبْضٌ':Added, #1: 1	صِحَّةِ قَبْضِ
u'صِحَّةٌ قَبْضٌ':Added, #1: 1	صِحَّةُ قَبْضِهِ
u'صِحَّةٌ قَبْضٌ':Added, #2: 2	صِحَّةُ الْقَبْضِ
u'صِحَّةٌ قَبْضٌ':Added, #3: 3	صِحَّةُ قَبْضِ
u'صِحَّةٌ قَبْضٌ':Added, #4: 4	صِحَّةَ الْقَبْضِ
u'صِحَّةٌ قَبْضٌ':Added, #4: 4	صِحَّةَ قَبْضِهِ
u'صِحَّةٌ قَبْضٌ':Added, #4: 4	صِحَّةِ قَبْضِهِ
u'صِحَّةٌ قَبُولٌ':Added, #6: 6	صِحَّةِ الْقَبْضِ
u'صِحَّةٌ قَبُولٌ':Added, #1: 1	صِحَّةِ قَبُولِ
u'صِحَّةٌ قَبُولٌ':Added, #1: 1	صِحَّةَ قَبُولِهِ
u'صِحَّةٌ قَبُولٌ':Added, #2: 2	صِحَّةِ الْقَبُولِ
u'صِحَّةٌ قَبُولٌ':Added, #2: 2	صِحَّةُ قَبُولِهِ
u'صِحَّةٌ قَبُولٌ':Added, #3: 3	صِحَّةَ الْقَبُولِ
u'صِحَّةٌ قَبُولٌ':Added, #3: 3	صِحَّةَ قَبُولِ
u'صِحَّةٌ قُدْوَةٌ':Added, #3: 3	صِحَّةِ قَبُولِهِ
u'صِحَّةٌ قُدْوَةٌ':Added, #1: 1	صِحَّةَ الْقُدْوَةِ
u'صِحَّةٌ قذف':Added, #6: 6	صِحَّةِ الْقُدْوَةِ
u'صِحَّةٌ قَذْفٌ':Added, #2: 2	صِحَّةِ قَذْفِ
u'صِحَّةٌ قِرَاءةٌ':Added, #2: 2	صِحَّةِ قَذْفِ
u'صِحَّةٌ قراض':Added, #1: 1	صِحَّةِ قِرَاءَتِهِ
u'صِحَّةٌ قراض':Added, #2: 2	صِحَّةَ الْقِرَاضِ
u'صِحَّةٌ قِرَانٌ':Added, #2: 2	صِحَّةِ الْقِرَاضِ
u'صِحَّةٌ قِرَانٌ':Added, #1: 1	صِحَّةِ الْقِرَانِ
u'صِحَّةٌ قِرَانٌ':Added, #1: 1	صِحَّةُ قِرَانِ
u'صِحَّةٌ قَرْضٌ':Added, #1: 1	صِحَّةِ قِرَانِ
u'صِحَّةٌ قَرْضٌ':Added, #1: 1	صِحَّةِ الْقَرْضِ
u'صِحَّةٌ قَرِيحَةٌ':Added, #1: 1	صِحَّةِ قَرْضِهِ
u'صِحَّةٌ قَرِيحَةٌ':Added, #1: 1	صِحَّةِ الْقَرِيحَةِ
u'صِحَّةٌ قَسام':Added, #1: 1	صِحَّةِ قَرِيحَتِهِ
u'صِحَّةٌ قَسامَة':Added, #1: 1	صِحَّةِ الْقَسَامَةِ
u'صِحَّةٌ قَسَمٌ':Added, #1: 1	صِحَّةِ الْقَسَامَةِ
u'صِحَّةٌ قَسَمٌ':Added, #1: 1	صِحَّةُ الْقَسَمِ
u'صِحَّةٌ قَسْمٌ':Added, #1: 1	صِحَّةِ الْقَسَمِ
u'صِحَّةٌ قسمة':Added, #1: 1	صِحَّةَ الْقَسْمِ
u'صِحَّةٌ قِسْمَةٌ':Added, #1: 1	صِحَّةُ الْقِسْمَةِ
u'صِحَّةٌ قسمة':Added, #1: 1	صِحَّةُ الْقِسْمَةِ
u'صِحَّةٌ قِسْمَةٌ':Added, #1: 1	صِحَّةِ قِسْمَةِ
u'صِحَّةٌ قسمة':Added, #1: 1	صِحَّةِ قِسْمَةِ
u'صِحَّةٌ قِسْمَةٌ':Added, #2: 2	صِحَّةَ الْقِسْمَةِ
u'صِحَّةٌ قسمة':Added, #2: 2	صِحَّةَ الْقِسْمَةِ
u'صِحَّةٌ قِسْمَةٌ':Added, #3: 3	صِحَّةِ الْقِسْمَةِ
u'صِحَّةٌ قَصْدٌ':Added, #3: 3	صِحَّةِ الْقِسْمَةِ
u'صِحَّةٌ قَصْدٌ':Added, #1: 1	صِحَّةَ الْقَصْدِ
u'صِحَّةٌ قَصْدٌ':Added, #1: 1	صِحَّةِ قَصْدِهِ
u'صِحَّةٌ قَضَاءٌ':Added, #5: 5	صِحَّةِ الْقَصْدِ
u'صِحَّةٌ قَضَاءٌ':Added, #1: 1	صِحَّةُ الْقَضَاءِ
u'صِحَّةٌ قَضَاءٌ':Added, #1: 1	صِحَّةُ قَضَاءِ
u'صِحَّةٌ قَضَاءٌ':Added, #4: 4	صِحَّةِ الْقَضَاءِ
u'صِحَّةٌ قلب':Added, #6: 6	صِحَّةَ الْقَضَاءِ
u'صِحَّةٌ قَلْبٌ':Added, #2: 2	صِحَّةِ الْقَلْبِ
u'صِحَّةٌ قَلْب':Added, #2: 2	صِحَّةِ الْقَلْبِ
u'صِحَّةٌ قول':Added, #2: 2	صِحَّةِ الْقَلْبِ
u'صِحَّةٌ قَوْلٌ':Added, #1: 1	صِحَّةَ الْقَوْلِ
u'صِحَّةٌ قَوْلٌ':Added, #1: 1	صِحَّةَ الْقَوْلِ
u'صِحَّةٌ قول':Added, #1: 1	صِحَّةُ الْقَوْلَيْنِ
u'صِحَّةٌ قَوْلٌ':Added, #2: 2	صِحَّةِ الْقَوْلِ
u'صِحَّةٌ قول':Added, #2: 2	صِحَّةِ الْقَوْلِ
u'صِحَّةٌ قَوْلٌ':Added, #2: 2	صِحَّةَ قَوْلِ
u'صِحَّةٌ قول':Added, #2: 2	صِحَّةَ قَوْلِ
u'صِحَّةٌ قَوْلٌ':Added, #4: 4	صِحَّةِ قَوْلِ
u'صِحَّةٌ قول':Added, #4: 4	صِحَّةِ قَوْلِ
u'صِحَّةٌ قَوْلٌ':Added, #4: 4	صِحَّةُ قَوْلِهِ
u'صِحَّةٌ قول':Added, #4: 4	صِحَّةُ قَوْلِهِ
u'صِحَّةٌ قَوْلٌ':Added, #6: 6	صِحَّةُ قَوْلِ
u'صِحَّةٌ قول':Added, #6: 6	صِحَّةُ قَوْلِ
u'صِحَّةٌ قَوْلٌ':Added, #7: 7	صِحَّةِ قَوْلِهِ
u'صِحَّةٌ قِيَاسٌ':Added, #7: 7	صِحَّةِ قَوْلِهِ
u'صِحَّةٌ قِيَاسٌ':Added, #10: 10	صِحَّةِ الْقِيَاسِ
u'صِحَّةٌ قِيَاسٌ':Added, #1: 1	صِحَّةَ الْقِيَاسِ
u'صِحَّةٌ قِيَاسٌ':Added, #1: 1	صِحَّةِ قِيَاسِهِ
u'صِحَّةٌ قِيَاسٌ':Added, #2: 2	صِحَّةُ الْقِيَاسِ
u'صِحَّةٌ قيام':Added, #2: 2	صِحَّةِ قِيَاسِ
u'صِحَّةٌ قِيَامٌ':Added, #1: 1	صِحَّةِ الْقِيَامِ
u'صِحَّةٌ كِتَابٌ':Added, #1: 1	صِحَّةِ الْقِيَامِ
u'صِحَّةٌ كِتَابٌ':Added, #1: 1	صِحَّةِ الْكِتَابِ
u'صِحَّةٌ كِتَابَةٌ':Added, #1: 1	صِحَّةِ كِتَابِهِ
u'صِحَّةٌ كِتَابَةٌ':Added, #1: 1	صِحَّةَ الْكِتَابَةِ
u'صِحَّةٌ كِتَابَةٌ':Added, #1: 1	صِحَّةُ الْكِتَابَةِ
u'صِحَّةٌ كِتَابَةٌ':Added, #1: 1	صِحَّةِ الْكِتَابَةِ
u'صِحَّةٌ كِرَاءٌ':Added, #4: 4	صِحَّةُ كِتَابَةِ
u'صِحَّةٌ كَسْرٌ':Added, #1: 1	صِحَّةَ الْكِرَاءِ
u'صِحَّةٌ كَفَالَةٌ':Added, #2: 2	صِحَّةَ الْكَسْرِ
u'صِحَّةٌ كَفَالَةٌ':Added, #10: 10	صِحَّةَ الْكَفَالَةِ
u'صِحَّةٌ كَفَالَةٌ':Added, #19: 19	صِحَّةِ الْكَفَالَةِ
u'صِحَّةٌ كَفَالَةٌ':Added, #1: 1	صِحَّةِ كَفَالَةِ
u'صِحَّةٌ كَفَالَةٌ':Added, #1: 1	صِحَّةِ كَفَالَتِهِ
u'صِحَّةٌ كَلاَمٌ':Added, #9: 9	صِحَّةُ الْكَفَالَةِ
u'صِحَّةٌ كَلاَمٌ':Added, #1: 1	صِحَّةُ كَلَامِ
u'صِحَّةٌ كَلاَمٌ':Added, #1: 1	صِحَّةِ كَلَامِ
u'صِحَّةٌ كَلاَمٌ':Added, #1: 1	صِحَّةُ كَلَامِهِ
u'صِحَّةٌ كَلاَمٌ':Added, #2: 2	صِحَّةُ الْكَلَامِ
u'صِحَّةٌ كَلاَمٌ':Added, #4: 4	صِحَّةَ الْكَلَامِ
u'صِحَّةٌ كَوْنٌ':Added, #6: 6	صِحَّةِ الْكَلَامِ
u'صِحَّةٌ كَوْنٌ':Added, #1: 1	صِحَّةَ كَوْنِ
u'صِحَّةٌ كَوْنٌ':Added, #2: 2	صِحَّةِ كَوْنِ
u'صِحَّةٌ كَوْنٌ':Added, #2: 2	صِحَّةُ كَوْنِهِ
u'صِحَّةٌ لاَزِمٌ':Added, #2: 2	صِحَّةِ كَوْنِهِ
u'صِحَّةٌ لعان':Added, #1: 1	صِحَّةِ اللَّازِمِ
u'صِحَّةٌ لعان':Added, #1: 1	صِحَّةِ لِعَانِ
u'صِحَّةٌ لَفْظٌ':Added, #2: 2	صِحَّةِ اللِّعَانِ
u'صِحَّةٌ لَفْظٌ':Added, #1: 1	صِحَّةَ اللَّفْظِ
u'صِحَّةٌ لَفْظٌ':Added, #2: 2	صِحَّةِ اللَّفْظِ
u'صِحَّةٌ لَفْظٌ':Added, #2: 2	صِحَّةِ لَفْظِ
u'صِحَّةٌ لقطة':Added, #7: 7	صِحَّةُ اللَّفْظِ
u'صِحَّةٌ مُبَاشَرَةٌ':Added, #1: 1	صِحَّةُ لُقَطَةِ
u'صِحَّةٌ مُبَاشَرَةٌ':Added, #1: 1	صِحَّةِ الْمُبَاشَرَةِ
u'صِحَّةٌ مُبَاشَرَةٌ':Added, #1: 1	صِحَّةُ مُبَاشَرَةِ
u'صِحَّةٌ مُبَاشَرَةٌ':Added, #1: 1	صِحَّةَ مُبَاشَرَتِهِ
u'صِحَّةٌ مُبَايَعَةٌ':Added, #3: 3	صِحَّةِ مُبَاشَرَةِ
u'صِحَّةٌ مُتارَكَة':Added, #1: 1	صِحَّةُ الْمُبَايَعَةِ
u'صِحَّةٌ مُتَعَلِّقٌ':Added, #1: 1	صِحَّةِ الْمُتَارَكَةِ
u'صِحَّةٌ مُتَعَلِّقٌ':Added, #1: 1	صِحَّةٍ مُتَعَلِّقَةٍ
u'صِحَّةٌ مثل':Added, #1: 1	صِحَّةِ مُتَعَلِّقِهِ
u'صِحَّةٌ مِثْلٌ':Added, #1: 1	صِحَّةِ مِثْلِهِ
u'صِحَّةٌ مثل':Added, #1: 1	صِحَّةِ مِثْلِهِ
u'صِحَّةٌ مِثْلٌ':Added, #3: 3	صِحَّةِ مِثْلِ
u'صِحَّةٌ مَجَازٌ':Added, #3: 3	صِحَّةِ مِثْلِ
u'صِحَّةٌ مُجَامَعَةٌ':Added, #1: 1	صِحَّةِ الْمَجَازِ
u'صِحَّةٌ مُحَابَاةٌ':Added, #1: 1	صِحَّةِ مُجَامَعَةِ
u'صِحَّةٌ مَحْكُومٌ':Added, #1: 1	صِحَّةِ الْمُحَابَاةِ
u'صِحَّةٌ مَخْرَجٌ':Added, #2: 2	صِحَّةَ الْمَحْكُومِ
u'صِحَّةٌ مَذْهَبٌ':Added, #4: 4	صِحَّةِ مَخْرَجِ
u'صِحَّةٌ مَذْهَبٌ':Added, #1: 1	صِحَّةُ مَذْهَبِهِ
u'صِحَّةٌ مَذْهَبٌ':Added, #1: 1	صِحَّةِ مَذْهَبِهِ
u'صِحَّةٌ مُرَاجَعَةٌ':Added, #3: 3	صِحَّةُ مَذْهَبِ
u'صِحَّةٌ مُرْسَلٌ':Added, #1: 1	صِحَّةَ الْمُرَاجَعَةِ
u'صِحَّةٌ مَرِيضٌ':Added, #1: 1	صِحَّةِ الْمُرْسَلِ
u'صِحَّةٌ مَزِيَّةٌ':Added, #1: 1	صِحَّةِ الْمَرِيضِ
u'صِحَّةٌ مُسَابَقَةٌ':Added, #1: 1	صِحَّةُ الْمَزِيَّةِ
u'صِحَّةٌ مُساقاة':Added, #1: 1	صِحَّةِ الْمُسَابَقَةِ
u'صِحَّةٌ مُساقاة':Added, #1: 1	صِحَّةَ الْمُسَاقَاةِ
u'صِحَّةٌ مُساقاة':Added, #1: 1	صِحَّةُ الْمُسَاقَاةِ
u'صِحَّةٌ مُسْتَنَدٌ':Added, #2: 2	صِحَّةُ مُسَاقَاةِ
u'صِحَّةٌ مُسْتَنَدٌ':Added, #1: 1	صِحَّةِ الْمُسْتَنَدِ
u'صِحَّةٌ مُسْتَنَدٌ':Added, #1: 1	صِحَّةِ مُسْتَنَدِهِ
u'صِحَّةٌ مَسْحٌ':Added, #2: 2	صِحَّةَ الْمُسْتَنَدِ
u'صِحَّةٌ مَسْحٌ':Added, #1: 1	صِحَّةِ الْمَسْحِ
u'صِحَّةٌ مُشَارَكَةٌ':Added, #1: 1	صِحَّةِ مَسْحِ
u'صِحَّةٌ مُشاعٌ':Added, #1: 1	صِحَّةَ الْمُشَارَكَةِ
u'صِحَّةٌ مُشَاوَرَةٌ':Added, #1: 1	صِحَّةِ الْمُشَاعِ
u'صِحَّةٌ مَشِيئَةٌ':Added, #1: 1	صِحَّةِ الْمُشَاوَرَةِ
u'صِحَّةٌ مُصَالَحَةٌ':Added, #1: 1	صِحَّةِ الْمَشِيئَةِ
u'صِحَّةٌ مُضَارَبَةٌ':Added, #1: 1	صِحَّةَ الْمُصَالَحَةِ
u'صِحَّةٌ مُضَارَبَةٌ':Added, #1: 1	صِحَّةِ الْمُضَارَبَةِ
u'صِحَّةٌ مَضْمُومٌ':Added, #2: 2	صِحَّةُ الْمُضَارَبَةِ
u'صِحَّةٌ مُطَالَبٌ':Added, #1: 1	صِحَّةِ الْمَضْمُومِ
u'صِحَّةٌ مُطَالَبٌ':Added, #1: 1	صِحَّةُ الْمُطَالَبَةِ
u'صِحَّةٌ مُطَالَبَةٌ':Added, #1: 1	صِحَّةِ الْمُطَالَبَةِ
u'صِحَّةٌ مُطَالَبَةٌ':Added, #1: 1	صِحَّةُ الْمُطَالَبَةِ
u'صِحَّةٌ مُطْلَقٌ':Added, #1: 1	صِحَّةِ الْمُطَالَبَةِ
u'صِحَّةٌ مُعَامَلَةٌ':Added, #1: 1	صِحَّةِ مُطْلَقِ
u'صِحَّةٌ مُعْتَقٌ':Added, #1: 1	صِحَّةِ مُعَامَلَتِهِ
u'صِحَّةٌ مُعَيَّنٌ':Added, #1: 1	صِحَّةُ الْمُعْتَقِ
u'صِحَّةٌ مَغْرِبٌ':Added, #2: 2	صِحَّةُ الْمُعَيَّنِ
u'صِحَّةٌ مَغْصُوب':Added, #1: 1	صِحَّةِ الْمَغْرِبِ
u'صِحَّةٌ مُفَارَقَةٌ':Added, #1: 1	صِحَّةِ الْمَغْصُوبِ
u'صِحَّةٌ مَقَالٌ':Added, #1: 1	صِحَّةِ مُفَارَقَتِهِ
u'صِحَّةٌ مُكَاتَبَةٌ':Added, #1: 1	صِحَّةُ الْمَقَالِ
u'صِحَّةٌ مَكْتُوبٌ':Added, #1: 1	صِحَّةِ مُكَاتَبَةِ
u'صِحَّةٌ مِلْكٌ':Added, #1: 1	صِحَّةِ مَكْتُوبِ
u'صِحَّةٌ مِلْكٌ':Added, #1: 1	صِحَّةِ مِلْكِهِ
u'صِحَّةٌ مَنْعٌ':Added, #2: 2	صِحَّةَ مِلْكِ
u'صِحَّةٌ مَنْهِيٌّ':Added, #1: 1	صِحَّةُ مَنْعِهِ
u'صِحَّةٌ مَنْهِيٌّ':Added, #1: 1	صِحَّةُ الْمَنْهِيِّ
u'صِحَّةٌ مَنْهِيٌّ':Added, #1: 1	صِحَّةِ الْمَنْهِيِّ
u'صِحَّةٌ مَهْرٌ':Added, #2: 2	صِحَّةَ الْمَنْهِيِّ
u'صِحَّةٌ مَوْتٌ':Added, #1: 1	صِحَّةِ الْمَهْرِ
u'صِحَّةٌ مُؤَدِّي':Added, #1: 1	صِحَّةِ مَوْتِهِ
u'صِحَّةٌ مَوْضُوعِيٌّ':Added, #1: 1	صِحَّةِ الْمُؤَدِّيَاتِ
u'صِحَّةٌ مَوْضُوعِيَّةٌ':Added, #1: 1	صِحَّةِ مَوْضُوعِيَّةِ
u'صِحَّةٌ مَوْقُوفٌ':Added, #1: 1	صِحَّةِ مَوْضُوعِيَّةِ
u'صِحَّةٌ نَافِلَةٌ':Added, #1: 1	صِحَّةِ الْمَوْقُوفِ
u'صِحَّةٌ نُبُوَّةٌ':Added, #2: 2	صِحَّةِ نَافِلَةٍ
u'صِحَّةٌ نَحْوٌ':Added, #1: 1	صِحَّةُ النُّبُوَّةِ
u'صِحَّةٌ نذر':Added, #1: 1	صِحَّةِ نَحْوِ
u'صِحَّةٌ نَذْرٌ':Added, #10: 10	صِحَّةَ النَّذْرِ
u'صِحَّةٌ نذر':Added, #10: 10	صِحَّةَ النَّذْرِ
u'صِحَّةٌ نَذْرٌ':Added, #10: 10	صِحَّةِ نَذْرِ
u'صِحَّةٌ نذر':Added, #10: 10	صِحَّةِ نَذْرِ
u'صِحَّةٌ نَذْرٌ':Added, #11: 11	صِحَّةِ النَّذْرِ
u'صِحَّةٌ نذر':Added, #11: 11	صِحَّةِ النَّذْرِ
u'صِحَّةٌ نَذْرٌ':Added, #1: 1	صِحَّة النَّذْرِ
u'صِحَّةٌ نذر':Added, #1: 1	صِحَّة النَّذْرِ
u'صِحَّةٌ نَذْرٌ':Added, #1: 1	صِحَّةُ نَذْرِ
u'صِحَّةٌ نَذْرٌ':Added, #1: 1	صِحَّةُ نَذْرٍ
u'صِحَّةٌ نذر':Added, #1: 1	صِحَّةُ نَذْرِ
u'صِحَّةٌ نَذْرٌ':Added, #3: 3	صِحَّةُ النَّذْرِ
u'صِحَّةٌ نذر':Added, #3: 3	صِحَّةُ النَّذْرِ
u'صِحَّةٌ نَذْرٌ':Added, #3: 3	صِحَّةُ نَذْرِهِ
u'صِحَّةٌ نذر':Added, #3: 3	صِحَّةُ نَذْرِهِ
u'صِحَّةٌ نَذْرٌ':Added, #5: 5	صِحَّةِ نَذْرِهِ
u'صِحَّةٌ نسخة':Added, #5: 5	صِحَّةِ نَذْرِهِ
u'صِحَّةٌ نُسْخَةٌ':Added, #1: 1	صِحَّةِ النُّسْخَةِ
u'صِحَّةٌ نُسُكٌ':Added, #1: 1	صِحَّةِ النُّسْخَةِ
u'صِحَّةٌ نُسُكٌ':Added, #1: 1	صِحَّةِ النُّسُكِ
u'صِحَّةٌ نصب':Added, #1: 1	صِحَّةِ النُّسُكَيْنِ
u'صِحَّةٌ نَصْبٌ':Added, #1: 1	صِحَّةِ نَصْبِ
u'صِحَّةٌ نصب':Added, #1: 1	صِحَّةِ نَصْبِ
u'صِحَّةٌ نَصْبٌ':Added, #2: 2	صِحَّةِ نَصْبِهِ
u'صِحَّةٌ نَظَرٌ':Added, #2: 2	صِحَّةِ نَصْبِهِ
u'صِحَّةٌ نَظَرٌ':Added, #1: 1	صِحَّةِ النَّظَرِ
u'صِحَّةٌ نَظَرٌ':Added, #1: 1	صِحَّةِ نَظَرِهِ
u'صِحَّةٌ نَظَرٌ':Added, #2: 2	صِحَّةَ النَّظَرِ
u'صِحَّةٌ نَفْلٌ':Added, #3: 3	صِحَّةِ نَظَرِ
u'صِحَّةٌ نَفْلٌ':Added, #1: 1	صِحَّةِ النَّفْلِ
u'صِحَّةٌ نَفْيٌ':Added, #3: 3	صِحَّةِ نَفْلِهِ
u'صِحَّةٌ نَفْيٌ':Added, #1: 1	صِحَّةِ النَّفْيِ
u'صِحَّةٌ نَفْيٌ':Added, #1: 1	صِحَّةَ نَفْيِ
u'صِحَّةٌ نَفْيٌ':Added, #1: 1	صِحَّةُ نَفْيِ
u'صِحَّةٌ نَفْيٌ':Added, #2: 2	صِحَّةُ النَّفْيِ
u'صِحَّةٌ نَفْيٌ':Added, #2: 2	صِحَّةِ نَفْيِهِ
u'صِحَّةٌ نِقَابَةٌ':Added, #3: 3	صِحَّةِ نَفْيِ
u'صِحَّةٌ نقل':Added, #1: 1	صِحَّةِ نِقَابَتِهِ
u'صِحَّةٌ نَقْلٌ':Added, #1: 1	صِحَّةَ نَقْلِ
u'صِحَّةٌ نقل':Added, #1: 1	صِحَّةَ نَقْلِ
u'صِحَّةٌ نَقْلٌ':Added, #2: 2	صِحَّةُ النَّقْلِ
u'صِحَّةٌ نقل':Added, #2: 2	صِحَّةُ النَّقْلِ
u'صِحَّةٌ نَقْلٌ':Added, #2: 2	صِحَّةِ نَقْلِهِ
u'صِحَّةٌ نقل':Added, #2: 2	صِحَّةِ نَقْلِهِ
u'صِحَّةٌ نَقْلٌ':Added, #4: 4	صِحَّةِ النَّقْلِ
u'صِحَّةٌ نكاح':Added, #4: 4	صِحَّةِ النَّقْلِ
u'صِحَّةٌ نكاح':Added, #11: 11	صِحَّةُ نِكَاحِ
u'صِحَّةٌ نِكَاحٌ':Added, #11: 11	صِحَّةِ نِكَاحِ
u'صِحَّةٌ نِكَاحٌ':Added, #11: 11	صِحَّةُ نِكَاحِ
u'صِحَّةٌ نكاح':Added, #11: 11	صِحَّةِ نِكَاحِ
u'صِحَّةٌ نِكَاحٌ':Added, #13: 13	صِحَّةُ النِّكَاحِ
u'صِحَّةٌ نكاح':Added, #13: 13	صِحَّةُ النِّكَاحِ
u'صِحَّةٌ نِكَاحٌ':Added, #1: 1	صِحَّةَ نِكَاحِ
u'صِحَّةٌ نكاح':Added, #1: 1	صِحَّةَ نِكَاحِ
u'صِحَّةٌ نِكَاحٌ':Added, #20: 20	صِحَّةَ النِّكَاحِ
u'صِحَّةٌ نكاح':Added, #20: 20	صِحَّةَ النِّكَاحِ
u'صِحَّةٌ نكاح':Added, #2: 2	صِحَّةَ نِكَاحٍ
u'صِحَّةٌ نِكَاحٌ':Added, #2: 2	صِحَّةِ نِكَاحٍ
u'صِحَّةٌ نِكَاحٌ':Added, #2: 2	صِحَّةَ نِكَاحٍ
u'صِحَّةٌ نكاح':Added, #2: 2	صِحَّةِ نِكَاحٍ
u'صِحَّةٌ نِكَاحٌ':Added, #2: 2	صِحَّةُ نِكَاحِهِ
u'صِحَّةٌ نكاح':Added, #2: 2	صِحَّةُ نِكَاحِهِ
u'صِحَّةٌ نِكَاحٌ':Added, #3: 3	صِحَّةَ نِكَاحِهِ
u'صِحَّةٌ نكاح':Added, #3: 3	صِحَّةَ نِكَاحِهِ
u'صِحَّةٌ نِكَاحٌ':Added, #44: 44	صِحَّةِ النِّكَاحِ
u'صِحَّةٌ نكاح':Added, #44: 44	صِحَّةِ النِّكَاحِ
u'صِحَّةٌ نِكَاحٌ':Added, #5: 5	صِحَّةِ نِكَاحِهِ
u'صِحَّةٌ نَهْيٌ':Added, #5: 5	صِحَّةِ نِكَاحِهِ
u'صِحَّةٌ نَهْيٌ':Added, #1: 1	صِحَّةَ النَّهْيِ
u'صِحَّةٌ نِيَابَةٌ':Added, #1: 1	صِحَّةِ النَّهْيِ
u'صِحَّةٌ نِيَابَةٌ':Added, #1: 1	صِحَّةُ النِّيَابَةِ
u'صِحَّةٌ نِيَّةٌ':Added, #1: 1	صِحَّةِ النِّيَابَةِ
u'صِحَّةٌ نِيَّةٌ':Added, #1: 1	صِحَّة نِيَّةِ
u'صِحَّةٌ نِيَّةٌ':Added, #1: 1	صِحَّةُ نِيَّتِهِ
u'صِحَّةٌ نِيَّةٌ':Added, #2: 2	صِحَّةَ نِيَّتِهِ
u'صِحَّةٌ نِيَّةٌ':Added, #2: 2	صِحَّةِ نِيَّتِهِ
u'صِحَّةٌ نِيَّةٌ':Added, #3: 3	صِحَّةَ نِيَّةِ
u'صِحَّةٌ نِيَّةٌ':Added, #6: 6	صِحَّةِ نِيَّةِ
u'صِحَّةٌ نِيَّةٌ':Added, #7: 7	صِحَّةِ النِّيَّةِ
u'صِحَّةٌ هِبَةٌ':Added, #7: 7	صِحَّةُ نِيَّةِ
u'صِحَّةٌ هِبَةٌ':Added, #1: 1	صِحَّةُ هِبَةِ
u'صِحَّةٌ هِبَةٌ':Added, #2: 2	صِحَّةِ هِبَتِهِ
u'صِحَّةٌ هِبَةٌ':Added, #3: 3	صِحَّةِ الْهِبَةِ
u'صِحَّةٌ هِبَةٌ':Added, #4: 4	صِحَّةُ الْهِبَةِ
u'صِحَّةٌ هِبَةٌ':Added, #4: 4	صِحَّةَ هِبَةِ
u'صِحَّةٌ هِبَةٌ':Added, #6: 6	صِحَّةِ هِبَةِ
u'صِحَّةٌ واحد':Added, #7: 7	صِحَّةَ الْهِبَةِ
u'صِحَّةٌ وَاحِدٌ':Added, #1: 1	صِحَّةِ وَاحِدٍ
u'صِحَّةٌ وَارِثٌ':Added, #1: 1	صِحَّةِ وَاحِدٍ
u'صِحَّةٌ وَاهِبٌ':Added, #1: 1	صِحَّةِ الْوَارِثِ
u'صِحَّةٌ وَجْهٌ':Added, #2: 2	صِحَّةِ الْوَاهِبِ
u'صِحَّةٌ وُرُودٌ':Added, #1: 1	صِحَّةُ الْوَجْهِ
u'صِحَّةٌ وِصَايَةٌ':Added, #1: 1	صِحَّةُ وُرُودِ
u'صِحَّةٌ وِصَايَةٌ':Added, #1: 1	صِحَّةَ الْوِصَايَةِ
u'صِحَّةٌ وَصْفٌ':Added, #1: 1	صِحَّةِ الْوِصَايَةِ
u'صِحَّةٌ وَصْفٌ':Added, #1: 1	صِحَّةِ الْوَصْفِ
u'صِحَّةٌ وَصِيٌّ':Added, #1: 1	صِحَّةِ وَصْفِهِ
u'صِحَّةٌ وَصِيٌّ':Added, #15: 15	صِحَّةَ الْوَصِيَّةِ
u'صِحَّةٌ وَصِيٌّ':Added, #19: 19	صِحَّةُ الْوَصِيَّةِ
u'صِحَّةٌ وَصِيٌّ':Added, #1: 1	صِحَّةِ الْوَصِيَّتَيْنِ
u'صِحَّةٌ وَصِيٌّ':Added, #1: 1	صِحَّةِ وَصِيَّةِ
u'صِحَّةٌ وَصِيٌّ':Added, #2: 2	صِحَّةَ وَصِيَّةِ
u'صِحَّةٌ وَصِيٌّ':Added, #2: 2	صِحَّةُ وَصِيَّتِهِ
u'صِحَّةٌ وَصِيٌّ':Added, #2: 2	صِحَّةِ وَصِيَّتِهِ
u'صِحَّةٌ وَصِيٌّ':Added, #36: 36	صِحَّةِ الْوَصِيَّةِ
u'صِحَّةٌ وَصِيَّةٌ':Added, #3: 3	صِحَّةُ وَصِيَّةِ
u'صِحَّةٌ وَصِيَّةٌ':Added, #15: 15	صِحَّةَ الْوَصِيَّةِ
u'صِحَّةٌ وَصِيَّةٌ':Added, #19: 19	صِحَّةُ الْوَصِيَّةِ
u'صِحَّةٌ وَصِيَّةٌ':Added, #1: 1	صِحَّةِ وَصِيَّةِ
u'صِحَّةٌ وَصِيَّةٌ':Added, #2: 2	صِحَّةَ وَصِيَّةِ
u'صِحَّةٌ وَصِيَّةٌ':Added, #2: 2	صِحَّةُ وَصِيَّتِهِ
u'صِحَّةٌ وَصِيَّةٌ':Added, #2: 2	صِحَّةِ وَصِيَّتِهِ
u'صِحَّةٌ وَصِيَّةٌ':Added, #36: 36	صِحَّةِ الْوَصِيَّةِ
u'صِحَّةٌ وَضْعٌ':Added, #3: 3	صِحَّةُ وَصِيَّةِ
u'صِحَّةٌ وُضُوءٌ':Added, #2: 2	صِحَّةُ وَضْعِ
u'صِحَّةٌ وُضُوءٌ':Added, #1: 1	صِحَّةُ الْوُضُوءِ
u'صِحَّةٌ وُضُوءٌ':Added, #1: 1	صِحَّةَ وُضُوءِ
u'صِحَّةٌ وُضُوءٌ':Added, #1: 1	صِحَّةُ وُضُوءِ
u'صِحَّةٌ وُضُوءٌ':Added, #1: 1	صِحَّةِ وُضُوءٍ
u'صِحَّةٌ وُضُوءٌ':Added, #2: 2	صِحَّةِ وُضُوءِ
u'صِحَّةٌ وُضُوءٌ':Added, #4: 4	صِحَّةَ الْوُضُوءِ
u'صِحَّةٌ وَقْتٌ':Added, #4: 4	صِحَّةِ الْوُضُوءِ
u'صِحَّةٌ وَقْت':Added, #1: 1	صِحَّةَ الْوَقْتِ
u'صِحَّةٌ وَقْتِيّ':Added, #2: 2	صِحَّةُ الْوَقْتِيَّةِ
u'صِحَّةٌ وَقْفٌ':Added, #2: 2	صِحَّةُ الْوَقْتِيَّةِ
u'صِحَّةٌ وَقْفٌ':Added, #18: 18	صِحَّةُ الْوَقْفِ
u'صِحَّةٌ وَقْفٌ':Added, #1: 1	صِحَّةَ وَقْفِهِ
u'صِحَّةٌ وَقْفٌ':Added, #1: 1	صِحَّةُ وَقْفِهِ
u'صِحَّةٌ وَقْفٌ':Added, #22: 22	صِحَّةِ الْوَقْفِ
u'صِحَّةٌ وَقْفٌ':Added, #3: 3	صِحَّةَ وَقْفِ
u'صِحَّةٌ وَقْفٌ':Added, #3: 3	صِحَّةُ وَقْفِ
u'صِحَّةٌ وَقْفٌ':Added, #3: 3	صِحَّةِ وَقْفِ
u'صِحَّةٌ وَقْفٌ':Added, #3: 3	صِحَّةِ وَقْفِهِ
u'صِحَّةٌ وُقُوعٌ':Added, #7: 7	صِحَّةَ الْوَقْفِ
u'صِحَّةٌ وُقُوعٌ':Added, #1: 1	صِحَّةَ وُقُوعِ
u'صِحَّةٌ وُقُوعٌ':Added, #1: 1	صِحَّةُ وُقُوعِ
u'صِحَّةٌ وُقُوعٌ':Added, #2: 2	صِحَّةِ وُقُوعِ
u'صِحَّةٌ وُقُوفٌ':Added, #2: 2	صِحَّةَ وُقُوعِهِ
u'صِحَّةٌ وُقُوفٌ':Added, #1: 1	صِحَّةِ وُقُوفِ
u'صِحَّةٌ وِلاَيَةٌ':Added, #3: 3	صِحَّةِ الْوُقُوفِ
u'صِحَّةٌ وِلاَيَةٌ':Added, #1: 1	صِحَّةُ وِلَايَةِ
u'صِحَّةٌ وِلاَيَةٌ':Added, #1: 1	صِحَّةِ وِلَايَةِ
u'صِحَّةٌ وِلاَيَةٌ':Added, #1: 1	صِحَّةَ وِلَايَتِهِ
u'صِحَّةٌ وِلاَيَةٌ':Added, #1: 1	صِحَّةُ وِلَايَتِهِ
u'صِحَّةٌ وِلاَيَةٌ':Added, #3: 3	صِحَّةِ الْوِلَايَةِ
u'صِحَّةٌ وِلاَيَةٌ':Added, #4: 4	صِحَّةُ الْوِلَايَةِ
u'صِحَّةٌ وَهْمٌ':Added, #5: 5	صِحَّةِ وِلَايَتِهِ
u'صِحَّةٌ يَقِينٌ':Added, #1: 1	صِحَّةِ وَهْمِهِ
u'صِحَّةٌ يَمِينٌ':Added, #1: 1	صِحَّةُ الْيَقِينِ
u'صِحَّةٌ يَمِينٌ':Added, #1: 1	صِحَّةَ الْيَمِينِ
u'صِحَّةٌ يَمِينٌ':Added, #2: 2	صِحَّةِ الْيَمِينِ
u'صِحَّةٌ يَوْمٌ':Added, #3: 3	صِحَّةِ يَمِينِهِ
u'صَحَّ تَابِعٌ':Predicate, #1: 1	صِحَّةُ يَوْمِ
u'صَحَّ تَأْجِيلٌ':Subject, #1: 1	أَصَحَّ التَّابِعِينَ
u'صَحَّ تَأْجِيلٌ':Subject, #1: 1	صَحَّ التَّأْجِيلُ
u'صَحَّ تَأْخِيرٌ':Subject, #5: 5	صَحَّ تَأْجِيلُهُ
u'صَحَّ تَأْكِيدٌ':Subject, #7: 7	صَحَّ التَّأْخِيرُ
u'صَحَّ تَأَلُّفٌ':Subject, #1: 1	صَحَّ التَّأْكِيدُ
u'صَحَّ تَأْمِينٌ':Subject, #1: 1	صَحَّ تَأَلُّفُ
u'صَحَّ تَبَرُّعٌ':Subject, #1: 1	صَحَّ تَأْمِينُهُ
u'صَحَّ تَبْعِيض':Subject, #4: 4	صَحَّ تَبَرُّعُهُ
u'صَحَّ تَجَوُّزٌ':Subject, #1: 1	صَحَّ تَبْعِيضُ
u'صَحَّ تَحَمُّلٌ':Subject, #1: 1	صَحَّ التَّجَوُّزُ
u'صَحَّ تَخْرِيجٌ':Subject, #4: 4	صَحَّ تَحَمُّلُهُ
u'صَحَّ تَخْصِيصٌ':Subject, #1: 1	صَحَّ تَخْرِيجٌ
u'صَحَّ تَخْصِيصٌ':Subject, #1: 1	صَحَّ التَّخْصِيصُ
u'صَحَّ تَدْبِيرٌ':Subject, #1: 1	صَحَّ تَخْصِيصُهُ
u'صَحَّ تَدْبِيرٌ':Subject, #1: 1	صَحَّ تَدْبِيرُ
u'صَحَّ تَدْبِيرٌ':Subject, #6: 6	صَحَّ التَّدْبِيرُ
u'صَحَّ تَرْجِيحٌ':Subject, #8: 8	صَحَّ تَدْبِيرُهُ
u'صَحَّ تَرْكٌ':Subject, #1: 1	صَحَّ التَّرْجِيحُ
u'صَحَّ تَرْكِيبٌ':Subject, #1: 1	صَحَّ تَرْكُهُ
u'صَحَّ تَزَوُّجٌ':Subject, #1: 1	صَحَّ التَّرْكِيبُ
u'صَحَّ تَزَوُّجٌ':Subject, #1: 1	صَحَّ التَّزَوُّجُ
u'صَحَّ تَزْوِيجٌ':Subject, #1: 1	صَحَّ تَزَوُّجُهُ
u'صَحَّ تَزْوِيجٌ':Subject, #1: 1	صَحَّ تَزْوِيجُ
u'صَحَّ تَسْلِيمٌ':Subject, #4: 4	صَحَّ التَّزْوِيجُ
u'صَحَّ تَسْلِيمٌ':Subject, #14: 14	صَحَّ التَّسْلِيمُ
u'صَحَّ تَسْمِيَة':Subject, #6: 6	صَحَّ تَسْلِيمُهُ
u'صَحَّ تَسْوِيَةٌ':Subject, #2: 2	صَحَّ تَسْمِيَةُ
u'صَحَّ تَشَبُّهٌ':Subject, #1: 1	صَحَّ تَسْوِيَتُهُ
u'صَحَّ تَشْبِيه':Subject, #1: 1	صَحَّ تَشَبُّهُهُ
u'صَحَّ تَصْدِيقٌ':Subject, #1: 1	صَحَّ التَّشْبِيهُ
u'صَحَّ تَصَرُّفٌ':Subject, #1: 1	صَحَّ تَصْدِيقُهُ
u'صَحَّ تَصَرُّفٌ':Subject, #26: 26	صَحَّ تَصَرُّفُهُ
u'صَحَّ تَصَرُّفٌ':Subject, #3: 3	صَحَّ تَصَرُّفُ
u'صَحَّ تَطَرُّقٌ':Subject, #8: 8	صَحَّ التَّصَرُّفُ
u'صَحَّ تَطْوِيلٌ':Subject, #1: 1	صَحَّ تَطَرُّقُ
u'صَحَّ تَعْجِيل':Subject, #1: 1	صَحَّ التَّطْوِيلُ
u'صَحَّ تَعْجِيل':Subject, #1: 1	صَحَّ تَعْجِيلُ
u'صَحَّ تَعْجِيل':Subject, #3: 3	صَحَّ تَعْجِيلُهُ
u'صَحَّ تَعْدَادٌ':Subject, #4: 4	صَحَّ التَّعْجِيلُ
u'صَحَّ تَعْدِيلٌ':Subject, #1: 1	صَحَّ التَّعْدَادُ
u'صَحَّ تَعَلُّقٌ':Subject, #1: 1	صَحَّ تَعْدِيلُهُ
u'صَحَّ تَعْلِيقٌ':Subject, #4: 4	صَحَّ التَّعَلُّقُ
u'صَحَّ تَعْلِيقٌ':Subject, #11: 11	صَحَّ التَّعْلِيقُ
u'صَحَّ تَعْلِيقٌ':Subject, #3: 3	صَحَّ تَعْلِيقُ
u'صَحَّ تَعْلِيلٌ':Subject, #6: 6	صَحَّ تَعْلِيقُهُ
u'صَحَّ تَعْلِيلٌ':Subject, #1: 1	صَحَّ تَعْلِيلُهُ
u'صَحَّ تَعْوِيضٌ':Subject, #4: 4	صَحَّ التَّعْلِيلُ
u'صَحَّ تَعْيِينٌ':Subject, #1: 1	صَحَّ التَّعْوِيضُ
u'صَحَّ تَعْيِينٌ':Subject, #1: 1	صَحَّ التَّعْيِينُ
u'صَحَّ تَغْسِيلٌ':Subject, #2: 2	صَحَّ تَعْيِينُهُ
u'صَحَّ تَفْرِيقٌ':Subject, #1: 1	صَحَّ تَغْسِيلُ
u'صَحَّ تَفْسِيرٌ':Subject, #1: 1	صَحَّ تَفْرِيقُ
u'صَحَّ تَفْلِيسٌ':Subject, #1: 1	صَحَّ تَفْسِيرُهُ
u'صَحَّ تَفْوِيضٌ':Subject, #1: 1	صَحَّ التَّفْلِيسُ
u'صَحَّ تَفْوِيضٌ':Subject, #1: 1	صَحَّ التَّفْوِيضُ
u'صَحَّ تَقْديمٌ':Subject, #1: 1	صَحَّ تَفْوِيضُهُ
u'صَحَّ تَقْديمٌ':Subject, #1: 1	صَحَّ تَقْدِيمُ
u'صَحَّ تَقْريرٌ':Subject, #1: 1	صَحَّ تَقْدِيمُهُ
u'صَحَّ تَقْريرٌ':Subject, #1: 1	صَحَّ تَقْرِيرُهُ
u'صَحَّ تَقْليدٌ':Subject, #2: 2	صَحَّ التَّقْرِيرُ
u'صَحَّ تَقْليد':Subject, #1: 1	صَحَّ تَقْلِيدُ
u'صَحَّ تَقْليدٌ':Subject, #1: 1	صَحَّ تَقْلِيدُ
u'صَحَّ تَقْليد':Subject, #3: 3	صَحَّ تَقْلِيدُهُ
u'صَحَّ تَقْليدٌ':Subject, #3: 3	صَحَّ تَقْلِيدُهُ
u'صَحَّ تَقْليد':Subject, #8: 8	صَحَّ التَّقْلِيدُ
u'صَحَّ تَقْيِيد':Subject, #8: 8	صَحَّ التَّقْلِيدُ
u'صَحَّ تَكْبيرٌ':Subject, #5: 5	صَحَّ التَّقْيِيدُ
u'صَحَّ تَكْفيرٌ':Subject, #1: 1	صَحَّ تَكْبِيرُهُ
u'صَحَّ تَكْفيلٌ':Subject, #1: 1	صَحَّ التَّكْفِيرُ
u'صَحَّ تَكْليفٌ':Subject, #1: 1	صَحَّ التَّكْفِيلُ
u'صَحَّ تَكْليفٌ':Subject, #1: 1	صَحَّ التَّكْلِيفُ
u'صَحَّ تَمَتُّعٌ':Subject, #1: 1	صَحَّ تَكْلِيفُ
u'صَحَّ تَمْثيلٌ':Subject, #1: 1	صَحَّ تَمَتُّعُهُ
u'صَحَّ تَمَلُّكٌ':Subject, #1: 1	صَحَّ تَمْثِيلُهُ
u'صَحَّ تَمْلِيك':Subject, #2: 2	صَحَّ تَمَلُّكُهُ
u'صَحَّ تَمْلِيكٌ':Subject, #1: 1	صَحَّ التَّمْلِيكُ
u'صَحَّ تَمْلِيكٌ':Subject, #1: 1	صَحَّ تَمْلِيكُ
u'صَحَّ تَنْزِيه':Subject, #1: 1	صَحَّ تَمْلِيكُهُ
u'صَحَّ تَنَفُّلٌ':Subject, #1: 1	صَحَّ التَّنْزِيهُ
u'صَحَّ تَوْقِيَةٌ':Subject, #1: 1	صَحَّ التَّنَفُّلُ
u'صَحَّ تَوْقِيتٌ':Subject, #1: 1	صَحَّ تَوْقِيتُهُ
u'صَحَّ تَوْقِيت':Subject, #1: 1	صَحَّ تَوْقِيتُهُ
u'صَحَّ تَوْكِيلٌ':Subject, #3: 3	صَحَّ التَّوْقِيتُ
u'صَحَّ تَوْكِيلٌ':Subject, #17: 17	صَحَّ التَّوْكِيلُ
u'صَحَّ تَوْلِيَةٌ':Subject, #7: 7	صَحَّ تَوْكِيلُهُ
u'صَحَّ تَيَمُّمٌ':Subject, #1: 1	صَحَّ تَوْلِيَةُ
u'صَحَّ تَيَمُّمٌ':Subject, #3: 3	صَحَّ التَّيَمُّمُ
u'صَحَّ جَازٌ':Predicate, #5: 5	صَحَّ تَيَمُّمُهُ
u'صَحَّ جَمْعٌ':Subject, #3: 3	صَحَّ جَازَ
u'صَحَّ جمع':Subject, #1: 1	صَحَّ جَمْعٌ
u'صَحَّ جَمْعٌ':Subject, #1: 1	صَحَّ جَمْعُهُ
u'صَحَّ جمع':Subject, #1: 1	صَحَّ جَمْعُهُ
u'صَحَّ جَمْعٌ':Subject, #2: 2	صَحَّ الْجَمْعُ
u'صَحَّ جَمِيع':Subject, #2: 2	صَحَّ الْجَمْعُ
u'صَحَّ جَوَابٌ':Subject, #2: 2	صَحَّ الْجَمِيعُ
u'صَحَّحَ اِبْنٌ':Subject, #3: 3	صَحَّ الْجَوَابُ
u'صَحَّحَ أَصْحَابٌ':Subject, #5: 5	صَحَّحَ ابْنُ
u'صَحَّحَ اِعْتِبارٌ':Predicate, #1: 1	صَحَّحَ الْأَصْحَابُ
u'صَحَّحَ إمَامٌ':Subject, #1: 1	صَحَّحَ اعْتِبَارَ
u'صَحَّحَ أَوَّلُ':Predicate, #7: 7	صَحَّحَ الْإِمَامُ
u'صَحَّحَ بَراءةٌ':Predicate, #3: 3	صَحَّحَ الْأَوَّلَ
u'صَحَّ حَبْسٌ':Subject, #1: 1	صَحَّحَ الْبَرَاءَةَ
u'صَحَّحَ تَخْرِيجٌ':Predicate, #1: 1	صَحَّ حَبْسُهُ
u'صَحَّحَ تَزْوِيجٌ':Subject, #2: 2	صَحَّحَ تَخْرِيجَ
u'صَحَّحَ تَفْصِيلٌ':Predicate, #1: 1	صَحَّحَ تَزْوِيجُهُ
u'صَحَّحَ تَقِيٌّ':Subject, #1: 1	صَحَّحَ التَّفْصِيلَ
u'صَحَّحَ تَوْبَةٌ':Predicate, #1: 1	صَحَّحَ تَقِيُّ
u'صَحَّحَ ثَانِي':Predicate, #1: 1	صَحَّحَ التَّوْبَةَ
u'صَحَّ حَجٌّ':Subject, #1: 1	صَحَّحَ الثَّانِيَ
u'صَحَّ حُجَّةٌ':Subject, #7: 7	صَحَّ حَجُّهُ
u'صَحَّ حَجْرٌ':Subject, #1: 1	صَحَّ حُجَّةٌ
u'صَحَّ حَجْرٌ':Subject, #2: 2	صَحَّ حَجْرُهُ
u'صَحَّحَ جَمَاعَةٌ':Subject, #3: 3	صَحَّ الْحَجْرُ
u'صَحَّحَ جَوَازٌ':Predicate, #1: 1	صَحَّحَ جَمَاعَةٌ
u'صَحَّحَ حافِظٌ':Subject, #1: 1	صَحَّحَ جَوَازَ
u'صَحَّحَ حاكِمٌ':Subject, #1: 1	صَحَّحَ الْحَافِظُ
u'صَحَّحَ حَديثٌ':Predicate, #3: 3	صَحَّحَ الْحَاكِمُ
u'صَحَّحَ حَديثٌ':Predicate, #1: 1	صَحَّحَ الْحَدِيثَ
u'صَحَّحَ حُروفٌ':Predicate, #1: 1	صَحَّحَ حَدِيثَ
u'صَحَّحَ دَوْرٌ':Predicate, #3: 3	صَحَّحَ الْحُرُوفَ
u'صَحَّ حَديثٌ':Subject, #1: 1	صَحَّحَ الدَّوْرَ
u'صَحَّ حَديثٌ':Subject, #11: 11	صَحَّ حَدِيثُ
u'صَحَّ حَديثٌ':Subject, #18: 18	صَحَّ الْحَدِيثُ
u'صَحَّحَ رُجُوعٌ':Predicate, #2: 2	صَحَّ حَدِيثٌ
u'صَحَّحَ رَسُولٌ':Subject, #1: 1	صَحَّحَ الرُّجُوعَ
u'صَحَّحَ رِوايَةٌ':Predicate, #1: 1	صَحَّحَ رَسُولُ
u'صَحَّحَ شَارِحٌ':Subject, #2: 2	صَحَّحَ رِوَايَةَ
u'صَحَّحَ شافِعِيّ':Subject, #1: 1	صَحَّحَ الشَّارِحُ
u'صَحَّحَ شمس':Subject, #1: 1	صَحَّحَ الشَّافِعِيُّ
u'صَحَّحَ شَمْسٌ':Subject, #1: 1	صَحَّحَ شَمْسُ
u'صَحَّحَ شَيْخٌ':Subject, #1: 1	صَحَّحَ شَمْسُ
u'صَحَّحَ صَاحِبٌ':Subject, #3: 3	صَحَّحَ الشَّيْخُ
u'صَحَّحَ صِحَّةٌ':Predicate, #4: 4	صَحَّحَ صَاحِبُ
u'صَحَّحَ صلح':Predicate, #1: 1	صَحَّحَ الصِّحَّةَ
u'صَحَّحَ صُلْحٌ':Predicate, #1: 1	صَحَّحَ الصُّلْحَ
u'صَحَّحَ ضَمَانٌ':Predicate, #1: 1	صَحَّحَ الصُّلْحَ
u'صَحَّ حَطّ':Subject, #1: 1	صَحَّحَ الضَّمَانَ
u'صَحَّحَ طَاعَةٌ':Predicate, #9: 9	صَحَّ الْحَطُّ
u'صَحَّحَ طَرِيقٌ':Predicate, #1: 1	صَحَّحَ الطَّاعَةَ
u'صَحَّحَ عَدَمٌ':Predicate, #2: 2	صَحَّحَ الطَّرِيقَ
u'صَحَّحَ عزل':Predicate, #6: 6	صَحَّحَ عَدَمَ
u'صَحَّحَ عِلَّةٌ':Predicate, #1: 1	صَحَّحَ عَزْلَ
u'صَحَّحَ عُمُومٌ':Predicate, #1: 1	صَحَّحَ الْعِلَّةَ
u'صَحَّحَ غير':Subject, #1: 1	صَحَّحَ عُمُومَ
u'صَحَّحَ غَيْرٌ':Subject, #1: 1	صَحَّحَ غَيْرُ
u'صَحَّحَ فقهاء':Subject, #1: 1	صَحَّحَ غَيْرُ
u'صَحَّحَ فلان':Subject, #1: 1	صَحَّحَ الْفُقَهَاءُ
u'صَحَّحَ قَبُولٌ':Predicate, #1: 1	صَحَّحَ الشَّافِعِيُّ
u'صَحَّحَ قول':Predicate, #1: 1	صَحَّحَ الْقَبُولَ
u'صَحَّحَ قَوْلٌ':Predicate, #1: 1	صَحَّحَ قَوْلَ
u'صَحَّحَ قول':Predicate, #1: 1	صَحَّحَ قَوْلَ
u'صَحَّحَ قَوْلٌ':Predicate, #3: 3	صَحَّحَ الْقَوْلَ
u'صَحَّحَ كَرَاهَةٌ':Predicate, #3: 3	صَحَّحَ الْقَوْلَ
u'صَحَّ حُكْمٌ':Subject, #1: 1	صَحَّحَ الْكَرَاهَةَ
u'صَحَّ حُكْمٌ':Subject, #1: 1	صَحَّ حُكْمُ
u'صَحَّ حُكْمٌ':Subject, #2: 2	صَحَّ حُكْمُهُ
u'صَحَّحَ مَذْهَبٌ':Predicate, #4: 4	صَحَّ الْحُكْمُ
u'صَحَّحَ مَسْأَلَةٌ':Predicate, #1: 1	صَحَّحَ الْمَذْهَبَ
u'صَحَّحَ مَشَايِخُ':Subject, #1: 1	صَحَّحَ مَسْأَلَةَ
u'صَحَّحَ مُصَنِّفٌ':Subject, #4: 4	صَحَّحَ الْمَشَايِخُ
u'صَحَّ حَمْلٌ':Subject, #6: 6	صَحَّحَ الْمُصَنِّفُ
u'صَحَّحَ مِلْكٌ':Predicate, #2: 2	صَحَّ الْحَمْلُ
u'صَحَّحَ مَنْعٌ':Predicate, #1: 1	صَحَّحَ الْمِلْكَ
u'صَحَّحَ مَوْقُوفٌ':Predicate, #1: 1	صَحَّحَ الْمَنْعَ
u'صَحَّحَ نَاظِمٌ':Subject, #1: 1	صَحَّحَ الْمَوْقُوفَ
u'صَحَّحَ نكاح':Subject, #1: 1	صَحَّحَ النَّاظِمُ
u'صَحَّحَ نِكَاحٌ':Subject, #1: 1	صَحَّحَ النِّكَاحُ
u'صَحَّحَ نَوَوِيٌّ':Subject, #1: 1	صَحَّحَ النِّكَاحُ
u'صَحَّحَ هِبَةٌ':Predicate, #13: 13	صَحَّحَ النَّوَوِيُّ
u'صَحَّحَ وَجَبٌ':Predicate, #1: 1	صَحَّحَ هِبَةَ
u'صَحَّحَ وُجُوبٌ':Predicate, #1: 1	صَحَّحَ وَجَبَ
u'صَحَّحَ وَصِيٌّ':Predicate, #1: 1	صَحَّحَ وُجُوبَ
u'صَحَّحَ وَصِيَّةٌ':Predicate, #1: 1	صَحَّحَ الْوَصِيَّةَ
u'صَحَّحَ وَقْفٌ':Predicate, #1: 1	صَحَّحَ الْوَصِيَّةَ
u'صَحَّحَ وُقُوعٌ':Predicate, #2: 2	صَحَّحَ الْوَقْفَ
u'صَحَّ خامس':Subject, #1: 1	صَحَّحَ الْوُقُوعَ
u'صَحَّ خَامِسٌ':Subject, #1: 1	صَحَّ الْخَامِسُ
u'صَحَّ خَبَرٌ':Subject, #1: 1	صَحَّ الْخَامِسُ
u'صَحَّ خَبَر':Subject, #12: 12	صَحَّ الْخَبَرُ
u'صَحَّ خَبَرٌ':Subject, #12: 12	صَحَّ الْخَبَرُ
u'صَحَّ خَبَرٌ':Subject, #1: 1	صَحَّ خَبَرٌ
u'صَحَّ خَبَر':Subject, #1: 1	صَحَّ خَبَرُ
u'صَحَّ خَبَر':Subject, #1: 1	صَحَّ خَبَرٌ
u'صَحَّ خُرُوجٌ':Subject, #1: 1	صَحَّ خَبَرُ
u'صَحَّ خُصٌّ':Predicate, #1: 1	صَحَّ خُرُوجُهُ
u'صَحَّ خَلْعٌ':Subject, #1: 1	صَحَّ خُصَّ
u'صَحَّ خُلْعٌ':Subject, #1: 1	صَحَّ الْخَلْعُ
u'صَحَّ خُلْعٌ':Subject, #29: 29	صَحَّ الْخُلْعُ
u'صَحَّ خَمْسٌ':Subject, #3: 3	صَحَّ خُلْعُهُ
u'صَحَّ خيار':Subject, #1: 1	صَحَّ الْخَمْسُ
u'صَحَّ خِيَارٌ':Subject, #2: 2	صَحَّ خِيَارُ
u'صَحَّ دُخُولٌ':Subject, #2: 2	صَحَّ خِيَارُ
u'صَحَّ دَعْوَةٌ':Subject, #2: 2	صَحَّ دُخُولُهُ
u'صَحَّ دَعْوَةٌ':Subject, #1: 1	صَحَّ دَعْوَةُ
u'صَحَّ دفع':Subject, #2: 2	صَحَّ دَعْوَتُهُ
u'صَحَّ دَفْعٌ':Subject, #7: 7	صَحَّ الدَّفْعُ
u'صَحَّ دَلالَةٌ':Subject, #7: 7	صَحَّ الدَّفْعُ
u'صَحَّ دِلاَلَةٌ':Subject, #1: 1	صَحَّ دَلاَلَةٌ
u'صَحَّ دونٌ':Predicate, #1: 1	صَحَّ دِلاَلَةٌ
u'صَحَّ ذكر':Subject, #1: 1	صَحَّ دُونَ
u'صَحَّ ذِكْرٌ':Subject, #2: 2	صَحَّ ذِكْرُهُ
u'صَحَّ ذَهَبٌ':Predicate, #2: 2	صَحَّ ذِكْرُهُ
u'صَحَّ رَأْيٌ':Subject, #1: 1	صَحَّ ذَهَبَ
u'صَحَّ رُجُوعٌ':Subject, #1: 1	صَحَّ رَأْيُ
u'صَحَّ رُجُوعٌ':Subject, #27: 27	صَحَّ رُجُوعُهُ
u'صَحَّ رُجُوعٌ':Subject, #5: 5	صَحَّ رُجُوعُ
u'صَحَّ رَدٌّ':Subject, #7: 7	صَحَّ الرُّجُوعُ
u'صَحَّ رَدٌّ':Subject, #1: 1	صَحَّ رَدٌّ
u'صَحَّ رَدٌّ':Subject, #5: 5	صَحَّ الرَّدُّ
u'صَحَّ رَفْعٌ':Subject, #9: 9	صَحَّ رَدُّهُ
u'صَحَّ رَفْعٌ':Subject, #1: 1	صَحَّ الرَّفْعُ
u'صَحَّ رَهْنٌ':Subject, #1: 1	صَحَّ رَفْعُ
u'صَحَّ رَهْنٌ':Subject, #13: 13	صَحَّ الرَّهْنُ
u'صَحَّ رَهْنٌ':Subject, #1: 1	صَحَّ رَهْنُ
u'صَحَّ رِوايَةٌ':Subject, #5: 5	صَحَّ رَهْنُهُ
u'صَحَّ زَوْجٌ':Subject, #2: 2	صَحَّ رِوَايَةُ
u'صَحَّ سَبَبٌ':Subject, #2: 2	صَحَّ الزَّوْجُ
u'صَحَّ سَبَبٌ':Subject, #1: 1	صَحَّ السَّبَبُ
u'صَحَّ سَبْيٌ':Subject, #1: 1	صَحَّ سَبَبُهُ
u'صَحَّ سُقُوطٌ':Subject, #1: 1	صَحَّ سَبْيُهُ
u'صَحَّ سَلْبٌ':Subject, #1: 1	صَحَّ سُقُوطُ
u'صَحَّ سَلَمٌ':Subject, #1: 1	صَحَّ سَلْبُ
u'صَحَّ سَلَمٌ':Subject, #11: 11	صَحَّ السَّلَمُ
u'صَحَّ سَمَاعٌ':Subject, #1: 1	صَحَّ سَلَمُ
u'صَحَّ سَمَاعٌ':Subject, #1: 1	صَحَّ السَّمَاعُ
u'صَحَّ سَمَاعٌ':Subject, #1: 1	صَحَّ سَمَاعُهُ
u'صَحَّ سَنَدٌ':Subject, #5: 5	صَحَّ سَمَاعُ
u'صَحَّ سَواءٌ':Subject, #5: 5	صَحَّ سَنَدُهُ
u'صَحَّ سُؤَالٌ':Subject, #3: 3	صَحَّ سَوَاءٌ
u'صَحَّ شَاهِدٌ':Subject, #2: 2	صَحَّ السُّؤَالُ
u'صَحَّ شِرَاءٌ':Subject, #1: 1	صَحَّ شَاهِدٌ
u'صَحَّ شِرَاءٌ':Subject, #27: 27	صَحَّ الشِّرَاءُ
u'صَحَّ شَرْطٌ':Subject, #4: 4	صَحَّ شِرَاءُ
u'صَحَّ شَرْطٌ':Subject, #15: 15	صَحَّ الشَّرْطُ
u'صَحَّ شَرْطٌ':Subject, #2: 2	صَحَّ شَرْطُ
u'صَحَّ شُرُوعٌ':Subject, #2: 2	صَحَّ شَرْطُهُ
u'صَحَّ شُرُوعٌ':Subject, #17: 17	صَحَّ شُرُوعُهُ
u'صَحَّ شَرِيطٌ':Subject, #5: 5	صَحَّ الشُّرُوعُ
u'صَحَّ صَادِرٌ':Subject, #1: 1	صَحَّ شَرِيطُهُ
u'صَحَّ صداق':Subject, #2: 2	صَحَّ الصَّادِرُ
u'صَحَّ صَدَاقٌ':Subject, #1: 1	صَحَّ الصَّدَاقُ
u'صَحَّ صَرْفٌ':Subject, #1: 1	صَحَّ الصَّدَاقُ
u'صَحَّ صَرْف':Subject, #1: 1	صَحَّ صَرْفُهُ
u'صَحَّ صَرْفٌ':Subject, #1: 1	صَحَّ صَرْفُهُ
u'صَحَّ صَرْف':Subject, #2: 2	صَحَّ الصَّرْفُ
u'صَحَّ صلح':Subject, #2: 2	صَحَّ الصَّرْفُ
u'صَحَّ صُلْحٌ':Subject, #27: 27	صَحَّ الصُّلْحُ
u'صَحَّ صَوَابٌ':Subject, #27: 27	صَحَّ الصُّلْحُ
u'صَحَّ صَوْمٌ':Subject, #1: 1	صَحَّ صَوَابُهُ
u'صَحَّ صَوْمٌ':Subject, #26: 26	صَحَّ صَوْمُهُ
u'صَحَّ صَوْمٌ':Subject, #2: 2	صَحَّ الصَّوْمُ
u'صَحَّ صِيَامٌ':Subject, #3: 3	صَحَّ صَوْمُ
u'صَحَّ ضَبْطٌ':Subject, #1: 1	صَحَّ صِيَامُهُ
u'صَحَّ ضَرُورَةٌ':Predicate, #1: 1	صَحَّ ضَبْطُهُ
u'صَحَّ ضَمَانٌ':Subject, #1: 1	صَحَّ ضَرُورَةَ
u'صَحَّ ضَمَانٌ':Subject, #11: 11	صَحَّ الضَّمَانُ
u'صَحَّ ضَمَانٌ':Subject, #7: 7	صَحَّ ضَمَانُ
u'صَحَّ طَرِيقٌ':Subject, #9: 9	صَحَّ ضَمَانُهُ
u'صَحَّ طَرِيقٌ':Subject, #1: 1	صَحَّ الطَّرِيقُ
u'صَحَّ طَلاَقٌ':Subject, #4: 4	صَحَّ طَرِيقُهُ
u'صَحَّ طَلاَقٌ':Subject, #15: 15	صَحَّ طَلَاقُهُ
u'صَحَّ طَلاَقٌ':Subject, #2: 2	صَحَّ الطَّلَاقُ
u'صَحَّ طلب':Subject, #3: 3	صَحَّ طَلَاقُ
u'صَحَّ طَلَبٌ':Subject, #1: 1	صَحَّ طَلَبُهُ
u'صَحَّ طَهَارَةٌ':Subject, #1: 1	صَحَّ طَلَبُهُ
u'صَحَّ ظهار':Subject, #1: 1	صَحَّ طَهَارَتُهُ
u'صَحَّ ظهار':Subject, #14: 14	صَحَّ ظِهَارُهُ
u'صَحَّ ظَهْرٌ':Predicate, #2: 2	صَحَّ ظِهَارُ
u'صَحَّ عتق':Subject, #1: 1	صَحَّ ظَهْرَ
u'صَحَّ عِتْقٌ':Subject, #17: 17	صَحَّ عِتْقُهُ
u'صَحَّ عتق':Subject, #17: 17	صَحَّ عِتْقُهُ
u'صَحَّ عِتْقٌ':Subject, #1: 1	صَحَّ عِتْقُ
u'صَحَّ عِتْقٌ':Subject, #1: 1	صَحَّ عِتْقٌ
u'صَحَّ عتق':Subject, #1: 1	صَحَّ عِتْقُ
u'صَحَّ عِتْقٌ':Subject, #6: 6	صَحَّ الْعِتْقُ
u'صَحَّ عجز':Subject, #6: 6	صَحَّ الْعِتْقُ
u'صَحَّ عَجْزٌ':Subject, #1: 1	صَحَّ عَجْزُهُ
u'صَحَّ عزل':Subject, #1: 1	صَحَّ عَجْزُهُ
u'صَحَّ عزل':Subject, #4: 4	صَحَّ الْعَزْلُ
u'صَحَّ عطف':Subject, #4: 4	صَحَّ عَزْلُهُ
u'صَحَّ عَطْفٌ':Subject, #1: 1	صَحَّ عَطْفُ
u'صَحَّ عَفْوٌ':Subject, #1: 1	صَحَّ عَطْفُ
u'صَحَّ عَفْوٌ':Subject, #5: 5	صَحَّ عَفْوُ
u'صَحَّ عَفْوٌ':Subject, #8: 8	صَحَّ عَفْوُهُ
u'صَحَّ عَقْدٌ':Subject, #9: 9	صَحَّ الْعَفْوُ
u'صَحَّ عَقْدٌ':Subject, #1: 1	صَحَّ عَقْدُهُ
u'صَحَّ عَقْدٌ':Subject, #2: 2	صَحَّ عَقْدُ
u'صَحَّ عَكْسٌ':Subject, #63: 63	صَحَّ الْعَقْدُ
u'صَحَّ عَمَلٌ':Subject, #1: 1	صَحَّ عَكْسُهُ
u'صَحَّ عَمَلٌ':Subject, #1: 1	صَحَّ عَمَلُ
u'صَحَّ عَمَلٌ':Subject, #1: 1	صَحَّ عَمَلُهُ
u'صَحَّ عُمُومٌ':Subject, #2: 2	صَحَّ الْعَمَلُ
u'صَحَّ عند':Predicate, #1: 1	صَحَّ الْعُمُومُ
u'صَحَّ عند':Predicate, #1: 1	صَحَّ عِنْدَكَ
u'صَحَّ عَهْدٌ':Subject, #27: 27	صَحَّ عِنْدَ
u'صَحَّ غُسْلٌ':Subject, #1: 1	صَحَّ عَهْدُهُ
u'صَحَّ غُسْلٌ':Subject, #1: 1	صَحَّ غُسْلُ
u'صَحَّ غَصْبٌ':Subject, #7: 7	صَحَّ غُسْلُهُ
u'صَحَّ غير':Predicate, #1: 1	صَحَّ غَصْبُهُ
u'صَحَّ غَيْرٌ':Predicate, #1: 1	صَحَّ غَيْرَ
u'صَحَّ فَجْرٌ':Subject, #1: 1	صَحَّ غَيْرَ
u'صَحَّ فَرْضٌ':Subject, #1: 1	صَحَّ فَجْرُهُ
u'صَحَّ فَرْضٌ':Subject, #1: 1	صَحَّ الْفَرْضُ
u'صَحَّ فَرْضٌ':Subject, #1: 1	صَحَّ فَرْضٌ
u'صَحَّ فَرْعٌ':Subject, #1: 1	صَحَّ فَرْضُ
u'صَحَّ فرق':Subject, #1: 1	صَحَّ الْفَرْعُ
u'صَحَّ فَرْقٌ':Subject, #2: 2	صَحَّ الْفَرْقُ
u'صَحَّ فَسْخٌ':Subject, #2: 2	صَحَّ الْفَرْقُ
u'صَحَّ فَسْخٌ':Subject, #3: 3	صَحَّ فَسْخُهُ
u'صَحَّ فَصْلٌ':Subject, #7: 7	صَحَّ الْفَسْخُ
u'صَحَّ فِعْلٌ':Subject, #1: 1	صَحَّ فَصْلُ
u'صَحَّ فِعْلٌ':Subject, #1: 1	صَحَّ فِعْلُ
u'صَحَّ قَالٌ':Predicate, #1: 1	صَحَّ فِعْلُهُ
u'صَحَّ قَبْضٌ':Subject, #12: 12	صَحَّ قَالَ
u'صَحَّ قَبْضٌ':Subject, #10: 10	صَحَّ قَبْضُهُ
u'صَحَّ قَبْضٌ':Subject, #3: 3	صَحَّ الْقَبْضُ
u'صَحَّ قَبُولٌ':Subject, #3: 3	صَحَّ قَبْضُ
u'صَحَّ قَبُولٌ':Subject, #1: 1	صَحَّ الْقَبُولُ
u'صَحَّ قذف':Subject, #2: 2	صَحَّ قَبُولُهُ
u'صَحَّ قَذْفٌ':Subject, #1: 1	صَحَّ الْقَذْفُ
u'صَحَّ قراض':Subject, #1: 1	صَحَّ الْقَذْفُ
u'صَحَّ قِرَانٌ':Subject, #1: 1	صَحَّ الْقِرَاضُ
u'صَحَّ قِرَانٌ':Subject, #1: 1	صَحَّ قِرَانُ
u'صَحَّ قَرْضٌ':Subject, #2: 2	صَحَّ قِرَانُهُ
u'صَحَّ قَرْضٌ':Subject, #2: 2	صَحَّ الْقَرْضُ
u'صَحَّ قَصْدٌ':Subject, #2: 2	صَحَّ قَرْضُهُ
u'صَحَّ قَصْرٌ':Subject, #1: 1	صَحَّ قَصْدُهُ
u'صَحَّ قَضَاءٌ':Subject, #2: 2	صَحَّ الْقَصْرُ
u'صَحَّ قُنُوتٌ':Subject, #5: 5	صَحَّ الْقَضَاءُ
u'صَحَّ قول':Subject, #1: 1	صَحَّ قُنُوتُهُ
u'صَحَّ قَوْلٌ':Subject, #2: 2	صَحَّ قَوْلُ
u'صَحَّ قول':Subject, #2: 2	صَحَّ قَوْلُ
u'صَحَّ قَوْلٌ':Subject, #6: 6	صَحَّ الْقَوْلُ
u'صَحَّ قول':Subject, #6: 6	صَحَّ الْقَوْلُ
u'صَحَّ قَوْلٌ':Subject, #9: 9	صَحَّ قَوْلُهُ
u'صَحَّ قِيَاسٌ':Subject, #9: 9	صَحَّ قَوْلُهُ
u'صَحَّ قِيَاسٌ':Subject, #1: 1	صَحَّ قِيَاسُ
u'صَحَّ قِيَاسٌ':Subject, #2: 2	صَحَّ قِيَاسُهُ
u'صَحَّ قيام':Subject, #3: 3	صَحَّ الْقِيَاسُ
u'صَحَّ قِيَامٌ':Subject, #1: 1	صَحَّ قِيَامُ
u'صَحَّ كِتَابَةٌ':Subject, #1: 1	صَحَّ قِيَامُ
u'صَحَّ كِرَاءٌ':Subject, #1: 1	صَحَّ كِتَابَةُ
u'صَحَّ كَلاَمٌ':Subject, #1: 1	صَحَّ الْكِرَاءُ
u'صَحَّ كَلاَمٌ':Subject, #1: 1	صَحَّ كَلَامُهُ
u'صَحَّ كَوْنٌ':Subject, #3: 3	صَحَّ الْكَلَامُ
u'صَحَّ كَوْنٌ':Subject, #1: 1	صَحَّ كَوْنُ
u'صَحَّ كِيمْيَاءُ':Subject, #5: 5	صَحَّ كَوْنُهُ
u'صَحَّ لعان':Subject, #1: 1	صَحَّ الْكِيمْيَاءُ
u'صَحَّ لعان':Subject, #1: 1	صَحَّ اللِّعَانُ
u'صَحَّ لَفْظٌ':Subject, #6: 6	صَحَّ لِعَانُهُ
u'صَحَّ مَبِيعٌ':Subject, #1: 1	صَحَّ لَفْظُهُ
u'صَحَّ مَجِيءٌ':Subject, #1: 1	صَحَّ الْمَبِيعُ
u'صَحَّ مَحَلٌّ':Subject, #1: 1	صَحَّ مَجِيءُ
u'صَحَّ مَحْمُولٌ':Subject, #1: 1	صَحَّ مَحَلُّهُ
u'صَحَّ مَذْهَبٌ':Subject, #5: 5	صَحَّ مَحْمُولٌ
u'صَحَّ مراد':Subject, #1: 1	صَحَّ مَذْهَبُ
u'صَحَّ مُرَادٌ':Subject, #1: 1	صَحَّ الْمُرَادُ
u'صَحَّ مَرِيضٌ':Subject, #1: 1	صَحَّ الْمُرَادُ
u'صَحَّ مَسْحٌ':Subject, #10: 10	صَحَّ الْمَرِيضُ
u'صَحَّ مُعْتَقَدٌ':Subject, #1: 1	صَحَّ الْمَسْحُ
u'صَحَّ مَعْرُوفٌ':Subject, #1: 1	صَحَّ مُعْتَقَدُهُ
u'صَحَّ مَغْرِبٌ':Subject, #1: 1	صَحَّ مَعْرُوفُهُ
u'صَحَّ مُفِيدٌ':Subject, #1: 1	صَحَّ مَغْرِبُهُ
u'صَحَّ مِلْكٌ':Subject, #1: 1	صَحَّ مُفِيدُ
u'صَحَّ مِلْكٌ':Subject, #1: 1	صَحَّ الْمِلْكُ
u'صَحَّ مَنْعٌ':Subject, #1: 1	صَحَّ مِلْكُ
u'صَحَّ مَهْرٌ':Subject, #2: 2	صَحَّ مَنْعُهُ
u'صَحْنٌ بَدْرٌ':Added, #1: 1	صَحَّ مَهْرُ
u'صَحْنٌ جَامِعٌ':Added, #1: 1	صَحْنِ بَدْرٍ
u'صَحْنٌ خَانٌ':Added, #1: 1	صَحْنَ الْجَامِعِ
u'صَحْنٌ دَاخِلٌ':Added, #1: 1	صَحْنِ الْخَانِ
u'صَحْنٌ دَارٌ':Added, #1: 1	صَحْنَ الدَّاخِلِ
u'صَحْنٌ دَارٌ':Added, #1: 1	صَحْنُ الدَّارِ
u'صَحْنٌ دَارٌ':Added, #1: 1	صَحْنَ دَارِهِ
u'صَحْنٌ دَارٌ':Added, #28: 28	صَحْنِ الدَّارِ
u'صَحْنٌ دَارٌ':Added, #2: 2	صَحْنِ دَارٍ
u'صَحْنٌ دَارٌ':Added, #2: 2	صَحْنِ دَارِهِ
u'صَحَّ نذر':Subject, #7: 7	صَحْنَ الدَّارِ
u'صَحَّ نَذْرٌ':Subject, #15: 15	صَحَّ نَذْرُهُ
u'صَحَّ نذر':Subject, #15: 15	صَحَّ نَذْرُهُ
u'صَحَّ نَذْرٌ':Subject, #1: 1	صَحَّ نَذْرُ
u'صَحَّ نذر':Subject, #1: 1	صَحَّ نَذْرُ
u'صَحَّ نَذْرٌ':Subject, #9: 9	صَحَّ النَّذْرُ
u'صَحَّ نِسْبَةٌ':Subject, #9: 9	صَحَّ النَّذْرُ
u'صَحَّ نَصٌّ':Predicate, #2: 2	صَحَّ نِسْبَةُ
u'صَحَّ نَصٌّ':Subject, #6: 6	صَحَّ نَصَّ
u'صَحَّ نصب':Subject, #1: 1	صَحَّ النَّصُّ
u'صَحَّ نَصْبٌ':Subject, #1: 1	صَحَّ النَّصْبُ
u'صَحَّ نِصْفٌ':Subject, #1: 1	صَحَّ النَّصْبُ
u'صَحْنٌ طَاحُونٌ':Added, #1: 1	صَحَّ نِصْفُهُ
u'صَحْنٌ طَاحُونٌ':Added, #1: 1	صَحْنُ الطَّاحُونَةِ
u'صَحْنٌ طَرِيقٌ':Added, #1: 1	صَحْنِ الطَّاحُونَةِ
u'صَحَّ نُطْقٌ':Subject, #1: 1	صَحْنِ الطَّرِيقِ
u'صَحَّ نفاذ':Subject, #2: 2	صَحَّ النُّطْقُ
u'صَحَّ نَفَاذٌ':Subject, #1: 1	صَحَّ النَّفَاذُ
u'صَحَّ نِفَاقٌ':Subject, #1: 1	صَحَّ النَّفَاذُ
u'صَحَّ نَفَذٌ':Predicate, #1: 1	صَحَّ نِفَاقُهُ
u'صَحَّ نَفَلٌ':Subject, #1: 1	صَحَّ نَفَذَ
u'صَحَّ نَفْلٌ':Subject, #1: 1	صَحَّ النَّفَلُ
u'صَحَّ نَفْيٌ':Subject, #1: 1	صَحَّ نَفْلُهُ
u'صَحَّ نَقْضٌ':Subject, #7: 7	صَحَّ نَفْيُهُ
u'صَحَّ نَقْضٌ':Subject, #1: 1	صَحَّ النَّقْضُ
u'صَحَّ نقل':Subject, #2: 2	صَحَّ نَقْضُهُ
u'صَحَّ نَقْلٌ':Subject, #1: 1	صَحَّ نَقْلُ
u'صَحَّ نقل':Subject, #1: 1	صَحَّ نَقْلُ
u'صَحَّ نَقْلٌ':Subject, #4: 4	صَحَّ النَّقْلُ
u'صَحَّ نقل':Subject, #4: 4	صَحَّ النَّقْلُ
u'صَحَّ نَقْلٌ':Subject, #4: 4	صَحَّ نَقْلُهُ
u'صَحَّ نكاح':Subject, #4: 4	صَحَّ نَقْلُهُ
u'صَحَّ نِكَاحٌ':Subject, #32: 32	صَحَّ نِكَاحُ
u'صَحَّ نكاح':Subject, #32: 32	صَحَّ نِكَاحُ
u'صَحَّ نِكَاحٌ':Subject, #78: 78	صَحَّ النِّكَاحُ
u'صَحَّ نكاح':Subject, #78: 78	صَحَّ النِّكَاحُ
u'صَحَّ نِكَاحٌ':Subject, #9: 9	صَحَّ نِكَاحُهُ
u'صَحْنٌ مَسْجِدٌ':Added, #9: 9	صَحَّ نِكَاحُهُ
u'صَحْنٌ مَسْجِدٌ':Added, #2: 2	صَحْنُ الْمَسْجِدِ
u'صَحَّ نَهْيٌ':Subject, #2: 2	صَحْنِ الْمَسْجِدِ
u'صَحَّ نَهْيٌ':Subject, #10: 10	صَحَّ نَهْيُهُ
u'صَحَّ نِيَّةٌ':Subject, #11: 11	صَحَّ النَّهْيُ
u'صَحَّ وَجَبٌ':Predicate, #3: 3	صَحَّ نِيَّةُ
u'صَحَّ وُرُودٌ':Subject, #6: 6	صَحَّ وَجَبَ
u'صَحَّ وَصْفٌ':Subject, #7: 7	صَحَّ وُرُودُ
u'صَحَّ وَضْعٌ':Subject, #1: 1	صَحَّ وَصْفُهُ
u'صَحَّ وُضُوءٌ':Subject, #1: 1	صَحَّ وَضْعُ
u'صَحَّ وُضُوءٌ':Subject, #12: 12	صَحَّ وُضُوءُهُ
u'صَحَّ وَعِيدٌ':Subject, #6: 6	صَحَّ الْوُضُوءُ
u'صَحَّ وَقْفٌ':Subject, #1: 1	صَحَّ وَعِيدٌ
u'صَحَّ وَقْفٌ':Subject, #1: 1	صَحَّ وَقْفُهُ
u'صَحَّ وَقْفٌ':Subject, #29: 29	صَحَّ الْوَقْفُ
u'صَحَّ وُقُوعٌ':Subject, #2: 2	صَحَّ وَقْفُ
u'صَحَّ وُقُوعٌ':Subject, #1: 1	صَحَّ الْوُقُوعُ
u'صَحَّ ولد':Predicate, #1: 1	صَحَّ وُقُوعُهُ
u'صَحَّ وَلَهٌ':Subject, #1: 1	صَحَّ وُلِدَ
u'صَحَّ يَقِينٌ':Subject, #6: 6	صَحَّ وَلَهُ
u'صَحَّ يَمِينٌ':Subject, #1: 1	صَحَّ يَقِينُهُ
u'صَحَّ يَوْمٌ':Subject, #1: 1	صَحَّ يَمِينُهُ
u'صَخَبٌ خلق':Added, #1: 1	صَحَّ يَوْمُ
u'صَخَبٌ خَلْقٌ':Added, #1: 1	صَخَبِ الْخَلْقِ
u'صَدَّرَ اِبْنٌ':Subject, #1: 1	صَخَبِ الْخَلْقِ
u'صَدَرَ إِجْمَاعٌ':Subject, #1: 1	صَدَّرَ ابْنُ
u'صَدْرٌ أَذَانٌ':Added, #1: 1	صَدَرَ الْإِجْمَاعُ
u'صَدْرٌ إِسْلامٌ':Added, #3: 3	صَدْرِ الأَذَانِ
u'صَدْرٌ إِسْلامٌ':Added, #2: 2	صَدْرِ الإِسْلاَمِ
u'صَدْرٌ إِسْلامٌ':Added, #45: 45	صَدْرِ الْإِسْلَامِ
u'صَدْرٌ إِسْلامٌ':Added, #52: 52	صَدْرُ الْإِسْلَامِ
u'صَدَرَ إِعْتاقٌ':Subject, #6: 6	صَدْرَ الْإِسْلَامِ
u'صَدَرَ اِعْتِقادٌ':Subject, #1: 1	صَدَرَ الْإِعْتَاقُ
u'صَدْرٌ أفاضل':Added, #1: 1	صَدَرَ اعْتِقَادُهُ
u'صَدْرٌ الْمَرْءُ':Added, #1: 1	صَدْرُ الْأَفَاضِلِ
u'صَدْرٌ الْمَرْأَةُ':Added, #2: 2	صَدْرُ الْمَرْءِ
u'صَدْرٌ الْمَرْأَةُ':Added, #1: 1	صَدْرَ الْمَرْأَةِ
u'صَدْرٌ الْمَرْأَةُ':Added, #1: 1	صَدْرُ الْمَرْأَةِ
u'صَدْرٌ أُمَّةٌ':Added, #1: 1	صَدْرِ الْمَرْأَةِ
u'صَدَرَ أَمْرٌ':Subject, #1: 1	صَدْرُ الْأُمَّةِ
u'صَدْرٌ إِنْسانٌ':Added, #2: 2	صَدَرَ الْأَمْرُ
u'صَدَرَ أهْلٌ':Subject, #1: 1	صَدْرِ الْإِنْسَانِ
u'صَدْرٌ أَوَّلُ':Added, #2: 2	صَدَرَ أَهْلُ
u'صَدْرٌ آيَةٌ':Added, #1: 1	صَدْرِ الْأَوَّلِ
u'صَدْرٌ آيَةٌ':Added, #1: 1	صَدْرُ الْآيَةِ
u'صَدَرَ إِيجَابٌ':Subject, #2: 2	صَدْرِ الْآيَةِ
u'صَدَّرَ بَابٌ':Predicate, #4: 4	صَدَرَ الْإِيجَابُ
u'صَدْرٌ بَابٌ':Added, #1: 1	صَدَّرَ الْبَابَ
u'صَدَّرَ بَحْثٌ':Predicate, #4: 4	صَدْرِ الْبَابِ
u'صَدَرَ بَحْثٌ':Subject, #1: 1	صَدَّرَ الْبَحْثَ
u'صَدْرٌ بَحْثٌ':Added, #1: 1	صَدَرَ الْبَحْثُ
u'صَدْرٌ بَحْثٌ':Added, #1: 1	صَدْرَ الْبَحْثِ
u'صَدْرٌ بَيَاضٌ':Added, #1: 1	صَدْرِ الْبَحْثِ
u'صَدَرَ بَيْعٌ':Subject, #2: 2	صَدْرِ الْبَيَاضِ
u'صَدَرَ بَيْعٌ':Subject, #1: 1	صَدَرَ الْبَيْعُ
u'صَدَرَ بَيْنٌ':Predicate, #5: 5	صَدَرَ بَيْعٌ
u'صَدَرَ تَحْكِيمٌ':Subject, #1: 1	صَدَرَ بَيْنَ
u'صَدْرٌ تَرْجَمَةٌ':Added, #1: 1	صَدَرَ التَّحْكِيمُ
u'صَدْرٌ تَعْرِيفٌ':Added, #1: 1	صَدْرِ التَّرْجَمَةِ
u'صَدَرَ تَنْجِيزٌ':Subject, #1: 1	صَدْرِ تَعْرِيفِهِ
u'صَدَرَ تَوْظِيفٌ':Subject, #1: 1	صَدَرَ تَنْجِيزُهُ
u'صَدْرٌ ثَوْبٌ':Added, #3: 3	صَدَرَ التَّوْظِيفُ
u'صَدَرَ حَديثٌ':Subject, #1: 1	صَدْرِ ثَوْبِ
u'صَدْرٌ حَديثٌ':Added, #1: 1	صَدَرَ الْحَدِيثُ
u'صَدْرٌ حَديثٌ':Added, #1: 1	صَدْرَ الْحَدِيثِ
u'صَدْرٌ حَديثٌ':Added, #1: 1	صَدْرِ الْحَدِيثِ
u'صَدْرٌ حَديثٌ':Added, #1: 1	صَدْرِ حَدِيثٍ
u'صَدْرٌ حسام':Added, #2: 2	صَدْرُ الْحَدِيثِ
u'صَدْرٌ حُسَامٌ':Added, #1: 1	صَدْرُ الْحُسَامِ
u'صَدَرَ حُكْمٌ':Subject, #1: 1	صَدْرُ الْحُسَامِ
u'صَدْرٌ حِمَالَةٌ':Added, #2: 2	صَدَرَ الْحُكْمُ
u'صَدَرَ حَمْدٌ':Subject, #1: 1	صَدْرَ الْحِمَالَةِ
u'صَدْرٌ خطبة':Added, #1: 1	صَدَرَ الْحَمْدُ
u'صَدْرٌ خُطْبَةٌ':Added, #1: 1	صَدْرِ الْخُطْبَةِ
u'صَدْرٌ خِلاَفَةٌ':Added, #1: 1	صَدْرِ الْخُطْبَةِ
u'صَدْرٌ خِلاَفَةٌ':Added, #1: 1	صَدْرُ خِلَافَةِ
u'صَدْرٌ خِلاَفَةٌ':Added, #1: 1	صَدْرِ خِلَافَةِ
u'صَدْرٌ دَرْبٌ':Added, #1: 1	صَدْرِ خِلاَفَةِ
u'صَدْرٌ دَوْلَةٌ':Added, #1: 1	صَدْرِ الدَّرْبِ
u'صَدْرٌ دِينٌ':Added, #1: 1	صَدْرِ الدَّوْلَةِ
u'صَدْرٌ دِينٌ':Added, #2: 2	صَدْرَ الدِّينِ
u'صَدْرٌ دِينٌ':Added, #3: 3	صَدْرِ الدِّينِ
u'صَدْرٌ ذكر':Added, #5: 5	صَدْرُ الدِّينِ
u'صَدْرٌ ذِكْرٌ':Added, #1: 1	صَدْرِ الذِّكْرِ
u'صَدْرٌ رَجُلٌ':Added, #1: 1	صَدْرِ الذِّكْرِ
u'صَدْرٌ رَجُلٌ':Added, #3: 3	صَدْرِ رَجُلٍ
u'صَدْرٌ رَسُولٌ':Added, #8: 8	صَدْرِ الرَّجُلِ
u'صَدْرٌ رَسُولٌ':Added, #1: 1	صَدْرِ رَسُولِ
u'صَدَرَ رَهْنٌ':Subject, #1: 1	صَدْرَ رَسُولِهِ
u'صَدْرٌ سائِل':Added, #2: 2	صَدَرَ الرَّهْنُ
u'صَدْرٌ سَائِلٌ':Added, #1: 1	صَدْرِ السَّائِلِ
u'صَدَرَ سِجِلٌّ':Subject, #1: 1	صَدْرِ السَّائِلِ
u'صَدْرٌ سِجِلٌّ':Added, #2: 2	صَدَرَ السِّجِلُّ
u'صَدْرٌ سِجِلٌّ':Added, #2: 2	صَدْرِ السِّجِلِّ
u'صَدْرٌ سِكَّةٌ':Added, #4: 4	صَدْرَ السِّجِلِّ
u'صَدْرٌ سُورَةٌ':Added, #1: 1	صَدْرِ السِّكَّةِ
u'صَدْرٌ سُورَةٌ':Added, #1: 1	صَدْرِ السُّورَةِ
u'صَدْرٌ سُورَةٌ':Added, #1: 1	صَدْرُ سُورَةِ
u'صَدْرٌ سُورَةٌ':Added, #1: 1	صَدْرِ سُورَةِ
u'صَدْرٌ شَرْحٌ':Added, #2: 2	صَدْرَ سُورَةِ
u'صَدَرَ شَرْطٌ':Subject, #2: 2	صَدْرِ شَرْحِهِ
u'صَدْرٌ شَرْعٌ':Added, #1: 1	صَدَرَ الشَّرْطُ
u'صَدْرٌ شَرِيعَةٌ':Added, #1: 1	صَدْرِ الشَّرْعِ
u'صَدْرٌ شَرِيعَةٌ':Added, #101: 101	صَدْرُ الشَّرِيعَةِ
u'صَدْرٌ شَرِيعَةٌ':Added, #53: 53	صَدْرِ الشَّرِيعَةِ
u'صَدْرٌ شِعْبٌ':Added, #5: 5	صَدْرَ الشَّرِيعَةِ
u'صَدْرٌ صَحِيحٌ':Added, #2: 2	صَدْرَ الشِّعْبِ
u'صَدْرٌ صُدُورٌ':Added, #2: 2	صَدْرِ صَحِيحِهِ
u'صَدَرَ صَكٌّ':Subject, #1: 1	صَدْرِ الصُّدُورِ
u'صَدْرٌ صَكٌّ':Added, #1: 1	صَدَرَ صَكُّ
u'صَدْرٌ صَيْدٌ':Added, #1: 1	صَدْرِ الصَّكِّ
u'صَدْرٌ عِبَارَةٌ':Added, #1: 1	صَدْرِ الصَّيْدِ
u'صَدْرٌ عِبَارَةٌ':Added, #1: 1	صَدْرِ الْعِبَارَةِ
u'صَدْرٌ عِبَارَةٌ':Added, #1: 1	صَدْرِ عِبَارَةِ
u'صَدْرٌ عِبَارَةٌ':Added, #1: 1	صَدْرِ عِبَارَتِهِ
u'صَدْرٌ عَدَدٌ':Added, #2: 2	صَدْرَ عِبَارَةِ
u'صَدَّرَ عَقْدٌ':Predicate, #1: 1	صَدْرِ الْعَدَدِ
u'صَدَرَ عَقْدٌ':Subject, #1: 1	صَدَّرَ الْعَقْدَ
u'صَدَرَ عَقْدٌ':Subject, #1: 1	صَدَرَ عَقْدُ
u'صَدَرَ عند':Predicate, #4: 4	صَدَرَ الْعَقْدُ
u'صَدَرَ غُرُورٌ':Subject, #1: 1	صَدَرَ عِنْدَ
u'صَدْرٌ فِرَاشٌ':Added, #1: 1	صَدَرَ الْغُرُورُ
u'صَدَّرَ فَصْلٌ':Predicate, #2: 2	صَدْرِ فِرَاشِهِ
u'صَدَرَ فَصْلٌ':Subject, #1: 1	صَدَّرَ الْفَصْلَ
u'صَدْرٌ فَصْلٌ':Added, #1: 1	صَدَرَ الْفَصْلُ
u'صَدْرٌ فَصْلٌ':Added, #1: 1	صَدْرُ الْفَصْلِ
u'صَدَرَ فِعْلٌ':Subject, #2: 2	صَدْرِ الْفَصْلِ
u'صَدَّرَ فلان':Subject, #1: 1	صَدَرَ فِعْلُهُ
u'صَدْرٌ قِرْطَاسٌ':Added, #1: 1	صَدَّرَ الْبَيْهَقِيُّ
u'صَدْرٌ قِرْطَاسٌ':Added, #2: 2	صَدْرِ الْقِرْطَاسِ
u'صَدْرٌ قضاة':Added, #2: 2	صَدْرِ قِرْطَاسٍ
u'صَدْرٌ قضاة':Added, #1: 1	صَدْرُ الْقُضَاةِ
u'صَدْرٌ قَنَاةٌ':Added, #2: 2	صَدْرِ الْقُضَاةِ
u'صَدْرٌ قَنَاةٌ':Added, #1: 1	صَدْرُ الْقَنَاةِ
u'صَدَرَ قول':Subject, #1: 1	صَدْرِ قَنَاةٍ
u'صَدَرَ قَوْلٌ':Subject, #1: 1	صَدَرَ الْقَوْلُ
u'صَدَرَ قول':Subject, #1: 1	صَدَرَ الْقَوْلُ
u'صَدَرَ قَوْلٌ':Subject, #1: 1	صَدَرَ قَوْلُهُ
u'صَدْرٌ قول':Added, #1: 1	صَدَرَ قَوْلُهُ
u'صَدْرٌ قَوْلٌ':Added, #1: 1	صَدْرِ الْقَوْلِ
u'صَدْرٌ كِتَابٌ':Added, #1: 1	صَدْرِ الْقَوْلِ
u'صَدْرٌ كِتَابٌ':Added, #1: 1	صَدْرَ الْكِتَابِ
u'صَدْرٌ كِتَابٌ':Added, #1: 1	صَدْرِ كِتَابِهِ
u'صَدْرٌ كِتَابٌ':Added, #2: 2	صَدْرِ كِتَابِ
u'صَدَرَ كَلاَمٌ':Subject, #6: 6	صَدْرِ الْكِتَابِ
u'صَدْرٌ كَلاَمٌ':Added, #2: 2	صَدَرَ الْكَلَامُ
u'صَدْرٌ كَلاَمٌ':Added, #13: 13	صَدْرِ الْكَلَامِ
u'صَدْرٌ كَلاَمٌ':Added, #14: 14	صَدْرُ الْكَلَامِ
u'صَدْرٌ كَلاَمٌ':Added, #1: 1	صَدْرُ كَلَامِ
u'صَدْرٌ كَلاَمٌ':Added, #1: 1	صَدْرِ كَلَامِ
u'صَدْرٌ كَلاَمٌ':Added, #4: 4	صَدْرُ كَلَامِهِ
u'صَدْرٌ كَلاَمٌ':Added, #5: 5	صَدْرَ كَلَامِهِ
u'صَدْرٌ كَلاَمٌ':Added, #6: 6	صَدْرِ كَلَامِهِ
u'صَدَرَ مثل':Subject, #9: 9	صَدْرَ الْكَلَامِ
u'صَدَرَ مِثْلٌ':Subject, #1: 1	صَدَرَ مِثْلُ
u'صَدْرٌ مَجْلِسٌ':Added, #1: 1	صَدَرَ مِثْلُ
u'صَدْرٌ مَجْلِسٌ':Added, #1: 1	صَدْرُ الْمَجْلِسِ
u'صَدْرٌ مَجْلِسٌ':Added, #1: 1	صَدْرِ الْمَجْلِسِ
u'صَدَّرَ مَسْأَلَةٌ':Predicate, #1: 1	صَدْرِ مَجْلِسِهِ
u'صَدْرٌ مَسْأَلَةٌ':Added, #1: 1	صَدَّرَ الْمَسْأَلَةَ
u'صَدْرٌ مَسْأَلَةٌ':Added, #12: 12	صَدْرِ الْمَسْأَلَةِ
u'صَدْرٌ مَسْجِدٌ':Added, #1: 1	صَدْرَ الْمَسْأَلَةِ
u'صَدْرٌ مُقَدِّمٌ':Added, #1: 1	صَدْرِ الْمَسْجِدِ
u'صَدْرٌ مُقَدِّمَةٌ':Added, #1: 1	صَدْرِ مُقَدِّمَاتِهِ
u'صَدْرٌ مَقُولٌ':Added, #1: 1	صَدْرِ مُقَدِّمَاتِهِ
u'صَدْرٌ مَلِكٌ':Added, #3: 3	صَدْرِ الْمَقُولَةِ
u'صَدْرٌ مُؤْمِنٌ':Added, #1: 1	صَدْرِ الْمَلِكِ
u'صَدَرَ نَاسٌ':Subject, #2: 2	صَدْرِ مُؤْمِنٍ
u'صَدْرٌ نَبِيٌّ':Added, #1: 1	صَدَرَ النّاسُ
u'صَدَرَ نذر':Subject, #1: 1	صَدْرُ النَّبِيِّ
u'صَدَرَ نَذْرٌ':Subject, #2: 2	صَدَرَ النَّذْرُ
u'صَدْرٌ نسخة':Added, #2: 2	صَدَرَ النَّذْرُ
u'صَدْرٌ نُسْخَةٌ':Added, #1: 1	صَدْرِ النُّسْخَةِ
u'صَدْرٌ نهار':Added, #1: 1	صَدْرِ النُّسْخَةِ
u'صَدْرٌ نَهَارٌ':Added, #1: 1	صَدْرَ النَّهَارِ
u'صَدْرٌ نهار':Added, #1: 1	صَدْرَ النَّهَارِ
u'صَدْرٌ نَهَارٌ':Added, #1: 1	صَدْرِ نَهَارِ
u'صَدْرٌ نهار':Added, #1: 1	صَدْرِ نَهَارِ
u'صَدْرٌ نَهَارٌ':Added, #3: 3	صَدْرِ النَّهَارِ
u'صَدْرٌ واحد':Added, #3: 3	صَدْرِ النَّهَارِ
u'صَدْرٌ وَاحِدٌ':Added, #1: 1	صَدْرُ وَاحِدٍ
u'صَدْرٌ واحد':Added, #1: 1	صَدْرُ وَاحِدٍ
u'صَدْرٌ وَاحِدٌ':Added, #2: 2	صَدْرِ وَاحِدٍ
u'صَدَرَ وَقْفٌ':Subject, #2: 2	صَدْرِ وَاحِدٍ
u'صَدَرَ وَلَهٌ':Subject, #1: 1	صَدَرَ الْوَقْفُ
u'صدق أَبٌ':Added, #1: 1	صَدَرَ وَلَهُ
u'صِدْقٌ أَبٌ':Added, #1: 1	صِدْقِ الْأَبِ
u'صَدَقَ اِبْنٌ':Subject, #1: 1	صِدْقِ الْأَبِ
u'صَدَقَ اِسْمٌ':Subject, #2: 2	صَدَقَ ابْنُ
u'صدق اِسْمٌ':Added, #2: 2	صَدَقَ اسْمُ
u'صِدْقٌ اِسْمٌ':Added, #3: 3	صِدْقِ اسْمِ
u'صدق إِطْلاقٌ':Added, #3: 3	صِدْقِ اسْمِ
u'صِدْقٌ إِطْلاقٌ':Added, #1: 1	صِدْقِ إطْلَاقِ
u'صدق إقْرَارٌ':Added, #1: 1	صِدْقِ إطْلَاقِ
u'صِدْقٌ إقْرَارٌ':Added, #1: 1	صِدْقِ الْإِقْرَارِ
u'صَدَّقَ المُشْتَرِي':Predicate, #1: 1	صِدْقِ الْإِقْرَارِ
u'صدق إمَارَةٌ':Added, #2: 2	صَدَّقَ الْمُشْتَرِيَ
u'صِدْقٌ إمَارَةٌ':Added, #1: 1	صِدْقِ الْإِمَارَةِ
u'صَدَقَ آمِرٌ':Subject, #1: 1	صِدْقِ الْإِمَارَةِ
u'صَدَقَ أَمْرٌ':Subject, #1: 1	صَدَقَ الْآمِرُ
u'صَدَّقَ آمِرٌ':Subject, #1: 1	صَدَقَ الْأَمْرُ
u'صدق أَمْرٌ':Added, #2: 2	صَدَّقَ الْآمِرُ
u'صِدْقٌ أَمْرٌ':Added, #1: 1	صِدْقِ الْأَمْرِ
u'صدق أنبياء':Added, #1: 1	صِدْقِ الْأَمْرِ
u'صِدْقٌ أنبياء':Added, #1: 1	صِدْقِ الْأَنْبِيَاءِ
u'صَدَقَ أهْلٌ':Subject, #1: 1	صِدْقِ الْأَنْبِيَاءِ
u'صَدَّقَ أَوَّلُ':Predicate, #1: 1	صَدَقَ أَهْلُ
u'صَدَقَ أَوَّلُ':Subject, #4: 4	صَدَّقَ الْأَوَّلَ
u'صَدَّقَ أيتام':Subject, #1: 1	صَدَقَ الْأَوَّلُ
u'صَدَقَ بَائِعٌ':Subject, #2: 2	صَدَّقَ الْأَيْتَامُ
u'صَدَّقَ بَائِعٌ':Subject, #3: 3	صَدَقَ الْبَائِعُ
u'صَدَّقَ بَرِيءٌ':Predicate, #4: 4	صَدَّقَ الْبَائِعُ
u'صَدَّقَ بَعْضٌ':Predicate, #1: 1	صَدَّقَ بَرِيءَ
u'صَدَّقَ بَعْضٌ':Subject, #1: 1	صَدَّقَ الْبَعْضَ
u'صدق بَيِّنَةٌ':Added, #1: 1	صَدَّقَ بَعْضُ
u'صدق بَيِّنَةٌ':Added, #1: 1	صِدْقُ الْبَيِّنَةِ
u'صِدْقٌ بَيِّنَةٌ':Added, #1: 1	صِدْقِ الْبَيِّنَةِ
u'صِدْقٌ بَيِّنَةٌ':Added, #1: 1	صِدْقُ الْبَيِّنَةِ
u'صدق بَيِّنَةٌ':Added, #1: 1	صِدْقِ الْبَيِّنَةِ
u'صِدْقٌ بَيِّنَةٌ':Added, #1: 1	صِدْقِ بَيِّنَةِ
u'صدق تَأَمُّلٌ':Added, #1: 1	صِدْقِ بَيِّنَةِ
u'صِدْقٌ تَأَمُّلٌ':Added, #1: 1	صِدْقِ التَّأَمُّلِ
u'صدق تَشْبِيه':Added, #1: 1	صِدْقِ التَّأَمُّلِ
u'صِدْقٌ تَشْبِيه':Added, #1: 1	صِدْقُ التَّشْبِيهِ
u'صَدَقَ تَعْرِيفٌ':Subject, #1: 1	صِدْقُ التَّشْبِيهِ
u'صدق تَعْرِيفٌ':Added, #1: 1	صَدَقَ التَّعْرِيفُ
u'صِدْقٌ تَعْرِيفٌ':Added, #1: 1	صِدْقِ تَعْرِيفِ
u'صدق تَعْرِيفٌ':Added, #1: 1	صِدْقِ تَعْرِيفِ
u'صِدْقٌ تَعْرِيفٌ':Added, #2: 2	صِدْقَ التَّعْرِيفِ
u'صدق تَعْرِيفٌ':Added, #2: 2	صِدْقَ التَّعْرِيفِ
u'صِدْقٌ تَعْرِيفٌ':Added, #4: 4	صِدْقِ التَّعْرِيفِ
u'صدق تَماسٌّ':Added, #4: 4	صِدْقِ التَّعْرِيفِ
u'صِدْقٌ تَماسٌّ':Added, #1: 1	صِدْقُ التَّمَاسِّ
u'صَدَّقَ ثَانِي':Predicate, #1: 1	صِدْقُ التَّمَاسِّ
u'صدق ثِقَةٌ':Added, #2: 2	صَدَّقَ الثَّانِيَ
u'صِدْقٌ ثِقَةٌ':Added, #1: 1	صِدْقَ ثِقَةٍ
u'صَدَقَ جَابِرٌ':Subject, #1: 1	صِدْقَ ثِقَةٍ
u'صَدَقَ جُزْءٌ':Subject, #1: 1	صَدَقَ جَابِرٌ
u'صَدَّقَ جَمِيع':Predicate, #1: 1	صَدَقَ جُزْءُ
u'صدق حاجَةٌ':Added, #2: 2	صَدَّقَ الْجَمِيعَ
u'صِدْقٌ حاجَةٌ':Added, #1: 1	صِدْقِ الْحَاجَةِ
u'صدق حاجَةٌ':Added, #1: 1	صِدْقِ الْحَاجَةِ
u'صِدْقٌ حاجَةٌ':Added, #1: 1	صِدْقِ حَاجَتِهِ
u'صَدَّقَ حاضِرٌ':Predicate, #1: 1	صِدْقِ حَاجَتِهِ
u'صَدَّقَ حاضِرٌ':Subject, #1: 1	صَدَّقَ الْحَاضِرَ
u'صَدَقَ حائِزٌ':Subject, #1: 1	صَدَّقَ الْحَاضِرُ
u'صَدَقَ حَدٌّ':Subject, #1: 1	صَدَقَ حَائِزُهُ
u'صدق حَدٌّ':Added, #1: 1	صَدَقَ الْحَدُّ
u'صِدْقٌ حَدٌّ':Added, #1: 1	صِدْقَ الْحَدِّ
u'صدق حَدٌّ':Added, #1: 1	صِدْقَ الْحَدِّ
u'صِدْقٌ حَدٌّ':Added, #1: 1	صِدْقِ حَدِّهِ
u'صدق حَدٌّ':Added, #1: 1	صِدْقِ حَدِّهِ
u'صِدْقٌ حَدٌّ':Added, #3: 3	صِدْقِ الْحَدِّ
u'صدق حَدَثٌ':Added, #3: 3	صِدْقِ الْحَدِّ
u'صِدْقٌ حَدَثٌ':Added, #1: 1	صِدْقِ الْحَدَثِ
u'صَدَقَ حَديثٌ':Predicate, #1: 1	صِدْقِ الْحَدَثِ
u'صدق حَديثٌ':Added, #1: 1	صَدَقَ الْحَدِيثَ
u'صدق حَديثٌ':Added, #1: 1	صِدْقَ الْحَدِيثِ
u'صِدْقٌ حَديثٌ':Added, #1: 1	صِدْقُ الْحَدِيثِ
u'صِدْقٌ حَديثٌ':Added, #1: 1	صِدْقَ الْحَدِيثِ
u'صدق حَديثٌ':Added, #1: 1	صِدْقُ الْحَدِيثِ
u'صِدْقٌ حَديثٌ':Added, #1: 1	صِدْقِ حَدِيثِهِ
u'صدق حَديثٌ':Added, #1: 1	صِدْقِ حَدِيثِهِ
u'صِدْقٌ حَديثٌ':Added, #2: 2	صِدْقِ الْحَدِيثِ
u'صَدَقَ حَرِيصٌ':Subject, #2: 2	صِدْقِ الْحَدِيثِ
u'صدق حَمْدٌ':Added, #1: 1	صَدَقَ الْحَرِيصُ
u'صِدْقٌ حَمْدٌ':Added, #1: 1	صِدْقِ الْحَمْدِ
u'صدق خاصّ':Added, #1: 1	صِدْقِ الْحَمْدِ
u'صِدْقٌ خاصّ':Added, #1: 1	صِدْقَ الْخَاصِّ
u'صدق خَبَرٌ':Added, #1: 1	صِدْقَ الْخَاصِّ
u'صدق خَبَر':Added, #14: 14	صِدْقُ الْخَبَرِ
u'صِدْقٌ خَبَرٌ':Added, #14: 14	صِدْقُ الْخَبَرِ
u'صِدْقٌ خَبَر':Added, #14: 14	صِدْقُ الْخَبَرِ
u'صدق خَبَرٌ':Added, #14: 14	صِدْقُ الْخَبَرِ
u'صدق خَبَر':Added, #1: 1	صِدْقِ خَبَرِهِ
u'صِدْقٌ خَبَرٌ':Added, #1: 1	صِدْقِ خَبَرِهِ
u'صِدْقٌ خَبَر':Added, #1: 1	صِدْقِ خَبَرِهِ
u'صدق خَبَرٌ':Added, #1: 1	صِدْقِ خَبَرِهِ
u'صدق خَبَرٌ':Added, #3: 3	صِدْقَ الْخَبَرِ
u'صدق خَبَر':Added, #3: 3	صِدْقِ الْخَبَرِ
u'صدق خَبَر':Added, #3: 3	صِدْقَ الْخَبَرِ
u'صِدْقٌ خَبَرٌ':Added, #3: 3	صِدْقِ الْخَبَرِ
u'صِدْقٌ خَبَرٌ':Added, #3: 3	صِدْقَ الْخَبَرِ
u'صِدْقٌ خَبَر':Added, #3: 3	صِدْقِ الْخَبَرِ
u'صِدْقٌ خَبَر':Added, #3: 3	صِدْقَ الْخَبَرِ
u'صَدَقَ خِتَامٌ':Subject, #3: 3	صِدْقِ الْخَبَرِ
u'صَدَّقَ دَافِعٌ':Subject, #1: 1	صَدَقَ خِتَامُ
u'صَدَقَ دَافِعٌ':Subject, #1: 1	صَدَّقَ الدَّافِعُ
u'صَدَّقَ رَاجِعٌ':Predicate, #2: 2	صَدَقَ الدَّافِعُ
u'صَدَقَ رَاهِنٌ':Subject, #1: 1	صَدَّقَ الرَّاجِعِينَ
u'صَدَقَ رَجُلٌ':Subject, #2: 2	صَدَقَ الرَّاهِنُ
u'صَدَقَ رَجُلٌ':Subject, #1: 1	صَدَقَ رَجُلٌ
u'صَدَّقَ رَجُلٌ':Subject, #2: 2	صَدَقَ الرَّجُلُ
u'صدق رُسُلٌ':Added, #2: 2	صَدَّقَ الرَّجُلُ
u'صِدْقٌ رُسُلٌ':Added, #1: 1	صِدْقِ الرُّسُلِ
u'صَدَّقَ رَسُولٌ':Predicate, #1: 1	صِدْقِ الرُّسُلِ
u'صَدَّقَ رَسُولٌ':Predicate, #1: 1	صَدَّقَ الرَّسُولَ
u'صَدَّقَ رَسُولٌ':Subject, #1: 1	صَدَّقَ رَسُولَ
u'صَدَقَ رَسُولٌ':Subject, #1: 1	صَدَّقَ الرَّسُولُ
u'صدق رَسُولٌ':Added, #6: 6	صَدَقَ رَسُولُ
u'صدق رَسُولٌ':Added, #1: 1	صِدْقُ الرَّسُولِ
u'صِدْقٌ رَسُولٌ':Added, #1: 1	صِدْقِ الرّسُولِ
u'صِدْقٌ رَسُولٌ':Added, #1: 1	صِدْقُ الرَّسُولِ
u'صدق رَسُولٌ':Added, #1: 1	صِدْقِ الرّسُولِ
u'صِدْقٌ رَسُولٌ':Added, #1: 1	صِدْقِ رَسُولِهِ
u'صدق رَسُولٌ':Added, #1: 1	صِدْقِ رَسُولِهِ
u'صِدْقٌ رَسُولٌ':Added, #6: 6	صِدْقِ الرَّسُولِ
u'صدق رَغْبَةٌ':Added, #6: 6	صِدْقِ الرَّسُولِ
u'صِدْقٌ رَغْبَةٌ':Added, #1: 1	صِدْقَ رَغْبَةِ
u'صدق رَغْبَةٌ':Added, #1: 1	صِدْقَ رَغْبَةِ
u'صِدْقٌ رَغْبَةٌ':Added, #2: 2	صِدْقُ الرَّغْبَةِ
u'صدق رَغْبَةٌ':Added, #2: 2	صِدْقُ الرَّغْبَةِ
u'صِدْقٌ رَغْبَةٌ':Added, #2: 2	صِدْقُ رَغْبَةِ
u'صدق رُؤْيَةٌ':Added, #2: 2	صِدْقُ رَغْبَةِ
u'صِدْقٌ رُؤْيَةٌ':Added, #1: 1	صِدْقُ رُؤْيَتِهِ
u'صَدَّقَ زَوْجٌ':Predicate, #1: 1	صِدْقُ رُؤْيَتِهِ
u'صدق زَوْجٌ':Added, #1: 1	صَدَّقَ الزَّوْجَ
u'صِدْقٌ زَوْجٌ':Added, #1: 1	صِدْقَ الزَّوْجِ
u'صدق زَوْجٌ':Added, #1: 1	صِدْقَ الزَّوْجِ
u'صِدْقٌ زَوْجٌ':Added, #1: 1	صِدْقِ الزَّوْجَيْنِ
u'صدق سَالِبٌ':Added, #1: 1	صِدْقِ الزَّوْجَيْنِ
u'صِدْقٌ سَالِبٌ':Added, #1: 1	صِدْقَ السَّالِبَةِ
u'صَدَقَ سمرة':Subject, #1: 1	صِدْقَ السَّالِبَةِ
u'صَدَقَ سَيِّدٌ':Subject, #1: 1	صَدَقَ سَمُرَةُ
u'صَدَّقَ شَاهِدٌ':Predicate, #1: 1	صَدَقَ السَّيِّدُ
u'صدق شَاهِدٌ':Added, #1: 1	صَدَّقَ الشَّاهِدَ
u'صدق شَاهِدٌ':Added, #1: 1	صِدْقَ الشَّاهِدِ
u'صِدْقٌ شَاهِدٌ':Added, #1: 1	صِدْقُ الشَّاهِدِ
u'صِدْقٌ شَاهِدٌ':Added, #1: 1	صِدْقَ الشَّاهِدِ
u'صدق شَاهِدٌ':Added, #1: 1	صِدْقُ الشَّاهِدِ
u'صِدْقٌ شَاهِدٌ':Added, #4: 4	صِدْقِ الشَّاهِدِ
u'صَدَّقَ شَرِيكٌ':Subject, #4: 4	صِدْقِ الشَّاهِدِ
u'صَدَقَ شُهُودٌ':Subject, #1: 1	صَدَّقَ الشَّرِيكُ
u'صدق شُهُودٌ':Added, #2: 2	صَدَقَ الشُّهُودُ
u'صِدْقٌ شُهُودٌ':Added, #1: 1	صِدْقِ الشُّهُودِ
u'صدق شُهُودٌ':Added, #1: 1	صِدْقِ الشُّهُودِ
u'صِدْقٌ شُهُودٌ':Added, #1: 1	صِدْقِ شُهُودِهِ
u'صَدَقَ شَيْخٌ':Subject, #1: 1	صِدْقِ شُهُودِهِ
u'صَدَقَ صَاحِبٌ':Subject, #1: 1	صَدَقَ الشَّيْخُ
u'صدق ضَارِبٌ':Added, #1: 1	صَدَقَ صَاحِبُ
u'صِدْقٌ ضَارِبٌ':Added, #1: 1	صِدْقِ الضَّارِبِ
u'صَدَقَ ضَرَرٌ':Subject, #1: 1	صِدْقِ الضَّارِبِ
u'صَدَقَ طَارِئٌ':Subject, #1: 1	صَدَقَ الضَّرَرُ
u'صدق طَالِبٌ':Added, #1: 1	صَدَقَ الطَّارِئُ
u'صِدْقٌ طَالِبٌ':Added, #1: 1	صِدْقُ الطَّالِبِ
u'صَدَقَ طَلاَقٌ':Subject, #1: 1	صِدْقُ الطَّالِبِ
u'صدق ظَنٌّ':Added, #1: 1	صَدَقَ الطَّلَاقُ
u'صِدْقٌ ظَنٌّ':Added, #1: 1	صِدْقَ الظَّنِّ
u'صدق ظَنٌّ':Added, #1: 1	صِدْقَ الظَّنِّ
u'صدق ظَنٌّ':Added, #1: 1	صِدْقَ ظَنِّهِ
u'صِدْقٌ ظَنٌّ':Added, #1: 1	صِدْقِ ظَنِّهِ
u'صِدْقٌ ظَنٌّ':Added, #1: 1	صِدْقَ ظَنِّهِ
u'صدق عَامٌّ':Added, #1: 1	صِدْقِ ظَنِّهِ
u'صِدْقٌ عَامٌّ':Added, #2: 2	صِدْقَ الْعَامِّ
u'صَدَقَ عَائِدٌ':Subject, #2: 2	صِدْقَ الْعَامِّ
u'صَدَّقَ عَبْدٌ':Predicate, #1: 1	صَدَقَ عَائِدٌ
u'صَدَقَ عَبْدٌ':Subject, #2: 2	صَدَّقَ الْعَبْدَ
u'صَدَقَ عَبْدٌ':Subject, #1: 1	صَدَقَ عَبْدُ
u'صَدَّقَ عَبْدٌ':Subject, #2: 2	صَدَقَ الْعَبْدُ
u'صَدَّقَ عَتِيقٌ':Subject, #2: 2	صَدَّقَ الْعَبْدُ
u'صدق عَدَالَةٌ':Added, #1: 1	صَدَّقَ الْعَتِيقُ
u'صِدْقٌ عَدَالَةٌ':Added, #1: 1	صِدْقِ الْعَدَالَةِ
u'صَدَقَ عُرْوَةٌ':Subject, #1: 1	صِدْقِ الْعَدَالَةِ
u'صدق عَزِيمَةٌ':Added, #1: 1	صَدَقَ عُرْوَةُ
u'صدق عَزِيمَةٌ':Added, #1: 1	صِدْقَ الْعَزِيمَةِ
u'صِدْقٌ عَزِيمَةٌ':Added, #1: 1	صِدْقِ الْعَزِيمَةِ
u'صِدْقٌ عَزِيمَةٌ':Added, #1: 1	صِدْقَ الْعَزِيمَةِ
u'صَدَقَ عِلَّةٌ':Subject, #1: 1	صِدْقِ الْعَزِيمَةِ
u'صدق عِلَّةٌ':Added, #3: 3	صَدَقَ الْعِلَّةُ
u'صِدْقٌ عِلَّةٌ':Added, #1: 1	صِدْقِ الْعِلَّةِ
u'صَدَّقَ عَلِيٌّ':Subject, #1: 1	صِدْقِ الْعِلَّةِ
u'صَدَقَ عُمَرٌ':Subject, #1: 1	صَدَّقَ عَلِيُّ
u'صدق عُمُومٌ':Added, #2: 2	صَدَقَ عُمَرُ
u'صِدْقٌ عُمُومٌ':Added, #1: 1	صِدْقَ عُمُومِ
u'صَدَّقَ غَائِبٌ':Subject, #1: 1	صِدْقَ عُمُومِ
u'صَدَّقَ غرماء':Subject, #1: 1	صَدَّقَ الْغَائِبُ
u'صَدَّقَ غَرِيمٌ':Predicate, #1: 1	صَدَّقَ الْغُرَمَاءُ
u'صَدَّقَ غَرِيمٌ':Subject, #1: 1	صَدَّقَ الْغَرِيمَ
u'صَدَقَ غُلاَمٌ':Subject, #1: 1	صَدَّقَ الْغَرِيمُ
u'صَدَقَ فَأْلٌ':Subject, #1: 1	صَدَقَ الْغُلَامُ
u'صَدَقَ فَالَ':Subject, #1: 1	صَدَقَ الْفَأْلُ
u'صَدَقَ فرق':Subject, #1: 1	صَدَقَ الْفَالُ
u'صَدَقَ فَرْقٌ':Subject, #1: 1	صَدَقَ الْفَرْقُ
u'صدق فَرِيقٌ':Added, #1: 1	صَدَقَ الْفَرْقُ
u'صِدْقٌ فَرِيقٌ':Added, #1: 1	صِدْقِ الْفَرِيقَيْنِ
u'صَدَقَ فَقْدٌ':Subject, #1: 1	صِدْقِ الْفَرِيقَيْنِ
u'صَدَقَ فلان':Subject, #1: 1	صَدَقَ فَقْدُ
u'صَدَقَ فلان':Subject, #1: 1	صَدَقَ الْبَيْهَقِيُّ
u'صَدَّقَ قَاذِفٌ':Subject, #2: 2	صَدَقَ سُفْيَانُ
u'صدق قَاذِفٌ':Added, #1: 1	صَدَّقَ الْقَاذِفُ
u'صِدْقٌ قَاذِفٌ':Added, #1: 1	صِدْقِ الْقَاذِفِ
u'صَدَّقَ قَاضِي':Predicate, #1: 1	صِدْقِ الْقَاذِفِ
u'صدق قَضِيَّةٌ':Added, #1: 1	صَدَّقَ الْقَاضِيَ
u'صِدْقٌ قَضِيَّةٌ':Added, #2: 2	صِدْقِ الْقَضِيَّةِ
u'صَدَقَ قلب':Subject, #2: 2	صِدْقِ الْقَضِيَّةِ
u'صَدَقَ قَلْبٌ':Subject, #1: 1	صَدَقَ قَلْبُهُ
u'صَدَقَ قَلْب':Subject, #1: 1	صَدَقَ قَلْبُهُ
u'صَدَقَ قَلَمٌ':Subject, #1: 1	صَدَقَ قَلْبُهُ
u'صَدَقَ قول':Subject, #1: 1	صَدَقَ الْقَلَمُ
u'صَدَقَ قَوْلٌ':Subject, #1: 1	صَدَقَ قَوْلُ
u'صدق قول':Added, #1: 1	صَدَقَ قَوْلُ
u'صدق قول':Added, #1: 1	صِدْقَ الْقَوْلِ
u'صِدْقٌ قول':Added, #1: 1	صِدْقِ الْقَوْلِ
u'صِدْقٌ قول':Added, #1: 1	صِدْقَ الْقَوْلِ
u'صدق قَوْلٌ':Added, #1: 1	صِدْقِ الْقَوْلِ
u'صدق قَوْلٌ':Added, #1: 1	صِدْقَ الْقَوْلِ
u'صِدْقٌ قَوْلٌ':Added, #1: 1	صِدْقِ الْقَوْلِ
u'صِدْقٌ قَوْلٌ':Added, #1: 1	صِدْقَ الْقَوْلِ
u'صدق قول':Added, #1: 1	صِدْقِ الْقَوْلِ
u'صِدْقٌ قول':Added, #1: 1	صِدْقِ قَوْلِ
u'صدق قَوْلٌ':Added, #1: 1	صِدْقِ قَوْلِ
u'صِدْقٌ قَوْلٌ':Added, #1: 1	صِدْقِ قَوْلِ
u'صدق قول':Added, #1: 1	صِدْقِ قَوْلِ
u'صِدْقٌ قول':Added, #1: 1	صِدْقِ قَوْلِهِ
u'صدق قَوْلٌ':Added, #1: 1	صِدْقِ قَوْلِهِ
u'صِدْقٌ قَوْلٌ':Added, #1: 1	صِدْقِ قَوْلِهِ
u'صَدَقَ قيام':Subject, #1: 1	صِدْقِ قَوْلِهِ
u'صَدَقَ قِيَامٌ':Subject, #1: 1	صَدَقَ الْقِيَامُ
u'صدق كِتَابَةٌ':Added, #1: 1	صَدَقَ الْقِيَامُ
u'صِدْقٌ كِتَابَةٌ':Added, #1: 1	صِدْقِ الْكِتَابَةِ
u'صَدَقَ كَعْبٌ':Subject, #1: 1	صِدْقِ الْكِتَابَةِ
u'صدق كَلاَمٌ':Added, #1: 1	صَدَقَ كَعْبٌ
u'صِدْقٌ كَلاَمٌ':Added, #1: 1	صِدْقِ الْكَلَامِ
u'صدق كَلاَمٌ':Added, #1: 1	صِدْقِ الْكَلَامِ
u'صِدْقٌ كَلاَمٌ':Added, #3: 3	صِدْقُ الْكَلَامِ
u'صدق كَلِمَةٌ':Added, #3: 3	صِدْقُ الْكَلَامِ
u'صِدْقٌ كَلِمَةٌ':Added, #1: 1	صِدْقِ الْكَلِمَةِ
u'صدق كَوْنٌ':Added, #1: 1	صِدْقِ الْكَلِمَةِ
u'صِدْقٌ كَوْنٌ':Added, #1: 1	صِدْقِ كَوْنِ
u'صدق لِسَانٌ':Added, #1: 1	صِدْقِ كَوْنِ
u'صِدْقٌ لِسَانٌ':Added, #1: 1	صِدْقُ اللِّسَانِ
u'صدق لَفْظٌ':Added, #1: 1	صِدْقُ اللِّسَانِ
u'صِدْقٌ لَفْظٌ':Added, #1: 1	صِدْقِ اللَّفْظِ
u'صدق لهجة':Added, #1: 1	صِدْقِ اللَّفْظِ
u'صِدْقٌ لهجة':Added, #1: 1	صِدْقُ اللَّهْجَةِ
u'صدق لَهْجَةٌ':Added, #1: 1	صِدْقُ اللَّهْجَةِ
u'صِدْقٌ لَهْجَةٌ':Added, #1: 1	صِدْقُ اللَّهْجَةِ
u'صَدَقَ مَالِكٌ':Subject, #1: 1	صِدْقُ اللَّهْجَةِ
u'صَدَقَ مَالِكٌ':Subject, #1: 1	صَدَقَ مَالِكُ
u'صَدَقَ مَأْمُورٌ':Subject, #2: 2	صَدَقَ الْمَالِكُ
u'صدق مُتَكَلِّمٌ':Added, #1: 1	صَدَقَ الْمَأْمُورُ
u'صِدْقٌ مُتَكَلِّمٌ':Added, #4: 4	صِدْقِ الْمُتَكَلِّمِ
u'صدق مُتَوَاتِرٌ':Added, #4: 4	صِدْقِ الْمُتَكَلِّمِ
u'صِدْقٌ مُتَوَاتِرٌ':Added, #1: 1	صِدْقَ الْمُتَوَاتِرِ
u'صَدَقَ مُتَوَكِّلٌ':Subject, #1: 1	صِدْقَ الْمُتَوَاتِرِ
u'صدق مَجَازٌ':Added, #1: 1	صَدَقَ الْمُتَوَكِّلُ
u'صِدْقٌ مَجَازٌ':Added, #1: 1	صِدْقِ الْمَجَازِ
u'صَدَّقَ مُجْمِعٌ':Predicate, #1: 1	صِدْقِ الْمَجَازِ
u'صدق مَجْمُوعٌ':Added, #3: 3	صَدَّقَ الْمُجْمِعِينَ
u'صِدْقٌ مَجْمُوعٌ':Added, #1: 1	صِدْقِ الْمَجْمُوعِ
u'صَدَقَ مُحَمَّدٌ':Subject, #1: 1	صِدْقِ الْمَجْمُوعِ
u'صَدَّقَ مُخْبِرٌ':Predicate, #1: 1	صَدَقَ مُحَمَّدٌ
u'صَدَقَ مُخْبِرٌ':Subject, #1: 1	صَدَّقَ الْمُخْبِرَ
u'صدق مُخْبِرٌ':Added, #2: 2	صَدَقَ الْمُخْبِرُ
u'صِدْقٌ مُخْبِرٌ':Added, #1: 1	صِدْقِ الْمُخْبِرِ
u'صدق مُخْبِرٌ':Added, #1: 1	صِدْقِ الْمُخْبِرِ
u'صِدْقٌ مُخْبِرٌ':Added, #2: 2	صِدْقَ الْمُخْبِرِ
u'صدق مُخْبِرٌ':Added, #2: 2	صِدْقَ الْمُخْبِرِ
u'صِدْقٌ مُخْبِرٌ':Added, #5: 5	صِدْقُ الْمُخْبِرِ
u'صَدَّقَ مُدَّعِي':Predicate, #5: 5	صِدْقُ الْمُخْبِرِ
u'صَدَّقَ مُدَّعِي':Predicate, #1: 1	صَدَّقَ الْمُدَّعِيَ
u'صَدَقَ مَدْفُوعٌ':Subject, #1: 1	صَدَّقَ مُدَّعِيَ
u'صَدَقَ مَدْلُولٌ':Subject, #1: 1	صَدَقَ الْمَدْفُوعُ
u'صَدَّقَ مَدْيُونٌ':Predicate, #1: 1	صَدَقَ مَدْلُولُهُ
u'صَدَّقَ مُرْتَهِنٌ':Predicate, #1: 1	صَدَّقَ الْمَدْيُونَ
u'صَدَقَ مُرْتَهِنٌ':Subject, #2: 2	صَدَّقَ الْمُرْتَهِنَ
u'صَدَّقَ مُرْسِلٌ':Predicate, #2: 2	صَدَقَ الْمُرْتَهِنُ
u'صَدَقَ مُسْلِمٌ':Subject, #1: 1	صَدَّقَ الْمُرْسِلَ
u'صَدَّقَ مُشْتَرِي':Predicate, #1: 1	صَدَقَ الْمُسْلِمُ
u'صدق مُشْتَقٌّ':Added, #2: 2	صَدَّقَ الْمُشْتَرِيَ
u'صِدْقٌ مُشْتَقٌّ':Added, #1: 1	صِدْقَ الْمُشْتَقِّ
u'صدق مُشْتَقٌّ':Added, #1: 1	صِدْقَ الْمُشْتَقِّ
u'صدق مُشْتَقٌّ':Added, #4: 4	صِدْقُ الْمُشْتَقِّ
u'صِدْقٌ مُشْتَقٌّ':Added, #4: 4	صِدْقِ الْمُشْتَقِّ
u'صِدْقٌ مُشْتَقٌّ':Added, #4: 4	صِدْقُ الْمُشْتَقِّ
u'صَدَّقَ مُضَارِبٌ':Subject, #4: 4	صِدْقِ الْمُشْتَقِّ
u'صَدَقَ مُطْعِمٌ':Subject, #1: 1	صَدَّقَ الْمُضَارِبُ
u'صدق مَطْلُوبٌ':Added, #1: 1	صَدَقَ الْمُطْعِمُ
u'صِدْقٌ مَطْلُوبٌ':Added, #1: 1	صِدْقُ الْمَطْلُوبِ
u'صدق مُعْتَرِفٌ':Added, #1: 1	صِدْقُ الْمَطْلُوبِ
u'صِدْقٌ مُعْتَرِفٌ':Added, #1: 1	صِدْقِ الْمُعْتَرِفِ
u'صدق مَقَالٌ':Added, #1: 1	صِدْقِ الْمُعْتَرِفِ
u'صِدْقٌ مَقَالٌ':Added, #1: 1	صِدْقِ مَقَالِهِ
u'صدق مَقَالَةٌ':Added, #1: 1	صِدْقِ مَقَالِهِ
u'صِدْقٌ مَقَالَةٌ':Added, #5: 5	صِدْقِ مَقَالَتِهِ
u'صدق مَقُولٌ':Added, #5: 5	صِدْقِ مَقَالَتِهِ
u'صِدْقٌ مَقُولٌ':Added, #1: 1	صِدْقِ الْمَقُولَاتِ
u'صدق مَنْطِقٌ':Added, #1: 1	صِدْقِ الْمَقُولَاتِ
u'صِدْقٌ مَنْطِقٌ':Added, #1: 1	صِدْقِ الْمَنْطِقِ
u'صَدَقَ مُنْكِرٌ':Subject, #1: 1	صِدْقِ الْمَنْطِقِ
u'صدق مَوْعُودٌ':Added, #1: 1	صَدَقَ الْمُنْكِرُ
u'صِدْقٌ مَوْعُودٌ':Added, #1: 1	صِدْقَ مَوْعُودِهِ
u'صَدَّقَ مُوَكِّلٌ':Subject, #1: 1	صِدْقَ مَوْعُودِهِ
u'صَدَقَ نَبِيٌّ':Subject, #1: 1	صَدَّقَ الْمُوَكِّلُ
u'صَدَّقَ نَبِيٌّ':Subject, #1: 1	صَدَقَ النَّبِيُّ
u'صَدَقَ نَبِيٌّ':Subject, #1: 1	صَدَّقَ النَّبِيُّ
u'صدق نَبِيٌّ':Added, #1: 1	صَدَقَ نَبِيُّ
u'صِدْقٌ نَبِيٌّ':Added, #1: 1	صِدْقِ النَّبِيِّ
u'صدق نَبِيٌّ':Added, #1: 1	صِدْقِ النَّبِيِّ
u'صِدْقٌ نَبِيٌّ':Added, #2: 2	صِدْقُ النَّبِيِّ
u'صدق نَفْسٌ':Added, #2: 2	صِدْقُ النَّبِيِّ
u'صدق نَفْسٌ':Added, #1: 1	صِدْقَ النَّفْسِ
u'صِدْقٌ نَفْسٌ':Added, #1: 1	صِدْقِ النَّفْسِ
u'صِدْقٌ نَفْسٌ':Added, #1: 1	صِدْقَ النَّفْسِ
u'صدق نَفْسٌ':Added, #1: 1	صِدْقِ النَّفْسِ
u'صِدْقٌ نَفْسٌ':Added, #5: 5	صِدْقَ نَفْسِهِ
u'صَدَقَ نَفْيٌ':Subject, #5: 5	صِدْقَ نَفْسِهِ
u'صَدَقَ نَوْءٌ':Subject, #1: 1	صَدَقَ النَّفْيُ
u'صدق نِيَّةٌ':Added, #1: 1	صَدَقَ نَوْءُ
u'صِدْقٌ نِيَّةٌ':Added, #1: 1	صِدْقُ النِّيَّةِ
u'صدق هُدْهُدٌ':Added, #1: 1	صِدْقُ النِّيَّةِ
u'صِدْقٌ هُدْهُدٌ':Added, #1: 1	صِدْقَ الْهُدْهُدِ
u'صَدَّقَ واحد':Predicate, #1: 1	صِدْقَ الْهُدْهُدِ
u'صَدَّقَ وَاحِدٌ':Predicate, #11: 11	صَدَّقَ وَاحِدَةً
u'صدق واحد':Added, #11: 11	صَدَّقَ وَاحِدَةً
u'صِدْقٌ واحد':Added, #1: 1	صِدْقُ الْوَاحِدِ
u'صدق وَاحِدٌ':Added, #1: 1	صِدْقُ الْوَاحِدِ
u'صِدْقٌ وَاحِدٌ':Added, #1: 1	صِدْقُ الْوَاحِدِ
u'صَدَّقَ وَارِثٌ':Subject, #1: 1	صِدْقُ الْوَاحِدِ
u'صَدَقَ وَجَبٌ':Predicate, #2: 2	صَدَّقَ الْوَارِثُ
u'صَدَّقَ وَرَثَةٌ':Subject, #1: 1	صَدَقَ وَجَبَ
u'صدق وَصْفٌ':Added, #1: 1	صَدَّقَ وَرَثَةُ
u'صِدْقٌ وَصْفٌ':Added, #1: 1	صِدْقِ الْوَصْفِ
u'صَدَقَ وَعْدٌ':Subject, #1: 1	صِدْقِ الْوَصْفِ
u'صدق وَعْدٌ':Added, #1: 1	صَدَقَ وَعْدُهُ
u'صِدْقٌ وَعْدٌ':Added, #1: 1	صِدْقِ الْوَعْدِ
u'صدق وَعْدٌ':Added, #1: 1	صِدْقِ الْوَعْدِ
u'صدق وَعْدٌ':Added, #1: 1	صِدْقَ وَعْدِهِ
u'صِدْقٌ وَعْدٌ':Added, #1: 1	صِدْقِ وَعْدِهِ
u'صِدْقٌ وَعْدٌ':Added, #1: 1	صِدْقَ وَعْدِهِ
u'صَدَقَ وَكْز':Subject, #1: 1	صِدْقِ وَعْدِهِ
u'صَدَّقَ وَكِيلٌ':Predicate, #1: 1	صَدَقَ الْوَكْزُ
u'صَدَقَ وَكِيلٌ':Subject, #1: 1	صَدَّقَ الْوَكِيلَ
u'صَدَّقَ وَكِيلٌ':Subject, #1: 1	صَدَقَ الْوَكِيلُ
u'صَدَّقَ وَلِيٌّ':Subject, #1: 1	صَدَّقَ الْوَكِيلُ
u'صدق وَلِيٌّ':Added, #2: 2	صَدَّقَ الْوَلِيُّ
u'صِدْقٌ وَلِيٌّ':Added, #1: 1	صِدْقَ وَلِيِّ
u'صدق يهود':Added, #1: 1	صِدْقَ وَلِيِّ
u'صدق يَهُودٌ':Added, #1: 1	صِدْقِ الْيَهُودِ
u'صِدْقٌ يهود':Added, #1: 1	صِدْقِ الْيَهُودِ
u'صِدْقٌ يَهُودٌ':Added, #1: 1	صِدْقِ الْيَهُودِ
u'صدق يَهُودِيٌّ':Added, #1: 1	صِدْقِ الْيَهُودِ
u'صِدْقٌ يَهُودِيٌّ':Added, #1: 1	صِدْقَ الْيَهُودِيِّ
u'صدق يَوْمٌ':Added, #1: 1	صِدْقَ الْيَهُودِيِّ
u'صِدْقٌ يَوْمٌ':Added, #1: 1	صِدْقِ الْيَوْمِ
u'صَدْمَةٌ بِئْرٌ':Added, #1: 1	صِدْقِ الْيَوْمِ
u'صَدْمَةٌ صَاحِبٌ':Added, #3: 3	صَدْمَةِ الْبِئْرِ
u'صَدْمٌ جَبَلٌ':Added, #1: 1	صَدْمَةِ صَاحِبِهِ
u'صَدْمٌ شَيْءٌ':Added, #1: 1	صَدْمِ جَبَلٍ
u'صَدْمٌ صَغِيرٌ':Added, #1: 1	صَدْمِ شَيْءٍ
u'صَدْمٌ طَائِرٌ':Added, #1: 1	صَدْمِ الصَّغِيرِ
u'صَدْمٌ مَضْرُوبٌ':Added, #1: 1	صَدْمِ الطَّائِرِ
u'صَدْمٌ مَضْرُوبٌ':Added, #1: 1	صَدْمَ الْمَضْرُوبِ
u'صُدُورٌ إجَارَةٌ':Added, #1: 1	صَدْمُ الْمَضْرُوبِ
u'صُدُورٌ إجَازَةٌ':Added, #1: 1	صُدُورِ الْإِجَارَةِ
u'صُدُورٌ أخْبَارٌ':Added, #1: 1	صُدُورِ الْإِجَازَةِ
u'صُدُورٌ أَخْبَارٌ':Added, #1: 1	صُدُورِ الْأَخْبَارِ
u'صُدُورٌ إِخْوَانٌ':Added, #1: 1	صُدُورِ الْأَخْبَارِ
u'صُدُورٌ أَعْدَاءٌ':Added, #1: 1	صُدُورَ الْإِخْوَانِ
u'صُدُورٌ أَقْوَالٌ':Added, #2: 2	صُدُورِ الْأَعْدَاءِ
u'صُدُورٌ اِنْتِقالٌ':Added, #1: 1	صُدُورَ الْأَقْوَالِ
u'صُدُورٌ أهْلٌ':Added, #1: 1	صُدُورَ انْتِقَالِ
u'صُدُورٌ أَوْلِيَاءُ':Added, #1: 1	صُدُورُ أَهْلِ
u'صُدُورٌ إيقَاعٌ':Added, #1: 1	صُدُورِ الْأَوْلِيَاءِ
u'صُدُورٌ بَيْعٌ':Added, #1: 1	صُدُورِ الْإِيقَاعِ
u'صُدُورٌ بَيْعٌ':Added, #1: 1	صُدُورَ الْبَيْعِ
u'صُدُورٌ بَيْعٌ':Added, #2: 2	صُدُورُ الْبَيْعِ
u'صُدُورٌ تَصَرُّفٌ':Added, #2: 2	صُدُورِ الْبَيْعِ
u'صُدُورٌ حُجَجٌ':Added, #1: 1	صُدُورَ التَّصَرُّفِ
u'صُدُورٌ ذَنْبٌ':Added, #1: 1	صُدُورِ الْحُجَجِ
u'صُدُورٌ ذَنْبٌ':Added, #1: 1	صُدُورَ الذَّنْبِ
u'صُدُورٌ رِجَالٌ':Added, #1: 1	صُدُورِ الذَّنْبِ
u'صُدُورٌ رُكْنٌ':Added, #10: 10	صُدُورِ الرِّجَالِ
u'صُدُورٌ رُكْن':Added, #1: 1	صُدُورُ الرُّكْنِ
u'صُدُورٌ رماح':Added, #1: 1	صُدُورُ الرُّكْنِ
u'صُدُورٌ رِماحٌ':Added, #1: 1	صُدُورُ الرّمَاحِ
u'صُدُورٌ رماح':Added, #1: 1	صُدُورُ الرّمَاحِ
u'صُدُورٌ رِماحٌ':Added, #2: 2	صُدُورُ رِمَاحٍ
u'صُدُورٌ رُوَاةٌ':Added, #2: 2	صُدُورُ رِمَاحٍ
u'صُدُورٌ رواحل':Added, #1: 1	صُدُورِ الرُّوَاةِ
u'صُدُورٌ رَوَاحِلُ':Added, #1: 1	صُدُورَ الرّوَاحِلِ
u'صُدُورٌ سَبَبٌ':Added, #1: 1	صُدُورَ الرّوَاحِلِ
u'صُدُورٌ سِجِلٌّ':Added, #2: 2	صُدُورُ السَّبَبِ
u'صُدُورٌ صِيَغٌ':Added, #1: 1	صُدُورِ السِّجِلَّاتِ
u'صُدُورٌ صِيغَةٌ':Added, #1: 1	صُدُورِ صِيَغِ
u'صُدُورٌ ضَرْبٌ':Added, #1: 1	صُدُورِ صِيغَةِ
u'صُدُورٌ عَقْدٌ':Added, #1: 1	صُدُورِ الضَّرْبِ
u'صُدُورٌ عَقْدٌ':Added, #1: 1	صُدُورِ الْعَقْدِ
u'صُدُورٌ فِعْلٌ':Added, #1: 1	صُدُورِ عَقْدِ
u'صُدُورٌ قَدَمٌ':Added, #1: 1	صُدُورُ الْفِعْلِ
u'صُدُورٌ قسمة':Added, #1: 1	صُدُورِ الْقَدَمَيْنِ
u'صُدُورٌ قِسْمَةٌ':Added, #1: 1	صُدُورُ الْقِسْمَةِ
u'صُدُورٌ قَوْلٌ':Added, #1: 1	صُدُورُ الْقِسْمَةِ
u'صُدُورٌ قَوْمٌ':Added, #1: 1	صُدُورِ قَوْلَيْنِ
u'صُدُورٌ قيام':Added, #6: 6	صُدُورَ قَوْمٍ
u'صُدُورٌ قِيَامٌ':Added, #1: 1	صُدُورُ الْقِيَامِ
u'صُدُورٌ كذب':Added, #1: 1	صُدُورُ الْقِيَامِ
u'صُدُورٌ كَذِبٌ':Added, #1: 1	صُدُورَ الْكَذِبِ
u'صُدُورٌ كَلاَمٌ':Added, #1: 1	صُدُورَ الْكَذِبِ
u'صُدُورٌ كَلاَمٌ':Added, #1: 1	صُدُورَ الْكَلَامِ
u'صُدُورٌ لُغَةٌ':Added, #2: 2	صُدُورُ الْكَلَامِ
u'صُدُورٌ لَفْظٌ':Added, #1: 1	صُدُورِ اللُّغَةِ
u'صُدُورٌ مثل':Added, #1: 1	صُدُورِ اللَّفْظِ
u'صُدُورٌ مِثْلٌ':Added, #1: 1	صُدُورِ مِثْلِ
u'صُدُورٌ مَجَالِسُ':Added, #1: 1	صُدُورِ مِثْلِ
u'صُدُورٌ مَعْصِيَةٌ':Added, #1: 1	صُدُورِ الْمَجَالِسِ
u'صُدُورٌ مُنْتَظِمٌ':Added, #2: 2	صُدُورُ الْمَعْصِيَةِ
u'صُدُورٌ مَنْهِيٌّ':Added, #1: 1	صُدُورِ الْمُنْتَظِمِ
u'صُدُورٌ نَاسٌ':Added, #1: 1	صُدُورِ الْمَنْهِيِّ
u'صُدُورٌ نكاح':Added, #1: 1	صُدُورِ النَّاسِ
u'صُدُورٌ نِكَاحٌ':Added, #1: 1	صُدُورِ النِّكَاحِ
u'صُدُورٌ هَدْأَةٌ':Added, #1: 1	صُدُورِ النِّكَاحِ
u'صُدُورٌ وَقْفٌ':Added, #1: 1	صُدُورِ الْهَدْأَةِ
u'صُدُورٌ يَمِينٌ':Added, #5: 5	صُدُورِ الْوَقْفِ
u'صَدِئَ إِناءٌ':Subject, #1: 1	صُدُورِ الْيَمِينِ
u'صَدِئَ ذَهَبٌ':Subject, #1: 1	صَدِئَ إنَاءُ
u'صَرَاحَةٌ لَفْظٌ':Added, #1: 1	صَدِئَ الذَّهَبُ
u'صَرَاحَةٌ لَفْظٌ':Added, #1: 1	صَرَاحَةَ اللَّفْظِ
u'صَرَاحَةٌ نَسَبٌ':Added, #1: 1	صَرَاحَةَ لَفْظِ
u'صَرَّ أهْلٌ':Subject, #1: 1	صَرَاحَةِ النَّسَبِ
u'صَرَّ بَاعٌ':Predicate, #1: 1	أَصَرَّ أَهْلُ
u'صَرَّ بَائِعٌ':Subject, #1: 1	أَصَرَّ بَاعَ
u'صَرَّحَ اِبْنٌ':Subject, #1: 1	أَصَرَّ الْبَائِعُ
u'صَرَّحَ أحَدٌ':Subject, #113: 113	صَرَّحَ ابْنُ
u'صَرَّحَ أُسْتَاذٌ':Subject, #3: 3	صَرَّحَ أَحَدٌ
u'صَرَّحَ أَشْهَب':Subject, #5: 5	صَرَّحَ الْأُسْتَاذُ
u'صَرَّحَ أَصْحَابٌ':Subject, #1: 1	صَرَّحَ أَشْهَبُ
u'صَرَّحَ أَصْحَابٌ':Subject, #24: 24	صَرَّحَ الْأَصْحَابُ
u'صَرَّحَ أصل':Subject, #3: 3	صَرَّحَ أَصْحَابُ
u'صَرَّحَ أًصْلٌ':Subject, #10: 10	صَرَّحَ أَصْلُهُ
u'صَرَّحَ أصل':Subject, #10: 10	صَرَّحَ أَصْلُهُ
u'صَرَّحَ أًصْلٌ':Subject, #70: 70	صَرَّحَ الْأَصْلُ
u'صَرَّحَ أَكْثَرُ':Subject, #70: 70	صَرَّحَ الْأَصْلُ
u'صَرَّحَ إمَامٌ':Subject, #2: 2	صَرَّحَ أَكْثَرُ
u'صَرَّحَ إمَامٌ':Subject, #46: 46	صَرَّحَ الْإِمَامُ
u'صَرَّحَ آمِرٌ':Subject, #4: 4	صَرَّحَ إمَامُ
u'صَرَّحَ أئِمَّةٌ':Subject, #1: 1	صَرَّحَ الْآمِرُ
u'صَرَّحَ بُخَارِيٌّ':Subject, #11: 11	صَرَّحَ الْأَئِمَّةُ
u'صَرَّحَ بَعْضٌ':Subject, #1: 1	صَرَّحَ الْبُخَارِيُّ
u'صَرَّحَ جَبَلِيٌّ':Subject, #14: 14	صَرَّحَ بَعْضُ
u'صَرَّحَ جَلاَلٌ':Subject, #2: 2	صَرَّحَ الْجَبَلِيُّ
u'صَرَّحَ جَمَاعَةٌ':Subject, #2: 2	صَرَّحَ الْجَلَالُ
u'صَرَّحَ جَمْعٌ':Subject, #17: 17	صَرَّحَ جَمَاعَةٌ
u'صَرَّحَ حافِظٌ':Subject, #8: 8	صَرَّحَ جَمْعٌ
u'صَرَّحَ حاكِمٌ':Subject, #1: 1	صَرَّحَ الْحَافِظُ
u'صَرَّحَ حَديثٌ':Subject, #4: 4	صَرَّحَ الْحَاكِمُ
u'صَرَّحَ حَلْوانِيٌّ':Subject, #1: 1	صَرَّحَ الْحَدِيثُ
u'صَرَّحَ حَنَفِيَّةٌ':Subject, #1: 1	صَرَّحَ الْحَلْوَانِيُّ
u'صَرَّحَ خَلْقٌ':Subject, #1: 1	صَرَّحَ الْحَنَفِيَّةُ
u'صَرَّحَ رَئِيسٌ':Subject, #1: 1	صَرَّحَ خَلْقٌ
u'صَرَّحَ زَوْجٌ':Subject, #2: 2	صَرَّحَ رَئِيسُ
u'صَرَّحَ سَيِّدٌ':Subject, #1: 1	صَرَّحَ الزَّوْجُ
u'صَرَّحَ شَارِحٌ':Subject, #2: 2	صَرَّحَ السَّيِّدُ
u'صَرَّحَ شَارِحٌ':Subject, #2: 2	صَرَّحَ شَارِحُ
u'صَرَّحَ شافِع':Subject, #5: 5	صَرَّحَ الشَّارِحُ
u'صَرَّحَ شافِعِيّ':Subject, #1: 1	صَرَّحَ الشَّافِعِيَّةُ
u'صَرَّحَ شافِعِيّ':Subject, #1: 1	صَرَّحَ الشَّافِعِيَّةُ
u'صَرَّحَ شُرَّاحٌ':Subject, #7: 7	صَرَّحَ الشَّافِعِيُّ
u'صَرَّحَ شمس':Subject, #1: 1	صَرَّحَ الشُّرَّاحُ
u'صَرَّحَ شَمْسٌ':Subject, #1: 1	صَرَّحَ الشَّمْسُ
u'صَرَّحَ شمس':Subject, #1: 1	صَرَّحَ الشَّمْسُ
u'صَرَّحَ شَمْسٌ':Subject, #1: 1	صَرَّحَ شَمْسُ
u'صَرَّحَ شَيْخٌ':Subject, #1: 1	صَرَّحَ شَمْسُ
u'صَرَّحَ شَيْخٌ':Subject, #23: 23	صَرَّحَ الشَّيْخُ
u'صَرَّحَ صَاحِبٌ':Subject, #2: 2	صَرَّحَ شَيْخُ
u'صَرَّحَ صَدْرٌ':Subject, #39: 39	صَرَّحَ صَاحِبُ
u'صَرَّحَ صَيْرَفِيٌّ':Subject, #1: 1	صَرَّحَ صَدْرُ
u'صَرَّحَ عَبْدٌ':Subject, #1: 1	صَرَّحَ الصَّيْرَفِيُّ
u'صَرَّحَ عِزٌّ':Subject, #1: 1	صَرَّحَ عَبْدُ
u'صَرَّحَ عَقِيبٌ':Predicate, #1: 1	صَرَّحَ عِزُّ
u'صَرَّحَ غير':Subject, #1: 1	صَرَّحَ عَقِيبَ
u'صَرَّحَ غَيْرٌ':Subject, #2: 2	صَرَّحَ غَيْرُهُ
u'صَرَّحَ غير':Subject, #2: 2	صَرَّحَ غَيْرُهُ
u'صَرَّحَ غَيْرٌ':Subject, #9: 9	صَرَّحَ غَيْرُ
u'صَرَّحَ فخر':Subject, #9: 9	صَرَّحَ غَيْرُ
u'صَرَّحَ فَخْرٌ':Subject, #3: 3	صَرَّحَ فَخْرُ
u'صَرَّحَ فقهاء':Subject, #3: 3	صَرَّحَ فَخْرُ
u'صَرَّحَ فَقِيهٌ':Subject, #2: 2	صَرَّحَ الْفُقَهَاءُ
u'صَرَّحَ فلان':Subject, #1: 1	صَرَّحَ الْفَقِيهُ
u'صَرَّحَ فلان':Subject, #1: 1	صَرَّحَ الدَّمِيرِيُّ
u'صَرَّحَ فلان':Subject, #1: 1	صَرَّحَ الشَّافِعِيَّةُ
u'صَرَّحَ قَارِئٌ':Subject, #7: 7	صَرَّحَ الشَّافِعِيُّ
u'صَرَّحَ قُرْآنٌ':Subject, #1: 1	صَرَّحَ قَارِئُ
u'صَرَّحَ قَفَّالٌ':Subject, #1: 1	صَرَّحَ الْقُرْآنُ
u'صَرَّ حَكَمٌ':Predicate, #12: 12	صَرَّحَ الْقَفَّالُ
u'صَرَّحَ كَمَالٌ':Subject, #1: 1	أَصَرَّ حَكَمَ
u'صَرَّحَ مَالِكٌ':Subject, #4: 4	صَرَّحَ الْكَمَالُ
u'صَرَّحَ مَجْدٌ':Subject, #1: 1	صَرَّحَ الْمَالِكُ
u'صَرَّحَ مُحِبٌّ':Subject, #3: 3	صَرَّحَ الْمَجْدُ
u'صَرَّحَ مُحَقِّقٌ':Subject, #1: 1	صَرَّحَ الْمُحِبُّ
u'صَرَّحَ مُسْلِمٌ':Subject, #2: 2	صَرَّحَ الْمُحَقِّقُ
u'صَرَّحَ مَشَايِخُ':Subject, #1: 1	صَرَّحَ مُسْلِمٌ
u'صَرَّحَ مُصَنِّفٌ':Subject, #1: 1	صَرَّحَ الْمَشَايِخُ
u'صَرَّحَ مُعِير':Subject, #34: 34	صَرَّحَ الْمُصَنِّفُ
u'صَرَّحَ مِنْهَاجٌ':Subject, #1: 1	صَرَّحَ الْمُعِيرُ
u'صَرَّحَ مُوَكِّلٌ':Subject, #11: 11	صَرَّحَ الْمِنْهَاجُ
u'صَرَّحَ مُؤَلِّفٌ':Subject, #2: 2	صَرَّحَ الْمُوَكِّلُ
u'صَرَّحَ ناذِر':Subject, #1: 1	صَرَّحَ الْمُؤَلِّفُ
u'صَرَّحَ نَبِيٌّ':Subject, #1: 1	صَرَّحَ النَّاذِرُ
u'صَرَّحَ نَوَوِيٌّ':Subject, #3: 3	صَرَّحَ النَّبِيُّ
u'صَرَّحَ وَاقِفٌ':Subject, #27: 27	صَرَّحَ النَّوَوِيُّ
u'صَرَّحَ وَالِدٌ':Subject, #2: 2	صَرَّحَ الْوَاقِفُ
u'صَرَّحَ وَكِيلٌ':Subject, #1: 1	صَرَّحَ وَالِدُ
u'صَرَّحَ وَلِيٌّ':Subject, #4: 4	صَرَّحَ الْوَكِيلُ
u'صَرَّحَ يَعْقُوبٌ':Subject, #1: 1	صَرَّحَ الْوَلِيُّ
u'صَرَخَ إبْلِيسُ':Subject, #2: 2	صَرَّحَ يَعْقُوبُ
u'صَرَخَ دِيكٌ':Subject, #1: 1	صَرَخَ إبْلِيسُ
u'صَرَخَ شَيْطَانٌ':Subject, #1: 1	صَرَخَ دِيكٌ
u'صَرَخَ صَارِخٌ':Subject, #2: 2	صَرَخَ الشّيْطَانُ
u'صَرَّ زَوْجٌ':Subject, #1: 1	صَرَخَ صَارِخٌ
u'صَرْعَةٌ ظَلُوم':Added, #1: 1	أَصَرَّ الزَّوْجُ
u'صَرَفَ أُجْرَةٌ':Predicate, #1: 1	صَرْعَةُ الظَّلُومِ
u'صَرْفٌ أُجْرَةٌ':Added, #1: 1	صَرَفَ الْأُجْرَةَ
u'صَرْف أُجْرَةٌ':Added, #1: 1	صَرْفَ أُجْرَةِ
u'صَرْفٌ أُجْرَةٌ':Added, #1: 1	صَرْفَ أُجْرَةِ
u'صَرْف أُجْرَةٌ':Added, #1: 1	صَرْفَ الْأُجْرَةِ
u'صَرْفٌ أُجْرَةٌ':Added, #1: 1	صَرْفَ الْأُجْرَةِ
u'صَرْف أُجْرَةٌ':Added, #2: 2	صَرْفُ الْأُجْرَةِ
u'صَرْفٌ أُجْرَةٌ':Added, #2: 2	صَرْفُ الْأُجْرَةِ
u'صَرْف أُجْرَةٌ':Added, #3: 3	صَرْفِ الْأُجْرَةِ
u'صَرَفَ أَجْنَبِيٌّ':Subject, #3: 3	صَرْفِ الْأُجْرَةِ
u'صَرْفٌ أَجْوَدُ':Added, #2: 2	صَرَفَ أَجْنَبِيٌّ
u'صَرْف أَجْوَدُ':Added, #1: 1	صَرْفُ أَجْوَدِ
u'صَرَفَ أَجِيرٌ':Subject, #1: 1	صَرْفُ أَجْوَدِ
u'صَرْفٌ أَحْباسٌ':Added, #3: 3	صَرَفَ الْأَجِيرُ
u'صَرْف أَحْباسٌ':Added, #1: 1	صَرْفِ أَحْبَاسِ
u'صَرْفٌ أَحْباسٌ':Added, #1: 1	صَرْفِ أَحْبَاسِ
u'صَرْف أَحْباسٌ':Added, #1: 1	صَرْفِ الْأَحْبَاسِ
u'صَرَفَ أحَدٌ':Predicate, #1: 1	صَرْفِ الْأَحْبَاسِ
u'صَرْفٌ أحَدٌ':Added, #1: 1	صَرَفَ أَحَدَ
u'صَرْف أحَدٌ':Added, #1: 1	صَرْفُ أَحَدِ
u'صَرْفٌ إِحْرَامٌ':Added, #1: 1	صَرْفُ أَحَدِ
u'صَرْف إِحْرَامٌ':Added, #1: 1	صَرْفُ إحْرَامِهِ
u'صَرْفٌ أصل':Added, #1: 1	صَرْفُ إحْرَامِهِ
u'صَرْف أصل':Added, #1: 1	صَرْفِ الْأَصْلِ
u'صَرْفٌ أًصْلٌ':Added, #1: 1	صَرْفِ الْأَصْلِ
u'صَرْف أًصْلٌ':Added, #1: 1	صَرْفِ الْأَصْلِ
u'صَرْفٌ أَصْلِيٌّ':Added, #1: 1	صَرْفِ الْأَصْلِ
u'صَرْف أَصْلِيٌّ':Added, #1: 1	صَرْفِ الْأَصْلِيَّةِ
u'صَرْفٌ إِطْعامٌ':Added, #1: 1	صَرْفِ الْأَصْلِيَّةِ
u'صَرْف إِطْعامٌ':Added, #2: 2	صَرْفُ الْإِطْعَامِ
u'صَرْفٌ إِطْلاقٌ':Added, #2: 2	صَرْفُ الْإِطْعَامِ
u'صَرْف إِطْلاقٌ':Added, #1: 1	صَرْفُ إطْلَاقِ
u'صَرْفٌ إقْرَارٌ':Added, #1: 1	صَرْفُ إطْلَاقِ
u'صَرْف إقْرَارٌ':Added, #1: 1	صَرْفَ إقْرَارِهِ
u'صَرَفَ أَكْثَرُ':Predicate, #1: 1	صَرْفَ إقْرَارِهِ
u'صَرْفٌ أَكْثَرُ':Added, #1: 1	صَرَفَ أَكْثَرَ
u'صَرْف أَكْثَرُ':Added, #1: 1	صَرْفِ أَكْثَرِ
u'صَرْفٌ ألف':Added, #1: 1	صَرْفِ أَكْثَرِ
u'صَرْف ألف':Added, #1: 1	صَرْفِ الْأَلْفِ
u'صَرْفٌ ألْفٌ':Added, #1: 1	صَرْفِ الْأَلْفِ
u'صَرْف ألْفٌ':Added, #1: 1	صَرْفِ الْأَلْفِ
u'صَرْفٌ أَلْفٌ':Added, #1: 1	صَرْفِ الْأَلْفِ
u'صَرْف أَلْفٌ':Added, #1: 1	صَرْفِ الْأَلْفِ
u'صَرْفٌ أَلْفَاظٌ':Added, #1: 1	صَرْفِ الْأَلْفِ
u'صَرْف أَلْفَاظٌ':Added, #1: 1	صَرْفُ أَلْفَاظِ
u'صَرْفٌ أَلْفَاظٌ':Added, #1: 1	صَرْفُ أَلْفَاظِ
u'صَرْف أَلْفَاظٌ':Added, #1: 1	صَرْفُ أَلْفَاظِهِ
u'صَرَفَ إمَامٌ':Subject, #1: 1	صَرْفُ أَلْفَاظِهِ
u'صَرْفٌ أمَانَةٌ':Added, #2: 2	صَرَفَ الْإِمَامُ
u'صَرْفٌ أمَانَةٌ':Added, #1: 1	صَرْفَ الْأَمَانَةِ
u'صَرْف أمَانَةٌ':Added, #1: 1	صَرْفِ الْأَمَانَةِ
u'صَرْف أمَانَةٌ':Added, #1: 1	صَرْفَ الْأَمَانَةِ
u'صَرَفَ أَمْرٌ':Predicate, #1: 1	صَرْفِ الْأَمَانَةِ
u'صَرْفٌ أَمْرٌ':Added, #1: 1	صَرَفَ الْأَمْرَ
u'صَرْفٌ أَمْرٌ':Added, #1: 1	صَرْفُ الْأَمْرِ
u'صَرْف أَمْرٌ':Added, #1: 1	صَرْفِ الْأَمْرِ
u'صَرْف أَمْرٌ':Added, #1: 1	صَرْفُ الْأَمْرِ
u'صَرْفٌ إِمْساكٌ':Added, #1: 1	صَرْفِ الْأَمْرِ
u'صَرْف إِمْساكٌ':Added, #1: 1	صَرْفُ الْإِمْسَاكِ
u'صَرْفٌ أَمْوَالٌ':Added, #1: 1	صَرْفُ الْإِمْسَاكِ
u'صَرْف أَمْوَالٌ':Added, #1: 1	صَرْفِ الْأَمْوَالِ
u'صَرَفَ أهْلٌ':Subject, #1: 1	صَرْفِ الْأَمْوَالِ
u'صَرَفَ إِيجَابٌ':Predicate, #1: 1	صَرَفَ أَهْلُ
u'صَرْفٌ بَزّاز':Added, #1: 1	صَرَفَ الْإِيجَابَ
u'صَرْف بَزّاز':Added, #1: 1	صَرْفِ الْبَزَّازِيَّةِ
u'صَرْفٌ بَزّازَة':Added, #1: 1	صَرْفِ الْبَزَّازِيَّةِ
u'صَرْف بَزّازَة':Added, #1: 1	صَرْفِ الْبَزَّازِيَّةِ
u'صَرْفٌ بَعْضٌ':Added, #1: 1	صَرْفِ الْبَزَّازِيَّةِ
u'صَرْف بَعْضٌ':Added, #1: 1	صَرْفِ بَعْضِ
u'صَرْفٌ تَحْرِيمٌ':Added, #1: 1	صَرْفِ بَعْضِ
u'صَرْفٌ تَحْرِيمٌ':Added, #1: 1	صَرْفَ التَّحْرِيمِ
u'صَرْف تَحْرِيمٌ':Added, #1: 1	صَرْفُ التَّحْرِيمِ
u'صَرْف تَحْرِيمٌ':Added, #1: 1	صَرْفَ التَّحْرِيمِ
u'صَرْفٌ تُرَابٌ':Added, #1: 1	صَرْفُ التَّحْرِيمِ
u'صَرْف تُرَابٌ':Added, #1: 1	صَرْفُ تُرَابِ
u'صَرْفٌ تَطَوُّعٌ':Added, #1: 1	صَرْفُ تُرَابِ
u'صَرْف تَطَوُّعٌ':Added, #1: 1	صَرْفُ التَّطَوُّعِ
u'صَرْفٌ ثَانِي':Added, #1: 1	صَرْفُ التَّطَوُّعِ
u'صَرْف ثَانِي':Added, #1: 1	صَرْفُ الثَّانِيَةِ
u'صَرْفٌ ثَانِيَةٌ':Added, #1: 1	صَرْفُ الثَّانِيَةِ
u'صَرْف ثَانِيَةٌ':Added, #1: 1	صَرْفُ الثَّانِيَةِ
u'صَرْفٌ ثَلاثُ':Added, #1: 1	صَرْفُ الثَّانِيَةِ
u'صَرْف ثَلاثُ':Added, #1: 1	صَرْفِ ثَلَاثِ
u'صَرْفٌ ثَمَنٌ':Added, #1: 1	صَرْفِ ثَلَاثِ
u'صَرْف ثَمَنٌ':Added, #1: 1	صَرْفِ الثَّمَنِ
u'صَرْفٌ ثَمَنٌ':Added, #1: 1	صَرْفِ الثَّمَنِ
u'صَرْف ثَمَنٌ':Added, #3: 3	صَرْفُ ثَمَنِهِ
u'صَرْفٌ ثَوْبٌ':Added, #3: 3	صَرْفُ ثَمَنِهِ
u'صَرْف ثَوْبٌ':Added, #1: 1	صَرْفَ ثَوْبٍ
u'صَرْفٌ جمعة':Added, #1: 1	صَرْفَ ثَوْبٍ
u'صَرْف جمعة':Added, #2: 2	صَرْفُ الْجُمُعَةِ
u'صَرْفٌ جُمُعَةٌ':Added, #2: 2	صَرْفُ الْجُمُعَةِ
u'صَرْف جُمُعَةٌ':Added, #2: 2	صَرْفُ الْجُمُعَةِ
u'صَرْفٌ جَمِيع':Added, #2: 2	صَرْفُ الْجُمُعَةِ
u'صَرْف جَمِيع':Added, #1: 1	صَرْفِ الْجَمِيعِ
u'صَرْفٌ جَمِيع':Added, #1: 1	صَرْفِ الْجَمِيعِ
u'صَرْف جَمِيع':Added, #4: 4	صَرْفُ الْجَمِيعِ
u'صَرَفَ جِنْسٌ':Predicate, #4: 4	صَرْفُ الْجَمِيعِ
u'صَرْفٌ جِنْسٌ':Added, #1: 1	صَرَفَ الْجِنْسَ
u'صَرْفٌ جِنْسٌ':Added, #1: 1	صَرْفَ الْجِنْسِ
u'صَرْفٌ جِنْسٌ':Added, #1: 1	صَرْفُ الْجِنْسِ
u'صَرْف جِنْسٌ':Added, #1: 1	صَرْفِ الْجِنْسِ
u'صَرْف جِنْسٌ':Added, #1: 1	صَرْفَ الْجِنْسِ
u'صَرْف جِنْسٌ':Added, #1: 1	صَرْفُ الْجِنْسِ
u'صَرَفَ حامِلٌ':Predicate, #1: 1	صَرْفِ الْجِنْسِ
u'صَرَفَ حَجٌّ':Predicate, #1: 1	صَرَفَ الْحَامِلَ
u'صَرْفٌ حَجٌّ':Added, #1: 1	صَرَفَ الْحَجَّ
u'صَرْف حَجٌّ':Added, #1: 1	صَرْفُ الْحَجِّ
u'صَرْفٌ حَديثٌ':Added, #1: 1	صَرْفُ الْحَجِّ
u'صَرْف حَديثٌ':Added, #1: 1	صَرْفَ الْحَدِيثِ
u'صَرْفٌ حَرِيرٌ':Added, #1: 1	صَرْفَ الْحَدِيثِ
u'صَرْف حَرِيرٌ':Added, #1: 1	صَرْفِ الْحَرِيرِ
u'صَرَفَ حُسْنٌ':Predicate, #1: 1	صَرْفِ الْحَرِيرِ
u'صَرَفَ حَقٌّ':Predicate, #1: 1	صَرَفَ حُسْنَ
u'صَرَفَ حَقٌّ':Predicate, #1: 1	صَرَفَ الْحَقَّ
u'صَرْفٌ حَقٌّ':Added, #1: 1	صَرَفَ حَقَّ
u'صَرْف حَقٌّ':Added, #1: 1	صَرْفَ حَقِّ
u'صَرْفٌ حَقِيقٌ':Added, #1: 1	صَرْفَ حَقِّ
u'صَرْف حَقِيقٌ':Added, #1: 1	صَرْفَ الْحَقِيقَةِ
u'صَرْفٌ حَقِيقَةٌ':Added, #1: 1	صَرْفَ الْحَقِيقَةِ
u'صَرْف حَقِيقَةٌ':Added, #1: 1	صَرْفَ الْحَقِيقَةِ
u'صَرْفٌ خراج':Added, #1: 1	صَرْفَ الْحَقِيقَةِ
u'صَرْف خراج':Added, #1: 1	صَرْفُ الْخَرَاجِ
u'صَرْفٌ خَرَاجٌ':Added, #1: 1	صَرْفُ الْخَرَاجِ
u'صَرْف خَرَاجٌ':Added, #1: 1	صَرْفُ الْخَرَاجِ
u'صَرْفٌ خَشَبٌ':Added, #1: 1	صَرْفُ الْخَرَاجِ
u'صَرْف خَشَبٌ':Added, #1: 1	صَرْفُ خَشَبِهِ
u'صَرَفَ خُمُسٌ':Predicate, #1: 1	صَرْفُ خَشَبِهِ
u'صَرْفٌ خُمُسٌ':Added, #1: 1	صَرَفَ الْخُمُسَ
u'صَرْفٌ خُمُسٌ':Added, #1: 1	صَرْفَ الْخُمُسِ
u'صَرْف خُمُسٌ':Added, #1: 1	صَرْفِ الْخُمُسِ
u'صَرْف خُمُسٌ':Added, #1: 1	صَرْفَ الْخُمُسِ
u'صَرْفٌ خُمُسٌ':Added, #1: 1	صَرْفِ الْخُمُسِ
u'صَرْف خُمُسٌ':Added, #2: 2	صَرْفُ خُمُسِ
u'صَرْفٌ خُمُسٌ':Added, #2: 2	صَرْفُ خُمُسِ
u'صَرْف خُمُسٌ':Added, #3: 3	صَرْفُ الْخُمُسِ
u'صَرْفٌ دَرَاهِمُ':Added, #3: 3	صَرْفُ الْخُمُسِ
u'صَرْف دَرَاهِمُ':Added, #1: 1	صَرْفَ الدَّرَاهِمِ
u'صَرْفٌ دَرَاهِمُ':Added, #1: 1	صَرْفَ الدَّرَاهِمِ
u'صَرْف دَرَاهِمُ':Added, #2: 2	صَرْفِ الدَّرَاهِمِ
u'صَرْفٌ دَلالَةٌ':Added, #2: 2	صَرْفِ الدَّرَاهِمِ
u'صَرْف دَلالَةٌ':Added, #1: 1	صَرْفِ دَلَالَةِ
u'صَرَفَ دَنانيرُ':Predicate, #1: 1	صَرْفِ دَلَالَةِ
u'صَرْفٌ دَهْرٌ':Added, #2: 2	صَرَفَ دَنَانِيرَ
u'صَرْف دَهْرٌ':Added, #1: 1	صَرْفِ دَهْرِهِ
u'صَرَفَ دَيْنٌ':Predicate, #1: 1	صَرْفِ دَهْرِهِ
u'صَرْفٌ دَيْنٌ':Added, #7: 7	صَرَفَ الدَّيْنَ
u'صَرْف دَيْنٌ':Added, #1: 1	صَرْفِ الدَّيْنِ
u'صَرْفٌ دَيْنٌ':Added, #1: 1	صَرْفِ الدَّيْنِ
u'صَرْف دَيْنٌ':Added, #1: 1	صَرْفُ دَيْنِهِ
u'صَرْفٌ دَيْنٌ':Added, #1: 1	صَرْفُ دَيْنِهِ
u'صَرْف دَيْنٌ':Added, #3: 3	صَرْفُ الدَّيْنِ
u'صَرْفٌ دِينارٌ':Added, #3: 3	صَرْفُ الدَّيْنِ
u'صَرْف دِينارٌ':Added, #1: 1	صَرْفِ الدِّينَارِ
u'صَرْفٌ دِينارٌ':Added, #1: 1	صَرْفِ الدِّينَارِ
u'صَرْف دِينارٌ':Added, #1: 1	صَرْفِ دِينَارِ
u'صَرْفٌ دِينارٌ':Added, #1: 1	صَرْفِ دِينَارِ
u'صَرْف دِينارٌ':Added, #1: 1	صَرْفُ دِينَارَيْنِ
u'صَرْفٌ دِينارٌ':Added, #1: 1	صَرْفُ دِينَارَيْنِ
u'صَرْف دِينارٌ':Added, #2: 2	صَرْفَ دِينَارِ
u'صَرْفٌ دِينارٌ':Added, #2: 2	صَرْفَ دِينَارِ
u'صَرْف دِينارٌ':Added, #5: 5	صَرْفِ دِينَارٍ
u'صَرْفٌ دِينارٌ':Added, #5: 5	صَرْفِ دِينَارٍ
u'صَرْف دِينارٌ':Added, #8: 8	صَرْفُ دِينَارٍ
u'صَرَفَ ذَهَبٌ':Predicate, #8: 8	صَرْفُ دِينَارٍ
u'صَرْفٌ رِبْحٌ':Added, #2: 2	صَرَفَ الذَّهَبَ
u'صَرْف رِبْحٌ':Added, #3: 3	صَرْفُ الرِّبْحِ
u'صَرْفٌ رُبْعٌ':Added, #3: 3	صَرْفُ الرِّبْحِ
u'صَرْف رُبْعٌ':Added, #1: 1	صَرْفُ الرُّبْعِ
u'صَرْفٌ رُبُعٌ':Added, #1: 1	صَرْفُ الرُّبْعِ
u'صَرْف رُبُعٌ':Added, #1: 1	صَرْفُ رُبُعِ
u'صَرْفٌ رِكاز':Added, #1: 1	صَرْفُ رُبُعِ
u'صَرْف رِكاز':Added, #1: 1	صَرْفُ الرِّكَازِ
u'صَرْفٌ رَمْيٌ':Added, #1: 1	صَرْفُ الرِّكَازِ
u'صَرْف رَمْيٌ':Added, #1: 1	صَرْفَ الرَّمْيِ
u'صَرْفٌ ريعٌ':Added, #1: 1	صَرْفَ الرَّمْيِ
u'صَرْف ريعٌ':Added, #1: 1	صَرْفُ الرِّيعِ
u'صَرْفٌ ريعٌ':Added, #1: 1	صَرْفُ الرِّيعِ
u'صَرْف ريعٌ':Added, #1: 1	صَرْفَ رِيعِهِ
u'صَرْفٌ زائِدٌ':Added, #1: 1	صَرْفَ رِيعِهِ
u'صَرْف زائِدٌ':Added, #1: 1	صَرْفُ الزَّائِدِ
u'صَرْفٌ زَكا':Added, #1: 1	صَرْفُ الزَّائِدِ
u'صَرْف زَكا':Added, #1: 1	صَرْفُ الزَّكَاتَيْنِ
u'صَرْفٌ زَكاةٌ':Added, #1: 1	صَرْفُ الزَّكَاتَيْنِ
u'صَرْف زَكاةٌ':Added, #1: 1	صَرْفَ زَكَاةٍ
u'صَرْفٌ زَكاةٌ':Added, #1: 1	صَرْفَ زَكَاةٍ
u'صَرْف زَكاةٌ':Added, #1: 1	صَرْفُ زَكَاتِهِ
u'صَرْفٌ زَكاةٌ':Added, #1: 1	صَرْفُ زَكَاتِهِ
u'صَرْف زَكاةٌ':Added, #25: 25	صَرْفُ الزَّكَاةِ
u'صَرْفٌ زَكاةٌ':Added, #25: 25	صَرْفُ الزَّكَاةِ
u'صَرْف زَكاةٌ':Added, #2: 2	صَرْفُ زَكَاةِ
u'صَرْفٌ زَكاةٌ':Added, #2: 2	صَرْفُ زَكَاةِ
u'صَرْف زَكاةٌ':Added, #7: 7	صَرْفِ الزَّكَاةِ
u'صَرْفٌ زَمانٌ':Added, #7: 7	صَرْفِ الزَّكَاةِ
u'صَرْفٌ زَمانٌ':Added, #1: 1	صَرْفِ الزّمَانِ
u'صَرْف زَمانٌ':Added, #1: 1	صَرْفِ الزَّمَانِ
u'صَرْف زَمانٌ':Added, #1: 1	صَرْفِ الزّمَانِ
u'صَرْفٌ زَمانٌ':Added, #1: 1	صَرْفِ الزَّمَانِ
u'صَرْف زَمانٌ':Added, #1: 1	صَرْفِ زَمَانٍ
u'صَرْفٌ زَمانٌ':Added, #1: 1	صَرْفِ زَمَانٍ
u'صَرْف زَمانٌ':Added, #2: 2	صَرْفُ الزَّمَانِ
u'صَرْفٌ زِيادَةٌ':Added, #2: 2	صَرْفُ الزَّمَانِ
u'صَرْف زِيادَةٌ':Added, #2: 2	صَرْفُ الزِّيَادَةِ
u'صَرْفٌ سَهْمٌ':Added, #2: 2	صَرْفُ الزِّيَادَةِ
u'صَرْف سَهْمٌ':Added, #2: 2	صَرْفُ سَهْمِ
u'صَرْفٌ شَرْطٌ':Added, #2: 2	صَرْفُ سَهْمِ
u'صَرْف شَرْطٌ':Added, #1: 1	صَرْفُ الشَّرْطِ
u'صَرْفٌ شَيْءٌ':Added, #1: 1	صَرْفُ الشَّرْطِ
u'صَرْف شَيْءٌ':Added, #14: 14	صَرْفُ شَيْءٍ
u'صَرْفٌ شَيْءٌ':Added, #14: 14	صَرْفُ شَيْءٍ
u'صَرْف شَيْءٌ':Added, #1: 1	صَرْفُ الشَّيْءِ
u'صَرْفٌ شَيْءٌ':Added, #1: 1	صَرْفُ الشَّيْءِ
u'صَرْف شَيْءٌ':Added, #2: 2	صَرْفَ شَيْءٍ
u'صَرْفٌ صَاعٌ':Added, #2: 2	صَرْفَ شَيْءٍ
u'صَرْف صَاعٌ':Added, #3: 3	صَرْفُ صَاعٍ
u'صَرَفَ صدقة':Predicate, #3: 3	صَرْفُ صَاعٍ
u'صَرَفَ صَدَقَةٌ':Predicate, #1: 1	صَرَفَ الصَّدَقَةَ
u'صَرْفٌ صدقة':Added, #1: 1	صَرَفَ الصَّدَقَةَ
u'صَرْفٌ صدقة':Added, #1: 1	صَرْفَ الصَّدَقَةِ
u'صَرْف صدقة':Added, #1: 1	صَرْفِ الصَّدَقَةِ
u'صَرْف صدقة':Added, #1: 1	صَرْفَ الصَّدَقَةِ
u'صَرْفٌ صَدَقَةٌ':Added, #1: 1	صَرْفِ الصَّدَقَةِ
u'صَرْفٌ صَدَقَةٌ':Added, #1: 1	صَرْفَ الصَّدَقَةِ
u'صَرْف صَدَقَةٌ':Added, #1: 1	صَرْفِ الصَّدَقَةِ
u'صَرْف صَدَقَةٌ':Added, #1: 1	صَرْفَ الصَّدَقَةِ
u'صَرْفٌ صدقة':Added, #1: 1	صَرْفِ الصَّدَقَةِ
u'صَرْف صدقة':Added, #1: 1	صَرْفَ صَدَقَةِ
u'صَرْفٌ صَدَقَةٌ':Added, #1: 1	صَرْفَ صَدَقَةِ
u'صَرْف صَدَقَةٌ':Added, #1: 1	صَرْفَ صَدَقَةِ
u'صَرْفٌ صدقة':Added, #1: 1	صَرْفَ صَدَقَةِ
u'صَرْف صدقة':Added, #5: 5	صَرْفُ صَدَقَةِ
u'صَرْفٌ صَدَقَةٌ':Added, #5: 5	صَرْفُ صَدَقَةِ
u'صَرْف صَدَقَةٌ':Added, #5: 5	صَرْفُ صَدَقَةِ
u'صَرْفٌ صِيغَةٌ':Added, #5: 5	صَرْفُ صَدَقَةِ
u'صَرْف صِيغَةٌ':Added, #1: 1	صَرْفِ الصِّيغَةِ
u'صَرْفٌ طَرِيقٌ':Added, #1: 1	صَرْفِ الصِّيغَةِ
u'صَرْف طَرِيقٌ':Added, #2: 2	صَرْفُ الطَّرِيقِ
u'صَرَفَ طعام':Predicate, #2: 2	صَرْفُ الطَّرِيقِ
u'صَرَفَ طَعَامٌ':Predicate, #1: 1	صَرَفَ الطَّعَامَ
u'صَرْفٌ طعام':Added, #1: 1	صَرَفَ الطَّعَامَ
u'صَرْف طعام':Added, #1: 1	صَرْفَ طَعَامِ
u'صَرْفٌ طَعَامٌ':Added, #1: 1	صَرْفَ طَعَامِ
u'صَرْف طَعَامٌ':Added, #1: 1	صَرْفَ طَعَامِ
u'صَرْفٌ طَلاَقٌ':Added, #1: 1	صَرْفَ طَعَامِ
u'صَرْف طَلاَقٌ':Added, #1: 1	صَرْفَ الطَّلَاقِ
u'صَرْفٌ طَلاَقٌ':Added, #1: 1	صَرْفَ الطَّلَاقِ
u'صَرْف طَلاَقٌ':Added, #3: 3	صَرْفِ الطَّلَاقِ
u'صَرَفَ طواف':Predicate, #3: 3	صَرْفِ الطَّلَاقِ
u'صَرَفَ طَوَافٌ':Predicate, #1: 1	صَرَفَ الطَّوَافَ
u'صَرْفٌ عَبْدٌ':Added, #1: 1	صَرَفَ الطَّوَافَ
u'صَرْف عَبْدٌ':Added, #1: 1	صَرْفِ الْعَبْدِ
u'صَرْفٌ عَبْدٌ':Added, #1: 1	صَرْفِ الْعَبْدِ
u'صَرْف عَبْدٌ':Added, #4: 4	صَرْفُ الْعَبْدِ
u'صَرْفٌ عتق':Added, #4: 4	صَرْفُ الْعَبْدِ
u'صَرْف عتق':Added, #1: 1	صَرْفَ عِتْقِ
u'صَرْفٌ عِتْقٌ':Added, #1: 1	صَرْفَ عِتْقِ
u'صَرْف عِتْقٌ':Added, #1: 1	صَرْفَ عِتْقِ
u'صَرْفٌ عتق':Added, #1: 1	صَرْفَ عِتْقِ
u'صَرْف عتق':Added, #3: 3	صَرْفِ الْعِتْقِ
u'صَرْفٌ عِتْقٌ':Added, #3: 3	صَرْفِ الْعِتْقِ
u'صَرْف عِتْقٌ':Added, #3: 3	صَرْفِ الْعِتْقِ
u'صَرْفٌ عُشْرٌ':Added, #3: 3	صَرْفِ الْعِتْقِ
u'صَرْفٌ عُشْرٌ':Added, #1: 1	صَرْفَ الْعُشْرِ
u'صَرْف عُشْرٌ':Added, #1: 1	صَرْفُ الْعُشْرِ
u'صَرْف عُشْرٌ':Added, #1: 1	صَرْفَ الْعُشْرِ
u'صَرْفٌ عَقْدٌ':Added, #1: 1	صَرْفُ الْعُشْرِ
u'صَرْف عَقْدٌ':Added, #2: 2	صَرْفُ الْعَقْدِ
u'صَرَفَ علماء':Subject, #2: 2	صَرْفُ الْعَقْدِ
u'صَرَفَ عُلَمَاءُ':Subject, #1: 1	صَرَفَ عُلَمَاءُ
u'صَرَفَ عِمَارَةٌ':Predicate, #1: 1	صَرَفَ عُلَمَاءُ
u'صَرْفٌ عِمَارَةٌ':Added, #1: 1	صَرَفَ الْعِمَارَةَ
u'صَرْف عِمَارَةٌ':Added, #1: 1	صَرْفِ عِمَارَتِهِ
u'صَرْفٌ عَمَلٌ':Added, #1: 1	صَرْفِ عِمَارَتِهِ
u'صَرْف عَمَلٌ':Added, #1: 1	صَرْفُ الْعَمَلِ
u'صَرْفٌ عَنَانٌ':Added, #1: 1	صَرْفُ الْعَمَلِ
u'صَرْف عَنَانٌ':Added, #1: 1	صَرْفِ الْعَنَانِ
u'صَرْفٌ عِنان':Added, #1: 1	صَرْفِ الْعَنَانِ
u'صَرْف عِنان':Added, #1: 1	صَرْفُ عِنَانِ
u'صَرْفٌ عِنَانٌ':Added, #1: 1	صَرْفُ عِنَانِ
u'صَرْف عِنَانٌ':Added, #1: 1	صَرْفُ عِنَانِ
u'صَرَفَ عِوَضٌ':Predicate, #1: 1	صَرْفُ عِنَانِ
u'صَرْفٌ عِوَضٌ':Added, #1: 1	صَرَفَ الْعِوَضَ
u'صَرْف عِوَضٌ':Added, #1: 1	صَرْفِ عِوَضِهِ
u'صَرْفٌ عين':Added, #1: 1	صَرْفِ عِوَضِهِ
u'صَرْف عين':Added, #1: 1	صَرْفُ الْعَيْنِ
u'صَرْفٌ عَيْنٌ':Added, #1: 1	صَرْفُ الْعَيْنِ
u'صَرْفٌ عَيْن':Added, #1: 1	صَرْفُ الْعَيْنِ
u'صَرْف عَيْنٌ':Added, #1: 1	صَرْفُ الْعَيْنِ
u'صَرْف عَيْن':Added, #1: 1	صَرْفُ الْعَيْنِ
u'صَرَفَ غَالِبٌ':Predicate, #1: 1	صَرْفُ الْعَيْنِ
u'صَرَفَ غَلَّةٌ':Predicate, #1: 1	صَرَفَ غَالِبَ
u'صَرْفٌ غَلَّةٌ':Added, #3: 3	صَرَفَ الْغَلَّةَ
u'صَرْف غَلَّةٌ':Added, #10: 10	صَرْفِ الْغَلَّةِ
u'صَرْفٌ غَلَّةٌ':Added, #10: 10	صَرْفِ الْغَلَّةِ
u'صَرْف غَلَّةٌ':Added, #1: 1	صَرْفُ غَلَّاتِ
u'صَرْفٌ غَلَّةٌ':Added, #1: 1	صَرْفُ غَلَّاتِ
u'صَرْفٌ غَلَّةٌ':Added, #1: 1	صَرْفُ غَلَّةِ
u'صَرْف غَلَّةٌ':Added, #1: 1	صَرْفِ غَلَّةِ
u'صَرْف غَلَّةٌ':Added, #1: 1	صَرْفُ غَلَّةِ
u'صَرْفٌ غَلَّةٌ':Added, #1: 1	صَرْفِ غَلَّةِ
u'صَرْف غَلَّةٌ':Added, #3: 3	صَرْفَ الْغَلَّةِ
u'صَرْفٌ غَلَّةٌ':Added, #3: 3	صَرْفَ الْغَلَّةِ
u'صَرْف غَلَّةٌ':Added, #8: 8	صَرْفُ الْغَلَّةِ
u'صَرْفٌ غير':Added, #8: 8	صَرْفُ الْغَلَّةِ
u'صَرْف غير':Added, #1: 1	صَرْفُ الْغَيْرِ
u'صَرْفٌ غَيْرٌ':Added, #1: 1	صَرْفُ الْغَيْرِ
u'صَرْف غَيْرٌ':Added, #1: 1	صَرْفُ الْغَيْرِ
u'صَرْفٌ فَاسِدٌ':Added, #1: 1	صَرْفُ الْغَيْرِ
u'صَرْف فَاسِدٌ':Added, #6: 6	صَرْفٍ فَاسِدٍ
u'صَرْفٌ فَاضِلٌ':Added, #6: 6	صَرْفٍ فَاسِدٍ
u'صَرْف فَاضِلٌ':Added, #1: 1	صَرْفَ الْفَاضِلِ
u'صَرْفٌ فَاضِلٌ':Added, #1: 1	صَرْفَ الْفَاضِلِ
u'صَرْف فَاضِلٌ':Added, #2: 2	صَرْفِ الْفَاضِلِ
u'صَرْفٌ فَاضِلٌ':Added, #2: 2	صَرْفِ الْفَاضِلِ
u'صَرْف فَاضِلٌ':Added, #3: 3	صَرْفُ الْفَاضِلِ
u'صَرَفَ فَضْلٌ':Predicate, #3: 3	صَرْفُ الْفَاضِلِ
u'صَرْفٌ فطرة':Added, #3: 3	صَرَفَ فَضْلَ
u'صَرْف فطرة':Added, #1: 1	صَرْفِ الْفِطْرَةِ
u'صَرْفٌ فِطْرَةٌ':Added, #1: 1	صَرْفِ الْفِطْرَةِ
u'صَرْف فِطْرَةٌ':Added, #1: 1	صَرْفِ الْفِطْرَةِ
u'صَرْفٌ فلان':Added, #1: 1	صَرْفِ الْفِطْرَةِ
u'صَرْف فلان':Added, #1: 1	صَرْفِ الْبَزَّازِيَّةِ
u'صَرَفَ فُلُوسٌ':Predicate, #1: 1	صَرْفِ الْبَزَّازِيَّةِ
u'صَرْفٌ فَيْءٌ':Added, #2: 2	صَرَفَ الْفُلُوسَ
u'صَرْف فَيْءٌ':Added, #1: 1	صَرْفُ الْفَيْءِ
u'صَرْفٌ قُبْحٌ':Added, #1: 1	صَرْفُ الْفَيْءِ
u'صَرْف قُبْحٌ':Added, #1: 1	صَرْفُ الْقُبْحِ
u'صَرْفٌ قِبْلَةٌ':Added, #1: 1	صَرْفُ الْقُبْحِ
u'صَرْفٌ قِبْلَةٌ':Added, #1: 1	صَرْفُ الْقِبْلَةِ
u'صَرْف قِبْلَةٌ':Added, #1: 1	صَرْفِ الْقِبْلَةِ
u'صَرْف قِبْلَةٌ':Added, #1: 1	صَرْفُ الْقِبْلَةِ
u'صَرَفَ قَدْرٌ':Predicate, #1: 1	صَرْفِ الْقِبْلَةِ
u'صَرْفٌ قَدْرٌ':Added, #1: 1	صَرَفَ قَدْرَ
u'صَرْف قَدْرٌ':Added, #2: 2	صَرْفِ قَدْرِهِ
u'صَرْفٌ قدرة':Added, #2: 2	صَرْفِ قَدْرِهِ
u'صَرْف قدرة':Added, #1: 1	صَرْفُ الْقُدْرَةِ
u'صَرْفٌ قُدْرَةٌ':Added, #1: 1	صَرْفُ الْقُدْرَةِ
u'صَرْف قُدْرَةٌ':Added, #1: 1	صَرْفُ الْقُدْرَةِ
u'صَرْفٌ قلب':Added, #1: 1	صَرْفُ الْقُدْرَةِ
u'صَرْف قلب':Added, #1: 1	صَرْفِ الْقَلْبِ
u'صَرْفٌ قَلْبٌ':Added, #1: 1	صَرْفِ الْقَلْبِ
u'صَرْفٌ قَلْب':Added, #1: 1	صَرْفِ الْقَلْبِ
u'صَرْف قَلْبٌ':Added, #1: 1	صَرْفِ الْقَلْبِ
u'صَرْف قَلْب':Added, #1: 1	صَرْفِ الْقَلْبِ
u'صَرْفٌ قلب':Added, #1: 1	صَرْفِ الْقَلْبِ
u'صَرْف قلب':Added, #1: 1	صَرْفَ قَلْبِهِ
u'صَرْفٌ قَلْبٌ':Added, #1: 1	صَرْفَ قَلْبِهِ
u'صَرْفٌ قَلْب':Added, #1: 1	صَرْفَ قَلْبِهِ
u'صَرْف قَلْبٌ':Added, #1: 1	صَرْفَ قَلْبِهِ
u'صَرْف قَلْب':Added, #1: 1	صَرْفَ قَلْبِهِ
u'صَرَفَ قُلُوبٌ':Predicate, #1: 1	صَرْفَ قَلْبِهِ
u'صَرْفٌ قَمْحٌ':Added, #1: 1	صَرَفَ الْقُلُوبَ
u'صَرْف قَمْحٌ':Added, #1: 1	صَرْفُ الْقَمْحِ
u'صَرْفٌ قول':Added, #1: 1	صَرْفُ الْقَمْحِ
u'صَرْف قول':Added, #1: 1	صَرْفَ قَوْلِ
u'صَرْفٌ قَوْلٌ':Added, #1: 1	صَرْفَ قَوْلِ
u'صَرْف قَوْلٌ':Added, #1: 1	صَرْفَ قَوْلِ
u'صَرَفَ قَيِّمٌ':Subject, #1: 1	صَرْفَ قَوْلِ
u'صَرْفٌ قِيمَةٌ':Added, #1: 1	صَرَفَ الْقَيِّمُ
u'صَرْف قِيمَةٌ':Added, #1: 1	صَرْفَ قِيمَتِهِ
u'صَرْفٌ قِيمَةٌ':Added, #1: 1	صَرْفَ قِيمَتِهِ
u'صَرْف قِيمَةٌ':Added, #2: 2	صَرْفُ قِيمَتِهِ
u'صَرْفٌ كَسْبٌ':Added, #2: 2	صَرْفُ قِيمَتِهِ
u'صَرْف كَسْبٌ':Added, #2: 2	صَرْفِ كَسْبِهِ
u'صَرْفٌ كَفَّارٌ':Added, #2: 2	صَرْفِ كَسْبِهِ
u'صَرْف كَفَّارٌ':Added, #1: 1	صَرْفِ الْكَفَّارَةِ
u'صَرْفٌ كَفَّارٌ':Added, #1: 1	صَرْفِ الْكَفَّارَةِ
u'صَرْف كَفَّارٌ':Added, #1: 1	صَرْفُ كَفَّارَةِ
u'صَرْفٌ كَفَّارٌ':Added, #1: 1	صَرْفُ كَفَّارَةِ
u'صَرْف كَفَّارٌ':Added, #4: 4	صَرْفُ الْكَفَّارَةِ
u'صَرْفٌ كَفَّارَةٌ':Added, #4: 4	صَرْفُ الْكَفَّارَةِ
u'صَرْف كَفَّارَةٌ':Added, #1: 1	صَرْفِ الْكَفَّارَةِ
u'صَرْفٌ كَفَّارَةٌ':Added, #1: 1	صَرْفِ الْكَفَّارَةِ
u'صَرْف كَفَّارَةٌ':Added, #1: 1	صَرْفُ كَفَّارَةِ
u'صَرْفٌ كَفَّارَةٌ':Added, #1: 1	صَرْفُ كَفَّارَةِ
u'صَرْف كَفَّارَةٌ':Added, #4: 4	صَرْفُ الْكَفَّارَةِ
u'صَرْفٌ كِفَايَةٌ':Added, #4: 4	صَرْفُ الْكَفَّارَةِ
u'صَرْف كِفَايَةٌ':Added, #1: 1	صَرْفِ كِفَايَتِهِ
u'صَرْفٌ كَلاَمٌ':Added, #1: 1	صَرْفِ كِفَايَتِهِ
u'صَرْف كَلاَمٌ':Added, #1: 1	صَرْفُ كَلَامِهِ
u'صَرْفٌ كَلاَمٌ':Added, #1: 1	صَرْفُ كَلَامِهِ
u'صَرْفٌ كَلاَمٌ':Added, #4: 4	صَرْفَ الْكَلَامِ
u'صَرْف كَلاَمٌ':Added, #4: 4	صَرْفُ الْكَلَامِ
u'صَرْف كَلاَمٌ':Added, #4: 4	صَرْفَ الْكَلَامِ
u'صَرْفٌ كَلاَمٌ':Added, #4: 4	صَرْفُ الْكَلَامِ
u'صَرْف كَلاَمٌ':Added, #6: 6	صَرْفِ الْكَلَامِ
u'صَرَفَ لَغْوٌ':Predicate, #6: 6	صَرْفِ الْكَلَامِ
u'صَرَفَ لَفْظٌ':Predicate, #1: 1	صَرَفَ اللَّغْوَ
u'صَرْفٌ لَفْظٌ':Added, #1: 1	صَرَفَ اللَّفْظَ
u'صَرْف لَفْظٌ':Added, #15: 15	صَرْفِ اللَّفْظِ
u'صَرْفٌ لَفْظٌ':Added, #15: 15	صَرْفِ اللَّفْظِ
u'صَرْف لَفْظٌ':Added, #2: 2	صَرْفَ لَفْظِهِ
u'صَرْفٌ لَفْظٌ':Added, #2: 2	صَرْفَ لَفْظِهِ
u'صَرْف لَفْظٌ':Added, #3: 3	صَرْفَ اللَّفْظِ
u'صَرْفٌ لَفْظٌ':Added, #3: 3	صَرْفَ اللَّفْظِ
u'صَرْف لَفْظٌ':Added, #7: 7	صَرْفُ اللَّفْظِ
u'صَرْفٌ لَوْنٌ':Added, #7: 7	صَرْفُ اللَّفْظِ
u'صَرْف لَوْنٌ':Added, #1: 1	صَرْفَ لَوْنٍ
u'صَرَفَ مَاءٌ':Predicate, #1: 1	صَرْفَ لَوْنٍ
u'صَرْفٌ مَاءٌ':Added, #1: 1	صَرَفَ الْمَاءَ
u'صَرْف مَاءٌ':Added, #1: 1	صَرْفِ الْمَاءِ
u'صَرْفٌ مَاءٌ':Added, #1: 1	صَرْفِ الْمَاءِ
u'صَرْف مَاءٌ':Added, #5: 5	صَرْفُ الْمَاءِ
u'صَرَفَ مَالٌ':Predicate, #5: 5	صَرْفُ الْمَاءِ
u'صَرَفَ مَالٌ':Predicate, #1: 1	صَرَفَ الْمَالَ
u'صَرْفٌ مَالٌ':Added, #2: 2	صَرَفَ مَالَ
u'صَرْفٌ مَالٌ':Added, #1: 1	صَرْفُ مَالِ
u'صَرْف مَالٌ':Added, #1: 1	صَرْفِ مَالِ
u'صَرْف مَالٌ':Added, #1: 1	صَرْفُ مَالِ
u'صَرْفٌ مَالٌ':Added, #1: 1	صَرْفِ مَالِ
u'صَرْفٌ مَالٌ':Added, #1: 1	صَرْفَ مَالِهِ
u'صَرْف مَالٌ':Added, #1: 1	صَرْفُ مَالِهِ
u'صَرْف مَالٌ':Added, #1: 1	صَرْفَ مَالِهِ
u'صَرْفٌ مَالٌ':Added, #1: 1	صَرْفُ مَالِهِ
u'صَرْف مَالٌ':Added, #2: 2	صَرْفَ مَالٍ
u'صَرْفٌ مَالٌ':Added, #2: 2	صَرْفَ مَالٍ
u'صَرْف مَالٌ':Added, #3: 3	صَرْفَ الْمَالِ
u'صَرْفٌ مَالٌ':Added, #3: 3	صَرْفَ الْمَالِ
u'صَرْف مَالٌ':Added, #3: 3	صَرْفِ مَالِهِ
u'صَرْفٌ مَالٌ':Added, #3: 3	صَرْفِ مَالِهِ
u'صَرْفٌ مَالٌ':Added, #5: 5	صَرْفُ الْمَالِ
u'صَرْف مَالٌ':Added, #5: 5	صَرْفِ الْمَالِ
u'صَرْف مَالٌ':Added, #5: 5	صَرْفُ الْمَالِ
u'صَرَفَ مَالِكٌ':Subject, #5: 5	صَرْفِ الْمَالِ
u'صَرْفٌ مَبْلَغٌ':Added, #1: 1	صَرَفَ الْمَالِكُ
u'صَرْف مَبْلَغٌ':Added, #1: 1	صَرْفُ مَبْلَغِ
u'صَرْفٌ مَبْلَغٌ':Added, #1: 1	صَرْفُ مَبْلَغِ
u'صَرْف مَبْلَغٌ':Added, #2: 2	صَرْفُ الْمَبْلَغِ
u'صَرْفٌ مثل':Added, #2: 2	صَرْفُ الْمَبْلَغِ
u'صَرْف مثل':Added, #2: 2	صَرْفِ مِثْلِهِ
u'صَرْفٌ مِثْلٌ':Added, #2: 2	صَرْفِ مِثْلِهِ
u'صَرْف مِثْلٌ':Added, #2: 2	صَرْفِ مِثْلِهِ
u'صَرَفَ مَشِيئَةٌ':Predicate, #2: 2	صَرْفِ مِثْلِهِ
u'صَرْفٌ مَشِيئَةٌ':Added, #4: 4	صَرَفَ الْمَشِيئَةَ
u'صَرْف مَشِيئَةٌ':Added, #1: 1	صَرْفَ الْمَشِيئَةِ
u'صَرْفٌ مَنَافِعُ':Added, #1: 1	صَرْفَ الْمَشِيئَةِ
u'صَرْف مَنَافِعُ':Added, #1: 1	صَرْفِ الْمَنَافِعِ
u'صَرْفٌ مَنَافِعُ':Added, #1: 1	صَرْفِ الْمَنَافِعِ
u'صَرْف مَنَافِعُ':Added, #1: 1	صَرْفَ مَنَافِعِهِ
u'صَرْفٌ مَنْذُور':Added, #1: 1	صَرْفَ مَنَافِعِهِ
u'صَرْف مَنْذُور':Added, #1: 1	صَرْفِ الْمَنْذُورِ
u'صَرْفٌ مَنْفَعَةٌ':Added, #1: 1	صَرْفِ الْمَنْذُورِ
u'صَرْف مَنْفَعَةٌ':Added, #1: 1	صَرْفِ الْمَنْفَعَةِ
u'صَرْفٌ مَنْفَعَةٌ':Added, #1: 1	صَرْفِ الْمَنْفَعَةِ
u'صَرْف مَنْفَعَةٌ':Added, #2: 2	صَرْفِ مَنْفَعَتِهِ
u'صَرْفٌ مَنْفَعَةٌ':Added, #2: 2	صَرْفِ مَنْفَعَتِهِ
u'صَرْف مَنْفَعَةٌ':Added, #3: 3	صَرْفُ مَنْفَعَةِ
u'صَرْفٌ مَوْقُوفٌ':Added, #3: 3	صَرْفُ مَنْفَعَةِ
u'صَرْف مَوْقُوفٌ':Added, #1: 1	صَرْفُ الْمَوْقُوفِ
u'صَرْفٌ مِيرَاثٌ':Added, #1: 1	صَرْفُ الْمَوْقُوفِ
u'صَرْف مِيرَاثٌ':Added, #1: 1	صَرْفِ الْمِيرَاثِ
u'صَرَفَ نَاسٌ':Predicate, #1: 1	صَرْفِ الْمِيرَاثِ
u'صَرْفٌ نَاسٌ':Added, #1: 1	صَرَفَ النَّاسَ
u'صَرْف نَاسٌ':Added, #1: 1	صَرْفَ النَّاسِ
u'صَرْفٌ نَاسٌ':Added, #1: 1	صَرْفَ النَّاسِ
u'صَرْف نَاسٌ':Added, #2: 2	صَرْفُ النَّاسِ
u'صَرَفَ نَاظِرٌ':Subject, #2: 2	صَرْفُ النَّاسِ
u'صَرْفٌ نَحْوٌ':Added, #3: 3	صَرَفَ النَّاظِرُ
u'صَرْف نَحْوٌ':Added, #1: 1	صَرْفِ نَحْوِ
u'صَرْفٌ نَصِيبٌ':Added, #1: 1	صَرْفِ نَحْوِ
u'صَرْف نَصِيبٌ':Added, #1: 1	صَرْفِ نَصِيبِ
u'صَرْفٌ نُظَّارٌ':Added, #1: 1	صَرْفِ نَصِيبِ
u'صَرْف نُظَّارٌ':Added, #1: 1	صَرْفَ النُّظَّارِ
u'صَرْفٌ نَظَرٌ':Added, #1: 1	صَرْفَ النُّظَّارِ
u'صَرْف نَظَرٌ':Added, #1: 1	صَرْفُ النَّظَرِ
u'صَرْفٌ نَفْسٌ':Added, #1: 1	صَرْفُ النَّظَرِ
u'صَرْف نَفْسٌ':Added, #1: 1	صَرْفَ النَّفْسِ
u'صَرَفَ نَفَقَةٌ':Predicate, #1: 1	صَرْفَ النَّفْسِ
u'صَرْفٌ نَقْدٌ':Added, #4: 4	صَرَفَ نَفَقَةَ
u'صَرْفٌ نَقْد':Added, #1: 1	صَرْفُ النَّقْدِ
u'صَرْف نَقْدٌ':Added, #1: 1	صَرْفُ النَّقْدِ
u'صَرْف نَقْد':Added, #1: 1	صَرْفُ النَّقْدِ
u'صَرْفٌ نَقْدٌ':Added, #1: 1	صَرْفُ النَّقْدِ
u'صَرْفٌ نَقْد':Added, #2: 2	صَرْفُ نَقْدٍ
u'صَرْف نَقْدٌ':Added, #2: 2	صَرْفُ نَقْدٍ
u'صَرْف نَقْد':Added, #2: 2	صَرْفُ نَقْدٍ
u'صَرْفٌ نَقْضٌ':Added, #2: 2	صَرْفُ نَقْدٍ
u'صَرْف نَقْضٌ':Added, #1: 1	صَرْفُ نَقْضِهِ
u'صَرْفٌ نكاح':Added, #1: 1	صَرْفُ نَقْضِهِ
u'صَرْف نكاح':Added, #1: 1	صَرْفٍ نِكَاحٍ
u'صَرْفٌ نِكَاحٌ':Added, #1: 1	صَرْفٍ نِكَاحٍ
u'صَرْف نِكَاحٌ':Added, #1: 1	صَرْفٍ نِكَاحٍ
u'صَرْفٌ نَمَاءٌ':Added, #1: 1	صَرْفٍ نِكَاحٍ
u'صَرْف نَمَاءٌ':Added, #1: 1	صَرْفُ النَّمَاءِ
u'صَرْفٌ هلاك':Added, #1: 1	صَرْفُ النَّمَاءِ
u'صَرْف هلاك':Added, #1: 1	صَرْفُ الْهَلَاكِ
u'صَرْفٌ هَلاَكٌ':Added, #1: 1	صَرْفُ الْهَلَاكِ
u'صَرْف هَلاَكٌ':Added, #1: 1	صَرْفُ الْهَلَاكِ
u'صَرْفٌ هَمٌّ':Added, #1: 1	صَرْفُ الْهَلَاكِ
u'صَرْف هَمٌّ':Added, #1: 1	صَرْفُ الْهَمِّ
u'صَرْفٌ هِمَّةٌ':Added, #1: 1	صَرْفُ الْهَمِّ
u'صَرْف هِمَّةٌ':Added, #1: 1	صَرْفَ الْهِمَّةِ
u'صَرْفٌ وَاجِبٌ':Added, #1: 1	صَرْفَ الْهِمَّةِ
u'صَرْف وَاجِبٌ':Added, #1: 1	صَرْفُ الْوَاجِبِ
u'صَرَفَ وَجْهٌ':Predicate, #1: 1	صَرْفُ الْوَاجِبِ
u'صَرْفٌ وَجْهٌ':Added, #1: 1	صَرَفَ وَجْهَ
u'صَرْفٌ وَجْهٌ':Added, #1: 1	صَرْفَ الْوَجْهِ
u'صَرْف وَجْهٌ':Added, #1: 1	صَرْفُ الْوَجْهِ
u'صَرْف وَجْهٌ':Added, #1: 1	صَرْفَ الْوَجْهِ
u'صَرْفٌ وَدِيعٌ':Added, #1: 1	صَرْفُ الْوَجْهِ
u'صَرْف وَدِيعٌ':Added, #1: 1	صَرْفِ الْوَدِيعَةِ
u'صَرْفٌ وَدِيعَةٌ':Added, #1: 1	صَرْفِ الْوَدِيعَةِ
u'صَرْف وَدِيعَةٌ':Added, #1: 1	صَرْفِ الْوَدِيعَةِ
u'صَرْفٌ وَصِيٌّ':Added, #1: 1	صَرْفِ الْوَدِيعَةِ
u'صَرْف وَصِيٌّ':Added, #1: 1	صَرْفِ الْوَصِيِّ
u'صَرَفَ وَقْتٌ':Predicate, #1: 1	صَرْفِ الْوَصِيِّ
u'صَرْفٌ وَقْتٌ':Added, #2: 2	صَرَفَ الْوَقْتَ
u'صَرْف وَقْتٌ':Added, #1: 1	صَرْفِ الْوَقْتِ
u'صَرْفٌ وَقْفٌ':Added, #1: 1	صَرْفِ الْوَقْتِ
u'صَرْف وَقْفٌ':Added, #1: 1	صَرْفُ وَقْفِ
u'صَرْفٌ وَكِيلٌ':Added, #1: 1	صَرْفُ وَقْفِ
u'صَرْف وَكِيلٌ':Added, #1: 1	صَرْفُ الْوَكِيلِ
u'صَرَّ قتل':Predicate, #1: 1	صَرْفُ الْوَكِيلِ
u'صَرَّ مَاءٌ':Predicate, #2: 2	أَصَرَّ قُتِلَ
u'صَرَمَ ثَمَرٌ':Predicate, #1: 1	صَرَّ الْمَاءَ
u'صَرَّ مُعَلِّمٌ':Subject, #1: 1	صَرَمَ الثَّمَرَ
u'صَرَمَ نَخْلٌ':Predicate, #1: 1	أَصَرَّ الْمُعَلِّمُ
u'صُرُوفٌ لَيَالِي':Added, #2: 2	صَرَمَ النَّخْلَ
u'صَرِيرٌ أَقْلاَمٌ':Added, #1: 1	صُرُوفُ اللَّيَالِيِ
u'صَرِيفٌ أَقْلاَمٌ':Added, #1: 1	صَرِيرُ الْأَقْلَامِ
u'صَرِيفٌ أَقْلاَمٌ':Added, #2: 2	صَرِيفَ الأَقْلامِ
u'صَرِيفٌ سِواكٌ':Added, #2: 2	صَرِيفَ الْأَقْلَامِ
u'صَعُبَ تَحَمُّلٌ':Subject, #1: 1	صَرِيفَ السِّوَاكِ
u'صَعُبَ وَضْعٌ':Subject, #1: 1	صَعُبَ تَحَمُّلُ
u'صَعِدَ إمَامٌ':Subject, #2: 2	صَعُبَ وَضْعُهُ
u'صَعِدَ أنبياء':Subject, #7: 7	صَعِدَ الْإِمَامُ
u'صَعِدَ خَطِيبٌ':Subject, #1: 1	صَعِدَ الْأَنْبِيَاءُ
u'صَعِدَ رَسُولٌ':Subject, #1: 1	صَعِدَ الْخَطِيبُ
u'صَعِدَ سَطْحٌ':Predicate, #5: 5	صَعِدَ رَسُولُ
u'صَعِدَ عُمَرٌ':Subject, #2: 2	صَعِدَ السَّطْحَ
u'صَعِدَ مرو':Predicate, #1: 1	صَعِدَ عُمَرُ
u'صَعِدَ مِنْبَرٌ':Predicate, #2: 2	صَعِدَ الْمَرْوَةَ
u'صَعِدَ مُؤَذِّنٌ':Subject, #30: 30	صَعِدَ الْمِنْبَرَ
u'صَعِدَ مِئْذَنَةٌ':Predicate, #1: 1	صَعِدَ الْمُؤَذِّنُ
u'صَعِدَ نَبِيٌّ':Subject, #1: 1	صَعِدَ الْمِئْذَنَةَ
u'صَعَّدَ نَظَرٌ':Predicate, #4: 4	صَعِدَ النَّبِيُّ
u'صُعُوبَةٌ حَدٌّ':Added, #3: 3	صَعَّدَ النَّظَرَ
u'صُعُوبَةٌ حَدٌّ':Added, #1: 1	صُعُوبَةَ الْحَدِّ
u'صُعُوبَةٌ طَرِيقٌ':Added, #1: 1	صُعُوبَةُ الْحَدِّ
u'صُعُودٌ إمَامٌ':Added, #1: 1	صُعُوبَةِ الطَّرِيقِ
u'صُعُودٌ جَبَلٌ':Added, #2: 2	صُعُودِ الْإِمَامِ
u'صُعُودٌ جَبَلٌ':Added, #1: 1	صُعُودُ الْجَبَلِ
u'صُعُودٌ خَطِيبٌ':Added, #4: 4	صُعُودَ الْجَبَلِ
u'صُعُودٌ روحٌ':Added, #2: 2	صُعُودِ الْخَطِيبِ
u'صُعُودٌ روحٌ':Added, #1: 1	صُعُودَ الرُّوحِ
u'صُعُودٌ سَطْحٌ':Added, #1: 1	صُعُودِ رُوحِهِ
u'صُعُودٌ سَطْحٌ':Added, #1: 1	صُعُودَ السَّطْحِ
u'صُعُودٌ سَطْحٌ':Added, #1: 1	صُعُودُ السَّطْحِ
u'صُعُودٌ سَمَاءٌ':Added, #6: 6	صُعُودِ السَّطْحِ
u'صُعُودٌ شَجَرَةٌ':Added, #7: 7	صُعُودِ السَّمَاءِ
u'صُعُودٌ شَجَرَةٌ':Added, #1: 1	صُعُودِ الشَّجَرَةِ
u'صُعُودٌ صَوْمَعَةٌ':Added, #1: 1	صُعُودِ شَجَرَةٍ
u'صُعُودٌ قُرَيْشٌ':Added, #1: 1	صُعُودِ الصَّوْمَعَةِ
u'صُعُودٌ مَنَارٌ':Added, #1: 1	صُعُودُ قُرَيْشٍ
u'صغار كَافِرٌ':Added, #1: 1	صُعُودِ الْمَنَارِ
u'صَغَارٌ كَافِرٌ':Added, #2: 2	صَغَارَ كَافِرٍ
u'صِغَرٌ اِبْنٌ':Added, #2: 2	صَغَارَ كَافِرٍ
u'صِغَرٌ اِبْنٌ':Added, #1: 1	صِغَرِ ابْنِ
u'صَغَّرَ اِسْمٌ':Predicate, #1: 1	صِغَرِ ابْنِهِ
u'صِغَرٌ بَهيمٌ':Added, #2: 2	صَغَّرَ اسْمَ
u'صِغَرٌ بَهِيمَةٌ':Added, #1: 1	صِغَرِ الْبَهِيمَةِ
u'صِغَرٌ ثَوْبٌ':Added, #1: 1	صِغَرِ الْبَهِيمَةِ
u'صِغَرٌ حَبٌّ':Added, #3: 3	صِغَرِ الثَّوْبِ
u'صِغَرٌ حَبَّةٌ':Added, #1: 1	صِغَرُ الْحَبَّاتِ
u'صَغَرَ حَيَوَانٌ':Subject, #1: 1	صِغَرُ الْحَبَّاتِ
u'صَغُرَ حَيَوَانٌ':Subject, #1: 1	صَغَرَ الْحَيَوَانُ
u'صِغَرٌ خَطِيئَةٌ':Added, #3: 3	صَغُرَ الْحَيَوَانُ
u'صِغَرٌ ذكر':Added, #2: 2	صِغَرِ الْخَطِيئَةِ
u'صِغَرٌ ذَكَرٌ':Added, #1: 1	صِغَرُ الذَّكَرِ
u'صِغَرٌ زَوْجَةٌ':Added, #1: 1	صِغَرُ الذَّكَرِ
u'صِغَرٌ سِنٌّ':Added, #1: 1	صِغَرِ الزَّوْجَةِ
u'صِغَرٌ سِنٌّ':Added, #1: 1	صِغَرَ السِّنِّ
u'صِغَرٌ سِنٌّ':Added, #1: 1	صِغَرِ السِّنِّ
u'صِغَرٌ سِنٌّ':Added, #1: 1	صِغَرُ سِنِّهِ
u'صِغَرٌ سِنٌّ':Added, #1: 1	صِغَرِ سِنِّهِ
u'صَغُرَ عند':Predicate, #2: 2	صِغَرُ السِّنِّ
u'صِغَرٌ قُبَّةٌ':Added, #1: 1	صَغُرَ عِنْدَ
u'صِغَرٌ مَتَاعٌ':Added, #2: 2	صِغَرِ الْقُبَّةِ
u'صِغَرٌ مَنْزِلٌ':Added, #1: 1	صِغَرَ مَتَاعِهِ
u'صِغَرٌ هِمَّةٌ':Added, #1: 1	صِغَرِ مَنْزِلِهِ
u'صِغَرٌ هِمَّةٌ':Added, #1: 1	صِغَرُ هِمَّةٍ
u'صِغَرٌ هِمَّةٌ':Added, #1: 1	صِغَرِ هِمَّتِهِ
u'صِغَرٌ هِمَمٌ':Added, #2: 2	صِغَرِ الْهِمَّةِ
u'صِغَرٌ وَرَثَةٌ':Added, #1: 1	صِغَرِ الْهِمَمِ
u'صِغَرٌ ولد':Added, #2: 2	صِغَرِ الْوَرَثَةِ
u'صِغَرٌ وَلَدٌ':Added, #4: 4	صِغَرِ الْوَلَدِ
u'صَغِيَ إِناءٌ':Predicate, #4: 4	صِغَرِ الْوَلَدِ
u'صَفَاءٌ حَقٌّ':Added, #1: 1	أَصْغَى الْإِنَاءَ
u'صَفَاءٌ خَاطِرٌ':Added, #1: 1	صَفَاءَ الْحَقِّ
u'صَفَاءٌ سَرِيرَةٌ':Added, #1: 1	صَفَاءِ الْخَاطِرِ
u'صَفَاءٌ قلب':Added, #1: 1	صَفَاءِ السَّرِيرَةِ
u'صَفَاءٌ قلب':Added, #1: 1	صَفَاءُ الْقَلْبِ
u'صَفَاءٌ قَلْبٌ':Added, #1: 1	صَفَاءِ الْقَلْبِ
u'صَفَاءٌ قَلْبٌ':Added, #1: 1	صَفَاءُ الْقَلْبِ
u'صَفَاءٌ قَلْب':Added, #1: 1	صَفَاءِ الْقَلْبِ
u'صَفَاءٌ قَلْب':Added, #1: 1	صَفَاءُ الْقَلْبِ
u'صَفَاءٌ مَدَارِكُ':Added, #1: 1	صَفَاءِ الْقَلْبِ
u'صَفَاءٌ نُطْفَةٌ':Added, #1: 1	صَفَاءُ الْمَدَارِكِ
u'صَفَا قلب':Subject, #1: 1	صَفَاءِ النّطْفَةِ
u'صَفَا قَلْبٌ':Subject, #1: 1	صَفَا قَلْبُهُ
u'صَفَا قَلْب':Subject, #1: 1	صَفَا قَلْبُهُ
u'صَفَا مَاءٌ':Subject, #1: 1	صَفَا قَلْبُهُ
u'صَفَّ إمَامٌ':Subject, #5: 5	صَفَا الْمَاءُ
u'صَفَا يَوْمٌ':Subject, #1: 1	صَفَّ الْإِمَامُ
u'صَفَّ بَيْنٌ':Predicate, #1: 1	صَفَا يَوْمٌ
u'صِفَةٌ إبَاحَةٌ':Added, #1: 1	صَفَّ بَيْنَ
u'صِفَةٌ أبدال':Added, #1: 1	صِفَةِ الْإِبَاحَةِ
u'صِفَةٌ أَبْدَالٌ':Added, #1: 1	صِفَةِ الْأَبْدَالِ
u'صِفَةٌ أبدانٌ':Added, #1: 1	صِفَةِ الْأَبْدَالِ
u'صِفَةٌ إتْمَامٌ':Added, #1: 1	صِفَةُ أَبْدَانِ
u'صِفَةٌ إِتْيانٌ':Added, #1: 1	صِفَةِ الْإِتْمَامِ
u'صِفَةٌ إِثْبَاتٌ':Added, #2: 2	صِفَةِ الْإِتْيَانِ
u'صِفَةٌ إِجْزَاءٌ':Added, #1: 1	صِفَةَ إثْبَاتٍ
u'صِفَةٌ أَجْسَامٌ':Added, #1: 1	صِفَةَ الْإِجْزَاءِ
u'صِفَةٌ أَجْسَامٌ':Added, #1: 1	صِفَةُ الأَجْسَامِ
u'صِفَةٌ إحَاطَةٌ':Added, #1: 1	صِفَةِ الْأَجْسَامِ
u'صِفَةٌ إِحْرَامٌ':Added, #1: 1	صِفَةُ إحَاطَةٍ
u'صِفَةٌ إِحْرَامٌ':Added, #1: 1	صِفَةِ إحْرَامِهِ
u'صِفَةٌ إِحْيَاءٌ':Added, #3: 3	صِفَةِ الْإِحْرَامِ
u'صِفَةٌ أَخٌ':Added, #1: 1	صِفَةُ الْإِحْيَاءِ
u'صِفَةٌ إِخْبَارٌ':Added, #1: 1	صِفَةِ أَخٍ
u'صِفَةٌ أخْذٌ':Added, #1: 1	صِفَةَ الْإِخْبَارِ
u'صِفَةٌ إِخْرَاجٌ':Added, #1: 1	صِفَةَ أَخْذِ
u'صِفَةٌ إِخْرَاجٌ':Added, #1: 1	صِفَةُ إخْرَاجِ
u'صِفَةٌ إِخْرَاجٌ':Added, #1: 1	صِفَةِ إخْرَاجِ
u'صِفَةٌ إِخْرَاجٌ':Added, #1: 1	صِفَةُ الْإِخْرَاجِ
u'صِفَةٌ أَدَاءٌ':Added, #2: 2	صِفَةُ إخْرَاجِهِ
u'صِفَةٌ أَدَاءٌ':Added, #1: 1	صِفَةُ أَدَاءِ
u'صِفَةٌ آدَمُ':Added, #2: 2	صِفَةِ الْأَدَاءِ
u'صِفَةٌ آدَمِيٌّ':Added, #1: 1	صِفَةِ الْآدَمِ
u'صِفَةٌ آدَمِيٌّ':Added, #1: 1	صِفَةِ الْآدَمِيِّ
u'صِفَةٌ أَذَانٌ':Added, #1: 1	صِفَةِ الْآدَمِيَّةِ
u'صِفَةٌ أَذَانٌ':Added, #1: 1	صِفَةُ الأَذَانِ
u'صِفَةٌ إِذْنٌ':Added, #1: 1	صِفَةِ الْأَذَانِ
u'صِفَةٌ إِذْنٌ':Added, #2: 2	صِفَةَ الْإِذْنِ
u'صِفَةٌ أَرْكانٌ':Added, #3: 3	صِفَةِ الْإِذْنِ
u'صِفَةٌ أَرْكَانٌ':Added, #1: 1	صِفَةِ أَرْكَانِ
u'صِفَةٌ أَسَدٌ':Added, #1: 1	صِفَةِ أَرْكَانِ
u'صِفَةٌ إِسْكارٌ':Added, #1: 1	صِفَةِ الْأَسَدِ
u'صِفَةٌ إِسْلامٌ':Added, #1: 1	صِفَةِ الْإِسْكَارِ
u'صِفَةٌ إِسْلامٌ':Added, #1: 1	صِفَةُ الْإِسْلَامِ
u'صِفَةٌ إِسْلامٌ':Added, #2: 2	صِفَةِ الْإِسْلَامِ
u'صِفَةٌ اِشْتِمالٌ':Added, #5: 5	صِفَةَ الْإِسْلَامِ
u'صِفَةٌ أشراف':Added, #1: 1	صِفَةَ اشْتِمَالِ
u'صِفَةٌ أَشْرَافٌ':Added, #1: 1	صِفَةُ الْأَشْرَافِ
u'صِفَةٌ أصل':Added, #1: 1	صِفَةُ الْأَشْرَافِ
u'صِفَةٌ أًصْلٌ':Added, #1: 1	صِفَةُ أَصْلِهِ
u'صِفَةٌ أصل':Added, #1: 1	صِفَةُ أَصْلِهِ
u'صِفَةٌ أًصْلٌ':Added, #1: 1	صِفَةِ الْأَصْلِ
u'صِفَةٌ أُصولٌ':Added, #1: 1	صِفَةِ الْأَصْلِ
u'صِفَةٌ أُصولٌ':Added, #1: 1	صِفَةَ الْأُصُولِ
u'صِفَةٌ أَطْرافٌ':Added, #6: 6	صِفَةُ الْأُصُولِ
u'صِفَةٌ أَطْرَافٌ':Added, #1: 1	صِفَةِ أَطْرَافِ
u'صِفَةٌ إِطْلاقٌ':Added, #1: 1	صِفَةِ أَطْرَافِ
u'صِفَةٌ إِطْلاقٌ':Added, #1: 1	صِفَةَ الْإِطْلَاقِ
u'صِفَةٌ إِعادَةٌ':Added, #2: 2	صِفَةِ الْإِطْلَاقِ
u'صِفَةٌ اِعْتِبارٌ':Added, #2: 2	صِفَةَ الْإِعَادَةِ
u'صِفَةٌ إِعْرابٌ':Added, #1: 1	صِفَةُ اعْتِبَارِ
u'صِفَةٌ أَعْرَاضٌ':Added, #1: 1	صِفَةُ الْإِعْرَابِ
u'صِفَةٌ أَفْعَالٌ':Added, #1: 1	صِفَةِ الْأَعْرَاضِ
u'صِفَةٌ إقامَةٌ':Added, #1: 1	صِفَةُ الْأَفْعَالِ
u'صِفَةٌ إقْرَارٌ':Added, #2: 2	صِفَةِ الْإِقَامَةِ
u'صِفَةٌ أقَلُّ':Added, #1: 1	صِفَةُ إقْرَارِهِ
u'صِفَةٌ أكل':Added, #1: 1	صِفَةِ أَقَلِّ
u'صِفَةٌ أَكْلٌ':Added, #1: 1	صِفَةِ أَكْلِ
u'صِفَةٌ إلْحَاقٌ':Added, #1: 1	صِفَةِ أَكْلِ
u'صِفَةٌ الْمَرْأَةُ':Added, #1: 1	صِفَةِ إلْحَاقِ
u'صِفَةٌ الْمَرْأَةُ':Added, #1: 1	صِفَةُ الْمَرْأَةِ
u'صِفَةٌ إمَامَةٌ':Added, #1: 1	صِفَةِ الْمَرْأَةِ
u'صِفَةٌ إمَامَةٌ':Added, #1: 1	صِفَةَ الْإِمَامَةِ
u'صِفَةٌ أُمَّةٌ':Added, #1: 1	صِفَةُ الْإِمَامَةِ
u'صِفَةٌ أَمْرٌ':Added, #1: 1	صِفَةُ أُمَّةِ
u'صِفَةٌ أَمْرٌ':Added, #1: 1	صِفَةِ الْأَمْرِ
u'صِفَةٌ أُمَمٌ':Added, #1: 1	صِفَةُ أَمْرِهِ
u'صِفَةٌ أَمْنٌ':Added, #1: 1	صِفَةُ الْأُمَمِ
u'صِفَةٌ أَمْنٌ':Added, #1: 1	صِفَةُ الْأَمْنِ
u'صِفَةٌ أَمْوَالٌ':Added, #1: 1	صِفَةِ الْأَمْنِ
u'صِفَةٌ أَنْباءٌ':Added, #1: 1	صِفَةِ الْأَمْوَالِ
u'صِفَةٌ أَنْبَاءٌ':Added, #1: 1	صِفَةِ الْأَنْبَاءِ
u'صِفَةٌ أنبياء':Added, #1: 1	صِفَةِ الْأَنْبَاءِ
u'صِفَةٌ إِنْسانٌ':Added, #1: 1	صِفَةَ الْأَنْبِيَاءِ
u'صِفَةٌ إِنْشاءٌ':Added, #1: 1	صِفَةُ الْإِنْسَانِ
u'صِفَةٌ اِنْعِقَادٌ':Added, #1: 1	صِفَةُ إنْشَاءٍ
u'صِفَةٌ إِنْكارٌ':Added, #1: 1	صِفَةَ انْعِقَادِهِ
u'صِفَةٌ أهْلٌ':Added, #1: 1	صِفَةَ الْإِنْكَارِ
u'صِفَةٌ أهْلٌ':Added, #1: 1	صِفَةُ أَهْلِ
u'صِفَةٌ أَوَّلُ':Added, #4: 4	صِفَةِ أَهْلِ
u'صِفَةٌ أَوَّلِيٌّ':Added, #1: 1	صِفَةَ الْأَوَّلِ
u'صِفَةٌ أَوَّلِيٌّ':Added, #1: 1	صِفَةَ الْأَوَّلِيَّةِ
u'صِفَةٌ أئِمَّةٌ':Added, #4: 4	صِفَةُ الْأَوَّلِيَّةِ
u'صِفَةٌ إِيجَابٌ':Added, #21: 21	صِفَةِ الْأَئِمَّةِ
u'صِفَةٌ إيقَاعٌ':Added, #1: 1	صِفَةُ الْإِيجَابِ
u'صِفَةٌ إيقَاعٌ':Added, #1: 1	صِفَةُ إيقَاعِ
u'صِفَةٌ أَيْمَانٌ':Added, #1: 1	صِفَةِ إيقَاعِ
u'صِفَةٌ إيمَانٌ':Added, #1: 1	صِفَةِ الْأَيْمَانِ
u'صِفَةٌ بتات':Added, #1: 1	صِفَةِ الْإِيمَانِ
u'صِفَةٌ بَتَاتٌ':Added, #1: 1	صِفَةَ الْبَتَاتِ
u'صِفَةٌ بُخْلٌ':Added, #1: 1	صِفَةَ الْبَتَاتِ
u'صِفَةٌ بَرْنامَجٌ':Added, #1: 1	صِفَةُ الْبُخْلِ
u'صِفَةٌ بُسُور':Added, #1: 1	صِفَةِ الْبَرْنَامَجِ
u'صِفَةٌ بَعْثٌ':Added, #1: 1	صِفَةَ الْبُسُورَةِ
u'صِفَةٌ بَعْضٌ':Added, #1: 1	صِفَةَ الْبَعْثِ
u'صِفَةٌ بَعيرٌ':Added, #1: 1	صِفَةُ بَعْضِ
u'صِفَةٌ بَقاءٌ':Added, #1: 1	صِفَةُ الْبَعِيرِ
u'صِفَةٌ بَقَرٌ':Added, #1: 1	صِفَةَ الْبَقَاءِ
u'صِفَةٌ بَكارَةٌ':Added, #1: 1	صِفَةِ الْبَقَرَةِ
u'صِفَةٌ بَكارَةٌ':Added, #2: 2	صِفَةَ الْبَكَارَةِ
u'صِفَةٌ بِئْرٌ':Added, #3: 3	صِفَةِ الْبَكَارَةِ
u'صِفَةٌ بَيْعٌ':Added, #1: 1	صِفَةِ بِئْرِ
u'صِفَةٌ بَيْعٌ':Added, #1: 1	صِفَةِ الْبَيْعِ
u'صِفَةٌ بَيْعٌ':Added, #1: 1	صِفَةُ بَيْعِ
u'صِفَةٌ بَيْعَةٌ':Added, #2: 2	صِفَةُ الْبَيْعِ
u'صِفَةٌ بَيْعَةٌ':Added, #1: 1	صِفَةِ الْبَيْعَةِ
u'صِفَةٌ تَابِعٌ':Added, #1: 1	صِفَةِ بَيْعَةِ
u'صِفَةٌ تَتَابُعٌ':Added, #1: 1	صِفَةٍ تَابِعَةٍ
u'صِفَةٌ تَتَابُعٌ':Added, #2: 2	صِفَةَ التَّتَابُعِ
u'صِفَةٌ تَتَابُعٌ':Added, #2: 2	صِفَةُ التَّتَابُعِ
u'صِفَةٌ تَثْلِيثٌ':Added, #4: 4	صِفَةِ التَّتَابُعِ
u'صِفَةٌ تَثْنِيَةٌ':Added, #1: 1	صِفَةَ التَّثْلِيثِ
u'صِفَةٌ تِجَارَةٌ':Added, #1: 1	صِفَةِ التَّثْنِيَةِ
u'صِفَةٌ تَحَالُفٌ':Added, #1: 1	صِفَةُ التِّجَارَةِ
u'صِفَةٌ تَحَمُّلٌ':Added, #1: 1	صِفَةُ التَّحَالُفِ
u'صِفَةٌ تَحْوِيلٌ':Added, #2: 2	صِفَةِ تَحَمُّلِ
u'صِفَةٌ تَخْرِيجٌ':Added, #1: 1	صِفَةُ تَحْوِيلِ
u'صِفَةٌ تَخْفِيفٌ':Added, #1: 1	صِفَةُ تَخْرِيجِ
u'صِفَةٌ تَخْيِيرٌ':Added, #1: 1	صِفَةِ التَّخْفِيفِ
u'صِفَةٌ تَدْبِيرٌ':Added, #2: 2	صِفَةِ التَّخْيِيرِ
u'صِفَةٌ تُرَابٌ':Added, #1: 1	صِفَةِ التَّدْبِيرِ
u'صِفَةٌ تَرْتِيبٌ':Added, #1: 1	صِفَةَ التُّرَابِ
u'صِفَةٌ تَزْكِيَةٌ':Added, #3: 3	صِفَةُ التَّرْتِيبِ
u'صِفَةٌ تَسْلِيمٌ':Added, #1: 1	صِفَةُ التَّزْكِيَةِ
u'صِفَةٌ تَسْمِيَة':Added, #1: 1	صِفَةِ تَسْلِيمِ
u'صِفَةٌ تَسْمِيَة':Added, #1: 1	صِفَةُ التَّسْمِيَةِ
u'صِفَةٌ تَضْحِيَةٌ':Added, #1: 1	صِفَةِ التَّسْمِيَةِ
u'صِفَةٌ تَطْهِيرٌ':Added, #1: 1	صِفَةُ التَّضْحِيَةِ
u'صِفَةٌ تَطْهِيرٌ':Added, #1: 1	صِفَةُ التَّطْهِيرِ
u'صِفَةٌ تَعْدِيلٌ':Added, #1: 1	صِفَةِ التَّطْهِيرِ
u'صِفَةٌ تَعَمُّدٌ':Added, #1: 1	صِفَةَ التَّعْدِيلِ
u'صِفَةٌ تَعْمِيمٌ':Added, #2: 2	صِفَةَ التَّعَمُّدِ
u'صِفَةٌ تَعَوُّذٌ':Added, #1: 1	صِفَةِ التَّعْمِيمِ
u'صِفَةٌ تَغْلِيظٌ':Added, #1: 1	صِفَةِ التَّعَوُّذِ
u'صِفَةٌ تَغْلِيظٌ':Added, #1: 1	صِفَةَ التَّغْلِيظِ
u'صِفَةٌ تَغَيُّرٌ':Added, #4: 4	صِفَةِ التَّغْلِيظِ
u'صِفَةٌ تَقْديسٌ':Added, #1: 1	صِفَةُ تَغَيُّرِهِ
u'صِفَةٌ تَقْديمٌ':Added, #1: 1	صِفَةِ التّقْدِيسِ
u'صِفَةٌ تَقْسيطٌ':Added, #1: 1	صِفَةُ التَّقْدِيمِ
u'صِفَةٌ تَقْصيرٌ':Added, #1: 1	صِفَةُ التَّقْسِيطِ
u'صِفَةٌ تَقْصيرٌ':Added, #1: 1	صِفَةَ التَّقْصِيرِ
u'صِفَةٌ تَقْليدٌ':Added, #1: 1	صِفَةُ تَقْصِيرِ
u'صِفَةٌ تَقْليد':Added, #1: 1	صِفَةُ التَّقْلِيدِ
u'صِفَةٌ تَقَوُّمٌ':Added, #1: 1	صِفَةُ التَّقْلِيدِ
u'صِفَةٌ تَقْويمٌ':Added, #1: 1	صِفَةُ التَّقَوُّمِ
u'صِفَةٌ تَكْبيرٌ':Added, #1: 1	صِفَةِ تَقْوِيمِ
u'صِفَةٌ تَكْبيرٌ':Added, #1: 1	صِفَةِ التَّكْبِيرِ
u'صِفَةٌ تَكْليفٌ':Added, #1: 1	صِفَةِ تَكْبِيرِ
u'صِفَةٌ تَكْوينٌ':Added, #3: 3	صِفَةِ التَّكْلِيفِ
u'صِفَةٌ تَلْبيَةٌ':Added, #2: 2	صِفَةُ التَّكْوِينِ
u'صِفَةٌ تَلْبيَةٌ':Added, #2: 2	صِفَةُ التَّلْبِيَةِ
u'صِفَةٌ تَمَتُّعٌ':Added, #2: 2	صِفَةِ تَلْبِيَةِ
u'صِفَةٌ تَمْييزٌ':Added, #1: 1	صِفَةِ التَّمَتُّعِ
u'صِفَةٌ تَمْييزٌ':Added, #1: 1	صِفَةِ التَّمْيِيزِ
u'صِفَةٌ تَنْمِيَةٌ':Added, #1: 1	صِفَةِ تَمْيِيزٍ
u'صِفَةٌ تَوَسُّط':Added, #1: 1	صِفَةُ التَّنْمِيَةِ
u'صِفَةٌ تَيَمُّمٌ':Added, #1: 1	صِفَةِ التَّوَسُّطِ
u'صِفَةٌ تَيَمُّمٌ':Added, #1: 1	صِفَةَ التَّيَمُّمِ
u'صِفَةٌ تَيَمُّمٌ':Added, #1: 1	صِفَةُ التَّيَمُّمِ
u'صِفَةٌ ثُبُوتٌ':Added, #1: 1	صِفَةِ التَّيَمُّمِ
u'صِفَةٌ ثَمَنٌ':Added, #1: 1	صِفَةِ ثُبُوتِ
u'صِفَةٌ ثَمَن':Added, #11: 11	صِفَةِ الثَّمَنِ
u'صِفَةٌ ثَمَنٌ':Added, #1: 1	صِفَةُ الثَّمَنِيَّةِ
u'صِفَةٌ ثَوْبٌ':Added, #2: 2	صِفَةَ الثَّمَنِ
u'صِفَةٌ ثَوْبٌ':Added, #1: 1	صِفَةِ الثَّوْبِ
u'صِفَةٌ جَارِحٌ':Added, #1: 1	صِفَةِ ثَوْبٍ
u'صِفَةٌ جِذْعٌ':Added, #1: 1	صِفَةِ الْجَارِحِ
u'صِفَةٌ جَزَاءٌ':Added, #1: 1	صِفَةِ الْجِذْعِ
u'صِفَةٌ جلسة':Added, #1: 1	صِفَةُ جَزَاءٍ
u'صِفَةٌ جلسة':Added, #1: 1	صِفَةَ جِلْسَةِ
u'صِفَةٌ جِلْسَةٌ':Added, #1: 1	صِفَةِ جِلْسَةِ
u'صِفَةٌ جِلْسَةٌ':Added, #1: 1	صِفَةَ جِلْسَةِ
u'صِفَةٌ جُلُوسٌ':Added, #1: 1	صِفَةِ جِلْسَةِ
u'صِفَةٌ جَمَالٌ':Added, #1: 1	صِفَةِ الْجُلُوسِ
u'صِفَةٌ جمع':Added, #1: 1	صِفَةَ الْجَمَالِ
u'صِفَةٌ جَمْعٌ':Added, #2: 2	صِفَةِ الْجَمْعِ
u'صِفَةٌ جمع':Added, #2: 2	صِفَةِ الْجَمْعِ
u'صِفَةٌ جَمْعٌ':Added, #3: 3	صِفَةَ الْجَمْعِ
u'صِفَةٌ جَنَابَةٌ':Added, #3: 3	صِفَةَ الْجَمْعِ
u'صِفَةٌ جَنَابَةٌ':Added, #1: 1	صِفَةَ الْجَنَابَةِ
u'صِفَةٌ جَنَّةٌ':Added, #2: 2	صِفَةِ الْجَنَابَةِ
u'صِفَةٌ جَنَّةٌ':Added, #1: 1	صِفَةَ الْجَنَّةِ
u'صِفَةٌ جهر':Added, #9: 9	صِفَةِ الْجَنَّةِ
u'صِفَةٌ جَهْرٌ':Added, #1: 1	صِفَةِ الْجَهْرِ
u'صِفَةٌ جَوَابٌ':Added, #1: 1	صِفَةِ الْجَهْرِ
u'صِفَةٌ جَوَازٌ':Added, #2: 2	صِفَةِ جَوَابِهِ
u'صِفَةٌ جَوَازٌ':Added, #1: 1	صِفَةُ الْجَوَازِ
u'صِفَةٌ جَوَازٌ':Added, #3: 3	صِفَةَ الْجَوَازِ
u'صِفَةٌ جَوْدَةٌ':Added, #4: 4	صِفَةِ الْجَوَازِ
u'صِفَةٌ جَوْدَةٌ':Added, #1: 1	صِفَةَ الْجَوْدَةِ
u'صِفَةٌ جَوْدَةٌ':Added, #1: 1	صِفَةُ الْجَوْدَةِ
u'صِفَةٌ جَوْدَةٌ':Added, #1: 1	صِفَةِ جَوْدَتِهِ
u'صِفَةٌ حاجٌّ':Added, #3: 3	صِفَةِ الْجَوْدَةِ
u'صِفَةٌ حاكِمٌ':Added, #1: 1	صِفَةَ الْحَاجِّ
u'صِفَةٌ حَجٌّ':Added, #1: 1	صِفَةِ الْحَاكِمِ
u'صِفَةٌ حَجٌّ':Added, #18: 18	صِفَةِ الْحَجِّ
u'صِفَةٌ حَجٌّ':Added, #1: 1	صِفَةِ حَجِّهِ
u'صِفَةٌ حِجارَةٌ':Added, #4: 4	صِفَةِ حَجِّ
u'صِفَةٌ حَجَرِيٌّ':Added, #1: 1	صِفَةَ الْحِجَارَةِ
u'صِفَةٌ حَدٌّ':Added, #1: 1	صِفَةَ الْحَجَرِيَّةِ
u'صِفَةٌ حَدَثٌ':Added, #1: 1	صِفَةِ الْحَدِّ
u'صِفَةٌ حَدَث':Added, #1: 1	صِفَةِ الْحَدَثِ
u'صِفَةٌ حَرْبٌ':Added, #1: 1	صِفَةِ الْحَدَثِيَّةِ
u'صِفَةٌ حِرْزٌ':Added, #1: 1	صِفَةِ الْحَرْبِ
u'صِفَةٌ حُرْمَةٌ':Added, #1: 1	صِفَةُ الْحِرْزِ
u'صِفَةٌ حُرِّيَّةٌ':Added, #1: 1	صِفَةِ الْحُرْمَةِ
u'صِفَةٌ حُرِّيَّةٌ':Added, #1: 1	صِفَةُ الْحُرِّيَّةِ
u'صِفَةٌ حُسْنٌ':Added, #2: 2	صِفَةِ الْحُرِّيَّةِ
u'صِفَةٌ حُسْنٌ':Added, #1: 1	صِفَةِ الْحُسْنِ
u'صِفَةٌ حَسَنٌ':Added, #1: 1	صِفَةُ حُسْنٍ
u'صِفَةٌ حُسْنٌ':Added, #1: 1	صِفَةٍ حَسَنَةٍ
u'صِفَةٌ حَسَنَةٌ':Added, #2: 2	صِفَةَ حُسْنٍ
u'صِفَةٌ حَظْر':Added, #1: 1	صِفَةٍ حَسَنَةٍ
u'صِفَةٌ حَقٌّ':Added, #1: 1	صِفَةِ الْحَظْرِ
u'صِفَةٌ حَقِيقٌ':Added, #1: 1	صِفَةِ حَقِّهِ
u'صِفَةٌ حَقِيقَةٌ':Added, #1: 1	صِفَةِ الْحَقِيقَةِ
u'صِفَةٌ حَقِيقِيٌّ':Added, #1: 1	صِفَةِ الْحَقِيقَةِ
u'صِفَةٌ حُكْمٌ':Added, #1: 1	صِفَةٍ حَقِيقِيَّةٍ
u'صِفَةٌ حُكْمٌ':Added, #1: 1	صِفَةُ الْحُكْمِ
u'صِفَةٌ حُكْمٌ':Added, #1: 1	صِفَةِ الْحُكْمِ
u'صِفَةٌ حُكُومَةٌ':Added, #1: 1	صِفَةِ حُكْمِ
u'صِفَةٌ حِلٌّ':Added, #1: 1	صِفَةُ الْحُكُومَةِ
u'صِفَةٌ حِلٌّ':Added, #1: 1	صِفَةَ الْحِلِّ
u'صِفَةٌ حِلٌّ':Added, #2: 2	صِفَةُ الْحِلِّ
u'صِفَةٌ حُلُولٌ':Added, #8: 8	صِفَةِ الْحِلِّ
u'صِفَةٌ حُلُولٌ':Added, #1: 1	صِفَةِ الْحُلُولِ
u'صِفَةٌ حُلِيٌّ':Added, #2: 2	صِفَةَ الْحُلُولِ
u'صِفَةٌ حِنْطَةٌ':Added, #1: 1	صِفَةَ الْحُلِيِّ
u'صِفَةٌ حِنْطَةٌ':Added, #1: 1	صِفَةَ الْحِنْطَةِ
u'صِفَةٌ حَوْضٌ':Added, #2: 2	صِفَةِ حِنْطَةِ
u'صِفَةٌ حَيَاءٌ':Added, #5: 5	صِفَةِ الْحَوْضِ
u'صِفَةٌ حَيَاةٌ':Added, #2: 2	صِفَةِ الْحَيَاءِ
u'صِفَةٌ حَيْضٌ':Added, #1: 1	صِفَةِ الْحَيَاةِ
u'صِفَةٌ حَيْضٌ':Added, #1: 1	صِفَةُ الْحَيْضِ
u'صِفَةٌ خَاصَّةٌ':Added, #3: 3	صِفَةِ الْحَيْضِ
u'صِفَةٌ خُرُوجٌ':Added, #2: 2	صِفَةٍ خَاصَّةٍ
u'صِفَةٌ خُرُوجٌ':Added, #1: 1	صِفَةِ الْخُرُوجِ
u'صِفَةٌ خُرُوجٌ':Added, #1: 1	صِفَةَ خُرُوجِ
u'صِفَةٌ خُرُوجٌ':Added, #1: 1	صِفَةِ خُرُوجِ
u'صِفَةٌ خَطَأٌ':Added, #1: 1	صِفَةِ خُرُوجِهِ
u'صِفَةٌ خِلاَفٌ':Added, #1: 1	صِفَةِ الْخَطَأِ
u'صِفَةٌ خُلَفَاءُ':Added, #1: 1	صِفَةِ خِلَافِهِ
u'صِفَةٌ خَمْرِيٌّ':Added, #1: 1	صِفَةَ الْخُلَفَاءِ
u'صِفَةٌ خَمْرِيٌّ':Added, #1: 1	صِفَةَ الْخَمْرِيَّةِ
u'صِفَةٌ خَوَاتِمُ':Added, #3: 3	صِفَةِ الْخَمْرِيَّةِ
u'صِفَةٌ خوارج':Added, #2: 2	صِفَةِ خَوَاتِمِ
u'صِفَةٌ خَوَارِجُ':Added, #1: 1	صِفَةَ الْخَوَارِجِ
u'صِفَةٌ خَيْرٌ':Added, #1: 1	صِفَةَ الْخَوَارِجِ
u'صِفَةٌ خَيْرِيٌّ':Added, #1: 1	صِفَةٍ خَيْرٍ
u'صِفَةٌ دِبَاغَةٌ':Added, #1: 1	صِفَةُ الْخَيْرِيَّةِ
u'صِفَةٌ دَجَّالٌ':Added, #1: 1	صِفَةَ الدِّبَاغَةِ
u'صِفَةٌ دَجَّالٌ':Added, #1: 1	صِفَةِ الدّجّالِ
u'صِفَةٌ دُخُولٌ':Added, #1: 1	صِفَةِ الدَّجَّالِ
u'صِفَةٌ دَرَاهِمُ':Added, #1: 1	صِفَةِ الدُّخُولِ
u'صِفَةٌ دَرَاهِمُ':Added, #1: 1	صِفَةُ الدَّرَاهِمِ
u'صِفَةٌ دُرُوعٌ':Added, #1: 1	صِفَةِ الدَّرَاهِمِ
u'صِفَةٌ دَمٌ':Added, #1: 1	صِفَةِ الدّرُوعِ
u'صِفَةٌ دِماءٌ':Added, #1: 1	صِفَةِ دَمِ
u'صِفَةٌ دَمَوِيٌّ':Added, #1: 1	صِفَةِ الدِّمَاءِ
u'صِفَةٌ دَيْنٌ':Added, #1: 1	صِفَةِ الدَّمَوِيَّةِ
u'صِفَةٌ دَيْنٌ':Added, #1: 1	صِفَةُ الدَّيْنِ
u'صِفَةٌ ذاتِيٌّ':Added, #2: 2	صِفَةِ الدَّيْنِ
u'صِفَةٌ ذَكاةٌ':Added, #1: 1	صِفَةٍ ذَاتِيَّةٍ
u'صِفَةٌ ذكر':Added, #1: 1	صِفَةَ الذَّكَاةِ
u'صِفَةٌ ذِكْرٌ':Added, #1: 1	صِفَةَ الذِّكْرِ
u'صِفَةٌ ذُكورَةٌ':Added, #1: 1	صِفَةَ الذِّكْرِ
u'صِفَةٌ ذُكورَةٌ':Added, #2: 2	صِفَةُ الذُّكُورَةِ
u'صِفَةٌ ذَمٌّ':Added, #2: 2	صِفَةِ الذُّكُورَةِ
u'صِفَةٌ ذَهَبِيٌّ':Added, #2: 2	صِفَةُ ذَمٍّ
u'صِفَةٌ رَأْسٌ':Added, #1: 1	صِفَةَ الذَّهَبِيَّةِ
u'صِفَةٌ راغِب':Added, #4: 4	صِفَةِ رَأْسِ
u'صِفَةٌ رَاهِبٌ':Added, #1: 1	صِفَةُ الرَّاغِبِ
u'صِفَةٌ رجعة':Added, #1: 1	صِفَةُ الرَّاهِبِ
u'صِفَةٌ رَجْعَةٌ':Added, #1: 1	صِفَةَ الرَّجْعَةِ
u'صِفَةٌ رُجُوعٌ':Added, #1: 1	صِفَةَ الرَّجْعَةِ
u'صِفَةٌ رَدٌّ':Added, #1: 1	صِفَةِ رُجُوعِ
u'صِفَةٌ رَسُولٌ':Added, #1: 1	صِفَةُ الرَّدِّ
u'صِفَةٌ رَسُولٌ':Added, #2: 2	صِفَةُ رَسُولِ
u'صِفَةٌ رُطوبَةٌ':Added, #5: 5	صِفَةِ رَسُولِ
u'صِفَةٌ رِقٌّ':Added, #2: 2	صِفَةَ الرُّطُوبَةِ
u'صِفَةٌ رُقْيَةٌ':Added, #1: 1	صِفَةِ الرِّقِّ
u'صِفَةٌ رُقْيَةٌ':Added, #1: 1	صِفَةِ الرُّقْيَةِ
u'صِفَةٌ رُكْنٌ':Added, #1: 1	صِفَةُ رُقْيَةِ
u'صِفَةٌ رُكْن':Added, #1: 1	صِفَةُ الرُّكْنِ
u'صِفَةٌ رُكْن':Added, #1: 1	صِفَةُ الرُّكْنِ
u'صِفَةٌ رُكْنِيّ':Added, #1: 1	صِفَةِ الرُّكْنِيَّةِ
u'صِفَةٌ رُكوعٌ':Added, #1: 1	صِفَةِ الرُّكْنِيَّةِ
u'صِفَةٌ رُكوعٌ':Added, #1: 1	صِفَةِ رُكُوعِ
u'صِفَةٌ زائِدٌ':Added, #3: 3	صِفَةِ الرُّكُوعِ
u'صِفَةٌ زَكاةٌ':Added, #2: 2	صِفَةٍ زَائِدَةٍ
u'صِفَةٌ زَوْجَةٌ':Added, #1: 1	صِفَةِ الزَّكَاةِ
u'صِفَةٌ زِيادَةٌ':Added, #1: 1	صِفَةُ زَوْجَةٍ
u'صِفَةٌ سَامِعٌ':Added, #1: 1	صِفَةِ زِيَادَةٍ
u'صِفَةٌ سَبَبٌ':Added, #1: 1	صِفَةُ السَّامِعِ
u'صِفَةٌ سَبْقٌ':Added, #1: 1	صِفَةِ السَّبَبِ
u'صِفَةٌ سِجِلٌّ':Added, #2: 2	صِفَةُ السَّبْقِ
u'صِفَةٌ سُجُودٌ':Added, #3: 3	صِفَةِ السِّجِلِّ
u'صِفَةٌ سِدْرٌ':Added, #4: 4	صِفَةِ السُّجُودِ
u'صِفَةٌ سَرقَةٌ':Added, #1: 1	صِفَةُ السِّدْرِ
u'صِفَةٌ سَرِقَةٌ':Added, #1: 1	صِفَةُ السَّرِقَةِ
u'صِفَةٌ سُكُونٌ':Added, #1: 1	صِفَةُ السَّرِقَةِ
u'صِفَةٌ سُكُونٌ':Added, #1: 1	صِفَةُ السُّكُونِ
u'صِفَةٌ سلام':Added, #1: 1	صِفَةِ السُّكُونِ
u'صِفَةٌ سَلاَمٌ':Added, #1: 1	صِفَةُ سَلَامِهِ
u'صِفَةٌ سلام':Added, #1: 1	صِفَةُ سَلَامِهِ
u'صِفَةٌ سَلاَمٌ':Added, #2: 2	صِفَةِ السَّلَامِ
u'صِفَةٌ سَلاَمَةٌ':Added, #2: 2	صِفَةِ السَّلَامِ
u'صِفَةٌ سَلاَمَةٌ':Added, #1: 1	صِفَةُ السَّلَامَةِ
u'صِفَةٌ سَلاَمَةٌ':Added, #2: 2	صِفَةَ السَّلَامَةِ
u'صِفَةٌ سِلْعَةٌ':Added, #5: 5	صِفَةِ السَّلَامَةِ
u'صِفَةٌ سِلْعَةٌ':Added, #1: 1	صِفَةُ السِّلْعَةِ
u'صِفَةٌ سَلَمٌ':Added, #1: 1	صِفَةِ السِّلْعَةِ
u'صِفَةٌ سَلَمٌ':Added, #1: 1	صِفَةِ سَلَمٍ
u'صِفَةٌ سُنَّةٌ':Added, #2: 2	صِفَةِ السَّلَمِ
u'صِفَةٌ سُنَّةٌ':Added, #1: 1	صِفَةُ السُّنَّةِ
u'صِفَةٌ سُؤَالٌ':Added, #1: 1	صِفَةِ سُنَّةٍ
u'صِفَةٌ سَوْطٌ':Added, #2: 2	صِفَةَ السُّؤَالِ
u'صِفَةٌ سَيْفٌ':Added, #2: 2	صِفَةِ السَّوْطِ
u'صِفَةٌ شَابٌّ':Added, #1: 1	صِفَةِ السَّيْفِ
u'صِفَةٌ شَاهِدٌ':Added, #1: 1	صِفَةَ الشَّابِّ
u'صِفَةٌ شَاهِدٌ':Added, #1: 1	صِفَةُ الشَّاهِدِ
u'صِفَةٌ شَدٌّ':Added, #1: 1	صِفَةِ الشَّاهِدِ
u'صِفَةٌ شَرْحٌ':Added, #1: 1	صِفَةُ شَدِّهِ
u'صِفَةٌ شَرْطٌ':Added, #1: 1	صِفَةَ شَرْحٍ
u'صِفَةٌ شَرْعِيٌّ':Added, #1: 1	صِفَةِ شَرْطِهِ
u'صِفَةٌ شَرْعِيٌّ':Added, #1: 1	صِفَةِ شَرْعِيَّةِ
u'صِفَةٌ شَهَادَةٌ':Added, #2: 2	صِفَةٍ شَرْعِيَّةٍ
u'صِفَةٌ شَهَادَةٌ':Added, #2: 2	صِفَةِ الشَّهَادَةِ
u'صِفَةٌ شهداء':Added, #3: 3	صِفَةُ الشَّهَادَةِ
u'صِفَةٌ شُهُودٌ':Added, #1: 1	صِفَةِ الشُّهَدَاءِ
u'صِفَةٌ شَيْءٌ':Added, #1: 1	صِفَةَ الشُّهُودِ
u'صِفَةٌ شَيْءٌ':Added, #2: 2	صِفَةُ الشَّيْءِ
u'صِفَةٌ صَاحِبٌ':Added, #3: 3	صِفَةِ الشَّيْءِ
u'صِفَةٌ صَائِدٌ':Added, #1: 1	صِفَةُ صَاحِبِهِ
u'صِفَةٌ صِحَّةٌ':Added, #1: 1	صِفَةِ الصَّائِدِ
u'صِفَةٌ صَحِيحٌ':Added, #3: 3	صِفَةِ الصِّحَّةِ
u'صِفَةٌ صدقة':Added, #1: 1	صِفَةِ الصَّحِيحَةِ
u'صِفَةٌ صَدَقَةٌ':Added, #2: 2	صِفَةِ الصَّدَقَةِ
u'صِفَةٌ صَدِيقٌ':Added, #2: 2	صِفَةِ الصَّدَقَةِ
u'صِفَةٌ صِرَاطٌ':Added, #1: 1	صِفَةُ الصَّدِيقِ
u'صِفَةٌ صِغَرٌ':Added, #1: 1	صِفَةِ الصّرَاطِ
u'صِفَةٌ صِغَرٌ':Added, #1: 1	صِفَةِ الصِّغَرِ
u'صِفَةٌ صِغَرٌ':Added, #2: 2	صِفَةَ الصِّغَرِ
u'صِفَةٌ صِفَةٌ':Added, #2: 2	صِفَةُ الصِّغَرِ
u'صِفَةٌ صَلاَةٌ':Added, #1: 1	صِفَةَ الصِّفَةِ
u'صِفَةٌ صَلاَةٌ':Added, #115: 115	صِفَةِ الصَّلَاةِ
u'صِفَةٌ صَلاَةٌ':Added, #19: 19	صِفَةِ صَلَاةِ
u'صِفَةٌ صَلاَةٌ':Added, #1: 1	صِفَةِ صَلاَتِهِ
u'صِفَةٌ صَلاَةٌ':Added, #2: 2	صِفَةُ الصَّلَاةِ
u'صِفَةٌ صَلاَةٌ':Added, #2: 2	صِفَةِ الصَّلاَةِ
u'صِفَةٌ صَلاَةٌ':Added, #3: 3	صِفَةَ الصَّلَاةِ
u'صِفَةٌ صَلاَةٌ':Added, #3: 3	صِفَةَ صَلَاةِ
u'صِفَةٌ صَلاَةٌ':Added, #3: 3	صِفَةُ صَلَاةِ
u'صِفَةٌ صَلاَةٌ':Added, #4: 4	صِفَةِ صَلَاتِهِ
u'صِفَةٌ صَلاَحٌ':Added, #5: 5	صِفَةِ صَلاَةِ
u'صِفَةٌ صَلاَحٌ':Added, #1: 1	صِفَةُ الصَّلَاحِ
u'صِفَةٌ صَوْمٌ':Added, #2: 2	صِفَةِ الصَّلَاحِ
u'صِفَةٌ صَيْدٌ':Added, #1: 1	صِفَةُ الصَّوْمِ
u'صِفَةٌ صَيْدٌ':Added, #1: 1	صِفَةُ الصَّيْدِ
u'صِفَةٌ ضَرْبٌ':Added, #1: 1	صِفَةِ الصَّيْدِ
u'صِفَةٌ ضَرْبٌ':Added, #1: 1	صِفَةِ الضَّرْبِ
u'صِفَةٌ طَاهِرٌ':Added, #3: 3	صِفَةُ الضَّرْبِ
u'صِفَةٌ طَبْخٌ':Added, #1: 1	صِفَةِ الطَّاهِرِ
u'صِفَةٌ طَلاَقٌ':Added, #2: 2	صِفَةُ طَبْخِهِ
u'صِفَةٌ طَلاَقٌ':Added, #1: 1	صِفَةَ الطَّلَاقِ
u'صِفَةٌ طلب':Added, #2: 2	صِفَةُ الطَّلَاقِ
u'صِفَةٌ طَلَبٌ':Added, #1: 1	صِفَةُ الطَّلَبِ
u'صِفَةٌ طَهَارَةٌ':Added, #1: 1	صِفَةُ الطَّلَبِ
u'صِفَةٌ طَهارَة':Added, #1: 1	صِفَةُ طَهَارَةِ
u'صِفَةٌ طَهَارَةٌ':Added, #1: 1	صِفَةٍ طَهَارِيَّةٍ
u'صِفَةٌ طَهَارَةٌ':Added, #3: 3	صِفَةُ الطَّهَارَةِ
u'صِفَةٌ طَهُورٌ':Added, #3: 3	صِفَةِ الطَّهَارَةِ
u'صِفَةٌ طَهُور':Added, #1: 1	صِفَةِ الطَّهُورِ
u'صِفَةٌ طَوَاعِيَةٌ':Added, #1: 1	صِفَةَ الطَّهُورِيَّةِ
u'صِفَةٌ طواف':Added, #1: 1	صِفَةَ الطَّوَاعِيَةِ
u'صِفَةٌ طَوَافٌ':Added, #1: 1	صِفَةُ الطَّوَافِ
u'صِفَةٌ طواف':Added, #1: 1	صِفَةُ الطَّوَافِ
u'صِفَةٌ طَوَافٌ':Added, #1: 1	صِفَةَ طَوَافِ
u'صِفَةٌ طُولٌ':Added, #1: 1	صِفَةَ طَوَافِ
u'صِفَةٌ ظاهِرٌ':Added, #3: 3	صِفَةِ طُولِهِ
u'صِفَةٌ ظاهِرَة':Added, #1: 1	صِفَةٍ ظَاهِرَةٍ
u'صِفَةٌ عَاقِلٌ':Added, #1: 1	صِفَةٍ ظَاهِرَةٍ
u'صِفَةٌ عَامِرٌ':Added, #2: 2	صِفَةِ الْعَاقِلَةِ
u'صِفَةٌ عِبَادَةٌ':Added, #1: 1	صِفَةِ عَامِرٍ
u'صِفَةٌ عِبَادَةٌ':Added, #1: 1	صِفَةَ الْعِبَادَةِ
u'صِفَةٌ عِبَادَةٌ':Added, #1: 1	صِفَةُ الْعِبَادَةِ
u'صِفَةٌ عِبَارَةٌ':Added, #2: 2	صِفَةِ الْعِبَادَةِ
u'صِفَةٌ عتق':Added, #1: 1	صِفَةِ الْعِبَارَةِ
u'صِفَةٌ عتق':Added, #1: 1	صِفَةَ الْعِتْقِ
u'صِفَةٌ عِتْقٌ':Added, #1: 1	صِفَةُ الْعِتْقِ
u'صِفَةٌ عِتْقٌ':Added, #1: 1	صِفَةَ الْعِتْقِ
u'صِفَةٌ عَجَاجٌ':Added, #1: 1	صِفَةُ الْعِتْقِ
u'صِفَةٌ عجز':Added, #1: 1	صِفَةِ الْعَجَاجِ
u'صِفَةٌ عَجْزٌ':Added, #1: 1	صِفَةِ الْعَجْزِ
u'صِفَةٌ عَدَالَةٌ':Added, #1: 1	صِفَةِ الْعَجْزِ
u'صِفَةٌ عُدْوَانِيٌّ':Added, #2: 2	صِفَةِ الْعَدَالَةِ
u'صِفَةٌ عُذْرَةٌ':Added, #1: 1	صِفَةِ الْعُدْوَانِيَّةِ
u'صِفَةٌ عُذْرَةٌ':Added, #1: 1	صِفَةَ الْعُذْرَةِ
u'صِفَةٌ عَرْضٌ':Added, #1: 1	صِفَةِ الْعُذْرَةِ
u'صِفَةٌ عَرْضٌ':Added, #1: 1	صِفَةَ الْعَرْضِ
u'صِفَةٌ عِزٌّ':Added, #2: 2	صِفَةِ الْعَرْضِ
u'صِفَةٌ عَقَارٌ':Added, #1: 1	صِفَةَ الْعِزِّ
u'صِفَةٌ عَقْدٌ':Added, #1: 1	صِفَةُ عَقَارٍ
u'صِفَةٌ عَقْدٌ':Added, #1: 1	صِفَةُ عَقْدِ
u'صِفَةٌ عَقْدٌ':Added, #1: 1	صِفَةِ عَقْدٍ
u'صِفَةٌ عَقْدٌ':Added, #2: 2	صِفَةِ عَقْدِ
u'صِفَةٌ عَقْدٌ':Added, #3: 3	صِفَةُ الْعَقْدِ
u'صِفَةٌ عُقُوبَةٌ':Added, #3: 3	صِفَةِ الْعَقْدِ
u'صِفَةٌ عُقُوبَةٌ':Added, #1: 1	صِفَةُ الْعُقُوبَةِ
u'صِفَةٌ عِلَّةٌ':Added, #2: 2	صِفَةَ الْعُقُوبَةِ
u'صِفَةٌ عِلَّةٌ':Added, #1: 1	صِفَةَ الْعِلَّةِ
u'صِفَةٌ عِلَّةٌ':Added, #1: 1	صِفَةِ الْعِلَّةِ
u'صِفَةٌ علم':Added, #1: 1	صِفَةِ عِلَّةٍ
u'صِفَةٌ علم':Added, #2: 2	صِفَةُ الْعِلْمِ
u'صِفَةٌ عِلْمٌ':Added, #2: 2	صِفَةِ الْعِلْمِ
u'صِفَةٌ عِلْمٌ':Added, #2: 2	صِفَةُ الْعِلْمِ
u'صِفَةٌ علم':Added, #2: 2	صِفَةِ الْعِلْمِ
u'صِفَةٌ عِلْمٌ':Added, #3: 3	صِفَةَ الْعِلْمِ
u'صِفَةٌ عَمْدٌ':Added, #3: 3	صِفَةَ الْعِلْمِ
u'صِفَةٌ عَمْد':Added, #1: 1	صِفَةَ الْعَمْدِ
u'صِفَةٌ عَمْد':Added, #1: 1	صِفَةَ الْعَمْدِيَّةِ
u'صِفَةٌ عَمْدٌ':Added, #1: 1	صِفَةِ الْعَمْدِيَّةِ
u'صِفَةٌ عَمْدِيّ':Added, #2: 2	صِفَةِ الْعَمْدِ
u'صِفَةٌ عَمْدِيّ':Added, #1: 1	صِفَةَ الْعَمْدِيَّةِ
u'صِفَةٌ عمرة':Added, #1: 1	صِفَةِ الْعَمْدِيَّةِ
u'صِفَةٌ عُمْرَةٌ':Added, #3: 3	صِفَةِ الْعُمْرَةِ
u'صِفَةٌ عَمَلٌ':Added, #3: 3	صِفَةِ الْعُمْرَةِ
u'صِفَةٌ عَمَلٌ':Added, #1: 1	صِفَةُ الْعَمَلِ
u'صِفَةٌ عَمَلٌ':Added, #1: 1	صِفَةِ عَمَلِهِ
u'صِفَةٌ عَمَلٌ':Added, #3: 3	صِفَةَ الْعَمَلِ
u'صِفَةٌ عُمُومٌ':Added, #7: 7	صِفَةِ الْعَمَلِ
u'صِفَةٌ عِوَضٌ':Added, #2: 2	صِفَةِ الْعُمُومِ
u'صِفَةٌ عين':Added, #1: 1	صِفَةُ الْعِوَضَيْنِ
u'صِفَةٌ عَيْنٌ':Added, #1: 1	صِفَةُ الْعَيْنِ
u'صِفَةٌ عَيْن':Added, #1: 1	صِفَةُ الْعَيْنِ
u'صِفَةٌ عَيْنٌ':Added, #1: 1	صِفَةُ الْعَيْنِ
u'صِفَةٌ عَيْن':Added, #1: 1	صِفَةَ عَيْنٍ
u'صِفَةٌ عين':Added, #1: 1	صِفَةَ عَيْنٍ
u'صِفَةٌ عَيْنٌ':Added, #2: 2	صِفَةِ الْعَيْنِ
u'صِفَةٌ عَيْن':Added, #2: 2	صِفَةِ الْعَيْنِ
u'صِفَةٌ غُرَّةٌ':Added, #2: 2	صِفَةِ الْعَيْنِ
u'صِفَةٌ غُسْلٌ':Added, #1: 1	صِفَةِ الْغُرَّةِ
u'صِفَةٌ غُسْلٌ':Added, #11: 11	صِفَةِ الْغُسْلِ
u'صِفَةٌ غُسْلٌ':Added, #1: 1	صِفَةَ الْغُسْلِ
u'صِفَةٌ غَسْلٌ':Added, #1: 1	صِفَةُ غُسْلِ
u'صِفَةٌ غُسْلٌ':Added, #1: 1	صِفَةِ غَسْلِهِ
u'صِفَةٌ غُسْلٌ':Added, #1: 1	صِفَةِ غُسْلِهِ
u'صِفَةٌ غناء':Added, #2: 2	صِفَةُ الْغُسْلِ
u'صِفَةٌ غِنَاءٌ':Added, #1: 1	صِفَةُ الْغِنَاءِ
u'صِفَةٌ غَنَمٌ':Added, #1: 1	صِفَةُ الْغِنَاءِ
u'صِفَةٌ غَنِيٌّ':Added, #1: 1	صِفَةِ غَنَمِهِ
u'صِفَةٌ غير':Added, #1: 1	صِفَةِ الْغَنِيِّ
u'صِفَةٌ غَيْرٌ':Added, #1: 1	صِفَةِ غَيْرِهِ
u'صِفَةٌ فَاعِلٌ':Added, #1: 1	صِفَةِ غَيْرِهِ
u'صِفَةٌ فَرْدٌ':Added, #1: 1	صِفَةُ الْفَاعِلِ
u'صِفَةٌ فَرْدٌ':Added, #1: 1	صِفَةُ الْفَرْدِيَّةِ
u'صِفَةٌ فَرْدِيٌّ':Added, #1: 1	صِفَةِ الْفَرْدِيَّةِ
u'صِفَةٌ فَرْدِيٌّ':Added, #1: 1	صِفَةُ الْفَرْدِيَّةِ
u'صِفَةٌ فَرْدِيَّةٌ':Added, #1: 1	صِفَةِ الْفَرْدِيَّةِ
u'صِفَةٌ فَرْدِيَّةٌ':Added, #1: 1	صِفَةُ الْفَرْدِيَّةِ
u'صِفَةٌ فَرْض':Added, #1: 1	صِفَةِ الْفَرْدِيَّةِ
u'صِفَةٌ فَرْضٌ':Added, #1: 1	صِفَةُ الْفَرْضِيَّةِ
u'صِفَةٌ فَرْض':Added, #2: 2	صِفَةَ الْفَرْضِ
u'صِفَةٌ فَرْض':Added, #2: 2	صِفَةَ الْفَرْضِيَّةِ
u'صِفَةٌ فَرْضِيّ':Added, #2: 2	صِفَةِ الْفَرْضِيَّةِ
u'صِفَةٌ فَرْضِيّ':Added, #1: 1	صِفَةُ الْفَرْضِيَّةِ
u'صِفَةٌ فَرْضِيّ':Added, #2: 2	صِفَةَ الْفَرْضِيَّةِ
u'صِفَةٌ فَرْضِيَّة':Added, #2: 2	صِفَةِ الْفَرْضِيَّةِ
u'صِفَةٌ فَرْضِيَّة':Added, #1: 1	صِفَةُ الْفَرْضِيَّةِ
u'صِفَةٌ فَرْضِيَّة':Added, #2: 2	صِفَةَ الْفَرْضِيَّةِ
u'صِفَةٌ فُرْقَةٌ':Added, #2: 2	صِفَةِ الْفَرْضِيَّةِ
u'صِفَةٌ فَرِيضَةٌ':Added, #1: 1	صِفَةَ الْفُرْقَةِ
u'صِفَةٌ فَرِيضَةٌ':Added, #1: 1	صِفَةُ الْفَرِيضَةِ
u'صِفَةٌ فساد':Added, #2: 2	صِفَةَ الْفَرِيضَةِ
u'صِفَةٌ فساد':Added, #2: 2	صِفَةَ الْفَسَادِ
u'صِفَةٌ فَسَادٌ':Added, #2: 2	صِفَةِ الْفَسَادِ
u'صِفَةٌ فَسَادٌ':Added, #2: 2	صِفَةَ الْفَسَادِ
u'صِفَةٌ فَضْلٌ':Added, #2: 2	صِفَةِ الْفَسَادِ
u'صِفَةٌ فِعْلٌ':Added, #1: 1	صِفَةِ الْفَضْلِ
u'صِفَةٌ فِعْلٌ':Added, #1: 1	صِفَةُ فِعْلِ
u'صِفَةٌ فِعْلٌ':Added, #1: 1	صِفَةِ فِعْلِ
u'صِفَةٌ فِعْلٌ':Added, #2: 2	صِفَةُ فِعْلٍ
u'صِفَةٌ فِعْلٌ':Added, #2: 2	صِفَةِ فِعْلٍ
u'صِفَةٌ فِعْلٌ':Added, #2: 2	صِفَةُ فِعْلِهِ
u'صِفَةٌ فِعْلٌ':Added, #4: 4	صِفَةِ الْفِعْلِ
u'صِفَةٌ فقر':Added, #8: 8	صِفَةُ الْفِعْلِ
u'صِفَةٌ فَقْرٌ':Added, #1: 1	صِفَةِ الْفَقْرِ
u'صِفَةٌ فقراء':Added, #1: 1	صِفَةِ الْفَقْرِ
u'صِفَةٌ فلان':Added, #1: 1	صِفَةِ الْفُقَرَاءِ
u'صِفَةٌ فلان':Added, #1: 1	صِفَةُ الرَّاغِبِ
u'صِفَةٌ فلان':Added, #1: 1	صِفَةِ الرُّكْنِيَّةِ
u'صِفَةٌ فلان':Added, #1: 1	صِفَةِ الزّبَيْرِ
u'صِفَةٌ فلان':Added, #1: 1	صِفَةُ الْمَمْلُوكِيَّةِ
u'صِفَةٌ فِيلٌ':Added, #2: 2	صِفَةِ الْمَمْلُوكِيَّةِ
u'صِفَةٌ فَيْئَةٌ':Added, #1: 1	صِفَةِ الْفِيلِ
u'صِفَةٌ قُبْحٌ':Added, #1: 1	صِفَةِ الْفَيْئَةِ
u'صِفَةٌ قُبْحٌ':Added, #1: 1	صِفَةَ الْقُبْحِ
u'صِفَةٌ قُبْحٌ':Added, #1: 1	صِفَةُ الْقُبْحِ
u'صِفَةٌ قَبْضٌ':Added, #1: 1	صِفَةِ الْقُبْحِ
u'صِفَةٌ قَبْضٌ':Added, #1: 1	صِفَةُ الْقَبْضِ
u'صِفَةٌ قَبُولٌ':Added, #1: 1	صِفَةُ قَبْضِ
u'صِفَةٌ قتل':Added, #1: 1	صِفَةُ قَبُولِهِ
u'صِفَةٌ قَتْلٌ':Added, #1: 1	صِفَةِ الْقَتْلِ
u'صِفَةٌ قتل':Added, #1: 1	صِفَةِ الْقَتْلِ
u'صِفَةٌ قَتْلٌ':Added, #1: 1	صِفَةِ قَتْلِ
u'صِفَةٌ قتل':Added, #1: 1	صِفَةِ قَتْلِ
u'صِفَةٌ قَتْلٌ':Added, #1: 1	صِفَةُ قَتْلِهِ
u'صِفَةٌ قتل':Added, #1: 1	صِفَةُ قَتْلِهِ
u'صِفَةٌ قَتْلٌ':Added, #2: 2	صِفَةَ الْقَتْلِ
u'صِفَةٌ قدرة':Added, #2: 2	صِفَةَ الْقَتْلِ
u'صِفَةٌ قُدْرَةٌ':Added, #2: 2	صِفَةِ الْقُدْرَةِ
u'صِفَةٌ قِرَاءةٌ':Added, #2: 2	صِفَةِ الْقُدْرَةِ
u'صِفَةٌ قِرَاءةٌ':Added, #1: 1	صِفَةَ الْقِرَاءَةِ
u'صِفَةٌ قِرَاءةٌ':Added, #2: 2	صِفَةُ الْقِرَاءَةِ
u'صِفَةٌ قُرْآنٌ':Added, #3: 3	صِفَةِ الْقِرَاءَةِ
u'صِفَةٌ قِرَانٌ':Added, #1: 1	صِفَةَ الْقُرْآنِ
u'صِفَةٌ قُرْبَةٌ':Added, #4: 4	صِفَةِ الْقِرَانِ
u'صِفَةٌ قُرْبَةٌ':Added, #1: 1	صِفَةُ الْقُرْبَةِ
u'صِفَةٌ قُرْبَةٌ':Added, #1: 1	صِفَةِ الْقُرْبَةِ
u'صِفَةٌ قَسام':Added, #2: 2	صِفَةَ الْقُرْبَةِ
u'صِفَةٌ قَسام':Added, #1: 1	صِفَةَ الْقَسَامَةِ
u'صِفَةٌ قَسامَة':Added, #1: 1	صِفَةُ الْقَسَامَةِ
u'صِفَةٌ قَسامَة':Added, #1: 1	صِفَةَ الْقَسَامَةِ
u'صِفَةٌ قَسْمٌ':Added, #1: 1	صِفَةُ الْقَسَامَةِ
u'صِفَةٌ قسمة':Added, #1: 1	صِفَةِ قَسْمِ
u'صِفَةٌ قِسْمَةٌ':Added, #1: 1	صِفَةَ قِسْمَةِ
u'صِفَةٌ قسمة':Added, #1: 1	صِفَةَ قِسْمَةِ
u'صِفَةٌ قِسْمَةٌ':Added, #2: 2	صِفَةُ الْقِسْمَةِ
u'صِفَةٌ قُصُورٌ':Added, #2: 2	صِفَةُ الْقِسْمَةِ
u'صِفَةٌ قَضَاءٌ':Added, #1: 1	صِفَةُ قُصُورٍ
u'صِفَةٌ قضاة':Added, #1: 1	صِفَةِ قَضَاءِ
u'صِفَةٌ قضاة':Added, #1: 1	صِفَةَ الْقُضَاةِ
u'صِفَةٌ قُعُودٌ':Added, #5: 5	صِفَةُ الْقُضَاةِ
u'صِفَةٌ قُعُودٌ':Added, #1: 1	صِفَةَ الْقُعُودِ
u'صِفَةٌ قُعُودٌ':Added, #1: 1	صِفَةُ الْقُعُودِ
u'صِفَةٌ قَمْحٌ':Added, #2: 2	صِفَةِ الْقُعُودِ
u'صِفَةٌ قيام':Added, #1: 1	صِفَةِ الْقَمْحِ
u'صِفَةٌ قِيَامٌ':Added, #1: 1	صِفَةِ الْقِيَامِ
u'صِفَةٌ قيام':Added, #1: 1	صِفَةِ الْقِيَامِ
u'صِفَةٌ قِيَامٌ':Added, #1: 1	صِفَةِ قِيَامِ
u'صِفَةٌ قِيمَةٌ':Added, #1: 1	صِفَةِ قِيَامِ
u'صِفَةٌ كَافِرٌ':Added, #1: 1	صِفَةِ الْقِيمَةِ
u'صِفَةٌ كَامِلٌ':Added, #1: 1	صِفَةُ الْكَافِرِ
u'صِفَةٌ كَبْشٌ':Added, #2: 2	صِفَةٍ كَامِلَةٍ
u'صِفَةٌ كِتاب':Added, #1: 1	صِفَةُ الْكَبْشِ
u'صِفَةٌ كِتابَة':Added, #1: 1	صِفَةِ الْكِتَابِيَّةِ
u'صِفَةٌ كِتابِيّ':Added, #1: 1	صِفَةِ الْكِتَابِيَّةِ
u'صِفَةٌ كَثْرَةٌ':Added, #1: 1	صِفَةِ الْكِتَابِيَّةِ
u'صِفَةٌ كَرَاهَةٌ':Added, #1: 1	صِفَةُ الْكَثْرَةِ
u'صِفَةٌ كَرَاهَةٌ':Added, #1: 1	صِفَةُ الْكَرَاهَةِ
u'صِفَةٌ كَسْلاَن':Added, #4: 4	صِفَةِ الْكَرَاهَةِ
u'صِفَةٌ كَفٌّ':Added, #1: 1	صِفَةُ الْكَسْلَانِ
u'صِفَةٌ كُفَّارٌ':Added, #1: 1	صِفَةِ الْكَفِّ
u'صِفَةٌ كَفَّارٌ':Added, #1: 1	صِفَةُ الْكُفَّارِ
u'صِفَةٌ كَفَّارَةٌ':Added, #1: 1	صِفَةِ الْكَفَّارَةِ
u'صِفَةٌ كفر':Added, #1: 1	صِفَةِ الْكَفَّارَةِ
u'صِفَةٌ كُفْرٌ':Added, #1: 1	صِفَةِ الْكُفْرِ
u'صِفَةٌ كَلاَمٌ':Added, #1: 1	صِفَةِ الْكُفْرِ
u'صِفَةٌ كَلاَمٌ':Added, #1: 1	صِفَةَ الْكَلَامِ
u'صِفَةٌ كَلاَمٌ':Added, #1: 1	صِفَةِ الْكَلَامِ
u'صِفَةٌ كَمَالٌ':Added, #2: 2	صِفَةُ الْكَلَامِ
u'صِفَةٌ كَمَالٌ':Added, #13: 13	صِفَةِ الْكَمَالِ
u'صِفَةٌ كَمَالٌ':Added, #1: 1	صِفَةِ كَمَالٍ
u'صِفَةٌ كَمَالٌ':Added, #2: 2	صِفَةَ الْكَمَالِ
u'صِفَةٌ كَمَالٌ':Added, #2: 2	صِفَةَ كَمَالٍ
u'صِفَةٌ كَمَالٌ':Added, #4: 4	صِفَةُ كَمَالٍ
u'صِفَةٌ كَوْثَرٌ':Added, #5: 5	صِفَةُ الْكَمَالِ
u'صِفَةٌ كَوْنٌ':Added, #1: 1	صِفَةَ الْكَوْثَرِ
u'صِفَةٌ كَوْنٌ':Added, #1: 1	صِفَةُ كَوْنِ
u'صِفَةٌ كَوْنٌ':Added, #3: 3	صِفَةَ كَوْنِهِ
u'صِفَةٌ لُزُومٌ':Added, #4: 4	صِفَةُ كَوْنِهِ
u'صِفَةٌ لُزُومٌ':Added, #3: 3	صِفَةُ اللُّزُومِ
u'صِفَةٌ لعان':Added, #3: 3	صِفَةِ اللُّزُومِ
u'صِفَةٌ لعان':Added, #1: 1	صِفَةَ اللِّعَانِ
u'صِفَةٌ لعان':Added, #1: 1	صِفَةِ اللِّعَانِ
u'صِفَةٌ لَفْظٌ':Added, #2: 2	صِفَةُ اللِّعَانِ
u'صِفَةٌ لَئِيمٌ':Added, #3: 3	صِفَةُ اللَّفْظِ
u'صِفَةٌ مَاءٌ':Added, #1: 1	صِفَةِ اللَّئِيمِ
u'صِفَةٌ مَاءٌ':Added, #2: 2	صِفَةُ الْمَاءِ
u'صِفَةٌ مَاءٌ':Added, #4: 4	صِفَةَ الْمَاءِ
u'صِفَةٌ مَاضِي':Added, #4: 4	صِفَةِ الْمَاءِ
u'صِفَةٌ مَالٌ':Added, #1: 1	صِفَةٍ مَاضِيَةٍ
u'صِفَةٌ مَالٌ':Added, #1: 1	صِفَةَ الْمَالِ
u'صِفَةٌ مَالٌ':Added, #1: 1	صِفَةَ الْمَالَيْنِ
u'صِفَةٌ مَالٌ':Added, #1: 1	صِفَةُ مَالِهِ
u'صِفَةٌ مالِك':Added, #3: 3	صِفَةِ الْمَالِ
u'صِفَةٌ مَالِكٌ':Added, #13: 13	صِفَةِ الْمَالِكِيَّةِ
u'صِفَةٌ مالِك':Added, #1: 1	صِفَةُ الْمَالِكِ
u'صِفَةٌ مالِك':Added, #2: 2	صِفَةَ الْمَالِكِيَّةِ
u'صِفَةٌ مالِكِيّ':Added, #4: 4	صِفَةُ الْمَالِكِيَّةِ
u'صِفَةٌ مالِكِيّ':Added, #13: 13	صِفَةِ الْمَالِكِيَّةِ
u'صِفَةٌ مالِكِيّ':Added, #2: 2	صِفَةَ الْمَالِكِيَّةِ
u'صِفَةٌ مَالِيٌّ':Added, #4: 4	صِفَةُ الْمَالِكِيَّةِ
u'صِفَةٌ مَالِيٌّ':Added, #14: 14	صِفَةِ الْمَالِيَّةِ
u'صِفَةٌ مُبَاحٌ':Added, #8: 8	صِفَةُ الْمَالِيَّةِ
u'صِفَةٌ مُبَالَغَةٌ':Added, #1: 1	صِفَةِ الْمُبَاحِ
u'صِفَةٌ مَبِيعٌ':Added, #2: 2	صِفَةِ الْمُبَالَغَةِ
u'صِفَةٌ مَبِيعٌ':Added, #1: 1	صِفَةُ الْمَبِيعِ
u'صِفَةٌ مَبِيعٌ':Added, #2: 2	صِفَةَ الْمَبِيعِ
u'صِفَةٌ مُتَعَاقِدٌ':Added, #7: 7	صِفَةِ الْمَبِيعِ
u'صِفَةٌ مُتَعَلِّقٌ':Added, #1: 1	صِفَةِ الْمُتَعَاقِدَيْنِ
u'صِفَةٌ مُتَقَدِّمٌ':Added, #1: 1	صِفَةٍ مُتَعَلِّقَةٍ
u'صِفَةٌ مُتَكَلِّمٌ':Added, #1: 1	صِفَةٍ مُتَقَدِّمَةٍ
u'صِفَةٌ مثل':Added, #4: 4	صِفَةُ الْمُتَكَلِّمِ
u'صِفَةٌ مِثْلٌ':Added, #1: 1	صِفَةِ الْمِثْلِ
u'صِفَةٌ مُجْتَهِد':Added, #1: 1	صِفَةِ الْمِثْلِ
u'صِفَةٌ مُجْمَعٌ':Added, #1: 1	صِفَةَ الْمُجْتَهِدِ
u'صِفَةٌ مُجْمَلٌ':Added, #1: 1	صِفَةُ الْمُجْمَعِ
u'صِفَةٌ مُحَدِّثٌ':Added, #1: 1	صِفَةُ الْمُجْمَلِ
u'صِفَةٌ مَحْدُودٌ':Added, #1: 1	صِفَةِ الْمُحَدِّثِ
u'صِفَةٌ مَحْضَرٌ':Added, #1: 1	صِفَةِ الْمَحْدُودِ
u'صِفَةٌ مَحَلٌّ':Added, #1: 1	صِفَةِ الْمَحْضَرِ
u'صِفَةٌ مُحَمَّدٌ':Added, #2: 2	صِفَةُ الْمَحَلِّ
u'صِفَةٌ مَحْمُودٌ':Added, #1: 1	صِفَةَ مُحَمَّدٍ
u'صِفَةٌ مُخَاصَمَةٌ':Added, #1: 1	صِفَةٍ مَحْمُودَةٍ
u'صِفَةٌ مَخْصُوصٌ':Added, #1: 1	صِفَةِ الْمُخَاصَمَةِ
u'صِفَةٌ مَخْطُوبٌ':Added, #3: 3	صِفَةٍ مَخْصُوصَةٍ
u'صِفَةٌ مَخْلُوقٌ':Added, #1: 1	صِفَةِ الْمَخْطُوبَةِ
u'صِفَةٌ مَدْحٌ':Added, #1: 1	صِفَةِ الْمَخْلُوقِ
u'صِفَةٌ مَدْفُوعٌ':Added, #2: 2	صِفَةُ مَدْحٍ
u'صِفَةٌ مَدْلُولٌ':Added, #1: 1	صِفَةَ الْمَدْفُوعِ
u'صِفَةٌ مَرْهُونٌ':Added, #1: 1	صِفَةِ مَدْلُولِ
u'صِفَةٌ مَسَاجِدُ':Added, #1: 1	صِفَةِ الْمَرْهُونِ
u'صِفَةٌ مَسْحٌ':Added, #1: 1	صِفَةِ الْمَسَاجِدِ
u'صِفَةٌ مَسْحٌ':Added, #1: 1	صِفَةَ الْمَسْحِ
u'صِفَةٌ مَسْحٌ':Added, #1: 1	صِفَةُ الْمَسْحِ
u'صِفَةٌ مَسْحٌ':Added, #1: 1	صِفَةِ مَسْحِ
u'صِفَةٌ مَسْحٌ':Added, #1: 1	صِفَةِ مَسْحِهِ
u'صِفَةٌ مُسْلِمٌ':Added, #3: 3	صِفَةِ الْمَسْحِ
u'صِفَةٌ مُسَلَّمٌ':Added, #1: 1	صِفَةَ مُسْلِمِهِ
u'صِفَةٌ مَشْرُوطٌ':Added, #5: 5	صِفَةِ الْمُسَلَّمِ
u'صِفَةٌ مَصْدَرٌ':Added, #1: 1	صِفَةٍ مَشْرُوطَةٍ
u'صِفَةٌ مِصْرٌ':Added, #1: 1	صِفَةِ الْمَصْدَرِ
u'صِفَةٌ مُطَلَّقٌ':Added, #1: 1	صِفَةِ الْمِصْرِ
u'صِفَةٌ مُطَهِّرٌ':Added, #1: 1	صِفَةَ الْمُطَلَّقَةِ
u'صِفَةٌ مَعِدَةٌ':Added, #1: 1	صِفَةِ الْمُطَهِّرِ
u'صِفَةٌ مَعْلُومٌ':Added, #1: 1	صِفَةَ الْمَعِدَةِ
u'صِفَةٌ مَفْعُولٌ':Added, #2: 2	صِفَةٍ مَعْلُومَةٍ
u'صِفَةٌ مُفَوَّضٌ':Added, #1: 1	صِفَةُ الْمَفْعُولِ
u'صِفَةٌ مَقْبُوضٌ':Added, #1: 1	صِفَةَ الْمُفَوَّضِ
u'صِفَةٌ مَكْتُوبٌ':Added, #2: 2	صِفَةِ الْمَقْبُوضِ
u'صِفَةٌ مَكْرُوهٌ':Added, #2: 2	صِفَةُ الْمَكْتُوبِ
u'صِفَةٌ مَكْرُوهَةٌ':Added, #1: 1	صِفَةٍ مَكْرُوهَةٍ
u'صِفَةٌ مُكَلَّفٌ':Added, #1: 1	صِفَةٍ مَكْرُوهَةٍ
u'صِفَةٌ مَلْبُوس':Added, #1: 1	صِفَةُ الْمُكَلَّفِ
u'صِفَةٌ ملح':Added, #1: 1	صِفَةِ الْمَلْبُوسِ
u'صِفَةٌ مِلْحٌ':Added, #1: 1	صِفَةُ الْمِلْحِ
u'صِفَةٌ مَلَكٌ':Added, #1: 1	صِفَةُ الْمِلْحِ
u'صِفَةٌ مَلَكِيٌّ':Added, #1: 1	صِفَةُ الْمَلَكَيْنِ
u'صِفَةٌ مَلَكِيَّةٌ':Added, #1: 1	صِفَةٍ مَلَكِيّةٍ
u'صِفَةٌ مُمَاثَلَةٌ':Added, #1: 1	صِفَةٍ مَلَكِيّةٍ
u'صِفَةٌ مَمْلُوك':Added, #1: 1	صِفَةِ الْمُمَاثَلَةِ
u'صِفَةٌ مَمْلُوك':Added, #1: 1	صِفَةُ الْمَمْلُوكِيَّةِ
u'صِفَةٌ مَمْلُوكِيّ':Added, #2: 2	صِفَةِ الْمَمْلُوكِيَّةِ
u'صِفَةٌ مَمْلُوكِيّ':Added, #1: 1	صِفَةُ الْمَمْلُوكِيَّةِ
u'صِفَةٌ مُنَافِقٌ':Added, #2: 2	صِفَةِ الْمَمْلُوكِيَّةِ
u'صِفَةٌ مُنَافِقٌ':Added, #1: 1	صِفَةُ الْمُنَافِقِ
u'صِفَةٌ مَنْذُور':Added, #1: 1	صِفَةِ الْمُنَافِقِ
u'صِفَةٌ مَهْرٌ':Added, #2: 2	صِفَةَ الْمَنْذُورِ
u'صِفَةٌ مُوجَبٌ':Added, #3: 3	صِفَةِ الْمَهْرِ
u'صِفَةٌ مُوجِبٌ':Added, #1: 1	صِفَةِ الْمُوجَبِ
u'صِفَةٌ مُؤَذِّنٌ':Added, #1: 1	صِفَةُ الْمُوجِبِ
u'صِفَةٌ مُؤْمِنٌ':Added, #2: 2	صِفَةِ الْمُؤَذِّنِ
u'صِفَةٌ مُؤَنَّثٌ':Added, #1: 1	صِفَةِ الْمُؤْمِنِ
u'صِفَةٌ مُؤَنَّثٌ':Added, #1: 1	صِفَةُ الْمُؤَنَّثِ
u'صِفَةٌ مُؤَنَّثٌ':Added, #1: 1	صِفَةَ مُؤَنَّثٍ
u'صِفَةٌ نَاجِزٌ':Added, #1: 1	صِفَةُ مُؤَنَّثٍ
u'صِفَةٌ نَارٌ':Added, #1: 1	صِفَةٍ نَاجِزَةٍ
u'صِفَةٌ نَاطِقٌ':Added, #5: 5	صِفَةِ النَّارِ
u'صِفَةٌ نَبَطِيٌّ':Added, #1: 1	صِفَةُ النَّاطِقِ
u'صِفَةٌ نَبَطِيَّةٌ':Added, #1: 1	صِفَةِ النَّبَطِيَّةِ
u'صِفَةٌ نَبِيٌّ':Added, #1: 1	صِفَةِ النَّبَطِيَّةِ
u'صِفَةٌ نَبِيٌّ':Added, #1: 1	صِفَةُ النَّبِيِّ
u'صِفَةٌ نَبِيٌّ':Added, #1: 1	صِفَةِ نَبِيِّهِ
u'صِفَةٌ نَجَاسَةٌ':Added, #4: 4	صِفَةِ النَّبِيِّ
u'صِفَةٌ نَجَاسَةٌ':Added, #1: 1	صِفَةَ النَّجَاسَةِ
u'صِفَةٌ نَجَسٌ':Added, #1: 1	صِفَةِ النَّجَاسَةِ
u'صِفَةٌ نِساءٌ':Added, #1: 1	صِفَةَ نَجَسٍ
u'صِفَةٌ نَسَبٌ':Added, #1: 1	صِفَةِ النِّسَاءِ
u'صِفَةٌ نُسُكٌ':Added, #1: 1	صِفَةِ النَّسَبِ
u'صِفَةٌ نظام':Added, #1: 1	صِفَةِ نُسُكِ
u'صِفَةٌ نِظَامٌ':Added, #1: 1	صِفَةُ نِظَامِهِ
u'صِفَةٌ نَعْلٌ':Added, #1: 1	صِفَةُ نِظَامِهِ
u'صِفَةٌ نَفْسٌ':Added, #1: 1	صِفَةِ نَعْلِ
u'صِفَةٌ نَفْسٌ':Added, #1: 1	صِفَةَ النَّفْسِ
u'صِفَةٌ نَفْسٌ':Added, #1: 1	صِفَةُ النَّفْسِ
u'صِفَةٌ نَفْسٌ':Added, #1: 1	صِفَةِ نَفْسِ
u'صِفَةٌ نَفْسِيٌّ':Added, #1: 1	صِفَةُ نَفْسِهِ
u'صِفَةٌ نَفْلٌ':Added, #3: 3	صِفَةٍ نَفْسِيَّةٍ
u'صِفَةٌ نَقْدٌ':Added, #1: 1	صِفَةِ النَّفْلِ
u'صِفَةٌ نَقْد':Added, #1: 1	صِفَةِ النَّقْدِ
u'صِفَةٌ نَقْصٌ':Added, #1: 1	صِفَةِ النَّقْدِ
u'صِفَةٌ نَقْصٌ':Added, #1: 1	صِفَةُ النَّقْصِ
u'صِفَةٌ نَمَاءٌ':Added, #1: 1	صِفَةَ نَقْصٍ
u'صِفَةٌ نَهْرٌ':Added, #2: 2	صِفَةِ النَّمَاءِ
u'صِفَةٌ نِيَّةٌ':Added, #1: 1	صِفَةِ النَّهْرِ
u'صِفَةٌ وَاجِبٌ':Added, #1: 1	صِفَةَ النِّيَّةِ
u'صِفَةٌ وَاجِبٌ':Added, #1: 1	صِفَةَ الْوَاجِبِ
u'صِفَةٌ وَاجِبٌ':Added, #1: 1	صِفَةُ الْوَاجِبِ
u'صِفَةٌ واحد':Added, #4: 4	صِفَةِ الْوَاجِبِ
u'صِفَةٌ وَاحِدٌ':Added, #19: 19	صِفَةٍ وَاحِدَةٍ
u'صِفَةٌ وَاقِعٌ':Added, #19: 19	صِفَةٍ وَاحِدَةٍ
u'صِفَةٌ وَاقِعَةٌ':Added, #2: 2	صِفَةُ الْوَاقِعَةِ
u'صِفَةٌ وُجُوبٌ':Added, #2: 2	صِفَةُ الْوَاقِعَةِ
u'صِفَةٌ وُجُوبٌ':Added, #1: 1	صِفَةُ الْوُجُوبِ
u'صِفَةٌ وُجُودٌ':Added, #2: 2	صِفَةِ الْوُجُوبِ
u'صِفَةٌ وَحْدَانِيٌّ':Added, #1: 1	صِفَةَ وُجُودِ
u'صِفَةٌ وَحْدَانِيَّةٌ':Added, #1: 1	صِفَةِ الْوَحْدَانِيَّةِ
u'صِفَةٌ وِرَاثَةٌ':Added, #1: 1	صِفَةِ الْوَحْدَانِيَّةِ
u'صِفَةٌ وِرَاثَةٌ':Added, #1: 1	صِفَةِ الْوِرَاثَةِ
u'صِفَةٌ وَزْنٌ':Added, #4: 4	صِفَةُ الْوِرَاثَةِ
u'صِفَةٌ وَزْنٌ':Added, #1: 1	صِفَة الْوَزْنِ
u'صِفَةٌ وَسَاطَةٌ':Added, #4: 4	صِفَةِ الْوَزْنِ
u'صِفَةٌ وَسْمٌ':Added, #1: 1	صِفَةِ الْوَسَاطَةِ
u'صِفَةٌ وَصِيٌّ':Added, #1: 1	صِفَةِ الْوَسْمِ
u'صِفَةٌ وَصِيَّةٌ':Added, #2: 2	صِفَةِ الْوَصِيَّةِ
u'صِفَةٌ وَضْعٌ':Added, #2: 2	صِفَةِ الْوَصِيَّةِ
u'صِفَةٌ وَضْعٌ':Added, #1: 1	صِفَةُ الْوَضْعِ
u'صِفَةٌ وَضْعٌ':Added, #1: 1	صِفَةِ الْوَضْعِ
u'صِفَةٌ وَضْعٌ':Added, #1: 1	صِفَةَ وَضْعِ
u'صِفَةٌ وُضُوءٌ':Added, #2: 2	صِفَةِ وَضْعِ
u'صِفَةٌ وُضُوءٌ':Added, #1: 1	صِفَة الْوُضُوءِ
u'صِفَةٌ وُضُوءٌ':Added, #1: 1	صِفَةُ الْوُضُوءِ
u'صِفَةٌ وُضُوءٌ':Added, #2: 2	صِفَةَ وُضُوءِ
u'صِفَةٌ وُضُوءٌ':Added, #34: 34	صِفَةِ الْوُضُوءِ
u'صِفَةٌ وُضُوءٌ':Added, #3: 3	صِفَةَ الْوُضُوءِ
u'صِفَةٌ وَظِيفٌ':Added, #5: 5	صِفَةِ وُضُوءِ
u'صِفَةٌ وَظِيفَةٌ':Added, #1: 1	صِفَةِ الْوَظِيفَةِ
u'صِفَةٌ وُقُوعٌ':Added, #1: 1	صِفَةِ الْوَظِيفَةِ
u'صِفَةٌ وُقُوعٌ':Added, #1: 1	صِفَةِ الْوُقُوعِ
u'صِفَةٌ وُقُوفٌ':Added, #1: 1	صِفَةِ وُقُوعِ
u'صِفَةٌ وُقُوفٌ':Added, #1: 1	صِفَةُ الْوُقُوفِ
u'صِفَةٌ وُقُوفٌ':Added, #1: 1	صِفَةِ الْوُقُوفِ
u'صِفَةٌ يسار':Added, #1: 1	صِفَةِ وُقُوفِهِ
u'صِفَةٌ يَسَارٌ':Added, #4: 4	صِفَةَ الْيَسَارِ
u'صِفَةٌ يَمِينٌ':Added, #4: 4	صِفَةَ الْيَسَارِ
u'صِفَةٌ يَمِينٌ':Added, #2: 2	صِفَةَ الْيَمِينِ
u'صِفَةٌ يَوْمٌ':Added, #2: 2	صِفَةِ الْيَمِينِ
u'صفح أحلام':Added, #1: 1	صِفَةُ يَوْمِ
u'صفح أحْلاَمٌ':Added, #1: 1	صَفْحَ أَحْلَامِ
u'صفح أَحْلاَمٌ':Added, #1: 1	صَفْحَ أَحْلَامِ
u'صَفْحٌ أحلام':Added, #1: 1	صَفْحَ أَحْلَامِ
u'صَفْحٌ أحْلاَمٌ':Added, #1: 1	صَفْحَ أَحْلَامِ
u'صَفْحٌ أَحْلاَمٌ':Added, #1: 1	صَفْحَ أَحْلَامِ
u'صفح ذُلٌّ':Added, #1: 1	صَفْحَ أَحْلَامِ
u'صَفْحٌ ذُلٌّ':Added, #1: 1	صَفْحَ ذُلٍّ
u'صفح عنق':Added, #1: 1	صَفْحَ ذُلٍّ
u'صَفْحٌ عنق':Added, #1: 1	صَفْحَ عُنُقِ
u'صفح عُنُقٌ':Added, #1: 1	صَفْحَ عُنُقِ
u'صَفْحٌ عُنُقٌ':Added, #1: 1	صَفْحَ عُنُقِ
u'صَفَرَ أَوَّلُ':Predicate, #1: 1	صَفْحَ عُنُقِ
u'صُفْرَةٌ خَلُوق':Added, #1: 1	صَفَرَ الأَوَّلَ
u'صُفْرَةٌ وَجْهٌ':Added, #1: 1	صُفْرَةِ الْخَلُوقِ
u'صَفَرَ حَديثٌ':Predicate, #1: 1	صُفْرَةُ الْوَجْهِ
u'صَفَّقَ رَجُلٌ':Subject, #1: 1	صَفَرَ الْحَدِيثَ
u'صَفْوٌ زَمانٌ':Added, #1: 1	صَفَّقَ الرَّجُلُ
u'صَفْوٌ زَمانٌ':Added, #1: 1	صَفْوَ الزَّمَانِ
u'صَفْوٌ عَقْلٌ':Added, #1: 1	صَفْوُ الزَّمَانِ
u'صُفُوفٌ أَصْحَابٌ':Added, #1: 1	صَفْوِ الْعَقْلِ
u'صُفُوفٌ أهْلٌ':Added, #1: 1	صُفُوفَ أَصْحَابِهِ
u'صُفُوفٌ جَمَاعَةٌ':Added, #2: 2	صُفُوفِ أَهْلِ
u'صُفُوفٌ رِجَالٌ':Added, #1: 1	صُفُوفِ الْجَمَاعَةِ
u'صُفُوفٌ رِجَالٌ':Added, #15: 15	صُفُوفِ الرِّجَالِ
u'صُفُوفٌ رِجَالٌ':Added, #1: 1	صُفُوفُ الرِّجَالِ
u'صُفُوفٌ صَلاَةٌ':Added, #1: 1	صُفُوفِ الرّجَالِ
u'صُفُوفٌ مَلاَئِكَةٌ':Added, #1: 1	صُفُوفِ الصَّلَاةِ
u'صُفُوفٌ نِساءٌ':Added, #1: 1	صُفُوفِ الْمَلاَئِكَةِ
u'صَفْوٌ مَاءٌ':Added, #9: 9	صُفُوفِ النِّسَاءِ
u'صَفْوٌ مَحَبَّةٌ':Added, #1: 1	صَفْوِ الْمَاءِ
u'صَفِيرٌ قَصَبٌ':Added, #1: 1	صَفْوَ الْمَحَبَّةِ
u'صَقَلَ سَيْفٌ':Predicate, #1: 1	صَفِيرُ الْقَصَبِ
u'صَقْلٌ سَيْفٌ':Added, #1: 1	صَقَلَ سَيْفَ
u'صُكُوكٌ سَلَمٌ':Added, #2: 2	صَقْلُ السَّيْفِ
u'صَلاَةٌ اِبْنٌ':Added, #1: 1	صُكُوكِ السَّلَمِ
u'صَلاَةٌ أحَدٌ':Added, #1: 1	صَلاَةِ ابْنِ
u'صَلاَةٌ أَرْبَعَةٌ':Added, #1: 1	صَلاَةِ أَحَدٍ
u'صَلاَةٌ اِسْتِسْقَاءٌ':Added, #1: 1	صَلاَةِ أَرْبَعَةٍ
u'صَلاَةٌ أَسيرٌ':Added, #1: 1	صَلاَةِ الاِسْتِسْقَاءِ
u'صَلاَةٌ الْمَرْءُ':Added, #1: 1	صَلاَةِ الأَسِيرِ
u'صَلاَةٌ الْمَرْءُ':Added, #2: 2	صَلاَةُ الْمَرْءِ
u'صَلاَةٌ الْمَرْأَةُ':Added, #2: 2	صَلاَةِ الْمَرْءِ
u'صَلاَةٌ إمَامٌ':Added, #1: 1	صَلاَةُ الْمَرْأَةِ
u'صَلاَةٌ اِمْرَأَةٌ':Added, #8: 8	صَلاَةِ الإِمَامِ
u'صَلاَةٌ أَميرٌ':Added, #1: 1	صَلاَةُ امْرَأَةٍ
u'صَلاَةٌ أئِمَّةٌ':Added, #1: 1	صَلاَةِ أَمِيرِ
u'صَلاَةٌ بَصَرٌ':Added, #1: 1	صَلاَةِ الأَئِمَّةِ
u'صَلاَةٌ تَرَاوِيحُ':Added, #2: 2	صَلاَةَ الْبَصَرِ
u'صَلاَةٌ تَرَاوِيحُ':Added, #1: 1	صَلاَةَ التَّرَاوِيحِ
u'صَلاَةٌ تَسْبِيحٌ':Added, #1: 1	صَلاَةِ التَّرَاوِيحِ
u'صَلاَةٌ تَطَوُّعٌ':Added, #1: 1	صَلاَةِ التَّسْبِيحِ
u'صَلاَةٌ تَطَوُّعٌ':Added, #1: 1	صَلاَةَ التَّطَوُّعِ
u'صَلاَةٌ تَطَوُّعٌ':Added, #1: 1	صَلاَةُ التَّطَوُّعِ
u'صَلاَةٌ ثَلاثُ':Added, #4: 4	صَلاَةِ التَّطَوُّعِ
u'صَلاَةٌ ثَمانِيَةٌ':Added, #1: 1	صَلاَةُ ثَلاَثِ
u'صَلاَةٌ جَالِسٌ':Added, #1: 1	صَلاَةِ ثَمَانِيَةٍ
u'صَلاَةٌ جَمَاعَةٌ':Added, #1: 1	صَلاَةِ الْجَالِسِ
u'صَلاَةٌ جَمَاعَةٌ':Added, #1: 1	صَلاَةَ الْجَمَاعَةِ
u'صَلاَةٌ جَمَاعَةٌ':Added, #1: 1	صَلاَةِ الْجَمَاعَةِ
u'صَلاَةٌ جَمَاعَةٌ':Added, #1: 1	صَلاَةِ جَمَاعَةٍ
u'صَلاَةٌ جمعة':Added, #6: 6	صَلاَةُ الْجَمَاعَةِ
u'صَلاَةٌ جمعة':Added, #2: 2	صَلاَةَ الْجُمُعَةِ
u'صَلاَةٌ جُمُعَةٌ':Added, #2: 2	صَلاَةُ الْجُمُعَةِ
u'صَلاَةٌ جُمُعَةٌ':Added, #2: 2	صَلاَةَ الْجُمُعَةِ
u'صَلاَةٌ جمعة':Added, #2: 2	صَلاَةُ الْجُمُعَةِ
u'صَلاَةٌ جُمُعَةٌ':Added, #3: 3	صَلاَةِ الْجُمُعَةِ
u'صَلاَةٌ جَمِيع':Added, #3: 3	صَلاَةِ الْجُمُعَةِ
u'صَلاَةٌ جَنَازَةٌ':Added, #2: 2	صَلاَةُ الْجَمِيعِ
u'صَلاَةٌ حائِضٌ':Added, #9: 9	صَلاَةِ الْجَنَازَةِ
u'صَلاَةٌ حائِضٌ':Added, #1: 1	صَلاَةَ الْحَائِضِ
u'صَلاَةٌ حَرَسٌ':Added, #3: 3	صَلاَةُ حَائِضٍ
u'صَلاَةٌ حَضَرٌ':Added, #1: 1	صَلاَةِ الْحَرَسِ
u'صَلاَةٌ حَضَرٌ':Added, #1: 1	صَلاَةَ الْحَضَرِ
u'صَلاَةٌ حَيْضٌ':Added, #2: 2	صَلاَةِ الْحَضَرِ
u'صَلاَةٌ خُسُوفٌ':Added, #1: 1	صَلاَةَ الْحَيْضِ
u'صَلاَةٌ خُسُوفٌ':Added, #2: 2	صَلاَةَ الْخُسُوفِ
u'صَلاَةٌ خَوْفٌ':Added, #5: 5	صَلاَةِ الْخُسُوفِ
u'صَلاَةٌ خَوْفٌ':Added, #1: 1	صَلاَةُ الْخَوْفِ
u'صَلاَةٌ خَوْفٌ':Added, #20: 20	صَلاَةِ الْخَوْفِ
u'صَلاَةٌ رَجُلٌ':Added, #25: 25	صَلاَةَ الْخَوْفِ
u'صَلاَةٌ رَجُلٌ':Added, #1: 1	صَلاَةُ رَجُلَيْنِ
u'صَلاَةٌ رَجُلٌ':Added, #2: 2	صَلاَةَ رَجُلٍ
u'صَلاَةٌ رَجُلٌ':Added, #4: 4	صَلاَةَ الرَّجُلِ
u'صَلاَةٌ رَجُلٌ':Added, #4: 4	صَلاَةُ رَجُلٍ
u'صَلاَةٌ رَجُلٌ':Added, #5: 5	صَلاَةُ الرَّجُلِ
u'صَلاَةٌ رَسُولٌ':Added, #9: 9	صَلاَةِ الرَّجُلِ
u'صَلاَةٌ رَسُولٌ':Added, #12: 12	صَلاَةُ رَسُولِ
u'صَلاَةٌ رَسُولٌ':Added, #17: 17	صَلاَةَ رَسُولِ
u'صَلاَةٌ زَوالٌ':Added, #36: 36	صَلاَةِ رَسُولِ
u'صَلاَةٌ سَفَرٌ':Added, #1: 1	صَلاَةَ الزَّوَالِ
u'صَلاَةٌ سَفَرٌ':Added, #1: 1	صَلاَةَ السَّفَرِ
u'صَلاَةٌ سَفَرٌ':Added, #1: 1	صَلاَةِ السَّفَرِ
u'صَلاَةٌ شِدَّةٌ':Added, #5: 5	صَلاَةُ السَّفَرِ
u'صَلاَةٌ صُبْحٌ':Added, #1: 1	صَلاَةِ شِدَّةِ
u'صَلاَةٌ صُبْحٌ':Added, #30: 30	صَلاَةَ الصُّبْحِ
u'صَلاَةٌ صُبْحٌ':Added, #7: 7	صَلاَةُ الصُّبْحِ
u'صَلاَةٌ ظُهْرٌ':Added, #89: 89	صَلاَةِ الصُّبْحِ
u'صَلاَةٌ ظُهْرٌ':Added, #10: 10	صَلاَةُ الظُّهْرِ
u'صَلاَةٌ ظُهْرٌ':Added, #27: 27	صَلاَةِ الظُّهْرِ
u'صَلاَةٌ عَبْدٌ':Added, #6: 6	صَلاَةَ الظُّهْرِ
u'صَلاَةٌ عتمة':Added, #1: 1	صَلاَةِ الْعَبْدِ
u'صَلاَةٌ عَتَمَةٌ':Added, #1: 1	صَلاَةَ الْعَتَمَةِ
u'صَلاَةٌ عتمة':Added, #1: 1	صَلاَةَ الْعَتَمَةِ
u'صَلاَةٌ عَتَمَةٌ':Added, #4: 4	صَلاَةِ الْعَتَمَةِ
u'صَلاَةٌ عِشَاءٌ':Added, #4: 4	صَلاَةِ الْعَتَمَةِ
u'صَلاَةٌ عِشَاءٌ':Added, #17: 17	صَلاَةَ الْعِشَاءِ
u'صَلاَةٌ عِشَاءٌ':Added, #25: 25	صَلاَةِ الْعِشَاءِ
u'صَلاَةٌ عَصْرٌ':Added, #4: 4	صَلاَةُ الْعِشَاءِ
u'صَلاَةٌ عَصْرٌ':Added, #12: 12	صَلاَةَ الْعَصْرِ
u'صَلاَةٌ عَصْرٌ':Added, #18: 18	صَلاَةُ الْعَصْرِ
u'صَلاَةٌ عِيدٌ':Added, #34: 34	صَلاَةِ الْعَصْرِ
u'صَلاَةٌ عِيدٌ':Added, #1: 1	صَلاَةَ الْعِيدِ
u'صَلاَةٌ عِيدٌ':Added, #1: 1	صَلاَةُ الْعِيدِ
u'صَلاَةٌ عِيدٌ':Added, #2: 2	صَلاَةُ الْعِيدَيْنِ
u'صَلاَةٌ عِيدٌ':Added, #3: 3	صَلاَةِ الْعِيدِ
u'صَلاَةٌ غَدٌ':Added, #7: 7	صَلاَةِ الْعِيدَيْنِ
u'صَلاَةٌ غداة':Added, #1: 1	صَلاَةَ الْغَدِ
u'صَلاَةٌ غَدَاةٌ':Added, #15: 15	صَلاَةِ الْغَدَاةِ
u'صَلاَةٌ غداة':Added, #15: 15	صَلاَةِ الْغَدَاةِ
u'صَلاَةٌ غَدَاةٌ':Added, #1: 1	صَلاَةُ الْغَدَاةِ
u'صَلاَةٌ غداة':Added, #1: 1	صَلاَةُ الْغَدَاةِ
u'صَلاَةٌ غَدَاةٌ':Added, #6: 6	صَلاَةَ الْغَدَاةِ
u'صَلاَةٌ غير':Added, #6: 6	صَلاَةَ الْغَدَاةِ
u'صَلاَةٌ غَيْرٌ':Added, #1: 1	صَلاَةَ غَيْرِهِ
u'صَلاَةٌ فَجْرٌ':Added, #1: 1	صَلاَةَ غَيْرِهِ
u'صَلاَةٌ فَجْرٌ':Added, #19: 19	صَلاَةَ الْفَجْرِ
u'صَلاَةٌ فَجْرٌ':Added, #1: 1	صَلاَةِ الفَجْرِ
u'صَلاَةٌ فَجْرٌ':Added, #47: 47	صَلاَةِ الْفَجْرِ
u'صَلاَةٌ فَذٌّ':Added, #4: 4	صَلاَةُ الْفَجْرِ
u'صَلاَةٌ فَذٌّ':Added, #2: 2	صَلاَةَ الْفَذِّ
u'صَلاَةٌ فَرِيضَةٌ':Added, #3: 3	صَلاَةِ الْفَذِّ
u'صَلاَةٌ فَرِيضَةٌ':Added, #1: 1	صَلاَةِ فَرِيضَةٍ
u'صَلاَةٌ فِطْرٌ':Added, #2: 2	صَلاَةِ الْفَرِيضَةِ
u'صَلاَةٌ قَاعِدٌ':Added, #1: 1	صَلاَةَ الْفِطْرِ
u'صَلاَةٌ قَاعِدٌ':Added, #2: 2	صَلاَةُ الْقَاعِدِ
u'صَلاَةٌ قَائِمٌ':Added, #3: 3	صَلاَةِ الْقَاعِدِ
u'صَلاَةٌ قَوْمٌ':Added, #3: 3	صَلاَةِ الْقَائِمِ
u'صَلاَةٌ كَافِرٌ':Added, #1: 1	صَلاَةِ الْقَوْمِ
u'صَلاَةٌ كُسُوفٌ':Added, #1: 1	صَلاَةُ الْكَافِرِ
u'صَلاَةٌ كُسُوفٌ':Added, #1: 1	صَلاَةَ الْكُسُوفِ
u'صَلاَةٌ كُسُوفٌ':Added, #1: 1	صَلاَةِ كُسُوفِ
u'صَلاَةٌ لَيْلٌ':Added, #6: 6	صَلاَةِ الْكُسُوفِ
u'صَلاَةٌ لَيْلٌ':Added, #13: 13	صَلاَةُ اللَّيْلِ
u'صَلاَةٌ لَيْلٌ':Added, #13: 13	صَلاَةِ اللَّيْلِ
u'صَلاَةٌ مُحَمَّدٌ':Added, #3: 3	صَلاَةَ اللَّيْلِ
u'صَلاَةٌ مَرِيضٌ':Added, #2: 2	صَلاَةِ مُحَمَّدٍ
u'صَلاَةٌ مُسَافِرٌ':Added, #1: 1	صَلاَةِ الْمَرِيضِ
u'صَلاَةٌ مُسَافِرٌ':Added, #1: 1	صَلاَةِ الْمُسَافِرِ
u'صَلاَةٌ مُسْفِر':Added, #2: 2	صَلاَةَ الْمُسَافِرِ
u'صَلاَةٌ مُسْلِمٌ':Added, #1: 1	صَلاَةِ الْمُسْفِرَةِ
u'صَلاَةٌ مُعَجَّلٌ':Added, #2: 2	صَلاَةَ الْمُسْلِمِ
u'صَلاَةٌ مَغْرِبٌ':Added, #1: 1	صَلاَةِ الْمُعَجَّلَةِ
u'صَلاَةٌ مَغْرِبٌ':Added, #15: 15	صَلاَةَ الْمَغْرِبِ
u'صَلاَةٌ مَغْرِبٌ':Added, #16: 16	صَلاَةِ الْمَغْرِبِ
u'صَلاَةٌ مَغْضُوبٌ':Added, #5: 5	صَلاَةُ الْمَغْرِبِ
u'صَلاَةٌ مَفْرُوضٌ':Added, #1: 1	صَلاَةُ الْمَغْضُوبِ
u'صَلاَةٌ مَكْتُوبٌ':Added, #1: 1	صَلاَةٍ مَفْرُوضَةٍ
u'صَلاَةٌ مَكْتُوبٌ':Added, #1: 1	صَلاَةِ الْمَكْتُوبَةِ
u'صَلاَةٌ مُنَافِقٌ':Added, #5: 5	صَلاَةٍ مَكْتُوبَةٍ
u'صَلاَةٌ نَاسٌ':Added, #1: 1	صَلاَةُ الْمُنَافِقِ
u'صَلاَةٌ نَافِلَةٌ':Added, #1: 1	صَلاَةِ النَّاسِ
u'صَلاَةٌ نَافِلَةٌ':Added, #1: 1	صَلاَةِ النَّافِلَةِ
u'صَلاَةٌ نفاس':Added, #1: 1	صَلاَةِ نَافِلَةٍ
u'صَلاَةٌ نِفَاسٌ':Added, #1: 1	صَلاَةِ النِّفَاسِ
u'صَلاَةٌ نهار':Added, #1: 1	صَلاَةِ النِّفَاسِ
u'صَلاَةٌ نَهَارٌ':Added, #1: 1	صَلاَةِ النَّهَارِ
u'صَلاَةٌ يهود':Added, #1: 1	صَلاَةِ النَّهَارِ
u'صَلاَةٌ يَهُودٌ':Added, #1: 1	صَلاَةُ الْيَهُودِ
u'صَلاَةٌ يَوْمٌ':Added, #1: 1	صَلاَةُ الْيَهُودِ
u'صَلاَحٌ إِسْلامٌ':Added, #1: 1	صَلاَةُ يَوْمٍ
u'صَلاَحٌ أُمَّةٌ':Added, #1: 1	صَلاَحُ الإِسْلاَمِ
u'صَلاَحٌ ثَمَرٌ':Added, #1: 1	صَلاَحِ الأُمَّةِ
u'صَلاَحٌ زَرْعٌ':Added, #1: 1	صَلاَحُ الثَّمَرِ
u'صَلَبَ إمَامٌ':Subject, #1: 1	صَلاَحِ الزَّرْعِ
u'صَلَبَ رَسُولٌ':Subject, #1: 1	صَلَبَ الْإِمَامُ
u'صلْبٌ عَقْدٌ':Added, #1: 1	صَلَبَ رَسُولُ
u'صَلْبٌ عَقْدٌ':Added, #1: 1	صَلْبِ الْعَقْدِ
u'صَلُبَ قِشْرٌ':Subject, #1: 1	صَلْبِ الْعَقْدِ
u'صلْبٌ مَالِكٌ':Added, #3: 3	صَلُبَ قِشْرُ
u'صَلْبٌ مَالِكٌ':Added, #1: 1	صَلْبِ مَالِكِهِ
u'صِلَةٌ إِحْيَاءٌ':Added, #1: 1	صَلْبِ مَالِكِهِ
u'صِلَةٌ إِخْوَانٌ':Added, #2: 2	صِلَةُ إحْيَاءٍ
u'صِلَةٌ أَرْحَامٌ':Added, #7: 7	صِلَةِ الْإِخْوَانِ
u'صِلَةٌ أَرْحَامٌ':Added, #1: 1	صِلَةُ الْأَرْحَامِ
u'صِلَةٌ اِسْتِثْنَاءٌ':Added, #2: 2	صِلَةِ الْأَرْحَامِ
u'صِلَةٌ اِسْتِحْقَاقٌ':Added, #1: 1	صِلَةِ الاِسْتِثْنَاءِ
u'صِلَةٌ أقْرَبُ':Added, #1: 1	صِلَةُ اسْتِحْقَاقِ
u'صِلَةٌ إمَامٌ':Added, #1: 1	صِلَةُ الْأَقْرَبِ
u'صِلَةٌ أهْلٌ':Added, #1: 1	صِلَةُ الْإِمَامِ
u'صِلَةٌ أهْلٌ':Added, #1: 1	صِلَةَ أَهْلِ
u'صِلَةٌ أَوْصَافٌ':Added, #2: 2	صِلَةُ أَهْلِ
u'صِلَةٌ تَثْرِيبٌ':Added, #1: 1	صِلَةُ الْأَوْصَافِ
u'صِلَةٌ حَيٌّ':Added, #1: 1	صِلَةِ التّثْرِيبِ
u'صِلَةٌ دُورٌ':Added, #1: 1	صِلَةِ الْحَيِّ
u'صِلَةٌ رحم':Added, #1: 1	صِلَةُ الدُّورِ
u'صِلَةٌ رحم':Added, #1: 1	صِلَةَ الرّحِمِ
u'صِلَةٌ رَحِمٌ':Added, #1: 1	صِلَةِ الرّحِمِ
u'صِلَةٌ رَحِمٌ':Added, #1: 1	صِلَةَ الرّحِمِ
u'صِلَةٌ رَحِمٌ':Added, #1: 1	صِلَةِ الرّحِمِ
u'صِلَةٌ رحم':Added, #1: 1	صِلَةُ رَحِمٍ
u'صِلَةٌ رَحِمٌ':Added, #22: 22	صِلَةُ الرَّحِمِ
u'صِلَةٌ رحم':Added, #22: 22	صِلَةُ الرَّحِمِ
u'صِلَةٌ رَحِمٌ':Added, #26: 26	صِلَةِ الرَّحِمِ
u'صِلَةٌ رحم':Added, #26: 26	صِلَةِ الرَّحِمِ
u'صِلَةٌ رَحِمٌ':Added, #2: 2	صِلَةَ رَحِمِهِ
u'صِلَةٌ رحم':Added, #2: 2	صِلَةَ رَحِمِهِ
u'صِلَةٌ رَحِمٌ':Added, #5: 5	صِلَةَ الرَّحِمِ
u'صِلَةٌ رَحِمٌ':Added, #5: 5	صِلَةَ الرَّحِمِ
u'صِلَةٌ عَاقِلٌ':Added, #7: 7	صِلَةِ رَحِمٍ
u'صِلَةٌ عَالِمٌ':Added, #1: 1	صِلَةُ الْعَاقِلِ
u'صِلَةٌ عَامٌّ':Added, #1: 1	صِلَةَ الْعَالِمِ
u'صِلَةٌ فراغ':Added, #1: 1	صِلَةِ الْعَامِّ
u'صِلَةٌ فَرَاغٌ':Added, #1: 1	صِلَةُ الْفَرَاغِ
u'صِلَةٌ قَاطِعٌ':Added, #1: 1	صِلَةُ الْفَرَاغِ
u'صِلَةٌ قَرَابَةٌ':Added, #1: 1	صِلَةِ الْقَاطِعِ
u'صِلَةٌ قَرَابَةٌ':Added, #1: 1	صِلَةَ الْقَرَابَةِ
u'صِلَةٌ قَرَابَةٌ':Added, #1: 1	صِلَةُ الْقَرَابَةِ
u'صِلَةٌ قَرَابَةٌ':Added, #1: 1	صِلَةِ الْقَرَابَةِ
u'صِلَةٌ قَرِيبٌ':Added, #1: 1	صِلَةِ قَرَابَةِ
u'صِلَةٌ قَرِيبٌ':Added, #1: 1	صِلَةَ الْقَرِيبِ
u'صِلَةٌ قَسَمٌ':Added, #1: 1	صِلَةِ الْقَرِيبِ
u'صِلَةٌ كَلاَمٌ':Added, #1: 1	صِلَةِ الْقَسَمِ
u'صِلَةٌ مَسْحٌ':Added, #3: 3	صِلَةِ كَلَامٍ
u'صِلَةٌ مُسْلِمٌ':Added, #1: 1	صِلَةِ الْمَسْحِ
u'صِلَةٌ مُشْرِك':Added, #1: 1	صِلَةِ الْمُسْلِمِ
u'صِلَةٌ مَصْدَرٌ':Added, #1: 1	صِلَةِ الْمُشْرِكِ
u'صِلَةٌ مَوْصُولٌ':Added, #2: 2	صِلَةِ الْمَصْدَرِ
u'صِلَةٌ وُضُوءٌ':Added, #3: 3	صِلَةُ الْمَوْصُولِ
u'صِلَةٌ ولد':Added, #1: 1	صِلَةِ الْوُضُوءِ
u'صِلَةٌ وَلَدٌ':Added, #2: 2	صِلَةُ الْوَلَدِ
u'صَلُحَ أثَاثٌ':Subject, #2: 2	صِلَةُ الْوَلَدِ
u'صَلَحَ أَسْفَلُ':Subject, #1: 1	صَلُحَ الْأَثَاثُ
u'صَلَحَ أَمْرٌ':Subject, #2: 2	صَلَحَ الْأَسْفَلُ
u'صَلَحَ بَدَلٌ':Predicate, #1: 1	صَلَحَ الْأَمْرُ
u'صَلُحَ تَأْدِيبٌ':Subject, #1: 1	صَلَحَ بَدَلَ
u'صَلُحَ ثَمَرٌ':Subject, #2: 2	صَلُحَ تَأْدِيبُهُ
u'صَلُحَ جَازٌ':Predicate, #1: 1	صَلُحَ الثَّمَرُ
u'صَلُحَ جَسَدٌ':Subject, #1: 1	صَلُحَ جَازَ
u'صَلَحَ جَسَدٌ':Subject, #1: 1	صَلُحَ الْجَسَدُ
u'صَلُحَ جَمَاعَةٌ':Subject, #3: 3	صَلَحَ الْجَسَدُ
u'صَلُحَ حالٌ':Subject, #1: 1	صَلُحَ جَمَاعَةٌ
u'صَلُحَ رَدٌّ':Subject, #1: 1	صَلُحَ حَالُهُ
u'صَلُحَ سَائِرٌ':Subject, #1: 1	صَلُحَ الرَّدُّ
u'صَلُحَ شَيْءٌ':Subject, #1: 1	صَلُحَ سَائِرُ
u'صَلَحَ صَدْرٌ':Subject, #1: 1	صَلُحَ شَيْءٌ
u'صَلَحَ عَائِدٌ':Subject, #1: 1	صَلَحَ الصَّدْرُ
u'صَلُحَ عَبْدٌ':Subject, #1: 1	صَلَحَ الْعَائِدُ
u'صَلَحَ فِعْلٌ':Subject, #2: 2	صَلُحَ الْعَبْدُ
u'صَلُحَ قول':Subject, #4: 4	صَلَحَ فِعْلُهُ
u'صَلُحَ قَوْلٌ':Subject, #1: 1	صَلُحَ قَوْلُهُ
u'صَلَحَ مَالٌ':Subject, #1: 1	صَلُحَ قَوْلُهُ
u'صَلَحَ مُحَكَّمٌ':Subject, #1: 1	صَلَحَ الْمَالُ
u'صَلُحَ نَاسٌ':Subject, #2: 2	صَلَحَ الْمُحَكَّمُ
u'صَلْصَلَةٌ جَرَسٌ':Added, #2: 2	صَلُحَ النَّاسُ
u'صَلْصَلَةٌ حَديدٌ':Added, #3: 3	صَلْصَلَةِ الْجَرَسِ
u'صَلَّ لَحْمٌ':Subject, #1: 1	صَلْصَلَةُ الْحَدِيدِ
u'صَلَوَاتٌ اللهُ':Added, #1: 1	صَلَّ اللَّحْمُ
u'صَلَوَاتٌ أيَّامٌ':Added, #3: 3	صَلَوَاتُ اللهِ
u'صَلَوَاتٌ أَيَّامٌ':Added, #3: 3	صَلَوَاتِ أَيَّامِ
u'صَلَوَاتٌ تَيَمُّمٌ':Added, #3: 3	صَلَوَاتِ أَيَّامِ
u'صَلَوَاتٌ ثَلاثَةٌ':Added, #1: 1	صَلَوَاتِ التَّيَمُّمِ
u'صَلَوَاتٌ جهر':Added, #1: 1	صَلَوَاتِ ثَلَاثَةِ
u'صَلَوَاتٌ جَهْرٌ':Added, #1: 1	صَلَوَاتِ الْجَهْرِ
u'صَلَوَاتٌ رِدَّةٌ':Added, #1: 1	صَلَوَاتِ الْجَهْرِ
u'صَلَوَاتٌ رَسُولٌ':Added, #1: 1	صَلَوَاتِ الرِّدَّةِ
u'صَلَوَاتٌ زَمَنٌ':Added, #1: 1	صَلَوَاتُ رَسُولِ
u'صَلَوَاتٌ سَبْعَةٌ':Added, #1: 1	صَلَوَاتِ زَمَنِ
u'صَلَوَاتٌ سَنَةٌ':Added, #1: 1	صَلَوَاتِ سَبْعَةِ
u'صَلَوَاتٌ شَهْرٌ':Added, #1: 1	صَلَوَاتُ سَنَةٍ
u'صَلَوَاتٌ شَهْرٌ':Added, #2: 2	صَلَوَاتُ شَهْرٍ
u'صَلَوَاتٌ عَشْرٌ':Added, #3: 3	صَلَوَاتِ شَهْرٍ
u'صَلَوَاتٌ عُمُرٌ':Added, #1: 1	صَلَوَاتِ عَشْرَةِ
u'صَلَوَاتٌ لَيْلٌ':Added, #1: 1	صَلَوَاتِ عُمُرِهِ
u'صَلَوَاتٌ نَدْبٌ':Added, #3: 3	صَلَوَاتِ اللَّيْلِ
u'صَلَوَاتٌ نهار':Added, #1: 1	صَلَوَاتِ النَّدْبِ
u'صَلَوَاتٌ نَهَارٌ':Added, #3: 3	صَلَوَاتِ النَّهَارِ
u'صَلَوَاتٌ وُضُوءٌ':Added, #3: 3	صَلَوَاتِ النَّهَارِ
u'صَلَوَاتٌ يَوْمٌ':Added, #1: 1	صَلَوَاتِ الْوُضُوءِ
u'صَلَوَاتٌ يَوْمٌ':Added, #1: 1	صَلَوَاتِ الْيَوْمِ
u'صَلَّى أَبْعَدُ':Subject, #2: 2	صَلَوَاتِ يَوْمٍ
u'صَلَّى اِبْنٌ':Subject, #1: 1	صَلَّى الْأَبْعَدُ
u'صَلَّى أَثْلاثٌ':Predicate, #8: 8	صَلَّى ابْنُ
u'صَلَّى أَجْنَبِيٌّ':Subject, #2: 2	صَلَّى أَثْلَاثَ
u'صَلَّى أحَدٌ':Predicate, #1: 1	صَلَّى الْأَجْنَبِيُّ
u'صَلَّى أحَدٌ':Subject, #1: 1	صَلَّى أَحَدَ
u'صَلَّى آخِرُ':Predicate, #1: 1	صَلَّى أَحَدٌ
u'صَلَّى أَرْبَعُ':Predicate, #2: 2	صَلَّى آخِرَ
u'صَلَّى أَرْبَعُ':Predicate, #22: 22	صَلَّى أَرْبَعَ
u'صَلَّى أَزْواجٌ':Subject, #2: 2	صَلَّى الْأَرْبَعَ
u'صَلَّى أقَلُّ':Predicate, #1: 1	صَلَّى أَزْوَاجُ
u'صَلَّى أَكْثَرُ':Predicate, #1: 1	صَلَّى أَقَلَّ
u'صَلَّى اللهُ':Subject, #1: 1	صَلَّى أَكْثَرَ
u'صَلَّى إلَهٌ':Subject, #29: 29	صَلَّى اللهُ
u'صَلَّى إمَامٌ':Subject, #1: 1	صَلَّى الْإِلَهُ
u'صَلَّى إمَامٌ':Subject, #1: 1	صَلَّى إمَامُ
u'صَلَّى إمَامٌ':Subject, #1: 1	صَلَّى إِمَامُهُ
u'صَلَّى إمَامٌ':Subject, #4: 4	صَلَّى الإِمَامُ
u'صَلَّى إمَامٌ':Subject, #5: 5	صَلَّى إمَامٌ
u'صَلَّى أُمِّيٌّ':Subject, #65: 65	صَلَّى الْإِمَامُ
u'صَلَّى أُمِّيٌّ':Subject, #1: 1	صَلَّى الْأُمِّيُّ
u'صَلَّى أَميرٌ':Subject, #2: 2	صَلَّى أُمِّيٌّ
u'صَلَّى إِنْسانٌ':Subject, #1: 1	صَلَّى أَمِيرُ
u'صَلَّى إِنْسانٌ':Subject, #1: 1	صَلَّى الْإِنْسَانُ
u'صَلَّى أهْلٌ':Subject, #2: 2	صَلَّى إنْسَانٌ
u'صَلَّى أَوَّلُ':Predicate, #6: 6	صَلَّى أَهْلُ
u'صَلَّى أَوَّلُ':Subject, #3: 3	صَلَّى أَوَّلَ
u'صَلَّى أئِمَّةٌ':Subject, #1: 1	صَلَّى الْأَوَّلُ
u'صَلَّى بَصيرٌ':Subject, #1: 1	صَلَّى الْأَئِمَّةُ
u'صَلَّى بَعْضٌ':Predicate, #1: 1	صَلَّى الْبَصِيرُ
u'صَلَّى بَعْضٌ':Subject, #13: 13	صَلَّى بَعْضَ
u'صَلَّى بَيْنٌ':Predicate, #2: 2	صَلَّى بَعْضُ
u'صَلَّى تَاسِعٌ':Predicate, #7: 7	صَلَّى بَيْنَ
u'صَلَّى تَحِيَّةٌ':Predicate, #1: 1	صَلَّى التَّاسِعَةَ
u'صَلَّى تَحِيَّةٌ':Predicate, #3: 3	صَلَّى تَحِيَّةَ
u'صَلَّى تَرَاوِيحُ':Predicate, #5: 5	صَلَّى التَّحِيَّةَ
u'صَلَّى تَرْوِيحَةٌ':Predicate, #19: 19	صَلَّى التَّرَاوِيحَ
u'صَلَّى تَرْوِيحَة':Predicate, #1: 1	صَلَّى التَّرْوِيحَةَ
u'صَلَّى تَشَهُّدٌ':Predicate, #1: 1	صَلَّى التَّرْوِيحَةَ
u'صَلَّى تَطَوُّعٌ':Predicate, #1: 1	صَلَّى التَّشَهُّدَ
u'صَلَّى تمام':Predicate, #6: 6	صَلَّى التَّطَوُّعَ
u'صَلَّى تَمامٌ':Predicate, #1: 1	صَلَّى تَمَامَ
u'صَلَّى ثَالِثٌ':Predicate, #1: 1	صَلَّى تَمَامَ
u'صَلَّى ثَانِي':Predicate, #1: 1	صَلَّى ثَالِثَةً
u'صَلَّى ثَانِي':Predicate, #1: 1	صَلَّى ثَانِيَةً
u'صَلَّى ثَانِيَةٌ':Predicate, #5: 5	صَلَّى الثَّانِيَةَ
u'صَلَّى ثَلاثُ':Predicate, #5: 5	صَلَّى الثَّانِيَةَ
u'صَلَّى ثَلاثُ':Predicate, #1: 1	صَلَّى الثَّلَاثَ
u'صَلَّى ثَلاثُ':Predicate, #1: 1	صَلَّى ثَلاَثَ
u'صَلَّى ثَلاثَةٌ':Predicate, #9: 9	صَلَّى ثَلَاثَ
u'صَلَّى ثَلاثَةٌ':Predicate, #1: 1	صَلَّى الثَّلَاثَةَ
u'صَلَّى ثَلاثَةٌ':Subject, #1: 1	صَلَّى ثَلَاثَةَ
u'صَلَّى جَابِرٌ':Subject, #1: 1	صَلَّى ثَلاَثَةُ
u'صَلَّى جَازٌ':Predicate, #1: 1	صَلَّى جَابِرٌ
u'صَلَّى جَخّ':Predicate, #2: 2	صَلَّى جَازَ
u'صَلَّى جَمَاعَةٌ':Subject, #2: 2	صَلَّى جَخَّ
u'صَلَّى جمعة':Predicate, #3: 3	صَلَّى جَمَاعَةٌ
u'صَلَّى جُمُعَةٌ':Predicate, #34: 34	صَلَّى الْجُمُعَةَ
u'صَلَّى حاجٌّ':Subject, #34: 34	صَلَّى الْجُمُعَةَ
u'صَلَّى حاضِرٌ':Predicate, #1: 1	صَلَّى الْحَاجُّ
u'صَلَّى حاضِرٌ':Predicate, #1: 1	صَلَّى حَاضِرَةً
u'صَلَّى حامِلٌ':Subject, #2: 2	صَلَّى الْحَاضِرَةَ
u'صَلَّى حَرٌّ':Predicate, #1: 1	صَلَّى حَامِلُ
u'صَلَّى حَسَبٌ':Predicate, #1: 1	صَلَّى حَرَّكَ
u'صَلَّى حَقِيقَةٌ':Subject, #1: 1	صَلَّى حَسَبَ
u'صَلَّى خامس':Predicate, #1: 1	صَلَّى حَقِيقَةٌ
u'صَلَّى خَامِسٌ':Predicate, #3: 3	صَلَّى خَامِسَةً
u'صَلَى خَلَفٌ':Predicate, #3: 3	صَلَّى خَامِسَةً
u'صَلَّى خَلْفٌ':Predicate, #1: 1	صَلَى خَلَفَ
u'صَلَّى خَلِيفَةٌ':Subject, #62: 62	صَلَّى خَلْفَ
u'صَلَّى خَمْسٌ':Predicate, #1: 1	صَلَّى الْخَلِيفَةُ
u'صَلَّى خَمْسٌ':Predicate, #4: 4	صَلَّى خَمْسَ
u'صَلَّى دَخَلٌ':Predicate, #7: 7	صَلَّى الْخَمْسَ
u'صَلَّى دونٌ':Predicate, #2: 2	صَلَّى دَخَلَ
u'صَلَّى رابع':Predicate, #1: 1	صَلَّى دُونَ
u'صَلَّى رَابِعٌ':Predicate, #1: 1	صَلَّى رَابِعَةً
u'صَلَّى رابع':Predicate, #1: 1	صَلَّى رَابِعَةً
u'صَلَّى رَابِعٌ':Predicate, #3: 3	صَلَّى الرَّابِعَةَ
u'صَلَّى رِجَالٌ':Subject, #3: 3	صَلَّى الرَّابِعَةَ
u'صَلَّى رَجُلٌ':Subject, #1: 1	صَلَّى الرِّجَالُ
u'صَلَّى رَجُلٌ':Subject, #10: 10	صَلَّى رَجُلٌ
u'صَلَّى رَسُولٌ':Subject, #6: 6	صَلَّى الرَّجُلُ
u'صَلَّى ركعة':Predicate, #130: 130	صَلَّى رَسُولُ
u'صَلَّى رَكْعَةٌ':Predicate, #1: 1	صَلَّى الرَّكْعَةَ
u'صَلَّى سَابِقٌ':Subject, #1: 1	صَلَّى الرَّكْعَةَ
u'صَلَّى سادس':Predicate, #1: 1	صَلَّى السَّابِقُ
u'صَلَّى سَادِسٌ':Predicate, #3: 3	صَلَّى السَّادِسَةَ
u'صَلَّى سبحة':Predicate, #3: 3	صَلَّى السَّادِسَةَ
u'صَلَّى سُبْحَةٌ':Predicate, #3: 3	صَلَّى سُبْحَةَ
u'صَلَّى سَبْعٌ':Predicate, #3: 3	صَلَّى سُبْحَةَ
u'صَلَّى سِتٌّ':Predicate, #2: 2	صَلَّى سَبْعَ
u'صَلَّى سقط':Predicate, #11: 11	صَلَّى سِتَّ
u'صَلَّى سَقَطٌ':Predicate, #1: 1	صَلَّى سَقَطَ
u'صَلَّى سُلْطَانٌ':Subject, #1: 1	صَلَّى سَقَطَ
u'صَلَّى سُنَّةٌ':Predicate, #4: 4	صَلَّى السُّلْطَانُ
u'صَلَّى سُنَّةٌ':Predicate, #3: 3	صَلَّى السُّنَّةَ
u'صَلَّى سَيِّدٌ':Subject, #5: 5	صَلَّى سُنَّةَ
u'صَلَّى شَاهِدٌ':Subject, #1: 1	صَلَّى سَيِّدُهُ
u'صَلَّى شَخْصٌ':Subject, #1: 1	صَلَّى شَاهِدٌ
u'صَلَّى شَرَعٌ':Predicate, #2: 2	صَلَّى شَخْصٌ
u'صَلَّى شَفْعٌ':Predicate, #1: 1	صَلَّى شَرَعَ
u'صَلَّى صَاحِبٌ':Subject, #5: 5	صَلَّى الشَّفْعَ
u'صَلَّى صَاحِبٌ':Subject, #1: 1	صَلَّى صَاحِبُهُ
u'صَلَّى صُبْحٌ':Predicate, #4: 4	صَلَّى صَاحِبُ
u'صَلَّى صَبِيٌّ':Subject, #63: 63	صَلَّى الصُّبْحَ
u'صَلَّى صَحَابَةٌ':Subject, #2: 2	صَلَّى الصَّبِيُّ
u'صَلَّى صَحِيحٌ':Subject, #2: 2	صَلَّى الصَّحَابَةُ
u'صَلَّى صُفُوفٌ':Subject, #2: 2	صَلَّى الصَّحِيحُ
u'صَلَّى صَلاَةٌ':Predicate, #1: 1	صَلَّى صُفُوفٌ
u'صَلَّى صَلاَةٌ':Predicate, #14: 14	صَلَّى صَلاَةَ
u'صَلَّى صَلاَةٌ':Predicate, #1: 1	صَلَّى الصَّلاةَ
u'صَلَّى صَلاَةٌ':Predicate, #1: 1	صَلَّى الصَّلاَةَ
u'صَلَّى صَلاَةٌ':Predicate, #2: 2	صَلَّى الصَّلَاةَ
u'صَلَّى صَلاَةٌ':Predicate, #3: 3	صَلَّى صَلاةَ
u'صَلَّى ظُهْرٌ':Predicate, #47: 47	صَلَّى صَلَاةَ
u'صَلَّى عَبْدٌ':Subject, #202: 202	صَلَّى الظُّهْرَ
u'صَلَّى عَبْدٌ':Subject, #3: 3	صَلَّى عَبْدُ
u'صَلَّى عتمة':Predicate, #4: 4	صَلَّى الْعَبْدُ
u'صَلَّى عَتَمَةٌ':Predicate, #2: 2	صَلَّى الْعَتَمَةَ
u'صَلَّى عِشَاءٌ':Predicate, #2: 2	صَلَّى الْعَتَمَةَ
u'صَلَّى عَشْرٌ':Predicate, #71: 71	صَلَّى الْعِشَاءَ
u'صَلَّى عَصْرٌ':Predicate, #2: 2	صَلَّى عَشْرَ
u'صَلَّى عَقِبٌ':Predicate, #55: 55	صَلَّى الْعَصْرَ
u'صَلَّى عَقِيبٌ':Predicate, #3: 3	صَلَّى عَقِبَ
u'صَلَّى عَلِيٌّ':Subject, #1: 1	صَلَّى عَقِيبَ
u'صَلَّى عُمَرٌ':Subject, #2: 2	صَلَّى عَلِيٌّ
u'صَلَّى عند':Predicate, #4: 4	صَلَّى عُمَرُ
u'صَلَّى عِيدٌ':Predicate, #2: 2	صَلَّى عِنْدَ
u'صَلَّى غداة':Predicate, #13: 13	صَلَّى الْعِيدَ
u'صَلَّى غَدَاةٌ':Predicate, #11: 11	صَلَّى الْغَدَاةَ
u'صَلَّى غير':Predicate, #11: 11	صَلَّى الْغَدَاةَ
u'صَلَّى غَيْرٌ':Predicate, #4: 4	صَلَّى غَيْرَ
u'صَلَّى غير':Subject, #4: 4	صَلَّى غَيْرَ
u'صَلَّى غَيْرٌ':Subject, #3: 3	صَلَّى غَيْرُهُ
u'صَلَّى غير':Subject, #3: 3	صَلَّى غَيْرُهُ
u'صَلَّى غَيْرٌ':Subject, #5: 5	صَلَّى غَيْرُ
u'صَلَّى فَاقِدٌ':Predicate, #5: 5	صَلَّى غَيْرُ
u'صَلَّى فَاقِدٌ':Subject, #1: 1	صَلَّى فَاقِدَ
u'صَلَّى فَجْرٌ':Predicate, #1: 1	صَلَّى فَاقِدُ
u'صَلَّى فَرْضٌ':Predicate, #50: 50	صَلَّى الْفَجْرَ
u'صَلَّى فَرْضٌ':Predicate, #12: 12	صَلَّى الْفَرْضَ
u'صَلَّى فَرِيضَةٌ':Predicate, #1: 1	صَلَّى فَرْضَ
u'صَلَّى فَلًا':Predicate, #6: 6	صَلَّى الْفَرِيضَةَ
u'صَلَّى فلان':Subject, #1: 1	صَلَّى فَلاَ
u'صَلَّى فلان':Subject, #1: 1	صَلَّى الزُّبَيْرُ
u'صَلَّى فلان':Subject, #2: 2	صَلَّى مُعَاوِيَةُ
u'صَلَّى فُلاَنٌ':Subject, #2: 2	صَلَّى مَكِّيٌّ
u'صَلَّى فلان':Subject, #3: 3	صَلَّى فُلَانٌ
u'صَلَّى فَوَائِدُ':Subject, #4: 4	صَلَّى عُثْمَانُ
u'صَلَّى قَابِلٌ':Predicate, #1: 1	صَلَّى فَوَائِدُ
u'صَلَّى قَادِمٌ':Subject, #1: 1	صَلَّى الْقَابِلَةَ
u'صَلَّى قَارِئٌ':Subject, #1: 1	صَلَّى الْقَادِمُ
u'صَلَّى قَارِئٌ':Subject, #1: 1	صَلَّى الْقَارِئُ
u'صَلَّى قَالٌ':Predicate, #1: 1	صَلَّى قَارِئٌ
u'صَلَّى قِبَلٌ':Predicate, #5: 5	صَلَّى قَالَ
u'صَلَّى قتل':Predicate, #3: 3	صَلَّى قِبَلَ
u'صَلَّى قَوْمٌ':Subject, #1: 1	صَلَّى قُتِلَ
u'صَلَّى كَافِرٌ':Subject, #1: 1	صَلَّى قَوْمٌ
u'صَلَّى كَافِرٌ':Subject, #2: 2	صَلَّى الْكَافِرُ
u'صَلَّى لَيْلٌ':Predicate, #2: 2	صَلَّى كَافِرٌ
u'صَلَّى مثل':Predicate, #1: 1	صَلَّى لَيْلَةً
u'صَلَّى مِثْلٌ':Predicate, #3: 3	صَلَّى مِثْلَ
u'صَلَّى مرٌّ':Predicate, #3: 3	صَلَّى مِثْلَ
u'صَلَّى مَرِيضٌ':Subject, #11: 11	صَلَّى مَرَّةً
u'صَلَّى مُسَافِرٌ':Subject, #5: 5	صَلَّى الْمَرِيضُ
u'صَلَّى مُسَافِرٌ':Subject, #14: 14	صَلَّى الْمُسَافِرُ
u'صَلَّى مُعاوِيَة':Subject, #2: 2	صَلَّى مُسَافِرٌ
u'صَلَّى مَعْذُورٌ':Subject, #2: 2	صَلَّى مُعَاوِيَةُ
u'صَلَّى مَعْذُورٌ':Subject, #1: 1	صَلَّى الْمَعْذُورُ
u'صَلَّى مَغْرِبٌ':Predicate, #1: 1	صَلَّى مَعْذُورٌ
u'صَلَّى مُقِيمٌ':Subject, #80: 80	صَلَّى الْمَغْرِبَ
u'صَلَّى مَكْتُوبٌ':Predicate, #2: 2	صَلَّى مُقِيمٌ
u'صَلَّى مَكْتُوبٌ':Predicate, #3: 3	صَلَّى الْمَكْتُوبَةَ
u'صَلَّى مَكْشُوفٌ':Predicate, #3: 3	صَلَّى مَكْتُوبَةً
u'صَلَّى مَكِّيّ':Subject, #2: 2	صَلَّى مَكْشُوفَ
u'صَلَّى مَنْذُور':Predicate, #2: 2	صَلَّى مَكِّيٌّ
u'صَلَّى نَاسٌ':Subject, #2: 2	صَلَّى مَنْذُورَةً
u'صَلَّى نَبِيٌّ':Subject, #14: 14	صَلَّى النَّاسُ
u'صَلَّى نَبِيٌّ':Subject, #18: 18	صَلَّى النَّبِيُّ
u'صَلَّى نِساءٌ':Subject, #2: 2	صَلَّى نَبِيُّ
u'صَلَّى نِسْوَةٌ':Subject, #1: 1	صَلَّى النِّسَاءُ
u'صَلَّى نَفَلٌ':Predicate, #1: 1	صَلَّى نِسْوَةٌ
u'صَلَّى نَوَافِلُ':Predicate, #2: 2	صَلَّى النَّفَلَ
u'صَلَّى نَوْعٌ':Subject, #1: 1	صَلَّى نَوَافِلَ
u'صَلَّى وَاجِبٌ':Predicate, #1: 1	صَلَّى نَوْعٌ
u'صَلَّى واحد':Predicate, #1: 1	صَلَّى الْوَاجِبَ
u'صَلَّى وَاحِدٌ':Predicate, #5: 5	صَلَّى وَاحِدَةً
u'صَلَّى واحد':Subject, #5: 5	صَلَّى وَاحِدَةً
u'صَلَّى وَاحِدٌ':Subject, #2: 2	صَلَّى وَاحِدٌ
u'صَلَّى وَاقِعٌ':Subject, #2: 2	صَلَّى وَاحِدٌ
u'صَلَّى وَاقِفٌ':Subject, #1: 1	صَلَّى وَاقِعٌ
u'صَلَّى وَتَرٌ':Predicate, #1: 1	صَلَّى الْوَاقِفُ
u'صَلَّى وَراء':Predicate, #1: 1	صَلَّى وَتَرَكَ
u'صَلَّى وَقْت':Predicate, #1: 1	صَلَّى وَرَاءَ
u'صَلَّى وَقْت':Predicate, #1: 1	صَلَّى وَقْتِيَّةً
u'صَلَّى وَقْتِيّ':Predicate, #2: 2	صَلَّى الْوَقْتِيَّةَ
u'صَلَّى وَقْتِيّ':Predicate, #1: 1	صَلَّى وَقْتِيَّةً
u'صَلَّى وَلِيٌّ':Subject, #2: 2	صَلَّى الْوَقْتِيَّةَ
u'صَلَّى يَوْمٌ':Predicate, #11: 11	صَلَّى الْوَلِيُّ
u'صَمَتَ رَسُولٌ':Subject, #11: 11	صَلَّى يَوْمَ
u'صمت يَوْمٌ':Added, #1: 1	صَمَتَ رَسُولُ
u'صَمْتٌ يَوْمٌ':Added, #2: 2	صَمْتَ يَوْمٍ
u'صَمَدَ حَشْوٌ':Subject, #2: 2	صَمْتَ يَوْمٍ
u'صَمَّمَ أحَدٌ':Subject, #1: 1	صَمَدَ حَشْوٌ
u'صَمَمٌ أَصْلِيٌّ':Added, #1: 1	صَمَّمَ أَحَدٌ
u'صَمَّمَ عَزْمٌ':Subject, #1: 1	صَمَمٍ أَصْلِيٍّ
u'صَمَّمَ مَالِكٌ':Subject, #1: 1	صَمَّمَ الْعَزْمُ
u'صَنَعَ أَبٌ':Subject, #1: 1	صَمَّمَ الْمَالِكُ
u'صَنَعَ اِبْنٌ':Subject, #4: 4	صَنَعَ الْأَبُ
u'صَنَعَ اِبْنٌ':Subject, #1: 1	صَنَعَ ابْنُ
u'صَنَعَ أَجْنَبِيٌّ':Subject, #1: 1	صَنَعَ ابْنُهُ
u'صنع أحَدٌ':Added, #1: 1	صَنَعَ الْأَجْنَبِيُّ
u'صُنْعٌ أحَدٌ':Added, #11: 11	صُنْعِ أَحَدٍ
u'صَنَعَ أَصْحَابٌ':Subject, #11: 11	صُنْعِ أَحَدٍ
u'صَنَعَ أصل':Subject, #1: 1	صَنَعَ أَصْحَابُ
u'صَنَعَ أًصْلٌ':Subject, #2: 2	صَنَعَ الْأَصْلُ
u'صنع أصل':Added, #2: 2	صَنَعَ الْأَصْلُ
u'صنع أًصْلٌ':Added, #1: 1	صُنْعِ أَصْلِهِ
u'صُنْعٌ أصل':Added, #1: 1	صُنْعِ أَصْلِهِ
u'صُنْعٌ أًصْلٌ':Added, #1: 1	صُنْعِ أَصْلِهِ
u'صنع الْمَرْءُ':Added, #1: 1	صُنْعِ أَصْلِهِ
u'صُنْعٌ الْمَرْءُ':Added, #1: 1	صُنْعِ الْمَرْءِ
u'صنع إلَهٌ':Added, #1: 1	صُنْعِ الْمَرْءِ
u'صُنْعٌ إلَهٌ':Added, #1: 1	صُنْعِ الْإِلَهِ
u'صَنَعَ إمَامٌ':Subject, #1: 1	صُنْعِ الْإِلَهِ
u'صَنَعَ أَمْرٌ':Predicate, #2: 2	صَنَعَ الْإِمَامُ
u'صَنَعَ أهْلٌ':Subject, #1: 1	صَنَعَ الأَمْرَ
u'صَنَعَ أَوَّلُ':Subject, #2: 2	صَنَعَ أَهْلُ
u'صنعة إِناءٌ':Added, #5: 5	صَنَعَ الْأَوَّلُ
u'صَنْعَةٌ إِناءٌ':Added, #1: 1	صَنْعَةِ الْإِنَاءِ
u'صنعة أهْلٌ':Added, #1: 1	صَنْعَةِ الْإِنَاءِ
u'صَنْعَةٌ أهْلٌ':Added, #1: 1	صَنْعَةِ أَهْلِ
u'صنعة تَجْنِيس':Added, #1: 1	صَنْعَةِ أَهْلِ
u'صَنْعَةٌ تَجْنِيس':Added, #1: 1	صَنْعَةُ التَّجْنِيسِ
u'صنعة جَدَلٌ':Added, #1: 1	صَنْعَةُ التَّجْنِيسِ
u'صَنْعَةٌ جَدَلٌ':Added, #1: 1	صَنْعَةِ الْجَدَلِ
u'صنعة دَبَّابَةٌ':Added, #1: 1	صَنْعَةِ الْجَدَلِ
u'صَنْعَةٌ دَبَّابَةٌ':Added, #2: 2	صَنْعَةَ الدّبّابَاتِ
u'صنعة دنيئة':Added, #2: 2	صَنْعَةَ الدّبّابَاتِ
u'صَنْعَةٌ دنيئة':Added, #1: 1	صَنْعَةٍ دَنِيئَةٍ
u'صنعة رِجَالٌ':Added, #1: 1	صَنْعَةٍ دَنِيئَةٍ
u'صَنْعَةٌ رِجَالٌ':Added, #3: 3	صَنْعَةِ الرِّجَالِ
u'صنعة شَعْرٌ':Added, #3: 3	صَنْعَةِ الرِّجَالِ
u'صَنْعَةٌ شَعْرٌ':Added, #1: 1	صَنْعَةِ الشَّعْرِ
u'صنعة شَيْءٌ':Added, #1: 1	صَنْعَةِ الشَّعْرِ
u'صَنْعَةٌ شَيْءٌ':Added, #1: 1	صَنْعَةِ شَيْءٍ
u'صنعة طعام':Added, #1: 1	صَنْعَةِ شَيْءٍ
u'صنعة طَعَامٌ':Added, #1: 1	صَنْعَةِ طَعَامٍ
u'صَنْعَةٌ طعام':Added, #1: 1	صَنْعَةِ طَعَامٍ
u'صَنْعَةٌ طَعَامٌ':Added, #1: 1	صَنْعَةِ طَعَامٍ
u'صنعة عَرَبِيٌّ':Added, #1: 1	صَنْعَةِ طَعَامٍ
u'صَنْعَةٌ عَرَبِيٌّ':Added, #1: 1	صَنْعَةِ الْعَرَبِيّةِ
u'صنعة فُلُوسٌ':Added, #1: 1	صَنْعَةِ الْعَرَبِيّةِ
u'صَنْعَةٌ فُلُوسٌ':Added, #2: 2	صَنْعَةِ الْفُلُوسِ
u'صنعة لَفٌّ':Added, #2: 2	صَنْعَةِ الْفُلُوسِ
u'صَنْعَةٌ لَفٌّ':Added, #1: 1	صَنْعَةُ اللَّفِّ
u'صنعة مثل':Added, #1: 1	صَنْعَةُ اللَّفِّ
u'صنعة مِثْلٌ':Added, #1: 1	صَنْعَةِ مِثْلِهِ
u'صَنْعَةٌ مثل':Added, #1: 1	صَنْعَةِ مِثْلِهِ
u'صَنْعَةٌ مِثْلٌ':Added, #1: 1	صَنْعَةِ مِثْلِهِ
u'صنعة مَزْجٌ':Added, #1: 1	صَنْعَةِ مِثْلِهِ
u'صَنْعَةٌ مَزْجٌ':Added, #1: 1	صَنْعَةَ الْمَزْجِ
u'صنعة واحد':Added, #1: 1	صَنْعَةَ الْمَزْجِ
u'صنعة وَاحِدٌ':Added, #4: 4	صَنْعَةٍ وَاحِدَةٍ
u'صَنْعَةٌ واحد':Added, #4: 4	صَنْعَةٍ وَاحِدَةٍ
u'صَنْعَةٌ وَاحِدٌ':Added, #4: 4	صَنْعَةٍ وَاحِدَةٍ
u'صنع تُجَّارٌ':Added, #4: 4	صَنْعَةٍ وَاحِدَةٍ
u'صُنْعٌ تُجَّارٌ':Added, #1: 1	صُنْعُ التُّجَّارِ
u'صنع تُجَّارٌ':Added, #1: 1	صُنْعُ التُّجَّارِ
u'صُنْعٌ تُجَّارٌ':Added, #5: 5	صُنْعِ التُّجَّارِ
u'صنع تِجَارَةٌ':Added, #5: 5	صُنْعِ التُّجَّارِ
u'صُنْعٌ تِجَارَةٌ':Added, #3: 3	صُنْعِ التِّجَارَةِ
u'صَنَعَ ثَعْلَبٌ':Subject, #3: 3	صُنْعِ التِّجَارَةِ
u'صَنَعَ جَابِرٌ':Subject, #1: 1	صَنَعَ ثَعْلَبَةُ
u'صَنَعَ جَازٌ':Predicate, #2: 2	صَنَعَ جَابِرٌ
u'صَنَعَ حاطِبٌ':Subject, #4: 4	صَنَعَ جَازَ
u'صَنَعَ حاكِمٌ':Subject, #1: 1	صَنَعَ حَاطِبٌ
u'صَنَعَ خَادِمٌ':Subject, #1: 1	صَنَعَ الْحَاكِمُ
u'صَنَعَ خَالِدٌ':Subject, #1: 1	صَنَعَ خَادِمُ
u'صَنَعَ خَالِدٌ':Subject, #3: 3	صَنَعَ خَالِدٌ
u'صَنَعَ ذِمِّيٌّ':Subject, #3: 3	صَنَعَ خَالِدُ
u'صَنَعَ رَجُلٌ':Subject, #1: 1	صَنَعَ الذِّمِّيُّ
u'صَنَعَ رَجُلٌ':Subject, #1: 1	صَنَعَ الرَّجُلُ
u'صَنَعَ رَسُولٌ':Subject, #1: 1	صَنَعَ رَجُلٌ
u'صَنَعَ رَهْطٌ':Predicate, #17: 17	صَنَعَ رَسُولُ
u'صَنَعَ رُومٌ':Subject, #1: 1	صَنَعَ الرّهْطَ
u'صَنَعَ زَوْجٌ':Subject, #1: 1	صَنَعَ الرُّومُ
u'صنع زَوْجٌ':Added, #1: 1	صَنَعَ الزَّوْجُ
u'صُنْعٌ زَوْجٌ':Added, #1: 1	صُنْعُ الزَّوْجِ
u'صَنَعَ سَارِقٌ':Subject, #1: 1	صُنْعُ الزَّوْجِ
u'صَنَعَ سَالِمٌ':Subject, #1: 1	صَنَعَ السَّارِقُ
u'صَنَعَ شَيْءٌ':Subject, #1: 1	صَنَعَ سَالِمٌ
u'صنع صَاحِبٌ':Added, #1: 1	صَنَعَ شَيْءٌ
u'صُنْعٌ صَاحِبٌ':Added, #2: 2	صُنْعِ صَاحِبِهِ
u'صنع طعام':Added, #2: 2	صُنْعِ صَاحِبِهِ
u'صُنْعٌ طعام':Added, #2: 2	صُنْعُ طَعَامٍ
u'صنع طَعَامٌ':Added, #2: 2	صُنْعُ طَعَامٍ
u'صُنْعٌ طَعَامٌ':Added, #2: 2	صُنْعُ طَعَامٍ
u'صنع عِبَادٌ':Added, #2: 2	صُنْعُ طَعَامٍ
u'صُنْعٌ عِبَادٌ':Added, #4: 4	صُنْعِ الْعِبَادِ
u'صَنَعَ عَبَّاسٌ':Subject, #4: 4	صُنْعِ الْعِبَادِ
u'صَنَعَ عَبْدٌ':Subject, #1: 1	صَنَعَ الْعَبَّاسُ
u'صَنَعَ عَبْدٌ':Subject, #1: 1	صَنَعَ عَبْدُ
u'صَنَعَ عَلِيٌّ':Subject, #2: 2	صَنَعَ الْعَبْدُ
u'صنع عَلِيٌّ':Added, #2: 2	صَنَعَ عَلِيٌّ
u'صُنْعٌ عَلِيٌّ':Added, #1: 1	صُنْعِ عَلِيٍّ
u'صَنَعَ عُمَرٌ':Subject, #1: 1	صُنْعِ عَلِيٍّ
u'صَنَعَ غير':Predicate, #1: 1	صَنَعَ عُمَرُ
u'صَنَعَ غَيْرٌ':Predicate, #1: 1	صَنَعَ غَيْرَ
u'صَنَعَ فَرِيقٌ':Subject, #1: 1	صَنَعَ غَيْرَ
u'صَنَعَ قَاتِلٌ':Subject, #2: 2	صَنَعَ الْفَرِيقُ
u'صَنَعَ قَالٌ':Predicate, #1: 1	صَنَعَ الْقَاتِلُ
u'صَنَعَ قَوْمٌ':Subject, #2: 2	صَنَعَ قَالَ
u'صَنَعَ كَفَّارَةٌ':Subject, #1: 1	صَنَعَ الْقَوْمُ
u'صَنَعَ مَالِكٌ':Subject, #1: 1	صَنَعَ كَفَّارَةٌ
u'صَنَعَ مثل':Predicate, #1: 1	صَنَعَ مَالِكُ
u'صَنَعَ مِثْلٌ':Predicate, #7: 7	صَنَعَ مِثْلَ
u'صَنَعَ مَحْجُورٌ':Subject, #7: 7	صَنَعَ مِثْلَ
u'صَنَعَ مُخْبِرٌ':Subject, #1: 1	صَنَعَ الْمَحْجُورُ
u'صَنَعَ مُسْتَأْجِرٌ':Subject, #1: 1	صَنَعَ الْمُخْبِرُ
u'صَنَعَ مَسْرُوقٌ':Subject, #1: 1	صَنَعَ الْمُسْتَأْجِرُ
u'صَنَعَ مَسْرُوقٌ':Subject, #1: 1	صَنَعَ الْمَسْرُوقُ
u'صنع مُكَلَّفٌ':Added, #1: 1	صَنَعَ مَسْرُوقٌ
u'صُنْعٌ مُكَلَّفٌ':Added, #1: 1	صُنْعَ الْمُكَلَّفِ
u'صَنَعَ مَلِيكٌ':Subject, #1: 1	صُنْعَ الْمُكَلَّفِ
u'صَنَعَ مُوَرِّث':Subject, #2: 2	صَنَعَ الْمَلِيكُ
u'صَنَعَ نَاسٌ':Subject, #3: 3	صَنَعَ الْمُوَرِّثُ
u'صَنَعَ نَائِبٌ':Subject, #1: 1	صَنَعَ النَّاسُ
u'صَنَعَ نَبِيٌّ':Subject, #1: 1	صَنَعَ نَائِبٌ
u'صَنَعَ نَحْوٌ':Predicate, #1: 1	صَنَعَ النَّبِيُّ
u'صَنَعَ نَحْوٌ':Predicate, #1: 1	صَنَعَ النّحْوَ
u'صنع هَرَوِيّ':Added, #1: 1	صَنَعَ نَحْوَ
u'صُنْعٌ هَرَوِيّ':Added, #1: 1	صُنْعَ الْهَرَوِيِّ
u'صنع واحد':Added, #1: 1	صُنْعَ الْهَرَوِيِّ
u'صُنْعٌ واحد':Added, #1: 1	صُنْعُ وَاحِدٍ
u'صنع وَاحِدٌ':Added, #1: 1	صُنْعُ وَاحِدٍ
u'صُنْعٌ وَاحِدٌ':Added, #1: 1	صُنْعُ وَاحِدٍ
u'صَنَعَ وَاهِبٌ':Subject, #1: 1	صُنْعُ وَاحِدٍ
u'صَنَعَ وَكِيلٌ':Subject, #1: 1	صَنَعَ الْوَاهِبُ
u'صَنَعَ وَلِيدٌ':Subject, #1: 1	صَنَعَ الْوَكِيلُ
u'صَنَعَ يَهُودِيٌّ':Subject, #2: 2	صَنَعَ الْوَلِيدُ
u'صَنَعَ يَوْمٌ':Predicate, #3: 3	صَنَعَ يَهُودِيٌّ
u'صَنَعَ يَوْمٌ':Predicate, #1: 1	صَنَعَ يَوْمَ
u'صَنَّفَ اِبْنٌ':Subject, #2: 2	صَنَعَ الْيَوْمَ
u'صَنَّفَ إمَامٌ':Subject, #4: 4	صَنَّفَ ابْنُ
u'صَنَّفَ بُخَارِيٌّ':Subject, #2: 2	صَنَّفَ الْإِمَامُ
u'صَنَّفَ شافِعِيّ':Subject, #1: 1	صَنَّفَ الْبُخَارِيُّ
u'صَنَّفَ شَرِيفٌ':Subject, #1: 1	صَنَّفَ الشَّافِعِيُّ
u'صَنَّفَ شَيْخٌ':Subject, #1: 1	صَنَّفَ الشَّرِيفُ
u'صَنَّفَ شَيْخٌ':Subject, #1: 1	صَنَّفَ شَيْخُ
u'صَنَّفَ صَاحِبٌ':Subject, #2: 2	صَنَّفَ الشَّيْخُ
u'صَنَّفَ علم':Predicate, #1: 1	صَنَّفَ صَاحِبُ
u'صَنَّفَ عِلْمٌ':Predicate, #2: 2	صَنَّفَ الْعِلْمَ
u'صَنَّفَ فلان':Subject, #2: 2	صَنَّفَ الْعِلْمَ
u'صَنَّفَ كِتَابٌ':Predicate, #1: 1	صَنَّفَ الشَّافِعِيُّ
u'صَنَّفَ مُسْنَدٌ':Predicate, #2: 2	صَنَّفَ كِتَابَ
u'صَنَّفَ نَاسٌ':Subject, #1: 1	صَنَّفَ الْمُسْنَدَ
u'صَنَّفَ نَوَوِيٌّ':Subject, #1: 1	صَنَّفَ النَّاسُ
u'صَنَمٌ ذَهَبٌ':Added, #1: 1	صَنَّفَ النَّوَوِيُّ
u'صَنَمٌ نَقْدٌ':Added, #2: 2	صَنَمَ ذَهَبٍ
u'صَنَمٌ نَقْد':Added, #1: 1	صَنَمِ نَقْدٍ
u'صَهِيلٌ خَيْلٌ':Added, #1: 1	صَنَمِ نَقْدٍ
u'صَوَّبَ أَوَّلُ':Predicate, #1: 1	صَهِيلَ الْخَيْلِ
u'صَوَّبَ إيرَادٌ':Predicate, #1: 1	صَوَّبَ الْأَوَّلَ
u'صَوْبٌ بَابٌ':Added, #1: 1	صَوَّبَ إيرَادَ
u'صَوْبٌ حاجَةٌ':Added, #1: 1	صَوْبَ الْبَابِ
u'صَوْبٌ حُفْرَةٌ':Added, #1: 1	صَوْبَ حَاجَتِهِ
u'صَوْبٌ خُرُوجٌ':Added, #1: 1	صَوْبِ الْحُفْرَةِ
u'صَوْبٌ خَرِيفٌ':Added, #1: 1	صَوْبِ الْخُرُوجِ
u'صَوْبٌ رَاحَةٌ':Added, #1: 1	صَوْبَ الْخَرِيفِ
u'صَوْبٌ رحمة':Added, #1: 1	صَوْبَ رَاحَتِهِ
u'صَوْبٌ رَحْمَةٌ':Added, #2: 2	صَوْبَ الرَّحْمَةِ
u'صَوْبٌ رِضْوان':Added, #2: 2	صَوْبَ الرَّحْمَةِ
u'صَوْبٌ سَاعِدٌ':Added, #1: 1	صَوْبَ الرِّضْوَانِ
u'صَوْبٌ سَحَابٌ':Added, #1: 1	صَوْبَ السَّاعِدِ
u'صَوْبٌ سَفَرٌ':Added, #1: 1	صَوْبَ سَحَابٍ
u'صَوْبٌ سَفَرٌ':Added, #1: 1	صَوْبَ سَفَرِهِ
u'صَوْبٌ سَفَرٌ':Added, #1: 1	صَوْبُ سَفَرِهِ
u'صَوَّبَ سُكُونٌ':Predicate, #1: 1	صَوْبِ سَفَرِهِ
u'صَوَّبَ شَارِحٌ':Subject, #1: 1	صَوَّبَ السُّكُونَ
u'صَوْبٌ شَرِيعَةٌ':Added, #1: 1	صَوَّبَ شَارِحُ
u'صَوْبٌ صَوَابٌ':Added, #2: 2	صَوْبِ الشَّرِيعَةِ
u'صَوْبٌ طَرِيقٌ':Added, #1: 1	صَوْبَ الصَّوَابِ
u'صَوْبٌ علم':Added, #1: 1	صَوْبِ الطَّرِيقِ
u'صَوْبٌ عِلْمٌ':Added, #3: 3	صَوْبِ الْعِلْمِ
u'صَوْبٌ غَادِي':Added, #3: 3	صَوْبِ الْعِلْمِ
u'صَوْبٌ غَمَامٌ':Added, #1: 1	صَوْبِ غَادِيَةٍ
u'صَوَّبَ غير':Predicate, #1: 1	صَوْبَ الْغَمَامِ
u'صَوَّبَ غَيْرٌ':Predicate, #2: 2	صَوَّبَ غَيْرَ
u'صَوْبٌ فلان':Added, #2: 2	صَوَّبَ غَيْرَ
u'صَوْبٌ قِبْلَةٌ':Added, #1: 1	صَوْبَ الرِّضْوَانِ
u'صَوَّبَ كَلاَمٌ':Predicate, #2: 2	صَوْبِ الْقِبْلَةِ
u'صَوَّبَ مُجْتَهِد':Predicate, #1: 1	صَوَّبَ كَلَامَ
u'صَوْبٌ مَقْصِدٌ':Added, #2: 2	صَوَّبَ الْمُجْتَهِدِينَ
u'صَوْبٌ مَقْصِدٌ':Added, #1: 1	صَوْبَ الْمَقْصِدِ
u'صَوْبٌ يَمِينٌ':Added, #1: 1	صَوْبِ مَقْصِدِهِ
u'صَوْتٌ إِبِلٌ':Added, #1: 1	صَوْبِ يَمِينِهِ
u'صَوْتٌ اِبْنٌ':Added, #1: 1	صَوْتُ الْإِبِلِ
u'صَوْتٌ أَجْنَبِيٌّ':Added, #1: 1	صَوْتَ ابْنِ
u'صَوْتٌ أَذَانٌ':Added, #3: 3	صَوْتُ الْأَجْنَبِيَّةِ
u'صَوْتٌ أَصْحَابٌ':Added, #1: 1	صَوْتِ الْأَذَانِ
u'صَوْتٌ اِصْطِكاكٌ':Added, #2: 2	صَوْتَ أَصْحَابِهِ
u'صَوْتٌ الْمَرْأَةُ':Added, #1: 1	صَوْتُ اصْطِكَاكِ
u'صَوْتٌ الْمَرْأَةُ':Added, #1: 1	صَوْتِ الْمَرْأَةِ
u'صَوْتٌ الْمَرْأَةُ':Added, #2: 2	صَوْتُ الْمَرْأَةِ
u'صَوْتٌ أُمٌّ':Added, #3: 3	صَوْتَ الْمَرْأَةِ
u'صَوْتٌ إمَامٌ':Added, #1: 1	صَوْتُ أُمِّ
u'صَوْتٌ إِنْسانٌ':Added, #1: 1	صَوْتُ الْإِمَامِ
u'صَوْتٌ أهْلٌ':Added, #1: 1	صَوْتَ إنْسَانَيْنِ
u'صَوْتٌ أَوْتَارٌ':Added, #2: 2	صَوْتَ أَهْلِ
u'صَوْتٌ بَعيرٌ':Added, #1: 1	صَوْتَ الْأَوْتَارِ
u'صَوْتٌ بُكاءٌ':Added, #1: 1	صَوْتُ الْبَعِيرِ
u'صَوْتٌ بُكاءٌ':Added, #1: 1	صَوْتِ الْبُكَاءِ
u'صَوَّتَ بُوقٌ':Subject, #1: 1	صَوْتَ بُكَاءٍ
u'صَوْتٌ بُوقٌ':Added, #1: 1	صَوَّتَ الْبُوقُ
u'صَوْتٌ تَسْبِيحٌ':Added, #1: 1	صَوْتَ الْبُوقِ
u'صَوْتٌ تَلْبيَةٌ':Added, #1: 1	صَوْتُ تَسْبِيحِهِ
u'صَوْتٌ جَرَسٌ':Added, #1: 1	صَوْتِ التَّلْبِيَةِ
u'صَوْتٌ جَرَسٌ':Added, #1: 1	صَوْتُ الْجَرَسِ
u'صَوْتٌ حَدَثٌ':Added, #2: 2	صَوْتَ الْجَرَسِ
u'صَوْتٌ حَدَثٌ':Added, #1: 1	صَوْتَ حَدَثٍ
u'صَوْتٌ حَديدٌ':Added, #2: 2	صَوْتُ حَدَثٍ
u'صَوْتٌ حَرَكَةٌ':Added, #1: 1	صَوْتُ الْحَدِيدِ
u'صَوْتٌ حَسَنٌ':Added, #1: 1	صَوْتِ الْحَرَكَاتِ
u'صَوْتٌ حَفِيفٌ':Added, #1: 1	صَوْتٍ حَسَنٍ
u'صَوْتٌ حِمَارٌ':Added, #1: 1	صَوْتَ حَفِيفِ
u'صَوْتٌ خُرُوجٌ':Added, #1: 1	صَوْتُ الْحِمَارِ
u'صَوْتٌ خُصُومٌ':Added, #1: 1	صَوْتَ خُرُوجِ
u'صَوْتٌ دُفٌّ':Added, #1: 1	صَوْتَ خُصُومٍ
u'صَوْتٌ دَمٌ':Added, #1: 1	صَوْتَ الدُّفِّ
u'صَوْتٌ ذُبابٌ':Added, #1: 1	صَوْتِ الدّمِ
u'صَوْتٌ رَجُلٌ':Added, #1: 1	صَوْتِ الذّبَابِ
u'صَوْتٌ رَجُلٌ':Added, #1: 1	صَوْتَ الرَّجُلِ
u'صَوْتٌ رَجُلٌ':Added, #1: 1	صَوْتُ رَجُلٍ
u'صَوْتٌ رَسُولٌ':Added, #4: 4	صَوْتَ رَجُلٍ
u'صَوْتٌ رَعْدٌ':Added, #2: 2	صَوْتَ رَسُولِ
u'صَوْتٌ رَعْدٌ':Added, #1: 1	صَوْتِ الرَّعْدِ
u'صَوْتٌ زَمَّارٌ':Added, #2: 2	صَوْتَ الرَّعْدِ
u'صَوْتٌ زَمَّارَةٌ':Added, #1: 1	صَوْتَ زَمَّارَةِ
u'صَوْتٌ سِلاَحٌ':Added, #1: 1	صَوْتَ زَمَّارَةِ
u'صَوْتٌ سِواكٌ':Added, #1: 1	صَوْتَ السِّلَاحِ
u'صَوْتٌ سُوقٌ':Added, #1: 1	صَوْتَ السِّوَاكِ
u'صَوْتٌ شَيْطَانٌ':Added, #1: 1	صَوْتَ سُوقِهِ
u'صَوْتٌ صَارِخٌ':Added, #1: 1	صَوْتُ شَيْطَانٍ
u'صَوْتٌ صَبِيٌّ':Added, #5: 5	صَوْتَ صَارِخٍ
u'صَوْتٌ صَدْرٌ':Added, #1: 1	صَوْتُ الصَّبِيِّ
u'صَوْتٌ طَبْلٌ':Added, #1: 1	صَوْتَ الصّدْرِ
u'صَوْتٌ طَبْلٌ':Added, #1: 1	صَوْتَ الطَّبْلِ
u'صَوْتٌ طَبْلٌ':Added, #1: 1	صَوْتُ الطّبْلِ
u'صَوْتٌ طَيْرٌ':Added, #1: 1	صَوْتُ طَبْلٍ
u'صَوْتٌ عَامِرٌ':Added, #1: 1	صَوْتَ الطَّيْرِ
u'صَوْتٌ عَبْدٌ':Added, #1: 1	صَوْتُ عَامِرٍ
u'صَوْتٌ عجل':Added, #1: 1	صَوْتَ عَبْدِ
u'صَوْتٌ عِجْلٌ':Added, #1: 1	صَوْتِ الْعِجْلِ
u'صَوْتٌ علم':Added, #1: 1	صَوْتِ الْعِجْلِ
u'صَوْتٌ عِلْمٌ':Added, #1: 1	صَوْتِ الْعِلْمِ
u'صَوْتٌ غَلَيَانٌ':Added, #1: 1	صَوْتِ الْعِلْمِ
u'صَوْتٌ غَلَيَانٌ':Added, #1: 1	صَوْتُ الْغَلَيَانِ
u'صَوْتٌ غناء':Added, #1: 1	صَوْتُ غَلَيَانِ
u'صَوْتٌ غِنَاءٌ':Added, #1: 1	صَوْتَ الْغِنَاءِ
u'صَوْتٌ غِنَاءٌ':Added, #1: 1	صَوْتَ الْغِنَاءِ
u'صَوْتٌ غَنَمٌ':Added, #1: 1	صَوْتُ غِنَاءٍ
u'صَوْتٌ فَرَسٌ':Added, #2: 2	صَوْتُ الْغَنَمِ
u'صَوْتٌ فساد':Added, #1: 1	صَوْتُ الْفَرَسِ
u'صَوْتٌ فَسَادٌ':Added, #1: 1	صَوْتُ فَسَادٍ
u'صَوْتٌ فِيلٌ':Added, #1: 1	صَوْتُ فَسَادٍ
u'صَوْتٌ قُرْآنٌ':Added, #1: 1	صَوْتُ الْفِيلِ
u'صَوْتٌ قَلَمٌ':Added, #1: 1	صَوْتُ الْقُرْآنِ
u'صَوْتٌ كبر':Added, #1: 1	صَوْتُ قَلَمٍ
u'صَوْتٌ كَبَرٌ':Added, #1: 1	صَوْتِ الْكَبَرِ
u'صَوْتٌ كَلْبٌ':Added, #1: 1	صَوْتِ الْكَبَرِ
u'صَوْتٌ لَهْوٌ':Added, #1: 1	صَوْتَ كَلْبٍ
u'صَوْتٌ مُبَلِّغٌ':Added, #1: 1	صَوْتِ اللَّهْوِ
u'صَوْتٌ مِزْمَارٌ':Added, #1: 1	صَوْتِ الْمُبَلِّغِ
u'صَوْتٌ مَصٌّ':Added, #1: 1	صَوْتَ مِزْمَارٍ
u'صَوْتٌ مُغَنِّي':Added, #1: 1	صَوْتِ الْمَصِّ
u'صَوْتٌ مِقْدَحٌ':Added, #1: 1	صَوْتَ الْمُغَنِّيَةِ
u'صَوْتٌ مَلْهَاةٌ':Added, #1: 1	صَوْتَ الْمِقْدَحِ
u'صَوْتٌ مَهِيبٌ':Added, #1: 1	صَوْتِ مَلْهَاةٍ
u'صَوْتٌ مُؤَذِّنٌ':Added, #1: 1	صَوْتِ الْمَهِيبِ
u'صَوْتٌ مُؤَذِّنٌ':Added, #11: 11	صَوْتِ الْمُؤَذِّنِ
u'صَوْتٌ مُؤَذِّنٌ':Added, #1: 1	صَوْتَ الْمُؤَذّنِ
u'صَوْتٌ نَاقُوسٌ':Added, #3: 3	صَوْتَ الْمُؤَذِّنِ
u'صَوْتٌ نَائِحٌ':Added, #1: 1	صَوْتَ نَاقُوسٍ
u'صَوْتٌ نَبِيٌّ':Added, #1: 1	صَوْتِ النَّائِحَةِ
u'صَوْتٌ نَبِيٌّ':Added, #14: 14	صَوْتِ النَّبِيِّ
u'صَوْتٌ نِساءٌ':Added, #2: 2	صَوْتَ النَّبِيِّ
u'صَوْتٌ نِعَالٌ':Added, #1: 1	صَوْتِ النِّسَاءِ
u'صَوْتٌ نَفْخ':Added, #3: 3	صَوْتَ النِّعَالِ
u'صَوْتٌ نقل':Added, #1: 1	صَوْتُ النّفْخِ
u'صَوْتٌ نَقْلٌ':Added, #1: 1	صَوْتُ نَقْلِ
u'صَوْتٌ نُهَامٌ':Added, #1: 1	صَوْتُ نَقْلِ
u'صَوْتٌ واحد':Added, #2: 2	صَوْتُ النّهَامِ
u'صَوْتٌ وَاحِدٌ':Added, #8: 8	صَوْتٍ وَاحِدٍ
u'صَوْتٌ ولد':Added, #8: 8	صَوْتٍ وَاحِدٍ
u'صَوْتٌ وَلَدٌ':Added, #1: 1	صَوْتَ الْوَلَدِ
u'صَوَّرَ اِبْنٌ':Subject, #1: 1	صَوْتَ الْوَلَدِ
u'صَوَّرَ أصل':Subject, #2: 2	صَوَّرَ ابْنُ
u'صَوَّرَ أًصْلٌ':Subject, #1: 1	صَوَّرَ الْأَصْلُ
u'صَوَّرَ إمَامٌ':Subject, #1: 1	صَوَّرَ الْأَصْلُ
u'صَوَّرَ تِمْثالٌ':Predicate, #1: 1	صَوَّرَ إمَامُ
u'صَوَّرَ حَرْفٌ':Predicate, #1: 1	صَوَّرَ تِمْثَالَ
u'صَوَّرَ شَيْخٌ':Subject, #2: 2	صَوَّرَ الْحَرْفَ
u'صَوَّرَ طَبَرِيّ':Subject, #1: 1	صَوَّرَ الشَّيْخُ
u'صَوَّرَ عَدَاوَةٌ':Predicate, #1: 1	صَوَّرَ الطَّبَرِيُّ
u'صَوَّرَ فلان':Subject, #1: 1	صَوَّرَ الْعَدَاوَةَ
u'صَوَّرَ قَوْمٌ':Subject, #1: 1	صَوَّرَ الطَّبَرِيُّ
u'صَوَّرَ مَحَلٌّ':Predicate, #1: 1	صَوَّرَ قَوْمٌ
u'صَوَّرَ مَسْأَلَةٌ':Predicate, #1: 1	صَوَّرَ مَحَلَّ
u'صَوَّرَ مَسْأَلَةٌ':Predicate, #11: 11	صَوَّرَ الْمَسْأَلَةَ
u'صَوَّرَ مُصَنِّفٌ':Subject, #1: 1	صَوَّرَ مَسْأَلَةَ
u'صَوَّرَ هَازِلٌ':Predicate, #2: 2	صَوَّرَ الْمُصَنِّفُ
u'صَوْغٌ ذَهَبٌ':Added, #1: 1	صَوَّرَ الْهَازِلَ
u'صَوْغٌ ذَهَبٌ':Added, #1: 1	صَوْغَ الذَّهَبِ
u'صَوْغٌ وَصْفٌ':Added, #1: 1	صَوْغُ الذَّهَبِ
u'صَوْغٌ وَصْفٌ':Added, #1: 1	صَوْغُ الْوَصْفِ
u'صُوفِيَّةٌ حقائق':Added, #1: 1	صَوْغِ الْوَصْفِ
u'صُوفِيَّةٌ حَقَائِقُ':Added, #1: 1	صُوفِيَّةُ الْحَقَائِقِ
u'صُوفِيٌّ حقائق':Added, #1: 1	صُوفِيَّةُ الْحَقَائِقِ
u'صُوفِيٌّ حَقَائِقُ':Added, #1: 1	صُوفِيَّةُ الْحَقَائِقِ
u'صَوْلَةٌ أمراء':Added, #1: 1	صُوفِيَّةُ الْحَقَائِقِ
u'صَوْلَةٌ شجاع':Added, #1: 1	صَوْلَةُ الْأُمَرَاءِ
u'صَوْلَةٌ شجَاعٌ':Added, #1: 1	صَوْلَةُ الشُّجَاعِ
u'صَوْمٌ أبَدٌ':Added, #1: 1	صَوْلَةُ الشُّجَاعِ
u'صَوْمٌ أبَدٌ':Added, #1: 1	صَوْمُ أَبَدٍ
u'صَوْمٌ أَجِيرٌ':Added, #2: 2	صَوْمَ الْأَبَدِ
u'صَوْمٌ أحَدٌ':Added, #1: 1	صَوْمِ الْأَجِيرِ
u'صَوْمٌ أحَدٌ':Added, #2: 2	صَوْمُ أَحَدِ
u'صَوْمٌ آخِرُ':Added, #3: 3	صَوْمُ أَحَدٍ
u'صَوْمٌ آخِرُ':Added, #1: 1	صَوْمُ آخِرِ
u'صَوْمٌ أَخِيرٌ':Added, #1: 1	صَوْمِ آخِرِ
u'صَوْمٌ أرْبِعَاءُ':Added, #1: 1	صَوْمُ الْأَخِيرَيْنِ
u'صَوْمٌ أَرْبِعَاءُ':Added, #1: 1	صَوْمِ الأَرْبِعَاءِ
u'صَوْمٌ أَرْبَعَةٌ':Added, #1: 1	صَوْمِ الأَرْبِعَاءِ
u'صَوْمٌ أَرْبَعَةٌ':Added, #1: 1	صَوْمِ أَرْبَعَةٍ
u'صَوْمٌ أُسْبُوعٌ':Added, #2: 2	صَوْمُ أَرْبَعَةِ
u'صَوْمٌ أَسيرٌ':Added, #1: 1	صَوْمُ أُسْبُوعٍ
u'صَوْمٌ أَشْهُرٌ':Added, #2: 2	صَوْمُ الْأَسِيرِ
u'صَوْمٌ أصل':Added, #2: 2	صَوْمُ الْأَشْهُرِ
u'صَوْمٌ أًصْلٌ':Added, #1: 1	صَوْمِ الْأَصْلِ
u'صَوْمٌ أَكْثَرُ':Added, #1: 1	صَوْمِ الْأَصْلِ
u'صَوْمٌ أَكْثَرُ':Added, #1: 1	صَوْمُ أَكْثَرِ
u'صَوْمٌ الْمَرْأَةُ':Added, #1: 1	صَوْمُ أَكْثَرِهِ
u'صَوْمٌ الْمَرْأَةُ':Added, #2: 2	صَوْمُ الْمَرْأَةِ
u'صَوْمٌ اِمْرَأَةٌ':Added, #2: 2	صَوْمِ الْمَرْأَةِ
u'صَوْمٌ أَمْس':Added, #1: 1	صَوْمَ امْرَأَةٍ
u'صَوْمٌ أَمْس':Added, #3: 3	صَوْمَ أَمْسِ
u'صَوْمٌ أهْلٌ':Added, #6: 6	صَوْمُ أَمْسِ
u'صَوْمٌ أَوَّلُ':Added, #2: 2	صَوْمَ أَهْلِ
u'صَوْمٌ أيَّامٌ':Added, #3: 3	صَوْمُ أَوَّلِ
u'صَوْمٌ أيَّامٌ':Added, #1: 1	صَوْمَ أَيَّامٍ
u'صَوْمٌ أَيَّامٌ':Added, #1: 1	صَوْمِ أَيَّامٍ
u'صَوْمٌ أَيَّامٌ':Added, #1: 1	صَوْمَ أَيَّامٍ
u'صَوْمٌ أيَّامٌ':Added, #1: 1	صَوْمِ أَيَّامٍ
u'صَوْمٌ أَيَّامٌ':Added, #2: 2	صَوْمَ الْأَيَّامِ
u'صَوْمٌ أيَّامٌ':Added, #2: 2	صَوْمَ الْأَيَّامِ
u'صَوْمٌ أَيَّامٌ':Added, #3: 3	صَوْمِ الْأَيَّامِ
u'صَوْمٌ أيَّامٌ':Added, #3: 3	صَوْمِ الْأَيَّامِ
u'صَوْمٌ أَيَّامٌ':Added, #3: 3	صَوْمُ أَيَّامٍ
u'صَوْمٌ أيَّامٌ':Added, #3: 3	صَوْمُ أَيَّامٍ
u'صَوْمٌ أَيَّامٌ':Added, #4: 4	صَوْمِ أَيَّامِ
u'صَوْمٌ أيَّامٌ':Added, #4: 4	صَوْمِ أَيَّامِ
u'صَوْمٌ أَيَّامٌ':Added, #5: 5	صَوْمُ الْأَيَّامِ
u'صَوْمٌ أيَّامٌ':Added, #5: 5	صَوْمُ الْأَيَّامِ
u'صَوْمٌ أَيَّامٌ':Added, #5: 5	صَوْمَ أَيَّامِ
u'صَوْمٌ أيَّامٌ':Added, #5: 5	صَوْمَ أَيَّامِ
u'صَوْمٌ أَيَّامٌ':Added, #6: 6	صَوْمُ أَيَّامِ
u'صَوْمٌ بَعْضٌ':Added, #6: 6	صَوْمُ أَيَّامِ
u'صَوْمٌ بَعْضٌ':Added, #3: 3	صَوْمِ بَعْضِ
u'صَوْمٌ بَعْضٌ':Added, #5: 5	صَوْمَ بَعْضِ
u'صَوْمٌ بَقِيَّةٌ':Added, #5: 5	صَوْمُ بَعْضِ
u'صَوْمٌ بَقِيَّةٌ':Added, #1: 1	صَوْمُ بَقِيَّتِهِ
u'صَوْمٌ بَقِيَّةٌ':Added, #2: 2	صَوْمَ بَقِيَّةِ
u'صَوْمٌ بَقِيَّةٌ':Added, #2: 2	صَوْمُ بَقِيَّةِ
u'صَوْمٌ تَاسِعٌ':Added, #2: 2	صَوْمِ بَقِيَّةِ
u'صَوْمٌ تَاسِعٌ':Added, #1: 1	صَوْمَ التَّاسِعِ
u'صَوْمٌ تَامٌّ':Added, #1: 1	صَوْمِ التَّاسِعِ
u'صَوْمٌ تِسْعَةٌ':Added, #1: 1	صَوْمٍ تَامٍّ
u'صَوْمٌ تَطَوُّعٌ':Added, #1: 1	صَوْمُ تِسْعَةِ
u'صَوْمٌ تَطَوُّعٌ':Added, #2: 2	صَوْمَ تَطَوُّعٍ
u'صَوْمٌ تَطَوُّعٌ':Added, #52: 52	صَوْمِ التَّطَوُّعِ
u'صَوْمٌ تَطَوُّعٌ':Added, #5: 5	صَوْمَ التَّطَوُّعِ
u'صَوْمٌ تَطَوُّعٌ':Added, #5: 5	صَوْمُ التَّطَوُّعِ
u'صَوْمٌ تَمَتُّعٌ':Added, #8: 8	صَوْمِ تَطَوُّعٍ
u'صَوْمٌ تَمَتُّعٌ':Added, #3: 3	صَوْمُ التَّمَتُّعِ
u'صَوْمٌ ثَالِثٌ':Added, #3: 3	صَوْمِ التَّمَتُّعِ
u'صَوْمٌ ثَامِنٌ':Added, #1: 1	صَوْمِ ثَالِثِ
u'صَوْمٌ ثَلاثُ':Added, #1: 1	صَوْمُ الثَّامِنِ
u'صَوْمٌ ثَلاثُ':Added, #1: 1	صَوْمَ الثَّلَاثِ
u'صَوْمٌ ثُلاَثَاءُ':Added, #1: 1	صَوْمِ الثَّلَاثِ
u'صَوْمٌ ثَلاثَةٌ':Added, #2: 2	صَوْمَ الثُّلَاثَاءِ
u'صَوْمٌ ثَلاثَةٌ':Added, #12: 12	صَوْمُ ثَلَاثَةِ
u'صَوْمٌ ثَلاثَةٌ':Added, #13: 13	صَوْمُ الثَّلَاثَةِ
u'صَوْمٌ ثَلاثَةٌ':Added, #1: 1	صَوْمُ ثَلاثَةِ
u'صَوْمٌ ثَلاثَةٌ':Added, #1: 1	صَوْم ثَلَاثَةِ
u'صَوْمٌ ثَلاثَةٌ':Added, #1: 1	صَوْمَ ثَلاَثَةِ
u'صَوْمٌ ثَلاثَةٌ':Added, #1: 1	صَوْمُ ثَلاَثَةِ
u'صَوْمٌ ثَلاثَةٌ':Added, #2: 2	صَوْمَ الثَّلَاثَةِ
u'صَوْمٌ ثَلاثَةٌ':Added, #2: 2	صَوْمِ ثَلاَثَةِ
u'صَوْمٌ ثَلاثَةٌ':Added, #3: 3	صَوْمَ ثَلَاثَةِ
u'صَوْمٌ ثَلاثَةٌ':Added, #5: 5	صَوْمِ ثَلَاثَةِ
u'صَوْمٌ ثَلاثَةٌ':Added, #6: 6	صَوْمُ ثَلَاثَةٍ
u'صَوْمٌ ثَمانِيَةٌ':Added, #9: 9	صَوْمِ الثَّلَاثَةِ
u'صَوْمٌ جَزَاءٌ':Added, #1: 1	صَوْمِ ثَمَانِيَةٍ
u'صَوْمٌ جَمَاعَةٌ':Added, #1: 1	صَوْمُ جَزَاءِ
u'صَوْمٌ جَمَاعَةٌ':Added, #2: 2	صَوْمِ جَمَاعَةٍ
u'صَوْمٌ جمع':Added, #3: 3	صَوْمُ جَمَاعَةٍ
u'صَوْمٌ جُمَعٌ':Added, #1: 1	صَوْمَ الْجُمَعِ
u'صَوْمٌ جمع':Added, #1: 1	صَوْمَ الْجُمَعِ
u'صَوْمٌ جُمَعٌ':Added, #1: 1	صَوْمُ جُمَعِ
u'صَوْمٌ جمع':Added, #1: 1	صَوْمُ جُمَعِ
u'صَوْمٌ جُمَعٌ':Added, #2: 2	صَوْمُ الْجُمَعِ
u'صَوْمٌ جمعة':Added, #2: 2	صَوْمُ الْجُمَعِ
u'صَوْمٌ جُمُعَةٌ':Added, #3: 3	صَوْمِ الْجُمُعَةِ
u'صَوْمٌ جمعة':Added, #3: 3	صَوْمِ الْجُمُعَةِ
u'صَوْمٌ جُمُعَةٌ':Added, #3: 3	صَوْمُ جُمُعَةٍ
u'صَوْمٌ حامِلٌ':Added, #3: 3	صَوْمُ جُمُعَةٍ
u'صَوْمٌ حائِضٌ':Added, #2: 2	صَوْمُ الْحَامِلِ
u'صَوْمٌ حائِضٌ':Added, #1: 1	صَوْمُ الْحَائِضِ
u'صَوْمٌ حَيْضٌ':Added, #1: 1	صَوْمِ الْحَائِضِ
u'صَوْمٌ خَمْسَةٌ':Added, #1: 1	صَوْمَ حَيْضٍ
u'صَوْمٌ خَمْسَةٌ':Added, #1: 1	صَوْمُ الْخَمْسَةِ
u'صَوْمٌ خَمْسَةٌ':Added, #2: 2	صَوْمُ خَمْسَةٍ
u'صَوْمٌ خَمِيسٌ':Added, #2: 2	صَوْمُ خَمْسَةِ
u'صَوْمٌ دَمٌ':Added, #1: 1	صَوْمَ الْخَمِيسِ
u'صَوْمٌ دَهْرٌ':Added, #1: 1	صَوْمِ دَمِ
u'صَوْمٌ دَهْرٌ':Added, #14: 14	صَوْمَ الدَّهْرِ
u'صَوْمٌ دَهْرٌ':Added, #1: 1	صَوْمَ دَهْرٍ
u'صَوْمٌ دَهْرٌ':Added, #20: 20	صَوْمُ الدَّهْرِ
u'صَوْمٌ رابع':Added, #20: 20	صَوْمِ الدَّهْرِ
u'صَوْمٌ رَابِعٌ':Added, #1: 1	صَوْمِ رَابِعِ
u'صَوْمٌ رَجَبٌ':Added, #1: 1	صَوْمِ رَابِعِ
u'صَوْمٌ رَجَبٌ':Added, #2: 2	صَوْمُ رَجَبٍ
u'صَوْمٌ رَجَبٌ':Added, #5: 5	صَوْمَ رَجَبٍ
u'صَوْمٌ زَمانٌ':Added, #6: 6	صَوْمِ رَجَبٍ
u'صَوْمٌ زَمانٌ':Added, #1: 1	صَوْمِ الزَّمَانِ
u'صَوْمٌ زَوْجَةٌ':Added, #1: 1	صَوْمُ زَمَانٍ
u'صَوْمٌ سابع':Added, #2: 2	صَوْمَ زَوْجَتِهِ
u'صَوْمٌ سَابعٌ':Added, #1: 1	صَوْمُ السَّابِعِ
u'صَوْمٌ سَاعَةٌ':Added, #1: 1	صَوْمُ السَّابِعِ
u'صَوْمٌ سَبْتٌ':Added, #1: 1	صَوْمَ سَاعَةٍ
u'صَوْمٌ سَبْتٌ':Added, #1: 1	صَوْمِ السَّبْتِ
u'صَوْمٌ سَبْعَةٌ':Added, #1: 1	صَوْمُ سَبْتَيْنِ
u'صَوْمٌ سَبْعَةٌ':Added, #2: 2	صَوْمِ السَّبْعَةِ
u'صَوْمٌ سَبْعَةٌ':Added, #3: 3	صَوْمَ السَّبْعَةِ
u'صَوْمٌ سَبْعَةٌ':Added, #3: 3	صَوْمُ السَّبْعَةِ
u'صَوْمٌ سِتٌّ':Added, #5: 5	صَوْمُ سَبْعَةِ
u'صَوْمٌ سِتٌّ':Added, #1: 1	صَوْمِ السِّتَّةِ
u'صَوْمٌ سِتٌّ':Added, #1: 1	صَوْمِ سِتٍّ
u'صَوْمٌ سِتٌّ':Added, #1: 1	صَوْمَ سِتَّةِ
u'صَوْمٌ سِتٌّ':Added, #1: 1	صَوْمُ سِتَّةِ
u'صَوْمٌ سِتٌّ':Added, #2: 2	صَوْمُ سِتَّةٍ
u'صَوْمٌ سَرَرٌ':Added, #3: 3	صَوْمِ سِتَّةِ
u'صَوْمٌ سَنَةٌ':Added, #1: 1	صَوْمِ سَرَرِ
u'صَوْمٌ سَنَةٌ':Added, #19: 19	صَوْمَ سَنَةٍ
u'صَوْمٌ سَنَةٌ':Added, #19: 19	صَوْمُ سَنَةٍ
u'صَوْمٌ سَنَةٌ':Added, #3: 3	صَوْمَ السَّنَةِ
u'صَوْمٌ سَنَةٌ':Added, #3: 3	صَوْمُ السَّنَةِ
u'صَوْمٌ شَارِبٌ':Added, #6: 6	صَوْمِ سَنَةٍ
u'صَوْمٌ شِتَاءٌ':Added, #1: 1	صَوْمِ الشَّارِبِ
u'صَوْمٌ شَرْطٌ':Added, #1: 1	صَوْمِ الشِّتَاءِ
u'صَوْمٌ شَرْعِيٌّ':Added, #1: 1	صَوْمِ شَرْطِ
u'صَوْمٌ شَكٌّ':Added, #2: 2	صَوْمٍ شَرْعِيٍّ
u'صَوْمٌ شَكٌّ':Added, #1: 1	صَوْم الشَّكِّ
u'صَوْمٌ شَكٌّ':Added, #1: 1	صَوْمُ الشَّكِّ
u'صَوْمٌ شَهْرٌ':Added, #1: 1	صَوْمِ الشَّكِّ
u'صَوْمٌ شَهْرٌ':Added, #12: 12	صَوْمُ شَهْرَيْنِ
u'صَوْمٌ شَهْرٌ':Added, #30: 30	صَوْمُ شَهْرٍ
u'صَوْمٌ شَهْرٌ':Added, #3: 3	صَوْمِ شَهْرٍ
u'صَوْمٌ شَهْرٌ':Added, #3: 3	صَوْمِ شَهْرَيْنِ
u'صَوْمٌ شَهْرٌ':Added, #44: 44	صَوْمَ شَهْرٍ
u'صَوْمٌ شَهْرٌ':Added, #4: 4	صَوْمِ الشَّهْرِ
u'صَوْمٌ شَهْرٌ':Added, #4: 4	صَوْمَ الشَّهْرَيْنِ
u'صَوْمٌ شَهْرٌ':Added, #4: 4	صَوْمُ الشَّهْرَيْنِ
u'صَوْمٌ شَهْرٌ':Added, #6: 6	صَوْمُ الشَّهْرِ
u'صَوْمٌ شَهْرٌ':Added, #6: 6	صَوْمِ الشَّهْرَيْنِ
u'صَوْمٌ شَهْرٌ':Added, #6: 6	صَوْمَ شَهْرَيْنِ
u'صَوْمٌ شَهْرٌ':Added, #7: 7	صَوْمَ الشَّهْرِ
u'صَوْمٌ شَهْرٌ':Added, #7: 7	صَوْمُ شَهْرِ
u'صَوْمٌ شَوَّالٌ':Added, #7: 7	صَوْمِ شَهْرِ
u'صَوْمٌ شَوَّالٌ':Added, #1: 1	صَوْمِ شَوَّالٍ
u'صَوْمٌ صَبِيٌّ':Added, #2: 2	صَوْمُ شَوَّالٍ
u'صَوْمٌ صمت':Added, #2: 2	صَوْمِ الصَّبِيِّ
u'صَوْمٌ صَمْتٌ':Added, #2: 2	صَوْمَ الصَّمْتِ
u'صَوْمٌ صمت':Added, #2: 2	صَوْمَ الصَّمْتِ
u'صَوْمٌ صَمْتٌ':Added, #4: 4	صَوْمُ الصَّمْتِ
u'صَوْمٌ طَاهِرٌ':Added, #4: 4	صَوْمُ الصَّمْتِ
u'صَوْمٌ ظهار':Added, #1: 1	صَوْمِ الطَّاهِرَةِ
u'صَوْمٌ ظهار':Added, #14: 14	صَوْمِ الظِّهَارِ
u'صَوْمٌ ظهار':Added, #2: 2	صَوْمُ الظِّهَارِ
u'صَوْمٌ ظهار':Added, #3: 3	صَوْمِ ظِهَارٍ
u'صَوْمٌ عَامٌ':Added, #4: 4	صَوْمَ الظِّهَارِ
u'صَوْمٌ عَبْدٌ':Added, #1: 1	صَوْمِ الْعَامِ
u'صَوْمٌ عَشْرٌ':Added, #1: 1	صَوْمُ الْعَبْدِ
u'صَوْمٌ عَشْرٌ':Added, #1: 1	صَوْمَ الْعَشْرِ
u'صَوْمٌ عَشْرٌ':Added, #1: 1	صَوْمُ عَشْرَةِ
u'صَوْمٌ عَشْرٌ':Added, #2: 2	صَوْمِ الْعَشْرِ
u'صَوْمٌ عَشْرٌ':Added, #2: 2	صَوْمِ عَشْرِ
u'صَوْمٌ عُمُرٌ':Added, #3: 3	صَوْمُ عَشْرِ
u'صَوْمٌ عُمُومٌ':Added, #1: 1	صَوْمُ عُمُرٍ
u'صَوْمٌ عِيدٌ':Added, #1: 1	صَوْمُ الْعُمُومِ
u'صَوْمٌ عِيدٌ':Added, #1: 1	صَوْمَ الْعِيدَيْنِ
u'صَوْمٌ عِيدٌ':Added, #1: 1	صَوْمَ عِيدٍ
u'صَوْمٌ عِيدٌ':Added, #2: 2	صَوْمُ الْعِيدَيْنِ
u'صَوْمٌ عَيْنٌ':Added, #7: 7	صَوْمِ الْعِيدِ
u'صَوْمٌ عَيْن':Added, #2: 2	صَوْمُ عَيْنٍ
u'صَوْمٌ غَدٌ':Added, #2: 2	صَوْمُ عَيْنٍ
u'صَوْمٌ غَدٌ':Added, #13: 13	صَوْمَ الْغَدِ
u'صَوْمٌ غَدٌ':Added, #14: 14	صَوْمَ غَدٍ
u'صَوْمٌ غَدٌ':Added, #1: 1	صَوْمِ غَدٍ
u'صَوْمٌ غَدٌ':Added, #2: 2	صَوْم غَدٍ
u'صَوْمٌ غَدٌ':Added, #2: 2	صَوْمُ غَدٍ
u'صَوْمٌ غير':Added, #6: 6	صَوْمِ الْغَدِ
u'صَوْمٌ غير':Added, #2: 2	صَوْمَ غَيْرِ
u'صَوْمٌ غَيْرٌ':Added, #2: 2	صَوْمُ غَيْرِ
u'صَوْمٌ غَيْرٌ':Added, #2: 2	صَوْمَ غَيْرِ
u'صَوْمٌ غير':Added, #2: 2	صَوْمُ غَيْرِ
u'صَوْمٌ غير':Added, #2: 2	صَوْمَ غَيْرِهِ
u'صَوْمٌ غَيْرٌ':Added, #2: 2	صَوْمِ غَيْرِهِ
u'صَوْمٌ غَيْرٌ':Added, #2: 2	صَوْمَ غَيْرِهِ
u'صَوْمٌ غير':Added, #2: 2	صَوْمِ غَيْرِهِ
u'صَوْمٌ غَيْرٌ':Added, #7: 7	صَوْمِ غَيْرِ
u'صَوْمٌ فِدْيَةٌ':Added, #7: 7	صَوْمِ غَيْرِ
u'صَوْمٌ فِدْيَةٌ':Added, #1: 1	صَوْمِ الْفِدْيَةِ
u'صَوْمٌ فَرْضٌ':Added, #1: 1	صَوْمِ فِدْيَةِ
u'صَوْمٌ فَرْضٌ':Added, #10: 10	صَوْمِ الْفَرْضِ
u'صَوْمٌ فَرْضٌ':Added, #1: 1	صَوْمُ فَرْضِ
u'صَوْمٌ فَرْضٌ':Added, #1: 1	صَوْمِ فَرْضِ
u'صَوْمٌ فَرْضٌ':Added, #3: 3	صَوْمَ الْفَرْضِ
u'صَوْمٌ فَرْضٌ':Added, #3: 3	صَوْمُ الْفَرْضِ
u'صَوْمٌ فَرْضٌ':Added, #3: 3	صَوْمِ فَرْضٍ
u'صَوْمٌ فَرْضٌ':Added, #4: 4	صَوْمَ فَرْضٍ
u'صَوْمٌ فِطْرٌ':Added, #9: 9	صَوْمُ فَرْضٍ
u'صَوْمٌ قِرَانٌ':Added, #1: 1	صَوْمِ الْفِطْرِ
u'صَوْمٌ قَضَاءٌ':Added, #1: 1	صَوْمِ الْقِرَانِ
u'صَوْمٌ قَضَاءٌ':Added, #10: 10	صَوْمَ الْقَضَاءِ
u'صَوْمٌ قَضَاءٌ':Added, #1: 1	صَوْمُ قَضَاءٍ
u'صَوْمٌ قَضَاءٌ':Added, #1: 1	صَوْمِ قَضَاءِ
u'صَوْمٌ قَضَاءٌ':Added, #2: 2	صَوْمِ قَضَاءٍ
u'صَوْمٌ قَضَاءٌ':Added, #3: 3	صَوْمُ الْقَضَاءِ
u'صَوْمٌ قلب':Added, #6: 6	صَوْمِ الْقَضَاءِ
u'صَوْمٌ قَلْبٌ':Added, #1: 1	صَوْمُ الْقَلْبِ
u'صَوْمٌ قَلْب':Added, #1: 1	صَوْمُ الْقَلْبِ
u'صَوْمٌ كَافِرٌ':Added, #1: 1	صَوْمُ الْقَلْبِ
u'صَوْمٌ كَفَّارٌ':Added, #2: 2	صَوْمُ الْكَافِرِ
u'صَوْمٌ كَفَّارٌ':Added, #1: 1	صَوْمِ الْكَفَّارَاتِ
u'صَوْمٌ كَفَّارٌ':Added, #1: 1	صَوْمَ الْكَفَّارَةِ
u'صَوْمٌ كَفَّارٌ':Added, #1: 1	صَوْمَ كَفَّارَةِ
u'صَوْمٌ كَفَّارٌ':Added, #29: 29	صَوْمِ الْكَفَّارَةِ
u'صَوْمٌ كَفَّارٌ':Added, #2: 2	صَوْمُ الْكَفَّارَةِ
u'صَوْمٌ كَفَّارٌ':Added, #6: 6	صَوْمِ كَفَّارَةِ
u'صَوْمٌ كَفَّارَةٌ':Added, #7: 7	صَوْمُ كَفَّارَةِ
u'صَوْمٌ كَفَّارَةٌ':Added, #1: 1	صَوْمِ الْكَفَّارَاتِ
u'صَوْمٌ كَفَّارَةٌ':Added, #1: 1	صَوْمَ الْكَفَّارَةِ
u'صَوْمٌ كَفَّارَةٌ':Added, #1: 1	صَوْمَ كَفَّارَةِ
u'صَوْمٌ كَفَّارَةٌ':Added, #29: 29	صَوْمِ الْكَفَّارَةِ
u'صَوْمٌ كَفَّارَةٌ':Added, #2: 2	صَوْمُ الْكَفَّارَةِ
u'صَوْمٌ كَفَّارَةٌ':Added, #2: 2	صَوْمُ كَفَّارَةٍ
u'صَوْمٌ كَفَّارَةٌ':Added, #6: 6	صَوْمِ كَفَّارَةِ
u'صَوْمٌ لَيْلٌ':Added, #7: 7	صَوْمُ كَفَّارَةِ
u'صَوْمٌ لَيْلٌ':Added, #1: 1	صَوْمُ لَيْلَةِ
u'صَوْمٌ لَيْلٌ':Added, #2: 2	صَوْمِ اللَّيْلِ
u'صَوْمٌ مُتْعَةٌ':Added, #2: 2	صَوْمِ لَيْلَةٍ
u'صَوْمٌ مُتْعَةٌ':Added, #1: 1	صَوْمِ الْمُتْعَةِ
u'صَوْمٌ مُتَمَتِّعٌ':Added, #4: 4	صَوْمُ الْمُتْعَةِ
u'صَوْمٌ مثل':Added, #4: 4	صَوْمِ الْمُتَمَتِّعِ
u'صَوْمٌ مِثْلٌ':Added, #1: 1	صَوْمُ مِثْلِ
u'صَوْمٌ مُحَرَّمٌ':Added, #1: 1	صَوْمُ مِثْلِ
u'صَوْمٌ مُحَرَّمٌ':Added, #1: 1	صَوْمَ الْمُحَرَّمِ
u'صَوْمٌ مُحَرَّمٌ':Added, #1: 1	صَوْمِ الْمُحَرَّمِ
u'صَوْمٌ مَرِيضٌ':Added, #6: 6	صَوْمُ الْمُحَرَّمِ
u'صَوْمٌ مَرِيضٌ':Added, #1: 1	صَوْمَ الْمَرِيضِ
u'صَوْمٌ مُسَافِرٌ':Added, #1: 1	صَوْمِ الْمَرِيضِ
u'صَوْمٌ مُسَافِرٌ':Added, #1: 1	صَوْمُ الْمُسَافِرِ
u'صَوْمٌ مُسَافِرٌ':Added, #2: 2	صَوْمَ الْمُسَافِرِ
u'صَوْمٌ مُسْتَحَقٌّ':Added, #3: 3	صَوْمِ الْمُسَافِرِ
u'صَوْمٌ مُضَلَّلٌ':Added, #1: 1	صَوْمٍ مُسْتَحَقٍّ
u'صَوْمٌ مُعَيَّنٌ':Added, #1: 1	صَوْمُ الْمُضَلَّلَةِ
u'صَوْمٌ مُغْتاب':Added, #1: 1	صَوْمٍ مُعَيَّنٍ
u'صَوْمٌ مُقِيمٌ':Added, #1: 1	صَوْمُ الْمُغْتَابِ
u'صَوْمٌ مُكْرَهٌ':Added, #1: 1	صَوْمِ مُقِيمٍ
u'صَوْمٌ مُكْرَهٌ':Added, #1: 1	صَوْمُ الْمُكْرَهَةِ
u'صَوْمٌ مَكْرُوهٌ':Added, #1: 1	صَوْمِ الْمُكْرَهَةِ
u'صَوْمٌ مُنْتَصَفٌ':Added, #1: 1	صَوْمٍ مَكْرُوهٍ
u'صَوْمٌ مَنْذُور':Added, #1: 1	صَوْمِ مُنْتَصَفِ
u'صَوْمٌ مُنْفَرِدٌ':Added, #1: 1	صَوْمِ الْمَنْذُورِ
u'صَوْمٌ نَاسٌ':Added, #1: 1	صَوْمِ الْمُنْفَرِدِ
u'صَوْمٌ نَائِمٌ':Added, #1: 1	صَوْمُ النَّاسِ
u'صَوْمٌ نَائِمٌ':Added, #1: 1	صَوْمُ النَّائِمِ
u'صَوْمٌ نَبِيٌّ':Added, #1: 1	صَوْمُ النَّائِمَةِ
u'صَوْمٌ نَحْرٌ':Added, #2: 2	صَوْمِ النَّبِيِّ
u'صَوْمٌ نَحْوٌ':Added, #1: 1	صَوْمُ النَّحْرِ
u'صَوْمٌ نَحْوٌ':Added, #1: 1	صَوْمُ نَحْوِ
u'صَوْمٌ نذر':Added, #1: 1	صَوْمِ نَحْوِ
u'صَوْمٌ نَذْرٌ':Added, #14: 14	صَوْمِ النَّذْرِ
u'صَوْمٌ نذر':Added, #14: 14	صَوْمِ النَّذْرِ
u'صَوْمٌ نَذْرٌ':Added, #1: 1	صَوْمُ النَّذْرِ
u'صَوْمٌ نذر':Added, #1: 1	صَوْمُ النَّذْرِ
u'صَوْمٌ نَذْرٌ':Added, #1: 1	صَوْمِ نَذْرِ
u'صَوْمٌ نَذْرٌ':Added, #1: 1	صَوْمَ نَذْرٍ
u'صَوْمٌ نَذْرٌ':Added, #1: 1	صَوْمِ نَذْرِ
u'صَوْمٌ نذر':Added, #4: 4	صَوْمُ نَذْرٍ
u'صَوْمٌ نَذْرٌ':Added, #7: 7	صَوْمَ النَّذْرِ
u'صَوْمٌ نِصْفٌ':Added, #7: 7	صَوْمَ النَّذْرِ
u'صَوْمٌ نِصْفٌ':Added, #1: 1	صَوْمَ نِصْفِ
u'صَوْمٌ نَفْسٌ':Added, #2: 2	صَوْمُ نِصْفِ
u'صَوْمٌ نَفْلٌ':Added, #1: 1	صَوْمَ نَفْسِهِ
u'صَوْمٌ نَفْلٌ':Added, #17: 17	صَوْمِ النَّفْلِ
u'صَوْمٌ نَفْلٌ':Added, #2: 2	صَوْمُ نَفْلٍ
u'صَوْمٌ نَفْلٌ':Added, #2: 2	صَوْمِ نَفْلٍ
u'صَوْمٌ نَفْلٌ':Added, #3: 3	صَوْمَ النَّفْلِ
u'صَوْمٌ نَيْرُوزٌ':Added, #6: 6	صَوْمُ النَّفْلِ
u'صَوْمٌ هَدْيٌ':Added, #1: 1	صَوْمُ النَّيْرُوزِ
u'صَوْمٌ وَاجِبٌ':Added, #1: 1	صَوْمُ هَدْيٍ
u'صَوْمٌ وَاجِبٌ':Added, #12: 12	صَوْمٍ وَاجِبٍ
u'صَوْمٌ وَاجِبٌ':Added, #1: 1	صَوْمُ الْوَاجِبِ
u'صَوْمٌ وَاجِبٌ':Added, #1: 1	صَوْمِ الْوَاجِبِ
u'صَوْمٌ واحد':Added, #2: 2	صَوْمُ وَاجِبٍ
u'صَوْمٌ وَاحِدٌ':Added, #1: 1	صَوْمُ وَاحِدٍ
u'صَوْمٌ وَرَثَةٌ':Added, #1: 1	صَوْمُ وَاحِدٍ
u'صَوْمٌ وصال':Added, #3: 3	صَوْمِ الْوَرَثَةِ
u'صَوْمٌ وِصَالٌ':Added, #1: 1	صَوْمِ الْوِصَالِ
u'صَوْمٌ وصال':Added, #1: 1	صَوْمِ الْوِصَالِ
u'صَوْمٌ وِصَالٌ':Added, #2: 2	صَوْمُ الْوِصَالِ
u'صَوْمٌ وَقْتٌ':Added, #2: 2	صَوْمُ الْوِصَالِ
u'صَوْمٌ يهود':Added, #2: 2	صَوْمَ الْوَقْتِ
u'صَوْمٌ يَهُودٌ':Added, #2: 2	صَوْمِ الْيَهُودِ
u'صَوْمٌ يَوْمٌ':Added, #2: 2	صَوْمِ الْيَهُودِ
u'صَوْمٌ يَوْمٌ':Added, #11: 11	صَوْمِ الْيَوْمِ
u'صَوْمٌ يَوْمٌ':Added, #1: 1	صَوْمِ الْيَوْمَيْنِ
u'صَوْمٌ يَوْمٌ':Added, #1: 1	صَوْم يَوْمِ
u'صَوْمٌ يَوْمٌ':Added, #1: 1	صَوْمِ يَوْمِهِ
u'صَوْمٌ يَوْمٌ':Added, #1: 1	صَوْمُ يَوْمَيْنِ
u'صَوْمٌ يَوْمٌ':Added, #21: 21	صَوْمِ يَوْمٍ
u'صَوْمٌ يَوْمٌ':Added, #2: 2	صَوْمَ الْيَوْمَيْنِ
u'صَوْمٌ يَوْمٌ':Added, #30: 30	صَوْمَ يَوْمٍ
u'صَوْمٌ يَوْمٌ':Added, #31: 31	صَوْمُ يَوْمٍ
u'صَوْمٌ يَوْمٌ':Added, #36: 36	صَوْمَ يَوْمِ
u'صَوْمٌ يَوْمٌ':Added, #4: 4	صَوْمَ يَوْمِهِ
u'صَوْمٌ يَوْمٌ':Added, #57: 57	صَوْمُ يَوْمِ
u'صَوْمٌ يَوْمٌ':Added, #5: 5	صَوْمُ الْيَوْمِ
u'صَوْمٌ يَوْمٌ':Added, #5: 5	صَوْمِ يَوْمَيْنِ
u'صَوْمٌ يَوْمٌ':Added, #6: 6	صَوْمَ الْيَوْمِ
u'صَوْنٌ ثِيابٌ':Added, #86: 86	صَوْمِ يَوْمِ
u'صَوْنٌ حَقٌّ':Added, #2: 2	صَوْنَ الثِّيَابِ
u'صَوْنٌ دَمٌ':Added, #1: 1	صَوْنُ حَقِّهِ
u'صَوْنٌ دَمٌ':Added, #1: 1	صَوْنَ الدَّمِ
u'صَوْنٌ رُطَبٌ':Added, #3: 3	صَوْنِ الدَّمِ
u'صَوْنٌ صَوْمٌ':Added, #1: 1	صَوْنُ الرُّطَبِ
u'صَوْنٌ عِبَارَةٌ':Added, #1: 1	صَوْنُ الصَّوْمِ
u'صَوْنٌ عِرْضٌ':Added, #1: 1	صَوْنِ عِبَارَةِ
u'صَوْنٌ قَضَاءٌ':Added, #1: 1	صَوْنِ الْعِرْضِ
u'صَوْنٌ قَوَد':Added, #1: 1	صَوْنُ الْقَضَاءِ
u'صَوْنٌ كَلاَمٌ':Added, #1: 1	صَوْنُ الْقَوَدِ
u'صَوْنٌ كَلاَمٌ':Added, #1: 1	صَوْنَ كَلَامِ
u'صَوْنٌ كَلاَمٌ':Added, #1: 1	صَوْنِ كَلَامِ
u'صَوْنٌ لِسَانٌ':Added, #1: 1	صَوْنَ كَلَامِهِ
u'صَوْنٌ مَاءٌ':Added, #4: 4	صَوْنُ اللِّسَانِ
u'صَوْنٌ مَاءٌ':Added, #2: 2	صَوْنِ الْمَاءِ
u'صَوْنٌ مَاءٌ':Added, #2: 2	صَوْنِ مَاءِ
u'صَوْنٌ مَالٌ':Added, #3: 3	صَوْنُ الْمَاءِ
u'صَوْنٌ مَسْجِدٌ':Added, #1: 1	صَوْنُ الْمَالِ
u'صَوْنٌ نَفْسٌ':Added, #1: 1	صَوْنُ الْمَسْجِدِ
u'صِيَاحٌ اِبْنٌ':Added, #2: 2	صَوْنُ النَّفْسِ
u'صِيَاحٌ دِيكٌ':Added, #1: 1	صِيَاحُ ابْنِ
u'صِيَاحٌ دِيَكَةٌ':Added, #1: 1	صِيَاحِ الدِّيكِ
u'صِيَاحٌ دِيَكَةٌ':Added, #1: 1	صِيَاحَ الدِّيَكَةِ
u'صِيَاحٌ صِبْيَانٌ':Added, #1: 1	صِيَاحِ الدِّيَكَةِ
u'صِيَاحٌ عَرَبٌ':Added, #1: 1	صِيَاحَ الصِّبْيَانِ
u'صِيَاحٌ عَقْعَقٌ':Added, #1: 1	صِيَاحِ الْعَرَبِ
u'صِيَاحٌ غير':Added, #1: 1	صِيَاحِ الْعَقْعَقِ
u'صِيَاحٌ غَيْرٌ':Added, #1: 1	صِيَاحِ غَيْرِهِ
u'صِيَاحٌ ولد':Added, #1: 1	صِيَاحِ غَيْرِهِ
u'صِيَاحٌ وَلَدٌ':Added, #1: 1	صِيَاحُ الْوَلَدِ
u'صِيَاغَةٌ أَلْفَاظٌ':Added, #1: 1	صِيَاحُ الْوَلَدِ
u'صِيَاغَةٌ حُلِيٌّ':Added, #1: 1	صِيَاغَةِ الْأَلْفَاظِ
u'صِيَامٌ آخِرُ':Added, #1: 1	صِيَاغَةُ الْحُلِيِّ
u'صِيَامٌ أَشْهُرٌ':Added, #1: 1	صِيَامَ آخِرِ
u'صِيَامٌ ألف':Added, #1: 1	صِيَامَ الْأَشْهُرِ
u'صِيَامٌ ألْفٌ':Added, #2: 2	صِيَامِ أَلْفِ
u'صِيَامٌ أَلْفٌ':Added, #2: 2	صِيَامِ أَلْفِ
u'صِيَامٌ أيَّامٌ':Added, #2: 2	صِيَامِ أَلْفِ
u'صِيَامٌ أَيَّامٌ':Added, #1: 1	صِيَامُ الْأَيَّامِ
u'صِيَامٌ أيَّامٌ':Added, #1: 1	صِيَامُ الْأَيَّامِ
u'صِيَامٌ أَيَّامٌ':Added, #1: 1	صِيَامُ أَيَّامٍ
u'صِيَامٌ أيَّامٌ':Added, #1: 1	صِيَامُ أَيَّامٍ
u'صِيَامٌ أَيَّامٌ':Added, #2: 2	صِيَامَ الْأَيَّامِ
u'صِيَامٌ أيَّامٌ':Added, #2: 2	صِيَامَ الْأَيَّامِ
u'صِيَامٌ أَيَّامٌ':Added, #3: 3	صِيَامَ أَيَّامٍ
u'صِيَامٌ أيَّامٌ':Added, #3: 3	صِيَامَ أَيَّامٍ
u'صِيَامٌ أَيَّامٌ':Added, #4: 4	صِيَامُ أَيَّامِ
u'صِيَامٌ أيَّامٌ':Added, #4: 4	صِيَامُ أَيَّامِ
u'صِيَامٌ أيَّامٌ':Added, #7: 7	صِيَامَ أَيَّامِ
u'صِيَامٌ أَيَّامٌ':Added, #7: 7	صِيَامِ أَيَّامِ
u'صِيَامٌ أَيَّامٌ':Added, #7: 7	صِيَامَ أَيَّامِ
u'صِيَامٌ تَطَوُّعٌ':Added, #7: 7	صِيَامِ أَيَّامِ
u'صِيَامٌ تَمَتُّعٌ':Added, #5: 5	صِيَامِ التَّطَوُّعِ
u'صِيَامٌ تَمَتُّعٌ':Added, #1: 1	صِيَامَ التَّمَتُّعِ
u'صِيَامٌ ثَلاثَةٌ':Added, #1: 1	صِيَامُ التَّمَتُّعِ
u'صِيَامٌ ثَلاثَةٌ':Added, #13: 13	صِيَامُ ثَلَاثَةِ
u'صِيَامٌ ثَلاثَةٌ':Added, #1: 1	صِيَامَ الثَّلَاثَةِ
u'صِيَامٌ ثَلاثَةٌ':Added, #1: 1	صِيَامُ ثَلَاثَةٍ
u'صِيَامٌ ثَلاثَةٌ':Added, #1: 1	صِيَامُ ثَلاَثَةِ
u'صِيَامٌ ثَلاثَةٌ':Added, #1: 1	صِيَامِ ثَلَاثَةٍ
u'صِيَامٌ ثَلاثَةٌ':Added, #1: 1	صِيَامِ ثَلاَثَةِ
u'صِيَامٌ ثَلاثَةٌ':Added, #2: 2	صِيَامِ الثَّلَاثَةِ
u'صِيَامٌ دَهْرٌ':Added, #3: 3	صِيَامِ ثَلَاثَةِ
u'صِيَامٌ دَهْرٌ':Added, #11: 11	صِيَامُ الدَّهْرِ
u'صِيَامٌ دَهْرٌ':Added, #2: 2	صِيَامَ الدَّهْرِ
u'صِيَامٌ رَجَبٌ':Added, #4: 4	صِيَامِ الدَّهْرِ
u'صِيَامٌ رَجُلٌ':Added, #2: 2	صِيَامِ رَجَبٍ
u'صِيَامٌ رَسُولٌ':Added, #1: 1	صِيَامُ رَجُلٍ
u'صِيَامٌ زَمَنٌ':Added, #2: 2	صِيَامِ رَسُولِ
u'صِيَامٌ سابع':Added, #1: 1	صِيَامُ الزَّمَنِ
u'صِيَامٌ سَابعٌ':Added, #1: 1	صِيَامُ السَّابِعِ
u'صِيَامٌ سَبْعَةٌ':Added, #1: 1	صِيَامُ السَّابِعِ
u'صِيَامٌ سَبْعَةٌ':Added, #1: 1	صِيَامَ السَّبْعَةِ
u'صِيَامٌ سِتٌّ':Added, #1: 1	صِيَامِ سَبْعَةٍ
u'صِيَامٌ سِتٌّ':Added, #1: 1	صِيَامَ سِتَّةِ
u'صِيَامٌ سِتٌّ':Added, #1: 1	صِيَامُ سِتَّةِ
u'صِيَامٌ سِتٌّ':Added, #1: 1	صِيَامِ سِتَّةٍ
u'صِيَامٌ سَنَةٌ':Added, #1: 1	صِيَامِ سِتَّةِ
u'صِيَامٌ سَنَةٌ':Added, #1: 1	صِيَامَ السَّنَةِ
u'صِيَامٌ سَنَةٌ':Added, #1: 1	صِيَامُ السَّنَةِ
u'صِيَامٌ سَنَةٌ':Added, #1: 1	صِيَامُ سَنَةٍ
u'صِيَامٌ شَهْرٌ':Added, #1: 1	صِيَامِ سَنَةٍ
u'صِيَامٌ شَهْرٌ':Added, #10: 10	صِيَامَ شَهْرٍ
u'صِيَامٌ شَهْرٌ':Added, #15: 15	صِيَامُ شَهْرَيْنِ
u'صِيَامٌ شَهْرٌ':Added, #1: 1	صِيَامَ الشَّهْرِ
u'صِيَامٌ شَهْرٌ':Added, #3: 3	صِيَامَ شَهْرِ
u'صِيَامٌ شَهْرٌ':Added, #3: 3	صِيَامَ شَهْرَيْنِ
u'صِيَامٌ شَهْرٌ':Added, #4: 4	صِيَامُ شَهْرٍ
u'صِيَامٌ شَهْرٌ':Added, #4: 4	صِيَامُ شَهْرِ
u'صِيَامٌ شَهْرٌ':Added, #4: 4	صِيَامِ شَهْرٍ
u'صِيَامٌ شَهْرٌ':Added, #4: 4	صِيَامِ شَهْرَيْنِ
u'صِيَامٌ صَاحِبٌ':Added, #6: 6	صِيَامِ شَهْرِ
u'صِيَامٌ صِبْيَانٌ':Added, #1: 1	صِيَامِ صَاحِبِهِ
u'صِيَامٌ صَحِيحٌ':Added, #1: 1	صِيَامِ الصِّبْيَانِ
u'صِيَامٌ عَامٌ':Added, #1: 1	صِيَامِ الصَّحِيحِ
u'صِيَامٌ عَشْرٌ':Added, #1: 1	صِيَامَ الْعَامِ
u'صِيَامٌ غير':Added, #1: 1	صِيَامِ الْعَشْرِ
u'صِيَامٌ غَيْرٌ':Added, #1: 1	صِيَامَ غَيْرِهِ
u'صِيَامٌ فَرْضٌ':Added, #1: 1	صِيَامَ غَيْرِهِ
u'صِيَامٌ فِطْرٌ':Added, #2: 2	صِيَامِ فَرْضٍ
u'صِيَامٌ فلان':Added, #1: 1	صِيَامِ الْفِطْرِ
u'صِيَامٌ كَفَّارٌ':Added, #1: 1	صِيَامُ رَمَضَانَيْنِ
u'صِيَامٌ كَفَّارٌ':Added, #1: 1	صِيَامِ كَفَّارَةِ
u'صِيَامٌ كَفَّارَةٌ':Added, #2: 2	صِيَامِ الْكَفَّارَةِ
u'صِيَامٌ كَفَّارَةٌ':Added, #1: 1	صِيَامِ كَفَّارَةِ
u'صِيَامٌ مُتَتَابِعٌ':Added, #2: 2	صِيَامِ الْكَفَّارَةِ
u'صِيَامٌ مُتْعَةٌ':Added, #3: 3	صِيَامٍ مُتَتَابِعٍ
u'صِيَامٌ مُتْعَةٌ':Added, #1: 1	صِيَامُ الْمُتْعَةِ
u'صِيَامٌ مُتَقَدِّمٌ':Added, #2: 2	صِيَامِ الْمُتْعَةِ
u'صِيَامٌ مُتَمَتِّعٌ':Added, #1: 1	صِيَامٍ مُتَقَدِّمٍ
u'صِيَامٌ مُتَمَتِّعٌ':Added, #1: 1	صِيَامَ الْمُتَمَتِّعِ
u'صِيَامٌ مُتَمَتِّعٌ':Added, #1: 1	صِيَامُ الْمُتَمَتِّعِ
u'صِيَامٌ نَاسٌ':Added, #1: 1	صِيَامِ الْمُتَمَتِّعِ
u'صِيَامٌ نَافِلَةٌ':Added, #3: 3	صِيَامِ النَّاسِ
u'صِيَامٌ نذر':Added, #1: 1	صِيَامِ النَّافِلَةِ
u'صِيَامٌ نَذْرٌ':Added, #1: 1	صِيَامِ النَّذْرِ
u'صِيَامٌ نِصْفٌ':Added, #1: 1	صِيَامِ النَّذْرِ
u'صِيَامٌ نهار':Added, #1: 1	صِيَامَ نِصْفِ
u'صِيَامٌ نَهَارٌ':Added, #7: 7	صِيَامِ النَّهَارِ
u'صِيَامٌ هَدْيٌ':Added, #7: 7	صِيَامِ النَّهَارِ
u'صِيَامٌ يَوْمٌ':Added, #1: 1	صِيَامَ الْهَدْيِ
u'صِيَامٌ يَوْمٌ':Added, #11: 11	صِيَامُ يَوْمِ
u'صِيَامٌ يَوْمٌ':Added, #12: 12	صِيَامِ يَوْمِ
u'صِيَامٌ يَوْمٌ':Added, #1: 1	صِيَامُ الْيَوْمِ
u'صِيَامٌ يَوْمٌ':Added, #3: 3	صِيَامَ يَوْمِ
u'صِيَامٌ يَوْمٌ':Added, #5: 5	صِيَامِ يَوْمَيْنِ
u'صِيَامٌ يَوْمٌ':Added, #7: 7	صِيَامَ يَوْمٍ
u'صِيَامٌ يَوْمٌ':Added, #7: 7	صِيَامُ يَوْمٍ
u'صِيَانَةٌ إِحْرَامٌ':Added, #7: 7	صِيَامِ يَوْمٍ
u'صِيَانَةٌ اِسْمٌ':Added, #1: 1	صِيَانَةِ إحْرَامِ
u'صِيَانَةٌ اِعْتِقادٌ':Added, #1: 1	صِيَانَةُ اسْمِ
u'صِيَانَةٌ أَعْرَاضٌ':Added, #1: 1	صِيَانَةِ اعْتِقَادِهِ
u'صِيَانَةٌ أَمْوَالٌ':Added, #2: 2	صِيَانَةُ الْأَعْرَاضِ
u'صِيَانَةٌ أَمْوَالٌ':Added, #1: 1	صِيَانَةِ أَمْوَالِ
u'صِيَانَةٌ أَمْوَالٌ':Added, #2: 2	صِيَانَةُ أَمْوَالِ
u'صِيَانَةٌ أَنْسَابٌ':Added, #3: 3	صِيَانَةُ الْأَمْوَالِ
u'صِيَانَةٌ ثِيابٌ':Added, #2: 2	صِيَانَةُ الْأَنْسَابِ
u'صِيَانَةٌ جَمَاعَةٌ':Added, #2: 2	صِيَانَةِ الثِّيَابِ
u'صِيَانَةٌ جَمَاعَةٌ':Added, #1: 1	صِيَانَةِ الْجَمَاعَةِ
u'صِيَانَةٌ حُرْمَةٌ':Added, #2: 2	صِيَانَةَ الْجَمَاعَةِ
u'صِيَانَةٌ حُرْمَةٌ':Added, #1: 1	صِيَانَةُ حُرْمَةِ
u'صِيَانَةٌ حَقٌّ':Added, #1: 1	صِيَانَةِ حُرْمَةِ
u'صِيَانَةٌ حَقٌّ':Added, #1: 1	صِيَانَةُ الْحَقِّ
u'صِيَانَةٌ حَقٌّ':Added, #1: 1	صِيَانَةِ حَقِّهِ
u'صِيَانَةٌ حُقوقٌ':Added, #2: 2	صِيَانَةُ حَقِّ
u'صِيَانَةٌ حُقُوقٌ':Added, #2: 2	صِيَانَةِ حُقُوقِ
u'صِيَانَةٌ خَيْلٌ':Added, #2: 2	صِيَانَةِ حُقُوقِ
u'صِيَانَةٌ خَيْلٌ':Added, #1: 1	صِيَانَةَ الْخَيْلِ
u'صِيَانَةٌ دَمٌ':Added, #1: 1	صِيَانَةُ الْخَيْلِ
u'صِيَانَةٌ رحم':Added, #1: 1	صِيَانَةُ دَمِهِ
u'صِيَانَةٌ رَحِمٌ':Added, #2: 2	صِيَانَةُ الرَّحِمِ
u'صِيَانَةٌ سِلاَحٌ':Added, #2: 2	صِيَانَةُ الرَّحِمِ
u'صِيَانَةٌ صَلاَةٌ':Added, #1: 1	صِيَانَةِ سِلَاحِهِ
u'صِيَانَةٌ صَلاَةٌ':Added, #1: 1	صِيَانَةُ صَلَاةِ
u'صِيَانَةٌ ضَالٌّ':Added, #2: 2	صِيَانَةِ الصَّلَاةِ
u'صِيَانَةٌ طَهَارَةٌ':Added, #2: 2	صِيَانَةِ الضَّالِّ
u'صِيَانَةٌ عِرْضٌ':Added, #1: 1	صِيَانَةِ الطَّهَارَةِ
u'صِيَانَةٌ عِرْضٌ':Added, #1: 1	صِيَانَةَ الْعِرْضِ
u'صِيَانَةٌ عَقْدٌ':Added, #1: 1	صِيَانَةُ عِرْضِ
u'صِيَانَةٌ عُقُولٌ':Added, #1: 1	صِيَانَةُ الْعَقْدِ
u'صِيَانَةٌ علم':Added, #2: 2	صِيَانَةُ الْعُقُولِ
u'صِيَانَةٌ عِلْمٌ':Added, #1: 1	صِيَانَةُ عِلْمِهِ
u'صِيَانَةٌ علم':Added, #1: 1	صِيَانَةُ عِلْمِهِ
u'صِيَانَةٌ عِلْمٌ':Added, #2: 2	صِيَانَةِ الْعِلْمِ
u'صِيَانَةٌ فِرَاشٌ':Added, #2: 2	صِيَانَةِ الْعِلْمِ
u'صِيَانَةٌ فَرْجٌ':Added, #1: 1	صِيَانَةِ فِرَاشِهِ
u'صِيَانَةٌ قُرْآنٌ':Added, #1: 1	صِيَانَةَ فَرْجِهِ
u'صِيَانَةٌ قَضَاءٌ':Added, #1: 1	صِيَانَةُ الْقُرْآنِ
u'صِيَانَةٌ قِطَارٌ':Added, #2: 2	صِيَانَةَ الْقَضَاءِ
u'صِيَانَةٌ كِتَابَةٌ':Added, #2: 2	صِيَانَةُ الْقِطَارِ
u'صِيَانَةٌ كَلاَمٌ':Added, #1: 1	صِيَانَةِ كِتَابَةٍ
u'صِيَانَةٌ كَلاَمٌ':Added, #1: 1	صِيَانَةُ كَلَامِ
u'صِيَانَةٌ مَاءٌ':Added, #2: 2	صِيَانَةِ كَلَامِ
u'صِيَانَةٌ مَاءٌ':Added, #1: 1	صِيَانَةُ الْمَاءِ
u'صِيَانَةٌ مَالٌ':Added, #5: 5	صِيَانَةِ الْمَاءِ
u'صِيَانَةٌ مَالٌ':Added, #2: 2	صِيَانَةَ الْمَالِ
u'صِيَانَةٌ مَالٌ':Added, #2: 2	صِيَانَةِ الْمَالِ
u'صِيَانَةٌ مَالٌ':Added, #2: 2	صِيَانَةِ مَالِهِ
u'صِيَانَةٌ مَسَاجِدُ':Added, #3: 3	صِيَانَةُ الْمَالِ
u'صِيَانَةٌ مَسْجِدٌ':Added, #1: 1	صِيَانَةِ الْمَسَاجِدِ
u'صِيَانَةٌ مَسْجِدٌ':Added, #1: 1	صِيَانَةَ الْمَسْجِدِ
u'صِيَانَةٌ مَسْجِدٌ':Added, #2: 2	صِيَانَةُ الْمَسْجِدِ
u'صِيَانَةٌ مُسْلِمٌ':Added, #4: 4	صِيَانَةِ الْمَسْجِدِ
u'صِيَانَةٌ مُصْحَفٌ':Added, #1: 1	صِيَانَةَ الْمُسْلِمِ
u'صِيَانَةٌ مُهْجَةٌ':Added, #1: 1	صِيَانَةُ الْمُصْحَفِ
u'صِيَانَةٌ نَسْلٌ':Added, #1: 1	صِيَانَةَ مُهْجَتِهِ
u'صِيَانَةٌ نُطْفَةٌ':Added, #1: 1	صِيَانَةُ النَّسْلِ
u'صِيَانَةٌ نَفْسٌ':Added, #1: 1	صِيَانَةُ النُّطْفَةِ
u'صِيَانَةٌ نَفْسٌ':Added, #1: 1	صِيَانَةِ النَّفْسِ
u'صِيَانَةٌ نَفْسٌ':Added, #1: 1	صِيَانَةِ نَفْسٍ
u'صِيَانَةٌ نَفْسٌ':Added, #1: 1	صِيَانَةِ نَفْسِهِ
u'صِيَانَةٌ نَفْسٌ':Added, #2: 2	صِيَانَةُ نَفْسِهِ
u'صِيَانَةٌ نَفْسٌ':Added, #3: 3	صِيَانَةَ نَفْسِهِ
u'صِيَانَةٌ نَفْسٌ':Added, #4: 4	صِيَانَةَ النَّفْسِ
u'صِيَانَةٌ نُفُوسٌ':Added, #4: 4	صِيَانَةُ النَّفْسِ
u'صِيَانَةٌ نُفُوسٌ':Added, #1: 1	صِيَانَةُ النُّفُوسِ
u'صِيَانَةٌ وَصِيٌّ':Added, #1: 1	صِيَانَةِ النُّفُوسِ
u'صِيَانَةٌ ولد':Added, #1: 1	صِيَانَةَ الْوَصِيِّ
u'صِيَانَةٌ وَلَدٌ':Added, #2: 2	صِيَانَةَ الْوَلَدِ
u'صَيْدٌ آجَامٌ':Added, #2: 2	صِيَانَةَ الْوَلَدِ
u'صَيْدٌ إِحْرَامٌ':Added, #1: 1	صَيْدِ الْآجَامِ
u'صَيْدٌ أخرَس':Added, #2: 2	صَيْدِ الْإِحْرَامِ
u'صَيْدٌ أَنْهَارٌ':Added, #1: 1	صَيْدُ الْأَخْرَسِ
u'صَيْدٌ أهْلٌ':Added, #1: 1	صَيْدَ الأَنْهَارِ
u'صَيْدٌ بَحْرٌ':Added, #1: 1	صَيْدِ أَهْلِ
u'صَيْدٌ بَحْرٌ':Added, #16: 16	صَيْدِ الْبَحْرِ
u'صَيْدٌ بَحْرٌ':Added, #28: 28	صَيْدُ الْبَحْرِ
u'صَيْدٌ بِرٌّ':Added, #6: 6	صَيْدَ الْبَحْرِ
u'صَيْدٌ بَرٌّ':Added, #1: 1	صَيْدُ الْبِرِّ
u'صَيْدٌ بَرٌّ':Added, #21: 21	صَيْدِ الْبَرِّ
u'صَيْدٌ بَرٌّ':Added, #33: 33	صَيْدُ الْبَرِّ
u'صَيْدٌ بَرِّيٌّ':Added, #4: 4	صَيْدَ الْبَرِّ
u'صَيْدٌ جَارِحٌ':Added, #1: 1	صَيْدٍ بَرِّيٍّ
u'صَيْدٌ جَارِحَةٌ':Added, #1: 1	صَيْدَ جَارِحَةٍ
u'صَيْدٌ جَاهِلٌ':Added, #1: 1	صَيْدَ جَارِحَةٍ
u'صَيْدٌ جَرَادٌ':Added, #1: 1	صَيْدَ الْجَاهِلِ
u'صَيْدٌ حَجَلٌ':Added, #2: 2	صَيْدِ الْجَرَادِ
u'صَيْدٌ حَرَمٌ':Added, #1: 1	صَيْدِ الْحَجَلِ
u'صَيْدٌ حَرَمٌ':Added, #103: 103	صَيْدِ الْحَرَمِ
u'صَيْدٌ حَرَمٌ':Added, #11: 11	صَيْدُ الْحَرَمِ
u'صَيْدٌ حَرَمٌ':Added, #1: 1	صَيْدِ الْحَرَمَيْنِ
u'صَيْدٌ حَرَمٌ':Added, #1: 1	صَيْدِ حَرَمِ
u'صَيْدٌ حَرَمٌ':Added, #42: 42	صَيْدَ الْحَرَمِ
u'صَيْدٌ حِلٌّ':Added, #6: 6	صَيْدَ حَرَمٍ
u'صَيْدٌ حِلٌّ':Added, #1: 1	صَيْدُ حِلٍّ
u'صَيْدٌ حِلٌّ':Added, #2: 2	صَيْدَ الْحِلِّ
u'صَيْدٌ حِلٌّ':Added, #4: 4	صَيْدُ الْحِلِّ
u'صَيْدٌ حَلالٌ':Added, #5: 5	صَيْدِ الْحِلِّ
u'صَيْدٌ حَلالٌ':Added, #1: 1	صَيْدِ الْحَلَالِ
u'صَيْدٌ حَيَوَانٌ':Added, #1: 1	صَيْدَ حَلَالٍ
u'صَيْدٌ خَاطِرٌ':Added, #1: 1	صَيْدِ الْحَيَوَانِ
u'صَيْدٌ خِنْزِيرٌ':Added, #7: 7	صَيْدِ الْخَاطِرِ
u'صَيْدٌ دَارٌ':Added, #1: 1	صَيْدُ الْخِنْزِيرِ
u'صَيْدٌ ذِمِّيٌّ':Added, #1: 1	صَيْدُ دَارِ
u'صَيْدٌ ذِمِّيٌّ':Added, #1: 1	صَيْدِ ذِمِّيٍّ
u'صَيْدٌ سَبْتٌ':Added, #3: 3	صَيْدُ الذِّمِّيِّ
u'صَيْدٌ سَكْرَان':Added, #1: 1	صَيْدَ السَّبْتِ
u'صَيْدٌ سَمَكٌ':Added, #1: 1	صَيْدِ السَّكْرَانِ
u'صَيْدٌ سَمَكٌ':Added, #1: 1	صَيْدَ السَّمَكِ
u'صَيْدٌ سَمَكٌ':Added, #1: 1	صَيْدَ سَمَكٍ
u'صَيْدٌ سَمَكٌ':Added, #2: 2	صَيْدُ السَّمَكِ
u'صَيْدٌ سَمَكٌ':Added, #3: 3	صَيْدُ سَمَكٍ
u'صَيْدٌ صَبِيٌّ':Added, #6: 6	صَيْدِ السَّمَكِ
u'صَيْدٌ صَبِيٌّ':Added, #1: 1	صَيْدُ الصَّبِيِّ
u'صَيْدٌ عَبْدٌ':Added, #1: 1	صَيْدُ صَبِيٍّ
u'صَيْدٌ عَبْدٌ':Added, #1: 1	صَيْدُ الْعَبْدِ
u'صَيْدٌ عَبْدٌ':Added, #2: 2	صَيْدَ عَبْدٍ
u'صَيْدٌ عَيْشٌ':Added, #3: 3	صَيْدِ الْعَبْدِ
u'صَيْدٌ غير':Added, #1: 1	صَيْدِ عَيْشِهِ
u'صَيْدٌ غَيْرٌ':Added, #1: 1	صَيْدِ غَيْرِهِ
u'صَيْدٌ غير':Added, #1: 1	صَيْدِ غَيْرِهِ
u'صَيْدٌ غَيْرٌ':Added, #2: 2	صَيْدِ غَيْرِ
u'صَيْدٌ فَرْخٌ':Added, #2: 2	صَيْدِ غَيْرِ
u'صَيْدٌ فَرَسٌ':Added, #1: 1	صَيْدُ فَرْخٍ
u'صَيْدٌ فَهْدٌ':Added, #1: 1	صَيْدِ الْفَرَسِ
u'صَيْدٌ كَلْبٌ':Added, #1: 1	صَيْدُ الْفَهْدِ
u'صَيْدٌ كَلْبٌ':Added, #10: 10	صَيْدِ الْكَلْبِ
u'صَيْدٌ كَلْبٌ':Added, #1: 1	صَيْدِ كَلْبِ
u'صَيْدٌ كَلْبٌ':Added, #2: 2	صَيْدَ الْكَلْبِ
u'صَيْدٌ كَلْبٌ':Added, #2: 2	صَيْدُ الْكَلْبِ
u'صَيْدٌ كَلْبٌ':Added, #2: 2	صَيْدَ كَلْبٍ
u'صَيْدٌ لَهْوٌ':Added, #2: 2	صَيْدُ كَلْبٍ
u'صَيْدٌ مَاءٌ':Added, #1: 1	صَيْدِ اللَّهْوِ
u'صَيْدٌ مَأْكُولٌ':Added, #1: 1	صَيْدِ الْمَاءِ
u'صَيْدٌ مُبَاحٌ':Added, #2: 2	صَيْدٍ مَأْكُولٍ
u'صَيْدٌ مَجْرُوحٌ':Added, #2: 2	صَيْدٍ مُبَاحٍ
u'صَيْدٌ مَجْنُونٌ':Added, #1: 1	صَيْدٍ مَجْرُوحٍ
u'صَيْدٌ مَجُوسٌ':Added, #1: 1	صَيْدِ الْمَجْنُونِ
u'صَيْدٌ مَجُوسِيٌّ':Added, #1: 1	صَيْدِ الْمَجُوسِ
u'صَيْدٌ مُحْرِمٌ':Added, #6: 6	صَيْدُ الْمَجُوسِيِّ
u'صَيْدٌ مُحْرِمٌ':Added, #1: 1	صَيْدَ الْمُحْرِمِ
u'صَيْدٌ مُحْرِمٌ':Added, #1: 1	صَيْدُ الْمُحْرِمِ
u'صَيْدٌ مَدِينٌ':Added, #7: 7	صَيْدِ الْمُحْرِمِ
u'صَيْدٌ مَدِينٌ':Added, #1: 1	صَيْدَ الْمَدِينَةِ
u'صَيْدٌ مَدِينٌ':Added, #4: 4	صَيْدُ الْمَدِينَةِ
u'صَيْدٌ مَدِينَةٌ':Added, #4: 4	صَيْدِ الْمَدِينَةِ
u'صَيْدٌ مَدِينَةٌ':Added, #1: 1	صَيْدَ الْمَدِينَةِ
u'صَيْدٌ مَدِينَةٌ':Added, #4: 4	صَيْدُ الْمَدِينَةِ
u'صَيْدٌ مِعْراض':Added, #4: 4	صَيْدِ الْمَدِينَةِ
u'صَيْدٌ مُعَيَّنٌ':Added, #6: 6	صَيْدِ الْمِعْرَاضِ
u'صَيْدٌ مُقَيَّدٌ':Added, #1: 1	صَيْدٍ مُعَيَّنٍ
u'صَيْدٌ مُلُوكٌ':Added, #1: 1	صَيْدٍ مُقَيَّدٍ
u'صَيْدٌ مَمْلُوكٌ':Added, #4: 4	صَيْدُ الْمُلُوكِ
u'صَيْدٌ مَمْلُوكٌ':Added, #1: 1	صَيْدِ مَمْلُوكٍ
u'صَيْدٌ مُمَيِّزٌ':Added, #4: 4	صَيْدٍ مَمْلُوكٍ
u'صَيْدٌ مُوثَقٌ':Added, #1: 1	صَيْدِ الْمُمَيِّزِ
u'صَيْدٌ مُوَثَّقٌ':Added, #1: 1	صَيْدٍ مُوثَقٍ
u'صَيْدٌ نَفْسٌ':Added, #1: 1	صَيْدٍ مُوَثَّقٍ
u'صَيْدٌ نَوَازِلُ':Added, #1: 1	صَيْدِ نَفْسِهِ
u'صَيْدٌ ولد':Added, #1: 1	صَيْدِ النَّوَازِلِ
u'صَيْدٌ وَلَدٌ':Added, #1: 1	صَيْدِ الْوَلَدِ
u'صَيَّرَ تَسْمِيَة':Predicate, #1: 1	صَيْدِ الْوَلَدِ
u'صَيَّرَ حَقٌّ':Predicate, #1: 1	صَيَّرَ التَّسْمِيَةَ
u'صَيَّرَ ضَمَانٌ':Predicate, #2: 2	صَيَّرَ حَقَّ
u'صَيَّرَ فَاعِلٌ':Predicate, #2: 2	صَيَّرَ الضَّمَانَ
u'صَيَّرَ مَجْمُوعٌ':Predicate, #1: 1	صَيَّرَ الْفَاعِلَ
u'صَيَّرَ مَسْأَلَةٌ':Predicate, #1: 1	صَيَّرَ الْمَجْمُوعَ
u'صِيَغٌ إِخْبَارٌ':Added, #1: 1	صَيَّرَ الْمَسْأَلَةَ
u'صِيَغٌ أَعْلاَمٌ':Added, #1: 1	صِيَغِ الْإِخْبَارِ
u'صِيَغٌ أَعَمُّ':Added, #1: 1	صِيَغِ الْأَعْلَامِ
u'صِيَغٌ أَعَمُّ':Added, #1: 1	صِيَغُ الْأَعَمِّ
u'صِيَغٌ أَفْعَالٌ':Added, #1: 1	صِيَغِ الْأَعَمِّ
u'صِيَغٌ أَلْفَاظٌ':Added, #1: 1	صِيَغَ الْأَفْعَالِ
u'صِيَغٌ أَمْرٌ':Added, #1: 1	صِيَغِ الْأَلْفَاظِ
u'صِيَغٌ أَمْرٌ':Added, #1: 1	صِيَغُ الْأَمْرِ
u'صِيَغٌ إِيجَابٌ':Added, #2: 2	صِيَغِ الْأَمْرِ
u'صِيَغٌ بَيْعٌ':Added, #1: 1	صِيَغِ الْإِيجَابِ
u'صِيغَةٌ إجَارَةٌ':Added, #1: 1	صِيَغِ الْبَيْعِ
u'صِيغَةٌ إِخْبَارٌ':Added, #2: 2	صِيغَةُ الْإِجَارَةِ
u'صِيغَةٌ إِخْبَارٌ':Added, #1: 1	صِيغَةَ إخْبَارٍ
u'صِيغَةٌ إِخْبَارٌ':Added, #1: 1	صِيغَةِ الْإِخْبَارِ
u'صِيغَةٌ اِسْمٌ':Added, #3: 3	صِيغَةُ إخْبَارٍ
u'صِيغَةٌ إِعْتاقٌ':Added, #18: 18	صِيغَةِ اسْمِ
u'صِيغَةٌ إقالَةٌ':Added, #1: 1	صِيغَةَ الْإِعْتَاقِ
u'صِيغَةٌ إقْرَارٌ':Added, #1: 1	صِيغَةَ الْإِقَالَةِ
u'صِيغَةٌ إقْرَارٌ':Added, #1: 1	صِيغَةُ إقْرَارٍ
u'صِيغَةٌ إقْرَارٌ':Added, #1: 1	صِيغَةَ الْإِقْرَارِ
u'صِيغَةٌ إقْرَارٌ':Added, #1: 1	صِيغَةُ الْإِقْرَارِ
u'صِيغَةٌ اِلْتِزَامٌ':Added, #1: 1	صِيغَةِ الْإِقْرَارِ
u'صِيغَةٌ أَلْفَاظٌ':Added, #3: 3	صِيغَةُ الْتِزَامٍ
u'صِيغَةٌ أمَانٌ':Added, #1: 1	صِيغَةِ الْأَلْفَاظِ
u'صِيغَةٌ أَمْرٌ':Added, #1: 1	صِيغَةِ الْأَمَانِ
u'صِيغَةٌ أَمْرٌ':Added, #14: 14	صِيغَةَ الْأَمْرِ
u'صِيغَةٌ أَمْرٌ':Added, #14: 14	صِيغَةُ الْأَمْرِ
u'صِيغَةٌ أَمْرٌ':Added, #17: 17	صِيغَةِ الْأَمْرِ
u'صِيغَةٌ أَمْرٌ':Added, #2: 2	صِيغَةَ أَمْرٍ
u'صِيغَةٌ إِنْشاءٌ':Added, #2: 2	صِيغَةُ أَمْرٍ
u'صِيغَةٌ إِنْشاءٌ':Added, #1: 1	صِيغَةِ إنْشَاءٍ
u'صِيغَةٌ إِنْكارٌ':Added, #3: 3	صِيغَةُ الْإِنْشَاءِ
u'صِيغَةٌ إهْدَاءٌ':Added, #2: 2	صِيغَةُ إنْكَارِهِ
u'صِيغَةٌ أَوَّلِيٌّ':Added, #1: 1	صِيغَةُ الْإِهْدَاءِ
u'صِيغَةٌ إِيجَابٌ':Added, #1: 1	صِيغَةُ الْأَوَّلِيَّةِ
u'صِيغَةٌ إِيجَابٌ':Added, #1: 1	صِيغَةَ الْإِيجَابِ
u'صِيغَةٌ إِيجَابٌ':Added, #1: 1	صِيغَةُ الْإِيجَابِ
u'صِيغَةٌ إِيجَابٌ':Added, #1: 1	صِيغَةِ إيجَابِ
u'صِيغَةٌ بِرٌّ':Added, #2: 2	صِيغَةُ إيجَابٍ
u'صِيغَةٌ بَراءةٌ':Added, #2: 2	صِيغَةِ الْبِرِّ
u'صِيغَةٌ بِنَاءٌ':Added, #1: 1	صِيغَةُ الْبَرَاءَةِ
u'صِيغَةٌ بَيْعٌ':Added, #1: 1	صِيغَةِ الْبِنَاءِ
u'صِيغَةٌ تَثْنِيَةٌ':Added, #1: 1	صِيغَةُ الْبَيْعِ
u'صِيغَةٌ تَثْنِيَةٌ':Added, #1: 1	صِيغَةِ التّثْنِيَةِ
u'صِيغَةٌ تَرْجِيحٌ':Added, #1: 1	صِيغَةِ التَّثْنِيَةِ
u'صِيغَةٌ تَعَجُّبٌ':Added, #1: 1	صِيغَةُ تَرْجِيحٍ
u'صِيغَةٌ تَعْلِيقٌ':Added, #1: 1	صِيغَةُ التَّعَجُّبِ
u'صِيغَةٌ تَعْلِيقٌ':Added, #1: 1	صِيغَةَ تَعْلِيقٍ
u'صِيغَةٌ تَعْلِيقٌ':Added, #1: 1	صِيغَةُ تَعْلِيقِهِ
u'صِيغَةٌ تَعْلِيقٌ':Added, #2: 2	صِيغَةَ التَّعْلِيقِ
u'صِيغَةٌ تَعْلِيقٌ':Added, #2: 2	صِيغَةُ التَّعْلِيقِ
u'صِيغَةٌ تَعْلِيقٌ':Added, #3: 3	صِيغَةُ تَعْلِيقٍ
u'صِيغَةٌ تَعْلِيلٌ':Added, #6: 6	صِيغَةِ التَّعْلِيقِ
u'صِيغَةٌ تَعَوُّذٌ':Added, #1: 1	صِيغَةِ التَّعْلِيلِ
u'صِيغَةٌ تَفْوِيضٌ':Added, #1: 1	صِيغَةَ التَّعَوُّذِ
u'صِيغَةٌ تَفْوِيضٌ':Added, #1: 1	صِيغَةَ تَفْوِيضِهِ
u'صِيغَةٌ تَمْريضٌ':Added, #2: 2	صِيغَةِ التَّفْوِيضِ
u'صِيغَةٌ تَمْريضٌ':Added, #1: 1	صِيغَةُ التَّمْرِيضِ
u'صِيغَةٌ تَنْفِيذٌ':Added, #1: 1	صِيغَةِ تَمْرِيضٍ
u'صِيغَةٌ جمع':Added, #1: 1	صِيغَةُ تَنْفِيذِهِ
u'صِيغَةٌ جمع':Added, #1: 1	صِيغَةَ جَمْعِ
u'صِيغَةٌ جَمْعٌ':Added, #1: 1	صِيغَةِ جَمْعِ
u'صِيغَةٌ جَمْعٌ':Added, #1: 1	صِيغَةَ جَمْعِ
u'صِيغَةٌ جمع':Added, #1: 1	صِيغَةِ جَمْعِ
u'صِيغَةٌ جَمْعٌ':Added, #4: 4	صِيغَةَ الْجَمْعِ
u'صِيغَةٌ جمع':Added, #4: 4	صِيغَةَ الْجَمْعِ
u'صِيغَةٌ جمع':Added, #6: 6	صِيغَةُ الْجَمْعِ
u'صِيغَةٌ جَمْعٌ':Added, #6: 6	صِيغَةِ الْجَمْعِ
u'صِيغَةٌ جَمْعٌ':Added, #6: 6	صِيغَةُ الْجَمْعِ
u'صِيغَةٌ جَوَابٌ':Added, #6: 6	صِيغَةِ الْجَمْعِ
u'صِيغَةٌ حَلٌّ':Added, #1: 1	صِيغَةُ جَوَابٍ
u'صِيغَةٌ حِنْثٌ':Added, #1: 1	صِيغَةِ حَلِّ
u'صِيغَةٌ خَبَرٌ':Added, #5: 5	صِيغَةِ الْحِنْثِ
u'صِيغَةٌ خَبَر':Added, #1: 1	صِيغَةَ الْخَبَرِ
u'صِيغَةٌ خَبَرٌ':Added, #1: 1	صِيغَةَ الْخَبَرِ
u'صِيغَةٌ خَبَر':Added, #2: 2	صِيغَةِ الْخَبَرِ
u'صِيغَةٌ خَبَرٌ':Added, #2: 2	صِيغَةِ الْخَبَرِ
u'صِيغَةٌ خَبَر':Added, #3: 3	صِيغَةُ الْخَبَرِ
u'صِيغَةٌ خُلْعٌ':Added, #3: 3	صِيغَةُ الْخَبَرِ
u'صِيغَةٌ دَالَّةٌ':Added, #1: 1	صِيغَةُ الْخُلْعِ
u'صِيغَةٌ دُعَاءٌ':Added, #1: 1	صِيغَةٍ دَالَّةٍ
u'صِيغَةٌ دَليلٌ':Added, #1: 1	صِيغَةِ الدُّعَاءِ
u'صِيغَةٌ رَدٌّ':Added, #1: 1	صِيغَةُ الدَّلِيلِ
u'صِيغَةٌ رَهْنٌ':Added, #1: 1	صِيغَةِ الرَّدِّ
u'صِيغَةٌ سلام':Added, #1: 1	صِيغَةَ الرَّهْنِ
u'صِيغَةٌ سَلاَمٌ':Added, #1: 1	صِيغَةُ السَّلَامِ
u'صِيغَةٌ شَرْطٌ':Added, #1: 1	صِيغَةُ السَّلَامِ
u'صِيغَةٌ شَرْطٌ':Added, #1: 1	صِيغَةُ الشَّرْطِ
u'صِيغَةٌ شَرْطٌ':Added, #1: 1	صِيغَةُ شَرْطٍ
u'صِيغَةٌ شَرْطٌ':Added, #2: 2	صِيغَةَ شَرْطٍ
u'صِيغَةٌ شَهَادَةٌ':Added, #5: 5	صِيغَةِ الشَّرْطِ
u'صِيغَةٌ صَلاَةٌ':Added, #1: 1	صِيغَةِ الشَّهَادَةِ
u'صِيغَةٌ صَلاَةٌ':Added, #1: 1	صِيغَةُ الصَّلَاةِ
u'صِيغَةٌ طَلاَقٌ':Added, #1: 1	صِيغَةُ صَلَاةٍ
u'صِيغَةٌ طلب':Added, #2: 2	صِيغَةِ طَلَاقٍ
u'صِيغَةٌ طَلَبٌ':Added, #1: 1	صِيغَةِ الطَّلَبِ
u'صِيغَةٌ عتاق':Added, #1: 1	صِيغَةِ الطَّلَبِ
u'صِيغَةٌ عَقْدٌ':Added, #1: 1	صِيغَةَ الْعَتَاقِ
u'صِيغَةٌ عَقْدٌ':Added, #1: 1	صِيغَةَ الْعَقْدِ
u'صِيغَةٌ عَقْدٌ':Added, #1: 1	صِيغَةُ الْعَقْدِ
u'صِيغَةٌ عَقْدٌ':Added, #1: 1	صِيغَةِ الْعَقْدِ
u'صِيغَةٌ عَقْدٌ':Added, #1: 1	صِيغَةِ عَقْدِ
u'صِيغَةٌ عُمُومٌ':Added, #2: 2	صِيغَةِ عَقْدٍ
u'صِيغَةٌ عُمُومٌ':Added, #2: 2	صِيغَةُ الْعُمُومِ
u'صِيغَةٌ عُمُومٌ':Added, #4: 4	صِيغَةَ الْعُمُومِ
u'صِيغَةٌ عُمُومٌ':Added, #4: 4	صِيغَةَ عُمُومٍ
u'صِيغَةٌ فِعْلٌ':Added, #5: 5	صِيغَةِ الْعُمُومِ
u'صِيغَةٌ فِعْلٌ':Added, #1: 1	صِيغَةُ فِعْلٍ
u'صِيغَةٌ قذف':Added, #3: 3	صِيغَةِ الْفِعْلِ
u'صِيغَةٌ قَذْفٌ':Added, #1: 1	صِيغَةِ الْقَذْفِ
u'صِيغَةٌ قَسَمٌ':Added, #1: 1	صِيغَةِ الْقَذْفِ
u'صِيغَةٌ قَسَمٌ':Added, #1: 1	صِيغَةَ الْقَسَمِ
u'صِيغَةٌ قِصَّةٌ':Added, #3: 3	صِيغَةِ الْقَسَمِ
u'صِيغَةٌ كَلاَمٌ':Added, #1: 1	صِيغَةُ الْقِصَّةِ
u'صِيغَةٌ كَلاَمٌ':Added, #1: 1	صِيغَةَ الْكَلَامِ
u'صِيغَةٌ كَلاَمٌ':Added, #1: 1	صِيغَةُ الْكَلَامِ
u'صِيغَةٌ كَلِمَةٌ':Added, #3: 3	صِيغَةَ كَلَامِهِ
u'صِيغَةٌ لعنة':Added, #2: 2	صِيغَةِ الْكَلِمَةِ
u'صِيغَةٌ لَعْنَةٌ':Added, #1: 1	صِيغَةُ اللَّعْنَةِ
u'صِيغَةٌ لَفْظٌ':Added, #1: 1	صِيغَةُ اللَّعْنَةِ
u'صِيغَةٌ لَفْظٌ':Added, #1: 1	صِيغَةَ اللَّفْظِ
u'صِيغَةٌ لَفْظٌ':Added, #1: 1	صِيغَةِ اللَّفْظِ
u'صِيغَةٌ مُبَالَغَةٌ':Added, #1: 1	صِيغَةَ لَفْظِ
u'صِيغَةٌ مُبَالَغَةٌ':Added, #1: 1	صِيغَةُ الْمُبَالَغَةِ
u'صِيغَةٌ مُبَالَغَةٌ':Added, #1: 1	صِيغَةِ الْمُبَالَغَةِ
u'صِيغَةٌ مَبْنِيٌّ':Added, #3: 3	صِيغَةُ مُبَالَغَةٍ
u'صِيغَةٌ مَجَازٌ':Added, #1: 1	صِيغَة الْمَبْنِيِّ
u'صِيغَةٌ مُرْتاب':Added, #1: 1	صِيغَةِ الْمَجَازِ
u'صِيغَةٌ مَسْأَلَةٌ':Added, #1: 1	صِيغَةُ مُرْتَابٍ
u'صِيغَةٌ مَصْدَرٌ':Added, #1: 1	صِيغَةَ مَسْأَلَةِ
u'صِيغَةٌ مُضَارِعٌ':Added, #1: 1	صِيغَةِ الْمَصْدَرِ
u'صِيغَةٌ مُضَارِعٌ':Added, #1: 1	صِيغَةُ الْمُضَارِعِ
u'صِيغَةٌ مُضَارِعٌ':Added, #1: 1	صِيغَةِ الْمُضَارِعِ
u'صِيغَةٌ مُضاهِي':Added, #2: 2	صِيغَةَ الْمُضَارِعِ
u'صِيغَةٌ مُطَالَبٌ':Added, #1: 1	صِيغَةٍ مُضَاهِيَةٍ
u'صِيغَةٌ مُطَالَبَةٌ':Added, #1: 1	صِيغَةَ الْمُطَالَبَةِ
u'صِيغَةٌ مُوَكِّلٌ':Added, #1: 1	صِيغَةَ الْمُطَالَبَةِ
u'صِيغَةٌ نِدَاءٌ':Added, #1: 1	صِيغَةُ الْمُوَكِّلِ
u'صِيغَةٌ نَدْبٌ':Added, #1: 1	صِيغَةِ النِّدَاءِ
u'صِيغَةٌ نذر':Added, #2: 2	صِيغَةِ النَّدْبِ
u'صِيغَةٌ نَذْرٌ':Added, #1: 1	صِيغَةُ النَّذْرِ
u'صِيغَةٌ نَذْرٌ':Added, #1: 1	صِيغَةُ النَّذْرِ
u'صِيغَةٌ نَذْرٌ':Added, #1: 1	صِيغَةَ نَذْرٍ
u'صِيغَةٌ نذر':Added, #1: 1	صِيغَةُ نَذْرٍ
u'صِيغَةٌ نَذْرٌ':Added, #3: 3	صِيغَةِ النَّذْرِ
u'صِيغَةٌ نَفْيٌ':Added, #3: 3	صِيغَةِ النَّذْرِ
u'صِيغَةٌ نَهْيٌ':Added, #1: 1	صِيغَةُ نَفْيٍ
u'صِيغَةٌ نَهْيٌ':Added, #1: 1	صِيغَةَ نَهْيٍ
u'صِيغَةٌ نَهْيٌ':Added, #2: 2	صِيغَةِ النَّهْيِ
u'صِيغَةٌ هِبَةٌ':Added, #3: 3	صِيغَةَ النَّهْيِ
u'صِيغَةٌ وَاثِقٌ':Added, #1: 1	صِيغَةِ الْهِبَةِ
u'صِيغَةٌ واحد':Added, #1: 1	صِيغَةُ وَاثِقٍ
u'صِيغَةٌ وَاحِدٌ':Added, #3: 3	صِيغَةٍ وَاحِدَةٍ
u'صِيغَةٌ وَصْفٌ':Added, #3: 3	صِيغَةٍ وَاحِدَةٍ
u'صِيغَةٌ وَصِيٌّ':Added, #1: 1	صِيغَةُ الْوَصْفِ
u'صِيغَةٌ وَصِيَّةٌ':Added, #1: 1	صِيغَةُ الْوَصِيَّةِ
u'صِيغَةٌ وَعْدٌ':Added, #1: 1	صِيغَةُ الْوَصِيَّةِ
u'صِيغَةٌ وَقْفٌ':Added, #1: 1	صِيغَةُ وَعْدٍ
u'صِيغَةٌ وُقُوعٌ':Added, #1: 1	صِيغَةِ وَقْفٍ
u'صِيغَةٌ يَمِينٌ':Added, #1: 1	صِيغَةُ وُقُوعِ
u'صِيغَةٌ يَمِينٌ':Added, #1: 1	صِيغَةُ الْيَمِينِ
u'صِيغَةٌ يَمِينٌ':Added, #1: 1	صِيغَةِ الْيَمِينِ
u'صِيَغٌ تَدْلِيس':Added, #1: 1	صِيغَةِ يَمِينٍ
u'صِيَغٌ تصاريف':Added, #1: 1	صِيَغِ التَّدْلِيسِ
u'صِيَغٌ تَصَارِيفُ':Added, #1: 1	صِيَغَ التَّصَارِيفِ
u'صِيَغٌ تَعْلِيقٌ':Added, #1: 1	صِيَغَ التَّصَارِيفِ
u'صِيَغٌ جمع':Added, #1: 1	صِيَغِ التَّعْلِيقِ
u'صِيَغٌ جَمْعٌ':Added, #1: 1	صِيَغِ الْجَمْعِ
u'صِيَغٌ جُمُوعٌ':Added, #1: 1	صِيَغِ الْجَمْعِ
u'صِيَغٌ طَلاَقٌ':Added, #1: 1	صِيَغَ الْجُمُوعِ
u'صِيَغٌ عَقْدٌ':Added, #1: 1	صِيَغِ الطَّلَاقِ
u'صِيَغٌ عُقُودٌ':Added, #1: 1	صِيَغِ الْعَقْدِ
u'صِيَغٌ عُقُودٌ':Added, #2: 2	صِيَغُ الْعُقُودِ
u'صِيَغٌ عُمُومٌ':Added, #4: 4	صِيَغِ الْعُقُودِ
u'صِيَغٌ عُمُومٌ':Added, #1: 1	صِيَغَ الْعُمُومِ
u'صِيَغٌ عُمُومٌ':Added, #3: 3	صِيَغُ الْعُمُومِ
u'صِيَغٌ فَاعِلٌ':Added, #42: 42	صِيَغِ الْعُمُومِ
u'صِيَغٌ فِعْلٌ':Added, #1: 1	صِيَغُ الْفَاعِلِ
u'صِيَغٌ قَبُولٌ':Added, #1: 1	صِيَغُ الْفِعْلِ
u'صِيَغٌ قَرْضٌ':Added, #1: 1	صِيَغِ الْقَبُولِ
u'صِيَغٌ مُبَاحٌ':Added, #1: 1	صِيَغِ الْقَرْضِ
u'صِيَغٌ مُبَالَغَةٌ':Added, #1: 1	صِيَغِ الْمُبَاحِ
u'صِيَغٌ مَفَاهِيمُ':Added, #1: 1	صِيَغِ الْمُبَالَغَةِ
u'صِيَغٌ نذر':Added, #1: 1	صِيَغِ مَفَاهِيمِ
u'صِيَغٌ نَذْرٌ':Added, #3: 3	صِيَغِ النَّذْرِ
u'ضَاءَ صُبْحٌ':Subject, #3: 3	صِيَغِ النَّذْرِ
u'ضَاءَ ضَوْءٌ':Subject, #1: 1	أَضَاءَ الصُّبْحُ
u'ضَاءَ فَجْرٌ':Subject, #1: 1	أَضَاءَ الضَّوْءُ
u'ضَادَّ حَيَاةٌ':Predicate, #4: 4	أَضَاءَ الْفَجْرُ
u'ضَارَبَ أَجِيرٌ':Subject, #1: 1	ضَادَّ الْحَيَاةَ
u'ضَارَبَ بَائِعٌ':Predicate, #1: 1	ضَارَبَ الْأَجِيرُ
u'ضَارَبَ مُسْتَحِقٌّ':Subject, #1: 1	ضَارَبَ الْبَائِعَ
u'ضَارَبَ مُضَارِبٌ':Subject, #1: 1	ضَارَبَ مُسْتَحِقُّ
u'ضَارَّ ضَارٌّ':Predicate, #1: 1	ضَارَبَ الْمُضَارِبُ
u'ضَاعَ أَبٌ':Subject, #2: 2	ضَارَّ ضَارَّ
u'ضَاعَ أحَدٌ':Subject, #2: 2	ضَاعَ الْأَبُ
u'ضَاعَ أصل':Subject, #4: 4	ضَاعَ أَحَدُ
u'ضَاعَ أًصْلٌ':Subject, #1: 1	ضَاعَ الْأَصْلُ
u'ضَاعَ إقْرَارٌ':Subject, #1: 1	ضَاعَ الْأَصْلُ
u'ضَاعَ ألف':Subject, #1: 1	ضَاعَ إقْرَارُ
u'ضَاعَ ألْفٌ':Subject, #3: 3	ضَاعَ الْأَلْفُ
u'ضَاعَ أَلْفٌ':Subject, #3: 3	ضَاعَ الْأَلْفُ
u'ضَاعَ بَذْرٌ':Subject, #3: 3	ضَاعَ الْأَلْفُ
u'ضَاعَ بَعْضٌ':Subject, #2: 2	ضَاعَ الْبَذْرُ
u'ضَاعَ بَعْضٌ':Subject, #1: 1	ضَاعَ بَعْضُهُ
u'ضَاعَ بَعْضٌ':Subject, #2: 2	ضَاعَ الْبَعْضُ
u'ضَاعَ بَيْنٌ':Predicate, #2: 2	ضَاعَ بَعْضُ
u'ضَاعَ ثَمَنٌ':Subject, #1: 1	ضَاعَ بَيْنَ
u'ضَاعَ ثَمَنٌ':Subject, #1: 1	ضَاعَ ثَمَنُهُ
u'ضَاعَ ثَوْبٌ':Subject, #5: 5	ضَاعَ الثَّمَنُ
u'ضَاعَ ثَوْرٌ':Subject, #2: 2	ضَاعَ الثَّوْبُ
u'ضَاعَ جَحْش':Subject, #1: 1	ضَاعَ الثَّوْرُ
u'ضَاعَ جَمِيع':Subject, #1: 1	ضَاعَ الْجَحْشُ
u'ضَاعَ جَنِينٌ':Subject, #1: 1	ضَاعَ الْجَمِيعُ
u'ضَاعَ حالٌ':Predicate, #3: 3	ضَاعَ الْجَنِينُ
u'ضَاعَ حَزْمٌ':Subject, #1: 1	ضَاعَ حَالَ
u'ضَاعَ حَقٌّ':Subject, #1: 1	ضَاعَ الْحَزْمُ
u'ضَاعَ حَقٌّ':Subject, #1: 1	ضَاعَ الْحَقُّ
u'ضَاعَ دِرْهَمٌ':Subject, #2: 2	ضَاعَ حَقُّ
u'ضَاعَ دِرْهَم':Subject, #1: 1	ضَاعَ الدِّرْهَمُ
u'ضَاعَ رَأْسٌ':Subject, #1: 1	ضَاعَ الدِّرْهَمُ
u'ضَاعَ رَهْنٌ':Subject, #1: 1	ضَاعَ رَأْسُ
u'ضَاعَ زَرْعٌ':Subject, #8: 8	ضَاعَ الرَّهْنُ
u'ضَاعَ سِجِلٌّ':Subject, #1: 1	ضَاعَ الزَّرْعُ
u'ضَاعَ سَرْجٌ':Subject, #2: 2	ضَاعَ سِجِلٌّ
u'ضَاعَ سقط':Predicate, #1: 1	ضَاعَ السَّرْجُ
u'ضَاعَ سَقَطٌ':Predicate, #2: 2	ضَاعَ سَقَطَ
u'ضَاعَ شَيْءٌ':Subject, #2: 2	ضَاعَ سَقَطَ
u'ضَاعَ شَيْءٌ':Subject, #1: 1	ضَاعَ الشَّيْءُ
u'ضَاعَ صَبِيٌّ':Subject, #2: 2	ضَاعَ شَيْءٌ
u'ضَاعَ صَكٌّ':Subject, #4: 4	ضَاعَ الصَّبِيُّ
u'ضَاعَ صَلاَةٌ':Predicate, #1: 1	ضَاعَ صَكُّهُ
u'ضَاعَ ضَرْبٌ':Subject, #1: 1	أَضَاعَ الصَّلَاةَ
u'ضَاعَ ضَمِنٌ':Predicate, #1: 1	ضَاعَ الضّرْبُ
u'ضَاعَ عِشْرُون':Predicate, #2: 2	ضَاعَ ضَمِنَ
u'ضَاعَ عند':Predicate, #1: 1	ضَاعَ عِشْرُونَ
u'ضَاعَ عِيَالٌ':Subject, #2: 2	ضَاعَ عِنْدَ
u'ضَاعَ غُلاَمٌ':Subject, #1: 1	ضَاعَ الْعِيَالُ
u'ضَاعَفَ ثَوابٌ':Predicate, #1: 1	ضَاعَ غُلَامٌ
u'ضَاعَ فَرَسٌ':Subject, #1: 1	ضَاعَفَ الثَّوَابَ
u'ضَاعَ فِعْلٌ':Subject, #1: 1	ضَاعَ فَرَسُهُ
u'ضَاعَفَ عُمَرٌ':Subject, #1: 1	ضَاعَ فِعْلُهُ
u'ضَاعَ قَالٌ':Predicate, #1: 1	ضَاعَفَ عُمَرُ
u'ضَاعَ قَدْرٌ':Subject, #2: 2	ضَاعَ قَالَ
u'ضَاعَ قَمْحٌ':Subject, #1: 1	ضَاعَ قَدْرُ
u'ضَاعَ كِتَابٌ':Subject, #1: 1	ضَاعَ الْقَمْحُ
u'ضَاعَ مَالٌ':Subject, #2: 2	ضَاعَ كِتَابُ
u'ضَاعَ مَالٌ':Subject, #18: 18	ضَاعَ الْمَالُ
u'ضَاعَ مَالٌ':Subject, #1: 1	ضَاعَ مَالٌ
u'ضَاعَ مَالٌ':Subject, #1: 1	ضَاعَ مَالُهُ
u'ضَاعَ مَحْضَرٌ':Subject, #5: 5	ضَاعَ مَالُ
u'ضَاعَ مَحْضَرٌ':Subject, #1: 1	ضَاعَ مَحْضَرٌ
u'ضَاعَ مَرْبَأٌ':Subject, #1: 1	ضَاعَ مَحْضَرُ
u'ضَاعَ مَغْصُوب':Subject, #1: 1	أَضَاعَ الْمَرْبَأَةُ
u'ضَاعَ مَقْبُوضٌ':Subject, #2: 2	ضَاعَ الْمَغْصُوبُ
u'ضَاعَ مُقَدَّمٌ':Subject, #1: 1	ضَاعَ الْمَقْبُوضُ
u'ضَاعَ نَسَبٌ':Subject, #1: 1	ضَاعَ الْمُقَدَّمُ
u'ضَاعَ نِصْفٌ':Subject, #5: 5	ضَاعَ نَسَبُهُ
u'ضَاعَ نِصْفٌ':Subject, #2: 2	ضَاعَ نِصْفُ
u'ضَاعَ وَهَلٌ':Predicate, #3: 3	ضَاعَ النِّصْفُ
u'ضَاعَ يَتِيمٌ':Subject, #1: 1	ضَاعَ وَهَلَكَ
u'ضَاعَ يَوْمٌ':Subject, #1: 1	ضَاعَ الْيَتِيمُ
u'ضَافَ اِبْنٌ':Subject, #1: 1	ضَاعَ يَوْمُهُ
u'ضَافَ إجَارَةٌ':Predicate, #1: 1	أَضَافَ ابْنُ
u'ضَافَ أَجْزَاءٌ':Predicate, #3: 3	أَضَافَ الْإِجَارَةَ
u'ضَافَ أَجَلٌ':Predicate, #3: 3	أَضَافَ الْأَجْزَاءَ
u'ضَافَ إِعْتاقٌ':Predicate, #1: 1	أَضَافَ الْأَجَلَ
u'ضَافَ إقْرَارٌ':Predicate, #2: 2	أَضَافَ الْإِعْتَاقَ
u'ضَافَ أكل':Predicate, #5: 5	أَضَافَ الْإِقْرَارَ
u'ضَافَ أَكْلٌ':Predicate, #1: 1	أَضَافَ الْأَكْلَ
u'ضَافَ ألف':Predicate, #1: 1	أَضَافَ الْأَكْلَ
u'ضَافَ ألْفٌ':Predicate, #2: 2	أَضَافَ الْأَلْفَ
u'ضَافَ أَلْفٌ':Predicate, #2: 2	أَضَافَ الْأَلْفَ
u'ضَافَ إِيجَابٌ':Predicate, #2: 2	أَضَافَ الْأَلْفَ
u'ضَافَ بَدَلٌ':Predicate, #1: 1	أَضَافَ الْإِيجَابَ
u'ضَافَ بَراءةٌ':Predicate, #3: 3	أَضَافَ الْبَدَلَ
u'ضَافَ بَيْعٌ':Predicate, #3: 3	أَضَافَ الْبَرَاءَةَ
u'ضَافَ بُيُوتٌ':Predicate, #2: 2	أَضَافَ الْبَيْعَ
u'ضَافَ تَأْثِيرٌ':Predicate, #1: 1	أَضَافَ الْبُيُوتَ
u'ضَافَ تَحْرِيمٌ':Predicate, #1: 1	أَضَافَ التَّأْثِيرَ
u'ضَافَ تَخْيِيرٌ':Predicate, #2: 2	أَضَافَ التَّحْرِيمَ
u'ضَافَ تَدْبِيرٌ':Predicate, #1: 1	أَضَافَ التَّخْيِيرَ
u'ضَافَ تَزَوُّجٌ':Predicate, #2: 2	أَضَافَ التَّدْبِيرَ
u'ضَافَ تَسْمِيَة':Predicate, #1: 1	أَضَافَ التَّزَوُّجَ
u'ضَافَ تَصَرُّفٌ':Predicate, #1: 1	أَضَافَ التَّسْمِيَةَ
u'ضَافَ ثَلاثَةٌ':Predicate, #2: 2	أَضَافَ التَّصَرُّفَ
u'ضَافَ جَارِي':Predicate, #1: 1	أَضَافَ الثَّلَاثَةَ
u'ضَافَ جَارِيَةٌ':Predicate, #1: 1	أَضَافَ الْجَارِيَةَ
u'ضَافَ جُزْءٌ':Predicate, #1: 1	أَضَافَ الْجَارِيَةَ
u'ضَافَ جَزَاءٌ':Predicate, #3: 3	أَضَافَ الْجُزْءَ
u'ضَافَ جمع':Predicate, #1: 1	أَضَافَ الْجَزَاءَ
u'ضَافَ جَمْعٌ':Predicate, #1: 1	أَضَافَ الْجَمْعَ
u'ضَافَ حائِطٌ':Predicate, #1: 1	أَضَافَ الْجَمْعَ
u'ضَافَ حَجٌّ':Predicate, #1: 1	أَضَافَ الْحَائِطَ
u'ضَافَ حُرْمَةٌ':Predicate, #1: 1	أَضَافَ الْحَجَّ
u'ضَافَ حُرِّيَّةٌ':Predicate, #1: 1	أَضَافَ الْحُرْمَةَ
u'ضَافَ حُكْمٌ':Predicate, #2: 2	أَضَافَ الْحُرِّيَّةَ
u'ضَافَ خُرُوجٌ':Predicate, #3: 3	أَضَافَ الْحُكْمَ
u'ضَافَ رَجُلٌ':Predicate, #1: 1	أَضَافَ الْخُرُوجَ
u'ضَافَ رِزْقٌ':Predicate, #1: 1	أَضَافَ رَجُلاً
u'ضَافَ رَسُولٌ':Predicate, #1: 1	أَضَافَ الرِّزْقَ
u'ضَافَ رَسُولٌ':Subject, #1: 1	ضَافَ رَسُولَ
u'ضَافَ ركعة':Predicate, #1: 1	أَضَافَ الرَّسُولُ
u'ضَافَ رَكْعَةٌ':Predicate, #1: 1	أَضَافَ رَكْعَةَ
u'ضَافَ زَوْجٌ':Subject, #1: 1	أَضَافَ رَكْعَةَ
u'ضَافَ زِيادَةٌ':Predicate, #2: 2	أَضَافَ الزَّوْجُ
u'ضَافَ سَيِّئٌ':Predicate, #2: 2	أَضَافَ الزِّيَادَةَ
u'ضَافَ شَاةٌ':Predicate, #1: 1	أَضَافَ السَّيِّئَةَ
u'ضَافَ شِرَاءٌ':Predicate, #1: 1	أَضَافَ الشَّاةَ
u'ضَافَ صدقة':Predicate, #5: 5	أَضَافَ الشِّرَاءَ
u'ضَافَ صَدَقَةٌ':Predicate, #1: 1	أَضَافَ الصَّدَقَةَ
u'ضَافَ صلح':Predicate, #1: 1	أَضَافَ الصَّدَقَةَ
u'ضَافَ صُلْحٌ':Predicate, #3: 3	أَضَافَ الصُّلْحَ
u'ضَافَ صَوْمٌ':Predicate, #3: 3	أَضَافَ الصُّلْحَ
u'ضَافَ صَيْدٌ':Predicate, #1: 1	أَضَافَ الصَّوْمَ
u'ضَافَ صِيغَةٌ':Predicate, #1: 1	أَضَافَ الصَّيْدَ
u'ضَافَ ضَمَانٌ':Predicate, #1: 1	أَضَافَ صِيغَةَ
u'ضَافَ ضَيْفٌ':Subject, #1: 1	أَضَافَ الضَّمَانَ
u'ضَافَ طَلاَقٌ':Predicate, #1: 1	ضَافَ ضَيْفٌ
u'ضَافَ طَلاَقٌ':Predicate, #2: 2	أَضَافَ طَلَاقَ
u'ضَافَ ظَرْفٌ':Predicate, #41: 41	أَضَافَ الطَّلَاقَ
u'ضَافَ ظهار':Predicate, #1: 1	أَضَافَ الظَّرْفَ
u'ضَافَ عَائِشٌ':Predicate, #2: 2	أَضَافَ الظِّهَارَ
u'ضَافَ عَائِشٌ':Predicate, #1: 1	أَضَافَ عَائِشَةَ
u'ضَافَ عتق':Predicate, #1: 1	ضَافَ عَائِشَةَ
u'ضَافَ عِتْقٌ':Predicate, #14: 14	أَضَافَ الْعِتْقَ
u'ضَافَ عَقْدٌ':Predicate, #14: 14	أَضَافَ الْعِتْقَ
u'ضَافَ عمرة':Predicate, #25: 25	أَضَافَ الْعَقْدَ
u'ضَافَ عُمْرَةٌ':Predicate, #1: 1	أَضَافَ الْعُمْرَةَ
u'ضَافَ غَنِيمَةٌ':Predicate, #1: 1	أَضَافَ الْعُمْرَةَ
u'ضَافَ فَسْخٌ':Predicate, #1: 1	أَضَافَ الْغَنِيمَةَ
u'ضَافَ فُضُولِيٌّ':Subject, #1: 1	أَضَافَ الْفَسْخَ
u'ضَافَ فِعْلٌ':Predicate, #1: 1	أَضَافَ الْفُضُولِيُّ
u'ضَافَ فِعْلٌ':Predicate, #1: 1	أَضَافَ فِعْلَ
u'ضَافَ قَبْضٌ':Predicate, #4: 4	أَضَافَ الْفِعْلَ
u'ضَافَ قَبْضٌ':Predicate, #1: 1	أَضَافَ قَبْضَ
u'ضَافَ قَرْضٌ':Predicate, #4: 4	أَضَافَ الْقَبْضَ
u'ضَافَ قَوْمٌ':Subject, #2: 2	أَضَافَ الْقَرْضَ
u'ضَافَ كَفَالَةٌ':Predicate, #1: 1	أَضَافَ قَوْمٌ
u'ضَافَ كَفِيلٌ':Subject, #2: 2	أَضَافَ الْكَفَالَةَ
u'ضَافَ كَلِمَةٌ':Predicate, #2: 2	أَضَافَ الْكَفِيلُ
u'ضَافَ لعان':Predicate, #2: 2	أَضَافَ كَلِمَةَ
u'ضَافَ لَفْظٌ':Predicate, #1: 1	أَضَافَ اللِّعَانَ
u'ضَافَ لَفْظَةٌ':Predicate, #1: 1	أَضَافَ لَفْظَ
u'ضَافَ مَالٌ':Predicate, #1: 1	أَضَافَ لَفْظَةَ
u'ضَافَ مَالٌ':Predicate, #1: 1	أَضَافَ مَالَ
u'ضَافَ مَبِيعٌ':Predicate, #5: 5	أَضَافَ الْمَالَ
u'ضَافَ مُتْعَةٌ':Predicate, #1: 1	أَضَافَ الْمَبِيعَ
u'ضَافَ مِثْقَالٌ':Predicate, #1: 1	أَضَافَ الْمُتْعَةَ
u'ضَافَ مَسَاجِدُ':Predicate, #3: 3	أَضَافَ الْمِثْقَالَ
u'ضَافَ مَشِيئَةٌ':Predicate, #1: 1	أَضَافَ الْمَسَاجِدَ
u'ضَافَ مَصْدَرٌ':Predicate, #3: 3	أَضَافَ الْمَشِيئَةَ
u'ضَافَ مُضَارَبَةٌ':Predicate, #1: 1	أَضَافَ الْمَصْدَرَ
u'ضَافَ مِقْدَارٌ':Predicate, #1: 1	أَضَافَ الْمُضَارَبَةَ
u'ضَافَ مَقْصُودٌ':Predicate, #1: 1	أَضَافَ الْمِقْدَارَ
u'ضَافَ مِلْكٌ':Predicate, #1: 1	أَضَافَ الْمَقْصُودَ
u'ضَافَ مَنْعٌ':Predicate, #1: 1	أَضَافَ الْمِلْكَ
u'ضَافَ مَنْفَعَةٌ':Predicate, #1: 1	أَضَافَ الْمَنْعَ
u'ضَافَ مِيرَاثٌ':Predicate, #1: 1	أَضَافَ مَنْفَعَةَ
u'ضَافَ نذر':Predicate, #2: 2	أَضَافَ الْمِيرَاثَ
u'ضَافَ نَذْرٌ':Predicate, #7: 7	أَضَافَ النَّذْرَ
u'ضَافَ نِصْفٌ':Predicate, #7: 7	أَضَافَ النَّذْرَ
u'ضَافَ نَفْخ':Predicate, #1: 1	أَضَافَ النِّصْفَ
u'ضَافَ نَفْيٌ':Predicate, #1: 1	أَضَافَ النّفْخَ
u'ضَافَ نكاح':Predicate, #1: 1	أَضَافَ نَفْيَ
u'ضَافَ نِكَاحٌ':Predicate, #9: 9	أَضَافَ النِّكَاحَ
u'ضَافَ هِبَةٌ':Predicate, #9: 9	أَضَافَ النِّكَاحَ
u'ضَافَ وَاهِبٌ':Subject, #5: 5	أَضَافَ الْهِبَةَ
u'ضَافَ وُجُوبٌ':Predicate, #1: 1	أَضَافَ الْوَاهِبُ
u'ضَافَ وَصِيٌّ':Predicate, #1: 1	أَضَافَ الْوُجُوبَ
u'ضَافَ وَصِيَّةٌ':Predicate, #4: 4	أَضَافَ الْوَصِيَّةَ
u'ضَافَ وَقْفٌ':Predicate, #4: 4	أَضَافَ الْوَصِيَّةَ
u'ضَافَ وَكِيلٌ':Subject, #1: 1	أَضَافَ الْوَقْفَ
u'ضَافَ يَمِينٌ':Predicate, #6: 6	أَضَافَ الْوَكِيلُ
u'ضَاقَ أَمْرٌ':Subject, #5: 5	أَضَافَ الْيَمِينَ
u'ضَاقَ بَيْتٌ':Subject, #6: 6	ضَاقَ الْأَمْرُ
u'ضَاقَ بَيْتٌ':Subject, #1: 1	ضَاقَ الْبَيْتُ
u'ضَاقَ خَارِجٌ':Predicate, #1: 1	ضَاقَ بَيْتُ
u'ضَاقَ رِزْقٌ':Subject, #1: 1	ضَاقَ خَارِجَ
u'ضَاقَ ريعٌ':Subject, #1: 1	ضَاقَ رِزْقُهُ
u'ضَاقَ زَمانٌ':Subject, #3: 3	ضَاقَ رِيعُ
u'ضَاقَ زَمَنٌ':Subject, #1: 1	ضَاقَ زَمَانُ
u'ضَاقَ صَدْرٌ':Subject, #2: 2	ضَاقَ زَمَنُ
u'ضَاقَ صَفٌّ':Subject, #2: 2	ضَاقَ صَدْرُ
u'ضَاقَ طَرِيقٌ':Subject, #1: 1	ضَاقَ صَفُّ
u'ضَاقَ فَرْضٌ':Subject, #2: 2	ضَاقَ الطَّرِيقُ
u'ضَاقَ فَضَاءٌ':Subject, #1: 1	ضَاقَ فَرْضُ
u'ضَاقَ فَضْلٌ':Subject, #1: 1	ضَاقَ الْفَضَاءُ
u'ضَاقَ قِرْطَاسٌ':Subject, #1: 1	ضَاقَ فَضْلُ
u'ضَاقَ قلب':Subject, #1: 1	ضَاقَ الْقِرْطَاسُ
u'ضَاقَ قَلْبٌ':Subject, #1: 1	ضَاقَ قَلْبُهُ
u'ضَاقَ قَلْب':Subject, #1: 1	ضَاقَ قَلْبُهُ
u'ضَاقَ لبس':Predicate, #1: 1	ضَاقَ قَلْبُهُ
u'ضَاقَ مَاءٌ':Subject, #1: 1	ضَاقَ لَبِسَ
u'ضَاقَ مَالٌ':Subject, #1: 1	ضَاقَ الْمَاءُ
u'ضَاقَ مَالٌ':Subject, #1: 1	ضَاقَ مَالُ
u'ضَاقَ مَحَلٌّ':Subject, #4: 4	ضَاقَ مَالُهُ
u'ضَاقَ مَذْهَبٌ':Subject, #1: 1	ضَاقَ الْمَحَلُّ
u'ضَاقَ مَسْجِدٌ':Subject, #1: 1	ضَاقَ مَذْهَبُهُ
u'ضَاقَ مَسْكَنٌ':Subject, #13: 13	ضَاقَ الْمَسْجِدُ
u'ضَاقَ مَكَانٌ':Subject, #1: 1	ضَاقَ مَسْكَنٌ
u'ضَاقَ مَوْضِعٌ':Subject, #1: 1	ضَاقَ الْمَكَانُ
u'ضَاقَ نُطْقٌ':Subject, #1: 1	ضَاقَ الْمَوْضِعُ
u'ضَاقَ وَقْتٌ':Subject, #1: 1	ضَاقَ النُّطْقُ
u'ضَاقَ وَقْتٌ':Subject, #19: 19	ضَاقَ وَقْتُ
u'ضَاقَ وَقْتٌ':Subject, #3: 3	ضَاقَ وَقْتُهُ
u'ضَايَقَ اِبْنٌ':Subject, #80: 80	ضَاقَ الْوَقْتُ
u'ضَبَطَ اِبْنٌ':Subject, #1: 1	ضَايَقَ ابْنُ
u'ضَبْطٌ أَجْزَاءٌ':Added, #1: 1	ضَبَطَ ابْنُ
u'ضَبْطٌ إِجْمَاعٌ':Added, #1: 1	ضَبْطِ أَجْزَاءِ
u'ضَبْطٌ أَسْماءٌ':Added, #1: 1	ضَبْطُ إجْمَاعٍ
u'ضَبْطٌ أصل':Added, #1: 1	ضَبْطِ الْأَسْمَاءِ
u'ضَبْطٌ أًصْلٌ':Added, #1: 1	ضَبْطِ الْأَصْلِ
u'ضَبْطٌ أَقْسَامٌ':Added, #1: 1	ضَبْطِ الْأَصْلِ
u'ضَبْطٌ أَقْوَالٌ':Added, #1: 1	ضَبْطِ أَقْسَامِ
u'ضَبَطَ إمَامٌ':Subject, #1: 1	ضَبْطُ أَقْوَالِ
u'ضَبْطٌ أَمْرٌ':Added, #1: 1	ضَبَطَ الْإِمَامُ
u'ضَبْطٌ أَمْرٌ':Added, #1: 1	ضَبْطَ الْأَمْرِ
u'ضَبْطٌ اِنْتِفاء':Added, #2: 2	ضَبْطُ الْأَمْرِ
u'ضَبْطٌ أُنْمُوذَجٌ':Added, #1: 1	ضَبْطِ انْتِفَاءِ
u'ضَبَطَ أهْلٌ':Subject, #2: 2	ضَبْطُ الْأُنْمُوذَجِ
u'ضَبْطٌ أَوَّلُ':Added, #1: 1	ضَبَطَ أَهْلُ
u'ضَبْطٌ بَاطن':Added, #1: 1	ضَبْطِ الْأَوَّلِ
u'ضَبْطٌ باطِنٌ':Added, #1: 1	ضَبْطُ بَاطِنِ
u'ضَبْطٌ بَاطن':Added, #1: 1	ضَبْطُ بَاطِنِ
u'ضَبْطٌ باطِنٌ':Added, #1: 1	ضَبْطُ بَاطِنِهِ
u'ضَبَطَ بَعْضٌ':Subject, #1: 1	ضَبْطُ بَاطِنِهِ
u'ضَبْطٌ بَعْضٌ':Added, #1: 1	ضَبَطَ بَعْضُ
u'ضَبْطٌ تَأَخُّرٌ':Added, #1: 1	ضَبْطِ بَعْضِ
u'ضَبْطٌ تَارِيخٌ':Added, #1: 1	ضَبْطِ تَأَخُّرِهِ
u'ضَبْطٌ جُيوشٌ':Added, #2: 2	ضَبْطُ التَّارِيخِ
u'ضَبْطٌ حَديثٌ':Added, #1: 1	ضَبْطُ الْجُيُوشِ
u'ضَبْطٌ حُروفٌ':Added, #2: 2	ضَبْطِ الْحَدِيثِ
u'ضَبْطٌ حَفْرٌ':Added, #1: 1	ضَبْطَ الْحُرُوفِ
u'ضَبَطَ حَمَّالٌ':Predicate, #1: 1	ضَبْطِ الْحَفْرِ
u'ضَبْطٌ حَواسٌّ':Added, #1: 1	ضَبَطَ الْحَمَّالَ
u'ضَبْطٌ حَوَاسُّ':Added, #1: 1	ضَبْطُ الْحَوَاسِّ
u'ضَبْطٌ دَابَّةٌ':Added, #1: 1	ضَبْطُ الْحَوَاسِّ
u'ضَبْطٌ ديباجٌ':Added, #1: 1	ضَبْطَ الدَّابَّةِ
u'ضَبْطٌ سَامِعٌ':Added, #1: 1	ضَبْطِ الدِّيبَاجِ
u'ضَبْطٌ سَبَبٌ':Added, #1: 1	ضَبْطِ السَّامِعِ
u'ضَبْطٌ شَرٌّ':Added, #1: 1	ضَبْطِ سَبَبِ
u'ضَبْطٌ شُهُودٌ':Added, #1: 1	ضَبْطَ الشَّرِّ
u'ضَبَطَ شَيْخٌ':Subject, #2: 2	ضَبْطِ الشُّهُودِ
u'ضَبْطٌ صَغِيرٌ':Added, #1: 1	ضَبَطَ الشَّيْخُ
u'ضَبْطٌ صِفَةٌ':Added, #2: 2	ضَبْطِ الصَّغِيرَةِ
u'ضَبْطٌ صِفَةٌ':Added, #2: 2	ضَبْطُ صِفَاتِهِ
u'ضَبْطٌ صِفَةٌ':Added, #3: 3	ضَبْطِ الصِّفَةِ
u'ضَبَطَ صَوْمٌ':Predicate, #6: 6	ضَبْطُ صِفَتِهِ
u'ضَبْطٌ ظاهِرٌ':Added, #1: 1	ضَبَطَ الصَّوْمَ
u'ضَبْطٌ عَامٌّ':Added, #1: 1	ضَبْطُ ظَاهِرِهِ
u'ضَبْطٌ عَدَدٌ':Added, #1: 1	ضَبْطِ الْعَامَّةِ
u'ضَبْطٌ عَدَدٌ':Added, #1: 1	ضَبْطُ الْعَدَدِ
u'ضَبْطٌ عَصَافِيرُ':Added, #1: 1	ضَبْطِ الْعَدَدِ
u'ضَبَطَ علم':Subject, #1: 1	ضَبْطَ الْعَصَافِيرِ
u'ضَبَطَ عِلْمٌ':Subject, #1: 1	ضَبَطَ عِلْمُهُ
u'ضَبَطَ عَمَلٌ':Predicate, #1: 1	ضَبَطَ عِلْمُهُ
u'ضَبْطٌ غَنِيٌّ':Added, #2: 2	ضَبَطَ الْعَمَلَ
u'ضَبْطٌ فَرْجٌ':Added, #1: 1	ضَبْطُ الْغَنِيِّ
u'ضَبَطَ فَقِيهٌ':Subject, #2: 2	ضَبْطُ الْفَرْجِ
u'ضَبْطٌ فلان':Added, #1: 1	ضَبَطَ الْفَقِيهُ
u'ضَبَطَ قَدْرٌ':Predicate, #1: 1	ضَبْطُ الْمَرْوِيِّ
u'ضَبْطٌ قُرْبٌ':Added, #2: 2	ضَبَطَ الْقَدْرَ
u'ضَبْطٌ قَوَانِينُ':Added, #1: 1	ضَبْطِ الْقُرْبِ
u'ضَبْطٌ قَوَانِينُ':Added, #1: 1	ضَبْطُ قَوَانِينِ
u'ضَبْطٌ كَبِيرٌ':Added, #1: 1	ضَبْطِ قَوَانِينِ
u'ضَبْطٌ كَبِيرٌ':Added, #1: 1	ضَبْطَ الْكَبِيرَةِ
u'ضَبْطٌ كَلاَمٌ':Added, #1: 1	ضَبْطُ الْكَبِيرَةِ
u'ضَبْطٌ كَلاَمٌ':Added, #1: 1	ضَبْطُ الْكَلَامِ
u'ضَبْطٌ كَلاَمٌ':Added, #1: 1	ضَبْطِ كَلَامِ
u'ضَبْطٌ كَمِّيٌّ':Added, #2: 2	ضَبْطِ الْكَلَامِ
u'ضَبْطٌ لِسَانٌ':Added, #1: 1	ضَبْطِ كَمِّيَّتِهِ
u'ضَبْطٌ لَفْظٌ':Added, #1: 1	ضَبْطَ اللِّسَانِ
u'ضَبْطٌ مَالٌ':Added, #1: 1	ضَبْطُ اللَّفْظِ
u'ضَبْطٌ مَتْنٌ':Added, #1: 1	ضَبْطِ الْمَالِ
u'ضَبْطٌ مِثْلِيٌّ':Added, #1: 1	ضَبْطُ الْمَتْنِ
u'ضَبْطٌ مَحَلٌّ':Added, #1: 1	ضَبْطِ الْمِثْلِيِّ
u'ضَبْطٌ مُخْتَصَرٌ':Added, #1: 1	ضَبْطِ مَحَلِّ
u'ضَبْطٌ مَرْتَبَةٌ':Added, #1: 1	ضَبْطُ الْمُخْتَصَرِ
u'ضَبْطٌ مَرْوِيّ':Added, #2: 2	ضَبْطِ مَرْتَبَةٍ
u'ضَبَطَ مَسَافَةٌ':Predicate, #1: 1	ضَبْطُ الْمَرْوِيِّ
u'ضَبْطٌ مُسَاوَاةٌ':Added, #1: 1	ضَبَطَ الْمَسَافَةَ
u'ضَبْطٌ مَشَاقُّ':Added, #1: 1	ضَبْطُ الْمُسَاوَاةِ
u'ضَبْطٌ مَشَاقُّ':Added, #1: 1	ضَبْطِ الْمَشَاقِّ
u'ضَبْطٌ مَشَقَّةٌ':Added, #1: 1	ضَبْطِ مَشَاقِّ
u'ضَبْطٌ مَشَقَّةٌ':Added, #1: 1	ضَبْطُ الْمَشَقَّةِ
u'ضَبْطٌ مَصَالِحُ':Added, #1: 1	ضَبْطِ الْمَشَقَّةِ
u'ضَبْطٌ مُصَنِّفٌ':Added, #1: 1	ضَبْطُ الْمَصَالِحِ
u'ضَبْطٌ مَقَادِيرُ':Added, #1: 1	ضَبْطِ مُصَنِّفِهِ
u'ضَبْطٌ مُوالاة':Added, #1: 1	ضَبْطُ مَقَادِيرِ
u'ضَبْطٌ نَائِمٌ':Added, #1: 1	ضَبْطِ مُوَالَاةِ
u'ضَبْطٌ نَفْسٌ':Added, #2: 2	ضَبْطِ النَّائِمِ
u'ضَبْطٌ نَفْسٌ':Added, #1: 1	ضَبْطِ النَّفْسِ
u'ضَبْطٌ نَفْسٌ':Added, #2: 2	ضَبْطُ النَّفْسِ
u'ضَبْطٌ نَفْسٌ':Added, #2: 2	ضَبْطُ نَفْسِهِ
u'ضَبْطٌ نُقْصَانٌ':Added, #3: 3	ضَبْطِ نَفْسِهِ
u'ضَبْطٌ وَاسِعٌ':Added, #1: 1	ضَبْطَ نُقْصَانِهِ
u'ضَبْطٌ وَقْتٌ':Added, #1: 1	ضَبْطِ الْوَاسِعِ
u'ضَجِرَ رَجُلٌ':Subject, #1: 1	ضَبْطِ الْوَقْتِ
u'ضجعة أهْلٌ':Added, #1: 1	ضَجِرَ الرَّجُلُ
u'ضَجْعَةٌ أهْلٌ':Added, #1: 1	ضَجْعَةُ أَهْلِ
u'ضَجَعَ ذَبيحٌ':Predicate, #1: 1	ضَجْعَةُ أَهْلِ
u'ضَجَعَ ذَبيحَةٌ':Predicate, #1: 1	أَضْجَعَ الذَّبِيحَةَ
u'ضَجَعَ رَجُلٌ':Subject, #1: 1	أَضْجَعَ الذَّبِيحَةَ
u'ضَجَعَ شَاةٌ':Predicate, #1: 1	ضَجَعَ الرَّجُلُ
u'ضَحِكَ إمَامٌ':Subject, #1: 1	أَضْجَعَ الشَّاةَ
u'ضحك إمَامٌ':Added, #4: 4	ضَحِكَ الْإِمَامُ
u'ضحك إمَامٌ':Added, #2: 2	ضَحِكُ الْإِمَامِ
u'ضَحِكٌ إمَامٌ':Added, #2: 2	ضَحِكِ الْإِمَامِ
u'ضَحِكٌ إمَامٌ':Added, #2: 2	ضَحِكُ الْإِمَامِ
u'ضحك أنبياء':Added, #2: 2	ضَحِكِ الْإِمَامِ
u'ضَحِكٌ أنبياء':Added, #1: 1	ضَحِكِ الْأَنْبِيَاءِ
u'ضحك أهْلٌ':Added, #1: 1	ضَحِكِ الْأَنْبِيَاءِ
u'ضَحِكٌ أهْلٌ':Added, #1: 1	ضَحِكِ أَهْلِ
u'ضحك بَعْضٌ':Added, #1: 1	ضَحِكِ أَهْلِ
u'ضَحِكٌ بَعْضٌ':Added, #1: 1	ضَحِكُ بَعْضِ
u'ضحك خَدَّامٌ':Added, #1: 1	ضَحِكُ بَعْضِ
u'ضَحِكٌ خَدَّامٌ':Added, #1: 1	ضَحِكَ الْخَدَّامِ
u'ضحك رَبُّ':Added, #1: 1	ضَحِكَ الْخَدَّامِ
u'ضَحِكٌ رَبُّ':Added, #1: 1	ضَحِكِ رَبِّ
u'ضَحِكَ رَجُلٌ':Subject, #1: 1	ضَحِكِ رَبِّ
u'ضَحِكَ رَسُولٌ':Subject, #2: 2	ضَحِكَ الرَّجُلُ
u'ضحك سُرُورٌ':Added, #2: 2	ضَحِكَ رَسُولُ
u'ضَحِكٌ سُرُورٌ':Added, #1: 1	ضَحِكِ السُّرُورِ
u'ضَحِكَ شَيْطَانٌ':Subject, #1: 1	ضَحِكِ السُّرُورِ
u'ضَحِكَ عَالِمٌ':Subject, #3: 3	ضَحِكَ الشَّيْطَانُ
u'ضحك عَبْدٌ':Added, #1: 1	ضَحِكَ الْعَالِمُ
u'ضَحِكٌ عَبْدٌ':Added, #1: 1	ضَحِكَ عَبْدِ
u'ضَحِكَ فلان':Subject, #1: 1	ضَحِكَ عَبْدِ
u'ضَحِكَ قَهْقَه':Predicate, #1: 1	ضَحِكَ الْمِقْدَادُ
u'ضَحِكَ قَوْمٌ':Subject, #5: 5	ضَحِكَ قَهْقَهَةً
u'ضحك قَوْمٌ':Added, #2: 2	ضَحِكَ الْقَوْمُ
u'ضَحِكٌ قَوْمٌ':Added, #1: 1	ضَحِكَ الْقَوْمِ
u'ضَحِكَ مَشِيبٌ':Subject, #1: 1	ضَحِكَ الْقَوْمِ
u'ضَحْوَةٌ نهار':Added, #1: 1	ضَحِكَ الْمَشِيبُ
u'ضَحْوَةٌ نهار':Added, #1: 1	ضَحْوَةَ النَّهَارِ
u'ضَحْوَةٌ نَهَارٌ':Added, #1: 1	ضَحْوَةُ النَّهَارِ
u'ضَحْوَةٌ نَهَارٌ':Added, #1: 1	ضَحْوَةَ النَّهَارِ
u'ضَحَّى أَبٌ':Subject, #1: 1	ضَحْوَةُ النَّهَارِ
u'ضَحَّى إمَامٌ':Subject, #1: 1	ضَحَّى الْأَبُ
u'ضَحِيَ بواسط':Predicate, #1: 1	ضَحَّى الْإِمَامُ
u'ضَحَّى ثَمانِي':Predicate, #1: 1	أَضْحَى بِوَاسِطَ
u'ضَحَّى جَمَاعَةٌ':Subject, #1: 1	ضَحَّى ثَمَانِيَ
u'ضَحَّى جَمْعٌ':Subject, #1: 1	ضَحَّى جَمَاعَةٌ
u'ضَحَّى دونٌ':Predicate, #1: 1	ضَحَّى جَمْعٌ
u'ضَحَّى رَجُلٌ':Subject, #1: 1	ضَحَّى دُونَ
u'ضَحَّى رَجُلٌ':Subject, #1: 1	ضَحَّى الرَّجُلُ
u'ضَحَّى رَسُولٌ':Subject, #3: 3	ضَحَّى رَجُلٌ
u'ضَحَّى طَيِّبٌ':Subject, #10: 10	ضَحَّى رَسُولُ
u'ضَحَّى عَامٌ':Predicate, #1: 1	ضَحَّى طَيِّبَةٌ
u'ضَحَّى فَقِيرٌ':Subject, #4: 4	ضَحَّى الْعَامَ
u'ضَحَّى مرٌّ':Predicate, #1: 1	ضَحَّى الْفَقِيرُ
u'ضَحَّى مَوْهُوبٌ':Subject, #1: 1	ضَحَّى مَرَّةً
u'ضَحَّى نَاسٌ':Subject, #1: 1	ضَحَّى الْمَوْهُوبُ
u'ضَحَّى نَبِيٌّ':Subject, #2: 2	ضَحَّى النَّاسُ
u'ضَحَّى وَلِيٌّ':Subject, #2: 2	ضَحَّى النَّبِيُّ
u'ضَخَامَةٌ شَأْنٌ':Added, #2: 2	ضَحَّى الْوَلِيُّ
u'ضَرَاوَةٌ إِسْلامٌ':Added, #1: 1	ضَخَامَةُ شَأْنِ
u'ضَرَبَ أَبٌ':Subject, #1: 1	ضَرَاوَةُ الإِسْلامِ
u'ضَرْبٌ أَبٌ':Added, #1: 1	ضَرَبَ الْأَبُ
u'ضَرْبٌ أَبٌ':Added, #1: 1	ضَرْبَ الْأَبِ
u'ضَرْبٌ أَبٌ':Added, #1: 1	ضَرْبُ الْأَبِ
u'ضَرَبَ اِبْنٌ':Subject, #2: 2	ضَرْبِ الْأَبِ
u'ضَرْبٌ اِبْنٌ':Added, #1: 1	ضَرَبَ ابْنُ
u'ضَرْبٌ إِبْهَامٌ':Added, #1: 1	ضَرْبَ ابْنِ
u'ضَرْبٌ أَبْوَابٌ':Added, #1: 1	ضَرْبِ إبْهَامٍ
u'ضَرَبَ أَجَلٌ':Predicate, #1: 1	ضَرْبِ الْأَبْوَابِ
u'ضَرْبٌ أَجَلٌ':Added, #7: 7	ضَرَبَ الْأَجَلَ
u'ضَرْبٌ أَجَلٌ':Added, #2: 2	ضَرْبِ أَجَلٍ
u'ضَرْبٌ أَجَلٌ':Added, #5: 5	ضَرْبِ الْأَجَلِ
u'ضَرْبٌ أحَدٌ':Added, #9: 9	ضَرْبُ الْأَجَلِ
u'ضَرْبٌ أَحْرارٌ':Added, #1: 1	ضَرْبِ أَحَدِ
u'ضَرْبٌ أدَب':Added, #1: 1	ضَرْبَ الْأَحْرَارِ
u'ضَرْبٌ أدَب':Added, #1: 1	ضَرْبِ أَدَبٍ
u'ضَرْبٌ أَرْبَعَةٌ':Added, #1: 1	ضَرْبِ الْأَدَبِ
u'ضَرَبَ أرْضٌ':Predicate, #1: 1	ضَرْبِ أَرْبَعَةٍ
u'ضَرْبٌ أرْضٌ':Added, #1: 1	ضَرَبَ الْأَرْضَ
u'ضَرْبٌ اِسْتِحْقَاقٌ':Added, #1: 1	ضَرْبِ الْأَرْضِ
u'ضَرْبٌ اِسْتِصْلاَحٌ':Added, #1: 1	ضَرْبُ اسْتِحْقَاقٍ
u'ضَرْبٌ إِسْلامٌ':Added, #1: 1	ضَرْبُ اسْتِصْلَاحٍ
u'ضَرْبٌ إِسْلامٌ':Added, #2: 2	ضَرْبُ الْإِسْلَامِ
u'ضَرْبٌ أَسيرٌ':Added, #5: 5	ضَرْبِ الْإِسْلَامِ
u'ضَرْبٌ إِشْكالٌ':Added, #1: 1	ضَرْبِ الْأَسِيرِ
u'ضَرَبَ أُصْبُعٌ':Predicate, #2: 2	ضَرْبُ إشْكَالٍ
u'ضَرْبٌ أَعْنَاقٌ':Added, #1: 1	ضَرَبَ أُصْبُعَ
u'ضَرْبٌ أَفْخَاذٌ':Added, #1: 1	ضَرْبُ الْأَعْنَاقِ
u'ضَرْبٌ أَقْسَامٌ':Added, #1: 1	ضَرْبِ الْأَفْخَاذِ
u'ضَرْبٌ أَكَاسِرَةٌ':Added, #1: 1	ضَرْبِ الْأَقْسَامِ
u'ضَرْبٌ آلةٌ':Added, #1: 1	ضَرْبِ الْأَكَاسِرَةِ
u'ضَرْبٌ الْمَرْأَةُ':Added, #1: 1	ضَرْبِ آلَةِ
u'ضَرْبٌ الْمَرْأَةُ':Added, #1: 1	ضَرْبُ الْمَرْأَةِ
u'ضَرْبٌ أُمٌّ':Added, #1: 1	ضَرْبِ الْمَرْأَةِ
u'ضَرْبٌ إمَامٌ':Added, #1: 1	ضَرْبِ الْأُمِّ
u'ضَرْبٌ إمَامٌ':Added, #1: 1	ضَرْبَ الْإِمَامِ
u'ضَرْبٌ أمثال':Added, #1: 1	ضَرْبُ الْإِمَامِ
u'ضَرْبٌ أمثال':Added, #1: 1	ضَرْبُ الْأَمْثَالِ
u'ضَرْبٌ أَمْثَالٌ':Added, #1: 1	ضَرْبِ الْأَمْثَالِ
u'ضَرْبٌ أَمْثَالٌ':Added, #1: 1	ضَرْبُ الْأَمْثَالِ
u'ضَرْبٌ اِمْرَأَةٌ':Added, #1: 1	ضَرْبِ الْأَمْثَالِ
u'ضَرْبٌ أَميرٌ':Added, #1: 1	ضَرْبِ امْرَأَتِهِ
u'ضَرَبَ إِنْسانٌ':Subject, #1: 1	ضَرْبُ الْأَمِيرِ
u'ضَرْبٌ إِنْسانٌ':Added, #17: 17	ضَرَبَ إنْسَانٌ
u'ضَرَبَ أَنْفٌ':Predicate, #1: 1	ضَرْبَ إنْسَانٍ
u'ضَرْبٌ أهْلٌ':Added, #1: 1	ضَرَبَ أَنْفَ
u'ضَرْبٌ أَوْتَارٌ':Added, #9: 9	ضَرْبِ أَهْلِ
u'ضَرَبَ أَوَّلُ':Predicate, #1: 1	ضَرْبُ الْأَوْتَارِ
u'ضَرْبٌ أَوَّلُ':Added, #1: 1	ضَرَبَ الْأَوَّلَ
u'ضَرْبٌ أَوَّلُ':Added, #1: 1	ضَرْبَ الْأَوَّلِ
u'ضَرْبٌ أَوَّلُ':Added, #1: 1	ضَرْبِ الْأَوَّلِ
u'ضَرْبٌ أَوْلاَدٌ':Added, #2: 2	ضَرْبُ الْأَوَّلِ
u'ضَرَبَ أَوْلِيَاءُ':Subject, #1: 1	ضَرْبِ الْأَوْلَادِ
u'ضَرَبَ بَاطن':Predicate, #1: 1	ضَرَبَ أَوْلِيَاءُ
u'ضَرَبَ باطِنٌ':Predicate, #1: 1	ضَرَبَ بَاطِنَ
u'ضَرَبَ بسط':Predicate, #1: 1	ضَرَبَ بَاطِنَ
u'ضَرَبَ بَسْطٌ':Predicate, #1: 1	ضَرَبَ بَسْطَ
u'ضَرَبَ بَطْنٌ':Predicate, #1: 1	ضَرَبَ بَسْطَ
u'ضَرْبٌ بَطْنٌ':Added, #39: 39	ضَرَبَ بَطْنَ
u'ضَرْبٌ بَطْنٌ':Added, #1: 1	ضَرْبَ الْبَطْنِ
u'ضَرْبٌ بَطْنٌ':Added, #1: 1	ضَرْبَ بَطْنِ
u'ضَرَبَ بَعْضٌ':Predicate, #1: 1	ضَرْبُ بَطْنِ
u'ضَرَبَ بَعْضٌ':Predicate, #1: 1	ضَرَبَ الْبَعْضَ
u'ضَرْبٌ بَعْضٌ':Added, #1: 1	ضَرَبَ بَعْضَ
u'ضَرَبٌ بِيدٌ':Added, #1: 1	ضَرْبِ بَعْضِ
u'ضربة أرْضٌ':Added, #15: 15	ضَرَبَ بِيَدِهِ
u'ضَرْبَةٌ أرْضٌ':Added, #1: 1	ضَرْبَةِ الْأَرْضِ
u'ضربة حَجَرٌ':Added, #1: 1	ضَرْبَةِ الْأَرْضِ
u'ضَرْبَةٌ حَجَرٌ':Added, #1: 1	ضَرْبَةِ حَجَرٍ
u'ضربة رَجُلٌ':Added, #1: 1	ضَرْبَةِ حَجَرٍ
u'ضَرْبَةٌ رَجُلٌ':Added, #1: 1	ضَرْبَةَ رَجُلٍ
u'ضربة رُومِيٌّ':Added, #1: 1	ضَرْبَةَ رَجُلٍ
u'ضَرْبَةٌ رُومِيٌّ':Added, #1: 1	ضَرْبَةُ الرُّومِيِّ
u'ضربة سَوْطٌ':Added, #1: 1	ضَرْبَةُ الرُّومِيِّ
u'ضَرْبَةٌ سَوْطٌ':Added, #1: 1	ضَرْبَةِ السَّوْطِ
u'ضربة عنق':Added, #1: 1	ضَرْبَةِ السَّوْطِ
u'ضربة عُنُقٌ':Added, #1: 1	ضَرْبَةُ الْعُنُقِ
u'ضَرْبَةٌ عنق':Added, #1: 1	ضَرْبَةُ الْعُنُقِ
u'ضَرْبَةٌ عُنُقٌ':Added, #1: 1	ضَرْبَةُ الْعُنُقِ
u'ضربة عنق':Added, #1: 1	ضَرْبَةُ الْعُنُقِ
u'ضربة عُنُقٌ':Added, #4: 4	ضَرْبَةِ عُنُقٍ
u'ضَرْبَةٌ عنق':Added, #4: 4	ضَرْبَةِ عُنُقٍ
u'ضَرْبَةٌ عُنُقٌ':Added, #4: 4	ضَرْبَةِ عُنُقٍ
u'ضربة غَائِصٌ':Added, #4: 4	ضَرْبَةِ عُنُقٍ
u'ضَرْبَةٌ غَائِصٌ':Added, #3: 3	ضَرْبَةِ الْغَائِصِ
u'ضربة قانِص':Added, #3: 3	ضَرْبَةِ الْغَائِصِ
u'ضربة قانِص':Added, #1: 1	ضَرْبَةُ الْقَانِصِ
u'ضَرْبَةٌ قانِص':Added, #1: 1	ضَرْبَةِ الْقَانِصِ
u'ضَرْبَةٌ قانِص':Added, #1: 1	ضَرْبَةُ الْقَانِصِ
u'ضربة لاَزِبٌ':Added, #1: 1	ضَرْبَةِ الْقَانِصِ
u'ضَرْبَةٌ لاَزِبٌ':Added, #2: 2	ضَرْبَةُ لَازِبٍ
u'ضربة لاَزِمٌ':Added, #2: 2	ضَرْبَةُ لَازِبٍ
u'ضَرْبَةٌ لاَزِمٌ':Added, #1: 1	ضَرْبَةُ لَازِمٍ
u'ضربة واحد':Added, #1: 1	ضَرْبَةُ لَازِمٍ
u'ضربة وَاحِدٌ':Added, #5: 5	ضَرْبَةٍ وَاحِدَةٍ
u'ضَرْبَةٌ واحد':Added, #5: 5	ضَرْبَةٍ وَاحِدَةٍ
u'ضَرْبَةٌ وَاحِدٌ':Added, #5: 5	ضَرْبَةٍ وَاحِدَةٍ
u'ضَرْبٌ تَأْدِيبٌ':Added, #5: 5	ضَرْبَةٍ وَاحِدَةٍ
u'ضَرْبٌ تَجَوُّزٌ':Added, #1: 1	ضَرْبُ تَأْدِيبٍ
u'ضَرْبٌ تِسْعَةٌ':Added, #1: 1	ضَرْبُ تَجَوُّزٍ
u'ضَرْبٌ تَعَبُّدٌ':Added, #2: 2	ضَرْبِ التِّسْعَةِ
u'ضَرْبٌ تَعْزِير':Added, #1: 1	ضَرْبِ تَعَبُّدٍ
u'ضَرْبٌ تَعْزِير':Added, #1: 1	ضَرْبَ التَّعْزِيرِ
u'ضَرْبٌ تَعْزِير':Added, #1: 1	ضَرْبِ التَّعْزِيرِ
u'ضَرْبٌ تَعْلِيمٌ':Added, #3: 3	ضَرْبُ التَّعْزِيرِ
u'ضَرَبَ تِلْميذٌ':Predicate, #1: 1	ضَرْبِ التَّعْلِيمِ
u'ضَرَبَ ثَالِثٌ':Predicate, #1: 1	ضَرَبَ التِّلْمِيذَ
u'ضَرَبَ ثَدْيٌ':Predicate, #1: 1	ضَرَبَ ثَالِثَةً
u'ضَرْبٌ ثَلاثَةٌ':Added, #1: 1	ضَرَبَ ثَدْيَ
u'ضَرَبَ ثَمانِين':Predicate, #2: 2	ضَرْبِ ثَلَاثَةٍ
u'ضَرَبَ ثَوْرٌ':Predicate, #1: 1	ضَرَبَ ثَمَانِينَ
u'ضَرْبٌ جَاهِلِيٌّ':Added, #1: 1	ضَرَبَ ثَوْرَ
u'ضَرْبٌ جَاهِلِيٌّ':Added, #1: 1	ضَرْبُ الْجَاهِلِيَّةِ
u'ضَرْبٌ جَاهِلِيَّةٌ':Added, #2: 2	ضَرْبِ الْجَاهِلِيَّةِ
u'ضَرْبٌ جَاهِلِيَّةٌ':Added, #1: 1	ضَرْبُ الْجَاهِلِيَّةِ
u'ضَرَبَ جِزْيَةٌ':Predicate, #2: 2	ضَرْبِ الْجَاهِلِيَّةِ
u'ضَرْبٌ جِزْيَةٌ':Added, #3: 3	ضَرَبَ الْجِزْيَةَ
u'ضَرْبٌ جِزْيَةٌ':Added, #1: 1	ضَرْبَ الْجِزْيَةِ
u'ضَرْبٌ جِزْيَةٌ':Added, #4: 4	ضَرْبِ الْجِزْيَةِ
u'ضَرْبٌ جِمَالٌ':Added, #6: 6	ضَرْبُ الْجِزْيَةِ
u'ضَرْبٌ حَدٌّ':Added, #2: 2	ضَرْبُ الْجِمَالِ
u'ضَرْبٌ حَدٌّ':Added, #1: 1	ضَرْبُ حَدِّ
u'ضَرْبٌ حَدٌّ':Added, #1: 1	ضَرْبِ حَدِّ
u'ضَرْبٌ حُدودٌ':Added, #2: 2	ضَرْبَ الْحَدِّ
u'ضَرْبٌ حُدودٌ':Added, #1: 1	ضَرْبَ الْحُدُودِ
u'ضَرْبٌ حساب':Added, #2: 2	ضَرْبِ الْحُدُودِ
u'ضَرْبٌ حِسَابٌ':Added, #1: 1	ضَرْبَ الْحِسَابِ
u'ضَرْبٌ حَطِيم':Added, #1: 1	ضَرْبَ الْحِسَابِ
u'ضَرَبَ حُوتٌ':Subject, #1: 1	ضَرْبُ الْحَطِيمِ
u'ضَرْبٌ خامس':Added, #1: 1	ضَرَبَ الْحُوتُ
u'ضَرْبٌ خَامِسٌ':Added, #1: 1	ضَرْبٍ خَامِسٍ
u'ضَرْبٌ خِبَاءٌ':Added, #1: 1	ضَرْبٍ خَامِسٍ
u'ضَرْبٌ خِبَاءٌ':Added, #1: 1	ضَرْبُ الْخِبَاءِ
u'ضَرْبٌ خَدٌّ':Added, #1: 1	ضَرْبُ خِبَاءٍ
u'ضَرَبَ خُدُودٌ':Predicate, #1: 1	ضَرْبُ الْخَدِّ
u'ضَرْبٌ خُدُودٌ':Added, #6: 6	ضَرَبَ الْخُدُودَ
u'ضَرْبٌ خُدُودٌ':Added, #1: 1	ضَرْبُ الْخُدُودِ
u'ضَرْبٌ خراج':Added, #1: 1	ضَرْبِ الْخُدُودِ
u'ضَرْبٌ خَرَاجٌ':Added, #1: 1	ضَرْبُ خَرَاجٍ
u'ضَرْبٌ خراج':Added, #1: 1	ضَرْبُ خَرَاجٍ
u'ضَرْبٌ خَرَاجٌ':Added, #2: 2	ضَرْبَ الْخَرَاجِ
u'ضَرْبٌ خَمْسَةٌ':Added, #2: 2	ضَرْبَ الْخَرَاجِ
u'ضَرَبَ خَنْدَقٌ':Predicate, #1: 1	ضَرْبِ الْخَمْسَةِ
u'ضَرَبَ دَابَّةٌ':Predicate, #1: 1	ضَرَبَ الْخَنْدَقَ
u'ضَرْبٌ دَابَّةٌ':Added, #2: 2	ضَرَبَ الدَّابَّةَ
u'ضَرْبٌ دَابَّةٌ':Added, #1: 1	ضَرْبُ دَابَّةِ
u'ضَرْبٌ دَابَّةٌ':Added, #2: 2	ضَرْبَ الدَّابَّةِ
u'ضَرَبَ دَرَاهِمُ':Predicate, #2: 2	ضَرْبُ الدَّابَّةِ
u'ضَرْبٌ دَرَاهِمُ':Added, #3: 3	ضَرَبَ الدَّرَاهِمَ
u'ضَرْبٌ دَرَاهِمُ':Added, #1: 1	ضَرْبَ الدَّرَاهِمِ
u'ضَرْبٌ دِرْهَمٌ':Added, #3: 3	ضَرْبُ الدَّرَاهِمِ
u'ضَرْبٌ دِرْهَم':Added, #1: 1	ضَرْبَ دِرْهَمِهِ
u'ضَرْبٌ دُفٌّ':Added, #1: 1	ضَرْبَ دِرْهَمِهِ
u'ضَرْبٌ دُفٌّ':Added, #3: 3	ضَرْبَ الدُّفِّ
u'ضَرْبٌ دُفٌّ':Added, #3: 3	ضَرْبُ الدُّفِّ
u'ضَرَبَ دَلٌّ':Predicate, #4: 4	ضَرْبِ الدُّفِّ
u'ضَرْبٌ دِيَةٌ':Added, #1: 1	ضَرَبَ دَلَّ
u'ضَرْبٌ دِيَةٌ':Added, #1: 1	ضَرْبُ دِيَةِ
u'ضَرْبٌ رِبْحٌ':Added, #2: 2	ضَرْبُ الدِّيَةِ
u'ضَرَبَ رَجُلٌ':Predicate, #1: 1	ضَرْبُ الرِّبْحِ
u'ضَرَبَ رَجُلٌ':Subject, #2: 2	ضَرَبَ رَجُلاً
u'ضَرَبَ رَجُلٌ':Subject, #14: 14	ضَرَبَ رَجُلٌ
u'ضَرْبٌ رَجُلٌ':Added, #1: 1	ضَرَبَ الرَّجُلُ
u'ضَرْبٌ رَجُلٌ':Added, #1: 1	ضَرْبَ رَجُلٍ
u'ضَرَبَ رَسُولٌ':Subject, #2: 2	ضَرْبِ رَجُلٍ
u'ضَرَبَ رِقٌّ':Predicate, #12: 12	ضَرَبَ رَسُولُ
u'ضَرْبٌ رِقٌّ':Added, #1: 1	ضَرَبَ الرِّقَّ
u'ضَرْبٌ رِقابٌ':Added, #1: 1	ضَرْبَ الرِّقِّ
u'ضَرْبٌ رِقابٌ':Added, #2: 2	ضَرْبَ الرِّقَابِ
u'ضَرْبٌ رَقَبَةٌ':Added, #2: 2	ضَرْبِ الرِّقَابِ
u'ضَرْبٌ رَقَبَةٌ':Added, #1: 1	ضَرْبِ الرَّقَبَةِ
u'ضَرْبٌ رَقيقٌ':Added, #2: 2	ضَرْبُ الرَّقَبَةِ
u'ضَرْبٌ رَقيق':Added, #1: 1	ضَرْبَ الرَّقِيقِ
u'ضَرْبٌ رَقيقٌ':Added, #1: 1	ضَرْبَ الرَّقِيقِ
u'ضَرْبٌ رَقيق':Added, #1: 1	ضَرْبُ رَقِيقِهِ
u'ضَرَبَ زانِي':Predicate, #1: 1	ضَرْبُ رَقِيقِهِ
u'ضَرَبَ زَوْجٌ':Subject, #1: 1	ضَرَبَ الزَّانِيَ
u'ضَرْبٌ زَوْجٌ':Added, #2: 2	ضَرَبَ الزَّوْجُ
u'ضَرْبٌ زَوْجَةٌ':Added, #2: 2	ضَرْبِ الزَّوْجِ
u'ضَرْبٌ زَوْجَةٌ':Added, #1: 1	ضَرْبِ الزَّوْجَاتِ
u'ضَرْبٌ زَوْجَةٌ':Added, #1: 1	ضَرْبُ الزَّوْجَةِ
u'ضَرَبَ زَيْدٌ':Subject, #4: 4	ضَرْبُ زَوْجَتِهِ
u'ضَرْبٌ زَيْدٌ':Added, #9: 9	ضَرَبَ زَيْدٌ
u'ضَرْبٌ زَيْدٌ':Added, #1: 1	ضَرْبَ زَيْدٍ
u'ضَرْبٌ زَيْدٌ':Added, #1: 1	ضَرْبُ زَيْدٍ
u'ضَرْبٌ سادس':Added, #1: 1	ضَرْبِ زَيْدٍ
u'ضَرْبٌ سَادِسٌ':Added, #1: 1	ضَرْبٍ سَادِسٍ
u'ضَرْبٌ سَارِقٌ':Added, #1: 1	ضَرْبٍ سَادِسٍ
u'ضَرَبَ سِدْرٌ':Predicate, #1: 1	ضَرْبُ السَّارِقِ
u'ضَرَبَ سُلْطَانٌ':Subject, #1: 1	ضَرَبَ السِّدْرَ
u'ضَرْبٌ سُلْطَانٌ':Added, #2: 2	ضَرَبَ سُلْطَانٌ
u'ضَرَبَ سَمَكٌ':Predicate, #1: 1	ضَرْبِ سُلْطَانِ
u'ضَرَبَ سِنٌّ':Predicate, #1: 1	ضَرَبَ سَمَكَةً
u'ضَرْبٌ سَوْطٌ':Added, #9: 9	ضَرَبَ سِنَّ
u'ضَرْبٌ سَوْطٌ':Added, #3: 3	ضَرْبِ السَّوْطِ
u'ضَرْبٌ سِياطٌ':Added, #5: 5	ضَرْبِ سَوْطٍ
u'ضَرْبٌ سُيوفٌ':Added, #1: 1	ضَرْبِ سِيَاطٍ
u'ضَرْبٌ شَارِبٌ':Added, #1: 1	ضَرْبُ السُّيُوفِ
u'ضَرْبٌ شَارِبٌ':Added, #1: 1	ضَرْبَ الشَّارِبِ
u'ضَرْبٌ شَارِبٌ':Added, #1: 1	ضَرْبِ الشَّارِبِ
u'ضَرَبَ شَاعِر':Subject, #1: 1	ضَرْبِ شَارِبِ
u'ضَرَبَ شافِعِيّ':Subject, #1: 1	ضَرَبَ الشَّاعِرُ
u'ضَرَبَ شَاهِدٌ':Predicate, #1: 1	ضَرَبَ الشَّافِعِيُّ
u'ضَرَبَ شبكة':Predicate, #4: 4	ضَرَبَ شَاهِدَ
u'ضَرَبَ شَبَكَةٌ':Predicate, #1: 1	ضَرَبَ الشَّبَكَةَ
u'ضَرْبٌ شُبْهَةٌ':Added, #1: 1	ضَرَبَ الشَّبَكَةَ
u'ضَرْبٌ شُبْهَةٌ':Added, #1: 1	ضَرْبُ شُبْهَةٍ
u'ضَرْبٌ شُبْهَةٌ':Added, #1: 1	ضَرْبِ شُبْهَةٍ
u'ضَرْبٌ شرب':Added, #2: 2	ضَرْبَ شُبْهَةٍ
u'ضَرْبٌ شُرْبٌ':Added, #1: 1	ضَرْبِ الشُّرْبِ
u'ضَرَبَ شَرْعٌ':Subject, #1: 1	ضَرْبِ الشُّرْبِ
u'ضَرَبَ شَرِيكٌ':Subject, #1: 1	ضَرَبَ الشَّرْعُ
u'ضَرْبٌ شَرِيكٌ':Added, #1: 1	ضَرَبَ الشَّرِيكُ
u'ضَرَبَ صَاحِبٌ':Subject, #1: 1	ضَرْبِ الشَّرِيكِ
u'ضَرَبَ صَبِيٌّ':Predicate, #3: 3	ضَرَبَ صَاحِبُ
u'ضَرْبٌ صَبِيٌّ':Added, #3: 3	ضَرَبَ الصَّبِيَّ
u'ضَرَبَ صَغِيرٌ':Predicate, #1: 1	ضَرْبِ الصَّبِيِّ
u'ضَرْبٌ صَغِيرٌ':Added, #2: 2	ضَرَبَ الصَّغِيرَ
u'ضَرْبٌ صَغِيرٌ':Added, #1: 1	ضَرْبَ الصَّغِيرِ
u'ضَرَبَ صَفْوَان':Subject, #3: 3	ضَرْبُ الصَّغِيرِ
u'ضَرَبَ صلْبٌ':Predicate, #2: 2	ضَرَبَ صَفْوَانُ
u'ضَرَبَ ضَارِبٌ':Predicate, #3: 3	ضَرَبَ صُلْبَ
u'ضَرَبَ ضَارِبٌ':Subject, #2: 2	ضَرَبَ الضَّارِبَ
u'ضَرَبَ ضَرَائِبُ':Predicate, #2: 2	ضَرَبَ ضَارِبٌ
u'ضَرْبٌ طُبُولٌ':Added, #1: 1	ضَرَبَ الضَّرَائِبَ
u'ضَرَبَ عَبْدٌ':Predicate, #1: 1	ضَرْبُ الطُّبُولِ
u'ضَرَبَ عَبْدٌ':Predicate, #1: 1	ضَرَبَ عَبْدَ
u'ضَرَبَ عَبْدٌ':Subject, #3: 3	ضَرَبَ الْعَبْدَ
u'ضَرَبَ عَبْدٌ':Subject, #1: 1	ضَرَبَ الْعَبْدُ
u'ضَرْبٌ عَبْدٌ':Added, #1: 1	ضَرَبَ عَبْدُ
u'ضَرْبٌ عَبْدٌ':Added, #2: 2	ضَرْبَ الْعَبْدِ
u'ضَرْبٌ عَبْدٌ':Added, #2: 2	ضَرْبَ عَبْدِهِ
u'ضَرْبٌ عَبْدٌ':Added, #2: 2	ضَرْبُ عَبْدِهِ
u'ضَرْبٌ عَبْدٌ':Added, #4: 4	ضَرْبِ الْعَبْدِ
u'ضَرْبٌ عَدَدٌ':Added, #5: 5	ضَرْبِ عَبْدِهِ
u'ضَرْبٌ عَدُوٌّ':Added, #2: 2	ضَرْبِ عَدَدٍ
u'ضَرْبٌ عَقْلٌ':Added, #1: 1	ضَرْبَ الْعَدُوِّ
u'ضَرْبٌ عَقْلٌ':Added, #1: 1	ضَرْبَ الْعَقْلِ
u'ضَرَبَ عِلاَوَةٌ':Predicate, #1: 1	ضَرْبُ الْعَقْلِ
u'ضَرَبَ علم':Predicate, #1: 1	ضَرَبَ الْعِلَاوَةَ
u'ضَرَبَ عُمَرٌ':Subject, #1: 1	ضَرَبَ عَلِمَ
u'ضَرْبٌ عناد':Added, #6: 6	ضَرَبَ عُمَرُ
u'ضَرْبٌ عِنَادٌ':Added, #1: 1	ضَرْبُ عِنَادٍ
u'ضَرَبَ عنق':Predicate, #1: 1	ضَرْبُ عِنَادٍ
u'ضَرَبَ عُنُقٌ':Predicate, #4: 4	ضَرَبَ الْعُنُقَ
u'ضَرَبَ عنق':Predicate, #4: 4	ضَرَبَ الْعُنُقَ
u'ضَرَبَ عُنُقٌ':Predicate, #4: 4	ضَرَبَ عُنُقَ
u'ضَرْبٌ عنق':Added, #4: 4	ضَرَبَ عُنُقَ
u'ضَرْبٌ عنق':Added, #1: 1	ضَرْبَ الْعُنُقِ
u'ضَرْبٌ عُنُقٌ':Added, #1: 1	ضَرْبِ الْعُنُقِ
u'ضَرْبٌ عُنُقٌ':Added, #1: 1	ضَرْبَ الْعُنُقِ
u'ضَرْبٌ عنق':Added, #1: 1	ضَرْبِ الْعُنُقِ
u'ضَرْبٌ عنق':Added, #1: 1	ضَرْبَ عُنُقِ
u'ضَرْبٌ عُنُقٌ':Added, #1: 1	ضَرْبِ عُنُقٍ
u'ضَرْبٌ عُنُقٌ':Added, #1: 1	ضَرْبَ عُنُقِ
u'ضَرْبٌ عنق':Added, #1: 1	ضَرْبِ عُنُقٍ
u'ضَرْبٌ عنق':Added, #1: 1	ضَرْبَ عُنُقِهِ
u'ضَرْبٌ عُنُقٌ':Added, #1: 1	ضَرْبِ عُنُقِهِ
u'ضَرْبٌ عُنُقٌ':Added, #1: 1	ضَرْبَ عُنُقِهِ
u'ضَرَبَ عين':Predicate, #1: 1	ضَرْبِ عُنُقِهِ
u'ضَرَبَ عَيْنٌ':Predicate, #2: 2	ضَرَبَ الْعَيْنَ
u'ضَرَبَ عَيْن':Predicate, #2: 2	ضَرَبَ الْعَيْنَ
u'ضَرَبَ عين':Predicate, #2: 2	ضَرَبَ الْعَيْنَ
u'ضَرَبَ عَيْنٌ':Predicate, #6: 6	ضَرَبَ عَيْنَ
u'ضَرَبَ عَيْن':Predicate, #6: 6	ضَرَبَ عَيْنَ
u'ضَرْبٌ عين':Added, #6: 6	ضَرَبَ عَيْنَ
u'ضَرْبٌ عَيْنٌ':Added, #1: 1	ضَرْبِ الْعَيْنِ
u'ضَرْبٌ عَيْن':Added, #1: 1	ضَرْبِ الْعَيْنِ
u'ضَرَبَ غرماء':Subject, #1: 1	ضَرْبِ الْعَيْنِ
u'ضَرْبٌ غفلة':Added, #1: 1	ضَرَبَ الْغُرَمَاءُ
u'ضَرْبٌ غَفْلَةٌ':Added, #1: 1	ضَرْبِ غَفْلَةٍ
u'ضَرَبَ غُلاَمٌ':Predicate, #1: 1	ضَرْبِ غَفْلَةٍ
u'ضَرْبٌ غُلاَمٌ':Added, #1: 1	ضَرَبَ الْغُلَامَ
u'ضَرَبَ غير':Predicate, #1: 1	ضَرْبَ الْغُلَامِ
u'ضَرَبَ غَيْرٌ':Predicate, #2: 2	ضَرَبَ غَيْرَ
u'ضَرْبٌ غير':Added, #2: 2	ضَرَبَ غَيْرَ
u'ضَرْبٌ غَيْرٌ':Added, #1: 1	ضَرْبِ غَيْرِهِ
u'ضَرْبٌ غير':Added, #1: 1	ضَرْبِ غَيْرِهِ
u'ضَرْبٌ غَيْرٌ':Added, #2: 2	ضَرْبَ غَيْرِهِ
u'ضَرَبٌ فَحْلٌ':Added, #2: 2	ضَرْبَ غَيْرِهِ
u'ضَرْبٌ فَحْلٌ':Added, #1: 1	ضَرَبَ الْفَحْلِ
u'ضَرَبَ فُسْطَاطٌ':Predicate, #1: 1	ضَرْبِ الْفَحْلِ
u'ضَرْبٌ فُسْطَاطٌ':Added, #1: 1	ضَرَبَ الْفُسْطَاطَ
u'ضَرَبَ فِضَّةٌ':Predicate, #1: 1	ضَرْبُ الْفُسْطَاطِ
u'ضَرَبَ فِعْلٌ':Subject, #1: 1	ضَرَبَ الْفِضَّةَ
u'ضَرَبَ فلان':Subject, #1: 1	ضَرَبَ فِعْلٌ
u'ضَرَبَ فُلاَنٌ':Subject, #1: 1	ضَرَبَ الشَّافِعِيُّ
u'ضَرْبٌ قَاذِفٌ':Added, #1: 1	ضَرَبَ فُلَانٌ
u'ضَرَبَ قَاطِعٌ':Subject, #1: 1	ضَرْبِ الْقَاذِفِ
u'ضَرَبَ قُبَّةٌ':Predicate, #1: 1	ضَرَبَ الْقَاطِعُ
u'ضَرْبٌ قذف':Added, #1: 1	ضَرَبَ الْقُبَّةَ
u'ضَرْبٌ قَذْفٌ':Added, #1: 1	ضَرْبِ الْقَذْفِ
u'ضَرْبٌ قُصُورٌ':Added, #1: 1	ضَرْبِ الْقَذْفِ
u'ضَرْبٌ قَضِيبٌ':Added, #3: 3	ضَرْبِ قُصُورٍ
u'ضَرْبٌ قَلَنْسُوَةٌ':Added, #1: 1	ضَرْبِ الْقَضِيبِ
u'ضَرَبَ قوائم':Predicate, #1: 1	ضَرْبَ الْقَلَنْسُوَةِ
u'ضَرَبَ قَوَائِمُ':Predicate, #1: 1	ضَرَبَ قَوَائِمَ
u'ضَرْبٌ قُوَّةٌ':Added, #1: 1	ضَرَبَ قَوَائِمَ
u'ضَرْبٌ قُوَّة':Added, #1: 1	ضَرْبِ قُوَّةٍ
u'ضَرْبٌ قُوَّةٌ':Added, #1: 1	ضَرْبِ قُوَّةٍ
u'ضَرْبٌ قُوَّة':Added, #2: 2	ضَرْبُ قُوَّةٍ
u'ضَرْبٌ قول':Added, #2: 2	ضَرْبُ قُوَّةٍ
u'ضَرْبٌ قَوْلٌ':Added, #1: 1	ضَرْبُ قَوْلِ
u'ضَرَبَ قَوْمٌ':Predicate, #1: 1	ضَرْبُ قَوْلِ
u'ضَرَبَ قِيمَةٌ':Predicate, #1: 1	ضَرَبَ الْقَوْمَ
u'ضَرْبٌ كَرَامَةٌ':Added, #1: 1	ضَرَبَ الْقِيمَةَ
u'ضَرَبَ كَعْبٌ':Predicate, #1: 1	ضَرْبُ كَرَامَةٍ
u'ضَرَبَ كَلْبٌ':Subject, #1: 1	ضَرَبَ كَعْبَ
u'ضَرْبٌ كُوبَة':Added, #1: 1	ضَرَبَ الْكَلْبُ
u'ضَرْبٌ كِيمْيَاءُ':Added, #1: 1	ضَرْبَ الْكُوبَةِ
u'ضَرَبَ لبن':Predicate, #1: 1	ضَرْبِ الْكِيمْيَاءِ
u'ضَرَبَ لَبَنٌ':Predicate, #1: 1	ضَرَبَ اللَّبَنَ
u'ضَرَبَ لَحْمٌ':Subject, #1: 1	ضَرَبَ اللَّبَنَ
u'ضَرَبَ لَحْمٌ':Subject, #1: 1	ضَرَبَ اللّحْمُ
u'ضَرَبَ لُغَةٌ':Subject, #1: 1	ضَرَبَ اللَّحْمُ
u'ضَرْبٌ مَاءٌ':Added, #1: 1	ضَرَبَ لُغَةٌ
u'ضَرْبٌ مالِك':Added, #1: 1	ضَرْبِ الْمَاءِ
u'ضَرْبٌ مالِكِيّ':Added, #1: 1	ضَرْبِ مَالِكِيَّةٍ
u'ضَرَبَ مَأْمُورٌ':Subject, #1: 1	ضَرْبِ مَالِكِيَّةٍ
u'ضَرْبٌ مُبَالَغَةٌ':Added, #1: 1	ضَرَبَ الْمَأْمُورُ
u'ضَرْبٌ مِثَالٌ':Added, #1: 1	ضَرْبِ مُبَالَغَةٍ
u'ضَرْبٌ مِثَالٌ':Added, #1: 1	ضَرْبَ الْمِثَالِ
u'ضَرْبٌ مِثَالٌ':Added, #1: 1	ضَرْبُ الْمِثَالِ
u'ضَرْبٌ مِثَالٌ':Added, #1: 1	ضَرْبُ مِثَالٍ
u'ضَرَبَ مثل':Predicate, #3: 3	ضَرْبِ الْمِثَالِ
u'ضَرَبَ مَثَلٌ':Predicate, #1: 1	ضَرَبَ مَثَلَ
u'ضَرَبَ مثل':Predicate, #1: 1	ضَرَبَ مَثَلَ
u'ضَرَبَ مَثَلٌ':Predicate, #2: 2	ضَرَبَ الْمَثَلَ
u'ضَرَبَ مثل':Subject, #2: 2	ضَرَبَ الْمَثَلَ
u'ضَرَبَ مَثَلٌ':Subject, #1: 1	ضَرَبَ الْمَثَلُ
u'ضَرَبَ مثل':Subject, #1: 1	ضَرَبَ الْمَثَلُ
u'ضَرَبَ مِثْلٌ':Subject, #1: 1	ضَرَبَ مِثْلُ
u'ضَرْبٌ مَثَلٌ':Added, #1: 1	ضَرَبَ مِثْلُ
u'ضَرْبٌ مَثَلٌ':Added, #1: 1	ضَرْبَ مَثَلٍ
u'ضَرْبٌ مثل':Added, #2: 2	ضَرْبُ مَثَلٍ
u'ضَرْبٌ مِثْلٌ':Added, #2: 2	ضَرْبَ مِثْلِهِ
u'ضَرْبٌ مثل':Added, #2: 2	ضَرْبَ مِثْلِهِ
u'ضَرْبٌ مَثَلٌ':Added, #3: 3	ضَرْبِ الْمَثَلِ
u'ضَرْبٌ مَجْمُوعٌ':Added, #3: 3	ضَرْبِ الْمَثَلِ
u'ضَرْبٌ مَجْنُونٌ':Added, #2: 2	ضَرْبِ مَجْمُوعِ
u'ضَرَبَ مُحَمَّدٌ':Subject, #1: 1	ضَرْبَ الْمَجْنُونِ
u'ضَرَبَ مُحَمَّدٌ':Subject, #1: 1	ضَرَبَ مُحَمَّدٌ
u'ضَرَبَ مُدَّةٌ':Predicate, #1: 1	ضَرَبَ مُحَمَّدُ
u'ضَرْبٌ مُدَّةٌ':Added, #1: 1	ضَرَبَ الْمُدَّةَ
u'ضَرْبٌ مُدَّةٌ':Added, #1: 1	ضَرْبِ مُدَّةٍ
u'ضَرْبٌ مُدَّةٌ':Added, #2: 2	ضَرْبَ الْمُدَّةِ
u'ضَرْبٌ مُدَّةٌ':Added, #2: 2	ضَرْبِ مُدَّةِ
u'ضَرْبٌ مُدَّةٌ':Added, #3: 3	ضَرْبُ مُدَّةٍ
u'ضَرْبٌ مُدَّةٌ':Added, #5: 5	ضَرْبِ الْمُدَّةِ
u'ضَرَبَ مرٌّ':Predicate, #9: 9	ضَرْبُ الْمُدَّةِ
u'ضَرْبٌ مَرَضٌ':Added, #3: 3	ضَرَبَ مَرَّةً
u'ضَرْبٌ مَزِيَّةٌ':Added, #1: 1	ضَرْبُ مَرَضٍ
u'ضَرَبَ مُسْتَأْجِرٌ':Subject, #1: 1	ضَرْبُ مَزِيَّةٍ
u'ضَرْبٌ مُسْلِمٌ':Added, #1: 1	ضَرَبَ الْمُسْتَأْجِرُ
u'ضَرْبٌ مَشَقَّةٌ':Added, #1: 1	ضَرْبُ الْمُسْلِمِ
u'ضَرْبٌ مِظَلَّةٌ':Added, #1: 1	ضَرْبُ مَشَقَّةٍ
u'ضَرْبٌ مَعْصُومٌ':Added, #1: 1	ضَرْبُ مِظَلَّةٍ
u'ضَرَبَ مُعَلِّمٌ':Subject, #1: 1	ضَرْبَ الْمَعْصُومِ
u'ضَرْبٌ مُعَلِّمٌ':Added, #1: 1	ضَرَبَ الْمُعَلِّمُ
u'ضَرْبٌ مَعْلُومٌ':Added, #3: 3	ضَرْبِ الْمُعَلِّمِ
u'ضَرْبٌ مَغْشُوشٌ':Added, #1: 1	ضَرْبٍ مَعْلُومٍ
u'ضَرَبَ مَقْتُولٌ':Predicate, #1: 1	ضَرْبُ الْمَغْشُوشَةِ
u'ضَرْبٌ مَقْتُولٌ':Added, #2: 2	ضَرَبَ الْمَقْتُولَ
u'ضَرَبَ مُقَدَّمٌ':Predicate, #1: 1	ضَرْبَ الْمَقْتُولِ
u'ضَرَبَ مَقْذُوفٌ':Predicate, #1: 1	ضَرَبَ مُقَدَّمَ
u'ضَرْبٌ مَمَالِيكُ':Added, #1: 1	ضَرَبَ الْمَقْذُوفَ
u'ضَرَبَ نَاسٌ':Subject, #1: 1	ضَرْبِ الْمَمَالِيكِ
u'ضَرْبٌ نَاقُوسٌ':Added, #2: 2	ضَرَبَ النَّاسُ
u'ضَرَبَ نَبِيٌّ':Subject, #2: 2	ضَرْبِ النَّاقُوسِ
u'ضَرْبٌ نَحْوٌ':Added, #2: 2	ضَرَبَ النَّبِيُّ
u'ضَرْبٌ نِساءٌ':Added, #1: 1	ضَرْبُ نَحْوِ
u'ضَرْبٌ نِساءٌ':Added, #1: 1	ضَرْبِ النّسَاءِ
u'ضَرَبَ نَعَامَةٌ':Predicate, #4: 4	ضَرْبِ النِّسَاءِ
u'ضَرْبٌ نَفْسٌ':Added, #1: 1	ضَرَبَ النّعَامَةَ
u'ضَرْبٌ نَقْدٌ':Added, #1: 1	ضَرْبِ نَفْسِهِ
u'ضَرْبٌ نَقْد':Added, #1: 1	ضَرْبُ نَقْدٍ
u'ضَرَبَ نقرة':Predicate, #1: 1	ضَرْبُ نَقْدٍ
u'ضَرَبَ نُقْرَةٌ':Predicate, #1: 1	ضَرَبَ النُّقْرَةَ
u'ضَرَبَ نقرة':Predicate, #1: 1	ضَرَبَ النُّقْرَةَ
u'ضَرْبٌ نُقْصَانٌ':Added, #4: 4	ضَرَبَ النَّقْرَةَ
u'ضَرْبٌ نَوَاقِيسُ':Added, #1: 1	ضَرْبِ نُقْصَانٍ
u'ضَرْبٌ واحد':Added, #1: 1	ضَرْبِ النَّوَاقِيسِ
u'ضَرْبٌ وَاحِدٌ':Added, #2: 2	ضَرْبٍ وَاحِدٍ
u'ضَرْبٌ وَالِدٌ':Added, #2: 2	ضَرْبٍ وَاحِدٍ
u'ضَرْبٌ وَالِدٌ':Added, #1: 1	ضَرْبُ الْوَالِدِ
u'ضَرْبٌ وَتَرٌ':Added, #1: 1	ضَرْبَ وَالِدِهِ
u'ضَرَبَ وَجْهٌ':Predicate, #1: 1	ضَرْبُ وَتَرٍ
u'ضَرَبَ وَجْهٌ':Predicate, #1: 1	ضَرَبَ وَجْهَ
u'ضَرْبٌ وَجْهٌ':Added, #2: 2	ضَرَبَ الْوَجْهَ
u'ضَرْبٌ وَجْهٌ':Added, #1: 1	ضَرْبُ وَجْهٍ
u'ضَرْبٌ وَجْهٌ':Added, #1: 1	ضَرْبُ وَجْهِهِ
u'ضَرْبٌ وُجُوبٌ':Added, #4: 4	ضَرْبِ الْوَجْهِ
u'ضَرْبٌ وَعْدٌ':Added, #1: 1	ضَرْبِ الْوُجُوبِ
u'ضَرْبٌ وَفْقٌ':Added, #1: 1	ضَرْبُ الْوَعْدِ
u'ضَرْبٌ وَفْقٌ':Added, #1: 1	ضَرْبِ الْوَفْقِ
u'ضَرْبٌ وُلاَةٌ':Added, #1: 1	ضَرْبِ وَفْقِ
u'ضَرْبٌ ولد':Added, #1: 1	ضَرْبُ وُلَاةِ
u'ضَرْبٌ وَلَدٌ':Added, #1: 1	ضَرْبُ الْوَلَدِ
u'ضَرْبٌ ولد':Added, #1: 1	ضَرْبُ الْوَلَدِ
u'ضَرْبٌ ولد':Added, #1: 1	ضَرْبَ وَلَدِهِ
u'ضَرْبٌ ولد':Added, #1: 1	ضَرْبُ وَلَدِهِ
u'ضَرْبٌ وَلَدٌ':Added, #1: 1	ضَرْبِ وَلَدِهِ
u'ضَرْبٌ وَلَدٌ':Added, #1: 1	ضَرْبَ وَلَدِهِ
u'ضَرْبٌ وَلَدٌ':Added, #1: 1	ضَرْبُ وَلَدِهِ
u'ضَرْبٌ ولد':Added, #1: 1	ضَرْبِ وَلَدِهِ
u'ضَرْبٌ وَلَدٌ':Added, #2: 2	ضَرْبِ وَلَدِ
u'ضَرْبٌ ولد':Added, #2: 2	ضَرْبِ وَلَدِ
u'ضَرْبٌ وَلَدٌ':Added, #7: 7	ضَرْبِ الْوَلَدِ
u'ضَرَبَ يَتِيمٌ':Predicate, #7: 7	ضَرْبِ الْوَلَدِ
u'ضَرَبَ يَدٌ':Predicate, #1: 1	ضَرَبَ الْيَتِيمَ
u'ضَرَبَ يَدٌ':Subject, #1: 1	ضَرَبَ يَدَ
u'ضَرْبٌ يَدٌ':Added, #1: 1	ضَرَبَ يَدُهُ
u'ضَرْبٌ يَدٌ':Added, #1: 1	ضَرْبَ الْيَدِ
u'ضَرْبٌ يَدٌ':Added, #1: 1	ضَرْبُ الْيَدِ
u'ضَرَبَ يَمِينٌ':Predicate, #1: 1	ضَرْبِ يَدِهِ
u'ضَرَّ ثَمَرَةٌ':Subject, #1: 1	ضَرَبَ الْيَمِينَ
u'ضَرَّ جَازٌ':Predicate, #1: 1	ضَرَّ الثَّمَرَةُ
u'ضَرَرٌ إِبْطَالٌ':Added, #1: 1	ضَرَّ جَازَ
u'ضَرَرٌ إِبْطَالٌ':Added, #2: 2	ضَرَرُ الْإِبْطَالِ
u'ضَرَرٌ إِجْبَارٌ':Added, #2: 2	ضَرَرِ الْإِبْطَالِ
u'ضَرَرٌ أُجْرَةٌ':Added, #1: 1	ضَرَرُ إجْبَارِهِ
u'ضَرَرٌ أحَدٌ':Added, #1: 1	ضَرَرِ أُجْرَةِ
u'ضَرَرٌ أحَدٌ':Added, #1: 1	ضَرَرُ أَحَدٍ
u'ضَرَرٌ آدَمِيٌّ':Added, #1: 1	ضَرَرِ أَحَدٍ
u'ضَرَرٌ آدَمِيٌّ':Added, #1: 1	ضَرَرَ آدَمِيٍّ
u'ضَرَرٌ أرْضٌ':Added, #2: 2	ضَرَرُ آدَمِيٍّ
u'ضَرَرٌ أُسْتَاذٌ':Added, #1: 1	ضَرَرِ الْأَرْضِ
u'ضَرَرٌ أُسْتَاذٌ':Added, #1: 1	ضَرَرُ أُسْتَاذِهِ
u'ضَرَرٌ اِسْتِدَامَةٌ':Added, #2: 2	ضَرَرَ أُسْتَاذِهِ
u'ضَرَرٌ أَشْيَاءٌ':Added, #1: 1	ضَرَرِ اسْتِدَامَةِ
u'ضَرَرٌ أَطْعِمَةٌ':Added, #1: 1	ضَرَرِ الْأَشْيَاءِ
u'ضَرَرٌ إقْرَارٌ':Added, #1: 1	ضَرَرَ الْأَطْعِمَةِ
u'ضَرَرٌ إقْرَارٌ':Added, #1: 1	ضَرَرُ إقْرَارِهِ
u'ضَرَرٌ أَكْثَرُ':Added, #1: 1	ضَرَرُ الْإِقْرَارِ
u'ضَرَرٌ إكْرَاهٌ':Added, #1: 1	ضَرَرِ أَكْثَرِ
u'ضَرَرٌ أكل':Added, #1: 1	ضَرَرِ الْإِكْرَاهِ
u'ضَرَرٌ أَكْلٌ':Added, #1: 1	ضَرَرِ أَكْلِ
u'ضَرَرٌ اِلْتِزَامٌ':Added, #1: 1	ضَرَرِ أَكْلِ
u'ضَرَرٌ بَائِعٌ':Added, #1: 1	ضَرَرِ الْتِزَامِ
u'ضَرَرٌ بدن':Added, #1: 1	ضَرَرِ الْبَائِعِ
u'ضَرَرٌ بدن':Added, #1: 1	ضَرَرَ الْبَدَنِ
u'ضَرَرٌ بَدَنٌ':Added, #1: 1	ضَرَرِ الْبَدَنِ
u'ضَرَرٌ بَدَنٌ':Added, #1: 1	ضَرَرَ الْبَدَنِ
u'ضَرَرٌ بَذْلٌ':Added, #1: 1	ضَرَرِ الْبَدَنِ
u'ضَرَرٌ بُرٌّ':Added, #1: 1	ضَرَرِ بَذْلِ
u'ضَرَرٌ بَرْدٌ':Added, #1: 1	ضَرَرِ الْبُرِّ
u'ضَرَرٌ بَقِيَّةٌ':Added, #2: 2	ضَرَرَ الْبَرْدِ
u'ضَرَرٌ بِنَاءٌ':Added, #1: 1	ضَرَرُ بَقِيَّةِ
u'ضَرَرٌ تَأْجِيلٌ':Added, #2: 2	ضَرَرُ الْبِنَاءِ
u'ضَرَرٌ تَأْخِيرٌ':Added, #1: 1	ضَرَرَ التَّأْجِيلِ
u'ضَرَرٌ تَأْخِيرٌ':Added, #1: 1	ضَرَرِ التَّأْخِيرِ
u'ضَرَرٌ تَبْعِيض':Added, #3: 3	ضَرَرُ التَّأْخِيرِ
u'ضَرَرٌ تَبْعِيض':Added, #1: 1	ضَرَرُ التَّبْعِيضِ
u'ضَرَرٌ تَحَمُّلٌ':Added, #1: 1	ضَرَرِ التَّبْعِيضِ
u'ضَرَرٌ تَرْكٌ':Added, #1: 1	ضَرَرِ تَحَمُّلِ
u'ضَرَرٌ تَرِكَةٌ':Added, #1: 1	ضَرَرِ تَرْكِ
u'ضَرَرٌ تَصَرُّفٌ':Added, #2: 2	ضَرَرُ تَرِكَتِهِ
u'ضَرَرٌ تَطْوِيلٌ':Added, #2: 2	ضَرَرُ تَصَرُّفِهِ
u'ضَرَرٌ تَطْوِيلٌ':Added, #1: 1	ضَرَرُ تَطْوِيلِ
u'ضَرَرٌ تَعْلِيقٌ':Added, #1: 1	ضَرَرِ تَطْوِيلِ
u'ضَرَرٌ تُهْمَةٌ':Added, #2: 2	ضَرَرِ التَّعْلِيقِ
u'ضَرَرٌ جَارٌ':Added, #1: 1	ضَرَرِ التُّهْمَةِ
u'ضَرَرٌ جَارٌ':Added, #1: 1	ضَرَرَ الْجَارِ
u'ضَرَرٌ جِدار':Added, #2: 2	ضَرَرِ الْجَارِ
u'ضَرَرٌ جَلِيٌّ':Added, #1: 1	ضَرَرِ الْجِدَارِ
u'ضَرَرٌ جماع':Added, #3: 3	ضَرَرٍ جَلِيٍّ
u'ضَرَرٌ جِمَاعٌ':Added, #2: 2	ضَرَرَ الْجِمَاعِ
u'ضَرَرٌ جهل':Added, #2: 2	ضَرَرَ الْجِمَاعِ
u'ضَرَرٌ جَهْلٌ':Added, #2: 2	ضَرَرِ الْجَهْلِ
u'ضَرَرٌ جِوَارٌ':Added, #2: 2	ضَرَرِ الْجَهْلِ
u'ضَرَرٌ جُوعٌ':Added, #5: 5	ضَرَرِ الْجِوَارِ
u'ضَرَرٌ جِيرَانٌ':Added, #1: 1	ضَرَرُ الْجُوعِ
u'ضَرَرٌ حاجَةٌ':Added, #1: 1	ضَرَرِ الْجِيرَانِ
u'ضَرَرٌ حاصِلٌ':Added, #1: 1	ضَرَرُ الْحَاجَةِ
u'ضَرَرٌ حَجْرٌ':Added, #2: 2	ضَرَرٍ حَاصِلٍ
u'ضَرَرٌ حَدَّادٌ':Added, #1: 1	ضَرَرَ الْحَجْرِ
u'ضَرَرٌ حَرِيقٌ':Added, #1: 1	ضَرَرُ الْحَدَّادِ
u'ضَرَرٌ حَلٌّ':Added, #1: 1	ضَرَرَ الْحَرِيقِ
u'ضَرَرٌ حَلٌّ':Added, #1: 1	ضَرَرَ الْحَلِّ
u'ضَرَرٌ حِلْيَةٌ':Added, #3: 3	ضَرَرِ الْحَلِّ
u'ضَرَرٌ حِنْطَةٌ':Added, #1: 1	ضَرَرِ الْحِلْيَةِ
u'ضَرَرٌ خاصّ':Added, #4: 4	ضَرَرِ الْحِنْطَةِ
u'ضَرَرٌ خَمْرٌ':Added, #7: 7	ضَرَرٍ خَاصٍّ
u'ضَرَرٌ خَمْرٌ':Added, #1: 1	ضَرَرُ الْخَمْرِ
u'ضَرَرٌ خَوْفٌ':Added, #1: 1	ضَرَرِ الْخَمْرِ
u'ضَرَرٌ دَابَّةٌ':Added, #3: 3	ضَرَرِ خَوْفِ
u'ضَرَرٌ دَائِنٌ':Added, #1: 1	ضَرَرِ دَابَّتِهِ
u'ضَرَرٌ دَائِنٌ':Added, #1: 1	ضَرَرَ الدَّائِنِ
u'ضَرَرٌ دَائِنٌ':Added, #1: 1	ضَرَرُ الدَّائِنِ
u'ضَرَرٌ دُخُولٌ':Added, #1: 1	ضَرَرِ الدَّائِنِ
u'ضَرَرٌ دَخِيلٌ':Added, #2: 2	ضَرَرِ دُخُولِهِ
u'ضَرَرٌ ذُرَةٌ':Added, #2: 2	ضَرَرِ الدَّخِيلِ
u'ضَرَرٌ رَدِيءٌ':Added, #2: 2	ضَرَرِ الذُّرَةِ
u'ضَرَرٌ زائِدٌ':Added, #1: 1	ضَرَرَ الرَّدِيءِ
u'ضَرَرٌ زَرْعٌ':Added, #12: 12	ضَرَرٍ زَائِدٍ
u'ضَرَرٌ سَارِقٌ':Added, #1: 1	ضَرَرِ زَرْعِ
u'ضَرَرٌ سَاكِنٌ':Added, #1: 1	ضَرَرِ السَّارِقِ
u'ضَرَرٌ سِحْرٌ':Added, #1: 1	ضَرَرَ السَّاكِنِ
u'ضَرَرٌ سَرْجٌ':Added, #1: 1	ضَرَرِ السِّحْرِ
u'ضَرَرٌ سُوءٌ':Added, #1: 1	ضَرَرَ السَّرْجِ
u'ضَرَرٌ سُوءٌ':Added, #1: 1	ضَرَرَ سُوءِ
u'ضَرَرٌ سَيِّدٌ':Added, #4: 4	ضَرَرِ سُوءِ
u'ضَرَرٌ سَيِّدٌ':Added, #1: 1	ضَرَرِ السَّيِّدِ
u'ضَرَرٌ شَجَرٌ':Added, #1: 1	ضَرَرَ سَيِّدِهِ
u'ضَرَرٌ شركة':Added, #1: 1	ضَرَرَ الشَّجَرِ
u'ضَرَرٌ شَرِكَةٌ':Added, #1: 1	ضَرَرَ الشَّرِكَةِ
u'ضَرَرٌ شركة':Added, #1: 1	ضَرَرَ الشَّرِكَةِ
u'ضَرَرٌ شَرِكَةٌ':Added, #3: 3	ضَرَرُ الشَّرِكَةِ
u'ضَرَرٌ شركة':Added, #3: 3	ضَرَرُ الشَّرِكَةِ
u'ضَرَرٌ شَرِكَةٌ':Added, #4: 4	ضَرَرِ الشَّرِكَةِ
u'ضَرَرٌ شَرِيكٌ':Added, #4: 4	ضَرَرِ الشَّرِكَةِ
u'ضَرَرٌ شَرِيكٌ':Added, #1: 1	ضَرَرُ شَرِيكِهِ
u'ضَرَرٌ شَعِيرٌ':Added, #1: 1	ضَرَرِ شَرِيكِهِ
u'ضَرَرٌ شَفِيعٌ':Added, #1: 1	ضَرَرَ الشَّعِيرِ
u'ضَرَرٌ شَيْءٌ':Added, #1: 1	ضَرَرَ الشَّفِيعِ
u'ضَرَرٌ صَاحِبٌ':Added, #1: 1	ضَرَرِ شَيْءٍ
u'ضَرَرٌ صَاحِبٌ':Added, #1: 1	ضَرَرَ صَاحِبِ
u'ضَرَرٌ صَاحِبٌ':Added, #1: 1	ضَرَرُ صَاحِبِ
u'ضَرَرٌ صَغِيرٌ':Added, #2: 2	ضَرَرِ صَاحِبِ
u'ضَرَرٌ صَوْتٌ':Added, #1: 1	ضَرَرِ الصَّغِيرِ
u'ضَرَرٌ صَوْتٌ':Added, #1: 1	ضَرَرِ الصَّوْتِ
u'ضَرَرٌ ضَمَانٌ':Added, #1: 1	ضَرَرِ صَوْتِ
u'ضَرَرٌ طلب':Added, #1: 1	ضَرَرَ الضَّمَانِ
u'ضَرَرٌ طَلَبٌ':Added, #1: 1	ضَرَرُ الطَّلَبِ
u'ضَرَرٌ ظاهِرٌ':Added, #1: 1	ضَرَرُ الطَّلَبِ
u'ضَرَرٌ عَارٌ':Added, #3: 3	ضَرَرٍ ظَاهِرٍ
u'ضَرَرٌ عَامٌّ':Added, #1: 1	ضَرَرِ الْعَارِ
u'ضَرَرٌ عَامٌّ':Added, #10: 10	ضَرَرٍ عَامٍّ
u'ضَرَرٌ عَدَمٌ':Added, #2: 2	ضَرَرِ الْعَامَّةِ
u'ضَرَرٌ عَظِيم':Added, #1: 1	ضَرَرُ عَدَمِ
u'ضَرَرٌ عُهْدَةٌ':Added, #3: 3	ضَرَرٍ عَظِيمٍ
u'ضَرَرٌ عَيْبٌ':Added, #1: 1	ضَرَرُ الْعُهْدَةِ
u'ضَرَرٌ عين':Added, #3: 3	ضَرَرُ عَيْبِ
u'ضَرَرٌ عَيْنٌ':Added, #1: 1	ضَرَرِ الْعَيْنِ
u'ضَرَرٌ عَيْن':Added, #1: 1	ضَرَرِ الْعَيْنِ
u'ضَرَرٌ غُرُورٌ':Added, #1: 1	ضَرَرِ الْعَيْنِ
u'ضَرَرٌ غير':Added, #1: 1	ضَرَرِ الْغُرُورِ
u'ضَرَرٌ غير':Added, #1: 1	ضَرَرَ الْغَيْرِ
u'ضَرَرٌ غَيْرٌ':Added, #1: 1	ضَرَرِ الْغَيْرِ
u'ضَرَرٌ غَيْرٌ':Added, #1: 1	ضَرَرَ الْغَيْرِ
u'ضَرَرٌ غير':Added, #1: 1	ضَرَرِ الْغَيْرِ
u'ضَرَرٌ غير':Added, #2: 2	ضَرَرَ غَيْرِهِ
u'ضَرَرٌ غَيْرٌ':Added, #2: 2	ضَرَرِ غَيْرِهِ
u'ضَرَرٌ غَيْرٌ':Added, #2: 2	ضَرَرَ غَيْرِهِ
u'ضَرَرٌ فِرَاقٌ':Added, #2: 2	ضَرَرِ غَيْرِهِ
u'ضَرَرٌ فساد':Added, #1: 1	ضَرَرَ الْفِرَاقِ
u'ضَرَرٌ فَسَادٌ':Added, #1: 1	ضَرَرُ الْفَسَادِ
u'ضَرَرٌ فَسْخٌ':Added, #1: 1	ضَرَرُ الْفَسَادِ
u'ضَرَرٌ فَسْخٌ':Added, #1: 1	ضَرَرِ الْفَسْخِ
u'ضَرَرٌ فِعْلٌ':Added, #1: 1	ضَرَرَ فَسْخِهِ
u'ضَرَرٌ فِعْلٌ':Added, #1: 1	ضَرَرِ فِعْلِ
u'ضَرَرٌ فَقْدٌ':Added, #1: 1	ضَرَرُ فِعْلِهِ
u'ضَرَرٌ فَقْدٌ':Added, #1: 1	ضَرَرَ فَقْدِهِ
u'ضَرَرٌ فَقْدٌ':Added, #1: 1	ضَرَرُ فَقْدِهِ
u'ضَرَرٌ قسمة':Added, #1: 1	ضَرَرِ فَقْدِهِ
u'ضَرَرٌ قِسْمَةٌ':Added, #2: 2	ضَرَرُ الْقِسْمَةِ
u'ضَرَرٌ قسمة':Added, #2: 2	ضَرَرُ الْقِسْمَةِ
u'ضَرَرٌ قِسْمَةٌ':Added, #3: 3	ضَرَرَ الْقِسْمَةِ
u'ضَرَرٌ قسمة':Added, #3: 3	ضَرَرَ الْقِسْمَةِ
u'ضَرَرٌ قِسْمَةٌ':Added, #4: 4	ضَرَرِ الْقِسْمَةِ
u'ضَرَرٌ قَطْعٌ':Added, #4: 4	ضَرَرِ الْقِسْمَةِ
u'ضَرَرٌ كَثْرَةٌ':Added, #1: 1	ضَرَرَ قَطْعِ
u'ضَرَرٌ كَسْرٌ':Added, #1: 1	ضَرَرُ كَثْرَةِ
u'ضَرَرٌ كُفَّارٌ':Added, #1: 1	ضَرَرُ الْكَسْرِ
u'ضَرَرٌ مَاءٌ':Added, #1: 1	ضَرَرَ الْكُفَّارِ
u'ضَرَرٌ مَارٌّ':Added, #1: 1	ضَرَرُ الْمَاءِ
u'ضَرَرٌ مَارٌّ':Added, #1: 1	ضَرَرُ الْمَارَّةِ
u'ضَرَرٌ مَارَّةٌ':Added, #1: 1	ضَرَرِ الْمَارَّةِ
u'ضَرَرٌ مَارَّةٌ':Added, #1: 1	ضَرَرُ الْمَارَّةِ
u'ضَرَرٌ مَالٌ':Added, #1: 1	ضَرَرِ الْمَارَّةِ
u'ضَرَرٌ مَالٌ':Added, #2: 2	ضَرَرَ الْمَالِ
u'ضَرَرٌ مَالِكٌ':Added, #3: 3	ضَرَرِ الْمَالِ
u'ضَرَرٌ مَالِكٌ':Added, #1: 1	ضَرَرَ الْمَالِكِ
u'ضَرَرٌ مُتَوَقَّعٌ':Added, #2: 2	ضَرَرِ الْمَالِكِ
u'ضَرَرٌ مَجْذُومٌ':Added, #1: 1	ضَرَرٍ مُتَوَقَّعٍ
u'ضَرَرٌ مُخَدَّرٌ':Added, #2: 2	ضَرَرِ الْمَجْذُومِ
u'ضَرَرٌ مُرْتَهِنٌ':Added, #1: 1	ضَرَرِ الْمُخَدَّرَةِ
u'ضَرَرٌ مَرَضٌ':Added, #1: 1	ضَرَرِ الْمُرْتَهِنِ
u'ضَرَرٌ مَرَضٌ':Added, #1: 1	ضَرَرُ الْمَرَضِ
u'ضَرَرٌ مُزَاحَمَةٌ':Added, #1: 1	ضَرَرِ الْمَرَضِ
u'ضَرَرٌ مُسْتَأْجِرٌ':Added, #1: 1	ضَرَرِ الْمُزَاحَمَةِ
u'ضَرَرٌ مُسْلِمٌ':Added, #1: 1	ضَرَرِ الْمُسْتَأْجِرِ
u'ضَرَرٌ مُشَارَكَةٌ':Added, #1: 1	ضَرَرِ الْمُسْلِمِ
u'ضَرَرٌ مَعِيبٌ':Added, #1: 1	ضَرَرِ الْمُشَارَكَةِ
u'ضَرَرٌ مِلْكٌ':Added, #1: 1	ضَرَرِ الْمَعِيبِ
u'ضَرَرٌ مِلْكٌ':Added, #1: 1	ضَرَرِ الْمِلْكِ
u'ضَرَرٌ مَنْعٌ':Added, #2: 2	ضَرَرِ مِلْكِ
u'ضَرَرٌ مُنْكَرٌ':Added, #1: 1	ضَرَرِ مَنْعِ
u'ضَرَرٌ مُنْهَزِمٌ':Added, #1: 1	ضَرَرِ الْمُنْكَرِ
u'ضَرَرٌ مُوجِبٌ':Added, #1: 1	ضَرَرِ الْمُنْهَزِمِ
u'ضَرَرٌ مُؤْذِي':Added, #1: 1	ضَرَرِ مُوجِبِ
u'ضَرَرٌ مَيَازِيبُ':Added, #1: 1	ضَرَرِ الْمُؤْذِيَاتِ
u'ضَرَرٌ نَادِرٌ':Added, #1: 1	ضَرَرَ الْمَيَازِيبِ
u'ضَرَرٌ ناذِر':Added, #1: 1	ضَرَرٍ نَادِرٍ
u'ضَرَرٌ نَاسٌ':Added, #1: 1	ضَرَرُ النَّاذِرِ
u'ضَرَرٌ نَاسٌ':Added, #1: 1	ضَرَرِ النَّاسِ
u'ضَرَرٌ نَفْسٌ':Added, #2: 2	ضَرَرُ النَّاسِ
u'ضَرَرٌ نَفْسٌ':Added, #1: 1	ضَرَرِ النَّفْسِ
u'ضَرَرٌ نَقْصٌ':Added, #4: 4	ضَرَرَ نَفْسِهِ
u'ضَرَرٌ نَقْصٌ':Added, #1: 1	ضَرَرِ النَّقْصِ
u'ضَرَرٌ نُقْصَانٌ':Added, #1: 1	ضَرَرُ نَقْصِ
u'ضَرَرٌ هَدْمٌ':Added, #1: 1	ضَرَرُ نُقْصَانِ
u'ضَرَرٌ وَحْشَةٌ':Added, #1: 1	ضَرَرُ هَدْمِ
u'ضَرَرٌ وِصَايَةٌ':Added, #2: 2	ضَرَرُ الْوَحْشَةِ
u'ضَرَرٌ وَصِيٌّ':Added, #1: 1	ضَرَرُ الْوِصَايَةِ
u'ضَرَرٌ وَصِيَّةٌ':Added, #1: 1	ضَرَرَ الْوَصِيَّةِ
u'ضَرَرٌ وَقْفٌ':Added, #1: 1	ضَرَرَ الْوَصِيَّةِ
u'ضَرَرٌ وُقُوعٌ':Added, #1: 1	ضَرَرِ الْوَقْفِ
u'ضَرَرٌ ولد':Added, #1: 1	ضَرَرَ وُقُوعِ
u'ضَرَرٌ وَلَدٌ':Added, #1: 1	ضَرَرُ الْوَلَدِ
u'ضَرَرٌ ولد':Added, #1: 1	ضَرَرُ الْوَلَدِ
u'ضَرَرٌ وَلَدٌ':Added, #1: 1	ضَرَرَ وَلَدِهِ
u'ضَرَرٌ يَتِيمٌ':Added, #1: 1	ضَرَرَ وَلَدِهِ
u'ضَرَّ سَقْيٌ':Subject, #1: 1	ضَرَرَ الْيَتِيمِ
u'ضَرَّ صَاحِبٌ':Predicate, #2: 2	ضَرَّ السَّقْيُ
u'ضرع بَهيمٌ':Added, #1: 1	ضَرَّ صَاحِبَ
u'ضَرْعٌ بَهيمٌ':Added, #1: 1	ضَرْعِ بَهِيمَةِ
u'ضرع بَهِيمَةٌ':Added, #1: 1	ضَرْعِ بَهِيمَةِ
u'ضرع بَهِيمَةٌ':Added, #1: 1	ضَرْعِ بَهِيمَةٍ
u'ضَرْعٌ بَهِيمَةٌ':Added, #1: 1	ضَرْعِ بَهِيمَةِ
u'ضَرْعٌ بَهِيمَةٌ':Added, #1: 1	ضَرْعِ بَهِيمَةٍ
u'ضَرَعَ سَائِلٌ':Predicate, #1: 1	ضَرْعِ بَهِيمَةِ
u'ضرع شَاةٌ':Added, #1: 1	ضَرَعَ السَّائِلِينَ
u'ضرع شَاةٌ':Added, #1: 1	ضَرْعَ الشَّاةِ
u'ضَرْعٌ شَاةٌ':Added, #1: 1	ضَرْعِ الشَّاةِ
u'ضَرْعٌ شَاةٌ':Added, #1: 1	ضَرْعَ الشَّاةِ
u'ضَرْعٌ عَظِيم':Added, #1: 1	ضَرْعِ الشَّاةِ
u'ضرع غَنَمٌ':Added, #1: 1	ضَرْعٍ عَظِيمٍ
u'ضَرْعٌ غَنَمٌ':Added, #1: 1	ضَرْعَ الْغَنَمِ
u'ضرع غير':Added, #1: 1	ضَرْعَ الْغَنَمِ
u'ضرع غَيْرٌ':Added, #1: 1	ضَرْعَ غَيْرِ
u'ضَرْعٌ غير':Added, #1: 1	ضَرْعَ غَيْرِ
u'ضَرْعٌ غَيْرٌ':Added, #1: 1	ضَرْعَ غَيْرِ
u'ضرع نَاقَةٌ':Added, #1: 1	ضَرْعَ غَيْرِ
u'ضرع نَاقَة':Added, #1: 1	ضَرْعِ النّاقَةِ
u'ضَرْعٌ نَاقَةٌ':Added, #1: 1	ضَرْعِ النّاقَةِ
u'ضَرْعٌ نَاقَة':Added, #1: 1	ضَرْعِ النّاقَةِ
u'ضَرَّ فلان':Predicate, #1: 1	ضَرْعِ النّاقَةِ
u'ضَرَّ قَالٌ':Predicate, #1: 1	ضَرَّ عُثْمَانَ
u'ضُرُوبٌ أَيْمَانٌ':Added, #1: 1	ضَرَّ قَالَ
u'ضُرُوبٌ بِدَعٌ':Added, #1: 1	ضُرُوبِ الْأَيْمَانِ
u'ضُرُوبٌ تَوْبَةٌ':Added, #2: 2	ضُرُوبِ الْبِدَعِ
u'ضُرُوبٌ جَلِيٌّ':Added, #1: 1	ضُرُوبِ التَّوْبَةِ
u'ضُرُوبٌ خَفِيٌّ':Added, #1: 1	ضُرُوبِ الْجَلِيِّ
u'ضُرُوبٌ رحمة':Added, #1: 1	ضُرُوبِ الْخَفِيِّ
u'ضُرُوبٌ رَحْمَةٌ':Added, #1: 1	ضُرُوبِ الرَّحْمَةِ
u'ضُرُوبٌ سِدْرٌ':Added, #1: 1	ضُرُوبِ الرَّحْمَةِ
u'ضُرُوبٌ شَكْلٌ':Added, #1: 1	ضُرُوبَ السّدْرِ
u'ضُرُوبٌ عَقْلٌ':Added, #2: 2	ضُرُوبِ الشَّكْلِ
u'ضُرُوبٌ لعب':Added, #1: 1	ضُرُوبِ الْعَقْلِ
u'ضُرُوبٌ لَعِبٌ':Added, #1: 1	ضُرُوبِ اللَّعِبِ
u'ضروع إِبِلٌ':Added, #1: 1	ضُرُوبِ اللَّعِبِ
u'ضُرُوعٌ إِبِلٌ':Added, #1: 1	ضُرُوعِ الإِبِلِ
u'ضروع غَنَمٌ':Added, #1: 1	ضُرُوعِ الإِبِلِ
u'ضروع غَنَمٌ':Added, #1: 1	ضُرُوعَ الْغَنَمِ
u'ضُرُوعٌ غَنَمٌ':Added, #1: 1	ضُرُوعِ الْغَنَمِ
u'ضُرُوعٌ غَنَمٌ':Added, #1: 1	ضُرُوعَ الْغَنَمِ
u'ضروع غَنَمٌ':Added, #1: 1	ضُرُوعِ الْغَنَمِ
u'ضُرُوعٌ غَنَمٌ':Added, #1: 1	ضُرُوعِ غَنَمِهِ
u'ضروع مَاشِي':Added, #1: 1	ضُرُوعِ غَنَمِهِ
u'ضُرُوعٌ مَاشِي':Added, #1: 1	ضُرُوعِ الْمَاشِيَةِ
u'ضروع مَاشِيَةٌ':Added, #1: 1	ضُرُوعِ الْمَاشِيَةِ
u'ضُرُوعٌ مَاشِيَةٌ':Added, #1: 1	ضُرُوعِ الْمَاشِيَةِ
u'ضروع مَيْتٌ':Added, #1: 1	ضُرُوعِ الْمَاشِيَةِ
u'ضُرُوعٌ مَيْتٌ':Added, #1: 1	ضُرُوعِ الْمَيْتَةِ
u'ضروع مَيْتَةٌ':Added, #1: 1	ضُرُوعِ الْمَيْتَةِ
u'ضُرُوعٌ مَيْتَةٌ':Added, #1: 1	ضُرُوعِ الْمَيْتَةِ
u'ضَعَّفَ اِبْنٌ':Subject, #1: 1	ضُرُوعِ الْمَيْتَةِ
u'ضَعُفَ أثَرٌ':Subject, #2: 2	ضَعَّفَ ابْنُ
u'ضَعَّفَ أَحادِيثُ':Predicate, #7: 7	ضَعُفَ أَثَرُهُ
u'ضَعُفَ اِحْتِمَالٌ':Subject, #3: 3	ضَعَّفَ الْأَحَادِيثَ
u'ضَعَفَ اِزْداد':Predicate, #1: 1	ضَعُفَ احْتِمَالُ
u'ضَعُفَ إِسْنادٌ':Subject, #1: 1	أَضْعَفَ ازْدَادَ
u'ضَعُفَ أصل':Subject, #2: 2	ضَعُفَ إسْنَادُ
u'ضَعُفَ أًصْلٌ':Subject, #1: 1	ضَعُفَ أَصْلُ
u'ضَعُفَ إمَامٌ':Subject, #1: 1	ضَعُفَ أَصْلُ
u'ضَعَّفَ إمَامٌ':Subject, #1: 1	ضَعُفَ الْإِمَامُ
u'ضَعَّفَ أَمْرٌ':Predicate, #2: 2	ضَعَّفَ الْإِمَامُ
u'ضَعُفَ أَمْرٌ':Subject, #1: 1	ضَعَّفَ أَمْرَ
u'ضَعُفَ أَمْرٌ':Subject, #1: 1	ضَعُفَ الْأَمْرُ
u'ضَعَّفَ أهْلٌ':Subject, #1: 1	ضَعُفَ أَمْرُ
u'ضَعُفَ أهْلٌ':Subject, #1: 1	ضَعَّفَ أَهْلُ
u'ضَعَّفَ أَوَّلُ':Predicate, #2: 2	ضَعُفَ أَهْلُ
u'ضَعُفَ بَصَرٌ':Subject, #2: 2	ضَعَّفَ الْأَوَّلَ
u'ضَعُفَ بِنَاءٌ':Subject, #1: 1	ضَعُفَ بَصَرُهُ
u'ضَعَّفَ ثَالِثٌ':Predicate, #2: 2	ضَعُفَ الْبِنَاءُ
u'ضَعَّفَ جُمْهُورٌ':Subject, #1: 1	ضَعَّفَ الثَّالِثَ
u'ضَعَّفَ حَديثٌ':Predicate, #1: 1	ضَعَّفَ الْجُمْهُورُ
u'ضَعَّفَ حَديثٌ':Predicate, #1: 1	ضَعَّفَ الْحَدِيثَ
u'ضَعُفَ حِسٌّ':Subject, #2: 2	ضَعَّفَ حَدِيثَ
u'ضَعُفَ خِلاَفٌ':Subject, #2: 2	ضَعُفَ الْحِسُّ
u'ضَعُفَ دَيْنٌ':Subject, #3: 3	ضَعُفَ الْخِلَافُ
u'ضَعُفَ رَقيقٌ':Subject, #1: 1	ضَعُفَ دَيْنُهُ
u'ضَعُفَ رَقيق':Subject, #1: 1	ضَعُفَ الرَّقِيقُ
u'ضَعَّفَ صَاحِبٌ':Subject, #1: 1	ضَعُفَ الرَّقِيقُ
u'ضَعَفَ صدقة':Predicate, #1: 1	ضَعَّفَ صَاحِبُ
u'ضَعَفَ صَدَقَةٌ':Predicate, #1: 1	أَضْعَفَ الصَّدَقَةَ
u'ضَعُفَ ظَنٌّ':Subject, #1: 1	أَضْعَفَ الصَّدَقَةَ
u'ضَعُفَ عَصَبٌ':Subject, #1: 1	ضَعُفَ الظَّنُّ
u'ضَعَّفَ عَمَلٌ':Predicate, #1: 1	ضَعُفَ عَصَبُهُ
u'ضَعَفَ غَرَامَةٌ':Predicate, #1: 1	ضَعَّفَ الْعَمَلَ
u'ضَعَفَ قُوَّةٌ':Predicate, #1: 1	أَضْعَفَ الْغَرَامَةَ
u'ضَعَفَ قُوَّة':Predicate, #1: 1	أَضْعَفَ قُوَّةَ
u'ضَعُفَ قول':Subject, #1: 1	أَضْعَفَ قُوَّةَ
u'ضَعُفَ قَوْلٌ':Subject, #1: 1	ضَعُفَ الْقَوْلُ
u'ضَعُفَ قول':Subject, #1: 1	ضَعُفَ الْقَوْلُ
u'ضَعُفَ قَوْلٌ':Subject, #1: 1	ضَعُفَ قَوْلُ
u'ضَعَّفَ كَلاَمٌ':Predicate, #1: 1	ضَعُفَ قَوْلُ
u'ضَعُفَ كَلاَمٌ':Subject, #1: 1	ضَعَّفَ كَلَامَ
u'ضَعَّفَ مُحَمَّدٌ':Subject, #1: 1	ضَعُفَ كَلَامُ
u'ضَعُفَ مُلْحَقٌ':Subject, #1: 1	ضَعَّفَ مُحَمَّدٌ
u'ضَعُفَ مِلْكٌ':Subject, #1: 1	ضَعُفَ مُلْحَقٌ
u'ضَعُفَ مِلْكٌ':Subject, #1: 1	ضَعُفَ الْمِلْكُ
u'ضَعُفَ مَنْصُوبٌ':Subject, #1: 1	ضَعُفَ مِلْكُهُ
u'ضَعَّفَ نَوَوِيٌّ':Subject, #1: 1	ضَعُفَ مَنْصُوبُ
u'ضَعُفَ هضم':Subject, #1: 1	ضَعَّفَ النَّوَوِيُّ
u'ضَعُفَ هَضْمٌ':Subject, #1: 1	ضَعُفَ الْهَضْمُ
u'ضَغْطٌ بيض':Added, #1: 1	ضَعُفَ الْهَضْمُ
u'ضَفْرٌ رَجُلٌ':Added, #1: 1	ضَغْطَ الْبَيْضِ
u'ضَلَّ أَصْحَابٌ':Subject, #1: 1	ضَفْرُ رَجُلٍ
u'ضَلَّ أصل':Subject, #1: 1	ضَلَّ أَصْحَابُ
u'ضَلَّ أًصْلٌ':Subject, #1: 1	ضَلَّ أَصْلُهُ
u'ضَلَّ أَكْثَرُ':Subject, #1: 1	ضَلَّ أَصْلُهُ
u'ضَلاَلَةٌ عَمَلٌ':Added, #1: 1	ضَلَّ أَكْثَرُ
u'ضَلَّ أهْلٌ':Subject, #1: 1	ضَلاَلَةَ الْعَمَلِ
u'ضَلَّ خلق':Predicate, #1: 1	ضَلَّ أَهْلُ
u'ضَلَّ رَاحِلٌ':Subject, #1: 1	أَضَلَّ خَلَقَ
u'ضَلَّ رَاحِلَةٌ':Subject, #1: 1	ضَلَّ رَاحِلَتُهُ
u'ضَلَّ رَجُلٌ':Subject, #1: 1	ضَلَّ رَاحِلَتُهُ
u'ضَلَّ رَحْلٌ':Subject, #2: 2	ضَلَّ رَجُلٌ
u'ضَلَّ سَعْدٌ':Subject, #3: 3	ضَلَّ رَحْلُهُ
u'ضَلَّ سَواءٌ':Predicate, #1: 1	أَضَلَّ سَعْدُ
u'ضَلَّ شكر':Subject, #2: 2	ضَلَّ سَوَاءَ
u'ضَلَّ شُكْرٌ':Subject, #1: 1	ضَلَّ شُكْرُهُ
u'ضَلَّ صَاحِبٌ':Subject, #1: 1	ضَلَّ شُكْرُهُ
u'ضَلَّ طَرِيقٌ':Predicate, #1: 1	ضَلَّ صَاحِبُهُ
u'ضَلَّ طَرِيقٌ':Predicate, #1: 1	ضَلَّ طَرِيقَ
u'ضَلَّ عِقْدٌ':Subject, #8: 8	ضَلَّ الطَّرِيقَ
u'ضَلَّ قَوْمٌ':Subject, #1: 1	ضَلَّ عِقْدٌ
u'ضَلَّلَ أُمَّةٌ':Predicate, #7: 7	ضَلَّ قَوْمٌ
u'ضَلَّ مُقَاطِعٌ':Subject, #1: 1	ضَلَّلَ الْأُمَّةَ
u'ضَلَّ مَوْضِعٌ':Subject, #1: 1	ضَلَّ الْمُقَاطِعُ
u'ضَلَّ نَاقَةٌ':Predicate, #1: 1	ضَلَّ مَوْضِعُ
u'ضَلَّ نَاقَة':Predicate, #1: 1	أَضَلَّ النَّاقَةَ
u'ضَلَّ هَدْيٌ':Subject, #1: 1	أَضَلَّ النَّاقَةَ
u'ضَلَّ واحد':Subject, #1: 1	ضَلَّ هَدْيُهُ
u'ضَلَّ وَاحِدٌ':Subject, #1: 1	ضَلَّ وَاحِدٌ
u'ضَمَّ أُجْرَةٌ':Predicate, #1: 1	ضَلَّ وَاحِدٌ
u'ضَمَّ أحَدٌ':Predicate, #1: 1	ضَمَّ أُجْرَةَ
u'ضَمَّ أَطْرافٌ':Predicate, #1: 1	ضَمَّ أَحَدَ
u'ضَمَّ أَطْرَافٌ':Predicate, #1: 1	ضَمَّ أَطْرَافَ
u'ضَمَانٌ أَبٌ':Added, #1: 1	ضَمَّ أَطْرَافَ
u'ضَمَانٌ إِتْلاَفٌ':Added, #1: 1	ضَمَانَ الْأَبِ
u'ضَمَانٌ إِتْلاَفٌ':Added, #1: 1	ضَمَانَ إتْلَافِ
u'ضَمَانٌ إِتْلاَفٌ':Added, #1: 1	ضَمَانُ إتْلَافِ
u'ضَمَانٌ إِتْلاَفٌ':Added, #1: 1	ضَمَانِ إتْلَافِ
u'ضَمَانٌ إِتْلاَفٌ':Added, #2: 2	ضَمَانَ الْإِتْلَافِ
u'ضَمَانٌ إِتْلاَفٌ':Added, #2: 2	ضَمَانُ الْإِتْلَافِ
u'ضَمَانٌ إِتْلاَفٌ':Added, #3: 3	ضَمَانِ الْإِتْلَافِ
u'ضَمَانٌ إِتْلاَفٌ':Added, #4: 4	ضَمَانَ إتْلَافٍ
u'ضَمَانٌ أجراء':Added, #7: 7	ضَمَانُ إتْلَافٍ
u'ضَمَانٌ أُجْرَةٌ':Added, #1: 1	ضَمَانِ الْأُجَرَاءِ
u'ضَمَانٌ أُجْرَةٌ':Added, #1: 1	ضَمَانَ أُجْرَةِ
u'ضَمَانٌ أُجْرَةٌ':Added, #1: 1	ضَمَانِ أُجْرَتِهِ
u'ضَمَانٌ أُجْرَةٌ':Added, #1: 1	ضَمَانِ الْأُجْرَةِ
u'ضَمَانٌ أَجْزَاءٌ':Added, #2: 2	ضَمَانُ الْأُجْرَةِ
u'ضَمَانٌ أَجْنَبِيٌّ':Added, #1: 1	ضَمَانُ الْأَجْزَاءِ
u'ضَمَانٌ أَجْنَبِيٌّ':Added, #1: 1	ضَمَانَ الْأَجْنَبِيِّ
u'ضَمَانٌ أَجِيرٌ':Added, #2: 2	ضَمَانِ الْأَجْنَبِيِّ
u'ضَمَانٌ أَجِيرٌ':Added, #2: 2	ضَمَانُ الْأَجِيرِ
u'ضَمَانٌ أحَدٌ':Added, #6: 6	ضَمَانِ الْأَجِيرِ
u'ضَمَانٌ أحَدٌ':Added, #1: 1	ضَمَانِ أَحَدٍ
u'ضَمَانٌ إحْضَارٌ':Added, #1: 1	ضَمَانِ أَحَدِ
u'ضَمَانٌ إحْضَارٌ':Added, #1: 1	ضَمَانَ إحْضَارِ
u'ضَمَانٌ أَخٌ':Added, #1: 1	ضَمَانُ الْإِحْضَارِ
u'ضَمَانٌ أخرَس':Added, #1: 1	ضَمَانِ الْأَخِ
u'ضَمَانٌ أَخِيرٌ':Added, #1: 1	ضَمَانُ الْأَخْرَسِ
u'ضَمَانٌ آدَمِيٌّ':Added, #2: 2	ضَمَانِ الْأَخِيرِ
u'ضَمَانٌ آدَمِيٌّ':Added, #1: 1	ضَمَانَ الْآدَمِيَّةِ
u'ضَمَانٌ اِسْتِهْلاكٌ':Added, #4: 4	ضَمَانُ الْآدَمِيِّ
u'ضَمَانٌ اِسْتيفاءٌ':Added, #1: 1	ضَمَانُ اسْتِهْلَاكٍ
u'ضَمَانٌ أَسْفَلُ':Added, #1: 1	ضَمَانُ اسْتِيفَاءِ
u'ضَمَانٌ اِشْتِراكٌ':Added, #1: 1	ضَمَانُ الْأَسْفَلِ
u'ضَمَانٌ اِشْتِراكٌ':Added, #1: 1	ضَمَانُ اشْتِرَاكٍ
u'ضَمَانٌ أَصابِعُ':Added, #2: 2	ضَمَانَ اشْتِرَاكٍ
u'ضَمَانٌ أَصابِعُ':Added, #1: 1	ضَمَانَ الْأَصَابِعِ
u'ضَمَانٌ أَصالَةٌ':Added, #1: 1	ضَمَانُ الْأَصَابِعِ
u'ضَمَانٌ إِصْبَعٌ':Added, #1: 1	ضَمَانُ أَصَالَةٍ
u'ضَمَانٌ أصل':Added, #1: 1	ضَمَانُ الْإِصْبَعِ
u'ضَمَانٌ أًصْلٌ':Added, #1: 1	ضَمَانِ أَصْلِهِ
u'ضَمَانٌ أصل':Added, #1: 1	ضَمَانِ أَصْلِهِ
u'ضَمَانٌ أًصْلٌ':Added, #1: 1	ضَمَانُ الْأَصْلِ
u'ضَمَانٌ أصل':Added, #1: 1	ضَمَانُ الْأَصْلِ
u'ضَمَانٌ أًصْلٌ':Added, #3: 3	ضَمَانِ الْأَصْلِ
u'ضَمَانٌ أَصيلٌ':Added, #3: 3	ضَمَانِ الْأَصْلِ
u'ضَمَانٌ أَطْرافٌ':Added, #1: 1	ضَمَانِ الْأَصِيلِ
u'ضَمَانٌ أَطْرَافٌ':Added, #1: 1	ضَمَانَ أَطْرَافِ
u'ضَمَانٌ أَطْرافٌ':Added, #1: 1	ضَمَانَ أَطْرَافِ
u'ضَمَانٌ أَطْرَافٌ':Added, #2: 2	ضَمَانُ أَطْرَافِهِ
u'ضَمَانٌ إِعْتاقٌ':Added, #2: 2	ضَمَانُ أَطْرَافِهِ
u'ضَمَانٌ إِعْتاقٌ':Added, #1: 1	ضَمَانَ الْإِعْتَاقِ
u'ضَمَانٌ إِعْتاقٌ':Added, #3: 3	ضَمَانُ الْإِعْتَاقِ
u'ضَمَانٌ إِعْتاقٌ':Added, #4: 4	ضَمَانِ الْإِعْتَاقِ
u'ضَمَانٌ إفْسَادٌ':Added, #6: 6	ضَمَانُ إعْتَاقٍ
u'ضَمَانٌ إفْسَادٌ':Added, #1: 1	ضَمَانَ إفْسَادٍ
u'ضَمَانٌ أَكْثَرُ':Added, #3: 3	ضَمَانُ إفْسَادٍ
u'ضَمَانٌ اِلْتِزَامٌ':Added, #2: 2	ضَمَانُ أَكْثَرِ
u'ضَمَانٌ ألف':Added, #1: 1	ضَمَانِ الْتِزَامِ
u'ضَمَانٌ ألف':Added, #1: 1	ضَمَانُ الْأَلْفِ
u'ضَمَانٌ ألْفٌ':Added, #1: 1	ضَمَانِ الْأَلْفِ
u'ضَمَانٌ ألْفٌ':Added, #1: 1	ضَمَانُ الْأَلْفِ
u'ضَمَانٌ أَلْفٌ':Added, #1: 1	ضَمَانِ الْأَلْفِ
u'ضَمَانٌ أَلْفٌ':Added, #1: 1	ضَمَانُ الْأَلْفِ
u'ضَمَانٌ الْمَرْأَةُ':Added, #1: 1	ضَمَانِ الْأَلْفِ
u'ضَمَانٌ أُمٌّ':Added, #1: 1	ضَمَانِ الْمَرْأَةِ
u'ضَمَانٌ أمَانٌ':Added, #1: 1	ضَمَانَ أُمِّ
u'ضَمَانٌ أمَانَةٌ':Added, #2: 2	ضَمَانُ الْأَمَانَاتِ
u'ضَمَانٌ آمِرٌ':Added, #2: 2	ضَمَانُ الْأَمَانَاتِ
u'ضَمَانٌ أَمْوَالٌ':Added, #2: 2	ضَمَانِ الْآمِرِ
u'ضَمَانٌ أَمْوَالٌ':Added, #1: 1	ضَمَانُ الْأَمْوَالِ
u'ضَمَانٌ أَمْوَالٌ':Added, #1: 1	ضَمَانُ أَمْوَالٍ
u'ضَمَانٌ أَمْوَالٌ':Added, #3: 3	ضَمَانَ الْأَمْوَالِ
u'ضَمَانٌ أَنْفُسٌ':Added, #5: 5	ضَمَانِ الْأَمْوَالِ
u'ضَمَانٌ أَوَّلُ':Added, #1: 1	ضَمَانِ الْأَنْفُسِ
u'ضَمَانٌ باذِلٌ':Added, #1: 1	ضَمَانُ الْأَوَّلِ
u'ضَمَانٌ بَائِعٌ':Added, #1: 1	ضَمَانِ بَاذِلِهِ
u'ضَمَانٌ بَائِعٌ':Added, #1: 1	ضَمَانَ الْبَائِعِ
u'ضَمَانٌ بَائِعٌ':Added, #1: 1	ضَمَانِ بَائِعِ
u'ضَمَانٌ بَائِعٌ':Added, #2: 2	ضَمَانِ بَائِعِهِ
u'ضَمَانٌ بَدَلٌ':Added, #44: 44	ضَمَانِ الْبَائِعِ
u'ضَمَانٌ بَذْرٌ':Added, #1: 1	ضَمَانِ الْبَدَلِ
u'ضَمَانٌ بَعْضٌ':Added, #1: 1	ضَمَانُ الْبَذْرِ
u'ضَمَانٌ بَقِيَّةٌ':Added, #1: 1	ضَمَانُ بَعْضِ
u'ضَمَانٌ بَقِيَّةٌ':Added, #1: 1	ضَمَانَ بَقِيَّةِ
u'ضَمَانٌ بِنَاءٌ':Added, #1: 1	ضَمَانِ بَقِيَّةِ
u'ضَمَانٌ بَهيمٌ':Added, #1: 1	ضَمَانَ الْبِنَاءِ
u'ضَمَانٌ بَهيمٌ':Added, #1: 1	ضَمَانِ الْبَهِيمَةِ
u'ضَمَانٌ بَهِيمَةٌ':Added, #2: 2	ضَمَانُ الْبَهِيمَةِ
u'ضَمَانٌ بَهِيمَةٌ':Added, #1: 1	ضَمَانِ الْبَهِيمَةِ
u'ضَمَانٌ بيض':Added, #2: 2	ضَمَانُ الْبَهِيمَةِ
u'ضَمَانٌ بيض':Added, #1: 1	ضَمَانَ الْبَيْضِ
u'ضَمَانٌ بَيْعٌ':Added, #1: 1	ضَمَانُ الْبَيْضِ
u'ضَمَانٌ بَيْعٌ':Added, #1: 1	ضَمَانَ الْبَيْعِ
u'ضَمَانٌ تالِف':Added, #2: 2	ضَمَانِ الْبَيْعِ
u'ضَمَانٌ تِجَارَةٌ':Added, #2: 2	ضَمَانُ التَّالِفِ
u'ضَمَانٌ تِجَارَةٌ':Added, #1: 1	ضَمَانَ تِجَارَةٍ
u'ضَمَانٌ تِجَارَةٌ':Added, #2: 2	ضَمَانُ تِجَارَةٍ
u'ضَمَانٌ تِجَارَةٌ':Added, #3: 3	ضَمَانَ التِّجَارَةِ
u'ضَمَانٌ تَدْبِيرٌ':Added, #6: 6	ضَمَانِ التِّجَارَةِ
u'ضَمَانٌ تَدْبِيرٌ':Added, #1: 1	ضَمَانَ التَّدْبِيرِ
u'ضَمَانٌ تَرْكٌ':Added, #2: 2	ضَمَانِ تَدْبِيرِ
u'ضَمَانٌ تَرِكَةٌ':Added, #2: 2	ضَمَانُ تَرْكِ
u'ضَمَانٌ تَسَبُّبٌ':Added, #1: 1	ضَمَانِ التَّرِكَةِ
u'ضَمَانٌ تِسْعَةٌ':Added, #1: 1	ضَمَانُ التَّسَبُّبِ
u'ضَمَانٌ تَسْلِيمٌ':Added, #1: 1	ضَمَانِ التِّسْعَةِ
u'ضَمَانٌ تَسْلِيمٌ':Added, #1: 1	ضَمَانُ تَسْلِيمِ
u'ضَمَانٌ تَفْوِيت':Added, #1: 1	ضَمَانِ تَسْلِيمِ
u'ضَمَانٌ تَفْوِيت':Added, #1: 1	ضَمَانُ تَفْوِيتِ
u'ضَمَانٌ تَلَف':Added, #1: 1	ضَمَانِ تَفْوِيتِ
u'ضَمَانٌ تَلَفٌ':Added, #1: 1	ضَمَانُ التَّلَفِ
u'ضَمَانٌ تَمَلُّكٌ':Added, #2: 2	ضَمَانُ تَلَفٍ
u'ضَمَانٌ تَمَلُّك':Added, #14: 14	ضَمَانُ تَمَلُّكٍ
u'ضَمَانٌ تَمَلُّكٌ':Added, #1: 1	ضَمَانَ التَّمَلُّكِ
u'ضَمَانٌ تَمَلُّك':Added, #3: 3	ضَمَانَ تَمَلُّكٍ
u'ضَمَانٌ تَمْلِيكٌ':Added, #6: 6	ضَمَانُ التَّمَلُّكِ
u'ضَمَانٌ ثَابِتٌ':Added, #1: 1	ضَمَانُ تَمْلِيكٍ
u'ضَمَانٌ ثَلاثَةٌ':Added, #1: 1	ضَمَانٍ ثَابِتٍ
u'ضَمَانٌ ثَمَنٌ':Added, #1: 1	ضَمَانُ ثَلَاثَةِ
u'ضَمَانٌ ثَمَنٌ':Added, #12: 12	ضَمَانُ الثَّمَنِ
u'ضَمَانٌ ثَمَنٌ':Added, #1: 1	ضَمَانَ الثَّمَنِ
u'ضَمَانٌ ثَمَنٌ':Added, #1: 1	ضَمَانِ الثَّمَنِ
u'ضَمَانٌ ثَمَنٌ':Added, #1: 1	ضَمَانَ ثَمَنٍ
u'ضَمَانٌ ثَمَنٌ':Added, #1: 1	ضَمَانُ ثَمَنٍ
u'ضَمَانٌ ثَوْبٌ':Added, #1: 1	ضَمَانُ ثَمَنِ
u'ضَمَانٌ ثِيابٌ':Added, #1: 1	ضَمَانُ ثَوْبِهِ
u'ضَمَانٌ ثِيابٌ':Added, #1: 1	ضَمَانُ ثِيَابٍ
u'ضَمَانٌ ثِيابٌ':Added, #1: 1	ضَمَانُ ثِيَابِهِ
u'ضَمَانٌ جَارِي':Added, #2: 2	ضَمَانُ الثِّيَابِ
u'ضَمَانٌ جَارِيَةٌ':Added, #1: 1	ضَمَانِ جَارِيَةٍ
u'ضَمَانٌ جَائِحٌ':Added, #1: 1	ضَمَانِ جَارِيَةٍ
u'ضَمَانٌ جاَئِحَةٌ':Added, #1: 1	ضَمَانَ الْجَائِحَةِ
u'ضَمَانٌ جِبَايَةٌ':Added, #1: 1	ضَمَانَ الْجَائِحَةِ
u'ضَمَانٌ جَبْرٌ':Added, #1: 1	ضَمَانَ الْجِبَايَاتِ
u'ضَمَانٌ جُرْحٌ':Added, #1: 1	ضَمَانُ جَبْرٍ
u'ضَمَانٌ جُزْءٌ':Added, #3: 3	ضَمَانُ الْجُرْحِ
u'ضَمَانٌ جُزْءٌ':Added, #1: 1	ضَمَانُ الْجُزْءِ
u'ضَمَانٌ جَزَاءٌ':Added, #1: 1	ضَمَانُ جُزْءٍ
u'ضَمَانٌ جِزْيَةٌ':Added, #1: 1	ضَمَانِ الْجَزَاءِ
u'ضَمَانٌ جُمْلَةٌ':Added, #1: 1	ضَمَانِ الْجِزْيَةِ
u'ضَمَانٌ جَمِيع':Added, #1: 1	ضَمَانِ الْجُمْلَةِ
u'ضَمَانٌ جَمِيع':Added, #1: 1	ضَمَانُ الْجَمِيعِ
u'ضَمَانٌ جِنَايَةٌ':Added, #2: 2	ضَمَانَ الْجَمِيعِ
u'ضَمَانٌ جِنَايَةٌ':Added, #11: 11	ضَمَانِ الْجِنَايَةِ
u'ضَمَانٌ جِنَايَةٌ':Added, #17: 17	ضَمَانُ جِنَايَةٍ
u'ضَمَانٌ جِنَايَةٌ':Added, #1: 1	ضَمَانِ جِنَايَةِ
u'ضَمَانٌ جِنَايَةٌ':Added, #2: 2	ضَمَانُ جِنَايَةِ
u'ضَمَانٌ جِنَايَةٌ':Added, #2: 2	ضَمَانُ جِنَايَتِهِ
u'ضَمَانٌ جِنَايَةٌ':Added, #3: 3	ضَمَانَ الْجِنَايَةِ
u'ضَمَانٌ جِنَايَةٌ':Added, #3: 3	ضَمَانَ جِنَايَةِ
u'ضَمَانٌ جَنِينٌ':Added, #6: 6	ضَمَانُ الْجِنَايَةِ
u'ضَمَانٌ جَنِينٌ':Added, #1: 1	ضَمَانِ الْجَنِينِ
u'ضَمَانٌ جَنِينٌ':Added, #1: 1	ضَمَانَ جَنِينِ
u'ضَمَانٌ جَنِينٌ':Added, #1: 1	ضَمَانِ جَنِينٍ
u'ضَمَانٌ جَنِينٌ':Added, #2: 2	ضَمَانَ الْجَنِينِ
u'ضَمَانٌ جَنِينٌ':Added, #2: 2	ضَمَانُ الْجَنِينِ
u'ضَمَانٌ جَنِينٌ':Added, #2: 2	ضَمَانَ جَنِينٍ
u'ضَمَانٌ حادِثٌ':Added, #2: 2	ضَمَانُ جَنِينِ
u'ضَمَانٌ حارِسٌ':Added, #1: 1	ضَمَانُ الْحَادِثِ
u'ضَمَانٌ حارِسٌ':Added, #1: 1	ضَمَانِ حَارِسٍ
u'ضَمَانٌ حافِرٌ':Added, #2: 2	ضَمَانِ الْحَارِسِ
u'ضَمَانٌ حاكِمٌ':Added, #1: 1	ضَمَانُ الْحَافِرِ
u'ضَمَانٌ حُرٌّ':Added, #1: 1	ضَمَانِ الْحَاكِمِ
u'ضَمَانٌ حَشَفَةٌ':Added, #1: 1	ضَمَانِ الْحُرِّ
u'ضَمَانٌ حَشِيشٌ':Added, #2: 2	ضَمَانُ الْحَشَفَةِ
u'ضَمَانٌ حِصَّةٌ':Added, #1: 1	ضَمَانُ الْحَشِيشِ
u'ضَمَانٌ حِصَّةٌ':Added, #1: 1	ضَمَانُ حِصَّةِ
u'ضَمَانٌ حَطَبٌ':Added, #1: 1	ضَمَانُ حِصَّتِهِ
u'ضَمَانٌ حَفْرٌ':Added, #2: 2	ضَمَانُ الْحَطَبِ
u'ضَمَانٌ حَفْنَةٌ':Added, #1: 1	ضَمَانِ الْحَفْرِ
u'ضَمَانٌ حُقوقٌ':Added, #1: 1	ضَمَانُ الْحَفْنَةِ
u'ضَمَانٌ حُقُوقٌ':Added, #1: 1	ضَمَانُ حُقُوقِ
u'ضَمَانٌ حَيَاةٌ':Added, #1: 1	ضَمَانُ حُقُوقِ
u'ضَمَانٌ حَيْلُولَةٌ':Added, #1: 1	ضَمَانُ حَيَاتِهِ
u'ضَمَانٌ حَيْلُولَةٌ':Added, #1: 1	ضَمَانُ الْحَيْلُولَةِ
u'ضَمَانٌ حَيْلُولَةٌ':Added, #1: 1	ضَمَانَ حَيْلُولَةٍ
u'ضَمَانٌ حَيْلُولَةٌ':Added, #1: 1	ضَمَانُ حَيْلُولَةٍ
u'ضَمَانٌ حَيَوَانٌ':Added, #2: 2	ضَمَانِ الْحَيْلُولَةِ
u'ضَمَانٌ خرق':Added, #1: 1	ضَمَانُ الْحَيَوَانِ
u'ضَمَانٌ خَرْقٌ':Added, #1: 1	ضَمَانِ الْخَرْقِ
u'ضَمَانٌ خلاص':Added, #1: 1	ضَمَانِ الْخَرْقِ
u'ضَمَانٌ خَلاَصٌ':Added, #1: 1	ضَمَانُ الْخَلَاصِ
u'ضَمَانٌ خلاص':Added, #1: 1	ضَمَانُ الْخَلَاصِ
u'ضَمَانٌ خَلاَصٌ':Added, #6: 6	ضَمَانِ الْخَلَاصِ
u'ضَمَانٌ خَمْرٌ':Added, #6: 6	ضَمَانِ الْخَلَاصِ
u'ضَمَانٌ دَابَّةٌ':Added, #1: 1	ضَمَانَ الْخَمْرِ
u'ضَمَانٌ دَابَّةٌ':Added, #2: 2	ضَمَانُ الدَّابَّةِ
u'ضَمَانٌ دَافِعٌ':Added, #2: 2	ضَمَانِ الدَّابَّةِ
u'ضَمَانٌ دَرَكٌ':Added, #2: 2	ضَمَانِ الدَّافِعِ
u'ضَمَانٌ دَرَكٌ':Added, #10: 10	ضَمَانُ الدَّرَكِ
u'ضَمَانٌ دَرَكٌ':Added, #1: 1	ضَمَانِ دَرَكِهِ
u'ضَمَانٌ دَرَكٌ':Added, #6: 6	ضَمَانَ الدَّرَكِ
u'ضَمَانٌ دُفٌّ':Added, #9: 9	ضَمَانِ الدَّرَكِ
u'ضَمَانٌ دَمٌ':Added, #1: 1	ضَمَانِ دُفِّ
u'ضَمَانٌ دِيَةٌ':Added, #6: 6	ضَمَانُ دَمٍ
u'ضَمَانٌ دِيَةٌ':Added, #1: 1	ضَمَانَ الدِّيَةِ
u'ضَمَانٌ دِيَةٌ':Added, #3: 3	ضَمَانِ الدِّيَةِ
u'ضَمَانٌ دِيَةٌ':Added, #3: 3	ضَمَانُ دِيَةِ
u'ضَمَانٌ دَيْنٌ':Added, #4: 4	ضَمَانُ الدِّيَةِ
u'ضَمَانٌ دَيْنٌ':Added, #1: 1	ضَمَانَ الدَّيْنِ
u'ضَمَانٌ دَيْنٌ':Added, #1: 1	ضَمَانُ دَيْنِهِ
u'ضَمَانٌ دَيْنٌ':Added, #2: 2	ضَمَانُ الدَّيْنِ
u'ضَمَانٌ دَيْنٌ':Added, #3: 3	ضَمَانِ الدَّيْنِ
u'ضَمَانٌ دَيْنٌ':Added, #3: 3	ضَمَانُ دَيْنٍ
u'ضَمَانٌ دَيْنٌ':Added, #5: 5	ضَمَانِ دَيْنِ
u'ضَمَانٌ دِينارٌ':Added, #7: 7	ضَمَانُ دَيْنِ
u'ضَمَانٌ ذِمَّةٌ':Added, #1: 1	ضَمَانُ الدِّينَارِ
u'ضَمَانٌ ذِمَّةٌ':Added, #1: 1	ضَمَانُ الذِّمَّةِ
u'ضَمَانٌ رَأْسٌ':Added, #1: 1	ضَمَانَ ذِمَّةٍ
u'ضَمَانٌ رَأْسٌ':Added, #1: 1	ضَمَانُ رَأْسِ
u'ضَمَانٌ رَاهِنٌ':Added, #1: 1	ضَمَانِ رَأْسِ
u'ضَمَانٌ رَاهِنٌ':Added, #1: 1	ضَمَانُ الرَّاهِنِ
u'ضَمَانٌ رَبُّ':Added, #4: 4	ضَمَانِ الرَّاهِنِ
u'ضَمَانٌ رَبُّ':Added, #1: 1	ضَمَانِ رَبِّ
u'ضَمَانٌ رَجُلٌ':Added, #2: 2	ضَمَانَ رَبِّ
u'ضَمَانٌ رَجُلٌ':Added, #1: 1	ضَمَانُ الرَّجُلِ
u'ضَمَانٌ رُجُوعٌ':Added, #2: 2	ضَمَانِ الرَّجُلَيْنِ
u'ضَمَانٌ رَدٌّ':Added, #1: 1	ضَمَانَ الرُّجُوعِ
u'ضَمَانٌ رَدٌّ':Added, #1: 1	ضَمَانَ رَدِّ
u'ضَمَانٌ رَدٌّ':Added, #2: 2	ضَمَانَ الرَّدِّ
u'ضَمَانٌ رَدٌّ':Added, #2: 2	ضَمَانُ رَدِّ
u'ضَمَانٌ رَسُولٌ':Added, #3: 3	ضَمَانِ الرَّدِّ
u'ضَمَانٌ رَقَبَةٌ':Added, #2: 2	ضَمَانِ الرَّسُولِ
u'ضَمَانٌ رَقَبَةٌ':Added, #1: 1	ضَمَانُ الرَّقَبَةِ
u'ضَمَانٌ رَقيقٌ':Added, #1: 1	ضَمَانِ الرَّقَبَةِ
u'ضَمَانٌ رَقيقٌ':Added, #1: 1	ضَمَانَ رَقِيقٍ
u'ضَمَانٌ رَقيق':Added, #1: 1	ضَمَانُ رَقِيقٍ
u'ضَمَانٌ رَقيق':Added, #1: 1	ضَمَانَ رَقِيقٍ
u'ضَمَانٌ رهان':Added, #1: 1	ضَمَانُ رَقِيقٍ
u'ضَمَانٌ رِهانٌ':Added, #1: 1	ضَمَانُ رِهَانٍ
u'ضَمَانٌ رهان':Added, #1: 1	ضَمَانُ رِهَانٍ
u'ضَمَانٌ رِهانٌ':Added, #3: 3	ضَمَانَ الرِّهَانِ
u'ضَمَانٌ رَهْنٌ':Added, #3: 3	ضَمَانَ الرِّهَانِ
u'ضَمَانٌ رَهْنٌ':Added, #10: 10	ضَمَانَ الرَّهْنِ
u'ضَمَانٌ رَهْنٌ':Added, #15: 15	ضَمَانِ الرَّهْنِ
u'ضَمَانٌ زائِدٌ':Added, #4: 4	ضَمَانُ الرَّهْنِ
u'ضَمَانٌ زَكاةٌ':Added, #1: 1	ضَمَانِ الزَّائِدِ
u'ضَمَانٌ زَكاةٌ':Added, #1: 1	ضَمَانِ الزَّكَاةِ
u'ضَمَانٌ زَكاةٌ':Added, #1: 1	ضَمَانِ زَكَاتِهِ
u'ضَمَانٌ زَوْجٌ':Added, #4: 4	ضَمَانُ الزَّكَاةِ
u'ضَمَانٌ زِيادَةٌ':Added, #3: 3	ضَمَانِ الزَّوْجِ
u'ضَمَانٌ سَائِرٌ':Added, #4: 4	ضَمَانِ زِيَادَتِهِ
u'ضَمَانٌ سَبَقٌ':Added, #2: 2	ضَمَانِ سَائِرِ
u'ضَمَانٌ سَرقَةٌ':Added, #3: 3	ضَمَانُ السَّبَقِ
u'ضَمَانٌ سَرِقَةٌ':Added, #2: 2	ضَمَانَ السَّرِقَةِ
u'ضَمَانٌ سَفِيهٌ':Added, #2: 2	ضَمَانَ السَّرِقَةِ
u'ضَمَانٌ سِلْعَةٌ':Added, #1: 1	ضَمَانُ السَّفِيهِ
u'ضَمَانٌ سُوقٌ':Added, #1: 1	ضَمَانُ السِّلْعَةِ
u'ضَمَانٌ سَيِّدٌ':Added, #1: 1	ضَمَانُ السُّوقِ
u'ضَمَانٌ سَيِّدٌ':Added, #1: 1	ضَمَانِ السَّيِّدِ
u'ضَمَانٌ شَارِبٌ':Added, #1: 1	ضَمَانُ سَيِّدِهِ
u'ضَمَانٌ شَاهِدٌ':Added, #1: 1	ضَمَانُ الشَّارِبِ
u'ضَمَانٌ شِبْهٌ':Added, #1: 1	ضَمَانَ الشَّاهِدَيْنِ
u'ضَمَانٌ شرب':Added, #1: 1	ضَمَانَ شِبْهِ
u'ضَمَانٌ شِرْبٌ':Added, #1: 1	ضَمَانِ الشِّرْبِ
u'ضَمَانٌ شَرِيكٌ':Added, #1: 1	ضَمَانِ الشِّرْبِ
u'ضَمَانٌ شَقٌّ':Added, #1: 1	ضَمَانِ الشَّرِيكِ
u'ضَمَانٌ شُهُودٌ':Added, #1: 1	ضَمَانِ الشَّقِّ
u'ضَمَانٌ شُهُودٌ':Added, #1: 1	ضَمَانَ الشُّهُودِ
u'ضَمَانٌ شَيْءٌ':Added, #1: 1	ضَمَانُ شُهُودِ
u'ضَمَانٌ شَيْءٌ':Added, #1: 1	ضَمَانَ شَيْءٍ
u'ضَمَانٌ صَاحِبٌ':Added, #4: 4	ضَمَانُ شَيْءٍ
u'ضَمَانٌ صَاحِبٌ':Added, #1: 1	ضَمَانِ صَاحِبِ
u'ضَمَانٌ صبر':Added, #3: 3	ضَمَانِ صَاحِبِهِ
u'ضَمَانٌ صَبِيٌّ':Added, #1: 1	ضَمَانِ صُبَرِ
u'ضَمَانٌ صَبِيٌّ':Added, #1: 1	ضَمَانُ الصَّبِيِّ
u'ضَمَانٌ صداق':Added, #3: 3	ضَمَانِ الصَّبِيِّ
u'ضَمَانٌ صَدَاقٌ':Added, #3: 3	ضَمَانُ الصَّدَاقِ
u'ضَمَانٌ صَغِيرٌ':Added, #3: 3	ضَمَانُ الصَّدَاقِ
u'ضَمَانٌ صَكٌّ':Added, #1: 1	ضَمَانَ الصَّغِيرِ
u'ضَمَانٌ صَيْدٌ':Added, #1: 1	ضَمَانُ الصَّكِّ
u'ضَمَانٌ صَيْدٌ':Added, #1: 1	ضَمَانُ صَيْدٍ
u'ضَمَانٌ صَيْدٌ':Added, #1: 1	ضَمَانِ صَيْدِ
u'ضَمَانٌ صَيْدٌ':Added, #2: 2	ضَمَانَ الصَّيْدِ
u'ضَمَانٌ صَيْدٌ':Added, #2: 2	ضَمَانُ الصَّيْدِ
u'ضَمَانٌ ضَامِنٌ':Added, #3: 3	ضَمَانِ الصَّيْدِ
u'ضَمَانٌ ضَامِنٌ':Added, #1: 1	ضَمَانُ الضَّامِنِ
u'ضَمَانٌ ضَامِنٌ':Added, #1: 1	ضَمَانِ الضَّامِنِ
u'ضَمَانٌ ضَامِنٌ':Added, #1: 1	ضَمَانِ ضَامِنِ
u'ضَمَانٌ ضَيْفٌ':Added, #1: 1	ضَمَانَ ضَامِنِهِ
u'ضَمَانٌ طرف':Added, #1: 1	ضَمَانِ الضَّيْفِ
u'ضَمَانٌ طَرَفٌ':Added, #1: 1	ضَمَانُ طَرَفِهِ
u'ضَمَانٌ طرف':Added, #1: 1	ضَمَانُ طَرَفِهِ
u'ضَمَانٌ طرف':Added, #2: 2	ضَمَانَ الطَّرَفِ
u'ضَمَانٌ طرف':Added, #2: 2	ضَمَانُ الطَّرَفِ
u'ضَمَانٌ طَرَفٌ':Added, #2: 2	ضَمَانِ الطَّرَفِ
u'ضَمَانٌ طَرَفٌ':Added, #2: 2	ضَمَانَ الطَّرَفِ
u'ضَمَانٌ طَرَفٌ':Added, #2: 2	ضَمَانُ الطَّرَفِ
u'ضَمَانٌ طَرِيقٌ':Added, #2: 2	ضَمَانِ الطَّرَفِ
u'ضَمَانٌ طعام':Added, #1: 1	ضَمَانِ طَرِيقٍ
u'ضَمَانٌ طَعَامٌ':Added, #1: 1	ضَمَانَ الطَّعَامِ
u'ضَمَانٌ طِفْلٌ':Added, #1: 1	ضَمَانَ الطَّعَامِ
u'ضَمَانٌ عارِيَّةٌ':Added, #1: 1	ضَمَانِ الطِّفْلِ
u'ضَمَانٌ عارِيَّةٌ':Added, #2: 2	ضَمَانَ الْعَارِيَّةِ
u'ضَمَانٌ عارِيَّةٌ':Added, #2: 2	ضَمَانُ الْعَارِيَّةِ
u'ضَمَانٌ عَامِلٌ':Added, #4: 4	ضَمَانِ الْعَارِيَّةِ
u'ضَمَانٌ عِبَادٌ':Added, #1: 1	ضَمَانِ الْعَامِلِ
u'ضَمَانٌ عَبْدٌ':Added, #1: 1	ضَمَانَ الْعِبَادِ
u'ضَمَانٌ عَبْدٌ':Added, #1: 1	ضَمَانُ الْعَبْدَيْنِ
u'ضَمَانٌ عَبْدٌ':Added, #2: 2	ضَمَانُ الْعَبْدِ
u'ضَمَانٌ عَبْدٌ':Added, #3: 3	ضَمَانَ الْعَبْدِ
u'ضَمَانٌ عِتْقٌ':Added, #4: 4	ضَمَانِ الْعَبْدِ
u'ضَمَانٌ عِتْقٌ':Added, #1: 1	ضَمَانَ عِتْقٍ
u'ضَمَانٌ عتق':Added, #1: 1	ضَمَانُ عِتْقٍ
u'ضَمَانٌ عِتْقٌ':Added, #5: 5	ضَمَانِ الْعِتْقِ
u'ضَمَانٌ عتق':Added, #5: 5	ضَمَانِ الْعِتْقِ
u'ضَمَانٌ عِتْقٌ':Added, #6: 6	ضَمَانَ الْعِتْقِ
u'ضَمَانٌ عُدْوَانٌ':Added, #6: 6	ضَمَانَ الْعِتْقِ
u'ضَمَانٌ عُدْوَانٌ':Added, #2: 2	ضَمَانُ الْعُدْوَانِ
u'ضَمَانٌ عُدْوَانٌ':Added, #3: 3	ضَمَانُ عُدْوَانٍ
u'ضَمَانٌ عُدْوَانٌ':Added, #4: 4	ضَمَانَ الْعُدْوَانِ
u'ضَمَانٌ عُرُوضٌ':Added, #9: 9	ضَمَانِ الْعُدْوَانِ
u'ضَمَانٌ عَزَاءٌ':Added, #2: 2	ضَمَانَ الْعُرُوضِ
u'ضَمَانٌ عُشْرٌ':Added, #1: 1	ضَمَانِ الْعَزَاءِ
u'ضَمَانٌ عَقْدٌ':Added, #1: 1	ضَمَانُ الْعُشْرِ
u'ضَمَانٌ عَقْدٌ':Added, #11: 11	ضَمَانَ عَقْدٍ
u'ضَمَانٌ عَقْدٌ':Added, #13: 13	ضَمَانِ الْعَقْدِ
u'ضَمَانٌ عَقْدٌ':Added, #3: 3	ضَمَانُ الْعَقْدِ
u'ضَمَانٌ عَقْدٌ':Added, #4: 4	ضَمَانَ الْعَقْدِ
u'ضَمَانٌ عقر':Added, #9: 9	ضَمَانُ عَقْدٍ
u'ضَمَانٌ عقر':Added, #1: 1	ضَمَانَ الْعُقْرِ
u'ضَمَانٌ عُقْرٌ':Added, #1: 1	ضَمَانُ الْعُقْرِ
u'ضَمَانٌ عُقْرٌ':Added, #1: 1	ضَمَانَ الْعُقْرِ
u'ضَمَانٌ عقر':Added, #1: 1	ضَمَانُ الْعُقْرِ
u'ضَمَانٌ عُقُودٌ':Added, #1: 1	ضَمَانِ عَقْرِ
u'ضَمَانٌ عُقُودٌ':Added, #1: 1	ضَمَانَ الْعُقُودِ
u'ضَمَانٌ عَمَلٌ':Added, #2: 2	ضَمَانِ الْعُقُودِ
u'ضَمَانٌ عَمَلٌ':Added, #2: 2	ضَمَانُ الْعَمَلِ
u'ضَمَانٌ عُهْدَةٌ':Added, #5: 5	ضَمَانِ الْعَمَلِ
u'ضَمَانٌ عُهْدَةٌ':Added, #10: 10	ضَمَانُ الْعُهْدَةِ
u'ضَمَانٌ عُهْدَةٌ':Added, #10: 10	ضَمَانِ الْعُهْدَةِ
u'ضَمَانٌ عُهْدَةٌ':Added, #2: 2	ضَمَانِ عُهْدَةِ
u'ضَمَانٌ عُهْدَةٌ':Added, #3: 3	ضَمَانُ عُهْدَةِ
u'ضَمَانٌ عَيْبٌ':Added, #4: 4	ضَمَانَ الْعُهْدَةِ
u'ضَمَانٌ عين':Added, #1: 1	ضَمَانَ عَيْبِ
u'ضَمَانٌ عَيْنٌ':Added, #10: 10	ضَمَانِ الْعَيْنِ
u'ضَمَانٌ عَيْن':Added, #10: 10	ضَمَانِ الْعَيْنِ
u'ضَمَانٌ عين':Added, #10: 10	ضَمَانِ الْعَيْنِ
u'ضَمَانٌ عين':Added, #1: 1	ضَمَانَ عَيْنِ
u'ضَمَانٌ عين':Added, #1: 1	ضَمَانُ عَيْنِ
u'ضَمَانٌ عَيْنٌ':Added, #1: 1	ضَمَانِ عَيْنِ
u'ضَمَانٌ عَيْنٌ':Added, #1: 1	ضَمَانَ عَيْنٍ
u'ضَمَانٌ عَيْنٌ':Added, #1: 1	ضَمَانَ عَيْنِ
u'ضَمَانٌ عَيْنٌ':Added, #1: 1	ضَمَانُ عَيْنٍ
u'ضَمَانٌ عَيْنٌ':Added, #1: 1	ضَمَانُ عَيْنِ
u'ضَمَانٌ عَيْنٌ':Added, #1: 1	ضَمَانِ عَيْنٍ
u'ضَمَانٌ عَيْن':Added, #1: 1	ضَمَانِ عَيْنِ
u'ضَمَانٌ عَيْن':Added, #1: 1	ضَمَانَ عَيْنٍ
u'ضَمَانٌ عَيْن':Added, #1: 1	ضَمَانَ عَيْنِ
u'ضَمَانٌ عَيْن':Added, #1: 1	ضَمَانُ عَيْنٍ
u'ضَمَانٌ عَيْن':Added, #1: 1	ضَمَانُ عَيْنِ
u'ضَمَانٌ عَيْن':Added, #1: 1	ضَمَانِ عَيْنٍ
u'ضَمَانٌ عين':Added, #1: 1	ضَمَانِ عَيْنِ
u'ضَمَانٌ عَيْنٌ':Added, #1: 1	ضَمَانُ عَيْنِهِ
u'ضَمَانٌ عَيْن':Added, #1: 1	ضَمَانُ عَيْنِهِ
u'ضَمَانٌ عين':Added, #1: 1	ضَمَانُ عَيْنِهِ
u'ضَمَانٌ عَيْنٌ':Added, #4: 4	ضَمَانَ الْعَيْنِ
u'ضَمَانٌ عَيْن':Added, #4: 4	ضَمَانَ الْعَيْنِ
u'ضَمَانٌ عين':Added, #4: 4	ضَمَانَ الْعَيْنِ
u'ضَمَانٌ عَيْنٌ':Added, #7: 7	ضَمَانُ الْعَيْنِ
u'ضَمَانٌ عَيْن':Added, #7: 7	ضَمَانُ الْعَيْنِ
u'ضَمَانٌ عُيُوبٌ':Added, #7: 7	ضَمَانُ الْعَيْنِ
u'ضَمَانٌ غَاصِبٌ':Added, #1: 1	ضَمَانُ الْعُيُوبِ
u'ضَمَانٌ غَاصِبٌ':Added, #12: 12	ضَمَانِ الْغَاصِبِ
u'ضَمَانٌ غَاصِبٌ':Added, #1: 1	ضَمَانُ الْغَاصِبِ
u'ضَمَانٌ غَائِبٌ':Added, #5: 5	ضَمَانَ الْغَاصِبِ
u'ضَمَانٌ غُرُورٌ':Added, #2: 2	ضَمَانَ الْغَائِبِ
u'ضَمَانٌ غُرُورٌ':Added, #1: 1	ضَمَانُ غُرُورٍ
u'ضَمَانٌ غَرِيمٌ':Added, #4: 4	ضَمَانَ الْغُرُورِ
u'ضَمَانٌ غَصْبٌ':Added, #2: 2	ضَمَانِ الْغَرِيمِ
u'ضَمَانٌ غَصْبٌ':Added, #10: 10	ضَمَانُ الْغَصْبِ
u'ضَمَانٌ غَصْبٌ':Added, #13: 13	ضَمَانِ الْغَصْبِ
u'ضَمَانٌ غَصْبٌ':Added, #1: 1	ضَمَانِ غَصْبٍ
u'ضَمَانٌ غَصْبٌ':Added, #1: 1	ضَمَانِ غَصْبِهِ
u'ضَمَانٌ غَصْبٌ':Added, #28: 28	ضَمَانَ الْغَصْبِ
u'ضَمَانٌ غَصْبٌ':Added, #4: 4	ضَمَانَ غَصْبٍ
u'ضَمَانٌ غير':Added, #4: 4	ضَمَانُ غَصْبٍ
u'ضَمَانٌ غَيْرٌ':Added, #1: 1	ضَمَانِ غَيْرِ
u'ضَمَانٌ غير':Added, #1: 1	ضَمَانِ غَيْرِ
u'ضَمَانٌ غَيْرٌ':Added, #1: 1	ضَمَانِ غَيْرِهِ
u'ضَمَانٌ غير':Added, #1: 1	ضَمَانِ غَيْرِهِ
u'ضَمَانٌ غَيْرٌ':Added, #2: 2	ضَمَانُ غَيْرِ
u'ضَمَانٌ فَاسِدٌ':Added, #2: 2	ضَمَانُ غَيْرِ
u'ضَمَانٌ فَتْحٌ':Added, #3: 3	ضَمَانُ الْفَاسِدِ
u'ضَمَانٌ فِدَاءٌ':Added, #1: 1	ضَمَانِ فَتْحِ
u'ضَمَانٌ فِرَاخٌ':Added, #2: 2	ضَمَانِ الْفِدَاءِ
u'ضَمَانٌ فَرْخٌ':Added, #1: 1	ضَمَانُ الْفِرَاخِ
u'ضَمَانٌ فَضْلٌ':Added, #2: 2	ضَمَانُ الْفَرْخِ
u'ضَمَانٌ فِعْلٌ':Added, #1: 1	ضَمَانِ الْفَضْلِ
u'ضَمَانٌ فقراء':Added, #1: 1	ضَمَانَ فِعْلِ
u'ضَمَانٌ قَابِضٌ':Added, #2: 2	ضَمَانِ الْفُقَرَاءِ
u'ضَمَانٌ قَابِضٌ':Added, #2: 2	ضَمَانِ قَابِضِهِ
u'ضَمَانٌ قتل':Added, #3: 3	ضَمَانِ الْقَابِضِ
u'ضَمَانٌ قَتْلٌ':Added, #1: 1	ضَمَانَ الْقَتْلِ
u'ضَمَانٌ قتل':Added, #1: 1	ضَمَانَ الْقَتْلِ
u'ضَمَانٌ قَتْلٌ':Added, #1: 1	ضَمَانُ قَتْلِهِ
u'ضَمَانٌ قتل':Added, #1: 1	ضَمَانُ قَتْلِهِ
u'ضَمَانٌ قَتْلٌ':Added, #4: 4	ضَمَانِ الْقَتْلِ
u'ضَمَانٌ قَتْلٌ':Added, #4: 4	ضَمَانِ الْقَتْلِ
u'ضَمَانٌ قَدْرٌ':Added, #4: 4	ضَمَانُ قَتْلٍ
u'ضَمَانٌ قَدْرٌ':Added, #1: 1	ضَمَانَ قَدْرِ
u'ضَمَانٌ قراض':Added, #1: 1	ضَمَانُ قَدْرِ
u'ضَمَانٌ قَرْضٌ':Added, #1: 1	ضَمَانَ الْقِرَاضِ
u'ضَمَانٌ قسمة':Added, #1: 1	ضَمَانَ الْقَرْضِ
u'ضَمَانٌ قسمة':Added, #1: 1	ضَمَانَ الْقِسْمَةِ
u'ضَمَانٌ قِسْمَةٌ':Added, #1: 1	ضَمَانِ الْقِسْمَةِ
u'ضَمَانٌ قِسْمَةٌ':Added, #1: 1	ضَمَانَ الْقِسْمَةِ
u'ضَمَانٌ قِنٌّ':Added, #1: 1	ضَمَانِ الْقِسْمَةِ
u'ضَمَانٌ قِيَمٌ':Added, #1: 1	ضَمَانَ الْقِنِّ
u'ضَمَانٌ قِيمَةٌ':Added, #1: 1	ضَمَانِ قِيَمِ
u'ضَمَانٌ قِيمَةٌ':Added, #11: 11	ضَمَانُ قِيمَتِهِ
u'ضَمَانٌ قِيمَةٌ':Added, #16: 16	ضَمَانِ الْقِيمَةِ
u'ضَمَانٌ قِيمَةٌ':Added, #1: 1	ضَمَانَ قِيمَتِهِ
u'ضَمَانٌ قِيمَةٌ':Added, #2: 2	ضَمَانَ قِيمَةِ
u'ضَمَانٌ قِيمَةٌ':Added, #3: 3	ضَمَانِ قِيمَةِ
u'ضَمَانٌ قِيمَةٌ':Added, #5: 5	ضَمَانِ قِيمَتِهِ
u'ضَمَانٌ قِيمَةٌ':Added, #7: 7	ضَمَانَ الْقِيمَةِ
u'ضَمَانٌ قِيمَةٌ':Added, #8: 8	ضَمَانُ الْقِيمَةِ
u'ضَمَانٌ كَسْرٌ':Added, #8: 8	ضَمَانُ قِيمَةِ
u'ضَمَانٌ كَفٌّ':Added, #2: 2	ضَمَانِ كَسْرِ
u'ضَمَانٌ كَفَالَةٌ':Added, #1: 1	ضَمَانُ الْكَفِّ
u'ضَمَانٌ كَفَالَةٌ':Added, #1: 1	ضَمَانَ الْكَفَالَةِ
u'ضَمَانٌ كَفَالَةٌ':Added, #1: 1	ضَمَانُ الْكَفَالَةِ
u'ضَمَانٌ لبن':Added, #1: 1	ضَمَانِ الْكَفَالَةِ
u'ضَمَانٌ لَبَنٌ':Added, #1: 1	ضَمَانُ اللَّبَنِ
u'ضَمَانٌ لَحْمٌ':Added, #1: 1	ضَمَانُ اللَّبَنِ
u'ضَمَانٌ لَحْمٌ':Added, #1: 1	ضَمَانِ اللَّحْمِ
u'ضَمَانٌ لِحْيَةٌ':Added, #3: 3	ضَمَانُ اللَّحْمِ
u'ضَمَانٌ مَاءٌ':Added, #1: 1	ضَمَانِ اللِّحْيَةِ
u'ضَمَانٌ مَاءٌ':Added, #1: 1	ضَمَانَ الْمَاءِ
u'ضَمَانٌ مَاءٌ':Added, #1: 1	ضَمَانِ الْمَاءِ
u'ضَمَانٌ مَارٌّ':Added, #2: 2	ضَمَانُ الْمَاءِ
u'ضَمَانٌ مَارٌّ':Added, #1: 1	ضَمَانُ الْمَارِّ
u'ضَمَانٌ مَالٌ':Added, #1: 1	ضَمَانِ الْمَارِّ
u'ضَمَانٌ مَالٌ':Added, #15: 15	ضَمَانُ الْمَالِ
u'ضَمَانٌ مَالٌ':Added, #17: 17	ضَمَانِ الْمَالِ
u'ضَمَانٌ مَالٌ':Added, #1: 1	ضَمَانُ مَالِ
u'ضَمَانٌ مَالٌ':Added, #1: 1	ضَمَانِ مَالِ
u'ضَمَانٌ مَالٌ':Added, #1: 1	ضَمَانِ مَالِهِ
u'ضَمَانٌ مَالٌ':Added, #2: 2	ضَمَانَ مَالٍ
u'ضَمَانٌ مَالٌ':Added, #5: 5	ضَمَانُ مَالٍ
u'ضَمَانٌ مَالِكٌ':Added, #7: 7	ضَمَانَ الْمَالِ
u'ضَمَانٌ مَالِكٌ':Added, #2: 2	ضَمَانِ مَالِكِهِ
u'ضَمَانٌ مَالِيٌّ':Added, #8: 8	ضَمَانِ الْمَالِكِ
u'ضَمَانٌ مُبْتاع':Added, #2: 2	ضَمَانُ الْمَالِيَّةِ
u'ضَمَانٌ مُبْهَمٌ':Added, #1: 1	ضَمَانِ الْمُبْتَاعِ
u'ضَمَانٌ مُبْهَمٌ':Added, #1: 1	ضَمَانُ الْمُبْهَمِ
u'ضَمَانٌ مَبِيعٌ':Added, #1: 1	ضَمَانِ الْمُبْهَمِ
u'ضَمَانٌ مَبِيعٌ':Added, #1: 1	ضَمَانَ الْمَبِيعِ
u'ضَمَانٌ مَبِيعٌ':Added, #2: 2	ضَمَانُ الْمَبِيعِ
u'ضَمَانٌ مَتَاعٌ':Added, #8: 8	ضَمَانِ الْمَبِيعِ
u'ضَمَانٌ مَتَاعٌ':Added, #1: 1	ضَمَانُ الْمَتَاعِ
u'ضَمَانٌ مُتَسَبِّبٌ':Added, #2: 2	ضَمَانِ الْمَتَاعِ
u'ضَمَانٌ مُتَسَبِّبٌ':Added, #1: 1	ضَمَانِ الْمُتَسَبِّبِ
u'ضَمَانٌ مُتْلِفٌ':Added, #2: 2	ضَمَانُ الْمُتَسَبِّبِ
u'ضَمَانٌ مُتْلِفٌ':Added, #1: 1	ضَمَانَ الْمُتْلِفَاتِ
u'ضَمَانٌ مثل':Added, #1: 1	ضَمَانِ الْمُتْلِفَاتِ
u'ضَمَانٌ مِثْلٌ':Added, #1: 1	ضَمَانَ الْمِثْلِ
u'ضَمَانٌ مثل':Added, #1: 1	ضَمَانَ الْمِثْلِ
u'ضَمَانٌ مِثْلٌ':Added, #2: 2	ضَمَانِ الْمِثْلِ
u'ضَمَانٌ مثل':Added, #2: 2	ضَمَانِ الْمِثْلِ
u'ضَمَانٌ مِثْلٌ':Added, #2: 2	ضَمَانُ مِثْلِ
u'ضَمَانٌ مثل':Added, #2: 2	ضَمَانُ مِثْلِ
u'ضَمَانٌ مِثْلٌ':Added, #3: 3	ضَمَانُ الْمِثْلِ
u'ضَمَانٌ مثل':Added, #3: 3	ضَمَانُ الْمِثْلِ
u'ضَمَانٌ مِثْلٌ':Added, #3: 3	ضَمَانُ مِثْلِهِ
u'ضَمَانٌ مِثْلِيٌّ':Added, #3: 3	ضَمَانُ مِثْلِهِ
u'ضَمَانٌ مَجْهُولٌ':Added, #1: 1	ضَمَانَ الْمِثْلِيِّ
u'ضَمَانٌ مَجْهُولٌ':Added, #1: 1	ضَمَانُ الْمَجْهُولِ
u'ضَمَانٌ مَحَالٌّ':Added, #1: 1	ضَمَانِ الْمَجْهُولِ
u'ضَمَانٌ مَحَالٌّ':Added, #1: 1	ضَمَانَ الْمَحَالِّ
u'ضَمَانٌ مَحَالُّ':Added, #1: 1	ضَمَانِ الْمَحَالِّ
u'ضَمَانٌ مَحَالُّ':Added, #1: 1	ضَمَانَ الْمَحَالِّ
u'ضَمَانٌ مَحْجُورٌ':Added, #1: 1	ضَمَانِ الْمَحَالِّ
u'ضَمَانٌ مَحْصُود':Added, #2: 2	ضَمَانُ الْمَحْجُورِ
u'ضَمَانٌ مَحَلٌّ':Added, #1: 1	ضَمَانِ الْمَحْصُودِ
u'ضَمَانٌ مُدَبَّرٌ':Added, #1: 1	ضَمَانَ الْمَحَلِّ
u'ضَمَانٌ مُدَبَّرٌ':Added, #2: 2	ضَمَانُ الْمُدَبَّرِ
u'ضَمَانٌ مَدِينٌ':Added, #4: 4	ضَمَانَ الْمُدَبَّرِ
u'ضَمَانٌ مُرْتَهِنٌ':Added, #2: 2	ضَمَانِ الْمَدِينِ
u'ضَمَانٌ مَرْهُونٌ':Added, #19: 19	ضَمَانِ الْمُرْتَهِنِ
u'ضَمَانٌ مَرِيضٌ':Added, #1: 1	ضَمَانِ الْمَرْهُونِ
u'ضَمَانٌ مَرِيضٌ':Added, #1: 1	ضَمَانَ الْمَرِيضِ
u'ضَمَانٌ مَرِيضٌ':Added, #1: 1	ضَمَانِ الْمَرِيضِ
u'ضَمَانٌ مساكين':Added, #2: 2	ضَمَانُ الْمَرِيضِ
u'ضَمَانٌ مُسْتَأْجِرٌ':Added, #1: 1	ضَمَانِ الْمَسَاكِينِ
u'ضَمَانٌ مُسْتَعِيرٌ':Added, #2: 2	ضَمَانِ الْمُسْتَأْجِرِ
u'ضَمَانٌ مُسْتَهْلَكٌ':Added, #2: 2	ضَمَانِ مُسْتَعِيرٍ
u'ضَمَانٌ مَسْرُوقٌ':Added, #1: 1	ضَمَانِ الْمُسْتَهْلَكَاتِ
u'ضَمَانٌ مَسْرُوقٌ':Added, #1: 1	ضَمَانُ الْمَسْرُوقِ
u'ضَمَانٌ مُسْلِمٌ':Added, #1: 1	ضَمَانِ الْمَسْرُوقِ
u'ضَمَانٌ مُشْتَرِي':Added, #1: 1	ضَمَانُ الْمُسْلِمِ
u'ضَمَانٌ مَضْمُونٌ':Added, #4: 4	ضَمَانِ مُشْتَرِيهِ
u'ضَمَانٌ مَضْمُونٌ':Added, #1: 1	ضَمَانِ الْمَضْمُونِ
u'ضَمَانٌ مُعَارٌ':Added, #1: 1	ضَمَانَ مَضْمُونِهِ
u'ضَمَانٌ مُعْتَقٌ':Added, #1: 1	ضَمَانِ الْمُعَارِ
u'ضَمَانٌ مَغْرُورٌ':Added, #1: 1	ضَمَانَ الْمُعْتَقِ
u'ضَمَانٌ مَغْصُوب':Added, #1: 1	ضَمَانِ الْمَغْرُورِ
u'ضَمَانٌ مَغْصُوب':Added, #2: 2	ضَمَانَ الْمَغْصُوبِ
u'ضَمَانٌ مَغْصُوب':Added, #2: 2	ضَمَانُ الْمَغْصُوبِ
u'ضَمَانٌ مُفْلِسٌ':Added, #2: 2	ضَمَانِ الْمَغْصُوبِ
u'ضَمَانٌ مُفْلِسٌ':Added, #1: 1	ضَمَانُ مُفْلِسٍ
u'ضَمَانٌ مُفْلِسٌ':Added, #2: 2	ضَمَانِ الْمُفْلِسِ
u'ضَمَانٌ مَقْبُوضٌ':Added, #3: 3	ضَمَانُ الْمُفْلِسِ
u'ضَمَانٌ مَقْبُوضٌ':Added, #1: 1	ضَمَانَ الْمَقْبُوضِ
u'ضَمَانٌ مُقَدَّرٌ':Added, #5: 5	ضَمَانِ الْمَقْبُوضِ
u'ضَمَانٌ مُقَدَّرٌ':Added, #1: 1	ضَمَانَ الْمُقَدَّرِ
u'ضَمَانٌ مُكْرَهٌ':Added, #1: 1	ضَمَانِ الْمُقَدَّرِ
u'ضَمَانٌ مُكُوسٌ':Added, #1: 1	ضَمَانُ الْمُكْرَهِ
u'ضَمَانٌ مَكِيلٌ':Added, #1: 1	ضَمَانِ الْمُكُوسِ
u'ضَمَانٌ مِلْكٌ':Added, #1: 1	ضَمَانُ الْمَكِيلِ
u'ضَمَانٌ مِلْكٌ':Added, #1: 1	ضَمَانَ مِلْكٍ
u'ضَمَانٌ مِلْكٌ':Added, #1: 1	ضَمَانُ مِلْكٍ
u'ضَمَانٌ مَنَافِعُ':Added, #2: 2	ضَمَانِ الْمِلْكِ
u'ضَمَانٌ مَنَافِعُ':Added, #1: 1	ضَمَانَ الْمَنَافِعِ
u'ضَمَانٌ مَنَافِعُ':Added, #1: 1	ضَمَانُ الْمَنَافِعِ
u'ضَمَانٌ مَنَافِعُ':Added, #1: 1	ضَمَانُ مَنَافِعِ
u'ضَمَانٌ مَنْفَعَةٌ':Added, #3: 3	ضَمَانِ الْمَنَافِعِ
u'ضَمَانٌ مَنْفَعَةٌ':Added, #1: 1	ضَمَانُ الْمَنْفَعَةِ
u'ضَمَانٌ مَهْرٌ':Added, #1: 1	ضَمَانِ مَنْفَعَةِ
u'ضَمَانٌ مَهْرٌ':Added, #1: 1	ضَمَانِ الْمَهْرِ
u'ضَمَانٌ مَهْرٌ':Added, #1: 1	ضَمَانِ مَهْرِهِ
u'ضَمَانٌ مَهْرٌ':Added, #2: 2	ضَمَانَ الْمَهْرِ
u'ضَمَانٌ مَهْرٌ':Added, #2: 2	ضَمَانُ الْمَهْرِ
u'ضَمَانٌ مُؤَجَّلٌ':Added, #2: 2	ضَمَانُ مَهْرِ
u'ضَمَانٌ مُودِعٌ':Added, #2: 2	ضَمَانِ الْمُؤَجَّلِ
u'ضَمَانٌ مُودِعٌ':Added, #1: 1	ضَمَانَ الْمُودِعِ
u'ضَمَانٌ مُودَعٌ':Added, #1: 1	ضَمَانُ الْمُودِعِ
u'ضَمَانٌ مُوَكِّلٌ':Added, #2: 2	ضَمَانَ الْمُودَعِ
u'ضَمَانٌ مِيرَاثٌ':Added, #3: 3	ضَمَانِ الْمُوَكِّلِ
u'ضَمَانٌ نُجْح':Added, #1: 1	ضَمَانَ الْمِيرَاثِ
u'ضَمَانٌ نُجُومٌ':Added, #1: 1	ضَمَانُ النُّجْحِ
u'ضَمَانٌ نَسَّاجٌ':Added, #1: 1	ضَمَانَ النُّجُومِ
u'ضَمَانٌ نِصْفٌ':Added, #1: 1	ضَمَانِ النَّسَّاجِ
u'ضَمَانٌ نِصْفٌ':Added, #16: 16	ضَمَانُ نِصْفِ
u'ضَمَانٌ نِصْفٌ':Added, #2: 2	ضَمَانُ النِّصْفِ
u'ضَمَانٌ نِصْفٌ':Added, #2: 2	ضَمَانَ نِصْفِ
u'ضَمَانٌ نِصْفٌ':Added, #3: 3	ضَمَانِ النِّصْفِ
u'ضَمَانٌ نَصِيبٌ':Added, #8: 8	ضَمَانِ نِصْفِ
u'ضَمَانٌ نَصِيبٌ':Added, #1: 1	ضَمَانِ نَصِيبِهِ
u'ضَمَانٌ نَصِيبٌ':Added, #2: 2	ضَمَانَ نَصِيبِ
u'ضَمَانٌ نَصِيبٌ':Added, #2: 2	ضَمَانُ نَصِيبِ
u'ضَمَانٌ نَفْحٌ':Added, #2: 2	ضَمَانِ نَصِيبِ
u'ضَمَانٌ نَفْسٌ':Added, #1: 1	ضَمَانُ النَّفْحِ
u'ضَمَانٌ نَفْسٌ':Added, #10: 10	ضَمَانُ النَّفْسِ
u'ضَمَانٌ نَفْسٌ':Added, #1: 1	ضَمَانِ نَفْسِ
u'ضَمَانٌ نَفْسٌ':Added, #1: 1	ضَمَانِ نَفْسِهِ
u'ضَمَانٌ نَفْسٌ':Added, #2: 2	ضَمَانُ نَفْسٍ
u'ضَمَانٌ نَفْسٌ':Added, #2: 2	ضَمَانَ نَفْسِهِ
u'ضَمَانٌ نَفْسٌ':Added, #2: 2	ضَمَانُ نَفْسِهِ
u'ضَمَانٌ نَفْسٌ':Added, #3: 3	ضَمَانِ النَّفْسِ
u'ضَمَانٌ نَفْعٌ':Added, #5: 5	ضَمَانَ النَّفْسِ
u'ضَمَانٌ نَفَقَةٌ':Added, #1: 1	ضَمَانِ النَّفْعِ
u'ضَمَانٌ نَفَقَةٌ':Added, #1: 1	ضَمَانَ النَّفَقَةِ
u'ضَمَانٌ نَفَقَةٌ':Added, #1: 1	ضَمَانَ نَفَقَةِ
u'ضَمَانٌ نَفَقَةٌ':Added, #1: 1	ضَمَانِ نَفَقَةِ
u'ضَمَانٌ نَقْصٌ':Added, #5: 5	ضَمَانُ النَّفَقَةِ
u'ضَمَانٌ نَقْصٌ':Added, #1: 1	ضَمَانَ النَّقْصِ
u'ضَمَانٌ نَقْصٌ':Added, #1: 1	ضَمَانِ نَقْصِ
u'ضَمَانٌ نَقْصٌ':Added, #3: 3	ضَمَانُ النَّقْصِ
u'ضَمَانٌ نَقْصٌ':Added, #3: 3	ضَمَانُ نَقْصِهِ
u'ضَمَانٌ نَقْصٌ':Added, #3: 3	ضَمَانِ نَقْصِهِ
u'ضَمَانٌ نَقْصٌ':Added, #4: 4	ضَمَانِ النَّقْصِ
u'ضَمَانٌ نُقْصَانٌ':Added, #6: 6	ضَمَانُ نَقْصِ
u'ضَمَانٌ نُقْصَانٌ':Added, #10: 10	ضَمَانِ النُّقْصَانِ
u'ضَمَانٌ نُقْصَانٌ':Added, #19: 19	ضَمَانُ النُّقْصَانِ
u'ضَمَانٌ نُقْصَانٌ':Added, #1: 1	ضَمَانُ نُقْصَانِهِ
u'ضَمَانٌ نُقْصَانٌ':Added, #3: 3	ضَمَانَ نُقْصَانِ
u'ضَمَانٌ نُقْصَانٌ':Added, #3: 3	ضَمَانُ نُقْصَانِ
u'ضَمَانٌ نَقْضٌ':Added, #6: 6	ضَمَانَ النُّقْصَانِ
u'ضَمَانٌ نقل':Added, #1: 1	ضَمَانُ النَّقْضِ
u'ضَمَانٌ نَقْلٌ':Added, #1: 1	ضَمَانَ النَّقْلِ
u'ضَمَانٌ نقل':Added, #1: 1	ضَمَانَ النَّقْلِ
u'ضَمَانٌ نَقْلٌ':Added, #1: 1	ضَمَانُ نَقْلِ
u'ضَمَانٌ نَقْلٌ':Added, #1: 1	ضَمَانُ نَقْلِ
u'ضَمَانٌ هَادِمٌ':Added, #2: 2	ضَمَانُ نَقْلٍ
u'ضَمَانٌ هَالِكٌ':Added, #1: 1	ضَمَانِ الْهَادِمِ
u'ضَمَانٌ هَالِكٌ':Added, #1: 1	ضَمَانَ الْهَالِكِ
u'ضَمَانٌ وَاقِفٌ':Added, #1: 1	ضَمَانِ الْهَالِكِ
u'ضَمَانٌ وَاقِفٌ':Added, #1: 1	ضَمَانُ الْوَاقِفَةِ
u'ضَمَانٌ وَجْهٌ':Added, #3: 3	ضَمَانُ الْوَاقِفِ
u'ضَمَانٌ وَدِيعٌ':Added, #1: 1	ضَمَانَ الْوَجْهِ
u'ضَمَانٌ وَدِيعَةٌ':Added, #1: 1	ضَمَانَ الْوَدِيعَةِ
u'ضَمَانٌ وَصْفٌ':Added, #1: 1	ضَمَانَ الْوَدِيعَةِ
u'ضَمَانٌ وُلاَةٌ':Added, #2: 2	ضَمَانِ الْوَصْفِ
u'ضَمَانٌ وِلاَدَةٌ':Added, #1: 1	ضَمَانِ الْوُلَاةِ
u'ضَمَانٌ ولد':Added, #1: 1	ضَمَانِ الْوِلَادَةِ
u'ضَمَانٌ وَلَدٌ':Added, #1: 1	ضَمَانِ وَلَدِ
u'ضَمَانٌ ولد':Added, #1: 1	ضَمَانِ وَلَدِ
u'ضَمَانٌ وَلَدٌ':Added, #3: 3	ضَمَانِ الْوَلَدِ
u'ضَمَانٌ وَلِيٌّ':Added, #3: 3	ضَمَانِ الْوَلَدِ
u'ضَمَانٌ وَلِيٌّ':Added, #1: 1	ضَمَانُ الْوَلِيِّ
u'ضَمَانٌ وَلِيٌّ':Added, #1: 1	ضَمَانِ الْوَلِيِّ
u'ضَمَانٌ يَدٌ':Added, #1: 1	ضَمَانُ وَلِيِّ
u'ضَمَانٌ يَدٌ':Added, #10: 10	ضَمَانُ الْيَدِ
u'ضَمَانٌ يَدٌ':Added, #12: 12	ضَمَانِ الْيَدِ
u'ضَمَانٌ يَدٌ':Added, #2: 2	ضَمَانَ الْيَدِ
u'ضَمَانٌ يَدٌ':Added, #2: 2	ضَمَانِ يَدِهِ
u'ضَمَانٌ يَدٌ':Added, #3: 3	ضَمَانُ يَدٍ
u'ضَمَّ بَائِعٌ':Subject, #8: 8	ضَمَانَ يَدٍ
u'ضَمَّ بَيْنٌ':Predicate, #1: 1	ضَمَّ الْبَائِعُ
u'ضَمَّةٌ راء':Added, #1: 1	ضَمَّ بَيْنَ
u'ضَمَّةٌ قَبْرٌ':Added, #1: 1	ضَمَّةُ الرَّاءِ
u'ضَمَّةٌ هاء':Added, #1: 1	ضَمَّةُ الْقَبْرِ
u'ضَمَّةٌ هاء':Added, #1: 1	ضَمَّةُ الْهَاءِ
u'ضَمَّ تاء':Predicate, #1: 1	ضَمَّةِ الْهَاءِ
u'ضَمَّ ثَانِي':Predicate, #2: 2	ضَمَّ التَّاءَ
u'ضَمَّ ثَانِيَةٌ':Predicate, #2: 2	ضَمَّ الثَّانِيَةَ
u'ضَمَّ ثَمَنٌ':Predicate, #2: 2	ضَمَّ الثَّانِيَةَ
u'ضَمَّ جَمِيع':Predicate, #2: 2	ضَمَّ الثَّمَنَ
u'ضَمَّ حَجٌّ':Predicate, #2: 2	ضَمَّ الْجَمِيعَ
u'ضَمَّخَ عتبة':Predicate, #1: 1	ضَمَّ الْحَجَّ
u'ضَمَّخَ عَتَبَةٌ':Predicate, #1: 1	ضَمَّخَ الْعَتَبَةَ
u'ضَمَّخَ كعبة':Predicate, #1: 1	ضَمَّخَ الْعَتَبَةَ
u'ضَمَّخَ كَعْبَةٌ':Predicate, #1: 1	ضَمَّخَ الْكَعْبَةَ
u'ضَمَّ ذِمَّةٌ':Predicate, #1: 1	ضَمَّخَ الْكَعْبَةَ
u'ضَمَّ ذَهَبٌ':Predicate, #1: 1	ضَمَّ الذِّمَّةَ
u'ضَمَّ راء':Predicate, #1: 1	ضَمَّ الذَّهَبَ
u'ضَمَّ رَبُّ':Subject, #1: 1	ضَمَّ الرَّاءَ
u'ضَمَّ سادس':Predicate, #1: 1	ضَمَّ رَبُّ
u'ضَمَّ سَادِسٌ':Predicate, #1: 1	ضَمَّ سَادِسَةً
u'ضَمَّ سَواءٌ':Subject, #1: 1	ضَمَّ سَادِسَةً
u'ضَمَّ سُورَةٌ':Predicate, #1: 1	ضَمَّ سَوَاءٌ
u'ضَمَّ شرب':Predicate, #2: 2	ضَمَّ السُّورَةَ
u'ضَمَّ شِرْبٌ':Predicate, #1: 1	ضَمَّ الشِّرْبَ
u'ضَمَّ ضَارِبٌ':Subject, #1: 1	ضَمَّ الشِّرْبَ
u'ضَمْضَمَ سَابِقٌ':Subject, #1: 1	ضَمَّ الضَّارِبُ
u'ضَمَّ عُرُوضٌ':Predicate, #1: 1	ضَمْضَمَ السَّابِقُ
u'ضَمَّ غَفِيرٌ':Predicate, #1: 1	ضَمَّ الْعُرُوضَ
u'ضَمَّ فاء':Predicate, #1: 1	ضَمَّ الْغَفِيرَ
u'ضَمَّ قَافٌ':Predicate, #1: 1	ضَمَّ الْفَاءَ
u'ضَمَّ قِيمَةٌ':Predicate, #1: 1	ضَمَّ الْقَافَ
u'ضَمَّنَ أَبٌ':Predicate, #2: 2	ضَمَّ قِيمَةَ
u'ضَمِنَ أَبٌ':Subject, #3: 3	ضَمَّنَ الْأَبَ
u'ضَمِنَ أُجْرَةٌ':Predicate, #13: 13	ضَمِنَ الْأَبُ
u'ضَمِنَ أُجْرَةٌ':Predicate, #1: 1	ضَمِنَ الْأُجْرَةَ
u'ضَمِنَ أَجْنَبِيٌّ':Subject, #2: 2	ضَمِنَ أُجْرَةَ
u'ضَمِنَ أَجْنَبِيٌّ':Subject, #1: 1	ضَمِنَ أَجْنَبِيٌّ
u'ضَمِنَ أَجِيرٌ':Subject, #3: 3	ضَمِنَ الْأَجْنَبِيُّ
u'ضَمِنَ أحَدٌ':Predicate, #5: 5	ضَمِنَ الْأَجِيرُ
u'ضَمِنَ أحَدٌ':Subject, #1: 1	ضَمِنَ أَحَدَ
u'ضَمَّنَ أَخٌ':Predicate, #2: 2	ضَمِنَ أَحَدُ
u'ضَمِنَ أَخِيرٌ':Subject, #8: 8	ضَمَّنَ الْأَخَ
u'ضَمِنَ إِسْكافٌ':Subject, #1: 1	ضَمِنَ الْأَخِيرُ
u'ضَمِنَ أصل':Predicate, #1: 1	ضَمِنَ الْإِسْكَافُ
u'ضَمِنَ أًصْلٌ':Predicate, #1: 1	ضَمِنَ الْأَصْلَ
u'ضَمِنَ أُصولٌ':Predicate, #1: 1	ضَمِنَ الْأَصْلَ
u'ضَمَّنَ أُصولٌ':Predicate, #1: 1	ضَمِنَ الْأُصُولَ
u'ضَمِنَ أَغْنَامٌ':Predicate, #3: 3	ضَمَّنَ الْأُصُولَ
u'ضَمِنَ أقَلُّ':Predicate, #1: 1	ضَمِنَ الْأَغْنَامَ
u'ضَمِنَ أقَلُّ':Predicate, #1: 1	ضَمِنَ أَقَلَّ
u'ضَمِنَ أَكْثَرُ':Predicate, #7: 7	ضَمِنَ الْأَقَلَّ
u'ضَمِنَ أَكْثَرُ':Predicate, #1: 1	ضَمِنَ أَكْثَرَ
u'ضَمِنَ ألف':Predicate, #2: 2	ضَمِنَ الْأَكْثَرَ
u'ضَمِنَ ألْفٌ':Predicate, #2: 2	ضَمِنَ الْأَلْفَ
u'ضَمِنَ أَلْفٌ':Predicate, #2: 2	ضَمِنَ الْأَلْفَ
u'ضَمَّنَ الْمَرْأَةُ':Predicate, #2: 2	ضَمِنَ الْأَلْفَ
u'ضَمَّنَ المُشْتَرِي':Predicate, #2: 2	ضَمَّنَ الْمَرْأَةَ
u'ضَمِنَ إمَامٌ':Subject, #27: 27	ضَمَّنَ الْمُشْتَرِيَ
u'ضَمِنَ آمِرٌ':Subject, #3: 3	ضَمِنَ الْإِمَامُ
u'ضَمِنَ أهْلٌ':Subject, #4: 4	ضَمِنَ الْآمِرُ
u'ضَمَّنَ أَوَّلُ':Predicate, #1: 1	ضَمِنَ الْأَهْلُ
u'ضَمِنَ أَوَّلُ':Predicate, #28: 28	ضَمَّنَ الْأَوَّلَ
u'ضَمِنَ أَوَّلُ':Subject, #3: 3	ضَمِنَ الْأَوَّلَ
u'ضَمَّنَ بَائِعٌ':Predicate, #21: 21	ضَمِنَ الْأَوَّلُ
u'ضَمِنَ بَائِعٌ':Predicate, #18: 18	ضَمَّنَ الْبَائِعَ
u'ضَمَّنَ بَائِعٌ':Subject, #1: 1	ضَمِنَ الْبَائِعَ
u'ضَمِنَ بَائِعٌ':Subject, #1: 1	ضَمَّنَ الْبَائِعُ
u'ضَمِنَ بَدَلٌ':Predicate, #8: 8	ضَمِنَ الْبَائِعُ
u'ضَمِنَ بَدَلٌ':Predicate, #2: 2	ضَمِنَ الْبَدَلَ
u'ضَمِنَ بَقّار':Subject, #7: 7	ضَمِنَ بَدَلَ
u'ضَمِنَ بَقِيَّةٌ':Predicate, #1: 1	ضَمِنَ الْبَقَّارُ
u'ضَمِنَ تِبْر':Predicate, #1: 1	ضَمِنَ الْبَقِيَّةَ
u'ضَمِنَ تَخْلِيصٌ':Predicate, #1: 1	ضَمِنَ التِّبْرَ
u'ضَمِنَ تِسْعَةٌ':Predicate, #2: 2	ضَمِنَ تَخْلِيصَ
u'ضَمِنَ تَسْلِيمٌ':Predicate, #1: 1	ضَمِنَ تِسْعَةَ
u'ضَمِنَ تِلْميذٌ':Subject, #3: 3	ضَمِنَ تَسْلِيمَ
u'ضَمَّنَ ثَالِثٌ':Predicate, #1: 1	ضَمِنَ التِّلْمِيذُ
u'ضَمَّنَ ثَالِثٌ':Subject, #3: 3	ضَمَّنَ الثَّالِثَ
u'ضَمِنَ ثَالِثٌ':Subject, #1: 1	ضَمَّنَ الثَّالِثُ
u'ضَمَّنَ ثَانِي':Predicate, #3: 3	ضَمِنَ ثَالِثٌ
u'ضَمِنَ ثَانِي':Predicate, #19: 19	ضَمَّنَ الثَّانِيَ
u'ضَمِنَ ثَانِي':Predicate, #1: 1	ضَمِنَ الثَّانِيَ
u'ضَمِنَ ثَانِي':Subject, #1: 1	ضَمِنَ الثَّانِيَةَ
u'ضَمِنَ ثَانِيَةٌ':Predicate, #1: 1	ضَمِنَ الثَّانِيَةُ
u'ضَمِنَ ثَانِيَةٌ':Subject, #1: 1	ضَمِنَ الثَّانِيَةَ
u'ضَمِنَ ثَمانِين':Predicate, #1: 1	ضَمِنَ الثَّانِيَةُ
u'ضَمِنَ ثَمَنٌ':Predicate, #1: 1	ضَمِنَ ثَمَانِينَ
u'ضَمَّنَ ثَمَنٌ':Predicate, #15: 15	ضَمِنَ الثَّمَنَ
u'ضَمِنَ ثَمَنٌ':Predicate, #1: 1	ضَمَّنَ الثَّمَنَ
u'ضَمِنَ ثَوْبٌ':Predicate, #2: 2	ضَمِنَ ثَمَنَ
u'ضَمِنَ جَارِحٌ':Subject, #1: 1	ضَمِنَ الثَّوْبَ
u'ضَمِنَ جَالِسٌ':Subject, #2: 2	ضَمِنَ الْجَارِحُ
u'ضَمَّنَ جَانِي':Predicate, #1: 1	ضَمِنَ الْجَالِسُ
u'ضَمِنَ جُرْحٌ':Predicate, #2: 2	ضَمَّنَ الْجَانِيَ
u'ضَمِنَ جُزْءٌ':Predicate, #1: 1	ضَمِنَ الْجُرْحَ
u'ضَمِنَ جَزَاءٌ':Predicate, #1: 1	ضَمِنَ الْجُزْءَ
u'ضَمِنَ جَمَّالٌ':Subject, #2: 2	ضَمِنَ الْجَزَاءَ
u'ضَمِنَ جَمِيع':Predicate, #1: 1	ضَمِنَ الْجَمَّالُ
u'ضَمِنَ جَمِيع':Subject, #14: 14	ضَمِنَ الْجَمِيعَ
u'ضَمِنَ جِنَايَةٌ':Predicate, #1: 1	ضَمِنَ الْجَمِيعُ
u'ضَمِنَ حافِرٌ':Subject, #1: 1	ضَمِنَ جِنَايَةَ
u'ضَمِنَ حَديقَةٌ':Predicate, #5: 5	ضَمِنَ الْحَافِرُ
u'ضَمِنَ حُرٌّ':Subject, #1: 1	ضَمِنَ حَدِيقَةَ
u'ضَمِنَ حِصَّةٌ':Predicate, #2: 2	ضَمِنَ الْحُرُّ
u'ضَمِنَ حَقٌّ':Predicate, #7: 7	ضَمِنَ حِصَّةَ
u'ضَمِنَ حَلالٌ':Subject, #2: 2	ضَمِنَ حَقَّ
u'ضَمِنَ حَمَّالٌ':Subject, #1: 1	ضَمِنَ الْحَلَالُ
u'ضَمِنَ خلاص':Predicate, #2: 2	ضَمِنَ الْحَمَّالُ
u'ضَمِنَ خَلاَصٌ':Predicate, #1: 1	ضَمِنَ الْخَلَاصَ
u'ضَمِنَ خِلاَفَةٌ':Predicate, #1: 1	ضَمِنَ الْخَلَاصَ
u'ضَمِنَ خُمُسٌ':Predicate, #1: 1	ضَمِنَ الْخِلَافَةَ
u'ضَمِنَ خَمْسَةٌ':Predicate, #4: 4	ضَمِنَ خُمُسَ
u'ضَمِنَ خَمْسَةٌ':Predicate, #1: 1	ضَمِنَ الْخَمْسَةَ
u'ضَمِنَ خَيَّاطٌ':Subject, #2: 2	ضَمِنَ خَمْسَةَ
u'ضَمِنَ دَابَّةٌ':Predicate, #1: 1	ضَمِنَ الْخَيَّاطُ
u'ضَمَّنَ دَافِعٌ':Predicate, #1: 1	ضَمِنَ الدَّابَّةَ
u'ضَمِنَ دَافِعٌ':Subject, #7: 7	ضَمَّنَ الدَّافِعَ
u'ضَمِنَ دَرَاهِمُ':Predicate, #4: 4	ضَمِنَ الدَّافِعُ
u'ضَمِنَ دَرَكٌ':Predicate, #2: 2	ضَمِنَ دَرَاهِمَ
u'ضَمِنَ دونٌ':Predicate, #2: 2	ضَمِنَ الدَّرَكَ
u'ضَمِنَ دِيَةٌ':Predicate, #1: 1	ضَمِنَ دُونَ
u'ضَمِنَ دِيَةٌ':Predicate, #3: 3	ضَمِنَ دِيَةَ
u'ضَمِنَ دَيْنٌ':Predicate, #9: 9	ضَمِنَ الدِّيَةَ
u'ضَمِنَ ذِمِّيٌّ':Subject, #6: 6	ضَمِنَ الدَّيْنَ
u'ضَمِنَ رَاجِعٌ':Subject, #2: 2	ضَمِنَ ذِمِّيٌّ
u'ضَمِنَ رَأْسٌ':Predicate, #2: 2	ضَمِنَ الرَّاجِعُ
u'ضَمَّنَ رَاعِي':Predicate, #2: 2	ضَمِنَ رَأْسَ
u'ضَمَّنَ رَاكِبٌ':Predicate, #1: 1	ضَمَّنَ الرَّاعِيَ
u'ضَمِنَ رَاكِبٌ':Subject, #2: 2	ضَمَّنَ الرَّاكِبَ
u'ضَمِنَ رَاكِبٌ':Subject, #1: 1	ضَمِنَ رَاكِبٌ
u'ضَمَّنَ رَاهِنٌ':Predicate, #2: 2	ضَمِنَ الرَّاكِبُ
u'ضَمِنَ رَاهِنٌ':Subject, #15: 15	ضَمَّنَ الرَّاهِنَ
u'ضَمَّنَ رَبُّ':Predicate, #3: 3	ضَمِنَ الرَّاهِنُ
u'ضَمِنَ رَبُّ':Subject, #1: 1	ضَمَّنَ رَبَّ
u'ضَمِنَ رَبُّ':Subject, #1: 1	ضَمِنَ رَبُّهُ
u'ضَمِنَ رِبْحٌ':Predicate, #2: 2	ضَمِنَ رَبُّ
u'ضَمِنَ رُبُعٌ':Predicate, #1: 1	ضَمِنَ الرِّبْحَ
u'ضَمِنَ رُبُعٌ':Predicate, #2: 2	ضَمِنَ الرُّبُعَ
u'ضَمِنَ رُبْعٌ':Predicate, #3: 3	ضَمِنَ رُبُعَ
u'ضَمِنَ رَجُلٌ':Subject, #3: 3	ضَمِنَ رُبْعَ
u'ضَمِنَ رَجُلٌ':Subject, #4: 4	ضَمِنَ الرَّجُلُ
u'ضَمِنَ رَدٌّ':Predicate, #7: 7	ضَمِنَ رَجُلٌ
u'ضَمَّنَ رَدِيفٌ':Predicate, #1: 1	ضَمِنَ رَدَّ
u'ضَمِنَ رِزْقٌ':Predicate, #3: 3	ضَمَّنَ الرَّدِيفَ
u'ضَمَّنَ رَسُولٌ':Predicate, #1: 1	ضَمِنَ الرِّزْقَ
u'ضَمِنَ رَسُولٌ':Subject, #2: 2	ضَمَّنَ الرَّسُولَ
u'ضَمِنَ رَسُولٌ':Subject, #1: 1	ضَمِنَ رَسُولُهُ
u'ضَمِنَ رَهْنٌ':Predicate, #2: 2	ضَمِنَ الرَّسُولُ
u'ضَمِنَ زائِدٌ':Predicate, #2: 2	ضَمِنَ الرَّهْنَ
u'ضَمِنَ زَرْعٌ':Predicate, #5: 5	ضَمِنَ الزَّائِدَ
u'ضَمِنَ زَكاةٌ':Predicate, #1: 1	ضَمِنَ الزَّرْعَ
u'ضَمِنَ زَكاةٌ':Predicate, #1: 1	ضَمِنَ الزَّكَاةَ
u'ضَمِنَ زَمَنٌ':Predicate, #1: 1	ضَمِنَ زَكَاةَ
u'ضَمَّنَ زَوْجٌ':Predicate, #1: 1	ضَمِنَ زَمَنَ
u'ضَمِنَ زَوْجٌ':Subject, #2: 2	ضَمَّنَ الزَّوْجَ
u'ضَمِنَ زِيادَةٌ':Predicate, #3: 3	ضَمِنَ الزَّوْجُ
u'ضَمِنَ زَيْدٌ':Subject, #6: 6	ضَمِنَ الزِّيَادَةَ
u'ضَمِنَ سَاكِتٌ':Predicate, #1: 1	ضَمِنَ زَيْدٌ
u'ضَمِنَ سَاكِتٌ':Subject, #1: 1	ضَمِنَ السَّاكِتَ
u'ضَمَّنَ سَاكِتٌ':Subject, #1: 1	ضَمِنَ السَّاكِتُ
u'ضَمِنَ سَاكِنٌ':Subject, #2: 2	ضَمَّنَ السَّاكِتُ
u'ضَمَّنَ سَائِسٌ':Predicate, #1: 1	ضَمِنَ السَّاكِنُ
u'ضَمَّنَ سَائِقٌ':Predicate, #1: 1	ضَمَّنَ السَّائِسَ
u'ضَمِنَ سَائِقٌ':Subject, #1: 1	ضَمَّنَ سَائِقَ
u'ضَمِنَ سَرقَةٌ':Predicate, #2: 2	ضَمِنَ السَّائِقُ
u'ضَمِنَ سَرِقَةٌ':Predicate, #2: 2	ضَمِنَ السَّرِقَةَ
u'ضَمِنَ سُقُوطٌ':Predicate, #2: 2	ضَمِنَ السَّرِقَةَ
u'ضَمِنَ سَلاَمَةٌ':Predicate, #1: 1	ضَمِنَ سُقُوطَ
u'ضَمِنَ سَلاَمَةٌ':Predicate, #1: 1	ضَمِنَ السَّلَامَةَ
u'ضَمَّنَ سُلْطَانٌ':Predicate, #1: 1	ضَمِنَ سَلَامَةَ
u'ضَمِنَ سُلْطَانٌ':Subject, #1: 1	ضَمَّنَ السُّلْطَانَ
u'ضَمِنَ سَواءٌ':Subject, #3: 3	ضَمِنَ السُّلْطَانُ
u'ضَمِنَ سَيِّدٌ':Subject, #2: 2	ضَمِنَ سَوَاءٌ
u'ضَمِنَ شَاهِدٌ':Subject, #6: 6	ضَمِنَ السَّيِّدُ
u'ضَمِنَ شَجَرَةٌ':Predicate, #2: 2	ضَمِنَ شَاهِدُ
u'ضَمِنَ شَخْصٌ':Subject, #1: 1	ضَمِنَ الشَّجَرَةَ
u'ضَمَّنَ شَرِيكٌ':Predicate, #3: 3	ضَمِنَ شَخْصٌ
u'ضَمِنَ شَرِيكٌ':Subject, #1: 1	ضَمَّنَ الشَّرِيكَ
u'ضَمِنَ شَفِيعٌ':Subject, #6: 6	ضَمِنَ شَرِيكُهُ
u'ضَمَّنَ شُهُودٌ':Predicate, #1: 1	ضَمِنَ الشَّفِيعُ
u'ضَمَّنَ شُهُودٌ':Predicate, #4: 4	ضَمَّنَ شُهُودَ
u'ضَمِنَ شُهُودٌ':Subject, #6: 6	ضَمَّنَ الشُّهُودَ
u'ضَمِنَ شُهُودٌ':Subject, #1: 1	ضَمِنَ شُهُودُهُ
u'ضَمِنَ شَيْءٌ':Predicate, #9: 9	ضَمِنَ شُهُودُ
u'ضَمَّنَ صَاحِبٌ':Predicate, #3: 3	ضَمِنَ الشَّيْءَ
u'ضَمِنَ صَاحِبٌ':Subject, #2: 2	ضَمَّنَ صَاحِبَ
u'ضَمِنَ صَبَّاغٌ':Predicate, #10: 10	ضَمِنَ صَاحِبُ
u'ضَمِنَ صَبْغٌ':Predicate, #1: 1	ضَمِنَ الصَّبَّاغَ
u'ضَمِنَ صَبِيٌّ':Subject, #1: 1	ضَمِنَ الصَّبْغَ
u'ضَمِنَ صداق':Predicate, #2: 2	ضَمِنَ الصَّبِيُّ
u'ضَمِنَ صَدَاقٌ':Predicate, #1: 1	ضَمِنَ الصَّدَاقَ
u'ضَمِنَ صداق':Predicate, #1: 1	ضَمِنَ الصَّدَاقَ
u'ضَمِنَ صَدَاقٌ':Predicate, #1: 1	ضَمِنَ صَدَاقَ
u'ضَمِنَ صَيْدٌ':Predicate, #1: 1	ضَمِنَ صَدَاقَ
u'ضَمِنَ ضَامِنٌ':Subject, #1: 1	ضَمِنَ الصَّيْدَ
u'ضَمِنَ ضَمَانٌ':Predicate, #1: 1	ضَمِنَ الضَّامِنُ
u'ضَمِنَ طَحَّانٌ':Subject, #1: 1	ضَمِنَ ضَمَانَ
u'ضَمَّنَ عَاقِلٌ':Predicate, #1: 1	ضَمِنَ الطَّحَّانُ
u'ضَمَّنَ عَاقِلٌ':Predicate, #1: 1	ضَمَّنَ الْعَاقِلَةَ
u'ضَمِنَ عَاقِلٌ':Subject, #2: 2	ضَمَّنَ عَاقِلَةَ
u'ضَمِنَ عَاقِلٌ':Subject, #1: 1	ضَمِنَ عَاقِلَتُهُ
u'ضَمَّنَ عَامِلٌ':Predicate, #3: 3	ضَمِنَ عَاقِلَةُ
u'ضَمِنَ عَبْدٌ':Subject, #1: 1	ضَمَّنَ الْعَامِلَ
u'ضَمَّنَ عَبْدٌ':Subject, #1: 1	ضَمِنَ عَبْدٌ
u'ضَمِنَ عَبْدٌ':Subject, #1: 1	ضَمَّنَ عَبْدُ
u'ضَمَّنَ عَدْلٌ':Predicate, #2: 2	ضَمِنَ الْعَبْدُ
u'ضَمِنَ عَدْلٌ':Subject, #5: 5	ضَمَّنَ الْعَدْلَ
u'ضَمِنَ عُشْرٌ':Predicate, #8: 8	ضَمِنَ الْعَدْلُ
u'ضَمِنَ عُشْرٌ':Predicate, #1: 1	ضَمِنَ الْعُشْرَ
u'ضَمِنَ عقر':Predicate, #1: 1	ضَمِنَ عُشْرَ
u'ضَمِنَ عُقْرٌ':Predicate, #1: 1	ضَمِنَ الْعُقْرَ
u'ضَمِنَ عَمَلٌ':Predicate, #1: 1	ضَمِنَ الْعُقْرَ
u'ضَمِنَ عند':Predicate, #1: 1	ضَمِنَ الْعَمَلَ
u'ضَمِنَ عُهْدَةٌ':Predicate, #13: 13	ضَمِنَ عِنْدَ
u'ضَمِنَ عُهْدَةٌ':Predicate, #1: 1	ضَمِنَ الْعُهْدَةَ
u'ضَمِنَ عين':Predicate, #2: 2	ضَمِنَ عُهْدَةَ
u'ضَمِنَ عَيْنٌ':Predicate, #1: 1	ضَمِنَ الْعَيْنَ
u'ضَمِنَ عَيْن':Predicate, #1: 1	ضَمِنَ الْعَيْنَ
u'ضَمَّنَ غَاصِبٌ':Predicate, #1: 1	ضَمِنَ الْعَيْنَ
u'ضَمِنَ غَاصِبٌ':Subject, #37: 37	ضَمَّنَ الْغَاصِبَ
u'ضَمِنَ غَاصِبٌ':Subject, #1: 1	ضَمِنَ غَاصِبُ
u'ضَمِنَ غرماء':Subject, #31: 31	ضَمِنَ الْغَاصِبُ
u'ضَمِنَ غَرِيمٌ':Subject, #1: 1	ضَمِنَ الْغُرَمَاءُ
u'ضَمِنَ غَسّال':Predicate, #2: 2	ضَمِنَ الْغَرِيمُ
u'ضَمَّنَ غَسّال':Predicate, #1: 1	ضَمِنَ الْغَسَّالَ
u'ضَمِنَ غير':Predicate, #1: 1	ضَمَّنَ الْغَسَّالَ
u'ضَمَّنَ غير':Predicate, #1: 1	ضَمِنَ غَيْرَ
u'ضَمِنَ غَيْرٌ':Predicate, #1: 1	ضَمَّنَ غَيْرَ
u'ضَمَّنَ غَيْرٌ':Predicate, #1: 1	ضَمِنَ غَيْرَ
u'ضَمِنَ غير':Subject, #1: 1	ضَمَّنَ غَيْرَ
u'ضَمِنَ غَيْرٌ':Subject, #1: 1	ضَمِنَ غَيْرُهُ
u'ضَمِنَ فَاعِلٌ':Subject, #1: 1	ضَمِنَ غَيْرُهُ
u'ضَمِنَ فَرْخٌ':Predicate, #1: 1	ضَمِنَ الْفَاعِلُ
u'ضَمِنَ فَرْعٌ':Subject, #3: 3	ضَمِنَ الْفَرْخَ
u'ضَمِنَ فَرْعٌ':Subject, #1: 1	ضَمِنَ فَرْعٌ
u'ضَمِنَ فُرُوعٌ':Predicate, #2: 2	ضَمِنَ الْفَرْعُ
u'ضَمَّنَ فُرُوعٌ':Predicate, #1: 1	ضَمِنَ الْفُرُوعَ
u'ضَمِنَ فُرُوعٌ':Subject, #4: 4	ضَمَّنَ الْفُرُوعَ
u'ضَمِنَ فَرِيقٌ':Subject, #1: 1	ضَمِنَ الْفُرُوعُ
u'ضَمِنَ فساد':Predicate, #1: 1	ضَمِنَ فَرِيقُ
u'ضَمِنَ فَسَادٌ':Predicate, #1: 1	ضَمِنَ فَسَادَ
u'ضَمَّنَ فَقِيرٌ':Predicate, #1: 1	ضَمِنَ فَسَادَ
u'ضَمِنَ فَقِيرٌ':Subject, #1: 1	ضَمَّنَ الْفَقِيرَ
u'ضَمِنَ فُلاَنٌ':Subject, #1: 1	ضَمِنَ الْفَقِيرُ
u'ضَمِنَ فُلُوسٌ':Predicate, #4: 4	ضَمِنَ فُلَانٌ
u'ضَمَّنَ قَابِضٌ':Predicate, #2: 2	ضَمِنَ الْفُلُوسَ
u'ضَمِنَ قَابِضٌ':Subject, #5: 5	ضَمَّنَ الْقَابِضَ
u'ضَمِنَ قَابِضٌ':Subject, #1: 1	ضَمِنَ قَابِضُ
u'ضَمَّنَ قَابِلٌ':Predicate, #3: 3	ضَمِنَ الْقَابِضُ
u'ضَمِنَ قَابِلٌ':Subject, #1: 1	ضَمَّنَ الْقَابِلَ
u'ضَمَّنَ قَاتِلٌ':Predicate, #1: 1	ضَمِنَ الْقَابِلُ
u'ضَمِنَ قَاتِلٌ':Subject, #3: 3	ضَمَّنَ الْقَاتِلَ
u'ضَمَّنَ قَاطِعٌ':Predicate, #5: 5	ضَمِنَ الْقَاتِلُ
u'ضَمِنَ قَاطِعٌ':Subject, #1: 1	ضَمَّنَ الْقَاطِعَ
u'ضَمِنَ قَالٌ':Predicate, #5: 5	ضَمِنَ الْقَاطِعُ
u'ضَمَّنَ قَالِعٌ':Predicate, #8: 8	ضَمِنَ قَالَ
u'ضَمِنَ قَائِدٌ':Subject, #2: 2	ضَمَّنَ الْقَالِعَ
u'ضَمِنَ قَائِلٌ':Subject, #2: 2	ضَمِنَ الْقَائِدُ
u'ضَمِنَ قَدْرٌ':Predicate, #1: 1	ضَمِنَ الْقَائِلُ
u'ضَمَّنَ قَيِّمٌ':Predicate, #6: 6	ضَمِنَ قَدْرَ
u'ضَمِنَ قَيِّمٌ':Subject, #2: 2	ضَمَّنَ الْقَيِّمَ
u'ضَمَّنَ قِيمَةٌ':Predicate, #1: 1	ضَمِنَ الْقَيِّمُ
u'ضَمِنَ قِيمَةٌ':Predicate, #1: 1	ضَمَّنَ قِيمَةَ
u'ضَمِنَ قِيمَةٌ':Predicate, #31: 31	ضَمِنَ الْقِيمَةَ
u'ضَمِنَ قِيمَةٌ':Subject, #34: 34	ضَمِنَ قِيمَةَ
u'ضَمِنَ قِيمَةٌ':Subject, #1: 1	ضَمِنَ قِيمَةُ
u'ضَمِنَ كَفِيلٌ':Subject, #1: 1	ضَمِنَ قِيمَتُهُ
u'ضَمِنَ كَمَالٌ':Predicate, #3: 3	ضَمِنَ الْكَفِيلُ
u'ضَمَّنَ لَفْظٌ':Predicate, #1: 1	ضَمِنَ كَمَالَ
u'ضَمِنَ مَاءٌ':Predicate, #1: 1	ضَمَّنَ لَفْظَ
u'ضَمِنَ مَالٌ':Predicate, #3: 3	ضَمِنَ الْمَاءَ
u'ضَمِنَ مَالٌ':Predicate, #24: 24	ضَمِنَ الْمَالَ
u'ضَمَّنَ مَالِكٌ':Subject, #4: 4	ضَمِنَ مَالَ
u'ضَمَّنَ مَالِكٌ':Subject, #1: 1	ضَمَّنَ مَالِكُهُ
u'ضَمِنَ مَالِكٌ':Subject, #2: 2	ضَمَّنَ مَالِكٌ
u'ضَمَّنَ مَالِكٌ':Subject, #6: 6	ضَمِنَ الْمَالِكُ
u'ضَمَّنَ مَأْمُورٌ':Predicate, #6: 6	ضَمَّنَ الْمَالِكُ
u'ضَمِنَ مَأْمُورٌ':Subject, #1: 1	ضَمَّنَ الْمَأْمُورَ
u'ضَمِنَ مُبَاشِرٌ':Subject, #1: 1	ضَمِنَ الْمَأْمُورُ
u'ضَمِنَ مَبِيعٌ':Predicate, #1: 1	ضَمِنَ الْمُبَاشِرُ
u'ضَمِنَ مَتَاعٌ':Predicate, #2: 2	ضَمِنَ الْمَبِيعَ
u'ضَمِنَ مُتَسَبِّبٌ':Subject, #1: 1	ضَمِنَ الْمَتَاعَ
u'ضَمِنَ مُتَشَبِّثٌ':Subject, #1: 1	ضَمِنَ الْمُتَسَبِّبُ
u'ضَمِنَ مُتَقَدِّمٌ':Subject, #1: 1	ضَمِنَ الْمُتَشَبِّثُ
u'ضَمَّنَ مُتْلِفٌ':Predicate, #1: 1	ضَمِنَ الْمُتَقَدِّمُ
u'ضَمِنَ مثل':Predicate, #1: 1	ضَمَّنَ الْمُتْلِفَ
u'ضَمِنَ مِثْلٌ':Predicate, #1: 1	ضَمِنَ الْمِثْلَ
u'ضَمِنَ مثل':Predicate, #1: 1	ضَمِنَ الْمِثْلَ
u'ضَمِنَ مِثْلٌ':Predicate, #5: 5	ضَمِنَ مِثْلَ
u'ضَمِنَ مُثَمَّنٌ':Predicate, #5: 5	ضَمِنَ مِثْلَ
u'ضَمِنَ مَجْرُوحٌ':Predicate, #1: 1	ضَمِنَ الْمُثَمَّنَ
u'ضَمَّنَ مُحْرِقٌ':Predicate, #2: 2	ضَمِنَ الْمَجْرُوحَ
u'ضَمِنَ مُحْرِمٌ':Subject, #1: 1	ضَمَّنَ الْمُحْرِقَ
u'ضَمَّنَ مُدَبَّرٌ':Predicate, #1: 1	ضَمِنَ الْمُحْرِمُ
u'ضَمَّنَ مُدَبِّرٌ':Predicate, #1: 1	ضَمَّنَ الْمُدَبَّرَ
u'ضَمِنَ مُدَبِّرٌ':Subject, #1: 1	ضَمَّنَ الْمُدَبِّرَ
u'ضَمَّنَ مُدَبِّرٌ':Subject, #1: 1	ضَمِنَ الْمُدَبِّرُ
u'ضَمِنَ مُدَبَّرٌ':Subject, #1: 1	ضَمَّنَ الْمُدَبِّرُ
u'ضَمِنَ مَدْيُونٌ':Subject, #4: 4	ضَمِنَ الْمُدَبَّرُ
u'ضَمَّنَ مَدْيُونٌ':Subject, #1: 1	ضَمِنَ الْمَدْيُونُ
u'ضَمَّنَ مُرْتَهِنٌ':Predicate, #1: 1	ضَمَّنَ الْمَدْيُونُ
u'ضَمِنَ مُرْتَهِنٌ':Subject, #19: 19	ضَمَّنَ الْمُرْتَهِنَ
u'ضَمِنَ مُرْسِلٌ':Subject, #7: 7	ضَمِنَ الْمُرْتَهِنُ
u'ضَمِنَ مُرْسِلٌ':Subject, #2: 2	ضَمِنَ الْمُرْسِلُ
u'ضَمِنَ مَرِيضٌ':Subject, #3: 3	ضَمِنَ مُرْسِلُهُ
u'ضَمَّنَ مُزَارِعٌ':Predicate, #2: 2	ضَمِنَ الْمَرِيضُ
u'ضَمِنَ مُزَارِعٌ':Subject, #1: 1	ضَمَّنَ الْمُزَارِعَ
u'ضَمَّنَ مُسْتَأْجِرٌ':Predicate, #1: 1	ضَمِنَ الْمُزَارِعُ
u'ضَمِنَ مُسْتَأْجِرٌ':Subject, #11: 11	ضَمَّنَ الْمُسْتَأْجِرَ
u'ضَمَّنَ مُسْتَبْضِع':Predicate, #7: 7	ضَمِنَ الْمُسْتَأْجِرُ
u'ضَمَّنَ مُسْتَحِقٌّ':Subject, #1: 1	ضَمَّنَ الْمُسْتَبْضِعَ
u'ضَمِنَ مُسْتَحِقٌّ':Subject, #3: 3	ضَمَّنَ الْمُسْتَحِقُّ
u'ضَمِنَ مُسْتَعْمِلٌ':Subject, #5: 5	ضَمِنَ الْمُسْتَحِقُّ
u'ضَمَّنَ مُسْتَعِيرٌ':Predicate, #2: 2	ضَمِنَ الْمُسْتَعْمِلُ
u'ضَمِنَ مُسْتَعِيرٌ':Subject, #9: 9	ضَمَّنَ الْمُسْتَعِيرَ
u'ضَمَّنَ مُسْتَوْدَعٌ':Predicate, #7: 7	ضَمِنَ الْمُسْتَعِيرُ
u'ضَمِنَ مُسْتَوْدَعٌ':Subject, #1: 1	ضَمَّنَ الْمُسْتَوْدَعَ
u'ضَمَّنَ مِسْكِينٌ':Predicate, #4: 4	ضَمِنَ الْمُسْتَوْدَعُ
u'ضَمِنَ مِسْكِينٌ':Subject, #1: 1	ضَمَّنَ الْمِسْكِينَ
u'ضَمِنَ مُسَلَّمٌ':Subject, #2: 2	ضَمِنَ الْمِسْكِينُ
u'ضَمَّنَ مُشْتَرِي':Predicate, #1: 1	ضَمِنَ الْمُسَلَّمُ
u'ضَمِنَ مَشْهُودٌ':Subject, #27: 27	ضَمَّنَ الْمُشْتَرِيَ
u'ضَمِنَ مُصَالِحٌ':Subject, #1: 1	ضَمِنَ الْمَشْهُودُ
u'ضَمَّنَ مُضَارِبٌ':Predicate, #1: 1	ضَمِنَ الْمُصَالِحُ
u'ضَمِنَ مُضَارِبٌ':Subject, #5: 5	ضَمَّنَ الْمُضَارِبَ
u'ضَمَّنَ مُعَالِجٌ':Predicate, #5: 5	ضَمِنَ الْمُضَارِبُ
u'ضَمَّنَ مُعْتَقٌ':Predicate, #2: 2	ضَمَّنَ الْمُعَالِجَ
u'ضَمِنَ مُعْتَقٌ':Predicate, #1: 1	ضَمَّنَ الْمُعْتَقَ
u'ضَمَّنَ مُعْتَقٌ':Subject, #3: 3	ضَمِنَ الْمُعْتَقَ
u'ضَمِنَ مُعْتَقٌ':Subject, #1: 1	ضَمَّنَ الْمُعْتَقُ
u'ضَمِنَ مُعْسِرٌ':Subject, #7: 7	ضَمِنَ الْمُعْتَقُ
u'ضَمَّنَ مُعِير':Predicate, #1: 1	ضَمِنَ مُعْسِرٌ
u'ضَمَّنَ مُعِير':Subject, #4: 4	ضَمَّنَ الْمُعِيرَ
u'ضَمِنَ مُعِير':Subject, #1: 1	ضَمَّنَ الْمُعِيرُ
u'ضَمِنَ مَغْرُورٌ':Subject, #2: 2	ضَمِنَ الْمُعِيرُ
u'ضَمِنَ مِقْدَارٌ':Predicate, #1: 1	ضَمِنَ الْمَغْرُورُ
u'ضَمَّنَ مُقْرِضٌ':Predicate, #2: 2	ضَمِنَ مِقْدَارَ
u'ضَمِنَ مُقْرِضٌ':Subject, #3: 3	ضَمَّنَ الْمُقْرِضَ
u'ضَمَّنَ مُكْرِهٌ':Predicate, #1: 1	ضَمِنَ الْمُقْرِضُ
u'ضَمَّنَ مُكْرَهٌ':Predicate, #13: 13	ضَمَّنَ الْمُكْرِهَ
u'ضَمَّنَ مُكْرِهٌ':Subject, #2: 2	ضَمَّنَ الْمُكْرَهَ
u'ضَمِنَ مُكْرِهٌ':Subject, #3: 3	ضَمَّنَ الْمُكْرِهُ
u'ضَمَّنَ مُكْرَهٌ':Subject, #4: 4	ضَمِنَ الْمُكْرِهُ
u'ضَمِنَ مُكْرَهٌ':Subject, #5: 5	ضَمَّنَ الْمُكْرَهُ
u'ضَمَّنَ مُلْتَقِط':Predicate, #8: 8	ضَمِنَ الْمُكْرَهُ
u'ضَمِنَ مُلْتَقِط':Subject, #3: 3	ضَمَّنَ الْمُلْتَقِطَ
u'ضَمِنَ مَلَكٌ':Predicate, #8: 8	ضَمِنَ الْمُلْتَقِطُ
u'ضَمِنَ مُمْسِكٌ':Subject, #2: 2	ضَمِنَ مَلَكَ
u'ضَمِنَ مَنْفَعَةٌ':Predicate, #3: 3	ضَمِنَ الْمُمْسِكُ
u'ضَمِنَ مَهْرٌ':Predicate, #1: 1	ضَمِنَ الْمَنْفَعَةَ
u'ضَمِنَ مَهْرٌ':Predicate, #1: 1	ضَمِنَ مَهْرَ
u'ضَمَّنَ مُؤَجِّرٌ':Predicate, #8: 8	ضَمِنَ الْمَهْرَ
u'ضَمِنَ مُؤَجَّلٌ':Predicate, #1: 1	ضَمَّنَ الْمُؤَجِّرَ
u'ضَمَّنَ مُودِعٌ':Predicate, #4: 4	ضَمِنَ الْمُؤَجَّلَ
u'ضَمَّنَ مُودَعٌ':Predicate, #2: 2	ضَمَّنَ الْمُودِعَ
u'ضَمِنَ مُودِعٌ':Subject, #7: 7	ضَمَّنَ الْمُودَعَ
u'ضَمَّنَ مُودَعٌ':Subject, #1: 1	ضَمِنَ الْمُودِعُ
u'ضَمِنَ مُودَعٌ':Subject, #1: 1	ضَمَّنَ الْمُودَعُ
u'ضَمِنَ مُودَعٌ':Subject, #2: 2	ضَمِنَ مُودَعُ
u'ضَمَّنَ مَوْهُوبٌ':Predicate, #4: 4	ضَمِنَ الْمُودَعُ
u'ضَمِنَ مَوْهُوبٌ':Subject, #3: 3	ضَمَّنَ الْمَوْهُوبَ
u'ضَمِنَ نَاظِرٌ':Subject, #1: 1	ضَمِنَ الْمَوْهُوبُ
u'ضَمِنَ نَاقِدٌ':Subject, #2: 2	ضَمِنَ النَّاظِرُ
u'ضَمِنَ نَائِمٌ':Subject, #1: 1	ضَمِنَ النَّاقِدُ
u'ضَمِنَ نِصْفٌ':Predicate, #1: 1	ضَمِنَ النَّائِمُ
u'ضَمَّنَ نِصْفٌ':Predicate, #12: 12	ضَمِنَ النِّصْفَ
u'ضَمِنَ نِصْفٌ':Predicate, #1: 1	ضَمَّنَ نِصْفَ
u'ضَمِنَ نَصِيبٌ':Predicate, #37: 37	ضَمِنَ نِصْفَ
u'ضَمِنَ نَفْحَةٌ':Predicate, #13: 13	ضَمِنَ نَصِيبَ
u'ضَمِنَ نَفَذٌ':Predicate, #1: 1	ضَمِنَ النَّفْحَةَ
u'ضَمِنَ نَفْسٌ':Predicate, #1: 1	ضَمِنَ نَفَذَ
u'ضَمِنَ نَفَقَةٌ':Predicate, #2: 2	ضَمِنَ نَفْسَ
u'ضَمِنَ نَفَقَةٌ':Predicate, #1: 1	ضَمِنَ النَّفَقَةَ
u'ضَمِنَ نَقْدٌ':Predicate, #2: 2	ضَمِنَ نَفَقَةَ
u'ضَمِنَ نَقْد':Predicate, #2: 2	ضَمِنَ النَّقْدَ
u'ضَمِنَ نَقْصٌ':Predicate, #2: 2	ضَمِنَ النَّقْدَ
u'ضَمِنَ نَقْصٌ':Predicate, #7: 7	ضَمِنَ نَقْصَ
u'ضَمِنَ نُقْصَانٌ':Predicate, #9: 9	ضَمِنَ النَّقْصَ
u'ضَمَّنَ نُقْصَانٌ':Predicate, #18: 18	ضَمِنَ النُّقْصَانَ
u'ضَمِنَ نُقْصَانٌ':Predicate, #1: 1	ضَمَّنَ نُقْصَانَ
u'ضَمِنَ هَدْمٌ':Predicate, #2: 2	ضَمِنَ نُقْصَانَ
u'ضَمِنَ هَدْمٌ':Predicate, #1: 1	ضَمِنَ الْهَدْمَ
u'ضَمِنَ وَاجِبٌ':Predicate, #1: 1	ضَمِنَ هَدْمَ
u'ضَمَّنَ وَارِثٌ':Predicate, #2: 2	ضَمِنَ الْوَاجِبَ
u'ضَمِنَ وَارِثٌ':Subject, #2: 2	ضَمَّنَ الْوَارِثَ
u'ضَمِنَ وَاضِعٌ':Subject, #3: 3	ضَمِنَ الْوَارِثُ
u'ضَمِنَ وَاضِعٌ':Subject, #1: 1	ضَمِنَ وَاضِعُ
u'ضَمِنَ وَاقِفٌ':Subject, #2: 2	ضَمِنَ الْوَاضِعُ
u'ضَمَّنَ وَاهِبٌ':Predicate, #1: 1	ضَمِنَ الْوَاقِفُ
u'ضَمِنَ وَاهِبٌ':Subject, #5: 5	ضَمَّنَ الْوَاهِبَ
u'ضَمِنَ وَدِيعٌ':Predicate, #2: 2	ضَمِنَ الْوَاهِبُ
u'ضَمِنَ وَدِيعَةٌ':Predicate, #1: 1	ضَمِنَ الْوَدِيعَةَ
u'ضَمَّنَ وَصِيٌّ':Predicate, #1: 1	ضَمِنَ الْوَدِيعَةَ
u'ضَمِنَ وَصِيٌّ':Subject, #3: 3	ضَمَّنَ الْوَصِيَّ
u'ضَمِنَ وقع':Predicate, #9: 9	ضَمِنَ الْوَصِيُّ
u'ضَمَّنَ وَكِيلٌ':Predicate, #1: 1	ضَمِنَ وَقَعَ
u'ضَمِنَ وَكِيلٌ':Subject, #13: 13	ضَمَّنَ الْوَكِيلَ
u'ضَمِنَ وَكِيلٌ':Subject, #22: 22	ضَمِنَ الْوَكِيلُ
u'ضَمِنَ ولد':Predicate, #2: 2	ضَمِنَ وَكِيلُ
u'ضَمِنَ وَلَدٌ':Predicate, #1: 1	ضَمِنَ وَلَدَ
u'ضَمَّنَ وَلِيٌّ':Predicate, #1: 1	ضَمِنَ وَلَدَ
u'ضَمَّنَ وَلِيٌّ':Subject, #1: 1	ضَمَّنَ الْوَلِيَّ
u'ضَمِنَ وَلِيٌّ':Subject, #1: 1	ضَمَّنَ الْوَلِيُّ
u'ضَمِنَ يَوْمٌ':Predicate, #6: 6	ضَمِنَ الْوَلِيُّ
u'ضَمَّ وَدِيعٌ':Predicate, #1: 1	ضَمِنَ يَوْمَ
u'ضَمَّ وَدِيعَةٌ':Predicate, #1: 1	ضَمَّ الْوَدِيعَةَ
u'ضَمَّ وَصْفٌ':Predicate, #1: 1	ضَمَّ الْوَدِيعَةَ
u'ضَنْكٌ حالٌ':Added, #1: 1	ضَمَّ وَصْفَ
u'ضَنَّ نَاسٌ':Subject, #1: 1	ضَنْكُ الْحَالِ
u'ضَوْءٌ إِنْسانٌ':Added, #3: 3	ضَنَّ النَّاسُ
u'ضَوْءٌ بَصَرٌ':Added, #1: 1	ضَوْءُ إنْسَانٍ
u'ضَوْءٌ سِرَاجٌ':Added, #2: 2	ضَوْءِ الْبَصَرِ
u'ضَوْءٌ سِرَاجٌ':Added, #2: 2	ضَوْءِ سِرَاجِهِ
u'ضَوْءٌ شمس':Added, #3: 3	ضَوْءِ السِّرَاجِ
u'ضَوْءٌ شمس':Added, #1: 1	ضَوْءَ الشّمْسِ
u'ضَوْءٌ شَمْسٌ':Added, #1: 1	ضَوْءَ الشَّمْسِ
u'ضَوْءٌ شَمْسٌ':Added, #1: 1	ضَوْءَ الشّمْسِ
u'ضَوْءٌ شمس':Added, #1: 1	ضَوْءَ الشَّمْسِ
u'ضَوْءٌ شَمْسٌ':Added, #4: 4	ضَوْءِ الشَّمْسِ
u'ضَوْءٌ شمس':Added, #4: 4	ضَوْءِ الشَّمْسِ
u'ضَوْءٌ شَمْسٌ':Added, #6: 6	ضَوْءُ الشَّمْسِ
u'ضَوْءٌ شِهَابٌ':Added, #6: 6	ضَوْءُ الشَّمْسِ
u'ضَوْءٌ شَيْءٌ':Added, #1: 1	ضَوْءَ شِهَابِ
u'ضَوْءٌ عَيْنٌ':Added, #1: 1	ضَوْءِ شَيْءٍ
u'ضَوْءٌ عَيْن':Added, #1: 1	ضَوْءَ عَيْنٍ
u'ضَوْءٌ عين':Added, #1: 1	ضَوْءَ عَيْنٍ
u'ضَوْءٌ عَيْنٌ':Added, #1: 1	ضَوْءُ عَيْنِهِ
u'ضَوْءٌ عَيْن':Added, #1: 1	ضَوْءُ عَيْنِهِ
u'ضَوْءٌ قمر':Added, #1: 1	ضَوْءُ عَيْنِهِ
u'ضَوْءٌ قَمَرٌ':Added, #2: 2	ضَوْءِ الْقَمَرِ
u'ضَوْءٌ نَارٌ':Added, #2: 2	ضَوْءِ الْقَمَرِ
u'ضَوْءٌ نُجُومٌ':Added, #3: 3	ضَوْءِ نَارِهِ
u'ضَوْءٌ نهار':Added, #2: 2	ضَوْءَ النُّجُومِ
u'ضَوْءٌ نَهَارٌ':Added, #1: 1	ضَوْءُ النَّهَارِ
u'ضَوْءٌ نهار':Added, #1: 1	ضَوْءُ النَّهَارِ
u'ضَوْءٌ نَهَارٌ':Added, #8: 8	ضَوْءِ النَّهَارِ
u'ضِيَاءٌ حُلُومٌ':Added, #8: 8	ضَوْءِ النَّهَارِ
u'ضِيَاءٌ دِينٌ':Added, #53: 53	ضِيَاءِ الْحُلُومِ
u'ضِيَاءٌ دِينٌ':Added, #2: 2	ضِيَاءِ الدِّينِ
u'ضِيَاءٌ صُبْحٌ':Added, #9: 9	ضِيَاءُ الدِّينِ
u'ضِيَاءٌ طَارِقٌ':Added, #1: 1	ضِيَاءِ الصُّبْحِ
u'ضِيَاءٌ عُلُومٌ':Added, #1: 1	ضِيَاءُ الطّارِقِ
u'ضِيَاءٌ نُورٌ':Added, #1: 1	ضِيَاءِ الْعُلُومِ
u'ضِيَاعٌ اِبْنٌ':Added, #1: 1	ضِيَاءُ نُورٍ
u'ضَيَاعٌ أصل':Added, #1: 1	ضِيَاعَ ابْنِهِ
u'ضَيَاعٌ أًصْلٌ':Added, #1: 1	ضَيَاعُ أَصْلِ
u'ضَيَاعٌ أهْلٌ':Added, #1: 1	ضَيَاعُ أَصْلِ
u'ضَيَاعٌ ثَمَنٌ':Added, #1: 1	ضَيَاعُ أَهْلِ
u'ضَيَاعٌ ثَوْبٌ':Added, #1: 1	ضَيَاعِ ثَمَنِهِ
u'ضَيَاعٌ حَقٌّ':Added, #1: 1	ضَيَاعَ ثَوْبٍ
u'ضَيَاعٌ حَقٌّ':Added, #1: 1	ضَيَاعُ الْحَقِّ
u'ضَيَاعٌ حَقٌّ':Added, #1: 1	ضَيَاعِ الْحَقِّ
u'ضَيَاعٌ حَقٌّ':Added, #1: 1	ضَيَاعُ حَقِّ
u'ضَيَاعٌ حَقٌّ':Added, #1: 1	ضَيَاعِ حَقِّهِ
u'ضَيَاعٌ حَقٌّ':Added, #2: 2	ضَيَاعِ حَقِّ
u'ضَيَاعٌ زَمانٌ':Added, #3: 3	ضَيَاعَ الْحَقِّ
u'ضَيَاعٌ شَيْءٌ':Added, #1: 1	ضَيَاعُ الزَّمَانِ
u'ضَيَاعٌ شَيْءٌ':Added, #1: 1	ضَيَاعَ الشَّيْءِ
u'ضَيَاعٌ صَكٌّ':Added, #1: 1	ضَيَاعَ شَيْءٍ
u'ضَيَاعٌ صَكٌّ':Added, #1: 1	ضَيَاعَ الصَّكِّ
u'ضِيَاعٌ طِفْلٌ':Added, #1: 1	ضَيَاعَ صَكِّهِ
u'ضَيَاعٌ علم':Added, #1: 1	ضِيَاعِ الطِّفْلِ
u'ضَيَاعٌ عِلْمٌ':Added, #1: 1	ضَيَاعِ الْعِلْمِ
u'ضَيَاعٌ غير':Added, #1: 1	ضَيَاعِ الْعِلْمِ
u'ضَيَاعٌ غَيْرٌ':Added, #1: 1	ضَيَاعِ غَيْرِهِ
u'ضَيَاعٌ قَيْدٌ':Added, #1: 1	ضَيَاعِ غَيْرِهِ
u'ضَيَاعٌ لقطة':Added, #1: 1	ضَيَاعِ الْقَيْدَيْنِ
u'ضَيَاعٌ مَالٌ':Added, #1: 1	ضَيَاعُ اللُّقَطَةِ
u'ضَيَاعٌ مَالٌ':Added, #1: 1	ضَيَاعَ مَالِ
u'ضَيَاعٌ مَالٌ':Added, #2: 2	ضَيَاعِ الْمَالِ
u'ضَيَاعٌ مَالٌ':Added, #2: 2	ضَيَاعِ مَالٍ
u'ضَيَاعٌ مَالٌ':Added, #4: 4	ضَيَاعَ مَالِهِ
u'ضَيَاعٌ مَتَاعٌ':Added, #5: 5	ضَيَاعِ مَالِهِ
u'ضَيَاعٌ مَجْمُوعٌ':Added, #1: 1	ضَيَاعَ الْمَتَاعِ
u'ضَيَاعٌ مَصْلَحَةٌ':Added, #1: 1	ضَيَاعُ مَجْمُوعِ
u'ضَيَاعٌ مُقَابِلٌ':Added, #1: 1	ضَيَاعُ مَصْلَحَةٍ
u'ضَيَاعٌ نَسَبٌ':Added, #1: 1	ضَيَاعِ الْمُقَابِلِ
u'ضَيَاعٌ نِصْفٌ':Added, #1: 1	ضَيَاعُ نَسَبِهِ
u'ضَيَاعٌ نَعْلٌ':Added, #1: 1	ضَيَاعُ نِصْفِ
u'ضَيَاعٌ نَفَقَةٌ':Added, #1: 1	ضَيَاعِ النَّعْلِ
u'ضَيَاعٌ واحد':Added, #1: 1	ضَيَاعُ نَفَقَةِ
u'ضَيَاعٌ وَاحِدٌ':Added, #1: 1	ضَيَاعَ وَاحِدٍ
u'ضَيَاعٌ وَدِيعٌ':Added, #1: 1	ضَيَاعَ وَاحِدٍ
u'ضَيَاعٌ وَدِيعَةٌ':Added, #1: 1	ضَيَاعِ الْوَدِيعَةِ
u'ضَيَاعٌ وَقْفٌ':Added, #1: 1	ضَيَاعِ الْوَدِيعَةِ
u'ضِيَاعٌ وُقُوفٌ':Added, #1: 1	ضَيَاعَ الْوَقْفِ
u'ضِيَافَةٌ أحَدٌ':Added, #1: 1	ضِيَاعِ الْوُقُوفِ
u'ضِيَافَةٌ أهْلٌ':Added, #1: 1	ضِيَافَةُ أَحَدٍ
u'ضِيَافَةٌ أَوَّلُ':Added, #1: 1	ضِيَافَةِ أَهْلِ
u'ضِيَافَةٌ تَزْوِيجٌ':Added, #1: 1	ضِيَافَةِ الْأَوَّلِ
u'ضِيَافَةٌ جَانٌّ':Added, #1: 1	ضِيَافَةُ التَّزْوِيجِ
u'ضِيَافَةٌ خَصْمٌ':Added, #1: 1	ضِيَافَةَ الْجَانِّ
u'ضِيَافَةٌ رَجُلٌ':Added, #1: 1	ضِيَافَةِ الْخَصْمَيْنِ
u'ضِيَافَةٌ فُلاَنٌ':Added, #2: 2	ضِيَافَةِ رَجُلٍ
u'ضِيَافَةٌ مُسْلِمٌ':Added, #1: 1	ضِيَافَةِ فُلَانٍ
u'ضِيَافَةٌ يَوْمٌ':Added, #2: 2	ضِيَافَةُ الْمُسْلِمِ
u'ضَيَّعَ إمَامٌ':Subject, #2: 2	ضِيَافَةَ يَوْمٍ
u'ضَيْعَةٌ أَصْحَابٌ':Added, #2: 2	ضَيَّعَ الْإِمَامُ
u'ضَيْعَةٌ خَرَابٌ':Added, #1: 1	ضَيْعَةَ أَصْحَابِهِ
u'ضَيْعَةٌ خَرَابٌ':Added, #1: 1	ضَيْعَةٍ خَرَابٍ
u'ضَيْعَةٌ رباط':Added, #1: 1	ضَيْعَةِ خَرَابٍ
u'ضَيْعَةٌ رِبَاطٌ':Added, #1: 1	ضَيْعَةَ الرِّبَاطِ
u'ضَيْعَةٌ رَجُلٌ':Added, #1: 1	ضَيْعَةَ الرِّبَاطِ
u'ضَيْعَةٌ رَجُلٌ':Added, #1: 1	ضَيْعَةَ رَجُلٍ
u'ضَيْعَةٌ رَكْبٌ':Added, #2: 2	ضَيْعَةِ رَجُلٍ
u'ضَيْعَةٌ غير':Added, #1: 1	ضَيْعَةِ رَكْبٍ
u'ضَيْعَةٌ غَيْرٌ':Added, #1: 1	ضَيْعَةَ غَيْرِهِ
u'ضَيْعَةٌ فُلاَنٌ':Added, #1: 1	ضَيْعَةَ غَيْرِهِ
u'ضَيْعَةٌ فُلاَنٌ':Added, #1: 1	ضَيْعَةَ فُلَانٍ
u'ضَيْعَةٌ مَالٌ':Added, #1: 1	ضَيْعَةِ فُلَانٍ
u'ضَيْعَةٌ مَالٌ':Added, #1: 1	ضَيْعَةَ مَالٍ
u'ضَيْعَةٌ مُشْتَرَكٌ':Added, #2: 2	ضَيْعَةَ مَالِهِ
u'ضَيْعَةٌ مَوْقُوفٌ':Added, #1: 1	ضَيْعَةٍ مُشْتَرَكَةٍ
u'ضَيْعَةٌ واحد':Added, #2: 2	ضَيْعَةٍ مَوْقُوفَةٍ
u'ضَيْعَةٌ وَاحِدٌ':Added, #1: 1	ضَيْعَةٍ وَاحِدَةٍ
u'ضَيْعَةٌ يَتِيمٌ':Added, #1: 1	ضَيْعَةٍ وَاحِدَةٍ
u'ضَيَّعَ زِيادَةٌ':Predicate, #1: 1	ضَيْعَةَ الْيَتِيمِ
u'ضَيْفٌ رَسُولٌ':Added, #4: 4	ضَيَّعَ الزِّيَادَةَ
u'ضَيْفٌ رَسُولٌ':Added, #1: 1	ضَيْفَ رَسُولِ
u'ضَيَّفَ ضَيْفٌ':Predicate, #2: 2	ضَيْفُ رَسُولِ
u'ضَيْفٌ نَفَقَةٌ':Added, #1: 1	ضَيَّفَ الضَّيْفَ
u'ضِيقٌ أذْهَانٌ':Added, #1: 1	ضَيْفِ النَّفَقَةِ
u'ضِيقٌ أَذْهَانٌ':Added, #2: 2	ضِيقِ الْأَذْهَانِ
u'ضِيقٌ إِزَارٌ':Added, #2: 2	ضِيقِ الْأَذْهَانِ
u'ضِيقٌ أزُرٌ':Added, #1: 1	ضِيقِ الإِزَارِ
u'ضِيقٌ بَطْنٌ':Added, #2: 2	ضِيقِ الأُزُرِ
u'ضِيقٌ حالٌ':Added, #1: 1	ضِيقِ الْبَطْنِ
u'ضِيقٌ حالٌ':Added, #1: 1	ضِيقِ حَالٍ
u'ضِيقٌ حِصَارٌ':Added, #1: 1	ضِيقِ حَالِ
u'ضَيَّقَ خِلاَفٌ':Predicate, #1: 1	ضِيقِ الْحِصَارِ
u'ضِيقٌ زُقاقٌ':Added, #1: 1	ضَيَّقَ الْخِلَافَ
u'ضِيقٌ زُقَاقٌ':Added, #1: 1	ضِيقُ الزُّقَاقِ
u'ضِيقٌ زَمانٌ':Added, #1: 1	ضِيقُ الزُّقَاقِ
u'ضِيقٌ سَرْجٌ':Added, #1: 1	ضِيقِ زَمَانِ
u'ضَيَّقَ شَارِعٌ':Predicate, #1: 1	ضِيقُ السَّرْجِ
u'ضَيَّقَ شيب':Subject, #1: 1	ضَيَّقَ الشَّارِعَ
u'ضَيَّقَ شَيْبٌ':Subject, #1: 1	ضَيَّقَ الشَّيْبُ
u'ضِيقٌ صَدْرٌ':Added, #1: 1	ضَيَّقَ الشَّيْبُ
u'ضِيقٌ صَدْرٌ':Added, #1: 1	ضِيقُ الصّدْرِ
u'ضِيقٌ صَدْرٌ':Added, #1: 1	ضِيقِ الصَّدْرِ
u'ضِيقٌ صَدْرٌ':Added, #1: 1	ضِيقُ صَدْرٍ
u'ضِيقٌ صَدْرٌ':Added, #1: 1	ضِيقِ صَدْرٍ
u'ضِيقٌ طُرُقٌ':Added, #3: 3	ضِيقُ الصَّدْرِ
u'ضَيَّقَ طَرِيقٌ':Predicate, #1: 1	ضِيقِ الطُّرُقِ
u'ضِيقٌ طَرِيقٌ':Added, #1: 1	ضَيَّقَ الطَّرِيقَ
u'ضِيقٌ عَيْشٌ':Added, #2: 2	ضِيقِ الطَّرِيقِ
u'ضِيقٌ عَيْشٌ':Added, #1: 1	ضِيقَ الْعَيْشِ
u'ضِيقٌ قُبُلٌ':Added, #1: 1	ضِيقِ عَيْشِهِ
u'ضِيقٌ كُمٌّ':Added, #1: 1	ضِيقِ قُبُلٍ
u'ضِيقٌ مَاءٌ':Added, #1: 1	ضِيقِ الْكُمِّ
u'ضِيقٌ مَالٌ':Added, #2: 2	ضِيقِ الْمَاءِ
u'ضِيقٌ مَخْرَجٌ':Added, #1: 1	ضِيقِ الْمَالِ
u'ضِيقٌ مَسْجِدٌ':Added, #1: 1	ضِيقِ الْمَخْرَجِ
u'ضِيقٌ مَقَامٌ':Added, #1: 1	ضِيقِ مَسْجِدٍ
u'ضِيقٌ مَكَانٌ':Added, #1: 1	ضِيقُ الْمَقَامِ
u'ضِيقٌ مَكَانٌ':Added, #2: 2	ضِيقَ الْمَكَانِ
u'ضِيقٌ مَكَانٌ':Added, #2: 2	ضِيقُ الْمَكَانِ
u'ضِيقٌ مَنَازِلُ':Added, #2: 2	ضِيقِ الْمَكَانِ
u'ضَيَّقَ مَنْزِلٌ':Predicate, #2: 2	ضِيقَ الْمَنَازِلِ
u'ضِيقٌ مَنْزِلٌ':Added, #1: 1	ضَيَّقَ مَنْزِلاً
u'ضِيقٌ مَنْفَذٌ':Added, #1: 1	ضِيقَ الْمَنْزِلِ
u'ضِيقٌ مَوْضِعٌ':Added, #1: 1	ضِيقُ الْمَنْفَذِ
u'ضِيقٌ نَظَرٌ':Added, #1: 1	ضِيقِ الْمَوْضِعِ
u'ضِيقٌ نَفَسٌ':Added, #1: 1	ضِيقِ النَّظَرِ
u'ضِيقٌ وُجُوبٌ':Added, #1: 1	ضِيقِ النَّفَسِ
u'ضَيَّقَ وَقْتٌ':Predicate, #1: 1	ضِيقِ الْوُجُوبِ
u'ضِيقٌ وَقْتٌ':Added, #1: 1	ضَيَّقَ الْوَقْتَ
u'ضِيقٌ وَقْتٌ':Added, #13: 13	ضِيقُ الْوَقْتِ
u'ضِيقٌ وَقْتٌ':Added, #1: 1	ضِيقُ وَقْتِ
u'ضِيقٌ وَقْتٌ':Added, #1: 1	ضِيقِ وَقْتٍ
u'ضِيقٌ وَقْتٌ':Added, #2: 2	ضِيقَ الْوَقْتِ
u'ضِيقٌ وَقْتٌ':Added, #3: 3	ضِيقَ وَقْتِ
u'ضِيقٌ وَقْتٌ':Added, #60: 60	ضِيقِ الْوَقْتِ
u'طَابَ أَسْفَلُ':Subject, #6: 6	ضِيقِ وَقْتِ
u'طَابَ أصل':Subject, #3: 3	طَابَ أَسْفَلُهُ
u'طَابَ أًصْلٌ':Subject, #1: 1	طَابَ أَصْلُهُ
u'طَابَ أكل':Subject, #1: 1	طَابَ أَصْلُهُ
u'طَابَ أَكْلٌ':Subject, #2: 2	طَابَ أَكْلُ
u'طَابَ أكل':Subject, #2: 2	طَابَ أَكْلُ
u'طَابَ أَكْلٌ':Subject, #2: 2	طَابَ أَكْلُهُ
u'طَابَ حَلٌّ':Predicate, #2: 2	طَابَ أَكْلُهُ
u'طَابَ رِبْحٌ':Subject, #1: 1	طَابَ حَلَّ
u'طَابَ ريحٌ':Subject, #2: 2	طَابَ الرِّبْحُ
u'طَابَ زَرْعٌ':Subject, #2: 2	طَابَ رِيحُهُ
u'طَابَ شَبابٌ':Subject, #1: 1	طَابَ الزَّرْعُ
u'طَابَ شَبَابٌ':Subject, #1: 1	طَابَ الشَّبَابُ
u'طَابَ غِبٌّ':Subject, #1: 1	طَابَ الشَّبَابُ
u'طَابَ فَضْلٌ':Subject, #1: 1	طَابَ غِبُّهُ
u'طَابَقَ اِجْتِهَادٌ':Subject, #3: 3	طَابَ الْفَضْلُ
u'طَابَقَ بَاطن':Subject, #1: 1	طَابَقَ اجْتِهَادُهُ
u'طَابَقَ باطِنٌ':Subject, #1: 1	طَابَقَ بَاطِنُ
u'طَابَقَ حُكْمٌ':Predicate, #1: 1	طَابَقَ بَاطِنُ
u'طَابَقَ خَارِجٌ':Predicate, #1: 1	طَابَقَ الْحُكْمَ
u'طَابَقَ شَرْعٌ':Predicate, #2: 2	طَابَقَ الْخَارِجَ
u'طَابَقَ شَرِيعَةٌ':Predicate, #1: 1	طَابَقَ الشَّرْعَ
u'طَابَقَ قول':Predicate, #1: 1	طَابَقَ الشَّرِيعَةَ
u'طَابَقَ قَوْلٌ':Predicate, #1: 1	طَابَقَ قَوْلَ
u'طَابَ قلب':Subject, #1: 1	طَابَقَ قَوْلَ
u'طَابَ قَلْبٌ':Subject, #1: 1	طَابَ قَلْبُ
u'طَابَ قَلْب':Subject, #1: 1	طَابَ قَلْبُ
u'طَابَقَ وَاقِعٌ':Predicate, #1: 1	طَابَ قَلْبُ
u'طَابَ كَرْمٌ':Subject, #5: 5	طَابَقَ الْوَاقِعَ
u'طَابَ كَسْبٌ':Subject, #1: 1	طَابَ كَرْمُهُ
u'طَابَ كَلاَمٌ':Predicate, #2: 2	طَابَ كَسْبُهُ
u'طَابَ مَكْسَبٌ':Subject, #1: 1	أَطَابَ الْكَلَامَ
u'طَابَ مَلِكٌ':Subject, #1: 1	طَابَ الْمَكْسَبُ
u'طَابَ نَفْسٌ':Subject, #1: 1	طَابَ الْمَلِكُ
u'طَارَ أَرْواحٌ':Subject, #1: 1	طَابَ نَفْسُهُ
u'طَارَ بُزاةٌ':Subject, #1: 1	طَارَ أَرْوَاحُ
u'طَارَ طَائِرٌ':Subject, #1: 1	طَارَ الْبُزَاةُ
u'طَارَ طَائِرٌ':Subject, #1: 1	طَارَ الطَّائِرُ
u'طَارَ طَائِرٌ':Subject, #1: 1	طَارَ طَائِرُ
u'طَارَ عَقِبٌ':Predicate, #2: 2	طَارَ طَائِرٌ
u'طَارَ غُرَابٌ':Subject, #1: 1	طَارَ عَقِبَ
u'طَارَ فِرَاشٌ':Predicate, #1: 1	طَارَ غُرَابٌ
u'طَارَ مثل':Predicate, #1: 1	أَطَارَ فِرَاشَ
u'طَارَ مِثْلٌ':Predicate, #1: 1	طَارَ مِثْلَ
u'طَاشَ ظَنٌّ':Subject, #1: 1	طَارَ مِثْلَ
u'طَأْطَأَ رَسُولٌ':Subject, #1: 1	طَاشَ ظَنُّ
u'طَاعَةٌ أَبٌ':Added, #1: 1	طَأْطَأَ رَسُولُ
u'طَاعَةٌ اِبْنٌ':Added, #2: 2	طَاعَةِ الْأَبِ
u'طَاعَةٌ آثِمٌ':Added, #1: 1	طَاعَةِ ابْنِ
u'طَاعَةٌ اللهُ':Added, #1: 1	طَاعَةِ الْآثِمِ
u'طَاعَةٌ اللهُ':Added, #1: 1	طَاعَةُ اللهِ
u'طَاعَةٌ إمَامٌ':Added, #1: 1	طَاعَةِ اللهِ
u'طَاعَةٌ إمَامٌ':Added, #10: 10	طَاعَةُ الْإِمَامِ
u'طَاعَةٌ إمَامٌ':Added, #13: 13	طَاعَةِ الْإِمَامِ
u'طَاعَةٌ إمَامٌ':Added, #2: 2	طَاعَةِ إمَامِهِ
u'طَاعَةٌ أَمْرٌ':Added, #3: 3	طَاعَةَ الْإِمَامِ
u'طَاعَةٌ أَمْرٌ':Added, #1: 1	طَاعَةُ الْأَمْرِ
u'طَاعَةٌ آمِرٌ':Added, #1: 1	طَاعَةِ الْأَمْرِ
u'طَاعَةٌ إِنْسانٌ':Added, #2: 2	طَاعَةِ الْآمِرِ
u'طَاعَةٌ جَائِرٌ':Added, #1: 1	طَاعَةُ الْإِنْسَانِ
u'طَاعَةٌ جَمِيع':Added, #1: 1	طَاعَةِ الْجَائِرِ
u'طَاعَةٌ دَيَّانٌ':Added, #1: 1	طَاعَةِ الْجَمِيعِ
u'طَاعَةٌ رَبُّ':Added, #2: 2	طَاعَةَ الدَّيَّانِ
u'طَاعَةٌ رَبُّ':Added, #1: 1	طَاعَةِ رَبِّ
u'طَاعَةٌ رَبُّ':Added, #1: 1	طَاعَةَ رَبِّهِ
u'طَاعَةٌ رَسُولٌ':Added, #3: 3	طَاعَةِ رَبِّهِ
u'طَاعَةٌ رَسُولٌ':Added, #1: 1	طَاعَةُ الرَّسُولِ
u'طَاعَةٌ رَسُولٌ':Added, #1: 1	طَاعَةِ الرّسُولِ
u'طَاعَةٌ رَسُولٌ':Added, #1: 1	طَاعَةَ رَسُولِ
u'طَاعَةٌ رَسُولٌ':Added, #1: 1	طَاعَةَ رَسُولِهِ
u'طَاعَةٌ رَسُولٌ':Added, #1: 1	طَاعَةِ رَسُولِهِ
u'طَاعَةٌ زَوْجٌ':Added, #3: 3	طَاعَةِ الرَّسُولِ
u'طَاعَةٌ زَوْجٌ':Added, #1: 1	طَاعَةَ الزَّوْجِ
u'طَاعَةٌ زَوْجٌ':Added, #1: 1	طَاعَةُ الزَّوْجِ
u'طَاعَةٌ سُلْطَانٌ':Added, #2: 2	طَاعَةِ الزَّوْجِ
u'طَاعَةٌ سَيِّدٌ':Added, #1: 1	طَاعَةَ السُّلْطَانِ
u'طَاعَةٌ شَارِعٌ':Added, #4: 4	طَاعَةُ سَيِّدِهِ
u'طَاعَةٌ شَهْوَةٌ':Added, #1: 1	طَاعَةَ الشَّارِعِ
u'طَاعَةٌ شَيْطَانٌ':Added, #1: 1	طَاعَةُ الشَّهْوَةِ
u'طَاعَةٌ عَامٌّ':Added, #1: 1	طَاعَةِ الشَّيْطَانِ
u'طَاعَةٌ غير':Added, #1: 1	طَاعَةُ الْعَامَّةِ
u'طَاعَةٌ غير':Added, #1: 1	طَاعَةَ غَيْرِهِ
u'طَاعَةٌ غَيْرٌ':Added, #1: 1	طَاعَةُ غَيْرِهِ
u'طَاعَةٌ غَيْرٌ':Added, #1: 1	طَاعَةَ غَيْرِهِ
u'طَاعَةٌ غير':Added, #1: 1	طَاعَةُ غَيْرِهِ
u'طَاعَةٌ غَيْرٌ':Added, #3: 3	طَاعَةُ غَيْرِ
u'طَاعَةٌ قَوْمٌ':Added, #3: 3	طَاعَةُ غَيْرِ
u'طَاعَةٌ كَافِرٌ':Added, #1: 1	طَاعَةَ قَوْمٍ
u'طَاعَةٌ كَفَرَةٌ':Added, #1: 1	طَاعَةُ الْكَافِرِ
u'طَاعَةٌ كَفُورٌ':Added, #1: 1	طَاعَةُ الْكَفَرَةِ
u'طَاعَةٌ مَأْمُورٌ':Added, #1: 1	طَاعَةِ الْكَفُورِ
u'طَاعَةٌ مُوَكِّلٌ':Added, #2: 2	طَاعَةَ الْمَأْمُورِ
u'طَاعَةٌ مُؤْمِنٌ':Added, #1: 1	طَاعَةُ مُوَكِّلِهِ
u'طَاعَةٌ نَاقِصٌ':Added, #1: 1	طَاعَةِ الْمُؤْمِنِ
u'طَاعَةٌ نَبِيٌّ':Added, #1: 1	طَاعَةٍ نَاقِصَةٍ
u'طَاعَةٌ وَالِدٌ':Added, #2: 2	طَاعَةِ النَّبِيِّ
u'طَاعَةٌ وَالِدٌ':Added, #1: 1	طَاعَةِ الْوَالِدَيْنِ
u'طَاعَةٌ وَالِدٌ':Added, #2: 2	طَاعَةِ الْوَالِدِ
u'طَاعَةٌ وُلاَةٌ':Added, #3: 3	طَاعَةُ الْوَالِدَيْنِ
u'طَاعَةٌ وَلِيٌّ':Added, #1: 1	طَاعَةِ وُلَاةِ
u'طَاعَ رَاهِنٌ':Subject, #2: 2	طَاعَةِ وَلِيِّ
u'طَاعَ رَسُولٌ':Predicate, #1: 1	طَاعَ الرَّاهِنُ
u'طَاعَ مَوْهُوبٌ':Subject, #1: 1	أَطَاعَ الرَّسُولَ
u'طَاعَ نَاسٌ':Predicate, #1: 1	طَاعَ الْمَوْهُوبُ
u'طَاعَ نَاسٌ':Subject, #2: 2	أَطَاعَ النّاسَ
u'طَافَ اِبْنٌ':Subject, #1: 1	أَطَاعَ النّاسُ
u'طَافَ أَرْبَعَةٌ':Predicate, #1: 1	طَافَ ابْنُ
u'طَافَ أرْضٌ':Predicate, #10: 10	طَافَ أَرْبَعَةَ
u'طَافَ أَسَابِيعُ':Predicate, #1: 1	طَافَ الْأَرْضَ
u'طَافَ آفاقٌ':Predicate, #2: 2	طَافَ أَسَابِيعَ
u'طَافَ أقَلُّ':Predicate, #1: 1	طَافَ آفَاقَ
u'طَافَ أقَلُّ':Predicate, #1: 1	طَافَ أَقَلَّ
u'طَافَ أَكْثَرُ':Predicate, #6: 6	طَافَ الْأَقَلَّ
u'طَافَ أَكْثَرُ':Predicate, #1: 1	طَافَ الْأَكْثَرَ
u'طَافَ أَكْثَرُ':Subject, #3: 3	طَافَ أَكْثَرَ
u'طَافَ أَوَّلُ':Predicate, #1: 1	طَافَ الْأَكْثَرُ
u'طَافَ أيَّامٌ':Predicate, #2: 2	طَافَ الْأَوَّلَ
u'طَافَ أَيَّامٌ':Predicate, #1: 1	طَافَ أَيَّامَ
u'طَافَ باقِي':Predicate, #1: 1	طَافَ أَيَّامَ
u'طَافَ بَعْضٌ':Predicate, #2: 2	طَافَ الْبَاقِيَ
u'طَافَ بَيْنٌ':Predicate, #1: 1	طَافَ بَعْضَ
u'طَافَ ثَلاثَةٌ':Predicate, #8: 8	طَافَ بَيْنَ
u'طَافَ حَلٌّ':Predicate, #7: 7	طَافَ ثَلَاثَةَ
u'طَافَ حول':Predicate, #1: 1	طَافَ حَلَّ
u'طَافَ حَوْلٌ':Predicate, #6: 6	طَافَ حَوْلَ
u'طَافَ خَارِجٌ':Predicate, #6: 6	طَافَ حَوْلَ
u'طَافَ خَيَالٌ':Subject, #1: 1	طَافَ خَارِجَ
u'طَافَ رَجُلٌ':Subject, #1: 1	طَافَ الْخَيَالُ
u'طَافَ رَسُولٌ':Subject, #1: 1	طَافَ الرَّجُلُ
u'طَافَ زِيارَةٌ':Predicate, #11: 11	طَافَ رَسُولُ
u'طَافَ صَبِيٌّ':Subject, #1: 1	طَافَ الزِّيَارَةَ
u'طَافَ طواف':Predicate, #2: 2	طَافَ صَبِيُّ
u'طَافَ طَوَافٌ':Predicate, #1: 1	طَافَ الطَّوَافَ
u'طَافَ طواف':Predicate, #1: 1	طَافَ الطَّوَافَ
u'طَافَ طَوَافٌ':Predicate, #33: 33	طَافَ طَوَافَ
u'طَافَ عَبْدٌ':Subject, #33: 33	طَافَ طَوَافَ
u'طَافَ عند':Predicate, #1: 1	طَافَ عَبْدُ
u'طَافَ غير':Predicate, #2: 2	طَافَ عِنْدَ
u'طَافَ غَيْرٌ':Predicate, #1: 1	طَافَ غَيْرَ
u'طَافَ قَادِمٌ':Subject, #1: 1	طَافَ غَيْرَ
u'طَافَ لَيْلٌ':Predicate, #1: 1	طَافَ الْقَادِمُ
u'طَافَ لَيْلٌ':Predicate, #1: 1	أَطَافَ اللَّيْلَةَ
u'طَافَ مُتَمَتِّعٌ':Subject, #1: 1	طَافَ اللَّيْلَةَ
u'طَافَ مُعْتَمِرٌ':Subject, #1: 1	طَافَ الْمُتَمَتِّعُ
u'طَافَ مَكْشُوفٌ':Predicate, #1: 1	طَافَ الْمُعْتَمِرُ
u'طَافَ نَاسٌ':Subject, #1: 1	طَافَ مَكْشُوفَ
u'طَافَ نِساءٌ':Subject, #1: 1	طَافَ النَّاسُ
u'طَافَ وَقْتٌ':Predicate, #1: 1	طَافَ نِسَاءُ
u'طَافَ وَلِيٌّ':Subject, #1: 1	طَافَ وَقْتَ
u'طَافَ يَوْمٌ':Predicate, #1: 1	طَافَ الْوَلِيُّ
u'طَاقَ إحْسَانٌ':Predicate, #5: 5	طَافَ يَوْمَ
u'طَاقَ أصل':Predicate, #1: 1	أَطَاقَ الْإِحْسَانَ
u'طَاقَ أًصْلٌ':Predicate, #1: 1	أَطَاقَ أَصْلَ
u'طَاقَةٌ أَبٌ':Added, #1: 1	أَطَاقَ أَصْلَ
u'طَاقَةٌ دَابَّةٌ':Added, #2: 2	طَاقَةِ الْأَبِ
u'طَاقَةٌ مَهْرٌ':Added, #1: 1	طَاقَةِ الدَّابَّةِ
u'طَاقَةٌ نَاسٌ':Added, #1: 1	طَاقَةُ الْمَهْرِ
u'طَاقَةٌ نَفَقَةٌ':Added, #3: 3	طَاقَةِ النَّاسِ
u'طَاقَ صَوْمٌ':Predicate, #1: 1	طَاقَةُ النَّفَقَةِ
u'طَاقَ قتال':Predicate, #1: 1	أَطَاقَ الصَّوْمَ
u'طَاقَ قِتَالٌ':Predicate, #1: 1	طَاقَ الْقِتَالَ
u'طَاقَ قتال':Predicate, #1: 1	طَاقَ الْقِتَالَ
u'طَاقَ قِتَالٌ':Predicate, #2: 2	أَطَاقَ الْقِتَالَ
u'طَاقَ قيام':Predicate, #2: 2	أَطَاقَ الْقِتَالَ
u'طَاقَ قِيَامٌ':Predicate, #2: 2	أَطَاقَ الْقِيَامَ
u'طَالَ إعْرَاضٌ':Subject, #2: 2	أَطَاقَ الْقِيَامَ
u'طَالَ إقامَةٌ':Predicate, #1: 1	طَالَ الْإِعْرَاضُ
u'طَالَ أكل':Predicate, #2: 2	أَطَالَ الْإِقَامَةَ
u'طَالَ أَكْلٌ':Predicate, #1: 1	أَطَالَ الْأَكْلَ
u'طَالَ اِلْتِفَاتٌ':Subject, #1: 1	أَطَالَ الْأَكْلَ
u'طَالَ إمَامٌ':Subject, #1: 1	طَالَ الْتِفَاتُهُ
u'طَالَ أَمَدٌ':Subject, #2: 2	أَطَالَ الْإِمَامُ
u'طَالَ أَمْرٌ':Subject, #1: 1	طَالَ الْأَمَدُ
u'طَالَ أَمْرٌ':Subject, #1: 1	طَالَ أَمْرُهُ
u'طَالَبَ آدَمِيٌّ':Subject, #3: 3	طَالَ الْأَمْرُ
u'طَالَبَ آدَمِيٌّ':Subject, #1: 1	طَالَبَ آدَمِيٌّ
u'طَالَبَ أَصيلٌ':Predicate, #1: 1	طَالَبَ الْآدَمِيُّ
u'طَالَبَ المُشْتَرِي':Predicate, #5: 5	طَالَبَ الْأَصِيلَ
u'طَالَبَ إمَامٌ':Subject, #3: 3	طَالَبَ الْمُشْتَرِيَ
u'طَالَبَ آمِرٌ':Predicate, #1: 1	طَالَبَ الْإِمَامُ
u'طَالَبَ آمِرٌ':Subject, #1: 1	طَالَبَ الْآمِرَ
u'طَالَبَ أَمينٌ':Subject, #1: 1	طَالَبَ الْآمِرُ
u'طَالَبَ بَائِعٌ':Predicate, #1: 1	طَالَبَ أَمِينُهُ
u'طَالَبَ بَائِعٌ':Subject, #2: 2	طَالَبَ الْبَائِعَ
u'طَالَ بَحْثٌ':Predicate, #2: 2	طَالَبَ الْبَائِعُ
u'طَالَبَ خَلِيفَةٌ':Predicate, #1: 1	أَطَالَ الْبَحْثَ
u'طَالَبَ رَبُّ':Subject, #1: 1	طَالَبَ الْخَلِيفَةَ
u'طَالَبَ زَوْجٌ':Predicate, #1: 1	طَالَبَ رَبُّ
u'طَالَبَ زَوْجٌ':Subject, #1: 1	طَالَبَ زَوْجَ
u'طَالَبَ زَيْدٌ':Subject, #1: 1	طَالَبَ الزَّوْجُ
u'طَالَ بِشْرٌ':Subject, #1: 1	طَالَبَ زَيْدٌ
u'طَالَبَ شَفِيعٌ':Subject, #1: 1	أَطَالَ بِشْرُ
u'طَالَبَ صَاحِبٌ':Subject, #2: 2	طَالَبَ الشَّفِيعُ
u'طَالَبَ صَدْرٌ':Subject, #1: 1	طَالَبَ صَاحِبُ
u'طَالَ بَطَلٌ':Predicate, #1: 1	طَالَبَ صَدْرُ
u'طَالَبَ غَرِيمٌ':Predicate, #2: 2	طَالَ بَطَلَ
u'طَالَبَ قَيِّمٌ':Predicate, #2: 2	طَالَبَ الْغَرِيمَ
u'طَالَبَ كُفَّارٌ':Predicate, #1: 1	طَالَبَ الْقَيِّمَ
u'طَالَبَ كَفِيلٌ':Predicate, #1: 1	طَالَبَ الْكُفَّارَ
u'طَالَبَ كَفِيلٌ':Subject, #5: 5	طَالَبَ الْكَفِيلَ
u'طَالَ بَلاءٌ':Subject, #1: 1	طَالَبَ الْكَفِيلُ
u'طَالَبَ مَالِكٌ':Subject, #1: 1	طَالَ الْبَلَاءُ
u'طَالَبَ مَجْنِيٌّ':Subject, #2: 2	طَالَبَ الْمَالِكُ
u'طَالَبَ مُحْتَالٌ':Subject, #1: 1	طَالَبَ الْمَجْنِيُّ
u'طَالَبَ مُحِيل':Subject, #4: 4	طَالَبَ الْمُحْتَالُ
u'طَالَبَ مُرْتَهِنٌ':Subject, #3: 3	طَالَبَ الْمُحِيلُ
u'طَالَبَ مُشْتَرِي':Predicate, #2: 2	طَالَبَ الْمُرْتَهِنُ
u'طَالَبَ مُصَالِحٌ':Predicate, #3: 3	طَالَبَ الْمُشْتَرِيَ
u'طَالَبَ مَكْفُولٌ':Subject, #1: 1	طَالَبَ الْمُصَالِحَ
u'طَالَبَ مُودَعٌ':Subject, #1: 1	طَالَبَ الْمَكْفُولُ
u'طَالَبَ مُوَكِّلٌ':Predicate, #1: 1	طَالَبَ الْمُودَعُ
u'طَالَبَ مُوَكِّلٌ':Subject, #1: 1	طَالَبَ الْمُوَكِّلَ
u'طَالَبَ وَالِدٌ':Predicate, #4: 4	طَالَبَ الْمُوَكِّلُ
u'طَالَبَ وَكِيلٌ':Subject, #1: 1	طَالَبَ الْوَالِدَ
u'طَالَ بَيَاضٌ':Subject, #3: 3	طَالَبَ الْوَكِيلُ
u'طَالَ تَرَدُّدٌ':Predicate, #1: 1	طَالَ الْبَيَاضُ
u'طَالَ تَرَدُّدٌ':Subject, #1: 1	طَالَ التَّرَدُّدَ
u'طَالَ تَشَهُّدٌ':Predicate, #1: 1	طَالَ التَّرَدُّدُ
u'طَالَ تَعَطُّشٌ':Subject, #1: 1	أَطَالَ التَّشَهُّدَ
u'طَالَ تَفَكُّرٌ':Subject, #1: 1	طَالَ تَعَطُّشُهُ
u'طَالَ جُلُوسٌ':Predicate, #7: 7	طَالَ تَفَكُّرُهُ
u'طَالَ جَمَاعَةٌ':Subject, #3: 3	أَطَالَ الْجُلُوسَ
u'طَالَ جَمْعٌ':Subject, #1: 1	أَطَالَ جَمَاعَةٌ
u'طَالَ جُنُونٌ':Subject, #1: 1	أَطَالَ جَمْعٌ
u'طَالَ جُنُونٌ':Subject, #1: 1	طَالَ الْجُنُونُ
u'طَالَ حَبْسٌ':Subject, #1: 1	طَالَ جُنُونُهُ
u'طَالَ حَبْسٌ':Subject, #1: 1	طَالَ حَبْسُ
u'طَالَ حَبْسٌ':Subject, #2: 2	طَالَ الْحَبْسُ
u'طَالَ حَديثٌ':Subject, #6: 6	طَالَ حَبْسُهُ
u'طَالَ حُزْنٌ':Subject, #2: 2	طَالَ الْحَدِيثُ
u'طَالَ خُرُوجٌ':Subject, #1: 1	طَالَ حُزْنُهُ
u'طَالَ خلق':Subject, #4: 4	طَالَ الْخُرُوجُ
u'طَالَ خَلْقٌ':Subject, #1: 1	أَطَالَ الْخَلْقُ
u'طَالَ دَيْنٌ':Subject, #1: 1	أَطَالَ الْخَلْقُ
u'طَالَ ذَبٌّ':Subject, #1: 1	طَالَ دَيْنٌ
u'طَالَ رَجُلٌ':Subject, #1: 1	طَالَ الذَّبُّ
u'طَالَ رُكوعٌ':Predicate, #1: 1	أَطَالَ الرَّجُلُ
u'طَالَ رُكوعٌ':Subject, #3: 3	أَطَالَ الرُّكُوعَ
u'طَالَ رَوَاجٌ':Subject, #1: 1	طَالَ رُكُوعُهُ
u'طَالَ زَمانٌ':Subject, #1: 1	طَالَ رَوَاجُ
u'طَالَ زَمانٌ':Subject, #31: 31	طَالَ الزَّمَانُ
u'طَالَ زَمَنٌ':Subject, #3: 3	طَالَ زَمَانُ
u'طَالَ زَمَنٌ':Subject, #10: 10	طَالَ زَمَنُهُ
u'طَالَ زَمَنٌ':Subject, #23: 23	طَالَ زَمَنُ
u'طَالَ سَجْنٌ':Subject, #9: 9	طَالَ الزَّمَنُ
u'طَالَ سُجُودٌ':Predicate, #2: 2	طَالَ سَجْنُهُ
u'طَالَ سَفَرٌ':Subject, #2: 2	أَطَالَ السُّجُودَ
u'طَالَ سَفَرٌ':Subject, #1: 1	طَالَ سَفَرُ
u'طَالَ سَفَرٌ':Subject, #3: 3	طَالَ السَّفَرُ
u'طَالَ سقم':Subject, #3: 3	طَالَ سَفَرُهُ
u'طَالَ سَقَمٌ':Subject, #1: 1	طَالَ سَقَمُهُ
u'طَالَ سَكْتٌ':Subject, #1: 1	طَالَ سَقَمُهُ
u'طَالَ سكر':Subject, #2: 2	طَالَ سَكْتُهُ
u'طَالَ سُكْرٌ':Subject, #1: 1	طَالَ السُّكْرُ
u'طَالَ شُرَّاحٌ':Subject, #1: 1	طَالَ السُّكْرُ
u'طَالَ شرب':Predicate, #1: 1	أَطَالَ شُرَّاحُ
u'طَالَ شُرْبٌ':Predicate, #1: 1	أَطَالَ الشُّرْبَ
u'طَالَ شَعْرٌ':Subject, #1: 1	أَطَالَ الشُّرْبَ
u'طَالَ شَعْرٌ':Subject, #1: 1	طَالَ شَعْرُ
u'طَالَ صَفٌّ':Subject, #2: 2	طَالَ الشَّعْرُ
u'طَالَ صَلاَةٌ':Predicate, #1: 1	طَالَ الصَّفُّ
u'طَالَ طهر':Subject, #1: 1	أَطَالَ الصَّلَاةَ
u'طَالَ طُهْرٌ':Subject, #1: 1	طَالَ الطُّهْرُ
u'طَالَعَ أسَاسٌ':Predicate, #1: 1	طَالَ الطُّهْرُ
u'طَالَعَ أَسَاسٌ':Predicate, #1: 1	طَالَعَ أَسَاسَ
u'طَالَ عَبْدٌ':Subject, #1: 1	طَالَعَ أَسَاسَ
u'طَالَعَ تَقْريرٌ':Predicate, #1: 1	أَطَالَ عَبْدٌ
u'طَالَعَ سَيْرٌ':Predicate, #1: 1	طَالَعَ التَّقْرِيرَ
u'طَالَعَ كُتُبٌ':Predicate, #1: 1	طَالَعَ سَيْرَ
u'طَالَعَ كَلاَمٌ':Predicate, #1: 1	طَالَعَ كُتُبَ
u'طَالَ عُمُرٌ':Subject, #1: 1	طَالَعَ كَلَامَ
u'طَالَ عَمَلٌ':Subject, #4: 4	طَالَ عُمُرُهُ
u'طَالَ عنق':Subject, #1: 1	طَالَ الْعَمَلُ
u'طَالَ عُنُقٌ':Subject, #1: 1	طَالَ عُنُقُ
u'طَالَ عنق':Subject, #1: 1	طَالَ عُنُقُ
u'طَالَ عُنُقٌ':Subject, #2: 2	طَالَ عُنُقُهُ
u'طَالَ غير':Subject, #2: 2	طَالَ عُنُقُهُ
u'طَالَ غَيْرٌ':Subject, #1: 1	أَطَالَ غَيْرُهُ
u'طَالَ فَصْلٌ':Predicate, #1: 1	أَطَالَ غَيْرُهُ
u'طَالَ فَصْلٌ':Subject, #1: 1	أَطَالَ الْفَصْلَ
u'طَالَ فَصْلٌ':Subject, #1: 1	أَطَالَ الْفَصْلُ
u'طَالَ فَصْلٌ':Subject, #1: 1	طَالَ فَصْلٌ
u'طَالَ فِعْلٌ':Subject, #38: 38	طَالَ الْفَصْلُ
u'طَالَ قِرَاءةٌ':Predicate, #3: 3	طَالَ الْفِعْلُ
u'طَالَ قُرْآنٌ':Subject, #4: 4	أَطَالَ الْقِرَاءَةَ
u'طَالَ قُعُودٌ':Predicate, #1: 1	طَالَ الْقُرْآنُ
u'طَالَ قول':Predicate, #1: 1	أَطَالَ الْقُعُودَ
u'طَالَ قَوْلٌ':Predicate, #1: 1	أَطَالَ الْقَوْلَ
u'طَالَ قول':Subject, #1: 1	أَطَالَ الْقَوْلَ
u'طَالَ قَوْلٌ':Subject, #1: 1	طَالَ الْقَوْلُ
u'طَالَ قول':Subject, #1: 1	طَالَ الْقَوْلُ
u'طَالَ قَوْلٌ':Subject, #1: 1	طَالَ قَوْلُهُ
u'طَالَ قيام':Predicate, #1: 1	طَالَ قَوْلُهُ
u'طَالَ قِيَامٌ':Predicate, #1: 1	أَطَالَ قِيَامَ
u'طَالَ قيام':Predicate, #1: 1	أَطَالَ قِيَامَ
u'طَالَ قِيَامٌ':Predicate, #5: 5	أَطَالَ الْقِيَامَ
u'طَالَ قيام':Subject, #5: 5	أَطَالَ الْقِيَامَ
u'طَالَ قِيَامٌ':Subject, #1: 1	طَالَ قِيَامُهُ
u'طَالَ كَلاَمٌ':Predicate, #1: 1	طَالَ قِيَامُهُ
u'طَالَ كَلاَمٌ':Subject, #5: 5	أَطَالَ الْكَلَامَ
u'طَالَ كَلاَمٌ':Subject, #1: 1	طَالَ كَلَامُهُ
u'طَالَ لَيْلٌ':Subject, #4: 4	طَالَ الْكَلَامُ
u'طَالَ مَجْلِسٌ':Subject, #1: 1	طَالَ اللَّيْلُ
u'طَالَ مَجْلِسٌ':Subject, #2: 2	طَالَ الْمَجْلِسُ
u'طَالَ مُحَقِّقٌ':Subject, #3: 3	طَالَ مَجْلِسُهُ
u'طَالَ مَرَضٌ':Subject, #5: 5	أَطَالَ الْمُحَقِّقُ
u'طَالَ مَرَضٌ':Subject, #1: 1	طَالَ مَرَضُ
u'طَالَ مَرَضٌ':Subject, #2: 2	طَالَ الْمَرَضُ
u'طَالَ مَغِيبٌ':Subject, #3: 3	طَالَ مَرَضُهُ
u'طَالَ مُقَامٌ':Subject, #1: 1	طَالَ مَغِيبُهُ
u'طَالَ مَقَامٌ':Subject, #1: 1	طَالَ مُقَامٌ
u'طَالَ مُقَامٌ':Subject, #2: 2	طَالَ مَقَامُهُ
u'طَالَ مُقَامٌ':Subject, #4: 4	طَالَ مُقَامُهُ
u'طَالَ مَقْدِسِيٌّ':Predicate, #6: 6	طَالَ مُقَامُ
u'طَالَ مُكْثٌ':Subject, #1: 1	أَطَالَ الْمَقْدِسِيَّ
u'طَالَ مُكْثٌ':Subject, #10: 10	طَالَ مُكْثُهُ
u'طَالَ مِنْبَرٌ':Subject, #1: 1	طَالَ الْمُكْثُ
u'طَالَ نَظَرٌ':Predicate, #1: 1	طَالَ الْمِنْبَرُ
u'طَالَ نَظَرٌ':Subject, #1: 1	أَطَالَ النَّظَرَ
u'طَالَ نَفَسٌ':Predicate, #1: 1	طَالَ نَظَرُهُ
u'طَالَ نَوْمٌ':Subject, #1: 1	أَطَالَ النَّفَسَ
u'طَالَ نَوَوِيٌّ':Subject, #1: 1	طَالَ النَّوْمُ
u'طَالَ وَجَبٌ':Predicate, #1: 1	أَطَالَ النَّوَوِيُّ
u'طَالَ وُضُوءٌ':Subject, #1: 1	طَالَ وَجَبَ
u'طَالَ وُقُوفٌ':Predicate, #1: 1	طَالَ وُضُوءُهُ
u'طَاوَعَ مُكْرِهٌ':Predicate, #1: 1	أَطَالَ الْوُقُوفَ
u'طِبَاعٌ أَوْلِيَاءُ':Added, #1: 1	طَاوَعَ الْمُكْرِهَ
u'طِبَاعٌ بَشَرٌ':Added, #2: 2	طِبَاعِ الْأَوْلِيَاءِ
u'طِبَاعٌ جُهَّالٌ':Added, #1: 1	طِبَاعَ الْبَشَرِ
u'طِبَاعٌ خلق':Added, #1: 1	طِبَاعِ الْجُهَّالِ
u'طِبَاعٌ خَلْقٌ':Added, #1: 1	طِبَاعَ الْخَلْقِ
u'طِبَاعٌ عُقَلاَءُ':Added, #1: 1	طِبَاعَ الْخَلْقِ
u'طِبَاعٌ نَاسٌ':Added, #1: 1	طِبَاعِ الْعُقَلَاءِ
u'طِبَاعٌ نَاسٌ':Added, #2: 2	طِبَاعُ النَّاسِ
u'طِبَاعٌ نَاسٌ':Added, #3: 3	طِبَاعَ النَّاسِ
u'طِبَاعٌ نِساءٌ':Added, #4: 4	طِبَاعِ النَّاسِ
u'طِبَاقٌ أرْضٌ':Added, #1: 1	طِبَاعَ النِّسَاءِ
u'طِبَاقٌ نَارٌ':Added, #1: 1	طِبَاقِ الْأَرْضِ
u'طَبْخٌ بَقِيَّةٌ':Added, #1: 1	طِبَاقِ النَّارِ
u'طَبْخٌ جِصٌّ':Added, #1: 1	طَبْخَ الْبَقِيَّةِ
u'طَبْخٌ خُبْزٌ':Added, #1: 1	طَبْخِ جِصٍّ
u'طَبْخٌ طعام':Added, #1: 1	طَبْخِ الْخُبْزِ
u'طَبْخٌ طَعَامٌ':Added, #1: 1	طَبْخِ الطَّعَامِ
u'طَبْخٌ طعام':Added, #1: 1	طَبْخِ الطَّعَامِ
u'طَبْخٌ طَعَامٌ':Added, #2: 2	طَبْخُ طَعَامِهِ
u'طَبَخَ عَصِيرٌ':Predicate, #2: 2	طَبْخُ طَعَامِهِ
u'طَبْخٌ عَصِيرٌ':Added, #2: 2	طَبَخَ الْعَصِيرَ
u'طَبْخٌ عَصِيرٌ':Added, #1: 1	طَبْخُ الْعَصِيرِ
u'طَبْخٌ قِدْرٌ':Added, #3: 3	طَبْخِ الْعَصِيرِ
u'طَبَخَ لَحْمٌ':Predicate, #1: 1	طَبْخِ قِدْرٍ
u'طَبَخَ لَحْمٌ':Predicate, #2: 2	طَبَخَ اللَّحْمَ
u'طَبْخٌ لَحْمٌ':Added, #2: 2	طَبَخَ لَحْمَ
u'طَبْخٌ لَحْمٌ':Added, #1: 1	طَبْخَ اللَّحْمِ
u'طَبْخٌ لَحْمٌ':Added, #1: 1	طَبْخُ اللَّحْمِ
u'طَبَخَ نَقِيعٌ':Predicate, #3: 3	طَبْخِ اللَّحْمِ
u'طَبَّ رَجُلٌ':Subject, #1: 1	طَبَخَ نَقِيعَ
u'طَبْعٌ أرْضٌ':Added, #1: 1	طَبَّ الرَّجُلُ
u'طَبْعٌ أَشْيَاءٌ':Added, #2: 2	طَبْعِ الْأَرْضِ
u'طَبْعٌ الْمَرْءُ':Added, #1: 1	طَبْعِ الْأَشْيَاءِ
u'طَبْعٌ الْمَرْأَةُ':Added, #1: 1	طَبْعِ الْمَرْءِ
u'طَبْعٌ إِنْسانٌ':Added, #1: 1	طَبْعَ الْمَرْأَةِ
u'طَبْعٌ إِنْسانٌ':Added, #1: 1	طَبْعِ الْإِنْسَانِ
u'طَبْعٌ بساط':Added, #2: 2	طَبْعَ الْإِنْسَانِ
u'طَبْعٌ بِساطٌ':Added, #1: 1	طَبْعِ الْبِسَاطِ
u'طَبْعٌ بَشَرِيٌّ':Added, #1: 1	طَبْعِ الْبِسَاطِ
u'طَبْعٌ بَشَرِيَّةٌ':Added, #1: 1	طَبْعُ الْبَشَرِيَّةِ
u'طَبْعٌ ثِيابٌ':Added, #1: 1	طَبْعُ الْبَشَرِيَّةِ
u'طَبْعٌ حَيَاةٌ':Added, #2: 2	طَبْعِ الثِّيَابِ
u'طَبْعٌ دَابَّةٌ':Added, #1: 1	طَبْعُ الْحَيَاةِ
u'طَبْعٌ رَجُلٌ':Added, #1: 1	طَبْعَ الدَّابَّةِ
u'طَبْعٌ سَائِقٌ':Added, #1: 1	طَبْعَ الرَّجُلِ
u'طَبْعٌ سُكَّرٌ':Added, #1: 1	طَبْعِ السَّائِقِ
u'طَبْعٌ شَعِيرٌ':Added, #1: 1	طَبْعِ السُّكَّرِ
u'طَبْعٌ كِتَابٌ':Added, #2: 2	طَبْعُ الشَّعِيرِ
u'طَبْعٌ لُحُومٌ':Added, #1: 1	طَبْعُ كِتَابِ
u'طَبْعٌ مَاءٌ':Added, #1: 1	طَبْعِ اللُّحُومِ
u'طَبْعٌ مَالِكٌ':Added, #3: 3	طَبْعِ الْمَاءِ
u'طَبْعٌ مُسْلِمٌ':Added, #1: 1	طَبْعَ الْمَالِكِ
u'طَبْعٌ مَنِيٌّ':Added, #2: 2	طَبْعَ الْمُسْلِمِ
u'طَبْعٌ مَوْتٌ':Added, #1: 1	طَبْعِ الْمَنِيِّ
u'طَبْعٌ نِساءٌ':Added, #1: 1	طَبْعُ الْمَوْتِ
u'طَبْعٌ واحد':Added, #2: 2	طَبْعِ النِّسَاءِ
u'طَبْعٌ وَاحِدٌ':Added, #1: 1	طَبْعٍ وَاحِدٍ
u'طَبْعٌ ولد':Added, #1: 1	طَبْعٍ وَاحِدٍ
u'طَبْعٌ وَلَدٌ':Added, #1: 1	طَبْعَ الْوَلَدِ
u'طَبَّقَ أرْضٌ':Predicate, #1: 1	طَبْعَ الْوَلَدِ
u'طَبَّقَ بَيْتٌ':Predicate, #1: 1	طَبَّقَ الْأَرْضَ
u'طَبَّقَ بَيْنٌ':Predicate, #1: 1	طَبَّقَ الْبَيْتَ
u'طَبَّقَ حَرامٌ':Subject, #1: 1	طَبَّقَ بَيْنَ
u'طَبِقَ سَوادٌ':Predicate, #1: 1	طَبَّقَ الْحَرَامُ
u'طَبَّقَ فَمٌ':Predicate, #2: 2	أَطْبَقَ السَّوَادَ
u'طَبَّقَ مُفَصَّلٌ':Predicate, #1: 1	طَبَّقَ الْفَمَ
u'طَبَقٌ واحد':Added, #1: 1	طَبَّقَ الْمُفَصَّلَ
u'طَبَقٌ وَاحِدٌ':Added, #1: 1	طَبَقٍ وَاحِدٍ
u'طَبْلٌ حَجيجٌ':Added, #1: 1	طَبَقٍ وَاحِدٍ
u'طَبْلٌ حَرْبٌ':Added, #1: 1	طَبْلِ الْحَجِيجِ
u'طَبْلٌ حَرْبٌ':Added, #1: 1	طَبْلَ الْحَرْبِ
u'طَبْلٌ حَرْبٌ':Added, #1: 1	طَبْلُ الْحَرْبِ
u'طَبْلٌ حَرْبٌ':Added, #1: 1	طَبْلِ الْحَرْبِ
u'طَبْلٌ غُزَاةٌ':Added, #1: 1	طَبْلُ حَرْبٍ
u'طَبْلٌ غُزَاةٌ':Added, #1: 1	طَبْلَ الْغُزَاةِ
u'طَبْلٌ لَهْوٌ':Added, #3: 3	طَبْلُ الْغُزَاةِ
u'طَبْلٌ لَهْوٌ':Added, #1: 1	طَبْلِ اللَّهْوِ
u'طَبْلٌ لَهْوٌ':Added, #1: 1	طَبْلُ لَهْوٍ
u'طَبْلٌ لَهْوٌ':Added, #3: 3	طَبْلُ اللَّهْوِ
u'طُبُولٌ لَهْوٌ':Added, #3: 3	طَبْلَ لَهْوٍ
u'طُبُولٌ لَهْوٌ':Added, #1: 1	طُبُولَ اللَّهْوِ
u'طَحَنَ أَكْثَرُ':Predicate, #1: 1	طُبُولِ اللَّهْوِ
u'طَحَنَ حِنْطَةٌ':Predicate, #1: 1	طَحَنَ أَكْثَرَ
u'طَحَنَ حِنْطَةٌ':Predicate, #1: 1	طَحَنَ الْحِنْطَةَ
u'طَحَنَ غَاصِبٌ':Subject, #1: 1	طَحَنَ حِنْطَةَ
u'طَحَنَ قَدْرٌ':Predicate, #1: 1	طَحَنَ الْغَاصِبُ
u'طَحَنَ قَمْحٌ':Predicate, #1: 1	طَحَنَ الْقَدْرَ
u'طَرَأَ أَبٌ':Subject, #2: 2	طَحَنَ الْقَمْحَ
u'طَرَأَ أَخٌ':Subject, #1: 1	طَرَأَ الْأَبُ
u'طَرَأَ إِسْلامٌ':Subject, #1: 1	طَرَأَ أَخٌ
u'طَرَأَ أَوَّلُ':Subject, #1: 1	طَرَأَ الْإِسْلَامُ
u'طَرَأَ تَحْرِيمٌ':Subject, #1: 1	طَرَأَ أَوَّلُ
u'طَرَأَ تَكْليفٌ':Subject, #2: 2	طَرَأَ التَّحْرِيمُ
u'طَرَأَ تَكْليفٌ':Subject, #1: 1	طَرَأَ تَكْلِيفُ
u'طَرَأَ تَكْليفٌ':Subject, #1: 1	طَرَأَ تَكْلِيفُهُ
u'طَرَأَ تَلَفٌ':Subject, #2: 2	طَرَأَ التَّكْلِيفُ
u'طَرَأَ تَوَقُّفٌ':Subject, #1: 1	طَرَأَ تَلَفُ
u'طَرَأَ جُنُونٌ':Subject, #1: 1	طَرَأَ التَّوَقُّفُ
u'طَرَأَ جُنُونٌ':Subject, #1: 1	طَرَأَ الْجُنُونُ
u'طَرَأَ جُنُونٌ':Subject, #2: 2	طَرَأَ جُنُونُهُ
u'طَرَأَ حَظْر':Subject, #6: 6	طَرَأَ جُنُونٌ
u'طَرَأَ حَقٌّ':Subject, #1: 1	طَرَأَ الْحَظْرُ
u'طَرَأَ حِلٌّ':Subject, #1: 1	طَرَأَ حَقُّهُ
u'طَرَأَ حِلٌّ':Subject, #2: 2	طَرَأَ حِلٌّ
u'طَرَأَ حَيْضٌ':Subject, #2: 2	طَرَأَ حِلُّ
u'طَرَأَ حَيْضٌ':Subject, #1: 1	طَرَأَ الْحَيْضُ
u'طَرَأَ خرس':Subject, #1: 1	طَرَأَ حَيْضٌ
u'طَرَأَ خَوْفٌ':Subject, #4: 4	طَرَأَ خَرَسُهُ
u'طَرَأَ دَيْنٌ':Subject, #1: 1	طَرَأَ الْخَوْفُ
u'طَرَأَ رضاع':Subject, #2: 2	طَرَأَ دَيْنٌ
u'طَرَأَ رِقٌّ':Subject, #1: 1	طَرَأَ رَضَاعٌ
u'طَرَأَ رِقٌّ':Subject, #1: 1	طَرَأَ رِقُّهُ
u'طَرَأَ سَفَهٌ':Subject, #2: 2	طَرَأَ الرِّقُّ
u'طَرَأَ سَفَهٌ':Subject, #1: 1	طَرَأَ سَفَهُهُ
u'طَرَأَ سَوادٌ':Subject, #2: 2	طَرَأَ سَفَهُ
u'طَرَأَ شَكٌّ':Subject, #1: 1	طَرَأَ السَّوَادُ
u'طَرَأَ شَكٌّ':Subject, #1: 1	طَرَأَ شَكُّهُ
u'طَرَأَ شَيْءٌ':Subject, #2: 2	طَرَأَ الشَّكُّ
u'طَرَأَ صَلاَحٌ':Subject, #1: 1	طَرَأَ شَيْءٌ
u'طَرَأَ عِبَارَةٌ':Subject, #2: 2	طَرَأَ صَلَاحٌ
u'طَرَأَ عجز':Subject, #1: 1	طَرَأَ عِبَارَةُ
u'طَرَأَ عَجْزٌ':Subject, #1: 1	طَرَأَ عَجْزُهُ
u'طَرَأَ عَجْزٌ':Subject, #1: 1	طَرَأَ عَجْزُهُ
u'طَرَأَ عجز':Subject, #2: 2	طَرَأَ عَجْزٌ
u'طَرَأَ عَجْزٌ':Subject, #3: 3	طَرَأَ الْعَجْزُ
u'طَرَأَ عَدَمٌ':Subject, #3: 3	طَرَأَ الْعَجْزُ
u'طَرَأَ عُذْرٌ':Subject, #1: 1	طَرَأَ عَدَمُ
u'طَرَأَ عُذْرٌ':Subject, #1: 1	طَرَأَ عُذْرٌ
u'طَرَأَ عَضْب':Subject, #2: 2	طَرَأَ الْعُذْرُ
u'طراف أَحْرارٌ':Added, #1: 1	طَرَأَ الْعَضْبُ
u'طراف أَحْكَامٌ':Added, #1: 1	أَطْرَافِ الْأَحْرَارِ
u'طراف آدَمِيٌّ':Added, #1: 1	أَطْرَافِ الْأَحْكَامِ
u'طراف أرْضٌ':Added, #1: 1	أَطْرَافَ الْآدَمِيِّ
u'طراف أرْضٌ':Added, #1: 1	أَطْرَافُ الْأَرْضِ
u'طراف أَصابِعُ':Added, #1: 1	أَطْرَافِ الْأَرْضِ
u'طراف أَصابِعُ':Added, #10: 10	أَطْرَافِ أَصَابِعِهِ
u'طراف أَصابِعُ':Added, #2: 2	أَطْرَافَ أَصَابِعِهِ
u'طراف أَصابِعُ':Added, #2: 2	أَطْرَافَ الْأَصَابِعِ
u'طراف أَصابِعُ':Added, #3: 3	أَطْرَافُ الْأَصَابِعِ
u'طراف أَصابِعُ':Added, #4: 4	أَطْرَافَ أَصَابِعِ
u'طراف أَصابِعُ':Added, #8: 8	أَطْرَافِ أَصَابِعِ
u'طراف أَقْدَامٌ':Added, #9: 9	أَطْرَافِ الْأَصَابِعِ
u'طراف بادِي':Added, #1: 1	أَطْرَافِ الْأَقْدَامِ
u'طراف بَادِيَةٌ':Added, #1: 1	أَطْرَافَ الْبَادِيَةِ
u'طراف بِلادٌ':Added, #1: 1	أَطْرَافَ الْبَادِيَةِ
u'طراف بِلادٌ':Added, #1: 1	أَطْرَافَ الْبِلَادِ
u'طراف بِلادٌ':Added, #2: 2	أَطْرَافِ الْبِلَادِ
u'طراف بَلَدٌ':Added, #2: 2	أَطْرَافُ بِلَادِ
u'طراف بَيْتٌ':Added, #5: 5	أَطْرَافِ الْبَلَدِ
u'طراف ثَوْبٌ':Added, #1: 1	أَطْرَافِ الْبَيْتِ
u'طراف ثَوْبٌ':Added, #1: 1	أَطْرَافِ الثّوْبِ
u'طراف ثِيابٌ':Added, #5: 5	أَطْرَافِ الثَّوْبِ
u'طراف جَبْهَةٌ':Added, #1: 1	أَطْرَافِ الثِّيَابِ
u'طراف جَبْهَةٌ':Added, #2: 2	أَطْرَافِ الْجَبْهَةِ
u'طراف جَبِيرَة':Added, #2: 2	أَطْرَافِ جَبْهَتِهِ
u'طراف جُذُوعٌ':Added, #1: 1	أَطْرَافِ الْجَبِيرَةِ
u'طراف جُذُوعٌ':Added, #1: 1	أَطْرَافُ جُذُوعٍ
u'طراف حافِرٌ':Added, #1: 1	أَطْرَافُ جُذُوعِهِ
u'طراف حافِظٌ':Added, #1: 1	أَطْرَافِ حَافِرِ
u'طراف حَجَرٌ':Added, #2: 2	أَطْرَافِ الْحَافِظِ
u'طراف حُرٌّ':Added, #1: 1	أَطْرَافِ حَجَرٍ
u'طراف حَرَمٌ':Added, #3: 3	أَطْرَافِ الْحُرِّ
u'طراف حيطانٌ':Added, #1: 1	أَطْرَافِ الْحَرَمِ
u'طراف حَيَوَانٌ':Added, #1: 1	أَطْرَافِ الْحِيطَانِ
u'طراف حَيَوَانٌ':Added, #1: 1	أَطْرَافَ حَيَوَانٍ
u'طراف خَاصِرَةٌ':Added, #5: 5	أَطْرَافِ الْحَيَوَانِ
u'طراف خَشَبٌ':Added, #1: 1	أَطْرَافُ الْخَاصِرَةِ
u'طراف خَشَبٌ':Added, #1: 1	أَطْرَافِ الْخَشَبِ
u'طراف خَشَبٌ':Added, #1: 1	أَطْرَافُ خَشَبِ
u'طَرَأَ فَرَحٌ':Subject, #1: 1	أَطْرَافَ خَشَبِهِ
u'طراف رَطْبَةٌ':Added, #1: 1	طَرَأَ فَرَحٌ
u'طَرَأَ فساد':Subject, #1: 1	أَطْرَافَ الرَّطْبَةِ
u'طَرَأَ فَسَادٌ':Subject, #1: 1	طَرَأَ الْفَسَادُ
u'طَرَأَ فساد':Subject, #1: 1	طَرَأَ الْفَسَادُ
u'طَرَأَ فَسَادٌ':Subject, #1: 1	طَرَأَ فَسَادُهُ
u'طراف سِتٌّ':Added, #1: 1	طَرَأَ فَسَادُهُ
u'طَرَأَ فِسْقٌ':Subject, #1: 1	أَطْرَافِ السِّتَّةِ
u'طَرَأَ فِسْقٌ':Subject, #1: 1	طَرَأَ الْفِسْقُ
u'طراف سَمَاءٌ':Added, #2: 2	طَرَأَ فِسْقُهُ
u'طراف سَمَاءٌ':Added, #1: 1	أَطْرَافِ السَّمَاءِ
u'طراف سهام':Added, #2: 2	أَطْرَافُ السَّمَاءِ
u'طراف سِهَامٌ':Added, #1: 1	أَطْرَافِ السِّهَامِ
u'طراف شَاةٌ':Added, #1: 1	أَطْرَافِ السِّهَامِ
u'طراف شَجَرٌ':Added, #1: 1	أَطْرَافَ شَاةٍ
u'طراف شَجَرٌ':Added, #1: 1	أَطْرَافَ الشّجَرِ
u'طراف شَعْرٌ':Added, #2: 2	أَطْرَافِ الشَّجَرِ
u'طراف شَعْرٌ':Added, #1: 1	أَطْرَافَ الشَّعْرِ
u'طراف شَعَرٌ':Added, #1: 1	أَطْرَافُ الشَّعْرِ
u'طراف شَعْرٌ':Added, #1: 1	أَطْرَافِ شَعَرِهِ
u'طراف شَعْرٌ':Added, #2: 2	أَطْرَافِ شَعْرِ
u'طراف شَوَارِبُ':Added, #3: 3	أَطْرَافِ شَعْرِهِ
u'طراف صَحِيحٌ':Added, #1: 1	أَطْرَافُ الشَّوَارِبِ
u'طراف ضلع':Added, #1: 1	أَطْرَافِ الصَّحِيحِ
u'طراف ضِلْعٌ':Added, #1: 1	أَطْرَافُ الضِّلْعِ
u'طراف عِبَارَةٌ':Added, #1: 1	أَطْرَافُ الضِّلْعِ
u'طراف عَبْدٌ':Added, #1: 1	أَطْرَافِ الْعِبَارَةِ
u'طراف عَبْدٌ':Added, #3: 3	أَطْرَافَ الْعَبْدِ
u'طراف عَبِيدٌ':Added, #5: 5	أَطْرَافِ الْعَبْدِ
u'طراف عَبِيدٌ':Added, #1: 1	أَطْرَافَ الْعَبِيدِ
u'طراف عَصَبٌ':Added, #2: 2	أَطْرَافِ الْعَبِيدِ
u'طراف فُصُولٌ':Added, #1: 1	أَطْرَافُ عَصَبٍ
u'طَرَأَ فقر':Subject, #1: 1	أَطْرَافَ الْفُصُولِ
u'طَرَأَ فَقْرٌ':Subject, #1: 1	طَرَأَ فَقْرُهُ
u'طراف كَفٌّ':Added, #1: 1	طَرَأَ فَقْرُهُ
u'طراف كَلاَمٌ':Added, #1: 1	أَطْرَافِ الْكَفِّ
u'طراف كَلاَمٌ':Added, #1: 1	أَطْرَافَ الْكَلَامِ
u'طراف كَلاَمٌ':Added, #1: 1	أَطْرَافُ الْكَلَامِ
u'طراف كَلاَمٌ':Added, #1: 1	أَطْرَافِ كَلَامِهِ
u'طراف لِحْيَةٌ':Added, #2: 2	أَطْرَافُ كَلَامِ
u'طراف لِحْيَةٌ':Added, #2: 2	أَطْرَافِ اللِّحْيَةِ
u'طراف مَزَارِعُ':Added, #4: 4	أَطْرَافِ لِحْيَتِهِ
u'طراف مَسْأَلَةٌ':Added, #1: 1	أَطْرَافِ الْمَزَارِعِ
u'طراف مِصْرٌ':Added, #1: 1	أَطْرَافِ الْمَسْأَلَةِ
u'طراف مَمْلَكَةٌ':Added, #1: 1	أَطْرَافِ الْمِصْرِ
u'طراف ميل':Added, #4: 4	أَطْرَافِ مَمْلَكَتِهِ
u'طراف مِيلٌ':Added, #1: 1	أَطْرَافِ الْمِيلِ
u'طراف نَفْسٌ':Added, #1: 1	أَطْرَافِ الْمِيلِ
u'طراف وَشِيجٌ':Added, #1: 1	أَطْرَافَ نَفْسِهِ
u'طَرَأَ قَالٌ':Predicate, #2: 2	أَطْرَافَ الْوَشِيجِ
u'طَرَأَ قَصْدٌ':Subject, #1: 1	طَرَأَ قَالَ
u'طَرَأَ قَصْدٌ':Subject, #1: 1	طَرَأَ قَصْدُهُ
u'طَرَأَ قَطْعٌ':Subject, #2: 2	طَرَأَ قَصْدُ
u'طَرَأَ كَسَادٌ':Subject, #1: 1	طَرَأَ قَطْعُهُ
u'طَرَأَ مَانِعٌ':Subject, #1: 1	طَرَأَ الْكَسَادُ
u'طَرَأَ مَانِعٌ':Subject, #4: 4	طَرَأَ الْمَانِعُ
u'طَرَأَ مُفْسِدٌ':Subject, #4: 4	طَرَأَ مَانِعٌ
u'طَرَأَ مِلْكٌ':Subject, #1: 1	طَرَأَ الْمُفْسِدُ
u'طَرَأَ مِلْكٌ':Subject, #2: 2	طَرَأَ الْمِلْكُ
u'طَرَأَ مُؤَبَّدٌ':Subject, #3: 3	طَرَأَ مِلْكٌ
u'طَرَأَ مُوجِبٌ':Subject, #1: 1	طَرَأَ مُؤَبَّدُ
u'طَرَأَ مَوْقُوفٌ':Subject, #2: 2	طَرَأَ مُوجِبٌ
u'طَرَأَ نَاسِخٌ':Subject, #1: 1	طَرَأَ مَوْقُوفٌ
u'طَرَأَ نَاسِخ':Subject, #1: 1	طَرَأَ نَاسِخٌ
u'طَرَأَ نَافِذٌ':Subject, #1: 1	طَرَأَ نَاسِخٌ
u'طَرَأَ نَاقِصٌ':Subject, #1: 1	طَرَأَ نَافِذٌ
u'طَرَأَ نَاقِلٌ':Subject, #1: 1	طَرَأَ نَاقِصٌ
u'طَرَأَ نَحْوٌ':Subject, #1: 1	طَرَأَ نَاقِلٌ
u'طَرَأَ نَسَبٌ':Subject, #1: 1	طَرَأَ نَحْوُ
u'طَرَأَ وَارِثٌ':Subject, #2: 2	طَرَأَ نَسَبٌ
u'طَرَاوَةٌ زُبْدٌ':Added, #1: 1	طَرَأَ وَارِثٌ
u'طرب طِبَاعٌ':Added, #1: 1	طَرَاوَةَ الزُّبْدِ
u'طَرَبٌ طِبَاعٌ':Added, #1: 1	طَرَبُ الطِّبَاعِ
u'طرب وَالِهٌ':Added, #1: 1	طَرَبُ الطِّبَاعِ
u'طَرَبٌ وَالِهٌ':Added, #1: 1	طَرَبَ الْوَالِهِ
u'طَرَّ جَيْبٌ':Predicate, #1: 1	طَرَبَ الْوَالِهِ
u'طَرْحٌ أَجْرٌ':Added, #1: 1	طَرَّ جَيْبَ
u'طَرْحٌ أُجْرَةٌ':Added, #1: 1	طَرْحِ أَجْرِ
u'طَرْحٌ أَخْشَابٌ':Added, #2: 2	طَرْحِ أُجْرَةِ
u'طَرْحٌ إكْرَاهٌ':Added, #1: 1	طَرْحِ أَخْشَابٍ
u'طَرْحٌ إمَامٌ':Added, #1: 1	طَرْحُ الإِكْرَاهِ
u'طَرْحٌ أَمْتِعَةٌ':Added, #1: 1	طَرْحِ الْإِمَامِ
u'طَرْحٌ بَذْرٌ':Added, #2: 2	طَرْحُ الْأَمْتِعَةِ
u'طَرْحٌ بُرْغوثٌ':Added, #1: 1	طَرْحَ الْبَذْرِ
u'طَرَحَ بَعْضٌ':Predicate, #1: 1	طَرْحُ الْبُرْغُوثِ
u'طَرْحٌ تَبِيع':Added, #1: 1	طَرَحَ بَعْضَ
u'طَرْحٌ تُرَابٌ':Added, #1: 1	طَرْحُ التَّبِيعِ
u'طَرْحٌ ثَلْجٌ':Added, #1: 1	طَرْحِ التُّرَابِ
u'طَرْحٌ ثَلْجٌ':Added, #1: 1	طَرْحُ الثَّلْجِ
u'طَرْحٌ ثَلْجٌ':Added, #1: 1	طَرْحِ الثَّلْجِ
u'طَرْحٌ ثَوْبٌ':Added, #1: 1	طَرْحِ ثَلْجٍ
u'طَرْحٌ ثِيابٌ':Added, #1: 1	طَرْحُ ثَوْبٍ
u'طَرَحَ جناح':Predicate, #1: 1	طَرْحَ الثّيَابِ
u'طَرَحَ جَنَاحٌ':Predicate, #1: 1	طَرَحَ الْجَنَاحَ
u'طَرْحٌ خرق':Added, #1: 1	طَرَحَ الْجَنَاحَ
u'طَرْحٌ خَرْقٌ':Added, #1: 1	طَرْحِ الْخَرْقِ
u'طَرْحٌ خَشَبٌ':Added, #1: 1	طَرْحِ الْخَرْقِ
u'طَرْحٌ خَمْرٌ':Added, #2: 2	طَرْحِ خَشَبٍ
u'طَرْحٌ دَيْنٌ':Added, #1: 1	طَرْحُ خَمْرٍ
u'طَرْحٌ رَأْيٌ':Added, #1: 1	طَرْحُ الدَّيْنِ
u'طَرَحَ رَجُلٌ':Subject, #1: 1	طَرْحِ الرَّأْيِ
u'طَرْحٌ رَغيفٌ':Added, #1: 1	طَرَحَ رَجُلٌ
u'طَرْحٌ زُبالَةٌ':Added, #1: 1	طَرْحُ الرَّغِيفِ
u'طَرَحَ سَمَكٌ':Predicate, #1: 1	طَرْحِ الزُّبَالَةِ
u'طَرَحَ سِنٌّ':Predicate, #1: 1	طَرَحَ السَّمَكَ
u'طَرْحٌ سنن':Added, #1: 1	طَرَحَ سِنَّ
u'طَرْحٌ سَهْمٌ':Added, #1: 1	طَرْحِ السُّنَنِ
u'طَرْحٌ سَهْمٌ':Added, #1: 1	طَرْحُ السَّهْمِ
u'طَرْحٌ سَيِّئٌ':Added, #3: 3	طَرْحِ السَّهْمِ
u'طَرْحٌ شَاةٌ':Added, #1: 1	طَرْحِ سَيِّئَاتِهِ
u'طَرْحٌ شَكٌّ':Added, #2: 2	طَرْحُ الشَّاةِ
u'طَرْحٌ شَهَادَةٌ':Added, #1: 1	طَرْحُ الشَّكِّ
u'طَرْحٌ شَهَادَةٌ':Added, #1: 1	طَرْحُ الشَّهَادَةِ
u'طَرْحٌ شَيْءٌ':Added, #1: 1	طَرْحِ شَهَادَتِهِ
u'طَرْحٌ صَخْرَةٌ':Added, #2: 2	طَرْحِ شَيْءٍ
u'طَرْحٌ ضَعِيفٌ':Added, #1: 1	طَرْحِ الصّخْرَةِ
u'طَرْحٌ ضَمَانٌ':Added, #1: 1	طَرْحِ الضَّعِيفِ
u'طَرْحٌ طِينٌ':Added, #1: 1	طَرْحِ ضَمَانِهِ
u'طَرْحٌ ظِلٌّ':Added, #1: 1	طَرْحُ طِينِ
u'طَرَحَ عَصِيرٌ':Predicate, #1: 1	طَرْحِ ظِلِّ
u'طَرْحٌ عَصِيرٌ':Added, #1: 1	طَرَحَ الْعَصِيرَ
u'طَرَحَ عَلَقَةٌ':Predicate, #1: 1	طَرْحِ الْعَصِيرِ
u'طَرْحٌ عِيَالٌ':Added, #1: 1	طَرَحَ الْعَلَقَةَ
u'طَرَحَ فَضْلٌ':Predicate, #1: 1	طَرْحِ عِيَالِهِ
u'طَرَحَ قَبَاءٌ':Predicate, #1: 1	طَرَحَ الْفَضْلَ
u'طَرْحٌ قَبَاءٌ':Added, #1: 1	طَرَحَ الْقَبَاءَ
u'طَرَحَ قَدَحٌ':Predicate, #1: 1	طَرْحُ الْقَبَاءِ
u'طَرَحَ قُرَادٌ':Predicate, #1: 1	طَرَحَ الْقَدَحَ
u'طَرْحٌ قِشْرٌ':Added, #1: 1	طَرَحَ الْقُرَادَ
u'طَرْحٌ قُمَامَةٌ':Added, #1: 1	طَرْحِ قِشْرِهِ
u'طَرْحٌ قَمِيصٌ':Added, #1: 1	طَرْح الْقُمَامَةِ
u'طَرْحٌ قَمِيصٌ':Added, #1: 1	طَرْحَ قَمِيصِهِ
u'طَرَحَ قَوْمٌ':Subject, #1: 1	طَرْحُ قَمِيصِهِ
u'طَرْحٌ قِيمَةٌ':Added, #1: 1	طَرَحَ الْقَوْمُ
u'طَرْحٌ كُنَاسَةٌ':Added, #1: 1	طَرْحِ قِيمَةِ
u'طَرْحٌ كُنَاسَةٌ':Added, #1: 1	طَرْحِ كُنَاسَتِهِ
u'طَرْحٌ لَحْمٌ':Added, #2: 2	طَرْحِ الْكُنَاسَةِ
u'طَرَحَ لُؤْلُؤٌ':Predicate, #1: 1	طَرْحِ اللَّحْمِ
u'طَرْحٌ مَاءٌ':Added, #1: 1	طَرَحَ لُؤْلُؤَ
u'طَرْحٌ مَاءٌ':Added, #1: 1	طَرْحَ الْمَاءِ
u'طَرْحٌ مَالٌ':Added, #2: 2	طَرْحُ الْمَاءِ
u'طَرْحٌ مُتَشَابِهٌ':Added, #1: 1	طَرْحَ الْمَالِ
u'طَرْحٌ مُشْتَرَكٌ':Added, #1: 1	طَرْحِ الْمُتَشَابِهِ
u'طَرْحٌ مَعْلُومٌ':Added, #1: 1	طَرْحِ الْمُشْتَرَكِ
u'طَرْحٌ مَيْتٌ':Added, #1: 1	طَرْحَ الْمَعْلُومِ
u'طَرْحٌ مَيْتَةٌ':Added, #1: 1	طَرْحِ الْمَيْتَةِ
u'طَرَحَ نَبِيٌّ':Subject, #1: 1	طَرْحِ الْمَيْتَةِ
u'طَرْحٌ نَحْوٌ':Added, #1: 1	طَرَحَ النَّبِيُّ
u'طَرَحَ نَقْضٌ':Predicate, #1: 1	طَرْحُ نَحْوِ
u'طَرْحٌ ولد':Added, #1: 1	طَرَحَ نَقْضَ
u'طَرْحٌ وَلَدٌ':Added, #1: 1	طَرْحَ وَلَدِهِ
u'طَرْدٌ اِخْتِيَارٌ':Added, #1: 1	طَرْحَ وَلَدِهِ
u'طَرْدٌ أَدْهَم':Added, #1: 1	طَرْدُ اخْتِيَارِهِ
u'طَرَدَ أصل':Subject, #1: 1	طَرْدَ الْأَدْهَمِ
u'طَرَدَ أًصْلٌ':Subject, #1: 1	طَرَدَ الْأَصْلُ
u'طَرْدٌ اِعْتِبارٌ':Added, #1: 1	طَرَدَ الْأَصْلُ
u'طَرَدَ إمَامٌ':Subject, #1: 1	طَرْدُ اعْتِبَارِ
u'طَرْدٌ حُكْمٌ':Added, #1: 1	طَرَدَ الْإِمَامُ
u'طَرَدَ خِلاَفٌ':Predicate, #1: 1	طَرْدُ الْحُكْمِ
u'طَرْدٌ خِلاَفٌ':Added, #4: 4	طَرَدَ الْخِلَافَ
u'طَرْدٌ خِلاَفٌ':Added, #1: 1	طَرْدِ الْخِلَافِ
u'طَرْدٌ خِلاَفٌ':Added, #1: 1	طَرْدُ خِلَافِ
u'طَرْدٌ خِلاَفٌ':Added, #2: 2	طَرْدَ الْخِلَافِ
u'طَرْدٌ دَليلٌ':Added, #3: 3	طَرْدُ الْخِلَافِ
u'طَرْدٌ رِياحٌ':Added, #1: 1	طَرْدُ الدَّلِيلِ
u'طَرْدٌ شَيَاطِينُ':Added, #1: 1	طَرْدِ الرِّيَاحِ
u'طَرْدٌ شَيْطَانٌ':Added, #1: 1	طَرْدِ الشّيَاطِينِ
u'طَرْدٌ عَادَةٌ':Added, #1: 1	طَرْدِ الشَّيْطَانِ
u'طَرَّدَ عَدَمٌ':Predicate, #1: 1	طَرْدِ الْعَادَةِ
u'طَرْدٌ عِلَّةٌ':Added, #1: 1	طَرَّدَ عَدَمَ
u'طَرْدٌ عِلَّةٌ':Added, #1: 1	طَرْدُ الْعِلَّةِ
u'طَرَدَ قول':Predicate, #2: 2	طَرْدِ الْعِلَّةِ
u'طَرَدَ قَوْلٌ':Predicate, #1: 1	طَرَدَ الْقَوْلَ
u'طَرَدَ قول':Predicate, #1: 1	طَرَدَ الْقَوْلَ
u'طَرَدَ قَوْلٌ':Predicate, #1: 1	طَرَدَ قَوْلَ
u'طَرْدٌ قَوْلٌ':Added, #1: 1	طَرَدَ قَوْلَ
u'طَرْدٌ قول':Added, #1: 1	طَرْدِ الْقَوْلَيْنِ
u'طَرْدٌ قَوْلٌ':Added, #1: 1	طَرْدُ قَوْلِ
u'طَرْدٌ قَوْلٌ':Added, #1: 1	طَرْدُ قَوْلِ
u'طَرْدٌ كَلاَمٌ':Added, #3: 3	طَرْدُ الْقَوْلَيْنِ
u'طَرْدٌ كَلْبٌ':Added, #1: 1	طَرْدِ كَلَامِ
u'طَرْدٌ كُلِّيٌّ':Added, #1: 1	طَرْدَ الْكَلْبِ
u'طَرَدٌ لُبَابٌ':Added, #1: 1	طَرْدِ الْكُلِّيِّ
u'طَرْدٌ مُتَعَدِّي':Added, #1: 1	طَرَدَ اللُّبَابِ
u'طَرْدٌ وَجْهٌ':Added, #1: 1	طَرْدُ الْمُتَعَدِّيَةِ
u'طَرَّ شَارِبٌ':Subject, #2: 2	طَرْدَ الْوَجْهَيْنِ
u'طَرَّ صُرَّةٌ':Predicate, #1: 1	طَرَّ الشَّارِبُ
u'طرف آدَمِيٌّ':Added, #1: 1	طَرَّ صُرَّةَ
u'طَرْفٌ آدَمِيٌّ':Added, #1: 1	طَرْفُ الْآدَمِيِّ
u'طرف إِنْسانٌ':Added, #1: 1	طَرْفُ الْآدَمِيِّ
u'طَرْفٌ إِنْسانٌ':Added, #1: 1	طَرْفِ الْإِنْسَانِ
u'طَرْفَةٌ عَيْنٌ':Added, #1: 1	طَرْفِ الْإِنْسَانِ
u'طَرْفَةٌ عَيْن':Added, #13: 13	طَرْفَةَ عَيْنٍ
u'طَرْفَةٌ عين':Added, #13: 13	طَرْفَةَ عَيْنٍ
u'طَرْفَةٌ عَيْنٌ':Added, #1: 1	طَرْفَةِ الْعَيْنِ
u'طَرْفَةٌ عَيْن':Added, #1: 1	طَرْفَةِ الْعَيْنِ
u'طَرْفَةٌ عَيْنٌ':Added, #1: 1	طَرْفَةِ الْعَيْنِ
u'طَرْفَةٌ عَيْن':Added, #1: 1	طَرْفَةُ عَيْنٍ
u'طَرْفَةٌ عَيْنٌ':Added, #1: 1	طَرْفَةُ عَيْنٍ
u'طَرْفَةٌ عَيْن':Added, #2: 2	طَرْفَةِ عَيْنٍ
u'طرف حُرٌّ':Added, #2: 2	طَرْفَةِ عَيْنٍ
u'طَرْفٌ حُرٌّ':Added, #1: 1	طَرْفِ الْحُرِّ
u'طرف حُرٌّ':Added, #1: 1	طَرْفِ الْحُرِّ
u'طَرْفٌ حُرٌّ':Added, #2: 2	طَرْفُ الْحُرِّ
u'طرف خَيْطٌ':Added, #2: 2	طَرْفُ الْحُرِّ
u'طَرْفٌ خَيْطٌ':Added, #1: 1	طَرْفَ خَيْطٍ
u'طرف شَعْرٌ':Added, #1: 1	طَرْفَ خَيْطٍ
u'طَرْفٌ شَعْرٌ':Added, #1: 1	طَرْفُ الشَّعْرِ
u'طرف صَفٌّ':Added, #1: 1	طَرْفُ الشَّعْرِ
u'طَرْفٌ صَفٌّ':Added, #1: 1	طَرْفَ الصَّفِّ
u'طرف عَبْدٌ':Added, #1: 1	طَرْفَ الصَّفِّ
u'طَرْفٌ عَبْدٌ':Added, #1: 1	طَرْفُ الْعَبْدِ
u'طرف عَيْنٌ':Added, #1: 1	طَرْفُ الْعَبْدِ
u'طرف عَيْن':Added, #4: 4	طَرْفِ عَيْنٍ
u'طَرْفٌ عَيْنٌ':Added, #4: 4	طَرْفِ عَيْنٍ
u'طَرْفٌ عَيْن':Added, #4: 4	طَرْفِ عَيْنٍ
u'طرف مَجْنِيٌّ':Added, #4: 4	طَرْفِ عَيْنٍ
u'طَرْفٌ مَجْنِيٌّ':Added, #1: 1	طَرْفِ مَجْنِيٍّ
u'طرف نَفْسٌ':Added, #1: 1	طَرْفِ مَجْنِيٍّ
u'طَرْفٌ نَفْسٌ':Added, #1: 1	طَرْفِ نَفْسِهِ
u'طَرَقَ أسْمَاعٌ':Predicate, #1: 1	طَرْفِ نَفْسِهِ
u'طَرَقَ بَابٌ':Predicate, #1: 1	طَرَقَ الْأَسْمَاعَ
u'طَرْقٌ حَقٌّ':Added, #1: 1	طَرَقَ الْبَابَ
u'طَرَقَ ذِهْنٌ':Predicate, #1: 1	طَرْقُ الْحَقِّ
u'طَرَقَ عَدُوٌّ':Subject, #1: 1	طَرَقَ الذِّهْنَ
u'طَرَقَ فَاطِمٌ':Predicate, #1: 1	طَرَقَ الْعَدُوُّ
u'طُرُوقٌ مَسَاجِدُ':Added, #1: 1	طَرَقَ فَاطِمَةَ
u'طُرُوقٌ نَاسٌ':Added, #1: 1	طُرُوقِ الْمَسَاجِدِ
u'طُرُوقٌ نِساءٌ':Added, #1: 1	طُرُوقِ النَّاسِ
u'طعام إبَاحَةٌ':Added, #1: 1	طُرُوقِ النِّسَاءِ
u'طَعَامٌ إبَاحَةٌ':Added, #1: 1	طَعَامُ الْإِبَاحَةِ
u'طعام إبَاحَةٌ':Added, #1: 1	طَعَامُ الْإِبَاحَةِ
u'طعام إبَاحَةٌ':Added, #5: 5	طَعَامَ الْإِبَاحَةِ
u'طَعَامٌ إبَاحَةٌ':Added, #5: 5	طَعَامِ الْإِبَاحَةِ
u'طَعَامٌ إبَاحَةٌ':Added, #5: 5	طَعَامَ الْإِبَاحَةِ
u'طعام أَثِيمٌ':Added, #5: 5	طَعَامِ الْإِبَاحَةِ
u'طَعَامٌ أَثِيمٌ':Added, #3: 3	طَعَامُ الْأَثِيمِ
u'طعام أَجِيرٌ':Added, #3: 3	طَعَامُ الْأَثِيمِ
u'طعام أَجِيرٌ':Added, #1: 1	طَعَامَ الْأَجِيرِ
u'طَعَامٌ أَجِيرٌ':Added, #1: 1	طَعَامِ الْأَجِيرِ
u'طَعَامٌ أَجِيرٌ':Added, #1: 1	طَعَامَ الْأَجِيرِ
u'طعام أحَدٌ':Added, #1: 1	طَعَامِ الْأَجِيرِ
u'طَعَامٌ أحَدٌ':Added, #1: 1	طَعَامُ أَحَدِ
u'طعام آدَمِيٌّ':Added, #1: 1	طَعَامُ أَحَدِ
u'طَعَامٌ آدَمِيٌّ':Added, #2: 2	طَعَامُ الْآدَمِيِّ
u'طعام أَرْبَعَةٌ':Added, #2: 2	طَعَامُ الْآدَمِيِّ
u'طَعَامٌ أَرْبَعَةٌ':Added, #1: 1	طَعَامُ أَرْبَعَةٍ
u'طعام أَرْبَعَةٌ':Added, #1: 1	طَعَامُ أَرْبَعَةٍ
u'طَعَامٌ أَرْبَعَةٌ':Added, #1: 1	طَعَامَ الْأَرْبَعَةِ
u'طعام أَغْنِيَاء':Added, #1: 1	طَعَامَ الْأَرْبَعَةِ
u'طَعَامٌ أَغْنِيَاء':Added, #2: 2	طَعَامُ الأَغْنِيَاءِ
u'طعام إقْلِيمٌ':Added, #2: 2	طَعَامُ الأَغْنِيَاءِ
u'طَعَامٌ إقْلِيمٌ':Added, #1: 1	طَعَامِ إقْلِيمٍ
u'طعام الْمَرْأَةُ':Added, #1: 1	طَعَامِ إقْلِيمٍ
u'طَعَامٌ الْمَرْأَةُ':Added, #1: 1	طَعَامِ الْمَرْأَةِ
u'طعام اِمْرَأَةٌ':Added, #1: 1	طَعَامِ الْمَرْأَةِ
u'طَعَامٌ اِمْرَأَةٌ':Added, #1: 1	طَعَامِ امْرَأَتِهِ
u'طعام إِمْلاكٌ':Added, #1: 1	طَعَامِ امْرَأَتِهِ
u'طَعَامٌ إِمْلاكٌ':Added, #1: 1	طَعَامُ الْإِمْلَاكِ
u'طعام أنبياء':Added, #1: 1	طَعَامُ الْإِمْلَاكِ
u'طَعَامٌ أنبياء':Added, #1: 1	طَعَامُ الْأَنْبِيَاءِ
u'طعام إِنْسانٌ':Added, #1: 1	طَعَامُ الْأَنْبِيَاءِ
u'طَعَامٌ إِنْسانٌ':Added, #1: 1	طَعَامِ إنْسَانٍ
u'طعام أهْلٌ':Added, #1: 1	طَعَامِ إنْسَانٍ
u'طَعَامٌ أهْلٌ':Added, #1: 1	طَعَامِ الْأَهْلِ
u'طعام أهْلٌ':Added, #1: 1	طَعَامِ الْأَهْلِ
u'طَعَامٌ أهْلٌ':Added, #1: 1	طَعَامُ أَهْلِهِ
u'طعام أهْلٌ':Added, #1: 1	طَعَامُ أَهْلِهِ
u'طَعَامٌ أهْلٌ':Added, #2: 2	طَعَامَ أَهْلِ
u'طعام أهْلٌ':Added, #2: 2	طَعَامَ أَهْلِ
u'طَعَامٌ أهْلٌ':Added, #2: 2	طَعَامِ أَهْلِهِ
u'طعام أهْلٌ':Added, #2: 2	طَعَامِ أَهْلِهِ
u'طَعَامٌ أهْلٌ':Added, #3: 3	طَعَامُ أَهْلِ
u'طعام أهْلٌ':Added, #3: 3	طَعَامُ أَهْلِ
u'طَعَامٌ أهْلٌ':Added, #4: 4	طَعَامَ أَهْلِهِ
u'طعام أهْلٌ':Added, #4: 4	طَعَامَ أَهْلِهِ
u'طَعَامٌ أهْلٌ':Added, #7: 7	طَعَامِ أَهْلِ
u'طعام أَوَّلُ':Added, #7: 7	طَعَامِ أَهْلِ
u'طَعَامٌ أَوَّلُ':Added, #2: 2	طَعَامُ أَوَّلِ
u'طعام بَحْرٌ':Added, #2: 2	طَعَامُ أَوَّلِ
u'طَعَامٌ بَحْرٌ':Added, #3: 3	طَعَامِ الْبَحْرِ
u'طعام بُرٌّ':Added, #3: 3	طَعَامِ الْبَحْرِ
u'طَعَامٌ بُرٌّ':Added, #1: 1	طَعَامٍ بُرٍّ
u'طعام بُرٌّ':Added, #1: 1	طَعَامٍ بُرٍّ
u'طَعَامٌ بُرٌّ':Added, #3: 3	طَعَامِ بُرٍّ
u'طعام بَلَدٌ':Added, #3: 3	طَعَامِ بُرٍّ
u'طَعَامٌ بَلَدٌ':Added, #1: 1	طَعَامِ الْبَلَدِ
u'طعام بَلَدٌ':Added, #1: 1	طَعَامِ الْبَلَدِ
u'طَعَامٌ بَلَدٌ':Added, #1: 1	طَعَامِ بَلَدِهِ
u'طعام بِنَاءٌ':Added, #1: 1	طَعَامِ بَلَدِهِ
u'طَعَامٌ بِنَاءٌ':Added, #2: 2	طَعَامُ الْبِنَاءِ
u'طعام بَهيمٌ':Added, #2: 2	طَعَامُ الْبِنَاءِ
u'طعام بَهيمٌ':Added, #1: 1	طَعَامَ الْبَهِيمَةِ
u'طَعَامٌ بَهيمٌ':Added, #1: 1	طَعَامُ الْبَهِيمَةِ
u'طَعَامٌ بَهيمٌ':Added, #1: 1	طَعَامَ الْبَهِيمَةِ
u'طعام بَهِيمَةٌ':Added, #1: 1	طَعَامُ الْبَهِيمَةِ
u'طعام بَهِيمَةٌ':Added, #1: 1	طَعَامَ الْبَهِيمَةِ
u'طَعَامٌ بَهِيمَةٌ':Added, #1: 1	طَعَامُ الْبَهِيمَةِ
u'طَعَامٌ بَهِيمَةٌ':Added, #1: 1	طَعَامَ الْبَهِيمَةِ
u'طعام تَعْزِيَةٌ':Added, #1: 1	طَعَامُ الْبَهِيمَةِ
u'طعام تَعْزِيَةٌ':Added, #1: 1	طَعَامُ التّعْزِيَةِ
u'طَعَامٌ تَعْزِيَةٌ':Added, #1: 1	طَعَامِ التّعْزِيَةِ
u'طَعَامٌ تَعْزِيَةٌ':Added, #1: 1	طَعَامُ التّعْزِيَةِ
u'طعام تَمْلِيك':Added, #1: 1	طَعَامِ التّعْزِيَةِ
u'طَعَامٌ تَمْلِيك':Added, #1: 1	طَعَامُ التَّمْلِيكِ
u'طعام تَمْلِيكٌ':Added, #1: 1	طَعَامُ التَّمْلِيكِ
u'طعام تَمْلِيكٌ':Added, #1: 1	طَعَامَ تَمْلِيكٍ
u'طَعَامٌ تَمْلِيكٌ':Added, #1: 1	طَعَامُ تَمْلِيكٍ
u'طَعَامٌ تَمْلِيكٌ':Added, #1: 1	طَعَامَ تَمْلِيكٍ
u'طعام جَامِدٌ':Added, #1: 1	طَعَامُ تَمْلِيكٍ
u'طَعَامٌ جَامِدٌ':Added, #1: 1	طَعَامٍ جَامِدٍ
u'طعام جِنٌّ':Added, #1: 1	طَعَامٍ جَامِدٍ
u'طَعَامٌ جِنٌّ':Added, #1: 1	طَعَامِ الْجِنِّ
u'طعام جَنَّةٌ':Added, #1: 1	طَعَامِ الْجِنِّ
u'طَعَامٌ جَنَّةٌ':Added, #1: 1	طَعَامَ الْجَنَّةِ
u'طعام جُنْدٌ':Added, #1: 1	طَعَامَ الْجَنَّةِ
u'طَعَامٌ جُنْدٌ':Added, #1: 1	طَعَامِ الْجُنْدِ
u'طعام جواد':Added, #1: 1	طَعَامِ الْجُنْدِ
u'طَعَامٌ جواد':Added, #1: 1	طَعَامُ الْجَوَادِ
u'طعام جَوَادٌ':Added, #1: 1	طَعَامُ الْجَوَادِ
u'طَعَامٌ جَوَادٌ':Added, #1: 1	طَعَامُ الْجَوَادِ
u'طعام حاجَةٌ':Added, #1: 1	طَعَامُ الْجَوَادِ
u'طَعَامٌ حاجَةٌ':Added, #1: 1	طَعَامِ الْحَاجَةِ
u'طعام حارٌّ':Added, #1: 1	طَعَامِ الْحَاجَةِ
u'طَعَامٌ حارٌّ':Added, #1: 1	طَعَامٍ حَارٍّ
u'طعام حامِلٌ':Added, #1: 1	طَعَامٍ حَارٍّ
u'طَعَامٌ حامِلٌ':Added, #2: 2	طَعَامَ الْحَامِلِ
u'طعام حُرٌّ':Added, #2: 2	طَعَامَ الْحَامِلِ
u'طَعَامٌ حُرٌّ':Added, #1: 1	طَعَامِ الْحُرِّ
u'طعام حَرْبٌ':Added, #1: 1	طَعَامِ الْحُرِّ
u'طَعَامٌ حَرْبٌ':Added, #1: 1	طَعَامِ الْحَرْبِ
u'طعام حَيَوَانٌ':Added, #1: 1	طَعَامِ الْحَرْبِ
u'طَعَامٌ حَيَوَانٌ':Added, #1: 1	طَعَامِ الْحَيَوَانِ
u'طعام خَادِمٌ':Added, #1: 1	طَعَامِ الْحَيَوَانِ
u'طَعَامٌ خَادِمٌ':Added, #3: 3	طَعَامُ الْخَادِمِ
u'طعام خاصّ':Added, #3: 3	طَعَامُ الْخَادِمِ
u'طَعَامٌ خاصّ':Added, #1: 1	طَعَامٍ خَاصٍّ
u'طعام ختان':Added, #1: 1	طَعَامٍ خَاصٍّ
u'طَعَامٌ ختان':Added, #1: 1	طَعَامُ الْخِتَانِ
u'طعام خِتَانٌ':Added, #1: 1	طَعَامُ الْخِتَانِ
u'طَعَامٌ خِتَانٌ':Added, #1: 1	طَعَامُ الْخِتَانِ
u'طعام خِوَانٌ':Added, #1: 1	طَعَامُ الْخِتَانِ
u'طَعَامٌ خِوَانٌ':Added, #1: 1	طَعَامِ خِوَانٍ
u'طعام دَعْوَةٌ':Added, #1: 1	طَعَامِ خِوَانٍ
u'طعام دَعْوَةٌ':Added, #1: 1	طَعَامَ الدَّعْوَةِ
u'طعام دَعْوَةٌ':Added, #1: 1	طَعَامُ الدَّعْوَةِ
u'طَعَامٌ دَعْوَةٌ':Added, #1: 1	طَعَامِ الدَّعْوَةِ
u'طَعَامٌ دَعْوَةٌ':Added, #1: 1	طَعَامَ الدَّعْوَةِ
u'طَعَامٌ دَعْوَةٌ':Added, #1: 1	طَعَامُ الدَّعْوَةِ
u'طعام رَجُلٌ':Added, #1: 1	طَعَامِ الدَّعْوَةِ
u'طَعَامٌ رَجُلٌ':Added, #1: 1	طَعَامِ الرَّجُلِ
u'طعام رَسُولٌ':Added, #1: 1	طَعَامِ الرَّجُلِ
u'طَعَامٌ رَسُولٌ':Added, #1: 1	طَعَامَ رَسُولِ
u'طعام رَسُولٌ':Added, #1: 1	طَعَامَ رَسُولِ
u'طَعَامٌ رَسُولٌ':Added, #3: 3	طَعَامِ رَسُولِ
u'طعام رَفيقٌ':Added, #3: 3	طَعَامِ رَسُولِ
u'طَعَامٌ رَفيقٌ':Added, #1: 1	طَعَامُ رَفِيقِهِ
u'طعام زائِرٌ':Added, #1: 1	طَعَامُ رَفِيقِهِ
u'طَعَامٌ زائِرٌ':Added, #1: 1	طَعَامُ الزَّائِرِ
u'طعام زَيْدٌ':Added, #1: 1	طَعَامُ الزَّائِرِ
u'طَعَامٌ زَيْدٌ':Added, #3: 3	طَعَامَ زَيْدٍ
u'طعام سِتٌّ':Added, #3: 3	طَعَامَ زَيْدٍ
u'طَعَامٌ سِتٌّ':Added, #2: 2	طَعَامَ سِتَّةِ
u'طعام سَخِيٌّ':Added, #2: 2	طَعَامَ سِتَّةِ
u'طَعَامٌ سَخِيٌّ':Added, #1: 1	طَعَامُ السَّخِيِّ
u'طعام سُلْطَانٌ':Added, #1: 1	طَعَامُ السَّخِيِّ
u'طَعَامٌ سُلْطَانٌ':Added, #1: 1	طَعَامُ سُلْطَانٍ
u'طعام سَلَمٌ':Added, #1: 1	طَعَامُ سُلْطَانٍ
u'طعام سَلَمٌ':Added, #1: 1	طَعَامُ سَلَمٍ
u'طَعَامٌ سَلَمٌ':Added, #1: 1	طَعَامِ سَلَمٍ
u'طَعَامٌ سَلَمٌ':Added, #1: 1	طَعَامُ سَلَمٍ
u'طعام سَلَمٌ':Added, #1: 1	طَعَامِ سَلَمٍ
u'طَعَامٌ سَلَمٌ':Added, #2: 2	طَعَامَ سَلَمٍ
u'طعام سَلَمٌ':Added, #2: 2	طَعَامَ سَلَمٍ
u'طَعَامٌ سَلَمٌ':Added, #4: 4	طَعَامَ السَّلَمِ
u'طعام سَلَمٌ':Added, #4: 4	طَعَامَ السَّلَمِ
u'طَعَامٌ سَلَمٌ':Added, #5: 5	طَعَامِ السَّلَمِ
u'طعام سَنَةٌ':Added, #5: 5	طَعَامِ السَّلَمِ
u'طَعَامٌ سَنَةٌ':Added, #1: 1	طَعَامُ سَنَةٍ
u'طعام سُوءٌ':Added, #1: 1	طَعَامُ سَنَةٍ
u'طَعَامٌ سُوءٌ':Added, #1: 1	طَعَامُ سُوءٍ
u'طعام سَوادٌ':Added, #1: 1	طَعَامُ سُوءٍ
u'طَعَامٌ سَوادٌ':Added, #1: 1	طَعَامِ السَّوَادِ
u'طعام شَيْخٌ':Added, #1: 1	طَعَامِ السَّوَادِ
u'طَعَامٌ شَيْخٌ':Added, #1: 1	طَعَامُ الشَّيْخِ
u'طعام صَاحِبٌ':Added, #1: 1	طَعَامُ الشَّيْخِ
u'طَعَامٌ صَاحِبٌ':Added, #1: 1	طَعَامِ صَاحِبِهِ
u'طعام صبرة':Added, #1: 1	طَعَامِ صَاحِبِهِ
u'طَعَامٌ صبرة':Added, #1: 1	طَعَامِ الصُّبْرَةِ
u'طعام صُبْرَةٌ':Added, #1: 1	طَعَامِ الصُّبْرَةِ
u'طَعَامٌ صُبْرَةٌ':Added, #1: 1	طَعَامِ الصُّبْرَةِ
u'طعام صَبِيٌّ':Added, #1: 1	طَعَامِ الصُّبْرَةِ
u'طَعَامٌ صَبِيٌّ':Added, #1: 1	طَعَامِ الصَّبِيِّ
u'طعام صَبِيٌّ':Added, #1: 1	طَعَامِ الصَّبِيِّ
u'طَعَامٌ صَبِيٌّ':Added, #4: 4	طَعَامَ الصَّبِيِّ
u'طعام صَدِيقٌ':Added, #4: 4	طَعَامَ الصَّبِيِّ
u'طَعَامٌ صَدِيقٌ':Added, #1: 1	طَعَامِ الصَّدِيقِ
u'طعام صَيَارِفَةٌ':Added, #1: 1	طَعَامِ الصَّدِيقِ
u'طَعَامٌ صَيَارِفَةٌ':Added, #2: 2	طَعَامِ الصَّيَارِفَةِ
u'طعام ضِيَافَةٌ':Added, #2: 2	طَعَامِ الصَّيَارِفَةِ
u'طعام ضِيَافَةٌ':Added, #1: 1	طَعَامَ الضِّيَافَةِ
u'طَعَامٌ ضِيَافَةٌ':Added, #1: 1	طَعَامِ الضِّيَافَةِ
u'طَعَامٌ ضِيَافَةٌ':Added, #1: 1	طَعَامَ الضِّيَافَةِ
u'طعام ضِيَافَةٌ':Added, #1: 1	طَعَامِ الضِّيَافَةِ
u'طَعَامٌ ضِيَافَةٌ':Added, #1: 1	طَعَامَ ضِيَافَةٍ
u'طعام ضَيْفٌ':Added, #1: 1	طَعَامَ ضِيَافَةٍ
u'طَعَامٌ ضَيْفٌ':Added, #1: 1	طَعَامُ الضَّيْفِ
u'طعام ضَيْفٌ':Added, #1: 1	طَعَامُ الضَّيْفِ
u'طَعَامٌ ضَيْفٌ':Added, #1: 1	طَعَامِ ضَيْفٍ
u'طعام طَاهِرٌ':Added, #1: 1	طَعَامِ ضَيْفٍ
u'طَعَامٌ طَاهِرٌ':Added, #2: 2	طَعَامٍ طَاهِرٍ
u'طعام طُعْمٌ':Added, #2: 2	طَعَامٍ طَاهِرٍ
u'طَعَامٌ طُعْمٌ':Added, #7: 7	طَعَامُ طُعْمٍ
u'طعام ظلمة':Added, #7: 7	طَعَامُ طُعْمٍ
u'طَعَامٌ ظلمة':Added, #1: 1	طَعَامِ الظَّلَمَةِ
u'طعام عَامٌّ':Added, #1: 1	طَعَامِ الظَّلَمَةِ
u'طعام عَامٌّ':Added, #1: 1	طَعَامُ عَامَّةٍ
u'طَعَامٌ عَامٌّ':Added, #1: 1	طَعَامُ عَامَّةِ
u'طَعَامٌ عَامٌّ':Added, #1: 1	طَعَامُ عَامَّةٍ
u'طعام عَبْدٌ':Added, #1: 1	طَعَامُ عَامَّةِ
u'طَعَامٌ عَبْدٌ':Added, #1: 1	طَعَامُ الْعَبْدِ
u'طعام عِرَاقٌ':Added, #1: 1	طَعَامُ الْعَبْدِ
u'طَعَامٌ عِرَاقٌ':Added, #1: 1	طَعَامِ الْعِرَاقِ
u'طعام عَرَبٌ':Added, #1: 1	طَعَامِ الْعِرَاقِ
u'طَعَامٌ عَرَبٌ':Added, #1: 1	طَعَامُ الْعَرَبِ
u'طعام عُرْسٌ':Added, #1: 1	طَعَامُ الْعَرَبِ
u'طعام عُرْسٌ':Added, #1: 1	طَعَامَ الْعُرْسِ
u'طَعَامٌ عُرْسٌ':Added, #1: 1	طَعَامِ الْعُرْسِ
u'طَعَامٌ عُرْسٌ':Added, #1: 1	طَعَامَ الْعُرْسِ
u'طعام عُرْسٌ':Added, #1: 1	طَعَامِ الْعُرْسِ
u'طَعَامٌ عُرْسٌ':Added, #4: 4	طَعَامُ الْعُرْسِ
u'طعام عِشَاءٌ':Added, #4: 4	طَعَامُ الْعُرْسِ
u'طَعَامٌ عِشَاءٌ':Added, #1: 1	طَعَامُ الْعِشَاءِ
u'طعام عَشْرٌ':Added, #1: 1	طَعَامُ الْعِشَاءِ
u'طعام عَشْرٌ':Added, #1: 1	طَعَامَ عَشْرَةٍ
u'طَعَامٌ عَشْرٌ':Added, #1: 1	طَعَامَ عَشْرَةِ
u'طَعَامٌ عَشْرٌ':Added, #1: 1	طَعَامَ عَشْرَةٍ
u'طعام عُشْرٌ':Added, #1: 1	طَعَامَ عَشْرَةِ
u'طَعَامٌ عُشْرٌ':Added, #2: 2	طَعَامِ الْعُشْرِ
u'طعام عَمَلَةٌ':Added, #2: 2	طَعَامِ الْعُشْرِ
u'طَعَامٌ عَمَلَةٌ':Added, #1: 1	طَعَامِ الْعَمَلَةِ
u'طعام عِيَالٌ':Added, #1: 1	طَعَامِ الْعَمَلَةِ
u'طَعَامٌ عِيَالٌ':Added, #1: 1	طَعَامِ عِيَالِهِ
u'طعام غَائِبٌ':Added, #1: 1	طَعَامِ عِيَالِهِ
u'طَعَامٌ غَائِبٌ':Added, #1: 1	طَعَامَ الْغَائِبِ
u'طعام غَائِبٌ':Added, #1: 1	طَعَامَ الْغَائِبِ
u'طعام غَائِبٌ':Added, #1: 1	طَعَامَ غَائِبٍ
u'طَعَامٌ غَائِبٌ':Added, #1: 1	طَعَامِ غَائِبٍ
u'طَعَامٌ غَائِبٌ':Added, #1: 1	طَعَامَ غَائِبٍ
u'طعام غَائِبٌ':Added, #1: 1	طَعَامِ غَائِبٍ
u'طَعَامٌ غَائِبٌ':Added, #2: 2	طَعَامِ الْغَائِبِ
u'طعام غَدٌ':Added, #2: 2	طَعَامِ الْغَائِبِ
u'طَعَامٌ غَدٌ':Added, #1: 1	طَعَامِ الْغَدِ
u'طعام غَدَاءٌ':Added, #1: 1	طَعَامِ الْغَدِ
u'طَعَامٌ غَدَاءٌ':Added, #1: 1	طَعَامُ الْغَدَاءِ
u'طعام غداة':Added, #1: 1	طَعَامُ الْغَدَاءِ
u'طَعَامٌ غداة':Added, #1: 1	طَعَامُ الْغَدَاةِ
u'طعام غَدَاةٌ':Added, #1: 1	طَعَامُ الْغَدَاةِ
u'طَعَامٌ غَدَاةٌ':Added, #1: 1	طَعَامُ الْغَدَاةِ
u'طعام غَنِيمَةٌ':Added, #1: 1	طَعَامُ الْغَدَاةِ
u'طَعَامٌ غَنِيمَةٌ':Added, #2: 2	طَعَامِ الْغَنِيمَةِ
u'طعام غير':Added, #2: 2	طَعَامِ الْغَنِيمَةِ
u'طعام غَيْرٌ':Added, #10: 10	طَعَامِ الْغَيْرِ
u'طَعَامٌ غير':Added, #10: 10	طَعَامِ الْغَيْرِ
u'طَعَامٌ غَيْرٌ':Added, #10: 10	طَعَامِ الْغَيْرِ
u'طعام غير':Added, #10: 10	طَعَامِ الْغَيْرِ
u'طعام غَيْرٌ':Added, #11: 11	طَعَامَ غَيْرِهِ
u'طَعَامٌ غير':Added, #11: 11	طَعَامَ غَيْرِهِ
u'طَعَامٌ غَيْرٌ':Added, #11: 11	طَعَامَ غَيْرِهِ
u'طعام غير':Added, #11: 11	طَعَامَ غَيْرِهِ
u'طعام غَيْرٌ':Added, #1: 1	طَعَامِ غَيْرِ
u'طَعَامٌ غير':Added, #1: 1	طَعَامِ غَيْرِ
u'طَعَامٌ غَيْرٌ':Added, #1: 1	طَعَامِ غَيْرِ
u'طعام غير':Added, #1: 1	طَعَامِ غَيْرِ
u'طعام غَيْرٌ':Added, #6: 6	طَعَامَ الْغَيْرِ
u'طَعَامٌ غير':Added, #6: 6	طَعَامَ الْغَيْرِ
u'طَعَامٌ غَيْرٌ':Added, #6: 6	طَعَامَ الْغَيْرِ
u'طعام غير':Added, #6: 6	طَعَامَ الْغَيْرِ
u'طعام غَيْرٌ':Added, #7: 7	طَعَامِ غَيْرِهِ
u'طَعَامٌ غير':Added, #7: 7	طَعَامِ غَيْرِهِ
u'طَعَامٌ غَيْرٌ':Added, #7: 7	طَعَامِ غَيْرِهِ
u'طعام فَاجِرٌ':Added, #7: 7	طَعَامِ غَيْرِهِ
u'طَعَامٌ فَاجِرٌ':Added, #2: 2	طَعَامُ الْفَاجِرِ
u'طعام فُجَاءةٌ':Added, #2: 2	طَعَامُ الْفَاجِرِ
u'طَعَامٌ فُجَاءةٌ':Added, #3: 3	طَعَامِ الْفُجَاءَةِ
u'طعام فُلاَنٌ':Added, #3: 3	طَعَامِ الْفُجَاءَةِ
u'طَعَامٌ فُلاَنٌ':Added, #13: 13	طَعَامِ فُلَانٍ
u'طعام فُلاَنٌ':Added, #13: 13	طَعَامِ فُلَانٍ
u'طَعَامٌ فُلاَنٌ':Added, #6: 6	طَعَامَ فُلَانٍ
u'طعام قَادِمٌ':Added, #6: 6	طَعَامَ فُلَانٍ
u'طَعَامٌ قَادِمٌ':Added, #2: 2	طَعَامُ الْقَادِمِ
u'طعام قُدُومٌ':Added, #2: 2	طَعَامُ الْقَادِمِ
u'طَعَامٌ قُدُومٌ':Added, #1: 1	طَعَامُ الْقُدُومِ
u'طعام قَرْضٌ':Added, #1: 1	طَعَامُ الْقُدُومِ
u'طَعَامٌ قَرْضٌ':Added, #3: 3	طَعَامِ الْقَرْضِ
u'طعام قَرْيَةٌ':Added, #3: 3	طَعَامِ الْقَرْضِ
u'طَعَامٌ قَرْيَةٌ':Added, #3: 3	طَعَامِ قَرْيَةٍ
u'طعام كَفَّارٌ':Added, #3: 3	طَعَامِ قَرْيَةٍ
u'طَعَامٌ كَفَّارٌ':Added, #1: 1	طَعَامَ الْكَفَّارَةِ
u'طعام كَفَّارٌ':Added, #1: 1	طَعَامَ الْكَفَّارَةِ
u'طَعَامٌ كَفَّارٌ':Added, #6: 6	طَعَامِ الْكَفَّارَةِ
u'طعام كَفَّارَةٌ':Added, #6: 6	طَعَامِ الْكَفَّارَةِ
u'طَعَامٌ كَفَّارَةٌ':Added, #1: 1	طَعَامَ الْكَفَّارَةِ
u'طعام كَفَّارَةٌ':Added, #1: 1	طَعَامَ الْكَفَّارَةِ
u'طَعَامٌ كَفَّارَةٌ':Added, #1: 1	طَعَامُ كَفَّارَةٍ
u'طعام كَفَّارَةٌ':Added, #1: 1	طَعَامُ كَفَّارَةٍ
u'طَعَامٌ كَفَّارَةٌ':Added, #6: 6	طَعَامِ الْكَفَّارَةِ
u'طعام لبن':Added, #6: 6	طَعَامِ الْكَفَّارَةِ
u'طَعَامٌ لبن':Added, #1: 1	طَعَامَ اللَّبَنِ
u'طعام لَبَنٌ':Added, #1: 1	طَعَامَ اللَّبَنِ
u'طَعَامٌ لَبَنٌ':Added, #1: 1	طَعَامَ اللَّبَنِ
u'طعام مَأْتَمٌ':Added, #1: 1	طَعَامَ اللَّبَنِ
u'طَعَامٌ مَأْتَمٌ':Added, #1: 1	طَعَامُ الْمَأْتَمِ
u'طعام مَائِدٌ':Added, #1: 1	طَعَامُ الْمَأْتَمِ
u'طَعَامٌ مَائِدٌ':Added, #1: 1	طَعَامِ الْمَائِدَةِ
u'طعام مَائِدَةٌ':Added, #1: 1	طَعَامِ الْمَائِدَةِ
u'طَعَامٌ مَائِدَةٌ':Added, #1: 1	طَعَامِ الْمَائِدَةِ
u'طعام مَائِعٌ':Added, #1: 1	طَعَامِ الْمَائِدَةِ
u'طَعَامٌ مَائِعٌ':Added, #4: 4	طَعَامٍ مَائِعٍ
u'طعام مَبِيعٌ':Added, #4: 4	طَعَامٍ مَائِعٍ
u'طَعَامٌ مَبِيعٌ':Added, #1: 1	طَعَامَ الْمَبِيعِ
u'طعام مُتَبَارِي':Added, #1: 1	طَعَامَ الْمَبِيعِ
u'طَعَامٌ مُتَبَارِي':Added, #5: 5	طَعَامِ الْمُتَبَارِيَيْنِ
u'طعام مثل':Added, #5: 5	طَعَامِ الْمُتَبَارِيَيْنِ
u'طَعَامٌ مثل':Added, #1: 1	طَعَامُ مِثْلِ
u'طعام مِثْلٌ':Added, #1: 1	طَعَامُ مِثْلِ
u'طَعَامٌ مِثْلٌ':Added, #1: 1	طَعَامُ مِثْلِ
u'طعام مثل':Added, #1: 1	طَعَامُ مِثْلِ
u'طَعَامٌ مثل':Added, #1: 1	طَعَامِ مِثْلِهِ
u'طعام مِثْلٌ':Added, #1: 1	طَعَامِ مِثْلِهِ
u'طَعَامٌ مِثْلٌ':Added, #1: 1	طَعَامِ مِثْلِهِ
u'طعام مثل':Added, #1: 1	طَعَامِ مِثْلِهِ
u'طَعَامٌ مثل':Added, #2: 2	طَعَامُ مِثْلِهِ
u'طعام مِثْلٌ':Added, #2: 2	طَعَامُ مِثْلِهِ
u'طَعَامٌ مِثْلٌ':Added, #2: 2	طَعَامُ مِثْلِهِ
u'طعام مُحْتَاجٌ':Added, #2: 2	طَعَامُ مِثْلِهِ
u'طَعَامٌ مُحْتَاجٌ':Added, #1: 1	طَعَامٍ مُحْتَاجٍ
u'طعام مساكين':Added, #1: 1	طَعَامٍ مُحْتَاجٍ
u'طَعَامٌ مساكين':Added, #1: 1	طَعَامُ الْمَسَاكِينِ
u'طعام مِسْكِينٌ':Added, #1: 1	طَعَامُ الْمَسَاكِينِ
u'طَعَامٌ مِسْكِينٌ':Added, #2: 2	طَعَامِ الْمِسْكِينِ
u'طعام مَسْمُومٌ':Added, #2: 2	طَعَامِ الْمِسْكِينِ
u'طَعَامٌ مَسْمُومٌ':Added, #2: 2	طَعَامٍ مَسْمُومٍ
u'طعام مُشْتَرَكٌ':Added, #2: 2	طَعَامٍ مَسْمُومٍ
u'طَعَامٌ مُشْتَرَكٌ':Added, #9: 9	طَعَامٍ مُشْتَرَكٍ
u'طعام مَشْهُودٌ':Added, #9: 9	طَعَامٍ مُشْتَرَكٍ
u'طَعَامٌ مَشْهُودٌ':Added, #1: 1	طَعَامِ الْمَشْهُودِ
u'طعام مُضْطَرٌّ':Added, #1: 1	طَعَامِ الْمَشْهُودِ
u'طَعَامٌ مُضْطَرٌّ':Added, #1: 1	طَعَامَ مُضْطَرٍّ
u'طعام مَضْمُونٌ':Added, #1: 1	طَعَامَ مُضْطَرٍّ
u'طَعَامٌ مَضْمُونٌ':Added, #1: 1	طَعَامٍ مَضْمُونٍ
u'طعام مُضِيفٌ':Added, #1: 1	طَعَامٍ مَضْمُونٍ
u'طَعَامٌ مُضِيفٌ':Added, #2: 2	طَعَامِ مُضِيفِهِ
u'طعام مَعْلُومٌ':Added, #2: 2	طَعَامِ مُضِيفِهِ
u'طَعَامٌ مَعْلُومٌ':Added, #1: 1	طَعَامٍ مَعْلُومٍ
u'طعام مُعَيَّنٌ':Added, #1: 1	طَعَامٍ مَعْلُومٍ
u'طَعَامٌ مُعَيَّنٌ':Added, #1: 1	طَعَامٍ مُعَيَّنٍ
u'طعام مَغْنَمٌ':Added, #1: 1	طَعَامٍ مُعَيَّنٍ
u'طَعَامٌ مَغْنَمٌ':Added, #1: 1	طَعَامِ الْمَغْنَمِ
u'طعام مَكْرُوهٌ':Added, #1: 1	طَعَامِ الْمَغْنَمِ
u'طَعَامٌ مَكْرُوهٌ':Added, #1: 1	طَعَامٍ مَكْرُوهٍ
u'طعام مُمْتَنِعٌ':Added, #1: 1	طَعَامٍ مَكْرُوهٍ
u'طَعَامٌ مُمْتَنِعٌ':Added, #1: 1	طَعَامِ الْمُمْتَنِعِ
u'طعام مَمْلُوكٌ':Added, #1: 1	طَعَامِ الْمُمْتَنِعِ
u'طَعَامٌ مَمْلُوكٌ':Added, #2: 2	طَعَامِ الْمَمْلُوكِ
u'طعام مُؤَجَّلٌ':Added, #2: 2	طَعَامِ الْمَمْلُوكِ
u'طَعَامٌ مُؤَجَّلٌ':Added, #2: 2	طَعَامٍ مُؤَجَّلٍ
u'طعام مَوْصُوفٌ':Added, #2: 2	طَعَامٍ مُؤَجَّلٍ
u'طَعَامٌ مَوْصُوفٌ':Added, #4: 4	طَعَامٍ مَوْصُوفٍ
u'طعام نَاسٌ':Added, #4: 4	طَعَامٍ مَوْصُوفٍ
u'طَعَامٌ نَاسٌ':Added, #3: 3	طَعَامَ النَّاسِ
u'طعام نَصْرَانِيٌّ':Added, #3: 3	طَعَامَ النَّاسِ
u'طَعَامٌ نَصْرَانِيٌّ':Added, #1: 1	طَعَامُ النَّصْرَانِيِّ
u'طعام نَفْسٌ':Added, #1: 1	طَعَامُ النَّصْرَانِيِّ
u'طَعَامٌ نَفْسٌ':Added, #1: 1	طَعَامُ نَفْسِهِ
u'طعام نَفْسٌ':Added, #1: 1	طَعَامُ نَفْسِهِ
u'طَعَامٌ نَفْسٌ':Added, #2: 2	طَعَامِ نَفْسِهِ
u'طعام نَفْسٌ':Added, #2: 2	طَعَامِ نَفْسِهِ
u'طَعَامٌ نَفْسٌ':Added, #4: 4	طَعَامَ نَفْسِهِ
u'طعام نُفَسَاءُ':Added, #4: 4	طَعَامَ نَفْسِهِ
u'طَعَامٌ نُفَسَاءُ':Added, #1: 1	طَعَامُ النُّفَسَاءِ
u'طعام نكاح':Added, #1: 1	طَعَامُ النُّفَسَاءِ
u'طَعَامٌ نكاح':Added, #1: 1	طَعَامُ النِّكَاحِ
u'طعام نِكَاحٌ':Added, #1: 1	طَعَامُ النِّكَاحِ
u'طَعَامٌ نِكَاحٌ':Added, #1: 1	طَعَامُ النِّكَاحِ
u'طعام واحد':Added, #1: 1	طَعَامُ النِّكَاحِ
u'طَعَامٌ واحد':Added, #1: 1	طَعَامِ الْوَاحِدِ
u'طعام وَاحِدٌ':Added, #1: 1	طَعَامِ الْوَاحِدِ
u'طَعَامٌ وَاحِدٌ':Added, #1: 1	طَعَامِ الْوَاحِدِ
u'طعام واحد':Added, #1: 1	طَعَامِ الْوَاحِدِ
u'طَعَامٌ واحد':Added, #5: 5	طَعَامُ الْوَاحِدِ
u'طعام وَاحِدٌ':Added, #5: 5	طَعَامُ الْوَاحِدِ
u'طَعَامٌ وَاحِدٌ':Added, #5: 5	طَعَامُ الْوَاحِدِ
u'طعام واحد':Added, #5: 5	طَعَامُ الْوَاحِدِ
u'طَعَامٌ واحد':Added, #7: 7	طَعَامٍ وَاحِدٍ
u'طعام وَاحِدٌ':Added, #7: 7	طَعَامٍ وَاحِدٍ
u'طَعَامٌ وَاحِدٌ':Added, #7: 7	طَعَامٍ وَاحِدٍ
u'طعام وَاهِبٌ':Added, #7: 7	طَعَامٍ وَاحِدٍ
u'طَعَامٌ وَاهِبٌ':Added, #1: 1	طَعَامُ الْوَاهِبِ
u'طعام وِلاَدَةٌ':Added, #1: 1	طَعَامُ الْوَاهِبِ
u'طَعَامٌ وِلاَدَةٌ':Added, #2: 2	طَعَامُ الْوِلَادَةِ
u'طعام وَلاَئِمُ':Added, #2: 2	طَعَامُ الْوِلَادَةِ
u'طَعَامٌ وَلاَئِمُ':Added, #1: 1	طَعَامَ الْوَلَائِمِ
u'طعام وِلاَيَةٌ':Added, #1: 1	طَعَامَ الْوَلَائِمِ
u'طَعَامٌ وِلاَيَةٌ':Added, #1: 1	طَعَامِ وِلَايَةٍ
u'طعام وَلِيمَةٌ':Added, #1: 1	طَعَامِ وِلَايَةٍ
u'طَعَامٌ وَلِيمَةٌ':Added, #1: 1	طَعَامِ الْوَلِيمَةِ
u'طعام وَلِيمَةٌ':Added, #1: 1	طَعَامِ الْوَلِيمَةِ
u'طَعَامٌ وَلِيمَةٌ':Added, #1: 1	طَعَامَ وَلِيمَةٍ
u'طعام وَلِيمَةٌ':Added, #1: 1	طَعَامَ وَلِيمَةٍ
u'طَعَامٌ وَلِيمَةٌ':Added, #3: 3	طَعَامَ الْوَلِيمَةِ
u'طعام وَلِيمَةٌ':Added, #3: 3	طَعَامَ الْوَلِيمَةِ
u'طَعَامٌ وَلِيمَةٌ':Added, #8: 8	طَعَامُ الْوَلِيمَةِ
u'طعام يَتِيمٌ':Added, #8: 8	طَعَامُ الْوَلِيمَةِ
u'طَعَامٌ يَتِيمٌ':Added, #1: 1	طَعَامُ الْيَتِيمِ
u'طعام يَوْمٌ':Added, #1: 1	طَعَامُ الْيَتِيمِ
u'طَعَامٌ يَوْمٌ':Added, #3: 3	طَعَامُ يَوْمٍ
u'طَعْمٌ أَدْوِيَةٌ':Added, #3: 3	طَعَامُ يَوْمٍ
u'طَعْمٌ إِسْلامٌ':Added, #1: 1	طَعْمُ الْأَدْوِيَةِ
u'طَعْمٌ إيمَانٌ':Added, #1: 1	طَعْمَ الْإِسْلَامِ
u'طَعْمٌ إيمَانٌ':Added, #4: 4	طَعْمَ الْإِيمَانِ
u'طَعِمَ بَعْضٌ':Predicate, #6: 6	طَعْمَ الإِيمَانِ
u'طَعِمَ بَعْضٌ':Predicate, #1: 1	أَطْعَمَ الْبَعْضَ
u'طَعْمٌ بَوْلٌ':Added, #2: 2	أَطْعَمَ بَعْضَ
u'طعمة ظلمة':Added, #2: 2	طَعْمَ بَوْلٍ
u'طعمة كُفَّارٌ':Added, #1: 1	أَطْعِمَةِ الظَّلَمَةِ
u'طعمة مَغْنَمٌ':Added, #1: 1	أَطْعِمَةَ الْكُفَّارِ
u'طَعْمٌ تَمْر':Added, #1: 1	أَطْعِمَةِ الْمَغْنَمِ
u'طَعِمَ ثَرِيدٌ':Predicate, #1: 1	طَعْمَ التَّمْرِ
u'طَعْمٌ حَقِيقٌ':Added, #1: 1	أَطْعَمَ الثّرِيدَ
u'طَعْمٌ حَقِيقَةٌ':Added, #1: 1	طَعْمَ حَقِيقَةِ
u'طَعْمٌ حِمَّصٌ':Added, #1: 1	طَعْمَ حَقِيقَةِ
u'طَعِمَ خُبْزٌ':Predicate, #1: 1	طَعْمُ الْحِمَّصِ
u'طَعِمَ خَدِيج':Predicate, #1: 1	أَطْعَمَ خُبْزَ
u'طَعْمٌ خَمْرٌ':Added, #1: 1	أَطْعَمَ خَدِيجَةَ
u'طَعْمٌ خَمْرٌ':Added, #1: 1	طَعْمَ الْخَمْرِ
u'طَعِمَ خَمْسَةٌ':Predicate, #5: 5	طَعْمُ الْخَمْرِ
u'طَعْمٌ دُخَانٌ':Added, #7: 7	أَطْعَمَ خَمْسَةَ
u'طَعْمٌ دُهْنٌ':Added, #1: 1	طَعْمَ الدُّخَانِ
u'طَعْمٌ دُهْنٌ':Added, #1: 1	طَعْمَ الدُّهْنِ
u'طَعْمٌ رَاحَةٌ':Added, #1: 1	طَعْمَ دُهْنِ
u'طَعِمَ زَيْدٌ':Subject, #1: 1	طَعْمَ الرَّاحَةِ
u'طَعِمَ سِتٌّ':Predicate, #1: 1	طَعِمَ زَيْدٌ
u'طَعْمٌ شَيْءٌ':Added, #2: 2	أَطْعَمَ سِتَّةَ
u'طَعْمٌ ضَرْبٌ':Added, #1: 1	طَعْمِ الشَّيْءِ
u'طَعِمَ طعام':Predicate, #1: 1	طَعْمَ الضَّرْبِ
u'طَعِمَ طَعَامٌ':Predicate, #2: 2	أَطْعَمَ الطَّعَامَ
u'طَعِمَ طَعْمٌ':Predicate, #2: 2	أَطْعَمَ الطَّعَامَ
u'طَعْمٌ عِبَادَةٌ':Added, #4: 4	طَعِمَ طَعْمَ
u'طَعِمَ عَشْرٌ':Predicate, #1: 1	طَعْمَ الْعِبَادَةِ
u'طَعِمَ عَشْرٌ':Predicate, #1: 1	أَطْعَمَ عَشْرَةَ
u'طَعْمٌ عَطَاءٌ':Added, #2: 2	أَطْعَمَ عَشْرَةً
u'طَعِمَ عند':Predicate, #1: 1	طَعْمَ الْعَطَاءِ
u'طَعِمَ فقراء':Predicate, #1: 1	طَعِمَ عِنْدَ
u'طَعْمٌ فِقْهٌ':Added, #1: 1	أَطْعَمَ فُقَرَاءَ
u'طَعِمَ فلان':Predicate, #1: 1	طَعْمَ الْفِقْهِ
u'طَعْمٌ فَمٌ':Added, #1: 1	أَطْعَمَ خَدِيجَةَ
u'طَعْمٌ كحل':Added, #1: 1	طَعْمِ الْفَمِ
u'طَعْمٌ كُحْلٌ':Added, #1: 1	طَعْمَ الْكُحْلِ
u'طَعِمَ كَفَّارٌ':Predicate, #1: 1	طَعْمَ الْكُحْلِ
u'طَعِمَ كَفَّارَةٌ':Predicate, #1: 1	أَطْعَمَ كَفَّارَةَ
u'طَعْمٌ لبن':Added, #1: 1	أَطْعَمَ كَفَّارَةَ
u'طَعْمٌ لَبَنٌ':Added, #1: 1	طَعْمُ اللَّبَنِ
u'طَعْمٌ لبن':Added, #1: 1	طَعْمُ اللَّبَنِ
u'طَعْمٌ لَبَنٌ':Added, #2: 2	طَعْمَ اللَّبَنِ
u'طَعْمٌ لَحْمٌ':Added, #2: 2	طَعْمَ اللَّبَنِ
u'طَعْمٌ لَحْمٌ':Added, #1: 1	طَعْمِ اللَّحْمِ
u'طَعْمٌ لَحْمٌ':Added, #1: 1	طَعْمَ لَحْمِ
u'طَعْمٌ مَاءٌ':Added, #2: 2	طَعْمَ اللَّحْمِ
u'طَعْمٌ مَاءٌ':Added, #1: 1	طَعْمَ الْمَاءِ
u'طَعْمٌ مَاءٌ':Added, #3: 3	طَعْمُ الْمَاءِ
u'طَعِمَ مساكين':Predicate, #3: 3	طَعْمِ الْمَاءِ
u'طَعِمَ مَغْصُوب':Predicate, #1: 1	أَطْعَمَ مَسَاكِينَ
u'طَعْمٌ ملح':Added, #1: 1	أَطْعَمَ الْمَغْصُوبَ
u'طَعْمٌ مِلْحٌ':Added, #2: 2	طَعْمَ الْمِلْحِ
u'طَعْمٌ نَجَاسَةٌ':Added, #2: 2	طَعْمَ الْمِلْحِ
u'طَعْمٌ نَفْعٌ':Added, #1: 1	طَعْمُ النَّجَاسَةِ
u'طَعِمَ يَوْمٌ':Predicate, #1: 1	طَعْمَ نَفْعِهِ
u'طَعْنٌ أَصْحَابٌ':Added, #1: 1	أَطْعَمَ الْيَوْمَ
u'طَعْنٌ إِنْسٌ':Added, #1: 1	طَعْنِ أَصْحَابِ
u'طَعَنَ بِشْرٌ':Subject, #1: 1	طَعْنِ الْإِنْسِ
u'طَعَنَ بَعْضٌ':Subject, #1: 1	طَعَنَ بِشْرٌ
u'طَعَنَ بَعْضٌ':Subject, #1: 1	طَعَنَ بَعْضٌ
u'طَعْنٌ بَعْضٌ':Added, #3: 3	طَعَنَ بَعْضُ
u'طعنة شَيْطَانٌ':Added, #1: 1	طَعْنُ بَعْضِ
u'طَعْنَةٌ شَيْطَانٌ':Added, #1: 1	طَعْنَةُ الشَّيْطَانِ
u'طَعَنَ ثَلاثَةٌ':Predicate, #1: 1	طَعْنَةُ الشَّيْطَانِ
u'طَعَنَ ثَلاثَةٌ':Predicate, #1: 1	طَعَنَ ثَلَاثَةَ
u'طَعَنَ ثَوْرٌ':Subject, #2: 2	طَعَنَ ثَلاَثَةَ
u'طَعْنٌ جِنٌّ':Added, #1: 1	طَعَنَ الثّوْرُ
u'طَعْنٌ جِنٌّ':Added, #2: 2	طَعْنُ الْجِنِّ
u'طَعَنَ حَنْظَلٌ':Predicate, #4: 4	طَعْنِ الْجِنِّ
u'طَعَنَ خَصْمٌ':Subject, #1: 1	طَعَنَ حَنْظَلَةَ
u'طَعْنٌ خَصْمٌ':Added, #12: 12	طَعَنَ الْخَصْمُ
u'طَعَنَ ذِمِّيٌّ':Subject, #5: 5	طَعْنِ الْخَصْمِ
u'طَعَنَ رَجُلٌ':Predicate, #1: 1	طَعَنَ الذِّمِّيُّ
u'طَعَنَ رَجُلٌ':Subject, #2: 2	طَعَنَ رَجُلاً
u'طَعَنَ رَجُلٌ':Subject, #1: 1	طَعَنَ الرَّجُلُ
u'طَعْنٌ سَلَفٌ':Added, #1: 1	طَعَنَ رَجُلٌ
u'طَعْنٌ شُهُودٌ':Added, #1: 1	طَعْنِ السَّلَفِ
u'طَعَنَ فَرَّاءٌ':Subject, #1: 1	طَعْنَ الشُّهُودِ
u'طَعْنٌ مَالِكٌ':Added, #1: 1	طَعَنَ الْفَرَّاءُ
u'طَعَنَ مُحَقِّقٌ':Subject, #1: 1	طَعْنِ مَالِكٍ
u'طَعَنَ مُسْتَأْجِرٌ':Subject, #2: 2	طَعَنَ الْمُحَقِّقُ
u'طَعَنَ مَشْهُودٌ':Subject, #1: 1	طَعَنَ الْمُسْتَأْجِرُ
u'طَعْنٌ مَشْهُودٌ':Added, #1: 1	طَعَنَ الْمَشْهُودُ
u'طَعْنٌ مَشْهُودٌ':Added, #1: 1	طَعْنَ الْمَشْهُودِ
u'طَعَنَ مُضَارِبٌ':Subject, #1: 1	طَعْنِ الْمَشْهُودِ
u'طَعْنٌ مُؤْمِنٌ':Added, #1: 1	طَعَنَ الْمُضَارِبُ
u'طُغْيَانٌ قَلَمٌ':Added, #1: 1	طَعْنِ الْمُؤْمِنِ
u'طُغْيَانٌ مَاءٌ':Added, #4: 4	طُغْيَانِ الْقَلَمِ
u'طُغْيَانٌ يَرَاعٌ':Added, #1: 1	طُغْيَانِ الْمَاءِ
u'طَغَى مَاءٌ':Subject, #1: 1	طُغْيَانِ الْيَرَاعِ
u'طَفَا سَمَكٌ':Subject, #2: 2	طَغَى الْمَاءُ
u'طَفَا شَيْءٌ':Subject, #1: 1	طَفَا السَّمَكُ
u'طَفَا فَلًا':Predicate, #1: 1	طَفَا الشَّيْءُ
u'طَفَا قَلَمٌ':Subject, #1: 1	طَفَا فَلاَ
u'طَفَّفَ قَوْمٌ':Subject, #1: 1	طَفَا قَلَمُهُ
u'طَفِقَ بَعْضٌ':Subject, #1: 1	طَفَّفَ قَوْمٌ
u'طَفِقَ رَسُولٌ':Subject, #1: 1	طَفِقَ بَعْضُ
u'طُفُولِيَّةٌ صَبِيٌّ':Added, #1: 1	طَفِقَ رَسُولُ
u'طُفُولِيٌّ صَبِيٌّ':Added, #1: 1	طُفُولِيَّةِ الصَّبِيِّ
u'طَفِئَ حَرارَةٌ':Predicate, #1: 1	طُفُولِيَّةِ الصَّبِيِّ
u'طَفِئَ سِرَاجٌ':Predicate, #1: 1	أَطْفَأَ الْحَرَارَةَ
u'طِلاَءٌ إِبِلٌ':Added, #1: 1	أَطْفَأَ السِّرَاجَ
u'طَلاَقٌ أُمٌّ':Added, #1: 1	طِلاَءِ الإِبِلِ
u'طَلاَقٌ أمَةٌ':Added, #1: 1	طَلاَقَ أُمِّ
u'طَلاَقٌ بَتَّةٌ':Added, #5: 5	طَلاَقُ الأَمَةِ
u'طَلاَقٌ بِكْرٌ':Added, #1: 1	طَلاَقِ الْبَتَّةِ
u'طَلاَقٌ ثَلاثُ':Added, #1: 1	طَلاَقُ الْبِكْرِ
u'طَلاَقٌ ثَلاثُ':Added, #1: 1	طَلاَقِ الثَّلاَثِ
u'طَلاَقٌ جَديدٌ':Added, #2: 2	طَلاَقُ الثَّلاَثِ
u'طَلاَقٌ سَكْرَان':Added, #1: 1	طَلاَقٍ جَدِيدٍ
u'طَلاَقٌ سَكْرَان':Added, #2: 2	طَلاَقُ السَّكْرَانِ
u'طَلاَقٌ سُنَّةٌ':Added, #2: 2	طَلاَقِ السَّكْرَانِ
u'طَلاَقٌ سُنَّةٌ':Added, #1: 1	طَلاَقَ السُّنَّةِ
u'طَلاَقٌ سُنَّةٌ':Added, #1: 1	طَلاَقُ السُّنَّةِ
u'طَلاَقٌ شِرْكٌ':Added, #2: 2	طَلاَقِ السُّنَّةِ
u'طَلاَقٌ عَبْدٌ':Added, #1: 1	طَلاَقُ الشِّرْكِ
u'طَلاَقٌ عَبْدٌ':Added, #1: 1	طَلاَقُ عَبْدٍ
u'طَلاَقٌ عَبْدٌ':Added, #2: 2	طَلاَقُ الْعَبْدِ
u'طَلاَقٌ مُسْتَقْبَلٌ':Added, #2: 2	طَلاَقِ الْعَبْدِ
u'طَلاَقٌ مَعْتُوهٌ':Added, #1: 1	طَلاَقٍ مُسْتَقْبَلٍ
u'طَلاَقٌ مَعْتُوهٌ':Added, #1: 1	طَلاَقُ الْمَعْتُوهِ
u'طَلاَقٌ مُكْرَهٌ':Added, #2: 2	طَلاَقَ الْمَعْتُوهِ
u'طَلَبَ أَبٌ':Subject, #1: 1	طَلاَقِ الْمُكْرَهِ
u'طلب أَبٌ':Added, #2: 2	طَلَبَ الْأَبُ
u'طَلَبٌ أَبٌ':Added, #1: 1	طَلَبِ الْأَبِ
u'طلب إبَاحَةٌ':Added, #1: 1	طَلَبِ الْأَبِ
u'طلب إبَاحَةٌ':Added, #1: 1	طَلَبَ إبَاحَةِ
u'طَلَبٌ إبَاحَةٌ':Added, #1: 1	طَلَبِ إبَاحَةِ
u'طَلَبٌ إبَاحَةٌ':Added, #1: 1	طَلَبَ إبَاحَةِ
u'طلب اِبْتِيَاعٌ':Added, #1: 1	طَلَبِ إبَاحَةِ
u'طَلَبٌ اِبْتِيَاعٌ':Added, #1: 1	طَلَبَ ابْتِيَاعِ
u'طلب إِبِلٌ':Added, #1: 1	طَلَبَ ابْتِيَاعِ
u'طَلَبٌ إِبِلٌ':Added, #1: 1	طَلَبِ إِبِلٍ
u'طلب إِبِلٌ':Added, #1: 1	طَلَبِ إِبِلٍ
u'طَلَبٌ إِبِلٌ':Added, #1: 1	طَلَبِ إِبِلِهِ
u'طلب اِبْنٌ':Added, #1: 1	طَلَبِ إِبِلِهِ
u'طَلَبٌ اِبْنٌ':Added, #1: 1	طَلَبِ ابْنِ
u'طلب اِتِّصَالٌ':Added, #1: 1	طَلَبِ ابْنِ
u'طَلَبٌ اِتِّصَالٌ':Added, #1: 1	طَلَبِ اتِّصَالِهِ
u'طلب إِثْبَاتٌ':Added, #1: 1	طَلَبِ اتِّصَالِهِ
u'طَلَبٌ إِثْبَاتٌ':Added, #1: 1	طَلَبُ إثْبَاتِهِ
u'طلب إِجَابَةٌ':Added, #1: 1	طَلَبُ إثْبَاتِهِ
u'طَلَبٌ إِجَابَةٌ':Added, #1: 1	طَلَبِ الإِجَابَةِ
u'طَلَبَ أَجْرٌ':Predicate, #1: 1	طَلَبِ الإِجَابَةِ
u'طلب أَجْرٌ':Added, #2: 2	طَلَبَ الْأَجْرَ
u'طَلَبٌ أَجْرٌ':Added, #2: 2	طَلَبِ الْأَجْرِ
u'طلب أَجْرٌ':Added, #2: 2	طَلَبِ الْأَجْرِ
u'طَلَبٌ أَجْرٌ':Added, #4: 4	طَلَبُ الْأَجْرِ
u'طَلَبَ أُجْرَةٌ':Predicate, #4: 4	طَلَبُ الْأَجْرِ
u'طلب أُجْرَةٌ':Added, #1: 1	طَلَبَ الْأُجْرَةَ
u'طَلَبٌ أُجْرَةٌ':Added, #1: 1	طَلَبُ أُجْرَةٍ
u'طلب أُجْرَةٌ':Added, #1: 1	طَلَبُ أُجْرَةٍ
u'طَلَبٌ أُجْرَةٌ':Added, #1: 1	طَلَبَ الْأُجْرَةِ
u'طلب أُجْرَةٌ':Added, #1: 1	طَلَبَ الْأُجْرَةِ
u'طَلَبٌ أُجْرَةٌ':Added, #2: 2	طَلَبِ الْأُجْرَةِ
u'طلب أُجْرَةٌ':Added, #2: 2	طَلَبِ الْأُجْرَةِ
u'طَلَبٌ أُجْرَةٌ':Added, #8: 8	طَلَبُ الْأُجْرَةِ
u'طلب أَجَلٌ':Added, #8: 8	طَلَبُ الْأُجْرَةِ
u'طَلَبٌ أَجَلٌ':Added, #1: 1	طَلَبَ الْأَجَلِ
u'طَلَبَ أَجِيرٌ':Subject, #1: 1	طَلَبَ الْأَجَلِ
u'طلب أَحادِيثُ':Added, #2: 2	طَلَبَ الْأَجِيرُ
u'طَلَبٌ أَحادِيثُ':Added, #2: 2	طَلَبُ الْأَحَادِيثِ
u'طَلَبَ أحَدٌ':Subject, #2: 2	طَلَبُ الْأَحَادِيثِ
u'طلب أحَدٌ':Added, #11: 11	طَلَبَ أَحَدُ
u'طَلَبٌ أحَدٌ':Added, #1: 1	طَلَبُ أَحَدِ
u'طلب أحَدٌ':Added, #1: 1	طَلَبُ أَحَدِ
u'طَلَبٌ أحَدٌ':Added, #2: 2	طَلَبِ أَحَدٍ
u'طلب أحَدٌ':Added, #2: 2	طَلَبِ أَحَدٍ
u'طَلَبٌ أحَدٌ':Added, #6: 6	طَلَبِ أَحَدِ
u'طَلَبَ إحْضَارٌ':Predicate, #6: 6	طَلَبِ أَحَدِ
u'طلب إحْضَارٌ':Added, #1: 1	طَلَبَ إحْضَارَ
u'طَلَبٌ إحْضَارٌ':Added, #1: 1	طَلَبِ إحْضَارِ
u'طلب إحْضَارٌ':Added, #1: 1	طَلَبِ إحْضَارِ
u'طَلَبٌ إحْضَارٌ':Added, #1: 1	طَلَبُ الْإِحْضَارِ
u'طلب إحْضَارٌ':Added, #1: 1	طَلَبُ الْإِحْضَارِ
u'طَلَبٌ إحْضَارٌ':Added, #2: 2	طَلَبِ إحْضَارِهِ
u'طلب أَحَقُّ':Added, #2: 2	طَلَبِ إحْضَارِهِ
u'طَلَبٌ أَحَقُّ':Added, #1: 1	طَلَبُ الْأَحَقِّ
u'طلب أَحْكَامٌ':Added, #1: 1	طَلَبُ الْأَحَقِّ
u'طَلَبٌ أَحْكَامٌ':Added, #1: 1	طَلَبُ أَحْكَامِ
u'طَلَبَ أخْذٌ':Predicate, #1: 1	طَلَبُ أَحْكَامِ
u'طلب أخْذٌ':Added, #1: 1	طَلَبَ أَخْذَ
u'طَلَبٌ أخْذٌ':Added, #4: 4	طَلَبُ الْأَخْذِ
u'طلب آخِرُ':Added, #4: 4	طَلَبُ الْأَخْذِ
u'طَلَبٌ آخِرُ':Added, #1: 1	طَلَبِ الْآخِرِ
u'طلب إِخْوَانٌ':Added, #1: 1	طَلَبِ الْآخِرِ
u'طَلَبٌ إِخْوَانٌ':Added, #1: 1	طَلَبِ الْإِخْوَانِ
u'طَلَبَ أَدَاءٌ':Predicate, #1: 1	طَلَبِ الْإِخْوَانِ
u'طلب أَدَاءٌ':Added, #1: 1	طَلَبَ الْأَدَاءَ
u'طَلَبٌ أَدَاءٌ':Added, #1: 1	طَلَبُ أَدَاءِ
u'طلب إدْخَالٌ':Added, #1: 1	طَلَبُ أَدَاءِ
u'طَلَبٌ إدْخَالٌ':Added, #1: 1	طَلَبُ إدْخَالِ
u'طلب أَذَانٌ':Added, #1: 1	طَلَبُ إدْخَالِ
u'طَلَبٌ أَذَانٌ':Added, #1: 1	طَلَبِ الْأَذَانِ
u'طلب إِذْنٌ':Added, #1: 1	طَلَبِ الْأَذَانِ
u'طَلَبٌ إِذْنٌ':Added, #2: 2	طَلَبُ الْإِذْنِ
u'طلب أرْبَابٌ':Added, #2: 2	طَلَبُ الْإِذْنِ
u'طَلَبٌ أرْبَابٌ':Added, #1: 1	طَلَبِ أَرْبَابِهِ
u'طلب أَرْدَأَ':Added, #1: 1	طَلَبِ أَرْبَابِهِ
u'طَلَبٌ أَرْدَأَ':Added, #2: 2	طَلَبَ الْأَرْدَأِ
u'طَلَبَ أَرْمَد':Subject, #2: 2	طَلَبَ الْأَرْدَأِ
u'طَلَبَ أَزْيَدُ':Predicate, #1: 1	طَلَبَ أَرْمَدُ
u'طلب اِسْتِدَامَةٌ':Added, #1: 1	طَلَبَ أَزْيَدَ
u'طَلَبٌ اِسْتِدَامَةٌ':Added, #1: 1	طَلَبُ اسْتِدَامَةِ
u'طَلَبَ اِسْتِسْقَاءٌ':Predicate, #1: 1	طَلَبُ اسْتِدَامَةِ
u'طلب إِسْراعٌ':Added, #1: 1	طَلَبَ الاِسْتِسْقَاءَ
u'طَلَبٌ إِسْراعٌ':Added, #1: 1	طَلَبِ الْإِسْرَاعِ
u'طلب إِسْقاطٌ':Added, #1: 1	طَلَبِ الْإِسْرَاعِ
u'طَلَبٌ إِسْقاطٌ':Added, #1: 1	طَلَبُ إسْقَاطِ
u'طلب إِسْكانٌ':Added, #1: 1	طَلَبُ إسْقَاطِ
u'طَلَبٌ إِسْكانٌ':Added, #1: 1	طَلَبَ الْإِسْكَانِ
u'طلب إِسْنادٌ':Added, #1: 1	طَلَبَ الْإِسْكَانِ
u'طَلَبٌ إِسْنادٌ':Added, #2: 2	طَلَبِ الْإِسْنَادِ
u'طلب إِعانَةٌ':Added, #2: 2	طَلَبِ الْإِسْنَادِ
u'طَلَبٌ إِعانَةٌ':Added, #1: 1	طَلَبُ الْإِعَانَةِ
u'طلب إِعْتاقٌ':Added, #1: 1	طَلَبُ الْإِعَانَةِ
u'طَلَبٌ إِعْتاقٌ':Added, #1: 1	طَلَبِ الْإِعْتَاقِ
u'طلب أَعْدَاءٌ':Added, #1: 1	طَلَبِ الْإِعْتَاقِ
u'طَلَبٌ أَعْدَاءٌ':Added, #1: 1	طَلَبَ أَعْدَاءِ
u'طلب أَعْضَاءٌ':Added, #1: 1	طَلَبَ أَعْدَاءِ
u'طَلَبٌ أَعْضَاءٌ':Added, #1: 1	طَلَبُ الْأَعْضَاءِ
u'طلب إعْطَاءٌ':Added, #1: 1	طَلَبُ الْأَعْضَاءِ
u'طَلَبٌ إعْطَاءٌ':Added, #1: 1	طَلَبُ إعْطَاءِ
u'طلب أَعْلاَجٌ':Added, #1: 1	طَلَبُ إعْطَاءِ
u'طَلَبٌ أَعْلاَجٌ':Added, #1: 1	طَلَبِ أَعْلاَجٍ
u'طلب أَعْلاَجٌ':Added, #1: 1	طَلَبِ أَعْلاَجٍ
u'طَلَبٌ أَعْلاَجٌ':Added, #2: 2	طَلَبِ أَعْلاجٍ
u'طلب أعْلَمُ':Added, #2: 2	طَلَبِ أَعْلاجٍ
u'طلب أعْلَمُ':Added, #1: 1	طَلَبُ الْأَعْلَمِ
u'طَلَبٌ أعْلَمُ':Added, #1: 1	طَلَبِ الْأَعْلَمِ
u'طَلَبٌ أعْلَمُ':Added, #1: 1	طَلَبُ الْأَعْلَمِ
u'طلب أَفْضَالٌ':Added, #1: 1	طَلَبِ الْأَعْلَمِ
u'طَلَبٌ أَفْضَالٌ':Added, #1: 1	طَلَبُ أَفْضَالٍ
u'طلب أفْضَلُ':Added, #1: 1	طَلَبُ أَفْضَالٍ
u'طَلَبٌ أفْضَلُ':Added, #1: 1	طَلَبَ الْأَفْضَلِ
u'طلب إقالَةٌ':Added, #1: 1	طَلَبَ الْأَفْضَلِ
u'طَلَبٌ إقالَةٌ':Added, #1: 1	طَلَبِ الْإِقَالَةِ
u'طلب إقامَةٌ':Added, #1: 1	طَلَبِ الْإِقَالَةِ
u'طَلَبٌ إقامَةٌ':Added, #1: 1	طَلَبِ إقَامَةِ
u'طلب إقْرَارٌ':Added, #1: 1	طَلَبِ إقَامَةِ
u'طَلَبٌ إقْرَارٌ':Added, #1: 1	طَلَبُ إقْرَارِهِ
u'طلب أقَلُّ':Added, #1: 1	طَلَبُ إقْرَارِهِ
u'طَلَبٌ أقَلُّ':Added, #1: 1	طَلَبُ أَقَلِّ
u'طَلَبَ أَكْثَرُ':Predicate, #1: 1	طَلَبُ أَقَلِّ
u'طلب أكل':Added, #2: 2	طَلَبَ أَكْثَرَ
u'طلب أَكْلٌ':Added, #1: 1	طَلَبِ الْأَكْلِ
u'طَلَبٌ أكل':Added, #1: 1	طَلَبِ الْأَكْلِ
u'طَلَبٌ أَكْلٌ':Added, #1: 1	طَلَبِ الْأَكْلِ
u'طَلَبَ آلةٌ':Predicate, #1: 1	طَلَبِ الْأَكْلِ
u'طلب ألْفٌ':Added, #1: 1	طَلَبَ آلَةَ
u'طلب أَلْفٌ':Added, #1: 1	طَلَبِ أَلْفٍ
u'طَلَبٌ ألْفٌ':Added, #1: 1	طَلَبِ أَلْفٍ
u'طَلَبٌ أَلْفٌ':Added, #1: 1	طَلَبِ أَلْفٍ
u'طَلَبَ الْمَرْأَةُ':Predicate, #1: 1	طَلَبِ أَلْفٍ
u'طلب الْمَرْأَةُ':Added, #1: 1	طَلَبَ الْمَرْأَةَ
u'طلب الْمَرْأَةُ':Added, #3: 3	طَلَبُ الْمَرْأَةِ
u'طَلَبٌ الْمَرْأَةُ':Added, #3: 3	طَلَبِ الْمَرْأَةِ
u'طَلَبٌ الْمَرْأَةُ':Added, #3: 3	طَلَبُ الْمَرْأَةِ
u'طلب إمَارَةٌ':Added, #3: 3	طَلَبِ الْمَرْأَةِ
u'طَلَبٌ إمَارَةٌ':Added, #1: 1	طَلَبِ الإِمَارَةِ
u'طَلَبَ إمَامٌ':Subject, #1: 1	طَلَبِ الإِمَارَةِ
u'طلب إمَامٌ':Added, #1: 1	طَلَبَ الْإِمَامُ
u'طَلَبٌ إمَامٌ':Added, #1: 1	طَلَبِ الْإِمَامِ
u'طلب إمَامَةٌ':Added, #1: 1	طَلَبِ الْإِمَامِ
u'طَلَبٌ إمَامَةٌ':Added, #1: 1	طَلَبُ الْإِمَامَةِ
u'طَلَبَ أمَانٌ':Predicate, #1: 1	طَلَبُ الْإِمَامَةِ
u'طلب أمَانٌ':Added, #2: 2	طَلَبَ الْأَمَانَ
u'طلب أمَانٌ':Added, #1: 1	طَلَبَ الْأَمَانِ
u'طَلَبٌ أمَانٌ':Added, #1: 1	طَلَبِ الْأَمَانِ
u'طَلَبٌ أمَانٌ':Added, #1: 1	طَلَبَ الْأَمَانِ
u'طَلَبَ آمِرٌ':Subject, #1: 1	طَلَبِ الْأَمَانِ
u'طَلَبَ إِمْهالٌ':Predicate, #1: 1	طَلَبَ الْآمِرُ
u'طَلَبَ إِنْسانٌ':Subject, #2: 2	طَلَبَ الْإِمْهَالَ
u'طَلَبَ إِنْسانٌ':Subject, #1: 1	طَلَبَ الْإِنْسَانُ
u'طلب إِنْصافٌ':Added, #1: 1	طَلَبَ إنْسَانُ
u'طَلَبٌ إِنْصافٌ':Added, #2: 2	طَلَبُ الْإِنْصَافِ
u'طَلَبَ اِنْعِقَادٌ':Predicate, #2: 2	طَلَبُ الْإِنْصَافِ
u'طلب إِنْفاقٌ':Added, #1: 1	طَلَبَ انْعِقَادَ
u'طَلَبٌ إِنْفاقٌ':Added, #1: 1	طَلَبِ الْإِنْفَاقِ
u'طلب أَنْوَاعٌ':Added, #1: 1	طَلَبِ الْإِنْفَاقِ
u'طَلَبٌ أَنْوَاعٌ':Added, #1: 1	طَلَبِ الْأَنْوَاعِ
u'طَلَبَ أهْلٌ':Subject, #1: 1	طَلَبِ الْأَنْوَاعِ
u'طلب أهْلٌ':Added, #1: 1	طَلَبَ أَهْلُ
u'طَلَبٌ أهْلٌ':Added, #1: 1	طَلَبَ أَهْلِ
u'طلب أَوْتَارٌ':Added, #1: 1	طَلَبَ أَهْلِ
u'طَلَبٌ أَوْتَارٌ':Added, #1: 1	طَلَبَ أَوْتَارِ
u'طَلَبَ أَوَّلُ':Predicate, #1: 1	طَلَبَ أَوْتَارِ
u'طَلَبَ أَوَّلُ':Subject, #1: 1	طَلَبَ الْأَوَّلَ
u'طلب أَوْلِيَاءُ':Added, #1: 1	طَلَبَ الْأَوَّلُ
u'طلب أَوْلِيَاءُ':Added, #1: 1	طَلَبَ الْأَوْلِيَاءِ
u'طَلَبٌ أَوْلِيَاءُ':Added, #1: 1	طَلَبُ الْأَوْلِيَاءِ
u'طَلَبٌ أَوْلِيَاءُ':Added, #1: 1	طَلَبَ الْأَوْلِيَاءِ
u'طلب إِيثَارٌ':Added, #1: 1	طَلَبُ الْأَوْلِيَاءِ
u'طَلَبٌ إِيثَارٌ':Added, #1: 1	طَلَبِ الْإِيثَارِ
u'طلب أَيْسَرُ':Added, #1: 1	طَلَبِ الْإِيثَارِ
u'طَلَبٌ أَيْسَرُ':Added, #1: 1	طَلَبُ الْأَيْسَرِ
u'طلب إيقَاعٌ':Added, #1: 1	طَلَبُ الْأَيْسَرِ
u'طَلَبٌ إيقَاعٌ':Added, #1: 1	طَلَبُ إيقَاعِ
u'طلب إيقَاعٌ':Added, #1: 1	طَلَبُ إيقَاعِ
u'طَلَبٌ إيقَاعٌ':Added, #1: 1	طَلَبُ إيقَاعِهِ
u'طَلَبَ أَيْمَانٌ':Predicate, #1: 1	طَلَبُ إيقَاعِهِ
u'طلب إيمَانٌ':Added, #1: 1	طَلَبَ أَيْمَانَ
u'طَلَبٌ إيمَانٌ':Added, #1: 1	طَلَبَ الْإِيمَانِ
u'طَلَبَ بَائِعٌ':Subject, #1: 1	طَلَبَ الْإِيمَانِ
u'طَلَبَ بَائِعٌ':Subject, #1: 1	طَلَبَ بَائِعُ
u'طلب بَائِعٌ':Added, #8: 8	طَلَبَ الْبَائِعُ
u'طلب بَائِعٌ':Added, #1: 1	طَلَبُ الْبَائِعِ
u'طَلَبٌ بَائِعٌ':Added, #1: 1	طَلَبِ الْبَائِعِ
u'طَلَبٌ بَائِعٌ':Added, #1: 1	طَلَبُ الْبَائِعِ
u'طَلَبَ بُخارٌ':Subject, #1: 1	طَلَبِ الْبَائِعِ
u'طلب بَدَلٌ':Added, #1: 1	طَلَبَ الْبُخَارُ
u'طَلَبٌ بَدَلٌ':Added, #1: 1	طَلَبُ الْبَدَلِ
u'طلب بَدَلٌ':Added, #1: 1	طَلَبُ الْبَدَلِ
u'طَلَبٌ بَدَلٌ':Added, #1: 1	طَلَبَ بَدَلٍ
u'طلب بَدَلٌ':Added, #1: 1	طَلَبَ بَدَلٍ
u'طَلَبٌ بَدَلٌ':Added, #1: 1	طَلَبُ بَدَلِهِ
u'طَلَبَ بِرٌّ':Predicate, #1: 1	طَلَبُ بَدَلِهِ
u'طلب بُرْء':Added, #1: 1	طَلَبَ الْبِرَّ
u'طَلَبٌ بُرْء':Added, #1: 1	طَلَبِ الْبُرْءِ
u'طلب بَراءةٌ':Added, #1: 1	طَلَبِ الْبُرْءِ
u'طَلَبٌ بَراءةٌ':Added, #1: 1	طَلَبُ الْبَرَاءَةِ
u'طلب بَراءةٌ':Added, #1: 1	طَلَبُ الْبَرَاءَةِ
u'طَلَبٌ بَراءةٌ':Added, #3: 3	طَلَبُ بَرَاءَةِ
u'طلب بُرْهانٌ':Added, #3: 3	طَلَبُ بَرَاءَةِ
u'طلب بُرْهَانٌ':Added, #1: 1	طَلَبُ الْبُرْهَانِ
u'طَلَبٌ بُرْهانٌ':Added, #1: 1	طَلَبُ الْبُرْهَانِ
u'طَلَبٌ بُرْهَانٌ':Added, #1: 1	طَلَبُ الْبُرْهَانِ
u'طلب بُرْهانٌ':Added, #1: 1	طَلَبُ الْبُرْهَانِ
u'طلب بُرْهَانٌ':Added, #2: 2	طَلَبِ الْبُرْهَانِ
u'طَلَبٌ بُرْهانٌ':Added, #2: 2	طَلَبِ الْبُرْهَانِ
u'طَلَبٌ بُرْهَانٌ':Added, #2: 2	طَلَبِ الْبُرْهَانِ
u'طَلَبَ بَعْضٌ':Subject, #2: 2	طَلَبِ الْبُرْهَانِ
u'طلب بَعْضٌ':Added, #10: 10	طَلَبَ بَعْضُ
u'طَلَبٌ بَعْضٌ':Added, #1: 1	طَلَبِ الْبَعْضِ
u'طلب بَعْضٌ':Added, #1: 1	طَلَبِ الْبَعْضِ
u'طَلَبٌ بَعْضٌ':Added, #6: 6	طَلَبِ بَعْضِ
u'طلب بَعيرٌ':Added, #6: 6	طَلَبِ بَعْضِ
u'طَلَبٌ بَعيرٌ':Added, #1: 1	طَلَبِ بَعِيرٍ
u'طلب بَعيرٌ':Added, #1: 1	طَلَبِ بَعِيرٍ
u'طَلَبٌ بَعيرٌ':Added, #1: 1	طَلَبِ بَعِيرِهِ
u'طلب بَقاءٌ':Added, #1: 1	طَلَبِ بَعِيرِهِ
u'طَلَبٌ بَقاءٌ':Added, #1: 1	طَلَبُ بَقَاءِ
u'طلب بُكاءٌ':Added, #1: 1	طَلَبُ بَقَاءِ
u'طَلَبٌ بُكاءٌ':Added, #1: 1	طَلَبُ الْبُكَاءِ
u'طلب بُوقٌ':Added, #1: 1	طَلَبُ الْبُكَاءِ
u'طَلَبٌ بُوقٌ':Added, #1: 1	طَلَبَ الْبُوقِ
u'طَلَبَ بَيَانٌ':Predicate, #1: 1	طَلَبَ الْبُوقِ
u'طلب بَيَانٌ':Added, #1: 1	طَلَبَ الْبَيَانَ
u'طَلَبٌ بَيَانٌ':Added, #1: 1	طَلَبُ الْبَيَانِ
u'طلب بَيَانٌ':Added, #1: 1	طَلَبُ الْبَيَانِ
u'طَلَبٌ بَيَانٌ':Added, #2: 2	طَلَبُ بَيَانِ
u'طَلَبَ بَيْعٌ':Predicate, #2: 2	طَلَبُ بَيَانِ
u'طَلَبَ بَيْعٌ':Predicate, #1: 1	طَلَبَ بَيْعَ
u'طلب بَيْعٌ':Added, #5: 5	طَلَبَ الْبَيْعَ
u'طَلَبٌ بَيْعٌ':Added, #1: 1	طَلَبُ بَيْعِهِ
u'طلب بَيِّنَةٌ':Added, #1: 1	طَلَبُ بَيْعِهِ
u'طَلَبٌ بَيِّنَةٌ':Added, #2: 2	طَلَبِ الْبَيِّنَةِ
u'طَلَبَ تَأْجِيلٌ':Predicate, #2: 2	طَلَبِ الْبَيِّنَةِ
u'طلب تَأَخُّرٌ':Added, #1: 1	طَلَبَ التَّأْجِيلَ
u'طَلَبٌ تَأَخُّرٌ':Added, #1: 1	طَلَبِ التَّأَخُّرِ
u'طَلَبَ تَأْخِيرٌ':Predicate, #1: 1	طَلَبِ التَّأَخُّرِ
u'طلب تَأْخِيرٌ':Added, #2: 2	طَلَبَ التَّأْخِيرَ
u'طَلَبٌ تَأْخِيرٌ':Added, #1: 1	طَلَبِ تَأْخِيرِ
u'طلب تَجْدِيدٌ':Added, #1: 1	طَلَبِ تَأْخِيرِ
u'طَلَبٌ تَجْدِيدٌ':Added, #1: 1	طَلَبَ تَجْدِيدِ
u'طلب تَحْصِيلٌ':Added, #1: 1	طَلَبَ تَجْدِيدِ
u'طَلَبٌ تَحْصِيلٌ':Added, #1: 1	طَلَبُ تَحْصِيلِ
u'طَلَبَ تَحْظِير':Predicate, #1: 1	طَلَبُ تَحْصِيلِ
u'طَلَبَ تَحْلِيف':Predicate, #1: 1	طَلَبَ التَّحْظِيرَ
u'طلب تَحْلِيف':Added, #2: 2	طَلَبَ تَحْلِيفَ
u'طَلَبٌ تَحْلِيف':Added, #2: 2	طَلَبُ التَّحْلِيفِ
u'طلب تَخْصِيصٌ':Added, #2: 2	طَلَبُ التَّحْلِيفِ
u'طَلَبٌ تَخْصِيصٌ':Added, #1: 1	طَلَبِ التَّخْصِيصِ
u'طَلَبَ تَرْجِيحٌ':Predicate, #1: 1	طَلَبِ التَّخْصِيصِ
u'طلب تَرْجِيحٌ':Added, #1: 1	طَلَبَ التَّرْجِيحَ
u'طلب تَرْجِيحٌ':Added, #1: 1	طَلَبَ التَّرْجِيحِ
u'طلب تَرْجِيحٌ':Added, #1: 1	طَلَبُ التَّرْجِيحِ
u'طَلَبٌ تَرْجِيحٌ':Added, #1: 1	طَلَبِ التَّرْجِيحِ
u'طَلَبٌ تَرْجِيحٌ':Added, #1: 1	طَلَبَ التَّرْجِيحِ
u'طَلَبٌ تَرْجِيحٌ':Added, #1: 1	طَلَبُ التَّرْجِيحِ
u'طلب تَرْكٌ':Added, #1: 1	طَلَبِ التَّرْجِيحِ
u'طَلَبٌ تَرْكٌ':Added, #1: 1	طَلَبِ التَّرْكِ
u'طلب تَرْكٌ':Added, #1: 1	طَلَبِ التَّرْكِ
u'طَلَبٌ تَرْكٌ':Added, #1: 1	طَلَبَ تَرْكِ
u'طلب تَرْكٌ':Added, #1: 1	طَلَبَ تَرْكِ
u'طلب تَرْكٌ':Added, #1: 1	طَلَبَ تَرْكِهِ
u'طَلَبٌ تَرْكٌ':Added, #1: 1	طَلَبِ تَرْكِهِ
u'طَلَبٌ تَرْكٌ':Added, #1: 1	طَلَبَ تَرْكِهِ
u'طلب تَرْكٌ':Added, #1: 1	طَلَبِ تَرْكِهِ
u'طَلَبٌ تَرْكٌ':Added, #3: 3	طَلَبُ التَّرْكِ
u'طلب تَرْكٌ':Added, #3: 3	طَلَبُ التَّرْكِ
u'طَلَبٌ تَرْكٌ':Added, #3: 3	طَلَبُ تَرْكِ
u'طلب تَرْكٌ':Added, #3: 3	طَلَبُ تَرْكِ
u'طَلَبٌ تَرْكٌ':Added, #4: 4	طَلَبِ تَرْكِ
u'طلب تَزَوُّجٌ':Added, #4: 4	طَلَبِ تَرْكِ
u'طَلَبٌ تَزَوُّجٌ':Added, #1: 1	طَلَبَ التَّزَوُّجِ
u'طَلَبَ تَزْوِيجٌ':Predicate, #1: 1	طَلَبَ التَّزَوُّجِ
u'طَلَبَ تَسْلِيمٌ':Predicate, #1: 1	طَلَبَ التَّزْوِيجَ
u'طلب تَسْلِيمٌ':Added, #3: 3	طَلَبَ التَّسْلِيمَ
u'طَلَبٌ تَسْلِيمٌ':Added, #1: 1	طَلَبِ التَّسْلِيمِ
u'طلب تَسْلِيمٌ':Added, #1: 1	طَلَبِ التَّسْلِيمِ
u'طَلَبٌ تَسْلِيمٌ':Added, #1: 1	طَلَبَ تَسْلِيمِ
u'طلب تَسْلِيمٌ':Added, #1: 1	طَلَبَ تَسْلِيمِ
u'طَلَبٌ تَسْلِيمٌ':Added, #2: 2	طَلَبُ تَسْلِيمِ
u'طلب تَسْمِيَة':Added, #2: 2	طَلَبُ تَسْلِيمِ
u'طَلَبٌ تَسْمِيَة':Added, #1: 1	طَلَبُ التَّسْمِيَةِ
u'طلب تَسْمِيَة':Added, #1: 1	طَلَبُ التَّسْمِيَةِ
u'طلب تَسْمِيَة':Added, #1: 1	طَلَبَ تَسْمِيَةِ
u'طَلَبٌ تَسْمِيَة':Added, #1: 1	طَلَبُ تَسْمِيَةِ
u'طَلَبٌ تَسْمِيَة':Added, #1: 1	طَلَبَ تَسْمِيَةِ
u'طلب تَشَبُّه':Added, #1: 1	طَلَبُ تَسْمِيَةِ
u'طَلَبٌ تَشَبُّه':Added, #1: 1	طَلَبُ التَّشَبُّهِ
u'طلب تَصَرُّفٌ':Added, #1: 1	طَلَبُ التَّشَبُّهِ
u'طَلَبٌ تَصَرُّفٌ':Added, #1: 1	طَلَبِ التَّصَرُّفِ
u'طلب تَعْجِيل':Added, #1: 1	طَلَبِ التَّصَرُّفِ
u'طَلَبٌ تَعْجِيل':Added, #1: 1	طَلَبُ تَعْجِيلِ
u'طلب تَعْدِيلٌ':Added, #1: 1	طَلَبُ تَعْجِيلِ
u'طَلَبٌ تَعْدِيلٌ':Added, #1: 1	طَلَبُ التَّعْدِيلِ
u'طلب تَعْدِيلٌ':Added, #1: 1	طَلَبُ التَّعْدِيلِ
u'طلب تَعْدِيلٌ':Added, #1: 1	طَلَبَ تَعْدِيلِهِ
u'طلب تَعْدِيلٌ':Added, #1: 1	طَلَبُ تَعْدِيلِهِ
u'طَلَبٌ تَعْدِيلٌ':Added, #1: 1	طَلَبِ تَعْدِيلِهِ
u'طَلَبٌ تَعْدِيلٌ':Added, #1: 1	طَلَبَ تَعْدِيلِهِ
u'طَلَبٌ تَعْدِيلٌ':Added, #1: 1	طَلَبُ تَعْدِيلِهِ
u'طلب تَغْسِيلٌ':Added, #1: 1	طَلَبِ تَعْدِيلِهِ
u'طَلَبٌ تَغْسِيلٌ':Added, #1: 1	طَلَبِ تَغْسِيلِهِ
u'طلب تَغْيِيرٌ':Added, #1: 1	طَلَبِ تَغْسِيلِهِ
u'طَلَبٌ تَغْيِيرٌ':Added, #1: 1	طَلَبِ تَغْيِيرِ
u'طلب تَفْرِيغٌ':Added, #1: 1	طَلَبِ تَغْيِيرِ
u'طَلَبٌ تَفْرِيغٌ':Added, #1: 1	طَلَبُ التَّفْرِيغِ
u'طلب تَفْرِيقٌ':Added, #1: 1	طَلَبُ التَّفْرِيغِ
u'طلب تَفْرِيقٌ':Added, #1: 1	طَلَبَ التَّفْرِيقِ
u'طلب تَفْرِيقٌ':Added, #1: 1	طَلَبُ التَّفْرِيقِ
u'طَلَبٌ تَفْرِيقٌ':Added, #1: 1	طَلَبِ التَّفْرِيقِ
u'طَلَبٌ تَفْرِيقٌ':Added, #1: 1	طَلَبَ التَّفْرِيقِ
u'طَلَبٌ تَفْرِيقٌ':Added, #1: 1	طَلَبُ التَّفْرِيقِ
u'طلب تَقْديرٌ':Added, #1: 1	طَلَبِ التَّفْرِيقِ
u'طَلَبٌ تَقْديرٌ':Added, #1: 1	طَلَبِ التَّقْدِيرِ
u'طلب تَقْديرٌ':Added, #1: 1	طَلَبِ التَّقْدِيرِ
u'طَلَبٌ تَقْديرٌ':Added, #2: 2	طَلَبُ التَّقْدِيرِ
u'طَلَبَ تَقْريرٌ':Predicate, #2: 2	طَلَبُ التَّقْدِيرِ
u'طلب تَقْريرٌ':Added, #1: 1	طَلَبَ التَّقْرِيرَ
u'طَلَبٌ تَقْريرٌ':Added, #2: 2	طَلَبَ التَّقْرِيرِ
u'طلب تَقْريرٌ':Added, #2: 2	طَلَبَ التَّقْرِيرِ
u'طَلَبٌ تَقْريرٌ':Added, #3: 3	طَلَبِ التَّقْرِيرِ
u'طلب تَقْريرٌ':Added, #3: 3	طَلَبِ التَّقْرِيرِ
u'طَلَبٌ تَقْريرٌ':Added, #5: 5	طَلَبُ التَّقْرِيرِ
u'طلب تَكْبيرٌ':Added, #5: 5	طَلَبُ التَّقْرِيرِ
u'طَلَبٌ تَكْبيرٌ':Added, #2: 2	طَلَبُ التَّكْبِيرِ
u'طلب تَكْرارٌ':Added, #2: 2	طَلَبُ التَّكْبِيرِ
u'طَلَبٌ تَكْرارٌ':Added, #1: 1	طَلَبَ تَكْرَارِ
u'طلب تَكْميلٌ':Added, #1: 1	طَلَبَ تَكْرَارِ
u'طَلَبٌ تَكْميلٌ':Added, #1: 1	طَلَبُ تَكْمِيلِ
u'طلب تَلْبيَةٌ':Added, #1: 1	طَلَبُ تَكْمِيلِ
u'طَلَبٌ تَلْبيَةٌ':Added, #1: 1	طَلَبِ التَّلْبِيَةِ
u'طلب تَمَكُّنٌ':Added, #1: 1	طَلَبِ التَّلْبِيَةِ
u'طَلَبٌ تَمَكُّنٌ':Added, #1: 1	طَلَبُ تَمَكُّنِ
u'طلب تَمْكِين':Added, #1: 1	طَلَبُ تَمَكُّنِ
u'طَلَبٌ تَمْكِين':Added, #3: 3	طَلَبُ التَّمْكِينِ
u'طلب تَمَلُّكٌ':Added, #3: 3	طَلَبُ التَّمْكِينِ
u'طَلَبٌ تَمَلُّكٌ':Added, #1: 1	طَلَبُ تَمَلُّكِ
u'طلب تَمْلِيك':Added, #1: 1	طَلَبُ تَمَلُّكِ
u'طَلَبٌ تَمْلِيك':Added, #1: 1	طَلَبَ التَّمْلِيكِ
u'طلب تَمْلِيك':Added, #1: 1	طَلَبَ التَّمْلِيكِ
u'طَلَبٌ تَمْلِيك':Added, #3: 3	طَلَبِ التَّمْلِيكِ
u'طلب تَمْلِيك':Added, #3: 3	طَلَبِ التَّمْلِيكِ
u'طَلَبٌ تَمْلِيك':Added, #5: 5	طَلَبُ التَّمْلِيكِ
u'طلب تَنَاقُضٌ':Added, #5: 5	طَلَبُ التَّمْلِيكِ
u'طَلَبٌ تَنَاقُضٌ':Added, #1: 1	طَلَبُ تَنَاقُضِهِ
u'طلب تَنَفُّلٌ':Added, #1: 1	طَلَبُ تَنَاقُضِهِ
u'طَلَبٌ تَنَفُّلٌ':Added, #1: 1	طَلَبِ التَّنَفُّلِ
u'طَلَبَ تَنْفِيذٌ':Predicate, #1: 1	طَلَبِ التَّنَفُّلِ
u'طلب تَوْبَةٌ':Added, #1: 1	طَلَبَ تَنْفِيذَ
u'طَلَبٌ تَوْبَةٌ':Added, #1: 1	طَلَبِ التَّوْبَةِ
u'طلب تَوْفِيقٌ':Added, #1: 1	طَلَبِ التَّوْبَةِ
u'طَلَبٌ تَوْفِيقٌ':Added, #1: 1	طَلَبَ التَّوْفِيقِ
u'طَلَبَ تَوْلِيَةٌ':Predicate, #1: 1	طَلَبَ التَّوْفِيقِ
u'طَلَبَ تَوْلِيَةٌ':Predicate, #1: 1	طَلَبَ التَّوْلِيَةَ
u'طلب تَوْلِيَةٌ':Added, #1: 1	طَلَبَ تَوْلِيَةَ
u'طَلَبٌ تَوْلِيَةٌ':Added, #1: 1	طَلَبِ التَّوْلِيَةِ
u'طلب تَيْسيرٌ':Added, #1: 1	طَلَبِ التَّوْلِيَةِ
u'طَلَبٌ تَيْسيرٌ':Added, #1: 1	طَلَبُ التَّيْسِيرِ
u'طلب ثَأْرٌ':Added, #1: 1	طَلَبُ التَّيْسِيرِ
u'طَلَبٌ ثَأْرٌ':Added, #1: 1	طَلَبِ الثّأْرِ
u'طلب ثَالِثٌ':Added, #1: 1	طَلَبِ الثّأْرِ
u'طَلَبٌ ثَالِثٌ':Added, #1: 1	طَلَبِ ثَالِثٍ
u'طلب ثَرْوَة':Added, #1: 1	طَلَبِ ثَالِثٍ
u'طَلَبٌ ثَرْوَة':Added, #1: 1	طَلَبِ الثّرْوَةِ
u'طَلَبَ ثَمَنٌ':Predicate, #1: 1	طَلَبِ الثّرْوَةِ
u'طلب ثَمَنٌ':Added, #1: 1	طَلَبَ الثَّمَنَ
u'طَلَبٌ ثَمَنٌ':Added, #1: 1	طَلَبِ الثَّمَنِ
u'طلب ثَمَنٌ':Added, #1: 1	طَلَبِ الثَّمَنِ
u'طَلَبٌ ثَمَنٌ':Added, #3: 3	طَلَبُ الثَّمَنِ
u'طَلَبَ ثَوابٌ':Predicate, #3: 3	طَلَبُ الثَّمَنِ
u'طلب ثَوابٌ':Added, #1: 1	طَلَبَ الثَّوَابَ
u'طلب ثَوابٌ':Added, #2: 2	طَلَبُ الثَّوَابِ
u'طَلَبٌ ثَوابٌ':Added, #2: 2	طَلَبِ الثَّوَابِ
u'طَلَبٌ ثَوابٌ':Added, #2: 2	طَلَبُ الثَّوَابِ
u'طَلَبَ جَارٌ':Subject, #2: 2	طَلَبِ الثَّوَابِ
u'طَلَبَ جَارٌ':Subject, #1: 1	طَلَبَ الْجَارُ
u'طَلَبَ جَارِحٌ':Subject, #1: 1	طَلَبَ جَارُ
u'طلب جَزَاءٌ':Added, #1: 1	طَلَبَ الْجَارِحُ
u'طَلَبٌ جَزَاءٌ':Added, #1: 1	طَلَبِ الْجَزَاءِ
u'طلب جَزَاءٌ':Added, #1: 1	طَلَبِ الْجَزَاءِ
u'طَلَبٌ جَزَاءٌ':Added, #1: 1	طَلَبِ جَزَاءٍ
u'طَلَبَ جِزْيَةٌ':Predicate, #1: 1	طَلَبِ جَزَاءٍ
u'طلب جَمَاعَةٌ':Added, #1: 1	طَلَبَ الْجِزْيَةَ
u'طلب جَمَاعَةٌ':Added, #1: 1	طَلَبُ جَمَاعَةٍ
u'طَلَبٌ جَمَاعَةٌ':Added, #1: 1	طَلَبِ جَمَاعَةٍ
u'طَلَبٌ جَمَاعَةٌ':Added, #1: 1	طَلَبُ جَمَاعَةٍ
u'طلب جَمَاعَةٌ':Added, #1: 1	طَلَبِ جَمَاعَةٍ
u'طَلَبٌ جَمَاعَةٌ':Added, #3: 3	طَلَبِ الْجَمَاعَةِ
u'طَلَبَ جَمْعٌ':Subject, #3: 3	طَلَبِ الْجَمَاعَةِ
u'طلب جمع':Added, #1: 1	طَلَبَ جَمْعٌ
u'طَلَبٌ جمع':Added, #1: 1	طَلَبِ الْجَمْعِ
u'طلب جَمْعٌ':Added, #1: 1	طَلَبِ الْجَمْعِ
u'طَلَبٌ جَمْعٌ':Added, #1: 1	طَلَبِ الْجَمْعِ
u'طلب جَمِيع':Added, #1: 1	طَلَبِ الْجَمْعِ
u'طَلَبٌ جَمِيع':Added, #1: 1	طَلَبُ الْجَمِيعِ
u'طَلَبَ جِنَايَةٌ':Predicate, #1: 1	طَلَبُ الْجَمِيعِ
u'طلب جِنَايَةٌ':Added, #2: 2	طَلَبَ الْجِنَايَةَ
u'طلب جِنَايَةٌ':Added, #1: 1	طَلَبَ الْجِنَايَةِ
u'طَلَبٌ جِنَايَةٌ':Added, #1: 1	طَلَبِ الْجِنَايَةِ
u'طَلَبٌ جِنَايَةٌ':Added, #1: 1	طَلَبَ الْجِنَايَةِ
u'طلب جَنَّةٌ':Added, #1: 1	طَلَبِ الْجِنَايَةِ
u'طَلَبٌ جَنَّةٌ':Added, #1: 1	طَلَبُ الْجَنَّةِ
u'طَلَبَ جِهَةٌ':Predicate, #1: 1	طَلَبُ الْجَنَّةِ
u'طلب جِهَةٌ':Added, #1: 1	طَلَبَ جِهَةَ
u'طَلَبٌ جِهَةٌ':Added, #1: 1	طَلَبِ الْجِهَةِ
u'طَلَبَ جهر':Predicate, #1: 1	طَلَبِ الْجِهَةِ
u'طَلَبَ جَهْرٌ':Predicate, #1: 1	طَلَبَ الْجَهْرَ
u'طلب جهر':Added, #1: 1	طَلَبَ الْجَهْرَ
u'طلب جهر':Added, #1: 1	طَلَبَ الْجَهْرِ
u'طَلَبٌ جهر':Added, #1: 1	طَلَبِ الْجَهْرِ
u'طَلَبٌ جهر':Added, #1: 1	طَلَبَ الْجَهْرِ
u'طلب جَهْرٌ':Added, #1: 1	طَلَبِ الْجَهْرِ
u'طلب جَهْرٌ':Added, #1: 1	طَلَبَ الْجَهْرِ
u'طَلَبٌ جَهْرٌ':Added, #1: 1	طَلَبِ الْجَهْرِ
u'طَلَبٌ جَهْرٌ':Added, #1: 1	طَلَبَ الْجَهْرِ
u'طلب جهل':Added, #1: 1	طَلَبِ الْجَهْرِ
u'طلب جهل':Added, #1: 1	طَلَبُ الْجَهْلِ
u'طَلَبٌ جهل':Added, #1: 1	طَلَبِ الْجَهْلِ
u'طَلَبٌ جهل':Added, #1: 1	طَلَبُ الْجَهْلِ
u'طلب جَهْلٌ':Added, #1: 1	طَلَبِ الْجَهْلِ
u'طلب جَهْلٌ':Added, #1: 1	طَلَبُ الْجَهْلِ
u'طَلَبٌ جَهْلٌ':Added, #1: 1	طَلَبِ الْجَهْلِ
u'طَلَبٌ جَهْلٌ':Added, #1: 1	طَلَبُ الْجَهْلِ
u'طلب جَوَابٌ':Added, #1: 1	طَلَبِ الْجَهْلِ
u'طَلَبٌ جَوَابٌ':Added, #1: 1	طَلَبُ الْجَوَابِ
u'طلب جَوَابٌ':Added, #1: 1	طَلَبُ الْجَوَابِ
u'طَلَبٌ جَوَابٌ':Added, #1: 1	طَلَبُ جَوَابِ
u'طلب حاجَةٌ':Added, #1: 1	طَلَبُ جَوَابِ
u'طَلَبٌ حاجَةٌ':Added, #1: 1	طَلَبُ الْحَاجَاتِ
u'طلب حاجَةٌ':Added, #1: 1	طَلَبُ الْحَاجَاتِ
u'طَلَبٌ حاجَةٌ':Added, #1: 1	طَلَبِ حَاجَةٍ
u'طلب حاجَةٌ':Added, #1: 1	طَلَبِ حَاجَةٍ
u'طَلَبٌ حاجَةٌ':Added, #2: 2	طَلَبِ الْحَاجَةِ
u'طَلَبَ حارِثٌ':Subject, #2: 2	طَلَبِ الْحَاجَةِ
u'طلب حاصِلٌ':Added, #1: 1	طَلَبَ الْحَارِثُ
u'طَلَبٌ حاصِلٌ':Added, #2: 2	طَلَبِ الْحَاصِلِ
u'طَلَبَ حاضِرٌ':Subject, #2: 2	طَلَبِ الْحَاصِلِ
u'طلب حَبٌّ':Added, #1: 1	طَلَبَ الْحَاضِرُ
u'طَلَبٌ حَبٌّ':Added, #1: 1	طَلَبُ الْحَبِّ
u'طَلَبَ حَبْسٌ':Predicate, #1: 1	طَلَبُ الْحَبِّ
u'طلب حَبْلٌ':Added, #1: 1	طَلَبَ حَبْسَ
u'طَلَبٌ حَبْلٌ':Added, #1: 1	طَلَبِ الْحَبْلِ
u'طَلَبَ حَجْرٌ':Predicate, #1: 1	طَلَبِ الْحَبْلِ
u'طلب حَدٌّ':Added, #2: 2	طَلَبَ الْحَجْرَ
u'طَلَبٌ حَدٌّ':Added, #1: 1	طَلَبِ الْحَدِّ
u'طلب حَدٌّ':Added, #1: 1	طَلَبِ الْحَدِّ
u'طَلَبٌ حَدٌّ':Added, #1: 1	طَلَبُ حَدِّ
u'طلب حَدٌّ':Added, #1: 1	طَلَبُ حَدِّ
u'طَلَبٌ حَدٌّ':Added, #2: 2	طَلَبُ الْحَدِّ
u'طَلَبَ حَديثٌ':Predicate, #2: 2	طَلَبُ الْحَدِّ
u'طلب حَديثٌ':Added, #3: 3	طَلَبَ الْحَدِيثَ
u'طَلَبٌ حَديثٌ':Added, #1: 1	طَلَبَ الْحَدِيثِ
u'طلب حَديثٌ':Added, #1: 1	طَلَبَ الْحَدِيثِ
u'طَلَبٌ حَديثٌ':Added, #7: 7	طَلَبِ الْحَدِيثِ
u'طلب حساب':Added, #7: 7	طَلَبِ الْحَدِيثِ
u'طَلَبٌ حساب':Added, #1: 1	طَلَبُ حِسَابِهِ
u'طلب حِسَابٌ':Added, #1: 1	طَلَبُ حِسَابِهِ
u'طَلَبٌ حِسَابٌ':Added, #1: 1	طَلَبُ حِسَابِهِ
u'طَلَبَ حَسْنَاءُ':Predicate, #1: 1	طَلَبُ حِسَابِهِ
u'طلب حُضورٌ':Added, #1: 1	طَلَبَ الْحَسْنَاءَ
u'طلب حُضُورٌ':Added, #1: 1	طَلَبِ الْحُضُورِ
u'طَلَبٌ حُضورٌ':Added, #1: 1	طَلَبِ الْحُضُورِ
u'طَلَبٌ حُضُورٌ':Added, #1: 1	طَلَبِ الْحُضُورِ
u'طلب حُضورٌ':Added, #1: 1	طَلَبِ الْحُضُورِ
u'طلب حُضُورٌ':Added, #1: 1	طَلَبُ حُضُورِهِ
u'طَلَبٌ حُضورٌ':Added, #1: 1	طَلَبُ حُضُورِهِ
u'طَلَبٌ حُضُورٌ':Added, #1: 1	طَلَبُ حُضُورِهِ
u'طلب حَظٌّ':Added, #1: 1	طَلَبُ حُضُورِهِ
u'طلب حَظٌّ':Added, #1: 1	طَلَبُ الْحَظِّ
u'طَلَبٌ حَظٌّ':Added, #1: 1	طَلَبِ الْحَظِّ
u'طَلَبٌ حَظٌّ':Added, #1: 1	طَلَبُ الْحَظِّ
u'طلب حَفَّارٌ':Added, #1: 1	طَلَبِ الْحَظِّ
u'طَلَبٌ حَفَّارٌ':Added, #1: 1	طَلَبِ الْحَفَّارِ
u'طلب حِفْظٌ':Added, #1: 1	طَلَبِ الْحَفَّارِ
u'طَلَبٌ حِفْظٌ':Added, #1: 1	طَلَبُ الْحِفْظِ
u'طَلَبَ حَقٌّ':Predicate, #1: 1	طَلَبُ الْحِفْظِ
u'طلب حَقٌّ':Added, #1: 1	طَلَبَ الْحَقَّ
u'طَلَبٌ حَقٌّ':Added, #14: 14	طَلَبِ الْحَقِّ
u'طلب حَقٌّ':Added, #14: 14	طَلَبِ الْحَقِّ
u'طَلَبٌ حَقٌّ':Added, #1: 1	طَلَبِ الْحَقَّيْنِ
u'طلب حَقٌّ':Added, #1: 1	طَلَبِ الْحَقَّيْنِ
u'طَلَبٌ حَقٌّ':Added, #1: 1	طَلَبُ حَقٍّ
u'طلب حَقٌّ':Added, #1: 1	طَلَبُ حَقٍّ
u'طَلَبٌ حَقٌّ':Added, #3: 3	طَلَبُ الْحَقِّ
u'طلب حَقٌّ':Added, #3: 3	طَلَبُ الْحَقِّ
u'طَلَبٌ حَقٌّ':Added, #5: 5	طَلَبَ الْحَقِّ
u'طلب حَقٌّ':Added, #5: 5	طَلَبَ الْحَقِّ
u'طَلَبٌ حَقٌّ':Added, #5: 5	طَلَبِ حَقِّهِ
u'طلب حُقوقٌ':Added, #5: 5	طَلَبِ حَقِّهِ
u'طلب حُقُوقٌ':Added, #1: 1	طَلَبُ حُقُوقِهِ
u'طَلَبٌ حُقوقٌ':Added, #1: 1	طَلَبُ حُقُوقِهِ
u'طَلَبٌ حُقُوقٌ':Added, #1: 1	طَلَبُ حُقُوقِهِ
u'طلب حُقوقٌ':Added, #1: 1	طَلَبُ حُقُوقِهِ
u'طلب حُقُوقٌ':Added, #4: 4	طَلَبِ حُقُوقِهِ
u'طَلَبٌ حُقوقٌ':Added, #4: 4	طَلَبِ حُقُوقِهِ
u'طَلَبٌ حُقُوقٌ':Added, #4: 4	طَلَبِ حُقُوقِهِ
u'طلب حَقِيقٌ':Added, #4: 4	طَلَبِ حُقُوقِهِ
u'طَلَبٌ حَقِيقٌ':Added, #1: 1	طَلَبُ حَقِيقَةِ
u'طلب حَقِيقَةٌ':Added, #1: 1	طَلَبُ حَقِيقَةِ
u'طَلَبٌ حَقِيقَةٌ':Added, #1: 1	طَلَبُ حَقِيقَةِ
u'طَلَبَ حُكْمٌ':Predicate, #1: 1	طَلَبُ حَقِيقَةِ
u'طلب حُكْمٌ':Added, #3: 3	طَلَبَ حُكْمَ
u'طَلَبٌ حُكْمٌ':Added, #1: 1	طَلَبُ الْحُكْمِ
u'طلب حُكْمٌ':Added, #1: 1	طَلَبُ الْحُكْمِ
u'طَلَبٌ حُكْمٌ':Added, #1: 1	طَلَبِ حُكْمٍ
u'طلب حُكْمٌ':Added, #1: 1	طَلَبِ حُكْمٍ
u'طَلَبٌ حُكْمٌ':Added, #2: 2	طَلَبِ حُكْمِ
u'طلب حُكْمٌ':Added, #2: 2	طَلَبِ حُكْمِ
u'طَلَبٌ حُكْمٌ':Added, #4: 4	طَلَبِ الْحُكْمِ
u'طلب حُكُومَةٌ':Added, #4: 4	طَلَبِ الْحُكْمِ
u'طَلَبٌ حُكُومَةٌ':Added, #1: 1	طَلَبَ حُكُومَةٍ
u'طلب حُكُومَةٌ':Added, #1: 1	طَلَبَ حُكُومَةٍ
u'طَلَبٌ حُكُومَةٌ':Added, #2: 2	طَلَبُ حُكُومَتِهِ
u'طَلَبَ حِلٌّ':Predicate, #2: 2	طَلَبُ حُكُومَتِهِ
u'طلب حَلالٌ':Added, #1: 1	طَلَبَ الْحِلَّ
u'طَلَبٌ حَلالٌ':Added, #1: 1	طَلَبِ الْحَلاَلِ
u'طلب حَلالٌ':Added, #1: 1	طَلَبِ الْحَلاَلِ
u'طلب حَلالٌ':Added, #3: 3	طَلَبَ الْحَلَالِ
u'طَلَبٌ حَلالٌ':Added, #3: 3	طَلَبُ الْحَلَالِ
u'طَلَبٌ حَلالٌ':Added, #3: 3	طَلَبَ الْحَلَالِ
u'طلب حَمِيل':Added, #3: 3	طَلَبُ الْحَلَالِ
u'طَلَبٌ حَمِيل':Added, #1: 1	طَلَبُ الْحَمِيلِ
u'طلب حِنْطَةٌ':Added, #1: 1	طَلَبُ الْحَمِيلِ
u'طلب حِنْطَةٌ':Added, #1: 1	طَلَبُ الْحِنْطَةِ
u'طَلَبٌ حِنْطَةٌ':Added, #1: 1	طَلَبِ الْحِنْطَةِ
u'طَلَبٌ حِنْطَةٌ':Added, #1: 1	طَلَبُ الْحِنْطَةِ
u'طَلَبَ حِيلَةٌ':Predicate, #1: 1	طَلَبِ الْحِنْطَةِ
u'طلب حِيلَةٌ':Added, #1: 1	طَلَبَ الْحِيلَةَ
u'طَلَبٌ حِيلَةٌ':Added, #1: 1	طَلَبِ الْحِيلَةِ
u'طلب خَارِجٌ':Added, #1: 1	طَلَبِ الْحِيلَةِ
u'طَلَبٌ خَارِجٌ':Added, #1: 1	طَلَبُ الْخَارِجِ
u'طلب خَالِدٌ':Added, #1: 1	طَلَبُ الْخَارِجِ
u'طَلَبٌ خَالِدٌ':Added, #1: 1	طَلَبِ خَالِدٍ
u'طَلَبَ خدمة':Predicate, #1: 1	طَلَبِ خَالِدٍ
u'طَلَبَ خِدْمَةٌ':Predicate, #1: 1	طَلَبَ الْخِدْمَةَ
u'طلب خدمة':Added, #1: 1	طَلَبَ الْخِدْمَةَ
u'طَلَبٌ خدمة':Added, #1: 1	طَلَبُ الْخِدْمَةِ
u'طلب خِدْمَةٌ':Added, #1: 1	طَلَبُ الْخِدْمَةِ
u'طَلَبٌ خِدْمَةٌ':Added, #1: 1	طَلَبُ الْخِدْمَةِ
u'طَلَبَ خُرُوجٌ':Predicate, #1: 1	طَلَبُ الْخِدْمَةِ
u'طلب خُرُوجٌ':Added, #1: 1	طَلَبَ الْخُرُوجَ
u'طَلَبٌ خُرُوجٌ':Added, #1: 1	طَلَبُ الْخُرُوجِ
u'طلب خَسِيسٌ':Added, #1: 1	طَلَبُ الْخُرُوجِ
u'طَلَبٌ خَسِيسٌ':Added, #1: 1	طَلَبِ الْخَسِيسِ
u'طلب خُشُوعٌ':Added, #1: 1	طَلَبِ الْخَسِيسِ
u'طَلَبٌ خُشُوعٌ':Added, #1: 1	طَلَبِ الْخُشُوعِ
u'طَلَبَ خَصْمٌ':Subject, #1: 1	طَلَبِ الْخُشُوعِ
u'طَلَبَ خَصْمٌ':Subject, #3: 3	طَلَبَ خَصْمُهُ
u'طلب خَصْمٌ':Added, #5: 5	طَلَبَ الْخَصْمُ
u'طَلَبٌ خَصْمٌ':Added, #1: 1	طَلَبَ الْخَصْمِ
u'طلب خَصْمٌ':Added, #1: 1	طَلَبَ الْخَصْمِ
u'طَلَبٌ خَصْمٌ':Added, #1: 1	طَلَبِ خَصْمٍ
u'طلب خَصْمٌ':Added, #1: 1	طَلَبِ خَصْمٍ
u'طَلَبٌ خَصْمٌ':Added, #1: 1	طَلَبِ خَصْمِهِ
u'طلب خَصْمٌ':Added, #1: 1	طَلَبِ خَصْمِهِ
u'طَلَبٌ خَصْمٌ':Added, #5: 5	طَلَبِ الْخَصْمِ
u'طلب خُصُومَةٌ':Added, #5: 5	طَلَبِ الْخَصْمِ
u'طلب خُصُومَةٌ':Added, #2: 2	طَلَبُ الْخُصُومَةِ
u'طَلَبٌ خُصُومَةٌ':Added, #2: 2	طَلَبِ الْخُصُومَةِ
u'طَلَبٌ خُصُومَةٌ':Added, #2: 2	طَلَبُ الْخُصُومَةِ
u'طَلَبَ خلاص':Predicate, #2: 2	طَلَبِ الْخُصُومَةِ
u'طَلَبَ خَلاَصٌ':Predicate, #1: 1	طَلَبَ خَلَاصَ
u'طلب خِلاَفَةٌ':Added, #1: 1	طَلَبَ خَلَاصَ
u'طَلَبٌ خِلاَفَةٌ':Added, #2: 2	طَلَبِ الْخِلَافَةِ
u'طلب خَيْرٌ':Added, #2: 2	طَلَبِ الْخِلَافَةِ
u'طَلَبٌ خَيْرٌ':Added, #1: 1	طَلَبِ الْخَيْرِ
u'طلب دَائِنٌ':Added, #1: 1	طَلَبِ الْخَيْرِ
u'طَلَبٌ دَائِنٌ':Added, #1: 1	طَلَبُ الدَّائِنِ
u'طلب دَائِنٌ':Added, #1: 1	طَلَبُ الدَّائِنِ
u'طَلَبٌ دَائِنٌ':Added, #2: 2	طَلَبِ الدَّائِنِ
u'طلب دُخُولٌ':Added, #2: 2	طَلَبِ الدَّائِنِ
u'طَلَبٌ دُخُولٌ':Added, #1: 1	طَلَبُ دُخُولِ
u'طلب دُخُولٌ':Added, #1: 1	طَلَبُ دُخُولِ
u'طَلَبٌ دُخُولٌ':Added, #1: 1	طَلَبُ دُخُولِهِ
u'طلب دِرْهَمٌ':Added, #1: 1	طَلَبُ دُخُولِهِ
u'طلب دِرْهَم':Added, #1: 1	طَلَبِ دِرْهَمٍ
u'طَلَبٌ دِرْهَمٌ':Added, #1: 1	طَلَبِ دِرْهَمٍ
u'طَلَبٌ دِرْهَم':Added, #1: 1	طَلَبِ دِرْهَمٍ
u'طلب دُعَاءٌ':Added, #1: 1	طَلَبِ دِرْهَمٍ
u'طَلَبٌ دُعَاءٌ':Added, #1: 1	طَلَبِ الدُّعَاءِ
u'طلب دُعَاءٌ':Added, #1: 1	طَلَبِ الدُّعَاءِ
u'طَلَبٌ دُعَاءٌ':Added, #3: 3	طَلَبُ الدُّعَاءِ
u'طلب دَلائِلُ':Added, #3: 3	طَلَبُ الدُّعَاءِ
u'طَلَبٌ دَلائِلُ':Added, #1: 1	طَلَبُ الدَّلاَئِلِ
u'طلب دَلائِلُ':Added, #1: 1	طَلَبُ الدَّلاَئِلِ
u'طلب دَلائِلُ':Added, #2: 2	طَلَبُ الدَّلَائِلِ
u'طَلَبٌ دَلائِلُ':Added, #2: 2	طَلَبِ الدَّلَائِلِ
u'طَلَبٌ دَلائِلُ':Added, #2: 2	طَلَبُ الدَّلَائِلِ
u'طلب دَلْوٌ':Added, #2: 2	طَلَبِ الدَّلَائِلِ
u'طَلَبٌ دَلْوٌ':Added, #1: 1	طَلَبُ الدَّلْوِ
u'طلب دَلْوٌ':Added, #1: 1	طَلَبُ الدَّلْوِ
u'طَلَبٌ دَلْوٌ':Added, #3: 3	طَلَبِ الدَّلْوِ
u'طلب دَليلٌ':Added, #3: 3	طَلَبِ الدَّلْوِ
u'طَلَبٌ دَليلٌ':Added, #2: 2	طَلَبَ الدَّلِيلِ
u'طلب دَليلٌ':Added, #2: 2	طَلَبَ الدَّلِيلِ
u'طلب دَليلٌ':Added, #4: 4	طَلَبُ الدَّلِيلِ
u'طَلَبٌ دَليلٌ':Added, #4: 4	طَلَبِ الدَّلِيلِ
u'طَلَبٌ دَليلٌ':Added, #4: 4	طَلَبُ الدَّلِيلِ
u'طلب دَمٌ':Added, #4: 4	طَلَبِ الدَّلِيلِ
u'طَلَبٌ دَمٌ':Added, #3: 3	طَلَبِ الدَّمِ
u'طلب دَوامٌ':Added, #3: 3	طَلَبِ الدَّمِ
u'طَلَبٌ دَوامٌ':Added, #1: 1	طَلَبُ الدَّوَامِ
u'طَلَبَ دونٌ':Predicate, #1: 1	طَلَبُ الدَّوَامِ
u'طلب دِيَةٌ':Added, #1: 1	طَلَبَ دُونَ
u'طَلَبٌ دِيَةٌ':Added, #1: 1	طَلَبُ الدِّيَةِ
u'طَلَبَ دِينٌ':Predicate, #1: 1	طَلَبُ الدِّيَةِ
u'طلب دِينٌ':Added, #1: 1	طَلَبَ الدِّينَ
u'طَلَبٌ دِينٌ':Added, #1: 1	طَلَبُ الدِّينِ
u'طلب دِينٌ':Added, #1: 1	طَلَبُ الدِّينِ
u'طَلَبٌ دِينٌ':Added, #1: 1	طَلَبُ دِينٍ
u'طلب دَيْنٌ':Added, #1: 1	طَلَبُ دِينٍ
u'طَلَبٌ دَيْنٌ':Added, #2: 2	طَلَبِ الدَّيْنِ
u'طلب دَيْنٌ':Added, #2: 2	طَلَبِ الدَّيْنِ
u'طَلَبٌ دَيْنٌ':Added, #3: 3	طَلَبِ دَيْنِهِ
u'طلب ذكر':Added, #3: 3	طَلَبِ دَيْنِهِ
u'طَلَبٌ ذكر':Added, #1: 1	طَلَبِ الذِّكْرِ
u'طلب ذِكْرٌ':Added, #1: 1	طَلَبِ الذِّكْرِ
u'طَلَبٌ ذِكْرٌ':Added, #1: 1	طَلَبِ الذِّكْرِ
u'طلب ذكر':Added, #1: 1	طَلَبِ الذِّكْرِ
u'طَلَبٌ ذكر':Added, #1: 1	طَلَبِ ذِكْرِ
u'طلب ذِكْرٌ':Added, #1: 1	طَلَبِ ذِكْرِ
u'طَلَبٌ ذِكْرٌ':Added, #1: 1	طَلَبِ ذِكْرِ
u'طلب رَاحَةٌ':Added, #1: 1	طَلَبِ ذِكْرِ
u'طَلَبٌ رَاحَةٌ':Added, #1: 1	طَلَبُ الرَّاحَةِ
u'طلب رَأْيٌ':Added, #1: 1	طَلَبُ الرَّاحَةِ
u'طَلَبٌ رَأْيٌ':Added, #2: 2	طَلَبِ الرَّأْيِ
u'طَلَبَ رَبُّ':Subject, #2: 2	طَلَبِ الرَّأْيِ
u'طلب رَبُّ':Added, #2: 2	طَلَبَ رَبُّ
u'طلب رَبُّ':Added, #1: 1	طَلَبَ رَبِّهِ
u'طَلَبٌ رَبُّ':Added, #1: 1	طَلَبُ رَبِّهِ
u'طَلَبٌ رَبُّ':Added, #1: 1	طَلَبَ رَبِّهِ
u'طلب رَبُّ':Added, #1: 1	طَلَبُ رَبِّهِ
u'طَلَبٌ رَبُّ':Added, #2: 2	طَلَبِ رَبِّ
u'طلب رِبْحٌ':Added, #2: 2	طَلَبِ رَبِّ
u'طَلَبٌ رِبْحٌ':Added, #1: 1	طَلَبُ الرِّبْحِ
u'طلب رِبْحٌ':Added, #1: 1	طَلَبُ الرِّبْحِ
u'طَلَبٌ رِبْحٌ':Added, #2: 2	طَلَبِ الرِّبْحِ
u'طلب رُجْحانٌ':Added, #2: 2	طَلَبِ الرِّبْحِ
u'طَلَبٌ رُجْحانٌ':Added, #1: 1	طَلَبِ الرُّجْحَانِ
u'طَلَبَ رَجُلٌ':Subject, #1: 1	طَلَبِ الرُّجْحَانِ
u'طَلَبَ رَجُلٌ':Subject, #1: 1	طَلَبَ رَجُلٌ
u'طلب رَجُلٌ':Added, #2: 2	طَلَبَ الرَّجُلُ
u'طَلَبٌ رَجُلٌ':Added, #2: 2	طَلَبِ الرَّجُلِ
u'طَلَبَ رُجُوعٌ':Predicate, #2: 2	طَلَبِ الرَّجُلِ
u'طلب رُجُوعٌ':Added, #1: 1	طَلَبَ الرُّجُوعَ
u'طَلَبٌ رُجُوعٌ':Added, #1: 1	طَلَبَ الرُّجُوعِ
u'طلب رحمة':Added, #1: 1	طَلَبَ الرُّجُوعِ
u'طَلَبٌ رحمة':Added, #1: 1	طَلَبِ الرَّحْمَةِ
u'طلب رَحْمَةٌ':Added, #1: 1	طَلَبِ الرَّحْمَةِ
u'طَلَبٌ رَحْمَةٌ':Added, #1: 1	طَلَبِ الرَّحْمَةِ
u'طلب رُخَصٌ':Added, #1: 1	طَلَبِ الرَّحْمَةِ
u'طَلَبٌ رُخَصٌ':Added, #2: 2	طَلَبِ الرُّخَصِ
u'طَلَبَ رُخْصَةٌ':Predicate, #2: 2	طَلَبِ الرُّخَصِ
u'طلب رِزْقٌ':Added, #1: 1	طَلَبَ الرُّخْصَةَ
u'طلب رِزْقٌ':Added, #1: 1	طَلَبَ الرِّزْقِ
u'طَلَبٌ رِزْقٌ':Added, #1: 1	طَلَبُ الرِّزْقِ
u'طَلَبٌ رِزْقٌ':Added, #1: 1	طَلَبَ الرِّزْقِ
u'طلب رِزْقٌ':Added, #1: 1	طَلَبُ الرِّزْقِ
u'طَلَبٌ رِزْقٌ':Added, #4: 4	طَلَبِ الرِّزْقِ
u'طلب رَسُولٌ':Added, #4: 4	طَلَبِ الرِّزْقِ
u'طَلَبٌ رَسُولٌ':Added, #1: 1	طَلَبِ رَسُولِ
u'طَلَبَ رَشيدٌ':Subject, #1: 1	طَلَبِ رَسُولِ
u'طَلَبَ رِضاً':Subject, #1: 1	طَلَبَ الرَّشِيدُ
u'طلب رَفْعٌ':Added, #1: 1	طَلَبَ رِضَاهُ
u'طَلَبٌ رَفْعٌ':Added, #1: 1	طَلَبِ رَفْعِ
u'طَلَبَ رَقَبَةٌ':Predicate, #1: 1	طَلَبِ رَفْعِ
u'طلب رِكاز':Added, #1: 1	طَلَبَ الرَّقَبَةَ
u'طَلَبٌ رِكاز':Added, #3: 3	طَلَبِ الرِّكَازِ
u'طَلَبَ رِوايَةٌ':Predicate, #3: 3	طَلَبِ الرِّكَازِ
u'طلب زائِدٌ':Added, #1: 1	طَلَبَ الرِّوَايَةَ
u'طَلَبٌ زائِدٌ':Added, #1: 1	طَلَبُ الزَّائِدِ
u'طَلَبَ زَبيبٌ':Predicate, #1: 1	طَلَبُ الزَّائِدِ
u'طَلَبَ زَكاةٌ':Predicate, #2: 2	طَلَبَ الزَّبِيبَ
u'طلب زَكاةٌ':Added, #1: 1	طَلَبَ الزَّكَاةَ
u'طَلَبٌ زَكاةٌ':Added, #1: 1	طَلَبِ الزَّكَاةِ
u'طلب زَكاةٌ':Added, #1: 1	طَلَبِ الزَّكَاةِ
u'طَلَبٌ زَكاةٌ':Added, #2: 2	طَلَبُ الزَّكَاةِ
u'طَلَبَ زَوْجٌ':Subject, #2: 2	طَلَبُ الزَّكَاةِ
u'طلب زَوْجٌ':Added, #6: 6	طَلَبَ الزَّوْجُ
u'طَلَبٌ زَوْجٌ':Added, #1: 1	طَلَبِ الزَّوْجِ
u'طلب زَوْجَةٌ':Added, #1: 1	طَلَبِ الزَّوْجِ
u'طَلَبٌ زَوْجَةٌ':Added, #1: 1	طَلَبِ الزَّوْجَةِ
u'طَلَبَ زِيادَةٌ':Predicate, #1: 1	طَلَبِ الزَّوْجَةِ
u'طلب زِيادَةٌ':Added, #1: 1	طَلَبَ الزِّيَادَةَ
u'طلب زِيادَةٌ':Added, #1: 1	طَلَبُ زِيَادَةِ
u'طَلَبٌ زِيادَةٌ':Added, #1: 1	طَلَبِ زِيَادَةِ
u'طَلَبٌ زِيادَةٌ':Added, #1: 1	طَلَبُ زِيَادَةِ
u'طلب زِيادَةٌ':Added, #1: 1	طَلَبِ زِيَادَةِ
u'طَلَبٌ زِيادَةٌ':Added, #5: 5	طَلَبِ الزِّيَادَةِ
u'طَلَبَ سَاكِنٌ':Subject, #5: 5	طَلَبِ الزِّيَادَةِ
u'طلب سَتْرٌ':Added, #1: 1	طَلَبَ السَّاكِنُ
u'طَلَبٌ سَتْرٌ':Added, #1: 1	طَلَبِ السَّتْرِ
u'طلب سَقْيٌ':Added, #1: 1	طَلَبِ السَّتْرِ
u'طَلَبٌ سَقْيٌ':Added, #1: 1	طَلَبَ السَّقْيِ
u'طلب سَقْيٌ':Added, #1: 1	طَلَبَ السَّقْيِ
u'طَلَبٌ سَقْيٌ':Added, #2: 2	طَلَبُ السَّقْيِ
u'طلب سلام':Added, #2: 2	طَلَبُ السَّقْيِ
u'طَلَبٌ سلام':Added, #1: 1	طَلَبِ السَّلَامِ
u'طلب سَلاَمٌ':Added, #1: 1	طَلَبِ السَّلَامِ
u'طَلَبٌ سَلاَمٌ':Added, #1: 1	طَلَبِ السَّلَامِ
u'طَلَبَ سَلاَمَةٌ':Predicate, #1: 1	طَلَبِ السَّلَامِ
u'طَلَبَ سَلَبٌ':Predicate, #1: 1	طَلَبَ السَّلَامَةَ
u'طلب سَلْبٌ':Added, #1: 1	طَلَبَ السَّلَبَ
u'طَلَبٌ سَلْبٌ':Added, #1: 1	طَلَبُ سَلْبِ
u'طلب سُلْطَانٌ':Added, #1: 1	طَلَبُ سَلْبِ
u'طَلَبٌ سُلْطَانٌ':Added, #1: 1	طَلَبَ السُّلْطَانِ
u'طلب سُلْطَانٌ':Added, #1: 1	طَلَبَ السُّلْطَانِ
u'طَلَبٌ سُلْطَانٌ':Added, #1: 1	طَلَبِ سُلْطَانٍ
u'طلب سِلْعَةٌ':Added, #1: 1	طَلَبِ سُلْطَانٍ
u'طَلَبٌ سِلْعَةٌ':Added, #1: 1	طَلَبَ السِّلْعَةِ
u'طلب سُؤَالٌ':Added, #1: 1	طَلَبَ السِّلْعَةِ
u'طَلَبٌ سُؤَالٌ':Added, #1: 1	طَلَبُ سُؤَالِ
u'طلب سِيادَةٌ':Added, #1: 1	طَلَبُ سُؤَالِ
u'طَلَبٌ سِيادَةٌ':Added, #1: 1	طَلَبِ السِّيَادَةِ
u'طَلَبَ سَيِّدٌ':Subject, #1: 1	طَلَبِ السِّيَادَةِ
u'طَلَبَ شَارِعٌ':Subject, #1: 1	طَلَبَ السَّيِّدُ
u'طَلَبَ شافِعِيّ':Subject, #3: 3	طَلَبَ الشَّارِعُ
u'طلب شافِعِيّ':Added, #1: 1	طَلَبَ الشَّافِعِيُّ
u'طَلَبٌ شافِعِيّ':Added, #3: 3	طَلَبِ الشَّافِعِيِّ
u'طَلَبَ شَاهِدٌ':Predicate, #3: 3	طَلَبِ الشَّافِعِيِّ
u'طَلَبَ شَاهِدٌ':Subject, #1: 1	طَلَبَ الشَّاهِدَ
u'طلب شَجَرٌ':Added, #1: 1	طَلَبَ الشَّاهِدُ
u'طَلَبٌ شَجَرٌ':Added, #1: 1	طَلَبُ شَجَرٍ
u'طلب شَجَرَةٌ':Added, #1: 1	طَلَبُ شَجَرٍ
u'طَلَبٌ شَجَرَةٌ':Added, #1: 1	طَلَبُ شَجَرَةٍ
u'طَلَبَ شَخْصٌ':Subject, #1: 1	طَلَبُ شَجَرَةٍ
u'طَلَبَ شِرَاءٌ':Predicate, #2: 2	طَلَبَ شَخْصٌ
u'طلب شَرْحٌ':Added, #1: 1	طَلَبَ شِرَاءَ
u'طَلَبٌ شَرْحٌ':Added, #1: 1	طَلَبُ شَرْحِ
u'طلب شَرْعٌ':Added, #1: 1	طَلَبُ شَرْحِ
u'طَلَبٌ شَرْعٌ':Added, #2: 2	طَلَبِ الشَّرْعِ
u'طلب شَفَاعَةٌ':Added, #2: 2	طَلَبِ الشَّرْعِ
u'طلب شَفَاعَةٌ':Added, #1: 1	طَلَبُ الشَّفَاعَةِ
u'طَلَبٌ شَفَاعَةٌ':Added, #1: 1	طَلَبِ الشَّفَاعَةِ
u'طَلَبٌ شَفَاعَةٌ':Added, #1: 1	طَلَبُ الشَّفَاعَةِ
u'طَلَبَ شفعة':Predicate, #1: 1	طَلَبِ الشَّفَاعَةِ
u'طَلَبَ شُفْعَةٌ':Predicate, #37: 37	طَلَبَ الشُّفْعَةَ
u'طلب شفعة':Added, #37: 37	طَلَبَ الشُّفْعَةَ
u'طَلَبٌ شفعة':Added, #12: 12	طَلَبُ الشُّفْعَةِ
u'طلب شُفْعَةٌ':Added, #12: 12	طَلَبُ الشُّفْعَةِ
u'طَلَبٌ شُفْعَةٌ':Added, #12: 12	طَلَبُ الشُّفْعَةِ
u'طلب شفعة':Added, #12: 12	طَلَبُ الشُّفْعَةِ
u'طَلَبٌ شفعة':Added, #23: 23	طَلَبِ الشُّفْعَةِ
u'طلب شُفْعَةٌ':Added, #23: 23	طَلَبِ الشُّفْعَةِ
u'طَلَبٌ شُفْعَةٌ':Added, #23: 23	طَلَبِ الشُّفْعَةِ
u'طلب شفعة':Added, #23: 23	طَلَبِ الشُّفْعَةِ
u'طَلَبٌ شفعة':Added, #7: 7	طَلَبَ الشُّفْعَةِ
u'طلب شُفْعَةٌ':Added, #7: 7	طَلَبَ الشُّفْعَةِ
u'طَلَبٌ شُفْعَةٌ':Added, #7: 7	طَلَبَ الشُّفْعَةِ
u'طَلَبَ شَفِيعٌ':Subject, #7: 7	طَلَبَ الشُّفْعَةِ
u'طلب شَفِيعٌ':Added, #8: 8	طَلَبَ الشَّفِيعُ
u'طلب شَفِيعٌ':Added, #1: 1	طَلَبَ الشَّفِيعِ
u'طلب شَفِيعٌ':Added, #1: 1	طَلَبُ الشَّفِيعِ
u'طَلَبٌ شَفِيعٌ':Added, #1: 1	طَلَبِ الشَّفِيعِ
u'طَلَبٌ شَفِيعٌ':Added, #1: 1	طَلَبَ الشَّفِيعِ
u'طَلَبٌ شَفِيعٌ':Added, #1: 1	طَلَبُ الشَّفِيعِ
u'طَلَبَ شَهَادَةٌ':Predicate, #1: 1	طَلَبِ الشَّفِيعِ
u'طلب شَهَادَةٌ':Added, #3: 3	طَلَبَ الشَّهَادَةَ
u'طَلَبٌ شَهَادَةٌ':Added, #1: 1	طَلَبُ شَهَادَةِ
u'طلب شَهَادَةٌ':Added, #1: 1	طَلَبُ شَهَادَةِ
u'طَلَبٌ شَهَادَةٌ':Added, #2: 2	طَلَبُ الشَّهَادَةِ
u'طلب شَيْءٌ':Added, #2: 2	طَلَبُ الشَّهَادَةِ
u'طلب شَيْءٌ':Added, #1: 1	طَلَبَ الشَّيْءِ
u'طلب شَيْءٌ':Added, #1: 1	طَلَبُ الشَّيْءِ
u'طَلَبٌ شَيْءٌ':Added, #1: 1	طَلَبِ الشَّيْءِ
u'طَلَبٌ شَيْءٌ':Added, #1: 1	طَلَبَ الشَّيْءِ
u'طَلَبٌ شَيْءٌ':Added, #1: 1	طَلَبُ الشَّيْءِ
u'طلب شَيْءٌ':Added, #1: 1	طَلَبِ الشَّيْءِ
u'طَلَبٌ شَيْءٌ':Added, #1: 1	طَلَبُ شَيْءٍ
u'طَلَبَ صَابُونٌ':Predicate, #1: 1	طَلَبُ شَيْءٍ
u'طَلَبَ صَاحِبٌ':Subject, #2: 2	طَلَبَ الصَّابُونَ
u'طَلَبَ صَاحِبٌ':Subject, #24: 24	طَلَبَ صَاحِبُ
u'طلب صَاحِبٌ':Added, #2: 2	طَلَبَ صَاحِبُهُ
u'طَلَبٌ صَاحِبٌ':Added, #5: 5	طَلَبِ صَاحِبِ
u'طلب صِبْيَانٌ':Added, #5: 5	طَلَبِ صَاحِبِ
u'طَلَبٌ صِبْيَانٌ':Added, #1: 1	طَلَبُ الصِّبْيَانِ
u'طَلَبَ صدقة':Predicate, #1: 1	طَلَبُ الصِّبْيَانِ
u'طَلَبَ صَدَقَةٌ':Predicate, #1: 1	طَلَبَ الصَّدَقَةَ
u'طلب صدقة':Added, #1: 1	طَلَبَ الصَّدَقَةَ
u'طلب صدقة':Added, #1: 1	طَلَبَ الصَّدَقَةِ
u'طَلَبٌ صدقة':Added, #1: 1	طَلَبِ الصَّدَقَةِ
u'طَلَبٌ صدقة':Added, #1: 1	طَلَبَ الصَّدَقَةِ
u'طلب صَدَقَةٌ':Added, #1: 1	طَلَبِ الصَّدَقَةِ
u'طلب صَدَقَةٌ':Added, #1: 1	طَلَبَ الصَّدَقَةِ
u'طَلَبٌ صَدَقَةٌ':Added, #1: 1	طَلَبِ الصَّدَقَةِ
u'طَلَبٌ صَدَقَةٌ':Added, #1: 1	طَلَبَ الصَّدَقَةِ
u'طلب صدقة':Added, #1: 1	طَلَبِ الصَّدَقَةِ
u'طَلَبٌ صدقة':Added, #2: 2	طَلَبُ الصَّدَقَةِ
u'طلب صَدَقَةٌ':Added, #2: 2	طَلَبُ الصَّدَقَةِ
u'طَلَبٌ صَدَقَةٌ':Added, #2: 2	طَلَبُ الصَّدَقَةِ
u'طلب صَلاَةٌ':Added, #2: 2	طَلَبُ الصَّدَقَةِ
u'طَلَبٌ صَلاَةٌ':Added, #1: 1	طَلَبَ الصَّلَاةِ
u'طلب صَلاَةٌ':Added, #1: 1	طَلَبَ الصَّلَاةِ
u'طَلَبٌ صَلاَةٌ':Added, #5: 5	طَلَبِ الصَّلَاةِ
u'طلب صَلاَحٌ':Added, #5: 5	طَلَبِ الصَّلَاةِ
u'طَلَبٌ صَلاَحٌ':Added, #1: 1	طَلَبِ صَلَاحِ
u'طَلَبَ صلح':Predicate, #1: 1	طَلَبِ صَلَاحِ
u'طَلَبَ صُلْحٌ':Predicate, #1: 1	طَلَبَ الصُّلْحَ
u'طلب صلح':Added, #1: 1	طَلَبَ الصُّلْحَ
u'طَلَبٌ صلح':Added, #1: 1	طَلَبَ الصُّلْحِ
u'طلب صُلْحٌ':Added, #1: 1	طَلَبَ الصُّلْحِ
u'طَلَبٌ صُلْحٌ':Added, #1: 1	طَلَبَ الصُّلْحِ
u'طلب صلح':Added, #1: 1	طَلَبَ الصُّلْحِ
u'طَلَبٌ صلح':Added, #2: 2	طَلَبُ الصُّلْحِ
u'طلب صُلْحٌ':Added, #2: 2	طَلَبُ الصُّلْحِ
u'طَلَبٌ صُلْحٌ':Added, #2: 2	طَلَبُ الصُّلْحِ
u'طلب صنع':Added, #2: 2	طَلَبُ الصُّلْحِ
u'طلب صنع':Added, #1: 1	طَلَبَ الصُّنْعِ
u'طَلَبٌ صنع':Added, #1: 1	طَلَبُ الصُّنْعِ
u'طَلَبٌ صنع':Added, #1: 1	طَلَبَ الصُّنْعِ
u'طلب صُنْعٌ':Added, #1: 1	طَلَبُ الصُّنْعِ
u'طلب صُنْعٌ':Added, #1: 1	طَلَبَ الصُّنْعِ
u'طَلَبٌ صُنْعٌ':Added, #1: 1	طَلَبُ الصُّنْعِ
u'طَلَبٌ صُنْعٌ':Added, #1: 1	طَلَبَ الصُّنْعِ
u'طلب صنعة':Added, #1: 1	طَلَبُ الصُّنْعِ
u'طَلَبٌ صنعة':Added, #1: 1	طَلَبُ الصَّنْعَةِ
u'طلب صَنْعَةٌ':Added, #1: 1	طَلَبُ الصَّنْعَةِ
u'طَلَبٌ صَنْعَةٌ':Added, #1: 1	طَلَبُ الصَّنْعَةِ
u'طلب صنعة':Added, #1: 1	طَلَبُ الصَّنْعَةِ
u'طَلَبٌ صنعة':Added, #1: 1	طَلَبِ صَنْعَةٍ
u'طلب صَنْعَةٌ':Added, #1: 1	طَلَبِ صَنْعَةٍ
u'طَلَبٌ صَنْعَةٌ':Added, #1: 1	طَلَبِ صَنْعَةٍ
u'طلب صَوَابٌ':Added, #1: 1	طَلَبِ صَنْعَةٍ
u'طَلَبٌ صَوَابٌ':Added, #3: 3	طَلَبُ الصَّوَابِ
u'طَلَبَ صَيْدٌ':Predicate, #3: 3	طَلَبُ الصَّوَابِ
u'طَلَبَ صَيْدٌ':Predicate, #1: 1	طَلَبَ صَيْدَ
u'طلب صَيْدٌ':Added, #2: 2	طَلَبَ الصَّيْدَ
u'طَلَبٌ صَيْدٌ':Added, #2: 2	طَلَبِ الصَّيْدِ
u'طلب ضَالٌّ':Added, #2: 2	طَلَبِ الصَّيْدِ
u'طَلَبٌ ضَالٌّ':Added, #1: 1	طَلَبِ ضَالَّةٍ
u'طلب ضِدٌّ':Added, #1: 1	طَلَبِ ضَالَّةٍ
u'طَلَبٌ ضِدٌّ':Added, #1: 1	طَلَبِ ضِدِّهِ
u'طلب ضَرَّةٌ':Added, #1: 1	طَلَبِ ضِدِّهِ
u'طَلَبٌ ضَرَّةٌ':Added, #1: 1	طَلَبِ الضَّرَّةِ
u'طلب طَاعَةٌ':Added, #1: 1	طَلَبِ الضَّرَّةِ
u'طَلَبٌ طَاعَةٌ':Added, #1: 1	طَلَبِ الطَّاعَةِ
u'طلب طَالِبٌ':Added, #1: 1	طَلَبِ الطَّاعَةِ
u'طَلَبٌ طَالِبٌ':Added, #3: 3	طَلَبِ الطَّالِبِ
u'طَلَبَ طِفْلٌ':Subject, #3: 3	طَلَبِ الطَّالِبِ
u'طَلَبَ طلب':Predicate, #1: 1	طَلَبَ الطِّفْلُ
u'طَلَبَ طَلَبٌ':Predicate, #1: 1	طَلَبَ طَلَبَ
u'طلب طَهَارَةٌ':Added, #1: 1	طَلَبَ طَلَبَ
u'طَلَبٌ طَهَارَةٌ':Added, #1: 1	طَلَبِ الطَّهَارَةِ
u'طلب طواف':Added, #1: 1	طَلَبِ الطَّهَارَةِ
u'طَلَبٌ طواف':Added, #1: 1	طَلَبِ الطَّوَافِ
u'طلب طَوَافٌ':Added, #1: 1	طَلَبِ الطَّوَافِ
u'طَلَبٌ طَوَافٌ':Added, #1: 1	طَلَبِ الطَّوَافِ
u'طَلَبَ ظاهِرٌ':Predicate, #1: 1	طَلَبِ الطَّوَافِ
u'طلب ظُهورٌ':Added, #1: 1	طَلَبَ الظَّاهِرَ
u'طَلَبٌ ظُهورٌ':Added, #1: 1	طَلَبُ ظُهُورِ
u'طلب عَادَةٌ':Added, #1: 1	طَلَبُ ظُهُورِ
u'طَلَبٌ عَادَةٌ':Added, #1: 1	طَلَبَ الْعَادَةِ
u'طلب عارِيَّةٌ':Added, #1: 1	طَلَبَ الْعَادَةِ
u'طَلَبٌ عارِيَّةٌ':Added, #4: 4	طَلَبُ الْعَارِيَّةِ
u'طَلَبَ عَامِلٌ':Subject, #4: 4	طَلَبُ الْعَارِيَّةِ
u'طَلَبَ عِبَادٌ':Predicate, #1: 1	طَلَبَ الْعَامِلُ
u'طلب عِبَادَةٌ':Added, #1: 1	طَلَبَ الْعِبَادَ
u'طَلَبٌ عِبَادَةٌ':Added, #1: 1	طَلَبِ الْعِبَادَةِ
u'طَلَبَ عَبْدٌ':Subject, #1: 1	طَلَبِ الْعِبَادَةِ
u'طلب عَبْدٌ':Added, #4: 4	طَلَبَ الْعَبْدُ
u'طَلَبٌ عَبْدٌ':Added, #1: 1	طَلَبِ الْعَبْدِ
u'طلب عَبْدٌ':Added, #1: 1	طَلَبِ الْعَبْدِ
u'طَلَبٌ عَبْدٌ':Added, #2: 2	طَلَبَ الْعَبْدِ
u'طلب عَدَالَةٌ':Added, #2: 2	طَلَبَ الْعَبْدِ
u'طَلَبٌ عَدَالَةٌ':Added, #1: 1	طَلَبِ الْعَدَالَةِ
u'طلب عَدَالَةٌ':Added, #1: 1	طَلَبِ الْعَدَالَةِ
u'طَلَبٌ عَدَالَةٌ':Added, #1: 1	طَلَبُ عَدَالَةِ
u'طلب عَدْلٌ':Added, #1: 1	طَلَبُ عَدَالَةِ
u'طَلَبٌ عَدْلٌ':Added, #2: 2	طَلَبِ الْعَدْلِ
u'طلب عَدَمٌ':Added, #2: 2	طَلَبِ الْعَدْلِ
u'طَلَبٌ عَدَمٌ':Added, #1: 1	طَلَبَ عَدَمِ
u'طَلَبَ عَدُوٌّ':Subject, #1: 1	طَلَبَ عَدَمِ
u'طلب عَدُوٌّ':Added, #1: 1	طَلَبَ الْعَدُوُّ
u'طَلَبٌ عَدُوٌّ':Added, #1: 1	طَلَبِ الْعَدُوِّ
u'طَلَبَ عَزِيزٌ':Predicate, #1: 1	طَلَبِ الْعَدُوِّ
u'طلب عِصْمَةٌ':Added, #1: 1	طَلَبَ الْعَزِيزَ
u'طَلَبٌ عِصْمَةٌ':Added, #1: 1	طَلَبُ عِصْمَةِ
u'طَلَبَ عَفْوٌ':Predicate, #1: 1	طَلَبُ عِصْمَةِ
u'طلب عَفْوٌ':Added, #1: 1	طَلَبَ الْعَفْوَ
u'طَلَبٌ عَفْوٌ':Added, #1: 1	طَلَبِ الْعَفْوِ
u'طلب عَفْوٌ':Added, #1: 1	طَلَبِ الْعَفْوِ
u'طَلَبٌ عَفْوٌ':Added, #1: 1	طَلَبِ عَفْوِ
u'طلب عَقْدٌ':Added, #1: 1	طَلَبِ عَفْوِ
u'طَلَبٌ عَقْدٌ':Added, #1: 1	طَلَب الْعَقْدِ
u'طَلَبَ علم':Predicate, #1: 1	طَلَب الْعَقْدِ
u'طَلَبَ عِلْمٌ':Predicate, #7: 7	طَلَبَ الْعِلْمَ
u'طلب علم':Added, #7: 7	طَلَبَ الْعِلْمَ
u'طلب علم':Added, #1: 1	طَلَبُ عِلْمٍ
u'طَلَبٌ علم':Added, #1: 1	طَلَبِ عِلْمِ
u'طَلَبٌ علم':Added, #1: 1	طَلَبُ عِلْمٍ
u'طلب عِلْمٌ':Added, #1: 1	طَلَبِ عِلْمِ
u'طلب عِلْمٌ':Added, #1: 1	طَلَبُ عِلْمٍ
u'طَلَبٌ عِلْمٌ':Added, #1: 1	طَلَبِ عِلْمِ
u'طَلَبٌ عِلْمٌ':Added, #1: 1	طَلَبُ عِلْمٍ
u'طلب علم':Added, #1: 1	طَلَبِ عِلْمِ
u'طَلَبٌ علم':Added, #30: 30	طَلَبُ الْعِلْمِ
u'طلب عِلْمٌ':Added, #30: 30	طَلَبُ الْعِلْمِ
u'طَلَبٌ عِلْمٌ':Added, #30: 30	طَلَبُ الْعِلْمِ
u'طلب علم':Added, #30: 30	طَلَبُ الْعِلْمِ
u'طَلَبٌ علم':Added, #3: 3	طَلَبِ عِلْمٍ
u'طلب عِلْمٌ':Added, #3: 3	طَلَبِ عِلْمٍ
u'طَلَبٌ عِلْمٌ':Added, #3: 3	طَلَبِ عِلْمٍ
u'طلب علم':Added, #3: 3	طَلَبِ عِلْمٍ
u'طَلَبٌ علم':Added, #48: 48	طَلَبِ الْعِلْمِ
u'طلب عِلْمٌ':Added, #48: 48	طَلَبِ الْعِلْمِ
u'طَلَبٌ عِلْمٌ':Added, #48: 48	طَلَبِ الْعِلْمِ
u'طلب علم':Added, #48: 48	طَلَبِ الْعِلْمِ
u'طَلَبٌ علم':Added, #4: 4	طَلَبَ الْعِلْمِ
u'طلب عِلْمٌ':Added, #4: 4	طَلَبَ الْعِلْمِ
u'طَلَبٌ عِلْمٌ':Added, #4: 4	طَلَبَ الْعِلْمِ
u'طلب عُلُوٌّ':Added, #4: 4	طَلَبَ الْعِلْمِ
u'طَلَبٌ عُلُوٌّ':Added, #1: 1	طَلَبِ عُلُوِّ
u'طلب عِمَارَةٌ':Added, #1: 1	طَلَبِ عُلُوِّ
u'طَلَبٌ عِمَارَةٌ':Added, #1: 1	طَلَبُ الْعِمَارَةِ
u'طَلَبَ عُمَرٌ':Subject, #1: 1	طَلَبُ الْعِمَارَةِ
u'طلب عَمَلٌ':Added, #1: 1	طَلَبَ عُمَرُ
u'طَلَبٌ عَمَلٌ':Added, #1: 1	طَلَبُ عَمَلِ
u'طَلَبَ عند':Predicate, #1: 1	طَلَبُ عَمَلِ
u'طلب عَوْدٌ':Added, #2: 2	طَلَبَ عِنْدَ
u'طلب عَوْدٌ':Added, #1: 1	طَلَبَ الْعَوْدِ
u'طَلَبٌ عَوْدٌ':Added, #1: 1	طَلَبُ الْعَوْدِ
u'طَلَبٌ عَوْدٌ':Added, #1: 1	طَلَبَ الْعَوْدِ
u'طلب عَوْذٌ':Added, #1: 1	طَلَبُ الْعَوْدِ
u'طَلَبٌ عَوْذٌ':Added, #1: 1	طَلَبُ الْعَوْذِ
u'طَلَبَ عَوْرَةٌ':Predicate, #1: 1	طَلَبُ الْعَوْذِ
u'طَلَبَ عين':Predicate, #1: 1	طَلَبَ عَوْرَةَ
u'طَلَبَ عَيْنٌ':Predicate, #1: 1	طَلَبَ عَيْنَ
u'طَلَبَ عَيْن':Predicate, #1: 1	طَلَبَ عَيْنَ
u'طلب عين':Added, #1: 1	طَلَبَ عَيْنَ
u'طلب عَيْنٌ':Added, #1: 1	طَلَبُ الْعَيْنِ
u'طلب عَيْن':Added, #1: 1	طَلَبُ الْعَيْنِ
u'طَلَبٌ عين':Added, #1: 1	طَلَبُ الْعَيْنِ
u'طَلَبٌ عَيْنٌ':Added, #1: 1	طَلَبُ الْعَيْنِ
u'طَلَبٌ عَيْن':Added, #1: 1	طَلَبُ الْعَيْنِ
u'طلب عين':Added, #1: 1	طَلَبُ الْعَيْنِ
u'طلب عَيْنٌ':Added, #1: 1	طَلَبُ عَيْنِهِ
u'طلب عَيْن':Added, #1: 1	طَلَبُ عَيْنِهِ
u'طَلَبٌ عين':Added, #1: 1	طَلَبُ عَيْنِهِ
u'طَلَبٌ عَيْنٌ':Added, #1: 1	طَلَبُ عَيْنِهِ
u'طَلَبٌ عَيْن':Added, #1: 1	طَلَبُ عَيْنِهِ
u'طَلَبَ عُيُوبٌ':Predicate, #1: 1	طَلَبُ عَيْنِهِ
u'طلب غَازٌ':Added, #1: 1	طَلَبَ عُيُوبَ
u'طَلَبٌ غَازٌ':Added, #2: 2	طَلَبَ غَازٍ
u'طلب غَاصِبٌ':Added, #2: 2	طَلَبَ غَازٍ
u'طَلَبٌ غَاصِبٌ':Added, #1: 1	طَلَبِ الْغَاصِبِ
u'طلب غَائِبٌ':Added, #1: 1	طَلَبِ الْغَاصِبِ
u'طَلَبٌ غَائِبٌ':Added, #1: 1	طَلَبِ الْغَائِبِ
u'طلب غِذَاءٌ':Added, #1: 1	طَلَبِ الْغَائِبِ
u'طَلَبٌ غِذَاءٌ':Added, #2: 2	طَلَبِ الْغِذَاءِ
u'طلب غَرَضٌ':Added, #2: 2	طَلَبِ الْغِذَاءِ
u'طَلَبٌ غَرَضٌ':Added, #1: 1	طَلَب غَرَضٍ
u'طَلَبَ غرماء':Subject, #1: 1	طَلَب غَرَضٍ
u'طَلَبَ غرماء':Subject, #4: 4	طَلَبَ غُرَمَاءُ
u'طلب غرماء':Added, #5: 5	طَلَبَ الْغُرَمَاءُ
u'طَلَبٌ غرماء':Added, #3: 3	طَلَبِ الْغُرَمَاءِ
u'طَلَبَ غَرِيبٌ':Predicate, #3: 3	طَلَبِ الْغُرَمَاءِ
u'طلب غَرِيبٌ':Added, #1: 1	طَلَبَ غَرِيبَ
u'طَلَبٌ غَرِيبٌ':Added, #1: 1	طَلَبِ الْغَرِيبِ
u'طَلَبَ غَرِيمٌ':Predicate, #1: 1	طَلَبِ الْغَرِيبِ
u'طلب غَرِيمٌ':Added, #1: 1	طَلَبَ غَرِيمَ
u'طَلَبٌ غَرِيمٌ':Added, #2: 2	طَلَبُ الْغَرِيمِ
u'طلب غَوايَة':Added, #2: 2	طَلَبُ الْغَرِيمِ
u'طَلَبٌ غَوايَة':Added, #1: 1	طَلَبِ الْغَوَايَةِ
u'طلب غَيْثٌ':Added, #1: 1	طَلَبِ الْغَوَايَةِ
u'طَلَبٌ غَيْثٌ':Added, #1: 1	طَلَبِ الْغَيْثِ
u'طَلَبَ غير':Subject, #1: 1	طَلَبِ الْغَيْثِ
u'طَلَبَ غَيْرٌ':Subject, #1: 1	طَلَبَ غَيْرُ
u'طَلَبَ غير':Subject, #1: 1	طَلَبَ غَيْرُ
u'طَلَبَ غَيْرٌ':Subject, #2: 2	طَلَبَ غَيْرُهُ
u'طلب غير':Added, #2: 2	طَلَبَ غَيْرُهُ
u'طلب غَيْرٌ':Added, #1: 1	طَلَبَ غَيْرِ
u'طَلَبٌ غير':Added, #1: 1	طَلَبَ غَيْرِ
u'طَلَبٌ غَيْرٌ':Added, #1: 1	طَلَبَ غَيْرِ
u'طلب غير':Added, #1: 1	طَلَبَ غَيْرِ
u'طلب غَيْرٌ':Added, #1: 1	طَلَبِ غَيْرِهِ
u'طَلَبٌ غير':Added, #1: 1	طَلَبِ غَيْرِهِ
u'طَلَبٌ غَيْرٌ':Added, #1: 1	طَلَبِ غَيْرِهِ
u'طلب فَاسِدٌ':Added, #1: 1	طَلَبِ غَيْرِهِ
u'طَلَبٌ فَاسِدٌ':Added, #1: 1	طَلَبِ الْفَاسِدِ
u'طلب فَائِدَةٌ':Added, #1: 1	طَلَبِ الْفَاسِدِ
u'طَلَبٌ فَائِدَةٌ':Added, #1: 1	طَلَبُ الْفَائِدَةِ
u'طلب فَتْحٌ':Added, #1: 1	طَلَبُ الْفَائِدَةِ
u'طَلَبٌ فَتْحٌ':Added, #1: 1	طَلَبُ الْفَتْحِ
u'طلب فِدَاءٌ':Added, #1: 1	طَلَبُ الْفَتْحِ
u'طَلَبٌ فِدَاءٌ':Added, #1: 1	طَلَبِ الْفِدَاءِ
u'طلب فِدَاءٌ':Added, #1: 1	طَلَبِ الْفِدَاءِ
u'طَلَبٌ فِدَاءٌ':Added, #1: 1	طَلَبِ فِدَاءِ
u'طلب فِرَاقٌ':Added, #1: 1	طَلَبِ فِدَاءِ
u'طلب فِرَاقٌ':Added, #1: 1	طَلَبُ الْفِرَاقِ
u'طَلَبٌ فِرَاقٌ':Added, #1: 1	طَلَبِ الْفِرَاقِ
u'طَلَبٌ فِرَاقٌ':Added, #1: 1	طَلَبُ الْفِرَاقِ
u'طلب فَرْضٌ':Added, #1: 1	طَلَبِ الْفِرَاقِ
u'طلب فَرْضٌ':Added, #2: 2	طَلَبُ الْفَرْضِ
u'طَلَبٌ فَرْضٌ':Added, #2: 2	طَلَبِ الْفَرْضِ
u'طَلَبٌ فَرْضٌ':Added, #2: 2	طَلَبُ الْفَرْضِ
u'طلب فرق':Added, #2: 2	طَلَبِ الْفَرْضِ
u'طَلَبٌ فرق':Added, #2: 2	طَلَبَ الْفَرْقِ
u'طلب فَرْقٌ':Added, #2: 2	طَلَبَ الْفَرْقِ
u'طَلَبٌ فَرْقٌ':Added, #2: 2	طَلَبَ الْفَرْقِ
u'طلب فرق':Added, #2: 2	طَلَبَ الْفَرْقِ
u'طَلَبٌ فرق':Added, #3: 3	طَلَبُ الْفَرْقِ
u'طلب فَرْقٌ':Added, #3: 3	طَلَبُ الْفَرْقِ
u'طَلَبٌ فَرْقٌ':Added, #3: 3	طَلَبُ الْفَرْقِ
u'طلب فَسْخٌ':Added, #3: 3	طَلَبُ الْفَرْقِ
u'طلب فَسْخٌ':Added, #2: 2	طَلَبُ الْفَسْخِ
u'طَلَبٌ فَسْخٌ':Added, #2: 2	طَلَبِ الْفَسْخِ
u'طَلَبٌ فَسْخٌ':Added, #2: 2	طَلَبُ الْفَسْخِ
u'طلب فَضَائِلُ':Added, #2: 2	طَلَبِ الْفَسْخِ
u'طَلَبٌ فَضَائِلُ':Added, #1: 1	طَلَبِ الْفَضَائِلِ
u'طَلَبَ فِعْلٌ':Predicate, #1: 1	طَلَبِ الْفَضَائِلِ
u'طلب فِعْلٌ':Added, #2: 2	طَلَبَ الْفِعْلَ
u'طَلَبٌ فِعْلٌ':Added, #10: 10	طَلَبِ الْفِعْلِ
u'طلب فِعْلٌ':Added, #10: 10	طَلَبِ الْفِعْلِ
u'طَلَبٌ فِعْلٌ':Added, #1: 1	طَلَبِ فِعْلٍ
u'طلب فِعْلٌ':Added, #1: 1	طَلَبِ فِعْلٍ
u'طَلَبٌ فِعْلٌ':Added, #1: 1	طَلَبُ فِعْلِهِ
u'طلب فِعْلٌ':Added, #1: 1	طَلَبُ فِعْلِهِ
u'طَلَبٌ فِعْلٌ':Added, #3: 3	طَلَبَ الْفِعْلِ
u'طلب فِعْلٌ':Added, #3: 3	طَلَبَ الْفِعْلِ
u'طَلَبٌ فِعْلٌ':Added, #3: 3	طَلَبِ فِعْلِ
u'طلب فِعْلٌ':Added, #3: 3	طَلَبِ فِعْلِ
u'طَلَبٌ فِعْلٌ':Added, #7: 7	طَلَبُ الْفِعْلِ
u'طلب فِعْلٌ':Added, #7: 7	طَلَبُ الْفِعْلِ
u'طَلَبٌ فِعْلٌ':Added, #8: 8	طَلَبُ فِعْلٍ
u'طلب فَكٌّ':Added, #8: 8	طَلَبُ فِعْلٍ
u'طَلَبٌ فَكٌّ':Added, #1: 1	طَلَبُ فَكِّهِ
u'طَلَبَ فلان':Subject, #1: 1	طَلَبُ فَكِّهِ
u'طلب فلان':Added, #1: 1	طَلَبَ الشَّافِعِيُّ
u'طَلَبٌ فلان':Added, #3: 3	طَلَبِ الشَّافِعِيِّ
u'طلب فَهْمٌ':Added, #3: 3	طَلَبِ الشَّافِعِيِّ
u'طَلَبٌ فَهْمٌ':Added, #1: 1	طَلَبُ الْفَهْمِ
u'طلب فَيْئَةٌ':Added, #1: 1	طَلَبُ الْفَهْمِ
u'طَلَبٌ فَيْئَةٌ':Added, #1: 1	طَلَبُ الْفَيْئَةِ
u'طلب فَيْئَةٌ':Added, #1: 1	طَلَبُ الْفَيْئَةِ
u'طَلَبٌ فَيْئَةٌ':Added, #2: 2	طَلَبَ الْفَيْئَةِ
u'طلب فَيْئَةٌ':Added, #2: 2	طَلَبَ الْفَيْئَةِ
u'طَلَبٌ فَيْئَةٌ':Added, #3: 3	طَلَبِ الْفَيْئَةِ
u'طلب قَاتِلٌ':Added, #3: 3	طَلَبِ الْفَيْئَةِ
u'طَلَبٌ قَاتِلٌ':Added, #1: 1	طَلَبِ الْقَاتِلِ
u'طلب قَاتِلٌ':Added, #1: 1	طَلَبِ الْقَاتِلِ
u'طَلَبٌ قَاتِلٌ':Added, #2: 2	طَلَبُ الْقَاتِلِ
u'طَلَبَ قتال':Predicate, #2: 2	طَلَبُ الْقَاتِلِ
u'طَلَبَ قِتَالٌ':Predicate, #1: 1	طَلَبَ الْقِتَالَ
u'طلب قَتْلٌ':Added, #1: 1	طَلَبَ الْقِتَالَ
u'طَلَبٌ قَتْلٌ':Added, #1: 1	طَلَبَ قَتْلٍ
u'طَلَبَ قَدْرٌ':Predicate, #1: 1	طَلَبَ قَتْلٍ
u'طلب قَدْرٌ':Added, #1: 1	طَلَبَ قَدْرَ
u'طَلَبٌ قَدْرٌ':Added, #1: 1	طَلَبِ قَدْرِ
u'طَلَبَ قُدُومٌ':Predicate, #1: 1	طَلَبِ قَدْرِ
u'طَلَبَ قَرْضٌ':Predicate, #1: 1	طَلَبَ قُدُومَ
u'طلب قَرْضٌ':Added, #1: 1	طَلَبَ الْقَرْضَ
u'طَلَبٌ قَرْضٌ':Added, #1: 1	طَلَبُ الْقَرْضِ
u'طَلَبَ قَسْمٌ':Predicate, #1: 1	طَلَبُ الْقَرْضِ
u'طلب قَسْمٌ':Added, #1: 1	طَلَبَ الْقَسْمَ
u'طلب قَسْمٌ':Added, #1: 1	طَلَبَ الْقَسْمِ
u'طَلَبٌ قَسْمٌ':Added, #1: 1	طَلَبِ الْقَسْمِ
u'طَلَبٌ قَسْمٌ':Added, #1: 1	طَلَبَ الْقَسْمِ
u'طَلَبَ قسمة':Predicate, #1: 1	طَلَبِ الْقَسْمِ
u'طَلَبَ قِسْمَةٌ':Predicate, #13: 13	طَلَبَ الْقِسْمَةَ
u'طَلَبَ قسمة':Predicate, #13: 13	طَلَبَ الْقِسْمَةَ
u'طَلَبَ قِسْمَةٌ':Predicate, #3: 3	طَلَبَ قِسْمَةَ
u'طلب قسمة':Added, #3: 3	طَلَبَ قِسْمَةَ
u'طَلَبٌ قسمة':Added, #5: 5	طَلَبُ الْقِسْمَةِ
u'طلب قِسْمَةٌ':Added, #5: 5	طَلَبُ الْقِسْمَةِ
u'طَلَبٌ قِسْمَةٌ':Added, #5: 5	طَلَبُ الْقِسْمَةِ
u'طلب قسمة':Added, #5: 5	طَلَبُ الْقِسْمَةِ
u'طَلَبٌ قسمة':Added, #7: 7	طَلَبِ الْقِسْمَةِ
u'طلب قِسْمَةٌ':Added, #7: 7	طَلَبِ الْقِسْمَةِ
u'طَلَبٌ قِسْمَةٌ':Added, #7: 7	طَلَبِ الْقِسْمَةِ
u'طَلَبَ قصاص':Predicate, #7: 7	طَلَبِ الْقِسْمَةِ
u'طَلَبَ قِصَاصٌ':Predicate, #2: 2	طَلَبَ الْقِصَاصَ
u'طلب قصاص':Added, #2: 2	طَلَبَ الْقِصَاصَ
u'طَلَبٌ قصاص':Added, #1: 1	طَلَبَ الْقِصَاصِ
u'طلب قِصَاصٌ':Added, #1: 1	طَلَبَ الْقِصَاصِ
u'طَلَبٌ قِصَاصٌ':Added, #1: 1	طَلَبَ الْقِصَاصِ
u'طلب قصاص':Added, #1: 1	طَلَبَ الْقِصَاصِ
u'طَلَبٌ قصاص':Added, #4: 4	طَلَبِ الْقِصَاصِ
u'طلب قِصَاصٌ':Added, #4: 4	طَلَبِ الْقِصَاصِ
u'طَلَبٌ قِصَاصٌ':Added, #4: 4	طَلَبِ الْقِصَاصِ
u'طلب قَصْدٌ':Added, #4: 4	طَلَبِ الْقِصَاصِ
u'طَلَبٌ قَصْدٌ':Added, #1: 1	طَلَبِ قَصْدِ
u'طَلَبَ قَضَاءٌ':Predicate, #1: 1	طَلَبِ قَصْدِ
u'طَلَبَ قَضَاءٌ':Predicate, #12: 12	طَلَبَ الْقَضَاءَ
u'طلب قَضَاءٌ':Added, #4: 4	طَلَبَ قَضَاءَ
u'طَلَبٌ قَضَاءٌ':Added, #1: 1	طَلَبُ الْقَضَاءِ
u'طلب قَضَاءٌ':Added, #1: 1	طَلَبُ الْقَضَاءِ
u'طَلَبٌ قَضَاءٌ':Added, #2: 2	طَلَبِ الْقَضَاءِ
u'طَلَبَ قَطْعٌ':Predicate, #2: 2	طَلَبِ الْقَضَاءِ
u'طلب قَطْعٌ':Added, #1: 1	طَلَبَ الْقَطْعَ
u'طَلَبٌ قَطْعٌ':Added, #1: 1	طَلَبُ قَطْعِ
u'طلب قَطْعٌ':Added, #1: 1	طَلَبُ قَطْعِ
u'طلب قَطْعٌ':Added, #2: 2	طَلَبَ الْقَطْعِ
u'طَلَبٌ قَطْعٌ':Added, #2: 2	طَلَبُ الْقَطْعِ
u'طَلَبٌ قَطْعٌ':Added, #2: 2	طَلَبَ الْقَطْعِ
u'طلب قِلاَدَةٌ':Added, #2: 2	طَلَبُ الْقَطْعِ
u'طَلَبٌ قِلاَدَةٌ':Added, #1: 1	طَلَبِ الْقِلَادَةِ
u'طَلَبَ قَمِيصٌ':Predicate, #1: 1	طَلَبِ الْقِلَادَةِ
u'طلب قُوَّةٌ':Added, #1: 1	طَلَبَ الْقَمِيصَ
u'طلب قُوَّة':Added, #1: 1	طَلَبَ قُوَّةٍ
u'طَلَبٌ قُوَّةٌ':Added, #1: 1	طَلَبَ قُوَّةٍ
u'طَلَبٌ قُوَّة':Added, #1: 1	طَلَبَ قُوَّةٍ
u'طلب قُوتٌ':Added, #1: 1	طَلَبَ قُوَّةٍ
u'طَلَبٌ قُوتٌ':Added, #1: 1	طَلَبُ الْقُوتِ
u'طَلَبَ قَوْمٌ':Subject, #1: 1	طَلَبُ الْقُوتِ
u'طلب قَوْمٌ':Added, #3: 3	طَلَبَ قَوْمٌ
u'طَلَبٌ قَوْمٌ':Added, #6: 6	طَلَبِ الْقَوْمِ
u'طلب قيام':Added, #6: 6	طَلَبِ الْقَوْمِ
u'طلب قيام':Added, #1: 1	طَلَبُ الْقِيَامِ
u'طلب قِيَامٌ':Added, #1: 1	طَلَبِ الْقِيَامِ
u'طلب قِيَامٌ':Added, #1: 1	طَلَبُ الْقِيَامِ
u'طَلَبٌ قيام':Added, #1: 1	طَلَبِ الْقِيَامِ
u'طَلَبٌ قيام':Added, #1: 1	طَلَبُ الْقِيَامِ
u'طَلَبٌ قِيَامٌ':Added, #1: 1	طَلَبِ الْقِيَامِ
u'طَلَبٌ قِيَامٌ':Added, #1: 1	طَلَبُ الْقِيَامِ
u'طَلَبَ قِيمَةٌ':Predicate, #1: 1	طَلَبِ الْقِيَامِ
u'طلب قِيمَةٌ':Added, #1: 1	طَلَبَ الْقِيمَةَ
u'طَلَبٌ قِيمَةٌ':Added, #1: 1	طَلَبِ الْقِيمَةِ
u'طلب قِيمَةٌ':Added, #1: 1	طَلَبِ الْقِيمَةِ
u'طَلَبٌ قِيمَةٌ':Added, #4: 4	طَلَبُ الْقِيمَةِ
u'طَلَبَ كَافِرٌ':Subject, #4: 4	طَلَبُ الْقِيمَةِ
u'طلب كُتُبٌ':Added, #1: 1	طَلَبَ الْكَافِرُ
u'طَلَبٌ كُتُبٌ':Added, #1: 1	طَلَبِ الْكُتُبِ
u'طلب كَثْرَةٌ':Added, #1: 1	طَلَبِ الْكُتُبِ
u'طَلَبٌ كَثْرَةٌ':Added, #1: 1	طَلَبِ الْكَثْرَةِ
u'طلب كَسْبٌ':Added, #1: 1	طَلَبِ الْكَثْرَةِ
u'طَلَبٌ كَسْبٌ':Added, #1: 1	طَلَبُ كَسْبِ
u'طلب كَفٌّ':Added, #1: 1	طَلَبُ كَسْبِ
u'طَلَبٌ كَفٌّ':Added, #1: 1	طَلَبَ الْكَفِّ
u'طلب كَفٌّ':Added, #1: 1	طَلَبَ الْكَفِّ
u'طَلَبٌ كَفٌّ':Added, #1: 1	طَلَبُ كَفٍّ
u'طلب كَفٌّ':Added, #1: 1	طَلَبُ كَفٍّ
u'طَلَبٌ كَفٌّ':Added, #2: 2	طَلَبِ الْكَفِّ
u'طلب كَفٌّ':Added, #2: 2	طَلَبِ الْكَفِّ
u'طَلَبٌ كَفٌّ':Added, #3: 3	طَلَبُ الْكَفِّ
u'طلب كَفَاءةٌ':Added, #3: 3	طَلَبُ الْكَفِّ
u'طَلَبٌ كَفَاءةٌ':Added, #2: 2	طَلَبِ الْكَفَاءَةِ
u'طلب كَفَاءةٌ':Added, #2: 2	طَلَبِ الْكَفَاءَةِ
u'طَلَبٌ كَفَاءةٌ':Added, #3: 3	طَلَبَ الْكَفَاءَةِ
u'طلب كَفَّارٌ':Added, #3: 3	طَلَبَ الْكَفَاءَةِ
u'طَلَبٌ كَفَّارٌ':Added, #1: 1	طَلَبَ الْكَفَّارَةِ
u'طلب كَفَّارٌ':Added, #1: 1	طَلَبَ الْكَفَّارَةِ
u'طَلَبٌ كَفَّارٌ':Added, #1: 1	طَلَبُ كَفَّارَةِ
u'طلب كَفَّارَةٌ':Added, #1: 1	طَلَبُ كَفَّارَةِ
u'طَلَبٌ كَفَّارَةٌ':Added, #1: 1	طَلَبَ الْكَفَّارَةِ
u'طلب كَفَّارَةٌ':Added, #1: 1	طَلَبَ الْكَفَّارَةِ
u'طلب كَفَّارَةٌ':Added, #1: 1	طَلَبُ كَفَّارَةٍ
u'طَلَبٌ كَفَّارَةٌ':Added, #1: 1	طَلَبُ كَفَّارَةِ
u'طَلَبٌ كَفَّارَةٌ':Added, #1: 1	طَلَبُ كَفَّارَةٍ
u'طلب كَفَالَةٌ':Added, #1: 1	طَلَبُ كَفَّارَةِ
u'طَلَبٌ كَفَالَةٌ':Added, #1: 1	طَلَبِ الْكَفَالَةِ
u'طَلَبَ كِفَايَةٌ':Predicate, #1: 1	طَلَبِ الْكَفَالَةِ
u'طلب كِفَايَةٌ':Added, #1: 1	طَلَبَ الْكِفَايَةَ
u'طَلَبٌ كِفَايَةٌ':Added, #1: 1	طَلَبِ الْكِفَايَةِ
u'طلب كِفَايَةٌ':Added, #1: 1	طَلَبِ الْكِفَايَةِ
u'طَلَبٌ كِفَايَةٌ':Added, #1: 1	طَلَبِ كِفَايَتِهِ
u'طلب كَفِيلٌ':Added, #1: 1	طَلَبِ كِفَايَتِهِ
u'طَلَبٌ كَفِيلٌ':Added, #1: 1	طَلَبَ الْكَفِيلِ
u'طلب كَفِيلٌ':Added, #1: 1	طَلَبَ الْكَفِيلِ
u'طَلَبٌ كَفِيلٌ':Added, #4: 4	طَلَبُ الْكَفِيلِ
u'طلب لَذَّةٌ':Added, #4: 4	طَلَبُ الْكَفِيلِ
u'طَلَبٌ لَذَّةٌ':Added, #1: 1	طَلَبَ اللَّذَّةِ
u'طَلَبَ لُصُوصٌ':Subject, #1: 1	طَلَبَ اللَّذَّةِ
u'طَلَبَ لِقَاءٌ':Predicate, #1: 1	طَلَبَ اللُّصُوصُ
u'طَلَبَ لَقِيطٌ':Subject, #1: 1	طَلَبَ لِقَاءَ
u'طلب لَيْلٌ':Added, #1: 1	طَلَبَ اللَّقِيطُ
u'طَلَبٌ لَيْلٌ':Added, #1: 1	طَلَبِ لَيْلَةِ
u'طَلَبَ مَاءٌ':Predicate, #1: 1	طَلَبِ لَيْلَةِ
u'طلب مَاءٌ':Added, #7: 7	طَلَبَ الْمَاءَ
u'طَلَبٌ مَاءٌ':Added, #10: 10	طَلَبِ الْمَاءِ
u'طلب مَاءٌ':Added, #10: 10	طَلَبِ الْمَاءِ
u'طَلَبٌ مَاءٌ':Added, #4: 4	طَلَبَ الْمَاءِ
u'طلب مَاءٌ':Added, #4: 4	طَلَبَ الْمَاءِ
u'طَلَبٌ مَاءٌ':Added, #9: 9	طَلَبُ الْمَاءِ
u'طَلَبَ مَالٌ':Predicate, #9: 9	طَلَبُ الْمَاءِ
u'طَلَبَ مَالٌ':Predicate, #1: 1	طَلَبَ الْمَالَ
u'طلب مَالٌ':Added, #1: 1	طَلَبَ مَالَ
u'طلب مَالٌ':Added, #1: 1	طَلَبُ مَالِهِ
u'طَلَبٌ مَالٌ':Added, #1: 1	طَلَبِ مَالِهِ
u'طَلَبٌ مَالٌ':Added, #1: 1	طَلَبُ مَالِهِ
u'طلب مَالٌ':Added, #1: 1	طَلَبِ مَالِهِ
u'طلب مَالٌ':Added, #2: 2	طَلَبُ الْمَالِ
u'طَلَبٌ مَالٌ':Added, #2: 2	طَلَبِ الْمَالِ
u'طَلَبٌ مَالٌ':Added, #2: 2	طَلَبُ الْمَالِ
u'طَلَبَ مَالِكٌ':Subject, #2: 2	طَلَبِ الْمَالِ
u'طَلَبَ مَالِكٌ':Subject, #1: 1	طَلَبَ مَالِكُ
u'طلب مَالِكٌ':Added, #5: 5	طَلَبَ الْمَالِكُ
u'طَلَبٌ مَالِكٌ':Added, #1: 1	طَلَبُ الْمَالِكِ
u'طلب مَالِكٌ':Added, #1: 1	طَلَبُ الْمَالِكِ
u'طَلَبٌ مَالِكٌ':Added, #3: 3	طَلَبِ مَالِكِهِ
u'طلب مَالِكٌ':Added, #3: 3	طَلَبِ مَالِكِهِ
u'طَلَبٌ مَالِكٌ':Added, #5: 5	طَلَبِ الْمَالِكِ
u'طلب مَأْمُورٌ':Added, #5: 5	طَلَبِ الْمَالِكِ
u'طلب مَأْمُورٌ':Added, #1: 1	طَلَبُ الْمَأْمُورِ
u'طَلَبٌ مَأْمُورٌ':Added, #1: 1	طَلَبِ الْمَأْمُورِ
u'طَلَبٌ مَأْمُورٌ':Added, #1: 1	طَلَبُ الْمَأْمُورِ
u'طلب مُبَاهَاةٌ':Added, #1: 1	طَلَبِ الْمَأْمُورِ
u'طَلَبٌ مُبَاهَاةٌ':Added, #1: 1	طَلَبَ الْمُبَاهَاةِ
u'طَلَبَ مَبِيعٌ':Predicate, #1: 1	طَلَبَ الْمُبَاهَاةِ
u'طلب مثل':Added, #1: 1	طَلَبَ الْمَبِيعَ
u'طَلَبٌ مثل':Added, #1: 1	طَلَبُ الْمِثْلِ
u'طلب مِثْلٌ':Added, #1: 1	طَلَبُ الْمِثْلِ
u'طَلَبٌ مِثْلٌ':Added, #1: 1	طَلَبُ الْمِثْلِ
u'طلب مثل':Added, #1: 1	طَلَبُ الْمِثْلِ
u'طَلَبٌ مثل':Added, #2: 2	طَلَبِ الْمِثْلِ
u'طلب مِثْلٌ':Added, #2: 2	طَلَبِ الْمِثْلِ
u'طَلَبٌ مِثْلٌ':Added, #2: 2	طَلَبِ الْمِثْلِ
u'طلب مَجَازٌ':Added, #2: 2	طَلَبِ الْمِثْلِ
u'طَلَبٌ مَجَازٌ':Added, #2: 2	طَلَبُ الْمَجَازِ
u'طَلَبَ مَجْرُوحٌ':Subject, #2: 2	طَلَبُ الْمَجَازِ
u'طلب مَجْهُولٌ':Added, #1: 1	طَلَبَ الْمَجْرُوحُ
u'طلب مَجْهُولٌ':Added, #1: 1	طَلَبُ الْمَجْهُولِ
u'طَلَبٌ مَجْهُولٌ':Added, #1: 1	طَلَبِ الْمَجْهُولِ
u'طَلَبٌ مَجْهُولٌ':Added, #1: 1	طَلَبُ الْمَجْهُولِ
u'طلب مُحَافَظَةٌ':Added, #1: 1	طَلَبِ الْمَجْهُولِ
u'طَلَبٌ مُحَافَظَةٌ':Added, #1: 1	طَلَبِ الْمُحَافَظَةِ
u'طَلَبَ مَحَامِدُ':Predicate, #1: 1	طَلَبِ الْمُحَافَظَةِ
u'طَلَبَ مَحْبُوسٌ':Subject, #1: 1	طَلَبَ مَحَامِدَ
u'طلب مُحْتَالٌ':Added, #1: 1	طَلَبَ الْمَحْبُوسُ
u'طَلَبٌ مُحْتَالٌ':Added, #1: 1	طَلَبُ الْمُحْتَالِ
u'طَلَبَ مَحْرُومٌ':Subject, #1: 1	طَلَبُ الْمُحْتَالِ
u'طَلَبَ مَحَلٌّ':Predicate, #1: 1	طَلَبَ الْمَحْرُومُ
u'طلب مُحِيل':Added, #1: 1	طَلَبَ مَحَلَّ
u'طَلَبٌ مُحِيل':Added, #1: 1	طَلَبُ الْمُحِيلِ
u'طلب مُخَالَفَةٌ':Added, #1: 1	طَلَبُ الْمُحِيلِ
u'طَلَبٌ مُخَالَفَةٌ':Added, #1: 1	طَلَبِ مُخَالَفَةِ
u'طَلَبَ مَدْيُونٌ':Subject, #1: 1	طَلَبِ مُخَالَفَةِ
u'طَلَبَ مُرْتَهِنٌ':Subject, #1: 1	طَلَبَ الْمَدْيُونُ
u'طَلَبَ مُرْتَهِنٌ':Subject, #1: 1	طَلَبَ مُرْتَهِنُ
u'طلب مَرْكَبٌ':Added, #7: 7	طَلَبَ الْمُرْتَهِنُ
u'طَلَبٌ مَرْكَبٌ':Added, #3: 3	طَلَبِ مَرْكَبٍ
u'طَلَبَ مُرِيدٌ':Subject, #3: 3	طَلَبِ مَرْكَبٍ
u'طلب مَزِيدٌ':Added, #1: 1	طَلَبَ مُرِيدُ
u'طَلَبٌ مَزِيدٌ':Added, #1: 1	طَلَبَ الْمَزِيدِ
u'طلب مُسَارَعَةٌ':Added, #1: 1	طَلَبَ الْمَزِيدِ
u'طَلَبٌ مُسَارَعَةٌ':Added, #1: 1	طَلَبُ الْمُسَارَعَةِ
u'طلب مُسْتَأْجِرٌ':Added, #1: 1	طَلَبُ الْمُسَارَعَةِ
u'طَلَبٌ مُسْتَأْجِرٌ':Added, #2: 2	طَلَبِ الْمُسْتَأْجِرِ
u'طَلَبَ مُسْتَحِقٌّ':Subject, #2: 2	طَلَبِ الْمُسْتَأْجِرِ
u'طلب مُسْتَحِقٌّ':Added, #1: 1	طَلَبَ الْمُسْتَحِقُّ
u'طلب مُسْتَحِقٌّ':Added, #1: 1	طَلَبُ الْمُسْتَحِقِّ
u'طَلَبٌ مُسْتَحِقٌّ':Added, #1: 1	طَلَبِ الْمُسْتَحِقِّ
u'طَلَبٌ مُسْتَحِقٌّ':Added, #1: 1	طَلَبُ الْمُسْتَحِقِّ
u'طلب مُسْتَحِقٌّ':Added, #1: 1	طَلَبِ الْمُسْتَحِقِّ
u'طَلَبٌ مُسْتَحِقٌّ':Added, #1: 1	طَلَبِ مُسْتَحِقِّهِ
u'طَلَبَ مُسْتَعِيرٌ':Subject, #1: 1	طَلَبِ مُسْتَحِقِّهِ
u'طَلَبَ مَسْرُوقٌ':Subject, #1: 1	طَلَبَ الْمُسْتَعِيرُ
u'طلب مَسْكَنٌ':Added, #1: 1	طَلَبَ الْمَسْرُوقُ
u'طَلَبٌ مَسْكَنٌ':Added, #3: 3	طَلَبِ مَسْكَنٍ
u'طَلَبَ مُشَارَكَةٌ':Predicate, #3: 3	طَلَبِ مَسْكَنٍ
u'طَلَبَ مَشْهُودٌ':Subject, #1: 1	طَلَبَ الْمُشَارَكَةَ
u'طَلَبَ مُصَالِحٌ':Subject, #2: 2	طَلَبَ الْمَشْهُودُ
u'طلب مَصْدَرٌ':Added, #1: 1	طَلَبَ الْمُصَالِحُ
u'طَلَبٌ مَصْدَرٌ':Added, #1: 1	طَلَبُ الْمَصْدَرِ
u'طَلَبَ مُضَارِبٌ':Subject, #1: 1	طَلَبُ الْمَصْدَرِ
u'طلب مَضْمَضَةٌ':Added, #1: 1	طَلَبَ مُضَارِبٌ
u'طَلَبٌ مَضْمَضَةٌ':Added, #1: 1	طَلَبِ الْمَضْمَضَةِ
u'طلب مُطَالَبٌ':Added, #1: 1	طَلَبِ الْمَضْمَضَةِ
u'طَلَبٌ مُطَالَبٌ':Added, #1: 1	طَلَبِ الْمُطَالَبَةِ
u'طلب مُطَالَبَةٌ':Added, #1: 1	طَلَبِ الْمُطَالَبَةِ
u'طَلَبٌ مُطَالَبَةٌ':Added, #1: 1	طَلَبِ الْمُطَالَبَةِ
u'طلب مُطْلَقٌ':Added, #1: 1	طَلَبِ الْمُطَالَبَةِ
u'طَلَبٌ مُطْلَقٌ':Added, #1: 1	طَلَبُ الْمُطْلَقِ
u'طَلَبَ مَطْلُوبٌ':Subject, #1: 1	طَلَبُ الْمُطْلَقِ
u'طلب مَعَاشٌ':Added, #1: 1	طَلَبَ الْمَطْلُوبُ
u'طلب مَعَاشٌ':Added, #1: 1	طَلَبُ الْمَعَاشِ
u'طَلَبٌ مَعَاشٌ':Added, #1: 1	طَلَبِ الْمَعَاشِ
u'طَلَبٌ مَعَاشٌ':Added, #1: 1	طَلَبُ الْمَعَاشِ
u'طلب مَعْرِفَةٌ':Added, #1: 1	طَلَبِ الْمَعَاشِ
u'طلب مَعْرِفَة':Added, #4: 4	طَلَبُ مَعْرِفَةِ
u'طَلَبٌ مَعْرِفَةٌ':Added, #4: 4	طَلَبُ مَعْرِفَةِ
u'طَلَبٌ مَعْرِفَة':Added, #4: 4	طَلَبُ مَعْرِفَةِ
u'طلب مَعُونَةٌ':Added, #4: 4	طَلَبُ مَعْرِفَةِ
u'طَلَبٌ مَعُونَةٌ':Added, #1: 1	طَلَبِ الْمَعُونَةِ
u'طَلَبَ مُعِير':Subject, #1: 1	طَلَبِ الْمَعُونَةِ
u'طلب مَعِيشَةٌ':Added, #1: 1	طَلَبَ الْمُعِيرُ
u'طَلَبٌ مَعِيشَةٌ':Added, #2: 2	طَلَبِ الْمَعِيشَةِ
u'طلب مَغْفِرَةٌ':Added, #2: 2	طَلَبِ الْمَعِيشَةِ
u'طَلَبٌ مَغْفِرَةٌ':Added, #1: 1	طَلَبُ مَغْفِرَتِهِ
u'طلب مَغْفِرَةٌ':Added, #1: 1	طَلَبُ مَغْفِرَتِهِ
u'طلب مَغْفِرَةٌ':Added, #2: 2	طَلَبُ الْمَغْفِرَةِ
u'طَلَبٌ مَغْفِرَةٌ':Added, #2: 2	طَلَبِ الْمَغْفِرَةِ
u'طَلَبٌ مَغْفِرَةٌ':Added, #2: 2	طَلَبُ الْمَغْفِرَةِ
u'طلب مِفْتَاحٌ':Added, #2: 2	طَلَبِ الْمَغْفِرَةِ
u'طَلَبٌ مِفْتَاحٌ':Added, #2: 2	طَلَبِ الْمِفْتَاحِ
u'طَلَبَ مُفْلِسٌ':Subject, #2: 2	طَلَبِ الْمِفْتَاحِ
u'طلب مُفْلِسٌ':Added, #2: 2	طَلَبَ الْمُفْلِسُ
u'طَلَبٌ مُفْلِسٌ':Added, #1: 1	طَلَبِ الْمُفْلِسِ
u'طَلَبَ مَفْهُومٌ':Predicate, #1: 1	طَلَبِ الْمُفْلِسِ
u'طلب مُقَابَلٌ':Added, #1: 1	طَلَبَ الْمَفْهُومَ
u'طَلَبٌ مُقَابَلٌ':Added, #1: 1	طَلَبَ الْمُقَابَلَةِ
u'طلب مُقَابَلَةٌ':Added, #1: 1	طَلَبَ الْمُقَابَلَةِ
u'طَلَبٌ مُقَابَلَةٌ':Added, #1: 1	طَلَبَ الْمُقَابَلَةِ
u'طَلَبَ مُقاسَمَة':Predicate, #1: 1	طَلَبَ الْمُقَابَلَةِ
u'طَلَبَ مَقْذُوفٌ':Subject, #1: 1	طَلَبَ مُقَاسَمَةَ
u'طلب مَقْذُوفٌ':Added, #1: 1	طَلَبَ الْمَقْذُوفُ
u'طَلَبٌ مَقْذُوفٌ':Added, #1: 1	طَلَبِ الْمَقْذُوفِ
u'طَلَبَ مُقْرِضٌ':Subject, #1: 1	طَلَبِ الْمَقْذُوفِ
u'طلب مَقْصُودٌ':Added, #1: 1	طَلَبَ الْمُقْرِضُ
u'طَلَبٌ مَقْصُودٌ':Added, #1: 1	طَلَبِ الْمَقْصُودِ
u'طَلَبَ مَقْطُوعٌ':Subject, #1: 1	طَلَبِ الْمَقْصُودِ
u'طلب مُقَلِّدٌ':Added, #1: 1	طَلَبَ الْمَقْطُوعُ
u'طَلَبٌ مُقَلِّدٌ':Added, #1: 1	طَلَبِ الْمُقَلِّدِ
u'طلب مُكْرِهٌ':Added, #1: 1	طَلَبِ الْمُقَلِّدِ
u'طَلَبٌ مُكْرِهٌ':Added, #2: 2	طَلَبُ مُكْرِهِهِ
u'طلب مَكْسٌ':Added, #2: 2	طَلَبُ مُكْرِهِهِ
u'طَلَبٌ مَكْسٌ':Added, #1: 1	طَلَبِ الْمَكْسِ
u'طلب مَكْفُولٌ':Added, #1: 1	طَلَبِ الْمَكْسِ
u'طَلَبٌ مَكْفُولٌ':Added, #1: 1	طَلَبِ الْمَكْفُولِ
u'طَلَبَ مَلِكٌ':Subject, #1: 1	طَلَبِ الْمَكْفُولِ
u'طلب مُنَاسَبَةٌ':Added, #1: 1	طَلَبَ مَلِكٌ
u'طَلَبٌ مُنَاسَبَةٌ':Added, #1: 1	طَلَبِ الْمُنَاسَبَةِ
u'طلب مَنَاطٌ':Added, #1: 1	طَلَبِ الْمُنَاسَبَةِ
u'طَلَبٌ مَنَاطٌ':Added, #1: 1	طَلَبِ مَنَاطٍ
u'طلب مَنْزِلٌ':Added, #1: 1	طَلَبِ مَنَاطٍ
u'طَلَبٌ مَنْزِلٌ':Added, #1: 1	طَلَبَ الْمَنْزِلِ
u'طلب مَنْزِلٌ':Added, #1: 1	طَلَبَ الْمَنْزِلِ
u'طَلَبٌ مَنْزِلٌ':Added, #2: 2	طَلَبِ مَنْزِلٍ
u'طلب مَنْزِلَةٌ':Added, #2: 2	طَلَبِ مَنْزِلٍ
u'طلب مَنْزِلَةٌ':Added, #2: 2	طَلَبَ الْمَنْزِلَةِ
u'طَلَبٌ مَنْزِلَةٌ':Added, #2: 2	طَلَبُ الْمَنْزِلَةِ
u'طَلَبٌ مَنْزِلَةٌ':Added, #2: 2	طَلَبَ الْمَنْزِلَةِ
u'طلب مَهْرٌ':Added, #2: 2	طَلَبُ الْمَنْزِلَةِ
u'طَلَبٌ مَهْرٌ':Added, #1: 1	طَلَبُ الْمَهْرِ
u'طلب مَهْرٌ':Added, #1: 1	طَلَبُ الْمَهْرِ
u'طَلَبٌ مَهْرٌ':Added, #3: 3	طَلَبِ الْمَهْرِ
u'طَلَبَ مُهْلَةٌ':Predicate, #3: 3	طَلَبِ الْمَهْرِ
u'طلب مُهْلَةٌ':Added, #4: 4	طَلَبَ الْمُهْلَةَ
u'طَلَبٌ مُهْلَةٌ':Added, #1: 1	طَلَبُ الْمُهْلَةِ
u'طلب مَوْتٌ':Added, #1: 1	طَلَبُ الْمُهْلَةِ
u'طَلَبٌ مَوْتٌ':Added, #1: 1	طَلَبُ الْمَوْتِ
u'طلب مُؤَجِّرٌ':Added, #1: 1	طَلَبُ الْمَوْتِ
u'طَلَبٌ مُؤَجِّرٌ':Added, #1: 1	طَلَبُ الْمُؤَجِّرِ
u'طَلَبَ مَوَدَّةٌ':Predicate, #1: 1	طَلَبُ الْمُؤَجِّرِ
u'طلب مَوَدَّةٌ':Added, #1: 1	طَلَبَ مَوَدَّةَ
u'طَلَبٌ مَوَدَّةٌ':Added, #1: 1	طَلَبِ الْمَوَدَّةِ
u'طَلَبَ مُودِعٌ':Subject, #1: 1	طَلَبِ الْمَوَدَّةِ
u'طلب مُودِعٌ':Added, #1: 1	طَلَبَ الْمُودِعُ
u'طَلَبٌ مُودِعٌ':Added, #1: 1	طَلَبِ الْمُودِعِ
u'طَلَبَ مُوَكِّلٌ':Subject, #1: 1	طَلَبِ الْمُودِعِ
u'طلب نَبِيٌّ':Added, #1: 1	طَلَبَ الْمُوَكِّلُ
u'طَلَبٌ نَبِيٌّ':Added, #1: 1	طَلَبُ النَّبِيِّ
u'طَلَبَ نجاة':Predicate, #1: 1	طَلَبُ النَّبِيِّ
u'طَلَبَ نَجَاةٌ':Predicate, #1: 1	طَلَبَ النَّجَاةَ
u'طلب نَجْوٌ':Added, #1: 1	طَلَبَ النَّجَاةَ
u'طَلَبٌ نَجْوٌ':Added, #1: 1	طَلَبُ النَّجْوِ
u'طلب نَحْوٌ':Added, #1: 1	طَلَبُ النَّجْوِ
u'طلب نَحْوٌ':Added, #1: 1	طَلَبُ نَحْوِ
u'طَلَبٌ نَحْوٌ':Added, #1: 1	طَلَبِ نَحْوِ
u'طَلَبٌ نَحْوٌ':Added, #1: 1	طَلَبُ نَحْوِ
u'طلب نذر':Added, #1: 1	طَلَبِ نَحْوِ
u'طَلَبٌ نذر':Added, #3: 3	طَلَبُ النَّذْرِ
u'طلب نَذْرٌ':Added, #3: 3	طَلَبُ النَّذْرِ
u'طَلَبٌ نَذْرٌ':Added, #3: 3	طَلَبُ النَّذْرِ
u'طلب نَسَبٌ':Added, #3: 3	طَلَبُ النَّذْرِ
u'طَلَبٌ نَسَبٌ':Added, #1: 1	طَلَبِ نَسَبِ
u'طَلَبَ نَصٌّ':Predicate, #1: 1	طَلَبِ نَسَبِ
u'طلب نَصٌّ':Added, #1: 1	طَلَبَ النَّصَّ
u'طَلَبٌ نَصٌّ':Added, #1: 1	طَلَبِ النَّصِّ
u'طلب نصب':Added, #1: 1	طَلَبِ النَّصِّ
u'طَلَبٌ نصب':Added, #1: 1	طَلَبُ نَصْبِ
u'طلب نَصْبٌ':Added, #1: 1	طَلَبُ نَصْبِ
u'طَلَبٌ نَصْبٌ':Added, #1: 1	طَلَبُ نَصْبِ
u'طَلَبَ نِصْفٌ':Predicate, #1: 1	طَلَبُ نَصْبِ
u'طَلَبَ نِصْفٌ':Predicate, #1: 1	طَلَبَ نِصْفَ
u'طلب نَصِيبٌ':Added, #4: 4	طَلَبَ النِّصْفَ
u'طَلَبٌ نَصِيبٌ':Added, #1: 1	طَلَبَ نَصِيبِهِ
u'طلب نَفْسٌ':Added, #1: 1	طَلَبَ نَصِيبِهِ
u'طَلَبٌ نَفْسٌ':Added, #1: 1	طَلَبُ النَّفْسِ
u'طلب نَفْسٌ':Added, #1: 1	طَلَبُ النَّفْسِ
u'طَلَبٌ نَفْسٌ':Added, #2: 2	طَلَبِ النَّفْسِ
u'طلب نَفَقَةٌ':Added, #2: 2	طَلَبِ النَّفْسِ
u'طَلَبٌ نَفَقَةٌ':Added, #1: 1	طَلَبُ النَّفَقَةِ
u'طلب نَفَقَةٌ':Added, #1: 1	طَلَبُ النَّفَقَةِ
u'طَلَبٌ نَفَقَةٌ':Added, #1: 1	طَلَبِ نَفَقَةٍ
u'طلب نَفَقَةٌ':Added, #1: 1	طَلَبِ نَفَقَةٍ
u'طَلَبٌ نَفَقَةٌ':Added, #2: 2	طَلَبِ النَّفَقَةِ
u'طلب نَفْيٌ':Added, #2: 2	طَلَبِ النَّفَقَةِ
u'طلب نَفْيٌ':Added, #1: 1	طَلَبُ نَفْيٍ
u'طَلَبٌ نَفْيٌ':Added, #1: 1	طَلَبُ نَفْيِ
u'طَلَبٌ نَفْيٌ':Added, #1: 1	طَلَبُ نَفْيٍ
u'طلب نُقْصَانٌ':Added, #1: 1	طَلَبُ نَفْيِ
u'طَلَبٌ نُقْصَانٌ':Added, #1: 1	طَلَبُ نُقْصَانِ
u'طلب نَقْضٌ':Added, #1: 1	طَلَبُ نُقْصَانِ
u'طَلَبٌ نَقْضٌ':Added, #1: 1	طَلَبُ النَّقْضِ
u'طلب نقل':Added, #1: 1	طَلَبُ النَّقْضِ
u'طَلَبٌ نقل':Added, #1: 1	طَلَبُ نَقْلِهِ
u'طلب نَقْلٌ':Added, #1: 1	طَلَبُ نَقْلِهِ
u'طَلَبٌ نَقْلٌ':Added, #1: 1	طَلَبُ نَقْلِهِ
u'طلب نقلة':Added, #1: 1	طَلَبُ نَقْلِهِ
u'طَلَبٌ نقلة':Added, #1: 1	طَلَبُ النَّقْلَةِ
u'طلب نقلة':Added, #1: 1	طَلَبُ النَّقْلَةِ
u'طَلَبٌ نقلة':Added, #1: 1	طَلَبُ نَقْلَةٍ
u'طلب نكاح':Added, #1: 1	طَلَبُ نَقْلَةٍ
u'طلب نكاح':Added, #1: 1	طَلَبُ النِّكَاحِ
u'طَلَبٌ نكاح':Added, #1: 1	طَلَبِ النِّكَاحِ
u'طَلَبٌ نكاح':Added, #1: 1	طَلَبُ النِّكَاحِ
u'طلب نِكَاحٌ':Added, #1: 1	طَلَبِ النِّكَاحِ
u'طلب نِكَاحٌ':Added, #1: 1	طَلَبُ النِّكَاحِ
u'طَلَبٌ نِكَاحٌ':Added, #1: 1	طَلَبِ النِّكَاحِ
u'طَلَبٌ نِكَاحٌ':Added, #1: 1	طَلَبُ النِّكَاحِ
u'طلب نكاح':Added, #1: 1	طَلَبِ النِّكَاحِ
u'طَلَبٌ نكاح':Added, #1: 1	طَلَبِ نِكَاحِ
u'طلب نِكَاحٌ':Added, #1: 1	طَلَبِ نِكَاحِ
u'طَلَبٌ نِكَاحٌ':Added, #1: 1	طَلَبِ نِكَاحِ
u'طلب نَمَاءٌ':Added, #1: 1	طَلَبِ نِكَاحِ
u'طَلَبٌ نَمَاءٌ':Added, #1: 1	طَلَبُ النَّمَاءِ
u'طلب نَمَاءٌ':Added, #1: 1	طَلَبُ النَّمَاءِ
u'طَلَبٌ نَمَاءٌ':Added, #2: 2	طَلَبِ النَّمَاءِ
u'طلب نُهُوضٌ':Added, #2: 2	طَلَبِ النَّمَاءِ
u'طَلَبٌ نُهُوضٌ':Added, #1: 1	طَلَبُ النُّهُوضِ
u'طلب نَهْيٌ':Added, #1: 1	طَلَبُ النُّهُوضِ
u'طَلَبٌ نَهْيٌ':Added, #1: 1	طَلَبُ النَّهْيِ
u'طَلَبَ نَيْلٌ':Predicate, #1: 1	طَلَبُ النَّهْيِ
u'طَلَبَ هِبَةٌ':Predicate, #1: 1	طَلَبَ نَيْلَ
u'طلب هلاك':Added, #1: 1	طَلَبَ الْهِبَةَ
u'طَلَبٌ هلاك':Added, #1: 1	طَلَبُ هَلَاكِهِ
u'طلب هَلاَكٌ':Added, #1: 1	طَلَبُ هَلَاكِهِ
u'طَلَبٌ هَلاَكٌ':Added, #1: 1	طَلَبُ هَلَاكِهِ
u'طلب هِلاَلٌ':Added, #1: 1	طَلَبُ هَلَاكِهِ
u'طلب هِلاَلٌ':Added, #1: 1	طَلَبَ الْهِلَالِ
u'طَلَبٌ هِلاَلٌ':Added, #1: 1	طَلَبِ الْهِلَالِ
u'طَلَبٌ هِلاَلٌ':Added, #1: 1	طَلَبَ الْهِلَالِ
u'طَلَبَ واحد':Subject, #1: 1	طَلَبِ الْهِلَالِ
u'طَلَبَ وَاحِدٌ':Subject, #2: 2	طَلَبَ وَاحِدٌ
u'طَلَبَ وَارِثٌ':Subject, #2: 2	طَلَبَ وَاحِدٌ
u'طلب وَارِثٌ':Added, #1: 1	طَلَبَ الْوَارِثُ
u'طَلَبٌ وَارِثٌ':Added, #2: 2	طَلَبُ الْوَارِثِ
u'طَلَبَ وَاطِئٌ':Subject, #2: 2	طَلَبُ الْوَارِثِ
u'طَلَبَ وَالِدٌ':Subject, #1: 1	طَلَبَ الْوَاطِئُ
u'طَلَبَ وَاهِبٌ':Subject, #1: 1	طَلَبَ الْوَالِدُ
u'طَلَبَ وَجَبٌ':Predicate, #2: 2	طَلَبَ الْوَاهِبُ
u'طلب وَجْهٌ':Added, #1: 1	طَلَبَ وَجَبَ
u'طلب وَجْهٌ':Added, #1: 1	طَلَبُ وَجْهِ
u'طَلَبٌ وَجْهٌ':Added, #1: 1	طَلَبِ وَجْهِ
u'طَلَبٌ وَجْهٌ':Added, #1: 1	طَلَبُ وَجْهِ
u'طَلَبَ وَدِيعٌ':Predicate, #1: 1	طَلَبِ وَجْهِ
u'طلب وَدِيعٌ':Added, #8: 8	طَلَبَ الْوَدِيعَةَ
u'طَلَبٌ وَدِيعٌ':Added, #2: 2	طَلَبِ الْوَدِيعَةِ
u'طَلَبَ وَدِيعَةٌ':Predicate, #2: 2	طَلَبِ الْوَدِيعَةِ
u'طلب وَدِيعَةٌ':Added, #8: 8	طَلَبَ الْوَدِيعَةَ
u'طَلَبٌ وَدِيعَةٌ':Added, #2: 2	طَلَبِ الْوَدِيعَةِ
u'طَلَبَ وَرَثَةٌ':Subject, #2: 2	طَلَبِ الْوَدِيعَةِ
u'طَلَبَ وَرَثَةٌ':Subject, #1: 1	طَلَبَ الْوَرَثَةُ
u'طلب وَرَثَةٌ':Added, #1: 1	طَلَبَ وَرَثَةُ
u'طَلَبٌ وَرَثَةٌ':Added, #1: 1	طَلَبُ الْوَرَثَةِ
u'طَلَبَ وَزْنٌ':Predicate, #1: 1	طَلَبُ الْوَرَثَةِ
u'طلب وَسَطٌ':Added, #2: 2	طَلَبَ الْوَزْنَ
u'طَلَبٌ وَسَطٌ':Added, #1: 1	طَلَبِ وَسَطٍ
u'طلب وَسِيلَةٌ':Added, #1: 1	طَلَبِ وَسَطٍ
u'طَلَبٌ وَسِيلَةٌ':Added, #1: 1	طَلَبِ الْوَسِيلَةِ
u'طلب وَصِيٌّ':Added, #1: 1	طَلَبِ الْوَسِيلَةِ
u'طَلَبٌ وَصِيٌّ':Added, #2: 2	طَلَبِ الْوَصِيِّ
u'طلب وَطْءٌ':Added, #2: 2	طَلَبِ الْوَصِيِّ
u'طَلَبٌ وَطْءٌ':Added, #1: 1	طَلَبَ الْوَطْءِ
u'طلب وَفَاءٌ':Added, #1: 1	طَلَبَ الْوَطْءِ
u'طَلَبٌ وَفَاءٌ':Added, #1: 1	طَلَبُ الْوَفَاءِ
u'طَلَبَ وَكِيلٌ':Subject, #1: 1	طَلَبُ الْوَفَاءِ
u'طلب وَكِيلٌ':Added, #1: 1	طَلَبَ وَكِيلُ
u'طَلَبٌ وَكِيلٌ':Added, #1: 1	طَلَبِ الْوَكِيلِ
u'طلب وِلاَيَةٌ':Added, #1: 1	طَلَبِ الْوَكِيلِ
u'طَلَبٌ وِلاَيَةٌ':Added, #1: 1	طَلَبَ الْوِلَايَةِ
u'طَلَبَ ولد':Predicate, #1: 1	طَلَبَ الْوِلَايَةِ
u'طَلَبَ وَلَدٌ':Predicate, #1: 1	طَلَبَ الْوَلَدَ
u'طَلَبَ ولد':Subject, #1: 1	طَلَبَ الْوَلَدَ
u'طَلَبَ وَلَدٌ':Subject, #1: 1	طَلَبَ وَلَدُ
u'طلب ولد':Added, #1: 1	طَلَبَ وَلَدُ
u'طَلَبٌ ولد':Added, #1: 1	طَلَبَ الْوَلَدِ
u'طلب وَلَدٌ':Added, #1: 1	طَلَبَ الْوَلَدِ
u'طَلَبٌ وَلَدٌ':Added, #1: 1	طَلَبَ الْوَلَدِ
u'طلب ولد':Added, #1: 1	طَلَبَ الْوَلَدِ
u'طَلَبٌ ولد':Added, #1: 1	طَلَبُ وَلَدِ
u'طلب وَلَدٌ':Added, #1: 1	طَلَبُ وَلَدِ
u'طَلَبٌ وَلَدٌ':Added, #1: 1	طَلَبُ وَلَدِ
u'طلب ولد':Added, #1: 1	طَلَبُ وَلَدِ
u'طَلَبٌ ولد':Added, #4: 4	طَلَبُ الْوَلَدِ
u'طلب وَلَدٌ':Added, #4: 4	طَلَبُ الْوَلَدِ
u'طَلَبٌ وَلَدٌ':Added, #4: 4	طَلَبُ الْوَلَدِ
u'طلب ولد':Added, #4: 4	طَلَبُ الْوَلَدِ
u'طَلَبٌ ولد':Added, #5: 5	طَلَبِ الْوَلَدِ
u'طلب وَلَدٌ':Added, #5: 5	طَلَبِ الْوَلَدِ
u'طَلَبٌ وَلَدٌ':Added, #5: 5	طَلَبِ الْوَلَدِ
u'طَلَبَ وَلِيٌّ':Subject, #5: 5	طَلَبِ الْوَلَدِ
u'طلب وَلِيٌّ':Added, #2: 2	طَلَبَ الْوَلِيُّ
u'طَلَبٌ وَلِيٌّ':Added, #1: 1	طَلَبِ الْوَلِيِّ
u'طلب وَلِيٌّ':Added, #1: 1	طَلَبِ الْوَلِيِّ
u'طَلَبٌ وَلِيٌّ':Added, #2: 2	طَلَبَ الْوَلِيِّ
u'طلب وَلِيٌّ':Added, #2: 2	طَلَبَ الْوَلِيِّ
u'طَلَبٌ وَلِيٌّ':Added, #3: 3	طَلَبُ الْوَلِيِّ
u'طَلَبَ يَسِيرٌ':Predicate, #3: 3	طَلَبُ الْوَلِيِّ
u'طلب يَسِيرٌ':Added, #1: 1	طَلَبَ الْيَسِيرَ
u'طَلَبٌ يَسِيرٌ':Added, #1: 1	طَلَبُ الْيَسِيرِ
u'طلب يَقِينٌ':Added, #1: 1	طَلَبُ الْيَسِيرِ
u'طَلَبٌ يَقِينٌ':Added, #1: 1	طَلَبِ الْيَقِينِ
u'طَلَبَ يَمِينٌ':Predicate, #1: 1	طَلَبِ الْيَقِينِ
u'طَلَبَ يَمِينٌ':Predicate, #1: 1	طَلَبَ الْيَمِينَ
u'طلب يَمِينٌ':Added, #7: 7	طَلَبَ يَمِينَ
u'طَلَبٌ يَمِينٌ':Added, #1: 1	طَلَبِ الْيَمِينِ
u'طلب يَمِينٌ':Added, #1: 1	طَلَبِ الْيَمِينِ
u'طَلَبٌ يَمِينٌ':Added, #1: 1	طَلَبُ يَمِينِ
u'طلب يَمِينٌ':Added, #1: 1	طَلَبُ يَمِينِ
u'طَلَبٌ يَمِينٌ':Added, #2: 2	طَلَبَ يَمِينِ
u'طلب يهود':Added, #2: 2	طَلَبَ يَمِينِ
u'طلب يَهُودٌ':Added, #1: 1	طَلَبِ الْيَهُودِ
u'طَلَبٌ يهود':Added, #1: 1	طَلَبِ الْيَهُودِ
u'طَلَبٌ يَهُودٌ':Added, #1: 1	طَلَبِ الْيَهُودِ
u'طَلَّ دَمٌ':Subject, #1: 1	طَلَبِ الْيَهُودِ
u'طَلَعَ أَخْضَر':Predicate, #1: 1	طَلَّ دَمُهُ
u'طَلَعَ إمَامٌ':Predicate, #1: 1	طَلَعَ أَخْضَرَ
u'طلعة بَدْرٌ':Added, #1: 1	أَطْلَعَ الْإِمَامَ
u'طَلْعَةٌ بَدْرٌ':Added, #1: 1	طَلْعَةِ الْبَدْرِ
u'طلعة ذَكَرٌ':Added, #1: 1	طَلْعَةِ الْبَدْرِ
u'طَلْعَةٌ ذَكَرٌ':Added, #2: 2	طَلْعَةِ ذَكَرٍ
u'طلعة ذَكَرٌ':Added, #2: 2	طَلْعَةِ ذَكَرٍ
u'طَلْعَةٌ ذَكَرٌ':Added, #3: 3	طَلْعَةٍ ذَكَرٍ
u'طَلَعَ ثَمَرٌ':Subject, #3: 3	طَلْعَةٍ ذَكَرٍ
u'طَلَعَ حاجِبٌ':Subject, #1: 1	طَلَعَ الثَّمَرُ
u'طَلَعَ دُخَانٌ':Subject, #3: 3	طَلَعَ حَاجِبُ
u'طَلَعَ ذكر':Predicate, #1: 1	طَلَعَ الدُّخَانُ
u'طَلَعَ ذَكَرٌ':Predicate, #1: 1	طَلَعَ ذَكَرَ
u'طَلَعَ رَجُلٌ':Subject, #1: 1	طَلَعَ ذَكَرَ
u'طَلَعَ رَجُلٌ':Subject, #1: 1	طَلَعَ الرّجُلُ
u'طَلَعَ رَجُلٌ':Subject, #1: 1	طَلَعَ الرَّجُلُ
u'طَلَعَ رَسُولٌ':Subject, #3: 3	طَلَعَ رَجُلٌ
u'طَلَعَ رَكْبٌ':Subject, #1: 1	طَلَعَ رَسُولُ
u'طَلَعَ سَدٌّ':Subject, #1: 1	طَلَعَ رَكْبٌ
u'طَلَعَ سُهَيْلٌ':Subject, #1: 1	طَلَعَ السَّدُّ
u'طَلَعَ شمس':Subject, #1: 1	طَلَعَ سُهَيْلٌ
u'طَلَعَ شَمْسٌ':Subject, #1: 1	طَلَعَ الشَّمْسُ
u'طَلَعَ شمس':Subject, #1: 1	طَلَعَ الشَّمْسُ
u'طَلَعَ شَمْسٌ':Subject, #2: 2	طَلَعَ الشّمْسُ
u'طَلَعَ عَبْدٌ':Subject, #2: 2	طَلَعَ الشّمْسُ
u'طَلَعَ عُمَرٌ':Subject, #1: 1	طَلَعَ عَبْدُ
u'طَلَعَ فَارِسٌ':Subject, #1: 1	طَلَعَ عُمَرُ
u'طَلَعَ فَجْرٌ':Subject, #1: 1	طَلَعَ فَارِسٌ
u'طَلَعَ فَجْرٌ':Subject, #135: 135	طَلَعَ الْفَجْرُ
u'طَلَعَ فَجْرٌ':Subject, #1: 1	طَلَعَ فَجْرٌ
u'طَلَعَ فلان':Subject, #1: 1	طَلَعَ فَجْرُ
u'طَلَعَ قَرْنٌ':Subject, #1: 1	طَلَعَ الزّبَيْرُ
u'طَلَعَ قمر':Subject, #2: 2	طَلَعَ قَرْنُ
u'طَلَعَ قَمَرٌ':Subject, #2: 2	طَلَعَ الْقَمَرُ
u'طَلَعَ لَيْلٌ':Predicate, #2: 2	طَلَعَ الْقَمَرُ
u'طَلَعَ مِنْبَرٌ':Predicate, #1: 1	طَلَعَ اللّيْلَةَ
u'طَلَعَ نَجْمٌ':Subject, #3: 3	طَلَعَ الْمِنْبَرَ
u'طَلَعَ نَجْمٌ':Subject, #1: 1	طَلَعَ النَّجْمُ
u'طَلَعَ وَجَبٌ':Predicate, #1: 1	طَلَعَ نَجْمُ
u'طَلَّقَ اِبْنٌ':Subject, #1: 1	طَلَعَ وَجَبَ
u'طَلَّقَ اِبْنٌ':Subject, #1: 1	طَلَّقَ ابْنُهُ
u'طَلَّقَ اِبْنَة':Predicate, #7: 7	طَلَّقَ ابْنُ
u'طَلِقَ أُجْرَةٌ':Predicate, #2: 2	طَلَّقَ ابْنَةَ
u'طَلَّقَ أَجْنَبِيٌّ':Subject, #1: 1	أَطْلَقَ الْأُجْرَةَ
u'طَلِقَ إِحْرَامٌ':Predicate, #1: 1	طَلَّقَ الْأَجْنَبِيُّ
u'طَلَّقَ أخرَس':Subject, #2: 2	أَطْلَقَ الْإِحْرَامَ
u'طَلَّقَ أَخِيرٌ':Predicate, #2: 2	طَلَّقَ الْأَخْرَسُ
u'طَلِقَ أَدَاءٌ':Predicate, #1: 1	طَلَّقَ الْأَخِيرَةَ
u'طَلِقَ إِذْنٌ':Predicate, #1: 1	أَطْلَقَ الْأَدَاءَ
u'طَلِقَ إِرَادَةٌ':Predicate, #2: 2	أَطْلَقَ الْإِذْنَ
u'طَلَّقَ أَرْبَعُ':Predicate, #1: 1	أَطْلَقَ الْإِرَادَةَ
u'طَلَّقَ أَرْبَعُ':Predicate, #1: 1	طَلَّقَ الْأَرْبَعَ
u'طَلِقَ أَرْبَعَةٌ':Predicate, #2: 2	طَلَّقَ أَرْبَعَ
u'طَلِقَ إِسْلامِيُّ':Predicate, #2: 2	أَطْلَقَ أَرْبَعَةَ
u'طَلِقَ اِسْمٌ':Predicate, #1: 1	أَطْلَقَ الْإِسْلَامِيَّ
u'طَلِقَ اِشْتِراطٌ':Predicate, #18: 18	أَطْلَقَ اسْمَ
u'طَلِقَ إضْمارٌ':Predicate, #1: 1	أَطْلَقَ اشْتِرَاطَ
u'طَلِقَ إِعارَةٌ':Predicate, #1: 1	أَطْلَقَ الْإِضْمَارَ
u'طَلِقَ إفْتَاءٌ':Predicate, #3: 3	أَطْلَقَ الْإِعَارَةَ
u'طَلِقَ أفْضَلِيَّةٌ':Predicate, #2: 2	أَطْلَقَ الْإِفْتَاءَ
u'طَلِقَ إقْرَارٌ':Predicate, #1: 1	أَطْلَقَ أَفْضَلِيَّةَ
u'طَلِقَ أَكْثَرُ':Predicate, #3: 3	أَطْلَقَ الْإِقْرَارَ
u'طَلَّقَ أَكْثَرُ':Predicate, #1: 1	أَطْلَقَ أَكْثَرَ
u'طَلِقَ اِلْتِزَامٌ':Predicate, #1: 1	طَلَّقَ أَكْثَرَ
u'طَلِقَ إلْغَاءٌ':Predicate, #1: 1	أَطْلَقَ الْتِزَامَ
u'طَلِقَ الْمَرْأَةُ':Predicate, #1: 1	أَطْلَقَ إلْغَاءَ
u'طَلَّقَ الْمَرْأَةُ':Predicate, #1: 1	أَطْلَقَ الْمَرْأَةَ
u'طَلَّقَ أُمٌّ':Predicate, #1: 1	طَلَّقَ الْمَرْأَةَ
u'طَلَّقَ أُمٌّ':Predicate, #2: 2	طَلَّقَ الْأُمَّ
u'طَلِقَ أمَةٌ':Predicate, #4: 4	طَلَّقَ أُمَّ
u'طَلَّقَ أمَةٌ':Predicate, #1: 1	أَطْلَقَ الْأَمَةَ
u'طَلِقَ أَمْرٌ':Predicate, #2: 2	طَلَّقَ الْأَمَةَ
u'طَلَّقَ اِمْرَأَةٌ':Predicate, #3: 3	أَطْلَقَ الْأَمْرَ
u'طَلَّقَ إِنْسانٌ':Subject, #2: 2	طَلَّقَ امْرَأَةَ
u'طَلِقَ إِنْكارٌ':Predicate, #1: 1	طَلَّقَ إنْسَانٌ
u'طَلِقَ أهْلٌ':Predicate, #1: 1	أَطْلَقَ إنْكَارَ
u'طَلِقَ أوَانٌ':Predicate, #1: 1	أَطْلَقَ أَهْلَ
u'طَلَّقَ أَوَّلُ':Predicate, #1: 1	أَطْلَقَ الْأَوَانَ
u'طَلِقَ أَوَّلُ':Predicate, #1: 1	طَلَّقَ أَوَّلَ
u'طَلَّقَ أَوَّلُ':Subject, #2: 2	أَطْلَقَ الْأَوَّلَ
u'طَلِقَ أيَّامٌ':Predicate, #4: 4	طَلَّقَ الْأَوَّلُ
u'طَلِقَ أَيَّامٌ':Predicate, #1: 1	أَطْلَقَ الْأَيَّامَ
u'طَلِقَ آيَةٌ':Predicate, #1: 1	أَطْلَقَ الْأَيَّامَ
u'طَلِقَ أَيْمَانٌ':Predicate, #1: 1	أَطْلَقَ الْآيَةَ
u'طَلِقَ بَائِنٌ':Predicate, #1: 1	أَطْلَقَ الْأَيْمَانَ
u'طَلَّقَ بَائِنٌ':Predicate, #1: 1	أَطْلَقَ الْبَائِنَ
u'طَلَّقَ بَائِنٌ':Subject, #1: 1	طَلَّقَ الْبَائِنَ
u'طَلِقَ بدنة':Predicate, #1: 1	طَلَّقَ الْبَائِنُ
u'طَلَّقَ بَشيرٌ':Predicate, #1: 1	أَطْلَقَ الْبَدَنَةَ
u'طَلِقَ بَطَلٌ':Predicate, #1: 1	طَلَّقَ بَشِيرَةَ
u'طَلِقَ بَطْنٌ':Predicate, #1: 1	أَطْلَقَ بَطَلَ
u'طَلَّقَ بَعْضٌ':Predicate, #1: 1	أَطْلَقَ الْبَطْنَ
u'طَلَّقَ بَعْضٌ':Predicate, #2: 2	طَلَّقَ بَعْضَهُنَّ
u'طَلَّقَ بَعْضٌ':Subject, #3: 3	طَلَّقَ بَعْضَ
u'طَلَّقَ بِكْرٌ':Predicate, #1: 1	طَلَّقَ بَعْضُ
u'طَلِقَ بِنَاءٌ':Predicate, #1: 1	طَلَّقَ الْبِكْرَ
u'طَلِقَ بَيْعٌ':Predicate, #1: 1	أَطْلَقَ الْبِنَاءَ
u'طَلِقَ تَحْرِيمٌ':Predicate, #1: 1	أَطْلَقَ الْبَيْعَ
u'طَلِقَ تَحْرِيمٌ':Predicate, #1: 1	أَطْلَقَ التَّحْرِيمَ
u'طَلِقَ تَحْلِيلٌ':Predicate, #1: 1	أَطْلَقَ تَحْرِيمَ
u'طَلِقَ تَخْرِيجٌ':Predicate, #1: 1	أَطْلَقَ تَحْلِيلَ
u'طَلِقَ تَخْيِيرٌ':Predicate, #1: 1	أَطْلَقَ التَّخْرِيجَ
u'طَلِقَ تَذَكُّرٌ':Predicate, #1: 1	أَطْلَقَ التَّخْيِيرَ
u'طَلِقَ تَشْبِيهٌ':Predicate, #1: 1	أَطْلَقَ التَّذَكُّرَ
u'طَلِقَ تَصَرُّفٌ':Predicate, #1: 1	أَطْلَقَ تَشْبِيهَ
u'طَلِقَ تَعْلِيقٌ':Predicate, #1: 1	أَطْلَقَ التَّصَرُّفَ
u'طَلِقَ تَفْوِيضٌ':Predicate, #1: 1	أَطْلَقَ التَّعْلِيقَ
u'طَلِقَ تَكْليفٌ':Predicate, #1: 1	أَطْلَقَ التَّفْوِيضَ
u'طَلِقَ تَنْفِيلٌ':Predicate, #1: 1	أَطْلَقَ تَكْلِيفَ
u'طَلِقَ تَوَصُّلٌ':Predicate, #1: 1	أَطْلَقَ التَّنْفِيلَ
u'طَلِقَ تَوْكِيلٌ':Predicate, #1: 1	أَطْلَقَ التَّوَصُّلَ
u'طَلَّقَ ثَانِي':Predicate, #3: 3	أَطْلَقَ التَّوْكِيلَ
u'طَلَّقَ ثَانِي':Predicate, #1: 1	طَلَّقَ الثَّانِيَ
u'طَلَّقَ ثَانِي':Predicate, #2: 2	طَلَّقَ الثَّانِيَةَ
u'طَلَّقَ ثَانِيَةٌ':Predicate, #3: 3	طَلَّقَ ثَانِيَةً
u'طَلِقَ ثُبُوتٌ':Predicate, #2: 2	طَلَّقَ الثَّانِيَةَ
u'طَلَّقَ ثَلاثُ':Predicate, #2: 2	أَطْلَقَ الثُّبُوتَ
u'طَلِقَ ثَلاثَةٌ':Predicate, #1: 1	طَلَّقَ الثَّلَاثَ
u'طَلِقَ ثَلاثَةٌ':Predicate, #1: 1	أَطْلَقَ الثَّلَاثَةَ
u'طَلِقَ ثَمَنٌ':Predicate, #1: 1	أَطْلَقَ ثَلَاثَةَ
u'طَلِقَ جَازٌ':Predicate, #8: 8	أَطْلَقَ الثَّمَنَ
u'طَلِقَ جَرَيان':Predicate, #2: 2	أَطْلَقَ جَازَ
u'طَلِقَ جمع':Predicate, #1: 1	أَطْلَقَ جَرَيَانَ
u'طَلِقَ جَمْعٌ':Predicate, #3: 3	أَطْلَقَ الْجَمْعَ
u'طَلَّقَ جَمِيع':Predicate, #3: 3	أَطْلَقَ الْجَمْعَ
u'طَلِقَ جُنُونٌ':Predicate, #2: 2	طَلَّقَ الْجَمِيعَ
u'طَلِقَ جَوَابٌ':Predicate, #1: 1	أَطْلَقَ الْجُنُونَ
u'طَلِقَ جَوَابٌ':Predicate, #10: 10	أَطْلَقَ الْجَوَابَ
u'طَلِقَ جَوَازٌ':Predicate, #1: 1	أَطْلَقَ جَوَابَ
u'طَلِقَ جَوَازٌ':Predicate, #2: 2	أَطْلَقَ جَوَازَ
u'طَلِقَ حاجَةٌ':Predicate, #3: 3	أَطْلَقَ الْجَوَازَ
u'طَلَّقَ حاكِمٌ':Subject, #1: 1	أَطْلَقَ الْحَاجَةَ
u'طَلَّقَ حامِلٌ':Predicate, #6: 6	طَلَّقَ الْحَاكِمُ
u'طَلِقَ حَجٌّ':Predicate, #2: 2	طَلَّقَ الْحَامِلَ
u'طَلِقَ حَجَرٌ':Predicate, #2: 2	أَطْلَقَ الْحَجَّ
u'طَلِقَ حَجْرٌ':Predicate, #1: 1	أَطْلَقَ الْحَجَرَ
u'طَلِقَ حَدَثٌ':Predicate, #1: 1	أَطْلَقَ الْحَجْرَ
u'طَلَّقَ حُرٌّ':Predicate, #1: 1	أَطْلَقَ الْحَدَثَ
u'طَلَّقَ حُرٌّ':Subject, #6: 6	طَلَّقَ الْحُرَّةَ
u'طَلِقَ حُرْمَةٌ':Predicate, #3: 3	طَلَّقَ الْحُرُّ
u'طَلَّقَ حَفْصٌ':Subject, #4: 4	أَطْلَقَ الْحُرْمَةَ
u'طَلِقَ حَقٌّ':Predicate, #2: 2	طَلَّقَ حَفْصُ
u'طَلِقَ حَمْلٌ':Predicate, #2: 2	أَطْلَقَ الْحَقَّ
u'طَلِقَ حَوَالَةٌ':Predicate, #1: 1	أَطْلَقَ حَمْلَ
u'طَلِقَ خُبْزٌ':Predicate, #2: 2	أَطْلَقَ الْحَوَالَةَ
u'طَلِقَ خطبة':Predicate, #1: 1	أَطْلَقَ الْخُبْزَ
u'طَلِقَ خُطْبَةٌ':Predicate, #1: 1	أَطْلَقَ الْخُطْبَةَ
u'طَلِقَ خِلاَفٌ':Predicate, #1: 1	أَطْلَقَ الْخُطْبَةَ
u'طَلِقَ خيار':Predicate, #507: 507	أَطْلَقَ الْخِلَافَ
u'طَلِقَ خِيَارٌ':Predicate, #4: 4	أَطْلَقَ الْخِيَارَ
u'طَلِقَ دَارٌ':Predicate, #4: 4	أَطْلَقَ الْخِيَارَ
u'طَلِقَ دَرَاهِمُ':Predicate, #1: 1	أَطْلَقَ دَارَ
u'طَلِقَ دَعْوَةٌ':Predicate, #1: 1	أَطْلَقَ الدَّرَاهِمَ
u'طَلِقَ ذكر':Predicate, #1: 1	أَطْلَقَ الدَّعْوَةَ
u'طَلِقَ ذِكْرٌ':Predicate, #4: 4	أَطْلَقَ ذِكْرَ
u'طَلَّقَ ذِمِّيٌّ':Predicate, #4: 4	أَطْلَقَ ذِكْرَ
u'طَلَّقَ ذِمِّيٌّ':Subject, #1: 1	طَلَّقَ الذِّمِّيَّةَ
u'طَلَّقَ ذِمِّيٌّ':Subject, #1: 1	طَلَّقَ ذِمِّيٌّ
u'طَلَّقَ رابع':Predicate, #7: 7	طَلَّقَ الذِّمِّيُّ
u'طَلَّقَ رَابِعٌ':Predicate, #1: 1	طَلَّقَ الرَّابِعَةَ
u'طَلَّقَ رابع':Predicate, #1: 1	طَلَّقَ الرَّابِعَةَ
u'طَلَّقَ رَابِعٌ':Predicate, #2: 2	طَلَّقَ رَابِعَةً
u'طَلَّقَ رَجْعِيٌّ':Predicate, #2: 2	طَلَّقَ رَابِعَةً
u'طَلِقَ رَجْعِيٌّ':Predicate, #1: 1	طَلَّقَ رَجْعِيَّةً
u'طَلَّقَ رَجْعِيٌّ':Predicate, #2: 2	أَطْلَقَ الرَّجْعِيَّ
u'طَلَّقَ رَجْعِيَّةٌ':Predicate, #3: 3	طَلَّقَ الرَّجْعِيَّةَ
u'طَلَّقَ رَجُلٌ':Subject, #3: 3	طَلَّقَ الرَّجْعِيَّةَ
u'طَلَقَ رَجُلٌ':Subject, #14: 14	طَلَّقَ رَجُلٌ
u'طَلَّقَ رَجُلٌ':Subject, #1: 1	طَلَقَ رَجُلٌ
u'طَلَّقَ رَسُولٌ':Subject, #52: 52	طَلَّقَ الرَّجُلُ
u'طَلَّقَ رَسُولٌ':Subject, #1: 1	طَلَّقَ الرَّسُولُ
u'طَلِقَ رضاع':Predicate, #2: 2	طَلَّقَ رَسُولُ
u'طَلِقَ رُكوبٌ':Predicate, #1: 1	أَطْلَقَ الرَّضَاعَ
u'طَلِقَ رَهْنٌ':Predicate, #5: 5	أَطْلَقَ الرُّكُوبَ
u'طَلِقَ رِوايَةٌ':Predicate, #1: 1	أَطْلَقَ رَهْنَ
u'طَلَّقَ زادٌ':Predicate, #4: 4	أَطْلَقَ الرِّوَايَةَ
u'طَلَّقَ زَوْجٌ':Subject, #1: 1	طَلَّقَ زَادَ
u'طَلِقَ زَوْجَةٌ':Predicate, #6: 6	طَلَّقَ الزَّوْجُ
u'طَلَّقَ زَوْجَةٌ':Predicate, #1: 1	أَطْلَقَ الزَّوْجَةَ
u'طَلَّقَ زَيْدٌ':Subject, #1: 1	طَلَّقَ زَوْجَةَ
u'طَلَّقَ زَيْنَبٌ':Predicate, #8: 8	طَلَّقَ زَيْدٌ
u'طَلَّقَ سَفِيهٌ':Predicate, #6: 6	طَلَّقَ زَيْنَبَ
u'طَلِقَ سكر':Predicate, #2: 2	طَلَّقَ السَّفِيهَةَ
u'طَلِقَ سُكْرٌ':Predicate, #1: 1	أَطْلَقَ السُّكْرَ
u'طَلَّقَ سَكْرَان':Subject, #1: 1	أَطْلَقَ السُّكْرَ
u'طَلِقَ سُؤَالٌ':Predicate, #1: 1	طَلَّقَ السَّكْرَانُ
u'طَلِقَ سُورَةٌ':Predicate, #1: 1	أَطْلَقَ السُّؤَالَ
u'طَلِقَ شَارِعٌ':Predicate, #1: 1	أَطْلَقَ السُّورَةَ
u'طَلِقَ شُبْهَةٌ':Predicate, #1: 1	أَطْلَقَ الشَّارِعَ
u'طَلَّقَ شَخْصٌ':Subject, #1: 1	أَطْلَقَ الشُّبْهَةَ
u'طَلِقَ شَرْطٌ':Predicate, #1: 1	طَلَّقَ شَخْصٌ
u'طَلِقَ شَقٌّ':Predicate, #1: 1	أَطْلَقَ الشَّرْطَ
u'طَلِقَ شَهَادَةٌ':Predicate, #1: 1	أَطْلَقَ الشَّقَّ
u'طَلِقَ شَهْرٌ':Predicate, #1: 1	أَطْلَقَ الشَّهَادَةَ
u'طَلِقَ صَبْغٌ':Predicate, #1: 1	أَطْلَقَ شَهْرَ
u'طَلَّقَ صَبِيٌّ':Predicate, #2: 2	أَطْلَقَ الصَّبْغَ
u'طَلِقَ صَبِيٌّ':Predicate, #1: 1	طَلَّقَ الصَّبِيَّةَ
u'طَلَّقَ صَبِيٌّ':Subject, #3: 3	أَطْلَقَ الصَّبِيَّ
u'طَلِقَ صِحَّةٌ':Predicate, #3: 3	طَلَّقَ الصَّبِيُّ
u'طَلَّقَ صَحِيحٌ':Subject, #3: 3	أَطْلَقَ الصِّحَّةَ
u'طَلِقَ صدقة':Predicate, #2: 2	طَلَّقَ الصَّحِيحُ
u'طَلِقَ صَدَقَةٌ':Predicate, #1: 1	أَطْلَقَ الصَّدَقَةَ
u'طَلِقَ صَرِيحٌ':Predicate, #1: 1	أَطْلَقَ الصَّدَقَةَ
u'طَلَّقَ صَغِيرٌ':Predicate, #1: 1	أَطْلَقَ صَرِيحَ
u'طَلِقَ صَلاَةٌ':Predicate, #2: 2	طَلَّقَ صَغِيرَةً
u'طَلِقَ صَلاَةٌ':Predicate, #1: 1	أَطْلَقَ صَلَاةَ
u'طَلِقَ صلح':Predicate, #5: 5	أَطْلَقَ الصَّلَاةَ
u'طَلِقَ صُلْحٌ':Predicate, #1: 1	أَطْلَقَ الصُّلْحَ
u'طَلِقَ صَوْمٌ':Predicate, #1: 1	أَطْلَقَ الصُّلْحَ
u'طَلَّقَ ضَرَّةٌ':Predicate, #1: 1	أَطْلَقَ الصَّوْمَ
u'طَلِقَ ضَرَرٌ':Predicate, #2: 2	طَلَّقَ الضَّرَّةَ
u'طَلِقَ طعام':Predicate, #1: 1	أَطْلَقَ الضَّرَرَ
u'طَلِقَ طَعَامٌ':Predicate, #1: 1	أَطْلَقَ الطَّعَامَ
u'طَلَّقَ طَلاَقٌ':Predicate, #1: 1	أَطْلَقَ الطَّعَامَ
u'طَلِقَ طَلاَقٌ':Predicate, #1: 1	طَلَّقَ طَلَاقَ
u'طَلِقَ ظَنّ':Predicate, #2: 2	أَطْلَقَ الطَّلَاقَ
u'طَلِقَ ظَنِّيّ':Predicate, #1: 1	أَطْلَقَ ظَنِّيَّةَ
u'طَلِقَ عارِيَّةٌ':Predicate, #1: 1	أَطْلَقَ ظَنِّيَّةَ
u'طَلِقَ عِبَارَةٌ':Predicate, #3: 3	أَطْلَقَ الْعَارِيَّةَ
u'طَلِقَ عَبْدٌ':Predicate, #2: 2	أَطْلَقَ الْعِبَارَةَ
u'طَلَّقَ عَبْدٌ':Subject, #2: 2	أَطْلَقَ الْعَبْدَ
u'طَلَّقَ عَبْدٌ':Subject, #10: 10	طَلَّقَ الْعَبْدُ
u'طَلِقَ عتق':Predicate, #6: 6	طَلَّقَ عَبْدُ
u'طَلِقَ عتق':Predicate, #1: 1	أَطْلَقَ عَتَقَ
u'طَلِقَ عِتْقٌ':Predicate, #1: 1	أَطْلَقَ عِتْقَ
u'طَلِقَ عتق':Predicate, #1: 1	أَطْلَقَ عِتْقَ
u'طَلِقَ عِتْقٌ':Predicate, #2: 2	أَطْلَقَ الْعِتْقَ
u'طَلَّقَ عَجَمِيٌّ':Subject, #2: 2	أَطْلَقَ الْعِتْقَ
u'طَلَّقَ عَدَدٌ':Predicate, #1: 1	طَلَّقَ الْعَجَمِيُّ
u'طَلِقَ عَدَمٌ':Predicate, #1: 1	طَلَّقَ عَدَدَ
u'طَلِقَ عَفْوٌ':Predicate, #6: 6	أَطْلَقَ عَدَمَ
u'طَلِقَ عَقْدٌ':Predicate, #1: 1	أَطْلَقَ الْعَفْوَ
u'طَلِقَ عَقْدٌ':Predicate, #1: 1	أَطْلَقَ عَقْدَ
u'طَلِقَ علم':Predicate, #4: 4	أَطْلَقَ الْعَقْدَ
u'طَلِقَ عِلْمٌ':Predicate, #1: 1	أَطْلَقَ الْعِلْمَ
u'طَلَّقَ عمرة':Predicate, #1: 1	أَطْلَقَ الْعِلْمَ
u'طَلَّقَ عُمْرَةٌ':Predicate, #1: 1	طَلَّقَ عُمْرَةَ
u'طَلَّقَ عمرة':Predicate, #1: 1	طَلَّقَ عُمْرَةَ
u'طَلِقَ عَمَلٌ':Predicate, #8: 8	طَلَّقَ عَمْرَةَ
u'طَلِقَ عُمُومٌ':Predicate, #1: 1	أَطْلَقَ الْعَمَلَ
u'طَلِقَ عند':Predicate, #1: 1	أَطْلَقَ عُمُومَ
u'طَلِقَ عَوْدٌ':Predicate, #1: 1	أَطْلَقَ عِنْدَ
u'طَلِقَ عَيْبٌ':Predicate, #1: 1	أَطْلَقَ عَوْدَ
u'طَلَّقَ عَيْبٌ':Predicate, #1: 1	أَطْلَقَ الْعَيْبَ
u'طَلِقَ غَائِبٌ':Predicate, #1: 1	طَلَّقَ الْعَيْبَ
u'طَلَّقَ غَائِبٌ':Subject, #1: 1	أَطْلَقَ الْغَائِبَ
u'طَلِقَ غَسْلٌ':Predicate, #1: 1	طَلَّقَ غَائِبٌ
u'طَلَّقَ غير':Predicate, #1: 1	أَطْلَقَ الْغَسْلَ
u'طَلَّقَ غَيْرٌ':Predicate, #4: 4	طَلَّقَ غَيْرَ
u'طَلِقَ فلان':Predicate, #4: 4	طَلَّقَ غَيْرَ
u'طَلَّقَ فلان':Predicate, #1: 1	أَطْلَقَ مَكَّةَ
u'طَلَّقَ فُلاَنٌ':Predicate, #1: 1	طَلَّقَ تُمَاضِرَ
u'طَلَّقَ فلان':Predicate, #1: 1	طَلَّقَ فُلَانَةَ
u'طَلَّقَ فُلاَنٌ':Subject, #8: 8	طَلَّقَ حَفْصَةَ
u'طَلِقَ فِنَاءٌ':Predicate, #10: 10	طَلَّقَ فُلَانٌ
u'طَلِقَ قَالٌ':Predicate, #1: 1	أَطْلَقَ الْفِنَاءَ
u'طَلِقَ قَدْرٌ':Predicate, #2: 2	أَطْلَقَ قَالَ
u'طَلِقَ قَرِيبٌ':Predicate, #1: 1	أَطْلَقَ قَدْرَ
u'طَلِقَ قول':Predicate, #1: 1	أَطْلَقَ الْقَرِيبَ
u'طَلِقَ قَوْلٌ':Predicate, #13: 13	أَطْلَقَ الْقَوْلَ
u'طَلِقَ قيام':Predicate, #13: 13	أَطْلَقَ الْقَوْلَ
u'طَلِقَ قِيَامٌ':Predicate, #2: 2	أَطْلَقَ الْقِيَامَ
u'طَلِقَ كَافِرٌ':Predicate, #2: 2	أَطْلَقَ الْقِيَامَ
u'طَلَّقَ كَافِرٌ':Subject, #2: 2	أَطْلَقَ الْكَافِرَ
u'طَلَّقَ كَبِيرٌ':Subject, #1: 1	طَلَّقَ الْكَافِرُ
u'طَلِقَ كِتَابَةٌ':Predicate, #1: 1	طَلَّقَ الْكَبِيرُ
u'طَلِقَ كذب':Predicate, #1: 1	أَطْلَقَ الْكِتَابَةَ
u'طَلِقَ كَذِبٌ':Predicate, #1: 1	أَطْلَقَ الْكَذِبَ
u'طَلِقَ كَرَاهَةٌ':Predicate, #1: 1	أَطْلَقَ الْكَذِبَ
u'طَلِقَ كفر':Predicate, #8: 8	أَطْلَقَ الْكَرَاهَةَ
u'طَلِقَ كُفْرٌ':Predicate, #1: 1	أَطْلَقَ الْكُفْرَ
u'طَلِقَ كَلَأٌ':Predicate, #1: 1	أَطْلَقَ الْكُفْرَ
u'طَلَّقَ كَلاَمٌ':Predicate, #1: 1	أَطْلَقَ الْكَلَأَ
u'طَلِقَ كَلاَمٌ':Predicate, #1: 1	طَلَّقَ كَلَامَ
u'طَلِقَ لَفْظٌ':Predicate, #5: 5	أَطْلَقَ الْكَلَامَ
u'طَلِقَ لَفْظٌ':Predicate, #3: 3	أَطْلَقَ اللَّفْظَ
u'طَلِقَ لَيْلٌ':Predicate, #4: 4	أَطْلَقَ لَفْظَ
u'طَلِقَ مَاءٌ':Predicate, #1: 1	أَطْلَقَ اللَّيْلَةَ
u'طَلِقَ مَاسِحٌ':Predicate, #1: 1	أَطْلَقَ الْمَاءَ
u'طَلِقَ مَالٌ':Predicate, #1: 1	أَطْلَقَ الْمَاسِحَ
u'طَلِقَ مُبَايَعَةٌ':Predicate, #1: 1	أَطْلَقَ الْمَالَ
u'طَلِقَ مثل':Predicate, #1: 1	أَطْلَقَ الْمُبَايَعَةَ
u'طَلِقَ مِثْلٌ':Predicate, #1: 1	أَطْلَقَ الْمِثْلَ
u'طَلِقَ مَحَلٌّ':Predicate, #1: 1	أَطْلَقَ الْمِثْلَ
u'طَلِقَ مُدَّةٌ':Predicate, #1: 1	أَطْلَقَ مَحَلَّ
u'طَلَّقَ مَدْخُولٌ':Predicate, #1: 1	أَطْلَقَ مُدَّةَ
u'طَلَّقَ مَرِيضٌ':Subject, #4: 4	طَلَّقَ الْمَدْخُولَ
u'طَلِقَ مَسْأَلَةٌ':Predicate, #14: 14	طَلَّقَ الْمَرِيضُ
u'طَلِقَ مَسْأَلَةٌ':Predicate, #1: 1	أَطْلَقَ الْمَسْأَلَةَ
u'طَلِقَ مَسْجِدٌ':Predicate, #1: 1	أَطْلَقَ مَسْأَلَةَ
u'طَلَّقَ مُسْلِمٌ':Subject, #1: 1	أَطْلَقَ الْمَسْجِدَ
u'طَلِقَ مَصْلَحَةٌ':Predicate, #1: 1	طَلَّقَ الْمُسْلِمُ
u'طَلِقَ مُضَافٌ':Predicate, #1: 1	أَطْلَقَ الْمَصْلَحَةَ
u'طَلِقَ مَطْلُوبٌ':Predicate, #1: 1	أَطْلَقَ الْمُضَافَ
u'طَلِقَ مُعْتَدٌّ':Predicate, #1: 1	أَطْلَقَ الْمَطْلُوبَ
u'طَلِقَ مُغَنِّي':Predicate, #1: 1	أَطْلَقَ الْمُعْتَدَّةَ
u'طَلَّقَ مَفْقُودٌ':Predicate, #1: 1	أَطْلَقَ الْمُغَنِّيَةَ
u'طَلَّقَ مُفَوَّضٌ':Predicate, #1: 1	طَلَّقَ الْمَفْقُودَةَ
u'طَلِقَ مُقَارَنٌ':Predicate, #1: 1	طَلَّقَ الْمُفَوَّضَةَ
u'طَلِقَ مُقَارَنَةٌ':Predicate, #1: 1	أَطْلَقَ الْمُقَارَنَةَ
u'طَلِقَ مَكْتُوبٌ':Predicate, #1: 1	أَطْلَقَ الْمُقَارَنَةَ
u'طَلِقَ مِلْكٌ':Predicate, #1: 1	أَطْلَقَ الْمَكْتُوبَ
u'طَلِقَ مَنْعٌ':Predicate, #4: 4	أَطْلَقَ الْمِلْكَ
u'طَلَّقَ مَنْكُوح':Predicate, #5: 5	أَطْلَقَ الْمَنْعَ
u'طَلَّقَ مُوَكِّلٌ':Subject, #1: 1	طَلَّقَ الْمَنْكُوحَةَ
u'طَلَّقَ نَائِمٌ':Subject, #1: 1	طَلَّقَ الْمُوَكِّلُ
u'طَلِقَ نَجَاسَةٌ':Predicate, #2: 2	طَلَّقَ النَّائِمُ
u'طَلِقَ نَجَسٌ':Predicate, #1: 1	أَطْلَقَ نَجَاسَةَ
u'طَلِقَ نِدَاءٌ':Predicate, #2: 2	أَطْلَقَ النَّجَسَ
u'طَلِقَ نذر':Predicate, #1: 1	أَطْلَقَ النِّدَاءَ
u'طَلِقَ نَذْرٌ':Predicate, #6: 6	أَطْلَقَ النَّذْرَ
u'طَلِقَ نَصْرَانِيٌّ':Predicate, #6: 6	أَطْلَقَ النَّذْرَ
u'طَلَّقَ نَصْرَانِيٌّ':Predicate, #1: 1	أَطْلَقَ النَّصْرَانِيَّ
u'طَلَّقَ نَصْرَانِيَّةٌ':Predicate, #1: 1	طَلَّقَ النَّصْرَانِيَّةَ
u'طَلَّقَ نِصْفٌ':Predicate, #1: 1	طَلَّقَ النَّصْرَانِيَّةَ
u'طَلِقَ نَظَرٌ':Predicate, #1: 1	طَلَّقَ النِّصْفَ
u'طَلِقَ نَفَقَةٌ':Predicate, #2: 2	أَطْلَقَ النَّظَرَ
u'طَلِقَ نَفْيٌ':Predicate, #2: 2	أَطْلَقَ النَّفَقَةَ
u'طَلِقَ نكاح':Predicate, #1: 1	أَطْلَقَ نَفْيَ
u'طَلِقَ نِكَاحٌ':Predicate, #1: 1	أَطْلَقَ النِّكَاحَ
u'طَلِقَ نِيَّةٌ':Predicate, #1: 1	أَطْلَقَ النِّكَاحَ
u'طَلِقَ نِيَّةٌ':Predicate, #13: 13	أَطْلَقَ النِّيَّةَ
u'طَلِقَ هِبَةٌ':Predicate, #3: 3	أَطْلَقَ نِيَّةَ
u'طَلِقَ وَاجِبٌ':Predicate, #1: 1	أَطْلَقَ الْهِبَةَ
u'طَلِقَ واحد':Predicate, #1: 1	أَطْلَقَ الْوَاجِبَ
u'طَلِقَ وَاحِدٌ':Predicate, #1: 1	أَطْلَقَ الْوَاحِدَ
u'طَلَّقَ واحد':Predicate, #1: 1	أَطْلَقَ الْوَاحِدَ
u'طَلَّقَ وَاحِدٌ':Predicate, #48: 48	طَلَّقَ وَاحِدَةً
u'طَلَّقَ واحد':Subject, #48: 48	طَلَّقَ وَاحِدَةً
u'طَلَّقَ وَاحِدٌ':Subject, #1: 1	طَلَّقَ وَاحِدٌ
u'طَلِقَ وَارِثٌ':Predicate, #1: 1	طَلَّقَ وَاحِدٌ
u'طَلِقَ وُجُوبٌ':Predicate, #1: 1	أَطْلَقَ الْوَارِثَ
u'طَلِقَ وَصِيٌّ':Predicate, #2: 2	أَطْلَقَ وُجُوبَ
u'طَلِقَ وَصِيَّةٌ':Predicate, #2: 2	أَطْلَقَ الْوَصِيَّةَ
u'طَلِقَ وَقْتٌ':Predicate, #2: 2	أَطْلَقَ الْوَصِيَّةَ
u'طَلِقَ وقع':Predicate, #2: 2	أَطْلَقَ الْوَقْتَ
u'طَلَّقَ وقع':Predicate, #4: 4	أَطْلَقَ وَقَعَ
u'طَلِقَ وَقْفٌ':Predicate, #4: 4	طَلَّقَ وَقَعَ
u'طَلِقَ وُقُوعٌ':Predicate, #1: 1	أَطْلَقَ وَقْفَ
u'طَلِقَ وُقُوعٌ':Predicate, #1: 1	أَطْلَقَ الْوُقُوعَ
u'طَلَّقَ وَكِيلٌ':Subject, #1: 1	أَطْلَقَ وُقُوعَ
u'طَلَّقَ وَلِيٌّ':Subject, #4: 4	طَلَّقَ الْوَكِيلُ
u'طَلِقَ يَدٌ':Predicate, #1: 1	طَلَّقَ وَلِيُّهُ
u'طَلِقَ يَمِينٌ':Predicate, #1: 1	أَطْلَقَ الْيَدَ
u'طُلُوعٌ بَحْرٌ':Added, #3: 3	أَطْلَقَ الْيَمِينَ
u'طُلُوعٌ بَرٌّ':Added, #1: 1	طُلُوعِ الْبَحْرِ
u'طُلُوعٌ ثَمَرَةٌ':Added, #1: 1	طُلُوعِ الْبَرِّ
u'طُلُوعٌ سَطْحٌ':Added, #1: 1	طُلُوعِ الثَّمَرَةِ
u'طُلُوعٌ شَجَرَةٌ':Added, #1: 1	طُلُوعَ سَطْحِهِ
u'طُلُوعٌ شمس':Added, #1: 1	طُلُوعِ الشَّجَرَةِ
u'طُلُوعٌ شَمْسٌ':Added, #19: 19	طُلُوعَ الشَّمْسِ
u'طُلُوعٌ شمس':Added, #19: 19	طُلُوعَ الشَّمْسِ
u'طُلُوعٌ شمس':Added, #1: 1	طُلُوعَ الشّمْسِ
u'طُلُوعٌ شَمْسٌ':Added, #1: 1	طُلُوعُ الشّمْسِ
u'طُلُوعٌ شَمْسٌ':Added, #1: 1	طُلُوعَ الشّمْسِ
u'طُلُوعٌ شمس':Added, #1: 1	طُلُوعُ الشّمْسِ
u'طُلُوعٌ شَمْسٌ':Added, #21: 21	طُلُوعُ الشَّمْسِ
u'طُلُوعٌ شمس':Added, #21: 21	طُلُوعُ الشَّمْسِ
u'طُلُوعٌ شَمْسٌ':Added, #2: 2	طُلُوعِ الشّمْسِ
u'طُلُوعٌ شمس':Added, #2: 2	طُلُوعِ الشّمْسِ
u'طُلُوعٌ شَمْسٌ':Added, #2: 2	طُلُوعِ شَمْسِ
u'طُلُوعٌ شمس':Added, #2: 2	طُلُوعِ شَمْسِ
u'طُلُوعٌ شَمْسٌ':Added, #372: 372	طُلُوعِ الشَّمْسِ
u'طُلُوعٌ شَيْءٌ':Added, #372: 372	طُلُوعِ الشَّمْسِ
u'طُلُوعٌ صُبْحٌ':Added, #1: 1	طُلُوعِ شَيْءٍ
u'طُلُوعٌ طَلْعٌ':Added, #1: 1	طُلُوعِ الصُّبْحِ
u'طُلُوعٌ عُذْرَةٌ':Added, #2: 2	طُلُوعِ الطَّلْعِ
u'طُلُوعٌ فَجْرٌ':Added, #1: 1	طُلُوعِ الْعُذْرَةِ
u'طُلُوعٌ فَجْرٌ':Added, #1: 1	طُلُوعُ فَجْرِ
u'طُلُوعٌ فَجْرٌ':Added, #21: 21	طُلُوعَ الْفَجْرِ
u'طُلُوعٌ فَجْرٌ':Added, #21: 21	طُلُوعُ الْفَجْرِ
u'طُلُوعٌ فَجْرٌ':Added, #424: 424	طُلُوعِ الْفَجْرِ
u'طُلُوعٌ لِحْيَةٌ':Added, #8: 8	طُلُوعِ فَجْرِ
u'طُلُوعٌ نَجْمٌ':Added, #1: 1	طُلُوع لِحْيَتِهِ
u'طُلُوعٌ نَجْمٌ':Added, #1: 1	طُلُوعُ النَّجْمِ
u'طُلُوعٌ نَجْمٌ':Added, #1: 1	طُلُوعِ النَّجْمِ
u'طُلُوعٌ نَجْمٌ':Added, #1: 1	طُلُوعِ نَجْمٍ
u'طُلُوعٌ نُجُومٌ':Added, #2: 2	طُلُوعَ النَّجْمِ
u'طُلُوعٌ هِلاَلٌ':Added, #2: 2	طُلُوعِ النُّجُومِ
u'طُلُوعٌ هِلاَلٌ':Added, #1: 1	طُلُوعَ الْهِلَالِ
u'طَلَى شقاق':Predicate, #1: 1	طُلُوعِ الْهِلَالِ
u'طَلَى شِقَاقٌ':Predicate, #1: 1	طَلَى شِقَاقَ
u'طَمَا بَحْرٌ':Subject, #1: 1	طَلَى شِقَاقَ
u'طماع آمال':Added, #1: 1	طَمَا الْبَحْرُ
u'طماع عَبْدٌ':Added, #1: 1	أَطْمَاعُ آمَالِهِ
u'طماع فقراء':Added, #1: 1	أَطْمَاعُ عَبْدٍ
u'طماع نَفْسٌ':Added, #1: 1	أَطْمَاعُ الْفُقَرَاءِ
u'طماع نَفْسٌ':Added, #1: 1	أَطْمَاعِ النَّفْسِ
u'طماع وَرَثَةٌ':Added, #1: 1	أَطْمَاعُ نَفْسِهِ
u'طُمَأْنِينَةٌ رُكوعٌ':Added, #1: 1	أَطْمَاعُ الْوَرَثَةِ
u'طُمَأْنِينَةٌ رُكوعٌ':Added, #1: 1	طُمَأْنِينَةِ الرُّكُوعِ
u'طُمَأْنِينَةٌ صَلاَةٌ':Added, #1: 1	طُمَأْنِينَةِ رُكُوعٍ
u'طُمَأْنِينَةٌ قلب':Added, #3: 3	طُمَأْنِينَةِ الصَّلَاةِ
u'طُمَأْنِينَةٌ قَلْبٌ':Added, #1: 1	طُمَأْنِينَةِ قَلْبِهِ
u'طُمَأْنِينَةٌ قَلْب':Added, #1: 1	طُمَأْنِينَةِ قَلْبِهِ
u'طُمَأْنِينَةٌ قلب':Added, #1: 1	طُمَأْنِينَةِ قَلْبِهِ
u'طُمَأْنِينَةٌ قلب':Added, #2: 2	طُمَأْنِينَةَ الْقَلْبِ
u'طُمَأْنِينَةٌ قَلْبٌ':Added, #2: 2	طُمَأْنِينَةُ الْقَلْبِ
u'طُمَأْنِينَةٌ قَلْبٌ':Added, #2: 2	طُمَأْنِينَةَ الْقَلْبِ
u'طُمَأْنِينَةٌ قَلْب':Added, #2: 2	طُمَأْنِينَةُ الْقَلْبِ
u'طُمَأْنِينَةٌ قَلْب':Added, #2: 2	طُمَأْنِينَةَ الْقَلْبِ
u'طُمَأْنِينَةٌ قلب':Added, #2: 2	طُمَأْنِينَةُ الْقَلْبِ
u'طُمَأْنِينَةٌ قَلْبٌ':Added, #3: 3	طُمَأْنِينَةِ الْقَلْبِ
u'طُمَأْنِينَةٌ قَلْب':Added, #3: 3	طُمَأْنِينَةِ الْقَلْبِ
u'طُمَأْنِينَةٌ قُلُوبٌ':Added, #3: 3	طُمَأْنِينَةِ الْقَلْبِ
u'طُمَأْنِينَةٌ نَفْسٌ':Added, #1: 1	طُمَأْنِينَةُ قُلُوبِ
u'طُمَأْنِينَةٌ نَفْسٌ':Added, #1: 1	طُمَأْنِينَةُ النَّفْسِ
u'طُمَأْنِينَةٌ نَفْسٌ':Added, #2: 2	طُمَأْنِينَةَ النَّفْسِ
u'طَمِعَ حاكِمٌ':Subject, #2: 2	طُمَأْنِينَةِ النَّفْسِ
u'طَمِعَ رَسُولٌ':Subject, #1: 1	طَمِعَ الْحَاكِمُ
u'طَمِعَ شَيْطَانٌ':Subject, #1: 1	طَمِعَ رَسُولُ
u'طَمَعٌ شَيْطَانٌ':Added, #1: 1	طَمِعَ الشَّيْطَانُ
u'طَمِعَ عَامِلٌ':Subject, #1: 1	طَمَعِ الشَّيْطَانِ
u'طَمَعٌ قضاة':Added, #1: 1	طَمِعَ الْعَامِلُ
u'طَمَعٌ لُصُوصٌ':Added, #2: 2	طَمَعِ الْقُضَاةِ
u'طَمَعٌ مُحَلِّل':Added, #2: 2	طَمَعَ اللُّصُوصِ
u'طَنَّ ذُبابٌ':Subject, #1: 1	طَمَعَ الْمُحَلِّلِ
u'طَنِينٌ حَلْقَةٌ':Added, #1: 1	طَنَّ الذُّبَابُ
u'طَهَارَةٌ آبارٌ':Added, #1: 1	طَنِينَ الْحَلْقَةِ
u'طَهَارَةٌ أبدانٌ':Added, #1: 1	طَهَارَةَ الْآبَارِ
u'طَهَارَةٌ أحَدٌ':Added, #1: 1	طَهَارَةِ الْأَبَدَانِ
u'طَهَارَةٌ أَحْداثٌ':Added, #2: 2	طَهَارَةَ أَحَدِ
u'طَهَارَةٌ أَحْدَاثٌ':Added, #1: 1	طَهَارَةُ الْأَحْدَاثِ
u'طَهَارَةٌ أَحْداثٌ':Added, #1: 1	طَهَارَةُ الْأَحْدَاثِ
u'طَهَارَةٌ أَحْدَاثٌ':Added, #4: 4	طَهَارَةِ الْأَحْدَاثِ
u'طَهَارَةٌ أَحْيَاءٌ':Added, #4: 4	طَهَارَةِ الْأَحْدَاثِ
u'طَهَارَةٌ أرْضٌ':Added, #1: 1	طَهَارَةِ الْأَحْيَاءِ
u'طَهَارَةٌ أرْضٌ':Added, #1: 1	طَهَارَةِ الأَرْضِ
u'طَهَارَةٌ أرْضٌ':Added, #1: 1	طَهَارَةَ الْأَرْضِ
u'طَهَارَةٌ أَرْواثٌ':Added, #3: 3	طَهَارَةُ الْأَرْضِ
u'طَهَارَةٌ أَصْحَابٌ':Added, #1: 1	طَهَارَةِ الْأَرْوَاثِ
u'طَهَارَةٌ أَعْضَاءٌ':Added, #1: 1	طَهَارَةِ أَصْحَابِ
u'طَهَارَةٌ أَعْضَاءٌ':Added, #1: 1	طَهَارَةُ أَعْضَاءِ
u'طَهَارَةٌ الْمَرْأَةُ':Added, #1: 1	طَهَارَةَ الْأَعْضَاءِ
u'طَهَارَةٌ إمَامٌ':Added, #1: 1	طَهَارَةِ الْمَرْأَةِ
u'طَهَارَةٌ إمَامٌ':Added, #1: 1	طَهَارَةَ الْإِمَامِ
u'طَهَارَةٌ إمَامٌ':Added, #1: 1	طَهَارَةُ الْإِمَامِ
u'طَهَارَةٌ إِناءٌ':Added, #4: 4	طَهَارَةِ الْإِمَامِ
u'طَهَارَةٌ إِناءٌ':Added, #2: 2	طَهَارَةُ الْإِنَاءِ
u'طَهَارَةٌ أَنْجَاسٌ':Added, #3: 3	طَهَارَةِ الْإِنَاءِ
u'طَهَارَةٌ أَوَّلُ':Added, #1: 1	طَهَارَةِ الْأَنْجَاسِ
u'طَهَارَةٌ بَاطن':Added, #1: 1	طَهَارَةِ الْأَوَّلِ
u'طَهَارَةٌ باطِنٌ':Added, #1: 1	طَهَارَةِ بَاطِنِهِ
u'طَهَارَةٌ بدن':Added, #1: 1	طَهَارَةِ بَاطِنِهِ
u'طَهَارَةٌ بَدَنٌ':Added, #1: 1	طَهَارَةُ الْبَدَنِ
u'طَهَارَةٌ بدن':Added, #1: 1	طَهَارَةُ الْبَدَنِ
u'طَهَارَةٌ بَدَنٌ':Added, #1: 1	طَهَارَةِ بَدَنِهِ
u'طَهَارَةٌ بدن':Added, #1: 1	طَهَارَةِ بَدَنِهِ
u'طَهَارَةٌ بَدَنٌ':Added, #3: 3	طَهَارَةُ بَدَنِهِ
u'طَهَارَةٌ بدن':Added, #3: 3	طَهَارَةُ بَدَنِهِ
u'طَهَارَةٌ بَدَنٌ':Added, #4: 4	طَهَارَةِ الْبَدَنِ
u'طَهَارَةٌ بُزاق':Added, #4: 4	طَهَارَةِ الْبَدَنِ
u'طَهَارَةٌ بَغْلٌ':Added, #1: 1	طَهَارَةِ الْبُزَاقِ
u'طَهَارَةٌ بُقْعَةٌ':Added, #1: 1	طَهَارَةُ الْبَغْلِ
u'طَهَارَةٌ بَوْلٌ':Added, #1: 1	طَهَارَةِ الْبُقْعَةِ
u'طَهَارَةٌ بَوْلٌ':Added, #2: 2	طَهَارَةُ بَوْلِ
u'طَهَارَةٌ بِئْرٌ':Added, #4: 4	طَهَارَةِ بَوْلِ
u'طَهَارَةٌ بِئْرٌ':Added, #1: 1	طَهَارَةَ الْبِئْرِ
u'طَهَارَةٌ تَامٌّ':Added, #2: 2	طَهَارَةِ الْبِئْرِ
u'طَهَارَةٌ تُرَابٌ':Added, #8: 8	طَهَارَةٍ تَامَّةٍ
u'طَهَارَةٌ تُراب':Added, #1: 1	طَهَارَةِ التُّرَابِ
u'طَهَارَةٌ تُرابَة':Added, #1: 1	طَهَارَةٍ تُرَابِيَّةٍ
u'طَهَارَةٌ تُرابِيّ':Added, #1: 1	طَهَارَةٍ تُرَابِيَّةٍ
u'طَهَارَةٌ تَيَمُّمٌ':Added, #1: 1	طَهَارَةٍ تُرَابِيَّةٍ
u'طَهَارَةٌ تَيَمُّمٌ':Added, #5: 5	طَهَارَةِ التَّيَمُّمِ
u'طَهَارَةٌ ثَدْيٌ':Added, #8: 8	طَهَارَةَ التَّيَمُّمِ
u'طَهَارَةٌ ثَوْبٌ':Added, #1: 1	طَهَارَةَ الثَّدْيِ
u'طَهَارَةٌ ثَوْبٌ':Added, #11: 11	طَهَارَةِ الثَّوْبِ
u'طَهَارَةٌ ثَوْبٌ':Added, #1: 1	طَهَارَةُ ثَوْبِهِ
u'طَهَارَةٌ ثَوْبٌ':Added, #2: 2	طَهَارَةَ الثَّوْبِ
u'طَهَارَةٌ جلد':Added, #5: 5	طَهَارَةُ الثَّوْبِ
u'طَهَارَةٌ جلد':Added, #1: 1	طَهَارَةَ الْجِلْدِ
u'طَهَارَةٌ جِلْدٌ':Added, #1: 1	طَهَارَةُ الْجِلْدِ
u'طَهَارَةٌ جِلْدٌ':Added, #1: 1	طَهَارَةَ الْجِلْدِ
u'طَهَارَةٌ جلد':Added, #1: 1	طَهَارَةُ الْجِلْدِ
u'طَهَارَةٌ جلد':Added, #1: 1	طَهَارَةُ جِلْدِهِ
u'طَهَارَةٌ جِلْدٌ':Added, #1: 1	طَهَارَةِ جِلْدِهِ
u'طَهَارَةٌ جِلْدٌ':Added, #1: 1	طَهَارَةُ جِلْدِهِ
u'طَهَارَةٌ جلد':Added, #1: 1	طَهَارَةِ جِلْدِهِ
u'طَهَارَةٌ جِلْدٌ':Added, #2: 2	طَهَارَةِ الْجِلْدِ
u'طَهَارَةٌ جلد':Added, #2: 2	طَهَارَةِ الْجِلْدِ
u'طَهَارَةٌ جِلْدٌ':Added, #2: 2	طَهَارَةَ جِلْدِ
u'طَهَارَةٌ جلد':Added, #2: 2	طَهَارَةَ جِلْدِ
u'طَهَارَةٌ جِلْدٌ':Added, #6: 6	طَهَارَةِ جِلْدِ
u'طَهَارَةٌ جُلُودٌ':Added, #6: 6	طَهَارَةِ جِلْدِ
u'طَهَارَةٌ حِجارَةٌ':Added, #1: 1	طَهَارَةِ جُلُودِ
u'طَهَارَةٌ حَجَرٌ':Added, #1: 1	طَهَارَةُ الْحِجَارَةِ
u'طَهَارَةٌ حَدَثٌ':Added, #2: 2	طَهَارَةُ الْحَجَرِ
u'طَهَارَةٌ حَدَث':Added, #10: 10	طَهَارَةِ الْحَدَثِ
u'طَهَارَةٌ حَدَثٌ':Added, #1: 1	طَهَارَةٍ حَدَثِيَّةٍ
u'طَهَارَةٌ حَدَثٌ':Added, #2: 2	طَهَارَةِ حَدَثٍ
u'طَهَارَةٌ حَدَثٌ':Added, #3: 3	طَهَارَةَ الْحَدَثِ
u'طَهَارَةٌ حَدَثٌ':Added, #4: 4	طَهَارَةُ حَدَثٍ
u'طَهَارَةٌ حَصَاةٌ':Added, #8: 8	طَهَارَةُ الْحَدَثِ
u'طَهَارَةٌ حَيٌّ':Added, #1: 1	طَهَارَةُ حَصَاةٍ
u'طَهَارَةٌ خُبْثٌ':Added, #1: 1	طَهَارَةِ الْحَيِّ
u'طَهَارَةٌ خُفٌّ':Added, #1: 1	طَهَارَةُ الْخُبْثِ
u'طَهَارَةٌ خَمْرٌ':Added, #3: 3	طَهَارَةِ الْخُفِّ
u'طَهَارَةٌ دَابَّةٌ':Added, #1: 1	طَهَارَةِ الْخَمْرِ
u'طَهَارَةٌ دَائِمٌ':Added, #1: 1	طَهَارَةَ الدَّابَّةِ
u'طَهَارَةٌ دَائِمٌ':Added, #2: 2	طَهَارَةُ دَائِمِ
u'طَهَارَةٌ دَمٌ':Added, #2: 2	طَهَارَةِ دَائِمِ
u'طَهَارَةٌ رُبْعٌ':Added, #2: 2	طَهَارَةُ دَمِ
u'طَهَارَةٌ رِجْلٌ':Added, #1: 1	طَهَارَةَ الرُّبْعِ
u'طَهَارَةٌ رِجْلٌ':Added, #1: 1	طَهَارَةِ الرِّجْلِ
u'طَهَارَةٌ رَجُلٌ':Added, #1: 1	طَهَارَةَ الرِّجْلَيْنِ
u'طَهَارَةٌ رُطوبَةٌ':Added, #2: 2	طَهَارَةِ الرَّجُلِ
u'طَهَارَةٌ رُطوبَةٌ':Added, #1: 1	طَهَارَةِ الرُّطُوبَةِ
u'طَهَارَةٌ رَفاهِيَةٌ':Added, #3: 3	طَهَارَةِ رُطُوبَةِ
u'طَهَارَةٌ رَفاهِيَةٌ':Added, #1: 1	طَهَارَةَ رَفَاهِيَةٍ
u'طَهَارَةٌ سَائِرٌ':Added, #2: 2	طَهَارَةُ رَفَاهِيَةٍ
u'طَهَارَةٌ سَرْجٌ':Added, #1: 1	طَهَارَةُ سَائِرِ
u'طَهَارَةٌ سُؤْرٌ':Added, #1: 1	طَهَارَةِ السَّرْجِ
u'طَهَارَةٌ سُؤْرٌ':Added, #1: 1	طَهَارَةَ السُّؤْرِ
u'طَهَارَةٌ سُؤْرٌ':Added, #1: 1	طَهَارَةُ سُؤْرِهِ
u'طَهَارَةٌ شَعْرٌ':Added, #5: 5	طَهَارَةِ سُؤْرِ
u'طَهَارَةٌ شَيْءٌ':Added, #1: 1	طَهَارَةُ الشَّعْرِ
u'طَهَارَةٌ شَيْءٌ':Added, #1: 1	طَهَارَةُ الشَّيْءِ
u'طَهَارَةٌ صَاحِبٌ':Added, #2: 2	طَهَارَةِ شَيْءٍ
u'طَهَارَةٌ صَعِيدٌ':Added, #1: 1	طَهَارَةُ صَاحِبِ
u'طَهَارَةٌ صَعِيدٌ':Added, #1: 1	طَهَارَةُ الصَّعِيدِ
u'طَهَارَةٌ صَلاَةٌ':Added, #3: 3	طَهَارَةَ الصَّعِيدِ
u'طَهَارَةٌ صَلاَةٌ':Added, #1: 1	طَهَارَةُ الصَّلَاةِ
u'طَهَارَةٌ ضَرُورَةٌ':Added, #1: 1	طَهَارَةِ الصَّلَاةِ
u'طَهَارَةٌ طِينٌ':Added, #6: 6	طَهَارَةُ ضَرُورَةٍ
u'طَهَارَةٌ ظاهِرٌ':Added, #1: 1	طَهَارَةُ الطِّينِ
u'طَهَارَةٌ عَرَقٌ':Added, #2: 2	طَهَارَةِ الظَّاهِرِ
u'طَهَارَةٌ عَرَقٌ':Added, #1: 1	طَهَارَةِ الْعَرَقِ
u'طَهَارَةٌ عَرَقٌ':Added, #2: 2	طَهَارَةِ عَرَقِهِ
u'طَهَارَةٌ عُضْوٌ':Added, #4: 4	طَهَارَةِ عَرَقِ
u'طَهَارَةٌ عُضْوٌ':Added, #1: 1	طَهَارَةَ الْعُضْوِ
u'طَهَارَةٌ عَظْمٌ':Added, #1: 1	طَهَارَةِ عُضْوٍ
u'طَهَارَةٌ عين':Added, #1: 1	طَهَارَةِ عَظْمِهِ
u'طَهَارَةٌ عَيْنٌ':Added, #1: 1	طَهَارَةَ الْعَيْنِ
u'طَهَارَةٌ عَيْن':Added, #1: 1	طَهَارَةَ الْعَيْنِ
u'طَهَارَةٌ عين':Added, #1: 1	طَهَارَةَ الْعَيْنِ
u'طَهَارَةٌ عَيْنٌ':Added, #2: 2	طَهَارَةَ عَيْنِهِ
u'طَهَارَةٌ عَيْن':Added, #2: 2	طَهَارَةَ عَيْنِهِ
u'طَهَارَةٌ عين':Added, #2: 2	طَهَارَةَ عَيْنِهِ
u'طَهَارَةٌ عين':Added, #5: 5	طَهَارَةُ عَيْنِهِ
u'طَهَارَةٌ عَيْنٌ':Added, #5: 5	طَهَارَةِ عَيْنِهِ
u'طَهَارَةٌ عَيْنٌ':Added, #5: 5	طَهَارَةُ عَيْنِهِ
u'طَهَارَةٌ عَيْن':Added, #5: 5	طَهَارَةِ عَيْنِهِ
u'طَهَارَةٌ عَيْن':Added, #5: 5	طَهَارَةُ عَيْنِهِ
u'طَهَارَةٌ غُسْلٌ':Added, #5: 5	طَهَارَةِ عَيْنِهِ
u'طَهَارَةٌ غَسْلٌ':Added, #1: 1	طَهَارَةُ الْغُسْلِ
u'طَهَارَةٌ غَسْلٌ':Added, #1: 1	طَهَارَةُ غَسْلٍ
u'طَهَارَةٌ غير':Added, #2: 2	طَهَارَةُ الْغَسْلِ
u'طَهَارَةٌ غَيْرٌ':Added, #1: 1	طَهَارَةِ غَيْرِ
u'طَهَارَةٌ فلان':Added, #1: 1	طَهَارَةِ غَيْرِ
u'طَهَارَةٌ فَمٌ':Added, #1: 1	طَهَارَةٍ تُرَابِيَّةٍ
u'طَهَارَةٌ قَدَمٌ':Added, #1: 1	طَهَارَةِ فَمِ
u'طَهَارَةٌ قُلَّةٌ':Added, #1: 1	طَهَارَةُ الْقَدَمَيْنِ
u'طَهَارَةٌ قُلُوبٌ':Added, #2: 2	طَهَارَةَ قُلَّةٍ
u'طَهَارَةٌ قَمِيصٌ':Added, #2: 2	طَهَارَةِ الْقُلُوبِ
u'طَهَارَةٌ قَيْءٌ':Added, #1: 1	طَهَارَةِ الْقَمِيصِ
u'طَهَارَةٌ قَيْحٌ':Added, #1: 1	طَهَارَةِ الْقَيْءِ
u'طَهَارَةٌ كَامِلٌ':Added, #1: 1	طَهَارَةُ قَيْحٍ
u'طَهَارَةٌ كَلْبٌ':Added, #32: 32	طَهَارَةٍ كَامِلَةٍ
u'طَهَارَةٌ لبس':Added, #2: 2	طَهَارَةِ الْكَلْبِ
u'طَهَارَةٌ لُبْسٌ':Added, #2: 2	طَهَارَةِ اللُّبْسِ
u'طَهَارَةٌ لبن':Added, #2: 2	طَهَارَةِ اللُّبْسِ
u'طَهَارَةٌ لَبَنٌ':Added, #1: 1	طَهَارَةِ لَبَنِ
u'طَهَارَةٌ لَحْمٌ':Added, #1: 1	طَهَارَةِ لَبَنِ
u'طَهَارَةٌ لَحْمٌ':Added, #1: 1	طَهَارَةُ لَحْمِهِ
u'طَهَارَةٌ لَحْمٌ':Added, #1: 1	طَهَارَةِ لَحْمِهِ
u'طَهَارَةٌ لَحْمٌ':Added, #2: 2	طَهَارَةَ اللَّحْمِ
u'طَهَارَةٌ لعاب':Added, #2: 2	طَهَارَةِ اللَّحْمِ
u'طَهَارَةٌ لُعَابٌ':Added, #1: 1	طَهَارَةَ اللُّعَابِ
u'طَهَارَةٌ مَاءٌ':Added, #1: 1	طَهَارَةَ اللُّعَابِ
u'طَهَارَةٌ مَاءٌ':Added, #31: 31	طَهَارَةِ الْمَاءِ
u'طَهَارَةٌ مَاءٌ':Added, #4: 4	طَهَارَةُ الْمَاءِ
u'طَهَارَةٌ مَأْكُولٌ':Added, #7: 7	طَهَارَةَ الْمَاءِ
u'طَهَارَةٌ مَائِيُّ':Added, #1: 1	طَهَارَةَ الْمَأْكُولِ
u'طَهَارَةٌ مَبِيعٌ':Added, #1: 1	طَهَارَةٍ مَائِيَّةٍ
u'طَهَارَةٌ مَحَلٌّ':Added, #1: 1	طَهَارَةِ الْمَبِيعِ
u'طَهَارَةٌ مَحَلٌّ':Added, #1: 1	طَهَارَةُ الْمَحَلِّ
u'طَهَارَةٌ مَحَلٌّ':Added, #1: 1	طَهَارَةُ مَحَلِّهِ
u'طَهَارَةٌ مَحَلٌّ':Added, #2: 2	طَهَارَةُ مَحَلِّ
u'طَهَارَةٌ مُحِيطٌ':Added, #6: 6	طَهَارَةِ الْمَحَلِّ
u'طَهَارَةٌ مُسْتَحَبٌّ':Added, #1: 1	طَهَارَةِ الْمُحِيطِ
u'طَهَارَةٌ مُسْتَعْمَلٌ':Added, #1: 1	طَهَارَةٍ مُسْتَحَبَّةٍ
u'طَهَارَةٌ مُسْتَعْمِلٌ':Added, #1: 1	طَهَارَةُ الْمُسْتَعْمَلِ
u'طَهَارَةٌ مُسْتَعْمَلٌ':Added, #1: 1	طَهَارَةِ الْمُسْتَعْمِلِ
u'طَهَارَةٌ مَسْحٌ':Added, #2: 2	طَهَارَةِ الْمُسْتَعْمَلِ
u'طَهَارَةٌ مَسْحٌ':Added, #1: 1	طَهَارَةِ الْمَسْحِ
u'طَهَارَةٌ مَسْحٌ':Added, #1: 1	طَهَارَةَ مَسْحٍ
u'طَهَارَةٌ مَسْحٌ':Added, #2: 2	طَهَارَةَ الْمَسْحِ
u'طَهَارَةٌ مِسْكٌ':Added, #3: 3	طَهَارَةُ مَسْحٍ
u'طَهَارَةٌ مَسْنُونٌ':Added, #1: 1	طَهَارَةِ الْمِسْكِ
u'طَهَارَةٌ مَشْرُوعٌ':Added, #3: 3	طَهَارَةٍ مَسْنُونَةٍ
u'طَهَارَةٌ مُعْتَبَرٌ':Added, #2: 2	طَهَارَةٍ مَشْرُوعَةٍ
u'طَهَارَةٌ مَعْذُورٌ':Added, #2: 2	طَهَارَةٍ مُعْتَبَرَةٍ
u'طَهَارَةٌ مَعْقُودٌ':Added, #2: 2	طَهَارَةَ الْمَعْذُورِ
u'طَهَارَةٌ مَكَانٌ':Added, #1: 1	طَهَارَةُ الْمَعْقُودِ
u'طَهَارَةٌ مَكَانٌ':Added, #1: 1	طَهَارَةَ مَكَانِ
u'طَهَارَةٌ مَكَانٌ':Added, #1: 1	طَهَارَةِ مَكَانِ
u'طَهَارَةٌ مَكَانٌ':Added, #1: 1	طَهَارَةِ مَكَانِهِ
u'طَهَارَةٌ مَكَانٌ':Added, #2: 2	طَهَارَةَ الْمَكَانِ
u'طَهَارَةٌ مَكَانٌ':Added, #2: 2	طَهَارَةُ الْمَكَانِ
u'طَهَارَةٌ مَكَانٌ':Added, #3: 3	طَهَارَةُ مَكَانِ
u'طَهَارَةٌ مَنْدُوبٌ':Added, #4: 4	طَهَارَةِ الْمَكَانِ
u'طَهَارَةٌ مُنْفَصِلٌ':Added, #1: 1	طَهَارَةٍ مَنْدُوبَةٍ
u'طَهَارَةٌ مَوَاضِعُ':Added, #1: 1	طَهَارَةُ مُنْفَصِلٍ
u'طَهَارَةٌ مَوْضِعٌ':Added, #1: 1	طَهَارَةُ مَوَاضِعِ
u'طَهَارَةٌ مَوْضِعٌ':Added, #1: 1	طَهَارَةُ الْمَوْضِعِ
u'طَهَارَةٌ مَوْضِعٌ':Added, #1: 1	طَهَارَةِ مَوْضِعِ
u'طَهَارَةٌ مَيْتٌ':Added, #3: 3	طَهَارَةُ مَوْضِعِ
u'طَهَارَةٌ مَيْتَةٌ':Added, #1: 1	طَهَارَةِ مَيْتَةِ
u'طَهَارَةٌ مَيْتَةٌ':Added, #1: 1	طَهَارَةَ مَيْتَةٍ
u'طَهَارَةٌ نَاقِصٌ':Added, #1: 1	طَهَارَةِ مَيْتَةِ
u'طَهَارَةٌ نَبِيذٌ':Added, #2: 2	طَهَارَةٍ نَاقِصَةٍ
u'طَهَارَةٌ نَجَاسَةٌ':Added, #3: 3	طَهَارَةُ النَّبِيذِ
u'طَهَارَةٌ نَجَسٌ':Added, #1: 1	طَهَارَةُ النَّجَاسَةِ
u'طَهَارَةٌ نُخَامَةٌ':Added, #2: 2	طَهَارَةُ النَّجَسِ
u'طَهَارَةٌ نَعْلٌ':Added, #1: 1	طَهَارَةِ النّخَامَةِ
u'طَهَارَةٌ وَاجِبٌ':Added, #1: 1	طَهَارَةِ النَّعْلَيْنِ
u'طَهَارَةٌ واحد':Added, #1: 1	طَهَارَةٍ وَاجِبَةٍ
u'طَهَارَةٌ وَاحِدٌ':Added, #3: 3	طَهَارَةٍ وَاحِدَةٍ
u'طَهَارَةٌ وُضُوءٌ':Added, #3: 3	طَهَارَةٍ وَاحِدَةٍ
u'طَهَارَةٌ وُضُوءٌ':Added, #1: 1	طَهَارَةَ الْوُضُوءِ
u'طَهَارَةٌ وُضُوءٌ':Added, #1: 1	طَهَارَةُ الْوُضُوءِ
u'طَهَارَةٌ يَدٌ':Added, #1: 1	طَهَارَةِ الْوُضُوءِ
u'طَهَارَةٌ يَدٌ':Added, #1: 1	طَهَارَةَ يَدِهِ
u'طَهَّرَ أحَدٌ':Predicate, #5: 5	طَهَارَةِ يَدِهِ
u'طهر أَرْبَعَةٌ':Added, #1: 1	طَهَّرَ أَحَدَ
u'طُهْرٌ أَرْبَعَةٌ':Added, #1: 1	طُهْرَ أَرْبَعَةٍ
u'طَهُرَ أقَلُّ':Subject, #1: 1	طُهْرَ أَرْبَعَةٍ
u'طَهُرَ أقَلُّ':Subject, #1: 1	طَهُرَ أَقَلُّ
u'طهر الْمَرْأَةُ':Added, #1: 1	طَهُرَ الْأَقَلُّ
u'طُهْرٌ الْمَرْأَةُ':Added, #1: 1	طُهْرِ الْمَرْأَةِ
u'طهر اِمْرَأَةٌ':Added, #1: 1	طُهْرِ الْمَرْأَةِ
u'طُهْرٌ اِمْرَأَةٌ':Added, #1: 1	طُهْرُ امْرَأَةٍ
u'طهر اِمْرَأَةٌ':Added, #1: 1	طُهْرُ امْرَأَةٍ
u'طُهْرٌ اِمْرَأَةٌ':Added, #2: 2	طُهْرِ امْرَأَةٍ
u'طَهُرَ إِناءٌ':Subject, #2: 2	طُهْرِ امْرَأَةٍ
u'طَهُرَ بادِئٌ':Subject, #2: 2	طَهُرَ الْإِنَاءُ
u'طَهُرَ بَعْضٌ':Subject, #2: 2	طَهُرَ الْبَادِئُ
u'طَهُرَ بَوْلٌ':Subject, #1: 1	طَهُرَ بَعْضُ
u'طُهْرٌ تَامٌّ':Added, #1: 1	طَهُرَ بَوْلُهُ
u'طهر تَيَمُّمٌ':Added, #7: 7	طُهْرٍ تَامٍّ
u'طُهْرٌ تَيَمُّمٌ':Added, #1: 1	طُهْرِ التَّيَمُّمِ
u'طَهَّرَ ثَوْبٌ':Predicate, #1: 1	طُهْرِ التَّيَمُّمِ
u'طَهُرَ ثَوْبٌ':Subject, #1: 1	طَهَّرَ الثَّوْبَ
u'طَهُرَ جلد':Subject, #3: 3	طَهُرَ الثَّوْبُ
u'طَهُرَ جِلْدٌ':Subject, #5: 5	طَهُرَ جِلْدُهُ
u'طهر حائِضٌ':Added, #5: 5	طَهُرَ جِلْدُهُ
u'طُهْرٌ حائِضٌ':Added, #1: 1	طُهْرِ الْحَائِضِ
u'طهر حَدَثٌ':Added, #1: 1	طُهْرِ الْحَائِضِ
u'طُهْرٌ حَدَثٌ':Added, #1: 1	طُهْرِ الْحَدَثِ
u'طهر حَيٌّ':Added, #1: 1	طُهْرِ الْحَدَثِ
u'طُهْرٌ حَيٌّ':Added, #2: 2	طُهْرِ الْحَيِّ
u'طهر حَيْضٌ':Added, #2: 2	طُهْرِ الْحَيِّ
u'طُهْرٌ حَيْضٌ':Added, #2: 2	طُهْرِ الْحَيْضِ
u'طهر حَيْضَةٌ':Added, #2: 2	طُهْرِ الْحَيْضِ
u'طُهْرٌ حَيْضَةٌ':Added, #2: 2	طُهْرِ الْحَيْضَةِ
u'طُهْرٌ خَالٌ':Added, #2: 2	طُهْرِ الْحَيْضَةِ
u'طهر خُبْثٌ':Added, #1: 1	طُهْرٍ خَالٍ
u'طُهْرٌ خُبْثٌ':Added, #1: 1	طُهْرُ الْخُبْثِ
u'طَهُرَ خُفٌّ':Subject, #1: 1	طُهْرُ الْخُبْثِ
u'طَهُرَ دونٌ':Predicate, #1: 1	طَهُرَ الْخُفُّ
u'طهر ذِمِّيٌّ':Added, #1: 1	طَهُرَ دُونَ
u'طُهْرٌ ذِمِّيٌّ':Added, #2: 2	طُهْرِ الذِّمِّيَّةِ
u'طهر سَبْعَةٌ':Added, #2: 2	طُهْرِ الذِّمِّيَّةِ
u'طُهْرٌ سَبْعَةٌ':Added, #1: 1	طُهْرُ سَبْعَةٍ
u'طهر سِتٌّ':Added, #1: 1	طُهْرُ سَبْعَةٍ
u'طُهْرٌ سِتٌّ':Added, #1: 1	طُهْرُ سِتَّةِ
u'طهر سَلِسٌ':Added, #1: 1	طُهْرُ سِتَّةِ
u'طُهْرٌ سَلِسٌ':Added, #1: 1	طُهْرَ السَّلِسِ
u'طهر شَهْرٌ':Added, #1: 1	طُهْرَ السَّلِسِ
u'طهر شَهْرٌ':Added, #1: 1	طُهْرَ شَهْرِ
u'طُهْرٌ شَهْرٌ':Added, #1: 1	طُهْرِ شَهْرِ
u'طُهْرٌ شَهْرٌ':Added, #1: 1	طُهْرَ شَهْرِ
u'طهر طَلاَقٌ':Added, #1: 1	طُهْرِ شَهْرِ
u'طُهْرٌ طَلاَقٌ':Added, #1: 1	طُهْرِ الطَّلَاقِ
u'طهر طَلاَقٌ':Added, #1: 1	طُهْرِ الطَّلَاقِ
u'طُهْرٌ طَلاَقٌ':Added, #2: 2	طُهْرُ الطَّلَاقِ
u'طَهُرَ ظاهِرٌ':Subject, #2: 2	طُهْرُ الطَّلَاقِ
u'طَهُرَ عَبْدٌ':Subject, #2: 2	طَهُرَ ظَاهِرُهُ
u'طهر عِدَّةٌ':Added, #1: 1	طَهُرَ الْعَبْدُ
u'طُهْرٌ عِدَّةٌ':Added, #1: 1	طُهْرِ الْعِدَّةِ
u'طَهُرَ عُضْوٌ':Subject, #1: 1	طُهْرِ الْعِدَّةِ
u'طَهُرَ فَمٌ':Subject, #1: 1	طَهُرَ الْعُضْوُ
u'طهر فَمٌ':Added, #4: 4	طَهُرَ فَمُهُ
u'طُهْرٌ فَمٌ':Added, #1: 1	طُهْرُ فَمِهِ
u'طهر فَمٌ':Added, #1: 1	طُهْرُ فَمِهِ
u'طُهْرٌ فَمٌ':Added, #2: 2	طُهْرِ فَمِ
u'طهر قَاذِفٌ':Added, #2: 2	طُهْرِ فَمِ
u'طُهْرٌ قَاذِفٌ':Added, #1: 1	طُهْرِ الْقَاذِفِ
u'طَهُرَ قَالٌ':Predicate, #1: 1	طُهْرِ الْقَاذِفِ
u'طُهْرٌ كَامِلٌ':Added, #1: 1	طَهُرَ قَالَ
u'طَهُرَ لَحْمٌ':Subject, #8: 8	طُهْرٍ كَامِلٍ
u'طَهُرَ مَاءٌ':Subject, #1: 1	طَهُرَ لَحْمُهُ
u'طَهُرَ مَاءٌ':Subject, #2: 2	طَهُرَ مَاءٌ
u'طهر مَجْنُونٌ':Added, #3: 3	طَهُرَ الْمَاءُ
u'طُهْرٌ مَجْنُونٌ':Added, #1: 1	طُهْرِ الْمَجْنُونَةِ
u'طَهُرَ مَحَلٌّ':Subject, #1: 1	طُهْرِ الْمَجْنُونَةِ
u'طُهْرٌ مُسْتَحَبٌّ':Added, #1: 1	طَهُرَ الْمَحَلُّ
u'طُهْرٌ مُسْتَقْبَلٌ':Added, #3: 3	طُهْرٍ مُسْتَحَبٍّ
u'طُهْرٌ مَشْكُوكٌ':Added, #1: 1	طُهْرٍ مُسْتَقْبَلٍ
u'طَهُرَ مَصْبُوغ':Subject, #2: 2	طُهْرٍ مَشْكُوكٍ
u'طُهْرٌ مَعْلُومٌ':Added, #1: 1	طَهُرَ الْمَصْبُوغُ
u'طهر مَلْمُوسٌ':Added, #1: 1	طُهْرٍ مَعْلُومٍ
u'طُهْرٌ مَلْمُوسٌ':Added, #1: 1	طُهْرَ الْمَلْمُوسِ
u'طهر مَلْمُوسٌ':Added, #1: 1	طُهْرَ الْمَلْمُوسِ
u'طُهْرٌ مَلْمُوسٌ':Added, #2: 2	طُهْرُ الْمَلْمُوسِ
u'طُهْرٌ واحد':Added, #2: 2	طُهْرُ الْمَلْمُوسِ
u'طُهْرٌ وَاحِدٌ':Added, #35: 35	طُهْرٍ وَاحِدٍ
u'طهر يَدٌ':Added, #35: 35	طُهْرٍ وَاحِدٍ
u'طُهْرٌ يَدٌ':Added, #1: 1	طُهْرَ يَدِهِ
u'طواف أحَدٌ':Added, #1: 1	طُهْرَ يَدِهِ
u'طَوَافٌ أحَدٌ':Added, #1: 1	طَوَافِ أَحَدٍ
u'طواف أَرْبَعَةٌ':Added, #1: 1	طَوَافِ أَحَدٍ
u'طَوَافٌ أَرْبَعَةٌ':Added, #1: 1	طَوَافُ أَرْبَعَةِ
u'طواف إضافَةٌ':Added, #1: 1	طَوَافُ أَرْبَعَةِ
u'طَوَافٌ إضافَةٌ':Added, #1: 1	طَوَافِ الْإِضَافَةِ
u'طواف إِفَاضَةٌ':Added, #1: 1	طَوَافِ الْإِضَافَةِ
u'طَوَافٌ إِفَاضَةٌ':Added, #11: 11	طَوَافُ الْإِفَاضَةِ
u'طواف إِفَاضَةٌ':Added, #11: 11	طَوَافُ الْإِفَاضَةِ
u'طَوَافٌ إِفَاضَةٌ':Added, #13: 13	طَوَافَ الْإِفَاضَةِ
u'طواف إِفَاضَةٌ':Added, #13: 13	طَوَافَ الْإِفَاضَةِ
u'طَوَافٌ إِفَاضَةٌ':Added, #1: 1	طَوَافِ إفَاضَتِهِ
u'طواف إِفَاضَةٌ':Added, #1: 1	طَوَافِ إفَاضَتِهِ
u'طَوَافٌ إِفَاضَةٌ':Added, #27: 27	طَوَافِ الْإِفَاضَةِ
u'طواف إِفَاضَةٌ':Added, #27: 27	طَوَافِ الْإِفَاضَةِ
u'طَوَافٌ إِفَاضَةٌ':Added, #2: 2	طَوَافِ الإِفَاضَةِ
u'طواف إِفَاضَةٌ':Added, #2: 2	طَوَافِ الإِفَاضَةِ
u'طَوَافٌ إِفَاضَةٌ':Added, #3: 3	طَوَافُ إفَاضَةٍ
u'طواف أَكْثَرُ':Added, #3: 3	طَوَافُ إفَاضَةٍ
u'طَوَافٌ أَكْثَرُ':Added, #1: 1	طَوَافِ أَكْثَرِ
u'طواف أَكْثَرُ':Added, #1: 1	طَوَافِ أَكْثَرِ
u'طَوَافٌ أَكْثَرُ':Added, #6: 6	طَوَافِ الْأَكْثَرِ
u'طواف تَحِيَّةٌ':Added, #6: 6	طَوَافِ الْأَكْثَرِ
u'طَوَافٌ تَحِيَّةٌ':Added, #13: 13	طَوَافَ التَّحِيَّةِ
u'طواف تَحِيَّةٌ':Added, #13: 13	طَوَافَ التَّحِيَّةِ
u'طَوَافٌ تَحِيَّةٌ':Added, #17: 17	طَوَافِ التَّحِيَّةِ
u'طواف تَحِيَّةٌ':Added, #17: 17	طَوَافِ التَّحِيَّةِ
u'طَوَافٌ تَحِيَّةٌ':Added, #2: 2	طَوَافَ تَحِيَّةٍ
u'طواف تَحِيَّةٌ':Added, #2: 2	طَوَافَ تَحِيَّةٍ
u'طَوَافٌ تَحِيَّةٌ':Added, #7: 7	طَوَافُ التَّحِيَّةِ
u'طواف تَطَوُّعٌ':Added, #7: 7	طَوَافُ التَّحِيَّةِ
u'طَوَافٌ تَطَوُّعٌ':Added, #1: 1	طَوَافُ التَّطَوُّعِ
u'طواف تَطَوُّعٌ':Added, #1: 1	طَوَافُ التَّطَوُّعِ
u'طَوَافٌ تَطَوُّعٌ':Added, #1: 1	طَوَافِ تَطَوُّعٍ
u'طواف تَطَوُّعٌ':Added, #1: 1	طَوَافِ تَطَوُّعٍ
u'طواف تَطَوُّعٌ':Added, #2: 2	طَوَافَ التَّطَوُّعِ
u'طَوَافٌ تَطَوُّعٌ':Added, #2: 2	طَوَافِ التَّطَوُّعِ
u'طَوَافٌ تَطَوُّعٌ':Added, #2: 2	طَوَافَ التَّطَوُّعِ
u'طواف حامِلٌ':Added, #2: 2	طَوَافِ التَّطَوُّعِ
u'طَوَافٌ حامِلٌ':Added, #1: 1	طَوَافِ الْحَامِلِ
u'طواف حَجٌّ':Added, #1: 1	طَوَافِ الْحَامِلِ
u'طَوَافٌ حَجٌّ':Added, #12: 12	طَوَافِ الْحَجِّ
u'طواف حَجٌّ':Added, #12: 12	طَوَافِ الْحَجِّ
u'طَوَافٌ حَجٌّ':Added, #2: 2	طَوَافَ الْحَجِّ
u'طواف حَجٌّ':Added, #2: 2	طَوَافَ الْحَجِّ
u'طَوَافٌ حَجٌّ':Added, #4: 4	طَوَافُ الْحَجِّ
u'طواف دُخُولٌ':Added, #4: 4	طَوَافُ الْحَجِّ
u'طَوَافٌ دُخُولٌ':Added, #2: 2	طَوَافِ الدُّخُولِ
u'طواف ذُكورٌ':Added, #2: 2	طَوَافِ الدُّخُولِ
u'طَوَافٌ ذُكورٌ':Added, #1: 1	طَوَافِ الذُّكُورِ
u'طواف رَاكِبٌ':Added, #1: 1	طَوَافِ الذُّكُورِ
u'طَوَافٌ رَاكِبٌ':Added, #1: 1	طَوَافِ الرَّاكِبِ
u'طواف رَسُولٌ':Added, #1: 1	طَوَافِ الرَّاكِبِ
u'طَوَافٌ رَسُولٌ':Added, #1: 1	طَوَافُ الرّسُولِ
u'طواف رُكْنٌ':Added, #1: 1	طَوَافُ الرّسُولِ
u'طواف رُكْن':Added, #11: 11	طَوَافِ الرُّكْنِ
u'طَوَافٌ رُكْنٌ':Added, #11: 11	طَوَافِ الرُّكْنِ
u'طَوَافٌ رُكْن':Added, #11: 11	طَوَافِ الرُّكْنِ
u'طواف رُكْنٌ':Added, #11: 11	طَوَافِ الرُّكْنِ
u'طواف رُكْن':Added, #1: 1	طَوَافُ الرُّكْنِ
u'طَوَافٌ رُكْنٌ':Added, #1: 1	طَوَافُ الرُّكْنِ
u'طَوَافٌ رُكْن':Added, #1: 1	طَوَافُ الرُّكْنِ
u'طواف رُكْنٌ':Added, #1: 1	طَوَافُ الرُّكْنِ
u'طواف رُكْن':Added, #1: 1	طَوَافُ رُكْنٍ
u'طَوَافٌ رُكْنٌ':Added, #1: 1	طَوَافُ رُكْنٍ
u'طَوَافٌ رُكْن':Added, #1: 1	طَوَافُ رُكْنٍ
u'طواف رُكْنٌ':Added, #1: 1	طَوَافُ رُكْنٍ
u'طواف رُكْن':Added, #3: 3	طَوَافَ الرُّكْنِ
u'طَوَافٌ رُكْنٌ':Added, #3: 3	طَوَافَ الرُّكْنِ
u'طَوَافٌ رُكْن':Added, #3: 3	طَوَافَ الرُّكْنِ
u'طواف زِيادَةٌ':Added, #3: 3	طَوَافَ الرُّكْنِ
u'طَوَافٌ زِيادَةٌ':Added, #1: 1	طَوَافَ الزِّيَادَةِ
u'طواف زِيادَةٌ':Added, #1: 1	طَوَافَ الزِّيَادَةِ
u'طَوَافٌ زِيادَةٌ':Added, #2: 2	طَوَافِ الزِّيَادَةِ
u'طواف زِيارَةٌ':Added, #2: 2	طَوَافِ الزِّيَادَةِ
u'طَوَافٌ زِيارَةٌ':Added, #154: 154	طَوَافِ الزِّيَارَةِ
u'طواف زِيارَةٌ':Added, #154: 154	طَوَافِ الزِّيَارَةِ
u'طَوَافٌ زِيارَةٌ':Added, #24: 24	طَوَافُ الزِّيَارَةِ
u'طواف زِيارَةٌ':Added, #24: 24	طَوَافُ الزِّيَارَةِ
u'طَوَافٌ زِيارَةٌ':Added, #70: 70	طَوَافَ الزِّيَارَةِ
u'طواف شَوْطٌ':Added, #70: 70	طَوَافَ الزِّيَارَةِ
u'طواف شَوْطٌ':Added, #1: 1	طَوَافَ شَوْطٍ
u'طَوَافٌ شَوْطٌ':Added, #1: 1	طَوَافِ شَوْطٍ
u'طَوَافٌ شَوْطٌ':Added, #1: 1	طَوَافَ شَوْطٍ
u'طواف صَدْرٌ':Added, #1: 1	طَوَافِ شَوْطٍ
u'طَوَافٌ صَدْرٌ':Added, #22: 22	طَوَافَ الصَّدْرِ
u'طواف صَدْرٌ':Added, #22: 22	طَوَافَ الصَّدْرِ
u'طَوَافٌ صَدْرٌ':Added, #27: 27	طَوَافُ الصَّدْرِ
u'طواف صَدْرٌ':Added, #27: 27	طَوَافُ الصَّدْرِ
u'طَوَافٌ صَدْرٌ':Added, #2: 2	طَوَافَ صَدْرٍ
u'طواف صَدْرٌ':Added, #2: 2	طَوَافَ صَدْرٍ
u'طَوَافٌ صَدْرٌ':Added, #34: 34	طَوَافِ الصَّدْرِ
u'طواف عُرْبَانٌ':Added, #34: 34	طَوَافِ الصَّدْرِ
u'طَوَافٌ عُرْبَانٌ':Added, #1: 1	طَوَافُ الْعُرْبَانِ
u'طواف عُرْيَانٌ':Added, #1: 1	طَوَافُ الْعُرْبَانِ
u'طَوَافٌ عُرْيَانٌ':Added, #1: 1	طَوَافِ الْعُرْيَانِ
u'طواف عمرة':Added, #1: 1	طَوَافِ الْعُرْيَانِ
u'طَوَافٌ عمرة':Added, #10: 10	طَوَافَ الْعُمْرَةِ
u'طواف عُمْرَةٌ':Added, #10: 10	طَوَافَ الْعُمْرَةِ
u'طَوَافٌ عُمْرَةٌ':Added, #10: 10	طَوَافَ الْعُمْرَةِ
u'طواف عمرة':Added, #10: 10	طَوَافَ الْعُمْرَةِ
u'طَوَافٌ عمرة':Added, #1: 1	طَوَافِ عُمْرَةٍ
u'طواف عُمْرَةٌ':Added, #1: 1	طَوَافِ عُمْرَةٍ
u'طَوَافٌ عُمْرَةٌ':Added, #1: 1	طَوَافِ عُمْرَةٍ
u'طواف عمرة':Added, #1: 1	طَوَافِ عُمْرَةٍ
u'طواف عمرة':Added, #1: 1	طَوَافُ عُمْرَتِهِ
u'طَوَافٌ عمرة':Added, #1: 1	طَوَافِ عُمْرَتِهِ
u'طَوَافٌ عمرة':Added, #1: 1	طَوَافُ عُمْرَتِهِ
u'طواف عُمْرَةٌ':Added, #1: 1	طَوَافِ عُمْرَتِهِ
u'طواف عُمْرَةٌ':Added, #1: 1	طَوَافُ عُمْرَتِهِ
u'طَوَافٌ عُمْرَةٌ':Added, #1: 1	طَوَافِ عُمْرَتِهِ
u'طَوَافٌ عُمْرَةٌ':Added, #1: 1	طَوَافُ عُمْرَتِهِ
u'طواف عمرة':Added, #1: 1	طَوَافِ عُمْرَتِهِ
u'طَوَافٌ عمرة':Added, #2: 2	طَوَافُ عُمْرَةٍ
u'طواف عُمْرَةٌ':Added, #2: 2	طَوَافُ عُمْرَةٍ
u'طَوَافٌ عُمْرَةٌ':Added, #2: 2	طَوَافُ عُمْرَةٍ
u'طواف عمرة':Added, #2: 2	طَوَافُ عُمْرَةٍ
u'طَوَافٌ عمرة':Added, #63: 63	طَوَافِ الْعُمْرَةِ
u'طواف عُمْرَةٌ':Added, #63: 63	طَوَافِ الْعُمْرَةِ
u'طَوَافٌ عُمْرَةٌ':Added, #63: 63	طَوَافِ الْعُمْرَةِ
u'طواف عمرة':Added, #63: 63	طَوَافِ الْعُمْرَةِ
u'طَوَافٌ عمرة':Added, #9: 9	طَوَافُ الْعُمْرَةِ
u'طواف عُمْرَةٌ':Added, #9: 9	طَوَافُ الْعُمْرَةِ
u'طَوَافٌ عُمْرَةٌ':Added, #9: 9	طَوَافُ الْعُمْرَةِ
u'طواف فَرْضٌ':Added, #9: 9	طَوَافُ الْعُمْرَةِ
u'طَوَافٌ فَرْضٌ':Added, #1: 1	طَوَافَ الْفَرْضِ
u'طواف فَرْضٌ':Added, #1: 1	طَوَافَ الْفَرْضِ
u'طَوَافٌ فَرْضٌ':Added, #1: 1	طَوَافِ فَرْضٍ
u'طواف فَرْضٌ':Added, #1: 1	طَوَافِ فَرْضٍ
u'طَوَافٌ فَرْضٌ':Added, #2: 2	طَوَافُ الْفَرْضِ
u'طواف فَرْضٌ':Added, #2: 2	طَوَافُ الْفَرْضِ
u'طَوَافٌ فَرْضٌ':Added, #6: 6	طَوَافِ الْفَرْضِ
u'طواف فرق':Added, #6: 6	طَوَافِ الْفَرْضِ
u'طَوَافٌ فرق':Added, #1: 1	طَوَافِ الْفَرْقِ
u'طواف فَرْقٌ':Added, #1: 1	طَوَافِ الْفَرْقِ
u'طَوَافٌ فَرْقٌ':Added, #1: 1	طَوَافِ الْفَرْقِ
u'طواف قَادِمٌ':Added, #1: 1	طَوَافِ الْفَرْقِ
u'طَوَافٌ قَادِمٌ':Added, #1: 1	طَوَافُ الْقَادِمِ
u'طواف قُدُومٌ':Added, #1: 1	طَوَافُ الْقَادِمِ
u'طواف قُدُومٌ':Added, #1: 1	طَوَافَ قُدُومٍ
u'طَوَافٌ قُدُومٌ':Added, #1: 1	طَوَافِ قُدُومٍ
u'طَوَافٌ قُدُومٌ':Added, #1: 1	طَوَافَ قُدُومٍ
u'طواف قُدُومٌ':Added, #1: 1	طَوَافِ قُدُومٍ
u'طَوَافٌ قُدُومٌ':Added, #1: 1	طَوَافُ قُدُومِهِ
u'طواف قُدُومٌ':Added, #1: 1	طَوَافُ قُدُومِهِ
u'طَوَافٌ قُدُومٌ':Added, #36: 36	طَوَافُ الْقُدُومِ
u'طواف قُدُومٌ':Added, #36: 36	طَوَافُ الْقُدُومِ
u'طَوَافٌ قُدُومٌ':Added, #40: 40	طَوَافَ الْقُدُومِ
u'طواف قُدُومٌ':Added, #40: 40	طَوَافَ الْقُدُومِ
u'طَوَافٌ قُدُومٌ':Added, #5: 5	طَوَافُ قُدُومٍ
u'طواف قُدُومٌ':Added, #5: 5	طَوَافُ قُدُومٍ
u'طَوَافٌ قُدُومٌ':Added, #64: 64	طَوَافِ الْقُدُومِ
u'طواف كَامِلٌ':Added, #64: 64	طَوَافِ الْقُدُومِ
u'طَوَافٌ كَامِلٌ':Added, #2: 2	طَوَافٍ كَامِلٍ
u'طواف كَائِنٌ':Added, #2: 2	طَوَافٍ كَامِلٍ
u'طَوَافٌ كَائِنٌ':Added, #1: 1	طَوَافٍ كَائِنٍ
u'طواف مُتَطَوِّعٌ':Added, #1: 1	طَوَافٍ كَائِنٍ
u'طَوَافٌ مُتَطَوِّعٌ':Added, #1: 1	طَوَافِ الْمُتَطَوِّعِ
u'طواف مُحْدِثٌ':Added, #1: 1	طَوَافِ الْمُتَطَوِّعِ
u'طَوَافٌ مُحْدِثٌ':Added, #1: 1	طَوَافِ الْمُحْدِثِ
u'طواف مُحْدِثٌ':Added, #1: 1	طَوَافِ الْمُحْدِثِ
u'طَوَافٌ مُحْدِثٌ':Added, #2: 2	طَوَافَ الْمُحْدِثِ
u'طواف مَحْمُولٌ':Added, #2: 2	طَوَافَ الْمُحْدِثِ
u'طَوَافٌ مَحْمُولٌ':Added, #1: 1	طَوَافِ الْمَحْمُولِ
u'طواف مُعْتَدٌّ':Added, #1: 1	طَوَافِ الْمَحْمُولِ
u'طَوَافٌ مُعْتَدٌّ':Added, #4: 4	طَوَافٍ مُعْتَدٍّ
u'طواف نَاسٌ':Added, #4: 4	طَوَافٍ مُعْتَدٍّ
u'طَوَافٌ نَاسٌ':Added, #2: 2	طَوَافِ النَّاسِ
u'طواف نذر':Added, #2: 2	طَوَافِ النَّاسِ
u'طَوَافٌ نذر':Added, #1: 1	طَوَافِ النَّذْرِ
u'طواف نَذْرٌ':Added, #1: 1	طَوَافِ النَّذْرِ
u'طَوَافٌ نَذْرٌ':Added, #1: 1	طَوَافِ النَّذْرِ
u'طواف نِساءٌ':Added, #1: 1	طَوَافِ النَّذْرِ
u'طَوَافٌ نِساءٌ':Added, #1: 1	طَوَافِ النِّسَاءِ
u'طواف نُسُكٌ':Added, #1: 1	طَوَافِ النِّسَاءِ
u'طَوَافٌ نُسُكٌ':Added, #1: 1	طَوَافِ نُسُكِهِ
u'طواف نُسُكٌ':Added, #1: 1	طَوَافِ نُسُكِهِ
u'طَوَافٌ نُسُكٌ':Added, #3: 3	طَوَافِ النُّسُكِ
u'طواف نَفْلٌ':Added, #3: 3	طَوَافِ النُّسُكِ
u'طواف نَفْلٌ':Added, #1: 1	طَوَافُ النَّفْلِ
u'طَوَافٌ نَفْلٌ':Added, #1: 1	طَوَافِ النَّفْلِ
u'طَوَافٌ نَفْلٌ':Added, #1: 1	طَوَافُ النَّفْلِ
u'طواف نَفْلٌ':Added, #1: 1	طَوَافِ النَّفْلِ
u'طواف نَفْلٌ':Added, #1: 1	طَوَافَ نَفْلٍ
u'طَوَافٌ نَفْلٌ':Added, #1: 1	طَوَافِ نَفْلٍ
u'طَوَافٌ نَفْلٌ':Added, #1: 1	طَوَافَ نَفْلٍ
u'طواف وَاجِبٌ':Added, #1: 1	طَوَافِ نَفْلٍ
u'طواف وَاجِبٌ':Added, #1: 1	طَوَافَ الْوَاجِبِ
u'طَوَافٌ وَاجِبٌ':Added, #1: 1	طَوَافُ الْوَاجِبِ
u'طَوَافٌ وَاجِبٌ':Added, #1: 1	طَوَافَ الْوَاجِبِ
u'طواف وَاجِبٌ':Added, #1: 1	طَوَافُ الْوَاجِبِ
u'طَوَافٌ وَاجِبٌ':Added, #3: 3	طَوَافٍ وَاجِبٍ
u'طواف واحد':Added, #3: 3	طَوَافٍ وَاجِبٍ
u'طَوَافٌ واحد':Added, #4: 4	طَوَافٍ وَاحِدٍ
u'طواف وَاحِدٌ':Added, #4: 4	طَوَافٍ وَاحِدٍ
u'طَوَافٌ وَاحِدٌ':Added, #4: 4	طَوَافٍ وَاحِدٍ
u'طواف وداع':Added, #4: 4	طَوَافٍ وَاحِدٍ
u'طَوَافٌ وداع':Added, #11: 11	طَوَافَ الْوَدَاعِ
u'طواف وَدَاعٌ':Added, #11: 11	طَوَافَ الْوَدَاعِ
u'طَوَافٌ وَدَاعٌ':Added, #11: 11	طَوَافَ الْوَدَاعِ
u'طواف وداع':Added, #11: 11	طَوَافَ الْوَدَاعِ
u'طَوَافٌ وداع':Added, #19: 19	طَوَافُ الْوَدَاعِ
u'طواف وَدَاعٌ':Added, #19: 19	طَوَافُ الْوَدَاعِ
u'طَوَافٌ وَدَاعٌ':Added, #19: 19	طَوَافُ الْوَدَاعِ
u'طواف وداع':Added, #19: 19	طَوَافُ الْوَدَاعِ
u'طَوَافٌ وداع':Added, #1: 1	طَوَافَ وَدَاعٍ
u'طواف وَدَاعٌ':Added, #1: 1	طَوَافَ وَدَاعٍ
u'طَوَافٌ وَدَاعٌ':Added, #1: 1	طَوَافَ وَدَاعٍ
u'طواف وداع':Added, #1: 1	طَوَافَ وَدَاعٍ
u'طَوَافٌ وداع':Added, #28: 28	طَوَافِ الْوَدَاعِ
u'طواف وَدَاعٌ':Added, #28: 28	طَوَافِ الْوَدَاعِ
u'طَوَافٌ وَدَاعٌ':Added, #28: 28	طَوَافِ الْوَدَاعِ
u'طواف وَلِيٌّ':Added, #28: 28	طَوَافِ الْوَدَاعِ
u'طَوَافٌ وَلِيٌّ':Added, #1: 1	طَوَافِ الْوَلِيِّ
u'طواف يَوْمٌ':Added, #1: 1	طَوَافِ الْوَلِيِّ
u'طَوَافٌ يَوْمٌ':Added, #1: 1	طَوَافُ يَوْمِ
u'طواف يَوْمٌ':Added, #1: 1	طَوَافُ يَوْمِ
u'طَوَافٌ يَوْمٌ':Added, #2: 2	طَوَافَ يَوْمِ
u'طواف يَوْمٌ':Added, #2: 2	طَوَافَ يَوْمِ
u'طَوَافٌ يَوْمٌ':Added, #4: 4	طَوَافِ يَوْمِ
u'طَوْعٌ الْمَرْأَةُ':Added, #4: 4	طَوَافِ يَوْمِ
u'طَوْعٌ عَقْلٌ':Added, #1: 1	طَوْعِ الْمَرْأَةِ
u'طُولٌ أحَدٌ':Added, #1: 1	طَوْعَ الْعَقْلِ
u'طُولٌ إِزَارٌ':Added, #1: 1	طُولُ أَحَدِ
u'طُولٌ أَظْفارٌ':Added, #1: 1	طُولُ الْإِزَارِ
u'طَوَّلَ أَعَمُّ':Subject, #1: 1	طُولُ الْأَظْفَارِ
u'طُولٌ إقامَةٌ':Added, #1: 1	طَوَّلَ أَعَمُّ
u'طُولٌ إقامَةٌ':Added, #1: 1	طُولِ إقَامَةٍ
u'طُولٌ إقامَةٌ':Added, #1: 1	طُولُ الْإِقَامَةِ
u'طَوَّلَ إمَامٌ':Subject, #2: 2	طُولِ إقَامَتِهِ
u'طَوَّلَ إمَامٌ':Subject, #1: 1	طَوَّلَ الْإِمَامُ
u'طُولٌ أَمَدٌ':Added, #1: 1	طَوَّلَ إمَامُهُ
u'طُولٌ أَمَلٌ':Added, #2: 2	طُولِ الْأَمَدِ
u'طُولٌ أَمَلٌ':Added, #2: 2	طُولُ الْأَمَلِ
u'طُولٌ أنَامِلُ':Added, #3: 3	طُولِ الْأَمَلِ
u'طُولٌ إِنْسانٌ':Added, #1: 1	طُولَ الْأَنَامِلِ
u'طُولٌ اِنْطِباقٌ':Added, #1: 1	طُولِ الْإِنْسَانِ
u'طُولٌ أَنْفٌ':Added, #1: 1	طُولِ انْطِبَاقِ
u'طُولٌ بَابٌ':Added, #1: 1	طُولِ الْأَنْفِ
u'طُولٌ بَحْثٌ':Added, #9: 9	طُولِ الْبَابِ
u'طُولٌ بَقاءٌ':Added, #2: 2	طُولِ الْبَحْثِ
u'طُولٌ بَقاءٌ':Added, #1: 1	طُولَ الْبَقَاءِ
u'طُولٌ بِنَاءٌ':Added, #1: 1	طُولِ الْبَقَاءِ
u'طُولٌ بِئْرٌ':Added, #1: 1	طُولِ الْبِنَاءِ
u'طُولٌ تَأْخِيرٌ':Added, #2: 2	طُولِ الْبِئْرِ
u'طُولٌ تَجَارِبُ':Added, #1: 1	طُولُ تَأْخِيرِ
u'طُولٌ تَجَشُّمٌ':Added, #1: 1	طُولُ التَّجَارِبِ
u'طُولٌ تَرَبُّصٌ':Added, #1: 1	طُولِ التَّجَشُّمِ
u'طُولٌ تَفْكِيرٌ':Added, #1: 1	طُولَ التَّرَبُّصِ
u'طُولٌ تَكْريرٌ':Added, #1: 1	طُولَ التَّفْكِيرِ
u'طُولٌ تَنَازُعٌ':Added, #1: 1	طُولِ تَكْرِيرِهِ
u'طُولٌ تَهَجُّدٌ':Added, #1: 1	طُولِ التَّنَازُعِ
u'طَوَّلَ ثَالِثٌ':Predicate, #1: 1	طُولِ التَّهَجُّدِ
u'طُولٌ ثَوْبٌ':Added, #1: 1	طَوَّلَ الثَّالِثَةَ
u'طُولٌ ثَوْبٌ':Added, #1: 1	طُولِ الثَّوْبِ
u'طُولٌ ثِيابٌ':Added, #1: 1	طُولِ ثَوْبِهِ
u'طُولٌ جِدار':Added, #1: 1	طُولِ ثِيَابِهِ
u'طَوَّلَ جلسة':Predicate, #1: 1	طُولِ الْجِدَارِ
u'طَوَّلَ جَلْسَةٌ':Predicate, #1: 1	طَوَّلَ الْجَلْسَةَ
u'طُولٌ جُلُوسٌ':Added, #1: 1	طَوَّلَ الْجَلْسَةَ
u'طُولٌ جُلُوسٌ':Added, #1: 1	طُولِ الْجُلُوسِ
u'طُولٌ جُمَّةٌ':Added, #1: 1	طُولِ جُلُوسِهِ
u'طَوَّلَ جمعة':Predicate, #1: 1	طُولُ جُمَّتِهِ
u'طَوَّلَ جُمُعَةٌ':Predicate, #1: 1	طَوَّلَ الْجُمُعَةَ
u'طُولٌ حائِطٌ':Added, #1: 1	طَوَّلَ الْجُمُعَةَ
u'طُولٌ حَبْسٌ':Added, #1: 1	طُولَ الْحَائِطِ
u'طُولٌ حَبْسٌ':Added, #1: 1	طُولَ الْحَبْسِ
u'طُولٌ حَبْسٌ':Added, #1: 1	طُولِ الْحَبْسِ
u'طُولٌ حَبْلٌ':Added, #1: 1	طُولَ حَبْسِهِ
u'طُولٌ حَبْلٌ':Added, #1: 1	طُولَ الْحَبْلِ
u'طُولٌ حَجَرٌ':Added, #1: 1	طُولِ الْحَبْلِ
u'طُولٌ حَدٌّ':Added, #1: 1	طُولُ الْحَجَرِ
u'طُولٌ حُرٌّ':Added, #3: 3	طُولِ الْحَدِّ
u'طُولٌ حُزْنٌ':Added, #1: 1	طُولَ الْحُرَّةِ
u'طُولٌ حَيَاةٌ':Added, #1: 1	طُولِ الْحُزْنِ
u'طُولٌ حَيَاةٌ':Added, #1: 1	طُولُ الْحَيَاةِ
u'طُولٌ حَيَاةٌ':Added, #1: 1	طُولِ حَيَاتِهِ
u'طُولٌ حَيَاةٌ':Added, #2: 2	طُولَ الْحَيَاةِ
u'طُولٌ خُفٌّ':Added, #3: 3	طُولِ الْحَيَاةِ
u'طُولٌ خُلُودٌ':Added, #1: 1	طُولُ الْخُفِّ
u'طُولٌ خَمْسَةٌ':Added, #1: 1	طُولَ الْخُلُودِ
u'طُولٌ دَهْرٌ':Added, #1: 1	طُولَ خَمْسَةٍ
u'طُولٌ ذِراعٌ':Added, #2: 2	طُولَ الدَّهْرِ
u'طُولٌ ذِراعٌ':Added, #1: 1	طُولَ ذِرَاعٍ
u'طُولٌ رَأْسٌ':Added, #1: 1	طُولُ ذِرَاعٍ
u'طُولٌ رَأْسٌ':Added, #1: 1	طُولِ الرَّأْسِ
u'طُولٌ رَجُلٌ':Added, #1: 1	طُولِ رَأْسِ
u'طُولٌ رَحْلٌ':Added, #1: 1	طُولَ الرَّجُلِ
u'طَوَّلَ رُكْنٌ':Predicate, #1: 1	طُولِ الرَّحْلِ
u'طَوَّلَ رُكْن':Predicate, #1: 1	طَوَّلَ الرُّكْنَ
u'طَوَّلَ رُكوعٌ':Predicate, #1: 1	طَوَّلَ الرُّكْنَ
u'طُولٌ زَمانٌ':Added, #2: 2	طَوَّلَ الرُّكُوعَ
u'طُولٌ زَمانٌ':Added, #1: 1	طُولَ الزَّمَانِ
u'طُولٌ زَمانٌ':Added, #1: 1	طُولُ زَمَانٍ
u'طُولٌ زَمانٌ':Added, #1: 1	طُولُ زَمَانِ
u'طُولٌ زَمانٌ':Added, #1: 1	طُولِ زَمَانٍ
u'طُولٌ زَمانٌ':Added, #1: 1	طُولَ زَمَانِهِ
u'طُولٌ زَمانٌ':Added, #1: 1	طُولُ زَمَانِهِ
u'طُولٌ زَمانٌ':Added, #21: 21	طُولِ الزَّمَانِ
u'طُولٌ زَمَنٌ':Added, #2: 2	طُولُ الزَّمَانِ
u'طُولٌ زَمَنٌ':Added, #1: 1	طُولَ الزَّمَنِ
u'طُولٌ زَمَنٌ':Added, #1: 1	طُولِ الزّمَنِ
u'طُولٌ زَمَنٌ':Added, #1: 1	طُولُ زَمَنِ
u'طُولٌ زَمَنٌ':Added, #2: 2	طُولُ الزَّمَنِ
u'طُولٌ زَمَنٌ':Added, #2: 2	طُولَ زَمَنِ
u'طُولٌ سُجُودٌ':Added, #5: 5	طُولِ الزَّمَنِ
u'طُولٌ سُرُورٌ':Added, #2: 2	طُولَ السُّجُودِ
u'طُولٌ سِفَارٌ':Added, #1: 1	طُولِ سُرُورِهِ
u'طُولٌ سَفَرٌ':Added, #1: 1	طُولِ السّفَارِ
u'طُولٌ سَفَرٌ':Added, #1: 1	طُولِ السَّفَرِ
u'طُولٌ سَفَرٌ':Added, #1: 1	طُولَ سَفَرِهِ
u'طُولٌ سُفْلٌ':Added, #1: 1	طُولِ سَفَرِهِ
u'طُولٌ سُكُوتٌ':Added, #1: 1	طُولِ سُفْلِ
u'طُولٌ سُكُوتٌ':Added, #1: 1	طُولُ السُّكُوتِ
u'طُولٌ سَوادٌ':Added, #3: 3	طُولِ السُّكُوتِ
u'طُولٌ سُؤَالٌ':Added, #1: 1	طُولُ سَوَادِ
u'طُولٌ سَيْرٌ':Added, #1: 1	طُولُ السُّؤَالِ
u'طُولٌ شَارِبٌ':Added, #1: 1	طُولِ السّيْرِ
u'طُولٌ شَارِعٌ':Added, #1: 1	طُولِ الشَّارِبِ
u'طُولٌ شَعْرٌ':Added, #1: 1	طُولِ الشَّارِعِ
u'طُولٌ شَعِيرٌ':Added, #1: 1	طُولِ الشَّعْرِ
u'طُولٌ صبر':Added, #1: 1	طُولِ الشَّعِيرِ
u'طُولٌ صَبْرٌ':Added, #1: 1	طُولُ الصَّبْرِ
u'طُولٌ صحبة':Added, #1: 1	طُولُ الصَّبْرِ
u'طُولٌ صُحْبَةٌ':Added, #1: 1	طُولَ الصُّحْبَةِ
u'طُولٌ صحبة':Added, #1: 1	طُولَ الصُّحْبَةِ
u'طُولٌ صُحْبَةٌ':Added, #1: 1	طُولُ صُحْبَتِهِ
u'طُولٌ صحبة':Added, #1: 1	طُولُ صُحْبَتِهِ
u'طُولٌ صُحْبَةٌ':Added, #5: 5	طُولِ الصُّحْبَةِ
u'طُولٌ صَلاَةٌ':Added, #5: 5	طُولِ الصُّحْبَةِ
u'طُولٌ صَلاَةٌ':Added, #1: 1	طُولَ الصَّلاَةِ
u'طُولٌ صَلاَةٌ':Added, #1: 1	طُولُ الصَّلَاةِ
u'طُولٌ صَلاَةٌ':Added, #1: 1	طُولَ صَلاةِ
u'طُولٌ صَلاَةٌ':Added, #1: 1	طُولَ صَلَاةِ
u'طُولٌ صَلاَةٌ':Added, #1: 1	طُولَ صَلاَةِ
u'طُولٌ صَلاَةٌ':Added, #1: 1	طُولُ صَلَاةِ
u'طُولٌ ضراب':Added, #2: 2	طُولَ الصَّلَاةِ
u'طُولٌ طَاقَةٌ':Added, #1: 1	طُولِ الضِّرَابِ
u'طُولٌ طَرِيقٌ':Added, #1: 1	طُولُ الطَّاقَةِ
u'طُولٌ طَرِيقٌ':Added, #1: 1	طُولَ الطَّرِيقِ
u'طَوَّلَ عِبَارَةٌ':Predicate, #1: 1	طُولِ الطَّرِيقِ
u'طُولٌ عِبَارَةٌ':Added, #1: 1	طَوَّلَ الْعِبَارَةَ
u'طُولٌ عتاب':Added, #1: 1	طُولِ الْعِبَارَةِ
u'طُولٌ عِتَابٌ':Added, #1: 1	طُولُ الْعِتَابِ
u'طَوَّلَ عِدَّةٌ':Predicate, #1: 1	طُولُ الْعِتَابِ
u'طُولٌ عِدَّةٌ':Added, #1: 1	طَوَّلَ الْعِدَّةَ
u'طُولٌ عِدَّةٌ':Added, #1: 1	طُولَ الْعِدَّةِ
u'طُولٌ عَدُوٌّ':Added, #2: 2	طُولُ الْعِدَّةِ
u'طُولٌ عَشْرٌ':Added, #1: 1	طُولِ الْعَدُوِّ
u'طُولٌ عِشْرَةٌ':Added, #1: 1	طُولِ عَشْرَةٍ
u'طُولٌ عُمُرٌ':Added, #1: 1	طُولِ عِشْرَةِ
u'طُولٌ عُمُرٌ':Added, #1: 1	طُولُ عُمُرِهِ
u'طُولٌ عُمُرٌ':Added, #1: 1	طُولِ عُمُرِهِ
u'طُولٌ عُمُرٌ':Added, #2: 2	طُولَ الْعُمُرِ
u'طُولٌ عُمُرٌ':Added, #2: 2	طُولُ الْعُمُرِ
u'طُولٌ عُمُرٌ':Added, #4: 4	طُولِ الْعُمُرِ
u'طُولٌ عَهْدٌ':Added, #6: 6	طُولَ عُمُرِهِ
u'طُولٌ عَهْدٌ':Added, #1: 1	طُولِ عَهْدِ
u'طُولٌ غَرَضٌ':Added, #3: 3	طُولِ الْعَهْدِ
u'طُولٌ غناء':Added, #1: 1	طُولِ الْغَرَضِ
u'طُولٌ غَنَاءٌ':Added, #1: 1	طُولِ الْغَنَاءِ
u'طُولٌ فَرَسٌ':Added, #1: 1	طُولِ الْغَنَاءِ
u'طُولٌ فَصْلٌ':Added, #1: 1	طُولُ الْفَرَسِ
u'طُولٌ فَصْلٌ':Added, #1: 1	طُولَ فَصْلٍ
u'طُولٌ فَصْلٌ':Added, #27: 27	طُولِ الْفَصْلِ
u'طُولٌ فَصْلٌ':Added, #4: 4	طُولَ الْفَصْلِ
u'طُولٌ فِعْلٌ':Added, #5: 5	طُولُ الْفَصْلِ
u'طُولٌ قَامَةٌ':Added, #1: 1	طُولِ الْفِعْلِ
u'طُولٌ قَامَةٌ':Added, #1: 1	طُولُ الْقَامَةِ
u'طُولٌ قَبْرٌ':Added, #2: 2	طُولِ الْقَامَةِ
u'طُولٌ قدم':Added, #1: 1	طُولُ الْقَبْرِ
u'طُولٌ قِدَمٌ':Added, #1: 1	طُولُ الْقِدَمِ
u'طَوَّلَ قِرَاءةٌ':Predicate, #1: 1	طُولُ الْقِدَمِ
u'طَوَّلَ قِرَاءةٌ':Predicate, #2: 2	طَوَّلَ قِرَاءَةَ
u'طُولٌ قِرَاءةٌ':Added, #5: 5	طَوَّلَ الْقِرَاءَةَ
u'طُولٌ قِرَاءةٌ':Added, #1: 1	طُولَ قِرَاءَتِهِ
u'طُولٌ قِرَاءةٌ':Added, #2: 2	طُولُ الْقِرَاءَةِ
u'طُولٌ قَمِيصٌ':Added, #3: 3	طُولِ الْقِرَاءَةِ
u'طُولٌ قَنَاةٌ':Added, #1: 1	طُولُ قَمِيصِ
u'طُولٌ قنات':Added, #1: 1	طُولَ قَنَاتِهِ
u'طُولٌ قُنُوتٌ':Added, #1: 1	طُولَ قَنَاتِهِ
u'طَوَّلَ قيام':Predicate, #10: 10	طُولُ الْقُنُوتِ
u'طَوَّلَ قِيَامٌ':Predicate, #1: 1	طَوَّلَ الْقِيَامَ
u'طُولٌ قيام':Added, #1: 1	طَوَّلَ الْقِيَامَ
u'طُولٌ قِيَامٌ':Added, #12: 12	طُولِ الْقِيَامِ
u'طُولٌ قيام':Added, #12: 12	طُولِ الْقِيَامِ
u'طُولٌ قِيَامٌ':Added, #14: 14	طُولُ الْقِيَامِ
u'طُولٌ قيام':Added, #14: 14	طُولُ الْقِيَامِ
u'طُولٌ قِيَامٌ':Added, #5: 5	طُولَ الْقِيَامِ
u'طُولٌ كِتَابٌ':Added, #5: 5	طُولَ الْقِيَامِ
u'طُولٌ كُسُوفٌ':Added, #1: 1	طُولِ الْكِتَابِ
u'طُولٌ كَلاَمٌ':Added, #1: 1	طُولِ الْكُسُوفِ
u'طُولٌ لِحْيَةٌ':Added, #2: 2	طُولِ الْكَلَامِ
u'طُولٌ لِسَانٌ':Added, #1: 1	طُولَ لِحْيَتِهِ
u'طُولٌ لَهْوٌ':Added, #1: 1	طُولِ اللِّسَانِ
u'طُولٌ لَيَالِي':Added, #1: 1	طُولِ اللَّهْوِ
u'طُولٌ لَيْلٌ':Added, #1: 1	طُولِ اللَّيَالِيِ
u'طُولٌ مَاءٌ':Added, #3: 3	طُولَ اللَّيْلِ
u'طُولٌ مَاءٌ':Added, #1: 1	طُولُ الْمَاءِ
u'طُولٌ مُبَاحَثَةٌ':Added, #1: 1	طُولِ الْمَاءِ
u'طُولٌ مَبِيعٌ':Added, #1: 1	طُولِ الْمُبَاحَثَةِ
u'طُولٌ مَجْلِسٌ':Added, #2: 2	طُولِ الْمَبِيعِ
u'طُولٌ مَجْلِسٌ':Added, #1: 1	طُولُ الْمَجْلِسِ
u'طَوَّلَ مُحَمَّدٌ':Subject, #1: 1	طُولِ الْمَجْلِسِ
u'طُولٌ مَدٌّ':Added, #3: 3	طَوَّلَ مُحَمَّدٌ
u'طَوَّلَ مُدَّةٌ':Predicate, #2: 2	طُولِ الْمَدِّ
u'طُولٌ مُدَّةٌ':Added, #1: 1	طَوَّلَ الْمُدَّةَ
u'طُولٌ مُدَّةٌ':Added, #17: 17	طُولِ الْمُدَّةِ
u'طُولٌ مُدَّةٌ':Added, #1: 1	طُولِ الْمُدّةِ
u'طُولٌ مُدَّةٌ':Added, #1: 1	طُولُ مُدَّةِ
u'طُولٌ مُدَّةٌ':Added, #1: 1	طُولِ مُدَّتِهِ
u'طُولٌ مُدَّةٌ':Added, #2: 2	طُولُ الْمُدَّةِ
u'طُولٌ مُدَّةٌ':Added, #2: 2	طُولِ مُدَّةِ
u'طُولٌ مُدَوَّرٌ':Added, #6: 6	طُولَ الْمُدَّةِ
u'طُولٌ مَرَضٌ':Added, #3: 3	طُولِ الْمُدَوَّرِ
u'طُولٌ مَرَضٌ':Added, #1: 1	طُولَ مَرَضِهِ
u'طُولٌ مَسَافَةٌ':Added, #2: 2	طُولِ الْمَرَضِ
u'طُولٌ مُقَامٌ':Added, #1: 1	طُولِ الْمَسَافَةِ
u'طُولٌ مُكْثٌ':Added, #1: 1	طُولِ الْمُقَامِ
u'طُولٌ مُكْثٌ':Added, #1: 1	طُولُ مُكْثِ
u'طُولٌ مُكْثٌ':Added, #1: 1	طُولِ مُكْثٍ
u'طُولٌ مُكْثٌ':Added, #1: 1	طُولِ مُكْثِهِ
u'طُولٌ مُكْثٌ':Added, #2: 2	طُولُ الْمُكْثِ
u'طَوَّلَ مُنْفَرِدٌ':Subject, #3: 3	طُولِ الْمُكْثِ
u'طُولٌ نِجَادٌ':Added, #1: 1	طَوَّلَ الْمُنْفَرِدُ
u'طُولٌ نهار':Added, #1: 1	طُولِ النِّجَادِ
u'طُولٌ نَهَارٌ':Added, #1: 1	طُولُ النَّهَارِ
u'طُولٌ نهار':Added, #1: 1	طُولُ النَّهَارِ
u'طُولٌ نَهَارٌ':Added, #2: 2	طُولِ النَّهَارِ
u'طُولٌ نهار':Added, #2: 2	طُولِ النَّهَارِ
u'طُولٌ نَهَارٌ':Added, #4: 4	طُولَ النَّهَارِ
u'طُولٌ نَهْرٌ':Added, #4: 4	طُولَ النَّهَارِ
u'طُولٌ نَهْرٌ':Added, #1: 1	طُولَ النَّهْرِ
u'طُولٌ واحد':Added, #3: 3	طُولِ النَّهْرِ
u'طُولٌ وَاحِدٌ':Added, #1: 1	طُولٍ وَاحِدٍ
u'طُولٌ وُقُوفٌ':Added, #1: 1	طُولٍ وَاحِدٍ
u'طُولٌ يَوْمٌ':Added, #1: 1	طُولِ الْوُقُوفِ
u'طَوَى تَصْرِيحٌ':Subject, #1: 1	طُولَ يَوْمِهِ
u'طَوَى زمر':Predicate, #1: 1	طَوَى التَّصْرِيحُ
u'طَوَى زَمْرٌ':Predicate, #1: 1	طَوَى زَمْرَ
u'طَوَى غَاصِبٌ':Subject, #1: 1	طَوَى زَمْرَ
u'طَوَى مَنَاهِلُ':Predicate, #1: 1	طَوَى الْغَاصِبُ
u'طَوَى نَاسٌ':Subject, #1: 1	طَوَى الْمَنَاهِلَ
u'طَيَّبَ أقَلُّ':Predicate, #1: 1	طَوَى النَّاسُ
u'طِيبٌ الْمَرْأَةُ':Added, #3: 3	طَيَّبَ أَقَلَّ
u'طِيبٌ اِمْرَأَةٌ':Added, #2: 2	طِيبِ الْمَرْأَةِ
u'طَيَّبَ إِنْسانٌ':Subject, #1: 1	طِيبِ امْرَأَتِهِ
u'طِيبٌ أهْلٌ':Added, #1: 1	طَيَّبَ إنْسَانٌ
u'طِيبٌ أَوَّلُ':Added, #2: 2	طِيبِ أَهْلِهِ
u'طَيَّبَ بَيَانٌ':Subject, #1: 1	طِيبِ أَوَّلِ
u'طِيبٌ بَيْتٌ':Added, #1: 1	طَيَّبَ بَيَانٌ
u'طِيبَةٌ حَجَّام':Added, #2: 2	طِيبِ بَيْتِهِ
u'طِيبَةٌ صَعِيدٌ':Added, #1: 1	طِيبَةَ الْحَجَّامِ
u'طِيبَةٌ لَحْمٌ':Added, #1: 1	طِيبَةُ الصَّعِيدِ
u'طِيبَةٌ نَفْسٌ':Added, #1: 1	طِيبَةِ لَحْمِهِ
u'طِيبَةٌ نَفْسٌ':Added, #2: 2	طِيبَةِ نَفْسٍ
u'طِيبٌ ثَمَرَةٌ':Added, #2: 2	طِيبَةِ نَفْسِهِ
u'طِيبٌ ثَمَنٌ':Added, #4: 4	طِيبِ الثَّمَرَةِ
u'طِيبٌ ثَناءٌ':Added, #1: 1	طِيبِ الثَّمَنِ
u'طِيبٌ جَمِيع':Added, #1: 1	طِيبُ الثّنَاءِ
u'طِيبٌ حَرائِرُ':Added, #1: 1	طِيبَ الْجَمِيعِ
u'طِيبٌ حَرَائِرُ':Added, #1: 1	طِيبَ الْحَرَائِرِ
u'طِيبٌ رَائِحٌ':Added, #1: 1	طِيبَ الْحَرَائِرِ
u'طِيبٌ رَائِحَةٌ':Added, #2: 2	طِيبِ الرَّائِحَةِ
u'طِيبٌ رِبْحٌ':Added, #2: 2	طِيبِ الرَّائِحَةِ
u'طَيَّبَ رُبُعٌ':Predicate, #1: 1	طِيبِ الرِّبْحِ
u'طِيبٌ رِجَالٌ':Added, #2: 2	طَيَّبَ رُبُعَ
u'طِيبٌ رِجَالٌ':Added, #1: 1	طِيبَ الرِّجَالِ
u'طِيبٌ رَجُلٌ':Added, #1: 1	طِيبِ الرِّجَالِ
u'طِيبٌ زَرْعٌ':Added, #1: 1	طِيبَ الرَّجُلِ
u'طِيبٌ صنعة':Added, #1: 1	طِيبِ الزَّرْعِ
u'طِيبٌ صَنْعَةٌ':Added, #1: 1	طِيبِ الصَّنْعَةِ
u'طِيبٌ عرف':Added, #1: 1	طِيبِ الصَّنْعَةِ
u'طِيبٌ عَرْفٌ':Added, #1: 1	طِيبُ عَرْفِ
u'طِيبٌ فَضْلٌ':Added, #1: 1	طِيبُ عَرْفِ
u'طَيَّبَ كعبة':Predicate, #1: 1	طِيبَ الْفَضْلِ
u'طَيَّبَ كَعْبَةٌ':Predicate, #1: 1	طَيَّبَ الْكَعْبَةَ
u'طِيبٌ كعبة':Added, #1: 1	طَيَّبَ الْكَعْبَةَ
u'طِيبٌ كَعْبَةٌ':Added, #3: 3	طِيبِ الْكَعْبَةِ
u'طِيبٌ كَلاَمٌ':Added, #3: 3	طِيبِ الْكَعْبَةِ
u'طِيبٌ لَحْمٌ':Added, #2: 2	طِيبُ الْكَلَامِ
u'طِيبٌ لَحْمٌ':Added, #1: 1	طِيبِ اللَّحْمِ
u'طَيَّبَ مُحْرِمٌ':Subject, #3: 3	طِيبُ اللَّحْمِ
u'طَيَّبَ مُحْرِمٌ':Subject, #1: 1	طَيَّبَ الْمُحْرِمُ
u'طِيبٌ مُرْتَفِعٌ':Added, #3: 3	طَيَّبَ مُحْرِمٌ
u'طِيبٌ مَعِيشَةٌ':Added, #1: 1	طِيبٍ مُرْتَفِعٍ
u'طِيبٌ ملاء':Added, #1: 1	طِيبُ الْمَعِيشَةِ
u'طِيبٌ نِساءٌ':Added, #2: 2	طِيبَ الْمَلَاءِ
u'طِيبٌ نِساءٌ':Added, #1: 1	طِيبَ النِّسَاءِ
u'طِيبٌ نَفْسٌ':Added, #2: 2	طِيبِ النِّسَاءِ
u'طِيبٌ نَفْسٌ':Added, #1: 1	طِيبَ نَفْسٍ
u'طِيبٌ نَفْسٌ':Added, #1: 1	طِيبُ نَفْسِ
u'طِيبٌ نَفْسٌ':Added, #1: 1	طِيبِ نَفْسِ
u'طِيبٌ نَفْسٌ':Added, #20: 20	طِيبِ نَفْسٍ
u'طِيبٌ نَفْسٌ':Added, #2: 2	طِيبَ النَّفْسِ
u'طِيبٌ نَفْسٌ':Added, #2: 2	طِيبِ النَّفْسِ
u'طَيَّبَ نَكْهَةٌ':Predicate, #4: 4	طِيبِ نَفْسِهِ
u'طَيَرَانٌ غُرَابٌ':Added, #1: 1	طَيَّبَ النَّكْهَةَ
u'طَيْرٌ بَحْرٌ':Added, #1: 1	طَيَرَانِ غُرَابٍ
u'طَيْرٌ بَرٌّ':Added, #3: 3	طَيْرُ الْبَحْرِ
u'طَيْرٌ بُروجٌ':Added, #1: 1	طَيْرَ الْبَرِّ
u'طَيْرٌ بيض':Added, #1: 1	طَيْرَ الْبُرُوجِ
u'طَيْرٌ جَارٌ':Added, #1: 1	طَيْرٍ بِيضٍ
u'طَيْرٌ جَنَّةٌ':Added, #1: 1	طَيْرُ جَارِهِ
u'طَيْرٌ حَرَمٌ':Added, #1: 1	طَيْرَ الْجَنَّةِ
u'طَيْرٌ خضر':Added, #1: 1	طَيْرَ الْحَرَمِ
u'طَيَّرَ ريحٌ':Subject, #11: 11	طَيْرٍ خُضْرٍ
u'طَيْرٌ لَيْلٌ':Added, #1: 1	طَيَّرَ الرِّيحُ
u'طَيْرٌ مَاءٌ':Added, #1: 1	طَيْرِ اللَّيْلِ
u'طَيْرٌ مَاءٌ':Added, #1: 1	طَيْرُ مَاءٍ
u'طَيْرٌ مَاءٌ':Added, #2: 2	طَيْرَ الْمَاءِ
u'طَيْرٌ مَاءٌ':Added, #2: 2	طَيْرَ مَاءٍ
u'طَيْرٌ مَاءٌ':Added, #6: 6	طَيْرُ الْمَاءِ
u'طَيْرٌ مَشْوِيٌّ':Added, #9: 9	طَيْرِ الْمَاءِ
u'طَيْرٌ وَاقِفٌ':Added, #1: 1	طَيْرٍ مَشْوِيٍّ
u'طَيْفٌ ضَيْفٌ':Added, #1: 1	طَيْرٍ وَاقِفٍ
u'طَيَّنَ أرْضٌ':Predicate, #1: 1	طَيْفَ ضَيْفٍ
u'طَيَّنَ جِدار':Predicate, #1: 1	طَيَّنَ الْأَرْضَ
u'طُيُورٌ بَحْرٌ':Added, #1: 1	طَيَّنَ جِدَارَ
u'طُيُورٌ جَنَّةٌ':Added, #1: 1	طُيُورُ الْبَحْرِ
u'طُيُورٌ خضر':Added, #1: 1	طُيُورِ الْجَنَّةِ
u'طُيُورٌ طَيَّارَةٌ':Added, #3: 3	طُيُورٍ خُضْرٍ
u'طُيُورٌ نَاسٌ':Added, #1: 1	طُيُورٍ طَيَّارَةٍ
u'ظَاهَرَ بَيْنٌ':Predicate, #3: 3	طُيُورَ النَّاسِ
u'ظَاهَرَ رَجُلٌ':Subject, #5: 5	ظَاهَرَ بَيْنَ
u'ظَاهَرَ رَجُلٌ':Subject, #1: 1	ظَاهَرَ رَجُلٌ
u'ظَاهَرَ رَسُولٌ':Subject, #4: 4	ظَاهَرَ الرَّجُلُ
u'ظَاهَرَ عَبْدٌ':Subject, #1: 1	ظَاهَرَ رَسُولُ
u'ظَاهَرَ عتق':Predicate, #4: 4	ظَاهَرَ الْعَبْدُ
u'ظَاهَرَ مُسْلِمٌ':Subject, #1: 1	ظَاهَرَ عَتَقَ
u'ظَاهَرَ يَوْمٌ':Predicate, #3: 3	ظَاهَرَ الْمُسْلِمُ
u'ظَرْفٌ تَبْعِيض':Added, #3: 3	ظَاهَرَ يَوْمَ
u'ظَرْفٌ تَبْعِيضِيّ':Added, #1: 1	ظَرْفَ التَّبْعِيضِيَّةِ
u'ظَرْفٌ تَشَهُّدٌ':Added, #1: 1	ظَرْفَ التَّبْعِيضِيَّةِ
u'ظَرْفٌ ثَمانِيَةٌ':Added, #1: 1	ظَرْفُ التَّشَهُّدِ
u'ظَرْفٌ خَمْسَةٌ':Added, #1: 1	ظَرْفِ الثَّمَانِيَةِ
u'ظَرْفٌ زَمانٌ':Added, #1: 1	ظَرْفِ الْخَمْسَةِ
u'ظَرْفٌ زَمانٌ':Added, #1: 1	ظَرْفَ زَمَانٍ
u'ظَرْفٌ زَمانٌ':Added, #1: 1	ظَرْفَ زَمَانِ
u'ظَرْفٌ زَمانٌ':Added, #1: 1	ظَرْفِ زَمَانٍ
u'ظَرْفٌ زَمانٌ':Added, #3: 3	ظَرْفُ الزَّمَانِ
u'ظَرْفٌ زَمانٌ':Added, #3: 3	ظَرْفِ الزَّمَانِ
u'ظَرْفٌ زَيْتٌ':Added, #5: 5	ظَرْفُ زَمَانٍ
u'ظَرْفٌ سلام':Added, #1: 1	ظَرْفُ زَيْتٍ
u'ظَرْفٌ سلام':Added, #1: 1	ظَرْفُ السَّلَامِ
u'ظَرْفٌ سَلاَمٌ':Added, #1: 1	ظَرْفِ السَّلَامِ
u'ظَرْفٌ سَلاَمٌ':Added, #1: 1	ظَرْفُ السَّلَامِ
u'ظَرْفٌ عَسَلٌ':Added, #1: 1	ظَرْفِ السَّلَامِ
u'ظَرْفٌ غير':Added, #1: 1	ظَرْفُ عَسَلٍ
u'ظَرْفٌ غَيْرٌ':Added, #2: 2	ظَرْفَ غَيْرِهِ
u'ظَرْفٌ قَمْحٌ':Added, #2: 2	ظَرْفَ غَيْرِهِ
u'ظَرْفٌ كحل':Added, #1: 1	ظَرْفُ الْقَمْحِ
u'ظَرْفٌ كُحْلٌ':Added, #1: 1	ظَرْفُ الْكُحْلِ
u'ظَرْفٌ لَغْوٌ':Added, #1: 1	ظَرْفُ الْكُحْلِ
u'ظَرْفٌ مَاءٌ':Added, #1: 1	ظَرْفُ لَغْوٍ
u'ظَرْفٌ مَبِيعٌ':Added, #1: 1	ظَرْفُ الْمَاءِ
u'ظَرْفٌ مِسْكٌ':Added, #1: 1	ظَرْفِ الْمَبِيعِ
u'ظَرْفٌ مَكَانٌ':Added, #1: 1	ظَرْفَ الْمِسْكِ
u'ظَرْفٌ نصاب':Added, #1: 1	ظَرْفُ الْمَكَانِ
u'ظَرْفٌ نِصَابٌ':Added, #1: 1	ظَرْفُ النِّصَابِ
u'ظَرْفٌ نَفْيٌ':Added, #1: 1	ظَرْفُ النِّصَابِ
u'ظَرْفٌ هَدِيٌّ':Added, #1: 1	ظَرْفَ النَّفْيِ
u'ظَرْفٌ هَدِيٌّ':Added, #1: 1	ظَرْفَ الْهَدِيَّةِ
u'ظَرْفٌ هَدِيَّةٌ':Added, #2: 2	ظَرْفِ الْهَدِيَّةِ
u'ظَرْفٌ هَدِيَّةٌ':Added, #1: 1	ظَرْفَ الْهَدِيَّةِ
u'ظَرْفٌ وِلاَدَةٌ':Added, #2: 2	ظَرْفِ الْهَدِيَّةِ
u'ظَفِرَ أحَدٌ':Subject, #1: 1	ظَرْفَ الْوِلَادَةِ
u'ظَفِرَ إمَامٌ':Subject, #1: 1	ظَفِرَ أَحَدٌ
u'ظَفِرَ إِنْسانٌ':Subject, #1: 1	ظَفِرَ الْإِمَامُ
u'ظَفِرَ بَائِعٌ':Subject, #1: 1	ظَفِرَ الْإِنْسَانُ
u'ظَفِرَ رَسُولٌ':Subject, #1: 1	ظَفِرَ الْبَائِعُ
u'ظَفِرَ غَاصِبٌ':Subject, #1: 1	ظَفِرَ رَسُولُ
u'ظَفَرَ فَقِيرٌ':Subject, #1: 1	ظَفِرَ الْغَاصِبُ
u'ظَفِرَ فلان':Subject, #1: 1	ظَفَرَ الْفَقِيرُ
u'ظَفِرَ مَالِكٌ':Subject, #1: 1	ظَفِرَ الْمَرْوِيُّ
u'ظَفِرَ مَرْوِيّ':Subject, #1: 1	ظَفِرَ الْمَالِكُ
u'ظَفَرٌ مُسْتَحِقٌّ':Added, #1: 1	ظَفِرَ الْمَرْوِيُّ
u'ظَفِرَ مُصَابٌ':Subject, #1: 1	ظَفَرُ الْمُسْتَحِقِّ
u'ظَفِرَ واحد':Subject, #1: 1	ظَفِرَ الْمُصَابُ
u'ظَفِرَ وَاحِدٌ':Subject, #1: 1	ظَفِرَ وَاحِدٌ
u'ظَفِرَ وَكِيلٌ':Subject, #1: 1	ظَفِرَ وَاحِدٌ
u'ظَلَّ حُكْمٌ':Subject, #1: 1	ظَفِرَ الْوَكِيلُ
u'ظَلَّ رَأْسٌ':Predicate, #1: 1	ظَلَّ حُكْمُ
u'ظَلَّ زَمانٌ':Subject, #1: 1	أَظَلَّ رَأْسَ
u'ظُلْمٌ أحَدٌ':Added, #2: 2	أَظَلَّ زَمَانُهُ
u'ظُلْمٌ آدَمِيٌّ':Added, #1: 1	ظُلْمَ أَحَدٍ
u'ظُلْمٌ إمَامٌ':Added, #1: 1	ظُلْمُ الْآدَمِيِّ
u'ظَلَمَ أهْلٌ':Predicate, #1: 1	ظُلْمَ الْإِمَامِ
u'ظُلْمٌ بَائِعٌ':Added, #1: 1	ظَلَمَ أَهْلَ
u'ظُلْمٌ تَعْلِيقٌ':Added, #3: 3	ظُلْمِ الْبَائِعِ
u'ظُلْمٌ خَالٌ':Added, #4: 4	ظُلْمِ التَّعْلِيقِ
u'ظُلْمٌ خَصْمٌ':Added, #1: 1	ظُلْمٍ خَالٍ
u'ظُلْمٌ خَصْمٌ':Added, #1: 1	ظُلْمُ الْخَصْمِ
u'ظُلْمٌ رَبُّ':Added, #1: 1	ظُلْمُ خَصْمِهِ
u'ظُلْمٌ زَوْجٌ':Added, #1: 1	ظُلْمُ رَبِّ
u'ظُلْمٌ سَلاَطِينُ':Added, #1: 1	ظُلْمِ الزَّوْجِ
u'ظُلْمٌ سُلْطَانٌ':Added, #1: 1	ظُلْمُ السَّلَاطِينِ
u'ظُلْمٌ سَيِّدٌ':Added, #1: 1	ظُلْمِ السُّلْطَانِ
u'ظَلَمَ ظالِمٌ':Subject, #2: 2	ظُلْمِ السَّيِّدِ
u'ظُلْمٌ ظالِمٌ':Added, #2: 2	ظَلَمَ ظَالِمٌ
u'ظُلْمٌ ظالِمٌ':Added, #1: 1	ظُلْمُ ظَالِمٍ
u'ظُلْمٌ عِبَادٌ':Added, #2: 2	ظُلْمِ الظَّالِمِ
u'ظُلْمٌ عِبَادٌ':Added, #1: 1	ظُلْمِ الْعِبَادِ
u'ظَلَمَ عُرْوَةٌ':Predicate, #1: 1	ظُلْمِ عِبَادِ
u'ظُلْمٌ عَظِيم':Added, #1: 1	ظَلَمَ عُرْوَةَ
u'ظُلْمٌ غضب':Added, #1: 1	ظُلْمٍ عَظِيمٍ
u'ظُلْمٌ غَضَبٌ':Added, #1: 1	ظُلْمَ الْغَضَبِ
u'ظُلْمٌ غير':Added, #1: 1	ظُلْمَ الْغَضَبِ
u'ظُلْمٌ غَيْرٌ':Added, #1: 1	ظُلْمُ الْغَيْرِ
u'ظُلْمٌ غير':Added, #1: 1	ظُلْمُ الْغَيْرِ
u'ظُلْمٌ غَيْرٌ':Added, #2: 2	ظُلْمِ غَيْرِهِ
u'ظَلَمَ فَلّاح':Predicate, #2: 2	ظُلْمِ غَيْرِهِ
u'ظَلَمَ قَيْدٌ':Predicate, #2: 2	ظَلَمَ الْفَلَّاحِينَ
u'ظَلَمَ قِيدٌ':Predicate, #1: 1	ظَلَمَ قَيْدَ
u'ظُلْمٌ لَيَالِي':Added, #4: 4	ظَلَمَ قِيدَ
u'ظُلْمٌ مَالِكٌ':Added, #1: 1	ظُلْمِ اللَّيَالِيِ
u'ظُلْمٌ مُحْتَمَلٌ':Added, #1: 1	ظُلْمَ الْمَالِكِ
u'ظَلَمَ مُسْلِمٌ':Subject, #1: 1	ظُلْمٍ مُحْتَمَلٍ
u'ظُلْمٌ مُوَكِّلٌ':Added, #1: 1	ظَلَمَ الْمُسْلِمُ
u'ظُلْمٌ وُلاَةٌ':Added, #3: 3	ظُلْمَ مُوَكِّلِهِ
u'ظُلْمٌ وُلاَةٌ':Added, #1: 1	ظُلْمِ الْوُلَاةِ
u'ظَلَّ وَجْهٌ':Subject, #1: 1	ظُلْمِ الْوُلاَةِ
u'ظَمِئَ حَجيجٌ':Subject, #3: 3	ظَلَّ وَجْهُهُ
u'ظَنَّ إبَاحَةٌ':Predicate, #1: 1	ظَمِئَ الْحَجِيجُ
u'ظَنَّ إبَاحَةٌ':Predicate, #1: 1	ظَنَّ إبَاحَةَ
u'ظَنَّ أَحْكَامٌ':Predicate, #3: 3	ظَنَّ الْإِبَاحَةَ
u'ظَنَّ إِدْرَاكٌ':Predicate, #1: 1	ظَنَّ الْأَحْكَامَ
u'ظَنَّ أَصْحَابٌ':Subject, #3: 3	ظَنَّ إدْرَاكَ
u'ظَنَّ أَصْحَابٌ':Subject, #1: 1	ظَنَّ أَصْحَابُ
u'ظَنَّ أصل':Predicate, #1: 1	ظَنَّ الْأَصْحَابُ
u'ظَنَّ أًصْلٌ':Predicate, #1: 1	ظَنَّ أَصْلَ
u'ظَنَّ إعْطَاءٌ':Predicate, #1: 1	ظَنَّ أَصْلَ
u'ظَنَّ إمَامٌ':Predicate, #2: 2	ظَنَّ الْإِعْطَاءَ
u'ظَنَّ إمَامٌ':Subject, #1: 1	ظَنَّ الْإِمَامَ
u'ظَنَّ أَمْنٌ':Predicate, #5: 5	ظَنَّ الْإِمَامُ
u'ظَنَّ اِنْتِقالٌ':Predicate, #1: 1	ظَنَّ الْأَمْنَ
u'ظَنَّ إِنْزالٌ':Predicate, #1: 1	ظَنَّ انْتِقَالَ
u'ظَنَّ أَوَّلُ':Subject, #2: 2	ظَنَّ الْإِنْزَالَ
u'ظَنَّ بَعْضٌ':Predicate, #1: 1	ظَنَّ الْأَوَّلُ
u'ظَنَّ بَعْضٌ':Subject, #1: 1	ظَنَّ بَعْضَ
u'ظَنَّ بَقاءٌ':Predicate, #23: 23	ظَنَّ بَعْضُ
u'ظَنَّ تَأَخُّرٌ':Predicate, #7: 7	ظَنَّ بَقَاءَ
u'ظَنَّ تَحْرِيمٌ':Predicate, #1: 1	ظَنَّ التَّأَخُّرَ
u'ظَنَّ تَسْلِيمٌ':Predicate, #2: 2	ظَنَّ تَحْرِيمَ
u'ظَنَّ تَفاوُت':Predicate, #1: 1	ظَنَّ التَّسْلِيمَ
u'ظَنَّ تمام':Predicate, #1: 1	ظَنَّ التَّفَاوُتَ
u'ظَنَّ تَمامٌ':Predicate, #1: 1	ظَنَّ تَمَامَ
u'ظَنَّ جَاهِلٌ':Subject, #1: 1	ظَنَّ تَمَامَ
u'ظَنَّ جَمَاعَةٌ':Subject, #1: 1	ظَنَّ الْجَاهِلُ
u'ظَنَّ جَهَلَةٌ':Subject, #2: 2	ظَنَّ جَمَاعَةٌ
u'ظَنَّ حاكِمٌ':Subject, #1: 1	ظَنَّ جَهَلَةٌ
u'ظَنَّ حالٌ':Predicate, #1: 1	ظَنَّ الْحَاكِمُ
u'ظَنَّ حَدَثٌ':Predicate, #1: 1	ظَنَّ حَالَ
u'ظَنَّ حُصُول':Predicate, #2: 2	ظَنَّ الْحَدَثَ
u'ظَنَّ حِلٌّ':Predicate, #4: 4	ظَنَّ حُصُولَ
u'ظَنَّ حَيَاةٌ':Predicate, #4: 4	ظَنَّ الْحِلَّ
u'ظَنَّ خُرُوجٌ':Predicate, #1: 1	ظَنَّ حَيَاةَ
u'ظَنَّ خَطَأٌ':Predicate, #2: 2	ظَنَّ خُرُوجَ
u'ظَنَّ خَطَأٌ':Predicate, #1: 1	ظَنَّ الْخَطَأَ
u'ظَنَّ دَاخِلٌ':Subject, #1: 1	ظَنَّ خَطَأَ
u'ظَنَّ دَائِنٌ':Subject, #1: 1	ظَنَّ الدَّاخِلُ
u'ظَنَّ دُخُولٌ':Predicate, #1: 1	ظَنَّ الدَّائِنُ
u'ظَنَّ دَوامٌ':Predicate, #4: 4	ظَنَّ دُخُولَ
u'ظَنَّ رِجَالٌ':Subject, #1: 1	ظَنَّ الدَّوَامَ
u'ظَنَّ رَجُلٌ':Subject, #1: 1	ظَنَّ الرِّجَالُ
u'ظَنَّ رَسُولٌ':Subject, #1: 1	ظَنَّ الرَّجُلُ
u'ظَنَّ رِضاً':Subject, #1: 1	ظَنَّ رَسُولُ
u'ظَنَّ رِضاءٌ':Predicate, #1: 1	ظَنَّ رِضَاهُ
u'ظَنَّ رعاف':Predicate, #1: 1	ظَنَّ رِضَاءَ
u'ظَنَّ رُعافٌ':Predicate, #1: 1	ظَنَّ الرُّعَافَ
u'ظَنَّ زَحْمَةٌ':Predicate, #1: 1	ظَنَّ الرُّعَافَ
u'ظَنَّ زُفَرٌ':Subject, #1: 1	ظَنَّ الزَّحْمَةَ
u'ظَنَّ زَوْجٌ':Subject, #1: 1	ظَنَّ زُفَرُ
u'ظَنَّ زِيادَةٌ':Predicate, #1: 1	ظَنَّ الزَّوْجُ
u'ظَنَّ سَامِعٌ':Subject, #1: 1	ظَنَّ الزِّيَادَةَ
u'ظَنَّ سَلاَمَةٌ':Predicate, #2: 2	ظَنَّ السَّامِعُ
u'ظَنَّ سَلاَمَةٌ':Predicate, #1: 1	ظَنَّ سَلَامَةَ
u'ظَنَّ شَخْصٌ':Subject, #2: 2	ظَنَّ السَّلَامَةَ
u'ظَنَّ صَاحِبٌ':Subject, #1: 1	ظَنَّ شَخْصٌ
u'ظَنَّ صِحَّةٌ':Predicate, #4: 4	ظَنَّ صَاحِبُ
u'ظَنَّ صدق':Predicate, #9: 9	ظَنَّ صِحَّةَ
u'ظَنَّ صِدْقٌ':Predicate, #1: 1	ظَنَّ صِدْقَ
u'ظَنَّ صلح':Predicate, #1: 1	ظَنَّ صِدْقَ
u'ظَنَّ صُلْحٌ':Predicate, #2: 2	ظَنَّ الصُّلْحَ
u'ظَنَّ صَوَابٌ':Predicate, #2: 2	ظَنَّ الصُّلْحَ
u'ظَنَّ ضَرَرٌ':Predicate, #2: 2	ظَنَّ الصَّوَابَ
u'ظَنَّ طَائِفٌ':Subject, #1: 1	ظَنَّ الضَّرَرَ
u'ظَنَّ طَلاَقٌ':Predicate, #1: 1	ظَنَّ طَائِفَةٌ
u'ظَنَّ طُلُوعٌ':Predicate, #1: 1	ظَنَّ طَلَاقَ
u'ظَنَّ طَهَارَةٌ':Predicate, #1: 1	ظَنَّ الطُّلُوعَ
u'ظَنَّ عجز':Predicate, #2: 2	ظَنَّ طَهَارَةَ
u'ظَنَّ عَجْزٌ':Predicate, #2: 2	ظَنَّ الْعَجْزَ
u'ظَنَّ عَدَالَةٌ':Predicate, #2: 2	ظَنَّ الْعَجْزَ
u'ظَنَّ عَدَمٌ':Predicate, #1: 1	ظَنَّ الْعَدَالَةَ
u'ظَنَّ عَدَمٌ':Predicate, #19: 19	ظَنَّ عَدَمَ
u'ظَنَّ عِلْجٌ':Subject, #1: 1	ظَنَّ الْعَدَمَ
u'ظَنَّ علم':Predicate, #2: 2	ظَنَّ الْعِلْجُ
u'ظَنَّ عِلْمٌ':Predicate, #1: 1	ظَنَّ عِلْمَ
u'ظَنَّ عند':Predicate, #1: 1	ظَنَّ عِلْمَ
u'ظَنَّ غُرُوبٌ':Predicate, #1: 1	ظَنَّ عِنْدَ
u'ظَنَّ غَلَطٌ':Predicate, #1: 1	ظَنَّ غُرُوبَ
u'ظَنَّ غير':Predicate, #1: 1	ظَنَّ غَلَطَ
u'ظَنَّ غَيْرٌ':Predicate, #1: 1	ظَنَّ غَيْرَ
u'ظَنَّ فتنة':Predicate, #1: 1	ظَنَّ غَيْرَ
u'ظَنَّ فِتْنَةٌ':Predicate, #2: 2	ظَنَّ الْفِتْنَةَ
u'ظَنَّ فراغ':Predicate, #2: 2	ظَنَّ الْفِتْنَةَ
u'ظَنَّ فَرَاغٌ':Predicate, #5: 5	ظَنَّ فَرَاغَ
u'ظَنَّ فساد':Predicate, #5: 5	ظَنَّ فَرَاغَ
u'ظَنَّ فَسَادٌ':Predicate, #1: 1	ظَنَّ فَسَادَ
u'ظَنَّ قدرة':Predicate, #1: 1	ظَنَّ فَسَادَ
u'ظَنَّ قُدْرَةٌ':Predicate, #2: 2	ظَنَّ الْقُدْرَةَ
u'ظَنَّ قَصْدٌ':Predicate, #2: 2	ظَنَّ الْقُدْرَةَ
u'ظَنَّ قول':Predicate, #1: 1	ظَنَّ قَصْدَ
u'ظَنَّ قَوْلٌ':Predicate, #1: 1	ظَنَّ قَوْلَ
u'ظَنَّ قَوْمٌ':Subject, #1: 1	ظَنَّ قَوْلَ
u'ظَنَّ قَوْمٌ':Subject, #10: 10	ظَنَّ قَوْمٌ
u'ظَنَّ قيام':Predicate, #1: 1	ظَنَّ الْقَوْمُ
u'ظَنَّ قِيَامٌ':Predicate, #1: 1	ظَنَّ قِيَامَ
u'ظَنَّ كذب':Predicate, #1: 1	ظَنَّ قِيَامَ
u'ظَنَّ كَذِبٌ':Predicate, #2: 2	ظَنَّ كَذِبَ
u'ظَنَّ كَوْنٌ':Predicate, #2: 2	ظَنَّ كَذِبَ
u'ظَنَّ لُزُومٌ':Predicate, #1: 1	ظَنَّ كَوْنَ
u'ظَنَّ مَاءٌ':Predicate, #2: 2	ظَنَّ لُزُومَ
u'ظَنَّ مُتَصَرِّفٌ':Subject, #2: 2	ظَنَّ الْمَاءَ
u'ظَنَّ مَسْبُوق':Subject, #1: 1	ظَنَّ الْمُتَصَرِّفُ
u'ظَنَّ مُسْتَأْجِرٌ':Subject, #1: 1	ظَنَّ الْمَسْبُوقُ
u'ظَنَّ مُسْلِمٌ':Predicate, #1: 1	ظَنَّ الْمُسْتَأْجِرُ
u'ظَنَّ مُصَنِّفٌ':Subject, #1: 1	ظَنَّ الْمُسْلِمَ
u'ظَنَّ مَفْهُومٌ':Predicate, #1: 1	ظَنَّ الْمُصَنِّفُ
u'ظَنَّ مُكَلَّفٌ':Subject, #1: 1	ظَنَّ الْمَفْهُومَ
u'ظَنَّ مِلْكٌ':Predicate, #1: 1	ظَنَّ الْمُكَلَّفُ
u'ظَنَّ مَنْعٌ':Predicate, #1: 1	ظَنَّ مِلْكَ
u'ظَنَّ مُؤَجِّرٌ':Subject, #1: 1	ظَنَّ الْمَنْعَ
u'ظَنَّ نَاسٌ':Subject, #1: 1	ظَنَّ مُؤَجِّرُهُ
u'ظَنَّ هَدَفٌ':Predicate, #1: 1	ظَنَّ النَّاسُ
u'ظَنَّ هلاك':Subject, #1: 1	ظَنَّ الْهَدَفَ
u'ظَنَّ هَلاَكٌ':Subject, #1: 1	ظَنَّ الْهَلَاكُ
u'ظَنَّ وَارِثٌ':Subject, #1: 1	ظَنَّ الْهَلَاكُ
u'ظَنَّ واقِف':Subject, #1: 1	ظَنَّ الْوَارِثُ
u'ظَنَّ وُجُوبٌ':Predicate, #1: 1	ظَنَّ الْوَاقِفِيَّةُ
u'ظَنَّ وُجُودٌ':Predicate, #1: 1	ظَنَّ وُجُوبَ
u'ظَنَّ وُصُولٌ':Predicate, #3: 3	ظَنَّ وُجُودَ
u'ظَنَّ وَطْءٌ':Predicate, #2: 2	ظَنَّ وُصُولَ
u'ظَنَّ وُقُوعٌ':Predicate, #1: 1	ظَنَّ الْوَطْءَ
u'ظَنَّ وَلِيٌّ':Subject, #1: 1	ظَنَّ الْوُقُوعَ
u'ظَهَرَ أَبٌ':Subject, #1: 1	ظَنَّ وَلِيُّ
u'ظَهْرٌ إِبْهَامٌ':Added, #1: 1	ظَهَرَ الْأَبُ
u'ظَهْرٌ إِبْهَامٌ':Added, #1: 1	ظَهْرِ الْإِبْهَامِ
u'ظَهَرَ آثَارٌ':Subject, #3: 3	ظَهْرِ إبْهَامِهِ
u'ظَهَرَ أثَرٌ':Subject, #2: 2	ظَهَرَ آثَارُ
u'ظَهَرَ أثَرٌ':Subject, #13: 13	ظَهَرَ أَثَرُ
u'ظَهَرَ اِحْتِمَالٌ':Subject, #9: 9	ظَهَرَ أَثَرُهُ
u'ظَهَرَ أحَدٌ':Subject, #1: 1	ظَهَرَ احْتِمَالُ
u'ظَهْرٌ أحَدٌ':Added, #1: 1	ظَهَرَ أَحَدُ
u'ظَهَرَ اِخْتِلاطٌ':Subject, #1: 1	ظَهْرِ أَحَدٍ
u'ظَهْرٌ أرْضٌ':Added, #2: 2	ظَهَرَ اخْتِلَاطُهُ
u'ظَهْرٌ أرْضٌ':Added, #11: 11	ظَهْرِ الْأَرْضِ
u'ظَهَرَ اِسْتِحْقَاقٌ':Subject, #8: 8	ظَهْرِ الأَرْضِ
u'ظَهْرٌ أَسَدٌ':Added, #1: 1	ظَهَرَ اسْتِحْقَاقُهُ
u'ظَهْرٌ أَسْفَلُ':Added, #1: 1	ظَهْرِ الْأَسَدِ
u'ظَهَرَ إِسْلامٌ':Predicate, #1: 1	ظَهْرِ الْأَسْفَلِ
u'ظَهِرَ إِسْلامٌ':Predicate, #2: 2	أَظْهَرَ الإِسْلاَمَ
u'ظَهَرَ إِسْلامٌ':Predicate, #2: 2	أَظْهَرَ الإِسْلاَمَ
u'ظَهِرَ إِسْلامٌ':Predicate, #3: 3	أَظْهَرَ الْإِسْلَامَ
u'ظَهَرَ إِسْلامٌ':Subject, #3: 3	أَظْهَرَ الْإِسْلَامَ
u'ظَهَرَ إِسْلامٌ':Subject, #1: 1	ظَهَرَ الإِسْلامُ
u'ظَهْرٌ أسْوَد':Added, #1: 1	ظَهَرَ الإِسْلاَمُ
u'ظَهَرَ اِشْتِراطٌ':Subject, #1: 1	ظَهْرَ الْأَسْوَدِ
u'ظَهَرَ اِشْتِراكٌ':Subject, #1: 1	ظَهَرَ اشْتِرَاطُهُ
u'ظَهَرَ إصابَةٌ':Subject, #1: 1	ظَهَرَ اشْتِرَاكُ
u'ظَهْرٌ أَصابِعُ':Added, #1: 1	ظَهَرَ إصَابَتُهُ
u'ظَهْرٌ أُصْبُعٌ':Added, #1: 1	ظَهْرِ أَصَابِعِهِ
u'ظَهَرَ إِضْرابٌ':Subject, #1: 1	ظَهْرِ الْأُصْبُعِ
u'ظَهَرَ إِطْلاقٌ':Subject, #1: 1	ظَهَرَ الْإِضْرَابُ
u'ظَهَرَ أَغْرَاضٌ':Predicate, #1: 1	ظَهَرَ الْإِطْلَاقُ
u'ظَهِرَ أَغْرَاضٌ':Predicate, #1: 1	أَظْهَرَ الْأَغْرَاضَ
u'ظَهَرَ أقَلُّ':Predicate, #1: 1	أَظْهَرَ الْأَغْرَاضَ
u'ظَهَرَ أقَلُّ':Subject, #3: 3	ظَهَرَ أَقَلَّ
u'ظَهَرَ أَكْثَرُ':Predicate, #1: 1	ظَهَرَ أَقَلُّ
u'ظَهَرَ أَكْثَرُ':Subject, #1: 1	ظَهَرَ أَكْثَرَ
u'ظَهْرٌ الْمَرْأَةُ':Added, #1: 1	ظَهَرَ أَكْثَرُ
u'ظَهْرٌ أُمٌّ':Added, #1: 1	ظَهْرِ الْمَرْأَةِ
u'ظَهْرٌ أُمٌّ':Added, #1: 1	ظَهْرُ الْأُمِّ
u'ظَهَرَ إمَامٌ':Subject, #2: 2	ظَهْرِ أُمِّهِ
u'ظَهْرٌ إمَامٌ':Added, #2: 2	ظَهَرَ الْإِمَامُ
u'ظَهْرٌ إمَامٌ':Added, #10: 10	ظَهْرِ الْإِمَامِ
u'ظَهَرَ أَمْرٌ':Subject, #2: 2	ظَهْرِ إمَامِهِ
u'ظَهَرَ أَمْرٌ':Subject, #1: 1	ظَهَرَ أَمْرٌ
u'ظَهَرَ إِمْكانٌ':Subject, #2: 2	ظَهَرَ الْأَمْرُ
u'ظَهَرَ أَميرٌ':Subject, #1: 1	ظَهَرَ إمْكَانُ
u'ظَهَرَ اِنْتِظامٌ':Subject, #1: 1	ظَهَرَ الْأَمِيرُ
u'ظَهَرَ اِنْتِفاء':Subject, #1: 1	ظَهَرَ انْتِظَامُ
u'ظَهَرَ اِنْدِراجٌ':Subject, #2: 2	ظَهَرَ انْتِفَاءُ
u'ظَهَرَ إِنْسانٌ':Subject, #1: 1	ظَهَرَ انْدِرَاجُهُ
u'ظَهْرٌ إِنْسانٌ':Added, #1: 1	ظَهَرَ إنْسَانٌ
u'ظَهْرٌ إِنْسانٌ':Added, #1: 1	ظَهْرِ الْإِنْسَانِ
u'ظَهْرٌ إِنْسانٌ':Added, #2: 2	ظَهْرَ إنْسَانٍ
u'ظَهْرٌ أَنْفٌ':Added, #5: 5	ظَهْرِ إنْسَانٍ
u'ظَهَرَ اِنْفِتاحٌ':Subject, #1: 1	ظَهْرُ أَنْفِهِ
u'ظَهَرَ اِنْقِضاءٌ':Subject, #1: 1	ظَهَرَ انْفِتَاحُ
u'ظَهَرَ اِنْقِطاعٌ':Subject, #1: 1	ظَهَرَ انْقِضَاءُ
u'ظَهَرَ أهْلٌ':Subject, #1: 1	ظَهَرَ انْقِطَاعُ
u'ظَهَرَ أَوَّلُ':Subject, #2: 2	ظَهَرَ أَهْلُ
u'ظَهَرَ آيَةٌ':Subject, #2: 2	ظَهَرَ الْأَوَّلُ
u'ظَهَرَ إيمَانٌ':Predicate, #1: 1	ظَهَرَ آيَةُ
u'ظَهِرَ إيمَانٌ':Predicate, #1: 1	أَظْهَرَ الإِيمَانَ
u'ظَهَرَ بَاطِلٌ':Subject, #1: 1	أَظْهَرَ الإِيمَانَ
u'ظَهَرَ بَحْثٌ':Subject, #1: 1	ظَهَرَ الْبَاطِلُ
u'ظَهَرَ بَحْثٌ':Subject, #1: 1	ظَهَرَ بَحْثُ
u'ظَهْرٌ بَحْرٌ':Added, #1: 1	ظَهَرَ بَحْثُهُ
u'ظَهَرَ بَدَلٌ':Subject, #1: 1	ظَهْرَ الْبَحْرِ
u'ظَهْرٌ بُراقٌ':Added, #1: 1	ظَهَرَ الْبَدَلُ
u'ظَهَرَ بُطْلان':Subject, #2: 2	ظَهْرِ الْبُرَاقِ
u'ظَهَرَ بَطْنٌ':Predicate, #1: 1	ظَهَرَ بُطْلَانُهُ
u'ظَهِرَ بَطْنٌ':Predicate, #1: 1	أَظْهَرَ بَطْنَ
u'ظَهْرٌ بَطْنٌ':Added, #1: 1	أَظْهَرَ بَطْنَ
u'ظَهَرَ بَعْضٌ':Predicate, #2: 2	ظَهْرَ الْبَطْنِ
u'ظَهِرَ بَعْضٌ':Predicate, #1: 1	أَظْهَرَ بَعْضَ
u'ظَهَرَ بَعْضٌ':Subject, #1: 1	أَظْهَرَ بَعْضَ
u'ظَهَرَ بَعْضٌ':Subject, #10: 10	ظَهَرَ بَعْضُ
u'ظَهَرَ بَعْضٌ':Subject, #1: 1	ظَهَرَ بَعْضُهُ
u'ظَهْرٌ بَعْضٌ':Added, #2: 2	ظَهَرَ الْبَعْضُ
u'ظَهْرٌ بَعيرٌ':Added, #2: 2	ظَهْرِ بَعْضٍ
u'ظَهْرٌ بَعيرٌ':Added, #2: 2	ظَهْرِ بَعِيرٍ
u'ظَهْرٌ بَعيرٌ':Added, #3: 3	ظَهْرِ بَعِيرِهِ
u'ظَهْرٌ بَهِيمَةٌ':Added, #5: 5	ظَهْرِ الْبَعِيرِ
u'ظَهَرَ بَوْلٌ':Subject, #2: 2	ظَهْرِ بَهِيمَةٍ
u'ظَهَرَ بِئْرٌ':Subject, #1: 1	ظَهَرَ الْبَوْلُ
u'ظَهْرٌ بَيْتٌ':Added, #1: 1	ظَهَرَ بِئْرٌ
u'ظَهْرٌ بَيْتٌ':Added, #10: 10	ظَهْرِ بَيْتِ
u'ظَهْرٌ بَيْتٌ':Added, #15: 15	ظَهْرِ بَيْتٍ
u'ظَهْرٌ بَيْتٌ':Added, #1: 1	ظَهْرَ بَيْتٍ
u'ظَهْرٌ بَيْتٌ':Added, #1: 1	ظَهْرُ بَيْتِهِ
u'ظَهْرٌ بَيْتٌ':Added, #2: 2	ظَهْرُ الْبَيْتِ
u'ظَهْرٌ بَيْتٌ':Added, #2: 2	ظَهْرِ بَيْتِهِ
u'ظَهَرَ بَيْعٌ':Predicate, #4: 4	ظَهْرِ الْبَيْتِ
u'ظَهِرَ بَيْعٌ':Predicate, #1: 1	أَظْهَرَ الْبَيْعَ
u'ظَهَرَ بَيْعٌ':Predicate, #1: 1	أَظْهَرَ الْبَيْعَ
u'ظَهِرَ بَيْعٌ':Predicate, #1: 1	أَظْهَرَ بَيْعَ
u'ظَهَرَ تَأْثِيرٌ':Subject, #1: 1	أَظْهَرَ بَيْعَ
u'ظَهَرَ تَأْثِيرٌ':Subject, #1: 1	ظَهَرَ التَّأْثِيرُ
u'ظَهَرَ تَأْثِيرٌ':Subject, #2: 2	ظَهَرَ تَأْثِيرُ
u'ظَهَرَ تَارِيخٌ':Subject, #8: 8	ظَهَرَ تَأْثِيرُهُ
u'ظَهَرَ تَبَرُّمٌ':Predicate, #1: 1	ظَهَرَ التَّارِيخُ
u'ظَهِرَ تَبَرُّمٌ':Predicate, #1: 1	أَظْهَرَ التَّبَرُّمَ
u'ظَهَرَ تَخْفِيفٌ':Subject, #1: 1	أَظْهَرَ التَّبَرُّمَ
u'ظَهَرَ تَرَادُفٌ':Subject, #1: 1	ظَهَرَ التَّخْفِيفُ
u'ظَهَرَ تَرَادُفٌ':Subject, #1: 1	ظَهَرَ التَّرَادُفُ
u'ظَهَرَ تَرْجِيحٌ':Subject, #1: 1	ظَهَرَ تَرَادُفُ
u'ظَهَرَ تَرْكٌ':Predicate, #1: 1	ظَهَرَ تَرْجِيحُ
u'ظَهِرَ تَرْكٌ':Predicate, #1: 1	أَظْهَرَ التَّرْكَ
u'ظَهَرَ تَضَرُّرٌ':Subject, #1: 1	أَظْهَرَ التَّرْكَ
u'ظَهَرَ تَضْعِيفٌ':Subject, #1: 1	ظَهَرَ تَضَرُّرُ
u'ظَهَرَ تَظَاهُرٌ':Subject, #1: 1	ظَهَرَ التّضْعِيفُ
u'ظَهَرَ تَعَلُّقٌ':Subject, #1: 1	ظَهَرَ التَّظَاهُرُ
u'ظَهَرَ تَغَايُرٌ':Subject, #1: 1	ظَهَرَ تَعَلُّقُهُ
u'ظَهَرَ تَغَيُّرٌ':Subject, #1: 1	ظَهَرَ التَّغَايُرُ
u'ظَهَرَ تَفاوُت':Subject, #1: 1	ظَهَرَ التَّغَيُّرُ
u'ظَهَرَ تَفَتُّتٌ':Subject, #5: 5	ظَهَرَ التَّفَاوُتُ
u'ظَهَرَ تَفْضِيلٌ':Subject, #1: 1	ظَهَرَ تَفَتُّتُهُ
u'ظَهَرَ تَقْريرٌ':Subject, #1: 1	ظَهَرَ تَفْضِيلُهُ
u'ظَهَرَ تَقْيِيد':Subject, #1: 1	ظَهَرَ تَقْرِيرُ
u'ظَهَرَ تَقْيِيد':Subject, #1: 1	ظَهَرَ تَقْيِيدُ
u'ظَهَرَ تَكاسُلٌ':Subject, #1: 1	ظَهَرَ تَقْيِيدُهُ
u'ظَهَرَ تَلاعُنٌ':Subject, #1: 1	ظَهَرَ تَكَاسُلُ
u'ظَهَرَ تَلَفٌ':Subject, #2: 2	ظَهَرَ التَّلَاعُنُ
u'ظَهَرَ تَوَاضُعٌ':Predicate, #1: 1	ظَهَرَ تَلَفُ
u'ظَهِرَ تَوَاضُعٌ':Predicate, #1: 1	أَظْهَرَ التَّوَاضُعَ
u'ظَهَرَ تَوْبَةٌ':Predicate, #1: 1	أَظْهَرَ التَّوَاضُعَ
u'ظَهِرَ تَوْبَةٌ':Predicate, #1: 1	أَظْهَرَ التَّوْبَةَ
u'ظَهَرَ ثَالِثٌ':Subject, #1: 1	أَظْهَرَ التَّوْبَةَ
u'ظَهَرَ ثَالِثٌ':Subject, #1: 1	ظَهَرَ الثَّالِثُ
u'ظَهَرَ ثُبُوتٌ':Subject, #2: 2	ظَهَرَ ثَالِثٌ
u'ظَهَرَ ثَمَنٌ':Subject, #1: 1	ظَهَرَ ثُبُوتُ
u'ظَهَرَ ثَوْبٌ':Subject, #2: 2	ظَهَرَ الثَّمَنُ
u'ظَهَرَ جَارِي':Subject, #2: 2	ظَهَرَ الثَّوْبُ
u'ظَهَرَ جَارِيَةٌ':Subject, #1: 1	ظَهَرَ الْجَارِيَةُ
u'ظَهَرَ جَامِعٌ':Subject, #1: 1	ظَهَرَ الْجَارِيَةُ
u'ظَهْرٌ جَبَلٌ':Added, #1: 1	ظَهَرَ جَامِعٌ
u'ظَهْرٌ جِدار':Added, #1: 1	ظَهْرِ جَبَلِ
u'ظَهْرٌ جُزْءٌ':Added, #2: 2	ظَهْرِ جِدَارٍ
u'ظَهْرٌ جُزْءٌ':Added, #2: 2	ظَهْرِ الْجُزْءِ
u'ظَهَرَ جِلْدَةٌ':Predicate, #2: 2	ظَهْرِ جُزْءٍ
u'ظَهِرَ جِلْدَةٌ':Predicate, #1: 1	أَظْهَرَ الْجِلْدَةَ
u'ظَهْرٌ جَمَلٌ':Added, #1: 1	أَظْهَرَ الْجِلْدَةَ
u'ظَهَرَ جَمِيلٌ':Predicate, #1: 1	ظَهْرِ جَمَلٍ
u'ظَهِرَ جَمِيلٌ':Predicate, #1: 1	أَظْهَرَ الْجَمِيلَ
u'ظَهَرَ جَوَابٌ':Predicate, #1: 1	أَظْهَرَ الْجَمِيلَ
u'ظَهَرَ جَوَابٌ':Subject, #1: 1	ظَهَرَ جَوَابَ
u'ظَهَرَ جَوَابٌ':Subject, #1: 1	ظَهَرَ جَوَابُهُ
u'ظَهَرَ جَوْرٌ':Subject, #3: 3	ظَهَرَ الْجَوَابُ
u'ظَهَرَ حالٌ':Predicate, #1: 1	ظَهَرَ جَوْرُ
u'ظَهِرَ حالٌ':Predicate, #1: 1	أَظْهَرَ حَالَ
u'ظَهَرَ حالٌ':Subject, #1: 1	أَظْهَرَ حَالَ
u'ظَهَرَ حالٌ':Subject, #1: 1	ظَهَرَ حَالُ
u'ظَهَرَ حالٌ':Subject, #1: 1	ظَهَرَ حَالُهُ
u'ظَهَرَ حَدَثٌ':Subject, #2: 2	ظَهَرَ الْحَالُ
u'ظَهَرَ حُرِّيَّةٌ':Predicate, #2: 2	ظَهَرَ الْحَدَثُ
u'ظَهِرَ حُرِّيَّةٌ':Predicate, #1: 1	أَظْهَرَ الْحُرِّيَّةَ
u'ظَهَرَ حَرِيرٌ':Subject, #1: 1	أَظْهَرَ الْحُرِّيَّةَ
u'ظَهَرَ حسد':Subject, #1: 1	ظَهَرَ الْحَرِيرُ
u'ظَهَرَ حَسَدٌ':Subject, #1: 1	ظَهَرَ حَسَدُهُ
u'ظَهَرَ حَصْرٌ':Subject, #1: 1	ظَهَرَ حَسَدُهُ
u'ظَهَرَ حَقٌّ':Predicate, #1: 1	ظَهَرَ حَصْرُ
u'ظَهِرَ حَقٌّ':Predicate, #1: 1	أَظْهَرَ الْحَقَّ
u'ظَهَرَ حَقٌّ':Predicate, #1: 1	أَظْهَرَ الْحَقَّ
u'ظَهِرَ حَقٌّ':Predicate, #2: 2	أَظْهَرَ حَقَّ
u'ظَهَرَ حَقٌّ':Subject, #2: 2	أَظْهَرَ حَقَّ
u'ظَهَرَ حَقٌّ':Subject, #1: 1	ظَهَرَ الْحَقُّ
u'ظَهَرَ حَقٌّ':Subject, #1: 1	ظَهَرَ حَقُّهُ
u'ظَهَرَ حَقِيقٌ':Predicate, #3: 3	ظَهَرَ حَقُّ
u'ظَهِرَ حَقِيقٌ':Predicate, #1: 1	أَظْهَرَ حَقِيقَةَ
u'ظَهَرَ حَقِيقَةٌ':Predicate, #1: 1	أَظْهَرَ حَقِيقَةَ
u'ظَهِرَ حَقِيقَةٌ':Predicate, #1: 1	أَظْهَرَ حَقِيقَةَ
u'ظَهَرَ حُكْمٌ':Subject, #1: 1	أَظْهَرَ حَقِيقَةَ
u'ظَهَرَ حُكْمٌ':Subject, #5: 5	ظَهَرَ حُكْمُهُ
u'ظَهَرَ حِلٌّ':Subject, #7: 7	ظَهَرَ حُكْمُ
u'ظَهَرَ حَلالٌ':Subject, #1: 1	ظَهَرَ الْحِلُّ
u'ظَهَرَ حَمْلٌ':Subject, #1: 1	ظَهَرَ حَلَالُ
u'ظَهَرَ حَمْلٌ':Subject, #4: 4	ظَهَرَ حَمْلٌ
u'ظَهْرٌ حُوتٌ':Added, #5: 5	ظَهَرَ الْحَمْلُ
u'ظَهْرٌ حَيٌّ':Added, #1: 1	ظَهْرِ حُوتٍ
u'ظَهْرٌ حَيَّةٌ':Added, #1: 1	ظَهْرِ الْحَيَّةِ
u'ظَهْرٌ حَيَوَانٌ':Added, #1: 1	ظَهْرِ الْحَيَّةِ
u'ظَهَرَ خَارِجٌ':Predicate, #1: 1	ظَهْرِ الْحَيَوَانِ
u'ظَهَرَ خَارِقٌ':Predicate, #1: 1	ظَهَرَ خَارِجَ
u'ظَهِرَ خَارِقٌ':Predicate, #1: 1	أَظْهَرَ خَارِقَةً
u'ظَهَرَ خُبْثٌ':Subject, #1: 1	أَظْهَرَ خَارِقَةً
u'ظَهَرَ خُسْران':Subject, #1: 1	ظَهَرَ خُبْثُهُ
u'ظَهَرَ خَطَأٌ':Predicate, #1: 1	ظَهَرَ خُسْرَانٌ
u'ظَهِرَ خَطَأٌ':Predicate, #1: 1	أَظْهَرَ الْخَطَأَ
u'ظَهَرَ خَطَأٌ':Subject, #1: 1	أَظْهَرَ الْخَطَأَ
u'ظَهَرَ خَطَأٌ':Subject, #14: 14	ظَهَرَ الْخَطَأُ
u'ظَهَرَ خُفٌّ':Subject, #5: 5	ظَهَرَ خَطَأُ
u'ظَهْرٌ خُفٌّ':Added, #1: 1	ظَهَرَ الْخُفُّ
u'ظَهْرٌ خُفٌّ':Added, #1: 1	ظَهْرَ الْخُفَّيْنِ
u'ظَهْرٌ خُفٌّ':Added, #1: 1	ظَهْرِ الْخُفَّيْنِ
u'ظَهْرٌ خُفٌّ':Added, #1: 1	ظَهْرِ خُفِّ
u'ظَهَرَ خِلاَفٌ':Predicate, #2: 2	ظَهْرِ الْخُفِّ
u'ظَهِرَ خِلاَفٌ':Predicate, #1: 1	أَظْهَرَ خِلَافَ
u'ظَهَرَ خِلاَفٌ':Subject, #1: 1	أَظْهَرَ خِلَافَ
u'ظَهَرَ خِلاَفٌ':Subject, #15: 15	ظَهَرَ خِلَافُهُ
u'ظَهْرٌ خِلاَفٌ':Added, #3: 3	ظَهَرَ الْخِلَافُ
u'ظَهَرَ خوارج':Subject, #4: 4	ظَهْرِ خِلَافِهِ
u'ظَهَرَ خَوَارِجُ':Subject, #1: 1	ظَهَرَ الْخَوَارِجُ
u'ظَهَرَ خَيْرٌ':Predicate, #1: 1	ظَهَرَ الْخَوَارِجُ
u'ظَهِرَ خَيْرٌ':Predicate, #3: 3	أَظْهَرَ الْخَيْرَ
u'ظَهَرَ خَيْرٌ':Subject, #3: 3	أَظْهَرَ الْخَيْرَ
u'ظَهْرٌ دَابَّةٌ':Added, #1: 1	ظَهَرَ خَيْرُهُ
u'ظَهْرٌ دَابَّةٌ':Added, #1: 1	ظَهْرُ الدَّابَّةِ
u'ظَهْرٌ دَابَّةٌ':Added, #1: 1	ظَهْرِ دَابَّةِ
u'ظَهْرٌ دَابَّةٌ':Added, #1: 1	ظَهْرَ دَابَّتِهِ
u'ظَهْرٌ دَابَّةٌ':Added, #2: 2	ظَهْرِ دَابَّتِهِ
u'ظَهْرٌ دَابَّةٌ':Added, #34: 34	ظَهْرِ الدَّابَّةِ
u'ظَهْرٌ دَارٌ':Added, #5: 5	ظَهْرِ دَابَّةٍ
u'ظَهْرٌ دَارٌ':Added, #1: 1	ظَهْرُ دَارٍ
u'ظَهْرٌ دَارٌ':Added, #1: 1	ظَهْرُ دَارِهِ
u'ظَهْرٌ دَارٌ':Added, #1: 1	ظَهْرِ دَارِهِ
u'ظَهَرَ دَليلٌ':Subject, #2: 2	ظَهْرِ الدَّارِ
u'ظَهَرَ دَليلٌ':Subject, #1: 1	ظَهَرَ دَلِيلُ
u'ظَهَرَ دَليلٌ':Subject, #3: 3	ظَهَرَ الدَّلِيلُ
u'ظَهَرَ دَمٌ':Subject, #3: 3	ظَهَرَ دَلِيلُهُ
u'ظَهَرَ دَمٌ':Subject, #2: 2	ظَهَرَ الدَّمُ
u'ظَهْرٌ دَوَابُّ':Added, #2: 2	ظَهَرَ دَمٌ
u'ظَهَرَ دِينٌ':Predicate, #2: 2	ظَهْرِ الدَّوَابِّ
u'ظَهِرَ دِينٌ':Predicate, #1: 1	أَظْهَرَ الدِّينَ
u'ظَهَرَ دَيْنٌ':Subject, #1: 1	أَظْهَرَ الدِّينَ
u'ظَهَرَ دِينٌ':Subject, #11: 11	ظَهَرَ دَيْنٌ
u'ظَهَرَ دَيْنٌ':Subject, #1: 1	ظَهَرَ الدِّينُ
u'ظَهْرٌ ذِراعٌ':Added, #6: 6	ظَهَرَ الدَّيْنُ
u'ظَهْرٌ ذكر':Added, #1: 1	ظَهْرَ ذِرَاعِ
u'ظَهْرٌ ذَكَرٌ':Added, #1: 1	ظَهْرِ الذَّكَرِ
u'ظَهْرٌ ذَكَرٌ':Added, #1: 1	ظَهْرِ الذَّكَرِ
u'ظَهْرٌ رَاحِلٌ':Added, #1: 1	ظَهْرِ ذَكَرٍ
u'ظَهْرٌ رَاحِلٌ':Added, #1: 1	ظَهْرِ الرَّاحِلَةِ
u'ظَهْرٌ رَاحِلَةٌ':Added, #5: 5	ظَهْرِ رَاحِلَتِهِ
u'ظَهْرٌ رَاحِلَةٌ':Added, #1: 1	ظَهْرِ الرَّاحِلَةِ
u'ظَهَرَ رَأْسٌ':Subject, #5: 5	ظَهْرِ رَاحِلَتِهِ
u'ظَهَرَ راغِب':Subject, #1: 1	ظَهَرَ رَأْسُ
u'ظَهَرَ رَافِعٌ':Subject, #1: 1	ظَهَرَ رَاغِبٌ
u'ظَهَرَ رِبْحٌ':Subject, #1: 1	ظَهَرَ الرَّافِعُ
u'ظَهَرَ رِبْحٌ':Subject, #11: 11	ظَهَرَ الرِّبْحُ
u'ظَهَرَ رُجْحانٌ':Subject, #16: 16	ظَهَرَ رِبْحٌ
u'ظَهَرَ رِجْلٌ':Subject, #1: 1	ظَهَرَ الرُّجْحَانُ
u'ظَهْرٌ رَجُلٌ':Added, #1: 1	ظَهَرَ رِجْلُهُ
u'ظَهْرٌ رَجُلٌ':Added, #14: 14	ظَهْرِ رَجُلٍ
u'ظَهْرٌ رِجْلٌ':Added, #1: 1	ظَهْرُ الرَّجُلِ
u'ظَهْرٌ رِجْلٌ':Added, #1: 1	ظَهْرِ الرِّجْلِ
u'ظَهْرٌ رَجُلٌ':Added, #1: 1	ظَهْرِ رِجْلِهِ
u'ظَهْرٌ رَجُلٌ':Added, #2: 2	ظَهْرَ الرَّجُلِ
u'ظَهَرَ رِدَّةٌ':Predicate, #3: 3	ظَهْرِ الرَّجُلِ
u'ظَهِرَ رِدَّةٌ':Predicate, #2: 2	أَظْهَرَ الرِّدَّةَ
u'ظَهَرَ رَسُولٌ':Subject, #2: 2	أَظْهَرَ الرِّدَّةَ
u'ظَهْرٌ رَسُولٌ':Added, #1: 1	ظَهَرَ رَسُولُ
u'ظَهَرَ رُشْدٌ':Subject, #4: 4	ظَهْرِ رَسُولِ
u'ظَهَرَ رِقٌّ':Subject, #1: 1	ظَهَرَ رُشْدُهُ
u'ظَهَرَ ريحٌ':Subject, #1: 1	ظَهَرَ الرِّقُّ
u'ظَهَرَ زَوْجٌ':Subject, #4: 4	ظَهَرَ رِيحُهُ
u'ظَهَرَ زُورٌ':Subject, #1: 1	ظَهَرَ الزَّوْجُ
u'ظَهَرَ زِيادَةٌ':Subject, #1: 1	ظَهَرَ زُورُهُ
u'ظَهْرٌ سَبَّابٌ':Added, #1: 1	ظَهَرَ زِيَادَةٌ
u'ظَهْرٌ سَبَّابَةٌ':Added, #2: 2	ظَهْرِ السَّبَّابَةِ
u'ظَهَرَ سَبَبٌ':Subject, #2: 2	ظَهْرِ السَّبَّابَةِ
u'ظَهَرَ سَبَبٌ':Subject, #2: 2	ظَهَرَ سَبَبُهُ
u'ظَهْرٌ سِجِلٌّ':Added, #4: 4	ظَهَرَ السَّبَبُ
u'ظَهَرَ سِرٌّ':Subject, #2: 2	ظَهْرِ السِّجِلِّ
u'ظَهَرَ سَرقَةٌ':Subject, #1: 1	ظَهَرَ سِرُّ
u'ظَهَرَ سَرِقَةٌ':Subject, #1: 1	ظَهَرَ سَرِقَتُهُ
u'ظَهَرَ سُرُورٌ':Subject, #1: 1	ظَهَرَ سَرِقَتُهُ
u'ظَهَرَ سعر':Subject, #1: 1	ظَهَرَ سُرُورُهُ
u'ظَهَرَ سِعْرٌ':Subject, #1: 1	ظَهَرَ سِعْرُهُ
u'ظَهْرٌ سُلَحْفَاةٌ':Added, #1: 1	ظَهَرَ سِعْرُهُ
u'ظَهَرَ سَهْوٌ':Subject, #1: 1	ظَهْرِ السُّلَحْفَاةِ
u'ظَهَرَ سَيِّدٌ':Subject, #1: 1	ظَهَرَ سَهْوٌ
u'ظَهْرٌ سَيْرٌ':Added, #1: 1	ظَهَرَ سَيِّدُهُ
u'ظَهْرٌ شَاةٌ':Added, #1: 1	ظَهْرِ سَيْرِهِ
u'ظَهَرَ شَجَرٌ':Subject, #2: 2	ظَهْرِ الشَّاةِ
u'ظَهَرَ شِرَاءٌ':Subject, #3: 3	ظَهَرَ الشَّجَرُ
u'ظَهَرَ شَرْطٌ':Subject, #1: 1	ظَهَرَ شِرَاءُ
u'ظَهْرٌ شَرِيكٌ':Added, #1: 1	ظَهَرَ شَرْطُ
u'ظَهَرَ شِفَاءٌ':Subject, #1: 1	ظَهْرِ شَرِيكِهِ
u'ظَهْرٌ شمال':Added, #1: 1	ظَهَرَ الشِّفَاءُ
u'ظَهْرٌ شِمَالٌ':Added, #1: 1	ظَهْرَ شِمَالِهِ
u'ظَهَرَ شُهُودٌ':Subject, #1: 1	ظَهْرَ شِمَالِهِ
u'ظَهَرَ شَيْءٌ':Subject, #4: 4	ظَهَرَ الشُّهُودُ
u'ظَهَرَ شَيْنٌ':Subject, #3: 3	ظَهَرَ شَيْءٌ
u'ظَهَرَ صَاحِبٌ':Subject, #1: 1	ظَهَرَ شَيْنٌ
u'ظَهَرَ صَاحِبٌ':Subject, #1: 1	ظَهَرَ صَاحِبُ
u'ظَهْرٌ صَادِقٌ':Added, #1: 1	ظَهَرَ صَاحِبُهُ
u'ظَهَرَ صِحَّةٌ':Subject, #1: 1	ظَهْرِ صَادِقَةِ
u'ظَهَرَ صِحَّةٌ':Subject, #2: 2	ظَهَرَ صِحَّتُهُ
u'ظَهَرَ صدق':Subject, #3: 3	ظَهَرَ صِحَّةُ
u'ظَهَرَ صِدْقٌ':Subject, #14: 14	ظَهَرَ صِدْقُ
u'ظَهَرَ صدق':Subject, #14: 14	ظَهَرَ صِدْقُ
u'ظَهَرَ صِدْقٌ':Subject, #1: 1	ظَهَرَ الصِّدْقُ
u'ظَهَرَ صدق':Subject, #1: 1	ظَهَرَ الصِّدْقُ
u'ظَهَرَ صِدْقٌ':Subject, #3: 3	ظَهَرَ صِدْقُهُ
u'ظَهَرَ صَغِيرٌ':Predicate, #3: 3	ظَهَرَ صِدْقُهُ
u'ظَهِرَ صَغِيرٌ':Predicate, #1: 1	أَظْهَرَ صَغِيرَةً
u'ظَهْرٌ صَكٌّ':Added, #1: 1	أَظْهَرَ صَغِيرَةً
u'ظَهْرٌ صَكٌّ':Added, #1: 1	ظَهْرِ صَكِّ
u'ظَهَرَ صَلاَحٌ':Subject, #4: 4	ظَهْرِ الصَّكِّ
u'ظَهَرَ صَوَابٌ':Subject, #2: 2	ظَهَرَ صَلَاحُهُ
u'ظَهَرَ ضَرَرٌ':Subject, #1: 1	ظَهَرَ صَوَابُهُ
u'ظَهَرَ طَالِبٌ':Subject, #1: 1	ظَهَرَ ضَرَرُ
u'ظَهَرَ طرف':Subject, #3: 3	ظَهَرَ طَالِبٌ
u'ظَهَرَ طَرَفٌ':Subject, #1: 1	ظَهَرَ طَرَفُ
u'ظَهْرٌ طَرِيقٌ':Added, #1: 1	ظَهَرَ طَرَفُ
u'ظَهْرٌ طَرِيقٌ':Added, #1: 1	ظَهْرِ الطّرِيقِ
u'ظَهَرَ طَعْمٌ':Subject, #5: 5	ظَهْرِ الطَّرِيقِ
u'ظَهَرَ طَعْمٌ':Subject, #2: 2	ظَهَرَ الطَّعْمُ
u'ظَهَرَ طُلُوعٌ':Subject, #4: 4	ظَهَرَ طَعْمُهُ
u'ظَهْرٌ طُنْفُسَةٌ':Added, #1: 1	ظَهَرَ طُلُوعُ
u'ظَهَرَ ظاهِرٌ':Predicate, #1: 1	ظَهْرَ الطُّنْفُسَةِ
u'ظَهِرَ ظاهِرٌ':Predicate, #1: 1	أَظْهَرَ الظَّاهِرِينَ
u'ظَهْرٌ ظُلَّةٌ':Added, #1: 1	أَظْهَرَ الظَّاهِرِينَ
u'ظَهْرٌ ظُلَّةٌ':Added, #1: 1	ظَهْرِ الظُّلَّةِ
u'ظَهَرَ ظُلْمٌ':Subject, #2: 2	ظَهْرِ ظُلَّةٍ
u'ظَهَرَ ظُلْمٌ':Subject, #1: 1	ظَهَرَ الظُّلْمُ
u'ظَهَرَ عَبْدٌ':Subject, #2: 2	ظَهَرَ ظُلْمُهُ
u'ظَهَرَ عتق':Subject, #11: 11	ظَهَرَ الْعَبْدُ
u'ظَهَرَ عِتْقٌ':Subject, #3: 3	ظَهَرَ الْعِتْقُ
u'ظَهَرَ عجز':Subject, #3: 3	ظَهَرَ الْعِتْقُ
u'ظَهَرَ عَجْزٌ':Subject, #1: 1	ظَهَرَ الْعَجْزُ
u'ظَهَرَ عجز':Subject, #1: 1	ظَهَرَ الْعَجْزُ
u'ظَهَرَ عَجْزٌ':Subject, #2: 2	ظَهَرَ عَجْزُهُ
u'ظَهَرَ عَدَمٌ':Predicate, #2: 2	ظَهَرَ عَجْزُهُ
u'ظَهِرَ عَدَمٌ':Predicate, #1: 1	أَظْهَرَ عَدَمَ
u'ظَهَرَ عَدَمٌ':Subject, #1: 1	أَظْهَرَ عَدَمَ
u'ظَهَرَ عَدَمٌ':Subject, #17: 17	ظَهَرَ عَدَمُ
u'ظَهَرَ عَدُوٌّ':Subject, #1: 1	ظَهَرَ عَدَمُهُ
u'ظَهَرَ عُذْرٌ':Subject, #2: 2	ظَهَرَ عَدُوٌّ
u'ظَهَرَ عُذْرٌ':Subject, #1: 1	ظَهَرَ عُذْرٌ
u'ظَهَرَ عزل':Subject, #2: 2	ظَهَرَ عُذْرُ
u'ظَهَرَ عسر':Subject, #1: 1	ظَهَرَ عَزْلُهُ
u'ظَهَرَ عُسْرٌ':Subject, #1: 1	ظَهَرَ عُسْرُ
u'ظَهَرَ عَشْرٌ':Predicate, #1: 1	ظَهَرَ عُسْرُ
u'ظَهِرَ عَشْرٌ':Predicate, #1: 1	أَظْهَرَ عَشْرَةً
u'ظَهَرَ عَصَبِيٌّ':Predicate, #1: 1	أَظْهَرَ عَشْرَةً
u'ظَهِرَ عَصَبِيٌّ':Predicate, #1: 1	أَظْهَرَ الْعَصَبِيَّةَ
u'ظَهَرَ عَصَبِيَّةٌ':Predicate, #1: 1	أَظْهَرَ الْعَصَبِيَّةَ
u'ظَهِرَ عَصَبِيَّةٌ':Predicate, #1: 1	أَظْهَرَ الْعَصَبِيَّةَ
u'ظَهَرَ عَقِيبٌ':Predicate, #1: 1	أَظْهَرَ الْعَصَبِيَّةَ
u'ظَهَرَ عَلاَمَةٌ':Subject, #2: 2	ظَهَرَ عَقِيبَ
u'ظَهَرَ عَلاَمَةٌ':Subject, #1: 1	ظَهَرَ عَلَامَاتُ
u'ظَهَرَ عَمَلٌ':Subject, #2: 2	ظَهَرَ عَلَامَةُ
u'ظَهَرَ عَمَلٌ':Subject, #1: 1	ظَهَرَ الْعَمَلُ
u'ظَهَرَ عناد':Subject, #2: 2	ظَهَرَ عَمَلُهُ
u'ظَهَرَ عِنَادٌ':Subject, #2: 2	ظَهَرَ عِنَادُهُ
u'ظَهَرَ عند':Predicate, #2: 2	ظَهَرَ عِنَادُهُ
u'ظَهْرٌ عَنْزٌ':Added, #16: 16	ظَهَرَ عِنْدَ
u'ظَهَرَ عَيْبٌ':Predicate, #1: 1	ظَهْرِ عَنْزٍ
u'ظَهِرَ عَيْبٌ':Predicate, #2: 2	أَظْهَرَ عَيْبَ
u'ظَهَرَ عَيْبٌ':Subject, #2: 2	أَظْهَرَ عَيْبَ
u'ظَهَرَ عَيْبٌ':Subject, #3: 3	ظَهَرَ الْعَيْبُ
u'ظَهْرٌ عِيرٌ':Added, #5: 5	ظَهَرَ عَيْبٌ
u'ظَهَرَ غَبْنٌ':Subject, #1: 1	ظَهْرِ عِيرٍ
u'ظَهَرَ غَبْنٌ':Subject, #1: 1	ظَهَرَ غَبْنٌ
u'ظَهَرَ غَسْلٌ':Subject, #1: 1	ظَهَرَ غَبْنُهُ
u'ظَهَرَ غضب':Predicate, #1: 1	ظَهَرَ غَسْلُهُ
u'ظَهِرَ غضب':Predicate, #1: 1	أَظْهَرَ الْغَضَبَ
u'ظَهَرَ غَضَبٌ':Predicate, #1: 1	أَظْهَرَ الْغَضَبَ
u'ظَهِرَ غَضَبٌ':Predicate, #1: 1	أَظْهَرَ الْغَضَبَ
u'ظَهَرَ غضب':Subject, #1: 1	أَظْهَرَ الْغَضَبَ
u'ظَهَرَ غَضَبٌ':Subject, #1: 1	ظَهَرَ غَضَبُهُ
u'ظَهَرَ غَلَطٌ':Subject, #1: 1	ظَهَرَ غَضَبُهُ
u'ظَهَرَ غُلُول':Subject, #2: 2	ظَهَرَ غَلَطُ
u'ظَهَرَ غناء':Predicate, #1: 1	ظَهَرَ الْغُلُولُ
u'ظَهِرَ غناء':Predicate, #1: 1	أَظْهَرَ غَنَاءَ
u'ظَهَرَ غَنَاءٌ':Predicate, #1: 1	أَظْهَرَ غَنَاءَ
u'ظَهِرَ غَنَاءٌ':Predicate, #1: 1	أَظْهَرَ غَنَاءَ
u'ظَهْرٌ غَنَمٌ':Added, #1: 1	أَظْهَرَ غَنَاءَ
u'ظَهْرٌ غَنَمٌ':Added, #14: 14	ظَهْرِ الْغَنَمِ
u'ظَهْرٌ غَنَمٌ':Added, #1: 1	ظَهْرِ غَنَمِهِ
u'ظَهْرٌ غَنِيٌّ':Added, #2: 2	ظَهْرِ غَنَمٍ
u'ظَهْرٌ غيب':Added, #1: 1	ظَهْرِ غَنِيٍّ
u'ظَهْرٌ غَيْبٌ':Added, #1: 1	ظَهْرِ الْغَيْبِ
u'ظَهَرَ غير':Subject, #1: 1	ظَهْرِ الْغَيْبِ
u'ظَهَرَ غَيْرٌ':Subject, #2: 2	ظَهَرَ غَيْرُهُ
u'ظَهْرٌ غير':Added, #2: 2	ظَهَرَ غَيْرُهُ
u'ظَهْرٌ غَيْرٌ':Added, #2: 2	ظَهْرِ غَيْرِهِ
u'ظَهَرَ فَاقَةٌ':Predicate, #2: 2	ظَهْرِ غَيْرِهِ
u'ظَهِرَ فَاقَةٌ':Predicate, #2: 2	أَظْهَرَ الْفَاقَةَ
u'ظَهَرَ فَائِدَةٌ':Subject, #2: 2	أَظْهَرَ الْفَاقَةَ
u'ظَهَرَ فرار':Subject, #3: 3	ظَهَرَ فَائِدَةُ
u'ظَهَرَ فِرَارٌ':Subject, #1: 1	ظَهَرَ فِرَارُهُ
u'ظَهَرَ فِرَاشٌ':Subject, #1: 1	ظَهَرَ فِرَارُهُ
u'ظَهْرٌ فَرَسٌ':Added, #3: 3	ظَهَرَ الْفِرَاشُ
u'ظَهْرٌ فَرَسٌ':Added, #1: 1	ظَهْرَ فَرَسِهِ
u'ظَهَرَ فرق':Subject, #7: 7	ظَهْرِ فَرَسِهِ
u'ظَهَرَ فَرْقٌ':Subject, #13: 13	ظَهَرَ الْفَرْقُ
u'ظَهَرَ فساد':Subject, #13: 13	ظَهَرَ الْفَرْقُ
u'ظَهَرَ فَسَادٌ':Subject, #16: 16	ظَهَرَ فَسَادُ
u'ظَهَرَ فساد':Subject, #16: 16	ظَهَرَ فَسَادُ
u'ظَهَرَ فَسَادٌ':Subject, #3: 3	ظَهَرَ فَسَادُهُ
u'ظَهَرَ فساد':Subject, #3: 3	ظَهَرَ فَسَادُهُ
u'ظَهَرَ فَسَادٌ':Subject, #6: 6	ظَهَرَ الْفَسَادُ
u'ظَهَرَ فِسْقٌ':Predicate, #6: 6	ظَهَرَ الْفَسَادُ
u'ظَهِرَ فِسْقٌ':Predicate, #2: 2	أَظْهَرَ الْفِسْقَ
u'ظَهَرَ فِسْقٌ':Subject, #2: 2	أَظْهَرَ الْفِسْقَ
u'ظَهَرَ فَضْلٌ':Subject, #3: 3	ظَهَرَ فِسْقُهُ
u'ظَهَرَ فَضْلٌ':Subject, #1: 1	ظَهَرَ الْفَضْلُ
u'ظَهَرَ فَضْلٌ':Subject, #1: 1	ظَهَرَ فَضْلُ
u'ظَهَرَ فِعْلٌ':Subject, #1: 1	ظَهَرَ فَضْلُهُ
u'ظَهَرَ فقر':Subject, #1: 1	ظَهَرَ فِعْلُهُ
u'ظَهَرَ فَقْرٌ':Subject, #2: 2	ظَهَرَ الْفَقْرُ
u'ظَهَرَ فلان':Subject, #2: 2	ظَهَرَ الْفَقْرُ
u'ظَهَرَ فُلاَنٌ':Subject, #1: 1	ظَهَرَ رَاغِبٌ
u'ظَهْرٌ فُلاَنٌ':Added, #1: 1	ظَهَرَ فُلَانٌ
u'ظَهَرَ قَابِضٌ':Subject, #1: 1	ظَهْرِ فُلَانٍ
u'ظَهْرٌ قَاعِدٌ':Added, #1: 1	ظَهَرَ قَابِضُ
u'ظَهَرَ قَالٌ':Predicate, #1: 1	ظَهْرِ قَاعِدٍ
u'ظَهَرَ قَبْضٌ':Subject, #1: 1	ظَهَرَ قَالَ
u'ظَهْرٌ قَتَب':Added, #1: 1	ظَهَرَ قَبْضُهُ
u'ظَهَرَ قَدْرٌ':Subject, #8: 8	ظَهْرِ قَتَبٍ
u'ظَهَرَ قدم':Subject, #1: 1	ظَهَرَ قَدْرُ
u'ظَهَرَ قَدَمٌ':Subject, #3: 3	ظَهَرَ قَدَمُ
u'ظَهْرٌ قَدَمٌ':Added, #3: 3	ظَهَرَ قَدَمُ
u'ظَهْرٌ قَدَمٌ':Added, #1: 1	ظَهْرَ الْقَدَمَيْنِ
u'ظَهْرٌ قدم':Added, #1: 1	ظَهْرُ الْقَدَمَيْنِ
u'ظَهْرٌ قَدَمٌ':Added, #1: 1	ظَهْرَ قَدَمِ
u'ظَهْرٌ قدم':Added, #1: 1	ظَهْرَ قَدَمِ
u'ظَهْرٌ قَدَمٌ':Added, #23: 23	ظَهْرِ الْقَدَمِ
u'ظَهْرٌ قدم':Added, #23: 23	ظَهْرِ الْقَدَمِ
u'ظَهْرٌ قَدَمٌ':Added, #2: 2	ظَهْرَ الْقَدَمِ
u'ظَهْرٌ قَدَمٌ':Added, #2: 2	ظَهْرَ الْقَدَمِ
u'ظَهْرٌ قدم':Added, #2: 2	ظَهْرِ الْقَدَمَيْنِ
u'ظَهْرٌ قَدَمٌ':Added, #4: 4	ظَهْرُ الْقَدَمِ
u'ظَهْرٌ قدم':Added, #4: 4	ظَهْرُ الْقَدَمِ
u'ظَهْرٌ قَدَمٌ':Added, #4: 4	ظَهْرِ قَدَمِهِ
u'ظَهَرَ قذف':Predicate, #4: 4	ظَهْرِ قَدَمِهِ
u'ظَهِرَ قذف':Predicate, #1: 1	أَظْهَرَ الْقَذْفَ
u'ظَهَرَ قَذْفٌ':Predicate, #1: 1	أَظْهَرَ الْقَذْفَ
u'ظَهِرَ قَذْفٌ':Predicate, #1: 1	أَظْهَرَ الْقَذْفَ
u'ظَهَرَ قذف':Subject, #1: 1	أَظْهَرَ الْقَذْفَ
u'ظَهَرَ قَذْفٌ':Subject, #1: 1	ظَهَرَ الْقَذْفُ
u'ظَهْرٌ قِصَّةٌ':Added, #1: 1	ظَهَرَ الْقَذْفُ
u'ظَهَرَ قَصْدٌ':Subject, #1: 1	ظَهْرِ الْقِصَّةِ
u'ظَهَرَ قَصْدٌ':Subject, #1: 1	ظَهَرَ الْقَصْدُ
u'ظَهَرَ قُصُورٌ':Subject, #3: 3	ظَهَرَ قَصْدُ
u'ظَهَرَ قَطْعٌ':Subject, #1: 1	ظَهَرَ قُصُورُ
u'ظَهْرٌ قلب':Added, #1: 1	ظَهَرَ الْقَطْعُ
u'ظَهْرٌ قَلْبٌ':Added, #11: 11	ظَهْرِ الْقَلْبِ
u'ظَهْرٌ قَلْب':Added, #11: 11	ظَهْرِ الْقَلْبِ
u'ظَهْرٌ قلب':Added, #11: 11	ظَهْرِ الْقَلْبِ
u'ظَهْرٌ قَلْبٌ':Added, #6: 6	ظَهْرِ قَلْبِهِ
u'ظَهْرٌ قَلْب':Added, #6: 6	ظَهْرِ قَلْبِهِ
u'ظَهْرٌ قَلْبٌ':Added, #6: 6	ظَهْرِ قَلْبِهِ
u'ظَهْرٌ قَلْب':Added, #8: 8	ظَهْرِ قَلْبٍ
u'ظَهَرَ قُوَّةٌ':Subject, #8: 8	ظَهْرِ قَلْبٍ
u'ظَهَرَ قُوَّة':Subject, #1: 1	ظَهَرَ قُوَّةُ
u'ظَهَرَ قول':Subject, #1: 1	ظَهَرَ قُوَّةُ
u'ظَهَرَ قَوْلٌ':Subject, #2: 2	ظَهَرَ الْقَوْلُ
u'ظَهَرَ قَوْمٌ':Subject, #2: 2	ظَهَرَ الْقَوْلُ
u'ظَهْرٌ قَوْمٌ':Added, #1: 1	ظَهَرَ الْقَوْمُ
u'ظَهَرَ قَوِيٌّ':Subject, #1: 1	ظَهْرِ الْقَوْمِ
u'ظَهَرَ قيام':Subject, #3: 3	ظَهَرَ الْقَوِيُّ
u'ظَهَرَ قِيَامٌ':Subject, #1: 1	ظَهَرَ قِيَامُهُ
u'ظَهَرَ قِيمَةٌ':Subject, #1: 1	ظَهَرَ قِيَامُهُ
u'ظَهَرَ قِيمَةٌ':Subject, #1: 1	ظَهَرَ قِيمَةُ
u'ظَهَرَ كَافِرٌ':Subject, #2: 2	ظَهَرَ قِيمَتُهُ
u'ظَهَرَ كِتَابٌ':Subject, #1: 1	ظَهَرَ الْكَافِرُ
u'ظَهَرَ كِتَابٌ':Subject, #1: 1	ظَهَرَ كِتَابٌ
u'ظَهْرٌ كِتَابٌ':Added, #2: 2	ظَهَرَ كِتَابُ
u'ظَهْرٌ كِتَابٌ':Added, #1: 1	ظَهْرِ كِتَابِهِ
u'ظَهْرٌ كَثِيبٌ':Added, #4: 4	ظَهْرِ الْكِتَابِ
u'ظَهَرَ كذب':Subject, #1: 1	ظَهْرُ الْكَثِيبِ
u'ظَهَرَ كَذِبٌ':Subject, #1: 1	ظَهَرَ الْكَذِبُ
u'ظَهَرَ كذب':Subject, #1: 1	ظَهَرَ الْكَذِبُ
u'ظَهَرَ كَذِبٌ':Subject, #4: 4	ظَهَرَ كَذِبُ
u'ظَهَرَ كذب':Subject, #4: 4	ظَهَرَ كَذِبُ
u'ظَهَرَ كَذِبٌ':Subject, #9: 9	ظَهَرَ كَذِبُهُ
u'ظَهْرٌ كعبة':Added, #9: 9	ظَهَرَ كَذِبُهُ
u'ظَهْرٌ كَعْبَةٌ':Added, #10: 10	ظَهْرِ الْكَعْبَةِ
u'ظَهْرٌ كعبة':Added, #10: 10	ظَهْرِ الْكَعْبَةِ
u'ظَهْرٌ كَعْبَةٌ':Added, #1: 1	ظَهْرُ الْكَعْبَةِ
u'ظَهْرٌ كَفٌّ':Added, #1: 1	ظَهْرُ الْكَعْبَةِ
u'ظَهْرٌ كَفٌّ':Added, #2: 2	ظَهْرُ الْكَفِّ
u'ظَهْرٌ كَفٌّ':Added, #3: 3	ظَهْرَ كَفِّهِ
u'ظَهْرٌ كَفٌّ':Added, #4: 4	ظَهْرِ الْكَفِّ
u'ظَهْرٌ كَفٌّ':Added, #6: 6	ظَهْرَ الْكَفِّ
u'ظَهَرَ كَلَأٌ':Subject, #8: 8	ظَهْرِ كَفِّهِ
u'ظَهَرَ كَمَالٌ':Predicate, #1: 1	ظَهَرَ كَلَأٌ
u'ظَهِرَ كَمَالٌ':Predicate, #1: 1	أَظْهَرَ كَمَالَ
u'ظَهَرَ كَمَالٌ':Subject, #1: 1	أَظْهَرَ كَمَالَ
u'ظَهَرَ كَوْنٌ':Subject, #2: 2	ظَهَرَ الْكَمَالُ
u'ظَهَرَ لُزُومٌ':Subject, #1: 1	ظَهَرَ كَوْنُ
u'ظَهَرَ لَوْنٌ':Subject, #1: 1	ظَهَرَ لُزُومُ
u'ظَهَرَ مَاءٌ':Subject, #2: 2	ظَهَرَ لَوْنُهُ
u'ظَهْرٌ مَاءٌ':Added, #4: 4	ظَهَرَ الْمَاءُ
u'ظَهَرَ مَالٌ':Subject, #1: 1	ظَهْرِ الْمَاءِ
u'ظَهَرَ مَالٌ':Subject, #1: 1	ظَهَرَ مَالُ
u'ظَهَرَ مَالٌ':Subject, #2: 2	ظَهَرَ الْمَالُ
u'ظَهَرَ مَالِكٌ':Subject, #2: 2	ظَهَرَ مَالٌ
u'ظَهْرٌ مَبْلَغٌ':Added, #5: 5	ظَهَرَ الْمَالِكُ
u'ظَهَرَ مَبِيعٌ':Subject, #1: 1	ظَهْرِ مَبْلَغٍ
u'ظَهَرَ مَتَاعٌ':Subject, #3: 3	ظَهَرَ الْمَبِيعُ
u'ظَهَرَ مثل':Predicate, #1: 1	ظَهَرَ الْمَتَاعُ
u'ظَهَرَ مِثْلٌ':Predicate, #2: 2	ظَهَرَ مِثْلَ
u'ظَهَرَ مُحَمَّدٌ':Subject, #2: 2	ظَهَرَ مِثْلَ
u'ظَهَرَ مُحَمَّدٌ':Subject, #1: 1	ظَهَرَ مُحَمّدٌ
u'ظَهْرٌ مَداس':Added, #1: 1	ظَهَرَ مُحَمَّدٌ
u'ظَهْرٌ مَدِينٌ':Added, #1: 1	ظَهْرِ الْمَدَاسِ
u'ظَهْرٌ مَدِينَةٌ':Added, #1: 1	ظَهْرَ الْمَدِينَةِ
u'ظَهَرَ مراد':Predicate, #1: 1	ظَهْرَ الْمَدِينَةِ
u'ظَهِرَ مراد':Predicate, #1: 1	أَظْهَرَ الْمُرَادَ
u'ظَهَرَ مُرَادٌ':Predicate, #1: 1	أَظْهَرَ الْمُرَادَ
u'ظَهِرَ مُرَادٌ':Predicate, #1: 1	أَظْهَرَ الْمُرَادَ
u'ظَهَرَ مراد':Subject, #1: 1	أَظْهَرَ الْمُرَادَ
u'ظَهَرَ مُرَادٌ':Subject, #5: 5	ظَهَرَ الْمُرَادُ
u'ظَهَرَ مُزَاحِمٌ':Subject, #5: 5	ظَهَرَ الْمُرَادُ
u'ظَهَرَ مُسَاوَاةٌ':Subject, #1: 1	ظَهَرَ مُزَاحِمُهُ
u'ظَهَرَ مُسْتَحِقٌّ':Subject, #1: 1	ظَهَرَ الْمُسَاوَاةُ
u'ظَهْرٌ مَسْجِدٌ':Added, #1: 1	ظَهَرَ الْمُسْتَحِقُّ
u'ظَهْرٌ مَسْجِدٌ':Added, #13: 13	ظَهْرِ الْمَسْجِدِ
u'ظَهْرٌ مُسْلِمٌ':Added, #1: 1	ظَهْرُ الْمَسْجِدِ
u'ظَهَرَ مَعْبَدٌ':Subject, #2: 2	ظَهْرَ مُسْلِمٍ
u'ظَهَرَ مُعْجِزٌ':Predicate, #1: 1	ظَهَرَ مَعْبَدُ
u'ظَهِرَ مُعْجِزٌ':Predicate, #1: 1	أَظْهَرَ الْمُعْجِزَةَ
u'ظَهَرَ مُعْجِزَةٌ':Predicate, #1: 1	أَظْهَرَ الْمُعْجِزَةَ
u'ظَهِرَ مُعْجِزَةٌ':Predicate, #1: 1	أَظْهَرَ الْمُعْجِزَةَ
u'ظَهَرَ مَعَرَّة':Predicate, #1: 1	أَظْهَرَ الْمُعْجِزَةَ
u'ظَهِرَ مَعَرَّة':Predicate, #3: 3	أَظْهَرَ مَعَرَّةَ
u'ظَهَرَ مَعْصِيَةٌ':Predicate, #3: 3	أَظْهَرَ مَعَرَّةَ
u'ظَهِرَ مَعْصِيَةٌ':Predicate, #1: 1	أَظْهَرَ الْمَعْصِيَةَ
u'ظَهَرَ مَعْقُودٌ':Subject, #1: 1	أَظْهَرَ الْمَعْصِيَةَ
u'ظَهَرَ مَغْصُوب':Subject, #1: 1	ظَهَرَ الْمَعْقُودُ
u'ظَهَرَ مَقْدُورٌ':Subject, #2: 2	ظَهَرَ الْمَغْصُوبُ
u'ظَهَرَ مِلْكٌ':Subject, #1: 1	ظَهَرَ الْمَقْدُورُ
u'ظَهَرَ مِلْكٌ':Subject, #2: 2	ظَهَرَ الْمِلْكُ
u'ظَهَرَ مِلْكٌ':Subject, #2: 2	ظَهَرَ مِلْكُهُ
u'ظَهَرَ مَوْتٌ':Subject, #3: 3	ظَهَرَ مِلْكُ
u'ظَهَرَ مَوْتٌ':Subject, #1: 1	ظَهَرَ مَوْتُهُ
u'ظَهَرَ مُوجِبٌ':Subject, #2: 2	ظَهَرَ الْمَوْتُ
u'ظَهَرَ مُؤَكِّدٌ':Subject, #1: 1	ظَهَرَ مُوجِبُهُ
u'ظَهْرٌ مُؤْمِنٌ':Added, #1: 1	ظَهَرَ الْمُؤَكِّدُ
u'ظَهَرَ ميل':Predicate, #2: 2	ظَهْرُ الْمُؤْمِنِ
u'ظَهِرَ ميل':Predicate, #1: 1	أَظْهَرَ الْمَيْلَ
u'ظَهَرَ مَيْلٌ':Predicate, #1: 1	أَظْهَرَ الْمَيْلَ
u'ظَهِرَ مَيْلٌ':Predicate, #1: 1	أَظْهَرَ الْمَيْلَ
u'ظَهَرَ ميل':Subject, #1: 1	أَظْهَرَ الْمَيْلَ
u'ظَهَرَ مَيْلٌ':Subject, #2: 2	ظَهَرَ مَيْلُ
u'ظَهَرَ نَاسِخٌ':Subject, #2: 2	ظَهَرَ مَيْلُ
u'ظَهَرَ نَاسِخ':Subject, #1: 1	ظَهَرَ نَاسِخُهُ
u'ظَهَرَ نَتْنٌ':Subject, #1: 1	ظَهَرَ نَاسِخُهُ
u'ظَهَرَ نَدْبٌ':Subject, #1: 1	ظَهَرَ نَتْنُ
u'ظَهَرَ نَدَمٌ':Subject, #1: 1	ظَهَرَ النَّدْبُ
u'ظَهَرَ نَصٌّ':Subject, #1: 1	ظَهَرَ نَدَمُهُ
u'ظَهَرَ نِصْفٌ':Subject, #5: 5	ظَهَرَ نَصٌّ
u'ظَهَرَ نَصِيبٌ':Subject, #1: 1	ظَهَرَ النِّصْفُ
u'ظَهَرَ نَصِيبٌ':Subject, #1: 1	ظَهَرَ نَصِيبُ
u'ظَهَرَ نَفْخ':Subject, #1: 1	ظَهَرَ نَصِيبُهُ
u'ظَهَرَ نُفُوذٌ':Subject, #1: 1	ظَهَرَ النَّفْخُ
u'ظَهَرَ نَقْصٌ':Subject, #1: 1	ظَهَرَ نُفُوذُ
u'ظَهَرَ نَقْصٌ':Subject, #1: 1	ظَهَرَ نَقْصٌ
u'ظَهَرَ نُقْصَانٌ':Subject, #1: 1	ظَهَرَ نَقْصُهُ
u'ظَهَرَ نقل':Subject, #2: 2	ظَهَرَ النُّقْصَانُ
u'ظَهَرَ نَقْلٌ':Subject, #1: 1	ظَهَرَ نَقْلُ
u'ظَهَرَ نَمَاءٌ':Subject, #1: 1	ظَهَرَ نَقْلُ
u'ظَهْرٌ نَهْرٌ':Added, #1: 1	ظَهَرَ النَّمَاءُ
u'ظَهْرٌ هَدِيٌّ':Added, #2: 2	ظَهْرِ نَهْرٍ
u'ظَهْرٌ هَدْيٌ':Added, #1: 1	ظَهْرِ هَدِيَّةٍ
u'ظَهْرٌ هَدِيَّةٌ':Added, #1: 1	ظَهْرِ هَدْيِهِ
u'ظَهَرَ هلاك':Subject, #1: 1	ظَهْرِ هَدِيَّةٍ
u'ظَهَرَ هَلاَكٌ':Subject, #1: 1	ظَهَرَ هَلاَكُهُ
u'ظَهْرٌ واحد':Added, #1: 1	ظَهَرَ هَلاَكُهُ
u'ظَهْرٌ وَاحِدٌ':Added, #1: 1	ظَهْرُ وَاحِدَةٍ
u'ظَهَرَ وَارِثٌ':Subject, #1: 1	ظَهْرُ وَاحِدَةٍ
u'ظَهَرَ وَارِثٌ':Subject, #3: 3	ظَهَرَ الْوَارِثُ
u'ظَهْرٌ وَثِيقٌ':Added, #6: 6	ظَهَرَ وَارِثٌ
u'ظَهَرَ وَجْهٌ':Subject, #1: 1	ظَهْرِ وَثِيقَةِ
u'ظَهَرَ وَجْهٌ':Subject, #13: 13	ظَهَرَ وَجْهُ
u'ظَهَرَ وُجُوبٌ':Subject, #2: 2	ظَهَرَ وَجْهُهُ
u'ظَهَرَ وُجُوبٌ':Subject, #2: 2	ظَهَرَ وُجُوبُ
u'ظَهَرَ وُجُوبٌ':Subject, #4: 4	ظَهَرَ الْوُجُوبُ
u'ظَهَرَ وَضْعٌ':Subject, #9: 9	ظَهَرَ وُجُوبُهُ
u'ظَهَرَ وُقُوعٌ':Subject, #2: 2	ظَهَرَ وَضْعُ
u'ظَهَرَ وَلاَءٌ':Subject, #1: 1	ظَهَرَ وُقُوعُ
u'ظَهَرَ وَلاَءٌ':Subject, #1: 1	ظَهَرَ الْوَلَاءُ
u'ظَهْرٌ يَدٌ':Added, #1: 1	ظَهَرَ وَلَاءُ
u'ظَهْرٌ يَدٌ':Added, #1: 1	ظَهْرَ الْيَدِ
u'ظَهْرٌ يَدٌ':Added, #1: 1	ظَهْرِ يَدِهِ
u'عَابَ اِبْنٌ':Subject, #2: 2	ظَهْرَ يَدِهِ
u'عَابَ أهْلٌ':Subject, #1: 1	عَابَ ابْنُ
u'عَابَ رَسُولٌ':Predicate, #1: 1	عَابَ أَهْلُ
u'عَابَ رَسُولٌ':Subject, #1: 1	عَابَ رَسُولَ
u'عَابَ عجلة':Predicate, #5: 5	عَابَ رَسُولُ
u'عَابَ عَجَلَةٌ':Predicate, #1: 1	عَابَ الْعَجَلَةَ
u'عَابَ قول':Predicate, #1: 1	عَابَ الْعَجَلَةَ
u'عَابَ قَوْلٌ':Predicate, #1: 1	عَابَ قَوْلَ
u'عَابَ كفر':Predicate, #1: 1	عَابَ قَوْلَ
u'عَابَ مَبِيعٌ':Predicate, #1: 1	عَابَ كَفَرَ
u'عَابَ مَتَاعٌ':Subject, #2: 2	عَابَ الْمَبِيعَ
u'عَابَ نَاسٌ':Predicate, #2: 2	عَابَ الْمَتَاعُ
u'عَابَ نَاسٌ':Subject, #1: 1	عَابَ النَّاسَ
u'عَادَ أَبٌ':Subject, #2: 2	عَابَ النَّاسُ
u'عَادَ إبَاحَةٌ':Predicate, #2: 2	عَادَ الْأَبُ
u'عَادَ اِبْنٌ':Predicate, #1: 1	أَعَادَ إبَاحَةَ
u'عَادَ اِبْنٌ':Subject, #1: 1	عَادَ ابْنَ
u'عَادَ إثْرٌ':Predicate, #1: 1	أَعَادَ ابْنُ
u'عَادَ أَجَلٌ':Subject, #1: 1	أَعَادَ إثْرَ
u'عَادَ أَجْنَبِيٌّ':Subject, #4: 4	عَادَ الْأَجَلُ
u'عَادَ أَذَانٌ':Predicate, #2: 2	عَادَ الْأَجْنَبِيُّ
u'عَادَ أسْوَد':Subject, #3: 3	أَعَادَ الْأَذَانَ
u'عَادَ إشارَة':Predicate, #3: 3	عَادَ الْأَسْوَدُ
u'عَادَ إِشْكالٌ':Subject, #1: 1	أَعَادَ الْإِشَارَةَ
u'عَادَ أُصْبُعٌ':Predicate, #1: 1	عَادَ الْإِشْكَالُ
u'عَادَ إقامَةٌ':Predicate, #1: 1	أَعَادَ الْأُصْبُعَ
u'عَادَ إقْرَارٌ':Predicate, #4: 4	أَعَادَ الْإِقَامَةَ
u'عَادَ إلْحَاقٌ':Subject, #2: 2	أَعَادَ الْإِقْرَارَ
u'عَادَ ألف':Subject, #1: 1	عَادَ إلْحَاقُهُ
u'عَادَ ألْفٌ':Subject, #2: 2	عَادَ الْأَلْفُ
u'عَادَ أَلْفٌ':Subject, #2: 2	عَادَ الْأَلْفُ
u'عَادَ الْمَرْءُ':Subject, #2: 2	عَادَ الْأَلْفُ
u'عَادَ إمَامٌ':Subject, #1: 1	عَادَ الْمَرْءُ
u'عَادَ إمَامٌ':Subject, #14: 14	عَادَ الْإِمَامُ
u'عَادَ إمَامٌ':Subject, #1: 1	عَادَ إمَامُهُ
u'عَادَ أَمْرٌ':Predicate, #3: 3	أَعَادَ الْإِمَامُ
u'عَادَ أَمْرٌ':Subject, #1: 1	أَعَادَ الْأَمْرَ
u'عَادَ أَمْرٌ':Subject, #1: 1	عَادَ الأَمْرُ
u'عَادَ اِنْتِسابٌ':Subject, #8: 8	عَادَ الْأَمْرُ
u'عَادَ أَوَّلُ':Predicate, #1: 1	عَادَ انْتِسَابُ
u'عَادَ أَوَّلُ':Predicate, #1: 1	أَعَادَ الْأَوَّلَ
u'عَادَ أَوَّلُ':Subject, #1: 1	عَادَ أَوَّلَ
u'عَادَ إِيجَابٌ':Predicate, #1: 1	عَادَ الْأَوَّلُ
u'عَادَ بَصَرٌ':Subject, #1: 1	أَعَادَ الْإِيجَابَ
u'عَادَ بَصَرٌ':Subject, #1: 1	عَادَ بَصَرُهُ
u'عَادَ بَعْضٌ':Predicate, #3: 3	عَادَ الْبَصَرُ
u'عَادَ بَعْضٌ':Subject, #1: 1	عَادَ بَعْضَ
u'عَادَ بَعيرٌ':Subject, #1: 1	عَادَ بَعْضُ
u'عَادَ بُنْيانٌ':Predicate, #1: 1	عَادَ الْبَعِيرُ
u'عَادَ بَيَاضٌ':Subject, #1: 1	أَعَادَ الْبُنْيَانَ
u'عَادَ بَيْعٌ':Subject, #6: 6	عَادَ الْبَيَاضُ
u'عَادَ بَيِّنَةٌ':Predicate, #5: 5	عَادَ الْبَيْعُ
u'عَادَ تَدْبِيرٌ':Subject, #8: 8	أَعَادَ الْبَيِّنَةَ
u'عَادَ تَرَاوِيحُ':Predicate, #1: 1	عَادَ التَّدْبِيرُ
u'عَادَ تَرْتِيبٌ':Predicate, #1: 1	أَعَادَ التَّرَاوِيحَ
u'عَادَ تَرْتِيبٌ':Subject, #1: 1	عَادَ التَّرْتِيبَ
u'عَادَ تَرْدِيدٌ':Subject, #2: 2	عَادَ التَّرْتِيبُ
u'عَادَ تَعَوُّذٌ':Predicate, #1: 1	عَادَ التَّرْدِيدُ
u'عَادَ تَلْبيَةٌ':Predicate, #2: 2	أَعَادَ التَّعَوُّذَ
u'عَادَ تَيَمُّمٌ':Predicate, #1: 1	أَعَادَ التَّلْبِيَةَ
u'عَادَ ثَانِي':Predicate, #7: 7	أَعَادَ التَّيَمُّمَ
u'عَادَ ثَانِي':Predicate, #1: 1	عَادَ ثَانِيَةً
u'عَادَ ثَانِيَةٌ':Predicate, #3: 3	أَعَادَ الثَّانِيَةَ
u'عَادَ ثُمام':Subject, #3: 3	أَعَادَ الثَّانِيَةَ
u'عَادَ ثَوْبٌ':Subject, #1: 1	عَادَ ثُمَامَةُ
u'عَادَ جَازٌ':Predicate, #1: 1	عَادَ الثَّوْبُ
u'عَادَ جلد':Subject, #1: 1	عَادَ جَازَ
u'عَادَ جِلْدٌ':Subject, #1: 1	عَادَ جِلْدُهُ
u'عَادَ جِمَارٌ':Predicate, #1: 1	عَادَ جِلْدُهُ
u'عَادَ جَمْرَةٌ':Predicate, #1: 1	أَعَادَ الْجِمَارَ
u'عَادَ جَمْرَة':Predicate, #1: 1	أَعَادَ الْجَمْرَةَ
u'عَادَ جُنُونٌ':Subject, #1: 1	أَعَادَ الْجَمْرَةَ
u'عَادَ جَيْشٌ':Subject, #1: 1	عَادَ جُنُونُهُ
u'عَادَ حاكِمٌ':Subject, #1: 1	عَادَ جَيْشُهُ
u'عَادَ حائِطٌ':Predicate, #1: 1	أَعَادَ الْحَاكِمُ
u'عَادَ حَجٌّ':Predicate, #1: 1	أَعَادَ حَائِطَ
u'عَادَ حجاب':Predicate, #4: 4	أَعَادَ الْحَجَّ
u'عَادَ حِجابٌ':Predicate, #1: 1	أَعَادَ الْحِجَابَ
u'عَادَ حَدَثٌ':Subject, #1: 1	أَعَادَ الْحِجَابَ
u'عَادَ حَديثٌ':Subject, #2: 2	عَادَ الْحَدَثُ
u'عَادَ حَقٌّ':Subject, #1: 1	عَادَ الْحَدِيثُ
u'عَادَ حَقٌّ':Subject, #1: 1	عَادَ الْحَقُّ
u'عَادَ حَقٌّ':Subject, #5: 5	عَادَ حَقُّ
u'عَادَ حُكْمٌ':Predicate, #8: 8	عَادَ حَقُّهُ
u'عَادَ حُكْمٌ':Subject, #1: 1	أَعَادَ حُكْمَ
u'عَادَ حُكْمٌ':Subject, #2: 2	عَادَ حُكْمُهُ
u'عَادَ حُكْمٌ':Subject, #5: 5	عَادَ حُكْمُ
u'عَادَ حَمَلٌ':Predicate, #9: 9	عَادَ الْحُكْمُ
u'عَادَ خَارِجٌ':Subject, #1: 1	عَادَ حَمَلَ
u'عَادَ خَائِفٌ':Subject, #1: 1	أَعَادَ الْخَارِجُ
u'عَادَ خطبة':Predicate, #1: 1	أَعَادَ الْخَائِفُ
u'عَادَ خُطْبَةٌ':Predicate, #1: 1	أَعَادَ الْخُطْبَةَ
u'عَادَ خِلاَفٌ':Subject, #1: 1	أَعَادَ الْخُطْبَةَ
u'عَادَ خيار':Subject, #1: 1	عَادَ الْخِلَافُ
u'عَادَ خِيَارٌ':Subject, #2: 2	عَادَ خِيَارُ
u'عَادَ دُعَاءٌ':Predicate, #2: 2	عَادَ خِيَارُ
u'عَادَ دَلْوٌ':Predicate, #2: 2	أَعَادَ الدُّعَاءَ
u'عَادَ دَلْوٌ':Subject, #1: 1	أَعَادَ الدَّلْوَ
u'عَادَ دَمٌ':Subject, #1: 1	عَادَ الدَّلْوُ
u'عَادَ دونٌ':Predicate, #16: 16	عَادَ الدَّمُ
u'عَادَ دَيْنٌ':Subject, #1: 1	عَادَ دُونَ
u'عَادَ دِينٌ':Subject, #11: 11	عَادَ الدَّيْنُ
u'عَادَ دَيْنٌ':Subject, #1: 1	عَادَ الدّينُ
u'عَادَ دَيْنٌ':Subject, #1: 1	عَادَ الدّينُ
u'عَادَ ذكر':Predicate, #1: 1	عَادَ دَيْنُهُ
u'عَادَ ذِكْرٌ':Predicate, #1: 1	أَعَادَ ذِكْرَ
u'عَادَ رابع':Predicate, #1: 1	أَعَادَ ذِكْرَ
u'عَادَ رَابِعٌ':Predicate, #8: 8	عَادَ الرَّابِعَةَ
u'عَادَ رَبُّ':Subject, #8: 8	عَادَ الرَّابِعَةَ
u'عَادَ رَجُلٌ':Subject, #1: 1	عَادَ رَبُّ
u'عَادَ رُجُوعٌ':Subject, #2: 2	عَادَ الرَّجُلُ
u'عَادَ رَسُولٌ':Subject, #3: 3	عَادَ الرُّجُوعُ
u'عَادَ رُكْنٌ':Predicate, #2: 2	عَادَ رَسُولُ
u'عَادَ رُكْن':Predicate, #2: 2	أَعَادَ الرُّكْنَ
u'عَادَ رُكوعٌ':Predicate, #2: 2	أَعَادَ الرُّكْنَ
u'عَادَ رَهْنٌ':Subject, #2: 2	أَعَادَ الرُّكُوعَ
u'عَادَ زَرْعٌ':Subject, #3: 3	عَادَ الرَّهْنُ
u'عَادَ زَمانٌ':Predicate, #1: 1	عَادَ الزَّرْعُ
u'عَادَ زَوْجٌ':Subject, #1: 1	أَعَادَ الزَّمَانَ
u'عَادَ زَيْدٌ':Predicate, #3: 3	عَادَ الزَّوْجُ
u'عَادَ سَارِقٌ':Subject, #1: 1	عَادَ زَيْدَ
u'عَادَ سَبَبٌ':Subject, #1: 1	عَادَ السَّارِقُ
u'عَادَ سجدة':Predicate, #1: 1	عَادَ سَبَبُ
u'عَادَ سَجْدَةٌ':Predicate, #2: 2	أَعَادَ السَّجْدَةَ
u'عَادَ سُجُودٌ':Predicate, #2: 2	أَعَادَ السَّجْدَةَ
u'عَادَ سَعْدٌ':Predicate, #3: 3	أَعَادَ السُّجُودَ
u'عَادَ سَعِيدٌ':Predicate, #2: 2	عَادَ سَعْدَ
u'عَادَ سَلَمٌ':Subject, #1: 1	عَادَ سَعِيدَ
u'عَادَ سِنٌّ':Predicate, #1: 1	عَادَ السَّلَمُ
u'عَادَ سَهْمٌ':Subject, #1: 1	أَعَادَ السِّنَّ
u'عَادَ سَوادٌ':Subject, #1: 1	عَادَ السَّهْمُ
u'عَادَ سُورَةٌ':Predicate, #3: 3	عَادَ السَّوَادُ
u'عَادَ سَيِّدٌ':Subject, #1: 1	أَعَادَ السُّورَةَ
u'عَادَ شَرْطٌ':Predicate, #1: 1	عَادَ السَّيِّدُ
u'عَادَ شَرِيكٌ':Subject, #1: 1	أَعَادَ الشَّرْطَ
u'عَادَ شَطْرٌ':Subject, #2: 2	عَادَ الشَّرِيكُ
u'عَادَ شَمٌّ':Subject, #1: 1	عَادَ الشَّطْرُ
u'عَادَ شَيْنٌ':Subject, #1: 1	عَادَ الشَّمُّ
u'عَادَ شَيْنٌ':Subject, #1: 1	عَادَ الشَّيْنُ
u'عَادَ صَاحِبٌ':Predicate, #1: 1	عَادَ شَيْنُهُ
u'عَادَ صُدَاعٌ':Subject, #1: 1	أَعَادَ صَاحِبَ
u'عَادَ صداق':Subject, #1: 1	عَادَ الصُّدَاعُ
u'عَادَ صَدَاقٌ':Subject, #1: 1	عَادَ الصَّدَاقُ
u'عَادَ صَفٌّ':Subject, #1: 1	عَادَ الصَّدَاقُ
u'عَادَ صَلاَةٌ':Predicate, #1: 1	عَادَ الصَّفُّ
u'عَادَ صَلاَةٌ':Predicate, #1: 1	أَعَادَ الصَّلاةَ
u'عَادَ صَلاَةٌ':Predicate, #1: 1	أَعَادَ صَلاَةَ
u'عَادَ صَلاَةٌ':Predicate, #26: 26	أَعَادَ الصَّلَاةَ
u'عَادَ صَلاَةٌ':Predicate, #3: 3	أَعَادَ صَلَاةَ
u'عَادَ صَلاَحٌ':Subject, #5: 5	أَعَادَ الصَّلاَةَ
u'عَادَ ضَرْبٌ':Predicate, #1: 1	عَادَ صَلَاحُ
u'عَادَ ضَرَرٌ':Subject, #3: 3	أَعَادَ الضَّرْبَ
u'عَادَ ضَمَانٌ':Subject, #1: 1	عَادَ الضَّرَرُ
u'عَادَ ضَمَانٌ':Subject, #1: 1	عَادَ ضَمَانُهُ
u'عَادَ ضَمِيرٌ':Predicate, #6: 6	عَادَ الضَّمَانُ
u'عَادَ ضَمِيرٌ':Subject, #3: 3	أَعَادَ الضَّمِيرَ
u'عَادَ ضَوْءٌ':Subject, #3: 3	عَادَ الضَّمِيرُ
u'عَادَ طَبْخٌ':Predicate, #1: 1	عَادَ الضَّوْءُ
u'عَادَ طرف':Subject, #5: 5	أَعَادَ الطَّبْخَ
u'عَادَ طَرَفٌ':Subject, #1: 1	عَادَ طَرَفُ
u'عَادَ طَلاَقٌ':Subject, #1: 1	عَادَ طَرَفُ
u'عَادَ طلب':Predicate, #1: 1	عَادَ الطَّلَاقُ
u'عَادَ طَلَبٌ':Predicate, #1: 1	أَعَادَ الطَّلَبَ
u'عَادَ طَلْحٌ':Subject, #1: 1	أَعَادَ الطَّلَبَ
u'عَادَ طلحة':Subject, #1: 1	عَادَ طَلْحَةُ
u'عَادَ طَهَارَةٌ':Predicate, #1: 1	عَادَ طَلْحَةُ
u'عَادَ طواف':Predicate, #1: 1	أَعَادَ الطَّهَارَةَ
u'عَادَ طَوَافٌ':Predicate, #12: 12	أَعَادَ الطَّوَافَ
u'عَادَ طواف':Predicate, #12: 12	أَعَادَ الطَّوَافَ
u'عَادَ طَوَافٌ':Predicate, #2: 2	أَعَادَ طَوَافَ
u'عَادَ ظُهْرٌ':Predicate, #2: 2	أَعَادَ طَوَافَ
u'عَادَ عَادٌ':Predicate, #5: 5	أَعَادَ الظُّهْرَ
u'عَادَ عَامِدٌ':Subject, #3: 3	عَادَ عَادَ
u'عَادَ عَامِلٌ':Predicate, #1: 1	عَادَ الْعَامِدُ
u'عَادَ عَامِلٌ':Subject, #1: 1	أَعَادَ الْعَامِلَ
u'عَادَ عَبْدٌ':Predicate, #1: 1	عَادَ الْعَامِلُ
u'عَادَ عَبْدٌ':Subject, #1: 1	عَادَ عَبْدَ
u'عَادَ عجز':Subject, #12: 12	عَادَ الْعَبْدُ
u'عَادَ عَجْزٌ':Subject, #1: 1	عَادَ الْعَجْزُ
u'عَادَ عِشَاءٌ':Predicate, #1: 1	عَادَ الْعَجْزُ
u'عَادَ عِشَاءٌ':Subject, #2: 2	أَعَادَ الْعِشَاءَ
u'عَادَ عَصْرٌ':Predicate, #2: 2	عَادَ الْعِشَاءُ
u'عَادَ عَصْرٌ':Predicate, #1: 1	عَادَ الْعَصْرَ
u'عَادَ عَقْدٌ':Subject, #2: 2	أَعَادَ الْعَصْرَ
u'عَادَ عَقْلٌ':Subject, #3: 3	عَادَ الْعَقْدُ
u'عَادَ عُمُومٌ':Predicate, #4: 4	عَادَ عَقْلُهُ
u'عَادَ عند':Predicate, #1: 1	أَعَادَ الْعُمُومَ
u'عَادَ عند':Predicate, #1: 1	أَعَادَ عِنْدَ
u'عَادَ غَاصِبٌ':Subject, #2: 2	عَادَ عِنْدَ
u'عَادَ غَائِبٌ':Subject, #1: 1	أَعَادَ الْغَاصِبُ
u'عَادَ غير':Predicate, #2: 2	عَادَ الْغَائِبُ
u'عَادَ غَيْرٌ':Predicate, #1: 1	عَادَ غَيْرَ
u'عَادَ غير':Subject, #1: 1	عَادَ غَيْرَ
u'عَادَ غَيْرٌ':Subject, #1: 1	أَعَادَ غَيْرُ
u'عَادَ فَاتِحٌ':Predicate, #1: 1	أَعَادَ غَيْرُ
u'عَادَ فَاتِحَةٌ':Predicate, #3: 3	أَعَادَ الْفَاتِحَةَ
u'عَادَ فَجْرٌ':Predicate, #3: 3	أَعَادَ الْفَاتِحَةَ
u'عَادَ فِرَاشٌ':Subject, #2: 2	أَعَادَ الْفَجْرَ
u'عَادَ فَضْلٌ':Subject, #1: 1	عَادَ فِرَاشُهُ
u'عَادَ فُلاَنٌ':Subject, #1: 1	عَادَ الْفَضْلُ
u'عَادَ فلان':Subject, #1: 1	عَادَ فُلَانٌ
u'عَادَ قَاطِعٌ':Subject, #3: 3	عَادَ حَامِدُهُ
u'عَادَ قَالٌ':Predicate, #1: 1	عَادَ الْقَاطِعُ
u'عَادَ قَالٌ':Predicate, #1: 1	أَعَادَ قَالَ
u'عَادَ قَبْضٌ':Subject, #2: 2	عَادَ قَالَ
u'عَادَ قتل':Predicate, #1: 1	عَادَ الْقَبْضُ
u'عَادَ قَدِيمٌ':Subject, #2: 2	عَادَ قُتِلَ
u'عَادَ قِرَاءةٌ':Predicate, #1: 1	عَادَ قَدِيمُ
u'عَادَ قِرَاءةٌ':Predicate, #2: 2	أَعَادَ قِرَاءَةَ
u'عَادَ قول':Subject, #5: 5	أَعَادَ الْقِرَاءَةَ
u'عَادَ قَوْلٌ':Subject, #1: 1	عَادَ الْقَوْلُ
u'عَادَ قَيْءٌ':Predicate, #1: 1	عَادَ الْقَوْلُ
u'عَادَ كَلِمَةٌ':Predicate, #1: 1	أَعَادَ الْقَيْءَ
u'عَادَ لاَمٌ':Predicate, #3: 3	أَعَادَ كَلِمَةَ
u'عَادَ لبن':Subject, #1: 1	أَعَادَ اللَّامَ
u'عَادَ لَبَنٌ':Subject, #2: 2	عَادَ اللَّبَنُ
u'عَادَلَ جَمِيع':Predicate, #2: 2	عَادَ اللَّبَنُ
u'عَادَ لُزُومٌ':Subject, #1: 1	عَادَلَ الْجَمِيعَ
u'عَادَلَ شَاةٌ':Predicate, #1: 1	عَادَ اللُّزُومُ
u'عَادَ لعان':Predicate, #1: 1	عَادَلَ الشَّاةَ
u'عَادَ لَفْظٌ':Predicate, #2: 2	أَعَادَ اللِّعَانَ
u'عَادَلَ وَصْفٌ':Predicate, #1: 1	أَعَادَ اللَّفْظَ
u'عَادَ مَاءٌ':Predicate, #1: 1	عَادَلَ الْوَصْفَ
u'عَادَ مَاءٌ':Subject, #1: 1	أَعَادَ الْمَاءَ
u'عَادَ مَالٌ':Subject, #1: 1	عَادَ الْمَاءُ
u'عَادَ مَبِيعٌ':Subject, #6: 6	عَادَ الْمَالُ
u'عَادَ مُتَمَتِّعٌ':Subject, #2: 2	عَادَ الْمَبِيعُ
u'عَادَ مثل':Predicate, #5: 5	عَادَ الْمُتَمَتِّعُ
u'عَادَ مِثْلٌ':Predicate, #2: 2	عَادَ مِثْلَ
u'عَادَ مثل':Subject, #2: 2	عَادَ مِثْلَ
u'عَادَ مِثْلٌ':Subject, #1: 1	عَادَ مِثْلُ
u'عَادَ مُحَمَّدٌ':Subject, #1: 1	عَادَ مِثْلُ
u'عَادَ مرٌّ':Predicate, #1: 1	عَادَ مُحَمَّدٌ
u'عَادَ مرٌّ':Predicate, #1: 1	عَادَ مَرَّةً
u'عَادَ مُرْتَدٌّ':Subject, #2: 2	أَعَادَ مَرَّةً
u'عَادَ مَرِيضٌ':Predicate, #8: 8	عَادَ الْمُرْتَدُّ
u'عَادَ مَسْأَلَةٌ':Predicate, #1: 1	عَادَ الْمَرِيضَ
u'عَادَ مُسْتَحِقٌّ':Subject, #3: 3	أَعَادَ الْمَسْأَلَةَ
u'عَادَ مَسْحٌ':Predicate, #2: 2	أَعَادَ الْمُسْتَحِقُّ
u'عَادَ مَسْكَنٌ':Subject, #3: 3	أَعَادَ الْمَسْحَ
u'عَادَ مُصَنِّفٌ':Subject, #1: 1	عَادَ الْمَسْكَنُ
u'عَادَ مُضَارِبٌ':Subject, #2: 2	أَعَادَ الْمُصَنِّفُ
u'عَادَ مُطَالَبٌ':Predicate, #1: 1	عَادَ الْمُضَارِبُ
u'عَادَ مُطَالَبَةٌ':Predicate, #1: 1	أَعَادَ الْمُطَالَبَةَ
u'عَادَ مَعْزُولٌ':Subject, #1: 1	أَعَادَ الْمُطَالَبَةَ
u'عَادَ مَعْقِلٌ':Predicate, #1: 1	عَادَ الْمَعْزُولُ
u'عَادَ مَغْرِبٌ':Predicate, #1: 1	عَادَ مَعْقِلَ
u'عَادَ مَفْقُودٌ':Subject, #3: 3	أَعَادَ الْمَغْرِبَ
u'عَادَ مُقَدَّمٌ':Predicate, #1: 1	عَادَ الْمَفْقُودُ
u'عَادَ مَقَرٌّ':Subject, #2: 2	أَعَادَ الْمُقَدَّمَ
u'عَادَ مُقَنَّعٌ':Predicate, #2: 2	عَادَ الْمَقَرُّ
u'عَادَ مِلْكٌ':Subject, #1: 1	عَادَ الْمُقَنَّعَ
u'عَادَ مِلْكٌ':Subject, #1: 1	عَادَ مِلْكُ
u'عَادَ مِلْكٌ':Subject, #6: 6	عَادَ مِلْكُهُ
u'عَادَ مُنَكَّسٌ':Subject, #9: 9	عَادَ الْمِلْكُ
u'عَادَ مَهْرٌ':Subject, #1: 1	أَعَادَ الْمُنَكَّسُ
u'عَادَ مُوَكِّلٌ':Subject, #2: 2	عَادَ الْمَهْرُ
u'عَادَ مَوْهُوبٌ':Subject, #4: 4	عَادَ الْمُوَكِّلُ
u'عَادَ نَبِيٌّ':Subject, #1: 1	عَادَ الْمَوْهُوبُ
u'عَادَ نَحْوٌ':Predicate, #2: 2	عَادَ النَّبِيُّ
u'عَادَ نزاع':Subject, #1: 1	عَادَ نَحْوَ
u'عَادَ نِزَاعٌ':Subject, #2: 2	عَادَ النِّزَاعُ
u'عَادَ نَسَبٌ':Subject, #2: 2	عَادَ النِّزَاعُ
u'عَادَ نَصٌّ':Predicate, #1: 1	عَادَ النَّسَبُ
u'عَادَ نِصْفٌ':Subject, #2: 2	أَعَادَ نَصَّ
u'عَادَ نَصِيبٌ':Subject, #3: 3	عَادَ النِّصْفُ
u'عَادَ نَصِيبٌ':Subject, #1: 1	عَادَ نَصِيبُ
u'عَادَ نَظَرٌ':Predicate, #4: 4	عَادَ نَصِيبُهُ
u'عَادَ نَظَرٌ':Subject, #1: 1	أَعَادَ النَّظَرَ
u'عَادَ نفاس':Subject, #1: 1	عَادَ نَظَرُهُ
u'عَادَ نِفَاسٌ':Subject, #1: 1	عَادَ النِّفَاسُ
u'عَادَ نَفْعٌ':Subject, #1: 1	عَادَ النِّفَاسُ
u'عَادَ نهار':Subject, #1: 1	عَادَ نَفْعُهُ
u'عَادَ نَهَارٌ':Subject, #1: 1	عَادَ النَّهَارُ
u'عَادَ وَاجِبٌ':Subject, #1: 1	عَادَ النَّهَارُ
u'عَادَ وَاقِفٌ':Subject, #1: 1	عَادَ الْوَاجِبُ
u'عَادَ وداع':Predicate, #1: 1	عَادَ الْوَاقِفُ
u'عَادَ وَدَاعٌ':Predicate, #3: 3	أَعَادَ الْوَدَاعَ
u'عَادَ وُضُوءٌ':Predicate, #3: 3	أَعَادَ الْوَدَاعَ
u'عَادَ وُضُوءٌ':Predicate, #10: 10	أَعَادَ الْوُضُوءَ
u'عَادَ وَقْفٌ':Predicate, #1: 1	أَعَادَ وُضُوءَ
u'عَادَ وَقْفٌ':Subject, #1: 1	أَعَادَ الْوَقْفَ
u'عَادَ وَكِيلٌ':Subject, #3: 3	عَادَ الْوَقْفُ
u'عَادَ وَلاَءٌ':Subject, #2: 2	عَادَ الْوَكِيلُ
u'عَادَ وَلِيٌّ':Subject, #4: 4	عَادَ الْوَلَاءُ
u'عَادَ وَلِيٌّ':Subject, #1: 1	عَادَ الْوَلِيُّ
u'عَادَى رِجَالٌ':Predicate, #6: 6	أَعَادَ الْوَلِيُّ
u'عَادَى كِنَانَةٌ':Predicate, #1: 1	عَادَى الرِّجَالَ
u'عَادَى وَصِيٌّ':Subject, #1: 1	عَادَى كِنَانَةَ
u'عَارَ أرْضٌ':Predicate, #1: 1	عَادَى الْوَصِيُّ
u'عَارَ بَائِعٌ':Subject, #3: 3	أَعَارَ الْأَرْضَ
u'عَارَ ثَوْبٌ':Predicate, #2: 2	أَعَارَ الْبَائِعُ
u'عَارَ جَازٌ':Predicate, #1: 1	أَعَارَ ثَوْبَ
u'عَارَ رَسُولٌ':Predicate, #1: 1	أَعَارَ جَازَ
u'عَارَ رَهْنٌ':Predicate, #2: 2	أَعَارَ رَسُولَ
u'عَارَ شَرِيكٌ':Subject, #1: 1	أَعَارَ الرَّهْنَ
u'عَارَضَ أَبٌ':Predicate, #1: 1	أَعَارَ الشَّرِيكُ
u'عَارَضَ أَبٌ':Subject, #1: 1	عَارَضَ الْأَبَ
u'عَارَضَ إِجْمَاعٌ':Predicate, #1: 1	عَارَضَ الْأَبُ
u'عَارَضَ إقْرَارٌ':Subject, #2: 2	عَارَضَ الْإِجْمَاعَ
u'عَارَضَ أَمْرٌ':Predicate, #1: 1	عَارَضَ إقْرَارُهُ
u'عَارَضَ باقِي':Predicate, #1: 1	عَارَضَ الْأَمْرَ
u'عَارَضَ تَعْلِيلٌ':Predicate, #1: 1	عَارَضَ الْبَاقِيَ
u'عَارَضَ جِهَةٌ':Subject, #1: 1	عَارَضَ تَعْلِيلَ
u'عَارَضَ حقائق':Predicate, #1: 1	عَارَضَ جِهَةُ
u'عَارَضَ حَقَائِقُ':Predicate, #1: 1	عَارَضَ حَقَائِقَ
u'عَارَضَ حَنَفِيَّةٌ':Subject, #1: 1	عَارَضَ حَقَائِقَ
u'عَارَضَ خَبَرٌ':Subject, #1: 1	عَارَضَ الْحَنَفِيَّةُ
u'عَارَضَ خَبَر':Subject, #1: 1	عَارَضَ خَبَرُ
u'عَارَضَ خَصْمٌ':Subject, #1: 1	عَارَضَ خَبَرُ
u'عَارَضَ خوارج':Predicate, #1: 1	عَارَضَ الْخَصْمُ
u'عَارَضَ خَوَارِجُ':Predicate, #1: 1	عَارَضَ الْخَوَارِجَ
u'عَارَضَ دَمٌ':Predicate, #1: 1	عَارَضَ الْخَوَارِجَ
u'عَارَضَ رِوايَةٌ':Predicate, #1: 1	عَارَضَ الدَّمَ
u'عَارَضَ سُنَّةٌ':Predicate, #1: 1	عَارَضَ رِوَايَةَ
u'عَارَضَ طَرِيقٌ':Predicate, #1: 1	عَارَضَ السُّنَّةَ
u'عَارَضَ طَرِيقٌ':Predicate, #1: 1	عَارَضَ الطّرِيقَ
u'عَارَضَ ظالِمٌ':Predicate, #1: 1	عَارَضَ الطَّرِيقَ
u'عَارَضَ ظُهورٌ':Predicate, #1: 1	عَارَضَ الظَّالِمَ
u'عَارَضَ عَادَةٌ':Predicate, #1: 1	عَارَضَ ظُهُورَ
u'عَارَضَ عَامٌّ':Predicate, #1: 1	عَارَضَ الْعَادَةَ
u'عَارَضَ عُمُومٌ':Predicate, #1: 1	عَارَضَ الْعَامَّ
u'عَارَضَ قول':Predicate, #2: 2	عَارَضَ عُمُومَ
u'عَارَضَ قَوْلٌ':Predicate, #1: 1	عَارَضَ قَوْلَ
u'عَارَضَ قول':Subject, #1: 1	عَارَضَ قَوْلَ
u'عَارَضَ قَوْلٌ':Subject, #1: 1	عَارَضَ قَوْلُ
u'عَارَضَ قِيَاسٌ':Subject, #1: 1	عَارَضَ قَوْلُ
u'عَارَضَ كِتَابٌ':Predicate, #2: 2	عَارَضَ قِيَاسٌ
u'عَارَضَ مُجْتَهِد':Subject, #1: 1	عَارَضَ الْكِتَابَ
u'عَارَضَ مُسْنَدٌ':Predicate, #3: 3	عَارَضَ مُجْتَهِدُهُ
u'عَارَضَ مُطْلَقٌ':Predicate, #1: 1	عَارَضَ الْمُسْنَدَ
u'عَارَضَ مُعْتَرِضٌ':Predicate, #1: 1	عَارَضَ مُطْلَقَ
u'عَارَضَ مَفْهُومٌ':Predicate, #1: 1	عَارَضَ الْمُعْتَرِضَ
u'عَارَضَ نِيَّةٌ':Predicate, #1: 1	عَارَضَ مَفْهُومَ
u'عَارَضَ وَطْءٌ':Predicate, #1: 1	عَارَضَ نِيَّةَ
u'عَارَضَ يَدٌ':Predicate, #1: 1	عَارَضَ الْوَطْءَ
u'عَارَ طِينٌ':Predicate, #1: 1	عَارَضَ يَدَ
u'عَارَ عَبْدٌ':Predicate, #1: 1	أَعَارَ الطِّينَ
u'عَارَ عَبْدٌ':Subject, #1: 1	أَعَارَ الْعَبْدَ
u'عَارَ عَشْرٌ':Predicate, #1: 1	أَعَارَ عَبْدٌ
u'عَارَ كَلْبٌ':Predicate, #1: 1	أَعَارَ عَشْرَةَ
u'عَارَ مَالِكٌ':Subject, #1: 1	أَعَارَ الْكَلْبَ
u'عَارَ مُحْرِمٌ':Subject, #1: 1	أَعَارَ الْمَالِكُ
u'عَارَ مُرْتَهِنٌ':Subject, #1: 1	أَعَارَ الْمُحْرِمُ
u'عَارَ مساكين':Predicate, #5: 5	أَعَارَ الْمُرْتَهِنُ
u'عَارَ مُسْتَأْجِرٌ':Predicate, #1: 1	أَعَارَ الْمَسَاكِينَ
u'عَارَ مُسْتَأْجِرٌ':Subject, #1: 1	أَعَارَ الْمُسْتَأْجِرَ
u'عَارَ مُسْتَحِقٌّ':Subject, #1: 1	أَعَارَ الْمُسْتَأْجِرُ
u'عَارَ مُسْلِمٌ':Subject, #1: 1	أَعَارَ مُسْتَحِقُّ
u'عَاشَ اِبْنٌ':Subject, #2: 2	أَعَارَ الْمُسْلِمُ
u'عَاشَ أَزْوادٌ':Subject, #1: 1	عَاشَ ابْنُ
u'عَاشَ ألف':Predicate, #1: 1	عَاشَ أَزْوَادُ
u'عَاشَ ألْفٌ':Predicate, #1: 1	عَاشَ أَلْفَ
u'عَاشَ أَلْفٌ':Predicate, #1: 1	عَاشَ أَلْفَ
u'عَاشَ بَطَلٌ':Predicate, #1: 1	عَاشَ أَلْفَ
u'عَاشَ ثَمانِين':Predicate, #1: 1	عَاشَ بَطَلَ
u'عَاشَ حاجَةٌ':Subject, #1: 1	عَاشَ ثَمَانِينَ
u'عَاشَرَ رَجْعِيٌّ':Predicate, #1: 1	عَاشَ حَاجَةٌ
u'عَاشَرَ رَجْعِيَّةٌ':Predicate, #2: 2	عَاشَرَ الرَّجْعِيَّةَ
u'عَاشَرَ نَاسٌ':Predicate, #2: 2	عَاشَرَ الرَّجْعِيَّةَ
u'عَاشَ شَرَطٌ':Predicate, #1: 1	عَاشَرَ النَّاسَ
u'عَاشَ صَبِيٌّ':Subject, #1: 1	عَاشَ شَرَطَ
u'عَاشَ طِفْلٌ':Subject, #1: 1	عَاشَ الصَّبِيُّ
u'عَاشَ عُمُرٌ':Predicate, #1: 1	عَاشَ الطِّفْلُ
u'عَاشَ عُمَرٌ':Subject, #1: 1	عَاشَ الْعُمُرَ
u'عَاشَ قَالٌ':Predicate, #2: 2	عَاشَ عُمَرُ
u'عَاشَ كَاتِبٌ':Subject, #2: 2	عَاشَ قَالَ
u'عَاشَ مَالٌ':Subject, #1: 1	عَاشَ الْكَاتِبُ
u'عَاشَ مثل':Predicate, #1: 1	عَاشَ مَالُهُ
u'عَاشَ مِثْلٌ':Predicate, #1: 1	عَاشَ مِثْلَ
u'عَاشَ مَمْدُودٌ':Subject, #1: 1	عَاشَ مِثْلَ
u'عَاشَ مَيْمُونٌ':Predicate, #2: 2	عَاشَ مَمْدُودٌ
u'عَاشَ نِصْفٌ':Predicate, #1: 1	عَاشَ مَيْمُونَ
u'عَاشَ وَاقِفٌ':Subject, #2: 2	عَاشَ نِصْفَ
u'عَاشَ ولد':Subject, #1: 1	عَاشَ الْوَاقِفُ
u'عَاشَ وَلَدٌ':Subject, #1: 1	عَاشَ الْوَلَدُ
u'عَاصَرَ رَسُولٌ':Predicate, #1: 1	عَاشَ الْوَلَدُ
u'عَاصَرَ شافِعِيّ':Predicate, #1: 1	عَاصَرَ الرَّسُولَ
u'عَاصَرَ صغار':Predicate, #1: 1	عَاصَرَ الشَّافِعِيَّ
u'عَاصَرَ فلان':Predicate, #1: 1	عَاصَرَ صِغَارَ
u'عَاصَرَ نَبِيٌّ':Predicate, #1: 1	عَاصَرَ الشَّافِعِيَّ
u'عَاصَرَ نَوَوِيٌّ':Predicate, #1: 1	عَاصَرَ النَّبِيَّ
u'عَافَ ضَبٌّ':Predicate, #2: 2	عَاصَرَ النَّوَوِيَّ
u'عَاقَبَ بَيْنٌ':Predicate, #1: 1	عَافَ الضَّبَّ
u'عَاقَبَ كَاسِرٌ':Predicate, #1: 1	عَاقَبَ بَيْنَ
u'عَاقَدَ إمَامٌ':Subject, #1: 1	عَاقَبَ الْكَاسِرَةَ
u'عَاقَدَ أمَانٌ':Predicate, #1: 1	عَاقَدَ الْإِمَامُ
u'عَاقَدَ مُسْلِمٌ':Subject, #1: 1	عَاقَدَ الْأَمَانَ
u'عَاقَلَ بَيْنٌ':Predicate, #1: 1	عَاقَدَ الْمُسْلِمُ
u'عَالَجَ رَجُلٌ':Subject, #1: 1	عَاقَلَ بَيْنَ
u'عَالَجَ شَوْقٌ':Predicate, #1: 1	عَالَجَ الرَّجُلُ
u'عَالَجَ طعام':Predicate, #1: 1	عَالَجَ الشَّوْقَ
u'عَالَجَ طَعَامٌ':Predicate, #1: 1	عَالَجَ الطَّعَامَ
u'عَالَجَ عَالِمٌ':Subject, #1: 1	عَالَجَ الطَّعَامَ
u'عَالَ حاكِمٌ':Subject, #1: 1	عَالَجَ الْعَالِمُ
u'عَالَ رَجُلٌ':Subject, #1: 1	عَالَ الْحَاكِمُ
u'عَالَ رَجُلٌ':Subject, #1: 1	أَعَالَ الرَّجُلُ
u'عَالَ فَرَائِضُ':Predicate, #2: 2	عَالَ الرَّجُلُ
u'عَالَ مِيزَانٌ':Subject, #3: 3	أَعَالَ الْفَرَائِضَ
u'عَامَ أَوَّلُ':Predicate, #1: 1	عَالَ الْمِيزَانُ
u'عَامَ أَوَّلُ':Predicate, #14: 14	عَامَ أَوَّلَ
u'عَامَ حَجٌّ':Predicate, #1: 1	عَامَ الأَوَّلَ
u'عَامَ صفر':Predicate, #3: 3	عَامَ حَجَّ
u'عَامَ صَفَرٌ':Predicate, #1: 1	عَامَ صَفَرَ
u'عَامَ فَتْحٌ':Predicate, #1: 1	عَامَ صَفَرَ
u'عَامَ فلان':Predicate, #1: 1	عَامَ فَتْحَ
u'عَامَلَ أهْلٌ':Predicate, #11: 11	عَامَ خَيْبَرَ
u'عَامَلَ عَامِلٌ':Subject, #10: 10	عَامَلَ أَهْلَ
u'عَامَلَ فلان':Predicate, #1: 1	عَامَلَ عَامِلُ
u'عَامَلَ مُسْلِمٌ':Subject, #1: 1	عَامَلَ خَيْبَرَ
u'عَامَلَ نَاسٌ':Predicate, #1: 1	عَامَلَ مُسْلِمٌ
u'عَامَلَ نَبِيٌّ':Subject, #1: 1	عَامَلَ النَّاسَ
u'عَانَ أَجْرٌ':Subject, #1: 1	عَامَلَ النَّبِيُّ
u'عَانَ إِنْسانٌ':Subject, #1: 1	أَعَانَ أَجْرُ
u'عَانَ جَمِيع':Predicate, #1: 1	أَعَانَ إنْسَانٌ
u'عَانَدَ إِسْلامٌ':Predicate, #1: 1	أَعَانَ الْجَمِيعَ
u'عَانَدَ شَرْعٌ':Predicate, #1: 1	عَانَدَ الْإِسْلَامَ
u'عَانَ ظالِمٌ':Predicate, #1: 1	عَانَدَ الشَّرْعَ
u'عَانَقَ رَجُلٌ':Predicate, #1: 1	أَعَانَ الظَّالِمَ
u'عَانَقَ رَجُلٌ':Subject, #1: 1	عَانَقَ رَجُلاً
u'عَانَ مُحَارِبٌ':Predicate, #1: 1	عَانَقَ رَجُلٌ
u'عَانَ مُحْرِمٌ':Subject, #1: 1	أَعَانَ الْمُحَارِبِينَ
u'عَانَ مُسْلِمٌ':Subject, #1: 1	أَعَانَ مُحْرِمٌ
u'عَانَى تَهْذِيبٌ':Predicate, #1: 1	أَعَانَ مُسْلِمٌ
u'عَاهَدَ دمع':Subject, #1: 1	عَانَى تَهْذِيبَ
u'عَاهَدَ دَمْعٌ':Subject, #1: 1	عَاهَدَ الدَّمْعُ
u'عَاهَدَ غَدَرٌ':Predicate, #1: 1	عَاهَدَ الدَّمْعُ
u'عَاوَدَ ثَانِي':Predicate, #12: 12	عَاهَدَ غَدَرَ
u'عَاوَدَ ذَنْبٌ':Predicate, #1: 1	عَاوَدَ ثَانِيَةً
u'عَاوَدَ مَدْبُوغٌ':Predicate, #1: 1	عَاوَدَ الذَّنْبَ
u'عَاوَضَ مَرِيضٌ':Subject, #1: 1	عَاوَدَ الْمَدْبُوغَ
u'عَايَرَ صَاعٌ':Predicate, #1: 1	عَاوَضَ الْمَرِيضُ
u'عُبَابٌ مَاءٌ':Added, #1: 1	عَايَرَ الصَّاعَ
u'عُبَابٌ مَسَالِكُ':Added, #1: 1	عُبَابِ الْمَاءِ
u'عِبَارَةٌ إبَاحَةٌ':Added, #1: 1	عُبَابِ الْمَسَالِكِ
u'عِبَارَةٌ اِبْنٌ':Added, #1: 1	عِبَارَةِ الْإِبَاحَةِ
u'عِبَارَةٌ اِبْنٌ':Added, #10: 10	عِبَارَةِ ابْنِ
u'عِبَارَةٌ اِبْنٌ':Added, #62: 62	عِبَارَةُ ابْنِ
u'عِبَارَةٌ إِرْشَادٌ':Added, #6: 6	عِبَارَةَ ابْنِ
u'عِبَارَةٌ إِرْشَادٌ':Added, #1: 1	عِبَارَةَ إرْشَادِهِ
u'عِبَارَةٌ إِرْشَادٌ':Added, #2: 2	عِبَارَةُ إرْشَادِهِ
u'عِبَارَةٌ إِرْشَادٌ':Added, #2: 2	عِبَارَةُ الْإِرْشَادِ
u'عِبَارَةٌ إِسْعافٌ':Added, #3: 3	عِبَارَةِ الْإِرْشَادِ
u'عِبَارَةٌ أَشْيَاخٌ':Added, #1: 1	عِبَارَةَ الْإِسْعَافِ
u'عِبَارَةٌ أَصْحَابٌ':Added, #1: 1	عِبَارَةُ الْأَشْيَاخِ
u'عِبَارَةٌ أَصْحَابٌ':Added, #2: 2	عِبَارَةِ الْأَصْحَابِ
u'عِبَارَةٌ أصل':Added, #5: 5	عِبَارَةُ الْأَصْحَابِ
u'عِبَارَةٌ أًصْلٌ':Added, #10: 10	عِبَارَةِ أَصْلِهِ
u'عِبَارَةٌ أصل':Added, #10: 10	عِبَارَةِ أَصْلِهِ
u'عِبَارَةٌ أًصْلٌ':Added, #11: 11	عِبَارَةُ أَصْلِهِ
u'عِبَارَةٌ أصل':Added, #11: 11	عِبَارَةُ أَصْلِهِ
u'عِبَارَةٌ أًصْلٌ':Added, #143: 143	عِبَارَةُ الْأَصْلِ
u'عِبَارَةٌ أصل':Added, #143: 143	عِبَارَةُ الْأَصْلِ
u'عِبَارَةٌ أًصْلٌ':Added, #17: 17	عِبَارَةِ الْأَصْلِ
u'عِبَارَةٌ أصل':Added, #17: 17	عِبَارَةِ الْأَصْلِ
u'عِبَارَةٌ أًصْلٌ':Added, #1: 1	عِبَارَةَ أَصْلِهِ
u'عِبَارَةٌ أصل':Added, #1: 1	عِبَارَةَ أَصْلِهِ
u'عِبَارَةٌ أًصْلٌ':Added, #2: 2	عِبَارَةِ أَصْلِ
u'عِبَارَةٌ أصل':Added, #2: 2	عِبَارَةِ أَصْلِ
u'عِبَارَةٌ أًصْلٌ':Added, #8: 8	عِبَارَةَ الْأَصْلِ
u'عِبَارَةٌ إِطْلاقٌ':Added, #8: 8	عِبَارَةَ الْأَصْلِ
u'عِبَارَةٌ أغْلَبُ':Added, #1: 1	عِبَارَةِ إطْلَاقِ
u'عِبَارَةٌ أَكْثَرُ':Added, #1: 1	عِبَارَةُ أَغْلَبِ
u'عِبَارَةٌ أَكْثَرُ':Added, #1: 1	عِبَارَةِ أَكْثَرِ
u'عِبَارَةٌ أُمٌّ':Added, #6: 6	عِبَارَةُ أَكْثَرِ
u'عِبَارَةٌ إمَامٌ':Added, #1: 1	عِبَارَةُ الْأُمِّ
u'عِبَارَةٌ إمَامٌ':Added, #2: 2	عِبَارَةِ الْإِمَامِ
u'عِبَارَةٌ آمِرٌ':Added, #3: 3	عِبَارَةُ الْإِمَامِ
u'عِبَارَةٌ أَنْوَارٌ':Added, #1: 1	عِبَارَةِ الْآمِرِ
u'عِبَارَةٌ أَنْوَارٌ':Added, #3: 3	عِبَارَةَ الْأَنْوَارِ
u'عِبَارَةٌ أَنْوَارٌ':Added, #3: 3	عِبَارَةِ الْأَنْوَارِ
u'عِبَارَةٌ بَحْرٌ':Added, #6: 6	عِبَارَةُ الْأَنْوَارِ
u'عِبَارَةٌ بَحْرٌ':Added, #1: 1	عِبَارَةُ الْبَحْرِ
u'عِبَارَةٌ بدائع':Added, #2: 2	عِبَارَةَ الْبَحْرِ
u'عِبَارَةٌ بدائع':Added, #5: 5	عِبَارَةَ الْبَدَائِعِ
u'عِبَارَةٌ بدائع':Added, #5: 5	عِبَارَةُ الْبَدَائِعِ
u'عِبَارَةٌ بَدِيعٌ':Added, #7: 7	عِبَارَةِ الْبَدَائِعِ
u'عِبَارَةٌ بَزّاز':Added, #1: 1	عِبَارَةَ الْبَدِيعِ
u'عِبَارَةٌ بَزّاز':Added, #2: 2	عِبَارَةَ الْبَزَّازِيَّةِ
u'عِبَارَةٌ بَزّاز':Added, #6: 6	عِبَارَةُ الْبَزَّازِيَّةِ
u'عِبَارَةٌ بَزّازَة':Added, #8: 8	عِبَارَةِ الْبَزَّازِيَّةِ
u'عِبَارَةٌ بَزّازَة':Added, #2: 2	عِبَارَةَ الْبَزَّازِيَّةِ
u'عِبَارَةٌ بَزّازَة':Added, #6: 6	عِبَارَةُ الْبَزَّازِيَّةِ
u'عِبَارَةٌ بَسيطٌ':Added, #8: 8	عِبَارَةِ الْبَزَّازِيَّةِ
u'عِبَارَةٌ بَعْضٌ':Added, #1: 1	عِبَارَةَ الْبَسِيطِ
u'عِبَارَةٌ بَعْضٌ':Added, #1: 1	عِبَارَةُ بَعْضِ
u'عِبَارَةٌ بَيَانٌ':Added, #4: 4	عِبَارَةِ بَعْضِ
u'عِبَارَةٌ بَيْضاوِيّ':Added, #1: 1	عِبَارَةُ الْبَيَانِ
u'عِبَارَةٌ تَبْيِين':Added, #1: 1	عِبَارَةُ الْبَيْضَاوِيِّ
u'عِبَارَةٌ تَبْيِين':Added, #1: 1	عِبَارَةُ التَّبْيِينِ
u'عِبَارَةٌ تَجْنِيس':Added, #2: 2	عِبَارَةَ التَّبْيِينِ
u'عِبَارَةٌ تَجْنِيس':Added, #1: 1	عِبَارَةُ التَّجْنِيسِ
u'عِبَارَةٌ تَحْرِيمٌ':Added, #2: 2	عِبَارَةِ التَّجْنِيسِ
u'عِبَارَةٌ تَحْصِيلٌ':Added, #1: 1	عِبَارَةِ التَّحْرِيمِ
u'عِبَارَةٌ تَحْقِيقٌ':Added, #1: 1	عِبَارَةُ التَّحْصِيلِ
u'عِبَارَةٌ تَحْقِيقٌ':Added, #1: 1	عِبَارَةَ التَّحْقِيقِ
u'عِبَارَةٌ تَحْقِيقٌ':Added, #1: 1	عِبَارَةُ التَّحْقِيقِ
u'عِبَارَةٌ تَدْرِيبٌ':Added, #2: 2	عِبَارَةِ التَّحْقِيقِ
u'عِبَارَةٌ تَسْهِيلٌ':Added, #1: 1	عِبَارَةُ التَّدْرِيبِ
u'عِبَارَةٌ تَفاوُت':Added, #1: 1	عِبَارَةِ التَّسْهِيلِ
u'عِبَارَةٌ تَفْسِيرٌ':Added, #1: 1	عِبَارَةُ التَّفَاوُتِ
u'عِبَارَةٌ تَلْخيصٌ':Added, #1: 1	عِبَارَةَ التَّفْسِيرِ
u'عِبَارَةٌ تَلْخيصٌ':Added, #1: 1	عِبَارَةُ التَّلْخِيصِ
u'عِبَارَةٌ تَلْخيصٌ':Added, #1: 1	عِبَارَةِ التَّلْخِيصِ
u'عِبَارَةٌ تَلْخيصٌ':Added, #1: 1	عِبَارَةُ تَلْخِيصِ
u'عِبَارَةٌ تَلْقِين':Added, #1: 1	عِبَارَةِ تَلْخِيصِ
u'عِبَارَةٌ تَنْبِيه':Added, #3: 3	عِبَارَةُ التَّلْقِينِ
u'عِبَارَةٌ تَنْبِيه':Added, #1: 1	عِبَارَةُ التَّنْبِيهِ
u'عِبَارَةٌ تَنْوِيرٌ':Added, #2: 2	عِبَارَةِ التَّنْبِيهِ
u'عِبَارَةٌ تَهْذِيبٌ':Added, #1: 1	عِبَارَةُ التَّنْوِيرِ
u'عِبَارَةٌ تَهْذِيبٌ':Added, #1: 1	عِبَارَةُ التَّهْذِيبِ
u'عِبَارَةٌ تَوَسُّط':Added, #1: 1	عِبَارَةِ التَّهْذِيبِ
u'عِبَارَةٌ تَوْضِيحٌ':Added, #1: 1	عِبَارَةُ التَّوَسُّطِ
u'عِبَارَةٌ تونِسِيّ':Added, #1: 1	عِبَارَةِ التَّوْضِيحِ
u'عِبَارَةٌ ثَالِثٌ':Added, #1: 1	عِبَارَةُ التُّونِسِيِّ
u'عِبَارَةٌ جَامِعٌ':Added, #1: 1	عِبَارَةٍ ثَالِثَةٍ
u'عِبَارَةٌ جَامِعٌ':Added, #1: 1	عِبَارَةَ جَامِعِ
u'عِبَارَةٌ جَامِعٌ':Added, #1: 1	عِبَارَةِ جَامِعِ
u'عِبَارَةٌ جَامِعٌ':Added, #4: 4	عِبَارَةُ جَامِعِ
u'عِبَارَةٌ جَامِعٌ':Added, #5: 5	عِبَارَةِ الْجَامِعِ
u'عِبَارَةٌ جَامِعٌ':Added, #6: 6	عِبَارَةَ الْجَامِعِ
u'عِبَارَةٌ جَلّاب':Added, #8: 8	عِبَارَةُ الْجَامِعِ
u'عِبَارَةٌ جَمَاعَةٌ':Added, #3: 3	عِبَارَةُ الْجَلَّابِ
u'عِبَارَةٌ جَمَاعَةٌ':Added, #1: 1	عِبَارَةُ جَمَاعَةٍ
u'عِبَارَةٌ جُمْهُورٌ':Added, #3: 3	عِبَارَةِ جَمَاعَةٍ
u'عِبَارَةٌ جُمْهُورٌ':Added, #1: 1	عِبَارَةُ الْجُمْهُورِ
u'عِبَارَةٌ جَوَامِعُ':Added, #2: 2	عِبَارَةِ الْجُمْهُورِ
u'عِبَارَةٌ جَوَاهِرُ':Added, #1: 1	عِبَارَةِ جَوَامِعِ
u'عِبَارَةٌ جَوَاهِرُ':Added, #2: 2	عِبَارَةُ الْجَوَاهِرِ
u'عِبَارَةٌ جَوْهَرٌ':Added, #2: 2	عِبَارَةِ الْجَوَاهِرِ
u'عِبَارَةٌ جَوْهَرٌ':Added, #1: 1	عِبَارَةُ الْجَوْهَرَةِ
u'عِبَارَةٌ حاشِيَةٌ':Added, #1: 1	عِبَارَةِ الْجَوْهَرَةِ
u'عِبَارَةٌ حاكِمٌ':Added, #1: 1	عِبَارَةُ الْحَاشِيَةِ
u'عِبَارَةٌ حاكِمٌ':Added, #1: 1	عِبَارَةُ الْحَاكِمِ
u'عِبَارَةٌ حاكِمٌ':Added, #2: 2	عِبَارَةَ الْحَاكِمِ
u'عِبَارَةٌ حائِزٌ':Added, #4: 4	عِبَارَةِ الْحَاكِمِ
u'عِبَارَةٌ خان':Added, #1: 1	عِبَارَةِ الْحَائِزِ
u'عِبَارَةٌ خان':Added, #3: 3	عِبَارَةَ الْخَانِيَّةِ
u'عِبَارَةٌ خان':Added, #8: 8	عِبَارَةُ الْخَانِيَّةِ
u'عِبَارَةٌ خانَة':Added, #9: 9	عِبَارَةِ الْخَانِيَّةِ
u'عِبَارَةٌ خانَة':Added, #3: 3	عِبَارَةَ الْخَانِيَّةِ
u'عِبَارَةٌ خانَة':Added, #8: 8	عِبَارَةُ الْخَانِيَّةِ
u'عِبَارَةٌ خَبّاز':Added, #9: 9	عِبَارَةِ الْخَانِيَّةِ
u'عِبَارَةٌ خِزَانَةٌ':Added, #1: 1	عِبَارَةَ الْخَبَّازِيَّةِ
u'عِبَارَةٌ خُلاصَة':Added, #2: 2	عِبَارَةِ الْخِزَانَةِ
u'عِبَارَةٌ خُلاصَة':Added, #11: 11	عِبَارَةِ الْخُلَاصَةِ
u'عِبَارَةٌ خُلاصَة':Added, #2: 2	عِبَارَةَ الْخُلَاصَةِ
u'عِبَارَةٌ دَرَاهِمُ':Added, #9: 9	عِبَارَةُ الْخُلَاصَةِ
u'عِبَارَةٌ دِرَايَةٌ':Added, #1: 1	عِبَارَةَ الدَّرَاهِمِ
u'عِبَارَةٌ دُرَرٌ':Added, #2: 2	عِبَارَةَ الدِّرَايَةِ
u'عِبَارَةٌ دُرَرٌ':Added, #1: 1	عِبَارَةَ الدُّرَرِ
u'عِبَارَةٌ دُرَرٌ':Added, #1: 1	عِبَارَةِ الدُّرَرِ
u'عِبَارَةٌ دُرَرٌ':Added, #1: 1	عِبَارَةُ دُرَرِ
u'عِبَارَةٌ ذَخيرَةٌ':Added, #2: 2	عِبَارَةُ الدُّرَرِ
u'عِبَارَةٌ ذَخيرَةٌ':Added, #2: 2	عِبَارَةَ الذَّخِيرَةِ
u'عِبَارَةٌ ذَخيرَةٌ':Added, #6: 6	عِبَارَةُ الذَّخِيرَةِ
u'عِبَارَةٌ رِسَالَةٌ':Added, #8: 8	عِبَارَةِ الذَّخِيرَةِ
u'عِبَارَةٌ رَسُولٌ':Added, #2: 2	عِبَارَةُ الرِّسَالَةِ
u'عِبَارَةٌ رَوْضٌ':Added, #1: 1	عِبَارَةَ الرَّسُولِ
u'عِبَارَةٌ رَوْضٌ':Added, #1: 1	عِبَارَةِ الرَّوْضِ
u'عِبَارَةٌ رَوْضَةٌ':Added, #2: 2	عِبَارَةُ الرَّوْضِ
u'عِبَارَةٌ رَوْضَةٌ':Added, #15: 15	عِبَارَةِ الرَّوْضَةِ
u'عِبَارَةٌ رَوْضَةٌ':Added, #1: 1	عِبَارَة الرَّوْضَةِ
u'عِبَارَةٌ رَوْضَةٌ':Added, #45: 45	عِبَارَةُ الرَّوْضَةِ
u'عِبَارَةٌ زواجر':Added, #8: 8	عِبَارَةَ الرَّوْضَةِ
u'عِبَارَةٌ زِيادَةٌ':Added, #1: 1	عِبَارَةُ الزَّوَاجِرِ
u'عِبَارَةٌ سائِل':Added, #1: 1	عِبَارَةِ الزِّيَادَاتِ
u'عِبَارَةٌ سَائِلٌ':Added, #1: 1	عِبَارَةِ السَّائِلِ
u'عِبَارَةٌ سِرَاجٌ':Added, #1: 1	عِبَارَةِ السَّائِلِ
u'عِبَارَةٌ سِرَاجٌ':Added, #2: 2	عِبَارَةَ السِّرَاجِ
u'عِبَارَةٌ سِرَاجٌ':Added, #2: 2	عِبَارَةُ السِّرَاجِ
u'عِبَارَةٌ سَعْد':Added, #2: 2	عِبَارَةِ السِّرَاجِ
u'عِبَارَةٌ سَعْدِيّ':Added, #1: 1	عِبَارَةُ السَّعْدِيَّةِ
u'عِبَارَةٌ شَارِحٌ':Added, #1: 1	عِبَارَةُ السَّعْدِيَّةِ
u'عِبَارَةٌ شَارِحٌ':Added, #10: 10	عِبَارَةِ الشَّارِحِ
u'عِبَارَةٌ شَارِحٌ':Added, #1: 1	عِبَارَةَ الشَّارِحِ
u'عِبَارَةٌ شافِعِيّ':Added, #3: 3	عِبَارَةُ الشَّارِحِ
u'عِبَارَةٌ شافِعِيّ':Added, #2: 2	عِبَارَةَ الشَّافِعِيِّ
u'عِبَارَةٌ شافِعِيّ':Added, #3: 3	عِبَارَةُ الشَّافِعِيِّ
u'عِبَارَةٌ شَامِلٌ':Added, #3: 3	عِبَارَةِ الشَّافِعِيِّ
u'عِبَارَةٌ شَامِلٌ':Added, #1: 1	عِبَارَةَ الشَّامِلِ
u'عِبَارَةٌ شَرْحٌ':Added, #2: 2	عِبَارَةُ الشَّامِلِ
u'عِبَارَةٌ شَرْحٌ':Added, #1: 1	عِبَارَة شَرْحِ
u'عِبَارَةٌ شَرْحٌ':Added, #1: 1	عِبَارَةَ شَرْحِ
u'عِبَارَةٌ شَرْحٌ':Added, #1: 1	عِبَارَةِ شَرْحِهِ
u'عِبَارَةٌ شَرْحٌ':Added, #2: 2	عِبَارَةِ الشَّرْحِ
u'عِبَارَةٌ شَرْحٌ':Added, #30: 30	عِبَارَةُ شَرْحِ
u'عِبَارَةٌ شَرْحٌ':Added, #42: 42	عِبَارَةُ الشَّرْحِ
u'عِبَارَةٌ شمس':Added, #8: 8	عِبَارَةِ شَرْحِ
u'عِبَارَةٌ شمس':Added, #1: 1	عِبَارَةُ شَمْسِ
u'عِبَارَةٌ شَمْسٌ':Added, #1: 1	عِبَارَةِ شَمْسِ
u'عِبَارَةٌ شَمْسٌ':Added, #1: 1	عِبَارَةُ شَمْسِ
u'عِبَارَةٌ شَيْخٌ':Added, #1: 1	عِبَارَةِ شَمْسِ
u'عِبَارَةٌ شَيْخٌ':Added, #1: 1	عِبَارَةَ الشَّيْخَيْنِ
u'عِبَارَةٌ شَيْخٌ':Added, #1: 1	عِبَارَةُ الشَّيْخَيْنِ
u'عِبَارَةٌ شَيْخٌ':Added, #1: 1	عِبَارَةُ شَيْخِ
u'عِبَارَةٌ شَيْخٌ':Added, #1: 1	عِبَارَةَ شَيْخِهِ
u'عِبَارَةٌ شَيْخٌ':Added, #4: 4	عِبَارَةُ الشَّيْخِ
u'عِبَارَةٌ شَيْخٌ':Added, #4: 4	عِبَارَةِ الشَّيْخِ
u'عِبَارَةٌ شُيُوخٌ':Added, #5: 5	عِبَارَةِ الشَّيْخَيْنِ
u'عِبَارَةٌ صَاحِبٌ':Added, #1: 1	عِبَارَةُ الشُّيُوخِ
u'عِبَارَةٌ صَاحِبٌ':Added, #3: 3	عِبَارَةُ صَاحِبِ
u'عِبَارَةٌ صَبِيٌّ':Added, #4: 4	عِبَارَةِ صَاحِبِ
u'عِبَارَةٌ صَبِيٌّ':Added, #1: 1	عِبَارَةُ الصَّبِيِّ
u'عِبَارَةٌ صَيْرَفِيٌّ':Added, #2: 2	عِبَارَةَ الصَّبِيِّ
u'عِبَارَةٌ طَائِفٌ':Added, #1: 1	عِبَارَةِ الصَّيْرَفِيَّةِ
u'عِبَارَةٌ طِرَازٌ':Added, #1: 1	عِبَارَةُ طَائِفَةٍ
u'عِبَارَةٌ ظَهِير':Added, #1: 1	عِبَارَةُ الطِّرَازِ
u'عِبَارَةٌ ظَهِير':Added, #4: 4	عِبَارَةُ الظَّهِيرِيَّةِ
u'عِبَارَةٌ ظَهِير':Added, #5: 5	عِبَارَةَ الظَّهِيرِيَّةِ
u'عِبَارَةٌ ظَهِيرَة':Added, #6: 6	عِبَارَةِ الظَّهِيرِيَّةِ
u'عِبَارَةٌ ظَهِيرَة':Added, #4: 4	عِبَارَةُ الظَّهِيرِيَّةِ
u'عِبَارَةٌ ظَهِيرَة':Added, #5: 5	عِبَارَةَ الظَّهِيرِيَّةِ
u'عِبَارَةٌ عَاقِلٌ':Added, #6: 6	عِبَارَةِ الظَّهِيرِيَّةِ
u'عِبَارَةٌ عَامٌّ':Added, #1: 1	عِبَارَةِ الْعَاقِلِ
u'عِبَارَةٌ عُبَابٌ':Added, #2: 2	عِبَارَةُ عَامَّةِ
u'عِبَارَةٌ عُبَابٌ':Added, #1: 1	عِبَارَةُ الْعُبَابِ
u'عِبَارَةٌ عَبْدٌ':Added, #1: 1	عِبَارَةِ الْعُبَابِ
u'عِبَارَةٌ عَرَبِيٌّ':Added, #1: 1	عِبَارَةُ عَبْدِ
u'عِبَارَةٌ عَزِيزٌ':Added, #1: 1	عِبَارَةَ الْعَرَبِيِّ
u'عِبَارَةٌ عَزِيزٌ':Added, #1: 1	عِبَارَةِ الْعَزِيزِ
u'عِبَارَةٌ عقدة':Added, #2: 2	عِبَارَةُ الْعَزِيزِ
u'عِبَارَةٌ عُقْدَةٌ':Added, #1: 1	عِبَارَةُ عُقْدَةٍ
u'عِبَارَةٌ عِلَّةٌ':Added, #1: 1	عِبَارَةُ عُقْدَةٍ
u'عِبَارَةٌ عِنَايَةٌ':Added, #1: 1	عِبَارَةَ الْعِلَّةِ
u'عِبَارَةٌ عِنَايَةٌ':Added, #1: 1	عِبَارَةَ الْعِنَايَةِ
u'عِبَارَةٌ غَالِبٌ':Added, #2: 2	عِبَارَةِ الْعِنَايَةِ
u'عِبَارَةٌ غير':Added, #3: 3	عِبَارَةُ غَالِبِ
u'عِبَارَةٌ غير':Added, #1: 1	عِبَارَة غَيْرِهِ
u'عِبَارَةٌ غَيْرٌ':Added, #1: 1	عِبَارَةِ غَيْرِهِ
u'عِبَارَةٌ غَيْرٌ':Added, #1: 1	عِبَارَة غَيْرِهِ
u'عِبَارَةٌ غير':Added, #1: 1	عِبَارَةِ غَيْرِهِ
u'عِبَارَةٌ غير':Added, #3: 3	عِبَارَةَ غَيْرِهِ
u'عِبَارَةٌ غَيْرٌ':Added, #3: 3	عِبَارَةُ غَيْرِهِ
u'عِبَارَةٌ غَيْرٌ':Added, #3: 3	عِبَارَةَ غَيْرِهِ
u'عِبَارَةٌ غير':Added, #3: 3	عِبَارَةُ غَيْرِهِ
u'عِبَارَةٌ غَيْرٌ':Added, #4: 4	عِبَارَةِ غَيْرِ
u'عِبَارَةٌ فَتَاوِي':Added, #4: 4	عِبَارَةِ غَيْرِ
u'عِبَارَةٌ فَتْحٌ':Added, #1: 1	عِبَارَةِ فَتَاوِيهِ
u'عِبَارَةٌ فَتْحٌ':Added, #18: 18	عِبَارَةِ الْفَتْحِ
u'عِبَارَةٌ فَتْحٌ':Added, #1: 1	عِبَارَةَ فَتْحِ
u'عِبَارَةٌ فَتْحٌ':Added, #1: 1	عِبَارَةُ فَتْحِ
u'عِبَارَةٌ فَتْحٌ':Added, #20: 20	عِبَارَةُ الْفَتْحِ
u'عِبَارَةٌ فَتْحٌ':Added, #3: 3	عِبَارَةَ الْفَتْحِ
u'عِبَارَةٌ فخر':Added, #3: 3	عِبَارَةِ فَتْحِ
u'عِبَارَةٌ فَخْرٌ':Added, #2: 2	عِبَارَةِ فَخْرِ
u'عِبَارَةٌ فُصُولٌ':Added, #2: 2	عِبَارَةِ فَخْرِ
u'عِبَارَةٌ فُصُولٌ':Added, #1: 1	عِبَارَةَ الْفُصُولِ
u'عِبَارَةٌ فُضُولِيٌّ':Added, #1: 1	عِبَارَةِ الْفُصُولِ
u'عِبَارَةٌ فقهاء':Added, #1: 1	عِبَارَةُ الْفُضُولِيِّ
u'عِبَارَةٌ فَلاَسِفَةٌ':Added, #2: 2	عِبَارَةِ الْفُقَهَاءِ
u'عِبَارَةٌ فلان':Added, #1: 1	عِبَارَةِ الْفَلَاسِفَةِ
u'عِبَارَةٌ فلان':Added, #1: 1	عِبَارَةُ الدَّمِيرِيِّ
u'عِبَارَةٌ فلان':Added, #1: 1	عِبَارَةُ السَّعْدِيَّةِ
u'عِبَارَةٌ فلان':Added, #2: 2	عِبَارَةَ الْبَزَّازِيَّةِ
u'عِبَارَةٌ فلان':Added, #2: 2	عِبَارَةَ الشَّافِعِيِّ
u'عِبَارَةٌ فلان':Added, #3: 3	عِبَارَةَ الْخَانِيَّةِ
u'عِبَارَةٌ فلان':Added, #3: 3	عِبَارَةُ الشَّافِعِيِّ
u'عِبَارَةٌ فلان':Added, #3: 3	عِبَارَةِ الشَّافِعِيِّ
u'عِبَارَةٌ فلان':Added, #6: 6	عِبَارَةُ الْبَزَّازِيَّةِ
u'عِبَارَةٌ فلان':Added, #8: 8	عِبَارَةِ الْبَزَّازِيَّةِ
u'عِبَارَةٌ فلان':Added, #8: 8	عِبَارَةُ الْخَانِيَّةِ
u'عِبَارَةٌ قَامُوسٌ':Added, #9: 9	عِبَارَةِ الْخَانِيَّةِ
u'عِبَارَةٌ قَائِلٌ':Added, #1: 1	عِبَارَةِ الْقَامُوسِ
u'عِبَارَةٌ قَفَّالٌ':Added, #1: 1	عِبَارَةِ الْقَائِلِ
u'عِبَارَةٌ قَوْمٌ':Added, #1: 1	عِبَارَةِ الْقَفَّالِ
u'عِبَارَةٌ كِتَابٌ':Added, #1: 1	عِبَارَةِ الْقَوْمِ
u'عِبَارَةٌ كِتَابٌ':Added, #10: 10	عِبَارَةِ الْكِتَابِ
u'عِبَارَةٌ كِتَابٌ':Added, #1: 1	عِبَارَةَ الْكِتَابِ
u'عِبَارَةٌ كِتَابٌ':Added, #1: 1	عِبَارَةُ كِتَابِ
u'عِبَارَةٌ كِتَابٌ':Added, #2: 2	عِبَارَةِ كِتَابِ
u'عِبَارَةٌ كَثِيرٌ':Added, #6: 6	عِبَارَةُ الْكِتَابِ
u'عِبَارَةٌ كِفَايَةٌ':Added, #1: 1	عِبَارَةِ كَثِيرِ
u'عِبَارَةٌ كَنْزٌ':Added, #2: 2	عِبَارَةُ الْكِفَايَةِ
u'عِبَارَةٌ مَالِكٌ':Added, #1: 1	عِبَارَةِ الْكَنْزِ
u'عِبَارَةٌ مُبَرِّدٌ':Added, #1: 1	عِبَارَةُ مَالِكٍ
u'عِبَارَةٌ مَبْسُوطٌ':Added, #1: 1	عِبَارَةِ الْمُبَرِّدِ
u'عِبَارَةٌ مَتْنٌ':Added, #2: 2	عِبَارَةِ الْمَبْسُوطِ
u'عِبَارَةٌ مَتْنٌ':Added, #1: 1	عِبَارَةَ الْمَتْنِ
u'عِبَارَةٌ مَتْنٌ':Added, #1: 1	عِبَارَةُ مَتْنِ
u'عِبَارَةٌ مَتْنٌ':Added, #1: 1	عِبَارَةِ مَتْنِ
u'عِبَارَةٌ مَتْنٌ':Added, #2: 2	عِبَارَةُ الْمَتْنِ
u'عِبَارَةٌ مَجْمَعٌ':Added, #7: 7	عِبَارَةِ الْمَتْنِ
u'عِبَارَةٌ مَجْمَعٌ':Added, #1: 1	عِبَارَةَ الْمَجْمَعِ
u'عِبَارَةٌ مَجْمَعٌ':Added, #1: 1	عِبَارَةُ الْمَجْمَعِ
u'عِبَارَةٌ مَجْمَعٌ':Added, #1: 1	عِبَارَةُ مَجْمَعِ
u'عِبَارَةٌ مَجْمُوعٌ':Added, #6: 6	عِبَارَةِ الْمَجْمَعِ
u'عِبَارَةٌ مَجْمُوعٌ':Added, #3: 3	عِبَارَةُ الْمَجْمُوعِ
u'عِبَارَةٌ مُحَرِّرٌ':Added, #8: 8	عِبَارَةِ الْمَجْمُوعِ
u'عِبَارَةٌ مُحَرَّرٌ':Added, #1: 1	عِبَارَةُ الْمُحَرِّرِ
u'عِبَارَةٌ مُحَرَّرٌ':Added, #2: 2	عِبَارَةُ الْمُحَرَّرِ
u'عِبَارَةٌ مُحْرِمٌ':Added, #2: 2	عِبَارَةِ الْمُحَرَّرِ
u'عِبَارَةٌ مُحَمَّدٌ':Added, #1: 1	عِبَارَةَ الْمُحْرِمِ
u'عِبَارَةٌ مُحَمَّدٌ':Added, #2: 2	عِبَارَةَ مُحَمَّدٍ
u'عِبَارَةٌ مُحَمَّدٌ':Added, #2: 2	عِبَارَةُ مُحَمَّدٍ
u'عِبَارَةٌ مُحِيطٌ':Added, #3: 3	عِبَارَةِ مُحَمَّدٍ
u'عِبَارَةٌ مُحِيطٌ':Added, #1: 1	عِبَارَةُ الْمُحِيطِ
u'عِبَارَةٌ مُحِيطٌ':Added, #2: 2	عِبَارَةَ الْمُحِيطِ
u'عِبَارَةٌ مُخْبِرٌ':Added, #5: 5	عِبَارَةِ الْمُحِيطِ
u'عِبَارَةٌ مُخْتَصَرٌ':Added, #1: 1	عِبَارَةِ الْمُخْبِرِ
u'عِبَارَةٌ مُخْتَصَرٌ':Added, #1: 1	عِبَارَةَ الْمُخْتَصَرِ
u'عِبَارَةٌ مُخْتَصَرٌ':Added, #1: 1	عِبَارَةِ مُخْتَصَرِ
u'عِبَارَةٌ مُخْتَصَرٌ':Added, #2: 2	عِبَارَةُ الْمُخْتَصَرِ
u'عِبَارَةٌ مُخْطِئٌ':Added, #5: 5	عِبَارَةِ الْمُخْتَصَرِ
u'عِبَارَةٌ مُدَوَّنٌ':Added, #1: 1	عِبَارَةَ الْمُخْطِئِ
u'عِبَارَةٌ مُدَوَّنَةٌ':Added, #3: 3	عِبَارَةُ الْمُدَوَّنَةِ
u'عِبَارَةٌ مُرْسِلٌ':Added, #3: 3	عِبَارَةُ الْمُدَوَّنَةِ
u'عِبَارَةٌ مُرْسِلٌ':Added, #1: 1	عِبَارَةَ الْمُرْسِلِ
u'عِبَارَةٌ مُرْسِلٌ':Added, #1: 1	عِبَارَةُ الْمُرْسِلِ
u'عِبَارَةٌ مَشَايِخُ':Added, #2: 2	عِبَارَةِ الْمُرْسِلِ
u'عِبَارَةٌ مَشَايِخُ':Added, #1: 1	عِبَارَةَ الْمَشَايِخِ
u'عِبَارَةٌ مَشَايِخُ':Added, #3: 3	عِبَارَةُ الْمَشَايِخِ
u'عِبَارَةٌ مُصَنِّفٌ':Added, #3: 3	عِبَارَةِ الْمَشَايِخِ
u'عِبَارَةٌ مُصَنِّفٌ':Added, #10: 10	عِبَارَةُ الْمُصَنِّفِ
u'عِبَارَةٌ مُصَنِّفٌ':Added, #31: 31	عِبَارَةِ الْمُصَنِّفِ
u'عِبَارَةٌ مُضْمَرٌ':Added, #6: 6	عِبَارَةَ الْمُصَنِّفِ
u'عِبَارَةٌ مِعْرَاجٌ':Added, #1: 1	عِبَارَةَ الْمُضْمَرَاتِ
u'عِبَارَةٌ مِعْرَاجٌ':Added, #1: 1	عِبَارَةَ الْمِعْرَاجِ
u'عِبَارَةٌ مِعْرَاجٌ':Added, #1: 1	عِبَارَةُ مِعْرَاجِ
u'عِبَارَةٌ مَعْصِيَةٌ':Added, #3: 3	عِبَارَةُ الْمِعْرَاجِ
u'عِبَارَةٌ مُفَصَّلٌ':Added, #1: 1	عِبَارَةَ الْمَعْصِيَةِ
u'عِبَارَةٌ مُفْلِسٌ':Added, #1: 1	عِبَارَةِ الْمُفَصَّلِ
u'عِبَارَةٌ مُقْنِعٌ':Added, #1: 1	عِبَارَةِ الْمُفْلِسِ
u'عِبَارَةٌ مَكْتُوبٌ':Added, #2: 2	عِبَارَةِ الْمُقْنِعِ
u'عِبَارَةٌ مُكْرَهٌ':Added, #3: 3	عِبَارَةِ مَكْتُوبِ
u'عِبَارَةٌ مَلَكٌ':Added, #1: 1	عِبَارَةِ الْمُكْرَهِ
u'عِبَارَةٌ مِنَحٌ':Added, #1: 1	عِبَارَةِ الْمَلَكِ
u'عِبَارَةٌ مِنْهَاجٌ':Added, #1: 1	عِبَارَةُ الْمِنَحِ
u'عِبَارَةٌ مِنْهَاجٌ':Added, #12: 12	عِبَارَةُ الْمِنْهَاجِ
u'عِبَارَةٌ مِنْهَاجٌ':Added, #1: 1	عِبَارَةَ الْمِنْهَاجِ
u'عِبَارَةٌ مُنْيَةٌ':Added, #6: 6	عِبَارَةِ الْمِنْهَاجِ
u'عِبَارَةٌ مُنْيَةٌ':Added, #1: 1	عِبَارَةُ الْمُنْيَةِ
u'عِبَارَةٌ مُهَذَّبٌ':Added, #2: 2	عِبَارَةِ الْمُنْيَةِ
u'عِبَارَةٌ مُهَذَّبٌ':Added, #1: 1	عِبَارَةَ الْمُهَذَّبِ
u'عِبَارَةٌ مُهَذَّبٌ':Added, #1: 1	عِبَارَةُ الْمُهَذَّبِ
u'عِبَارَةٌ مُهِمٌّ':Added, #1: 1	عِبَارَةِ الْمُهَذَّبِ
u'عِبَارَةٌ مُهِمَّةٌ':Added, #1: 1	عِبَارَةُ الْمُهِمَّاتِ
u'عِبَارَةٌ مَوَاهِبُ':Added, #1: 1	عِبَارَةُ الْمُهِمَّاتِ
u'عِبَارَةٌ مُوَطَّأٌ':Added, #1: 1	عِبَارَةِ مَوَاهِبِ
u'عِبَارَةٌ مَوْقُوفٌ':Added, #1: 1	عِبَارَةُ الْمُوَطَّأِ
u'عِبَارَةٌ مُوَكِّلٌ':Added, #1: 1	عِبَارَةِ الْمَوْقُوفِ
u'عِبَارَةٌ مُوَكِّلٌ':Added, #1: 1	عِبَارَةِ الْمُوَكِّلِ
u'عِبَارَةٌ مُؤَلِّفٌ':Added, #2: 2	عِبَارَةُ الْمُوَكِّلِ
u'عِبَارَةٌ مُؤَلِّفٌ':Added, #18: 18	عِبَارَةِ الْمُؤَلِّفِ
u'عِبَارَةٌ مُؤَلِّفٌ':Added, #1: 1	عِبَارَةُ الْمُؤَلِّفِ
u'عِبَارَةٌ نَاطِقٌ':Added, #9: 9	عِبَارَةَ الْمُؤَلِّفِ
u'عِبَارَةٌ نَاظِمٌ':Added, #3: 3	عِبَارَةِ النَّاطِقِ
u'عِبَارَةٌ نَائِمٌ':Added, #1: 1	عِبَارَةُ النَّاظِمِ
u'عِبَارَةٌ نَذْرٌ':Added, #1: 1	عِبَارَةُ النَّائِمِ
u'عِبَارَةٌ نِساءٌ':Added, #1: 1	عِبَارَةُ نَذْرٍ
u'عِبَارَةٌ نَصٌّ':Added, #2: 2	عِبَارَةَ النِّسَاءِ
u'عِبَارَةٌ نَصٌّ':Added, #1: 1	عِبَارَةَ النَّصِّ
u'عِبَارَةٌ نَصٌّ':Added, #1: 1	عِبَارَةُ النَّصِّ
u'عِبَارَةٌ نصاب':Added, #1: 1	عِبَارَةِ النَّصِّ
u'عِبَارَةٌ نِصَابٌ':Added, #1: 1	عِبَارَةَ النِّصَابِ
u'عِبَارَةٌ نَظْمٌ':Added, #1: 1	عِبَارَةَ النِّصَابِ
u'عِبَارَةٌ نُقايَة':Added, #1: 1	عِبَارَةِ النَّظْمِ
u'عِبَارَةٌ نِهَايَةٌ':Added, #1: 1	عِبَارَةُ النُّقَايَةِ
u'عِبَارَةٌ نِهَايَةٌ':Added, #1: 1	عِبَارَةَ النِّهَايَةِ
u'عِبَارَةٌ نَهْرٌ':Added, #3: 3	عِبَارَةِ النِّهَايَةِ
u'عِبَارَةٌ نَهْرٌ':Added, #5: 5	عِبَارَةُ النَّهْرِ
u'عِبَارَةٌ نَوَوِيٌّ':Added, #5: 5	عِبَارَةِ النَّهْرِ
u'عِبَارَةٌ هِدَايَةٌ':Added, #1: 1	عِبَارَةِ النَّوَوِيِّ
u'عِبَارَةٌ هِدَايَةٌ':Added, #11: 11	عِبَارَةُ الْهِدَايَةِ
u'عِبَارَةٌ هِدَايَةٌ':Added, #20: 20	عِبَارَةِ الْهِدَايَةِ
u'عِبَارَةٌ وَاقِفٌ':Added, #3: 3	عِبَارَةَ الْهِدَايَةِ
u'عِبَارَةٌ وَاقِفٌ':Added, #1: 1	عِبَارَةَ الْوَاقِفِ
u'عِبَارَةٌ وَاقِفٌ':Added, #1: 1	عِبَارَةُ الْوَاقِفِ
u'عِبَارَةٌ وَاقِفٌ':Added, #1: 1	عِبَارَةِ الْوَاقِفَةِ
u'عِبَارَةٌ وَسِيطٌ':Added, #5: 5	عِبَارَةِ الْوَاقِفِ
u'عِبَارَةٌ وَسِيطٌ':Added, #1: 1	عِبَارَةُ وَسِيطِ
u'عِبَارَةٌ وِقَايَةٌ':Added, #2: 2	عِبَارَةُ الْوَسِيطِ
u'عِبَارَةٌ وِقَايَةٌ':Added, #1: 1	عِبَارَةِ الْوِقَايَةِ
u'عِبَارَةٌ وَكِيلٌ':Added, #2: 2	عِبَارَةَ الْوِقَايَةِ
u'عِبَارَةٌ وَكِيلٌ':Added, #1: 1	عِبَارَةِ وَكِيلِهِ
u'عِبَارَةٌ وَكِيلٌ':Added, #2: 2	عِبَارَةَ الْوَكِيلِ
u'عَبَدَ حِجارَةٌ':Predicate, #3: 3	عِبَارَةِ الْوَكِيلِ
u'عَبَّرَ اِبْنٌ':Subject, #1: 1	عَبَدَ الْحِجَارَةَ
u'عَبْرٌ آحَادٌ':Added, #3: 3	عَبَّرَ ابْنُ
u'عَبَّرَ أَصْحَابٌ':Subject, #1: 1	عَبْرَ الْآحَادِ
u'عَبَّرَ أصل':Subject, #1: 1	عَبَّرَ الْأَصْحَابُ
u'عَبَّرَ أًصْلٌ':Subject, #1: 1	عَبَّرَ أَصْلُهُ
u'عَبَّرَ أصل':Subject, #1: 1	عَبَّرَ أَصْلُهُ
u'عَبَّرَ أًصْلٌ':Subject, #8: 8	عَبَّرَ الْأَصْلُ
u'عَبَرَ أَكْثَرُ':Predicate, #8: 8	عَبَّرَ الْأَصْلُ
u'عَبَّرَ إِنْسانٌ':Subject, #1: 1	عَبَرَ أَكْثَرَ
u'عَبَّرَ بَدَلٌ':Predicate, #2: 2	عَبَّرَ الْإِنْسَانُ
u'عَبَّرَ بَعْضٌ':Subject, #17: 17	عَبَّرَ بَدَلَ
u'عَبَّرَ جَمَاعَةٌ':Subject, #4: 4	عَبَّرَ بَعْضُ
u'عَبَّرَ جَوْهَرِيٌّ':Subject, #2: 2	عَبَّرَ جَمَاعَةٌ
u'عَبَّرَ حَسَنٌ':Subject, #1: 1	عَبَّرَ الْجَوْهَرِيُّ
u'عَبْرٌ خراج':Added, #1: 1	عَبَّرَ الْحَسَنُ
u'عَبْرٌ خَرَاجٌ':Added, #1: 1	عَبْرُ الْخَرَاجِ
u'عَبَرَ رَجُلٌ':Subject, #1: 1	عَبْرُ الْخَرَاجِ
u'عَبَّرَ رَسُولٌ':Subject, #1: 1	عَبَرَ الرّجُلُ
u'عَبَّرَ شافِعِيّ':Subject, #1: 1	عَبَّرَ رَسُولُ
u'عَبَّرَ طَرَفَةٌ':Subject, #3: 3	عَبَّرَ الشَّافِعِيُّ
u'عَبَّرَ عند':Predicate, #1: 1	عَبَّرَ طَرَفَةُ
u'عَبَّرَ فخر':Subject, #1: 1	عَبَّرَ عِنْدَ
u'عَبَّرَ فَخْرٌ':Subject, #1: 1	عَبَّرَ فَخْرُ
u'عَبَّرَ فقهاء':Subject, #1: 1	عَبَّرَ فَخْرُ
u'عَبَّرَ فلان':Subject, #1: 1	عَبَّرَ الْفُقَهَاءُ
u'عَبَّرَ قضاة':Subject, #3: 3	عَبَّرَ الشَّافِعِيُّ
u'عَبَّرَ مُحَرَّرٌ':Subject, #1: 1	عَبَّرَ الْقُضَاةُ
u'عَبَّرَ مُحَمَّدٌ':Subject, #1: 1	عَبَّرَ الْمُحَرَّرُ
u'عَبَّرَ مُصَنِّفٌ':Subject, #1: 1	عَبَّرَ مُحَمَّدٌ
u'عَبَّرَ مُعْظَمٌ':Subject, #23: 23	عَبَّرَ الْمُصَنِّفُ
u'عَبَرَ مَكْتَبٌ':Predicate, #1: 1	عَبَّرَ مُعْظَمُ
u'عَبَّرَ نَبِيٌّ':Subject, #1: 1	عَبَرَ الْمَكْتَبَ
u'عَبَرَ نَهْرٌ':Predicate, #1: 1	عَبَّرَ النَّبِيُّ
u'عَبَّرَ نَوَوِيٌّ':Subject, #2: 2	عَبَرَ النّهْرَ
u'عَبَّرَ هَرَوِيّ':Subject, #1: 1	عَبَّرَ النَّوَوِيُّ
u'عَبَسَ زَمانٌ':Subject, #2: 2	عَبَّرَ الْهَرَوِيُّ
u'عَبَسَ وَجْهٌ':Subject, #4: 4	عَبَسَ الزَّمَانُ
u'عَبَّ مَاءٌ':Predicate, #1: 1	عَبَسَ وَجْهُهُ
u'عُبُودِيَّةٌ إِخَاءٌ':Added, #1: 1	عَبَّ الْمَاءَ
u'عُبُودِيَّةٌ تَعْرِيفٌ':Added, #1: 1	عُبُودِيَّةُ الْإِخَاءِ
u'عُبُودِيَّةٌ رَبُّ':Added, #1: 1	عُبُودِيَّةَ التَّعْرِيفِ
u'عُبُودِيَّةٌ رِقٌّ':Added, #1: 1	عُبُودِيَّةِ رَبِّهِ
u'عُبُورٌ سَبِيلٌ':Added, #1: 1	عُبُودِيَّةُ الرِّقِّ
u'عُبُورٌ سَبِيلٌ':Added, #1: 1	عُبُورِ السَّبِيلِ
u'عُبُورٌ مَحْمَلٌ':Added, #1: 1	عُبُورُ سَبِيلٍ
u'عُبُورٌ مَسْجِدٌ':Added, #2: 2	عُبُورُ مَحْمَلٍ
u'عُبُورٌ مَسْجِدٌ':Added, #1: 1	عُبُورَ الْمَسْجِدِ
u'عُبُورٌ نَفَرٌ':Added, #2: 2	عُبُورُ الْمَسْجِدِ
u'عتاب الْمَرْءُ':Added, #1: 1	عُبُورُ نَفَرٍ
u'عِتَابٌ الْمَرْءُ':Added, #2: 2	عِتَابُ الْمَرْءِ
u'عَتَقَ أَبٌ':Subject, #2: 2	عِتَابُ الْمَرْءِ
u'عتق أَبٌ':Added, #17: 17	عَتَقَ الْأَبُ
u'عِتْقٌ أَبٌ':Added, #11: 11	عِتْقِ الْأَبِ
u'عتق أَبٌ':Added, #11: 11	عِتْقِ الْأَبِ
u'عِتْقٌ أَبٌ':Added, #1: 1	عِتْقَ أَبِ
u'عتق أَبٌ':Added, #1: 1	عِتْقَ أَبِ
u'عِتْقٌ أَبٌ':Added, #1: 1	عِتْقَ الْأَبِ
u'عتق أَبٌ':Added, #1: 1	عِتْقَ الْأَبِ
u'عِتْقٌ أَبٌ':Added, #3: 3	عِتْقُ الْأَبِ
u'عتق اِبْنٌ':Added, #3: 3	عِتْقُ الْأَبِ
u'عتق اِبْنٌ':Added, #1: 1	عِتْقُ ابْنِ
u'عِتْقٌ اِبْنٌ':Added, #1: 1	عِتْقِ ابْنِ
u'عِتْقٌ اِبْنٌ':Added, #1: 1	عِتْقُ ابْنِ
u'عَتَقَ أحَدٌ':Predicate, #1: 1	عِتْقِ ابْنِ
u'عَتَقَ أحَدٌ':Subject, #1: 1	عَتَقَ أَحَدَ
u'عتق أحَدٌ':Added, #1: 1	عَتَقَ أَحَدُ
u'عتق أحَدٌ':Added, #1: 1	عِتْقَ أَحَدِ
u'عتق أحَدٌ':Added, #1: 1	عِتْقُ أَحَدِ
u'عِتْقٌ أحَدٌ':Added, #1: 1	عِتْقِ أَحَدٍ
u'عِتْقٌ أحَدٌ':Added, #1: 1	عِتْقَ أَحَدِ
u'عِتْقٌ أحَدٌ':Added, #1: 1	عِتْقُ أَحَدِ
u'عتق أحَدٌ':Added, #1: 1	عِتْقِ أَحَدٍ
u'عِتْقٌ أحَدٌ':Added, #7: 7	عِتْقِ أَحَدِ
u'عَتَقَ أَخٌ':Subject, #7: 7	عِتْقِ أَحَدِ
u'عتق أَخٌ':Added, #1: 1	عَتَقَ الْأَخُ
u'عِتْقٌ أَخٌ':Added, #1: 1	عِتْقُ الْأَخِ
u'عتق آخِرُ':Added, #1: 1	عِتْقُ الْأَخِ
u'عِتْقٌ آخِرُ':Added, #2: 2	عِتْقُ آخِرِ
u'عَتَقَ أَخِيرٌ':Subject, #2: 2	عِتْقُ آخِرِ
u'عتق أَخِيرٌ':Added, #2: 2	عَتَقَ الْأَخِيرُ
u'عِتْقٌ أَخِيرٌ':Added, #1: 1	عِتْقِ الْأَخِيرِ
u'عَتَقَ أَرْبَعَةٌ':Subject, #1: 1	عِتْقِ الْأَخِيرِ
u'عَتَقَ أَرْبَعَةٌ':Subject, #2: 2	عَتَقَ أَرْبَعَةٌ
u'عَتَقَ أصْغَرٌ':Subject, #3: 3	عَتَقَ أَرْبَعَةُ
u'عَتَقَ أَصْغَرُ':Subject, #3: 3	عَتَقَ الْأَصْغَرُ
u'عَتَقَ أصل':Subject, #3: 3	عَتَقَ الْأَصْغَرُ
u'عَتَقَ أًصْلٌ':Subject, #1: 1	عَتَقَ أَصْلُهُ
u'عتق أصل':Added, #1: 1	عَتَقَ أَصْلُهُ
u'عتق أًصْلٌ':Added, #1: 1	عِتْقِ أَصْلِهِ
u'عِتْقٌ أصل':Added, #1: 1	عِتْقِ أَصْلِهِ
u'عِتْقٌ أًصْلٌ':Added, #1: 1	عِتْقِ أَصْلِهِ
u'عتق أصل':Added, #1: 1	عِتْقِ أَصْلِهِ
u'عتق أًصْلٌ':Added, #1: 1	عِتْقَ الْأَصْلِ
u'عِتْقٌ أصل':Added, #1: 1	عِتْقَ الْأَصْلِ
u'عِتْقٌ أًصْلٌ':Added, #1: 1	عِتْقَ الْأَصْلِ
u'عتق أَصَمّ':Added, #1: 1	عِتْقَ الْأَصْلِ
u'عِتْقٌ أَصَمّ':Added, #1: 1	عِتْقُ الْأَصَمِّ
u'عتق أعْرَج':Added, #1: 1	عِتْقُ الْأَصَمِّ
u'عِتْقٌ أعْرَج':Added, #1: 1	عِتْقُ الْأَعْرَجِ
u'عتق أعْوَر':Added, #1: 1	عِتْقُ الْأَعْرَجِ
u'عِتْقٌ أعْوَر':Added, #2: 2	عِتْقَ الْأَعْوَرِ
u'عَتَقَ أقَلُّ':Subject, #2: 2	عِتْقَ الْأَعْوَرِ
u'عَتَقَ أقَلُّ':Subject, #1: 1	عَتَقَ أَقَلُّ
u'عتق الْمَرْأَةُ':Added, #1: 1	عَتَقَ الْأَقَلُّ
u'عِتْقٌ الْمَرْأَةُ':Added, #2: 2	عِتْقُ الْمَرْأَةِ
u'عَتَقَ أُمٌّ':Subject, #2: 2	عِتْقُ الْمَرْأَةِ
u'عتق أُمٌّ':Added, #1: 1	عَتَقَ الْأُمُّ
u'عِتْقٌ أُمٌّ':Added, #1: 1	عِتْقَ أُمِّ
u'عتق أُمٌّ':Added, #1: 1	عِتْقَ أُمِّ
u'عِتْقٌ أُمٌّ':Added, #2: 2	عِتْقُ الْأُمِّ
u'عتق أُمٌّ':Added, #2: 2	عِتْقُ الْأُمِّ
u'عِتْقٌ أُمٌّ':Added, #3: 3	عِتْقَ الْأُمِّ
u'عتق أُمٌّ':Added, #3: 3	عِتْقَ الْأُمِّ
u'عِتْقٌ أُمٌّ':Added, #4: 4	عِتْقِ أُمِّ
u'عتق أُمٌّ':Added, #4: 4	عِتْقِ أُمِّ
u'عِتْقٌ أُمٌّ':Added, #4: 4	عِتْقِ أُمِّهِ
u'عتق أُمٌّ':Added, #4: 4	عِتْقِ أُمِّهِ
u'عِتْقٌ أُمٌّ':Added, #5: 5	عِتْقُ أُمِّ
u'عتق أُمٌّ':Added, #5: 5	عِتْقُ أُمِّ
u'عِتْقٌ أُمٌّ':Added, #6: 6	عِتْقِ الْأُمِّ
u'عَتَقَ إمَاءٌ':Subject, #6: 6	عِتْقِ الْأُمِّ
u'عتق أمَةٌ':Added, #1: 1	عَتَقَ الْإِمَاءُ
u'عِتْقٌ أمَةٌ':Added, #1: 1	عِتْقُ أَمَةٍ
u'عتق أمَةٌ':Added, #1: 1	عِتْقُ أَمَةٍ
u'عِتْقٌ أمَةٌ':Added, #1: 1	عِتْقُ أَمَتِهِ
u'عتق أمَةٌ':Added, #1: 1	عِتْقُ أَمَتِهِ
u'عِتْقٌ أمَةٌ':Added, #21: 21	عِتْقِ الْأَمَةِ
u'عتق أمَةٌ':Added, #21: 21	عِتْقِ الْأَمَةِ
u'عِتْقٌ أمَةٌ':Added, #2: 2	عِتْقِ أَمَتِهِ
u'عتق أمَةٌ':Added, #2: 2	عِتْقِ أَمَتِهِ
u'عِتْقٌ أمَةٌ':Added, #3: 3	عِتْقَ الْأَمَةِ
u'عتق أمَةٌ':Added, #3: 3	عِتْقَ الْأَمَةِ
u'عِتْقٌ أمَةٌ':Added, #3: 3	عِتْقِ أَمَةٍ
u'عتق أمَةٌ':Added, #3: 3	عِتْقِ أَمَةٍ
u'عِتْقٌ أمَةٌ':Added, #4: 4	عِتْقُ الْأَمَةِ
u'عتق أمَةٌ':Added, #4: 4	عِتْقُ الْأَمَةِ
u'عِتْقٌ أمَةٌ':Added, #7: 7	عِتْقَ أَمَتِهِ
u'عَتَقَ أُمَّهَاتٌ':Subject, #7: 7	عِتْقَ أَمَتِهِ
u'عتق أُمَّهَاتٌ':Added, #1: 1	عَتَقَ أُمَّهَاتُ
u'عِتْقٌ أُمَّهَاتٌ':Added, #4: 4	عِتْقِ أُمَّهَاتِ
u'عتق أوْسَطُ':Added, #4: 4	عِتْقِ أُمَّهَاتِ
u'عِتْقٌ أوْسَطُ':Added, #1: 1	عِتْقِ الْأَوْسَطِ
u'عَتَقَ أَوَّلُ':Subject, #1: 1	عِتْقِ الْأَوْسَطِ
u'عتق أَوَّلُ':Added, #22: 22	عَتَقَ الْأَوَّلُ
u'عِتْقٌ أَوَّلُ':Added, #1: 1	عِتْقُ الْأَوَّلِ
u'عتق أَوَّلُ':Added, #1: 1	عِتْقُ الْأَوَّلِ
u'عِتْقٌ أَوَّلُ':Added, #3: 3	عِتْقَ الْأَوَّلِ
u'عتق أَوَّلُ':Added, #3: 3	عِتْقَ الْأَوَّلِ
u'عِتْقٌ أَوَّلُ':Added, #4: 4	عِتْقِ الْأَوَّلِ
u'عتق أَوْلاَدٌ':Added, #4: 4	عِتْقِ الْأَوَّلِ
u'عِتْقٌ أَوْلاَدٌ':Added, #1: 1	عِتْقِ الْأَوْلَادِ
u'عَتَقَ بَائِعٌ':Subject, #1: 1	عِتْقِ الْأَوْلَادِ
u'عتق بَائِعٌ':Added, #1: 1	عَتَقَ الْبَائِعُ
u'عِتْقٌ بَائِعٌ':Added, #1: 1	عِتْقَ الْبَائِعِ
u'عتق بَائِعٌ':Added, #1: 1	عِتْقَ الْبَائِعِ
u'عِتْقٌ بَائِعٌ':Added, #5: 5	عِتْقُ الْبَائِعِ
u'عَتَقَ بَعْضٌ':Subject, #5: 5	عِتْقُ الْبَائِعِ
u'عَتَقَ بَعْضٌ':Subject, #2: 2	عَتَقَ الْبَعْضُ
u'عَتَقَ بَعْضٌ':Subject, #4: 4	عَتَقَ بَعْضُ
u'عتق بَعْضٌ':Added, #6: 6	عَتَقَ بَعْضُهُ
u'عِتْقٌ بَعْضٌ':Added, #1: 1	عِتْقَ بَعْضِهِ
u'عتق بَعْضٌ':Added, #1: 1	عِتْقَ بَعْضِهِ
u'عِتْقٌ بَعْضٌ':Added, #2: 2	عِتْقَ الْبَعْضِ
u'عتق بَعْضٌ':Added, #2: 2	عِتْقَ الْبَعْضِ
u'عِتْقٌ بَعْضٌ':Added, #2: 2	عِتْقَ بَعْضِ
u'عتق بَعْضٌ':Added, #2: 2	عِتْقَ بَعْضِ
u'عِتْقٌ بَعْضٌ':Added, #3: 3	عِتْقِ الْبَعْضِ
u'عتق بَعْضٌ':Added, #3: 3	عِتْقِ الْبَعْضِ
u'عِتْقٌ بَعْضٌ':Added, #3: 3	عِتْقُ بَعْضِ
u'عتق بَعْضٌ':Added, #3: 3	عِتْقُ بَعْضِ
u'عِتْقٌ بَعْضٌ':Added, #4: 4	عِتْقِ بَعْضِ
u'عتق بَقِيَّةٌ':Added, #4: 4	عِتْقِ بَعْضِ
u'عتق بَقِيَّةٌ':Added, #1: 1	عِتْقَ بَقِيَّتِهِ
u'عِتْقٌ بَقِيَّةٌ':Added, #1: 1	عِتْقُ بَقِيَّتِهِ
u'عِتْقٌ بَقِيَّةٌ':Added, #1: 1	عِتْقَ بَقِيَّتِهِ
u'عتق تَبَرُّعٌ':Added, #1: 1	عِتْقُ بَقِيَّتِهِ
u'عِتْقٌ تَبَرُّعٌ':Added, #1: 1	عِتْقُ التَّبَرُّعِ
u'عتق تَدْبِيرٌ':Added, #1: 1	عِتْقُ التَّبَرُّعِ
u'عِتْقٌ تَدْبِيرٌ':Added, #1: 1	عِتْقُ التَّدْبِيرِ
u'عَتَقَ ثَابِتٌ':Predicate, #1: 1	عِتْقُ التَّدْبِيرِ
u'عَتَقَ ثَابِتٌ':Subject, #1: 1	عَتَقَ الثَّابِتَ
u'عَتَقَ ثَالِثٌ':Subject, #8: 8	عَتَقَ الثَّابِتُ
u'عَتَقَ ثَلاثَةٌ':Predicate, #7: 7	عَتَقَ الثَّالِثُ
u'عَتَقَ ثَلاثَةٌ':Subject, #1: 1	عَتَقَ ثَلَاثَةَ
u'عَتَقَ ثَلاثَةٌ':Subject, #1: 1	عَتَقَ الثَّلَاثَةُ
u'عتق ثَلاثَةٌ':Added, #4: 4	عَتَقَ ثَلَاثَةُ
u'عِتْقٌ ثَلاثَةٌ':Added, #1: 1	عِتْقِ ثَلَاثَةِ
u'عَتَقَ جَارِي':Subject, #1: 1	عِتْقِ ثَلَاثَةِ
u'عتق جَارِي':Added, #1: 1	عَتَقَ الْجَارِيَةُ
u'عِتْقٌ جَارِي':Added, #1: 1	عِتْقُ الْجَارِيَةِ
u'عتق جَارِي':Added, #1: 1	عِتْقُ الْجَارِيَةِ
u'عِتْقٌ جَارِي':Added, #1: 1	عِتْقَ جَارِيَتِهِ
u'عتق جَارِي':Added, #1: 1	عِتْقَ جَارِيَتِهِ
u'عِتْقٌ جَارِي':Added, #2: 2	عِتْقِ الْجَارِيَةِ
u'عَتَقَ جَارِيَةٌ':Subject, #2: 2	عِتْقِ الْجَارِيَةِ
u'عتق جَارِيَةٌ':Added, #1: 1	عَتَقَ الْجَارِيَةُ
u'عِتْقٌ جَارِيَةٌ':Added, #1: 1	عِتْقُ الْجَارِيَةِ
u'عتق جَارِيَةٌ':Added, #1: 1	عِتْقُ الْجَارِيَةِ
u'عِتْقٌ جَارِيَةٌ':Added, #1: 1	عِتْقَ جَارِيَتِهِ
u'عتق جَارِيَةٌ':Added, #1: 1	عِتْقَ جَارِيَتِهِ
u'عِتْقٌ جَارِيَةٌ':Added, #2: 2	عِتْقِ الْجَارِيَةِ
u'عَتَقَ جَازٌ':Predicate, #2: 2	عِتْقِ الْجَارِيَةِ
u'عَتَقَ جَمِيع':Subject, #1: 1	عَتَقَ جَازَ
u'عتق جَمِيع':Added, #3: 3	عَتَقَ الْجَمِيعُ
u'عِتْقٌ جَمِيع':Added, #1: 1	عِتْقِ الْجَمِيعِ
u'عتق جَمِيع':Added, #1: 1	عِتْقِ الْجَمِيعِ
u'عِتْقٌ جَمِيع':Added, #2: 2	عِتْقَ الْجَمِيعِ
u'عَتَقَ جَنِينٌ':Subject, #2: 2	عِتْقَ الْجَمِيعِ
u'عتق جَنِينٌ':Added, #3: 3	عَتَقَ الْجَنِينُ
u'عِتْقٌ جَنِينٌ':Added, #1: 1	عِتْقَ الْجَنِينِ
u'عتق جَنِينٌ':Added, #1: 1	عِتْقَ الْجَنِينِ
u'عِتْقٌ جَنِينٌ':Added, #3: 3	عِتْقِ الْجَنِينِ
u'عتق جَنِينٌ':Added, #3: 3	عِتْقِ الْجَنِينِ
u'عِتْقٌ جَنِينٌ':Added, #4: 4	عِتْقُ الْجَنِينِ
u'عَتَقَ جَوَابٌ':Subject, #4: 4	عِتْقُ الْجَنِينِ
u'عتق حامِلٌ':Added, #1: 1	عَتَقَ جَوَابُ
u'عتق حامِلٌ':Added, #1: 1	عِتْقَ حَامِلٍ
u'عِتْقٌ حامِلٌ':Added, #1: 1	عِتْقِ حَامِلٍ
u'عِتْقٌ حامِلٌ':Added, #1: 1	عِتْقَ حَامِلٍ
u'عتق حِصَّةٌ':Added, #1: 1	عِتْقِ حَامِلٍ
u'عِتْقٌ حِصَّةٌ':Added, #1: 1	عِتْقِ حِصَّتِهِ
u'عَتَقَ حَظٌّ':Subject, #1: 1	عِتْقِ حِصَّتِهِ
u'عَتَقَ حَقٌّ':Subject, #4: 4	عَتَقَ حَظُّهُ
u'عَتَقَ حَلٌّ':Predicate, #2: 2	عَتَقَ حَقُّهُ
u'عَتَقَ حَمْلٌ':Subject, #1: 1	عَتَقَ حَلَّ
u'عتق حَمْلٌ':Added, #4: 4	عَتَقَ الْحَمْلُ
u'عِتْقٌ حَمْلٌ':Added, #1: 1	عِتْقَ الْحَمْلِ
u'عتق حَمْلٌ':Added, #1: 1	عِتْقَ الْحَمْلِ
u'عِتْقٌ حَمْلٌ':Added, #2: 2	عِتْقُ الْحَمْلِ
u'عتق حَمْلٌ':Added, #2: 2	عِتْقُ الْحَمْلِ
u'عِتْقٌ حَمْلٌ':Added, #3: 3	عِتْقِ الْحَمْلِ
u'عَتَقَ حَيٌّ':Subject, #3: 3	عِتْقِ الْحَمْلِ
u'عَتَقَ خَارِجٌ':Subject, #8: 8	عَتَقَ الْحَيُّ
u'عَتَقَ خُمُسٌ':Subject, #9: 9	عَتَقَ الْخَارِجُ
u'عَتَقَ خَمْسَةٌ':Predicate, #1: 1	عَتَقَ خُمُسُهُ
u'عَتَقَ خَمْسَةٌ':Subject, #4: 4	عَتَقَ خَمْسَةَ
u'عَتَقَ دَاخِلٌ':Subject, #1: 1	عَتَقَ خَمْسَةُ
u'عَتَقَ دَمٌ':Subject, #3: 3	عَتَقَ الدَّاخِلُ
u'عَتَقَ دونٌ':Predicate, #1: 1	عَتَقَ دَمٌ
u'عَتَقَ ذكر':Subject, #2: 2	عَتَقَ دُونَ
u'عَتَقَ ذَكَرٌ':Subject, #1: 1	عَتَقَ الذَّكَرُ
u'عتق ذكر':Added, #1: 1	عَتَقَ الذَّكَرُ
u'عِتْقٌ ذكر':Added, #1: 1	عِتْقُ الذَّكَرِ
u'عتق ذَكَرٌ':Added, #1: 1	عِتْقُ الذَّكَرِ
u'عِتْقٌ ذَكَرٌ':Added, #1: 1	عِتْقُ الذَّكَرِ
u'عتق ذِمِّيٌّ':Added, #1: 1	عِتْقُ الذَّكَرِ
u'عِتْقٌ ذِمِّيٌّ':Added, #1: 1	عِتْقِ الذِّمِّيِّ
u'عتق رَاهِنٌ':Added, #1: 1	عِتْقِ الذِّمِّيِّ
u'عتق رَاهِنٌ':Added, #2: 2	عِتْقُ الرَّاهِنِ
u'عِتْقٌ رَاهِنٌ':Added, #2: 2	عِتْقِ الرَّاهِنِ
u'عِتْقٌ رَاهِنٌ':Added, #2: 2	عِتْقُ الرَّاهِنِ
u'عتق رَبُّ':Added, #2: 2	عِتْقِ الرَّاهِنِ
u'عِتْقٌ رَبُّ':Added, #1: 1	عِتْقُ رَبِّ
u'عَتَقَ رُبْعٌ':Subject, #1: 1	عِتْقُ رَبِّ
u'عَتَقَ رُبْعٌ':Subject, #1: 1	عَتَقَ الرُّبْعُ
u'عَتَقَ رُبُعٌ':Subject, #1: 1	عَتَقَ رُبْعُ
u'عتق رُبْعٌ':Added, #2: 2	عَتَقَ رُبُعُهُ
u'عِتْقٌ رُبْعٌ':Added, #1: 1	عِتْقِ رُبْعِ
u'عَتَقَ رَجُلٌ':Subject, #1: 1	عِتْقِ رُبْعِ
u'عتق رَجُلٌ':Added, #1: 1	عَتَقَ الرَّجُلُ
u'عِتْقٌ رَجُلٌ':Added, #1: 1	عِتْقِ الرَّجُلِ
u'عَتَقَ رَدٌّ':Predicate, #1: 1	عِتْقِ الرَّجُلِ
u'عَتَقَ رَسُولٌ':Subject, #1: 1	عَتَقَ رَدَّ
u'عتق رِقابٌ':Added, #1: 1	عَتَقَ الرَّسُولُ
u'عِتْقٌ رِقابٌ':Added, #1: 1	عِتْقِ رِقَابٍ
u'عتق رِقابٌ':Added, #1: 1	عِتْقِ رِقَابٍ
u'عِتْقٌ رِقابٌ':Added, #3: 3	عِتْقِ الرِّقَابِ
u'عتق رَقَبَةٌ':Added, #3: 3	عِتْقِ الرِّقَابِ
u'عِتْقٌ رَقَبَةٌ':Added, #18: 18	عِتْقَ رَقَبَةٍ
u'عتق رَقَبَةٌ':Added, #18: 18	عِتْقَ رَقَبَةٍ
u'عِتْقٌ رَقَبَةٌ':Added, #1: 1	عِتْقَ الرَّقَبَةِ
u'عتق رَقَبَةٌ':Added, #1: 1	عِتْقَ الرَّقَبَةِ
u'عِتْقٌ رَقَبَةٌ':Added, #3: 3	عِتْقُ الرَّقَبَةِ
u'عتق رَقَبَةٌ':Added, #3: 3	عِتْقُ الرَّقَبَةِ
u'عِتْقٌ رَقَبَةٌ':Added, #61: 61	عِتْقُ رَقَبَةٍ
u'عتق رَقَبَةٌ':Added, #61: 61	عِتْقُ رَقَبَةٍ
u'عِتْقٌ رَقَبَةٌ':Added, #8: 8	عِتْقِ رَقَبَةٍ
u'عَتَقَ رَقيقٌ':Subject, #8: 8	عِتْقِ رَقَبَةٍ
u'عَتَقَ رَقيق':Subject, #1: 1	عَتَقَ رَقِيقُهُ
u'عتق رَقيقٌ':Added, #1: 1	عَتَقَ رَقِيقُهُ
u'عتق رَقيق':Added, #1: 1	عِتْقِ الرَّقِيقِ
u'عِتْقٌ رَقيقٌ':Added, #1: 1	عِتْقِ الرَّقِيقِ
u'عِتْقٌ رَقيق':Added, #1: 1	عِتْقِ الرَّقِيقِ
u'عتق رَقيقٌ':Added, #1: 1	عِتْقِ الرَّقِيقِ
u'عتق رَقيق':Added, #1: 1	عِتْقَ رَقِيقٍ
u'عِتْقٌ رَقيقٌ':Added, #1: 1	عِتْقَ رَقِيقٍ
u'عِتْقٌ رَقيق':Added, #1: 1	عِتْقَ رَقِيقٍ
u'عتق رَقيقٌ':Added, #1: 1	عِتْقَ رَقِيقٍ
u'عتق رَقيقٌ':Added, #1: 1	عِتْقَ رَقِيقِهِ
u'عتق رَقيق':Added, #1: 1	عِتْقُ رَقِيقِهِ
u'عتق رَقيق':Added, #1: 1	عِتْقَ رَقِيقِهِ
u'عِتْقٌ رَقيقٌ':Added, #1: 1	عِتْقُ رَقِيقِهِ
u'عِتْقٌ رَقيقٌ':Added, #1: 1	عِتْقَ رَقِيقِهِ
u'عِتْقٌ رَقيق':Added, #1: 1	عِتْقُ رَقِيقِهِ
u'عِتْقٌ رَقيق':Added, #1: 1	عِتْقَ رَقِيقِهِ
u'عتق رَقيقٌ':Added, #1: 1	عِتْقُ رَقِيقِهِ
u'عتق رَقيق':Added, #2: 2	عِتْقِ رَقِيقٍ
u'عِتْقٌ رَقيقٌ':Added, #2: 2	عِتْقِ رَقِيقٍ
u'عِتْقٌ رَقيق':Added, #2: 2	عِتْقِ رَقِيقٍ
u'عتق رَهْنٌ':Added, #2: 2	عِتْقِ رَقِيقٍ
u'عتق رَهْنٌ':Added, #1: 1	عِتْقُ الرَّهْنِ
u'عِتْقٌ رَهْنٌ':Added, #1: 1	عِتْقِ الرَّهْنِ
u'عِتْقٌ رَهْنٌ':Added, #1: 1	عِتْقُ الرَّهْنِ
u'عتق زَوْجَةٌ':Added, #1: 1	عِتْقِ الرَّهْنِ
u'عِتْقٌ زَوْجَةٌ':Added, #1: 1	عِتْقُ الزَّوْجَةِ
u'عَتَقَ سَاعَةٌ':Predicate, #1: 1	عِتْقُ الزَّوْجَةِ
u'عَتَقَ سَاعَةٌ':Predicate, #1: 1	عَتَقَ السَّاعَةَ
u'عَتَقَ سَالِمٌ':Subject, #1: 1	عَتَقَ سَاعَةَ
u'عَتَقَ سَالِمٌ':Subject, #13: 13	عَتَقَ سَالِمٌ
u'عتق سَالِمٌ':Added, #1: 1	عَتَقَ سَالِمُ
u'عِتْقٌ سَالِمٌ':Added, #2: 2	عِتْقَ سَالِمٍ
u'عتق سَالِمٌ':Added, #2: 2	عِتْقَ سَالِمٍ
u'عِتْقٌ سَالِمٌ':Added, #6: 6	عِتْقِ سَالِمٍ
u'عتق سَائِبٌ':Added, #6: 6	عِتْقِ سَالِمٍ
u'عتق سَائِبٌ':Added, #1: 1	عِتْقَ السَّائِبَةِ
u'عِتْقٌ سَائِبٌ':Added, #1: 1	عِتْقِ السَّائِبَةِ
u'عِتْقٌ سَائِبٌ':Added, #1: 1	عِتْقَ السَّائِبَةِ
u'عَتَقَ سَبْعَةٌ':Subject, #1: 1	عِتْقِ السَّائِبَةِ
u'عتق سَفِيهٌ':Added, #1: 1	عَتَقَ سَبْعَةٌ
u'عِتْقٌ سَفِيهٌ':Added, #1: 1	عِتْقُ السَّفِيهِ
u'عتق سَفِيهٌ':Added, #1: 1	عِتْقُ السَّفِيهِ
u'عِتْقٌ سَفِيهٌ':Added, #3: 3	عِتْقِ السَّفِيهِ
u'عتق سَكْرَان':Added, #3: 3	عِتْقِ السَّفِيهِ
u'عِتْقٌ سَكْرَان':Added, #1: 1	عِتْقِ السَّكْرَانِ
u'عَتَقَ سَواءٌ':Subject, #1: 1	عِتْقِ السَّكْرَانِ
u'عتق سُودانُ':Added, #3: 3	عَتَقَ سَوَاءٌ
u'عِتْقٌ سُودانُ':Added, #1: 1	عِتْقَ السُّودَانِ
u'عَتَقَ سَيِّدٌ':Subject, #1: 1	عِتْقَ السُّودَانِ
u'عَتَقَ سَيِّدٌ':Subject, #1: 1	عَتَقَ السَّيِّدُ
u'عتق سَيِّدٌ':Added, #1: 1	عَتَقَ سَيِّدُهُ
u'عِتْقٌ سَيِّدٌ':Added, #1: 1	عِتْقَ السَّيِّدِ
u'عتق سَيِّدٌ':Added, #1: 1	عِتْقَ السَّيِّدِ
u'عتق سَيِّدٌ':Added, #3: 3	عِتْقُ السَّيِّدِ
u'عِتْقٌ سَيِّدٌ':Added, #3: 3	عِتْقِ السَّيِّدِ
u'عِتْقٌ سَيِّدٌ':Added, #3: 3	عِتْقُ السَّيِّدِ
u'عتق شركاء':Added, #3: 3	عِتْقِ السَّيِّدِ
u'عِتْقٌ شركاء':Added, #1: 1	عِتْقِ الشُّرَكَاءِ
u'عتق شَرِيكٌ':Added, #1: 1	عِتْقِ الشُّرَكَاءِ
u'عِتْقٌ شَرِيكٌ':Added, #1: 1	عِتْقُ الشَّرِيكِ
u'عتق شَرِيكٌ':Added, #1: 1	عِتْقُ الشَّرِيكِ
u'عِتْقٌ شَرِيكٌ':Added, #1: 1	عِتْقِ شَرِيكِهِ
u'عتق شَرِيكٌ':Added, #1: 1	عِتْقِ شَرِيكِهِ
u'عِتْقٌ شَرِيكٌ':Added, #4: 4	عِتْقِ الشَّرِيكِ
u'عتق شَيْءٌ':Added, #4: 4	عِتْقِ الشَّرِيكِ
u'عِتْقٌ شَيْءٌ':Added, #2: 2	عِتْقَ شَيْءٍ
u'عتق صَاحِبٌ':Added, #2: 2	عِتْقَ شَيْءٍ
u'عِتْقٌ صَاحِبٌ':Added, #1: 1	عِتْقَ صَاحِبِهِ
u'عتق صَاحِبٌ':Added, #1: 1	عِتْقَ صَاحِبِهِ
u'عِتْقٌ صَاحِبٌ':Added, #2: 2	عِتْقِ صَاحِبِهِ
u'عتق صَبِيٌّ':Added, #2: 2	عِتْقِ صَاحِبِهِ
u'عِتْقٌ صَبِيٌّ':Added, #1: 1	عِتْقِ الصَّبِيِّ
u'عتق صَبِيٌّ':Added, #1: 1	عِتْقِ الصَّبِيِّ
u'عِتْقٌ صَبِيٌّ':Added, #1: 1	عِتْقُ صَبِيٍّ
u'عتق صَبِيٌّ':Added, #1: 1	عِتْقُ صَبِيٍّ
u'عِتْقٌ صَبِيٌّ':Added, #3: 3	عِتْقُ الصَّبِيِّ
u'عَتَقَ صَغِيرٌ':Subject, #3: 3	عِتْقُ الصَّبِيِّ
u'عتق صَغِيرٌ':Added, #1: 1	عَتَقَ الصَّغِيرُ
u'عِتْقٌ صَغِيرٌ':Added, #3: 3	عِتْقُ الصَّغِيرِ
u'عتق ضَعِيفٌ':Added, #3: 3	عِتْقُ الصَّغِيرِ
u'عِتْقٌ ضَعِيفٌ':Added, #1: 1	عِتْقِ الضَّعِيفِ
u'عتق طِفْلٌ':Added, #1: 1	عِتْقِ الضَّعِيفِ
u'عِتْقٌ طِفْلٌ':Added, #1: 1	عِتْقُ الطِّفْلِ
u'عَتَقَ طَيْرٌ':Subject, #1: 1	عِتْقُ الطِّفْلِ
u'عتق طَيْرٌ':Added, #1: 1	عَتَقَ الطَّيْرُ
u'عِتْقٌ طَيْرٌ':Added, #1: 1	عِتْقِ الطَّيْرِ
u'عتق ظهار':Added, #1: 1	عِتْقِ الطَّيْرِ
u'عتق ظهار':Added, #1: 1	عِتْقُ الظِّهَارِ
u'عِتْقٌ ظهار':Added, #1: 1	عِتْقِ الظِّهَارِ
u'عِتْقٌ ظهار':Added, #1: 1	عِتْقُ الظِّهَارِ
u'عتق ظهار':Added, #1: 1	عِتْقِ الظِّهَارِ
u'عِتْقٌ ظهار':Added, #2: 2	عِتْقُ ظِهَارٍ
u'عَتَقَ عَبْدٌ':Predicate, #2: 2	عِتْقُ ظِهَارٍ
u'عَتَقَ عَبْدٌ':Subject, #2: 2	عَتَقَ الْعَبْدَ
u'عَتَقَ عَبْدٌ':Subject, #100: 100	عَتَقَ الْعَبْدُ
u'عَتَقَ عَبْدٌ':Subject, #13: 13	عَتَقَ عَبْدُهُ
u'عتق عَبْدٌ':Added, #5: 5	عَتَقَ عَبْدٌ
u'عِتْقٌ عَبْدٌ':Added, #10: 10	عِتْقُ الْعَبْدِ
u'عتق عَبْدٌ':Added, #10: 10	عِتْقُ الْعَبْدِ
u'عِتْقٌ عَبْدٌ':Added, #11: 11	عِتْقَ عَبْدٍ
u'عتق عَبْدٌ':Added, #11: 11	عِتْقَ عَبْدٍ
u'عِتْقٌ عَبْدٌ':Added, #12: 12	عِتْقِ عَبْدٍ
u'عتق عَبْدٌ':Added, #12: 12	عِتْقِ عَبْدٍ
u'عِتْقٌ عَبْدٌ':Added, #14: 14	عِتْقِ عَبْدِهِ
u'عتق عَبْدٌ':Added, #14: 14	عِتْقِ عَبْدِهِ
u'عِتْقٌ عَبْدٌ':Added, #1: 1	عِتْقِ الْعَبْدَيْنِ
u'عتق عَبْدٌ':Added, #1: 1	عِتْقِ الْعَبْدَيْنِ
u'عِتْقٌ عَبْدٌ':Added, #1: 1	عِتْقُ عَبْدَيْنِ
u'عتق عَبْدٌ':Added, #1: 1	عِتْقُ عَبْدَيْنِ
u'عتق عَبْدٌ':Added, #2: 2	عِتْقُ عَبْدِ
u'عِتْقٌ عَبْدٌ':Added, #2: 2	عِتْقِ عَبْدِ
u'عِتْقٌ عَبْدٌ':Added, #2: 2	عِتْقُ عَبْدِ
u'عتق عَبْدٌ':Added, #2: 2	عِتْقِ عَبْدِ
u'عِتْقٌ عَبْدٌ':Added, #36: 36	عِتْقِ الْعَبْدِ
u'عتق عَبْدٌ':Added, #36: 36	عِتْقِ الْعَبْدِ
u'عِتْقٌ عَبْدٌ':Added, #38: 38	عِتْقَ عَبْدِهِ
u'عتق عَبْدٌ':Added, #38: 38	عِتْقَ عَبْدِهِ
u'عِتْقٌ عَبْدٌ':Added, #3: 3	عِتْقَ عَبْدِ
u'عتق عَبْدٌ':Added, #3: 3	عِتْقَ عَبْدِ
u'عِتْقٌ عَبْدٌ':Added, #5: 5	عِتْقُ عَبْدٍ
u'عتق عَبْدٌ':Added, #5: 5	عِتْقُ عَبْدٍ
u'عِتْقٌ عَبْدٌ':Added, #5: 5	عِتْقُ عَبْدِهِ
u'عتق عَبْدٌ':Added, #5: 5	عِتْقُ عَبْدِهِ
u'عِتْقٌ عَبْدٌ':Added, #8: 8	عِتْقَ الْعَبْدِ
u'عَتَقَ عَبِيدٌ':Subject, #8: 8	عِتْقَ الْعَبْدِ
u'عَتَقَ عَبِيدٌ':Subject, #1: 1	عَتَقَ الْعَبِيدُ
u'عتق عَبِيدٌ':Added, #3: 3	عَتَقَ عَبِيدُهُ
u'عتق عَبِيدٌ':Added, #1: 1	عِتْقُ الْعَبِيدِ
u'عِتْقٌ عَبِيدٌ':Added, #1: 1	عِتْقِ الْعَبِيدِ
u'عِتْقٌ عَبِيدٌ':Added, #1: 1	عِتْقُ الْعَبِيدِ
u'عتق عَبِيدٌ':Added, #1: 1	عِتْقِ الْعَبِيدِ
u'عِتْقٌ عَبِيدٌ':Added, #1: 1	عِتْقَ عَبِيدِهِ
u'عَتَقَ عَجَمِيٌّ':Subject, #1: 1	عِتْقَ عَبِيدِهِ
u'عتق عُضْوٌ':Added, #1: 1	عَتَقَ الْعَجَمِيُّ
u'عِتْقٌ عُضْوٌ':Added, #1: 1	عِتْقِ عُضْوٍ
u'عَتَقَ عند':Predicate, #1: 1	عِتْقِ عُضْوٍ
u'عتق غَاصِبٌ':Added, #15: 15	عَتَقَ عِنْدَ
u'عِتْقٌ غَاصِبٌ':Added, #1: 1	عِتْقَ الْغَاصِبِ
u'عَتَقَ غانِم':Subject, #1: 1	عِتْقَ الْغَاصِبِ
u'عتق غانِم':Added, #7: 7	عَتَقَ غَانِمٌ
u'عِتْقٌ غانِم':Added, #2: 2	عِتْقُ غَانِمٍ
u'عتق غانِم':Added, #2: 2	عِتْقُ غَانِمٍ
u'عِتْقٌ غانِم':Added, #8: 8	عِتْقِ غَانِمٍ
u'عَتَقَ غَائِبٌ':Subject, #8: 8	عِتْقِ غَانِمٍ
u'عتق غَائِبٌ':Added, #2: 2	عَتَقَ الْغَائِبُ
u'عِتْقٌ غَائِبٌ':Added, #2: 2	عِتْقَ الْغَائِبِ
u'عَتَقَ غُلاَمٌ':Subject, #2: 2	عِتْقَ الْغَائِبِ
u'عتق غُلاَمٌ':Added, #9: 9	عَتَقَ الْغُلَامُ
u'عتق غُلاَمٌ':Added, #1: 1	عِتْقَ الْغُلَامِ
u'عِتْقٌ غُلاَمٌ':Added, #1: 1	عِتْقِ الْغُلَامِ
u'عِتْقٌ غُلاَمٌ':Added, #1: 1	عِتْقَ الْغُلَامِ
u'عَتَقَ غير':Subject, #1: 1	عِتْقِ الْغُلَامِ
u'عَتَقَ غَيْرٌ':Subject, #1: 1	عَتَقَ غَيْرُ
u'عتق غير':Added, #1: 1	عَتَقَ غَيْرُ
u'عتق غير':Added, #1: 1	عِتْقَ غَيْرِ
u'عتق غير':Added, #1: 1	عِتْقُ غَيْرِ
u'عتق غَيْرٌ':Added, #1: 1	عِتْقِ غَيْرِ
u'عتق غَيْرٌ':Added, #1: 1	عِتْقَ غَيْرِ
u'عتق غَيْرٌ':Added, #1: 1	عِتْقُ غَيْرِ
u'عتق غَيْرٌ':Added, #1: 1	عِتْقِ غَيْرٍ
u'عِتْقٌ غير':Added, #1: 1	عِتْقِ غَيْرِ
u'عِتْقٌ غير':Added, #1: 1	عِتْقَ غَيْرِ
u'عِتْقٌ غير':Added, #1: 1	عِتْقُ غَيْرِ
u'عِتْقٌ غَيْرٌ':Added, #1: 1	عِتْقِ غَيْرِ
u'عِتْقٌ غَيْرٌ':Added, #1: 1	عِتْقَ غَيْرِ
u'عِتْقٌ غَيْرٌ':Added, #1: 1	عِتْقُ غَيْرِ
u'عِتْقٌ غَيْرٌ':Added, #1: 1	عِتْقِ غَيْرٍ
u'عتق غير':Added, #1: 1	عِتْقِ غَيْرِ
u'عتق غَيْرٌ':Added, #2: 2	عِتْقُ الْغَيْرِ
u'عِتْقٌ غير':Added, #2: 2	عِتْقُ الْغَيْرِ
u'عِتْقٌ غَيْرٌ':Added, #2: 2	عِتْقُ الْغَيْرِ
u'عتق غير':Added, #2: 2	عِتْقُ الْغَيْرِ
u'عتق غَيْرٌ':Added, #2: 2	عِتْقُ غَيْرِهِ
u'عِتْقٌ غير':Added, #2: 2	عِتْقُ غَيْرِهِ
u'عِتْقٌ غَيْرٌ':Added, #2: 2	عِتْقُ غَيْرِهِ
u'عَتَقَ فَرْخٌ':Subject, #2: 2	عِتْقُ غَيْرِهِ
u'عتق فَرْعٌ':Added, #2: 2	عَتَقَ الْفَرْخُ
u'عِتْقٌ فَرْعٌ':Added, #1: 1	عِتْقَ الْفَرْعِ
u'عَتَقَ فُلاَنٌ':Subject, #1: 1	عِتْقَ الْفَرْعِ
u'عَتَقَ فلان':Subject, #1: 1	عَتَقَ فُلَانٌ
u'عتق فُلاَنٌ':Added, #7: 7	عَتَقَ غَانِمٌ
u'عِتْقٌ فُلاَنٌ':Added, #1: 1	عِتْقَ فُلَانٍ
u'عتق فلان':Added, #1: 1	عِتْقَ فُلَانٍ
u'عِتْقٌ فلان':Added, #2: 2	عِتْقُ غَانِمٍ
u'عتق فلان':Added, #2: 2	عِتْقُ غَانِمٍ
u'عِتْقٌ فلان':Added, #8: 8	عِتْقِ غَانِمٍ
u'عَتَقَ قَابِلٌ':Subject, #8: 8	عِتْقِ غَانِمٍ
u'عَتَقَ قَاتِلٌ':Subject, #2: 2	عَتَقَ الْقَابِلُ
u'عتق قارِع':Added, #1: 1	عَتَقَ الْقَاتِلُ
u'عِتْقٌ قارِع':Added, #1: 1	عِتْقِ الْقَارِعِ
u'عَتَقَ قَالٌ':Predicate, #1: 1	عِتْقِ الْقَارِعِ
u'عِتْقٌ قَائِمٌ':Added, #2: 2	عَتَقَ قَالَ
u'عَتَقَ قَدْرٌ':Subject, #1: 1	عِتْقٍ قَائِمٍ
u'عَتَقَ قَدْرٌ':Subject, #1: 1	عَتَقَ الْقَدْرُ
u'عَتَقَ قَدْرٌ':Subject, #1: 1	عَتَقَ قَدْرُ
u'عتق قَرَابَةٌ':Added, #3: 3	عَتَقَ قَدْرُهُ
u'عِتْقٌ قَرَابَةٌ':Added, #1: 1	عِتْقُ الْقَرَابَةِ
u'عَتَقَ قَرِيبٌ':Subject, #1: 1	عِتْقُ الْقَرَابَةِ
u'عَتَقَ قَرِيبٌ':Subject, #1: 1	عَتَقَ قَرِيبُهُ
u'عتق قَرِيبٌ':Added, #3: 3	عَتَقَ الْقَرِيبُ
u'عِتْقٌ قَرِيبٌ':Added, #1: 1	عِتْقَ الْقَرِيبِ
u'عتق قَرِيبٌ':Added, #1: 1	عِتْقَ الْقَرِيبِ
u'عِتْقٌ قَرِيبٌ':Added, #2: 2	عِتْقِ قَرِيبِ
u'عتق قَرِيبٌ':Added, #2: 2	عِتْقِ قَرِيبِ
u'عِتْقٌ قَرِيبٌ':Added, #5: 5	عِتْقِ الْقَرِيبِ
u'عَتَقَ قِنٌّ':Subject, #5: 5	عِتْقِ الْقَرِيبِ
u'عتق قِنٌّ':Added, #2: 2	عَتَقَ الْقِنُّ
u'عِتْقٌ قِنٌّ':Added, #1: 1	عِتْقِ الْقِنِّ
u'عَتَقَ قِيمَةٌ':Subject, #1: 1	عِتْقِ الْقِنِّ
u'عتق كَافِرٌ':Added, #1: 1	عَتَقَ قِيمَةُ
u'عِتْقٌ كَافِرٌ':Added, #1: 1	عِتْقِ الْكَافِرِ
u'عتق كَافِرٌ':Added, #1: 1	عِتْقِ الْكَافِرِ
u'عِتْقٌ كَافِرٌ':Added, #1: 1	عِتْقُ كَافِرٍ
u'عَتَقَ كَامِلٌ':Subject, #1: 1	عِتْقُ كَافِرٍ
u'عتق كَفَّارٌ':Added, #1: 1	عَتَقَ الْكَامِلُ
u'عِتْقٌ كَفَّارٌ':Added, #1: 1	عِتْقِ الْكَفَّارَاتِ
u'عتق كَفَّارٌ':Added, #1: 1	عِتْقِ الْكَفَّارَاتِ
u'عِتْقٌ كَفَّارٌ':Added, #1: 1	عِتْقَ كَفَّارَتِهِ
u'عتق كَفَّارٌ':Added, #1: 1	عِتْقَ كَفَّارَتِهِ
u'عِتْقٌ كَفَّارٌ':Added, #2: 2	عِتْقِ كَفَّارَةِ
u'عتق كَفَّارَةٌ':Added, #2: 2	عِتْقِ كَفَّارَةِ
u'عِتْقٌ كَفَّارَةٌ':Added, #1: 1	عِتْقِ الْكَفَّارَاتِ
u'عتق كَفَّارَةٌ':Added, #1: 1	عِتْقِ الْكَفَّارَاتِ
u'عِتْقٌ كَفَّارَةٌ':Added, #1: 1	عِتْقَ كَفَّارَتِهِ
u'عتق كَفَّارَةٌ':Added, #1: 1	عِتْقَ كَفَّارَتِهِ
u'عِتْقٌ كَفَّارَةٌ':Added, #2: 2	عِتْقِ كَفَّارَةِ
u'عتق مُبْتاع':Added, #2: 2	عِتْقِ كَفَّارَةِ
u'عِتْقٌ مُبْتاع':Added, #2: 2	عِتْقِ الْمُبْتَاعِ
u'عتق مُتَقَدِّمٌ':Added, #2: 2	عِتْقِ الْمُبْتَاعِ
u'عِتْقٌ مُتَقَدِّمٌ':Added, #1: 1	عِتْقُ الْمُتَقَدِّمَةِ
u'عَتَقَ مثل':Subject, #1: 1	عِتْقُ الْمُتَقَدِّمَةِ
u'عَتَقَ مِثْلٌ':Subject, #1: 1	عَتَقَ مِثْلُهُ
u'عتق مثل':Added, #1: 1	عَتَقَ مِثْلُهُ
u'عِتْقٌ مثل':Added, #4: 4	عِتْقِ مِثْلِهِ
u'عتق مِثْلٌ':Added, #4: 4	عِتْقِ مِثْلِهِ
u'عِتْقٌ مِثْلٌ':Added, #4: 4	عِتْقِ مِثْلِهِ
u'عَتَقَ مَجْرُوحٌ':Subject, #4: 4	عِتْقِ مِثْلِهِ
u'عتق مَجْنُونٌ':Added, #1: 1	عَتَقَ الْمَجْرُوحُ
u'عتق مَجْنُونٌ':Added, #1: 1	عِتْقُ الْمَجْنُونِ
u'عِتْقٌ مَجْنُونٌ':Added, #1: 1	عِتْقِ الْمَجْنُونِ
u'عِتْقٌ مَجْنُونٌ':Added, #1: 1	عِتْقُ الْمَجْنُونِ
u'عتق مَحْجُورٌ':Added, #1: 1	عِتْقِ الْمَجْنُونِ
u'عِتْقٌ مَحْجُورٌ':Added, #1: 1	عِتْقِ مَحْجُورٍ
u'عتق مَحْجُورٌ':Added, #1: 1	عِتْقِ مَحْجُورٍ
u'عِتْقٌ مَحْجُورٌ':Added, #2: 2	عِتْقِ الْمَحْجُورِ
u'عتق مَحْرَمٌ':Added, #2: 2	عِتْقِ الْمَحْجُورِ
u'عِتْقٌ مَحْرَمٌ':Added, #1: 1	عِتْقُ الْمَحْرَمِ
u'عتق مَحَلٌّ':Added, #1: 1	عِتْقُ الْمَحْرَمِ
u'عِتْقٌ مَحَلٌّ':Added, #1: 1	عِتْقُ الْمَحَلِّ
u'عَتَقَ مَحْمَلٌ':Subject, #1: 1	عِتْقُ الْمَحَلِّ
u'عتق مَحْمَلٌ':Added, #1: 1	عَتَقَ مَحْمَلُهُ
u'عتق مَحْمَلٌ':Added, #1: 1	عِتْقُ مَحْمَلِ
u'عِتْقٌ مَحْمَلٌ':Added, #1: 1	عِتْقِ مَحْمَلِ
u'عِتْقٌ مَحْمَلٌ':Added, #1: 1	عِتْقُ مَحْمَلِ
u'عَتَقَ مُخَاطَبٌ':Subject, #1: 1	عِتْقِ مَحْمَلِ
u'عتق مُخْطِئٌ':Added, #1: 1	عَتَقَ الْمُخَاطَبُ
u'عِتْقٌ مُخْطِئٌ':Added, #1: 1	عِتْقِ الْمُخْطِئِ
u'عَتَقَ مُدَبَّرٌ':Subject, #1: 1	عِتْقِ الْمُخْطِئِ
u'عَتَقَ مُدَبَّرٌ':Subject, #19: 19	عَتَقَ الْمُدَبَّرُ
u'عتق مُدَبَّرٌ':Added, #2: 2	عَتَقَ مُدَبَّرُهُ
u'عِتْقٌ مُدَبَّرٌ':Added, #1: 1	عِتْقَ الْمُدَبَّرِ
u'عتق مُدَبَّرٌ':Added, #1: 1	عِتْقَ الْمُدَبَّرِ
u'عِتْقٌ مُدَبَّرٌ':Added, #1: 1	عِتْقِ مُدَبَّرٍ
u'عتق مُدَبَّرٌ':Added, #1: 1	عِتْقِ مُدَبَّرٍ
u'عِتْقٌ مُدَبَّرٌ':Added, #1: 1	عِتْقَ مُدَبَّرِهِ
u'عتق مُدَبَّرٌ':Added, #1: 1	عِتْقَ مُدَبَّرِهِ
u'عِتْقٌ مُدَبَّرٌ':Added, #3: 3	عِتْقِ الْمُدَبَّرِ
u'عتق مُدَبَّرٌ':Added, #3: 3	عِتْقِ الْمُدَبَّرِ
u'عِتْقٌ مُدَبَّرٌ':Added, #6: 6	عِتْقُ الْمُدَبَّرِ
u'عتق مِدْيَانٌ':Added, #6: 6	عِتْقُ الْمُدَبَّرِ
u'عِتْقٌ مِدْيَانٌ':Added, #1: 1	عِتْقَ الْمِدْيَانِ
u'عتق مُرْتَدٌّ':Added, #1: 1	عِتْقَ الْمِدْيَانِ
u'عِتْقٌ مُرْتَدٌّ':Added, #1: 1	عِتْقُ الْمُرْتَدِّ
u'عَتَقَ مُرْسِلٌ':Subject, #1: 1	عِتْقُ الْمُرْتَدِّ
u'عتق مَرْهُونٌ':Added, #1: 1	عَتَقَ الْمُرْسِلُ
u'عتق مَرْهُونٌ':Added, #1: 1	عِتْقَ مَرْهُونٍ
u'عِتْقٌ مَرْهُونٌ':Added, #1: 1	عِتْقَ مَرْهُونِ
u'عِتْقٌ مَرْهُونٌ':Added, #1: 1	عِتْقَ مَرْهُونٍ
u'عتق مَرْهُونٌ':Added, #1: 1	عِتْقَ مَرْهُونِ
u'عِتْقٌ مَرْهُونٌ':Added, #2: 2	عِتْقَ الْمَرْهُونِ
u'عتق مَرْهُونٌ':Added, #2: 2	عِتْقَ الْمَرْهُونِ
u'عتق مَرْهُونٌ':Added, #4: 4	عِتْقُ الْمَرْهُونِ
u'عِتْقٌ مَرْهُونٌ':Added, #4: 4	عِتْقِ الْمَرْهُونِ
u'عِتْقٌ مَرْهُونٌ':Added, #4: 4	عِتْقُ الْمَرْهُونِ
u'عتق مَرِيضٌ':Added, #4: 4	عِتْقِ الْمَرْهُونِ
u'عتق مَرِيضٌ':Added, #1: 1	عِتْقَ الْمَرِيضِ
u'عِتْقٌ مَرِيضٌ':Added, #1: 1	عِتْقِ الْمَرِيضِ
u'عِتْقٌ مَرِيضٌ':Added, #1: 1	عِتْقَ الْمَرِيضِ
u'عتق مُسْتَأْجِرٌ':Added, #1: 1	عِتْقِ الْمَرِيضِ
u'عِتْقٌ مُسْتَأْجِرٌ':Added, #1: 1	عِتْقُ الْمُسْتَأْجِرِ
u'عتق مُسْلِمٌ':Added, #1: 1	عِتْقُ الْمُسْتَأْجِرِ
u'عِتْقٌ مُسْلِمٌ':Added, #1: 1	عِتْقِ الْمُسْلِمِ
u'عتق مُسْلِمٌ':Added, #1: 1	عِتْقِ الْمُسْلِمِ
u'عِتْقٌ مُسْلِمٌ':Added, #1: 1	عِتْقِ مُسْلِمٍ
u'عتق مُشْكِلٌ':Added, #1: 1	عِتْقِ مُسْلِمٍ
u'عِتْقٌ مُشْكِلٌ':Added, #1: 1	عِتْقِ مُشْكِلٍ
u'عَتَقَ مَضْرُوبٌ':Subject, #1: 1	عِتْقِ مُشْكِلٍ
u'عِتْقٌ مُطْلَقٌ':Added, #1: 1	عَتَقَ الْمَضْرُوبُ
u'عتق مَطْلُوبٌ':Added, #1: 1	عِتْقٍ مُطْلَقٍ
u'عِتْقٌ مَطْلُوبٌ':Added, #1: 1	عِتْقُ الْمَطْلُوبِ
u'عتق مُعْتَقٌ':Added, #1: 1	عِتْقُ الْمَطْلُوبِ
u'عتق مُعْتَقٌ':Added, #1: 1	عِتْقُ الْمُعْتَقِ
u'عِتْقٌ مُعْتَقٌ':Added, #1: 1	عِتْقِ الْمُعْتَقِ
u'عِتْقٌ مُعْتَقٌ':Added, #1: 1	عِتْقُ الْمُعْتَقِ
u'عتق مُعْسِرٌ':Added, #1: 1	عِتْقِ الْمُعْتَقِ
u'عِتْقٌ مُعْسِرٌ':Added, #1: 1	عِتْقِ الْمُعْسِرِ
u'عتق مُعْسِرٌ':Added, #1: 1	عِتْقِ الْمُعْسِرِ
u'عِتْقٌ مُعْسِرٌ':Added, #2: 2	عِتْقُ الْمُعْسِرِ
u'عتق مُعْسِرٌ':Added, #2: 2	عِتْقُ الْمُعْسِرِ
u'عِتْقٌ مُعْسِرٌ':Added, #3: 3	عِتْقُ مُعْسِرٍ
u'عتق مُعَلَّقٌ':Added, #3: 3	عِتْقُ مُعْسِرٍ
u'عِتْقٌ مُعَلَّقٌ':Added, #2: 2	عِتْقِ الْمُعَلَّقِ
u'عتق مَعْلُومٌ':Added, #2: 2	عِتْقِ الْمُعَلَّقِ
u'عِتْقٌ مَعْلُومٌ':Added, #1: 1	عِتْقُ مَعْلُومَةٍ
u'عَتَقَ مُعَيَّنٌ':Subject, #1: 1	عِتْقُ مَعْلُومَةٍ
u'عِتْقٌ مُعَيَّنٌ':Added, #1: 1	عَتَقَ الْمُعَيَّنُ
u'عتق مَغْصُوب':Added, #1: 1	عِتْقٍ مُعَيَّنٍ
u'عِتْقٌ مَغْصُوب':Added, #4: 4	عِتْقُ الْمَغْصُوبِ
u'عتق مُفْلِسٌ':Added, #4: 4	عِتْقُ الْمَغْصُوبِ
u'عِتْقٌ مُفْلِسٌ':Added, #1: 1	عِتْقُ الْمُفْلِسِ
u'عتق مُفْلِسٌ':Added, #1: 1	عِتْقُ الْمُفْلِسِ
u'عِتْقٌ مُفْلِسٌ':Added, #1: 1	عِتْقِ مُفْلِسٍ
u'عتق مَقْتُولٌ':Added, #1: 1	عِتْقِ مُفْلِسٍ
u'عِتْقٌ مَقْتُولٌ':Added, #2: 2	عِتْقَ الْمَقْتُولِ
u'عتق مُكَلَّفٌ':Added, #2: 2	عِتْقَ الْمَقْتُولِ
u'عِتْقٌ مُكَلَّفٌ':Added, #1: 1	عِتْقُ الْمُكَلَّفِ
u'عَتَقَ مَلَكٌ':Predicate, #1: 1	عِتْقُ الْمُكَلَّفِ
u'عَتَقَ مِلْكٌ':Predicate, #1: 1	عَتَقَ مَلَكَ
u'عتق مَمَالِيكُ':Added, #1: 1	عَتَقَ مِلْكَ
u'عِتْقٌ مَمَالِيكُ':Added, #1: 1	عِتْقِ الْمَمَالِيكِ
u'عتق مَمَالِيكُ':Added, #1: 1	عِتْقِ الْمَمَالِيكِ
u'عِتْقٌ مَمَالِيكُ':Added, #1: 1	عِتْقُ مَمَالِيكِهِ
u'عَتَقَ مَمْلُوكٌ':Subject, #1: 1	عِتْقُ مَمَالِيكِهِ
u'عتق مَمْلُوكٌ':Added, #1: 1	عَتَقَ الْمَمْلُوكُ
u'عتق مَمْلُوكٌ':Added, #1: 1	عِتْقُ الْمَمْلُوكِ
u'عِتْقٌ مَمْلُوكٌ':Added, #1: 1	عِتْقِ الْمَمْلُوكِ
u'عِتْقٌ مَمْلُوكٌ':Added, #1: 1	عِتْقُ الْمَمْلُوكِ
u'عتق مَمْلُوكٌ':Added, #1: 1	عِتْقِ الْمَمْلُوكِ
u'عِتْقٌ مَمْلُوكٌ':Added, #2: 2	عِتْقَ مَمْلُوكِهِ
u'عتق مُمَيِّزٌ':Added, #2: 2	عِتْقَ مَمْلُوكِهِ
u'عِتْقٌ مُمَيِّزٌ':Added, #2: 2	عِتْقِ مُمَيِّزٍ
u'عتق مُمَيِّزٌ':Added, #2: 2	عِتْقِ مُمَيِّزٍ
u'عِتْقٌ مُمَيِّزٌ':Added, #4: 4	عِتْقِ الْمُمَيِّزِ
u'عتق مُوالاة':Added, #4: 4	عِتْقِ الْمُمَيِّزِ
u'عِتْقٌ مُوالاة':Added, #1: 1	عِتْقِ الْمُوَالَاةِ
u'عِتْقٌ مُؤَجَّلٌ':Added, #1: 1	عِتْقِ الْمُوَالَاةِ
u'عتق مَوْرُوثٌ':Added, #2: 2	عِتْقٍ مُؤَجَّلٍ
u'عِتْقٌ مَوْرُوثٌ':Added, #1: 1	عِتْقِ الْمَوْرُوثِ
u'عتق مُوسِرٌ':Added, #1: 1	عِتْقِ الْمَوْرُوثِ
u'عِتْقٌ مُوسِرٌ':Added, #1: 1	عِتْقِ الْمُوسِرِ
u'عتق مُوسِرٌ':Added, #1: 1	عِتْقِ الْمُوسِرِ
u'عِتْقٌ مُوسِرٌ':Added, #4: 4	عِتْقُ الْمُوسِرِ
u'عتق مَوْقُوفٌ':Added, #4: 4	عِتْقُ الْمُوسِرِ
u'عِتْقٌ مَوْقُوفٌ':Added, #1: 1	عِتْقُ مَوْقُوفٍ
u'عتق مُؤْمِنٌ':Added, #1: 1	عِتْقُ مَوْقُوفٍ
u'عِتْقٌ مُؤْمِنٌ':Added, #1: 1	عِتْقِ الْمُؤْمِنَةِ
u'عتق نَبِيٌّ':Added, #1: 1	عِتْقِ الْمُؤْمِنَةِ
u'عِتْقٌ نَبِيٌّ':Added, #1: 1	عِتْقِ النَّبِيِّ
u'عتق نسمة':Added, #1: 1	عِتْقِ النَّبِيِّ
u'عِتْقٌ نسمة':Added, #4: 4	عِتْقُ النَّسَمَةِ
u'عتق نَسَمَةٌ':Added, #4: 4	عِتْقُ النَّسَمَةِ
u'عِتْقٌ نَسَمَةٌ':Added, #4: 4	عِتْقُ النَّسَمَةِ
u'عتق نسمة':Added, #4: 4	عِتْقُ النَّسَمَةِ
u'عِتْقٌ نسمة':Added, #5: 5	عِتْقُ نَسَمَةٍ
u'عتق نَسَمَةٌ':Added, #5: 5	عِتْقُ نَسَمَةٍ
u'عِتْقٌ نَسَمَةٌ':Added, #5: 5	عِتْقُ نَسَمَةٍ
u'عَتَقَ نِصْفٌ':Subject, #5: 5	عِتْقُ نَسَمَةٍ
u'عَتَقَ نِصْفٌ':Subject, #19: 19	عَتَقَ نِصْفُ
u'عَتَقَ نِصْفٌ':Subject, #23: 23	عَتَقَ نِصْفُهُ
u'عتق نِصْفٌ':Added, #9: 9	عَتَقَ النِّصْفُ
u'عِتْقٌ نِصْفٌ':Added, #1: 1	عِتْقُ النِّصْفِ
u'عتق نِصْفٌ':Added, #1: 1	عِتْقُ النِّصْفِ
u'عِتْقٌ نِصْفٌ':Added, #1: 1	عِتْقِ نِصْفِ
u'عتق نِصْفٌ':Added, #1: 1	عِتْقِ نِصْفِ
u'عتق نِصْفٌ':Added, #1: 1	عِتْقُ نِصْفِهِ
u'عِتْقٌ نِصْفٌ':Added, #1: 1	عِتْقِ نِصْفِهِ
u'عِتْقٌ نِصْفٌ':Added, #1: 1	عِتْقُ نِصْفِهِ
u'عتق نِصْفٌ':Added, #1: 1	عِتْقِ نِصْفِهِ
u'عتق نِصْفٌ':Added, #3: 3	عِتْقَ النِّصْفِ
u'عِتْقٌ نِصْفٌ':Added, #3: 3	عِتْقِ النِّصْفِ
u'عِتْقٌ نِصْفٌ':Added, #3: 3	عِتْقَ النِّصْفِ
u'عَتَقَ نَصِيبٌ':Predicate, #3: 3	عِتْقِ النِّصْفِ
u'عَتَقَ نَصِيبٌ':Subject, #1: 1	عَتَقَ نَصِيبَ
u'عَتَقَ نَصِيبٌ':Subject, #31: 31	عَتَقَ نَصِيبُ
u'عتق نَصِيبٌ':Added, #39: 39	عَتَقَ نَصِيبُهُ
u'عِتْقٌ نَصِيبٌ':Added, #1: 1	عِتْقِ النَّصِيبِ
u'عتق نَصِيبٌ':Added, #1: 1	عِتْقِ النَّصِيبِ
u'عتق نَصِيبٌ':Added, #2: 2	عِتْقَ نَصِيبِ
u'عتق نَصِيبٌ':Added, #2: 2	عِتْقُ نَصِيبِ
u'عِتْقٌ نَصِيبٌ':Added, #2: 2	عِتْقِ نَصِيبِ
u'عِتْقٌ نَصِيبٌ':Added, #2: 2	عِتْقَ نَصِيبِ
u'عِتْقٌ نَصِيبٌ':Added, #2: 2	عِتْقُ نَصِيبِ
u'عتق نَصِيبٌ':Added, #2: 2	عِتْقِ نَصِيبِ
u'عِتْقٌ نَصِيبٌ':Added, #4: 4	عِتْقُ نَصِيبِهِ
u'عتق نَصِيبٌ':Added, #4: 4	عِتْقُ نَصِيبِهِ
u'عِتْقٌ نَصِيبٌ':Added, #5: 5	عِتْقِ نَصِيبِهِ
u'عتق نَصِيبٌ':Added, #5: 5	عِتْقِ نَصِيبِهِ
u'عِتْقٌ نَصِيبٌ':Added, #6: 6	عِتْقَ نَصِيبِهِ
u'عَتَقَ نَفَذٌ':Predicate, #6: 6	عِتْقَ نَصِيبِهِ
u'عتق نَفْسٌ':Added, #1: 1	عَتَقَ نَفَذَ
u'عِتْقٌ نَفْسٌ':Added, #1: 1	عِتْقُ نَفْسِهِ
u'عتق نَفْسٌ':Added, #1: 1	عِتْقُ نَفْسِهِ
u'عِتْقٌ نَفْسٌ':Added, #6: 6	عِتْقَ نَفْسِهِ
u'عتق هَازِلٌ':Added, #6: 6	عِتْقَ نَفْسِهِ
u'عِتْقٌ هَازِلٌ':Added, #1: 1	عِتْقُ الْهَازِلِ
u'عِتْقٌ وَاجِبٌ':Added, #1: 1	عِتْقُ الْهَازِلِ
u'عَتَقَ واحد':Subject, #1: 1	عِتْقٍ وَاجِبٍ
u'عَتَقَ وَاحِدٌ':Subject, #8: 8	عَتَقَ وَاحِدٌ
u'عتق واحد':Added, #8: 8	عَتَقَ وَاحِدٌ
u'عِتْقٌ واحد':Added, #1: 1	عِتْقِ الْوَاحِدِ
u'عتق وَاحِدٌ':Added, #1: 1	عِتْقِ الْوَاحِدِ
u'عِتْقٌ وَاحِدٌ':Added, #1: 1	عِتْقِ الْوَاحِدِ
u'عتق واحد':Added, #1: 1	عِتْقِ الْوَاحِدِ
u'عِتْقٌ واحد':Added, #1: 1	عِتْقُ وَاحِدٍ
u'عتق وَاحِدٌ':Added, #1: 1	عِتْقُ وَاحِدٍ
u'عِتْقٌ وَاحِدٌ':Added, #1: 1	عِتْقُ وَاحِدٍ
u'عتق واحد':Added, #1: 1	عِتْقُ وَاحِدٍ
u'عِتْقٌ واحد':Added, #2: 2	عِتْقَ وَاحِدٍ
u'عتق وَاحِدٌ':Added, #2: 2	عِتْقَ وَاحِدٍ
u'عِتْقٌ وَاحِدٌ':Added, #2: 2	عِتْقَ وَاحِدٍ
u'عتق وَارِثٌ':Added, #2: 2	عِتْقَ وَاحِدٍ
u'عتق وَارِثٌ':Added, #1: 1	عِتْقُ الْوَارِثِ
u'عِتْقٌ وَارِثٌ':Added, #1: 1	عِتْقِ الْوَارِثِ
u'عِتْقٌ وَارِثٌ':Added, #1: 1	عِتْقُ الْوَارِثِ
u'عَتَقَ وَالِدٌ':Subject, #1: 1	عِتْقِ الْوَارِثِ
u'عَتَقَ وَجَبٌ':Predicate, #1: 1	عَتَقَ الْوَالِدُ
u'عَتَقَ وَحْدٌ':Subject, #1: 1	عَتَقَ وَجَبَ
u'عتق وَرَثَةٌ':Added, #1: 1	عَتَقَ وَحْدُهُ
u'عتق وَرَثَةٌ':Added, #1: 1	عِتْقَ الْوَرَثَةِ
u'عِتْقٌ وَرَثَةٌ':Added, #1: 1	عِتْقُ الْوَرَثَةِ
u'عِتْقٌ وَرَثَةٌ':Added, #1: 1	عِتْقَ الْوَرَثَةِ
u'عِتْقٌ وصلة':Added, #1: 1	عِتْقُ الْوَرَثَةِ
u'عتق وَصِيٌّ':Added, #1: 1	عِتْقٍ وَصِلَةٍ
u'عِتْقٌ وَصِيٌّ':Added, #1: 1	عِتْقُ الْوَصِيِّ
u'عتق وَكِيلٌ':Added, #1: 1	عِتْقُ الْوَصِيِّ
u'عِتْقٌ وَكِيلٌ':Added, #1: 1	عِتْقُ الْوَكِيلِ
u'عَتَقَ ولد':Subject, #1: 1	عِتْقُ الْوَكِيلِ
u'عَتَقَ وَلَدٌ':Subject, #19: 19	عَتَقَ الْوَلَدُ
u'عَتَقَ ولد':Subject, #19: 19	عَتَقَ الْوَلَدُ
u'عَتَقَ وَلَدٌ':Subject, #2: 2	عَتَقَ وَلَدُ
u'عتق ولد':Added, #2: 2	عَتَقَ وَلَدُ
u'عِتْقٌ ولد':Added, #1: 1	عِتْقُ الْوَلَدِ
u'عتق وَلَدٌ':Added, #1: 1	عِتْقُ الْوَلَدِ
u'عِتْقٌ وَلَدٌ':Added, #1: 1	عِتْقُ الْوَلَدِ
u'عتق ولد':Added, #1: 1	عِتْقُ الْوَلَدِ
u'عِتْقٌ ولد':Added, #1: 1	عِتْقِ وَلَدِ
u'عتق وَلَدٌ':Added, #1: 1	عِتْقِ وَلَدِ
u'عِتْقٌ وَلَدٌ':Added, #1: 1	عِتْقِ وَلَدِ
u'عتق ولد':Added, #1: 1	عِتْقِ وَلَدِ
u'عِتْقٌ ولد':Added, #4: 4	عِتْقِ الْوَلَدِ
u'عتق وَلَدٌ':Added, #4: 4	عِتْقِ الْوَلَدِ
u'عِتْقٌ وَلَدٌ':Added, #4: 4	عِتْقِ الْوَلَدِ
u'عتق ولد':Added, #4: 4	عِتْقِ الْوَلَدِ
u'عِتْقٌ ولد':Added, #5: 5	عِتْقَ الْوَلَدِ
u'عتق وَلَدٌ':Added, #5: 5	عِتْقَ الْوَلَدِ
u'عِتْقٌ وَلَدٌ':Added, #5: 5	عِتْقَ الْوَلَدِ
u'عَتَقَ وَلَهٌ':Subject, #5: 5	عِتْقَ الْوَلَدِ
u'عَتَقَ وَلِيٌّ':Subject, #1: 1	عَتَقَ وَلَهُ
u'عَتَقَ يَوْمٌ':Predicate, #1: 1	عَتَقَ الْوَلِيُّ
u'عَتِهَ أَبٌ':Subject, #2: 2	عَتَقَ الْيَوْمَ
u'عَتِهَ رَجُلٌ':Subject, #1: 1	عَتِهَ الْأَبُ
u'عَثَرَ إِنْسانٌ':Subject, #1: 1	عَتِهَ الرَّجُلُ
u'عَثَرَ رَجُلٌ':Subject, #4: 4	عَثَرَ إنْسَانٌ
u'عَجِبَ إمَامٌ':Predicate, #5: 5	عَثَرَ رَجُلٌ
u'عَجَبٌ أيَّامٌ':Added, #1: 1	أَعْجَبَ الْإِمَامَ
u'عَجَبٌ أَيَّامٌ':Added, #1: 1	عَجَبِ الْأَيّامِ
u'عَجَبٌ دَهْرٌ':Added, #1: 1	عَجَبِ الْأَيّامِ
u'عَجِبَ رَسُولٌ':Predicate, #1: 1	عَجَبِ الدّهْرِ
u'عَجِبَ كُفَّارٌ':Predicate, #1: 1	أَعْجَبَ رَسُولَ
u'عَجِبَ نَبِيٌّ':Predicate, #1: 1	أَعْجَبَ الْكُفَّارَ
u'عَجَزَ أَبٌ':Subject, #1: 1	أَعْجَبَ النَّبِيَّ
u'عَجَزَ أَجِيرٌ':Subject, #2: 2	عَجَزَ الْأَبُ
u'عَجَزَ أحَدٌ':Subject, #1: 1	عَجَزَ الْأَجِيرُ
u'عجز أحَدٌ':Added, #1: 1	عَجَزَ أَحَدٌ
u'عَجْزٌ أحَدٌ':Added, #1: 1	عَجْزُ أَحَدِ
u'عَجَزَ أخرَس':Subject, #1: 1	عَجْزُ أَحَدِ
u'عَجَزَ اِسْتَناب':Predicate, #1: 1	عَجَزَ الْأَخْرَسُ
u'عَجَزَ أَصْحَابٌ':Subject, #1: 1	عَجَزَ اسْتَنَابَ
u'عجز أصل':Added, #1: 1	عَجَزَ أَصْحَابُ
u'عجز أًصْلٌ':Added, #2: 2	عَجْزِ الْأَصْلِ
u'عَجْزٌ أصل':Added, #2: 2	عَجْزِ الْأَصْلِ
u'عَجْزٌ أًصْلٌ':Added, #2: 2	عَجْزِ الْأَصْلِ
u'عَجَزَ أعْلَمُ':Predicate, #2: 2	عَجْزِ الْأَصْلِ
u'عجز الْمَرْءُ':Added, #1: 1	عَجَزَ أَعْلَمَ
u'عَجْزٌ الْمَرْءُ':Added, #1: 1	عَجْزِ الْمَرْءِ
u'عجز أُمٌّ':Added, #1: 1	عَجْزِ الْمَرْءِ
u'عَجْزٌ أُمٌّ':Added, #1: 1	عَجْزُ الْأُمِّ
u'عجز أُمٌّ':Added, #1: 1	عَجْزُ الْأُمِّ
u'عَجْزٌ أُمٌّ':Added, #2: 2	عَجْزِ الْأُمِّ
u'عَجَزَ إمَامٌ':Subject, #2: 2	عَجْزِ الْأُمِّ
u'عَجَزَ إمَامٌ':Subject, #2: 2	عَجَزَ الْإِمَامُ
u'عجز إمَامٌ':Added, #2: 2	عَجَزَ إمَامُهُ
u'عَجْزٌ إمَامٌ':Added, #1: 1	عَجْزُ إمَامِهِ
u'عجز إِنْسانٌ':Added, #1: 1	عَجْزُ إمَامِهِ
u'عَجْزٌ إِنْسانٌ':Added, #1: 1	عَجْزِ الْإِنْسَانِ
u'عَجَزَ أهْلٌ':Subject, #1: 1	عَجْزِ الْإِنْسَانِ
u'عَجَزَ أوْسَطُ':Subject, #3: 3	عَجَزَ أَهْلُ
u'عجز أوْسَطُ':Added, #1: 1	عَجَزَ الْأَوْسَطُ
u'عَجْزٌ أوْسَطُ':Added, #1: 1	عَجْزُ الْأَوْسَطِ
u'عَجَزَ أَوَّلُ':Subject, #1: 1	عَجْزُ الْأَوْسَطِ
u'عجز أَوَّلُ':Added, #5: 5	عَجَزَ الْأَوَّلُ
u'عَجْزٌ أَوَّلُ':Added, #1: 1	عَجْزِ الْأَوَّلِ
u'عَجَزَ بَانٌ':Predicate, #1: 1	عَجْزِ الْأَوَّلِ
u'عَجَزَ بَائِعٌ':Subject, #1: 1	عَجَزَ بَانَ
u'عجز بدن':Added, #3: 3	عَجَزَ الْبَائِعُ
u'عَجْزٌ بدن':Added, #1: 1	عَجْزِ الْبَدَنِ
u'عجز بَدَنٌ':Added, #1: 1	عَجْزِ الْبَدَنِ
u'عَجْزٌ بَدَنٌ':Added, #1: 1	عَجْزِ الْبَدَنِ
u'عَجَزَ بسط':Predicate, #1: 1	عَجْزِ الْبَدَنِ
u'عَجَزَ بَطَلٌ':Predicate, #1: 1	عَجَزَ بَسَطَ
u'عَجَزَ بَيْتٌ':Subject, #1: 1	عَجَزَ بَطَلَ
u'عَجَزَ بِيَعٌ':Predicate, #2: 2	عَجَزَ بَيْتُ
u'عجز حازِمٌ':Added, #3: 3	عَجَزَ بِيعَ
u'عَجْزٌ حازِمٌ':Added, #1: 1	عَجْزُ حَازِمِ
u'عَجَزَ حاضِرٌ':Subject, #1: 1	عَجْزُ حَازِمِ
u'عَجَزَ حَلٌّ':Predicate, #1: 1	عَجَزَ الْحَاضِرُ
u'عجز حِيلَةٌ':Added, #1: 1	عَجَزَ حَلَّ
u'عَجْزٌ حِيلَةٌ':Added, #1: 1	عَجْزِ الْحِيلَةِ
u'عَجَزَ خَطٌّ':Predicate, #1: 1	عَجْزِ الْحِيلَةِ
u'عجز خلق':Added, #3: 3	عَجَزَ خَطَّ
u'عَجْزٌ خلق':Added, #1: 1	عَجْزَ خَلْقِهِ
u'عجز خَلْقٌ':Added, #1: 1	عَجْزَ خَلْقِهِ
u'عَجْزٌ خَلْقٌ':Added, #1: 1	عَجْزَ خَلْقِهِ
u'عجز خلق':Added, #1: 1	عَجْزَ خَلْقِهِ
u'عَجْزٌ خلق':Added, #2: 2	عَجْزَ الْخَلْقِ
u'عجز خَلْقٌ':Added, #2: 2	عَجْزَ الْخَلْقِ
u'عَجْزٌ خَلْقٌ':Added, #2: 2	عَجْزَ الْخَلْقِ
u'عَجَزَ رَاكِعٌ':Subject, #2: 2	عَجْزَ الْخَلْقِ
u'عَجَزَ رَبُّ':Subject, #1: 1	عَجَزَ الرَّاكِعُ
u'عَجَزَ رَبُّ':Subject, #1: 1	عَجَزَ رَبُّ
u'عجز رَبُّ':Added, #1: 1	عَجَزَ رَبُّهُ
u'عَجْزٌ رَبُّ':Added, #1: 1	عَجْزُ رَبِّ
u'عجز رَدٌّ':Added, #1: 1	عَجْزُ رَبِّ
u'عَجْزٌ رَدٌّ':Added, #1: 1	عَجْزِ الرَّدِّ
u'عَجَزَ رَقٌّ':Predicate, #1: 1	عَجْزِ الرَّدِّ
u'عَجَزَ ركب':Predicate, #4: 4	عَجَزَ رَقَّ
u'عَجَزَ زَوْجٌ':Subject, #1: 1	عَجَزَ رَكِبَ
u'عَجَزَ زَوْجٌ':Subject, #1: 1	عَجَزَ الزَّوْجُ
u'عجز زَوْجٌ':Added, #1: 1	عَجَزَ زَوْجُ
u'عجز زَوْجٌ':Added, #1: 1	عَجْزَ الزَّوْجِ
u'عَجْزٌ زَوْجٌ':Added, #1: 1	عَجْزِ الزَّوْجِ
u'عَجْزٌ زَوْجٌ':Added, #1: 1	عَجْزَ الزَّوْجِ
u'عَجَزَ سقط':Predicate, #1: 1	عَجْزِ الزَّوْجِ
u'عَجَزَ سَقَطٌ':Predicate, #1: 1	عَجَزَ سَقَطَ
u'عجز سُلْطَانٌ':Added, #1: 1	عَجَزَ سَقَطَ
u'عَجْزٌ سُلْطَانٌ':Added, #3: 3	عَجْزُ السُّلْطَانِ
u'عَجَزَ سَيِّدٌ':Subject, #3: 3	عَجْزُ السُّلْطَانِ
u'عَجَّزَ سَيِّدٌ':Subject, #1: 1	عَجَزَ السَّيِّدُ
u'عَجَزَ شَفِيعٌ':Subject, #1: 1	عَجَّزَ السَّيِّدُ
u'عَجَزَ شُهُودٌ':Subject, #1: 1	عَجَزَ الشَّفِيعُ
u'عَجَزَ شَيْخٌ':Subject, #2: 2	عَجَزَ الشُّهُودُ
u'عجز صَبِيٌّ':Added, #1: 1	عَجَزَ الشَّيْخُ
u'عَجْزٌ صَبِيٌّ':Added, #1: 1	عَجْزُ الصَّبِيِّ
u'عجز صِغَرٌ':Added, #1: 1	عَجْزُ الصَّبِيِّ
u'عَجْزٌ صِغَرٌ':Added, #1: 1	عَجْزِ الصِّغَرِ
u'عَجَزَ طَالِبٌ':Subject, #1: 1	عَجْزِ الصِّغَرِ
u'عَجَزَ عَادٌ':Predicate, #1: 1	عَجَزَ الطَّالِبُ
u'عجز عَاقِدٌ':Added, #7: 7	عَجَزَ عَادَ
u'عَجْزٌ عَاقِدٌ':Added, #2: 2	عَجْزُ الْعَاقِدِ
u'عَجَزَ عَامِلٌ':Subject, #2: 2	عَجْزُ الْعَاقِدِ
u'عَجَزَ عَبْدٌ':Subject, #1: 1	عَجَزَ عَامِلُ
u'عَجَزَ عَدْلٌ':Subject, #6: 6	عَجَزَ الْعَبْدُ
u'عَجَزَ عند':Predicate, #1: 1	عَجَزَ الْعَدْلُ
u'عَجَزَ غَاصِبٌ':Subject, #2: 2	عَجَزَ عِنْدَ
u'عَجَزَ غَائِبٌ':Subject, #2: 2	عَجَزَ الْغَاصِبُ
u'عَجَزَ غُلاَمٌ':Subject, #1: 1	عَجَزَ الْغَائِبُ
u'عجز غير':Added, #3: 3	عَجَزَ الْغُلَامُ
u'عجز غَيْرٌ':Added, #1: 1	عَجْزِ غَيْرِهِ
u'عَجْزٌ غير':Added, #1: 1	عَجْزِ غَيْرِهِ
u'عَجْزٌ غَيْرٌ':Added, #1: 1	عَجْزِ غَيْرِهِ
u'عَجَزَ فَقِيهٌ':Subject, #1: 1	عَجْزِ غَيْرِهِ
u'عَجَزَ فَلًا':Predicate, #1: 1	عَجَزَ الْفَقِيهُ
u'عَجَزَ فُلاَنٌ':Subject, #1: 1	عَجَزَ فَلاَ
u'عجز قَاذِفٌ':Added, #1: 1	عَجَزَ فُلَانٌ
u'عَجْزٌ قَاذِفٌ':Added, #1: 1	عَجْزِ الْقَاذِفِ
u'عَجَزَ قَالٌ':Predicate, #1: 1	عَجْزِ الْقَاذِفِ
u'عَجَزَ قَرِيبٌ':Subject, #1: 1	عَجَزَ قَالَ
u'عَجَزَ قضاة':Subject, #1: 1	عَجَزَ قَرِيبُهُ
u'عَجَزَ كَاتِبٌ':Subject, #1: 1	عَجَزَ الْقُضَاةُ
u'عجز كَفِيلٌ':Added, #1: 1	عَجَزَ الْكَاتِبُ
u'عَجْزٌ كَفِيلٌ':Added, #1: 1	عَجْزِ الْكَفِيلِ
u'عجز كلال':Added, #1: 1	عَجْزِ الْكَفِيلِ
u'عجز كلال':Added, #1: 1	عَجْزُ الْكَلَالِ
u'عَجْزٌ كلال':Added, #1: 1	عَجْزِ الْكَلَالِ
u'عَجْزٌ كلال':Added, #1: 1	عَجْزُ الْكَلَالِ
u'عَجَزَ مَالٌ':Subject, #1: 1	عَجْزِ الْكَلَالِ
u'عَجَزَ مَالِكٌ':Subject, #1: 1	عَجَزَ الْمَالُ
u'عجز مَالِكٌ':Added, #4: 4	عَجَزَ الْمَالِكُ
u'عَجْزٌ مَالِكٌ':Added, #1: 1	عَجْزِ الْمَالِكِ
u'عجز مُحِيل':Added, #1: 1	عَجْزِ الْمَالِكِ
u'عَجْزٌ مُحِيل':Added, #1: 1	عَجْزُ الْمُحِيلِ
u'عجز مَدْيُونٌ':Added, #1: 1	عَجْزُ الْمُحِيلِ
u'عَجْزٌ مَدْيُونٌ':Added, #1: 1	عَجْزِ الْمَدْيُونِ
u'عجز مَرْجُوّ':Added, #1: 1	عَجْزِ الْمَدْيُونِ
u'عَجْزٌ مَرْجُوّ':Added, #1: 1	عَجْزِ مَرْجُوِّ
u'عجز مُرْسَلٌ':Added, #1: 1	عَجْزِ مَرْجُوِّ
u'عَجْزٌ مُرْسَلٌ':Added, #1: 1	عَجْزِ الْمُرْسَلِ
u'عَجَزَ مَرِيضٌ':Subject, #1: 1	عَجْزِ الْمُرْسَلِ
u'عَجَزَ مُسْتَعِيرٌ':Subject, #7: 7	عَجَزَ الْمَرِيضُ
u'عجز مُسْتَنِيب':Added, #1: 1	عَجَزَ الْمُسْتَعِيرُ
u'عَجْزٌ مُسْتَنِيب':Added, #1: 1	عَجْزُ الْمُسْتَنِيبِ
u'عَجَزَ مَسْجِدٌ':Subject, #1: 1	عَجْزُ الْمُسْتَنِيبِ
u'عَجَزَ مُعْتَرِضٌ':Subject, #1: 1	عَجَزَ الْمَسْجِدُ
u'عجز مُعْتَرِضٌ':Added, #1: 1	عَجَزَ الْمُعْتَرِضُ
u'عَجْزٌ مُعْتَرِضٌ':Added, #1: 1	عَجْزِ الْمُعْتَرِضِ
u'عجز مُعْتَرِضٌ':Added, #1: 1	عَجْزِ الْمُعْتَرِضِ
u'عَجْزٌ مُعْتَرِضٌ':Added, #2: 2	عَجْزُ الْمُعْتَرِضِ
u'عجز مُعْسِرٌ':Added, #2: 2	عَجْزُ الْمُعْتَرِضِ
u'عَجْزٌ مُعْسِرٌ':Added, #1: 1	عَجْزِ الْمُعْسِرِ
u'عَجَزَ مُفْسِدٌ':Subject, #1: 1	عَجْزِ الْمُعْسِرِ
u'عجز مُقَلِّدٌ':Added, #1: 1	عَجَزَ الْمُفْسِدُ
u'عَجْزٌ مُقَلِّدٌ':Added, #1: 1	عَجْزِ الْمُقَلِّدِ
u'عجز مُكَاتَبَةٌ':Added, #1: 1	عَجْزِ الْمُقَلِّدِ
u'عَجْزٌ مُكَاتَبَةٌ':Added, #1: 1	عَجْزِ الْمُكَاتَبَةِ
u'عجز مُكْرَهٌ':Added, #1: 1	عَجْزِ الْمُكَاتَبَةِ
u'عَجْزٌ مُكْرَهٌ':Added, #1: 1	عَجْزُ الْمُكْرَهِ
u'عَجَزَ مَلَكٌ':Predicate, #1: 1	عَجْزُ الْمُكْرَهِ
u'عجز مُنْفَق':Added, #2: 2	عَجَزَ مَلَكَ
u'عَجْزٌ مُنْفَق':Added, #2: 2	عَجْزُ الْمُنْفَقِ
u'عجز مُوَكِّلٌ':Added, #2: 2	عَجْزُ الْمُنْفَقِ
u'عَجْزٌ مُوَكِّلٌ':Added, #1: 1	عَجْزُ الْمُوَكِّلِ
u'عَجَزَ نَظَرٌ':Predicate, #1: 1	عَجْزُ الْمُوَكِّلِ
u'عَجَزَ نَفْسٌ':Subject, #1: 1	عَجَزَ نَظَرَ
u'عجز نَفْسٌ':Added, #5: 5	عَجَزَ نَفْسُهُ
u'عَجْزٌ نَفْسٌ':Added, #3: 3	عَجْزَ نَفْسِهِ
u'عَجَزَ هَدَرٌ':Predicate, #3: 3	عَجْزَ نَفْسِهِ
u'عجز وَالِدٌ':Added, #1: 1	عَجَزَ هَدَرَ
u'عَجْزٌ وَالِدٌ':Added, #1: 1	عَجْزُ الْوَالِدِ
u'عَجَزَ وَصِيٌّ':Subject, #1: 1	عَجْزُ الْوَالِدِ
u'عجز وَصِيٌّ':Added, #1: 1	عَجَزَ الْوَصِيُّ
u'عَجْزٌ وَصِيٌّ':Added, #1: 1	عَجْزُ وَصِيٍّ
u'عَجَزَ وَقْتٌ':Predicate, #1: 1	عَجْزُ وَصِيٍّ
u'عَجَزَ وَكِيلٌ':Subject, #1: 1	عَجَزَ وَقْتَ
u'عجز وَكِيلٌ':Added, #4: 4	عَجَزَ الْوَكِيلُ
u'عَجْزٌ وَكِيلٌ':Added, #1: 1	عَجْزَ الْوَكِيلِ
u'عَجَزَ ولد':Subject, #1: 1	عَجْزَ الْوَكِيلِ
u'عَجَزَ وَلَدٌ':Subject, #1: 1	عَجَزَ الْوَلَدُ
u'عجز ولد':Added, #1: 1	عَجَزَ الْوَلَدُ
u'عَجْزٌ ولد':Added, #2: 2	عَجْزُ الْوَلَدِ
u'عجز وَلَدٌ':Added, #2: 2	عَجْزُ الْوَلَدِ
u'عَجْزٌ وَلَدٌ':Added, #2: 2	عَجْزُ الْوَلَدِ
u'عَجَّلَ أَجْرٌ':Predicate, #2: 2	عَجْزُ الْوَلَدِ
u'عَجَّلَ أُجْرَةٌ':Predicate, #2: 2	عَجَّلَ الْأَجْرَ
u'عَجَّلَ اِخْتِيَارٌ':Predicate, #6: 6	عَجَّلَ الْأُجْرَةَ
u'عَجَّلَ أَدَاءٌ':Predicate, #1: 1	عَجَّلَ اخْتِيَارَ
u'عَجَّلَ أُمٌّ':Predicate, #2: 2	عَجَّلَ أَدَاءَ
u'عَجَّلَ إمَامٌ':Subject, #1: 1	عَجَّلَ أُمَّ
u'عَجَّلَ بَدَلٌ':Predicate, #1: 1	عَجَّلَ الْإِمَامُ
u'عَجِلَ بَطَلٌ':Predicate, #2: 2	عَجَّلَ الْبَدَلَ
u'عَجَّلَ بَعْضٌ':Predicate, #1: 1	عَجِلَ بَطَلَ
u'عَجَّلَ بِنْتٌ':Predicate, #1: 1	عَجَّلَ بَعْضَ
u'عجلة غير':Added, #1: 1	عَجَّلَ بِنْتَ
u'عجلة غَيْرٌ':Added, #1: 1	عَجَلَةَ غَيْرِ
u'عَجَلَةٌ غير':Added, #1: 1	عَجَلَةَ غَيْرِ
u'عَجَلَةٌ غَيْرٌ':Added, #1: 1	عَجَلَةَ غَيْرِ
u'عَجَّلَ ثَوْبٌ':Predicate, #1: 1	عَجَلَةَ غَيْرِ
u'عَجَّلَ حَقٌّ':Predicate, #1: 1	عَجَّلَ الثَّوْبَ
u'عَجِلَ حَمِيل':Subject, #2: 2	عَجَّلَ الْحَقَّ
u'عَجَّلَ خَتْمٌ':Predicate, #1: 1	عَجِلَ الْحَمِيلُ
u'عَجَّلَ خراج':Predicate, #1: 1	عَجَّلَ الْخَتْمَ
u'عَجَّلَ خَرَاجٌ':Predicate, #4: 4	عَجَّلَ خَرَاجَ
u'عَجَّلَ دَرَاهِمُ':Predicate, #4: 4	عَجَّلَ خَرَاجَ
u'عَجَّلَ دَيْنٌ':Predicate, #3: 3	عَجَّلَ الدَّرَاهِمَ
u'عَجَّلَ رَأْسٌ':Predicate, #2: 2	عَجَّلَ الدَّيْنَ
u'عَجَّلَ رَبُّ':Subject, #1: 1	عَجَّلَ رَأْسَ
u'عَجَّلَ زَكاةٌ':Predicate, #2: 2	عَجَّلَ رَبُّهُ
u'عَجَّلَ زَكاةٌ':Predicate, #10: 10	عَجَّلَ زَكَاةَ
u'عَجَّلَ زَوْجٌ':Subject, #23: 23	عَجَّلَ الزَّكَاةَ
u'عَجَّلَ زِيادَةٌ':Predicate, #1: 1	عَجَّلَ الزَّوْجُ
u'عَجِلَ سرعان':Subject, #1: 1	عَجَّلَ الزِّيَادَةَ
u'عَجَّلَ شَفِيعٌ':Subject, #2: 2	عَجِلَ سَرَعَانُ
u'عَجِلَ شَيْخٌ':Subject, #1: 1	عَجَّلَ الشَّفِيعُ
u'عَجَّلَ صدقة':Predicate, #1: 1	عَجِلَ شَيْخٌ
u'عَجَّلَ صَدَقَةٌ':Predicate, #3: 3	عَجَّلَ صَدَقَةَ
u'عَجَّلَ صَوْمٌ':Predicate, #3: 3	عَجَّلَ صَدَقَةَ
u'عَجَّلَ ضَمِنٌ':Predicate, #1: 1	عَجَّلَ صَوْمَ
u'عَجَّلَ طعام':Predicate, #1: 1	عَجَّلَ ضَمِنَ
u'عَجَّلَ طَعَامٌ':Predicate, #1: 1	عَجَّلَ الطَّعَامَ
u'عَجَّلَ عَبْدٌ':Subject, #1: 1	عَجَّلَ الطَّعَامَ
u'عَجَّلَ عتق':Predicate, #1: 1	عَجَّلَ الْعَبْدُ
u'عَجَّلَ عِتْقٌ':Predicate, #1: 1	عَجَّلَ الْعِتْقَ
u'عَجَّلَ عُذْرٌ':Predicate, #1: 1	عَجَّلَ الْعِتْقَ
u'عَجَّلَ عِشَاءٌ':Predicate, #1: 1	عَجَّلَ الْعُذْرَ
u'عَجَّلَ عُشْرٌ':Predicate, #2: 2	عَجَّلَ الْعِشَاءَ
u'عَجَّلَ فطرة':Predicate, #9: 9	عَجَّلَ عُشْرَ
u'عَجَّلَ فِطْرَةٌ':Predicate, #1: 1	عَجَّلَ فِطْرَةَ
u'عَجَّلَ قتل':Predicate, #1: 1	عَجَّلَ فِطْرَةَ
u'عَجَّلَ قَتْلٌ':Predicate, #1: 1	عَجَّلَ الْقَتْلَ
u'عَجَّلَ قَطْعٌ':Predicate, #1: 1	عَجَّلَ الْقَتْلَ
u'عَجَّلَ كِتَابَةٌ':Predicate, #1: 1	عَجَّلَ قَطْعَ
u'عَجَّلَ كَفَّارٌ':Predicate, #2: 2	عَجَّلَ الْكِتَابَةَ
u'عَجَّلَ كَفَّارٌ':Predicate, #1: 1	عَجَّلَ كَفَّارَةَ
u'عَجَّلَ كَفَّارَةٌ':Predicate, #2: 2	عَجَّلَ الْكَفَّارَةَ
u'عَجَّلَ كَفَّارَةٌ':Predicate, #1: 1	عَجَّلَ كَفَّارَةَ
u'عَجَّلَ كَفِيلٌ':Subject, #2: 2	عَجَّلَ الْكَفَّارَةَ
u'عَجَّلَ مَالِكٌ':Subject, #2: 2	عَجَّلَ الْكَفِيلُ
u'عَجَّلَ مُتَمَتِّعٌ':Subject, #3: 3	عَجَّلَ الْمَالِكُ
u'عَجَّلَ مُسْتَأْجِرٌ':Subject, #1: 1	عَجَّلَ الْمُتَمَتِّعُ
u'عَجَّلَ مُسِنٌّ':Predicate, #3: 3	عَجَّلَ الْمُسْتَأْجِرُ
u'عَجَّلَ مَعْلُوفٌ':Predicate, #2: 2	عَجَّلَ مُسِنَّةً
u'عَجَّلَ مُقْتَرِضٌ':Subject, #1: 1	عَجَّلَ مَعْلُوفَةً
u'عَجِلَ مَلِيكٌ':Subject, #1: 1	عَجَّلَ الْمُقْتَرِضُ
u'عَجَّلَ نَاسٌ':Subject, #1: 1	عَجِلَ الْمَلِيكُ
u'عَجَّلَ نَاظِرٌ':Subject, #1: 1	عَجَّلَ النَّاسُ
u'عَجَّلَ نَجْمٌ':Predicate, #2: 2	عَجَّلَ النَّاظِرُ
u'عَجَّلَ نُجُومٌ':Predicate, #1: 1	عَجَّلَ النَّجْمَ
u'عَجَّلَ وَاجِبٌ':Predicate, #1: 1	عَجَّلَ النُّجُومَ
u'عَجَّلَ واحد':Predicate, #1: 1	عَجَّلَ الْوَاجِبَ
u'عَجَّلَ وَاحِدٌ':Predicate, #2: 2	عَجَّلَ وَاحِدَةً
u'عُجْمَةٌ لِسَانٌ':Added, #2: 2	عَجَّلَ وَاحِدَةً
u'عُجْمَةٌ لِسَانٌ':Added, #1: 1	عُجْمَةُ اللِّسَانِ
u'عَجَنَ تُرَابٌ':Predicate, #1: 1	عُجْمَةُ لِسَانٍ
u'عَجَنَ دَقيقٌ':Predicate, #1: 1	عَجَنَ التُّرَابَ
u'عَجَنَ غَاصِبٌ':Subject, #1: 1	عَجَنَ الدَّقِيقَ
u'عَدَا أَبٌ':Predicate, #1: 1	عَجَنَ الْغَاصِبُ
u'عَدَا إبَاحَةٌ':Predicate, #1: 1	عَدَا الْأَبَ
u'عَدَا إِبْطَالٌ':Predicate, #1: 1	عَدَا إبَاحَةَ
u'عَدَا اِبْنٌ':Predicate, #1: 1	عَدَا إبْطَالَ
u'عَدَا إِثْبَاتٌ':Predicate, #2: 2	عَدَا ابْنَ
u'عَدَا آخِرُ':Predicate, #3: 3	عَدَا الْإِثْبَاتَ
u'عَدَا أَخِيرٌ':Predicate, #1: 1	عَدَا الْآخِرَ
u'عَدَا أَخِيرٌ':Predicate, #4: 4	عَدَا الْأَخِيرَ
u'عَدَا أَرْبَعُ':Predicate, #6: 6	عَدَا الْأَخِيرَةَ
u'عَدَا اِسْتِصْحابٌ':Predicate, #1: 1	عَدَا الْأَرْبَعَ
u'عَدَا اِسْتيلاءٌ':Predicate, #1: 1	عَدَا اسْتِصْحَابَ
u'عَدَا إِسْلامٌ':Predicate, #1: 1	عَدَا اسْتِيلَاءَ
u'عَدَا أُصْبُعٌ':Predicate, #2: 2	عَدَا الْإِسْلَامَ
u'عَدَا أُصولٌ':Predicate, #1: 1	عَدَا الْأُصْبُعَ
u'عَدَا أُمٌّ':Predicate, #1: 1	عَدَا الْأُصُولَ
u'عَدَا إمَامٌ':Subject, #1: 1	عَدَا أُمَّ
u'عَدَا أَمْلاكٌ':Predicate, #1: 1	عَدَا الْإِمَامُ
u'عَدَا أَمْلاَكٌ':Predicate, #1: 1	عَدَا الْأَمْلَاكَ
u'عَدَا أَمْوَالٌ':Predicate, #1: 1	عَدَا الْأَمْلَاكَ
u'عَدَا أهْلٌ':Predicate, #1: 1	عَدَا الْأَمْوَالَ
u'عَدَا أَوْسَاطٌ':Predicate, #1: 1	عَدَا أَهْلَ
u'عَدَا أَوْسَاطٌ':Predicate, #1: 1	عَدَا الْأَوْسَاطَ
u'عَدَا أَوَّلُ':Predicate, #1: 1	عَدَا أَوْسَاطَ
u'عَدَا أَوَّلُ':Subject, #1: 1	عَدَا الْأَوَّلَ
u'عَدَا بُخَارِيٌّ':Predicate, #1: 1	عَدَا أَوَّلُ
u'عَدَا بَدَلٌ':Predicate, #1: 1	عَدَا الْبُخَارِيَّ
u'عَدَّ اِبْنٌ':Subject, #1: 1	عَدَا بَدَلَ
u'عَدَا بِنَاءٌ':Predicate, #7: 7	عَدَّ ابْنُ
u'عَدَا تَحْلِيلٌ':Predicate, #1: 1	عَدَا الْبِنَاءَ
u'عَدَا تَرْجِيعٌ':Predicate, #1: 1	عَدَا التَّحْلِيلَ
u'عَدَا تَسْبِيحٌ':Predicate, #2: 2	عَدَا التَّرْجِيعَ
u'عَدَا تَسْلِيمٌ':Predicate, #1: 1	عَدَا التَّسْبِيحَ
u'عَدَا تَكْبِير':Predicate, #1: 1	عَدَا تَسْلِيمَ
u'عَدَا تَكْبيرٌ':Subject, #1: 1	عَدَا التَّكْبِيرَةَ
u'عَدَا تَكْميلٌ':Predicate, #1: 1	عَدَا التَّكْبِيرُ
u'عَدَا تَمْييزٌ':Predicate, #1: 1	عَدَا تَكْمِيلَ
u'عَدَا تَمْييزٌ':Predicate, #1: 1	عَدَا التَّمْيِيزَ
u'عَدَا تَنْفِيذٌ':Predicate, #1: 1	عَدَا تَمْيِيزَ
u'عَدَا ثَالِثٌ':Predicate, #1: 1	عَدَا تَنْفِيذَ
u'عَدَا ثَلاثُ':Predicate, #1: 1	عَدَا الثَّالِثَةَ
u'عَدَا جَبِيرَة':Predicate, #1: 1	عَدَا الثَّلَاثَ
u'عَدَا جُزْءٌ':Predicate, #1: 1	عَدَا الْجَبِيرَةَ
u'عَدَا جمعة':Predicate, #1: 1	عَدَا الْجُزْءَ
u'عَدَا جُمُعَةٌ':Predicate, #2: 2	عَدَا الْجُمُعَةَ
u'عَدَا جُمْهُورٌ':Predicate, #2: 2	عَدَا الْجُمُعَةَ
u'عَدَا جهاد':Predicate, #1: 1	عَدَا جُمْهُورَ
u'عَدَا جِهَادٌ':Predicate, #1: 1	عَدَا جِهَادَ
u'عَدَا جهاد':Predicate, #1: 1	عَدَا جِهَادَ
u'عَدَا جِهَادٌ':Predicate, #3: 3	عَدَا الْجِهَادَ
u'عَدَا جَيْشٌ':Predicate, #3: 3	عَدَا الْجِهَادَ
u'عَدَا حالَةٌ':Predicate, #1: 1	عَدَا الْجَيْشَ
u'عَدَّ أحَدٌ':Subject, #1: 1	عَدَا الْحَالَةَ
u'عَدَّ أَحْداثٌ':Predicate, #1: 1	أَعَدَّ أَحَدٌ
u'عَدَّ أَحْدَاثٌ':Predicate, #3: 3	عَدَّ الْأَحْدَاثَ
u'عَدَا حَديدٌ':Predicate, #3: 3	عَدَّ الْأَحْدَاثَ
u'عَدَا حَرَمٌ':Predicate, #1: 1	عَدَا الْحَدِيدَ
u'عَدَا حُكْمٌ':Predicate, #1: 1	عَدَا الْحَرَمَ
u'عَدَا حَمْز':Subject, #2: 2	عَدَا حُكْمَ
u'عَدَا حول':Predicate, #1: 1	عَدَا حَمْزَةُ
u'عَدَا حَوْلٌ':Predicate, #1: 1	عَدَا الْحَوْلَ
u'عَدَا حول':Predicate, #1: 1	عَدَا الْحَوْلَ
u'عَدَا حَوْلٌ':Predicate, #2: 2	عَدَا حَوْلَ
u'عَدَا خاصّ':Predicate, #2: 2	عَدَا حَوْلَ
u'عَدَا خُلْعٌ':Predicate, #1: 1	عَدَا الْخَاصَّ
u'عَدَا خَلْفٌ':Predicate, #1: 1	عَدَا الْخُلْعَ
u'عَدَا خِمَارٌ':Predicate, #2: 2	عَدَا خَلْفَ
u'عَدَا خَمْسَةٌ':Predicate, #1: 1	عَدَا الْخِمَارَ
u'عِدَادٌ أَحْرارٌ':Added, #1: 1	عَدَا خَمْسَةَ
u'عِدَادٌ إِخْوَانٌ':Added, #4: 4	عِدَادِ الْأَحْرَارِ
u'عَدَا دُبُرٌ':Predicate, #2: 2	عِدَادِ الْإِخْوَانِ
u'عِدَادٌ شُبَّانٌ':Added, #1: 1	عَدَا الدُّبُرَ
u'عِدَادٌ علماء':Added, #1: 1	عِدَادِ الشُّبَّانِ
u'عِدَادٌ عُلَمَاءُ':Added, #2: 2	عِدَادِ الْعُلَمَاءِ
u'عَدَا دُفٌّ':Predicate, #2: 2	عِدَادِ الْعُلَمَاءِ
u'عِدَادٌ مَحاوِيج':Added, #2: 2	عَدَا الدُّفَّ
u'عَدَا ذُكورَةٌ':Predicate, #1: 1	عِدَادِ الْمَحَاوِيجِ
u'عَدَا ذَهَابٌ':Predicate, #1: 1	عَدَا الذُّكُورَةَ
u'عَدَا ذَهَبٌ':Predicate, #1: 1	عَدَا ذَهَابَ
u'عَدَا ذِئْبٌ':Subject, #1: 1	عَدَا الذَّهَبَ
u'عَدَا رابع':Predicate, #1: 1	عَدَا الذِّئْبُ
u'عَدَا رَابِعٌ':Predicate, #1: 1	عَدَا الرَّابِعَ
u'عَدَا رَأْسٌ':Predicate, #1: 1	عَدَا الرَّابِعَ
u'عَدَا رَدٌّ':Predicate, #4: 4	عَدَا الرَّأْسَ
u'عَدَا رَقَبَةٌ':Predicate, #1: 1	عَدَا الرَّدَّ
u'عَدَا رَمَضانُ':Predicate, #2: 2	عَدَا الرَّقَبَةَ
u'عَدَا رواجع':Predicate, #1: 1	عَدَا رَمَضَانَ
u'عَدَا زَكاةٌ':Predicate, #1: 1	عَدَا الرَّوَاجِعَ
u'عَدَا زَمَنٌ':Predicate, #5: 5	عَدَا الزَّكَاةَ
u'عَدَا زَوْجَةٌ':Predicate, #1: 1	عَدَا زَمَنَ
u'عَدَا سَرقَةٌ':Predicate, #2: 2	عَدَا الزَّوْجَةَ
u'عَدَا سَرِقَةٌ':Predicate, #1: 1	عَدَا السَّرِقَةَ
u'عَدَا سُنَّةٌ':Predicate, #1: 1	عَدَا السَّرِقَةَ
u'عَدَا سنن':Predicate, #1: 1	عَدَا سُنَّةَ
u'عَدَا سَوائِمُ':Predicate, #1: 1	عَدَا السُّنَنَ
u'عَدَا سَوَائِمُ':Predicate, #1: 1	عَدَا السَّوَائِمَ
u'عَدَا شَرْطٌ':Predicate, #1: 1	عَدَا السَّوَائِمَ
u'عَدَا شَعْرٌ':Predicate, #1: 1	عَدَا الشَّرْطَ
u'عَدَا شَهْرٌ':Predicate, #2: 2	عَدَا شَعْرَ
u'عَدَا صَاعٌ':Predicate, #1: 1	عَدَا الشَّهْرَ
u'عَدَا صُبْحٌ':Predicate, #1: 1	عَدَا الصَّاعَ
u'عَدَّ أَصْحَابٌ':Subject, #1: 1	عَدَا الصُّبْحَ
u'عَدَا صدقة':Predicate, #2: 2	عَدَّ الْأَصْحَابُ
u'عَدَا صَدَقَةٌ':Predicate, #1: 1	عَدَا الصَّدَقَةَ
u'عَدَا صَرِيحٌ':Predicate, #1: 1	عَدَا الصَّدَقَةَ
u'عَدَا صِفَةٌ':Predicate, #1: 1	عَدَا الصَّرِيحَ
u'عَدَا صُورَةٌ':Predicate, #1: 1	عَدَا الصِّفَةَ
u'عَدَّ أُصولٌ':Predicate, #1: 1	عَدَا صُورَةَ
u'عَدَا ضَرْبٌ':Predicate, #2: 2	عَدَّ الْأُصُولَ
u'عَدَا طَائِرٌ':Predicate, #1: 1	عَدَا ضَرْبَ
u'عَدَا طَبَقَةٌ':Predicate, #1: 1	عَدَا الطَّائِرَ
u'عَدَا طعام':Predicate, #2: 2	عَدَا الطَّبَقَةَ
u'عَدَا طَعَامٌ':Predicate, #2: 2	عَدَا الطَّعَامَ
u'عَدَا طَلاَقٌ':Predicate, #2: 2	عَدَا الطَّعَامَ
u'عَدَا ظاهِرٌ':Predicate, #1: 1	عَدَا الطَّلَاقَ
u'عَدَا عتق':Predicate, #1: 1	عَدَا ظَاهِرَ
u'عَدَا عِتْقٌ':Predicate, #2: 2	عَدَا الْعِتْقَ
u'عَدَا عَجْوَةٌ':Predicate, #2: 2	عَدَا الْعِتْقَ
u'عَدَا عَجُوزٌ':Predicate, #1: 1	عَدَا الْعَجْوَةَ
u'عَدَّ أَعْذَارٌ':Predicate, #1: 1	عَدَا الْعَجُوزَ
u'عَدَا عَرَبِيٌّ':Predicate, #1: 1	عَدَّ الْأَعْذَارَ
u'عَدَا عرفة':Predicate, #2: 2	عَدَا الْعَرَبِيَّةَ
u'عَدَا علم':Predicate, #1: 1	عَدَا عَرَفَةَ
u'عَدَا عَلَمٌ':Predicate, #1: 1	عَدَا عَلَمَ
u'عَدَا علماء':Predicate, #1: 1	عَدَا عَلَمَ
u'عَدَا عُلَمَاءُ':Predicate, #1: 1	عَدَا الْعُلَمَاءَ
u'عَدَا عِمَامَةٌ':Predicate, #1: 1	عَدَا الْعُلَمَاءَ
u'عَدَا عَوْرَةٌ':Predicate, #1: 1	عَدَا الْعِمَامَةَ
u'عَدَا غُسْلٌ':Predicate, #3: 3	عَدَا الْعَوْرَةَ
u'عَدَا غُلاَةٌ':Predicate, #1: 1	عَدَا الْغُسْلَ
u'عَدَا فَاتِحٌ':Predicate, #1: 1	عَدَا غُلَاةَ
u'عَدَا فَاتِحَةٌ':Predicate, #3: 3	عَدَا الْفَاتِحَةَ
u'عَدَا فَرَائِضُ':Predicate, #3: 3	عَدَا الْفَاتِحَةَ
u'عَدَا فَرْجٌ':Predicate, #1: 1	عَدَا الْفَرَائِضَ
u'عَدَا فَرْضٌ':Predicate, #2: 2	عَدَا الْفَرْجَ
u'عَدَا فرق':Predicate, #1: 1	عَدَا الْفَرْضَ
u'عَدَا فَرْقٌ':Predicate, #1: 1	عَدَا الْفَرْقَ
u'عَدَا فُرُوعٌ':Predicate, #1: 1	عَدَا الْفَرْقَ
u'عَدَا فلان':Predicate, #1: 1	عَدَا الْفُرُوعَ
u'عَدَا فلان':Subject, #1: 1	عَدَا مَكَّةَ
u'عَدَا فَمٌ':Predicate, #1: 1	عَدَا حَمْزَةُ
u'عَدَا قَادِرٌ':Predicate, #1: 1	عَدَا الْفَمَ
u'عَدَا قَانُونٌ':Predicate, #1: 1	عَدَا الْقَادِرَ
u'عَدَا قُبُلٌ':Predicate, #1: 1	عَدَا الْقَانُونَ
u'عَدَا قتل':Predicate, #1: 1	عَدَا الْقُبُلَ
u'عَدَا قَتْلٌ':Predicate, #2: 2	عَدَا الْقَتْلَ
u'عَدَا قَدْرٌ':Predicate, #2: 2	عَدَا الْقَتْلَ
u'عَدَا قِرَاءةٌ':Predicate, #1: 1	عَدَا قَدْرَ
u'عَدَا قَوَاعِدُ':Predicate, #1: 1	عَدَا الْقِرَاءَةَ
u'عَدَا قول':Predicate, #1: 1	عَدَا الْقَوَاعِدَ
u'عَدَا قَوْلٌ':Predicate, #1: 1	عَدَا قَوْلَ
u'عَدَا كِتاب':Predicate, #1: 1	عَدَا قَوْلَ
u'عَدَا كِتَابٌ':Predicate, #1: 1	عَدَا الْكِتَابِيَّةَ
u'عَدَا كِتابَة':Predicate, #1: 1	عَدَا كِتَابَ
u'عَدَا كِتابِيّ':Predicate, #1: 1	عَدَا الْكِتَابِيَّةَ
u'عَدَا كَتَّانٌ':Predicate, #1: 1	عَدَا الْكِتَابِيَّةَ
u'عَدَا كفر':Predicate, #1: 1	عَدَا الْكَتَّانَ
u'عَدَا كُفْرٌ':Predicate, #1: 1	عَدَا الْكُفْرَ
u'عَدَا كَلْبٌ':Predicate, #1: 1	عَدَا الْكُفْرَ
u'عَدَا كُوبَة':Predicate, #1: 1	عَدَا الْكَلْبَ
u'عَدَالَةٌ إِسْلامٌ':Added, #1: 1	عَدَا الْكُوبَةَ
u'عَدَالَةٌ إِسْلامٌ':Added, #1: 1	عَدَالَةَ الْإِسْلَامِ
u'عَدَالَةٌ إِسْلامٌ':Added, #1: 1	عَدَالَةُ الْإِسْلَامِ
u'عَدَالَةٌ أَصْحَابٌ':Added, #7: 7	عَدَالَةِ الْإِسْلَامِ
u'عَدَالَةٌ أصل':Added, #1: 1	عَدَالَةُ أَصْحَابِ
u'عَدَالَةٌ أصل':Added, #1: 1	عَدَالَةَ الْأَصْلِ
u'عَدَالَةٌ أًصْلٌ':Added, #1: 1	عَدَالَةِ الْأَصْلِ
u'عَدَالَةٌ أًصْلٌ':Added, #1: 1	عَدَالَةَ الْأَصْلِ
u'عَدَالَةٌ أُصولٌ':Added, #1: 1	عَدَالَةِ الْأَصْلِ
u'عَدَالَةٌ أُصولٌ':Added, #1: 1	عَدَالَةِ الْأُصُولِ
u'عَدَالَةٌ إمَامٌ':Added, #2: 2	عَدَالَةُ الْأُصُولِ
u'عَدَالَةٌ إمَامٌ':Added, #1: 1	عَدَالَةُ الْإِمَامِ
u'عَدَالَةٌ آمِرٌ':Added, #1: 1	عَدَالَةِ الْإِمَامِ
u'عَدَالَةٌ بَاطن':Added, #1: 1	عَدَالَةُ الْآمِرِ
u'عَدَالَةٌ باطِنٌ':Added, #1: 1	عَدَالَةُ الْبَاطِنِ
u'عَدَالَةٌ باطِنٌ':Added, #1: 1	عَدَالَةُ الْبَاطِنِ
u'عَدَالَةٌ بَعْضٌ':Added, #1: 1	عَدَالَةٍ بَاطِنَةٍ
u'عَدَالَةٌ بَعْضٌ':Added, #1: 1	عَدَالَةُ الْبَعْضِ
u'عَدَالَةٌ بَيِّنَةٌ':Added, #1: 1	عَدَالَةِ بَعْضِ
u'عَدَالَةٌ بَيِّنَةٌ':Added, #2: 2	عَدَالَةَ الْبَيِّنَةِ
u'عَدَالَةٌ بَيِّنَةٌ':Added, #3: 3	عَدَالَةُ الْبَيِّنَةِ
u'عَدَالَةٌ تَائِبٌ':Added, #3: 3	عَدَالَةِ الْبَيِّنَةِ
u'عَدَالَةٌ حاضِنٌ':Added, #2: 2	عَدَالَةُ التَّائِبِ
u'عَدَالَةٌ دَاخِلٌ':Added, #1: 1	عَدَالَةُ الْحَاضِنَةِ
u'عَدَالَةٌ رُوَاةٌ':Added, #1: 1	عَدَالَةِ الدَّاخِلِ
u'عَدَالَةٌ رُوَاةٌ':Added, #1: 1	عَدَالَةُ رُوَاةِ
u'عَدَالَةٌ شَارِبٌ':Added, #2: 2	عَدَالَةِ رُوَاتِهِ
u'عَدَالَةٌ شَاهِدٌ':Added, #1: 1	عَدَالَةُ شَارِبِ
u'عَدَالَةٌ شَاهِدٌ':Added, #1: 1	عَدَالَةِ الشَّاهِدَيْنِ
u'عَدَالَةٌ شَاهِدٌ':Added, #2: 2	عَدَالَةَ الشَّاهِدِ
u'عَدَالَةٌ شَاهِدٌ':Added, #2: 2	عَدَالَةُ الشَّاهِدَيْنِ
u'عَدَالَةٌ شَخْصٌ':Added, #4: 4	عَدَالَةِ الشَّاهِدِ
u'عَدَالَةٌ شُهُودٌ':Added, #1: 1	عَدَالَةُ شَخْصٍ
u'عَدَالَةٌ شُهُودٌ':Added, #10: 10	عَدَالَةِ الشُّهُودِ
u'عَدَالَةٌ شُهُودٌ':Added, #12: 12	عَدَالَةُ الشُّهُودِ
u'عَدَالَةٌ شُهُودٌ':Added, #1: 1	عَدَالَةَ شُهُودِ
u'عَدَالَةٌ شُهُودٌ':Added, #1: 1	عَدَالَةِ شُهُودِهِ
u'عَدَالَةٌ صَحَابَةٌ':Added, #5: 5	عَدَالَةَ الشُّهُودِ
u'عَدَالَةٌ صَحَابَةٌ':Added, #1: 1	عَدَالَةُ الصَّحَابَةِ
u'عَدَالَةٌ صَحَابِيٌّ':Added, #3: 3	عَدَالَةِ الصَّحَابَةِ
u'عَدَالَةٌ ظاهِرٌ':Added, #1: 1	عَدَالَةِ الصَّحَابِيِّ
u'عَدَالَةٌ عَبْدٌ':Added, #2: 2	عَدَالَةَ الظَّاهِرِ
u'عَدَالَةٌ غير':Added, #1: 1	عَدَالَةَ الْعَبْدِ
u'عَدَالَةٌ غَيْرٌ':Added, #1: 1	عَدَالَةِ غَيْرِ
u'عَدَالَةٌ فَرِيقٌ':Added, #1: 1	عَدَالَةِ غَيْرِ
u'عَدَالَةٌ فلان':Added, #1: 1	عَدَالَةُ الْفَرِيقَيْنِ
u'عَدَالَةٌ كَافِرٌ':Added, #1: 1	عَدَالَةُ الْمَرْوِيِّ
u'عَدَالَةٌ مَأْمُورٌ':Added, #1: 1	عَدَالَةِ الْكَافِرِ
u'عَدَالَةٌ مُجْتَهِد':Added, #1: 1	عَدَالَةِ الْمَأْمُورِ
u'عَدَالَةٌ مُجْتَهِد':Added, #1: 1	عَدَالَةَ الْمُجْتَهِدِ
u'عَدَالَةٌ مُجَرِّبٌ':Added, #1: 1	عَدَالَةُ الْمُجْتَهِدِ
u'عَدَالَةٌ مُخْبِرٌ':Added, #1: 1	عَدَالَةِ الْمُجَرِّبِ
u'عَدَالَةٌ مُخْبِرٌ':Added, #1: 1	عَدَالَةِ الْمُخْبِرِ
u'عَدَالَةٌ مُخْبِرٌ':Added, #2: 2	عَدَالَةَ الْمُخْبِرِ
u'عَدَالَةٌ مَرْوِيّ':Added, #4: 4	عَدَالَةُ الْمُخْبِرِ
u'عَدَالَةٌ مُسْلِمٌ':Added, #1: 1	عَدَالَةُ الْمَرْوِيِّ
u'عَدَالَةٌ مَشْهُودٌ':Added, #1: 1	عَدَالَةِ الْمُسْلِمِ
u'عَدَالَةٌ مُطَهِّرٌ':Added, #1: 1	عَدَالَةِ الْمَشْهُودِ
u'عَدَالَةٌ مُعَنْعَن':Added, #1: 1	عَدَالَةِ الْمُطَهِّرِ
u'عَدَالَةٌ وَصْفٌ':Added, #1: 1	عَدَالَةِ الْمُعَنْعَنِ
u'عَدَالَةٌ وَكِيلٌ':Added, #1: 1	عَدَالَةَ الْوَصْفِ
u'عَدَالَةٌ وَلِيٌّ':Added, #1: 1	عَدَالَةُ الْوَكِيلِ
u'عَدَا لُزُومٌ':Predicate, #1: 1	عَدَالَةِ الْوَلِيِّ
u'عَدَّ ألف':Predicate, #2: 2	عَدَا لُزُومَ
u'عَدَّ ألْفٌ':Predicate, #1: 1	عَدَّ أَلْفَ
u'عَدَّ أَلْفٌ':Predicate, #1: 1	عَدَّ أَلْفَ
u'عَدَا لَفْظٌ':Predicate, #1: 1	عَدَّ أَلْفَ
u'عَدَا لقطة':Predicate, #1: 1	عَدَا لَفْظَ
u'عَدَا مَاءٌ':Predicate, #1: 1	عَدَا لُقَطَةَ
u'عَدَا مَالِيٌّ':Predicate, #4: 4	عَدَا الْمَاءَ
u'عَدَّ إمَامٌ':Subject, #1: 1	عَدَا الْمَالِيَّةَ
u'عَدَّ إمَامَةٌ':Predicate, #1: 1	عَدَّ إمَامُ
u'عَدَا مَأْمُورٌ':Predicate, #1: 1	عَدَّ إمَامَةَ
u'عَدَا مَبِيعٌ':Predicate, #1: 1	عَدَا الْمَأْمُورَ
u'عَدَا مُتَشَابِهٌ':Predicate, #1: 1	عَدَا الْمَبِيعَ
u'عَدَا مَجْرُوحٌ':Predicate, #1: 1	عَدَا الْمُتَشَابِهَ
u'عَدَا مُجْمَعٌ':Predicate, #1: 1	عَدَا الْمَجْرُوحَةَ
u'عَدَا مَجْنُونٌ':Predicate, #1: 1	عَدَا الْمُجْمَعَ
u'عَدَا مُحَرَّمٌ':Predicate, #1: 1	عَدَا الْمَجْنُونَةَ
u'عَدَا مَحَلٌّ':Predicate, #1: 1	عَدَا الْمُحَرَّمَ
u'عَدَا مَخْرَجٌ':Predicate, #2: 2	عَدَا مَحَلَّ
u'عَدَا مُخَصَّصٌ':Predicate, #1: 1	عَدَا الْمَخْرَجَ
u'عَدَا مَخْصُوصٌ':Predicate, #1: 1	عَدَا الْمُخَصَّصَ
u'عَدَا مُدَّةٌ':Predicate, #2: 2	عَدَا الْمَخْصُوصَ
u'عَدَا مَذْكُورٌ':Predicate, #2: 2	عَدَا الْمُدَّةَ
u'عَدَا مَذْكُورٌ':Predicate, #1: 1	عَدَا الْمَذْكُورِينَ
u'عَدَا مَسَاجِدُ':Predicate, #2: 2	عَدَا الْمَذْكُورَ
u'عَدَا مَسْأَلَةٌ':Predicate, #1: 1	عَدَا الْمَسَاجِدَ
u'عَدَا مَسْجِدٌ':Predicate, #2: 2	عَدَا مَسْأَلَةَ
u'عَدَا مَضْمَضَةٌ':Predicate, #1: 1	عَدَا الْمَسْجِدَ
u'عَدَا مُعْتَزِلٌ':Predicate, #1: 1	عَدَا الْمَضْمَضَةَ
u'عَدَا مُعْتَزِلَةٌ':Predicate, #1: 1	عَدَا الْمُعْتَزِلَةَ
u'عَدَا مَعْطُوف':Predicate, #1: 1	عَدَا الْمُعْتَزِلَةَ
u'عَدَا مَغْرِبٌ':Predicate, #1: 1	عَدَا الْمَعْطُوفَ
u'عَدَا مُغَلَّظ':Predicate, #1: 1	عَدَا الْمَغْرِبَ
u'عَدَا مُقَاتِلٌ':Predicate, #1: 1	عَدَا الْمُغَلَّظَةَ
u'عَدَا مِقْدَارٌ':Predicate, #1: 1	عَدَا الْمُقَاتِلَةَ
u'عَدَا مَقْصُورٌ':Predicate, #2: 2	عَدَا مِقْدَارَ
u'عَدَا مَكِيلٌ':Predicate, #2: 2	عَدَا الْمَقْصُورَ
u'عَدَا مِلْكٌ':Predicate, #2: 2	عَدَا الْمَكِيلَ
u'عَدَا مَنْصُوصٌ':Predicate, #1: 1	عَدَا الْمِلْكَ
u'عَدَا مَنْطِقٌ':Predicate, #5: 5	عَدَا الْمَنْصُوصَ
u'عَدَا مَنْطُوقٌ':Predicate, #1: 1	عَدَا الْمَنْطِقَ
u'عَدَا مُنْقَطِعٌ':Predicate, #3: 3	عَدَا الْمَنْطُوقَ
u'عَدَا مَوْضِعٌ':Predicate, #2: 2	عَدَا مُنْقَطِعَ
u'عَدَا نَصٌّ':Predicate, #1: 1	عَدَا مَوْضِعَ
u'عَدَا نِصْفٌ':Predicate, #1: 1	عَدَا النَّصَّ
u'عَدَا نَصِيبٌ':Predicate, #1: 1	عَدَا نِصْفَ
u'عَدَا نَعِيمٌ':Predicate, #2: 2	عَدَا نَصِيبَ
u'عَدَا نَفْيٌ':Predicate, #1: 1	عَدَا نَعِيمَ
u'عَدَا نكاح':Predicate, #1: 1	عَدَا النَّفْيَ
u'عَدَا نِكَاحٌ':Predicate, #6: 6	عَدَا النِّكَاحَ
u'عَدَا هشام':Subject, #6: 6	عَدَا النِّكَاحَ
u'عَدَا هِشَامٌ':Subject, #1: 1	عَدَا هِشَامُ
u'عَدَا وَاجِبٌ':Predicate, #1: 1	عَدَا هِشَامُ
u'عَدَا وَالِدٌ':Predicate, #1: 1	عَدَا الْوَاجِبَ
u'عَدَا وَجْهٌ':Predicate, #2: 2	عَدَا الْوَالِدَ
u'عَدَا وَدِيعٌ':Predicate, #8: 8	عَدَا الْوَجْهَ
u'عَدَا وَدِيعَةٌ':Predicate, #1: 1	عَدَا الْوَدِيعَةَ
u'عَدَا وَصْفٌ':Predicate, #1: 1	عَدَا الْوَدِيعَةَ
u'عَدَا وَقْتٌ':Predicate, #1: 1	عَدَا الْوَصْفَ
u'عَدَا وَقْفٌ':Predicate, #1: 1	عَدَا وَقْتَ
u'عَدَا ولد':Predicate, #1: 1	عَدَا الْوَقْفَ
u'عَدَا وَلَدٌ':Predicate, #4: 4	عَدَا الْوَلَدَ
u'عَدَا يهود':Predicate, #4: 4	عَدَا الْوَلَدَ
u'عَدَا يَهُودٌ':Predicate, #1: 1	عَدَا الْيَهُودَ
u'عَدَا يَهُودِيٌّ':Subject, #1: 1	عَدَا الْيَهُودَ
u'عَدَا يَوْمٌ':Predicate, #1: 1	عَدَا يَهُودِيٌّ
u'عَدَّ بَعْضٌ':Predicate, #1: 1	عَدَا الْيَوْمَ
u'عَدَّ تَرْتِيبٌ':Predicate, #1: 1	عَدَّ بَعْضَ
u'عَدَّ تَرْكٌ':Predicate, #1: 1	عَدَّ التَّرْتِيبَ
u'عَدَّ تَعْقِيبٌ':Predicate, #1: 1	عَدَّ تَرْكَ
u'عَدَّ تَكْبِير':Predicate, #1: 1	عَدَّ تَعْقِيبَ
u'عَدَّ حَبْسٌ':Predicate, #1: 1	عَدَّ تَكْبِيرَةَ
u'عَدَّ حَيَاةٌ':Predicate, #1: 1	عَدَّ حَبْسَ
u'عَدَّ خِصَامٌ':Predicate, #1: 1	عَدَّ الْحَيَاةَ
u'عَدَّ خَمْسٌ':Predicate, #1: 1	عَدَّ الْخِصَامَ
u'عَدَّ خَمْسَةٌ':Predicate, #2: 2	عَدَّ خَمْسَ
u'عَدَّدَ أَحادِيثُ':Predicate, #1: 1	عَدَّ خَمْسَةَ
u'عَدَّ دَارٌ':Predicate, #1: 1	عَدَّدَ أَحَادِيثَ
u'عَدَّدَ أَفْعَالٌ':Predicate, #1: 1	أَعَدَّ الدَّارَ
u'عَدَّدَ أَكْثَرُ':Predicate, #3: 3	عَدَّدَ أَفْعَالَ
u'عَدَّدَ بَعْضٌ':Subject, #1: 1	عَدَّدَ أَكْثَرَ
u'عَدَّدَ جمعة':Predicate, #1: 1	عَدَّدَ بَعْضُ
u'عَدَّدَ جُمُعَةٌ':Predicate, #1: 1	عَدَّدَ الْجُمُعَةَ
u'عَدَّ رُسُلٌ':Predicate, #1: 1	عَدَّدَ الْجُمُعَةَ
u'عَدَّ رَسُولٌ':Subject, #1: 1	عَدَّ الرُّسُلَ
u'عَدَّ سَبْعٌ':Predicate, #1: 1	أَعَدَّ رَسُولُ
u'عَدَّ سَبْعَةٌ':Predicate, #3: 3	عَدَّ سَبْعَ
u'عَدَّ سَمَاعٌ':Predicate, #2: 2	عَدَّ سَبْعَةَ
u'عَدَّ سُورَةٌ':Predicate, #1: 1	عَدَّ السَّمَاعَ
u'عَدَّ شُبْهَةٌ':Predicate, #1: 1	عَدَّ سُورَةَ
u'عَدَّ شِرْكٌ':Predicate, #1: 1	عَدَّ الشُّبْهَةَ
u'عَدَّ شَيْءٌ':Predicate, #1: 1	عَدَّ الشِّرْكَ
u'عَدَّ صَاحِبٌ':Subject, #1: 1	عَدَّ الشَّيْءَ
u'عَدَّ صَلاَةٌ':Predicate, #1: 1	عَدَّ صَاحِبُ
u'عَدَّ علماء':Subject, #1: 1	عَدَّ الصَّلَاةَ
u'عَدَّ عُلَمَاءُ':Subject, #1: 1	عَدَّ الْعُلَمَاءُ
u'عَدَّ عَمَلٌ':Predicate, #1: 1	عَدَّ الْعُلَمَاءُ
u'عَدَّ فَاتِحٌ':Predicate, #1: 1	عَدَّ عَمَلَ
u'عَدَّ فَاتِحَةٌ':Predicate, #1: 1	عَدَّ فَاتِحَةَ
u'عَدَّ فُجُورٌ':Predicate, #1: 1	عَدَّ فَاتِحَةَ
u'عَدَّ فرار':Predicate, #1: 1	عَدَّ الْفُجُورَ
u'عَدَّ فِرَارٌ':Predicate, #1: 1	عَدَّ الْفِرَارَ
u'عَدَّ فرق':Predicate, #1: 1	عَدَّ الْفِرَارَ
u'عَدَّ فِرَقٌ':Predicate, #1: 1	عَدَّ الْفِرَقَ
u'عَدَّ كَلِمَةٌ':Predicate, #1: 1	عَدَّ الْفِرَقَ
u'عَدَّ كَوَاغِدُ':Predicate, #1: 1	عَدَّ كَلِمَةَ
u'عَدَلَ أحَدٌ':Subject, #1: 1	عَدَّ الْكَوَاغِدَ
u'عَدْلٌ آخِرَةٌ':Added, #1: 1	عَدَلَ أَحَدٌ
u'عَدَّلَ أَكْثَرُ':Predicate, #1: 1	عَدْلِ الْآخِرَةِ
u'عَدْلٌ إِنْسانٌ':Added, #1: 1	عَدَّلَ أَكْثَرَ
u'عَدْلٌ بَدَلٌ':Added, #4: 4	عَدْلُ الْإِنْسَانِ
u'عَدْلٌ بُرٌّ':Added, #1: 1	عَدْلُ الْبَدَلِ
u'عَدْلٌ بُرٌّ':Added, #1: 1	عَدْلَ بُرٍّ
u'عَدْلٌ ثِقَةٌ':Added, #1: 1	عَدْلُ بُرٍّ
u'عَدْلٌ ثِيابٌ':Added, #1: 1	عَدْلٍ ثِقَةٍ
u'عَدْلٌ جَائِزٌ':Added, #1: 1	عَدْلَ ثِيَابٍ
u'عَدَلَ حَيَوَانٌ':Predicate, #1: 1	عَدْلٍ جَائِزٍ
u'عَدْلٌ دَقيقٌ':Added, #1: 1	عَدَلَ الْحَيَوَانَ
u'عَدَلَ دنيء':Subject, #1: 1	عَدْلِ الدَّقِيقِ
u'عَدَلَ دَنيءٌ':Subject, #1: 1	عَدَلَ الدَّنِيءُ
u'عَدْلٌ رَاهِنٌ':Added, #1: 1	عَدَلَ الدَّنِيءُ
u'عَدَلَ رَسُولٌ':Subject, #1: 1	عَدْلُ الرَّاهِنِ
u'عَدَلَ رَفيعٌ':Subject, #1: 1	عَدَلَ رَسُولُ
u'عَدْلٌ رَقَبَةٌ':Added, #1: 1	عَدَلَ الرَّفِيعُ
u'عَدْلٌ رَهْنٌ':Added, #2: 2	عَدْلَ رَقَبَةٍ
u'عَدْلٌ رِوايَةٌ':Added, #5: 5	عَدْلِ الرَّهْنِ
u'عَدْلٌ رِوايَةٌ':Added, #1: 1	عَدْلَ الرِّوَايَةِ
u'عَدْلٌ رِوايَةٌ':Added, #1: 1	عَدْلُ رِوَايَةٍ
u'عَدْلٌ رِوايَةٌ':Added, #1: 1	عَدْلِ رِوَايَةِ
u'عَدْلٌ رِوايَةٌ':Added, #2: 2	عَدْلُ الرِّوَايَةِ
u'عَدْلٌ سَاعَةٌ':Added, #2: 2	عَدْلَ رِوَايَةٍ
u'عَدْلٌ سَفِيهٌ':Added, #1: 1	عَدْلُ سَاعَةٍ
u'عَدْلٌ سيرَةٌ':Added, #1: 1	عَدْلُ السَّفِيهِ
u'عَدَلَ سَيْفٌ':Predicate, #1: 1	عَدْلَ السِّيرَةِ
u'عَدَلَ شافِعِيّ':Subject, #1: 1	عَدَلَ السّيْفَ
u'عَدَّلَ شَاهِدٌ':Predicate, #1: 1	عَدَلَ الشَّافِعِيُّ
u'عَدَلَ شَاهِدٌ':Subject, #2: 2	عَدَّلَ الشَّاهِدَ
u'عَدْلٌ شَهَادَةٌ':Added, #1: 1	عَدَلَ الشَّاهِدُ
u'عَدْلٌ شَهَادَةٌ':Added, #1: 1	عَدْلَ شَهَادَةٍ
u'عَدَّلَ شُهُودٌ':Predicate, #1: 1	عَدْلِ شَهَادَةٍ
u'عَدَّلَ شُهُودٌ':Predicate, #1: 1	عَدَّلَ شُهُودَ
u'عَدَّلَ شُهُودٌ':Subject, #5: 5	عَدَّلَ الشُّهُودَ
u'عَدْلٌ شَيْءٌ':Added, #2: 2	عَدَّلَ شُهُودُ
u'عَدَلَ صَحَابِيٌّ':Subject, #1: 1	عَدْلُ الشَّيْءِ
u'عَدَلَ صِيَامٌ':Predicate, #1: 1	عَدَلَ الصَّحَابِيُّ
u'عَدْلٌ ضَابِطٌ':Added, #1: 1	عَدَلَ صِيَامَ
u'عَدَلَ طَالِبٌ':Subject, #1: 1	عَدْلٍ ضَابِطٍ
u'عَدْلٌ طعام':Added, #1: 1	عَدَلَ الطَّالِبُ
u'عَدْلٌ طَعَامٌ':Added, #1: 1	عَدْلُ الطَّعَامِ
u'عَدْلٌ عَادِلٌ':Added, #1: 1	عَدْلُ الطَّعَامِ
u'عَدْلٌ عَالِمٌ':Added, #2: 2	عَدْلُ عَادِلٍ
u'عَدْلٌ عَشْرٌ':Added, #1: 1	عَدْلٍ عَالِمٍ
u'عَدَلَ عُمَرٌ':Subject, #1: 1	عَدْلَ عَشْرِ
u'عَدْلٌ عمرة':Added, #2: 2	عَدَلَ عُمَرُ
u'عَدْلٌ عُمْرَةٌ':Added, #1: 1	عَدْلُ عُمْرَةٍ
u'عَدَلَ عند':Predicate, #1: 1	عَدْلُ عُمْرَةٍ
u'عَدْلٌ غَائِبٌ':Added, #1: 1	عَدَلَ عِنْدَ
u'عَدْلٌ غِرَارَةٌ':Added, #1: 1	عَدْلٍ غَائِبٍ
u'عَدَّلَ فُرُوعٌ':Subject, #1: 1	عَدْلُ غِرَارَةٍ
u'عَدَلَ فَرِيقٌ':Subject, #1: 1	عَدَّلَ الْفُرُوعُ
u'عَدَلَ فلان':Subject, #1: 1	عَدَلَ الْفَرِيقُ
u'عَدَّلَ قَاسِمٌ':Subject, #1: 1	عَدَلَ الشَّافِعِيُّ
u'عَدَلَ قَائِلٌ':Subject, #1: 1	عَدَّلَ الْقَاسِمُ
u'عَدْلٌ مَأْمُونٌ':Added, #1: 1	عَدَلَ قَائِلُهُ
u'عَدْلٌ مُجْتَهِد':Added, #1: 1	عَدْلٍ مَأْمُونٍ
u'عَدَلَ مُسْتَحِقٌّ':Subject, #1: 1	عَدْلٍ مُجْتَهِدٍ
u'عَدْلٌ مُسْتَعْمَلٌ':Added, #1: 1	عَدَلَ الْمُسْتَحِقُّ
u'عَدْلٌ مُسْلِمٌ':Added, #1: 1	عَدْلٍ مُسْتَعْمَلٍ
u'عَدَّلَ مَشْهُودٌ':Subject, #2: 2	عَدْلٍ مُسْلِمٍ
u'عَدَلَ مُصَنِّفٌ':Subject, #1: 1	عَدَّلَ الْمَشْهُودُ
u'عَدَلَ مُعْسِرٌ':Subject, #10: 10	عَدَلَ الْمُصَنِّفُ
u'عَدَلَ مُوسِرٌ':Subject, #1: 1	عَدَلَ الْمُعْسِرُ
u'عَدَلَ نَبِيٌّ':Subject, #1: 1	عَدَلَ الْمُوسِرُ
u'عَدْلٌ واحد':Added, #1: 1	عَدَلَ النَّبِيُّ
u'عَدْلٌ وَاحِدٌ':Added, #16: 16	عَدْلٍ وَاحِدٍ
u'عَدْلٌ يَوْمٌ':Added, #16: 16	عَدْلٍ وَاحِدٍ
u'عَدَمٌ أَبٌ':Added, #1: 1	عَدْلُ يَوْمٍ
u'عَدَمٌ أَبٌ':Added, #1: 1	عَدَمُ الْأَبِ
u'عَدَمٌ أَبٌ':Added, #21: 21	عَدَمِ الْأَبِ
u'عَدَمٌ إبَاحَةٌ':Added, #4: 4	عَدَمَ الْأَبِ
u'عَدَمٌ إبَاحَةٌ':Added, #1: 1	عَدَمِ إبَاحَةِ
u'عَدَمٌ إبَاحَةٌ':Added, #1: 1	عَدَمُ إبَاحَتِهِ
u'عَدَمٌ إبَاحَةٌ':Added, #1: 1	عَدَمَ الْإِبَاحَةِ
u'عَدَمٌ إبَاحَةٌ':Added, #2: 2	عَدَمِ الْإِبَاحَةِ
u'عَدَمٌ إبْداءٌ':Added, #6: 6	عَدَمُ الْإِبَاحَةِ
u'عَدَمٌ إبدالٌ':Added, #1: 1	عَدَمَ إبْدَاءِ
u'عَدَمٌ إِبْطَالٌ':Added, #2: 2	عَدَمَ إبْدَالِهِ
u'عَدَمٌ إِبْطَالٌ':Added, #1: 1	عَدَمِ الْإِبْطَالِ
u'عَدِمَ اِبْنٌ':Predicate, #2: 2	عَدَمُ الْإِبْطَالِ
u'عَدَمٌ اِبْنَة':Added, #4: 4	عَدِمَ ابْنَ
u'عَدَمٌ أُبُوَّةٌ':Added, #1: 1	عَدَمِ ابْنَةِ
u'عَدَمٌ أُبُوَّةٌ':Added, #1: 1	عَدَمُ أُبُوَّةِ
u'عَدَمٌ اِتِّبَاعٌ':Added, #1: 1	عَدَمُ أُبُوَّتِهِ
u'عَدَمٌ اِتِّبَاعٌ':Added, #1: 1	عَدَمِ اتِّبَاعِ
u'عَدَمٌ اِتِّبَاعٌ':Added, #1: 1	عَدَمَ اتِّبَاعِهِ
u'عَدَمٌ اِتِّحَادٌ':Added, #1: 1	عَدَمُ اتِّبَاعِهِ
u'عَدَمٌ اِتِّخَاذٌ':Added, #1: 1	عَدَمُ اتِّحَادِ
u'عَدَمٌ اِتِّصَالٌ':Added, #1: 1	عَدَمَ اتِّخَاذِهِ
u'عَدَمٌ اِتِّصَالٌ':Added, #1: 1	عَدَمُ اتِّصَالِ
u'عَدَمٌ اِتِّصَالٌ':Added, #1: 1	عَدَمِ اتِّصَالِ
u'عَدَمٌ اِتِّفَاقٌ':Added, #1: 1	عَدَمُ اتِّصَالِهِ
u'عَدَمٌ إِتْلاَفٌ':Added, #1: 1	عَدَمُ اتِّفَاقِ
u'عَدَمٌ إِتْلاَفٌ':Added, #1: 1	عَدَمُ إتْلَافِهِ
u'عَدَمٌ إتْمَامٌ':Added, #1: 1	عَدَمِ إتْلَافِهِ
u'عَدَمٌ إتْمَامٌ':Added, #1: 1	عَدَمُ الْإِتْمَامِ
u'عَدَمٌ إتْمَامٌ':Added, #1: 1	عَدَمِ الْإِتْمَامِ
u'عَدَمٌ إِتْيانٌ':Added, #3: 3	عَدَمُ إتْمَامِ
u'عَدَمٌ إِتْيانٌ':Added, #1: 1	عَدَمَ إتْيَانِهِ
u'عَدَمٌ إِتْيانٌ':Added, #1: 1	عَدَمِ إتْيَانِهِ
u'عَدَمٌ إِتْيانٌ':Added, #2: 2	عَدَمُ إتْيَانِهِ
u'عَدَمٌ إِتْيانٌ':Added, #3: 3	عَدَمُ الْإِتْيَانِ
u'عَدَمٌ إِتْيانٌ':Added, #4: 4	عَدَمَ الْإِتْيَانِ
u'عَدَمٌ إثَابَةٌ':Added, #4: 4	عَدَمِ الْإِتْيَانِ
u'عَدَمٌ إِثَارَةٌ':Added, #1: 1	عَدَمُ الْإِثَابَةِ
u'عَدَمٌ إِثْبَاتٌ':Added, #1: 1	عَدَمَ إثَارَةِ
u'عَدَمٌ إِثْبَاتٌ':Added, #1: 1	عَدَمُ إثْبَاتِهِ
u'عَدَمٌ إِثْبَاتٌ':Added, #2: 2	عَدَمِ إثْبَاتِ
u'عَدَمٌ إِثْمٌ':Added, #2: 2	عَدَمِ إثْبَاتِهِ
u'عَدَمٌ إِثْمٌ':Added, #1: 1	عَدَمُ إثْمِهِ
u'عَدَمٌ إِثْمٌ':Added, #3: 3	عَدَمِ إثْمِ
u'عَدَمٌ إِثْمٌ':Added, #3: 3	عَدَمَ الْإِثْمِ
u'عَدَمٌ إِثْمٌ':Added, #6: 6	عَدَمِ الْإِثْمِ
u'عَدَمٌ إِجَابَةٌ':Added, #7: 7	عَدَمُ الْإِثْمِ
u'عَدَمٌ إِجَابَةٌ':Added, #1: 1	عَدَمِ إجَابَةِ
u'عَدَمٌ إِجَابَةٌ':Added, #1: 1	عَدَمَ إجَابَتِهِ
u'عَدَمٌ إِجَابَةٌ':Added, #1: 1	عَدَمِ إجَابَتِهِ
u'عَدَمٌ إجَارَةٌ':Added, #3: 3	عَدَمِ الْإِجَابَةِ
u'عَدَمٌ إجَارَةٌ':Added, #1: 1	عَدَمَ الْإِجَارَةِ
u'عَدَمٌ إجَارَةٌ':Added, #2: 2	عَدَمِ إجَارَةِ
u'عَدِمَ إجَازَةٌ':Predicate, #2: 2	عَدَمِ الْإِجَارَةِ
u'عَدَمٌ إجَازَةٌ':Added, #1: 1	عَدِمَ الْإِجَازَةَ
u'عَدَمٌ إجَازَةٌ':Added, #1: 1	عَدَمَ الْإِجَازَةِ
u'عَدَمٌ إجَازَةٌ':Added, #23: 23	عَدَمِ الْإِجَازَةِ
u'عَدَمٌ أجَانِبُ':Added, #6: 6	عَدَمِ إجَازَةِ
u'عَدَمٌ إِجْبَارٌ':Added, #2: 2	عَدَمِ الْأَجَانِبِ
u'عَدَمٌ إِجْبَارٌ':Added, #1: 1	عَدَمِ إجْبَارِ
u'عَدَمٌ إِجْبَارٌ':Added, #1: 1	عَدَمُ إجْبَارِهِ
u'عَدَمٌ إِجْبَارٌ':Added, #1: 1	عَدَمِ إجْبَارِهِ
u'عَدَمٌ إِجْبَارٌ':Added, #3: 3	عَدَمَ إجْبَارِ
u'عَدَمٌ إِجْبَارٌ':Added, #3: 3	عَدَمُ الْإِجْبَارِ
u'عَدَمٌ إِجْبَارٌ':Added, #4: 4	عَدَمَ الْإِجْبَارِ
u'عَدَمٌ اِجْتِمَاعٌ':Added, #8: 8	عَدَمِ الْإِجْبَارِ
u'عَدَمٌ اجْتِنَابٌ':Added, #1: 1	عَدَمُ اجْتِمَاعِ
u'عَدَمٌ اِجْتِهَادٌ':Added, #1: 1	عَدَمِ اجْتِنَابِ
u'عَدَمٌ إِجْحَافٌ':Added, #1: 1	عَدَمِ اجْتِهَادٍ
u'عَدَمٌ أَجْرٌ':Added, #1: 1	عَدَمَ الْإِجْحَافِ
u'عَدَمٌ أُجْرَةٌ':Added, #1: 1	عَدَمُ الْأَجْرِ
u'عَدَمٌ أُجْرَةٌ':Added, #1: 1	عَدَمَ الْأُجْرَةِ
u'عَدَمٌ إِجْزَاءٌ':Added, #1: 1	عَدَمُ الْأُجْرَةِ
u'عَدَمٌ إِجْزَاءٌ':Added, #11: 11	عَدَمُ إجْزَاءِ
u'عَدَمٌ إِجْزَاءٌ':Added, #12: 12	عَدَمِ الْإِجْزَاءِ
u'عَدَمٌ إِجْزَاءٌ':Added, #25: 25	عَدَمُ الْإِجْزَاءِ
u'عَدَمٌ إِجْزَاءٌ':Added, #28: 28	عَدَمَ الْإِجْزَاءِ
u'عَدَمٌ إِجْمَاعٌ':Added, #9: 9	عَدَمِ إجْزَاءِ
u'عَدَمٌ إِجْمَالٌ':Added, #1: 1	عَدَمِ الْإِجْمَاعِ
u'عَدَمٌ إِجْمَالٌ':Added, #1: 1	عَدَمَ الْإِجْمَالِ
u'عَدَمٌ إِجْمَالٌ':Added, #1: 1	عَدَمِ الْإِجْمَالِ
u'عَدَمٌ إحَاطَةٌ':Added, #2: 2	عَدَمُ الْإِجْمَالِ
u'عَدَمٌ إحَاطَةٌ':Added, #1: 1	عَدَمُ الْإِحَاطَةِ
u'عَدَمٌ إِحالَةٌ':Added, #1: 1	عَدَمِ الْإِحَاطَةِ
u'عَدَمٌ إِحْبَالٌ':Added, #1: 1	عَدَمِ إحَالَةِ
u'عَدَمٌ اِحْتِرَامٌ':Added, #2: 2	عَدَمُ الْإِحْبَالِ
u'عَدَمٌ اِحْتِسابٌ':Added, #1: 1	عَدَمَ احْتِرَامِهِ
u'عَدَمٌ اِحْتِمَالٌ':Added, #1: 1	عَدَمِ احْتِسَابِ
u'عَدَمٌ اِحْتِمَالٌ':Added, #1: 1	عَدَمُ احْتِمَالِ
u'عَدَمٌ اِحْتِمَالٌ':Added, #3: 3	عَدَمِ احْتِمَالِهِ
u'عَدَمٌ اِحْتِواءٌ':Added, #8: 8	عَدَمِ احْتِمَالِ
u'عَدِمَ اِحْتِيَاجٌ':Predicate, #1: 1	عَدَمُ احْتِوَاءِ
u'عَدَمٌ اِحْتِيَاجٌ':Added, #1: 1	عَدِمَ احْتِيَاجَ
u'عَدَمٌ اِحْتِيَاجٌ':Added, #1: 1	عَدَمَ احْتِيَاجِهِ
u'عَدَمٌ اِحْتِيَاجٌ':Added, #1: 1	عَدَمُ احْتِيَاجِهِ
u'عَدَمٌ اِحْتِيَاطٌ':Added, #2: 2	عَدَمُ احْتِيَاجِ
u'عَدَمٌ أحَدٌ':Added, #1: 1	عَدَمِ احْتِيَاطِهِ
u'عَدَمٌ إِحْرَازٌ':Added, #1: 1	عَدَمِ أَحَدِ
u'عَدَمٌ إِحْرَامٌ':Added, #1: 1	عَدَمَ الْإِحْرَازِ
u'عَدَمٌ إِحْرَامٌ':Added, #1: 1	عَدَمَ إحْرَامِ
u'عَدَمٌ إِحْرَامٌ':Added, #1: 1	عَدَمَ إحْرَامِهِ
u'عَدَمٌ إِحْرَامٌ':Added, #2: 2	عَدَمُ الْإِحْرَامِ
u'عَدَمٌ إِحْسَاسٌ':Added, #4: 4	عَدَمِ الْإِحْرَامِ
u'عَدَمٌ إِحْسَاسٌ':Added, #1: 1	عَدَمُ إحْسَاسِهِ
u'عَدَمٌ إحْسَانٌ':Added, #1: 1	عَدَمِ الْإِحْسَاسِ
u'عَدَمٌ إحْضَارٌ':Added, #1: 1	عَدَمُ الْإِحْسَانِ
u'عَدَمٌ أَحْكَامٌ':Added, #1: 1	عَدَمَ إحْضَارِهِ
u'عَدَمٌ أَحْكَامٌ':Added, #1: 1	عَدَمِ أَحْكَامِ
u'عَدَمٌ أَحْكَامٌ':Added, #1: 1	عَدَمُ الْأَحْكَامِ
u'عَدَمٌ أَخٌ':Added, #1: 1	عَدَمِ الْأَحْكَامِ
u'عَدَمٌ أَخٌ':Added, #1: 1	عَدَمِ أَخٍ
u'عَدَمٌ إِخْبَارٌ':Added, #3: 3	عَدَمِ الْأَخِ
u'عَدَمٌ إِخْبَارٌ':Added, #1: 1	عَدَمَ الْإِخْبَارِ
u'عَدَمٌ إِخْبَارٌ':Added, #1: 1	عَدَمُ الْإِخْبَارِ
u'عَدَمٌ أُخْتٌ':Added, #1: 1	عَدَمِ الْإِخْبَارِ
u'عَدَمٌ اِخْتِصَاصٌ':Added, #2: 2	عَدَمِ الْأُخْتِ
u'عَدَمٌ اِخْتِصَاصٌ':Added, #1: 1	عَدَمَ اخْتِصَاصِ
u'عَدَمٌ اِخْتِصَاصٌ':Added, #1: 1	عَدَمِ اخْتِصَاصِ
u'عَدَمٌ اِخْتِصَاصٌ':Added, #1: 1	عَدَم اخْتِصَاصِهِ
u'عَدَمٌ اِخْتِصَاصٌ':Added, #1: 1	عَدَمُ اخْتِصَاصِهِ
u'عَدَمٌ اِخْتِصَاصٌ':Added, #3: 3	عَدَمُ اخْتِصَاصِ
u'عَدَمٌ اِخْتِلاطٌ':Added, #4: 4	عَدَمِ اخْتِصَاصِهِ
u'عَدَمٌ اِخْتِلاَفٌ':Added, #1: 1	عَدَمِ اخْتِلَاطِ
u'عَدَمٌ اِخْتِلاَفٌ':Added, #1: 1	عَدَمَ اخْتِلَافِ
u'عَدَمٌ اِخْتِلاَفٌ':Added, #2: 2	عَدَمُ اخْتِلَافِ
u'عَدَمٌ اِخْتِلالٌ':Added, #4: 4	عَدَمِ اخْتِلَافِ
u'عَدَمٌ اِخْتِيَارٌ':Added, #1: 1	عَدَمِ اخْتِلَالِهِ
u'عَدَمٌ اِخْتِيَارٌ':Added, #1: 1	عَدَمِ اخْتِيَارِ
u'عَدَمٌ أخْذٌ':Added, #3: 3	عَدَمِ اخْتِيَارِهِ
u'عَدَمٌ أخْذٌ':Added, #1: 1	عَدَمِ أَخْذِهِ
u'عَدَمٌ أخْذٌ':Added, #2: 2	عَدَمُ أَخْذِ
u'عَدَمٌ أخْذٌ':Added, #2: 2	عَدَمِ أَخْذِ
u'عَدَمٌ أخْذٌ':Added, #2: 2	عَدَمُ الْأَخْذِ
u'عَدَمٌ أخْذٌ':Added, #3: 3	عَدَمَ أَخْذِ
u'عَدَمٌ أخْذٌ':Added, #5: 5	عَدَمِ الْأَخْذِ
u'عَدَمٌ إِخْرَاجٌ':Added, #6: 6	عَدَمَ الْأَخْذِ
u'عَدَمٌ إِخْرَاجٌ':Added, #1: 1	عَدَمِ إخْرَاجِ
u'عَدَمٌ إِخْرَاجٌ':Added, #1: 1	عَدَمِ الْإِخْرَاجِ
u'عَدَمٌ إِخْرَاجٌ':Added, #2: 2	عَدَمُ إخْرَاجِ
u'عَدَمٌ إِخْطَارٌ':Added, #2: 2	عَدَمَ الْإِخْرَاجِ
u'عَدَمٌ إِخْلاَصٌ':Added, #1: 1	عَدَمِ إخْطَارِهِ
u'عَدَمٌ أَخَوَاتٌ':Added, #1: 1	عَدَمَ إخْلَاصِهِ
u'عَدَمٌ إِخْوَةٌ':Added, #2: 2	عَدَمِ الْأَخَوَاتِ
u'عَدَمٌ أَدَاءٌ':Added, #2: 2	عَدَمِ الْإِخْوَةِ
u'عَدَمٌ أَدَاءٌ':Added, #2: 2	عَدَمِ أَدَاءِ
u'عَدَمٌ إِدَارَةٌ':Added, #7: 7	عَدَمِ الْأَدَاءِ
u'عَدَمٌ إدْخَالٌ':Added, #1: 1	عَدَمِ الْإِدَارَةِ
u'عَدَمٌ إِدْرَاكٌ':Added, #1: 1	عَدَمُ الْإِدْخَالِ
u'عَدَمٌ إِدْرَاكٌ':Added, #1: 1	عَدَمُ إدْرَاكِهِ
u'عَدَمٌ إِدْرَاكٌ':Added, #1: 1	عَدَمِ إدْرَاكِهِ
u'عَدَمٌ إِدْرَاكٌ':Added, #2: 2	عَدَمَ إدْرَاكِ
u'عَدَمٌ إِدْرَاكٌ':Added, #2: 2	عَدَمِ الْإِدْرَاكِ
u'عَدَمٌ إِدْرَاكٌ':Added, #3: 3	عَدَمَ الْإِدْرَاكِ
u'عَدَمٌ إِدْرَاكٌ':Added, #4: 4	عَدَمِ إدْرَاكِ
u'عَدَمٌ إِدْرَاكٌ':Added, #4: 4	عَدَمُ الْإِدْرَاكِ
u'عَدَمٌ أَذَانٌ':Added, #6: 6	عَدَمُ إدْرَاكِ
u'عَدَمٌ إِذْنٌ':Added, #1: 1	عَدَمُ الْأَذَانِ
u'عَدَمٌ إِذْنٌ':Added, #10: 10	عَدَمُ الْإِذْنِ
u'عَدَمٌ إِذْنٌ':Added, #1: 1	عَدَمُ إذْنِ
u'عَدَمٌ إِذْنٌ':Added, #21: 21	عَدَمِ الْإِذْنِ
u'عَدَمٌ إِذْنٌ':Added, #2: 2	عَدَمِ إذْنِ
u'عَدَمٌ إِذْنٌ':Added, #3: 3	عَدَمَ إذْنِهِ
u'عَدَمٌ إِذْنٌ':Added, #3: 3	عَدَمَ الْإِذْنِ
u'عَدَمٌ إِرَادَةٌ':Added, #4: 4	عَدَمِ إذْنِهِ
u'عَدَمٌ إِرَادَةٌ':Added, #1: 1	عَدَم إرَادَةِ
u'عَدَمٌ إِرَادَةٌ':Added, #1: 1	عَدَمُ إرَادَةِ
u'عَدَمٌ إِرَادَةٌ':Added, #1: 1	عَدَمُ إرَادَتِهِ
u'عَدَمٌ إِرَادَةٌ':Added, #1: 1	عَدَمُ الْإِرَادَةِ
u'عَدَمٌ إِرَادَةٌ':Added, #26: 26	عَدَمِ إرَادَةِ
u'عَدَمٌ إِرَادَةٌ':Added, #2: 2	عَدَمَ إرَادَتِهِ
u'عَدَمٌ إِرَادَةٌ':Added, #4: 4	عَدَمَ إرَادَةِ
u'عَدَمٌ إِرَادَةٌ':Added, #7: 7	عَدَمِ إرَادَتِهِ
u'عَدَمٌ أَرْبَعَةٌ':Added, #8: 8	عَدَمِ الْإِرَادَةِ
u'عَدَمٌ اِرْتِدَادٌ':Added, #2: 2	عَدَمِ الْأَرْبَعَةِ
u'عَدَمٌ اِرْتِفَاعٌ':Added, #1: 1	عَدَمِ ارْتِدَادِ
u'عَدَمٌ اِرْتِفَاعٌ':Added, #2: 2	عَدَمُ ارْتِفَاعِ
u'عَدَمٌ إِرْثٌ':Added, #2: 2	عَدَمِ ارْتِفَاعِ
u'عَدَمٌ إِرْثٌ':Added, #1: 1	عَدَمَ إرْثِ
u'عَدَمٌ إِرْثٌ':Added, #1: 1	عَدَمِ إرْثِ
u'عَدَمٌ إِرْثٌ':Added, #1: 1	عَدَمَ الْإِرْثِ
u'عَدَمٌ إِرْثٌ':Added, #2: 2	عَدَمَ إرْثِهِ
u'عَدَمٌ إِرْثٌ':Added, #2: 2	عَدَمُ إرْثِهِ
u'عَدَمٌ إِرْثٌ':Added, #4: 4	عَدَمُ الْإِرْثِ
u'عَدَمٌ إِرْسَالٌ':Added, #6: 6	عَدَمِ الْإِرْثِ
u'عَدَمٌ إِرْسَالٌ':Added, #1: 1	عَدَمُ إرْسَالِ
u'عَدَمٌ إِرْسَالٌ':Added, #1: 1	عَدَمُ إرْسَالِهِ
u'عَدَمٌ إِرْسَالٌ':Added, #1: 1	عَدَمِ الْإِرْسَالِ
u'عَدِمَ إِزَارٌ':Predicate, #3: 3	عَدَمُ الْإِرْسَالِ
u'عَدَمٌ إِزَالَةٌ':Added, #1: 1	عَدِمَ الْإِزَارَ
u'عَدَمٌ إِزَالَةٌ':Added, #1: 1	عَدَمُ إزَالَةِ
u'عَدَمٌ إِزَالَةٌ':Added, #1: 1	عَدَمِ إزَالَةِ
u'عَدَمٌ إِزْعَاجٌ':Added, #1: 1	عَدَمَ الْإِزَالَةِ
u'عَدَمٌ إِسَاءةٌ':Added, #1: 1	عَدَمُ إزْعَاجِهِ
u'عَدَمٌ إِسَاءةٌ':Added, #1: 1	عَدَمِ إسَاءَةِ
u'عَدَمٌ أسْبَابٌ':Added, #1: 1	عَدَمِ الْإِسَاءَةِ
u'عَدَمٌ أسْبَابٌ':Added, #1: 1	عَدَمُ أَسْبَابٍ
u'عَدَمٌ أَسْبَابٌ':Added, #1: 1	عَدَمِ أَسْبَابٍ
u'عَدَمٌ أَسْبَابٌ':Added, #1: 1	عَدَمُ أَسْبَابٍ
u'عَدَمٌ إِسْبَاغٌ':Added, #1: 1	عَدَمِ أَسْبَابٍ
u'عَدَمٌ اِسْتِحَالَةٌ':Added, #1: 1	عَدَمُ الْإِسْبَاغِ
u'عَدَمٌ اِسْتِحْسان':Added, #1: 1	عَدَمِ اسْتِحَالَةِ
u'عَدَمٌ اِسْتِحْضَارٌ':Added, #1: 1	عَدَمَ اسْتِحْسَانِ
u'عَدَمٌ اِسْتِحْقَاقٌ':Added, #1: 1	عَدَمُ اسْتِحْضَارِ
u'عَدَمٌ اِسْتِحْقَاقٌ':Added, #13: 13	عَدَمِ اسْتِحْقَاقِ
u'عَدَمٌ اِسْتِحْقَاقٌ':Added, #2: 2	عَدَمَ اسْتِحْقَاقِ
u'عَدَمٌ اِسْتِحْقَاقٌ':Added, #3: 3	عَدَمُ اسْتِحْقَاقِهِ
u'عَدَمٌ اِسْتِحْقَاقٌ':Added, #4: 4	عَدَمُ اسْتِحْقَاقِ
u'عَدَمٌ اِسْتِحْقَاقٌ':Added, #4: 4	عَدَمِ اسْتِحْقَاقِهِ
u'عَدَمٌ اِسْتِرْدَادٌ':Added, #6: 6	عَدَمَ اسْتِحْقَاقِهِ
u'عَدَمٌ اِسْتِرْدَادٌ':Added, #1: 1	عَدَمَ اسْتِرْدَادِ
u'عَدَمٌ اِسْتِرْدَادٌ':Added, #1: 1	عَدَمُ اسْتِرْدَادِهِ
u'عَدَمٌ اِسْتِطاعَةٌ':Added, #2: 2	عَدَمِ اسْتِرْدَادِهِ
u'عَدَمٌ اِسْتِطاعَةٌ':Added, #1: 1	عَدَمُ اسْتِطَاعَةِ
u'عَدَمٌ اِسْتِطاعَةٌ':Added, #1: 1	عَدَمِ اسْتِطَاعَةِ
u'عَدَمٌ اِسْتِعْمالٌ':Added, #1: 1	عَدَمَ اسْتِطَاعَتِهِ
u'عَدَمٌ اِسْتِعْمالٌ':Added, #1: 1	عَدَمَ اسْتِعْمَالِ
u'عَدَمٌ اِسْتِعْمالٌ':Added, #1: 1	عَدَمُ اسْتِعْمَالِ
u'عَدَمٌ اِسْتِعْمالٌ':Added, #1: 1	عَدَمَ اسْتِعْمَالِهِ
u'عَدَمٌ اِسْتِغْرَاقٌ':Added, #2: 2	عَدَمِ اسْتِعْمَالِهِ
u'عَدَمٌ اِسْتِقامَةٌ':Added, #1: 1	عَدَمُ اسْتِغْرَاقِهِ
u'عَدَمٌ اِسْتِقامَةٌ':Added, #1: 1	عَدَمَ اسْتِقَامَةِ
u'عَدَمٌ اِسْتِقْرارٌ':Added, #1: 1	عَدَمِ اسْتِقَامَتِهِ
u'عَدَمٌ اِسْتِقْرارٌ':Added, #1: 1	عَدَمَ اسْتِقْرَارِ
u'عَدَمٌ اِسْتِقْرارٌ':Added, #1: 1	عَدَمُ اسْتِقْرَارِ
u'عَدَمٌ اِسْتِقْرارٌ':Added, #1: 1	عَدَمِ اسْتِقْرَارِهِ
u'عَدَمٌ اِسْتِقْرارٌ':Added, #2: 2	عَدَمِ اسْتِقْرَارِ
u'عَدَمٌ اِسْتِقْلالٌ':Added, #2: 2	عَدَمُ اسْتِقْرَارِهِ
u'عَدَمٌ اِسْتِقْلالٌ':Added, #1: 1	عَدَمُ اسْتِقْلَالِ
u'عَدَمٌ اِسْتِقْلالٌ':Added, #1: 1	عَدَمُ اسْتِقْلَالِهِ
u'عَدَمٌ اِسْتِلْزامٌ':Added, #1: 1	عَدَمِ اسْتِقْلَالِهِ
u'عَدَمٌ اِسْتِمْرارٌ':Added, #2: 2	عَدَمِ اسْتِلْزَامِ
u'عَدَمٌ اِسْتِمْرارٌ':Added, #1: 1	عَدَمُ اسْتِمْرَارِ
u'عَدَمٌ اِسْتِمْرارٌ':Added, #1: 1	عَدَمِ اسْتِمْرَارِ
u'عَدَمٌ اِسْتِمْساك':Added, #1: 1	عَدَمُ اسْتِمْرَارِهِ
u'عَدَمٌ اِسْتِنْباطٌ':Added, #1: 1	عَدَمُ اسْتِمْسَاكٍ
u'عَدَمٌ اِسْتيعابٌ':Added, #1: 1	عَدَمِ اسْتِنْبَاطِ
u'عَدَمٌ اِسْتيفاءٌ':Added, #1: 1	عَدَمِ اسْتِيعَابِ
u'عَدَمٌ اِسْتيفاءٌ':Added, #1: 1	عَدَمَ اسْتِيفَاءِ
u'عَدَمٌ إِسْرافٌ':Added, #2: 2	عَدَمُ اسْتِيفَاءِ
u'عَدَمٌ إِسْكارٌ':Added, #1: 1	عَدَمَ الْإِسْرَافِ
u'عَدَمٌ إِسْكارٌ':Added, #1: 1	عَدَمُ الْإِسْكَارِ
u'عَدَمٌ إِسْكانٌ':Added, #1: 1	عَدَمِ الْإِسْكَارِ
u'عَدَمٌ إِسْلامٌ':Added, #1: 1	عَدَمُ إسْكَانِهِ
u'عَدَمٌ إِسْلامٌ':Added, #1: 1	عَدَمَ إسْلَامِ
u'عَدَمٌ إِسْلامٌ':Added, #1: 1	عَدَمِ إسْلَامِ
u'عَدَمٌ إِسْلامٌ':Added, #1: 1	عَدَمُ إسْلَامِهِ
u'عَدَمٌ إِسْلامٌ':Added, #2: 2	عَدَمُ الْإِسْلَامِ
u'عَدَمٌ إِسْماعٌ':Added, #3: 3	عَدَمِ الْإِسْلَامِ
u'عَدَمٌ أسْنَانٌ':Added, #1: 1	عَدَمَ الْإِسْمَاعِ
u'عَدَمٌ إِسْهامٌ':Added, #1: 1	عَدَمِ أَسْنَانِهِ
u'عَدَمٌ إشارَة':Added, #1: 1	عَدَمِ الْإِسْهَامِ
u'عَدَمٌ اِشْتِباهٌ':Added, #6: 6	عَدَمِ الْإِشَارَةِ
u'عَدَمٌ اِشْتِراطٌ':Added, #1: 1	عَدَمُ اشْتِبَاهِ
u'عَدَمٌ اِشْتِراطٌ':Added, #10: 10	عَدَمِ اشْتِرَاطِهِ
u'عَدَمٌ اِشْتِراطٌ':Added, #16: 16	عَدَمُ اشْتِرَاطِهِ
u'عَدَمٌ اِشْتِراطٌ':Added, #1: 1	عَدَمُ اشْتِرَاطٍ
u'عَدَمٌ اِشْتِراطٌ':Added, #25: 25	عَدَمَ اشْتِرَاطِ
u'عَدَمٌ اِشْتِراطٌ':Added, #46: 46	عَدَمُ اشْتِرَاطِ
u'عَدَمٌ اِشْتِراطٌ':Added, #4: 4	عَدَمَ اشْتِرَاطِهِ
u'عَدَمٌ اِشْتِغالٌ':Added, #73: 73	عَدَمِ اشْتِرَاطِ
u'عَدَمٌ اِشْتِمالٌ':Added, #1: 1	عَدَمُ اشْتِغَالِ
u'عَدَمٌ اِشْتِمالٌ':Added, #1: 1	عَدَمَ اشْتِمَالِ
u'عَدَمٌ اِشْتِمالٌ':Added, #1: 1	عَدَمَ اشْتِمَالِهِ
u'عَدَمٌ اِشْتِهارٌ':Added, #1: 1	عَدَمُ اشْتِمَالِهِ
u'عَدَمٌ إِشْراكٌ':Added, #1: 1	عَدَمِ اشْتِهَارِهِ
u'عَدَمٌ إِشْعارٌ':Added, #1: 1	عَدَمِ الْإِشْرَاكِ
u'عَدَمٌ إصابَةٌ':Added, #1: 1	عَدَمَ إشْعَارِهِ
u'عَدَمٌ إصابَةٌ':Added, #1: 1	عَدَمُ إصَابَتِهِ
u'عَدَمٌ إصابَةٌ':Added, #1: 1	عَدَمِ إصَابَتِهِ
u'عَدَمٌ أَصْحَابٌ':Added, #3: 3	عَدَمُ إصَابَةِ
u'عَدَمٌ إِصْرارٌ':Added, #1: 1	عَدَمِ أَصْحَابِ
u'عَدِمَ أصل':Predicate, #1: 1	عَدَمُ الْإِصْرَارِ
u'عَدِمَ أًصْلٌ':Predicate, #1: 1	أَعْدَمَ أَصْلَ
u'عَدَمٌ أصل':Added, #1: 1	أَعْدَمَ أَصْلَ
u'عَدَمٌ أًصْلٌ':Added, #6: 6	عَدَمِ الْأَصْلِ
u'عَدَمٌ إِصْلاحٌ':Added, #6: 6	عَدَمِ الْأَصْلِ
u'عَدَمٌ إِصْلاحٌ':Added, #2: 2	عَدَمِ إصْلَاحِ
u'عَدَمٌ أَصْنَافٌ':Added, #3: 3	عَدَمَ إصْلَاحِهِ
u'عَدَمٌ إضافَةٌ':Added, #3: 3	عَدَمِ الْأَصْنَافِ
u'عَدَمٌ إضافَةٌ':Added, #1: 1	عَدَمَ إضَافَتِهِ
u'عَدَمٌ إضافَةٌ':Added, #1: 1	عَدَمُ إضَافَتِهِ
u'عَدَمٌ إضْمارٌ':Added, #2: 2	عَدَمِ الْإِضَافَةِ
u'عَدَمٌ إضْمارٌ':Added, #1: 1	عَدَمُ الْإِضْمَارِ
u'عَدَمٌ إِطالَةٌ':Added, #3: 3	عَدَمِ الْإِضْمَارِ
u'عَدَمٌ اِطِّرادٌ':Added, #1: 1	عَدَمُ إطَالَةِ
u'عَدَمٌ اِطِّرادٌ':Added, #1: 1	عَدَمِ اطِّرَادِهِ
u'عَدَمٌ اِطِّلاعٌ':Added, #2: 2	عَدَمِ اطِّرَادِ
u'عَدَمٌ اِطِّلاعٌ':Added, #1: 1	عَدَمُ اطِّلَاعِ
u'عَدَمٌ اِطِّلاعٌ':Added, #1: 1	عَدَمِ اطِّلَاعِ
u'عَدَمٌ اِطِّلاعٌ':Added, #1: 1	عَدَمَ اطِّلَاعِهِ
u'عَدَمٌ إِطْلاعٌ':Added, #1: 1	عَدَمِ اطِّلَاعِهِ
u'عَدَمٌ إِطْلاقٌ':Added, #1: 1	عَدَمَ الْإِطْلَاعِ
u'عَدَمٌ إِطْلاقٌ':Added, #1: 1	عَدَمُ إطْلَاقِ
u'عَدَمٌ إِظْهارٌ':Added, #2: 2	عَدَمِ الْإِطْلَاقِ
u'عَدَمٌ إِظْهارٌ':Added, #1: 1	عَدَمَ إظْهَارِ
u'عَدَمٌ إِظْهارٌ':Added, #1: 1	عَدَمُ إظْهَارِ
u'عَدَمٌ إِعادَةٌ':Added, #2: 2	عَدَمِ إظْهَارِ
u'عَدَمٌ إِعادَةٌ':Added, #1: 1	عَدَمَ إعَادَةِ
u'عَدَمٌ إِعادَةٌ':Added, #1: 1	عَدَمِ إعَادَةِ
u'عَدَمٌ إِعادَةٌ':Added, #1: 1	عَدَمِ إعَادَتِهِ
u'عَدَمٌ إِعادَةٌ':Added, #2: 2	عَدَمَ الْإِعَادَةِ
u'عَدَمٌ إِعادَةٌ':Added, #3: 3	عَدَمُ إعَادَةِ
u'عَدَمٌ إِعادَةٌ':Added, #7: 7	عَدَمِ الْإِعَادَةِ
u'عَدَمٌ إِعانَةٌ':Added, #8: 8	عَدَمُ الْإِعَادَةِ
u'عَدَمٌ إِعانَةٌ':Added, #1: 1	عَدَمَ الْإِعَانَةِ
u'عَدَمٌ إِعانَةٌ':Added, #1: 1	عَدَمُ الْإِعَانَةِ
u'عَدَمٌ إِعْتاقٌ':Added, #1: 1	عَدَمِ الْإِعَانَةِ
u'عَدَمٌ اِعْتِبارٌ':Added, #3: 3	عَدَمُ الْإِعْتَاقِ
u'عَدَمٌ اِعْتِبارٌ':Added, #11: 11	عَدَمُ اعْتِبَارِهِ
u'عَدَمٌ اِعْتِبارٌ':Added, #14: 14	عَدَمَ اعْتِبَارِ
u'عَدَمٌ اِعْتِبارٌ':Added, #30: 30	عَدَمُ اعْتِبَارِ
u'عَدَمٌ اِعْتِبارٌ':Added, #36: 36	عَدَمِ اعْتِبَارِ
u'عَدَمٌ اِعْتِبارٌ':Added, #7: 7	عَدَمَ اعْتِبَارِهِ
u'عَدَمٌ اِعْتِدادٌ':Added, #7: 7	عَدَمِ اعْتِبَارِهِ
u'عَدَمٌ اِعْتِدادٌ':Added, #1: 1	عَدَمَ اعْتِدَادِ
u'عَدَمٌ اِعْتِدالٌ':Added, #1: 1	عَدَمِ اعْتِدَادِهِ
u'عَدَمٌ اِعْتِقادٌ':Added, #1: 1	عَدَمِ اعْتِدَالِهِ
u'عَدَمٌ اِعْتِقادٌ':Added, #1: 1	عَدَمُ اعْتِقَادِ
u'عَدَمٌ اِعْتِقادٌ':Added, #1: 1	عَدَمِ اعْتِقَادِهِ
u'عَدَمٌ اِعْتِقادٌ':Added, #2: 2	عَدَمِ اعْتِقَادِ
u'عَدَمٌ اِعْتِمادٌ':Added, #2: 2	عَدَمُ اعْتِقَادِهِ
u'عَدَمٌ إِعْجازٌ':Added, #2: 2	عَدَمَ اعْتِمَادِ
u'عَدَمٌ إعْطَاءٌ':Added, #1: 1	عَدَمَ الْإِعْجَازِ
u'عَدَمٌ إعْطَاءٌ':Added, #1: 1	عَدَمَ الْإِعْطَاءِ
u'عَدَمٌ إعْطَاءٌ':Added, #2: 2	عَدَمِ إعْطَاءِ
u'عَدَمٌ إعْلاَمٌ':Added, #4: 4	عَدَمُ الْإِعْطَاءِ
u'عَدَمٌ إعْمَالٌ':Added, #3: 3	عَدَمِ إعْلَامِهِ
u'عَدَمٌ إفَادَةٌ':Added, #1: 1	عَدَمُ إعْمَالِ
u'عَدَمٌ إفَادَةٌ':Added, #1: 1	عَدَمِ الْإِفَادَةِ
u'عَدَمٌ إفَادَةٌ':Added, #3: 3	عَدَمِ إفَادَةِ
u'عَدَمٌ إفَادَةٌ':Added, #4: 4	عَدَمِ إفَادَتِهِ
u'عَدَمٌ إفْتَاءٌ':Added, #5: 5	عَدَمُ إفَادَةِ
u'عَدَمٌ اِفْتِرَاضٌ':Added, #1: 1	عَدَمُ الْإِفْتَاءِ
u'عَدَمٌ اِفْتِرَاقٌ':Added, #1: 1	عَدَمُ افْتِرَاضِ
u'عَدَمٌ اِفْتِقَارٌ':Added, #1: 1	عَدَمِ افْتِرَاقِ
u'عَدَمٌ اِفْتِقَارٌ':Added, #1: 1	عَدَمِ افْتِقَارِ
u'عَدَمٌ اِفْتِقَارٌ':Added, #1: 1	عَدَمَ افْتِقَارِهِ
u'عَدَمٌ إِفْرَادٌ':Added, #1: 1	عَدَمِ افْتِقَارِهِ
u'عَدَمٌ إفْسَادٌ':Added, #1: 1	عَدَمِ الْإِفْرَادِ
u'عَدَمٌ إفْسَادٌ':Added, #1: 1	عَدَمِ إفْسَادِ
u'عَدَمٌ إفْسَادٌ':Added, #1: 1	عَدَمَ الْإِفْسَادِ
u'عَدَمٌ إفْسَادٌ':Added, #1: 1	عَدَمِ الْإِفْسَادِ
u'عَدَمٌ إفْسَادٌ':Added, #2: 2	عَدَمُ إفْسَادِ
u'عَدَمٌ إفْسَادٌ':Added, #2: 2	عَدَمِ إفْسَادِهِ
u'عَدَمٌ إفْصَاحٌ':Added, #3: 3	عَدَمُ الْإِفْسَادِ
u'عَدَمٌ أفْضَلِيَّةٌ':Added, #1: 1	عَدَمُ إفْصَاحٍ
u'عَدَمٌ إِفْطارٌ':Added, #1: 1	عَدَمُ الْأَفْضَلِيَّةِ
u'عَدَمٌ إِفْطارٌ':Added, #1: 1	عَدَمُ إفْطَارِهِ
u'عَدَمٌ إِفْطارٌ':Added, #1: 1	عَدَمُ الْإِفْطَارِ
u'عَدَمٌ إِفْطارٌ':Added, #2: 2	عَدَمَ الْإِفْطَارِ
u'عَدَمٌ إقامَةٌ':Added, #3: 3	عَدَمِ الْإِفْطَارِ
u'عَدَمٌ إقامَةٌ':Added, #1: 1	عَدَمَ إقَامَةِ
u'عَدَمٌ إقامَةٌ':Added, #1: 1	عَدَمِ إقَامَةِ
u'عَدَمٌ إقامَةٌ':Added, #1: 1	عَدَمُ إقَامَتِهِ
u'عَدَمٌ إقامَةٌ':Added, #1: 1	عَدَمِ الْإِقَامَةِ
u'عَدَمٌ إقامَةٌ':Added, #2: 2	عَدَمُ إقَامَةٍ
u'عَدَمٌ اِقْتِران':Added, #2: 2	عَدَمُ إقَامَةِ
u'عَدَمٌ اِقْتِصَارٌ':Added, #1: 1	عَدَمِ اقْتِرَانِ
u'عَدَمٌ اِقْتِضَاءٌ':Added, #1: 1	عَدَمِ اقْتِصَارِهِ
u'عَدَمٌ اِقْتِضَاءٌ':Added, #1: 1	عَدَمُ اقْتِضَاءِ
u'عَدَمٌ إقْدَامٌ':Added, #1: 1	عَدَمِ اقْتِضَاءِ
u'عَدَمٌ إقْرَارٌ':Added, #1: 1	عَدَمُ إقْدَامِ
u'عَدَمٌ إقْرَارٌ':Added, #1: 1	عَدَمِ إقْرَارِ
u'عَدَمٌ إقْرَارٌ':Added, #1: 1	عَدَمِ الْإِقْرَارِ
u'عَدَمٌ إقْطَاعٌ':Added, #2: 2	عَدَمُ الْإِقْرَارِ
u'عَدِمَ أَكْثَرُ':Subject, #3: 3	عَدَمِ إقْطَاعٍ
u'عَدَمٌ إكْرَاهٌ':Added, #1: 1	عَدِمَ أَكْثَرُ
u'عَدَمٌ إكْرَاهٌ':Added, #3: 3	عَدَمِ الْإِكْرَاهِ
u'عَدَمٌ أكل':Added, #4: 4	عَدَمُ الْإِكْرَاهِ
u'عَدَمٌ أَكْلٌ':Added, #1: 1	عَدَمُ أَكْلِ
u'عَدَمٌ أكل':Added, #1: 1	عَدَمُ أَكْلِ
u'عَدَمٌ أكل':Added, #1: 1	عَدَمُ أَكْلِهِ
u'عَدَمٌ أَكْلٌ':Added, #1: 1	عَدَمِ أَكْلِهِ
u'عَدَمٌ أَكْلٌ':Added, #1: 1	عَدَمُ أَكْلِهِ
u'عَدَمٌ أكل':Added, #1: 1	عَدَمِ أَكْلِهِ
u'عَدَمٌ أَكْلٌ':Added, #2: 2	عَدَمِ أَكْلِ
u'عَدَمٌ أكل':Added, #2: 2	عَدَمِ أَكْلِ
u'عَدَمٌ أَكْلٌ':Added, #2: 2	عَدَمَ الْأَكْلِ
u'عَدَمٌ أكل':Added, #2: 2	عَدَمَ الْأَكْلِ
u'عَدَمٌ أكل':Added, #4: 4	عَدَمُ الْأَكْلِ
u'عَدَمٌ أَكْلٌ':Added, #4: 4	عَدَمِ الْأَكْلِ
u'عَدَمٌ أَكْلٌ':Added, #4: 4	عَدَمُ الْأَكْلِ
u'عَدَمٌ إلْبَاسٌ':Added, #4: 4	عَدَمِ الْأَكْلِ
u'عَدِمَ آلةٌ':Predicate, #1: 1	عَدَمِ الْإِلْبَاسِ
u'عَدَمٌ آلةٌ':Added, #3: 3	عَدِمَ آلَةَ
u'عَدَمٌ آلةٌ':Added, #1: 1	عَدَمَ الْآلَةِ
u'عَدَمٌ اِلْتِبَاسٌ':Added, #1: 1	عَدَمُ آلَةِ
u'عَدَمٌ اِلْتِحَاقٌ':Added, #1: 1	عَدَمُ الْتِبَاسِ
u'عَدَمٌ اِلْتِزَامٌ':Added, #1: 1	عَدَمُ الْتِحَاقِهِ
u'عَدَمٌ اِلْتِفَاتٌ':Added, #1: 1	عَدَمِ الْتِزَامِ
u'عَدَمٌ إلْحَاقٌ':Added, #1: 1	عَدَمُ الْتِفَاتِ
u'عَدَمٌ إلْحَاقٌ':Added, #1: 1	عَدَمَ الْإِلْحَاقِ
u'عَدَمٌ إلْحَاقٌ':Added, #1: 1	عَدَمِ الْإِلْحَاقِ
u'عَدَمٌ إلْحَاقٌ':Added, #2: 2	عَدَمُ إلْحَاقِ
u'عَدَمٌ إلْحَاقٌ':Added, #2: 2	عَدَمَ إلْحَاقِهِ
u'عَدَمٌ إِلْزَامٌ':Added, #8: 8	عَدَمُ الْإِلْحَاقِ
u'عَدَمٌ إلْغَاءٌ':Added, #1: 1	عَدَمُ إلْزَامِهِ
u'عَدَمٌ أُلْفَةٌ':Added, #1: 1	عَدَمِ إلْغَاءِ
u'عَدَمٌ إِلْمَامٌ':Added, #1: 1	عَدَمِ الْأُلْفَةِ
u'عَدَمٌ إِلْمَامٌ':Added, #1: 1	عَدَمِ الْإِلْمَامِ
u'عَدَمٌ إِلْمَامٌ':Added, #2: 2	عَدَمُ الْإِلْمَامِ
u'عَدِمَ إمَامٌ':Subject, #3: 3	عَدَمَ الْإِلْمَامِ
u'عَدَمٌ إمَامٌ':Added, #1: 1	عَدِمَ الْإِمَامُ
u'عَدَمٌ إمَامٌ':Added, #1: 1	عَدَمِ إمَامٍ
u'عَدَمٌ إمَامَةٌ':Added, #5: 5	عَدَمِ الْإِمَامِ
u'عَدَمٌ أمَانٌ':Added, #1: 1	عَدَمِ إمَامَتِهِ
u'عَدَمٌ أمَانَةٌ':Added, #2: 2	عَدَمُ الْأَمَانِ
u'عَدَمٌ أمَانَةٌ':Added, #1: 1	عَدَمُ الْأَمَانَةِ
u'عَدَمٌ اِمْتِثَالٌ':Added, #1: 1	عَدَمِ الْأَمَانَةِ
u'عَدَمٌ اِمْتِناعٌ':Added, #1: 1	عَدَمَ امْتِثَالِ
u'عَدَمٌ اِمْتِناعٌ':Added, #1: 1	عَدَمُ امْتِنَاعِ
u'عَدَمٌ اِمْتِناعٌ':Added, #1: 1	عَدَمِ امْتِنَاعِهِ
u'عَدَمٌ اِمْتِناعٌ':Added, #2: 2	عَدَمُ امْتِنَاعِهِ
u'عَدَمٌ آمِرٌ':Added, #3: 3	عَدَمِ امْتِنَاعِ
u'عَدَمٌ أَمْرٌ':Added, #1: 1	عَدَمِ الْآمِرِ
u'عَدَمٌ أَمْرٌ':Added, #1: 1	عَدَمَ الْأَمْرِ
u'عَدَمٌ أَمْرٌ':Added, #1: 1	عَدَمُ الْأَمْرَيْنِ
u'عَدَمٌ أَمْرٌ':Added, #1: 1	عَدَمِ أَمْرِهِ
u'عَدَمٌ أَمْرٌ':Added, #2: 2	عَدَمُ أَمْرِهِ
u'عَدَمٌ إِمْساكٌ':Added, #7: 7	عَدَمِ الْأَمْرِ
u'عَدَمٌ إِمْساكٌ':Added, #1: 1	عَدَمِ الْإِمْسَاكِ
u'عَدَمٌ إِمْعانٌ':Added, #2: 2	عَدَمَ الْإِمْسَاكِ
u'عَدَمٌ إِمْكانٌ':Added, #1: 1	عَدَمِ إمْعَانِ
u'عَدَمٌ إِمْكانٌ':Added, #10: 10	عَدَمِ الْإِمْكَانِ
u'عَدَمٌ إِمْكانٌ':Added, #1: 1	عَدَمَ إمْكَانِهِ
u'عَدَمٌ إِمْكانٌ':Added, #2: 2	عَدَمَ الْإِمْكَانِ
u'عَدَمٌ إِمْكانٌ':Added, #2: 2	عَدَمِ إمْكَانِهِ
u'عَدَمٌ إِمْكانٌ':Added, #3: 3	عَدَمُ الْإِمْكَانِ
u'عَدَمٌ إِمْكانٌ':Added, #3: 3	عَدَمُ إمْكَانِهِ
u'عَدَمٌ إِمْكانٌ':Added, #4: 4	عَدَمَ إمْكَانِ
u'عَدَمٌ إِمْكانٌ':Added, #7: 7	عَدَمُ إمْكَانِ
u'عَدَمٌ أَمْنٌ':Added, #9: 9	عَدَمِ إمْكَانِ
u'عَدَمٌ أَمْنٌ':Added, #1: 1	عَدَمُ الْأَمْنِ
u'عَدَمٌ أُمِّيٌّ':Added, #3: 3	عَدَمِ الْأَمْنِ
u'عَدَمٌ أُمِّيَّةٌ':Added, #1: 1	عَدَمُ أُمِّيَّةِ
u'عَدَمٌ إِنْباتٌ':Added, #1: 1	عَدَمُ أُمِّيَّةِ
u'عَدَمٌ اِنْتِظارٌ':Added, #1: 1	عَدَمُ إنْبَاتِهِ
u'عَدَمٌ اِنْتِظامٌ':Added, #1: 1	عَدَمِ انْتِظَارِ
u'عَدَمٌ اِنْتِفاء':Added, #2: 2	عَدَمُ انْتِظَامِ
u'عَدَمٌ اِنْتِفاء':Added, #1: 1	عَدَمُ انْتِفَاءِ
u'عَدَمٌ اِنْتِفاعٌ':Added, #2: 2	عَدَمِ انْتِفَاءِ
u'عَدَمٌ اِنْتِقاضٌ':Added, #1: 1	عَدَمِ انْتِفَاعِهِ
u'عَدَمٌ اِنْتِقاضٌ':Added, #1: 1	عَدَمُ انْتِقَاضِ
u'عَدَمٌ اِنْتِقالٌ':Added, #3: 3	عَدَمِ انْتِقَاضِ
u'عَدَمٌ اِنْتِقالٌ':Added, #1: 1	عَدَمُ انْتِقَالِهِ
u'عَدَمٌ اِنْتِقالٌ':Added, #1: 1	عَدَمِ انْتِقَالِهِ
u'عَدَمٌ اِنْتِهاءٌ':Added, #3: 3	عَدَمِ انْتِقَالِ
u'عَدَمٌ اِنْتِهاكٌ':Added, #1: 1	عَدَمُ انْتِهَاءِ
u'عَدَمٌ اِنْحِصارٌ':Added, #1: 1	عَدَمُ انْتِهَاكِ
u'عَدَمٌ اِنْحِصارٌ':Added, #1: 1	عَدَمُ انْحِصَارِ
u'عَدَمٌ اِنْحِلالٌ':Added, #1: 1	عَدَمِ انْحِصَارِ
u'عَدَمٌ اِنْحِلالٌ':Added, #1: 1	عَدَمِ انْحِلَالِ
u'عَدَمٌ اِنْخِرامٌ':Added, #1: 1	عَدَمُ انْحِلَالِهِ
u'عَدَمٌ اِنْدِفاعٌ':Added, #1: 1	عَدَمِ انْخِرَامِ
u'عَدَمٌ إِنْزالٌ':Added, #1: 1	عَدَمُ انْدِفَاعِهِ
u'عَدَمٌ إِنْزالٌ':Added, #1: 1	عَدَمُ الْإِنْزَالِ
u'عَدَمٌ اِنْزِجارٌ':Added, #4: 4	عَدَمَ إنْزَالِهِ
u'عَدَمٌ إِنْصافٌ':Added, #1: 1	عَدَمِ انْزِجَارِهِ
u'عَدَمٌ اِنْصِرافٌ':Added, #2: 2	عَدَمُ إنْصَافٍ
u'عَدَمٌ اِنْضِباطٌ':Added, #1: 1	عَدَمِ انْصِرَافِهِ
u'عَدَمٌ اِنْضِباطٌ':Added, #1: 1	عَدَمُ انْضِبَاطِ
u'عَدَمٌ اِنْضِمامٌ':Added, #1: 1	عَدَمِ انْضِبَاطِهِ
u'عَدَمٌ اِنْعِزالٌ':Added, #1: 1	عَدَمِ انْضِمَامِ
u'عَدَمٌ اِنْعِزالٌ':Added, #1: 1	عَدَمِ انْعِزَالِ
u'عَدَمٌ اِنْعِزالٌ':Added, #1: 1	عَدَمِ انْعِزَالِهِ
u'عَدَمٌ اِنْعِقَادٌ':Added, #3: 3	عَدَمُ انْعِزَالِهِ
u'عَدَمٌ اِنْعِقَادٌ':Added, #2: 2	عَدَمَ انْعِقَادِهِ
u'عَدَمٌ اِنْعِقَادٌ':Added, #2: 2	عَدَمِ انْعِقَادِهِ
u'عَدَمٌ اِنْعِقَادٌ':Added, #4: 4	عَدَمَ انْعِقَادِ
u'عَدَمٌ اِنْعِقَادٌ':Added, #4: 4	عَدَمُ انْعِقَادِهِ
u'عَدَمٌ اِنْعِقَادٌ':Added, #5: 5	عَدَمُ انْعِقَادِ
u'عَدَمٌ اِنْعِكاسٌ':Added, #5: 5	عَدَمِ انْعِقَادِ
u'عَدَمٌ إِنْفاقٌ':Added, #1: 1	عَدَمُ انْعِكَاسِ
u'عَدَمٌ إِنْفاقٌ':Added, #1: 1	عَدَمَ الْإِنْفَاقِ
u'عَدَمٌ أَنَفَةٌ':Added, #3: 3	عَدَمِ الْإِنْفَاقِ
u'عَدَمٌ اِنْفِساخٌ':Added, #1: 1	عَدَمِ الْأَنَفَةِ
u'عَدَمٌ اِنْفِساخٌ':Added, #1: 1	عَدَمُ انْفِسَاخِ
u'عَدَمٌ اِنْفِساخٌ':Added, #1: 1	عَدَمُ انْفِسَاخِهِ
u'عَدَمٌ اِنْفِكاكٌ':Added, #2: 2	عَدَمِ انْفِسَاخِ
u'عَدَمٌ اِنْقِضاءٌ':Added, #1: 1	عَدَمَ انْفِكَاكِ
u'عَدَمٌ اِنْقِضاءٌ':Added, #1: 1	عَدَمِ انْقِضَاءِ
u'عَدَمٌ اِنْقِطاعٌ':Added, #2: 2	عَدَمُ انْقِضَاءِ
u'عَدَمٌ اِنْقِطاعٌ':Added, #1: 1	عَدَمَ انْقِطَاعِ
u'عَدَمٌ اِنْقِطاعٌ':Added, #1: 1	عَدَمِ انْقِطَاعِ
u'عَدِمَ إِنْكارٌ':Predicate, #1: 1	عَدَمُ انْقِطَاعِهِ
u'عَدَمٌ إِنْكارٌ':Added, #1: 1	عَدِمَ الْإِنْكَارَ
u'عَدَمٌ إِنْكارٌ':Added, #1: 1	عَدَمَ إنْكَارِهِ
u'عَدَمٌ إِنْكارٌ':Added, #2: 2	عَدَمَ الْإِنْكَارِ
u'عَدَمٌ إِنْكارٌ':Added, #2: 2	عَدَمِ الْإِنْكَارِ
u'عَدَمٌ إهْدَارٌ':Added, #3: 3	عَدَمُ الْإِنْكَارِ
u'عَدَمٌ أَهْلِيٌّ':Added, #1: 1	عَدَمُ الْإِهْدَارِ
u'عَدَمٌ أَهْلِيٌّ':Added, #1: 1	عَدَمُ الْأَهْلِيَّةِ
u'عَدَمٌ أَهْلِيٌّ':Added, #1: 1	عَدَمُ أَهْلِيَّةِ
u'عَدَمٌ أَهْلِيٌّ':Added, #1: 1	عَدَمِ أَهْلِيَّةٍ
u'عَدَمٌ أَهْلِيٌّ':Added, #1: 1	عَدَمَ أَهْلِيَّتِهِ
u'عَدَمٌ أَهْلِيٌّ':Added, #1: 1	عَدَمُ أَهْلِيَّتِهِ
u'عَدَمٌ أَهْلِيٌّ':Added, #2: 2	عَدَمِ أَهْلِيَّتِهِ
u'عَدَمٌ أَهْلِيٌّ':Added, #3: 3	عَدَمِ الْأَهْلِيَّةِ
u'عَدَمٌ أهْلِيَّةٌ':Added, #3: 3	عَدَمِ أَهْلِيَّةِ
u'عَدَمٌ أهْلِيَّةٌ':Added, #1: 1	عَدَمُ الْأَهْلِيَّةِ
u'عَدَمٌ أهْلِيَّةٌ':Added, #1: 1	عَدَمُ أَهْلِيَّةِ
u'عَدَمٌ أهْلِيَّةٌ':Added, #1: 1	عَدَمِ أَهْلِيَّةٍ
u'عَدَمٌ أهْلِيَّةٌ':Added, #1: 1	عَدَمَ أَهْلِيَّتِهِ
u'عَدَمٌ أهْلِيَّةٌ':Added, #1: 1	عَدَمُ أَهْلِيَّتِهِ
u'عَدَمٌ أهْلِيَّةٌ':Added, #2: 2	عَدَمِ أَهْلِيَّتِهِ
u'عَدَمٌ أهْلِيَّةٌ':Added, #3: 3	عَدَمِ الْأَهْلِيَّةِ
u'عَدَمٌ أَوَّلُ':Added, #3: 3	عَدَمِ أَهْلِيَّةِ
u'عَدَمٌ أَوَّلُ':Added, #1: 1	عَدَمُ الْأَوَّلِ
u'عَدَمٌ أَوْلَوِيٌّ':Added, #1: 1	عَدَمِ الْأَوَّلِ
u'عَدَمٌ أَوْلَوِيٌّ':Added, #1: 1	عَدَمِ الْأَوْلَوِيَّةِ
u'عَدَمٌ أَوَّلِيٌّ':Added, #2: 2	عَدَمَ الْأَوْلَوِيَّةِ
u'عَدَمٌ إِيجَابٌ':Added, #1: 1	عَدَمِ الْأَوَّلِيَّةِ
u'عَدَمٌ إِيجَابٌ':Added, #1: 1	عَدَمَ الْإِيجَابِ
u'عَدَمٌ إِيجَابٌ':Added, #1: 1	عَدَمُ الْإِيجَابِ
u'عَدَمٌ إِيجَابٌ':Added, #1: 1	عَدَمِ الْإِيجَابِ
u'عَدَمٌ إِيجَابٌ':Added, #1: 1	عَدَمَ إيجَابِ
u'عَدَمٌ إِيجَابٌ':Added, #1: 1	عَدَمِ إيجَابِهِ
u'عَدَمٌ إِيجَابٌ':Added, #3: 3	عَدَمِ إيجَابِ
u'عَدَمٌ إِيجَابٌ':Added, #3: 3	عَدَمُ إيجَابِهِ
u'عَدَمٌ إِيجَارٌ':Added, #6: 6	عَدَمُ إيجَابِ
u'عَدَمٌ إِيجَارٌ':Added, #1: 1	عَدَمِ الْإِيجَارِ
u'عَدَمٌ إيرَادٌ':Added, #1: 1	عَدَمَ إيجَارِهِ
u'عَدَمٌ إيصَالٌ':Added, #2: 2	عَدَمُ إيرَادِ
u'عَدَمٌ إيقَاعٌ':Added, #1: 1	عَدَمُ الْإِيصَالِ
u'عَدَمٌ إيمَانٌ':Added, #1: 1	عَدَمَ إيقَاعِ
u'عَدَمٌ إيمَانٌ':Added, #1: 1	عَدَمُ الْإِيمَانِ
u'عَدَمٌ إيمَانٌ':Added, #1: 1	عَدَمَ إيمَانِهِ
u'عَدَمٌ إيمَانٌ':Added, #1: 1	عَدَمُ إيمَانِهِ
u'عَدَمٌ إِيهَامٌ':Added, #3: 3	عَدَمِ الْإِيمَانِ
u'عَدَمٌ بَحْثٌ':Added, #1: 1	عَدَمِ إيهَامِ
u'عَدَمٌ بَحْثٌ':Added, #1: 1	عَدَمَ الْبَحْثِ
u'عَدَمٌ بَدْءٌ':Added, #1: 1	عَدَمِ الْبَحْثِ
u'عَدَمٌ بَدْءٌ':Added, #1: 1	عَدَمُ الْبَدْءِ
u'عَدَمٌ بِدْعَةٌ':Added, #1: 1	عَدَمِ بَدْءٍ
u'عَدَمٌ بِدْعَةٌ':Added, #1: 1	عَدَمُ الْبِدْعَةِ
u'عَدِمَ بدنة':Predicate, #1: 1	عَدَمِ الْبِدْعَةِ
u'عَدَمٌ بدنة':Added, #1: 1	عَدِمَ بَدَنَةَ
u'عَدَمٌ بَذْلٌ':Added, #1: 1	عَدَمِ الْبَدَنَةِ
u'عَدَمٌ بِرٌّ':Added, #1: 1	عَدَمِ بَذْلِ
u'عَدَمٌ بِرٌّ':Added, #1: 1	عَدَمَ بِرِّ
u'عَدَمٌ بُرْء':Added, #3: 3	عَدَمُ الْبِرِّ
u'عَدَمٌ بَراءةٌ':Added, #1: 1	عَدَمَ الْبُرْءِ
u'عَدَمٌ بَراءةٌ':Added, #1: 1	عَدَمَ الْبَرَاءَةِ
u'عَدَمٌ بَراءةٌ':Added, #1: 1	عَدَمُ بَرَاءَتِهِ
u'عَدَمٌ بَراءةٌ':Added, #2: 2	عَدَمُ الْبَرَاءَةِ
u'عَدَمٌ بَراءةٌ':Added, #2: 2	عَدَمُ بَرَاءَةِ
u'عَدَمٌ بَرَكَةٌ':Added, #2: 2	عَدَمِ بَرَاءَةِ
u'عَدَمٌ بُرْهانٌ':Added, #1: 1	عَدَمِ الْبَرَكَةِ
u'عَدَمٌ بُرْهَانٌ':Added, #1: 1	عَدَمِ الْبُرْهَانِ
u'عَدَمٌ بَصَرٌ':Added, #1: 1	عَدَمِ الْبُرْهَانِ
u'عَدَمٌ بُعْدٌ':Added, #1: 1	عَدَمُ الْبَصَرِ
u'عَدَمٌ بَعْضٌ':Added, #2: 2	عَدَمِ الْبُعْدِ
u'عَدَمٌ بَعْضٌ':Added, #1: 1	عَدَمُ بَعْضِ
u'عَدَمٌ بَعْضٌ':Added, #1: 1	عَدَمُ بَعْضِهِ
u'عَدَمٌ بَقاءٌ':Added, #1: 1	عَدَمِ بَعْضِهِ
u'عَدَمٌ بَقاءٌ':Added, #1: 1	عَدَمِ الْبَقَاءِ
u'عَدَمٌ بَقاءٌ':Added, #3: 3	عَدَمُ الْبَقَاءِ
u'عَدَمٌ بَقاءٌ':Added, #3: 3	عَدَمُ بَقَاءِ
u'عَدَمٌ بُلُوغٌ':Added, #4: 4	عَدَمِ بَقَاءِ
u'عَدَمٌ بُلُوغٌ':Added, #1: 1	عَدَمِ الْبُلُوغِ
u'عَدَمٌ بُلُوغٌ':Added, #1: 1	عَدَمَ بُلُوغِ
u'عَدَمٌ بُلُوغٌ':Added, #1: 1	عَدَمُ بُلُوغِ
u'عَدَمٌ بُلُوغٌ':Added, #1: 1	عَدَمُ بُلُوغِهِ
u'عَدَمٌ بُلُوغٌ':Added, #2: 2	عَدَمِ بُلُوغِهِ
u'عَدَمٌ بُلُوغٌ':Added, #3: 3	عَدَمَ الْبُلُوغِ
u'عَدَمٌ بِنَاءٌ':Added, #4: 4	عَدَمُ الْبُلُوغِ
u'عَدَمٌ بِنَاءٌ':Added, #15: 15	عَدَمُ الْبِنَاءِ
u'عَدَمٌ بناتٌ':Added, #3: 3	عَدَمَ الْبِنَاءِ
u'عَدَمٌ بناتٌ':Added, #1: 1	عَدَمِ بَنَاتِ
u'عَدِمَ بِنْتٌ':Predicate, #3: 3	عَدَمِ الْبَنَاتِ
u'عَدَمٌ بِنْتٌ':Added, #1: 1	عَدِمَ بِنْتَ
u'عَدَمٌ بِنْتٌ':Added, #1: 1	عَدَمِ الْبِنْتِ
u'عَدَمٌ بَيَانٌ':Added, #2: 2	عَدَمِ بِنْتِ
u'عَدَمٌ بَيَانٌ':Added, #1: 1	عَدَمِ الْبَيَانِ
u'عَدَمٌ بَيَانٌ':Added, #1: 1	عَدَمَ بَيَانِ
u'عَدَمٌ بَيَانٌ':Added, #1: 1	عَدَمُ بَيَانِهِ
u'عَدِمَ بِيَعٌ':Predicate, #4: 4	عَدَمِ بَيَانِ
u'عَدَمٌ بَيْعٌ':Added, #1: 1	عَدِمَ بِيعَ
u'عَدَمٌ بَيْعٌ':Added, #1: 1	عَدَم الْبَيْعِ
u'عَدَمٌ بَيْعٌ':Added, #1: 1	عَدَمِ الْبَيْعِ
u'عَدَمٌ بَيْعٌ':Added, #1: 1	عَدَمُ بَيْعِ
u'عَدَمٌ بَيْعٌ':Added, #3: 3	عَدَمَ الْبَيْعِ
u'عَدَمٌ بَيِّنَةٌ':Added, #7: 7	عَدَمُ الْبَيْعِ
u'عَدَمٌ بَيِّنَةٌ':Added, #1: 1	عَدَمِ بَيِّنَةٍ
u'عَدَمٌ بَيِّنَةٌ':Added, #3: 3	عَدَمِ بَيِّنَةِ
u'عَدَمٌ تَأَتِّي':Added, #4: 4	عَدَمِ الْبَيِّنَةِ
u'عَدَمٌ تَأْثِيرٌ':Added, #1: 1	عَدَم تَأَتِّيهِ
u'عَدَمٌ تَأْثِيرٌ':Added, #10: 10	عَدَمِ التَّأْثِيرِ
u'عَدَمٌ تَأْثِيرٌ':Added, #17: 17	عَدَمُ التَّأْثِيرِ
u'عَدَمٌ تَأْثِيرٌ':Added, #2: 2	عَدَمِ تَأْثِيرِ
u'عَدَمٌ تَأْثِيرٌ':Added, #2: 2	عَدَمَ تَأْثِيرِهِ
u'عَدَمٌ تَأْثِيرٌ':Added, #3: 3	عَدَمَ تَأْثِيرِ
u'عَدَمٌ تَأْثِيرٌ':Added, #3: 3	عَدَمِ تَأْثِيرِهِ
u'عَدَمٌ تَأْثِيرٌ':Added, #4: 4	عَدَمُ تَأْثِيرِ
u'عَدَمٌ تَأْثِيرٌ':Added, #4: 4	عَدَمُ تَأْثِيرِهِ
u'عَدَمٌ تَأَخُّرٌ':Added, #6: 6	عَدَمَ التَّأْثِيرِ
u'عَدَمٌ تَأَخُّرٌ':Added, #1: 1	عَدَمُ التَّأَخُّرِ
u'عَدَمٌ تَأَخُّرٌ':Added, #1: 1	عَدَمِ تَأَخُّرِ
u'عَدَمٌ تَأْخِيرٌ':Added, #1: 1	عَدَمُ تَأَخُّرِهِ
u'عَدَمٌ تَأْخِيرٌ':Added, #1: 1	عَدَمَ التَّأْخِيرِ
u'عَدَمٌ تَأْخِيرٌ':Added, #1: 1	عَدَمُ التَّأْخِيرِ
u'عَدَمٌ تَأْخِيرٌ':Added, #1: 1	عَدَمِ تَأْخِيرِهِ
u'عَدَمٌ تَأْرِيخٌ':Added, #2: 2	عَدَمُ تَأْخِيرِ
u'عَدَمٌ تَارِيخٌ':Added, #1: 1	عَدَمَ التَّأْرِيخِ
u'عَدَمٌ تَأَكُّدٌ':Added, #2: 2	عَدَمِ التَّارِيخِ
u'عَدَمٌ تَأَمُّلٌ':Added, #1: 1	عَدَمُ تَأَكُّدِ
u'عَدَمٌ تَأَمُّلٌ':Added, #1: 1	عَدَمُ تَأَمُّلٍ
u'عَدَمٌ تَأَمُّلٌ':Added, #4: 4	عَدَمُ التَّأَمُّلِ
u'عَدَمٌ تَبْدِيلٌ':Added, #5: 5	عَدَمِ التَّأَمُّلِ
u'عَدَمٌ تَبَرُّعٌ':Added, #1: 1	عَدَمِ التَّبْدِيلِ
u'عَدَمٌ تَبَع':Added, #2: 2	عَدَمُ التَّبَرُّعِ
u'عَدَمٌ تَبَع':Added, #1: 1	عَدَمُ التَّبَعِيَّةِ
u'عَدَمٌ تَبَع':Added, #1: 1	عَدَمِ التَّبَعِيَّةِ
u'عَدَمٌ تَبَع':Added, #1: 1	عَدَمُ تَبَعِيَّةِ
u'عَدَمٌ تَبَع':Added, #1: 1	عَدَمِ تَبَعِيَّةِ
u'عَدَمٌ تَبَعِيّ':Added, #2: 2	عَدَمَ التَّبَعِيَّةِ
u'عَدَمٌ تَبَعِيّ':Added, #1: 1	عَدَمُ التَّبَعِيَّةِ
u'عَدَمٌ تَبَعِيّ':Added, #1: 1	عَدَمِ التَّبَعِيَّةِ
u'عَدَمٌ تَبَعِيّ':Added, #1: 1	عَدَمُ تَبَعِيَّةِ
u'عَدَمٌ تَبَعِيّ':Added, #1: 1	عَدَمِ تَبَعِيَّةِ
u'عَدَمٌ تَبَعِيَّة':Added, #2: 2	عَدَمَ التَّبَعِيَّةِ
u'عَدَمٌ تَبَعِيَّة':Added, #1: 1	عَدَمُ التَّبَعِيَّةِ
u'عَدَمٌ تَبَعِيَّة':Added, #1: 1	عَدَمِ التَّبَعِيَّةِ
u'عَدَمٌ تَبَعِيَّة':Added, #1: 1	عَدَمُ تَبَعِيَّةِ
u'عَدَمٌ تَبَعِيَّة':Added, #1: 1	عَدَمِ تَبَعِيَّةِ
u'عَدَمٌ تَبْعِيض':Added, #2: 2	عَدَمَ التَّبَعِيَّةِ
u'عَدَمٌ تَبَيُّنٌ':Added, #1: 1	عَدَمِ تَبْعِيضِ
u'عَدَمٌ تَبْيِين':Added, #1: 1	عَدَمِ تَبَيُّنِ
u'عَدَمٌ تَتَابُعٌ':Added, #1: 1	عَدَمِ تَبْيِينِ
u'عَدَمٌ تَتَبُّعٌ':Added, #1: 1	عَدَمِ التَّتَابُعِ
u'عَدَمٌ تَتَبُّعٌ':Added, #1: 1	عَدَمِ التَّتَبُّعِ
u'عَدَمٌ تَثَبُّتٌ':Added, #1: 1	عَدَمِ تَتَبُّعِ
u'عَدَمٌ تَثَبُّت':Added, #1: 1	عَدَمَ تَثَبُّتِهِ
u'عَدَمٌ تَثَبُّت':Added, #2: 2	عَدَمِ التَّثَبُّتِ
u'عَدَمٌ تَثْبِيت':Added, #3: 3	عَدَمُ التَّثَبُّتِ
u'عَدَمٌ تِجَارَةٌ':Added, #1: 1	عَدَمِ التَّثْبِيتِ
u'عَدَمٌ تِجَارَةٌ':Added, #1: 1	عَدَمِ التِّجَارَةِ
u'عَدَمٌ تَجَاوُزٌ':Added, #2: 2	عَدَمَ التِّجَارَةِ
u'عَدَمٌ تَجَاوُزٌ':Added, #1: 1	عَدَمَ التَّجَاوُزِ
u'عَدَمٌ تَجَاوُزٌ':Added, #1: 1	عَدَمِ التَّجَاوُزِ
u'عَدَمٌ تَجْدِيدٌ':Added, #1: 1	عَدَمَ تَجَاوُزِهِ
u'عَدَمٌ تَجْدِيدٌ':Added, #1: 1	عَدَمِ تَجْدِيدِ
u'عَدَمٌ تَجَزُّؤٌ':Added, #2: 2	عَدَمُ التَّجْدِيدِ
u'عَدَمٌ تَجَزُّؤٌ':Added, #2: 2	عَدَمُ التَّجَزُّؤِ
u'عَدَمٌ تَجَزُّؤٌ':Added, #2: 2	عَدَمِ التَّجَزُّؤِ
u'عَدَمٌ تَجْزِيءٌ':Added, #2: 2	عَدَمِ تَجَزُّؤِ
u'عَدَمٌ تَجْنِيس':Added, #1: 1	عَدَمِ التَّجْزِيءِ
u'عَدَمٌ تَجْوِيزٌ':Added, #1: 1	عَدَمُ التَّجْنِيسِ
u'عَدَمٌ تَجْوِيزٌ':Added, #1: 1	عَدَمَ تَجْوِيزِ
u'عَدَمٌ تَجْوِيزٌ':Added, #1: 1	عَدَمُ تَجْوِيزِ
u'عَدَمٌ تَحَالُفٌ':Added, #1: 1	عَدَمِ تَجْوِيزِ
u'عَدَمٌ تَحَالُفٌ':Added, #1: 1	عَدَمَ التَّحَالُفِ
u'عَدَمٌ تَحَالُفٌ':Added, #1: 1	عَدَمُ التَّحَالُفِ
u'عَدَمٌ تَحَتُّمٌ':Added, #1: 1	عَدَمِ التَّحَالُفِ
u'عَدَمٌ تَحْدِيدٌ':Added, #1: 1	عَدَمُ التَّحَتُّمِ
u'عَدَمٌ تَحْدِيدٌ':Added, #1: 1	عَدَمُ التَّحْدِيدِ
u'عَدَمٌ تَحْرِيرٌ':Added, #1: 1	عَدَمِ التَّحْدِيدِ
u'عَدَمٌ تَحْرِيك':Added, #1: 1	عَدَمِ التَّحْرِيرِ
u'عَدَمٌ تَحْرِيمٌ':Added, #1: 1	عَدَمِ التَّحْرِيكِ
u'عَدَمٌ تَحْرِيمٌ':Added, #1: 1	عَدَمَ تَحْرِيمِهِ
u'عَدَمٌ تَحْرِيمٌ':Added, #22: 22	عَدَمُ التَّحْرِيمِ
u'عَدَمٌ تَحْرِيمٌ':Added, #2: 2	عَدَمِ تَحْرِيمِهِ
u'عَدَمٌ تَحْرِيمٌ':Added, #3: 3	عَدَمُ تَحْرِيمِهِ
u'عَدَمٌ تَحْرِيمٌ':Added, #4: 4	عَدَمَ تَحْرِيمِ
u'عَدَمٌ تَحْرِيمٌ':Added, #5: 5	عَدَمِ التَّحْرِيمِ
u'عَدَمٌ تَحْرِيمٌ':Added, #6: 6	عَدَمَ التَّحْرِيمِ
u'عَدَمٌ تَحْرِيمٌ':Added, #6: 6	عَدَمِ تَحْرِيمِ
u'عَدَمٌ تَحْصِيص':Added, #8: 8	عَدَمُ تَحْرِيمِ
u'عَدَمٌ تَحَقُّقٌ':Added, #1: 1	عَدَمِ التَّحْصِيصِ
u'عَدَمٌ تَحَقُّقٌ':Added, #1: 1	عَدَمَ التَّحَقُّقِ
u'عَدَمٌ تَحَقُّقٌ':Added, #1: 1	عَدَمِ التَّحَقُّقِ
u'عَدَمٌ تَحَقُّقٌ':Added, #1: 1	عَدَمَ تَحَقُّقِ
u'عَدَمٌ تَحَقُّقٌ':Added, #1: 1	عَدَمُ تَحَقُّقِ
u'عَدَمٌ تَحَقُّقٌ':Added, #2: 2	عَدَمِ تَحَقُّقِهِ
u'عَدَمٌ تَحْقِيقٌ':Added, #4: 4	عَدَمِ تَحَقُّقِ
u'عَدَمٌ تَحَكُّمٌ':Added, #1: 1	عَدَمِ تَحْقِيقِ
u'عَدَمٌ تَحْكِيمٌ':Added, #1: 1	عَدَمِ التَّحَكُّمِ
u'عَدَمٌ تَحْلِيف':Added, #1: 1	عَدَمِ تَحْكِيمِ
u'عَدَمٌ تَحْلِيف':Added, #2: 2	عَدَمَ التَّحْلِيفِ
u'عَدَمٌ تَحْلِيلٌ':Added, #2: 2	عَدَمِ التَّحْلِيفِ
u'عَدَمٌ تَحَمُّلٌ':Added, #1: 1	عَدَمُ تَحْلِيلِهِ
u'عَدَمٌ تَحَمُّلٌ':Added, #1: 1	عَدَمِ تَحَمُّلِ
u'عَدَمٌ تَحْمِيلٌ':Added, #3: 3	عَدَمُ تَحَمُّلِ
u'عَدَمٌ تَحْمِيلٌ':Added, #1: 1	عَدَمِ التَّحْمِيلِ
u'عَدَمٌ تَحْمِيلٌ':Added, #1: 1	عَدَمِ تَحْمِيلِ
u'عَدَمٌ تَخْرِيجٌ':Added, #1: 1	عَدَمِ تَحْمِيلِهِ
u'عَدَمٌ تَخْرِيجٌ':Added, #1: 1	عَدَمِ التَّخْرِيجِ
u'عَدَمٌ تَخْرِيجٌ':Added, #1: 1	عَدَم تَخْرِيجِهِ
u'عَدَمٌ تَخْرِيجٌ':Added, #1: 1	عَدَمُ تَخْرِيجِهِ
u'عَدَمٌ تَخْصِيصٌ':Added, #2: 2	عَدَمَ التَّخْرِيجِ
u'عَدَمٌ تَخْصِيصٌ':Added, #1: 1	عَدَمَ التَّخْصِيصِ
u'عَدَمٌ تَخْصِيصٌ':Added, #1: 1	عَدَمُ تَخْصِيصِ
u'عَدَمٌ تَخْصِيصٌ':Added, #3: 3	عَدَمُ تَخْصِيصِهِ
u'عَدَمٌ تَخْصِيصٌ':Added, #5: 5	عَدَمُ التَّخْصِيصِ
u'عَدَمٌ تَخَلُّفٌ':Added, #5: 5	عَدَمِ التَّخْصِيصِ
u'عَدَمٌ تَخَمُّرٌ':Added, #1: 1	عَدَمُ التَّخَلُّفِ
u'عَدَمٌ تَخْيِيرٌ':Added, #2: 2	عَدَمُ التَّخَمُّرِ
u'عَدَمٌ تَخْيِيرٌ':Added, #1: 1	عَدَمُ التَّخْيِيرِ
u'عَدَمٌ تَدَاخُلٌ':Added, #1: 1	عَدَمِ التَّخْيِيرِ
u'عَدَمٌ تَدَاخُلٌ':Added, #1: 1	عَدَمِ التَّدَاخُلِ
u'عَدَمٌ تَدَاخُلٌ':Added, #2: 2	عَدَمُ تَدَاخُلِ
u'عَدَمٌ تَدَبُّرٌ':Added, #3: 3	عَدَمُ التَّدَاخُلِ
u'عَدَمٌ تَدَبُّرٌ':Added, #1: 1	عَدَمِ التَّدَبُّرِ
u'عَدَمٌ تَدْبِيرٌ':Added, #2: 2	عَدَمِ تَدَبُّرِهِ
u'عَدَمٌ تَدَيُّنٌ':Added, #1: 1	عَدَمُ التَّدْبِيرِ
u'عَدَمٌ تَذَكُّرٌ':Added, #1: 1	عَدَمُ التَّدَيُّنِ
u'عَدَمٌ تَذَكُّرٌ':Added, #1: 1	عَدَمُ التَّذَكُّرِ
u'عَدَمٌ تَذَكُّرٌ':Added, #1: 1	عَدَمَ تَذَكُّرِ
u'عَدَمٌ تَذَكُّرٌ':Added, #1: 1	عَدَمُ تَذَكُّرِ
u'عَدَمٌ تَذَكُّرٌ':Added, #1: 1	عَدَمِ تَذَكُّرِ
u'عَدَمٌ تَذْكِيَةٌ':Added, #2: 2	عَدَمِ التَّذَكُّرِ
u'عَدِمَ تُرَابٌ':Predicate, #3: 3	عَدَمِ التَّذْكِيَةِ
u'عَدَمٌ تُرَابٌ':Added, #1: 1	عَدِمَ التُّرَابَ
u'عَدَمٌ تَرَادُفٌ':Added, #2: 2	عَدَمِ التُّرَابِ
u'عَدَمٌ تَرْتِيبٌ':Added, #1: 1	عَدَمُ التَّرَادُفِ
u'عَدَمٌ تَرْتِيبٌ':Added, #1: 1	عَدَمُ التَّرْتِيبِ
u'عَدِمَ تَرْجِيحٌ':Predicate, #2: 2	عَدَمِ التَّرْتِيبِ
u'عَدِمَ تَرْجِيحٌ':Subject, #1: 1	عَدِمَ التَّرْجِيحَ
u'عَدَمٌ تَرْجِيحٌ':Added, #1: 1	عَدِمَ التَّرْجِيحُ
u'عَدَمٌ تَرْجِيحٌ':Added, #2: 2	عَدَمُ التَّرْجِيحِ
u'عَدَمٌ تَرْجِيحٌ':Added, #2: 2	عَدَمُ تَرْجِيحِ
u'عَدَمٌ تَرْجِيحٌ':Added, #2: 2	عَدَمِ تَرْجِيحِهِ
u'عَدَمٌ تَرْجِيحٌ':Added, #3: 3	عَدَمِ تَرْجِيحِ
u'عَدَمٌ تَرَدُّدٌ':Added, #7: 7	عَدَمِ التَّرْجِيحِ
u'عَدَمٌ تَرْكٌ':Added, #1: 1	عَدَمِ التَّرَدُّدِ
u'عَدَمٌ تَرْكٌ':Added, #1: 1	عَدَمُ التَّرْكِ
u'عَدَمٌ تَرْكٌ':Added, #1: 1	عَدَمِ التَّرْكِ
u'عَدَمٌ تَرْكٌ':Added, #1: 1	عَدَمِ تَرْكِ
u'عَدَمٌ تَرْكٌ':Added, #1: 1	عَدَمُ تَرْكِهِ
u'عَدَمٌ تَرَكُّبٌ':Added, #2: 2	عَدَمَ التَّرْكِ
u'عَدَمٌ تَرِكَةٌ':Added, #1: 1	عَدَمُ تَرَكُّبِهِ
u'عَدَمٌ تَرِكَةٌ':Added, #1: 1	عَدَمِ تَرِكَةٍ
u'عَدَمٌ تَرْكِيبٌ':Added, #3: 3	عَدَمِ التَّرِكَةِ
u'عَدَمٌ تَرْكِيبٌ':Added, #2: 2	عَدَمُ التَّرْكِيبِ
u'عَدَمٌ تَزَاحُمٌ':Added, #2: 2	عَدَمُ تَرْكِيبِ
u'عَدَمٌ تَزْكِيَةٌ':Added, #1: 1	عَدَمُ التَّزَاحُمِ
u'عَدَمٌ تَزَوُّجٌ':Added, #1: 1	عَدَمُ تَزْكِيَةِ
u'عَدَمٌ تَزَوُّجٌ':Added, #1: 1	عَدَمُ التَّزَوُّجِ
u'عَدَمٌ تَزَوُّجٌ':Added, #1: 1	عَدَمِ التَّزَوُّجِ
u'عَدَمٌ تَزَوُّجٌ':Added, #1: 1	عَدَمَ تَزَوُّجِ
u'عَدَمٌ تَزْوِيجٌ':Added, #2: 2	عَدَمَ التَّزَوُّجِ
u'عَدَمٌ تَسَبُّبٌ':Added, #1: 1	عَدَمِ تَزْوِيجِهِ
u'عَدَمٌ تَسْلِيطٌ':Added, #1: 1	عَدَمُ التَّسَبُّبِ
u'عَدَمٌ تَسْلِيمٌ':Added, #1: 1	عَدَمِ تَسْلِيطِ
u'عَدَمٌ تَسْلِيمٌ':Added, #1: 1	عَدَم التَّسْلِيمِ
u'عَدَمٌ تَسْلِيمٌ':Added, #1: 1	عَدَمِ تَسْلِيمِهِ
u'عَدَمٌ تَسْلِيمٌ':Added, #2: 2	عَدَمُ تَسْلِيمِ
u'عَدَمٌ تَسْمِيَة':Added, #3: 3	عَدَمُ التَّسْلِيمِ
u'عَدَمٌ تَسْمِيَة':Added, #10: 10	عَدَمِ التَّسْمِيَةِ
u'عَدَمٌ تَسْمِيَة':Added, #1: 1	عَدَمَ تَسْمِيَةِ
u'عَدَمٌ تَسْمِيَة':Added, #1: 1	عَدَمِ تَسْمِيَةٍ
u'عَدَمٌ تَسْمِيَة':Added, #2: 2	عَدَمُ تَسْمِيَةِ
u'عَدَمٌ تَسْمِيَة':Added, #2: 2	عَدَمِ تَسْمِيَةِ
u'عَدَمٌ تَسْمِيَة':Added, #3: 3	عَدَمَ التَّسْمِيَةِ
u'عَدَمٌ تَسْوِيَةٌ':Added, #5: 5	عَدَمُ التَّسْمِيَةِ
u'عَدَمٌ تَسْوِيَةٌ':Added, #1: 1	عَدَمُ تَسْوِيَةِ
u'عَدَمٌ تَسْوِيَةٌ':Added, #1: 1	عَدَمَ تَسْوِيَتِهِ
u'عَدَمٌ تَشْرِيعٌ':Added, #2: 2	عَدَمِ التَّسْوِيَةِ
u'عَدَمٌ تَشْرِيك':Added, #1: 1	عَدَمُ التَّشْرِيعِ
u'عَدَمٌ تَصْحِيحٌ':Added, #1: 1	عَدَمِ التَّشْرِيكِ
u'عَدَمٌ تَصْدِيقٌ':Added, #1: 1	عَدَمِ تَصْحِيحِ
u'عَدَمٌ تَصْدِيقٌ':Added, #1: 1	عَدَمَ التَّصْدِيقِ
u'عَدَمٌ تَصْدِيقٌ':Added, #1: 1	عَدَمِ التَّصْدِيقِ
u'عَدَمٌ تَصْدِيقٌ':Added, #1: 1	عَدَمَ تَصْدِيقِهِ
u'عَدَمٌ تَصْدِيقٌ':Added, #2: 2	عَدَمُ تَصْدِيقِهِ
u'عَدَمٌ تَصْدِيقٌ':Added, #3: 3	عَدَمُ التَّصْدِيقِ
u'عَدَمٌ تَصَرُّفٌ':Added, #3: 3	عَدَمِ تَصْدِيقِهِ
u'عَدَمٌ تَصَرُّفٌ':Added, #1: 1	عَدَمُ تَصَرُّفِهِ
u'عَدَمٌ تَصْرِيحٌ':Added, #4: 4	عَدَمُ التَّصَرُّفِ
u'عَدَمٌ تَصْرِيحٌ':Added, #1: 1	عَدَمِ تَصْرِيحِهِ
u'عَدَمٌ تَصْرِيحٌ':Added, #3: 3	عَدَمُ التَّصْرِيحِ
u'عَدَمٌ تَصَوُّرٌ':Added, #6: 6	عَدَمِ التَّصْرِيحِ
u'عَدَمٌ تَصَوُّرٌ':Added, #1: 1	عَدَمُ التَّصَوُّرِ
u'عَدَمٌ تَصَوُّرٌ':Added, #1: 1	عَدَمُ تَصَوُّرِهِ
u'عَدَمٌ تَصَوُّرٌ':Added, #2: 2	عَدَمَ تَصَوُّرِ
u'عَدَمٌ تَصَوُّرٌ':Added, #2: 2	عَدَمِ تَصَوُّرِ
u'عَدَمٌ تَصَوُّرٌ':Added, #2: 2	عَدَمِ تَصَوُّرِهِ
u'عَدَمٌ تَضْحِيَةٌ':Added, #5: 5	عَدَمُ تَصَوُّرِ
u'عَدَمٌ تَضَرُّرٌ':Added, #1: 1	عَدَمَ التَّضْحِيَةِ
u'عَدَمٌ تَضْلِيلٌ':Added, #1: 1	عَدَمِ التَّضَرُّرِ
u'عَدَمٌ تَضْمِين':Added, #1: 1	عَدَمِ تَضْلِيلِ
u'عَدَمٌ تَضْمِينٌ':Added, #1: 1	عَدَمُ التَّضْمِينِ
u'عَدَمٌ تَضْمِينٌ':Added, #1: 1	عَدَمَ تَضْمِينِ
u'عَدَمٌ تَضْمِين':Added, #1: 1	عَدَمُ تَضْمِينِ
u'عَدَمٌ تَضْمِينٌ':Added, #2: 2	عَدَمَ التَّضْمِينِ
u'عَدَمٌ تَضْمِينٌ':Added, #2: 2	عَدَمِ تَضْمِينِ
u'عَدَمٌ تَضْمِينٌ':Added, #2: 2	عَدَمُ تَضْمِينِهِ
u'عَدَمٌ تَطْلِيقٌ':Added, #3: 3	عَدَمِ تَضْمِينِهِ
u'عَدَمٌ تَطْلِيقٌ':Added, #1: 1	عَدَمَ التَّطْلِيقِ
u'عَدَمٌ تَطْلِيقٌ':Added, #1: 1	عَدَمِ التَّطْلِيقِ
u'عَدَمٌ تَطْوِيلٌ':Added, #2: 2	عَدَمُ التَّطْلِيقِ
u'عَدَمٌ تَعَاقُبٌ':Added, #1: 1	عَدَمُ التَّطْوِيلِ
u'عَدَمٌ تَعَبُّدٌ':Added, #1: 1	عَدَمُ تَعَاقُبِ
u'عَدَمٌ تَعْجِيل':Added, #1: 1	عَدَمُ التَّعَبُّدِ
u'عَدَمٌ تَعْجِيل':Added, #1: 1	عَدَمَ التَّعْجِيلِ
u'عَدَمٌ تَعْجِيل':Added, #1: 1	عَدَمِ تَعْجِيلِ
u'عَدَمٌ تَعَدُّدٌ':Added, #3: 3	عَدَمُ التَّعْجِيلِ
u'عَدَمٌ تَعَدُّدٌ':Added, #1: 1	عَدَمَ التَّعَدُّدِ
u'عَدَمٌ تَعَدُّدٌ':Added, #1: 1	عَدَمِ تَعَدُّدِ
u'عَدَمٌ تَعَدُّدٌ':Added, #2: 2	عَدَمُ تَعَدُّدِ
u'عَدَمٌ تَعَدُّدٌ':Added, #3: 3	عَدَمِ التَّعَدُّدِ
u'عَدَمٌ تَعَدِّي':Added, #9: 9	عَدَمُ التَّعَدُّدِ
u'عَدَمٌ تَعْدِيَة':Added, #3: 3	عَدَمِ تَعَدِّيهِ
u'عَدَمٌ تَعْدِيلٌ':Added, #1: 1	عَدَمِ التَّعْدِيَةِ
u'عَدَمٌ تَعَذُّرٌ':Added, #1: 1	عَدَمَ التَّعْدِيلِ
u'عَدَمٌ تَعَذُّرٌ':Added, #1: 1	عَدَمَ التَّعَذُّرِ
u'عَدَمٌ تَعَذُّرٌ':Added, #1: 1	عَدَمِ تَعَذُّرِ
u'عَدَمٌ تَعَذُّرٌ':Added, #1: 1	عَدَمُ تَعَذُّرِهِ
u'عَدَمٌ تَعْذِيب':Added, #2: 2	عَدَمِ التَّعَذُّرِ
u'عَدَمٌ تَعَرُّضٌ':Added, #1: 1	عَدَمِ تَعْذِيبِ
u'عَدَمٌ تَعَرُّضٌ':Added, #1: 1	عَدَمِ التَّعَرُّضِ
u'عَدَمٌ تَعَرُّضٌ':Added, #1: 1	عَدَمِ تَعَرُّضِ
u'عَدَمٌ تَعَرُّضٌ':Added, #2: 2	عَدَمَ التَّعَرُّضِ
u'عَدَمٌ تَعَرُّضٌ':Added, #2: 2	عَدَمُ تَعَرُّضِ
u'عَدَمٌ تَعْرِيفٌ':Added, #7: 7	عَدَمُ التَّعَرُّضِ
u'عَدَمٌ تَعْرِيفٌ':Added, #1: 1	عَدَمَ التَّعْرِيفِ
u'عَدَمٌ تَعْرِيفٌ':Added, #2: 2	عَدَمِ التَّعْرِيفِ
u'عَدَمٌ تَعْزِير':Added, #3: 3	عَدَمُ التَّعْرِيفِ
u'عَدَمٌ تَعْزِير':Added, #1: 1	عَدَمَ التَّعْزِيرِ
u'عَدَمٌ تَعْزِير':Added, #2: 2	عَدَمِ التَّعْزِيرِ
u'عَدَمٌ تَعْطِيلٌ':Added, #5: 5	عَدَمُ التَّعْزِيرِ
u'عَدَمٌ تَعْظِيمٌ':Added, #1: 1	عَدَمُ التَّعْطِيلِ
u'عَدَمٌ تَعَقُّبٌ':Added, #1: 1	عَدَمِ التَّعْظِيمِ
u'عَدَمٌ تَعَقُّبٌ':Added, #1: 1	عَدَمُ تَعَقُّبِ
u'عَدَمٌ تَعَقُّلٌ':Added, #1: 1	عَدَمِ تَعَقُّبِهِ
u'عَدَمٌ تَعَلُّقٌ':Added, #1: 1	عَدَمِ تَعَقُّلِ
u'عَدَمٌ تَعَلُّقٌ':Added, #1: 1	عَدَمُ التَّعَلُّقِ
u'عَدَمٌ تَعَلُّقٌ':Added, #1: 1	عَدَمَ تَعَلُّقِ
u'عَدَمٌ تَعَلُّقٌ':Added, #2: 2	عَدَمَ التَّعَلُّقِ
u'عَدَمٌ تَعَلُّقٌ':Added, #2: 2	عَدَمِ تَعَلُّقِهِ
u'عَدَمٌ تَعَلُّقٌ':Added, #3: 3	عَدَمِ تَعَلُّقِ
u'عَدَمٌ تَعَلُّقٌ':Added, #4: 4	عَدَمِ التَّعَلُّقِ
u'عَدَمٌ تَعَلُّمٌ':Added, #4: 4	عَدَمُ تَعَلُّقِ
u'عَدَمٌ تَعْلِيقٌ':Added, #2: 2	عَدَمِ التَّعَلُّمِ
u'عَدَمٌ تَعْلِيقٌ':Added, #1: 1	عَدَمِ تَعْلِيقِ
u'عَدَمٌ تَعْلِيمٌ':Added, #1: 1	عَدَمَ تَعْلِيقِهِ
u'عَدَمٌ تَعْلِيمٌ':Added, #1: 1	عَدَمِ التَّعْلِيمِ
u'عَدَمٌ تَعَمُّدٌ':Added, #1: 1	عَدَمِ تَعْلِيمِ
u'عَدَمٌ تَعْمِيمٌ':Added, #1: 1	عَدَمِ التَّعَمُّدِ
u'عَدَمٌ تَعْمِيمٌ':Added, #1: 1	عَدَمِ تَعْمِيمِهِ
u'عَدَمٌ تَعَهُّدٌ':Added, #4: 4	عَدَمِ التَّعْمِيمِ
u'عَدَمٌ تَعَهُّدٌ':Added, #1: 1	عَدَمِ تَعَهُّدِ
u'عَدَمٌ تَعْوِيلٌ':Added, #1: 1	عَدَمُ تَعَهُّدِهِ
u'عَدَمٌ تَعَيُّنٌ':Added, #2: 2	عَدَمِ التَّعْوِيلِ
u'عَدَمٌ تَعَيُّنٌ':Added, #1: 1	عَدَمَ تَعَيُّنِ
u'عَدَمٌ تَعَيُّنٌ':Added, #1: 1	عَدَمِ تَعَيُّنِهِ
u'عَدَمٌ تَعَيُّنٌ':Added, #2: 2	عَدَمُ تَعَيُّنِ
u'عَدَمٌ تَعَيُّنٌ':Added, #3: 3	عَدَمِ التَّعَيُّنِ
u'عَدَمٌ تَعْيِينٌ':Added, #4: 4	عَدَمِ تَعَيُّنِ
u'عَدَمٌ تَعْيِينٌ':Added, #10: 10	عَدَمِ تَعْيِينِ
u'عَدَمٌ تَعْيِينٌ':Added, #17: 17	عَدَمِ التَّعْيِينِ
u'عَدَمٌ تَعْيِينٌ':Added, #1: 1	عَدَمِ تَعْيِينِهِ
u'عَدَمٌ تَعْيِينٌ':Added, #2: 2	عَدَمَ تَعْيِينِ
u'عَدَمٌ تَعْيِينٌ':Added, #2: 2	عَدَمُ تَعْيِينِهِ
u'عَدَمٌ تَعْيِينٌ':Added, #4: 4	عَدَمَ التَّعْيِينِ
u'عَدَمٌ تَعْيِينٌ':Added, #5: 5	عَدَمُ التَّعْيِينِ
u'عَدَمٌ تَغْرِيمٌ':Added, #5: 5	عَدَمُ تَعْيِينِ
u'عَدَمٌ تَغْلِيبٌ':Added, #1: 1	عَدَم تَغْرِيمِهِ
u'عَدَمٌ تَغَيُّرٌ':Added, #1: 1	عَدَمُ التَّغْلِيبِ
u'عَدَمٌ تَغَيُّرٌ':Added, #1: 1	عَدَمُ تَغَيُّرِ
u'عَدَمٌ تَغَيُّرٌ':Added, #3: 3	عَدَمِ التَّغَيُّرِ
u'عَدَمٌ تَغَيُّرٌ':Added, #3: 3	عَدَمُ تَغَيُّرِهِ
u'عَدَمٌ تَغَيُّرٌ':Added, #3: 3	عَدَمِ تَغَيُّرِهِ
u'عَدَمٌ تَغْيِيرٌ':Added, #5: 5	عَدَمُ التَّغَيُّرِ
u'عَدَمٌ تَغْيِيرٌ':Added, #2: 2	عَدَمَ التَّغْيِيرِ
u'عَدَمٌ تَفَاضُلٌ':Added, #4: 4	عَدَمُ التَّغْيِيرِ
u'عَدَمٌ تَفَاضُلٌ':Added, #1: 1	عَدَمَ التَّفَاضُلِ
u'عَدَمٌ تَفاوُت':Added, #1: 1	عَدَمِ التَّفَاضُلِ
u'عَدَمٌ تَفاوُت':Added, #2: 2	عَدَمِ التَّفَاوُتِ
u'عَدَمٌ تَفاوُت':Added, #3: 3	عَدَمَ التَّفَاوُتِ
u'عَدَمٌ تَفَرُّجٌ':Added, #4: 4	عَدَمُ التَّفَاوُتِ
u'عَدَمٌ تَفَرُّقٌ':Added, #1: 1	عَدَمِ التَّفَرُّجِ
u'عَدَمٌ تَفَرُّقٌ':Added, #2: 2	عَدَمُ التَّفَرُّقِ
u'عَدَمٌ تَفْرِقَة':Added, #7: 7	عَدَمِ التَّفَرُّقِ
u'عَدَمٌ تَفْرِقَة':Added, #1: 1	عَدَمُ التَّفْرِقَةِ
u'عَدَمٌ تَفْرِقَة':Added, #3: 3	عَدَمِ التَّفْرِقَةِ
u'عَدَمٌ تَفْرِيقٌ':Added, #4: 4	عَدَمَ التَّفْرِقَةِ
u'عَدَمٌ تَفْرِيقٌ':Added, #1: 1	عَدَمَ التَّفْرِيقِ
u'عَدَمٌ تَفْرِيقٌ':Added, #2: 2	عَدَمِ تَفْرِيقِ
u'عَدَمٌ تَفَسُّخٌ':Added, #5: 5	عَدَمِ التَّفْرِيقِ
u'عَدَمٌ تَفْسِيرٌ':Added, #1: 1	عَدَمِ التَّفَسُّخِ
u'عَدَمٌ تَفْصِيلٌ':Added, #1: 1	عَدَمِ التَّفْسِيرِ
u'عَدَمٌ تَفْصِيلٌ':Added, #2: 2	عَدَمَ التَّفْصِيلِ
u'عَدَمٌ تَفْصِيلٌ':Added, #4: 4	عَدَمُ التَّفْصِيلِ
u'عَدَمٌ تَفْطِيرٌ':Added, #7: 7	عَدَمِ التَّفْصِيلِ
u'عَدَمٌ تَفَهُّمٌ':Added, #1: 1	عَدَمِ تَفْطِيرِ
u'عَدَمٌ تَفْوِيضٌ':Added, #1: 1	عَدَمُ تَفَهُّمِ
u'عَدَمٌ تَقادُم':Added, #1: 1	عَدَمُ التَّفْوِيضِ
u'عَدَمٌ تَقادُم':Added, #1: 1	عَدَمَ التَّقَادُمِ
u'عَدَمٌ تَقاطُرٌ':Added, #1: 1	عَدَمُ التَّقَادُمِ
u'عَدَمٌ تَقَدُّمٌ':Added, #1: 1	عَدَمِ التَّقَاطُرِ
u'عَدَمٌ تَقَدُّمٌ':Added, #1: 1	عَدَمِ التَّقَدُّمِ
u'عَدَمٌ تَقَدُّمٌ':Added, #1: 1	عَدَمُ تَقَدُّمِهِ
u'عَدَمٌ تَقَدُّمٌ':Added, #2: 2	عَدَمُ تَقَدُّمِ
u'عَدَمٌ تَقْديرٌ':Added, #2: 2	عَدَمِ تَقَدُّمِهِ
u'عَدَمٌ تَقْديرٌ':Added, #1: 1	عَدَمَ تَقْدِيرِ
u'عَدَمٌ تَقْديرٌ':Added, #1: 1	عَدَمِ تَقْدِيرِ
u'عَدَمٌ تَقْديرٌ':Added, #2: 2	عَدَمَ التَّقْدِيرِ
u'عَدَمٌ تَقْديرٌ':Added, #3: 3	عَدَمُ تَقْدِيرِهِ
u'عَدَمٌ تَقْديرٌ':Added, #5: 5	عَدَمُ التَّقْدِيرِ
u'عَدَمٌ تَقْديمٌ':Added, #6: 6	عَدَمِ التَّقْدِيرِ
u'عَدَمٌ تَقْديمٌ':Added, #1: 1	عَدَمِ التَّقْدِيمِ
u'عَدَمٌ تَقْديمٌ':Added, #1: 1	عَدَمُ تَقْدِيمِ
u'عَدَمٌ تَقْديمٌ':Added, #1: 1	عَدَمُ تَقْدِيمِهِ
u'عَدَمٌ تَقَرُّرٌ':Added, #3: 3	عَدَمِ تَقْدِيمِ
u'عَدَمٌ تَقْريرٌ':Added, #1: 1	عَدَمِ تَقَرُّرِ
u'عَدَمٌ تَقْريرٌ':Added, #1: 1	عَدَمُ التَّقْرِيرِ
u'عَدَمٌ تَقْصيرٌ':Added, #2: 2	عَدَمِ تَقْرِيرِهِ
u'عَدَمٌ تَقْصيرٌ':Added, #1: 1	عَدَمُ التَّقْصِيرِ
u'عَدَمٌ تَقْصيرٌ':Added, #1: 1	عَدَمُ تَقْصِيرِهِ
u'عَدَمٌ تَقْصيرٌ':Added, #2: 2	عَدَمِ تَقْصِيرٍ
u'عَدَمٌ تَقْليدٌ':Added, #3: 3	عَدَمِ تَقْصِيرِهِ
u'عَدَمٌ تَقْليد':Added, #1: 1	عَدَمِ التَّقْلِيدِ
u'عَدَمٌ تَقْليدٌ':Added, #1: 1	عَدَمِ التَّقْلِيدِ
u'عَدَمٌ تَقْليد':Added, #1: 1	عَدَمُ تَقْلِيدِ
u'عَدَمٌ تَقْليدٌ':Added, #1: 1	عَدَمُ تَقْلِيدِ
u'عَدَمٌ تَقْليد':Added, #2: 2	عَدَمِ تَقْلِيدِ
u'عَدَمٌ تَقْليلٌ':Added, #2: 2	عَدَمِ تَقْلِيدِ
u'عَدَمٌ تَقَوُّمٌ':Added, #1: 1	عَدَمُ تَقْلِيلِ
u'عَدَمٌ تَقَوُّمٌ':Added, #1: 1	عَدَمِ التَّقَوُّمِ
u'عَدَمٌ تَقْويمٌ':Added, #1: 1	عَدَمَ تَقَوُّمِ
u'عَدَمٌ تَقَيُّدٌ':Added, #1: 1	عَدَمِ تَقْوِيمِ
u'عَدَمٌ تَقَيُّدٌ':Added, #1: 1	عَدَمِ تَقَيُّدِهِ
u'عَدَمٌ تَقْيِيد':Added, #2: 2	عَدَمُ التَّقَيُّدِ
u'عَدَمٌ تَقْيِيد':Added, #2: 2	عَدَمَ تَقْيِيدِ
u'عَدَمٌ تَقْيِيد':Added, #2: 2	عَدَمُ تَقْيِيدِ
u'عَدَمٌ تَقْيِيد':Added, #6: 6	عَدَمِ التَّقْيِيدِ
u'عَدَمٌ تَقْيِيد':Added, #8: 8	عَدَمَ التَّقْيِيدِ
u'عَدَمٌ تَكاذُبٌ':Added, #8: 8	عَدَمُ التَّقْيِيدِ
u'عَدَمٌ تَكافُؤٌ':Added, #1: 1	عَدَمُ التَّكَاذُبِ
u'عَدَمٌ تَكافُؤٌ':Added, #1: 1	عَدَمُ التَّكَافُؤِ
u'عَدَمٌ تَكامُلٌ':Added, #2: 2	عَدَمَ التَّكَافُؤِ
u'عَدَمٌ تَكْبيرٌ':Added, #1: 1	عَدَمِ تَكَامُلِ
u'عَدَمٌ تَكْذيبٌ':Added, #1: 1	عَدَمِ التَّكْبِيرِ
u'عَدَمٌ تَكْذيبٌ':Added, #2: 2	عَدَمُ تَكْذِيبِ
u'عَدَمٌ تَكْرارٌ':Added, #3: 3	عَدَمُ تَكْذِيبِهِ
u'عَدَمٌ تَكْرارٌ':Added, #1: 1	عَدَمِ التَّكْرَارِ
u'عَدَمٌ تَكْرارٌ':Added, #1: 1	عَدَمَ تَكْرَارِ
u'عَدَمٌ تَكْرارٌ':Added, #1: 1	عَدَمُ تَكْرَارِ
u'عَدَمٌ تَكْرارٌ':Added, #1: 1	عَدَمِ تَكْرَارِهِ
u'عَدَمٌ تَكْرارٌ':Added, #2: 2	عَدَمَ التَّكْرَارِ
u'عَدَمٌ تَكَرُّرٌ':Added, #2: 2	عَدَمُ التَّكْرَارِ
u'عَدَمٌ تَكَرُّرٌ':Added, #1: 1	عَدَمُ تَكَرُّرِ
u'عَدَمٌ تَكَرُّرٌ':Added, #2: 2	عَدَمَ التَّكَرُّرِ
u'عَدَمٌ تَكَرُّرٌ':Added, #2: 2	عَدَمُ تَكَرُّرِهِ
u'عَدَمٌ تَكْفيرٌ':Added, #4: 4	عَدَمِ تَكَرُّرِ
u'عَدَمٌ تَكْفيرٌ':Added, #1: 1	عَدَمَ التَّكْفِيرِ
u'عَدَمٌ تَكْفيرٌ':Added, #1: 1	عَدَمَ تَكْفِيرِ
u'عَدَمٌ تَكْفيرٌ':Added, #2: 2	عَدَمُ التَّكْفِيرِ
u'عَدَمٌ تَكْفيرٌ':Added, #2: 2	عَدَمُ تَكْفِيرِهِ
u'عَدَمٌ تَكْفيرٌ':Added, #2: 2	عَدَمِ تَكْفِيرِهِ
u'عَدَمٌ تَكْفيرٌ':Added, #3: 3	عَدَمِ تَكْفِيرِ
u'عَدَمٌ تَكْفيرٌ':Added, #6: 6	عَدَمِ التَّكْفِيرِ
u'عَدَمٌ تَكْفيلٌ':Added, #6: 6	عَدَمُ تَكْفِيرِ
u'عَدَمٌ تَكْفينٌ':Added, #1: 1	عَدَمِ التَّكْفِيلِ
u'عَدَمٌ تَكَلُّمٌ':Added, #1: 1	عَدَمِ تَكْفِينِهِ
u'عَدَمٌ تَكَلُّمٌ':Added, #1: 1	عَدَمُ التَّكَلُّمِ
u'عَدَمٌ تَكْليفٌ':Added, #2: 2	عَدَمِ التَّكَلُّمِ
u'عَدَمٌ تَكْليفٌ':Added, #1: 1	عَدَمُ التَّكْلِيفِ
u'عَدَمٌ تَكْليفٌ':Added, #1: 1	عَدَمُ تَكْلِيفِ
u'عَدَمٌ تَكْليفٌ':Added, #1: 1	عَدَمَ تَكْلِيفِهِ
u'عَدَمٌ تَكْليفٌ':Added, #1: 1	عَدَمُ تَكْلِيفِهِ
u'عَدَمٌ تَكْليفٌ':Added, #1: 1	عَدَمِ تَكْلِيفِهِ
u'عَدَمٌ تَكْليفٌ':Added, #2: 2	عَدَمِ تَكْلِيفِ
u'عَدَمٌ تَكْليمٌ':Added, #4: 4	عَدَمِ التَّكْلِيفِ
u'عَدَمٌ تَكْميلٌ':Added, #1: 1	عَدَمِ التَّكْلِيمِ
u'عَدَمٌ تَلازُم':Added, #1: 1	عَدَمِ تَكْمِيلِ
u'عَدَمٌ تِلاوَةٌ':Added, #2: 2	عَدَمِ التَّلَازُمِ
u'عَدَمٌ تَلَف':Added, #1: 1	عَدَمُ تِلَاوَةِ
u'عَدَمٌ تَلْفيقٌ':Added, #1: 1	عَدَمِ التَّلَفِ
u'عَدَمٌ تمام':Added, #3: 3	عَدَمِ التَّلْفِيقِ
u'عَدَمٌ تَمامٌ':Added, #1: 1	عَدَمِ تَمَامِ
u'عَدَمٌ تمام':Added, #1: 1	عَدَمِ تَمَامِ
u'عَدَمٌ تمام':Added, #2: 2	عَدَمَ تَمَامِ
u'عَدَمٌ تَمامٌ':Added, #2: 2	عَدَمُ تَمَامِ
u'عَدَمٌ تَمامٌ':Added, #2: 2	عَدَمَ تَمَامِ
u'عَدَمٌ تَمَكُّنٌ':Added, #2: 2	عَدَمُ تَمَامِ
u'عَدَمٌ تَمَكُّنٌ':Added, #1: 1	عَدَمَ التَّمَكُّنِ
u'عَدَمٌ تَمَكُّنٌ':Added, #1: 1	عَدَمُ تَمَكُّنِ
u'عَدَمٌ تَمَكُّنٌ':Added, #1: 1	عَدَمِ تَمَكُّنِ
u'عَدَمٌ تَمَكُّنٌ':Added, #1: 1	عَدَمَ تَمَكُّنِهِ
u'عَدَمٌ تَمَكُّنٌ':Added, #1: 1	عَدَمِ تَمَكُّنِهِ
u'عَدَمٌ تَمَكُّنٌ':Added, #3: 3	عَدَمِ التَّمَكُّنِ
u'عَدَمٌ تَمْكِين':Added, #5: 5	عَدَمُ التَّمَكُّنِ
u'عَدَمٌ تَمْكِين':Added, #1: 1	عَدَم التَّمْكِينِ
u'عَدَمٌ تَمْكِينٌ':Added, #1: 1	عَدَمَ التَّمْكِينِ
u'عَدَمٌ تَمْكِينٌ':Added, #1: 1	عَدَمِ تَمْكِينِ
u'عَدَمٌ تَمْكِينٌ':Added, #1: 1	عَدَمَ تَمْكِينِهِ
u'عَدَمٌ تَمْكِين':Added, #1: 1	عَدَمُ تَمْكِينِهِ
u'عَدَمٌ تَمَلُّكٌ':Added, #3: 3	عَدَمُ التَّمْكِينِ
u'عَدَمٌ تَمَيُّزٌ':Added, #1: 1	عَدَمُ تَمَلُّكِ
u'عَدَمٌ تَمْييزٌ':Added, #1: 1	عَدَمُ تَمَيُّزِهِ
u'عَدَمٌ تَمْييزٌ':Added, #1: 1	عَدَمَ تَمْيِيزِهِ
u'عَدَمٌ تَمْييزٌ':Added, #2: 2	عَدَمَ التَّمْيِيزِ
u'عَدَمٌ تَمْييزٌ':Added, #2: 2	عَدَمُ التَّمْيِيزِ
u'عَدَمٌ تَناجُز':Added, #8: 8	عَدَمِ التَّمْيِيزِ
u'عَدَمٌ تَنَاصُرٌ':Added, #1: 1	عَدَمِ التَّنَاجُزِ
u'عَدَمٌ تَنَاقُضٌ':Added, #1: 1	عَدَمِ التَّنَاصُرِ
u'عَدَمٌ تَنَاقُضٌ':Added, #1: 1	عَدَمِ التَّنَاقُضِ
u'عَدَمٌ تَنَاوُلٌ':Added, #5: 5	عَدَمُ التَّنَاقُضِ
u'عَدَمٌ تَنَاوُلٌ':Added, #1: 1	عَدَم تَنَاوُلِ
u'عَدَمٌ تَنَاوُلٌ':Added, #1: 1	عَدَمَ تَنَاوُلِ
u'عَدَمٌ تَنَاوُلٌ':Added, #1: 1	عَدَمِ تَنَاوُلِ
u'عَدَمٌ تَنَاوُلٌ':Added, #1: 1	عَدَمَ تَنَاوُلِهِ
u'عَدَمٌ تَنَاوُلٌ':Added, #1: 1	عَدَمُ تَنَاوُلِهِ
u'عَدَمٌ تَنَاوُلٌ':Added, #2: 2	عَدَمُ التَّنَاوُلِ
u'عَدَمٌ تَنجُّسٌ':Added, #2: 2	عَدَمُ تَنَاوُلِ
u'عَدَمٌ تَنجُّسٌ':Added, #1: 1	عَدَمِ التَّنَجُّسِ
u'عَدَمٌ تَنجُّسٌ':Added, #1: 1	عَدَمُ تَنَجُّسِهِ
u'عَدَمٌ تَنجُّسٌ':Added, #2: 2	عَدَمَ التَّنَجُّسِ
u'عَدَمٌ تَنجُّسٌ':Added, #2: 2	عَدَمُ تَنَجُّسِ
u'عَدَمٌ تَنْجِيزٌ':Added, #3: 3	عَدَمِ تَنَجُّسِ
u'عَدَمٌ تَنْجِيزٌ':Added, #1: 1	عَدَمَ التَّنْجِيزِ
u'عَدَمٌ تَنْجِيسٌ':Added, #1: 1	عَدَمَ تَنْجِيزِ
u'عَدَمٌ تَنَزُّه':Added, #1: 1	عَدَمُ التَّنْجِيسِ
u'عَدَمٌ تَنَزُّه':Added, #1: 1	عَدَمُ التَّنَزُّهِ
u'عَدَمٌ تَنَزُّه':Added, #2: 2	عَدَمِ التَّنَزُّهِ
u'عَدَمٌ تَنْفِيذٌ':Added, #3: 3	عَدَمَ التَّنَزُّهِ
u'عَدَمٌ تَنْفِيذٌ':Added, #1: 1	عَدَمُ تَنْفِيذِهِ
u'عَدَمٌ تَنْقِيصٌ':Added, #2: 2	عَدَمَ تَنْفِيذِ
u'عَدَمٌ تَنْكِيسٌ':Added, #2: 2	عَدَمِ تَنْقِيصِ
u'عَدَمٌ تَنْوِينٌ':Added, #2: 2	عَدَمُ التَّنْكِيسِ
u'عَدَمٌ تُهْمَةٌ':Added, #1: 1	عَدَمُ تَنْوِينِهِ
u'عَدَمٌ تُهْمَةٌ':Added, #2: 2	عَدَمُ التُّهْمَةِ
u'عَدَمٌ تَوَاتُرٌ':Added, #3: 3	عَدَمِ التُّهْمَةِ
u'عَدَمٌ تَوَاتُرٌ':Added, #1: 1	عَدَمَ التَّوَاتُرِ
u'عَدَمٌ تَوَاتُرٌ':Added, #1: 1	عَدَمِ التَّوَاتُرِ
u'عَدَمٌ تَوَاتُرٌ':Added, #1: 1	عَدَمَ تَوَاتُرِهِ
u'عَدَمٌ تَوَاتُرٌ':Added, #1: 1	عَدَمُ تَوَاتُرِهِ
u'عَدَمٌ تَوَارُثٌ':Added, #2: 2	عَدَمَ تَوَاتُرِ
u'عَدَمٌ تَوَارُدٌ':Added, #1: 1	عَدَمُ التَّوَارُثِ
u'عَدَمٌ تَوَارُدٌ':Added, #1: 1	عَدَمُ التَّوَارُدِ
u'عَدَمٌ تَوَافُقٌ':Added, #1: 1	عَدَمِ التَّوَارُدِ
u'عَدَمٌ تَوْبَةٌ':Added, #3: 3	عَدَمِ التَّوَافُقِ
u'عَدَمٌ تَوْبَةٌ':Added, #1: 1	عَدَمِ تَوْبَةٍ
u'عَدَمٌ تَوْبَةٌ':Added, #2: 2	عَدَمَ التَّوْبَةِ
u'عَدَمٌ تَوْبَةٌ':Added, #2: 2	عَدَمُ التَّوْبَةِ
u'عَدَمٌ تَوَجُّهٌ':Added, #2: 2	عَدَمِ التَّوْبَةِ
u'عَدَمٌ تَوْرِيث':Added, #1: 1	عَدَمُ تَوَجُّهِ
u'عَدَمٌ تَوْرِيث':Added, #1: 1	عَدَمَ تَوْرِيثِ
u'عَدَمٌ تَوْفِيَةٌ':Added, #2: 2	عَدَمِ التَّوْرِيثِ
u'عَدَمٌ تَوَقان':Added, #1: 1	عَدَمُ تَوْفِيَةِ
u'عَدَمٌ تَوَقُّفٌ':Added, #1: 1	عَدَمِ التَّوَقَانِ
u'عَدَمٌ تَوَقُّفٌ':Added, #1: 1	عَدَمَ تَوَقُّفِ
u'عَدَمٌ تَوَقُّفٌ':Added, #1: 1	عَدَمِ تَوَقُّفِ
u'عَدَمٌ تَوَقُّفٌ':Added, #1: 1	عَدَمِ تَوَقُّفِهِ
u'عَدَمٌ تَوَقُّفٌ':Added, #2: 2	عَدَمَ التَّوَقُّفِ
u'عَدَمٌ تَوَقُّفٌ':Added, #2: 2	عَدَمِ التَّوَقُّفِ
u'عَدَمٌ تَوَقُّفٌ':Added, #3: 3	عَدَمُ تَوَقُّفِ
u'عَدَمٌ تَوَقُّفٌ':Added, #3: 3	عَدَمُ تَوَقُّفِهِ
u'عَدَمٌ تَوْقِيَةٌ':Added, #7: 7	عَدَمُ التَّوَقُّفِ
u'عَدَمٌ تَوْقِيت':Added, #2: 2	عَدَمُ تَوْقِيتِهِ
u'عَدَمٌ تَوْقِيت':Added, #1: 1	عَدَمَ التَّوْقِيتِ
u'عَدَمٌ تَوْقِيتٌ':Added, #2: 2	عَدَمُ التَّوْقِيتِ
u'عَدَمٌ تَوْقِيرٌ':Added, #2: 2	عَدَمُ تَوْقِيتِهِ
u'عَدَمٌ تَوْكِيلٌ':Added, #1: 1	عَدَمِ تَوْقِيرِ
u'عَدَمٌ تَوْكِيلٌ':Added, #1: 1	عَدَمَ تَوْكِيلِ
u'عَدَمٌ تَوَهُّمٌ':Added, #1: 1	عَدَمِ تَوْكِيلِ
u'عَدَمٌ تَيَسُّرٌ':Added, #1: 1	عَدَمِ تَوَهُّمِهِ
u'عَدَمٌ تَيَقُّنٌ':Added, #1: 1	عَدَمِ تَيَسُّرِ
u'عَدَمٌ تَيَقُّنٌ':Added, #2: 2	عَدَمُ تَيَقُّنِ
u'عَدَمٌ تَيَمُّمٌ':Added, #3: 3	عَدَمِ تَيَقُّنِ
u'عَدِمَ ثَانِي':Predicate, #2: 2	عَدَمِ التَّيَمُّمِ
u'عَدَمٌ ثبات':Added, #1: 1	عَدِمَ الثَّانِيَ
u'عَدَمٌ ثبَاتٌ':Added, #1: 1	عَدَمُ الثَّبَاتِ
u'عَدَمٌ ثُبُوتٌ':Added, #1: 1	عَدَمُ الثَّبَاتِ
u'عَدَمٌ ثُبُوتٌ':Added, #11: 11	عَدَمَ ثُبُوتِ
u'عَدَمٌ ثُبُوتٌ':Added, #11: 11	عَدَمُ ثُبُوتِهِ
u'عَدَمٌ ثُبُوتٌ':Added, #19: 19	عَدَمُ ثُبُوتِ
u'عَدَمٌ ثُبُوتٌ':Added, #1: 1	عَدَم ثُبُوتِ
u'عَدَمٌ ثُبُوتٌ':Added, #22: 22	عَدَمِ ثُبُوتِ
u'عَدَمٌ ثُبُوتٌ':Added, #3: 3	عَدَمَ الثُّبُوتِ
u'عَدَمٌ ثُبُوتٌ':Added, #3: 3	عَدَمِ الثُّبُوتِ
u'عَدَمٌ ثُبُوتٌ':Added, #4: 4	عَدَمُ الثُّبُوتِ
u'عَدَمٌ ثُبُوتٌ':Added, #5: 5	عَدَمَ ثُبُوتِهِ
u'عَدَمٌ ثِقَةٌ':Added, #6: 6	عَدَمِ ثُبُوتِهِ
u'عَدَمٌ ثَمَنٌ':Added, #1: 1	عَدَمُ الثِّقَةِ
u'عَدَمٌ ثَناءٌ':Added, #1: 1	عَدَمِ ثَمَنٍ
u'عَدَمٌ ثَوابٌ':Added, #1: 1	عَدَمِ الثَّنَاءِ
u'عَدَمٌ ثَوابٌ':Added, #1: 1	عَدَمِ الثَّوَابِ
u'عَدَمٌ ثَوابٌ':Added, #2: 2	عَدَمَ الثَّوَابِ
u'عَدَمٌ جَابِرٌ':Added, #3: 3	عَدَمُ الثَّوَابِ
u'عَدَمٌ جَبْرٌ':Added, #1: 1	عَدَمِ الْجَابِرِ
u'عَدَمٌ جَبْرٌ':Added, #1: 1	عَدَمُ جَبْرِ
u'عَدَمٌ جَبْرٌ':Added, #1: 1	عَدَمُ جَبْرِهِ
u'عَدَمٌ جَبْرٌ':Added, #2: 2	عَدَمِ جَبْرِ
u'عَدَمٌ جَبْرٌ':Added, #3: 3	عَدَمُ الْجَبْرِ
u'عَدَمٌ جُبْنٌ':Added, #7: 7	عَدَمِ الْجَبْرِ
u'عَدَمٌ جُحُود':Added, #1: 1	عَدَمِ الْجُبْنِ
u'عَدَمٌ جَرَيان':Added, #1: 1	عَدَمُ الْجُحُودِ
u'عَدَمٌ جَرَيان':Added, #1: 1	عَدَمِ الْجَرَيَانِ
u'عَدَمٌ جَرَيان':Added, #1: 1	عَدَمَ جَرَيَانِ
u'عَدَمٌ جَرَيان':Added, #1: 1	عَدَمُ جَرَيَانِ
u'عَدَمٌ جُزْءٌ':Added, #2: 2	عَدَمِ جَرَيَانِ
u'عَدَمٌ جَزَاءٌ':Added, #1: 1	عَدَمِ جُزْءٍ
u'عَدَمٌ جَزَاءٌ':Added, #1: 1	عَدَمَ الْجَزَاءِ
u'عَدَمٌ جَزَاءٌ':Added, #1: 1	عَدَمُ الْجَزَاءِ
u'عَدَمٌ جَزْم':Added, #2: 2	عَدَمِ الْجَزَاءِ
u'عَدَمٌ جَزْم':Added, #1: 1	عَدَمِ الْجَزْمِ
u'عَدَمٌ جِسْمٌ':Added, #5: 5	عَدَمُ الْجَزْمِ
u'عَدَمٌ جُلُوسٌ':Added, #1: 1	عَدَمُ الْجِسْمِ
u'عَدَمٌ جماع':Added, #1: 1	عَدَمَ الْجُلُوسِ
u'عَدَمٌ جِمَاعٌ':Added, #1: 1	عَدَمِ الْجِمَاعِ
u'عَدَمٌ جمع':Added, #1: 1	عَدَمِ الْجِمَاعِ
u'عَدَمٌ جَمْعٌ':Added, #1: 1	عَدَمَ جَمْعِ
u'عَدَمٌ جمع':Added, #1: 1	عَدَمَ جَمْعِ
u'عَدَمٌ جَمْعٌ':Added, #1: 1	عَدَمِ جَمْعِهِ
u'عَدَمٌ جمع':Added, #1: 1	عَدَمِ جَمْعِهِ
u'عَدَمٌ جَمْعٌ':Added, #6: 6	عَدَمُ الْجَمْعِ
u'عَدَمٌ جمعة':Added, #6: 6	عَدَمُ الْجَمْعِ
u'عَدَمٌ جُمُعَةٌ':Added, #1: 1	عَدَمِ جُمُعَةٍ
u'عَدَمٌ جَنَابَةٌ':Added, #1: 1	عَدَمِ جُمُعَةٍ
u'عَدَمٌ جَنَابَةٌ':Added, #1: 1	عَدَمُ جَنَابَتِهِ
u'عَدَمٌ جناح':Added, #2: 2	عَدَمَ جَنَابَتِهِ
u'عَدَمٌ جُنَاحٌ':Added, #1: 1	عَدَمُ الْجُنَاحِ
u'عَدَمٌ جِنَايَةٌ':Added, #1: 1	عَدَمُ الْجُنَاحِ
u'عَدَمٌ جِنَايَةٌ':Added, #1: 1	عَدَمُ الْجِنَايَةِ
u'عَدَمٌ جِنْسٌ':Added, #1: 1	عَدَمِ الْجِنَايَةِ
u'عَدَمٌ جِنْسٌ':Added, #1: 1	عَدَمَ الْجِنْسِ
u'عَدَمٌ جهاد':Added, #3: 3	عَدَمُ الْجِنْسِ
u'عَدَمٌ جِهَادٌ':Added, #1: 1	عَدَمَ الْجِهَادِ
u'عَدِمَ جُهَّالٌ':Subject, #1: 1	عَدَمَ الْجِهَادِ
u'عَدَمٌ جَهالَة':Added, #1: 1	عَدِمَ الْجُهَّالُ
u'عَدَمٌ جَهالَة':Added, #1: 1	عَدَمِ الْجَهَالَةِ
u'عَدَمٌ جَهْر':Added, #2: 2	عَدَمُ الْجَهَالَةِ
u'عَدَمٌ جهر':Added, #1: 1	عَدَمِ الْجَهْرِيَّةِ
u'عَدَمٌ جَهْرٌ':Added, #1: 1	عَدَمَ جَهْرِ
u'عَدَمٌ جهر':Added, #1: 1	عَدَمَ جَهْرِ
u'عَدَمٌ جَهْرٌ':Added, #2: 2	عَدَمُ الْجَهْرِ
u'عَدَمٌ جَهْرَة':Added, #2: 2	عَدَمُ الْجَهْرِ
u'عَدَمٌ جَهْرِيّ':Added, #1: 1	عَدَمِ الْجَهْرِيَّةِ
u'عَدَمٌ جهل':Added, #1: 1	عَدَمِ الْجَهْرِيَّةِ
u'عَدَمٌ جَهْلٌ':Added, #1: 1	عَدَمِ الْجَهْلِ
u'عَدَمٌ جَوَابٌ':Added, #1: 1	عَدَمِ الْجَهْلِ
u'عَدَمٌ جَوَابٌ':Added, #1: 1	عَدَمَ الْجَوَابِ
u'عَدَمٌ جَوَازٌ':Added, #1: 1	عَدَمِ جَوَابِهِ
u'عَدَمٌ جَوَازٌ':Added, #105: 105	عَدَمُ الْجَوَازِ
u'عَدَمٌ جَوَازٌ':Added, #121: 121	عَدَمِ جَوَازِ
u'عَدَمٌ جَوَازٌ':Added, #16: 16	عَدَمُ جَوَازِهِ
u'عَدَمٌ جَوَازٌ':Added, #1: 1	عَدَم الْجَوَازِ
u'عَدَمٌ جَوَازٌ':Added, #24: 24	عَدَمِ جَوَازِهِ
u'عَدَمٌ جَوَازٌ':Added, #55: 55	عَدَمَ الْجَوَازِ
u'عَدَمٌ جَوَازٌ':Added, #57: 57	عَدَمَ جَوَازِ
u'عَدَمٌ جَوَازٌ':Added, #70: 70	عَدَمِ الْجَوَازِ
u'عَدَمٌ جَوَازٌ':Added, #89: 89	عَدَمُ جَوَازِ
u'عَدَمٌ حاجِبٌ':Added, #9: 9	عَدَمَ جَوَازِهِ
u'عَدَمٌ حاجَةٌ':Added, #1: 1	عَدَمِ الْحَاجِبِ
u'عَدَمٌ حاجَةٌ':Added, #1: 1	عَدَمَ الْحَاجَةِ
u'عَدَمٌ حاجَةٌ':Added, #1: 1	عَدَمِ حَاجَةِ
u'عَدَمٌ حاجَةٌ':Added, #1: 1	عَدَمُ حَاجَتِهِ
u'عَدَمٌ حاجَةٌ':Added, #26: 26	عَدَمِ الْحَاجَةِ
u'عَدَمٌ حاجَةٌ':Added, #2: 2	عَدَمِ حَاجَتِهِ
u'عَدَمٌ حادِثٌ':Added, #4: 4	عَدَمُ الْحَاجَةِ
u'عَدَمٌ حافِرٌ':Added, #2: 2	عَدَمُ الْحَادِثِ
u'عَدَمٌ حافِظٌ':Added, #1: 1	عَدَمِ الْحَافِرِ
u'عَدِمَ حاكِمٌ':Subject, #1: 1	عَدَمَ الْحَافِظِ
u'عَدَمٌ حاكِمٌ':Added, #2: 2	عَدِمَ الْحَاكِمُ
u'عَدَمٌ حاكِمٌ':Added, #1: 1	عَدَمَ الْحَاكِمِ
u'عَدَمٌ حائِلٌ':Added, #3: 3	عَدَمِ الْحَاكِمِ
u'عَدَمٌ حائِلٌ':Added, #2: 2	عَدَمَ الْحَائِلِ
u'عَدَمٌ حائِلٌ':Added, #3: 3	عَدَمُ الْحَائِلِ
u'عَدَمٌ حَبْسٌ':Added, #3: 3	عَدَمِ الْحَائِلِ
u'عَدَمٌ حَبْسٌ':Added, #1: 1	عَدَمُ الْحَبْسِ
u'عَدَمٌ حَجٌّ':Added, #1: 1	عَدَمَ حَبْسِ
u'عَدَمٌ حَجٌّ':Added, #1: 1	عَدَمُ الْحَجِّ
u'عَدَمٌ حُجَّةٌ':Added, #1: 1	عَدَمُ حَجِّهِ
u'عَدَمٌ حُجَّة':Added, #1: 1	عَدَمُ الْحُجَّةِ
u'عَدَمٌ حَجْرٌ':Added, #1: 1	عَدَمُ الْحُجِّيَّةِ
u'عَدَمٌ حَجْرٌ':Added, #1: 1	عَدَمُ حَجْرٍ
u'عَدَمٌ حَجْرٌ':Added, #2: 2	عَدَمُ الْحَجْرِ
u'عَدَمٌ حُجِّيَّة':Added, #2: 2	عَدَمِ الْحَجْرِ
u'عَدَمٌ حَدٌّ':Added, #1: 1	عَدَمُ الْحُجِّيَّةِ
u'عَدَمٌ حَدٌّ':Added, #1: 1	عَدَمِ حَدِّهِ
u'عَدَمٌ حَدٌّ':Added, #3: 3	عَدَمَ الْحَدِّ
u'عَدَمٌ حَدٌّ':Added, #3: 3	عَدَمُ حَدِّهِ
u'عَدَمٌ حَدٌّ':Added, #5: 5	عَدَمِ الْحَدِّ
u'عَدَمٌ حَدَثٌ':Added, #6: 6	عَدَمُ الْحَدِّ
u'عَدَمٌ حَدَثٌ':Added, #1: 1	عَدَمَ الْحَدَثِ
u'عَدَمٌ حُدوثٌ':Added, #5: 5	عَدَمِ الْحَدَثِ
u'عَدَمٌ حُدوثٌ':Added, #1: 1	عَدَمِ الْحُدُوثِ
u'عَدَمٌ حُدوثٌ':Added, #1: 1	عَدَمُ حُدُوثِ
u'عَدَمٌ حُدوثٌ':Added, #1: 1	عَدَمِ حُدُوثِ
u'عَدَمٌ حُدوثٌ':Added, #1: 1	عَدَمَ حُدُوثِهِ
u'عَدَمٌ حَرٌّ':Added, #1: 1	عَدَمِ حُدُوثِهِ
u'عَدَمٌ حَرامٌ':Added, #1: 1	عَدَمُ الْحَرِّ
u'عَدَمٌ حَرامٌ':Added, #1: 1	عَدَمِ الْحَرَامِ
u'عَدَمٌ حَرَجٌ':Added, #3: 3	عَدَمَ الْحَرَامِ
u'عَدَمٌ حَرَجٌ':Added, #2: 2	عَدَمُ الْحَرَجِ
u'عَدَمٌ حِرْزٌ':Added, #3: 3	عَدَمِ الْحَرَجِ
u'عَدَمٌ حِرْزٌ':Added, #1: 1	عَدَمُ الْحِرْزِ
u'عَدَمٌ حِرْفَةٌ':Added, #2: 2	عَدَمِ حِرْزٍ
u'عَدَمٌ حَرَكَةٌ':Added, #1: 1	عَدَمِ الْحِرْفَةِ
u'عَدَمٌ حِرْمَانٌ':Added, #1: 1	عَدَمِ حَرَكَةِ
u'عَدَمٌ حُرْمَةٌ':Added, #2: 2	عَدَمِ حِرْمَانِ
u'عَدَمٌ حُرْمَةٌ':Added, #10: 10	عَدَمُ حُرْمَةِ
u'عَدَمٌ حُرْمَةٌ':Added, #2: 2	عَدَمِ حُرْمَتِهِ
u'عَدَمٌ حُرْمَةٌ':Added, #5: 5	عَدَمَ الْحُرْمَةِ
u'عَدَمٌ حُرْمَةٌ':Added, #5: 5	عَدَمِ حُرْمَةِ
u'عَدَمٌ حُرْمَةٌ':Added, #6: 6	عَدَمِ الْحُرْمَةِ
u'عَدَمٌ حُرِّيَّةٌ':Added, #9: 9	عَدَمُ الْحُرْمَةِ
u'عَدَمٌ حُرِّيَّةٌ':Added, #1: 1	عَدَمِ الْحُرِّيَّةِ
u'عَدَمٌ حُسْبَانٌ':Added, #1: 1	عَدَمُ حُرِّيَّتِهِ
u'عَدَمٌ حُسْنٌ':Added, #1: 1	عَدَمُ الْحُسْبَانِ
u'عَدَمٌ حِصَّةٌ':Added, #1: 1	عَدَمِ حُسْنِ
u'عَدَمٌ حَصْرٌ':Added, #2: 2	عَدَمُ حِصَّةِ
u'عَدَمٌ حَصْرٌ':Added, #1: 1	عَدَمَ الْحَصْرِ
u'عَدَمٌ حَصْرٌ':Added, #1: 1	عَدَمُ الْحَصْرِ
u'عَدَمٌ حَصْرٌ':Added, #2: 2	عَدَمَ حَصْرِ
u'عَدَمٌ حَصْرٌ':Added, #2: 2	عَدَمُ حَصْرِ
u'عَدَمٌ حُصُول':Added, #4: 4	عَدَمِ الْحَصْرِ
u'عَدَمٌ حُصُول':Added, #11: 11	عَدَمِ حُصُولِ
u'عَدَمٌ حُصُول':Added, #1: 1	عَدَمِ الْحُصُولِ
u'عَدَمٌ حُصُول':Added, #2: 2	عَدَمَ الْحُصُولِ
u'عَدَمٌ حُصُول':Added, #2: 2	عَدَمُ الْحُصُولِ
u'عَدَمٌ حُصُول':Added, #3: 3	عَدَمَ حُصُولِ
u'عَدِمَ حَضَانَةٌ':Predicate, #7: 7	عَدَمُ حُصُولِ
u'عَدَمٌ حضرة':Added, #1: 1	عَدِمَ الْحَضَانَةَ
u'عَدَمٌ حَضْرَةٌ':Added, #1: 1	عَدَمُ الْحَضْرَةِ
u'عَدَمٌ حضرة':Added, #1: 1	عَدَمُ الْحَضْرَةِ
u'عَدَمٌ حَضْرَةٌ':Added, #1: 1	عَدَمَ حَضْرَتِهِ
u'عَدَمٌ حُضورٌ':Added, #1: 1	عَدَمَ حَضْرَتِهِ
u'عَدَمٌ حُضُورٌ':Added, #1: 1	عَدَمُ الْحُضُورِ
u'عَدَمٌ حُضورٌ':Added, #1: 1	عَدَمُ الْحُضُورِ
u'عَدَمٌ حُضُورٌ':Added, #1: 1	عَدَمُ حُضُورِهِ
u'عَدَمٌ حُضورٌ':Added, #1: 1	عَدَمُ حُضُورِهِ
u'عَدَمٌ حُضُورٌ':Added, #2: 2	عَدَمِ الْحُضُورِ
u'عَدَمٌ حُضورٌ':Added, #2: 2	عَدَمِ الْحُضُورِ
u'عَدَمٌ حُضُورٌ':Added, #2: 2	عَدَمِ حُضُورِ
u'عَدَمٌ حُضورٌ':Added, #2: 2	عَدَمِ حُضُورِ
u'عَدَمٌ حُضُورٌ':Added, #3: 3	عَدَمُ حُضُورِ
u'عَدَمٌ حُضورٌ':Added, #3: 3	عَدَمُ حُضُورِ
u'عَدَمٌ حُضُورٌ':Added, #3: 3	عَدَمِ حُضُورِهِ
u'عَدَمٌ حَظٌّ':Added, #3: 3	عَدَمِ حُضُورِهِ
u'عَدَمٌ حَفْرٌ':Added, #3: 3	عَدَمِ الْحَظِّ
u'عَدَمٌ حِفْظٌ':Added, #4: 4	عَدَمُ الْحَفْرِ
u'عَدَمٌ حَقٌّ':Added, #1: 1	عَدَمِ الْحِفْظِ
u'عَدَمٌ حُقوقٌ':Added, #1: 1	عَدَمِ الْحَقِّ
u'عَدَمٌ حُقُوقٌ':Added, #1: 1	عَدَمُ الْحُقُوقِ
u'عَدَمٌ حَقِيقٌ':Added, #1: 1	عَدَمُ الْحُقُوقِ
u'عَدَمٌ حَقِيقٌ':Added, #1: 1	عَدَمِ الْحَقِيقَةِ
u'عَدَمٌ حَقِيقَةٌ':Added, #1: 1	عَدَمَ حَقِيقَةِ
u'عَدَمٌ حَقِيقَةٌ':Added, #1: 1	عَدَمِ الْحَقِيقَةِ
u'عَدَمٌ حِكَايَةٌ':Added, #1: 1	عَدَمَ حَقِيقَةِ
u'عَدَمٌ حِكَايَةٌ':Added, #1: 1	عَدَمَ الْحِكَايَةِ
u'عَدَمٌ حِكَايَةٌ':Added, #1: 1	عَدَمُ حِكَايَةِ
u'عَدَمٌ حُكْمٌ':Added, #1: 1	عَدَمِ حِكَايَةِ
u'عَدَمٌ حُكْمٌ':Added, #19: 19	عَدَمَ الْحُكْمِ
u'عَدَمٌ حَكَمٌ':Added, #1: 1	عَدَم الْحُكْمِ
u'عَدَمٌ حُكْمٌ':Added, #1: 1	عَدَمُ الْحَكَمَيْنِ
u'عَدَمٌ حُكْمٌ':Added, #1: 1	عَدَمَ حُكْمِ
u'عَدَمٌ حُكْمٌ':Added, #1: 1	عَدَمِ حُكْمِ
u'عَدَمٌ حُكْمٌ':Added, #1: 1	عَدَمُ حُكْمِهِ
u'عَدَمٌ حُكْمٌ':Added, #23: 23	عَدَمُ الْحُكْمِ
u'عَدَمٌ حُكْمٌ':Added, #24: 24	عَدَمِ الْحُكْمِ
u'عَدَمٌ حِلٌّ':Added, #2: 2	عَدَمِ حُكْمِهِ
u'عَدَمٌ حِلٌّ':Added, #10: 10	عَدَمُ حِلِّ
u'عَدَمٌ حِلٌّ':Added, #12: 12	عَدَمُ الْحِلِّ
u'عَدَمٌ حِلٌّ':Added, #2: 2	عَدَمَ حِلِّ
u'عَدَمٌ حِلٌّ':Added, #3: 3	عَدَمَ الْحِلِّ
u'عَدَمٌ حِلٌّ':Added, #3: 3	عَدَمِ حِلِّ
u'عَدَمٌ حِلٌّ':Added, #4: 4	عَدَمُ حِلِّهِ
u'عَدَمٌ حَلْقٌ':Added, #8: 8	عَدَمِ الْحِلِّ
u'عَدَمٌ حُلُولٌ':Added, #1: 1	عَدَمَ حَلْقِ
u'عَدَمٌ حُلُولٌ':Added, #1: 1	عَدَمُ الْحُلُولِ
u'عَدَمٌ حُلُولٌ':Added, #1: 1	عَدَمَ حُلُولِهِ
u'عَدَمٌ حَمْلٌ':Added, #2: 2	عَدَمَ الْحُلُولِ
u'عَدَمٌ حَمْلٌ':Added, #2: 2	عَدَمِ الْحَمْلِ
u'عَدَمٌ حِنْثٌ':Added, #8: 8	عَدَمُ الْحَمْلِ
u'عَدَمٌ حِنْثٌ':Added, #13: 13	عَدَمَ الْحِنْثِ
u'عَدَمٌ حِنْثٌ':Added, #1: 1	عَدَمَ حِنْثِ
u'عَدَمٌ حِنْثٌ':Added, #1: 1	عَدَمِ حِنْثِ
u'عَدَمٌ حِنْثٌ':Added, #1: 1	عَدَمِ حِنْثِهِ
u'عَدَمٌ حِنْثٌ':Added, #27: 27	عَدَمِ الْحِنْثِ
u'عَدَمٌ حِنْثٌ':Added, #29: 29	عَدَمُ الْحِنْثِ
u'عَدَمٌ حِنْثٌ':Added, #2: 2	عَدَمَ حِنْثِهِ
u'عَدَمٌ حَوْزٌ':Added, #2: 2	عَدَمُ حِنْثِهِ
u'عَدَمٌ حول':Added, #1: 1	عَدَمِ الْحَوْزِ
u'عَدَمٌ حَوْلٌ':Added, #1: 1	عَدَمِ الْحَوْلِ
u'عَدَمٌ حَيَاءٌ':Added, #1: 1	عَدَمِ الْحَوْلِ
u'عَدَمٌ حَيَاةٌ':Added, #1: 1	عَدَمُ الْحَيَاءِ
u'عَدَمٌ حَيَاةٌ':Added, #1: 1	عَدَمَ الْحَيَاةِ
u'عَدَمٌ حَيَاةٌ':Added, #1: 1	عَدَمَ حَيَاتِهِ
u'عَدَمٌ حَيَاةٌ':Added, #3: 3	عَدَمِ الْحَيَاةِ
u'عَدَمٌ حِيازَة':Added, #7: 7	عَدَمُ الْحَيَاةِ
u'عَدَمٌ حَيْضٌ':Added, #1: 1	عَدَمِ حِيَازَةِ
u'عَدَمٌ حَيْضٌ':Added, #1: 1	عَدَمُ حَيْضِ
u'عَدَمٌ حَيْضٌ':Added, #4: 4	عَدَمُ الْحَيْضِ
u'عَدَمٌ حِيلَةٌ':Added, #5: 5	عَدَمِ الْحَيْضِ
u'عَدَمٌ خَارِجٌ':Added, #1: 1	عَدَمَ الْحِيلَةِ
u'عَدَمٌ ختان':Added, #1: 1	عَدَمِ الْخَارِجِ
u'عَدَمٌ خِتَانٌ':Added, #1: 1	عَدَمَ الْخِتَانِ
u'عَدَمٌ ختان':Added, #1: 1	عَدَمَ الْخِتَانِ
u'عَدَمٌ خِتَانٌ':Added, #1: 1	عَدَمُ خِتَانِ
u'عَدَمٌ ختان':Added, #1: 1	عَدَمُ خِتَانِ
u'عَدَمٌ خِتَانٌ':Added, #2: 2	عَدَمُ الْخِتَانِ
u'عَدَمٌ خُرُوجٌ':Added, #2: 2	عَدَمُ الْخِتَانِ
u'عَدَمٌ خُرُوجٌ':Added, #1: 1	عَدَمَ الْخُرُوجِ
u'عَدَمٌ خُرُوجٌ':Added, #2: 2	عَدَمَ خُرُوجِ
u'عَدَمٌ خُرُوجٌ':Added, #2: 2	عَدَمِ خُرُوجِ
u'عَدَمٌ خُرُوجٌ':Added, #2: 2	عَدَمَ خُرُوجِهِ
u'عَدَمٌ خُرُوجٌ':Added, #2: 2	عَدَمُ خُرُوجِهِ
u'عَدَمٌ خُرُوجٌ':Added, #3: 3	عَدَمِ خُرُوجِهِ
u'عَدَمٌ خُرُوجٌ':Added, #5: 5	عَدَمِ الْخُرُوجِ
u'عَدَمٌ خُرُوجٌ':Added, #6: 6	عَدَمُ خُرُوجِ
u'عَدَمٌ خَشْيَةٌ':Added, #8: 8	عَدَمُ الْخُرُوجِ
u'عَدَمٌ خَصْمٌ':Added, #1: 1	عَدَمِ خَشْيَةِ
u'عَدَمٌ خُصُوصِيٌّ':Added, #2: 2	عَدَمِ خَصْمٍ
u'عَدَمٌ خُصُوصِيٌّ':Added, #1: 1	عَدَمَ الْخُصُوصِيَّةِ
u'عَدَمٌ خُصُوصِيٌّ':Added, #1: 1	عَدَمُ الْخُصُوصِيَّةِ
u'عَدَمٌ خِطَابٌ':Added, #1: 1	عَدَمِ خُصُوصِيَّتِهِ
u'عَدَمٌ خِطَابٌ':Added, #1: 1	عَدَمَ الْخِطَابِ
u'عَدَمٌ خِطَابٌ':Added, #1: 1	عَدَمِ الْخِطَابِ
u'عَدَمٌ خِطَابٌ':Added, #1: 1	عَدَمُ خِطَابِهِ
u'عَدَمٌ خطر':Added, #2: 2	عَدَمِ خِطَابِ
u'عَدَمٌ خَطَرٌ':Added, #1: 1	عَدَمَ الْخَطَرِ
u'عَدَمٌ خَفَاءٌ':Added, #1: 1	عَدَمَ الْخَطَرِ
u'عَدَمٌ خفاض':Added, #1: 1	عَدَمُ الْخَفَاءِ
u'عَدَمٌ خَفْض':Added, #1: 1	عَدَمِ خِفَاضِ
u'عَدَمٌ خِلاَفٌ':Added, #1: 1	عَدَمُ الْخَفْضِ
u'عَدَمٌ خِلاَفٌ':Added, #1: 1	عَدَمُ الْخِلَافِ
u'عَدَمٌ خِلاَفٌ':Added, #1: 1	عَدَمَ خِلَافِهِ
u'عَدَمٌ خِلاَفٌ':Added, #1: 1	عَدَمُ خِلَافِهِ
u'عَدَمٌ خِلاَفٌ':Added, #5: 5	عَدَمَ الْخِلَافِ
u'عَدَمٌ خِلاَفَةٌ':Added, #7: 7	عَدَمِ الْخِلَافِ
u'عَدَمٌ خلط':Added, #1: 1	عَدَمِ الْخِلَافَةِ
u'عَدَمٌ خَلْوَةٌ':Added, #1: 1	عَدَمِ الْخَلْطِ
u'عَدَمٌ خُلُودٌ':Added, #1: 1	عَدَمِ الْخَلْوَةِ
u'عَدَمٌ خُلُوصٌ':Added, #1: 1	عَدَمَ خُلُودِهِ
u'عَدَمٌ خُمُسٌ':Added, #2: 2	عَدَمِ خُلُوصِ
u'عَدَمٌ خَوْفٌ':Added, #1: 1	عَدَمَ الْخُمُسِ
u'عَدَمٌ خَوْفٌ':Added, #1: 1	عَدَمُ الْخَوْفِ
u'عَدَمٌ خَوْفٌ':Added, #1: 1	عَدَمُ خَوْفِ
u'عَدَمٌ خَوْفٌ':Added, #1: 1	عَدَمِ خَوْفٍ
u'عَدَمٌ خَوْفٌ':Added, #3: 3	عَدَمِ خَوْفِ
u'عَدَمٌ خيار':Added, #9: 9	عَدَمِ الْخَوْفِ
u'عَدَمٌ خيار':Added, #1: 1	عَدَمَ الْخِيَارِ
u'عَدَمٌ خِيَارٌ':Added, #1: 1	عَدَمِ الْخِيَارِ
u'عَدَمٌ خِيَارٌ':Added, #1: 1	عَدَمَ الْخِيَارِ
u'عَدَمٌ خيار':Added, #1: 1	عَدَمِ الْخِيَارِ
u'عَدَمٌ خِيَارٌ':Added, #1: 1	عَدَمِ خِيَارٍ
u'عَدَمٌ خيار':Added, #1: 1	عَدَمِ خِيَارٍ
u'عَدَمٌ خِيَارٌ':Added, #5: 5	عَدَمُ الْخِيَارِ
u'عَدَمٌ خِيَانَةٌ':Added, #5: 5	عَدَمُ الْخِيَارِ
u'عَدَمٌ خِيَانَةٌ':Added, #1: 1	عَدَمِ الْخِيَانَةِ
u'عَدَمٌ دَافِعٌ':Added, #2: 2	عَدَمُ الْخِيَانَةِ
u'عَدَمٌ دُخُولٌ':Added, #1: 1	عَدَمُ الدَّافِعِ
u'عَدَمٌ دُخُولٌ':Added, #10: 10	عَدَمِ دُخُولِ
u'عَدَمٌ دُخُولٌ':Added, #13: 13	عَدَمُ دُخُولِ
u'عَدَمٌ دُخُولٌ':Added, #16: 16	عَدَمَ الدُّخُولِ
u'عَدَمٌ دُخُولٌ':Added, #19: 19	عَدَمُ الدُّخُولِ
u'عَدَمٌ دُخُولٌ':Added, #21: 21	عَدَمِ الدُّخُولِ
u'عَدَمٌ دُخُولٌ':Added, #5: 5	عَدَمَ دُخُولِ
u'عَدَمٌ دُخُولٌ':Added, #7: 7	عَدَمُ دُخُولِهِ
u'عَدَمٌ دُخُولٌ':Added, #8: 8	عَدَمَ دُخُولِهِ
u'عَدَمٌ دُعَاءٌ':Added, #8: 8	عَدَمِ دُخُولِهِ
u'عَدَمٌ دُعَاءٌ':Added, #1: 1	عَدَمَ الدُّعَاءِ
u'عَدَمٌ دُعَاءٌ':Added, #1: 1	عَدَمُ الدُّعَاءِ
u'عَدَمٌ دفع':Added, #2: 2	عَدَمُ دُعَاءِ
u'عَدَمٌ دَفْعٌ':Added, #1: 1	عَدَمَ الدَّفْعِ
u'عَدَمٌ دفع':Added, #1: 1	عَدَمَ الدَّفْعِ
u'عَدَمٌ دَفْعٌ':Added, #1: 1	عَدَمَ دَفْعِ
u'عَدَمٌ دفع':Added, #1: 1	عَدَمَ دَفْعِ
u'عَدَمٌ دَفْعٌ':Added, #2: 2	عَدَمُ دَفْعِ
u'عَدَمٌ دفع':Added, #2: 2	عَدَمُ دَفْعِ
u'عَدَمٌ دَفْعٌ':Added, #4: 4	عَدَمُ الدَّفْعِ
u'عَدَمٌ دفع':Added, #4: 4	عَدَمُ الدَّفْعِ
u'عَدَمٌ دَفْعٌ':Added, #5: 5	عَدَمِ الدَّفْعِ
u'عَدَمٌ دَلالَةٌ':Added, #5: 5	عَدَمِ الدَّفْعِ
u'عَدَمٌ دَلالَةٌ':Added, #1: 1	عَدَمَ الدَّلَالَةِ
u'عَدَمٌ دَلالَةٌ':Added, #1: 1	عَدَمُ دَلَالَةِ
u'عَدَمٌ دَلالَةٌ':Added, #1: 1	عَدَمِ دَلَالَةٍ
u'عَدَمٌ دَلالَةٌ':Added, #2: 2	عَدَمِ الدَّلَالَةِ
u'عَدَمٌ دَلالَةٌ':Added, #2: 2	عَدَمِ دَلَالَتِهِ
u'عَدَمٌ دَلالَةٌ':Added, #3: 3	عَدَمَ دَلَالَةِ
u'عَدَمٌ دَلالَةٌ':Added, #4: 4	عَدَمِ دَلَالَةِ
u'عَدِمَ دَلائِلُ':Predicate, #6: 6	عَدَمُ الدَّلَالَةِ
u'عَدِمَ دَليلٌ':Predicate, #1: 1	عَدِمَ الدَّلَائِلَ
u'عَدِمَ دَليلٌ':Subject, #1: 1	عَدِمَ الدَّلِيلَ
u'عَدَمٌ دَليلٌ':Added, #1: 1	عَدِمَ دَلِيلُ
u'عَدَمٌ دَليلٌ':Added, #1: 1	عَدَمُ الدَّلِيلِ
u'عَدَمٌ دَليلٌ':Added, #1: 1	عَدَمُ دَلِيلِ
u'عَدَمٌ دَليلٌ':Added, #1: 1	عَدَمِ دَلِيلِ
u'عَدَمٌ دَليلٌ':Added, #2: 2	عَدَمَ الدَّلِيلِ
u'عَدِمَ دَمٌ':Predicate, #8: 8	عَدَمِ الدَّلِيلِ
u'عَدَمٌ دَمٌ':Added, #2: 2	عَدِمَ الدَّمَ
u'عَدَمٌ دَمٌ':Added, #1: 1	عَدَمُ الدَّمِ
u'عَدَمٌ دَمٌ':Added, #1: 1	عَدَمِ الدَّمِ
u'عَدَمٌ دَهْنٌ':Added, #1: 1	عَدَمُ دَمِ
u'عَدِمَ دَواءٌ':Predicate, #1: 1	عَدَمَ الدَّهْنِ
u'عَدَمٌ دَوامٌ':Added, #1: 1	عَدِمَ الدَّوَاءَ
u'عَدَمٌ دَوامٌ':Added, #1: 1	عَدَمَ دَوَامِهِ
u'عَدَمٌ دَوامٌ':Added, #1: 1	عَدَمِ دَوَامِهِ
u'عَدَمٌ دِينٌ':Added, #2: 2	عَدَمُ دَوَامِ
u'عَدَمٌ دَيْنٌ':Added, #1: 1	عَدَمِ الدِّينِ
u'عَدَمٌ دَيْنٌ':Added, #1: 1	عَدَمِ دَيْنٍ
u'عَدَمٌ دَيْنٌ':Added, #2: 2	عَدَمُ الدَّيْنِ
u'عَدَمٌ ذَبٌّ':Added, #2: 2	عَدَمِ الدَّيْنِ
u'عَدَمٌ ذَكاءٌ':Added, #1: 1	عَدَمِ الذَّبِّ
u'عَدَمٌ ذكر':Added, #1: 1	عَدَمِ الذَّكَاءِ
u'عَدَمٌ ذِكْرٌ':Added, #15: 15	عَدَمِ ذِكْرِ
u'عَدَمٌ ذكر':Added, #15: 15	عَدَمِ ذِكْرِ
u'عَدَمٌ ذِكْرٌ':Added, #1: 1	عَدَم ذِكْرِ
u'عَدَمٌ ذكر':Added, #1: 1	عَدَم ذِكْرِ
u'عَدَمٌ ذِكْرٌ':Added, #2: 2	عَدَمِ الذِّكْرِ
u'عَدَمٌ ذكر':Added, #2: 2	عَدَمِ الذِّكْرِ
u'عَدَمٌ ذِكْرٌ':Added, #2: 2	عَدَمَ ذِكْرِ
u'عَدَمٌ ذكر':Added, #2: 2	عَدَمَ ذِكْرِ
u'عَدَمٌ ذِكْرٌ':Added, #4: 4	عَدَمُ ذِكْرِ
u'عَدَمٌ ذكر':Added, #4: 4	عَدَمُ ذِكْرِ
u'عَدَمٌ ذكر':Added, #4: 4	عَدَمَ ذِكْرِهِ
u'عَدَمٌ ذِكْرٌ':Added, #4: 4	عَدَمِ ذِكْرِهِ
u'عَدَمٌ ذِكْرٌ':Added, #4: 4	عَدَمَ ذِكْرِهِ
u'عَدَمٌ ذكر':Added, #4: 4	عَدَمِ ذِكْرِهِ
u'عَدَمٌ ذِكْرٌ':Added, #5: 5	عَدَمُ ذِكْرِهِ
u'عَدَمٌ ذِمَّةٌ':Added, #5: 5	عَدَمُ ذِكْرِهِ
u'عَدَمٌ ذَنْبٌ':Added, #1: 1	عَدَمُ الذِّمَّةِ
u'عَدَمٌ ذَنَبٌ':Added, #1: 1	عَدَمُ الذّنْبِ
u'عَدَمٌ ذَهَابٌ':Added, #2: 2	عَدَمُ الذَّنَبِ
u'عَدَمٌ ذَهَابٌ':Added, #1: 1	عَدَمَ ذَهَابِهِ
u'عَدَمٌ رَابِطٌ':Added, #1: 1	عَدَمِ ذَهَابِهِ
u'عَدِمَ رِبْحٌ':Predicate, #2: 2	عَدَمِ الرَّابِطِ
u'عَدَمٌ رِبْحٌ':Added, #1: 1	عَدِمَ الرِّبْحَ
u'عَدَمٌ رِبْحٌ':Added, #4: 4	عَدَمُ الرِّبْحِ
u'عَدَمٌ رَبْطٌ':Added, #4: 4	عَدَمِ الرِّبْحِ
u'عَدَمٌ رِبَوِيّ':Added, #2: 2	عَدَمِ الرَّبْطِ
u'عَدَمٌ رَجاء':Added, #1: 1	عَدَمِ رِبَوِيَّةِ
u'عَدَمٌ رَجَاءٌ':Added, #2: 2	عَدَمِ الرَّجَاءِ
u'عَدَمٌ رِجَالٌ':Added, #2: 2	عَدَمِ الرَّجَاءِ
u'عَدَمٌ رُجْحانٌ':Added, #2: 2	عَدَمِ الرِّجَالِ
u'عَدَمٌ رُجْحانٌ':Added, #1: 1	عَدَمُ الرُّجْحَانِ
u'عَدَمٌ رُجْحانٌ':Added, #1: 1	عَدَمَ رُجْحَانِ
u'عَدَمٌ رجعة':Added, #2: 2	عَدَمُ رُجْحَانِ
u'عَدَمٌ رَجْعَةٌ':Added, #1: 1	عَدَمِ رَجْعَتِهِ
u'عَدَمٌ رجعة':Added, #1: 1	عَدَمِ رَجْعَتِهِ
u'عَدَمٌ رَجْعَةٌ':Added, #3: 3	عَدَمُ الرَّجْعَةِ
u'عَدَمٌ رَجُلٌ':Added, #3: 3	عَدَمُ الرَّجْعَةِ
u'عَدَمٌ رَجْمٌ':Added, #1: 1	عَدَمَ الرَّجُلَيْنِ
u'عَدِمَ رُجُوعٌ':Predicate, #1: 1	عَدَمُ رَجْمِهِ
u'عَدَمٌ رُجُوعٌ':Added, #1: 1	عَدِمَ الرُّجُوعَ
u'عَدَمٌ رُجُوعٌ':Added, #15: 15	عَدَمِ الرُّجُوعِ
u'عَدَمٌ رُجُوعٌ':Added, #18: 18	عَدَمَ الرُّجُوعِ
u'عَدَمٌ رُجُوعٌ':Added, #1: 1	عَدَمَ رُجُوعِ
u'عَدَمٌ رُجُوعٌ':Added, #26: 26	عَدَمُ الرُّجُوعِ
u'عَدَمٌ رُجُوعٌ':Added, #2: 2	عَدَمُ رُجُوعِ
u'عَدَمٌ رُجُوعٌ':Added, #2: 2	عَدَمُ رُجُوعِهِ
u'عَدَمٌ رُجُوعٌ':Added, #3: 3	عَدَمِ رُجُوعِهِ
u'عَدَمٌ رحم':Added, #4: 4	عَدَمِ رُجُوعِ
u'عَدَمٌ رَحِمٌ':Added, #1: 1	عَدَمِ الرَّحِمِ
u'عَدَمٌ رحمة':Added, #1: 1	عَدَمِ الرَّحِمِ
u'عَدَمٌ رَحْمَةٌ':Added, #1: 1	عَدَمِ رَحْمَتِهِ
u'عَدَمٌ رَدٌّ':Added, #1: 1	عَدَمِ رَحْمَتِهِ
u'عَدَمٌ رَدٌّ':Added, #12: 12	عَدَمُ الرَّدِّ
u'عَدَمٌ رَدٌّ':Added, #1: 1	عَدَمَ رَدِّ
u'عَدَمٌ رَدٌّ':Added, #1: 1	عَدَمِ رَدِّهِ
u'عَدَمٌ رَدٌّ':Added, #2: 2	عَدَمَ رَدِّهِ
u'عَدَمٌ رَدٌّ':Added, #3: 3	عَدَمُ رَدِّ
u'عَدَمٌ رَدٌّ':Added, #3: 3	عَدَمُ رَدِّهِ
u'عَدَمٌ رَدٌّ':Added, #4: 4	عَدَمَ الرَّدِّ
u'عَدَمٌ رِدَّةٌ':Added, #9: 9	عَدَمِ الرَّدِّ
u'عَدَمٌ رُسُوخ':Added, #2: 2	عَدَمُ الرِّدَّةِ
u'عَدَمٌ رُشْدٌ':Added, #1: 1	عَدَمُ الرُّسُوخِ
u'عَدَمٌ رَضْخ':Added, #1: 1	عَدَمُ الرُّشْدِ
u'عَدَمٌ رَضْخ':Added, #1: 1	عَدَمُ الرَّضْخِ
u'عَدَمٌ رِعايَةٌ':Added, #2: 2	عَدَمَ الرَّضْخِ
u'عَدَمٌ رَعْيٌ':Added, #1: 1	عَدَمِ رِعَايَةِ
u'عَدَمٌ رَغْبَةٌ':Added, #2: 2	عَدَمَ رَعْيِ
u'عَدَمٌ رَفْعٌ':Added, #1: 1	عَدَمَ الرَّغْبَةِ
u'عَدَمٌ رَفْعٌ':Added, #1: 1	عَدَمُ الرَّفْعِ
u'عَدَمٌ رَفْعٌ':Added, #1: 1	عَدَمِ الرَّفْعِ
u'عَدَمٌ رَفْعٌ':Added, #1: 1	عَدَمُ رَفْعِ
u'عَدَمٌ رَفْعٌ':Added, #1: 1	عَدَمِ رَفْعِهِ
u'عَدَمٌ رِفْقٌ':Added, #2: 2	عَدَمُ رَفْعِهِ
u'عَدَمٌ رُكْنٌ':Added, #1: 1	عَدَمُ الرِّفْقِ
u'عَدَمٌ رُكْن':Added, #1: 1	عَدَمَ الرُّكْنِ
u'عَدَمٌ رُكْنٌ':Added, #1: 1	عَدَمَ الرُّكْنِ
u'عَدَمٌ رُكْن':Added, #1: 1	عَدَمِ رُكْنِ
u'عَدَمٌ رُكْنٌ':Added, #1: 1	عَدَمِ رُكْنِ
u'عَدَمٌ رُكْن':Added, #2: 2	عَدَمِ الرُّكْنِ
u'عَدَمٌ رُكْنٌ':Added, #2: 2	عَدَمِ الرُّكْنِ
u'عَدَمٌ رُكْن':Added, #2: 2	عَدَمِ رُكْنِهِ
u'عَدَمٌ رُكوبٌ':Added, #2: 2	عَدَمِ رُكْنِهِ
u'عَدَمٌ رَمَلٌ':Added, #1: 1	عَدَمِ الرُّكُوبِ
u'عَدَمٌ رَمْيٌ':Added, #1: 1	عَدَمِ الرَّمَلِ
u'عَدَمٌ رَهْنٌ':Added, #1: 1	عَدَمِ رَمْيِ
u'عَدَمٌ رَهينٌ':Added, #1: 1	عَدَمُ رَهْنِ
u'عَدَمٌ رَهينَةٌ':Added, #1: 1	عَدَمُ الرَّهِينَةِ
u'عَدَمٌ رَوَاجٌ':Added, #1: 1	عَدَمُ الرَّهِينَةِ
u'عَدَمٌ رِوايَةٌ':Added, #1: 1	عَدَمَ الرَّوَاجِ
u'عَدَمٌ روحٌ':Added, #1: 1	عَدَمَ الرِّوَايَةِ
u'عَدَمٌ رُؤْيَةٌ':Added, #1: 1	عَدَمِ الرُّوحِ
u'عَدَمٌ رُؤْيَةٌ':Added, #1: 1	عَدَمَ الرُّؤْيَةِ
u'عَدَمٌ رُؤْيَةٌ':Added, #1: 1	عَدَمُ رُؤْيَةِ
u'عَدَمٌ رُؤْيَةٌ':Added, #1: 1	عَدَمِ رُؤْيَةِ
u'عَدَمٌ رُؤْيَةٌ':Added, #1: 1	عَدَمَ رُؤْيَتِهِ
u'عَدَمٌ رُؤْيَةٌ':Added, #1: 1	عَدَمُ رُؤْيَتِهِ
u'عَدَمٌ رُؤْيَةٌ':Added, #1: 1	عَدَمِ رُؤْيَتِهِ
u'عَدَمٌ رُؤْيَةٌ':Added, #4: 4	عَدَمُ الرُّؤْيَةِ
u'عَدَمٌ رُؤْيَةٌ':Added, #5: 5	عَدَمِ الرُّؤْيَةِ
u'عَدَمٌ رِيبَةٌ':Added, #5: 5	عَدَمِ رُؤْيَةٍ
u'عَدَمٌ زادٌ':Added, #2: 2	عَدَمُ الرِّيبَةِ
u'عَدَمٌ زائِدٌ':Added, #2: 2	عَدَمِ زَادٍ
u'عَدَمٌ زَكاةٌ':Added, #2: 2	عَدَمُ الزَّائِدِ
u'عَدَمٌ زَكاةٌ':Added, #1: 1	عَدَمَ الزَّكَاةِ
u'عَدَمٌ زَكاةٌ':Added, #3: 3	عَدَمُ الزَّكَاةِ
u'عَدَمٌ زَوالٌ':Added, #3: 3	عَدَمِ الزَّكَاةِ
u'عَدَمٌ زَوالٌ':Added, #2: 2	عَدَمَ زَوَالِ
u'عَدَمٌ زَوالٌ':Added, #2: 2	عَدَمِ زَوَالِ
u'عَدَمٌ زَوالٌ':Added, #2: 2	عَدَمُ زَوَالِهِ
u'عَدِمَ زَوْجٌ':Subject, #3: 3	عَدَمُ زَوَالِ
u'عَدَمٌ زَوْجٌ':Added, #1: 1	عَدِمَ الزَّوْجُ
u'عَدَمٌ زَوْجٌ':Added, #1: 1	عَدَمِ الزَّوْجِ
u'عَدَمٌ زَوْجَةٌ':Added, #1: 1	عَدَمُ زَوْجِ
u'عَدَمٌ زَوْجِيٌّ':Added, #2: 2	عَدَمِ الزَّوْجَةِ
u'عَدَمٌ زِيادَةٌ':Added, #1: 1	عَدَمِ الزَّوْجِيَّةِ
u'عَدَمٌ زِيادَةٌ':Added, #1: 1	عَدَمَ الزِّيَادَةِ
u'عَدَمٌ زِيادَةٌ':Added, #1: 1	عَدَمِ زِيَادَةِ
u'عَدَمٌ زِيادَةٌ':Added, #2: 2	عَدَمُ زِيَادَةٍ
u'عَدَمٌ زِيادَةٌ':Added, #5: 5	عَدَمُ الزِّيَادَةِ
u'عَدَمٌ زِيادَةٌ':Added, #5: 5	عَدَمِ الزِّيَادَةِ
u'عَدَمٌ زِينَةٌ':Added, #6: 6	عَدَمُ زِيَادَةِ
u'عَدَمٌ سَابِقٌ':Added, #1: 1	عَدَمِ الزِّينَةِ
u'عَدَمٌ سَابِقٌ':Added, #1: 1	عَدَمِ السَّابِقِ
u'عَدَمٌ سَابِقٌ':Added, #1: 1	عَدَمِ سَابِقَةِ
u'عَدَمٌ سَاتِرٌ':Added, #2: 2	عَدَمٍ سَابِقٍ
u'عَدَمٌ سَبَبٌ':Added, #1: 1	عَدَمِ السَّاتِرِ
u'عَدَمٌ سَبَبٌ':Added, #1: 1	عَدَمُ سَبَبِهِ
u'عَدَمٌ سَبَبٌ':Added, #2: 2	عَدَمِ السَّبَبِ
u'عَدَمٌ سَبَبٌ':Added, #2: 2	عَدَمِ سَبَبِهِ
u'عَدَمٌ سَبَبِيَّةٌ':Added, #5: 5	عَدَمُ السَّبَبِ
u'عَدَمٌ سَبْعٌ':Added, #1: 1	عَدَمِ السَّبَبِيَّةِ
u'عَدَمٌ سَبْقٌ':Added, #1: 1	عَدَمُ السَّبْعِ
u'عَدَمٌ سَبْقٌ':Added, #2: 2	عَدَمِ السَّبْقِ
u'عَدَمٌ سَبْقٌ':Added, #2: 2	عَدَمَ سَبْقِ
u'عَدَمٌ سَبْقٌ':Added, #2: 2	عَدَمِ سَبْقِ
u'عَدِمَ سترة':Predicate, #2: 2	عَدَمُ سَبْقِهِ
u'عَدِمَ سُتْرَةٌ':Predicate, #1: 1	عَدِمَ السُّتْرَةَ
u'عَدَمٌ سترة':Added, #1: 1	عَدِمَ السُّتْرَةَ
u'عَدَمٌ سُتْرَةٌ':Added, #3: 3	عَدَمِ السُّتْرَةِ
u'عَدَمٌ سَجْنٌ':Added, #3: 3	عَدَمِ السُّتْرَةِ
u'عَدَمٌ سُجُودٌ':Added, #1: 1	عَدَمُ سَجْنِهِ
u'عَدَمٌ سُجُودٌ':Added, #1: 1	عَدَمَ السُّجُودِ
u'عَدَمٌ سُجُودٌ':Added, #1: 1	عَدَمُ سُجُودِهِ
u'عَدَمٌ سُجُودٌ':Added, #1: 1	عَدَمِ سُجُودِهِ
u'عَدَمٌ سُجُودٌ':Added, #2: 2	عَدَمُ السُّجُودِ
u'عَدَمٌ سَدٌّ':Added, #2: 2	عَدَمِ السُّجُودِ
u'عَدَمٌ سِعَايَةٌ':Added, #1: 1	عَدَمِ سَدِّ
u'عَدَمٌ سَعَةٌ':Added, #1: 1	عَدَمُ السِّعَايَةِ
u'عَدَمٌ سَفَرٌ':Added, #2: 2	عَدَمِ سَعَتِهِ
u'عَدَمٌ سَفَرٌ':Added, #1: 1	عَدَمِ السَّفَرِ
u'عَدَمٌ سَقْفٌ':Added, #2: 2	عَدَمِ سَفَرِهِ
u'عَدَمٌ سُقُوطٌ':Added, #1: 1	عَدَمُ السَّقْفِ
u'عَدَمٌ سُقُوطٌ':Added, #10: 10	عَدَمِ السُّقُوطِ
u'عَدَمٌ سُقُوطٌ':Added, #11: 11	عَدَمِ سُقُوطِ
u'عَدَمٌ سُقُوطٌ':Added, #20: 20	عَدَمُ السُّقُوطِ
u'عَدَمٌ سُقُوطٌ':Added, #4: 4	عَدَمُ سُقُوطِهِ
u'عَدَمٌ سُقُوطٌ':Added, #4: 4	عَدَمِ سُقُوطِهِ
u'عَدَمٌ سُقُوطٌ':Added, #5: 5	عَدَمَ السُّقُوطِ
u'عَدَمٌ سُقُوطٌ':Added, #6: 6	عَدَمُ سُقُوطِ
u'عَدَمٌ سُقُوطٌ':Added, #6: 6	عَدَمَ سُقُوطِهِ
u'عَدَمٌ سَقْيٌ':Added, #8: 8	عَدَمَ سُقُوطِ
u'عَدَمٌ سكر':Added, #1: 1	عَدَمِ سَقْيِ
u'عَدَمٌ سكر':Added, #1: 1	عَدَمَ السُّكْرِ
u'عَدَمٌ سُكْرٌ':Added, #1: 1	عَدَمِ السُّكْرِ
u'عَدَمٌ سُكْرٌ':Added, #1: 1	عَدَمَ السُّكْرِ
u'عَدَمٌ سِكِّينٌ':Added, #1: 1	عَدَمِ السُّكْرِ
u'عَدَمٌ سلام':Added, #1: 1	عَدَمُ السِّكِّينِ
u'عَدَمٌ سَلاَمٌ':Added, #1: 1	عَدَمُ السَّلَامِ
u'عَدَمٌ سَلاَمَةٌ':Added, #1: 1	عَدَمُ السَّلَامِ
u'عَدَمٌ سَلاَمَةٌ':Added, #1: 1	عَدَمَ سَلَامَةِ
u'عَدَمٌ سَلاَمَةٌ':Added, #1: 1	عَدَمَ سَلَامَتِهِ
u'عَدَمٌ سَلاَمَةٌ':Added, #2: 2	عَدَمِ السَّلَامَةِ
u'عَدَمٌ سَلْبٌ':Added, #2: 2	عَدَمُ سَلَامَةِ
u'عَدَمٌ سُلْطَانٌ':Added, #1: 1	عَدَمِ سَلْبِ
u'عَدِمَ سَمَاعٌ':Predicate, #1: 1	عَدَمِ السُّلْطَانِ
u'عَدَمٌ سَمَاعٌ':Added, #1: 1	عَدِمَ سَمَاعَ
u'عَدَمٌ سَمَاعٌ':Added, #13: 13	عَدَمِ سَمَاعِ
u'عَدَمٌ سَمَاعٌ':Added, #1: 1	عَدَمَ السّمَاعِ
u'عَدَمٌ سَمَاعٌ':Added, #1: 1	عَدَمِ السَّمَاعِ
u'عَدَمٌ سَمَاعٌ':Added, #1: 1	عَدَمَ سَمَاعِ
u'عَدَمٌ سَمَاعٌ':Added, #1: 1	عَدَمُ سَمَاعِهِ
u'عَدَمٌ سَمَاعٌ':Added, #1: 1	عَدَمِ سَمَاعِهِ
u'عَدَمٌ سَمَاعٌ':Added, #2: 2	عَدَمَ السَّمَاعِ
u'عَدَمٌ سَمَاعٌ':Added, #2: 2	عَدَمُ السَّمَاعِ
u'عَدِمَ سِنٌّ':Predicate, #4: 4	عَدَمُ سَمَاعِ
u'عَدَمٌ سُنِّيٌّ':Added, #2: 2	عَدِمَ السِّنَّ
u'عَدَمٌ سُنِّيٌّ':Added, #1: 1	عَدَمِ السُّنِّيَّةِ
u'عَدَمٌ سُنِّيٌّ':Added, #1: 1	عَدَمَ سُنِّيَّتِهِ
u'عَدَمٌ سُنِّيٌّ':Added, #1: 1	عَدَمِ سُنِّيَّتِهِ
u'عَدَمٌ سهام':Added, #2: 2	عَدَمُ سُنِّيَّةِ
u'عَدَمٌ سِهَامٌ':Added, #1: 1	عَدَمِ السِّهَامِ
u'عَدَمٌ سَهْوٌ':Added, #1: 1	عَدَمِ السِّهَامِ
u'عَدَمٌ سَهْوٌ':Added, #1: 1	عَدَمُ السَّهْوِ
u'عَدَمٌ سَهْوٌ':Added, #1: 1	عَدَمَ سَهْوِهِ
u'عَدَمٌ سِواكٌ':Added, #1: 1	عَدَمُ سَهْوِهِ
u'عَدَمٌ سُؤَالٌ':Added, #1: 1	عَدَمِ السِّوَاكِ
u'عَدَمٌ سُؤَالٌ':Added, #1: 1	عَدَمَ السُّؤَالِ
u'عَدَمٌ سُؤَالٌ':Added, #1: 1	عَدَمَ سُؤَالِ
u'عَدَمٌ سُؤَالٌ':Added, #1: 1	عَدَمِ سُؤَالِ
u'عَدَمٌ سُؤَالٌ':Added, #1: 1	عَدَمُ سُؤَالِهِ
u'عَدَمٌ سُورَةٌ':Added, #3: 3	عَدَمِ السُّؤَالِ
u'عَدَمٌ سَيْرٌ':Added, #1: 1	عَدَمَ السُّورَةِ
u'عَدَمٌ شَاهِدٌ':Added, #1: 1	عَدَمِ السَّيْرِ
u'عَدَمٌ شَاهِدٌ':Added, #1: 1	عَدَمِ الشَّاهِدِ
u'عَدَمٌ شِبَعٌ':Added, #1: 1	عَدَمِ شَاهِدِ
u'عَدَمٌ شُبْهَةٌ':Added, #1: 1	عَدَمِ الشِّبَعِ
u'عَدَمٌ شُبْهَةٌ':Added, #1: 1	عَدَمِ الشُّبْهَةِ
u'عَدَمٌ شجَاعٌ':Added, #3: 3	عَدَمُ الشُّبْهَةِ
u'عَدَمٌ شَجَاعَةٌ':Added, #1: 1	عَدَمِ الشَّجَاعَةِ
u'عَدَمٌ شِرَاءٌ':Added, #1: 1	عَدَمِ الشَّجَاعَةِ
u'عَدَمٌ شِرَاءٌ':Added, #1: 1	عَدَمِ الشِّرَاءِ
u'عَدَمٌ شرب':Added, #1: 1	عَدَمِ شِرَاءِ
u'عَدَمٌ شُرْبٌ':Added, #1: 1	عَدَمَ شُرْبِهِ
u'عَدِمَ شَرْطٌ':Predicate, #1: 1	عَدَمَ شُرْبِهِ
u'عَدِمَ شَرْطٌ':Predicate, #1: 1	عَدِمَ الشَّرْطَ
u'عَدَمٌ شَرْطٌ':Added, #2: 2	عَدِمَ شَرْطَ
u'عَدَمٌ شَرْطٌ':Added, #1: 1	عَدَمُ شَرْطِهِ
u'عَدَمٌ شَرْطٌ':Added, #29: 29	عَدَمِ الشَّرْطِ
u'عَدَمٌ شَرْطٌ':Added, #2: 2	عَدَمِ شَرْطٍ
u'عَدَمٌ شَرْطٌ':Added, #2: 2	عَدَمِ شَرْطِهِ
u'عَدَمٌ شَرْطٌ':Added, #4: 4	عَدَمُ الشَّرْطِ
u'عَدَمٌ شَرْطٌ':Added, #4: 4	عَدَمُ شَرْطِ
u'عَدَمٌ شَرْطٌ':Added, #4: 4	عَدَمِ شَرْطِ
u'عَدَمٌ شَرْعِيٌّ':Added, #5: 5	عَدَمَ الشَّرْطِ
u'عَدَمٌ شَرْعِيٌّ':Added, #1: 1	عَدَمِ الشَّرْعِيَّةِ
u'عَدَمٌ شركة':Added, #1: 1	عَدَمِ شَرْعِيَّةِ
u'عَدَمٌ شركة':Added, #1: 1	عَدَمُ الشَّرِكَةِ
u'عَدَمٌ شَرِكَةٌ':Added, #1: 1	عَدَمِ الشَّرِكَةِ
u'عَدَمٌ شَرِكَةٌ':Added, #1: 1	عَدَمُ الشَّرِكَةِ
u'عَدَمٌ شُرُوعٌ':Added, #1: 1	عَدَمِ الشَّرِكَةِ
u'عَدَمٌ شُرُوعٌ':Added, #1: 1	عَدَمُ شُرُوعِهِ
u'عَدَمٌ شُرُوعٌ':Added, #1: 1	عَدَمِ شُرُوعِهِ
u'عَدَمٌ شعار':Added, #2: 2	عَدَمَ الشُّرُوعِ
u'عَدَمٌ شِعَارٌ':Added, #1: 1	عَدَمِ الشِّعَارِ
u'عَدِمَ شَعْرٌ':Predicate, #1: 1	عَدَمِ الشِّعَارِ
u'عَدَمٌ شَعْرٌ':Added, #1: 1	عَدِمَ الشَّعْرَ
u'عَدَمٌ شَعْرٌ':Added, #1: 1	عَدَمُ الشَّعْرِ
u'عَدَمٌ شَعْرٌ':Added, #1: 1	عَدَمِ الشَّعْرِ
u'عَدَمٌ شُعُورٌ':Added, #1: 1	عَدَمِ شَعْرِهِ
u'عَدَمٌ شُعُورٌ':Added, #1: 1	عَدَمَ الشُّعُورِ
u'عَدَمٌ شُعُورٌ':Added, #1: 1	عَدَمِ شُعُورِ
u'عَدَمٌ شِفَاءٌ':Added, #3: 3	عَدَمِ الشُّعُورِ
u'عَدَمٌ شفعة':Added, #1: 1	عَدَمُ الشِّفَاءِ
u'عَدَمٌ شفعة':Added, #3: 3	عَدَمَ الشُّفْعَةِ
u'عَدَمٌ شُفْعَةٌ':Added, #3: 3	عَدَمِ الشُّفْعَةِ
u'عَدَمٌ شُفْعَةٌ':Added, #3: 3	عَدَمَ الشُّفْعَةِ
u'عَدَمٌ شقاق':Added, #3: 3	عَدَمِ الشُّفْعَةِ
u'عَدَمٌ شِقَاقٌ':Added, #2: 2	عَدَمِ الشِّقَاقِ
u'عَدَمٌ شَقِيقٌ':Added, #2: 2	عَدَمِ الشِّقَاقِ
u'عَدَمٌ شَكٌّ':Added, #2: 2	عَدَمِ الشَّقِيقِ
u'عَدَمٌ شَكٌّ':Added, #1: 1	عَدَمَ الشَّكِّ
u'عَدَمٌ شَكٌّ':Added, #1: 1	عَدَمِ الشَّكِّ
u'عَدَمٌ شُمُول':Added, #2: 2	عَدَمُ الشَّكِّ
u'عَدَمٌ شُمُول':Added, #1: 1	عَدَمَ شُمُولِ
u'عَدَمٌ شَهَادَةٌ':Added, #2: 2	عَدَمُ شُمُولِ
u'عَدَمٌ شهرة':Added, #2: 2	عَدَمِ شَهَادَةِ
u'عَدَمٌ شُهْرَةٌ':Added, #1: 1	عَدَمُ شُهْرَةِ
u'عَدَمٌ شهرة':Added, #1: 1	عَدَمُ شُهْرَةِ
u'عَدَمٌ شُهْرَةٌ':Added, #3: 3	عَدَمِ شُهْرَةِ
u'عَدَمٌ شَهْوَةٌ':Added, #3: 3	عَدَمِ شُهْرَةِ
u'عَدَمٌ شَيْءٌ':Added, #2: 2	عَدَمِ الشَّهْوَةِ
u'عَدَمٌ شَيْءٌ':Added, #1: 1	عَدَمُ الشَّيْءِ
u'عَدَمٌ شَيْءٌ':Added, #1: 1	عَدَمِ الشَّيْءِ
u'عَدَمٌ شَيْءٌ':Added, #2: 2	عَدَمَ الشَّيْءِ
u'عَدَمٌ صَاحِبٌ':Added, #6: 6	عَدَمِ شَيْءٍ
u'عَدَمٌ صبر':Added, #2: 2	عَدَمِ صَاحِبِ
u'عَدَمٌ صَبْرٌ':Added, #1: 1	عَدَمِ الصَّبْرِ
u'عَدَمٌ صبر':Added, #1: 1	عَدَمِ الصَّبْرِ
u'عَدَمٌ صَبْرٌ':Added, #1: 1	عَدَمُ صَبْرِهِ
u'عَدَمٌ صبر':Added, #1: 1	عَدَمُ صَبْرِهِ
u'عَدَمٌ صَبْرٌ':Added, #2: 2	عَدَمِ صَبْرِهِ
u'عَدَمٌ صِحَّةٌ':Added, #2: 2	عَدَمِ صَبْرِهِ
u'عَدَمٌ صِحَّةٌ':Added, #107: 107	عَدَمُ صِحَّةِ
u'عَدَمٌ صِحَّةٌ':Added, #109: 109	عَدَمُ الصِّحَّةِ
u'عَدَمٌ صِحَّةٌ':Added, #16: 16	عَدَمِ صِحَّتِهِ
u'عَدَمٌ صِحَّةٌ':Added, #1: 1	عَدَم الصِّحَّةِ
u'عَدَمٌ صِحَّةٌ':Added, #36: 36	عَدَمَ صِحَّةِ
u'عَدَمٌ صِحَّةٌ':Added, #41: 41	عَدَمِ الصِّحَّةِ
u'عَدَمٌ صِحَّةٌ':Added, #73: 73	عَدَمَ الصِّحَّةِ
u'عَدَمٌ صِحَّةٌ':Added, #78: 78	عَدَمِ صِحَّةِ
u'عَدَمٌ صِحَّةٌ':Added, #7: 7	عَدَمَ صِحَّتِهِ
u'عَدِمَ صداق':Predicate, #9: 9	عَدَمُ صِحَّتِهِ
u'عَدِمَ صَدَاقٌ':Predicate, #1: 1	عَدِمَ صَدَاقَ
u'عَدَمٌ صداق':Added, #1: 1	عَدِمَ صَدَاقَ
u'عَدَمٌ صَدَاقٌ':Added, #1: 1	عَدَمِ الصَّدَاقِ
u'عَدَمٌ صدق':Added, #1: 1	عَدَمِ الصَّدَاقِ
u'عَدَمٌ صِدْقٌ':Added, #1: 1	عَدَمِ صِدْقِ
u'عَدَمٌ صدق':Added, #1: 1	عَدَمِ صِدْقِ
u'عَدَمٌ صِدْقٌ':Added, #2: 2	عَدَمَ صِدْقِ
u'عَدَمٌ صدق':Added, #2: 2	عَدَمَ صِدْقِ
u'عَدَمٌ صِدْقٌ':Added, #2: 2	عَدَمِ صِدْقِهِ
u'عَدَمٌ صدق':Added, #2: 2	عَدَمِ صِدْقِهِ
u'عَدَمٌ صِدْقٌ':Added, #4: 4	عَدَمُ صِدْقِ
u'عَدَمٌ صَرَاحَةٌ':Added, #4: 4	عَدَمُ صِدْقِ
u'عَدَمٌ صَرْفٌ':Added, #1: 1	عَدَمِ صَرَاحَةٍ
u'عَدَمٌ صَرْفٌ':Added, #1: 1	عَدَمَ صَرْفِهِ
u'عَدَمٌ صَرْف':Added, #1: 1	عَدَمُ صَرْفِهِ
u'عَدَمٌ صَرْف':Added, #1: 1	عَدَمَ صَرْفِهِ
u'عَدَمٌ صَرْفٌ':Added, #1: 1	عَدَمُ صَرْفِهِ
u'عَدَمٌ صَرْف':Added, #2: 2	عَدَمُ الصَّرْفِ
u'عَدِمَ صَعِيدٌ':Predicate, #2: 2	عَدَمُ الصَّرْفِ
u'عَدَمٌ صِغَرٌ':Added, #1: 1	عَدِمَ الصَّعِيدَ
u'عَدَمٌ صَلاَةٌ':Added, #1: 1	عَدَمِ صِغَرِهِ
u'عَدَمٌ صَلاَةٌ':Added, #1: 1	عَدَمَ صَلَاتِهِ
u'عَدَمٌ صَلاَةٌ':Added, #1: 1	عَدَمِ صَلَاتِهِ
u'عَدَمٌ صَلاَةٌ':Added, #2: 2	عَدَمَ الصَّلَاةِ
u'عَدَمٌ صَلاَةٌ':Added, #4: 4	عَدَمِ الصَّلَاةِ
u'عَدَمٌ صَلاَحٌ':Added, #5: 5	عَدَمُ الصَّلَاةِ
u'عَدَمٌ صَلاَحِيَةٌ':Added, #1: 1	عَدَمُ الصَّلَاحِ
u'عَدَمٌ صَلاَحِيَّةٌ':Added, #1: 1	عَدَمُ صَلَاحِيَةِ
u'عَدَمٌ صَلاَحِيَّةٌ':Added, #1: 1	عَدَمُ صَلَاحِيَّةِ
u'عَدَمٌ صَلاَحِيَةٌ':Added, #1: 1	عَدَمِ صَلَاحِيَّةِ
u'عَدَمٌ صَلاَحِيَّةٌ':Added, #1: 1	عَدَمَ صَلَاحِيَتِهِ
u'عَدَمٌ صَلاَحِيَّةٌ':Added, #1: 1	عَدَمُ صَلَاحِيَّتِهِ
u'عَدَمٌ صلْبٌ':Added, #1: 1	عَدَمِ صَلَاحِيَّتِهِ
u'عَدَّ مُصَنِّفٌ':Subject, #1: 1	عَدَمِ الصُّلْبِ
u'عَدَمٌ صِنْفٌ':Added, #1: 1	عَدَّ الْمُصَنِّفُ
u'عَدَمٌ صَوْمٌ':Added, #1: 1	عَدَمِ الصِّنْفَيْنِ
u'عَدَمٌ صَوْمٌ':Added, #1: 1	عَدَمَ الصَّوْمِ
u'عَدَمٌ صَوْمٌ':Added, #1: 1	عَدَمِ صَوْمِ
u'عَدَمٌ صَوْمٌ':Added, #1: 1	عَدَمَ صَوْمِهِ
u'عَدِمَ صَيْدٌ':Subject, #3: 3	عَدَمِ الصَّوْمِ
u'عَدَمٌ صَيْرُورَة':Added, #1: 1	عَدِمَ الصَّيْدُ
u'عَدَمٌ صَيْرُورَة':Added, #1: 1	عَدَمِ الصَّيْرُورَةِ
u'عَدَمٌ صَيْرُورَة':Added, #1: 1	عَدَمَ صَيْرُورَةِ
u'عَدَمٌ ضَبْطٌ':Added, #1: 1	عَدَمِ صَيْرُورَةِ
u'عَدَمٌ ضَبْطٌ':Added, #1: 1	عَدَمُ الضَّبْطِ
u'عَدَمٌ ضَبْطٌ':Added, #1: 1	عَدَمِ ضَبْطِهِ
u'عَدَمٌ ضِدٌّ':Added, #2: 2	عَدَمِ الضَّبْطِ
u'عَدَمٌ ضِدٌّ':Added, #1: 1	عَدَمَ الضِّدِّ
u'عَدَمٌ ضَرْبٌ':Added, #1: 1	عَدَمُ ضِدِّهِ
u'عَدَمٌ ضَرْبٌ':Added, #1: 1	عَدَمِ الضَّرْبِ
u'عَدَمٌ ضَرَرٌ':Added, #1: 1	عَدَمِ ضَرْبِ
u'عَدَمٌ ضَرَرٌ':Added, #12: 12	عَدَمِ الضَّرَرِ
u'عَدَمٌ ضَرَرٌ':Added, #1: 1	عَدَمَ ضَرَرِ
u'عَدَمٌ ضَرَرٌ':Added, #1: 1	عَدَمِ ضَرَرِ
u'عَدَمٌ ضَرَرٌ':Added, #3: 3	عَدَمَ الضَّرَرِ
u'عَدَمٌ ضَرُورَةٌ':Added, #6: 6	عَدَمُ الضَّرَرِ
u'عَدَمٌ ضَرُورَةٌ':Added, #11: 11	عَدَمِ الضَّرُورَةِ
u'عَدَمٌ ضَمٌّ':Added, #1: 1	عَدَمَ الضَّرُورَةِ
u'عَدَمٌ ضَمٌّ':Added, #1: 1	عَدَمَ ضَمِّ
u'عَدَمٌ ضَمٌّ':Added, #2: 2	عَدَمِ ضَمِّ
u'عَدَمٌ ضَمٌّ':Added, #3: 3	عَدَمُ الضَّمِّ
u'عَدَمٌ ضَمٌّ':Added, #3: 3	عَدَمِ الضَّمِّ
u'عَدَمٌ ضَمَانٌ':Added, #4: 4	عَدَمَ الضَّمِّ
u'عَدَمٌ ضَمَانٌ':Added, #17: 17	عَدَمَ الضَّمَانِ
u'عَدَمٌ ضَمَانٌ':Added, #1: 1	عَدَمَ ضَمَانِ
u'عَدَمٌ ضَمَانٌ':Added, #2: 2	عَدَمَ ضَمَانِهِ
u'عَدَمٌ ضَمَانٌ':Added, #32: 32	عَدَمِ الضَّمَانِ
u'عَدَمٌ ضَمَانٌ':Added, #3: 3	عَدَمُ ضَمَانِهِ
u'عَدَمٌ ضَمَانٌ':Added, #41: 41	عَدَمُ الضَّمَانِ
u'عَدَمٌ ضَمَانٌ':Added, #6: 6	عَدَمُ ضَمَانِ
u'عَدَمٌ ضَمَانٌ':Added, #6: 6	عَدَمِ ضَمَانِهِ
u'عَدَمٌ ضِيقٌ':Added, #8: 8	عَدَمِ ضَمَانِ
u'عَدَمٌ طَاعَةٌ':Added, #1: 1	عَدَمِ الضِّيقِ
u'عَدَمٌ طَاعَةٌ':Added, #1: 1	عَدَمَ طَاعَتِهِ
u'عَدَمٌ طَاقَةٌ':Added, #1: 1	عَدَمِ طَاعَتِهِ
u'عَدَمٌ طَرْقٌ':Added, #1: 1	عَدَمِ الطَّاقَةِ
u'عَدِمَ طَرِيقٌ':Predicate, #1: 1	عَدَمُ طَرْقِ
u'عَدَمٌ طَعْمٌ':Added, #1: 1	عَدِمَ طَرِيقَ
u'عَدَمٌ طُعْمٌ':Added, #1: 1	عَدَمُ الطّعْمِ
u'عَدَمٌ طَعْنٌ':Added, #1: 1	عَدَمُ الطّعْمِ
u'عَدَمٌ طَلاَقٌ':Added, #1: 1	عَدَمِ طَعْنِ
u'عَدَمٌ طَلاَقٌ':Added, #2: 2	عَدَمَ الطَّلَاقِ
u'عَدَمٌ طَلاَقٌ':Added, #5: 5	عَدَمُ الطَّلَاقِ
u'عَدَمٌ طلب':Added, #5: 5	عَدَمِ الطَّلَاقِ
u'عَدَمٌ طَلَبٌ':Added, #1: 1	عَدَمُ طَلَبِ
u'عَدَمٌ طلب':Added, #1: 1	عَدَمُ طَلَبِ
u'عَدَمٌ طلب':Added, #1: 1	عَدَمَ طَلَبِهِ
u'عَدَمٌ طَلَبٌ':Added, #1: 1	عَدَمِ طَلَبِهِ
u'عَدَمٌ طَلَبٌ':Added, #1: 1	عَدَمَ طَلَبِهِ
u'عَدَمٌ طلب':Added, #1: 1	عَدَمِ طَلَبِهِ
u'عَدَمٌ طَلَبٌ':Added, #2: 2	عَدَمِ الطَّلَبِ
u'عَدَمٌ طلب':Added, #2: 2	عَدَمِ الطَّلَبِ
u'عَدَمٌ طَلَبٌ':Added, #4: 4	عَدَمِ طَلَبِ
u'عَدَمٌ طُلُوعٌ':Added, #4: 4	عَدَمِ طَلَبِ
u'عَدَمٌ طُلُوعٌ':Added, #1: 1	عَدَمِ الطُّلُوعِ
u'عَدَمٌ طُلُوعٌ':Added, #1: 1	عَدَمُ طُلُوعِ
u'عَدَمٌ طُمَأْنِينَةٌ':Added, #1: 1	عَدَمِ طُلُوعِ
u'عَدَمٌ طَهَارَةٌ':Added, #1: 1	عَدَمِ الطُّمَأْنِينَةِ
u'عَدَمٌ طَهَارَةٌ':Added, #1: 1	عَدَمَ الطَّهَارَةِ
u'عَدَمٌ طَهَارَةٌ':Added, #1: 1	عَدَمَ طَهَارَةِ
u'عَدَمٌ طَهَارَةٌ':Added, #1: 1	عَدَمُ طَهَارَةِ
u'عَدَمٌ طَهَارَةٌ':Added, #1: 1	عَدَمَ طَهَارَتِهِ
u'عَدَمٌ طَهَارَةٌ':Added, #2: 2	عَدَمِ طَهَارَةِ
u'عَدَمٌ طَهَارَةٌ':Added, #3: 3	عَدَمُ الطَّهَارَةِ
u'عَدِمَ طَهُورٌ':Predicate, #5: 5	عَدَمِ الطَّهَارَةِ
u'عَدَمٌ طَهُورٌ':Added, #1: 1	عَدِمَ الطَّهُورَ
u'عَدَمٌ طَهُور':Added, #1: 1	عَدَمِ طَهُورِ
u'عَدَمٌ طواف':Added, #2: 2	عَدَمُ طَهُورِيَّةِ
u'عَدَمٌ طَوَافٌ':Added, #1: 1	عَدَمُ الطَّوَافِ
u'عَدَمٌ طواف':Added, #1: 1	عَدَمُ الطَّوَافِ
u'عَدَمٌ طَوَافٌ':Added, #1: 1	عَدَمِ طَوَافِ
u'عَدِمَ طَوْلٌ':Predicate, #1: 1	عَدَمِ طَوَافِ
u'عَدَمٌ طَوْلٌ':Added, #1: 1	عَدِمَ الطَّوْلَ
u'عَدَمٌ طُولٌ':Added, #1: 1	عَدَمَ طَوْلِ
u'عَدَمٌ طَوْلٌ':Added, #2: 2	عَدَمِ الطُّولِ
u'عَدَمٌ طَوْلٌ':Added, #2: 2	عَدَمِ طَوْلِ
u'عَدَمٌ طَيٌّ':Added, #5: 5	عَدَمُ الطَّوْلِ
u'عَدَمٌ طَيِّبٌ':Added, #1: 1	عَدَمُ الطَّيِّ
u'عَدَمٌ طِيبٌ':Added, #1: 1	عَدَمِ الطَّيِّبِ
u'عَدَمٌ طِيبٌ':Added, #1: 1	عَدَمَ طِيبِ
u'عَدَمٌ ظاهِرٌ':Added, #1: 1	عَدَمُ طِيبِ
u'عَدَمٌ ظَفَرٌ':Added, #1: 1	عَدَمِ ظَاهِرٍ
u'عَدَمٌ ظُلْمٌ':Added, #2: 2	عَدَمُ الظَّفَرِ
u'عَدَمٌ ظُلْمٌ':Added, #1: 1	عَدَمَ الظُّلْمِ
u'عَدَمٌ ظُلْمٌ':Added, #1: 1	عَدَمُ ظُلْمِ
u'عَدَمٌ ظُلْمٌ':Added, #1: 1	عَدَمُ ظُلْمِهِ
u'عَدَمٌ ظَنٌّ':Added, #1: 1	عَدَمِ ظُلْمِهِ
u'عَدَمٌ ظَنّ':Added, #1: 1	عَدَمُ الظَّنِّ
u'عَدَمٌ ظَنٌّ':Added, #1: 1	عَدَمُ الظَّنِّيَّةِ
u'عَدَمٌ ظَنّ':Added, #1: 1	عَدَمَ ظَنِّهِ
u'عَدَمٌ ظَنٌّ':Added, #1: 1	عَدَمِ ظَنِّيَّةِ
u'عَدَمٌ ظَنٌّ':Added, #2: 2	عَدَمَ ظَنِّ
u'عَدَمٌ ظَنِّيّ':Added, #2: 2	عَدَمِ ظَنِّ
u'عَدَمٌ ظَنِّيّ':Added, #1: 1	عَدَمُ الظَّنِّيَّةِ
u'عَدَمٌ ظُهورٌ':Added, #1: 1	عَدَمِ ظَنِّيَّةِ
u'عَدَمٌ ظُهورٌ':Added, #13: 13	عَدَمِ ظُهُورِ
u'عَدَمٌ ظُهورٌ':Added, #1: 1	عَدَمُ ظُهُورِهِ
u'عَدَمٌ ظُهورٌ':Added, #2: 2	عَدَمَ ظُهُورِ
u'عَدَمٌ ظُهورٌ':Added, #2: 2	عَدَمِ ظُهُورِهِ
u'عَدَمٌ ظُهورٌ':Added, #4: 4	عَدَمِ الظُّهُورِ
u'عَدَمٌ عَارِضٌ':Added, #7: 7	عَدَمُ ظُهُورِ
u'عَدَمٌ عَارِضٌ':Added, #1: 1	عَدَمَ الْعَارِضِ
u'عَدَمٌ عَارِضٌ':Added, #1: 1	عَدَمُ الْعَارِضِ
u'عَدَمٌ عَاقِدٌ':Added, #2: 2	عَدَمِ الْعَارِضِ
u'عَدَمٌ عَبَثٌ':Added, #2: 2	عَدَمَ الْعَاقِدِ
u'عَدَمٌ عتق':Added, #1: 1	عَدَمَ الْعَبَثِ
u'عَدَمٌ عِتْقٌ':Added, #12: 12	عَدَمُ الْعِتْقِ
u'عَدَمٌ عتق':Added, #12: 12	عَدَمُ الْعِتْقِ
u'عَدَمٌ عتق':Added, #1: 1	عَدَم عِتْقِ
u'عَدَمٌ عِتْقٌ':Added, #1: 1	عَدَمُ عِتْقِ
u'عَدَمٌ عِتْقٌ':Added, #1: 1	عَدَم عِتْقِ
u'عَدَمٌ عتق':Added, #1: 1	عَدَمُ عِتْقِ
u'عَدَمٌ عتق':Added, #1: 1	عَدَمَ عِتْقِهِ
u'عَدَمٌ عِتْقٌ':Added, #1: 1	عَدَمُ عِتْقِهِ
u'عَدَمٌ عِتْقٌ':Added, #1: 1	عَدَمَ عِتْقِهِ
u'عَدَمٌ عتق':Added, #1: 1	عَدَمُ عِتْقِهِ
u'عَدَمٌ عتق':Added, #2: 2	عَدَمَ الْعِتْقِ
u'عَدَمٌ عِتْقٌ':Added, #2: 2	عَدَمِ الْعِتْقِ
u'عَدَمٌ عِتْقٌ':Added, #2: 2	عَدَمَ الْعِتْقِ
u'عَدَمٌ عتق':Added, #2: 2	عَدَمِ الْعِتْقِ
u'عَدَمٌ عِتْقٌ':Added, #2: 2	عَدَمِ عِتْقِهِ
u'عَدَمٌ عتق':Added, #2: 2	عَدَمِ عِتْقِهِ
u'عَدَمٌ عِتْقٌ':Added, #4: 4	عَدَمِ عِتْقِ
u'عَدَمٌ عُثُور':Added, #4: 4	عَدَمِ عِتْقِ
u'عَدَمٌ عجز':Added, #1: 1	عَدَمُ الْعُثُورِ
u'عَدَمٌ عَجْزٌ':Added, #1: 1	عَدَمِ الْعَجْزِ
u'عَدَمٌ عَدٌّ':Added, #1: 1	عَدَمِ الْعَجْزِ
u'عَدَمٌ عَدٌّ':Added, #1: 1	عَدَمُ عَدِّ
u'عَدَمٌ عَدَالَةٌ':Added, #2: 2	عَدَمِ عَدِّهِ
u'عَدَمٌ عَدَاوَةٌ':Added, #4: 4	عَدَمُ الْعَدَالَةِ
u'عَدَمٌ عَدَاوَةٌ':Added, #1: 1	عَدَمُ عَدَاوَةٍ
u'عَدَمٌ عَدَاوَةٌ':Added, #2: 2	عَدَمُ الْعَدَاوَةِ
u'عَدَمٌ عِدَّةٌ':Added, #3: 3	عَدَمِ الْعَدَاوَةِ
u'عَدَمٌ عِدَّةٌ':Added, #1: 1	عَدَمَ الْعِدَّةِ
u'عَدَمٌ عَدْلٌ':Added, #1: 1	عَدَمِ الْعِدَّةِ
u'عَدَمٌ عَدْلٌ':Added, #2: 2	عَدَمِ الْعَدْلِ
u'عَدَمٌ عَدَمٌ':Added, #3: 3	عَدَمَ الْعَدْلِ
u'عَدَمٌ عَدَمٌ':Added, #1: 1	عَدَمِ الْعَدَمِ
u'عَدَمٌ عُدُولٌ':Added, #1: 1	عَدَمَ عَدَمِهِ
u'عَدَمٌ عُذْرٌ':Added, #2: 2	عَدَمُ الْعُدُولِ
u'عَدَمٌ عُذْرٌ':Added, #15: 15	عَدَمِ الْعُذْرِ
u'عَدَمٌ عُذْرٌ':Added, #1: 1	عَدَمِ عُذْرِ
u'عَدَمٌ عرف':Added, #2: 2	عَدَمُ الْعُذْرِ
u'عَدَمٌ عرف':Added, #1: 1	عَدَمَ الْعُرْفِ
u'عَدَمٌ عُرْفٌ':Added, #1: 1	عَدَمِ الْعُرْفِ
u'عَدَمٌ عُرْفٌ':Added, #1: 1	عَدَمَ الْعُرْفِ
u'عَدَمٌ عُرُوضٌ':Added, #1: 1	عَدَمِ الْعُرْفِ
u'عَدَمٌ عزل':Added, #1: 1	عَدَمُ عُرُوضِهِ
u'عَدَمٌ عزل':Added, #1: 1	عَدَمَ الْعَزْلِ
u'عَدَمٌ عزل':Added, #1: 1	عَدَمُ الْعَزْلِ
u'عَدِمَ عصبة':Predicate, #3: 3	عَدَمِ عَزْلِهِ
u'عَدِمَ عَصَبَةٌ':Predicate, #1: 1	عَدِمَ عَصَبَةَ
u'عَدَمٌ عصبة':Added, #1: 1	عَدِمَ عَصَبَةَ
u'عَدَمٌ عَصَبَةٌ':Added, #1: 1	عَدَمِ عَصَبَةِ
u'عَدَمٌ عصبة':Added, #1: 1	عَدَمِ عَصَبَةِ
u'عَدَمٌ عَصَبَةٌ':Added, #2: 2	عَدَمِ عَصَبَةٍ
u'عَدَمٌ عصبة':Added, #2: 2	عَدَمِ عَصَبَةٍ
u'عَدَمٌ عَصَبَةٌ':Added, #6: 6	عَدَمِ الْعَصَبَةِ
u'عَدَمٌ عَصَبَةٌ':Added, #6: 6	عَدَمِ الْعَصَبَةِ
u'عَدَمٌ عِصْمَةٌ':Added, #8: 8	عَدَمِ الْعَصَبَاتِ
u'عَدَمٌ عِصْمَةٌ':Added, #1: 1	عَدَمُ الْعِصْمَةِ
u'عَدَمٌ عِصْيَانٌ':Added, #1: 1	عَدَمِ الْعِصْمَةِ
u'عَدَمٌ عِصْيَانٌ':Added, #1: 1	عَدَمِ عِصْيَانِ
u'عَدَمٌ عِصْيَانٌ':Added, #1: 1	عَدَمُ عِصْيَانِهِ
u'عَدَمٌ عِصْيَانٌ':Added, #2: 2	عَدَمَ الْعِصْيَانِ
u'عَدَمٌ عطف':Added, #3: 3	عَدَمِ عِصْيَانِهِ
u'عَدَمٌ عَطْفٌ':Added, #1: 1	عَدَمَ الْعَطْفِ
u'عَدَمٌ عطف':Added, #1: 1	عَدَمَ الْعَطْفِ
u'عَدَمٌ عَطْفٌ':Added, #1: 1	عَدَمِ عَطْفِ
u'عَدَمٌ عَظَمَةٌ':Added, #1: 1	عَدَمِ عَطْفِ
u'عَدَمٌ عِفَّةٌ':Added, #1: 1	عَدَمِ الْعَظَمَةِ
u'عَدَمٌ عَفْوٌ':Added, #1: 1	عَدَمُ الْعِفَّةِ
u'عَدَمٌ عَفْوٌ':Added, #1: 1	عَدَمَ الْعَفْوِ
u'عَدَمٌ عَفْوٌ':Added, #4: 4	عَدَمِ الْعَفْوِ
u'عَدَمٌ عقاب':Added, #6: 6	عَدَمُ الْعَفْوِ
u'عَدَمٌ عِقَابٌ':Added, #1: 1	عَدَمِ الْعِقَابِ
u'عَدِمَ عَقْلٌ':Predicate, #1: 1	عَدَمِ الْعِقَابِ
u'عَدَمٌ عَقْلٌ':Added, #1: 1	عَدِمَ الْعَقْلَ
u'عَدَمٌ عَقْلٌ':Added, #1: 1	عَدَمُ عَقْلِهِ
u'عَدَمٌ عَقْلٌ':Added, #3: 3	عَدَمُ الْعَقْلِ
u'عَدَمٌ عَكْسٌ':Added, #4: 4	عَدَمِ الْعَقْلِ
u'عَدَمٌ عَكْسٌ':Added, #1: 1	عَدَمَ عَكْسِ
u'عَدَمٌ عَكْسٌ':Added, #2: 2	عَدَمُ الْعَكْسِ
u'عَدَمٌ عِلَّةٌ':Added, #2: 2	عَدَمِ الْعَكْسِ
u'عَدَمٌ عِلَّةٌ':Added, #12: 12	عَدَمِ الْعِلَّةِ
u'عَدَمٌ عِلَّةٌ':Added, #1: 1	عَدَمَ عِلَّةٍ
u'عَدَمٌ عِلَّةٌ':Added, #1: 1	عَدَمُ عِلَّةِ
u'عَدَمٌ عِلَّةٌ':Added, #2: 2	عَدَمِ عِلَّةٍ
u'عَدَمٌ عِلَّةٌ':Added, #3: 3	عَدَمَ الْعِلَّةِ
u'عَدَمٌ علم':Added, #3: 3	عَدَمُ الْعِلَّةِ
u'عَدَمٌ عِلْمٌ':Added, #10: 10	عَدَمَ الْعِلْمِ
u'عَدَمٌ علم':Added, #10: 10	عَدَمَ الْعِلْمِ
u'عَدَمٌ عِلْمٌ':Added, #12: 12	عَدَمِ عِلْمِهِ
u'عَدَمٌ علم':Added, #12: 12	عَدَمِ عِلْمِهِ
u'عَدَمٌ عِلْمٌ':Added, #1: 1	عَدَمَ عِلْمِ
u'عَدَمٌ علم':Added, #1: 1	عَدَمَ عِلْمِ
u'عَدَمٌ عِلْمٌ':Added, #26: 26	عَدَمُ الْعِلْمِ
u'عَدَمٌ علم':Added, #26: 26	عَدَمُ الْعِلْمِ
u'عَدَمٌ عِلْمٌ':Added, #4: 4	عَدَمِ عِلْمِ
u'عَدَمٌ علم':Added, #4: 4	عَدَمِ عِلْمِ
u'عَدَمٌ عِلْمٌ':Added, #50: 50	عَدَمِ الْعِلْمِ
u'عَدَمٌ علم':Added, #50: 50	عَدَمِ الْعِلْمِ
u'عَدَمٌ عِلْمٌ':Added, #5: 5	عَدَمُ عِلْمِ
u'عَدَمٌ علم':Added, #5: 5	عَدَمُ عِلْمِ
u'عَدَمٌ عِلْمٌ':Added, #7: 7	عَدَمَ عِلْمِهِ
u'عَدَمٌ علم':Added, #7: 7	عَدَمَ عِلْمِهِ
u'عَدَمٌ عِلْمٌ':Added, #8: 8	عَدَمُ عِلْمِهِ
u'عَدَمٌ عِلِّيٌّ':Added, #8: 8	عَدَمُ عِلْمِهِ
u'عَدَمٌ عِلِّيٌّ':Added, #1: 1	عَدَمَ عِلِّيَّتِهِ
u'عَدَمٌ عِلِّيٌّ':Added, #1: 1	عَدَمِ عِلِّيَّتِهِ
u'عَدَمٌ عِلِّيٌّ':Added, #2: 2	عَدَمُ الْعِلِّيَّةِ
u'عَدَمٌ عِلِّيٌّ':Added, #3: 3	عَدَمِ الْعِلِّيَّةِ
u'عَدَمٌ عِلِّيٌّ':Added, #3: 3	عَدَمُ عِلِّيَّةِ
u'عَدَمٌ عِمَارَةٌ':Added, #3: 3	عَدَمِ عِلِّيَّةِ
u'عَدَمٌ عَمْدٌ':Added, #1: 1	عَدَمَ عِمَارَتِهِ
u'عَدَمٌ عَمْد':Added, #1: 1	عَدَمُ الْعَمْدِ
u'عَدَمٌ عَمْدِيّ':Added, #3: 3	عَدَمِ الْعَمْدِيَّةِ
u'عَدَمٌ عُمْقٌ':Added, #3: 3	عَدَمِ الْعَمْدِيَّةِ
u'عَدَمٌ عَمَلٌ':Added, #1: 1	عَدَمُ عُمْقِهِ
u'عَدَمٌ عَمَلٌ':Added, #10: 10	عَدَمِ الْعَمَلِ
u'عَدَمٌ عَمَلٌ':Added, #1: 1	عَدَمَ عَمَلِ
u'عَدَمٌ عَمَلٌ':Added, #3: 3	عَدَمَ الْعَمَلِ
u'عَدَمٌ عُمُومٌ':Added, #6: 6	عَدَمُ الْعَمَلِ
u'عَدَمٌ عُمُومٌ':Added, #1: 1	عَدَمُ عُمُومِ
u'عَدَمٌ عُمُومٌ':Added, #1: 1	عَدَمَ عُمُومِهِ
u'عَدَمٌ عُمُومٌ':Added, #2: 2	عَدَمَ الْعُمُومِ
u'عَدَمٌ عُمُومٌ':Added, #2: 2	عَدَمِ عُمُومِهِ
u'عَدَمٌ عُمُومٌ':Added, #3: 3	عَدَمِ الْعُمُومِ
u'عَدَمٌ عناد':Added, #3: 3	عَدَمِ عُمُومِ
u'عَدَمٌ عِنَادٌ':Added, #1: 1	عَدَمَ الْعِنَادِ
u'عَدَمٌ عَهْدٌ':Added, #1: 1	عَدَمَ الْعِنَادِ
u'عَدَمٌ عَهْدٌ':Added, #1: 1	عَدَمَ الْعَهْدِ
u'عَدَمٌ عَوْدٌ':Added, #2: 2	عَدَمِ الْعَهْدِ
u'عَدَمٌ عَوْدٌ':Added, #16: 16	عَدَمِ الْعَوْدِ
u'عَدَمٌ عَوْدٌ':Added, #1: 1	عَدَمَ عَوْدِ
u'عَدَمٌ عُودٌ':Added, #1: 1	عَدَمُ عَوْدٍ
u'عَدَمٌ عَوْدٌ':Added, #2: 2	عَدَمِ الْعُودِ
u'عَدَمٌ عَوْدٌ':Added, #4: 4	عَدَمُ عَوْدِ
u'عَدَمٌ عَوْدٌ':Added, #4: 4	عَدَمَ عَوْدِهِ
u'عَدَمٌ عَوْدٌ':Added, #5: 5	عَدَمَ الْعَوْدِ
u'عَدَمٌ عَوْدٌ':Added, #6: 6	عَدَمِ عَوْدِهِ
u'عَدَمٌ عَوْدٌ':Added, #7: 7	عَدَمُ الْعَوْدِ
u'عَدَمٌ عَوْدٌ':Added, #8: 8	عَدَمُ عَوْدِهِ
u'عَدَمٌ عَوْدَةٌ':Added, #9: 9	عَدَمِ عَوْدِ
u'عَدَمٌ عِوَضٌ':Added, #1: 1	عَدَمُ عَوْدَةٍ
u'عَدَمٌ عِوَضٌ':Added, #1: 1	عَدَمُ الْعِوَضِ
u'عَدَمٌ عَوْل':Added, #5: 5	عَدَمَ الْعِوَضِ
u'عَدَمٌ عَيْبٌ':Added, #1: 1	عَدَمِ الْعَوْلِ
u'عَدَمٌ عَيْبٌ':Added, #1: 1	عَدَمِ عَيْبٍ
u'عَدَمٌ غاسِل':Added, #3: 3	عَدَمُ الْعَيْبِ
u'عَدَمٌ غَاصِبٌ':Added, #1: 1	عَدَمِ غَاسِلٍ
u'عَدِمَ غِذَاءٌ':Predicate, #2: 2	عَدَمِ الْغَاصِبِ
u'عَدَمٌ غِذَاءٌ':Added, #1: 1	عَدِمَ الْغِذَاءَ
u'عَدَمٌ غُرَّةٌ':Added, #2: 2	عَدَمِ الْغِذَاءِ
u'عَدَمٌ غَرَضٌ':Added, #1: 1	عَدَمِ الْغُرَّةِ
u'عَدَمٌ غَرْغَرَةٌ':Added, #1: 1	عَدَمِ غَرَضِ
u'عَدَمٌ غَرْغَرَةٌ':Added, #1: 1	عَدَمُ الْغَرْغَرَةِ
u'عَدَمٌ غُرْمٌ':Added, #1: 1	عَدَمِ الْغَرْغَرَةِ
u'عَدَمٌ غُرْمٌ':Added, #1: 1	عَدَمَ الْغُرْمِ
u'عَدَمٌ غُرْمٌ':Added, #1: 1	عَدَمُ غُرْمِهِ
u'عَدَمٌ غُرُوبٌ':Added, #2: 2	عَدَمُ الْغُرْمِ
u'عَدَمٌ غُرُورٌ':Added, #1: 1	عَدَمُ الْغُرُوبِ
u'عَدَمٌ غَرِيمٌ':Added, #1: 1	عَدَمُ الْغُرُورِ
u'عَدَمٌ غَسْلٌ':Added, #3: 3	عَدَمِ الْغَرِيمِ
u'عَدَمٌ غُسْلٌ':Added, #1: 1	عَدَمَ الْغَسْلِ
u'عَدَمٌ غُسْلٌ':Added, #1: 1	عَدَمَ الْغُسْلِ
u'عَدَمٌ غَسْلٌ':Added, #1: 1	عَدَمِ الْغُسْلِ
u'عَدَمٌ غَسْلٌ':Added, #1: 1	عَدَمَ غَسْلِ
u'عَدَمٌ غَسْلٌ':Added, #1: 1	عَدَمُ غَسْلِ
u'عَدَمٌ غُسْلٌ':Added, #1: 1	عَدَمِ غَسْلِ
u'عَدَمٌ غَسْلٌ':Added, #1: 1	عَدَمِ غُسْلِهِ
u'عَدَمٌ غُسْلٌ':Added, #2: 2	عَدَمِ الْغَسْلِ
u'عَدَمٌ غَصْبٌ':Added, #2: 2	عَدَمُ الْغُسْلِ
u'عَدَمٌ غَصْبٌ':Added, #1: 1	عَدَمُ غَصْبِ
u'عَدَمٌ غَصْبٌ':Added, #1: 1	عَدَمُ غَصْبِهِ
u'عَدَمٌ غضب':Added, #2: 2	عَدَمُ الْغَصْبِ
u'عَدَمٌ غضب':Added, #2: 2	عَدَمُ الْغَضَبِ
u'عَدَمٌ غَضَبٌ':Added, #2: 2	عَدَمِ الْغَضَبِ
u'عَدَمٌ غَضَبٌ':Added, #2: 2	عَدَمُ الْغَضَبِ
u'عَدَمٌ غُفْرَانٌ':Added, #2: 2	عَدَمِ الْغَضَبِ
u'عَدَمٌ غَلَبَةٌ':Added, #1: 1	عَدَمِ غُفْرَانِ
u'عَدَمٌ غَلَبَةٌ':Added, #1: 1	عَدَمِ الْغَلَبَةِ
u'عَدَمٌ غَلَبَةٌ':Added, #3: 3	عَدَمُ غَلَبَةِ
u'عَدَمٌ غَلَّةٌ':Added, #3: 3	عَدَمِ غَلَبَةِ
u'عَدَمٌ غَلَطٌ':Added, #1: 1	عَدَمُ الْغَلَّةِ
u'عَدَمٌ غِيبَةٌ':Added, #1: 1	عَدَم الْغَلَطِ
u'عَدَمٌ غَيْبَةٌ':Added, #1: 1	عَدَمُ الْغِيبَةِ
u'عَدَمٌ غير':Added, #1: 1	عَدَمُ غَيْبَتِهِ
u'عَدَمٌ غَيْرٌ':Added, #11: 11	عَدَمِ غَيْرِهِ
u'عَدَمٌ غير':Added, #11: 11	عَدَمِ غَيْرِهِ
u'عَدَمٌ غَيْرٌ':Added, #1: 1	عَدَمُ الْغَيْرِ
u'عَدَمٌ غير':Added, #1: 1	عَدَمُ الْغَيْرِ
u'عَدَمٌ غَيْرٌ':Added, #1: 1	عَدَمُ غَيْرِ
u'عَدَمٌ غير':Added, #1: 1	عَدَمُ غَيْرِ
u'عَدَمٌ غَيْرٌ':Added, #4: 4	عَدَمُ غَيْرِهِ
u'عَدَمٌ فاء':Added, #4: 4	عَدَمُ غَيْرِهِ
u'عَدَمٌ فَارِقٌ':Added, #2: 2	عَدَمِ الْفَاءِ
u'عَدَمٌ فَارِقٌ':Added, #1: 1	عَدَمُ الْفَارِقِ
u'عَدَمٌ فَاصِلٌ':Added, #1: 1	عَدَمِ الْفَارِقِ
u'عَدَمٌ فَائِدَةٌ':Added, #1: 1	عَدَمِ الْفَاصِلِ
u'عَدَمٌ فَائِدَةٌ':Added, #1: 1	عَدَمُ فَائِدَةِ
u'عَدَمٌ فَائِدَةٌ':Added, #1: 1	عَدَمِ فَائِدَةٍ
u'عَدَمٌ فَائِدَةٌ':Added, #3: 3	عَدَمَ الْفَائِدَةِ
u'عَدَمٌ فَائِدَةٌ':Added, #5: 5	عَدَمُ الْفَائِدَةِ
u'عَدَمٌ فتنة':Added, #6: 6	عَدَمِ الْفَائِدَةِ
u'عَدَمٌ فِتْنَةٌ':Added, #1: 1	عَدَمِ الْفِتْنَةِ
u'عَدَمٌ فَجْرٌ':Added, #1: 1	عَدَمِ الْفِتْنَةِ
u'عَدَمٌ فُحْشٌ':Added, #1: 1	عَدَمِ الْفَجْرِ
u'عَدَمٌ فِدَاءٌ':Added, #1: 1	عَدَمِ فُحْشِ
u'عَدَمٌ فِدْيَةٌ':Added, #1: 1	عَدَمِ الْفِدَاءِ
u'عَدَمٌ فرار':Added, #1: 1	عَدَمَ الْفِدْيَةِ
u'عَدَمٌ فِرَارٌ':Added, #1: 1	عَدَمِ فِرَارٍ
u'عَدَمٌ فراغ':Added, #1: 1	عَدَمِ فِرَارٍ
u'عَدَمٌ فَرَاغٌ':Added, #1: 1	عَدَمُ فَرَاغِ
u'عَدَمٌ فَرْضٌ':Added, #1: 1	عَدَمُ فَرَاغِ
u'عَدَمٌ فَرْضٌ':Added, #1: 1	عَدَمِ الْفَرْضِ
u'عَدَمٌ فَرْضٌ':Added, #1: 1	عَدَمِ الْفَرْضَيْنِ
u'عَدَمٌ فَرْضٌ':Added, #1: 1	عَدَمُ فَرْضِ
u'عَدَمٌ فَرْض':Added, #1: 1	عَدَمِ فَرْضِهِ
u'عَدَمٌ فَرْض':Added, #2: 2	عَدَمَ الْفَرْضِيَّةِ
u'عَدَمٌ فَرْضِيّ':Added, #4: 4	عَدَمِ الْفَرْضِيَّةِ
u'عَدَمٌ فَرْضِيّ':Added, #2: 2	عَدَمَ الْفَرْضِيَّةِ
u'عَدَمٌ فَرْضِيَّة':Added, #4: 4	عَدَمِ الْفَرْضِيَّةِ
u'عَدَمٌ فَرْضِيَّة':Added, #2: 2	عَدَمَ الْفَرْضِيَّةِ
u'عَدَمٌ فَرْعٌ':Added, #4: 4	عَدَمِ الْفَرْضِيَّةِ
u'عَدَمٌ فرق':Added, #2: 2	عَدَمِ الْفَرْعِ
u'عَدَمٌ فَرْقٌ':Added, #14: 14	عَدَمَ الْفَرْقِ
u'عَدَمٌ فرق':Added, #14: 14	عَدَمَ الْفَرْقِ
u'عَدَمٌ فَرْقٌ':Added, #27: 27	عَدَمِ الْفَرْقِ
u'عَدَمٌ فرق':Added, #27: 27	عَدَمِ الْفَرْقِ
u'عَدَمٌ فَرْقٌ':Added, #39: 39	عَدَمُ الْفَرْقِ
u'عَدَمٌ فُرْقَةٌ':Added, #39: 39	عَدَمُ الْفَرْقِ
u'عَدَمٌ فُرُوعٌ':Added, #1: 1	عَدَمُ الْفُرْقَةِ
u'عَدَمٌ فَرِيضَةٌ':Added, #1: 1	عَدَمِ الْفُرُوعِ
u'عَدِمَ فساد':Subject, #1: 1	عَدَمِ فَرِيضَةِ
u'عَدِمَ فَسَادٌ':Subject, #1: 1	عَدِمَ الْفَسَادُ
u'عَدَمٌ فساد':Added, #1: 1	عَدِمَ الْفَسَادُ
u'عَدَمٌ فَسَادٌ':Added, #12: 12	عَدَمَ الْفَسَادِ
u'عَدَمٌ فساد':Added, #12: 12	عَدَمَ الْفَسَادِ
u'عَدَمٌ فَسَادٌ':Added, #14: 14	عَدَمُ الْفَسَادِ
u'عَدَمٌ فساد':Added, #14: 14	عَدَمُ الْفَسَادِ
u'عَدَمٌ فَسَادٌ':Added, #21: 21	عَدَمِ الْفَسَادِ
u'عَدَمٌ فساد':Added, #21: 21	عَدَمِ الْفَسَادِ
u'عَدَمٌ فَسَادٌ':Added, #2: 2	عَدَمُ فَسَادِهِ
u'عَدَمٌ فساد':Added, #2: 2	عَدَمُ فَسَادِهِ
u'عَدَمٌ فَسَادٌ':Added, #3: 3	عَدَمِ فَسَادِ
u'عَدَمٌ فساد':Added, #3: 3	عَدَمِ فَسَادِ
u'عَدَمٌ فَسَادٌ':Added, #6: 6	عَدَمُ فَسَادِ
u'عَدَمٌ فَسْخٌ':Added, #6: 6	عَدَمُ فَسَادِ
u'عَدَمٌ فَسْخٌ':Added, #1: 1	عَدَمِ فَسْخِ
u'عَدَمٌ فَسْخٌ':Added, #1: 1	عَدَمِ فَسْخِهِ
u'عَدَمٌ فَسْخٌ':Added, #2: 2	عَدَمَ الْفَسْخِ
u'عَدَمٌ فَسْخٌ':Added, #4: 4	عَدَمِ الْفَسْخِ
u'عَدَمٌ فِسْقٌ':Added, #5: 5	عَدَمُ الْفَسْخِ
u'عَدَمٌ فِسْقٌ':Added, #1: 1	عَدَمُ فِسْقِهِ
u'عَدَمٌ فِسْقٌ':Added, #2: 2	عَدَمِ الْفِسْقِ
u'عَدَمٌ فِسْقٌ':Added, #2: 2	عَدَمِ فِسْقِ
u'عَدَمٌ فَصَاحَةٌ':Added, #5: 5	عَدَمُ الْفِسْقِ
u'عَدَمٌ فَصَاحَةٌ':Added, #1: 1	عَدَمُ الْفَصَاحَةِ
u'عَدَمٌ فَصْلٌ':Added, #1: 1	عَدَمِ الْفَصَاحَةِ
u'عَدَمٌ فَصْلٌ':Added, #1: 1	عَدَمُ فَصْلِهِ
u'عَدَمٌ فَصْلٌ':Added, #1: 1	عَدَمِ فَصْلِهِ
u'عَدَمٌ فَصْلٌ':Added, #3: 3	عَدَمُ الْفَصْلِ
u'عَدَمٌ فِطْرٌ':Added, #3: 3	عَدَمِ الْفَصْلِ
u'عَدَمٌ فِطْرٌ':Added, #2: 2	عَدَمَ الْفِطْرِ
u'عَدَمٌ فِطْرٌ':Added, #2: 2	عَدَمُ الْفِطْرِ
u'عَدَمٌ فطرة':Added, #5: 5	عَدَمِ الْفِطْرِ
u'عَدَمٌ فِطْرَةٌ':Added, #1: 1	عَدَمَ الْفِطْرَةِ
u'عَدَمٌ فِعْلٌ':Added, #1: 1	عَدَمَ الْفِطْرَةِ
u'عَدَمٌ فِعْلٌ':Added, #13: 13	عَدَمُ الْفِعْلِ
u'عَدَمٌ فِعْلٌ':Added, #1: 1	عَدَمِ فِعْلٍ
u'عَدَمٌ فِعْلٌ':Added, #1: 1	عَدَمِ فِعْلِهِ
u'عَدَمٌ فِعْلٌ':Added, #2: 2	عَدَمَ الْفِعْلِ
u'عَدَمٌ فِعْلٌ':Added, #2: 2	عَدَمُ فِعْلِهِ
u'عَدَمٌ فِعْلٌ':Added, #4: 4	عَدَمُ فِعْلِ
u'عَدَمٌ فِعْلٌ':Added, #5: 5	عَدَمِ فِعْلِ
u'عَدِمَ فقهاء':Subject, #7: 7	عَدَمِ الْفِعْلِ
u'عَدِمَ فلان':Predicate, #1: 1	عَدِمَ الْفُقَهَاءُ
u'عَدَمٌ فَهْمٌ':Added, #1: 1	عَدِمَ الْجُبْرَانَ
u'عَدَمٌ فَهْمٌ':Added, #1: 1	عَدَمُ فَهْمٍ
u'عَدَمٌ فَهْمٌ':Added, #1: 1	عَدَمِ فَهْمٍ
u'عَدَمٌ فَهْمٌ':Added, #1: 1	عَدَمُ فَهْمهِ
u'عَدَمٌ فَهْمٌ':Added, #1: 1	عَدَمَ فَهْمِهِ
u'عَدَمٌ فَهْمٌ':Added, #1: 1	عَدَمُ فَهْمِهِ
u'عَدَمٌ فَهْمٌ':Added, #2: 2	عَدَمُ الْفَهْمِ
u'عَدَمٌ فَهْمٌ':Added, #3: 3	عَدَمِ فَهْمِهِ
u'عَدَمٌ فَهْمٌ':Added, #4: 4	عَدَمِ الْفَهْمِ
u'عَدَمٌ فَهْمٌ':Added, #4: 4	عَدَمُ فَهْمِ
u'عَدَمٌ فَوَاتٌ':Added, #8: 8	عَدَمِ فَهْمِ
u'عَدَمٌ فَوَاتٌ':Added, #2: 2	عَدَمُ فَوَاتِ
u'عَدَمٌ فَوْرٌ':Added, #4: 4	عَدَمِ فَوَاتِ
u'عَدَمٌ فَوْر':Added, #1: 1	عَدَمِ الْفَوْرِ
u'عَدَمٌ فَوْرَة':Added, #1: 1	عَدَمَ الْفَوْرِيَّةِ
u'عَدَمٌ فَوْرِيّ':Added, #1: 1	عَدَمَ الْفَوْرِيَّةِ
u'عَدَمٌ فَيْئَةٌ':Added, #1: 1	عَدَمَ الْفَوْرِيَّةِ
u'عَدَمٌ قَابِلِيَّةٌ':Added, #1: 1	عَدَمِ الْفَيْئَةِ
u'عَدِمَ قَاعِدٌ':Predicate, #1: 1	عَدَمِ قَابِلِيَّةِ
u'عَدَمٌ قاف':Added, #1: 1	عَدِمَ قَاعِدَةً
u'عَدِمَ قَالٌ':Predicate, #1: 1	عَدَمِ الْقَافَةِ
u'عَدَمٌ قَائِدٌ':Added, #1: 1	أَعْدَمَ قَالَ
u'عَدَمٌ قَبْضٌ':Added, #3: 3	عَدَمِ الْقَائِدِ
u'عَدَمٌ قَبْضٌ':Added, #12: 12	عَدَمِ الْقَبْضِ
u'عَدَمٌ قَبْضٌ':Added, #1: 1	عَدَم الْقَبْضِ
u'عَدَمٌ قَبْضٌ':Added, #1: 1	عَدَمَ الْقَبْضِ
u'عَدَمٌ قَبْضٌ':Added, #1: 1	عَدَمَ قَبْضِ
u'عَدَمٌ قَبْضٌ':Added, #2: 2	عَدَمِ قَبْضِ
u'عَدَمٌ قَبْضٌ':Added, #2: 2	عَدَمُ قَبْضِهِ
u'عَدَمٌ قَبْضٌ':Added, #2: 2	عَدَمِ قَبْضِهِ
u'عَدَمٌ قَبْضٌ':Added, #3: 3	عَدَمُ قَبْضِ
u'عَدَمٌ قَبُولٌ':Added, #7: 7	عَدَمُ الْقَبْضِ
u'عَدَمٌ قَبُولٌ':Added, #14: 14	عَدَمَ قَبُولِ
u'عَدَمٌ قَبُولٌ':Added, #1: 1	عَدَم قَبُولِ
u'عَدَمٌ قَبُولٌ':Added, #20: 20	عَدَمُ قَبُولِ
u'عَدَمٌ قَبُولٌ':Added, #21: 21	عَدَمَ الْقَبُولِ
u'عَدَمٌ قَبُولٌ':Added, #23: 23	عَدَمِ الْقَبُولِ
u'عَدَمٌ قَبُولٌ':Added, #27: 27	عَدَمُ الْقَبُولِ
u'عَدَمٌ قَبُولٌ':Added, #36: 36	عَدَمِ قَبُولِ
u'عَدَمٌ قَبُولٌ':Added, #3: 3	عَدَمَ قَبُولِهِ
u'عَدَمٌ قَبُولٌ':Added, #6: 6	عَدَمِ قَبُولِهِ
u'عَدَمٌ قتل':Added, #7: 7	عَدَمُ قَبُولِهِ
u'عَدَمٌ قتل':Added, #1: 1	عَدَمُ الْقَتْلِ
u'عَدَمٌ قَتْلٌ':Added, #1: 1	عَدَمِ الْقَتْلِ
u'عَدَمٌ قَتْلٌ':Added, #1: 1	عَدَمُ الْقَتْلِ
u'عَدَمٌ قتل':Added, #1: 1	عَدَمِ الْقَتْلِ
u'عَدَمٌ قَتْلٌ':Added, #1: 1	عَدَمُ قَتْلِ
u'عَدَمٌ قتل':Added, #1: 1	عَدَمُ قَتْلِ
u'عَدَمٌ قتل':Added, #1: 1	عَدَمَ قَتْلِهِ
u'عَدَمٌ قَتْلٌ':Added, #1: 1	عَدَمِ قَتْلِهِ
u'عَدَمٌ قَتْلٌ':Added, #1: 1	عَدَمَ قَتْلِهِ
u'عَدَمٌ قتل':Added, #1: 1	عَدَمِ قَتْلِهِ
u'عَدَمٌ قَتْلٌ':Added, #2: 2	عَدَمَ قَتْلِ
u'عَدَمٌ قتل':Added, #2: 2	عَدَمَ قَتْلِ
u'عَدَمٌ قَتْلٌ':Added, #3: 3	عَدَمُ قَتْلِهِ
u'عَدَمٌ قتل':Added, #3: 3	عَدَمُ قَتْلِهِ
u'عَدَمٌ قَتْلٌ':Added, #7: 7	عَدَمِ قَتْلِ
u'عَدَمٌ قَدْرٌ':Added, #7: 7	عَدَمِ قَتْلِ
u'عَدَمٌ قدرة':Added, #1: 1	عَدَمُ الْقَدْرِ
u'عَدَمٌ قُدْرَةٌ':Added, #11: 11	عَدَمَ الْقُدْرَةِ
u'عَدَمٌ قدرة':Added, #11: 11	عَدَمَ الْقُدْرَةِ
u'عَدَمٌ قُدْرَةٌ':Added, #12: 12	عَدَمُ الْقُدْرَةِ
u'عَدَمٌ قدرة':Added, #12: 12	عَدَمُ الْقُدْرَةِ
u'عَدَمٌ قدرة':Added, #1: 1	عَدَمُ قُدْرَةِ
u'عَدَمٌ قُدْرَةٌ':Added, #1: 1	عَدَمِ قُدْرَةٍ
u'عَدَمٌ قُدْرَةٌ':Added, #1: 1	عَدَمُ قُدْرَةِ
u'عَدَمٌ قدرة':Added, #1: 1	عَدَمِ قُدْرَةٍ
u'عَدَمٌ قُدْرَةٌ':Added, #1: 1	عَدَمِ قُدْرَتِهِ
u'عَدَمٌ قدرة':Added, #1: 1	عَدَمِ قُدْرَتِهِ
u'عَدَمٌ قُدْرَةٌ':Added, #27: 27	عَدَمِ الْقُدْرَةِ
u'عَدَمٌ قدرة':Added, #27: 27	عَدَمِ الْقُدْرَةِ
u'عَدَمٌ قُدْرَةٌ':Added, #2: 2	عَدَمِ قُدْرَةِ
u'عَدَمٌ قدرة':Added, #2: 2	عَدَمِ قُدْرَةِ
u'عَدَمٌ قُدْرَةٌ':Added, #2: 2	عَدَمَ قُدْرَتِهِ
u'عَدَمٌ قُدُومٌ':Added, #2: 2	عَدَمَ قُدْرَتِهِ
u'عَدَمٌ قِرَاءةٌ':Added, #1: 1	عَدَمِ الْقُدُومِ
u'عَدَمٌ قِرَاءةٌ':Added, #1: 1	عَدَمِ قِرَاءَةِ
u'عَدَمٌ قِرَاءةٌ':Added, #1: 1	عَدَمُ قِرَاءَتِهِ
u'عَدَمٌ قَرَابَةٌ':Added, #1: 1	عَدَمِ قِرَاءَتِهِ
u'عَدَمٌ قَرَابَةٌ':Added, #1: 1	عَدَمِ الْقَرَابَةِ
u'عَدَمٌ قرار':Added, #1: 1	عَدَمِ قَرَابَةِ
u'عَدَمٌ قَرَارٌ':Added, #1: 1	عَدَمُ قَرَارِهِ
u'عَدَمٌ قُرْآنٌ':Added, #1: 1	عَدَمُ قَرَارِهِ
u'عَدَمٌ قرائن':Added, #1: 1	عَدَمِ الْقُرْآنِ
u'عَدَمٌ قَرْنٌ':Added, #4: 4	عَدَمِ الْقَرَائِنِ
u'عَدَمٌ قَرِينٌ':Added, #1: 1	عَدَمُ الْقَرْنِ
u'عَدَمٌ قَرِينٌ':Added, #14: 14	عَدَمِ الْقَرِينَةِ
u'عَدَمٌ قَرِينٌ':Added, #1: 1	عَدَمِ قَرِينَتِهِ
u'عَدَمٌ قَرِينٌ':Added, #2: 2	عَدَمَ الْقَرِينَةِ
u'عَدَمٌ قِسْطٌ':Added, #2: 2	عَدَمِ قَرِينَةِ
u'عَدَمٌ قسمة':Added, #1: 1	عَدَمَ الْقِسْطِ
u'عَدَمٌ قِسْمَةٌ':Added, #1: 1	عَدَمِ الْقِسْمَةِ
u'عَدَمٌ قسمة':Added, #1: 1	عَدَمِ الْقِسْمَةِ
u'عَدَمٌ قِسْمَةٌ':Added, #3: 3	عَدَمُ الْقِسْمَةِ
u'عَدَمٌ قصاص':Added, #3: 3	عَدَمُ الْقِسْمَةِ
u'عَدَمٌ قِصَاصٌ':Added, #2: 2	عَدَمُ الْقِصَاصِ
u'عَدَمٌ قصاص':Added, #2: 2	عَدَمُ الْقِصَاصِ
u'عَدَمٌ قِصَاصٌ':Added, #4: 4	عَدَمِ الْقِصَاصِ
u'عَدِمَ قَصْدٌ':Predicate, #4: 4	عَدَمِ الْقِصَاصِ
u'عَدَمٌ قَصْدٌ':Added, #1: 1	عَدِمَ قَصْدَ
u'عَدَمٌ قَصْدٌ':Added, #11: 11	عَدَمِ قَصْدِ
u'عَدَمٌ قَصْدٌ':Added, #1: 1	عَدَمَ قَصْدِ
u'عَدَمٌ قَصْدٌ':Added, #1: 1	عَدَمُ قَصْدٍ
u'عَدَمٌ قَصْدٌ':Added, #21: 21	عَدَمِ الْقَصْدِ
u'عَدَمٌ قَصْدٌ':Added, #2: 2	عَدَمِ قَصْدِهِ
u'عَدَمٌ قَصْدٌ':Added, #3: 3	عَدَمُ قَصْدِ
u'عَدَمٌ قَصْدٌ':Added, #5: 5	عَدَمَ الْقَصْدِ
u'عَدَمٌ قَصْرٌ':Added, #7: 7	عَدَمُ الْقَصْدِ
u'عَدَمٌ قَصْرٌ':Added, #1: 1	عَدَمَ الْقَصْرِ
u'عَدَمٌ قَصْرٌ':Added, #1: 1	عَدَمِ قَصْرِ
u'عَدَمٌ قَصْرٌ':Added, #2: 2	عَدَمُ الْقَصْرِ
u'عَدَمٌ قُصُورٌ':Added, #2: 2	عَدَمِ الْقَصْرِ
u'عَدَمٌ قُصُورٌ':Added, #1: 1	عَدَمَ قُصُورِ
u'عَدَمٌ قَضَاءٌ':Added, #1: 1	عَدَمِ قُصُورِهِ
u'عَدَمٌ قَضَاءٌ':Added, #13: 13	عَدَمِ الْقَضَاءِ
u'عَدَمٌ قَضَاءٌ':Added, #1: 1	عَدَمِ قَضَاءِ
u'عَدَمٌ قَضَاءٌ':Added, #5: 5	عَدَمَ الْقَضَاءِ
u'عَدَمٌ قَطْعٌ':Added, #8: 8	عَدَمُ الْقَضَاءِ
u'عَدَمٌ قَطْعٌ':Added, #11: 11	عَدَمِ الْقَطْعِ
u'عَدَمٌ قَطْعٌ':Added, #15: 15	عَدَمُ الْقَطْعِ
u'عَدَمٌ قَطْع':Added, #1: 1	عَدَمِ قَطْعِ
u'عَدَمٌ قَطْع':Added, #1: 1	عَدَمَ قَطْعِيَّةِ
u'عَدَمٌ قَطْعٌ':Added, #1: 1	عَدَمِ قَطْعِيَّةِ
u'عَدَمٌ قَطْعٌ':Added, #2: 2	عَدَمَ قَطْعِ
u'عَدَمٌ قَطْعٌ':Added, #2: 2	عَدَمِ قَطْعِهِ
u'عَدَمٌ قَطْعٌ':Added, #3: 3	عَدَمُ قَطْعِهِ
u'عَدَمٌ قَطْعَة':Added, #5: 5	عَدَمَ الْقَطْعِ
u'عَدَمٌ قَطْعَة':Added, #1: 1	عَدَمَ قَطْعِيَّةِ
u'عَدَمٌ قَطْعِيّ':Added, #1: 1	عَدَمِ قَطْعِيَّةِ
u'عَدَمٌ قَطْعِيّ':Added, #1: 1	عَدَمَ قَطْعِيَّةِ
u'عَدَمٌ قَطْعِيَّة':Added, #1: 1	عَدَمِ قَطْعِيَّةِ
u'عَدَمٌ قَطْعِيَّة':Added, #1: 1	عَدَمَ قَطْعِيَّةِ
u'عَدَمٌ قُنُوتٌ':Added, #1: 1	عَدَمِ قَطْعِيَّةِ
u'عَدَمٌ قَوَاطِعُ':Added, #1: 1	عَدَمَ الْقُنُوتِ
u'عَدَمٌ قُوَّةٌ':Added, #1: 1	عَدَمُ الْقَوَاطِعِ
u'عَدَمٌ قُوَّة':Added, #1: 1	عَدَمِ قُوَّتِهِ
u'عَدَمٌ قُوتٌ':Added, #1: 1	عَدَمِ قُوَّتِهِ
u'عَدَمٌ قَوَد':Added, #1: 1	عَدَمِ الْقُوتِ
u'عَدَمٌ قول':Added, #1: 1	عَدَمَ الْقَوَدِ
u'عَدَمٌ قَوْلٌ':Added, #1: 1	عَدَمِ قَوْلِ
u'عَدَمٌ قول':Added, #1: 1	عَدَمِ قَوْلِ
u'عَدَمٌ قَوْلٌ':Added, #1: 1	عَدَمُ قَوْلِهِ
u'عَدَمٌ قول':Added, #1: 1	عَدَمُ قَوْلِهِ
u'عَدَمٌ قَوْلٌ':Added, #2: 2	عَدَمُ الْقَوْلِ
u'عَدَمٌ قول':Added, #2: 2	عَدَمُ الْقَوْلِ
u'عَدَمٌ قَوْلٌ':Added, #3: 3	عَدَمَ الْقَوْلِ
u'عَدَمٌ قول':Added, #3: 3	عَدَمَ الْقَوْلِ
u'عَدَمٌ قَوْلٌ':Added, #5: 5	عَدَمِ الْقَوْلِ
u'عَدَمٌ قِيَاسٌ':Added, #5: 5	عَدَمِ الْقَوْلِ
u'عَدَمٌ قِيَاسٌ':Added, #1: 1	عَدَمُ الْقِيَاسِ
u'عَدَمٌ قيام':Added, #4: 4	عَدَمِ الْقِيَاسِ
u'عَدَمٌ قِيَامٌ':Added, #1: 1	عَدَمَ قِيَامِهِ
u'عَدَمٌ قيام':Added, #1: 1	عَدَمَ قِيَامِهِ
u'عَدَمٌ قِيَامٌ':Added, #2: 2	عَدَمُ الْقِيَامِ
u'عَدَمٌ قيام':Added, #2: 2	عَدَمُ الْقِيَامِ
u'عَدَمٌ قِيَامٌ':Added, #2: 2	عَدَمِ قِيَامِ
u'عَدَمٌ قيام':Added, #2: 2	عَدَمِ قِيَامِ
u'عَدَمٌ قِيَامٌ':Added, #3: 3	عَدَمُ قِيَامِ
u'عَدَمٌ قَيْدٌ':Added, #3: 3	عَدَمُ قِيَامِ
u'عَدَمٌ قِيمَةٌ':Added, #2: 2	عَدَمُ الْقَيْدِ
u'عَدَمٌ كِتَابَةٌ':Added, #1: 1	عَدَمِ الْقِيمَةِ
u'عَدَمٌ كِتَابَةٌ':Added, #1: 1	عَدَمُ الْكِتَابَةِ
u'عَدَمٌ كَثْرَةٌ':Added, #1: 1	عَدَمُ كِتَابَةِ
u'عَدَمٌ كذب':Added, #1: 1	عَدَمُ الْكَثْرَةِ
u'عَدَمٌ كَذِبٌ':Added, #1: 1	عَدَمِ الْكَذِبِ
u'عَدَمٌ كذب':Added, #1: 1	عَدَمِ الْكَذِبِ
u'عَدَمٌ كَذِبٌ':Added, #1: 1	عَدَمُ كَذِبِهِ
u'عَدَمٌ كذب':Added, #1: 1	عَدَمُ كَذِبِهِ
u'عَدَمٌ كَذِبٌ':Added, #2: 2	عَدَمِ كَذِبِهِ
u'عَدَمٌ كَرَاهَةٌ':Added, #2: 2	عَدَمِ كَذِبِهِ
u'عَدَمٌ كَرَاهَةٌ':Added, #16: 16	عَدَمَ الْكَرَاهَةِ
u'عَدَمٌ كَرَاهَةٌ':Added, #16: 16	عَدَمِ كَرَاهَةِ
u'عَدَمٌ كَرَاهَةٌ':Added, #1: 1	عَدَمُ كَرَاهَتِهِ
u'عَدَمٌ كَرَاهَةٌ':Added, #20: 20	عَدَمِ الْكَرَاهَةِ
u'عَدَمٌ كَرَاهَةٌ':Added, #2: 2	عَدَمَ كَرَاهَتِهِ
u'عَدَمٌ كَرَاهَةٌ':Added, #2: 2	عَدَمِ كَرَاهَتِهِ
u'عَدَمٌ كَرَاهَةٌ':Added, #30: 30	عَدَمُ الْكَرَاهَةِ
u'عَدَمٌ كَرَاهَةٌ':Added, #5: 5	عَدَمُ كَرَاهَةِ
u'عَدَمٌ كَرَمٌ':Added, #8: 8	عَدَمَ كَرَاهَةِ
u'عَدَمٌ كَسْبٌ':Added, #1: 1	عَدَمِ الْكَرَمِ
u'عَدَمٌ كَسْبٌ':Added, #1: 1	عَدَمُ الْكَسْبِ
u'عَدَمٌ كَفَاءةٌ':Added, #2: 2	عَدَمُ كَسْبِهِ
u'عَدَمٌ كَفَاءةٌ':Added, #1: 1	عَدَم الْكَفَاءَةِ
u'عَدَمٌ كَفَاءةٌ':Added, #1: 1	عَدَمَ الْكَفَاءَةِ
u'عَدَمٌ كَفَاءةٌ':Added, #1: 1	عَدَمِ كَفَاءَةٍ
u'عَدَمٌ كَفَاءةٌ':Added, #1: 1	عَدَمَ كَفَاءَتِهِ
u'عَدَمٌ كَفَاءةٌ':Added, #6: 6	عَدَمُ الْكَفَاءَةِ
u'عَدَمٌ كَفَّارٌ':Added, #7: 7	عَدَمِ الْكَفَاءَةِ
u'عَدَمٌ كَفَّارٌ':Added, #1: 1	عَدَمُ الْكَفَّارَةِ
u'عَدَمٌ كَفَّارٌ':Added, #2: 2	عَدَمِ الْكَفَّارَةِ
u'عَدَمٌ كَفَّارَةٌ':Added, #4: 4	عَدَمَ الْكَفَّارَةِ
u'عَدَمٌ كَفَّارَةٌ':Added, #1: 1	عَدَمُ الْكَفَّارَةِ
u'عَدَمٌ كَفَّارَةٌ':Added, #2: 2	عَدَمِ الْكَفَّارَةِ
u'عَدَمٌ كَفَالَةٌ':Added, #4: 4	عَدَمَ الْكَفَّارَةِ
u'عَدَمٌ كِفَايَةٌ':Added, #1: 1	عَدَمُ الْكَفَالَةِ
u'عَدَمٌ كِفَايَةٌ':Added, #1: 1	عَدَمُ الْكِفَايَةِ
u'عَدَمٌ كِفَايَةٌ':Added, #2: 2	عَدَمِ الْكِفَايَةِ
u'عَدَمٌ كفر':Added, #3: 3	عَدَمِ كِفَايَتِهِ
u'عَدَمٌ كفر':Added, #1: 1	عَدَمَ الْكُفْرِ
u'عَدَمٌ كفر':Added, #1: 1	عَدَمُ الْكُفْرِ
u'عَدَمٌ كُفْرٌ':Added, #1: 1	عَدَمِ الْكُفْرِ
u'عَدَمٌ كُفْرٌ':Added, #1: 1	عَدَمَ الْكُفْرِ
u'عَدَمٌ كُفْرٌ':Added, #1: 1	عَدَمُ الْكُفْرِ
u'عَدَمٌ كفر':Added, #1: 1	عَدَمِ الْكُفْرِ
u'عَدَمٌ كُفْرٌ':Added, #1: 1	عَدَمَ كُفْرِ
u'عَدَمٌ كفر':Added, #1: 1	عَدَمَ كُفْرِ
u'عَدَمٌ كُفْرٌ':Added, #1: 1	عَدَمَ كُفْرِهِ
u'عَدَمٌ كفر':Added, #1: 1	عَدَمَ كُفْرِهِ
u'عَدَمٌ كُفْرٌ':Added, #2: 2	عَدَمِ كُفْرِ
u'عَدَمٌ كفر':Added, #2: 2	عَدَمِ كُفْرِ
u'عَدَمٌ كُفْرٌ':Added, #3: 3	عَدَمُ كُفْرِهِ
u'عَدِمَ كَلاَمٌ':Predicate, #3: 3	عَدَمُ كُفْرِهِ
u'عَدَمٌ كَلاَمٌ':Added, #2: 2	عَدِمَ الْكَلَامَ
u'عَدَمٌ كَلاَمٌ':Added, #1: 1	عَدَمَ الْكَلَامِ
u'عَدَمٌ كَلاَمٌ':Added, #1: 1	عَدَمِ الْكَلَامِ
u'عَدَمٌ كَلاَمٌ':Added, #1: 1	عَدَمُ كَلَامِهِ
u'عَدَمٌ كَلاَمٌ':Added, #1: 1	عَدَمِ كَلَامِهِ
u'عَدَمٌ كَمَالٌ':Added, #4: 4	عَدَمُ الْكَلَامِ
u'عَدَمٌ كَمَالٌ':Added, #1: 1	عَدَمُ الْكَمَالِ
u'عَدَمٌ كَمَالٌ':Added, #1: 1	عَدَمِ الْكَمَالِ
u'عَدَمٌ كَوْنٌ':Added, #1: 1	عَدَمِ كَمَالِ
u'عَدَمٌ كَوْنٌ':Added, #1: 1	عَدَمِ الْكَوْنِ
u'عَدَمٌ كَوْنٌ':Added, #2: 2	عَدَمُ كَوْنِ
u'عَدَمٌ كَوْنٌ':Added, #2: 2	عَدَمُ كَوْنِهِ
u'عَدَمٌ كَوْنٌ':Added, #3: 3	عَدَمَ كَوْنِ
u'عَدَمٌ كَوْنٌ':Added, #4: 4	عَدَمِ كَوْنِ
u'عَدَمٌ كَوْنٌ':Added, #6: 6	عَدَمَ كَوْنِهِ
u'عَدَمٌ كَيْلٌ':Added, #9: 9	عَدَمِ كَوْنِهِ
u'عَدَمٌ لاَزِمٌ':Added, #1: 1	عَدَمُ الْكَيْلِ
u'عَدَمٌ لاَزِمٌ':Added, #1: 1	عَدَمَ اللَّازِمِ
u'عَدَمٌ لاَزِمٌ':Added, #1: 1	عَدَمُ اللَّازِمِ
u'عَدَمٌ لبس':Added, #2: 2	عَدَمِ اللَّازِمِ
u'عَدَمٌ لبس':Added, #1: 1	عَدَمُ اللُّبْسِ
u'عَدَمٌ لُبْسٌ':Added, #1: 1	عَدَمِ اللُّبْسِ
u'عَدَمٌ لُبْسٌ':Added, #1: 1	عَدَمُ اللُّبْسِ
u'عَدَمٌ لبن':Added, #1: 1	عَدَمِ اللُّبْسِ
u'عَدَمٌ لَبَنٌ':Added, #1: 1	عَدَمُ اللَّبَنِ
u'عَدَمٌ لَبَنٌ':Added, #1: 1	عَدَمُ اللَّبَنِ
u'عَدَّ ملح':Predicate, #2: 2	عَدَمِ لَبَنٍ
u'عَدَّ مِلْحٌ':Predicate, #1: 1	عَدَّ الْمِلْحَ
u'عَدَمٌ لَحْدٌ':Added, #1: 1	عَدَّ الْمِلْحَ
u'عَدَمٌ لَحْنٌ':Added, #1: 1	عَدَمُ اللَّحْدِ
u'عَدَمٌ لَحْنٌ':Added, #1: 1	عَدَمَ اللَّحْنِ
u'عَدِمَ لُزُومٌ':Predicate, #1: 1	عَدَمُ اللَّحْنِ
u'عَدَمٌ لُزُومٌ':Added, #1: 1	عَدِمَ لُزُومَ
u'عَدَمٌ لُزُومٌ':Added, #11: 11	عَدَمَ اللُّزُومِ
u'عَدَمٌ لُزُومٌ':Added, #13: 13	عَدَمَ لُزُومِ
u'عَدَمٌ لُزُومٌ':Added, #14: 14	عَدَمِ اللُّزُومِ
u'عَدَمٌ لُزُومٌ':Added, #31: 31	عَدَمُ اللُّزُومِ
u'عَدَمٌ لُزُومٌ':Added, #34: 34	عَدَمِ لُزُومِ
u'عَدَمٌ لُزُومٌ':Added, #35: 35	عَدَمُ لُزُومِ
u'عَدَمٌ لُزُومٌ':Added, #4: 4	عَدَمَ لُزُومِهِ
u'عَدَمٌ لُزُومٌ':Added, #7: 7	عَدَمِ لُزُومِهِ
u'عَدَمٌ لعان':Added, #9: 9	عَدَمُ لُزُومِهِ
u'عَدَمٌ لَفْظٌ':Added, #2: 2	عَدَمِ اللِّعَانِ
u'عَدَمٌ لِيَاقَةٌ':Added, #1: 1	عَدَمُ لَفْظٍ
u'عَدِمَ مَاءٌ':Predicate, #1: 1	عَدَمِ لِيَاقَةٍ
u'عَدَمٌ مَاءٌ':Added, #37: 37	عَدِمَ الْمَاءَ
u'عَدَمٌ مَاءٌ':Added, #12: 12	عَدَمُ الْمَاءِ
u'عَدَمٌ مَاءٌ':Added, #20: 20	عَدَمَ الْمَاءِ
u'عَدَمٌ مَاءٌ':Added, #3: 3	عَدَمِ مَاءٍ
u'عَدَمٌ مَارٌّ':Added, #69: 69	عَدَمِ الْمَاءِ
u'عَدَمٌ مَالٌ':Added, #2: 2	عَدَمِ الْمَارِّ
u'عَدَمٌ مَالٌ':Added, #1: 1	عَدَمِ مَالِهِ
u'عَدَمٌ مَالٌ':Added, #2: 2	عَدَمَ الْمَالِ
u'عَدَمٌ مَالٌ':Added, #3: 3	عَدَمُ الْمَالِ
u'عَدَمٌ مَالٌ':Added, #3: 3	عَدَمِ مَالٍ
u'عَدِمَ مَالِكٌ':Subject, #4: 4	عَدَمِ الْمَالِ
u'عَدَمٌ مَالِيٌّ':Added, #1: 1	عَدِمَ الْمَالِكُ
u'عَدَمٌ مَالِيٌّ':Added, #1: 1	عَدَمِ الْمَالِيَّةِ
u'عَدَمٌ مَانِعٌ':Added, #2: 2	عَدَمُ الْمَالِيَّةِ
u'عَدَمٌ مَانِعٌ':Added, #14: 14	عَدَمُ الْمَانِعِ
u'عَدَمٌ مَانِعٌ':Added, #16: 16	عَدَمِ الْمَانِعِ
u'عَدَمٌ مَانِعٌ':Added, #1: 1	عَدَمِ مَانِعٍ
u'عَدَمٌ مَانِعٌ':Added, #1: 1	عَدَمِ مَانِعِ
u'عَدَمٌ مُبَاحٌ':Added, #3: 3	عَدَمَ الْمَانِعِ
u'عَدَمٌ مُبَادَرَةٌ':Added, #1: 1	عَدَمُ الْمُبَاحِ
u'عَدَمٌ مُبَادَرَةٌ':Added, #1: 1	عَدَمُ الْمُبَادَرَةِ
u'عَدَمٌ مُبَاشَرَةٌ':Added, #1: 1	عَدَمِ الْمُبَادَرَةِ
u'عَدَمٌ مُبَاشَرَةٌ':Added, #1: 1	عَدَمِ مُبَاشَرَةِ
u'عَدَمٌ مُبَاشَرَةٌ':Added, #1: 1	عَدَمَ مُبَاشَرَتِهِ
u'عَدَمٌ مُبَاشَرَةٌ':Added, #1: 1	عَدَمُ مُبَاشَرَتِهِ
u'عَدَمٌ مُبَالاَةٌ':Added, #1: 1	عَدَمِ مُبَاشَرَتِهِ
u'عَدَمٌ مُبَالاَةٌ':Added, #1: 1	عَدَم الْمُبَالَاةِ
u'عَدَمٌ مُبَالاَةٌ':Added, #1: 1	عَدَمَ الْمُبَالَاةِ
u'عَدَمٌ مُبَالاَةٌ':Added, #1: 1	عَدَمُ الْمُبَالَاةِ
u'عَدَمٌ مُبَالاَةٌ':Added, #2: 2	عَدَمِ الْمُبَالَاةِ
u'عَدَمٌ مُبَايَعَةٌ':Added, #2: 2	عَدَمِ مُبَالَاتِهِ
u'عَدَمٌ مُتَابَعٌ':Added, #1: 1	عَدَمِ مُبَايَعَتِهِ
u'عَدَمٌ مُتَابَعٌ':Added, #1: 1	عَدَمُ مُتَابَعَةِ
u'عَدَمٌ مُتَابَعَةٌ':Added, #2: 2	عَدَمِ الْمُتَابَعَةِ
u'عَدَمٌ مُتَابَعَةٌ':Added, #1: 1	عَدَمُ مُتَابَعَةِ
u'عَدِمَ مُتَبَرِّعٌ':Subject, #2: 2	عَدَمِ الْمُتَابَعَةِ
u'عَدَمٌ مُتَعَاقِدٌ':Added, #1: 1	عَدِمَ مُتَبَرِّعٌ
u'عَدِمَ مُتَمَتِّعٌ':Subject, #1: 1	عَدَمِ الْمُتَعَاقِدَيْنِ
u'عَدِمَ مثل':Predicate, #1: 1	عَدِمَ الْمُتَمَتِّعُ
u'عَدِمَ مِثْلٌ':Predicate, #1: 1	عَدِمَ الْمِثْلَ
u'عَدَمٌ مَجَازٌ':Added, #1: 1	عَدِمَ الْمِثْلَ
u'عَدَمٌ مُجَازَاةٌ':Added, #1: 1	عَدَمُ الْمَجَازِ
u'عَدَمٌ مُجَازَفَةٌ':Added, #1: 1	عَدَمُ الْمُجَازَاةِ
u'عَدَمٌ مُجَانَبَةٌ':Added, #1: 1	عَدَمُ الْمُجَازَفَةِ
u'عَدَمٌ مُجَانَسَةٌ':Added, #1: 1	عَدَمِ الْمُجَانَبَةِ
u'عَدَمٌ مُجَانَسَةٌ':Added, #1: 1	عَدَمَ الْمُجَانَسَةِ
u'عَدَمٌ مُجَاهَدَةٌ':Added, #1: 1	عَدَمُ الْمُجَانَسَةِ
u'عَدَمٌ مُجَاوِرٌ':Added, #1: 1	عَدَمَ الْمُجَاهَدَةِ
u'عَدِمَ مُجْتَهِد':Subject, #1: 1	عَدَمِ مُجَاوِرَةِ
u'عَدَمٌ مَجِيءٌ':Added, #1: 1	عَدِمَ الْمُجْتَهِدُ
u'عَدَمٌ مَجِيءٌ':Added, #1: 1	عَدَمُ الْمَجِيءِ
u'عَدَمٌ مَجِيءٌ':Added, #1: 1	عَدَمَ مَجِيءٍ
u'عَدَمٌ مَجِيءٌ':Added, #1: 1	عَدَمِ مَجِيءِ
u'عَدَمٌ مُحَابَاةٌ':Added, #3: 3	عَدَمَ مَجِيءِ
u'عَدَمٌ مُحَابَاةٌ':Added, #1: 1	عَدَمَ الْمُحَابَاةِ
u'عَدَمٌ مُحَابَاةٌ':Added, #1: 1	عَدَمِ الْمُحَابَاةِ
u'عَدَمٌ مُحَابَاةٌ':Added, #1: 1	عَدَمَ مُحَابَاةِ
u'عَدَمٌ مُحَاذَاةٌ':Added, #2: 2	عَدَمُ الْمُحَابَاةِ
u'عَدَمٌ مُحَاسَبَةٌ':Added, #1: 1	عَدَمُ مُحَاذَاةِ
u'عَدَمٌ مُحاصَّة':Added, #1: 1	عَدَمِ الْمُحَاسَبَةِ
u'عَدَمٌ مُحَافَظَةٌ':Added, #1: 1	عَدَمِ الْمُحَاصَّةِ
u'عَدَمٌ مَحَبَّةٌ':Added, #1: 1	عَدَمَ الْمُحَافَظَةِ
u'عَدِمَ مَحْبُوسٌ':Subject, #1: 1	عَدَمَ مَحَبَّتِهِ
u'عَدَمٌ مَحْدُودٌ':Added, #1: 1	عَدِمَ الْمَحْبُوسُ
u'عَدَمٌ مَحْذُور':Added, #1: 1	عَدَمِ الْمَحْدُودِ
u'عَدَمٌ مَحْذُور':Added, #1: 1	عَدَمُ مَحْذُورٍ
u'عَدَمٌ مَحْرَمٌ':Added, #2: 2	عَدَمِ مَحْذُورٍ
u'عَدَمٌ مَحْرَم':Added, #1: 1	عَدَمُ الْمَحْرَمِ
u'عَدَمٌ مَحْرَم':Added, #1: 1	عَدَمَ الْمَحْرَمِيَّةِ
u'عَدَمٌ مَحْرَمٌ':Added, #1: 1	عَدَمُ الْمَحْرَمِيَّةِ
u'عَدَمٌ مُحْرِمٌ':Added, #1: 1	عَدَمِ مَحْرَمٍ
u'عَدَمٌ مَحْرَمٌ':Added, #2: 2	عَدَمِ الْمُحْرِمِ
u'عَدَمٌ مَحْرَمَة':Added, #5: 5	عَدَمِ الْمَحْرَمِ
u'عَدَمٌ مَحْرَمَة':Added, #1: 1	عَدَمَ الْمَحْرَمِيَّةِ
u'عَدَمٌ مَحْضٌ':Added, #1: 1	عَدَمُ الْمَحْرَمِيَّةِ
u'عَدَمٌ مَحْظُورٌ':Added, #1: 1	عَدَمٍ مَحْضٍ
u'عَدَمٌ مَحَلٌّ':Added, #1: 1	عَدَمِ مَحْظُورٍ
u'عَدَمٌ مَحَلِّيٌّ':Added, #1: 1	عَدَمِ مَحَلِّ
u'عَدَمٌ مَحَلِّيَّةٌ':Added, #1: 1	عَدَمَ مَحَلِّيَّةِ
u'عَدَمٌ مُخَاصَمَةٌ':Added, #1: 1	عَدَمَ مَحَلِّيَّةِ
u'عَدَمٌ مُخَالَطَةٌ':Added, #1: 1	عَدَمَ مُخَاصَمَةِ
u'عَدَمٌ مُخَالَطَةٌ':Added, #1: 1	عَدَمِ الْمُخَالَطَةِ
u'عَدَمٌ مُخَالَفَةٌ':Added, #1: 1	عَدَمِ مُخَالَطَةِ
u'عَدَمٌ مُخَالَفَةٌ':Added, #1: 1	عَدَمِ مُخَالَفَةِ
u'عَدَمٌ مُخَالَفَةٌ':Added, #1: 1	عَدَمُ مُخَالَفَتِهِ
u'عَدَمٌ مُخَالَفَةٌ':Added, #2: 2	عَدَمَ الْمُخَالَفَةِ
u'عَدَمٌ مُخَالَفَةٌ':Added, #2: 2	عَدَمِ مُخَالَفَتِهِ
u'عَدَمٌ مُخَالَفَةٌ':Added, #3: 3	عَدَمِ الْمُخَالَفَةِ
u'عَدَمٌ مَخُوفٌ':Added, #5: 5	عَدَمُ الْمُخَالَفَةِ
u'عَدَمٌ مُدَاوَمَةٌ':Added, #1: 1	عَدَمُ الْمَخُوفِ
u'عَدَمٌ مُدَّةٌ':Added, #1: 1	عَدَمُ الْمُدَاوَمَةِ
u'عَدَمٌ مَدْلُولٌ':Added, #1: 1	عَدَمُ الْمُدَّةِ
u'عَدَمٌ مُرَاجَعَةٌ':Added, #1: 1	عَدَمُ الْمَدْلُولِ
u'عَدَمٌ مُرَاجَعَةٌ':Added, #1: 1	عَدَمُ الْمُرَاجَعَةِ
u'عَدَمٌ مُرَاجَعَةٌ':Added, #1: 1	عَدَمِ مُرَاجَعَةِ
u'عَدِمَ مراد':Predicate, #2: 2	عَدَمِ مُرَاجَعَتِهِ
u'عَدِمَ مُرَادٌ':Predicate, #1: 1	عَدِمَ الْمُرَادَ
u'عَدَمٌ مراد':Added, #1: 1	عَدِمَ الْمُرَادَ
u'عَدَمٌ مُرَادٌ':Added, #1: 1	عَدَمِ الْمُرَادِ
u'عَدَمٌ مُرَاعَاةٌ':Added, #1: 1	عَدَمِ الْمُرَادِ
u'عَدَمٌ مُرَاعَاةٌ':Added, #1: 1	عَدَمَ الْمُرَاعَاةِ
u'عَدَمٌ مُرَاعَاةٌ':Added, #1: 1	عَدَمُ الْمُرَاعَاةِ
u'عَدَمٌ مُرَاعَاةٌ':Added, #1: 1	عَدَمُ مُرَاعَاةِ
u'عَدَمٌ مُرَجِّحٌ':Added, #1: 1	عَدَمِ مُرَاعَاةِ
u'عَدَمٌ مُرَجِّحٌ':Added, #1: 1	عَدَمِ مُرَجِّحٍ
u'عَدَمٌ مَرْجُوحَة':Added, #3: 3	عَدَمِ الْمُرَجِّحِ
u'عَدَمٌ مُرُورٌ':Added, #1: 1	عَدَمَ الْمَرْجُوحَةِ
u'عَدَمٌ مُزَاحِمٌ':Added, #2: 2	عَدَمِ الْمُرُورِ
u'عَدَمٌ مُزَاحِمٌ':Added, #1: 1	عَدَمَ الْمُزَاحِمِ
u'عَدَمٌ مُزَاحَمَةٌ':Added, #2: 2	عَدَمِ الْمُزَاحِمِ
u'عَدَمٌ مُزَاحَمَةٌ':Added, #1: 1	عَدَمَ الْمُزَاحَمَةِ
u'عَدَمٌ مُزَاحَمَةٌ':Added, #1: 1	عَدَمُ الْمُزَاحَمَةِ
u'عَدَمٌ مُزَاحَمَةٌ':Added, #1: 1	عَدَمِ مُزَاحَمَةِ
u'عَدَمٌ مُزِيل':Added, #2: 2	عَدَمِ الْمُزَاحَمَةِ
u'عَدَمٌ مَسٌّ':Added, #2: 2	عَدَمُ الْمُزِيلِ
u'عَدَمٌ مُسَاعَدَةٌ':Added, #1: 1	عَدَمُ مَسِّ
u'عَدِمَ مساكين':Subject, #1: 1	عَدَمِ الْمُسَاعَدَةِ
u'عَدَمٌ مُسامَحَة':Added, #1: 1	عَدِمَ الْمَسَاكِينُ
u'عَدَمٌ مُسامَحَة':Added, #1: 1	عَدَم مُسَامَحَةِ
u'عَدَمٌ مُسَاوَاةٌ':Added, #4: 4	عَدَمِ الْمُسَامَحَةِ
u'عَدَمٌ مُسَاوَاةٌ':Added, #2: 2	عَدَمَ مُسَاوَاةِ
u'عَدَمٌ مُسَاوَاةٌ':Added, #2: 2	عَدَمِ مُسَاوَاةِ
u'عَدَمٌ مُسَاوَاةٌ':Added, #3: 3	عَدَمَ الْمُسَاوَاةِ
u'عَدَمٌ مُسَاوَاةٌ':Added, #5: 5	عَدَمِ الْمُسَاوَاةِ
u'عَدَمٌ مُسَبِّبٌ':Added, #7: 7	عَدَمُ الْمُسَاوَاةِ
u'عَدَمٌ مَسْبُوق':Added, #1: 1	عَدَمَ الْمُسَبِّبِ
u'عَدَمٌ مُسْتَحِقٌّ':Added, #1: 1	عَدَمِ الْمَسْبُوقِيَّةِ
u'عَدَمٌ مُسْتَعِيرٌ':Added, #1: 1	عَدَمِ الْمُسْتَحِقِّ
u'عَدَمٌ مَسْحٌ':Added, #1: 1	عَدَمِ الْمُسْتَعِيرِ
u'عَدَمٌ مَسْحٌ':Added, #1: 1	عَدَمَ الْمَسْحِ
u'عَدَمٌ مَسْحٌ':Added, #1: 1	عَدَمِ الْمَسْحِ
u'عَدَمٌ مَسْحٌ':Added, #1: 1	عَدَمَ مَسْحِ
u'عَدَمٌ مَسْحٌ':Added, #2: 2	عَدَمُ الْمَسْحِ
u'عَدَمٌ مُسْلِمٌ':Added, #3: 3	عَدَمِ مَسْحِ
u'عَدَمٌ مَسِيسٌ':Added, #1: 1	عَدَمِ الْمُسْلِمِ
u'عَدَمٌ مَسِيسٌ':Added, #1: 1	عَدَمِ الْمَسِيسِ
u'عَدَمٌ مُشَابَهَةٌ':Added, #1: 1	عَدَمِ مَسِيسِهِ
u'عَدَمٌ مُشَابَهَةٌ':Added, #1: 1	عَدَمَ الْمُشَابَهَةِ
u'عَدَمٌ مُشَارَكَةٌ':Added, #1: 1	عَدَمِ مُشَابَهَتِهِ
u'عَدَمٌ مُشَارَكَةٌ':Added, #1: 1	عَدَم الْمُشَارَكَةِ
u'عَدَمٌ مُشَارَكَةٌ':Added, #1: 1	عَدَمُ الْمُشَارَكَةِ
u'عَدَمٌ مُشَارَكَةٌ':Added, #1: 1	عَدَمُ مُشَارَكَةِ
u'عَدَمٌ مُشَاهَدٌ':Added, #2: 2	عَدَمِ مُشَارَكَةِ
u'عَدَمٌ مُشَاهَدٌ':Added, #1: 1	عَدَمُ الْمُشَاهَدَةِ
u'عَدَمٌ مُشَاهَدَةٌ':Added, #1: 1	عَدَمِ الْمُشَاهَدَةِ
u'عَدَمٌ مُشَاهَدَةٌ':Added, #1: 1	عَدَمُ الْمُشَاهَدَةِ
u'عَدَمٌ مُشْتَرَكٌ':Added, #1: 1	عَدَمِ الْمُشَاهَدَةِ
u'عَدَمٌ مُشْتَقٌّ':Added, #1: 1	عَدَمِ الْمُشْتَرَكِ
u'عَدَمٌ مَشْرُوطٌ':Added, #1: 1	عَدَمُ الْمُشْتَقِّ
u'عَدَمٌ مَشْرُوطٌ':Added, #2: 2	عَدَمَ الْمَشْرُوطِ
u'عَدَمٌ مَشْرُوعِيَّةٌ':Added, #2: 2	عَدَمُ الْمَشْرُوطِ
u'عَدَمٌ مَشْرُوعِيَّةٌ':Added, #1: 1	عَدَمَ الْمَشْرُوعِيَّةِ
u'عَدَمٌ مَشْرُوعِيَّةٌ':Added, #1: 1	عَدَمُ الْمَشْرُوعِيَّةِ
u'عَدَمٌ مَشْرُوعِيَّةٌ':Added, #1: 1	عَدَمِ الْمَشْرُوعِيَّةِ
u'عَدَمٌ مَشْرُوعِيَّةٌ':Added, #1: 1	عَدَمَ مَشْرُوعِيَّةِ
u'عَدَمٌ مَشْرُوعِيَّةٌ':Added, #1: 1	عَدَمُ مَشْرُوعِيَّةِ
u'عَدَمٌ مَشْرُوعِيَّةٌ':Added, #2: 2	عَدَمِ مَشْرُوعِيَّتِهِ
u'عَدَمٌ مَشَقَّةٌ':Added, #3: 3	عَدَمِ مَشْرُوعِيَّةِ
u'عَدَمٌ مَشْهُودٌ':Added, #4: 4	عَدَمِ الْمَشَقَّةِ
u'عَدَمٌ مَشِيئَةٌ':Added, #1: 1	عَدَمِ الْمَشْهُودِ
u'عَدَمٌ مَشِيئَةٌ':Added, #1: 1	عَدَمَ الْمَشِيئَةِ
u'عَدَمٌ مَشِيئَةٌ':Added, #1: 1	عَدَمُ الْمَشِيئَةِ
u'عَدَمٌ مَشِيئَةٌ':Added, #1: 1	عَدَمُ مَشِيئَتِهِ
u'عَدَمٌ مَشِيئَةٌ':Added, #2: 2	عَدَمُ مَشِيئَةِ
u'عَدَمٌ مُصَادَفَةٌ':Added, #3: 3	عَدَمِ الْمَشِيئَةِ
u'عَدَمٌ مُصَادَفَةٌ':Added, #1: 1	عَدَمَ مُصَادَفَةِ
u'عَدَمٌ مَصْلَحَةٌ':Added, #1: 1	عَدَمُ مُصَادَفَةِ
u'عَدَمٌ مَصْلَحَةٌ':Added, #1: 1	عَدَمَ مَصْلَحَةِ
u'عَدَمٌ مَصْلَحَةٌ':Added, #2: 2	عَدَمُ الْمَصْلَحَةِ
u'عَدَمٌ مَضَرَّةٌ':Added, #3: 3	عَدَمِ الْمَصْلَحَةِ
u'عَدَمٌ مُضِيٌّ':Added, #1: 1	عَدَمُ الْمَضَرَّةِ
u'عَدَمٌ مُضِيٌّ':Added, #1: 1	عَدَمُ الْمُضِيِّ
u'عَدَمٌ مَضِيقٌ':Added, #1: 1	عَدَمُ مُضِيِّ
u'عَدَمٌ مُطَابِقٌ':Added, #1: 1	عَدَمَ الْمَضِيقِ
u'عَدَمٌ مُطَابَقَةٌ':Added, #1: 1	عَدَمُ الْمُطَابِقَةِ
u'عَدَمٌ مُطَابَقَةٌ':Added, #1: 1	عَدَمَ مُطَابَقَةِ
u'عَدَمٌ مُطَابَقَةٌ':Added, #1: 1	عَدَمُ مُطَابَقَةِ
u'عَدَمٌ مُطَابَقَةٌ':Added, #1: 1	عَدَمِ مُطَابَقَةِ
u'عَدَمٌ مُطَابَقَةٌ':Added, #2: 2	عَدَمُ الْمُطَابَقَةِ
u'عَدَمٌ مُطَابَقَةٌ':Added, #2: 2	عَدَمِ الْمُطَابَقَةِ
u'عَدَمٌ مُطَابَقَةٌ':Added, #2: 2	عَدَمُ مُطَابَقَتِهِ
u'عَدَمٌ مُطَالَبٌ':Added, #2: 2	عَدَمِ مُطَابَقَتِهِ
u'عَدَمٌ مُطَالَبٌ':Added, #1: 1	عَدَمِ مُطَالَبَةِ
u'عَدَمٌ مُطَالَبٌ':Added, #1: 1	عَدَمَ مُطَالَبَتِهِ
u'عَدَمٌ مُطَالَبٌ':Added, #2: 2	عَدَمِ الْمُطَالَبَةِ
u'عَدَمٌ مُطَالَبٌ':Added, #2: 2	عَدَمَ مُطَالَبَةِ
u'عَدَمٌ مُطَالَبٌ':Added, #2: 2	عَدَمُ مُطَالَبَتِهِ
u'عَدَمٌ مُطَالَبَةٌ':Added, #3: 3	عَدَمَ الْمُطَالَبَةِ
u'عَدَمٌ مُطَالَبَةٌ':Added, #1: 1	عَدَمِ مُطَالَبَةِ
u'عَدَمٌ مُطَالَبَةٌ':Added, #1: 1	عَدَمَ مُطَالَبَتِهِ
u'عَدَمٌ مُطَالَبَةٌ':Added, #2: 2	عَدَمِ الْمُطَالَبَةِ
u'عَدَمٌ مُطَالَبَةٌ':Added, #2: 2	عَدَمَ مُطَالَبَةِ
u'عَدَمٌ مُطَالَبَةٌ':Added, #2: 2	عَدَمُ مُطَالَبَتِهِ
u'عَدَمٌ مَطْلُوبٌ':Added, #3: 3	عَدَمَ الْمُطَالَبَةِ
u'عَدَمٌ مُعارِضٌ':Added, #2: 2	عَدَمِ الْمَطْلُوبِ
u'عَدَمٌ مُعارِضٌ':Added, #1: 1	عَدَمَ الْمُعَارِضِ
u'عَدَمٌ مُعارِضٌ':Added, #1: 1	عَدَمُ مُعَارِضٍ
u'عَدَمٌ مُعارِضٌ':Added, #3: 3	عَدَمُ الْمُعَارِضِ
u'عَدَمٌ مُعَارَضَةٌ':Added, #7: 7	عَدَمِ الْمُعَارِضِ
u'عَدَمٌ مُعَارَضَةٌ':Added, #1: 1	عَدَمِ الْمُعَارَضَةِ
u'عَدَمٌ مُعَارَضَةٌ':Added, #1: 1	عَدَمَ مُعَارَضَتِهِ
u'عَدَمٌ مُعَارَضَةٌ':Added, #1: 1	عَدَمُ مُعَارَضَتِهِ
u'عَدَمٌ مُعْتَادٌ':Added, #2: 2	عَدَمُ مُعَارَضَةِ
u'عَدَمٌ مَعْرِفَةٌ':Added, #1: 1	عَدَمِ الْمُعْتَادِ
u'عَدَمٌ مَعْرِفَة':Added, #2: 2	عَدَمَ مَعْرِفَةِ
u'عَدَمٌ مَعْرِفَةٌ':Added, #2: 2	عَدَمَ مَعْرِفَةِ
u'عَدَمٌ مَعْرِفَةٌ':Added, #2: 2	عَدَمَ مَعْرِفَتِهِ
u'عَدَمٌ مَعْرِفَة':Added, #2: 2	عَدَمِ مَعْرِفَتِهِ
u'عَدَمٌ مَعْرِفَة':Added, #2: 2	عَدَمَ مَعْرِفَتِهِ
u'عَدَمٌ مَعْرِفَةٌ':Added, #2: 2	عَدَمِ مَعْرِفَتِهِ
u'عَدَمٌ مَعْرِفَة':Added, #4: 4	عَدَمُ مَعْرِفَةِ
u'عَدَمٌ مَعْرِفَةٌ':Added, #4: 4	عَدَمُ مَعْرِفَةِ
u'عَدَمٌ مَعْرِفَة':Added, #5: 5	عَدَمِ الْمَعْرِفَةِ
u'عَدَمٌ مَعْرِفَةٌ':Added, #5: 5	عَدَمِ الْمَعْرِفَةِ
u'عَدَمٌ مَعْرِفَة':Added, #8: 8	عَدَمِ مَعْرِفَةِ
u'عَدَمٌ مُعَصَّبٌ':Added, #8: 8	عَدَمِ مَعْرِفَةِ
u'عَدَمٌ مَعْصِيَةٌ':Added, #1: 1	عَدَمِ الْمُعَصَّبِ
u'عَدَمٌ مَعْصِيَةٌ':Added, #1: 1	عَدَمَ الْمَعْصِيَةِ
u'عَدَمٌ مَعْقُودٌ':Added, #1: 1	عَدَمُ الْمَعْصِيَةِ
u'عَدَمٌ مَعْقُول':Added, #1: 1	عَدَمُ الْمَعْقُودِ
u'عَدَمٌ مَعْقُولِيَّة':Added, #1: 1	عَدَمُ مَعْقُولِيَّةِ
u'عَدَمٌ مُعَلِّمٌ':Added, #1: 1	عَدَمُ مَعْقُولِيَّةِ
u'عَدَمٌ مَعْلُوفٌ':Added, #1: 1	عَدَمِ مُعَلِّمٍ
u'عَدَمٌ مَعْلُولٌ':Added, #1: 1	عَدَمِ الْمَعْلُوفَةِ
u'عَدَمٌ مُغالَبَة':Added, #3: 3	عَدَمُ الْمَعْلُولِ
u'عَدَمٌ مُغَايَرَةٌ':Added, #2: 2	عَدَمِ الْمُغَالَبَةِ
u'عَدَمٌ مَغْفِرَةٌ':Added, #1: 1	عَدَمِ الْمُغَايَرَةِ
u'عَدَمٌ مَغْفِرَةٌ':Added, #1: 1	عَدَمِ الْمَغْفِرَةِ
u'عَدَمٌ مُفاداة':Added, #2: 2	عَدَمُ الْمَغْفِرَةِ
u'عَدَمٌ مُفَارَقَةٌ':Added, #1: 1	عَدَمِ مُفَادَاةٍ
u'عَدَمٌ مُفَارَقَةٌ':Added, #1: 1	عَدَمُ مُفَارَقَةِ
u'عَدَمٌ مَفَاسِدُ':Added, #1: 1	عَدَمِ مُفَارَقَتِهِ
u'عَدَمٌ مُفَاضَلَةٌ':Added, #1: 1	عَدَمِ الْمَفَاسِدِ
u'عَدَمٌ مُفْسِدٌ':Added, #1: 1	عَدَمِ الْمُفَاضَلَةِ
u'عَدَمٌ مُفْسِدٌ':Added, #1: 1	عَدَمِ الْمُفْسِدِ
u'عَدَمٌ مَفْسَدَةٌ':Added, #6: 6	عَدَمُ الْمُفْسِدِ
u'عَدَمٌ مَفْسَدَةٌ':Added, #1: 1	عَدَمَ الْمَفْسَدَةِ
u'عَدَمٌ مُقَابَلٌ':Added, #1: 1	عَدَمُ الْمَفْسَدَةِ
u'عَدَمٌ مُقَابَلَةٌ':Added, #1: 1	عَدَمُ مُقَابَلَةِ
u'عَدَمٌ مُقَارَنٌ':Added, #1: 1	عَدَمُ مُقَابَلَةِ
u'عَدَمٌ مُقَارَنَةٌ':Added, #1: 1	عَدَمُ مُقَارَنَةِ
u'عَدَمٌ مُقَاصَّةٌ':Added, #1: 1	عَدَمُ مُقَارَنَةِ
u'عَدَمٌ مُقَدَّرٌ':Added, #1: 1	عَدَمَ الْمُقَاصَّةِ
u'عَدِمَ مَقْصُودٌ':Predicate, #1: 1	عَدَمِ الْمُقَدَّرِ
u'عَدَمٌ مَقْصُودٌ':Added, #1: 1	عَدِمَ الْمَقْصُودَ
u'عَدَمٌ مُكَافَأَةٌ':Added, #1: 1	عَدَمُ الْمَقْصُودِ
u'عَدَمٌ مُكَافَأَةٌ':Added, #1: 1	عَدَمُ الْمُكَافَأَةِ
u'عَدَمٌ مُلاَحَظَةٌ':Added, #1: 1	عَدَمِ مُكَافَأَةٍ
u'عَدَمٌ مُلاَحَظَةٌ':Added, #1: 1	عَدَمَ مُلَاحَظَةِ
u'عَدَمٌ مُلاَقَاةٌ':Added, #1: 1	عَدَمُ مُلَاحَظَةِ
u'عَدَمٌ مُلاَقَاةٌ':Added, #1: 1	عَدَمُ الْمُلَاقَاةِ
u'عَدَمٌ مَلْزُوم':Added, #1: 1	عَدَمَ مُلَاقَاةِ
u'عَدَمٌ مَلْزُوم':Added, #1: 1	عَدَمَ الْمَلْزُومِ
u'عَدِمَ مِلْكٌ':Predicate, #1: 1	عَدَمِ الْمَلْزُومِ
u'عَدِمَ مِلْكٌ':Subject, #1: 1	عَدِمَ الْمِلْكَ
u'عَدَمٌ مِلْكٌ':Added, #1: 1	عَدِمَ الْمِلْكُ
u'عَدَمٌ مِلْكٌ':Added, #10: 10	عَدَمَ الْمِلْكِ
u'عَدَمٌ مِلْكٌ':Added, #1: 1	عَدَمَ مِلْكِ
u'عَدَمٌ مِلْكٌ':Added, #24: 24	عَدَمِ الْمِلْكِ
u'عَدَمٌ مِلْكٌ':Added, #2: 2	عَدَمَ مِلْكِهِ
u'عَدَمٌ مِلْكٌ':Added, #3: 3	عَدَمِ مِلْكِهِ
u'عَدَمٌ مِلْكٌ':Added, #4: 4	عَدَمِ مِلْكِ
u'عَدَمٌ مُمَاثَلَةٌ':Added, #6: 6	عَدَمُ الْمِلْكِ
u'عَدَمٌ مُمَاثَلَةٌ':Added, #1: 1	عَدَمِ الْمُمَاثَلَةِ
u'عَدَمٌ مُمَارَسٌ':Added, #3: 3	عَدَمُ الْمُمَاثَلَةِ
u'عَدَمٌ مُمَارَسٌ':Added, #1: 1	عَدَمِ مُمَارَسَةِ
u'عَدَمٌ مُمَارَسَةٌ':Added, #2: 2	عَدَمِ مُمَارَسَتِهِ
u'عَدَمٌ مُمَارَسَةٌ':Added, #1: 1	عَدَمِ مُمَارَسَةِ
u'عَدَمٌ مُمَاسَّةٌ':Added, #2: 2	عَدَمِ مُمَارَسَتِهِ
u'عَدَمٌ مَمَرٌّ':Added, #1: 1	عَدَمُ مُمَاسَّةِ
u'عَدَمٌ مَنٌّ':Added, #1: 1	عَدَمَ الْمَمَرِّ
u'عَدَمٌ مُناجَزَة':Added, #1: 1	عَدَمُ الْمَنِّ
u'عَدَمٌ مُنَازِعٌ':Added, #1: 1	عَدَمُ الْمُنَاجَزَةِ
u'عَدَمٌ مُنَازِعٌ':Added, #1: 1	عَدَمُ الْمُنَازِعِ
u'عَدَمٌ مُنَازَعٌ':Added, #1: 1	عَدَمِ الْمُنَازِعِ
u'عَدَمٌ مُنَازَعٌ':Added, #1: 1	عَدَمُ الْمُنَازَعَةِ
u'عَدَمٌ مُنَازَعَةٌ':Added, #1: 1	عَدَمِ الْمُنَازَعَةِ
u'عَدَمٌ مُنَازَعَةٌ':Added, #1: 1	عَدَمُ الْمُنَازَعَةِ
u'عَدَمٌ مُنَاسِبٌ':Added, #1: 1	عَدَمِ الْمُنَازَعَةِ
u'عَدَمٌ مُنَاسَبَةٌ':Added, #1: 1	عَدَمِ الْمُنَاسِبِ
u'عَدَمٌ مُنَاسَبَةٌ':Added, #1: 1	عَدَمَ الْمُنَاسَبَةِ
u'عَدَمٌ مُنَاسَبَةٌ':Added, #1: 1	عَدَمِ الْمُنَاسَبَةِ
u'عَدَمٌ مُنَاسَبَةٌ':Added, #1: 1	عَدَمُ مُنَاسَبَةٍ
u'عَدَمٌ مُنَاسَبَةٌ':Added, #1: 1	عَدَمِ مُنَاسَبَةِ
u'عَدَمٌ مُنافاة':Added, #2: 2	عَدَمُ الْمُنَاسَبَةِ
u'عَدَمٌ مُنافاة':Added, #1: 1	عَدَمِ مُنَافَاةِ
u'عَدَمٌ مُنافاة':Added, #4: 4	عَدَمَ الْمُنَافَاةِ
u'عَدَمٌ مُنافاة':Added, #4: 4	عَدَمُ الْمُنَافَاةِ
u'عَدَمٌ مُنَاقَضَةٌ':Added, #8: 8	عَدَمِ الْمُنَافَاةِ
u'عَدَمٌ مِنَّةٌ':Added, #1: 1	عَدَمِ الْمُنَاقَضَةِ
u'عَدَمٌ مَنْعٌ':Added, #1: 1	عَدَمِ الْمِنَّةِ
u'عَدَمٌ مَنْعٌ':Added, #13: 13	عَدَمُ الْمَنْعِ
u'عَدَمٌ مَنْعٌ':Added, #1: 1	عَدَمَ مَنْعِهِ
u'عَدَمٌ مَنْعٌ':Added, #2: 2	عَدَمِ مَنْعٍ
u'عَدَمٌ مَنْعٌ':Added, #3: 3	عَدَمُ مَنْعِ
u'عَدَمٌ مَنْعٌ':Added, #3: 3	عَدَمُ مَنْعِهِ
u'عَدَمٌ مَنْعٌ':Added, #4: 4	عَدَمَ الْمَنْعِ
u'عَدَمٌ مَنْعٌ':Added, #4: 4	عَدَمِ مَنْعِهِ
u'عَدَمٌ مَنْعٌ':Added, #6: 6	عَدَمِ مَنْعِ
u'عَدَمٌ مِهَادٌ':Added, #8: 8	عَدَمِ الْمَنْعِ
u'عَدَمٌ مَهْرٌ':Added, #1: 1	عَدَمِ الْمِهَادِ
u'عَدَمٌ مَهْرٌ':Added, #1: 1	عَدَمَ مَهْرٍ
u'عَدَمٌ مُؤَاخَذَةٌ':Added, #4: 4	عَدَمِ الْمَهْرِ
u'عَدَمٌ مُؤَاخَذَةٌ':Added, #3: 3	عَدَمِ الْمُؤَاخَذَةِ
u'عَدَمٌ مُؤَاخَذَةٌ':Added, #5: 5	عَدَمَ الْمُؤَاخَذَةِ
u'عَدَمٌ مُوَاظَبَةٌ':Added, #5: 5	عَدَمُ الْمُؤَاخَذَةِ
u'عَدَمٌ مُوَاظَبَةٌ':Added, #1: 1	عَدَمُ مُوَاظَبَتِهِ
u'عَدَمٌ مُوافاة':Added, #2: 2	عَدَمَ الْمُوَاظَبَةِ
u'عَدَمٌ مُوافاة':Added, #1: 1	عَدَمَ الْمُوَافَاةِ
u'عَدَمٌ مُوافاة':Added, #3: 3	عَدَمُ الْمُوَافَاةِ
u'عَدَمٌ مُوَافَقَةٌ':Added, #5: 5	عَدَمِ الْمُوَافَاةِ
u'عَدَمٌ مُوَافَقَةٌ':Added, #1: 1	عَدَمُ الْمُوَافَقَةِ
u'عَدَمٌ مُوَافَقَةٌ':Added, #1: 1	عَدَمَ مُوَافَقَةِ
u'عَدَمٌ مُوَافَقَةٌ':Added, #1: 1	عَدَمُ مُوَافَقَتِهِ
u'عَدَمٌ مُوَافَقَةٌ':Added, #2: 2	عَدَمُ مُوَافَقَةِ
u'عَدَمٌ مُوَافَقَةٌ':Added, #3: 3	عَدَمِ الْمُوَافَقَةِ
u'عَدَمٌ مُوالاة':Added, #9: 9	عَدَمِ مُوَافَقَةِ
u'عَدَمٌ مُوالاة':Added, #1: 1	عَدَمَ الْمُوَالَاةِ
u'عَدَمٌ مَوَالِي':Added, #2: 2	عَدَمِ الْمُوَالَاةِ
u'عَدَمٌ مَوْتٌ':Added, #2: 2	عَدَمِ مَوَالِيهِ
u'عَدَمٌ مَوْتٌ':Added, #1: 1	عَدَمُ الْمَوْتِ
u'عَدَمٌ مُوجِبٌ':Added, #1: 1	عَدَمُ مَوْتِهِ
u'عَدَمٌ مُوجِبٌ':Added, #1: 1	عَدَمُ مُوجِبِ
u'عَدَمٌ مُوجِبٌ':Added, #2: 2	عَدَمُ الْمُوجِبِ
u'عَدَمٌ مَوَدَّةٌ':Added, #2: 2	عَدَمِ الْمُوجِبِ
u'عَدَمٌ مَوْصُوفٌ':Added, #1: 1	عَدَمُ الْمَوَدَّةِ
u'عَدَمٌ مَوْضِعٌ':Added, #1: 1	عَدَمِ مَوْصُوفٍ
u'عَدَمٌ مِيرَاثٌ':Added, #1: 1	عَدَمِ مَوْضِعٍ
u'عَدَمٌ ميل':Added, #2: 2	عَدَمُ الْمِيرَاثِ
u'عَدَمٌ مَيْلٌ':Added, #1: 1	عَدَمِ الْمَيْلِ
u'عَدَمٌ ميل':Added, #1: 1	عَدَمِ الْمَيْلِ
u'عَدَمٌ مِيلٌ':Added, #1: 1	عَدَمُ مِيلِ
u'عَدَمٌ مَيَلاَنٌ':Added, #1: 1	عَدَمُ مِيلِ
u'عَدَمٌ نَاسِخٌ':Added, #1: 1	عَدَمُ مَيَلَانِهِ
u'عَدَمٌ نَاسِخ':Added, #3: 3	عَدَمِ النَّاسِخِ
u'عَدَمٌ نَاظِرٌ':Added, #3: 3	عَدَمِ النَّاسِخِ
u'عَدَمٌ نبات':Added, #1: 1	عَدَمِ نَاظِرٍ
u'عَدَمٌ نبات':Added, #1: 1	عَدَمَ نَبَاتِ
u'عَدَمٌ نَبَاتٌ':Added, #1: 1	عَدَمُ نَبَاتِ
u'عَدَمٌ نَبَاتٌ':Added, #1: 1	عَدَمَ نَبَاتِ
u'عَدَمٌ نَبْش':Added, #1: 1	عَدَمُ نَبَاتِ
u'عَدَمٌ نَجَابَةٌ':Added, #1: 1	عَدَمَ النَّبْشِ
u'عَدَمٌ نَجَاسَةٌ':Added, #1: 1	عَدَمُ نَجَابَةِ
u'عَدَمٌ نَجَاسَةٌ':Added, #1: 1	عَدَمُ نَجَاسَةِ
u'عَدَمٌ نَجَاسَةٌ':Added, #1: 1	عَدَمِ نَجَاسَةِ
u'عَدَمٌ نَجَاسَةٌ':Added, #1: 1	عَدَمِ نَجَاسَتِهِ
u'عَدَمٌ نَجَاسَةٌ':Added, #3: 3	عَدَمِ النَّجَاسَةِ
u'عَدَمٌ نَدْبٌ':Added, #5: 5	عَدَمُ النَّجَاسَةِ
u'عَدَمٌ نَدْبٌ':Added, #1: 1	عَدَمِ النَّدْبِ
u'عَدَمٌ نَدْبٌ':Added, #1: 1	عَدَمَ نَدْبِ
u'عَدَمٌ نَدْبٌ':Added, #1: 1	عَدَمِ نَدْبِهِ
u'عَدَمٌ نَدْبٌ':Added, #3: 3	عَدَمُ نَدْبِهِ
u'عَدَمٌ نَدَمٌ':Added, #4: 4	عَدَمُ نَدْبِ
u'عَدَمٌ نذر':Added, #3: 3	عَدَمِ النَّدَمِ
u'عَدَمٌ نَذْرٌ':Added, #1: 1	عَدَمُ النَّذْرِ
u'عَدَمٌ نَزْعٌ':Added, #1: 1	عَدَمُ النَّذْرِ
u'عَدَمٌ نُزُولٌ':Added, #1: 1	عَدَمِ النَّزْعِ
u'عَدَمٌ نُزُولٌ':Added, #1: 1	عَدَمِ نُزُولِ
u'عَدَمٌ نَسَبٌ':Added, #2: 2	عَدَمِ نُزُولِهِ
u'عَدَمٌ نِسْبَةٌ':Added, #1: 1	عَدَمُ النَّسَبِ
u'عَدَمٌ نِسْبَةٌ':Added, #1: 1	عَدَمُ نِسْبَةِ
u'عَدَمٌ نِسْبَةٌ':Added, #1: 1	عَدَمِ نِسْبَةِ
u'عَدَمٌ نَسْلٌ':Added, #2: 2	عَدَمِ النِّسْبَةِ
u'عَدَمٌ نشاط':Added, #2: 2	عَدَمِ النَّسْلِ
u'عَدَمٌ نَشَاطٌ':Added, #1: 1	عَدَمُ النَّشَاطِ
u'عَدَمٌ نَصٌّ':Added, #1: 1	عَدَمُ النَّشَاطِ
u'عَدَمٌ نَصٌّ':Added, #14: 14	عَدَمِ النَّصِّ
u'عَدَمٌ نَصٌّ':Added, #1: 1	عَدَمَ نَصِّ
u'عَدَمٌ نَصٌّ':Added, #1: 1	عَدَمِ نَصٍّ
u'عَدَمٌ نَصٌّ':Added, #1: 1	عَدَمِ نَصِّ
u'عَدَمٌ نَصٌّ':Added, #1: 1	عَدَمَ نَصِّهِ
u'عَدَمٌ نَصٌّ':Added, #1: 1	عَدَمِ نَصِّهِ
u'عَدِمَ نصرة':Predicate, #3: 3	عَدَمُ النَّصِّ
u'عَدِمَ نُصْرَةٌ':Predicate, #1: 1	عَدِمَ النُّصْرَةَ
u'عَدَمٌ نَصِيرٌ':Added, #1: 1	عَدِمَ النُّصْرَةَ
u'عَدَمٌ نَصِير':Added, #1: 1	عَدَمِ النَّصِيرِ
u'عَدَمٌ نُطْقٌ':Added, #1: 1	عَدَمِ النَّصِيرِ
u'عَدَمٌ نَظَرٌ':Added, #1: 1	عَدَمِ النُّطْقِ
u'عَدَمٌ نَظَرٌ':Added, #2: 2	عَدَمَ النَّظَرِ
u'عَدَمٌ نَظَرٌ':Added, #2: 2	عَدَمُ النَّظَرِ
u'عَدَمٌ نَعْلٌ':Added, #4: 4	عَدَمِ النَّظَرِ
u'عَدَمٌ نَعْلٌ':Added, #1: 1	عَدَمَ النَّعْلِ
u'عَدَمٌ نَعْلٌ':Added, #1: 1	عَدَمَ النَّعْلَيْنِ
u'عَدَمٌ نفاذ':Added, #1: 1	عَدَمِ النَّعْلَيْنِ
u'عَدَمٌ نَفَاذٌ':Added, #1: 1	عَدَمَ نَفَاذِ
u'عَدَمٌ نفاذ':Added, #1: 1	عَدَمَ نَفَاذِ
u'عَدَمٌ نَفَاذٌ':Added, #3: 3	عَدَمِ نَفَاذِ
u'عَدَمٌ نفاذ':Added, #3: 3	عَدَمِ نَفَاذِ
u'عَدَمٌ نَفَاذٌ':Added, #3: 3	عَدَمِ نَفَاذِهِ
u'عَدَمٌ نفاذ':Added, #3: 3	عَدَمِ نَفَاذِهِ
u'عَدَمٌ نَفَاذٌ':Added, #4: 4	عَدَمُ نَفَاذِ
u'عَدَمٌ نفاذ':Added, #4: 4	عَدَمُ نَفَاذِ
u'عَدَمٌ نفاذ':Added, #5: 5	عَدَمَ النَّفَاذِ
u'عَدَمٌ نَفَاذٌ':Added, #5: 5	عَدَمُ النَّفَاذِ
u'عَدَمٌ نَفَاذٌ':Added, #5: 5	عَدَمَ النَّفَاذِ
u'عَدَمٌ نفاذ':Added, #5: 5	عَدَمُ النَّفَاذِ
u'عَدَمٌ نَفَاذٌ':Added, #6: 6	عَدَمِ النَّفَاذِ
u'عَدَمٌ نفاس':Added, #6: 6	عَدَمِ النَّفَاذِ
u'عَدَمٌ نفاس':Added, #1: 1	عَدَمَ النِّفَاسِ
u'عَدَمٌ نِفَاسٌ':Added, #1: 1	عَدَمُ النِّفَاسِ
u'عَدَمٌ نِفَاسٌ':Added, #1: 1	عَدَمَ النِّفَاسِ
u'عَدَمٌ نَفْعٌ':Added, #1: 1	عَدَمُ النِّفَاسِ
u'عَدَمٌ نَفْعٌ':Added, #1: 1	عَدَمُ النَّفْعِ
u'عَدَمٌ نَفْعٌ':Added, #1: 1	عَدَمِ النَّفْعِ
u'عَدَمٌ نَفَقَةٌ':Added, #1: 1	عَدَمُ نَفْعِ
u'عَدَمٌ نَفَقَةٌ':Added, #1: 1	عَدَمِ نَفَقَةِ
u'عَدَمٌ نَفَقَةٌ':Added, #3: 3	عَدَمَ النَّفَقَةِ
u'عَدَمٌ نُفُوذٌ':Added, #3: 3	عَدَمِ النَّفَقَةِ
u'عَدَمٌ نُفُوذٌ':Added, #1: 1	عَدَمَ نُفُوذِهِ
u'عَدَمٌ نُفُوذٌ':Added, #2: 2	عَدَمُ النُّفُوذِ
u'عَدَمٌ نُفُوذٌ':Added, #2: 2	عَدَمُ نُفُوذِ
u'عَدَمٌ نُفُوذٌ':Added, #3: 3	عَدَمُ نُفُوذِهِ
u'عَدَمٌ نُفُوذٌ':Added, #3: 3	عَدَمِ نُفُوذِهِ
u'عَدَمٌ نُفُوذٌ':Added, #6: 6	عَدَمِ نُفُوذِ
u'عَدَمٌ نَفْيٌ':Added, #8: 8	عَدَمِ النُّفُوذِ
u'عَدَمٌ نَفْيٌ':Added, #1: 1	عَدَمِ النَّفْيِ
u'عَدَمٌ نَقْدٌ':Added, #1: 1	عَدَمُ نَفْيِهِ
u'عَدَمٌ نَقْد':Added, #1: 1	عَدَمَ النَّقْدِ
u'عَدَمٌ نَقْدٌ':Added, #1: 1	عَدَمَ النَّقْدِ
u'عَدَمٌ نَقْد':Added, #2: 2	عَدَمُ النَّقْدِ
u'عَدَمٌ نَقْدٌ':Added, #2: 2	عَدَمُ النَّقْدِ
u'عَدَمٌ نَقْد':Added, #3: 3	عَدَمِ النَّقْدِ
u'عَدِمَ نَقْصٌ':Predicate, #3: 3	عَدَمِ النَّقْدِ
u'عَدَمٌ نَقْصٌ':Added, #1: 1	عَدِمَ نَقْصَ
u'عَدَمٌ نَقْصٌ':Added, #1: 1	عَدَمُ النَّقْصِ
u'عَدَمٌ نُقْصَانٌ':Added, #1: 1	عَدَمِ النَّقْصِ
u'عَدَمٌ نُقْصَانٌ':Added, #1: 1	عَدَمُ النُّقْصَانِ
u'عَدَمٌ نَقْضٌ':Added, #1: 1	عَدَمِ نُقْصَانِهِ
u'عَدَمٌ نَقْضٌ':Added, #10: 10	عَدَمَ النَّقْضِ
u'عَدَمٌ نَقْضٌ':Added, #15: 15	عَدَمُ النَّقْضِ
u'عَدَمٌ نَقْضٌ':Added, #15: 15	عَدَمِ النَّقْضِ
u'عَدَمٌ نَقْضٌ':Added, #1: 1	عَدَمُ نَقْضِ
u'عَدَمٌ نَقْضٌ':Added, #2: 2	عَدَمُ نَقْضِهِ
u'عَدَمٌ نقل':Added, #9: 9	عَدَمِ نَقْضِ
u'عَدَمٌ نقل':Added, #1: 1	عَدَمُ نَقْلِ
u'عَدَمٌ نَقْلٌ':Added, #1: 1	عَدَمِ نَقْلِ
u'عَدَمٌ نَقْلٌ':Added, #1: 1	عَدَمُ نَقْلِ
u'عَدَمٌ نقل':Added, #1: 1	عَدَمِ نَقْلِ
u'عَدَمٌ نَقْلٌ':Added, #1: 1	عَدَمِ نَقْلِهِ
u'عَدَمٌ نقل':Added, #1: 1	عَدَمِ نَقْلِهِ
u'عَدَمٌ نَقْلٌ':Added, #2: 2	عَدَمِ النَّقْلِ
u'عَدَمٌ نقل':Added, #2: 2	عَدَمِ النَّقْلِ
u'عَدَمٌ نَقْلٌ':Added, #4: 4	عَدَمَ النَّقْلِ
u'عَدَمٌ نقل':Added, #4: 4	عَدَمَ النَّقْلِ
u'عَدَمٌ نَقْلٌ':Added, #7: 7	عَدَمُ النَّقْلِ
u'عَدَمٌ نكاح':Added, #7: 7	عَدَمُ النَّقْلِ
u'عَدَمٌ نِكَاحٌ':Added, #1: 1	عَدَمَ النِّكَاحِ
u'عَدَمٌ نكاح':Added, #1: 1	عَدَمَ النِّكَاحِ
u'عَدَمٌ نِكَاحٌ':Added, #3: 3	عَدَمُ النِّكَاحِ
u'عَدَمٌ نكاح':Added, #3: 3	عَدَمُ النِّكَاحِ
u'عَدَمٌ نِكَاحٌ':Added, #7: 7	عَدَمِ النِّكَاحِ
u'عَدَمٌ نَكِيرٌ':Added, #7: 7	عَدَمِ النِّكَاحِ
u'عَدَمٌ نَمَاءٌ':Added, #2: 2	عَدَمِ النَّكِيرِ
u'عَدَمٌ نَمَاءٌ':Added, #1: 1	عَدَمُ النَّمَاءِ
u'عَدَمٌ نُمُوٌّ':Added, #1: 1	عَدَمِ النَّمَاءِ
u'عَدَمٌ نَهْيٌ':Added, #1: 1	عَدَمُ نُمُوٍّ
u'عَدَمٌ نَهْيٌ':Added, #1: 1	عَدَمِ نَهْيِهِ
u'عَدَمٌ نَهْيٌ':Added, #2: 2	عَدَمُ النَّهْيِ
u'عَدَمٌ نَوْعٌ':Added, #8: 8	عَدَمِ النَّهْيِ
u'عَدَمٌ نِيَابَةٌ':Added, #1: 1	عَدَمِ النَّوْعَيْنِ
u'عَدَمٌ نِيَابَةٌ':Added, #1: 1	عَدَمُ النِّيَابَةِ
u'عَدَمٌ نِيَابَةٌ':Added, #1: 1	عَدَمِ النِّيَابَةِ
u'عَدِمَ نِيَّةٌ':Predicate, #1: 1	عَدَمِ نِيَابَتِهِ
u'عَدَمٌ نِيَّةٌ':Added, #1: 1	عَدِمَ النِّيَّةَ
u'عَدَمٌ نِيَّةٌ':Added, #2: 2	عَدَمَ النِّيَّةِ
u'عَدَمٌ نِيَّةٌ':Added, #2: 2	عَدَمِ نِيَّةٍ
u'عَدَمٌ نِيَّةٌ':Added, #31: 31	عَدَمِ النِّيَّةِ
u'عَدَمٌ نِيَّةٌ':Added, #3: 3	عَدَمُ نِيَّةِ
u'عَدَمٌ نِيَّةٌ':Added, #5: 5	عَدَمُ النِّيَّةِ
u'عَدَمٌ هِدَايَةٌ':Added, #8: 8	عَدَمِ نِيَّةِ
u'عَدَمٌ هَدْمٌ':Added, #1: 1	عَدَمُ الْهِدَايَةِ
u'عَدَمٌ هَدْمٌ':Added, #1: 1	عَدَمُ الْهَدْمِ
u'عَدَمٌ هَدْمٌ':Added, #1: 1	عَدَمِ الْهَدْمِ
u'عَدِمَ هَدْيٌ':Predicate, #1: 1	عَدَمِ هَدْمِ
u'عَدِمَ هَدْيٌ':Predicate, #10: 10	عَدِمَ الْهَدْيَ
u'عَدَمٌ هَدْيٌ':Added, #1: 1	عَدِمَ هَدْيَ
u'عَدَمٌ هَدِيٌّ':Added, #1: 1	عَدَمِ الْهَدْيِ
u'عَدَمٌ هَدِيَّةٌ':Added, #2: 2	عَدَمِ الْهَدِيَّةِ
u'عَدَمٌ هلاك':Added, #2: 2	عَدَمِ الْهَدِيَّةِ
u'عَدَمٌ هَلاَكٌ':Added, #1: 1	عَدَمَ الْهَلَاكِ
u'عَدَمٌ هِلاَلٌ':Added, #1: 1	عَدَمَ الْهَلَاكِ
u'عَدِمَ وَاجِبٌ':Predicate, #2: 2	عَدَمَ الْهِلَالِ
u'عَدَمٌ وَارِثٌ':Added, #1: 1	عَدِمَ الْوَاجِبَ
u'عَدَمٌ وَارِثٌ':Added, #1: 1	عَدَمَ الْوَارِثِ
u'عَدَمٌ وَارِثٌ':Added, #3: 3	عَدَمِ وَارِثٍ
u'عَدَمٌ وَاسِطٌ':Added, #9: 9	عَدَمِ الْوَارِثِ
u'عَدَّ مَوَاضِعُ':Predicate, #1: 1	عَدَمُ الْوَاسِطَةِ
u'عَدَمٌ وَالِدٌ':Added, #1: 1	عَدَّ مَوَاضِعَ
u'عَدَمٌ وَالِدٌ':Added, #1: 1	عَدَمَ الْوَالِدِ
u'عَدَمٌ وَاهِبٌ':Added, #2: 2	عَدَمِ الْوَالِدِ
u'عَدَمٌ وُثُوقٌ':Added, #2: 2	عَدَمِ الْوَاهِبِ
u'عَدَمٌ وُثُوقٌ':Added, #2: 2	عَدَمُ الْوُثُوقِ
u'عَدَمٌ وِجْدَانٌ':Added, #3: 3	عَدَمِ الْوُثُوقِ
u'عَدَمٌ وِجْدَانٌ':Added, #1: 1	عَدَمَ الْوِجْدَانِ
u'عَدَمٌ وِجْدَانٌ':Added, #1: 1	عَدَمُ الْوِجْدَانِ
u'عَدَمٌ وِجْدَانٌ':Added, #1: 1	عَدَمُ وِجْدَانِ
u'عَدَمٌ وِجْدَانٌ':Added, #1: 1	عَدَمُ وِجْدَانِهِ
u'عَدَمٌ وُجُوبٌ':Added, #4: 4	عَدَمِ الْوِجْدَانِ
u'عَدَمٌ وُجُوبٌ':Added, #100: 100	عَدَمِ وُجُوبِ
u'عَدَمٌ وُجُوبٌ':Added, #15: 15	عَدَمِ وُجُوبِهِ
u'عَدَمٌ وُجُوبٌ':Added, #18: 18	عَدَمُ وُجُوبِهِ
u'عَدَمٌ وُجُوبٌ':Added, #1: 1	عَدَم وُجُوبِ
u'عَدَمٌ وُجُوبٌ':Added, #28: 28	عَدَمَ الْوُجُوبِ
u'عَدَمٌ وُجُوبٌ':Added, #41: 41	عَدَمِ الْوُجُوبِ
u'عَدَمٌ وُجُوبٌ':Added, #48: 48	عَدَمَ وُجُوبِ
u'عَدَمٌ وُجُوبٌ':Added, #5: 5	عَدَمَ وُجُوبِهِ
u'عَدَمٌ وُجُوبٌ':Added, #72: 72	عَدَمُ وُجُوبِ
u'عَدَمٌ وُجُودٌ':Added, #74: 74	عَدَمُ الْوُجُوبِ
u'عَدَمٌ وُجُودٌ':Added, #10: 10	عَدَمِ وُجُودِ
u'عَدَمٌ وُجُودٌ':Added, #14: 14	عَدَمُ وُجُودِ
u'عَدَمٌ وُجُودٌ':Added, #2: 2	عَدَم وُجُودِ
u'عَدَمٌ وُجُودٌ':Added, #2: 2	عَدَمِ وُجُودِهِ
u'عَدَمٌ وُجُودٌ':Added, #3: 3	عَدَمَ وُجُودِهِ
u'عَدَمٌ وُجُودٌ':Added, #3: 3	عَدَمُ وُجُودِهِ
u'عَدَمٌ وُجُودٌ':Added, #4: 4	عَدَمُ الْوُجُودِ
u'عَدَمٌ وُجُودٌ':Added, #5: 5	عَدَمَ الْوُجُودِ
u'عَدَمٌ وُجُودٌ':Added, #5: 5	عَدَمَ وُجُودِ
u'عَدَمٌ وَحْيٌ':Added, #7: 7	عَدَمِ الْوُجُودِ
u'عَدَمٌ وَرَثَةٌ':Added, #1: 1	عَدَمَ الْوَحْيِ
u'عَدَمٌ وُرُودٌ':Added, #1: 1	عَدَمِ الْوَرَثَةِ
u'عَدَمٌ وُرُودٌ':Added, #1: 1	عَدَمُ الْوُرُودِ
u'عَدَمٌ وُرُودٌ':Added, #1: 1	عَدَمُ وُرُودِهِ
u'عَدَمٌ وُرُودٌ':Added, #2: 2	عَدَمَ وُرُودِ
u'عَدَمٌ وُرُودٌ':Added, #3: 3	عَدَمِ وُرُودِهِ
u'عَدَمٌ وَسَائِلُ':Added, #6: 6	عَدَمُ وُرُودِ
u'عَدَمٌ وُسْعٌ':Added, #1: 1	عَدَمُ الْوَسَائِلِ
u'عَدَمٌ وَصْفٌ':Added, #2: 2	عَدَمِ الْوُسْعِ
u'عَدَمٌ وَصْفٌ':Added, #11: 11	عَدَمِ الْوَصْفِ
u'عَدَمٌ وَصْفٌ':Added, #1: 1	عَدَمِ وَصْفٍ
u'عَدَمٌ وُصُولٌ':Added, #1: 1	عَدَمِ وَصْفِ
u'عَدَمٌ وُصُولٌ':Added, #1: 1	عَدَمَ الْوُصُولِ
u'عَدَمٌ وُصُولٌ':Added, #1: 1	عَدَمَ وُصُولِ
u'عَدَمٌ وُصُولٌ':Added, #1: 1	عَدَمِ وُصُولِهِ
u'عَدَمٌ وُصُولٌ':Added, #3: 3	عَدَمِ الْوُصُولِ
u'عَدَمٌ وُصُولٌ':Added, #3: 3	عَدَمُ وُصُولِ
u'عَدَمٌ وُصُولٌ':Added, #4: 4	عَدَمِ وُصُولِ
u'عَدَمٌ وَصِيٌّ':Added, #5: 5	عَدَمُ الْوُصُولِ
u'عَدَمٌ وَصِيٌّ':Added, #1: 1	عَدَمُ وَصِيٍّ
u'عَدَمٌ وَصِيَّةٌ':Added, #2: 2	عَدَمِ الْوَصِيَّةِ
u'عَدَمٌ وَضْعٌ':Added, #2: 2	عَدَمِ الْوَصِيَّةِ
u'عَدَمٌ وَضْعٌ':Added, #1: 1	عَدَمُ وَضْعٍ
u'عَدَمٌ وَضْعٌ':Added, #1: 1	عَدَمِ وَضْعِ
u'عَدَمٌ وَضْعٌ':Added, #2: 2	عَدَمِ وَضْعِهِ
u'عَدَمٌ وُضُوءٌ':Added, #4: 4	عَدَمُ الْوَضْعِ
u'عَدَمٌ وَطْءٌ':Added, #1: 1	عَدَمُ الْوُضُوءِ
u'عَدَمٌ وَطْءٌ':Added, #1: 1	عَدَم الْوَطْءِ
u'عَدَمٌ وَطْءٌ':Added, #1: 1	عَدَمَ وَطْءٍ
u'عَدَمٌ وَطْءٌ':Added, #1: 1	عَدَمُ وَطْءِ
u'عَدَمٌ وَطْءٌ':Added, #4: 4	عَدَمِ الْوَطْءِ
u'عَدَمٌ وَطْءٌ':Added, #7: 7	عَدَمَ الْوَطْءِ
u'عَدَمٌ وَفَاءٌ':Added, #8: 8	عَدَمُ الْوَطْءِ
u'عَدَمٌ وَفَاءٌ':Added, #4: 4	عَدَمُ الْوَفَاءِ
u'عَدَمٌ وَفَاءٌ':Added, #5: 5	عَدَمَ الْوَفَاءِ
u'عَدَمٌ وقع':Added, #6: 6	عَدَمِ الْوَفَاءِ
u'عَدَمٌ وَقْعٌ':Added, #1: 1	عَدَمِ الْوَقْعِ
u'عَدَمٌ وَقْفٌ':Added, #1: 1	عَدَمِ الْوَقْعِ
u'عَدَمٌ وَقْفٌ':Added, #1: 1	عَدَمُ الْوَقْفِ
u'عَدَمٌ وَقْفٌ':Added, #1: 1	عَدَمِ الْوَقْفِ
u'عَدَمٌ وَقْفٌ':Added, #1: 1	عَدَمُ وَقْفِ
u'عَدَمٌ وَقْفٌ':Added, #2: 2	عَدَمِ وَقْفِ
u'عَدَمٌ وُقُوعٌ':Added, #2: 2	عَدَمِ وَقْفِهِ
u'عَدَمٌ وُقُوعٌ':Added, #10: 10	عَدَمُ وُقُوعِ
u'عَدَمٌ وُقُوعٌ':Added, #11: 11	عَدَمَ وُقُوعِ
u'عَدَمٌ وُقُوعٌ':Added, #14: 14	عَدَمِ وُقُوعِ
u'عَدَمٌ وُقُوعٌ':Added, #1: 1	عَدَم وُقُوعِهِ
u'عَدَمٌ وُقُوعٌ':Added, #23: 23	عَدَمِ الْوُقُوعِ
u'عَدَمٌ وُقُوعٌ':Added, #25: 25	عَدَمَ الْوُقُوعِ
u'عَدَمٌ وُقُوعٌ':Added, #2: 2	عَدَم الْوُقُوعِ
u'عَدَمٌ وُقُوعٌ':Added, #35: 35	عَدَمُ الْوُقُوعِ
u'عَدَمٌ وُقُوعٌ':Added, #6: 6	عَدَمَ وُقُوعِهِ
u'عَدَمٌ وُقُوعٌ':Added, #7: 7	عَدَمُ وُقُوعِهِ
u'عَدَمٌ وُقُوفٌ':Added, #7: 7	عَدَمِ وُقُوعِهِ
u'عَدَمٌ وُقُوفٌ':Added, #1: 1	عَدَمُ وُقُوفِهِ
u'عَدَمٌ وَلاَءٌ':Added, #3: 3	عَدَمِ الْوُقُوفِ
u'عَدَمٌ وِلاَدَةٌ':Added, #2: 2	عَدَمِ الْوَلَاءِ
u'عَدَمٌ وِلاَدَةٌ':Added, #1: 1	عَدَمِ وِلَادَتِهِ
u'عَدَمٌ وِلاَيَةٌ':Added, #3: 3	عَدَمُ الْوِلَادَةِ
u'عَدَمٌ وِلاَيَةٌ':Added, #1: 1	عَدَمُ الْوِلَايَةِ
u'عَدَمٌ وِلاَيَةٌ':Added, #1: 1	عَدَمُ وِلَايَتِهِ
u'عَدَمٌ وِلاَيَةٌ':Added, #2: 2	عَدَمِ وِلَايَةِ
u'عَدِمَ ولد':Subject, #2: 2	عَدَمِ وِلَايَتِهِ
u'عَدِمَ وَلَدٌ':Subject, #1: 1	عَدِمَ الْوَلَدُ
u'عَدَمٌ ولد':Added, #1: 1	عَدِمَ الْوَلَدُ
u'عَدَمٌ وَلَدٌ':Added, #10: 10	عَدَمِ الْوَلَدِ
u'عَدَمٌ ولد':Added, #10: 10	عَدَمِ الْوَلَدِ
u'عَدَمٌ وَلَدٌ':Added, #1: 1	عَدَمَ الْوَلَدِ
u'عَدَمٌ وَلَدٌ':Added, #1: 1	عَدَمَ الْوَلَدِ
u'عَدَمٌ ولد':Added, #1: 1	عَدَمِ وَلَدٍ
u'عَدَمٌ وَلَدٌ':Added, #1: 1	عَدَمِ وَلَدِهِ
u'عَدَمٌ ولد':Added, #1: 1	عَدَمِ وَلَدِهِ
u'عَدَمٌ وَلَدٌ':Added, #3: 3	عَدَمِ وَلَدِ
u'عَدَمٌ وُلُوغ':Added, #3: 3	عَدَمِ وَلَدِ
u'عَدَمٌ وَلِيٌّ':Added, #1: 1	عَدَمُ الْوُلُوغِ
u'عَدَمٌ وَلِيٌّ':Added, #1: 1	عَدَمِ وَلِيِّهِ
u'عَدَمٌ يَأْسٌ':Added, #8: 8	عَدَمِ الْوَلِيِّ
u'عَدَمٌ يَدٌ':Added, #1: 1	عَدَمِ الْيَأْسِ
u'عَدَمٌ يَدٌ':Added, #1: 1	عَدَمَ يَدِ
u'عَدَمٌ يَسَارَةٌ':Added, #2: 2	عَدَمِ الْيَدِ
u'عَدَمٌ يَقِينٌ':Added, #1: 1	عَدَمِ يَسَارَةِ
u'عَدَمٌ يَمِينٌ':Added, #1: 1	عَدَمُ الْيَقِينِ
u'عَدَمٌ يَمِينٌ':Added, #1: 1	عَدَمَ يَمِينِهِ
u'عَدَّ نَبِيٌّ':Subject, #2: 2	عَدَمَ الْيَمِينِ
u'عَدَّ نَحْوٌ':Predicate, #1: 1	عَدَّ النَّبِيُّ
u'عُدْوَانٌ أسْوَد':Added, #1: 1	عَدَّ نَحْوَ
u'عَدْوٌ فَرَسٌ':Added, #1: 1	عُدْوَانُ الْأَسْوَدِ
u'عَدْوٌ كَلْبٌ':Added, #1: 1	عَدْوِ الْفَرَسِ
u'عُدُولٌ أَحْرارٌ':Added, #1: 1	عَدْوُ كَلْبِهِ
u'عُدُولٌ إمَامٌ':Added, #2: 2	عُدُولٍ أَحْرَارٍ
u'عُدُولٌ حاكِمٌ':Added, #1: 1	عُدُولِ الْإِمَامِ
u'عُدُولٌ رُوَاةٌ':Added, #1: 1	عُدُولَ الْحَاكِمِ
u'عُدُولٌ شُهُودٌ':Added, #1: 1	عُدُولِ الرُّوَاةِ
u'عُدُولٌ قَادِرٌ':Added, #1: 1	عُدُولِ الشُّهُودِ
u'عُدُولٌ كُفَّارٌ':Added, #2: 2	عُدُولُ الْقَادِرِ
u'عُدُولٌ كُفَّارٌ':Added, #1: 1	عُدُولَ الْكُفَّارِ
u'عُدُولٌ مُحَقِّقٌ':Added, #1: 1	عُدُولِ الْكُفَّارِ
u'عُدُولٌ مُصَنِّفٌ':Added, #1: 1	عُدُولِ الْمُحَقِّقِ
u'عُدُولٌ نِساءٌ':Added, #1: 1	عُدُولِ الْمُصَنِّفِ
u'عَدْوٌ وَالِهٌ':Added, #1: 1	عُدُولِ النِّسَاءِ
u'عَدْوَى بَليدٌ':Added, #1: 1	عَدْوَ الْوَالِهِ
u'عَدَّى بَلَدِيٌّ':Subject, #1: 1	عَدْوَى الْبَلِيدِ
u'عَدَّى حَنَفِيَّةٌ':Subject, #3: 3	عَدَّى الْبَلَدِيُّ
u'عَدَّ يَوْمٌ':Predicate, #1: 1	عَدَّى الْحَنَفِيَّةُ
u'عَذَّبَ أهْلٌ':Predicate, #1: 1	عَدَّ يَوْمَ
u'عَذْبٌ جَارٌ':Added, #5: 5	عَذَّبَ أَهْلَ
u'عَذُبَ شَيْءٌ':Subject, #1: 1	عَذْبٍ جَارٍ
u'عَذْبٌ طَعْمٌ':Added, #1: 1	عَذُبَ الشّيْءُ
u'عَذْبٌ كَلاَمٌ':Added, #1: 1	عَذْبَ الطَّعْمِ
u'عَذْبٌ مَاءٌ':Added, #1: 1	عَذْبِ الْكَلَامِ
u'عَذَرَ مُغْتاب':Subject, #1: 1	عَذْبَ الْمَاءِ
u'عَذَرَ ناسِي':Predicate, #1: 1	عَذَرَ الْمُغْتَابُ
u'عَذْقٌ مُذَلَّلٌ':Added, #1: 1	عَذَرَ النَّاسِيَ
u'عَذْقٌ مَلِكٌ':Added, #2: 2	عَذْقٍ مُذَلَّلٍ
u'عَذْقٌ مَلِكٌ':Added, #1: 1	عَذْق الْمَلِكِ
u'عَذْقٌ نخلة':Added, #1: 1	عَذْقِ الْمَلِكِ
u'عَذْقٌ نَخْلَةٌ':Added, #1: 1	عَذْقِ نَخْلَةٍ
u'عذل عَاذِلٌ':Added, #1: 1	عَذْقِ نَخْلَةٍ
u'عَذْلٌ عَاذِلٌ':Added, #1: 1	عَذْلُ عَاذِلٍ
u'عُذُوبَةٌ مَوْرِدٌ':Added, #1: 1	عَذْلُ عَاذِلٍ
u'عراض خَيْلٌ':Added, #1: 1	عُذُوبَةِ الْمَوْرِدِ
u'عراض مَسْجِدٌ':Added, #1: 1	أَعْرَاضِ الْخَيْلِ
u'عراض نَاسٌ':Added, #1: 1	أَعْرَاضِ الْمَسْجِدِ
u'عراض نَاسٌ':Added, #1: 1	أَعْرَاضَ النَّاسِ
u'عراض وُجُوهٌ':Added, #3: 3	أَعْرَاضِ النَّاسِ
u'عِرَاضٌ وُجُوهٌ':Added, #1: 1	عِرَاضُ الْوُجُوهِ
u'عراض وُجُوهٌ':Added, #1: 1	عِرَاضُ الْوُجُوهِ
u'عِرَاضٌ وُجُوهٌ':Added, #2: 2	عِرَاضَ الْوُجُوهِ
u'عَرَا عَقْدٌ':Subject, #2: 2	عِرَاضَ الْوُجُوهِ
u'عَرَا كَلاَمٌ':Subject, #1: 1	عَرَا الْعَقْدُ
u'عَرِبَ بَطْنٌ':Subject, #1: 1	عَرَا الْكَلَامُ
u'عَرَّبَ عِرَابٌ':Predicate, #2: 2	عَرِبَ بَطْنُهُ
u'عَرِبَ هاء':Predicate, #1: 1	عَرَّبَ الْعِرَابَ
u'عَرِجَ شَدِيدٌ':Predicate, #1: 1	أَعْرَبَ الْهَاءَ
u'عَرَّسَ رَسُولٌ':Subject, #2: 2	أَعْرَجَ شَدِيدَ
u'عَرَّسَ قُرْبٌ':Predicate, #5: 5	عَرَّسَ رَسُولُ
u'عَرْشٌ رَحْمَن':Added, #1: 1	عَرَّسَ قُرْبَ
u'عَرْشٌ رَحْمَن':Added, #1: 1	عَرْشُ الرّحْمَنِ
u'عَرْشٌ فلان':Added, #7: 7	عَرْشُ الرَّحْمَنِ
u'عَرْشٌ فلان':Added, #1: 1	عَرْشُ الرّحْمَنِ
u'عَرَضَ اِبْنٌ':Subject, #7: 7	عَرْشُ الرَّحْمَنِ
u'عَرْضٌ اِبْنٌ':Added, #1: 1	عَرَضَ ابْنُ
u'عَرْضٌ إجَارَةٌ':Added, #4: 4	عَرْضِ ابْنِهِ
u'عَرْضٌ أَدِيمٌ':Added, #1: 1	عَرْضِ الْإِجَارَةِ
u'عَرَضَ إِسْلامٌ':Predicate, #1: 1	عَرْضِ الْأَدِيمِ
u'عَرْضٌ إِسْلامٌ':Added, #1: 1	عَرَضَ الْإِسْلَامَ
u'عَرْضٌ إِسْلامٌ':Added, #17: 17	عَرْضِ الْإِسْلَامِ
u'عَرْضٌ إِسْلامٌ':Added, #1: 1	عَرْضَ الْإِسْلَامِ
u'عَرْضٌ أسْنَانٌ':Added, #6: 6	عَرْضُ الْإِسْلَامِ
u'عَرْضٌ أسْنَانٌ':Added, #1: 1	عَرْضُ الْأَسْنَانِ
u'عَرَضَ اِشْتِراكٌ':Subject, #2: 2	عَرْضَ أَسْنَانِهِ
u'عَرْضٌ أُصْبُعٌ':Added, #1: 1	عَرَضَ اشْتِرَاكٌ
u'عَرَضَ أعْرَابِيٌّ':Subject, #1: 1	عَرْضِ الْأُصْبُعِ
u'عَرْضٌ أَقْوَالٌ':Added, #1: 1	عَرَضَ أَعْرَابِيٌّ
u'عَرَضَ أَمْرٌ':Predicate, #1: 1	عَرْضِ أَقْوَالِهِ
u'عَرَضَ إِنْسانٌ':Subject, #1: 1	عَرَضَ الْأَمْرَ
u'عَرْضٌ أَنْفٌ':Added, #2: 2	عَرَضَ إنْسَانٌ
u'عَرَضَ اِنْفِساخٌ':Subject, #1: 1	عَرْضِ أَنْفِهِ
u'عَرَضَ أهْلٌ':Subject, #1: 1	عَرَضَ انْفِسَاخٌ
u'عَرَضَ أَيْمَانٌ':Predicate, #1: 1	عَرَضَ أَهْلُ
u'عَرْضٌ بَابٌ':Added, #1: 1	عَرَضَ الْأَيْمَانَ
u'عَرْضٌ بَابٌ':Added, #1: 1	عَرْضَ الْبَابِ
u'عَرْضٌ بَابٌ':Added, #1: 1	عَرْضُ الْبَابِ
u'عَرْضٌ بَابٌ':Added, #1: 1	عَرْضُ بَابِ
u'عَرْضٌ بَابٌ':Added, #2: 2	عَرْضَ بَابِ
u'عَرْضٌ بَابٌ':Added, #3: 3	عَرْضِ بَابِ
u'عَرْضٌ بَائِعٌ':Added, #7: 7	عَرْضِ الْبَابِ
u'عَرَضَ بَرْدٌ':Subject, #1: 1	عَرْضِ الْبَائِعِ
u'عَرَضَ بَعْضٌ':Predicate, #1: 1	عَرَضَ بَرْدُ
u'عَرْضٌ بَلَدٌ':Added, #1: 1	عَرَضَ بَعْضَ
u'عَرْضٌ بَيْتٌ':Added, #1: 1	عَرْضُ الْبَلَدَيْنِ
u'عَرْضٌ تِجَارَةٌ':Added, #1: 1	عَرْضِ الْبَيْتِ
u'عَرْضٌ تِجَارَةٌ':Added, #1: 1	عَرْضُ التِّجَارَةِ
u'عَرْضٌ تِجَارَةٌ':Added, #2: 2	عَرْضَ التِّجَارَةِ
u'عَرْضٌ تِجَارَةٌ':Added, #2: 2	عَرْضِ تِجَارَةٍ
u'عَرْضٌ تِجَارَةٌ':Added, #3: 3	عَرْضُ تِجَارَةٍ
u'عَرْضٌ تِجَارَةٌ':Added, #7: 7	عَرْضِ التِّجَارَةِ
u'عَرْضٌ تِسْعَةٌ':Added, #8: 8	عَرْضَ تِجَارَةٍ
u'عَرْضٌ تَوْبَةٌ':Added, #1: 1	عَرْضِ تِسْعَةِ
u'عَرْضٌ جِدار':Added, #1: 1	عَرْضُ التَّوْبَةِ
u'عَرْضٌ جَسَدٌ':Added, #1: 1	عَرْضِ جِدَارِ
u'عَرْضٌ جَيْشٌ':Added, #1: 1	عَرْضَ جَسَدِ
u'عَرْضٌ حائِطٌ':Added, #1: 1	عَرْضُ الْجَيْشِ
u'عَرَضَ حَبَشِيٌّ':Subject, #1: 1	عَرْضَ الْحَائِطِ
u'عَرْضٌ حَديثٌ':Added, #1: 1	عَرَضَ حَبَشِيٌّ
u'عَرْضٌ حَديثٌ':Added, #1: 1	عَرْضُ الْحَدِيثِ
u'عَرَضَ حَيْضٌ':Subject, #2: 2	عَرْضِ حَدِيثِهِ
u'عَرْضٌ خَبَرٌ':Added, #1: 1	عَرَضَ الْحَيْضُ
u'عَرْضٌ خَبَر':Added, #1: 1	عَرْضُ الْخَبَرِ
u'عَرْضٌ خرقة':Added, #1: 1	عَرْضُ الْخَبَرِ
u'عَرْضٌ خِرْقَةٌ':Added, #1: 1	عَرْضِ الْخِرْقَةِ
u'عَرَضَ خَفَقَانٌ':Subject, #1: 1	عَرْضِ الْخِرْقَةِ
u'عَرْضٌ خَمْسَةٌ':Added, #1: 1	عَرَضَ الْخَفَقَانُ
u'عَرَضَ دَارٌ':Predicate, #1: 1	عَرْضِ خَمْسَةٍ
u'عَرْضٌ دُخُولٌ':Added, #2: 2	عَرَضَ الدَّارَ
u'عَرْضٌ ذِراعٌ':Added, #2: 2	عَرْضِ الدُّخُولِ
u'عَرَضَ ذِئْبٌ':Subject, #1: 1	عَرْضِ ذِرَاعٍ
u'عَرَضَ رَجُلٌ':Subject, #1: 1	عَرَضَ ذِئْبٌ
u'عَرَضَ رَجُلٌ':Subject, #1: 1	عَرَضَ الرَّجُلُ
u'عَرْضٌ رَجُلٌ':Added, #2: 2	عَرَضَ رَجُلٌ
u'عَرَضَ رَسُولٌ':Subject, #1: 1	عَرْضُ الرَّجُلِ
u'عَرْضٌ رَسُولٌ':Added, #1: 1	عَرَضَ رَسُولُ
u'عَرَضَ زَوالٌ':Subject, #1: 1	عَرْضُ رَسُولِ
u'عَرْضٌ سَاقِي':Added, #1: 1	عَرَضَ زَوَالُ
u'عَرْضٌ سَاقِيَةٌ':Added, #1: 1	عَرْضَ السَّاقِيَةِ
u'عَرْضٌ سَبْعَةٌ':Added, #1: 1	عَرْضَ السَّاقِيَةِ
u'عَرْضٌ سترة':Added, #1: 1	عَرْضِ سَبْعَةِ
u'عَرْضٌ سُتْرَةٌ':Added, #1: 1	عَرْضُ السُّتْرَةِ
u'عَرَضَ سُلْطَانٌ':Subject, #1: 1	عَرْضُ السُّتْرَةِ
u'عَرْضٌ سَنَةٌ':Added, #1: 1	عَرَضَ السُّلْطَانُ
u'عَرَضَ شَاعِر':Subject, #1: 1	عَرْضِ السَّنَةِ
u'عَرَضَ شَاعِر':Subject, #1: 1	عَرَضَ شََاعِرٌ
u'عَرْضٌ شَخْصٌ':Added, #2: 2	عَرَضَ شَاعِرٌ
u'عَرَضَ شَكٌّ':Subject, #1: 1	عَرْضُ شَخْصَيْنِ
u'عَرَضَ شَكٌّ':Subject, #1: 1	عَرَضَ شَكٌّ
u'عَرَضَ شَكٌّ':Subject, #1: 1	عَرَضَ شَكُّهُ
u'عَرْضٌ شَيْءٌ':Added, #2: 2	عَرَضَ الشَّكُّ
u'عَرَضَ شَيْطَانٌ':Subject, #2: 2	عَرْضِ الشَّيْءِ
u'عَرَضَ صَالِحٌ':Subject, #2: 2	عَرَضَ الشَّيْطَانُ
u'عَرَضَ صَالِح':Subject, #1: 1	عَرَضَ صَالِحُ
u'عَرْضٌ صداق':Added, #1: 1	عَرَضَ صَالِحُ
u'عَرْضٌ صَدَاقٌ':Added, #1: 1	عَرْضَ الصَّدَاقِ
u'عَرَضَ صَيْدٌ':Subject, #1: 1	عَرْضَ الصَّدَاقِ
u'عَرْضٌ طَرِيقٌ':Added, #1: 1	عَرَضَ صَيْدٌ
u'عَرْضٌ طَرِيقٌ':Added, #1: 1	عَرْضُ الطَّرِيقِ
u'عَرْضٌ طَرِيقٌ':Added, #1: 1	عَرْضِ الطَّرِيقِ
u'عَرَضَ طِينَةٌ':Predicate, #2: 2	عَرْضَ الطَّرِيقِ
u'عَرَضَ عَارِضٌ':Subject, #1: 1	عَرَضَ الطِّينَةَ
u'عَرَضَ عَدَمٌ':Subject, #2: 2	عَرَضَ عَارِضٌ
u'عَرَضَ عُطاس':Subject, #1: 1	عَرَضَ عَدَمُ
u'عَرَضَ عين':Predicate, #1: 1	عَرَضَ عُطَاسٌ
u'عَرَضَ عَيْنٌ':Predicate, #1: 1	عَرَضَ الْعَيْنَ
u'عَرَضَ عَيْن':Predicate, #1: 1	عَرَضَ الْعَيْنَ
u'عَرَّضَ غير':Subject, #1: 1	عَرَضَ الْعَيْنَ
u'عَرَّضَ غَيْرٌ':Subject, #1: 1	عَرَّضَ غَيْرُ
u'عَرْضٌ فِدَاءٌ':Added, #1: 1	عَرَّضَ غَيْرُ
u'عَرَضَ فَوَاتٌ':Subject, #1: 1	عَرْضِ الْفِدَاءِ
u'عَرْضٌ قَبْرٌ':Added, #1: 1	عَرَضَ فَوَاتُ
u'عَرْضٌ قَبْرٌ':Added, #1: 1	عَرْضَ الْقَبْرِ
u'عَرْضٌ قِرَاءةٌ':Added, #1: 1	عَرْضِ الْقَبْرِ
u'عَرْضٌ قِصَصٌ':Added, #1: 1	عَرْضَ الْقِرَاءَةِ
u'عَرَضَ قَوْمٌ':Subject, #1: 1	عَرْضَ الْقِصَصِ
u'عَرَضَ كِتَابٌ':Predicate, #1: 1	عَرَضَ قَوْمٌ
u'عَرَضَ كَسَادٌ':Subject, #1: 1	عَرَضَ الْكِتَابَ
u'عَرْضٌ كَفٌّ':Added, #1: 1	عَرَضَ كَسَادٌ
u'عَرْضٌ لِحْيَةٌ':Added, #4: 4	عَرْضِ الْكَفِّ
u'عَرَضَ مَاءٌ':Predicate, #1: 1	عَرْضِ لِحْيَتِهِ
u'عَرْضٌ مَالٌ':Added, #1: 1	عَرَضَ الْمَاءَ
u'عَرَضَ مَانِعٌ':Subject, #2: 2	عَرْضِ مَالِ
u'عَرَضَ مَبِيعٌ':Predicate, #1: 1	عَرَضَ مَانِعٌ
u'عَرَضَ مثل':Subject, #5: 5	عَرَضَ الْمَبِيعَ
u'عَرَضَ مِثْلٌ':Subject, #1: 1	عَرَضَ مِثْلُ
u'عَرَّضَ مَدْيُونٌ':Subject, #1: 1	عَرَضَ مِثْلُ
u'عَرْضٌ مَسْجِدٌ':Added, #1: 1	عَرَّضَ الْمَدْيُونُ
u'عَرْضٌ مُسْلِمٌ':Added, #1: 1	عَرْضِ الْمَسْجِدِ
u'عَرَضَ مُصْحَفٌ':Predicate, #1: 1	عَرْضِ الْمُسْلِمِ
u'عَرْضٌ مِعْراض':Added, #1: 1	عَرَضَ الْمُصْحَفَ
u'عَرْضٌ مَعْلُومٌ':Added, #1: 1	عَرْضُ الْمِعْرَاضِ
u'عَرْضٌ مُعَيَّنٌ':Added, #1: 1	عَرْضٍ مَعْلُومٍ
u'عَرْضٌ مُفَادٌ':Added, #1: 1	عَرْضٍ مُعَيَّنٍ
u'عَرْضٌ مَفْصِلٌ':Added, #2: 2	عَرْضٍ مُفَادٍ
u'عَرْضٌ مُناوَلَة':Added, #1: 1	عَرْضِ الْمَفْصِلِ
u'عَرَضَ مُهِمٌّ':Subject, #1: 1	عَرْضَ الْمُنَاوَلَةِ
u'عَرَضَ مُوجِبٌ':Subject, #1: 1	عَرَضَ مُهِمٌّ
u'عَرْضٌ مُؤَجَّلٌ':Added, #1: 1	عَرَضَ مُوجِبُ
u'عَرْضٌ مَوْصُوفٌ':Added, #1: 1	عَرْضٍ مُؤَجَّلٍ
u'عَرْضٌ مَوْضِعٌ':Added, #1: 1	عَرْضٍ مَوْصُوفٍ
u'عَرْضٌ نَاسٌ':Added, #1: 1	عَرْضُ مَوْضِعِ
u'عَرْضٌ نَسَبٌ':Added, #4: 4	عَرْضِ النَّاسِ
u'عَرَضَ نِصْفٌ':Predicate, #1: 1	عَرْضِ النَّسَبِ
u'عَرْضٌ نَفْسٌ':Added, #1: 1	عَرَضَ نِصْفَ
u'عَرْضٌ نقلة':Added, #1: 1	عَرْضُ نَفْسِهِ
u'عَرْضٌ نَهْرٌ':Added, #1: 1	عَرْضُ نَقْلَةٍ
u'عَرْضٌ نَهْرٌ':Added, #1: 1	عَرْضَ النَّهْرِ
u'عَرْضٌ نِيلٌ':Added, #3: 3	عَرْضِ النَّهْرِ
u'عَرْضٌ نَيْلٌ':Added, #1: 1	عَرْضُ النّيلِ
u'عَرَضَ هلاك':Subject, #1: 1	عَرْضُ النّيلِ
u'عَرَضَ هَلاَكٌ':Subject, #1: 1	عَرَضَ الْهَلَاكُ
u'عَرْضٌ واحد':Added, #1: 1	عَرَضَ الْهَلَاكُ
u'عَرْضٌ وَاحِدٌ':Added, #1: 1	عَرْضٍ وَاحِدٍ
u'عَرْضٌ وَجْهٌ':Added, #1: 1	عَرْضٍ وَاحِدٍ
u'عَرْضٌ وَجْهٌ':Added, #1: 1	عَرْضَ الْوَجْهِ
u'عَرَضَ يَمِينٌ':Predicate, #2: 2	عَرْضِ الْوَجْهِ
u'عَرْضٌ يَمِينٌ':Added, #1: 1	عَرَضَ الْيَمِينَ
u'عَرَفَ اِتِّفَاقٌ':Predicate, #7: 7	عَرْضِ الْيَمِينِ
u'عَرَفَ أَجْنَبِيٌّ':Subject, #1: 1	عَرَفَ اتِّفَاقَ
u'عَرَفَ أحَدٌ':Subject, #2: 2	عَرَفَ الْأَجْنَبِيُّ
u'عَرَفَ أَحْكَامٌ':Predicate, #1: 1	عَرَفَ أَحَدُ
u'عَرَفَ آخِرَةٌ':Predicate, #1: 1	عَرَفَ أَحْكَامَ
u'عَرَفَ أرْبَابٌ':Subject, #1: 1	عَرَفَ الْآخِرَةَ
u'عَرَفَ اِسْتِمْرارٌ':Predicate, #4: 4	عَرَفَ أَرْبَابُهُ
u'عَرَفَ اِسْتِناد':Predicate, #1: 1	عَرَفَ اسْتِمْرَارَ
u'عَرَفَ أسْعَارٌ':Predicate, #1: 1	عَرَفَ اسْتِنَادَ
u'عَرَفَ إِسْلامٌ':Predicate, #2: 2	عَرَفَ الْأَسْعَارَ
u'عَرَفَ إِسْلامٌ':Predicate, #1: 1	عَرَفَ الإِسْلاَمَ
u'عَرَفَ إشارَة':Predicate, #2: 2	عَرَفَ الْإِسْلَامَ
u'عَرَفَ أَشْيَاءٌ':Predicate, #1: 1	عَرَفَ الْإِشَارَةَ
u'عَرَفَ أَصْلِيٌّ':Predicate, #1: 1	عَرَفَ الْأَشْيَاءَ
u'عَرَفَ أُصولٌ':Predicate, #1: 1	عَرَفَ الْأَصْلِيَّ
u'عَرَفَ أَقَاوِيلُ':Predicate, #4: 4	عَرَفَ الْأُصُولَ
u'عَرَفَ أكل':Predicate, #2: 2	عَرَفَ أَقَاوِيلَ
u'عَرَفَ أَكْلٌ':Predicate, #1: 1	عَرَفَ أَكْلَ
u'عَرَفَ الْمَرْءُ':Subject, #1: 1	عَرَفَ أَكْلَ
u'عَرَفَ إمَامٌ':Subject, #1: 1	عَرَفَ الْمَرْءُ
u'عِرْفَانٌ أَفْرَادٌ':Added, #4: 4	عَرَفَ الْإِمَامُ
u'عِرْفَانٌ حُكْمٌ':Added, #1: 1	عِرْفَانِ أَفْرَادِ
u'عِرْفَانٌ وَزْنٌ':Added, #1: 1	عِرْفَانَ الْحُكْمِ
u'عَرَفَ أهْلٌ':Subject, #1: 1	عِرْفَانَ وَزْنِهِ
u'عَرَفَ أَوَّلُ':Predicate, #3: 3	عَرَفَ أَهْلُ
u'عَرَفَ أيَّامٌ':Predicate, #1: 1	عَرَفَ الْأَوَّلَ
u'عَرَفَ أَيَّامٌ':Predicate, #1: 1	عَرَفَ الْأَيَّامَ
u'عَرَفَ بَائِعٌ':Predicate, #1: 1	عَرَفَ الْأَيَّامَ
u'عَرَفَ بَائِعٌ':Subject, #1: 1	عَرَفَ الْبَائِعَ
u'عَرَفَ بَعْضٌ':Predicate, #1: 1	عَرَفَ الْبَائِعُ
u'عَرَفَ بَعْضٌ':Subject, #4: 4	عَرَفَ بَعْضَ
u'عَرَفَ تَحْرِيمٌ':Predicate, #1: 1	عَرَفَ بَعْضٌ
u'عَرَّفَ تَطَيُّبٌ':Predicate, #1: 1	عَرَفَ التَّحْرِيمَ
u'عَرَفَ تَغْيِيرٌ':Predicate, #1: 1	عَرَّفَ التَّطَيُّبَ
u'عَرَفَ تَفْسِيرٌ':Predicate, #1: 1	عَرَفَ تَغْيِيرَ
u'عَرَفَ تَنَاكُحٌ':Predicate, #1: 1	عَرَفَ التَّفْسِيرَ
u'عَرَّفَ ثَانِي':Predicate, #1: 1	عَرَفَ تَنَاكُحَ
u'عَرَفَ جَارِحٌ':Subject, #1: 1	عَرَّفَ الثَّانِيَ
u'عَرَفَ جَارِي':Predicate, #1: 1	عَرَفَ الْجَارِحُ
u'عَرَفَ جَمَلٌ':Predicate, #2: 2	عَرَفَ جَارِيَةً
u'عرف جَنَّةٌ':Added, #1: 1	عَرَفَ جَمَلاً
u'عَرْفٌ جَنَّةٌ':Added, #3: 3	عَرْفَ الْجَنَّةِ
u'عَرَفَ حالٌ':Predicate, #3: 3	عَرْفَ الْجَنَّةِ
u'عَرَفَ حُدودٌ':Predicate, #2: 2	عَرَفَ الْحَالَ
u'عَرَفَ حَديثٌ':Predicate, #1: 1	عَرَفَ الْحُدُودَ
u'عَرَفَ حِراسَةٌ':Predicate, #1: 1	عَرَفَ الْحَدِيثَ
u'عَرَفَ حَقٌّ':Predicate, #1: 1	عَرَفَ حِرَاسَةَ
u'عَرَفَ حَقٌّ':Predicate, #14: 14	عَرَفَ الْحَقَّ
u'عَرَفَ حَقِيقٌ':Predicate, #1: 1	عَرَفَ حَقَّ
u'عَرَفَ حَقِيقَةٌ':Predicate, #4: 4	عَرَفَ حَقِيقَةَ
u'عَرَفَ حُكْمٌ':Predicate, #4: 4	عَرَفَ حَقِيقَةَ
u'عَرَفَ حُكْمٌ':Predicate, #2: 2	عَرَفَ الْحُكْمَ
u'عَرَفَ حَوَّاءُ':Predicate, #2: 2	عَرَفَ حُكْمَ
u'عَرَفَ حَيٌّ':Predicate, #1: 1	عَرَفَ حَوَّاءَ
u'عَرَفَ خُرُوجٌ':Predicate, #1: 1	عَرَفَ الْحَيَّ
u'عَرَفَ دُخُولٌ':Predicate, #1: 1	عَرَفَ خُرُوجَ
u'عَرَّفَ دِرْهَمٌ':Predicate, #1: 1	عَرَفَ دُخُولَ
u'عَرَّفَ دِرْهَم':Predicate, #2: 2	عَرَّفَ الدِّرْهَمَ
u'عَرَفَ دَلالَةٌ':Predicate, #2: 2	عَرَّفَ الدِّرْهَمَ
u'عَرَفَ دَليلٌ':Predicate, #1: 1	عَرَفَ الدَّلَالَةَ
u'عَرَفَ رَاجِحٌ':Predicate, #1: 1	عَرَفَ دَلِيلَ
u'عَرَفَ رَجُلٌ':Predicate, #1: 1	عَرَفَ الرَّاجِحَ
u'عَرَفَ رَجُلٌ':Subject, #2: 2	عَرَفَ الرَّجُلَ
u'عَرَفَ رَجُلٌ':Subject, #1: 1	عَرَفَ الرَّجُلُ
u'عَرَفَ رَدٌّ':Predicate, #1: 1	عَرَفَ رَجُلٌ
u'عَرَفَ رَسُولٌ':Predicate, #1: 1	عَرَفَ رَدَّ
u'عَرَفَ رَسُولٌ':Predicate, #1: 1	عَرَفَ الرّسُولَ
u'عَرَفَ رَسُولٌ':Subject, #2: 2	عَرَفَ رَسُولَ
u'عَرَفَ رُكْنٌ':Predicate, #2: 2	عَرَفَ رَسُولُ
u'عَرَفَ رُكْن':Predicate, #1: 1	عَرَفَ الرُّكْنَ
u'عَرَفَ رَمْيٌ':Predicate, #1: 1	عَرَفَ الرُّكْنَ
u'عَرَفَ روحٌ':Predicate, #1: 1	عَرَفَ الرَّمْيَ
u'عَرَفَ رَوْحٌ':Predicate, #1: 1	عَرَفَ الرّوحَ
u'عَرَفَ زائِدٌ':Predicate, #1: 1	عَرَفَ الرّوحَ
u'عَرَفَ سَابِقٌ':Predicate, #1: 1	عَرَفَ الزَّائِدَ
u'عَرَفَ سَابِقٌ':Subject, #3: 3	عَرَفَ السَّابِقَ
u'عَرَفَ سَعْدٌ':Subject, #1: 1	عَرَفَ السَّابِقُ
u'عَرَفَ سعر':Predicate, #1: 1	عَرَفَ سَعْدٌ
u'عَرَفَ سِعْرٌ':Predicate, #1: 1	عَرَفَ السِّعْرَ
u'عَرَّفَ سَنَةٌ':Predicate, #1: 1	عَرَفَ السِّعْرَ
u'عَرَفَ شَاهِدٌ':Predicate, #1: 1	عَرَّفَ السَّنَةَ
u'عَرَفَ شَاهِدٌ':Subject, #1: 1	عَرَفَ الشَّاهِدَ
u'عَرَفَ شَخْصٌ':Subject, #1: 1	عَرَفَ الشَّاهِدُ
u'عَرَفَ شَرْطٌ':Predicate, #1: 1	عَرَفَ شَخْصٌ
u'عَرَّفَ شَهْرٌ':Predicate, #1: 1	عَرَفَ شَرْطَ
u'عَرَفَ شُهُودٌ':Predicate, #1: 1	عَرَّفَ الشَّهْرَ
u'عَرَفَ شُهُودٌ':Subject, #1: 1	عَرَفَ الشُّهُودَ
u'عَرَّفَ شَيْءٌ':Predicate, #6: 6	عَرَفَ الشُّهُودُ
u'عَرَفَ صَاحِبٌ':Predicate, #1: 1	عَرَّفَ الشَّيْءَ
u'عَرَفَ صَاحِبٌ':Subject, #3: 3	عَرَفَ صَاحِبَ
u'عَرَفَ صَاحِبٌ':Subject, #1: 1	عَرَفَ صَاحِبُ
u'عَرَفَ صِحَّةٌ':Predicate, #1: 1	عَرَفَ صَاحِبُهُ
u'عَرَفَ صدق':Predicate, #2: 2	عَرَفَ صِحَّةَ
u'عَرَفَ صِدْقٌ':Predicate, #1: 1	عَرَفَ صِدْقَ
u'عَرَفَ صَقِيلٌ':Subject, #1: 1	عَرَفَ صِدْقَ
u'عَرَفَ صَيْقَل':Subject, #1: 1	عَرَفَ الصَّقِيلُ
u'عَرَفَ طِبٌّ':Predicate, #1: 1	عَرَفَ الصَّيْقَلُ
u'عَرَفَ طُرُقٌ':Predicate, #1: 1	عَرَفَ الطِّبَّ
u'عَرَفَ طُرُقٌ':Predicate, #1: 1	عَرَفَ الطُّرُقَ
u'عَرَّفَ عَامٌ':Predicate, #1: 1	عَرَفَ طُرُقَ
u'عَرَفَ عَامِّيٌّ':Subject, #1: 1	عَرَّفَ عَامَ
u'عَرَفَ عَبْدٌ':Predicate, #1: 1	عَرَفَ الْعَامِّيُّ
u'عَرَفَ عَبْدٌ':Subject, #1: 1	عَرَفَ الْعَبْدَ
u'عَرَفَ عَبْدٌ':Subject, #1: 1	عَرَفَ الْعَبْدُ
u'عَرَفَ عَدَدٌ':Predicate, #1: 1	عَرَفَ عَبْدُ
u'عَرَفَ عَرَبِيٌّ':Predicate, #1: 1	عَرَفَ الْعَدَدَ
u'عَرَفَ عَصْرٌ':Subject, #3: 3	عَرَفَ الْعَرَبِيَّةَ
u'عَرَفَ عَلِيٌّ':Subject, #1: 1	عَرَفَ الْعَصْرُ
u'عَرَّفَ عَمَلٌ':Predicate, #1: 1	عَرَفَ عَلِيٌّ
u'عرف عُودٌ':Added, #1: 1	عَرَّفَ الْعَمَلَ
u'عَرْفٌ عُودٌ':Added, #1: 1	عَرْفِ الْعُودِ
u'عَرَفَ عِيَالٌ':Predicate, #1: 1	عَرْفِ الْعُودِ
u'عَرَفَ عَيْبٌ':Predicate, #2: 2	عَرَفَ عِيَالَ
u'عَرَفَ عَيْبٌ':Predicate, #1: 1	عَرَفَ عَيْبَ
u'عَرَفَ عين':Predicate, #2: 2	عَرَفَ الْعَيْبَ
u'عَرَفَ عَيْنٌ':Predicate, #1: 1	عَرَفَ عَيْنَ
u'عَرَفَ عَيْن':Predicate, #1: 1	عَرَفَ عَيْنَ
u'عَرَفَ غُلاَمٌ':Subject, #1: 1	عَرَفَ عَيْنَ
u'عَرَفَ غير':Predicate, #1: 1	عَرَفَ الْغُلامُ
u'عَرَفَ غَيْرٌ':Predicate, #1: 1	عَرَفَ غَيْرَ
u'عَرَفَ فَاعِلٌ':Predicate, #1: 1	عَرَفَ غَيْرَ
u'عَرَفَ فَرَائِضُ':Predicate, #1: 1	عَرَفَ الْفَاعِلَ
u'عَرَفَ فرق':Predicate, #1: 1	عَرَفَ الْفَرَائِضَ
u'عَرَفَ فَرْقٌ':Predicate, #1: 1	عَرَفَ الْفَرْقَ
u'عَرَفَ فُرُوضٌ':Predicate, #1: 1	عَرَفَ الْفَرْقَ
u'عَرَفَ فُرُوعٌ':Predicate, #1: 1	عَرَفَ فُرُوضَ
u'عَرَفَ فِسْقٌ':Predicate, #2: 2	عَرَفَ الْفُرُوعَ
u'عَرَفَ فِعْلٌ':Predicate, #3: 3	عَرَفَ فِسْقَ
u'عَرَفَ قَاتِلٌ':Predicate, #1: 1	عَرَفَ الْفِعْلَ
u'عَرَفَ قَاتِلٌ':Predicate, #1: 1	عَرَفَ الْقَاتِلَ
u'عَرَفَ قَدْرٌ':Predicate, #3: 3	عَرَفَ قَاتِلَ
u'عَرَفَ قِصَّةٌ':Predicate, #4: 4	عَرَفَ قَدْرَ
u'عَرَفَ قَوْمٌ':Subject, #1: 1	عَرَفَ الْقِصّةَ
u'عَرَفَ قِيَاسٌ':Predicate, #3: 3	عَرَفَ الْقَوْمُ
u'عَرَفَ قيام':Predicate, #1: 1	عَرَفَ الْقِيَاسَ
u'عَرَفَ قِيَامٌ':Predicate, #3: 3	عَرَفَ قِيَامَ
u'عَرَفَ كَاتِبٌ':Subject, #3: 3	عَرَفَ قِيَامَ
u'عَرَفَ كِتَابٌ':Predicate, #1: 1	عَرَفَ كَاتِبُ
u'عَرَفَ كَوْنٌ':Predicate, #1: 1	عَرَفَ كِتَابَ
u'عَرَفَ كَيْفِيَّةٌ':Predicate, #1: 1	عَرَفَ كَوْنَ
u'عَرَّفَ مَالِكٌ':Predicate, #1: 1	عَرَفَ كَيْفِيَّةَ
u'عَرَفَ مَالِكٌ':Predicate, #1: 1	عَرَّفَ مَالِكَ
u'عَرَفَ مُبْرِئٌ':Subject, #3: 3	عَرَفَ الْمَالِكَ
u'عَرَفَ مَبْلَغٌ':Predicate, #1: 1	عَرَفَ الْمُبْرِئُ
u'عَرَفَ مَحَلٌّ':Predicate, #1: 1	عَرَفَ مَبْلَغَ
u'عَرَفَ مُدَّعِي':Predicate, #2: 2	عَرَفَ مَحَلَّ
u'عَرَفَ مَذْهَبٌ':Predicate, #1: 1	عَرَفَ الْمُدَّعِيَ
u'عَرَفَ مراد':Predicate, #2: 2	عَرَفَ مَذْهَبَ
u'عَرَفَ مُرَادٌ':Predicate, #1: 1	عَرَفَ الْمُرَادَ
u'عَرَفَ مُسْتَأْجِرٌ':Predicate, #1: 1	عَرَفَ الْمُرَادَ
u'عرف مِسْكٌ':Added, #1: 1	عَرَفَ الْمُسْتَأْجِرَ
u'عَرْفٌ مِسْكٌ':Added, #1: 1	عَرْفُ الْمِسْكِ
u'عَرَفَ مَشْهُودٌ':Predicate, #1: 1	عَرْفُ الْمِسْكِ
u'عَرَفَ مَصْلَحَةٌ':Predicate, #1: 1	عَرَفَ الْمَشْهُودَ
u'عَرَّفَ مُصَنِّفٌ':Subject, #1: 1	عَرَفَ الْمَصْلَحَةَ
u'عَرَفَ مُطَلَّقٌ':Predicate, #2: 2	عَرَّفَ الْمُصَنِّفُ
u'عَرَفَ مِقْدَارٌ':Predicate, #1: 1	عَرَفَ الْمُطَلَّقَةَ
u'عَرَفَ مكارم':Predicate, #1: 1	عَرَفَ مِقْدَارَ
u'عَرَفَ مَكَارِمُ':Predicate, #1: 1	عَرَفَ الْمَكَارِمَ
u'عَرَفَ مَكْتُوبٌ':Subject, #1: 1	عَرَفَ الْمَكَارِمَ
u'عَرَفَ مُلْتَقِط':Subject, #1: 1	عَرَفَ الْمَكْتُوبُ
u'عَرَفَ مَنَازِلُ':Predicate, #1: 1	عَرَفَ الْمُلْتَقِطُ
u'عَرَفَ مُوَثِّقٌ':Subject, #2: 2	عَرَفَ مَنَازِلَ
u'عَرَفَ مَوْضِعٌ':Predicate, #1: 1	عَرَفَ الْمُوَثِّقُ
u'عَرَّفَ مُوَكِّلٌ':Predicate, #3: 3	عَرَفَ مَوْضِعَ
u'عَرَّفَ مُؤَلِّفٌ':Subject, #1: 1	عَرَّفَ الْمُوَكِّلَ
u'عَرَفَ نَاحِي':Predicate, #1: 1	عَرَّفَ الْمُؤَلِّفُ
u'عَرَفَ نَاحِيَةٌ':Predicate, #1: 1	عَرَفَ نَاحِيَةَ
u'عَرَفَ نَاسٌ':Predicate, #1: 1	عَرَفَ نَاحِيَةَ
u'عَرَّفَ نَاسٌ':Predicate, #1: 1	عَرَفَ النَّاسَ
u'عَرَفَ نَاسٌ':Subject, #1: 1	عَرَّفَ النَّاسَ
u'عَرَفَ نَاظِرٌ':Subject, #3: 3	عَرَفَ النَّاسُ
u'عَرَّفَ نَبِيٌّ':Subject, #1: 1	عَرَفَ النَّاظِرُ
u'عَرَفَ نَحْوٌ':Predicate, #1: 1	عَرَّفَ النَّبِيُّ
u'عَرَفَ نَسَبٌ':Predicate, #1: 1	عَرَفَ النَّحْوَ
u'عَرَفَ نِسْبَةٌ':Predicate, #1: 1	عَرَفَ نَسَبَ
u'عَرَفَ نَظْمٌ':Predicate, #1: 1	عَرَفَ النِّسْبَةَ
u'عَرَّفَ نَكِرٌ':Predicate, #1: 1	عَرَفَ نَظْمَ
u'عَرَّفَ نكرة':Predicate, #1: 1	عَرَّفَ النَّكِرَةَ
u'عَرَّفَ نَكِرَةٌ':Predicate, #1: 1	عَرَّفَ النَّكِرَةَ
u'عَرَفَ نَهْيٌ':Predicate, #1: 1	عَرَّفَ النَّكِرَةَ
u'عَرَفَ وَاجِبٌ':Predicate, #1: 1	عَرَفَ النَّهْيَ
u'عَرَّفَ واحد':Subject, #1: 1	عَرَفَ الْوَاجِبَ
u'عَرَّفَ وَاحِدٌ':Subject, #1: 1	عَرَّفَ وَاحِدٌ
u'عَرَفَ وَارِثٌ':Subject, #1: 1	عَرَّفَ وَاحِدٌ
u'عَرَفَ وَجْهٌ':Predicate, #1: 1	عَرَفَ الْوَارِثُ
u'عَرَفَ وُجُوبٌ':Predicate, #2: 2	عَرَفَ وَجْهَ
u'عَرَفَ وَرَثَةٌ':Subject, #1: 1	عَرَفَ وُجُوبَ
u'عَرَفَ وَزْنٌ':Predicate, #1: 1	عَرَفَ الْوَرَثَةُ
u'عَرَفَ وَصْفٌ':Predicate, #2: 2	عَرَفَ وَزْنَ
u'عَرَفَ وَصِيٌّ':Subject, #1: 1	عَرَفَ الْوَصْفَ
u'عَرَفَ وَضْعٌ':Predicate, #1: 1	عَرَفَ الْوَصِيُّ
u'عَرَّفَ وَقْتٌ':Predicate, #1: 1	عَرَفَ وَضْعَ
u'عَرَّفَ وَلِيٌّ':Subject, #1: 1	عَرَّفَ وَقْتَ
u'عَرَقٌ آدَمِيٌّ':Added, #1: 1	عَرَّفَ وَلِيُّ
u'عَرَقٌ آدَمِيٌّ':Added, #1: 1	عَرَقِ الْآدَمِيِّ
u'عَرَقٌ إِنْسانٌ':Added, #2: 2	عَرَقُ الْآدَمِيِّ
u'عَرَقٌ أهْلٌ':Added, #1: 1	عَرَقِ الإِنْسَانِ
u'عَرَقٌ جَبِينٌ':Added, #4: 4	عَرَقُ أَهْلِ
u'عَرَقٌ جَبِينٌ':Added, #1: 1	عَرَقُ الْجَبِينِ
u'عَرَقٌ حائِضٌ':Added, #1: 1	عَرَقُ جَبِينِهِ
u'عَرَقٌ حِمَارٌ':Added, #1: 1	عَرَقِ الْحَائِضِ
u'عَرَقٌ حِمَارٌ':Added, #1: 1	عَرَقَ الْحِمَارِ
u'عَرَقٌ حِمَارٌ':Added, #1: 1	عَرَقِ الْحِمَارِ
u'عَرَقٌ حَيَوَانٌ':Added, #2: 2	عَرَقُ الْحِمَارِ
u'عَرَقٌ خِنْزِيرٌ':Added, #1: 1	عَرَقُ حَيَوَانٍ
u'عَرَقٌ خَيْلٌ':Added, #1: 1	عَرَقِ الْخِنْزِيرِ
u'عَرَقٌ دَابَّةٌ':Added, #1: 1	عَرَقِ الْخَيْلِ
u'عَرَقٌ دَوَابُّ':Added, #1: 1	عَرَقُ الدَّابَّةِ
u'عَرَقٌ رِجْلٌ':Added, #1: 1	عَرَقِ الدَّوَابِّ
u'عَرَقٌ رَسُولٌ':Added, #1: 1	عَرَقِ الرِّجْلِ
u'عَرَقٌ سَكْرَان':Added, #1: 1	عَرَقِ رَسُولِ
u'عَرَقٌ سِنَّوْرٌ':Added, #1: 1	عَرَقَ السَّكْرَانِ
u'عَرِقَ طَابَقٌ':Subject, #2: 2	عَرَقُ سِنَّوْرٍ
u'عَرَقٌ غير':Added, #1: 1	عَرِقَ الطَّابَقُ
u'عَرَقٌ غَيْرٌ':Added, #1: 1	عَرَقُ غَيْرِ
u'عَرَقٌ كَلْبٌ':Added, #1: 1	عَرَقُ غَيْرِ
u'عَرَقٌ كَلْبٌ':Added, #1: 1	عَرَقُ الْكَلْبِ
u'عَرَقٌ كَلْبٌ':Added, #1: 1	عَرَقِ الْكَلْبِ
u'عَرِقَ لَيْلٌ':Predicate, #2: 2	عَرَقَ الْكَلْبِ
u'عَرِقَ مَحَلٌّ':Subject, #1: 1	عَرِقَ لَيْلَةً
u'عَرَقٌ مَحَلٌّ':Added, #1: 1	عَرِقَ مَحَلُّ
u'عَرَقٌ وَجْهٌ':Added, #1: 1	عَرَقِ مَحَلِّ
u'عُرُوضٌ إِثْبَاتٌ':Added, #1: 1	عَرَقُ الْوَجْهِ
u'عُرُوضٌ أَحْكَامٌ':Added, #1: 1	عُرُوضَ الْإِثْبَاتِ
u'عُرُوضٌ إِسْلامٌ':Added, #1: 1	عُرُوضُ الْأَحْكَامِ
u'عُرُوضٌ إضافَةٌ':Added, #1: 1	عُرُوضِ الْإِسْلَامِ
u'عُرُوضٌ إِعارَةٌ':Added, #1: 1	عُرُوضُ الْإِضَافَةِ
u'عُرُوضٌ اِلْتِزَامٌ':Added, #1: 1	عُرُوضِ الْإِعَارَةِ
u'عُرُوضٌ أَوْصَافٌ':Added, #1: 1	عُرُوضِ الْتِزَامِ
u'عُرُوضٌ بُلْدانٌ':Added, #1: 1	عُرُوضِ الْأَوْصَافِ
u'عُرُوضٌ بَيْعٌ':Added, #1: 1	عُرُوضِ الْبُلْدَانِ
u'عُرُوضٌ تِجَارَةٌ':Added, #2: 2	عُرُوضِ الْبَيْعِ
u'عُرُوضٌ تِجَارَةٌ':Added, #1: 1	عُرُوضَ التِّجَارَةِ
u'عُرُوضٌ تِجَارَةٌ':Added, #1: 1	عُرُوضَ تِجَارَةٍ
u'عُرُوضٌ تِجَارَةٌ':Added, #1: 1	عُرُوضِ تِجَارَةٍ
u'عُرُوضٌ تِجَارَةٌ':Added, #35: 35	عُرُوضِ التِّجَارَةِ
u'عُرُوضٌ تَسْمِيَة':Added, #5: 5	عُرُوضُ التِّجَارَةِ
u'عُرُوضٌ تَعَيُّنٌ':Added, #1: 1	عُرُوضِ التَّسْمِيَةِ
u'عُرُوضٌ جُنُونٌ':Added, #1: 1	عُرُوضُ تَعَيُّنِهِ
u'عُرُوضٌ جُنُونٌ':Added, #1: 1	عُرُوضُ جُنُونِهِ
u'عُرُوضٌ حاجَةٌ':Added, #3: 3	عُرُوضِ الْجُنُونِ
u'عُرُوضٌ حُرْمَةٌ':Added, #1: 1	عُرُوضِ حَاجَتِهِ
u'عُرُوضٌ سَفَرٌ':Added, #1: 1	عُرُوضِ الْحُرْمَةِ
u'عُرُوضٌ شُبْهَةٌ':Added, #1: 1	عُرُوضِ السَّفَرِ
u'عُرُوضٌ شَرْطٌ':Added, #1: 1	عُرُوضِ شُبْهَةِ
u'عُرُوضٌ شَكٌّ':Added, #1: 1	عُرُوضِ الشَّرْطِ
u'عُرُوضٌ شهرة':Added, #1: 1	عُرُوضِ الشَّكِّ
u'عُرُوضٌ شهرة':Added, #1: 1	عُرُوضَ الشُّهْرَةِ
u'عُرُوضٌ شُهْرَةٌ':Added, #1: 1	عُرُوضِ الشُّهْرَةِ
u'عُرُوضٌ شُهْرَةٌ':Added, #1: 1	عُرُوضَ الشُّهْرَةِ
u'عُرُوضٌ عَارِضٌ':Added, #1: 1	عُرُوضِ الشُّهْرَةِ
u'عُرُوضٌ عَدَمٌ':Added, #1: 1	عُرُوضِ عَارِضِ
u'عُرُوضٌ عُذْرٌ':Added, #1: 1	عُرُوضُ عَدَمِ
u'عُرُوضٌ عُمُومٌ':Added, #1: 1	عُرُوضُ الْعُذْرِ
u'عُرُوضٌ عَوَارِضُ':Added, #1: 1	عُرُوضَ الْعُمُومِ
u'عُرُوضٌ قَرِينٌ':Added, #2: 2	عُرُوضِ الْعَوَارِضِ
u'عُرُوضٌ كَثْرَةٌ':Added, #1: 1	عُرُوضِ الْقَرِينَةِ
u'عُرُوضٌ كَلاَمٌ':Added, #1: 1	عُرُوضِ كَثْرَةِ
u'عُرُوضٌ مُبْطِلٌ':Added, #1: 1	عُرُوضِ الْكَلَامِ
u'عُرُوضٌ مثل':Added, #1: 1	عُرُوضِ الْمُبْطِلِ
u'عُرُوضٌ مثل':Added, #1: 1	عُرُوض مِثْلِ
u'عُرُوضٌ مِثْلٌ':Added, #1: 1	عُرُوضِ مِثْلِ
u'عُرُوضٌ مِثْلٌ':Added, #1: 1	عُرُوض مِثْلِ
u'عُرُوضٌ مَدْيُونٌ':Added, #1: 1	عُرُوضِ مِثْلِ
u'عُرُوضٌ نَدَمٌ':Added, #1: 1	عُرُوضَ الْمَدْيُونِ
u'عُرُوضٌ نَقْصٌ':Added, #1: 1	عُرُوضِ النَّدَمِ
u'عُرُوضٌ وَجَعٌ':Added, #1: 1	عُرُوضِ النَّقْصِ
u'عُرُوضٌ ولد':Added, #1: 1	عُرُوضِ وَجَعِ
u'عُرُوضٌ وَلَدٌ':Added, #1: 1	عُرُوضَ الْوَلَدِ
u'عَرَى قَصْدٌ':Subject, #1: 1	عُرُوضَ الْوَلَدِ
u'عَرَى قول':Subject, #1: 1	عَرَى قَصْدُ
u'عَرَى قَوْلٌ':Subject, #1: 1	عَرَى الْقَوْلُ
u'عَزَا اِبْنٌ':Subject, #1: 1	عَرَى الْقَوْلُ
u'عَزَا خَطِيبٌ':Subject, #4: 4	عَزَا ابْنُ
u'عَزَّ إِسْلامٌ':Predicate, #1: 1	عَزَا الْخَطِيبُ
u'عَزَّ إِسْلامٌ':Predicate, #1: 1	أَعَزَّ الإِسْلاَمَ
u'عَزَا صَاحِبٌ':Subject, #4: 4	أَعَزَّ الْإِسْلَامَ
u'عَزَا قول':Predicate, #1: 1	عَزَا صَاحِبُ
u'عَزَا قَوْلٌ':Predicate, #1: 1	عَزَا الْقَوْلَ
u'عَزَا مَجْدٌ':Subject, #1: 1	عَزَا الْقَوْلَ
u'عَزَا مَسْأَلَةٌ':Predicate, #1: 1	عَزَا الْمَجْدُ
u'عَزَبَ رَأْيٌ':Subject, #2: 2	عَزَا الْمَسْأَلَةَ
u'عَزَبَ شَيْءٌ':Subject, #1: 1	عَزَبَ رَأْيُهُ
u'عَزَبَ واحد':Subject, #1: 1	عَزَبَ شَيْءٌ
u'عَزَبَ وَاحِدٌ':Subject, #1: 1	عَزَبَ وَاحِدٌ
u'عَزَّ بَيْنٌ':Predicate, #1: 1	عَزَبَ وَاحِدٌ
u'عِزَّةٌ طعام':Added, #1: 1	عَزَّ بَيْنَ
u'عِزَّةٌ طَعَامٌ':Added, #1: 1	عِزَّةِ الطَّعَامِ
u'عِزَّةٌ مَاءٌ':Added, #1: 1	عِزَّةِ الطَّعَامِ
u'عِزَّةٌ مُجْتَهِد':Added, #5: 5	عِزَّةِ الْمَاءِ
u'عِزَّةٌ نُصُوصٌ':Added, #1: 1	عِزَّةَ الْمُجْتَهِدِ
u'عِزَّةٌ نَفْسٌ':Added, #1: 1	عِزَّةِ النُّصُوصِ
u'عِزَّةٌ وُجُودٌ':Added, #2: 2	عِزَّةُ النَّفْسِ
u'عِزَّةٌ وُجُودٌ':Added, #1: 1	عِزَّةَ الْوُجُودِ
u'عَزَّ جَلٌّ':Predicate, #7: 7	عِزَّةِ الْوُجُودِ
u'عَزَّ دَرَاهِمُ':Predicate, #1: 1	عَزَّ جَلَّ
u'عَزَّ ذكر':Subject, #1: 1	أَعَزَّ الدَّرَاهِمَ
u'عَزَّ ذِكْرٌ':Subject, #1: 1	عَزَّ ذِكْرُهُ
u'عَزَّرَ سُلْطَانٌ':Subject, #1: 1	عَزَّ ذِكْرُهُ
u'عَزَّ شَيْءٌ':Subject, #1: 1	عَزَّرَ السُّلْطَانُ
u'عَزَّ عَدُوٌّ':Predicate, #1: 1	عَزَّ الشَّيْءُ
u'عَزَّ علم':Predicate, #1: 1	أَعَزَّ عَدُوَّ
u'عَزَّ عِلْمٌ':Predicate, #1: 1	أَعَزَّ الْعِلْمَ
u'عَزَّ عند':Predicate, #1: 1	أَعَزَّ الْعِلْمَ
u'عزف قِيَانٌ':Added, #1: 1	أَعَزَّ عِنْدَ
u'عَزْفٌ قِيَانٌ':Added, #1: 1	عَزْفِ الْقِيَانِ
u'عَزَلَ أَجْوَدُ':Predicate, #1: 1	عَزْفِ الْقِيَانِ
u'عَزَلَ أحَدٌ':Predicate, #2: 2	عَزَلَ الْأَجْوَدَ
u'عَزَلَ إمَامٌ':Subject, #1: 1	عَزَلَ أَحَدَ
u'عَزَلَ أَوَّلُ':Predicate, #2: 2	عَزَلَ الْإِمَامُ
u'عَزَلَ أَوَّلُ':Subject, #1: 1	عَزَلَ الْأَوَّلَ
u'عَزَلَ بَائِعٌ':Subject, #1: 1	عَزَلَ الْأَوَّلُ
u'عَزَلَ ثَانِي':Predicate, #1: 1	عَزَلَ الْبَائِعُ
u'عَزَلَ حاكِمٌ':Subject, #1: 1	عَزَلَ الثَّانِيَ
u'عَزَلَ خَلِيفَةٌ':Subject, #1: 1	عَزَلَ الْحَاكِمُ
u'عَزَلَ دَرَاهِمُ':Predicate, #1: 1	عَزَلَ الْخَلِيفَةُ
u'عَزَلَ رَاهِنٌ':Subject, #1: 1	عَزَلَ دَرَاهِمَ
u'عَزَلَ رَبُّ':Subject, #1: 1	عَزَلَ الرَّاهِنُ
u'عَزَلَ رَجُلٌ':Subject, #5: 5	عَزَلَ رَبُّ
u'عَزَلَ زَكاةٌ':Predicate, #2: 2	عَزَلَ الرَّجُلُ
u'عَزَلَ زَكاةٌ':Predicate, #1: 1	عَزَلَ الزَّكَاةَ
u'عَزَلَ سُلْطَانٌ':Subject, #1: 1	عَزَلَ زَكَاةَ
u'عَزَلَ شَحْمٌ':Predicate, #1: 1	عَزَلَ السُّلْطَانُ
u'عَزَلَ عَبْدٌ':Subject, #1: 1	عَزَلَ شَحْمَ
u'عَزَلَ عُشْرٌ':Predicate, #1: 1	عَزَلَ عَبْدُ
u'عَزَلَ عُمَرٌ':Subject, #2: 2	عَزَلَ عُشْرَ
u'عَزَلَ قَاضِي':Predicate, #2: 2	عَزَلَ عُمَرُ
u'عَزَلَ قَدْرٌ':Predicate, #1: 1	عَزَلَ الْقَاضِيَ
u'عَزَلَ قَيِّمٌ':Subject, #2: 2	عَزَلَ قَدْرَ
u'عَزَلَ كَاتِبٌ':Predicate, #1: 1	عَزَلَ قَيِّمٌ
u'عَزَلَ مُعِير':Subject, #2: 2	عَزَلَ الْكَاتِبَ
u'عَزَلَ مُودِعٌ':Subject, #1: 1	عَزَلَ الْمُعِيرُ
u'عَزَلَ مُوَكِّلٌ':Subject, #1: 1	عَزَلَ الْمُودِعُ
u'عَزَلَ نَاظِرٌ':Subject, #1: 1	عَزَلَ الْمُوَكِّلُ
u'عَزَلَ نَاظِرٌ':Subject, #1: 1	عَزَلَ نَاظِرُ
u'عَزَلَ نَبِيٌّ':Subject, #6: 6	عَزَلَ النَّاظِرُ
u'عَزَلَ نَصِيبٌ':Predicate, #1: 1	عَزَلَ النَّبِيُّ
u'عَزَلَ وَاقِفٌ':Subject, #2: 2	عَزَلَ نَصِيبَ
u'عَزَلَ وَزِيرٌ':Predicate, #2: 2	عَزَلَ الْوَاقِفُ
u'عَزَلَ وَصِيٌّ':Predicate, #1: 1	عَزَلَ وَزِيرَ
u'عَزَلَ وَكِيلٌ':Predicate, #3: 3	عَزَلَ الْوَصِيَّ
u'عَزَلَ وَكِيلٌ':Predicate, #1: 1	عَزَلَ وَكِيلَ
u'عَزَلَ وَكِيلٌ':Subject, #5: 5	عَزَلَ الْوَكِيلَ
u'عَزْمٌ إِتْيانٌ':Added, #3: 3	عَزَلَ الْوَكِيلُ
u'عَزْمٌ أَدَاءٌ':Added, #1: 1	عَزْمِ الْإِتْيَانِ
u'عَزْمٌ إِعادَةٌ':Added, #1: 1	عَزْمِ الْأَدَاءِ
u'عَزْمٌ إقامَةٌ':Added, #1: 1	عَزْمِ إعَادَتِهِ
u'عَزْمٌ أُمُورٌ':Added, #2: 2	عَزْمِ الْإِقَامَةِ
u'عَزَمَ بَائِعٌ':Subject, #9: 9	عَزْمِ الْأُمُورِ
u'عَزْمٌ تَمَتُّعٌ':Added, #5: 5	عَزَمَ الْبَائِعُ
u'عَزَّ مُجْتَهِد':Subject, #1: 1	عَزْمِ التَّمَتُّعِ
u'عَزْمٌ جَديدٌ':Added, #1: 1	عَزَّ الْمُجْتَهِدُ
u'عَزْمٌ جَمَاعَةٌ':Added, #2: 2	عَزْمٍ جَدِيدٍ
u'عَزْمٌ خُرُوجٌ':Added, #1: 1	عَزْمِ الْجَمَاعَةِ
u'عَزَمَ رَسُولٌ':Subject, #2: 2	عَزْمِ الْخُرُوجِ
u'عَزَمَ رَسُولٌ':Subject, #1: 1	عَزَمَ الرَّسُولُ
u'عَزْمٌ سَفَرٌ':Added, #1: 1	عَزَمَ رَسُولُ
u'عَزَمَ شَيْخٌ':Subject, #3: 3	عَزْمِ السَّفَرِ
u'عَزَمَ شَيْخٌ':Subject, #1: 1	عَزَمَ الشَّيْخُ
u'عَزْمٌ طَلاَقٌ':Added, #1: 1	عَزَمَ شَيْخُهُ
u'عَزْمٌ عَدَمٌ':Added, #2: 2	عَزْمُ الطَّلاَقِ
u'عَزْمٌ عَوْدٌ':Added, #1: 1	عَزْمِ عَدَمِ
u'عَزَمَ فِرَاقٌ':Predicate, #2: 2	عَزْمِ عَوْدِهِ
u'عَزْمٌ قلب':Added, #1: 1	عَزَمَ الْفِرَاقَ
u'عَزْمٌ قَلْبٌ':Added, #1: 1	عَزْمِ الْقَلْبِ
u'عَزْمٌ قَلْب':Added, #1: 1	عَزْمِ الْقَلْبِ
u'عَزْمٌ قلب':Added, #1: 1	عَزْمِ الْقَلْبِ
u'عَزْمٌ قَلْبٌ':Added, #2: 2	عَزْمُ الْقَلْبِ
u'عَزْمٌ قَلْب':Added, #2: 2	عَزْمُ الْقَلْبِ
u'عَزْمٌ كَفٌّ':Added, #2: 2	عَزْمُ الْقَلْبِ
u'عَزْمٌ مُحَقَّقٌ':Added, #1: 1	عَزْمِ الْكَفِّ
u'عَزْمٌ نَاسٌ':Added, #1: 1	عَزْمٍ مُحَقَّقٍ
u'عَزَمَ وَاطِئٌ':Subject, #2: 2	عَزْمِ النَّاسِ
u'عَزْمٌ وَاطِئٌ':Added, #1: 1	عَزَمَ الْوَاطِئُ
u'عَزَّ نَصْرٌ':Subject, #4: 4	عَزْمِ الْوَاطِئِ
u'عَزَّ وُجُودٌ':Subject, #1: 1	عَزَّ نَصْرُهُ
u'عُزُوفٌ نَفْسٌ':Added, #2: 2	عَزَّ وُجُودُهُ
u'عُزُوفٌ نَفْسٌ':Added, #1: 1	عُزُوفَ النَّفْسِ
u'عَزَّ وهان':Predicate, #1: 1	عُزُوفُ النَّفْسِ
u'عَزَّى إمَامٌ':Subject, #10: 10	عَزَّ وَهَانَ
u'عَزَّى أهْلٌ':Predicate, #1: 1	عَزَّى الْإِمَامُ
u'عَزَّى رَجُلٌ':Predicate, #1: 1	عَزَّى أَهْلَ
u'عَزِيمَةٌ تَمَتُّعٌ':Added, #1: 1	عَزَّى رَجُلاً
u'عَزِيمَةٌ سَفَرٌ':Added, #1: 1	عَزِيمَةِ التَّمَتُّعِ
u'عَزِيمَةٌ صبر':Added, #1: 1	عَزِيمَةَ السَّفَرِ
u'عَزِيمَةٌ صَبْرٌ':Added, #1: 1	عَزِيمَةِ الصَّبْرِ
u'عَزِيمَةٌ صلح':Added, #1: 1	عَزِيمَةِ الصَّبْرِ
u'عَزِيمَةٌ صُلْحٌ':Added, #1: 1	عَزِيمَةُ الصّلْحِ
u'عَزِيمَةٌ صَوْمٌ':Added, #1: 1	عَزِيمَةُ الصّلْحِ
u'عَزِيمَةٌ طَلاَقٌ':Added, #1: 1	عَزِيمَةِ الصَّوْمِ
u'عَزِيمَةٌ طَلاَقٌ':Added, #3: 3	عَزِيمَةَ الطَّلَاقِ
u'عَزِيمَةٌ قَضَاءٌ':Added, #4: 4	عَزِيمَةُ الطَّلَاقِ
u'عَزِيمَةٌ قلب':Added, #1: 1	عَزِيمَةِ الْقَضَاءِ
u'عَزِيمَةٌ قلب':Added, #1: 1	عَزِيمَةُ الْقَلْبِ
u'عَزِيمَةٌ قَلْبٌ':Added, #1: 1	عَزِيمَةِ الْقَلْبِ
u'عَزِيمَةٌ قَلْبٌ':Added, #1: 1	عَزِيمَةُ الْقَلْبِ
u'عَزِيمَةٌ قَلْب':Added, #1: 1	عَزِيمَةِ الْقَلْبِ
u'عَزِيمَةٌ قَلْب':Added, #1: 1	عَزِيمَةُ الْقَلْبِ
u'عَزِيمَةٌ قلب':Added, #1: 1	عَزِيمَةِ الْقَلْبِ
u'عَزِيمَةٌ قَلْبٌ':Added, #2: 2	عَزِيمَةُ قَلْبِهِ
u'عَزِيمَةٌ قَلْب':Added, #2: 2	عَزِيمَةُ قَلْبِهِ
u'عَزَّى مُسْلِمٌ':Subject, #2: 2	عَزِيمَةُ قَلْبِهِ
u'عَسُرَ إِثْبَاتٌ':Subject, #1: 1	عَزَّى مُسْلِمٌ
u'عسر إِثْبَاتٌ':Added, #1: 1	عَسُرَ إثْبَاتُ
u'عُسْرٌ إِثْبَاتٌ':Added, #1: 1	عُسْرِ إثْبَاتِ
u'عسر إِجَابَةٌ':Added, #1: 1	عُسْرِ إثْبَاتِ
u'عُسْرٌ إِجَابَةٌ':Added, #1: 1	عُسْرِ الْإِجَابَةِ
u'عسر أَدَاءٌ':Added, #1: 1	عُسْرِ الْإِجَابَةِ
u'عُسْرٌ أَدَاءٌ':Added, #2: 2	عُسْرِ الْأَدَاءِ
u'عَسُرَ إِزَالَةٌ':Subject, #2: 2	عُسْرِ الْأَدَاءِ
u'عَسُرَ إِصْلاحٌ':Subject, #1: 1	عَسُرَ إزَالَتُهُ
u'عَسُرَ إِفْرَادٌ':Subject, #1: 1	عَسُرَ الْإِصْلَاحُ
u'عسر إِفْرَادٌ':Added, #2: 2	عَسُرَ إفْرَادُ
u'عُسْرٌ إِفْرَادٌ':Added, #1: 1	عُسْرَ إفْرَادِ
u'عسر إِفْرَادٌ':Added, #1: 1	عُسْرَ إفْرَادِ
u'عُسْرٌ إِفْرَادٌ':Added, #1: 1	عُسْرِ الْإِفْرَادِ
u'عسر إِفْرَادٌ':Added, #1: 1	عُسْرِ الْإِفْرَادِ
u'عُسْرٌ إِفْرَادٌ':Added, #2: 2	عُسْرِ إفْرَادِ
u'عَسِرَ إقامَةٌ':Subject, #2: 2	عُسْرِ إفْرَادِ
u'عسر أَمْرٌ':Added, #1: 1	عَسِرَ إقَامَةُ
u'عُسْرٌ أَمْرٌ':Added, #1: 1	عُسْرُ الْأَمْرِ
u'عَسِرَ أَيْسَرُ':Predicate, #1: 1	عُسْرُ الْأَمْرِ
u'عسر بَوْلٌ':Added, #1: 1	أَعْسَرَ أَيْسَرَ
u'عُسْرٌ بَوْلٌ':Added, #1: 1	عُسْرَ الْبَوْلِ
u'عسر بَوْلٌ':Added, #1: 1	عُسْرَ الْبَوْلِ
u'عُسْرٌ بَوْلٌ':Added, #2: 2	عُسْرِ الْبَوْلِ
u'عَسِرَ بِيَعٌ':Predicate, #2: 2	عُسْرِ الْبَوْلِ
u'عسر بَيِّنَةٌ':Added, #1: 1	أَعْسَرَ بِيعَ
u'عُسْرٌ بَيِّنَةٌ':Added, #1: 1	عُسْرِ الْبَيِّنَةِ
u'عسر تَتَبُّعٌ':Added, #1: 1	عُسْرِ الْبَيِّنَةِ
u'عسر تَتَبُّعٌ':Added, #1: 1	عُسْرُ تَتَبُّعِ
u'عُسْرٌ تَتَبُّعٌ':Added, #1: 1	عُسْرِ تَتَبُّعِ
u'عُسْرٌ تَتَبُّعٌ':Added, #1: 1	عُسْرُ تَتَبُّعِ
u'عَسُرَ تَحْصِيلٌ':Subject, #1: 1	عُسْرِ تَتَبُّعِ
u'عَسُرَ تَقْديرٌ':Subject, #2: 2	عَسُرَ تَحْصِيلُهُ
u'عسر تَمَكُّنٌ':Added, #1: 1	عَسُرَ تَقْدِيرُ
u'عُسْرٌ تَمَكُّنٌ':Added, #1: 1	عُسْرُ التَّمَكُّنِ
u'عسر تَمْييزٌ':Added, #1: 1	عُسْرُ التَّمَكُّنِ
u'عُسْرٌ تَمْييزٌ':Added, #1: 1	عُسْرُ تَمْيِيزِهِ
u'عَسِرَ جَازٌ':Predicate, #1: 1	عُسْرُ تَمْيِيزِهِ
u'عسر حَدٌّ':Added, #1: 1	أَعْسَرَ جَازَ
u'عُسْرٌ حَدٌّ':Added, #1: 1	عُسْرُ الْحَدِّ
u'عسر حَدٌّ':Added, #1: 1	عُسْرُ الْحَدِّ
u'عُسْرٌ حَدٌّ':Added, #1: 1	عُسْرِ حَدِّ
u'عَسُرَ خَلْعٌ':Subject, #1: 1	عُسْرِ حَدِّ
u'عَسِرَ زَوالٌ':Subject, #1: 1	عَسُرَ خَلْعُ
u'عَسُرَ زَوالٌ':Subject, #1: 1	عَسِرَ زَوَالُهُ
u'عسر زَوْجٌ':Added, #3: 3	عَسُرَ زَوَالُهُ
u'عُسْرٌ زَوْجٌ':Added, #2: 2	عُسْرِ الزَّوْجِ
u'عَسُرَ عِلاَجٌ':Subject, #2: 2	عُسْرِ الزَّوْجِ
u'عَسِرَ علم':Predicate, #1: 1	عَسُرَ الْعِلَاجُ
u'عَسُرَ عَمَلٌ':Subject, #1: 1	عَسِرَ عُلِمَ
u'عسر غَسْلٌ':Added, #1: 1	عَسُرَ عَمَلُهُ
u'عُسْرٌ غَسْلٌ':Added, #1: 1	عُسْرُ غَسْلِ
u'عسر فرق':Added, #1: 1	عُسْرُ غَسْلِ
u'عسر فرق':Added, #1: 1	عُسْرُ الْفَرْقِ
u'عُسْرٌ فرق':Added, #1: 1	عُسْرِ الْفَرْقِ
u'عُسْرٌ فرق':Added, #1: 1	عُسْرُ الْفَرْقِ
u'عسر فَرْقٌ':Added, #1: 1	عُسْرِ الْفَرْقِ
u'عسر فَرْقٌ':Added, #1: 1	عُسْرُ الْفَرْقِ
u'عُسْرٌ فَرْقٌ':Added, #1: 1	عُسْرِ الْفَرْقِ
u'عُسْرٌ فَرْقٌ':Added, #1: 1	عُسْرُ الْفَرْقِ
u'عَسِرَ فِطَامٌ':Subject, #1: 1	عُسْرِ الْفَرْقِ
u'عَسُرَ فَهْمٌ':Subject, #1: 1	عَسِرَ فِطَامُهُ
u'عَسُرَ قول':Subject, #1: 1	عَسُرَ فَهْمُ
u'عَسُرَ قَوْلٌ':Subject, #1: 1	عَسُرَ الْقَوْلُ
u'عَسُرَ لَمْسٌ':Subject, #1: 1	عَسُرَ الْقَوْلُ
u'عَسُرَ نَظَرٌ':Subject, #2: 2	عَسُرَ لَمْسُهُ
u'عَسِرَ نَفَقَةٌ':Predicate, #1: 1	عَسُرَ النَّظَرُ
u'عَسُرَ وَزْنٌ':Subject, #1: 1	أَعْسَرَ نَفَقَةَ
u'عسر وُصُولٌ':Added, #2: 2	عَسُرَ الْوَزْنُ
u'عُسْرٌ وُصُولٌ':Added, #1: 1	عُسْرِ الْوُصُولِ
u'عسر يُسْرٌ':Added, #1: 1	عُسْرِ الْوُصُولِ
u'عُسْرٌ يُسْرٌ':Added, #1: 1	عُسْرُ يُسْرٍ
u'عَسَّلَ نَحْلٌ':Subject, #1: 1	عُسْرُ يُسْرٍ
u'عَسَى أيَّامٌ':Subject, #3: 3	عَسَّلَ النَّحْلُ
u'عَسَى أيَّامٌ':Subject, #1: 1	عَسَى الْأَيّامُ
u'عَسَى أَيَّامٌ':Subject, #1: 1	عَسَى الْأَيَّامُ
u'عَسَى أَيَّامٌ':Subject, #1: 1	عَسَى الْأَيّامُ
u'عَسَى رَبُّ':Subject, #1: 1	عَسَى الْأَيَّامُ
u'عَسَى رَجُلٌ':Subject, #4: 4	عَسَى رَبُّهُ
u'عَسَى سائِل':Subject, #1: 1	عَسَى رَجُلٌ
u'عَسَى سَائِلٌ':Subject, #1: 1	عَسَى سَائِلٌ
u'عَسَى فَرَجٌ':Subject, #1: 1	عَسَى سَائِلٌ
u'عَسَى وَاجِبٌ':Predicate, #1: 1	عَسَى فَرَجٌ
u'عَشَرَ إِبِلٌ':Subject, #3: 3	عَسَى وَاجِبَةً
u'عُشْرٌ إِبِلٌ':Added, #1: 1	عَشَرَ إبِلُ
u'عَشَرَ آتِي':Subject, #1: 1	عُشْرِ الْإِبِلِ
u'عُشْرٌ أَجْرٌ':Added, #1: 1	عَشَرَ الْآتِيَةُ
u'عُشْرٌ أَجْرٌ':Added, #1: 1	عُشْرَ أَجْرِ
u'عَشَرَ أحَدٌ':Predicate, #1: 1	عُشْرُ أَجْرِ
u'عَشَرَ أحَدٌ':Subject, #1: 1	عَشَرَ أَحَدَ
u'عَشَرَ أحْمَر':Predicate, #1: 1	عَشَرَ أَحَدُ
u'عَشَرَ إِخْبَارٌ':Subject, #14: 14	عَشَرَ أَحْمَرَ
u'عَشَرَ آخِرُ':Subject, #1: 1	عَشَرَ الْإِخْبَارُ
u'عَشَرَ أَرْبَعُ':Subject, #1: 1	عَشَرَ آخِرُ
u'عَشَرَ أَرْبَعَةٌ':Predicate, #2: 2	عَشَرَ أَرْبَعُ
u'عُشْرٌ أرْضٌ':Added, #1: 1	عَشَرَ أَرْبَعَةَ
u'عُشْرٌ أرْضٌ':Added, #1: 1	عُشْرِ أَرْضِهِ
u'عُشْرٌ أرْضٌ':Added, #2: 2	عُشْرُ الْأَرْضِ
u'عَشَرَ اِسْمٌ':Subject, #3: 3	عُشْرَ أَرْضِهِ
u'عَشَرَ أسْوَد':Predicate, #1: 1	عَشَرَ اسْمٌ
u'عَشَرَ أسْوَد':Subject, #6: 6	عَشَرَ أَسْوَدَ
u'عَشَرَ أَشْقَر':Predicate, #1: 1	عَشَرَ أَسْوَدُ
u'عُشْرٌ أصل':Added, #1: 1	عَشَرَ أَشْقَرَ
u'عُشْرٌ أًصْلٌ':Added, #1: 1	عُشْرُ الْأَصْلِ
u'عَشَرَ أَضْلاَعٌ':Subject, #1: 1	عُشْرُ الْأَصْلِ
u'عَشَرَ إِعادَةٌ':Subject, #1: 1	عَشَرَ أَضْلَاعُ
u'عُشْرٌ أعْيانٌ':Added, #1: 1	عَشَرَ إعَادَةُ
u'عُشْرٌ أَعْيَانٌ':Added, #1: 1	عُشْرُ الْأَعْيَانِ
u'عَشَرَ إقْرَارٌ':Subject, #1: 1	عُشْرُ الْأَعْيَانِ
u'عَشَرَ أَكْثَرُ':Predicate, #1: 1	عَشَرَ إقْرَارُ
u'عَشَرَ ألف':Predicate, #1: 1	عَشَرَ أَكْثَرَ
u'عَشَرَ ألْفٌ':Predicate, #51: 51	عَشَرَ أَلْفَ
u'عَشَرَ أَلْفٌ':Predicate, #51: 51	عَشَرَ أَلْفَ
u'عُشْرٌ ألف':Added, #51: 51	عَشَرَ أَلْفَ
u'عُشْرٌ ألْفٌ':Added, #1: 1	عُشْرَ الْأَلْفِ
u'عُشْرٌ أَلْفٌ':Added, #1: 1	عُشْرَ الْأَلْفِ
u'عُشْرٌ الْمَرْأَةُ':Added, #1: 1	عُشْرَ الْأَلْفِ
u'عُشْرٌ أُمٌّ':Added, #1: 1	عُشْرِ الْمَرْأَةِ
u'عُشْرٌ أُمٌّ':Added, #1: 1	عُشْرُ الْأُمِّ
u'عُشْرٌ أُمٌّ':Added, #1: 1	عُشْرِ أُمِّهِ
u'عَشَرَ اِمْرَأَةٌ':Subject, #2: 2	عُشْرُ أُمِّهِ
u'عُشْرٌ أَمْوَالٌ':Added, #1: 1	عَشَرَ امْرَأَةٌ
u'عَشَرَ اِنْتِهاءٌ':Predicate, #1: 1	عُشْرَ الْأَمْوَالِ
u'عَشَرَ أوْسَطُ':Subject, #1: 1	عَشَرَ انْتِهَاءَ
u'عَشَرَ أَوَّلُ':Predicate, #1: 1	عَشَرَ الْأَوْسَطُ
u'عَشَرَ أَوَّلُ':Subject, #1: 1	عَشَرَ الْأَوَّلَ
u'عُشْرٌ أَوَّلُ':Added, #1: 1	عَشَرَ أَوَّلُ
u'عَشَرَ بَانٌ':Predicate, #1: 1	عُشْرِ أَوَّلِ
u'عَشَرَ بَدَلٌ':Predicate, #2: 2	عَشَرَ بَانَ
u'عُشْرٌ بَدَلٌ':Added, #1: 1	عَشَرَ بَدَلَ
u'عُشْرٌ بَدَلٌ':Added, #1: 1	عُشْرُ الْبَدَلِ
u'عَشَرَ بَقِيَّةٌ':Subject, #2: 2	عُشْرِ بَدَلِ
u'عَشَرَ بَيَانٌ':Subject, #2: 2	عَشَرَ بَقِيَّةُ
u'عَشَرَ بَيْعٌ':Subject, #2: 2	عَشَرَ بَيَانُ
u'عَشَرَ بَيْنٌ':Predicate, #1: 1	عَشَرَ بَيْعُ
u'عَشَرَ بَيْنٌ':Predicate, #1: 1	عَشَرَ بَيْنَهُنَّ
u'عَشَرَ تَابِعٌ':Predicate, #4: 4	عَشَرَ بَيْنَ
u'عُشْرٌ تَبِيع':Added, #1: 1	عَشَرَ تَابِعَةً
u'عَشَرَ تَرْتِيبٌ':Subject, #1: 1	عُشْرِ تَبِيعٍ
u'عَشَرَ تِسْعَةٌ':Subject, #2: 2	عَشَرَ التَّرْتِيبُ
u'عَشَرَ تَشْرِيقٌ':Subject, #2: 2	عَشَرَ تِسْعَةٌ
u'عَشَرَ تَشَهُّدٌ':Subject, #2: 2	عَشَرَ تَشْرِيقٌ
u'عَشَرَ تَكْبِير':Predicate, #1: 1	عَشَرَ التَّشَهُّدُ
u'عَشَرَ تمام':Subject, #1: 1	عَشَرَ تَكْبِيرَةً
u'عَشَرَ تَمامٌ':Subject, #1: 1	عَشَرَ تَمَامُ
u'عَشَرَ ثَانِي':Predicate, #1: 1	عَشَرَ تَمَامُ
u'عَشَرَ ثَانِي':Subject, #1: 1	عَشَرَ الثَّانِيَةَ
u'عَشَرَ ثَانِيَةٌ':Predicate, #1: 1	عَشَرَ الثَّانِيَةُ
u'عَشَرَ ثَانِيَةٌ':Subject, #1: 1	عَشَرَ الثَّانِيَةَ
u'عَشَرَ ثَلاثُ':Subject, #1: 1	عَشَرَ الثَّانِيَةُ
u'عَشَرَ ثَلاثَةٌ':Predicate, #1: 1	عَشَرَ ثَلَاثُ
u'عَشَرَ ثَلاثَةٌ':Subject, #1: 1	عَشَرَ ثَلاَثَةَ
u'عَشَرَ ثَلاثَةٌ':Subject, #1: 1	عَشَرَ ثَلَاثَةٌ
u'عُشْرٌ ثِمارٌ':Added, #1: 1	عَشَرَ ثَلَاثَةُ
u'عُشْرٌ ثِمارٌ':Added, #1: 1	عُشْرَ الثِّمَارِ
u'عَشَرَ ثَمانِيَةٌ':Subject, #1: 1	عُشْرِ الثِّمَارِ
u'عُشْرٌ ثَمَرٌ':Added, #1: 1	عَشَرَ ثَمَانِيَةٌ
u'عُشْرٌ ثَمَرٌ':Added, #1: 1	عُشْرِ الثَّمَرِ
u'عُشْرٌ ثَمَرٌ':Added, #1: 1	عُشْرَ ثَمَرِ
u'عُشْرٌ ثَمَرٌ':Added, #1: 1	عُشْرَ ثَمَرِهِ
u'عُشْرٌ ثَمَرَةٌ':Added, #3: 3	عُشْرُ ثَمَرِهِ
u'عُشْرٌ ثَمَرَةٌ':Added, #1: 1	عُشْرَ الثَّمَرَةِ
u'عُشْرٌ ثَمَرَةٌ':Added, #1: 1	عُشْرِ الثَّمَرَةِ
u'عُشْرٌ ثَمَنٌ':Added, #1: 1	عُشْرُ ثَمَرَةِ
u'عُشْرٌ ثَمَنٌ':Added, #1: 1	عُشْرِ ثَمَنِهِ
u'عُشْرٌ ثَمَنٌ':Added, #2: 2	عُشْرَ ثَمَنِهِ
u'عُشْرٌ ثَمَنٌ':Added, #4: 4	عُشْرُ الثَّمَنِ
u'عُشْرٌ ثَمَنٌ':Added, #4: 4	عُشْرُ ثَمَنِهِ
u'عُشْرٌ ثَمَنٌ':Added, #5: 5	عُشْرَ الثَّمَنِ
u'عُشْرٌ ثَمَنٌ':Added, #5: 5	عُشْرِ الثَّمَنِ
u'عُشْرٌ ثَوْبٌ':Added, #7: 7	عُشْرُ ثَمَنِ
u'عَشَرَ جَازٌ':Predicate, #1: 1	عُشْرُ الثَّوْبِ
u'عُشْرٌ جَرِيب':Added, #1: 1	عَشَرَ جَازَ
u'عُشْرٌ جَزَاءٌ':Added, #2: 2	عُشْرُ الْجَرِيبِ
u'عَشَرَ جُلُوسٌ':Subject, #1: 1	عُشْرُ جَزَاءِ
u'عَشَرَ جهر':Subject, #1: 1	عَشَرَ الْجُلُوسُ
u'عَشَرَ جَهْرٌ':Subject, #1: 1	عَشَرَ الْجَهْرُ
u'عَشَرَ حَبٌّ':Predicate, #1: 1	عَشَرَ الْجَهْرُ
u'عُشْرٌ حَبٌّ':Added, #2: 2	عَشَرَ حَبَّةً
u'عُشْرٌ حَبٌّ':Added, #1: 1	عُشْر الْحَبِّ
u'عُشْرٌ حَبَّةٌ':Added, #2: 2	عُشْرِ حَبَّةٍ
u'عَشَرَ حَبْسٌ':Subject, #2: 2	عُشْرِ حَبَّةٍ
u'عَشَرَ حَديثٌ':Predicate, #1: 1	عَشَرَ حَبْسٌ
u'عَشَرَ حَرامٌ':Subject, #1: 1	عَشَرَ الْحَدِيثَ
u'عَشَرَ حُزَيرَانُ':Predicate, #1: 1	عَشَرَ حَرَامٌ
u'عُشْرٌ حِصَّةٌ':Added, #1: 1	عَشَرَ حُزَيْرَانَ
u'عُشْرٌ حِصَّةٌ':Added, #1: 1	عُشْرَ حِصَّةِ
u'عَشَرَ حَصَلٌ':Predicate, #1: 1	عُشْرُ حِصَّةِ
u'عَشَرَ حَقٌّ':Subject, #1: 1	عَشَرَ حَصَلَ
u'عُشْرٌ حَقٌّ':Added, #1: 1	عَشَرَ حَقُّ
u'عُشْرٌ حُلِيٌّ':Added, #1: 1	عُشْرَ حَقِّهِ
u'عَشَرَ حُمْرَةٌ':Subject, #1: 1	عُشْرُ الْحُلِيِّ
u'عُشْرٌ حِنْطَةٌ':Added, #1: 1	عَشَرَ الْحُمْرَةُ
u'عُشْرٌ حِنْطَةٌ':Added, #1: 1	عُشْرَ الْحِنْطَةِ
u'عُشْرٌ خَارِجٌ':Added, #1: 1	عُشْرِ الْحِنْطَةِ
u'عُشْرٌ خَرُّوب':Added, #1: 1	عُشْرَ الْخَارِجِ
u'عُشْرٌ خَرُّوبَة':Added, #1: 1	عُشْرِ خَرُّوبَةٍ
u'عَشَّرَ خَمْرٌ':Predicate, #1: 1	عُشْرِ خَرُّوبَةٍ
u'عَشَرَ خَمْرٌ':Predicate, #2: 2	عَشَّرَ الْخَمْرَ
u'عُشْرٌ خَمْرٌ':Added, #3: 3	عَشَرَ الْخَمْرَ
u'عَشَّرَ خوارج':Subject, #1: 1	عُشْرُ الْخَمْرِ
u'عَشَّرَ خَوَارِجُ':Subject, #1: 1	عَشَّرَ الْخَوَارِجُ
u'عَشَرَ خيار':Subject, #1: 1	عَشَّرَ الْخَوَارِجُ
u'عَشَرَ خِيَارٌ':Subject, #1: 1	عَشَرَ خِيَارُ
u'عَشَرَ دَاخِلٌ':Subject, #1: 1	عَشَرَ خِيَارُ
u'عُشْرٌ دَارٌ':Added, #1: 1	عَشَرَ دَاخِلٌ
u'عُشْرٌ دَارٌ':Added, #1: 1	عُشْرُ دَارٍ
u'عُشْرٌ دَارٌ':Added, #1: 1	عُشْرِ دَارٍ
u'عُشْرٌ دَارٌ':Added, #2: 2	عُشْرُ الدَّارِ
u'عَشَرَ دَرْء':Subject, #4: 4	عُشْرِ الدَّارِ
u'عَشَرَ دَرَاهِمُ':Predicate, #1: 1	عَشَرَ دَرْءُ
u'عَشَرَ دفع':Predicate, #2: 2	عَشَرَ دَرَاهِمَ
u'عُشْرٌ دِيَةٌ':Added, #2: 2	عَشَرَ دَفَعَ
u'عُشْرٌ دِيَةٌ':Added, #16: 16	عُشْرُ دِيَةِ
u'عُشْرٌ دِيَةٌ':Added, #16: 16	عُشْرِ دِيَةِ
u'عُشْرٌ دِيَةٌ':Added, #1: 1	عُشْرَ دِيَةِ
u'عُشْرٌ دِيَةٌ':Added, #1: 1	عُشْرُ دِيَةٍ
u'عُشْرٌ دِيَةٌ':Added, #1: 1	عُشْرِ دِيَةٍ
u'عُشْرٌ دِيَةٌ':Added, #2: 2	عُشْرُ دِيَتِهِ
u'عُشْرٌ دِيَةٌ':Added, #34: 34	عُشْرُ الدِّيَةِ
u'عُشْرٌ دِيَةٌ':Added, #3: 3	عُشْرِ دِيَتِهِ
u'عُشْرٌ دِيَةٌ':Added, #47: 47	عُشْرِ الدِّيَةِ
u'عُشْرٌ دِينارٌ':Added, #4: 4	عُشْرَ الدِّيَةِ
u'عُشْرٌ دِينارٌ':Added, #1: 1	عُشْرَ الدِّينَارِ
u'عُشْرٌ دِينارٌ':Added, #1: 1	عُشْرَ دِينَارِهِ
u'عُشْرٌ ذِراعٌ':Added, #2: 2	عُشْرِ دِينَارٍ
u'عَشَرَ ذكر':Subject, #1: 1	عُشْرَ ذِرَاعٍ
u'عَشَرَ ذَكَرٌ':Subject, #1: 1	عَشَرَ الذَّكَرُ
u'عُشْرٌ رَأْسٌ':Added, #1: 1	عَشَرَ الذَّكَرُ
u'عُشْرٌ رِبْحٌ':Added, #1: 1	عُشْرِ رَأْسِ
u'عُشْرٌ رِبْحٌ':Added, #1: 1	عُشْرَ الرِّبْحِ
u'عَشَرَ رُبْعٌ':Subject, #2: 2	عُشْرُ الرِّبْحِ
u'عَشَرَ رَجُلٌ':Predicate, #1: 1	عَشَرَ رُبْعُهُ
u'عَشَرَ رُجُوعٌ':Subject, #12: 12	عَشَرَ رَجُلاً
u'عُشْرٌ رَطْبٌ':Added, #1: 1	عَشَرَ الرُّجُوعُ
u'عُشْرٌ رُطَبٌ':Added, #1: 1	عُشْرُ الرَّطْبِ
u'عُشْرٌ رُطَبٌ':Added, #1: 1	عُشْرَ الرُّطَبِ
u'عَشَرَ رِطْلٌ':Predicate, #1: 1	عُشْرِ رُطَبِهِ
u'عَشَرَ رَمْلِيٌّ':Subject, #1: 1	عَشَرَ رِطْلاً
u'عَشَرَ زادٌ':Predicate, #1: 1	عَشَرَ رَمْلِيٌّ
u'عُشْرٌ زَرْعٌ':Added, #1: 1	عَشَرَ زَادَ
u'عُشْرٌ زَرْعٌ':Added, #1: 1	عُشْرِ الزَّرْعِ
u'عُشْرٌ زَرْعٌ':Added, #1: 1	عُشْرِ زَرْعٍ
u'عُشْرٌ زَرْعٌ':Added, #1: 1	عُشْرِ زَرْعِهِ
u'عُشْرٌ زَرْعٌ':Added, #2: 2	عُشْرَ زَرْعِهِ
u'عُشْرٌ زَرْعٌ':Added, #5: 5	عُشْرَ الزَّرْعِ
u'عَشَرَ زَكاةٌ':Subject, #6: 6	عُشْرُ الزَّرْعِ
u'عُشْرٌ زَكاةٌ':Added, #1: 1	عَشَرَ الزَّكَاةُ
u'عَشَرَ زَوْجٌ':Subject, #3: 3	عُشْرُ الزَّكَاةِ
u'عَشَرَ زَوْجَةٌ':Subject, #3: 3	عَشَرَ زَوْجٌ
u'عُشْرٌ زَيْتٌ':Added, #1: 1	عَشَرَ زَوْجَةٌ
u'عُشْرٌ زَيْتونٌ':Added, #1: 1	عُشْرَ زَيْتِهِ
u'عَشَرَ سَبْعٌ':Subject, #1: 1	عُشْرِ الزَّيْتُونِ
u'عَشَرَ سَبْعَةٌ':Predicate, #1: 1	عَشَرَ سَبْعٌ
u'عَشَرَ سَبْعَةٌ':Subject, #1: 1	عَشَرَ سَبْعَةَ
u'عَشَرَ سِتٌّ':Subject, #2: 2	عَشَرَ سَبْعَةٌ
u'عَشَرَ سُكُوتٌ':Subject, #2: 2	عَشَرَ سِتَّةٌ
u'عَشَرَ سُكُوتٌ':Subject, #1: 1	عَشَرَ السُّكُوتُ
u'عَشَرَ سلام':Subject, #1: 1	عَشَرَ سُكُوتُ
u'عَشَرَ سَلاَمٌ':Subject, #1: 1	عَشَرَ السَّلَامُ
u'عَشَرَ سَلْخٌ':Subject, #1: 1	عَشَرَ السَّلَامُ
u'عَشَرَ سَمٌّ':Subject, #2: 2	عَشَرَ سَلْخُ
u'عُشْرٌ سَهْمٌ':Added, #1: 1	عَشَرَ سَمَّاهُ
u'عُشْرٌ سَهْمٌ':Added, #1: 1	عُشْرُ سَهْمٍ
u'عَشَرَ سَوادٌ':Subject, #1: 1	عُشْرِ سَهْمٍ
u'عُشْرٌ شَاةٌ':Added, #1: 1	عَشَرَ السَّوَادُ
u'عُشْرٌ شَاةٌ':Added, #1: 1	عُشْرَ شَاةٍ
u'عَشَرَ شُبْهَةٌ':Subject, #1: 1	عُشْرُ شَاةٍ
u'عَشَرَ شَعْبَانُ':Predicate, #1: 1	عَشَرَ شُبْهَةُ
u'عُشْرٌ شَعِيرٌ':Added, #1: 1	عَشَرَ شَعْبَانَ
u'عَشَرَ صَالِحٌ':Subject, #1: 1	عُشْرِ الشَّعِيرِ
u'عَشَرَ صَالِح':Subject, #1: 1	عَشَرَ صَالِحٌ
u'عُشْرٌ صبرة':Added, #1: 1	عَشَرَ صَالِحٌ
u'عُشْرٌ صُبْرَةٌ':Added, #1: 1	عُشْرَ الصُّبْرَةِ
u'عَشَرَ صَبِيحٌ':Predicate, #1: 1	عُشْرَ الصُّبْرَةِ
u'عَشَرَ صَحِيحٌ':Subject, #1: 1	عَشَرَ صَبِيحَةَ
u'عَشَرَ صدقة':Subject, #1: 1	عَشَرَ الصَّحِيحُ
u'عَشَرَ صَدَقَةٌ':Subject, #3: 3	عَشَرَ صَدَقَةٌ
u'عَشَرَ صَرِيحٌ':Subject, #3: 3	عَشَرَ صَدَقَةٌ
u'عَشَرَ صَلاَةٌ':Subject, #1: 1	عَشَرَ صَرِيحٌ
u'عَشَرَ صَلاَةٌ':Subject, #1: 1	عَشَرَ صَلَاةُ
u'عُشْرٌ صَلاَةٌ':Added, #2: 2	عَشَرَ الصَّلَاةُ
u'عَشَرَ ضَمِنٌ':Predicate, #1: 1	عُشْرُ صَلاَتِهِ
u'عُشْرٌ ضَيْعَةٌ':Added, #1: 1	عَشَرَ ضَمِنَ
u'عُشْرٌ طَاهِرٌ':Added, #1: 1	عُشْرَ الضَّيْعَةِ
u'عُشْرٌ طعام':Added, #1: 1	عُشْرَ الطَّاهِرِ
u'عُشْرٌ طعام':Added, #1: 1	عُشْرُ الطَّعَامِ
u'عُشْرٌ طَعَامٌ':Added, #1: 1	عُشْرِ الطَّعَامِ
u'عُشْرٌ طَعَامٌ':Added, #1: 1	عُشْرُ الطَّعَامِ
u'عُشْرٌ طعام':Added, #1: 1	عُشْرِ الطَّعَامِ
u'عُشْرٌ طَعَامٌ':Added, #1: 1	عُشْرَ طَعَامِ
u'عُشْرٌ طعام':Added, #1: 1	عُشْرَ طَعَامِ
u'عُشْرٌ طَعَامٌ':Added, #1: 1	عُشْرَ طَعَامِهِ
u'عُشْرٌ طعام':Added, #1: 1	عُشْرَ طَعَامِهِ
u'عُشْرٌ طَعَامٌ':Added, #3: 3	عُشْرَ الطَّعَامِ
u'عَشَرَ طُهْرٌ':Subject, #3: 3	عُشْرَ الطَّعَامِ
u'عَشَرَ طهر':Subject, #15: 15	عَشَرَ طُهْرٌ
u'عَشَرَ طُهْرٌ':Subject, #1: 1	عَشَرَ طُهْرُ
u'عَشَرَ عَبْدٌ':Subject, #1: 1	عَشَرَ طُهْرُ
u'عَشَرَ عتق':Predicate, #1: 1	عَشَرَ الْعَبْدُ
u'عَشَرَ عَدٌّ':Predicate, #2: 2	عَشَرَ عَتَقَ
u'عَشَرَ عَدَدٌ':Subject, #3: 3	عَشَرَ عَدَّ
u'عُشْرٌ عَرْضٌ':Added, #1: 1	عَشَرَ عَدَدُ
u'عُشْرٌ عُرُوضٌ':Added, #1: 1	عُشْرُ الْعَرْضِ
u'عُشْرٌ عُشْرٌ':Added, #1: 1	عُشْرِ الْعُرُوضِ
u'عَشَرَ علم':Predicate, #1: 1	عُشْرُ الْعُشْرِ
u'عُشْرٌ علماء':Added, #1: 1	عَشَرَ عَلِمَ
u'عُشْرٌ عُلَمَاءُ':Added, #1: 1	عُشْرِ الْعُلَمَاءِ
u'عَشَرَ عند':Predicate, #1: 1	عُشْرِ الْعُلَمَاءِ
u'عُشْرٌ عين':Added, #2: 2	عَشَرَ عِنْدَ
u'عُشْرٌ عَيْنٌ':Added, #1: 1	عُشْرِ الْعَيْنِ
u'عُشْرٌ عَيْن':Added, #1: 1	عُشْرِ الْعَيْنِ
u'عُشْرٌ غَلَّةٌ':Added, #1: 1	عُشْرِ الْعَيْنِ
u'عُشْرٌ غَلَّةٌ':Added, #1: 1	عُشْرُ غَلَّةِ
u'عُشْرٌ غَلَّةٌ':Added, #3: 3	عُشْرَ الْغَلَّاتِ
u'عَشَرَ غير':Predicate, #5: 5	عُشْرَ الْغَلَّةِ
u'عَشَرَ غَيْرٌ':Predicate, #4: 4	عَشَرَ غَيْرَ
u'عُشْرٌ فَصْلٌ':Added, #4: 4	عَشَرَ غَيْرَ
u'عُشْرٌ فِضَّةٌ':Added, #1: 1	عُشْرُ الْفَصْلِ
u'عُشْرٌ فَضْلٌ':Added, #1: 1	عُشْرِ الْفِضَّةِ
u'عَشَرَ فقراء':Predicate, #1: 1	عُشْرُ الْفَضْلِ
u'عَشَرَ فلان':Subject, #1: 1	عَشَرَ فُقَرَاءَ
u'عُشْرٌ فلان':Added, #1: 1	عَشَرَ بِلَالٌ
u'عَشَرَ قَالٌ':Predicate, #1: 1	عُشْرِ خَرُّوبَةٍ
u'عَشَرَ قَبْضٌ':Subject, #12: 12	عَشَرَ قَالَ
u'عَشَرَ قَدْرٌ':Predicate, #1: 1	عَشَرَ قَبْضُ
u'عُشْرٌ قَفِيز':Added, #1: 1	عَشَرَ قَدْرَ
u'عُشْرٌ قلب':Added, #1: 1	عُشْرُ الْقَفِيزِ
u'عُشْرٌ قَلْبٌ':Added, #2: 2	عُشْرِ الْقَلْبِ
u'عُشْرٌ قَلْب':Added, #2: 2	عُشْرِ الْقَلْبِ
u'عُشْرٌ قَنَاةٌ':Added, #2: 2	عُشْرِ الْقَلْبِ
u'عَشَرَ قول':Predicate, #1: 1	عُشْرَ قَنَاةٍ
u'عَشَرَ قَوْلٌ':Predicate, #1: 1	عَشَرَ الْقَوْلَ
u'عَشَرَ قول':Subject, #1: 1	عَشَرَ الْقَوْلَ
u'عَشَرَ قَوْلٌ':Subject, #1: 1	عَشَرَ قَوْلُ
u'عَشَرَ قول':Subject, #1: 1	عَشَرَ قَوْلُ
u'عَشَرَ قَوْلٌ':Subject, #2: 2	عَشَرَ قَوْلُهُ
u'عُشْرٌ قِيمَةٌ':Added, #2: 2	عَشَرَ قَوْلُهُ
u'عُشْرٌ قِيمَةٌ':Added, #14: 14	عُشْرِ قِيمَةِ
u'عُشْرٌ قِيمَةٌ':Added, #17: 17	عُشْرِ الْقِيمَةِ
u'عُشْرٌ قِيمَةٌ':Added, #23: 23	عُشْرُ قِيمَةِ
u'عُشْرٌ قِيمَةٌ':Added, #28: 28	عُشْرِ قِيمَتِهِ
u'عُشْرٌ قِيمَةٌ':Added, #4: 4	عُشْرُ قِيمَتِهِ
u'عُشْرٌ قِيمَةٌ':Added, #5: 5	عُشْرُ الْقِيمَةِ
u'عُشْرٌ كَسْبٌ':Added, #6: 6	عُشْرَ قِيمَةِ
u'عَشَرَ كِفَايَةٌ':Subject, #1: 1	عُشْرَ كَسْبِهِ
u'عَشَرَ لَيْلٌ':Predicate, #1: 1	عَشَرَ كِفَايَةٌ
u'عُشْرٌ مَالٌ':Added, #1: 1	عَشَرَ لَيْلَةً
u'عُشْرٌ مَالٌ':Added, #1: 1	عُشْرِ مَالِهِ
u'عَشَرَ مثل':Subject, #2: 2	عُشْرِ الْمَالِ
u'عَشَرَ مِثْلٌ':Subject, #3: 3	عَشَرَ مِثْلُ
u'عَشَرَ مُحَرَّمٌ':Subject, #3: 3	عَشَرَ مِثْلُ
u'عَشَرَ مُخَالِفٌ':Subject, #1: 1	عَشَرَ مُحَرَّمَةٌ
u'عَشَرَ مَذْكُورٌ':Subject, #1: 1	عَشَرَ مُخَالِفٌ
u'عَشَرَ مرٌّ':Predicate, #1: 1	عَشَرَ الْمَذْكُورَةُ
u'عُشْرٌ مَسَائِلُ':Added, #2: 2	عَشَرَ مَرَّةً
u'عَشَرَ مُسْتَحَبٌّ':Subject, #1: 1	عُشْرُ الْمَسَائِلِ
u'عُشْرٌ مُسِنٌّ':Added, #1: 1	عَشَرَ مُسْتَحَبٌّ
u'عُشْرٌ مُسِنٌّ':Added, #11: 11	عُشْرِ مُسِنَّةٍ
u'عَشَرَ مَضْرُوبٌ':Subject, #1: 1	عُشْرُ مُسِنَّةٍ
u'عَشَرَ مَضْمُومٌ':Subject, #1: 1	عَشَرَ مَضْرُوبَةٌ
u'عَشَرَ مَغْصُوب':Subject, #1: 1	عَشَرَ مَضْمُومَةٌ
u'عَشَرَ مَقْبُوضٌ':Subject, #1: 1	عَشَرَ الْمَغْصُوبُ
u'عَشَرَ مِقْدَارٌ':Predicate, #2: 2	عَشَرَ الْمَقْبُوضُ
u'عُشْرٌ مِقْدَارٌ':Added, #1: 1	عَشَرَ مِقْدَارَ
u'عَشَرَ مَقْسُومٌ':Subject, #2: 2	عُشْرُ مِقْدَارِ
u'عُشْرٌ مَقْطُوعٌ':Added, #1: 1	عَشَرَ مَقْسُومٌ
u'عَشَرَ مُكَسَّرٌ':Predicate, #1: 1	عُشْرِ الْمَقْطُوعِ
u'عَشَرَ مُوَافَقَةٌ':Subject, #1: 1	عَشَرَ مُكَسَّرَةً
u'عُشْرٌ مُوجَبٌ':Added, #1: 1	عَشَرَ مُوَافَقَةٌ
u'عَشَرَ مَوْقُوفٌ':Subject, #2: 2	عُشْرُ مُوجَبِ
u'عَشَرَ ميل':Predicate, #1: 1	عَشَرَ مَوْقُوفَةٌ
u'عَشَرَ مِيلٌ':Predicate, #3: 3	عَشَرَ مِيلاً
u'عَشَرَ نُحَاسٌ':Subject, #3: 3	عَشَرَ مِيلاً
u'عُشْرٌ نَخْلٌ':Added, #1: 1	عَشَرَ نُحَاسٌ
u'عَشَرَ نِصْفٌ':Subject, #1: 1	عُشْرِ النَّخْلِ
u'عَشَرَ نَصِيبٌ':Subject, #1: 1	عَشَرَ نِصْفُ
u'عُشْرٌ نَصِيبٌ':Added, #2: 2	عَشَرَ النَّصِيبُ
u'عُشْرٌ نَصِيبٌ':Added, #1: 1	عُشْرُ نَصِيبِ
u'عَشَرَ نَظَرٌ':Predicate, #1: 1	عُشْرُ نَصِيبِهِ
u'عَشَرَ نَظِيرٌ':Subject, #1: 1	عَشَرَ نَظَرَ
u'عُشْرٌ نَعْجَةٌ':Added, #1: 1	عَشَرَ نَظِيرُهُ
u'عَشَرَ نفر':Subject, #1: 1	عُشْرِ النَّعْجَةِ
u'عَشَرَ نَفْرٌ':Subject, #1: 1	عَشَرَ النَّفْرُ
u'عَشَرَ نُقَبَاءُ':Predicate, #1: 1	عَشَرَ النَّفْرُ
u'عُشْرٌ نَهْرٌ':Added, #1: 1	عَشَرَ النُّقَبَاءَ
u'عُشْرٌ نَهْرٌ':Added, #1: 1	عُشْرَ نَهْرٍ
u'عُشْرٌ وَاجِبٌ':Added, #1: 1	عُشْرِ نَهْرٍ
u'عُشْرٌ واحد':Added, #1: 1	عُشْرُ وَاجِبِ
u'عُشْرٌ وَاحِدٌ':Added, #5: 5	عُشْرٍ وَاحِدٍ
u'عَشَرَ وَجَبٌ':Predicate, #5: 5	عُشْرٍ وَاحِدٍ
u'عَشَرَ وُجُودٌ':Subject, #1: 1	عَشَرَ وَجَبَ
u'عُشْرٌ وَرْسٌ':Added, #1: 1	عَشَرَ وُجُودُ
u'عَشَرَ وقع':Predicate, #2: 2	عُشْرَ الْوَرْسِ
u'عَشَرَ وَقْفٌ':Subject, #1: 1	عَشَرَ وَقَعَ
u'عَشَرَ وَقِيّ':Predicate, #1: 1	عَشَرَ وَقْفٌ
u'عُشْرٌ ولد':Added, #1: 1	عَشَرَ وَقِيَّةً
u'عُشْرٌ وَلَدٌ':Added, #1: 1	عُشْرُ الْوَلَدِ
u'عُشْرٌ يَابِسٌ':Added, #1: 1	عُشْرُ الْوَلَدِ
u'عَشَرَ يَوْمٌ':Subject, #1: 1	عُشْرَ يَابِسِهِ
u'عُشْرٌ يَوْمٌ':Added, #2: 2	عَشَرَ يَوْمُ
u'عَشَّشَ طَائِرٌ':Subject, #1: 1	عُشْرِ يَوْمٍ
u'عَشَّشَ طَائِرٌ':Subject, #1: 1	عَشَّشَ الطَّائِرُ
u'عِشْقٌ نِساءٌ':Added, #1: 1	عَشَّشَ طَائِرٌ
u'عُشُورٌ نَحْلٌ':Added, #1: 1	عِشْقِ النّسَاءِ
u'عُشُورٌ نَخْلٌ':Added, #2: 2	عُشُورِ نَحْلِهِ
u'عَشِيَ بَصَرٌ':Subject, #1: 1	عُشُورِ نَخْلِهِ
u'عَصَا قَدِيمٌ':Subject, #1: 1	عَشِيَ الْبَصَرُ
u'عَصَا مُحَدَّدٌ':Predicate, #1: 1	عَصَا الْقَدِيمُ
u'عَصَا مُسْلِمٌ':Predicate, #1: 1	عَصَا مُحَدَّدَةً
u'عَصَبَ جُرْحٌ':Predicate, #4: 4	عَصَا الْمُسْلِمِينَ
u'عَصَبٌ جَمِيع':Added, #1: 1	عَصَبَ جُرْحَ
u'عَصَبٌ حِسٌّ':Added, #1: 1	عَصَبُ الْجَمِيعِ
u'عَصَبٌ رَأْسٌ':Added, #1: 1	عَصَبِ الْحِسِّ
u'عَصَبَ رِيقٌ':Predicate, #1: 1	عَصَبِ الرَّأْسِ
u'عَصَبَ رَيْقٌ':Predicate, #1: 1	عَصَبَ الرّيقَ
u'عَصَبَ عِصَابَةٌ':Predicate, #1: 1	عَصَبَ الرّيقَ
u'عَصَبٌ مَيْتٌ':Added, #1: 1	عَصَبَ الْعِصَابَةَ
u'عَصَبٌ مَيْتَةٌ':Added, #1: 1	عَصَبُ الْمَيْتَةِ
u'عَصَبٌ يَابِسٌ':Added, #1: 1	عَصَبُ الْمَيْتَةِ
u'عَصَرَ بَثْر':Predicate, #4: 4	عَصَبٍ يَابِسٍ
u'عَصَرَ ثَوْبٌ':Predicate, #2: 2	عَصَرَ بَثْرَةً
u'عَصَرَ قرحة':Predicate, #5: 5	عَصَرَ الثَّوْبَ
u'عَصَرَ قُرْحَةٌ':Predicate, #1: 1	عَصَرَ الْقُرْحَةَ
u'عَصَرَ مَاءٌ':Predicate, #1: 1	عَصَرَ الْقُرْحَةَ
u'عَصَمَ إلَهٌ':Subject, #2: 2	عَصَرَ مَاءَ
u'عَصَمَ أُمَّةٌ':Predicate, #1: 1	عَصَمَ الْإِلَهُ
u'عَصَمَ جُمْلَةٌ':Predicate, #1: 1	عَصَمَ الْأُمَّةَ
u'عَصَى أقْرَبُ':Subject, #1: 1	عَصَمَ جُمْلَةَ
u'عِصْيَانٌ أَصْحَابٌ':Added, #1: 1	عَصَى الْأَقْرَبُ
u'عِصْيَانٌ أَميرٌ':Added, #1: 1	عِصْيَانِ أَصْحَابِ
u'عَصَى أنبياء':Subject, #1: 1	عِصْيَانُ الْأَمِيرِ
u'عِصْيَانٌ سَفَرٌ':Added, #1: 1	عَصَى الْأَنْبِيَاءُ
u'عِصْيَانٌ مَأْمُورٌ':Added, #1: 1	عِصْيَانِ السَّفَرِ
u'عِصْيَانٌ مُسَافِرٌ':Added, #1: 1	عِصْيَانِ الْمَأْمُورِ
u'عِصْيَانٌ نَفْسٌ':Added, #1: 1	عِصْيَانِ الْمُسَافِرِ
u'عَصَى حاضِرٌ':Subject, #1: 1	عِصْيَانُ نَفْسِهِ
u'عَصَى رَقيقٌ':Subject, #1: 1	عَصَى الْحَاضِرُ
u'عَصَى رَقيق':Subject, #2: 2	عَصَى الرَّقِيقُ
u'عَصَى مُكَلَّفٌ':Subject, #2: 2	عَصَى الرَّقِيقُ
u'عَصَى نَائِمٌ':Subject, #1: 1	عَصَى الْمُكَلَّفُ
u'عَصَى وَلِيٌّ':Subject, #1: 1	عَصَى النَّائِمُ
u'عَضَّ إِنْسانٌ':Subject, #1: 1	عَصَى الْوَلِيُّ
u'عَضَّ ذِراعٌ':Predicate, #1: 1	عَضَّ إنْسَانٌ
u'عَضَّ كَلْبٌ':Subject, #1: 1	عَضَّ ذِرَاعَ
u'عَضَلَ أقْرَبُ':Subject, #1: 1	عَضَّ كَلْبٌ
u'عَضَلَ أقْرَبُ':Subject, #1: 1	عَضَلَ أَقْرَبُ
u'عَضَلَ واحد':Subject, #1: 1	عَضَلَ الْأَقْرَبُ
u'عَضَلَ وَاحِدٌ':Subject, #2: 2	عَضَلَ وَاحِدٌ
u'عَضَلَ وَلِيٌّ':Subject, #2: 2	عَضَلَ وَاحِدٌ
u'عَضَّ مَكْرُوهٌ':Subject, #3: 3	عَضَلَ الْوَلِيُّ
u'عَضَّ يَدٌ':Predicate, #1: 1	عَضَّ مَكْرُوهٌ
u'عَطِبَ أحَدٌ':Subject, #3: 3	عَضَّ يَدَ
u'عَطِبَ بَعْضٌ':Subject, #1: 1	عَطِبَ أَحَدُ
u'عَطِبَ سَائِرٌ':Subject, #2: 2	عَطِبَ بَعْضُ
u'عَطِبَ صَبِيٌّ':Subject, #1: 1	عَطِبَ السَّائِرُ
u'عَطِبَ صَيْدٌ':Subject, #1: 1	عَطِبَ الصَّبِيُّ
u'عَطِبَ ضَمِنٌ':Predicate, #1: 1	عَطِبَ الصَّيْدُ
u'عَطِبَ عَبْدٌ':Subject, #1: 1	عَطِبَ ضَمِنَ
u'عَطِبَ غُلاَمٌ':Subject, #2: 2	عَطِبَ الْعَبْدُ
u'عَطِبَ قَالٌ':Predicate, #1: 1	عَطِبَ الْغُلَامُ
u'عَطِبَ هَدْيٌ':Subject, #1: 1	عَطِبَ قَالَ
u'عَطِبَ هَدْيٌ':Subject, #1: 1	عَطِبَ هَدْيُهُ
u'عَطِبَ وَاجِبٌ':Subject, #3: 3	عَطِبَ الْهَدْيُ
u'عَطِبَ وَاجِبٌ':Subject, #1: 1	عَطِبَ الْوَاجِبُ
u'عَطَسَ أَكْثَرُ':Predicate, #1: 1	عَطِبَ وَاجِبٌ
u'عَطَسَ أَمْس':Predicate, #2: 2	عَطَسَ أَكْثَرَ
u'عَطَسَ إِنْسانٌ':Subject, #1: 1	عَطَسَ أَمْسَكَ
u'عَطَسَ رابع':Predicate, #1: 1	عَطَسَ الْإِنْسَانُ
u'عَطَسَ رَابِعٌ':Predicate, #1: 1	عَطَسَ رَابِعَةً
u'عَطَسَ رَجُلٌ':Subject, #1: 1	عَطَسَ رَابِعَةً
u'عَطَسَ رَجُلٌ':Subject, #12: 12	عَطَسَ رَجُلٌ
u'عَطَسَ سَامِعٌ':Subject, #6: 6	عَطَسَ الرَّجُلُ
u'عَطَسَ سُلْطَانٌ':Subject, #1: 1	عَطَسَ السَّامِعُ
u'عَطَسَ شَابٌّ':Subject, #1: 1	عَطَسَ السُّلْطَانُ
u'عَطَسَ صَاحِبٌ':Subject, #1: 1	عَطَسَ شَابٌّ
u'عَطَسَ صَبِيٌّ':Subject, #1: 1	عَطَسَ صَاحِبُهُ
u'عَطَسَ عند':Predicate, #1: 1	عَطَسَ صَبِيٌّ
u'عَطَسَ غَضٌّ':Predicate, #5: 5	عَطَسَ عِنْدَ
u'عَطَسَ غير':Subject, #1: 1	عَطَسَ غَضَّ
u'عَطَسَ غَيْرٌ':Subject, #1: 1	عَطَسَ غَيْرُهُ
u'عَطَسَ فُلاَنٌ':Subject, #1: 1	عَطَسَ غَيْرُهُ
u'عَطَسَ كَافِرٌ':Subject, #1: 1	عَطَسَ فُلَانٌ
u'عَطَسَ نَصٌّ':Predicate, #1: 1	عَطَسَ كَافِرٌ
u'عَطَسَ يَهُودِيٌّ':Subject, #1: 1	عَطَسَ نَصَّ
u'عَطَسَ يَوْمٌ':Predicate, #1: 1	عَطَسَ يَهُودِيٌّ
u'عَطِشَ أصل':Subject, #1: 1	عَطَسَ يَوْمَ
u'عَطِشَ أًصْلٌ':Subject, #1: 1	عَطِشَ الْأَصْلُ
u'عَطِشَ إِنْسانٌ':Subject, #1: 1	عَطِشَ الْأَصْلُ
u'عَطِشَ إِنْسانٌ':Subject, #1: 1	عَطِشَ الإِنْسَانُ
u'عَطِشَ بَعْضٌ':Subject, #1: 1	عَطِشَ الْإِنْسَانُ
u'عَطَشٌ حَيَوَانٌ':Added, #1: 1	عَطِشَ بَعْضُ
u'عَطِشَ رَسُولٌ':Subject, #1: 1	عَطَشَ حَيَوَانٍ
u'عَطَشٌ رَفيقٌ':Added, #2: 2	عَطِشَ رَسُولُ
u'عَطِشَ زَرْعٌ':Subject, #1: 1	عَطَشَ رَفِيقِهِ
u'عَطَشٌ غير':Added, #1: 1	عَطِشَ الزَّرْعُ
u'عَطَشٌ غَيْرٌ':Added, #3: 3	عَطَشِ غَيْرِهِ
u'عَطَشٌ مُحْتَرَمٌ':Added, #3: 3	عَطَشِ غَيْرِهِ
u'عَطَشٌ مُحْتَرَمٌ':Added, #1: 1	عَطَشٍ مُحْتَرَمٍ
u'عَطَشٌ نَفْسٌ':Added, #1: 1	عَطَشَ مُحْتَرَمٍ
u'عَطَشٌ نَفْسٌ':Added, #1: 1	عَطَشُ نَفْسِهِ
u'عَطَشٌ نَفْسٌ':Added, #2: 2	عَطَشَ نَفْسِهِ
u'عطف اِبْنٌ':Added, #2: 2	عَطَشِ نَفْسِهِ
u'عَطْفٌ اِبْنٌ':Added, #1: 1	عَطْفِ ابْنِ
u'عَطَفَ إِبْهَامٌ':Predicate, #1: 1	عَطْفِ ابْنِ
u'عَطَفَ أحَدٌ':Predicate, #1: 1	عَطَفَ الإِبْهَامَ
u'عطف إِخْبَارٌ':Added, #2: 2	عَطَفَ أَحَدَ
u'عَطْفٌ إِخْبَارٌ':Added, #1: 1	عَطْفِ الْإِخْبَارِ
u'عطف أَصْحَابٌ':Added, #1: 1	عَطْفِ الْإِخْبَارِ
u'عَطْفٌ أَصْحَابٌ':Added, #1: 1	عَطْفُ الْأَصْحَابِ
u'عَطَفَ أصل':Subject, #1: 1	عَطْفُ الْأَصْحَابِ
u'عَطَفَ أًصْلٌ':Subject, #1: 1	عَطَفَ الْأَصْلُ
u'عطف أصل':Added, #1: 1	عَطَفَ الْأَصْلُ
u'عطف أصل':Added, #1: 1	عَطْفُ الْأَصْلِ
u'عطف أًصْلٌ':Added, #1: 1	عَطْفِ الْأَصْلِ
u'عطف أًصْلٌ':Added, #1: 1	عَطْفُ الْأَصْلِ
u'عَطْفٌ أصل':Added, #1: 1	عَطْفِ الْأَصْلِ
u'عَطْفٌ أصل':Added, #1: 1	عَطْفُ الْأَصْلِ
u'عَطْفٌ أًصْلٌ':Added, #1: 1	عَطْفِ الْأَصْلِ
u'عَطْفٌ أًصْلٌ':Added, #1: 1	عَطْفُ الْأَصْلِ
u'عطف أصل':Added, #1: 1	عَطْفِ الْأَصْلِ
u'عطف أًصْلٌ':Added, #2: 2	عَطْفِ أَصْلِهِ
u'عَطْفٌ أصل':Added, #2: 2	عَطْفِ أَصْلِهِ
u'عَطْفٌ أًصْلٌ':Added, #2: 2	عَطْفِ أَصْلِهِ
u'عَطَفَ إِعْتاقٌ':Predicate, #2: 2	عَطْفِ أَصْلِهِ
u'عَطَفَ أقْرَبُ':Predicate, #1: 1	عَطَفَ الْإِعْتَاقَ
u'عَطَفَ اِنْتِظارٌ':Predicate, #2: 2	عَطَفَ الْأَقْرَبِينَ
u'عَطَفَ بَائِنٌ':Predicate, #1: 1	عَطَفَ انْتِظَارَ
u'عَطَفَ بَعْضٌ':Predicate, #1: 1	عَطَفَ الْبَائِنَ
u'عَطَفَ بَعْضٌ':Predicate, #2: 2	عَطَفَ الْبَعْضَ
u'عطف بَعْضٌ':Added, #2: 2	عَطَفَ بَعْضَ
u'عَطْفٌ بَعْضٌ':Added, #1: 1	عَطْفِ الْبَعْضِ
u'عَطَفَ بِكْرٌ':Predicate, #1: 1	عَطْفِ الْبَعْضِ
u'عطف بَيَانٌ':Added, #1: 1	عَطَفَ الْبِكْرَ
u'عَطْفٌ بَيَانٌ':Added, #11: 11	عَطْفُ بَيَانٍ
u'عطف بَيَانٌ':Added, #11: 11	عَطْفُ بَيَانٍ
u'عَطْفٌ بَيَانٌ':Added, #1: 1	عَطْفَ الْبَيَانِ
u'عطف بَيَانٌ':Added, #1: 1	عَطْفَ الْبَيَانِ
u'عَطْفٌ بَيَانٌ':Added, #2: 2	عَطْفَ بَيَانٍ
u'عطف تَامٌّ':Added, #2: 2	عَطْفَ بَيَانٍ
u'عَطْفٌ تَامٌّ':Added, #1: 1	عَطْفِ التَّامَّةِ
u'عطف تَفْسِيرٌ':Added, #1: 1	عَطْفِ التَّامَّةِ
u'عَطْفٌ تَفْسِيرٌ':Added, #2: 2	عَطْفَ تَفْسِيرٍ
u'عطف تَفْسِيرٌ':Added, #2: 2	عَطْفَ تَفْسِيرٍ
u'عَطْفٌ تَفْسِيرٌ':Added, #8: 8	عَطْفُ تَفْسِيرٍ
u'عَطَفَ ثَالِثٌ':Predicate, #8: 8	عَطْفُ تَفْسِيرٍ
u'عَطَفَ ثَالِثٌ':Predicate, #1: 1	عَطَفَ الثَّالِثَةَ
u'عطف ثَالِثٌ':Added, #2: 2	عَطَفَ الثَّالِثَ
u'عَطْفٌ ثَالِثٌ':Added, #1: 1	عَطْفِ الثَّالِثِ
u'عطف ثَالِثٌ':Added, #1: 1	عَطْفِ الثَّالِثِ
u'عَطْفٌ ثَالِثٌ':Added, #2: 2	عَطْفُ الثَّالِثِ
u'عَطَفَ ثَانِي':Predicate, #2: 2	عَطْفُ الثَّالِثِ
u'عَطَفَ ثَانِيَةٌ':Predicate, #4: 4	عَطَفَ الثَّانِيَةَ
u'عطف جُزْءٌ':Added, #4: 4	عَطَفَ الثَّانِيَةَ
u'عَطْفٌ جُزْءٌ':Added, #2: 2	عَطْفِ الْجُزْءِ
u'عطف جُمَلٌ':Added, #2: 2	عَطْفِ الْجُزْءِ
u'عَطْفٌ جُمَلٌ':Added, #10: 10	عَطْفِ الْجُمَلِ
u'عَطَفَ جُمْلَةٌ':Predicate, #10: 10	عَطْفِ الْجُمَلِ
u'عطف جُمْلَةٌ':Added, #1: 1	عَطَفَ الْجُمْلَةَ
u'عطف جُمْلَةٌ':Added, #1: 1	عَطْفُ الْجُمْلَةِ
u'عَطْفٌ جُمْلَةٌ':Added, #1: 1	عَطْفِ الْجُمْلَةِ
u'عَطْفٌ جُمْلَةٌ':Added, #1: 1	عَطْفُ الْجُمْلَةِ
u'عطف جُمْلَةٌ':Added, #1: 1	عَطْفِ الْجُمْلَةِ
u'عَطْفٌ جُمْلَةٌ':Added, #1: 1	عَطْفَ جُمْلَةٍ
u'عطف جُمْلَةٌ':Added, #1: 1	عَطْفَ جُمْلَةٍ
u'عَطْفٌ جُمْلَةٌ':Added, #2: 2	عَطْفَ الْجُمْلَةِ
u'عطف جُمْلَةٌ':Added, #2: 2	عَطْفَ الْجُمْلَةِ
u'عَطْفٌ جُمْلَةٌ':Added, #4: 4	عَطْفُ جُمْلَةٍ
u'عطف خاصّ':Added, #4: 4	عَطْفُ جُمْلَةٍ
u'عَطْفٌ خاصّ':Added, #1: 1	عَطْفُ الْخَاصِّ
u'عطف خاصّ':Added, #1: 1	عَطْفُ الْخَاصِّ
u'عَطْفٌ خاصّ':Added, #23: 23	عَطْفِ الْخَاصِّ
u'عطف خاصّ':Added, #23: 23	عَطْفِ الْخَاصِّ
u'عَطْفٌ خاصّ':Added, #2: 2	عَطْفُ خَاصٍّ
u'عطف خاصّ':Added, #2: 2	عَطْفُ خَاصٍّ
u'عَطْفٌ خاصّ':Added, #6: 6	عَطْفَ الْخَاصِّ
u'عَطَفَ خَلْخَالٌ':Predicate, #6: 6	عَطْفَ الْخَاصِّ
u'عَطَفَ دَاليَةٌ':Predicate, #1: 1	عَطَفَ الْخَلْخَالَ
u'عطف دِرْهَمٌ':Added, #1: 1	عَطَفَ الدَّالِيَةَ
u'عطف دِرْهَم':Added, #1: 1	عَطْفُ الدِّرْهَمِ
u'عَطْفٌ دِرْهَمٌ':Added, #1: 1	عَطْفُ الدِّرْهَمِ
u'عَطْفٌ دِرْهَم':Added, #1: 1	عَطْفُ الدِّرْهَمِ
u'عطف رَطْبٌ':Added, #1: 1	عَطْفُ الدِّرْهَمِ
u'عَطْفٌ رَطْبٌ':Added, #1: 1	عَطْفِ رَطْبٍ
u'عطف زادٌ':Added, #1: 1	عَطْفِ رَطْبٍ
u'عَطْفٌ زادٌ':Added, #1: 1	عَطْفِ الزَّادِ
u'عطف زَمَنٌ':Added, #1: 1	عَطْفِ الزَّادِ
u'عَطْفٌ زَمَنٌ':Added, #1: 1	عَطْفَ زَمَنٍ
u'عَطَفَ زَوْجٌ':Subject, #1: 1	عَطْفَ زَمَنٍ
u'عطف سَبَبٌ':Added, #1: 1	عَطَفَ الزَّوْجُ
u'عَطْفٌ سَبَبٌ':Added, #2: 2	عَطْفِ السَّبَبِ
u'عطف شافِعِيّ':Added, #2: 2	عَطْفِ السَّبَبِ
u'عَطْفٌ شافِعِيّ':Added, #1: 1	عَطْفُ الشَّافِعِيِّ
u'عطف شَرْطٌ':Added, #1: 1	عَطْفُ الشَّافِعِيِّ
u'عَطْفٌ شَرْطٌ':Added, #1: 1	عَطْفِ الشَّرْطِ
u'عطف شُرُوطٌ':Added, #1: 1	عَطْفِ الشَّرْطِ
u'عَطْفٌ شُرُوطٌ':Added, #3: 3	عَطْفِ الشُّرُوطِ
u'عطف شَيْءٌ':Added, #3: 3	عَطْفِ الشُّرُوطِ
u'عَطْفٌ شَيْءٌ':Added, #2: 2	عَطْفُ الشَّيْءِ
u'عطف شَيْءٌ':Added, #2: 2	عَطْفُ الشَّيْءِ
u'عَطْفٌ شَيْءٌ':Added, #3: 3	عَطْفِ الشَّيْءِ
u'عَطَفَ صَلاَةٌ':Predicate, #3: 3	عَطْفِ الشَّيْءِ
u'عطف صَلاَةٌ':Added, #2: 2	عَطَفَ الصَّلَاةَ
u'عطف صَلاَةٌ':Added, #1: 1	عَطْفُ الصَّلَاةِ
u'عَطْفٌ صَلاَةٌ':Added, #1: 1	عَطْفِ الصَّلَاةِ
u'عَطْفٌ صَلاَةٌ':Added, #1: 1	عَطْفُ الصَّلَاةِ
u'عَطَفَ طَلاَقٌ':Predicate, #1: 1	عَطْفِ الصَّلَاةِ
u'عطف طَلاَقٌ':Added, #1: 1	عَطَفَ الطَّلَاقَ
u'عَطْفٌ طَلاَقٌ':Added, #1: 1	عَطْفِ الطَّلَاقِ
u'عَطَفَ طواف':Predicate, #1: 1	عَطْفِ الطَّلَاقِ
u'عَطَفَ طَوَافٌ':Predicate, #1: 1	عَطَفَ الطَّوَافَ
u'عطف عَامٌّ':Added, #1: 1	عَطَفَ الطَّوَافَ
u'عَطْفٌ عَامٌّ':Added, #12: 12	عَطْفِ الْعَامِّ
u'عطف عَامٌّ':Added, #12: 12	عَطْفِ الْعَامِّ
u'عطف عَامٌّ':Added, #1: 1	عَطْفَ عَامٍّ
u'عَطْفٌ عَامٌّ':Added, #1: 1	عَطْفُ عَامٍّ
u'عَطْفٌ عَامٌّ':Added, #1: 1	عَطْفَ عَامٍّ
u'عطف عَامٌّ':Added, #1: 1	عَطْفُ عَامٍّ
u'عَطْفٌ عَامٌّ':Added, #2: 2	عَطْفُ الْعَامِّ
u'عطف عَدَمٌ':Added, #2: 2	عَطْفُ الْعَامِّ
u'عَطْفٌ عَدَمٌ':Added, #1: 1	عَطْفِ عَدَمِ
u'عَطَفَ عمرة':Predicate, #1: 1	عَطْفِ عَدَمِ
u'عَطَفَ عُمْرَةٌ':Predicate, #1: 1	عَطَفَ الْعُمْرَةَ
u'عَطَفَ عَوْدٌ':Predicate, #1: 1	عَطَفَ الْعُمْرَةَ
u'عَطَفَ غَدٌ':Predicate, #1: 1	عَطَفَ الْعَوْدَ
u'عَطَفَ فَاكِهٌ':Predicate, #1: 1	عَطَفَ الْغَدَ
u'عَطَفَ فَاكِهَةٌ':Predicate, #1: 1	عَطَفَ الْفَاكِهَةَ
u'عَطَفَ فِعْلٌ':Predicate, #1: 1	عَطَفَ الْفَاكِهَةَ
u'عطف فِعْلٌ':Added, #1: 1	عَطَفَ الْفِعْلَ
u'عَطْفٌ فِعْلٌ':Added, #1: 1	عَطْفُ الْفِعْلِ
u'عطف فلان':Added, #1: 1	عَطْفُ الْفِعْلِ
u'عَطْفٌ فلان':Added, #1: 1	عَطْفُ الشَّافِعِيِّ
u'عطف قِرَاءةٌ':Added, #1: 1	عَطْفُ الشَّافِعِيِّ
u'عَطْفٌ قِرَاءةٌ':Added, #1: 1	عَطْفُ قِرَاءَةِ
u'عَطَفَ قَرِيبٌ':Predicate, #1: 1	عَطْفُ قِرَاءَةِ
u'عَطَفَ قَسَمٌ':Predicate, #1: 1	عَطَفَ الْقَرِيبَ
u'عَطَفَ قَضَاءٌ':Predicate, #1: 1	عَطَفَ الْقَسَمَ
u'عَطَفَ مَاءٌ':Predicate, #1: 1	عَطَفَ قَضَاءَ
u'عطف مُرَادِفٌ':Added, #1: 1	عَطَفَ الْمَاءَ
u'عَطْفٌ مُرَادِفٌ':Added, #1: 1	عَطْفُ مُرَادِفٍ
u'عَطَفَ مُشْرِك':Predicate, #1: 1	عَطْفُ مُرَادِفٍ
u'عطف مُصَنِّفٌ':Added, #3: 3	عَطَفَ الْمُشْرِكِينَ
u'عطف مُصَنِّفٌ':Added, #1: 1	عَطْفُ الْمُصَنِّفِ
u'عَطْفٌ مُصَنِّفٌ':Added, #1: 1	عَطْفِ الْمُصَنِّفِ
u'عَطْفٌ مُصَنِّفٌ':Added, #1: 1	عَطْفُ الْمُصَنِّفِ
u'عَطَفَ مُضَارِعٌ':Predicate, #1: 1	عَطْفِ الْمُصَنِّفِ
u'عطف مُغَايِرٌ':Added, #1: 1	عَطَفَ الْمُضَارِعَ
u'عَطْفٌ مُغَايِرٌ':Added, #3: 3	عَطْفِ الْمُغَايِرِ
u'عطف مُفْرَدٌ':Added, #3: 3	عَطْفِ الْمُغَايِرِ
u'عَطْفٌ مُفْرَدٌ':Added, #1: 1	عَطْفِ الْمُفْرَدِ
u'عطف مُفْرَدٌ':Added, #1: 1	عَطْفِ الْمُفْرَدِ
u'عَطْفٌ مُفْرَدٌ':Added, #1: 1	عَطْفُ الْمُفْرَدَاتِ
u'عطف مُفْرَدٌ':Added, #1: 1	عَطْفُ الْمُفْرَدَاتِ
u'عَطْفٌ مُفْرَدٌ':Added, #1: 1	عَطْفِ الْمُفْرَدَيْنِ
u'عطف مُفْرَدٌ':Added, #1: 1	عَطْفِ الْمُفْرَدَيْنِ
u'عَطْفٌ مُفْرَدٌ':Added, #3: 3	عَطْفُ الْمُفْرَدِ
u'عطف مُفْرَدٌ':Added, #3: 3	عَطْفُ الْمُفْرَدِ
u'عَطْفٌ مُفْرَدٌ':Added, #3: 3	عَطْفِ الْمُفْرَدَاتِ
u'عطف مُفَصَّلٌ':Added, #3: 3	عَطْفِ الْمُفْرَدَاتِ
u'عَطْفٌ مُفَصَّلٌ':Added, #1: 1	عَطْفِ الْمُفَصَّلِ
u'عطف مُفَصَّلٌ':Added, #1: 1	عَطْفِ الْمُفَصَّلِ
u'عَطْفٌ مُفَصَّلٌ':Added, #1: 1	عَطْفُ مُفَصَّلٍ
u'عطف مُقَيَّدٌ':Added, #1: 1	عَطْفُ مُفَصَّلٍ
u'عَطْفٌ مُقَيَّدٌ':Added, #1: 1	عَطْفِ الْمُقَيَّدِ
u'عطف نَخْلٌ':Added, #1: 1	عَطْفِ الْمُقَيَّدِ
u'عَطْفٌ نَخْلٌ':Added, #1: 1	عَطْفُ النَّخْلِ
u'عطف نَسَقٌ':Added, #1: 1	عَطْفُ النَّخْلِ
u'عَطْفٌ نَسَقٌ':Added, #1: 1	عَطْفُ نَسَقٍ
u'عَطَفَ نَوَاجِذُ':Predicate, #1: 1	عَطْفُ نَسَقٍ
u'عَطَفَ نِيَّةٌ':Predicate, #1: 1	عَطَفَ النَّوَاجِذَ
u'عَطَفَ يَمِينٌ':Predicate, #1: 1	عَطَفَ نِيَّةَ
u'عطف يَوْمٌ':Added, #1: 1	عَطَفَ الْيَمِينَ
u'عَطْفٌ يَوْمٌ':Added, #1: 1	عَطْفَ الْيَوْمِ
u'عَطَّلَ أرْضٌ':Predicate, #1: 1	عَطْفَ الْيَوْمِ
u'عَطَّلَ إمَامٌ':Subject, #3: 3	عَطَّلَ الْأَرْضَ
u'عَطَّلَ تَدْرِيسٌ':Predicate, #1: 1	عَطَّلَ الْإِمَامُ
u'عَطَّلَ مُغِلّ':Subject, #1: 1	عَطَّلَ التَّدْرِيسَ
u'عَطَّلَ نَفْعٌ':Predicate, #2: 2	عَطَّلَ مُغِلٌّ
u'عَظُمَ إِثْمٌ':Subject, #1: 1	عَطَّلَ نَفْعَ
u'عِظَمٌ إِثْمٌ':Added, #1: 1	عَظُمَ إثْمُهُ
u'عِظَمٌ أَجْرٌ':Added, #1: 1	عِظَمِ الْإِثْمِ
u'عَظَّمَ إمَامٌ':Subject, #1: 1	عِظَمُ الْأَجْرِ
u'عِظَمٌ أَمْرٌ':Added, #1: 1	عَظَّمَ الْإِمَامُ
u'عَظُمَ إِنْكارٌ':Subject, #1: 1	عِظَمِ الْأَمْرِ
u'عِظَمٌ بُسْرٌ':Added, #1: 1	عَظُمَ الْإِنْكَارُ
u'عِظَمٌ بَلاءٌ':Added, #4: 4	عِظَمُ الْبُسْرِ
u'عَظُمَ ثَمَنٌ':Subject, #1: 1	عِظَمِ الْبَلَاءِ
u'عِظَمٌ جَبَلٌ':Added, #1: 1	عَظُمَ ثَمَنُهُ
u'عِظَمٌ جَبَلٌ':Added, #1: 1	عِظَمَ الْجَبَلِ
u'عِظَمٌ جُرْمٌ':Added, #5: 5	عِظَمِ الْجَبَلِ
u'عِظَمٌ حَبٌّ':Added, #1: 1	عِظَمِ الْجُرْمِ
u'عِظَمٌ حَبٌّ':Added, #1: 1	عِظَمَ الْحَبَّةِ
u'عِظَمٌ حَبَّةٌ':Added, #1: 1	عِظَمِ حَبَّةٍ
u'عِظَمٌ حَبَّةٌ':Added, #1: 1	عِظَمَ الْحَبَّةِ
u'عَظَّمَ حَقٌّ':Predicate, #1: 1	عِظَمِ حَبَّةٍ
u'عِظَمٌ حَقٌّ':Added, #1: 1	عَظَّمَ حَقَّ
u'عِظَمٌ حَقٌّ':Added, #1: 1	عِظَمِ حَقِّ
u'عِظَمٌ خَرْدَلٌ':Added, #2: 2	عِظَمِ حَقِّهِ
u'عِظَمٌ خصى':Added, #1: 1	عِظَمِ خَرْدَلَةٍ
u'عِظَمٌ خَطْبٌ':Added, #1: 1	عِظَمُ الْخُصْيَتَيْنِ
u'عَظُمَ خطر':Subject, #1: 1	عِظَمِ الْخَطْبِ
u'عَظُمَ خَطَرٌ':Subject, #1: 1	عَظُمَ الْخَطَرُ
u'عِظَمٌ خطر':Added, #1: 1	عَظُمَ الْخَطَرُ
u'عِظَمٌ خَطَرٌ':Added, #1: 1	عِظَمِ خَطَرِهِ
u'عِظَمٌ خطر':Added, #1: 1	عِظَمِ خَطَرِهِ
u'عِظَمٌ خَطَرٌ':Added, #2: 2	عِظَمِ الْخَطَرِ
u'عِظَمٌ خلق':Added, #2: 2	عِظَمِ الْخَطَرِ
u'عِظَمٌ خَلْقٌ':Added, #1: 1	عِظَمِ الْخَلْقِ
u'عِظَمٌ خلقة':Added, #1: 1	عِظَمِ الْخَلْقِ
u'عِظَمٌ خِلْقَةٌ':Added, #1: 1	عِظَمِ خِلْقَتِهِ
u'عِظَمٌ رَأْسٌ':Added, #1: 1	عِظَمِ خِلْقَتِهِ
u'عِظَمٌ رَأْسٌ':Added, #1: 1	عِظَمَ رَأْسِ
u'عَظَّمَ رِسَالَةٌ':Predicate, #4: 4	عِظَمِ رَأْسِ
u'عِظَمٌ زَمانٌ':Added, #1: 1	عَظَّمَ الرِّسَالَةَ
u'عِظَمٌ سِمْسِمٌ':Added, #1: 1	عِظَمِ الزَّمَانِ
u'عَظُمَ شَأْنٌ':Subject, #1: 1	عِظَمِ السِّمْسِمِ
u'عِظَمٌ شَأْنٌ':Added, #2: 2	عَظُمَ شَأْنُهُ
u'عِظَمٌ شَفَقَةٌ':Added, #1: 1	عِظَمِ الشَّأْنِ
u'عِظَمٌ ضَرَرٌ':Added, #1: 1	عِظَمِ الشَّفَقَةِ
u'عِظَمٌ ضَرَرٌ':Added, #1: 1	عِظَمِ ضَرَرِهِ
u'عَظَّمَ عَالِمٌ':Predicate, #4: 4	عِظَمِ الضَّرَرِ
u'عَظُمَ عُضْوٌ':Subject, #1: 1	عَظَّمَ الْعَالِمَ
u'عِظَمٌ عُقُوبَةٌ':Added, #1: 1	عَظُمَ عُضْوُ
u'عِظَمٌ عُنْقُودٌ':Added, #1: 1	عِظَمُ الْعُقُوبَةِ
u'عَظُمَ قَدْرٌ':Subject, #1: 1	عِظَمَ عُنْقُودٍ
u'عَظُمَ قَدْرٌ':Subject, #1: 1	عَظُمَ قَدْرُ
u'عِظَمٌ قدرة':Added, #4: 4	عَظُمَ قَدْرُهُ
u'عِظَمٌ قُدْرَةٌ':Added, #1: 1	عِظَمِ قُدْرَةِ
u'عِظَمٌ مَشَقَّةٌ':Added, #1: 1	عِظَمِ قُدْرَةِ
u'عِظَمٌ مَشَقَّةٌ':Added, #1: 1	عِظَمِ الْمَشَقَّةِ
u'عَظُمَ مِصْرٌ':Subject, #1: 1	عِظَمَ مَشَقَّةِ
u'عِظَمٌ مُصِيبٌ':Added, #1: 1	عَظُمَ الْمِصْرُ
u'عِظَمٌ مُصِيبَةٌ':Added, #1: 1	عِظَمِ الْمُصِيبَةِ
u'عِظَمٌ مَفْسَدَةٌ':Added, #1: 1	عِظَمِ الْمُصِيبَةِ
u'عِظَمٌ مَفْسَدَةٌ':Added, #1: 1	عِظَمَ الْمَفْسَدَةِ
u'عَظُمَ مَقَالٌ':Subject, #2: 2	عِظَمِ الْمَفْسَدَةِ
u'عِظَمٌ مَقَامٌ':Added, #1: 1	عَظُمَ مَقَالُهُ
u'عِظَمٌ مَكَانٌ':Added, #1: 1	عِظَمِ مَقَامِ
u'عِظَمٌ مَكْرٌ':Added, #1: 1	عِظَمِ الْمَكَانِ
u'عِظَمٌ مَنْزِلَةٌ':Added, #1: 1	عِظَمِ الْمَكْرِ
u'عِظَمٌ مَنْزِلَةٌ':Added, #1: 1	عِظَمُ الْمَنْزِلَةِ
u'عَظُمَ مُوجِبٌ':Subject, #1: 1	عِظَمَ مَنْزِلَةِ
u'عَظَّمَ نَبِيٌّ':Subject, #1: 1	عَظُمَ مُوجِبُهُ
u'عَظُمَ نَكِيرٌ':Subject, #1: 1	عَظَّمَ النَّبِيُّ
u'عَظُمَ نَكِيرٌ':Subject, #1: 1	عَظُمَ النَّكِيرُ
u'عِظَمٌ هَامَةٌ':Added, #1: 1	عَظُمَ نَكِيرُ
u'عَظُمَ وِزْرٌ':Subject, #1: 1	عِظَمِ هَامَتِهِ
u'عَظُمَ وِزْر':Subject, #1: 1	عَظُمَ الْوِزْرُ
u'عَظُمَ وَعِيدٌ':Subject, #1: 1	عَظُمَ الْوِزْرُ
u'عَفَاءٌ دِيَارٌ':Added, #1: 1	عَظُمَ الْوَعِيدُ
u'عَفَا أثَرٌ':Subject, #1: 1	عَفَاءِ الدّيَارِ
u'عَفَا أثَرٌ':Subject, #1: 1	عَفَا أَثَرُهُ
u'عَفَا أحَدٌ':Subject, #1: 1	عَفَا الْأَثَرُ
u'عَفَا أَوَّلُ':Subject, #30: 30	عَفَا أَحَدُ
u'عَفَا أَوْلِيَاءُ':Subject, #3: 3	عَفَا الْأَوَّلُ
u'عَفَا بَائِعٌ':Subject, #3: 3	عَفَا الْأَوْلِيَاءُ
u'عَفَا بَعْضٌ':Subject, #2: 2	عَفَا الْبَائِعُ
u'عَفَا ثَالِثٌ':Subject, #15: 15	عَفَا بَعْضُ
u'عَفَا رَبُّ':Subject, #1: 1	عَفَا الثَّالِثُ
u'عَفَا رَجُلٌ':Subject, #1: 1	عَفَا رَبُّ
u'عَفَا زَرْعٌ':Subject, #2: 2	عَفَا رَجُلٌ
u'عَفَا سقط':Predicate, #1: 1	عَفَا الزَّرْعُ
u'عَفَا سَقَطٌ':Predicate, #1: 1	عَفَا سَقَطَ
u'عَفَا سَيِّدٌ':Subject, #1: 1	عَفَا سَقَطَ
u'عَفَا سَيِّدٌ':Subject, #1: 1	عَفَا سَيِّدُهُ
u'عَفَا شَاهِدٌ':Subject, #4: 4	عَفَا السَّيِّدُ
u'عَفَا شَفِيعٌ':Subject, #2: 2	عَفَا الشَّاهِدُ
u'عَفَا صَفْوَان':Subject, #6: 6	عَفَا الشَّفِيعُ
u'عَفَا عَامِلٌ':Subject, #1: 1	عَفَا صَفْوَانُ
u'عَفَا عصبة':Subject, #1: 1	عَفَا الْعَامِلُ
u'عَفَا عَصَبَةٌ':Subject, #1: 1	عَفَا الْعَصَبَةُ
u'عَفَا عَمٌّ':Subject, #1: 1	عَفَا الْعَصَبَةُ
u'عَفَافٌ فَرْجٌ':Added, #1: 1	عَفَا الْعَمُّ
u'عَفَا قَاتِلٌ':Subject, #1: 1	عَفَافُ الْفَرْجِ
u'عَفَا كَبِيرٌ':Subject, #1: 1	عَفَا الْقَاتِلُ
u'عَفَا مَالِكٌ':Subject, #1: 1	عَفَا الْكَبِيرُ
u'عَفَا مَجْرُوحٌ':Subject, #1: 1	عَفَا الْمَالِكُ
u'عَفَا مَجْرُوحٌ':Subject, #1: 1	عَفَا مَجْرُوحٌ
u'عَفَا مَحْجُورٌ':Subject, #3: 3	عَفَا الْمَجْرُوحُ
u'عَفَا مَدْحٌ':Subject, #1: 1	عَفَا الْمَحْجُورُ
u'عَفَا مُسْتَحِقٌّ':Subject, #1: 1	عَفَا مَدْحُهُ
u'عَفَا مُسْتَحِقٌّ':Subject, #3: 3	عَفَا مُسْتَحِقُّ
u'عَفَا مَضْرُوبٌ':Subject, #5: 5	عَفَا الْمُسْتَحِقُّ
u'عَفَا مَقْتُولٌ':Subject, #1: 1	عَفَا الْمَضْرُوبُ
u'عَفَا مَقْذُوفٌ':Subject, #3: 3	عَفَا الْمَقْتُولُ
u'عَفَا مَقْطُوعٌ':Subject, #4: 4	عَفَا الْمَقْذُوفُ
u'عَفَا نِصْفٌ':Predicate, #1: 1	عَفَا الْمَقْطُوعُ
u'عَفَا واحد':Subject, #2: 2	عَفَا نِصْفَ
u'عَفَا وَاحِدٌ':Subject, #2: 2	عَفَا وَاحِدٌ
u'عَفَا وَارِثٌ':Subject, #2: 2	عَفَا وَاحِدٌ
u'عَفَا وَلِيٌّ':Subject, #2: 2	عَفَا الْوَارِثُ
u'عَفَا وَلِيٌّ':Subject, #11: 11	عَفَا وَلِيُّ
u'عَفَّ بَطْنٌ':Subject, #13: 13	عَفَا الْوَلِيُّ
u'عِفَّةٌ فَرْجٌ':Added, #1: 1	عَفَّ بَطْنُهُ
u'عِفَّةٌ مَقْذُوفٌ':Added, #1: 1	عِفَّةِ فَرْجِهِ
u'عفر تُرَابٌ':Added, #1: 1	عِفَّةِ الْمَقْذُوفِ
u'عَفَرٌ تُرَابٌ':Added, #1: 1	عَفَرَ التّرَابِ
u'عَفَّ فَرْعٌ':Subject, #1: 1	عَفَرَ التّرَابِ
u'عَفِنَ بَذْرٌ':Subject, #1: 1	أَعَفَّ الْفَرْعُ
u'عَفَنٌ حِنْطَةٌ':Added, #1: 1	عَفِنَ الْبَذْرُ
u'عَفِنَ شَيْءٌ':Subject, #1: 1	عَفَنِ الْحِنْطَةِ
u'عَفِنَ عند':Predicate, #1: 1	عَفِنَ الشَّيْءُ
u'عَفْوٌ أَبٌ':Added, #2: 2	عَفِنَ عِنْدَ
u'عَفْوٌ أَبٌ':Added, #1: 1	عَفْوِ الْأَبِ
u'عَفْوٌ أحَدٌ':Added, #4: 4	عَفْوُ الْأَبِ
u'عَفْوٌ إِخْوَانٌ':Added, #1: 1	عَفْوُ أَحَدِ
u'عَفْوٌ آدَمِيٌّ':Added, #1: 1	عَفْوِ الْإِخْوَانِ
u'عَفْوٌ الْمَرْأَةُ':Added, #1: 1	عَفْوِ الْآدَمِيِّ
u'عَفْوٌ إمَامٌ':Added, #2: 2	عَفْوِ الْمَرْأَةِ
u'عَفْوٌ أَوَّلُ':Added, #1: 1	عَفْوُ الْإِمَامِ
u'عَفْوٌ أَوْلِيَاءُ':Added, #1: 1	عَفْوُ الْأَوَّلِ
u'عَفْوٌ أَوْلِيَاءُ':Added, #1: 1	عَفْوِ الأَوْلِيَاءِ
u'عَفْوٌ بَعْضٌ':Added, #1: 1	عَفْوُ أَوْلِيَاءِ
u'عَفْوٌ بَعْضٌ':Added, #1: 1	عَفْوِ الْبَعْضِ
u'عَفْوٌ بِلادٌ':Added, #6: 6	عَفْوِ بَعْضِ
u'عَفْوٌ رَاهِنٌ':Added, #1: 1	عَفْوِ بِلَادِ
u'عَفْوٌ رَبُّ':Added, #1: 1	عَفْوُ الرَّاهِنِ
u'عَفْوٌ رَبُّ':Added, #2: 2	عَفْوِ رَبِّهِ
u'عَفْوٌ رَجُلٌ':Added, #4: 4	عَفْوَ رَبِّهِ
u'عَفْوٌ زَوْجٌ':Added, #1: 1	عَفْوِ الرَّجُلِ
u'عَفْوٌ زَوْجٌ':Added, #1: 1	عَفْوُ الزَّوْجِ
u'عَفْوٌ زَوْجَةٌ':Added, #1: 1	عَفْوِ الزَّوْجِ
u'عَفْوٌ شَفِيعٌ':Added, #1: 1	عَفْوُ الزَّوْجَةِ
u'عَفْوٌ شَفِيعٌ':Added, #1: 1	عَفْوُ الشَّفِيعِ
u'عَفْوٌ شَفِيعٌ':Added, #1: 1	عَفْوَ الشَّفِيعَيْنِ
u'عَفْوٌ صَاحِبٌ':Added, #2: 2	عَفْوِ الشَّفِيعِ
u'عَفْوٌ صَاحِبٌ':Added, #1: 1	عَفْوِ صَاحِبِ
u'عَفْوٌ عَامِلٌ':Added, #2: 2	عَفْوَ صَاحِبِهِ
u'عَفْوٌ عصبة':Added, #1: 1	عَفْوُ الْعَامِلِ
u'عَفْوٌ عَصَبَةٌ':Added, #2: 2	عَفْوُ الْعَصَبَةِ
u'عَفْوٌ عُقُوبَةٌ':Added, #2: 2	عَفْوُ الْعَصَبَةِ
u'عَفْوٌ غَائِبٌ':Added, #1: 1	عَفْوِ الْعُقُوبَةِ
u'عَفْوٌ غَائِبٌ':Added, #2: 2	عَفْوَ الْغَائِبِ
u'عَفْوٌ فلان':Added, #2: 2	عَفْوِ الْغَائِبِ
u'عَفْوٌ قصاص':Added, #1: 1	عَفْوُ الْمُقْتَدِرِ
u'عَفْوٌ قِصَاصٌ':Added, #2: 2	عَفْوِ الْقِصَاصِ
u'عَفْوٌ قُلُوبٌ':Added, #2: 2	عَفْوِ الْقِصَاصِ
u'عَفْوٌ قَوَد':Added, #1: 1	عَفْوَ الْقُلُوبِ
u'عَفْوٌ مَالِكٌ':Added, #1: 1	عَفْوِ قَوَدٍ
u'عَفْوٌ مَجْرُوحٌ':Added, #1: 1	عَفْوُ مَالِكِ
u'عَفْوٌ مَرِيضٌ':Added, #1: 1	عَفْوُ الْمَجْرُوحِ
u'عَفْوٌ مَشْهُودٌ':Added, #1: 1	عَفْوُ الْمَرِيضِ
u'عَفْوٌ مَظْلُومٌ':Added, #1: 1	عَفْوَ الْمَشْهُودِ
u'عَفْوٌ مُغْتاب':Added, #1: 1	عَفْوِ الْمَظْلُومِ
u'عَفْوٌ مُفْلِسٌ':Added, #1: 1	عَفْوِ الْمُغْتَابِ
u'عَفْوٌ مُفْلِسٌ':Added, #1: 1	عَفْوِ الْمُفْلِسِ
u'عَفْوٌ مُقْتَدِر':Added, #3: 3	عَفْوُ الْمُفْلِسِ
u'عَفْوٌ مَقْتُولٌ':Added, #1: 1	عَفْوُ الْمُقْتَدِرِ
u'عَفْوٌ مَقْذُوفٌ':Added, #3: 3	عَفْوِ الْمَقْتُولِ
u'عَفْوٌ مَقْذُوفٌ':Added, #1: 1	عَفْوَ الْمَقْذُوفِ
u'عَفْوٌ مَقْذُوفٌ':Added, #2: 2	عَفْوِ الْمَقْذُوفِ
u'عَفْوٌ مَهْرٌ':Added, #3: 3	عَفْوُ الْمَقْذُوفِ
u'عَفْوٌ مُوَرِّث':Added, #1: 1	عَفْوِ الْمَهْرِ
u'عَفْوٌ مُوَكِّلٌ':Added, #1: 1	عَفْوِ الْمُوَرِّثِ
u'عَفْوٌ مُوَكِّلٌ':Added, #1: 1	عَفْوِ مُوَكِّلِهِ
u'عَفْوٌ مُوَكِّلٌ':Added, #2: 2	عَفْوِ الْمُوَكِّلِ
u'عُفُونَةٌ دَمٌ':Added, #3: 3	عَفْوَ مُوَكِّلِهِ
u'عَفْوٌ نِساءٌ':Added, #1: 1	عُفُونَةِ الدَّمِ
u'عَفْوٌ وَارِثٌ':Added, #1: 1	عَفْوَ النِّسَاءِ
u'عَفْوٌ وَارِثٌ':Added, #1: 1	عَفْوُ الْوَارِثِ
u'عَفْوٌ وَارِثٌ':Added, #1: 1	عَفْوِ الْوَارِثِ
u'عَفْوٌ وَرَثَةٌ':Added, #1: 1	عَفْوِ وَارِثِهِ
u'عَفْوٌ وَلِيٌّ':Added, #2: 2	عَفْوُ الْوَرَثَةِ
u'عَفْوٌ وَلِيٌّ':Added, #1: 1	عَفْو الْوَلِيِّ
u'عَفْوٌ وَلِيٌّ':Added, #1: 1	عَفْوُ الْوَلِيِّ
u'عَفْوٌ وَلِيٌّ':Added, #1: 1	عَفْوُ وَلِيِّ
u'عَفْوٌ وَلِيٌّ':Added, #2: 2	عَفْوَ الْوَلِيِّ
u'عَفْوٌ وَلِيٌّ':Added, #2: 2	عَفْوِ الْوَلِيِّ
u'عقاب أهْلٌ':Added, #5: 5	عَفْوِ وَلِيِّ
u'عِقَابٌ أهْلٌ':Added, #1: 1	عِقَابَ أَهْلِ
u'عقاب بَعْضٌ':Added, #1: 1	عِقَابَ أَهْلِ
u'عِقَابٌ بَعْضٌ':Added, #1: 1	عِقَابِ بَعْضِ
u'عقاب تارِك':Added, #1: 1	عِقَابِ بَعْضِ
u'عِقَابٌ تارِك':Added, #1: 1	عِقَابَ تَارِكِ
u'عقاب تَرْكٌ':Added, #1: 1	عِقَابَ تَارِكِ
u'عِقَابٌ تَرْكٌ':Added, #2: 2	عِقَابِ تَرْكِ
u'عقاب تَوْلِيَةٌ':Added, #2: 2	عِقَابِ تَرْكِ
u'عِقَابٌ تَوْلِيَةٌ':Added, #1: 1	عِقَابُ التَّوْلِيَةِ
u'عقاب حَدٌّ':Added, #1: 1	عِقَابُ التَّوْلِيَةِ
u'عِقَابٌ حَدٌّ':Added, #1: 1	عِقَابِ الْحَدِّ
u'عقاب ذَنْبٌ':Added, #1: 1	عِقَابِ الْحَدِّ
u'عِقَابٌ ذَنْبٌ':Added, #1: 1	عِقَابَ الذَّنْبِ
u'عقاب سَيِّئٌ':Added, #1: 1	عِقَابَ الذَّنْبِ
u'عِقَابٌ سَيِّئٌ':Added, #1: 1	عِقَابِ سَيِّئَاتِ
u'عقاب صَلَوَاتٌ':Added, #1: 1	عِقَابِ سَيِّئَاتِ
u'عقاب طَائِفٌ':Added, #2: 2	أَعْقَابِ الصَّلَوَاتِ
u'عِقَابٌ طَائِفٌ':Added, #1: 1	عِقَابِ طَائِفَةٍ
u'عقاب فَرَائِضُ':Added, #1: 1	عِقَابِ طَائِفَةٍ
u'عقاب فِعْلٌ':Added, #1: 1	أَعْقَابِ الْفَرَائِضِ
u'عِقَابٌ فِعْلٌ':Added, #1: 1	عِقَابَ فِعْلِ
u'عقاب كَبِيرٌ':Added, #1: 1	عِقَابَ فِعْلِ
u'عِقَابٌ كَبِيرٌ':Added, #2: 2	عِقَابِ الْكَبِيرَةِ
u'عقاب كفر':Added, #2: 2	عِقَابِ الْكَبِيرَةِ
u'عِقَابٌ كفر':Added, #1: 1	عِقَابِ الْكُفْرِ
u'عقاب كُفْرٌ':Added, #1: 1	عِقَابِ الْكُفْرِ
u'عِقَابٌ كُفْرٌ':Added, #1: 1	عِقَابِ الْكُفْرِ
u'عقاب لَيْلٌ':Added, #1: 1	عِقَابِ الْكُفْرِ
u'عقاب مُخَالِفٌ':Added, #1: 1	أَعْقَابِ لَيْلٍ
u'عِقَابٌ مُخَالِفٌ':Added, #1: 1	عِقَابِ مُخَالِفِهِ
u'عقاب مَدِينٌ':Added, #1: 1	عِقَابِ مُخَالِفِهِ
u'عِقَابٌ مَدِينٌ':Added, #1: 1	عِقَابِ الْمَدِينَةِ
u'عقاب مَدِينَةٌ':Added, #1: 1	عِقَابِ الْمَدِينَةِ
u'عِقَابٌ مَدِينَةٌ':Added, #1: 1	عِقَابِ الْمَدِينَةِ
u'عقاب مُطِيعٌ':Added, #1: 1	عِقَابِ الْمَدِينَةِ
u'عِقَابٌ مُطِيعٌ':Added, #1: 1	عِقَابُ الْمُطِيعِ
u'عقاب نَاسٌ':Added, #1: 1	عِقَابُ الْمُطِيعِ
u'عَقَارٌ اِبْنٌ':Added, #1: 1	أَعْقَابَ النَّاسِ
u'عَقَارٌ أحَدٌ':Added, #1: 1	عَقَارَ ابْنِهِ
u'عَقَارٌ بَيْتٌ':Added, #1: 1	عَقَارِ أَحَدِ
u'عَقَارٌ خَالِصٌ':Added, #1: 1	عَقَارُ بَيْتِ
u'عَقَارٌ شَفِيعٌ':Added, #2: 2	عَقَارٍ خَالِصٍ
u'عَقَارٌ صَغِيرٌ':Added, #2: 2	عَقَارِ الشَّفِيعِ
u'عَقَارٌ عَامِرٌ':Added, #4: 4	عَقَارِ الصَّغِيرِ
u'عَقَارٌ غَائِبٌ':Added, #1: 1	عَقَارٍ عَامِرٍ
u'عَقَارٌ فَيْءٌ':Added, #2: 2	عَقَارِ الْغَائِبِ
u'عَقَارٌ كُفَّارٌ':Added, #1: 1	عَقَارُ الْفَيْءِ
u'عَقَارٌ مَحْجُورٌ':Added, #1: 1	عَقَارِ الْكُفَّارِ
u'عَقَارٌ مَحْجُورٌ':Added, #1: 1	عَقَارِ الْمَحْجُورِ
u'عَقَارٌ مَسْجِدٌ':Added, #1: 1	عَقَارَ مَحْجُورِهِ
u'عَقَارٌ مُشْتَرَكٌ':Added, #3: 3	عَقَارِ الْمَسْجِدِ
u'عَقَارٌ مُشْتَمِلٌ':Added, #4: 4	عَقَارٍ مُشْتَرَكٍ
u'عَقَارٌ نَاسٌ':Added, #1: 1	عَقَارٍ مُشْتَمِلٍ
u'عَقَارٌ وَقْفٌ':Added, #2: 2	عَقَارِ النَّاسِ
u'عَقَارٌ يَتِيمٌ':Added, #2: 2	عَقَارِ الْوَقْفِ
u'عَقَارٌ يَتِيمٌ':Added, #1: 1	عَقَارَ الْيَتِيمِ
u'عَقَّبَ أَحْكَامٌ':Predicate, #9: 9	عَقَارِ الْيَتِيمِ
u'عَقَبَ إِلْزَامٌ':Predicate, #1: 1	عَقَّبَ أَحْكَامَ
u'عَقَبَ آيَةٌ':Predicate, #1: 1	عَقَبَ إلْزَامَ
u'عَقَّبَ بَيْعٌ':Predicate, #1: 1	عَقَبَ الْآيَةَ
u'عَقَّبَ بيوع':Predicate, #1: 1	عَقَّبَ الْبَيْعَ
u'عَقَّبَ حِلٌّ':Predicate, #1: 1	عَقَّبَ الْبُيُوعَ
u'عَقَّبَ قيام':Predicate, #1: 1	عَقَّبَ حِلَّ
u'عَقَّبَ قِيَامٌ':Predicate, #1: 1	عَقَّبَ الْقِيَامَ
u'عَقَبَ نِيَّةٌ':Predicate, #1: 1	عَقَّبَ الْقِيَامَ
u'عَقَّبَ نِيَّةٌ':Predicate, #1: 1	عَقَبَ النِّيَّةَ
u'عَقَدَ أَبٌ':Subject, #2: 2	عَقَّبَ النِّيَّةَ
u'عَقْدٌ أَبٌ':Added, #2: 2	عَقَدَ الْأَبُ
u'عَقْدٌ أَبٌ':Added, #1: 1	عَقْدُ أَبٍ
u'عَقْدٌ أَبٌ':Added, #2: 2	عَقْدُ الْأَبِ
u'عَقَدَ آباءٌ':Subject, #2: 2	عَقْدِ الْأَبِ
u'عَقْدٌ اِبْتِداءٌ':Added, #1: 1	عَقَدَ الْآبَاءُ
u'عَقْدٌ أَبْعَدُ':Added, #1: 1	عَقْدُ ابْتِدَاءٍ
u'عَقَدَ اِبْنٌ':Subject, #1: 1	عَقْدُ الْأَبْعَدِ
u'عَقَدَ إجَارَةٌ':Predicate, #3: 3	عَقَدَ ابْنُ
u'عَقْدٌ إجَارَةٌ':Added, #8: 8	عَقَدَ الْإِجَارَةَ
u'عَقْدٌ إجَارَةٌ':Added, #22: 22	عَقْدَ الْإِجَارَةِ
u'عَقْدٌ إجَارَةٌ':Added, #2: 2	عَقْدُ إجَارَةٍ
u'عَقْدٌ إجَارَةٌ':Added, #2: 2	عَقْدُ إجَارَتِهِ
u'عَقْدٌ إجَارَةٌ':Added, #3: 3	عَقْدَ إجَارَةٍ
u'عَقْدٌ إجَارَةٌ':Added, #3: 3	عَقْدِ إجَارَةٍ
u'عَقْدٌ إجَارَةٌ':Added, #41: 41	عَقْدُ الْإِجَارَةِ
u'عَقْدٌ آحَادٌ':Added, #55: 55	عَقْدِ الْإِجَارَةِ
u'عَقْدٌ أحَدٌ':Added, #1: 1	عَقْدُ الْآحَادِ
u'عَقَدَ إِحْرَامٌ':Predicate, #1: 1	عَقْدِ أَحَدِ
u'عَقْدٌ إِحْرَامٌ':Added, #6: 6	عَقَدَ الْإِحْرَامَ
u'عَقْدٌ إِحْرَامٌ':Added, #1: 1	عَقْدُ الْإِحْرَامِ
u'عَقْدٌ إِحْرَامٌ':Added, #3: 3	عَقْدَ الْإِحْرَامِ
u'عَقْدٌ إِرْثٌ':Added, #3: 3	عَقْدِ الْإِحْرَامِ
u'عَقَدَ إِزَارٌ':Predicate, #1: 1	عَقْدُ إرْثٍ
u'عَقْدٌ إِزَارٌ':Added, #1: 1	عَقَدَ الإِزَارَ
u'عَقْدٌ إِزَارٌ':Added, #1: 1	عَقْدُ الْإِزَارِ
u'عَقْدٌ اِزْدِوَاجٌ':Added, #1: 1	عَقْدِ الْإِزَارِ
u'عَقْدٌ اِسْتيفاءٌ':Added, #1: 1	عَقْدُ ازْدِوَاجٍ
u'عَقَدَ أَسْفَلُ':Subject, #3: 3	عَقْدُ اسْتِيفَاءٍ
u'عَقَدَ إِسْلامٌ':Predicate, #2: 2	عَقَدَ الْأَسْفَلُ
u'عَقْدٌ إِسْلامٌ':Added, #1: 1	عَقَدَ الْإِسْلَامَ
u'عَقْدٌ أَصابِعُ':Added, #1: 1	عَقْدَ الْإِسْلَامِ
u'عَقْدٌ أَصابِعُ':Added, #1: 1	عَقْدُ الْأَصَابِعِ
u'عَقْدٌ إِعارَةٌ':Added, #1: 1	عَقْدِ الْأَصَابِعِ
u'عَقْدٌ إِعارَةٌ':Added, #1: 1	عَقْدِ الْإِعَارَةِ
u'عَقْدٌ إقالَةٌ':Added, #4: 4	عَقْدُ الْإِعَارَةِ
u'عَقْدٌ إقالَةٌ':Added, #1: 1	عَقْدَ الْإِقَالَةِ
u'عَقْدٌ إقالَةٌ':Added, #1: 1	عَقْدِ الْإِقَالَةِ
u'عَقْدٌ أقْرَبُ':Added, #2: 2	عَقْدُ الْإِقَالَةِ
u'عَقْدٌ أقْرَبُ':Added, #1: 1	عَقْدُ الْأَقْرَبِ
u'عَقْدٌ اِكْتِسَابٌ':Added, #1: 1	عَقْدِ الْأَقْرَبِ
u'عَقْدٌ اِكْتِسَابٌ':Added, #2: 2	عَقْدُ اكْتِسَابٍ
u'عَقْدٌ أَكْفَانٌ':Added, #2: 2	عَقْدُ اكْتِسَابِ
u'عَقْدٌ اِلْتِزَامٌ':Added, #1: 1	عَقْدِ الأَكْفَانِ
u'عَقْدٌ الْمَرْأَةُ':Added, #2: 2	عَقْدُ الْتِزَامِ
u'عَقْدٌ أَلْوِيَةٌ':Added, #1: 1	عَقْدُ الْمَرْأَةِ
u'عَقْدٌ أُمٌّ':Added, #1: 1	عَقْدِ الأَلْوِيَةِ
u'عَقْدٌ إمَارَةٌ':Added, #1: 1	عَقْدِ الْأُمِّ
u'عَقْدٌ إمَارَةٌ':Added, #1: 1	عَقْدَ الْإِمَارَةِ
u'عَقَدَ إمَامٌ':Subject, #1: 1	عَقْدُ إمَارَتِهِ
u'عَقَدَ إمَامٌ':Subject, #1: 1	عَقَدَ إمَامُ
u'عَقْدٌ إمَامٌ':Added, #3: 3	عَقَدَ الْإِمَامُ
u'عَقْدٌ إمَامَةٌ':Added, #1: 1	عَقْدِ إمَامِهِ
u'عَقْدٌ إمَامَةٌ':Added, #13: 13	عَقْدِ الْإِمَامَةِ
u'عَقْدٌ أمَانٌ':Added, #3: 3	عَقْدُ الْإِمَامَةِ
u'عَقْدٌ أمَانٌ':Added, #1: 1	عَقْدَ الْأَمَانِ
u'عَقْدٌ أمَانٌ':Added, #2: 2	عَقْدُ الْأَمَانِ
u'عَقْدٌ أمَانَةٌ':Added, #3: 3	عَقْدِ الْأَمَانِ
u'عَقْدٌ اِنْضِمامٌ':Added, #2: 2	عَقْدُ أَمَانَةٍ
u'عَقَدَ أَوَّلُ':Predicate, #3: 3	عَقْدُ انْضِمَامٍ
u'عَقْدٌ إِيجَابٌ':Added, #1: 1	عَقَدَ أَوَّلَ
u'عَقْدٌ أَيْمَانٌ':Added, #1: 1	عَقْدِ الْإِيجَابِ
u'عَقْدٌ إيمَانٌ':Added, #1: 1	عَقْدُ الأَيْمَانِ
u'عَقْدٌ بَابٌ':Added, #1: 1	عَقْدِ الْإِيمَانِ
u'عَقْدٌ بَاطِلٌ':Added, #2: 2	عَقْدَ الْبَابِ
u'عَقْدٌ بَائِعٌ':Added, #1: 1	عَقْدٍ بَاطِلٍ
u'عَقْدٌ بَعْضٌ':Added, #1: 1	عَقْدِ الْبَائِعِ
u'عَقَدَ بُغاةٌ':Subject, #1: 1	عَقْدِ بَعْضِ
u'عَقْدٌ بِكْرٌ':Added, #2: 2	عَقَدَ الْبُغَاةُ
u'عَقْدٌ بِكْرٌ':Added, #1: 1	عَقْدَ الْبِكْرِ
u'عَقَدَ بَيْعٌ':Predicate, #1: 1	عَقْدِ الْبِكْرِ
u'عَقْدٌ بَيْعٌ':Added, #3: 3	عَقَدَ الْبَيْعَ
u'عَقْدٌ بَيْعٌ':Added, #13: 13	عَقْدُ الْبَيْعِ
u'عَقْدٌ بَيْعٌ':Added, #1: 1	عَقْدَ بَيْعٍ
u'عَقْدٌ بَيْعٌ':Added, #1: 1	عَقْدُ بَيْعِ
u'عَقْدٌ بَيْعٌ':Added, #1: 1	عَقْدِ بَيْعِ
u'عَقْدٌ بَيْعٌ':Added, #2: 2	عَقْدَ بَيْعِهِ
u'عَقْدٌ بَيْعٌ':Added, #42: 42	عَقْدِ الْبَيْعِ
u'عَقْدٌ بَيْعٌ':Added, #5: 5	عَقْدُ بَيْعٍ
u'عَقْدٌ بَيْعٌ':Added, #6: 6	عَقْدِ بَيْعٍ
u'عَقْدٌ بَيْعَةٌ':Added, #9: 9	عَقْدَ الْبَيْعِ
u'عَقْدٌ بَيْعَةٌ':Added, #1: 1	عَقْدُ الْبَيْعَةِ
u'عَقَدَ تَاجٌ':Predicate, #1: 1	عَقْدِ الْبَيْعَةِ
u'عَقْدٌ تَامٌّ':Added, #1: 1	عَقَدَ التّاجَ
u'عَقْدٌ تَبَرُّعٌ':Added, #1: 1	عَقْدٍ تَامٍّ
u'عَقْدٌ تَبَرُّعٌ':Added, #2: 2	عَقْدِ التَّبَرُّعِ
u'عَقْدٌ تِجَارَةٌ':Added, #32: 32	عَقْدُ تَبَرُّعٍ
u'عَقْدٌ تِجَارَةٌ':Added, #1: 1	عَقْدُ تِجَارَةٍ
u'عَقْدٌ تَجْدِيدٌ':Added, #3: 3	عَقْدِ التِّجَارَةِ
u'عَقْدٌ تَحْلِيلٌ':Added, #1: 1	عَقْدُ التَّجْدِيدِ
u'عَقْدٌ تَدْبِيرٌ':Added, #1: 1	عَقْدُ تَحْلِيلِ
u'عَقْدٌ تَدْبِيرٌ':Added, #1: 1	عَقْدَ التَّدْبِيرِ
u'عَقْدٌ تَزْوِيجٌ':Added, #2: 2	عَقْدِ التَّدْبِيرِ
u'عَقْدٌ تَزْوِيجٌ':Added, #1: 1	عَقْدُ التَّزْوِيجِ
u'عَقْدٌ تَسْبِيحٌ':Added, #1: 1	عَقْدَ تَزْوِيجِ
u'عَقْدٌ تَعَفُّفٌ':Added, #1: 1	عَقْدُ التَّسْبِيحِ
u'عَقْدٌ تَقْليدٌ':Added, #1: 1	عَقْدِ التَّعَفُّفِ
u'عَقْدٌ تَقْليد':Added, #1: 1	عَقْدِ تَقْلِيدِهِ
u'عَقْدٌ تَكَرُّمٌ':Added, #1: 1	عَقْدِ تَقْلِيدِهِ
u'عَقْدٌ تَمَلُّكٌ':Added, #1: 1	عَقْدُ تَكَرُّمٍ
u'عَقْدٌ تَمْلِيكٌ':Added, #1: 1	عَقْدُ تَمَلُّكٍ
u'عَقْدٌ تَمْلِيكٌ':Added, #3: 3	عَقْدُ تَمْلِيكِ
u'عَقْدٌ تَوَثُّقٌ':Added, #8: 8	عَقْدُ تَمْلِيكٍ
u'عَقَدَ تَوَكُّلٌ':Predicate, #3: 3	عَقْدُ تَوَثُّقٍ
u'عَقْدٌ تَوْكِيلٌ':Added, #1: 1	عَقَدَ التَّوَكُّلَ
u'عَقْدٌ تَوْكِيلٌ':Added, #1: 1	عَقْدُ تَوْكِيلٍ
u'عَقْدٌ تَوْلِيَةٌ':Added, #3: 3	عَقْدِ التَّوْكِيلِ
u'عَقْدٌ تَوْلِيَةٌ':Added, #1: 1	عَقْدُ التَّوْلِيَةِ
u'عَقَدَ ثَالِثٌ':Predicate, #1: 1	عَقْدِ التَّوْلِيَةِ
u'عَقْدٌ ثَالِثٌ':Added, #1: 1	عَقَدَ ثَالِثَةَ
u'عَقَدَ ثَانِي':Predicate, #1: 1	عَقْدِ الثَّالِثَةِ
u'عَقْدٌ ثَانِي':Added, #1: 1	عَقَدَ الثَّانِيَ
u'عَقْدٌ ثَانِي':Added, #1: 1	عَقْدَ الثَّانِيَةِ
u'عَقْدٌ ثَانِيَةٌ':Added, #2: 2	عَقْدِ الثَّانِيَةِ
u'عَقْدٌ ثَانِيَةٌ':Added, #1: 1	عَقْدَ الثَّانِيَةِ
u'عَقَدَ ثَلاثُ':Predicate, #2: 2	عَقْدِ الثَّانِيَةِ
u'عَقْدٌ ثَلاثُ':Added, #1: 1	عَقَدَ ثَلَاثَ
u'عَقْدٌ ثَلاثَةٌ':Added, #1: 1	عَقْدَ الثَّلَاثِ
u'عَقْدٌ ثَلاثَةٌ':Added, #1: 1	عَقْدِ الثَّلَاثَةِ
u'عَقَدَ ثَوْبٌ':Predicate, #1: 1	عَقْدِ ثَلَاثَةٍ
u'عَقْدٌ جَاهِلِيٌّ':Added, #1: 1	عَقَدَ الثَّوْبَ
u'عَقْدٌ جَاهِلِيَّةٌ':Added, #1: 1	عَقْدِ الْجَاهِلِيَّةِ
u'عَقْدٌ جَائِزٌ':Added, #1: 1	عَقْدِ الْجَاهِلِيَّةِ
u'عَقْدٌ جَديدٌ':Added, #3: 3	عَقْدٍ جَائِزٍ
u'عَقَدَ جِزْيَةٌ':Predicate, #8: 8	عَقْدٍ جَدِيدٍ
u'عَقْدٌ جِزْيَةٌ':Added, #2: 2	عَقَدَ الْجِزْيَةَ
u'عَقْدٌ جِزْيَةٌ':Added, #11: 11	عَقْدِ الْجِزْيَةِ
u'عَقْدٌ جِزْيَةٌ':Added, #1: 1	عَقْدِ جِزْيَةٍ
u'عَقْدٌ جِزْيَةٌ':Added, #4: 4	عَقْدَ الْجِزْيَةِ
u'عَقْدٌ جِعال':Added, #4: 4	عَقْدُ الْجِزْيَةِ
u'عَقْدٌ جمعة':Added, #4: 4	عَقْدِ الْجِعَالَةِ
u'عَقْدٌ جُمُعَةٌ':Added, #1: 1	عَقْدِ الْجُمُعَةِ
u'عَقْدٌ جَوْهَرٌ':Added, #1: 1	عَقْدِ الْجُمُعَةِ
u'عَقْدٌ حاكِمٌ':Added, #3: 3	عَقْدَ جَوْهَرٍ
u'عَقَدَ حَبْلٌ':Predicate, #1: 1	عَقْدُ الْحَاكِمِ
u'عَقْدٌ حُرِّيَّةٌ':Added, #1: 1	عَقَدَ الْحَبْلَ
u'عَقْدٌ حُرِّيَّةٌ':Added, #1: 1	عَقْدَ حُرِّيَّةٍ
u'عَقْدٌ حُكْمٌ':Added, #3: 3	عَقْدُ حُرِّيَّةٍ
u'عَقْدٌ حِلْفٌ':Added, #1: 1	عَقْدُ حُكْمِ
u'عَقْدٌ حَوَالَةٌ':Added, #1: 1	عَقْدِ الْحِلْفِ
u'عَقْدٌ خاصّ':Added, #1: 1	عَقْدِ الْحَوَالَةِ
u'عَقْدٌ خرقة':Added, #2: 2	عَقْدٍ خَاصٍّ
u'عَقْدٌ خِرْقَةٌ':Added, #1: 1	عَقْدُ الْخِرْقَةِ
u'عَقْدٌ خِلاَفَةٌ':Added, #1: 1	عَقْدُ الْخِرْقَةِ
u'عَقْدٌ خُلْعٌ':Added, #1: 1	عَقْدَ الْخِلَافَةِ
u'عَقْدٌ خُلْعٌ':Added, #1: 1	عَقْدُ الْخُلْعِ
u'عَقْدٌ خُلْعٌ':Added, #1: 1	عَقْدِ خُلْعٍ
u'عَقَدَ خُلَفَاءُ':Subject, #7: 7	عَقْدِ الْخُلْعِ
u'عَقَدَ خَمْسَةٌ':Predicate, #1: 1	عَقَدَ الْخُلَفَاءُ
u'عَقَدَ خِنْصَرٌ':Predicate, #1: 1	عَقَدَ خَمْسَةَ
u'عَقْدٌ دَرَاهِمُ':Added, #1: 1	عَقَدَ الْخِنْصَرَ
u'عَقْدٌ دَلالَةٌ':Added, #1: 1	عَقْدُ الدَّرَاهِمِ
u'عَقْدٌ دَوْرٌ':Added, #1: 1	عَقْدِ الدَّلَالَةِ
u'عَقَدَ ذِمَّةٌ':Predicate, #1: 1	عَقْدُ الدَّوْرِ
u'عَقْدٌ ذِمَّةٌ':Added, #1: 1	عَقَدَ الذِّمَّةَ
u'عَقْدٌ ذِمَّةٌ':Added, #11: 11	عَقْدَ الذِّمَّةِ
u'عَقْدٌ ذِمَّةٌ':Added, #13: 13	عَقْدُ الذِّمَّةِ
u'عَقْدٌ ذِمَّةٌ':Added, #1: 1	عَقْدِ ذِمَّةٍ
u'عَقْدٌ ذِمِّيٌّ':Added, #41: 41	عَقْدِ الذِّمَّةِ
u'عَقَدَ رايَة':Predicate, #1: 1	عَقْدَ الذِّمِّيِّ
u'عَقَدَ رَجُلٌ':Subject, #1: 1	عَقَدَ رَايَةَ
u'عَقَدَ رَجُلٌ':Subject, #1: 1	عَقَدَ الرَّجُلُ
u'عَقْدٌ رَجُلٌ':Added, #1: 1	عَقَدَ رَجُلٌ
u'عَقْدٌ رَجُلٌ':Added, #1: 1	عَقْدُ الرَّجُلِ
u'عَقْدٌ رَجُلٌ':Added, #1: 1	عَقْدِ الرَّجُلِ
u'عَقَدَ رِدَاءٌ':Predicate, #1: 1	عَقْدَ الرَّجُلَيْنِ
u'عَقَدَ رَسُولٌ':Subject, #1: 1	عَقَدَ الرِّدَاءَ
u'عَقْدٌ رَسُولٌ':Added, #3: 3	عَقَدَ رَسُولُ
u'عَقْدٌ رَسُولٌ':Added, #1: 1	عَقْدِ الرَّسُولِ
u'عَقْدٌ رَعْيٌ':Added, #2: 2	عَقْدِ رَسُولِ
u'عَقْدٌ رفقة':Added, #1: 1	عَقْدِ الرَّعْيِ
u'عَقْدٌ رفقة':Added, #1: 1	عَقْدَ الرِّفْقَةِ
u'عَقْدٌ رُفْقَةٌ':Added, #1: 1	عَقْدُ الرُّفْقَةِ
u'عَقْدٌ رفقة':Added, #1: 1	عَقْدُ الرُّفْقَةِ
u'عَقْدٌ رُفْقَةٌ':Added, #3: 3	عَقْدَ الرُّفْقَةِ
u'عَقْدٌ رَقيقٌ':Added, #3: 3	عَقْدَ الرُّفْقَةِ
u'عَقْدٌ رَقيق':Added, #1: 1	عَقْدِ الرَّقِيقِ
u'عَقْدٌ ركعة':Added, #1: 1	عَقْدِ الرَّقِيقِ
u'عَقْدٌ ركعة':Added, #2: 2	عَقْدَ رَكْعَةٍ
u'عَقْدٌ رَكْعَةٌ':Added, #2: 2	عَقْدِ رَكْعَةٍ
u'عَقْدٌ رَكْعَةٌ':Added, #2: 2	عَقْدَ رَكْعَةٍ
u'عَقْدٌ ركعة':Added, #2: 2	عَقْدِ رَكْعَةٍ
u'عَقْدٌ رَكْعَةٌ':Added, #4: 4	عَقْدَ الرَّكْعَةِ
u'عَقْدٌ رُكوعٌ':Added, #4: 4	عَقْدَ الرَّكْعَةِ
u'عَقْدٌ رُكوعٌ':Added, #1: 1	عَقْدِ رُكُوعٍ
u'عَقَدَ رَهْنٌ':Predicate, #1: 1	عَقْدِ رُكُوعِ
u'عَقْدٌ رَهْنٌ':Added, #1: 1	عَقَدَ الرَّهْنَ
u'عَقْدٌ رَهْن':Added, #16: 16	عَقْدُ الرَّهْنِ
u'عَقْدٌ رَهْنٌ':Added, #1: 1	عَقْدِ الرَّهْنِيَّةِ
u'عَقْدٌ رَهْنٌ':Added, #20: 20	عَقْدَ الرَّهْنِ
u'عَقْدٌ رَهْنِيَّة':Added, #56: 56	عَقْدِ الرَّهْنِ
u'عَقْدٌ رَئِيسٌ':Added, #1: 1	عَقْدِ الرَّهْنِيَّةِ
u'عَقْدٌ زِراعَةٌ':Added, #1: 1	عَقْدُ الرَّئِيسِ
u'عَقْدٌ زَواجٌ':Added, #1: 1	عَقْدِ الزِّرَاعَةِ
u'عَقْدٌ زَوْجَةٌ':Added, #2: 2	عَقْدَ الزَّوَاجِ
u'عَقْدٌ زَوْجِيٌّ':Added, #1: 1	عَقْدَ زَوْجَتِهِ
u'عَقْدٌ سَابِقٌ':Added, #2: 2	عَقْدُ الزَّوْجِيَّةِ
u'عَقْدٌ سِرٌّ':Added, #1: 1	عَقْدَ سَابِقٍ
u'عَقْدٌ سِرٌّ':Added, #1: 1	عَقْدِ السِّرِّ
u'عَقْدٌ سَفِيهٌ':Added, #2: 2	عَقْدُ السِّرِّ
u'عَقْدٌ سَفِيهٌ':Added, #1: 1	عَقْدَ السَّفِيهِ
u'عَقْدٌ سَفِيهٌ':Added, #1: 1	عَقْدُ السَّفِيهِ
u'عَقْدٌ سَلاَمَةٌ':Added, #1: 1	عَقْدِ السَّفِيهِ
u'عَقْدٌ سَلْطَنَةٌ':Added, #1: 1	عَقْدُ السَّلَامَةِ
u'عَقْدٌ سَلَفٌ':Added, #1: 1	عَقْدَ السَّلْطَنَةِ
u'عَقَدَ سَلَمٌ':Predicate, #1: 1	عَقْدِ سَلَفٍ
u'عَقَدَ سَلَمٌ':Subject, #1: 1	عَقَدَ السَّلَمَ
u'عَقْدٌ سَلَمٌ':Added, #1: 1	عَقَدَ السَّلَمُ
u'عَقْدٌ سَلَمٌ':Added, #11: 11	عَقْدَ السَّلَمِ
u'عَقْدٌ سَلَمٌ':Added, #1: 1	عَقْدُ سَلَمٍ
u'عَقْدٌ سَلَمٌ':Added, #4: 4	عَقْدُ السَّلَمِ
u'عَقْدٌ شِرَاءٌ':Added, #9: 9	عَقْدِ السَّلَمِ
u'عَقْدٌ شِرَاءٌ':Added, #2: 2	عَقْدَ الشِّرَاءِ
u'عَقْدٌ شِرَاءٌ':Added, #2: 2	عَقْدُ الشِّرَاءِ
u'عَقْدٌ شَرْعِيٌّ':Added, #3: 3	عَقْدِ الشِّرَاءِ
u'عَقَدَ شركة':Predicate, #1: 1	عَقْدٍ شَرْعِيٍّ
u'عَقَدَ شركة':Predicate, #3: 3	عَقَدَ الشَّرِكَةَ
u'عَقَدَ شَرِكَةٌ':Predicate, #3: 3	عَقَدَ الشِّرْكَةَ
u'عَقَدَ شِرْكَةٌ':Predicate, #3: 3	عَقَدَ الشَّرِكَةَ
u'عَقْدٌ شركة':Added, #3: 3	عَقَدَ الشِّرْكَةَ
u'عَقْدٌ شَرِكَةٌ':Added, #12: 12	عَقْدُ الشَّرِكَةِ
u'عَقْدٌ شركة':Added, #12: 12	عَقْدُ الشَّرِكَةِ
u'عَقْدٌ شَرِكَةٌ':Added, #19: 19	عَقْدَ الشَّرِكَةِ
u'عَقْدٌ شركة':Added, #19: 19	عَقْدَ الشَّرِكَةِ
u'عَقْدٌ شركة':Added, #1: 1	عَقْدَ الشِّرْكَةِ
u'عَقْدٌ شِرْكَةٌ':Added, #1: 1	عَقْدِ الشِّرْكَةِ
u'عَقْدٌ شِرْكَةٌ':Added, #1: 1	عَقْدَ الشِّرْكَةِ
u'عَقْدٌ شركة':Added, #1: 1	عَقْدِ الشِّرْكَةِ
u'عَقْدٌ شركة':Added, #1: 1	عَقْدَ شَرِكَةٍ
u'عَقْدٌ شَرِكَةٌ':Added, #1: 1	عَقْدِ شَرِكَةٍ
u'عَقْدٌ شَرِكَةٌ':Added, #1: 1	عَقْدَ شَرِكَةٍ
u'عَقْدٌ شركة':Added, #1: 1	عَقْدِ شَرِكَةٍ
u'عَقْدٌ شِرْكَةٌ':Added, #2: 2	عَقْدُ الشِّرْكَةِ
u'عَقْدٌ شركة':Added, #2: 2	عَقْدُ الشِّرْكَةِ
u'عَقْدٌ شركة':Added, #2: 2	عَقْدُ شَرِكَةٍ
u'عَقْدٌ شَرِكَةٌ':Added, #2: 2	عَقْدُ شَرِكَةِ
u'عَقْدٌ شَرِكَةٌ':Added, #2: 2	عَقْدُ شَرِكَةٍ
u'عَقْدٌ شركة':Added, #2: 2	عَقْدُ شَرِكَةِ
u'عَقْدٌ شَرِكَةٌ':Added, #37: 37	عَقْدِ الشَّرِكَةِ
u'عَقْدٌ شَرِيكٌ':Added, #37: 37	عَقْدِ الشَّرِكَةِ
u'عَقْدٌ شَرِيكٌ':Added, #1: 1	عَقْدُ شَرِيكِهِ
u'عَقْدٌ شَعِيرَةٌ':Added, #1: 1	عَقْدِ شَرِيكِهِ
u'عَقْدٌ شَعِيرَة':Added, #1: 1	عَقْدَ شَعِيرَةٍ
u'عَقَدَ شَيْءٌ':Predicate, #1: 1	عَقْدَ شَعِيرَةٍ
u'عَقْدٌ صَاحِبٌ':Added, #1: 1	عَقَدَ الشَّيْءَ
u'عَقْدٌ صَبِيٌّ':Added, #1: 1	عَقْدِ صَاحِبِهِ
u'عَقْدٌ صَبِيٌّ':Added, #1: 1	عَقْدُ الصَّبِيِّ
u'عَقْدٌ صَبِيٌّ':Added, #1: 1	عَقْدِ الصَّبِيِّ
u'عَقْدٌ صِحَّةٌ':Added, #1: 1	عَقْدِ صَبِيٍّ
u'عَقْدٌ صداق':Added, #1: 1	عَقْدِ الصِّحَّةِ
u'عَقْدٌ صداق':Added, #1: 1	عَقْدَ الصَّدَاقِ
u'عَقْدٌ صَدَاقٌ':Added, #1: 1	عَقْدِ الصَّدَاقِ
u'عَقْدٌ صَدَاقٌ':Added, #1: 1	عَقْدَ الصَّدَاقِ
u'عَقْدٌ صداق':Added, #1: 1	عَقْدِ الصَّدَاقِ
u'عَقْدٌ صَدَاقٌ':Added, #7: 7	عَقْدُ الصَّدَاقِ
u'عَقْدٌ صدقة':Added, #7: 7	عَقْدُ الصَّدَاقِ
u'عَقْدٌ صَدَقَةٌ':Added, #1: 1	عَقْدَ الصَّدَقَةِ
u'عَقْدٌ صدقة':Added, #1: 1	عَقْدَ الصَّدَقَةِ
u'عَقْدٌ صَدَقَةٌ':Added, #1: 1	عَقْدِ صَدَقَتِهِ
u'عَقَدَ صَرْفٌ':Predicate, #1: 1	عَقْدِ صَدَقَتِهِ
u'عَقَدَ صَرْف':Predicate, #1: 1	عَقَدَ الصَّرْفَ
u'عَقْدٌ صَرْفٌ':Added, #1: 1	عَقَدَ الصَّرْفَ
u'عَقْدٌ صَرْف':Added, #11: 11	عَقْدِ الصَّرْفِ
u'عَقْدٌ صَرْفٌ':Added, #11: 11	عَقْدِ الصَّرْفِ
u'عَقْدٌ صَرْفٌ':Added, #1: 1	عَقْدَ صَرْفٍ
u'عَقْدٌ صَرْفٌ':Added, #1: 1	عَقْدُ صَرْفٍ
u'عَقْدٌ صَرْف':Added, #1: 1	عَقْدِ صَرْفٍ
u'عَقْدٌ صَرْف':Added, #1: 1	عَقْدَ صَرْفٍ
u'عَقْدٌ صَرْف':Added, #1: 1	عَقْدُ صَرْفٍ
u'عَقْدٌ صَرْفٌ':Added, #1: 1	عَقْدِ صَرْفٍ
u'عَقْدٌ صَرْفٌ':Added, #4: 4	عَقْدَ الصَّرْفِ
u'عَقْدٌ صَرْف':Added, #4: 4	عَقْدُ الصَّرْفِ
u'عَقْدٌ صَرْف':Added, #4: 4	عَقْدَ الصَّرْفِ
u'عَقْدٌ صَغِيرٌ':Added, #4: 4	عَقْدُ الصَّرْفِ
u'عَقْدٌ صَغِيرٌ':Added, #1: 1	عَقْدَ الصَّغِيرَةِ
u'عَقْدٌ صِفَةٌ':Added, #2: 2	عَقْدَ الصَّغِيرِ
u'عَقْدٌ صِفَةٌ':Added, #1: 1	عَقْدِ الصِّفَةِ
u'عَقْدٌ صَفْقَةٌ':Added, #2: 2	عَقْدَ صِفَةٍ
u'عَقَدَ صَلاَةٌ':Predicate, #1: 1	عَقْدِ الصَّفْقَةِ
u'عَقْدٌ صَلاَةٌ':Added, #1: 1	عَقَدَ الصَّلَاةَ
u'عَقْدٌ صَلاَةٌ':Added, #1: 1	عَقْدَ الصَّلَاةِ
u'عَقْدٌ صلح':Added, #2: 2	عَقْدِ الصَّلَاةِ
u'عَقْدٌ صُلْحٌ':Added, #2: 2	عَقْدَ الصُّلْحِ
u'عَقْدٌ صلح':Added, #2: 2	عَقْدَ الصُّلْحِ
u'عَقْدٌ صُلْحٌ':Added, #3: 3	عَقْدُ الصُّلْحِ
u'عَقْدٌ صلح':Added, #3: 3	عَقْدُ الصُّلْحِ
u'عَقْدٌ صُلْحٌ':Added, #6: 6	عَقْدِ الصُّلْحِ
u'عَقَدَ صَوْمٌ':Predicate, #6: 6	عَقْدِ الصُّلْحِ
u'عَقْدٌ ضَمَانٌ':Added, #1: 1	عَقَدَ الصَّوْمَ
u'عَقْدٌ ضَمَانٌ':Added, #1: 1	عَقْدِ ضَمَانٍ
u'عَقْدٌ ظُهْرٌ':Added, #5: 5	عَقْدُ ضَمَانٍ
u'عَقْدٌ عارِيَّةٌ':Added, #1: 1	عَقْدُ الظُّهْرِ
u'عَقْدٌ عارِيَّةٌ':Added, #1: 1	عَقْدَ الْعَارِيَّةِ
u'عَقْدٌ عَاقِدٌ':Added, #4: 4	عَقْدِ الْعَارِيَّةِ
u'عَقَدَ عَبْدٌ':Subject, #1: 1	عَقْدِ الْعَاقِدِ
u'عَقْدٌ عَتاقَة':Added, #1: 1	عَقَدَ الْعَبْدُ
u'عَقْدٌ عِتْقٌ':Added, #5: 5	عَقْدُ عَتَاقَةٍ
u'عَقْدٌ عتق':Added, #1: 1	عَقْدُ عِتْقٍ
u'عَقْدٌ عِتْقٌ':Added, #2: 2	عَقْدَ الْعِتْقِ
u'عَقْدٌ عَدَدٌ':Added, #2: 2	عَقْدَ الْعِتْقِ
u'عَقَدَ عَقْدٌ':Predicate, #1: 1	عَقْدِ عَدَدٍ
u'عَقَدَ عَقْدٌ':Predicate, #4: 4	عَقَدَ الْعَقْدَ
u'عَقْدٌ عَلاَنِيَةٌ':Added, #4: 4	عَقَدَ عَقْدَ
u'عَقْدٌ عَمٌّ':Added, #2: 2	عَقْدُ الْعَلَانِيَةِ
u'عَقْدٌ عُمُرٌ':Added, #1: 1	عَقْدِ الْعَمِّ
u'عَقْدٌ عُهْدَةٌ':Added, #1: 1	عَقْدُ الْعُمُرِ
u'عَقْدٌ غَائِبٌ':Added, #1: 1	عَقْدَ عُهْدَةٍ
u'عَقْدٌ غَبْنٌ':Added, #1: 1	عَقْدَ الْغَائِبِ
u'عَقْدٌ غَرَرٌ':Added, #1: 1	عَقْدُ غَبْنٍ
u'عَقْدٌ غير':Added, #5: 5	عَقْدُ غَرَرٍ
u'عَقْدٌ غَيْرٌ':Added, #1: 1	عَقْدِ غَيْرِهِ
u'عَقْدٌ غير':Added, #1: 1	عَقْدِ غَيْرِهِ
u'عَقْدٌ غَيْرٌ':Added, #2: 2	عَقْدِ غَيْرِ
u'عَقْدٌ فَاسِدٌ':Added, #2: 2	عَقْدِ غَيْرِ
u'عَقْدٌ فرائد':Added, #33: 33	عَقْدٍ فَاسِدٍ
u'عَقْدٌ فَصْلٌ':Added, #2: 2	عَقْدِ الْفَرَائِدِ
u'عَقْدٌ فضلاء':Added, #1: 1	عَقْدِ فَصْلَيْنِ
u'عَقْدٌ فُضَلاَءُ':Added, #1: 1	عَقْدِ الْفُضَلَاءِ
u'عَقَدَ فُضُولِيٌّ':Subject, #1: 1	عَقْدِ الْفُضَلَاءِ
u'عَقْدٌ فُضُولِيٌّ':Added, #1: 1	عَقَدَ فُضُولِيٌّ
u'عَقْدٌ فُضُولِيٌّ':Added, #1: 1	عَقْدَ فُضُولِيٍّ
u'عَقْدٌ فُضُولِيٌّ':Added, #1: 1	عَقْدُ فُضُولِيٍّ
u'عَقْدٌ فُضُولِيٌّ':Added, #1: 1	عَقْدِ فُضُولِيٍّ
u'عَقْدٌ فُضُولِيٌّ':Added, #2: 2	عَقْدَ الْفُضُولِيِّ
u'عَقْدٌ فُضُولِيٌّ':Added, #2: 2	عَقْدُ الْفُضُولِيِّ
u'عَقَدَ فلان':Predicate, #3: 3	عَقْدِ الْفُضُولِيِّ
u'عَقَدَ فلان':Predicate, #1: 1	عَقَدَ رَايَةً
u'عَقْدٌ فَوَائِدُ':Added, #1: 1	عَقَدَ رَايَةَ
u'عَقْدٌ قراض':Added, #10: 10	عَقْدِ الْفَوَائِدِ
u'عَقْدٌ قراض':Added, #2: 2	عَقْدُ الْقِرَاضِ
u'عَقْدٌ قُرْبَةٌ':Added, #3: 3	عَقْدِ الْقِرَاضِ
u'عَقْدٌ قَرْضٌ':Added, #4: 4	عَقْدَ قُرْبَةٍ
u'عَقْدٌ قَرْضٌ':Added, #1: 1	عَقْدِ الْقَرْضِ
u'عَقْدٌ قُرَيْشٌ':Added, #2: 2	عَقْدَ الْقَرْضِ
u'عَقَدَ قلب':Subject, #8: 8	عَقْدِ قُرَيْشٍ
u'عَقَدَ قَلْبٌ':Subject, #3: 3	عَقَدَ الْقَلْبُ
u'عَقَدَ قَلْب':Subject, #3: 3	عَقَدَ الْقَلْبُ
u'عَقْدٌ قلب':Added, #3: 3	عَقَدَ الْقَلْبُ
u'عَقْدٌ قَلْبٌ':Added, #2: 2	عَقْدَ الْقَلْبِ
u'عَقْدٌ قَلْب':Added, #2: 2	عَقْدَ الْقَلْبِ
u'عَقْدٌ قلب':Added, #2: 2	عَقْدَ الْقَلْبِ
u'عَقْدٌ قَلْبٌ':Added, #3: 3	عَقْدِ الْقَلْبِ
u'عَقْدٌ قَلْب':Added, #3: 3	عَقْدِ الْقَلْبِ
u'عَقْدٌ قلب':Added, #3: 3	عَقْدِ الْقَلْبِ
u'عَقْدٌ قَلْبٌ':Added, #6: 6	عَقْدُ الْقَلْبِ
u'عَقْدٌ قَلْب':Added, #6: 6	عَقْدُ الْقَلْبِ
u'عَقْدٌ قِنٌّ':Added, #6: 6	عَقْدُ الْقَلْبِ
u'عَقْدٌ كَافِرٌ':Added, #1: 1	عَقْدِ الْقِنِّ
u'عَقَدَ كِتَابَةٌ':Predicate, #1: 1	عَقْدَ كَافِرٍ
u'عَقْدٌ كِتَابَةٌ':Added, #2: 2	عَقَدَ الْكِتَابَةَ
u'عَقْدٌ كِتَابَةٌ':Added, #18: 18	عَقْدُ الْكِتَابَةِ
u'عَقْدٌ كِتَابَةٌ':Added, #1: 1	عَقْدَ كِتَابَةِ
u'عَقْدٌ كِتَابَةٌ':Added, #1: 1	عَقْدُ كِتَابَةٍ
u'عَقْدٌ كِتَابَةٌ':Added, #25: 25	عَقْدَ الْكِتَابَةِ
u'عَقْدٌ كِتَابَةٌ':Added, #2: 2	عَقْدِ كِتَابَتِهِ
u'عَقْدٌ كِرَاءٌ':Added, #52: 52	عَقْدِ الْكِتَابَةِ
u'عَقْدٌ كِرَاءٌ':Added, #2: 2	عَقْدِ الْكِرَاءِ
u'عَقْدٌ كِرَاءٌ':Added, #4: 4	عَقْدَ الْكِرَاءِ
u'عَقْدٌ كرائه':Added, #6: 6	عَقْدُ الْكِرَاءِ
u'عَقْدٌ كَفَالَةٌ':Added, #1: 1	عَقْدِ كِرَائِهِ
u'عَقْدٌ كَفَالَةٌ':Added, #1: 1	عَقْدَ الْكَفَالَةِ
u'عَقْدٌ كَفَالَةٌ':Added, #1: 1	عَقْدُ الْكَفَالَةِ
u'عَقْدٌ لاَزِمٌ':Added, #7: 7	عَقْدِ الْكَفَالَةِ
u'عَقْدٌ لِوَاءٌ':Added, #3: 3	عَقْدٍ لَازِمٍ
u'عَقْدٌ لُؤْلُؤٌ':Added, #2: 2	عَقْدُ اللّوَاءِ
u'عَقْدٌ لُؤْلُؤٌ':Added, #1: 1	عَقْدُ اللُّؤْلُؤِ
u'عَقْدٌ مَالِيٌّ':Added, #1: 1	عَقْدَ لُؤْلُؤٍ
u'عَقْدٌ مُبَادَلَةٌ':Added, #1: 1	عَقْدٍ مَالِيٍّ
u'عَقْدٌ مَبِيعٌ':Added, #2: 2	عَقْدُ مُبَادَلَةٍ
u'عَقْدٌ مَبِيعٌ':Added, #1: 1	عَقْدُ الْمَبِيعِ
u'عَقْدٌ مُتَجَدِّدٌ':Added, #1: 1	عَقْدِ الْمَبِيعِ
u'عَقْدٌ مُتَفاوِض':Added, #2: 2	عَقْدٍ مُتَجَدِّدٍ
u'عَقْدٌ مُجَدَّدُ':Added, #1: 1	عَقْدُ الْمُتَفَاوِضَيْنِ
u'عَقْدٌ مَحْجُورٌ':Added, #1: 1	عَقْدٍ مُجَدَّدٍ
u'عَقْدٌ مُحَلِّل':Added, #1: 1	عَقْدَ الْمَحْجُورِ
u'عَقْدٌ مُحَلِّل':Added, #1: 1	عَقْدَ الْمُحَلِّلِ
u'عَقْدٌ مُحَمَّدٌ':Added, #1: 1	عَقْدِ الْمُحَلِّلِ
u'عَقْدٌ مُرابَحَة':Added, #4: 4	عَقْدِ مُحَمَّدٍ
u'عَقْدٌ مُراضاة':Added, #2: 2	عَقْدَ مُرَابَحَةٍ
u'عَقْدٌ مُسَابَقَةٌ':Added, #1: 1	عَقْدُ مُرَاضَاةٍ
u'عَقَدَ مُساقاة':Predicate, #1: 1	عَقْدَ الْمُسَابَقَةِ
u'عَقْدٌ مُساقاة':Added, #1: 1	عَقَدَ الْمُسَاقَاةَ
u'عَقْدٌ مُساقاة':Added, #1: 1	عَقْدَ الْمُسَاقَاةِ
u'عَقْدٌ مُساقاة':Added, #8: 8	عَقْدُ الْمُسَاقَاةِ
u'عَقْدٌ مَسْأَلَةٌ':Added, #8: 8	عَقْدِ الْمُسَاقَاةِ
u'عَقْدٌ مُسَاهَلَةٌ':Added, #1: 1	عَقْدُ مَسْأَلَةٍ
u'عَقَدَ مُسْتَحِقٌّ':Subject, #1: 1	عَقْدُ مُسَاهَلَةٍ
u'عَقْدٌ مُسْتَقِلٌّ':Added, #2: 2	عَقَدَ الْمُسْتَحِقُّ
u'عَقَدَ مُسْلِمٌ':Subject, #1: 1	عَقْدٍ مُسْتَقِلٍّ
u'عَقْدٌ مُسْلِمٌ':Added, #2: 2	عَقَدَ مُسْلِمٌ
u'عَقْدٌ مُسْلِمٌ':Added, #1: 1	عَقْدُ الْمُسْلِمِ
u'عَقْدٌ مُشْتَمِلٌ':Added, #1: 1	عَقْدِ الْمُسْلِمِ
u'عَقْدٌ مَشْرُوعٌ':Added, #2: 2	عَقْدٍ مُشْتَمِلٍ
u'عَقْدٌ مُضَارَبَةٌ':Added, #2: 2	عَقْدٍ مَشْرُوعٍ
u'عَقْدٌ مُضَارَبَةٌ':Added, #2: 2	عَقْدُ الْمُضَارَبَةِ
u'عَقْدٌ مُضَارَبَةٌ':Added, #5: 5	عَقْدَ الْمُضَارَبَةِ
u'عَقْدٌ مُطْلَقٌ':Added, #7: 7	عَقْدِ الْمُضَارَبَةِ
u'عَقْدٌ مُعَارَضَةٌ':Added, #1: 1	عَقْدٍ مُطْلَقٍ
u'عَقْدٌ مُعَامَلَةٌ':Added, #1: 1	عَقْدِ الْمُعَارَضَةِ
u'عَقْدٌ مُعَامَلَةٌ':Added, #1: 1	عَقْدِ الْمُعَامَلَةِ
u'عَقْدٌ مُعَامَلَةٌ':Added, #1: 1	عَقْدَ مُعَامَلَةٍ
u'عَقْدٌ مُعَلَّقٌ':Added, #4: 4	عَقْدُ مُعَامَلَةٍ
u'عَقْدٌ مُفَاوَضَةٌ':Added, #1: 1	عَقْدٍ مُعَلَّقٍ
u'عَقْدٌ مُفَاوَضَةٌ':Added, #2: 2	عَقْدَ الْمُفَاوَضَةِ
u'عَقْدٌ مُكَلَّفٌ':Added, #3: 3	عَقْدِ الْمُفَاوَضَةِ
u'عَقْدٌ مِلْكٌ':Added, #1: 1	عَقْدِ الْمُكَلَّفِ
u'عَقْدٌ مَمْلُوكٌ':Added, #1: 1	عَقْدِ الْمِلْكِ
u'عَقْدٌ مَمْلُوكٌ':Added, #1: 1	عَقْدُ الْمَمْلُوكِ
u'عَقْدٌ مَنْفَعَةٌ':Added, #1: 1	عَقْدَ مَمْلُوكٍ
u'عَقْدٌ مُهَادَنَةٌ':Added, #1: 1	عَقْدِ مَنْفَعَةِ
u'عَقْدٌ مُوَافَقَةٌ':Added, #1: 1	عَقْدِ الْمُهَادَنَةِ
u'عَقَدَ مُوالاة':Predicate, #1: 1	عَقْدُ مُوَافَقَةٍ
u'عَقْدٌ مُوالاة':Added, #1: 1	عَقَدَ الْمُوَالَاةَ
u'عَقْدٌ مُوالاة':Added, #6: 6	عَقْدَ الْمُوَالَاةِ
u'عَقْدٌ مُوالاة':Added, #6: 6	عَقْدُ الْمُوَالَاةِ
u'عَقْدٌ مُوَرِّث':Added, #7: 7	عَقْدِ الْمُوَالَاةِ
u'عَقْدٌ نَائِبٌ':Added, #1: 1	عَقْدُ الْمُوَرِّثِ
u'عَقَدَ نَبِيٌّ':Subject, #2: 2	عَقْدُ نَائِبِهِ
u'عَقْدٌ نَبِيٌّ':Added, #1: 1	عَقَدَ النَّبِيُّ
u'عَقْدٌ نَبِيٌّ':Added, #1: 1	عَقْدُ النَّبِيِّ
u'عَقْدٌ نَخْلٌ':Added, #1: 1	عَقْدِ النَّبِيِّ
u'عَقْدٌ نذر':Added, #1: 1	عَقْدِ نَخْلٍ
u'عَقْدٌ نَذْرٌ':Added, #1: 1	عَقْدِ النَّذْرِ
u'عَقْدٌ نَذْرٌ':Added, #1: 1	عَقْدِ النَّذْرِ
u'عَقَدَ نِصْفٌ':Predicate, #1: 1	عَقْدٍ نَذْرٍ
u'عَقَدَ نِضَالٌ':Predicate, #1: 1	عَقَدَ نِصْفَ
u'عَقَدَ نَفَذٌ':Predicate, #2: 2	عَقَدَ النِّضَالَ
u'عَقَدَ نكاح':Predicate, #2: 2	عَقَدَ نَفَذَ
u'عَقَدَ نِكَاحٌ':Predicate, #1: 1	عَقَدَ نِكَاحَ
u'عَقَدَ نكاح':Predicate, #1: 1	عَقَدَ نِكَاحَ
u'عَقَدَ نِكَاحٌ':Predicate, #3: 3	عَقَدَ النِّكَاحَ
u'عَقْدٌ نكاح':Added, #3: 3	عَقَدَ النِّكَاحَ
u'عَقْدٌ نِكَاحٌ':Added, #102: 102	عَقْدِ النِّكَاحِ
u'عَقْدٌ نكاح':Added, #102: 102	عَقْدِ النِّكَاحِ
u'عَقْدٌ نكاح':Added, #1: 1	عَقْدَ نِكَاحِ
u'عَقْدٌ نِكَاحٌ':Added, #1: 1	عَقْدُ نِكَاحِ
u'عَقْدٌ نِكَاحٌ':Added, #1: 1	عَقْدَ نِكَاحِ
u'عَقْدٌ نكاح':Added, #1: 1	عَقْدُ نِكَاحِ
u'عَقْدٌ نِكَاحٌ':Added, #1: 1	عَقْدَ نِكَاحِهِ
u'عَقْدٌ نكاح':Added, #1: 1	عَقْدَ نِكَاحِهِ
u'عَقْدٌ نِكَاحٌ':Added, #33: 33	عَقْدُ النِّكَاحِ
u'عَقْدٌ نكاح':Added, #33: 33	عَقْدُ النِّكَاحِ
u'عَقْدٌ نكاح':Added, #3: 3	عَقْدَ نِكَاحٍ
u'عَقْدٌ نكاح':Added, #3: 3	عَقْدُ نِكَاحٍ
u'عَقْدٌ نِكَاحٌ':Added, #3: 3	عَقْدِ نِكَاحِ
u'عَقْدٌ نِكَاحٌ':Added, #3: 3	عَقْدَ نِكَاحٍ
u'عَقْدٌ نِكَاحٌ':Added, #3: 3	عَقْدُ نِكَاحٍ
u'عَقْدٌ نكاح':Added, #3: 3	عَقْدِ نِكَاحِ
u'عَقْدٌ نِكَاحٌ':Added, #40: 40	عَقْدَ النِّكَاحِ
u'عَقْدٌ نكاح':Added, #40: 40	عَقْدَ النِّكَاحِ
u'عَقْدٌ نِكَاحٌ':Added, #5: 5	عَقْدِ نِكَاحِهِ
u'عَقْدٌ نكاح':Added, #5: 5	عَقْدِ نِكَاحِهِ
u'عَقْدٌ نِكَاحٌ':Added, #6: 6	عَقْدِ نِكَاحٍ
u'عَقْدٌ نِيَابَةٌ':Added, #6: 6	عَقْدِ نِكَاحٍ
u'عَقَدَ نِيَّةٌ':Predicate, #1: 1	عَقْدُ نِيَابَةٍ
u'عَقْدٌ نِيَّةٌ':Added, #1: 1	عَقَدَ النِّيَّةَ
u'عَقْدٌ هِبَةٌ':Added, #1: 1	عَقْدُ النِّيَّةِ
u'عَقْدٌ هِبَةٌ':Added, #5: 5	عَقْدَ الْهِبَةِ
u'عَقْدٌ هِبَةٌ':Added, #6: 6	عَقْدُ الْهِبَةِ
u'عَقَدَ هُدْنَةٌ':Predicate, #8: 8	عَقْدِ الْهِبَةِ
u'عَقْدٌ هُدْنَةٌ':Added, #1: 1	عَقَدَ الْهُدْنَةَ
u'عَقْدٌ هُدْنَةٌ':Added, #2: 2	عَقْدَ الْهُدْنَةِ
u'عَقْدٌ هُدْنَةٌ':Added, #6: 6	عَقْدُ الْهُدْنَةِ
u'عَقْدٌ وَاجِبٌ':Added, #8: 8	عَقْدِ الْهُدْنَةِ
u'عَقْدٌ واحد':Added, #1: 1	عَقْدٍ وَاجِبٍ
u'عَقْدٌ وَاحِدٌ':Added, #2: 2	عَقْدُ الْوَاحِدِ
u'عَقْدٌ واحد':Added, #2: 2	عَقْدُ الْوَاحِدِ
u'عَقْدٌ وَاحِدٌ':Added, #81: 81	عَقْدٍ وَاحِدٍ
u'عَقْدٌ وثائق':Added, #81: 81	عَقْدٍ وَاحِدٍ
u'عَقْدٌ وَثَائِقُ':Added, #1: 1	عَقْدِ الْوَثَائِقِ
u'عَقْدٌ وَدِيعٌ':Added, #1: 1	عَقْدِ الْوَثَائِقِ
u'عَقْدٌ وَدِيعٌ':Added, #1: 1	عَقْدُ الْوَدِيعَةِ
u'عَقْدٌ وَدِيعٌ':Added, #2: 2	عَقْدِ الْوَدِيعَةِ
u'عَقْدٌ وَدِيعَةٌ':Added, #3: 3	عَقْدَ الْوَدِيعَةِ
u'عَقْدٌ وَدِيعَةٌ':Added, #1: 1	عَقْدُ الْوَدِيعَةِ
u'عَقْدٌ وَدِيعَةٌ':Added, #1: 1	عَقْدَ وَدِيعَةٍ
u'عَقْدٌ وَدِيعَةٌ':Added, #1: 1	عَقْدُ وَدِيعَةٍ
u'عَقْدٌ وَدِيعَةٌ':Added, #2: 2	عَقْدِ الْوَدِيعَةِ
u'عَقْدٌ وَصِيٌّ':Added, #3: 3	عَقْدَ الْوَدِيعَةِ
u'عَقْدٌ وَصِيٌّ':Added, #1: 1	عَقْدَ الْوَصِيِّ
u'عَقْدٌ وَصِيٌّ':Added, #1: 1	عَقْدُ الْوَصِيَّةِ
u'عَقْدٌ وَصِيَّةٌ':Added, #1: 1	عَقْدِ الْوَصِيَّةِ
u'عَقْدٌ وَصِيَّةٌ':Added, #1: 1	عَقْدُ الْوَصِيَّةِ
u'عَقْدٌ وَقْفٌ':Added, #1: 1	عَقْدِ الْوَصِيَّةِ
u'عَقْدٌ وَقْفٌ':Added, #1: 1	عَقْدُ الْوَقْفِ
u'عَقْدٌ وَقْفٌ':Added, #1: 1	عَقْدِ وَقْفِهِ
u'عَقَدَ وَكِيلٌ':Subject, #5: 5	عَقْدِ الْوَقْفِ
u'عَقْدٌ وَكِيلٌ':Added, #1: 1	عَقَدَ الْوَكِيلُ
u'عَقْدٌ وَكِيلٌ':Added, #1: 1	عَقْدُ الْوَكِيلِ
u'عَقْدٌ وَكِيلٌ':Added, #1: 1	عَقْدِ وَكِيلِ
u'عَقْدٌ وَكِيلٌ':Added, #2: 2	عَقْدُ وَكِيلِهِ
u'عَقْدٌ وَلاَءٌ':Added, #8: 8	عَقْدِ الْوَكِيلِ
u'عَقْدٌ وَلاَءٌ':Added, #1: 1	عَقْدُ وَلاَءٍ
u'عَقْدٌ وَلاَءٌ':Added, #3: 3	عَقْدُ الْوَلَاءِ
u'عَقْدٌ وَلاَءٌ':Added, #7: 7	عَقْدَ الْوَلَاءِ
u'عَقْدٌ وِلاَيَةٌ':Added, #8: 8	عَقْدِ الْوَلَاءِ
u'عَقْدٌ وِلاَيَةٌ':Added, #1: 1	عَقْدُ وِلَايَةٍ
u'عَقَدَ وَلِيٌّ':Subject, #4: 4	عَقْدِ الْوِلَايَةِ
u'عَقَدَ وَلِيٌّ':Subject, #1: 1	عَقَدَ وَلِيُّهُ
u'عَقْدٌ وَلِيٌّ':Added, #2: 2	عَقَدَ الْوَلِيُّ
u'عَقْدٌ وَلِيٌّ':Added, #1: 1	عَقْدَ الْوَلِيِّ
u'عَقَدَ يَمِينٌ':Predicate, #3: 3	عَقْدُ الْوَلِيِّ
u'عَقْدٌ يَمِينٌ':Added, #21: 21	عَقَدَ الْيَمِينَ
u'عَقْدٌ يَمِينٌ':Added, #1: 1	عَقْدُ يَمِينٍ
u'عَقْدٌ يَمِينٌ':Added, #2: 2	عَقْدُ الْيَمِينِ
u'عَقْدٌ يَمِينٌ':Added, #6: 6	عَقْدَ الْيَمِينِ
u'عَقْدٌ يَوْمٌ':Added, #7: 7	عَقْدِ الْيَمِينِ
u'عقر أُمٌّ':Added, #1: 1	عَقْدِ الْيَوْمِ
u'عُقْرٌ أُمٌّ':Added, #1: 1	عُقْرِ أُمِّهِ
u'عقر أمَةٌ':Added, #1: 1	عُقْرِ أُمِّهِ
u'عُقْرٌ أمَةٌ':Added, #1: 1	عُقْرَ أَمَتِهِ
u'عقر جَارِي':Added, #1: 1	عُقْرَ أَمَتِهِ
u'عُقْرٌ جَارِي':Added, #1: 1	عُقْرَ الْجَارِيَةِ
u'عقر جَارِي':Added, #1: 1	عُقْرَ الْجَارِيَةِ
u'عُقْرٌ جَارِي':Added, #1: 1	عُقْرُ جَارِيَةِ
u'عقر جَارِي':Added, #1: 1	عُقْرُ جَارِيَةِ
u'عُقْرٌ جَارِي':Added, #2: 2	عُقْرِ الْجَارِيَةِ
u'عقر جَارِيَةٌ':Added, #2: 2	عُقْرِ الْجَارِيَةِ
u'عُقْرٌ جَارِيَةٌ':Added, #1: 1	عُقْرَ الْجَارِيَةِ
u'عقر جَارِيَةٌ':Added, #1: 1	عُقْرَ الْجَارِيَةِ
u'عُقْرٌ جَارِيَةٌ':Added, #1: 1	عُقْرُ جَارِيَةِ
u'عقر جَارِيَةٌ':Added, #1: 1	عُقْرُ جَارِيَةِ
u'عُقْرٌ جَارِيَةٌ':Added, #2: 2	عُقْرِ الْجَارِيَةِ
u'عَقَرَ حَنْظَلٌ':Subject, #2: 2	عُقْرِ الْجَارِيَةِ
u'عَقَرَ خَارِجٌ':Predicate, #2: 2	عَقَرَ حَنْظَلَةُ
u'عَقَرَ دَابَّةٌ':Predicate, #2: 2	عَقَرَ خَارِجَ
u'عقر دَارٌ':Added, #3: 3	عَقَرَ الدَّابَّةَ
u'عقر دَارٌ':Added, #1: 1	عُقْرَ دَارِ
u'عُقْرٌ دَارٌ':Added, #1: 1	عُقْرُ دَارِ
u'عُقْرٌ دَارٌ':Added, #1: 1	عُقْرَ دَارِ
u'عَقَرَ دونٌ':Predicate, #1: 1	عُقْرُ دَارِ
u'عَقِرَ رَجُلٌ':Subject, #1: 1	عَقَرَ دُونَ
u'عقر زَوْجَةٌ':Added, #1: 1	عَقِرَ الرّجُلُ
u'عُقْرٌ زَوْجَةٌ':Added, #1: 1	عُقْرَ زَوْجَتِهِ
u'عَقَرَ سَرْجٌ':Subject, #1: 1	عُقْرَ زَوْجَتِهِ
u'عَقَّ رَسُولٌ':Subject, #1: 1	عَقَرَ السّرْجُ
u'عَقَرَ عند':Predicate, #4: 4	عَقَّ رَسُولُ
u'عَقَرَ فَرَسٌ':Predicate, #1: 1	عَقَرَ عِنْدَ
u'عَقَرَ كَلْبٌ':Subject, #1: 1	عَقَرَ فَرَسَ
u'عقر مَالٌ':Added, #1: 1	عَقَرَ الْكَلْبُ
u'عُقْرٌ مَالٌ':Added, #1: 1	عُقْرُ مَالِ
u'عقر مَمْلُوكٌ':Added, #1: 1	عُقْرُ مَالِ
u'عُقْرٌ مَمْلُوكٌ':Added, #1: 1	عُقْرَ الْمَمْلُوكَةِ
u'عَقَرَ نَاسٌ':Predicate, #1: 1	عُقْرَ الْمَمْلُوكَةِ
u'عَقَرَ نَاقَةٌ':Predicate, #1: 1	عَقَرَ النَّاسَ
u'عَقَرَ نَاقَة':Predicate, #1: 1	عَقَرَ النّاقَةَ
u'عَقَرَ نَاقَةٌ':Predicate, #1: 1	عَقَرَ النّاقَةَ
u'عَقَرَ نَاقَة':Predicate, #1: 1	عَقَرَ نَاقَةَ
u'عَقَصَ حَلَقٌ':Predicate, #1: 1	عَقَرَ نَاقَةَ
u'عَقَلَ اِبْنٌ':Predicate, #1: 1	عَقَصَ حَلَقَ
u'عَقْلٌ أحَدٌ':Added, #1: 1	عَقَلَ ابْنَ
u'عَقَلَ أَدْيانٌ':Predicate, #1: 1	عَقْلُ أَحَدٍ
u'عَقْلٌ أذْهَانٌ':Added, #2: 2	عَقَلَ الْأَدْيَانَ
u'عَقْلٌ أَذْهَانٌ':Added, #1: 1	عَقْلِ الْأَذْهَانِ
u'عَقَلَ إِسْلامٌ':Predicate, #1: 1	عَقْلِ الْأَذْهَانِ
u'عَقْلٌ أَصابِعُ':Added, #1: 1	عَقَلَ الْإِسْلَامَ
u'عَقْلٌ أُصْبُعٌ':Added, #1: 1	عَقْلُ أَصَابِعِهِ
u'عَقْلٌ إِصْبَعٌ':Added, #1: 1	عَقْلَ أُصْبُعِهِ
u'عَقْلٌ الْمَرْءُ':Added, #1: 1	عَقْلِ الإِصْبَعِ
u'عَقْلٌ الْمَرْأَةُ':Added, #2: 2	عَقْلُ الْمَرْءِ
u'عَقْلٌ الْمَرْأَةُ':Added, #3: 3	عَقْلَ الْمَرْأَةِ
u'عَقَلَ أمَانٌ':Predicate, #4: 4	عَقْلُ الْمَرْأَةِ
u'عَقْلٌ اِمْرَأَةٌ':Added, #1: 1	عَقَلَ الْأَمَانَ
u'عَقْلٌ أَنْفٌ':Added, #1: 1	عَقْلَ امْرَأَةٍ
u'عَقْلٌ أهْلٌ':Added, #1: 1	عَقْلَ الأَنْفِ
u'عَقِلَ بِشْرٌ':Predicate, #2: 2	عَقْلَ أَهْلِ
u'عَقَلَ بَطْنٌ':Predicate, #1: 1	أَعْقَلَ بِشْرَ
u'عَقَلَ بَعيرٌ':Predicate, #2: 2	عَقَلَ الْبَطْنَ
u'عَقَلَ بَيْتٌ':Subject, #1: 1	عَقَلَ الْبَعِيرَ
u'عَقَلَ جِنَايَةٌ':Predicate, #2: 2	عَقَلَ بَيْتُ
u'عَقْلٌ جِنَايَةٌ':Added, #1: 1	عَقَلَ جِنَايَةَ
u'عَقْلٌ جِنَايَةٌ':Added, #1: 1	عَقْلَ الْجِنَايَةِ
u'عَقْلٌ جِنَايَةٌ':Added, #1: 1	عَقْلِ الْجِنَايَةِ
u'عَقْلٌ جِنَايَةٌ':Added, #1: 1	عَقْلُ جِنَايَةِ
u'عَقْلٌ جِنَايَةٌ':Added, #1: 1	عَقْلَ جِنَايَتِهِ
u'عَقْلٌ جِنَايَةٌ':Added, #2: 2	عَقْلَ جِنَايَةِ
u'عَقْلٌ جِنَايَةٌ':Added, #2: 2	عَقْلِ جِنَايَتِهِ
u'عَقْلٌ جَنِينٌ':Added, #7: 7	عَقْلُ جِنَايَتِهِ
u'عَقْلٌ حُرٌّ':Added, #1: 1	عَقْلِ الْجَنِينِ
u'عَقْلٌ خُبْزٌ':Added, #1: 1	عَقْلِ الْحُرِّ
u'عَقْلٌ رَاهِنٌ':Added, #1: 1	عَقْلُ الْخُبْزِ
u'عَقْلٌ رَاوِي':Added, #1: 1	عَقْلُ الرَّاهِنِ
u'عَقْلٌ رَجُلٌ':Added, #1: 1	عَقْلُ رَاوِيهِ
u'عَقْلٌ رَجُلٌ':Added, #1: 1	عَقْلُ الرَّجُلِ
u'عَقَلَ رَسُولٌ':Predicate, #4: 4	عَقْلِ الرَّجُلِ
u'عَقْلٌ سَيِّدٌ':Added, #1: 1	عَقَلَ رَسُولَ
u'عَقْلٌ شِبْهٌ':Added, #2: 2	عَقْلِ السَّيِّدِ
u'عَقْلٌ شَوَارِدُ':Added, #2: 2	عَقْلُ شِبْهِ
u'عَقْلٌ صَاحِبٌ':Added, #1: 1	عَقْلِ الشَّوَارِدِ
u'عَقَلَ صَبِيٌّ':Subject, #2: 2	عَقْلِ صَاحِبِهِ
u'عَقَلَ صَلاَةٌ':Predicate, #2: 2	عَقَلَ الصَّبِيُّ
u'عَقْلٌ طَالِبٌ':Added, #1: 1	عَقَلَ الصَّلَاةَ
u'عَقَلَ طَلاَقٌ':Predicate, #1: 1	عَقْلُ الطَّالِبِ
u'عَقْلٌ عَاقِدٌ':Added, #3: 3	عَقَلَ الطَّلَاقَ
u'عَقْلٌ عَاقِدٌ':Added, #1: 1	عَقْلَ الْعَاقِدَيْنِ
u'عَقْلٌ عَاقِلٌ':Added, #2: 2	عَقْلُ الْعَاقِدَيْنِ
u'عَقْلٌ عَبْدٌ':Added, #1: 1	عَقْلِ عَاقِلٍ
u'عَقْلٌ عَبْدٌ':Added, #1: 1	عَقْلِ الْعَبْدِ
u'عَقَلَ عَبِيدٌ':Subject, #3: 3	عَقْلُ الْعَبْدِ
u'عَقَلَ عَقْدٌ':Predicate, #1: 1	عَقَلَ عَبِيدُهُ
u'عَقْلٌ عَمْدٌ':Added, #1: 1	عَقَلَ الْعَقْدَ
u'عَقْلٌ عَمْدٌ':Added, #2: 2	عَقْلُ الْعَمْدِ
u'عَقْلٌ غير':Added, #2: 2	عَقْلِ الْعَمْدِ
u'عَقْلٌ غَيْرٌ':Added, #2: 2	عَقْلَ غَيْرِهِ
u'عَقْلٌ فَقِيرٌ':Added, #2: 2	عَقْلَ غَيْرِهِ
u'عَقْلٌ فَهِيمٌ':Added, #1: 1	عَقْلِ الْفَقِيرِ
u'عَقَلَ قُرْبَةٌ':Predicate, #1: 1	عَقْلَ الْفَهِيمِ
u'عَقَلَ قَوْمٌ':Subject, #3: 3	عَقَلَ الْقُرْبَةَ
u'عَقَلَ قِيَاسٌ':Predicate, #1: 1	عَقَلَ قَوْمُ
u'عَقْلٌ كَافِرٌ':Added, #1: 1	عَقَلَ الْقِيَاسَ
u'عَقْلٌ كَبِيرٌ':Added, #3: 3	عَقْلُ الْكَافِرِ
u'عَقَلَ كَلاَمٌ':Predicate, #1: 1	عَقْلُ الْكَبِيرِ
u'عَقْلٌ مَالِكٌ':Added, #1: 1	عَقَلَ الْكَلَامَ
u'عَقْلٌ متبوع':Added, #1: 1	عَقْلَ الْمَالِكِ
u'عَقِلَ مَجّ':Predicate, #1: 1	عَقْلٍ مَتْبُوعٍ
u'عَقَلَ مَجْنُونٌ':Subject, #1: 1	عَقِلَ مَجَّةً
u'عَقَلَ مَجْنُونٌ':Subject, #1: 1	عَقَلَ الْمَجْنُونُ
u'عَقْلٌ مَجْنُونٌ':Added, #1: 1	عَقَلَ مَجْنُونٌ
u'عَقْلٌ مُرْسِلٌ':Added, #1: 1	عَقْلَ الْمَجْنُونِ
u'عَقْلٌ مُسْلِمٌ':Added, #1: 1	عَقْلِ مُرْسِلِهِ
u'عَقْلٌ مَصْرُوعٌ':Added, #1: 1	عَقْلِ الْمُسْلِمِ
u'عَقْلٌ مَقَامٌ':Added, #1: 1	عَقْلِ الْمَصْرُوعِ
u'عَقْلٌ مَقْتُولٌ':Added, #1: 1	عَقْلِ مَقَامِهِ
u'عَقْلٌ مُنْكِرٌ':Added, #1: 1	عَقْلُ الْمَقْتُولَةِ
u'عَقْلٌ مُودِعٌ':Added, #1: 1	عَقْلِ الْمُنْكِرِ
u'عَقْلٌ مُوَفَّقٌ':Added, #1: 1	عَقْلُ الْمُودِعِ
u'عَقْلٌ مُؤْمِنٌ':Added, #1: 1	عَقْلُ الْمُوَفَّقِ
u'عَقْلٌ نَائِمٌ':Added, #2: 2	عَقْلِ الْمُؤْمِنِ
u'عَقْلٌ وَكِيلٌ':Added, #1: 1	عَقْلُ النَّائِمِ
u'عَقْلٌ وَلِيدٌ':Added, #1: 1	عَقْلِ الْوَكِيلِ
u'عُقُودٌ أبدانٌ':Added, #1: 1	عَقْلَ الْوَلِيدِ
u'عُقُودٌ اِبْنٌ':Added, #1: 1	عُقُودُ الْأَبْدَانِ
u'عُقُودٌ إجَارَةٌ':Added, #1: 1	عُقُودِ ابْنِ
u'عُقُودٌ أُصولٌ':Added, #1: 1	عُقُودِ الْإِجَارَةِ
u'عُقُودٌ اِكْتِسَابٌ':Added, #2: 2	عُقُودُ الْأُصُولِ
u'عُقُودٌ أمَانٌ':Added, #4: 4	عُقُودِ اكْتِسَابِ
u'عُقُودٌ أمَانٌ':Added, #1: 1	عُقُودِ الْأَمَانَاتِ
u'عُقُودٌ أمَانَةٌ':Added, #2: 2	عُقُودُ الْأَمَانَاتِ
u'عُقُودٌ أمَانَةٌ':Added, #1: 1	عُقُودِ الْأَمَانَاتِ
u'عُقُودٌ أَمْرٌ':Added, #2: 2	عُقُودُ الْأَمَانَاتِ
u'عُقُودٌ أَمْوَالٌ':Added, #1: 1	عُقُودُ الْأَمْرِ
u'عُقُودٌ إِيجَارٌ':Added, #1: 1	عُقُودِ الْأَمْوَالِ
u'عُقُودٌ بِرٌّ':Added, #1: 1	عُقُودِ الْإِيجَارَاتِ
u'عُقُودٌ بِنَاءٌ':Added, #1: 1	عُقُودُ بِرٍّ
u'عُقُودٌ بَيَانٌ':Added, #1: 1	عُقُودِ الْبِنَاءِ
u'عُقُودٌ تَبَرُّعٌ':Added, #1: 1	عُقُودُ الْبَيَانِ
u'عُقُودٌ تَبَرُّعٌ':Added, #1: 1	عُقُودَ التَّبَرُّعَاتِ
u'عُقُودٌ تَبَرُّعٌ':Added, #1: 1	عُقُودُ التَّبَرُّعَاتِ
u'عُقُودٌ تَبَرُّعٌ':Added, #1: 1	عُقُودِ التَّبَرُّعَاتِ
u'عُقُودٌ تِجَارَةٌ':Added, #2: 2	عُقُودِ التَّبَرُّعِ
u'عُقُودٌ تِجَارَةٌ':Added, #3: 3	عُقُودِ التِّجَارَةِ
u'عُقُودٌ تَصَرُّفٌ':Added, #5: 5	عُقُودِ التِّجَارَاتِ
u'عُقُودٌ تَصَرُّفٌ':Added, #1: 1	عُقُودِ التَّصَرُّفِ
u'عُقُودٌ تَمْلِيكٌ':Added, #1: 1	عُقُودِ التَّصَرُّفَاتِ
u'عُقُودٌ تَمْلِيكٌ':Added, #3: 3	عُقُودِ التَّمْلِيكَاتِ
u'عُقُودٌ تَوَثُّقٌ':Added, #6: 6	عُقُودُ التَّمْلِيكَاتِ
u'عُقُودٌ تَوَصُّلٌ':Added, #1: 1	عُقُودِ التَّوَثُّقِ
u'عُقُودٌ ثَلاثَةٌ':Added, #1: 1	عُقُودَ تَوَصُّلِهِ
u'عُقُودٌ جِيدٌ':Added, #1: 1	عُقُودٍ ثَلَاثَةٍ
u'عُقُودٌ حُرِّيَّةٌ':Added, #1: 1	عُقُودَ الْجِيدِ
u'عُقُودٌ خُلَفَاءُ':Added, #1: 1	عُقُودِ الْحُرِّيَّةِ
u'عُقُودٌ ضَمَانٌ':Added, #1: 1	عُقُودُ الْخُلَفَاءِ
u'عُقُودٌ ضَمَانٌ':Added, #2: 2	عُقُودُ الضَّمَانِ
u'عُقُودٌ غَادِرٌ':Added, #2: 2	عُقُودُ ضَمَانٍ
u'عُقُودٌ غير':Added, #1: 1	عُقُودُ الْغَادِرِ
u'عُقُودٌ غَيْرٌ':Added, #1: 1	عُقُودُ غَيْرِ
u'عُقُودٌ فُضُولِيٌّ':Added, #1: 1	عُقُودُ غَيْرِ
u'عُقُودٌ قراض':Added, #1: 1	عُقُودِ الْفُضُولِيِّ
u'عُقُودٌ كُفَّارٌ':Added, #1: 1	عُقُودِ الْقِرَاضِ
u'عُقُودٌ مُبَادَلَةٌ':Added, #1: 1	عُقُودَ الْكُفَّارِ
u'عُقُودٌ مُخْتَصَرٌ':Added, #2: 2	عُقُودِ الْمُبَادَلَاتِ
u'عُقُودٌ مُشَارَكَةٌ':Added, #2: 2	عُقُودِ الْمُخْتَصَرِ
u'عُقُودٌ مُعَامَلَةٌ':Added, #4: 4	عُقُودُ الْمُشَارَكَاتِ
u'عُقُودٌ مُعَامَلَةٌ':Added, #1: 1	عُقُودِ الْمُعَامَلَةِ
u'عُقُودٌ مِلْكٌ':Added, #5: 5	عُقُودِ الْمُعَامَلَاتِ
u'عُقُودٌ مِلْكٌ':Added, #1: 1	عُقُودَ الْمِلْكِ
u'عُقُودٌ مَناكِح':Added, #1: 1	عُقُودِ الْمِلْكِ
u'عُقُودٌ نكاح':Added, #1: 1	عُقُودُ الْمَنَاكِحِ
u'عُقُودٌ نِكَاحٌ':Added, #1: 1	عُقُودَ النِّكَاحِ
u'عُقُودٌ وَكِيلٌ':Added, #1: 1	عُقُودَ النِّكَاحِ
u'عُقُودٌ وِلاَيَةٌ':Added, #1: 1	عُقُودِ الْوَكِيلِ
u'عُقُودٌ يهود':Added, #1: 1	عُقُودُ الْوِلَايَاتِ
u'عُقُودٌ يَهُودٌ':Added, #2: 2	عُقُودِ الْيَهُودِ
u'عُقُوقٌ أُمَّهَاتٌ':Added, #2: 2	عُقُودِ الْيَهُودِ
u'عُقُوقٌ أُمَّهَاتٌ':Added, #1: 1	عُقُوقَ الأُمَّهَاتِ
u'عُقُوقٌ أُمَّهَاتٌ':Added, #1: 1	عُقُوقَ الْأُمَّهَاتِ
u'عُقُوقٌ وَالِدٌ':Added, #1: 1	عُقُوقِ الْأُمَّهَاتِ
u'عُقُوقٌ وَالِدٌ':Added, #10: 10	عُقُوقُ الْوَالِدَيْنِ
u'عُقُوقٌ وَالِدٌ':Added, #1: 1	عُقُوقِ الْوَالِدَاتِ
u'عُقُوقٌ وَالِدٌ':Added, #1: 1	عُقُوقِ الْوَالِدَيْنِ
u'عُقُولٌ أهْلٌ':Added, #2: 2	عُقُوقَ الْوَالِدَيْنِ
u'عُقُولٌ حكماء':Added, #1: 1	عُقُولِ أَهْلِ
u'عُقُولٌ حكماء':Added, #1: 1	عُقُولَ الْحُكَمَاءِ
u'عُقُولٌ رَبَّةٌ':Added, #1: 1	عُقُولُ الْحُكَمَاءِ
u'عُقُولٌ رِجَالٌ':Added, #1: 1	عُقُولَ رَبّاتِ
u'عُقُولٌ رِجَالٌ':Added, #1: 1	عُقُولَ الرِّجَالِ
u'عُقُولٌ رِجَالٌ':Added, #1: 1	عُقُولُ الرِّجَالِ
u'عُقُولٌ فقهاء':Added, #2: 2	عُقُولِ الرِّجَالِ
u'عَكَسَ أحَدٌ':Subject, #1: 1	عُقُولُ الْفُقَهَاءِ
u'عَكْسٌ اِعْتِبارٌ':Added, #1: 1	عَكَسَ أَحَدٌ
u'عَكْسٌ أَمينٌ':Added, #2: 2	عَكْسِ اعْتِبَارِ
u'عَكْسٌ أَوَّلُ':Added, #2: 2	عَكْسُ الْأَمِينِ
u'عَكْسٌ أَوَّلُ':Added, #1: 1	عَكْسَ الْأَوَّلِ
u'عَكْسٌ أَوَّلُ':Added, #1: 1	عَكْسِ الْأَوَّلِ
u'عَكْسٌ بَائِعٌ':Added, #4: 4	عَكْسُ الْأَوَّلِ
u'عَكْسٌ بِرٌّ':Added, #1: 1	عَكْسَ الْبَائِعِ
u'عَكْسٌ بَيَانٌ':Added, #1: 1	عَكْسُ الْبِرِّ
u'عَكْسٌ بَيْعٌ':Added, #1: 1	عَكْسِ بَيَانِ
u'عَكَسَ تَرْتِيبٌ':Predicate, #1: 1	عَكْسَ الْبَيْعِ
u'عَكْسٌ تَرْتِيبٌ':Added, #1: 1	عَكَسَ التَّرْتِيبَ
u'عَكْسٌ تَرْتِيبٌ':Added, #1: 1	عَكْسِ التَّرْتِيبِ
u'عَكْسٌ تَرْتِيبٌ':Added, #2: 2	عَكْسُ التَّرْتِيبِ
u'عَكْسٌ تَشْبِيه':Added, #2: 2	عَكْسِ تَرْتِيبِ
u'عَكْسٌ تَشْبِيه':Added, #1: 1	عَكْسُ التَّشْبِيهِ
u'عَكْسٌ تَصْوِيرٌ':Added, #1: 1	عَكْسِ التَّشْبِيهِ
u'عَكْسٌ تَعَرُّضٌ':Added, #2: 2	عَكْسَ التَّصْوِيرِ
u'عَكْسٌ تَعْرِيفٌ':Added, #1: 1	عَكْسُ التَّعَرُّضِ
u'عَكْسٌ تَعْرِيفٌ':Added, #1: 1	عَكْسُ التَّعْرِيفِ
u'عَكَسَ تَعْلِيقٌ':Predicate, #2: 2	عَكْسِ التَّعْرِيفِ
u'عَكْسٌ تَفْوِيضٌ':Added, #1: 1	عَكَسَ التَّعْلِيقَ
u'عَكْسٌ تَقْديمٌ':Added, #1: 1	عَكْسُ التَّفْوِيضِ
u'عَكْسٌ تَلَفٌ':Added, #1: 1	عَكْسَ تَقْدِيمِ
u'عَكَسَ ثَانِي':Predicate, #1: 1	عَكْسُ تَلَفِ
u'عَكَسَ ثَانِيَةٌ':Predicate, #1: 1	عَكَسَ الثَّانِيَةَ
u'عَكَسَ جَازٌ':Predicate, #1: 1	عَكَسَ الثَّانِيَةَ
u'عَكْسٌ جَمَالٌ':Added, #3: 3	عَكَسَ جَازَ
u'عَكْسٌ جَمِيع':Added, #1: 1	عَكْسُ الْجَمَالِ
u'عَكْسٌ حالٌ':Added, #3: 3	عَكْسُ الْجَمِيعِ
u'عَكْسٌ حَشِيشٌ':Added, #1: 1	عَكْسِ حَالِهِ
u'عَكْسٌ حَصْرٌ':Added, #1: 1	عَكْسَ الْحَشِيشَةِ
u'عَكَسَ حَصَلٌ':Predicate, #1: 1	عَكْسَ الْحَصْرِ
u'عَكْسٌ حَقٌّ':Added, #1: 1	عَكَسَ حَصَلَ
u'عَكْسٌ حِكَايَةٌ':Added, #1: 1	عَكْسُ الْحَقِّ
u'عَكَسَ حُكْمٌ':Predicate, #1: 1	عَكْسُ حِكَايَةِ
u'عَكْسٌ حُكْمٌ':Added, #1: 1	عَكَسَ الْحُكْمَ
u'عَكْسٌ حُكْمٌ':Added, #2: 2	عَكْسُ الْحُكْمِ
u'عَكْسٌ خِلاَفٌ':Added, #2: 2	عَكْسُ حُكْمِهِ
u'عَكْسٌ رابع':Added, #1: 1	عَكْسُ الْخِلَافِ
u'عَكْسٌ رَابِعٌ':Added, #1: 1	عَكْسُ الرَّابِعَةِ
u'عَكْسٌ رِوايَةٌ':Added, #1: 1	عَكْسُ الرَّابِعَةِ
u'عَكْسٌ رِوايَةٌ':Added, #1: 1	عَكْسَ الرِّوَايَةِ
u'عَكْسٌ زَرْعٌ':Added, #1: 1	عَكْسُ الرِّوَايَةِ
u'عَكْسٌ سَاتِرٌ':Added, #1: 1	عَكْسِ الزَّرْعِ
u'عَكْسٌ سَائِرٌ':Added, #1: 1	عَكْسُ سَاتِرِ
u'عَكْسٌ سَائِرٌ':Added, #1: 1	عَكْسَ السَّائِرِ
u'عَكْسٌ سَفِين':Added, #1: 1	عَكْسُ سَائِرِ
u'عَكْسٌ شافِع':Added, #1: 1	عَكْسُ السَّفِينَتَيْنِ
u'عَكْسٌ شافِعِيّ':Added, #1: 1	عَكْسِ الشَّافِعِيَّةِ
u'عَكْسٌ شَرْطٌ':Added, #1: 1	عَكْسِ الشَّافِعِيَّةِ
u'عَكْسٌ شَرِيعَةٌ':Added, #4: 4	عَكْسُ الشَّرْطِ
u'عَكْسٌ شَهَادَةٌ':Added, #1: 1	عَكْسُ الشَّرِيعَةِ
u'عَكَسَ صَاحِبٌ':Subject, #1: 1	عَكْسَ شَهَادَةِ
u'عَكْسٌ صَاحِبٌ':Added, #1: 1	عَكَسَ صَاحِبُ
u'عَكْسٌ صِفَةٌ':Added, #1: 1	عَكْسَ صَاحِبِ
u'عَكْسٌ طَرِيقَةٌ':Added, #1: 1	عَكْسُ الصِّفَةِ
u'عَكْسٌ طَلاَقٌ':Added, #1: 1	عَكْسُ طَرِيقَةِ
u'عَكْسٌ ظاهِرٌ':Added, #1: 1	عَكْسُ الطَّلَاقِ
u'عَكْسٌ عَدَالَةٌ':Added, #1: 1	عَكْسُ الظَّاهِرِ
u'عَكْسٌ عِدَّةٌ':Added, #1: 1	عَكْسُ الْعَدَالَةِ
u'عَكْسٌ عرف':Added, #1: 1	عَكْسُ الْعِدَّةِ
u'عَكْسٌ عُرْفٌ':Added, #1: 1	عَكْسُ عُرْفِ
u'عَكْسٌ عِلَّةٌ':Added, #1: 1	عَكْسُ عُرْفِ
u'عَكْسٌ عُهْدَةٌ':Added, #1: 1	عَكْسُ عِلَّتِهِ
u'عَكَسَ فَارِقٌ':Subject, #1: 1	عَكْسُ عُهْدَةِ
u'عَكْسٌ فَرِيضَةٌ':Added, #1: 1	عَكَسَ الْفَارِقُ
u'عَكْسٌ فِعْلٌ':Added, #1: 1	عَكْسِ الْفَرِيضَةِ
u'عَكْسٌ فلان':Added, #1: 1	عَكْسُ فِعْلِ
u'عَكْسٌ فَوَائِدُ':Added, #1: 1	عَكْسِ الشَّافِعِيَّةِ
u'عَكْسٌ قَاصِرٌ':Added, #1: 1	عَكْسُ الْفَوَائِدِ
u'عَكْسٌ قَضَاءٌ':Added, #1: 1	عَكْسَ الْقَاصِرَةِ
u'عَكْسٌ قَضِيَّةٌ':Added, #1: 1	عَكْسَ الْقَضَاءِ
u'عَكْسٌ قول':Added, #1: 1	عَكْسُ الْقَضِيَّةِ
u'عَكْسٌ قول':Added, #1: 1	عَكْسَ قَوْلِ
u'عَكْسٌ قَوْلٌ':Added, #1: 1	عَكْسُ قَوْلِ
u'عَكْسٌ قَوْلٌ':Added, #1: 1	عَكْسَ قَوْلِ
u'عَكْسٌ قِيَاسٌ':Added, #1: 1	عَكْسُ قَوْلِ
u'عَكْسٌ كُسُوفٌ':Added, #1: 1	عَكْسُ الْقِيَاسِ
u'عَكْسٌ كَلاَمٌ':Added, #1: 1	عَكْسُ الْكُسُوفِ
u'عَكْسٌ كَلاَمٌ':Added, #1: 1	عَكْسُ كَلَامِ
u'عَكْسٌ كَلاَمٌ':Added, #1: 1	عَكْسُ كَلَامِهِ
u'عَكْسٌ كُلِّيٌّ':Added, #2: 2	عَكْسِ كَلَامِ
u'عَكْسٌ كُلِّيٌّ':Added, #1: 1	عَكْسِ الْكُلِّيِّ
u'عَكْسٌ كُلِّيَّةٌ':Added, #1: 1	عَكْسُ الْكُلِّيَّةِ
u'عَكْسٌ مَاءٌ':Added, #1: 1	عَكْسُ الْكُلِّيَّةِ
u'عَكْسٌ مُتَوَاتِرٌ':Added, #1: 1	عَكْسُ الْمَاءِ
u'عَكْسٌ مَجَازٌ':Added, #1: 1	عَكْسُ الْمُتَوَاتِرِ
u'عَكْسٌ مَذْهَبٌ':Added, #1: 1	عَكْسُ الْمَجَازِ
u'عَكْسٌ مراد':Added, #1: 1	عَكْسُ الْمَذْهَبِ
u'عَكْسٌ مراد':Added, #1: 1	عَكْسَ الْمُرَادِ
u'عَكْسٌ مُرَادٌ':Added, #1: 1	عَكْسُ الْمُرَادِ
u'عَكْسٌ مُرَادٌ':Added, #1: 1	عَكْسَ الْمُرَادِ
u'عَكْسٌ مراد':Added, #1: 1	عَكْسُ الْمُرَادِ
u'عَكْسٌ مُرَادٌ':Added, #1: 1	عَكْسُ مُرَادِ
u'عَكْسٌ مُرْتَزِقٌ':Added, #1: 1	عَكْسُ مُرَادِ
u'عَكَسَ مَسْأَلَةٌ':Predicate, #1: 1	عَكْسَ الْمُرْتَزِقَةِ
u'عَكَسَ مَسْأَلَةٌ':Predicate, #1: 1	عَكَسَ الْمَسْأَلَةَ
u'عَكْسٌ مَسْأَلَةٌ':Added, #1: 1	عَكَسَ مَسْأَلَةَ
u'عَكْسٌ مَسْأَلَةٌ':Added, #1: 1	عَكْسُ مَسْأَلَةِ
u'عَكْسٌ مَسْجِدٌ':Added, #4: 4	عَكْسُ الْمَسْأَلَةِ
u'عَكْسٌ مَشْرُوعٌ':Added, #1: 1	عَكْسُ مَسْجِدٍ
u'عَكْسٌ مُصَحَّحٌ':Added, #1: 1	عَكْسُ الْمَشْرُوعِ
u'عَكْسٌ مَصْلَحَةٌ':Added, #1: 1	عَكْسُ الْمُصَحَّحِ
u'عَكَسَ مُصَنِّفٌ':Subject, #1: 1	عَكْسُ مَصْلَحَةِ
u'عَكْسٌ مَعْدُودٌ':Added, #1: 1	عَكَسَ الْمُصَنِّفُ
u'عَكْسٌ مَعْقُولٌ':Added, #1: 1	عَكْسَ الْمَعْدُودِ
u'عَكَسَ مَعِيٌّ':Predicate, #3: 3	عَكْسُ الْمَعْقُولِ
u'عَكَسَ مَعِيَّةٌ':Predicate, #1: 1	عَكَسَ الْمَعِيَّةَ
u'عَكْسٌ مَقَالَةٌ':Added, #1: 1	عَكَسَ الْمَعِيَّةَ
u'عَكْسٌ مَقَالَةٌ':Added, #1: 1	عَكْسَ مَقَالَةِ
u'عَكْسٌ مُقْرِضٌ':Added, #1: 1	عَكْسُ مَقَالَةِ
u'عَكْسٌ مَنْعٌ':Added, #1: 1	عَكْسُ الْمُقْرِضِ
u'عَكْسٌ مَنْفَذٌ':Added, #1: 1	عَكْسُ الْمَنْعِ
u'عَكْسٌ مُوجَبٌ':Added, #1: 1	عَكْسَ مَنْفَذِ
u'عَكْسٌ مَوْضُوعٌ':Added, #2: 2	عَكْسَ الْمُوجَبَةِ
u'عَكَسَ نَتِيجَةٌ':Predicate, #1: 1	عَكْسُ الْمَوْضُوعِ
u'عَكْسٌ نَتِيجَةٌ':Added, #1: 1	عَكَسَ النَّتِيجَةَ
u'عَكْسٌ نَتِيجَةٌ':Added, #1: 1	عَكْسُ النَّتِيجَةِ
u'عَكْسٌ نَفْسِيٌّ':Added, #2: 2	عَكْسِ النَّتِيجَةِ
u'عَكْسٌ نَفَقَةٌ':Added, #1: 1	عَكْسِ النَّفْسِيِّ
u'عَكْسٌ هاء':Added, #2: 2	عَكْسُ النَّفَقَةِ
u'عَكْسٌ هَجِينٌ':Added, #1: 1	عَكْسِ الْهَاءِ
u'عَكْسٌ وَصِيٌّ':Added, #1: 1	عَكْسُ الْهَجِينِ
u'عَكْسٌ وَصِيَّةٌ':Added, #1: 1	عَكْسِ الْوَصِيَّةِ
u'عَكْسٌ وَضْعٌ':Added, #1: 1	عَكْسِ الْوَصِيَّةِ
u'عَكْسٌ وَضْعٌ':Added, #1: 1	عَكْسِ وَضْعِ
u'عَكْسٌ يَمِينٌ':Added, #1: 1	عَكْسُ وَضْعِهِ
u'عَكَفَ قلب':Subject, #1: 1	عَكْسِ الْيَمِينِ
u'عَكَفَ قَلْبٌ':Subject, #1: 1	عَكَفَ قَلْبُهُ
u'عَكَفَ قَلْب':Subject, #1: 1	عَكَفَ قَلْبُهُ
u'عَلَا أَحَقُّ':Predicate, #1: 1	عَكَفَ قَلْبُهُ
u'عَلَا أرْضٌ':Predicate, #1: 1	عَلَا أَحَقَّ
u'عَلَا أشْبَهُ':Predicate, #1: 1	عَلَا الْأَرْضَ
u'عَلَا بُنْيانٌ':Subject, #1: 1	عَلَا أَشْبَهَ
u'عَلَا بَيْداءُ':Predicate, #1: 1	عَلَا بُنْيَانُهُ
u'عَلَا تُرَابٌ':Predicate, #4: 4	عَلَا الْبَيْدَاءَ
u'عَلَا تَهْويلٌ':Subject, #1: 1	عَلَا التُّرَابَ
u'عَلَا ثَنِيَّةٌ':Predicate, #1: 1	عَلَا التّهْوِيلُ
u'عَلَا حَنْظَلٌ':Predicate, #1: 1	عَلَا ثَنِيّةَ
u'عَلَا فَيْفَاءُ':Predicate, #1: 1	عَلَا حَنْظَلَةَ
u'عَلَا قَصِيلٌ':Subject, #2: 2	عَلَا الْفَيْفَاءَ
u'عَلَا قيام':Subject, #1: 1	عَلَا الْقَصِيلُ
u'عَلَا قِيَامٌ':Subject, #1: 1	عَلَا الْقِيَامُ
u'عَلَا كَرَاهَةٌ':Predicate, #1: 1	عَلَا الْقِيَامُ
u'عَلَا مَاءٌ':Predicate, #1: 1	عَلَا كَرَاهَةَ
u'عَلَا مَاءٌ':Subject, #1: 1	عَلَا مَاءَ
u'عَلَا مَكَانٌ':Subject, #2: 2	عَلَا مَاءُ
u'عَلَا مَوْضِعٌ':Subject, #1: 1	عَلَا مَكَانُهُ
u'عَلِبَ لَحْمٌ':Subject, #2: 2	عَلَا مَوْضِعُ
u'عَلَفَ بَهائِمُ':Predicate, #1: 1	عَلِبَ اللّحْمُ
u'عَلَفَ دَابَّةٌ':Predicate, #1: 1	عَلَفَ الْبَهَائِمَ
u'عَلَفَ دُودٌ':Predicate, #1: 1	عَلَفَ الدَّابَّةَ
u'عَلَفَ شَاةٌ':Predicate, #1: 1	عَلَفَ دُودَ
u'عَلَفَ فِرَاخٌ':Predicate, #1: 1	عَلَفَ الشَّاةَ
u'عَلَّقَ أَبٌ':Subject, #1: 1	عَلَفَ الْفِرَاخَ
u'عَلَّقَ إبَاحَةٌ':Predicate, #1: 1	عَلَّقَ الْأَبُ
u'عَلَّقَ إبَاحَةٌ':Predicate, #1: 1	عَلَّقَ إبَاحَةَ
u'عَلَّقَ إِبَانَةٌ':Predicate, #1: 1	عَلَّقَ الْإِبَاحَةَ
u'عَلَّقَ اِبْتِداءٌ':Predicate, #1: 1	عَلَّقَ إبَانَةَ
u'عَلَّقَ إِثْبَاتٌ':Predicate, #1: 1	عَلَّقَ ابْتِدَاءَ
u'عَلَّقَ أحَدٌ':Subject, #1: 1	عَلَّقَ إثْبَاتَ
u'عَلَّقَ اِسْتِحْقَاقٌ':Predicate, #2: 2	عَلَّقَ أَحَدُ
u'عَلَّقَ إِعْتاقٌ':Predicate, #2: 2	عَلَّقَ اسْتِحْقَاقَ
u'عَلَّقَ إقْرَارٌ':Predicate, #3: 3	عَلَّقَ الْإِعْتَاقَ
u'عَلَّقَ بَائِعٌ':Subject, #2: 2	عَلَّقَ الْإِقْرَارَ
u'عِلْقٌ بَائِعٌ':Added, #1: 1	عَلَّقَ الْبَائِعُ
u'عِلْقٌ بَائِعٌ':Added, #1: 1	عِلْقَ الْبَائِعِ
u'عَلَّقَ بَائِنٌ':Predicate, #1: 1	عِلْقُ الْبَائِعِ
u'عَلَّقَ بُخَارِيٌّ':Subject, #2: 2	عَلَّقَ الْبَائِنَ
u'عَلَّقَ بَراءةٌ':Predicate, #2: 2	عَلَّقَ الْبُخَارِيُّ
u'عَلَّقَ بَراءةٌ':Predicate, #2: 2	عَلَّقَ بَرَاءَةَ
u'عَلَّقَ بَيْعٌ':Predicate, #3: 3	عَلَّقَ الْبَرَاءَةَ
u'عَلَّقَ تَأْمِينٌ':Predicate, #1: 1	عَلَّقَ الْبَيْعَ
u'عَلَّقَ تَحْرِيمٌ':Predicate, #1: 1	عَلَّقَ تَأْمِينَ
u'عَلَّقَ تَحْرِيمٌ':Predicate, #1: 1	عَلَّقَ التَّحْرِيمَ
u'عَلَّقَ تَدْبِيرٌ':Predicate, #2: 2	عَلَّقَ تَحْرِيمَ
u'عَلَّقَ تَسْلِيمٌ':Predicate, #5: 5	عَلَّقَ التَّدْبِيرَ
u'عَلَّقَ تَطْلِيقٌ':Predicate, #2: 2	عَلَّقَ التَّسْلِيمَ
u'عَلَّقَ تمام':Predicate, #5: 5	عَلَّقَ التَّطْلِيقَ
u'عَلَّقَ تَمامٌ':Predicate, #2: 2	عَلَّقَ تَمَامَ
u'عَلَّقَ تمام':Predicate, #2: 2	عَلَّقَ تَمَامَ
u'عَلَّقَ تَمامٌ':Predicate, #4: 4	عَلَّقَ التَّمَامَ
u'عَلَّقَ تَوْكِيلٌ':Predicate, #4: 4	عَلَّقَ التَّمَامَ
u'عَلَّقَ ثَلاثُ':Predicate, #1: 1	عَلَّقَ التَّوْكِيلَ
u'عَلَّقَ ثَلاثُ':Predicate, #1: 1	عَلَّقَ ثَلَاثَ
u'عَلَّقَ جَوَازٌ':Predicate, #5: 5	عَلَّقَ الثَّلَاثَ
u'عَلَّقَ حَجٌّ':Predicate, #1: 1	عَلَّقَ جَوَازَ
u'عَلَّقَ حُرٌّ':Predicate, #1: 1	عَلَّقَ الْحَجَّ
u'عَلِقَ حُرٌّ':Predicate, #1: 1	عَلَّقَ حُرَّ
u'عَلَّقَ حُرِّيَّةٌ':Predicate, #3: 3	عَلِقَ حُرَّ
u'عَلَّقَ حُرِّيَّةٌ':Predicate, #1: 1	عَلَّقَ الْحُرِّيَّةَ
u'عَلَّقَ حَظْر':Predicate, #2: 2	عَلَّقَ حُرِّيَّةَ
u'عَلَّقَ حُكْمٌ':Predicate, #1: 1	عَلَّقَ الْحَظْرَ
u'عَلِقَ حُكْمٌ':Subject, #7: 7	عَلَّقَ الْحُكْمَ
u'عَلَّقَ حِلٌّ':Predicate, #1: 1	عَلِقَ الْحُكْمُ
u'عَلَّقَ خَبَرٌ':Predicate, #2: 2	عَلَّقَ الْحِلَّ
u'عَلَّقَ خَبَر':Predicate, #1: 1	عَلَّقَ الْخَبَرَ
u'عَلَّقَ خراج':Predicate, #1: 1	عَلَّقَ الْخَبَرَ
u'عَلَّقَ خَرَاجٌ':Predicate, #1: 1	عَلَّقَ الْخَرَاجَ
u'عَلَّقَ خُرُوجٌ':Predicate, #1: 1	عَلَّقَ الْخَرَاجَ
u'عَلَّقَ دُخُولٌ':Predicate, #2: 2	عَلَّقَ الْخُرُوجَ
u'عَلَّقَ دفع':Predicate, #1: 1	عَلَّقَ دُخُولَ
u'عَلَّقَ دَفْعٌ':Predicate, #1: 1	عَلَّقَ الدَّفْعَ
u'عَلَّقَ دفع':Predicate, #1: 1	عَلَّقَ الدَّفْعَ
u'عَلَّقَ دَفْعٌ':Predicate, #1: 1	عَلَّقَ دَفْعَ
u'عَلَقٌ دَمٌ':Added, #1: 1	عَلَّقَ دَفْعَ
u'عَلَق دَمٌ':Added, #1: 1	عَلَقَ الدّمِ
u'عَلَّقَ ذَمٌّ':Predicate, #1: 1	عَلَقَ الدّمِ
u'عَلَّقَ رَجُلٌ':Subject, #1: 1	عَلَّقَ الذَّمَّ
u'عَلَّقَ رَجْمٌ':Predicate, #1: 1	عَلَّقَ رَجُلٌ
u'عَلَّقَ رُخْصَةٌ':Predicate, #1: 1	عَلَّقَ الرَّجْمَ
u'عَلَّقَ رَمْيٌ':Predicate, #1: 1	عَلَّقَ رُخْصَةَ
u'عَلَّقَ رُؤْيَةٌ':Predicate, #1: 1	عَلَّقَ الرَّمْيَ
u'عَلَّقَ زَوْجٌ':Subject, #1: 1	عَلَّقَ رُؤْيَةَ
u'عَلَّقَ زَوْجٌ':Subject, #1: 1	عَلَّقَ زَوْجُ
u'عَلَقٌ زَوْجِيٌّ':Added, #9: 9	عَلَّقَ الزَّوْجُ
u'عَلَق زَوْجِيٌّ':Added, #1: 1	عَلَقِ الزَّوْجِيَّةِ
u'عَلَّقَ سُلْطَانٌ':Subject, #1: 1	عَلَقِ الزَّوْجِيَّةِ
u'عَلَّقَ سَيِّدٌ':Subject, #1: 1	عَلَّقَ السُّلْطَانُ
u'عَلَّقَ شَاةٌ':Predicate, #2: 2	عَلَّقَ السَّيِّدُ
u'عَلَّقَ شَارِعٌ':Subject, #1: 1	عَلَّقَ الشَّاةَ
u'عَلَّقَ شافِعِيّ':Subject, #2: 2	عَلَّقَ الشَّارِعُ
u'عَلَّقَ شَخْصٌ':Subject, #4: 4	عَلَّقَ الشَّافِعِيُّ
u'عَلَّقَ شَرْطٌ':Predicate, #1: 1	عَلَّقَ شَخْصٌ
u'عَلَّقَ شِفَاءٌ':Predicate, #1: 1	عَلَّقَ الشَّرْطَ
u'عَلِقَ شَقَاءٌ':Subject, #1: 1	عَلَّقَ شِفَاءَ
u'عَلَقَ صَخْرٌ':Subject, #1: 1	عَلِقَ الشّقَاءُ
u'عَلَقَ صَخْرٌ':Subject, #1: 1	عَلَقَ الصّخْرُ
u'عَلَّقَ صدقة':Predicate, #2: 2	عَلَقَ صَخْرُ
u'عَلَّقَ صَدَقَةٌ':Predicate, #3: 3	عَلَّقَ الصَّدَقَةَ
u'عَلَّقَ ضَمَانٌ':Predicate, #3: 3	عَلَّقَ الصَّدَقَةَ
u'عَلَّقَ طَلاَقٌ':Predicate, #1: 1	عَلَّقَ الضَّمَانَ
u'عَلَّقَ طَلاَقٌ':Predicate, #25: 25	عَلَّقَ طَلَاقَ
u'عَلَّقَ ظهار':Predicate, #84: 84	عَلَّقَ الطَّلَاقَ
u'عَلَّقَ عَاقِلٌ':Subject, #6: 6	عَلَّقَ الظِّهَارَ
u'عَلَّقَ عِبَادَةٌ':Predicate, #1: 1	عَلَّقَ الْعَاقِلُ
u'عَلَّقَ عَبْدٌ':Subject, #2: 2	عَلَّقَ عِبَادَةَ
u'عَلَّقَ عَبْدٌ':Subject, #1: 1	عَلَّقَ عَبْدٌ
u'عَلَّقَ عتق':Predicate, #3: 3	عَلَّقَ الْعَبْدُ
u'عَلَّقَ عِتْقٌ':Predicate, #14: 14	عَلَّقَ الْعِتْقَ
u'عَلَّقَ عتق':Predicate, #14: 14	عَلَّقَ الْعِتْقَ
u'عَلَّقَ عِتْقٌ':Predicate, #39: 39	عَلَّقَ عِتْقَ
u'عَلَّقَ عَدَدٌ':Predicate, #39: 39	عَلَّقَ عِتْقَ
u'عَلَّقَ عَدَمٌ':Predicate, #1: 1	عَلَّقَ عَدَدَ
u'عَلَّقَ عِصْمَةٌ':Predicate, #1: 1	عَلَّقَ عَدَمَ
u'عَلَّقَ غُفْرَانٌ':Predicate, #1: 1	عَلَّقَ الْعِصْمَةَ
u'عَلَّقَ غير':Subject, #1: 1	عَلَّقَ الْغُفْرَانَ
u'عَلَّقَ غَيْرٌ':Subject, #1: 1	عَلَّقَ غَيْرُ
u'عَلَّقَ فلان':Subject, #1: 1	عَلَّقَ غَيْرُ
u'عَلَّقَ قُدْوَةٌ':Predicate, #4: 4	عَلَّقَ الشَّافِعِيُّ
u'عَلَّقَ قذف':Predicate, #1: 1	عَلَّقَ الْقُدْوَةَ
u'عَلَّقَ قَذْفٌ':Predicate, #2: 2	عَلَّقَ الْقَذْفَ
u'عَلَّقَ قراض':Predicate, #2: 2	عَلَّقَ الْقَذْفَ
u'عَلَقٌ قِرْبَةٌ':Added, #1: 1	عَلَّقَ الْقِرَاضَ
u'عَلَق قِرْبَةٌ':Added, #2: 2	عَلَقَ الْقِرْبَةِ
u'عَلَّقَ قَصْرٌ':Predicate, #2: 2	عَلَقَ الْقِرْبَةِ
u'عَلَّقَ قول':Predicate, #2: 2	عَلَّقَ الْقَصْرَ
u'عَلَّقَ قَوْلٌ':Predicate, #5: 5	عَلَّقَ الْقَوْلَ
u'عَلَّقَ كَرَاهَةٌ':Predicate, #5: 5	عَلَّقَ الْقَوْلَ
u'عَلَّقَ كَفَّارٌ':Predicate, #1: 1	عَلَّقَ كَرَاهَةَ
u'عَلَّقَ كَفَّارَةٌ':Predicate, #1: 1	عَلَّقَ الْكَفَّارَةَ
u'عَلَّقَ كَفَالَةٌ':Predicate, #1: 1	عَلَّقَ الْكَفَّارَةَ
u'عَلَّقَ كفر':Predicate, #1: 1	عَلَّقَ الْكَفَالَةَ
u'عَلَّقَ كُفْرٌ':Predicate, #3: 3	عَلَّقَ الْكُفْرَ
u'عَلَّقَ كَفِيلٌ':Subject, #3: 3	عَلَّقَ الْكُفْرَ
u'عَلَّقَ مَالٌ':Predicate, #1: 1	عَلَّقَ الْكَفِيلُ
u'عَلَّقَ مُدَبَّرٌ':Subject, #1: 1	عَلَّقَ الْمَالَ
u'عَلَّقَ مَدْيُونٌ':Subject, #1: 1	عَلَّقَ الْمُدَبَّرُ
u'عَلَّقَ مَسْحٌ':Predicate, #2: 2	عَلَّقَ الْمَدْيُونُ
u'عَلَّقَ مَشِيئَةٌ':Predicate, #1: 1	عَلَّقَ الْمَسْحَ
u'عَلَّقَ مُطْلَقٌ':Predicate, #1: 1	عَلَّقَ الْمَشِيئَةَ
u'عَلَّقَ مَغْنَمٌ':Predicate, #1: 1	عَلَّقَ مُطْلَقَ
u'عَلَّقَ مُؤَلِّفٌ':Subject, #1: 1	عَلَّقَ الْمَغْنَمَ
u'عَلَّقَ نَبِيٌّ':Subject, #1: 1	عَلَّقَ الْمُؤَلِّفُ
u'عَلَّقَ نذر':Predicate, #1: 1	عَلَّقَ النَّبِيُّ
u'عَلَّقَ نَذْرٌ':Predicate, #13: 13	عَلَّقَ النَّذْرَ
u'عَلِقَ نُزُولٌ':Subject, #13: 13	عَلَّقَ النَّذْرَ
u'عَلَّقَ نكاح':Predicate, #1: 1	عَلِقَ نُزُولُهُ
u'عَلَّقَ نِكَاحٌ':Predicate, #2: 2	عَلَّقَ النِّكَاحَ
u'عَلَّقَ نِيَّةٌ':Predicate, #2: 2	عَلَّقَ النِّكَاحَ
u'عَلَّقَ واحد':Predicate, #1: 1	عَلَّقَ نِيَّةَ
u'عَلَّقَ وَاحِدٌ':Predicate, #1: 1	عَلَّقَ وَاحِدَةً
u'عَلَّقَ وُجُوبٌ':Predicate, #1: 1	عَلَّقَ وَاحِدَةً
u'عَلَّقَ وَدَعٌ':Predicate, #1: 1	عَلَّقَ وُجُوبَ
u'عَلَّقَ وَصِيٌّ':Predicate, #2: 2	عَلَّقَ وَدَعَةً
u'عَلَّقَ وَصِيَّةٌ':Predicate, #1: 1	عَلَّقَ وَصِيَّةَ
u'عَلَّقَ وَقْفٌ':Predicate, #1: 1	عَلَّقَ وَصِيَّةَ
u'عَلَّقَ وُقُوعٌ':Predicate, #2: 2	عَلَّقَ الْوَقْفَ
u'عَلَّقَ وُقُوعٌ':Predicate, #1: 1	عَلَّقَ وُقُوعَ
u'عَلَّقَ وِلاَيَةٌ':Predicate, #2: 2	عَلَّقَ الْوُقُوعَ
u'عَلَّقَ ولد':Predicate, #1: 1	عَلَّقَ الْوِلَايَةَ
u'عَلَّقَ وَلَدٌ':Predicate, #1: 1	عَلَّقَ الْوَلَدَ
u'عَلَّقَ وَلِيٌّ':Subject, #1: 1	عَلَّقَ الْوَلَدَ
u'عَلَّقَ يَمِينٌ':Predicate, #2: 2	عَلَّقَ وَلِيُّ
u'عَلَكَ لِجَامٌ':Subject, #2: 2	عَلَّقَ الْيَمِينَ
u'عَلَّلَ اِبْنٌ':Subject, #1: 1	عَلَكَ اللّجَامُ
u'عَلَّلَ أَصْحَابٌ':Subject, #3: 3	عَلَّلَ ابْنُ
u'عَلَّلَ أصل':Predicate, #2: 2	عَلَّلَ الْأَصْحَابُ
u'عَلَّلَ أًصْلٌ':Predicate, #1: 1	عَلَّلَ الْأَصْلَ
u'عَلَّلَ اِعْتِبارٌ':Predicate, #1: 1	عَلَّلَ الْأَصْلَ
u'عَلَّلَ إمَامٌ':Subject, #1: 1	عَلَّلَ اعْتِبَارَ
u'عَلَّلَ أَمْرٌ':Predicate, #2: 2	عَلَّلَ الْإِمَامُ
u'عَلَّلَ اِنْفِساخٌ':Predicate, #1: 1	عَلَّلَ الْأَمْرَ
u'عَلَّلَ إهْدَاءٌ':Predicate, #1: 1	عَلَّلَ انْفِسَاخَ
u'عَلَّلَ أهْلٌ':Subject, #1: 1	عَلَّلَ الْإِهْدَاءَ
u'عَلَّلَ بَعْضٌ':Subject, #1: 1	عَلَّلَ أَهْلُ
u'عَلَّلَ تَبَع':Predicate, #5: 5	عَلَّلَ بَعْضُ
u'عَلَّلَ تَبَعِيّ':Predicate, #1: 1	عَلَّلَ تَبَعِيَّةَ
u'عَلَّلَ تَبَعِيَّة':Predicate, #1: 1	عَلَّلَ تَبَعِيَّةَ
u'عَلَّلَ تَعْلِيقٌ':Predicate, #1: 1	عَلَّلَ تَبَعِيَّةَ
u'عَلَّلَ تَغَيُّرٌ':Predicate, #1: 1	عَلَّلَ تَعْلِيقَ
u'عَلَّلَ ثُبُوتٌ':Predicate, #1: 1	عَلَّلَ تَغَيُّرَ
u'عَلَّلَ جمع':Predicate, #1: 1	عَلَّلَ ثُبُوتَ
u'عَلَّلَ جَمْعٌ':Predicate, #1: 1	عَلَّلَ الْجَمْعَ
u'عَلَّلَ جَوَازٌ':Predicate, #1: 1	عَلَّلَ الْجَمْعَ
u'عَلَّلَ حُرْمَةٌ':Predicate, #1: 1	عَلَّلَ الْجَوَازَ
u'عَلَّلَ حُكْمٌ':Predicate, #2: 2	عَلَّلَ الْحُرْمَةَ
u'عَلَّلَ حُكْمٌ':Predicate, #1: 1	عَلَّلَ حُكْمَ
u'عَلَّلَ حِلٌّ':Predicate, #2: 2	عَلَّلَ الْحُكْمَ
u'عَلَّلَ حَمْلٌ':Predicate, #1: 1	عَلَّلَ الْحِلَّ
u'عَلَّلَ دَليلٌ':Predicate, #1: 1	عَلَّلَ حَمْلَ
u'عَلَّلَ رَدٌّ':Predicate, #1: 1	عَلَّلَ دَلِيلَ
u'عَلَّلَ سُقُوطٌ':Predicate, #1: 1	عَلَّلَ الرَّدَّ
u'عَلَّلَ شَارِحٌ':Subject, #1: 1	عَلَّلَ سُقُوطَ
u'عَلَّلَ شافِعِيّ':Subject, #2: 2	عَلَّلَ الشَّارِحُ
u'عَلَّلَ شُرَّاحٌ':Subject, #2: 2	عَلَّلَ الشَّافِعِيُّ
u'عَلَّلَ شَيْخٌ':Subject, #1: 1	عَلَّلَ شُرَّاحُ
u'عَلَّلَ صَاحِبٌ':Subject, #1: 1	عَلَّلَ الشَّيْخُ
u'عَلَّلَ صِحَّةٌ':Predicate, #2: 2	عَلَّلَ صَاحِبُ
u'عَلَّلَ صَلاَةٌ':Predicate, #1: 1	عَلَّلَ صِحَّةَ
u'عَلَّلَ ضَمَانٌ':Predicate, #1: 1	عَلَّلَ الصَّلَاةَ
u'عَلَّلَ طعام':Predicate, #1: 1	عَلَّلَ الضَّمَانَ
u'عَلَّلَ طَعَامٌ':Predicate, #1: 1	عَلَّلَ الطَّعَامَ
u'عَلَّلَ عَدَمٌ':Predicate, #1: 1	عَلَّلَ الطَّعَامَ
u'عَلَّلَ فساد':Predicate, #10: 10	عَلَّلَ عَدَمَ
u'عَلَّلَ فَسَادٌ':Predicate, #1: 1	عَلَّلَ الْفَسَادَ
u'عَلَّلَ فلان':Subject, #1: 1	عَلَّلَ الْفَسَادَ
u'عَلَّلَ قَبُولٌ':Predicate, #2: 2	عَلَّلَ الشَّافِعِيُّ
u'عَلَّلَ قول':Predicate, #1: 1	عَلَّلَ قَبُولَ
u'عَلَّلَ قَوْلٌ':Predicate, #1: 1	عَلَّلَ الْقَوْلَ
u'عَلَّلَ قَوْمٌ':Subject, #1: 1	عَلَّلَ الْقَوْلَ
u'عَلَّلَ كَرَاهَةٌ':Predicate, #1: 1	عَلَّلَ قَوْمٌ
u'عَلَّلَ مُحَقِّقٌ':Subject, #2: 2	عَلَّلَ الْكَرَاهَةَ
u'عَلَّلَ مُحَمَّدٌ':Subject, #1: 1	عَلَّلَ الْمُحَقِّقُ
u'عَلَّلَ مَسْأَلَةٌ':Predicate, #3: 3	عَلَّلَ مُحَمَّدٌ
u'عَلَّلَ مَسْأَلَةٌ':Predicate, #1: 1	عَلَّلَ مَسْأَلَةَ
u'عَلَّلَ مَشَايِخُ':Subject, #5: 5	عَلَّلَ الْمَسْأَلَةَ
u'عَلَّلَ مُصَنِّفٌ':Subject, #1: 1	عَلَّلَ الْمَشَايِخُ
u'عَلَّلَ مَطْلُوب':Predicate, #4: 4	عَلَّلَ الْمُصَنِّفُ
u'عَلَّلَ مَنْعٌ':Predicate, #1: 1	عَلَّلَ مَطْلُوبِيَّةَ
u'عَلَّلَ مُنْكِرٌ':Subject, #2: 2	عَلَّلَ مَنْعَ
u'عَلَّلَ مُؤَلِّفٌ':Subject, #1: 1	عَلَّلَ الْمُنْكِرُ
u'عَلَّلَ وَجْهٌ':Predicate, #1: 1	عَلَّلَ الْمُؤَلِّفُ
u'عَلَّلَ وُجُوبٌ':Predicate, #1: 1	عَلَّلَ وَجْهَ
u'عَلَّلَ وُقُوعٌ':Predicate, #2: 2	عَلَّلَ وُجُوبَ
u'عَلِمَ أَبٌ':Subject, #1: 1	عَلَّلَ وُقُوعَ
u'علم آباءٌ':Added, #2: 2	عَلِمَ الْأَبُ
u'عِلْمٌ آباءٌ':Added, #1: 1	عِلْمَ الْآبَاءِ
u'علم أبدانٌ':Added, #1: 1	عِلْمَ الْآبَاءِ
u'عِلْمٌ أبدانٌ':Added, #1: 1	عِلْمِ الْأَبَدَانِ
u'عَلِمَ إِبْرَازٌ':Predicate, #1: 1	عِلْمِ الْأَبَدَانِ
u'عَلِمَ اِبْنٌ':Subject, #1: 1	عَلِمَ إبْرَازَ
u'علم اِبْنٌ':Added, #3: 3	عَلِمَ ابْنُ
u'عِلْمٌ اِبْنٌ':Added, #1: 1	عِلْمُ ابْنِ
u'علم اِتِّبَاعٌ':Added, #1: 1	عِلْمُ ابْنِ
u'عِلْمٌ اِتِّبَاعٌ':Added, #1: 1	عِلْمَ اتِّبَاعٍ
u'عَلِمَ اِتِّضَاحٌ':Predicate, #1: 1	عِلْمَ اتِّبَاعٍ
u'عَلِمَ أَجِيرٌ':Subject, #1: 1	عَلِمَ اتِّضَاحَ
u'عَلِمَ اِحْتِراقٌ':Predicate, #4: 4	عَلِمَ الْأَجِيرُ
u'عَلِمَ أحَدٌ':Predicate, #2: 2	عَلِمَ احْتِرَاقَ
u'عَلِمَ أحَدٌ':Subject, #1: 1	عَلِمَ أَحَدَ
u'عَلِمَ أحْزَابٌ':Subject, #3: 3	عَلِمَ أَحَدٌ
u'علم أَحْكَامٌ':Added, #1: 1	عَلِمَ الْأَحْزَابُ
u'عِلْمٌ أَحْكَامٌ':Added, #1: 1	عِلْمُ الْأَحْكَامِ
u'علم أخْبَارٌ':Added, #1: 1	عِلْمُ الْأَحْكَامِ
u'علم أَخْبَارٌ':Added, #2: 2	عِلْمِ الْأَخْبَارِ
u'عِلْمٌ أخْبَارٌ':Added, #2: 2	عِلْمِ الْأَخْبَارِ
u'عِلْمٌ أَخْبَارٌ':Added, #2: 2	عِلْمِ الْأَخْبَارِ
u'عَلِمَ اِخْتِلاَفٌ':Predicate, #2: 2	عِلْمِ الْأَخْبَارِ
u'علم أخْلاقٌ':Added, #1: 1	عَلِمَ اخْتِلَافَ
u'علم أَخْلاَقٌ':Added, #1: 1	عِلْمُ الْأَخْلَاقِ
u'عِلْمٌ أخْلاقٌ':Added, #1: 1	عِلْمُ الْأَخْلَاقِ
u'عِلْمٌ أَخْلاَقٌ':Added, #1: 1	عِلْمُ الْأَخْلَاقِ
u'علم أدَب':Added, #1: 1	عِلْمُ الْأَخْلَاقِ
u'عِلْمٌ أدَب':Added, #2: 2	عِلْمِ الْأَدَبِ
u'عَلَّمَ آدَمُ':Predicate, #2: 2	عِلْمِ الْأَدَبِ
u'علم أَدْيانٌ':Added, #4: 4	عَلَّمَ آدَمَ
u'عِلْمٌ أَدْيانٌ':Added, #1: 1	عِلْمُ الْأَدْيَانِ
u'عَلَّمَ أَذَانٌ':Predicate, #1: 1	عِلْمُ الْأَدْيَانِ
u'عَلِمَ إِذْنٌ':Predicate, #1: 1	عَلَّمَ الْأَذَانَ
u'علم إِذْنٌ':Added, #5: 5	عَلِمَ الْإِذْنَ
u'عِلْمٌ إِذْنٌ':Added, #1: 1	عِلْمِ إذْنٍ
u'عَلِمَ إِرَادَةٌ':Predicate, #1: 1	عِلْمِ إذْنٍ
u'علم إِرَادَةٌ':Added, #1: 1	عَلِمَ إرَادَةَ
u'عِلْمٌ إِرَادَةٌ':Added, #1: 1	عِلْمِ الْإِرَادَةِ
u'علم أَزَلٌ':Added, #1: 1	عِلْمِ الْإِرَادَةِ
u'عِلْمٌ أَزَلٌ':Added, #2: 2	عِلْمَ الأَزَلِ
u'عَلِمَ اِسْتِبْعَادٌ':Predicate, #2: 2	عِلْمَ الأَزَلِ
u'عَلِمَ اِسْتِحَالَةٌ':Predicate, #1: 1	عَلِمَ اسْتِبْعَادَ
u'عَلِمَ اِسْتِحْقاق':Predicate, #1: 1	عَلِمَ اسْتِحَالَةَ
u'عَلِمَ اِسْتِناد':Predicate, #1: 1	عَلِمَ اسْتِحْقَاقَةَ
u'عَلِمَ اِسْتيلاءٌ':Predicate, #1: 1	عَلِمَ اسْتِنَادَ
u'علم إِسْلامٌ':Added, #1: 1	عَلِمَ اسْتِيلَاءَ
u'عِلْمٌ إِسْلامٌ':Added, #1: 1	عِلْمُ الْإِسْلَامِ
u'علم أَسْماءٌ':Added, #1: 1	عِلْمُ الْإِسْلَامِ
u'عِلْمٌ أَسْماءٌ':Added, #1: 1	عِلْمِ الْأَسْمَاءِ
u'عَلِمَ أَسيرٌ':Subject, #1: 1	عِلْمِ الْأَسْمَاءِ
u'عَلِمَ إصابَةٌ':Predicate, #1: 1	عَلِمَ الْأَسِيرُ
u'عَلِمَ أَصْحَابٌ':Subject, #1: 1	عَلِمَ الْإِصَابَةَ
u'علم إِصْرارٌ':Added, #1: 1	عَلِمَ أَصْحَابُ
u'عِلْمٌ إِصْرارٌ':Added, #1: 1	عِلْمُ الْإِصْرَارِ
u'علم أُصولٌ':Added, #1: 1	عِلْمُ الْإِصْرَارِ
u'عِلْمٌ أُصولٌ':Added, #29: 29	عِلْمِ الْأُصُولِ
u'علم أُصولٌ':Added, #29: 29	عِلْمِ الْأُصُولِ
u'علم أُصولٌ':Added, #2: 2	عِلْمَ أُصُولِ
u'علم أُصولٌ':Added, #2: 2	عِلْمُ أُصُولِ
u'عِلْمٌ أُصولٌ':Added, #2: 2	عِلْمِ أُصُولِ
u'عِلْمٌ أُصولٌ':Added, #2: 2	عِلْمَ أُصُولِ
u'عِلْمٌ أُصولٌ':Added, #2: 2	عِلْمُ أُصُولِ
u'علم أُصولٌ':Added, #2: 2	عِلْمِ أُصُولِ
u'عِلْمٌ أُصولٌ':Added, #3: 3	عِلْمَ الْأُصُولِ
u'علم أُصولٌ':Added, #3: 3	عِلْمَ الْأُصُولِ
u'عِلْمٌ أُصولٌ':Added, #4: 4	عِلْمُ الْأُصُولِ
u'عَلِمَ أَعْدَاءٌ':Subject, #4: 4	عِلْمُ الْأُصُولِ
u'علم أَعْدَاءٌ':Added, #1: 1	عَلِمَ الْأَعْدَاءُ
u'عَلَمٌ أَعْدَاءٌ':Added, #1: 1	عَلَمُ الْأَعْدَاءِ
u'علم إِعْرابٌ':Added, #1: 1	عَلَمُ الْأَعْدَاءِ
u'عِلْمٌ إِعْرابٌ':Added, #1: 1	عِلْمِ الْإِعْرَابِ
u'عَلَّمَ أعْرَابِيٌّ':Predicate, #1: 1	عِلْمِ الْإِعْرَابِ
u'علم أَعْلاَمٌ':Added, #4: 4	عَلَّمَ الْأَعْرَابِيَّ
u'عَلَمٌ أَعْلاَمٌ':Added, #1: 1	عَلَمِ الْأَعْلَامِ
u'عَلِمَ أفْضَلُ':Predicate, #1: 1	عَلَمِ الْأَعْلَامِ
u'عَلِمَ إقامَةٌ':Predicate, #1: 1	عَلِمَ أَفْضَلَ
u'علم أَقْوَالٌ':Added, #1: 1	عَلِمَ الْإِقَامَةَ
u'عِلْمٌ أَقْوَالٌ':Added, #1: 1	عِلْمُ أَقْوَالِ
u'عَلِمَ أَقْوَامٌ':Subject, #1: 1	عِلْمُ أَقْوَالِ
u'علم أكابر':Added, #1: 1	عَلِمَ الْأَقْوَامُ
u'عِلْمٌ أكابر':Added, #1: 1	عِلْمِ أَكَابِرِ
u'علم أَكْثَرُ':Added, #1: 1	عِلْمِ أَكَابِرِ
u'عِلْمٌ أَكْثَرُ':Added, #2: 2	عِلْمُ أَكْثَرِ
u'عَلِمَ اِلْتِجَاءٌ':Predicate, #2: 2	عِلْمُ أَكْثَرِ
u'علم اللهُ':Added, #1: 1	عَلِمَ الْتِجَاءَ
u'عِلْمٌ اللهُ':Added, #1: 1	عِلْمِ اللهِ
u'عَلَّمَ الْمَرْأَةُ':Predicate, #1: 1	عِلْمِ اللهِ
u'علم الْمَرْأَةُ':Added, #1: 1	عَلَّمَ الْمَرْأَةَ
u'علم الْمَرْأَةُ':Added, #1: 1	عِلْمَ الْمَرْأَةِ
u'عِلْمٌ الْمَرْأَةُ':Added, #1: 1	عِلْمِ الْمَرْأَةِ
u'عِلْمٌ الْمَرْأَةُ':Added, #1: 1	عِلْمَ الْمَرْأَةِ
u'عَلِمَ المُشْتَرِي':Predicate, #1: 1	عِلْمِ الْمَرْأَةِ
u'عَلِمَ إمَامٌ':Subject, #3: 3	أَعْلَمَ الْمُشْتَرِيَ
u'علم إمَامٌ':Added, #13: 13	عَلِمَ الْإِمَامُ
u'عِلْمٌ إمَامٌ':Added, #1: 1	عِلْمُ الْإِمَامِ
u'علم إمَامٌ':Added, #1: 1	عِلْمُ الْإِمَامِ
u'عِلْمٌ إمَامٌ':Added, #1: 1	عِلْمَ إمَامِهِ
u'علم إمَامٌ':Added, #1: 1	عِلْمَ إمَامِهِ
u'عِلْمٌ إمَامٌ':Added, #4: 4	عِلْمِ الْإِمَامِ
u'علم أمَانَةٌ':Added, #4: 4	عِلْمِ الْإِمَامِ
u'عِلْمٌ أمَانَةٌ':Added, #1: 1	عِلْمُ أَمَانَةِ
u'علم أُمَّةٌ':Added, #1: 1	عِلْمُ أَمَانَةِ
u'عَلَمٌ أُمَّةٌ':Added, #1: 1	عَلَمُ الْأُمَّةِ
u'عَلِمَ آمِرٌ':Subject, #1: 1	عَلَمُ الْأُمَّةِ
u'علم آمِرٌ':Added, #5: 5	عَلِمَ الْآمِرُ
u'عِلْمٌ آمِرٌ':Added, #3: 3	عِلْمِ الْآمِرِ
u'علم أُمَمٌ':Added, #3: 3	عِلْمِ الْآمِرِ
u'عِلْمٌ أُمَمٌ':Added, #1: 1	عِلْمُ الْأُمَمِ
u'عَلِمَ أُمِّيٌّ':Subject, #1: 1	عِلْمُ الْأُمَمِ
u'عَلِمَ أَميرٌ':Predicate, #1: 1	عَلِمَ الْأُمِّيُّ
u'عَلِمَ أَميرٌ':Subject, #1: 1	أَعْلَمَ الْأَمِيرَ
u'علم أنبياء':Added, #1: 1	عَلِمَ أَمِيرُ
u'عِلْمٌ أنبياء':Added, #1: 1	عِلْمِ الْأَنْبِيَاءِ
u'عَلِمَ اِنْتِفاء':Predicate, #1: 1	عِلْمِ الْأَنْبِيَاءِ
u'علم اِنْتِفاء':Added, #2: 2	عَلِمَ انْتِفَاءَ
u'عِلْمٌ اِنْتِفاء':Added, #1: 1	عِلْمِ انْتِفَاءِ
u'عَلِمَ اِنْتِقالٌ':Predicate, #1: 1	عِلْمِ انْتِفَاءِ
u'عَلَّمَ إِنْسانٌ':Predicate, #1: 1	عَلِمَ انْتِقَالَ
u'عَلَّمَ إِنْسانٌ':Predicate, #1: 1	عَلَّمَ الإِنْسَانَ
u'عَلِمَ إِنْسانٌ':Subject, #3: 3	عَلَّمَ الْإِنْسَانَ
u'عَلِمَ إِنْسانٌ':Subject, #1: 1	عَلِمَ الْإِنْسَانُ
u'علم إِنْسانٌ':Added, #1: 1	عَلِمَ إنْسَانٌ
u'عِلْمٌ إِنْسانٌ':Added, #1: 1	عِلْمُ الْإِنْسَانِ
u'عَلِمَ إِنْسِيٌّ':Subject, #1: 1	عِلْمُ الْإِنْسَانِ
u'عَلِمَ إِنْفاقٌ':Subject, #1: 1	عَلِمَ الْإِنْسِيُّ
u'علم اِنْقِسَامٌ':Added, #1: 1	عَلِمَ الْإِنْفَاقُ
u'عِلْمٌ اِنْقِسَامٌ':Added, #1: 1	عِلْمُ انْقِسَامِ
u'عَلِمَ أهْلٌ':Subject, #1: 1	عِلْمُ انْقِسَامِ
u'علم أهْلٌ':Added, #4: 4	عَلِمَ أَهْلُ
u'عِلْمٌ أهْلٌ':Added, #3: 3	عِلْمُ أَهْلِ
u'عَلِمَ أَوَّلُ':Predicate, #3: 3	عِلْمُ أَهْلِ
u'عَلِمَ أَوَّلُ':Predicate, #2: 2	عَلِمَ الْأَوَّلَ
u'عَلِمَ أَوَّلُ':Subject, #2: 2	عَلِمَ أَوَّلَ
u'علم أَوَّلُ':Added, #5: 5	عَلِمَ الْأَوَّلُ
u'عِلْمٌ أَوَّلُ':Added, #3: 3	عِلْمِ الْأَوَّلِ
u'علم أئِمَّةٌ':Added, #3: 3	عِلْمِ الْأَوَّلِ
u'عَلَمٌ أئِمَّةٌ':Added, #1: 1	عَلَمُ الْأَئِمَّةِ
u'عَلِمَ أَيْنٌ':Predicate, #1: 1	عَلَمُ الْأَئِمَّةِ
u'علم بَابٌ':Added, #1: 1	عَلِمَ أَيْنَ
u'عِلْمٌ بَابٌ':Added, #1: 1	عِلْمَ بَابِ
u'علم بَارِئٌ':Added, #1: 1	عِلْمَ بَابِ
u'عِلْمٌ بَارِئٌ':Added, #2: 2	عِلْمَ الْبَارِئِ
u'عَلِمَ بَائِعٌ':Subject, #2: 2	عِلْمَ الْبَارِئِ
u'عَلِمَ بَائِعٌ':Subject, #15: 15	عَلِمَ الْبَائِعُ
u'علم بَائِعٌ':Added, #2: 2	عَلِمَ بَائِعُهُ
u'عِلْمٌ بَائِعٌ':Added, #1: 1	عِلْمِ بَائِعِهِ
u'علم بَائِعٌ':Added, #1: 1	عِلْمِ بَائِعِهِ
u'عِلْمٌ بَائِعٌ':Added, #2: 2	عِلْمَ بَائِعِهِ
u'علم بَائِعٌ':Added, #2: 2	عِلْمَ بَائِعِهِ
u'عِلْمٌ بَائِعٌ':Added, #6: 6	عِلْمِ الْبَائِعِ
u'علم بِدَعٌ':Added, #6: 6	عِلْمِ الْبَائِعِ
u'عِلْمٌ بِدَعٌ':Added, #1: 1	عِلْمِ الْبِدَعِ
u'علم بَدِيعٌ':Added, #1: 1	عِلْمِ الْبِدَعِ
u'عِلْمٌ بَدِيعٌ':Added, #1: 1	عِلْمِ الْبَدِيعِ
u'عَلِمَ بَراءةٌ':Predicate, #1: 1	عِلْمِ الْبَدِيعِ
u'عَلِمَ بَعْضٌ':Predicate, #1: 1	عَلِمَ بَرَاءَةَ
u'علم بَعْضٌ':Added, #1: 1	عَلِمَ بَعْضَ
u'عِلْمٌ بَعْضٌ':Added, #1: 1	عِلْمُ الْبَعْضِ
u'علم بَعْض':Added, #1: 1	عِلْمُ الْبَعْضِ
u'عِلْمٌ بَعْض':Added, #1: 1	عِلْمُ الْبَعْضِيَّةِ
u'علم بَعْضٌ':Added, #1: 1	عِلْمُ الْبَعْضِيَّةِ
u'عِلْمٌ بَعْضٌ':Added, #2: 2	عِلْمِ بَعْضِ
u'علم بَلاغَةٌ':Added, #2: 2	عِلْمِ بَعْضِ
u'علم بَلاغَةٌ':Added, #1: 1	عِلْمُ الْبَلَاغَةِ
u'عِلْمٌ بَلاغَةٌ':Added, #1: 1	عِلْمِ الْبَلَاغَةِ
u'عِلْمٌ بَلاغَةٌ':Added, #1: 1	عِلْمُ الْبَلَاغَةِ
u'عَلِمَ بَنْجٌ':Predicate, #1: 1	عِلْمِ الْبَلَاغَةِ
u'علم بَيَانٌ':Added, #1: 1	عَلِمَ الْبَنْجَ
u'عِلْمٌ بَيَانٌ':Added, #2: 2	عِلْمُ الْبَيَانِ
u'علم بَيَانٌ':Added, #2: 2	عِلْمُ الْبَيَانِ
u'عِلْمٌ بَيَانٌ':Added, #8: 8	عِلْمِ الْبَيَانِ
u'عَلِمَ بيض':Subject, #8: 8	عِلْمِ الْبَيَانِ
u'عَلِمَ بَيِّنَةٌ':Predicate, #1: 1	عَلِمَ الْبِيضُ
u'عَلِمَ تَأْجِيلٌ':Predicate, #1: 1	عَلِمَ الْبَيِّنَةَ
u'علم تَأَخُّرٌ':Added, #1: 1	عَلِمَ تَأْجِيلَ
u'عِلْمٌ تَأَخُّرٌ':Added, #1: 1	عِلْمِ تَأَخُّرِ
u'عَلِمَ تَارِيخٌ':Predicate, #1: 1	عِلْمِ تَأَخُّرِ
u'عَلِمَ تَارِيخٌ':Predicate, #1: 1	عَلِمَ التَّارِيخَ
u'عَلِمَ تَارِيخٌ':Subject, #1: 1	عَلِمَ تَارِيخَ
u'علم تَارِيخٌ':Added, #1: 1	عَلِمَ التَّارِيخُ
u'علم تَارِيخٌ':Added, #1: 1	عِلْمَ التَّارِيخِ
u'عِلْمٌ تَارِيخٌ':Added, #1: 1	عِلْمُ التَّارِيخِ
u'عِلْمٌ تَارِيخٌ':Added, #1: 1	عِلْمَ التَّارِيخِ
u'عَلِمَ تَبَع':Subject, #1: 1	عِلْمُ التَّارِيخِ
u'علم تَجَارِبُ':Added, #1: 1	عَلِمَ التَّبَعُ
u'عِلْمٌ تَجَارِبُ':Added, #1: 1	عِلْمُ التّجَارِبِ
u'عَلِمَ تَحْرِيمٌ':Predicate, #1: 1	عِلْمُ التّجَارِبِ
u'عَلِمَ تَحْرِيمٌ':Predicate, #10: 10	عَلِمَ تَحْرِيمَ
u'علم تَحْرِيمٌ':Added, #12: 12	عَلِمَ التَّحْرِيمَ
u'عِلْمٌ تَحْرِيمٌ':Added, #1: 1	عِلْمِ التَّحْرِيمِ
u'علم تَذْكيرٌ':Added, #1: 1	عِلْمِ التَّحْرِيمِ
u'عِلْمٌ تَذْكيرٌ':Added, #1: 1	عِلْمِ التَّذْكِيرِ
u'عَلِمَ تَرْكٌ':Predicate, #1: 1	عِلْمِ التَّذْكِيرِ
u'عَلِمَ تَسْلِيمٌ':Predicate, #2: 2	عَلِمَ تَرْكَ
u'علم تَصرِيفٌ':Added, #1: 1	عَلِمَ تَسْلِيمَ
u'علم تَصرِيفٌ':Added, #1: 1	عِلْمِ التّصْرِيفِ
u'عِلْمٌ تَصرِيفٌ':Added, #1: 1	عِلْمِ التَّصْرِيفِ
u'عِلْمٌ تَصرِيفٌ':Added, #1: 1	عِلْمِ التّصْرِيفِ
u'علم تَعْبِيرٌ':Added, #1: 1	عِلْمِ التَّصْرِيفِ
u'عِلْمٌ تَعْبِيرٌ':Added, #4: 4	عِلْمِ التّعْبِيرِ
u'عَلِمَ تَعْجِيل':Predicate, #4: 4	عِلْمِ التّعْبِيرِ
u'علم تَعْجِيل':Added, #1: 1	عَلِمَ التَّعْجِيلَ
u'عِلْمٌ تَعْجِيل':Added, #2: 2	عِلْمِ التَّعْجِيلِ
u'عَلِمَ تَغَيُّرٌ':Predicate, #2: 2	عِلْمِ التَّعْجِيلِ
u'عَلِمَ تَفَاضُلٌ':Predicate, #1: 1	عَلِمَ تَغَيُّرَ
u'علم تَفْسِيرٌ':Added, #1: 1	عَلِمَ التَّفَاضُلَ
u'عِلْمٌ تَفْسِيرٌ':Added, #1: 1	عِلْمُ التَّفْسِيرِ
u'علم تَفْسِيرٌ':Added, #1: 1	عِلْمُ التَّفْسِيرِ
u'عِلْمٌ تَفْسِيرٌ':Added, #2: 2	عِلْمِ التَّفْسِيرِ
u'عَلِمَ تَقَدُّمٌ':Predicate, #2: 2	عِلْمِ التَّفْسِيرِ
u'عَلِمَ تَلْويثٌ':Predicate, #1: 1	عَلِمَ تَقَدُّمَ
u'علم تَوْحِيدٌ':Added, #1: 1	عَلِمَ التَّلْوِيثَ
u'عِلْمٌ تَوْحِيدٌ':Added, #2: 2	عِلْمُ التَّوْحِيدِ
u'علم تَوْحِيدٌ':Added, #2: 2	عِلْمُ التَّوْحِيدِ
u'عِلْمٌ تَوْحِيدٌ':Added, #5: 5	عِلْمِ التَّوْحِيدِ
u'عَلِمَ ثُبُوتٌ':Predicate, #5: 5	عِلْمِ التَّوْحِيدِ
u'عَلِمَ ثَمَنٌ':Predicate, #2: 2	عَلِمَ ثُبُوتَ
u'علم ثَوْبٌ':Added, #3: 3	عَلِمَ الثَّمَنَ
u'عَلَمٌ ثَوْبٌ':Added, #1: 1	عَلَمُ الثَّوْبِ
u'علم جَارِحٌ':Added, #1: 1	عَلَمُ الثَّوْبِ
u'عِلْمٌ جَارِحٌ':Added, #1: 1	عِلْمِ الْجَارِحِ
u'عَلِمَ جَاهِلٌ':Subject, #1: 1	عِلْمِ الْجَارِحِ
u'علم جُبّةٌ':Added, #1: 1	عَلِمَ الْجَاهِلُ
u'عَلَمٌ جُبّةٌ':Added, #1: 1	عَلَمُ الْجُبَّةِ
u'علم جَبْرٌ':Added, #1: 1	عَلَمُ الْجُبَّةِ
u'عِلْمٌ جَبْرٌ':Added, #1: 1	عِلْمَ الْجَبْرِ
u'علم جِبِلَّةٌ':Added, #1: 1	عِلْمَ الْجَبْرِ
u'عِلْمٌ جِبِلَّةٌ':Added, #1: 1	عِلْمِ الْجِبِلَّةِ
u'علم جَدَلٌ':Added, #1: 1	عِلْمِ الْجِبِلَّةِ
u'عِلْمٌ جَدَلٌ':Added, #3: 3	عِلْمُ الْجَدَلِ
u'علم جَرٌّ':Added, #3: 3	عِلْمُ الْجَدَلِ
u'عِلْمٌ جَرٌّ':Added, #1: 1	عِلْمُ جَرِّ
u'علم جُزْئِيٌّ':Added, #1: 1	عِلْمُ جَرِّ
u'عِلْمٌ جُزْئِيٌّ':Added, #2: 2	عِلْمِ الْجُزْئِيَّاتِ
u'علم جُزْئِيَّةٌ':Added, #2: 2	عِلْمِ الْجُزْئِيَّاتِ
u'عِلْمٌ جُزْئِيَّةٌ':Added, #2: 2	عِلْمِ الْجُزْئِيَّاتِ
u'عَلِمَ جَفَاءٌ':Predicate, #2: 2	عِلْمِ الْجُزْئِيَّاتِ
u'عَلِمَ جَمَاعَةٌ':Predicate, #1: 1	عَلِمَ جَفَاءَ
u'عَلِمَ جَمَاعَةٌ':Subject, #1: 1	عَلِمَ الْجَمَاعَةَ
u'عَلِمَ جَمَاعَةٌ':Subject, #1: 1	عَلِمَ الْجَمَاعَةُ
u'عَلِمَ جُمْلَةٌ':Predicate, #1: 1	عَلِمَ جَمَاعَةٌ
u'عَلِمَ جُمْلَةٌ':Predicate, #1: 1	عَلِمَ جُمْلَةَ
u'علم جَمِيع':Added, #3: 3	عَلِمَ الْجُمْلَةَ
u'عِلْمٌ جَمِيع':Added, #1: 1	عِلْمُ الْجَمِيعِ
u'علم جِنْسٌ':Added, #1: 1	عِلْمُ الْجَمِيعِ
u'عِلْمٌ جِنْسٌ':Added, #1: 1	عِلْمِ الْجِنْسِ
u'علم جِنْسٌ':Added, #1: 1	عِلْمِ الْجِنْسِ
u'عَلَمٌ جِنْسٌ':Added, #2: 2	عَلَمُ جِنْسٍ
u'علم جِنْسٌ':Added, #2: 2	عَلَمُ جِنْسٍ
u'عِلْمٌ جِنْسٌ':Added, #4: 4	عِلْمَ الْجِنْسِ
u'علم جِنْسٌ':Added, #4: 4	عِلْمَ الْجِنْسِ
u'عَلَمٌ جِنْسٌ':Added, #4: 4	عَلَمَ جِنْسٍ
u'علم جِنْسٌ':Added, #4: 4	عَلَمَ جِنْسٍ
u'عَلَمٌ جِنْسٌ':Added, #5: 5	عَلَمُ الْجِنْسِ
u'علم جِنْسٌ':Added, #5: 5	عَلَمُ الْجِنْسِ
u'عَلَمٌ جِنْسٌ':Added, #7: 7	عَلَمِ الْجِنْسِ
u'علم جِنْسٌ':Added, #7: 7	عَلَمِ الْجِنْسِ
u'عَلَمٌ جِنْسٌ':Added, #9: 9	عَلَمَ الْجِنْسِ
u'عَلِمَ جَوَامِعُ':Predicate, #9: 9	عَلَمَ الْجِنْسِ
u'عَلِمَ حاجَةٌ':Predicate, #1: 1	عَلِمَ جَوَامِعَ
u'عَلِمَ حاضِرٌ':Subject, #1: 1	عَلِمَ حَاجَةَ
u'علم حافِظٌ':Added, #1: 1	عَلِمَ الْحَاضِرُ
u'علم حافِظٌ':Added, #1: 1	عِلْمَ حَافِظِ
u'عِلْمٌ حافِظٌ':Added, #1: 1	عِلْمُ حَافِظِ
u'عِلْمٌ حافِظٌ':Added, #1: 1	عِلْمَ حَافِظِ
u'عَلِمَ حاكِمٌ':Subject, #1: 1	عِلْمُ حَافِظِ
u'علم حاكِمٌ':Added, #14: 14	عَلِمَ الْحَاكِمُ
u'عِلْمٌ حاكِمٌ':Added, #1: 1	عِلْمِ الْحَاكِمِ
u'علم حاكِمٌ':Added, #1: 1	عِلْمِ الْحَاكِمِ
u'عِلْمٌ حاكِمٌ':Added, #3: 3	عِلْمُ الْحَاكِمِ
u'عَلِمَ حالٌ':Predicate, #3: 3	عِلْمُ الْحَاكِمِ
u'عَلِمَ حالٌ':Predicate, #4: 4	عَلِمَ حَالَ
u'علم حالٌ':Added, #6: 6	عَلِمَ الْحَالَ
u'عِلْمٌ حالٌ':Added, #2: 2	عِلْمُ حَالِ
u'عَلِمَ حالَةٌ':Predicate, #2: 2	عِلْمُ حَالِ
u'علم حائِطٌ':Added, #1: 1	عَلِمَ حَالَةَ
u'عِلْمٌ حائِطٌ':Added, #1: 1	عِلْمُ الْحَائِطِ
u'عَلِمَ حَدَثٌ':Predicate, #1: 1	عِلْمُ الْحَائِطِ
u'عَلِمَ حَدَثٌ':Predicate, #2: 2	عَلِمَ الْحَدَثَ
u'علم حَديثٌ':Added, #3: 3	عَلِمَ حَدَثَ
u'عِلْمٌ حَديثٌ':Added, #15: 15	عِلْمِ الْحَدِيثِ
u'علم حَديثٌ':Added, #15: 15	عِلْمِ الْحَدِيثِ
u'عِلْمٌ حَديثٌ':Added, #2: 2	عِلْمُ الْحَدِيثِ
u'علم حِرَفٌ':Added, #2: 2	عِلْمُ الْحَدِيثِ
u'عِلْمٌ حِرَفٌ':Added, #1: 1	عِلْمُ الْحِرَفِ
u'عَلِمَ حُرْمَةٌ':Predicate, #1: 1	عِلْمُ الْحِرَفِ
u'عَلِمَ حُرْمَةٌ':Predicate, #1: 1	عَلِمَ حُرْمَةَ
u'عَلِمَ حُرْمَةٌ':Subject, #6: 6	عَلِمَ الْحُرْمَةَ
u'علم حُروفٌ':Added, #1: 1	عَلِمَ حُرْمَةُ
u'عِلْمٌ حُروفٌ':Added, #2: 2	عِلْمِ الْحُرُوفِ
u'علم حساب':Added, #2: 2	عِلْمِ الْحُرُوفِ
u'علم حساب':Added, #1: 1	عِلْمَ الْحِسَابِ
u'عِلْمٌ حساب':Added, #1: 1	عِلْمُ الْحِسَابِ
u'عِلْمٌ حساب':Added, #1: 1	عِلْمَ الْحِسَابِ
u'علم حِسَابٌ':Added, #1: 1	عِلْمُ الْحِسَابِ
u'علم حِسَابٌ':Added, #1: 1	عِلْمَ الْحِسَابِ
u'عِلْمٌ حِسَابٌ':Added, #1: 1	عِلْمُ الْحِسَابِ
u'عِلْمٌ حِسَابٌ':Added, #1: 1	عِلْمَ الْحِسَابِ
u'علم حساب':Added, #1: 1	عِلْمُ الْحِسَابِ
u'عِلْمٌ حساب':Added, #8: 8	عِلْمِ الْحِسَابِ
u'علم حِسَابٌ':Added, #8: 8	عِلْمِ الْحِسَابِ
u'عِلْمٌ حِسَابٌ':Added, #8: 8	عِلْمِ الْحِسَابِ
u'علم حَسَنٌ':Added, #8: 8	عِلْمِ الْحِسَابِ
u'عِلْمٌ حَسَنٌ':Added, #1: 1	عِلْمَ الْحَسَنِ
u'عَلِمَ حُصُول':Predicate, #1: 1	عِلْمَ الْحَسَنِ
u'عَلِمَ حُضورٌ':Predicate, #2: 2	عَلِمَ حُصُولَ
u'عَلِمَ حُضُورٌ':Predicate, #4: 4	عَلِمَ حُضُورَ
u'عَلِمَ حَقٌّ':Predicate, #4: 4	عَلِمَ حُضُورَ
u'علم حقائق':Added, #1: 1	عَلِمَ الْحَقَّ
u'عِلْمٌ حقائق':Added, #1: 1	عِلْمِ الْحَقَائِقِ
u'علم حَقَائِقُ':Added, #1: 1	عِلْمِ الْحَقَائِقِ
u'عِلْمٌ حَقَائِقُ':Added, #1: 1	عِلْمِ الْحَقَائِقِ
u'علم حَقِيقٌ':Added, #1: 1	عِلْمِ الْحَقَائِقِ
u'عِلْمٌ حَقِيقٌ':Added, #1: 1	عِلْمِ حَقِيقَةِ
u'علم حَقِيقٌ':Added, #1: 1	عِلْمِ حَقِيقَةِ
u'عِلْمٌ حَقِيقٌ':Added, #2: 2	عِلْمَ الْحَقِيقَةِ
u'علم حَقِيقَةٌ':Added, #2: 2	عِلْمَ الْحَقِيقَةِ
u'عِلْمٌ حَقِيقَةٌ':Added, #1: 1	عِلْمِ حَقِيقَةِ
u'علم حَقِيقَةٌ':Added, #1: 1	عِلْمِ حَقِيقَةِ
u'عِلْمٌ حَقِيقَةٌ':Added, #2: 2	عِلْمَ الْحَقِيقَةِ
u'عَلِمَ حُكْمٌ':Predicate, #2: 2	عِلْمَ الْحَقِيقَةِ
u'عَلِمَ حُكْمٌ':Predicate, #1: 1	عَلِمَ الْحُكْمَ
u'علم حُكْمٌ':Added, #2: 2	عَلِمَ حُكْمَ
u'علم حُكْمٌ':Added, #1: 1	عِلْمُ حُكْمِ
u'عِلْمٌ حُكْمٌ':Added, #1: 1	عِلْمِ حُكْمِ
u'عِلْمٌ حُكْمٌ':Added, #1: 1	عِلْمُ حُكْمِ
u'علم حكمة':Added, #1: 1	عِلْمِ حُكْمِ
u'عِلْمٌ حكمة':Added, #1: 1	عِلْمِ الْحِكْمَةِ
u'علم حِكْمَةٌ':Added, #1: 1	عِلْمِ الْحِكْمَةِ
u'عِلْمٌ حِكْمَةٌ':Added, #1: 1	عِلْمِ الْحِكْمَةِ
u'عَلِمَ حَكِيمٌ':Subject, #1: 1	عِلْمِ الْحِكْمَةِ
u'عَلِمَ حَمْدٌ':Subject, #1: 1	عَلِمَ الْحَكِيمُ
u'علم خَاتِمٌ':Added, #1: 1	عَلِمَ الْحَمْدُ
u'عِلْمٌ خَاتِمٌ':Added, #1: 1	عِلْمُ خَاتِمَتِهِ
u'علم خَاتِمَةٌ':Added, #1: 1	عِلْمُ خَاتِمَتِهِ
u'عِلْمٌ خَاتِمَةٌ':Added, #1: 1	عِلْمُ خَاتِمَتِهِ
u'علم خَادِمٌ':Added, #1: 1	عِلْمُ خَاتِمَتِهِ
u'عِلْمٌ خَادِمٌ':Added, #1: 1	عِلْمٍ خَادِمٍ
u'علم خُرُوجٌ':Added, #1: 1	عِلْمٍ خَادِمٍ
u'عَلَمٌ خُرُوجٌ':Added, #1: 1	عَلَمُ الْخُرُوجِ
u'عَلِمَ خَصْمٌ':Subject, #1: 1	عَلَمُ الْخُرُوجِ
u'عَلِمَ خضر':Subject, #1: 1	عَلِمَ الْخَصْمُ
u'عَلِمَ خَضِرٌ':Subject, #2: 2	عَلِمَ الْخَضِرُ
u'عَلَّمَ خَطٌّ':Predicate, #2: 2	عَلِمَ الْخَضِرُ
u'علم خَطٌّ':Added, #1: 1	عَلَّمَ الْخَطَّ
u'عِلْمٌ خَطٌّ':Added, #1: 1	عِلْمَ الْخَطِّ
u'عَلِمَ خَطَأٌ':Predicate, #1: 1	عِلْمَ الْخَطِّ
u'علم خُطَبٌ':Added, #1: 1	عَلِمَ الْخَطَأَ
u'عِلْمٌ خُطَبٌ':Added, #1: 1	عِلْمُ خُطَبِ
u'عَلِمَ خِلاَفٌ':Predicate, #1: 1	عِلْمُ خُطَبِ
u'علم خِلاَفٌ':Added, #1: 1	عَلِمَ خِلَافَ
u'عِلْمٌ خِلاَفٌ':Added, #1: 1	عِلْمُ الْخِلَافِ
u'علم خِلاَفٌ':Added, #1: 1	عِلْمُ الْخِلَافِ
u'عِلْمٌ خِلاَفٌ':Added, #2: 2	عِلْمِ الْخِلَافِ
u'علم خِلاَفِيٌّ':Added, #2: 2	عِلْمِ الْخِلَافِ
u'عِلْمٌ خِلاَفِيٌّ':Added, #2: 2	عِلْمِ الْخِلَافِيِّ
u'عَلِمَ خُلَفَاءُ':Predicate, #2: 2	عِلْمِ الْخِلَافِيِّ
u'علم خلق':Added, #1: 1	أَعْلَمَ الْخُلَفَاءَ
u'عِلْمٌ خلق':Added, #1: 1	عِلْمِ الْخَلْقِ
u'علم خَلْقٌ':Added, #1: 1	عِلْمِ الْخَلْقِ
u'عِلْمٌ خَلْقٌ':Added, #1: 1	عِلْمِ الْخَلْقِ
u'علم خلق':Added, #1: 1	عِلْمِ الْخَلْقِ
u'عِلْمٌ خلق':Added, #1: 1	عِلْمُ خَلْقِهِ
u'علم خَلْقٌ':Added, #1: 1	عِلْمُ خَلْقِهِ
u'عِلْمٌ خَلْقٌ':Added, #1: 1	عِلْمُ خَلْقِهِ
u'علم خَلْوَةٌ':Added, #1: 1	عِلْمُ خَلْقِهِ
u'عِلْمٌ خَلْوَةٌ':Added, #1: 1	عِلْمُ الْخَلْوَةِ
u'علم خَمِيص':Added, #1: 1	عِلْمُ الْخَلْوَةِ
u'عِلْمٌ خَمِيص':Added, #1: 1	عِلْمُ الْخَمِيصَةِ
u'عَلِمَ خيار':Predicate, #1: 1	عِلْمُ الْخَمِيصَةِ
u'عَلِمَ خِيَارٌ':Predicate, #1: 1	عَلِمَ الْخِيَارَ
u'عَلِمَ خِيَانَةٌ':Predicate, #1: 1	عَلِمَ الْخِيَارَ
u'عَلِمَ خِيَانَةٌ':Predicate, #1: 1	عَلِمَ الْخِيَانَةَ
u'علم خَيْرٌ':Added, #3: 3	عَلِمَ خِيَانَةَ
u'عِلْمٌ خَيْرٌ':Added, #1: 1	عِلْمِ الْخَيْرِ
u'عَلِمَ دَاعِرٌ':Subject, #1: 1	عِلْمِ الْخَيْرِ
u'عَلِمَ دَافِعٌ':Predicate, #1: 1	عَلِمَ الدَّاعِرُ
u'عَلِمَ دَافِعٌ':Subject, #1: 1	أَعْلَمَ الدَّافِعَ
u'عَلِمَ دَائِنٌ':Subject, #1: 1	عَلِمَ الدَّافِعُ
u'عَلِمَ دُخُولٌ':Predicate, #1: 1	عَلِمَ الدَّائِنُ
u'عَلِمَ دونٌ':Predicate, #4: 4	عَلِمَ دُخُولَ
u'عَلِمَ دِينٌ':Predicate, #1: 1	عَلِمَ دُونَ
u'عَلِمَ دَيْنٌ':Predicate, #1: 1	عَلِمَ دِينَ
u'علم دِينٌ':Added, #1: 1	عَلِمَ دَيْنَ
u'علم دِينٌ':Added, #1: 1	عَلَمَ الدِّينِ
u'علم دِينٌ':Added, #1: 1	عَلَمِ الدِّينِ
u'عَلَمٌ دِينٌ':Added, #1: 1	عِلْمِ الدِّينِ
u'عَلَمٌ دِينٌ':Added, #1: 1	عَلَمَ الدِّينِ
u'عِلْمٌ دِينٌ':Added, #1: 1	عَلَمِ الدِّينِ
u'علم دِينٌ':Added, #1: 1	عِلْمِ الدِّينِ
u'عِلْمٌ دِينٌ':Added, #2: 2	عِلْمَ الدِّينِ
u'علم دِينٌ':Added, #2: 2	عِلْمَ الدِّينِ
u'عِلْمٌ دِينٌ':Added, #2: 2	عِلْمِ دِينِ
u'علم دِينٌ':Added, #2: 2	عِلْمِ دِينِ
u'عِلْمٌ دِينٌ':Added, #2: 2	عِلْمُ دِينِهِ
u'علم دِينٌ':Added, #2: 2	عِلْمُ دِينِهِ
u'عِلْمٌ دِينٌ':Added, #3: 3	عِلْمُ الدِّينِ
u'علم دِينٌ':Added, #3: 3	عِلْمُ الدِّينِ
u'عَلَمٌ دِينٌ':Added, #4: 4	عَلَمُ الدِّينِ
u'عَلِمَ ذِراعٌ':Predicate, #4: 4	عَلَمُ الدِّينِ
u'عَلِمَ رَاهِنٌ':Subject, #1: 1	عَلِمَ ذِرَاعَ
u'عَلِمَ رَبُّ':Predicate, #1: 1	عَلِمَ الرَّاهِنُ
u'عَلِمَ رَبُّ':Subject, #1: 1	أَعْلَمَ رَبَّ
u'عَلِمَ رَبُّ':Subject, #4: 4	عَلِمَ رَبُّ
u'علم رَبُّ':Added, #5: 5	عَلِمَ رَبُّهُ
u'عِلْمٌ رَبُّ':Added, #1: 1	عِلْمِ الرَّبِّ
u'علم رَبُّ':Added, #1: 1	عِلْمِ الرَّبِّ
u'عِلْمٌ رَبُّ':Added, #1: 1	عِلْمَ رَبِّ
u'عَلِمَ رُجْحانٌ':Predicate, #1: 1	عِلْمَ رَبِّ
u'عَلَّمَ رَجُلٌ':Subject, #1: 1	عَلِمَ رُجْحَانَ
u'عَلَّمَ رَجُلٌ':Subject, #1: 1	عَلَّمَ الرَّجُلُ
u'عَلِمَ رَجُلٌ':Subject, #1: 1	عَلَّمَ رَجُلٌ
u'علم رَجُلٌ':Added, #2: 2	عَلِمَ الرَّجُلُ
u'عِلْمٌ رَجُلٌ':Added, #1: 1	عِلْمِ الرَّجُلِ
u'علم رَجُلٌ':Added, #1: 1	عِلْمِ الرَّجُلِ
u'عِلْمٌ رَجُلٌ':Added, #2: 2	عِلْمُ الرَّجُلِ
u'عَلِمَ رَدِيفٌ':Subject, #2: 2	عِلْمُ الرَّجُلِ
u'عَلِمَ رَسُولٌ':Subject, #1: 1	عَلِمَ الرَّدِيفُ
u'عَلِمَ رَسُولٌ':Subject, #4: 4	عَلِمَ الرَّسُولُ
u'عَلَّمَ رَسُولٌ':Subject, #5: 5	عَلِمَ رَسُولُ
u'علم رَسُولٌ':Added, #5: 5	عَلَّمَ رَسُولُ
u'علم رَسُولٌ':Added, #1: 1	عِلْمُ الرَّسُولِ
u'عِلْمٌ رَسُولٌ':Added, #1: 1	عِلْمِ الرَّسُولِ
u'عِلْمٌ رَسُولٌ':Added, #1: 1	عِلْمُ الرَّسُولِ
u'عَلِمَ رُشْدٌ':Predicate, #1: 1	عِلْمِ الرَّسُولِ
u'عَلِمَ رِضاً':Subject, #1: 1	عَلِمَ الرُّشْدَ
u'عَلِمَ رِضاءٌ':Predicate, #4: 4	عَلِمَ رِضَاهُ
u'علم رَمْلٌ':Added, #1: 1	عَلِمَ رِضَاءَ
u'عِلْمٌ رَمْلٌ':Added, #1: 1	عِلْمِ الرَّمْلِ
u'عَلِمَ رَمْيٌ':Predicate, #1: 1	عِلْمِ الرَّمْلِ
u'علم رِوايَةٌ':Added, #3: 3	عَلِمَ الرَّمْيَ
u'عِلْمٌ رِوايَةٌ':Added, #1: 1	عِلْمِ الرِّوَايَةِ
u'علم زُهْدٌ':Added, #1: 1	عِلْمِ الرِّوَايَةِ
u'عِلْمٌ زُهْدٌ':Added, #1: 1	عِلْمِ الزُّهْدِ
u'عَلِمَ زَوْجٌ':Subject, #1: 1	عِلْمِ الزُّهْدِ
u'علم زَوْجٌ':Added, #11: 11	عَلِمَ الزَّوْجُ
u'عِلْمٌ زَوْجٌ':Added, #1: 1	عِلْمُ الزَّوْجَيْنِ
u'علم زَوْجٌ':Added, #1: 1	عِلْمُ الزَّوْجَيْنِ
u'عِلْمٌ زَوْجٌ':Added, #4: 4	عِلْمُ الزَّوْجِ
u'علم زَوْجٌ':Added, #4: 4	عِلْمُ الزَّوْجِ
u'عِلْمٌ زَوْجٌ':Added, #6: 6	عِلْمِ الزَّوْجِ
u'علم زَوْجَةٌ':Added, #6: 6	عِلْمِ الزَّوْجِ
u'عِلْمٌ زَوْجَةٌ':Added, #1: 1	عِلْمِ الزَّوْجَةِ
u'علم زَوْجَةٌ':Added, #1: 1	عِلْمِ الزَّوْجَةِ
u'عِلْمٌ زَوْجَةٌ':Added, #2: 2	عِلْمُ الزَّوْجَةِ
u'عَلِمَ زَيْدٌ':Subject, #2: 2	عِلْمُ الزَّوْجَةِ
u'علم زَيْدٌ':Added, #1: 1	عَلِمَ زَيْدٌ
u'علم زَيْدٌ':Added, #1: 1	عِلْمُ زَيْدِ
u'عِلْمٌ زَيْدٌ':Added, #1: 1	عِلْمِ زَيْدٍ
u'عِلْمٌ زَيْدٌ':Added, #1: 1	عِلْمُ زَيْدِ
u'عَلِمَ سَابِقٌ':Predicate, #1: 1	عِلْمِ زَيْدٍ
u'علم سَابِقٌ':Added, #1: 1	عَلِمَ السَّابِقَ
u'عِلْمٌ سَابِقٌ':Added, #1: 1	عِلْمِ السَّابِقَةِ
u'عَلِمَ سَاعَةٌ':Predicate, #1: 1	عِلْمِ السَّابِقَةِ
u'علم سَاعَةٌ':Added, #1: 1	عَلِمَ السَّاعَةَ
u'علم سَاعَةٌ':Added, #1: 1	عِلْمِ السّاعَةِ
u'عِلْمٌ سَاعَةٌ':Added, #1: 1	عِلْمِ السَّاعَةِ
u'عِلْمٌ سَاعَةٌ':Added, #1: 1	عِلْمِ السّاعَةِ
u'علم سَاعَةٌ':Added, #1: 1	عِلْمِ السَّاعَةِ
u'عِلْمٌ سَاعَةٌ':Added, #2: 2	عِلْمُ السَّاعَةِ
u'عَلِمَ سَالِمٌ':Subject, #2: 2	عِلْمُ السَّاعَةِ
u'عَلَّمَ سائِل':Predicate, #1: 1	عَلِمَ السَّالِمُ
u'عَلَّمَ سَائِلٌ':Predicate, #1: 1	عَلَّمَ السَّائِلَ
u'علم سَبَبٌ':Added, #1: 1	عَلَّمَ السَّائِلَ
u'عِلْمٌ سَبَبٌ':Added, #1: 1	عِلْمِ سَبَبِ
u'عَلِمَ سَبَقٌ':Predicate, #1: 1	عِلْمِ سَبَبِ
u'عَلِمَ سَبْقٌ':Predicate, #1: 1	عَلِمَ السَّبَقَ
u'عَلِمَ سَبْقٌ':Predicate, #2: 2	عَلِمَ السَّبْقَ
u'علم سِحْرٌ':Added, #3: 3	عَلِمَ سَبْقَ
u'عِلْمٌ سِحْرٌ':Added, #1: 1	عِلْمِ السِّحْرِ
u'علم سِحْرٌ':Added, #1: 1	عِلْمِ السِّحْرِ
u'عِلْمٌ سِحْرٌ':Added, #3: 3	عِلْمَ السِّحْرِ
u'عَلِمَ سِرٌّ':Predicate, #3: 3	عِلْمَ السِّحْرِ
u'علم سِرٌّ':Added, #1: 1	عَلِمَ السِّرَّ
u'عِلْمٌ سِرٌّ':Added, #1: 1	عِلْمِ سِرِّ
u'عَلِمَ سَعَةٌ':Predicate, #1: 1	عِلْمِ سِرِّ
u'عَلِمَ سَفَهٌ':Predicate, #1: 1	عَلِمَ السَّعَةَ
u'عَلِمَ سُقُوطٌ':Predicate, #1: 1	أَعْلَمَ السَّفَهَ
u'عَلِمَ سَلاَمَةٌ':Predicate, #1: 1	عَلِمَ سُقُوطَ
u'علم سَلاَمَةٌ':Added, #2: 2	عَلِمَ السَّلَامَةَ
u'عِلْمٌ سَلاَمَةٌ':Added, #5: 5	عِلْمِ السَّلَامَةِ
u'عَلِمَ سُلْطَانٌ':Predicate, #5: 5	عِلْمِ السَّلَامَةِ
u'عَلِمَ سُلْطَانٌ':Subject, #1: 1	أَعْلَمَ السُّلْطَانَ
u'علم سُلْطَانٌ':Added, #1: 1	عَلِمَ السُّلْطَانُ
u'عِلْمٌ سُلْطَانٌ':Added, #2: 2	عِلْمِ السُّلْطَانِ
u'علم سَلَفٌ':Added, #2: 2	عِلْمِ السُّلْطَانِ
u'عِلْمٌ سَلَفٌ':Added, #1: 1	عِلْمِ السَّلَفِ
u'علم سَمَاعٌ':Added, #1: 1	عِلْمِ السَّلَفِ
u'عِلْمٌ سَمَاعٌ':Added, #1: 1	عِلْمِ سَمَاعِ
u'علم سَمَاعٌ':Added, #1: 1	عِلْمِ سَمَاعِ
u'عِلْمٌ سَمَاعٌ':Added, #1: 1	عِلْمِ سَمَاعِهِ
u'عَلِمَ سَهْوٌ':Subject, #1: 1	عِلْمِ سَمَاعِهِ
u'عَلِمَ سُوءٌ':Predicate, #1: 1	عَلِمَ سَهْوٌ
u'عَلَّمَ سُوق':Predicate, #1: 1	عَلِمَ سُوءَ
u'عَلَّمَ سُوقَة':Predicate, #1: 1	عَلَّمَ السُّوقَةَ
u'عَلِمَ سَيِّدٌ':Subject, #1: 1	عَلَّمَ السُّوقَةَ
u'علم سَيِّدٌ':Added, #4: 4	عَلِمَ السَّيِّدُ
u'عِلْمٌ سَيِّدٌ':Added, #1: 1	عِلْمِ السَّيِّدِ
u'علم سَيِّدٌ':Added, #1: 1	عِلْمِ السَّيِّدِ
u'عِلْمٌ سَيِّدٌ':Added, #1: 1	عِلْمِ سَيِّدِهِ
u'علم سَيِّدٌ':Added, #1: 1	عِلْمِ سَيِّدِهِ
u'عِلْمٌ سَيِّدٌ':Added, #2: 2	عِلْمُ السَّيِّدِ
u'عَلِمَ شَارِبٌ':Subject, #2: 2	عِلْمُ السَّيِّدِ
u'عَلِمَ شَارِعٌ':Subject, #2: 2	عَلِمَ الشَّارِبُ
u'علم شَارِعٌ':Added, #1: 1	عَلِمَ الشَّارِعُ
u'عِلْمٌ شَارِعٌ':Added, #1: 1	عِلْمِ الشَّارِعِ
u'علم شافِعِيّ':Added, #1: 1	عِلْمِ الشَّارِعِ
u'علم شافِعِيّ':Added, #1: 1	عِلْمَ الشَّافِعِيِّ
u'عِلْمٌ شافِعِيّ':Added, #1: 1	عِلْمِ الشَّافِعِيِّ
u'عِلْمٌ شافِعِيّ':Added, #1: 1	عِلْمَ الشَّافِعِيِّ
u'عَلِمَ شَاهِدٌ':Subject, #1: 1	عِلْمِ الشَّافِعِيِّ
u'علم شَاهِدٌ':Added, #2: 2	عَلِمَ الشَّاهِدُ
u'عِلْمٌ شَاهِدٌ':Added, #14: 14	عِلْمُ الشَّاهِدِ
u'علم شَاهِدٌ':Added, #14: 14	عِلْمُ الشَّاهِدِ
u'عِلْمٌ شَاهِدٌ':Added, #1: 1	عِلْمَ الشَّاهِدِ
u'علم شَاهِدٌ':Added, #1: 1	عِلْمَ الشَّاهِدِ
u'عِلْمٌ شَاهِدٌ':Added, #8: 8	عِلْمِ الشَّاهِدِ
u'علم شجَاعٌ':Added, #8: 8	عِلْمِ الشَّاهِدِ
u'عِلْمٌ شجَاعٌ':Added, #1: 1	عِلْمُ الشَّجَاعَةِ
u'علم شَجَاعَةٌ':Added, #1: 1	عِلْمُ الشَّجَاعَةِ
u'عِلْمٌ شَجَاعَةٌ':Added, #1: 1	عِلْمُ الشَّجَاعَةِ
u'علم شَخْصٌ':Added, #1: 1	عِلْمُ الشَّجَاعَةِ
u'علم شَخْصٌ':Added, #1: 1	عَلَمُ الشَّخْصِ
u'عَلَمٌ شَخْصٌ':Added, #1: 1	عَلَمِ الشَّخْصِ
u'عَلَمٌ شَخْصٌ':Added, #1: 1	عَلَمُ الشَّخْصِ
u'علم شَخْصٌ':Added, #1: 1	عَلَمِ الشَّخْصِ
u'عَلَمٌ شَخْصٌ':Added, #2: 2	عَلَمَ الشَّخْصِ
u'علم شَخْصٌ':Added, #2: 2	عَلَمَ الشَّخْصِ
u'عَلَمٌ شَخْصٌ':Added, #2: 2	عَلَمَ شَخْصٍ
u'عَلِمَ شِرَاءٌ':Predicate, #2: 2	عَلَمَ شَخْصٍ
u'علم شَرَائِعُ':Added, #1: 1	عَلِمَ الشِّرَاءَ
u'عِلْمٌ شَرَائِعُ':Added, #1: 1	عِلْمَ الشَّرَائِعِ
u'علم شَرَائِعُ':Added, #1: 1	عِلْمَ الشَّرَائِعِ
u'عِلْمٌ شَرَائِعُ':Added, #1: 1	عِلْمَ شَرَائِعِهِ
u'علم شَرَائِعُ':Added, #1: 1	عِلْمَ شَرَائِعِهِ
u'عِلْمٌ شَرَائِعُ':Added, #2: 2	عِلْمِ الشَّرَائِعِ
u'عَلِمَ شَرْطٌ':Predicate, #2: 2	عِلْمِ الشَّرَائِعِ
u'علم شَرْطٌ':Added, #1: 1	عَلِمَ شَرْطَ
u'عِلْمٌ شَرْطٌ':Added, #1: 1	عِلْمَ شَرْطِ
u'علم شَرْعِيٌّ':Added, #1: 1	عِلْمَ شَرْطِ
u'عِلْمٌ شَرْعِيٌّ':Added, #3: 3	عِلْمٍ شَرْعِيٍّ
u'عَلِمَ شُرُوطٌ':Predicate, #3: 3	عِلْمٍ شَرْعِيٍّ
u'علم شَرِيعَةٌ':Added, #1: 1	عَلِمَ شُرُوطَ
u'عِلْمٌ شَرِيعَةٌ':Added, #1: 1	عِلْمُ الشَّرِيعَةِ
u'علم شَرِيعَةٌ':Added, #1: 1	عِلْمُ الشَّرِيعَةِ
u'عِلْمٌ شَرِيعَةٌ':Added, #6: 6	عِلْمِ الشَّرِيعَةِ
u'عَلِمَ شَرِيكٌ':Subject, #6: 6	عِلْمِ الشَّرِيعَةِ
u'عَلِمَ شَرِيكٌ':Subject, #3: 3	عَلِمَ الشَّرِيكُ
u'علم شِعْرٌ':Added, #3: 3	عَلِمَ شَرِيكُهُ
u'عِلْمٌ شِعْرٌ':Added, #1: 1	عِلْمِ الشِّعْرِ
u'عَلِمَ شَفِيعٌ':Subject, #1: 1	عِلْمِ الشِّعْرِ
u'عَلِمَ شَفِيعٌ':Subject, #13: 13	عَلِمَ الشَّفِيعُ
u'علم شَفِيعٌ':Added, #1: 1	عَلِمَ شَفِيعُهُ
u'عِلْمٌ شَفِيعٌ':Added, #5: 5	عِلْمِ الشَّفِيعِ
u'عَلِمَ شُهُودٌ':Subject, #5: 5	عِلْمِ الشَّفِيعِ
u'علم شُهُودٌ':Added, #5: 5	عَلِمَ الشُّهُودُ
u'عِلْمٌ شُهُودٌ':Added, #1: 1	عِلْمِ الشُّهُودِ
u'علم شُهُودٌ':Added, #1: 1	عِلْمِ الشُّهُودِ
u'علم شُهُودٌ':Added, #2: 2	عِلْمَ الشُّهُودِ
u'عِلْمٌ شُهُودٌ':Added, #2: 2	عِلْمُ الشُّهُودِ
u'عِلْمٌ شُهُودٌ':Added, #2: 2	عِلْمَ الشُّهُودِ
u'علم شَيْءٌ':Added, #2: 2	عِلْمُ الشُّهُودِ
u'عِلْمٌ شَيْءٌ':Added, #1: 1	عِلْمِ الشّيْءِ
u'عَلِمَ صَاحِبٌ':Predicate, #1: 1	عِلْمِ الشّيْءِ
u'عَلِمَ صَاحِبٌ':Predicate, #1: 1	عَلِمَ صَاحِبَ
u'عَلِمَ صَاحِبٌ':Subject, #2: 2	أَعْلَمَ صَاحِبَ
u'عَلِمَ صَاحِبٌ':Subject, #4: 4	عَلِمَ صَاحِبُهُ
u'علم صَاحِبٌ':Added, #6: 6	عَلِمَ صَاحِبُ
u'علم صَاحِبٌ':Added, #1: 1	عِلْمُ صَاحِبِ
u'عِلْمٌ صَاحِبٌ':Added, #1: 1	عِلْمِ صَاحِبِ
u'عِلْمٌ صَاحِبٌ':Added, #1: 1	عِلْمُ صَاحِبِ
u'علم صَاحِبٌ':Added, #1: 1	عِلْمِ صَاحِبِ
u'عِلْمٌ صَاحِبٌ':Added, #4: 4	عِلْمِ صَاحِبِهِ
u'عَلَّمَ صِبْيَانٌ':Predicate, #4: 4	عِلْمِ صَاحِبِهِ
u'علم صَحَابَةٌ':Added, #1: 1	عَلَّمَ الصِّبْيَانَ
u'عِلْمٌ صَحَابَةٌ':Added, #3: 3	عِلْمِ الصَّحَابَةِ
u'عَلِمَ صِحَّةٌ':Predicate, #3: 3	عِلْمِ الصَّحَابَةِ
u'عَلِمَ صدق':Predicate, #2: 2	عَلِمَ صِحَّةَ
u'عَلِمَ صِدْقٌ':Predicate, #1: 1	أَعْلَمَ صِدْقَ
u'عَلِمَ صدق':Predicate, #1: 1	أَعْلَمَ صِدْقَ
u'عَلِمَ صِدْقٌ':Predicate, #2: 2	عَلِمَ صِدْقَ
u'علم صَلاَةٌ':Added, #2: 2	عَلِمَ صِدْقَ
u'عِلْمٌ صَلاَةٌ':Added, #2: 2	عِلْمِ الصَّلَاةِ
u'عَلِمَ صُنَّاعٌ':Subject, #2: 2	عِلْمِ الصَّلَاةِ
u'عَلَّمَ صنعة':Predicate, #1: 1	عَلِمَ الصُّنَّاعُ
u'عَلَّمَ صَنْعَةٌ':Predicate, #1: 1	عَلَّمَ صَنْعَةَ
u'عَلِمَ صِيَانَةٌ':Predicate, #1: 1	عَلَّمَ صَنْعَةَ
u'علم صَيْدٌ':Added, #1: 1	عَلِمَ صِيَانَةَ
u'عِلْمٌ صَيْدٌ':Added, #1: 1	عِلْمَ الصَّيْدِ
u'عَلِمَ ضَابِطٌ':Predicate, #1: 1	عِلْمَ الصَّيْدِ
u'عَلِمَ ضَارِبٌ':Predicate, #1: 1	عَلِمَ ضَابِطَ
u'عَلِمَ ضَارِبٌ':Subject, #1: 1	عَلِمَ الضَّارِبَ
u'عَلِمَ ضَرَبٌ':Predicate, #1: 1	عَلِمَ الضَّارِبُ
u'علم ضَرُورَةٌ':Added, #1: 1	عَلِمَ ضَرَبَ
u'عِلْمٌ ضَرُورَةٌ':Added, #1: 1	عِلْمَ الضَّرُورَةِ
u'علم ضَرُورِيٌّ':Added, #1: 1	عِلْمَ الضَّرُورَةِ
u'عِلْمٌ ضَرُورِيٌّ':Added, #1: 1	عِلْمُ ضَرُورِيَّتِهِ
u'علم ضَرُورِيٌّ':Added, #1: 1	عِلْمُ ضَرُورِيَّتِهِ
u'عِلْمٌ ضَرُورِيٌّ':Added, #7: 7	عِلْمٍ ضَرُورِيٍّ
u'عَلِمَ ضَمِنٌ':Predicate, #7: 7	عِلْمٍ ضَرُورِيٍّ
u'عَلِمَ ضِيقٌ':Predicate, #3: 3	عَلِمَ ضَمِنَ
u'علم طَالِبٌ':Added, #1: 1	عَلِمَ ضِيقَ
u'عِلْمٌ طَالِبٌ':Added, #1: 1	عِلْمُ الطَّالِبِ
u'علم طِبٌّ':Added, #1: 1	عِلْمُ الطَّالِبِ
u'عِلْمٌ طِبٌّ':Added, #2: 2	عِلْمَ الطِّبِّ
u'علم طِبٌّ':Added, #2: 2	عِلْمَ الطِّبِّ
u'عِلْمٌ طِبٌّ':Added, #4: 4	عِلْمِ الطِّبِّ
u'عَلِمَ طَرِيقٌ':Predicate, #4: 4	عِلْمِ الطِّبِّ
u'علم طُمَأْنِينَةٌ':Added, #1: 1	عَلِمَ طَرِيقَ
u'عِلْمٌ طُمَأْنِينَةٌ':Added, #1: 1	عِلْمَ الطُّمَأْنِينَةِ
u'علم طُمَأْنِينَةٌ':Added, #1: 1	عِلْمَ الطُّمَأْنِينَةِ
u'عِلْمٌ طُمَأْنِينَةٌ':Added, #2: 2	عِلْمَ طُمَأْنِينَةٍ
u'علم طَهَارَةٌ':Added, #2: 2	عِلْمَ طُمَأْنِينَةٍ
u'علم طَهَارَةٌ':Added, #1: 1	عِلْمَ الطَّهَارَةِ
u'عِلْمٌ طَهَارَةٌ':Added, #1: 1	عِلْمِ الطَّهَارَةِ
u'عِلْمٌ طَهَارَةٌ':Added, #1: 1	عِلْمَ الطَّهَارَةِ
u'عَلِمَ طُولٌ':Predicate, #1: 1	عِلْمِ الطَّهَارَةِ
u'علم ظاهِرٌ':Added, #1: 1	عَلِمَ طُولَ
u'علم ظاهِرٌ':Added, #1: 1	عِلْمَ الظَّاهِرِ
u'عِلْمٌ ظاهِرٌ':Added, #1: 1	عِلْمِ الظَّاهِرِ
u'عِلْمٌ ظاهِرٌ':Added, #1: 1	عِلْمَ الظَّاهِرِ
u'عَلِمَ ظُلْمٌ':Predicate, #1: 1	عِلْمِ الظَّاهِرِ
u'علم عَاقِبٌ':Added, #4: 4	عَلِمَ ظُلْمَ
u'عِلْمٌ عَاقِبٌ':Added, #1: 1	عِلْمِ الْعَاقِبَةِ
u'علم عَاقِبَةٌ':Added, #1: 1	عِلْمِ الْعَاقِبَةِ
u'عِلْمٌ عَاقِبَةٌ':Added, #1: 1	عِلْمِ الْعَاقِبَةِ
u'عَلِمَ عَاقِدٌ':Subject, #1: 1	عِلْمِ الْعَاقِبَةِ
u'علم عَاقِدٌ':Added, #1: 1	عَلِمَ الْعَاقِدُ
u'عِلْمٌ عَاقِدٌ':Added, #1: 1	عِلْمِ الْعَاقِدَيْنِ
u'علم عَاقِدٌ':Added, #1: 1	عِلْمِ الْعَاقِدَيْنِ
u'عِلْمٌ عَاقِدٌ':Added, #2: 2	عِلْمُ الْعَاقِدَيْنِ
u'علم عَالِمٌ':Added, #2: 2	عِلْمُ الْعَاقِدَيْنِ
u'عِلْمٌ عَالِمٌ':Added, #1: 1	عِلْمُ الْعَالِمِ
u'عَلِمَ عَامِلٌ':Subject, #1: 1	عِلْمُ الْعَالِمِ
u'عَلَّمَ عَبْدٌ':Predicate, #1: 1	عَلِمَ الْعَامِلُ
u'عَلَّمَ عَبْدٌ':Predicate, #1: 1	عَلَّمَ الْعَبْدَ
u'عَلِمَ عَبْدٌ':Subject, #1: 1	عَلَّمَ عَبْدَ
u'علم عَبْدٌ':Added, #13: 13	عَلِمَ الْعَبْدُ
u'علم عَبْدٌ':Added, #5: 5	عِلْمُ الْعَبْدِ
u'عِلْمٌ عَبْدٌ':Added, #5: 5	عِلْمِ الْعَبْدِ
u'عِلْمٌ عَبْدٌ':Added, #5: 5	عِلْمُ الْعَبْدِ
u'عَلِمَ عجز':Predicate, #5: 5	عِلْمِ الْعَبْدِ
u'عَلِمَ عَجْزٌ':Predicate, #2: 2	عَلِمَ عَجْزَ
u'عَلِمَ عَدَدٌ':Predicate, #2: 2	عَلِمَ عَجْزَ
u'عَلِمَ عَدَدٌ':Predicate, #1: 1	عَلِمَ عَدَدَهُنَّ
u'عَلِمَ عَدَدٌ':Predicate, #2: 2	عَلِمَ الْعَدَدَ
u'عَلِمَ عَدَمٌ':Predicate, #2: 2	عَلِمَ عَدَدَ
u'عَلِمَ عَدَمٌ':Predicate, #10: 10	عَلِمَ عَدَمَ
u'علم عَدَمٌ':Added, #1: 1	عَلِمَ الْعَدَمَ
u'عِلْمٌ عَدَمٌ':Added, #1: 1	عِلْمَ عَدَمِ
u'علم عَدَمٌ':Added, #1: 1	عِلْمَ عَدَمِ
u'عِلْمٌ عَدَمٌ':Added, #2: 2	عِلْمِ عَدَمِ
u'علم عَرَبِيٌّ':Added, #2: 2	عِلْمِ عَدَمِ
u'عِلْمٌ عَرَبِيٌّ':Added, #10: 10	عِلْمِ الْعَرَبِيَّةِ
u'علم عَرُوضٌ':Added, #10: 10	عِلْمِ الْعَرَبِيَّةِ
u'عِلْمٌ عَرُوضٌ':Added, #1: 1	عِلْمِ الْعَرُوضِ
u'عَلِمَ عزل':Predicate, #1: 1	عِلْمِ الْعَرُوضِ
u'علم عَقْدٌ':Added, #2: 2	عَلِمَ الْعَزْلَ
u'عِلْمٌ عَقْدٌ':Added, #1: 1	عِلْمِ الْعَقْدِ
u'عَلِمَ عُقُوبَةٌ':Predicate, #1: 1	عِلْمِ الْعَقْدِ
u'عَلِمَ علماء':Predicate, #1: 1	عَلِمَ عُقُوبَةَ
u'عَلِمَ عُلَمَاءُ':Predicate, #1: 1	أَعْلَمَ الْعُلَمَاءَ
u'عَلِمَ علماء':Subject, #1: 1	أَعْلَمَ الْعُلَمَاءَ
u'عَلِمَ عُلَمَاءُ':Subject, #1: 1	عَلِمَ الْعُلَمَاءُ
u'علم علماء':Added, #1: 1	عَلِمَ الْعُلَمَاءُ
u'عِلْمٌ علماء':Added, #1: 1	عِلْمُ عُلَمَاءِ
u'علم عُلَمَاءُ':Added, #1: 1	عِلْمُ عُلَمَاءِ
u'عِلْمٌ عُلَمَاءُ':Added, #1: 1	عِلْمُ عُلَمَاءِ
u'عَلِمَ عُمَرٌ':Subject, #1: 1	عِلْمُ عُلَمَاءِ
u'علم عَمَلٌ':Added, #4: 4	عَلِمَ عُمَرُ
u'علم عَمَلٌ':Added, #1: 1	عِلْمُ عَمَلِهِ
u'عِلْمٌ عَمَلٌ':Added, #1: 1	عِلْمِ عَمَلِهِ
u'عِلْمٌ عَمَلٌ':Added, #1: 1	عِلْمُ عَمَلِهِ
u'عَلِمَ عند':Predicate, #1: 1	عِلْمِ عَمَلِهِ
u'علم عند':Added, #1: 1	عَلِمَ عِنْدَ
u'عِلْمٌ عند':Added, #3: 3	عِلْمَ عِنْدِهِ
u'عَلِمَ عَيْبٌ':Predicate, #3: 3	عِلْمَ عِنْدِهِ
u'عَلِمَ عَيْبٌ':Predicate, #1: 1	عَلِمَ عَيْبَ
u'عَلِمَ عين':Predicate, #9: 9	عَلِمَ الْعَيْبَ
u'عَلِمَ عَيْنٌ':Predicate, #1: 1	عَلِمَ عَيْنَ
u'عَلِمَ عَيْن':Predicate, #1: 1	عَلِمَ عَيْنَ
u'عَلِمَ غَاصِبٌ':Subject, #1: 1	عَلِمَ عَيْنَ
u'علم غَالِبٌ':Added, #1: 1	عَلِمَ الْغَاصِبُ
u'علم غَالِبٌ':Added, #2: 2	عِلْمَ غَالِبِ
u'عِلْمٌ غَالِبٌ':Added, #2: 2	عِلْمُ غَالِبِ
u'عِلْمٌ غَالِبٌ':Added, #2: 2	عِلْمَ غَالِبِ
u'عَلِمَ غَائِبٌ':Subject, #2: 2	عِلْمُ غَالِبِ
u'عَلِمَ غَرَضٌ':Predicate, #3: 3	عَلِمَ الْغَائِبُ
u'عَلِمَ غرماء':Subject, #1: 1	عَلِمَ غَرَضَ
u'علم غَرِيمٌ':Added, #1: 1	عَلِمَ الْغُرَمَاءُ
u'عِلْمٌ غَرِيمٌ':Added, #1: 1	عِلْمُ الْغَرِيمَيْنِ
u'عَلِمَ غَلَطٌ':Predicate, #1: 1	عِلْمُ الْغَرِيمَيْنِ
u'علم غيب':Added, #1: 1	عَلِمَ الْغَلَطَ
u'علم غَيْبٌ':Added, #11: 11	عِلْمِ الْغَيْبِ
u'عِلْمٌ غيب':Added, #11: 11	عِلْمِ الْغَيْبِ
u'عِلْمٌ غَيْبٌ':Added, #11: 11	عِلْمِ الْغَيْبِ
u'علم غيب':Added, #11: 11	عِلْمِ الْغَيْبِ
u'علم غيب':Added, #2: 2	عِلْمَ الْغَيْبِ
u'علم غَيْبٌ':Added, #2: 2	عِلْمُ الْغَيْبِ
u'علم غَيْبٌ':Added, #2: 2	عِلْمَ الْغَيْبِ
u'عِلْمٌ غيب':Added, #2: 2	عِلْمُ الْغَيْبِ
u'عِلْمٌ غيب':Added, #2: 2	عِلْمَ الْغَيْبِ
u'عِلْمٌ غَيْبٌ':Added, #2: 2	عِلْمُ الْغَيْبِ
u'عِلْمٌ غَيْبٌ':Added, #2: 2	عِلْمَ الْغَيْبِ
u'عَلَّمَ غير':Subject, #2: 2	عِلْمُ الْغَيْبِ
u'عَلَّمَ غَيْرٌ':Subject, #2: 2	عَلَّمَ غَيْرُهُ
u'علم غير':Added, #2: 2	عَلَّمَ غَيْرُهُ
u'علم غَيْرٌ':Added, #1: 1	عِلْمِ الْغَيْرِ
u'عِلْمٌ غير':Added, #1: 1	عِلْمِ الْغَيْرِ
u'عِلْمٌ غَيْرٌ':Added, #1: 1	عِلْمِ الْغَيْرِ
u'علم غير':Added, #1: 1	عِلْمِ الْغَيْرِ
u'علم غير':Added, #1: 1	عِلْمَ غَيْرِ
u'علم غير':Added, #1: 1	عِلْمُ غَيْرِ
u'علم غَيْرٌ':Added, #1: 1	عِلْمِ غَيْرِ
u'علم غَيْرٌ':Added, #1: 1	عِلْمَ غَيْرِ
u'علم غَيْرٌ':Added, #1: 1	عِلْمُ غَيْرِ
u'عِلْمٌ غير':Added, #1: 1	عِلْمِ غَيْرِ
u'عِلْمٌ غير':Added, #1: 1	عِلْمَ غَيْرِ
u'عِلْمٌ غير':Added, #1: 1	عِلْمُ غَيْرِ
u'عِلْمٌ غَيْرٌ':Added, #1: 1	عِلْمِ غَيْرِ
u'عِلْمٌ غَيْرٌ':Added, #1: 1	عِلْمَ غَيْرِ
u'عِلْمٌ غَيْرٌ':Added, #1: 1	عِلْمُ غَيْرِ
u'علم غير':Added, #1: 1	عِلْمِ غَيْرِ
u'علم غَيْرٌ':Added, #3: 3	عِلْمِ غَيْرِهِ
u'عِلْمٌ غير':Added, #3: 3	عِلْمِ غَيْرِهِ
u'عِلْمٌ غَيْرٌ':Added, #3: 3	عِلْمِ غَيْرِهِ
u'علم غُيُوبٌ':Added, #3: 3	عِلْمِ غَيْرِهِ
u'عِلْمٌ غُيُوبٌ':Added, #1: 1	عِلْمِ الْغُيُوبِ
u'عَلِمَ فَاعِلٌ':Subject, #1: 1	عِلْمِ الْغُيُوبِ
u'علم فِرَاقٌ':Added, #1: 1	عَلِمَ فَاعِلُهُ
u'عِلْمٌ فِرَاقٌ':Added, #1: 1	عِلْمِ الْفِرَاقِ
u'عَلِمَ فَرَائِضُ':Predicate, #1: 1	عِلْمِ الْفِرَاقِ
u'علم فَرَائِضُ':Added, #1: 1	عَلِمَ الْفَرَائِضَ
u'عِلْمٌ فَرَائِضُ':Added, #1: 1	عِلْمَ الْفَرَائِضِ
u'علم فَرَائِضُ':Added, #1: 1	عِلْمَ الْفَرَائِضِ
u'عِلْمٌ فَرَائِضُ':Added, #2: 2	عِلْمُ الْفَرَائِضِ
u'علم فَرَائِضُ':Added, #2: 2	عِلْمُ الْفَرَائِضِ
u'عِلْمٌ فَرَائِضُ':Added, #5: 5	عِلْمِ الْفَرَائِضِ
u'علم فَرْضٌ':Added, #5: 5	عِلْمِ الْفَرَائِضِ
u'عِلْمٌ فَرْضٌ':Added, #1: 1	عِلْمَ فَرْضِ
u'عَلِمَ فرق':Predicate, #1: 1	عِلْمَ فَرْضِ
u'عَلِمَ فَرْقٌ':Predicate, #2: 2	عَلِمَ الْفَرْقَ
u'علم فُرُوعٌ':Added, #2: 2	عَلِمَ الْفَرْقَ
u'عِلْمٌ فُرُوعٌ':Added, #1: 1	عِلْمِ الْفُرُوعِ
u'عَلِمَ فساد':Predicate, #1: 1	عِلْمِ الْفُرُوعِ
u'عَلِمَ فَسَادٌ':Predicate, #4: 4	عَلِمَ الْفَسَادَ
u'عَلِمَ فساد':Predicate, #4: 4	عَلِمَ الْفَسَادَ
u'عَلِمَ فَسَادٌ':Predicate, #6: 6	عَلِمَ فَسَادَ
u'عَلِمَ فِسْقٌ':Predicate, #6: 6	عَلِمَ فَسَادَ
u'علم فِقْهٌ':Added, #3: 3	عَلِمَ فِسْقَ
u'عِلْمٌ فِقْهٌ':Added, #1: 1	عِلْمَ الْفِقْهِ
u'علم فِقْهٌ':Added, #1: 1	عِلْمَ الْفِقْهِ
u'عِلْمٌ فِقْهٌ':Added, #7: 7	عِلْمُ الْفِقْهِ
u'علم فِقْهٌ':Added, #7: 7	عِلْمُ الْفِقْهِ
u'عِلْمٌ فِقْهٌ':Added, #8: 8	عِلْمِ الْفِقْهِ
u'عَلِمَ فَقِيرٌ':Predicate, #8: 8	عِلْمِ الْفِقْهِ
u'عَلِمَ فَقِيرٌ':Subject, #1: 1	أَعْلَمَ الْفَقِيرَ
u'عَلَّمَ فلان':Predicate, #2: 2	عَلِمَ الْفَقِيرُ
u'عَلَّمَ فلان':Predicate, #1: 1	عَلَّمَ السُّوقَةَ
u'عَلِمَ فلان':Predicate, #1: 1	عَلَّمَ بِلاَلاً
u'عَلِمَ فلان':Subject, #2: 2	أَعْلَمَ عُثْمَانَ
u'عَلِمَ فُلاَنٌ':Subject, #1: 1	عَلِمَ الْمُتَصَدِّقُ
u'علم فلان':Added, #1: 1	عَلِمَ فُلَانٌ
u'علم فلان':Added, #1: 1	عِلْمَ الشَّافِعِيِّ
u'عِلْمٌ فلان':Added, #1: 1	عِلْمِ الشَّافِعِيِّ
u'عِلْمٌ فلان':Added, #1: 1	عِلْمَ الشَّافِعِيِّ
u'علم فُلاَنٌ':Added, #1: 1	عِلْمِ الشَّافِعِيِّ
u'عِلْمٌ فُلاَنٌ':Added, #6: 6	عِلْمِ فُلَانٍ
u'عَلِمَ فَوَاتٌ':Predicate, #6: 6	عِلْمِ فُلَانٍ
u'عَلِمَ فَوْرٌ':Predicate, #1: 1	عَلِمَ الْفَوَاتَ
u'علم قَابِضٌ':Added, #1: 1	عَلِمَ الْفَوْرَ
u'عِلْمٌ قَابِضٌ':Added, #1: 1	عِلْمِ الْقَابِضِ
u'علم قَاصِرٌ':Added, #1: 1	عِلْمِ الْقَابِضِ
u'عِلْمٌ قَاصِرٌ':Added, #1: 1	عِلْمٍ قَاصِرٍ
u'عَلِمَ قَاضِي':Predicate, #1: 1	عِلْمٍ قَاصِرٍ
u'عَلِمَ قَاطِعٌ':Subject, #1: 1	أَعْلَمَ الْقَاضِيَ
u'عَلِمَ قَالٌ':Predicate, #1: 1	عَلِمَ الْقَاطِعُ
u'عَلِمَ قَائِدٌ':Subject, #2: 2	عَلِمَ قَالَ
u'عَلَّمَ قَبْرٌ':Predicate, #2: 2	عَلِمَ الْقَائِدُ
u'عَلِمَ قتل':Predicate, #1: 1	عَلَّمَ قَبْرَ
u'عَلِمَ قَتْلٌ':Predicate, #1: 1	عَلِمَ قَتْلَ
u'عَلِمَ قَدْرٌ':Predicate, #1: 1	عَلِمَ قَتْلَ
u'علم قَدْرٌ':Added, #4: 4	عَلِمَ قَدْرَ
u'عِلْمٌ قَدْرٌ':Added, #1: 1	عِلْمُ قَدْرِ
u'علم قَدْرٌ':Added, #1: 1	عِلْمُ قَدْرِ
u'عِلْمٌ قَدْرٌ':Added, #4: 4	عِلْمُ قَدْرِهِ
u'علم قُدُومٌ':Added, #4: 4	عِلْمُ قَدْرِهِ
u'عِلْمٌ قُدُومٌ':Added, #1: 1	عِلْمَ قُدُومِهِ
u'علم قِرَاءةٌ':Added, #1: 1	عِلْمَ قُدُومِهِ
u'عِلْمٌ قِرَاءةٌ':Added, #1: 1	عِلْمَ الْقِرَاءَاتِ
u'عَلَّمَ قُرْآنٌ':Predicate, #1: 1	عِلْمَ الْقِرَاءَاتِ
u'علم قُرْآنٌ':Added, #1: 1	عَلَّمَ الْقُرْآنَ
u'علم قُرْآنٌ':Added, #1: 1	عِلْمُ الْقُرْآنِ
u'عِلْمٌ قُرْآنٌ':Added, #1: 1	عِلْمِ الْقُرْآنِ
u'عِلْمٌ قُرْآنٌ':Added, #1: 1	عِلْمُ الْقُرْآنِ
u'عَلِمَ قَصَرٌ':Predicate, #1: 1	عِلْمِ الْقُرْآنِ
u'علم قَضَاءٌ':Added, #1: 1	عَلِمَ قَصَرَ
u'عِلْمٌ قَضَاءٌ':Added, #3: 3	عِلْمُ الْقَضَاءِ
u'علم قضاة':Added, #3: 3	عِلْمُ الْقَضَاءِ
u'عِلْمٌ قضاة':Added, #1: 1	عِلْمَ قُضَاةِ
u'علم قلب':Added, #1: 1	عِلْمَ قُضَاةِ
u'علم قلب':Added, #1: 1	عِلْمُ الْقَلْبِ
u'عِلْمٌ قلب':Added, #1: 1	عِلْمِ الْقَلْبِ
u'عِلْمٌ قلب':Added, #1: 1	عِلْمُ الْقَلْبِ
u'علم قَلْبٌ':Added, #1: 1	عِلْمِ الْقَلْبِ
u'علم قَلْبٌ':Added, #1: 1	عِلْمُ الْقَلْبِ
u'علم قَلْب':Added, #1: 1	عِلْمِ الْقَلْبِ
u'علم قَلْب':Added, #1: 1	عِلْمُ الْقَلْبِ
u'عِلْمٌ قَلْبٌ':Added, #1: 1	عِلْمِ الْقَلْبِ
u'عِلْمٌ قَلْبٌ':Added, #1: 1	عِلْمُ الْقَلْبِ
u'عِلْمٌ قَلْب':Added, #1: 1	عِلْمِ الْقَلْبِ
u'عِلْمٌ قَلْب':Added, #1: 1	عِلْمُ الْقَلْبِ
u'عَلِمَ قيام':Predicate, #1: 1	عِلْمِ الْقَلْبِ
u'عَلِمَ قِيَامٌ':Predicate, #2: 2	عَلِمَ قِيَامَ
u'عَلِمَ قِيمَةٌ':Predicate, #2: 2	عَلِمَ قِيَامَ
u'علم قِيمَةٌ':Added, #1: 1	عَلِمَ قِيمَةَ
u'عِلْمٌ قِيمَةٌ':Added, #2: 2	عِلْمُ قِيمَتِهِ
u'علم كَافِرٌ':Added, #2: 2	عِلْمُ قِيمَتِهِ
u'عِلْمٌ كَافِرٌ':Added, #1: 1	عِلْمُ الْكَافِرِ
u'علم كِتَابٌ':Added, #1: 1	عِلْمُ الْكَافِرِ
u'عِلْمٌ كِتَابٌ':Added, #10: 10	عِلْمُ الْكِتَابِ
u'علم كِتَابٌ':Added, #10: 10	عِلْمُ الْكِتَابِ
u'علم كِتَابٌ':Added, #1: 1	عِلْمَ الْكِتَابِ
u'عِلْمٌ كِتَابٌ':Added, #1: 1	عِلْمِ الْكِتَابِ
u'عِلْمٌ كِتَابٌ':Added, #1: 1	عِلْمَ الْكِتَابِ
u'عَلَّمَ كِتَابَةٌ':Predicate, #1: 1	عِلْمِ الْكِتَابِ
u'عَلِمَ كذب':Predicate, #1: 1	عَلَّمَ الْكِتَابَةَ
u'عَلِمَ كَذِبٌ':Predicate, #2: 2	عَلِمَ كَذِبَ
u'علم كَسْبٌ':Added, #2: 2	عَلِمَ كَذِبَ
u'عِلْمٌ كَسْبٌ':Added, #1: 1	عِلْمَ الْكَسْبِ
u'عَلِمَ كفر':Predicate, #1: 1	عِلْمَ الْكَسْبِ
u'عَلِمَ كُفْرٌ':Predicate, #1: 1	عَلِمَ الْكُفْرَ
u'عَلِمَ كَفِيلٌ':Subject, #1: 1	عَلِمَ الْكُفْرَ
u'علم كَلاَمٌ':Added, #1: 1	عَلِمَ الْكَفِيلُ
u'عِلْمٌ كَلاَمٌ':Added, #13: 13	عِلْمُ الْكَلَامِ
u'علم كَلاَمٌ':Added, #13: 13	عِلْمُ الْكَلَامِ
u'عِلْمٌ كَلاَمٌ':Added, #34: 34	عِلْمِ الْكَلَامِ
u'علم كَلاَمٌ':Added, #34: 34	عِلْمِ الْكَلَامِ
u'عِلْمٌ كَلاَمٌ':Added, #5: 5	عِلْمَ الْكَلَامِ
u'علم كُورَةٌ':Added, #5: 5	عِلْمَ الْكَلَامِ
u'علم كُورَةٌ':Added, #1: 1	عِلْمِ كُورَةٍ
u'عِلْمٌ كُورَةٌ':Added, #1: 1	عِلْمِ كُورَةِ
u'عِلْمٌ كُورَةٌ':Added, #1: 1	عِلْمِ كُورَةٍ
u'عَلِمَ كَوْنٌ':Predicate, #1: 1	عِلْمِ كُورَةِ
u'علم كِيمْيَاءُ':Added, #1: 1	عَلِمَ كَوْنَ
u'عِلْمٌ كِيمْيَاءُ':Added, #2: 2	عِلْمِ الْكِيمْيَاءِ
u'علم لِسَانٌ':Added, #2: 2	عِلْمِ الْكِيمْيَاءِ
u'عِلْمٌ لِسَانٌ':Added, #1: 1	عِلْمِ اللِّسَانِ
u'عَلِمَ لُصُوصٌ':Predicate, #1: 1	عِلْمِ اللِّسَانِ
u'علم لُغَةٌ':Added, #2: 2	أَعْلَمَ اللُّصُوصَ
u'علم لُغَةٌ':Added, #1: 1	عِلْمُ اللُّغَةِ
u'عِلْمٌ لُغَةٌ':Added, #1: 1	عِلْمِ اللُّغَةِ
u'عِلْمٌ لُغَةٌ':Added, #1: 1	عِلْمُ اللُّغَةِ
u'عَلِمَ مَاءٌ':Predicate, #1: 1	عِلْمِ اللُّغَةِ
u'عَلِمَ مَارٌّ':Subject, #2: 2	عَلِمَ الْمَاءَ
u'علم مَارٌّ':Added, #4: 4	عَلِمَ الْمَارُّ
u'عِلْمٌ مَارٌّ':Added, #1: 1	عِلْمِ الْمَارِّ
u'عَلِمَ مَالٌ':Predicate, #1: 1	عِلْمِ الْمَارِّ
u'علم مَالٌ':Added, #1: 1	عَلِمَ مَالَ
u'عِلْمٌ مَالٌ':Added, #2: 2	عِلْمُ الْمَالِ
u'عَلِمَ مَالِكٌ':Subject, #2: 2	عِلْمُ الْمَالِ
u'علم مَالِكٌ':Added, #6: 6	عَلِمَ الْمَالِكُ
u'عِلْمٌ مَالِكٌ':Added, #1: 1	عِلْمِ مَالِكٍ
u'علم مَالِكٌ':Added, #1: 1	عِلْمِ مَالِكٍ
u'عِلْمٌ مَالِكٌ':Added, #5: 5	عِلْمِ الْمَالِكِ
u'عَلِمَ مَأْمُورٌ':Subject, #5: 5	عِلْمِ الْمَالِكِ
u'علم مَأْمُورٌ':Added, #2: 2	عَلِمَ الْمَأْمُورُ
u'عِلْمٌ مَأْمُورٌ':Added, #1: 1	عِلْمَ الْمَأْمُورِ
u'علم مَأْمُورٌ':Added, #1: 1	عِلْمَ الْمَأْمُورِ
u'عِلْمٌ مَأْمُورٌ':Added, #3: 3	عِلْمِ الْمَأْمُورِ
u'علم مُبَاشِرٌ':Added, #3: 3	عِلْمِ الْمَأْمُورِ
u'عِلْمٌ مُبَاشِرٌ':Added, #1: 1	عِلْمُ الْمُبَاشِرِ
u'عَلِمَ مُبْتَدِعٌ':Subject, #1: 1	عِلْمُ الْمُبَاشِرِ
u'عَلِمَ مَبْلَغٌ':Predicate, #1: 1	عَلِمَ الْمُبْتَدِعُ
u'علم مُتَأَخِّرٌ':Added, #3: 3	عَلِمَ مَبْلَغَ
u'عِلْمٌ مُتَأَخِّرٌ':Added, #1: 1	عِلْمِ الْمُتَأَخِّرِ
u'عَلِمَ مُتَحَيِّزٌ':Subject, #1: 1	عِلْمِ الْمُتَأَخِّرِ
u'علم مُتَداعِي':Added, #1: 1	عَلِمَ الْمُتَحَيِّزُ
u'عِلْمٌ مُتَداعِي':Added, #1: 1	عِلْمُ الْمُتَدَاعِيَيْنِ
u'عَلِمَ مُتَزَوِّجٌ':Subject, #1: 1	عِلْمُ الْمُتَدَاعِيَيْنِ
u'علم مُتَشَابِهٌ':Added, #1: 1	عَلِمَ الْمُتَزَوِّجُ
u'عِلْمٌ مُتَشَابِهٌ':Added, #1: 1	عِلْمِ الْمُتَشَابِهِ
u'عَلِمَ مُتَصَدِّق':Subject, #1: 1	عِلْمِ الْمُتَشَابِهِ
u'علم مُتَعَاقِدٌ':Added, #1: 1	عَلِمَ الْمُتَصَدِّقُ
u'عِلْمٌ مُتَعَاقِدٌ':Added, #1: 1	عِلْمَ الْمُتَعَاقِدَيْنِ
u'علم مُتَعَاقِدٌ':Added, #1: 1	عِلْمَ الْمُتَعَاقِدَيْنِ
u'عِلْمٌ مُتَعَاقِدٌ':Added, #2: 2	عِلْمُ الْمُتَعَاقِدَيْنِ
u'علم مُتَعَاقِدٌ':Added, #2: 2	عِلْمُ الْمُتَعَاقِدَيْنِ
u'عِلْمٌ مُتَعَاقِدٌ':Added, #3: 3	عِلْمِ الْمُتَعَاقِدَيْنِ
u'علم مُتَقَدِّمٌ':Added, #3: 3	عِلْمِ الْمُتَعَاقِدَيْنِ
u'عِلْمٌ مُتَقَدِّمٌ':Added, #1: 1	عِلْمِ الْمُتَقَدِّمِ
u'علم مُتَقَدِّمٌ':Added, #1: 1	عِلْمِ الْمُتَقَدِّمِ
u'عِلْمٌ مُتَقَدِّمٌ':Added, #1: 1	عِلْمٍ مُتَقَدِّمٍ
u'عَلِمَ مُتَكَلِّمٌ':Subject, #1: 1	عِلْمٍ مُتَقَدِّمٍ
u'علم مُتَكَلِّمٌ':Added, #1: 1	عَلِمَ الْمُتَكَلِّمُ
u'عِلْمٌ مُتَكَلِّمٌ':Added, #1: 1	عِلْم الْمُتَكَلِّمِ
u'علم مُتَوَاتِرٌ':Added, #1: 1	عِلْم الْمُتَكَلِّمِ
u'عِلْمٌ مُتَوَاتِرٌ':Added, #1: 1	عِلْمَ الْمُتَوَاتِرِ
u'علم مثل':Added, #1: 1	عِلْمَ الْمُتَوَاتِرِ
u'عِلْمٌ مثل':Added, #1: 1	عِلْمَ مِثْلِهِ
u'علم مِثْلٌ':Added, #1: 1	عِلْمَ مِثْلِهِ
u'عِلْمٌ مِثْلٌ':Added, #1: 1	عِلْمَ مِثْلِهِ
u'عَلِمَ مَجْرُوحٌ':Subject, #1: 1	عِلْمَ مِثْلِهِ
u'علم مَجْنِيٌّ':Added, #1: 1	عَلِمَ الْمَجْرُوحُ
u'عِلْمٌ مَجْنِيٌّ':Added, #1: 1	عِلْمَ الْمَجْنِيِّ
u'علم مُجِيزٌ':Added, #1: 1	عِلْمَ الْمَجْنِيِّ
u'علم مُجِيزٌ':Added, #1: 1	عِلْمَ الْمُجِيزِ
u'عِلْمٌ مُجِيزٌ':Added, #1: 1	عِلْمِ الْمُجِيزِ
u'عِلْمٌ مُجِيزٌ':Added, #1: 1	عِلْمَ الْمُجِيزِ
u'علم مَحْجُورٌ':Added, #1: 1	عِلْمِ الْمُجِيزِ
u'عِلْمٌ مَحْجُورٌ':Added, #2: 2	عِلْمُ الْمَحْجُورِ
u'عَلِمَ مُحَدِّثٌ':Subject, #2: 2	عِلْمُ الْمَحْجُورِ
u'عَلِمَ مُحْرِمٌ':Subject, #1: 1	عَلِمَ الْمُحَدِّثُ
u'عَلِمَ مُحَكَّمٌ':Subject, #1: 1	عَلِمَ الْمُحْرِمُ
u'عَلِمَ مَحْكُومٌ':Subject, #2: 2	عَلِمَ الْمُحَكَّمُ
u'علم مُخَاطَبٌ':Added, #1: 1	عَلِمَ الْمَحْكُومُ
u'علم مُخَاطَبٌ':Added, #1: 1	عِلْمَ الْمُخَاطَبِ
u'عِلْمٌ مُخَاطَبٌ':Added, #1: 1	عِلْمُ الْمُخَاطَبِ
u'عِلْمٌ مُخَاطَبٌ':Added, #1: 1	عِلْمَ الْمُخَاطَبِ
u'علم مُخَاطَبٌ':Added, #1: 1	عِلْمُ الْمُخَاطَبِ
u'عِلْمٌ مُخَاطَبٌ':Added, #3: 3	عِلْمِ الْمُخَاطَبِ
u'علم مُخْطِئٌ':Added, #3: 3	عِلْمِ الْمُخَاطَبِ
u'عِلْمٌ مُخْطِئٌ':Added, #1: 1	عِلْمُ الْمُخْطِئِ
u'علم مَدْفُوعٌ':Added, #1: 1	عِلْمُ الْمُخْطِئِ
u'عِلْمٌ مَدْفُوعٌ':Added, #1: 1	عِلْمِ الْمَدْفُوعِ
u'علم مُدَوَّنٌ':Added, #1: 1	عِلْمِ الْمَدْفُوعِ
u'عِلْمٌ مُدَوَّنٌ':Added, #1: 1	عِلْمِ مُدَوَّنٍ
u'علم مَدِينٌ':Added, #1: 1	عِلْمِ مُدَوَّنٍ
u'عِلْمٌ مَدِينٌ':Added, #1: 1	عِلْمِ الْمَدِينِ
u'عَلِمَ مَدْيُونٌ':Subject, #1: 1	عِلْمِ الْمَدِينِ
u'علم مَدْيُونٌ':Added, #1: 1	عَلِمَ الْمَدْيُونُ
u'علم مَدْيُونٌ':Added, #1: 1	عِلْمُ الْمَدْيُونِ
u'عِلْمٌ مَدْيُونٌ':Added, #1: 1	عِلْمِ الْمَدْيُونِ
u'عِلْمٌ مَدْيُونٌ':Added, #1: 1	عِلْمُ الْمَدْيُونِ
u'علم مَذْهَبٌ':Added, #1: 1	عِلْمِ الْمَدْيُونِ
u'عِلْمٌ مَذْهَبٌ':Added, #1: 1	عِلْمِ مَذْهَبِهِ
u'علم مراد':Added, #1: 1	عِلْمِ مَذْهَبِهِ
u'عِلْمٌ مراد':Added, #1: 1	عِلْمِ الْمُرَادِ
u'علم مُرَادٌ':Added, #1: 1	عِلْمِ الْمُرَادِ
u'عِلْمٌ مُرَادٌ':Added, #1: 1	عِلْمِ الْمُرَادِ
u'عَلِمَ مُرْتَهِنٌ':Subject, #1: 1	عِلْمِ الْمُرَادِ
u'عَلِمَ مُرْتَهِنٌ':Subject, #1: 1	عَلِمَ الْمُرْتَهِنُ
u'علم مُرَكَّبٌ':Added, #1: 1	عَلِمَ مُرْتَهِنُهُ
u'عِلْمٌ مُرَكَّبٌ':Added, #1: 1	عِلْمُ الْمُرَكَّبِ
u'عَلِمَ مُرِيدٌ':Subject, #1: 1	عِلْمُ الْمُرَكَّبِ
u'عَلِمَ مُزَارِعٌ':Subject, #1: 1	عَلِمَ مُرِيدُ
u'عَلِمَ مُسَافِرٌ':Subject, #1: 1	عَلِمَ الْمُزَارِعُ
u'عَلِمَ مُسَافِرٌ':Subject, #1: 1	عَلِمَ الْمُسَافِرُ
u'عَلِمَ مَسَالِكُ':Predicate, #1: 1	عَلِمَ مُسَافِرٌ
u'عَلِمَ مَسَائِلُ':Predicate, #1: 1	عَلِمَ مَسَالِكَ
u'عَلِمَ مَسْبُوق':Subject, #1: 1	عَلِمَ الْمَسَائِلَ
u'عَلِمَ مُسْتَبْضِع':Subject, #1: 1	عَلِمَ الْمَسْبُوقُ
u'عَلِمَ مُسْتَحِقٌّ':Predicate, #1: 1	عَلِمَ الْمُسْتَبْضِعُ
u'عَلِمَ مُسْتَحِقٌّ':Subject, #1: 1	أَعْلَمَ الْمُسْتَحِقَّ
u'عَلِمَ مُسْتَعْمِلٌ':Subject, #1: 1	عَلِمَ الْمُسْتَحِقُّ
u'عَلِمَ مُسْلِمٌ':Subject, #1: 1	عَلِمَ الْمُسْتَعْمِلُ
u'عَلِمَ مُشَاهَدٌ':Predicate, #1: 1	عَلِمَ الْمُسْلِمُ
u'عَلِمَ مُشْتَرِي':Predicate, #1: 1	عَلِمَ مُشَاهَدَةً
u'علم مُشْرِفٌ':Added, #3: 3	أَعْلَمَ الْمُشْتَرِيَ
u'عِلْمٌ مُشْرِفٌ':Added, #1: 1	عِلْمِ الْمُشْرِفِ
u'عَلِمَ مَشْرُوطٌ':Subject, #1: 1	عِلْمِ الْمُشْرِفِ
u'عَلِمَ مَشْهُودٌ':Predicate, #1: 1	عَلِمَ الْمَشْرُوطُ
u'علم مَشِيئَةٌ':Added, #1: 1	أَعْلَمَ الْمَشْهُودَ
u'عِلْمٌ مَشِيئَةٌ':Added, #1: 1	عِلْمِ مَشِيئَتِهِ
u'علم مَصْلَحَةٌ':Added, #1: 1	عِلْمِ مَشِيئَتِهِ
u'عِلْمٌ مَصْلَحَةٌ':Added, #1: 1	عِلْمَ الْمَصْلَحَةِ
u'عَلِمَ مُضِيفٌ':Subject, #1: 1	عِلْمَ الْمَصْلَحَةِ
u'علم مَطْلُوبٌ':Added, #2: 2	عَلِمَ الْمُضِيفُ
u'عِلْمٌ مَطْلُوبٌ':Added, #1: 1	عِلْمَ الْمَطْلُوبِ
u'عَلِمَ مُعْتَقٌ':Subject, #1: 1	عِلْمَ الْمَطْلُوبِ
u'علم مَعْرِفَةٌ':Added, #1: 1	عَلِمَ الْمُعْتَقُ
u'علم مَعْرِفَة':Added, #1: 1	عِلْمُ مَعْرِفَةِ
u'عِلْمٌ مَعْرِفَةٌ':Added, #1: 1	عِلْمُ مَعْرِفَةِ
u'عِلْمٌ مَعْرِفَة':Added, #1: 1	عِلْمُ مَعْرِفَةِ
u'عَلِمَ مَعْقُودٌ':Predicate, #1: 1	عِلْمُ مَعْرِفَةِ
u'علم مَعْقُودٌ':Added, #1: 1	عَلِمَ الْمَعْقُودَ
u'عِلْمٌ مَعْقُودٌ':Added, #2: 2	عِلْمُ الْمَعْقُودِ
u'علم مَعْقُولٌ':Added, #2: 2	عِلْمُ الْمَعْقُودِ
u'علم مَعْقُولٌ':Added, #1: 1	عِلْمُ الْمَعْقُولِ
u'عِلْمٌ مَعْقُولٌ':Added, #1: 1	عِلْمِ الْمَعْقُولِ
u'عِلْمٌ مَعْقُولٌ':Added, #1: 1	عِلْمُ الْمَعْقُولِ
u'علم مُعَلِّقٌ':Added, #1: 1	عِلْمِ الْمَعْقُولِ
u'عِلْمٌ مُعَلِّقٌ':Added, #1: 1	عِلْمُ الْمُعَلِّقِ
u'علم مَعْنَوِيٌّ':Added, #1: 1	عِلْمُ الْمُعَلِّقِ
u'عِلْمٌ مَعْنَوِيٌّ':Added, #1: 1	عِلْمٍ مَعْنَوِيٍّ
u'عَلِمَ مَقَادِيرُ':Predicate, #1: 1	عِلْمٍ مَعْنَوِيٍّ
u'علم مَقَايِيسُ':Added, #1: 1	عَلِمَ مَقَادِيرَ
u'عِلْمٌ مَقَايِيسُ':Added, #1: 1	عِلْمُ الْمَقَايِيسِ
u'عَلِمَ مِقْدَارٌ':Predicate, #1: 1	عِلْمُ الْمَقَايِيسِ
u'عَلِمَ مِقْدَارٌ':Predicate, #1: 1	عَلِمَ الْمِقْدَارَ
u'عَلِمَ مَقْذُوفٌ':Subject, #2: 2	عَلِمَ مِقْدَارَ
u'علم مُقَلَّدٌ':Added, #1: 1	عَلِمَ الْمَقْذُوفُ
u'عِلْمٌ مُقَلَّدٌ':Added, #1: 1	عِلْمُ الْمُقَلَّدِ
u'علم مُقَلِّدٌ':Added, #1: 1	عِلْمُ الْمُقَلَّدِ
u'عِلْمٌ مُقَلِّدٌ':Added, #3: 3	عِلْمُ الْمُقَلِّدِ
u'عَلِمَ مَكَانٌ':Predicate, #3: 3	عِلْمُ الْمُقَلِّدِ
u'علم مَكَانٌ':Added, #1: 1	عَلِمَ مَكَانَ
u'عِلْمٌ مَكَانٌ':Added, #1: 1	عِلْمَ مَكَانِ
u'علم مُكْتَسِبٌ':Added, #1: 1	عِلْمَ مَكَانِ
u'عِلْمٌ مُكْتَسِبٌ':Added, #1: 1	عِلْمُ الْمُكْتَسِبِ
u'علم مُكَلَّفٌ':Added, #1: 1	عِلْمُ الْمُكْتَسِبِ
u'عِلْمٌ مُكَلَّفٌ':Added, #1: 1	عِلْمَ الْمُكَلَّفِ
u'علم مُكَلَّفٌ':Added, #1: 1	عِلْمَ الْمُكَلَّفِ
u'عِلْمٌ مُكَلَّفٌ':Added, #4: 4	عِلْمُ الْمُكَلَّفِ
u'علم مُكَلَّفٌ':Added, #4: 4	عِلْمُ الْمُكَلَّفِ
u'عِلْمٌ مُكَلَّفٌ':Added, #5: 5	عِلْمِ الْمُكَلَّفِ
u'علم مَلاَئِكَةٌ':Added, #5: 5	عِلْمِ الْمُكَلَّفِ
u'عِلْمٌ مَلاَئِكَةٌ':Added, #1: 1	عِلْمِ الْمَلَائِكَةِ
u'عَلِمَ مِلْكٌ':Predicate, #1: 1	عِلْمِ الْمَلَائِكَةِ
u'علم مَلِكٌ':Added, #1: 1	عَلِمَ مِلْكَ
u'عِلْمٌ مَلِكٌ':Added, #1: 1	عِلْمُ الْمَلِكِ
u'علم مَلِيكٌ':Added, #1: 1	عِلْمُ الْمَلِكِ
u'عِلْمٌ مَلِيكٌ':Added, #1: 1	عِلْمِ الْمَلِيكِ
u'عَلِمَ مَمْدوحٌ':Subject, #1: 1	عِلْمِ الْمَلِيكِ
u'علم مَنْصُوبٌ':Added, #1: 1	عَلِمَ الْمَمْدُوحُ
u'عَلَمٌ مَنْصُوبٌ':Added, #1: 1	عَلَمٍ مَنْصُوبٍ
u'علم مَنْطِقٌ':Added, #1: 1	عَلَمٍ مَنْصُوبٍ
u'عِلْمٌ مَنْطِقٌ':Added, #1: 1	عِلْمُ الْمَنْطِقِ
u'علم مَنْطِقٌ':Added, #1: 1	عِلْمُ الْمَنْطِقِ
u'عِلْمٌ مَنْطِقٌ':Added, #1: 1	عِلْمَ مَنْطِقِ
u'علم مَنْطِقٌ':Added, #1: 1	عِلْمَ مَنْطِقِ
u'عِلْمٌ مَنْطِقٌ':Added, #4: 4	عِلْمِ الْمَنْطِقِ
u'عَلِمَ مَنْعٌ':Predicate, #4: 4	عِلْمِ الْمَنْطِقِ
u'علم مَوَارِيثُ':Added, #1: 1	عَلِمَ الْمَنْعَ
u'عِلْمٌ مَوَارِيثُ':Added, #1: 1	عِلْمِ الْمَوَارِيثِ
u'علم مَوَارِيثُ':Added, #1: 1	عِلْمِ الْمَوَارِيثِ
u'عِلْمٌ مَوَارِيثُ':Added, #2: 2	عِلْمُ الْمَوَارِيثِ
u'علم مُودَعٌ':Added, #2: 2	عِلْمُ الْمَوَارِيثِ
u'علم مُودَعٌ':Added, #1: 1	عِلْمُ الْمُودَعِ
u'علم مُودِعٌ':Added, #1: 1	عِلْمِ الْمُودَعِ
u'عِلْمٌ مُودَعٌ':Added, #1: 1	عِلْمِ الْمُودِعِ
u'عِلْمٌ مُودَعٌ':Added, #1: 1	عِلْمُ الْمُودَعِ
u'عِلْمٌ مُودِعٌ':Added, #1: 1	عِلْمِ الْمُودَعِ
u'عَلِمَ مُؤَذِّنٌ':Subject, #1: 1	عِلْمِ الْمُودِعِ
u'عَلِمَ مَوْضِعٌ':Predicate, #2: 2	عَلِمَ الْمُؤَذِّنُ
u'علم مَوْضِعٌ':Added, #1: 1	عَلِمَ مَوْضِعَ
u'عِلْمٌ مَوْضِعٌ':Added, #1: 1	عِلْمِ مَوْضِعِهِ
u'عَلِمَ مُوَكِّلٌ':Subject, #1: 1	عِلْمِ مَوْضِعِهِ
u'علم مُوَكِّلٌ':Added, #3: 3	عَلِمَ الْمُوَكِّلُ
u'علم مُوَكِّلٌ':Added, #1: 1	عِلْمَ مُوَكِّلِهِ
u'عِلْمٌ مُوَكِّلٌ':Added, #1: 1	عِلْمِ مُوَكِّلِهِ
u'عِلْمٌ مُوَكِّلٌ':Added, #1: 1	عِلْمَ مُوَكِّلِهِ
u'علم مُوَكِّلٌ':Added, #1: 1	عِلْمِ مُوَكِّلِهِ
u'علم مُوَكِّلٌ':Added, #2: 2	عِلْمَ الْمُوَكِّلِ
u'عِلْمٌ مُوَكِّلٌ':Added, #2: 2	عِلْمُ الْمُوَكِّلِ
u'عِلْمٌ مُوَكِّلٌ':Added, #2: 2	عِلْمَ الْمُوَكِّلِ
u'علم مُوَكِّلٌ':Added, #2: 2	عِلْمُ الْمُوَكِّلِ
u'عِلْمٌ مُوَكِّلٌ':Added, #5: 5	عِلْمِ الْمُوَكِّلِ
u'عَلِمَ مَوْهُوبٌ':Subject, #5: 5	عِلْمِ الْمُوَكِّلِ
u'عَلَّمَ مَوْهُوبٌ':Subject, #1: 1	عَلِمَ الْمَوْهُوبُ
u'علم مَوْهُوبٌ':Added, #1: 1	عَلَّمَ الْمَوْهُوبُ
u'عِلْمٌ مَوْهُوبٌ':Added, #1: 1	عِلْمِ الْمَوْهُوبِ
u'علم مِيقَاتٌ':Added, #1: 1	عِلْمِ الْمَوْهُوبِ
u'عِلْمٌ مِيقَاتٌ':Added, #1: 1	عِلْمِ الْمِيقَاتِ
u'عَلِمَ نَاسٌ':Predicate, #1: 1	عِلْمِ الْمِيقَاتِ
u'عَلَّمَ نَاسٌ':Predicate, #1: 1	أَعْلَمَ النّاسَ
u'عَلِمَ نَاسٌ':Subject, #5: 5	عَلَّمَ النَّاسَ
u'علم نَاسٌ':Added, #7: 7	عَلِمَ النَّاسُ
u'عِلْمٌ نَاسٌ':Added, #1: 1	عِلْمِ النّاسِ
u'علم نَاسٌ':Added, #1: 1	عِلْمِ النّاسِ
u'عِلْمٌ نَاسٌ':Added, #2: 2	عِلْمِ النَّاسِ
u'علم نُبُوءةٌ':Added, #2: 2	عِلْمِ النَّاسِ
u'عِلْمٌ نُبُوءةٌ':Added, #1: 1	عِلْمِ النّبُوءَةِ
u'عَلَّمَ نَبِيٌّ':Subject, #1: 1	عِلْمِ النّبُوءَةِ
u'عَلِمَ نَبِيٌّ':Subject, #2: 2	عَلَّمَ النَّبِيُّ
u'علم نَبِيٌّ':Added, #7: 7	عَلِمَ النَّبِيُّ
u'عِلْمٌ نَبِيٌّ':Added, #2: 2	عِلْمَ النَّبِيِّ
u'علم نَبِيٌّ':Added, #2: 2	عِلْمَ النَّبِيِّ
u'عِلْمٌ نَبِيٌّ':Added, #3: 3	عِلْمِ النَّبِيِّ
u'عَلِمَ نَجَاسَةٌ':Predicate, #3: 3	عِلْمِ النَّبِيِّ
u'عَلِمَ نَجَسٌ':Predicate, #3: 3	عَلِمَ نَجَاسَةَ
u'عَلِمَ نَجِسٌ':Predicate, #1: 1	عَلِمَ النَّجَسَ
u'علم نُجُومٌ':Added, #3: 3	عَلِمَ النَّجِسَ
u'علم نُجُومٌ':Added, #1: 1	عِلْمَ النُّجُومِ
u'عِلْمٌ نُجُومٌ':Added, #1: 1	عِلْمُ النُّجُومِ
u'عِلْمٌ نُجُومٌ':Added, #1: 1	عِلْمَ النُّجُومِ
u'علم نُجُومٌ':Added, #1: 1	عِلْمُ النُّجُومِ
u'عِلْمٌ نُجُومٌ':Added, #5: 5	عِلْمِ النُّجُومِ
u'علم نَحْوٌ':Added, #5: 5	عِلْمِ النُّجُومِ
u'عِلْمٌ نَحْوٌ':Added, #1: 1	عِلْمُ النَّحْوِ
u'علم نَحْوٌ':Added, #1: 1	عِلْمُ النَّحْوِ
u'عِلْمٌ نَحْوٌ':Added, #2: 2	عِلْمِ النَّحْوِ
u'علم نَسَبٌ':Added, #2: 2	عِلْمِ النَّحْوِ
u'علم نِسَبٌ':Added, #1: 1	عِلْمِ النّسَبِ
u'عِلْمٌ نَسَبٌ':Added, #1: 1	عِلْمِ النّسَبِ
u'عِلْمٌ نِسَبٌ':Added, #1: 1	عِلْمِ النّسَبِ
u'عَلَّمَ نِصْفٌ':Predicate, #1: 1	عِلْمِ النّسَبِ
u'علم نَظَرٌ':Added, #1: 1	عَلَّمَ نِصْفَ
u'عِلْمٌ نَظَرٌ':Added, #1: 1	عِلْمِ النَّظَرِ
u'علم نَظَرِيٌّ':Added, #1: 1	عِلْمِ النَّظَرِ
u'عِلْمٌ نَظَرِيٌّ':Added, #1: 1	عِلْمٍ نَظَرِيٍّ
u'علم نَظْمٌ':Added, #1: 1	عِلْمٍ نَظَرِيٍّ
u'عِلْمٌ نَظْمٌ':Added, #1: 1	عِلْمُ نَظْمِ
u'علم نَفْسٌ':Added, #1: 1	عِلْمُ نَظْمِ
u'عِلْمٌ نَفْسٌ':Added, #1: 1	عِلْمُ نَفْسِهِ
u'علم نَفْسٌ':Added, #1: 1	عِلْمُ نَفْسِهِ
u'عِلْمٌ نَفْسٌ':Added, #2: 2	عِلْمِ نَفْسِهِ
u'عَلِمَ نكاح':Predicate, #2: 2	عِلْمِ نَفْسِهِ
u'عَلِمَ نِكَاحٌ':Predicate, #1: 1	عَلِمَ النِّكَاحَ
u'عَلِمَ نَهْيٌ':Predicate, #1: 1	عَلِمَ النِّكَاحَ
u'عَلِمَ هلاك':Predicate, #11: 11	عَلِمَ النَّهْيَ
u'عَلِمَ هَلاَكٌ':Predicate, #1: 1	عَلِمَ الْهَلَاكَ
u'علم هَيْئَةٌ':Added, #1: 1	عَلِمَ الْهَلَاكَ
u'عِلْمٌ هَيْئَةٌ':Added, #1: 1	عِلْمِ الْهَيْئَةِ
u'عَلِمَ واحد':Subject, #1: 1	عِلْمِ الْهَيْئَةِ
u'عَلِمَ وَاحِدٌ':Subject, #1: 1	عَلِمَ الْوَاحِدُ
u'عَلِمَ واحد':Subject, #1: 1	عَلِمَ الْوَاحِدُ
u'عَلِمَ وَاحِدٌ':Subject, #1: 1	عَلِمَ وَاحِدٌ
u'علم واحد':Added, #1: 1	عَلِمَ وَاحِدٌ
u'عِلْمٌ واحد':Added, #2: 2	عِلْمٍ وَاحِدٍ
u'علم وَاحِدٌ':Added, #2: 2	عِلْمٍ وَاحِدٍ
u'عِلْمٌ وَاحِدٌ':Added, #2: 2	عِلْمٍ وَاحِدٍ
u'عَلِمَ وَارِثٌ':Subject, #2: 2	عِلْمٍ وَاحِدٍ
u'عَلِمَ وَارِثٌ':Subject, #1: 1	عَلِمَ وَارِثُهُ
u'علم وَارِثٌ':Added, #4: 4	عَلِمَ الْوَارِثُ
u'عِلْمٌ وَارِثٌ':Added, #1: 1	عِلْمَ الْوَارِثِ
u'علم وَارِثٌ':Added, #1: 1	عِلْمَ الْوَارِثِ
u'عِلْمٌ وَارِثٌ':Added, #1: 1	عِلْمَ وَارِثِهِ
u'عَلِمَ وَاطِئٌ':Subject, #1: 1	عِلْمَ وَارِثِهِ
u'عَلِمَ وَاقِعٌ':Predicate, #1: 1	عَلِمَ الْوَاطِئُ
u'علم وَاقِعٌ':Added, #1: 1	عَلِمَ الْوَاقِعَ
u'علم وَاقِعٌ':Added, #1: 1	عِلْمَ الْوَاقِعِ
u'عِلْمٌ وَاقِعٌ':Added, #1: 1	عِلْمِ الْوَاقِعِ
u'عِلْمٌ وَاقِعٌ':Added, #1: 1	عِلْمَ الْوَاقِعِ
u'عَلِمَ وَالِدٌ':Subject, #1: 1	عِلْمِ الْوَاقِعِ
u'عَلِمَ وَالِي':Predicate, #1: 1	عَلِمَ الْوَالِدُ
u'عَلِمَ وَاهِبٌ':Subject, #1: 1	أَعْلَمَ الْوَالِيَ
u'عَلِمَ وُجُوبٌ':Predicate, #1: 1	عَلِمَ وَاهِبُهُ
u'عَلِمَ وُجُودٌ':Predicate, #4: 4	عَلِمَ وُجُوبَ
u'علم وُجُودٌ':Added, #2: 2	عَلِمَ وُجُودَ
u'عِلْمٌ وُجُودٌ':Added, #1: 1	عِلْمُ وُجُودِ
u'علم وُجُودٌ':Added, #1: 1	عِلْمُ وُجُودِ
u'عِلْمٌ وُجُودٌ':Added, #1: 1	عِلْمُ وُجُودِهِ
u'علم وَدِيعٌ':Added, #1: 1	عِلْمُ وُجُودِهِ
u'علم وَدِيعٌ':Added, #1: 1	عِلْمَ الْوَدِيعِ
u'عِلْمٌ وَدِيعٌ':Added, #1: 1	عِلْمِ الْوَدِيعِ
u'عِلْمٌ وَدِيعٌ':Added, #1: 1	عِلْمَ الْوَدِيعِ
u'عَلِمَ وَرَثَةٌ':Subject, #1: 1	عِلْمِ الْوَدِيعِ
u'علم وَرَثَةٌ':Added, #2: 2	عَلِمَ الْوَرَثَةُ
u'عِلْمٌ وَرَثَةٌ':Added, #1: 1	عِلْمَ الْوَرَثَةِ
u'علم وَرَثَةٌ':Added, #1: 1	عِلْمَ الْوَرَثَةِ
u'عِلْمٌ وَرَثَةٌ':Added, #2: 2	عِلْمِ الْوَرَثَةِ
u'علم وَرَثَةٌ':Added, #2: 2	عِلْمِ الْوَرَثَةِ
u'عِلْمٌ وَرَثَةٌ':Added, #3: 3	عِلْمِ وَرَثَتِهِ
u'عَلِمَ وَزْنٌ':Predicate, #3: 3	عِلْمِ وَرَثَتِهِ
u'علم وَزْنٌ':Added, #3: 3	عَلِمَ وَزْنَ
u'عِلْمٌ وَزْنٌ':Added, #1: 1	عِلْمُ وَزْنِهِ
u'عَلِمَ وُصُولٌ':Predicate, #1: 1	عِلْمُ وَزْنِهِ
u'عَلِمَ وُصُولٌ':Predicate, #1: 1	عَلِمَ الْوُصُولَ
u'عَلِمَ وَصِيٌّ':Subject, #2: 2	عَلِمَ وُصُولَ
u'عَلِمَ وَضْعٌ':Predicate, #2: 2	عَلِمَ الْوَصِيُّ
u'عَلَّمَ وُضُوءٌ':Predicate, #1: 1	عَلِمَ الْوَضْعَ
u'عَلِمَ وَقْتٌ':Predicate, #1: 1	عَلَّمَ الْوُضُوءَ
u'عَلِمَ وقع':Predicate, #7: 7	عَلِمَ وَقْتَ
u'عَلِمَ وَقْفٌ':Predicate, #1: 1	عَلِمَ وَقَعَ
u'عَلِمَ وُقُوعٌ':Predicate, #1: 1	عَلِمَ الْوَقْفَ
u'عَلِمَ وُقُوعٌ':Subject, #4: 4	عَلِمَ وُقُوعَ
u'علم وُقُوعٌ':Added, #1: 1	عَلِمَ وُقُوعُهُ
u'عِلْمٌ وُقُوعٌ':Added, #1: 1	عِلْمُ وُقُوعِ
u'عَلِمَ وَكِيلٌ':Subject, #1: 1	عِلْمُ وُقُوعِ
u'علم وَكِيلٌ':Added, #13: 13	عَلِمَ الْوَكِيلُ
u'عِلْمٌ وَكِيلٌ':Added, #2: 2	عِلْمَ الْوَكِيلِ
u'علم وَكِيلٌ':Added, #2: 2	عِلْمَ الْوَكِيلِ
u'علم وَكِيلٌ':Added, #8: 8	عِلْمُ الْوَكِيلِ
u'عِلْمٌ وَكِيلٌ':Added, #8: 8	عِلْمِ الْوَكِيلِ
u'عِلْمٌ وَكِيلٌ':Added, #8: 8	عِلْمُ الْوَكِيلِ
u'عَلِمَ ولد':Subject, #8: 8	عِلْمِ الْوَكِيلِ
u'عَلِمَ وَلَدٌ':Subject, #3: 3	عَلِمَ الْوَلَدُ
u'عَلِمَ وَلِيٌّ':Subject, #3: 3	عَلِمَ الْوَلَدُ
u'عَلَّمَ وَلِيٌّ':Subject, #1: 1	عَلِمَ وَلِيُّهُ
u'عَلِمَ وَلِيٌّ':Subject, #2: 2	عَلَّمَ وَلِيُّ
u'علم وَلِيٌّ':Added, #6: 6	عَلِمَ الْوَلِيُّ
u'علم وَلِيٌّ':Added, #1: 1	عِلْمَ الْوَلِيِّ
u'عِلْمٌ وَلِيٌّ':Added, #1: 1	عِلْمُ الْوَلِيِّ
u'عِلْمٌ وَلِيٌّ':Added, #1: 1	عِلْمَ الْوَلِيِّ
u'علم يَقِينٌ':Added, #1: 1	عِلْمُ الْوَلِيِّ
u'عِلْمٌ يَقِينٌ':Added, #13: 13	عِلْمَ الْيَقِينِ
u'علم يَقِينٌ':Added, #13: 13	عِلْمَ الْيَقِينِ
u'علم يَقِينٌ':Added, #2: 2	عِلْمُ الْيَقِينِ
u'عِلْمٌ يَقِينٌ':Added, #2: 2	عِلْمِ الْيَقِينِ
u'عِلْمٌ يَقِينٌ':Added, #2: 2	عِلْمُ الْيَقِينِ
u'عَلِمَ يَوْمٌ':Predicate, #2: 2	عِلْمِ الْيَقِينِ
u'عَلَنَ أَمْرٌ':Subject, #2: 2	عَلِمَ يَوْمَ
u'عُلُوقٌ حادِثٌ':Added, #1: 1	عَلَنَ الْأَمْرُ
u'عُلُوقٌ ولد':Added, #11: 11	عُلُوقٍ حَادِثٍ
u'عُلُوقٌ وَلَدٌ':Added, #2: 2	عُلُوقُ الْوَلَدِ
u'عُلُوقٌ ولد':Added, #2: 2	عُلُوقُ الْوَلَدِ
u'عُلُوقٌ وَلَدٌ':Added, #3: 3	عُلُوقِ الْوَلَدِ
u'عُلُومٌ آخِرَةٌ':Added, #3: 3	عُلُوقِ الْوَلَدِ
u'عُلُومٌ إِدْرَاكٌ':Added, #1: 1	عُلُومِ الْآخِرَةِ
u'عُلُومٌ إِسْلامٌ':Added, #1: 1	عُلُومَ الْإِدْرَاكَاتِ
u'عُلُومٌ إلْهَامٌ':Added, #1: 1	عُلُومِ الْإِسْلَامِ
u'عُلُومٌ أنبياء':Added, #1: 1	عُلُومِ الْإِلْهَامِ
u'عُلُومٌ تَوْحِيدٌ':Added, #2: 2	عُلُومِ الْأَنْبِيَاءِ
u'عُلُومٌ حَديثٌ':Added, #1: 1	عُلُومِ التَّوْحِيدِ
u'عُلُومٌ حِسٌّ':Added, #23: 23	عُلُومِ الْحَدِيثِ
u'عُلُومٌ دِينٌ':Added, #1: 1	عُلُومِ الْحِسِّ
u'عُلُومٌ شَرَائِعُ':Added, #6: 6	عُلُومِ الدِّينِ
u'عُلُومٌ شَرْعٌ':Added, #1: 1	عُلُومِ الشَّرَائِعِ
u'عُلُومٌ شَرِيعَةٌ':Added, #4: 4	عُلُومِ الشَّرْعِ
u'عُلُومٌ شَرِيعَةٌ':Added, #2: 2	عُلُومَ الشَّرِيعَةِ
u'عُلُومٌ صُوفِيٌّ':Added, #2: 2	عُلُومِ الشَّرِيعَةِ
u'عُلُومٌ صُوفِيَّةٌ':Added, #1: 1	عُلُومِ الصُّوفِيَّةِ
u'عُلُومٌ عَرَبِيٌّ':Added, #1: 1	عُلُومِ الصُّوفِيَّةِ
u'عُلُومٌ عَرَبِيٌّ':Added, #1: 1	عُلُومَ الْعَرَبِيَّةِ
u'عُلُومٌ علماء':Added, #1: 1	عُلُومِ الْعَرَبِيَّةِ
u'عُلُومٌ عُلَمَاءُ':Added, #1: 1	عُلُومُ الْعُلَمَاءِ
u'عُلُومٌ فِقْهٌ':Added, #1: 1	عُلُومُ الْعُلَمَاءِ
u'عُلُومٌ فَلاَسِفَةٌ':Added, #1: 1	عُلُومِ الْفِقْهِ
u'عُلُومٌ قِرَاءةٌ':Added, #1: 1	عُلُومُ الْفَلَاسِفَةِ
u'عُلُومٌ قُرْآنٌ':Added, #1: 1	عُلُومِ الْقِرَاءَاتِ
u'عُلُومٌ قُرْآنٌ':Added, #12: 12	عُلُومِ الْقُرْآنِ
u'عُلُومٌ لِسَانٌ':Added, #1: 1	عُلُومَ الْقُرْآنِ
u'عُلُومٌ نِساءٌ':Added, #1: 1	عُلُومِ اللِّسَانِ
u'عُلُومٌ هَيْئَةٌ':Added, #1: 1	عُلُومُ النِّسَاءِ
u'عَلَى أَبٌ':Subject, #1: 1	عُلُومِ الْهَيْئَةِ
u'عَلَى إبَاحَةٌ':Predicate, #1: 1	عَلَى أَبُ
u'عَلَى إبْداءٌ':Subject, #1: 1	عَلَى إبَاحَةَ
u'عَلَى أَبْعَدُ':Predicate, #1: 1	عَلَى إبْدَاءُ
u'عَلَى اِبْنٌ':Predicate, #2: 2	عَلَى الْأَبْعَدِينَ
u'عَلَى أَبْيَض':Predicate, #1: 1	عَلَى ابْنَ
u'عَلَى إِثْمٌ':Predicate, #1: 1	عَلَى أَبْيَضَ
u'عَلَى إجَازَةٌ':Subject, #1: 1	عَلَى إِثْمَ
u'عَلَى أَجْوَدُ':Predicate, #1: 1	عَلَى إجَازَةُ
u'عَلَى أَحادِيثُ':Predicate, #1: 1	عَلَى أَجْوَدَ
u'عَلَى أحَدٌ':Predicate, #1: 1	عَلَى أَحَادِيثَ
u'عَلَى أحَدٌ':Predicate, #1: 1	عَلَى الْأَحَدَ
u'عَلَى أَحْيَاءٌ':Predicate, #46: 46	عَلَى أَحَدَ
u'عَلَى أخرَس':Predicate, #2: 2	عَلَى أَحْيَاءَ
u'عَلَى أَخَصُّ':Predicate, #1: 1	عَلَى أَخْرَسَ
u'عَلَى آدَمُ':Predicate, #1: 1	عَلَى أَخَصَّ
u'عَلَى آدَمِيٌّ':Predicate, #13: 13	عَلَى آدَمَ
u'عَلَى آرَاءٌ':Predicate, #1: 1	عَلَى الْآدَمِيِّينَ
u'عَلَى أَرْبَعَةٌ':Predicate, #1: 1	عَلَى آرَاءَ
u'عَلَى أَرْبَعَةٌ':Predicate, #1: 1	عَلَى الْأَرْبَعَةَ
u'عَلَى أَرْبَعَةٌ':Subject, #6: 6	عَلَى أَرْبَعَةَ
u'عَلَى أرْحَاءُ':Predicate, #1: 1	عَلَى أَرْبَعَةُ
u'عَلَى أَزْهَر':Predicate, #1: 1	عَلَى أَرْحَاءَ
u'عَلَى أَزْيَدُ':Predicate, #1: 1	عَلَى أَزْهَرَ
u'عَلَى اِسْمٌ':Subject, #7: 7	عَلَى أَزْيَدَ
u'عَلَى أَسْماءٌ':Predicate, #1: 1	عَلَى اسْمُ
u'عَلَى أَشْهَب':Predicate, #7: 7	عَلَى أَسْمَاءَ
u'عَلَى أَشْيَاءٌ':Predicate, #1: 1	عَلَى أَشْهَبَ
u'عَلَى أَصَمّ':Predicate, #17: 17	عَلَى أَشْيَاءَ
u'عَلَى أَصيلٌ':Subject, #2: 2	عَلَى أَصَمَّ
u'عَلَى إِطْعامٌ':Subject, #1: 1	عَلَى الْأَصِيلُ
u'عَلَى أَعاجِيبُ':Predicate, #1: 1	عَلَى إطْعَامٌ
u'عَلَى اِعْتِبارٌ':Predicate, #1: 1	عَلَى أَعَاجِيبَ
u'عَلَى أعْظَمُ':Predicate, #2: 2	عَلَى اعْتِبَارَ
u'عَلَى أَعَمُّ':Predicate, #2: 2	عَلَى أَعْظَمَ
u'عَلَى أعْوَر':Predicate, #1: 1	عَلَى أَعَمَّ
u'عَلَى أَقَاوِيلُ':Predicate, #1: 1	عَلَى أَعْوَرَ
u'عَلَى أقْرَبُ':Predicate, #2: 2	عَلَى أَقَاوِيلَ
u'عَلَى أقَلُّ':Predicate, #2: 2	عَلَى أَقْرَبَ
u'عَلَى أَكْثَرُ':Predicate, #77: 77	عَلَى أَقَلَّ
u'عَلَى أَكْثَرُ':Predicate, #143: 143	عَلَى أَكْثَرَ
u'عَلَى أَكُفٌّ':Predicate, #3: 3	عَلَى الْأَكْثَرِينَ
u'عَلَى أَلْفَاظٌ':Predicate, #1: 1	عَلَى أَكُفَّ
u'عَلَى أَمَاكِنُ':Predicate, #1: 1	عَلَى أَلْفَاظَ
u'عَلَى أَمْلأُ':Predicate, #2: 2	عَلَى أَمَاكِنَ
u'عَلَى أَنْحَاءٌ':Predicate, #2: 2	عَلَى أَمْلَأَ
u'عَلَى أَنْدَلُسِيٌّ':Predicate, #1: 1	عَلَى أَنْحَاءَ
u'عَلَى أوامر':Predicate, #1: 1	عَلَى الْأَنْدَلُسِيِّينَ
u'عَلَى أَوامِرُ':Predicate, #4: 4	عَلَى أَوَامِرَ
u'عَلَى أَوَّلُ':Predicate, #4: 4	عَلَى أَوَامِرَ
u'عَلَى أَوَّلُ':Predicate, #1: 1	عَلَى أَوَّلَ
u'عَلَى أَوْلاَدٌ':Subject, #5: 5	عَلَى الْأَوَّلِينَ
u'عَلَى أَيْسَرُ':Predicate, #1: 1	عَلَى الْأَوْلَادُ
u'عَلَى إيصَالٌ':Subject, #1: 1	عَلَى أَيْسَرَ
u'عَلَى أَيْمَنُ':Predicate, #1: 1	عَلَى إيصَالُ
u'عَلَى أَيْمَن':Predicate, #4: 4	عَلَى أَيْمَنَ
u'عَلَى بَادِنٌ':Predicate, #4: 4	عَلَى أَيْمَنَ
u'عَلَى بادِي':Predicate, #1: 1	عَلَى بَادِنَةَ
u'عَلَى بَادِيَةٌ':Predicate, #1: 1	عَلَى بَادِيَةَ
u'عَلَى بالِغٌ':Predicate, #1: 1	عَلَى بَادِيَةَ
u'عَلَى بالِغٌ':Predicate, #1: 1	عَلَى بَالِغِينَ
u'عَلَى بَائِعٌ':Predicate, #5: 5	عَلَى الْبَالِغِينَ
u'عَلَى بَداءةٌ':Predicate, #2: 2	عَلَى الْبَائِعَ
u'عَلَى بَصْرِيّ':Predicate, #1: 1	عَلَى الْبَدَاءَةَ
u'عَلَى بِضْعٌ':Predicate, #1: 1	عَلَى الْبَصْرِيِّينَ
u'عَلَى بِضْعٌ':Predicate, #1: 1	عَلَى بِضْعَ
u'عَلَى بَعْضٌ':Predicate, #1: 1	عَلَى بِضْعَةَ
u'عَلَّى بِنَاءٌ':Predicate, #1: 1	عَلَى الْبَعْضَ
u'عَلَى بِنْصِرٌ':Predicate, #1: 1	عَلَّى بِنَاءَ
u'عَلَى بَوَّابٌ':Predicate, #1: 1	عَلَى الْبِنْصِرَ
u'عَلَى بَوَّابٌ':Predicate, #1: 1	عَلَى الْبَوَّابِينَ
u'عَلَى بَيَّاعٌ':Predicate, #1: 1	عَلَى بَوَّابِينَ
u'عَلَى تَابِعٌ':Predicate, #1: 1	عَلَى الْبَيَّاعِينَ
u'عَلَى تِسْعَةٌ':Predicate, #4: 4	عَلَى التَّابِعِينَ
u'عَلَى تِسْعِين':Predicate, #6: 6	عَلَى تِسْعَةَ
u'عَلَى تَعْبِيرٌ':Subject, #3: 3	عَلَى التِّسْعِينَ
u'عَلَى تَفَاصِيلُ':Predicate, #1: 1	عَلَى التَّعْبِيرُ
u'عَلَى تَمَّارٌ':Predicate, #1: 1	عَلَى تَفَاصِيلَ
u'عَلَى ثَلاثُ':Predicate, #1: 1	عَلَى التَّمَّارِينَ
u'عَلَى ثَلاثَةٌ':Predicate, #2: 2	عَلَى ثَلَاثَ
u'عَلَى ثَلاثَةٌ':Predicate, #16: 16	عَلَى ثَلَاثَةَ
u'عَلَى ثُمالَةٌ':Predicate, #2: 2	عَلَى ثَلاَثَةَ
u'عَلَى ثُمام':Predicate, #1: 1	عَلَى ثُمَالَةَ
u'عَلَى ثَمانِيَةٌ':Predicate, #2: 2	عَلَى ثُمَامَةَ
u'عَلَى ثَمانِيَةٌ':Predicate, #1: 1	عَلَى الثَّمَانِيَةَ
u'عَلَى ثَمانِين':Predicate, #8: 8	عَلَى ثَمَانِيَةَ
u'عَلَى ثَمانِين':Predicate, #1: 1	عَلَى الثّمَانِينَ
u'عَلَى ثَمانِين':Predicate, #1: 1	عَلَى الثَّمَانِينَ
u'عَلَى ثَمَن':Predicate, #8: 8	عَلَى ثَمَانِينَ
u'عَلَى ثَنايا':Subject, #1: 1	عَلَى الثَّمَنِيَّةَ
u'عَلَى جَاحِدٌ':Predicate, #5: 5	عَلَى ثَنَايَاهُ
u'عَلِيَ جَازٌ':Predicate, #2: 2	عَلَى الْجَاحِدِينَ
u'عَلَى جَبَّارٌ':Predicate, #1: 1	أَعْلَى جَازَ
u'عَلَى جَعْدٌ':Predicate, #1: 1	عَلَى الْجَبّارِينَ
u'عَلَى جُمْلَةٌ':Subject, #1: 1	عَلَى جَعْدَةَ
u'عَلَى جَمِيع':Subject, #1: 1	عَلَى جُمْلَةٌ
u'عَلَى جَنَائِزُ':Predicate, #1: 1	عَلَى الْجَمِيعُ
u'عَلِيَ جَهَنَّمُ':Predicate, #3: 3	عَلَى جَنَائِزَ
u'عَلَى جَهَنَّمُ':Predicate, #1: 1	أَعْلَى جَهَنَّمَ
u'عَلَى حاضِرٌ':Predicate, #6: 6	عَلَى جَهَنَّمَ
u'عَلَى حامِلٌ':Predicate, #8: 8	عَلَى الْحَاضِرِينَ
u'عَلَى حائِطٌ':Predicate, #1: 1	عَلَى الْحَامِلِينَ
u'عَلَى حَجٌّ':Subject, #1: 1	عَلَى الْحَائِطَ
u'عَلَى حذَّاءٌ':Predicate, #1: 1	عَلَى الْحَجُّ
u'عَلَى حَرائِرُ':Predicate, #2: 2	عَلَى الْحَذَّائِينَ
u'عَلَى حَرَائِرُ':Predicate, #1: 1	عَلَى حَرَائِرَ
u'عَلَى حَرْبِيّ':Predicate, #1: 1	عَلَى حَرَائِرَ
u'عَلَى حَصْبَاءُ':Predicate, #2: 2	عَلَى الْحَرْبِيِّينَ
u'عَلَى حَفَّارٌ':Predicate, #1: 1	عَلَى حَصْبَاءَ
u'عَلَى حقائق':Predicate, #1: 1	عَلَى الْحَفَّارِينَ
u'عَلَى حَقَائِقُ':Predicate, #1: 1	عَلَى حَقَائِقَ
u'عَلَى حمر':Subject, #1: 1	عَلَى حَقَائِقَ
u'عَلَى حُمُرٌ':Subject, #1: 1	عَلَى الْحُمُرُ
u'عَلَى حَمْز':Predicate, #1: 1	عَلَى الْحُمُرُ
u'عَلَى حَنْظَلٌ':Predicate, #26: 26	عَلَى حَمْزَةَ
u'عَلَى خَارِجٌ':Predicate, #4: 4	عَلَى حَنْظَلَةَ
u'عَلَى خَاشِعٌ':Predicate, #1: 1	عَلَى خَارِجَةَ
u'عَلَى خَدِيج':Predicate, #1: 1	عَلَى الْخَاشِعِينَ
u'عَلَى خُزَاعَةٌ':Predicate, #12: 12	عَلَى خَدِيجَةَ
u'عَلَى خِلاَفٌ':Predicate, #9: 9	عَلَى خُزَاعَةَ
u'عَلَى خَمْسَةٌ':Predicate, #1: 1	عَلَى خِلَافَ
u'عَلَى خَمْسَةٌ':Predicate, #27: 27	عَلَى خَمْسَةَ
u'عَلَى خَوْلَةٌ':Predicate, #4: 4	عَلَى الْخَمْسَةَ
u'عَلَى خَيْرٌ':Predicate, #1: 1	عَلَى خَوْلَةَ
u'عَلَى دَاخِلٌ':Predicate, #1: 1	عَلَى الْخَيْرَ
u'عَلَى دَخَلٌ':Predicate, #2: 2	عَلَى الدَّاخِلِينَ
u'عَلَى دَرَاهِمُ':Predicate, #1: 1	عَلَى دَخَلَ
u'عَلَى دِرْهَمٌ':Subject, #149: 149	عَلَى دَرَاهِمَ
u'عَلَى دِرْهَم':Subject, #1: 1	عَلَى دِرْهَمٌ
u'عَلَى دُرَيْهِمٌ':Subject, #1: 1	عَلَى دِرْهَمٌ
u'عَلَى دقائق':Predicate, #1: 1	عَلَى دُرَيْهِمَاتٌ
u'عَلَى دَقائِقُ':Predicate, #2: 2	عَلَى دَقَائِقَ
u'عَلَى دَمامِيسُ':Predicate, #2: 2	عَلَى دَقَائِقَ
u'عَلَى دَنانيرُ':Predicate, #1: 1	عَلَى دَمَامِيسَ
u'عَلَى دنيا':Predicate, #35: 35	عَلَى دَنَانِيرَ
u'عَلَى دُنْيا':Predicate, #1: 1	عَلَى دُنْيَايَ
u'عَلَى دَوَابُّ':Predicate, #1: 1	عَلَى دُنْيَايَ
u'عَلَى دَوْم':Predicate, #4: 4	عَلَى دَوَابَّ
u'عَلَى ذِمِّيٌّ':Predicate, #1: 1	عَلَى دَوْمَةَ
u'عَلَى رَاجِعٌ':Predicate, #1: 1	عَلَى الذِّمِّيِّينَ
u'عَلَى رَاسِخٌ':Predicate, #4: 4	عَلَى الرَّاجِعِينَ
u'عَلَى رَبُّ':Predicate, #1: 1	عَلَى الرَّاسِخِينَ
u'عَلَى رَبِيعَةٌ':Predicate, #1: 1	عَلَى رَبّكَ
u'عَلَى رَجُلٌ':Subject, #6: 6	عَلَى رَبِيعَةَ
u'عَلَى رَجُلٌ':Subject, #1: 1	عَلَى الرَّجُلُ
u'عَلَى رَسُولٌ':Predicate, #1: 1	عَلَى رَجُلٌ
u'عَلَى رَشًا':Subject, #1: 1	عَلَى رَسُولَ
u'عَلَى رِضاً':Predicate, #1: 1	عَلَى رَشَاهُ
u'عَلَى رِضاً':Subject, #1: 1	عَلَى رِضَاهُنَّ
u'عَلَى رَمَضانُ':Predicate, #23: 23	عَلَى رِضَاهُ
u'عَلَى رواحل':Predicate, #9: 9	عَلَى رَمَضَانَ
u'عَلَى رَوَاحِلُ':Predicate, #1: 1	عَلَى رَوَاحِلَ
u'عَلَى رِوايَةٌ':Subject, #1: 1	عَلَى رَوَاحِلَ
u'عَلَى زَرْعٌ':Subject, #1: 1	عَلَى الرِّوَايَةُ
u'عَلَى زُفَرٌ':Predicate, #1: 1	عَلَى الزَّرْعُ
u'عَلَى زَيْدٌ':Subject, #5: 5	عَلَى زُفَرَ
u'عَلَى زَيْنَبٌ':Predicate, #1: 1	عَلَى زَيْدُ
u'عَلَى سَابِقٌ':Predicate, #26: 26	عَلَى زَيْنَبَ
u'عَلَى سَاكِنٌ':Predicate, #3: 3	عَلَى السَّابِقِينَ
u'عَلَى سَالِكٌ':Predicate, #1: 1	عَلَى السَّاكِنِينَ
u'عَلَى سَامِعٌ':Predicate, #1: 1	عَلَى السَّالِكِينَ
u'عَلَى سَبْعَةٌ':Predicate, #4: 4	عَلَى السَّامِعِينَ
u'عَلَى سِتٌّ':Predicate, #1: 1	عَلَى سَبْعَةَ
u'عَلَى سِتٌّ':Predicate, #1: 1	عَلَى السِّتَّةَ
u'عَلَى سِتٌّ':Predicate, #1: 1	عَلَى سِتَّ
u'عَلَى سجدة':Predicate, #5: 5	عَلَى سِتَّةَ
u'عَلَى سَجْدَةٌ':Predicate, #1: 1	عَلَى السَّجْدَةَ
u'عَلَى سَخِينٌ':Predicate, #1: 1	عَلَى السَّجْدَةَ
u'عَلَى سَعْدِيّ':Predicate, #1: 1	عَلَى سَخِينَةَ
u'عَلَى سَعْي':Predicate, #1: 1	عَلَى السَّعْدِيِّينَ
u'عَلَى سُلاف':Predicate, #1: 1	عَلَى سَعْيَةَ
u'عَلَى سُلافَة':Predicate, #1: 1	عَلَى سُلَافَةَ
u'عَلَى سُنَّةٌ':Subject, #1: 1	عَلَى سُلَافَةَ
u'عَلَى شَارِبٌ':Predicate, #1: 1	عَلَى السُّنَّةُ
u'عَلَى شَارِحٌ':Predicate, #1: 1	عَلَى الشَّارِبِينَ
u'عَلَى شَاهِدٌ':Predicate, #2: 2	عَلَى الشَّارِحِينَ
u'عَلَى شَرَائِطُ':Predicate, #1: 1	عَلَى الشَّاهِدِينَ
u'عَلَى شرائك':Predicate, #5: 5	عَلَى شَرَائِطَ
u'عَلَى شَرْطٌ':Subject, #1: 1	عَلَى شِرَائِكَ
u'عَلَى شُعْبَةٌ':Predicate, #1: 1	عَلَى شَرْطٌ
u'عَلَى شَيْءٌ':Subject, #4: 4	عَلَى شُعْبَةَ
u'عَلَى شَيْبَةٌ':Predicate, #2: 2	عَلَى شَيْءٌ
u'عَلَى صَالِحٌ':Predicate, #2: 2	عَلَى شَيْبَةَ
u'عَلَى صَالِح':Predicate, #2: 2	عَلَى الصَّالِحِينَ
u'عَلَى صدقة':Predicate, #2: 2	عَلَى الصَّالِحِينَ
u'عَلَى صَدَقَةٌ':Predicate, #1: 1	عَلَى صَدَقَةَ
u'عَلَى صَغِيرٌ':Predicate, #1: 1	عَلَى صَدَقَةَ
u'عَلَى صَفْوَان':Predicate, #1: 1	عَلَى الصَّغِيرَ
u'عَلَى صَفِيٌّ':Predicate, #6: 6	عَلَى صَفْوَانَ
u'عَلَى صَلَوَاتٌ':Subject, #9: 9	عَلَى صَفِيَّةَ
u'عَلَى صَوْمٌ':Subject, #1: 1	عَلَى صَلَوَاتٌ
u'عَلَى ضَرَائِرُ':Predicate, #1: 1	عَلَى صَوْمُ
u'عَلَى ضَرَبٌ':Predicate, #1: 1	عَلَى ضَرَائِرَ
u'عَلَى ضعفاء':Predicate, #1: 1	عَلَى ضَرَبَ
u'عَلَى ضِمْنِيٌّ':Subject, #1: 1	عَلَى ضُعَفَاءَ
u'عَلَى طالِبِيّ':Predicate, #1: 1	عَلَى ضِمْنِيٌّ
u'عَلَى طَائِفٌ':Predicate, #1: 1	عَلَى الطَّالِبِيِّينَ
u'عَلَى طَلْحٌ':Predicate, #4: 4	عَلَى الطَّائِفِينَ
u'عَلَى طلحة':Predicate, #13: 13	عَلَى طَلْحَةَ
u'عَلَى طَوَائِفُ':Predicate, #13: 13	عَلَى طَلْحَةَ
u'عَلَى ظالِمٌ':Predicate, #3: 3	عَلَى طَوَائِفَ
u'عَلَى ظالِمٌ':Predicate, #1: 1	عَلَى الظّالِمِينَ
u'عَلَى ظاهِرٌ':Subject, #9: 9	عَلَى الظَّالِمِينَ
u'عَلَى ظاهِرٌ':Subject, #1: 1	عَلَى ظَاهِرُ
u'عَلَى ظاهِرَة':Subject, #2: 2	عَلَى ظَاهِرَةٌ
u'عَلَى ظُهورٌ':Predicate, #2: 2	عَلَى ظَاهِرَةٌ
u'عَلَى عَاشُورَاءُ':Predicate, #1: 1	عَلَى ظُهُورَ
u'عَلَى عَاقِدٌ':Predicate, #1: 1	عَلَى عَاشُورَاءَ
u'عَلَى عَاقِلٌ':Subject, #1: 1	عَلَى الْعَاقِدِينَ
u'عَلَى عَامِلٌ':Predicate, #1: 1	عَلَى الْعَاقِلَةُ
u'عَلَى عَائِشٌ':Predicate, #1: 1	عَلَى الْعَامِلِينَ
u'عَلَى عِبَادَةٌ':Predicate, #108: 108	عَلَى عَائِشَةَ
u'عَلَى عَبّاسِيّ':Predicate, #1: 1	عَلَى عِبَادَةَ
u'عَلَى عَبْدٌ':Subject, #1: 1	عَلَى الْعَبَّاسِيِّينَ
u'عَلَى عَبْدٌ':Subject, #1: 1	عَلَى الْعَبْدُ
u'عَلَى عتبة':Predicate, #1: 1	عَلَى عَبْدُهُ
u'عَلَى عجائب':Predicate, #7: 7	عَلَى عُتْبَةَ
u'عَلَى عَدَمٌ':Predicate, #1: 1	عَلَى عَجَائِبَ
u'عَلَى عَدَمٌ':Subject, #1: 1	عَلَى عَدَمَ
u'عَلَى عَدَن':Predicate, #1: 1	عَلَى عَدَمُ
u'عَلَى عِراقِيّ':Predicate, #1: 1	عَلَى عَدَنَ
u'عَلَى عرفة':Predicate, #1: 1	عَلَى الْعِرَاقِيِّينَ
u'عَلَى عُرْوَةٌ':Predicate, #6: 6	عَلَى عَرَفَةَ
u'عَلَى عِشْرُون':Predicate, #3: 3	عَلَى عُرْوَةَ
u'عَلَى عَصًا':Subject, #2: 2	عَلَى عِشْرُونَ
u'عَلَى عُصَيَّةٌ':Predicate, #2: 2	عَلَى عَصَاهُ
u'عَلَى عَطِيَّةٌ':Predicate, #2: 2	عَلَى عُصَيَّةَ
u'عَلَى عقبة':Predicate, #1: 1	عَلَى عَطِيَّةَ
u'عَلَى عُقْبَةٌ':Predicate, #1: 1	عَلَى عُقْبَةَ
u'عَلِيَ عِلِّيٌّ':Predicate, #1: 1	عَلَى عُقْبَةَ
u'عَلَى عُمَارَةٌ':Predicate, #3: 3	أَعْلَى عِلِّيِّينَ
u'عَلَى عُمَرٌ':Predicate, #1: 1	عَلَى عُمَارَةَ
u'عَلَى عمرة':Predicate, #127: 127	عَلَى عُمَرَ
u'عَلَى عمرة':Predicate, #10: 10	عَلَى عَمْرَةَ
u'عَلَى عُمْرَةٌ':Predicate, #4: 4	عَلَى عُمْرَةَ
u'عَلَى عَوَارِضُ':Predicate, #4: 4	عَلَى عُمْرَةَ
u'عَلَى عَوَاقِلُ':Predicate, #1: 1	عَلَى عَوَارِضَ
u'عَلَى غانِم':Predicate, #1: 1	عَلَى عَوَاقِلَ
u'عَلَى غَائِبٌ':Predicate, #5: 5	عَلَى الْغَانِمِينَ
u'عَلَى غرماء':Predicate, #2: 2	عَلَى الْغَائِبِينَ
u'عَلَى غُسْلٌ':Predicate, #2: 2	عَلَى غُرَمَاءَ
u'عَلَى غير':Subject, #1: 1	عَلَى غُسْلَ
u'عَلَى غَيْرٌ':Subject, #3: 3	عَلَى غَيْرُ
u'عَلَى فَارِسٌ':Predicate, #3: 3	عَلَى غَيْرُ
u'عَلَى فَاطِمٌ':Predicate, #10: 10	عَلَى فَارِسَ
u'عَلَى فَاعِلٌ':Predicate, #23: 23	عَلَى فَاطِمَةَ
u'عَلَى فَرَاسِخُ':Predicate, #1: 1	عَلَى الْفَاعِلِينَ
u'عَلَى فَرَائِضُ':Predicate, #4: 4	عَلَى فَرَاسِخَ
u'عَلَى فِرْعَوْنُ':Predicate, #1: 1	عَلَى فَرَائِضَ
u'عَلَى فَضَائِحُ':Predicate, #5: 5	عَلَى فِرْعَوْنَ
u'عَلَى فقراء':Predicate, #1: 1	عَلَى فَضَائِحَ
u'عَلَى فلان':Predicate, #1: 1	عَلَى فُقَرَاءَ
u'عَلَى فلان':Predicate, #11: 11	عَلَى مَكّةَ
u'عَلَى فلان':Predicate, #12: 12	عَلَى خَدِيجَةَ
u'عَلَى فلان':Predicate, #12: 12	عَلَى خَيْبَرَ
u'عَلَى فلان':Predicate, #12: 12	عَلَى مَكَّةَ
u'عَلَى فُلاَنٌ':Predicate, #14: 14	عَلَى سُفْيَانَ
u'عَلَى فلان':Predicate, #15: 15	عَلَى فُلَانَةَ
u'عَلَى فلان':Predicate, #18: 18	عَلَى مُعَاوِيَةَ
u'عَلَى فلان':Predicate, #1: 1	عَلَى الْبَصْرِيِّينَ
u'عَلَى فلان':Predicate, #1: 1	عَلَى الْعَبَّاسِيِّينَ
u'عَلَى فلان':Predicate, #1: 1	عَلَى اللَّيْثِيِّينَ
u'عَلَى فلان':Predicate, #1: 1	عَلَى رِفَاعَةَ
u'عَلَى فلان':Predicate, #1: 1	عَلَى طُلَيْطِلَةَ
u'عَلَى فُلاَنٌ':Predicate, #1: 1	عَلَى عَدْنَانَ
u'عَلَى فُلاَنٌ':Predicate, #1: 1	عَلَى فُلانَةَ
u'عَلَى فلان':Predicate, #1: 1	عَلَى فُلاَنَةَ
u'عَلَى فلان':Predicate, #1: 1	عَلَى هِرَقْلَ
u'عَلَى فلان':Predicate, #22: 22	عَلَى حَفْصَةَ
u'عَلَى فلان':Predicate, #26: 26	عَلَى حَمْزَةَ
u'عَلَى فلان':Predicate, #2: 2	عَلَى حِرَاءَ
u'عَلِيَ فلان':Predicate, #2: 2	عَلَى هَارُونَ
u'عَلَى فلان':Predicate, #3: 3	أَعْلَى مَكّةَ
u'عَلَى فلان':Predicate, #3: 3	عَلَى حُذَيْفَةَ
u'عَلَى فلان':Predicate, #3: 3	عَلَى خُرَاسَانَ
u'عَلَى فلان':Predicate, #3: 3	عَلَى دَاوُدَ
u'عَلَى فلان':Predicate, #3: 3	عَلَى صَنْعَاءَ
u'عَلَى فلان':Predicate, #3: 3	عَلَى مَرْيَمَ
u'عَلَى فلان':Predicate, #42: 42	عَلَى عُثْمَانَ
u'عَلَى فلان':Predicate, #4: 4	عَلَى دِجْلَةَ
u'عَلَى فلان':Predicate, #4: 4	عَلَى قَتَادَةَ
u'عَلِيَ فلان':Predicate, #5: 5	عَلَى الْغَانِمِينَ
u'عَلَى فَوَاعِلُ':Predicate, #7: 7	أَعْلَى مَكَّةَ
u'عَلَى فَوَائِدُ':Predicate, #2: 2	عَلَى فَوَاعِلَ
u'عَلَى فَوْرٌ':Predicate, #8: 8	عَلَى فَوَائِدَ
u'عَلَى قَادِرٌ':Predicate, #1: 1	عَلَى الْفَوْرَ
u'عَلَى قَاصِرٌ':Predicate, #1: 1	عَلَى الْقَادِرِينَ
u'عَلَى قَاطِعٌ':Predicate, #1: 1	عَلَى الْقَاصِرِينَ
u'عَلَى قَاعِدٌ':Predicate, #1: 1	عَلَى الْقَاطِعِينَ
u'عَلَى قَالٌ':Predicate, #14: 14	عَلَى الْقَاعِدِينَ
u'عَلَى قَائِلٌ':Predicate, #1: 1	عَلَى قَالَ
u'عَلَى قبائح':Predicate, #21: 21	عَلَى الْقَائِلِينَ
u'عَلَى قَبَائِلُ':Predicate, #3: 3	عَلَى قَبَائِحَ
u'عَلَى قَتاد':Predicate, #7: 7	عَلَى قَبَائِلَ
u'عَلِيَ قَدْرٌ':Predicate, #4: 4	عَلَى قَتَادَةَ
u'عَلَى قَدْرٌ':Predicate, #1: 1	أَعْلَى قَدْرَ
u'عَلَى قَرَارِيطُ':Predicate, #2: 2	عَلَى قَدْرَ
u'عَلَى قرائن':Predicate, #1: 1	عَلَى قَرَارِيطَ
u'عَلَى قُزَحٌ':Predicate, #2: 2	عَلَى قَرَائِنَ
u'عَلَى قَصْدٌ':Predicate, #3: 3	عَلَى قُزَحَ
u'عَلَى قَفَا':Predicate, #1: 1	عَلَى الْقَصْدَ
u'عَلَى قَفَا':Subject, #3: 3	عَلَى قَفَاكَ
u'عَلَى قَوَاعِدُ':Predicate, #43: 43	عَلَى قَفَاهُ
u'عَلَى قوائم':Predicate, #3: 3	عَلَى قَوَاعِدَ
u'عَلَى قَوَائِمُ':Predicate, #1: 1	عَلَى قَوَائِمَ
u'عَلَى قِيَاسٌ':Subject, #1: 1	عَلَى قَوَائِمَ
u'عَلَى قَيْصَرٌ':Predicate, #1: 1	عَلَى قِيَاسُ
u'عَلَى كَاذِبٌ':Predicate, #6: 6	عَلَى قَيْصَرَ
u'عَلَى كَافِرٌ':Predicate, #6: 6	عَلَى الْكَاذِبِينَ
u'عَلَى كَامِلٌ':Predicate, #14: 14	عَلَى الْكَافِرِينَ
u'عَلَى كبائر':Predicate, #1: 1	عَلَى الْكَامِلِينَ
u'عَلَى كَثِيرٌ':Predicate, #1: 1	عَلَى كَبَائِرَ
u'عَلَى كَذَّابٌ':Predicate, #15: 15	عَلَى كَثِيرِينَ
u'عَلَى كَفِيلٌ':Subject, #1: 1	عَلَى الْكَذَّابِينَ
u'عَلَى كَلِمَةٌ':Subject, #1: 1	عَلَى الْكَفِيلُ
u'عَلَى كِنَانَةٌ':Predicate, #2: 2	عَلَى كَلِمَةُ
u'عَلَى لاَعِبٌ':Predicate, #2: 2	عَلَى كِنَانَةَ
u'عَلَى لبس':Subject, #1: 1	عَلَى اللَّاعِبِينَ
u'عَلَى لُبْسٌ':Subject, #1: 1	عَلَى اللُّبْسُ
u'عَلَى لَفْظٌ':Subject, #1: 1	عَلَى اللُّبْسُ
u'عَلَى مَارٌّ':Predicate, #1: 1	عَلَى لَفْظٌ
u'عَلَى مَالِكٌ':Predicate, #1: 1	عَلَى الْمَارِّينَ
u'عَلَى مَالِكٌ':Predicate, #1: 1	عَلَى الْمَالِكِينَ
u'عَلَى مَأْمُورٌ':Predicate, #3: 3	عَلَى مَالِكَ
u'عَلَى مَانِعٌ':Predicate, #1: 1	عَلَى الْمَأْمُورِينَ
u'عَلَى مُتَأَخِّرٌ':Predicate, #1: 1	عَلَى الْمَانِعِينَ
u'عَلَى مُتَبَحِّرٌ':Predicate, #3: 3	عَلَى الْمُتَأَخِّرِينَ
u'عَلَى مُتَحابّ':Predicate, #1: 1	عَلَى الْمُتَبَحِّرِينَ
u'عَلَى مُتَعَبِّدٌ':Predicate, #1: 1	عَلَى الْمُتَحَابِّينَ
u'عَلَى مُتَعَلِّمٌ':Predicate, #2: 2	عَلَى الْمُتَعَبِّدِينَ
u'عَلَى مُتَقَبِّلٌ':Predicate, #1: 1	عَلَى الْمُتَعَلِّمِينَ
u'عَلَى مُتَكَلِّمٌ':Predicate, #1: 1	عَلَى الْمُتَقَبِّلِينَ
u'عَلَى مُتَلاَئِمٌ':Subject, #2: 2	عَلَى الْمُتَكَلِّمِينَ
u'عَلَى مُتَلَبِّسٌ':Predicate, #1: 1	عَلَى مُتَلَائِمٌ
u'عَلَى مُتَّهَمٌ':Predicate, #1: 1	عَلَى الْمُتَلَبِّسِينَ
u'عَلَى مُتَوَكِّلٌ':Predicate, #1: 1	عَلَى الْمُتَّهَمِينَ
u'عَلِيَ مثل':Predicate, #1: 1	عَلَى الْمُتَوَكِّلِينَ
u'عَلِيَ مِثْلٌ':Predicate, #1: 1	أَعْلَى مِثْلَ
u'عَلَى مثل':Predicate, #1: 1	أَعْلَى مِثْلَ
u'عَلَى مِثْلٌ':Predicate, #1: 1	عَلَى مِثْلَ
u'عَلَى مثل':Subject, #1: 1	عَلَى مِثْلَ
u'عَلَى مِثْلٌ':Subject, #1: 1	عَلَى مِثْلُهُ
u'عَلَى مُجَاهِدٌ':Predicate, #1: 1	عَلَى مِثْلُهُ
u'عَلَى مُجْبِرٌ':Predicate, #5: 5	عَلَى الْمُجَاهِدِينَ
u'عَلَى مُجْتَهِد':Predicate, #1: 1	عَلَى الْمُجْبِرِينَ
u'عَلَى مُجْمِعٌ':Predicate, #2: 2	عَلَى الْمُجْتَهِدِينَ
u'عَلَى مُجِيزٌ':Predicate, #1: 1	عَلَى الْمُجْمِعِينَ
u'عَلَى مُحَارِبٌ':Predicate, #2: 2	عَلَى الْمُجِيزِينَ
u'عَلَى مَحَامِلُ':Predicate, #4: 4	عَلَى الْمُحَارِبِينَ
u'عَلَى مُحْتَاجٌ':Predicate, #1: 1	عَلَى مَحَامِلَ
u'عَلَى مُحْتَاجٌ':Predicate, #11: 11	عَلَى الْمُحْتَاجِينَ
u'عَلَى مُحْتَجٌّ':Predicate, #1: 1	عَلَى مُحْتَاجِينَ
u'عَلَى مَحْجُورٌ':Predicate, #1: 1	عَلَى الْمُحْتَجِّينَ
u'عَلَى مُحْدِثٌ':Predicate, #1: 1	عَلَى الْمَحْجُورِينَ
u'عَلَى مُحْرِمٌ':Predicate, #1: 1	عَلَى الْمُحْدِثِينَ
u'عَلَى مُحْرِمٌ':Subject, #3: 3	عَلَى الْمُحْرِمِينَ
u'عَلَى مُحْسِنٌ':Predicate, #1: 1	عَلَى الْمُحْرِمُ
u'عَلَى مُحَصِّل':Predicate, #20: 20	عَلَى الْمُحْسِنِينَ
u'عَلَى مُحَلِّقٌ':Predicate, #2: 2	عَلَى الْمُحَصِّلِينَ
u'عَلَى مُحَمَّدٌ':Subject, #1: 1	عَلَى الْمُحَلِّقِينَ
u'عَلَى مُخَاطَبٌ':Predicate, #1: 1	عَلَى مُحَمَّدٌ
u'عَلَى مُخَالِفٌ':Predicate, #2: 2	عَلَى الْمُخَاطَبِينَ
u'عَلَى مُخْبِرٌ':Predicate, #4: 4	عَلَى الْمُخَالِفِينَ
u'عَلَى مَخْلُوقٌ':Predicate, #1: 1	عَلَى الْمُخْبِرِينَ
u'عَلَى مَدَارِسُ':Predicate, #1: 1	عَلَى الْمَخْلُوقِينَ
u'عَلَى مُدَرِّسٌ':Predicate, #1: 1	عَلَى مَدَارِسَ
u'عَلَى مَدْعُوٌّ':Predicate, #3: 3	عَلَى الْمُدَرِّسِينَ
u'عَلَى مَدَنِيٌّ':Predicate, #1: 1	عَلَى الْمَدْعُوِّينَ
u'عَلَى مَدِينٌ':Predicate, #1: 1	عَلَى الْمَدَنِيِّينَ
u'عَلَى مَدْيُونٌ':Predicate, #1: 1	عَلَى الْمَدِينِينَ
u'عَلَى مَذَاهِبُ':Predicate, #1: 1	عَلَى الْمَدْيُونَ
u'عَلَى مَذْكُورٌ':Predicate, #38: 38	عَلَى مَذَاهِبَ
u'عَلَى مَرَاتِبُ':Predicate, #1: 1	عَلَى الْمَذْكُورِينَ
u'عَلَى مَرَافِقُ':Predicate, #25: 25	عَلَى مَرَاتِبَ
u'عَلَى مَرَاكِبُ':Predicate, #1: 1	عَلَى مَرَافِقَ
u'عَلَى مرائر':Predicate, #3: 3	عَلَى مَرَاكِبَ
u'عَلَى مُرْتَدٌّ':Predicate, #1: 1	عَلَى مَرَائِرَ
u'عَلَى مُرَجَّحٌ':Subject, #6: 6	عَلَى الْمُرْتَدِّينَ
u'عَلَى مُرْسَلٌ':Predicate, #1: 1	عَلَى مُرَجَّحُ
u'عَلَى مُزَارِعٌ':Predicate, #11: 11	عَلَى الْمُرْسَلِينَ
u'عَلَى مَسَاجِدُ':Predicate, #1: 1	عَلَى الْمُزَارِعِينَ
u'عَلَى مَسَافَةٌ':Predicate, #1: 1	عَلَى مَسَاجِدَ
u'عَلَى مُسَافِرٌ':Predicate, #1: 1	عَلَى مَسَافَةَ
u'عَلَى مساكين':Predicate, #2: 2	عَلَى الْمُسَافِرِينَ
u'عَلَى مساكين':Predicate, #2: 2	عَلَى الْمَسَاكِينَ
u'عَلَى مَسْأَلَةٌ':Subject, #3: 3	عَلَى مَسَاكِينَ
u'عَلَى مَسَائِلُ':Predicate, #1: 1	عَلَى مَسْأَلَتُهُ
u'عَلَى مُسْتَحِقٌّ':Predicate, #35: 35	عَلَى مَسَائِلَ
u'عَلَى مُسْتَضْعَف':Predicate, #30: 30	عَلَى الْمُسْتَحِقِّينَ
u'عَلَى مُسْتَوْطِن':Predicate, #1: 1	عَلَى الْمُسْتَضْعَفِينَ
u'عَلَى مُسْلِمٌ':Predicate, #3: 3	عَلَى الْمُسْتَوْطِنِينَ
u'عَلَى مُشْتَرِكٌ':Predicate, #272: 272	عَلَى الْمُسْلِمِينَ
u'عَلَى مُشْتَرَكٌ':Subject, #3: 3	عَلَى الْمُشْتَرِكِينَ
u'عَلَى مُشْتَغِل':Predicate, #1: 1	عَلَى مُشْتَرَكَةٌ
u'عَلَى مُشْرِك':Predicate, #1: 1	عَلَى الْمُشْتَغِلِينَ
u'عَلَى مَصَاحِفُ':Predicate, #28: 28	عَلَى الْمُشْرِكِينَ
u'عَلَى مَصَالِحُ':Predicate, #1: 1	عَلَى مَصَاحِفَ
u'عَلَى مُصَدِّقٌ':Subject, #2: 2	عَلَى مَصَالِحَ
u'عَلَى مِصْرٌ':Predicate, #1: 1	عَلَى الْمُصَدِّقُ
u'عَلَى مُصَنِّفٌ':Subject, #8: 8	عَلَى مِصْرَ
u'عَلَى مُصِيبٌ':Predicate, #2: 2	عَلَى الْمُصَنِّفُ
u'عَلَى مُضْطَرٌّ':Predicate, #1: 1	عَلَى الْمُصِيبِينَ
u'عَلَى مُطْلَقٌ':Subject, #1: 1	عَلَى الْمُضْطَرِّينَ
u'عَلَى مَظْلُومٌ':Predicate, #1: 1	عَلَى الْمُطْلَقَةُ
u'عَلَى مَعَالِمُ':Predicate, #1: 1	عَلَى الْمَظْلُومِينَ
u'عَلِيَ مَعَالِمُ':Predicate, #1: 1	عَلَى مَعَالِمَ
u'عَلَى مُعاوِيَة':Predicate, #2: 2	أَعْلَى مَعَالِمَ
u'عَلَى مُعْتَمَدٌ':Predicate, #18: 18	عَلَى مُعَاوِيَةَ
u'عَلَى مَعْدِنٌ':Subject, #1: 1	عَلَى الْمُعْتَمَدِينَ
u'عَلَى مَعْذُورٌ':Predicate, #1: 1	عَلَى مَعْدِنٌ
u'عَلَى مَعْرِفَةٌ':Subject, #1: 1	عَلَى الْمَعْذُورِينَ
u'عَلَى مَعْرِفَة':Subject, #1: 1	عَلَى الْمَعْرِفَةُ
u'عَلَى مَعْرِفَةٌ':Subject, #1: 1	عَلَى الْمَعْرِفَةُ
u'عَلَى مَعْرِفَة':Subject, #1: 1	عَلَى مَعْرِفَةُ
u'عَلَى مُعْسِرٌ':Predicate, #1: 1	عَلَى مَعْرِفَةُ
u'عَلَى مُعَلَّمٌ':Predicate, #1: 1	عَلَى الْمُعْسِرِينَ
u'عَلَى مُعَلِّمٌ':Predicate, #1: 1	عَلَى الْمُعَلَّمِينَ
u'عَلَى مُعَيَّنٌ':Predicate, #1: 1	عَلَى الْمُعَلِّمِينَ
u'عَلَى مَغْلُوبٌ':Predicate, #18: 18	عَلَى مُعَيَّنِينَ
u'عَلَى مَفَاسِدُ':Predicate, #1: 1	عَلَى الْمَغْلُوبِينَ
u'عَلَى مُفَاوَضَةٌ':Subject, #5: 5	عَلَى مَفَاسِدَ
u'عَلَى مُفْسِدٌ':Predicate, #1: 1	عَلَى مُفَاوَضَةٌ
u'عَلَى مُقَابِلٌ':Subject, #1: 1	عَلَى الْمُفْسِدِينَ
u'عَلَى مَقَاصِدُ':Predicate, #1: 1	عَلَى مُقَابِلُ
u'عَلَى مَقَاصِيرُ':Predicate, #2: 2	عَلَى مَقَاصِدَ
u'عَلَى مُقَامٌ':Predicate, #1: 1	عَلَى مَقَاصِيرَ
u'عَلَى مُقْتَسِمٌ':Predicate, #1: 1	عَلَى مُقَامَ
u'عَلَى مُقَصِّرٌ':Predicate, #1: 1	عَلَى الْمُقْتَسِمِينَ
u'عَلَى مُقِلٌّ':Predicate, #1: 1	عَلَى الْمُقَصِّرِينَ
u'عَلَى مُقَلَّدٌ':Predicate, #1: 1	عَلَى الْمُقِلِّينَ
u'عَلَى مُقَوِّمٌ':Predicate, #1: 1	عَلَى الْمُقَلَّدِينَ
u'عَلَى مُقِيمٌ':Predicate, #1: 1	عَلَى الْمُقَوِّمِينَ
u'عَلَى مُكَلَّفٌ':Predicate, #3: 3	عَلَى الْمُقِيمِينَ
u'عَلَى مُلاَزِمٌ':Predicate, #17: 17	عَلَى الْمُكَلَّفِينَ
u'عَلَى مِلْكٌ':Subject, #1: 1	عَلَى الْمُلَازِمِينَ
u'عَلَى مَمْلُوكٌ':Predicate, #1: 1	عَلَى مِلْكُ
u'عَلَى مَنَابِرُ':Predicate, #2: 2	عَلَى الْمَمْلُوكِينَ
u'عَلَى مَنَافِعُ':Predicate, #10: 10	عَلَى مَنَابِرَ
u'عَلَى مُنَافِقٌ':Predicate, #3: 3	عَلَى مَنَافِعَ
u'عَلَى مِنْبَرٌ':Predicate, #19: 19	عَلَى الْمُنَافِقِينَ
u'عَلَى مُنْتَسِبٌ':Predicate, #1: 1	عَلَى الْمِنْبَرَ
u'عَلَى مُنَجِّمٌ':Predicate, #1: 1	عَلَى الْمُنْتَسِبِينَ
u'عَلَى مَنْصُوصٌ':Subject, #1: 1	عَلَى الْمُنَجِّمِينَ
u'عَلَى مَنْطِقِيٌّ':Predicate, #2: 2	عَلَى الْمَنْصُوصُ
u'عَلَى مُنْكِرٌ':Predicate, #3: 3	عَلَى الْمَنْطِقِيِّينَ
u'عَلَى مُنْهَمِكٌ':Predicate, #4: 4	عَلَى الْمُنْكِرِينَ
u'عَلَى مُهَاجِرٌ':Predicate, #1: 1	عَلَى الْمُنْهَمِكِينَ
u'عَلَى مَوَاضِعُ':Predicate, #13: 13	عَلَى الْمُهَاجِرِينَ
u'عَلَى مَوْجُودٌ':Predicate, #2: 2	عَلَى مَوَاضِعَ
u'عَلَى مُوسِرٌ':Predicate, #7: 7	عَلَى الْمَوْجُودِينَ
u'عَلَى مَوْقُوفٌ':Subject, #1: 1	عَلَى الْمُوسِرِينَ
u'عَلَى مُؤَكِّدٌ':Predicate, #1: 1	عَلَى مَوْقُوفَةٌ
u'عَلَى مُوَكِّلٌ':Subject, #1: 1	عَلَى مُؤَكِّدَةً
u'عَلَى مُؤْمِنٌ':Predicate, #1: 1	عَلَى مُوَكِّلُهُ
u'عَلَى مَيْمُونٌ':Predicate, #111: 111	عَلَى الْمُؤْمِنِينَ
u'عَلَى نَاظِرٌ':Predicate, #6: 6	عَلَى مَيْمُونَةَ
u'عَلَى نَاقِصٌ':Predicate, #3: 3	عَلَى النَّاظِرِينَ
u'عَلَى نَائِلٌ':Predicate, #1: 1	عَلَى النَّاقِصِينَ
u'عَلَى نَبِيٌّ':Predicate, #1: 1	عَلَى نَائِلَةَ
u'عَلَى نَبِيٌّ':Subject, #1: 1	عَلَى النَّبِيِّينَ
u'عَلَى نَجْرَان':Predicate, #1: 1	عَلَى النَّبِيُّ
u'عَلَى نَحْوِيٌّ':Predicate, #3: 3	عَلَى نَجْرَانَ
u'عَلَى نخلة':Predicate, #1: 1	عَلَى النّحْوِيّينَ
u'عَلَى نَخْلَةٌ':Predicate, #1: 1	عَلَى نَخْلَةَ
u'عَلَى نِساءٌ':Subject, #1: 1	عَلَى نَخْلَةَ
u'عَلَى نَفْسٌ':Subject, #1: 1	عَلَى النِّسَاءُ
u'عَلَى نَوَادِرُ':Predicate, #1: 1	عَلَى نَفْسُهُ
u'عَلَى هَادِمٌ':Predicate, #1: 1	عَلَى نَوَادِرَ
u'عَلَى هبل':Predicate, #1: 1	عَلَى الْهَادِمِينَ
u'عَلَى هُبَيْرَة':Predicate, #1: 1	عَلَى هُبَلَ
u'عَلَى وَاجِبٌ':Subject, #2: 2	عَلَى هُبَيْرَةَ
u'عَلَى واحد':Predicate, #1: 1	عَلَى وَاجِبٌ
u'عَلَى وَاحِدٌ':Predicate, #1: 1	عَلَى وَاحِدَةً
u'عَلَى وَادِعٌ':Predicate, #1: 1	عَلَى وَاحِدَةً
u'عَلَى وَارِدٌ':Predicate, #1: 1	عَلَى وَادِعَةَ
u'عَلَى وَاطِئٌ':Predicate, #5: 5	عَلَى الْوَارِدِينَ
u'عَلَى وُجُوبٌ':Subject, #3: 3	عَلَى الْوَاطِئِينَ
u'عَلَى وَسَائِدُ':Predicate, #1: 1	عَلَى وُجُوبُ
u'عَلَى وَطْءٌ':Subject, #1: 1	عَلَى وَسَائِدَ
u'عَلَى وَظَائِفُ':Predicate, #1: 1	عَلَى الْوَطْءُ
u'عَلَى وقع':Predicate, #1: 1	عَلَى وَظَائِفَ
u'عَلَى وَلَدٌ':Subject, #2: 2	عَلَى وَقَعَ
u'عَلَى وَلِيٌّ':Subject, #1: 1	عَلَى وَلَدَاهُ
u'عَلَى يَعْقُوبٌ':Predicate, #1: 1	عَلَى الْوَلِيُّ
u'عَمَّاتٌ أَبٌ':Added, #2: 2	عَلَى يَعْقُوبَ
u'عَمَّاتٌ آباءٌ':Added, #1: 1	عَمَّاتِ أَبٍ
u'عَمَّاتٌ أُمٌّ':Added, #2: 2	عَمَّاتُ الْآبَاءِ
u'عَمَّاتٌ أُمَّهَاتٌ':Added, #1: 1	عَمَّاتِ الْأُمِّ
u'عَمَّاتٌ أيتام':Added, #1: 1	عَمَّاتُ الْأُمَّهَاتِ
u'عَمَّاتٌ رَضيعٌ':Added, #1: 1	عَمَّاتِ الْأَيْتَامِ
u'عَمَّ أَجْزَاءٌ':Predicate, #1: 1	عَمَّاتُ الرَّضِيعِ
u'عِمَارَةٌ أرْضٌ':Added, #1: 1	عَمَّ أَجْزَاءَ
u'عِمَارَةٌ أرْضٌ':Added, #1: 1	عِمَارَةِ أَرْضٍ
u'عِمَارَةٌ أَمْلاكٌ':Added, #4: 4	عِمَارَةِ الْأَرْضِ
u'عِمَارَةٌ أَمْلاَكٌ':Added, #2: 2	عِمَارَةِ أَمْلَاكِهِ
u'عِمَارَةٌ أَوْقَافٌ':Added, #2: 2	عِمَارَةِ أَمْلَاكِهِ
u'عِمَارَةٌ بَقِيَّةٌ':Added, #1: 1	عِمَارَةَ الْأَوْقَافِ
u'عِمَارَةٌ بَلَدٌ':Added, #1: 1	عِمَارَةِ بَقِيَّةِ
u'عِمَارَةٌ بُلْدانٌ':Added, #1: 1	عِمَارَةِ الْبَلَدِ
u'عِمَارَةٌ بِنَاءٌ':Added, #1: 1	عِمَارَةُ الْبُلْدَانِ
u'عِمَارَةٌ بِئْرٌ':Added, #3: 3	عِمَارَةِ الْبِنَاءِ
u'عِمَارَةٌ بَيْتٌ':Added, #2: 2	عِمَارَةِ بِئْرٍ
u'عِمَارَةٌ بَيْتٌ':Added, #1: 1	عِمَارَةَ الْبَيْتِ
u'عِمَارَةٌ بَيْتٌ':Added, #1: 1	عِمَارَةُ الْبَيْتِ
u'عِمَارَةٌ بَيْتٌ':Added, #1: 1	عِمَارَةِ بَيْتِ
u'عِمَارَةٌ بَيْعٌ':Added, #2: 2	عِمَارَةَ بَيْتِ
u'عِمَارَةٌ بِيَعٌ':Added, #1: 1	عِمَارَةُ الْبَيْعِ
u'عِمَارَةٌ جَاهِلِيٌّ':Added, #1: 1	عِمَارَةِ الْبِيَعِ
u'عِمَارَةٌ جَاهِلِيَّةٌ':Added, #1: 1	عِمَارَةِ جَاهِلِيَّةٍ
u'عِمَارَةٌ جُدْرَانٌ':Added, #1: 1	عِمَارَةِ جَاهِلِيَّةٍ
u'عِمَارَةٌ حاجِزٌ':Added, #1: 1	عِمَارَةِ الْجُدْرَانِ
u'عِمَارَةٌ حانوتٌ':Added, #1: 1	عِمَارَةُ الْحَاجِزِ
u'عِمَارَةٌ حانوتٌ':Added, #1: 1	عِمَارَةُ الْحَانُوتِ
u'عِمَارَةٌ حائِطٌ':Added, #1: 1	عِمَارَةَ حَانُوتٍ
u'عِمَارَةٌ حَرَمٌ':Added, #1: 1	عِمَارَةِ الْحَائِطِ
u'عِمَارَةٌ خَرَابٌ':Added, #1: 1	عِمَارَةِ الْحَرَمَيْنِ
u'عِمَارَةٌ دَارٌ':Added, #1: 1	عِمَارَةِ خَرَابٍ
u'عِمَارَةٌ دَارٌ':Added, #1: 1	عِمَارَةِ دَارِهِ
u'عِمَارَةٌ دَارٌ':Added, #2: 2	عِمَارَةِ دَارِ
u'عِمَارَةٌ دَارٌ':Added, #2: 2	عِمَارَةَ دَارِهِ
u'عِمَارَةٌ دَارٌ':Added, #3: 3	عِمَارَةِ دَارٍ
u'عِمَارَةٌ ذِمَّةٌ':Added, #6: 6	عِمَارَةِ الدَّارِ
u'عِمَارَةٌ ذِمَّةٌ':Added, #1: 1	عِمَارَةَ ذِمَّةٍ
u'عِمَارَةٌ ذِمَّةٌ':Added, #1: 1	عِمَارَةَ ذِمَّةِ
u'عِمَارَةٌ ذِمَّةٌ':Added, #1: 1	عِمَارَةِ ذِمَّةٍ
u'عِمَارَةٌ رباط':Added, #1: 1	عِمَارَةُ ذِمَّتِهِ
u'عِمَارَةٌ رِبَاطٌ':Added, #6: 6	عِمَارَةِ الرِّبَاطِ
u'عِمَارَةٌ سورٌ':Added, #6: 6	عِمَارَةِ الرِّبَاطِ
u'عِمَارَةٌ سورٌ':Added, #1: 1	عِمَارَةَ السُّورِ
u'عِمَارَةٌ عَقَارٌ':Added, #2: 2	عِمَارَةِ السُّورِ
u'عِمَارَةٌ عَقَارٌ':Added, #1: 1	عِمَارَةُ الْعَقَارِ
u'عِمَارَةٌ عَقَارٌ':Added, #1: 1	عِمَارَةُ عَقَارِ
u'عِمَارَةٌ عُلُوٌّ':Added, #1: 1	عِمَارَةَ عَقَارِهِ
u'عِمَارَةٌ عين':Added, #1: 1	عِمَارَةُ الْعُلُوِّ
u'عِمَارَةٌ عَيْنٌ':Added, #1: 1	عِمَارَةِ الْعَيْنِ
u'عِمَارَةٌ عَيْن':Added, #1: 1	عِمَارَةِ الْعَيْنِ
u'عِمَارَةٌ قَائِمٌ':Added, #1: 1	عِمَارَةِ الْعَيْنِ
u'عِمَارَةٌ قَبْرٌ':Added, #1: 1	عِمَارَةِ الْقَائِمِ
u'عِمَارَةٌ قُبُورٌ':Added, #1: 1	عِمَارَةَ قَبْرٍ
u'عِمَارَةٌ قَنْطَرَةٌ':Added, #1: 1	عِمَارَةِ الْقُبُورِ
u'عِمَارَةٌ قَنْطَرَةٌ':Added, #1: 1	عِمَارَةُ الْقَنْطَرَةِ
u'عِمَارَةٌ قَنْطَرَةٌ':Added, #2: 2	عِمَارَةِ الْقَنْطَرَةِ
u'عِمَارَةٌ مَائِلٌ':Added, #2: 2	عِمَارَةِ قَنْطَرَةِ
u'عِمَارَةٌ مَدْرَسَةٌ':Added, #1: 1	عِمَارَةُ الْمَائِلِ
u'عِمَارَةٌ مَسَاجِدُ':Added, #2: 2	عِمَارَةِ الْمَدْرَسَةِ
u'عِمَارَةٌ مَسَاجِدُ':Added, #1: 1	عِمَارَةُ الْمَسَاجِدِ
u'عِمَارَةٌ مُسْتَأْجِرٌ':Added, #3: 3	عِمَارَةِ الْمَسَاجِدِ
u'عِمَارَةٌ مَسْجِدٌ':Added, #1: 1	عِمَارَةُ الْمُسْتَأْجِرِ
u'عِمَارَةٌ مَسْجِدٌ':Added, #1: 1	عِمَارَةَ الْمَسْجِدِ
u'عِمَارَةٌ مَسْجِدٌ':Added, #28: 28	عِمَارَةِ الْمَسْجِدِ
u'عِمَارَةٌ مَسْجِدٌ':Added, #4: 4	عِمَارَةُ الْمَسْجِدِ
u'عِمَارَةٌ مَسْجِدٌ':Added, #4: 4	عِمَارَةُ مَسْجِدٍ
u'عِمَارَةٌ مَقْبَرَةٌ':Added, #6: 6	عِمَارَةِ مَسْجِدٍ
u'عِمَارَةٌ مَقْبَرَةٌ':Added, #1: 1	عِمَارَةُ الْمَقْبَرَةِ
u'عِمَارَةٌ مِلْكٌ':Added, #2: 2	عِمَارَةِ الْمَقْبَرَةِ
u'عِمَارَةٌ مَمَرٌّ':Added, #2: 2	عِمَارَةُ مِلْكِهِ
u'عِمَارَةٌ مَنْزِلٌ':Added, #1: 1	عِمَارَةِ الْمَمَرِّ
u'عِمَارَةٌ مَنْقُولٌ':Added, #2: 2	عِمَارَةِ الْمَنْزِلِ
u'عِمَارَةٌ مَوْضِعٌ':Added, #1: 1	عِمَارَةِ الْمَنْقُولِ
u'عِمَارَةٌ مَوْقُوفٌ':Added, #1: 1	عِمَارَةُ الْمَوْضِعِ
u'عِمَارَةٌ نَهْرٌ':Added, #1: 1	عِمَارَةِ الْمَوْقُوفِ
u'عِمَارَةٌ وَقْفٌ':Added, #5: 5	عِمَارَةِ النَّهْرِ
u'عِمَارَةٌ وَقْفٌ':Added, #18: 18	عِمَارَةِ الْوَقْفِ
u'عِمَارَةٌ وَقْفٌ':Added, #1: 1	عِمَارَةُ وَقْفٍ
u'عِمَارَةٌ وَقْفٌ':Added, #1: 1	عِمَارَةِ وَقْفٍ
u'عَمَّ أرْضٌ':Predicate, #4: 4	عِمَارَةُ الْوَقْفِ
u'عَمَّ اِسْتِعْمالٌ':Subject, #1: 1	عَمَّ الْأَرْضَ
u'عَمَّ أَشْرِبَةٌ':Predicate, #1: 1	عَمَّ اسْتِعْمَالُهُ
u'عَمَّ إِشْكالٌ':Subject, #1: 1	عَمَّ الأَشْرِبَةَ
u'عَمَّ أَفْرَادٌ':Predicate, #1: 1	عَمَّ الْإِشْكَالُ
u'عَمَّ الْمَرْءُ':Subject, #1: 1	عَمَّ أَفْرَادَ
u'عَمَّ أَمْرٌ':Subject, #1: 1	عَمَّ الْمَرْءُ
u'عَمَّ أهْلٌ':Predicate, #1: 1	عَمَّ أَمْرُهُ
u'عَمَايَةٌ صُبْحٌ':Added, #1: 1	عَمَّ أَهْلَ
u'عَمَّ بَطْنٌ':Subject, #1: 1	عَمَايَةِ الصّبْحِ
u'عَمَّ بَعْضٌ':Subject, #1: 1	عَمَّ الْبَطْنُ
u'عَمَّ بَلاءٌ':Subject, #1: 1	عَمَّ بَعْضُ
u'عَمَّةٌ أَبٌ':Added, #2: 2	عَمَّ الْبَلَاءُ
u'عَمَّةٌ أَبٌ':Added, #3: 3	عَمَّةِ الْأَبِ
u'عَمَّةٌ أَبٌ':Added, #4: 4	عَمَّةَ الْأَبِ
u'عَمَّةٌ أُمٌّ':Added, #8: 8	عَمَّةُ الْأَبِ
u'عَمَّةٌ أُمٌّ':Added, #1: 1	عَمَّةَ الْأُمِّ
u'عَمَّةٌ أُمٌّ':Added, #1: 1	عَمَّةِ أُمِّ
u'عَمَّةٌ حزام':Added, #5: 5	عَمَّةُ الْأُمِّ
u'عَمَّةٌ خَالٌ':Added, #1: 1	عَمَّةِ حَزَامِ
u'عَمَّةٌ خَالٌ':Added, #1: 1	عَمَّةُ الْخَالِ
u'عَمَّةٌ رَسُولٌ':Added, #3: 3	عَمَّةُ الْخَالَةِ
u'عَمَّةٌ رَسُولٌ':Added, #1: 1	عَمَّةِ رَسُولِ
u'عَمَّةٌ رَسُولٌ':Added, #4: 4	عَمَّةُ رَسُولِ
u'عَمَّةٌ صَغِيرٌ':Added, #6: 6	عَمَّةَ رَسُولِ
u'عَمَّةٌ صَغِيرٌ':Added, #1: 1	عَمَّةُ الصَّغِيرِ
u'عَمَّةٌ عَبْدٌ':Added, #1: 1	عَمَّةِ الصَّغِيرِ
u'عَمَّةٌ عَمٌّ':Added, #1: 1	عَمَّةَ عَبْدِ
u'عَمَّةٌ عَمَّةٌ':Added, #1: 1	عَمَّةَ الْعَمِّ
u'عَمَّةٌ كَبِيرٌ':Added, #6: 6	عَمَّةُ الْعَمَّةِ
u'عَمَّةٌ نَبِيٌّ':Added, #2: 2	عَمَّةُ الْكَبِيرَةِ
u'عَمَّةٌ ولد':Added, #2: 2	عَمَّةِ النَّبِيِّ
u'عَمَّةٌ وَلَدٌ':Added, #1: 1	عَمَّةُ الْوَلَدِ
u'عَمَّةٌ ولد':Added, #1: 1	عَمَّةُ الْوَلَدِ
u'عَمَّةٌ وَلَدٌ':Added, #3: 3	عَمَّةِ وَلَدِهِ
u'عَمَّ تَحْرِيمٌ':Subject, #3: 3	عَمَّةِ وَلَدِهِ
u'عَمَّ تَصْوِيرٌ':Subject, #1: 1	عَمَّ التَّحْرِيمُ
u'عَمَّ جَرَادٌ':Subject, #1: 1	عَمَّ التَّصْوِيرُ
u'عَمَّ جواري':Predicate, #4: 4	عَمَّ الْجَرَادُ
u'عَمَّ جَوَارِي':Predicate, #1: 1	عَمَّ الْجَوَارِيَ
u'عَمَّ حَرامٌ':Subject, #1: 1	عَمَّ الْجَوَارِيَ
u'عَمَدَ اِبْنٌ':Subject, #4: 4	عَمَّ الْحَرَامُ
u'عَمْدٌ إِتْلاَفٌ':Added, #1: 1	عَمَدَ ابْنُهُ
u'عَمَدَ بَاطِلٌ':Predicate, #1: 1	عَمْدَ الْإِتْلَافِ
u'عَمَدَ بَائِعٌ':Subject, #1: 1	عَمَدَ الْبَاطِلَ
u'عَمِدَ بَعيرٌ':Subject, #1: 1	عَمَدَ الْبَائِعُ
u'عَمْدٌ تَرْكٌ':Added, #1: 1	عَمِدَ الْبَعِيرُ
u'عَمْدٌ تَرْكٌ':Added, #1: 1	عَمْدُ تَرْكِ
u'عَمْدٌ تَكْفيرٌ':Added, #1: 1	عَمْدِ تَرْكِ
u'عَمْدٌ جِرَاحَاتٌ':Added, #1: 1	عَمْدِ تَكْفِيرِ
u'عَمْدٌ جِرَاحَةٌ':Added, #1: 1	عَمْدِ جِرَاحَاتِ
u'عَمَدَ حارِثٌ':Subject, #1: 1	عَمْدِ جِرَاحَاتِ
u'عَمَدَ حُداةٌ':Subject, #1: 1	عَمَدَ الْحَارِثُ
u'عَمْدٌ حَدَثٌ':Added, #1: 1	عَمَدَ الْحُدَاةُ
u'عَمَدَ حَمِيمٌ':Subject, #1: 1	عَمْدُ الْحَدَثِ
u'عَمَدَ خَطَأٌ':Predicate, #2: 2	عَمَدَ حَمِيمُ
u'عَمْدٌ خَطَأٌ':Added, #1: 1	عَمَدَ الْخَطَأَ
u'عَمْدٌ خَطَأٌ':Added, #1: 1	عَمْدِ الْخَطَأِ
u'عَمْدٌ صَبِيٌّ':Added, #1: 1	عَمْدُ خَطَأٍ
u'عَمْدٌ صَبِيٌّ':Added, #1: 1	عَمْدُ الصَّبِيِّ
u'عَمْدٌ صِبْيَانٌ':Added, #4: 4	عَمْدَ الصَّبِيِّ
u'عَمْدٌ عُدْوَانٌ':Added, #1: 1	عَمْدَ الصِّبْيَانِ
u'عَمْدٌ عُدْوَانٌ':Added, #1: 1	عَمْدِ الْعُدْوَانِ
u'عَمْدٌ فِعْلٌ':Added, #3: 3	عَمْدٍ عُدْوَانٍ
u'عَمْدٌ قتل':Added, #1: 1	عَمْدِ فِعْلٍ
u'عَمْدٌ قَتْلٌ':Added, #2: 2	عَمْدِ الْقَتْلِ
u'عَمَدَ قَوْمٌ':Subject, #2: 2	عَمْدِ الْقَتْلِ
u'عَمْدٌ كذب':Added, #1: 1	عَمَدَ قَوْمٌ
u'عَمْدٌ كَذِبٌ':Added, #1: 1	عَمْدِ الْكَذِبِ
u'عَمْدٌ مَجْنُونٌ':Added, #1: 1	عَمْدِ الْكَذِبِ
u'عَمْدٌ مَحْضٌ':Added, #2: 2	عَمْدُ الْمَجْنُونِ
u'عَمْدٌ وَاجِبٌ':Added, #1: 1	عَمْدٍ مَحْضٍ
u'عَمَّ ذُكورٌ':Predicate, #1: 1	عَمْدٍ وَاجِبٍ
u'عَمَرَ أرْضٌ':Predicate, #1: 1	عَمَّ الذُّكُورَ
u'عَمَّرَ أَكْثَرُ':Predicate, #1: 1	عَمَرَ الْأَرْضَ
u'عُمْرَانٌ إِسْلامٌ':Added, #2: 2	عَمَّرَ أَكْثَرَ
u'عُمْرَانٌ بَلَدٌ':Added, #1: 1	عُمْرَانُ الْإِسْلَامِ
u'عُمْرَانٌ بَلَدٌ':Added, #1: 1	عُمْرَانَ الْبَلَدِ
u'عُمْرَانٌ بَيْتٌ':Added, #1: 1	عُمْرَانِ الْبَلَدِ
u'عُمْرَانٌ دَارٌ':Added, #1: 1	عُمْرَانُ بَيْتِ
u'عَمَّرَ إِنْسانٌ':Subject, #1: 1	عُمْرَانَ دَارِ
u'عُمْرَانٌ قَرْيَةٌ':Added, #2: 2	عَمَّرَ إنْسَانٌ
u'عُمْرَانٌ قَرْيَةٌ':Added, #1: 1	عُمْرَانَ قَرْيَةِ
u'عُمْرَانٌ مِصْرٌ':Added, #2: 2	عُمْرَانِ الْقَرْيَةِ
u'عُمْرَانٌ مِصْرٌ':Added, #1: 1	عُمْرَانُ الْمِصْرِ
u'عُمْرَانٌ مِصْرٌ':Added, #1: 1	عُمْرَانِ مِصْرِهِ
u'عُمْرَانٌ مِصْرٌ':Added, #2: 2	عُمْرَانَ الْمِصْرِ
u'عُمْرَانٌ مِصْرٌ':Added, #4: 4	عُمْرَانَ مِصْرِهِ
u'عَمَّرَ حاكِمٌ':Subject, #5: 5	عُمْرَانِ الْمِصْرِ
u'عَمَّ رُخْصَةٌ':Predicate, #3: 3	عَمَّرَ الْحَاكِمُ
u'عَمَّ رُخْصَةٌ':Subject, #1: 1	عَمَّ الرُّخْصَةَ
u'عَمَّرَ دَارٌ':Predicate, #2: 2	عَمَّ الرُّخْصَةُ
u'عَمَّرَ دونٌ':Predicate, #2: 2	عَمَّرَ دَارَ
u'عَمِرَ رَجُلٌ':Predicate, #1: 1	عَمَّرَ دُونَ
u'عَمَّرَ رَجُلٌ':Subject, #2: 2	أَعْمَرَ رَجُلاً
u'عَمِرَ طَائِفٌ':Predicate, #1: 1	عَمَّرَ الرَّجُلُ
u'عَمِرَ عَائِشٌ':Predicate, #2: 2	أَعْمَرَ طَائِفَةً
u'عَمَّرَ مُسْتَأْجِرٌ':Subject, #2: 2	أَعْمَرَ عَائِشَةَ
u'عَمَّرَ مَيْسَرَةٌ':Predicate, #2: 2	عَمَّرَ الْمُسْتَأْجِرُ
u'عَمَرَ يَوْمٌ':Predicate, #1: 1	عَمَّرَ مَيْسَرَةَ
u'عَمَّ شَلَلٌ':Subject, #1: 1	عَمَرَ الْيَوْمَ
u'عَمَّ ضَرَرٌ':Subject, #1: 1	عَمَّ الشَّلَلُ
u'عَمَّ عرف':Subject, #1: 1	عَمَّ ضَرَرُهُ
u'عَمَّ عُرْفٌ':Subject, #1: 1	عَمَّ الْعُرْفُ
u'عَمَّ غُسْلٌ':Predicate, #1: 1	عَمَّ الْعُرْفُ
u'عَمَّ فِسْقٌ':Subject, #1: 1	عَمَّ الْغُسْلَ
u'عُمْقٌ بدن':Added, #1: 1	عَمَّ الْفِسْقُ
u'عُمْقٌ بَدَنٌ':Added, #2: 2	عُمْقِ الْبَدَنِ
u'عُمْقٌ بِئْرٌ':Added, #2: 2	عُمْقِ الْبَدَنِ
u'عُمْقٌ جَرْي':Added, #1: 1	عُمْقِ الْبِئْرِ
u'عُمْقٌ جَرْي':Added, #1: 1	عُمْقُ الْجَرْيَةِ
u'عُمْقٌ جلد':Added, #1: 1	عُمْقِ الْجَرْيَةِ
u'عُمْقٌ جِلْدٌ':Added, #1: 1	عُمْقِ الْجِلْدِ
u'عُمْقٌ حَوْضٌ':Added, #1: 1	عُمْقِ الْجِلْدِ
u'عُمْقٌ خَمْسَةٌ':Added, #1: 1	عُمْقُ الْحَوْضِ
u'عُمْقٌ ذِراعٌ':Added, #1: 1	عُمْقِ خَمْسَةٍ
u'عُمْقٌ ذِراعٌ':Added, #1: 1	عُمْقِ ذِرَاعٍ
u'عُمْقٌ ذِراعٌ':Added, #1: 1	عُمْقَ ذِرَاعَيْنِ
u'عُمْقٌ سُرَّةٌ':Added, #1: 1	عُمْقِ ذِرَاعَيْنِ
u'عُمْقٌ قَبْرٌ':Added, #2: 2	عُمْقَ سُرَّتِهِ
u'عُمْقٌ لَحْمٌ':Added, #2: 2	عُمْقِ الْقَبْرِ
u'عَمَلٌ آباءٌ':Added, #1: 1	عُمْقِ اللَّحْمِ
u'عَمَلٌ أبدانٌ':Added, #1: 1	عَمَلُ الْآبَاءِ
u'عَمَلٌ أبدانٌ':Added, #1: 1	عَمَلَ الْأَبَدَانِ
u'عَمَلٌ اِبْنٌ':Added, #1: 1	عَمَلِ الْأَبْدَانِ
u'عَمَلٌ اِبْنٌ':Added, #21: 21	عَمَلِ ابْنِ
u'عَمَلٌ إجَارَةٌ':Added, #3: 3	عَمَلُ ابْنِ
u'عَمَلٌ إجَارَةٌ':Added, #1: 1	عَمَلٍ إجَارَةٍ
u'عَمَلٌ إِجْمَاعٌ':Added, #1: 1	عَمَلِ إجَارَةٍ
u'عَمَلٌ أَجْنَبِيٌّ':Added, #1: 1	عَمَلَ الْإِجْمَاعِ
u'عَمَلٌ أَجْنَبِيٌّ':Added, #1: 1	عَمَلَ الْأَجْنَبِيِّ
u'عَمِلَ أَجِيرٌ':Subject, #2: 2	عَمَلُ الْأَجْنَبِيِّ
u'عَمَلٌ أَجِيرٌ':Added, #2: 2	عَمِلَ الْأَجِيرُ
u'عَمَلٌ أَجِيرٌ':Added, #1: 1	عَمَلِ أَجِيرِ
u'عَمَلٌ أَجِيرٌ':Added, #1: 1	عَمَلَ الْأَجِيرِ
u'عَمَلٌ أَجِيرٌ':Added, #1: 1	عَمَلُ الْأَجِيرِ
u'عَمَلٌ أَحْجارٌ':Added, #3: 3	عَمَلِ الْأَجِيرِ
u'عَمِلَ أحَدٌ':Subject, #1: 1	عَمَلُ أَحْجَارِ
u'عَمِلَ أحَدٌ':Subject, #1: 1	عَمِلَ أَحَدُ
u'عَمَلٌ أحَدٌ':Added, #2: 2	عَمِلَ أَحَدٌ
u'عَمَلٌ أحَدٌ':Added, #1: 1	عَمَلُ أَحَدٍ
u'عَمَلٌ أحَدٌ':Added, #1: 1	عَمَلِ أَحَدِ
u'عَمَلٌ آخِرُ':Added, #2: 2	عَمَلِ أَحَدٍ
u'عَمَلٌ آخِرَةٌ':Added, #1: 1	عَمَلُ الْآخِرِ
u'عَمَلٌ آخِرَةٌ':Added, #1: 1	عَمَلَ الآخِرَةِ
u'عَمَلٌ آخِرَةٌ':Added, #1: 1	عَمَلِ الآخِرَةِ
u'عَمِلَ آدَمِيٌّ':Subject, #5: 5	عَمَلِ الْآخِرَةِ
u'عَمَلٌ آدَمِيٌّ':Added, #4: 4	عَمِلَ آدَمِيٌّ
u'عَمَلٌ آدَمِيٌّ':Added, #1: 1	عَمَلِ آدَمِيٍّ
u'عَمَلٌ أرْضٌ':Added, #1: 1	عَمَلِ الْآدَمِيِّ
u'عَمَلٌ أسْرَارٌ':Added, #1: 1	عَمَلِ أَرْضِهِ
u'عَمَلٌ أَسْرَارٌ':Added, #1: 1	عَمَلِ الْأَسْرَارِ
u'عَمِلَ إِسْكافٌ':Subject, #1: 1	عَمَلِ الْأَسْرَارِ
u'عَمَلٌ أَصْحَابٌ':Added, #1: 1	عَمِلَ الْإِسْكَافُ
u'عَمَلٌ أَصْحَابٌ':Added, #1: 1	عَمَلَ الْأَصْحَابِ
u'عَمِلَ أصل':Subject, #1: 1	عَمَلُ الْأَصْحَابِ
u'عَمِلَ أًصْلٌ':Subject, #1: 1	عَمِلَ الْأَصْلُ
u'عَمَلٌ أصل':Added, #1: 1	عَمِلَ الْأَصْلُ
u'عَمَلٌ أًصْلٌ':Added, #2: 2	عَمَلَ الْأَصْلِ
u'عَمَلٌ أَصْنَامٌ':Added, #2: 2	عَمَلَ الْأَصْلِ
u'عَمِلَ إِطْلاقٌ':Predicate, #1: 1	عَمَلِ أَصْنَامٍ
u'عَمَلٌ إِظْهارٌ':Added, #1: 1	أَعْمَلَ إطْلَاقَ
u'عَمَلٌ إِفْرَازٌ':Added, #1: 1	عَمَلَ إِظْهَارِ
u'عَمِلَ أقَلُّ':Predicate, #1: 1	عَمَلَ الْإِفْرَازِ
u'عَمَلٌ أقوياء':Added, #1: 1	عَمِلَ أَقَلَّ
u'عَمِلَ أَكْثَرُ':Predicate, #1: 1	عَمَلُ الْأَقْوِيَاءِ
u'عَمَلٌ أَكْثَرُ':Added, #2: 2	عَمِلَ أَكْثَرَ
u'عَمَلٌ أَكْثَرُ':Added, #1: 1	عَمَلَ الْأَكْثَرِ
u'عَمَلٌ أَكْثَرُ':Added, #2: 2	عَمَلُ أَكْثَرِ
u'عَمَلٌ ألف':Added, #2: 2	عَمَلُ الْأَكْثَرِ
u'عَمَلٌ ألْفٌ':Added, #1: 1	عَمَلِ أَلْفِ
u'عَمَلٌ أَلْفٌ':Added, #1: 1	عَمَلِ أَلْفِ
u'عَمَلٌ الْمَرْءُ':Added, #1: 1	عَمَلِ أَلْفِ
u'عَمَلٌ الْمَرْءُ':Added, #1: 1	عَمَلَ الْمَرْءِ
u'عَمَلٌ الْمَرْءُ':Added, #1: 1	عَمَلُ الْمَرْءِ
u'عَمَلٌ الْمَرْأَةُ':Added, #1: 1	عَمَلِ الْمَرْءِ
u'عَمِلَ إمَامٌ':Subject, #1: 1	عَمَلِ الْمَرْأَةِ
u'عَمَلٌ إمَامٌ':Added, #2: 2	عَمِلَ الْإِمَامُ
u'عَمَلٌ إمَامٌ':Added, #1: 1	عَمَلَ الْإِمَامِ
u'عَمَلٌ أُمَّةٌ':Added, #1: 1	عَمَلُ الْإِمَامِ
u'عَمَلٌ أُمَّةٌ':Added, #1: 1	عَمَلِ الْأُمَّةِ
u'عَمَلٌ أنبياء':Added, #2: 2	عَمَلُ الْأُمَّةِ
u'عَمَلٌ أَنْدَلُسُ':Added, #1: 1	عَمَلَ الْأَنْبِيَاءِ
u'عَمَلٌ إِنْسانٌ':Added, #1: 1	عَمَلُ الْأَنْدَلُسِ
u'عَمِلَ أهْلٌ':Subject, #1: 1	عَمَلِ الْإِنْسَانِ
u'عَمَلٌ أهْلٌ':Added, #1: 1	عَمِلَ أَهْلُ
u'عَمَلٌ أهْلٌ':Added, #18: 18	عَمَلُ أَهْلِ
u'عَمَلٌ أهْلٌ':Added, #1: 1	عَمَلَ أَهْلِهِ
u'عَمَلٌ أهْلٌ':Added, #5: 5	عَمَلِ أَهْلِ
u'عَمَلٌ أَوَّلُ':Added, #9: 9	عَمَلَ أَهْلِ
u'عَمَلٌ بدن':Added, #1: 1	عَمَلِ الْأَوَّلِ
u'عَمَلٌ بَدَنٌ':Added, #1: 1	عَمَلُ الْبَدَنِ
u'عَمَلٌ بَدَنٌ':Added, #1: 1	عَمَلُ الْبَدَنِ
u'عَمَلٌ بِرٌّ':Added, #1: 1	عَمَلُ بَدَنٍ
u'عَمِلَ بَعْضٌ':Predicate, #1: 1	عَمَلِ الْبِرِّ
u'عَمَلٌ بَعْضٌ':Added, #3: 3	عَمِلَ بَعْضَ
u'عَمَلٌ بَعْضٌ':Added, #1: 1	عَمَلِ بَعْضِ
u'عَمَلٌ بَقَرٌ':Added, #2: 2	عَمَلُ بَعْضِ
u'عَمَلٌ بَقَرٌ':Added, #1: 1	عَمَلُ الْبَقَرِ
u'عَمَلٌ بَقَرٌ':Added, #1: 1	عَمَلُ بَقَرٍ
u'عَمَلٌ بَلْقَاء':Added, #1: 1	عَمَلِ بَقَرٍ
u'عَمَلٌ بَهائِمُ':Added, #1: 1	عَمَلِ الْبَلْقَاءِ
u'عَمَلٌ بَيْتٌ':Added, #1: 1	عَمَلُ الْبَهَائِمِ
u'عَمَلٌ بَيْعٌ':Added, #1: 1	عَمَلِ بَيْتِهِ
u'عَمَلٌ بُيُوتٌ':Added, #1: 1	عَمَلُ الْبَيْعِ
u'عَمَلٌ تُجَّارٌ':Added, #1: 1	عَمَلِ الْبُيُوتِ
u'عَمَلٌ تِجَارَةٌ':Added, #1: 1	عَمَلِ التُّجَّارِ
u'عَمَلٌ تِجَارَةٌ':Added, #2: 2	عَمَلَ التِّجَارَةِ
u'عَمَلٌ تَدْبِيرٌ':Added, #2: 2	عَمَلِ التِّجَارَةِ
u'عَمَلٌ تَطَوُّعٌ':Added, #1: 1	عَمَلَ تَدْبِيرِهِ
u'عَمَلٌ تَفْطِيرٌ':Added, #1: 1	عَمَلِ تَطَوُّعٍ
u'عَمِلَ ثَمَنٌ':Predicate, #1: 1	عَمَلِ التَّفْطِيرِ
u'عَمِلَ ثَوْبٌ':Predicate, #1: 1	عَمِلَ الثَّمَنَ
u'عَمَلٌ جَارِحٌ':Added, #4: 4	عَمِلَ الثَّوْبَ
u'عَمَلٌ جَارِحَةٌ':Added, #1: 1	عَمَلُ جَارِحَةٍ
u'عَمِلَ جَازٌ':Predicate, #1: 1	عَمَلُ جَارِحَةٍ
u'عَمَلٌ جَاهِلٌ':Added, #1: 1	عَمِلَ جَازَ
u'عَمَلٌ جَاهِلِيٌّ':Added, #1: 1	عَمَلِ الْجَاهِلِ
u'عَمَلٌ جَاهِلِيَّةٌ':Added, #4: 4	عَمَلِ الْجَاهِلِيَّةِ
u'عَمَلٌ جُبْنٌ':Added, #4: 4	عَمَلِ الْجَاهِلِيَّةِ
u'عَمَلٌ جَزَّارٌ':Added, #1: 1	عَمَلِ الْجُبْنِ
u'عَمِلَ جلد':Predicate, #1: 1	عَمَلِ الْجَزَّارِ
u'عَمِلَ جِلْدٌ':Predicate, #1: 1	عَمِلَ الْجِلْدَ
u'عَمَلٌ جُمْلَةٌ':Added, #1: 1	عَمِلَ الْجِلْدَ
u'عَمَلٌ جُمْهُورٌ':Added, #1: 1	عَمَلُ جُمْلَةٍ
u'عَمَلٌ جُمْهُورٌ':Added, #1: 1	عَمَلَ الْجُمْهُورِ
u'عَمَلٌ جَنَّةٌ':Added, #1: 1	عَمَلُ الْجُمْهُورِ
u'عَمَلٌ جَنَّةٌ':Added, #1: 1	عَمَلَ الْجَنَّةِ
u'عَمَلٌ جهاد':Added, #1: 1	عَمَلُ الْجَنَّةِ
u'عَمَلٌ جِهَادٌ':Added, #2: 2	عَمَلِ الْجِهَادِ
u'عَمِلَ جَوَابٌ':Subject, #2: 2	عَمَلِ الْجِهَادِ
u'عَمَلٌ جوارح':Added, #1: 1	عَمِلَ جَوَابُ
u'عَمَلٌ جَوَارِحُ':Added, #2: 2	عَمَلُ الْجَوَارِحِ
u'عَمَلٌ جوارح':Added, #2: 2	عَمَلُ الْجَوَارِحِ
u'عَمَلٌ جَوَارِحُ':Added, #4: 4	عَمَلَ الْجَوَارِحِ
u'عَمَلٌ جوارح':Added, #4: 4	عَمَلَ الْجَوَارِحِ
u'عَمَلٌ جَوَارِحُ':Added, #6: 6	عَمَلِ الْجَوَارِحِ
u'عَمَلٌ جَيْشٌ':Added, #6: 6	عَمَلِ الْجَوَارِحِ
u'عَمَلٌ حاجٌّ':Added, #1: 1	عَمَلُ الْجَيْشِ
u'عَمَلٌ حافِرٌ':Added, #1: 1	عَمَلَ الْحَاجِّ
u'عَمَلٌ حاكِمٌ':Added, #1: 1	عَمَلَ الْحَافِرِ
u'عَمَلٌ حائِطٌ':Added, #2: 2	عَمَلِ الْحَاكِمِ
u'عَمَلٌ حائِطٌ':Added, #1: 1	عَمَلُ الْحَائِطِ
u'عَمَلٌ حائِطٌ':Added, #1: 1	عَمَلِ حَائِطٍ
u'عَمَلٌ حائِطٌ':Added, #1: 1	عَمَلِ حَائِطِهِ
u'عَمَلٌ حَجٌّ':Added, #3: 3	عَمَلِ الْحَائِطِ
u'عَمَلٌ حَجٌّ':Added, #1: 1	عَمَلِ حَجِّهِ
u'عَمَلٌ حَجٌّ':Added, #2: 2	عَمَلَ الْحَجِّ
u'عَمَلٌ حَجٌّ':Added, #3: 3	عَمَلُ الْحَجِّ
u'عَمِلَ حَجْرٌ':Subject, #7: 7	عَمَلِ الْحَجِّ
u'عَمَلٌ حِدادَةٌ':Added, #2: 2	عَمِلَ حَجْرُهُ
u'عَمِلَ حَدَثٌ':Subject, #1: 1	عَمَلِ الْحِدَادَةِ
u'عَمَلٌ حَدَثٌ':Added, #1: 1	عَمِلَ الْحَدَثُ
u'عَمِلَ حَديدٌ':Predicate, #1: 1	عَمَلُ الْحَدَثِ
u'عَمَلٌ حَديدٌ':Added, #1: 1	عَمِلَ الْحَدِيدَ
u'عَمَلٌ حِراثَةٌ':Added, #1: 1	عَمَلَ الْحَدِيدِ
u'عَمَلٌ حَرامٌ':Added, #1: 1	عَمَلَ الْحِرَاثَةِ
u'عَمِلَ حَسَنٌ':Predicate, #1: 1	عَمَلٍ حَرَامٍ
u'عَمَلٌ حَطّ':Added, #6: 6	عَمِلَ حَسَنَةً
u'عَمَلٌ حَقٌّ':Added, #1: 1	عَمَلَ الْحَطِّ
u'عَمَلٌ حَقِيقٌ':Added, #1: 1	عَمَلِ الْحَقِّ
u'عَمَلٌ حَقِيقَةٌ':Added, #2: 2	عَمَلَ الْحَقِيقَةِ
u'عَمَلٌ حُكَّامٌ':Added, #2: 2	عَمَلَ الْحَقِيقَةِ
u'عَمَلٌ حُكْمٌ':Added, #1: 1	عَمَلَ الْحُكَّامِ
u'عَمَلٌ حُكُومَةٌ':Added, #1: 1	عَمَلِ حُكْمِ
u'عَمِلَ حَلْقٌ':Predicate, #1: 1	عَمَلَ الْحُكُومَةِ
u'عَمَلٌ حِيَاكَةٌ':Added, #1: 1	عَمِلَ الْحَلْقَ
u'عَمَلٌ حِيلَةٌ':Added, #1: 1	عَمَلِ الْحِيَاكَةِ
u'عَمَلٌ خَالِدٌ':Added, #1: 1	عَمَلُ حِيلَةٍ
u'عَمَلٌ خَالِدٌ':Added, #1: 1	عَمَلُ خَالِدٍ
u'عَمِلَ خُبْزٌ':Predicate, #1: 1	عَمَلِ خَالِدٍ
u'عَمَلٌ خِضَابٌ':Added, #1: 1	عَمِلَ الْخُبْزَ
u'عَمِلَ خُفٌّ':Predicate, #3: 3	عَمَلَ الْخِضَابِ
u'عَمَلٌ خُفٌّ':Added, #1: 1	عَمِلَ الْخُفَّ
u'عَمَلٌ خُفٌّ':Added, #1: 1	عَمَلِ الْخُفِّ
u'عَمَلٌ خُلَفَاءُ':Added, #3: 3	عَمَلُ خُفَّيْنِ
u'عَمَلٌ خُلَفَاءُ':Added, #1: 1	عَمَلِ الْخُلَفَاءِ
u'عَمَلٌ خُوصٌ':Added, #4: 4	عَمَلُ الْخُلَفَاءِ
u'عَمَلٌ خَيَّاطٌ':Added, #1: 1	عَمَلِ الْخُوصِ
u'عَمَلٌ خَيَّاطٌ':Added, #1: 1	عَمَلَ الْخَيَّاطِ
u'عَمَلٌ خِيَاطَةٌ':Added, #1: 1	عَمَلُ الْخَيَّاطِ
u'عَمَلٌ خِيَاطَةٌ':Added, #2: 2	عَمَلَ الْخِيَاطَةِ
u'عَمَلٌ خَيْرٌ':Added, #3: 3	عَمَلِ الْخِيَاطَةِ
u'عَمَلٌ خَيْرٌ':Added, #1: 1	عَمَلُ خَيْرٍ
u'عَمَلٌ خَيْرٌ':Added, #1: 1	عَمَلِ خَيْرٍ
u'عَمَلٌ خَيْرَاتٌ':Added, #5: 5	عَمَلِ الْخَيْرِ
u'عَمَلٌ خَيْرَةٌ':Added, #1: 1	عَمَلِ الْخَيْرَاتِ
u'عَمَلٌ دَبَّاغٌ':Added, #1: 1	عَمَلِ الْخَيْرَاتِ
u'عَمَلٌ دِبَاغٌ':Added, #1: 1	عَمَلَ الدَّبَّاغِ
u'عَمَلٌ دَعْوَةٌ':Added, #1: 1	عَمَلَ الدِّبَاغِ
u'عَمِلَ دفع':Predicate, #1: 1	عَمَلُ دَعْوَةٍ
u'عَمَلٌ دَقيقٌ':Added, #2: 2	عَمِلَ دَفَعَ
u'عَمَلٌ دَلالَةٌ':Added, #1: 1	عَمَلِ الدَّقِيقِ
u'عَمَلٌ ذِمِّيٌّ':Added, #1: 1	عَمَلِ الدَّلَالَةِ
u'عَمِلَ ذُنُوبٌ':Predicate, #1: 1	عَمَلِ الذِّمِّيِّ
u'عَمِلَ رَاجِحٌ':Predicate, #2: 2	عَمِلَ الذُّنُوبَ
u'عَمِلَ رَبُّ':Subject, #1: 1	أَعْمَلَ الرَّاجِحَ
u'عَمَلٌ رَبُّ':Added, #2: 2	عَمِلَ رَبُّ
u'عَمَلٌ رَبُّ':Added, #1: 1	عَمَلَ رَبِّهِ
u'عَمَلٌ رَبُّ':Added, #3: 3	عَمَلِ رَبِّ
u'عَمَلٌ رَبُّ':Added, #6: 6	عَمَلَ رَبِّ
u'عَمَلٌ رِجَالٌ':Added, #7: 7	عَمَلُ رَبِّ
u'عَمِلَ رَجُلٌ':Subject, #1: 1	عَمَلَ الرِّجَالِ
u'عَمَلٌ رَجُلٌ':Added, #1: 1	عَمِلَ الرَّجُلُ
u'عَمَلٌ رَجُلٌ':Added, #1: 1	عَمَلِ الرَّجُلِ
u'عَمَلٌ رَجُلٌ':Added, #4: 4	عَمَلُ الرَّجُلِ
u'عَمَلٌ رَدٌّ':Added, #7: 7	عَمَلَ رَجُلٍ
u'عَمِلَ رَسُولٌ':Subject, #1: 1	عَمَلَ الرَّدِّ
u'عَمَلٌ رَسُولٌ':Added, #2: 2	عَمِلَ رَسُولُ
u'عَمَلٌ رَعْيٌ':Added, #2: 2	عَمَلِ رَسُولِ
u'عَمَلٌ زِراعَةٌ':Added, #1: 1	عَمَلِ الرَّعْيِ
u'عَمَلٌ زِراعَةٌ':Added, #1: 1	عَمَلَ الزِّرَاعَةِ
u'عَمَلٌ زَرْعٌ':Added, #3: 3	عَمَلِ الزِّرَاعَةِ
u'عَمَلٌ زَيْتٌ':Added, #1: 1	عَمَلُ الزَّرْعِ
u'عَمَلٌ زَيْتٌ':Added, #1: 1	عَمَلُ زَيْتٍ
u'عَمَلٌ زَيْدٌ':Added, #1: 1	عَمَلُ زَيْتِ
u'عَمِلَ سَبَبٌ':Subject, #1: 1	عَمَلُ زَيْدٍ
u'عَمَلٌ سَبَبٌ':Added, #1: 1	عَمِلَ السَّبَبُ
u'عَمَلٌ سترة':Added, #1: 1	عَمَلُ السَّبَبِ
u'عَمَلٌ سُتْرَةٌ':Added, #2: 2	عَمَلُ سُتْرَةٍ
u'عَمِلَ سِحْرٌ':Predicate, #2: 2	عَمَلُ سُتْرَةٍ
u'عَمَلٌ سِحْرٌ':Added, #1: 1	عَمِلَ السِّحْرَ
u'عَمَلٌ سِحْرٌ':Added, #1: 1	عَمَلَ السِّحْرِ
u'عَمَلٌ سِرٌّ':Added, #1: 1	عَمَلِ السِّحْرِ
u'عَمَلٌ سِرٌّ':Added, #1: 1	عَمَلَ السِّرِّ
u'عَمَلٌ سُفُنٌ':Added, #1: 1	عَمَلِ السِّرِّ
u'عَمَلٌ سِلاَحٌ':Added, #2: 2	عَمَلِ سُفُنٍ
u'عَمَلٌ سُلْطَانٌ':Added, #2: 2	عَمَلَ السِّلَاحِ
u'عَمَلٌ سُلْطَانٌ':Added, #1: 1	عَمَلَ السُّلْطَانِ
u'عَمِلَ سَلَفٌ':Subject, #1: 1	عَمَلِ سُلْطَانٍ
u'عَمَلٌ سَلَفٌ':Added, #1: 1	عَمِلَ السَّلَفُ
u'عَمَلٌ سَلَفٌ':Added, #1: 1	عَمَلَ السَّلَفِ
u'عَمَلٌ سَلَفٌ':Added, #2: 2	عَمَلِ السَّلَفِ
u'عَمَلٌ سُمُومٌ':Added, #4: 4	عَمَلُ السَّلَفِ
u'عَمَلٌ سَنَةٌ':Added, #1: 1	عَمَلَ السُّمُومِ
u'عَمَلٌ سَنَةٌ':Added, #1: 1	عَمَلِ سَنَةٍ
u'عَمَلٌ سُهولَةٌ':Added, #4: 4	عَمَلُ سَنَةٍ
u'عَمَلٌ سَيْفٌ':Added, #1: 1	عَمَلِ السُّهُولَةِ
u'عَمِلَ سُيوفٌ':Predicate, #1: 1	عَمَلَ السَّيْفِ
u'عَمِلَ شافِعِيّ':Subject, #1: 1	عَمِلَ السّيُوفَ
u'عَمَلٌ شافِعِيّ':Added, #1: 1	عَمِلَ الشَّافِعِيُّ
u'عَمَلٌ شَاقٌّ':Added, #1: 1	عَمَلُ الشَّافِعِيِّ
u'عَمَلٌ شَاهِدٌ':Added, #1: 1	عَمَلٍ شَاقٍّ
u'عَمَلٌ شَرْطٌ':Added, #1: 1	عَمَلُ الشَّاهِدِ
u'عَمَلٌ شَرِيطٌ':Added, #2: 2	عَمَلَ الشَّرْطِ
u'عَمَلٌ شَرِيكٌ':Added, #1: 1	عَمَلِ الشَّرِيطِ
u'عَمَلٌ شمس':Added, #1: 1	عَمَلَ شَرِيكِهِ
u'عَمَلٌ شَمْسٌ':Added, #1: 1	عَمَلُ الشَّمْسِ
u'عَمَلٌ شَيْءٌ':Added, #1: 1	عَمَلُ الشَّمْسِ
u'عَمَلٌ شَيْءٌ':Added, #1: 1	عَمَلِ شَيْءٍ
u'عَمَلٌ شَيْخٌ':Added, #2: 2	عَمَلَ شَيْءٍ
u'عَمَلٌ شَيْطَانٌ':Added, #1: 1	عَمَلَ الشَّيْخَيْنِ
u'عَمَلٌ شَيْطَانٌ':Added, #21: 21	عَمَلِ الشَّيْطَانِ
u'عَمَلٌ شَيْطَانٌ':Added, #2: 2	عَمَلِ الشّيْطَانِ
u'عَمَلٌ شَيْطَانٌ':Added, #3: 3	عَمَلُ الشَّيْطَانِ
u'عَمِلَ صَاحِبٌ':Subject, #5: 5	عَمَلَ الشَّيْطَانِ
u'عَمَلٌ صَاحِبٌ':Added, #2: 2	عَمِلَ صَاحِبُ
u'عَمَلٌ صَاحِبٌ':Added, #1: 1	عَمَلَ صَاحِبِ
u'عَمَلٌ صَاحِبٌ':Added, #1: 1	عَمَلِ صَاحِبِ
u'عَمَلٌ صَاحِبٌ':Added, #1: 1	عَمَلِ صَاحِبِهِ
u'عَمَلٌ صَالِحٌ':Added, #2: 2	عَمَلَ صَاحِبِهِ
u'عَمَلٌ صَالِح':Added, #11: 11	عَمَلٍ صَالِحٍ
u'عَمَلٌ صَانِعٌ':Added, #11: 11	عَمَلٍ صَالِحٍ
u'عَمَلٌ صَبْغٌ':Added, #1: 1	عَمَلِ الصَّانِعِ
u'عَمَلٌ صَحَابَةٌ':Added, #1: 1	عَمَلِ الصَّبْغِ
u'عَمَلٌ صَحَابَةٌ':Added, #1: 1	عَمَلَ الصَّحَابَةِ
u'عَمَلٌ صَحَابَةٌ':Added, #3: 3	عَمَلِ الصَّحَابَةِ
u'عَمَلٌ صَحَابِيٌّ':Added, #5: 5	عَمَلُ الصَّحَابَةِ
u'عَمَلٌ صَرِيحٌ':Added, #1: 1	عَمَلُ الصَّحَابِيِّ
u'عَمَلٌ صَغِيرٌ':Added, #8: 8	عَمَلَ الصَّرِيحِ
u'عَمَلٌ صَلاَةٌ':Added, #3: 3	عَمَلَ الصَّغِيرِ
u'عَمَلٌ صَلاَةٌ':Added, #1: 1	عَمَلِ الصَّلَاةِ
u'عَمَلٌ صَلاَةٌ':Added, #1: 1	عَمَلِ الصَّلاَةِ
u'عَمَلٌ صلْبٌ':Added, #1: 1	عَمَلِ صَلَاتِهِ
u'عَمَلٌ صُنَّاعٌ':Added, #1: 1	عَمَلَ صُلْبِ
u'عَمَلٌ صِنَاعَةٌ':Added, #1: 1	عَمَلِ الصُّنَّاعِ
u'عَمَلٌ صنائع':Added, #1: 1	عَمَلُ صِنَاعَةٍ
u'عَمَلٌ صَنَائِعُ':Added, #1: 1	عَمَلِ الصَّنَائِعِ
u'عَمِلَ صنعة':Predicate, #1: 1	عَمَلِ الصَّنَائِعِ
u'عَمِلَ صَنْعَةٌ':Predicate, #1: 1	عَمِلَ الصَّنْعَةَ
u'عَمَلٌ صنعة':Added, #1: 1	عَمِلَ الصَّنْعَةَ
u'عَمَلٌ صنعة':Added, #1: 1	عَمَلَ الصَّنْعَةِ
u'عَمَلٌ صَنْعَةٌ':Added, #1: 1	عَمَلُ الصَّنْعَةِ
u'عَمَلٌ صَنْعَةٌ':Added, #1: 1	عَمَلَ الصَّنْعَةِ
u'عَمَلٌ صنعة':Added, #1: 1	عَمَلُ الصَّنْعَةِ
u'عَمَلٌ صَنْعَةٌ':Added, #4: 4	عَمَلِ صَنْعَةٍ
u'عَمَلٌ صَنَمٌ':Added, #4: 4	عَمَلِ صَنْعَةٍ
u'عَمَلٌ صُورٌ':Added, #1: 1	عَمَلِ صَنَمٍ
u'عَمَلٌ صُوَرٌ':Added, #1: 1	عَمَلَ الصُّوَرِ
u'عَمَلٌ صَوْمٌ':Added, #1: 1	عَمَلَ الصُّوَرِ
u'عَمَلٌ ضَرْبٌ':Added, #1: 1	عَمَلِ الصَّوْمِ
u'عَمِلَ ضَمِنٌ':Predicate, #3: 3	عَمَلَ الضَّرْبِ
u'عَمَلٌ طَاعَةٌ':Added, #1: 1	عَمِلَ ضَمِنَ
u'عَمَلٌ طَبْخٌ':Added, #1: 1	عَمَلِ طَاعَةٍ
u'عَمَلٌ طحن':Added, #1: 1	عَمَلَ الطَّبْخِ
u'عَمَلٌ طحن':Added, #1: 1	عَمَلَ الطَّحْنِ
u'عَمَلٌ طَلاَقٌ':Added, #1: 1	عَمَلِ طَحْنِ
u'عَمَلٌ طِيبٌ':Added, #2: 2	عَمَلِ الطَّلَاقِ
u'عَمَلٌ طِيبٌ':Added, #1: 1	عَمَلُ الطِّيبِ
u'عَمَلٌ طِينٌ':Added, #1: 1	عَمَلَ طِيبٍ
u'عَمَلٌ ظاهِرٌ':Added, #1: 1	عَمَلَ الطِّينِ
u'عَمَلٌ عَابِدٌ':Added, #1: 1	عَمَلٍ ظَاهِرٍ
u'عَمَلٌ عَالِمٌ':Added, #1: 1	عَمَلَ الْعَابِدِ
u'عَمَلٌ عَالِمٌ':Added, #1: 1	عَمَلَ الْعَالِمِ
u'عَمَلٌ عَالِمٌ':Added, #1: 1	عَمَلُ الْعَالِمِ
u'عَمَلٌ عَامٌّ':Added, #3: 3	عَمَلِ الْعَالِمِ
u'عَمَلٌ عَامٌّ':Added, #1: 1	عَمَلِ الْعَامَّةِ
u'عَمَلٌ عَامِلٌ':Added, #6: 6	عَمَلُ الْعَامَّةِ
u'عَمَلٌ عَامِلٌ':Added, #1: 1	عَمَلَ الْعَامِلِ
u'عَمَلٌ عَامِلٌ':Added, #1: 1	عَمَلِ عَامِلٍ
u'عَمَلٌ عَامِلٌ':Added, #1: 1	عَمَلِ عَامِلِهِ
u'عَمَلٌ عَامِلٌ':Added, #1: 1	عَمَلِ عَامِلَيْنِ
u'عَمَلٌ عَامِلٌ':Added, #5: 5	عَمَلُ الْعَامِلِ
u'عَمَلٌ عَامِّيٌّ':Added, #6: 6	عَمَلِ الْعَامِلِ
u'عَمَلٌ عِبَادٌ':Added, #1: 1	عَمَلُ الْعَامِّيِّ
u'عَمَلٌ عِبَادٌ':Added, #1: 1	عَمَلَ الْعِبَادِ
u'عَمِلَ عِبَادَةٌ':Predicate, #1: 1	عَمَلِ الْعِبَادِ
u'عَمَلٌ عَبْدٌ':Added, #1: 1	عَمِلَ الْعِبَادَةَ
u'عَمَلٌ عَبْدٌ':Added, #14: 14	عَمَلُ الْعَبْدِ
u'عَمَلٌ عَبْدٌ':Added, #1: 1	عَمَلَ عَبْدِهِ
u'عَمَلٌ عَبْدٌ':Added, #3: 3	عَمَلِ الْعَبْدِ
u'عَمَلٌ عَبْدٌ':Added, #3: 3	عَمَلِ عَبْدِهِ
u'عَمَلٌ عزل':Added, #7: 7	عَمَلَ الْعَبْدِ
u'عَمَلٌ عَصَائِبُ':Added, #1: 1	عَمَلِ الْعَزْلِ
u'عَمَلٌ عَصَائِبُ':Added, #1: 1	عَمَلِ الْعَصَائِبِ
u'عَمَلٌ عَقْدٌ':Added, #1: 1	عَمَلُ عَصَائِبِ
u'عَمَلٌ عَقْلٌ':Added, #1: 1	عَمَلُ الْعَقْدِ
u'عَمَلٌ عَقْلٌ':Added, #1: 1	عَمَلَ الْعَقْلِ
u'عَمَلٌ عَقْلٌ':Added, #1: 1	عَمَلُ الْعَقْلِ
u'عَمَلٌ عُقَلاَءُ':Added, #1: 1	عَمَلِ الْعَقْلِ
u'عَمَلٌ عَلاَنِيَةٌ':Added, #1: 1	عَمَلِ الْعُقَلَاءِ
u'عَمَلٌ عِلَّةٌ':Added, #1: 1	عَمَلَ الْعَلَانِيَةِ
u'عَمَلٌ عِلَّةٌ':Added, #1: 1	عَمَلُ الْعِلَّةِ
u'عَمَلٌ عِلَّةٌ':Added, #1: 1	عَمَلِ عِلَّتِهِ
u'عَمَلٌ علماء':Added, #2: 2	عَمَلِ الْعِلَّةِ
u'عَمَلٌ عُلَمَاءُ':Added, #1: 1	عَمَلِ الْعُلَمَاءِ
u'عَمِلَ عُمَرٌ':Subject, #1: 1	عَمَلِ الْعُلَمَاءِ
u'عَمَلٌ عمرة':Added, #2: 2	عَمِلَ عُمَرُ
u'عَمَلٌ عُمْرَةٌ':Added, #1: 1	عَمَل الْعُمْرَةِ
u'عَمَلٌ عمرة':Added, #1: 1	عَمَل الْعُمْرَةِ
u'عَمَلٌ عمرة':Added, #2: 2	عَمَلَ الْعُمْرَةِ
u'عَمَلٌ عُمْرَةٌ':Added, #2: 2	عَمَلُ الْعُمْرَةِ
u'عَمَلٌ عُمْرَةٌ':Added, #2: 2	عَمَلَ الْعُمْرَةِ
u'عَمَلٌ عمرة':Added, #2: 2	عَمَلُ الْعُمْرَةِ
u'عَمَلٌ عُمْرَةٌ':Added, #3: 3	عَمَلُ عُمْرَةٍ
u'عَمَلٌ عمرة':Added, #3: 3	عَمَلُ عُمْرَةٍ
u'عَمَلٌ عُمْرَةٌ':Added, #5: 5	عَمَلِ الْعُمْرَةِ
u'عَمِلَ عَمَلٌ':Predicate, #5: 5	عَمَلِ الْعُمْرَةِ
u'عَمِلَ عَمَلٌ':Predicate, #1: 1	أَعْمَلَ عَمَلاً
u'عَمِلَ عَمَلٌ':Predicate, #2: 2	عَمِلَ عَمَلاً
u'عَمَلٌ عَمَلٌ':Added, #33: 33	عَمِلَ عَمَلَ
u'عَمِلَ غَاصِبٌ':Subject, #1: 1	عَمَلُ عَمَلِهِ
u'عَمَلٌ غَاصِبٌ':Added, #1: 1	عَمِلَ الْغَاصِبُ
u'عَمَلٌ غَاصِبٌ':Added, #1: 1	عَمَلُ الْغَاصِبِ
u'عَمَلٌ غَسّال':Added, #1: 1	عَمَلِ الْغَاصِبِ
u'عَمَلٌ غَسْلٌ':Added, #1: 1	عَمَلِ الْغَسَّالِ
u'عَمَلٌ غُلاَمٌ':Added, #1: 1	عَمَلَ الْغَسْلِ
u'عَمَلٌ غُلاَمٌ':Added, #1: 1	عَمَلُ غُلَامِ
u'عَمَلٌ غِلْمَانٌ':Added, #2: 2	عَمَلَ غُلَامِهِ
u'عَمِلَ غير':Predicate, #1: 1	عَمَلَ غِلْمَانِ
u'عَمِلَ غَيْرٌ':Predicate, #1: 1	عَمِلَ غَيْرَ
u'عَمِلَ غير':Subject, #1: 1	عَمِلَ غَيْرَ
u'عَمِلَ غَيْرٌ':Subject, #1: 1	عَمِلَ غَيْرُهُ
u'عَمَلٌ غير':Added, #1: 1	عَمِلَ غَيْرُهُ
u'عَمَلٌ غَيْرٌ':Added, #1: 1	عَمَلِ الْغَيْرِ
u'عَمَلٌ غير':Added, #1: 1	عَمَلِ الْغَيْرِ
u'عَمَلٌ غَيْرٌ':Added, #1: 1	عَمَلُ غَيْرِهِ
u'عَمَلٌ غير':Added, #1: 1	عَمَلُ غَيْرِهِ
u'عَمَلٌ غَيْرٌ':Added, #2: 2	عَمَلِ غَيْرِ
u'عَمَلٌ غير':Added, #2: 2	عَمَلِ غَيْرِ
u'عَمَلٌ غَيْرٌ':Added, #2: 2	عَمَلِ غَيْرِهِ
u'عَمَلٌ فَرَائِضُ':Added, #2: 2	عَمَلِ غَيْرِهِ
u'عَمِلَ فَسْخٌ':Subject, #1: 1	عَمَلِ الْفَرَائِضِ
u'عَمَلٌ فقهاء':Added, #1: 1	عَمِلَ الْفَسْخُ
u'عَمِلَ فلان':Subject, #2: 2	عَمَلِ الْفُقَهَاءِ
u'عَمِلَ فلان':Subject, #1: 1	عَمِلَ الشَّافِعِيُّ
u'عَمَلٌ فلان':Added, #1: 1	عَمِلَ الْهَاشِمِيُّ
u'عَمَلٌ فُلاَنٌ':Added, #1: 1	عَمَلُ الشَّافِعِيِّ
u'عَمَلٌ قَابِلٌ':Added, #2: 2	عَمَلِ فُلَانٍ
u'عَمَلٌ قَاطِعٌ':Added, #1: 1	عَمَلُ الْقَابِلِ
u'عَمَلٌ قَاطِعٌ':Added, #1: 1	عَمَلُ الْقَاطِعِ
u'عَمَلٌ قِبْطٌ':Added, #1: 1	عَمَلُ قَاطِعِ
u'عَمَلٌ قراض':Added, #1: 1	عَمَلِ الْقِبْطِ
u'عَمَلٌ قراض':Added, #1: 1	عَمَلَ الْقِرَاضِ
u'عَمَلٌ قراض':Added, #1: 1	عَمَلُ الْقِرَاضِ
u'عَمَلٌ قُرْبَةٌ':Added, #2: 2	عَمَلِ الْقِرَاضِ
u'عَمَلٌ قُرْبَةٌ':Added, #1: 1	عَمَلِ الْقُرْبَةِ
u'عَمَلٌ قسمة':Added, #1: 1	عَمَلِ قُرْبَةٍ
u'عَمَلٌ قِسْمَةٌ':Added, #1: 1	عَمَلُ قِسْمَةِ
u'عَمَلٌ قَضَاءٌ':Added, #1: 1	عَمَلُ قِسْمَةِ
u'عَمَلٌ قَضَاءٌ':Added, #1: 1	عَمَلُ الْقَضَاءِ
u'عَمَلٌ قَضَاءٌ':Added, #4: 4	عَمَلَ الْقَضَاءِ
u'عَمَلٌ قضاة':Added, #5: 5	عَمَلِ الْقَضَاءِ
u'عَمَلٌ قضاة':Added, #1: 1	عَمَلِ الْقُضَاةِ
u'عَمَلٌ قضاة':Added, #2: 2	عَمَلَ الْقُضَاةِ
u'عَمَلٌ قضاة':Added, #2: 2	عَمَلُ قُضَاةِ
u'عَمَلٌ قلب':Added, #7: 7	عَمَلُ الْقُضَاةِ
u'عَمَلٌ قَلْبٌ':Added, #10: 10	عَمَلُ الْقَلْبِ
u'عَمَلٌ قَلْب':Added, #10: 10	عَمَلُ الْقَلْبِ
u'عَمَلٌ قلب':Added, #10: 10	عَمَلُ الْقَلْبِ
u'عَمَلٌ قَلْبٌ':Added, #8: 8	عَمَلَ الْقَلْبِ
u'عَمَلٌ قَلْب':Added, #8: 8	عَمَلَ الْقَلْبِ
u'عَمَلٌ قلب':Added, #8: 8	عَمَلَ الْقَلْبِ
u'عَمَلٌ قَلْبٌ':Added, #9: 9	عَمَلِ الْقَلْبِ
u'عَمَلٌ قَلْب':Added, #9: 9	عَمَلِ الْقَلْبِ
u'عَمِلَ قَنْطَرَةٌ':Predicate, #9: 9	عَمَلِ الْقَلْبِ
u'عَمَلٌ قَوْمٌ':Added, #1: 1	عَمِلَ الْقَنْطَرَةَ
u'عَمَلٌ قَوْمٌ':Added, #1: 1	عَمَلُ قَوْمٍ
u'عَمَلٌ قَوْمٌ':Added, #1: 1	عَمَلِ قَوْمِ
u'عَمَلٌ قَوْمٌ':Added, #45: 45	عَمَلَ قَوْمِ
u'عَمِلَ قَيِّمٌ':Subject, #4: 4	عَمَلُ قَوْمِ
u'عَمِلَ كبائر':Predicate, #2: 2	عَمِلَ الْقَيِّمُ
u'عَمَلٌ كُرُومٌ':Added, #5: 5	عَمِلَ الْكَبَائِرَ
u'عَمَلٌ كُفْرٌ':Added, #1: 1	عَمَلِ الْكُرُومِ
u'عَمَلٌ لِسَانٌ':Added, #1: 1	عَمَلِ كُفْرٍ
u'عَمَلٌ لِسَانٌ':Added, #1: 1	عَمَلَ اللِّسَانِ
u'عَمَلٌ لَفْظٌ':Added, #4: 4	عَمَلُ اللِّسَانِ
u'عَمِلَ مَاءٌ':Subject, #1: 1	عَمَلُ لَفْظِهِ
u'عَمِلَ مَالِكٌ':Subject, #1: 1	عَمِلَ الْمَاءُ
u'عَمَلٌ مَالِكٌ':Added, #1: 1	عَمِلَ الْمَالِكُ
u'عَمَلٌ مَالِكٌ':Added, #1: 1	عَمَلِ الْمَالِكِ
u'عَمَلٌ مَالِكٌ':Added, #2: 2	عَمَلَ الْمَالِكِ
u'عَمِلَ مُبَاشِرٌ':Subject, #2: 2	عَمَلُ الْمَالِكِ
u'عَمَلٌ مُبْطِلٌ':Added, #1: 1	عَمِلَ الْمُبَاشِرُ
u'عَمَلٌ مُبْطِلٌ':Added, #1: 1	عَمَلَ الْمُبْطِلِ
u'عَمَلٌ مُبْطِلٌ':Added, #2: 2	عَمَلُ الْمُبْطِلِ
u'عَمَلٌ مُبَلَّغٌ':Added, #3: 3	عَمَلِ الْمُبْطِلِ
u'عَمَلٌ مُتَطَوِّعٌ':Added, #1: 1	عَمَلِ الْمُبَلَّغِ
u'عَمَلٌ مُتَفَرِّعٌ':Added, #1: 1	عَمَلِ الْمُتَطَوِّعِ
u'عَمِلَ مِثْقَالٌ':Predicate, #1: 1	عَمَلٍ مُتَفَرِّعٍ
u'عَمِلَ مثل':Predicate, #1: 1	عَمِلَ مِثْقَالَ
u'عَمِلَ مِثْلٌ':Predicate, #2: 2	عَمِلَ مِثْلَ
u'عَمَلٌ مثل':Added, #2: 2	عَمِلَ مِثْلَ
u'عَمَلٌ مِثْلٌ':Added, #1: 1	عَمَلِ مِثْلِهِ
u'عَمَلٌ مُجْتَهِد':Added, #1: 1	عَمَلِ مِثْلِهِ
u'عَمَلٌ مَجْهُولٌ':Added, #3: 3	عَمَلِ الْمُجْتَهِدِ
u'عَمَلٌ مَجْهُولٌ':Added, #1: 1	عَمَلِ مَجْهُولٍ
u'عَمَلٌ مَحْدُودٌ':Added, #2: 2	عَمَلٍ مَجْهُولٍ
u'عَمَلٌ مُحَرَّمٌ':Added, #1: 1	عَمَلٍ مَحْدُودٍ
u'عَمَلٌ مَحْسُوسٌ':Added, #1: 1	عَمَلٍ مُحَرَّمٍ
u'عَمَلٌ مُحَمَّدٌ':Added, #1: 1	عَمَلٍ مَحْسُوسٍ
u'عَمَلٌ مَخْصُوصٌ':Added, #1: 1	عَمَلِ مُحَمَّدٍ
u'عَمَلٌ مَدْيُونٌ':Added, #2: 2	عَمَلٍ مَخْصُوصٍ
u'عَمَلٌ مَذْمُومٌ':Added, #1: 1	عَمَلُ الْمَدْيُونِ
u'عَمِلَ مُزَارِعٌ':Subject, #1: 1	عَمَلٍ مَذْمُومٍ
u'عَمَلٌ مُزَارِعٌ':Added, #1: 1	عَمِلَ الْمُزَارِعُ
u'عَمَلٌ مُزَارِعٌ':Added, #1: 1	عَمَلَ الْمُزَارِعِ
u'عَمَلٌ مُساقاة':Added, #3: 3	عَمَلِ الْمُزَارِعِ
u'عَمَلٌ مَسْأَلَةٌ':Added, #3: 3	عَمَلِ الْمُسَاقَاةِ
u'عَمَلٌ مُسْتَأْجِرٌ':Added, #1: 1	عَمَلِ الْمَسْأَلَةِ
u'عَمَلٌ مُسْتَدِيمٌ':Added, #1: 1	عَمَلِ الْمُسْتَأْجِرِ
u'عَمَلٌ مَسْجِدٌ':Added, #2: 2	عَمَلٍ مُسْتَدِيمٍ
u'عَمَلٌ مُسِيءٌ':Added, #1: 1	عَمَلِ الْمَسْجِدِ
u'عَمَلٌ مَشَايِخُ':Added, #1: 1	عَمَلُ الْمُسِيءِ
u'عَمَلٌ مَشُوبٌ':Added, #1: 1	عَمَلَ الْمَشَايِخِ
u'عَمَلٌ مَصَالِحُ':Added, #2: 2	عَمَلٍ مَشُوبٍ
u'عَمَلٌ مُصَدِّقٌ':Added, #1: 1	عَمَلِ مَصَالِحِ
u'عَمَلٌ مَصْلَحَةٌ':Added, #1: 1	عَمَلَ مُصَدِّقٍ
u'عَمَلٌ مَصْلَحَةٌ':Added, #1: 1	عَمَلِ الْمَصْلَحَةِ
u'عَمِلَ مُضَارِبٌ':Subject, #2: 2	عَمَلُ الْمَصْلَحَةِ
u'عَمَلٌ مُضَارِبٌ':Added, #9: 9	عَمِلَ الْمُضَارِبُ
u'عَمَلٌ مُضَارَبَةٌ':Added, #1: 1	عَمَلِ الْمُضَارِبِ
u'عَمَلٌ مُعَامَلَةٌ':Added, #2: 2	عَمَلِ الْمُضَارَبَةِ
u'عَمَلٌ مُعَاوِنٌ':Added, #1: 1	عَمَلِ الْمُعَامَلَةِ
u'عَمَلٌ مُعْتَادٌ':Added, #1: 1	عَمَلُ الْمُعَاوِنِ
u'عَمَلٌ مَعْدِنٌ':Added, #1: 1	عَمَلٍ مُعْتَادٍ
u'عَمَلٌ مَعْلُومٌ':Added, #1: 1	عَمَلِ مَعْدِنٍ
u'عَمَلٌ مُعَيَّنٌ':Added, #13: 13	عَمَلٍ مَعْلُومٍ
u'عَمَلٌ مُفْرَدٌ':Added, #6: 6	عَمَلٍ مُعَيَّنٍ
u'عَمِلَ مُفْلِسٌ':Subject, #1: 1	عَمَلَ الْمُفْرَدِ
u'عَمَلٌ مُفْلِسٌ':Added, #1: 1	عَمِلَ الْمُفْلِسُ
u'عَمَلٌ مُفْلِسٌ':Added, #1: 1	عَمَلُ الْمُفْلِسِ
u'عَمَلٌ مُفِيدٌ':Added, #1: 1	عَمَلِ الْمُفْلِسِ
u'عَمِلَ مَكَانٌ':Predicate, #1: 1	عَمَلٍ مُفِيدٍ
u'عَمَلٌ مَكْتُوبٌ':Added, #1: 1	عَمِلَ مَكَانَ
u'عَمَلٌ مَلْزُوم':Added, #1: 1	عَمَلِ الْمَكْتُوبِ
u'عَمَلٌ مُنَاظِرٌ':Added, #1: 1	عَمَلُ الْمَلْزُومِ
u'عَمِلَ مِنْبَرٌ':Predicate, #1: 1	عَمَلِ الْمُنَاظِرِ
u'عَمَلٌ مُنَجِّمٌ':Added, #1: 1	عَمِلَ مِنْبَرَ
u'عَمِلَ مُنْكَرٌ':Predicate, #1: 1	عَمَلِ الْمُنَجِّمِ
u'عَمِلَ مُؤْمِنٌ':Subject, #1: 1	عَمِلَ الْمُنْكَرَ
u'عَمَلٌ نَاجِزٌ':Added, #1: 1	عَمِلَ الْمُؤْمِنُ
u'عَمَلٌ نَاحِي':Added, #1: 1	عَمَلٍ نَاجِزٍ
u'عَمَلٌ نَاحِيَةٌ':Added, #2: 2	عَمَلَ نَاحِيَةٍ
u'عَمَلٌ نَارٌ':Added, #2: 2	عَمَلَ نَاحِيَةٍ
u'عَمَلٌ نَارٌ':Added, #1: 1	عَمَلَ النَّارِ
u'عَمَلٌ نَارٌ':Added, #1: 1	عَمَلُ النَّارِ
u'عَمَلٌ نَارٌ':Added, #1: 1	عَمَلِ النَّارِ
u'عَمِلَ نَاسٌ':Subject, #1: 1	عَمَلِ نَارٍ
u'عَمَلٌ نَاسٌ':Added, #2: 2	عَمِلَ النَّاسُ
u'عَمَلٌ نَاسٌ':Added, #11: 11	عَمَلِ النَّاسِ
u'عَمَلٌ نَاسٌ':Added, #35: 35	عَمَلُ النَّاسِ
u'عَمَلٌ نَحْلٌ':Added, #4: 4	عَمَلَ النَّاسِ
u'عَمَلٌ نُحْلٌ':Added, #2: 2	عَمَلُ النّحْلِ
u'عَمَلٌ نذر':Added, #2: 2	عَمَلُ النّحْلِ
u'عَمَلٌ نَذْرٌ':Added, #1: 1	عَمَلُ النَّذْرِ
u'عَمَلٌ نِساءٌ':Added, #1: 1	عَمَلُ النَّذْرِ
u'عَمَلٌ نسج':Added, #1: 1	عَمَلِ النّسَاءِ
u'عَمَلٌ نَسْجٌ':Added, #1: 1	عَمَلَ النَّسْجِ
u'عَمَلٌ نسج':Added, #1: 1	عَمَلَ النَّسْجِ
u'عَمَلٌ نَسْجٌ':Added, #1: 1	عَمَلَ نَسْجِ
u'عَمَلٌ نَصٌّ':Added, #1: 1	عَمَلَ نَسْجِ
u'عَمِلَ نِصْفٌ':Predicate, #1: 1	عَمَلَ النَّصِّ
u'عَمَلٌ نَظَرٌ':Added, #3: 3	عَمِلَ نِصْفَ
u'عَمِلَ نَظِيرٌ':Predicate, #1: 1	عَمَلُ نَظَرٍ
u'عَمَلٌ نَفْسٌ':Added, #1: 1	عَمِلَ نَظِيرَ
u'عَمَلٌ نَفْسٌ':Added, #2: 2	عَمَلِ نَفْسِهِ
u'عَمِلَ نَفَقَةٌ':Subject, #3: 3	عَمَلَ نَفْسِهِ
u'عَمَلٌ نقل':Added, #1: 1	عَمِلَ نَفَقَتُهُ
u'عَمَلٌ نَقْلٌ':Added, #1: 1	عَمَلِ النَّقْلِ
u'عَمَلٌ نَمَّامٌ':Added, #1: 1	عَمَلِ النَّقْلِ
u'عَمَلٌ نهار':Added, #1: 1	عَمَلُ النَّمَّامِ
u'عَمَلٌ نَهَارٌ':Added, #1: 1	عَمَلُ النَّهَارِ
u'عَمَلٌ نَهْيٌ':Added, #1: 1	عَمَلُ النَّهَارِ
u'عَمَلٌ نِيَّةٌ':Added, #1: 1	عَمَلَ النَّهْيِ
u'عَمَلٌ نِيَّةٌ':Added, #1: 1	عَمَلَ النِّيَّةِ
u'عَمَلٌ نِيَّةٌ':Added, #1: 1	عَمَلُ النِّيَّةِ
u'عَمِلَ هاشِمِيّ':Subject, #1: 1	عَمَلِ النِّيَّةِ
u'عَمَلٌ هَزْلٌ':Added, #1: 1	عَمِلَ الْهَاشِمِيُّ
u'عَمَلٌ وَاجِبٌ':Added, #1: 1	عَمَلَ الْهَزْلِ
u'عَمَلٌ وَاجِبٌ':Added, #1: 1	عَمَلِ وَاجِبٍ
u'عَمِلَ واحد':Subject, #2: 2	عَمَلٍ وَاجِبٍ
u'عَمِلَ وَاحِدٌ':Subject, #1: 1	عَمِلَ وَاحِدٌ
u'عَمَلٌ واحد':Added, #1: 1	عَمِلَ وَاحِدٌ
u'عَمَلٌ وَاحِدٌ':Added, #1: 1	عَمَلِ وَاحِدٍ
u'عَمَلٌ واحد':Added, #1: 1	عَمَلِ وَاحِدٍ
u'عَمَلٌ وَاحِدٌ':Added, #4: 4	عَمَلٍ وَاحِدٍ
u'عَمَلٌ واصِب':Added, #4: 4	عَمَلٍ وَاحِدٍ
u'عَمَلٌ وَزْنٌ':Added, #1: 1	عَمَلٍ وَاصِبٍ
u'عَمِلَ وَصِيٌّ':Subject, #1: 1	عَمَلِ الْوَزْنِ
u'عَمَلٌ وَصِيٌّ':Added, #1: 1	عَمِلَ الْوَصِيُّ
u'عَمَلٌ وُضُوءٌ':Added, #1: 1	عَمَلِ الْوَصِيِّ
u'عَمَلٌ وُضُوءٌ':Added, #1: 1	عَمَلِ الْوُضُوءِ
u'عَمِلَ وَفْقٌ':Predicate, #5: 5	عَمَلَ الْوُضُوءِ
u'عَمِلَ وَكِيلٌ':Subject, #1: 1	عَمِلَ وَفْقَ
u'عَمَلٌ وَكِيلٌ':Added, #1: 1	عَمِلَ الْوَكِيلُ
u'عَمَلٌ ولد':Added, #3: 3	عَمَلَ الْوَكِيلِ
u'عَمَلٌ وَلَدٌ':Added, #1: 1	عَمَلِ وَلَدِهِ
u'عَمَلٌ يَتِيمٌ':Added, #1: 1	عَمَلِ وَلَدِهِ
u'عَمَلٌ يَدٌ':Added, #1: 1	عَمَلِ الْيَتِيمِ
u'عَمَلٌ يَدٌ':Added, #1: 1	عَمَلِ يَدٍ
u'عَمَلٌ يَدٌ':Added, #1: 1	عَمَلِ يَدِ
u'عَمَلٌ يَدٌ':Added, #2: 2	عَمَلَ الْيَدِ
u'عَمَلٌ يَدٌ':Added, #2: 2	عَمَلُ الْيَدِ
u'عَمَلٌ يَدٌ':Added, #2: 2	عَمَلُ يَدِهِ
u'عَمَلٌ يَقِينٌ':Added, #6: 6	عَمَلِ يَدِهِ
u'عَمَلٌ يهود':Added, #2: 2	عَمَلَ الْيَقِينِ
u'عَمَلٌ يَهُودٌ':Added, #1: 1	عَمَلُ الْيَهُودِ
u'عَمَلٌ يَوْمٌ':Added, #1: 1	عَمَلُ الْيَهُودِ
u'عَمَلٌ يَوْمٌ':Added, #1: 1	عَمَلَ الْيَوْمِ
u'عَمَلٌ يَوْمٌ':Added, #1: 1	عَمَلَ يَوْمٍ
u'عَمَلٌ يَوْمٌ':Added, #1: 1	عَمَلُ يَوْمٍ
u'عَمَلٌ يَوْمٌ':Added, #1: 1	عَمَلِ يَوْمِ
u'عَمَلٌ يَوْمٌ':Added, #1: 1	عَمَلُ يَوْمَيْنِ
u'عَمَلٌ يَوْمٌ':Added, #2: 2	عَمَلِ يَوْمٍ
u'عَمَّ مَاءٌ':Subject, #4: 4	عَمَلِ الْيَوْمِ
u'عَمَّمَ جَازٌ':Predicate, #1: 1	عَمَّ الْمَاءُ
u'عَمَّمَ خِلاَفٌ':Predicate, #1: 1	عَمَّمَ جَازَ
u'عَمَّمَ خَمْرٌ':Predicate, #1: 1	عَمَّمَ الْخِلَافَ
u'عَمَّمَ رحم':Predicate, #1: 1	عَمَّمَ الْخَمْرَ
u'عَمَّمَ رَحِمٌ':Predicate, #1: 1	عَمَّمَ الرَّحِمَ
u'عَمَّ مَرَضٌ':Subject, #1: 1	عَمَّمَ الرَّحِمَ
u'عَمَّمَ عَبْدٌ':Predicate, #1: 1	عَمَّ الْمَرَضُ
u'عَمَّمَ كَلاَمٌ':Predicate, #1: 1	عَمَّمَ عَبْدَ
u'عَمَّمَ مُصَنِّفٌ':Subject, #2: 2	عَمَّمَ الْكَلَامَ
u'عَمَّمَ مَنْعٌ':Predicate, #1: 1	عَمَّمَ الْمُصَنِّفُ
u'عَمَّ مَنَافِعُ':Predicate, #1: 1	عَمَّمَ الْمَنْعَ
u'عَمَّ نَاسٌ':Predicate, #1: 1	عَمَّ الْمَنَافِعَ
u'عَمَّ نَبِيٌّ':Predicate, #2: 2	عَمَّ النَّاسَ
u'عَمَّ نِساءٌ':Predicate, #1: 1	عَمَّ النَّبِيَّ
u'عَمَّ هِلاَلٌ':Subject, #2: 2	عَمَّ النِّسَاءَ
u'عَمَّ وَبَاءٌ':Subject, #1: 1	عَمَّ هِلَالُ
u'عَمَّ وُقُوعٌ':Subject, #1: 1	عَمَّ الْوَبَاءُ
u'عُمُومٌ اِبْتِلاَءٌ':Added, #1: 1	عَمَّ وُقُوعُهُ
u'عُمُومٌ آحَادٌ':Added, #1: 1	عُمُومَ ابْتِلَاءِ
u'عُمُومٌ أَحادِيثُ':Added, #1: 1	عُمُومِ آحَادِ
u'عُمُومٌ أَحادِيثُ':Added, #1: 1	عُمُومُ الْأَحَادِيثِ
u'عُمُومٌ أحَدٌ':Added, #2: 2	عُمُومِ الْأَحَادِيثِ
u'عُمُومٌ أَحْكَامٌ':Added, #1: 1	عُمُومِ أَحَدِ
u'عُمُومٌ أَحْكَامٌ':Added, #1: 1	عُمُومِ أَحْكَامِ
u'عُمُومٌ أَحْكَامٌ':Added, #1: 1	عُمُومِ أَحْكَامِهِ
u'عُمُومٌ أَحْوالٌ':Added, #1: 1	عُمُومَ الْأَحْكَامِ
u'عُمُومٌ أحْوَالٌ':Added, #1: 1	عُمُومِ الأَحْوَالِ
u'عُمُومٌ أَحْوالٌ':Added, #1: 1	عُمُومِ الأَحْوَالِ
u'عُمُومٌ أحْوَالٌ':Added, #3: 3	عُمُومِ الْأَحْوَالِ
u'عُمُومٌ أخْبَارٌ':Added, #3: 3	عُمُومِ الْأَحْوَالِ
u'عُمُومٌ أَخْبَارٌ':Added, #1: 1	عُمُومِ أَخْبَارِ
u'عُمُومٌ أخْذٌ':Added, #1: 1	عُمُومِ أَخْبَارِ
u'عُمُومٌ إِذْنٌ':Added, #1: 1	عُمُومِ أَخْذِ
u'عُمُومٌ إِرَادَةٌ':Added, #1: 1	عُمُومُ الْإِذْنِ
u'عُمُومٌ أَزْمِنَةٌ':Added, #1: 1	عُمُومِ إرَادَةِ
u'عُمُومٌ اِسْتِغْرَاقٌ':Added, #1: 1	عُمُومَ الْأَزْمِنَةِ
u'عُمُومٌ أَسْماءٌ':Added, #1: 1	عُمُومُ اسْتِغْرَاقٍ
u'عُمُومٌ أَسْماءٌ':Added, #1: 1	عُمُومَ أَسْمَاءِ
u'عُمُومٌ أَسْماءٌ':Added, #1: 1	عُمُومِ الْأَسْمَاءِ
u'عُمُومٌ أَشْخَاصٌ':Added, #3: 3	عُمُومَ الْأَسْمَاءِ
u'عُمُومٌ أَشْخَاصٌ':Added, #1: 1	عُمُومَ الْأَشْخَاصِ
u'عُمُومٌ أَشْخَاصٌ':Added, #1: 1	عُمُومُ الْأَشْخَاصِ
u'عُمُومٌ أَشْكَالٌ':Added, #1: 1	عُمُومِ الْأَشْخَاصِ
u'عُمُومٌ أَشْيَاءٌ':Added, #1: 1	عُمُومِ الْأَشْكَالِ
u'عُمُومٌ أصدقاء':Added, #1: 1	عُمُومَ الْأَشْيَاءِ
u'عُمُومٌ أصل':Added, #2: 2	عُمُومَ الْأَصْدِقَاءِ
u'عُمُومٌ أًصْلٌ':Added, #1: 1	عُمُومُ أَصْلِهِ
u'عُمُومٌ أَصْنَافٌ':Added, #1: 1	عُمُومُ أَصْلِهِ
u'عُمُومٌ إضافَةٌ':Added, #1: 1	عُمُومِ الْأَصْنَافِ
u'عُمُومٌ أَعْمَالٌ':Added, #1: 1	عُمُومَ الْإِضَافَةِ
u'عُمُومٌ أعْيانٌ':Added, #2: 2	عُمُومِ الْأَعْمَالِ
u'عُمُومٌ أَعْيَانٌ':Added, #1: 1	عُمُومُ الْأَعْيَانِ
u'عُمُومٌ أَفْرَادٌ':Added, #1: 1	عُمُومُ الْأَعْيَانِ
u'عُمُومٌ إِفْرَادٌ':Added, #1: 1	عُمُومَ الْأَفْرَادِ
u'عُمُومٌ أَفْعَالٌ':Added, #1: 1	عُمُومَ الْإِفْرَادِ
u'عُمُومٌ أَفْعَالٌ':Added, #1: 1	عُمُومِ الْأَفْعَالِ
u'عُمُومٌ آلاَمٌ':Added, #6: 6	عُمُومَ الْأَفْعَالِ
u'عُمُومٌ ألف':Added, #1: 1	عُمُومِ الْآلَامِ
u'عُمُومٌ أَمْرٌ':Added, #1: 1	عُمُومَ الْأَلِفِ
u'عُمُومٌ أَمْرٌ':Added, #1: 1	عُمُومُ الْأَمْرِ
u'عُمُومٌ أَمْرٌ':Added, #1: 1	عُمُومِ الْأَمْرِ
u'عُمُومٌ أَمْرٌ':Added, #1: 1	عُمُومِ الْأَمْرَيْنِ
u'عُمُومٌ إِمْرارٌ':Added, #3: 3	عُمُومِ أَمْرِ
u'عُمُومٌ أَمْرَاضٌ':Added, #1: 1	عُمُومَ إمْرَارِ
u'عُمُومٌ أَمْرَاضٌ':Added, #1: 1	عُمُومِ الْأَمْرَاضِ
u'عُمُومٌ أُمُورٌ':Added, #2: 2	عُمُومُ الْأَمْرَاضِ
u'عُمُومٌ اِنْتِفاعٌ':Added, #1: 1	عُمُومِ الْأُمُورِ
u'عُمُومٌ أَنْوَاعٌ':Added, #1: 1	عُمُومِ انْتِفَاعٍ
u'عُمُومٌ أَوْجُهٌ':Added, #1: 1	عُمُومُ أَنْوَاعِ
u'عُمُومٌ أَوْقَاتٌ':Added, #1: 1	عُمُومِ أَوْجُهِ
u'عُمُومٌ أَوْقَاتٌ':Added, #1: 1	عُمُومَ الْأَوْقَاتِ
u'عُمُومٌ أَوَّلُ':Added, #4: 4	عُمُومِ الْأَوْقَاتِ
u'عُمُومٌ أَوَّلُ':Added, #1: 1	عُمُومِ أَوَّلِ
u'عُمُومٌ أَوَّلُ':Added, #2: 2	عُمُومَ الْأَوَّلِ
u'عُمُومٌ أَوَّلُ':Added, #2: 2	عُمُومِ الْأَوَّلِ
u'عُمُومٌ آيَةٌ':Added, #5: 5	عُمُومُ الْأَوَّلِ
u'عُمُومٌ آيَةٌ':Added, #1: 1	عُمُومَ آيَةٍ
u'عُمُومٌ آيَةٌ':Added, #1: 1	عُمُومُ آيَةِ
u'عُمُومٌ آيَةٌ':Added, #2: 2	عُمُومِ آيَةِ
u'عُمُومٌ آيَةٌ':Added, #4: 4	عُمُومَ الْآيَةِ
u'عُمُومٌ آيَةٌ':Added, #4: 4	عُمُومُ الْآيَةِ
u'عُمُومٌ إيرَادٌ':Added, #7: 7	عُمُومِ الْآيَةِ
u'عُمُومٌ أَيْمَانٌ':Added, #1: 1	عُمُومُ إيرَادِ
u'عُمُومٌ بَدَلٌ':Added, #1: 1	عُمُومِ الْأَيْمَانِ
u'عُمُومٌ بَدَلٌ':Added, #1: 1	عُمُومُ الْبَدَلِ
u'عُمُومٌ بَدَلٌ':Added, #1: 1	عُمُومَ بَدَلٍ
u'عُمُومٌ بدن':Added, #1: 1	عُمُومُ بَدَلٍ
u'عُمُومٌ بَدَنٌ':Added, #1: 1	عُمُومَ الْبَدَنِ
u'عُمُومٌ بَعْثٌ':Added, #1: 1	عُمُومَ الْبَدَنِ
u'عُمُومٌ بَعْثٌ':Added, #1: 1	عُمُومُ الْبَعْثِ
u'عُمُومٌ بَوْلٌ':Added, #1: 1	عُمُومِ الْبَعْثِ
u'عُمُومٌ تَأَخُّرٌ':Added, #1: 1	عُمُومِ الْبَوْلِ
u'عُمُومٌ تِجَارَةٌ':Added, #1: 1	عُمُومُ التَّأَخُّرِ
u'عُمُومٌ تَحْرِيمٌ':Added, #6: 6	عُمُومِ التِّجَارَاتِ
u'عُمُومٌ تَحْرِيمٌ':Added, #1: 1	عُمُومَ التَّحْرِيمِ
u'عُمُومٌ تَحْلِيلٌ':Added, #1: 1	عُمُومِ التَّحْرِيمِ
u'عُمُومٌ تَرْتِيبٌ':Added, #1: 1	عُمُومِ التَّحْلِيلِ
u'عُمُومٌ تَسْوِيَةٌ':Added, #1: 1	عُمُومَ التَّرْتِيبِ
u'عُمُومٌ تَسْوِيَةٌ':Added, #1: 1	عُمُومُ التَّسْوِيَةِ
u'عُمُومٌ تَصَرُّفٌ':Added, #1: 1	عُمُومِ التَّسْوِيَةِ
u'عُمُومٌ تَعَلُّقٌ':Added, #1: 1	عُمُومَ التَّصَرُّفِ
u'عُمُومٌ تَعَلُّقٌ':Added, #1: 1	عُمُومُ تَعَلُّقِ
u'عُمُومٌ تَعَلُّقٌ':Added, #1: 1	عُمُومِ تَعَلُّقِ
u'عُمُومٌ تقارير':Added, #1: 1	عُمُومِ تَعَلُّقِهِ
u'عُمُومٌ تَقْديرٌ':Added, #1: 1	عُمُومَ التَّقَارِيرِ
u'عُمُومٌ تَقْليدٌ':Added, #4: 4	عُمُومُ التَّقْدِيرِ
u'عُمُومٌ تَقْليد':Added, #2: 2	عُمُومُ التَّقْلِيدِ
u'عُمُومٌ تَكْليفٌ':Added, #2: 2	عُمُومُ التَّقْلِيدِ
u'عُمُومٌ تَنَاوُلٌ':Added, #1: 1	عُمُومِ التَّكْلِيفِ
u'عُمُومٌ تَنْزِيلٌ':Added, #1: 1	عُمُومَ التَّنَاوُلِ
u'عُمُومٌ تَوْلِيَةٌ':Added, #1: 1	عُمُومُ التّنْزِيلِ
u'عُمُومٌ ثِيابٌ':Added, #1: 1	عُمُومُ التَّوْلِيَةِ
u'عُمُومٌ جَرَيان':Added, #1: 1	عُمُومِ الثِّيَابِ
u'عُمُومٌ جمع':Added, #1: 1	عُمُومَ جَرَيَانِ
u'عُمُومٌ جمع':Added, #1: 1	عُمُومُ الْجَمْعِ
u'عُمُومٌ جَمْعٌ':Added, #1: 1	عُمُومِ الْجَمْعِ
u'عُمُومٌ جَمْعٌ':Added, #1: 1	عُمُومُ الْجَمْعِ
u'عُمُومٌ جمع':Added, #1: 1	عُمُومِ الْجَمْعِ
u'عُمُومٌ جَمْعٌ':Added, #3: 3	عُمُومَ الْجَمْعِ
u'عُمُومٌ جِنْسٌ':Added, #3: 3	عُمُومَ الْجَمْعِ
u'عُمُومٌ جَوَابٌ':Added, #1: 1	عُمُومِ الْجِنْسِ
u'عُمُومٌ جَوَابٌ':Added, #1: 1	عُمُومُ الْجَوَابِ
u'عُمُومٌ جود':Added, #4: 4	عُمُومِ الْجَوَابِ
u'عُمُومٌ جُودٌ':Added, #1: 1	عُمُومِ جُودِهِ
u'عُمُومٌ جَوْهَرٌ':Added, #1: 1	عُمُومِ جُودِهِ
u'عُمُومٌ جَوْهَرِيٌّ':Added, #1: 1	عُمُومُ الْجَوْهَرِيَّةِ
u'عُمُومٌ حاجَةٌ':Added, #1: 1	عُمُومُ الْجَوْهَرِيَّةِ
u'عُمُومٌ حاجَةٌ':Added, #1: 1	عُمُومَ الْحَاجَةِ
u'عُمُومٌ حاجَةٌ':Added, #1: 1	عُمُومِ الْحَاجَةِ
u'عُمُومٌ حَجٌّ':Added, #2: 2	عُمُومُ الْحَاجَةِ
u'عُمُومٌ حجبة':Added, #1: 1	عُمُومِ الْحَجِّ
u'عُمُومٌ حَديثٌ':Added, #1: 1	عُمُومِ الْحُجْبَةِ
u'عُمُومٌ حَديثٌ':Added, #2: 2	عُمُومَ الْحَدِيثِ
u'عُمُومٌ حَديثٌ':Added, #3: 3	عُمُومُ الْحَدِيثِ
u'عُمُومٌ حُرْمَةٌ':Added, #3: 3	عُمُومِ الْحَدِيثِ
u'عُمُومٌ حُرْمَةٌ':Added, #1: 1	عُمُومَ الْحُرْمَةِ
u'عُمُومٌ حُصُول':Added, #1: 1	عُمُومُ حُرْمَةِ
u'عُمُومٌ حُكْمٌ':Added, #1: 1	عُمُومُ حُصُولٍ
u'عُمُومٌ حُكْمٌ':Added, #1: 1	عُمُومُ حُكْمِ
u'عُمُومٌ حُكْمٌ':Added, #1: 1	عُمُومِ حُكْمِهِ
u'عُمُومٌ حُكْمٌ':Added, #2: 2	عُمُومِ حُكْمِ
u'عُمُومٌ حُكْمٌ':Added, #3: 3	عُمُومَ الْحُكْمِ
u'عُمُومٌ حُكْمٌ':Added, #3: 3	عُمُومُ الْحُكْمِ
u'عُمُومٌ خَبَرٌ':Added, #5: 5	عُمُومِ الْحُكْمِ
u'عُمُومٌ خَبَر':Added, #1: 1	عُمُومُ الْخَبَرِ
u'عُمُومٌ خَبَرٌ':Added, #1: 1	عُمُومُ الْخَبَرِ
u'عُمُومٌ خَبَر':Added, #1: 1	عُمُومُ خَبَرِ
u'عُمُومٌ خَبَرٌ':Added, #1: 1	عُمُومُ خَبَرِ
u'عُمُومٌ خَبَر':Added, #2: 2	عُمُومِ الْخَبَرِ
u'عُمُومٌ خَبَرٌ':Added, #2: 2	عُمُومِ الْخَبَرِ
u'عُمُومٌ خَبَر':Added, #2: 2	عُمُومَ خَبَرِ
u'عُمُومٌ خَبَرٌ':Added, #2: 2	عُمُومَ خَبَرِ
u'عُمُومٌ خَبَر':Added, #3: 3	عُمُومِ خَبَرِ
u'عُمُومٌ خُرُوجٌ':Added, #3: 3	عُمُومِ خَبَرِ
u'عُمُومٌ خِطَابٌ':Added, #1: 1	عُمُومِ الْخُرُوجِ
u'عُمُومٌ خِطَابٌ':Added, #2: 2	عُمُومُ الْخِطَابِ
u'عُمُومٌ خِطَابٌ':Added, #5: 5	عُمُومِ الْخِطَابِ
u'عُمُومٌ خِلاَفٌ':Added, #5: 5	عُمُومِ خِطَابِهِ
u'عُمُومٌ خلق':Added, #1: 1	عُمُومِ الْخِلَافِ
u'عُمُومٌ خَلْقٌ':Added, #1: 1	عُمُومِ الْخَلْقِ
u'عُمُومٌ خلق':Added, #1: 1	عُمُومِ الْخَلْقِ
u'عُمُومٌ خَلْقٌ':Added, #1: 1	عُمُومِ خَلْقِ
u'عُمُومٌ خلق':Added, #1: 1	عُمُومِ خَلْقِ
u'عُمُومٌ خَلْقٌ':Added, #1: 1	عُمُومَ خَلْقِهِ
u'عُمُومٌ دَارٌ':Added, #1: 1	عُمُومَ خَلْقِهِ
u'عُمُومٌ ذُرِّيَّةٌ':Added, #1: 1	عُمُومَ دَارِ
u'عُمُومٌ ذكر':Added, #2: 2	عُمُومَ الذُّرِّيَّةِ
u'عُمُومٌ ذِكْرٌ':Added, #1: 1	عُمُومِ ذِكْرِ
u'عُمُومٌ ذكر':Added, #1: 1	عُمُومِ ذِكْرِ
u'عُمُومٌ ذِكْرٌ':Added, #2: 2	عُمُومِ الذِّكْرِ
u'عُمُومٌ ذَمٌّ':Added, #2: 2	عُمُومِ الذِّكْرِ
u'عُمُومٌ رُخْصَةٌ':Added, #3: 3	عُمُومِ الذَّمِّ
u'عُمُومٌ رِسَالَةٌ':Added, #1: 1	عُمُومِ الرُّخْصَةِ
u'عُمُومٌ رِسَالَةٌ':Added, #1: 1	عُمُومَ الرِّسَالَةِ
u'عُمُومٌ رِوايَةٌ':Added, #1: 1	عُمُومُ رِسَالَةِ
u'عُمُومٌ رِوايَةٌ':Added, #1: 1	عُمُومُ الرِّوَايَةِ
u'عُمُومٌ زَمانٌ':Added, #1: 1	عُمُومُ رِوَايَةِ
u'عُمُومٌ زَمانٌ':Added, #1: 1	عُمُومَ الزَّمَانِ
u'عُمُومٌ زَوْجَةٌ':Added, #1: 1	عُمُومِ زَمَانِ
u'عُمُومٌ سَابِقٌ':Added, #1: 1	عُمُومَ الزَّوْجَاتِ
u'عُمُومٌ سَائِرٌ':Added, #1: 1	عُمُومٍ سَابِقٍ
u'عُمُومٌ سَبَبٌ':Added, #1: 1	عُمُومِ سَائِرِ
u'عُمُومٌ سَلْبٌ':Added, #1: 1	عُمُومَ السَّبَبِ
u'عُمُومٌ سَلْبٌ':Added, #1: 1	عُمُومُ سَلْبِ
u'عُمُومٌ سَلْبٌ':Added, #3: 3	عُمُومُ السَّلْبِ
u'عُمُومٌ سَلْبٌ':Added, #4: 4	عُمُومَ السَّلْبِ
u'عُمُومٌ سُنَّةٌ':Added, #4: 4	عُمُومِ السَّلْبِ
u'عُمُومٌ سُؤَالٌ':Added, #1: 1	عُمُومِ السُّنَّةِ
u'عُمُومٌ شَبَهٌ':Added, #1: 1	عُمُومُ سُؤَالِ
u'عُمُومٌ شَخْصٌ':Added, #1: 1	عُمُومَ الشَّبَهِ
u'عُمُومٌ شَرْطٌ':Added, #1: 1	عُمُومَ الشَّخْصِ
u'عُمُومٌ شَرْطٌ':Added, #1: 1	عُمُومِ شَرْطِ
u'عُمُومٌ شَرْعِيٌّ':Added, #2: 2	عُمُومِ الشَّرْطِ
u'عُمُومٌ شُمُول':Added, #1: 1	عُمُومُ شَرْعِيَّةِ
u'عُمُومٌ شُمُول':Added, #1: 1	عُمُومَ شُمُولٍ
u'عُمُومٌ شُمُول':Added, #1: 1	عُمُومُ شُمُولٍ
u'عُمُومٌ شُمُول':Added, #2: 2	عُمُومِ الشُّمُولِ
u'عُمُومٌ شَهَادَةٌ':Added, #3: 3	عُمُومَ الشُّمُولِ
u'عُمُومٌ شَيْءٌ':Added, #1: 1	عُمُومُ الشَّهَادَةِ
u'عُمُومٌ صَدَقَةٌ':Added, #1: 1	عُمُومِ شَيْءٍ
u'عُمُومٌ صِفَةٌ':Added, #1: 1	عُمُومِ الصَّدَقَاتِ
u'عُمُومٌ صَلاَةٌ':Added, #1: 1	عُمُومَ الصِّفَةِ
u'عُمُومٌ صَلاَةٌ':Added, #1: 1	عُمُومَ الصَّلَاةِ
u'عُمُومٌ صَلاَةٌ':Added, #1: 1	عُمُومُ الصَّلَاةِ
u'عُمُومٌ صَلاَحِيَةٌ':Added, #3: 3	عُمُومِ الصَّلَاةِ
u'عُمُومٌ صُورٌ':Added, #1: 1	عُمُومَ الصَّلَاحِيَةِ
u'عُمُومٌ صُوَرٌ':Added, #1: 1	عُمُومِ الصُّوَرِ
u'عُمُومٌ صَوْمٌ':Added, #1: 1	عُمُومِ الصُّوَرِ
u'عُمُومٌ صَيْدٌ':Added, #1: 1	عُمُومَ صَوْمِهِ
u'عُمُومٌ صِيَغٌ':Added, #2: 2	عُمُومَ الصَّيْدِ
u'عُمُومٌ صِيَغٌ':Added, #1: 1	عُمُومُ الصِّيَغِ
u'عُمُومٌ ضَأْنٌ':Added, #2: 2	عُمُومَ الصِّيَغِ
u'عُمُومٌ طَاعُونٌ':Added, #1: 1	عُمُومُ الضَّأْنِ
u'عُمُومٌ طعام':Added, #1: 1	عُمُومِ الطَّاعُونِ
u'عُمُومٌ طَعَامٌ':Added, #1: 1	عُمُومَ الطَّعَامِ
u'عُمُومٌ طَلاَقٌ':Added, #1: 1	عُمُومَ الطَّعَامِ
u'عُمُومٌ طَيْرٌ':Added, #1: 1	عُمُومَ الطَّلَاقِ
u'عُمُومٌ ظاهِرٌ':Added, #1: 1	عُمُومِ الطَّيْرِ
u'عُمُومٌ عِبَارَةٌ':Added, #1: 1	عُمُومِ ظَاهِرِ
u'عُمُومٌ عِبَارَةٌ':Added, #1: 1	عُمُومُ عِبَارَاتِ
u'عُمُومٌ عِبَارَةٌ':Added, #1: 1	عُمُومِ عِبَارَاتِ
u'عُمُومٌ عقاب':Added, #2: 2	عُمُومُ عِبَارَةِ
u'عُمُومٌ عِقَابٌ':Added, #1: 1	عُمُومِ الْعِقَابِ
u'عُمُومٌ عُقُودٌ':Added, #1: 1	عُمُومِ الْعِقَابِ
u'عُمُومٌ عِلَّةٌ':Added, #1: 1	عُمُومِ الْعُقُودِ
u'عُمُومٌ علم':Added, #1: 1	عُمُومِ عِلَّةٍ
u'عُمُومٌ علم':Added, #1: 1	عُمُومَ عِلْمِهِ
u'عُمُومٌ عِلْمٌ':Added, #1: 1	عُمُومِ عِلْمِهِ
u'عُمُومٌ عِلْمٌ':Added, #1: 1	عُمُومَ عِلْمِهِ
u'عُمُومٌ عَمَلٌ':Added, #1: 1	عُمُومِ عِلْمِهِ
u'عُمُومٌ غير':Added, #2: 2	عُمُومِ الْعَمَلِ
u'عُمُومٌ غير':Added, #1: 1	عُمُومَ غَيْرِ
u'عُمُومٌ غَيْرٌ':Added, #1: 1	عُمُومُ غَيْرِ
u'عُمُومٌ غَيْرٌ':Added, #1: 1	عُمُومَ غَيْرِ
u'عُمُومٌ فَاعِلٌ':Added, #1: 1	عُمُومُ غَيْرِ
u'عُمُومٌ فَاعِلٌ':Added, #1: 1	عُمُومُ الْفَاعِلِ
u'عُمُومٌ فَرْضٌ':Added, #1: 1	عُمُومِ الْفَاعِلِ
u'عُمُومٌ فِسْقٌ':Added, #1: 1	عُمُومَ فَرْضِ
u'عُمُومٌ فَصْلٌ':Added, #1: 1	عُمُومِ الْفِسْقِ
u'عُمُومٌ فِعْلٌ':Added, #1: 1	عُمُومِ فَصْلٍ
u'عُمُومٌ فِعْلٌ':Added, #1: 1	عُمُومَ الْفِعْلِ
u'عُمُومٌ فِعْلٌ':Added, #2: 2	عُمُومُ الْفِعْلِ
u'عُمُومٌ فلان':Added, #2: 2	عُمُومِ الْفِعْلِ
u'عُمُومٌ قَبُولٌ':Added, #1: 1	عُمُومِ مَمْلُوكِيَّةِ
u'عُمُومٌ قَرَابَةٌ':Added, #1: 1	عُمُومِ قَبُولِ
u'عُمُومٌ قَرَابَةٌ':Added, #1: 1	عُمُومُ الْقَرَابَةِ
u'عُمُومٌ قُرْآنٌ':Added, #1: 1	عُمُومِ الْقَرَابَةِ
u'عُمُومٌ قُرْآنٌ':Added, #3: 3	عُمُومِ الْقُرْآنِ
u'عُمُومٌ قُرْآنٌ':Added, #4: 4	عُمُومَ الْقُرْآنِ
u'عُمُومٌ قول':Added, #6: 6	عُمُومُ الْقُرْآنِ
u'عُمُومٌ قَوْلٌ':Added, #10: 10	عُمُومُ قَوْلِهِ
u'عُمُومٌ قول':Added, #10: 10	عُمُومُ قَوْلِهِ
u'عُمُومٌ قَوْلٌ':Added, #27: 27	عُمُومِ قَوْلِهِ
u'عُمُومٌ قول':Added, #27: 27	عُمُومِ قَوْلِهِ
u'عُمُومٌ قَوْلٌ':Added, #2: 2	عُمُومِ الْقَوْلِ
u'عُمُومٌ قول':Added, #2: 2	عُمُومِ الْقَوْلِ
u'عُمُومٌ قَوْلٌ':Added, #2: 2	عُمُومِ قَوْلِ
u'عُمُومٌ قول':Added, #2: 2	عُمُومِ قَوْلِ
u'عُمُومٌ قَوْلٌ':Added, #4: 4	عُمُومُ قَوْلِ
u'عُمُومٌ قول':Added, #4: 4	عُمُومُ قَوْلِ
u'عُمُومٌ قَوْلٌ':Added, #4: 4	عُمُومَ قَوْلِهِ
u'عُمُومٌ قِيَاسٌ':Added, #4: 4	عُمُومَ قَوْلِهِ
u'عُمُومٌ كِتَابٌ':Added, #1: 1	عُمُومَ الْقِيَاسِ
u'عُمُومٌ كِتَابٌ':Added, #11: 11	عُمُومِ الْكِتَابِ
u'عُمُومٌ كِتَابٌ':Added, #1: 1	عُمُومَ الْكِتَابِ
u'عُمُومٌ كِتَابٌ':Added, #1: 1	عُمُومَ كِتَابٍ
u'عُمُومٌ كُفَّارٌ':Added, #1: 1	عُمُومُ كِتَابٍ
u'عُمُومٌ كَلاَمٌ':Added, #1: 1	عُمُومَ الْكُفَّارِ
u'عُمُومٌ كَلاَمٌ':Added, #1: 1	عُمُومِ الْكَلَامِ
u'عُمُومٌ كَلاَمٌ':Added, #1: 1	عُمُومَ كَلَامِ
u'عُمُومٌ كَلاَمٌ':Added, #1: 1	عُمُومَ كَلَامِهِ
u'عُمُومٌ كَلاَمٌ':Added, #2: 2	عُمُومُ الْكَلَامِ
u'عُمُومٌ كَلاَمٌ':Added, #31: 31	عُمُومِ كَلَامِ
u'عُمُومٌ كَلاَمٌ':Added, #4: 4	عُمُومُ كَلَامِ
u'عُمُومٌ كَلاَمٌ':Added, #4: 4	عُمُومُ كَلَامِهِ
u'عُمُومٌ كَلِمَةٌ':Added, #9: 9	عُمُومِ كَلَامِهِ
u'عُمُومٌ كَوْنٌ':Added, #1: 1	عُمُومُ كَلِمَةِ
u'عُمُومٌ لَفْظٌ':Added, #1: 1	عُمُومِ كَوْنِ
u'عُمُومٌ لَفْظٌ':Added, #10: 10	عُمُومُ اللَّفْظِ
u'عُمُومٌ لَفْظٌ':Added, #14: 14	عُمُومِ اللَّفْظِ
u'عُمُومٌ لَفْظٌ':Added, #1: 1	عُمُومَ لَفْظٍ
u'عُمُومٌ لَفْظٌ':Added, #2: 2	عُمُومُ لَفْظِ
u'عُمُومٌ لَفْظٌ':Added, #2: 2	عُمُومِ لَفْظِ
u'عُمُومٌ لَفْظٌ':Added, #3: 3	عُمُومَ لَفْظِ
u'عُمُومٌ لَفْظٌ':Added, #3: 3	عُمُومُ لَفْظِهِ
u'عُمُومٌ لَفْظٌ':Added, #3: 3	عُمُومِ لَفْظِهِ
u'عُمُومٌ مَاءٌ':Added, #5: 5	عُمُومَ اللَّفْظِ
u'عُمُومٌ مَأْكُولٌ':Added, #1: 1	عُمُومِ الْمَاءِ
u'عُمُومٌ مَالٌ':Added, #2: 2	عُمُومِ الْمَأْكُولِ
u'عُمُومٌ مُبِيحٌ':Added, #4: 4	عُمُومِ الْمَالِ
u'عُمُومٌ مُتَعَلِّقٌ':Added, #1: 1	عُمُومِ الْمُبِيحِ
u'عُمُومٌ مَتْنٌ':Added, #3: 3	عُمُومِ مُتَعَلِّقِ
u'عُمُومٌ مثل':Added, #1: 1	عُمُومُ الْمَتْنِ
u'عُمُومٌ مِثْلٌ':Added, #1: 1	عُمُومِ مِثْلِ
u'عُمُومٌ مَجَازٌ':Added, #1: 1	عُمُومِ مِثْلِ
u'عُمُومٌ مَجَازٌ':Added, #18: 18	عُمُومِ الْمَجَازِ
u'عُمُومٌ مَجَازٌ':Added, #1: 1	عُمُومَ الْمَجَازِ
u'عُمُومٌ مَجِيءٌ':Added, #1: 1	عُمُومُ الْمَجَازِ
u'عُمُومٌ مَحَالٌّ':Added, #1: 1	عُمُومِ الْمَجِيءِ
u'عُمُومٌ مَحَالُّ':Added, #1: 1	عُمُومِ الْمَحَالِّ
u'عُمُومٌ مَدْلُولٌ':Added, #1: 1	عُمُومِ الْمَحَالِّ
u'عُمُومٌ مراد':Added, #1: 1	عُمُومُ الْمَدْلُولِ
u'عُمُومٌ مُرَادٌ':Added, #1: 1	عُمُومِ الْمُرَادِ
u'عُمُومٌ مَسٌّ':Added, #1: 1	عُمُومِ الْمُرَادِ
u'عُمُومٌ مَسْأَلَةٌ':Added, #1: 1	عُمُومِ الْمَسِّ
u'عُمُومٌ مُسَاوَاةٌ':Added, #1: 1	عُمُومِ الْمَسْأَلَةِ
u'عُمُومٌ مَسْحٌ':Added, #1: 1	عُمُومِ الْمُسَاوَاةِ
u'عُمُومٌ مَسْحٌ':Added, #1: 1	عُمُومِ الْمَسْحِ
u'عُمُومٌ مُشْتَرَكٌ':Added, #1: 1	عُمُومِ مَسْحِ
u'عُمُومٌ مُشْتَرَكٌ':Added, #2: 2	عُمُومَ الْمُشْتَرَكِ
u'عُمُومٌ مُشْتَرَكٌ':Added, #3: 3	عُمُومُ الْمُشْتَرَكِ
u'عُمُومٌ مَصَالِحُ':Added, #8: 8	عُمُومِ الْمُشْتَرَكِ
u'عُمُومٌ مَصَالِحُ':Added, #3: 3	عُمُومِ الْمَصَالِحِ
u'عُمُومٌ مَصْدَرٌ':Added, #3: 3	عُمُومِ مَصَالِحِ
u'عُمُومٌ مَصْدَرٌ':Added, #1: 1	عُمُومِ الْمَصْدَرِ
u'عُمُومٌ مَصْلَحَةٌ':Added, #2: 2	عُمُومَ الْمَصْدَرِ
u'عُمُومٌ مُضَاعَفٌ':Added, #1: 1	عُمُومِ الْمَصْلَحَةِ
u'عُمُومٌ مُضَاعَفَةٌ':Added, #1: 1	عُمُومَ الْمُضَاعَفَةِ
u'عُمُومٌ مَضْمُونٌ':Added, #1: 1	عُمُومَ الْمُضَاعَفَةِ
u'عُمُومٌ مُطَلَّقٌ':Added, #1: 1	عُمُومِ مَضْمُونِ
u'عُمُومٌ مُطْلَقٌ':Added, #1: 1	عُمُومُ الْمُطَلَّقَاتِ
u'عُمُومٌ مُطْلَقٌ':Added, #1: 1	عُمُومُ مُطْلَقٍ
u'عُمُومٌ مَعْطُوف':Added, #2: 2	عُمُومِ الْمُطْلَقِ
u'عُمُومٌ مَعْطُوف':Added, #1: 1	عُمُومِ الْمَعْطُوفِ
u'عُمُومٌ مَعْطُوف':Added, #2: 2	عُمُومَ الْمَعْطُوفِ
u'عُمُومٌ مَفْعُولٌ':Added, #5: 5	عُمُومُ الْمَعْطُوفِ
u'عُمُومٌ مَفْعُولٌ':Added, #1: 1	عُمُومَ الْمَفْعُولِ
u'عُمُومٌ مَفْعُولٌ':Added, #1: 1	عُمُومُ الْمَفْعُولِ
u'عُمُومٌ مَفْهُومٌ':Added, #1: 1	عُمُومِ الْمَفْعُولِ
u'عُمُومٌ مَفْهُومٌ':Added, #3: 3	عُمُومِ مَفْهُومِ
u'عُمُومٌ مُقَدَّرٌ':Added, #4: 4	عُمُومِ الْمَفْهُومِ
u'عُمُومٌ مَقْرُوءٌ':Added, #1: 1	عُمُومِ الْمُقَدَّرِ
u'عُمُومٌ مَمْلُوك':Added, #1: 1	عُمُومَ الْمَقْرُوءِ
u'عُمُومٌ مَمْلُوكِيّ':Added, #1: 1	عُمُومِ مَمْلُوكِيَّةِ
u'عُمُومٌ مَنَافِعُ':Added, #1: 1	عُمُومِ مَمْلُوكِيَّةِ
u'عُمُومٌ مَنْطُوقٌ':Added, #1: 1	عُمُومَ الْمَنَافِعِ
u'عُمُومٌ مَنْعٌ':Added, #1: 1	عُمُومُ مَنْطُوقِ
u'عُمُومٌ مَنْعٌ':Added, #1: 1	عُمُومَ الْمَنْعِ
u'عُمُومٌ مَنْفَعَةٌ':Added, #1: 1	عُمُومِ مَنْعِ
u'عُمُومٌ مُنَكَّرٌ':Added, #1: 1	عُمُومِ مَنْفَعَةِ
u'عُمُومٌ مَوْصُوفٌ':Added, #1: 1	عُمُومَ الْمُنَكَّرِ
u'عُمُومٌ مَوْضُوعٌ':Added, #1: 1	عُمُومِ الْمَوْصُوفِ
u'عُمُومٌ مَيْتٌ':Added, #1: 1	عُمُومِ مَوْضُوعِ
u'عُمُومٌ مَيْتَةٌ':Added, #1: 1	عُمُومِ الْمَيْتَةِ
u'عُمُومٌ نَازِلٌ':Added, #1: 1	عُمُومِ الْمَيْتَةِ
u'عُمُومٌ نَازِلَةٌ':Added, #1: 1	عُمُومِ النَّازِلَةِ
u'عُمُومٌ نَاسٌ':Added, #1: 1	عُمُومِ النَّازِلَةِ
u'عُمُومٌ نَاسٌ':Added, #13: 13	عُمُومِ النَّاسِ
u'عُمُومٌ نُبُوَّةٌ':Added, #2: 2	عُمُومُ النَّاسِ
u'عُمُومٌ نَجَاسَةٌ':Added, #1: 1	عُمُومِ النُّبُوَّاتِ
u'عُمُومٌ نَحْوٌ':Added, #1: 1	عُمُومُ النَّجَاسَةِ
u'عُمُومٌ نَحْوٌ':Added, #1: 1	عُمُومَ نَحْوِ
u'عُمُومٌ نَصٌّ':Added, #1: 1	عُمُومِ نَحْوِ
u'عُمُومٌ نَصٌّ':Added, #1: 1	عُمُومُ النَّصِّ
u'عُمُومٌ نَصٌّ':Added, #1: 1	عُمُومَ نَصٍّ
u'عُمُومٌ نَصٌّ':Added, #1: 1	عُمُومِ نَصِّ
u'عُمُومٌ نَظَرٌ':Added, #2: 2	عُمُومِ النَّصِّ
u'عُمُومٌ نَظَرٌ':Added, #1: 1	عُمُومُ نَظَرِهِ
u'عُمُومٌ نَظَرٌ':Added, #1: 1	عُمُومِ نَظَرِهِ
u'عُمُومٌ نَظَرٌ':Added, #2: 2	عُمُومُ النَّظَرِ
u'عُمُومٌ نَظَرٌ':Added, #5: 5	عُمُومَ النَّظَرِ
u'عُمُومٌ نَفْسِيٌّ':Added, #5: 5	عُمُومِ النَّظَرِ
u'عُمُومٌ نَفْعٌ':Added, #1: 1	عُمُومَ النَّفْسِيِّ
u'عُمُومٌ نَفْعٌ':Added, #1: 1	عُمُومُ النَّفْعِ
u'عُمُومٌ نَفْيٌ':Added, #3: 3	عُمُومِ النَّفْعِ
u'عُمُومٌ نَفْيٌ':Added, #1: 1	عُمُومُ نَفْيِ
u'عُمُومٌ نَفْيٌ':Added, #2: 2	عُمُومَ النَّفْيِ
u'عُمُومٌ نَفْيٌ':Added, #2: 2	عُمُومُ النَّفْيِ
u'عُمُومٌ نَفْيٌ':Added, #3: 3	عُمُومِ النَّفْيِ
u'عُمُومٌ نَفِيرٌ':Added, #7: 7	عُمُومِ نَفْيِ
u'عُمُومٌ نَكِرٌ':Added, #1: 1	عُمُومِ النَّفِيرِ
u'عُمُومٌ نَكِرٌ':Added, #2: 2	عُمُومَ النَّكِرَةِ
u'عُمُومٌ نكرة':Added, #3: 3	عُمُومِ النَّكِرَةِ
u'عُمُومٌ نَكِرَةٌ':Added, #2: 2	عُمُومَ النَّكِرَةِ
u'عُمُومٌ نكرة':Added, #2: 2	عُمُومَ النَّكِرَةِ
u'عُمُومٌ نَكِرَةٌ':Added, #3: 3	عُمُومِ النَّكِرَةِ
u'عُمُومٌ نَهْيٌ':Added, #3: 3	عُمُومِ النَّكِرَةِ
u'عُمُومٌ نَهْيٌ':Added, #1: 1	عُمُومُ النَّهْيِ
u'عُمُومٌ نِيَّةٌ':Added, #3: 3	عُمُومِ النَّهْيِ
u'عُمُومٌ واحد':Added, #1: 1	عُمُومِ النِّيَّةِ
u'عُمُومٌ وَاحِدٌ':Added, #1: 1	عُمُومٍ وَاحِدٍ
u'عُمُومٌ وَجْهٌ':Added, #1: 1	عُمُومٍ وَاحِدٍ
u'عُمُومٌ وُجُوبٌ':Added, #1: 1	عُمُومِ الْوَجْهِ
u'عُمُومٌ وُجُوبٌ':Added, #1: 1	عُمُومِ الْوُجُوبِ
u'عُمُومٌ وُجُوبٌ':Added, #1: 1	عُمُومَ وُجُوبِ
u'عُمُومٌ وُجُودٌ':Added, #1: 1	عُمُومُ وُجُوبِ
u'عُمُومٌ وُرُودٌ':Added, #1: 1	عُمُومِ وُجُودِهِ
u'عُمُومٌ وَصْفٌ':Added, #1: 1	عُمُومِ وُرُودِ
u'عُمُومٌ وَقْتٌ':Added, #1: 1	عُمُومِ الْوَصْفِ
u'عُمُومٌ وَقْتٌ':Added, #1: 1	عُمُومَ الْوَقْتِ
u'عُمُومٌ وَقْتٌ':Added, #1: 1	عُمُومِ وَقْتِ
u'عُمُومٌ وُقُوفٌ':Added, #4: 4	عُمُومِ الْوَقْتِ
u'عُمُومٌ وِلاَيَةٌ':Added, #1: 1	عُمُومِ الْوُقُوفِ
u'عُمُومٌ وِلاَيَةٌ':Added, #2: 2	عُمُومِ الْوِلَايَةِ
u'عُمُومٌ يَدٌ':Added, #5: 5	عُمُومِ وِلَايَتِهِ
u'عَمِيَ أَبْكَم':Predicate, #1: 1	عُمُومُ الْيَدِ
u'عَمِيَ أخرَس':Predicate, #1: 1	أَعْمَى أَبْكَمَ
u'عَمِيَ أَصَمّ':Predicate, #2: 2	أَعْمَى أَخْرَسَ
u'عَمِيَ بَصَرٌ':Subject, #1: 1	أَعْمَى أَصَمَّ
u'عَمِيَ تَخَلُّفٌ':Predicate, #1: 1	عَمِيَ الْبَصَرُ
u'عَمِيَ حارِثٌ':Subject, #1: 1	أَعْمَى التَّخَلُّفَ
u'عَمِيَ حَسَنٌ':Subject, #1: 1	عَمِيَ الْحَارِثُ
u'عَمِيَ حَكَمٌ':Predicate, #1: 1	عَمِيَ الْحَسَنُ
u'عَمِيَ حَكَمٌ':Subject, #1: 1	عَمِيَ حَكَمَ
u'عَمِيَ حِمَارٌ':Subject, #1: 1	عَمِيَ الْحَكَمُ
u'عَمِيَ دونٌ':Predicate, #1: 1	عَمِيَ الْحِمَارُ
u'عَمِيَ ذكر':Predicate, #1: 1	أَعْمَى دُونَ
u'عَمِيَ ظَبْيٌ':Subject, #1: 1	أَعْمَى ذُكِرَ
u'عَمِيَ عَبْدٌ':Subject, #1: 1	عَمِيَ الظّبْيُ
u'عَمِيَ عند':Predicate, #1: 1	عَمِيَ الْعَبْدُ
u'عَمِيَ قَالٌ':Predicate, #5: 5	أَعْمَى عِنْدَ
u'عَمَى مَصْرِفٌ':Subject, #1: 1	أَعْمَى قَالَ
u'عَمِيَ نَبِيٌّ':Predicate, #1: 1	عَمَى مَصْرِفُهُ
u'عَمِيَ وَجَبٌ':Predicate, #1: 1	أَعْمَى النَّبِيَّ
u'عَمِيَ وَجَبٌ':Predicate, #1: 1	أَعْمَى وَجَبَ
u'عَمِيَ وَقْتٌ':Predicate, #1: 1	عَمِيَ وَجَبَ
u'عَمِيَ يَوْمٌ':Predicate, #1: 1	أَعْمَى وَقْتَ
u'عَنَاءٌ كَدٌّ':Added, #1: 1	أَعْمَى يَوْمَ
u'عَنَا اِبْنٌ':Subject, #1: 1	عَنَاءِ كَدِّهِ
u'عِنان بَغْلٌ':Added, #1: 1	عَنَا ابْنُ
u'عِنَانٌ بَغْلٌ':Added, #1: 1	عِنَانِ بَغْلَةِ
u'عِنان دَابَّةٌ':Added, #1: 1	عِنَانِ بَغْلَةِ
u'عِنَانٌ دَابَّةٌ':Added, #1: 1	عِنَانِ الدَّابَّةِ
u'عِنان عِنَايَةٌ':Added, #1: 1	عِنَانِ الدَّابَّةِ
u'عِنَانٌ عِنَايَةٌ':Added, #1: 1	عِنَانَ الْعِنَايَةِ
u'عِنان فَرَسٌ':Added, #1: 1	عِنَانَ الْعِنَايَةِ
u'عِنَانٌ فَرَسٌ':Added, #1: 1	عِنَانِ الْفَرَسِ
u'عِنان فَرَسٌ':Added, #1: 1	عِنَانِ الْفَرَسِ
u'عِنَانٌ فَرَسٌ':Added, #1: 1	عِنَانَ فَرَسِهِ
u'عِنان فِكْرٌ':Added, #1: 1	عِنَانَ فَرَسِهِ
u'عِنَانٌ فِكْرٌ':Added, #1: 1	عِنَانِ الْفِكْرِ
u'عِنَايَةٌ طلب':Added, #1: 1	عِنَانِ الْفِكْرِ
u'عِنَايَةٌ طَلَبٌ':Added, #1: 1	عِنَايَةَ الطَّلَبِ
u'عَنْزٌ ثَنِيَّةٌ':Added, #1: 1	عِنَايَةَ الطَّلَبِ
u'عَنْزٌ ثَنِيَّةٌ':Added, #1: 1	عَنْزٍ ثَنِيَّةٍ
u'عَنَّ شَيْءٌ':Subject, #1: 1	عَنْزِ ثَنِيَّةِ
u'عَنْعَنَةٌ اِبْنٌ':Added, #2: 2	عَنَّ الشَّيْءُ
u'عَنْعَنَةٌ مُحَمَّدٌ':Added, #1: 1	عَنْعَنَةُ ابْنِ
u'عَنَّفَ دَابَّةٌ':Predicate, #1: 1	عَنْعَنَةِ مُحَمَّدِ
u'عنف سِياقٌ':Added, #1: 1	عَنَّفَ الدَّابَّةَ
u'عُنْفٌ سِياقٌ':Added, #1: 1	عُنْفَ السّيَاقِ
u'عَنَّفَ ولد':Predicate, #1: 1	عُنْفَ السّيَاقِ
u'عَنَّفَ وَلَدٌ':Predicate, #1: 1	عَنَّفَ الْوَلَدَ
u'عَنَّ مُرَجِّحٌ':Subject, #1: 1	عَنَّفَ الْوَلَدَ
u'عَنَّ نَصْرٌ':Subject, #1: 1	عَنَّ مُرَجِّحٌ
u'عَنَى اِبْنٌ':Predicate, #1: 1	عَنَّ نَصْرُهُ
u'عَنَى اِسْتِطاعَةٌ':Predicate, #1: 1	عَنَى ابْنَ
u'عَنِيَ اِسْمٌ':Predicate, #1: 1	عَنَى اسْتِطَاعَةَ
u'عَنِيَ أكل':Predicate, #1: 1	عَنِيَ اسْمَ
u'عَنِيَ أَكْلٌ':Predicate, #1: 1	عَنِيَ أَكْلَ
u'عَنَى أكل':Predicate, #1: 1	عَنِيَ أَكْلَ
u'عَنَى أَكْلٌ':Predicate, #2: 2	عَنَى أَكْلَ
u'عَنَى إمَامٌ':Subject, #2: 2	عَنَى أَكْلَ
u'عَنَى أهْلٌ':Predicate, #1: 1	عَنَى الْإِمَامُ
u'عَنَى أَوَّلُ':Predicate, #1: 1	عَنَى أَهْلَ
u'عَنَى بَائِنٌ':Predicate, #3: 3	عَنَى الْأَوَّلَ
u'عَنَى تَجْرِبَةٌ':Predicate, #2: 2	عَنَى الْبَائِنَ
u'عَنَى تَخْيِيرٌ':Predicate, #1: 1	عَنَى تَجْرِبَةَ
u'عَنَى تَعْلِيقٌ':Predicate, #1: 1	عَنَى التَّخْيِيرَ
u'عَنَى تَقْيِيد':Predicate, #2: 2	عَنَى التَّعْلِيقَ
u'عَنَى تَكْرارٌ':Predicate, #1: 1	عَنَى التَّقْيِيدَ
u'عَنَى ثَانِي':Predicate, #1: 1	عَنَى التَّكْرَارَ
u'عَنَى جَارِحٌ':Predicate, #1: 1	عَنَى الثَّانِيَ
u'عَنَى جَارِحَةٌ':Predicate, #1: 1	عَنَى الْجَارِحَةَ
u'عَنَى جماع':Predicate, #1: 1	عَنَى الْجَارِحَةَ
u'عَنَى جِمَاعٌ':Predicate, #1: 1	عَنَى الْجِمَاعَ
u'عَنَى جَوَابٌ':Predicate, #1: 1	عَنَى الْجِمَاعَ
u'عَنَى حَقِيقٌ':Predicate, #1: 1	عَنَى الْجَوَابَ
u'عَنَى حَقِيقَةٌ':Predicate, #1: 1	عَنَى حَقِيقَةَ
u'عَنَى دفع':Predicate, #1: 1	عَنَى حَقِيقَةَ
u'عَنَى دَفْعٌ':Predicate, #1: 1	عَنَى الدَّفْعَ
u'عَنَى رِجَالٌ':Predicate, #1: 1	عَنَى الدَّفْعَ
u'عَنَى رَجْعِيٌّ':Predicate, #1: 1	عَنَى الرِّجَالَ
u'عَنَى رَدٌّ':Predicate, #3: 3	عَنَى الرَّجْعِيَّ
u'عَنَى رَسُولٌ':Subject, #1: 1	عَنَى رَدَّ
u'عَنِيَ رَهْنٌ':Predicate, #3: 3	عَنَى رَسُولُ
u'عَنَى رِوايَةٌ':Predicate, #1: 1	عَنِيَ الرَّهْنَ
u'عَنِيَ زَوْجٌ':Subject, #1: 1	عَنَى الرِّوَايَةَ
u'عَنَى زَوْجٌ':Subject, #1: 1	عَنِيَ الزَّوْجُ
u'عَنَى سَطِيح':Subject, #2: 2	عَنَى الزَّوْجُ
u'عَنَى صَغِيرٌ':Predicate, #3: 3	عَنَى سَطِيحٌ
u'عَنَى صَلاَةٌ':Predicate, #1: 1	عَنَى الصَّغِيرَ
u'عَنِيَ ظَنٌّ':Predicate, #1: 1	عَنَى صَلَاةَ
u'عَنَى عين':Predicate, #1: 1	عَنِيَ ظَنَّ
u'عَنَى عَيْنٌ':Predicate, #1: 1	عَنَى عَيْنَ
u'عَنَى عَيْن':Predicate, #1: 1	عَنَى عَيْنَ
u'عَنَى فلان':Subject, #1: 1	عَنَى عَيْنَ
u'عَنَى قَبِيلَةٌ':Predicate, #1: 1	عَنَى التِّرْمِذِيُّ
u'عَنَى كَعْبٌ':Subject, #1: 1	عَنَى الْقَبِيلَةَ
u'عَنِيَ مَاءٌ':Predicate, #1: 1	عَنَى كَعْبٌ
u'عَنَى مَاءٌ':Predicate, #1: 1	عَنِيَ الْمَاءَ
u'عَنَى نَبِيٌّ':Subject, #1: 1	عَنَى الْمَاءَ
u'عَنِيَ نهار':Predicate, #2: 2	عَنَى النَّبِيُّ
u'عَنِيَ نَهَارٌ':Predicate, #1: 1	عَنِيَ النَّهَارَ
u'عَنَى واحد':Predicate, #1: 1	عَنِيَ النَّهَارَ
u'عَنَى وَاحِدٌ':Predicate, #1: 1	عَنَى وَاحِدَةً
u'عَنِيَ يَمِينٌ':Predicate, #1: 1	عَنَى وَاحِدَةً
u'عَهْدٌ اِبْنٌ':Added, #2: 2	عَنِيَ الْيَمِينَ
u'عَهِدَ إتْمَامٌ':Predicate, #6: 6	عَهْدِ ابْنِ
u'عَهْدٌ أحَدٌ':Added, #1: 1	عَهِدَ إتْمَامَ
u'عَهْدٌ إِسْلامٌ':Added, #1: 1	عَهْدِ أَحَدٍ
u'عَهْدٌ إِسْلامٌ':Added, #1: 1	عَهْدُ الْإِسْلَامِ
u'عَهِدَ إمَامٌ':Subject, #3: 3	عَهْدِ الْإِسْلَامِ
u'عَهْدٌ إمَامٌ':Added, #3: 3	عَهِدَ الْإِمَامُ
u'عَهْدٌ بُراقٌ':Added, #2: 2	عَهْدِ إِمَامِ
u'عَهْدٌ بَعْضٌ':Added, #1: 1	عَهْدِ الْبُرَاقِ
u'عَهْدٌ بِنَاءٌ':Added, #1: 1	عَهْدِ بَعْضِ
u'عَهْدٌ تَكْليفٌ':Added, #1: 1	عَهْدُ الْبِنَاءِ
u'عَهْدٌ جَاهِلِيٌّ':Added, #1: 1	عَهْدِ التَّكْلِيفِ
u'عَهْدٌ جَاهِلِيَّةٌ':Added, #1: 1	عَهْدِ الْجَاهِلِيَّةِ
u'عَهْدٌ جَمِيع':Added, #1: 1	عَهْدِ الْجَاهِلِيَّةِ
u'عَهْدٌ جَمِيع':Added, #1: 1	عَهْدَ الْجَمِيعِ
u'عَهْدٌ حضرة':Added, #1: 1	عَهْدُ الْجَمِيعِ
u'عَهْدٌ حَضْرَةٌ':Added, #1: 1	عَهْدِ الْحَضْرَةِ
u'عَهْدٌ خُلَفَاءُ':Added, #1: 1	عَهْدِ الْحَضْرَةِ
u'عَهِدَ خَلِيفَةٌ':Subject, #3: 3	عَهْدِ الْخُلَفَاءِ
u'عَهْدٌ ذُرِّيَّةٌ':Added, #3: 3	عَهِدَ الْخَلِيفَةُ
u'عَهْدٌ ذِمَّةٌ':Added, #1: 1	عَهْدُ ذُرِّيَّتِهِ
u'عَهْدٌ ذِمِّيٌّ':Added, #1: 1	عَهْدَ ذِمَّةٍ
u'عَهْدٌ ذِمِّيٌّ':Added, #1: 1	عَهْدُ ذِمِّيٍّ
u'عَهْدٌ ذِمِّيٌّ':Added, #2: 2	عَهْدُ الذِّمِّيِّ
u'عَهْدٌ رَدٌّ':Added, #2: 2	عَهْدِ الذِّمِّيِّ
u'عَهِدَ رَسُولٌ':Subject, #1: 1	عَهْدِ الرَّدِّ
u'عَهْدٌ رَسُولٌ':Added, #4: 4	عَهِدَ رَسُولُ
u'عَهْدٌ رَسُولٌ':Added, #1: 1	عَهْدُ الرّسُولِ
u'عَهْدٌ رَسُولٌ':Added, #1: 1	عَهْد رَسُولِ
u'عَهْدٌ رَسُولٌ':Added, #1: 1	عَهْدِ رَسُوُلِ
u'عَهْدٌ رَسُولٌ':Added, #2: 2	عَهْدُ رَسُولِ
u'عَهْدٌ رَسُولٌ':Added, #3: 3	عَهْدِ الرَّسُولِ
u'عَهْدٌ رَسُولٌ':Added, #3: 3	عَهْدَ رَسُولِ
u'عَهْدٌ زَمَنٌ':Added, #517: 517	عَهْدِ رَسُولِ
u'عَهِدَ سَفَّاحٌ':Subject, #1: 1	عَهْدِ زَمَنِ
u'عَهْدٌ سَلَفٌ':Added, #1: 1	عَهِدَ السَّفَّاحُ
u'عَهْدٌ شافِعِيّ':Added, #2: 2	عَهْدِ السَّلَفِ
u'عَهْدٌ شَبابٌ':Added, #1: 1	عَهْدِ الشَّافِعِيِّ
u'عَهْدٌ شَبَابٌ':Added, #1: 1	عَهْدِ الشّبَابِ
u'عَهْدٌ صَحَابَةٌ':Added, #1: 1	عَهْدِ الشّبَابِ
u'عَهْدٌ صَحَابَةٌ':Added, #2: 2	عَهْدَ الصَّحَابَةِ
u'عَهْدٌ عَادٌ':Added, #7: 7	عَهْدِ الصَّحَابَةِ
u'عَهْدٌ عَادٌ':Added, #1: 1	عَهْدِ عَادِ
u'عَهِدَ عتبة':Subject, #2: 2	عَهْدِ عَادٍ
u'عَهْدٌ عَقْدٌ':Added, #1: 1	عَهِدَ عُتْبَةُ
u'عَهْدٌ عَلِيٌّ':Added, #1: 1	عَهْدِ عَقْدِ
u'عَهْدٌ عَلِيٌّ':Added, #1: 1	عَهْدِ عَلِيٍّ
u'عَهِدَ عُمَرٌ':Subject, #1: 1	عَهْدِ عَلِيِّ
u'عَهْدٌ عَهْدٌ':Added, #1: 1	عَهِدَ عُمَرُ
u'عَهْدٌ غير':Added, #1: 1	عَهْدِ عَهْدِ
u'عَهْدٌ غَيْرٌ':Added, #1: 1	عَهْدِ غَيْرِهِ
u'عَهْدٌ فَاعِلٌ':Added, #1: 1	عَهْدِ غَيْرِهِ
u'عَهْدٌ فساد':Added, #1: 1	عَهْدُ فَاعِلِهِ
u'عَهْدٌ فَسَادٌ':Added, #1: 1	عَهْدِ الْفَسَادِ
u'عَهِدَ فُلاَنٌ':Subject, #1: 1	عَهْدِ الْفَسَادِ
u'عَهْدٌ فلان':Added, #1: 1	عَهِدَ فُلَانٌ
u'عَهْدٌ فُلاَنٌ':Added, #1: 1	عَهْدِ الشَّافِعِيِّ
u'عَهْدٌ قُرَيْشٌ':Added, #1: 1	عَهْدُ فُلَانٍ
u'عَهْدٌ مُتَوَكِّلٌ':Added, #7: 7	عَهْدِ قُرَيْشٍ
u'عَهْدٌ مُحَمَّدٌ':Added, #1: 1	عَهْدِ الْمُتَوَكِّلِ
u'عَهْدٌ مُحَمَّدٌ':Added, #1: 1	عَهْدِ مُحَمّدٍ
u'عَهْدٌ نَائِبٌ':Added, #1: 1	عَهْدِ مُحَمَّدٍ
u'عَهْدٌ نَبِيٌّ':Added, #1: 1	عَهْدِ نَائِبِهِ
u'عَهْدٌ نَبِيٌّ':Added, #1: 1	عَهْدَ النَّبِيِّ
u'عَهْدٌ نِساءٌ':Added, #41: 41	عَهْدِ النَّبِيِّ
u'عَهْدٌ نِساءٌ':Added, #1: 1	عَهْدُ النِّسَاءِ
u'عَهْدٌ هُودٌ':Added, #1: 1	عَهْدُ نِسَاءٍ
u'عَهْدٌ وصال':Added, #1: 1	عَهْدِ هُودٍ
u'عَهْدٌ وِصَالٌ':Added, #1: 1	عَهْدَ الْوِصَالِ
u'عُهُودٌ شَرِيعَةٌ':Added, #1: 1	عَهْدَ الْوِصَالِ
u'عُهُودٌ عُمَّالٌ':Added, #1: 1	عُهُودِ الشَّرِيعَةِ
u'عُهُودٌ نَاسٌ':Added, #1: 1	عُهُودِ الْعُمَّالِ
u'عُوَاءٌ أهْلٌ':Added, #1: 1	عُهُودُ النَّاسِ
u'عَوْدٌ أرْضٌ':Added, #3: 3	عُوَاءُ أَهْلِ
u'عَوْدٌ اِسْمٌ':Added, #1: 1	عَوْدِ الْأَرْضِ
u'عَوْدٌ أسْوَد':Added, #1: 1	عَوْدِ اسْمِ
u'عَوْدٌ إمَامٌ':Added, #2: 2	عَوْدِ الْأَسْوَدِ
u'عَوْدٌ إمَامٌ':Added, #1: 1	عَوْدِ الْإِمَامِ
u'عَوْدٌ إمَامٌ':Added, #1: 1	عَوْدِ إمَامِهِ
u'عَوْدٌ أَوْجُهٌ':Added, #4: 4	عَوْدَ الْإِمَامِ
u'عَوْدٌ بَرَكَةٌ':Added, #1: 1	عَوْدُ الْأَوْجُهِ
u'عَوْدٌ بَصَرٌ':Added, #1: 1	عَوْدُ بَرَكَتِهِ
u'عَوْدٌ بَكارَةٌ':Added, #3: 3	عَوْدِ الْبَصَرِ
u'عَوْدَةٌ أهْلٌ':Added, #4: 4	عَوْدِ الْبَكَارَةِ
u'عَوْدَةٌ سُؤَالٌ':Added, #1: 1	عَوْدَةِ أَهْلِهِ
u'عَوْدٌ تَخْصِيصٌ':Added, #1: 1	عَوْدَةَ السُّؤَالِ
u'عَوْدٌ تَخْصِيصٌ':Added, #1: 1	عَوْدَ التَّخْصِيصِ
u'عَوْدٌ تَرْتِيبٌ':Added, #1: 1	عَوْدُ التَّخْصِيصِ
u'عَوْدٌ تَغَيُّرٌ':Added, #1: 1	عَوْدُ التَّرْتِيبِ
u'عَوْدٌ تَمْييزٌ':Added, #1: 1	عَوْدُ تَغَيُّرِهِ
u'عَوْدٌ ثَمَرَةٌ':Added, #1: 1	عَوْدُ التَّمْيِيزِ
u'عَوْدٌ ثَمَنٌ':Added, #1: 1	عَوْدُ ثَمَرَةِ
u'عَوْدٌ جلد':Added, #1: 1	عَوْدَ الثَّمَنِ
u'عَوْدٌ جِلْدٌ':Added, #1: 1	عَوْدِ الْجِلْدِ
u'عَوْدٌ جَمَالٌ':Added, #1: 1	عَوْدِ الْجِلْدِ
u'عَوْدٌ جَوَابٌ':Added, #1: 1	عَوْدُ الْجَمَالِ
u'عَوْدٌ حَرْفٌ':Added, #1: 1	عَوْدِ جَوَابِهِ
u'عَوْدٌ حُرْمَةٌ':Added, #1: 1	عَوْدِ حَرْفٍ
u'عَوْدٌ حَضَانَةٌ':Added, #1: 1	عَوْدُ الْحُرْمَةِ
u'عَوْدٌ حَقٌّ':Added, #1: 1	عَوْدِ الْحَضَانَةِ
u'عَوْدٌ حَقٌّ':Added, #2: 2	عَوْدِ الْحَقِّ
u'عَوْدٌ حُكْمٌ':Added, #2: 2	عَوْدُ حَقِّ
u'عَوْدٌ حُكْمٌ':Added, #1: 1	عَوْدُ الْحُكْمِ
u'عَوْدٌ حِنْثٌ':Added, #1: 1	عَوْدِ الْحُكْمِ
u'عَوْدٌ حِنْثٌ':Added, #11: 11	عَوْدِ الْحِنْثِ
u'عَوْدٌ حِنْثٌ':Added, #1: 1	عَوْدَ الْحِنْثِ
u'عَوْدٌ حَيَاةٌ':Added, #2: 2	عَوْدُ الْحِنْثِ
u'عَوْدٌ خَمْرٌ':Added, #2: 2	عَوْدِ الْحَيَاةِ
u'عَوْدٌ خيار':Added, #1: 1	عَوْدِ الْخَمْرِ
u'عَوْدٌ خِيَارٌ':Added, #1: 1	عَوْدِ الْخِيَارِ
u'عَوْدٌ دَارٌ':Added, #1: 1	عَوْدِ الْخِيَارِ
u'عَوْدٌ دَلْوٌ':Added, #1: 1	عَوْدِ الدَّارِ
u'عَوْدٌ دَمٌ':Added, #1: 1	عَوْدَ الدَّلْوِ
u'عَوْدٌ دَمٌ':Added, #2: 2	عَوْدَ الدَّمِ
u'عَوْدٌ دَمٌ':Added, #2: 2	عَوْدُ الدَّمِ
u'عَوْدٌ دَيْنٌ':Added, #4: 4	عَوْدِ الدَّمِ
u'عَوْدٌ رَاكِعٌ':Added, #2: 2	عَوْدُ الدَّيْنِ
u'عَوْدٌ رَشاشٌ':Added, #1: 1	عَوْدِ رَاكِعٍ
u'عَوْدٌ رَشاشٌ':Added, #1: 1	عَوْدُ الرَّشَاشِ
u'عَوْدٌ زائِلٌ':Added, #1: 1	عَوْدُ رَشَاشٍ
u'عَوْدٌ سَاقِطٌ':Added, #1: 1	عَوْدَ الزَّائِلِ
u'عَوْدٌ سَلَمٌ':Added, #3: 3	عَوْدِ السَّاقِطِ
u'عَوْدٌ سَمْنٌ':Added, #1: 1	عَوْدِ السَّلَمِ
u'عَوْدٌ سِنٌّ':Added, #1: 1	عَوْدِ السَّمْنِ
u'عَوْدٌ سَيِّدٌ':Added, #1: 1	عَوْدِ السِّنِّ
u'عَوْدٌ شَرْطٌ':Added, #2: 2	عَوْدِ السَّيِّدِ
u'عَوْدٌ شَرْطٌ':Added, #1: 1	عَوْدَ الشَّرْطِ
u'عَوْدٌ شَطْرٌ':Added, #1: 1	عَوْدُ الشَّرْطِ
u'عَوْدٌ شَهَادَةٌ':Added, #2: 2	عَوْدِ الشَّطْرِ
u'عَوْدٌ شَيْءٌ':Added, #1: 1	عَوْدُ الشَّهَادَاتِ
u'عَوْدٌ صداق':Added, #1: 1	عَوْدِ شَيْءٍ
u'عَوْدٌ صَدَاقٌ':Added, #1: 1	عَوْدَ الصَّدَاقِ
u'عَوْدٌ صِفَةٌ':Added, #1: 1	عَوْدَ الصَّدَاقِ
u'عَوْدٌ صنعة':Added, #5: 5	عَوْدِ الصِّفَةِ
u'عَوْدٌ صَنْعَةٌ':Added, #1: 1	عَوْدَ الصَّنْعَةِ
u'عَوْدٌ صِنْفٌ':Added, #1: 1	عَوْدَ الصَّنْعَةِ
u'عَوْدٌ ضَرَرٌ':Added, #1: 1	عَوْدُ الصِّنْفِ
u'عَوْدٌ ضَمَانٌ':Added, #1: 1	عَوْدِ ضَرَرٍ
u'عَوْدٌ ضَمَائِرُ':Added, #1: 1	عَوْدُ الضَّمَانِ
u'عَوْدٌ ضَمِيرٌ':Added, #1: 1	عَوْدِ الضَّمَائِرِ
u'عَوْدٌ ضَمِيرٌ':Added, #1: 1	عَوْدِ الضّمِيرِ
u'عَوْدٌ ضَمِيرٌ':Added, #1: 1	عَوْدَ ضَمِيرٍ
u'عَوْدٌ ضَمِيرٌ':Added, #2: 2	عَوْدَ الضَّمِيرِ
u'عَوْدٌ ضَمِيرٌ':Added, #4: 4	عَوْدُ ضَمِيرِ
u'عَوْدٌ ضَمِيرٌ':Added, #9: 9	عَوْدُ الضَّمِيرِ
u'عَوْدٌ ضَوْءٌ':Added, #9: 9	عَوْدِ الضَّمِيرِ
u'عَوْدٌ طَهُور':Added, #1: 1	عَوْدِ الضَّوْءِ
u'عَوْدٌ طَهُور':Added, #1: 1	عَوْدُ الطَّهُورِيَّةِ
u'عَوْدٌ عَامِدٌ':Added, #1: 1	عَوْدِ الطَّهُورِيَّةِ
u'عَوْدٌ عَبْدٌ':Added, #1: 1	عَوْدَ الْعَامِدِ
u'عَوْدٌ عِدَّةٌ':Added, #2: 2	عَوْدِ الْعَبْدِ
u'عَوْدٌ عُذْرَةٌ':Added, #1: 1	عَوْدِ الْعِدَّةِ
u'عَوْدٌ عِمَارَةٌ':Added, #2: 2	عَوْدُ الْعُذْرَةِ
u'عَوْدٌ غَائِبٌ':Added, #1: 1	عَوْدِ الْعِمَارَةِ
u'عَوْدٌ غَلَّةٌ':Added, #1: 1	عَوْدِ الْغَائِبِ
u'عَوْدٌ غَلَّةٌ':Added, #1: 1	عَوْدَ الْغَلَّةِ
u'عَوْدٌ فساد':Added, #1: 1	عَوْدِ الْغَلَّةِ
u'عَوْدٌ فَسَادٌ':Added, #1: 1	عَوْدُ الْفَسَادِ
u'عَوْدٌ قدرة':Added, #1: 1	عَوْدُ الْفَسَادِ
u'عَوْدٌ قُدْرَةٌ':Added, #1: 1	عَوْدِ الْقُدْرَةِ
u'عَوْدٌ قِيمَةٌ':Added, #1: 1	عَوْدِ الْقُدْرَةِ
u'عَوْدٌ كَبِيرٌ':Added, #1: 1	عَوْدِ الْقِيمَةِ
u'عَوْدٌ كَسْبٌ':Added, #1: 1	عَوْدِ الْكَبِيرِ
u'عَوْدٌ كَفَاءةٌ':Added, #1: 1	عَوْدُ كَسْبِهِ
u'عَوْدٌ مَالٌ':Added, #1: 1	عَوْدَ كَفَاءَةٍ
u'عَوْدٌ مَالِيٌّ':Added, #1: 1	عَوْدَ مَالِهِ
u'عَوْدٌ مَبِيعٌ':Added, #1: 1	عَوْدَ الْمَالِيَّةِ
u'عَوْدٌ مُتَعَلِّقٌ':Added, #1: 1	عَوْدِ الْمَبِيعِ
u'عَوْدٌ مَحَلٌّ':Added, #1: 1	عَوْدِ الْمُتَعَلِّقَاتِ
u'عَوْدٌ مُدَرِّسٌ':Added, #1: 1	عَوْدِ الْمَحَلِّ
u'عَوْدٌ مَسِيخ':Added, #1: 1	عَوْدِ مُدَرِّسٍ
u'عَوْدٌ مَشِيئَةٌ':Added, #1: 1	عَوْدِ الْمَسِيخِ
u'عَوْدٌ مَصْلَحَةٌ':Added, #1: 1	عَوْدَ الْمَشِيئَةِ
u'عَوْدٌ مُطَالَبٌ':Added, #1: 1	عَوْدُ مَصْلَحَةٍ
u'عَوْدٌ مُطَالَبٌ':Added, #1: 1	عَوْدَ الْمُطَالَبَةِ
u'عَوْدٌ مُطَالَبَةٌ':Added, #2: 2	عَوْدُ الْمُطَالَبَةِ
u'عَوْدٌ مُطَالَبَةٌ':Added, #1: 1	عَوْدَ الْمُطَالَبَةِ
u'عَوْدٌ مَعْقُودٌ':Added, #2: 2	عَوْدُ الْمُطَالَبَةِ
u'عَوْدٌ مَغْصُوب':Added, #2: 2	عَوْدُ الْمَعْقُودِ
u'عَوْدٌ مِلْكٌ':Added, #1: 1	عَوْدِ الْمَغْصُوبِ
u'عَوْدٌ مِلْكٌ':Added, #1: 1	عَوْدِ مِلْكٍ
u'عَوْدٌ مَنْفَعَةٌ':Added, #2: 2	عَوْدِ مِلْكِ
u'عَوْدٌ نَاسٌ':Added, #1: 1	عَوْدُ مَنْفَعَتِهِ
u'عَوْدٌ نَجَاسَةٌ':Added, #1: 1	عَوْدَ النَّاسِ
u'عَوْدٌ نَجَاسَةٌ':Added, #1: 1	عَوْدَ النَّجَاسَةِ
u'عَوْدٌ نِصْفٌ':Added, #3: 3	عَوْدِ النَّجَاسَةِ
u'عَوْدٌ نِصْفٌ':Added, #1: 1	عَوْدُ النِّصْفِ
u'عَوْدٌ نَعْلٌ':Added, #2: 2	عَوْدِ النِّصْفِ
u'عَوْدٌ نَفْعٌ':Added, #1: 1	عَوْدِ النَّعْلِ
u'عَوْدٌ نَقْضٌ':Added, #1: 1	عَوْدِ النَّفْعِ
u'عَوْدٌ هَدِيٌّ':Added, #1: 1	عَوْدِ النَّقْضِ
u'عَوْدٌ هَدِيَّةٌ':Added, #1: 1	عَوْدِ الْهَدِيَّةِ
u'عَوْدٌ وَصْفٌ':Added, #1: 1	عَوْدِ الْهَدِيَّةِ
u'عَوْدٌ وَقْفٌ':Added, #1: 1	عَوْدِ وَصْفِ
u'عَوْدٌ وَقْفٌ':Added, #1: 1	عَوْدُ الْوَقْفِ
u'عَوْدٌ يَدٌ':Added, #2: 2	عَوْدِ الْوَقْفِ
u'عَوِرَ أقْرَع':Predicate, #1: 1	عَوْدَ الْيَدِ
u'عور عين':Added, #1: 1	أَعْوَرَ أَقْرَعَ
u'عور عَيْنٌ':Added, #1: 1	عَوَرُ الْعَيْنِ
u'عور عَيْن':Added, #1: 1	عَوَرُ الْعَيْنِ
u'عَوَرٌ عين':Added, #1: 1	عَوَرُ الْعَيْنِ
u'عَوَرٌ عَيْنٌ':Added, #1: 1	عَوَرُ الْعَيْنِ
u'عَوَرٌ عَيْن':Added, #1: 1	عَوَرُ الْعَيْنِ
u'عَوِزَ مثل':Predicate, #1: 1	عَوَرُ الْعَيْنِ
u'عَوِزَ مِثْلٌ':Predicate, #1: 1	أَعْوَزَ الْمِثْلَ
u'عَوِصَ كَلاَمٌ':Subject, #1: 1	أَعْوَزَ الْمِثْلَ
u'عِوَضٌ إجَارَةٌ':Added, #1: 1	عَوِصَ الْكَلَامُ
u'عِوَضٌ ألْفٌ':Added, #1: 1	عِوَضِ إجَارَةِ
u'عِوَضٌ أَلْفٌ':Added, #1: 1	عِوَضِ أَلْفٍ
u'عِوَضٌ ألف':Added, #1: 1	عِوَضِ أَلْفٍ
u'عِوَضٌ ألْفٌ':Added, #4: 4	عِوَضِ أَلْفِ
u'عِوَضٌ أَلْفٌ':Added, #4: 4	عِوَضِ أَلْفِ
u'عِوَضٌ إِنْشائِيٌّ':Added, #4: 4	عِوَضِ أَلْفِ
u'عِوَضٌ بَذْرٌ':Added, #1: 1	عِوَضٍ إنْشَائِيٍّ
u'عِوَضٌ بِنَاءٌ':Added, #1: 1	عِوَضُ الْبَذْرِ
u'عِوَضٌ بِنَاءٌ':Added, #1: 1	عِوَضَ الْبِنَاءِ
u'عِوَضٌ تَمْلِيكٌ':Added, #2: 2	عِوَضُ الْبِنَاءِ
u'عِوَضٌ ثَمَنٌ':Added, #1: 1	عِوَضَ تَمْلِيكٍ
u'عِوَضٌ ثَمَنٌ':Added, #1: 1	عِوَضَ الثَّمَنِ
u'عِوَضٌ جِزْيَةٌ':Added, #1: 1	عِوَضِ الثَّمَنِ
u'عِوَضٌ جُنْدِيٌّ':Added, #1: 1	عِوَضُ الْجِزْيَةِ
u'عِوَضٌ حَقٌّ':Added, #1: 1	عِوَضَ الْجُنْدِيِّ
u'عِوَضٌ حَقٌّ':Added, #1: 1	عِوَضَ حَقِّهِ
u'عِوَضٌ حَلِيم':Added, #1: 1	عِوَضُ حَقِّهِ
u'عِوَضٌ خَالٌ':Added, #1: 1	عِوَضِ الْحَلِيمِ
u'عِوَضٌ خدمة':Added, #1: 1	عِوَضٍ خَالٍ
u'عِوَضٌ خِدْمَةٌ':Added, #1: 1	عِوَضُ الْخِدْمَةِ
u'عِوَضٌ خدمة':Added, #1: 1	عِوَضُ الْخِدْمَةِ
u'عِوَضٌ خِدْمَةٌ':Added, #1: 1	عِوَضَ خِدْمَتِهِ
u'عِوَضٌ خَلْعٌ':Added, #1: 1	عِوَضَ خِدْمَتِهِ
u'عِوَضٌ خُلْعٌ':Added, #1: 1	عِوَضُ الْخَلْعِ
u'عِوَضٌ خُلْعٌ':Added, #1: 1	عِوَضَ الْخُلْعِ
u'عِوَضٌ خُلْعٌ':Added, #1: 1	عِوَضَ خُلْعٍ
u'عِوَضٌ خُلْعٌ':Added, #2: 2	عِوَضُ خُلْعٍ
u'عِوَضٌ خُلْعٌ':Added, #2: 2	عِوَضِ خُلْعٍ
u'عِوَضٌ خُلْعٌ':Added, #7: 7	عِوَضُ الْخُلْعِ
u'عِوَضٌ دَارٌ':Added, #7: 7	عِوَضِ الْخُلْعِ
u'عِوَضٌ دِرْهَمٌ':Added, #1: 1	عِوَضَ الدَّارِ
u'عِوَضٌ دِرْهَم':Added, #1: 1	عِوَضَ دِرْهَمٍ
u'عِوَضٌ دَيْنٌ':Added, #1: 1	عِوَضَ دِرْهَمٍ
u'عِوَضٌ ذَكاةٌ':Added, #1: 1	عِوَضِ الدَّيْنِ
u'عِوَضٌ رَأْسٌ':Added, #1: 1	عِوَضُ الذَّكَاةِ
u'عَوَّضَ رَبُّ':Predicate, #2: 2	عِوَضَ رَأْسِ
u'عِوَضٌ رِبْحٌ':Added, #1: 1	عَوَّضَ رَبَّ
u'عَوَّضَ رَجُلٌ':Predicate, #1: 1	عِوَضُ الرِّبْحِ
u'عَوَّضَ رُجُوعٌ':Subject, #1: 1	عَوَّضَ الرَّجُلَ
u'عِوَضٌ رَهْنٌ':Added, #1: 1	عَوَّضَ رُجُوعٌ
u'عِوَضٌ زائِدٌ':Added, #1: 1	عِوَضُ الرَّهْنِ
u'عِوَضٌ زَرْعٌ':Added, #1: 1	عِوَضُ الزَّائِدِ
u'عِوَضٌ زَكاةٌ':Added, #1: 1	عِوَضِ الزَّرْعِ
u'عِوَضٌ زِيادَةٌ':Added, #1: 1	عِوَضَ الزَّكَاةِ
u'عِوَضٌ زِيادَةٌ':Added, #1: 1	عِوَضِ الزِّيَادَةِ
u'عِوَضٌ سِلاَحٌ':Added, #1: 1	عِوَضِ زِيَادَةِ
u'عِوَضٌ سِلْعَةٌ':Added, #1: 1	عِوَضَ السِّلَاحِ
u'عِوَضٌ شَرْطٌ':Added, #1: 1	عِوَضِ السِّلْعَةِ
u'عِوَضٌ صداق':Added, #1: 1	عِوَضِ شَرْطٍ
u'عِوَضٌ صَدَاقٌ':Added, #1: 1	عِوَضُ الصَّدَاقِ
u'عِوَضٌ صَرْفٌ':Added, #1: 1	عِوَضُ الصَّدَاقِ
u'عِوَضٌ صَرْف':Added, #2: 2	عِوَضِ الصَّرْفِ
u'عِوَضٌ صِلَةٌ':Added, #2: 2	عِوَضِ الصَّرْفِ
u'عِوَضٌ صلح':Added, #1: 1	عِوَضِ صِلَةٍ
u'عِوَضٌ صُلْحٌ':Added, #1: 1	عِوَضِ الصُّلْحِ
u'عِوَضٌ صُلْحٌ':Added, #1: 1	عِوَضِ الصُّلْحِ
u'عِوَضٌ طعام':Added, #1: 1	عِوَضَ صُلْحٍ
u'عِوَضٌ طَعَامٌ':Added, #1: 1	عِوَضِ الطَّعَامِ
u'عِوَضٌ عَاجِلٌ':Added, #1: 1	عِوَضِ الطَّعَامِ
u'عِوَضٌ عَبْدٌ':Added, #1: 1	عِوَضٍ عَاجِلٍ
u'عِوَضٌ عتق':Added, #1: 1	عِوَضَ الْعَبْدِ
u'عِوَضٌ عِتْقٌ':Added, #1: 1	عِوَضَ الْعِتْقِ
u'عِوَضٌ عِتْقٌ':Added, #1: 1	عِوَضَ الْعِتْقِ
u'عِوَضٌ عَقْدٌ':Added, #2: 2	عِوَضَ عِتْقٍ
u'عَوَّضَ عُمَرٌ':Subject, #1: 1	عِوَضُ الْعَقْدِ
u'عِوَضٌ عين':Added, #1: 1	عَوَّضَ عُمَرُ
u'عِوَضٌ عَيْنٌ':Added, #3: 3	عِوَضُ الْعَيْنِ
u'عِوَضٌ عَيْن':Added, #3: 3	عِوَضُ الْعَيْنِ
u'عَوَّضَ غانِم':Predicate, #3: 3	عِوَضُ الْعَيْنِ
u'عَوَّضَ غَرِيمٌ':Predicate, #1: 1	عَوَّضَ الْغَانِمِينَ
u'عِوَضٌ غير':Added, #1: 1	عَوَّضَ الْغَرِيمَ
u'عِوَضٌ غَيْرٌ':Added, #1: 1	عِوَضِ غَيْرِ
u'عِوَضٌ فَاسِدٌ':Added, #1: 1	عِوَضِ غَيْرِ
u'عِوَضٌ فَضْلٌ':Added, #2: 2	عِوَضٍ فَاسِدٍ
u'عَوَّضَ فلان':Predicate, #1: 1	عِوَضُ الْفَضْلِ
u'عَوَّضَ فُلاَنٌ':Subject, #1: 1	عَوَّضَ الْغَانِمِينَ
u'عِوَضٌ قول':Added, #1: 1	عَوَّضَ فُلَانٌ
u'عِوَضٌ قَوْلٌ':Added, #1: 1	عِوَضَ قَوْلِهِ
u'عِوَضٌ كِرَاءٌ':Added, #1: 1	عِوَضَ قَوْلِهِ
u'عِوَضٌ كَلِمَةٌ':Added, #1: 1	عِوَضَ كِرَاءٍ
u'عِوَضٌ لبن':Added, #1: 1	عِوَضَ كَلِمَةِ
u'عِوَضٌ لَبَنٌ':Added, #1: 1	عِوَضَ اللَّبَنِ
u'عِوَضٌ لبن':Added, #1: 1	عِوَضَ اللَّبَنِ
u'عِوَضٌ لَبَنٌ':Added, #2: 2	عِوَضُ لَبَنِ
u'عِوَضٌ لَيْلٌ':Added, #2: 2	عِوَضُ لَبَنِ
u'عِوَضٌ مَالِيٌّ':Added, #1: 1	عِوَضُ اللَّيْلِ
u'عِوَضٌ مُتْعَةٌ':Added, #2: 2	عِوَضٍ مَالِيٍّ
u'عِوَضٌ مُتْلِفٌ':Added, #1: 1	عِوَضُ الْمُتْعَةِ
u'عِوَضٌ مثل':Added, #1: 1	عِوَضِ الْمُتْلِفِ
u'عِوَضٌ مِثْلٌ':Added, #1: 1	عِوَضِ مِثْلِهِ
u'عِوَضٌ مثل':Added, #1: 1	عِوَضِ مِثْلِهِ
u'عِوَضٌ مِثْلٌ':Added, #4: 4	عِوَضِ الْمِثْلِ
u'عِوَضٌ مَجْهُولٌ':Added, #4: 4	عِوَضِ الْمِثْلِ
u'عِوَضٌ مُحَرَّمٌ':Added, #3: 3	عِوَضٍ مَجْهُولٍ
u'عِوَضٌ مَخْصُوصٌ':Added, #1: 1	عِوَضٍ مُحَرَّمٍ
u'عِوَضٌ مَدْفُوعٌ':Added, #2: 2	عِوَضٍ مَخْصُوصٍ
u'عِوَضٌ مُسَابَقَةٌ':Added, #1: 1	عِوَضُ الْمَدْفُوعِ
u'عِوَضٌ مَشْرُوطٌ':Added, #1: 1	عِوَضِ الْمُسَابَقَةِ
u'عِوَضٌ مَطْلُوبٌ':Added, #3: 3	عِوَضٍ مَشْرُوطٍ
u'عِوَضٌ مَعْلُومٌ':Added, #1: 1	عِوَضٍ مَطْلُوبٍ
u'عِوَضٌ مُعَيَّنٌ':Added, #4: 4	عِوَضٍ مَعْلُومٍ
u'عِوَضٌ مُفْظِع':Added, #3: 3	عِوَضٍ مُعَيَّنٍ
u'عِوَضٌ مَقْصُودٌ':Added, #1: 1	عِوَضٍ مُفْظِعٍ
u'عِوَضٌ مِلْكٌ':Added, #1: 1	عِوَضٍ مَقْصُودٍ
u'عِوَضٌ مِلْكٌ':Added, #1: 1	عِوَضُ الْمِلْكِ
u'عِوَضٌ مِلْكٌ':Added, #1: 1	عِوَضِ مِلْكٍ
u'عِوَضٌ مَنَافِعُ':Added, #3: 3	عِوَضَ مِلْكِهِ
u'عِوَضٌ مَنَافِعُ':Added, #1: 1	عِوَضَ الْمَنَافِعِ
u'عِوَضٌ مَنْفَعَةٌ':Added, #1: 1	عِوَضَ مَنَافِعِ
u'عِوَضٌ مَنْفَعَةٌ':Added, #1: 1	عِوَضُ مَنْفَعَةٍ
u'عِوَضٌ مَهْرٌ':Added, #1: 1	عِوَضُ مَنْفَعَةِ
u'عِوَضٌ مَوْصُوفٌ':Added, #1: 1	عِوَضُ الْمَهْرِ
u'عَوَّضَ مَوْهُوبٌ':Subject, #1: 1	عِوَضٍ مَوْصُوفٍ
u'عَوَّضَ نِصْفٌ':Predicate, #1: 1	عَوَّضَ الْمَوْهُوبُ
u'عِوَضٌ نَفْسٌ':Added, #1: 1	عَوَّضَ النِّصْفَ
u'عِوَضٌ نكاح':Added, #1: 1	عِوَضُ نَفْسٍ
u'عِوَضٌ نِكَاحٌ':Added, #1: 1	عِوَضُ النِّكَاحِ
u'عِوَضٌ نهار':Added, #1: 1	عِوَضُ النِّكَاحِ
u'عِوَضٌ نَهَارٌ':Added, #1: 1	عِوَضُ النَّهَارِ
u'عِوَضٌ هِبَةٌ':Added, #1: 1	عِوَضُ النَّهَارِ
u'عِوَضٌ واحد':Added, #2: 2	عِوَضُ هِبَتِهِ
u'عِوَضٌ وَاحِدٌ':Added, #1: 1	عِوَضٍ وَاحِدٍ
u'عَوَّضَ وَاهِبٌ':Predicate, #1: 1	عِوَضٍ وَاحِدٍ
u'عِوَضٌ وَاهِبٌ':Added, #2: 2	عَوَّضَ الْوَاهِبَ
u'عَوَّضَ وَصِيٌّ':Subject, #1: 1	عِوَضُ الْوَاهِبِ
u'عَوَّلَ إمَامٌ':Subject, #1: 1	عَوَّضَ الْوَصِيُّ
u'عَوَّلَ أهْلٌ':Subject, #1: 1	عَوَّلَ الْإِمَامُ
u'عَوَّلَ جُمْهُورٌ':Subject, #1: 1	عَوَّلَ أَهْلُ
u'عَوَّلَ شَيْخٌ':Subject, #1: 1	عَوَّلَ جُمْهُورُ
u'عَوَّلَ شَيْخٌ':Subject, #1: 1	عَوَّلَ الشَّيْخُ
u'عَوَّلَ صَحَابَةٌ':Subject, #2: 2	عَوَّلَ شَيْخُ
u'عَوَّلَ فقهاء':Subject, #1: 1	عَوَّلَ الصَّحَابَةُ
u'عَوَّلَ مَالِكٌ':Subject, #1: 1	عَوَّلَ الْفُقَهَاءُ
u'عَوَّلَ نَاسٌ':Subject, #1: 1	عَوَّلَ مَالِكٌ
u'عَوْنٌ بِيدٌ':Added, #1: 1	عَوَّلَ النَّاسُ
u'عَوْنٌ سُلْطَانٌ':Added, #1: 1	عَوْنٍ بِيَدٍ
u'عَوْنٌ شَيْطَانٌ':Added, #1: 1	عَوْنِ السُّلْطَانِ
u'عَوْنٌ عَبْدٌ':Added, #1: 1	عَوْنَ الشَّيْطَانِ
u'عَوْنٌ غُلاَمٌ':Added, #6: 6	عَوْنِ الْعَبْدِ
u'عَوْنٌ غير':Added, #1: 1	عَوْنِ غُلَامِ
u'عَوْنٌ غَيْرٌ':Added, #1: 1	عَوْنِ غَيْرِهِ
u'عَوَى كَلْبٌ':Subject, #1: 1	عَوْنِ غَيْرِهِ
u'عِيَادَةٌ أهْلٌ':Added, #1: 1	عَوَى الْكَلْبُ
u'عِيَادَةٌ ذِمِّيٌّ':Added, #1: 1	عِيَادَةِ أَهْلِ
u'عِيَادَةٌ فَاسِقٌ':Added, #3: 3	عِيَادَةُ الذِّمِّيِّ
u'عِيَادَةٌ مُبْتَدِعٌ':Added, #3: 3	عِيَادَةِ الْفَاسِقِ
u'عِيَادَةٌ مَجُوسٌ':Added, #1: 1	عِيَادَةِ الْمُبْتَدِعِ
u'عِيَادَةٌ مَرِيضٌ':Added, #1: 1	عِيَادَةِ الْمَجُوسِ
u'عِيَادَةٌ مَرِيضٌ':Added, #12: 12	عِيَادَةِ الْمَرِيضِ
u'عِيَادَةٌ مَرِيضٌ':Added, #5: 5	عِيَادَةَ الْمَرِيضِ
u'عِيَادَةٌ مُسْلِمٌ':Added, #9: 9	عِيَادَةُ الْمَرِيضِ
u'عِيَارٌ جَدَلٌ':Added, #1: 1	عِيَادَةِ الْمُسْلِمِ
u'عِيَارٌ نَظَرٌ':Added, #1: 1	عِيَارِ الْجَدَلِ
u'عِيَانٌ حَقِيقٌ':Added, #1: 1	عِيَارِ النَّظَرِ
u'عِيَانٌ حَقِيقَةٌ':Added, #1: 1	عِيَانِ حَقِيقَةِ
u'عِيَانٌ كعبة':Added, #1: 1	عِيَانِ حَقِيقَةِ
u'عِيَانٌ كَعْبَةٌ':Added, #1: 1	عِيَانِ الْكَعْبَةِ
u'عَيْبٌ أحَدٌ':Added, #1: 1	عِيَانِ الْكَعْبَةِ
u'عَيْبٌ أحَدٌ':Added, #1: 1	عَيْبَ أَحَدِ
u'عَيْبٌ إفْلاَسٌ':Added, #1: 1	عَيْبُ أَحَدِ
u'عَيْبٌ إفْلاَسٌ':Added, #1: 1	عَيْبُ الْإِفْلَاسِ
u'عَيْبٌ أكل':Added, #2: 2	عَيْبِ الْإِفْلَاسِ
u'عَيْبٌ أَكْلٌ':Added, #1: 1	عَيْبِ الْأَكْلِ
u'عَيْبٌ الْمَرْءُ':Added, #1: 1	عَيْبِ الْأَكْلِ
u'عَيْبٌ الْمَرْأَةُ':Added, #1: 1	عَيْبَ الْمَرْءِ
u'عَيْبٌ اِمْتِلاءٌ':Added, #1: 1	عَيْبُ الْمَرْأَةِ
u'عَيْبٌ بَاطن':Added, #1: 1	عَيْبُ امْتِلَاءِ
u'عَيْبٌ باطِنٌ':Added, #1: 1	عَيْبِ بَاطِنٍ
u'عَيْبٌ بَاطن':Added, #1: 1	عَيْبِ بَاطِنٍ
u'عَيْبٌ باطِنٌ':Added, #6: 6	عَيْبٍ بَاطِنٍ
u'عَيْبٌ باطِنِيٌّ':Added, #6: 6	عَيْبٍ بَاطِنٍ
u'عَيْبٌ بَيْعٌ':Added, #1: 1	عَيْبٍ بَاطِنِيٍّ
u'عَيْبٌ تَزْوِيجٌ':Added, #4: 4	عَيْبِ الْبَيْعِ
u'عَيْبٌ تَزْوِيجٌ':Added, #1: 1	عَيْبَ التَّزْوِيجِ
u'عَيْبٌ تَلَف':Added, #2: 2	عَيْبِ التَّزْوِيجِ
u'عَيْبٌ ثَمَنٌ':Added, #1: 1	عَيْبُ التَّلَفِ
u'عَيْبٌ جَارِي':Added, #1: 1	عَيْبِ الثَّمَنِ
u'عَيْبٌ جَارِيَةٌ':Added, #1: 1	عَيْبِ الْجَارِيَةِ
u'عَيْبٌ جُنُونٌ':Added, #1: 1	عَيْبِ الْجَارِيَةِ
u'عَيْبٌ جَوْزٌ':Added, #1: 1	عَيْبَ الْجُنُونِ
u'عَيْبٌ حادِثٌ':Added, #2: 2	عَيْبِ الْجَوْزِ
u'عَيْبٌ خَادِمٌ':Added, #1: 1	عَيْبٍ حَادِثٍ
u'عَيْبٌ خَاطِبٌ':Added, #1: 1	عَيْبِ خَادِمٍ
u'عَيْبٌ خَاطِبٌ':Added, #1: 1	عَيْبِ الْخَاطِبِ
u'عَيْبٌ خَطٌّ':Added, #1: 1	عَيْبِ خَاطِبٍ
u'عَيْبٌ دَابَّةٌ':Added, #2: 2	عَيْبِ الْخَطِّ
u'عَيْبٌ دِيَةٌ':Added, #1: 1	عَيْبُ الدَّابَّةِ
u'عَيْبٌ رَجُلٌ':Added, #1: 1	عَيْبُ الدِّيَةِ
u'عَيْبٌ رَدٌّ':Added, #2: 2	عَيْبَ الرَّجُلِ
u'عَيْبٌ رَدٌّ':Added, #1: 1	عَيْبُ الرَّدِّ
u'عَيْبٌ رَقيقٌ':Added, #1: 1	عَيْبُ رَدٍّ
u'عَيْبٌ رَقيقٌ':Added, #1: 1	عَيْبَ الرَّقِيقِ
u'عَيْبٌ رَقيق':Added, #1: 1	عَيْبِ الرَّقِيقِ
u'عَيْبٌ رَقيق':Added, #1: 1	عَيْبَ الرَّقِيقِ
u'عَيْبٌ سِلْعَةٌ':Added, #1: 1	عَيْبِ الرَّقِيقِ
u'عَيْبٌ شُبْهَةٌ':Added, #3: 3	عَيْبِ السِّلْعَةِ
u'عَيْبٌ شَجَّةٌ':Added, #1: 1	عَيْبِ الشُّبْهَةِ
u'عَيْبٌ شركة':Added, #2: 2	عَيْبِ الشَّجَّةِ
u'عَيْبٌ شِرْكَةٌ':Added, #2: 2	عَيْبُ الشِّرْكَةِ
u'عَيْبٌ شركة':Added, #2: 2	عَيْبُ الشِّرْكَةِ
u'عَيْبٌ شَرِكَةٌ':Added, #4: 4	عَيْبِ الشَّرِكَةِ
u'عَيْبٌ شِعْرٌ':Added, #4: 4	عَيْبِ الشَّرِكَةِ
u'عَيْبٌ صَاحِبٌ':Added, #2: 2	عَيْبِ الشِّعْرِ
u'عَيْبٌ صَدِيقٌ':Added, #1: 1	عَيْبِ صَاحِبِهِ
u'عَيْبٌ طعام':Added, #1: 1	عَيْبِ الصَّدِيقِ
u'عَيْبٌ طَعَامٌ':Added, #1: 1	عَيْبُ الطَّعَامِ
u'عَيْبٌ طعام':Added, #1: 1	عَيْبُ الطَّعَامِ
u'عَيْبٌ طَعَامٌ':Added, #1: 1	عَيْبُ طَعَامِ
u'عَيْبٌ ظاهِرٌ':Added, #1: 1	عَيْبُ طَعَامِ
u'عَيَّبَ عَبْدٌ':Predicate, #2: 2	عَيْبٍ ظَاهِرٍ
u'عَيْبٌ عَبْدٌ':Added, #1: 1	عَيَّبَ الْعَبْدَ
u'عَيْبٌ عَبْدٌ':Added, #1: 1	عَيْبِ الْعَبْدِ
u'عَيْبٌ غَنِيٌّ':Added, #2: 2	عَيْبِ عَبْدٍ
u'عَيْبٌ غير':Added, #1: 1	عَيْبُ الْغَنِيِّ
u'عَيْبٌ غَيْرٌ':Added, #1: 1	عَيْبَ الْغَيْرِ
u'عَيْبٌ غير':Added, #1: 1	عَيْبَ الْغَيْرِ
u'عَيْبٌ غَيْرٌ':Added, #1: 1	عَيْبُ غَيْرِهِ
u'عَيْبٌ غير':Added, #1: 1	عَيْبُ غَيْرِهِ
u'عَيْبٌ غير':Added, #2: 2	عَيْبَ غَيْرِهِ
u'عَيْبٌ غَيْرٌ':Added, #2: 2	عَيْبِ غَيْرِهِ
u'عَيْبٌ غَيْرٌ':Added, #2: 2	عَيْبَ غَيْرِهِ
u'عَيْبٌ فَاسِدٌ':Added, #2: 2	عَيْبِ غَيْرِهِ
u'عَيْبٌ فُجُورٌ':Added, #1: 1	عَيْبٍ فَاسِدٍ
u'عَيْبٌ فَرْجٌ':Added, #1: 1	عَيْبُ الْفُجُورِ
u'عَيْبٌ قَطْعٌ':Added, #1: 1	عَيْبُ الْفَرْجِ
u'عَيْبٌ قَطْعٌ':Added, #1: 1	عَيْبَ الْقَطْعِ
u'عَيْبٌ كفر':Added, #1: 1	عَيْبُ الْقَطْعِ
u'عَيْبٌ كُفْرٌ':Added, #2: 2	عَيْبِ الْكُفْرِ
u'عَيَّبَ مَبِيعٌ':Predicate, #2: 2	عَيْبِ الْكُفْرِ
u'عَيْبٌ مَبِيعٌ':Added, #2: 2	عَيَّبَ الْمَبِيعَ
u'عَيْبٌ مَبِيعٌ':Added, #1: 1	عَيْبُ الْمَبِيعِ
u'عَيْبٌ مَبِيعٌ':Added, #1: 1	عَيْبٍ مَبِيعٍ
u'عَيْبٌ مَبِيعٌ':Added, #2: 2	عَيْبِ مَبِيعٍ
u'عَيْبٌ مُخْطِئٌ':Added, #7: 7	عَيْبِ الْمَبِيعِ
u'عَيْبٌ مَرْهُونٌ':Added, #1: 1	عَيْبُ الْمُخْطِئِ
u'عَيَّبَ مُسْتَأْجِرٌ':Subject, #1: 1	عَيْبُ الْمَرْهُونِ
u'عَيْبٌ مُضِرٌّ':Added, #1: 1	عَيَّبَ الْمُسْتَأْجِرُ
u'عَيَّبَ مَعْقُودٌ':Predicate, #1: 1	عَيْبٍ مُضِرٍّ
u'عَيْبٌ مُعَيَّنٌ':Added, #2: 2	عَيَّبَ الْمَعْقُودَ
u'عَيَّبَ مَغْصُوب':Predicate, #1: 1	عَيْبٍ مُعَيَّنٍ
u'عَيْبٌ مُفْسِدٌ':Added, #2: 2	عَيَّبَ الْمَغْصُوبَ
u'عَيْبٌ مَوْجُودٌ':Added, #1: 1	عَيْبٍ مُفْسِدٍ
u'عَيَّبَ مَوْهُوبٌ':Subject, #1: 1	عَيْبٍ مَوْجُودٍ
u'عَيْبٌ نَفْسٌ':Added, #1: 1	عَيَّبَ الْمَوْهُوبُ
u'عَيْبٌ نَفْسٌ':Added, #1: 1	عَيْبِ نَفْسِهِ
u'عَيْبٌ نكاح':Added, #3: 3	عَيْبَ نَفْسِهِ
u'عَيْبٌ نِكَاحٌ':Added, #3: 3	عَيْبِ النِّكَاحِ
u'عَيْبٌ واحد':Added, #3: 3	عَيْبِ النِّكَاحِ
u'عَيْبٌ وَاحِدٌ':Added, #10: 10	عَيْبٍ وَاحِدٍ
u'عَيْبٌ وَاقِفٌ':Added, #10: 10	عَيْبٍ وَاحِدٍ
u'عَيْبٌ وَجْهٌ':Added, #1: 1	عَيْبٍ وَاقِفٍ
u'عَيْبٌ ورق':Added, #1: 1	عَيْبِ الْوَجْهِ
u'عَيْبٌ وَرَقٌ':Added, #1: 1	عَيْبُ الْوَرَقِ
u'عِيدٌ آخِرَةٌ':Added, #1: 1	عَيْبُ الْوَرَقِ
u'عِيدٌ إِرْهَابٌ':Added, #1: 1	وَعِيدِ الْآخِرَةِ
u'عِيدٌ بَارِئٌ':Added, #1: 1	وَعِيدُ إرْهَابٍ
u'عِيدٌ حَقٌّ':Added, #1: 1	وَعِيدَ الْبَارِئِ
u'عِيدٌ خَمْرٌ':Added, #1: 1	وَعِيدِ الْحَقِّ
u'عِيدٌ ذَنْبٌ':Added, #1: 1	وَعِيدُ الْخَمْرِ
u'عِيدٌ رَسُولٌ':Added, #1: 1	وَعِيدِ ذَنْبِهِ
u'عِيدٌ شَرْعٌ':Added, #1: 1	وَعِيدَ الرَّسُولِ
u'عِيدٌ عَذَابٌ':Added, #3: 3	وَعِيدِ الشَّرْعِ
u'عِيدٌ غَاصِبٌ':Added, #1: 1	وَعِيدَ عَذَابِ
u'عِيدٌ فُسَّاقٌ':Added, #1: 1	وَعِيدِ الْغَاصِبِ
u'عِيدٌ فَطِيرٌ':Added, #1: 1	وَعِيدِ الْفُسَّاقِ
u'عِيدٌ يَوْمٌ':Added, #1: 1	وَعِيدِ الْفَطِيرِ
u'عَيْشٌ أحْمَق':Added, #1: 1	وَعِيدَ الْيَوْمِ
u'عَيْشٌ آخِرَةٌ':Added, #1: 1	عَيْشِ الْأَحْمَقِ
u'عَيْشٌ آخِرَةٌ':Added, #2: 2	عَيْشَ الْآخِرَةِ
u'عَيْشٌ آخِرَةٌ':Added, #3: 3	عَيْشَ الآخِرَةِ
u'عَيْشٌ آخِرَةٌ':Added, #7: 7	عَيْشُ الآخِرَةِ
u'عَيْشٌ أَرْمَد':Added, #9: 9	عَيْشُ الْآخِرَةِ
u'عَيْشٌ أَزْواجٌ':Added, #1: 1	عَيْشِ أَرْمَدِ
u'عَيْشٌ أهْلٌ':Added, #2: 2	عَيْشَ الْأَزْوَاجِ
u'عَيْشٌ أهْلٌ':Added, #1: 1	عَيْشُ أَهْلِ
u'عَيْشٌ بَلَدٌ':Added, #4: 4	عَيْشِ أَهْلِ
u'عَيْشٌ بَلَدٌ':Added, #1: 1	عَيْشُ الْبَلَدِ
u'عِيشَةٌ رَاضِي':Added, #3: 3	عَيْشِ الْبَلَدِ
u'عَيْشٌ زَرْعٌ':Added, #2: 2	عِيشَةٍ رَاضِيَةٍ
u'عَيْشٌ صَاعٌ':Added, #1: 1	عَيْشِ الزَّرْعِ
u'عَيْشٌ صَاعٌ':Added, #1: 1	عَيْشَ الصَّاعِ
u'عَيْشٌ عِيَالٌ':Added, #1: 1	عَيْشِ الصَّاعِ
u'عَيْشٌ فقراء':Added, #1: 1	عَيْشِ عِيَالِهِ
u'عَيْشٌ قَوْمٌ':Added, #1: 1	عَيْشَ الْفُقَرَاءِ
u'عَيْشٌ مَذْبُوحٌ':Added, #1: 1	عَيْشَ قَوْمٍ
u'عَيْشٌ مَذْبُوحٌ':Added, #1: 1	عَيْشُ الْمَذْبُوحِ
u'عَيْشٌ مَذْبُوحٌ':Added, #1: 1	عَيْشِ الْمَذْبُوحِ
u'عَيْشٌ مَذْبُوحٌ':Added, #1: 1	عَيْشِ مَذْبُوحٍ
u'عَيْشٌ نَفْسٌ':Added, #3: 3	عَيْشَ مَذْبُوحٍ
u'عَيَّنَ أَبٌ':Subject, #1: 1	عَيْشُ النَّفْسِ
u'عين اِتِّبَاعٌ':Added, #1: 1	عَيَّنَ الْأَبُ
u'عَيْنٌ اِتِّبَاعٌ':Added, #2: 2	عَيْنُ اتِّبَاعِ
u'عَيْن اِتِّبَاعٌ':Added, #2: 2	عَيْنُ اتِّبَاعِ
u'عين أثَرٌ':Added, #2: 2	عَيْنُ اتِّبَاعِ
u'عَيْنٌ أثَرٌ':Added, #1: 1	عَيْنُ الْأَثَرِ
u'عَيْن أثَرٌ':Added, #1: 1	عَيْنُ الْأَثَرِ
u'عين إِجْرَاءٌ':Added, #1: 1	عَيْنُ الْأَثَرِ
u'عَيْنٌ إِجْرَاءٌ':Added, #1: 1	عَيْنُ الْإِجْرَاءِ
u'عَيْن إِجْرَاءٌ':Added, #1: 1	عَيْنُ الْإِجْرَاءِ
u'عين أَجِيرٌ':Added, #1: 1	عَيْنُ الْإِجْرَاءِ
u'عَيْنٌ أَجِيرٌ':Added, #1: 1	عَيْنِ الْأَجِيرِ
u'عَيْن أَجِيرٌ':Added, #1: 1	عَيْنِ الْأَجِيرِ
u'عين أحَدٌ':Added, #1: 1	عَيْنِ الْأَجِيرِ
u'عَيْنٌ أحَدٌ':Added, #1: 1	عَيْنَ أَحَدٍ
u'عَيْن أحَدٌ':Added, #1: 1	عَيْنَ أَحَدٍ
u'عين إِحْرَامٌ':Added, #1: 1	عَيْنَ أَحَدٍ
u'عَيْنٌ إِحْرَامٌ':Added, #1: 1	عَيْنُ الْإِحْرَامِ
u'عَيْن إِحْرَامٌ':Added, #1: 1	عَيْنُ الْإِحْرَامِ
u'عين أحْوَل':Added, #1: 1	عَيْنُ الْإِحْرَامِ
u'عَيْنٌ أحْوَل':Added, #1: 1	عَيْنِ الْأَحْوَلِ
u'عَيْن أحْوَل':Added, #1: 1	عَيْنِ الْأَحْوَلِ
u'عَيَّنَ آخِرُ':Predicate, #1: 1	عَيْنِ الْأَحْوَلِ
u'عين أَخَصُّ':Added, #1: 1	عَيَّنَ آخِرَ
u'عَيْنٌ أَخَصُّ':Added, #1: 1	عَيْنَ الْأَخَصِّ
u'عَيْن أَخَصُّ':Added, #1: 1	عَيْنَ الْأَخَصِّ
u'عين آدَمِيٌّ':Added, #1: 1	عَيْنَ الْأَخَصِّ
u'عَيْنٌ آدَمِيٌّ':Added, #1: 1	عَيْنَ الْآدَمِيِّ
u'عَيْن آدَمِيٌّ':Added, #1: 1	عَيْنَ الْآدَمِيِّ
u'عين إِرَاقَةٌ':Added, #1: 1	عَيْنَ الْآدَمِيِّ
u'عَيْنٌ إِرَاقَةٌ':Added, #1: 1	عَيْنَ إرَاقَةِ
u'عَيْن إِرَاقَةٌ':Added, #1: 1	عَيْنَ إرَاقَةِ
u'عَيَّنَ أرْضٌ':Predicate, #1: 1	عَيْنَ إرَاقَةِ
u'عين أرْضٌ':Added, #1: 1	عَيَّنَ الْأَرْضَ
u'عَيْنٌ أرْضٌ':Added, #1: 1	عَيْنَ الْأَرْضِ
u'عَيْن أرْضٌ':Added, #1: 1	عَيْنَ الْأَرْضِ
u'عين إِسْكارٌ':Added, #1: 1	عَيْنَ الْأَرْضِ
u'عَيْنٌ إِسْكارٌ':Added, #1: 1	عَيْنُ الْإِسْكَارِ
u'عَيْن إِسْكارٌ':Added, #1: 1	عَيْنُ الْإِسْكَارِ
u'عين اِشْتِراطٌ':Added, #1: 1	عَيْنُ الْإِسْكَارِ
u'عَيْنٌ اِشْتِراطٌ':Added, #1: 1	عَيْنُ اشْتِرَاطِ
u'عَيْن اِشْتِراطٌ':Added, #1: 1	عَيْنُ اشْتِرَاطِ
u'عين اِشْتِمالٌ':Added, #1: 1	عَيْنُ اشْتِرَاطِ
u'عَيْنٌ اِشْتِمالٌ':Added, #1: 1	عَيْنُ اشْتِمَالِ
u'عَيْن اِشْتِمالٌ':Added, #1: 1	عَيْنُ اشْتِمَالِ
u'عَيَّنَ أصْغَرٌ':Subject, #1: 1	عَيْنُ اشْتِمَالِ
u'عَيَّنَ أَصْغَرُ':Subject, #1: 1	عَيَّنَ الْأَصْغَرُ
u'عين أصل':Added, #1: 1	عَيَّنَ الْأَصْغَرُ
u'عين أًصْلٌ':Added, #1: 1	عَيْنِ الْأَصْلِ
u'عَيْنٌ أصل':Added, #1: 1	عَيْنِ الْأَصْلِ
u'عَيْن أصل':Added, #1: 1	عَيْنِ الْأَصْلِ
u'عَيْنٌ أًصْلٌ':Added, #1: 1	عَيْنِ الْأَصْلِ
u'عَيْن أًصْلٌ':Added, #1: 1	عَيْنِ الْأَصْلِ
u'عين أَصْلِيٌّ':Added, #1: 1	عَيْنِ الْأَصْلِ
u'عَيْنٌ أَصْلِيٌّ':Added, #1: 1	عَيْنَ الْأَصْلِيَّةِ
u'عَيْن أَصْلِيٌّ':Added, #1: 1	عَيْنَ الْأَصْلِيَّةِ
u'عين أعْمَش':Added, #1: 1	عَيْنَ الْأَصْلِيَّةِ
u'عَيْنٌ أعْمَش':Added, #1: 1	عَيْنِ الْأَعْمَشِ
u'عَيْن أعْمَش':Added, #1: 1	عَيْنِ الْأَعْمَشِ
u'عين أعْوَر':Added, #1: 1	عَيْنِ الْأَعْمَشِ
u'عَيْنٌ أعْوَر':Added, #14: 14	عَيْنِ الْأَعْوَرِ
u'عَيْن أعْوَر':Added, #14: 14	عَيْنِ الْأَعْوَرِ
u'عين أعْوَر':Added, #14: 14	عَيْنِ الْأَعْوَرِ
u'عين أعْوَر':Added, #1: 1	عَيْنَ الأَعْوَرِ
u'عَيْنٌ أعْوَر':Added, #1: 1	عَيْنَ الْأَعْوَرِ
u'عَيْن أعْوَر':Added, #1: 1	عَيْنَ الأَعْوَرِ
u'عَيْنٌ أعْوَر':Added, #1: 1	عَيْنَ الأَعْوَرِ
u'عَيْن أعْوَر':Added, #1: 1	عَيْنَ الْأَعْوَرِ
u'عين أعْوَر':Added, #1: 1	عَيْنَ الْأَعْوَرِ
u'عين أعْوَر':Added, #2: 2	عَيْنِ الأَعْوَرِ
u'عَيْنٌ أعْوَر':Added, #2: 2	عَيْنُ الْأَعْوَرِ
u'عَيْن أعْوَر':Added, #2: 2	عَيْنِ الأَعْوَرِ
u'عَيْنٌ أعْوَر':Added, #2: 2	عَيْنِ الأَعْوَرِ
u'عَيْن أعْوَر':Added, #2: 2	عَيْنُ الْأَعْوَرِ
u'عَيَّنَ أفْضَلُ':Predicate, #2: 2	عَيْنُ الْأَعْوَرِ
u'عين أكْبَرُ':Added, #1: 1	عَيَّنَ أَفْضَلَ
u'عَيْنٌ أكْبَرُ':Added, #3: 3	عَيْنَ الْأَكْبَرِ
u'عَيْن أكْبَرُ':Added, #3: 3	عَيْنَ الْأَكْبَرِ
u'عَيَّنَ أَكْثَرُ':Predicate, #3: 3	عَيْنَ الْأَكْبَرِ
u'عَيَّنَ ألف':Predicate, #2: 2	عَيَّنَ أَكْثَرَ
u'عَيَّنَ ألْفٌ':Predicate, #1: 1	عَيَّنَ الْأَلْفَ
u'عَيَّنَ أَلْفٌ':Predicate, #1: 1	عَيَّنَ الْأَلْفَ
u'عين ألف':Added, #1: 1	عَيَّنَ الْأَلْفَ
u'عين ألْفٌ':Added, #1: 1	عَيْنِ الْأَلْفِ
u'عين أَلْفٌ':Added, #1: 1	عَيْنِ الْأَلْفِ
u'عَيْنٌ ألف':Added, #1: 1	عَيْنِ الْأَلْفِ
u'عَيْن ألف':Added, #1: 1	عَيْنِ الْأَلْفِ
u'عَيْنٌ ألْفٌ':Added, #1: 1	عَيْنِ الْأَلْفِ
u'عَيْن ألْفٌ':Added, #1: 1	عَيْنِ الْأَلْفِ
u'عَيْنٌ أَلْفٌ':Added, #1: 1	عَيْنِ الْأَلْفِ
u'عَيْن أَلْفٌ':Added, #1: 1	عَيْنِ الْأَلْفِ
u'عين الْمَرْأَةُ':Added, #1: 1	عَيْنِ الْأَلْفِ
u'عَيْنٌ الْمَرْأَةُ':Added, #2: 2	عَيْنَ الْمَرْأَةِ
u'عَيْن الْمَرْأَةُ':Added, #2: 2	عَيْنَ الْمَرْأَةِ
u'عَيَّنَ المُشْتَرِي':Predicate, #2: 2	عَيْنَ الْمَرْأَةِ
u'عين أُمٌّ':Added, #1: 1	عَيَّنَ الْمُشْتَرِيَ
u'عَيْنٌ أُمٌّ':Added, #1: 1	عَيْنَ الْأُمِّ
u'عَيْن أُمٌّ':Added, #1: 1	عَيْنَ الْأُمِّ
u'عين أُمٌّ':Added, #1: 1	عَيْنَ الْأُمِّ
u'عَيْنٌ أُمٌّ':Added, #1: 1	عَيْنِ أُمِّهِ
u'عَيْن أُمٌّ':Added, #1: 1	عَيْنِ أُمِّهِ
u'عَيَّنَ إمَامٌ':Subject, #1: 1	عَيْنِ أُمِّهِ
u'عين إمَامٌ':Added, #3: 3	عَيَّنَ الْإِمَامُ
u'عَيْنٌ إمَامٌ':Added, #1: 1	عَيْنِ الْإِمَامِ
u'عَيْن إمَامٌ':Added, #1: 1	عَيْنِ الْإِمَامِ
u'عين أمَةٌ':Added, #1: 1	عَيْنِ الْإِمَامِ
u'عَيْنٌ أمَةٌ':Added, #1: 1	عَيْنَ الْأَمَةِ
u'عَيْن أمَةٌ':Added, #1: 1	عَيْنَ الْأَمَةِ
u'عين أمَةٌ':Added, #1: 1	عَيْنَ الْأَمَةِ
u'عَيْنٌ أمَةٌ':Added, #2: 2	عَيْنِ الْأَمَةِ
u'عَيْن أمَةٌ':Added, #2: 2	عَيْنِ الْأَمَةِ
u'عين أَمْرٌ':Added, #2: 2	عَيْنِ الْأَمَةِ
u'عين أَمْرٌ':Added, #1: 1	عَيْنَ الْأَمْرِ
u'عَيْنٌ أَمْرٌ':Added, #1: 1	عَيْنِ الْأَمْرِ
u'عَيْنٌ أَمْرٌ':Added, #1: 1	عَيْنَ الْأَمْرِ
u'عَيْن أَمْرٌ':Added, #1: 1	عَيْنِ الْأَمْرِ
u'عَيْن أَمْرٌ':Added, #1: 1	عَيْنَ الْأَمْرِ
u'عين اِمْرَأَةٌ':Added, #1: 1	عَيْنِ الْأَمْرِ
u'عَيْنٌ اِمْرَأَةٌ':Added, #1: 1	عَيْنِ امْرَأَةٍ
u'عَيْن اِمْرَأَةٌ':Added, #1: 1	عَيْنِ امْرَأَةٍ
u'عين اِمْرَأَةٌ':Added, #1: 1	عَيْنِ امْرَأَةٍ
u'عَيْنٌ اِمْرَأَةٌ':Added, #1: 1	عَيْنَ امْرَأَتِهِ
u'عَيْن اِمْرَأَةٌ':Added, #1: 1	عَيْنَ امْرَأَتِهِ
u'عين اِمْرَأَةٌ':Added, #1: 1	عَيْنَ امْرَأَتِهِ
u'عَيْنٌ اِمْرَأَةٌ':Added, #2: 2	عَيْنُ امْرَأَةٍ
u'عَيْن اِمْرَأَةٌ':Added, #2: 2	عَيْنُ امْرَأَةٍ
u'عين أُمَّهَاتٌ':Added, #2: 2	عَيْنُ امْرَأَةٍ
u'عَيْنٌ أُمَّهَاتٌ':Added, #1: 1	عَيْنِ الْأُمَّهَاتِ
u'عَيْن أُمَّهَاتٌ':Added, #1: 1	عَيْنِ الْأُمَّهَاتِ
u'عين إِنْسانٌ':Added, #1: 1	عَيْنِ الْأُمَّهَاتِ
u'عين إِنْسانٌ':Added, #1: 1	عَيْنُ إنْسَانٍ
u'عَيْنٌ إِنْسانٌ':Added, #1: 1	عَيْنِ إنْسَانٍ
u'عَيْنٌ إِنْسانٌ':Added, #1: 1	عَيْنُ إنْسَانٍ
u'عَيْن إِنْسانٌ':Added, #1: 1	عَيْنِ إنْسَانٍ
u'عَيْن إِنْسانٌ':Added, #1: 1	عَيْنُ إنْسَانٍ
u'عين إِنْسانٌ':Added, #1: 1	عَيْنِ إنْسَانٍ
u'عَيْنٌ إِنْسانٌ':Added, #2: 2	عَيْنِ الْإِنْسَانِ
u'عَيْن إِنْسانٌ':Added, #2: 2	عَيْنِ الْإِنْسَانِ
u'عين إِنْسانٌ':Added, #2: 2	عَيْنِ الْإِنْسَانِ
u'عَيْنٌ إِنْسانٌ':Added, #6: 6	عَيْنَ إنْسَانٍ
u'عَيْن إِنْسانٌ':Added, #6: 6	عَيْنَ إنْسَانٍ
u'عين أنصار':Added, #6: 6	عَيْنَ إنْسَانٍ
u'عين أَنْصارٌ':Added, #1: 1	أَعْيُنِ الأَنْصَارِ
u'عين أَنْصَارٌ':Added, #1: 1	أَعْيُنِ الأَنْصَارِ
u'عين أنصار':Added, #1: 1	أَعْيُنِ الأَنْصَارِ
u'عين أَنْصارٌ':Added, #1: 1	عَيْنِ الأَنْصَارِ
u'عين أَنْصَارٌ':Added, #1: 1	عَيْنِ الأَنْصَارِ
u'عَيْنٌ أنصار':Added, #1: 1	عَيْنِ الأَنْصَارِ
u'عَيْن أنصار':Added, #1: 1	عَيْنِ الأَنْصَارِ
u'عَيْنٌ أَنْصارٌ':Added, #1: 1	عَيْنِ الأَنْصَارِ
u'عَيْن أَنْصارٌ':Added, #1: 1	عَيْنِ الأَنْصَارِ
u'عَيْنٌ أَنْصَارٌ':Added, #1: 1	عَيْنِ الأَنْصَارِ
u'عَيْن أَنْصَارٌ':Added, #1: 1	عَيْنِ الأَنْصَارِ
u'عين أَنْصَافٌ':Added, #1: 1	عَيْنِ الأَنْصَارِ
u'عَيْنٌ أَنْصَافٌ':Added, #1: 1	عَيْنُ الْأَنْصَافِ
u'عَيْن أَنْصَافٌ':Added, #1: 1	عَيْنُ الْأَنْصَافِ
u'عين إِنْصافٌ':Added, #1: 1	عَيْنُ الْأَنْصَافِ
u'عَيْنٌ إِنْصافٌ':Added, #3: 3	عَيْنُ الْإِنْصَافِ
u'عَيْن إِنْصافٌ':Added, #3: 3	عَيْنُ الْإِنْصَافِ
u'عَيَّنَ أَنْفٌ':Predicate, #3: 3	عَيْنُ الْإِنْصَافِ
u'عَيَّنَ أوْسَطُ':Predicate, #1: 1	عَيَّنَ الْأَنْفَ
u'عَيَّنَ أَوَّلُ':Predicate, #1: 1	عَيَّنَ الْأَوْسَطَ
u'عين أَوَّلُ':Added, #1: 1	عَيَّنَ الْأَوَّلَ
u'عَيْنٌ أَوَّلُ':Added, #10: 10	عَيْنُ الْأَوَّلِ
u'عَيْن أَوَّلُ':Added, #10: 10	عَيْنُ الْأَوَّلِ
u'عين أَوَّلُ':Added, #10: 10	عَيْنُ الْأَوَّلِ
u'عَيْنٌ أَوَّلُ':Added, #17: 17	عَيْنَ الْأَوَّلِ
u'عَيْن أَوَّلُ':Added, #17: 17	عَيْنَ الْأَوَّلِ
u'عَيَّنَ أَوْلاَدٌ':Predicate, #17: 17	عَيْنَ الْأَوَّلِ
u'عين أئِمَّةٌ':Added, #1: 1	عَيَّنَ الْأَوْلَادَ
u'عَيْنٌ أئِمَّةٌ':Added, #10: 10	عَيْنُ الْأَئِمَّةِ
u'عَيْن أئِمَّةٌ':Added, #10: 10	عَيْنُ الْأَئِمَّةِ
u'عين آيَةٌ':Added, #10: 10	عَيْنُ الْأَئِمَّةِ
u'عَيْنٌ آيَةٌ':Added, #1: 1	عَيْنَ الْآيَةِ
u'عَيْن آيَةٌ':Added, #1: 1	عَيْنَ الْآيَةِ
u'عَيَّنَ بَابٌ':Predicate, #1: 1	عَيْنَ الْآيَةِ
u'عين بَاصِرٌ':Added, #1: 1	عَيَّنَ الْبَابَ
u'عَيْنٌ بَاصِرٌ':Added, #1: 1	عَيْنُ الْبَاصِرَةِ
u'عَيْن بَاصِرٌ':Added, #1: 1	عَيْنُ الْبَاصِرَةِ
u'عَيَّنَ بَائِعٌ':Predicate, #1: 1	عَيْنُ الْبَاصِرَةِ
u'عَيَّنَ بَائِعٌ':Subject, #7: 7	عَيَّنَ الْبَائِعَ
u'عين بِدْعَةٌ':Added, #4: 4	عَيَّنَ الْبَائِعُ
u'عَيْنٌ بِدْعَةٌ':Added, #6: 6	عَيْنُ الْبِدْعَةِ
u'عَيْن بِدْعَةٌ':Added, #6: 6	عَيْنُ الْبِدْعَةِ
u'عين بدنة':Added, #6: 6	عَيْنُ الْبِدْعَةِ
u'عَيْنٌ بدنة':Added, #2: 2	عَيْنِ بَدَنَةِ
u'عَيْن بدنة':Added, #2: 2	عَيْنِ بَدَنَةِ
u'عين بَراءةٌ':Added, #2: 2	عَيْنِ بَدَنَةِ
u'عَيْنٌ بَراءةٌ':Added, #1: 1	عَيْنِ الْبَرَاءَةِ
u'عَيْن بَراءةٌ':Added, #1: 1	عَيْنِ الْبَرَاءَةِ
u'عين بِرْذَوْنٌ':Added, #1: 1	عَيْنِ الْبَرَاءَةِ
u'عَيْنٌ بِرْذَوْنٌ':Added, #1: 1	عَيْنِ الْبِرْذَوْنِ
u'عَيْن بِرْذَوْنٌ':Added, #1: 1	عَيْنِ الْبِرْذَوْنِ
u'عين بِرْذَوْنٌ':Added, #1: 1	عَيْنِ الْبِرْذَوْنِ
u'عَيْنٌ بِرْذَوْنٌ':Added, #2: 2	عَيْنَ بِرْذَوْنٍ
u'عَيْن بِرْذَوْنٌ':Added, #2: 2	عَيْنَ بِرْذَوْنٍ
u'عَيَّنَ بُسْرٌ':Predicate, #2: 2	عَيْنَ بِرْذَوْنٍ
u'عين بَصيرٌ':Added, #1: 1	عَيَّنَ الْبُسْرَ
u'عَيْنٌ بَصيرٌ':Added, #1: 1	عَيْنَ الْبَصِيرَةِ
u'عَيْن بَصيرٌ':Added, #1: 1	عَيْنَ الْبَصِيرَةِ
u'عين بَصيرَةٌ':Added, #1: 1	عَيْنَ الْبَصِيرَةِ
u'عَيْنٌ بَصيرَةٌ':Added, #1: 1	عَيْنَ الْبَصِيرَةِ
u'عَيْن بَصيرَةٌ':Added, #1: 1	عَيْنَ الْبَصِيرَةِ
u'عَيَّنَ بَعْضٌ':Predicate, #1: 1	عَيْنَ الْبَصِيرَةِ
u'عَيَّنَ بَعْضٌ':Subject, #1: 1	عَيَّنَ الْبَعْضَ
u'عين بَغْلٌ':Added, #1: 1	عَيَّنَ بَعْضُ
u'عَيْنٌ بَغْلٌ':Added, #1: 1	عَيْنِ الْبَغْلِ
u'عَيْن بَغْلٌ':Added, #1: 1	عَيْنِ الْبَغْلِ
u'عين بَقَرٌ':Added, #1: 1	عَيْنِ الْبَغْلِ
u'عَيْنٌ بَقَرٌ':Added, #1: 1	عَيْنِ الْبَقَرِ
u'عَيْن بَقَرٌ':Added, #1: 1	عَيْنِ الْبَقَرِ
u'عين بَقَرٌ':Added, #1: 1	عَيْنِ الْبَقَرِ
u'عَيْنٌ بَقَرٌ':Added, #3: 3	عَيْنِ بَقَرَةِ
u'عَيْن بَقَرٌ':Added, #3: 3	عَيْنِ بَقَرَةِ
u'عين بُقْعَةٌ':Added, #3: 3	عَيْنِ بَقَرَةِ
u'عَيْنٌ بُقْعَةٌ':Added, #2: 2	عَيْنِ الْبُقْعَةِ
u'عَيْن بُقْعَةٌ':Added, #2: 2	عَيْنِ الْبُقْعَةِ
u'عين بِنْتٌ':Added, #2: 2	عَيْنِ الْبُقْعَةِ
u'عَيْنٌ بِنْتٌ':Added, #1: 1	عَيْنَ الْبِنْتِ
u'عَيْن بِنْتٌ':Added, #1: 1	عَيْنَ الْبِنْتِ
u'عين بَنَفْسَجٌ':Added, #1: 1	عَيْنَ الْبِنْتِ
u'عَيْنٌ بَنَفْسَجٌ':Added, #1: 1	عَيْنِ الْبَنَفْسَجِ
u'عَيْن بَنَفْسَجٌ':Added, #1: 1	عَيْنِ الْبَنَفْسَجِ
u'عين بِئْرٌ':Added, #1: 1	عَيْنِ الْبَنَفْسَجِ
u'عَيْنٌ بِئْرٌ':Added, #1: 1	عَيْنِ الْبِئْرِ
u'عَيْن بِئْرٌ':Added, #1: 1	عَيْنِ الْبِئْرِ
u'عين بَيَانٌ':Added, #1: 1	عَيْنِ الْبِئْرِ
u'عَيْنٌ بَيَانٌ':Added, #1: 1	عَيْنُ الْبَيَانِ
u'عَيْن بَيَانٌ':Added, #1: 1	عَيْنُ الْبَيَانِ
u'عَيَّنَ بَيْتٌ':Predicate, #1: 1	عَيْنُ الْبَيَانِ
u'عين بَيْتٌ':Added, #1: 1	عَيَّنَ الْبَيْتَ
u'عَيْنٌ بَيْتٌ':Added, #1: 1	عَيْنُ الْبَيْتِ
u'عَيْن بَيْتٌ':Added, #1: 1	عَيْنُ الْبَيْتِ
u'عين بَيْتٌ':Added, #1: 1	عَيْنُ الْبَيْتِ
u'عَيْنٌ بَيْتٌ':Added, #2: 2	عَيْنَ الْبَيْتِ
u'عَيْن بَيْتٌ':Added, #2: 2	عَيْنَ الْبَيْتِ
u'عَيَّنَ بَيْعٌ':Predicate, #2: 2	عَيْنَ الْبَيْتِ
u'عين بَيْعٌ':Added, #1: 1	عَيَّنَ الْبَيْعَ
u'عَيْنٌ بَيْعٌ':Added, #1: 1	عَيْنُ الْبَيْعِ
u'عَيْن بَيْعٌ':Added, #1: 1	عَيْنُ الْبَيْعِ
u'عين بَيْعٌ':Added, #1: 1	عَيْنُ الْبَيْعِ
u'عَيْنٌ بَيْعٌ':Added, #1: 1	عَيْنُ بَيْعِ
u'عَيْن بَيْعٌ':Added, #1: 1	عَيْنُ بَيْعِ
u'عين بَيْعٌ':Added, #1: 1	عَيْنُ بَيْعِ
u'عَيْنٌ بَيْعٌ':Added, #1: 1	عَيْنُ بَيْعِهِ
u'عَيْن بَيْعٌ':Added, #1: 1	عَيْنُ بَيْعِهِ
u'عين تَأْسِيسٌ':Added, #1: 1	عَيْنُ بَيْعِهِ
u'عَيْنٌ تَأْسِيسٌ':Added, #1: 1	عَيْنُ التَّأْسِيسِ
u'عَيْن تَأْسِيسٌ':Added, #1: 1	عَيْنُ التَّأْسِيسِ
u'عين تَبِيع':Added, #1: 1	عَيْنُ التَّأْسِيسِ
u'عَيْنٌ تَبِيع':Added, #1: 1	عَيْنَ التَّبِيعِ
u'عَيْن تَبِيع':Added, #1: 1	عَيْنَ التَّبِيعِ
u'عين تَحْرِيمٌ':Added, #1: 1	عَيْنَ التَّبِيعِ
u'عين تَحْرِيمٌ':Added, #1: 1	عَيْنَ التَّحْرِيمِ
u'عَيْنٌ تَحْرِيمٌ':Added, #1: 1	عَيْنِ التَّحْرِيمِ
u'عَيْنٌ تَحْرِيمٌ':Added, #1: 1	عَيْنَ التَّحْرِيمِ
u'عَيْن تَحْرِيمٌ':Added, #1: 1	عَيْنِ التَّحْرِيمِ
u'عَيْن تَحْرِيمٌ':Added, #1: 1	عَيْنَ التَّحْرِيمِ
u'عين تَحْسِين':Added, #1: 1	عَيْنِ التَّحْرِيمِ
u'عَيْنٌ تَحْسِين':Added, #1: 1	عَيْنُ التَّحْسِينِ
u'عَيْن تَحْسِين':Added, #1: 1	عَيْنُ التَّحْسِينِ
u'عين تَحَكُّمٌ':Added, #1: 1	عَيْنُ التَّحْسِينِ
u'عَيْنٌ تَحَكُّمٌ':Added, #1: 1	عَيْنَ التَّحَكُّمِ
u'عَيْن تَحَكُّمٌ':Added, #1: 1	عَيْنَ التَّحَكُّمِ
u'عين تَدْلِيس':Added, #1: 1	عَيْنَ التَّحَكُّمِ
u'عَيْنٌ تَدْلِيس':Added, #1: 1	عَيْنُ التَّدْلِيسِ
u'عَيْن تَدْلِيس':Added, #1: 1	عَيْنُ التَّدْلِيسِ
u'عين تَرْكٌ':Added, #1: 1	عَيْنُ التَّدْلِيسِ
u'عَيْنٌ تَرْكٌ':Added, #1: 1	عَيْنُ تَرْكِ
u'عَيْن تَرْكٌ':Added, #1: 1	عَيْنُ تَرْكِ
u'عين تَرِكَةٌ':Added, #1: 1	عَيْنُ تَرْكِ
u'عَيْنٌ تَرِكَةٌ':Added, #1: 1	عَيْنُ تَرِكَةٍ
u'عَيْن تَرِكَةٌ':Added, #1: 1	عَيْنُ تَرِكَةٍ
u'عين تَرِكَةٌ':Added, #1: 1	عَيْنُ تَرِكَةٍ
u'عَيْنٌ تَرِكَةٌ':Added, #2: 2	عَيْنَ التَّرِكَةِ
u'عَيْن تَرِكَةٌ':Added, #2: 2	عَيْنَ التَّرِكَةِ
u'عين تَرِكَةٌ':Added, #2: 2	عَيْنَ التَّرِكَةِ
u'عَيْنٌ تَرِكَةٌ':Added, #8: 8	عَيْنِ التَّرِكَةِ
u'عَيْن تَرِكَةٌ':Added, #8: 8	عَيْنِ التَّرِكَةِ
u'عين تَضْيِيقٌ':Added, #8: 8	عَيْنِ التَّرِكَةِ
u'عَيْنٌ تَضْيِيقٌ':Added, #1: 1	عَيْنُ التَّضْيِيقِ
u'عَيْن تَضْيِيقٌ':Added, #1: 1	عَيْنُ التَّضْيِيقِ
u'عين تَعَذُّرٌ':Added, #1: 1	عَيْنُ التَّضْيِيقِ
u'عَيْنٌ تَعَذُّرٌ':Added, #1: 1	عَيْنُ تَعَذُّرِ
u'عَيْن تَعَذُّرٌ':Added, #1: 1	عَيْنُ تَعَذُّرِ
u'عين تَكْبيرٌ':Added, #1: 1	عَيْنُ تَعَذُّرِ
u'عَيْنٌ تَكْبيرٌ':Added, #1: 1	عَيْنَ التَّكْبِيرِ
u'عَيْن تَكْبيرٌ':Added, #1: 1	عَيْنَ التَّكْبِيرِ
u'عين تَكْليفٌ':Added, #1: 1	عَيْنَ التَّكْبِيرِ
u'عَيْنٌ تَكْليفٌ':Added, #1: 1	عَيْنُ التَّكْلِيفِ
u'عَيْن تَكْليفٌ':Added, #1: 1	عَيْنُ التَّكْلِيفِ
u'عين تَلَفٌ':Added, #1: 1	عَيْنُ التَّكْلِيفِ
u'عَيْنٌ تَلَفٌ':Added, #1: 1	عَيْنُ تَلَفِهِ
u'عَيْن تَلَفٌ':Added, #1: 1	عَيْنُ تَلَفِهِ
u'عين تَلَفُّظٌ':Added, #1: 1	عَيْنُ تَلَفِهِ
u'عَيْنٌ تَلَفُّظٌ':Added, #1: 1	عَيْنُ التَّلَفُّظِ
u'عَيْن تَلَفُّظٌ':Added, #1: 1	عَيْنُ التَّلَفُّظِ
u'عَيَّنَ تَمَتُّعٌ':Predicate, #1: 1	عَيْنُ التَّلَفُّظِ
u'عين تَمْر':Added, #1: 1	عَيَّنَ التَّمَتُّعَ
u'عَيْنٌ تَمْر':Added, #1: 1	عَيْنِ التّمْرِ
u'عَيْن تَمْر':Added, #1: 1	عَيْنِ التّمْرِ
u'عين تَمْر':Added, #1: 1	عَيْنِ التّمْرِ
u'عَيْنٌ تَمْر':Added, #3: 3	عَيْنِ التَّمْرِ
u'عَيْن تَمْر':Added, #3: 3	عَيْنِ التَّمْرِ
u'عين تَمْرَةٌ':Added, #3: 3	عَيْنِ التَّمْرِ
u'عَيْنٌ تَمْرَةٌ':Added, #1: 1	عَيْنَ التَّمْرَةِ
u'عَيْن تَمْرَةٌ':Added, #1: 1	عَيْنَ التَّمْرَةِ
u'عَيَّنَ تَوْقِيت':Predicate, #1: 1	عَيْنَ التَّمْرَةِ
u'عين ثَابِتٌ':Added, #1: 1	عَيَّنَ التَّوْقِيتَ
u'عَيْنٌ ثَابِتٌ':Added, #2: 2	عَيْنُ الثَّابِتِ
u'عَيْن ثَابِتٌ':Added, #2: 2	عَيْنُ الثَّابِتِ
u'عَيَّنَ ثَالِثٌ':Predicate, #2: 2	عَيْنُ الثَّابِتِ
u'عين ثَانِي':Added, #1: 1	عَيَّنَ الثَّالِثَةَ
u'عَيْنٌ ثَانِي':Added, #2: 2	عَيْنُ الثَّانِيَةِ
u'عَيْن ثَانِي':Added, #2: 2	عَيْنُ الثَّانِيَةِ
u'عين ثَانِيَةٌ':Added, #2: 2	عَيْنُ الثَّانِيَةِ
u'عَيْنٌ ثَانِيَةٌ':Added, #2: 2	عَيْنُ الثَّانِيَةِ
u'عَيْن ثَانِيَةٌ':Added, #2: 2	عَيْنُ الثَّانِيَةِ
u'عين ثُبُوتٌ':Added, #2: 2	عَيْنُ الثَّانِيَةِ
u'عَيْنٌ ثُبُوتٌ':Added, #1: 1	عَيْنَ الثُّبُوتِ
u'عَيْن ثُبُوتٌ':Added, #1: 1	عَيْنَ الثُّبُوتِ
u'عين ثَرِيدٌ':Added, #1: 1	عَيْنَ الثُّبُوتِ
u'عَيْنٌ ثَرِيدٌ':Added, #1: 1	عَيْنَ الثَّرِيدِ
u'عَيْن ثَرِيدٌ':Added, #1: 1	عَيْنَ الثَّرِيدِ
u'عين ثَلاثُ':Added, #1: 1	عَيْنَ الثَّرِيدِ
u'عَيْنٌ ثَلاثُ':Added, #1: 1	عَيْنَ الثَّلَاثِ
u'عَيْن ثَلاثُ':Added, #1: 1	عَيْنَ الثَّلَاثِ
u'عين ثَلْجٌ':Added, #1: 1	عَيْنَ الثَّلَاثِ
u'عَيْنٌ ثَلْجٌ':Added, #1: 1	عَيْنُ ثَلْجِهِ
u'عَيْن ثَلْجٌ':Added, #1: 1	عَيْنُ ثَلْجِهِ
u'عين ثَمَرَةٌ':Added, #1: 1	عَيْنُ ثَلْجِهِ
u'عَيْنٌ ثَمَرَةٌ':Added, #1: 1	عَيْنَ الثَّمَرَةِ
u'عَيْن ثَمَرَةٌ':Added, #1: 1	عَيْنَ الثَّمَرَةِ
u'عَيَّنَ ثَمَنٌ':Predicate, #1: 1	عَيْنَ الثَّمَرَةِ
u'عين ثَمَنٌ':Added, #2: 2	عَيَّنَ الثَّمَنَ
u'عين ثَمَنٌ':Added, #1: 1	عَيْنَ الثَّمَنِ
u'عَيْنٌ ثَمَنٌ':Added, #1: 1	عَيْنُ الثَّمَنِ
u'عَيْنٌ ثَمَنٌ':Added, #1: 1	عَيْنَ الثَّمَنِ
u'عَيْن ثَمَنٌ':Added, #1: 1	عَيْنُ الثَّمَنِ
u'عَيْن ثَمَنٌ':Added, #1: 1	عَيْنَ الثَّمَنِ
u'عين ثَمَنٌ':Added, #1: 1	عَيْنُ الثَّمَنِ
u'عَيْنٌ ثَمَنٌ':Added, #1: 1	عَيْنُ ثَمَنِهِ
u'عَيْن ثَمَنٌ':Added, #1: 1	عَيْنُ ثَمَنِهِ
u'عين ثَمَنٌ':Added, #1: 1	عَيْنُ ثَمَنِهِ
u'عَيْنٌ ثَمَنٌ':Added, #9: 9	عَيْنِ الثَّمَنِ
u'عَيْن ثَمَنٌ':Added, #9: 9	عَيْنِ الثَّمَنِ
u'عين ثَوابٌ':Added, #9: 9	عَيْنِ الثَّمَنِ
u'عَيْنٌ ثَوابٌ':Added, #1: 1	عَيْنِ ثَوَابِ
u'عَيْن ثَوابٌ':Added, #1: 1	عَيْنِ ثَوَابِ
u'عين ثَوْبٌ':Added, #1: 1	عَيْنِ ثَوَابِ
u'عَيْنٌ ثَوْبٌ':Added, #1: 1	عَيْنُ الثَّوْبِ
u'عَيْن ثَوْبٌ':Added, #1: 1	عَيْنُ الثَّوْبِ
u'عين ثَوْبٌ':Added, #1: 1	عَيْنُ الثَّوْبِ
u'عَيْنٌ ثَوْبٌ':Added, #2: 2	عَيْنِ الثَّوْبِ
u'عَيْن ثَوْبٌ':Added, #2: 2	عَيْنِ الثَّوْبِ
u'عين ثَوْبٌ':Added, #2: 2	عَيْنِ الثَّوْبِ
u'عَيْنٌ ثَوْبٌ':Added, #3: 3	عَيْنَ الثَّوْبِ
u'عَيْن ثَوْبٌ':Added, #3: 3	عَيْنَ الثَّوْبِ
u'عَيَّنَ ثِيابٌ':Predicate, #3: 3	عَيْنَ الثَّوْبِ
u'عين جَارِي':Added, #3: 3	عَيَّنَ الثِّيَابَ
u'عَيْنٌ جَارِي':Added, #4: 4	عَيْنَ الْجَارِيَةِ
u'عَيْن جَارِي':Added, #4: 4	عَيْنَ الْجَارِيَةِ
u'عَيْنٌ جَارِيَةٌ':Added, #4: 4	عَيْنَ الْجَارِيَةِ
u'عَيْن جَارِيَةٌ':Added, #1: 1	عَيْنٍ جَارِيَةٍ
u'عين جَارِيَةٌ':Added, #1: 1	عَيْنٍ جَارِيَةٍ
u'عَيْنٌ جَارِيَةٌ':Added, #4: 4	عَيْنَ الْجَارِيَةِ
u'عَيْن جَارِيَةٌ':Added, #4: 4	عَيْنَ الْجَارِيَةِ
u'عَيَّنَ جَانِي':Predicate, #4: 4	عَيْنَ الْجَارِيَةِ
u'عَيَّنَ جَديدٌ':Predicate, #1: 1	عَيَّنَ الْجَانِيَ
u'عَيَّنَ جَدِيدٌ':Predicate, #1: 1	عَيَّنَ جَدِيدَ
u'عين جَعْدٌ':Added, #1: 1	عَيَّنَ جَدِيدَ
u'عَيْنٌ جَعْدٌ':Added, #1: 1	عَيْنِ جَعْدَةِ
u'عَيْن جَعْدٌ':Added, #1: 1	عَيْنِ جَعْدَةِ
u'عين جلد':Added, #1: 1	عَيْنِ جَعْدَةِ
u'عَيْنٌ جلد':Added, #1: 1	عَيْنُ جِلْدِ
u'عَيْن جلد':Added, #1: 1	عَيْنُ جِلْدِ
u'عين جِلْدٌ':Added, #1: 1	عَيْنُ جِلْدِ
u'عَيْنٌ جِلْدٌ':Added, #1: 1	عَيْنُ جِلْدِ
u'عَيْن جِلْدٌ':Added, #1: 1	عَيْنُ جِلْدِ
u'عين جماع':Added, #1: 1	عَيْنُ جِلْدِ
u'عَيْنٌ جماع':Added, #1: 1	عَيْنُ الْجِمَاعِ
u'عَيْن جماع':Added, #1: 1	عَيْنُ الْجِمَاعِ
u'عين جِمَاعٌ':Added, #1: 1	عَيْنُ الْجِمَاعِ
u'عَيْنٌ جِمَاعٌ':Added, #1: 1	عَيْنُ الْجِمَاعِ
u'عَيْن جِمَاعٌ':Added, #1: 1	عَيْنُ الْجِمَاعِ
u'عين جَمَاعَةٌ':Added, #1: 1	عَيْنُ الْجِمَاعِ
u'عَيْنٌ جَمَاعَةٌ':Added, #1: 1	عَيْنَ جَمَاعَةٍ
u'عَيْن جَمَاعَةٌ':Added, #1: 1	عَيْنَ جَمَاعَةٍ
u'عين جمع':Added, #1: 1	عَيْنَ جَمَاعَةٍ
u'عَيْنٌ جمع':Added, #1: 1	عَيْنِ الْجَمْعِ
u'عَيْن جمع':Added, #1: 1	عَيْنِ الْجَمْعِ
u'عين جَمْعٌ':Added, #1: 1	عَيْنِ الْجَمْعِ
u'عَيْنٌ جَمْعٌ':Added, #1: 1	عَيْنِ الْجَمْعِ
u'عَيْن جَمْعٌ':Added, #1: 1	عَيْنِ الْجَمْعِ
u'عين جمع':Added, #1: 1	عَيْنِ الْجَمْعِ
u'عَيْنٌ جمع':Added, #1: 1	عَيْنُ جَمْعِ
u'عَيْن جمع':Added, #1: 1	عَيْنُ جَمْعِ
u'عين جَمْعٌ':Added, #1: 1	عَيْنُ جَمْعِ
u'عَيْنٌ جَمْعٌ':Added, #1: 1	عَيْنُ جَمْعِ
u'عَيْن جَمْعٌ':Added, #1: 1	عَيْنُ جَمْعِ
u'عين جمع':Added, #1: 1	عَيْنُ جَمْعِ
u'عَيْنٌ جمع':Added, #2: 2	عَيْنُ الْجَمْعِ
u'عَيْن جمع':Added, #2: 2	عَيْنُ الْجَمْعِ
u'عين جَمْعٌ':Added, #2: 2	عَيْنُ الْجَمْعِ
u'عَيْنٌ جَمْعٌ':Added, #2: 2	عَيْنُ الْجَمْعِ
u'عَيْن جَمْعٌ':Added, #2: 2	عَيْنُ الْجَمْعِ
u'عَيَّنَ جِنْسٌ':Predicate, #2: 2	عَيْنُ الْجَمْعِ
u'عين جِنْسٌ':Added, #1: 1	عَيَّنَ الْجِنْسَ
u'عَيْنٌ جِنْسٌ':Added, #1: 1	عَيْنِ جِنْسِهِ
u'عَيْن جِنْسٌ':Added, #1: 1	عَيْنِ جِنْسِهِ
u'عَيَّنَ جِهَةٌ':Predicate, #1: 1	عَيْنِ جِنْسِهِ
u'عَيَّنَ جِهَةٌ':Predicate, #3: 3	عَيَّنَ جِهَةَ
u'عين حاجِبٌ':Added, #5: 5	عَيَّنَ الْجِهَةَ
u'عَيْنٌ حاجِبٌ':Added, #1: 1	عَيْنِ حَاجِبٍ
u'عَيْن حاجِبٌ':Added, #1: 1	عَيْنِ حَاجِبٍ
u'عين حارِسٌ':Added, #1: 1	عَيْنِ حَاجِبٍ
u'عَيْنٌ حارِسٌ':Added, #1: 1	عَيْنِ الْحَارِسِ
u'عَيْن حارِسٌ':Added, #1: 1	عَيْنِ الْحَارِسِ
u'عين حاضِرٌ':Added, #1: 1	عَيْنِ الْحَارِسِ
u'عَيْنٌ حاضِرٌ':Added, #1: 1	عَيْنِ حَاضِرٍ
u'عَيْن حاضِرٌ':Added, #1: 1	عَيْنِ حَاضِرٍ
u'عين حافِظٌ':Added, #1: 1	عَيْنِ حَاضِرٍ
u'عَيْنٌ حافِظٌ':Added, #1: 1	عَيْنِ الْحَافِظِ
u'عَيْن حافِظٌ':Added, #1: 1	عَيْنِ الْحَافِظِ
u'عَيَّنَ حاكِمٌ':Subject, #1: 1	عَيْنِ الْحَافِظِ
u'عَيَّنَ حاكِمٌ':Subject, #1: 1	عَيَّنَ حَاكِمٌ
u'عين حائِضٌ':Added, #2: 2	عَيَّنَ الْحَاكِمُ
u'عَيْنٌ حائِضٌ':Added, #1: 1	عَيْنِ الْحَائِضِ
u'عَيْن حائِضٌ':Added, #1: 1	عَيْنِ الْحَائِضِ
u'عين حُجَّةٌ':Added, #1: 1	عَيْنِ الْحَائِضِ
u'عَيْنٌ حُجَّةٌ':Added, #1: 1	عَيْنِ الْحُجَّةِ
u'عَيْن حُجَّةٌ':Added, #1: 1	عَيْنِ الْحُجَّةِ
u'عين حَدَثٌ':Added, #1: 1	عَيْنِ الْحُجَّةِ
u'عَيْنٌ حَدَثٌ':Added, #2: 2	عَيْنِ الْحَدَثِ
u'عَيْن حَدَثٌ':Added, #2: 2	عَيْنِ الْحَدَثِ
u'عين حَديقَةٌ':Added, #2: 2	عَيْنِ الْحَدَثِ
u'عَيْنٌ حَديقَةٌ':Added, #1: 1	عَيْنِ الْحَدِيقَةِ
u'عَيْن حَديقَةٌ':Added, #1: 1	عَيْنِ الْحَدِيقَةِ
u'عين حُرٌّ':Added, #1: 1	عَيْنِ الْحَدِيقَةِ
u'عَيْنٌ حُرٌّ':Added, #1: 1	عَيْنِ حُرَّةٍ
u'عَيْن حُرٌّ':Added, #1: 1	عَيْنِ حُرَّةٍ
u'عين حَرامٌ':Added, #1: 1	عَيْنِ حُرَّةٍ
u'عَيْنٌ حَرامٌ':Added, #2: 2	عَيْنَ الْحَرَامِ
u'عَيْن حَرامٌ':Added, #2: 2	عَيْنَ الْحَرَامِ
u'عين حَرَجٌ':Added, #2: 2	عَيْنَ الْحَرَامِ
u'عَيْنٌ حَرَجٌ':Added, #1: 1	عَيْنُ حَرَجِ
u'عَيْن حَرَجٌ':Added, #1: 1	عَيْنُ حَرَجِ
u'عَيَّنَ حُروفٌ':Predicate, #1: 1	عَيْنُ حَرَجِ
u'عين حُسْنٌ':Added, #1: 1	عَيَّنَ حُرُوفَ
u'عَيْنٌ حُسْنٌ':Added, #1: 1	عَيْنُ الْحُسْنِ
u'عَيْن حُسْنٌ':Added, #1: 1	عَيْنُ الْحُسْنِ
u'عين حِصَّةٌ':Added, #1: 1	عَيْنُ الْحُسْنِ
u'عَيْنٌ حِصَّةٌ':Added, #1: 1	عَيْنُ حِصَّةِ
u'عَيْن حِصَّةٌ':Added, #1: 1	عَيْنُ حِصَّةِ
u'عين حَصىً':Added, #1: 1	عَيْنُ حِصَّةِ
u'عَيْنٌ حَصىً':Added, #1: 1	عَيْنُ الْحَصَيَاتِ
u'عَيْن حَصىً':Added, #1: 1	عَيْنُ الْحَصَيَاتِ
u'عين حَصَياتٌ':Added, #1: 1	عَيْنُ الْحَصَيَاتِ
u'عين حَصَيَاتٌ':Added, #1: 1	عَيْنُ الْحَصَيَاتِ
u'عَيْنٌ حَصَياتٌ':Added, #1: 1	عَيْنُ الْحَصَيَاتِ
u'عَيْن حَصَياتٌ':Added, #1: 1	عَيْنُ الْحَصَيَاتِ
u'عَيْنٌ حَصَيَاتٌ':Added, #1: 1	عَيْنُ الْحَصَيَاتِ
u'عَيْن حَصَيَاتٌ':Added, #1: 1	عَيْنُ الْحَصَيَاتِ
u'عين حَقٌّ':Added, #1: 1	عَيْنُ الْحَصَيَاتِ
u'عَيْنٌ حَقٌّ':Added, #15: 15	عَيْنِ حَقِّهِ
u'عَيْن حَقٌّ':Added, #15: 15	عَيْنِ حَقِّهِ
u'عين حَقٌّ':Added, #15: 15	عَيْنِ حَقِّهِ
u'عين حَقٌّ':Added, #1: 1	عَيْنَ حَقٍّ
u'عَيْنٌ حَقٌّ':Added, #1: 1	عَيْنُ حَقِّ
u'عَيْنٌ حَقٌّ':Added, #1: 1	عَيْنَ حَقٍّ
u'عَيْن حَقٌّ':Added, #1: 1	عَيْنُ حَقِّ
u'عَيْن حَقٌّ':Added, #1: 1	عَيْنَ حَقٍّ
u'عين حَقٌّ':Added, #1: 1	عَيْنُ حَقِّ
u'عَيْنٌ حَقٌّ':Added, #2: 2	عَيْنَ الْحَقِّ
u'عَيْن حَقٌّ':Added, #2: 2	عَيْنَ الْحَقِّ
u'عين حَقٌّ':Added, #2: 2	عَيْنَ الْحَقِّ
u'عَيْنٌ حَقٌّ':Added, #2: 2	عَيْنِ حَقِّ
u'عَيْن حَقٌّ':Added, #2: 2	عَيْنِ حَقِّ
u'عين حَقٌّ':Added, #2: 2	عَيْنِ حَقِّ
u'عَيْنٌ حَقٌّ':Added, #3: 3	عَيْنِ الْحَقِّ
u'عَيْن حَقٌّ':Added, #3: 3	عَيْنِ الْحَقِّ
u'عين حَقٌّ':Added, #3: 3	عَيْنِ الْحَقِّ
u'عَيْنٌ حَقٌّ':Added, #7: 7	عَيْنَ حَقِّهِ
u'عَيْن حَقٌّ':Added, #7: 7	عَيْنَ حَقِّهِ
u'عين حَقٌّ':Added, #7: 7	عَيْنَ حَقِّهِ
u'عَيْنٌ حَقٌّ':Added, #8: 8	عَيْنُ حَقِّهِ
u'عَيْن حَقٌّ':Added, #8: 8	عَيْنُ حَقِّهِ
u'عين حَقِيقٌ':Added, #8: 8	عَيْنُ حَقِّهِ
u'عَيْنٌ حَقِيقٌ':Added, #1: 1	عَيْنُ حَقِيقَةِ
u'عَيْن حَقِيقٌ':Added, #1: 1	عَيْنُ حَقِيقَةِ
u'عين حَقِيقَةٌ':Added, #1: 1	عَيْنُ حَقِيقَةِ
u'عَيْنٌ حَقِيقَةٌ':Added, #1: 1	عَيْنُ حَقِيقَةِ
u'عَيْن حَقِيقَةٌ':Added, #1: 1	عَيْنُ حَقِيقَةِ
u'عين حُكْمٌ':Added, #1: 1	عَيْنُ حَقِيقَةِ
u'عَيْنٌ حُكْمٌ':Added, #1: 1	عَيْنَ الْحُكْمِ
u'عَيْن حُكْمٌ':Added, #1: 1	عَيْنَ الْحُكْمِ
u'عين حُكْمٌ':Added, #1: 1	عَيْنَ الْحُكْمِ
u'عَيْنٌ حُكْمٌ':Added, #1: 1	عَيْنِ حُكْمِهِ
u'عَيْن حُكْمٌ':Added, #1: 1	عَيْنِ حُكْمِهِ
u'عين حُكْمٌ':Added, #1: 1	عَيْنِ حُكْمِهِ
u'عَيْنٌ حُكْمٌ':Added, #2: 2	عَيْنُ الْحُكْمِ
u'عَيْن حُكْمٌ':Added, #2: 2	عَيْنُ الْحُكْمِ
u'عين حُكْمٌ':Added, #2: 2	عَيْنُ الْحُكْمِ
u'عَيْنٌ حُكْمٌ':Added, #2: 2	عَيْنِ حُكْمِ
u'عَيْن حُكْمٌ':Added, #2: 2	عَيْنِ حُكْمِ
u'عين حُكْمٌ':Added, #2: 2	عَيْنِ حُكْمِ
u'عَيْنٌ حُكْمٌ':Added, #44: 44	عَيْنِ الْحُكْمِ
u'عَيْن حُكْمٌ':Added, #44: 44	عَيْنِ الْحُكْمِ
u'عين حِمَارٌ':Added, #44: 44	عَيْنِ الْحُكْمِ
u'عَيْنٌ حِمَارٌ':Added, #1: 1	عَيْنِ الْحِمَارِ
u'عَيْن حِمَارٌ':Added, #1: 1	عَيْنِ الْحِمَارِ
u'عين حَمَّامِيٌّ':Added, #1: 1	عَيْنِ الْحِمَارِ
u'عَيْنٌ حَمَّامِيٌّ':Added, #1: 1	عَيْنِ الْحَمَّامِيَّةِ
u'عَيْن حَمَّامِيٌّ':Added, #1: 1	عَيْنِ الْحَمَّامِيَّةِ
u'عَيَّنَ حِنْطَةٌ':Predicate, #1: 1	عَيْنِ الْحَمَّامِيَّةِ
u'عين حِنْطَةٌ':Added, #1: 1	عَيَّنَ الْحِنْطَةَ
u'عين حِنْطَةٌ':Added, #2: 2	عَيْنُ الْحِنْطَةِ
u'عَيْنٌ حِنْطَةٌ':Added, #2: 2	عَيْنِ الْحِنْطَةِ
u'عَيْنٌ حِنْطَةٌ':Added, #2: 2	عَيْنُ الْحِنْطَةِ
u'عَيْن حِنْطَةٌ':Added, #2: 2	عَيْنِ الْحِنْطَةِ
u'عَيْن حِنْطَةٌ':Added, #2: 2	عَيْنُ الْحِنْطَةِ
u'عَيَّنَ حَيٌّ':Predicate, #2: 2	عَيْنِ الْحِنْطَةِ
u'عين حَيَاةٌ':Added, #1: 1	عَيَّنَ الْحَيَّةَ
u'عين حَيَاةٌ':Added, #1: 1	عَيْنَ الْحَيَاةِ
u'عَيْنٌ حَيَاةٌ':Added, #1: 1	عَيْنُ الْحَيَاةِ
u'عَيْنٌ حَيَاةٌ':Added, #1: 1	عَيْنَ الْحَيَاةِ
u'عَيْن حَيَاةٌ':Added, #1: 1	عَيْنُ الْحَيَاةِ
u'عَيْن حَيَاةٌ':Added, #1: 1	عَيْنَ الْحَيَاةِ
u'عَيَّنَ حَيَّةٌ':Predicate, #1: 1	عَيْنُ الْحَيَاةِ
u'عين خبال':Added, #1: 1	عَيَّنَ الْحَيَّةَ
u'عَيْنٌ خبال':Added, #1: 1	عَيْنُ الْخَبَالِ
u'عَيْن خبال':Added, #1: 1	عَيْنُ الْخَبَالِ
u'عين خَبَالٌ':Added, #1: 1	عَيْنُ الْخَبَالِ
u'عَيْنٌ خَبَالٌ':Added, #1: 1	عَيْنُ الْخَبَالِ
u'عَيْن خَبَالٌ':Added, #1: 1	عَيْنُ الْخَبَالِ
u'عَيَّنَ خدم':Predicate, #1: 1	عَيْنُ الْخَبَالِ
u'عَيَّنَ خَدَمٌ':Predicate, #1: 1	عَيَّنَ الْخَدَمَ
u'عين خدمة':Added, #1: 1	عَيَّنَ الْخَدَمَ
u'عَيْنٌ خدمة':Added, #1: 1	عَيْنِ الْخِدْمَةِ
u'عَيْن خدمة':Added, #1: 1	عَيْنِ الْخِدْمَةِ
u'عين خِدْمَةٌ':Added, #1: 1	عَيْنِ الْخِدْمَةِ
u'عَيْنٌ خِدْمَةٌ':Added, #1: 1	عَيْنِ الْخِدْمَةِ
u'عَيْن خِدْمَةٌ':Added, #1: 1	عَيْنِ الْخِدْمَةِ
u'عين خَطَأٌ':Added, #1: 1	عَيْنِ الْخِدْمَةِ
u'عَيْنٌ خَطَأٌ':Added, #1: 1	عَيْنَ الْخَطَأِ
u'عَيْن خَطَأٌ':Added, #1: 1	عَيْنَ الْخَطَأِ
u'عين خِلاَفٌ':Added, #1: 1	عَيْنَ الْخَطَأِ
u'عَيْنٌ خِلاَفٌ':Added, #1: 1	عَيْنَ الْخِلَافِ
u'عَيْن خِلاَفٌ':Added, #1: 1	عَيْنَ الْخِلَافِ
u'عين خَلَلٌ':Added, #1: 1	عَيْنَ الْخِلَافِ
u'عَيْنٌ خَلَلٌ':Added, #1: 1	عَيْنَ الْخَلَلِ
u'عَيْن خَلَلٌ':Added, #1: 1	عَيْنَ الْخَلَلِ
u'عين خُلُوفٌ':Added, #1: 1	عَيْنَ الْخَلَلِ
u'عَيْنٌ خُلُوفٌ':Added, #1: 1	عَيْنُ الْخُلُوفِ
u'عَيْن خُلُوفٌ':Added, #1: 1	عَيْنُ الْخُلُوفِ
u'عين خَلِيلٌ':Added, #1: 1	عَيْنُ الْخُلُوفِ
u'عَيْنٌ خَلِيلٌ':Added, #1: 1	عَيْنِ الْخَلِيلِ
u'عَيْن خَلِيلٌ':Added, #1: 1	عَيْنِ الْخَلِيلِ
u'عين خَمْرٌ':Added, #1: 1	عَيْنِ الْخَلِيلِ
u'عَيْنٌ خَمْرٌ':Added, #5: 5	عَيْنَ الْخَمْرِ
u'عَيْن خَمْرٌ':Added, #5: 5	عَيْنَ الْخَمْرِ
u'عين خَمْرٌ':Added, #5: 5	عَيْنَ الْخَمْرِ
u'عَيْنٌ خَمْرٌ':Added, #9: 9	عَيْنِ الْخَمْرِ
u'عَيْن خَمْرٌ':Added, #9: 9	عَيْنِ الْخَمْرِ
u'عين خِنْزِيرٌ':Added, #9: 9	عَيْنِ الْخَمْرِ
u'عَيْنٌ خِنْزِيرٌ':Added, #4: 4	عَيْنِ الْخِنْزِيرِ
u'عَيْن خِنْزِيرٌ':Added, #4: 4	عَيْنِ الْخِنْزِيرِ
u'عين خَيْلٌ':Added, #4: 4	عَيْنِ الْخِنْزِيرِ
u'عَيْنٌ خَيْلٌ':Added, #1: 1	عَيْنِ خَيْلٍ
u'عَيْن خَيْلٌ':Added, #1: 1	عَيْنِ خَيْلٍ
u'عين دَابَّةٌ':Added, #1: 1	عَيْنِ خَيْلٍ
u'عَيْنٌ دَابَّةٌ':Added, #12: 12	عَيْنِ الدَّابَّةِ
u'عَيْن دَابَّةٌ':Added, #12: 12	عَيْنِ الدَّابَّةِ
u'عين دَابَّةٌ':Added, #12: 12	عَيْنِ الدَّابَّةِ
u'عين دَابَّةٌ':Added, #1: 1	عَيْنَ الدَّابَّةِ
u'عَيْنٌ دَابَّةٌ':Added, #1: 1	عَيْنُ الدَّابَّةِ
u'عَيْنٌ دَابَّةٌ':Added, #1: 1	عَيْنَ الدَّابَّةِ
u'عَيْن دَابَّةٌ':Added, #1: 1	عَيْنُ الدَّابَّةِ
u'عَيْن دَابَّةٌ':Added, #1: 1	عَيْنَ الدَّابَّةِ
u'عين دَابَّةٌ':Added, #1: 1	عَيْنُ الدَّابَّةِ
u'عَيْنٌ دَابَّةٌ':Added, #1: 1	عَيْنَ دَابَّةٍ
u'عَيْن دَابَّةٌ':Added, #1: 1	عَيْنَ دَابَّةٍ
u'عين دَابَّةٌ':Added, #1: 1	عَيْنَ دَابَّةٍ
u'عَيْنٌ دَابَّةٌ':Added, #2: 2	عَيْنِ دَابَّةٍ
u'عَيْن دَابَّةٌ':Added, #2: 2	عَيْنِ دَابَّةٍ
u'عين دَاخِلٌ':Added, #2: 2	عَيْنِ دَابَّةٍ
u'عين دَاخِلٌ':Added, #1: 1	عَيْنُ الدَّاخِلِ
u'عَيْنٌ دَاخِلٌ':Added, #1: 1	عَيْنِ الدَّاخِلِ
u'عَيْنٌ دَاخِلٌ':Added, #1: 1	عَيْنُ الدَّاخِلِ
u'عَيْن دَاخِلٌ':Added, #1: 1	عَيْنِ الدَّاخِلِ
u'عَيْن دَاخِلٌ':Added, #1: 1	عَيْنُ الدَّاخِلِ
u'عَيَّنَ دَارٌ':Predicate, #1: 1	عَيْنِ الدَّاخِلِ
u'عين دَارٌ':Added, #1: 1	عَيَّنَ الدَّارَ
u'عَيْنٌ دَارٌ':Added, #2: 2	عَيْنُ الدَّارِ
u'عَيْن دَارٌ':Added, #2: 2	عَيْنُ الدَّارِ
u'عين دَارٌ':Added, #2: 2	عَيْنُ الدَّارِ
u'عين دَارٌ':Added, #3: 3	عَيْنَ الدَّارِ
u'عَيْنٌ دَارٌ':Added, #3: 3	عَيْنِ الدَّارِ
u'عَيْنٌ دَارٌ':Added, #3: 3	عَيْنَ الدَّارِ
u'عَيْن دَارٌ':Added, #3: 3	عَيْنِ الدَّارِ
u'عَيْن دَارٌ':Added, #3: 3	عَيْنَ الدَّارِ
u'عَيَّنَ دَرَاهِمُ':Predicate, #3: 3	عَيْنِ الدَّارِ
u'عَيَّنَ دَرَاهِمُ':Predicate, #1: 1	عَيَّنَ الدَّرَاهِمَ
u'عين دَرَاهِمُ':Added, #1: 1	عَيَّنَ دَرَاهِمَ
u'عَيْنٌ دَرَاهِمُ':Added, #2: 2	عَيْنِ الدَّرَاهِمِ
u'عَيْن دَرَاهِمُ':Added, #2: 2	عَيْنِ الدَّرَاهِمِ
u'عين دفع':Added, #2: 2	عَيْنِ الدَّرَاهِمِ
u'عَيْنٌ دفع':Added, #1: 1	عَيْنَ دَفْعِ
u'عَيْن دفع':Added, #1: 1	عَيْنَ دَفْعِ
u'عين دَفْعٌ':Added, #1: 1	عَيْنَ دَفْعِ
u'عَيْنٌ دَفْعٌ':Added, #1: 1	عَيْنَ دَفْعِ
u'عَيْن دَفْعٌ':Added, #1: 1	عَيْنَ دَفْعِ
u'عين دَقيقٌ':Added, #1: 1	عَيْنَ دَفْعِ
u'عَيْنٌ دَقيقٌ':Added, #5: 5	عَيْنَ الدَّقِيقِ
u'عَيْن دَقيقٌ':Added, #5: 5	عَيْنَ الدَّقِيقِ
u'عين دَليلٌ':Added, #5: 5	عَيْنَ الدَّقِيقِ
u'عين دَليلٌ':Added, #1: 1	عَيْنَ الدَّلِيلِ
u'عَيْنٌ دَليلٌ':Added, #1: 1	عَيْنِ الدَّلِيلِ
u'عَيْنٌ دَليلٌ':Added, #1: 1	عَيْنَ الدَّلِيلِ
u'عَيْن دَليلٌ':Added, #1: 1	عَيْنِ الدَّلِيلِ
u'عَيْن دَليلٌ':Added, #1: 1	عَيْنَ الدَّلِيلِ
u'عين دَليلٌ':Added, #1: 1	عَيْنِ الدَّلِيلِ
u'عَيْنٌ دَليلٌ':Added, #1: 1	عَيْنُ دَلِيلِ
u'عَيْن دَليلٌ':Added, #1: 1	عَيْنُ دَلِيلِ
u'عين دَليلٌ':Added, #1: 1	عَيْنُ دَلِيلِ
u'عَيْنٌ دَليلٌ':Added, #1: 1	عَيْنُ دَلِيلِهِ
u'عَيْن دَليلٌ':Added, #1: 1	عَيْنُ دَلِيلِهِ
u'عين دَمٌ':Added, #1: 1	عَيْنُ دَلِيلِهِ
u'عَيْنٌ دَمٌ':Added, #1: 1	عَيْنُ الدَّمِ
u'عَيْن دَمٌ':Added, #1: 1	عَيْنُ الدَّمِ
u'عين دُهْنٌ':Added, #1: 1	عَيْنُ الدَّمِ
u'عَيْنٌ دُهْنٌ':Added, #1: 1	عَيْنَ الدُّهْنِ
u'عَيْن دُهْنٌ':Added, #1: 1	عَيْنَ الدُّهْنِ
u'عين دَوْرٌ':Added, #1: 1	عَيْنَ الدُّهْنِ
u'عَيْنٌ دَوْرٌ':Added, #1: 1	عَيْنُ الدَّوْرِ
u'عَيْن دَوْرٌ':Added, #1: 1	عَيْنُ الدَّوْرِ
u'عين دَوْلَةٌ':Added, #1: 1	عَيْنُ الدَّوْرِ
u'عَيْنٌ دَوْلَةٌ':Added, #2: 2	عَيْنِ الدَّوْلَةِ
u'عَيْن دَوْلَةٌ':Added, #2: 2	عَيْنِ الدَّوْلَةِ
u'عين دِينارٌ':Added, #2: 2	عَيْنِ الدَّوْلَةِ
u'عَيْنٌ دِينارٌ':Added, #1: 1	عَيْنَ الدِّينَارِ
u'عَيْن دِينارٌ':Added, #1: 1	عَيْنَ الدِّينَارِ
u'عين ذَهَبٌ':Added, #1: 1	عَيْنَ الدِّينَارِ
u'عين ذَهَبٌ':Added, #1: 1	عَيْنُ الذَّهَبِ
u'عَيْنٌ ذَهَبٌ':Added, #1: 1	عَيْنِ الذَّهَبِ
u'عَيْنٌ ذَهَبٌ':Added, #1: 1	عَيْنُ الذَّهَبِ
u'عَيْن ذَهَبٌ':Added, #1: 1	عَيْنِ الذَّهَبِ
u'عَيْن ذَهَبٌ':Added, #1: 1	عَيْنُ الذَّهَبِ
u'عين ذَهَبٌ':Added, #1: 1	عَيْنِ الذَّهَبِ
u'عَيْنٌ ذَهَبٌ':Added, #2: 2	عَيْنَ الذَّهَبِ
u'عَيْن ذَهَبٌ':Added, #2: 2	عَيْنَ الذَّهَبِ
u'عَيَّنَ رَأْسٌ':Predicate, #2: 2	عَيْنَ الذَّهَبِ
u'عَيَّنَ رَاكِبٌ':Predicate, #1: 1	عَيَّنَ الرَّأْسَ
u'عَيَّنَ رَبُّ':Subject, #1: 1	عَيَّنَ الرَّاكِبَ
u'عين رَجُلٌ':Added, #1: 1	عَيَّنَ رَبُّ
u'عين رَجُلٌ':Added, #1: 1	عَيْنُ الرّجُلِ
u'عَيْنٌ رَجُلٌ':Added, #1: 1	عَيْنِ الرَّجُلِ
u'عَيْنٌ رَجُلٌ':Added, #1: 1	عَيْنُ الرّجُلِ
u'عَيْن رَجُلٌ':Added, #1: 1	عَيْنِ الرَّجُلِ
u'عَيْن رَجُلٌ':Added, #1: 1	عَيْنُ الرّجُلِ
u'عين رَجُلٌ':Added, #1: 1	عَيْنِ الرَّجُلِ
u'عَيْنٌ رَجُلٌ':Added, #1: 1	عَيْنُ رَجُلٍ
u'عَيْن رَجُلٌ':Added, #1: 1	عَيْنُ رَجُلٍ
u'عين رَجُلٌ':Added, #1: 1	عَيْنُ رَجُلٍ
u'عَيْنٌ رَجُلٌ':Added, #5: 5	عَيْنِ رَجُلٍ
u'عَيْن رَجُلٌ':Added, #5: 5	عَيْنِ رَجُلٍ
u'عين رَجُلٌ':Added, #5: 5	عَيْنِ رَجُلٍ
u'عَيْنٌ رَجُلٌ':Added, #9: 9	عَيْنَ رَجُلٍ
u'عَيْن رَجُلٌ':Added, #9: 9	عَيْنَ رَجُلٍ
u'عين رحمة':Added, #9: 9	عَيْنَ رَجُلٍ
u'عَيْنٌ رحمة':Added, #1: 1	عَيْنُ الرَّحْمَةِ
u'عَيْن رحمة':Added, #1: 1	عَيْنُ الرَّحْمَةِ
u'عين رَحْمَةٌ':Added, #1: 1	عَيْنُ الرَّحْمَةِ
u'عَيْنٌ رَحْمَةٌ':Added, #1: 1	عَيْنُ الرَّحْمَةِ
u'عَيْن رَحْمَةٌ':Added, #1: 1	عَيْنُ الرَّحْمَةِ
u'عين رُخْصَةٌ':Added, #1: 1	عَيْنُ الرَّحْمَةِ
u'عَيْنٌ رُخْصَةٌ':Added, #2: 2	عَيْنِ رُخْصَةِ
u'عَيْن رُخْصَةٌ':Added, #2: 2	عَيْنِ رُخْصَةِ
u'عَيَّنَ رَسُولٌ':Subject, #2: 2	عَيْنِ رُخْصَةِ
u'عين رُطَبٌ':Added, #1: 1	عَيَّنَ رَسُولُ
u'عَيْنٌ رُطَبٌ':Added, #1: 1	عَيْنُ الرُّطَبِ
u'عَيْن رُطَبٌ':Added, #1: 1	عَيْنُ الرُّطَبِ
u'عين رُعاَةٌ':Added, #1: 1	عَيْنُ الرُّطَبِ
u'عين رَقَبَةٌ':Added, #3: 3	أَعْيُنَ الرُّعَاةِ
u'عَيْنٌ رَقَبَةٌ':Added, #3: 3	عَيْنِ الرَّقَبَةِ
u'عَيْن رَقَبَةٌ':Added, #3: 3	عَيْنِ الرَّقَبَةِ
u'عين رُكْنٌ':Added, #3: 3	عَيْنِ الرَّقَبَةِ
u'عين رُكْن':Added, #1: 1	عَيْنَ الرُّكْنِ
u'عَيْنٌ رُكْنٌ':Added, #1: 1	عَيْنَ الرُّكْنِ
u'عَيْنٌ رُكْن':Added, #1: 1	عَيْنَ الرُّكْنِ
u'عَيْن رُكْنٌ':Added, #1: 1	عَيْنَ الرُّكْنِ
u'عَيْن رُكْن':Added, #1: 1	عَيْنَ الرُّكْنِ
u'عين رَمْيٌ':Added, #1: 1	عَيْنَ الرُّكْنِ
u'عَيْنٌ رَمْيٌ':Added, #1: 1	عَيْنَ الرَّمْيِ
u'عَيْن رَمْيٌ':Added, #1: 1	عَيْنَ الرَّمْيِ
u'عَيَّنَ رَهْنٌ':Predicate, #1: 1	عَيْنَ الرَّمْيِ
u'عين رَهْنٌ':Added, #1: 1	عَيَّنَ الرَّهْنَ
u'عَيْنٌ رَهْنٌ':Added, #1: 1	عَيْنُ الرَّهْنِ
u'عَيْن رَهْنٌ':Added, #1: 1	عَيْنُ الرَّهْنِ
u'عين رَهْنٌ':Added, #1: 1	عَيْنُ الرَّهْنِ
u'عَيْنٌ رَهْنٌ':Added, #1: 1	عَيْنِ رَهْنٍ
u'عَيْن رَهْنٌ':Added, #1: 1	عَيْنِ رَهْنٍ
u'عين رَهْنٌ':Added, #1: 1	عَيْنِ رَهْنٍ
u'عَيْنٌ رَهْنٌ':Added, #2: 2	عَيْنَ الرَّهْنِ
u'عَيْن رَهْنٌ':Added, #2: 2	عَيْنَ الرَّهْنِ
u'عين رَهْنٌ':Added, #2: 2	عَيْنَ الرَّهْنِ
u'عَيْنٌ رَهْنٌ':Added, #4: 4	عَيْنِ الرَّهْنِ
u'عَيْن رَهْنٌ':Added, #4: 4	عَيْنِ الرَّهْنِ
u'عين رَواءٌ':Added, #4: 4	عَيْنِ الرَّهْنِ
u'عين رُواءٌ':Added, #1: 1	عَيْنَ الرّوَاءِ
u'عين رِواءٌ':Added, #1: 1	عَيْنَ الرّوَاءِ
u'عَيْنٌ رَواءٌ':Added, #1: 1	عَيْنَ الرّوَاءِ
u'عَيْنٌ رُواءٌ':Added, #1: 1	عَيْنَ الرّوَاءِ
u'عَيْنٌ رِواءٌ':Added, #1: 1	عَيْنَ الرّوَاءِ
u'عَيْن رَواءٌ':Added, #1: 1	عَيْنَ الرّوَاءِ
u'عَيْن رُواءٌ':Added, #1: 1	عَيْنَ الرّوَاءِ
u'عَيْن رِواءٌ':Added, #1: 1	عَيْنَ الرّوَاءِ
u'عين رِوايَةٌ':Added, #1: 1	عَيْنَ الرّوَاءِ
u'عَيْنٌ رِوايَةٌ':Added, #2: 2	عَيْنُ الرِّوَايَةِ
u'عَيْن رِوايَةٌ':Added, #2: 2	عَيْنُ الرِّوَايَةِ
u'عين ريحٌ':Added, #2: 2	عَيْنُ الرِّوَايَةِ
u'عَيْنٌ ريحٌ':Added, #1: 1	عَيْنَ الرِّيحِ
u'عَيْن ريحٌ':Added, #1: 1	عَيْنَ الرِّيحِ
u'عين زِبْلٌ':Added, #1: 1	عَيْنَ الرِّيحِ
u'عَيْنٌ زِبْلٌ':Added, #1: 1	عَيْنَ الزِّبْلِ
u'عَيْن زِبْلٌ':Added, #1: 1	عَيْنَ الزِّبْلِ
u'عين زِبْلٌ':Added, #1: 1	عَيْنَ الزِّبْلِ
u'عَيْنٌ زِبْلٌ':Added, #2: 2	عَيْنُ الزِّبْلِ
u'عَيْن زِبْلٌ':Added, #2: 2	عَيْنُ الزِّبْلِ
u'عَيَّنَ زِراعَةٌ':Predicate, #2: 2	عَيْنُ الزِّبْلِ
u'عَيَّنَ زَرْعٌ':Predicate, #1: 1	عَيَّنَ الزِّرَاعَةَ
u'عين زَكاةٌ':Added, #1: 1	عَيَّنَ الزَّرْعَ
u'عَيْنٌ زَكاةٌ':Added, #1: 1	عَيْنَ زَكَاتِهِ
u'عَيْن زَكاةٌ':Added, #1: 1	عَيْنَ زَكَاتِهِ
u'عَيَّنَ زَمَنٌ':Predicate, #1: 1	عَيْنَ زَكَاتِهِ
u'عَيَّنَ زَمَنٌ':Predicate, #1: 1	عَيَّنَ الزَّمَنَ
u'عين زَنْدَقَةٌ':Added, #2: 2	عَيَّنَ زَمَنَ
u'عَيْنٌ زَنْدَقَةٌ':Added, #1: 1	عَيْنُ الزَّنْدَقَةِ
u'عَيْن زَنْدَقَةٌ':Added, #1: 1	عَيْنُ الزَّنْدَقَةِ
u'عَيَّنَ زَوْجٌ':Predicate, #1: 1	عَيْنُ الزَّنْدَقَةِ
u'عين زَوْجٌ':Added, #2: 2	عَيَّنَ الزَّوْجَ
u'عَيْنٌ زَوْجٌ':Added, #1: 1	عَيْنُ الزَّوْجِ
u'عَيْن زَوْجٌ':Added, #1: 1	عَيْنُ الزَّوْجِ
u'عين زَوْجَةٌ':Added, #1: 1	عَيْنُ الزَّوْجِ
u'عَيْنٌ زَوْجَةٌ':Added, #1: 1	عَيْنُ الزَّوْجَةِ
u'عَيْن زَوْجَةٌ':Added, #1: 1	عَيْنُ الزَّوْجَةِ
u'عين زَيْدٌ':Added, #1: 1	عَيْنُ الزَّوْجَةِ
u'عَيْنٌ زَيْدٌ':Added, #1: 1	عَيْنُ زَيْدٍ
u'عَيْن زَيْدٌ':Added, #1: 1	عَيْنُ زَيْدٍ
u'عين زِينَةٌ':Added, #1: 1	عَيْنُ زَيْدٍ
u'عَيْنٌ زِينَةٌ':Added, #1: 1	عَيْنِ الزِّينَةِ
u'عَيْن زِينَةٌ':Added, #1: 1	عَيْنِ الزِّينَةِ
u'عين سَابِقٌ':Added, #1: 1	عَيْنِ الزِّينَةِ
u'عين سَابِقٌ':Added, #3: 3	عَيْنَ السَّابِقِ
u'عَيْنٌ سَابِقٌ':Added, #3: 3	عَيْنُ السَّابِقِ
u'عَيْنٌ سَابِقٌ':Added, #3: 3	عَيْنَ السَّابِقِ
u'عَيْن سَابِقٌ':Added, #3: 3	عَيْنُ السَّابِقِ
u'عَيْن سَابِقٌ':Added, #3: 3	عَيْنَ السَّابِقِ
u'عين سَائِقٌ':Added, #3: 3	عَيْنُ السَّابِقِ
u'عَيْنٌ سَائِقٌ':Added, #2: 2	عَيْنِ السَّائِقِ
u'عَيْن سَائِقٌ':Added, #2: 2	عَيْنِ السَّائِقِ
u'عَيَّنَ سائِل':Subject, #2: 2	عَيْنِ السَّائِقِ
u'عَيَّنَ سَائِلٌ':Subject, #1: 1	عَيَّنَ السَّائِلُ
u'عين سَائِمَةٌ':Added, #1: 1	عَيَّنَ السَّائِلُ
u'عَيْنٌ سَائِمَةٌ':Added, #1: 1	عَيْنِ السَّائِمَةِ
u'عَيْن سَائِمَةٌ':Added, #1: 1	عَيْنِ السَّائِمَةِ
u'عَيَّنَ سَبَبٌ':Predicate, #1: 1	عَيْنِ السَّائِمَةِ
u'عين سُجُودٌ':Added, #4: 4	عَيَّنَ السَّبَبَ
u'عَيْنٌ سُجُودٌ':Added, #1: 1	عَيْنِ السُّجُودِ
u'عَيْن سُجُودٌ':Added, #1: 1	عَيْنِ السُّجُودِ
u'عين سُخْطٌ':Added, #1: 1	عَيْنِ السُّجُودِ
u'عَيْنٌ سُخْطٌ':Added, #1: 1	عَيْنَ السُّخْطِ
u'عَيْن سُخْطٌ':Added, #1: 1	عَيْنَ السُّخْطِ
u'عَيَّنَ سَرقَةٌ':Predicate, #1: 1	عَيْنَ السُّخْطِ
u'عَيَّنَ سَرِقَةٌ':Predicate, #2: 2	عَيَّنَ السَّرِقَةَ
u'عين سُقُوطٌ':Added, #2: 2	عَيَّنَ السَّرِقَةَ
u'عَيْنٌ سُقُوطٌ':Added, #1: 1	عَيْنِ سُقُوطِ
u'عَيْن سُقُوطٌ':Added, #1: 1	عَيْنِ سُقُوطِ
u'عين سكر':Added, #1: 1	عَيْنِ سُقُوطِ
u'عَيْنٌ سكر':Added, #1: 1	عَيْنَ السُّكْرِ
u'عَيْن سكر':Added, #1: 1	عَيْنَ السُّكْرِ
u'عين سُكْرٌ':Added, #1: 1	عَيْنَ السُّكْرِ
u'عَيْنٌ سُكْرٌ':Added, #1: 1	عَيْنَ السُّكْرِ
u'عَيْن سُكْرٌ':Added, #1: 1	عَيْنَ السُّكْرِ
u'عين سَلاَمَةٌ':Added, #1: 1	عَيْنَ السُّكْرِ
u'عَيْنٌ سَلاَمَةٌ':Added, #1: 1	عَيْنِ السَّلَامَةِ
u'عَيْن سَلاَمَةٌ':Added, #1: 1	عَيْنِ السَّلَامَةِ
u'عين سِلْعَةٌ':Added, #1: 1	عَيْنِ السَّلَامَةِ
u'عَيْنٌ سِلْعَةٌ':Added, #1: 1	عَيْنِ سِلْعَةٍ
u'عَيْن سِلْعَةٌ':Added, #1: 1	عَيْنِ سِلْعَةٍ
u'عين سَمْنٌ':Added, #1: 1	عَيْنِ سِلْعَةٍ
u'عَيْنٌ سَمْنٌ':Added, #1: 1	عَيْنِ السَّمْنِ
u'عَيْن سَمْنٌ':Added, #1: 1	عَيْنِ السَّمْنِ
u'عين سِنٌّ':Added, #1: 1	عَيْنِ السَّمْنِ
u'عَيْنٌ سِنٌّ':Added, #1: 1	عَيْنِ السِّنِّ
u'عَيْن سِنٌّ':Added, #1: 1	عَيْنِ السِّنِّ
u'عَيَّنَ سَنَةٌ':Predicate, #1: 1	عَيْنِ السِّنِّ
u'عين سُوءٌ':Added, #2: 2	عَيَّنَ السَّنَةَ
u'عَيَّنَ سَيِّدٌ':Subject, #1: 1	أَعْيُنَ سُوءٍ
u'عين شَاةٌ':Added, #1: 1	عَيَّنَ السَّيِّدُ
u'عين شَاةٌ':Added, #1: 1	عَيْنِ شَاةٍ
u'عَيْنٌ شَاةٌ':Added, #1: 1	عَيْنِ شَاةِ
u'عَيْنٌ شَاةٌ':Added, #1: 1	عَيْنِ شَاةٍ
u'عَيْن شَاةٌ':Added, #1: 1	عَيْنِ شَاةِ
u'عَيْن شَاةٌ':Added, #1: 1	عَيْنِ شَاةٍ
u'عين شَاةٌ':Added, #1: 1	عَيْنِ شَاةِ
u'عين شَاةٌ':Added, #2: 2	عَيْنَ الشَّاةِ
u'عين شَاةٌ':Added, #2: 2	عَيْنُ الشَّاةِ
u'عَيْنٌ شَاةٌ':Added, #2: 2	عَيْنِ الشَّاةِ
u'عَيْنٌ شَاةٌ':Added, #2: 2	عَيْنَ الشَّاةِ
u'عَيْنٌ شَاةٌ':Added, #2: 2	عَيْنُ الشَّاةِ
u'عَيْن شَاةٌ':Added, #2: 2	عَيْنِ الشَّاةِ
u'عَيْن شَاةٌ':Added, #2: 2	عَيْنَ الشَّاةِ
u'عَيْن شَاةٌ':Added, #2: 2	عَيْنُ الشَّاةِ
u'عَيَّنَ شَارِعٌ':Subject, #2: 2	عَيْنِ الشَّاةِ
u'عين شَجَرٌ':Added, #1: 1	عَيَّنَ الشَّارِعُ
u'عَيْنٌ شَجَرٌ':Added, #1: 1	عَيْنِ الشَّجَرِ
u'عَيْن شَجَرٌ':Added, #1: 1	عَيْنِ الشَّجَرِ
u'عين شَخْصٌ':Added, #1: 1	عَيْنِ الشَّجَرِ
u'عَيْنٌ شَخْصٌ':Added, #1: 1	عَيْنَ الشَّخْصِ
u'عَيْن شَخْصٌ':Added, #1: 1	عَيْنَ الشَّخْصِ
u'عين شَخْصٌ':Added, #1: 1	عَيْنَ الشَّخْصِ
u'عَيْنٌ شَخْصٌ':Added, #1: 1	عَيْنِ شَخْصٍ
u'عَيْن شَخْصٌ':Added, #1: 1	عَيْنِ شَخْصٍ
u'عين شَخْصٌ':Added, #1: 1	عَيْنِ شَخْصٍ
u'عَيْنٌ شَخْصٌ':Added, #2: 2	عَيْنِ الشَّخْصِ
u'عَيْن شَخْصٌ':Added, #2: 2	عَيْنِ الشَّخْصِ
u'عَيَّنَ شَرْعٌ':Subject, #2: 2	عَيْنِ الشَّخْصِ
u'عين شِرْكٌ':Added, #1: 1	عَيَّنَ الشَّرْعُ
u'عَيْنٌ شِرْكٌ':Added, #2: 2	عَيْنُ الشِّرْكِ
u'عَيْن شِرْكٌ':Added, #2: 2	عَيْنُ الشِّرْكِ
u'عين شِقٌّ':Added, #2: 2	عَيْنُ الشِّرْكِ
u'عَيْنٌ شِقٌّ':Added, #1: 1	عَيْنُ الشِّقِّ
u'عَيْن شِقٌّ':Added, #1: 1	عَيْنُ الشِّقِّ
u'عين شمال':Added, #1: 1	عَيْنُ الشِّقِّ
u'عَيْنٌ شمال':Added, #1: 1	عَيْنِ الشِّمَالِ
u'عَيْن شمال':Added, #1: 1	عَيْنِ الشِّمَالِ
u'عين شِمَالٌ':Added, #1: 1	عَيْنِ الشِّمَالِ
u'عَيْنٌ شِمَالٌ':Added, #1: 1	عَيْنِ الشِّمَالِ
u'عَيْن شِمَالٌ':Added, #1: 1	عَيْنِ الشِّمَالِ
u'عين شمس':Added, #1: 1	عَيْنِ الشِّمَالِ
u'عَيْنٌ شمس':Added, #1: 1	عَيْنِ الشَّمْسِ
u'عَيْن شمس':Added, #1: 1	عَيْنِ الشَّمْسِ
u'عين شَمْسٌ':Added, #1: 1	عَيْنِ الشَّمْسِ
u'عَيْنٌ شَمْسٌ':Added, #1: 1	عَيْنِ الشَّمْسِ
u'عَيْن شَمْسٌ':Added, #1: 1	عَيْنِ الشَّمْسِ
u'عين شَمْسٌ':Added, #1: 1	عَيْنِ الشَّمْسِ
u'عَيْنٌ شَمْسٌ':Added, #1: 1	عَيْنِ شَمْسٍ
u'عَيْن شَمْسٌ':Added, #1: 1	عَيْنِ شَمْسٍ
u'عين شمس':Added, #1: 1	عَيْنِ شَمْسٍ
u'عَيْنٌ شمس':Added, #6: 6	عَيْنَ الشَّمْسِ
u'عَيْن شمس':Added, #6: 6	عَيْنَ الشَّمْسِ
u'عين شَمْسٌ':Added, #6: 6	عَيْنَ الشَّمْسِ
u'عَيْنٌ شَمْسٌ':Added, #6: 6	عَيْنَ الشَّمْسِ
u'عَيْن شَمْسٌ':Added, #6: 6	عَيْنَ الشَّمْسِ
u'عَيَّنَ شَهْرٌ':Predicate, #6: 6	عَيْنَ الشَّمْسِ
u'عين شَيْءٌ':Added, #3: 3	عَيَّنَ الشَّهْرَ
u'عَيْنٌ شَيْءٌ':Added, #1: 1	عَيْنَ الشَّيْءِ
u'عَيْن شَيْءٌ':Added, #1: 1	عَيْنَ الشَّيْءِ
u'عين شَيْءٌ':Added, #1: 1	عَيْنَ الشَّيْءِ
u'عَيْنٌ شَيْءٌ':Added, #4: 4	عَيْنِ الشَّيْءِ
u'عَيْن شَيْءٌ':Added, #4: 4	عَيْنِ الشَّيْءِ
u'عين صَاحِبٌ':Added, #4: 4	عَيْنِ الشَّيْءِ
u'عين صَاحِبٌ':Added, #1: 1	عَيْنُ صَاحِبِ
u'عَيْنٌ صَاحِبٌ':Added, #1: 1	عَيْنِ صَاحِبِ
u'عَيْنٌ صَاحِبٌ':Added, #1: 1	عَيْنُ صَاحِبِ
u'عَيْن صَاحِبٌ':Added, #1: 1	عَيْنِ صَاحِبِ
u'عَيْن صَاحِبٌ':Added, #1: 1	عَيْنُ صَاحِبِ
u'عين صَاحِبٌ':Added, #1: 1	عَيْنِ صَاحِبِ
u'عين صَاحِبٌ':Added, #1: 1	عَيْنَ صَاحِبِهِ
u'عَيْنٌ صَاحِبٌ':Added, #1: 1	عَيْنِ صَاحِبِهِ
u'عَيْنٌ صَاحِبٌ':Added, #1: 1	عَيْنَ صَاحِبِهِ
u'عَيْن صَاحِبٌ':Added, #1: 1	عَيْنِ صَاحِبِهِ
u'عَيْن صَاحِبٌ':Added, #1: 1	عَيْنَ صَاحِبِهِ
u'عين صِبْغٌ':Added, #1: 1	عَيْنِ صَاحِبِهِ
u'عين صِبْغٌ':Added, #1: 1	عَيْنُ الصِّبْغِ
u'عَيْنٌ صِبْغٌ':Added, #1: 1	عَيْنِ الصِّبْغِ
u'عَيْنٌ صِبْغٌ':Added, #1: 1	عَيْنُ الصِّبْغِ
u'عَيْن صِبْغٌ':Added, #1: 1	عَيْنِ الصِّبْغِ
u'عَيْن صِبْغٌ':Added, #1: 1	عَيْنُ الصِّبْغِ
u'عين صَبِيٌّ':Added, #1: 1	عَيْنِ الصِّبْغِ
u'عَيْنٌ صَبِيٌّ':Added, #1: 1	عَيْنُ الصَّبِيِّ
u'عَيْن صَبِيٌّ':Added, #1: 1	عَيْنُ الصَّبِيِّ
u'عين صَبِيٌّ':Added, #1: 1	عَيْنُ الصَّبِيِّ
u'عَيْنٌ صَبِيٌّ':Added, #1: 1	عَيْنَ صَبِيٍّ
u'عَيْن صَبِيٌّ':Added, #1: 1	عَيْنَ صَبِيٍّ
u'عين صَبِيٌّ':Added, #1: 1	عَيْنَ صَبِيٍّ
u'عَيْنٌ صَبِيٌّ':Added, #5: 5	عَيْنِ الصَّبِيِّ
u'عَيْن صَبِيٌّ':Added, #5: 5	عَيْنِ الصَّبِيِّ
u'عَيَّنَ صَحَابِيٌّ':Subject, #5: 5	عَيْنِ الصَّبِيِّ
u'عين صَحِيحٌ':Added, #1: 1	عَيَّنَ الصَّحَابِيُّ
u'عَيْنٌ صَحِيحٌ':Added, #4: 4	عَيْنَ الصَّحِيحِ
u'عَيْن صَحِيحٌ':Added, #4: 4	عَيْنَ الصَّحِيحِ
u'عين صداق':Added, #4: 4	عَيْنَ الصَّحِيحِ
u'عَيْنٌ صداق':Added, #1: 1	عَيْنَ الصَّدَاقِ
u'عَيْن صداق':Added, #1: 1	عَيْنَ الصَّدَاقِ
u'عين صَدَاقٌ':Added, #1: 1	عَيْنَ الصَّدَاقِ
u'عَيْنٌ صَدَاقٌ':Added, #1: 1	عَيْنَ الصَّدَاقِ
u'عَيْن صَدَاقٌ':Added, #1: 1	عَيْنَ الصَّدَاقِ
u'عين صداق':Added, #1: 1	عَيْنَ الصَّدَاقِ
u'عَيْنٌ صداق':Added, #2: 2	عَيْنِ الصَّدَاقِ
u'عَيْن صداق':Added, #2: 2	عَيْنِ الصَّدَاقِ
u'عين صَدَاقٌ':Added, #2: 2	عَيْنِ الصَّدَاقِ
u'عَيْنٌ صَدَاقٌ':Added, #2: 2	عَيْنِ الصَّدَاقِ
u'عَيْن صَدَاقٌ':Added, #2: 2	عَيْنِ الصَّدَاقِ
u'عين صِغَرٌ':Added, #2: 2	عَيْنِ الصَّدَاقِ
u'عَيْنٌ صِغَرٌ':Added, #2: 2	عَيْنَ الصِّغَرِ
u'عَيْن صِغَرٌ':Added, #2: 2	عَيْنَ الصِّغَرِ
u'عَيَّنَ صِفَةٌ':Predicate, #2: 2	عَيْنَ الصِّغَرِ
u'عين صِفَةٌ':Added, #1: 1	عَيَّنَ صِفَةَ
u'عَيْنٌ صِفَةٌ':Added, #1: 1	عَيْنِ الصِّفَةِ
u'عَيْن صِفَةٌ':Added, #1: 1	عَيْنِ الصِّفَةِ
u'عين صَقْرٌ':Added, #1: 1	عَيْنِ الصِّفَةِ
u'عَيْنٌ صَقْرٌ':Added, #1: 1	عَيْنِ الصَّقْرِ
u'عَيْن صَقْرٌ':Added, #1: 1	عَيْنِ الصَّقْرِ
u'عَيَّنَ صَلاَةٌ':Predicate, #1: 1	عَيْنِ الصَّقْرِ
u'عين صَلاَةٌ':Added, #2: 2	عَيَّنَ الصَّلَاةَ
u'عَيْنٌ صَلاَةٌ':Added, #1: 1	عَيْنِ الصَّلَاةِ
u'عَيْن صَلاَةٌ':Added, #1: 1	عَيْنِ الصَّلَاةِ
u'عين صَلاَةٌ':Added, #1: 1	عَيْنِ الصَّلَاةِ
u'عَيْنٌ صَلاَةٌ':Added, #3: 3	عَيْنَ الصَّلَاةِ
u'عَيْن صَلاَةٌ':Added, #3: 3	عَيْنَ الصَّلَاةِ
u'عين صنعة':Added, #3: 3	عَيْنَ الصَّلَاةِ
u'عَيْنٌ صنعة':Added, #1: 1	عَيْنَ الصَّنْعَةِ
u'عَيْن صنعة':Added, #1: 1	عَيْنَ الصَّنْعَةِ
u'عين صَنْعَةٌ':Added, #1: 1	عَيْنَ الصَّنْعَةِ
u'عَيْنٌ صَنْعَةٌ':Added, #1: 1	عَيْنَ الصَّنْعَةِ
u'عَيْن صَنْعَةٌ':Added, #1: 1	عَيْنَ الصَّنْعَةِ
u'عين صَوَابٌ':Added, #1: 1	عَيْنَ الصَّنْعَةِ
u'عَيْنٌ صَوَابٌ':Added, #22: 22	عَيْنُ الصَّوَابِ
u'عَيْن صَوَابٌ':Added, #22: 22	عَيْنُ الصَّوَابِ
u'عين صُورَةٌ':Added, #22: 22	عَيْنُ الصَّوَابِ
u'عَيْنٌ صُورَةٌ':Added, #1: 1	عَيْنُ الصُّورَةِ
u'عَيْن صُورَةٌ':Added, #1: 1	عَيْنُ الصُّورَةِ
u'عين صُورَةٌ':Added, #1: 1	عَيْنُ الصُّورَةِ
u'عَيْنٌ صُورَةٌ':Added, #1: 1	عَيْن صُورَةِ
u'عَيْن صُورَةٌ':Added, #1: 1	عَيْن صُورَةِ
u'عين صُورَةٌ':Added, #1: 1	عَيْن صُورَةِ
u'عَيْنٌ صُورَةٌ':Added, #3: 3	عَيْنِ صُورَةِ
u'عَيْن صُورَةٌ':Added, #3: 3	عَيْنِ صُورَةِ
u'عين صُورَةٌ':Added, #3: 3	عَيْنِ صُورَةِ
u'عَيْنٌ صُورَةٌ':Added, #4: 4	عَيْنُ صُورَةِ
u'عَيْن صُورَةٌ':Added, #4: 4	عَيْنُ صُورَةِ
u'عَيَّنَ صَوْمٌ':Predicate, #4: 4	عَيْنُ صُورَةِ
u'عين صَوْمٌ':Added, #1: 1	عَيَّنَ صَوْمَ
u'عَيْنٌ صَوْمٌ':Added, #1: 1	عَيْنِ الصَّوْمِ
u'عَيْن صَوْمٌ':Added, #1: 1	عَيْنِ الصَّوْمِ
u'عَيَّنَ صَيْدٌ':Predicate, #1: 1	عَيْنِ الصَّوْمِ
u'عين صَيْدٌ':Added, #1: 1	عَيَّنَ الصَّيْدَ
u'عَيْنٌ صَيْدٌ':Added, #1: 1	عَيْنِ الصَّيْدِ
u'عَيْن صَيْدٌ':Added, #1: 1	عَيْنِ الصَّيْدِ
u'عين صَيْدٌ':Added, #1: 1	عَيْنِ الصَّيْدِ
u'عَيْنٌ صَيْدٌ':Added, #1: 1	عَيْنَ صَيْدٍ
u'عَيْن صَيْدٌ':Added, #1: 1	عَيْنَ صَيْدٍ
u'عين ضَامِنٌ':Added, #1: 1	عَيْنَ صَيْدٍ
u'عَيْنٌ ضَامِنٌ':Added, #1: 1	عَيْنِ الضَّامِنِ
u'عَيْن ضَامِنٌ':Added, #1: 1	عَيْنِ الضَّامِنِ
u'عين طَالِبٌ':Added, #1: 1	عَيْنِ الضَّامِنِ
u'عَيْنٌ طَالِبٌ':Added, #1: 1	عَيْنِ الطَّالِبِ
u'عَيْن طَالِبٌ':Added, #1: 1	عَيْنِ الطَّالِبِ
u'عين طَرِيقٌ':Added, #1: 1	عَيْنِ الطَّالِبِ
u'عين طَرِيقٌ':Added, #1: 1	عَيْنَ الطَّرِيقِ
u'عَيْنٌ طَرِيقٌ':Added, #1: 1	عَيْنُ الطَّرِيقِ
u'عَيْنٌ طَرِيقٌ':Added, #1: 1	عَيْنَ الطَّرِيقِ
u'عَيْن طَرِيقٌ':Added, #1: 1	عَيْنُ الطَّرِيقِ
u'عَيْن طَرِيقٌ':Added, #1: 1	عَيْنَ الطَّرِيقِ
u'عين طعام':Added, #1: 1	عَيْنُ الطَّرِيقِ
u'عين طعام':Added, #1: 1	عَيْنَ الطَّعَامِ
u'عَيْنٌ طعام':Added, #1: 1	عَيْنُ الطَّعَامِ
u'عَيْنٌ طعام':Added, #1: 1	عَيْنَ الطَّعَامِ
u'عَيْن طعام':Added, #1: 1	عَيْنُ الطَّعَامِ
u'عَيْن طعام':Added, #1: 1	عَيْنَ الطَّعَامِ
u'عين طَعَامٌ':Added, #1: 1	عَيْنُ الطَّعَامِ
u'عين طَعَامٌ':Added, #1: 1	عَيْنَ الطَّعَامِ
u'عَيْنٌ طَعَامٌ':Added, #1: 1	عَيْنُ الطَّعَامِ
u'عَيْنٌ طَعَامٌ':Added, #1: 1	عَيْنَ الطَّعَامِ
u'عَيْن طَعَامٌ':Added, #1: 1	عَيْنُ الطَّعَامِ
u'عَيْن طَعَامٌ':Added, #1: 1	عَيْنَ الطَّعَامِ
u'عين طعام':Added, #1: 1	عَيْنُ الطَّعَامِ
u'عَيْنٌ طعام':Added, #1: 1	عَيْنِ طَعَامٍ
u'عَيْن طعام':Added, #1: 1	عَيْنِ طَعَامٍ
u'عين طَعَامٌ':Added, #1: 1	عَيْنِ طَعَامٍ
u'عَيْنٌ طَعَامٌ':Added, #1: 1	عَيْنِ طَعَامٍ
u'عَيْن طَعَامٌ':Added, #1: 1	عَيْنِ طَعَامٍ
u'عَيَّنَ طَلاَقٌ':Predicate, #1: 1	عَيْنِ طَعَامٍ
u'عين طَلاَقٌ':Added, #3: 3	عَيَّنَ الطَّلَاقَ
u'عَيْنٌ طَلاَقٌ':Added, #1: 1	عَيْنِ طَلَاقٍ
u'عَيْن طَلاَقٌ':Added, #1: 1	عَيْنِ طَلَاقٍ
u'عين طلب':Added, #1: 1	عَيْنِ طَلَاقٍ
u'عَيْنٌ طلب':Added, #2: 2	عَيْنُ طَلَبِ
u'عَيْن طلب':Added, #2: 2	عَيْنُ طَلَبِ
u'عين طَلَبٌ':Added, #2: 2	عَيْنُ طَلَبِ
u'عَيْنٌ طَلَبٌ':Added, #2: 2	عَيْنُ طَلَبِ
u'عَيْن طَلَبٌ':Added, #2: 2	عَيْنُ طَلَبِ
u'عين طَوْفٌ':Added, #2: 2	عَيْنُ طَلَبِ
u'عَيْنٌ طَوْفٌ':Added, #1: 1	عَيْنَ الطَّوْفِ
u'عَيْن طَوْفٌ':Added, #1: 1	عَيْنَ الطَّوْفِ
u'عين طِيبٌ':Added, #1: 1	عَيْنَ الطَّوْفِ
u'عَيْنٌ طِيبٌ':Added, #3: 3	عَيْنَ الطِّيبِ
u'عَيْن طِيبٌ':Added, #3: 3	عَيْنَ الطِّيبِ
u'عين طِيبٌ':Added, #3: 3	عَيْنَ الطِّيبِ
u'عَيْنٌ طِيبٌ':Added, #4: 4	عَيْنِ الطِّيبِ
u'عَيْن طِيبٌ':Added, #4: 4	عَيْنِ الطِّيبِ
u'عَيَّنَ ظهار':Predicate, #4: 4	عَيْنِ الطِّيبِ
u'عَيَّنَ ظُهْرٌ':Predicate, #1: 1	عَيَّنَ ظِهَارَ
u'عَيَّنَ عَامٌ':Predicate, #1: 1	عَيَّنَ ظُهْرَ
u'عين عَامٌّ':Added, #1: 1	عَيَّنَ الْعَامَ
u'عين عَامِرٌ':Added, #1: 1	أَعْيُنِ عَامَّةِ
u'عَيْنٌ عَامِرٌ':Added, #1: 1	عَيْنَ عَامِرٍ
u'عَيْن عَامِرٌ':Added, #1: 1	عَيْنَ عَامِرٍ
u'عَيَّنَ عَبْدٌ':Predicate, #1: 1	عَيْنَ عَامِرٍ
u'عَيَّنَ عَبْدٌ':Subject, #1: 1	عَيَّنَ الْعَبْدَ
u'عين عَبْدٌ':Added, #1: 1	عَيَّنَ الْعَبْدُ
u'عَيْنٌ عَبْدٌ':Added, #2: 2	عَيْنَ عَبْدٍ
u'عَيْن عَبْدٌ':Added, #2: 2	عَيْنَ عَبْدٍ
u'عين عَبْدٌ':Added, #2: 2	عَيْنَ عَبْدٍ
u'عين عَبْدٌ':Added, #3: 3	عَيْنَ الْعَبْدِ
u'عَيْنٌ عَبْدٌ':Added, #3: 3	عَيْنِ الْعَبْدِ
u'عَيْنٌ عَبْدٌ':Added, #3: 3	عَيْنَ الْعَبْدِ
u'عَيْن عَبْدٌ':Added, #3: 3	عَيْنِ الْعَبْدِ
u'عَيْن عَبْدٌ':Added, #3: 3	عَيْنَ الْعَبْدِ
u'عين عَبْدٌ':Added, #3: 3	عَيْنِ الْعَبْدِ
u'عَيْنٌ عَبْدٌ':Added, #3: 3	عَيْنَ عَبْدِهِ
u'عَيْن عَبْدٌ':Added, #3: 3	عَيْنَ عَبْدِهِ
u'عين عَبْدٌ':Added, #3: 3	عَيْنَ عَبْدِهِ
u'عَيْنٌ عَبْدٌ':Added, #8: 8	عَيْنُ الْعَبْدِ
u'عَيْن عَبْدٌ':Added, #8: 8	عَيْنُ الْعَبْدِ
u'عَيَّنَ عتق':Predicate, #8: 8	عَيْنُ الْعَبْدِ
u'عَيَّنَ عِتْقٌ':Predicate, #2: 2	عَيَّنَ الْعِتْقَ
u'عين عَدُوٌّ':Added, #2: 2	عَيَّنَ الْعِتْقَ
u'عَيْنٌ عَدُوٌّ':Added, #8: 8	عَيْنِ الْعَدُوِّ
u'عَيْن عَدُوٌّ':Added, #8: 8	عَيْنِ الْعَدُوِّ
u'عين عُذْرٌ':Added, #8: 8	عَيْنِ الْعَدُوِّ
u'عَيْنٌ عُذْرٌ':Added, #1: 1	عَيْنِ الْعُذْرِ
u'عَيْن عُذْرٌ':Added, #1: 1	عَيْنِ الْعُذْرِ
u'عين عُرُوضٌ':Added, #1: 1	عَيْنِ الْعُذْرِ
u'عَيْنٌ عُرُوضٌ':Added, #1: 1	عَيْنِ الْعُرُوضِ
u'عَيْن عُرُوضٌ':Added, #1: 1	عَيْنِ الْعُرُوضِ
u'عين عَصِيرٌ':Added, #1: 1	عَيْنِ الْعُرُوضِ
u'عَيْنٌ عَصِيرٌ':Added, #1: 1	عَيْنِ الْعَصِيرِ
u'عَيْن عَصِيرٌ':Added, #1: 1	عَيْنِ الْعَصِيرِ
u'عَيَّنَ عَقَارٌ':Predicate, #1: 1	عَيْنِ الْعَصِيرِ
u'عين عَقَارٌ':Added, #2: 2	عَيَّنَ الْعَقَارَ
u'عَيْنٌ عَقَارٌ':Added, #2: 2	عَيْنِ الْعَقَارِ
u'عَيْن عَقَارٌ':Added, #2: 2	عَيْنِ الْعَقَارِ
u'عين عَقْدٌ':Added, #2: 2	عَيْنِ الْعَقَارِ
u'عين عَقْدٌ':Added, #1: 1	عَيْنَ الْعَقْدِ
u'عَيْنٌ عَقْدٌ':Added, #1: 1	عَيْنُ الْعَقْدِ
u'عَيْنٌ عَقْدٌ':Added, #1: 1	عَيْنَ الْعَقْدِ
u'عَيْن عَقْدٌ':Added, #1: 1	عَيْنُ الْعَقْدِ
u'عَيْن عَقْدٌ':Added, #1: 1	عَيْنَ الْعَقْدِ
u'عين عِلَّةٌ':Added, #1: 1	عَيْنُ الْعَقْدِ
u'عين عِلَّةٌ':Added, #1: 1	عَيْنُ عِلَّةِ
u'عَيْنٌ عِلَّةٌ':Added, #1: 1	عَيْنِ عِلَّةِ
u'عَيْنٌ عِلَّةٌ':Added, #1: 1	عَيْنُ عِلَّةِ
u'عَيْن عِلَّةٌ':Added, #1: 1	عَيْنِ عِلَّةِ
u'عَيْن عِلَّةٌ':Added, #1: 1	عَيْنُ عِلَّةِ
u'عين عِلَّةٌ':Added, #1: 1	عَيْنِ عِلَّةِ
u'عَيْنٌ عِلَّةٌ':Added, #3: 3	عَيْنِ الْعِلَّةِ
u'عَيْن عِلَّةٌ':Added, #3: 3	عَيْنِ الْعِلَّةِ
u'عين عِلْكٌ':Added, #3: 3	عَيْنِ الْعِلَّةِ
u'عَيْنٌ عِلْكٌ':Added, #1: 1	عَيْنَ الْعِلْكِ
u'عَيْن عِلْكٌ':Added, #1: 1	عَيْنَ الْعِلْكِ
u'عين علم':Added, #1: 1	عَيْنَ الْعِلْكِ
u'عَيْنٌ علم':Added, #1: 1	عَيْنُ الْعِلْمِ
u'عَيْن علم':Added, #1: 1	عَيْنُ الْعِلْمِ
u'عين عِلْمٌ':Added, #1: 1	عَيْنُ الْعِلْمِ
u'عَيْنٌ عِلْمٌ':Added, #1: 1	عَيْنُ الْعِلْمِ
u'عَيْن عِلْمٌ':Added, #1: 1	عَيْنُ الْعِلْمِ
u'عين عَوْرَةٌ':Added, #1: 1	عَيْنُ الْعِلْمِ
u'عَيْنٌ عَوْرَةٌ':Added, #2: 2	عَيْنِ الْعَوْرَةِ
u'عَيْن عَوْرَةٌ':Added, #2: 2	عَيْنِ الْعَوْرَةِ
u'عين عين':Added, #2: 2	عَيْنِ الْعَوْرَةِ
u'عين عَيْنٌ':Added, #1: 1	أَعْيُنِ الْعَيْنِ
u'عين عَيْن':Added, #1: 1	أَعْيُنِ الْعَيْنِ
u'عين عُيُونٌ':Added, #1: 1	أَعْيُنِ الْعَيْنِ
u'عَيْنٌ عُيُونٌ':Added, #1: 1	عَيْنَ عُيُونٍ
u'عَيْن عُيُونٌ':Added, #1: 1	عَيْنَ عُيُونٍ
u'عين غَائِبٌ':Added, #1: 1	عَيْنَ عُيُونٍ
u'عَيْنٌ غَائِبٌ':Added, #1: 1	عَيْنِ غَائِبٍ
u'عَيْن غَائِبٌ':Added, #1: 1	عَيْنِ غَائِبٍ
u'عين غَزْلٌ':Added, #1: 1	عَيْنِ غَائِبٍ
u'عَيْنٌ غَزْلٌ':Added, #1: 1	عَيْنُ الْغَزْلِ
u'عَيْن غَزْلٌ':Added, #1: 1	عَيْنُ الْغَزْلِ
u'عين غَزْلٌ':Added, #1: 1	عَيْنُ الْغَزْلِ
u'عَيْنٌ غَزْلٌ':Added, #2: 2	عَيْنَ الْغَزْلِ
u'عَيْن غَزْلٌ':Added, #2: 2	عَيْنَ الْغَزْلِ
u'عين غَصْبٌ':Added, #2: 2	عَيْنَ الْغَزْلِ
u'عَيْنٌ غَصْبٌ':Added, #1: 1	عَيْنَ الْغَصْبِ
u'عَيْن غَصْبٌ':Added, #1: 1	عَيْنَ الْغَصْبِ
u'عين غطارفة':Added, #1: 1	عَيْنَ الْغَصْبِ
u'عَيْنٌ غطارفة':Added, #1: 1	عَيْنَ الْغَطَارِفَةِ
u'عَيْن غطارفة':Added, #1: 1	عَيْنَ الْغَطَارِفَةِ
u'عين غُلاَمٌ':Added, #1: 1	عَيْنَ الْغَطَارِفَةِ
u'عين غُلاَمٌ':Added, #1: 1	عَيْنِ الْغُلامِ
u'عَيْنٌ غُلاَمٌ':Added, #1: 1	عَيْنَ الْغُلَامِ
u'عَيْن غُلاَمٌ':Added, #1: 1	عَيْنِ الْغُلامِ
u'عَيْنٌ غُلاَمٌ':Added, #1: 1	عَيْنِ الْغُلامِ
u'عَيْن غُلاَمٌ':Added, #1: 1	عَيْنَ الْغُلَامِ
u'عين غُلاَمٌ':Added, #1: 1	عَيْنَ الْغُلَامِ
u'عَيْنٌ غُلاَمٌ':Added, #2: 2	عَيْنِ الْغُلَامِ
u'عَيْن غُلاَمٌ':Added, #2: 2	عَيْنِ الْغُلَامِ
u'عَيَّنَ غير':Predicate, #2: 2	عَيْنِ الْغُلَامِ
u'عَيَّنَ غَيْرٌ':Predicate, #5: 5	عَيَّنَ غَيْرَ
u'عَيَّنَ غير':Subject, #5: 5	عَيَّنَ غَيْرَ
u'عَيَّنَ غَيْرٌ':Subject, #1: 1	عَيَّنَ غَيْرُ
u'عَيَّنَ غير':Subject, #1: 1	عَيَّنَ غَيْرُ
u'عَيَّنَ غَيْرٌ':Subject, #1: 1	عَيَّنَ غَيْرُهُ
u'عين غير':Added, #1: 1	عَيَّنَ غَيْرُهُ
u'عين غَيْرٌ':Added, #1: 1	عَيْنِ غَيْرِ
u'عَيْنٌ غير':Added, #1: 1	عَيْنِ غَيْرِ
u'عَيْن غير':Added, #1: 1	عَيْنِ غَيْرِ
u'عَيْنٌ غَيْرٌ':Added, #1: 1	عَيْنِ غَيْرِ
u'عَيْن غَيْرٌ':Added, #1: 1	عَيْنِ غَيْرِ
u'عين فَحْلٌ':Added, #1: 1	عَيْنِ غَيْرِ
u'عَيْنٌ فَحْلٌ':Added, #1: 1	عَيْنَ الْفَحْلِ
u'عَيْن فَحْلٌ':Added, #1: 1	عَيْنَ الْفَحْلِ
u'عين فَرَسٌ':Added, #1: 1	عَيْنَ الْفَحْلِ
u'عَيْنٌ فَرَسٌ':Added, #3: 3	عَيْنِ الْفَرَسِ
u'عَيْن فَرَسٌ':Added, #3: 3	عَيْنِ الْفَرَسِ
u'عَيَّنَ فَرْضٌ':Predicate, #3: 3	عَيْنِ الْفَرَسِ
u'عين فَرْضٌ':Added, #1: 1	عَيَّنَ الْفَرْضَ
u'عَيْنٌ فَرْضٌ':Added, #1: 1	عَيْنَ الْفَرْضِ
u'عَيْن فَرْضٌ':Added, #1: 1	عَيْنَ الْفَرْضِ
u'عَيَّنَ فَرْعٌ':Predicate, #1: 1	عَيْنَ الْفَرْضِ
u'عين فرق':Added, #1: 1	عَيَّنَ الْفَرْعَ
u'عَيْنٌ فرق':Added, #3: 3	عَيْنُ الْفَرْقِ
u'عَيْن فرق':Added, #3: 3	عَيْنُ الْفَرْقِ
u'عين فَرْقٌ':Added, #3: 3	عَيْنُ الْفَرْقِ
u'عَيْنٌ فَرْقٌ':Added, #3: 3	عَيْنُ الْفَرْقِ
u'عَيْن فَرْقٌ':Added, #3: 3	عَيْنُ الْفَرْقِ
u'عين فساد':Added, #3: 3	عَيْنُ الْفَرْقِ
u'عَيْنٌ فساد':Added, #1: 1	عَيْنُ الْفَسَادِ
u'عَيْن فساد':Added, #1: 1	عَيْنُ الْفَسَادِ
u'عين فَسَادٌ':Added, #1: 1	عَيْنُ الْفَسَادِ
u'عَيْنٌ فَسَادٌ':Added, #1: 1	عَيْنُ الْفَسَادِ
u'عَيْن فَسَادٌ':Added, #1: 1	عَيْنُ الْفَسَادِ
u'عين فُسْطَاطٌ':Added, #1: 1	عَيْنُ الْفَسَادِ
u'عَيْنٌ فُسْطَاطٌ':Added, #1: 1	عَيْنُ الْفُسْطَاطِ
u'عَيْن فُسْطَاطٌ':Added, #1: 1	عَيْنُ الْفُسْطَاطِ
u'عين فَسْلٌ':Added, #1: 1	عَيْنُ الْفُسْطَاطِ
u'عَيْنٌ فَسْلٌ':Added, #1: 1	عَيْنِ الْفَسْلِ
u'عَيْن فَسْلٌ':Added, #1: 1	عَيْنِ الْفَسْلِ
u'عين فَصِيلٌ':Added, #1: 1	عَيْنِ الْفَسْلِ
u'عَيْنٌ فَصِيلٌ':Added, #1: 1	عَيْنِ الْفَصِيلِ
u'عَيْن فَصِيلٌ':Added, #1: 1	عَيْنِ الْفَصِيلِ
u'عين فِضَّةٌ':Added, #1: 1	عَيْنِ الْفَصِيلِ
u'عَيْنٌ فِضَّةٌ':Added, #2: 2	عَيْنِ الْفِضَّةِ
u'عَيْن فِضَّةٌ':Added, #2: 2	عَيْنِ الْفِضَّةِ
u'عَيَّنَ فِعْلٌ':Predicate, #2: 2	عَيْنِ الْفِضَّةِ
u'عين فِعْلٌ':Added, #1: 1	عَيَّنَ الْفِعْلَ
u'عين فِعْلٌ':Added, #1: 1	عَيْنَ فِعْلِ
u'عَيْنٌ فِعْلٌ':Added, #1: 1	عَيْنُ فِعْلِ
u'عَيْنٌ فِعْلٌ':Added, #1: 1	عَيْنَ فِعْلِ
u'عَيْن فِعْلٌ':Added, #1: 1	عَيْنُ فِعْلِ
u'عَيْن فِعْلٌ':Added, #1: 1	عَيْنَ فِعْلِ
u'عين فِعْلٌ':Added, #1: 1	عَيْنُ فِعْلِ
u'عَيْنٌ فِعْلٌ':Added, #1: 1	عَيْنِ فِعْلِهِ
u'عَيْن فِعْلٌ':Added, #1: 1	عَيْنِ فِعْلِهِ
u'عين فِعْلٌ':Added, #1: 1	عَيْنِ فِعْلِهِ
u'عَيْنٌ فِعْلٌ':Added, #3: 3	عَيْنِ الْفِعْلِ
u'عَيْن فِعْلٌ':Added, #3: 3	عَيْنِ الْفِعْلِ
u'عين فِعْلٌ':Added, #3: 3	عَيْنِ الْفِعْلِ
u'عَيْنٌ فِعْلٌ':Added, #4: 4	عَيْنَ الْفِعْلِ
u'عَيْن فِعْلٌ':Added, #4: 4	عَيْنَ الْفِعْلِ
u'عين فِعْلٌ':Added, #4: 4	عَيْنَ الْفِعْلِ
u'عَيْنٌ فِعْلٌ':Added, #7: 7	عَيْنُ الْفِعْلِ
u'عَيْن فِعْلٌ':Added, #7: 7	عَيْنُ الْفِعْلِ
u'عين فِقْهٌ':Added, #7: 7	عَيْنُ الْفِعْلِ
u'عَيْنٌ فِقْهٌ':Added, #2: 2	عَيْنُ الْفِقْهِ
u'عَيْن فِقْهٌ':Added, #2: 2	عَيْنُ الْفِقْهِ
u'عَيَّنَ فَقِيرٌ':Predicate, #2: 2	عَيْنُ الْفِقْهِ
u'عين فُلاَنٌ':Added, #1: 1	عَيَّنَ الْفَقِيرَ
u'عين فُلاَنٌ':Added, #1: 1	عَيْنَ فُلَانٍ
u'عَيْنٌ فُلاَنٌ':Added, #1: 1	عَيْنُ فُلَانٍ
u'عَيْنٌ فُلاَنٌ':Added, #1: 1	عَيْنَ فُلَانٍ
u'عَيْن فُلاَنٌ':Added, #1: 1	عَيْنُ فُلَانٍ
u'عَيْن فُلاَنٌ':Added, #1: 1	عَيْنَ فُلَانٍ
u'عَيْنٌ فَوَّارَةٌ':Added, #1: 1	عَيْنُ فُلَانٍ
u'عَيْن فَوَّارَةٌ':Added, #2: 2	عَيْنٍ فَوَّارَةٍ
u'عين فِيلٌ':Added, #2: 2	عَيْنٍ فَوَّارَةٍ
u'عَيْنٌ فِيلٌ':Added, #1: 1	عَيْنِ الْفِيلِ
u'عَيْن فِيلٌ':Added, #1: 1	عَيْنِ الْفِيلِ
u'عين قَابِلِيَّةٌ':Added, #1: 1	عَيْنِ الْفِيلِ
u'عَيْنٌ قَابِلِيَّةٌ':Added, #1: 1	عَيْنُ الْقَابِلِيَّةِ
u'عَيْن قَابِلِيَّةٌ':Added, #1: 1	عَيْنُ الْقَابِلِيَّةِ
u'عين قَاتِلٌ':Added, #1: 1	عَيْنُ الْقَابِلِيَّةِ
u'عَيْنٌ قَاتِلٌ':Added, #2: 2	عَيْنُ الْقَاتِلِ
u'عَيْن قَاتِلٌ':Added, #2: 2	عَيْنُ الْقَاتِلِ
u'عَيْنٌ قَائِمٌ':Added, #2: 2	عَيْنُ الْقَاتِلِ
u'عَيْن قَائِمٌ':Added, #1: 1	عَيْنٍ قَائِمٍ
u'عَيْنٌ قَائِمَةٌ':Added, #1: 1	عَيْنٍ قَائِمٍ
u'عَيْن قَائِمَةٌ':Added, #3: 3	عَيْنٍ قَائِمَةٍ
u'عين قِبْلَةٌ':Added, #3: 3	عَيْنٍ قَائِمَةٍ
u'عَيْنٌ قِبْلَةٌ':Added, #1: 1	عَيْنَ الْقِبْلَةِ
u'عَيْن قِبْلَةٌ':Added, #1: 1	عَيْنَ الْقِبْلَةِ
u'عين قِبْلَةٌ':Added, #1: 1	عَيْنَ الْقِبْلَةِ
u'عين قِبْلَةٌ':Added, #2: 2	عَيْنُ الْقِبْلَةِ
u'عَيْنٌ قِبْلَةٌ':Added, #2: 2	عَيْنِ الْقِبْلَةِ
u'عَيْنٌ قِبْلَةٌ':Added, #2: 2	عَيْنُ الْقِبْلَةِ
u'عَيْن قِبْلَةٌ':Added, #2: 2	عَيْنِ الْقِبْلَةِ
u'عَيْن قِبْلَةٌ':Added, #2: 2	عَيْنُ الْقِبْلَةِ
u'عين قتل':Added, #2: 2	عَيْنِ الْقِبْلَةِ
u'عَيْنٌ قتل':Added, #1: 1	عَيْنُ الْقَتْلِ
u'عَيْن قتل':Added, #1: 1	عَيْنُ الْقَتْلِ
u'عين قَتْلٌ':Added, #1: 1	عَيْنُ الْقَتْلِ
u'عَيْنٌ قَتْلٌ':Added, #1: 1	عَيْنُ الْقَتْلِ
u'عَيْن قَتْلٌ':Added, #1: 1	عَيْنُ الْقَتْلِ
u'عَيَّنَ قَتِيلٌ':Predicate, #1: 1	عَيْنُ الْقَتْلِ
u'عين قَدْرٌ':Added, #1: 1	عَيَّنَ الْقَتِيلَ
u'عَيْنٌ قَدْرٌ':Added, #1: 1	عَيْنُ قَدْرِهِ
u'عَيْن قَدْرٌ':Added, #1: 1	عَيْنُ قَدْرِهِ
u'عَيَّنَ قِرَاءةٌ':Predicate, #1: 1	عَيْنُ قَدْرِهِ
u'عين قِرَاءةٌ':Added, #1: 1	عَيَّنَ قِرَاءَةَ
u'عَيْنٌ قِرَاءةٌ':Added, #3: 3	عَيْنُ الْقِرَاءَةِ
u'عَيْن قِرَاءةٌ':Added, #3: 3	عَيْنُ الْقِرَاءَةِ
u'عين قرار':Added, #3: 3	عَيْنُ الْقِرَاءَةِ
u'عَيْنٌ قرار':Added, #1: 1	عَيْنَ الْقَرَارِ
u'عَيْن قرار':Added, #1: 1	عَيْنَ الْقَرَارِ
u'عين قَرَارٌ':Added, #1: 1	عَيْنَ الْقَرَارِ
u'عَيْنٌ قَرَارٌ':Added, #1: 1	عَيْنَ الْقَرَارِ
u'عَيْن قَرَارٌ':Added, #1: 1	عَيْنَ الْقَرَارِ
u'عين قرار':Added, #1: 1	عَيْنَ الْقَرَارِ
u'عَيْنٌ قرار':Added, #2: 2	عَيْنُ الْقَرَارِ
u'عَيْن قرار':Added, #2: 2	عَيْنُ الْقَرَارِ
u'عين قَرَارٌ':Added, #2: 2	عَيْنُ الْقَرَارِ
u'عَيْنٌ قَرَارٌ':Added, #2: 2	عَيْنُ الْقَرَارِ
u'عَيْن قَرَارٌ':Added, #2: 2	عَيْنُ الْقَرَارِ
u'عين قَرْضٌ':Added, #2: 2	عَيْنُ الْقَرَارِ
u'عَيْنٌ قَرْضٌ':Added, #1: 1	عَيْنُ الْقَرْضِ
u'عَيْن قَرْضٌ':Added, #1: 1	عَيْنُ الْقَرْضِ
u'عين قَرْضٌ':Added, #1: 1	عَيْنُ الْقَرْضِ
u'عَيْنٌ قَرْضٌ':Added, #1: 1	عَيْنَ قَرْضِهِ
u'عَيْن قَرْضٌ':Added, #1: 1	عَيْنَ قَرْضِهِ
u'عين قَرْضٌ':Added, #1: 1	عَيْنَ قَرْضِهِ
u'عين قَرْضٌ':Added, #2: 2	عَيْنَ الْقَرْضِ
u'عَيْنٌ قَرْضٌ':Added, #2: 2	عَيْنِ الْقَرْضِ
u'عَيْنٌ قَرْضٌ':Added, #2: 2	عَيْنَ الْقَرْضِ
u'عَيْن قَرْضٌ':Added, #2: 2	عَيْنِ الْقَرْضِ
u'عَيْن قَرْضٌ':Added, #2: 2	عَيْنَ الْقَرْضِ
u'عين قُرَيْشٌ':Added, #2: 2	عَيْنِ الْقَرْضِ
u'عَيْنٌ قُرَيْشٌ':Added, #1: 1	عَيْنَ قُرَيْشٍ
u'عَيْن قُرَيْشٌ':Added, #1: 1	عَيْنَ قُرَيْشٍ
u'عين قَضَاءٌ':Added, #1: 1	عَيْنَ قُرَيْشٍ
u'عَيْنٌ قَضَاءٌ':Added, #2: 2	عَيْنُ الْقَضَاءِ
u'عَيْن قَضَاءٌ':Added, #2: 2	عَيْنُ الْقَضَاءِ
u'عين قول':Added, #2: 2	عَيْنُ الْقَضَاءِ
u'عَيْنٌ قول':Added, #1: 1	عَيْنُ الْقَوْلِ
u'عَيْن قول':Added, #1: 1	عَيْنُ الْقَوْلِ
u'عين قَوْلٌ':Added, #1: 1	عَيْنُ الْقَوْلِ
u'عَيْنٌ قَوْلٌ':Added, #1: 1	عَيْنُ الْقَوْلِ
u'عَيْن قَوْلٌ':Added, #1: 1	عَيْنُ الْقَوْلِ
u'عين قول':Added, #1: 1	عَيْنُ الْقَوْلِ
u'عَيْنٌ قول':Added, #3: 3	عَيْنُ قَوْلِهِ
u'عَيْن قول':Added, #3: 3	عَيْنُ قَوْلِهِ
u'عين قَوْلٌ':Added, #3: 3	عَيْنُ قَوْلِهِ
u'عَيْنٌ قَوْلٌ':Added, #3: 3	عَيْنُ قَوْلِهِ
u'عَيْن قَوْلٌ':Added, #3: 3	عَيْنُ قَوْلِهِ
u'عين قول':Added, #3: 3	عَيْنُ قَوْلِهِ
u'عَيْنٌ قول':Added, #6: 6	عَيْنُ قَوْلِ
u'عَيْن قول':Added, #6: 6	عَيْنُ قَوْلِ
u'عين قَوْلٌ':Added, #6: 6	عَيْنُ قَوْلِ
u'عَيْنٌ قَوْلٌ':Added, #6: 6	عَيْنُ قَوْلِ
u'عَيْن قَوْلٌ':Added, #6: 6	عَيْنُ قَوْلِ
u'عين قَوْمٌ':Added, #6: 6	عَيْنُ قَوْلِ
u'عَيْنٌ قَوْمٌ':Added, #2: 2	عَيْنُ الْقَوْمِ
u'عَيْن قَوْمٌ':Added, #2: 2	عَيْنُ الْقَوْمِ
u'عين قِير':Added, #2: 2	عَيْنُ الْقَوْمِ
u'عَيْنٌ قِير':Added, #1: 1	عَيْنُ الْقِيرِ
u'عَيْن قِير':Added, #1: 1	عَيْنُ الْقِيرِ
u'عين قِير':Added, #1: 1	عَيْنُ الْقِيرِ
u'عَيْنٌ قِير':Added, #1: 1	عَيْنَ قِيرٍ
u'عَيْن قِير':Added, #1: 1	عَيْنَ قِيرٍ
u'عين قِير':Added, #1: 1	عَيْنَ قِيرٍ
u'عَيْنٌ قِير':Added, #4: 4	عَيْنِ الْقِيرِ
u'عَيْن قِير':Added, #4: 4	عَيْنِ الْقِيرِ
u'عين قِيمَةٌ':Added, #4: 4	عَيْنِ الْقِيرِ
u'عَيْنٌ قِيمَةٌ':Added, #1: 1	عَيْنِ قِيمَتِهِ
u'عَيْن قِيمَةٌ':Added, #1: 1	عَيْنِ قِيمَتِهِ
u'عين كبر':Added, #1: 1	عَيْنِ قِيمَتِهِ
u'عَيْنٌ كبر':Added, #1: 1	عَيْنَ الْكِبْرِ
u'عَيْن كبر':Added, #1: 1	عَيْنَ الْكِبْرِ
u'عين كِبْرٌ':Added, #1: 1	عَيْنَ الْكِبْرِ
u'عَيْنٌ كِبْرٌ':Added, #1: 1	عَيْنَ الْكِبْرِ
u'عَيْن كِبْرٌ':Added, #1: 1	عَيْنَ الْكِبْرِ
u'عين كحل':Added, #1: 1	عَيْنَ الْكِبْرِ
u'عَيْنٌ كحل':Added, #1: 1	عَيْنُ الْكُحْلِ
u'عَيْن كحل':Added, #1: 1	عَيْنُ الْكُحْلِ
u'عين كُحْلٌ':Added, #1: 1	عَيْنُ الْكُحْلِ
u'عَيْنٌ كُحْلٌ':Added, #1: 1	عَيْنُ الْكُحْلِ
u'عَيْن كُحْلٌ':Added, #1: 1	عَيْنُ الْكُحْلِ
u'عين كُرَاعٌ':Added, #1: 1	عَيْنُ الْكُحْلِ
u'عَيْنٌ كُرَاعٌ':Added, #1: 1	عَيْنِ الْكُرَاعِ
u'عَيْن كُرَاعٌ':Added, #1: 1	عَيْنِ الْكُرَاعِ
u'عين كَرَاهَةٌ':Added, #1: 1	عَيْنِ الْكُرَاعِ
u'عَيْنٌ كَرَاهَةٌ':Added, #1: 1	عَيْنُ كَرَاهَةِ
u'عَيْن كَرَاهَةٌ':Added, #1: 1	عَيْنُ كَرَاهَةِ
u'عَيَّنَ كعبة':Predicate, #1: 1	عَيْنُ كَرَاهَةِ
u'عَيَّنَ كَعْبَةٌ':Predicate, #1: 1	عَيَّنَ الْكَعْبَةَ
u'عين كعبة':Added, #1: 1	عَيَّنَ الْكَعْبَةَ
u'عَيْنٌ كعبة':Added, #1: 1	عَيْنُ الْكَعْبَةِ
u'عَيْن كعبة':Added, #1: 1	عَيْنُ الْكَعْبَةِ
u'عين كَعْبَةٌ':Added, #1: 1	عَيْنُ الْكَعْبَةِ
u'عَيْنٌ كَعْبَةٌ':Added, #1: 1	عَيْنُ الْكَعْبَةِ
u'عَيْن كَعْبَةٌ':Added, #1: 1	عَيْنُ الْكَعْبَةِ
u'عين كعبة':Added, #1: 1	عَيْنُ الْكَعْبَةِ
u'عَيْنٌ كعبة':Added, #2: 2	عَيْنَ الْكَعْبَةِ
u'عَيْن كعبة':Added, #2: 2	عَيْنَ الْكَعْبَةِ
u'عين كَعْبَةٌ':Added, #2: 2	عَيْنَ الْكَعْبَةِ
u'عَيْنٌ كَعْبَةٌ':Added, #2: 2	عَيْنَ الْكَعْبَةِ
u'عَيْن كَعْبَةٌ':Added, #2: 2	عَيْنَ الْكَعْبَةِ
u'عين كعبة':Added, #2: 2	عَيْنَ الْكَعْبَةِ
u'عَيْنٌ كعبة':Added, #7: 7	عَيْنِ الْكَعْبَةِ
u'عَيْن كعبة':Added, #7: 7	عَيْنِ الْكَعْبَةِ
u'عين كَعْبَةٌ':Added, #7: 7	عَيْنِ الْكَعْبَةِ
u'عَيْنٌ كَعْبَةٌ':Added, #7: 7	عَيْنِ الْكَعْبَةِ
u'عَيْن كَعْبَةٌ':Added, #7: 7	عَيْنِ الْكَعْبَةِ
u'عين كُفَّارٌ':Added, #7: 7	عَيْنِ الْكَعْبَةِ
u'عين كَلاَمٌ':Added, #1: 1	أَعْيُنَ الْكُفّارِ
u'عَيْنٌ كَلاَمٌ':Added, #3: 3	عَيْنُ كَلَامِ
u'عَيْن كَلاَمٌ':Added, #3: 3	عَيْنُ كَلَامِ
u'عين كَلْبٌ':Added, #3: 3	عَيْنُ كَلَامِ
u'عَيْنٌ كَلْبٌ':Added, #1: 1	عَيْنُ الْكَلْبِ
u'عَيْن كَلْبٌ':Added, #1: 1	عَيْنُ الْكَلْبِ
u'عين كَلْبٌ':Added, #1: 1	عَيْنُ الْكَلْبِ
u'عَيْنٌ كَلْبٌ':Added, #2: 2	عَيْنِ الْكَلْبِ
u'عَيْن كَلْبٌ':Added, #2: 2	عَيْنِ الْكَلْبِ
u'عين كَلْبٌ':Added, #2: 2	عَيْنِ الْكَلْبِ
u'عَيْنٌ كَلْبٌ':Added, #4: 4	عَيْنَ الْكَلْبِ
u'عَيْن كَلْبٌ':Added, #4: 4	عَيْنَ الْكَلْبِ
u'عين كَلِمَةٌ':Added, #4: 4	عَيْنَ الْكَلْبِ
u'عَيْنٌ كَلِمَةٌ':Added, #1: 1	عَيْنَ الْكَلِمَةِ
u'عَيْن كَلِمَةٌ':Added, #1: 1	عَيْنَ الْكَلِمَةِ
u'عين كَلِمَةٌ':Added, #1: 1	عَيْنَ الْكَلِمَةِ
u'عَيْنٌ كَلِمَةٌ':Added, #2: 2	عَيْنِ الْكَلِمَةِ
u'عَيْن كَلِمَةٌ':Added, #2: 2	عَيْنِ الْكَلِمَةِ
u'عَيَّنَ كُوفَةٌ':Predicate, #2: 2	عَيْنِ الْكَلِمَةِ
u'عين لبن':Added, #1: 1	عَيَّنَ الْكُوفَةَ
u'عَيْنٌ لبن':Added, #2: 2	عَيْنِ اللَّبَنِ
u'عَيْن لبن':Added, #2: 2	عَيْنِ اللَّبَنِ
u'عين لَبَنٌ':Added, #2: 2	عَيْنِ اللَّبَنِ
u'عَيْنٌ لَبَنٌ':Added, #2: 2	عَيْنِ اللَّبَنِ
u'عَيْن لَبَنٌ':Added, #2: 2	عَيْنِ اللَّبَنِ
u'عين لَحْمٌ':Added, #2: 2	عَيْنِ اللَّبَنِ
u'عَيْنٌ لَحْمٌ':Added, #1: 1	عَيْنَ اللَّحْمِ
u'عَيْن لَحْمٌ':Added, #1: 1	عَيْنَ اللَّحْمِ
u'عين لَفْظٌ':Added, #1: 1	عَيْنَ اللَّحْمِ
u'عين لَفْظٌ':Added, #1: 1	عَيْنُ اللَّفْظِ
u'عَيْنٌ لَفْظٌ':Added, #1: 1	عَيْنِ اللَّفْظِ
u'عَيْنٌ لَفْظٌ':Added, #1: 1	عَيْنُ اللَّفْظِ
u'عَيْن لَفْظٌ':Added, #1: 1	عَيْنِ اللَّفْظِ
u'عَيْن لَفْظٌ':Added, #1: 1	عَيْنُ اللَّفْظِ
u'عين لَفْظٌ':Added, #1: 1	عَيْنِ اللَّفْظِ
u'عَيْنٌ لَفْظٌ':Added, #1: 1	عَيْنُ لَفْظِ
u'عَيْن لَفْظٌ':Added, #1: 1	عَيْنُ لَفْظِ
u'عين مَاءٌ':Added, #1: 1	عَيْنُ لَفْظِ
u'عَيْنٌ مَاءٌ':Added, #1: 1	عَيْنَ الْمَاءِ
u'عَيْن مَاءٌ':Added, #1: 1	عَيْنَ الْمَاءِ
u'عين مَاءٌ':Added, #1: 1	عَيْنَ الْمَاءِ
u'عَيْنٌ مَاءٌ':Added, #6: 6	عَيْنُ مَاءٍ
u'عَيْن مَاءٌ':Added, #6: 6	عَيْنُ مَاءٍ
u'عين مَأْكُولٌ':Added, #6: 6	عَيْنُ مَاءٍ
u'عَيْنٌ مَأْكُولٌ':Added, #1: 1	عَيْنِ الْمَأْكُولِ
u'عَيْن مَأْكُولٌ':Added, #1: 1	عَيْنِ الْمَأْكُولِ
u'عَيْنٌ مَأْكُولٌ':Added, #1: 1	عَيْنِ الْمَأْكُولِ
u'عَيْن مَأْكُولٌ':Added, #1: 1	عَيْنٍ مَأْكُولٍ
u'عَيَّنَ مَالٌ':Predicate, #1: 1	عَيْنٍ مَأْكُولٍ
u'عَيَّنَ مَالٌ':Predicate, #1: 1	عَيَّنَ الْمَالَ
u'عين مَالٌ':Added, #1: 1	عَيَّنَ مَالَ
u'عَيْنٌ مَالٌ':Added, #14: 14	عَيْنُ مَالٍ
u'عَيْن مَالٌ':Added, #14: 14	عَيْنُ مَالٍ
u'عين مَالٌ':Added, #14: 14	عَيْنُ مَالٍ
u'عين مَالٌ':Added, #1: 1	عَيْنَ الْمَالِ
u'عَيْنٌ مَالٌ':Added, #1: 1	عَيْنُ الْمَالِ
u'عَيْنٌ مَالٌ':Added, #1: 1	عَيْنَ الْمَالِ
u'عَيْن مَالٌ':Added, #1: 1	عَيْنُ الْمَالِ
u'عَيْن مَالٌ':Added, #1: 1	عَيْنَ الْمَالِ
u'عين مَالٌ':Added, #1: 1	عَيْنُ الْمَالِ
u'عَيْنٌ مَالٌ':Added, #1: 1	عَيْن مَالِهِ
u'عَيْن مَالٌ':Added, #1: 1	عَيْن مَالِهِ
u'عين مَالٌ':Added, #1: 1	عَيْن مَالِهِ
u'عَيْنٌ مَالٌ':Added, #20: 20	عَيْنُ مَالِهِ
u'عَيْن مَالٌ':Added, #20: 20	عَيْنُ مَالِهِ
u'عين مَالٌ':Added, #20: 20	عَيْنُ مَالِهِ
u'عَيْنٌ مَالٌ':Added, #24: 24	عَيْنِ الْمَالِ
u'عَيْن مَالٌ':Added, #24: 24	عَيْنِ الْمَالِ
u'عين مَالٌ':Added, #24: 24	عَيْنِ الْمَالِ
u'عين مَالٌ':Added, #27: 27	عَيْنَ مَالِهِ
u'عَيْنٌ مَالٌ':Added, #27: 27	عَيْنِ مَالِهِ
u'عَيْنٌ مَالٌ':Added, #27: 27	عَيْنَ مَالِهِ
u'عَيْن مَالٌ':Added, #27: 27	عَيْنِ مَالِهِ
u'عَيْن مَالٌ':Added, #27: 27	عَيْنَ مَالِهِ
u'عين مَالٌ':Added, #27: 27	عَيْنِ مَالِهِ
u'عَيْنٌ مَالٌ':Added, #3: 3	عَيْنَ مَالِ
u'عَيْن مَالٌ':Added, #3: 3	عَيْنَ مَالِ
u'عين مَالٌ':Added, #3: 3	عَيْنَ مَالِ
u'عين مَالٌ':Added, #4: 4	عَيْنُ مَالِ
u'عَيْنٌ مَالٌ':Added, #4: 4	عَيْنِ مَالِ
u'عَيْنٌ مَالٌ':Added, #4: 4	عَيْنُ مَالِ
u'عَيْن مَالٌ':Added, #4: 4	عَيْنِ مَالِ
u'عَيْن مَالٌ':Added, #4: 4	عَيْنُ مَالِ
u'عين مَالٌ':Added, #4: 4	عَيْنِ مَالِ
u'عَيْنٌ مَالٌ':Added, #5: 5	عَيْنِ مَالٍ
u'عَيْن مَالٌ':Added, #5: 5	عَيْنِ مَالٍ
u'عين مَالٌ':Added, #5: 5	عَيْنِ مَالٍ
u'عَيْنٌ مَالٌ':Added, #6: 6	عَيْنَ مَالٍ
u'عَيْن مَالٌ':Added, #6: 6	عَيْنَ مَالٍ
u'عَيَّنَ مَالِكٌ':Subject, #6: 6	عَيْنَ مَالٍ
u'عين مَالِكٌ':Added, #3: 3	عَيَّنَ الْمَالِكُ
u'عَيْنٌ مَالِكٌ':Added, #1: 1	عَيْنِ الْمَالِكِ
u'عَيْن مَالِكٌ':Added, #1: 1	عَيْنِ الْمَالِكِ
u'عين مَالِكٌ':Added, #1: 1	عَيْنِ الْمَالِكِ
u'عَيْنٌ مَالِكٌ':Added, #1: 1	عَيْنُ مَالِكِهِ
u'عَيْن مَالِكٌ':Added, #1: 1	عَيْنُ مَالِكِهِ
u'عين مَالِكٌ':Added, #1: 1	عَيْنُ مَالِكِهِ
u'عَيْنٌ مَالِكٌ':Added, #3: 3	عَيْنُ الْمَالِكِ
u'عَيْن مَالِكٌ':Added, #3: 3	عَيْنُ الْمَالِكِ
u'عَيْنٌ مُبَاحٌ':Added, #3: 3	عَيْنُ الْمَالِكِ
u'عَيْن مُبَاحٌ':Added, #4: 4	عَيْنٍ مُبَاحٍ
u'عَيَّنَ مُبْهَمٌ':Predicate, #4: 4	عَيْنٍ مُبَاحٍ
u'عَيَّنَ مَبِيعٌ':Predicate, #1: 1	عَيَّنَ الْمُبْهَمَ
u'عين مَبِيعٌ':Added, #2: 2	عَيَّنَ الْمَبِيعَ
u'عَيْنٌ مَبِيعٌ':Added, #14: 14	عَيْنِ الْمَبِيعِ
u'عَيْن مَبِيعٌ':Added, #14: 14	عَيْنِ الْمَبِيعِ
u'عين مَبِيعٌ':Added, #14: 14	عَيْنِ الْمَبِيعِ
u'عَيْنٌ مَبِيعٌ':Added, #2: 2	عَيْنُ الْمَبِيعِ
u'عَيْن مَبِيعٌ':Added, #2: 2	عَيْنُ الْمَبِيعِ
u'عين مَبِيعٌ':Added, #2: 2	عَيْنُ الْمَبِيعِ
u'عَيْنٌ مَبِيعٌ':Added, #3: 3	عَيْنَ الْمَبِيعِ
u'عَيْن مَبِيعٌ':Added, #3: 3	عَيْنَ الْمَبِيعِ
u'عين مَتَاعٌ':Added, #3: 3	عَيْنَ الْمَبِيعِ
u'عَيْنٌ مَتَاعٌ':Added, #1: 1	عَيْنِ الْمَتَاعِ
u'عَيْن مَتَاعٌ':Added, #1: 1	عَيْنِ الْمَتَاعِ
u'عين مَتَاعٌ':Added, #1: 1	عَيْنِ الْمَتَاعِ
u'عَيْنٌ مَتَاعٌ':Added, #1: 1	عَيْنَ مَتَاعِهِ
u'عَيْن مَتَاعٌ':Added, #1: 1	عَيْنَ مَتَاعِهِ
u'عين مُتَقَدِّمٌ':Added, #1: 1	عَيْنَ مَتَاعِهِ
u'عَيْنٌ مُتَقَدِّمٌ':Added, #1: 1	عَيْنُ الْمُتَقَدِّمِ
u'عَيْن مُتَقَدِّمٌ':Added, #1: 1	عَيْنُ الْمُتَقَدِّمِ
u'عين مثل':Added, #1: 1	عَيْنُ الْمُتَقَدِّمِ
u'عَيْنٌ مثل':Added, #1: 1	عَيْنَ مِثْلِهِ
u'عَيْن مثل':Added, #1: 1	عَيْنَ مِثْلِهِ
u'عين مِثْلٌ':Added, #1: 1	عَيْنَ مِثْلِهِ
u'عَيْنٌ مِثْلٌ':Added, #1: 1	عَيْنَ مِثْلِهِ
u'عَيْن مِثْلٌ':Added, #1: 1	عَيْنَ مِثْلِهِ
u'عين مِثْلِيٌّ':Added, #1: 1	عَيْنَ مِثْلِهِ
u'عَيْنٌ مِثْلِيٌّ':Added, #1: 1	عَيْنِ الْمِثْلِيِّ
u'عَيْن مِثْلِيٌّ':Added, #1: 1	عَيْنِ الْمِثْلِيِّ
u'عَيَّنَ مَجْلِسٌ':Predicate, #1: 1	عَيْنِ الْمِثْلِيِّ
u'عَيَّنَ مَجْمُوعٌ':Predicate, #1: 1	عَيَّنَ مَجْلِسَ
u'عَيَّنَ مُحْتَمَلٌ':Predicate, #1: 1	عَيَّنَ الْمَجْمُوعَ
u'عين مَحْدُودٌ':Added, #1: 1	عَيَّنَ الْمُحْتَمَلَ
u'عَيْنٌ مَحْدُودٌ':Added, #1: 1	عَيْنُ الْمَحْدُودِ
u'عَيْن مَحْدُودٌ':Added, #1: 1	عَيْنُ الْمَحْدُودِ
u'عين مَحْكُومٌ':Added, #1: 1	عَيْنُ الْمَحْدُودِ
u'عَيْنٌ مَحْكُومٌ':Added, #2: 2	عَيْنِ الْمَحْكُومِ
u'عَيْن مَحْكُومٌ':Added, #2: 2	عَيْنِ الْمَحْكُومِ
u'عين مَحَلٌّ':Added, #2: 2	عَيْنِ الْمَحْكُومِ
u'عَيْنٌ مَحَلٌّ':Added, #1: 1	عَيْنِ الْمَحَلِّ
u'عَيْن مَحَلٌّ':Added, #1: 1	عَيْنِ الْمَحَلِّ
u'عين مَحَلٌّ':Added, #1: 1	عَيْنِ الْمَحَلِّ
u'عَيْنٌ مَحَلٌّ':Added, #1: 1	عَيْنُ مَحَلِّ
u'عَيْن مَحَلٌّ':Added, #1: 1	عَيْنُ مَحَلِّ
u'عين مُحَمَّدٌ':Added, #1: 1	عَيْنُ مَحَلِّ
u'عَيْنٌ مُحَمَّدٌ':Added, #1: 1	عَيْنَ مُحَمّدٍ
u'عَيْن مُحَمَّدٌ':Added, #1: 1	عَيْنَ مُحَمّدٍ
u'عين مُخَالَفَةٌ':Added, #1: 1	عَيْنَ مُحَمّدٍ
u'عَيْنٌ مُخَالَفَةٌ':Added, #1: 1	عَيْنُ الْمُخَالَفَةِ
u'عَيْن مُخَالَفَةٌ':Added, #1: 1	عَيْنُ الْمُخَالَفَةِ
u'عين مُخْتَلِطٌ':Added, #1: 1	عَيْنُ الْمُخَالَفَةِ
u'عَيْنٌ مُخْتَلِطٌ':Added, #1: 1	عَيْنِ الْمُخْتَلِطِ
u'عَيْن مُخْتَلِطٌ':Added, #1: 1	عَيْنِ الْمُخْتَلِطِ
u'عين مُدَبَّرٌ':Added, #1: 1	عَيْنِ الْمُخْتَلِطِ
u'عَيْنٌ مُدَبَّرٌ':Added, #1: 1	عَيْنَ الْمُدَبَّرِ
u'عَيْن مُدَبَّرٌ':Added, #1: 1	عَيْنَ الْمُدَبَّرِ
u'عَيَّنَ مُدَّةٌ':Predicate, #1: 1	عَيْنَ الْمُدَبَّرِ
u'عين مَدْخُولٌ':Added, #2: 2	عَيَّنَ مُدَّةَ
u'عَيْنٌ مَدْخُولٌ':Added, #1: 1	عَيْنِ الْمَدْخُولِ
u'عَيْن مَدْخُولٌ':Added, #1: 1	عَيْنِ الْمَدْخُولِ
u'عَيْنٌ مُدَّعاة':Added, #1: 1	عَيْنِ الْمَدْخُولِ
u'عَيْن مُدَّعاة':Added, #2: 2	عَيْنٍ مُدَّعَاةٍ
u'عين مَذْهَبٌ':Added, #2: 2	عَيْنٍ مُدَّعَاةٍ
u'عَيْنٌ مَذْهَبٌ':Added, #1: 1	عَيْنُ الْمَذْهَبِ
u'عَيْن مَذْهَبٌ':Added, #1: 1	عَيْنُ الْمَذْهَبِ
u'عين مَذْهَبٌ':Added, #1: 1	عَيْنُ الْمَذْهَبِ
u'عَيْنٌ مَذْهَبٌ':Added, #4: 4	عَيْنُ مَذْهَبِ
u'عَيْن مَذْهَبٌ':Added, #4: 4	عَيْنُ مَذْهَبِ
u'عَيَّنَ مرٌّ':Predicate, #4: 4	عَيْنُ مَذْهَبِ
u'عين مراد':Added, #1: 1	عَيَّنَ مَرَّةً
u'عين مراد':Added, #1: 1	عَيْنَ الْمُرَادِ
u'عَيْنٌ مراد':Added, #1: 1	عَيْنِ الْمُرَادِ
u'عَيْنٌ مراد':Added, #1: 1	عَيْنَ الْمُرَادِ
u'عَيْن مراد':Added, #1: 1	عَيْنِ الْمُرَادِ
u'عَيْن مراد':Added, #1: 1	عَيْنَ الْمُرَادِ
u'عين مُرَادٌ':Added, #1: 1	عَيْنِ الْمُرَادِ
u'عين مُرَادٌ':Added, #1: 1	عَيْنَ الْمُرَادِ
u'عَيْنٌ مُرَادٌ':Added, #1: 1	عَيْنِ الْمُرَادِ
u'عَيْنٌ مُرَادٌ':Added, #1: 1	عَيْنَ الْمُرَادِ
u'عَيْن مُرَادٌ':Added, #1: 1	عَيْنِ الْمُرَادِ
u'عَيْن مُرَادٌ':Added, #1: 1	عَيْنَ الْمُرَادِ
u'عين مَرَضٌ':Added, #1: 1	عَيْنِ الْمُرَادِ
u'عَيْنٌ مَرَضٌ':Added, #1: 1	عَيْنِ الْمَرَضِ
u'عَيْن مَرَضٌ':Added, #1: 1	عَيْنِ الْمَرَضِ
u'عين مَرْهُونٌ':Added, #1: 1	عَيْنِ الْمَرَضِ
u'عَيْنٌ مَرْهُونٌ':Added, #2: 2	عَيْنِ الْمَرْهُونِ
u'عَيْن مَرْهُونٌ':Added, #2: 2	عَيْنِ الْمَرْهُونِ
u'عين مَسٌّ':Added, #2: 2	عَيْنِ الْمَرْهُونِ
u'عَيْنٌ مَسٌّ':Added, #1: 1	عَيْنَ مَسِّ
u'عَيْن مَسٌّ':Added, #1: 1	عَيْنَ مَسِّ
u'عين مَسٌّ':Added, #1: 1	عَيْنَ مَسِّ
u'عَيْنٌ مَسٌّ':Added, #2: 2	عَيْنَ الْمَسِّ
u'عَيْن مَسٌّ':Added, #2: 2	عَيْنَ الْمَسِّ
u'عَيَّنَ مساكين':Predicate, #2: 2	عَيْنَ الْمَسِّ
u'عين مَسْأَلَةٌ':Added, #1: 1	عَيَّنَ مَسَاكِينَ
u'عَيْنٌ مَسْأَلَةٌ':Added, #1: 1	عَيْنُ الْمَسْأَلَةِ
u'عَيْن مَسْأَلَةٌ':Added, #1: 1	عَيْنُ الْمَسْأَلَةِ
u'عين مَسْأَلَةٌ':Added, #1: 1	عَيْنُ الْمَسْأَلَةِ
u'عَيْنٌ مَسْأَلَةٌ':Added, #2: 2	عَيْنَ مَسْأَلَةِ
u'عَيْن مَسْأَلَةٌ':Added, #2: 2	عَيْنَ مَسْأَلَةِ
u'عين مَسْأَلَةٌ':Added, #2: 2	عَيْنَ مَسْأَلَةِ
u'عين مَسْأَلَةٌ':Added, #3: 3	عَيْنَ الْمَسْأَلَةِ
u'عَيْنٌ مَسْأَلَةٌ':Added, #3: 3	عَيْنِ الْمَسْأَلَةِ
u'عَيْنٌ مَسْأَلَةٌ':Added, #3: 3	عَيْنَ الْمَسْأَلَةِ
u'عَيْن مَسْأَلَةٌ':Added, #3: 3	عَيْنِ الْمَسْأَلَةِ
u'عَيْن مَسْأَلَةٌ':Added, #3: 3	عَيْنَ الْمَسْأَلَةِ
u'عين مَسْأَلَةٌ':Added, #3: 3	عَيْنِ الْمَسْأَلَةِ
u'عَيْنٌ مَسْأَلَةٌ':Added, #6: 6	عَيْنُ مَسْأَلَةِ
u'عَيْن مَسْأَلَةٌ':Added, #6: 6	عَيْنُ مَسْأَلَةِ
u'عين مُسْتَحِقٌّ':Added, #6: 6	عَيْنُ مَسْأَلَةِ
u'عَيْنٌ مُسْتَحِقٌّ':Added, #1: 1	عَيْنِ الْمُسْتَحِقِّ
u'عَيْن مُسْتَحِقٌّ':Added, #1: 1	عَيْنِ الْمُسْتَحِقِّ
u'عين مُسْتَعَارٌ':Added, #1: 1	عَيْنِ الْمُسْتَحِقِّ
u'عَيْنٌ مُسْتَعَارٌ':Added, #1: 1	عَيْنُ الْمُسْتَعَارِ
u'عَيْن مُسْتَعَارٌ':Added, #1: 1	عَيْنُ الْمُسْتَعَارِ
u'عَيَّنَ مُسْتَهْلِكٌ':Subject, #1: 1	عَيْنُ الْمُسْتَعَارِ
u'عَيَّنَ مَسْجِدٌ':Predicate, #1: 1	عَيَّنَ الْمُسْتَهْلِكُ
u'عَيَّنَ مَسْجِدٌ':Predicate, #2: 2	عَيَّنَ مَسْجِدَ
u'عين مَسْرُوقٌ':Added, #5: 5	عَيَّنَ الْمَسْجِدَ
u'عَيْنٌ مَسْرُوقٌ':Added, #3: 3	عَيْنَ الْمَسْرُوقِ
u'عَيْن مَسْرُوقٌ':Added, #3: 3	عَيْنَ الْمَسْرُوقِ
u'عَيَّنَ مِسْكِينٌ':Predicate, #3: 3	عَيْنَ الْمَسْرُوقِ
u'عين مُسْلِمٌ':Added, #1: 1	عَيَّنَ الْمِسْكِينَ
u'عَيْنٌ مُسْلِمٌ':Added, #1: 1	عَيْنِ الْمُسْلِمِ
u'عَيْن مُسْلِمٌ':Added, #1: 1	عَيْنِ الْمُسْلِمِ
u'عَيْنٌ مُسَمّاة':Added, #1: 1	عَيْنِ الْمُسْلِمِ
u'عَيْن مُسَمّاة':Added, #1: 1	عَيْنٍ مُسَمَّاةٍ
u'عين مَسْمُوعٌ':Added, #1: 1	عَيْنٍ مُسَمَّاةٍ
u'عَيْنٌ مَسْمُوعٌ':Added, #1: 1	عَيْنَ الْمَسْمُوعِ
u'عَيْن مَسْمُوعٌ':Added, #1: 1	عَيْنَ الْمَسْمُوعِ
u'عَيْنٌ مُشار':Added, #1: 1	عَيْنَ الْمَسْمُوعِ
u'عَيْن مُشار':Added, #1: 1	عَيْنٍ مُشَارٍ
u'عَيَّنَ مُشْتَرِي':Predicate, #1: 1	عَيْنٍ مُشَارٍ
u'عين مُشْرِك':Added, #1: 1	عَيَّنَ الْمُشْتَرِيَ
u'عَيْنٌ مُشْرِك':Added, #2: 2	عَيْنُ الْمُشْرِكِ
u'عَيْن مُشْرِك':Added, #2: 2	عَيْنُ الْمُشْرِكِ
u'عين مَشْرُوبٌ':Added, #2: 2	عَيْنُ الْمُشْرِكِ
u'عَيْنٌ مَشْرُوبٌ':Added, #1: 1	عَيْنَ الْمَشْرُوبِ
u'عَيْن مَشْرُوبٌ':Added, #1: 1	عَيْنَ الْمَشْرُوبِ
u'عين مَشْهُودٌ':Added, #1: 1	عَيْنَ الْمَشْرُوبِ
u'عَيْنٌ مَشْهُودٌ':Added, #1: 1	عَيْنِ الْمَشْهُودِ
u'عَيْن مَشْهُودٌ':Added, #1: 1	عَيْنِ الْمَشْهُودِ
u'عَيَّنَ مِصْرٌ':Predicate, #1: 1	عَيْنِ الْمَشْهُودِ
u'عين مُضَارِعٌ':Added, #2: 2	عَيَّنَ الْمِصْرَ
u'عَيْنٌ مُضَارِعٌ':Added, #1: 1	عَيْنِ الْمُضَارِعِ
u'عَيْن مُضَارِعٌ':Added, #1: 1	عَيْنِ الْمُضَارِعِ
u'عين مَضْمُونٌ':Added, #1: 1	عَيْنِ الْمُضَارِعِ
u'عَيْنٌ مَضْمُونٌ':Added, #1: 1	عَيْنُ مَضْمُونٍ
u'عَيْن مَضْمُونٌ':Added, #1: 1	عَيْنُ مَضْمُونٍ
u'عين مَطْرُوحٌ':Added, #1: 1	عَيْنُ مَضْمُونٍ
u'عَيْنٌ مَطْرُوحٌ':Added, #1: 1	عَيْنِ الْمَطْرُوحِ
u'عَيْن مَطْرُوحٌ':Added, #1: 1	عَيْنِ الْمَطْرُوحِ
u'عين مُطَلَّقٌ':Added, #1: 1	عَيْنِ الْمَطْرُوحِ
u'عَيْنٌ مُطَلَّقٌ':Added, #1: 1	عَيْنَ الْمُطَلَّقَةِ
u'عَيْن مُطَلَّقٌ':Added, #1: 1	عَيْنَ الْمُطَلَّقَةِ
u'عين مَطْلُوبٌ':Added, #1: 1	عَيْنَ الْمُطَلَّقَةِ
u'عَيْنٌ مَطْلُوبٌ':Added, #2: 2	عَيْنُ الْمَطْلُوبِ
u'عَيْن مَطْلُوبٌ':Added, #2: 2	عَيْنُ الْمَطْلُوبِ
u'عَيَّنَ مُعَامَلَةٌ':Predicate, #2: 2	عَيْنُ الْمَطْلُوبِ
u'عَيَّنَ مُعْتَقٌ':Predicate, #1: 1	عَيَّنَ مُعَامَلَةَ
u'عين مَعْقُودٌ':Added, #1: 1	عَيَّنَ الْمُعْتَقَةَ
u'عَيْنٌ مَعْقُودٌ':Added, #2: 2	عَيْنِ الْمَعْقُودِ
u'عَيْن مَعْقُودٌ':Added, #2: 2	عَيْنِ الْمَعْقُودِ
u'عين مَعْهُودٌ':Added, #2: 2	عَيْنِ الْمَعْقُودِ
u'عَيْنٌ مَعْهُودٌ':Added, #1: 1	عَيْنَ الْمَعْهُودِ
u'عَيْن مَعْهُودٌ':Added, #1: 1	عَيْنَ الْمَعْهُودِ
u'عَيْنٌ مُعَيَّنٌ':Added, #1: 1	عَيْنَ الْمَعْهُودِ
u'عَيْن مُعَيَّنٌ':Added, #1: 1	عَيْنٍ مُعَيَّنٍ
u'عين مَغْصُوب':Added, #1: 1	عَيْنٍ مُعَيَّنٍ
u'عَيْنٌ مَغْصُوب':Added, #2: 2	عَيْنُ الْمَغْصُوبِ
u'عَيْن مَغْصُوب':Added, #2: 2	عَيْنُ الْمَغْصُوبِ
u'عين مَغْصُوب':Added, #2: 2	عَيْنُ الْمَغْصُوبِ
u'عين مَغْصُوب':Added, #7: 7	عَيْنَ الْمَغْصُوبِ
u'عَيْنٌ مَغْصُوب':Added, #7: 7	عَيْنِ الْمَغْصُوبِ
u'عَيْنٌ مَغْصُوب':Added, #7: 7	عَيْنَ الْمَغْصُوبِ
u'عَيْن مَغْصُوب':Added, #7: 7	عَيْنِ الْمَغْصُوبِ
u'عَيْن مَغْصُوب':Added, #7: 7	عَيْنَ الْمَغْصُوبِ
u'عين مَفْسَدَةٌ':Added, #7: 7	عَيْنِ الْمَغْصُوبِ
u'عَيْنٌ مَفْسَدَةٌ':Added, #1: 1	عَيْنُ الْمَفْسَدَةِ
u'عَيْن مَفْسَدَةٌ':Added, #1: 1	عَيْنُ الْمَفْسَدَةِ
u'عين مَفْهُومٌ':Added, #1: 1	عَيْنُ الْمَفْسَدَةِ
u'عَيْنٌ مَفْهُومٌ':Added, #1: 1	عَيْنُ مَفْهُومِ
u'عَيْن مَفْهُومٌ':Added, #1: 1	عَيْنُ مَفْهُومِ
u'عين مَقَالَةٌ':Added, #1: 1	عَيْنُ مَفْهُومِ
u'عَيْنٌ مَقَالَةٌ':Added, #1: 1	عَيْنُ مَقَالَةِ
u'عَيْن مَقَالَةٌ':Added, #1: 1	عَيْنُ مَقَالَةِ
u'عين مَقْبُوضٌ':Added, #1: 1	عَيْنُ مَقَالَةِ
u'عَيْنٌ مَقْبُوضٌ':Added, #1: 1	عَيْنُ الْمَقْبُوضِ
u'عَيْن مَقْبُوضٌ':Added, #1: 1	عَيْنُ الْمَقْبُوضِ
u'عين مَقْبُوضٌ':Added, #1: 1	عَيْنُ الْمَقْبُوضِ
u'عين مَقْبُوضٌ':Added, #3: 3	عَيْنَ الْمَقْبُوضِ
u'عَيْنٌ مَقْبُوضٌ':Added, #3: 3	عَيْنِ الْمَقْبُوضِ
u'عَيْنٌ مَقْبُوضٌ':Added, #3: 3	عَيْنَ الْمَقْبُوضِ
u'عَيْن مَقْبُوضٌ':Added, #3: 3	عَيْنِ الْمَقْبُوضِ
u'عَيْن مَقْبُوضٌ':Added, #3: 3	عَيْنَ الْمَقْبُوضِ
u'عين مُقْتَرَضٌ':Added, #3: 3	عَيْنِ الْمَقْبُوضِ
u'عَيْنٌ مُقْتَرَضٌ':Added, #1: 1	عَيْنُ الْمُقْتَرَضِ
u'عَيْن مُقْتَرَضٌ':Added, #1: 1	عَيْنُ الْمُقْتَرَضِ
u'عين مُقَدَّمٌ':Added, #1: 1	عَيْنُ الْمُقْتَرَضِ
u'عين مُقَدَّمٌ':Added, #1: 1	عَيْنَ الْمُقَدَّمِ
u'عين مُقَدَّمٌ':Added, #1: 1	عَيْنُ الْمُقَدَّمِ
u'عَيْنٌ مُقَدَّمٌ':Added, #1: 1	عَيْنِ الْمُقَدَّمِ
u'عَيْنٌ مُقَدَّمٌ':Added, #1: 1	عَيْنَ الْمُقَدَّمِ
u'عَيْنٌ مُقَدَّمٌ':Added, #1: 1	عَيْنُ الْمُقَدَّمِ
u'عَيْن مُقَدَّمٌ':Added, #1: 1	عَيْنِ الْمُقَدَّمِ
u'عَيْن مُقَدَّمٌ':Added, #1: 1	عَيْنَ الْمُقَدَّمِ
u'عَيْن مُقَدَّمٌ':Added, #1: 1	عَيْنُ الْمُقَدَّمِ
u'عين مَقْطُوعٌ':Added, #1: 1	عَيْنِ الْمُقَدَّمِ
u'عَيْنٌ مَقْطُوعٌ':Added, #2: 2	عَيْنَ الْمَقْطُوعِ
u'عَيْن مَقْطُوعٌ':Added, #2: 2	عَيْنَ الْمَقْطُوعِ
u'عَيَّنَ مَكَانٌ':Predicate, #2: 2	عَيْنَ الْمَقْطُوعِ
u'عَيَّنَ مُكَلَّفٌ':Subject, #1: 1	عَيَّنَ الْمَكَانَ
u'عَيَّنَ مِكْيَالٌ':Predicate, #1: 1	عَيَّنَ الْمُكَلَّفُ
u'عين ملح':Added, #1: 1	عَيَّنَ مِكْيَالَ
u'عين ملح':Added, #1: 1	عَيْنَ الْمِلْحِ
u'عَيْنٌ ملح':Added, #1: 1	عَيْنُ الْمِلْحِ
u'عَيْنٌ ملح':Added, #1: 1	عَيْنَ الْمِلْحِ
u'عَيْن ملح':Added, #1: 1	عَيْنُ الْمِلْحِ
u'عَيْن ملح':Added, #1: 1	عَيْنَ الْمِلْحِ
u'عين مِلْحٌ':Added, #1: 1	عَيْنُ الْمِلْحِ
u'عين مِلْحٌ':Added, #1: 1	عَيْنَ الْمِلْحِ
u'عَيْنٌ مِلْحٌ':Added, #1: 1	عَيْنُ الْمِلْحِ
u'عَيْنٌ مِلْحٌ':Added, #1: 1	عَيْنَ الْمِلْحِ
u'عَيْن مِلْحٌ':Added, #1: 1	عَيْنُ الْمِلْحِ
u'عَيْن مِلْحٌ':Added, #1: 1	عَيْنَ الْمِلْحِ
u'عين مِلْكٌ':Added, #1: 1	عَيْنُ الْمِلْحِ
u'عَيْنٌ مِلْكٌ':Added, #1: 1	عَيْنُ مِلْكِ
u'عَيْن مِلْكٌ':Added, #1: 1	عَيْنُ مِلْكِ
u'عين مِلْكٌ':Added, #1: 1	عَيْنُ مِلْكِ
u'عين مِلْكٌ':Added, #1: 1	عَيْنَ مِلْكِهِ
u'عَيْنٌ مِلْكٌ':Added, #1: 1	عَيْنِ مِلْكِهِ
u'عَيْنٌ مِلْكٌ':Added, #1: 1	عَيْنَ مِلْكِهِ
u'عَيْن مِلْكٌ':Added, #1: 1	عَيْنِ مِلْكِهِ
u'عَيْن مِلْكٌ':Added, #1: 1	عَيْنَ مِلْكِهِ
u'عين مِلْكٌ':Added, #1: 1	عَيْنِ مِلْكِهِ
u'عَيْنٌ مِلْكٌ':Added, #4: 4	عَيْنُ مِلْكِهِ
u'عَيْن مِلْكٌ':Added, #4: 4	عَيْنُ مِلْكِهِ
u'عين مَمْلُوكٌ':Added, #4: 4	عَيْنُ مِلْكِهِ
u'عَيْنٌ مَمْلُوكٌ':Added, #1: 1	عَيْنِ الْمَمْلُوكَةِ
u'عَيْن مَمْلُوكٌ':Added, #1: 1	عَيْنِ الْمَمْلُوكَةِ
u'عَيْنٌ مَمْلُوكٌ':Added, #1: 1	عَيْنِ الْمَمْلُوكَةِ
u'عَيْن مَمْلُوكٌ':Added, #2: 2	عَيْنٍ مَمْلُوكٍ
u'عين مُنَاسِبٌ':Added, #2: 2	عَيْنٍ مَمْلُوكٍ
u'عَيْنٌ مُنَاسِبٌ':Added, #1: 1	عَيْنُ الْمُنَاسِبِ
u'عَيْن مُنَاسِبٌ':Added, #1: 1	عَيْنُ الْمُنَاسِبِ
u'عين مَنْسُوبٌ':Added, #1: 1	عَيْنُ الْمُنَاسِبِ
u'عَيْنٌ مَنْسُوبٌ':Added, #1: 1	عَيْنَ الْمَنْسُوبِ
u'عَيْن مَنْسُوبٌ':Added, #1: 1	عَيْنَ الْمَنْسُوبِ
u'عَيَّنَ مَنْسِيٌّ':Subject, #1: 1	عَيْنَ الْمَنْسُوبِ
u'عين مَنْسِيٌّ':Added, #1: 1	عَيَّنَ الْمَنْسِيُّ
u'عَيْنٌ مَنْسِيٌّ':Added, #1: 1	عَيْنَ مَنْسِيَّةٍ
u'عَيْن مَنْسِيٌّ':Added, #1: 1	عَيْنَ مَنْسِيَّةٍ
u'عَيَّنَ مَنْصُوصٌ':Predicate, #1: 1	عَيْنَ مَنْسِيَّةٍ
u'عين مَنْصُوصٌ':Added, #1: 1	عَيَّنَ الْمَنْصُوصَ
u'عَيْنٌ مَنْصُوصٌ':Added, #1: 1	عَيْنَ الْمَنْصُوصِ
u'عَيْن مَنْصُوصٌ':Added, #1: 1	عَيْنَ الْمَنْصُوصِ
u'عين مَنْصُوصٌ':Added, #1: 1	عَيْنَ الْمَنْصُوصِ
u'عَيْنٌ مَنْصُوصٌ':Added, #4: 4	عَيْنِ الْمَنْصُوصِ
u'عَيْن مَنْصُوصٌ':Added, #4: 4	عَيْنِ الْمَنْصُوصِ
u'عين مَنْصُوصٌ':Added, #4: 4	عَيْنِ الْمَنْصُوصِ
u'عَيْنٌ مَنْصُوصٌ':Added, #6: 6	عَيْنُ الْمَنْصُوصِ
u'عَيْن مَنْصُوصٌ':Added, #6: 6	عَيْنُ الْمَنْصُوصِ
u'عين مَنْفَعَةٌ':Added, #6: 6	عَيْنُ الْمَنْصُوصِ
u'عَيْنٌ مَنْفَعَةٌ':Added, #4: 4	عَيْنِ الْمَنْفَعَةِ
u'عَيْن مَنْفَعَةٌ':Added, #4: 4	عَيْنِ الْمَنْفَعَةِ
u'عين مَنْكُوح':Added, #4: 4	عَيْنِ الْمَنْفَعَةِ
u'عَيْنٌ مَنْكُوح':Added, #1: 1	عَيْنِ الْمَنْكُوحَةِ
u'عَيْن مَنْكُوح':Added, #1: 1	عَيْنِ الْمَنْكُوحَةِ
u'عين مَنْهِيٌّ':Added, #1: 1	عَيْنِ الْمَنْكُوحَةِ
u'عَيْنٌ مَنْهِيٌّ':Added, #5: 5	عَيْنِ الْمَنْهِيِّ
u'عَيْن مَنْهِيٌّ':Added, #5: 5	عَيْنِ الْمَنْهِيِّ
u'عين مَهْرٌ':Added, #5: 5	عَيْنِ الْمَنْهِيِّ
u'عَيْنٌ مَهْرٌ':Added, #1: 1	عَيْنُ الْمَهْرِ
u'عَيْن مَهْرٌ':Added, #1: 1	عَيْنُ الْمَهْرِ
u'عين مَهْرٌ':Added, #1: 1	عَيْنُ الْمَهْرِ
u'عَيْنٌ مَهْرٌ':Added, #2: 2	عَيْنِ الْمَهْرِ
u'عَيْن مَهْرٌ':Added, #2: 2	عَيْنِ الْمَهْرِ
u'عين مَوْثُوقٌ':Added, #2: 2	عَيْنِ الْمَهْرِ
u'عَيْنٌ مَوْثُوقٌ':Added, #1: 1	عَيْنُ الْمَوْثُوقِ
u'عَيْن مَوْثُوقٌ':Added, #1: 1	عَيْنُ الْمَوْثُوقِ
u'عين مَوْصُوفٌ':Added, #1: 1	عَيْنُ الْمَوْثُوقِ
u'عين مَوْصُوفٌ':Added, #1: 1	عَيْنَ الْمَوْصُوفِ
u'عَيْنٌ مَوْصُوفٌ':Added, #1: 1	عَيْنُ الْمَوْصُوفِ
u'عَيْنٌ مَوْصُوفٌ':Added, #1: 1	عَيْنَ الْمَوْصُوفِ
u'عَيْن مَوْصُوفٌ':Added, #1: 1	عَيْنُ الْمَوْصُوفِ
u'عَيْن مَوْصُوفٌ':Added, #1: 1	عَيْنَ الْمَوْصُوفِ
u'عَيَّنَ مَوْضِعٌ':Predicate, #1: 1	عَيْنُ الْمَوْصُوفِ
u'عين مَوْقُوفٌ':Added, #1: 1	عَيَّنَ الْمَوْضِعَ
u'عين مَوْقُوفٌ':Added, #1: 1	عَيْنُ الْمَوْقُوفِ
u'عَيْنٌ مَوْقُوفٌ':Added, #1: 1	عَيْنِ الْمَوْقُوفِ
u'عَيْنٌ مَوْقُوفٌ':Added, #1: 1	عَيْنُ الْمَوْقُوفِ
u'عَيْن مَوْقُوفٌ':Added, #1: 1	عَيْنِ الْمَوْقُوفِ
u'عَيْن مَوْقُوفٌ':Added, #1: 1	عَيْنُ الْمَوْقُوفِ
u'عَيَّنَ مُوَكِّلٌ':Subject, #1: 1	عَيْنِ الْمَوْقُوفِ
u'عَيَّنَ مَوْهُوبٌ':Predicate, #2: 2	عَيَّنَ الْمُوَكِّلُ
u'عين مَوْهُوبٌ':Added, #1: 1	عَيَّنَ الْمَوْهُوبَ
u'عَيْنٌ مَوْهُوبٌ':Added, #1: 1	عَيْنِ الْمَوْهُوبِ
u'عَيْن مَوْهُوبٌ':Added, #1: 1	عَيْنِ الْمَوْهُوبِ
u'عَيَّنَ مِيقَاتٌ':Predicate, #1: 1	عَيْنِ الْمَوْهُوبِ
u'عَيَّنَ نَاحِي':Predicate, #1: 1	عَيَّنَ الْمِيقَاتَ
u'عَيَّنَ ناذِر':Subject, #1: 1	عَيَّنَ نَاحِيَةً
u'عين نَاسٌ':Added, #1: 1	عَيَّنَ النَّاذِرُ
u'عين نَاسٌ':Added, #16: 16	أَعْيُنِ النَّاسِ
u'عَيَّنَ نَاسِخٌ':Predicate, #1: 1	أَعْيُنَ النَّاسِ
u'عَيَّنَ نَاسِخ':Predicate, #2: 2	عَيَّنَ النَّاسِخَ
u'عين نَاظِرٌ':Added, #2: 2	عَيَّنَ النَّاسِخَ
u'عَيْنٌ نَاظِرٌ':Added, #3: 3	عَيْنِ النَّاظِرِ
u'عَيْن نَاظِرٌ':Added, #3: 3	عَيْنِ النَّاظِرِ
u'عين نَجَاسَةٌ':Added, #3: 3	عَيْنِ النَّاظِرِ
u'عَيْنٌ نَجَاسَةٌ':Added, #12: 12	عَيْنِ النَّجَاسَةِ
u'عَيْن نَجَاسَةٌ':Added, #12: 12	عَيْنِ النَّجَاسَةِ
u'عين نَجَاسَةٌ':Added, #12: 12	عَيْنِ النَّجَاسَةِ
u'عَيْنٌ نَجَاسَةٌ':Added, #15: 15	عَيْنُ النَّجَاسَةِ
u'عَيْن نَجَاسَةٌ':Added, #15: 15	عَيْنُ النَّجَاسَةِ
u'عين نَجَاسَةٌ':Added, #15: 15	عَيْنُ النَّجَاسَةِ
u'عَيْنٌ نَجَاسَةٌ':Added, #1: 1	عَيْنَ نَجَاسَةٍ
u'عَيْن نَجَاسَةٌ':Added, #1: 1	عَيْنَ نَجَاسَةٍ
u'عين نَجَاسَةٌ':Added, #1: 1	عَيْنَ نَجَاسَةٍ
u'عَيْنٌ نَجَاسَةٌ':Added, #4: 4	عَيْنُ نَجَاسَةٍ
u'عَيْن نَجَاسَةٌ':Added, #4: 4	عَيْنُ نَجَاسَةٍ
u'عين نَجَاسَةٌ':Added, #4: 4	عَيْنُ نَجَاسَةٍ
u'عَيْنٌ نَجَاسَةٌ':Added, #5: 5	عَيْنَ النَّجَاسَةِ
u'عَيْن نَجَاسَةٌ':Added, #5: 5	عَيْنَ النَّجَاسَةِ
u'عين نخلة':Added, #5: 5	عَيْنَ النَّجَاسَةِ
u'عَيْنٌ نخلة':Added, #1: 1	عَيْنَ النَّخْلَةِ
u'عَيْن نخلة':Added, #1: 1	عَيْنَ النَّخْلَةِ
u'عين نَخْلَةٌ':Added, #1: 1	عَيْنَ النَّخْلَةِ
u'عَيْنٌ نَخْلَةٌ':Added, #1: 1	عَيْنَ النَّخْلَةِ
u'عَيْن نَخْلَةٌ':Added, #1: 1	عَيْنَ النَّخْلَةِ
u'عين نخلة':Added, #1: 1	عَيْنَ النَّخْلَةِ
u'عَيْنٌ نخلة':Added, #2: 2	عَيْنِ النَّخْلَةِ
u'عَيْن نخلة':Added, #2: 2	عَيْنِ النَّخْلَةِ
u'عين نَخْلَةٌ':Added, #2: 2	عَيْنِ النَّخْلَةِ
u'عَيْنٌ نَخْلَةٌ':Added, #2: 2	عَيْنِ النَّخْلَةِ
u'عَيْن نَخْلَةٌ':Added, #2: 2	عَيْنِ النَّخْلَةِ
u'عين نِدَاءٌ':Added, #2: 2	عَيْنِ النَّخْلَةِ
u'عَيْنٌ نِدَاءٌ':Added, #1: 1	عَيْنَ النِّدَاءِ
u'عَيْن نِدَاءٌ':Added, #1: 1	عَيْنَ النِّدَاءِ
u'عين نزاع':Added, #1: 1	عَيْنَ النِّدَاءِ
u'عَيْنٌ نزاع':Added, #9: 9	عَيْنُ النِّزَاعِ
u'عَيْن نزاع':Added, #9: 9	عَيْنُ النِّزَاعِ
u'عين نِزَاعٌ':Added, #9: 9	عَيْنُ النِّزَاعِ
u'عَيْنٌ نِزَاعٌ':Added, #9: 9	عَيْنُ النِّزَاعِ
u'عَيْن نِزَاعٌ':Added, #9: 9	عَيْنُ النِّزَاعِ
u'عَيَّنَ نسي':Predicate, #9: 9	عَيْنُ النِّزَاعِ
u'عين نَصٌّ':Added, #1: 1	عَيَّنَ نَسِيَ
u'عين نَصٌّ':Added, #1: 1	عَيْنَ النَّصِّ
u'عَيْنٌ نَصٌّ':Added, #1: 1	عَيْنُ النَّصِّ
u'عَيْنٌ نَصٌّ':Added, #1: 1	عَيْنَ النَّصِّ
u'عَيْن نَصٌّ':Added, #1: 1	عَيْنُ النَّصِّ
u'عَيْن نَصٌّ':Added, #1: 1	عَيْنَ النَّصِّ
u'عين نَصٌّ':Added, #1: 1	عَيْنُ النَّصِّ
u'عَيْنٌ نَصٌّ':Added, #2: 2	عَيْنِ النَّصِّ
u'عَيْن نَصٌّ':Added, #2: 2	عَيْنِ النَّصِّ
u'عين نصاب':Added, #2: 2	عَيْنِ النَّصِّ
u'عَيْنٌ نصاب':Added, #1: 1	عَيْنَ النِّصَابِ
u'عَيْن نصاب':Added, #1: 1	عَيْنَ النِّصَابِ
u'عين نِصَابٌ':Added, #1: 1	عَيْنَ النِّصَابِ
u'عَيْنٌ نِصَابٌ':Added, #1: 1	عَيْنَ النِّصَابِ
u'عَيْن نِصَابٌ':Added, #1: 1	عَيْنَ النِّصَابِ
u'عين نصاب':Added, #1: 1	عَيْنَ النِّصَابِ
u'عَيْنٌ نصاب':Added, #2: 2	عَيْنِ النِّصَابِ
u'عَيْن نصاب':Added, #2: 2	عَيْنِ النِّصَابِ
u'عين نِصَابٌ':Added, #2: 2	عَيْنِ النِّصَابِ
u'عَيْنٌ نِصَابٌ':Added, #2: 2	عَيْنِ النِّصَابِ
u'عَيْن نِصَابٌ':Added, #2: 2	عَيْنِ النِّصَابِ
u'عين نَصِيبٌ':Added, #2: 2	عَيْنِ النِّصَابِ
u'عَيْنٌ نَصِيبٌ':Added, #1: 1	عَيْنَ نَصِيبِهِ
u'عَيْن نَصِيبٌ':Added, #1: 1	عَيْنَ نَصِيبِهِ
u'عين نِفَاقٌ':Added, #1: 1	عَيْنَ نَصِيبِهِ
u'عَيْنٌ نِفَاقٌ':Added, #1: 1	عَيْنُ النِّفَاقِ
u'عَيْن نِفَاقٌ':Added, #1: 1	عَيْنُ النِّفَاقِ
u'عين نَفْسٌ':Added, #1: 1	عَيْنُ النِّفَاقِ
u'عَيْنٌ نَفْسٌ':Added, #1: 1	عَيْنِ نَفْسِهِ
u'عَيْن نَفْسٌ':Added, #1: 1	عَيْنِ نَفْسِهِ
u'عين نَفْطٌ':Added, #1: 1	عَيْنِ نَفْسِهِ
u'عَيْنٌ نَفْطٌ':Added, #1: 1	عَيْنُ النَّفْطِ
u'عَيْن نَفْطٌ':Added, #1: 1	عَيْنُ النَّفْطِ
u'عين نَفَقَةٌ':Added, #1: 1	عَيْنُ النَّفْطِ
u'عَيْنٌ نَفَقَةٌ':Added, #1: 1	عَيْنِ النَّفَقَةِ
u'عَيْن نَفَقَةٌ':Added, #1: 1	عَيْنِ النَّفَقَةِ
u'عَيَّنَ نَقْدٌ':Predicate, #1: 1	عَيْنِ النَّفَقَةِ
u'عَيَّنَ نَقْد':Predicate, #1: 1	عَيَّنَ النَّقْدَ
u'عين نَقْدٌ':Added, #1: 1	عَيَّنَ النَّقْدَ
u'عين نَقْد':Added, #1: 1	عَيْنِ نَقْدِ
u'عَيْنٌ نَقْدٌ':Added, #1: 1	عَيْنِ نَقْدِ
u'عَيْنٌ نَقْد':Added, #1: 1	عَيْنِ نَقْدِ
u'عَيْن نَقْدٌ':Added, #1: 1	عَيْنِ نَقْدِ
u'عَيْن نَقْد':Added, #1: 1	عَيْنِ نَقْدِ
u'عين نُقْصَانٌ':Added, #1: 1	عَيْنِ نَقْدِ
u'عَيْنٌ نُقْصَانٌ':Added, #1: 1	عَيْنُ النُّقْصَانِ
u'عَيْن نُقْصَانٌ':Added, #1: 1	عَيْنُ النُّقْصَانِ
u'عين نكاح':Added, #1: 1	عَيْنُ النُّقْصَانِ
u'عَيْنٌ نكاح':Added, #1: 1	عَيْنُ نِكَاحِ
u'عَيْن نكاح':Added, #1: 1	عَيْنُ نِكَاحِ
u'عين نِكَاحٌ':Added, #1: 1	عَيْنُ نِكَاحِ
u'عَيْنٌ نِكَاحٌ':Added, #1: 1	عَيْنُ نِكَاحِ
u'عَيْن نِكَاحٌ':Added, #1: 1	عَيْنُ نِكَاحِ
u'عين نَهْيٌ':Added, #1: 1	عَيْنُ نِكَاحِ
u'عَيْنٌ نَهْيٌ':Added, #2: 2	عَيْنُ النَّهْيِ
u'عَيْن نَهْيٌ':Added, #2: 2	عَيْنُ النَّهْيِ
u'عين نَوْعٌ':Added, #2: 2	عَيْنُ النَّهْيِ
u'عَيْنٌ نَوْعٌ':Added, #1: 1	عَيْنِ نَوْعِهِ
u'عَيْن نَوْعٌ':Added, #1: 1	عَيْنِ نَوْعِهِ
u'عين هِدَايَةٌ':Added, #1: 1	عَيْنِ نَوْعِهِ
u'عَيْنٌ هِدَايَةٌ':Added, #3: 3	عَيْنُ الْهِدَايَةِ
u'عَيْن هِدَايَةٌ':Added, #3: 3	عَيْنُ الْهِدَايَةِ
u'عين هَدْيٌ':Added, #3: 3	عَيْنُ الْهِدَايَةِ
u'عَيْنٌ هَدْيٌ':Added, #1: 1	عَيْنَ الْهَدْيِ
u'عَيْن هَدْيٌ':Added, #1: 1	عَيْنَ الْهَدْيِ
u'عين وَاجِبٌ':Added, #1: 1	عَيْنَ الْهَدْيِ
u'عَيْنٌ وَاجِبٌ':Added, #1: 1	عَيْنِ الْوَاجِبِ
u'عَيْن وَاجِبٌ':Added, #1: 1	عَيْنِ الْوَاجِبِ
u'عين وَاجِبٌ':Added, #1: 1	عَيْنِ الْوَاجِبِ
u'عين وَاجِبٌ':Added, #3: 3	عَيْنَ الْوَاجِبِ
u'عَيْنٌ وَاجِبٌ':Added, #3: 3	عَيْنُ الْوَاجِبِ
u'عَيْنٌ وَاجِبٌ':Added, #3: 3	عَيْنَ الْوَاجِبِ
u'عَيْن وَاجِبٌ':Added, #3: 3	عَيْنُ الْوَاجِبِ
u'عَيْن وَاجِبٌ':Added, #3: 3	عَيْنَ الْوَاجِبِ
u'عَيَّنَ واحد':Predicate, #3: 3	عَيْنُ الْوَاجِبِ
u'عَيَّنَ وَاحِدٌ':Predicate, #1: 1	عَيَّنَ وَاحِدَةً
u'عَيْنٌ واحد':Added, #1: 1	عَيَّنَ وَاحِدَةً
u'عَيْن واحد':Added, #1: 1	عَيْنٍ وَاحِدٍ
u'عَيْنٌ وَاحِدٌ':Added, #1: 1	عَيْنٍ وَاحِدٍ
u'عَيْن وَاحِدٌ':Added, #1: 1	عَيْنٍ وَاحِدٍ
u'عَيَّنَ وَارِثٌ':Subject, #1: 1	عَيْنٍ وَاحِدٍ
u'عَيَّنَ وَاقِفٌ':Subject, #3: 3	عَيَّنَ الْوَارِثُ
u'عَيَّنَ وَاهِبٌ':Subject, #5: 5	عَيَّنَ الْوَاقِفُ
u'عَيَّنَ وَجْهٌ':Predicate, #1: 1	عَيَّنَ الْوَاهِبُ
u'عَيَّنَ وُجُوبٌ':Predicate, #1: 1	عَيَّنَ الْوَجْهَ
u'عين وُجُودٌ':Added, #1: 1	عَيَّنَ الْوُجُوبَ
u'عَيْنٌ وُجُودٌ':Added, #1: 1	عَيْنُ وُجُودِهِ
u'عَيْن وُجُودٌ':Added, #1: 1	عَيْنُ وُجُودِهِ
u'عين وَدِيعٌ':Added, #1: 1	عَيْنُ وُجُودِهِ
u'عَيْنٌ وَدِيعٌ':Added, #1: 1	عَيْنِ الْوَدِيعَةِ
u'عَيْن وَدِيعٌ':Added, #1: 1	عَيْنِ الْوَدِيعَةِ
u'عين وَدِيعَةٌ':Added, #1: 1	عَيْنِ الْوَدِيعَةِ
u'عَيْنٌ وَدِيعَةٌ':Added, #1: 1	عَيْنِ الْوَدِيعَةِ
u'عَيْن وَدِيعَةٌ':Added, #1: 1	عَيْنِ الْوَدِيعَةِ
u'عَيْنٌ وَدِيعَةٌ':Added, #1: 1	عَيْنِ الْوَدِيعَةِ
u'عَيْن وَدِيعَةٌ':Added, #1: 1	عَيْنٍ وَدِيعَةٍ
u'عَيَّنَ وَرَثَةٌ':Subject, #1: 1	عَيْنٍ وَدِيعَةٍ
u'عين وَرَقَةٌ':Added, #3: 3	عَيَّنَ الْوَرَثَةُ
u'عَيْنٌ وَرَقَةٌ':Added, #1: 1	عَيْنِ وَرَقَةِ
u'عَيْن وَرَقَةٌ':Added, #1: 1	عَيْنِ وَرَقَةِ
u'عَيَّنَ وَصْفٌ':Predicate, #1: 1	عَيْنِ وَرَقَةِ
u'عين وَصْفٌ':Added, #1: 1	عَيَّنَ الْوَصْفَ
u'عَيْنٌ وَصْفٌ':Added, #4: 4	عَيْنُ الْوَصْفِ
u'عَيْن وَصْفٌ':Added, #4: 4	عَيْنُ الْوَصْفِ
u'عين وَصْفٌ':Added, #4: 4	عَيْنُ الْوَصْفِ
u'عَيْنٌ وَصْفٌ':Added, #6: 6	عَيْنِ الْوَصْفِ
u'عَيْن وَصْفٌ':Added, #6: 6	عَيْنِ الْوَصْفِ
u'عين وُصُولٌ':Added, #6: 6	عَيْنِ الْوَصْفِ
u'عَيْنٌ وُصُولٌ':Added, #1: 1	عَيْنُ الْوُصُولِ
u'عَيْن وُصُولٌ':Added, #1: 1	عَيْنُ الْوُصُولِ
u'عَيَّنَ وَصِيٌّ':Subject, #1: 1	عَيْنُ الْوُصُولِ
u'عين وَضْعٌ':Added, #2: 2	عَيَّنَ الْوَصِيُّ
u'عَيْنٌ وَضْعٌ':Added, #1: 1	عَيْنُ الْوَضْعِ
u'عَيْن وَضْعٌ':Added, #1: 1	عَيْنُ الْوَضْعِ
u'عين وقاع':Added, #1: 1	عَيْنُ الْوَضْعِ
u'عَيْنٌ وقاع':Added, #1: 1	عَيْنُ الْوِقَاعِ
u'عَيْن وقاع':Added, #1: 1	عَيْنُ الْوِقَاعِ
u'عين وَقْفٌ':Added, #1: 1	عَيْنُ الْوِقَاعِ
u'عَيْنٌ وَقْفٌ':Added, #16: 16	عَيْنِ الْوَقْفِ
u'عَيْن وَقْفٌ':Added, #16: 16	عَيْنِ الْوَقْفِ
u'عين وَقْفٌ':Added, #16: 16	عَيْنِ الْوَقْفِ
u'عَيْنٌ وَقْفٌ':Added, #1: 1	عَيْنَ الْوَقْفِ
u'عَيْن وَقْفٌ':Added, #1: 1	عَيْنَ الْوَقْفِ
u'عين وَقْفٌ':Added, #1: 1	عَيْنَ الْوَقْفِ
u'عَيْنٌ وَقْفٌ':Added, #2: 2	عَيْنُ الْوَقْفِ
u'عَيْن وَقْفٌ':Added, #2: 2	عَيْنُ الْوَقْفِ
u'عين وُقُوعٌ':Added, #2: 2	عَيْنُ الْوَقْفِ
u'عَيْنٌ وُقُوعٌ':Added, #1: 1	عَيْنُ وُقُوعِهِ
u'عَيْن وُقُوعٌ':Added, #1: 1	عَيْنُ وُقُوعِهِ
u'عين وِلاَيَةٌ':Added, #1: 1	عَيْنُ وُقُوعِهِ
u'عَيْنٌ وِلاَيَةٌ':Added, #1: 1	عَيْنِ الْوِلَايَةِ
u'عَيْن وِلاَيَةٌ':Added, #1: 1	عَيْنِ الْوِلَايَةِ
u'عين وِلاَيَةٌ':Added, #1: 1	عَيْنِ الْوِلَايَةِ
u'عَيْنٌ وِلاَيَةٌ':Added, #1: 1	عَيْنِ وِلَايَةِ
u'عَيْن وِلاَيَةٌ':Added, #1: 1	عَيْنِ وِلَايَةِ
u'عين ولد':Added, #1: 1	عَيْنِ وِلَايَةِ
u'عين ولد':Added, #1: 1	عَيْنُ الْوَلَدِ
u'عَيْنٌ ولد':Added, #1: 1	عَيْنِ الْوَلَدِ
u'عَيْنٌ ولد':Added, #1: 1	عَيْنُ الْوَلَدِ
u'عَيْن ولد':Added, #1: 1	عَيْنِ الْوَلَدِ
u'عَيْن ولد':Added, #1: 1	عَيْنُ الْوَلَدِ
u'عين وَلَدٌ':Added, #1: 1	عَيْنِ الْوَلَدِ
u'عين وَلَدٌ':Added, #1: 1	عَيْنُ الْوَلَدِ
u'عَيْنٌ وَلَدٌ':Added, #1: 1	عَيْنِ الْوَلَدِ
u'عَيْنٌ وَلَدٌ':Added, #1: 1	عَيْنُ الْوَلَدِ
u'عَيْن وَلَدٌ':Added, #1: 1	عَيْنِ الْوَلَدِ
u'عَيْن وَلَدٌ':Added, #1: 1	عَيْنُ الْوَلَدِ
u'عين يَقِينٌ':Added, #1: 1	عَيْنِ الْوَلَدِ
u'عين يَقِينٌ':Added, #1: 1	عَيْنُ الْيَقِينِ
u'عَيْنٌ يَقِينٌ':Added, #1: 1	عَيْنِ الْيَقِينِ
u'عَيْنٌ يَقِينٌ':Added, #1: 1	عَيْنُ الْيَقِينِ
u'عَيْن يَقِينٌ':Added, #1: 1	عَيْنِ الْيَقِينِ
u'عَيْن يَقِينٌ':Added, #1: 1	عَيْنُ الْيَقِينِ
u'عَيَّنَ يَوْمٌ':Predicate, #1: 1	عَيْنِ الْيَقِينِ
u'عين يَوْمٌ':Added, #3: 3	عَيَّنَ الْيَوْمَ
u'عَيْنٌ يَوْمٌ':Added, #3: 3	عَيْنُ يَوْمِ
u'عَيْن يَوْمٌ':Added, #3: 3	عَيْنُ يَوْمِ
u'عُيُوبٌ بَيْعٌ':Added, #3: 3	عَيْنُ يَوْمِ
u'عُيُوبٌ تَآلِيفُ':Added, #1: 1	عُيُوبُ الْبَيْعِ
u'عُيُوبٌ تَقْصيرٌ':Added, #1: 1	عُيُوبِ التَّآلِيفِ
u'عُيُوبٌ جَسَدٌ':Added, #1: 1	عُيُوبِ التَّقْصِيرِ
u'عُيُوبٌ دَوَابُّ':Added, #1: 1	عُيُوبَ جَسَدِ
u'عُيُوبٌ رَقيقٌ':Added, #2: 2	عُيُوبِ الدَّوَابِّ
u'عُيُوبٌ رَقيق':Added, #1: 1	عُيُوبِ الرَّقِيقِ
u'عُيُوبٌ زَوْجٌ':Added, #1: 1	عُيُوبِ الرَّقِيقِ
u'عُيُوبٌ زَوْجٌ':Added, #1: 1	عُيُوبِ الزَّوْجِ
u'عُيُوبٌ زَوْجَةٌ':Added, #2: 2	عُيُوبِ الزَّوْجَيْنِ
u'عُيُوبٌ شَخْصٌ':Added, #1: 1	عُيُوبِ الزَّوْجَةِ
u'عُيُوبٌ شِعْرٌ':Added, #1: 1	عُيُوبِ شَخْصٍ
u'عُيُوبٌ فَرْجٌ':Added, #1: 1	عُيُوبِ الشِّعْرِ
u'عُيُوبٌ فَرْجٌ':Added, #11: 11	عُيُوبِ الْفَرْجِ
u'عُيُوبٌ قول':Added, #1: 1	عُيُوبَ الْفَرْجِ
u'عُيُوبٌ قَوْلٌ':Added, #1: 1	عُيُوبِ الْقَوْلِ
u'عُيُوبٌ مَبِيعٌ':Added, #1: 1	عُيُوبِ الْقَوْلِ
u'عُيُوبٌ نَاسٌ':Added, #1: 1	عُيُوبِ الْمَبِيعِ
u'عُيُوبٌ نَاسٌ':Added, #1: 1	عُيُوبَ النَّاسِ
u'عُيُوبٌ نِساءٌ':Added, #2: 2	عُيُوبِ النَّاسِ
u'عُيُوبٌ نِساءٌ':Added, #2: 2	عُيُوبَ النِّسَاءِ
u'عُيُوبٌ نَفْسٌ':Added, #5: 5	عُيُوبِ النِّسَاءِ
u'عُيُوبٌ نَفْسٌ':Added, #1: 1	عُيُوبِ النَّفْسِ
u'عُيُونٌ أخْبَارٌ':Added, #1: 1	عُيُوبِ نَفْسِهِ
u'عُيُونٌ أَخْبَارٌ':Added, #1: 1	عُيُونُ أَخْبَارٍ
u'عُيُونٌ أخْبَارٌ':Added, #1: 1	عُيُونُ أَخْبَارٍ
u'عُيُونٌ أَخْبَارٌ':Added, #1: 1	عُيُونِ الْأَخْبَارِ
u'عُيُونٌ إِنْسٌ':Added, #1: 1	عُيُونِ الْأَخْبَارِ
u'عُيُونٌ أَوْدِيَةٌ':Added, #1: 1	عُيُونُ الْإِنْسِ
u'عُيُونٌ أَوْدِيَةٌ':Added, #1: 1	عُيُونَ أَوْدِيَةِ
u'عُيُونٌ أَوْدِيَةٌ':Added, #1: 1	عُيُونُ أَوْدِيَةِ
u'عُيُونٌ بَقَرٌ':Added, #3: 3	عُيُونِ أَوْدِيَةِ
u'عُيُونٌ بَلَدٌ':Added, #1: 1	عُيُونِ الْبَقَرِ
u'عُيُونٌ جِبَالٌ':Added, #1: 1	عُيُونَ الْبَلَدِ
u'عُيُونٌ جَنَادِبُ':Added, #1: 1	عُيُونِ الْجِبَالِ
u'عُيُونٌ جَنَّةٌ':Added, #1: 1	عُيُونُ الْجَنَادِبِ
u'عُيُونٌ حجاز':Added, #1: 1	عُيُونِ الْجَنَّةِ
u'عُيُونٌ حجاز':Added, #11: 11	عُيُونِ الْحِجَازِ
u'عُيُونٌ حجاز':Added, #2: 2	عُيُونَ الْحِجَازِ
u'عُيُونٌ حُسَّدٌ':Added, #2: 2	عُيُونُ الْحِجَازِ
u'عُيُونٌ رَامِقٌ':Added, #1: 1	عُيُونَ الْحُسّدِ
u'عُيُونٌ رِوايَةٌ':Added, #1: 1	عُيُونِ رَامِقِهِ
u'عُيُونٌ فَضْلٌ':Added, #1: 1	عُيُونِ الرِّوَايَةِ
u'عُيُونٌ كرام':Added, #1: 1	عُيُونُ الْفَضْلِ
u'عُيُونٌ كَلاَمٌ':Added, #1: 1	عُيُونِ الْكِرَامِ
u'عُيُونٌ مَاءٌ':Added, #1: 1	عُيُونِ كَلَامِ
u'عُيُونٌ مَذَاهِبُ':Added, #1: 1	عُيُونَ الْمَاءِ
u'عُيُونٌ مرٌّ':Added, #5: 5	عُيُونِ الْمَذَاهِبِ
u'عُيُونٌ مَرٌّ':Added, #5: 5	عُيُونِ مَرِّ
u'عُيُونٌ مَسَائِلُ':Added, #5: 5	عُيُونِ مَرِّ
u'عُيُونٌ مَعَارِفُ':Added, #381: 381	عُيُونِ الْمَسَائِلِ
u'عُيُونٌ نَاسٌ':Added, #1: 1	عُيُونِ الْمَعَارِفِ
u'عُيُونٌ نَاظِرٌ':Added, #1: 1	عُيُونِ النَّاسِ
u'عُيُونٌ نَائِحٌ':Added, #1: 1	عُيُونُ النّاظِرَاتِ
u'عَيِيَ حِمَارٌ':Subject, #1: 1	عُيُونُ النّائِحَاتِ
u'غَابَ أَبٌ':Subject, #1: 1	عَيِيَ الْحِمَارُ
u'غَابَ أحَدٌ':Subject, #7: 7	غَابَ الْأَبُ
u'غَابَ أَخٌ':Subject, #8: 8	غَابَ أَحَدُ
u'غَابَ أَسَدٌ':Subject, #1: 1	غَابَ الْأَخُ
u'غَابَ أَصْحَابٌ':Subject, #1: 1	غَابَ الْأَسَدُ
u'غَابَ أصل':Subject, #1: 1	غَابَ أَصْحَابُهُ
u'غَابَ أًصْلٌ':Subject, #1: 1	غَابَ الْأَصْلُ
u'غَابَ أُصولٌ':Subject, #1: 1	غَابَ الْأَصْلُ
u'غَابَ أَصيلٌ':Subject, #1: 1	غَابَ الْأُصُولُ
u'غَابَ أقْرَبُ':Subject, #1: 1	غَابَ الْأَصِيلُ
u'غَابَ أقَلُّ':Predicate, #9: 9	غَابَ الْأَقْرَبُ
u'غَابَ أَكْثَرُ':Predicate, #1: 1	غَابَ أَقَلَّ
u'غَابَ أَكْثَرُ':Subject, #4: 4	غَابَ أَكْثَرَ
u'غَابَ إمَامٌ':Subject, #1: 1	غَابَ أَكْثَرُهُ
u'غَابَ أهْلٌ':Subject, #1: 1	غَابَ الْإِمَامُ
u'غَابَ أَوَّلُ':Subject, #1: 1	غَابَ الْأَهْلُ
u'غَابَ بَائِعٌ':Subject, #2: 2	غَابَ الْأَوَّلُ
u'غَابَ بَائِعٌ':Subject, #1: 1	غَابَ بَائِعُ
u'غَابَ بَائِعٌ':Subject, #1: 1	غَابَ بَائِعُهُ
u'غَابَ بَيَاضٌ':Subject, #7: 7	غَابَ الْبَائِعُ
u'غَابَ ثَلاثَةٌ':Predicate, #1: 1	غَابَ الْبَيَاضُ
u'غَابَ جَمَّالٌ':Subject, #2: 2	غَابَ ثَلَاثَةَ
u'غَابَ حاجِبٌ':Subject, #1: 1	غَابَ الْجَمَّالُ
u'غَابَ حاضِرٌ':Subject, #4: 4	غَابَ حَاجِبُ
u'غَابَ حالٌ':Predicate, #1: 1	غَابَ الْحَاضِرُ
u'غَابَ حَمَّالٌ':Subject, #1: 1	غَابَ حَالَ
u'غَابَ خَصْمٌ':Subject, #1: 1	غَابَ الْحَمَّالُ
u'غَابَ خَمْسٌ':Predicate, #1: 1	غَابَ الْخَصْمُ
u'غَابَ دِرْهَمٌ':Subject, #1: 1	غَابَ خَمْسَ
u'غَابَ دِرْهَم':Subject, #1: 1	غَابَ الدِّرْهَمُ
u'غَابَ ذِمِّيٌّ':Subject, #1: 1	غَابَ الدِّرْهَمُ
u'غَابَ رَاهِنٌ':Subject, #1: 1	غَابَ ذِمِّيٌّ
u'غَابَ رَبُّ':Subject, #4: 4	غَابَ الرَّاهِنُ
u'غَابَ رَجُلٌ':Subject, #2: 2	غَابَ رَبُّ
u'غَابَ رَجُلٌ':Subject, #12: 12	غَابَ الرَّجُلُ
u'غَابَ رَدٌّ':Subject, #2: 2	غَابَ رَجُلٌ
u'غَابَ رَشيدٌ':Subject, #2: 2	غَابَ الرَّدُّ
u'غَابَ رَهْنٌ':Subject, #1: 1	غَابَ الرَّشِيدُ
u'غَابَ زَوْجٌ':Subject, #1: 1	غَابَ رَهْنٌ
u'غَابَ سَيِّدٌ':Subject, #12: 12	غَابَ الزَّوْجُ
u'غَابَ شَرِيكٌ':Subject, #1: 1	غَابَ سَيِّدُهُ
u'غَابَ شفعاء':Subject, #2: 2	غَابَ شَرِيكُهُ
u'غَابَ شفق':Predicate, #1: 1	غَابَ الشُّفَعَاءُ
u'غَابَ شَفَقٌ':Predicate, #1: 1	غَابَ الشَّفَقَ
u'غَابَ شفق':Subject, #1: 1	غَابَ الشَّفَقَ
u'غَابَ شَفَقٌ':Subject, #1: 1	غَابَ الشّفَقُ
u'غَابَ شفق':Subject, #1: 1	غَابَ الشّفَقُ
u'غَابَ شَفَقٌ':Subject, #37: 37	غَابَ الشَّفَقُ
u'غَابَ شُهُودٌ':Subject, #37: 37	غَابَ الشَّفَقُ
u'غَابَ شُهُودٌ':Subject, #1: 1	غَابَ شُهُودُهُ
u'غَابَ صَاحِبٌ':Subject, #2: 2	غَابَ الشُّهُودُ
u'غَابَ صَيْدٌ':Subject, #3: 3	غَابَ صَاحِبُهُ
u'غَابَ ضَمِنٌ':Predicate, #2: 2	غَابَ الصَّيْدُ
u'غَابَ عَبْدٌ':Subject, #1: 1	غَابَ ضَمِنَ
u'غَابَ عَبْدٌ':Subject, #1: 1	غَابَ عَبْدُ
u'غَابَ عَدْلٌ':Subject, #4: 4	غَابَ الْعَبْدُ
u'غَابَ عَقْلٌ':Subject, #2: 2	غَابَ الْعَدْلُ
u'غَابَ عند':Predicate, #2: 2	غَابَ عَقْلُهُ
u'غَابَ غَاصِبٌ':Subject, #6: 6	غَابَ عِنْدَ
u'غَابَ غَرِيمٌ':Subject, #1: 1	غَابَ غَاصِبٌ
u'غَابَ غَيْبَةٌ':Predicate, #2: 2	غَابَ الْغَرِيمُ
u'غَابَ غير':Predicate, #2: 2	غَابَ الْغَيْبَةَ
u'غَابَ غَيْرٌ':Predicate, #1: 1	غَابَ غَيْرَ
u'غَابَ فَرَسٌ':Subject, #1: 1	غَابَ غَيْرَ
u'غَابَ فلان':Subject, #1: 1	غَابَ فَرَسُهُ
u'غَابَ قَابِضٌ':Subject, #1: 1	غَابَ بِلَالٌ
u'غَابَ قَالٌ':Predicate, #1: 1	غَابَ الْقَابِضُ
u'غَابَ قُرْصٌ':Subject, #1: 1	غَابَ قَالَ
u'غَابَ قُرْصٌ':Subject, #1: 1	غَابَ قُرْصُ
u'غَابَ قَرْنٌ':Subject, #2: 2	غَابَ الْقُرْصُ
u'غَابَ قلب':Subject, #1: 1	غَابَ قَرْنُ
u'غَابَ قَلْبٌ':Subject, #1: 1	غَابَ قَلْبُ
u'غَابَ قَلْب':Subject, #1: 1	غَابَ قَلْبُ
u'غَابَ قمر':Subject, #1: 1	غَابَ قَلْبُ
u'غَابَ قَمَرٌ':Subject, #7: 7	غَابَ الْقَمَرُ
u'غَابَ كَفِيلٌ':Subject, #7: 7	غَابَ الْقَمَرُ
u'غَابَ كَوْكَبٌ':Subject, #2: 2	غَابَ الْكَفِيلُ
u'غَابَ لَيْلٌ':Predicate, #2: 2	غَابَ كَوْكَبٌ
u'غَابَ مَالٌ':Subject, #1: 1	غَابَ لَيْلَةَ
u'غَابَ مَالٌ':Subject, #10: 10	غَابَ مَالُهُ
u'غَابَ مَالِكٌ':Subject, #2: 2	غَابَ مَالُ
u'غَابَ مُبْتاع':Subject, #3: 3	غَابَ الْمَالِكُ
u'غَابَ مُتَعَلِّمٌ':Subject, #1: 1	غَابَ الْمُبْتَاعُ
u'غَابَ مثل':Subject, #1: 1	غَابَ الْمُتَعَلِّمُ
u'غَابَ مِثْلٌ':Subject, #1: 1	غَابَ مِثْلُهُ
u'غَابَ مُحْتَالٌ':Subject, #1: 1	غَابَ مِثْلُهُ
u'غَابَ مُحَلِّل':Subject, #1: 1	غَابَ الْمُحْتَالُ
u'غَابَ مُحِيل':Subject, #1: 1	غَابَ الْمُحَلِّلُ
u'غَابَ مُدَرِّسٌ':Subject, #2: 2	غَابَ الْمُحِيلُ
u'غَابَ مَزَارِعُ':Subject, #1: 1	غَابَ مُدَرِّسُهُ
u'غَابَ مُزَارِعٌ':Subject, #1: 1	غَابَ الْمَزَارِعُ
u'غَابَ مُسْتَأْجِرٌ':Subject, #1: 1	غَابَ الْمُزَارِعُ
u'غَابَ مِسْكِينٌ':Subject, #3: 3	غَابَ الْمُسْتَأْجِرُ
u'غَابَ مُسَلَّمٌ':Subject, #2: 2	غَابَ الْمِسْكِينُ
u'غَابَ مَطْلُوبٌ':Subject, #1: 1	غَابَ الْمُسَلَّمُ
u'غَابَ مَغْصُوب':Subject, #1: 1	غَابَ الْمَطْلُوبُ
u'غَابَ مَقْذُوفٌ':Subject, #3: 3	غَابَ الْمَغْصُوبُ
u'غَابَ مَقْضِيّ':Subject, #1: 1	غَابَ الْمَقْذُوفُ
u'غَابَ مَكَانٌ':Predicate, #1: 1	غَابَ الْمَقْضِيُّ
u'غَابَ مُكْرَهٌ':Subject, #1: 1	غَابَ مَكَانَ
u'غَابَ مَكْفُولٌ':Subject, #2: 2	غَابَ الْمُكْرَهُ
u'غَابَ مُودَعٌ':Subject, #6: 6	غَابَ الْمَكْفُولُ
u'غَابَ مُودِعٌ':Subject, #1: 1	غَابَ الْمُودَعُ
u'غَابَ مُؤَذِّنٌ':Subject, #2: 2	غَابَ الْمُودِعُ
u'غَابَ مُوسِرٌ':Subject, #1: 1	غَابَ الْمُؤَذِّنُ
u'غَابَ مُوَكِّلٌ':Subject, #1: 1	غَابَ مُوسِرٌ
u'غَابَ مُوَكِّلٌ':Subject, #2: 2	غَابَ الْمُوَكِّلُ
u'غَابَ نَاصِحٌ':Subject, #2: 2	غَابَ مُوَكِّلُهُ
u'غَابَ نَاظِرٌ':Subject, #1: 1	غَابَ نَاصِحُ
u'غَابَ نَقْدٌ':Subject, #2: 2	غَابَ النَّاظِرُ
u'غَابَ نَقْد':Subject, #1: 1	غَابَ نَقْدُ
u'غَابَ وَارِثٌ':Subject, #1: 1	غَابَ نَقْدُ
u'غَابَ وَتَرٌ':Predicate, #1: 1	غَابَ الْوَارِثُ
u'غَابَ وَصِيٌّ':Subject, #1: 1	غَابَ وَتَرَكَ
u'غَابَ وَقْتٌ':Predicate, #1: 1	غَابَ الْوَصِيُّ
u'غَابَ وَقْتٌ':Subject, #1: 1	غَابَ وَقْتَ
u'غَابَ وَكِيلٌ':Subject, #1: 1	غَابَ وَقْتُ
u'غَابَ وَلَهٌ':Subject, #1: 1	غَابَ الْوَكِيلُ
u'غَابَ وَلِيٌّ':Subject, #4: 4	غَابَ وَلَهُ
u'غَابَ وَلِيٌّ':Subject, #1: 1	غَابَ وَلِيُّ
u'غَارَ إشارَة':Subject, #8: 8	غَابَ الْوَلِيُّ
u'غَارَ إِنْسانٌ':Subject, #1: 1	أَغَارَ إشَارَةٌ
u'غَارَ أهْلٌ':Subject, #3: 3	أَغَارَ إنْسَانٌ
u'غَارَةٌ خَيْلٌ':Added, #2: 2	أَغَارَ أَهْلُ
u'غَارَةٌ رَجُلٌ':Added, #1: 1	غَارَةَ خَيْلٍ
u'غَارَ ثَعْلَبٌ':Subject, #1: 1	غَارَةَ رَجُلٍ
u'غَارَ حَبْلٌ':Predicate, #1: 1	أَغَارَ الثَّعْلَبُ
u'غَارَ حَديثٌ':Predicate, #2: 2	أَغَارَ الْحَبْلَ
u'غَارَ رَجُلٌ':Subject, #1: 1	أَغَارَ الْحَدِيثَ
u'غَارَ رَجُلٌ':Subject, #1: 1	غَارَ الرَّجُلُ
u'غَارَ رَسُولٌ':Subject, #2: 2	أَغَارَ رَجُلٌ
u'غَارَ عَدُوٌّ':Subject, #6: 6	أَغَارَ رَسُولُ
u'غَارَ قَالٌ':Predicate, #1: 1	أَغَارَ الْعَدُوُّ
u'غَارَ قَوْمٌ':Subject, #1: 1	أَغَارَ قَالَ
u'غَارَ كُرْزٌ':Subject, #1: 1	أَغَارَ قَوْمٌ
u'غَارَ لَفْظٌ':Subject, #1: 1	أَغَارَ كُرْزُ
u'غَارَ مَاءٌ':Subject, #1: 1	أَغَارَ لَفْظُ
u'غَارَ مَاءٌ':Subject, #3: 3	غَارَ الْمَاءُ
u'غَالَ بَعْضٌ':Subject, #4: 4	غَارَ مَاءُ
u'غَايَرَ أُسْلوبٌ':Predicate, #1: 1	غَالَ بَعْضُ
u'غَايَرَ بَيْنٌ':Predicate, #1: 1	غَايَرَ الْأُسْلُوبَ
u'غَايَرَ حُروفٌ':Predicate, #7: 7	غَايَرَ بَيْنَ
u'غَايَرَ حُروفٌ':Predicate, #1: 1	غَايَرَ الْحُرُوفَ
u'غَايَرَ حُكْمٌ':Predicate, #1: 1	غَايَرَ حُرُوفَ
u'غَايَرَ شَرْعٌ':Subject, #1: 1	غَايَرَ الْحُكْمَ
u'غَايَرَ فَقِيرٌ':Predicate, #2: 2	غَايَرَ الشَّرْعُ
u'غَبَشٌ لَيْلٌ':Added, #1: 1	غَايَرَ الْفَقِيرَ
u'غِبْطَةٌ بِنْتٌ':Added, #1: 1	غَبَشِ اللَّيْلِ
u'غَبْنٌ أهْلٌ':Added, #1: 1	غِبْطَةُ بِنْتِ
u'غَبْنٌ فَاحِشٌ':Added, #1: 1	غَبْنُ أَهْلِ
u'غَبْنٌ مُسْتَرْسِلٌ':Added, #1: 1	غَبْنٍ فَاحِشٍ
u'غَبْنٌ مُسْتَرْسِلٌ':Added, #1: 1	غَبْنِ الْمُسْتَرْسِلِ
u'غَبْنٌ يَسِيرٌ':Added, #4: 4	غَبْنُ الْمُسْتَرْسِلِ
u'غَدَا أَقْوَمُ':Predicate, #1: 1	غَبْنٍ يَسِيرٍ
u'غَدَا أكل':Subject, #1: 1	غَدَا أَقْوَمَ
u'غَدَا أَكْلٌ':Subject, #2: 2	غَدَا أَكْلُ
u'غَدَا أهْلٌ':Subject, #2: 2	غَدَا أَكْلُ
u'غَدَا رَجُلٌ':Subject, #2: 2	غَدَا أَهْلُ
u'غَدَا رَجُلٌ':Subject, #1: 1	غَدَا الرَّجُلُ
u'غَدَا عرفة':Predicate, #1: 1	غَدَا رَجُلٌ
u'غَدَا هَانِئٌ':Subject, #1: 1	غَدَا عَرَفَةَ
u'غَدْرٌ أمَانٌ':Added, #1: 1	غَدَا هَانِئٌ
u'غَدَرَ تَاجِرٌ':Subject, #1: 1	غَدْرِ الْأَمَانِ
u'غَدَرَ غَادِرٌ':Subject, #1: 1	غَدَرَ التَّاجِرُ
u'غَدَرَ مُحَمَّدٌ':Subject, #1: 1	غَدَرَ غَادِرٌ
u'غُدْوَةٌ رَجُلٌ':Added, #1: 1	غَدَرَ مُحَمَّدٌ
u'غَدَّى عَدَدٌ':Predicate, #1: 1	غُدْوَةَ رَجُلٍ
u'غَدَّى مساكين':Predicate, #1: 1	غَدَّى الْعَدَدَ
u'غَرَّ أَجِيرٌ':Predicate, #1: 1	غَدَّى الْمَسَاكِينَ
u'غِرَاسٌ شَجَرٌ':Added, #2: 2	غَرَّ الْأَجِيرَ
u'غِرَاسٌ غَاصِبٌ':Added, #1: 1	غِرَاسَ شَجَرٍ
u'غِرَاسٌ مُسْتَأْجِرٌ':Added, #1: 1	غِرَاسُ الْغَاصِبِ
u'غِرَاسٌ مُسْتَعِيرٌ':Added, #1: 1	غِرَاسُ الْمُسْتَأْجِرِ
u'غِرَاسٌ مُسْتَعِيرٌ':Added, #1: 1	غِرَاسَ الْمُسْتَعِيرِ
u'غِرَاسٌ مُسْتَعِيرٌ':Added, #1: 1	غِرَاسُ الْمُسْتَعِيرِ
u'غِرَاسٌ مُفْلِسٌ':Added, #1: 1	غِرَاسِ الْمُسْتَعِيرِ
u'غَرَّ الْمَرْأَةُ':Predicate, #1: 1	غِرَاسُ الْمُفْلِسِ
u'غَرَّ المُشْتَرِي':Predicate, #1: 1	غَرَّ الْمَرْأَةَ
u'غَرَامَةٌ إِتْلاَفٌ':Added, #1: 1	غَرَّ الْمُشْتَرِيَ
u'غَرَامَةٌ بَدَلٌ':Added, #1: 1	غَرَامَةَ الْإِتْلَافِ
u'غَرَامَةٌ ثَمَنٌ':Added, #1: 1	غَرَامَةُ بَدَلِهِ
u'غَرَامَةٌ شَيْءٌ':Added, #1: 1	غَرَامَةُ الثَّمَنِ
u'غَرَامَةٌ قسمة':Added, #1: 1	غَرَامَةُ شَيْءٍ
u'غَرَامَةٌ قِسْمَةٌ':Added, #1: 1	غَرَامَةُ الْقِسْمَةِ
u'غَرَامَةٌ قِيمَةٌ':Added, #1: 1	غَرَامَةُ الْقِسْمَةِ
u'غَرَامَةٌ مثل':Added, #3: 3	غَرَامَةُ الْقِيمَةِ
u'غَرَامَةٌ مِثْلٌ':Added, #1: 1	غَرَامَةِ الْمِثْلِ
u'غَرَامَةٌ مِثْلٌ':Added, #1: 1	غَرَامَةِ الْمِثْلِ
u'غَرَامَةٌ نَفَقَةٌ':Added, #1: 1	غَرَامَةُ الْمِثْلَيْنِ
u'غَرَامَةٌ نَقْصٌ':Added, #1: 1	غَرَامَةُ النَّفَقَةِ
u'غَرَّ بَائِعٌ':Subject, #1: 1	غَرَامَةُ نَقْصِ
u'غُرْبَةٌ حارِثٌ':Added, #1: 1	غَرَّ الْبَائِعُ
u'غَرَّبَ عُمَرٌ':Subject, #1: 1	غُرْبَةُ الْحَارِثِ
u'غَرْبَلَةٌ قَمْحٌ':Added, #2: 2	غَرَّبَ عُمَرُ
u'غَرْبَلَةٌ قَمْحٌ':Added, #1: 1	غَرْبَلَةُ قَمْحٍ
u'غَرْبَلَ قَتِيلٌ':Subject, #2: 2	غَرْبَلَةُ الْقَمْحِ
u'غَرَرٌ اِنْفِساخٌ':Added, #1: 1	غَرْبَلَ الْقَتِيلُ
u'غَرَرٌ اِنْفِساخٌ':Added, #3: 3	غَرَرَ انْفِسَاخِ
u'غَرَرٌ إيرَادٌ':Added, #4: 4	غَرَرُ انْفِسَاخِ
u'غَرَرٌ جَهالَة':Added, #1: 1	غَرَرِ إيرَادِ
u'غَرَّرَ حالٌ':Predicate, #1: 1	غَرَرُ الْجَهَالَةِ
u'غَرَرٌ خيار':Added, #1: 1	غَرَّرَ حَالَ
u'غَرَرٌ خِيَارٌ':Added, #1: 1	غَرَرَ الْخِيَارِ
u'غَرَرٌ طَرِيقٌ':Added, #1: 1	غَرَرَ الْخِيَارِ
u'غَرَرٌ فَسْخٌ':Added, #1: 1	غَرَرِ الطَّرِيقِ
u'غَرَرٌ وُرُودٌ':Added, #1: 1	غَرَرُ الْفَسْخِ
u'غَرْزٌ إِبْرَةٌ':Added, #1: 1	غَرَرُ وُرُودِهِ
u'غَرْزٌ إِبْرَةٌ':Added, #1: 1	غَرْزَ الْإِبْرَةِ
u'غَرَزَ بَيْنٌ':Predicate, #1: 1	غَرْزِ الْإِبْرَةِ
u'غَرَزَ ثَالِثٌ':Predicate, #1: 1	غَرَزَ بَيْنَ
u'غَرْزٌ جلد':Added, #1: 1	غَرَزَ الثَّالِثَ
u'غَرْزٌ جِلْدٌ':Added, #1: 1	غَرْزُ الْجِلْدِ
u'غَرْزٌ خَشَبٌ':Added, #1: 1	غَرْزُ الْجِلْدِ
u'غَرْزٌ خَشَبٌ':Added, #1: 1	غَرْزِ خَشَبٍ
u'غَرْزٌ خَشَبَةٌ':Added, #1: 1	غَرْزِ خَشَبِهِ
u'غَرَزَ عُودٌ':Predicate, #1: 1	غَرْزِ الْخَشَبَةِ
u'غَرَسَ أرْضٌ':Predicate, #1: 1	غَرَزَ الْعُودَ
u'غَرَسَ أرْضٌ':Predicate, #1: 1	غَرَسَ أَرْضَ
u'غَرْسٌ أرْضٌ':Added, #3: 3	غَرَسَ الْأَرْضَ
u'غَرَسَ أَشْجَارٌ':Predicate, #1: 1	غَرْسُ الْأَرْضِ
u'غَرْسٌ أَشْجَارٌ':Added, #2: 2	غَرَسَ الْأَشْجَارَ
u'غَرْسٌ أَشْجَارٌ':Added, #1: 1	غَرْسُ أَشْجَارٍ
u'غَرْسٌ أَشْجَارٌ':Added, #1: 1	غَرْسَ الْأَشْجَارِ
u'غَرْسٌ بُسْتانٌ':Added, #6: 6	غَرْسُ الْأَشْجَارِ
u'غَرْسٌ بَعْضٌ':Added, #1: 1	غَرْسُ الْبُسْتَانِ
u'غَرْسٌ جَرِيدٌ':Added, #1: 1	غَرْسُ بَعْضِهِ
u'غَرَسَ رَجُلٌ':Subject, #1: 1	غَرْسِ الْجَرِيدَتَيْنِ
u'غَرْسٌ رَجُلٌ':Added, #1: 1	غَرَسَ رَجُلٌ
u'غَرَسَ شَجَرٌ':Predicate, #1: 1	غَرْسَ رَجُلٍ
u'غَرْسٌ شَجَرٌ':Added, #1: 1	غَرَسَ الشَّجَرَ
u'غَرْسٌ شَجَرٌ':Added, #1: 1	غَرْسَ الشَّجَرِ
u'غَرْسٌ شَجَرٌ':Added, #1: 1	غَرْسِ شَجَرٍ
u'غَرْسٌ شَجَرٌ':Added, #2: 2	غَرْسِ الشَّجَرِ
u'غَرَسَ شَجَرَةٌ':Predicate, #3: 3	غَرْسُ الشَّجَرِ
u'غَرْسٌ شَجَرَةٌ':Added, #1: 1	غَرَسَ شَجَرَةَ
u'غَرْسٌ شَجَرَةٌ':Added, #1: 1	غَرْسَ شَجَرَةٍ
u'غَرْسٌ شَجَرَةٌ':Added, #2: 2	غَرْسُ شَجَرَةٍ
u'غَرَسَ غَاصِبٌ':Subject, #5: 5	غَرْسِ الشَّجَرَةِ
u'غَرْسٌ غَاصِبٌ':Added, #2: 2	غَرَسَ الْغَاصِبُ
u'غَرْسٌ غير':Added, #4: 4	غَرْسِ الْغَاصِبِ
u'غَرْسٌ غَيْرٌ':Added, #1: 1	غَرْسَ غَيْرِهِ
u'غَرَسَ قِيمَةٌ':Subject, #1: 1	غَرْسَ غَيْرِهِ
u'غَرَسَ كَرْمٌ':Predicate, #1: 1	غَرَسَ الْقِيمَةُ
u'غَرَسَ مِثَالٌ':Subject, #1: 1	غَرَسَ الْكَرْمَ
u'غَرَسَ مَحْجُورٌ':Subject, #1: 1	غَرَسَ مِثَالٌ
u'غَرَسَ نَاحِي':Predicate, #1: 1	غَرَسَ الْمَحْجُورُ
u'غَرَسَ نَاظِرٌ':Subject, #1: 1	غَرَسَ نَاحِيَةً
u'غَرْسٌ نَخْلٌ':Added, #3: 3	غَرَسَ نَاظِرٌ
u'غَرَسَ نخلة':Predicate, #1: 1	غَرْسَ نَخْلٍ
u'غَرَسَ نَخْلَةٌ':Predicate, #1: 1	غَرَسَ النّخْلَةَ
u'غَرَسَ وَاقِفٌ':Subject, #1: 1	غَرَسَ النّخْلَةَ
u'غَرَضَ صَحِيحٌ':Predicate, #1: 1	غَرَسَ الْوَاقِفُ
u'غَرَضَ وَاقِفٌ':Predicate, #1: 1	غَرَضَ صَحِيحَ
u'غَرَّ عَبْدٌ':Subject, #1: 1	غَرَضَ الْوَاقِفِينَ
u'غَرْفٌ مَاءٌ':Added, #2: 2	غَرَّ عَبْدٌ
u'غَرِقَ بَعْضٌ':Subject, #1: 1	غَرْفُ مَاءِ
u'غَرِقَ بِنَاءٌ':Subject, #1: 1	غَرِقَ بَعْضُ
u'غَرِقَ جَمَاعَةٌ':Subject, #1: 1	غَرِقَ بِنَاءُ
u'غَرِقَ دفن':Predicate, #1: 1	غَرِقَ جَمَاعَةٌ
u'غَرَّقَ سَفِينَةٌ':Predicate, #1: 1	غَرِقَ دُفِنَ
u'غَرِقَ فِرْعَوْنُ':Subject, #1: 1	غَرَّقَ السَّفِينَةَ
u'غَرِقَ مَرْكَبٌ':Subject, #1: 1	غَرِقَ فِرْعَوْنُ
u'غَرِقَ مُسْلِمٌ':Subject, #1: 1	غَرِقَ مَرْكَبُهُ
u'غَرِقَ نَزْعٌ':Predicate, #1: 1	غَرِقَ مُسْلِمٌ
u'غَرِقَ نِصْفٌ':Subject, #1: 1	أَغْرَقَ النَّزْعَ
u'غَرِمَ أَبٌ':Subject, #1: 1	غَرِقَ نِصْفُ
u'غَرِمَ أُجْرَةٌ':Predicate, #4: 4	غَرِمَ الْأَبُ
u'غَرِمَ أَجْنَبِيٌّ':Subject, #3: 3	غَرِمَ أُجْرَةَ
u'غُرْمٌ أقَلُّ':Added, #1: 1	غَرِمَ الْأَجْنَبِيُّ
u'غَرِمَ ألف':Predicate, #2: 2	غُرْمُ الْأَقَلِّ
u'غَرِمَ ألْفٌ':Predicate, #1: 1	غَرِمَ الْأَلْفَ
u'غَرِمَ أَلْفٌ':Predicate, #1: 1	غَرِمَ الْأَلْفَ
u'غَرَّمَ المُشْتَرِي':Predicate, #1: 1	غَرِمَ الْأَلْفَ
u'غُرْمٌ أَمْوَالٌ':Added, #1: 1	غَرَّمَ الْمُشْتَرِيَ
u'غَرَّمَ أهْلٌ':Predicate, #1: 1	غُرْمَ الْأَمْوَالِ
u'غَرِمَ أَوَّلُ':Subject, #1: 1	غَرَّمَ أَهْلَ
u'غَرِمَ بَاعَةٌ':Subject, #1: 1	غَرِمَ الْأَوَّلُ
u'غَرِمَ بَائِعٌ':Subject, #1: 1	غَرِمَ الْبَاعَةُ
u'غَرِمَ بَدَلٌ':Predicate, #2: 2	غَرِمَ الْبَائِعُ
u'غَرِمَ بَدَلٌ':Predicate, #1: 1	غَرِمَ الْبَدَلَ
u'غُرْمٌ بَدَلٌ':Added, #2: 2	غَرِمَ بَدَلَ
u'غُرْمٌ بَذْرٌ':Added, #1: 1	غُرْمِ بَدَلِهِ
u'غَرِمَ تالِف':Predicate, #1: 1	غُرْمُ الْبَذْرِ
u'غُرْمٌ تَرْكٌ':Added, #2: 2	غَرِمَ التَّالِفَ
u'غَرِمَ تَسْمِيَة':Predicate, #1: 1	غُرْمِ التَّرْكِ
u'غُرْمٌ تَكْمِلَةٌ':Added, #1: 1	غَرِمَ التَّسْمِيَةَ
u'غَرِمَ ثَالِثٌ':Predicate, #1: 1	غُرْمِ تَكْمِلَةِ
u'غَرِمَ ثَمَنٌ':Predicate, #1: 1	غَرِمَ ثَالِثَةً
u'غُرْمٌ ثَمَنٌ':Added, #3: 3	غَرِمَ الثَّمَنَ
u'غُرْمٌ جِزْيَةٌ':Added, #3: 3	غُرْمُ الثَّمَنِ
u'غُرْمٌ جَنِينٌ':Added, #2: 2	غُرْمِ الْجِزْيَةِ
u'غَرِمَ حاكِمٌ':Subject, #1: 1	غُرْمُ جَنِينِ
u'غَرِمَ حِصَّةٌ':Predicate, #3: 3	غَرِمَ الْحَاكِمُ
u'غُرْمٌ حِصَّةٌ':Added, #1: 1	غَرِمَ حِصَّةَ
u'غَرَّ مُحِيل':Predicate, #1: 1	غُرْمُ حِصَّةِ
u'غَرَّمَ دَافِعٌ':Predicate, #1: 1	غَرَّ الْمُحِيلَ
u'غُرْمٌ دَرَاهِمُ':Added, #1: 1	غَرَّمَ الدَّافِعَ
u'غَرِمَ دِيَةٌ':Predicate, #1: 1	غُرْمِ الدَّرَاهِمِ
u'غَرِمَ رَاجِعٌ':Subject, #1: 1	غَرِمَ الدِّيَةَ
u'غَرِمَ رَاهِنٌ':Subject, #2: 2	غَرِمَ الرَّاجِعُ
u'غَرِمَ رَبُّ':Subject, #3: 3	غَرِمَ الرَّاهِنُ
u'غَرِمَ رُبْعٌ':Predicate, #2: 2	غَرِمَ رَبُّ
u'غَرِمَ رُبُعٌ':Predicate, #1: 1	غَرِمَ الرُّبْعَ
u'غُرْمٌ رُبْعٌ':Added, #4: 4	غَرِمَ رُبُعَ
u'غَرِمَ رَجُلٌ':Predicate, #1: 1	غُرْمُ الرُّبْعِ
u'غَرِمَ رَجُلٌ':Subject, #1: 1	أَغْرَمَ رَجُلاً
u'غَرِمَ رَسُولٌ':Subject, #1: 1	غَرِمَ الرَّجُلُ
u'غَرِمَ زائِدٌ':Predicate, #1: 1	غَرِمَ الرَّسُولُ
u'غُرْمٌ زِيادَةٌ':Added, #1: 1	غَرِمَ الزَّائِدَ
u'غَرِمَ سَارِقٌ':Predicate, #1: 1	غُرْمُ الزِّيَادَةِ
u'غُرْمٌ سَارِقٌ':Added, #1: 1	أَغْرَمَ السَّارِقَ
u'غُرْمٌ سَقْيٌ':Added, #1: 1	غُرْمِ السَّارِقِ
u'غَرِمَ سِنٌّ':Predicate, #1: 1	غُرْمَ السَّقْيِ
u'غُرْمٌ سَيِّدٌ':Added, #1: 1	غَرِمَ سِنَّ
u'غَرِمَ شَاهِدٌ':Subject, #1: 1	غُرْمِ سَيِّدِهِ
u'غَرَّ مُشْتَرِي':Predicate, #1: 1	غَرِمَ الشَّاهِدُ
u'غَرِمَ شُهُودٌ':Subject, #1: 1	غَرَّ الْمُشْتَرِيَ
u'غُرْمٌ شَيْءٌ':Added, #1: 1	غَرِمَ شُهُودُ
u'غُرْمٌ صَاحِبٌ':Added, #1: 1	غُرْمُ شَيْءٍ
u'غَرِمَ ضَامِنٌ':Subject, #1: 1	غُرْمِ صَاحِبِ
u'غُرْمٌ ضَمَانٌ':Added, #1: 1	غَرِمَ الضَّامِنُ
u'غَرِمَ عَاقِلٌ':Subject, #1: 1	غُرْمُ الضَّمَانِ
u'غَرِمَ عَامِلٌ':Subject, #2: 2	غَرِمَ عَاقِلَةُ
u'غُرْمٌ عُشْرٌ':Added, #1: 1	غَرِمَ الْعَامِلُ
u'غَرِمَ عقر':Predicate, #1: 1	غُرْمِ عُشْرِ
u'غَرِمَ عُقْرٌ':Predicate, #2: 2	غَرِمَ الْعُقْرَ
u'غَرِمَ غَاصِبٌ':Subject, #2: 2	غَرِمَ الْعُقْرَ
u'غُرْمٌ غَاصِبٌ':Added, #3: 3	غَرِمَ الْغَاصِبُ
u'غُرْمٌ غُرَّةٌ':Added, #2: 2	غُرْمِ الْغَاصِبِ
u'غَرِمَ غرماء':Subject, #2: 2	غُرْمِ الْغُرَّةِ
u'غَرِمَ غَرِيمٌ':Subject, #1: 1	غَرِمَ الْغُرَمَاءُ
u'غُرْمٌ غَلَّةٌ':Added, #1: 1	غَرِمَ الْغَرِيمُ
u'غَرِمَ قَاتِلٌ':Subject, #1: 1	غُرْمُ غَلَّاتِ
u'غَرِمَ قَاتِلٌ':Subject, #1: 1	غَرِمَ قَاتِلُهُ
u'غُرْمٌ قَدْرٌ':Added, #5: 5	غَرِمَ الْقَاتِلُ
u'غَرِمَ قِسْطٌ':Predicate, #1: 1	غُرْمُ قَدْرِ
u'غَرِمَ قِيمَةٌ':Predicate, #1: 1	غَرِمَ قِسْطَ
u'غَرِمَ قِيمَةٌ':Predicate, #10: 10	غَرِمَ قِيمَةَ
u'غُرْمٌ قِيمَةٌ':Added, #9: 9	غَرِمَ الْقِيمَةَ
u'غُرْمٌ قِيمَةٌ':Added, #1: 1	غُرْمَ الْقِيمَةِ
u'غُرْمٌ قِيمَةٌ':Added, #1: 1	غُرْمُ قِيمَةِ
u'غُرْمٌ قِيمَةٌ':Added, #1: 1	غُرْمَ قِيمَتِهِ
u'غُرْمٌ قِيمَةٌ':Added, #2: 2	غُرْمُ قِيمَتِهِ
u'غُرْمٌ قِيمَةٌ':Added, #2: 2	غُرْمِ قِيمَتِهِ
u'غُرْمٌ قِيمَةٌ':Added, #3: 3	غُرْمُ الْقِيمَةِ
u'غُرْمٌ كِرَاءٌ':Added, #7: 7	غُرْمِ الْقِيمَةِ
u'غَرِمَ لبن':Predicate, #1: 1	غُرْمُ الْكِرَاءِ
u'غَرِمَ لَبَنٌ':Predicate, #1: 1	غَرِمَ اللَّبَنَ
u'غَرِمَ مَالٌ':Predicate, #1: 1	غَرِمَ اللَّبَنَ
u'غُرْمٌ مَالٌ':Added, #3: 3	غَرِمَ الْمَالَ
u'غَرَّمَ مَالِكٌ':Subject, #6: 6	غُرْمُ الْمَالِ
u'غَرِمَ مَأْمُورٌ':Subject, #1: 1	غَرَّمَ الْمَالِكُ
u'غَرِمَ مُبْتاع':Subject, #1: 1	غَرِمَ الْمَأْمُورُ
u'غَرِمَ مثل':Predicate, #1: 1	غَرِمَ الْمُبْتَاعُ
u'غَرِمَ مِثْلٌ':Predicate, #1: 1	غَرِمَ الْمِثْلَ
u'غَرِمَ مثل':Predicate, #1: 1	غَرِمَ الْمِثْلَ
u'غَرِمَ مِثْلٌ':Predicate, #4: 4	غَرِمَ مِثْلَ
u'غَرِمَ مُرْتَهِنٌ':Subject, #4: 4	غَرِمَ مِثْلَ
u'غَرِمَ مَرْهُونٌ':Subject, #1: 1	غَرِمَ الْمُرْتَهِنُ
u'غَرِمَ مُسْتَعِيرٌ':Subject, #1: 1	غَرِمَ الْمَرْهُونُ
u'غُرْمٌ مُسْتَهْلِكٌ':Added, #2: 2	غَرِمَ الْمُسْتَعِيرُ
u'غَرَّمَ مُشْتَرِي':Predicate, #1: 1	غُرْمُ الْمُسْتَهْلِكَاتِ
u'غَرِمَ مُضَارِبٌ':Subject, #1: 1	غَرَّمَ الْمُشْتَرِيَ
u'غُرْمٌ مُفْظِع':Added, #2: 2	غَرِمَ الْمُضَارِبُ
u'غَرِمَ مُكْرِهٌ':Subject, #4: 4	غُرْمٍ مُفْظِعٍ
u'غَرِمَ مُناضِلٌ':Subject, #2: 2	غَرِمَ الْمُكْرِهُ
u'غُرْمٌ مَهْرٌ':Added, #1: 1	غَرِمَ الْمُنَاضِلُ
u'غَرَّمَ مُوَكِّلٌ':Subject, #1: 1	غُرْمَ الْمَهْرِ
u'غَرِمَ نِصْفٌ':Predicate, #1: 1	غَرَّمَ الْمُوَكِّلُ
u'غَرِمَ نِصْفٌ':Predicate, #12: 12	غَرِمَ نِصْفَ
u'غَرِمَ نَصِيبٌ':Predicate, #2: 2	غَرِمَ النِّصْفَ
u'غَرِمَ نَفَقَةٌ':Predicate, #1: 1	غَرِمَ نَصِيبَ
u'غَرِمَ نَقْصٌ':Predicate, #1: 1	غَرِمَ النَّفَقَةَ
u'غَرِمَ نَقْصٌ':Predicate, #2: 2	غَرِمَ النَّقْصَ
u'غُرْمٌ نَقْصٌ':Added, #3: 3	غَرِمَ نَقْصَ
u'غَرِمَ نُقْصَانٌ':Predicate, #2: 2	غُرْمِ نَقْصِ
u'غَرِمَ نُقْصَانٌ':Predicate, #1: 1	غَرِمَ النُّقْصَانَ
u'غَرِمَ وَاجِدٌ':Subject, #2: 2	غَرِمَ نُقْصَانَ
u'غَرِمَ واحد':Subject, #2: 2	غَرِمَ وَاجِدُهُ
u'غَرِمَ وَاحِدٌ':Subject, #1: 1	غَرِمَ الْوَاحِدُ
u'غَرِمَ وَاطِئٌ':Subject, #1: 1	غَرِمَ الْوَاحِدُ
u'غَرِمَ وَرَثَةٌ':Predicate, #1: 1	غَرِمَ الْوَاطِئُ
u'غَرِمَ وَصِيٌّ':Subject, #1: 1	أَغْرَمَ الْوَرَثَةَ
u'غَرَّمَ وَكِيلٌ':Predicate, #1: 1	غَرِمَ الْوَصِيُّ
u'غَرِمَ وَكِيلٌ':Subject, #1: 1	غَرَّمَ الْوَكِيلَ
u'غَرِمَ وَلِيٌّ':Subject, #4: 4	غَرِمَ الْوَكِيلُ
u'غَرَّ نَاسٌ':Predicate, #1: 1	غَرِمَ الْوَلِيُّ
u'غُرُوبٌ آخِرُ':Added, #1: 1	غَرَّ النَّاسَ
u'غُرُوبٌ حُمْرَةٌ':Added, #1: 1	غُرُوبُ آخِرِ
u'غُرُوبٌ رابع':Added, #2: 2	غُرُوبِ حُمْرَةِ
u'غُرُوبٌ رَابِعٌ':Added, #3: 3	غُرُوبِ الرَّابِعِ
u'غُرُوبٌ شفق':Added, #3: 3	غُرُوبِ الرَّابِعِ
u'غُرُوبٌ شَفَقٌ':Added, #7: 7	غُرُوبِ الشَّفَقِ
u'غُرُوبٌ شمس':Added, #7: 7	غُرُوبِ الشَّفَقِ
u'غُرُوبٌ شَمْسٌ':Added, #16: 16	غُرُوبُ الشَّمْسِ
u'غُرُوبٌ شمس':Added, #16: 16	غُرُوبُ الشَّمْسِ
u'غُرُوبٌ شَمْسٌ':Added, #1: 1	غُرُوبُ شَمْسِ
u'غُرُوبٌ شمس':Added, #1: 1	غُرُوبُ شَمْسِ
u'غُرُوبٌ شَمْسٌ':Added, #277: 277	غُرُوبِ الشَّمْسِ
u'غُرُوبٌ شمس':Added, #277: 277	غُرُوبِ الشَّمْسِ
u'غُرُوبٌ شَمْسٌ':Added, #3: 3	غُرُوبِ شَمْسِهِ
u'غُرُوبٌ شمس':Added, #3: 3	غُرُوبِ شَمْسِهِ
u'غُرُوبٌ شَمْسٌ':Added, #6: 6	غُرُوبِ الشّمْسِ
u'غُرُوبٌ شمس':Added, #6: 6	غُرُوبِ الشّمْسِ
u'غُرُوبٌ شَمْسٌ':Added, #7: 7	غُرُوبِ شَمْسِ
u'غُرُوبٌ شمس':Added, #7: 7	غُرُوبِ شَمْسِ
u'غُرُوبٌ شَمْسٌ':Added, #8: 8	غُرُوبَ الشَّمْسِ
u'غُرُورٌ شَيْطَانٌ':Added, #8: 8	غُرُوبَ الشَّمْسِ
u'غُرُورٌ شَيْطَانٌ':Added, #1: 1	غُرُورَ الشّيْطَانِ
u'غُرُورٌ غير':Added, #1: 1	غُرُورِ الشَّيْطَانِ
u'غُرُورٌ غَيْرٌ':Added, #1: 1	غُرُورَ الْغَيْرِ
u'غُرُورٌ مُوَكِّلٌ':Added, #1: 1	غُرُورَ الْغَيْرِ
u'غَزَا آخِرُ':Predicate, #1: 1	غُرُورِ الْمُوَكِّلِ
u'غَزَا إمَامٌ':Subject, #2: 2	غَزَا آخِرَ
u'غَزَا بُغاةٌ':Subject, #1: 1	غَزَا الْإِمَامُ
u'غَزَا بِلادٌ':Predicate, #1: 1	غَزَا الْبُغَاةُ
u'غَزَا رَسُولٌ':Subject, #1: 1	غَزَا بِلَادَ
u'غَزَا رُومٌ':Predicate, #14: 14	غَزَا رَسُولُ
u'غَزَا سِتٌّ':Predicate, #1: 1	غَزَا الرُّومَ
u'غَزَا صَفْوَان':Subject, #1: 1	غَزَا سِتَّ
u'غَزَا عَبْدٌ':Subject, #1: 1	غَزَا صَفْوَانُ
u'غَزَا عَدُوٌّ':Subject, #4: 4	غَزَا الْعَبْدُ
u'غَزَا غَزْوَةٌ':Predicate, #1: 1	غَزَا الْعَدُوُّ
u'غَزَا فلان':Predicate, #2: 2	غَزَا غَزْوَةَ
u'غَزَا قَالٌ':Predicate, #2: 2	غَزَا خَيْبَرَ
u'غَزَا قَوْمٌ':Subject, #1: 1	غَزَا قَالَ
u'غَزَا نَحْوٌ':Subject, #1: 1	غَزَا قَوْمٌ
u'غَزَلٌ أَشْعَارٌ':Added, #1: 1	غَزَا نَحْوُ
u'غَزْلٌ الْمَرْأَةُ':Added, #1: 1	غَزَلِ الْأَشْعَارِ
u'غَزْلٌ الْمَرْأَةُ':Added, #1: 1	غَزْلِ الْمَرْأَةِ
u'غَزْلٌ أُمٌّ':Added, #3: 3	غَزْلَ الْمَرْأَةِ
u'غَزْلٌ اِمْرَأَةٌ':Added, #1: 1	غَزْلِ أُمِّهِ
u'غَزْلٌ إِنْسانٌ':Added, #1: 1	غَزْلِ امْرَأَتِهِ
u'غَزْلٌ خَزٌّ':Added, #1: 1	غَزْلَ إنْسَانٍ
u'غَزْلٌ رَجُلٌ':Added, #1: 1	غَزْلُ خَزٍّ
u'غَزْلٌ صُوفٌ':Added, #1: 1	غَزْلُ الرَّجُلِ
u'غَزْلٌ صُوفٌ':Added, #1: 1	غَزْلِ الصُّوفِ
u'غَزْلٌ غير':Added, #2: 2	غَزْلُ الصُّوفِ
u'غَزْلٌ غَيْرٌ':Added, #1: 1	غَزْلَ غَيْرِهِ
u'غَزْلٌ فِضَّةٌ':Added, #1: 1	غَزْلَ غَيْرِهِ
u'غَزْلٌ فُلاَنٌ':Added, #1: 1	غَزْلِ الْفِضَّةِ
u'غَزَلَ قُطْنٌ':Predicate, #1: 1	غَزْلِ فُلَانٍ
u'غَزْلٌ قُطْنٌ':Added, #1: 1	غَزَلَ قُطْنَ
u'غَزْلٌ قُطْنٌ':Added, #1: 1	غَزْلَ قُطْنٍ
u'غَزْلٌ قُطْنٌ':Added, #1: 1	غَزْلُ قُطْنٍ
u'غَزْلٌ قُطْنٌ':Added, #1: 1	غَزْلِ قُطْنٍ
u'غَزْلٌ مثل':Added, #3: 3	غَزْلِ الْقُطْنِ
u'غَزْلٌ مِثْلٌ':Added, #1: 1	غَزْلُ مِثْلِهِ
u'غَزْلٌ هَدْيٌ':Added, #1: 1	غَزْلُ مِثْلِهِ
u'غَزْوٌ بَرٌّ':Added, #1: 1	غَزْلِ الْهَدْيِ
u'غَزْوَةٌ اِبْنٌ':Added, #1: 1	غَزْوِ الْبَرِّ
u'غَزْوَةٌ أحْزَابٌ':Added, #3: 3	غَزْوَةُ ابْنِ
u'غَزْوَةٌ أَنْمَارٌ':Added, #1: 1	غَزْوَةِ الْأَحْزَابِ
u'غَزْوَةٌ بَدْرٌ':Added, #3: 3	غَزْوَةِ أَنْمَارٍ
u'غَزْوَةٌ بَدْرٌ':Added, #11: 11	غَزْوَةُ بَدْرٍ
u'غَزْوَةٌ جَيْشٌ':Added, #12: 12	غَزْوَةِ بَدْرٍ
u'غَزْوَةٌ حَمْرَاء':Added, #1: 1	غَزْوَةُ جَيْشِ
u'غَزْوَةٌ خَنْدَقٌ':Added, #1: 1	غَزْوَةُ حَمْرَاءِ
u'غَزْوَةٌ خَنْدَقٌ':Added, #1: 1	غَزْوَةَ الْخَنْدَقِ
u'غَزْوَةٌ خَنْدَقٌ':Added, #5: 5	غَزْوَةِ الْخَنْدَقِ
u'غَزْوَةٌ دَوْم':Added, #7: 7	غَزْوَةُ الْخَنْدَقِ
u'غَزْوَةٌ رِقاعٌ':Added, #1: 1	غَزْوَةُ دَوْمَةِ
u'غَزْوَةٌ رِقاعٌ':Added, #1: 1	غَزْوَةُ الرِّقَاعِ
u'غَزْوَةٌ رُومٌ':Added, #1: 1	غَزْوَةِ الرّقَاعِ
u'غَزْوَةٌ زَيْدٌ':Added, #1: 1	غَزْوَةِ الرّومِ
u'غَزْوَةٌ زَيْدٌ':Added, #1: 1	غَزْوَةَ زَيْدٍ
u'غَزْوَةٌ سَابِقٌ':Added, #2: 2	غَزْوَةُ زَيْدِ
u'غَزْوَةٌ سَعْدٌ':Added, #1: 1	غَزْوَةٍ سَابِقَةٍ
u'غَزْوَةٌ سَوِيق':Added, #1: 1	غَزْوَةِ سَعْدِ
u'غَزْوَةٌ سَوِيق':Added, #1: 1	غَزْوَةِ السّوِيقِ
u'غَزْوَةٌ سَوِيق':Added, #2: 2	غَزْوَةَ السّوِيقِ
u'غَزْوَةٌ طَائِفٌ':Added, #3: 3	غَزْوَةُ السّوِيقِ
u'غَزْوَةٌ طَائِفٌ':Added, #1: 1	غَزْوَةُ الطّائِفِ
u'غَزْوَةٌ طَائِفٌ':Added, #4: 4	غَزْوَةِ الطّائِفِ
u'غَزْوَةٌ عَبْدٌ':Added, #6: 6	غَزْوَةِ الطَّائِفِ
u'غَزْوَةٌ عَبْدٌ':Added, #1: 1	غَزْوَةِ عَبْدِ
u'غَزْوَةٌ عُسْرَةٌ':Added, #3: 3	غَزْوَةُ عَبْدِ
u'غَزْوَةٌ عُسْرَةٌ':Added, #1: 1	غَزْوَةَ الْعُسْرَةِ
u'غَزْوَةٌ غَالِبٌ':Added, #3: 3	غَزْوَةِ الْعُسْرَةِ
u'غَزْوَةٌ غَالِبٌ':Added, #1: 1	غَزْوَةَ غَالِبِ
u'غَزْوَةٌ غَالِبٌ':Added, #1: 1	غَزْوَةُ غَالِبِ
u'غَزْوَةٌ فَتْحٌ':Added, #1: 1	غَزْوَةِ غَالِبِ
u'غَزْوَةٌ فَتْحٌ':Added, #1: 1	غَزْوَةَ الْفَتْحِ
u'غَزْوَةٌ فَتْحٌ':Added, #1: 1	غَزْوَةُ الْفَتْحِ
u'غَزْوَةٌ مُحَارِبٌ':Added, #3: 3	غَزْوَةِ الْفَتْحِ
u'غَزْوَةٌ مُحَمَّدٌ':Added, #1: 1	غَزْوَةِ مُحَارِبٍ
u'غَزْوَةٌ مَضِيقٌ':Added, #1: 1	غَزْوَةَ مُحَمّدِ
u'غَزْوَةٌ نَجْدٌ':Added, #1: 1	غَزْوَةَ الْمَضِيقِ
u'غَزْوَةٌ هِنْدٌ':Added, #1: 1	غَزْوَةِ نَجْدٍ
u'غَزْوَةٌ واحد':Added, #1: 1	غَزْوَةَ الْهِنْدِ
u'غَزْوَةٌ وَاحِدٌ':Added, #2: 2	غَزْوَةٍ وَاحِدَةٍ
u'غَزْوٌ رَسُولٌ':Added, #2: 2	غَزْوَةٍ وَاحِدَةٍ
u'غَزْوٌ رَسُولٌ':Added, #1: 1	غَزْوِ الرّسُولِ
u'غَزْوٌ سَنَةٌ':Added, #1: 1	غَزْوِ رَسُولِ
u'غَزْوٌ عَبْدٌ':Added, #1: 1	غَزْوِ سَنَةٍ
u'غَزْوٌ نَبِيٌّ':Added, #1: 1	غَزْوُ عَبْدِ
u'غَسَقٌ لَيْلٌ':Added, #1: 1	غَزْوُ النَّبِيِّ
u'غَسَقٌ لَيْلٌ':Added, #12: 12	غَسَقِ اللَّيْلِ
u'غَسَلَ أثَرٌ':Predicate, #1: 1	غَسَقُ اللَّيْلِ
u'غَسْلٌ أَحْجارٌ':Added, #1: 1	غَسَلَ أَثَرَ
u'غَسَلَ أحَدٌ':Predicate, #1: 1	غَسْلِ الْأَحْجَارِ
u'غَسَلَ أَرْبَعَةٌ':Predicate, #1: 1	غَسَلَ أَحَدَ
u'غَسْلٌ أَرُزٌّ':Added, #1: 1	غَسَلَ أَرْبَعَةَ
u'غَسَلَ أسافل':Predicate, #1: 1	غَسْلُ الْأَرُزِّ
u'غَسَلَ أَعْضَاءٌ':Predicate, #1: 1	غَسَلَ الْأَسَافِلَ
u'غَسْلٌ أَعْضَاءٌ':Added, #3: 3	غَسَلَ أَعْضَاءَ
u'غَسْلٌ أَعْضَاءٌ':Added, #1: 1	غَسْلَ أَعْضَاءٍ
u'غَسْلٌ أَعْضَاءٌ':Added, #2: 2	غَسْلِ أَعْضَاءٍ
u'غَسْلٌ أَعْضَاءٌ':Added, #2: 2	غَسْلَ الْأَعْضَاءِ
u'غَسْلٌ أَعْضَاءٌ':Added, #3: 3	غَسْلُ أَعْضَاءِ
u'غَسْلٌ أَعْضَاءٌ':Added, #6: 6	غَسْلِ أَعْضَاءِ
u'غَسْلٌ أَعْضَاءٌ':Added, #9: 9	غَسْلُ الْأَعْضَاءِ
u'غَسْلٌ أَكْثَرُ':Added, #9: 9	غَسْلِ الْأَعْضَاءِ
u'غَسْلٌ الْمَرْأَةُ':Added, #1: 1	غَسْلَ أَكْثَرِ
u'غَسَّلَ أُمٌّ':Predicate, #1: 1	غَسْلُ الْمَرْأَةِ
u'غَسَلَ إِناءٌ':Predicate, #3: 3	غَسَّلَ أُمَّ
u'غَسْلٌ إِناءٌ':Added, #1: 1	غَسَلَ الْإِنَاءَ
u'غَسْلٌ إِناءٌ':Added, #1: 1	غَسْلَ الْإِنَاءِ
u'غَسْلٌ إِناءٌ':Added, #1: 1	غَسْلُ إنَاءِ
u'غَسْلٌ إِناءٌ':Added, #2: 2	غَسْلِ الإِنَاءِ
u'غَسْلٌ إِناءٌ':Added, #2: 2	غَسْلُ الْإِنَاءِ
u'غَسْلٌ أَنْفٌ':Added, #3: 3	غَسْلِ الْإِنَاءِ
u'غَسَلَ أَوَّلُ':Predicate, #1: 1	غَسْلِ أَنْفِهِ
u'غَسْلٌ أَوَّلُ':Added, #1: 1	غَسَلَ أَوَّلَ
u'غَسْلٌ أَيْمَنُ':Added, #4: 4	غَسْلِ أَوَّلِ
u'غَسْلٌ أَيْمَن':Added, #2: 2	غَسْلِ الْأَيْمَنِ
u'غَسَلَ بَاطن':Predicate, #2: 2	غَسْلِ الْأَيْمَنِ
u'غَسَلَ باطِنٌ':Predicate, #1: 1	غَسَلَ بَاطِنَ
u'غَسْلٌ بَاطن':Added, #1: 1	غَسَلَ بَاطِنَ
u'غَسْلٌ باطِنٌ':Added, #10: 10	غَسْلُ بَاطِنِ
u'غَسْلٌ بَاطن':Added, #10: 10	غَسْلُ بَاطِنِ
u'غَسْلٌ باطِنٌ':Added, #1: 1	غَسْلُ الْبَاطِنِ
u'غَسْلٌ بَاطن':Added, #1: 1	غَسْلُ الْبَاطِنِ
u'غَسْلٌ باطِنٌ':Added, #1: 1	غَسْلِ بَاطِنِ
u'غَسْلٌ بَاطن':Added, #1: 1	غَسْلِ بَاطِنِ
u'غَسْلٌ باطِنٌ':Added, #3: 3	غَسْلُ بَاطِنِهِ
u'غَسْلٌ باقَةٌ':Added, #3: 3	غَسْلُ بَاطِنِهِ
u'غَسَلَ باقِي':Predicate, #1: 1	غَسْلُ بَاقِيهِ
u'غَسَلَ باقِي':Predicate, #1: 1	غَسَلَ الْبَاقِيَ
u'غَسْلٌ باقِي':Added, #2: 2	غَسَلَ بَاقِيَ
u'غَسْلٌ بدن':Added, #1: 1	غَسْلُ بَاقِيهِ
u'غَسْلٌ بَدَنٌ':Added, #1: 1	غَسْلَ الْبَدَنِ
u'غَسْلٌ بدن':Added, #1: 1	غَسْلَ الْبَدَنِ
u'غَسْلٌ بَدَنٌ':Added, #3: 3	غَسْلُ الْبَدَنِ
u'غَسَلَ بَشَرَةٌ':Predicate, #3: 3	غَسْلُ الْبَدَنِ
u'غَسَلَ بَعْضٌ':Predicate, #1: 1	غَسَلَ بَشَرَةَ
u'غَسْلٌ بَعْضٌ':Added, #7: 7	غَسَلَ بَعْضَ
u'غَسْلٌ بَعْضٌ':Added, #1: 1	غَسْلُ الْبَعْضِ
u'غَسْلٌ بَعْضٌ':Added, #1: 1	غَسْلِ الْبَعْضِ
u'غَسْلٌ بَعْضٌ':Added, #1: 1	غَسْلَ بَعْضِهِ
u'غَسْلٌ بَعْضٌ':Added, #2: 2	غَسْلُ بَعْضِ
u'غَسْلٌ بَعْضٌ':Added, #3: 3	غَسْلَ بَعْضِ
u'غَسَلَ بَقِيَّةٌ':Predicate, #9: 9	غَسْلِ بَعْضِ
u'غَسْلٌ بَقِيَّةٌ':Added, #2: 2	غَسَلَ بَقِيَّةَ
u'غَسْلٌ بَقِيَّةٌ':Added, #1: 1	غَسْلُ بَقِيَّةِ
u'غَسْلٌ بَوْلٌ':Added, #2: 2	غَسْلَ بَقِيَّتِهِ
u'غَسْلٌ بِئْرٌ':Added, #1: 1	غَسْلُ الْبَوْلِ
u'غَسْلٌ بَيَاضٌ':Added, #2: 2	غَسْلُ الْبِئْرِ
u'غَسْلٌ بَيْضَةٌ':Added, #1: 1	غَسْلُ الْبَيَاضِ
u'غَسْلٌ تمام':Added, #1: 1	غَسْلُ الْبَيْضَةِ
u'غَسْلٌ تَمامٌ':Added, #1: 1	غَسْلُ تَمَامِ
u'غَسَلَ ثَانِي':Predicate, #1: 1	غَسْلُ تَمَامِ
u'غَسَلَ ثَلاثُ':Predicate, #1: 1	غَسَلَ الثَّانِيَ
u'غَسْلٌ ثَلاثَةٌ':Added, #1: 1	غَسَلَ ثَلَاثَ
u'غَسَلَ ثَوْبٌ':Predicate, #1: 1	غَسْلُ الثَّلَاثَةِ
u'غَسْلٌ ثَوْبٌ':Added, #3: 3	غَسَلَ الثَّوْبَ
u'غَسْلٌ ثَوْبٌ':Added, #11: 11	غَسْلُ الثَّوْبِ
u'غَسْلٌ ثَوْبٌ':Added, #17: 17	غَسْلِ الثَّوْبِ
u'غَسْلٌ ثَوْبٌ':Added, #1: 1	غَسْلِ ثَوْبٍ
u'غَسْلٌ ثَوْبٌ':Added, #1: 1	غَسْلَ ثَوْبِهِ
u'غَسْلٌ ثَوْبٌ':Added, #1: 1	غَسْلِ ثَوْبَيْنِ
u'غَسْلٌ ثَوْبٌ':Added, #2: 2	غَسْلَ الثَّوْبِ
u'غَسْلٌ ثَوْبٌ':Added, #3: 3	غَسْلِ ثَوْبِهِ
u'غَسْلٌ ثِيابٌ':Added, #4: 4	غَسْلُ ثَوْبِهِ
u'غَسْلٌ ثِيابٌ':Added, #1: 1	غَسْلَ الثِّيَابِ
u'غَسْلٌ ثِيابٌ':Added, #1: 1	غَسْلُ الثِّيَابِ
u'غَسْلٌ ثِيابٌ':Added, #1: 1	غَسْلِ ثِيَابِ
u'غَسْلٌ ثِيابٌ':Added, #1: 1	غَسْلِ ثِيَابِهِ
u'غَسْلٌ ثِيابٌ':Added, #4: 4	غَسْلِ الثِّيَابِ
u'غَسْلٌ جِرَاحَةٌ':Added, #4: 4	غَسْلُ ثِيَابِهِ
u'غَسْلٌ جِرَاحَةٌ':Added, #1: 1	غَسْلَ الْجِرَاحَةِ
u'غَسْلٌ جُرْحٌ':Added, #1: 1	غَسْلُ الْجِرَاحَةِ
u'غَسْلٌ جُرْحٌ':Added, #1: 1	غَسْلَ الْجُرْحِ
u'غَسْلٌ جُرْحٌ':Added, #1: 1	غَسْلِ الْجُرْحِ
u'غَسْلٌ جَرِيحٌ':Added, #2: 2	غَسْلُ جُرْحٍ
u'غَسْلٌ جُزْءٌ':Added, #1: 1	غَسْلِ الْجَرِيحِ
u'غَسْلٌ جُزْءٌ':Added, #1: 1	غَسْلِ الْجُزْءِ
u'غَسْلٌ جُزْءٌ':Added, #4: 4	غَسْلُ جُزْءٍ
u'غَسْلٌ جَسَدٌ':Added, #6: 6	غَسْلِ جُزْءٍ
u'غَسْلٌ جَسَدٌ':Added, #1: 1	غَسْلَ جَسَدِهِ
u'غَسْلٌ جِمَارٌ':Added, #3: 3	غَسْلِ الْجَسَدِ
u'غَسْلٌ جُمْلَةٌ':Added, #1: 1	غَسْلِ الْجِمَارِ
u'غَسْلٌ جُمْلَةٌ':Added, #1: 1	غَسْلُ جُمْلَةٍ
u'غَسَلَ جَمِيع':Predicate, #2: 2	غَسْلِ جُمْلَةِ
u'غَسْلٌ جَمِيع':Added, #1: 1	غَسَلَ الْجَمِيعَ
u'غَسْلٌ جَمِيع':Added, #1: 1	غَسْلَ الْجَمِيعِ
u'غَسْلٌ جَمِيع':Added, #2: 2	غَسْلِ الْجَمِيعِ
u'غَسْلٌ جَنَابَةٌ':Added, #6: 6	غَسْلُ الْجَمِيعِ
u'غَسْلٌ جَنَابَةٌ':Added, #1: 1	غَسْلَ الْجَنَابَةِ
u'غَسْلٌ جَوَانِبُ':Added, #1: 1	غَسْلِ الْجَنَابَةِ
u'غَسْلٌ حَشَفَةٌ':Added, #3: 3	غَسْلِ جَوَانِبِ
u'غَسْلٌ حَشَفَةٌ':Added, #1: 1	غَسْلُ حَشَفَةِ
u'غَسَلَ خامس':Subject, #1: 1	غَسْلِ حَشَفَةِ
u'غَسَلَ خَامِسٌ':Subject, #1: 1	غَسَلَ الْخَامِسَةُ
u'غَسْلٌ خرقة':Added, #1: 1	غَسَلَ الْخَامِسَةُ
u'غَسْلٌ خِرْقَةٌ':Added, #1: 1	غَسْلِ الْخِرْقَةِ
u'غَسْلٌ خُفٌّ':Added, #1: 1	غَسْلِ الْخِرْقَةِ
u'غَسْلٌ خُفٌّ':Added, #1: 1	غَسْلِ الْخُفِّ
u'غَسْلٌ دَاخِلٌ':Added, #2: 2	غَسْلُ الْخُفِّ
u'غَسْلٌ دَاخِلٌ':Added, #1: 1	غَسْلُ دَاخِلِ
u'غَسَلَ دَمٌ':Predicate, #4: 4	غَسْلِ دَاخِلِ
u'غَسْلٌ دَمٌ':Added, #2: 2	غَسَلَ الدَّمَ
u'غَسْلٌ دَمٌ':Added, #11: 11	غَسْلِ الدَّمِ
u'غَسْلٌ دَمٌ':Added, #1: 1	غَسْلُ دَمِ
u'غَسْلٌ دَمٌ':Added, #1: 1	غَسْلِ دَمِ
u'غَسْلٌ ذِراعٌ':Added, #2: 2	غَسْلُ الدَّمِ
u'غَسْلٌ ذِراعٌ':Added, #2: 2	غَسْلِ الذِّرَاعِ
u'غَسْلٌ ذِراعٌ':Added, #3: 3	غَسْلُ الذِّرَاعَيْنِ
u'غَسْلٌ ذقن':Added, #3: 3	غَسْلِ الذِّرَاعَيْنِ
u'غَسْلٌ ذَقَنٌ':Added, #2: 2	غَسْلُ الذَّقَنِ
u'غَسْلٌ ذكر':Added, #2: 2	غَسْلُ الذَّقَنِ
u'غَسْلٌ ذَكَرٌ':Added, #3: 3	غَسْلِ الذَّكَرِ
u'غَسْلٌ ذِمِّيٌّ':Added, #3: 3	غَسْلِ الذَّكَرِ
u'غَسْلٌ ذَوائِبُ':Added, #1: 1	غَسْلُ الذِّمِّيَّةِ
u'غَسَلَ رَأْسٌ':Predicate, #1: 1	غَسْلُ الذَّوَائِبِ
u'غَسَلَ رَأْسٌ':Predicate, #1: 1	غَسَلَ الرَّأْسَ
u'غَسْلٌ رَأْسٌ':Added, #1: 1	غَسَلَ رَأْسَ
u'غَسْلٌ رَأْسٌ':Added, #2: 2	غَسْلَ رَأْسِهِ
u'غَسْلٌ رَأْسٌ':Added, #2: 2	غَسْلِ رَأْسِهِ
u'غَسْلٌ رَأْسٌ':Added, #3: 3	غَسْلِ الرَّأْسِ
u'غَسْلٌ رَأْسٌ':Added, #3: 3	غَسْلُ رَأْسِ
u'غَسْلٌ رَأْسٌ':Added, #8: 8	غَسْلُ الرَّأْسِ
u'غَسَلَ رِجْلٌ':Predicate, #9: 9	غَسْلُ رَأْسِهِ
u'غَسْلٌ رِجْلٌ':Added, #3: 3	غَسَلَ الرِّجْلَ
u'غَسْلٌ رِجْلٌ':Added, #10: 10	غَسْلُ الرِّجْلِ
u'غَسْلٌ رَجُلٌ':Added, #14: 14	غَسْلِ الرِّجْلِ
u'غَسْلٌ رَجُلٌ':Added, #1: 1	غَسْلُ الرَّجُلَيْنِ
u'غَسْلٌ رِجْلٌ':Added, #1: 1	غَسْلَ رَجُلٍ
u'غَسْلٌ رَجُلٌ':Added, #21: 21	غَسْلُ الرِّجْلَيْنِ
u'غَسْلٌ رِجْلٌ':Added, #2: 2	غَسْلِ الرَّجُلِ
u'غَسْلٌ رِجْلٌ':Added, #41: 41	غَسْلِ الرِّجْلَيْنِ
u'غَسْلٌ رِجْلٌ':Added, #6: 6	غَسْلِ رِجْلِهِ
u'غَسْلٌ رِجْلٌ':Added, #7: 7	غَسْلَ الرِّجْلِ
u'غَسَلَ رَدٌّ':Predicate, #9: 9	غَسْلَ الرِّجْلَيْنِ
u'غَسَلَ رَسُولٌ':Predicate, #1: 1	غَسَلَ رَدَّ
u'غَسَّلَ رَسُولٌ':Predicate, #1: 1	غَسَلَ رَسُولَ
u'غَسَلَ رَسُولٌ':Subject, #5: 5	غَسَّلَ رَسُولَ
u'غَسَّلَ رَسُولٌ':Subject, #1: 1	غَسَلَ رَسُولُ
u'غَسْلٌ رَسُولٌ':Added, #1: 1	غَسَّلَ رَسُولُ
u'غَسْلٌ رَطْبٌ':Added, #1: 1	غَسْلَ رَسُولِ
u'غَسْلٌ زائِدٌ':Added, #1: 1	غَسْلُ رَطْبِهِ
u'غَسْلٌ زائِدٌ':Added, #1: 1	غَسْلِ الزَّائِدِ
u'غَسْلٌ زَوْجَةٌ':Added, #1: 1	غَسْلُ الزَّائِدَةِ
u'غَسْلٌ زَيْتٌ':Added, #1: 1	غَسْلُ زَوْجَتِهِ
u'غَسَلَ زَيْدٌ':Subject, #1: 1	غَسْلِ الزَّيْتِ
u'غَسَلَ سادس':Subject, #1: 1	غَسَلَ زَيْدٌ
u'غَسَلَ سَادِسٌ':Subject, #1: 1	غَسَلَ السَّادِسَةُ
u'غَسَلَ سَائِرٌ':Predicate, #1: 1	غَسَلَ السَّادِسَةُ
u'غَسْلٌ سَائِرٌ':Added, #4: 4	غَسَلَ سَائِرَ
u'غَسْلٌ سَائِرٌ':Added, #1: 1	غَسْلَ سَائِرِ
u'غَسْلٌ سَائِرٌ':Added, #1: 1	غَسْلُ سَائِرِ
u'غَسَّلَ سَعْدٌ':Subject, #2: 2	غَسْلِ سَائِرِ
u'غَسْلٌ سِلْعَةٌ':Added, #1: 1	غَسَّلَ سَعْدٌ
u'غَسْلٌ سِواكٌ':Added, #1: 1	غَسْلُ سِلْعَةٍ
u'غَسْلٌ سُيوفٌ':Added, #1: 1	غَسْلِ السِّوَاكِ
u'غَسَلَ شَارِبٌ':Subject, #1: 1	غَسْلُ السّيُوفِ
u'غَسْلٌ شَعْرٌ':Added, #1: 1	غَسَلَ شَارِبُ
u'غَسْلٌ شَعْرٌ':Added, #1: 1	غَسْلِ الشَّعْرِ
u'غَسْلٌ شَعْرٌ':Added, #1: 1	غَسْلُ شَعْرٍ
u'غَسْلٌ شَعْرٌ':Added, #2: 2	غَسْلُ شَعْرِ
u'غَسْلٌ شِقٌّ':Added, #5: 5	غَسْلُ الشَّعْرِ
u'غَسْلٌ شَهِيدٌ':Added, #1: 1	غَسْلَ الشِّقِّ
u'غَسَلَ شَيْءٌ':Predicate, #1: 1	غَسْلِ الشَّهِيدِ
u'غَسْلٌ شَيْءٌ':Added, #1: 1	غَسَلَ الشَّيْءَ
u'غَسْلٌ شَيْءٌ':Added, #1: 1	غَسْلِ شَيْءٍ
u'غَسْلٌ صَائِغٌ':Added, #2: 2	غَسْلُ شَيْءٍ
u'غَسَّلَ صَبِيٌّ':Subject, #1: 1	غَسْلِ الصَّائِغِ
u'غَسْلٌ صَبِيٌّ':Added, #1: 1	غَسَّلَ الصَّبِيُّ
u'غَسَلَ صَحِيحٌ':Predicate, #1: 1	غَسْلُ الصَّبِيِّ
u'غَسْلٌ صَحِيحٌ':Added, #4: 4	غَسَلَ الصَّحِيحَ
u'غَسْلٌ صَحِيحٌ':Added, #1: 1	غَسْلِ صَحِيحِ
u'غَسْلٌ صَحِيحٌ':Added, #3: 3	غَسْلَ الصَّحِيحِ
u'غَسْلٌ صَحِيحٌ':Added, #3: 3	غَسْلُ الصَّحِيحِ
u'غَسْلٌ صِمَاخٌ':Added, #4: 4	غَسْلِ الصَّحِيحِ
u'غَسْلٌ طَاهِرٌ':Added, #1: 1	غَسْلِ الصِّمَاخِ
u'غَسْلٌ طَاهِرٌ':Added, #1: 1	غَسْلَ الطَّاهِرِ
u'غَسْلٌ طرف':Added, #1: 1	غَسْلُ الطَّاهِرِ
u'غَسْلٌ طَرَفٌ':Added, #1: 1	غَسْلُ طَرَفِ
u'غَسَلَ طِيبٌ':Predicate, #1: 1	غَسْلُ طَرَفِ
u'غَسْلٌ طِيبٌ':Added, #2: 2	غَسَلَ الطِّيبَ
u'غَسْلٌ طِيبٌ':Added, #1: 1	غَسْلُ طِيبٍ
u'غَسْلٌ ظاهِرٌ':Added, #3: 3	غَسْلُ الطِّيبِ
u'غَسْلٌ ظاهِرٌ':Added, #1: 1	غَسْلُ الظَّاهِرِ
u'غَسْلٌ ظاهِرٌ':Added, #1: 1	غَسْلِ الظَّاهِرِ
u'غَسْلٌ ظاهِرٌ':Added, #1: 1	غَسْلُ ظَاهِرِ
u'غَسْلٌ عَضُدٌ':Added, #1: 1	غَسْلُ ظَاهِرِهِ
u'غَسَلَ عُضْوٌ':Predicate, #1: 1	غَسْلُ الْعَضُدِ
u'غَسْلٌ عُضْوٌ':Added, #3: 3	غَسَلَ الْعُضْوَ
u'غَسْلٌ عُضْوٌ':Added, #1: 1	غَسْلُ عُضْوِ
u'غَسْلٌ عُضْوٌ':Added, #2: 2	غَسْلُ الْعُضْوِ
u'غَسْلٌ عُضْوٌ':Added, #2: 2	غَسْلِ عُضْوٍ
u'غَسْلٌ عُضْوٌ':Added, #5: 5	غَسْلَ عُضْوٍ
u'غَسْلٌ عين':Added, #7: 7	غَسْلِ الْعُضْوِ
u'غَسْلٌ عَيْنٌ':Added, #1: 1	غَسْلُ عَيْنِهِ
u'غَسْلٌ عَيْن':Added, #1: 1	غَسْلُ عَيْنِهِ
u'غَسَلَ غير':Predicate, #1: 1	غَسْلُ عَيْنِهِ
u'غَسَلَ غَيْرٌ':Predicate, #1: 1	غَسَلَ غَيْرَ
u'غَسْلٌ غير':Added, #1: 1	غَسَلَ غَيْرَ
u'غَسْلٌ غير':Added, #1: 1	غَسْلُ غَيْرِ
u'غَسْلٌ غَيْرٌ':Added, #1: 1	غَسْلِ غَيْرِ
u'غَسْلٌ غَيْرٌ':Added, #1: 1	غَسْلُ غَيْرِ
u'غَسْلٌ غير':Added, #1: 1	غَسْلِ غَيْرِ
u'غَسْلٌ غَيْرٌ':Added, #2: 2	غَسْلَ غَيْرِ
u'غَسْلٌ غير':Added, #2: 2	غَسْلَ غَيْرِ
u'غَسْلٌ غَيْرٌ':Added, #2: 2	غَسْلِ غَيْرِهِ
u'غَسَّلَ فَاطِمٌ':Predicate, #2: 2	غَسْلِ غَيْرِهِ
u'غَسْلٌ فَرْجٌ':Added, #4: 4	غَسَّلَ فَاطِمَةَ
u'غَسْلٌ فَرْجٌ':Added, #1: 1	غَسْلَ الْفَرْجِ
u'غَسْلٌ فَرْجٌ':Added, #2: 2	غَسْلُ الْفَرْجِ
u'غَسْلٌ فَرْجٌ':Added, #2: 2	غَسْلُ فَرْجٍ
u'غَسْلٌ فَرْجٌ':Added, #2: 2	غَسْلِ فَرْجٍ
u'غَسْلٌ فَرْجٌ':Added, #5: 5	غَسْلِ الْفَرْجِ
u'غَسْلٌ فَمٌ':Added, #6: 6	غَسْلُ فَرْجِهِ
u'غَسْلٌ فَمٌ':Added, #1: 1	غَسْلَ الْفَمِ
u'غَسْلٌ فَمٌ':Added, #1: 1	غَسْلَ فَمِهِ
u'غَسْلٌ فَمٌ':Added, #1: 1	غَسْلِ فَمِهِ
u'غَسْلٌ فَمٌ':Added, #3: 3	غَسْلُ فَمِهِ
u'غَسْلٌ فَمٌ':Added, #4: 4	غَسْلُ فَمٍ
u'غَسْلٌ فَمٌ':Added, #6: 6	غَسْلِ الْفَمِ
u'غَسَلَ قَالٌ':Predicate, #8: 8	غَسْلُ الْفَمِ
u'غَسْلٌ قُبُلٌ':Added, #1: 1	غَسَلَ قَالَ
u'غَسْلٌ قدم':Added, #1: 1	غَسْلَ قُبُلِهِ
u'غَسْلٌ قَدَمٌ':Added, #1: 1	غَسْلِ الْقَدَمِ
u'غَسْلٌ قَدَمٌ':Added, #1: 1	غَسْلِ الْقَدَمِ
u'غَسْلٌ قَدَمٌ':Added, #4: 4	غَسْلُ الْقَدَمَيْنِ
u'غَسْلٌ قَدَمٌ':Added, #5: 5	غَسْلَ الْقَدَمَيْنِ
u'غَسْلٌ قَلِيلٌ':Added, #7: 7	غَسْلِ الْقَدَمَيْنِ
u'غَسْلٌ كَثِيرٌ':Added, #1: 1	غَسْلُ قَلِيلِهِ
u'غَسْلٌ كَعْبٌ':Added, #1: 1	غَسْلُ الْكَثِيرِ
u'غَسْلٌ كَفٌّ':Added, #1: 1	غَسْلُ الْكَعْبَيْنِ
u'غَسْلٌ كَفٌّ':Added, #14: 14	غَسْلِ الْكَفَّيْنِ
u'غَسْلٌ كَفٌّ':Added, #1: 1	غَسْلَ الْكَفِّ
u'غَسْلٌ كَفٌّ':Added, #1: 1	غَسْلُ الْكَفِّ
u'غَسْلٌ كَفٌّ':Added, #1: 1	غَسْلِ الْكَفِّ
u'غَسْلٌ كَفٌّ':Added, #1: 1	غَسْلَ الْكَفَّيْنِ
u'غَسْلٌ لِحْيَةٌ':Added, #1: 1	غَسْلُ الْكَفَّيْنِ
u'غَسَلَ لمعة':Predicate, #4: 4	غَسْلُ اللِّحْيَةِ
u'غَسْلٌ لمعة':Added, #3: 3	غَسَلَ اللُّمْعَةَ
u'غَسْلٌ مَاءٌ':Added, #2: 2	غَسْلِ اللُّمْعَةِ
u'غَسْلٌ مَجْرُوحٌ':Added, #1: 1	غَسْلِ مَاءٍ
u'غَسْلٌ مَحَاجِمُ':Added, #1: 1	غَسْلُ الْمَجْرُوحَةِ
u'غَسْلٌ مَحَاجِمُ':Added, #1: 1	غَسْلُ الْمَحَاجِمِ
u'غَسَلَ مُحْدِثٌ':Subject, #2: 2	غَسْلِ مَحَاجِمِهِ
u'غَسَلَ مُحْرِمٌ':Subject, #5: 5	غَسَلَ الْمُحْدِثُ
u'غَسْلٌ مُحْرِمٌ':Added, #1: 1	غَسَلَ الْمُحْرِمُ
u'غَسْلٌ مَحَلٌّ':Added, #1: 1	غَسْلِ الْمُحْرِمِ
u'غَسْلٌ مَحَلٌّ':Added, #1: 1	غَسْلِ مَحَلِّ
u'غَسْلٌ مَحَلٌّ':Added, #2: 2	غَسْلُ الْمَحَلِّ
u'غَسْلٌ مَحَلٌّ':Added, #5: 5	غَسْلُ مَحَلِّ
u'غَسْلٌ مَخْرَجٌ':Added, #5: 5	غَسْلِ مَحَلِّهِ
u'غَسْلٌ مَخْرَجٌ':Added, #1: 1	غَسْلِ مَخْرَجِهِ
u'غَسْلٌ مُدَبَّرٌ':Added, #3: 3	غَسْلِ مَخْرَجِ
u'غَسْلٌ مَدْبُوغٌ':Added, #1: 1	غَسْلُ مُدَبَّرَتِهِ
u'غَسْلٌ مذاكير':Added, #2: 2	غَسْلُ الْمَدْبُوغِ
u'غَسَلَ مرٌّ':Predicate, #1: 1	غَسْلِ مَذَاكِيرِهِ
u'غَسَلَ مَرَافِقُ':Predicate, #1: 1	غَسَلَ مَرَّةً
u'غَسْلٌ مَرَافِقُ':Added, #1: 1	غَسَلَ الْمَرَافِقَ
u'غَسْلٌ مَرَافِقُ':Added, #1: 1	غَسْلُ الْمَرَافِقِ
u'غَسْلٌ مِرْفَقٌ':Added, #6: 6	غَسْلِ الْمَرَافِقِ
u'غَسْلٌ مِرْفَقٌ':Added, #2: 2	غَسْلُ الْمِرْفَقِ
u'غَسْلٌ مِرْفَقٌ':Added, #4: 4	غَسْلِ الْمِرْفَقَيْنِ
u'غَسْلٌ مُسْتَرْسِلٌ':Added, #5: 5	غَسْلِ الْمِرْفَقِ
u'غَسْلٌ مُسْلِمٌ':Added, #1: 1	غَسْلُ الْمُسْتَرْسِلِ
u'غَسَلَ مَعِدَةٌ':Predicate, #1: 1	غَسْلِ الْمُسْلِمِ
u'غَسْلٌ مُكَاتَبَةٌ':Added, #1: 1	غَسَلَ الْمَعِدَةَ
u'غَسْلٌ مَكَانٌ':Added, #1: 1	غَسْلُ مُكَاتَبَتِهِ
u'غَسْلٌ ملاء':Added, #1: 1	غَسْلُ مَكَانِ
u'غَسْلٌ مُلاَءٌ':Added, #1: 1	غَسْلَ الْمُلَاءِ
u'غَسْلٌ مُلْتَحِمٌ':Added, #1: 1	غَسْلَ الْمُلَاءِ
u'غَسْلٌ مَنِيٌّ':Added, #1: 1	غَسْلُ الْمُلْتَحِمِ
u'غَسْلٌ مَنِيٌّ':Added, #1: 1	غَسْلُ الْمَنِيِّ
u'غَسَلَ مَوَاضِعُ':Predicate, #1: 1	غَسْلِ الْمَنِيِّ
u'غَسْلٌ مَوَاضِعُ':Added, #2: 2	غَسَلَ مَوَاضِعَ
u'غَسَلَ مَوْضِعٌ':Predicate, #1: 1	غَسْلَ مَوَاضِعِ
u'غَسَلَ مَوْضِعٌ':Predicate, #2: 2	غَسَلَ مَوْضِعَ
u'غَسْلٌ مَوْضِعٌ':Added, #3: 3	غَسَلَ الْمَوْضِعَ
u'غَسْلٌ مَوْضِعٌ':Added, #12: 12	غَسْلُ مَوْضِعِ
u'غَسْلٌ مَوْضِعٌ':Added, #1: 1	غَسْلُ الْمَوْضِعِ
u'غَسَّلَ نَبِيٌّ':Predicate, #1: 1	غَسْلِ مَوْضِعٍ
u'غَسْلٌ نَبِيٌّ':Added, #3: 3	غَسَّلَ النَّبِيَّ
u'غَسَلَ نَجَاسَةٌ':Predicate, #1: 1	غَسْلِ النَّبِيِّ
u'غَسْلٌ نَجَاسَةٌ':Added, #6: 6	غَسَلَ النَّجَاسَةَ
u'غَسْلٌ نَجَاسَةٌ':Added, #11: 11	غَسْلِ النَّجَاسَةِ
u'غَسْلٌ نَجَاسَةٌ':Added, #1: 1	غَسْلَ النَّجَاسَةِ
u'غَسْلٌ نَجَاسَةٌ':Added, #1: 1	غَسْلُ نَجَاسَةِ
u'غَسْلٌ نَجَاسَةٌ':Added, #1: 1	غَسْلِ نَجَاسَةٍ
u'غَسْلٌ نَجَاسَةٌ':Added, #2: 2	غَسْلُ نَجَاسَتِهِ
u'غَسْلٌ نَجَاسَةٌ':Added, #3: 3	غَسْلِ نَجَاسَةِ
u'غَسَلَ نَجَسٌ':Predicate, #9: 9	غَسْلُ النَّجَاسَةِ
u'غَسَلَ نَجِسٌ':Predicate, #1: 1	غَسَلَ النَّجَسَ
u'غَسْلٌ نَجِسٌ':Added, #1: 1	غَسَلَ النَّجِسَ
u'غَسْلٌ نَحْوٌ':Added, #1: 1	غَسْلِ نَجِسِ
u'غَسْلٌ نَزَع':Added, #1: 1	غَسْلِ نَحْوِ
u'غَسْلٌ وَاجِبٌ':Added, #1: 1	غَسْلِ النَّزَعَتَيْنِ
u'غَسْلٌ واحد':Added, #1: 1	غَسْلُ الْوَاجِبِ
u'غَسْلٌ وَاحِدٌ':Added, #1: 1	غَسْلُ وَاحِدَةٍ
u'غَسْلٌ وَتَدٌ':Added, #1: 1	غَسْلُ وَاحِدَةٍ
u'غَسْلٌ وَتَدٌ':Added, #1: 1	غَسْلُ الْوَتَدِ
u'غَسَلَ وَجَبٌ':Predicate, #1: 1	غَسْلُ الْوَتَدَيْنِ
u'غَسَلَ وَجْهٌ':Predicate, #1: 1	غَسَلَ وَجَبَ
u'غَسَلَ وَجْهٌ':Predicate, #1: 1	غَسَلَ الْوَجْهَ
u'غَسَلَ وَجْهٌ':Subject, #1: 1	غَسَلَ وَجْهَ
u'غَسْلٌ وَجْهٌ':Added, #1: 1	غَسَلَ وَجْهٌ
u'غَسْلٌ وَجْهٌ':Added, #13: 13	غَسْلِ وَجْهِهِ
u'غَسْلٌ وَجْهٌ':Added, #14: 14	غَسْلُ الْوَجْهِ
u'غَسْلٌ وَجْهٌ':Added, #1: 1	غَسْل الْوَجْهِ
u'غَسْلٌ وَجْهٌ':Added, #1: 1	غَسْلَ وَجْهِهِ
u'غَسْلٌ وَجْهٌ':Added, #1: 1	غَسْلُ وَجْهِهِ
u'غَسْلٌ وَجْهٌ':Added, #46: 46	غَسْلِ الْوَجْهِ
u'غَسْلٌ وُضُوءٌ':Added, #6: 6	غَسْلَ الْوَجْهِ
u'غَسْلٌ وُضُوءٌ':Added, #1: 1	غَسْلَ الْوُضُوءِ
u'غَسْلٌ وُضُوءٌ':Added, #1: 1	غَسْلُ الْوُضُوءِ
u'غَسْلٌ وُلُوغ':Added, #1: 1	غَسْلِ الْوُضُوءِ
u'غَسَلَ يَدٌ':Predicate, #1: 1	غَسْلِ الْوُلُوغِ
u'غَسْلٌ يَدٌ':Added, #2: 2	غَسَلَ الْيَدَ
u'غَسْلٌ يَدٌ':Added, #12: 12	غَسْلَ الْيَدِ
u'غَسْلٌ يَدٌ':Added, #16: 16	غَسْلِ الْيَدِ
u'غَسْلٌ يَدٌ':Added, #17: 17	غَسْلُ الْيَدِ
u'غَسْلٌ يَدٌ':Added, #2: 2	غَسْلُ يَدٍ
u'غَسْلٌ يَدٌ':Added, #31: 31	غَسْلُ الْيَدَيْنِ
u'غَسْلٌ يَدٌ':Added, #32: 32	غَسْلِ الْيَدَيْنِ
u'غَسْلٌ يَدٌ':Added, #3: 3	غَسْلِ يَدِهِ
u'غَسْلٌ يَدٌ':Added, #7: 7	غَسْلَ الْيَدَيْنِ
u'غَسَّلَ يَوْمٌ':Predicate, #7: 7	غَسْلُ يَدِهِ
u'غَشَّ عَرَبٌ':Predicate, #4: 4	غَسَّلَ يَوْمَ
u'غَشَّ مُسْلِمٌ':Predicate, #1: 1	غَشَّ الْعَرَبَ
u'غَشِيَ نِساءٌ':Predicate, #4: 4	غَشَّ الْمُسْلِمِينَ
u'غَصَبَ أبْنيَةٌ':Predicate, #1: 1	غَشِيَ النِّسَاءَ
u'غَصَبَ أرْضٌ':Predicate, #2: 2	غَصَبَ الْأَبْنِيَةَ
u'غَصَبَ أرْضٌ':Predicate, #2: 2	غَصَبَ أَرْضَ
u'غَصْبٌ أرْضٌ':Added, #4: 4	غَصَبَ الْأَرْضَ
u'غَصْبٌ أرْضٌ':Added, #1: 1	غَصْبِ أَرْضٍ
u'غَصْبٌ اِسْتيلاءٌ':Added, #2: 2	غَصْبِ الْأَرْضِ
u'غَصَبَ ألف':Predicate, #1: 1	غَصْبُ اسْتِيلَاءٍ
u'غَصَبَ ألْفٌ':Predicate, #1: 1	غَصَبَ الْأَلْفَ
u'غَصَبَ أَلْفٌ':Predicate, #1: 1	غَصَبَ الْأَلْفَ
u'غَصَبَ ألف':Predicate, #1: 1	غَصَبَ الْأَلْفَ
u'غَصَبَ ألْفٌ':Predicate, #4: 4	غَصَبَ أَلْفَ
u'غَصَبَ أَلْفٌ':Predicate, #4: 4	غَصَبَ أَلْفَ
u'غَصَبَ أَلْوَاحٌ':Predicate, #4: 4	غَصَبَ أَلْفَ
u'غَصَبَ أُمٌّ':Predicate, #1: 1	غَصَبَ الْأَلْوَاحَ
u'غَصَبَ اِمْرَأَةٌ':Predicate, #8: 8	غَصَبَ أُمَّ
u'غَصْبٌ أَمْوَالٌ':Added, #1: 1	غَصَبَ امْرَأَةَ
u'غَصَبَ إِنْسانٌ':Subject, #1: 1	غَصْبِ الْأَمْوَالِ
u'غَصَبَ بَائِعٌ':Subject, #3: 3	غَصَبَ إنْسَانٌ
u'غَصْبٌ بَائِعٌ':Added, #1: 1	غَصَبَ الْبَائِعُ
u'غَصَبَ بَذْرٌ':Predicate, #1: 1	غَصْبَ الْبَائِعِ
u'غَصْبٌ بَزّاز':Added, #1: 1	غَصَبَ بَذْرَ
u'غَصْبٌ بَزّازَة':Added, #6: 6	غَصْبِ الْبَزَّازِيَّةِ
u'غَصَبَ بِطِّيخٌ':Predicate, #6: 6	غَصْبِ الْبَزَّازِيَّةِ
u'غَصَبَ بَقَرٌ':Predicate, #1: 1	غَصَبَ بِطِّيخَةً
u'غَصَبَ ثَوْبٌ':Predicate, #1: 1	غَصَبَ بَقَرَةً
u'غَصْبٌ ثَوْبٌ':Added, #1: 1	غَصَبَ ثَوْبَ
u'غَصَبَ جَارِحٌ':Predicate, #1: 1	غَصْبُ الثَّوْبِ
u'غَصَبَ جَارِي':Predicate, #1: 1	غَصَبَ جَارِحَةً
u'غَصَبَ جَارِي':Predicate, #1: 1	غَصَبَ جَارِيَةَ
u'غَصَبَ جَارِي':Predicate, #32: 32	غَصَبَ جَارِيَةً
u'غَصْبٌ جَارِي':Added, #3: 3	غَصَبَ الْجَارِيَةَ
u'غَصَبَ جَارِيَةٌ':Predicate, #1: 1	غَصْبُ الْجَارِيَةِ
u'غَصَبَ جَارِيَةٌ':Predicate, #1: 1	غَصَبَ جَارِيَةَ
u'غَصْبٌ جَارِيَةٌ':Added, #3: 3	غَصَبَ الْجَارِيَةَ
u'غَصْبٌ جَديدٌ':Added, #1: 1	غَصْبُ الْجَارِيَةِ
u'غَصْبٌ جَدِيدٌ':Added, #1: 1	غَصْبِ الْجَدِيدِ
u'غَصَبَ جلد':Predicate, #1: 1	غَصْبِ الْجَدِيدِ
u'غَصَبَ جِلْدٌ':Predicate, #12: 12	غَصَبَ جِلْدَ
u'غَصَبَ جلد':Predicate, #12: 12	غَصَبَ جِلْدَ
u'غَصَبَ جِلْدٌ':Predicate, #1: 1	غَصَبَ الْجِلْدَ
u'غَصَبَ جَمَاعَةٌ':Subject, #1: 1	غَصَبَ الْجِلْدَ
u'غَصَبَ جَمِيع':Predicate, #2: 2	غَصَبَ جَمَاعَةٌ
u'غَصَبَ جِنْسٌ':Predicate, #1: 1	غَصَبَ الْجَمِيعَ
u'غَصْبٌ جَوَابٌ':Added, #2: 2	غَصَبَ جِنْسَ
u'غَصَبَ جَوْهَرٌ':Predicate, #1: 1	غَصْبُ جَوَابٍ
u'غَصْبٌ جياد':Added, #1: 1	غَصَبَ جَوْهَرَةً
u'غَصْبٌ جِيَادٌ':Added, #1: 1	غَصْبِ الْجِيَادِ
u'غَصْبٌ حَبٌّ':Added, #1: 1	غَصْبِ الْجِيَادِ
u'غَصْبٌ حَبَّةٌ':Added, #6: 6	غَصْبَ الْحَبَّةِ
u'غَصَبَ حُرٌّ':Predicate, #6: 6	غَصْبَ الْحَبَّةِ
u'غَصَبَ حُرٌّ':Predicate, #1: 1	غَصَبَ الْحُرَّةَ
u'غَصْبٌ حُرٌّ':Added, #2: 2	غَصَبَ حُرَّةً
u'غَصْبٌ حُرٌّ':Added, #1: 1	غَصْبَ الْحُرِّ
u'غَصْبٌ حَقٌّ':Added, #1: 1	غَصْبِ الْحُرِّ
u'غَصَبَ حَلالٌ':Subject, #1: 1	غَصْبِ حَقِّهِ
u'غَصَبَ حِمَارٌ':Predicate, #1: 1	غَصَبَ حَلَالٌ
u'غَصْبٌ حِنْطَةٌ':Added, #1: 1	غَصَبَ الْحِمَارَ
u'غَصْبٌ خان':Added, #1: 1	غَصْبَ حِنْطَةٍ
u'غَصْبٌ خانَة':Added, #1: 1	غَصْبِ الْخَانِيَّةِ
u'غَصَبَ خَصِيٌّ':Predicate, #1: 1	غَصْبِ الْخَانِيَّةِ
u'غَصَبَ خَمْرٌ':Predicate, #1: 1	غَصَبَ الْخَصِيَّ
u'غَصَبَ خِنْزِيرٌ':Predicate, #3: 3	غَصَبَ خَمْرَ
u'غَصَبَ دَارٌ':Predicate, #2: 2	غَصَبَ خِنْزِيرَ
u'غَصْبٌ دَارٌ':Added, #1: 1	غَصَبَ الدَّارَ
u'غَصْبٌ دَارٌ':Added, #1: 1	غَصْبَ الدَّارِ
u'غَصْبٌ دَارٌ':Added, #1: 1	غَصْبِ الدَّارِ
u'غَصَبَ دَجاج':Predicate, #1: 1	غَصْبَ دَارٍ
u'غَصَبَ دَرَاهِمُ':Predicate, #1: 1	غَصَبَ دَجَاجَةً
u'غَصَبَ دَنانيرُ':Predicate, #11: 11	غَصَبَ دَرَاهِمَ
u'غَصَبَ دُودٌ':Predicate, #1: 1	غَصَبَ دَنَانِيرَ
u'غَصْبٌ دُورٌ':Added, #1: 1	غَصَبَ دُودَ
u'غَصَبَ دِينارٌ':Predicate, #1: 1	غَصْبِ الدُّورِ
u'غَصَبَ ذِمِّيٌّ':Subject, #1: 1	غَصَبَ الدِّينَارَ
u'غَصَبَ ذِمِّيٌّ':Subject, #1: 1	غَصَبَ الذِّمِّيُّ
u'غَصَبَ رَبُّ':Subject, #3: 3	غَصَبَ ذِمِّيٌّ
u'غَصَبَ رَجُلٌ':Subject, #3: 3	غَصَبَ رَبُّ
u'غَصَبَ رَجُلٌ':Subject, #17: 17	غَصَبَ رَجُلٌ
u'غَصَبَ رَقَبَةٌ':Predicate, #5: 5	غَصَبَ الرَّجُلُ
u'غَصَبَ رَهْنٌ':Predicate, #1: 1	غَصَبَ الرَّقَبَةَ
u'غَصَبَ زَوْجَةٌ':Predicate, #1: 1	غَصَبَ الرَّهْنَ
u'غَصَبَ ساج':Predicate, #1: 1	غَصَبَ زَوْجَةَ
u'غَصْبٌ سَائِمَةٌ':Added, #7: 7	غَصَبَ سَاجَةً
u'غَصَبَ سِتَارَةٌ':Predicate, #2: 2	غَصْبِ السَّائِمَةِ
u'غَصَبَ سُلَّمٌ':Predicate, #1: 1	غَصَبَ سِتَارَةَ
u'غَصَبَ شَابٌّ':Predicate, #1: 1	غَصَبَ سُلَّمَ
u'غَصَبَ شَاةٌ':Predicate, #1: 1	غَصَبَ شَابَّةً
u'غَصْبٌ شَائِعٌ':Added, #1: 1	غَصَبَ شَاةَ
u'غَصَبَ شَرِيكٌ':Subject, #1: 1	غَصْبُ الشَّائِعِ
u'غَصَبَ شَيْءٌ':Predicate, #1: 1	غَصَبَ شَرِيكُ
u'غَصْبٌ شَيْءٌ':Added, #1: 1	غَصَبَ الشَّيْءَ
u'غَصْبٌ شَيْءٌ':Added, #1: 1	غَصْبَ الشَّيْءِ
u'غَصْبٌ شَيْءٌ':Added, #1: 1	غَصْبُ الشَّيْءِ
u'غَصَبَ صَاحِبٌ':Subject, #1: 1	غَصْبِ شَيْءٍ
u'غَصْبٌ صَبِيٌّ':Added, #2: 2	غَصَبَ صَاحِبُ
u'غَصْبٌ ضَعِيفٌ':Added, #1: 1	غَصْبِ الصَّبِيِّ
u'غَصْبٌ ضَيْعَةٌ':Added, #1: 1	غَصْبِ الضَّعِيفِ
u'غَصْبٌ طعام':Added, #1: 1	غَصْبَ ضَيْعَتِهِ
u'غَصْبٌ طَعَامٌ':Added, #1: 1	غَصْبُ طَعَامِ
u'غَصَبَ عَبْدٌ':Predicate, #1: 1	غَصْبُ طَعَامِ
u'غَصَبَ عَبْدٌ':Predicate, #1: 1	غَصَبَ عَبْدَ
u'غَصَبَ عَبْدٌ':Subject, #2: 2	غَصَبَ الْعَبْدَ
u'غَصَبَ عَبْدٌ':Subject, #1: 1	غَصَبَ عَبْدٌ
u'غَصْبٌ عَبْدٌ':Added, #3: 3	غَصَبَ الْعَبْدُ
u'غَصْبٌ عَبْدٌ':Added, #1: 1	غَصْبَ الْعَبْدِ
u'غَصْبٌ عُدَّةٌ':Added, #4: 4	غَصْبِ الْعَبْدِ
u'غَصَبَ عَشْرٌ':Predicate, #1: 1	غَصْبِ الْعُدَّةِ
u'غَصَبَ عُصْفُر':Predicate, #1: 1	غَصَبَ عَشْرَةَ
u'غَصْبٌ عَقَارٌ':Added, #2: 2	غَصَبَ الْعُصْفُرَ
u'غَصْبٌ عَقَارٌ':Added, #1: 1	غَصْبِ عَقَارِ
u'غَصْبٌ عَقَارٌ':Added, #2: 2	غَصْبِ عَقَارٍ
u'غَصْبٌ عَقَارٌ':Added, #3: 3	غَصْبَ الْعَقَارِ
u'غَصْبٌ عَلَفٌ':Added, #6: 6	غَصْبِ الْعَقَارِ
u'غَصَبَ عين':Predicate, #2: 2	غَصْبُ الْعَلَفِ
u'غَصَبَ عَيْنٌ':Predicate, #1: 1	غَصَبَ الْعَيْنَ
u'غَصَبَ عَيْن':Predicate, #1: 1	غَصَبَ الْعَيْنَ
u'غَصْبٌ عين':Added, #1: 1	غَصَبَ الْعَيْنَ
u'غَصْبٌ عَيْنٌ':Added, #1: 1	غَصْبُ الْعَيْنِ
u'غَصْبٌ عَيْن':Added, #1: 1	غَصْبُ الْعَيْنِ
u'غَصْبٌ غَاصِبٌ':Added, #1: 1	غَصْبُ الْعَيْنِ
u'غَصَبَ غير':Subject, #1: 1	غَصْبِ الْغَاصِبِ
u'غَصَبَ غَيْرٌ':Subject, #1: 1	غَصَبَ غَيْرُ
u'غَصْبٌ غير':Added, #1: 1	غَصَبَ غَيْرُ
u'غَصْبٌ غير':Added, #1: 1	غَصْبُ غَيْرِهِ
u'غَصْبٌ غَيْرٌ':Added, #1: 1	غَصْبِ غَيْرِهِ
u'غَصْبٌ غَيْرٌ':Added, #1: 1	غَصْبُ غَيْرِهِ
u'غَصْبٌ غير':Added, #1: 1	غَصْبِ غَيْرِهِ
u'غَصْبٌ غَيْرٌ':Added, #2: 2	غَصْبِ غَيْرِ
u'غَصْبٌ فلان':Added, #2: 2	غَصْبِ غَيْرِ
u'غَصْبٌ فلان':Added, #1: 1	غَصْبِ الْخَانِيَّةِ
u'غَصَبَ قلب':Predicate, #6: 6	غَصْبِ الْبَزَّازِيَّةِ
u'غَصَبَ قلب':Predicate, #1: 1	غَصَبَ قَلْبَ
u'غَصَبَ قَلْبٌ':Predicate, #1: 1	غَصَبَ قُلْبَ
u'غَصَبَ قَلْب':Predicate, #1: 1	غَصَبَ قَلْبَ
u'غَصَبَ قِنٌّ':Predicate, #1: 1	غَصَبَ قَلْبَ
u'غَصْبٌ قِنٌّ':Added, #1: 1	غَصَبَ الْقِنَّ
u'غَصَبَ قَوْمٌ':Subject, #1: 1	غَصْبُ الْقِنِّ
u'غَصْبٌ كَافِرٌ':Added, #1: 1	غَصَبَ قَوْمٌ
u'غَصْبٌ كَلْبٌ':Added, #1: 1	غَصْبُ الْكَافِرِ
u'غَصَبَ لَحْمٌ':Predicate, #1: 1	غَصْبِ الْكَلْبِ
u'غَصَبَ مَالٌ':Predicate, #1: 1	غَصَبَ اللَّحْمَ
u'غَصَبَ مَالٌ':Predicate, #1: 1	غَصَبَ الْمَالَ
u'غَصْبٌ مَالٌ':Added, #4: 4	غَصَبَ مَالَ
u'غَصْبٌ مَالٌ':Added, #1: 1	غَصْبِ الْمَالِ
u'غَصْبٌ مَالٌ':Added, #1: 1	غَصْبِ مَالٍ
u'غَصَبَ مَبِيعٌ':Predicate, #2: 2	غَصْبَ مَالٍ
u'غَصَبَ مَتَاعٌ':Predicate, #1: 1	غَصَبَ الْمَبِيعَ
u'غَصْبٌ مَتَاعٌ':Added, #1: 1	غَصَبَ الْمَتَاعَ
u'غَصْبٌ مِثْلِيٌّ':Added, #1: 1	غَصْبَ الْمَتَاعِ
u'غَصَبَ مَحْجُورٌ':Subject, #1: 1	غَصْبِ الْمِثْلِيَّاتِ
u'غَصَبَ مُدَبَّرٌ':Predicate, #1: 1	غَصَبَ مَحْجُورٌ
u'غَصَبَ مُدَبَّرٌ':Predicate, #1: 1	غَصَبَ مُدَبَّرَةً
u'غَصَبَ مُدَبَّرٌ':Subject, #3: 3	غَصَبَ مُدَبَّرَ
u'غَصْبٌ مُدَبَّرٌ':Added, #1: 1	غَصَبَ الْمُدَبَّرُ
u'غَصْبٌ مَرْهُونٌ':Added, #1: 1	غَصْبِ الْمُدَبَّرِ
u'غَصَبَ مُسْلِمٌ':Predicate, #1: 1	غَصْبِ الْمَرْهُونِ
u'غَصَبَ مُسْلِمٌ':Predicate, #1: 1	غَصَبَ الْمُسْلِمَةَ
u'غَصَبَ مُسْلِمٌ':Subject, #1: 1	غَصَبَ مُسْلِمَةً
u'غَصَبَ مُسْلِمٌ':Subject, #2: 2	غَصَبَ الْمُسْلِمُ
u'غَصْبٌ مُسْلِمٌ':Added, #4: 4	غَصَبَ مُسْلِمٌ
u'غَصْبٌ مُشاعٌ':Added, #1: 1	غَصْبُ الْمُسْلِمِ
u'غَصَبَ مَعْلُوفٌ':Predicate, #1: 1	غَصْبِ الْمُشَاعِ
u'غَصْبٌ مَنَاصِبُ':Added, #1: 1	غَصَبَ مَعْلُوفَةً
u'غَصْبٌ مَنَافِعُ':Added, #1: 1	غَصْبَ الْمَنَاصِبِ
u'غَصْبٌ مَنَافِعُ':Added, #1: 1	غَصْبُ الْمَنَافِعِ
u'غَصْبٌ مَنْصِبٌ':Added, #1: 1	غَصْبِ مَنَافِعِ
u'غَصْبٌ مَنْفَعَةٌ':Added, #1: 1	غَصْبَ الْمَنْصِبِ
u'غَصْبٌ مَنْقُولٌ':Added, #1: 1	غَصْبِ الْمَنْفَعَةِ
u'غَصْبٌ مُنْيَةٌ':Added, #1: 1	غَصْبُ الْمَنْقُولِ
u'غَصْبٌ مُوجِبٌ':Added, #1: 1	غَصْبِ مُنْيَةِ
u'غَصْبٌ مُؤَجِّرٌ':Added, #1: 1	غَصْبٍ مُوجِبٍ
u'غَصَبَ نَجَّارٌ':Subject, #1: 1	غَصْبَ الْمُؤَجِّرِ
u'غَصْبٌ نَحْوٌ':Added, #1: 1	غَصَبَ النَّجَّارُ
u'غَصْبٌ نصاب':Added, #1: 1	غَصْبُ نَحْوِ
u'غَصْبٌ نِصَابٌ':Added, #2: 2	غَصْبُ النِّصَابِ
u'غَصَبَ نَصْرَانِيٌّ':Subject, #2: 2	غَصْبُ النِّصَابِ
u'غَصْبٌ نِصْفٌ':Added, #1: 1	غَصَبَ نَصْرَانِيٌّ
u'غَصْبٌ نِصْفٌ':Added, #1: 1	غَصْبُ نِصْفِ
u'غَصْبٌ نِصْفٌ':Added, #2: 2	غَصْبِ نِصْفِ
u'غَصْبٌ نِصْفٌ':Added, #2: 2	غَصْبُ نِصْفِهِ
u'غَصَبَ نقرة':Predicate, #3: 3	غَصْبَ نِصْفِ
u'غَصْبٌ نَوَازِلُ':Added, #1: 1	غَصَبَ نَقْرَةَ
u'غَصَبَ وَصِيٌّ':Subject, #1: 1	غَصْبِ النَّوَازِلِ
u'غَصَبَ وَقْفٌ':Predicate, #1: 1	غَصَبَ الْوَصِيُّ
u'غَصْبٌ وَقْفٌ':Added, #1: 1	غَصَبَ الْوَقْفَ
u'غَصَّ مَجْلِسٌ':Subject, #2: 2	غَصْبِ الْوَقْفِ
u'غَضَارَةٌ أَيْكَةٌ':Added, #1: 1	غَصَّ الْمَجْلِسُ
u'غَضِبَ أَشَدُّ':Predicate, #1: 1	غَضَارَةُ أَيْكَةٍ
u'غَضِبَ أعْمَش':Subject, #1: 1	غَضِبَ أَشَدَّ
u'غضب اللهُ':Added, #1: 1	غَضِبَ الْأَعْمَشُ
u'غَضَبٌ اللهُ':Added, #1: 1	غَضَبِ اللهِ
u'غضب أُمٌّ':Added, #1: 1	غَضَبِ اللهِ
u'غَضَبٌ أُمٌّ':Added, #1: 1	غَضَبِ الْأُمِّ
u'غضب تُبَّانٌ':Added, #1: 1	غَضَبِ الْأُمِّ
u'غَضَبٌ تُبَّانٌ':Added, #1: 1	غَضَبِ تُبّانٍ
u'غَضِبَ تَلَوُّنٌ':Predicate, #1: 1	غَضَبِ تُبّانٍ
u'غَضِبَ جَالِسٌ':Subject, #1: 1	غَضِبَ تَلَوّنَ
u'غضب جَاهِلٌ':Added, #1: 1	غَضِبَ الْجَالِسُ
u'غَضَبٌ جَاهِلٌ':Added, #1: 1	غَضَبُ الْجَاهِلِ
u'غضب رَبُّ':Added, #1: 1	غَضَبُ الْجَاهِلِ
u'غَضَبٌ رَبُّ':Added, #1: 1	غَضَبِ رَبِّ
u'غضب رَبُّ':Added, #1: 1	غَضَبِ رَبِّ
u'غَضَبٌ رَبُّ':Added, #8: 8	غَضَبَ الرَّبِّ
u'غَضِبَ رَجُلٌ':Subject, #8: 8	غَضَبَ الرَّبِّ
u'غَضِبَ رَسُولٌ':Subject, #1: 1	غَضِبَ رَجُلٌ
u'غضب رَسُولٌ':Added, #2: 2	غَضِبَ رَسُولُ
u'غَضَبٌ رَسُولٌ':Added, #1: 1	غَضَبُ الرّسُولِ
u'غضب زَوْجٌ':Added, #1: 1	غَضَبُ الرّسُولِ
u'غَضَبٌ زَوْجٌ':Added, #1: 1	غَضَبِ الزَّوْجِ
u'غضب سَعْدٌ':Added, #1: 1	غَضَبِ الزَّوْجِ
u'غَضَبٌ سَعْدٌ':Added, #1: 1	غَضَبُ سَعْدٍ
u'غَضِبَ شَيْطَانٌ':Subject, #1: 1	غَضَبُ سَعْدٍ
u'غَضَّ بَصَرٌ':Predicate, #1: 1	غَضِبَ الشَّيْطَانُ
u'غَضِبَ عُمَرٌ':Predicate, #1: 1	غَضَّ الْبَصَرَ
u'غَضِبَ عند':Predicate, #1: 1	أَغْضَبَ عُمَرَ
u'غَضِبَ قَالٌ':Predicate, #1: 1	غَضِبَ عِنْدَ
u'غَضِبَ قَائِمٌ':Subject, #1: 1	غَضِبَ قَالَ
u'غضب مُجَادِلٌ':Added, #1: 1	غَضِبَ الْقَائِمُ
u'غَضَبٌ مُجَادِلٌ':Added, #2: 2	غَضَبِ الْمُجَادِلِ
u'غضب مَلِكٌ':Added, #2: 2	غَضَبِ الْمُجَادِلِ
u'غَضَبٌ مَلِكٌ':Added, #1: 1	غَضَبُ الْمَلِكِ
u'غضب نَاسٌ':Added, #1: 1	غَضَبُ الْمَلِكِ
u'غَضَبٌ نَاسٌ':Added, #1: 1	غَضَبِ النَّاسِ
u'غَضِبَ نَبِيٌّ':Subject, #1: 1	غَضَبِ النَّاسِ
u'غضب نَبِيٌّ':Added, #1: 1	غَضِبَ النَّبِيُّ
u'غَضَبٌ نَبِيٌّ':Added, #1: 1	غَضَبُ النَّبِيِّ
u'غضب وَلِيٌّ':Added, #1: 1	غَضَبُ النَّبِيِّ
u'غَضَبٌ وَلِيٌّ':Added, #1: 1	غَضَبُ وَلِيِّ
u'غَضِبَ يَوْمٌ':Predicate, #1: 1	غَضَبُ وَلِيِّ
u'غَضْنٌ كَتِفٌ':Added, #5: 5	غَضِبَ الْيَوْمَ
u'غَطَّى أَكْثَرُ':Predicate, #1: 1	غَضْنِ كَتِفِهِ
u'غَطَّى إِنْسانٌ':Subject, #1: 1	غَطَّى أَكْثَرَ
u'غَطَّى بَعْضٌ':Predicate, #1: 1	غَطَّى إنْسَانٌ
u'غَطَّى رُبُعٌ':Predicate, #3: 3	غَطَّى بَعْضَ
u'غَطَّى رُبْعٌ':Predicate, #2: 2	غَطَّى رُبُعَ
u'غَطَّى مُحْرِمٌ':Subject, #2: 2	غَطَّى رُبْعَ
u'غَطَّى نعمة':Predicate, #2: 2	غَطَّى الْمُحْرِمُ
u'غَطَّى نِعْمَةٌ':Predicate, #1: 1	غَطَّى نِعْمَةَ
u'غُفْرَانٌ تَبَع':Added, #1: 1	غَطَّى نِعْمَةَ
u'غُفْرَانٌ حُرْمَةٌ':Added, #1: 1	غُفْرَانِ التَّبَعَاتِ
u'غُفْرَانٌ ذَنْبٌ':Added, #1: 1	غُفْرَانَ حُرْمَةِ
u'غُفْرَانٌ ذَنْبٌ':Added, #1: 1	غُفْرَانُ الذَّنْبِ
u'غُفْرَانٌ ذَنْبٌ':Added, #1: 1	غُفْرَانُ ذَنْبِ
u'غُفْرَانٌ ذُنُوبٌ':Added, #1: 1	غُفْرَانِ ذَنْبِ
u'غُفْرَانٌ صغائر':Added, #1: 1	غُفْرَانُ الذُّنُوبِ
u'غُفْرَانٌ صَغَائِرُ':Added, #1: 1	غُفْرَانِ الصَّغَائِرِ
u'غُفْرَانٌ صغائر':Added, #1: 1	غُفْرَانِ الصَّغَائِرِ
u'غُفْرَانٌ صَغَائِرُ':Added, #5: 5	غُفْرَانُ الصَّغَائِرِ
u'غُفْرَانٌ غير':Added, #5: 5	غُفْرَانُ الصَّغَائِرِ
u'غُفْرَانٌ غَيْرٌ':Added, #1: 1	غُفْرَانُ غَيْرِ
u'غُفْرَانٌ كفر':Added, #1: 1	غُفْرَانُ غَيْرِ
u'غُفْرَانٌ كُفْرٌ':Added, #1: 1	غُفْرَانِ الْكُفْرِ
u'غُفْرَانٌ مَسَاوِئُ':Added, #1: 1	غُفْرَانِ الْكُفْرِ
u'غَفَرَ قَالٌ':Predicate, #1: 1	غُفْرَانِ الْمَسَاوِئِ
u'غفلة الْمَرْءُ':Added, #1: 1	غَفَرَ قَالَ
u'غَفْلَةٌ الْمَرْءُ':Added, #1: 1	غَفْلَةِ الْمَرْءِ
u'غفلة تَقْصيرٌ':Added, #1: 1	غَفْلَةِ الْمَرْءِ
u'غَفْلَةٌ تَقْصيرٌ':Added, #1: 1	غَفْلَةِ التَّقْصِيرِ
u'غفلة عَبْدٌ':Added, #1: 1	غَفْلَةِ التَّقْصِيرِ
u'غَفْلَةٌ عَبْدٌ':Added, #1: 1	غَفْلَةُ الْعَبْدِ
u'غفلة مُخَاطَبٌ':Added, #1: 1	غَفْلَةُ الْعَبْدِ
u'غَفْلَةٌ مُخَاطَبٌ':Added, #1: 1	غَفْلَةُ الْمُخَاطَبِ
u'غفلة نَاسٌ':Added, #1: 1	غَفْلَةُ الْمُخَاطَبِ
u'غَفْلَةٌ نَاسٌ':Added, #1: 1	غَفْلَةِ النَّاسِ
u'غفلة نَائِمٌ':Added, #1: 1	غَفْلَةِ النَّاسِ
u'غَفْلَةٌ نَائِمٌ':Added, #1: 1	غَفْلَةِ النَّائِمِ
u'غَفَلَ شَارِحٌ':Subject, #1: 1	غَفْلَةِ النَّائِمِ
u'غَفَلَ عُرْوَةٌ':Subject, #1: 1	غَفَلَ الشَّارِحُ
u'غَفَلَ قلب':Subject, #1: 1	غَفَلَ عُرْوَةُ
u'غَفَلَ قَلْبٌ':Subject, #1: 1	غَفَلَ قَلْبُهُ
u'غَفَلَ قَلْب':Subject, #1: 1	غَفَلَ قَلْبُهُ
u'غَفَلَ نَاسٌ':Subject, #1: 1	غَفَلَ قَلْبُهُ
u'غَفْوَةٌ زَمانٌ':Added, #1: 1	غَفَلَ النَّاسُ
u'غَلَا أَجْرٌ':Subject, #1: 1	غَفْوَةَ الزَّمَانِ
u'غَلَا بَعْضٌ':Subject, #1: 1	غَلَا أَجْرُ
u'غَلَا دِينارٌ':Subject, #1: 1	غَلَا بَعْضُ
u'غَلَا سعر':Subject, #1: 1	غَلَا الدِّينَارُ
u'غَلَا سِعْرٌ':Subject, #1: 1	غَلَا سِعْرُهُ
u'غَلَا سعر':Subject, #1: 1	غَلَا سِعْرُهُ
u'غَلَا سِعْرٌ':Subject, #2: 2	غَلَا السِّعْرُ
u'غَلَا قَوْمٌ':Subject, #2: 2	غَلَا السِّعْرُ
u'غَلَا نُسُكٌ':Subject, #1: 1	غَلَا قَوْمٌ
u'غَلَبَ اِتِّخَاذٌ':Subject, #1: 1	غَلَا النُّسُكُ
u'غَلَبَ أحَدٌ':Subject, #1: 1	غَلَبَ اتِّخَاذُهُ
u'غَلَبَ اِسْتِعْمالٌ':Subject, #1: 1	غَلَبَ أَحَدُ
u'غَلَبَ اِسْتِعْمالٌ':Subject, #5: 5	غَلَبَ اسْتِعْمَالُ
u'غَلَبَ اِسْمٌ':Subject, #9: 9	غَلَبَ اسْتِعْمَالُهُ
u'غَلَبَ أشْهَرُ':Subject, #1: 1	غَلَبَ اسْمُ
u'غَلَبَ إمَامٌ':Subject, #1: 1	غَلَبَ الْأَشْهَرُ
u'غَلَبَ أهْلٌ':Subject, #3: 3	غَلَبَ الْإِمَامُ
u'غَلَبَ بَاعِثٌ':Subject, #1: 1	غَلَبَ أَهْلُ
u'غَلَبَ بُزاق':Subject, #2: 2	غَلَبَ بَاعِثُ
u'غَلَبَةٌ أَجْزَاءٌ':Added, #1: 1	غَلَبَ الْبُزَاقُ
u'غَلَبَةٌ أَخْلاَطٌ':Added, #1: 1	غَلَبَةَ الْأَجْزَاءِ
u'غَلَبَةٌ اِسْتِعْمالٌ':Added, #1: 1	غَلَبَةِ الْأَخْلَاطِ
u'غَلَبَةٌ اِسْتِعْمالٌ':Added, #1: 1	غَلَبَةُ اسْتِعْمَالِ
u'غَلَبَةٌ أشباه':Added, #1: 1	غَلَبَةِ اسْتِعْمَالٍ
u'غَلَبَةٌ أشْبَاهٌ':Added, #1: 1	غَلَبَةَ الْأَشْبَاهِ
u'غَلَبَةٌ أَشْبَاهٌ':Added, #1: 1	غَلَبَةَ الْأَشْبَاهِ
u'غَلَبَةٌ أشباه':Added, #1: 1	غَلَبَةَ الْأَشْبَاهِ
u'غَلَبَةٌ أشْبَاهٌ':Added, #2: 2	غَلَبَةِ الْأَشْبَاهِ
u'غَلَبَةٌ أَشْبَاهٌ':Added, #2: 2	غَلَبَةِ الْأَشْبَاهِ
u'غَلَبَةٌ إصابَةٌ':Added, #2: 2	غَلَبَةِ الْأَشْبَاهِ
u'غَلَبَةٌ أَمْطَارٌ':Added, #1: 1	غَلَبَةِ الْإِصَابَةِ
u'غَلَبَةٌ أهْلٌ':Added, #1: 1	غَلَبَةِ الْأَمْطَارِ
u'غَلَبَةٌ أهْلٌ':Added, #1: 1	غَلَبَةَ أَهْلِ
u'غَلَبَةٌ بَعْضٌ':Added, #1: 1	غَلَبَةُ أَهْلِ
u'غَلَبَةٌ تَخْصِيصٌ':Added, #1: 1	غَلَبَةِ بَعْضِ
u'غَلَبَةٌ تَقْريرٌ':Added, #1: 1	غَلَبَةِ التَّخْصِيصِ
u'غَلَبَةٌ تَقْريرٌ':Added, #1: 1	غَلَبَةَ تَقْرِيرٍ
u'غَلَبَةٌ تَنْجِيسٌ':Added, #1: 1	غَلَبَةِ تَقْرِيرٍ
u'غَلَبَةٌ توائه':Added, #1: 1	غَلَبَةِ التَّنْجِيسِ
u'غَلَبَةٌ تَوَقُّعٌ':Added, #1: 1	غَلَبَةِ تَوَائِهِ
u'غَلَبَةٌ ثَمَن':Added, #1: 1	غَلَبَةُ تَوَقُّعِ
u'غَلَبَةٌ جهل':Added, #1: 1	غَلَبَةُ الثَّمَنِيَّةِ
u'غَلَبَةٌ جَهْلٌ':Added, #1: 1	غَلَبَةُ الْجَهْلِ
u'غَلَبَةٌ حالٌ':Added, #1: 1	غَلَبَةُ الْجَهْلِ
u'غَلَبَةٌ حُبٌّ':Added, #1: 1	غَلَبَةُ حَالٍ
u'غَلَبَةٌ حَبَشَة':Added, #1: 1	غَلَبَةُ حُبِّ
u'غَلَبَةٌ حَقٌّ':Added, #1: 1	غَلَبَةِ الْحَبَشَةِ
u'غَلَبَةٌ حَلالٌ':Added, #1: 1	غَلَبَةِ حَقِّ
u'غَلَبَةٌ حُنُوٌّ':Added, #4: 4	غَلَبَةِ الْحَلَالِ
u'غَلَبَةٌ خُلُوصٌ':Added, #1: 1	غَلَبَةِ الْحُنُوِّ
u'غَلَبَةٌ خَوْفٌ':Added, #1: 1	غَلَبَةِ الْخُلُوصِ
u'غَلَبَةٌ خَوْفٌ':Added, #2: 2	غَلَبَةُ الْخَوْفِ
u'غَلَبَةٌ خَوْفٌ':Added, #2: 2	غَلَبَةِ الْخَوْفِ
u'غَلَبَةٌ دَابَّةٌ':Added, #2: 2	غَلَبَةِ خَوْفِ
u'غَلَبَةٌ دَمٌ':Added, #1: 1	غَلَبَةِ الدَّابَّةِ
u'غَلَبَةٌ دَمٌ':Added, #1: 1	غَلَبَةُ الدَّمِ
u'غَلَبَةٌ دَوامٌ':Added, #2: 2	غَلَبَةَ الدَّمِ
u'غَلَبَةٌ دَيْنٌ':Added, #1: 1	غَلَبَةِ الدَّوَامِ
u'غَلَبَةٌ رَأْيٌ':Added, #2: 2	غَلَبَةِ الدَّيْنِ
u'غَلَبَةٌ رَجاء':Added, #1: 1	غَلَبَةُ الرَّأْيِ
u'غَلَبَةٌ رَجاء':Added, #1: 1	غَلَبَةُ الرَّجَاءِ
u'غَلَبَةٌ رَجَاءٌ':Added, #1: 1	غَلَبَةِ الرَّجَاءِ
u'غَلَبَةٌ رَجَاءٌ':Added, #1: 1	غَلَبَةُ الرَّجَاءِ
u'غَلَبَةٌ رَجاء':Added, #1: 1	غَلَبَةِ الرَّجَاءِ
u'غَلَبَةٌ رَجَاءٌ':Added, #1: 1	غَلَبَةِ رَجَاءِ
u'غَلَبَةٌ رُطوبَةٌ':Added, #1: 1	غَلَبَةِ رَجَاءِ
u'غَلَبَةٌ رُطوبَةٌ':Added, #1: 1	غَلَبَةُ الرُّطُوبَةِ
u'غَلَبَةٌ رِيقٌ':Added, #1: 1	غَلَبَةِ الرُّطُوبَةِ
u'غَلَبَةٌ سُرَّاقٌ':Added, #1: 1	غَلَبَةُ الرِّيقِ
u'غَلَبَةٌ سُرُورٌ':Added, #1: 1	غَلَبَةِ السُّرَّاقِ
u'غَلَبَةٌ سلام':Added, #1: 1	غَلَبَةُ سُرُورٍ
u'غَلَبَةٌ سَلاَمٌ':Added, #2: 2	غَلَبَةِ السَّلَامِ
u'غَلَبَةٌ سَلاَمَةٌ':Added, #2: 2	غَلَبَةِ السَّلَامِ
u'غَلَبَةٌ سَلاَمَةٌ':Added, #13: 13	غَلَبَةِ السَّلَامَةِ
u'غَلَبَةٌ سَلاَمَةٌ':Added, #1: 1	غَلَبَةَ السَّلَامَةِ
u'غَلَبَةٌ سَوْداء':Added, #1: 1	غَلَبَةُ سَلَامَةِ
u'غَلَبَةٌ شَبَقٌ':Added, #2: 2	غَلَبَةِ السَّوْدَاءِ
u'غَلَبَةٌ شَفَقَةٌ':Added, #2: 2	غَلَبَةِ الشَّبَقِ
u'غَلَبَةٌ شَهْوَةٌ':Added, #1: 1	غَلَبَةِ شَفَقَتِهِ
u'غَلَبَةٌ صدق':Added, #3: 3	غَلَبَةِ الشَّهْوَةِ
u'غَلَبَةٌ صِدْقٌ':Added, #1: 1	غَلَبَةِ الصِّدْقِ
u'غَلَبَةٌ صغائر':Added, #1: 1	غَلَبَةِ الصِّدْقِ
u'غَلَبَةٌ صَغَائِرُ':Added, #2: 2	غَلَبَةِ الصَّغَائِرِ
u'غَلَبَةٌ صَفْرَاء':Added, #2: 2	غَلَبَةِ الصَّغَائِرِ
u'غَلَبَةٌ طَاعَةٌ':Added, #2: 2	غَلَبَةِ الصَّفْرَاءِ
u'غَلَبَةٌ طَاعَةٌ':Added, #1: 1	غَلَبَةِ طَاعَاتِهِ
u'غَلَبَةٌ طِبَاعٌ':Added, #4: 4	غَلَبَةِ الطَّاعَاتِ
u'غَلَبَةٌ ظَنٌّ':Added, #1: 1	غَلَبَةِ الطِّبَاعِ
u'غَلَبَةٌ ظَنٌّ':Added, #1: 1	غَلَبَةَ ظَنِّ
u'غَلَبَةٌ ظَنٌّ':Added, #1: 1	غَلَبَةُ ظَنِّ
u'غَلَبَةٌ ظَنٌّ':Added, #28: 28	غَلَبَةَ الظَّنِّ
u'غَلَبَةٌ ظَنٌّ':Added, #2: 2	غَلَبَةَ ظَنٍّ
u'غَلَبَةٌ ظَنٌّ':Added, #3: 3	غَلَبَةِ ظَنٍّ
u'غَلَبَةٌ ظَنٌّ':Added, #45: 45	غَلَبَةِ الظَّنِّ
u'غَلَبَةٌ ظَنٌّ':Added, #4: 4	غَلَبَةُ ظَنٍّ
u'غَلَبَةٌ ظَنٌّ':Added, #59: 59	غَلَبَةُ الظَّنِّ
u'غَلَبَةٌ ظَنٌّ':Added, #5: 5	غَلَبَةُ ظَنِّهِ
u'غَلَبَةٌ ظَنٌّ':Added, #7: 7	غَلَبَةِ ظَنِّ
u'غَلَبَةٌ ظُنونٌ':Added, #8: 8	غَلَبَةِ ظَنِّهِ
u'غَلَبَةٌ ظُنونٌ':Added, #1: 1	غَلَبَةُ الظُّنُونِ
u'غَلَبَةٌ عَادَةٌ':Added, #1: 1	غَلَبَةِ الظُّنُونِ
u'غَلَبَةٌ عَامٌّ':Added, #1: 1	غَلَبَةِ الْعَادَةِ
u'غَلَبَةٌ عَدَالَةٌ':Added, #1: 1	غَلَبَةُ الْعَامَّةِ
u'غَلَبَةٌ عَدَمٌ':Added, #1: 1	غَلَبَةُ الْعَدَالَةِ
u'غَلَبَةٌ عَدُوٌّ':Added, #1: 1	غَلَبَةُ عَدَمِ
u'غَلَبَةٌ فساد':Added, #1: 1	غَلَبَةِ الْعَدُوِّ
u'غَلَبَةٌ فَسَادٌ':Added, #1: 1	غَلَبَةِ الْفَسَادِ
u'غَلَبَةٌ فِسْقٌ':Added, #1: 1	غَلَبَةِ الْفَسَادِ
u'غَلَبَةٌ فَقْدٌ':Added, #1: 1	غَلَبَةُ الْفِسْقِ
u'غَلَبَةٌ فَقْدٌ':Added, #1: 1	غَلَبَةُ الْفَقْدِ
u'غَلَبَةٌ فَقْدٌ':Added, #1: 1	غَلَبَةُ فَقْدِهِ
u'غَلَبَةٌ فقر':Added, #2: 2	غَلَبَةِ الْفَقْدِ
u'غَلَبَةٌ فَقْرٌ':Added, #1: 1	غَلَبَةِ الْفَقْرِ
u'غَلَبَةٌ قَائِمٌ':Added, #1: 1	غَلَبَةِ الْفَقْرِ
u'غَلَبَةٌ كُفَّارٌ':Added, #1: 1	غَلَبَةُ الْقَائِمِ
u'غَلَبَةٌ لَوْنٌ':Added, #1: 1	غَلَبَةِ الْكُفَّارِ
u'غَلَبَةٌ مَاءٌ':Added, #1: 1	غَلَبَةِ لَوْنِ
u'غَلَبَةٌ مَاءٌ':Added, #1: 1	غَلَبَةَ الْمَاءِ
u'غَلَبَةٌ مَاءٌ':Added, #1: 1	غَلَبَةِ الْمَاءِ
u'غَلَبَةٌ مَاءٌ':Added, #1: 1	غَلَبَةِ مَاءِ
u'غَلَبَةٌ مُخَالَطَةٌ':Added, #2: 2	غَلَبَةُ الْمَاءِ
u'غَلَبَةٌ مُسَلَّمٌ':Added, #1: 1	غَلَبَةُ مُخَالَطَةِ
u'غَلَبَةٌ مَقَامٌ':Added, #1: 1	غَلَبَةُ الْمُسَلَّمِ
u'غَلَبَةٌ مُلُوكٌ':Added, #1: 1	غَلَبَةِ مَقَامِ
u'غَلَبَةٌ نَجَاسَةٌ':Added, #1: 1	غَلَبَةِ الْمُلُوكِ
u'غَلَبَةٌ نَجَاسَةٌ':Added, #1: 1	غَلَبَةُ النَّجَاسَةِ
u'غَلَبَةٌ نعاس':Added, #2: 2	غَلَبَةِ النَّجَاسَةِ
u'غَلَبَةٌ نعاس':Added, #1: 1	غَلَبَةَ النُّعَاسِ
u'غَلَبَةٌ نُعَاسٌ':Added, #1: 1	غَلَبَةُ النّعَاسِ
u'غَلَبَةٌ نُعَاسٌ':Added, #1: 1	غَلَبَةَ النُّعَاسِ
u'غَلَبَةٌ نعاس':Added, #1: 1	غَلَبَةُ النّعَاسِ
u'غَلَبَةٌ نُعَاسٌ':Added, #1: 1	غَلَبَةِ نُعَاسٍ
u'غَلَبَةٌ نعاس':Added, #1: 1	غَلَبَةِ نُعَاسٍ
u'غَلَبَةٌ نُعَاسٌ':Added, #3: 3	غَلَبَةِ النُّعَاسِ
u'غَلَبَةٌ نَهْبٌ':Added, #3: 3	غَلَبَةِ النُّعَاسِ
u'غَلَبَةٌ نَوْمٌ':Added, #1: 1	غَلَبَةِ النَّهْبِ
u'غَلَبَةٌ هلاك':Added, #1: 1	غَلَبَةِ النَّوْمِ
u'غَلَبَةٌ هَلاَكٌ':Added, #1: 1	غَلَبَةَ الْهَلَاكِ
u'غَلَبَةٌ هلاك':Added, #1: 1	غَلَبَةَ الْهَلَاكِ
u'غَلَبَةٌ هَلاَكٌ':Added, #2: 2	غَلَبَةِ الْهَلَاكِ
u'غَلَبَةٌ وُجُودٌ':Added, #2: 2	غَلَبَةِ الْهَلَاكِ
u'غَلَبَةٌ وُجُودٌ':Added, #1: 1	غَلَبَةُ الْوُجُودِ
u'غَلَبَةٌ وُقُوعٌ':Added, #1: 1	غَلَبَةُ وُجُودِهِ
u'غَلَبَةٌ وُقُوعٌ':Added, #2: 2	غَلَبَةُ وُقُوعِ
u'غَلَبَ تَابِعٌ':Subject, #2: 2	غَلَبَةُ وُقُوعِهِ
u'غَلَبَ تَحْرِيمٌ':Subject, #1: 1	غَلَبَ التّابِعُ
u'غَلَبَ تَعَارُفٌ':Subject, #2: 2	غَلَبَ التَّحْرِيمُ
u'غَلَبَ تَعَامُلٌ':Subject, #1: 1	غَلَبَ التَّعَارُفُ
u'غَلَبَ تَلَف':Subject, #3: 3	غَلَبَ التَّعَامُلُ
u'غَلَبَ جَازٌ':Predicate, #1: 1	غَلَبَ التَّلَفُ
u'غَلَّبَ جَانِبٌ':Predicate, #2: 2	غَلَبَ جَازَ
u'غَلَبَ جَانِبٌ':Subject, #2: 2	غَلَّبَ جَانِبَ
u'غَلَبَ جَانِبٌ':Subject, #1: 1	غَلَبَ جَانِبُهُ
u'غَلَبَ جمع':Subject, #2: 2	غَلَبَ جَانِبُ
u'غَلَبَ جَمْعٌ':Subject, #1: 1	غَلَبَ جَمْعُهُ
u'غَلَبَ جَوْرٌ':Subject, #1: 1	غَلَبَ جَمْعُهُ
u'غَلَبَ حارٌّ':Subject, #3: 3	غَلَبَ جَوْرُهُ
u'غَلَبَ حَرامٌ':Subject, #1: 1	غَلَبَ الْحَارُّ
u'غَلَّبَ حُرْمَةٌ':Predicate, #18: 18	غَلَبَ الْحَرَامُ
u'غَلَبَ حُرْمَةٌ':Subject, #1: 1	غَلَّبَ حُرْمَةَ
u'غَلَبَ حُصُول':Subject, #1: 1	غَلَبَ الْحُرْمَةُ
u'غَلَبَ حَضَرٌ':Subject, #1: 1	غَلَبَ حُصُولُهُ
u'غَلَبَ حَظْر':Subject, #1: 1	غَلَبَ الْحَضَرُ
u'غَلَبَ حِفْظٌ':Subject, #1: 1	غَلَبَ الْحَظْرُ
u'غَلَبَ حَقٌّ':Subject, #1: 1	غَلَبَ حِفْظُهُ
u'غَلَبَ حَقٌّ':Subject, #1: 1	غَلَبَ حَقُّ
u'غَلَبَ حقد':Subject, #3: 3	غَلَبَ الْحَقُّ
u'غَلَبَ حِقد':Subject, #1: 1	غَلَبَ الْحِقْدُ
u'غَلَبَ حِقْدٌ':Subject, #1: 1	غَلَبَ الْحِقْدُ
u'غَلَبَ حُكْمٌ':Subject, #1: 1	غَلَبَ الْحِقْدُ
u'غَلَبَ حَلالٌ':Subject, #2: 2	غَلَبَ حُكْمُ
u'غَلَّبَ حِمَايَةٌ':Predicate, #2: 2	غَلَبَ الْحَلَالُ
u'غَلَبَ خَارِجِيٌّ':Subject, #1: 1	غَلَّبَ حِمَايَةَ
u'غَلَبَ خوارج':Subject, #1: 1	غَلَبَ الْخَارِجِيُّ
u'غَلَبَ خَوَارِجُ':Subject, #5: 5	غَلَبَ الْخَوَارِجُ
u'غَلَبَ خَوْفٌ':Subject, #5: 5	غَلَبَ الْخَوَارِجُ
u'غَلَبَ دَرْء':Subject, #3: 3	غَلَبَ الْخَوْفُ
u'غَلَبَ دَمٌ':Subject, #1: 1	غَلَبَ دَرْءُ
u'غَلَبَ دونٌ':Predicate, #1: 1	غَلَبَ الدَّمُ
u'غَلَبَ رَجُلٌ':Subject, #1: 1	غَلَبَ دُونَ
u'غَلَبَ رُومٌ':Predicate, #1: 1	غَلَبَ رَجُلٌ
u'غَلَبَ رُومٌ':Subject, #2: 2	غَلَبَ الرّومَ
u'غَلَبَ ريحٌ':Subject, #1: 1	غَلَبَ الرُّومُ
u'غَلَبَ رِيقٌ':Predicate, #1: 1	غَلَبَ الرِّيحُ
u'غَلَبَ سُرُورٌ':Subject, #1: 1	غَلَبَ الرِّيقَ
u'غَلَبَ سَلَبٌ':Predicate, #1: 1	غَلَبَ السّرُورُ
u'غَلَبَ سَيْل':Subject, #1: 1	غَلَبَ سَلَبَ
u'غَلَبَ شَبَهٌ':Subject, #2: 2	غَلَبَ السَّيْلُ
u'غَلَبَ شَقَاءٌ':Subject, #1: 1	غَلَبَ شَبَهُهُ
u'غَلَبَ شَيْطَانٌ':Subject, #2: 2	غَلَبَ الشَّقَاءُ
u'غَلَّبَ صَبِيٌّ':Predicate, #1: 1	غَلَبَ الشَّيْطَانُ
u'غَلَبَ صَلاَحٌ':Subject, #1: 1	غَلَّبَ الصَّبِيَّ
u'غَلَبَ صَلِيبٌ':Subject, #2: 2	غَلَبَ الصَّلَاحُ
u'غَلَبَ صنعة':Subject, #2: 2	غَلَبَ الصَّلِيبُ
u'غَلَبَ صَنْعَةٌ':Subject, #1: 1	غَلَبَ الصَّنْعَةُ
u'غَلَبَ طَاعَةٌ':Subject, #1: 1	غَلَبَ الصَّنْعَةُ
u'غَلَبَ طَعْمٌ':Subject, #1: 1	غَلَبَ الطَّاعَاتُ
u'غَلَبَ طَمَعٌ':Subject, #1: 1	غَلَبَ طَعْمُهُ
u'غَلَبَ طهر':Subject, #1: 1	غَلَبَ الطَّمَعُ
u'غَلَبَ طُهْرٌ':Subject, #2: 2	غَلَبَ الطُّهْرُ
u'غَلَبَ ظَنٌّ':Subject, #2: 2	غَلَبَ الطُّهْرُ
u'غَلَبَ ظَنٌّ':Subject, #3: 3	غَلَبَ ظَنُّ
u'غَلَبَ عَدْلٌ':Subject, #3: 3	غَلَبَ ظَنُّهُ
u'غَلَبَ عَدَمٌ':Subject, #4: 4	غَلَبَ عَدْلُهُ
u'غَلَبَ عَدُوٌّ':Subject, #1: 1	غَلَبَ عَدَمُ
u'غَلَّبَ عَقْلٌ':Predicate, #2: 2	غَلَبَ الْعَدُوُّ
u'غَلَبَ عَقْلٌ':Subject, #1: 1	غَلَّبَ الْعَقْلَ
u'غَلَبَ عند':Predicate, #2: 2	غَلَبَ عَقْلُهُ
u'غَلَبَ غِشٌّ':Subject, #2: 2	غَلَبَ عِنْدَ
u'غَلَبَ غِشٌّ':Subject, #1: 1	غَلَبَ غِشُّهُ
u'غَلَبَ غَصْبٌ':Subject, #3: 3	غَلَبَ الْغِشُّ
u'غَلَبَ غَلَطٌ':Subject, #1: 1	غَلَبَ غَصْبُ
u'غَلَبَ فساد':Subject, #1: 1	غَلَبَ غَلَطُهُ
u'غَلَبَ فَسَادٌ':Subject, #1: 1	غَلَبَ الْفَسَادُ
u'غَلَبَ فِضَّةٌ':Subject, #1: 1	غَلَبَ الْفَسَادُ
u'غَلَبَ قَصْدٌ':Subject, #1: 1	غَلَبَ فِضَّتُهُ
u'غَلَبَ قَضَاءٌ':Subject, #1: 1	غَلَبَ قَصْدُ
u'غَلَبَ قَضَاءٌ':Subject, #1: 1	غَلَبَ الْقَضَاءُ
u'غَلَبَ قَوْمٌ':Subject, #1: 1	غَلَبَ قَضَاءُ
u'غَلَبَ قَوْمٌ':Subject, #1: 1	غَلَبَ قَوْمٌ
u'غَلَبَ كُفَّارٌ':Subject, #1: 1	غَلَبَ قَوْمُهُ
u'غَلَبَ كُفَّارٌ':Subject, #1: 1	غَلَبَ كُفَّارُ
u'غَلَبَ لبن':Subject, #2: 2	غَلَبَ الْكُفَّارُ
u'غَلَبَ لَبَنٌ':Subject, #2: 2	غَلَبَ اللَّبَنُ
u'غَلَبَ لبن':Subject, #2: 2	غَلَبَ اللَّبَنُ
u'غَلَبَ لَبَنٌ':Subject, #2: 2	غَلَبَ لَبَنُ
u'غَلَبَ لَوْنٌ':Subject, #2: 2	غَلَبَ لَبَنُ
u'غَلَبَ مَاءٌ':Subject, #1: 1	غَلَبَ لَوْنُ
u'غَلَبَ مَالٌ':Predicate, #4: 4	غَلَبَ الْمَاءُ
u'غَلَبَ مَالٌ':Predicate, #1: 1	غَلَبَ مَالَ
u'غَلَبَ مُبَاشَرَةٌ':Subject, #2: 2	غَلَبَ الْمَالَ
u'غَلَبَ مَجَازٌ':Subject, #1: 1	غَلَبَ الْمُبَاشَرَةُ
u'غَلَبَ مَجَازٌ':Subject, #1: 1	غَلَبَ الْمَجَازُ
u'غَلَّبَ مُحَرَّمٌ':Predicate, #1: 1	غَلَبَ مَجَازُ
u'غَلَبَ مُخَاطَبٌ':Subject, #1: 1	غَلَّبَ الْمُحَرَّمَ
u'غَلَبَ مُخَالَطَةٌ':Subject, #1: 1	غَلَبَ الْمُخَاطَبُ
u'غَلَّبَ مُذَكَّرٌ':Predicate, #1: 1	غَلَبَ مُخَالَطَتُهُ
u'غَلَبَ مَرَضٌ':Subject, #2: 2	غَلَّبَ الْمُذَكَّرَ
u'غَلَبَ مَرْكُوبٌ':Subject, #1: 1	غَلَبَ الْمَرَضُ
u'غَلَبَ مُرُورٌ':Subject, #1: 1	غَلَبَ الْمَرْكُوبُ
u'غَلَّبَ مَسْأَلَةٌ':Predicate, #1: 1	غَلَبَ مُرُورُهُ
u'غَلَبَ مُنْكَرٌ':Subject, #1: 1	غَلَّبَ الْمَسْأَلَةَ
u'غَلَبَ نَقْدٌ':Subject, #1: 1	غَلَبَ الْمُنْكَرُ
u'غَلَبَ نَقْد':Subject, #1: 1	غَلَبَ نَقْدٌ
u'غَلَبَ نَقْصٌ':Subject, #1: 1	غَلَبَ نَقْدٌ
u'غَلَبَ نَوْعٌ':Subject, #1: 1	غَلَبَ النَّقْصُ
u'غَلَبَ هلاك':Subject, #1: 1	غَلَبَ نَوْعٌ
u'غَلَبَ هَلاَكٌ':Subject, #3: 3	غَلَبَ الْهَلَاكُ
u'غَلَبَ واحد':Subject, #3: 3	غَلَبَ الْهَلَاكُ
u'غَلَبَ وَاحِدٌ':Subject, #3: 3	غَلَبَ وَاحِدٌ
u'غَلَبَ وَجَارٌ':Predicate, #3: 3	غَلَبَ وَاحِدٌ
u'غَلَبَ وُجُودٌ':Subject, #1: 1	غَلَبَ وَجَارَ
u'غَلَبَ وَسْوَاسٌ':Subject, #2: 2	غَلَبَ وُجُودُهُ
u'غَلَبَ وَصْفٌ':Subject, #2: 2	غَلَبَ الْوَسْوَاسُ
u'غَلَبَ وُقُوعٌ':Subject, #1: 1	غَلَبَ الْوَصْفُ
u'غَلَبَ يَوْمٌ':Subject, #1: 1	غَلَبَ وُقُوعُهُ
u'غَلَّ جَيْشٌ':Subject, #1: 1	غَلَبَ يَوْمُ
u'غَلَّ رَجُلٌ':Subject, #1: 1	غَلَّ جَيْشٌ
u'غَلَّ رَجُلٌ':Subject, #1: 1	غَلَّ الرَّجُلُ
u'غَلَّطَ اِبْنٌ':Subject, #1: 1	غَلَّ رَجُلٌ
u'غَلِطَ اِبْنٌ':Subject, #1: 1	غَلَّطَ ابْنُ
u'غَلَطٌ اِبْنٌ':Added, #4: 4	غَلِطَ ابْنُ
u'غَلَطٌ اِبْنٌ':Added, #1: 1	غَلَطُ ابْنِ
u'غَلَّطَ أَصْحَابٌ':Subject, #1: 1	غَلَطِ ابْنِ
u'غَلَطٌ أَصْحَابٌ':Added, #1: 1	غَلَّطَ الْأَصْحَابُ
u'غَلَّطَ أصل':Predicate, #1: 1	غَلَطُ الْأَصْحَابِ
u'غَلَّطَ أًصْلٌ':Predicate, #1: 1	غَلَّطَ الْأَصْلَ
u'غَلِطَ أصل':Subject, #1: 1	غَلَّطَ الْأَصْلَ
u'غَلِطَ أًصْلٌ':Subject, #1: 1	غَلِطَ الْأَصْلُ
u'غَلَطٌ أهْلٌ':Added, #1: 1	غَلِطَ الْأَصْلُ
u'غَلِطَ بَعْضٌ':Subject, #1: 1	غَلَطَ أَهْلِ
u'غَلِطَ جَمٌّ':Subject, #4: 4	غَلِطَ بَعْضُ
u'غَلِطَ جَمَاعَةٌ':Subject, #2: 2	غَلِطَ الْجَمُّ
u'غَلِطَ حاكِمٌ':Subject, #1: 1	غَلِطَ جَمَاعَةٌ
u'غَلَطٌ حِسٌّ':Added, #1: 1	غَلِطَ الْحَاكِمُ
u'غَلَطٌ سِماكٌ':Added, #1: 1	غَلَطِ الْحِسِّ
u'غَلِطَ سَيْفٌ':Subject, #1: 1	غَلَطِ سِمَاكٍ
u'غَلَّطَ شافِعِيّ':Subject, #1: 1	غَلِطَ سَيْفٌ
u'غَلِطَ شَاهِدٌ':Subject, #2: 2	غَلَّطَ الشَّافِعِيُّ
u'غَلَطٌ شَاهِدٌ':Added, #1: 1	غَلِطَ الشَّاهِدُ
u'غَلَطٌ شَاهِدٌ':Added, #1: 1	غَلَطُ الشَّاهِدِ
u'غَلَطٌ طَاعِنٌ':Added, #1: 1	غَلَطِ الشَّاهِدِ
u'غَلِطَ طَائِفٌ':Subject, #1: 1	غَلَطَ الطَّاعِنِ
u'غَلَطٌ طَلَبَةٌ':Added, #1: 1	غَلِطَ طَائِفَةٌ
u'غَلَّطَ عَلِيٌّ':Predicate, #1: 1	غَلَطِ الطَّلَبَةِ
u'غَلِطَ فلان':Subject, #1: 1	غَلَّطَ عَلِيَّ
u'غَلَّطَ فلان':Subject, #1: 1	غَلِطَ سُفْيَانُ
u'غَلِطَ قَوْمٌ':Subject, #2: 2	غَلَّطَ الشَّافِعِيُّ
u'غَلِطَ مَالِكٌ':Subject, #1: 1	غَلِطَ قَوْمٌ
u'غَلَطٌ مُذِلّ':Added, #1: 1	غَلِطَ مَالِكٌ
u'غَلَطٌ مُمْكِنٌ':Added, #1: 1	غَلَطٍ مُذِلٍّ
u'غَلَطٌ مُمْكِن':Added, #3: 3	غَلَطٍ مُمْكِنٍ
u'غَلِطَ نَاسٌ':Subject, #3: 3	غَلَطٍ مُمْكِنٍ
u'غَلِطَ نَقَّاشٌ':Subject, #1: 1	غَلِطَ النَّاسُ
u'غَلُظَ جِسْمٌ':Subject, #1: 1	غَلِطَ النَّقَّاشُ
u'غَلَّظَ حَدٌّ':Predicate, #1: 1	غَلُظَ جِسْمُهُ
u'غَلَّظَ دِيَةٌ':Predicate, #1: 1	غَلَّظَ الْحَدَّ
u'غَلُظَ طَبْعٌ':Subject, #1: 1	غَلَّظَ الدِّيَةَ
u'غَلَّ عَبْدٌ':Subject, #1: 1	غَلُظَ طَبْعُهُ
u'غَلِقَ أَبْوَابٌ':Predicate, #1: 1	غَلَّ عَبْدٌ
u'غَلِقَ بَابٌ':Predicate, #1: 1	أَغْلَقَ أَبْوَابَ
u'غَلِقَ بَابٌ':Predicate, #17: 17	أَغْلَقَ الْبَابَ
u'غَلَقَ رَهْنٌ':Subject, #3: 3	أَغْلَقَ بَابَ
u'غُلْمَةٌ نِساءٌ':Added, #1: 1	غَلَقَ الرَّهْنُ
u'غَلَى أَجْرٌ':Subject, #1: 1	غُلْمَةَ النِّسَاءِ
u'غَلَيَانٌ دَمٌ':Added, #1: 1	غَلَى أَجْرُهُ
u'غَلَيَانٌ قِدْرٌ':Added, #1: 1	غَلَيَانُ دَمِهِ
u'غَلَيَانٌ قِدْرٌ':Added, #1: 1	غَلَيَانُ الْقِدْرِ
u'غَلَى عَصِيرٌ':Subject, #2: 2	غَلَيَانِ الْقِدْرِ
u'غَلَى عِنَبٌ':Subject, #1: 1	غَلَى الْعَصِيرُ
u'غَلِيلٌ حُبٌّ':Added, #2: 2	غَلَى الْعِنَبُ
u'غَلْيٌ مِرْجَلٌ':Added, #1: 1	غَلِيلِ الْحُبِّ
u'غَلَّ يَوْمٌ':Predicate, #1: 1	غَلْيِ الْمِرْجَلِ
u'غمار عَوَامُّ':Added, #6: 6	غَلَّ يَوْمَ
u'غَمْرٌ طعام':Added, #1: 1	أَغْمَارُ الْعَوَامِّ
u'غَمْرٌ طَعَامٌ':Added, #1: 1	غَمْرُ الطَّعَامِ
u'غَمْرٌ لَحْمٌ':Added, #1: 1	غَمْرُ الطَّعَامِ
u'غَمْرٌ مَاءٌ':Added, #1: 1	غَمْرِ اللَّحْمِ
u'غَمْرٌ مَغْمُورٌ':Added, #1: 1	غَمْرِ الْمَاءِ
u'غَمَزَ اِبْنٌ':Subject, #1: 1	غَمْرٍ مَغْمُورٍ
u'غَمْزٌ أَعْضَاءٌ':Added, #1: 1	غَمَزَ ابْنُ
u'غَمْزٌ رَجُلٌ':Added, #2: 2	غَمْزُ الْأَعْضَاءِ
u'غَمْزٌ طَبِيبٌ':Added, #1: 1	غَمْزِ الرَّجُلِ
u'غَمَسَ ثَوْبٌ':Predicate, #1: 1	غَمْزَ الطَّبِيبِ
u'غَمَسَ جَبِيرَة':Predicate, #2: 2	غَمَسَ الثَّوْبَ
u'غَمَسَ رَجُلٌ':Subject, #1: 1	غَمَسَ الْجَبِيرَةَ
u'غَمَسَ صَغِيرٌ':Subject, #1: 1	غَمَسَ الرَّجُلُ
u'غَمَسَ قَائِمٌ':Subject, #1: 1	غَمَسَ الصَّغِيرُ
u'غَمَسَ قَوْمٌ':Subject, #1: 1	غَمَسَ قَائِمٌ
u'غَمُضَ إِعْرابٌ':Subject, #1: 1	غَمَسَ الْقَوْمُ
u'غَمْضٌ مَعَانِي':Added, #1: 1	غَمُضَ إعْرَابُهُ
u'غَمَّ هِلاَلٌ':Subject, #1: 1	غَمْضَ مَعَانِيهِ
u'غناء رَاجِلٌ':Added, #1: 1	غَمَّ الْهِلَالُ
u'غَنَاءٌ رَاجِلٌ':Added, #1: 1	غَنَاءِ الرَّاجِلِ
u'غناء رَجُلٌ':Added, #1: 1	غَنَاءِ الرَّاجِلِ
u'غَنَاءٌ رَجُلٌ':Added, #1: 1	غَنَاءُ رَجُلٍ
u'غناء فَارِسٌ':Added, #1: 1	غَنَاءُ رَجُلٍ
u'غَنَاءٌ فَارِسٌ':Added, #1: 1	غَنَاءَ الْفَارِسِ
u'غُنْمٌ تَصَرُّفٌ':Added, #1: 1	غَنَاءَ الْفَارِسِ
u'غَنِمَ جَيْشٌ':Subject, #1: 1	غُنْمَ تَصَرُّفِ
u'غَنِمَ حِزْبٌ':Subject, #2: 2	غَنِمَ الْجَيْشُ
u'غَنِمَ رَسُولٌ':Subject, #1: 1	غَنِمَ حِزْبُهُ
u'غَنِمَ غَنَائِمُ':Predicate, #1: 1	غَنِمَ رَسُولُ
u'غَنِمَ كُفَّارٌ':Subject, #1: 1	غَنِمَ غَنَائِمَ
u'غَنِمَ مَالٌ':Predicate, #1: 1	غَنِمَ الْكُفَّارُ
u'غُنْمٌ مُرْسَلٌ':Added, #1: 1	غَنِمَ مَالَ
u'غَنِمَ مُسْلِمٌ':Subject, #1: 1	غُنْمٍ مُرْسَلٍ
u'غَنِمَ وَجَبٌ':Predicate, #1: 1	غَنِمَ مُسْلِمٌ
u'غَنِيَ ثَانِي':Predicate, #1: 1	غَنِمَ وَجَبَ
u'غَنَّى هَزَارٌ':Subject, #1: 1	أَغْنَى الثَّانِيَ
u'غَوْرٌ أرْضٌ':Added, #1: 1	غَنَّى الْهَزَارُ
u'غَوْرٌ جِرَاحَةٌ':Added, #1: 1	غَوْرَ الْأَرْضِ
u'غَوْرٌ حَرارَةٌ':Added, #1: 1	غَوْرُ الْجِرَاحَةِ
u'غَوْرٌ مَاءٌ':Added, #1: 1	غَوْرُ الْحَرَارَةِ
u'غَوْرٌ مَسْأَلَةٌ':Added, #2: 2	غَوْرَ الْمَاءِ
u'غِيَاضٌ مُزْدَحِمٌ':Added, #1: 1	غَوْرَ الْمَسْأَلَةِ
u'غَيَّبَ الْمَرْءُ':Subject, #1: 1	غِيَاضِ الْمُزْدَحِمِ
u'غَيْبَةٌ أَبٌ':Added, #1: 1	غَيَّبَ الْمَرْءُ
u'غَيْبَةٌ أَبٌ':Added, #1: 1	غَيْبَةُ الْأَبِ
u'غَيْبَةٌ أَجِيرٌ':Added, #1: 1	غَيْبَةِ الْأَبِ
u'غَيْبَةٌ أصل':Added, #1: 1	غَيْبَةِ الْأَجِيرِ
u'غَيْبَةٌ أًصْلٌ':Added, #2: 2	غَيْبَةِ الْأَصْلِ
u'غَيْبَةٌ أَصيلٌ':Added, #2: 2	غَيْبَةِ الْأَصْلِ
u'غَيْبَةٌ أقْرَبُ':Added, #2: 2	غَيْبَةِ الْأَصِيلِ
u'غَيْبَةٌ الْمَرْأَةُ':Added, #2: 2	غَيْبَةِ الْأَقْرَبِ
u'غَيْبَةٌ اِنْتِقالٌ':Added, #2: 2	غَيْبَةِ الْمَرْأَةِ
u'غَيْبَةٌ اِنْقِطاعٌ':Added, #1: 1	غَيْبَةَ انْتِقَالٍ
u'غِيبَةٌ أهْلٌ':Added, #5: 5	غَيْبَةَ انْقِطَاعٍ
u'غَيْبَةٌ أَوَّلُ':Added, #3: 3	غِيبَةِ أَهْلِ
u'غِيبَةٌ أَوْلِيَاءُ':Added, #3: 3	غَيْبَةِ الْأَوَّلِ
u'غَيْبَةٌ باقَةٌ':Added, #1: 1	غِيبَةُ الْأَوْلِيَاءِ
u'غَيْبَةٌ باقِي':Added, #1: 1	غَيْبَةُ بَاقِيهِ
u'غَيْبَةٌ بَائِعٌ':Added, #1: 1	غَيْبَةُ بَاقِيهِ
u'غَيْبَةٌ بَائِعٌ':Added, #1: 1	غَيْبَةُ بَائِعِ
u'غَيْبَةٌ بَعْضٌ':Added, #4: 4	غَيْبَةِ الْبَائِعِ
u'غَيْبَةٌ بَعْضٌ':Added, #1: 1	غَيْبَةِ بَعْضِ
u'غَيْبَةٌ بَقِيَّةٌ':Added, #1: 1	غَيْبَةَ بَعْضِهِ
u'غَيْبَةٌ بَيِّنَةٌ':Added, #1: 1	غَيْبَةِ الْبَقِيَّةِ
u'غَيْبَةٌ بَيِّنَةٌ':Added, #1: 1	غَيْبَةِ الْبَيِّنَةِ
u'غِيبَةٌ تارِك':Added, #3: 3	غَيْبَةِ بَيِّنَتِهِ
u'غَيْبَةٌ ثَمَنٌ':Added, #1: 1	غِيبَةِ تَارِكِ
u'غَيْبَةٌ حَشَفَةٌ':Added, #1: 1	غَيْبَةِ الثَّمَنِ
u'غَيْبَةٌ خاصّ':Added, #1: 1	غَيْبَةِ حَشَفَةِ
u'غِيبَةٌ خَصْمٌ':Added, #1: 1	غَيْبَةِ الْخَاصِّ
u'غَيْبَةٌ خَصْمٌ':Added, #1: 1	غِيبَةِ خَصْمِهِ
u'غِيبَةٌ ذِمِّيٌّ':Added, #6: 6	غَيْبَةِ الْخَصْمِ
u'غَيْبَةٌ ذِهْنٌ':Added, #1: 1	غِيبَةِ الذِّمِّيِّ
u'غَيْبَةٌ رَاهِنٌ':Added, #1: 1	غَيْبَةَ ذِهْنٍ
u'غَيْبَةٌ رَاهِنٌ':Added, #1: 1	غَيْبَةُ الرَّاهِنِ
u'غَيْبَةٌ رَاهِنٌ':Added, #1: 1	غَيْبَةِ رَاهِنِهِ
u'غِيبَةٌ رَبُّ':Added, #6: 6	غَيْبَةِ الرَّاهِنِ
u'غَيْبَةٌ رَبُّ':Added, #1: 1	غِيبَةِ رَبِّهِ
u'غَيْبَةٌ رَقيقٌ':Added, #1: 1	غَيْبَةِ رَبِّهِ
u'غَيْبَةٌ رَقيق':Added, #1: 1	غَيْبَةُ الرَّقِيقِ
u'غَيْبَةٌ رَهْنٌ':Added, #1: 1	غَيْبَةُ الرَّقِيقِ
u'غَيْبَةٌ زَوْجٌ':Added, #1: 1	غَيْبَةِ الرَّهْنِ
u'غَيْبَةٌ سَفَرٌ':Added, #3: 3	غَيْبَةِ الزَّوْجِ
u'غَيْبَةٌ سَفَرٌ':Added, #1: 1	غَيْبَةُ سَفَرِ
u'غَيْبَةٌ سَيِّدٌ':Added, #3: 3	غَيْبَةَ سَفَرٍ
u'غَيْبَةٌ سَيِّدٌ':Added, #1: 1	غَيْبَةُ سَيِّدِهِ
u'غَيْبَةٌ شَاهِدٌ':Added, #1: 1	غَيْبَةِ سَيِّدِهِ
u'غَيْبَةٌ شركاء':Added, #2: 2	غَيْبَةِ الشَّاهِدِ
u'غَيْبَةٌ شَرِيكٌ':Added, #1: 1	غَيْبَةِ الشُّرَكَاءِ
u'غَيْبَةٌ شَرِيكٌ':Added, #1: 1	غَيْبَةَ شَرِيكِ
u'غَيْبَةٌ شَرِيكٌ':Added, #1: 1	غَيْبَةِ شَرِيكِ
u'غَيْبَةٌ شَرِيكٌ':Added, #2: 2	غَيْبَةِ الشَّرِيكِ
u'غَيْبَةٌ شَفِيعٌ':Added, #4: 4	غَيْبَةِ شَرِيكِهِ
u'غَيْبَةٌ شُهُودٌ':Added, #1: 1	غَيْبَةَ الشَّفِيعِ
u'غَيْبَةٌ شُهُودٌ':Added, #1: 1	غَيْبَةَ الشُّهُودِ
u'غَيْبَةٌ شُهُودٌ':Added, #1: 1	غَيْبَةِ شُهُودِ
u'غَيْبَةٌ صَاحِبٌ':Added, #3: 3	غَيْبَةِ الشُّهُودِ
u'غِيبَةٌ صَبِيٌّ':Added, #12: 12	غَيْبَةِ صَاحِبِهِ
u'غَيْبَةٌ ضَيْفٌ':Added, #1: 1	غِيبَةُ الصَّبِيِّ
u'غِيبَةٌ طَالِبٌ':Added, #2: 2	غَيْبَةِ الضَّيْفِ
u'غَيْبَةٌ طَالِبٌ':Added, #1: 1	غِيبَةِ الطَّالِبِ
u'غَيْبَةٌ طَالِبٌ':Added, #1: 1	غَيْبَةُ الطَّالِبِ
u'غَيْبَةٌ طعام':Added, #4: 4	غَيْبَةِ الطَّالِبِ
u'غَيْبَةٌ طَعَامٌ':Added, #1: 1	غَيْبَةِ الطَّعَامِ
u'غَيْبَةٌ عَاقِلٌ':Added, #1: 1	غَيْبَةِ الطَّعَامِ
u'غِيبَةٌ عَالِمٌ':Added, #1: 1	غَيْبَةِ الْعَاقِلَةِ
u'غَيْبَةٌ عَبْدٌ':Added, #1: 1	غِيبَةَ الْعَالِمِ
u'غَيْبَةٌ عَقْلٌ':Added, #2: 2	غَيْبَةِ الْعَبْدِ
u'غَيْبَةٌ غَائِبٌ':Added, #1: 1	غَيْبَةِ الْعَقْلِ
u'غَيْبَةٌ غرماء':Added, #2: 2	غَيْبَةِ الْغَائِبِ
u'غَيْبَةٌ غَرِيمٌ':Added, #3: 3	غَيْبَةِ الْغُرَمَاءِ
u'غِيبَةٌ فَاسِقٌ':Added, #2: 2	غَيْبَةُ غَرِيمِهِ
u'غَيْبَةٌ كَاتِبٌ':Added, #1: 1	غِيبَةِ الْفَاسِقِ
u'غِيبَةٌ كَافِرٌ':Added, #1: 1	غَيْبَةِ الْكَاتِبِ
u'غِيبَةٌ لِسَانٌ':Added, #1: 1	غِيبَةِ الْكَافِرِ
u'غَيْبَةٌ مَالٌ':Added, #1: 1	غِيبَةِ اللِّسَانِ
u'غَيْبَةٌ مَالٌ':Added, #1: 1	غَيْبَةُ الْمَالِ
u'غَيْبَةٌ مَالٌ':Added, #1: 1	غَيْبَةَ مَالِهِ
u'غَيْبَةٌ مَالٌ':Added, #1: 1	غَيْبَةُ مَالِهِ
u'غَيْبَةٌ مَالٌ':Added, #2: 2	غَيْبَةِ الْمَالِ
u'غَيْبَةٌ مَالِكٌ':Added, #5: 5	غَيْبَةِ مَالِهِ
u'غَيْبَةٌ مَالِكٌ':Added, #11: 11	غَيْبَةِ الْمَالِكِ
u'غَيْبَةٌ مَالِكٌ':Added, #1: 1	غَيْبَةُ الْمَالِكِ
u'غَيْبَةٌ مُحْتَالٌ':Added, #1: 1	غَيْبَةِ مَالِكِهِ
u'غَيْبَةٌ مُخْبِرٌ':Added, #3: 3	غَيْبَةِ الْمُحْتَالِ
u'غَيْبَةٌ مُدَّةٌ':Added, #2: 2	غَيْبَةِ الْمُخْبِرِ
u'غَيْبَةٌ مُرْتَهِنٌ':Added, #1: 1	غَيْبَةُ مُدَّةِ
u'غَيْبَةٌ مُرْتَهِنٌ':Added, #1: 1	غَيْبَةِ الْمُرْتَهِنِ
u'غَيْبَةٌ مُسْتَحِقٌّ':Added, #1: 1	غَيْبَةِ مُرْتَهِنٍ
u'غَيْبَةٌ مَسْرُوقٌ':Added, #2: 2	غَيْبَةِ الْمُسْتَحِقِّ
u'غِيبَةٌ مُسْلِمٌ':Added, #1: 1	غَيْبَةُ الْمَسْرُوقِ
u'غَيْبَةٌ مُسْلِمٌ':Added, #1: 1	غِيبَةِ الْمُسْلِمِ
u'غِيبَةٌ مُسْلِمٌ':Added, #1: 1	غَيْبَةِ الْمُسْلِمِ
u'غَيْبَةٌ مَضْمُونٌ':Added, #2: 2	غِيبَةُ الْمُسْلِمِ
u'غَيْبَةٌ مَطْلُوبٌ':Added, #1: 1	غَيْبَةِ الْمَضْمُونِ
u'غَيْبَةٌ مُغْتاب':Added, #1: 1	غَيْبَةِ الْمَطْلُوبِ
u'غِيبَةٌ مُكَلَّفٌ':Added, #1: 1	غَيْبَةِ الْمُغْتَابِ
u'غِيبَةٌ مُودَعٌ':Added, #1: 1	غِيبَةِ الْمُكَلَّفِ
u'غَيْبَةٌ مُودِعٌ':Added, #1: 1	غِيبَةِ الْمُودَعِ
u'غَيْبَةٌ مُوَكِّلٌ':Added, #5: 5	غَيْبَةِ الْمُودِعِ
u'غَيْبَةٌ مُوَكَّلٌ':Added, #15: 15	غَيْبَةِ الْمُوَكِّلِ
u'غَيْبَةٌ مُوَكِّلٌ':Added, #1: 1	غَيْبَةُ الْمُوَكَّلَيْنِ
u'غَيْبَةٌ مُوَكِّلٌ':Added, #1: 1	غَيْبَةِ مُوَكِّلٍ
u'غَيْبَةٌ وَارِثٌ':Added, #3: 3	غَيْبَةِ مُوَكِّلِهِ
u'غِيبَةٌ وَالِدٌ':Added, #3: 3	غَيْبَةِ الْوَارِثِ
u'غَيْبَةٌ وَرَثَةٌ':Added, #1: 1	غِيبَةِ الْوَالِدِ
u'غَيْبَةٌ وَكِيلٌ':Added, #1: 1	غَيْبَةِ الْوَرَثَةِ
u'غَيْبَةٌ وَلِيٌّ':Added, #4: 4	غَيْبَةِ الْوَكِيلِ
u'غَيْبَةٌ وَلِيٌّ':Added, #1: 1	غَيْبَةِ وَلِيِّ
u'غَيْبَةٌ وَلِيٌّ':Added, #1: 1	غَيْبَةِ وَلِيِّهِ
u'غَيْبَةٌ وَلِيٌّ':Added, #2: 2	غَيْبَةِ وَلِيٍّ
u'غَيْبَةٌ يَسِيرٌ':Added, #9: 9	غَيْبَةِ الْوَلِيِّ
u'غَيَّبَ حَشَفَةٌ':Predicate, #1: 1	غَيْبَةُ الْيَسِيرِ
u'غيب سَمَاواتٌ':Added, #1: 1	غَيَّبَ الْحَشَفَةَ
u'غَيْبٌ سَمَاواتٌ':Added, #1: 1	غَيْبُ السّمَاوَاتِ
u'غيب سموات':Added, #1: 1	غَيْبُ السّمَاوَاتِ
u'غَيْبٌ سموات':Added, #1: 1	غَيْبُ السَّمَوَاتِ
u'غَيَّبَ عَقْلٌ':Predicate, #1: 1	غَيْبُ السَّمَوَاتِ
u'غَيَّبَ كَفِيلٌ':Subject, #6: 6	غَيَّبَ الْعَقْلَ
u'غَيَّبَ مَغْصُوب':Predicate, #1: 1	غَيَّبَ الْكَفِيلُ
u'غَيَّبَ مَوْضُوعٌ':Subject, #1: 1	غَيَّبَ الْمَغْصُوبَ
u'غَيْبُوبَةٌ أحْمَر':Added, #1: 1	غَيَّبَ مَوْضُوعٌ
u'غَيْبُوبَةٌ جَمِيع':Added, #1: 1	غَيْبُوبَةِ الْأَحْمَرِ
u'غَيْبُوبَةٌ حَشَفَةٌ':Added, #1: 1	غَيْبُوبَةِ الْجَمِيعِ
u'غَيْبُوبَةٌ حَشَفَةٌ':Added, #1: 1	غَيْبُوبَةُ الْحَشَفَةِ
u'غَيْبُوبَةٌ شفق':Added, #2: 2	غَيْبُوبَةِ الْحَشَفَةِ
u'غَيْبُوبَةٌ شَفَقٌ':Added, #18: 18	غَيْبُوبَةِ الشَّفَقِ
u'غَيْبُوبَةٌ شفق':Added, #18: 18	غَيْبُوبَةِ الشَّفَقِ
u'غَيْبُوبَةٌ شَفَقٌ':Added, #4: 4	غَيْبُوبَةُ الشَّفَقِ
u'غَيْبُوبَةٌ شمس':Added, #4: 4	غَيْبُوبَةُ الشَّفَقِ
u'غَيْبُوبَةٌ شَمْسٌ':Added, #6: 6	غَيْبُوبَةِ الشَّمْسِ
u'غَيْبُوبَةٌ مِقْدَارٌ':Added, #6: 6	غَيْبُوبَةِ الشَّمْسِ
u'غيب وُجُودٌ':Added, #1: 1	غَيْبُوبَةُ مِقْدَارِ
u'غَيْبٌ وُجُودٌ':Added, #1: 1	غَيْبِ وُجُودِ
u'غَيْثٌ رَبِيعٌ':Added, #1: 1	غَيْبِ وُجُودِ
u'غَيْثٌ سَمَاءٌ':Added, #1: 1	غَيْثُ الرّبِيعِ
u'غَيْثٌ سَمَاءٌ':Added, #1: 1	غَيْثَ السَّمَاءِ
u'غَيْثٌ فَقِيرٌ':Added, #1: 1	غَيْثُ السّمَاءِ
u'غير أَبٌ':Added, #1: 1	غَيْثَ الْفَقِيرِ
u'غَيْرٌ أَبٌ':Added, #21: 21	غَيْرَ الْأَبِ
u'غير أَبٌ':Added, #21: 21	غَيْرَ الْأَبِ
u'غَيْرٌ أَبٌ':Added, #34: 34	غَيْرُ الْأَبِ
u'غير أَبٌ':Added, #34: 34	غَيْرُ الْأَبِ
u'غَيْرٌ أَبٌ':Added, #4: 4	غَيْرُ أَبٍ
u'غير أَبٌ':Added, #4: 4	غَيْرُ أَبٍ
u'غَيْرٌ أَبٌ':Added, #54: 54	غَيْرِ الْأَبِ
u'غير أَبٌ':Added, #54: 54	غَيْرِ الْأَبِ
u'غير أَبٌ':Added, #6: 6	غَيْرَ أَبٍ
u'غَيْرٌ أَبٌ':Added, #6: 6	غَيْرِ أَبٍ
u'غَيْرٌ أَبٌ':Added, #6: 6	غَيْرَ أَبٍ
u'غير آباءٌ':Added, #6: 6	غَيْرِ أَبٍ
u'غَيْرٌ آباءٌ':Added, #1: 1	غَيْرَ الآبَاءِ
u'غير إِبَانَةٌ':Added, #1: 1	غَيْرَ الآبَاءِ
u'غَيْرٌ إِبَانَةٌ':Added, #1: 1	غَيْرِ إبَانَةٍ
u'غير اِبْتِداءٌ':Added, #1: 1	غَيْرِ إبَانَةٍ
u'غَيْرٌ اِبْتِداءٌ':Added, #1: 1	غَيْرِ ابْتِدَاءٍ
u'غير أبْتَر':Added, #1: 1	غَيْرِ ابْتِدَاءٍ
u'غَيْرٌ أبْتَر':Added, #1: 1	غَيْرِ الْأَبْتَرِ
u'غير اِبْتِلاَعٌ':Added, #1: 1	غَيْرِ الْأَبْتَرِ
u'غَيْرٌ اِبْتِلاَعٌ':Added, #1: 1	غَيْرِ ابْتِلَاعٍ
u'غير أبدانٌ':Added, #1: 1	غَيْرِ ابْتِلَاعٍ
u'غَيْرٌ أبدانٌ':Added, #1: 1	غَيْرِ الْأَبَدَانِ
u'غير أبدانٌ':Added, #1: 1	غَيْرِ الْأَبَدَانِ
u'غَيْرٌ أبدانٌ':Added, #3: 3	غَيْرِ الْأَبْدَانِ
u'غير أبَدِيٌّ':Added, #3: 3	غَيْرِ الْأَبْدَانِ
u'غَيْرٌ أبَدِيٌّ':Added, #1: 1	غَيْرُ أَبَدِيٍّ
u'غير إِبْطَالٌ':Added, #1: 1	غَيْرُ أَبَدِيٍّ
u'غَيْرٌ إِبْطَالٌ':Added, #1: 1	غَيْرِ إبْطَالٍ
u'غير إِبْطَالٌ':Added, #1: 1	غَيْرِ إبْطَالٍ
u'غَيْرٌ إِبْطَالٌ':Added, #2: 2	غَيْرِ إبْطَالِ
u'غير إِبِلٌ':Added, #2: 2	غَيْرِ إبْطَالِ
u'غَيْرٌ إِبِلٌ':Added, #1: 1	غَيْرَ إبِلٍ
u'غير إِبِلٌ':Added, #1: 1	غَيْرَ إبِلٍ
u'غَيْرٌ إِبِلٌ':Added, #2: 2	غَيْرِ إبِلٍ
u'غير إِبِلٌ':Added, #2: 2	غَيْرِ إبِلٍ
u'غَيْرٌ إِبِلٌ':Added, #3: 3	غَيْرَ الْإِبِلِ
u'غير إِبِلٌ':Added, #3: 3	غَيْرَ الْإِبِلِ
u'غَيْرٌ إِبِلٌ':Added, #8: 8	غَيْرِ الْإِبِلِ
u'غير اِبْنٌ':Added, #8: 8	غَيْرِ الْإِبِلِ
u'غَيْرٌ اِبْنٌ':Added, #11: 11	غَيْرَ ابْنِ
u'غير اِبْنٌ':Added, #11: 11	غَيْرَ ابْنِ
u'غَيْرٌ اِبْنٌ':Added, #1: 1	غَيْرَ ابْنٍ
u'غير اِبْنٌ':Added, #1: 1	غَيْرَ ابْنٍ
u'غَيْرٌ اِبْنٌ':Added, #1: 1	غَيْرَ ابْنِهِ
u'غير اِبْنٌ':Added, #1: 1	غَيْرَ ابْنِهِ
u'غَيْرٌ اِبْنٌ':Added, #58: 58	غَيْرُ ابْنِ
u'غير اِبْنٌ':Added, #58: 58	غَيْرُ ابْنِ
u'غَيْرٌ اِبْنٌ':Added, #64: 64	غَيْرِ ابْنِ
u'غير اِبْنٌ':Added, #64: 64	غَيْرِ ابْنِ
u'غَيْرٌ اِبْنٌ':Added, #8: 8	غَيْرُ ابْنِهِ
u'غير أَبْنَاءٌ':Added, #8: 8	غَيْرُ ابْنِهِ
u'غَيْرٌ أَبْنَاءٌ':Added, #1: 1	غَيْرِ أَبْنَاءِ
u'غير إِبْهَامٌ':Added, #1: 1	غَيْرِ أَبْنَاءِ
u'غَيْرٌ إِبْهَامٌ':Added, #3: 3	غَيْرَ الْإِبْهَامِ
u'غير إِبْهَامٌ':Added, #3: 3	غَيْرَ الْإِبْهَامِ
u'غَيْرٌ إِبْهَامٌ':Added, #7: 7	غَيْرِ الْإِبْهَامِ
u'غير أَبْوَابٌ':Added, #7: 7	غَيْرِ الْإِبْهَامِ
u'غَيْرٌ أَبْوَابٌ':Added, #1: 1	غَيْرِ أَبْوَابِ
u'غير اِتِّجَارٌ':Added, #1: 1	غَيْرِ أَبْوَابِ
u'غَيْرٌ اِتِّجَارٌ':Added, #1: 1	غَيْرِ اتِّجَارٍ
u'غير اِتِّصَالٌ':Added, #1: 1	غَيْرِ اتِّجَارٍ
u'غَيْرٌ اِتِّصَالٌ':Added, #1: 1	غَيْرِ اتِّصَالِ
u'غير اِتِّصَالٌ':Added, #1: 1	غَيْرِ اتِّصَالِ
u'غَيْرٌ اِتِّصَالٌ':Added, #2: 2	غَيْرِ اتِّصَالٍ
u'غير إِتْعَابٌ':Added, #2: 2	غَيْرِ اتِّصَالٍ
u'غَيْرٌ إِتْعَابٌ':Added, #1: 1	غَيْرِ إتْعَابِ
u'غير اِتِّفَاقٌ':Added, #1: 1	غَيْرِ إتْعَابِ
u'غَيْرٌ اِتِّفَاقٌ':Added, #2: 2	غَيْرِ اتِّفَاقٍ
u'غير إِتْلاَفٌ':Added, #2: 2	غَيْرِ اتِّفَاقٍ
u'غَيْرٌ إِتْلاَفٌ':Added, #1: 1	غَيْرِ إتْلَافِهِ
u'غير إِتْلاَفٌ':Added, #1: 1	غَيْرِ إتْلَافِهِ
u'غَيْرٌ إِتْلاَفٌ':Added, #3: 3	غَيْرِ إتْلَافٍ
u'غير إِتْيانٌ':Added, #3: 3	غَيْرِ إتْلَافٍ
u'غَيْرٌ إِتْيانٌ':Added, #1: 1	غَيْرَ إتْيَانِ
u'غير إِثْبَاتٌ':Added, #1: 1	غَيْرَ إتْيَانِ
u'غَيْرٌ إِثْبَاتٌ':Added, #3: 3	غَيْرِ إثْبَاتِ
u'غير أثَرٌ':Added, #3: 3	غَيْرِ إثْبَاتِ
u'غَيْرٌ أثَرٌ':Added, #1: 1	غَيْرُ أَثَرِ
u'غير أثَرٌ':Added, #1: 1	غَيْرُ أَثَرِ
u'غَيْرٌ أثَرٌ':Added, #2: 2	غَيْرَ الْأَثَرِ
u'غير أثَرٌ':Added, #2: 2	غَيْرَ الْأَثَرِ
u'غير أثَرٌ':Added, #3: 3	غَيْرَ أَثَرِ
u'غَيْرٌ أثَرٌ':Added, #3: 3	غَيْرِ أَثَرٍ
u'غَيْرٌ أثَرٌ':Added, #3: 3	غَيْرَ أَثَرِ
u'غير إِثْمٌ':Added, #3: 3	غَيْرِ أَثَرٍ
u'غَيْرٌ إِثْمٌ':Added, #2: 2	غَيْرَ الْإِثْمِ
u'غير إِثْمٌ':Added, #2: 2	غَيْرَ الْإِثْمِ
u'غَيْرٌ إِثْمٌ':Added, #3: 3	غَيْرِ إثْمٍ
u'غير آثِمٌ':Added, #3: 3	غَيْرِ إثْمٍ
u'غَيْرٌ آثِمٌ':Added, #4: 4	غَيْرَ آثِمٍ
u'غير آثِمٌ':Added, #4: 4	غَيْرَ آثِمٍ
u'غَيْرٌ آثِمٌ':Added, #9: 9	غَيْرُ آثِمٍ
u'غير أَثْمانٌ':Added, #9: 9	غَيْرُ آثِمٍ
u'غَيْرٌ أَثْمانٌ':Added, #5: 5	غَيْرَ الْأَثْمَانِ
u'غير أَثْمانٌ':Added, #5: 5	غَيْرَ الْأَثْمَانِ
u'غَيْرٌ أَثْمانٌ':Added, #7: 7	غَيْرِ الْأَثْمَانِ
u'غير إِجَابَةٌ':Added, #7: 7	غَيْرِ الْأَثْمَانِ
u'غَيْرٌ إِجَابَةٌ':Added, #1: 1	غَيْرَ إجَابَةِ
u'غير إجَارَةٌ':Added, #1: 1	غَيْرَ إجَابَةِ
u'غير إجَارَةٌ':Added, #1: 1	غَيْرِ إجَارَةٍ
u'غَيْرٌ إجَارَةٌ':Added, #1: 1	غَيْرِ إجَارَةِ
u'غَيْرٌ إجَارَةٌ':Added, #1: 1	غَيْرِ إجَارَةٍ
u'غير إجَارَةٌ':Added, #1: 1	غَيْرِ إجَارَةِ
u'غَيْرٌ إجَارَةٌ':Added, #1: 1	غَيْرِ الْإِجَارَةِ
u'غير إجَازَةٌ':Added, #1: 1	غَيْرِ الْإِجَارَةِ
u'غير إجَازَةٌ':Added, #9: 9	غَيْرِ إجَازَةٍ
u'غَيْرٌ إجَازَةٌ':Added, #9: 9	غَيْرِ إجَازَةِ
u'غَيْرٌ إجَازَةٌ':Added, #9: 9	غَيْرِ إجَازَةٍ
u'غير أجَانِبُ':Added, #9: 9	غَيْرِ إجَازَةِ
u'غَيْرٌ أجَانِبُ':Added, #1: 1	غَيْرُ الْأَجَانِبِ
u'غير أجَانِبُ':Added, #1: 1	غَيْرُ الْأَجَانِبِ
u'غَيْرٌ أجَانِبُ':Added, #2: 2	غَيْرِ الْأَجَانِبِ
u'غير إِجْبَارٌ':Added, #2: 2	غَيْرِ الْأَجَانِبِ
u'غَيْرٌ إِجْبَارٌ':Added, #1: 1	غَيْرِ إجْبَارٍ
u'غير اِجْتِمَاعٌ':Added, #1: 1	غَيْرِ إجْبَارٍ
u'غَيْرٌ اِجْتِمَاعٌ':Added, #1: 1	غَيْرِ اجْتِمَاعٍ
u'غير اِجْتِهَادٌ':Added, #1: 1	غَيْرِ اجْتِمَاعٍ
u'غَيْرٌ اِجْتِهَادٌ':Added, #9: 9	غَيْرِ اجْتِهَادٍ
u'غير أَجْرٌ':Added, #9: 9	غَيْرِ اجْتِهَادٍ
u'غَيْرٌ أَجْرٌ':Added, #1: 1	غَيْرَ الْأَجْرِ
u'غير أَجْرٌ':Added, #1: 1	غَيْرَ الْأَجْرِ
u'غَيْرٌ أَجْرٌ':Added, #3: 3	غَيْرِ أَجْرٍ
u'غير أُجْرَةٌ':Added, #3: 3	غَيْرِ أَجْرٍ
u'غير أُجْرَةٌ':Added, #1: 1	غَيْرَ أُجْرَةِ
u'غَيْرٌ أُجْرَةٌ':Added, #1: 1	غَيْرِ أُجْرَةِ
u'غَيْرٌ أُجْرَةٌ':Added, #1: 1	غَيْرَ أُجْرَةِ
u'غير أُجْرَةٌ':Added, #1: 1	غَيْرِ أُجْرَةِ
u'غَيْرٌ أُجْرَةٌ':Added, #2: 2	غَيْرُ أُجْرَةِ
u'غير أُجْرَةٌ':Added, #2: 2	غَيْرُ أُجْرَةِ
u'غَيْرٌ أُجْرَةٌ':Added, #3: 3	غَيْرِ الْأُجْرَةِ
u'غير أُجْرَةٌ':Added, #3: 3	غَيْرِ الْأُجْرَةِ
u'غَيْرٌ أُجْرَةٌ':Added, #6: 6	غَيْرِ أُجْرَةٍ
u'غير آجِلٌ':Added, #6: 6	غَيْرِ أُجْرَةٍ
u'غَيْرٌ آجِلٌ':Added, #1: 1	غَيْرَ آجِلِ
u'غير آجِلٌ':Added, #1: 1	غَيْرَ آجِلِ
u'غَيْرٌ آجِلٌ':Added, #3: 3	غَيْرَ آجِلٍ
u'غير أَجَلٌ':Added, #3: 3	غَيْرَ آجِلٍ
u'غَيْرٌ أَجَلٌ':Added, #4: 4	غَيْرِ أَجَلٍ
u'غير إِجْمَاعٌ':Added, #4: 4	غَيْرِ أَجَلٍ
u'غير إِجْمَاعٌ':Added, #1: 1	غَيْرَ إجْمَاعٍ
u'غير إِجْمَاعٌ':Added, #1: 1	غَيْرُ إجْمَاعٍ
u'غير إِجْمَاعٌ':Added, #1: 1	غَيْرِ إجْمَاعٍ
u'غَيْرٌ إِجْمَاعٌ':Added, #1: 1	غَيْرِ إجْمَاعِ
u'غَيْرٌ إِجْمَاعٌ':Added, #1: 1	غَيْرَ إجْمَاعٍ
u'غَيْرٌ إِجْمَاعٌ':Added, #1: 1	غَيْرُ إجْمَاعٍ
u'غَيْرٌ إِجْمَاعٌ':Added, #1: 1	غَيْرِ إجْمَاعٍ
u'غير إِجْمَاعٌ':Added, #1: 1	غَيْرِ إجْمَاعِ
u'غَيْرٌ إِجْمَاعٌ':Added, #1: 1	غَيْرِ الْإِجْمَاعِ
u'غير إِجْمَاعٌ':Added, #1: 1	غَيْرِ الْإِجْمَاعِ
u'غَيْرٌ إِجْمَاعٌ':Added, #2: 2	غَيْرَ إجْمَاعِ
u'غير إِجْمَالٌ':Added, #2: 2	غَيْرَ إجْمَاعِ
u'غَيْرٌ إِجْمَالٌ':Added, #1: 1	غَيْرُ الْإِجْمَالِ
u'غير أَجْنَبِيٌّ':Added, #1: 1	غَيْرُ الْإِجْمَالِ
u'غَيْرٌ أَجْنَبِيٌّ':Added, #2: 2	غَيْرُ أَجْنَبِيٍّ
u'غير إِجْهَازٌ':Added, #2: 2	غَيْرُ أَجْنَبِيٍّ
u'غَيْرٌ إِجْهَازٌ':Added, #1: 1	غَيْرِ إِجْهَازِ
u'غير أَجِيرٌ':Added, #1: 1	غَيْرِ إِجْهَازِ
u'غَيْرٌ أَجِيرٌ':Added, #2: 2	غَيْرِ الْأَجِيرِ
u'غير إحَاطَةٌ':Added, #2: 2	غَيْرِ الْأَجِيرِ
u'غَيْرٌ إحَاطَةٌ':Added, #1: 1	غَيْرِ إِحَاطَةٍ
u'غير إحَاطَةٌ':Added, #1: 1	غَيْرِ إِحَاطَةٍ
u'غَيْرٌ إحَاطَةٌ':Added, #2: 2	غَيْرِ إحَاطَةٍ
u'غير إِحْبَالٌ':Added, #2: 2	غَيْرِ إحَاطَةٍ
u'غَيْرٌ إِحْبَالٌ':Added, #2: 2	غَيْرِ إحْبَالٍ
u'غير اِحْتِذَاءٌ':Added, #2: 2	غَيْرِ إحْبَالٍ
u'غَيْرٌ اِحْتِذَاءٌ':Added, #1: 1	غَيْرِ احْتِذَاءِ
u'غير اِحْتِسابٌ':Added, #1: 1	غَيْرِ احْتِذَاءِ
u'غَيْرٌ اِحْتِسابٌ':Added, #1: 1	غَيْرُ احْتِسَابِ
u'غير اِحْتِلاَمٌ':Added, #1: 1	غَيْرُ احْتِسَابِ
u'غَيْرٌ اِحْتِلاَمٌ':Added, #2: 2	غَيْرِ احْتِلاَمٍ
u'غير اِحْتِلاَمٌ':Added, #2: 2	غَيْرِ احْتِلاَمٍ
u'غَيْرٌ اِحْتِلاَمٌ':Added, #6: 6	غَيْرِ احْتِلَامٍ
u'غير اِحْتِمَالٌ':Added, #6: 6	غَيْرِ احْتِلَامٍ
u'غَيْرٌ اِحْتِمَالٌ':Added, #1: 1	غَيْرُ احْتِمَالِ
u'غير اِحْتِمَالٌ':Added, #1: 1	غَيْرُ احْتِمَالِ
u'غَيْرٌ اِحْتِمَالٌ':Added, #2: 2	غَيْرِ احْتِمَالِ
u'غير اِحْتِيَاجٌ':Added, #2: 2	غَيْرِ احْتِمَالِ
u'غير اِحْتِيَاجٌ':Added, #1: 1	غَيْر احْتِيَاجٍ
u'غَيْرٌ اِحْتِيَاجٌ':Added, #1: 1	غَيْرِ احْتِيَاجِ
u'غَيْرٌ اِحْتِيَاجٌ':Added, #1: 1	غَيْر احْتِيَاجٍ
u'غير اِحْتِيَاجٌ':Added, #1: 1	غَيْرِ احْتِيَاجِ
u'غَيْرٌ اِحْتِيَاجٌ':Added, #35: 35	غَيْرِ احْتِيَاجٍ
u'غير اِحْتِيَاطٌ':Added, #35: 35	غَيْرِ احْتِيَاجٍ
u'غَيْرٌ اِحْتِيَاطٌ':Added, #2: 2	غَيْرِ احْتِيَاطٍ
u'غَيَّرَ أحَدٌ':Predicate, #2: 2	غَيْرِ احْتِيَاطٍ
u'غير أحَدٌ':Added, #5: 5	غَيَّرَ أَحَدَ
u'غير أحَدٌ':Added, #1: 1	غَيْرَ أَحَدِ
u'غَيْرٌ أحَدٌ':Added, #1: 1	غَيْرُ أَحَدِ
u'غَيْرٌ أحَدٌ':Added, #1: 1	غَيْرَ أَحَدِ
u'غير أحَدٌ':Added, #1: 1	غَيْرُ أَحَدِ
u'غَيْرٌ أحَدٌ':Added, #1: 1	غَيْرِ الْأَحَدِ
u'غير إِحْدَاثٌ':Added, #1: 1	غَيْرِ الْأَحَدِ
u'غَيْرٌ إِحْدَاثٌ':Added, #1: 1	غَيْرِ إحْدَاثِ
u'غير إِحْرَازٌ':Added, #1: 1	غَيْرِ إحْدَاثِ
u'غَيْرٌ إِحْرَازٌ':Added, #1: 1	غَيْرَ إحْرَازٍ
u'غير إِحْرَامٌ':Added, #1: 1	غَيْرَ إحْرَازٍ
u'غَيْرٌ إِحْرَامٌ':Added, #12: 12	غَيْرِ الْإِحْرَامِ
u'غير إِحْرَامٌ':Added, #12: 12	غَيْرِ الْإِحْرَامِ
u'غير إِحْرَامٌ':Added, #1: 1	غَيْر إحْرَامٍ
u'غَيْرٌ إِحْرَامٌ':Added, #1: 1	غَيْرُ إحْرَامِ
u'غَيْرٌ إِحْرَامٌ':Added, #1: 1	غَيْر إحْرَامٍ
u'غير إِحْرَامٌ':Added, #1: 1	غَيْرُ إحْرَامِ
u'غَيْرٌ إِحْرَامٌ':Added, #2: 2	غَيْرُ الْإِحْرَامِ
u'غير إِحْرَامٌ':Added, #2: 2	غَيْرُ الْإِحْرَامِ
u'غَيْرٌ إِحْرَامٌ':Added, #3: 3	غَيْرَ الْإِحْرَامِ
u'غير إِحْرَامٌ':Added, #3: 3	غَيْرَ الْإِحْرَامِ
u'غَيْرٌ إِحْرَامٌ':Added, #9: 9	غَيْرِ إحْرَامٍ
u'غير إحْضَارٌ':Added, #9: 9	غَيْرِ إحْرَامٍ
u'غَيْرٌ إحْضَارٌ':Added, #1: 1	غَيْرِ إحْضَارٍ
u'غير إحْضَارٌ':Added, #1: 1	غَيْرِ إحْضَارٍ
u'غَيْرٌ إحْضَارٌ':Added, #3: 3	غَيْرِ إحْضَارِ
u'غَيَّرَ أَحْكَامٌ':Predicate, #3: 3	غَيْرِ إحْضَارِ
u'غير أَحْكَامٌ':Added, #1: 1	غَيَّرَ الْأَحْكَامَ
u'غَيْرٌ أَحْكَامٌ':Added, #1: 1	غَيْرُ الْأَحْكَامِ
u'غير أَحْكَامٌ':Added, #1: 1	غَيْرُ الْأَحْكَامِ
u'غَيْرٌ أَحْكَامٌ':Added, #2: 2	غَيْرَ أَحْكَامِ
u'غير أَحْكَامٌ':Added, #2: 2	غَيْرَ أَحْكَامِ
u'غَيْرٌ أَحْكَامٌ':Added, #3: 3	غَيْرِ أَحْكَامِ
u'غير أَحْكَامٌ':Added, #3: 3	غَيْرِ أَحْكَامِ
u'غَيْرٌ أَحْكَامٌ':Added, #3: 3	غَيْرِ الْأَحْكَامِ
u'غير إِحْيَاءٌ':Added, #3: 3	غَيْرِ الْأَحْكَامِ
u'غَيْرٌ إِحْيَاءٌ':Added, #2: 2	غَيْرِ الْإِحْيَاءِ
u'غير أَحْيَاءٌ':Added, #2: 2	غَيْرِ الْإِحْيَاءِ
u'غَيْرٌ أَحْيَاءٌ':Added, #4: 4	غَيْرُ أَحْيَاءٍ
u'غير أَخٌ':Added, #4: 4	غَيْرُ أَحْيَاءٍ
u'غَيْرٌ أَخٌ':Added, #1: 1	غَيْرِ أَخٍ
u'غير أخْبَارٌ':Added, #1: 1	غَيْرِ أَخٍ
u'غير أَخْبَارٌ':Added, #1: 1	غَيْرَ أَخْبَارِ
u'غَيْرٌ أخْبَارٌ':Added, #1: 1	غَيْرَ أَخْبَارِ
u'غَيْرٌ أَخْبَارٌ':Added, #1: 1	غَيْرَ أَخْبَارِ
u'غير أخْبَارٌ':Added, #1: 1	غَيْرَ أَخْبَارِ
u'غير أَخْبَارٌ':Added, #1: 1	غَيْرِ الْأَخْبَارِ
u'غَيْرٌ أخْبَارٌ':Added, #1: 1	غَيْرِ الْأَخْبَارِ
u'غَيْرٌ أَخْبَارٌ':Added, #1: 1	غَيْرِ الْأَخْبَارِ
u'غير إِخْبَارٌ':Added, #1: 1	غَيْرِ الْأَخْبَارِ
u'غَيْرٌ إِخْبَارٌ':Added, #3: 3	غَيْرِ إخْبَارِ
u'غير أُخْتٌ':Added, #3: 3	غَيْرِ إخْبَارِ
u'غَيْرٌ أُخْتٌ':Added, #1: 1	غَيْرُ الْأُخْتِ
u'غير أُخْتٌ':Added, #1: 1	غَيْرُ الْأُخْتِ
u'غَيْرٌ أُخْتٌ':Added, #1: 1	غَيْرِ الْأُخْتَيْنِ
u'غير اِخْتِصَاصٌ':Added, #1: 1	غَيْرِ الْأُخْتَيْنِ
u'غَيْرٌ اِخْتِصَاصٌ':Added, #3: 3	غَيْرِ اخْتِصَاصٍ
u'غير اِخْتِلاَءٌ':Added, #3: 3	غَيْرِ اخْتِصَاصٍ
u'غَيْرٌ اِخْتِلاَءٌ':Added, #1: 1	غَيْرِ اخْتِلَاءٍ
u'غير اِخْتِلاطٌ':Added, #1: 1	غَيْرِ اخْتِلَاءٍ
u'غير اِخْتِلاطٌ':Added, #1: 1	غَيْرِ اخْتِلَاطٍ
u'غَيْرٌ اِخْتِلاطٌ':Added, #1: 1	غَيْرِ اخْتِلَاطِ
u'غَيْرٌ اِخْتِلاطٌ':Added, #1: 1	غَيْرِ اخْتِلَاطٍ
u'غير اِخْتِلاَفٌ':Added, #1: 1	غَيْرِ اخْتِلَاطِ
u'غَيْرٌ اِخْتِلاَفٌ':Added, #2: 2	غَيْرِ اخْتِلَافٍ
u'غير اِخْتِلاَفٌ':Added, #2: 2	غَيْرِ اخْتِلَافٍ
u'غَيْرٌ اِخْتِلاَفٌ':Added, #3: 3	غَيْرِ اخْتِلَافِ
u'غير اِخْتِلالٌ':Added, #3: 3	غَيْرِ اخْتِلَافِ
u'غَيْرٌ اِخْتِلالٌ':Added, #1: 1	غَيْرِ اخْتِلَالٍ
u'غير اِخْتِيَارٌ':Added, #1: 1	غَيْرِ اخْتِلَالٍ
u'غَيْرٌ اِخْتِيَارٌ':Added, #13: 13	غَيْرِ اخْتِيَارٍ
u'غير اِخْتِيَارٌ':Added, #13: 13	غَيْرِ اخْتِيَارٍ
u'غَيْرٌ اِخْتِيَارٌ':Added, #1: 1	غَيْرَ اخْتِيَارٍ
u'غير اِخْتِيَارٌ':Added, #1: 1	غَيْرَ اخْتِيَارٍ
u'غَيْرٌ اِخْتِيَارٌ':Added, #3: 3	غَيْرِ اخْتِيَارِ
u'غير اِخْتِيَارٌ':Added, #3: 3	غَيْرِ اخْتِيَارِ
u'غَيْرٌ اِخْتِيَارٌ':Added, #9: 9	غَيْرِ اخْتِيَارِهِ
u'غير اِخْتِيَارِيٌّ':Added, #9: 9	غَيْرِ اخْتِيَارِهِ
u'غير اِخْتِيَارِيٌّ':Added, #1: 1	غَيْرَ اخْتِيَارِيٍّ
u'غَيْرٌ اِخْتِيَارِيٌّ':Added, #1: 1	غَيْرُ اخْتِيَارِيٍّ
u'غَيْرٌ اِخْتِيَارِيٌّ':Added, #1: 1	غَيْرَ اخْتِيَارِيٍّ
u'غير اِخْتِيَارِيٌّ':Added, #1: 1	غَيْرُ اخْتِيَارِيٍّ
u'غَيْرٌ اِخْتِيَارِيٌّ':Added, #1: 1	غَيْرُ اخْتِيَارِيَّةٍ
u'غير اِخْتِيَارِيٌّ':Added, #1: 1	غَيْرُ اخْتِيَارِيَّةٍ
u'غَيْرٌ اِخْتِيَارِيٌّ':Added, #2: 2	غَيْرِ اخْتِيَارِيٍّ
u'غير أُخْدُودٌ':Added, #2: 2	غَيْرِ اخْتِيَارِيٍّ
u'غير أُخْدُود':Added, #1: 1	غَيْرِ أُخْدُودٍ
u'غَيْرٌ أُخْدُودٌ':Added, #1: 1	غَيْرِ أُخْدُودٍ
u'غَيْرٌ أُخْدُود':Added, #1: 1	غَيْرِ أُخْدُودٍ
u'غير أخْذٌ':Added, #1: 1	غَيْرِ أُخْدُودٍ
u'غَيْرٌ أخْذٌ':Added, #1: 1	غَيْرِ أَخْذِ
u'غير أخْذٌ':Added, #1: 1	غَيْرِ أَخْذِ
u'غَيْرٌ أخْذٌ':Added, #3: 3	غَيْرِ أَخْذٍ
u'غير آخِرُ':Added, #3: 3	غَيْرِ أَخْذٍ
u'غَيْرٌ آخِرُ':Added, #1: 1	غَيْرِ آخِرِ
u'غير آخِرُ':Added, #1: 1	غَيْرِ آخِرِ
u'غير آخِرُ':Added, #2: 2	غَيْرَ الْآخِرِ
u'غَيْرٌ آخِرُ':Added, #2: 2	غَيْرِ الْآخِرِ
u'غَيْرٌ آخِرُ':Added, #2: 2	غَيْرَ الْآخِرِ
u'غير إِخْرَاجٌ':Added, #2: 2	غَيْرِ الْآخِرِ
u'غَيْرٌ إِخْرَاجٌ':Added, #3: 3	غَيْرِ إخْرَاجِ
u'غير إِخْرَاجٌ':Added, #3: 3	غَيْرِ إخْرَاجِ
u'غير إِخْرَاجٌ':Added, #4: 4	غَيْرَ إخْرَاجٍ
u'غَيْرٌ إِخْرَاجٌ':Added, #4: 4	غَيْرِ إخْرَاجٍ
u'غَيْرٌ إِخْرَاجٌ':Added, #4: 4	غَيْرَ إخْرَاجٍ
u'غير إِخْرَاجٌ':Added, #4: 4	غَيْرِ إخْرَاجٍ
u'غَيْرٌ إِخْرَاجٌ':Added, #7: 7	غَيْرَ إِخْرَاجٍ
u'غير آخِرَةٌ':Added, #7: 7	غَيْرَ إِخْرَاجٍ
u'غَيْرٌ آخِرَةٌ':Added, #1: 1	غَيْرُ الْآخِرَةِ
u'غير أخرَس':Added, #1: 1	غَيْرُ الْآخِرَةِ
u'غَيْرٌ أخرَس':Added, #1: 1	غَيْرَ الْأَخْرَسِ
u'غير إِخْطَارٌ':Added, #1: 1	غَيْرَ الْأَخْرَسِ
u'غَيْرٌ إِخْطَارٌ':Added, #1: 1	غَيْرِ إخْطَارِهِ
u'غير إِخْفَاءٌ':Added, #1: 1	غَيْرِ إخْطَارِهِ
u'غَيْرٌ إِخْفَاءٌ':Added, #1: 1	غَيْرُ الْإِخْفَاءِ
u'غير إِخْلالٌ':Added, #1: 1	غَيْرُ الْإِخْفَاءِ
u'غَيْرٌ إِخْلالٌ':Added, #1: 1	غَيْرِ إِخْلَالٍ
u'غير إِخْلالٌ':Added, #1: 1	غَيْرِ إِخْلَالٍ
u'غَيْرٌ إِخْلالٌ':Added, #3: 3	غَيْرِ إخْلَالٍ
u'غير إِخْوَةٌ':Added, #3: 3	غَيْرِ إخْلَالٍ
u'غَيْرٌ إِخْوَةٌ':Added, #2: 2	غَيْرِ الْإِخْوَةِ
u'غير إِخْوَةٌ':Added, #2: 2	غَيْرِ الْإِخْوَةِ
u'غَيْرٌ إِخْوَةٌ':Added, #4: 4	غَيْرُ الْإِخْوَةِ
u'غير أَخِيرٌ':Added, #4: 4	غَيْرُ الْإِخْوَةِ
u'غَيْرٌ أَخِيرٌ':Added, #1: 1	غَيْرَ الْأَخِيرِ
u'غير أَخِيرٌ':Added, #1: 1	غَيْرَ الْأَخِيرِ
u'غَيْرٌ أَخِيرٌ':Added, #23: 23	غَيْرِ الْأَخِيرَةِ
u'غير أَخِيرٌ':Added, #23: 23	غَيْرِ الْأَخِيرَةِ
u'غَيْرٌ أَخِيرٌ':Added, #2: 2	غَيْرِ الْأَخِيرَتَيْنِ
u'غير أَخِيرٌ':Added, #2: 2	غَيْرِ الْأَخِيرَتَيْنِ
u'غَيْرٌ أَخِيرٌ':Added, #2: 2	غَيْرِ الْأَخِيرَيْنِ
u'غير أَخِيرٌ':Added, #2: 2	غَيْرِ الْأَخِيرَيْنِ
u'غَيْرٌ أَخِيرٌ':Added, #5: 5	غَيْرِ الْأَخِيرِ
u'غير أَدَاءٌ':Added, #5: 5	غَيْرِ الْأَخِيرِ
u'غَيْرٌ أَدَاءٌ':Added, #2: 2	غَيْرِ أَدَاءٍ
u'غير أَدَاءٌ':Added, #2: 2	غَيْرِ أَدَاءٍ
u'غَيْرٌ أَدَاءٌ':Added, #3: 3	غَيْرِ أَدَاءِ
u'غير إِدَارَةٌ':Added, #3: 3	غَيْرِ أَدَاءِ
u'غَيْرٌ إِدَارَةٌ':Added, #1: 1	غَيْرِ الْإِدَارَةِ
u'غير إِدَارَةٌ':Added, #1: 1	غَيْرِ الْإِدَارَةِ
u'غَيْرٌ إِدَارَةٌ':Added, #2: 2	غَيْرِ إدَارَةٍ
u'غير إِدَارَةٌ':Added, #2: 2	غَيْرِ إدَارَةٍ
u'غَيْرٌ إِدَارَةٌ':Added, #2: 2	غَيْرِ إدَارَتِهِ
u'غير إِدَامٌ':Added, #2: 2	غَيْرِ إدَارَتِهِ
u'غَيْرٌ إِدَامٌ':Added, #2: 2	غَيْرِ إدَامٍ
u'غير أدَب':Added, #2: 2	غَيْرِ إدَامٍ
u'غَيْرٌ أدَب':Added, #1: 1	غَيْرِ أَدَبٍ
u'غير أدَب':Added, #1: 1	غَيْرِ أَدَبٍ
u'غَيْرٌ أدَب':Added, #1: 1	غَيْرُ الْأَدَبِ
u'غير أدْبَارٌ':Added, #1: 1	غَيْرُ الْأَدَبِ
u'غير أَدْبَارٌ':Added, #1: 1	غَيْرِ أَدْبَارِ
u'غَيْرٌ أدْبَارٌ':Added, #1: 1	غَيْرِ أَدْبَارِ
u'غَيْرٌ أَدْبَارٌ':Added, #1: 1	غَيْرِ أَدْبَارِ
u'غير إدْخَالٌ':Added, #1: 1	غَيْرِ أَدْبَارِ
u'غَيْرٌ إدْخَالٌ':Added, #1: 1	غَيْرُ الْإِدْخَالِ
u'غير إدْخَالٌ':Added, #1: 1	غَيْرُ الْإِدْخَالِ
u'غَيْرٌ إدْخَالٌ':Added, #2: 2	غَيْرِ إدْخَالٍ
u'غير إدْخَالٌ':Added, #2: 2	غَيْرِ إدْخَالٍ
u'غَيْرٌ إدْخَالٌ':Added, #8: 8	غَيْرِ إدْخَالِ
u'غير اِدِّعَاءٌ':Added, #8: 8	غَيْرِ إدْخَالِ
u'غَيْرٌ اِدِّعَاءٌ':Added, #1: 1	غَيْرِ ادِّعَاءِ
u'غير إِدْمَانٌ':Added, #1: 1	غَيْرِ ادِّعَاءِ
u'غَيْرٌ إِدْمَانٌ':Added, #1: 1	غَيْرِ إدْمَانٍ
u'غير آدَمِيٌّ':Added, #1: 1	غَيْرِ إدْمَانٍ
u'غَيْرٌ آدَمِيٌّ':Added, #11: 11	غَيْرَ آدَمِيٍّ
u'غير آدَمِيٌّ':Added, #11: 11	غَيْرَ آدَمِيٍّ
u'غَيْرٌ آدَمِيٌّ':Added, #14: 14	غَيْرِ آدَمِيٍّ
u'غير آدَمِيٌّ':Added, #14: 14	غَيْرِ آدَمِيٍّ
u'غَيْرٌ آدَمِيٌّ':Added, #1: 1	غَيْرُ آدَمِيٍّ
u'غير آدَمِيٌّ':Added, #1: 1	غَيْرُ آدَمِيٍّ
u'غَيْرٌ آدَمِيٌّ':Added, #1: 1	غَيْرِ الْآدَمِيَّاتِ
u'غير آدَمِيٌّ':Added, #1: 1	غَيْرِ الْآدَمِيَّاتِ
u'غَيْرٌ آدَمِيٌّ':Added, #1: 1	غَيْرَ الْآدَمِيَّةِ
u'غير آدَمِيٌّ':Added, #1: 1	غَيْرَ الْآدَمِيَّةِ
u'غَيْرٌ آدَمِيٌّ':Added, #21: 21	غَيْرِ الْآدَمِيِّ
u'غير آدَمِيٌّ':Added, #21: 21	غَيْرِ الْآدَمِيِّ
u'غير آدَمِيٌّ':Added, #4: 4	غَيْرَ الْآدَمِيِّ
u'غَيْرٌ آدَمِيٌّ':Added, #4: 4	غَيْرُ الْآدَمِيِّ
u'غَيْرٌ آدَمِيٌّ':Added, #4: 4	غَيْرَ الْآدَمِيِّ
u'غير أَذَانٌ':Added, #4: 4	غَيْرُ الْآدَمِيِّ
u'غَيْرٌ أَذَانٌ':Added, #1: 1	غَيْرَ أَذَانٍ
u'غير أَذَانٌ':Added, #1: 1	غَيْرَ أَذَانٍ
u'غَيْرٌ أَذَانٌ':Added, #1: 1	غَيْرِ الْأَذَانِ
u'غير أَذَانٌ':Added, #1: 1	غَيْرِ الْأَذَانِ
u'غير أَذَانٌ':Added, #2: 2	غَيْرُ أَذَانِ
u'غير أَذَانٌ':Added, #2: 2	غَيْرِ أَذَانٍ
u'غَيْرٌ أَذَانٌ':Added, #2: 2	غَيْرِ أَذَانِ
u'غَيْرٌ أَذَانٌ':Added, #2: 2	غَيْرُ أَذَانِ
u'غَيْرٌ أَذَانٌ':Added, #2: 2	غَيْرِ أَذَانٍ
u'غير إِذْعَانٌ':Added, #2: 2	غَيْرِ أَذَانِ
u'غَيْرٌ إِذْعَانٌ':Added, #1: 1	غَيْرِ إذْعَانٍ
u'غير إِذْنٌ':Added, #1: 1	غَيْرِ إذْعَانٍ
u'غَيْرٌ إِذْنٌ':Added, #22: 22	غَيْرِ إذْنِهِ
u'غير إِذْنٌ':Added, #22: 22	غَيْرِ إذْنِهِ
u'غَيْرٌ إِذْنٌ':Added, #34: 34	غَيْرِ إذْنٍ
u'غير إِذْنٌ':Added, #34: 34	غَيْرِ إذْنٍ
u'غَيْرٌ إِذْنٌ':Added, #53: 53	غَيْرِ إذْنِ
u'غير إِرَادَةٌ':Added, #53: 53	غَيْرِ إذْنِ
u'غير إِرَادَةٌ':Added, #1: 1	غَيْرُ إرَادَةِ
u'غَيْرٌ إِرَادَةٌ':Added, #1: 1	غَيْرِ إرَادَةٍ
u'غَيْرٌ إِرَادَةٌ':Added, #1: 1	غَيْرُ إرَادَةِ
u'غير إِرَادَةٌ':Added, #1: 1	غَيْرِ إرَادَةٍ
u'غَيْرٌ إِرَادَةٌ':Added, #1: 1	غَيْرُ الْإِرَادَةِ
u'غير إِرَادَةٌ':Added, #1: 1	غَيْرُ الْإِرَادَةِ
u'غَيْرٌ إِرَادَةٌ':Added, #7: 7	غَيْرِ إرَادَةِ
u'غير إِرَاقَةٌ':Added, #7: 7	غَيْرِ إرَادَةِ
u'غَيْرٌ إِرَاقَةٌ':Added, #1: 1	غَيْرِ إرَاقَةٍ
u'غير أَرَاكٌ':Added, #1: 1	غَيْرِ إرَاقَةٍ
u'غَيْرٌ أَرَاكٌ':Added, #1: 1	غَيْرِ الْأَرَاكِ
u'غير أَرْبَعُ':Added, #1: 1	غَيْرِ الْأَرَاكِ
u'غَيْرٌ أَرْبَعُ':Added, #2: 2	غَيْرَ أَرْبَعِ
u'غير أَرْبَعَةٌ':Added, #2: 2	غَيْرَ أَرْبَعِ
u'غير أَرْبَعَةٌ':Added, #1: 1	غَيْرُ أَرْبَعَةٍ
u'غَيْرٌ أَرْبَعَةٌ':Added, #1: 1	غَيْرِ أَرْبَعَةٍ
u'غَيْرٌ أَرْبَعَةٌ':Added, #1: 1	غَيْرُ أَرْبَعَةٍ
u'غير أَرْبَعَةٌ':Added, #1: 1	غَيْرِ أَرْبَعَةٍ
u'غَيْرٌ أَرْبَعَةٌ':Added, #2: 2	غَيْرَ أَرْبَعَةٍ
u'غير أَرْبَعَةٌ':Added, #2: 2	غَيْرَ أَرْبَعَةٍ
u'غَيْرٌ أَرْبَعَةٌ':Added, #2: 2	غَيْرُ الْأَرْبَعَةِ
u'غير أَرْبَعَةٌ':Added, #2: 2	غَيْرُ الْأَرْبَعَةِ
u'غَيْرٌ أَرْبَعَةٌ':Added, #6: 6	غَيْرِ الْأَرْبَعَةِ
u'غير اِرْتِبَاطٌ':Added, #6: 6	غَيْرِ الْأَرْبَعَةِ
u'غَيْرٌ اِرْتِبَاطٌ':Added, #1: 1	غَيْرِ ارْتِبَاطٍ
u'غير اِرْتِكَابٌ':Added, #1: 1	غَيْرِ ارْتِبَاطٍ
u'غير اِرْتِكَابٌ':Added, #1: 1	غَيْر ارْتِكَابِ
u'غَيْرٌ اِرْتِكَابٌ':Added, #1: 1	غَيْرِ ارْتِكَابٍ
u'غَيْرٌ اِرْتِكَابٌ':Added, #1: 1	غَيْر ارْتِكَابِ
u'غير اِرْتِكَابٌ':Added, #1: 1	غَيْرِ ارْتِكَابٍ
u'غَيْرٌ اِرْتِكَابٌ':Added, #6: 6	غَيْرِ ارْتِكَابِ
u'غير إِرْثٌ':Added, #6: 6	غَيْرِ ارْتِكَابِ
u'غَيْرٌ إِرْثٌ':Added, #1: 1	غَيْرِ إرْثٍ
u'غير إِرْثٌ':Added, #1: 1	غَيْرِ إرْثٍ
u'غَيْرٌ إِرْثٌ':Added, #1: 1	غَيْرَ الْإِرْثِ
u'غير إِرْثٌ':Added, #1: 1	غَيْرَ الْإِرْثِ
u'غَيْرٌ إِرْثٌ':Added, #2: 2	غَيْرِ الْإِرْثِ
u'غير أَرْحَامٌ':Added, #2: 2	غَيْرِ الْإِرْثِ
u'غَيْرٌ أَرْحَامٌ':Added, #2: 2	غَيْرِ أَرْحَامٍ
u'غير إِرْسَالٌ':Added, #2: 2	غَيْرِ أَرْحَامٍ
u'غَيْرٌ إِرْسَالٌ':Added, #1: 1	غَيْرِ إرْسَالِ
u'غير إِرْسَالٌ':Added, #1: 1	غَيْرِ إرْسَالِ
u'غَيْرٌ إِرْسَالٌ':Added, #1: 1	غَيْرِ إرْسَالِهِ
u'غير إِرْسَالٌ':Added, #1: 1	غَيْرِ إرْسَالِهِ
u'غَيْرٌ إِرْسَالٌ':Added, #3: 3	غَيْرِ إرْسَالٍ
u'غير أرْضٌ':Added, #3: 3	غَيْرِ إرْسَالٍ
u'غير أرْضٌ':Added, #1: 1	غَيْرُ أَرْضِ
u'غَيْرٌ أرْضٌ':Added, #1: 1	غَيْرِ أَرْضِ
u'غَيْرٌ أرْضٌ':Added, #1: 1	غَيْرُ أَرْضِ
u'غير أرْضٌ':Added, #1: 1	غَيْرِ أَرْضِ
u'غير أرْضٌ':Added, #1: 1	غَيْرَ الأَرْضِ
u'غَيْرٌ أرْضٌ':Added, #1: 1	غَيْرُ الْأَرْضِ
u'غَيْرٌ أرْضٌ':Added, #1: 1	غَيْرَ الأَرْضِ
u'غير أرْضٌ':Added, #1: 1	غَيْرُ الْأَرْضِ
u'غَيْرٌ أرْضٌ':Added, #2: 2	غَيْرَ أَرْضِ
u'غير أرْضٌ':Added, #2: 2	غَيْرَ أَرْضِ
u'غَيْرٌ أرْضٌ':Added, #2: 2	غَيْرِ أَرْضِهِ
u'غير أرْضٌ':Added, #2: 2	غَيْرِ أَرْضِهِ
u'غَيْرٌ أرْضٌ':Added, #3: 3	غَيْرِ الْأَرْضِ
u'غير أرْضٌ':Added, #3: 3	غَيْرِ الْأَرْضِ
u'غَيْرٌ أرْضٌ':Added, #4: 4	غَيْرِ أَرْضٍ
u'غير أرْضٌ':Added, #4: 4	غَيْرِ أَرْضٍ
u'غَيْرٌ أرْضٌ':Added, #5: 5	غَيْرَ الْأَرْضِ
u'غير إِرْضاءٌ':Added, #5: 5	غَيْرَ الْأَرْضِ
u'غَيْرٌ إِرْضاءٌ':Added, #1: 1	غَيْرِ إرْضَاءٍ
u'غير إِرْضاعٌ':Added, #1: 1	غَيْرِ إرْضَاءٍ
u'غَيْرٌ إِرْضاعٌ':Added, #2: 2	غَيْرِ إرْضَاعٍ
u'غير إِرْوَاءٌ':Added, #2: 2	غَيْرِ إرْضَاعٍ
u'غَيْرٌ إِرْوَاءٌ':Added, #1: 1	غَيْرُ الْإِرْوَاءِ
u'غير إِزَارٌ':Added, #1: 1	غَيْرُ الْإِرْوَاءِ
u'غَيْرٌ إِزَارٌ':Added, #1: 1	غَيْرُ الْإِزَارِ
u'غير إِزَارٌ':Added, #1: 1	غَيْرُ الْإِزَارِ
u'غَيْرٌ إِزَارٌ':Added, #3: 3	غَيْرِ إزَارٍ
u'غير إِزَالَةٌ':Added, #3: 3	غَيْرِ إزَارٍ
u'غير إِزَالَةٌ':Added, #1: 1	غَيْرِ إزَالَةٍ
u'غَيْرٌ إِزَالَةٌ':Added, #1: 1	غَيْرِ إزَالَةِ
u'غَيْرٌ إِزَالَةٌ':Added, #1: 1	غَيْرِ إزَالَةٍ
u'غير إِزَالَةٌ':Added, #1: 1	غَيْرِ إزَالَةِ
u'غَيْرٌ إِزَالَةٌ':Added, #1: 1	غَيْرِ إزَالَتِهِ
u'غير اِزْدِرادٌ':Added, #1: 1	غَيْرِ إزَالَتِهِ
u'غَيْرٌ اِزْدِرادٌ':Added, #1: 1	غَيْرِ ازْدِرَادٍ
u'غير أَزْواجٌ':Added, #1: 1	غَيْرِ ازْدِرَادٍ
u'غَيْرٌ أَزْواجٌ':Added, #1: 1	غَيْرَ الأَزْوَاجِ
u'غير أُسٌّ':Added, #1: 1	غَيْرَ الأَزْوَاجِ
u'غير أُسٌّ':Added, #1: 1	غَيْرِ أُسٍّ
u'غَيْرٌ أُسٌّ':Added, #1: 1	غَيْرِ أُسِّ
u'غَيْرٌ أُسٌّ':Added, #1: 1	غَيْرِ أُسٍّ
u'غير آس':Added, #1: 1	غَيْرِ أُسِّ
u'غَيْرٌ آس':Added, #1: 1	غَيْرُ الْآسِ
u'غير إِسَاءةٌ':Added, #1: 1	غَيْرُ الْآسِ
u'غَيْرٌ إِسَاءةٌ':Added, #1: 1	غَيْرُ الْإِسَاءَةِ
u'غير إِسَاءةٌ':Added, #1: 1	غَيْرُ الْإِسَاءَةِ
u'غَيْرٌ إِسَاءةٌ':Added, #2: 2	غَيْرِ إسَاءَةٍ
u'غير أسَاسٌ':Added, #2: 2	غَيْرِ إسَاءَةٍ
u'غير أَسَاسٌ':Added, #1: 1	غَيْرِ أَسَاسٍ
u'غَيْرٌ أسَاسٌ':Added, #1: 1	غَيْرِ أَسَاسٍ
u'غَيْرٌ أَسَاسٌ':Added, #1: 1	غَيْرِ أَسَاسٍ
u'غير أَسالِيبُ':Added, #1: 1	غَيْرِ أَسَاسٍ
u'غَيْرٌ أَسالِيبُ':Added, #1: 1	غَيْرِ أَسَالِيبِ
u'غير اِسْتِبْراء':Added, #1: 1	غَيْرِ أَسَالِيبِ
u'غَيْرٌ اِسْتِبْراء':Added, #6: 6	غَيْرِ اسْتِبْرَاءٍ
u'غير اِسْتِثْنَاءٌ':Added, #6: 6	غَيْرِ اسْتِبْرَاءٍ
u'غَيْرٌ اِسْتِثْنَاءٌ':Added, #12: 12	غَيْرِ اسْتِثْنَاءٍ
u'غير اِسْتِثْنَاءٌ':Added, #12: 12	غَيْرِ اسْتِثْنَاءٍ
u'غَيْرٌ اِسْتِثْنَاءٌ':Added, #2: 2	غَيْرِ اسْتِثْنَاءِ
u'غير اِسْتِحَالَةٌ':Added, #2: 2	غَيْرِ اسْتِثْنَاءِ
u'غَيْرٌ اِسْتِحَالَةٌ':Added, #1: 1	غَيْرِ اسْتِحَالَةٍ
u'غير اِسْتِحْضَارٌ':Added, #1: 1	غَيْرِ اسْتِحَالَةٍ
u'غَيْرٌ اِسْتِحْضَارٌ':Added, #2: 2	غَيْرِ اسْتِحْضَارِ
u'غير اِسْتِحْقَاقٌ':Added, #2: 2	غَيْرِ اسْتِحْضَارِ
u'غَيْرٌ اِسْتِحْقَاقٌ':Added, #2: 2	غَيْرِ اسْتِحْقَاقٍ
u'غير اِسْتِحْقَاقٌ':Added, #2: 2	غَيْرِ اسْتِحْقَاقٍ
u'غَيْرٌ اِسْتِحْقَاقٌ':Added, #3: 3	غَيْرِ اسْتِحْقَاقِ
u'غير اِسْتِحْيَاءٌ':Added, #3: 3	غَيْرِ اسْتِحْقَاقِ
u'غَيْرٌ اِسْتِحْيَاءٌ':Added, #1: 1	غَيْرِ اسْتِحْيَاءٍ
u'غير اِسْتِخْبَارٌ':Added, #1: 1	غَيْرِ اسْتِحْيَاءٍ
u'غَيْرٌ اِسْتِخْبَارٌ':Added, #1: 1	غَيْرِ اسْتِخْبَارٍ
u'غير اِسْتِدْعَاءٌ':Added, #1: 1	غَيْرِ اسْتِخْبَارٍ
u'غَيْرٌ اِسْتِدْعَاءٌ':Added, #2: 2	غَيْرِ اسْتِدْعَاءٍ
u'غير اِسْتِدْلاَلٌ':Added, #2: 2	غَيْرِ اسْتِدْعَاءٍ
u'غَيْرٌ اِسْتِدْلاَلٌ':Added, #3: 3	غَيْرِ اسْتِدْلَالٍ
u'غير اِسْتِرْجَاعٌ':Added, #3: 3	غَيْرِ اسْتِدْلَالٍ
u'غَيْرٌ اِسْتِرْجَاعٌ':Added, #1: 1	غَيْرَ اسْتِرْجَاعِهِ
u'غير اِسْتِرْدَادٌ':Added, #1: 1	غَيْرَ اسْتِرْجَاعِهِ
u'غَيْرٌ اِسْتِرْدَادٌ':Added, #1: 1	غَيْرِ اسْتِرْدَادٍ
u'غير اِسْتِشْرَافٌ':Added, #1: 1	غَيْرِ اسْتِرْدَادٍ
u'غَيْرٌ اِسْتِشْرَافٌ':Added, #4: 4	غَيْرِ اسْتِشْرَافٍ
u'غير اِسْتِشْعَارٌ':Added, #4: 4	غَيْرِ اسْتِشْرَافٍ
u'غَيْرٌ اِسْتِشْعَارٌ':Added, #1: 1	غَيْرِ اسْتِشْعَارِ
u'غير اِسْتِشْهَادٌ':Added, #1: 1	غَيْرِ اسْتِشْعَارِ
u'غَيْرٌ اِسْتِشْهَادٌ':Added, #2: 2	غَيْرِ اسْتِشْهَادِ
u'غير اِسْتِطالَةٌ':Added, #2: 2	غَيْرِ اسْتِشْهَادِ
u'غَيْرٌ اِسْتِطالَةٌ':Added, #1: 1	غَيْرِ اسْتِطَالَةٍ
u'غير اِسْتِطْلاعٌ':Added, #1: 1	غَيْرِ اسْتِطَالَةٍ
u'غَيْرٌ اِسْتِطْلاعٌ':Added, #6: 6	غَيْرِ اسْتِطْلَاعِ
u'غير اِسْتِعانَةٌ':Added, #6: 6	غَيْرِ اسْتِطْلَاعِ
u'غَيْرٌ اِسْتِعانَةٌ':Added, #1: 1	غَيْرِ اسْتِعَانَةٍ
u'غير اِسْتِعْدَادٌ':Added, #1: 1	غَيْرِ اسْتِعَانَةٍ
u'غَيْرٌ اِسْتِعْدَادٌ':Added, #2: 2	غَيْرِ اسْتِعْدَادٍ
u'غير اِسْتِعْمالٌ':Added, #2: 2	غَيْرِ اسْتِعْدَادٍ
u'غَيْرٌ اِسْتِعْمالٌ':Added, #1: 1	غَيْرِ اسْتِعْمَالِ
u'غير اِسْتِعْمالٌ':Added, #1: 1	غَيْرِ اسْتِعْمَالِ
u'غَيْرٌ اِسْتِعْمالٌ':Added, #1: 1	غَيْرُ اسْتِعْمَالِهِ
u'غير اِسْتِفْتاحٌ':Added, #1: 1	غَيْرُ اسْتِعْمَالِهِ
u'غَيْرٌ اِسْتِفْتاحٌ':Added, #1: 1	غَيْرِ اسْتِفْتَاحٍ
u'غير اِسْتِفْسارٌ':Added, #1: 1	غَيْرِ اسْتِفْتَاحٍ
u'غَيْرٌ اِسْتِفْسارٌ':Added, #1: 1	غَيْرِ اسْتِفْسَارٍ
u'غير اِسْتِقْبالٌ':Added, #1: 1	غَيْرِ اسْتِفْسَارٍ
u'غَيْرٌ اِسْتِقْبالٌ':Added, #1: 1	غَيْرِ اسْتِقْبَالِ
u'غير اِسْتِقْرارٌ':Added, #1: 1	غَيْرِ اسْتِقْبَالِ
u'غَيْرٌ اِسْتِقْرارٌ':Added, #2: 2	غَيْرِ اسْتِقْرَارٍ
u'غير اِسْتِقْصاءٌ':Added, #2: 2	غَيْرِ اسْتِقْرَارٍ
u'غَيْرٌ اِسْتِقْصاءٌ':Added, #2: 2	غَيْرِ اسْتِقْصَاءٍ
u'غير اِسْتِقْلالٌ':Added, #2: 2	غَيْرِ اسْتِقْصَاءٍ
u'غَيْرٌ اِسْتِقْلالٌ':Added, #2: 2	غَيْرِ اسْتِقْلَالٍ
u'غير اِسْتِلامٌ':Added, #2: 2	غَيْرِ اسْتِقْلَالٍ
u'غَيْرٌ اِسْتِلامٌ':Added, #1: 1	غَيْرِ اسْتِلَامٍ
u'غير اِسْتِلْقاءٌ':Added, #1: 1	غَيْرِ اسْتِلَامٍ
u'غَيْرٌ اِسْتِلْقاءٌ':Added, #1: 1	غَيْرِ اسْتِلْقَاءٍ
u'غير اِسْتِمْساك':Added, #1: 1	غَيْرِ اسْتِلْقَاءٍ
u'غَيْرٌ اِسْتِمْساك':Added, #1: 1	غَيْرِ اسْتِمْسَاكٍ
u'غير اِسْتِمْهالٌ':Added, #1: 1	غَيْرِ اسْتِمْسَاكٍ
u'غَيْرٌ اِسْتِمْهالٌ':Added, #1: 1	غَيْرِ اسْتِمْهَالٍ
u'غير اِسْتِنابَة':Added, #1: 1	غَيْرِ اسْتِمْهَالٍ
u'غَيْرٌ اِسْتِنابَة':Added, #1: 1	غَيْرِ اسْتِنَابَةٍ
u'غير اِسْتِناد':Added, #1: 1	غَيْرِ اسْتِنَابَةٍ
u'غَيْرٌ اِسْتِناد':Added, #5: 5	غَيْرِ اسْتِنَادٍ
u'غير اِسْتِهْزاء':Added, #5: 5	غَيْرِ اسْتِنَادٍ
u'غَيْرٌ اِسْتِهْزاء':Added, #2: 2	غَيْرِ اسْتِهْزَاءٍ
u'غير اِسْتِهْلاكٌ':Added, #2: 2	غَيْرِ اسْتِهْزَاءٍ
u'غَيْرٌ اِسْتِهْلاكٌ':Added, #2: 2	غَيْرِ اسْتِهْلَاكٍ
u'غير اِسْتِئْثَارٌ':Added, #2: 2	غَيْرِ اسْتِهْلَاكٍ
u'غَيْرٌ اِسْتِئْثَارٌ':Added, #1: 1	غَيْرِ اسْتِئْثَارِ
u'غير اِسْتِئْجَارٌ':Added, #1: 1	غَيْرِ اسْتِئْثَارِ
u'غَيْرٌ اِسْتِئْجَارٌ':Added, #1: 1	غَيْرِ اسْتِئْجَارٍ
u'غير اِسْتِئْذَان':Added, #1: 1	غَيْرِ اسْتِئْجَارٍ
u'غَيْرٌ اِسْتِئْذَان':Added, #37: 37	غَيْرِ اسْتِئْذَانٍ
u'غير اِسْتيفاءٌ':Added, #37: 37	غَيْرِ اسْتِئْذَانٍ
u'غَيْرٌ اِسْتيفاءٌ':Added, #2: 2	غَيْرِ اسْتِيفَاءٍ
u'غير اِسْتيلاءٌ':Added, #2: 2	غَيْرِ اسْتِيفَاءٍ
u'غَيْرٌ اِسْتيلاءٌ':Added, #1: 1	غَيْرِ اسْتِيلَاءٍ
u'غير أَسَدٌ':Added, #1: 1	غَيْرِ اسْتِيلَاءٍ
u'غَيْرٌ أَسَدٌ':Added, #1: 1	غَيْرَ أَسَدٍ
u'غير أَسَدٌ':Added, #1: 1	غَيْرَ أَسَدٍ
u'غَيْرٌ أَسَدٌ':Added, #1: 1	غَيْرُ الْأَسَدِ
u'غير إِسْرافٌ':Added, #1: 1	غَيْرُ الْأَسَدِ
u'غَيْرٌ إِسْرافٌ':Added, #16: 16	غَيْرِ إسْرَافٍ
u'غير إِسْقاطٌ':Added, #16: 16	غَيْرِ إسْرَافٍ
u'غَيْرٌ إِسْقاطٌ':Added, #3: 3	غَيْرِ إسْقَاطِ
u'غير إِسْكارٌ':Added, #3: 3	غَيْرِ إسْقَاطِ
u'غَيْرٌ إِسْكارٌ':Added, #1: 1	غَيْرِ الْإِسْكَارِ
u'غير إِسْكانٌ':Added, #1: 1	غَيْرِ الْإِسْكَارِ
u'غَيْرٌ إِسْكانٌ':Added, #1: 1	غَيْرِ إسْكَانٍ
u'غير إِسْلامٌ':Added, #1: 1	غَيْرِ إسْكَانٍ
u'غَيْرٌ إِسْلامٌ':Added, #16: 16	غَيْرِ الْإِسْلَامِ
u'غير إِسْلامٌ':Added, #16: 16	غَيْرِ الْإِسْلَامِ
u'غير إِسْلامٌ':Added, #1: 1	غَيْرَ الإِسْلامِ
u'غير إِسْلامٌ':Added, #1: 1	غَيْرَ الإِسْلاَمِ
u'غَيْرٌ إِسْلامٌ':Added, #1: 1	غَيْرُ الْإِسْلَامِ
u'غَيْرٌ إِسْلامٌ':Added, #1: 1	غَيْرَ الإِسْلامِ
u'غَيْرٌ إِسْلامٌ':Added, #1: 1	غَيْرَ الإِسْلاَمِ
u'غير إِسْلامٌ':Added, #1: 1	غَيْرُ الْإِسْلَامِ
u'غَيْرٌ إِسْلامٌ':Added, #4: 4	غَيْرِ الإِسْلاَمِ
u'غير إِسْلامٌ':Added, #4: 4	غَيْرِ الإِسْلاَمِ
u'غَيْرٌ إِسْلامٌ':Added, #5: 5	غَيْرَ الْإِسْلَامِ
u'غَيَّرَ اِسْمٌ':Predicate, #5: 5	غَيْرَ الْإِسْلَامِ
u'غير اِسْمٌ':Added, #3: 3	غَيَّرَ اسْمَ
u'غير اِسْمٌ':Added, #3: 3	غَيْرَ اسْمِ
u'غَيْرٌ اِسْمٌ':Added, #3: 3	غَيْرِ اسْمِ
u'غَيْرٌ اِسْمٌ':Added, #3: 3	غَيْرَ اسْمِ
u'غير اِسْمٌ':Added, #3: 3	غَيْرِ اسْمِ
u'غَيْرٌ اِسْمٌ':Added, #5: 5	غَيْرُ اسْمِ
u'غير آسِنٌ':Added, #5: 5	غَيْرُ اسْمِ
u'غَيْرٌ آسِنٌ':Added, #3: 3	غَيْرِ آسِنٍ
u'غير إِسْنادٌ':Added, #3: 3	غَيْرِ آسِنٍ
u'غَيْرٌ إِسْنادٌ':Added, #1: 1	غَيْرِ إسْنَادِ
u'غير إِسْنادٌ':Added, #1: 1	غَيْرِ إسْنَادِ
u'غَيْرٌ إِسْنادٌ':Added, #2: 2	غَيْرِ إسْنَادٍ
u'غير أَسْواقٌ':Added, #2: 2	غَيْرِ إسْنَادٍ
u'غَيْرٌ أَسْواقٌ':Added, #1: 1	غَيْرِ الْأَسْوَاقِ
u'غير أسْوَد':Added, #1: 1	غَيْرِ الْأَسْوَاقِ
u'غَيْرٌ أسْوَد':Added, #1: 1	غَيْرِ الأَسْوَدِ
u'غير إشارَة':Added, #1: 1	غَيْرِ الأَسْوَدِ
u'غَيْرٌ إشارَة':Added, #1: 1	غَيْرِ إشَارَتِهِ
u'غير إشارَة':Added, #1: 1	غَيْرِ إشَارَتِهِ
u'غَيْرٌ إشارَة':Added, #4: 4	غَيْرِ إشَارَةٍ
u'غير إشاعَةٌ':Added, #4: 4	غَيْرِ إشَارَةٍ
u'غَيْرٌ إشاعَةٌ':Added, #1: 1	غَيْرِ إشَاعَةِ
u'غير إِشْباعٌ':Added, #1: 1	غَيْرِ إشَاعَةِ
u'غَيْرٌ إِشْباعٌ':Added, #1: 1	غَيْرِ إشْبَاعٍ
u'غير اِشْتِراطٌ':Added, #1: 1	غَيْرِ إشْبَاعٍ
u'غَيْرٌ اِشْتِراطٌ':Added, #1: 1	غَيْرَ اشْتِرَاطِ
u'غير اِشْتِراطٌ':Added, #1: 1	غَيْرَ اشْتِرَاطِ
u'غَيْرٌ اِشْتِراطٌ':Added, #30: 30	غَيْرِ اشْتِرَاطِ
u'غير اِشْتِراكٌ':Added, #30: 30	غَيْرِ اشْتِرَاطِ
u'غَيْرٌ اِشْتِراكٌ':Added, #6: 6	غَيْرِ اشْتِرَاكٍ
u'غير اِشْتِغالٌ':Added, #6: 6	غَيْرِ اشْتِرَاكٍ
u'غَيْرٌ اِشْتِغالٌ':Added, #1: 1	غَيْرِ اشْتِغَالِ
u'غير اِشْتِغالٌ':Added, #1: 1	غَيْرِ اشْتِغَالِ
u'غَيْرٌ اِشْتِغالٌ':Added, #3: 3	غَيْرِ اشْتِغَالٍ
u'غير اِشْتِقاقٌ':Added, #3: 3	غَيْرِ اشْتِغَالٍ
u'غَيْرٌ اِشْتِقاقٌ':Added, #1: 1	غَيْرِ اشْتِقَاقٍ
u'غير اِشْتِمالٌ':Added, #1: 1	غَيْرِ اشْتِقَاقٍ
u'غَيْرٌ اِشْتِمالٌ':Added, #1: 1	غَيْرِ اشْتِمَالِهِ
u'غير أَشْرِبَةٌ':Added, #1: 1	غَيْرِ اشْتِمَالِهِ
u'غَيْرٌ أَشْرِبَةٌ':Added, #4: 4	غَيْرِ الْأَشْرِبَةِ
u'غير إِشْعارٌ':Added, #4: 4	غَيْرِ الْأَشْرِبَةِ
u'غَيْرٌ إِشْعارٌ':Added, #1: 1	غَيْرِ إِشْعَارٍ
u'غير أَشْعَارٌ':Added, #1: 1	غَيْرِ إِشْعَارٍ
u'غَيْرٌ أَشْعَارٌ':Added, #1: 1	غَيْرِ الْأَشْعَارِ
u'غير إِشْعارٌ':Added, #1: 1	غَيْرِ الْأَشْعَارِ
u'غَيْرٌ إِشْعارٌ':Added, #2: 2	غَيْرِ إشْعَارٍ
u'غير إِشْكالٌ':Added, #2: 2	غَيْرِ إشْعَارٍ
u'غَيْرٌ إِشْكالٌ':Added, #1: 1	غَيْرِ إشْكَالٍ
u'غير إِشْكالٌ':Added, #1: 1	غَيْرِ إشْكَالٍ
u'غَيْرٌ إِشْكالٌ':Added, #4: 4	غَيْرِ إِشْكَالٍ
u'غير أَشْهُرٌ':Added, #4: 4	غَيْرِ إِشْكَالٍ
u'غَيْرٌ أَشْهُرٌ':Added, #16: 16	غَيْرِ أَشْهُرِهِ
u'غير أَشْهُرٌ':Added, #16: 16	غَيْرِ أَشْهُرِهِ
u'غَيْرٌ أَشْهُرٌ':Added, #3: 3	غَيْرِ الْأَشْهُرِ
u'غير أَشْهُرٌ':Added, #3: 3	غَيْرِ الْأَشْهُرِ
u'غَيْرٌ أَشْهُرٌ':Added, #40: 40	غَيْرِ أَشْهُرِ
u'غير أَشْيَاءٌ':Added, #40: 40	غَيْرِ أَشْهُرِ
u'غَيْرٌ أَشْيَاءٌ':Added, #2: 2	غَيْرِ الْأَشْيَاءِ
u'غير إصابَةٌ':Added, #2: 2	غَيْرِ الْأَشْيَاءِ
u'غَيْرٌ إصابَةٌ':Added, #1: 1	غَيْرَ إصَابَتِهِ
u'غير إصابَةٌ':Added, #1: 1	غَيْرَ إصَابَتِهِ
u'غَيْرٌ إصابَةٌ':Added, #2: 2	غَيْرِ إصَابَةِ
u'غير أُصْبُعٌ':Added, #2: 2	غَيْرِ إصَابَةِ
u'غَيْرٌ أُصْبُعٌ':Added, #2: 2	غَيْرِ الْأُصْبُعِ
u'غير أَصْحَابٌ':Added, #2: 2	غَيْرِ الْأُصْبُعِ
u'غير أَصْحَابٌ':Added, #1: 1	غَيْر أَصْحَابِ
u'غير أَصْحَابٌ':Added, #1: 1	غَيْرَ أَصْحَابِ
u'غَيْرٌ أَصْحَابٌ':Added, #1: 1	غَيْرُ أَصْحَابِ
u'غَيْرٌ أَصْحَابٌ':Added, #1: 1	غَيْر أَصْحَابِ
u'غَيْرٌ أَصْحَابٌ':Added, #1: 1	غَيْرَ أَصْحَابِ
u'غير أَصْحَابٌ':Added, #1: 1	غَيْرُ أَصْحَابِ
u'غَيْرٌ أَصْحَابٌ':Added, #2: 2	غَيْرِ أَصْحَابِ
u'غير إِصْرارٌ':Added, #2: 2	غَيْرِ أَصْحَابِ
u'غَيْرٌ إِصْرارٌ':Added, #3: 3	غَيْرِ إصْرَارٍ
u'غير اِصْطِلاحٌ':Added, #3: 3	غَيْرِ إصْرَارٍ
u'غَيْرٌ اِصْطِلاحٌ':Added, #1: 1	غَيْرِ اصْطِلَاحِ
u'غير اِصْطِيادٌ':Added, #1: 1	غَيْرِ اصْطِلَاحِ
u'غَيْرٌ اِصْطِيادٌ':Added, #3: 3	غَيْرِ اصْطِيَادٍ
u'غير أصْغَرٌ':Added, #3: 3	غَيْرِ اصْطِيَادٍ
u'غير أَصْغَرُ':Added, #1: 1	غَيْرَ الْأَصْغَرِ
u'غَيْرٌ أصْغَرٌ':Added, #1: 1	غَيْرَ الْأَصْغَرِ
u'غَيْرٌ أَصْغَرُ':Added, #1: 1	غَيْرَ الْأَصْغَرِ
u'غير أًصْلٌ':Added, #1: 1	غَيْرَ الْأَصْغَرِ
u'غَيْرٌ أًصْلٌ':Added, #15: 15	غَيْرِ أَصْلٍ
u'غير أصل':Added, #15: 15	غَيْرِ أَصْلٍ
u'غير أًصْلٌ':Added, #1: 1	غَيْرَ أَصْلِ
u'غَيْرٌ أصل':Added, #1: 1	غَيْرَ أَصْلِ
u'غَيْرٌ أًصْلٌ':Added, #1: 1	غَيْرَ أَصْلِ
u'غير أصل':Added, #1: 1	غَيْرَ أَصْلِ
u'غير أًصْلٌ':Added, #2: 2	غَيْرُ الْأَصْلِ
u'غَيْرٌ أصل':Added, #2: 2	غَيْرُ الْأَصْلِ
u'غَيْرٌ أًصْلٌ':Added, #2: 2	غَيْرُ الْأَصْلِ
u'غير أًصْلٌ':Added, #2: 2	غَيْرُ الْأَصْلِ
u'غَيْرٌ أًصْلٌ':Added, #3: 3	غَيْرَ أَصْلٍ
u'غير أصل':Added, #3: 3	غَيْرَ أَصْلٍ
u'غير أًصْلٌ':Added, #5: 5	غَيْرِ أَصْلِهِ
u'غَيْرٌ أصل':Added, #5: 5	غَيْرِ أَصْلِهِ
u'غَيْرٌ أًصْلٌ':Added, #5: 5	غَيْرِ أَصْلِهِ
u'غير أصل':Added, #5: 5	غَيْرِ أَصْلِهِ
u'غير أًصْلٌ':Added, #8: 8	غَيْرِ أَصْلِ
u'غَيْرٌ أصل':Added, #8: 8	غَيْرِ أَصْلِ
u'غَيْرٌ أًصْلٌ':Added, #8: 8	غَيْرِ أَصْلِ
u'غير أصل':Added, #8: 8	غَيْرِ أَصْلِ
u'غير أًصْلٌ':Added, #8: 8	غَيْرِ الْأَصْلِ
u'غَيْرٌ أصل':Added, #8: 8	غَيْرِ الْأَصْلِ
u'غَيْرٌ أًصْلٌ':Added, #8: 8	غَيْرِ الْأَصْلِ
u'غير إِصْلاحٌ':Added, #8: 8	غَيْرِ الْأَصْلِ
u'غَيْرٌ إِصْلاحٌ':Added, #1: 1	غَيْرَ الْإِصْلَاحِ
u'غير أَصْلَحُ':Added, #1: 1	غَيْرَ الْإِصْلَاحِ
u'غَيْرٌ أَصْلَحُ':Added, #1: 1	غَيْرَ الْأَصْلَحِ
u'غير أَصْلِيٌّ':Added, #1: 1	غَيْرَ الْأَصْلَحِ
u'غَيْرٌ أَصْلِيٌّ':Added, #1: 1	غَيْرُ أَصْلِيٍّ
u'غير أَصْلِيٌّ':Added, #1: 1	غَيْرُ أَصْلِيٍّ
u'غَيْرٌ أَصْلِيٌّ':Added, #1: 1	غَيْرُ أَصْلِيَّةٍ
u'غير أَصْلِيٌّ':Added, #1: 1	غَيْرُ أَصْلِيَّةٍ
u'غَيْرٌ أَصْلِيٌّ':Added, #2: 2	غَيْرِ أَصْلِيٍّ
u'غير أَصْلِيٌّ':Added, #2: 2	غَيْرِ أَصْلِيٍّ
u'غَيْرٌ أَصْلِيٌّ':Added, #3: 3	غَيْرَ أَصْلِيٍّ
u'غير أَصْنَافٌ':Added, #3: 3	غَيْرَ أَصْلِيٍّ
u'غير أَصْنَافٌ':Added, #1: 1	غَيْرُ الْأَصْنَافِ
u'غَيْرٌ أَصْنَافٌ':Added, #1: 1	غَيْرِ الْأَصْنَافِ
u'غَيْرٌ أَصْنَافٌ':Added, #1: 1	غَيْرُ الْأَصْنَافِ
u'غير أُصولٌ':Added, #1: 1	غَيْرِ الْأَصْنَافِ
u'غَيْرٌ أُصولٌ':Added, #1: 1	غَيْرِ أُصُولِهِ
u'غير أُصولٌ':Added, #1: 1	غَيْرِ أُصُولِهِ
u'غَيْرٌ أُصولٌ':Added, #1: 1	غَيْرُ الْأُصُولِ
u'غير أُصولٌ':Added, #1: 1	غَيْرُ الْأُصُولِ
u'غَيْرٌ أُصولٌ':Added, #2: 2	غَيْرِ أُصُولِ
u'غير أُصولٌ':Added, #2: 2	غَيْرِ أُصُولِ
u'غَيْرٌ أُصولٌ':Added, #8: 8	غَيْرِ الْأُصُولِ
u'غير أَصيلٌ':Added, #8: 8	غَيْرِ الْأُصُولِ
u'غَيْرٌ أَصيلٌ':Added, #2: 2	غَيْرُ الْأَصِيلِ
u'غير إضافَةٌ':Added, #2: 2	غَيْرُ الْأَصِيلِ
u'غَيْرٌ إضافَةٌ':Added, #1: 1	غَيْرِ إضَافَةِ
u'غير إضافَةٌ':Added, #1: 1	غَيْرِ إضَافَةِ
u'غَيْرٌ إضافَةٌ':Added, #3: 3	غَيْرِ الْإِضَافَةِ
u'غير إضافَةٌ':Added, #3: 3	غَيْرِ الْإِضَافَةِ
u'غَيْرٌ إضافَةٌ':Added, #6: 6	غَيْرِ إضَافَةٍ
u'غير اِضْطِرارٌ':Added, #6: 6	غَيْرِ إضَافَةٍ
u'غَيْرٌ اِضْطِرارٌ':Added, #4: 4	غَيْرِ اضْطِرَارٍ
u'غير اِطِّرادٌ':Added, #4: 4	غَيْرِ اضْطِرَارٍ
u'غَيْرٌ اِطِّرادٌ':Added, #1: 1	غَيْرِ اطِّرَادٍ
u'غير إِطْعامٌ':Added, #1: 1	غَيْرِ اطِّرَادٍ
u'غَيْرٌ إِطْعامٌ':Added, #1: 1	غَيْرِ إطْعَامٍ
u'غير إِطْعامٌ':Added, #1: 1	غَيْرِ إطْعَامٍ
u'غَيْرٌ إِطْعامٌ':Added, #1: 1	غَيْرِ الْإِطْعَامِ
u'غير اِطِّلاعٌ':Added, #1: 1	غَيْرِ الْإِطْعَامِ
u'غَيْرٌ اِطِّلاعٌ':Added, #1: 1	غَيْرِ اطِّلَاعِ
u'غير اِطِّلاعٌ':Added, #1: 1	غَيْرِ اطِّلَاعِ
u'غَيْرٌ اِطِّلاعٌ':Added, #1: 1	غَيْرِ اطِّلَاعِهِ
u'غير اِطِّلاعٌ':Added, #1: 1	غَيْرِ اطِّلَاعِهِ
u'غَيْرٌ اِطِّلاعٌ':Added, #2: 2	غَيْرِ اطِّلَاعٍ
u'غير إِطْلاقٌ':Added, #2: 2	غَيْرِ اطِّلَاعٍ
u'غَيْرٌ إِطْلاقٌ':Added, #1: 1	غَيْرِ إطْلَاقِ
u'غير إِطْلاقٌ':Added, #1: 1	غَيْرِ إطْلَاقِ
u'غَيْرٌ إِطْلاقٌ':Added, #1: 1	غَيْرِ إطْلَاقِهِ
u'غير إِظْهارٌ':Added, #1: 1	غَيْرِ إطْلَاقِهِ
u'غَيْرٌ إِظْهارٌ':Added, #1: 1	غَيْرِ إظْهَارِ
u'غير إِعادَةٌ':Added, #1: 1	غَيْرِ إظْهَارِ
u'غَيْرٌ إِعادَةٌ':Added, #6: 6	غَيْرِ إعَادَةٍ
u'غير إِعادَةٌ':Added, #6: 6	غَيْرِ إعَادَةٍ
u'غَيْرٌ إِعادَةٌ':Added, #8: 8	غَيْرِ إعَادَةِ
u'غير إِعْتاقٌ':Added, #8: 8	غَيْرِ إعَادَةِ
u'غَيْرٌ إِعْتاقٌ':Added, #1: 1	غَيْرِ إعْتَاقِ
u'غير إِعْتاقٌ':Added, #1: 1	غَيْرِ إعْتَاقِ
u'غَيْرٌ إِعْتاقٌ':Added, #1: 1	غَيْرِ الْإِعْتَاقِ
u'غير إِعْتاقٌ':Added, #1: 1	غَيْرِ الْإِعْتَاقِ
u'غَيْرٌ إِعْتاقٌ':Added, #3: 3	غَيْرِ إعْتَاقٍ
u'غير اِعْتِبارٌ':Added, #3: 3	غَيْرِ إعْتَاقٍ
u'غَيْرٌ اِعْتِبارٌ':Added, #1: 1	غَيْرِ اعْتِبَارِهِ
u'غير اِعْتِبارٌ':Added, #1: 1	غَيْرِ اعْتِبَارِهِ
u'غَيْرٌ اِعْتِبارٌ':Added, #36: 36	غَيْرِ اعْتِبَارِ
u'غير اِعْتِبارٌ':Added, #36: 36	غَيْرِ اعْتِبَارِ
u'غَيْرٌ اِعْتِبارٌ':Added, #6: 6	غَيْرِ اعْتِبَارٍ
u'غير اِعْتِداءٌ':Added, #6: 6	غَيْرِ اعْتِبَارٍ
u'غَيْرٌ اِعْتِداءٌ':Added, #1: 1	غَيْرِ اعْتِدَاءٍ
u'غير اِعْتِدالٌ':Added, #1: 1	غَيْرِ اعْتِدَاءٍ
u'غَيْرٌ اِعْتِدالٌ':Added, #1: 1	غَيْرِ اعْتِدَالٍ
u'غير اِعْتِذارٌ':Added, #1: 1	غَيْرِ اعْتِدَالٍ
u'غَيْرٌ اِعْتِذارٌ':Added, #1: 1	غَيْرِ اعْتِذَارٍ
u'غير اِعْتِراضٌ':Added, #1: 1	غَيْرِ اعْتِذَارٍ
u'غَيْرٌ اِعْتِراضٌ':Added, #8: 8	غَيْرِ اعْتِرَاضٍ
u'غير اِعْتِرافٌ':Added, #8: 8	غَيْرِ اعْتِرَاضٍ
u'غَيْرٌ اِعْتِرافٌ':Added, #2: 2	غَيْرِ اعْتِرَافٍ
u'غير اِعْتِقادٌ':Added, #2: 2	غَيْرِ اعْتِرَافٍ
u'غير اِعْتِقادٌ':Added, #2: 2	غَيْرِ اعْتِقَادٍ
u'غَيْرٌ اِعْتِقادٌ':Added, #2: 2	غَيْرِ اعْتِقَادِ
u'غَيْرٌ اِعْتِقادٌ':Added, #2: 2	غَيْرِ اعْتِقَادٍ
u'غير اِعْتِكافٌ':Added, #2: 2	غَيْرِ اعْتِقَادِ
u'غَيْرٌ اِعْتِكافٌ':Added, #1: 1	غَيْرِ اعْتِكَافٍ
u'غير أَعْجَميٌّ':Added, #1: 1	غَيْرِ اعْتِكَافٍ
u'غَيْرٌ أَعْجَميٌّ':Added, #1: 1	غَيْرِ الْأَعْجَمِيِّ
u'غير أعداد':Added, #1: 1	غَيْرِ الْأَعْجَمِيِّ
u'غير أَعْدَادٌ':Added, #1: 1	غَيْرِ الْأَعْدَادِ
u'غَيْرٌ أعداد':Added, #1: 1	غَيْرِ الْأَعْدَادِ
u'غَيْرٌ أَعْدَادٌ':Added, #1: 1	غَيْرِ الْأَعْدَادِ
u'غير أَعْذَارٌ':Added, #1: 1	غَيْرِ الْأَعْدَادِ
u'غَيْرٌ أَعْذَارٌ':Added, #1: 1	غَيْرِ أَعْذَارٍ
u'غير إِعْرابٌ':Added, #1: 1	غَيْرِ أَعْذَارٍ
u'غَيْرٌ إِعْرابٌ':Added, #1: 1	غَيْرِ الْإِعْرَابِ
u'غير أعْرَابِيٌّ':Added, #1: 1	غَيْرِ الْإِعْرَابِ
u'غَيْرٌ أعْرَابِيٌّ':Added, #2: 2	غَيْرِ الْأَعْرَابِيِّ
u'غير أعسر':Added, #2: 2	غَيْرِ الْأَعْرَابِيِّ
u'غير أعْسَر':Added, #1: 1	غَيْرَ أَعْسَرِ
u'غَيْرٌ أعسر':Added, #1: 1	غَيْرَ أَعْسَرِ
u'غَيْرٌ أعْسَر':Added, #1: 1	غَيْرَ أَعْسَرِ
u'غير أَعْضَاءٌ':Added, #1: 1	غَيْرَ أَعْسَرِ
u'غَيْرٌ أَعْضَاءٌ':Added, #5: 5	غَيْرِ أَعْضَاءِ
u'غير إعْطَاءٌ':Added, #5: 5	غَيْرِ أَعْضَاءِ
u'غَيْرٌ إعْطَاءٌ':Added, #1: 1	غَيْرِ الْإِعْطَاءِ
u'غير إعْطَاءٌ':Added, #1: 1	غَيْرِ الْإِعْطَاءِ
u'غَيْرٌ إعْطَاءٌ':Added, #4: 4	غَيْرِ إعْطَاءِ
u'غير أعْقَابٌ':Added, #4: 4	غَيْرِ إعْطَاءِ
u'غير أَعْقَابٌ':Added, #1: 1	غَيْرِ أَعْقَابِ
u'غَيْرٌ أعْقَابٌ':Added, #1: 1	غَيْرِ أَعْقَابِ
u'غَيْرٌ أَعْقَابٌ':Added, #1: 1	غَيْرِ أَعْقَابِ
u'غير أَعْلاَمٌ':Added, #1: 1	غَيْرِ أَعْقَابِ
u'غير إعْلاَمٌ':Added, #1: 1	غَيْرُ أَعْلَامٍ
u'غير إعْلاَمٌ':Added, #1: 1	غَيْرِ إعْلَامِ
u'غَيْرٌ أَعْلاَمٌ':Added, #1: 1	غَيْرَ إِعْلَامٍ
u'غَيْرٌ إعْلاَمٌ':Added, #1: 1	غَيْرُ أَعْلَامٍ
u'غَيْرٌ إعْلاَمٌ':Added, #1: 1	غَيْرِ إعْلَامِ
u'غير أَعْلاَمٌ':Added, #1: 1	غَيْرَ إِعْلَامٍ
u'غَيْرٌ أَعْلاَمٌ':Added, #1: 1	غَيْرَ الْأَعْلَامِ
u'غير أَعْلاَمٌ':Added, #1: 1	غَيْرَ الْأَعْلَامِ
u'غَيْرٌ أَعْلاَمٌ':Added, #4: 4	غَيْرِ الْأَعْلَامِ
u'غير أعْلَمُ':Added, #4: 4	غَيْرِ الْأَعْلَامِ
u'غَيْرٌ أعْلَمُ':Added, #1: 1	غَيْرَ الْأَعْلَمِ
u'غير أعْلَمُ':Added, #1: 1	غَيْرَ الْأَعْلَمِ
u'غَيْرٌ أعْلَمُ':Added, #2: 2	غَيْرِ الْأَعْلَمِ
u'غير أَعْمَالٌ':Added, #2: 2	غَيْرِ الْأَعْلَمِ
u'غَيْرٌ أَعْمَالٌ':Added, #1: 1	غَيْرِ الْأَعْمَالِ
u'غير أعْيانٌ':Added, #1: 1	غَيْرِ الْأَعْمَالِ
u'غير أعْيانٌ':Added, #2: 2	غَيْرُ الْأَعْيَانِ
u'غير أَعْيَانٌ':Added, #2: 2	غَيْرِ الْأَعْيَانِ
u'غير أَعْيَانٌ':Added, #2: 2	غَيْرُ الْأَعْيَانِ
u'غَيْرٌ أعْيانٌ':Added, #2: 2	غَيْرِ الْأَعْيَانِ
u'غَيْرٌ أعْيانٌ':Added, #2: 2	غَيْرُ الْأَعْيَانِ
u'غَيْرٌ أَعْيَانٌ':Added, #2: 2	غَيْرِ الْأَعْيَانِ
u'غَيْرٌ أَعْيَانٌ':Added, #2: 2	غَيْرُ الْأَعْيَانِ
u'غير اِغْتِسَالٌ':Added, #2: 2	غَيْرِ الْأَعْيَانِ
u'غَيْرٌ اِغْتِسَالٌ':Added, #1: 1	غَيْرِ اغْتِسَالٍ
u'غير إفَادَةٌ':Added, #1: 1	غَيْرِ اغْتِسَالٍ
u'غَيْرٌ إفَادَةٌ':Added, #1: 1	غَيْرِ إفَادَةِ
u'غير آفَةٌ':Added, #1: 1	غَيْرِ إفَادَةِ
u'غَيْرٌ آفَةٌ':Added, #5: 5	غَيْرِ آفَةٍ
u'غير اِفْتِرَاضٌ':Added, #5: 5	غَيْرِ آفَةٍ
u'غَيْرٌ اِفْتِرَاضٌ':Added, #2: 2	غَيْرِ افْتِرَاضٍ
u'غير اِفْتِضاض':Added, #2: 2	غَيْرِ افْتِرَاضٍ
u'غَيْرٌ اِفْتِضاض':Added, #1: 1	غَيْرِ افْتِضَاضٍ
u'غير اِفْتِقَارٌ':Added, #1: 1	غَيْرِ افْتِضَاضٍ
u'غَيْرٌ اِفْتِقَارٌ':Added, #11: 11	غَيْرِ افْتِقَارٍ
u'غير اِفْتِيات':Added, #11: 11	غَيْرِ افْتِقَارٍ
u'غَيْرٌ اِفْتِيات':Added, #1: 1	غَيْرِ افْتِيَاتٍ
u'غير إِفْرَاطٌ':Added, #1: 1	غَيْرِ افْتِيَاتٍ
u'غَيْرٌ إِفْرَاطٌ':Added, #5: 5	غَيْرِ إفْرَاطٍ
u'غير إفْسَادٌ':Added, #5: 5	غَيْرِ إفْرَاطٍ
u'غَيْرٌ إفْسَادٌ':Added, #1: 1	غَيْرِ إفْسَادِ
u'غير إفْسَادٌ':Added, #1: 1	غَيْرِ إفْسَادِ
u'غَيْرٌ إفْسَادٌ':Added, #1: 1	غَيْرُ الإِفْسَادِ
u'غير أفْضَلُ':Added, #1: 1	غَيْرُ الإِفْسَادِ
u'غَيْرٌ أفْضَلُ':Added, #1: 1	غَيْرِ الْأَفْضَلِ
u'غير أفْضَلِيَّةٌ':Added, #1: 1	غَيْرِ الْأَفْضَلِ
u'غَيْرٌ أفْضَلِيَّةٌ':Added, #1: 1	غَيْرِ أَفْضَلِيَّةٍ
u'غير أفْضَلِيَّةٌ':Added, #1: 1	غَيْرِ أَفْضَلِيَّةٍ
u'غَيْرٌ أفْضَلِيَّةٌ':Added, #1: 1	غَيْرِ الْأَفْضَلِيَّةِ
u'غير أَفْعَالٌ':Added, #1: 1	غَيْرِ الْأَفْضَلِيَّةِ
u'غير أَفْعَالٌ':Added, #1: 1	غَيْرُ أَفْعَالِ
u'غَيْرٌ أَفْعَالٌ':Added, #1: 1	غَيْرِ أَفْعَالِ
u'غَيْرٌ أَفْعَالٌ':Added, #1: 1	غَيْرُ أَفْعَالِ
u'غير أَفْعَالٌ':Added, #1: 1	غَيْرِ أَفْعَالِ
u'غير أَفْعَالٌ':Added, #1: 1	غَيْرُ الْأَفْعَالِ
u'غَيْرٌ أَفْعَالٌ':Added, #1: 1	غَيْرِ الْأَفْعَالِ
u'غَيْرٌ أَفْعَالٌ':Added, #1: 1	غَيْرُ الْأَفْعَالِ
u'غير أَفْنِيَةٌ':Added, #1: 1	غَيْرِ الْأَفْعَالِ
u'غَيْرٌ أَفْنِيَةٌ':Added, #1: 1	غَيْرِ أَفْنِيَةِ
u'غير أقارب':Added, #1: 1	غَيْرِ أَفْنِيَةِ
u'غَيْرٌ أقارب':Added, #1: 1	غَيْرِ الْأَقَارِبِ
u'غير إقامَةٌ':Added, #1: 1	غَيْرِ الْأَقَارِبِ
u'غَيْرٌ إقامَةٌ':Added, #1: 1	غَيْرِ إقَامَةٍ
u'غير إقامَةٌ':Added, #1: 1	غَيْرِ إقَامَةٍ
u'غَيْرٌ إقامَةٌ':Added, #8: 8	غَيْرِ إقَامَةِ
u'غير اِقْتِحامٌ':Added, #8: 8	غَيْرِ إقَامَةِ
u'غَيْرٌ اِقْتِحامٌ':Added, #2: 2	غَيْرِ اقْتِحَامِهِ
u'غير اِقْتِران':Added, #2: 2	غَيْرِ اقْتِحَامِهِ
u'غَيْرٌ اِقْتِران':Added, #2: 2	غَيْرِ اقْتِرَانِ
u'غير اِقْتِسامٌ':Added, #2: 2	غَيْرِ اقْتِرَانِ
u'غَيْرٌ اِقْتِسامٌ':Added, #1: 1	غَيْرِ اقْتِسَامٍ
u'غير اِقْتِصَارٌ':Added, #1: 1	غَيْرِ اقْتِسَامٍ
u'غَيْرٌ اِقْتِصَارٌ':Added, #1: 1	غَيْرِ اقْتِصَارٍ
u'غير اِقْتِضَاءٌ':Added, #1: 1	غَيْرِ اقْتِصَارٍ
u'غَيْرٌ اِقْتِضَاءٌ':Added, #1: 1	غَيْرِ اقْتِضَاءٍ
u'غير اِقْتِضَاءٌ':Added, #1: 1	غَيْرِ اقْتِضَاءٍ
u'غَيْرٌ اِقْتِضَاءٌ':Added, #5: 5	غَيْرِ اقْتِضَاءِ
u'غير اِقْتِناءٌ':Added, #5: 5	غَيْرِ اقْتِضَاءِ
u'غَيْرٌ اِقْتِناءٌ':Added, #1: 1	غَيْرِ اقْتِنَاءٍ
u'غير إقْدَامٌ':Added, #1: 1	غَيْرِ اقْتِنَاءٍ
u'غَيْرٌ إقْدَامٌ':Added, #1: 1	غَيْرِ إقْدَامٍ
u'غير أقْرأُ':Added, #1: 1	غَيْرِ إقْدَامٍ
u'غَيْرٌ أقْرأُ':Added, #1: 1	غَيْرَ الْأَقْرَأِ
u'غير إقْرَارٌ':Added, #1: 1	غَيْرَ الْأَقْرَأِ
u'غَيْرٌ إقْرَارٌ':Added, #1: 1	غَيْرُ إقْرَارِهِ
u'غير إقْرَارٌ':Added, #1: 1	غَيْرُ إقْرَارِهِ
u'غَيْرٌ إقْرَارٌ':Added, #1: 1	غَيْرَ الْإِقْرَارِ
u'غير إقْرَارٌ':Added, #1: 1	غَيْرَ الْإِقْرَارِ
u'غَيْرٌ إقْرَارٌ':Added, #2: 2	غَيْرِ إقْرَارِهِ
u'غير إقْرَارٌ':Added, #2: 2	غَيْرِ إقْرَارِهِ
u'غير إقْرَارٌ':Added, #2: 2	غَيْرُ الْإِقْرَارِ
u'غَيْرٌ إقْرَارٌ':Added, #2: 2	غَيْرِ الْإِقْرَارِ
u'غَيْرٌ إقْرَارٌ':Added, #2: 2	غَيْرُ الْإِقْرَارِ
u'غير إقْرَارٌ':Added, #2: 2	غَيْرِ الْإِقْرَارِ
u'غَيْرٌ إقْرَارٌ':Added, #7: 7	غَيْرِ إقْرَارٍ
u'غير أقْرَبُ':Added, #7: 7	غَيْرِ إقْرَارٍ
u'غَيْرٌ أقْرَبُ':Added, #1: 1	غَيْرَ الْأَقْرَبِ
u'غير أقْرَبُ':Added, #1: 1	غَيْرَ الْأَقْرَبِ
u'غَيْرٌ أقْرَبُ':Added, #2: 2	غَيْرِ الْأَقْرَبِ
u'غير إقْطَاعٌ':Added, #2: 2	غَيْرِ الْأَقْرَبِ
u'غَيْرٌ إقْطَاعٌ':Added, #2: 2	غَيْرِ إقْطَاعٍ
u'غير أقَلُّ':Added, #2: 2	غَيْرِ إقْطَاعٍ
u'غَيْرٌ أقَلُّ':Added, #1: 1	غَيْرَ الْأَقَلِّ
u'غير إقْلاعٌ':Added, #1: 1	غَيْرَ الْأَقَلِّ
u'غَيْرٌ إقْلاعٌ':Added, #1: 1	غَيْرِ إقْلَاعٍ
u'غير إقْلِيمٌ':Added, #1: 1	غَيْرِ إقْلَاعٍ
u'غَيْرٌ إقْلِيمٌ':Added, #3: 3	غَيْرِ إقْلِيمِهِ
u'غير أكابر':Added, #3: 3	غَيْرِ إقْلِيمِهِ
u'غَيْرٌ أكابر':Added, #1: 1	غَيْرِ الْأَكَابِرِ
u'غير أكَّارٌ':Added, #1: 1	غَيْرِ الْأَكَابِرِ
u'غَيْرٌ أكَّارٌ':Added, #1: 1	غَيْرُ الْأَكَّارِ
u'غير أكْبَرُ':Added, #1: 1	غَيْرُ الْأَكَّارِ
u'غَيْرٌ أكْبَرُ':Added, #2: 2	غَيْرِ الْأَكْبَرِ
u'غير اِكْتِحَالٌ':Added, #2: 2	غَيْرِ الْأَكْبَرِ
u'غَيْرٌ اِكْتِحَالٌ':Added, #1: 1	غَيْرِ اكْتِحَالٍ
u'غير اِكْتِسَابٌ':Added, #1: 1	غَيْرِ اكْتِحَالٍ
u'غَيْرٌ اِكْتِسَابٌ':Added, #2: 2	غَيْرِ اكْتِسَابٍ
u'غير إكْثَارٌ':Added, #2: 2	غَيْرِ اكْتِسَابٍ
u'غَيْرٌ إكْثَارٌ':Added, #1: 1	غَيْرِ إكْثَارٍ
u'غير أَكْثَرُ':Added, #1: 1	غَيْرِ إكْثَارٍ
u'غَيْرٌ أَكْثَرُ':Added, #1: 1	غَيْرِ أَكْثَرِ
u'غير أَكْثَرُ':Added, #1: 1	غَيْرِ أَكْثَرِ
u'غَيْرٌ أَكْثَرُ':Added, #1: 1	غَيْرَ الْأَكْثَرِ
u'غير أَكْثَرُ':Added, #1: 1	غَيْرَ الْأَكْثَرِ
u'غَيْرٌ أَكْثَرُ':Added, #2: 2	غَيْرِ الْأَكْثَرِ
u'غير إكْرَاهٌ':Added, #2: 2	غَيْرِ الْأَكْثَرِ
u'غَيْرٌ إكْرَاهٌ':Added, #10: 10	غَيْرِ إكْرَاهٍ
u'غير إكْرَاهٌ':Added, #10: 10	غَيْرِ إكْرَاهٍ
u'غير إكْرَاهٌ':Added, #1: 1	غَيْرُ إكْرَاهٍ
u'غَيْرٌ إكْرَاهٌ':Added, #1: 1	غَيْرِ إكْرَاهِ
u'غَيْرٌ إكْرَاهٌ':Added, #1: 1	غَيْرُ إكْرَاهٍ
u'غير إكْرَاهٌ':Added, #1: 1	غَيْرِ إكْرَاهِ
u'غَيْرٌ إكْرَاهٌ':Added, #3: 3	غَيْرِ الْإِكْرَاهِ
u'غير أكفاء':Added, #3: 3	غَيْرِ الْإِكْرَاهِ
u'غَيْرٌ أكفاء':Added, #1: 1	غَيْرِ الْأَكْفَاءِ
u'غير أكل':Added, #1: 1	غَيْرِ الْأَكْفَاءِ
u'غير أَكْلٌ':Added, #1: 1	غَيْرَ أَكْلِ
u'غَيْرٌ أكل':Added, #1: 1	غَيْرَ أَكْلِ
u'غَيْرٌ أَكْلٌ':Added, #1: 1	غَيْرَ أَكْلِ
u'غير أكل':Added, #1: 1	غَيْرَ أَكْلِ
u'غير أَكْلٌ':Added, #2: 2	غَيْرُ الْأَكْلِ
u'غَيْرٌ أكل':Added, #2: 2	غَيْرُ الْأَكْلِ
u'غَيْرٌ أَكْلٌ':Added, #2: 2	غَيْرُ الْأَكْلِ
u'غير أَكْلٌ':Added, #2: 2	غَيْرُ الْأَكْلِ
u'غَيْرٌ أَكْلٌ':Added, #3: 3	غَيْرِ أَكْلٍ
u'غير أكل':Added, #3: 3	غَيْرِ أَكْلٍ
u'غير أَكْلٌ':Added, #8: 8	غَيْرِ الْأَكْلِ
u'غَيْرٌ أكل':Added, #8: 8	غَيْرِ الْأَكْلِ
u'غَيْرٌ أَكْلٌ':Added, #8: 8	غَيْرِ الْأَكْلِ
u'غير آلةٌ':Added, #8: 8	غَيْرِ الْأَكْلِ
u'غَيْرٌ آلةٌ':Added, #1: 1	غَيْرِ آلَةٍ
u'غير آلةٌ':Added, #1: 1	غَيْرِ آلَةٍ
u'غَيْرٌ آلةٌ':Added, #2: 2	غَيْرَ آلَةِ
u'غير اِلْتِزَامٌ':Added, #2: 2	غَيْرَ آلَةِ
u'غَيْرٌ اِلْتِزَامٌ':Added, #2: 2	غَيْرِ الْتِزَامِهِ
u'غير اِلْتِزَامٌ':Added, #2: 2	غَيْرِ الْتِزَامِهِ
u'غير اِلْتِزَامٌ':Added, #4: 4	غَيْرِ الْتِزَامٍ
u'غَيْرٌ اِلْتِزَامٌ':Added, #4: 4	غَيْرِ الْتِزَامِ
u'غَيْرٌ اِلْتِزَامٌ':Added, #4: 4	غَيْرِ الْتِزَامٍ
u'غير اِلْتِفَاتٌ':Added, #4: 4	غَيْرِ الْتِزَامِ
u'غَيْرٌ اِلْتِفَاتٌ':Added, #1: 1	غَيْرِ الْتِفَاتِ
u'غير اِلْتِفَاتٌ':Added, #1: 1	غَيْرِ الْتِفَاتِ
u'غَيْرٌ اِلْتِفَاتٌ':Added, #7: 7	غَيْرِ الْتِفَاتٍ
u'غير اِلْتِمَاسٌ':Added, #7: 7	غَيْرِ الْتِفَاتٍ
u'غَيْرٌ اِلْتِمَاسٌ':Added, #2: 2	غَيْرِ الْتِمَاسِ
u'غير إلْجَاءٌ':Added, #2: 2	غَيْرِ الْتِمَاسِ
u'غَيْرٌ إلْجَاءٌ':Added, #2: 2	غَيْرِ إلْجَاءٍ
u'غير إلْحَاحٌ':Added, #2: 2	غَيْرِ إلْجَاءٍ
u'غَيْرٌ إلْحَاحٌ':Added, #2: 2	غَيْرِ إلْحَاحٍ
u'غير إِلْحَافٌ':Added, #2: 2	غَيْرِ إلْحَاحٍ
u'غَيْرٌ إِلْحَافٌ':Added, #1: 1	غَيْرَ إلْحَافٍ
u'غير إِلْزَامٌ':Added, #1: 1	غَيْرَ إلْحَافٍ
u'غير إِلْزَامٌ':Added, #3: 3	غَيْرِ إلْزَامٍ
u'غَيْرٌ إِلْزَامٌ':Added, #3: 3	غَيْرِ إلْزَامِ
u'غَيْرٌ إِلْزَامٌ':Added, #3: 3	غَيْرِ إلْزَامٍ
u'غير إِلْزَامٌ':Added, #3: 3	غَيْرِ إلْزَامِ
u'غَيْرٌ إِلْزَامٌ':Added, #5: 5	غَيْرِ الْإِلْزَامِ
u'غير إلْغَاءٌ':Added, #5: 5	غَيْرِ الْإِلْزَامِ
u'غَيْرٌ إلْغَاءٌ':Added, #1: 1	غَيْرِ إلْغَاءِ
u'غير ألف':Added, #1: 1	غَيْرِ إلْغَاءِ
u'غير ألف':Added, #1: 1	غَيْرَ الْأَلِفِ
u'غير ألف':Added, #1: 1	غَيْرَ الْأَلْفِ
u'غير ألْفٌ':Added, #1: 1	غَيْرُ الْأَلِفِ
u'غير أَلْفٌ':Added, #1: 1	غَيْرَ الْأَلْفِ
u'غَيْرٌ ألف':Added, #1: 1	غَيْرَ الْأَلْفِ
u'غَيْرٌ ألف':Added, #1: 1	غَيْرَ الْأَلِفِ
u'غَيْرٌ ألف':Added, #1: 1	غَيْرَ الْأَلْفِ
u'غَيْرٌ ألْفٌ':Added, #1: 1	غَيْرُ الْأَلِفِ
u'غَيْرٌ أَلْفٌ':Added, #1: 1	غَيْرَ الْأَلْفِ
u'غير ألْفٌ':Added, #1: 1	غَيْرَ الْأَلْفِ
u'غير أَلْفٌ':Added, #1: 1	غَيْرُ أَلْفٍ
u'غَيْرٌ ألْفٌ':Added, #1: 1	غَيْرُ أَلْفٍ
u'غَيْرٌ أَلْفٌ':Added, #1: 1	غَيْرُ أَلْفٍ
u'غير ألف':Added, #1: 1	غَيْرُ أَلْفٍ
u'غير ألْفٌ':Added, #2: 2	غَيْرُ أَلْفِ
u'غير أَلْفٌ':Added, #2: 2	غَيْرُ أَلْفِ
u'غَيْرٌ ألف':Added, #2: 2	غَيْرُ أَلْفِ
u'غَيْرٌ ألْفٌ':Added, #2: 2	غَيْرُ أَلْفِ
u'غَيْرٌ أَلْفٌ':Added, #2: 2	غَيْرُ أَلْفِ
u'غير ألف':Added, #2: 2	غَيْرُ أَلْفِ
u'غير ألْفٌ':Added, #3: 3	غَيْرُ الْأَلْفِ
u'غير أَلْفٌ':Added, #3: 3	غَيْرُ الْأَلْفِ
u'غَيْرٌ ألف':Added, #3: 3	غَيْرُ الْأَلْفِ
u'غَيْرٌ ألْفٌ':Added, #3: 3	غَيْرُ الْأَلْفِ
u'غَيْرٌ أَلْفٌ':Added, #3: 3	غَيْرُ الْأَلْفِ
u'غير ألْفٌ':Added, #3: 3	غَيْرُ الْأَلْفِ
u'غَيْرٌ ألْفٌ':Added, #3: 3	غَيْرُ أَلْفَيْنِ
u'غير أَلْفَاظٌ':Added, #3: 3	غَيْرُ أَلْفَيْنِ
u'غَيْرٌ أَلْفَاظٌ':Added, #1: 1	غَيْرِ الْأَلْفَاظِ
u'غير أَلْفَاظٌ':Added, #1: 1	غَيْرِ الْأَلْفَاظِ
u'غَيْرٌ أَلْفَاظٌ':Added, #1: 1	غَيْرَ أَلْفَاظِ
u'غير إِلْقَاءٌ':Added, #1: 1	غَيْرَ أَلْفَاظِ
u'غَيْرٌ إِلْقَاءٌ':Added, #1: 1	غَيْرُ إلْقَاءِ
u'غير إِلْمَامٌ':Added, #1: 1	غَيْرُ إلْقَاءِ
u'غَيْرٌ إِلْمَامٌ':Added, #1: 1	غَيْرِ إلْمَامٍ
u'غير الْمَرْأَةُ':Added, #1: 1	غَيْرِ إلْمَامٍ
u'غَيْرٌ الْمَرْأَةُ':Added, #1: 1	غَيْرُ الْمَرْأَةِ
u'غير الْمَرْأَةُ':Added, #1: 1	غَيْرُ الْمَرْأَةِ
u'غَيْرٌ الْمَرْأَةُ':Added, #4: 4	غَيْرَ الْمَرْأَةِ
u'غير الْمَرْأَةُ':Added, #4: 4	غَيْرَ الْمَرْأَةِ
u'غَيْرٌ الْمَرْأَةُ':Added, #5: 5	غَيْرِ الْمَرْأَةِ
u'غير إلَهٌ':Added, #5: 5	غَيْرِ الْمَرْأَةِ
u'غَيْرٌ إلَهٌ':Added, #1: 1	غَيْرُ الْإِلَهِ
u'غير أُمٌّ':Added, #1: 1	غَيْرُ الْإِلَهِ
u'غَيْرٌ أُمٌّ':Added, #1: 1	غَيْرَ الْأُمِّ
u'غير أُمٌّ':Added, #1: 1	غَيْرَ الْأُمِّ
u'غَيْرٌ أُمٌّ':Added, #1: 1	غَيْرِ أُمٍّ
u'غير أُمٌّ':Added, #1: 1	غَيْرِ أُمٍّ
u'غَيْرٌ أُمٌّ':Added, #2: 2	غَيْرُ الْأُمِّ
u'غير أُمٌّ':Added, #2: 2	غَيْرُ الْأُمِّ
u'غَيْرٌ أُمٌّ':Added, #2: 2	غَيْرَ أُمِّ
u'غير أُمٌّ':Added, #2: 2	غَيْرَ أُمِّ
u'غير أُمٌّ':Added, #2: 2	غَيْرَ أُمِّهِ
u'غير أُمٌّ':Added, #2: 2	غَيْرُ أُمِّهِ
u'غَيْرٌ أُمٌّ':Added, #2: 2	غَيْرِ أُمِّهِ
u'غَيْرٌ أُمٌّ':Added, #2: 2	غَيْرَ أُمِّهِ
u'غَيْرٌ أُمٌّ':Added, #2: 2	غَيْرُ أُمِّهِ
u'غير أُمٌّ':Added, #2: 2	غَيْرِ أُمِّهِ
u'غَيْرٌ أُمٌّ':Added, #4: 4	غَيْرُ أُمِّ
u'غير أُمٌّ':Added, #4: 4	غَيْرُ أُمِّ
u'غَيْرٌ أُمٌّ':Added, #8: 8	غَيْرِ الْأُمِّ
u'غير إمَاءٌ':Added, #8: 8	غَيْرِ الْأُمِّ
u'غَيْرٌ إمَاءٌ':Added, #1: 1	غَيْرِ الْإِمَاءِ
u'غير أمَارَةٌ':Added, #1: 1	غَيْرِ الْإِمَاءِ
u'غَيْرٌ أمَارَةٌ':Added, #4: 4	غَيْرِ أَمَارَةٍ
u'غير أَمَاكِنُ':Added, #4: 4	غَيْرِ أَمَارَةٍ
u'غير أَمَاكِنُ':Added, #1: 1	غَيْرَ الْأَمَاكِنِ
u'غَيْرٌ أَمَاكِنُ':Added, #1: 1	غَيْرِ الْأَمَاكِنِ
u'غَيْرٌ أَمَاكِنُ':Added, #1: 1	غَيْرَ الْأَمَاكِنِ
u'غير إمَامٌ':Added, #1: 1	غَيْرِ الْأَمَاكِنِ
u'غير إمَامٌ':Added, #1: 1	غَيْرُ الإِمَامِ
u'غَيْرٌ إمَامٌ':Added, #1: 1	غَيْرِ الإِمَامِ
u'غَيْرٌ إمَامٌ':Added, #1: 1	غَيْرُ الإِمَامِ
u'غير إمَامٌ':Added, #1: 1	غَيْرِ الإِمَامِ
u'غَيْرٌ إمَامٌ':Added, #1: 1	غَيْرُ إمَامِ
u'غير إمَامٌ':Added, #1: 1	غَيْرُ إمَامِ
u'غَيْرٌ إمَامٌ':Added, #1: 1	غَيْرِ إِمَامِهِ
u'غير إمَامٌ':Added, #1: 1	غَيْرِ إِمَامِهِ
u'غَيْرٌ إمَامٌ':Added, #21: 21	غَيْرَ الْإِمَامِ
u'غير إمَامٌ':Added, #21: 21	غَيْرَ الْإِمَامِ
u'غير إمَامٌ':Added, #23: 23	غَيْرُ الْإِمَامِ
u'غَيْرٌ إمَامٌ':Added, #23: 23	غَيْرِ الْإِمَامِ
u'غَيْرٌ إمَامٌ':Added, #23: 23	غَيْرُ الْإِمَامِ
u'غير إمَامٌ':Added, #23: 23	غَيْرِ الْإِمَامِ
u'غَيْرٌ إمَامٌ':Added, #2: 2	غَيْرِ إمَامٍ
u'غير إمَامٌ':Added, #2: 2	غَيْرِ إمَامٍ
u'غَيْرٌ إمَامٌ':Added, #35: 35	غَيْرِ إمَامِهِ
u'غير إمَامٌ':Added, #35: 35	غَيْرِ إمَامِهِ
u'غَيْرٌ إمَامٌ':Added, #3: 3	غَيْرَ إمَامٍ
u'غير إمَامٌ':Added, #3: 3	غَيْرَ إمَامٍ
u'غَيْرٌ إمَامٌ':Added, #4: 4	غَيْرِ إمَامِ
u'غير إمَامَةٌ':Added, #4: 4	غَيْرِ إمَامِ
u'غَيْرٌ إمَامَةٌ':Added, #2: 2	غَيْرِ الْإِمَامَةِ
u'غير أمَانٌ':Added, #2: 2	غَيْرِ الْإِمَامَةِ
u'غَيْرٌ أمَانٌ':Added, #2: 2	غَيْرِ الْأَمَانِ
u'غير أمَانٌ':Added, #2: 2	غَيْرِ الْأَمَانِ
u'غَيْرٌ أمَانٌ':Added, #2: 2	غَيْرِ أَمَانٍ
u'غير أمَةٌ':Added, #2: 2	غَيْرِ أَمَانٍ
u'غير أمَةٌ':Added, #1: 1	غَيْرَ الْأَمَةِ
u'غَيْرٌ أمَةٌ':Added, #1: 1	غَيْرُ الْأَمَةِ
u'غَيْرٌ أمَةٌ':Added, #1: 1	غَيْرَ الْأَمَةِ
u'غير أمَةٌ':Added, #1: 1	غَيْرُ الْأَمَةِ
u'غَيْرٌ أمَةٌ':Added, #1: 1	غَيْرِ أَمَةِ
u'غير أمَةٌ':Added, #1: 1	غَيْرِ أَمَةِ
u'غَيْرٌ أمَةٌ':Added, #2: 2	غَيْرِ أَمَتِهِ
u'غير أمَةٌ':Added, #2: 2	غَيْرِ أَمَتِهِ
u'غَيْرٌ أمَةٌ':Added, #3: 3	غَيْرِ الْأَمَةِ
u'غير أمَةٌ':Added, #3: 3	غَيْرِ الْأَمَةِ
u'غَيْرٌ أمَةٌ':Added, #3: 3	غَيْرِ أَمَةٍ
u'غير اِمْتِحَانٌ':Added, #3: 3	غَيْرِ أَمَةٍ
u'غَيْرٌ اِمْتِحَانٌ':Added, #1: 1	غَيْرِ امْتِحَانٍ
u'غير اِمْتِناعٌ':Added, #1: 1	غَيْرِ امْتِحَانٍ
u'غَيْرٌ اِمْتِناعٌ':Added, #2: 2	غَيْرِ امْتِنَاعٍ
u'غير أَمَدٌ':Added, #2: 2	غَيْرِ امْتِنَاعٍ
u'غَيْرٌ أَمَدٌ':Added, #1: 1	غَيْرِ أَمَدٍ
u'غير أَمْرٌ':Added, #1: 1	غَيْرِ أَمَدٍ
u'غَيْرٌ أَمْرٌ':Added, #1: 1	غَيْرِ الْأَمْرِ
u'غير أَمْرٌ':Added, #1: 1	غَيْرِ الْأَمْرِ
u'غير أَمْرٌ':Added, #1: 1	غَيْرَ أَمْرٍ
u'غير أَمْرٌ':Added, #1: 1	غَيْرُ أَمْرٍ
u'غَيْرٌ أَمْرٌ':Added, #1: 1	غَيْرُ أَمْرِ
u'غَيْرٌ أَمْرٌ':Added, #1: 1	غَيْرَ أَمْرٍ
u'غَيْرٌ أَمْرٌ':Added, #1: 1	غَيْرُ أَمْرٍ
u'غير أَمْرٌ':Added, #1: 1	غَيْرُ أَمْرِ
u'غَيْرٌ أَمْرٌ':Added, #3: 3	غَيْرِ أَمْرٍ
u'غير أَمْرٌ':Added, #3: 3	غَيْرِ أَمْرٍ
u'غَيْرٌ أَمْرٌ':Added, #3: 3	غَيْرِ أَمْرِهِ
u'غير أَمْرٌ':Added, #3: 3	غَيْرِ أَمْرِهِ
u'غَيْرٌ أَمْرٌ':Added, #8: 8	غَيْرِ أَمْرِ
u'غير اِمْرَأَةٌ':Added, #8: 8	غَيْرِ أَمْرِ
u'غَيْرٌ اِمْرَأَةٌ':Added, #11: 11	غَيْرُ امْرَأَتِهِ
u'غير اِمْرَأَةٌ':Added, #11: 11	غَيْرُ امْرَأَتِهِ
u'غَيْرٌ اِمْرَأَةٌ':Added, #1: 1	غَيْرَ امْرَأَةٍ
u'غير اِمْرَأَةٌ':Added, #1: 1	غَيْرَ امْرَأَةٍ
u'غير اِمْرَأَةٌ':Added, #2: 2	غَيْرِ امْرَأَةٍ
u'غَيْرٌ اِمْرَأَةٌ':Added, #2: 2	غَيْرِ امْرَأَةِ
u'غَيْرٌ اِمْرَأَةٌ':Added, #2: 2	غَيْرِ امْرَأَةٍ
u'غير اِمْرَأَةٌ':Added, #2: 2	غَيْرِ امْرَأَةِ
u'غَيْرٌ اِمْرَأَةٌ':Added, #2: 2	غَيْرَ امْرَأَتِهِ
u'غير إِمْرارٌ':Added, #2: 2	غَيْرَ امْرَأَتِهِ
u'غَيْرٌ إِمْرارٌ':Added, #1: 1	غَيْرِ إمْرَارٍ
u'غير أَمْرَد':Added, #1: 1	غَيْرِ إمْرَارٍ
u'غَيْرٌ أَمْرَد':Added, #1: 1	غَيْرِ الْأَمْرَدِ
u'غير إِمْساكٌ':Added, #1: 1	غَيْرِ الْأَمْرَدِ
u'غَيْرٌ إِمْساكٌ':Added, #1: 1	غَيْرِ الْإِمْسَاكِ
u'غير إِمْساكٌ':Added, #1: 1	غَيْرِ الْإِمْسَاكِ
u'غَيْرٌ إِمْساكٌ':Added, #2: 2	غَيْرِ إمْسَاكٍ
u'غير إِمْعانٌ':Added, #2: 2	غَيْرِ إمْسَاكٍ
u'غَيْرٌ إِمْعانٌ':Added, #1: 1	غَيْرِ إمْعَانٍ
u'غير إِمْكانٌ':Added, #1: 1	غَيْرِ إمْعَانٍ
u'غَيْرٌ إِمْكانٌ':Added, #1: 1	غَيْرُ إمْكَانِ
u'غير إِمْكانٌ':Added, #1: 1	غَيْرُ إمْكَانِ
u'غَيْرٌ إِمْكانٌ':Added, #2: 2	غَيْرِ إمْكَانِ
u'غير إِمْلاءٌ':Added, #2: 2	غَيْرِ إمْكَانِ
u'غَيْرٌ إِمْلاءٌ':Added, #1: 1	غَيْرِ الْإِمْلَاءِ
u'غير أَمْلاكٌ':Added, #1: 1	غَيْرِ الْإِمْلَاءِ
u'غير أَمْلاَكٌ':Added, #1: 1	غَيْرِ الْأَمْلَاكِ
u'غَيْرٌ أَمْلاكٌ':Added, #1: 1	غَيْرِ الْأَمْلَاكِ
u'غَيْرٌ أَمْلاَكٌ':Added, #1: 1	غَيْرِ الْأَمْلَاكِ
u'غير آمِنٌ':Added, #1: 1	غَيْرِ الْأَمْلَاكِ
u'غَيْرٌ آمِنٌ':Added, #1: 1	غَيْرَ آمِنٍ
u'غير أُمَّهَاتٌ':Added, #1: 1	غَيْرَ آمِنٍ
u'غَيْرٌ أُمَّهَاتٌ':Added, #1: 1	غَيْرَ أُمَّهَاتِهِ
u'غير أُمَّهَاتٌ':Added, #1: 1	غَيْرَ أُمَّهَاتِهِ
u'غَيْرٌ أُمَّهَاتٌ':Added, #2: 2	غَيْرِ أُمَّهَاتِ
u'غير أُمَّهَاتٌ':Added, #2: 2	غَيْرِ أُمَّهَاتِ
u'غَيْرٌ أُمَّهَاتٌ':Added, #2: 2	غَيْرِ أُمَّهَاتِهِ
u'غير إِمْهالٌ':Added, #2: 2	غَيْرِ أُمَّهَاتِهِ
u'غَيْرٌ إِمْهالٌ':Added, #1: 1	غَيْرِ إمْهَالٍ
u'غير أَمْوَالٌ':Added, #1: 1	غَيْرِ إمْهَالٍ
u'غير أَمْوَالٌ':Added, #1: 1	غَيْرِ الأَمْوَالِ
u'غَيْرٌ أَمْوَالٌ':Added, #1: 1	غَيْرُ الْأَمْوَالِ
u'غَيْرٌ أَمْوَالٌ':Added, #1: 1	غَيْرِ الأَمْوَالِ
u'غير أَمْوَالٌ':Added, #1: 1	غَيْرُ الْأَمْوَالِ
u'غَيْرٌ أَمْوَالٌ':Added, #1: 1	غَيْرَ أَمْوَالٍ
u'غير أَمْوَالٌ':Added, #1: 1	غَيْرَ أَمْوَالٍ
u'غَيْرٌ أَمْوَالٌ':Added, #5: 5	غَيْرِ الْأَمْوَالِ
u'غير أَمْوَالٌ':Added, #5: 5	غَيْرِ الْأَمْوَالِ
u'غَيْرٌ أَمْوَالٌ':Added, #5: 5	غَيْرِ أَمْوَالِ
u'غير أُمُورٌ':Added, #5: 5	غَيْرِ أَمْوَالِ
u'غَيْرٌ أُمُورٌ':Added, #1: 1	غَيْرِ أُمُورِ
u'غير أَميرٌ':Added, #1: 1	غَيْرِ أُمُورِ
u'غَيْرٌ أَميرٌ':Added, #1: 1	غَيْرُ الْأَمِيرِ
u'غير أَميرٌ':Added, #1: 1	غَيْرُ الْأَمِيرِ
u'غَيْرٌ أَميرٌ':Added, #1: 1	غَيْرُ أَمِيرِهِ
u'غير أَمينٌ':Added, #1: 1	غَيْرُ أَمِيرِهِ
u'غَيْرٌ أَمينٌ':Added, #1: 1	غَيْرُ الْأَمِينِ
u'غير أَمينٌ':Added, #1: 1	غَيْرُ الْأَمِينِ
u'غَيْرٌ أَمينٌ':Added, #1: 1	غَيْرُ أَمِينِ
u'غير أَمينٌ':Added, #1: 1	غَيْرُ أَمِينِ
u'غَيْرٌ أَمينٌ':Added, #5: 5	غَيْرِ الْأَمِينِ
u'غير إِناءٌ':Added, #5: 5	غَيْرِ الْأَمِينِ
u'غَيْرٌ إِناءٌ':Added, #2: 2	غَيْرِ الْإِنَاءِ
u'غير إِناءٌ':Added, #2: 2	غَيْرِ الْإِنَاءِ
u'غَيْرٌ إِناءٌ':Added, #5: 5	غَيْرِ إنَاءٍ
u'غير إِنْباتٌ':Added, #5: 5	غَيْرِ إنَاءٍ
u'غَيْرٌ إِنْباتٌ':Added, #1: 1	غَيْرِ إنْبَاتٍ
u'غير أنبياء':Added, #1: 1	غَيْرِ إنْبَاتٍ
u'غَيْرٌ أنبياء':Added, #1: 1	غَيْرُ الْأَنْبِيَاءِ
u'غير أنبياء':Added, #1: 1	غَيْرُ الْأَنْبِيَاءِ
u'غَيْرٌ أنبياء':Added, #26: 26	غَيْرِ الْأَنْبِيَاءِ
u'غير أنبياء':Added, #26: 26	غَيْرِ الْأَنْبِيَاءِ
u'غَيْرٌ أنبياء':Added, #2: 2	غَيْرَ الْأَنْبِيَاءِ
u'غير اِنْتِشارٌ':Added, #2: 2	غَيْرَ الْأَنْبِيَاءِ
u'غَيْرٌ اِنْتِشارٌ':Added, #2: 2	غَيْرِ انْتِشَارٍ
u'غير اِنْتِظارٌ':Added, #2: 2	غَيْرِ انْتِشَارٍ
u'غير اِنْتِظارٌ':Added, #1: 1	غَيْرِ انْتِظَارٍ
u'غَيْرٌ اِنْتِظارٌ':Added, #1: 1	غَيْرِ انْتِظَارِ
u'غَيْرٌ اِنْتِظارٌ':Added, #1: 1	غَيْرِ انْتِظَارٍ
u'غير اِنْتِفاعٌ':Added, #1: 1	غَيْرِ انْتِظَارِ
u'غَيْرٌ اِنْتِفاعٌ':Added, #1: 1	غَيْرِ انْتِفَاعٍ
u'غير اِنْتِقالٌ':Added, #1: 1	غَيْرِ انْتِفَاعٍ
u'غَيْرٌ اِنْتِقالٌ':Added, #4: 4	غَيْرِ انْتِقَالٍ
u'غير اِنْتِهاءٌ':Added, #4: 4	غَيْرِ انْتِقَالٍ
u'غَيْرٌ اِنْتِهاءٌ':Added, #1: 1	غَيْرِ انْتِهَاءٍ
u'غير اِنْتِهاءٌ':Added, #1: 1	غَيْرِ انْتِهَاءٍ
u'غَيْرٌ اِنْتِهاءٌ':Added, #2: 2	غَيْرِ انْتِهَاءِ
u'غير اِنْحِرافٌ':Added, #2: 2	غَيْرِ انْتِهَاءِ
u'غَيْرٌ اِنْحِرافٌ':Added, #1: 1	غَيْرِ انْحِرَافٍ
u'غير إِنْذارٌ':Added, #1: 1	غَيْرِ انْحِرَافٍ
u'غَيْرٌ إِنْذارٌ':Added, #1: 1	غَيْرِ إنْذَارِ
u'غير إِنْذارٌ':Added, #1: 1	غَيْرِ إنْذَارِ
u'غَيْرٌ إِنْذارٌ':Added, #2: 2	غَيْرِ إنْذَارٍ
u'غير إِنْزالٌ':Added, #2: 2	غَيْرِ إنْذَارٍ
u'غَيْرٌ إِنْزالٌ':Added, #20: 20	غَيْرِ إنْزَالٍ
u'غير إِنْسانٌ':Added, #20: 20	غَيْرِ إنْزَالٍ
u'غَيْرٌ إِنْسانٌ':Added, #1: 1	غَيْرَ إنْسَانٍ
u'غير إِنْسانٌ':Added, #1: 1	غَيْرَ إنْسَانٍ
u'غَيْرٌ إِنْسانٌ':Added, #2: 2	غَيْرُ الْإِنْسَانِ
u'غير إِنْسانٌ':Added, #2: 2	غَيْرُ الْإِنْسَانِ
u'غَيْرٌ إِنْسانٌ':Added, #2: 2	غَيْرِ إنْسَانٍ
u'غير إِنْسانٌ':Added, #2: 2	غَيْرِ إنْسَانٍ
u'غَيْرٌ إِنْسانٌ':Added, #4: 4	غَيْرِ الْإِنْسَانِ
u'غير إِنْشاءٌ':Added, #4: 4	غَيْرِ الْإِنْسَانِ
u'غَيْرٌ إِنْشاءٌ':Added, #1: 1	غَيْرِ الْإِنْشَاءِ
u'غير إِنْشاءٌ':Added, #1: 1	غَيْرِ الْإِنْشَاءِ
u'غَيْرٌ إِنْشاءٌ':Added, #4: 4	غَيْرِ إنْشَاءِ
u'غير أنصار':Added, #4: 4	غَيْرِ إنْشَاءِ
u'غير أَنْصارٌ':Added, #1: 1	غَيْرُ الْأَنْصَارِ
u'غير أَنْصَارٌ':Added, #1: 1	غَيْرُ الْأَنْصَارِ
u'غَيْرٌ أنصار':Added, #1: 1	غَيْرُ الْأَنْصَارِ
u'غَيْرٌ أَنْصارٌ':Added, #1: 1	غَيْرُ الْأَنْصَارِ
u'غَيْرٌ أَنْصَارٌ':Added, #1: 1	غَيْرُ الْأَنْصَارِ
u'غير اِنْضِمامٌ':Added, #1: 1	غَيْرُ الْأَنْصَارِ
u'غَيْرٌ اِنْضِمامٌ':Added, #1: 1	غَيْرِ انْضِمَامٍ
u'غير اِنْضِمامٌ':Added, #1: 1	غَيْرِ انْضِمَامٍ
u'غَيْرٌ اِنْضِمامٌ':Added, #4: 4	غَيْرِ انْضِمَامِ
u'غير أَنْفٌ':Added, #4: 4	غَيْرِ انْضِمَامِ
u'غَيْرٌ أَنْفٌ':Added, #1: 1	غَيْرِ الْأَنْفِ
u'غير اِنْفِصالٌ':Added, #1: 1	غَيْرِ الْأَنْفِ
u'غَيْرٌ اِنْفِصالٌ':Added, #1: 1	غَيْرِ انْفِصَالٍ
u'غير اِنْقِطاعٌ':Added, #1: 1	غَيْرِ انْفِصَالٍ
u'غَيْرٌ اِنْقِطاعٌ':Added, #2: 2	غَيْرِ انْقِطَاعِ
u'غير اِنْقِطاعٌ':Added, #2: 2	غَيْرِ انْقِطَاعِ
u'غَيْرٌ اِنْقِطاعٌ':Added, #4: 4	غَيْرِ انْقِطَاعٍ
u'غير إِنْكارٌ':Added, #4: 4	غَيْرِ انْقِطَاعٍ
u'غَيْرٌ إِنْكارٌ':Added, #1: 1	غَيْرُ الْإِنْكَارِ
u'غير إِنْكارٌ':Added, #1: 1	غَيْرُ الْإِنْكَارِ
u'غير إِنْكارٌ':Added, #1: 1	غَيْرَ إنْكَارِ
u'غَيْرٌ إِنْكارٌ':Added, #1: 1	غَيْرِ إنْكَارِ
u'غَيْرٌ إِنْكارٌ':Added, #1: 1	غَيْرَ إنْكَارِ
u'غير إِنْكارٌ':Added, #1: 1	غَيْرِ إنْكَارِ
u'غَيْرٌ إِنْكارٌ':Added, #1: 1	غَيْرَ إِنْكَارِهِ
u'غير إِنْكارٌ':Added, #1: 1	غَيْرَ إِنْكَارِهِ
u'غَيْرٌ إِنْكارٌ':Added, #26: 26	غَيْرِ إنْكَارٍ
u'غير إِنْكارٌ':Added, #26: 26	غَيْرِ إنْكَارٍ
u'غَيْرٌ إِنْكارٌ':Added, #2: 2	غَيْرِ إِنْكَارٍ
u'غير اِنْكِسارٌ':Added, #2: 2	غَيْرِ إِنْكَارٍ
u'غَيْرٌ اِنْكِسارٌ':Added, #1: 1	غَيْرِ انْكِسَارٍ
u'غير أُنْمُلَةٌ':Added, #1: 1	غَيْرِ انْكِسَارٍ
u'غَيْرٌ أُنْمُلَةٌ':Added, #1: 1	غَيْرِ الْأُنْمُلَةِ
u'غير أَنْوَاعٌ':Added, #1: 1	غَيْرِ الْأُنْمُلَةِ
u'غَيْرٌ أَنْوَاعٌ':Added, #1: 1	غَيْرِ الْأَنْوَاعِ
u'غير أَنْوَاعٌ':Added, #1: 1	غَيْرِ الْأَنْوَاعِ
u'غَيْرٌ أَنْوَاعٌ':Added, #1: 1	غَيْرِ أَنْوَاعِ
u'غير آنِيَةٌ':Added, #1: 1	غَيْرِ أَنْوَاعِ
u'غَيْرٌ آنِيَةٌ':Added, #1: 1	غَيْرِ الْآنِيَةِ
u'غير إهْدَاءٌ':Added, #1: 1	غَيْرِ الْآنِيَةِ
u'غَيْرٌ إهْدَاءٌ':Added, #1: 1	غَيْرِ إهْدَاءٍ
u'غير أهْلٌ':Added, #1: 1	غَيْرِ إهْدَاءٍ
u'غَيْرٌ أهْلٌ':Added, #12: 12	غَيْرَ أَهْلٍ
u'غير أهْلٌ':Added, #12: 12	غَيْرَ أَهْلٍ
u'غَيْرٌ أهْلٌ':Added, #12: 12	غَيْرَ أَهْلِهِ
u'غير أهْلٌ':Added, #12: 12	غَيْرَ أَهْلِهِ
u'غَيْرٌ أهْلٌ':Added, #18: 18	غَيْرُ أَهْلِ
u'غير أهْلٌ':Added, #18: 18	غَيْرُ أَهْلِ
u'غَيْرٌ أهْلٌ':Added, #1: 1	غَيْرُ الْأَهْلِ
u'غير أهْلٌ':Added, #1: 1	غَيْرُ الْأَهْلِ
u'غَيْرٌ أهْلٌ':Added, #35: 35	غَيْرِ أَهْلِهِ
u'غير أهْلٌ':Added, #35: 35	غَيْرِ أَهْلِهِ
u'غَيْرٌ أهْلٌ':Added, #4: 4	غَيْرِ الْأَهْلِ
u'غير أهْلٌ':Added, #4: 4	غَيْرِ الْأَهْلِ
u'غَيْرٌ أهْلٌ':Added, #4: 4	غَيْرَ أَهْلِ
u'غير أهْلٌ':Added, #4: 4	غَيْرَ أَهْلِ
u'غير أهْلٌ':Added, #5: 5	غَيْرُ أَهْلٍ
u'غَيْرٌ أهْلٌ':Added, #5: 5	غَيْرِ أَهْلٍ
u'غَيْرٌ أهْلٌ':Added, #5: 5	غَيْرُ أَهْلٍ
u'غير أهْلٌ':Added, #5: 5	غَيْرِ أَهْلٍ
u'غَيْرٌ أهْلٌ':Added, #70: 70	غَيْرِ أَهْلِ
u'غير أهْلٌ':Added, #70: 70	غَيْرِ أَهْلِ
u'غَيْرٌ أهْلٌ':Added, #7: 7	غَيْرُ أَهْلِهِ
u'غير أَهْلِيٌّ':Added, #7: 7	غَيْرُ أَهْلِهِ
u'غَيْرٌ أَهْلِيٌّ':Added, #1: 1	غَيْرِ أَهْلِيٍّ
u'غير إهْمَالٌ':Added, #1: 1	غَيْرِ أَهْلِيٍّ
u'غَيْرٌ إهْمَالٌ':Added, #1: 1	غَيْرِ إهْمَالٍ
u'غير أوامر':Added, #1: 1	غَيْرِ إهْمَالٍ
u'غير أَوامِرُ':Added, #1: 1	غَيْرِ الْأَوَامِرِ
u'غَيْرٌ أوامر':Added, #1: 1	غَيْرِ الْأَوَامِرِ
u'غَيْرٌ أَوامِرُ':Added, #1: 1	غَيْرِ الْأَوَامِرِ
u'غير أوَانٌ':Added, #1: 1	غَيْرِ الْأَوَامِرِ
u'غَيْرٌ أوَانٌ':Added, #1: 1	غَيْر أَوَانِهِ
u'غير أوَانٌ':Added, #1: 1	غَيْر أَوَانِهِ
u'غَيْرٌ أوَانٌ':Added, #32: 32	غَيْرِ أَوَانِهِ
u'غير أوَانٌ':Added, #32: 32	غَيْرِ أَوَانِهِ
u'غَيْرٌ أوَانٌ':Added, #6: 6	غَيْرِ أَوَانِ
u'غير أوْجَهُ':Added, #6: 6	غَيْرِ أَوَانِ
u'غَيْرٌ أوْجَهُ':Added, #1: 1	غَيْرُ الْأَوْجَهِ
u'غير أوْسَطُ':Added, #1: 1	غَيْرُ الْأَوْجَهِ
u'غَيْرٌ أوْسَطُ':Added, #1: 1	غَيْرِ الْأَوْسَطِ
u'غَيَّرَ أَوْصَافٌ':Predicate, #1: 1	غَيْرِ الْأَوْسَطِ
u'غير أَوْصَافٌ':Added, #2: 2	غَيَّرَ الْأَوْصَافَ
u'غَيْرٌ أَوْصَافٌ':Added, #1: 1	غَيْرِ الْأَوْصَافِ
u'غير أَوْصَافٌ':Added, #1: 1	غَيْرِ الْأَوْصَافِ
u'غَيْرٌ أَوْصَافٌ':Added, #1: 1	غَيْرَ أَوْصَافِ
u'غير أَوْقَاتٌ':Added, #1: 1	غَيْرَ أَوْصَافِ
u'غَيْرٌ أَوْقَاتٌ':Added, #1: 1	غَيْرِ أَوْقَاتِهِ
u'غير أَوْقَاتٌ':Added, #1: 1	غَيْرِ أَوْقَاتِهِ
u'غَيْرٌ أَوْقَاتٌ':Added, #2: 2	غَيْرِ أَوْقَاتِ
u'غير أَوْقَاتٌ':Added, #2: 2	غَيْرِ أَوْقَاتِ
u'غَيْرٌ أَوْقَاتٌ':Added, #3: 3	غَيْرِ الْأَوْقَاتِ
u'غير أَوَّلُ':Added, #3: 3	غَيْرِ الْأَوْقَاتِ
u'غَيْرٌ أَوَّلُ':Added, #16: 16	غَيْرِ الْأَوَّلِ
u'غير أَوَّلُ':Added, #16: 16	غَيْرِ الْأَوَّلِ
u'غَيْرٌ أَوَّلُ':Added, #1: 1	غَيْرَ الْأَوّلِ
u'غير أَوَّلُ':Added, #1: 1	غَيْرَ الْأَوّلِ
u'غَيْرٌ أَوَّلُ':Added, #1: 1	غَيْرُ الْأَوَّلَيْنِ
u'غير أَوَّلُ':Added, #1: 1	غَيْرُ الْأَوَّلَيْنِ
u'غَيْرٌ أَوَّلُ':Added, #1: 1	غَيْرِ أَوَّلِ
u'غير أَوَّلُ':Added, #1: 1	غَيْرِ أَوَّلِ
u'غير أَوَّلُ':Added, #30: 30	غَيْرَ الْأَوَّلِ
u'غَيْرٌ أَوَّلُ':Added, #30: 30	غَيْرُ الْأَوَّلِ
u'غَيْرٌ أَوَّلُ':Added, #30: 30	غَيْرَ الْأَوَّلِ
u'غير أَوْلاَدٌ':Added, #30: 30	غَيْرُ الْأَوَّلِ
u'غَيْرٌ أَوْلاَدٌ':Added, #1: 1	غَيْرُ الْأَوْلَادِ
u'غير أَوْلاَدٌ':Added, #1: 1	غَيْرُ الْأَوْلَادِ
u'غَيْرٌ أَوْلاَدٌ':Added, #1: 1	غَيْرِ أَوْلَادٍ
u'غير أَوْلاَدٌ':Added, #1: 1	غَيْرِ أَوْلَادٍ
u'غَيْرٌ أَوْلاَدٌ':Added, #1: 1	غَيْرُ أَوْلَادِهِ
u'غير أَوْلاَدٌ':Added, #1: 1	غَيْرُ أَوْلَادِهِ
u'غَيْرٌ أَوْلاَدٌ':Added, #3: 3	غَيْرِ أَوْلَادِ
u'غير أَوْلاَدٌ':Added, #3: 3	غَيْرِ أَوْلَادِ
u'غَيْرٌ أَوْلاَدٌ':Added, #3: 3	غَيْرِ أَوْلَادِهِ
u'غير أَوَّلِيٌّ':Added, #3: 3	غَيْرِ أَوْلَادِهِ
u'غَيْرٌ أَوَّلِيٌّ':Added, #1: 1	غَيْرِ الْأَوَّلِيَّيْنِ
u'غير أَوَّلِيٌّ':Added, #1: 1	غَيْرِ الْأَوَّلِيَّيْنِ
u'غَيْرٌ أَوَّلِيٌّ':Added, #2: 2	غَيْرَ الْأَوَّلِيَّةِ
u'غير أولى':Added, #2: 2	غَيْرَ الْأَوَّلِيَّةِ
u'غير أوْلَى':Added, #3: 3	غَيْرِ الْأُولَيَيْنِ
u'غَيْرٌ أولى':Added, #3: 3	غَيْرِ الْأُولَيَيْنِ
u'غَيْرٌ أوْلَى':Added, #3: 3	غَيْرِ الْأُولَيَيْنِ
u'غير أَوْلِيَاءُ':Added, #3: 3	غَيْرِ الْأُولَيَيْنِ
u'غَيْرٌ أَوْلِيَاءُ':Added, #3: 3	غَيْرِ الْأَوْلِيَاءِ
u'غير اِئْتِمَانٌ':Added, #3: 3	غَيْرِ الْأَوْلِيَاءِ
u'غَيْرٌ اِئْتِمَانٌ':Added, #1: 1	غَيْرُ ائْتِمَانٍ
u'غير أئِمَّةٌ':Added, #1: 1	غَيْرُ ائْتِمَانٍ
u'غَيْرٌ أئِمَّةٌ':Added, #1: 1	غَيْرِ أَئِمَّةِ
u'غير أئِمَّةٌ':Added, #1: 1	غَيْرِ أَئِمَّةِ
u'غَيْرٌ أئِمَّةٌ':Added, #4: 4	غَيْرِ الْأَئِمَّةِ
u'غير إيابٌ':Added, #4: 4	غَيْرِ الْأَئِمَّةِ
u'غَيْرٌ إيابٌ':Added, #1: 1	غَيْرَ الْإِيَابِ
u'غير أيَّامٌ':Added, #1: 1	غَيْرَ الْإِيَابِ
u'غير أَيَّامٌ':Added, #1: 1	غَيْرِ الْأَيَّامِ
u'غَيْرٌ أيَّامٌ':Added, #1: 1	غَيْرِ الْأَيَّامِ
u'غَيْرٌ أَيَّامٌ':Added, #1: 1	غَيْرِ الْأَيَّامِ
u'غير أيَّامٌ':Added, #1: 1	غَيْرِ الْأَيَّامِ
u'غير أَيَّامٌ':Added, #1: 1	غَيْرِ أَيَّامِهِ
u'غَيْرٌ أيَّامٌ':Added, #1: 1	غَيْرِ أَيَّامِهِ
u'غَيْرٌ أَيَّامٌ':Added, #1: 1	غَيْرِ أَيَّامِهِ
u'غير أيَّامٌ':Added, #1: 1	غَيْرِ أَيَّامِهِ
u'غير أَيَّامٌ':Added, #23: 23	غَيْرِ أَيَّامِ
u'غَيْرٌ أيَّامٌ':Added, #23: 23	غَيْرِ أَيَّامِ
u'غَيْرٌ أَيَّامٌ':Added, #23: 23	غَيْرِ أَيَّامِ
u'غير أيَّامٌ':Added, #23: 23	غَيْرِ أَيَّامِ
u'غير أَيَّامٌ':Added, #2: 2	غَيْرَ الْأَيَّامِ
u'غَيْرٌ أيَّامٌ':Added, #2: 2	غَيْرَ الْأَيَّامِ
u'غَيْرٌ أَيَّامٌ':Added, #2: 2	غَيْرَ الْأَيَّامِ
u'غير أيَّامٌ':Added, #2: 2	غَيْرَ الْأَيَّامِ
u'غير أَيَّامٌ':Added, #2: 2	غَيْرَ أَيَّامِ
u'غَيْرٌ أيَّامٌ':Added, #2: 2	غَيْرَ أَيَّامِ
u'غَيْرٌ أَيَّامٌ':Added, #2: 2	غَيْرَ أَيَّامِ
u'غير آيَةٌ':Added, #2: 2	غَيْرَ أَيَّامِ
u'غَيْرٌ آيَةٌ':Added, #1: 1	غَيْرُ آيَةٍ
u'غير آيَةٌ':Added, #1: 1	غَيْرُ آيَةٍ
u'غَيْرٌ آيَةٌ':Added, #3: 3	غَيْرِ آيَةٍ
u'غير إِيثَارٌ':Added, #3: 3	غَيْرِ آيَةٍ
u'غَيْرٌ إِيثَارٌ':Added, #1: 1	غَيْرِ إيثَارٍ
u'غير إِيجَابٌ':Added, #1: 1	غَيْرِ إيثَارٍ
u'غَيْرٌ إِيجَابٌ':Added, #11: 11	غَيْرِ إيجَابٍ
u'غير إِيجَابٌ':Added, #11: 11	غَيْرِ إيجَابٍ
u'غير إِيجَابٌ':Added, #1: 1	غَيْرُ الْإِيجَابِ
u'غَيْرٌ إِيجَابٌ':Added, #1: 1	غَيْرِ الْإِيجَابِ
u'غَيْرٌ إِيجَابٌ':Added, #1: 1	غَيْرُ الْإِيجَابِ
u'غير إِيدَاعٌ':Added, #1: 1	غَيْرِ الْإِيجَابِ
u'غَيْرٌ إِيدَاعٌ':Added, #2: 2	غَيْرِ إيدَاعٍ
u'غير أَيْسَرُ':Added, #2: 2	غَيْرِ إيدَاعٍ
u'غَيْرٌ أَيْسَرُ':Added, #1: 1	غَيْرَ أَيْسَرِ
u'غير إيصَالٌ':Added, #1: 1	غَيْرَ أَيْسَرِ
u'غَيْرٌ إيصَالٌ':Added, #1: 1	غَيْرِ إيصَالِ
u'غير إِيطَاءٌ':Added, #1: 1	غَيْرِ إيصَالِ
u'غَيْرٌ إِيطَاءٌ':Added, #3: 3	غَيْرِ الْإِيطَاءِ
u'غير إيقَاعٌ':Added, #3: 3	غَيْرِ الْإِيطَاءِ
u'غَيْرٌ إيقَاعٌ':Added, #1: 1	غَيْرُ الْإِيقَاعِ
u'غير أُيَّلٌ':Added, #1: 1	غَيْرُ الْإِيقَاعِ
u'غَيْرٌ أُيَّلٌ':Added, #1: 1	غَيْرُ الْأُيَّلِ
u'غَيَّرَ إيمَانٌ':Predicate, #1: 1	غَيْرُ الْأُيَّلِ
u'غير إِيهَامٌ':Added, #1: 1	غَيَّرَ الْإِيمَانَ
u'غَيْرٌ إِيهَامٌ':Added, #1: 1	غَيْرِ إيهَامٍ
u'غير بَابٌ':Added, #1: 1	غَيْرِ إيهَامٍ
u'غَيْرٌ بَابٌ':Added, #1: 1	غَيْرَ الْبَابِ
u'غير بَابٌ':Added, #1: 1	غَيْرَ الْبَابِ
u'غير بَابٌ':Added, #1: 1	غَيْرَ بَابِ
u'غير بَابٌ':Added, #1: 1	غَيْرِ بَابٍ
u'غَيْرٌ بَابٌ':Added, #1: 1	غَيْرِ بَابِ
u'غَيْرٌ بَابٌ':Added, #1: 1	غَيْرَ بَابِ
u'غَيْرٌ بَابٌ':Added, #1: 1	غَيْرِ بَابٍ
u'غير بَابٌ':Added, #1: 1	غَيْرِ بَابِ
u'غَيْرٌ بَابٌ':Added, #2: 2	غَيْرِ بَابِهِ
u'غير بَابٌ':Added, #2: 2	غَيْرِ بَابِهِ
u'غَيْرٌ بَابٌ':Added, #6: 6	غَيْرِ الْبَابِ
u'غير باتٌّ':Added, #6: 6	غَيْرِ الْبَابِ
u'غَيْرٌ باتٌّ':Added, #2: 2	غَيْرُ بَاتٍّ
u'غير بَاحِثٌ':Added, #2: 2	غَيْرُ بَاتٍّ
u'غَيْرٌ بَاحِثٌ':Added, #1: 1	غَيْرُ بَاحِثِ
u'غير بادِي':Added, #1: 1	غَيْرُ بَاحِثِ
u'غَيْرٌ بادِي':Added, #1: 1	غَيْرِ الْبَادِيَةِ
u'غير بَادِيَةٌ':Added, #1: 1	غَيْرِ الْبَادِيَةِ
u'غَيْرٌ بَادِيَةٌ':Added, #1: 1	غَيْرِ الْبَادِيَةِ
u'غير باذِلٌ':Added, #1: 1	غَيْرِ الْبَادِيَةِ
u'غَيْرٌ باذِلٌ':Added, #1: 1	غَيْرِ الْبَاذِلِ
u'غير باذِلٌ':Added, #1: 1	غَيْرِ الْبَاذِلِ
u'غَيْرٌ باذِلٌ':Added, #1: 1	غَيْرُ بَاذِلٍ
u'غير بَأسٌ':Added, #1: 1	غَيْرُ بَاذِلٍ
u'غَيْرٌ بَأسٌ':Added, #3: 3	غَيْرِ بَأْسٍ
u'غير باطِش':Added, #3: 3	غَيْرِ بَأْسٍ
u'غَيْرٌ باطِش':Added, #1: 1	غَيْرَ بَاطِشَتَيْنِ
u'غير بَاطِلٌ':Added, #1: 1	غَيْرَ بَاطِشَتَيْنِ
u'غير بَاطِلٌ':Added, #1: 1	غَيْرُ بَاطِلٍ
u'غَيْرٌ بَاطِلٌ':Added, #1: 1	غَيْرُ بَاطِلِ
u'غَيْرٌ بَاطِلٌ':Added, #1: 1	غَيْرُ بَاطِلٍ
u'غير باقِي':Added, #1: 1	غَيْرُ بَاطِلِ
u'غَيْرٌ باقِي':Added, #3: 3	غَيْرُ بَاقِيَةٍ
u'غير باقِيَةٌ':Added, #3: 3	غَيْرُ بَاقِيَةٍ
u'غَيْرٌ باقِيَةٌ':Added, #3: 3	غَيْرُ بَاقِيَةٍ
u'غير بالٌ':Added, #3: 3	غَيْرُ بَاقِيَةٍ
u'غير بَالٌ':Added, #1: 1	غَيْرَ بَالٍ
u'غَيْرٌ بالٌ':Added, #1: 1	غَيْرَ بَالٍ
u'غَيْرٌ بَالٌ':Added, #1: 1	غَيْرَ بَالٍ
u'غير بالِغٌ':Added, #1: 1	غَيْرَ بَالٍ
u'غَيْرٌ بالِغٌ':Added, #19: 19	غَيْرَ بَالِغٍ
u'غير بالِغٌ':Added, #19: 19	غَيْرَ بَالِغٍ
u'غَيْرٌ بالِغٌ':Added, #1: 1	غَيْرَ الْبَالِغَةِ
u'غير بالِغٌ':Added, #1: 1	غَيْرَ الْبَالِغَةِ
u'غَيْرٌ بالِغٌ':Added, #1: 1	غَيْرِ الْبَالِغَيْنِ
u'غير بالِغٌ':Added, #1: 1	غَيْرِ الْبَالِغَيْنِ
u'غير بالِغٌ':Added, #1: 1	غَيْرَ بَالِغَةٍ
u'غَيْرٌ بالِغٌ':Added, #1: 1	غَيْرِ بَالِغَةٍ
u'غَيْرٌ بالِغٌ':Added, #1: 1	غَيْرَ بَالِغَةٍ
u'غير بالِغٌ':Added, #1: 1	غَيْرِ بَالِغَةٍ
u'غَيْرٌ بالِغٌ':Added, #2: 2	غَيْرَ الْبَالِغِ
u'غير بالِغٌ':Added, #2: 2	غَيْرَ الْبَالِغِ
u'غَيْرٌ بالِغٌ':Added, #2: 2	غَيْرِ بَالِغٍ
u'غير بالِغٌ':Added, #2: 2	غَيْرِ بَالِغٍ
u'غَيْرٌ بالِغٌ':Added, #3: 3	غَيْرِ الْبَالِغَةِ
u'غير بالِغٌ':Added, #3: 3	غَيْرِ الْبَالِغَةِ
u'غَيْرٌ بالِغٌ':Added, #3: 3	غَيْرُ بَالِغَةٍ
u'غير بالِغٌ':Added, #3: 3	غَيْرُ بَالِغَةٍ
u'غَيْرٌ بالِغٌ':Added, #3: 3	غَيْرَ بَالِغَيْنِ
u'غير بالِغٌ':Added, #3: 3	غَيْرَ بَالِغَيْنِ
u'غَيْرٌ بالِغٌ':Added, #4: 4	غَيْرُ الْبَالِغِ
u'غير بالِغٌ':Added, #4: 4	غَيْرُ الْبَالِغِ
u'غَيْرٌ بالِغٌ':Added, #6: 6	غَيْرِ الْبَالِغِ
u'غير بالِغٌ':Added, #6: 6	غَيْرِ الْبَالِغِ
u'غَيْرٌ بالِغٌ':Added, #7: 7	غَيْرُ بَالِغٍ
u'غير بَانٌ':Added, #7: 7	غَيْرُ بَالِغٍ
u'غَيْرٌ بَانٌ':Added, #1: 1	غَيْرَ بَانٍ
u'غير باهِل':Added, #1: 1	غَيْرَ بَانٍ
u'غَيْرٌ باهِل':Added, #2: 2	غَيْرَ بَاهِلِ
u'غير بَائِعٌ':Added, #2: 2	غَيْرَ بَاهِلِ
u'غَيْرٌ بَائِعٌ':Added, #15: 15	غَيْرُ الْبَائِعِ
u'غير بَائِعٌ':Added, #15: 15	غَيْرُ الْبَائِعِ
u'غَيْرٌ بَائِعٌ':Added, #1: 1	غَيْرِ بَائِعِ
u'غير بَائِعٌ':Added, #1: 1	غَيْرِ بَائِعِ
u'غَيْرٌ بَائِعٌ':Added, #24: 24	غَيْرِ الْبَائِعِ
u'غير بَائِعٌ':Added, #24: 24	غَيْرِ الْبَائِعِ
u'غَيْرٌ بَائِعٌ':Added, #2: 2	غَيْرَ الْبَائِعِ
u'غير بَائِعٌ':Added, #2: 2	غَيْرَ الْبَائِعِ
u'غَيْرٌ بَائِعٌ':Added, #2: 2	غَيْرُ بَائِعِهِ
u'غير بَائِعٌ':Added, #2: 2	غَيْرُ بَائِعِهِ
u'غَيْرٌ بَائِعٌ':Added, #3: 3	غَيْرِ بَائِعِهِ
u'غير بَائِنٌ':Added, #3: 3	غَيْرِ بَائِعِهِ
u'غَيْرٌ بَائِنٌ':Added, #1: 1	غَيْرِ الْبَائِنِ
u'غير بَائِنٌ':Added, #1: 1	غَيْرِ الْبَائِنِ
u'غَيْرٌ بَائِنٌ':Added, #1: 1	غَيْرُ بَائِنَةٍ
u'غير بَائِنٌ':Added, #1: 1	غَيْرُ بَائِنَةٍ
u'غَيْرٌ بَائِنٌ':Added, #2: 2	غَيْرِ بَائِنٍ
u'غير بَائِنٌ':Added, #2: 2	غَيْرِ بَائِنٍ
u'غَيْرٌ بَائِنٌ':Added, #3: 3	غَيْرُ بَائِنٍ
u'غير بَائِنٌ':Added, #3: 3	غَيْرُ بَائِنٍ
u'غَيْرٌ بَائِنٌ':Added, #4: 4	غَيْرَ بَائِنٍ
u'غير بَحْثٌ':Added, #4: 4	غَيْرَ بَائِنٍ
u'غَيْرٌ بَحْثٌ':Added, #11: 11	غَيْرِ بَحْثٍ
u'غير بَحْثٌ':Added, #11: 11	غَيْرِ بَحْثٍ
u'غَيْرٌ بَحْثٌ':Added, #1: 1	غَيْرَ الْبَحْثِ
u'غير بَحْثٌ':Added, #1: 1	غَيْرَ الْبَحْثِ
u'غَيْرٌ بَحْثٌ':Added, #1: 1	غَيْر بَحْثٍ
u'غير بَحْثٌ':Added, #1: 1	غَيْر بَحْثٍ
u'غَيْرٌ بَحْثٌ':Added, #2: 2	غَيْرُ بَحْثٍ
u'غير بُخَارِيٌّ':Added, #2: 2	غَيْرُ بَحْثٍ
u'غير بُخَارِيٌّ':Added, #1: 1	غَيْرُ الْبُخَارِيِّ
u'غَيْرٌ بُخَارِيٌّ':Added, #1: 1	غَيْرِ الْبُخَارِيِّ
u'غَيْرٌ بُخَارِيٌّ':Added, #1: 1	غَيْرُ الْبُخَارِيِّ
u'غير بَخْسٌ':Added, #1: 1	غَيْرِ الْبُخَارِيِّ
u'غَيْرٌ بَخْسٌ':Added, #2: 2	غَيْرِ بَخْسٍ
u'غير بُخْلٌ':Added, #2: 2	غَيْرِ بَخْسٍ
u'غَيْرٌ بُخْلٌ':Added, #2: 2	غَيْرِ بُخْلٍ
u'غير بِدَعٌ':Added, #2: 2	غَيْرِ بُخْلٍ
u'غَيْرٌ بِدَعٌ':Added, #1: 1	غَيْرِ الْبِدَعِ
u'غير بِدَعٌ':Added, #1: 1	غَيْرِ الْبِدَعِ
u'غَيْرٌ بِدَعٌ':Added, #1: 1	غَيْرُ بِدَعٍ
u'غير بِدَعٌ':Added, #1: 1	غَيْرُ بِدَعٍ
u'غَيْرٌ بِدَعٌ':Added, #2: 2	غَيْرُ الْبِدَعِ
u'غير بِدْعَةٌ':Added, #2: 2	غَيْرُ الْبِدَعِ
u'غَيْرٌ بِدْعَةٌ':Added, #1: 1	غَيْرَ بِدْعَةٍ
u'غير بِدْعَةٌ':Added, #1: 1	غَيْرَ بِدْعَةٍ
u'غَيْرٌ بِدْعَةٌ':Added, #1: 1	غَيْرِ بِدْعَتِهِ
u'غير بِدْعَةٌ':Added, #1: 1	غَيْرِ بِدْعَتِهِ
u'غَيْرٌ بِدْعَةٌ':Added, #3: 3	غَيْرُ بِدْعَةٍ
u'غير بدعيٌّ':Added, #3: 3	غَيْرُ بِدْعَةٍ
u'غَيْرٌ بدعيٌّ':Added, #1: 1	غَيْرُ بِدْعِيٍّ
u'غير بَدَلٌ':Added, #1: 1	غَيْرُ بِدْعِيٍّ
u'غَيْرٌ بَدَلٌ':Added, #15: 15	غَيْرِ بَدَلٍ
u'غير بَدَلٌ':Added, #15: 15	غَيْرِ بَدَلٍ
u'غَيْرٌ بَدَلٌ':Added, #1: 1	غَيْرُ الْبَدَلِ
u'غير بَدَلٌ':Added, #1: 1	غَيْرُ الْبَدَلِ
u'غير بَدَلٌ':Added, #1: 1	غَيْرَ بَدَلِ
u'غَيْرٌ بَدَلٌ':Added, #1: 1	غَيْرُ بَدَلِ
u'غَيْرٌ بَدَلٌ':Added, #1: 1	غَيْرَ بَدَلِ
u'غير بَدَلٌ':Added, #1: 1	غَيْرُ بَدَلِ
u'غَيْرٌ بَدَلٌ':Added, #2: 2	غَيْرِ الْبَدَلِ
u'غير بَدَلٌ':Added, #2: 2	غَيْرِ الْبَدَلِ
u'غَيْرٌ بَدَلٌ':Added, #2: 2	غَيْرُ بَدَلٍ
u'غير بَدَلٌ':Added, #2: 2	غَيْرُ بَدَلٍ
u'غَيْرٌ بَدَلٌ':Added, #3: 3	غَيْرِ بَدَلِ
u'غير بدن':Added, #3: 3	غَيْرِ بَدَلِ
u'غَيْرٌ بدن':Added, #2: 2	غَيْرِ بَدَنِهِ
u'غير بَدَنٌ':Added, #2: 2	غَيْرِ بَدَنِهِ
u'غَيْرٌ بَدَنٌ':Added, #2: 2	غَيْرِ بَدَنِهِ
u'غير بدن':Added, #2: 2	غَيْرِ بَدَنِهِ
u'غَيْرٌ بدن':Added, #4: 4	غَيْرِ الْبَدَنِ
u'غير بَدَنٌ':Added, #4: 4	غَيْرِ الْبَدَنِ
u'غَيْرٌ بَدَنٌ':Added, #4: 4	غَيْرِ الْبَدَنِ
u'غير بَذْلٌ':Added, #4: 4	غَيْرِ الْبَدَنِ
u'غير بَذْلٌ':Added, #1: 1	غَيْرِ بَذْلٍ
u'غَيْرٌ بَذْلٌ':Added, #1: 1	غَيْرِ بَذْلِ
u'غَيْرٌ بَذْلٌ':Added, #1: 1	غَيْرِ بَذْلٍ
u'غير بُرٌّ':Added, #1: 1	غَيْرِ بَذْلِ
u'غَيْرٌ بُرٌّ':Added, #1: 1	غَيْرُ الْبُرِّ
u'غير بُرٌّ':Added, #1: 1	غَيْرُ الْبُرِّ
u'غَيْرٌ بُرٌّ':Added, #1: 1	غَيْرِ بُرٍّ
u'غير بُرٌّ':Added, #1: 1	غَيْرِ بُرٍّ
u'غَيْرٌ بُرٌّ':Added, #4: 4	غَيْرِ الْبُرِّ
u'غير براءٌ':Added, #4: 4	غَيْرِ الْبُرِّ
u'غير بَراءٌ':Added, #1: 1	غَيْرِ الْبَرَاءِ
u'غَيْرٌ براءٌ':Added, #1: 1	غَيْرِ الْبَرَاءِ
u'غَيْرٌ بَراءٌ':Added, #1: 1	غَيْرِ الْبَرَاءِ
u'غير بَراءةٌ':Added, #1: 1	غَيْرِ الْبَرَاءِ
u'غير بَراءةٌ':Added, #1: 1	غَيْرَ الْبَرَاءَةِ
u'غَيْرٌ بَراءةٌ':Added, #1: 1	غَيْرُ الْبَرَاءَةِ
u'غَيْرٌ بَراءةٌ':Added, #1: 1	غَيْرَ الْبَرَاءَةِ
u'غير بَراءةٌ':Added, #1: 1	غَيْرُ الْبَرَاءَةِ
u'غَيْرٌ بَراءةٌ':Added, #1: 1	غَيْرِ بَرَاءَةٍ
u'غير برزة':Added, #1: 1	غَيْرِ بَرَاءَةٍ
u'غير برزة':Added, #1: 1	غَيْرَ بَرْزَةٍ
u'غَيْرٌ برزة':Added, #1: 1	غَيْرِ بَرْزَةٍ
u'غَيْرٌ برزة':Added, #1: 1	غَيْرَ بَرْزَةٍ
u'غير بُرْهانٌ':Added, #1: 1	غَيْرِ بَرْزَةٍ
u'غير بُرْهَانٌ':Added, #3: 3	غَيْرِ بُرْهَانٍ
u'غَيْرٌ بُرْهانٌ':Added, #3: 3	غَيْرِ بُرْهَانٍ
u'غَيْرٌ بُرْهَانٌ':Added, #3: 3	غَيْرِ بُرْهَانٍ
u'غير بَزّ':Added, #3: 3	غَيْرِ بُرْهَانٍ
u'غَيْرٌ بَزّ':Added, #2: 2	غَيْرِ الْبَزِّ
u'غير بُسْتانٌ':Added, #2: 2	غَيْرِ الْبَزِّ
u'غَيْرٌ بُسْتانٌ':Added, #1: 1	غَيْرَ الْبُسْتَانِ
u'غير بُسْرٌ':Added, #1: 1	غَيْرَ الْبُسْتَانِ
u'غَيْرٌ بُسْرٌ':Added, #1: 1	غَيْرُ الْبُسْرِ
u'غير بَسْمَلَةٌ':Added, #1: 1	غَيْرُ الْبُسْرِ
u'غَيْرٌ بَسْمَلَةٌ':Added, #1: 1	غَيْرِ الْبَسْمَلَةِ
u'غير بَسيطٌ':Added, #1: 1	غَيْرِ الْبَسْمَلَةِ
u'غَيْرٌ بَسيطٌ':Added, #1: 1	غَيْرِ الْبَسِيطِ
u'غير بَشَرٌ':Added, #1: 1	غَيْرِ الْبَسِيطِ
u'غَيْرٌ بَشَرٌ':Added, #1: 1	غَيْرِ بَشَرٍ
u'غير بَصَرٌ':Added, #1: 1	غَيْرِ بَشَرٍ
u'غَيْرٌ بَصَرٌ':Added, #1: 1	غَيْرَ الْبَصَرِ
u'غير بَصيرَةٌ':Added, #1: 1	غَيْرَ الْبَصَرِ
u'غَيْرٌ بَصيرَةٌ':Added, #2: 2	غَيْرِ بَصِيرَةٍ
u'غير بِطانَةٌ':Added, #2: 2	غَيْرِ بَصِيرَةٍ
u'غَيْرٌ بِطانَةٌ':Added, #1: 1	غَيْرُ الْبِطَانَةِ
u'غير بَطْنٌ':Added, #1: 1	غَيْرُ الْبِطَانَةِ
u'غَيْرٌ بَطْنٌ':Added, #1: 1	غَيْرَ الْبَطْنِ
u'غَيَّرَ بَعْضٌ':Predicate, #1: 1	غَيْرَ الْبَطْنِ
u'غَيَّرَ بَعْضٌ':Subject, #1: 1	غَيَّرَ بَعْضَ
u'غير بَعْضٌ':Added, #1: 1	غَيَّرَ بَعْضُ
u'غَيْرٌ بَعْضٌ':Added, #1: 1	غَيْرَ بَعْضٍ
u'غير بَعْضٌ':Added, #1: 1	غَيْرَ بَعْضٍ
u'غَيْرٌ بَعْضٌ':Added, #1: 1	غَيْرَ بَعْضِهِ
u'غير بَعيدٌ':Added, #1: 1	غَيْرَ بَعْضِهِ
u'غَيْرٌ بَعيدٌ':Added, #1: 1	غَيْرُ الْبَعِيدِ
u'غير بَعيرٌ':Added, #1: 1	غَيْرُ الْبَعِيدِ
u'غَيْرٌ بَعيرٌ':Added, #1: 1	غَيْرِ الْبَعِيرِ
u'غير بَغْلٌ':Added, #1: 1	غَيْرِ الْبَعِيرِ
u'غَيْرٌ بَغْلٌ':Added, #1: 1	غَيْرُ بَغْلٍ
u'غير بَقاءٌ':Added, #1: 1	غَيْرُ بَغْلٍ
u'غَيْرٌ بَقاءٌ':Added, #2: 2	غَيْرِ بَقَاءِ
u'غير بَقَرٌ':Added, #2: 2	غَيْرِ بَقَاءِ
u'غَيْرٌ بَقَرٌ':Added, #1: 1	غَيْرِ بَقَرَةِ
u'غير بُقْعَةٌ':Added, #1: 1	غَيْرِ بَقَرَةِ
u'غَيْرٌ بُقْعَةٌ':Added, #1: 1	غَيْرِ الْبُقْعَةِ
u'غير بَقِيَّةٌ':Added, #1: 1	غَيْرِ الْبُقْعَةِ
u'غَيْرٌ بَقِيَّةٌ':Added, #1: 1	غَيْرَ بَقِيَّةٍ
u'غير بِكْرٌ':Added, #1: 1	غَيْرَ بَقِيَّةٍ
u'غَيْرٌ بِكْرٌ':Added, #1: 1	غَيْرِ الْبِكْرِ
u'غير بِكْرٌ':Added, #1: 1	غَيْرِ الْبِكْرِ
u'غَيْرٌ بِكْرٌ':Added, #3: 3	غَيْرَ بِكْرٍ
u'غير بَلاءٌ':Added, #3: 3	غَيْرَ بِكْرٍ
u'غَيْرٌ بَلاءٌ':Added, #1: 1	غَيْرِ بَلَاءٍ
u'غير بِلادٌ':Added, #1: 1	غَيْرِ بَلَاءٍ
u'غَيْرٌ بِلادٌ':Added, #1: 1	غَيْرِ الْبِلَادِ
u'غير بِلادٌ':Added, #1: 1	غَيْرِ الْبِلَادِ
u'غَيْرٌ بِلادٌ':Added, #1: 1	غَيْرُ بِلاَدِ
u'غير بلاغ':Added, #1: 1	غَيْرُ بِلاَدِ
u'غير بَلاغٌ':Added, #1: 1	غَيْرِ الْبَلَاغِ
u'غَيْرٌ بلاغ':Added, #1: 1	غَيْرِ الْبَلَاغِ
u'غَيْرٌ بَلاغٌ':Added, #1: 1	غَيْرِ الْبَلَاغِ
u'غير بَلَدٌ':Added, #1: 1	غَيْرِ الْبَلَاغِ
u'غَيْرٌ بَلَدٌ':Added, #18: 18	غَيْرِ الْبَلَدِ
u'غير بَلَدٌ':Added, #18: 18	غَيْرِ الْبَلَدِ
u'غَيْرٌ بَلَدٌ':Added, #25: 25	غَيْرِ بَلَدِ
u'غير بَلَدٌ':Added, #25: 25	غَيْرِ بَلَدِ
u'غَيْرٌ بَلَدٌ':Added, #25: 25	غَيْرِ بَلَدِهِ
u'غير بَلَدٌ':Added, #25: 25	غَيْرِ بَلَدِهِ
u'غَيْرٌ بَلَدٌ':Added, #2: 2	غَيْرَ الْبَلَدِ
u'غير بَلَدٌ':Added, #2: 2	غَيْرَ الْبَلَدِ
u'غَيْرٌ بَلَدٌ':Added, #2: 2	غَيْرَ بَلَدِ
u'غير بَلَدٌ':Added, #2: 2	غَيْرَ بَلَدِ
u'غَيْرٌ بَلَدٌ':Added, #2: 2	غَيْرُ بَلَدِهِ
u'غير بلغة':Added, #2: 2	غَيْرُ بَلَدِهِ
u'غَيْرٌ بلغة':Added, #1: 1	غَيْرِ الْبُلْغَةِ
u'غير بُلْغَةٌ':Added, #1: 1	غَيْرِ الْبُلْغَةِ
u'غَيْرٌ بُلْغَةٌ':Added, #1: 1	غَيْرِ الْبُلْغَةِ
u'غير بَلْغَم':Added, #1: 1	غَيْرِ الْبُلْغَةِ
u'غَيْرٌ بَلْغَم':Added, #1: 1	غَيْرِ الْبَلْغَمِ
u'غير بَلِيَّةٌ':Added, #1: 1	غَيْرِ الْبَلْغَمِ
u'غَيْرٌ بَلِيَّةٌ':Added, #3: 3	غَيْرِ بَلِيَّةٍ
u'غير بَليغٌ':Added, #3: 3	غَيْرِ بَلِيَّةٍ
u'غَيْرٌ بَليغٌ':Added, #1: 1	غَيْرِ الْبَلِيغِ
u'غير بِنَاءٌ':Added, #1: 1	غَيْرِ الْبَلِيغِ
u'غَيْرٌ بِنَاءٌ':Added, #16: 16	غَيْرِ بِنَاءٍ
u'غير بِنَاءٌ':Added, #16: 16	غَيْرِ بِنَاءٍ
u'غَيْرٌ بِنَاءٌ':Added, #4: 4	غَيْرِ الْبِنَاءِ
u'غير بِنَاءٌ':Added, #4: 4	غَيْرِ الْبِنَاءِ
u'غَيْرٌ بِنَاءٌ':Added, #4: 4	غَيْرِ بِنَاءِ
u'غير بناتٌ':Added, #4: 4	غَيْرِ بِنَاءِ
u'غير بناتٌ':Added, #1: 1	غَيْرَ الْبَنَاتِ
u'غَيْرٌ بناتٌ':Added, #1: 1	غَيْرِ الْبَنَاتِ
u'غَيْرٌ بناتٌ':Added, #1: 1	غَيْرَ الْبَنَاتِ
u'غير بناتٌ':Added, #1: 1	غَيْرِ الْبَنَاتِ
u'غَيْرٌ بناتٌ':Added, #1: 1	غَيْرِ بَنَاتِ
u'غير بِنْتٌ':Added, #1: 1	غَيْرِ بَنَاتِ
u'غير بِنْتٌ':Added, #1: 1	غَيْرُ بِنْتِ
u'غَيْرٌ بِنْتٌ':Added, #1: 1	غَيْرِ بِنْتِ
u'غَيْرٌ بِنْتٌ':Added, #1: 1	غَيْرُ بِنْتِ
u'غير بَنَفْسَجٌ':Added, #1: 1	غَيْرِ بِنْتِ
u'غَيْرٌ بَنَفْسَجٌ':Added, #1: 1	غَيْرَ الْبَنَفْسَجِ
u'غير بُنُوَّة':Added, #1: 1	غَيْرَ الْبَنَفْسَجِ
u'غَيْرٌ بُنُوَّة':Added, #1: 1	غَيْرِ الْبُنُوَّةِ
u'غير بُنُوَّة':Added, #1: 1	غَيْرِ الْبُنُوَّةِ
u'غَيْرٌ بُنُوَّة':Added, #2: 2	غَيْرِ بُنُوَّةٍ
u'غير بَهيمٌ':Added, #2: 2	غَيْرِ بُنُوَّةٍ
u'غَيْرٌ بَهيمٌ':Added, #1: 1	غَيْرِ بَهِيمَةِ
u'غير بَهِيمَةٌ':Added, #1: 1	غَيْرِ بَهِيمَةِ
u'غَيْرٌ بَهِيمَةٌ':Added, #1: 1	غَيْرِ بَهِيمَةِ
u'غير بَوْلٌ':Added, #1: 1	غَيْرِ بَهِيمَةِ
u'غير بَوْلٌ':Added, #1: 1	غَيْرَ بَوْلٍ
u'غَيْرٌ بَوْلٌ':Added, #1: 1	غَيْرُ بَوْلٍ
u'غَيْرٌ بَوْلٌ':Added, #1: 1	غَيْرَ بَوْلٍ
u'غير بَوْلٌ':Added, #1: 1	غَيْرُ بَوْلٍ
u'غَيْرٌ بَوْلٌ':Added, #2: 2	غَيْرِ بَوْلٍ
u'غير بَوْلٌ':Added, #2: 2	غَيْرِ بَوْلٍ
u'غَيْرٌ بَوْلٌ':Added, #3: 3	غَيْرِ الْبَوْلِ
u'غير بِئْرٌ':Added, #3: 3	غَيْرِ الْبَوْلِ
u'غَيْرٌ بِئْرٌ':Added, #1: 1	غَيْرِ الْبِئْرِ
u'غير بِئْرٌ':Added, #1: 1	غَيْرِ الْبِئْرِ
u'غَيْرٌ بِئْرٌ':Added, #1: 1	غَيْرَ بِئْرِ
u'غير بَيَاضٌ':Added, #1: 1	غَيْرَ بِئْرِ
u'غَيْرٌ بَيَاضٌ':Added, #1: 1	غَيْرُ الْبَيَاضِ
u'غير بَيَّاضٌ':Added, #1: 1	غَيْرُ الْبَيَاضِ
u'غَيْرٌ بَيَّاضٌ':Added, #1: 1	غَيْرُ الْبَيَّاضَةِ
u'غير بَيَانٌ':Added, #1: 1	غَيْرُ الْبَيَّاضَةِ
u'غَيْرٌ بَيَانٌ':Added, #1: 1	غَيْرَ بَيَانِ
u'غير بَيَانٌ':Added, #1: 1	غَيْرَ بَيَانِ
u'غَيْرٌ بَيَانٌ':Added, #21: 21	غَيْرِ بَيَانِ
u'غير بَيَانٌ':Added, #21: 21	غَيْرِ بَيَانِ
u'غَيْرٌ بَيَانٌ':Added, #28: 28	غَيْرِ بَيَانٍ
u'غير بَيَانٌ':Added, #28: 28	غَيْرِ بَيَانٍ
u'غَيْرٌ بَيَانٌ':Added, #3: 3	غَيْرِ بَيَانِهِ
u'غير بَيْتٌ':Added, #3: 3	غَيْرِ بَيَانِهِ
u'غَيْرٌ بَيْتٌ':Added, #14: 14	غَيْرِ بَيْتِ
u'غير بَيْتٌ':Added, #14: 14	غَيْرِ بَيْتِ
u'غَيْرٌ بَيْتٌ':Added, #1: 1	غَيْرِ الْبَيْتِ
u'غير بَيْتٌ':Added, #1: 1	غَيْرِ الْبَيْتِ
u'غير بَيْتٌ':Added, #1: 1	غَيْرُ بَيْتٍ
u'غَيْرٌ بَيْتٌ':Added, #1: 1	غَيْرِ بَيْتٍ
u'غَيْرٌ بَيْتٌ':Added, #1: 1	غَيْرُ بَيْتٍ
u'غير بَيْتٌ':Added, #1: 1	غَيْرِ بَيْتٍ
u'غَيْرٌ بَيْتٌ':Added, #1: 1	غَيْرَ بَيْتِهِ
u'غير بَيْتٌ':Added, #1: 1	غَيْرَ بَيْتِهِ
u'غَيْرٌ بَيْتٌ':Added, #1: 1	غَيْرُ بَيْتَيْنِ
u'غير بَيْتٌ':Added, #1: 1	غَيْرُ بَيْتَيْنِ
u'غَيْرٌ بَيْتٌ':Added, #2: 2	غَيْرَ بَيْتٍ
u'غير بَيْتٌ':Added, #2: 2	غَيْرَ بَيْتٍ
u'غَيْرٌ بَيْتٌ':Added, #3: 3	غَيْرُ الْبَيْتِ
u'غير بَيْتٌ':Added, #3: 3	غَيْرُ الْبَيْتِ
u'غَيْرٌ بَيْتٌ':Added, #7: 7	غَيْرِ بَيْتِهِ
u'غير بَيْعٌ':Added, #7: 7	غَيْرِ بَيْتِهِ
u'غَيْرٌ بَيْعٌ':Added, #10: 10	غَيْرِ الْبَيْعِ
u'غير بَيْعٌ':Added, #10: 10	غَيْرِ الْبَيْعِ
u'غَيْرٌ بَيْعٌ':Added, #1: 1	غَيْرُ الْبَيْعِ
u'غير بَيْعٌ':Added, #1: 1	غَيْرُ الْبَيْعِ
u'غَيْرٌ بَيْعٌ':Added, #1: 1	غَيْرُ بَيْعٍ
u'غير بَيْعٌ':Added, #1: 1	غَيْرُ بَيْعٍ
u'غَيْرٌ بَيْعٌ':Added, #2: 2	غَيْرَ الْبَيْعِ
u'غير بَيْعٌ':Added, #2: 2	غَيْرَ الْبَيْعِ
u'غَيْرٌ بَيْعٌ':Added, #2: 2	غَيْرِ بَيْعِ
u'غير بَيْعٌ':Added, #2: 2	غَيْرِ بَيْعِ
u'غَيْرٌ بَيْعٌ':Added, #4: 4	غَيْرِ بَيْعٍ
u'غير بَيْنٌ':Added, #4: 4	غَيْرِ بَيْعٍ
u'غَيْرٌ بَيْنٌ':Added, #1: 1	غَيْرَ بَيْنٍ
u'غير بَيِّنٌ':Added, #1: 1	غَيْرَ بَيْنٍ
u'غَيْرٌ بَيِّنٌ':Added, #4: 4	غَيْرُ بَيِّنٍ
u'غير بَيِّنَةٌ':Added, #4: 4	غَيْرُ بَيِّنٍ
u'غَيْرٌ بَيِّنَةٌ':Added, #1: 1	غَيْرِ بَيّنَةٍ
u'غير بَيِّنَةٌ':Added, #1: 1	غَيْرِ بَيّنَةٍ
u'غَيْرٌ بَيِّنَةٌ':Added, #22: 22	غَيْرِ بَيِّنَةٍ
u'غير بُيُوتٌ':Added, #22: 22	غَيْرِ بَيِّنَةٍ
u'غَيْرٌ بُيُوتٌ':Added, #2: 2	غَيْرِ الْبُيُوتِ
u'غير بيوع':Added, #2: 2	غَيْرِ الْبُيُوتِ
u'غَيْرٌ بيوع':Added, #1: 1	غَيْرِ الْبُيُوعِ
u'غَيْرَةٌ أَزْواجٌ':Added, #1: 1	غَيْرِ الْبُيُوعِ
u'غَيْرَةٌ رِجَالٌ':Added, #1: 1	غَيْرَةِ الأَزْوَاجِ
u'غَيْرَةٌ سَعْدٌ':Added, #1: 1	غَيْرَةِ الرِّجَالِ
u'غَيْرَةٌ مَلِكٌ':Added, #3: 3	غَيْرَةِ سَعْدٍ
u'غَيْرَةٌ نِساءٌ':Added, #1: 1	غَيْرَةُ الْمَلِكِ
u'غَيْرَةٌ نِساءٌ':Added, #1: 1	غَيْرَةِ النِّسَاءِ
u'غير تَابِعٌ':Added, #1: 1	غَيْرَةُ نِسَاءِ
u'غَيْرٌ تَابِعٌ':Added, #1: 1	غَيْرُ تَابِعَةٍ
u'غير تَابِعٌ':Added, #1: 1	غَيْرُ تَابِعَةٍ
u'غَيْرٌ تَابِعٌ':Added, #1: 1	غَيْرَ تَابِعَيْنِ
u'غير تَابِعٌ':Added, #1: 1	غَيْرَ تَابِعَيْنِ
u'غَيْرٌ تَابِعٌ':Added, #3: 3	غَيْرِ التَّابِعِ
u'غير تَابِعٌ':Added, #3: 3	غَيْرِ التَّابِعِ
u'غَيْرٌ تَابِعٌ':Added, #3: 3	غَيْرِ تَابِعٍ
u'غير تَابِعٌ':Added, #3: 3	غَيْرِ تَابِعٍ
u'غَيْرٌ تَابِعٌ':Added, #5: 5	غَيْرَ تَابِعٍ
u'غير تَابِعٌ':Added, #5: 5	غَيْرَ تَابِعٍ
u'غَيْرٌ تَابِعٌ':Added, #6: 6	غَيْرُ تَابِعٍ
u'غير تَأَثُّرٌ':Added, #6: 6	غَيْرُ تَابِعٍ
u'غَيْرٌ تَأَثُّرٌ':Added, #1: 1	غَيْرِ تَأَثُّرٍ
u'غير تَأْثِيرٌ':Added, #1: 1	غَيْرِ تَأَثُّرٍ
u'غير تَأْثِيرٌ':Added, #1: 1	غَيْرُ التَّأْثِيرِ
u'غَيْرٌ تَأْثِيرٌ':Added, #1: 1	غَيْرِ التَّأْثِيرِ
u'غَيْرٌ تَأْثِيرٌ':Added, #1: 1	غَيْرُ التَّأْثِيرِ
u'غير تَأْثِيرٌ':Added, #1: 1	غَيْرِ التَّأْثِيرِ
u'غَيْرٌ تَأْثِيرٌ':Added, #1: 1	غَيْرُ تَأْثِيرِ
u'غير تَأْثِيرٌ':Added, #1: 1	غَيْرُ تَأْثِيرِ
u'غَيْرٌ تَأْثِيرٌ':Added, #6: 6	غَيْرِ تَأْثِيرٍ
u'غير تَاجِرٌ':Added, #6: 6	غَيْرِ تَأْثِيرٍ
u'غير تَاجِرٌ':Added, #1: 1	غَيْرُ التَّاجِرِ
u'غَيْرٌ تَاجِرٌ':Added, #1: 1	غَيْرِ التَّاجِرِ
u'غَيْرٌ تَاجِرٌ':Added, #1: 1	غَيْرُ التَّاجِرِ
u'غير تَاجِرٌ':Added, #1: 1	غَيْرِ التَّاجِرِ
u'غَيْرٌ تَاجِرٌ':Added, #1: 1	غَيْرَ تَاجِرٍ
u'غير تَأْجِيلٌ':Added, #1: 1	غَيْرَ تَاجِرٍ
u'غَيْرٌ تَأْجِيلٌ':Added, #1: 1	غَيْرِ تَأْجِيلٍ
u'غير تَأْخِيرٌ':Added, #1: 1	غَيْرِ تَأْجِيلٍ
u'غَيْرٌ تَأْخِيرٌ':Added, #25: 25	غَيْرِ تَأْخِيرٍ
u'غير تارِك':Added, #25: 25	غَيْرِ تَأْخِيرٍ
u'غَيْرٌ تارِك':Added, #1: 1	غَيْرُ تَارِكٍ
u'غير تارِك':Added, #1: 1	غَيْرُ تَارِكٍ
u'غَيْرٌ تارِك':Added, #3: 3	غَيْرَ تَارِكٍ
u'غير تَارِيخٌ':Added, #3: 3	غَيْرَ تَارِكٍ
u'غير تَارِيخٌ':Added, #1: 1	غَيْرَ تَارِيخِ
u'غَيْرٌ تَارِيخٌ':Added, #1: 1	غَيْرُ تَارِيخِ
u'غَيْرٌ تَارِيخٌ':Added, #1: 1	غَيْرَ تَارِيخِ
u'غير تَارِيخٌ':Added, #1: 1	غَيْرُ تَارِيخِ
u'غَيْرٌ تَارِيخٌ':Added, #5: 5	غَيْرِ تَارِيخٍ
u'غير تَافِهٌ':Added, #5: 5	غَيْرِ تَارِيخٍ
u'غَيْرٌ تَافِهٌ':Added, #3: 3	غَيْرِ تَافِهٍ
u'غير تَأْكِيدٌ':Added, #3: 3	غَيْرِ تَافِهٍ
u'غير تَأْكِيدٌ':Added, #1: 1	غَيْرَ التَّأْكِيدِ
u'غَيْرٌ تَأْكِيدٌ':Added, #1: 1	غَيْرُ التَّأْكِيدِ
u'غَيْرٌ تَأْكِيدٌ':Added, #1: 1	غَيْرَ التَّأْكِيدِ
u'غير تَأْكِيدٌ':Added, #1: 1	غَيْرُ التَّأْكِيدِ
u'غَيْرٌ تَأْكِيدٌ':Added, #1: 1	غَيْرِ تَأْكِيدٍ
u'غير تالِف':Added, #1: 1	غَيْرِ تَأْكِيدٍ
u'غير تالِف':Added, #1: 1	غَيْرَ تَالِفٍ
u'غَيْرٌ تالِف':Added, #1: 1	غَيْرُ تَالِفٍ
u'غَيْرٌ تالِف':Added, #1: 1	غَيْرَ تَالِفٍ
u'غير تَامٌّ':Added, #1: 1	غَيْرُ تَالِفٍ
u'غَيْرٌ تَامٌّ':Added, #19: 19	غَيْرُ تَامٍّ
u'غير تَامٌّ':Added, #19: 19	غَيْرُ تَامٍّ
u'غير تَامٌّ':Added, #1: 1	غَيْرُ التَّامِّ
u'غَيْرٌ تَامٌّ':Added, #1: 1	غَيْرِ التَّامِّ
u'غَيْرٌ تَامٌّ':Added, #1: 1	غَيْرُ التَّامِّ
u'غير تَامٌّ':Added, #1: 1	غَيْرِ التَّامِّ
u'غير تَامٌّ':Added, #1: 1	غَيْرُ تَامِّ
u'غَيْرٌ تَامٌّ':Added, #1: 1	غَيْرِ تَامٍّ
u'غَيْرٌ تَامٌّ':Added, #1: 1	غَيْرُ تَامِّ
u'غير تَامٌّ':Added, #1: 1	غَيْرِ تَامٍّ
u'غير تَامٌّ':Added, #1: 1	غَيْرَ تَامَّةٍ
u'غير تَامٌّ':Added, #1: 1	غَيْرُ تَامَّةِ
u'غير تَامٌّ':Added, #1: 1	غَيْرِ تَامَّةٍ
u'غَيْرٌ تَامٌّ':Added, #1: 1	غَيْرِ تَامَّةِ
u'غَيْرٌ تَامٌّ':Added, #1: 1	غَيْرَ تَامَّةٍ
u'غَيْرٌ تَامٌّ':Added, #1: 1	غَيْرُ تَامَّةِ
u'غَيْرٌ تَامٌّ':Added, #1: 1	غَيْرِ تَامَّةٍ
u'غير تَامٌّ':Added, #1: 1	غَيْرِ تَامَّةِ
u'غَيْرٌ تَامٌّ':Added, #2: 2	غَيْرُ تَامَّةٍ
u'غير تَامٌّ':Added, #2: 2	غَيْرُ تَامَّةٍ
u'غَيْرٌ تَامٌّ':Added, #5: 5	غَيْرَ تَامٍّ
u'غير تَأَمُّلٌ':Added, #5: 5	غَيْرَ تَامٍّ
u'غَيْرٌ تَأَمُّلٌ':Added, #17: 17	غَيْرِ تَأَمُّلٍ
u'غَيْرٌ تَأَمُّلٌ':Added, #17: 17	غَيْرِ تَأَمُّلٍ
u'غير تَأْمِينٌ':Added, #1: 1	غَيْرٍ تَأَمُّلٍ
u'غَيْرٌ تَأْمِينٌ':Added, #1: 1	غَيْرِ تَأْمِينِهِ
u'غير تَأَهُّبٌ':Added, #1: 1	غَيْرِ تَأْمِينِهِ
u'غَيْرٌ تَأَهُّبٌ':Added, #1: 1	غَيْرِ تَأَهُّبٍ
u'غير تَائِبٌ':Added, #1: 1	غَيْرِ تَأَهُّبٍ
u'غَيْرٌ تَائِبٌ':Added, #1: 1	غَيْرُ تَائِبٍ
u'غير تَائِبٌ':Added, #1: 1	غَيْرُ تَائِبٍ
u'غَيْرٌ تَائِبٌ':Added, #1: 1	غَيْرَ تَائِبَيْنِ
u'غير تَائِبٌ':Added, #1: 1	غَيْرَ تَائِبَيْنِ
u'غَيْرٌ تَائِبٌ':Added, #4: 4	غَيْرَ تَائِبٍ
u'غير تَأْيِيدٌ':Added, #4: 4	غَيْرَ تَائِبٍ
u'غَيْرٌ تَأْيِيدٌ':Added, #1: 1	غَيْرِ تَأْيِيدٍ
u'غير تَبْدِيلٌ':Added, #1: 1	غَيْرِ تَأْيِيدٍ
u'غَيْرٌ تَبْدِيلٌ':Added, #1: 1	غَيْرِ تَبْدِيلِ
u'غير تَبْذِيرٌ':Added, #1: 1	غَيْرِ تَبْدِيلِ
u'غَيْرٌ تَبْذِيرٌ':Added, #5: 5	غَيْرِ تَبْذِيرٍ
u'غير تَبَرُّعٌ':Added, #5: 5	غَيْرِ تَبْذِيرٍ
u'غَيْرٌ تَبَرُّعٌ':Added, #2: 2	غَيْرَ تَبَرُّعٍ
u'غير تَبَع':Added, #2: 2	غَيْرَ تَبَرُّعٍ
u'غَيْرٌ تَبَع':Added, #1: 1	غَيْرَ التَّبَعِيَّةِ
u'غير تَبَع':Added, #1: 1	غَيْرَ التَّبَعِيَّةِ
u'غير تَبَع':Added, #1: 1	غَيْرَ تَبَعٍ
u'غير تَبَع':Added, #1: 1	غَيْرُ تَبَعٍ
u'غَيْرٌ تَبَع':Added, #1: 1	غَيْرِ تَبَعٍ
u'غَيْرٌ تَبَع':Added, #1: 1	غَيْرَ تَبَعٍ
u'غَيْرٌ تَبَع':Added, #1: 1	غَيْرُ تَبَعٍ
u'غير تَبَع':Added, #1: 1	غَيْرِ تَبَعٍ
u'غَيْرٌ تَبَع':Added, #1: 1	غَيْرِ تَبَعِيَّةِ
u'غير تَبَعِيّ':Added, #1: 1	غَيْرِ تَبَعِيَّةِ
u'غَيْرٌ تَبَعِيّ':Added, #1: 1	غَيْرَ التَّبَعِيَّةِ
u'غير تَبَعِيّ':Added, #1: 1	غَيْرَ التَّبَعِيَّةِ
u'غَيْرٌ تَبَعِيّ':Added, #1: 1	غَيْرِ تَبَعِيَّةِ
u'غير تَبَعِيَّة':Added, #1: 1	غَيْرِ تَبَعِيَّةِ
u'غَيْرٌ تَبَعِيَّة':Added, #1: 1	غَيْرَ التَّبَعِيَّةِ
u'غير تَبَعِيَّة':Added, #1: 1	غَيْرَ التَّبَعِيَّةِ
u'غَيْرٌ تَبَعِيَّة':Added, #1: 1	غَيْرِ تَبَعِيَّةِ
u'غير تَبْعِيض':Added, #1: 1	غَيْرِ تَبَعِيَّةِ
u'غَيْرٌ تَبْعِيض':Added, #2: 2	غَيْر التَّبْعِيضِ
u'غير تَبْيِين':Added, #2: 2	غَيْر التَّبْعِيضِ
u'غَيْرٌ تَبْيِين':Added, #2: 2	غَيْرِ تَبْيِينِ
u'غير تَتَبُّعٌ':Added, #2: 2	غَيْرِ تَبْيِينِ
u'غَيْرٌ تَتَبُّعٌ':Added, #1: 1	غَيْرِ تَتَبُّعٍ
u'غير تَثَبُّتٌ':Added, #1: 1	غَيْرِ تَتَبُّعٍ
u'غَيْرٌ تَثَبُّتٌ':Added, #4: 4	غَيْرِ تَثَبُّتٍ
u'غير تَثْبِيت':Added, #4: 4	غَيْرِ تَثَبُّتٍ
u'غَيْرٌ تَثْبِيت':Added, #1: 1	غَيْرِ تَثْبِيتٍ
u'غير تَثْقِيف':Added, #1: 1	غَيْرِ تَثْبِيتٍ
u'غَيْرٌ تَثْقِيف':Added, #1: 1	غَيْرِ تَثْقِيفٍ
u'غير تَثْنِيَةٌ':Added, #1: 1	غَيْرِ تَثْقِيفٍ
u'غَيْرٌ تَثْنِيَةٌ':Added, #1: 1	غَيْرُ التَّثْنِيَةِ
u'غير تِجَارَةٌ':Added, #1: 1	غَيْرُ التَّثْنِيَةِ
u'غَيْرٌ تِجَارَةٌ':Added, #1: 1	غَيْرَ التِّجَارَةِ
u'غير تِجَارَةٌ':Added, #1: 1	غَيْرَ التِّجَارَةِ
u'غير تِجَارَةٌ':Added, #1: 1	غَيْرَ تِجَارَةٍ
u'غَيْرٌ تِجَارَةٌ':Added, #1: 1	غَيْرِ تِجَارَةٍ
u'غَيْرٌ تِجَارَةٌ':Added, #1: 1	غَيْرَ تِجَارَةٍ
u'غير تِجَارَةٌ':Added, #1: 1	غَيْرِ تِجَارَةٍ
u'غَيْرٌ تِجَارَةٌ':Added, #6: 6	غَيْرِ التِّجَارَةِ
u'غير تَجَاوُزٌ':Added, #6: 6	غَيْرِ التِّجَارَةِ
u'غَيْرٌ تَجَاوُزٌ':Added, #2: 2	غَيْرِ تَجَاوُزٍ
u'غير تَجَدُّدٌ':Added, #2: 2	غَيْرِ تَجَاوُزٍ
u'غَيْرٌ تَجَدُّدٌ':Added, #1: 1	غَيْرِ تَجَدُّدِ
u'غير تَجْدِيدٌ':Added, #1: 1	غَيْرِ تَجَدُّدِ
u'غَيْرٌ تَجْدِيدٌ':Added, #15: 15	غَيْرِ تَجْدِيدِ
u'غير تَجْدِيدٌ':Added, #15: 15	غَيْرِ تَجْدِيدِ
u'غَيْرٌ تَجْدِيدٌ':Added, #1: 1	غَيْرِ تَجْدِيدٍ
u'غير تَجْرِبَةٌ':Added, #1: 1	غَيْرِ تَجْدِيدٍ
u'غَيْرٌ تَجْرِبَةٌ':Added, #1: 1	غَيْرِ تَجْرِبَةِ
u'غير تَجْرِيبٌ':Added, #1: 1	غَيْرِ تَجْرِبَةِ
u'غَيْرٌ تَجْرِيبٌ':Added, #1: 1	غَيْرِ تَجْرِيبِ
u'غير تَجْرِيدٌ':Added, #1: 1	غَيْرِ تَجْرِيبِ
u'غَيْرٌ تَجْرِيدٌ':Added, #1: 1	غَيْرُ التَّجْرِيدِ
u'غير تَجْرِيدٌ':Added, #1: 1	غَيْرُ التَّجْرِيدِ
u'غَيْرٌ تَجْرِيدٌ':Added, #2: 2	غَيْرِ تَجْرِيدِ
u'غير تَجَسُّسٌ':Added, #2: 2	غَيْرِ تَجْرِيدِ
u'غَيْرٌ تَجَسُّسٌ':Added, #1: 1	غَيْرِ تَجَسُّسٍ
u'غير تَجْفِيفٌ':Added, #1: 1	غَيْرِ تَجَسُّسٍ
u'غَيْرٌ تَجْفِيفٌ':Added, #1: 1	غَيْرِ تَجْفِيفٍ
u'غير تَجْلِيدٌ':Added, #1: 1	غَيْرِ تَجْفِيفٍ
u'غَيْرٌ تَجْلِيدٌ':Added, #1: 1	غَيْرِ تَجْلِيدٍ
u'غير تَحَالُفٌ':Added, #1: 1	غَيْرِ تَجْلِيدٍ
u'غَيْرٌ تَحَالُفٌ':Added, #1: 1	غَيْرِ تَحَالُفٍ
u'غير تَحَامُلٌ':Added, #1: 1	غَيْرِ تَحَالُفٍ
u'غَيْرٌ تَحَامُلٌ':Added, #1: 1	غَيْرِ تَحَامُلٍ
u'غير تَحْتَانِيٌّ':Added, #1: 1	غَيْرِ تَحَامُلٍ
u'غَيْرٌ تَحْتَانِيٌّ':Added, #1: 1	غَيْرُ التَّحْتَانِيِّ
u'غير تَحْدِيدٌ':Added, #1: 1	غَيْرُ التَّحْتَانِيِّ
u'غَيْرٌ تَحْدِيدٌ':Added, #14: 14	غَيْرِ تَحْدِيدٍ
u'غير تَحْدِيدٌ':Added, #14: 14	غَيْرِ تَحْدِيدٍ
u'غير تَحْدِيدٌ':Added, #1: 1	غَيْرَ التَّحْدِيدِ
u'غَيْرٌ تَحْدِيدٌ':Added, #1: 1	غَيْرُ التَّحْدِيدِ
u'غَيْرٌ تَحْدِيدٌ':Added, #1: 1	غَيْرَ التَّحْدِيدِ
u'غير تَحْرِيرٌ':Added, #1: 1	غَيْرُ التَّحْدِيدِ
u'غَيْرٌ تَحْرِيرٌ':Added, #1: 1	غَيْرُ التَّحْرِيرِ
u'غير تَحْرِيرٌ':Added, #1: 1	غَيْرُ التَّحْرِيرِ
u'غَيْرٌ تَحْرِيرٌ':Added, #1: 1	غَيْرَ تَحْرِيرٍ
u'غير تَحْرِيفٌ':Added, #1: 1	غَيْرَ تَحْرِيرٍ
u'غَيْرٌ تَحْرِيفٌ':Added, #1: 1	غَيْرِ تَحْرِيفٍ
u'غير تَحْرِيك':Added, #1: 1	غَيْرِ تَحْرِيفٍ
u'غَيْرٌ تَحْرِيك':Added, #1: 1	غَيْرِ التَّحْرِيكِ
u'غير تَحْرِيكٌ':Added, #1: 1	غَيْرِ التَّحْرِيكِ
u'غَيْرٌ تَحْرِيكٌ':Added, #1: 1	غَيْرِ تَحْرِيكِهِ
u'غير تَحْرِيكٌ':Added, #1: 1	غَيْرِ تَحْرِيكِهِ
u'غير تَحْرِيكٌ':Added, #2: 2	غَيْرِ تَحْرِيكٍ
u'غَيْرٌ تَحْرِيكٌ':Added, #2: 2	غَيْرِ تَحْرِيكِ
u'غَيْرٌ تَحْرِيكٌ':Added, #2: 2	غَيْرِ تَحْرِيكٍ
u'غير تَحْرِيمٌ':Added, #2: 2	غَيْرِ تَحْرِيكِ
u'غَيْرٌ تَحْرِيمٌ':Added, #12: 12	غَيْرِ تَحْرِيمٍ
u'غير تَحْرِيمٌ':Added, #12: 12	غَيْرِ تَحْرِيمٍ
u'غير تَحْرِيمٌ':Added, #1: 1	غَيْرَ تَحْرِيمٍ
u'غَيْرٌ تَحْرِيمٌ':Added, #1: 1	غَيْرِ تَحْرِيمِ
u'غَيْرٌ تَحْرِيمٌ':Added, #1: 1	غَيْرَ تَحْرِيمٍ
u'غير تَحْرِيمٌ':Added, #1: 1	غَيْرِ تَحْرِيمِ
u'غير تَحْرِيمٌ':Added, #2: 2	غَيْرَ التَّحْرِيمِ
u'غَيْرٌ تَحْرِيمٌ':Added, #2: 2	غَيْرُ التَّحْرِيمِ
u'غَيْرٌ تَحْرِيمٌ':Added, #2: 2	غَيْرَ التَّحْرِيمِ
u'غير تَحْرِيم':Added, #2: 2	غَيْرُ التَّحْرِيمِ
u'غَيْرٌ تَحْرِيم':Added, #2: 2	غَيْرِ تَحْرِيمَةٍ
u'غير تَحْرِيمٌ':Added, #2: 2	غَيْرِ تَحْرِيمَةٍ
u'غَيْرٌ تَحْرِيمٌ':Added, #5: 5	غَيْرِ التَّحْرِيمِ
u'غير تَحْصِيلٌ':Added, #5: 5	غَيْرِ التَّحْرِيمِ
u'غير تَحْصِيلٌ':Added, #1: 1	غَيْرِ تَحْصِيلٍ
u'غَيْرٌ تَحْصِيلٌ':Added, #1: 1	غَيْرِ تَحْصِيلِ
u'غَيْرٌ تَحْصِيلٌ':Added, #1: 1	غَيْرِ تَحْصِيلٍ
u'غير تَحَقُّقٌ':Added, #1: 1	غَيْرِ تَحْصِيلِ
u'غَيْرٌ تَحَقُّقٌ':Added, #1: 1	غَيْرِ تَحَقُّقٍ
u'غير تَحَقُّقٌ':Added, #1: 1	غَيْرِ تَحَقُّقٍ
u'غَيْرٌ تَحَقُّقٌ':Added, #4: 4	غَيْرِ تَحَقُّقِ
u'غير تَحْقِيقٌ':Added, #4: 4	غَيْرِ تَحَقُّقِ
u'غير تَحْقِيقٌ':Added, #1: 1	غَيْر تَحْقِيقٍ
u'غَيْرٌ تَحْقِيقٌ':Added, #1: 1	غَيْرِ تَحْقِيقِ
u'غَيْرٌ تَحْقِيقٌ':Added, #1: 1	غَيْر تَحْقِيقٍ
u'غير تَحْقِيقٌ':Added, #1: 1	غَيْرِ تَحْقِيقِ
u'غَيْرٌ تَحْقِيقٌ':Added, #6: 6	غَيْرِ تَحْقِيقٍ
u'غير تَحْكِيمٌ':Added, #6: 6	غَيْرِ تَحْقِيقٍ
u'غَيْرٌ تَحْكِيمٌ':Added, #2: 2	غَيْرِ تَحْكِيمٍ
u'غير تَحَلُّلٌ':Added, #2: 2	غَيْرِ تَحْكِيمٍ
u'غَيْرٌ تَحَلُّلٌ':Added, #1: 1	غَيْرِ تَحَلُّلٍ
u'غير تَحْلِيف':Added, #1: 1	غَيْرِ تَحَلُّلٍ
u'غَيْرٌ تَحْلِيف':Added, #2: 2	غَيْرِ تَحْلِيفٍ
u'غير تَحْلِيلٌ':Added, #2: 2	غَيْرِ تَحْلِيفٍ
u'غَيْرٌ تَحْلِيلٌ':Added, #1: 1	غَيْرِ التَّحْلِيلِ
u'غير تَحْلِيلٌ':Added, #1: 1	غَيْرِ التَّحْلِيلِ
u'غير تَحْلِيلٌ':Added, #1: 1	غَيْرِ تَحْلِيلٍ
u'غَيْرٌ تَحْلِيلٌ':Added, #1: 1	غَيْرِ تَحْلِيلِ
u'غَيْرٌ تَحْلِيلٌ':Added, #1: 1	غَيْرِ تَحْلِيلٍ
u'غير تَحَمُّلٌ':Added, #1: 1	غَيْرِ تَحْلِيلِ
u'غَيْرٌ تَحَمُّلٌ':Added, #1: 1	غَيْرِ تَحَمُّلٍ
u'غير تَحْوِيلٌ':Added, #1: 1	غَيْرِ تَحَمُّلٍ
u'غَيْرٌ تَحْوِيلٌ':Added, #1: 1	غَيْرِ تَحْوِيلِ
u'غير تَحْوِيلٌ':Added, #1: 1	غَيْرِ تَحْوِيلِ
u'غَيْرٌ تَحْوِيلٌ':Added, #2: 2	غَيْرِ تَحْوِيلٍ
u'غير تَحِيَّةٌ':Added, #2: 2	غَيْرِ تَحْوِيلٍ
u'غير تَحِيَّةٌ':Added, #1: 1	غَيْرَ التَّحِيَّةِ
u'غَيْرٌ تَحِيَّةٌ':Added, #1: 1	غَيْرِ التَّحِيَّةِ
u'غَيْرٌ تَحِيَّةٌ':Added, #1: 1	غَيْرَ التَّحِيَّةِ
u'غير تَحِيَّةٌ':Added, #1: 1	غَيْرِ التَّحِيَّةِ
u'غير تَحِيَّةٌ':Added, #1: 1	غَيْرِ تَحِيَّةٍ
u'غَيْرٌ تَحِيَّةٌ':Added, #1: 1	غَيْرِ تَحِيَّةِ
u'غَيْرٌ تَحِيَّةٌ':Added, #1: 1	غَيْرِ تَحِيَّةٍ
u'غير تَخْرِيبٌ':Added, #1: 1	غَيْرِ تَحِيَّةِ
u'غَيْرٌ تَخْرِيبٌ':Added, #1: 1	غَيْرِ تَخْرِيبٍ
u'غير تَخْرِيجٌ':Added, #1: 1	غَيْرِ تَخْرِيبٍ
u'غَيْرٌ تَخْرِيجٌ':Added, #3: 3	غَيْرِ تَخْرِيجٍ
u'غير تَخْصِيصٌ':Added, #3: 3	غَيْرِ تَخْرِيجٍ
u'غَيْرٌ تَخْصِيصٌ':Added, #12: 12	غَيْرِ تَخْصِيصٍ
u'غير تَخْصِيصٌ':Added, #12: 12	غَيْرِ تَخْصِيصٍ
u'غَيْرٌ تَخْصِيصٌ':Added, #1: 1	غَيْرِ تَخْصِيصِهِ
u'غير تَخْصِيصٌ':Added, #1: 1	غَيْرِ تَخْصِيصِهِ
u'غَيْرٌ تَخْصِيصٌ':Added, #3: 3	غَيْرِ تَخْصِيصِ
u'غير تَخْفِيفٌ':Added, #3: 3	غَيْرِ تَخْصِيصِ
u'غَيْرٌ تَخْفِيفٌ':Added, #1: 1	غَيْرِ التَّخْفِيفَاتِ
u'غير تَخَلُّفٌ':Added, #1: 1	غَيْرِ التَّخْفِيفَاتِ
u'غَيْرٌ تَخَلُّفٌ':Added, #1: 1	غَيْرِ تَخَلُّفٍ
u'غير تَخَلُّلٌ':Added, #1: 1	غَيْرِ تَخَلُّفٍ
u'غير تَخَلُّلٌ':Added, #1: 1	غَيْرِ تَخَلُّلٍ
u'غَيْرٌ تَخَلُّلٌ':Added, #1: 1	غَيْرِ تَخَلُّلِ
u'غَيْرٌ تَخَلُّلٌ':Added, #1: 1	غَيْرِ تَخَلُّلٍ
u'غير تَخَمُّرٌ':Added, #1: 1	غَيْرِ تَخَلُّلِ
u'غَيْرٌ تَخَمُّرٌ':Added, #4: 4	غَيْرِ تَخَمُّرٍ
u'غير تَخَيُّلٌ':Added, #4: 4	غَيْرِ تَخَمُّرٍ
u'غَيْرٌ تَخَيُّلٌ':Added, #1: 1	غَيْرِ تَخَيُّلِ
u'غير تَخْيِيرٌ':Added, #1: 1	غَيْرِ تَخَيُّلِ
u'غَيْرٌ تَخْيِيرٌ':Added, #1: 1	غَيْرُ التَّخْيِيرِ
u'غير تَخْيِيرٌ':Added, #1: 1	غَيْرُ التَّخْيِيرِ
u'غَيْرٌ تَخْيِيرٌ':Added, #9: 9	غَيْرِ تَخْيِيرٍ
u'غير تَدَاخُلٌ':Added, #9: 9	غَيْرِ تَخْيِيرٍ
u'غَيْرٌ تَدَاخُلٌ':Added, #4: 4	غَيْرِ تَدَاخُلٍ
u'غير تَدَارُكٌ':Added, #4: 4	غَيْرِ تَدَاخُلٍ
u'غَيْرٌ تَدَارُكٌ':Added, #1: 1	غَيْرِ تَدَارُكٍ
u'غير تَدَبُّرٌ':Added, #1: 1	غَيْرِ تَدَارُكٍ
u'غَيْرٌ تَدَبُّرٌ':Added, #1: 1	غَيْرِ تَدَبُّرٍ
u'غير تَدْبِيرٌ':Added, #1: 1	غَيْرِ تَدَبُّرٍ
u'غَيْرٌ تَدْبِيرٌ':Added, #1: 1	غَيْرَ التَّدْبِيرِ
u'غير تَدْبِيرٌ':Added, #1: 1	غَيْرَ التَّدْبِيرِ
u'غَيْرٌ تَدْبِيرٌ':Added, #1: 1	غَيْرِ تَدْبِيرٍ
u'غير تَدْبِيرٌ':Added, #1: 1	غَيْرِ تَدْبِيرٍ
u'غَيْرٌ تَدْبِيرٌ':Added, #2: 2	غَيْرِ التَّدْبِيرِ
u'غير تَدْرِيجٌ':Added, #2: 2	غَيْرِ التَّدْبِيرِ
u'غَيْرٌ تَدْرِيجٌ':Added, #1: 1	غَيْرِ تَدْرِيجٍ
u'غير تَذَكُّرٌ':Added, #1: 1	غَيْرِ تَدْرِيجٍ
u'غَيْرٌ تَذَكُّرٌ':Added, #1: 1	غَيْرِ التَّذَكُّرِ
u'غير تَذَكُّرٌ':Added, #1: 1	غَيْرِ التَّذَكُّرِ
u'غير تَذَكُّرٌ':Added, #1: 1	غَيْرِ تَذَكُّرٍ
u'غَيْرٌ تَذَكُّرٌ':Added, #1: 1	غَيْرِ تَذَكُّرِ
u'غَيْرٌ تَذَكُّرٌ':Added, #1: 1	غَيْرِ تَذَكُّرٍ
u'غير تُرَابٌ':Added, #1: 1	غَيْرِ تَذَكُّرِ
u'غير تُرَابٌ':Added, #1: 1	غَيْرَ التُّرَابِ
u'غَيْرٌ تُرَابٌ':Added, #1: 1	غَيْرِ التُّرَابِ
u'غَيْرٌ تُرَابٌ':Added, #1: 1	غَيْرَ التُّرَابِ
u'غير تُرَابٌ':Added, #1: 1	غَيْرِ التُّرَابِ
u'غير تُرَابٌ':Added, #1: 1	غَيْرَ تُرَابِ
u'غَيْرٌ تُرَابٌ':Added, #1: 1	غَيْرِ تُرَابٍ
u'غَيْرٌ تُرَابٌ':Added, #1: 1	غَيْرَ تُرَابِ
u'غير تُرَابٌ':Added, #1: 1	غَيْرِ تُرَابٍ
u'غَيْرٌ تُرَابٌ':Added, #1: 1	غَيْرَ تُرَابِهِ
u'غير تُرَابٌ':Added, #1: 1	غَيْرَ تُرَابِهِ
u'غَيْرٌ تُرَابٌ':Added, #3: 3	غَيْرُ التُّرَابِ
u'غير تَرَاجُعٌ':Added, #3: 3	غَيْرُ التُّرَابِ
u'غَيْرٌ تَرَاجُعٌ':Added, #1: 1	غَيْرِ تَرَاجُعِ
u'غير تَرَافُعٌ':Added, #1: 1	غَيْرِ تَرَاجُعِ
u'غَيْرٌ تَرَافُعٌ':Added, #2: 2	غَيْرِ تَرَافُعٍ
u'غير تَرَاوِيحُ':Added, #2: 2	غَيْرِ تَرَافُعٍ
u'غَيْرٌ تَرَاوِيحُ':Added, #3: 3	غَيْرِ التَّرَاوِيحِ
u'غير تَرَاوِيحُ':Added, #3: 3	غَيْرِ التَّرَاوِيحِ
u'غَيْرٌ تَرَاوِيحُ':Added, #4: 4	غَيْرَ التَّرَاوِيحِ
u'غير تُرْبَةٌ':Added, #4: 4	غَيْرَ التَّرَاوِيحِ
u'غَيْرٌ تُرْبَةٌ':Added, #1: 1	غَيْرِ التُّرْبَةِ
u'غير تَرَبُّصٌ':Added, #1: 1	غَيْرِ التُّرْبَةِ
u'غَيْرٌ تَرَبُّصٌ':Added, #1: 1	غَيْرِ تَرَبُّصٍ
u'غير تَرْتِيبٌ':Added, #1: 1	غَيْرِ تَرَبُّصٍ
u'غَيْرٌ تَرْتِيبٌ':Added, #10: 10	غَيْرِ تَرْتِيبٍ
u'غير تَرْتِيبٌ':Added, #10: 10	غَيْرِ تَرْتِيبٍ
u'غَيْرٌ تَرْتِيبٌ':Added, #1: 1	غَيْرُ التَّرْتِيبِ
u'غير تَرْتِيبٌ':Added, #1: 1	غَيْرُ التَّرْتِيبِ
u'غَيْرٌ تَرْتِيبٌ':Added, #2: 2	غَيْرِ تَرْتِيبِ
u'غير تَرْجِيحٌ':Added, #2: 2	غَيْرِ تَرْتِيبِ
u'غَيْرٌ تَرْجِيحٌ':Added, #29: 29	غَيْرِ تَرْجِيحٍ
u'غير تَرْجِيحٌ':Added, #29: 29	غَيْرِ تَرْجِيحٍ
u'غَيْرٌ تَرْجِيحٌ':Added, #2: 2	غَيْرِ تَرْجِيحِ
u'غير تَرَدُّدٌ':Added, #2: 2	غَيْرِ تَرْجِيحِ
u'غَيْرٌ تَرَدُّدٌ':Added, #11: 11	غَيْرِ تَرَدُّدٍ
u'غير تَرْدِيدٌ':Added, #11: 11	غَيْرِ تَرَدُّدٍ
u'غَيْرٌ تَرْدِيدٌ':Added, #2: 2	غَيْرِ تَرْدِيدٍ
u'غير تَرْكٌ':Added, #2: 2	غَيْرِ تَرْدِيدٍ
u'غَيْرٌ تَرْكٌ':Added, #16: 16	غَيْرِ تَرْكٍ
u'غير تَرْكٌ':Added, #16: 16	غَيْرِ تَرْكٍ
u'غير تَرْكٌ':Added, #1: 1	غَيْرُ التَّرْكِ
u'غَيْرٌ تَرْكٌ':Added, #1: 1	غَيْرِ التَّرْكِ
u'غَيْرٌ تَرْكٌ':Added, #1: 1	غَيْرُ التَّرْكِ
u'غير تَرْك':Added, #1: 1	غَيْرِ التَّرْكِ
u'غَيْرٌ تَرْك':Added, #1: 1	غَيْرُ التَّرْكِيَّةِ
u'غير تَرْكٌ':Added, #1: 1	غَيْرُ التَّرْكِيَّةِ
u'غير تَرْكٌ':Added, #1: 1	غَيْرُ تَرْكٍ
u'غَيْرٌ تَرْكٌ':Added, #1: 1	غَيْرُ تَرْكِ
u'غَيْرٌ تَرْكٌ':Added, #1: 1	غَيْرُ تَرْكٍ
u'غير تَرْكٌ':Added, #1: 1	غَيْرُ تَرْكِ
u'غَيْرٌ تَرْكٌ':Added, #3: 3	غَيْرِ تَرْكِ
u'غير تَرِكَةٌ':Added, #3: 3	غَيْرِ تَرْكِ
u'غَيْرٌ تَرِكَةٌ':Added, #1: 1	غَيْرِ تَرِكَةِ
u'غير تَرِكَةٌ':Added, #1: 1	غَيْرِ تَرِكَةِ
u'غَيْرٌ تَرِكَةٌ':Added, #3: 3	غَيْرِ التَّرِكَةِ
u'غير تَزْكِيَةٌ':Added, #3: 3	غَيْرِ التَّرِكَةِ
u'غَيْرٌ تَزْكِيَةٌ':Added, #1: 1	غَيْرِ تَزْكِيَةٍ
u'غير تَزْوِيجٌ':Added, #1: 1	غَيْرِ تَزْكِيَةٍ
u'غَيْرٌ تَزْوِيجٌ':Added, #2: 2	غَيْرِ تَزْوِيجٍ
u'غير تَسَبُّبٌ':Added, #2: 2	غَيْرِ تَزْوِيجٍ
u'غَيْرٌ تَسَبُّبٌ':Added, #1: 1	غَيْرِ تَسَبُّبِهِ
u'غير تَسَبُّبٌ':Added, #1: 1	غَيْرِ تَسَبُّبِهِ
u'غَيْرٌ تَسَبُّبٌ':Added, #2: 2	غَيْرِ تَسَبُّبٍ
u'غير تَسْبِيحٌ':Added, #2: 2	غَيْرِ تَسَبُّبٍ
u'غَيْرٌ تَسْبِيحٌ':Added, #1: 1	غَيْرُ التَّسْبِيحِ
u'غير تَسْبِيعٌ':Added, #1: 1	غَيْرُ التَّسْبِيحِ
u'غَيْرٌ تَسْبِيعٌ':Added, #1: 1	غَيْرُ التَّسْبِيعِ
u'غير تَسْرِيحٌ':Added, #1: 1	غَيْرُ التَّسْبِيعِ
u'غَيْرٌ تَسْرِيحٌ':Added, #1: 1	غَيْرِ تَسْرِيحٍ
u'غير تِسْعَةٌ':Added, #1: 1	غَيْرِ تَسْرِيحٍ
u'غَيْرٌ تِسْعَةٌ':Added, #1: 1	غَيْرَ تِسْعَةٍ
u'غير تَسْلِيطٌ':Added, #1: 1	غَيْرَ تِسْعَةٍ
u'غَيْرٌ تَسْلِيطٌ':Added, #1: 1	غَيْرُ التَّسْلِيطِ
u'غير تَسْلِيطٌ':Added, #1: 1	غَيْرُ التَّسْلِيطِ
u'غَيْرٌ تَسْلِيطٌ':Added, #7: 7	غَيْرِ تَسْلِيطٍ
u'غير تَسْلِيمٌ':Added, #7: 7	غَيْرِ تَسْلِيطٍ
u'غَيْرٌ تَسْلِيمٌ':Added, #1: 1	غَيْرِ التَّسْلِيمِ
u'غير تَسْلِيمٌ':Added, #1: 1	غَيْرِ التَّسْلِيمِ
u'غَيْرٌ تَسْلِيمٌ':Added, #1: 1	غَيْرُ تَسْلِيمِ
u'غير تَسْلِيمٌ':Added, #1: 1	غَيْرُ تَسْلِيمِ
u'غَيْرٌ تَسْلِيمٌ':Added, #4: 4	غَيْرِ تَسْلِيمِ
u'غير تَسْلِيمٌ':Added, #4: 4	غَيْرِ تَسْلِيمِ
u'غَيْرٌ تَسْلِيمٌ':Added, #6: 6	غَيْرِ تَسْلِيمٍ
u'غير تَسْمِيَة':Added, #6: 6	غَيْرِ تَسْلِيمٍ
u'غَيْرٌ تَسْمِيَة':Added, #1: 1	غَيْرَ التَّسْمِيَةِ
u'غير تَسْمِيَة':Added, #1: 1	غَيْرَ التَّسْمِيَةِ
u'غَيْرٌ تَسْمِيَة':Added, #4: 4	غَيْرِ تَسْمِيَةٍ
u'غير تَسْمِيَة':Added, #4: 4	غَيْرِ تَسْمِيَةٍ
u'غَيْرٌ تَسْمِيَة':Added, #7: 7	غَيْرِ تَسْمِيَةِ
u'غير تَسْوِيَةٌ':Added, #7: 7	غَيْرِ تَسْمِيَةِ
u'غَيْرٌ تَسْوِيَةٌ':Added, #1: 1	غَيْرِ تَسْوِيَةٍ
u'غير تَسْوِيقٌ':Added, #1: 1	غَيْرِ تَسْوِيَةٍ
u'غَيْرٌ تَسْوِيقٌ':Added, #1: 1	غَيْرِ تَسْوِيقٍ
u'غير تَسْيِيرٌ':Added, #1: 1	غَيْرِ تَسْوِيقٍ
u'غَيْرٌ تَسْيِيرٌ':Added, #1: 1	غَيْرِ تَسْيِيرٍ
u'غير تَشَاغُلٌ':Added, #1: 1	غَيْرِ تَسْيِيرٍ
u'غَيْرٌ تَشَاغُلٌ':Added, #1: 1	غَيْرِ تَشَاغُلٍ
u'غير تَشَبُّهٌ':Added, #1: 1	غَيْرِ تَشَاغُلٍ
u'غَيْرٌ تَشَبُّهٌ':Added, #1: 1	غَيْرِ تَشَبُّهٍ
u'غير تَشْبِيه':Added, #1: 1	غَيْرِ تَشَبُّهٍ
u'غَيْرٌ تَشْبِيه':Added, #1: 1	غَيْرِ التّشْبِيهِ
u'غير تَشْبِيهٌ':Added, #1: 1	غَيْرِ التّشْبِيهِ
u'غَيْرٌ تَشْبِيهٌ':Added, #1: 1	غَيْرِ تَشْبِيهٍ
u'غير تَشْدِيدٌ':Added, #1: 1	غَيْرِ تَشْبِيهٍ
u'غَيْرٌ تَشْدِيدٌ':Added, #1: 1	غَيْرِ تَشْدِيدٍ
u'غير تَشَهُّدٌ':Added, #1: 1	غَيْرِ تَشْدِيدٍ
u'غَيْرٌ تَشَهُّدٌ':Added, #1: 1	غَيْرُ التَّشَهُّدِ
u'غير تَشَهُّدٌ':Added, #1: 1	غَيْرُ التَّشَهُّدِ
u'غَيْرٌ تَشَهُّدٌ':Added, #2: 2	غَيْرِ التَّشَهُّدِ
u'غير تَشَهُّدٌ':Added, #2: 2	غَيْرِ التَّشَهُّدِ
u'غَيْرٌ تَشَهُّدٌ':Added, #2: 2	غَيْرِ تَشَهُّدٍ
u'غير تَشَيُّعٌ':Added, #2: 2	غَيْرِ تَشَهُّدٍ
u'غَيْرٌ تَشَيُّعٌ':Added, #1: 1	غَيْرُ التَّشَيُّعِ
u'غير تَصْحِيحٌ':Added, #1: 1	غَيْرُ التَّشَيُّعِ
u'غَيْرٌ تَصْحِيحٌ':Added, #1: 1	غَيْرِ تَصْحِيحِ
u'غير تَصْحِيحٌ':Added, #1: 1	غَيْرِ تَصْحِيحِ
u'غَيْرٌ تَصْحِيحٌ':Added, #2: 2	غَيْرِ تَصْحِيحٍ
u'غير تَصْدِيقٌ':Added, #2: 2	غَيْرِ تَصْحِيحٍ
u'غَيْرٌ تَصْدِيقٌ':Added, #2: 2	غَيْرِ تَصْدِيقِهِ
u'غير تَصْدِيقٌ':Added, #2: 2	غَيْرِ تَصْدِيقِهِ
u'غَيْرٌ تَصْدِيقٌ':Added, #3: 3	غَيْرِ تَصْدِيقِ
u'غير تَصْدِيقٌ':Added, #3: 3	غَيْرِ تَصْدِيقِ
u'غَيْرٌ تَصْدِيقٌ':Added, #4: 4	غَيْرِ تَصْدِيقٍ
u'غير تَصَرُّفٌ':Added, #4: 4	غَيْرِ تَصْدِيقٍ
u'غَيْرٌ تَصَرُّفٌ':Added, #5: 5	غَيْرِ تَصَرُّفٍ
u'غير تَصْرِيحٌ':Added, #5: 5	غَيْرِ تَصَرُّفٍ
u'غَيْرٌ تَصْرِيحٌ':Added, #19: 19	غَيْرِ تَصْرِيحٍ
u'غير تَصْرِيحٌ':Added, #19: 19	غَيْرِ تَصْرِيحٍ
u'غَيْرٌ تَصْرِيحٌ':Added, #1: 1	غَيْرُ التَّصْرِيحِ
u'غير تَصْرِيحٌ':Added, #1: 1	غَيْرُ التَّصْرِيحِ
u'غَيْرٌ تَصْرِيحٌ':Added, #2: 2	غَيْرِ التَّصْرِيحِ
u'غير تَصْمِيمٌ':Added, #2: 2	غَيْرِ التَّصْرِيحِ
u'غَيْرٌ تَصْمِيمٌ':Added, #1: 1	غَيْرَ التَّصْمِيمِ
u'غير تَصَوُّرٌ':Added, #1: 1	غَيْرَ التَّصْمِيمِ
u'غير تَصَوُّرٌ':Added, #1: 1	غَيْرِ تَصَوُّرٍ
u'غَيْرٌ تَصَوُّرٌ':Added, #1: 1	غَيْرِ تَصَوُّرِ
u'غَيْرٌ تَصَوُّرٌ':Added, #1: 1	غَيْرِ تَصَوُّرٍ
u'غير تَصْوِيتٌ':Added, #1: 1	غَيْرِ تَصَوُّرِ
u'غَيْرٌ تَصْوِيتٌ':Added, #4: 4	غَيْرِ تَصْوِيتٍ
u'غير تَضْعِيفٌ':Added, #4: 4	غَيْرِ تَصْوِيتٍ
u'غَيْرٌ تَضْعِيفٌ':Added, #1: 1	غَيْرِ تَضْعِيفٍ
u'غير تَضْمِينٌ':Added, #1: 1	غَيْرِ تَضْعِيفٍ
u'غَيْرٌ تَضْمِينٌ':Added, #2: 2	غَيْرِ تَضْمِينٍ
u'غير تَضْيِيعٌ':Added, #2: 2	غَيْرِ تَضْمِينٍ
u'غَيْرٌ تَضْيِيعٌ':Added, #1: 1	غَيْرِ تَضْيِيعٍ
u'غير تَضْيِيعٌ':Added, #1: 1	غَيْرِ تَضْيِيعٍ
u'غَيْرٌ تَضْيِيعٌ':Added, #1: 1	غَيْرِ تَضْيِيعِهِ
u'غير تَضْيِيقٌ':Added, #1: 1	غَيْرِ تَضْيِيعِهِ
u'غَيْرٌ تَضْيِيقٌ':Added, #1: 1	غَيْرِ تَضْيِيقٍ
u'غير تَطْلِيقٌ':Added, #1: 1	غَيْرِ تَضْيِيقٍ
u'غَيْرٌ تَطْلِيقٌ':Added, #1: 1	غَيْرُ التَّطْلِيقِ
u'غير تَطْلِيقٌ':Added, #1: 1	غَيْرُ التَّطْلِيقِ
u'غَيْرٌ تَطْلِيقٌ':Added, #2: 2	غَيْرِ التَّطْلِيقِ
u'غير تَطَهُّرٌ':Added, #2: 2	غَيْرِ التَّطْلِيقِ
u'غَيْرٌ تَطَهُّرٌ':Added, #1: 1	غَيْرِ تَطَهُّرٍ
u'غير تَطْهِيرٌ':Added, #1: 1	غَيْرِ تَطَهُّرٍ
u'غَيْرٌ تَطْهِيرٌ':Added, #1: 1	غَيْرِ التَّطْهِيرِ
u'غير تَطْهِيرٌ':Added, #1: 1	غَيْرِ التَّطْهِيرِ
u'غَيْرٌ تَطْهِيرٌ':Added, #1: 1	غَيْرِ تَطْهِيرٍ
u'غير تَطَوُّعٌ':Added, #1: 1	غَيْرِ تَطْهِيرٍ
u'غَيْرٌ تَطَوُّعٌ':Added, #2: 2	غَيْرِ التَّطَوُّعِ
u'غير تَطْوِيلٌ':Added, #2: 2	غَيْرِ التَّطَوُّعِ
u'غَيْرٌ تَطْوِيلٌ':Added, #1: 1	غَيْرَ تَطْوِيلٍ
u'غير تَطْوِيلٌ':Added, #1: 1	غَيْرَ تَطْوِيلٍ
u'غَيْرٌ تَطْوِيلٌ':Added, #5: 5	غَيْرِ تَطْوِيلٍ
u'غير تَطَيُّبٌ':Added, #5: 5	غَيْرِ تَطْوِيلٍ
u'غَيْرٌ تَطَيُّبٌ':Added, #1: 1	غَيْرِ التَّطَيُّبِ
u'غير تَظَاهُرٌ':Added, #1: 1	غَيْرِ التَّطَيُّبِ
u'غَيْرٌ تَظَاهُرٌ':Added, #1: 1	غَيْرِ تَظَاهُرٍ
u'غير تَعَالِيقُ':Added, #1: 1	غَيْرِ تَظَاهُرٍ
u'غَيْرٌ تَعَالِيقُ':Added, #1: 1	غَيْرِ التَّعَالِيقِ
u'غير تَعَبُّدٌ':Added, #1: 1	غَيْرِ التَّعَالِيقِ
u'غَيْرٌ تَعَبُّدٌ':Added, #1: 1	غَيْرِ التَّعَبُّدِ
u'غير تَعْجِيل':Added, #1: 1	غَيْرِ التَّعَبُّدِ
u'غَيْرٌ تَعْجِيل':Added, #1: 1	غَيْرِ تَعْجِيلِ
u'غير تَعَدُّدٌ':Added, #1: 1	غَيْرِ تَعْجِيلِ
u'غَيْرٌ تَعَدُّدٌ':Added, #2: 2	غَيْرِ تَعَدُّدٍ
u'غير تَعْدِيَة':Added, #2: 2	غَيْرِ تَعَدُّدٍ
u'غَيْرٌ تَعْدِيَة':Added, #1: 1	غَيْرِ تَعْدِيَةٍ
u'غير تَعْدِيلٌ':Added, #1: 1	غَيْرِ تَعْدِيَةٍ
u'غَيْرٌ تَعْدِيلٌ':Added, #1: 1	غَيْرُ تَعْدِيلٍ
u'غير تَعْذِيب':Added, #1: 1	غَيْرُ تَعْدِيلٍ
u'غَيْرٌ تَعْذِيب':Added, #1: 1	غَيْرِ تَعْذِيبٍ
u'غير تَعَرُّضٌ':Added, #1: 1	غَيْرِ تَعْذِيبٍ
u'غَيْرٌ تَعَرُّضٌ':Added, #1: 1	غَيْرِ تَعَرُّضِ
u'غير تَعَرُّضٌ':Added, #1: 1	غَيْرِ تَعَرُّضِ
u'غَيْرٌ تَعَرُّضٌ':Added, #54: 54	غَيْرِ تَعَرُّضٍ
u'غير تَعْرِيفٌ':Added, #54: 54	غَيْرِ تَعَرُّضٍ
u'غَيْرٌ تَعْرِيفٌ':Added, #8: 8	غَيْرِ تَعْرِيفٍ
u'غير تَعْزِير':Added, #8: 8	غَيْرِ تَعْرِيفٍ
u'غَيْرٌ تَعْزِير':Added, #1: 1	غَيْرَ التَّعْزِيرِ
u'غير تَعَسُّرٌ':Added, #1: 1	غَيْرَ التَّعْزِيرِ
u'غَيْرٌ تَعَسُّرٌ':Added, #1: 1	غَيْرِ تَعَسُّرٍ
u'غير تَعَسُّفٌ':Added, #1: 1	غَيْرِ تَعَسُّرٍ
u'غَيْرٌ تَعَسُّفٌ':Added, #1: 1	غَيْرِ تَعَسُّفٍ
u'غير تَعَصُّبٌ':Added, #1: 1	غَيْرِ تَعَسُّفٍ
u'غَيْرٌ تَعَصُّبٌ':Added, #1: 1	غَيْرِ تَعَصُّبٍ
u'غير تَعَقُّبٌ':Added, #1: 1	غَيْرِ تَعَصُّبٍ
u'غَيْرٌ تَعَقُّبٌ':Added, #5: 5	غَيْرِ تَعَقُّبٍ
u'غير تَعْقِيبٌ':Added, #5: 5	غَيْرِ تَعَقُّبٍ
u'غَيْرٌ تَعْقِيبٌ':Added, #1: 1	غَيْرِ تَعْقِيبٍ
u'غير تَعَلُّقٌ':Added, #1: 1	غَيْرِ تَعْقِيبٍ
u'غَيْرٌ تَعَلُّقٌ':Added, #2: 2	غَيْرِ تَعَلُّقِ
u'غير تَعَلُّقٌ':Added, #2: 2	غَيْرِ تَعَلُّقِ
u'غَيْرٌ تَعَلُّقٌ':Added, #3: 3	غَيْرِ تَعَلُّقٍ
u'غير تَعَلُّمٌ':Added, #3: 3	غَيْرِ تَعَلُّقٍ
u'غَيْرٌ تَعَلُّمٌ':Added, #2: 2	غَيْرِ تَعَلُّمٍ
u'غير تَعْلِيقٌ':Added, #2: 2	غَيْرِ تَعَلُّمٍ
u'غَيْرٌ تَعْلِيقٌ':Added, #3: 3	غَيْرُ التَّعْلِيقِ
u'غير تَعْلِيقٌ':Added, #3: 3	غَيْرُ التَّعْلِيقِ
u'غَيْرٌ تَعْلِيقٌ':Added, #4: 4	غَيْرِ تَعْلِيقٍ
u'غير تَعْلِيلٌ':Added, #4: 4	غَيْرِ تَعْلِيقٍ
u'غَيْرٌ تَعْلِيلٌ':Added, #2: 2	غَيْرِ التَّعْلِيلِ
u'غير تَعَمُّدٌ':Added, #2: 2	غَيْرِ التَّعْلِيلِ
u'غَيْرٌ تَعَمُّدٌ':Added, #2: 2	غَيْرِ تَعَمُّدٍ
u'غير تَعْمِيرٌ':Added, #2: 2	غَيْرِ تَعَمُّدٍ
u'غَيْرٌ تَعْمِيرٌ':Added, #1: 1	غَيْرِ تَعْمِيرٍ
u'غير تَعْمِيمٌ':Added, #1: 1	غَيْرِ تَعْمِيرٍ
u'غَيْرٌ تَعْمِيمٌ':Added, #1: 1	غَيْرِ تَعْمِيمٍ
u'غير تَعَهُّدٌ':Added, #1: 1	غَيْرِ تَعْمِيمٍ
u'غَيْرٌ تَعَهُّدٌ':Added, #1: 1	غَيْرِ تَعَهُّدٍ
u'غير تَعْوِيلٌ':Added, #1: 1	غَيْرِ تَعَهُّدٍ
u'غَيْرٌ تَعْوِيلٌ':Added, #1: 1	غَيْرِ تَعْوِيلٍ
u'غير تَعَيُّنٌ':Added, #1: 1	غَيْرِ تَعْوِيلٍ
u'غَيْرٌ تَعَيُّنٌ':Added, #1: 1	غَيْرِ التَّعَيُّنِ
u'غير تَعْيِينٌ':Added, #1: 1	غَيْرِ التَّعَيُّنِ
u'غَيْرٌ تَعْيِينٌ':Added, #1: 1	غَيْرِ تَعْيِينِهِ
u'غير تَعْيِينٌ':Added, #1: 1	غَيْرِ تَعْيِينِهِ
u'غَيْرٌ تَعْيِينٌ':Added, #25: 25	غَيْرِ تَعْيِينِ
u'غير تَعْيِينٌ':Added, #25: 25	غَيْرِ تَعْيِينِ
u'غَيْرٌ تَعْيِينٌ':Added, #32: 32	غَيْرِ تَعْيِينٍ
u'غير تَغْرِيبٌ':Added, #32: 32	غَيْرِ تَعْيِينٍ
u'غَيْرٌ تَغْرِيبٌ':Added, #1: 1	غَيْرِ تَغْرِيبٍ
u'غير تَغْسِيلٌ':Added, #1: 1	غَيْرِ تَغْرِيبٍ
u'غَيْرٌ تَغْسِيلٌ':Added, #1: 1	غَيْرِ تَغْسِيلٍ
u'غير تَغَلُّبٌ':Added, #1: 1	غَيْرِ تَغْسِيلٍ
u'غَيْرٌ تَغَلُّبٌ':Added, #1: 1	غَيْرِ تَغَلُّبٍ
u'غير تَغَيُّرٌ':Added, #1: 1	غَيْرِ تَغَلُّبٍ
u'غَيْرٌ تَغَيُّرٌ':Added, #1: 1	غَيْرِ تَغَيُّرِ
u'غير تَغَيُّرٌ':Added, #1: 1	غَيْرِ تَغَيُّرِ
u'غَيْرٌ تَغَيُّرٌ':Added, #5: 5	غَيْرِ تَغَيُّرٍ
u'غير تَغْيِيرٌ':Added, #5: 5	غَيْرِ تَغَيُّرٍ
u'غَيْرٌ تَغْيِيرٌ':Added, #12: 12	غَيْرِ تَغْيِيرٍ
u'غير تَغْيِيرٌ':Added, #12: 12	غَيْرِ تَغْيِيرٍ
u'غَيْرٌ تَغْيِيرٌ':Added, #3: 3	غَيْرِ تَغْيِيرِ
u'غير تَفَاوُتٌ':Added, #3: 3	غَيْرِ تَغْيِيرِ
u'غَيْرٌ تَفَاوُتٌ':Added, #7: 7	غَيْرِ تَفَاوُتٍ
u'غير تَفَرُّقٌ':Added, #7: 7	غَيْرِ تَفَاوُتٍ
u'غَيْرٌ تَفَرُّقٌ':Added, #2: 2	غَيْرِ تَفَرُّقٍ
u'غير تَفْرِقَة':Added, #2: 2	غَيْرِ تَفَرُّقٍ
u'غَيْرٌ تَفْرِقَة':Added, #10: 10	غَيْرِ تَفْرِقَةٍ
u'غير تَفْرِقَة':Added, #10: 10	غَيْرِ تَفْرِقَةٍ
u'غَيْرٌ تَفْرِقَة':Added, #1: 1	غَيْرِ التَّفْرِقَةِ
u'غير تَفْرِقَة':Added, #1: 1	غَيْرِ التَّفْرِقَةِ
u'غَيْرٌ تَفْرِقَة':Added, #2: 2	غَيْرُ تَفْرِقَةٍ
u'غير تَفْرِيطٌ':Added, #2: 2	غَيْرُ تَفْرِقَةٍ
u'غَيْرٌ تَفْرِيطٌ':Added, #19: 19	غَيْرِ تَفْرِيطٍ
u'غير تَفْرِيقٌ':Added, #19: 19	غَيْرِ تَفْرِيطٍ
u'غَيْرٌ تَفْرِيقٌ':Added, #10: 10	غَيْرِ تَفْرِيقٍ
u'غير تَفْرِيقٌ':Added, #10: 10	غَيْرِ تَفْرِيقٍ
u'غَيْرٌ تَفْرِيقٌ':Added, #2: 2	غَيْرِ تَفْرِيقِ
u'غير تَفْسِيرٌ':Added, #2: 2	غَيْرِ تَفْرِيقِ
u'غَيْرٌ تَفْسِيرٌ':Added, #1: 1	غَيْرَ التّفْسِيرِ
u'غير تَفْسِيرٌ':Added, #1: 1	غَيْرَ التّفْسِيرِ
u'غَيْرٌ تَفْسِيرٌ':Added, #6: 6	غَيْرِ تَفْسِيرٍ
u'غير تَفْصِيلٌ':Added, #6: 6	غَيْرِ تَفْسِيرٍ
u'غَيْرٌ تَفْصِيلٌ':Added, #1: 1	غَيْر تَفْصِيلٍ
u'غير تَفْصِيلٌ':Added, #1: 1	غَيْر تَفْصِيلٍ
u'غَيْرٌ تَفْصِيلٌ':Added, #6: 6	غَيْرِ تَفْصِيلِ
u'غير تَفْصِيلٌ':Added, #6: 6	غَيْرِ تَفْصِيلِ
u'غَيْرٌ تَفْصِيلٌ':Added, #89: 89	غَيْرِ تَفْصِيلٍ
u'غير تَفْضِيلٌ':Added, #89: 89	غَيْرِ تَفْصِيلٍ
u'غَيْرٌ تَفْضِيلٌ':Added, #1: 1	غَيْرِ التَّفْضِيلِ
u'غير تَفْضِيلٌ':Added, #1: 1	غَيْرِ التَّفْضِيلِ
u'غَيْرٌ تَفْضِيلٌ':Added, #1: 1	غَيْرِ تَفْضِيلٍ
u'غير تَفَكُّرٌ':Added, #1: 1	غَيْرِ تَفْضِيلٍ
u'غَيْرٌ تَفَكُّرٌ':Added, #3: 3	غَيْرِ تَفَكُّرٍ
u'غير تَفْوِيت':Added, #3: 3	غَيْرِ تَفَكُّرٍ
u'غَيْرٌ تَفْوِيت':Added, #1: 1	غَيْرِ تَفْوِيتٍ
u'غير تَفْوِيضٌ':Added, #1: 1	غَيْرِ تَفْوِيتٍ
u'غَيْرٌ تَفْوِيضٌ':Added, #1: 1	غَيْرِ التَّفْوِيضِ
u'غير تَفْوِيضٌ':Added, #1: 1	غَيْرِ التَّفْوِيضِ
u'غَيْرٌ تَفْوِيضٌ':Added, #1: 1	غَيْرِ تَفْوِيضٍ
u'غير تَقابُض':Added, #1: 1	غَيْرِ تَفْوِيضٍ
u'غَيْرٌ تَقابُض':Added, #1: 1	غَيْرِ تَقَابُضٍ
u'غير تَقَارُبٌ':Added, #1: 1	غَيْرِ تَقَابُضٍ
u'غَيْرٌ تَقَارُبٌ':Added, #1: 1	غَيْرِ تَقَارُبٍ
u'غير تَقْتِيرٌ':Added, #1: 1	غَيْرِ تَقَارُبٍ
u'غَيْرٌ تَقْتِيرٌ':Added, #4: 4	غَيْرِ تَقْتِيرٍ
u'غير تَقَدُّمٌ':Added, #4: 4	غَيْرِ تَقْتِيرٍ
u'غَيْرٌ تَقَدُّمٌ':Added, #12: 12	غَيْرِ تَقَدُّمِ
u'غير تَقْديرٌ':Added, #12: 12	غَيْرِ تَقَدُّمِ
u'غَيْرٌ تَقْديرٌ':Added, #10: 10	غَيْرِ تَقْدِيرِ
u'غير تَقْديرٌ':Added, #10: 10	غَيْرِ تَقْدِيرِ
u'غَيْرٌ تَقْديرٌ':Added, #1: 1	غَيْرُ التَّقْدِيرِ
u'غير تَقْديرٌ':Added, #1: 1	غَيْرُ التَّقْدِيرِ
u'غير تَقْديرٌ':Added, #1: 1	غَيْرَ تَقْدِيرِ
u'غَيْرٌ تَقْديرٌ':Added, #1: 1	غَيْرُ تَقْدِيرِ
u'غَيْرٌ تَقْديرٌ':Added, #1: 1	غَيْرَ تَقْدِيرِ
u'غير تَقْديرٌ':Added, #1: 1	غَيْرُ تَقْدِيرِ
u'غَيْرٌ تَقْديرٌ':Added, #1: 1	غَيْرِ تَقْدِيرِهِ
u'غير تَقْديرٌ':Added, #1: 1	غَيْرِ تَقْدِيرِهِ
u'غَيْرٌ تَقْديرٌ':Added, #25: 25	غَيْرِ تَقْدِيرٍ
u'غير تَقْديرٌ':Added, #25: 25	غَيْرِ تَقْدِيرٍ
u'غَيْرٌ تَقْديرٌ':Added, #2: 2	غَيْرِ التَّقْدِيرِ
u'غير تَقْديمٌ':Added, #2: 2	غَيْرِ التَّقْدِيرِ
u'غَيْرٌ تَقْديمٌ':Added, #1: 1	غَيْرِ تَقْدِيمٍ
u'غير تَقْديمٌ':Added, #1: 1	غَيْرِ تَقْدِيمٍ
u'غَيْرٌ تَقْديمٌ':Added, #3: 3	غَيْرِ تَقْدِيمِ
u'غير تَقْريرٌ':Added, #3: 3	غَيْرِ تَقْدِيمِ
u'غَيْرٌ تَقْريرٌ':Added, #2: 2	غَيْرِ تَقْرِيرِ
u'غير تَقْصيرٌ':Added, #2: 2	غَيْرِ تَقْرِيرِ
u'غَيْرٌ تَقْصيرٌ':Added, #10: 10	غَيْرِ تَقْصِيرٍ
u'غير تَقْصيرٌ':Added, #10: 10	غَيْرِ تَقْصِيرٍ
u'غَيْرٌ تَقْصيرٌ':Added, #1: 1	غَيْرُ التَّقْصِيرِ
u'غير تَقْصيرٌ':Added, #1: 1	غَيْرُ التَّقْصِيرِ
u'غَيْرٌ تَقْصيرٌ':Added, #1: 1	غَيْرِ تَقْصِيرِ
u'غير تَقْصيرٌ':Added, #1: 1	غَيْرِ تَقْصِيرِ
u'غَيْرٌ تَقْصيرٌ':Added, #1: 1	غَيْرِ تَقْصِيرِهِ
u'غير تَقْطيعٌ':Added, #1: 1	غَيْرِ تَقْصِيرِهِ
u'غَيْرٌ تَقْطيعٌ':Added, #1: 1	غَيْرِ التَّقْطِيعِ
u'غير تَقْطيعٌ':Added, #1: 1	غَيْرِ التَّقْطِيعِ
u'غَيْرٌ تَقْطيعٌ':Added, #1: 1	غَيْرِ تَقْطِيعِهِ
u'غير تَقْليدٌ':Added, #1: 1	غَيْرِ تَقْطِيعِهِ
u'غير تَقْليد':Added, #1: 1	غَيْرِ تَقْلِيدِ
u'غَيْرٌ تَقْليدٌ':Added, #1: 1	غَيْرِ تَقْلِيدِ
u'غَيْرٌ تَقْليد':Added, #1: 1	غَيْرِ تَقْلِيدِ
u'غير تَقْليدٌ':Added, #1: 1	غَيْرِ تَقْلِيدِ
u'غير تَقْليد':Added, #6: 6	غَيْرِ تَقْلِيدٍ
u'غَيْرٌ تَقْليدٌ':Added, #6: 6	غَيْرِ تَقْلِيدٍ
u'غَيْرٌ تَقْليد':Added, #6: 6	غَيْرِ تَقْلِيدٍ
u'غير تَقَوُّتٌ':Added, #6: 6	غَيْرِ تَقْلِيدٍ
u'غَيْرٌ تَقَوُّتٌ':Added, #1: 1	غَيْرِ التَّقَوُّتِ
u'غير تَقْويمٌ':Added, #1: 1	غَيْرِ التَّقَوُّتِ
u'غَيْرٌ تَقْويمٌ':Added, #1: 1	غَيْرِ التَّقْوِيمِ
u'غير تَقْويمٌ':Added, #1: 1	غَيْرِ التَّقْوِيمِ
u'غَيْرٌ تَقْويمٌ':Added, #4: 4	غَيْرِ تَقْوِيمٍ
u'غير تَقْيِيد':Added, #4: 4	غَيْرِ تَقْوِيمٍ
u'غَيْرٌ تَقْيِيد':Added, #1: 1	غَيْرِ تَقْيِيدِ
u'غير تَقْيِيد':Added, #1: 1	غَيْرِ تَقْيِيدِ
u'غَيْرٌ تَقْيِيد':Added, #2: 2	غَيْرِ التَّقْيِيدِ
u'غير تَقْيِيد':Added, #2: 2	غَيْرِ التَّقْيِيدِ
u'غَيْرٌ تَقْيِيد':Added, #62: 62	غَيْرِ تَقْيِيدٍ
u'غير تَكْبيرٌ':Added, #62: 62	غَيْرِ تَقْيِيدٍ
u'غير تَكْبيرٌ':Added, #1: 1	غَيْرُ التَّكْبِيرِ
u'غَيْرٌ تَكْبيرٌ':Added, #1: 1	غَيْرِ التَّكْبِيرِ
u'غَيْرٌ تَكْبيرٌ':Added, #1: 1	غَيْرُ التَّكْبِيرِ
u'غير تَكْبيرٌ':Added, #1: 1	غَيْرِ التَّكْبِيرِ
u'غير تَكْبيرٌ':Added, #1: 1	غَيْرَ تَكْبِيرِ
u'غَيْرٌ تَكْبيرٌ':Added, #1: 1	غَيْرِ تَكْبِيرٍ
u'غَيْرٌ تَكْبيرٌ':Added, #1: 1	غَيْرَ تَكْبِيرِ
u'غير تَكْبيرٌ':Added, #1: 1	غَيْرِ تَكْبِيرٍ
u'غَيْرٌ تَكْبيرٌ':Added, #2: 2	غَيْرِ تَكْبِيرِ
u'غير تَكْبِير':Added, #2: 2	غَيْرِ تَكْبِيرِ
u'غَيْرٌ تَكْبِير':Added, #2: 2	غَيْرِ تَكْبِيرَةِ
u'غير تَكْبِير':Added, #2: 2	غَيْرِ تَكْبِيرَةِ
u'غَيْرٌ تَكْبِير':Added, #6: 6	غَيْرَ تَكْبِيرَةِ
u'غير تَكْرارٌ':Added, #6: 6	غَيْرَ تَكْبِيرَةِ
u'غَيْرٌ تَكْرارٌ':Added, #2: 2	غَيْرِ تَكْرَارِ
u'غير تَكْرارٌ':Added, #2: 2	غَيْرِ تَكْرَارِ
u'غَيْرٌ تَكْرارٌ':Added, #6: 6	غَيْرِ تَكْرَارٍ
u'غير تَكْريرٌ':Added, #6: 6	غَيْرِ تَكْرَارٍ
u'غَيْرٌ تَكْريرٌ':Added, #1: 1	غَيْرِ تَكْرِيرِ
u'غير تَكَسُّبٌ':Added, #1: 1	غَيْرِ تَكْرِيرِ
u'غَيْرٌ تَكَسُّبٌ':Added, #1: 1	غَيْرِ تَكَسُّبٍ
u'غير تَكَلُّفٌ':Added, #1: 1	غَيْرِ تَكَسُّبٍ
u'غَيْرٌ تَكَلُّفٌ':Added, #11: 11	غَيْرِ تَكَلُّفٍ
u'غير تَكَلُّفٌ':Added, #11: 11	غَيْرِ تَكَلُّفٍ
u'غَيْرٌ تَكَلُّفٌ':Added, #3: 3	غَيْرِ تَكَلُّفِ
u'غير تَكْليفٌ':Added, #3: 3	غَيْرِ تَكَلُّفِ
u'غَيْرٌ تَكْليفٌ':Added, #1: 1	غَيْرِ تَكْلِيفٍ
u'غير تَكْيِيفٌ':Added, #1: 1	غَيْرِ تَكْلِيفٍ
u'غَيْرٌ تَكْيِيفٌ':Added, #1: 1	غَيْرِ تَكْيِيفٍ
u'غير تَلاصُقٌ':Added, #1: 1	غَيْرِ تَكْيِيفٍ
u'غَيْرٌ تَلاصُقٌ':Added, #1: 1	غَيْرِ تَلَاصُقٍ
u'غير تِلاوَةٌ':Added, #1: 1	غَيْرِ تَلَاصُقٍ
u'غَيْرٌ تِلاوَةٌ':Added, #1: 1	غَيْرِ تِلَاوَةٍ
u'غير تِلاوَةٌ':Added, #1: 1	غَيْرِ تِلَاوَةٍ
u'غَيْرٌ تِلاوَةٌ':Added, #2: 2	غَيْرِ التِّلَاوَةِ
u'غير تَلْبيَةٌ':Added, #2: 2	غَيْرِ التِّلَاوَةِ
u'غير تَلْبيَةٌ':Added, #1: 1	غَيْرَ التَّلْبِيَةِ
u'غير تَلْبيَةٌ':Added, #1: 1	غَيْرُ التَّلْبِيَةِ
u'غَيْرٌ تَلْبيَةٌ':Added, #1: 1	غَيْرِ التَّلْبِيَةِ
u'غَيْرٌ تَلْبيَةٌ':Added, #1: 1	غَيْرَ التَّلْبِيَةِ
u'غَيْرٌ تَلْبيَةٌ':Added, #1: 1	غَيْرُ التَّلْبِيَةِ
u'غير تَلْبيَةٌ':Added, #1: 1	غَيْرِ التَّلْبِيَةِ
u'غَيْرٌ تَلْبيَةٌ':Added, #1: 1	غَيْرِ تَلْبِيَةٍ
u'غير تَلَفٌ':Added, #1: 1	غَيْرِ تَلْبِيَةٍ
u'غَيْرٌ تَلَفٌ':Added, #3: 3	غَيْرِ تَلَفٍ
u'غير تَلَفُّظٌ':Added, #3: 3	غَيْرِ تَلَفٍ
u'غَيْرٌ تَلَفُّظٌ':Added, #1: 1	غَيْرُ التَّلَفُّظِ
u'غير تَلَفُّظٌ':Added, #1: 1	غَيْرُ التَّلَفُّظِ
u'غَيْرٌ تَلَفُّظٌ':Added, #4: 4	غَيْرِ تَلَفُّظٍ
u'غير تَلَقُّطٌ':Added, #4: 4	غَيْرِ تَلَفُّظٍ
u'غَيْرٌ تَلَقُّطٌ':Added, #2: 2	غَيْرِ تَلَقُّطِ
u'غير تَلَوُّمٌ':Added, #2: 2	غَيْرِ تَلَقُّطِ
u'غَيْرٌ تَلَوُّمٌ':Added, #7: 7	غَيْرِ تَلَوُّمٍ
u'غير تمام':Added, #7: 7	غَيْرِ تَلَوُّمٍ
u'غير تَمامٌ':Added, #1: 1	غَيْرَ تَمَامٍ
u'غَيْرٌ تمام':Added, #1: 1	غَيْرَ تَمَامٍ
u'غَيْرٌ تَمامٌ':Added, #1: 1	غَيْرَ تَمَامٍ
u'غير تمام':Added, #1: 1	غَيْرَ تَمَامٍ
u'غير تَمامٌ':Added, #6: 6	غَيْرُ تَمَامٍ
u'غَيْرٌ تمام':Added, #6: 6	غَيْرُ تَمَامٍ
u'غَيْرٌ تَمامٌ':Added, #6: 6	غَيْرُ تَمَامٍ
u'غير تَمَتُّعٌ':Added, #6: 6	غَيْرُ تَمَامٍ
u'غَيْرٌ تَمَتُّعٌ':Added, #1: 1	غَيْرُ التَّمَتُّعِ
u'غير تَمْر':Added, #1: 1	غَيْرُ التَّمَتُّعِ
u'غَيْرٌ تَمْر':Added, #1: 1	غَيْرُ التَّمْرِ
u'غير تَمْر':Added, #1: 1	غَيْرُ التَّمْرِ
u'غير تَمْر':Added, #2: 2	غَيْرَ التَّمْرِ
u'غَيْرٌ تَمْر':Added, #2: 2	غَيْرِ التَّمْرِ
u'غَيْرٌ تَمْر':Added, #2: 2	غَيْرَ التَّمْرِ
u'غير تَمْرٌ':Added, #2: 2	غَيْرِ التَّمْرِ
u'غَيْرٌ تَمْرٌ':Added, #3: 3	غَيْرَ تَمْرٍ
u'غير تَمْرَةٌ':Added, #3: 3	غَيْرَ تَمْرٍ
u'غَيْرٌ تَمْرَةٌ':Added, #1: 1	غَيْرَ تَمْرَةٍ
u'غير تَمْكِينٌ':Added, #1: 1	غَيْرَ تَمْرَةٍ
u'غَيْرٌ تَمْكِينٌ':Added, #1: 1	غَيْرِ تَمْكِينِ
u'غير تَمْكِينٌ':Added, #1: 1	غَيْرِ تَمْكِينِ
u'غَيْرٌ تَمْكِينٌ':Added, #2: 2	غَيْرِ تَمْكِينٍ
u'غير تَمَلُّك':Added, #2: 2	غَيْرِ تَمْكِينٍ
u'غَيْرٌ تَمَلُّك':Added, #1: 1	غَيْرُ التَّمَلُّكِ
u'غير تَمَلُّكٌ':Added, #1: 1	غَيْرُ التَّمَلُّكِ
u'غَيْرٌ تَمَلُّكٌ':Added, #1: 1	غَيْرِ تَمَلُّكِ
u'غير تَمْلِيكٌ':Added, #1: 1	غَيْرِ تَمَلُّكِ
u'غَيْرٌ تَمْلِيكٌ':Added, #1: 1	غَيْرِ التَّمْلِيكَاتِ
u'غير تَمْلِيكٌ':Added, #1: 1	غَيْرِ التَّمْلِيكَاتِ
u'غير تَمْلِيكٌ':Added, #1: 1	غَيْر تَمْلِيكٍ
u'غير تَمْلِيكٌ':Added, #1: 1	غَيْرَ تَمْلِيكٍ
u'غَيْرٌ تَمْلِيكٌ':Added, #1: 1	غَيْرِ تَمْلِيكِ
u'غَيْرٌ تَمْلِيكٌ':Added, #1: 1	غَيْر تَمْلِيكٍ
u'غَيْرٌ تَمْلِيكٌ':Added, #1: 1	غَيْرَ تَمْلِيكٍ
u'غير تَمْلِيكٌ':Added, #1: 1	غَيْرِ تَمْلِيكِ
u'غَيْرٌ تَمْلِيكٌ':Added, #1: 1	غَيْرِ تَمْلِيكِهِ
u'غير تَمْلِيكٌ':Added, #1: 1	غَيْرِ تَمْلِيكِهِ
u'غَيْرٌ تَمْلِيكٌ':Added, #4: 4	غَيْرِ تَمْلِيكٍ
u'غير تَمَيُّزٌ':Added, #4: 4	غَيْرِ تَمْلِيكٍ
u'غَيْرٌ تَمَيُّزٌ':Added, #1: 1	غَيْرَ تَمَيُّزِهِ
u'غير تَمِيمِيّ':Added, #1: 1	غَيْرَ تَمَيُّزِهِ
u'غَيْرٌ تَمِيمِيّ':Added, #2: 2	غَيْرِ التَّمِيمِيِّ
u'غير تَمْييزٌ':Added, #2: 2	غَيْرِ التَّمِيمِيِّ
u'غَيْرٌ تَمْييزٌ':Added, #1: 1	غَيْرُ التَّمْيِيزِ
u'غير تَمْييزٌ':Added, #1: 1	غَيْرُ التَّمْيِيزِ
u'غَيْرٌ تَمْييزٌ':Added, #1: 1	غَيْرِ تَمْيِيزِ
u'غير تَمْييزٌ':Added, #1: 1	غَيْرِ تَمْيِيزِ
u'غَيْرٌ تَمْييزٌ':Added, #5: 5	غَيْرِ تَمْيِيزٍ
u'غير تَنَاقُضٌ':Added, #5: 5	غَيْرِ تَمْيِيزٍ
u'غَيْرٌ تَنَاقُضٌ':Added, #1: 1	غَيْرِ تَنَاقُضٍ
u'غير تَنْبِيه':Added, #1: 1	غَيْرِ تَنَاقُضٍ
u'غَيْرٌ تَنْبِيه':Added, #1: 1	غَيْرِ التَّنْبِيهِ
u'غير تَنْبِيهٌ':Added, #1: 1	غَيْرِ التَّنْبِيهِ
u'غَيْرٌ تَنْبِيهٌ':Added, #2: 2	غَيْرِ تَنْبِيهٍ
u'غير تَنْجِيزٌ':Added, #2: 2	غَيْرِ تَنْبِيهٍ
u'غَيْرٌ تَنْجِيزٌ':Added, #1: 1	غَيْرُ التَّنْجِيزِ
u'غير تَنَحُّلٌ':Added, #1: 1	غَيْرُ التَّنْجِيزِ
u'غَيْرٌ تَنَحُّلٌ':Added, #2: 2	غَيْرَ تَنَحّلٍ
u'غير تَنْزِيلٌ':Added, #2: 2	غَيْرَ تَنَحّلٍ
u'غَيْرٌ تَنْزِيلٌ':Added, #1: 1	غَيْرِ التَّنْزِيلِ
u'غير تَنْصِيص':Added, #1: 1	غَيْرِ التَّنْزِيلِ
u'غَيْرٌ تَنْصِيص':Added, #5: 5	غَيْرِ تَنْصِيصٍ
u'غير تَنَفُّلٌ':Added, #5: 5	غَيْرِ تَنْصِيصٍ
u'غَيْرٌ تَنَفُّلٌ':Added, #1: 1	غَيْرُ التَّنَفُّلِ
u'غير تَنَفُّلٌ':Added, #1: 1	غَيْرُ التَّنَفُّلِ
u'غَيْرٌ تَنَفُّلٌ':Added, #1: 1	غَيْرِ تَنَفُّلٍ
u'غير تَنْفِيذٌ':Added, #1: 1	غَيْرِ تَنَفُّلٍ
u'غَيْرٌ تَنْفِيذٌ':Added, #1: 1	غَيْرِ تَنْفِيذٍ
u'غير تَنْفِيرٌ':Added, #1: 1	غَيْرِ تَنْفِيذٍ
u'غير تَنْفِيرٌ':Added, #1: 1	غَيْرِ تَنْفِيرٍ
u'غَيْرٌ تَنْفِيرٌ':Added, #1: 1	غَيْرِ تَنْفِيرِ
u'غَيْرٌ تَنْفِيرٌ':Added, #1: 1	غَيْرِ تَنْفِيرٍ
u'غير تَنْكِيسٌ':Added, #1: 1	غَيْرِ تَنْفِيرِ
u'غَيْرٌ تَنْكِيسٌ':Added, #1: 1	غَيْرِ تَنْكِيسٍ
u'غير تَهَجُّدٌ':Added, #1: 1	غَيْرِ تَنْكِيسٍ
u'غَيْرٌ تَهَجُّدٌ':Added, #2: 2	غَيْرُ التَّهَجُّدِ
u'غير تَهْدِيدٌ':Added, #2: 2	غَيْرُ التَّهَجُّدِ
u'غَيْرٌ تَهْدِيدٌ':Added, #2: 2	غَيْرِ تَهْدِيدٍ
u'غير تَهْذِيبٌ':Added, #2: 2	غَيْرِ تَهْدِيدٍ
u'غَيْرٌ تَهْذِيبٌ':Added, #1: 1	غَيْرِ تَهْذِيبِ
u'غير تَوَاتُرٌ':Added, #1: 1	غَيْرِ تَهْذِيبِ
u'غَيْرٌ تَوَاتُرٌ':Added, #1: 1	غَيْرِ التَّوَاتُرِ
u'غير تَوَاتُرٌ':Added, #1: 1	غَيْرِ التَّوَاتُرِ
u'غَيْرٌ تَوَاتُرٌ':Added, #1: 1	غَيْرِ تَوَاتُرٍ
u'غير تَوْبَةٌ':Added, #1: 1	غَيْرِ تَوَاتُرٍ
u'غَيْرٌ تَوْبَةٌ':Added, #10: 10	غَيْرِ تَوْبَةٍ
u'غير تَوْبِيخٌ':Added, #10: 10	غَيْرِ تَوْبَةٍ
u'غَيْرٌ تَوْبِيخٌ':Added, #1: 1	غَيْرِ تَوْبِيخٍ
u'غير تَوَضُّؤٌ':Added, #1: 1	غَيْرِ تَوْبِيخٍ
u'غَيْرٌ تَوَضُّؤٌ':Added, #1: 1	غَيْرِ التَّوَضُّؤِ
u'غير تَوْفِيقٌ':Added, #1: 1	غَيْرِ التَّوَضُّؤِ
u'غَيْرٌ تَوْفِيقٌ':Added, #1: 1	غَيْرَ تَوْفِيقِ
u'غير تَوْفِيقٌ':Added, #1: 1	غَيْرَ تَوْفِيقِ
u'غَيْرٌ تَوْفِيقٌ':Added, #3: 3	غَيْرِ تَوْفِيقٍ
u'غير تَوَقُّعٌ':Added, #3: 3	غَيْرِ تَوْفِيقٍ
u'غَيْرٌ تَوَقُّعٌ':Added, #1: 1	غَيْرِ تَوَقُّعِ
u'غير تَوَقُّفٌ':Added, #1: 1	غَيْرِ تَوَقُّعِ
u'غَيْرٌ تَوَقُّفٌ':Added, #84: 84	غَيْرِ تَوَقُّفٍ
u'غير تَوْقِيتٌ':Added, #84: 84	غَيْرِ تَوَقُّفٍ
u'غَيْرٌ تَوْقِيتٌ':Added, #5: 5	غَيْرِ تَوْقِيتٍ
u'غير تَوْكِيلٌ':Added, #5: 5	غَيْرِ تَوْقِيتٍ
u'غير تَوْكِيلٌ':Added, #1: 1	غَيْرُ التَّوْكِيلِ
u'غَيْرٌ تَوْكِيلٌ':Added, #1: 1	غَيْرِ التَّوْكِيلِ
u'غَيْرٌ تَوْكِيلٌ':Added, #1: 1	غَيْرُ التَّوْكِيلِ
u'غير تَوْكِيلٌ':Added, #1: 1	غَيْرِ التَّوْكِيلِ
u'غَيْرٌ تَوْكِيلٌ':Added, #2: 2	غَيْرِ تَوْكِيلٍ
u'غير تَوَهُّمٌ':Added, #2: 2	غَيْرِ تَوْكِيلٍ
u'غَيْرٌ تَوَهُّمٌ':Added, #1: 1	غَيْرِ تَوَهُّمِ
u'غير تَيَمُّمٌ':Added, #1: 1	غَيْرِ تَوَهُّمِ
u'غَيْرٌ تَيَمُّمٌ':Added, #6: 6	غَيْرِ تَيَمُّمٍ
u'غير ثَابِتٌ':Added, #6: 6	غَيْرِ تَيَمُّمٍ
u'غَيْرٌ ثَابِتٌ':Added, #12: 12	غَيْرَ ثَابِتٍ
u'غير ثَابِتٌ':Added, #12: 12	غَيْرَ ثَابِتٍ
u'غَيْرٌ ثَابِتٌ':Added, #18: 18	غَيْرُ ثَابِتَةٍ
u'غير ثَابِتٌ':Added, #18: 18	غَيْرُ ثَابِتَةٍ
u'غَيْرٌ ثَابِتٌ':Added, #1: 1	غَيْرُ الثَّابِتِ
u'غير ثَابِتٌ':Added, #1: 1	غَيْرُ الثَّابِتِ
u'غَيْرٌ ثَابِتٌ':Added, #1: 1	غَيْرَ الثَّابِتَةِ
u'غير ثَابِتٌ':Added, #1: 1	غَيْرَ الثَّابِتَةِ
u'غَيْرٌ ثَابِتٌ':Added, #1: 1	غَيْرَ ثَابِتَيْنِ
u'غير ثَابِتٌ':Added, #1: 1	غَيْرَ ثَابِتَيْنِ
u'غَيْرٌ ثَابِتٌ':Added, #2: 2	غَيْرَ الثَّابِتِ
u'غير ثَابِتٌ':Added, #2: 2	غَيْرَ الثَّابِتِ
u'غَيْرٌ ثَابِتٌ':Added, #3: 3	غَيْرَ ثَابِتِ
u'غير ثَابِتٌ':Added, #3: 3	غَيْرَ ثَابِتِ
u'غَيْرٌ ثَابِتٌ':Added, #6: 6	غَيْرُ ثَابِتِ
u'غير ثَابِتٌ':Added, #6: 6	غَيْرُ ثَابِتِ
u'غَيْرٌ ثَابِتٌ':Added, #76: 76	غَيْرُ ثَابِتٍ
u'غير ثَابِتٌ':Added, #76: 76	غَيْرُ ثَابِتٍ
u'غَيْرٌ ثَابِتٌ':Added, #7: 7	غَيْرِ ثَابِتٍ
u'غير ثابتة':Added, #7: 7	غَيْرِ ثَابِتٍ
u'غَيْرٌ ثابتة':Added, #18: 18	غَيْرُ ثَابِتَةٍ
u'غير ثابتة':Added, #18: 18	غَيْرُ ثَابِتَةٍ
u'غَيْرٌ ثابتة':Added, #1: 1	غَيْرَ الثَّابِتَةِ
u'غير ثَالِثٌ':Added, #1: 1	غَيْرَ الثَّابِتَةِ
u'غير ثَالِثٌ':Added, #1: 1	غَيْرَ الثَّالِثِ
u'غَيْرٌ ثَالِثٌ':Added, #1: 1	غَيْرِ الثَّالِثِ
u'غَيْرٌ ثَالِثٌ':Added, #1: 1	غَيْرَ الثَّالِثِ
u'غير ثَانِي':Added, #1: 1	غَيْرِ الثَّالِثِ
u'غير ثَانِي':Added, #1: 1	غَيْرُ الثَّانِيَةِ
u'غَيْرٌ ثَانِي':Added, #1: 1	غَيْرِ الثَّانِيَةِ
u'غَيْرٌ ثَانِي':Added, #1: 1	غَيْرُ الثَّانِيَةِ
u'غير ثَانِيَةٌ':Added, #1: 1	غَيْرِ الثَّانِيَةِ
u'غير ثَانِيَةٌ':Added, #1: 1	غَيْرُ الثَّانِيَةِ
u'غَيْرٌ ثَانِيَةٌ':Added, #1: 1	غَيْرِ الثَّانِيَةِ
u'غَيْرٌ ثَانِيَةٌ':Added, #1: 1	غَيْرُ الثَّانِيَةِ
u'غير ثَبْتٌ':Added, #1: 1	غَيْرِ الثَّانِيَةِ
u'غير ثَبْتٌ':Added, #1: 1	غَيْرَ ثَبْتٍ
u'غَيْرٌ ثَبْتٌ':Added, #1: 1	غَيْرُ ثَبْتٍ
u'غَيْرٌ ثَبْتٌ':Added, #1: 1	غَيْرَ ثَبْتٍ
u'غير ثَبْتٌ':Added, #1: 1	غَيْرُ ثَبْتٍ
u'غَيْرٌ ثَبْتٌ':Added, #2: 2	غَيْرِ ثَبْتٍ
u'غير ثُبُوتٌ':Added, #2: 2	غَيْرِ ثَبْتٍ
u'غَيْرٌ ثُبُوتٌ':Added, #1: 1	غَيْرِ ثُبُوتِهِ
u'غير ثُبُوتٌ':Added, #1: 1	غَيْرِ ثُبُوتِهِ
u'غَيْرٌ ثُبُوتٌ':Added, #2: 2	غَيْرِ ثُبُوتٍ
u'غير ثُبُوتٌ':Added, #2: 2	غَيْرِ ثُبُوتٍ
u'غَيْرٌ ثُبُوتٌ':Added, #5: 5	غَيْرِ ثُبُوتِ
u'غير ثَغْرٌ':Added, #5: 5	غَيْرِ ثُبُوتِ
u'غَيْرٌ ثَغْرٌ':Added, #1: 1	غَيْرِ الثَّغْرِ
u'غير ثِقَةٌ':Added, #1: 1	غَيْرِ الثَّغْرِ
u'غَيْرٌ ثِقَةٌ':Added, #17: 17	غَيْرَ ثِقَةٍ
u'غير ثِقَة':Added, #17: 17	غَيْرَ ثِقَةٍ
u'غَيْرٌ ثِقَة':Added, #1: 1	غَيْرِ الثِّقَاتِ
u'غير ثِقَةٌ':Added, #1: 1	غَيْرِ الثِّقَاتِ
u'غير ثِقَةٌ':Added, #1: 1	غَيْرَ الثِّقَةِ
u'غَيْرٌ ثِقَةٌ':Added, #1: 1	غَيْرُ الثِّقَةِ
u'غَيْرٌ ثِقَةٌ':Added, #1: 1	غَيْرَ الثِّقَةِ
u'غير ثِقَة':Added, #1: 1	غَيْرُ الثِّقَةِ
u'غير ثِقَة':Added, #2: 2	غَيْرَ ثِقَاتٍ
u'غَيْرٌ ثِقَة':Added, #2: 2	غَيْرُ ثِقَاتٍ
u'غَيْرٌ ثِقَة':Added, #2: 2	غَيْرَ ثِقَاتٍ
u'غير ثِقَةٌ':Added, #2: 2	غَيْرُ ثِقَاتٍ
u'غَيْرٌ ثِقَةٌ':Added, #4: 4	غَيْرِ ثِقَةٍ
u'غير ثِقَةٌ':Added, #4: 4	غَيْرِ ثِقَةٍ
u'غَيْرٌ ثِقَةٌ':Added, #8: 8	غَيْرُ ثِقَةٍ
u'غير ثَقَل':Added, #8: 8	غَيْرُ ثِقَةٍ
u'غَيْرٌ ثَقَل':Added, #1: 1	غَيْرِ الثَّقَلَيْنِ
u'غير ثَقَل':Added, #1: 1	غَيْرِ الثَّقَلَيْنِ
u'غَيْرٌ ثَقَل':Added, #2: 2	غَيْرَ الثَّقَلَيْنِ
u'غير ثَلاثُ':Added, #2: 2	غَيْرَ الثَّقَلَيْنِ
u'غير ثَلاثُ':Added, #1: 1	غَيْرُ الثَّلَاثِ
u'غَيْرٌ ثَلاثُ':Added, #1: 1	غَيْرِ الثَّلَاثِ
u'غَيْرٌ ثَلاثُ':Added, #1: 1	غَيْرُ الثَّلَاثِ
u'غير ثَلاثُ':Added, #1: 1	غَيْرِ الثَّلَاثِ
u'غَيْرٌ ثَلاثُ':Added, #1: 1	غَيْرَ ثَلاَثِ
u'غَيَّرَ ثَلاثَةٌ':Predicate, #1: 1	غَيْرَ ثَلاَثِ
u'غير ثَلاثَةٌ':Added, #1: 1	غَيَّرَ الثَّلَاثَةَ
u'غير ثَلاثَةٌ':Added, #1: 1	غَيْرَ ثَلَاثَةٍ
u'غير ثَلاثَةٌ':Added, #1: 1	غَيْرُ ثَلَاثَةِ
u'غير ثَلاثَةٌ':Added, #1: 1	غَيْرِ ثَلَاثَةٍ
u'غَيْرٌ ثَلاثَةٌ':Added, #1: 1	غَيْرِ ثَلَاثَةِ
u'غَيْرٌ ثَلاثَةٌ':Added, #1: 1	غَيْرَ ثَلَاثَةٍ
u'غَيْرٌ ثَلاثَةٌ':Added, #1: 1	غَيْرُ ثَلَاثَةِ
u'غَيْرٌ ثَلاثَةٌ':Added, #1: 1	غَيْرِ ثَلَاثَةٍ
u'غير ثَلاثَةٌ':Added, #1: 1	غَيْرِ ثَلَاثَةِ
u'غَيْرٌ ثَلاثَةٌ':Added, #2: 2	غَيْرُ الثَّلَاثَةِ
u'غير ثَلاثَةٌ':Added, #2: 2	غَيْرُ الثَّلَاثَةِ
u'غَيْرٌ ثَلاثَةٌ':Added, #3: 3	غَيْرَ الثَّلَاثَةِ
u'غير ثَلاثَةٌ':Added, #3: 3	غَيْرَ الثَّلَاثَةِ
u'غَيْرٌ ثَلاثَةٌ':Added, #6: 6	غَيْرَ ثَلَاثَةِ
u'غير ثَلاثَةٌ':Added, #6: 6	غَيْرَ ثَلَاثَةِ
u'غَيْرٌ ثَلاثَةٌ':Added, #9: 9	غَيْرِ الثَّلَاثَةِ
u'غير ثُلاثِيٌّ':Added, #9: 9	غَيْرِ الثَّلَاثَةِ
u'غَيْرٌ ثُلاثِيٌّ':Added, #1: 1	غَيْرِ الثُّلَاثِيَّةِ
u'غير ثِمارٌ':Added, #1: 1	غَيْرِ الثُّلَاثِيَّةِ
u'غَيْرٌ ثِمارٌ':Added, #1: 1	غَيْرِ الثِّمَارِ
u'غير ثَمانِيَةٌ':Added, #1: 1	غَيْرِ الثِّمَارِ
u'غَيْرٌ ثَمانِيَةٌ':Added, #1: 1	غَيْرِ الثَّمَانِيَةِ
u'غير ثَمَرٌ':Added, #1: 1	غَيْرِ الثَّمَانِيَةِ
u'غير ثَمَرٌ':Added, #1: 1	غَيْرُ الثَّمَرِ
u'غَيْرٌ ثَمَرٌ':Added, #1: 1	غَيْرِ الثَّمَرِ
u'غَيْرٌ ثَمَرٌ':Added, #1: 1	غَيْرُ الثَّمَرِ
u'غير ثَمَرَةٌ':Added, #1: 1	غَيْرِ الثَّمَرِ
u'غَيْرٌ ثَمَرَةٌ':Added, #1: 1	غَيْرِ ثَمَرَةٍ
u'غير ثَمَرَةٌ':Added, #1: 1	غَيْرِ ثَمَرَةٍ
u'غَيْرٌ ثَمَرَةٌ':Added, #3: 3	غَيْرِ الثَّمَرَةِ
u'غير ثَمَنٌ':Added, #3: 3	غَيْرِ الثَّمَرَةِ
u'غَيْرٌ ثَمَنٌ':Added, #11: 11	غَيْرِ ثَمَنِهِ
u'غير ثَمَنٌ':Added, #11: 11	غَيْرِ ثَمَنِهِ
u'غَيْرٌ ثَمَنٌ':Added, #1: 1	غَيْرِ ثَمَنِ
u'غير ثَمَنٌ':Added, #1: 1	غَيْرِ ثَمَنِ
u'غير ثَمَنٌ':Added, #3: 3	غَيْرَ الثَّمَنِ
u'غَيْرٌ ثَمَنٌ':Added, #3: 3	غَيْرِ الثَّمَنِ
u'غَيْرٌ ثَمَنٌ':Added, #3: 3	غَيْرَ الثَّمَنِ
u'غير ثَمَنٌ':Added, #3: 3	غَيْرِ الثَّمَنِ
u'غَيْرٌ ثَمَنٌ':Added, #4: 4	غَيْرِ ثَمَنٍ
u'غير ثَمَنٌ':Added, #4: 4	غَيْرِ ثَمَنٍ
u'غَيْرٌ ثَمَنٌ':Added, #7: 7	غَيْرُ الثَّمَنِ
u'غير ثُنائِيٌّ':Added, #7: 7	غَيْرُ الثَّمَنِ
u'غَيْرٌ ثُنائِيٌّ':Added, #1: 1	غَيْرَ ثُنَائِيَّةٍ
u'غير ثُنائِيٌّ':Added, #1: 1	غَيْرَ ثُنَائِيَّةٍ
u'غَيْرٌ ثُنائِيٌّ':Added, #2: 2	غَيْرِ الثُّنَائِيَّةِ
u'غير ثَنِيَّةٌ':Added, #2: 2	غَيْرِ الثُّنَائِيَّةِ
u'غَيْرٌ ثَنِيَّةٌ':Added, #1: 1	غَيْرِ ثَنِيَّةٍ
u'غير ثَوابٌ':Added, #1: 1	غَيْرِ ثَنِيَّةٍ
u'غَيْرٌ ثَوابٌ':Added, #1: 1	غَيْرُ الثَّوَابِ
u'غير ثَوابٌ':Added, #1: 1	غَيْرُ الثَّوَابِ
u'غَيْرٌ ثَوابٌ':Added, #2: 2	غَيْرَ الثَّوَابِ
u'غير ثَوْبٌ':Added, #2: 2	غَيْرَ الثَّوَابِ
u'غَيْرٌ ثَوْبٌ':Added, #2: 2	غَيْرِ ثَوْبٍ
u'غير ثَوْبٌ':Added, #2: 2	غَيْرِ ثَوْبٍ
u'غَيْرٌ ثَوْبٌ':Added, #2: 2	غَيْرِ ثَوْبِهِ
u'غير ثَوْبٌ':Added, #2: 2	غَيْرِ ثَوْبِهِ
u'غَيْرٌ ثَوْبٌ':Added, #4: 4	غَيْرُ ثَوْبٍ
u'غير ثِيابٌ':Added, #4: 4	غَيْرُ ثَوْبٍ
u'غَيْرٌ ثِيابٌ':Added, #1: 1	غَيْرِ الثِّيَابِ
u'غير ثِيابٌ':Added, #1: 1	غَيْرِ الثِّيَابِ
u'غير ثِيابٌ':Added, #1: 1	غَيْرُ ثِيَابِهِ
u'غَيْرٌ ثِيابٌ':Added, #1: 1	غَيْرِ ثِيَابِهِ
u'غَيْرٌ ثِيابٌ':Added, #1: 1	غَيْرُ ثِيَابِهِ
u'غير ثِيابٌ':Added, #1: 1	غَيْرِ ثِيَابِهِ
u'غير ثِيابٌ':Added, #2: 2	غَيْرَ ثِيَابِ
u'غَيْرٌ ثِيابٌ':Added, #2: 2	غَيْرِ ثِيَابِ
u'غَيْرٌ ثِيابٌ':Added, #2: 2	غَيْرَ ثِيَابِ
u'غير ثَيِّبٌ':Added, #2: 2	غَيْرِ ثِيَابِ
u'غَيْرٌ ثَيِّبٌ':Added, #1: 1	غَيْرِ الثَّيِّبِ
u'غير جَابِرٌ':Added, #1: 1	غَيْرِ الثَّيِّبِ
u'غَيْرٌ جَابِرٌ':Added, #1: 1	غَيْرِ جَابِرٍ
u'غير جَابِرٌ':Added, #1: 1	غَيْرِ جَابِرٍ
u'غَيْرٌ جَابِرٌ':Added, #4: 4	غَيْرُ جَابِرٍ
u'غير جَاحِدٌ':Added, #4: 4	غَيْرُ جَابِرٍ
u'غَيْرٌ جَاحِدٌ':Added, #2: 2	غَيْرَ جَاحِدٍ
u'غير جَادٌّ':Added, #2: 2	غَيْرَ جَاحِدٍ
u'غَيْرٌ جَادٌّ':Added, #1: 1	غَيْرِ الْجَادَّةِ
u'غير جَادَّةٌ':Added, #1: 1	غَيْرِ الْجَادَّةِ
u'غَيْرٌ جَادَّةٌ':Added, #1: 1	غَيْرِ الْجَادَّةِ
u'غير جَارٌ':Added, #1: 1	غَيْرِ الْجَادَّةِ
u'غَيْرٌ جَارٌ':Added, #2: 2	غَيْرِ الْجَارِ
u'غير جَارٌ':Added, #2: 2	غَيْرِ الْجَارِ
u'غَيْرٌ جَارٌ':Added, #5: 5	غَيْرَ جَارٍ
u'غير جَارٌ':Added, #5: 5	غَيْرَ جَارٍ
u'غَيْرٌ جَارٌ':Added, #9: 9	غَيْرُ جَارٍ
u'غير جَارِحٌ':Added, #9: 9	غَيْرُ جَارٍ
u'غَيْرٌ جَارِحٌ':Added, #1: 1	غَيْرُ الْجَارِحِ
u'غير جَارِحٌ':Added, #1: 1	غَيْرُ الْجَارِحِ
u'غَيْرٌ جَارِحٌ':Added, #1: 1	غَيْرُ جَارِحَةٍ
u'غير جَارِحٌ':Added, #1: 1	غَيْرُ جَارِحَةٍ
u'غير جَارِحٌ':Added, #2: 2	غَيْرَ جَارِحٍ
u'غَيْرٌ جَارِحٌ':Added, #2: 2	غَيْرُ جَارِحٍ
u'غَيْرٌ جَارِحٌ':Added, #2: 2	غَيْرَ جَارِحٍ
u'غير جَارِحَةٌ':Added, #2: 2	غَيْرُ جَارِحٍ
u'غَيْرٌ جَارِحَةٌ':Added, #1: 1	غَيْرُ جَارِحَةٍ
u'غير جَارِي':Added, #1: 1	غَيْرُ جَارِحَةٍ
u'غير جَارِي':Added, #1: 1	غَيْرَ جَارِيَةٍ
u'غَيْرٌ جَارِي':Added, #1: 1	غَيْرُ جَارِيَةٍ
u'غَيْرٌ جَارِي':Added, #1: 1	غَيْرَ جَارِيَةٍ
u'غير جَارِيَةٌ':Added, #1: 1	غَيْرُ جَارِيَةٍ
u'غير جَارِيَةٌ':Added, #1: 1	غَيْرَ جَارِيَةٍ
u'غَيْرٌ جَارِيَةٌ':Added, #1: 1	غَيْرُ جَارِيَةٍ
u'غَيْرٌ جَارِيَةٌ':Added, #1: 1	غَيْرَ جَارِيَةٍ
u'غير جَازِمٌ':Added, #1: 1	غَيْرُ جَارِيَةٍ
u'غَيْرٌ جَازِمٌ':Added, #1: 1	غَيْرِ جَازِمٍ
u'غير جَازِمٌ':Added, #1: 1	غَيْرِ جَازِمٍ
u'غَيْرٌ جَازِمٌ':Added, #5: 5	غَيْرُ جَازِمٍ
u'غير جَازِمٌ':Added, #5: 5	غَيْرُ جَازِمٍ
u'غَيْرٌ جَازِمٌ':Added, #6: 6	غَيْرَ جَازِمٍ
u'غير جَامِعٌ':Added, #6: 6	غَيْرَ جَازِمٍ
u'غير جَامِعٌ':Added, #1: 1	غَيْرَ جَامِعِ
u'غَيْرٌ جَامِعٌ':Added, #1: 1	غَيْرِ جَامِعٍ
u'غَيْرٌ جَامِعٌ':Added, #1: 1	غَيْرَ جَامِعِ
u'غير جَامِعٌ':Added, #1: 1	غَيْرِ جَامِعٍ
u'غَيْرٌ جَامِعٌ':Added, #1: 1	غَيْرُ جَامِعَةٍ
u'غير جَامِعٌ':Added, #1: 1	غَيْرُ جَامِعَةٍ
u'غَيْرٌ جَامِعٌ':Added, #21: 21	غَيْرُ جَامِعٍ
u'غير جَامِعٌ':Added, #21: 21	غَيْرُ جَامِعٍ
u'غَيْرٌ جَامِعٌ':Added, #3: 3	غَيْرَ جَامِعٍ
u'غير جَامِعٌ':Added, #3: 3	غَيْرَ جَامِعٍ
u'غَيْرٌ جَامِعٌ':Added, #4: 4	غَيْرَ الْجَامِعِ
u'غير جَامِعٌ':Added, #4: 4	غَيْرَ الْجَامِعِ
u'غَيْرٌ جَامِعٌ':Added, #8: 8	غَيْرِ الْجَامِعِ
u'غير جَامِعَةٌ':Added, #8: 8	غَيْرِ الْجَامِعِ
u'غَيْرٌ جَامِعَةٌ':Added, #1: 1	غَيْرُ جَامِعَةٍ
u'غير جَانِبٌ':Added, #1: 1	غَيْرُ جَامِعَةٍ
u'غَيْرٌ جَانِبٌ':Added, #1: 1	غَيْر الْجَانِبِ
u'غير جَانِبٌ':Added, #1: 1	غَيْر الْجَانِبِ
u'غَيْرٌ جَانِبٌ':Added, #2: 2	غَيْرِ جَانِبِ
u'غير جَاهِلٌ':Added, #2: 2	غَيْرِ جَانِبِ
u'غَيْرٌ جَاهِلٌ':Added, #1: 1	غَيْرُ جَاهِلٍ
u'غير جَاهِلٌ':Added, #1: 1	غَيْرُ جَاهِلٍ
u'غَيْرٌ جَاهِلٌ':Added, #4: 4	غَيْرَ جَاهِلٍ
u'غير جَاهِلِيٌّ':Added, #4: 4	غَيْرَ جَاهِلٍ
u'غَيْرٌ جَاهِلِيٌّ':Added, #1: 1	غَيْرُ جَاهِلِيٍّ
u'غير جَائِحٌ':Added, #1: 1	غَيْرُ جَاهِلِيٍّ
u'غَيْرٌ جَائِحٌ':Added, #1: 1	غَيْرُ جَائِحَةٍ
u'غير جَائِحٌ':Added, #1: 1	غَيْرُ جَائِحَةٍ
u'غَيْرٌ جَائِحٌ':Added, #2: 2	غَيْرَ الْجَائِحَةِ
u'غير جاَئِحَةٌ':Added, #2: 2	غَيْرَ الْجَائِحَةِ
u'غَيْرٌ جاَئِحَةٌ':Added, #1: 1	غَيْرُ جَائِحَةٍ
u'غير جاَئِحَةٌ':Added, #1: 1	غَيْرُ جَائِحَةٍ
u'غَيْرٌ جاَئِحَةٌ':Added, #2: 2	غَيْرَ الْجَائِحَةِ
u'غير جَائِرٌ':Added, #2: 2	غَيْرَ الْجَائِحَةِ
u'غَيْرٌ جَائِرٌ':Added, #2: 2	غَيْرُ جَائِرٍ
u'غير جَائِزٌ':Added, #2: 2	غَيْرُ جَائِرٍ
u'غَيْرٌ جَائِزٌ':Added, #11: 11	غَيْرَ جَائِزٍ
u'غير جَائِزٌ':Added, #11: 11	غَيْرَ جَائِزٍ
u'غَيْرٌ جَائِزٌ':Added, #12: 12	غَيْرُ جَائِزِ
u'غير جَائِزٌ':Added, #12: 12	غَيْرُ جَائِزِ
u'غَيْرٌ جَائِزٌ':Added, #12: 12	غَيْرُ جَائِزَةٍ
u'غير جَائِزٌ':Added, #12: 12	غَيْرُ جَائِزَةٍ
u'غَيْرٌ جَائِزٌ':Added, #150: 150	غَيْرُ جَائِزٍ
u'غير جَائِزٌ':Added, #150: 150	غَيْرُ جَائِزٍ
u'غير جَائِزٌ':Added, #1: 1	غَيْرَ الْجَائِزِ
u'غَيْرٌ جَائِزٌ':Added, #1: 1	غَيْرُ الْجَائِزِ
u'غَيْرٌ جَائِزٌ':Added, #1: 1	غَيْرَ الْجَائِزِ
u'غير جَائِزٌ':Added, #1: 1	غَيْرُ الْجَائِزِ
u'غَيْرٌ جَائِزٌ':Added, #1: 1	غَيْرَ جَائِزَةِ
u'غير جَائِزٌ':Added, #1: 1	غَيْرَ جَائِزَةِ
u'غَيْرٌ جَائِزٌ':Added, #2: 2	غَيْرَ جَائِزِ
u'غير جَائِزٌ':Added, #2: 2	غَيْرَ جَائِزِ
u'غَيْرٌ جَائِزٌ':Added, #4: 4	غَيْرَ جَائِزَةٍ
u'غير جَائِزٌ':Added, #4: 4	غَيْرَ جَائِزَةٍ
u'غَيْرٌ جَائِزٌ':Added, #5: 5	غَيْرِ الْجَائِزِ
u'غير جَائِزٌ':Added, #5: 5	غَيْرِ الْجَائِزِ
u'غَيْرٌ جَائِزٌ':Added, #5: 5	غَيْرِ جَائِزٍ
u'غير جَائِزَةٌ':Added, #5: 5	غَيْرِ جَائِزٍ
u'غَيْرٌ جَائِزَةٌ':Added, #12: 12	غَيْرُ جَائِزَةٍ
u'غير جَائِزَةٌ':Added, #12: 12	غَيْرُ جَائِزَةٍ
u'غَيْرٌ جَائِزَةٌ':Added, #1: 1	غَيْرَ جَائِزَةِ
u'غير جَائِزَةٌ':Added, #1: 1	غَيْرَ جَائِزَةِ
u'غَيْرٌ جَائِزَةٌ':Added, #4: 4	غَيْرَ جَائِزَةٍ
u'غير جَبْرٌ':Added, #4: 4	غَيْرَ جَائِزَةٍ
u'غَيْرٌ جَبْرٌ':Added, #1: 1	غَيْرِ جَبْرٍ
u'غير جَبْهَةٌ':Added, #1: 1	غَيْرِ جَبْرٍ
u'غَيْرٌ جَبْهَةٌ':Added, #2: 2	غَيْرِ الْجَبْهَةِ
u'غير جَبِيرَة':Added, #2: 2	غَيْرِ الْجَبْهَةِ
u'غير جَبِيرَة':Added, #1: 1	غَيْرَ الْجَبِيرَةِ
u'غَيْرٌ جَبِيرَة':Added, #1: 1	غَيْرِ الْجَبِيرَةِ
u'غَيْرٌ جَبِيرَة':Added, #1: 1	غَيْرَ الْجَبِيرَةِ
u'غير جَبِيرَة':Added, #1: 1	غَيْرِ الْجَبِيرَةِ
u'غَيْرٌ جَبِيرَة':Added, #1: 1	غَيْرَ جَبِيرَةٍ
u'غير جَحْد':Added, #1: 1	غَيْرَ جَبِيرَةٍ
u'غَيْرٌ جَحْد':Added, #1: 1	غَيْرِ جَحْدٍ
u'غير جُحُود':Added, #1: 1	غَيْرِ جَحْدٍ
u'غَيْرٌ جُحُود':Added, #1: 1	غَيْرِ جُحُودٍ
u'غير جِدار':Added, #1: 1	غَيْرِ جُحُودٍ
u'غَيْرٌ جِدار':Added, #1: 1	غَيْرِ جِدَارِ
u'غير جِدار':Added, #1: 1	غَيْرِ جِدَارِ
u'غَيْرٌ جِدار':Added, #4: 4	غَيْرِ جِدَارٍ
u'غير جدعاء':Added, #4: 4	غَيْرِ جِدَارٍ
u'غَيْرٌ جدعاء':Added, #1: 1	غَيْرُ الْجَدْعَاءِ
u'غير جَديدٌ':Added, #1: 1	غَيْرُ الْجَدْعَاءِ
u'غَيْرٌ جَديدٌ':Added, #1: 1	غَيْرِ جَدِيدٍ
u'غير جَديدٌ':Added, #1: 1	غَيْرِ جَدِيدٍ
u'غَيْرٌ جَديدٌ':Added, #2: 2	غَيْرَ جَدِيدٍ
u'غير جِرَاحَةٌ':Added, #2: 2	غَيْرَ جَدِيدٍ
u'غَيْرٌ جِرَاحَةٌ':Added, #1: 1	غَيْرِ جِرَاحَةٍ
u'غير جَرَادٌ':Added, #1: 1	غَيْرِ جِرَاحَةٍ
u'غَيْرٌ جَرَادٌ':Added, #1: 1	غَيْرِ الْجَرَادِ
u'غير جَرَّارٌ':Added, #1: 1	غَيْرِ الْجَرَادِ
u'غَيْرٌ جَرَّارٌ':Added, #1: 1	غَيْرَ جَرّارٍ
u'غير جُرْحٌ':Added, #1: 1	غَيْرَ جَرّارٍ
u'غَيْرٌ جُرْحٌ':Added, #1: 1	غَيْرِ الْجُرْحِ
u'غير جُرْحٌ':Added, #1: 1	غَيْرِ الْجُرْحِ
u'غير جُرْحٌ':Added, #1: 1	غَيْرَ جُرْحٍ
u'غَيْرٌ جُرْحٌ':Added, #1: 1	غَيْرُ جُرْحٍ
u'غَيْرٌ جُرْحٌ':Added, #1: 1	غَيْرَ جُرْحٍ
u'غير جُرْحٌ':Added, #1: 1	غَيْرُ جُرْحٍ
u'غَيْرٌ جُرْحٌ':Added, #7: 7	غَيْرِ جُرْحٍ
u'غير جُرْمٌ':Added, #7: 7	غَيْرِ جُرْحٍ
u'غَيْرٌ جُرْمٌ':Added, #3: 3	غَيْرِ جُرْمٍ
u'غير جَرَيان':Added, #3: 3	غَيْرِ جُرْمٍ
u'غَيْرٌ جَرَيان':Added, #1: 1	غَيْرِ جَرَيَانِ
u'غير جُزْءٌ':Added, #1: 1	غَيْرِ جَرَيَانِ
u'غير جُزْءٌ':Added, #1: 1	غَيْرُ الْجُزْءِ
u'غَيْرٌ جُزْءٌ':Added, #1: 1	غَيْرِ الْجُزْءِ
u'غَيْرٌ جُزْءٌ':Added, #1: 1	غَيْرُ الْجُزْءِ
u'غير جُزْءٌ':Added, #1: 1	غَيْرِ الْجُزْءِ
u'غير جُزْءٌ':Added, #1: 1	غَيْرَ جُزْءٍ
u'غَيْرٌ جُزْءٌ':Added, #1: 1	غَيْرُ جُزْءٍ
u'غَيْرٌ جُزْءٌ':Added, #1: 1	غَيْرَ جُزْءٍ
u'غير جَزَاءٌ':Added, #1: 1	غَيْرُ جُزْءٍ
u'غَيْرٌ جَزَاءٌ':Added, #2: 2	غَيْرِ جَزَاءٍ
u'غير جَزْم':Added, #2: 2	غَيْرِ جَزَاءٍ
u'غَيْرٌ جَزْم':Added, #3: 3	غَيْرِ جَزْمٍ
u'غير جُزْئِيٌّ':Added, #3: 3	غَيْرِ جَزْمٍ
u'غَيْرٌ جُزْئِيٌّ':Added, #1: 1	غَيْرِ الْجُزْئِيِّ
u'غير جَزِيرَةٌ':Added, #1: 1	غَيْرِ الْجُزْئِيِّ
u'غير جَزِيرَةٌ':Added, #1: 1	غَيْرُ جَزِيرَةِ
u'غَيْرٌ جَزِيرَةٌ':Added, #1: 1	غَيْرِ جَزِيرَةِ
u'غَيْرٌ جَزِيرَةٌ':Added, #1: 1	غَيْرُ جَزِيرَةِ
u'غير جَفْنَةٌ':Added, #1: 1	غَيْرِ جَزِيرَةِ
u'غَيْرٌ جَفْنَةٌ':Added, #1: 1	غَيْرِ جَفْنَةٍ
u'غير جلد':Added, #1: 1	غَيْرِ جَفْنَةٍ
u'غَيْرٌ جلد':Added, #1: 1	غَيْرُ الْجَلْدِ
u'غير جَلْدٌ':Added, #1: 1	غَيْرُ الْجَلْدِ
u'غَيْرٌ جَلْدٌ':Added, #1: 1	غَيْرُ الْجَلْدِ
u'غير جلد':Added, #1: 1	غَيْرُ الْجَلْدِ
u'غَيْرٌ جلد':Added, #1: 1	غَيْرِ جَلْدِ
u'غير جَلْدٌ':Added, #1: 1	غَيْرِ جَلْدِ
u'غَيْرٌ جَلْدٌ':Added, #1: 1	غَيْرِ جَلْدِ
u'غير جلد':Added, #1: 1	غَيْرِ جَلْدِ
u'غَيْرٌ جلد':Added, #2: 2	غَيْرِ الْجِلْدِ
u'غير جِلْدٌ':Added, #2: 2	غَيْرِ الْجِلْدِ
u'غَيْرٌ جِلْدٌ':Added, #2: 2	غَيْرِ الْجِلْدِ
u'غير جلد':Added, #2: 2	غَيْرِ الْجِلْدِ
u'غَيْرٌ جلد':Added, #2: 2	غَيْرَ جِلْدِ
u'غير جِلْدٌ':Added, #2: 2	غَيْرَ جِلْدِ
u'غَيْرٌ جِلْدٌ':Added, #2: 2	غَيْرَ جِلْدِ
u'غير جُلُوسٌ':Added, #2: 2	غَيْرَ جِلْدِ
u'غَيْرٌ جُلُوسٌ':Added, #11: 11	غَيْرِ جُلُوسٍ
u'غير جُلُوسٌ':Added, #11: 11	غَيْرِ جُلُوسٍ
u'غَيْرٌ جُلُوسٌ':Added, #1: 1	غَيْرِ الْجُلُوسِ
u'غير جُلُوسٌ':Added, #1: 1	غَيْرِ الْجُلُوسِ
u'غَيْرٌ جُلُوسٌ':Added, #1: 1	غَيْرِ جُلُوسِ
u'غير جَلِيٌّ':Added, #1: 1	غَيْرِ جُلُوسِ
u'غَيْرٌ جَلِيٌّ':Added, #1: 1	غَيْرِ الْجَلِيِّ
u'غير جَلِيٌّ':Added, #1: 1	غَيْرِ الْجَلِيِّ
u'غير جَلِيٌّ':Added, #1: 1	غَيْرَ جَلِيٍّ
u'غير جَلِيٌّ':Added, #1: 1	غَيْرُ جَلِيٍّ
u'غَيْرٌ جَلِيٌّ':Added, #1: 1	غَيْرُ جَلِيِّ
u'غَيْرٌ جَلِيٌّ':Added, #1: 1	غَيْرَ جَلِيٍّ
u'غَيْرٌ جَلِيٌّ':Added, #1: 1	غَيْرُ جَلِيٍّ
u'غير جماع':Added, #1: 1	غَيْرُ جَلِيِّ
u'غَيْرٌ جماع':Added, #15: 15	غَيْرِ جِمَاعٍ
u'غير جِمَاعٌ':Added, #15: 15	غَيْرِ جِمَاعٍ
u'غَيْرٌ جِمَاعٌ':Added, #15: 15	غَيْرِ جِمَاعٍ
u'غير جماع':Added, #15: 15	غَيْرِ جِمَاعٍ
u'غَيْرٌ جماع':Added, #1: 1	غَيْرُ الْجِمَاعِ
u'غير جِمَاعٌ':Added, #1: 1	غَيْرُ الْجِمَاعِ
u'غَيْرٌ جِمَاعٌ':Added, #1: 1	غَيْرُ الْجِمَاعِ
u'غير جماع':Added, #1: 1	غَيْرُ الْجِمَاعِ
u'غَيْرٌ جماع':Added, #1: 1	غَيْرَ جِمَاعٍ
u'غير جِمَاعٌ':Added, #1: 1	غَيْرَ جِمَاعٍ
u'غَيْرٌ جِمَاعٌ':Added, #1: 1	غَيْرَ جِمَاعٍ
u'غير جماع':Added, #1: 1	غَيْرَ جِمَاعٍ
u'غَيْرٌ جماع':Added, #2: 2	غَيْرَ الْجِمَاعِ
u'غير جِمَاعٌ':Added, #2: 2	غَيْرَ الْجِمَاعِ
u'غَيْرٌ جِمَاعٌ':Added, #2: 2	غَيْرَ الْجِمَاعِ
u'غير جماع':Added, #2: 2	غَيْرَ الْجِمَاعِ
u'غَيْرٌ جماع':Added, #4: 4	غَيْرِ الْجِمَاعِ
u'غير جِمَاعٌ':Added, #4: 4	غَيْرِ الْجِمَاعِ
u'غَيْرٌ جِمَاعٌ':Added, #4: 4	غَيْرِ الْجِمَاعِ
u'غير جَمَاعَةٌ':Added, #4: 4	غَيْرِ الْجِمَاعِ
u'غَيْرٌ جَمَاعَةٌ':Added, #1: 1	غَيْرِ الْجَمَاعَةِ
u'غير جَمَاعَةٌ':Added, #1: 1	غَيْرِ الْجَمَاعَةِ
u'غَيْرٌ جَمَاعَةٌ':Added, #2: 2	غَيْرُ الْجَمَاعَةِ
u'غير جَمَاعَةٌ':Added, #2: 2	غَيْرُ الْجَمَاعَةِ
u'غَيْرٌ جَمَاعَةٌ':Added, #4: 4	غَيْرِ جَمَاعَةٍ
u'غير جَمَدٌ':Added, #4: 4	غَيْرِ جَمَاعَةٍ
u'غَيْرٌ جَمَدٌ':Added, #1: 1	غَيْرُ الْجَمَدِ
u'غير جمع':Added, #1: 1	غَيْرُ الْجَمَدِ
u'غَيْرٌ جمع':Added, #1: 1	غَيْرِ الْجَمْعِ
u'غير جَمْعٌ':Added, #1: 1	غَيْرِ الْجَمْعِ
u'غَيْرٌ جَمْعٌ':Added, #1: 1	غَيْرِ الْجَمْعِ
u'غير جمع':Added, #1: 1	غَيْرِ الْجَمْعِ
u'غَيْرٌ جمع':Added, #1: 1	غَيْرِ جَمْعِ
u'غير جَمْعٌ':Added, #1: 1	غَيْرِ جَمْعِ
u'غير جَمْعٌ':Added, #1: 1	غَيْرَ جَمْعٍ
u'غَيْرٌ جَمْعٌ':Added, #1: 1	غَيْرِ جَمْعِ
u'غَيْرٌ جَمْعٌ':Added, #1: 1	غَيْرَ جَمْعٍ
u'غير جمع':Added, #1: 1	غَيْرِ جَمْعِ
u'غَيْرٌ جمع':Added, #2: 2	غَيْرَ الْجَمْعِ
u'غير جَمْعٌ':Added, #2: 2	غَيْرَ الْجَمْعِ
u'غَيْرٌ جَمْعٌ':Added, #2: 2	غَيْرَ الْجَمْعِ
u'غير جَمْعٌ':Added, #2: 2	غَيْرَ الْجَمْعِ
u'غَيْرٌ جَمْعٌ':Added, #2: 2	غَيْرِ جَمْعٍ
u'غير جمع':Added, #2: 2	غَيْرِ جَمْعٍ
u'غَيْرٌ جمع':Added, #6: 6	غَيْرُ الْجَمْعِ
u'غير جَمْعٌ':Added, #6: 6	غَيْرُ الْجَمْعِ
u'غَيْرٌ جَمْعٌ':Added, #6: 6	غَيْرُ الْجَمْعِ
u'غير جمعة':Added, #6: 6	غَيْرُ الْجَمْعِ
u'غير جمعة':Added, #1: 1	غَيْرُ الْجُمُعَةِ
u'غَيْرٌ جمعة':Added, #1: 1	غَيْرِ الْجُمْعَةِ
u'غَيْرٌ جمعة':Added, #1: 1	غَيْرُ الْجُمُعَةِ
u'غير جُمُعَةٌ':Added, #1: 1	غَيْرِ الْجُمْعَةِ
u'غَيْرٌ جُمُعَةٌ':Added, #1: 1	غَيْرُ الْجُمُعَةِ
u'غير جمعة':Added, #1: 1	غَيْرُ الْجُمُعَةِ
u'غَيْرٌ جمعة':Added, #2: 2	غَيْرَ جُمُعَةٍ
u'غير جُمُعَةٌ':Added, #2: 2	غَيْرَ جُمُعَةٍ
u'غَيْرٌ جُمُعَةٌ':Added, #2: 2	غَيْرَ جُمُعَةٍ
u'غير جمعة':Added, #2: 2	غَيْرَ جُمُعَةٍ
u'غَيْرٌ جمعة':Added, #3: 3	غَيْرَ الْجُمُعَةِ
u'غير جُمُعَةٌ':Added, #3: 3	غَيْرَ الْجُمُعَةِ
u'غَيْرٌ جُمُعَةٌ':Added, #3: 3	غَيْرَ الْجُمُعَةِ
u'غير جمعة':Added, #3: 3	غَيْرَ الْجُمُعَةِ
u'غَيْرٌ جمعة':Added, #44: 44	غَيْرِ الْجُمُعَةِ
u'غير جُمُعَةٌ':Added, #44: 44	غَيْرِ الْجُمُعَةِ
u'غَيْرٌ جُمُعَةٌ':Added, #44: 44	غَيْرِ الْجُمُعَةِ
u'غير جمعة':Added, #44: 44	غَيْرِ الْجُمُعَةِ
u'غَيْرٌ جمعة':Added, #5: 5	غَيْرِ جُمُعَةٍ
u'غير جُمُعَةٌ':Added, #5: 5	غَيْرِ جُمُعَةٍ
u'غَيْرٌ جُمُعَةٌ':Added, #5: 5	غَيْرِ جُمُعَةٍ
u'غير جَمِيلٌ':Added, #5: 5	غَيْرِ جُمُعَةٍ
u'غَيْرٌ جَمِيلٌ':Added, #1: 1	غَيْرِ الْجَمِيلِ
u'غير جَمِيلٌ':Added, #1: 1	غَيْرِ الْجَمِيلِ
u'غَيْرٌ جَمِيلٌ':Added, #1: 1	غَيْرُ جَمِيلِ
u'غير جِنٌّ':Added, #1: 1	غَيْرُ جَمِيلِ
u'غَيْرٌ جِنٌّ':Added, #1: 1	غَيْرَ الْجِنِّ
u'غير جَنَابَةٌ':Added, #1: 1	غَيْرَ الْجِنِّ
u'غَيْرٌ جَنَابَةٌ':Added, #1: 1	غَيْرُ الْجَنَابَةِ
u'غير جَنَابَةٌ':Added, #1: 1	غَيْرُ الْجَنَابَةِ
u'غَيْرٌ جَنَابَةٌ':Added, #1: 1	غَيْرِ جَنَابَةٍ
u'غير جَنَابَةٌ':Added, #1: 1	غَيْرِ جَنَابَةٍ
u'غَيْرٌ جَنَابَةٌ':Added, #2: 2	غَيْرِ الْجَنَابَةِ
u'غير جِنَايَةٌ':Added, #2: 2	غَيْرِ الْجَنَابَةِ
u'غَيْرٌ جِنَايَةٌ':Added, #1: 1	غَيْرِ الْجِنَايَاتِ
u'غير جِنَايَةٌ':Added, #1: 1	غَيْرِ الْجِنَايَاتِ
u'غَيْرٌ جِنَايَةٌ':Added, #1: 1	غَيْرِ الْجِنَايَةِ
u'غير جِنَايَةٌ':Added, #1: 1	غَيْرِ الْجِنَايَةِ
u'غَيْرٌ جِنَايَةٌ':Added, #2: 2	غَيْرِ جِنَايَةِ
u'غير جِنَايَةٌ':Added, #2: 2	غَيْرِ جِنَايَةِ
u'غَيْرٌ جِنَايَةٌ':Added, #6: 6	غَيْرِ جِنَايَةٍ
u'غير جَنَّةٌ':Added, #6: 6	غَيْرِ جِنَايَةٍ
u'غَيْرٌ جَنَّةٌ':Added, #3: 3	غَيْرَ الْجَنَّةِ
u'غير جُنْدِيٌّ':Added, #3: 3	غَيْرَ الْجَنَّةِ
u'غَيْرٌ جُنْدِيٌّ':Added, #2: 2	غَيْرِ الْجُنْدِيِّ
u'غير جِنْسٌ':Added, #2: 2	غَيْرِ الْجُنْدِيِّ
u'غَيْرٌ جِنْسٌ':Added, #1: 1	غَيْرُ الْجِنْسِ
u'غير جِنْسٌ':Added, #1: 1	غَيْرُ الْجِنْسِ
u'غَيْرٌ جِنْسٌ':Added, #2: 2	غَيْرَ جِنْسِهِ
u'غير جِنْسٌ':Added, #2: 2	غَيْرَ جِنْسِهِ
u'غَيْرٌ جِنْسٌ':Added, #48: 48	غَيْرِ جِنْسِ
u'غير جِنْسٌ':Added, #48: 48	غَيْرِ جِنْسِ
u'غَيْرٌ جِنْسٌ':Added, #4: 4	غَيْرَ الْجِنْسِ
u'غير جِنْسٌ':Added, #4: 4	غَيْرَ الْجِنْسِ
u'غَيْرٌ جِنْسٌ':Added, #4: 4	غَيْرَ جِنْسِ
u'غير جِنْسٌ':Added, #4: 4	غَيْرَ جِنْسِ
u'غَيْرٌ جِنْسٌ':Added, #72: 72	غَيْرِ الْجِنْسِ
u'غير جِنْسٌ':Added, #72: 72	غَيْرِ الْجِنْسِ
u'غَيْرٌ جِنْسٌ':Added, #7: 7	غَيْرُ جِنْسِ
u'غير جِنْسٌ':Added, #7: 7	غَيْرُ جِنْسِ
u'غَيْرٌ جِنْسٌ':Added, #96: 96	غَيْرِ جِنْسِهِ
u'غير جُنُونٌ':Added, #96: 96	غَيْرِ جِنْسِهِ
u'غَيْرٌ جُنُونٌ':Added, #1: 1	غَيْرِ الْجُنُونِ
u'غير جُنُونٌ':Added, #1: 1	غَيْرِ الْجُنُونِ
u'غَيْرٌ جُنُونٌ':Added, #2: 2	غَيْرِ جُنُونٍ
u'غير جَنِينٌ':Added, #2: 2	غَيْرِ جُنُونٍ
u'غير جَنِينٌ':Added, #1: 1	غَيْرُ الْجَنِينِ
u'غَيْرٌ جَنِينٌ':Added, #1: 1	غَيْرِ الْجَنِينِ
u'غَيْرٌ جَنِينٌ':Added, #1: 1	غَيْرُ الْجَنِينِ
u'غير جهاد':Added, #1: 1	غَيْرِ الْجَنِينِ
u'غَيْرٌ جهاد':Added, #8: 8	غَيْرِ الْجِهَادِ
u'غير جِهَادٌ':Added, #8: 8	غَيْرِ الْجِهَادِ
u'غَيْرٌ جِهَادٌ':Added, #8: 8	غَيْرِ الْجِهَادِ
u'غير جِهَةٌ':Added, #8: 8	غَيْرِ الْجِهَادِ
u'غَيْرٌ جِهَةٌ':Added, #15: 15	غَيْرِ جِهَتِهِ
u'غير جِهَةٌ':Added, #15: 15	غَيْرِ جِهَتِهِ
u'غَيْرٌ جِهَةٌ':Added, #1: 1	غَيْرَ الْجِهَةِ
u'غير جِهَةٌ':Added, #1: 1	غَيْرَ الْجِهَةِ
u'غَيْرٌ جِهَةٌ':Added, #1: 1	غَيْرِ جِهَاتِهِ
u'غير جِهَةٌ':Added, #1: 1	غَيْرِ جِهَاتِهِ
u'غَيْرٌ جِهَةٌ':Added, #1: 1	غَيْرَ جِهَتِهِ
u'غير جِهَةٌ':Added, #1: 1	غَيْرَ جِهَتِهِ
u'غَيْرٌ جِهَةٌ':Added, #2: 2	غَيْرَ جِهَةِ
u'غير جِهَةٌ':Added, #2: 2	غَيْرَ جِهَةِ
u'غَيْرٌ جِهَةٌ':Added, #41: 41	غَيْرِ جِهَةِ
u'غير جِهَةٌ':Added, #41: 41	غَيْرِ جِهَةِ
u'غَيْرٌ جِهَةٌ':Added, #4: 4	غَيْرِ الْجِهَةِ
u'غير جَهْلٌ':Added, #4: 4	غَيْرِ الْجِهَةِ
u'غَيْرٌ جَهْلٌ':Added, #1: 1	غَيْرِ جَهْلٍ
u'غير جَوَابٌ':Added, #1: 1	غَيْرِ جَهْلٍ
u'غَيْرٌ جَوَابٌ':Added, #1: 1	غَيْرِ جَوَابٍ
u'غير جوارح':Added, #1: 1	غَيْرِ جَوَابٍ
u'غَيْرٌ جوارح':Added, #1: 1	غَيْرِ الْجَوَارِحِ
u'غير جَوَارِحُ':Added, #1: 1	غَيْرِ الْجَوَارِحِ
u'غَيْرٌ جَوَارِحُ':Added, #1: 1	غَيْرِ الْجَوَارِحِ
u'غير جَوَامِعُ':Added, #1: 1	غَيْرِ الْجَوَارِحِ
u'غَيْرٌ جَوَامِعُ':Added, #1: 1	غَيْرُ الْجَوَامِعِ
u'غير جَوْرٌ':Added, #1: 1	غَيْرُ الْجَوَامِعِ
u'غَيْرٌ جَوْرٌ':Added, #1: 1	غَيْرُ الْجَوْرِ
u'غير جُوعٌ':Added, #1: 1	غَيْرُ الْجَوْرِ
u'غَيْرٌ جُوعٌ':Added, #1: 1	غَيْرُ الْجُوعِ
u'غير جُوعٌ':Added, #1: 1	غَيْرُ الْجُوعِ
u'غَيْرٌ جُوعٌ':Added, #3: 3	غَيْرِ جُوعٍ
u'غير جوف':Added, #3: 3	غَيْرِ جُوعٍ
u'غَيْرٌ جوف':Added, #2: 2	غَيْرِ الْجَوْفِ
u'غير جَوْفٌ':Added, #2: 2	غَيْرِ الْجَوْفِ
u'غَيْرٌ جَوْفٌ':Added, #2: 2	غَيْرِ الْجَوْفِ
u'غير جَوْهَرِيٌّ':Added, #2: 2	غَيْرِ الْجَوْفِ
u'غَيْرٌ جَوْهَرِيٌّ':Added, #2: 2	غَيْرِ جَوْهَرِيٍّ
u'غير جِيرَانٌ':Added, #2: 2	غَيْرِ جَوْهَرِيٍّ
u'غَيْرٌ جِيرَانٌ':Added, #1: 1	غَيْرِ جِيرَانِهِ
u'غير جَيْشٌ':Added, #1: 1	غَيْرِ جِيرَانِهِ
u'غَيْرٌ جَيْشٌ':Added, #2: 2	غَيْرِ الْجَيْشِ
u'غير جِيفَةٌ':Added, #2: 2	غَيْرِ الْجَيْشِ
u'غَيْرٌ جِيفَةٌ':Added, #1: 1	غَيْرِ الْجِيفَةِ
u'غير حاجٌّ':Added, #1: 1	غَيْرِ الْجِيفَةِ
u'غَيْرٌ حاجٌّ':Added, #1: 1	غَيْرَ الْحَاجِّ
u'غير حاجٌّ':Added, #1: 1	غَيْرَ الْحَاجِّ
u'غَيْرٌ حاجٌّ':Added, #1: 1	غَيْرُ حَاجٍّ
u'غير حاجٌّ':Added, #1: 1	غَيْرُ حَاجٍّ
u'غَيْرٌ حاجٌّ':Added, #2: 2	غَيْرُ الْحَاجِّ
u'غير حاجٌّ':Added, #2: 2	غَيْرُ الْحَاجِّ
u'غَيْرٌ حاجٌّ':Added, #3: 3	غَيْرِ حَاجٍّ
u'غير حاجٌّ':Added, #3: 3	غَيْرِ حَاجٍّ
u'غَيْرٌ حاجٌّ':Added, #4: 4	غَيْرِ الْحَاجِّ
u'غير حاجٌّ':Added, #4: 4	غَيْرِ الْحَاجِّ
u'غَيْرٌ حاجٌّ':Added, #7: 7	غَيْرَ حَاجٍّ
u'غير حاجِبٌ':Added, #7: 7	غَيْرَ حَاجٍّ
u'غَيْرٌ حاجِبٌ':Added, #2: 2	غَيْرِ حَاجِبٍ
u'غير حاجَةٌ':Added, #2: 2	غَيْرِ حَاجِبٍ
u'غَيْرٌ حاجَةٌ':Added, #106: 106	غَيْرِ حَاجَةٍ
u'غير حاجَةٌ':Added, #106: 106	غَيْرِ حَاجَةٍ
u'غَيْرٌ حاجَةٌ':Added, #1: 1	غَيْرِ حَاجَةِ
u'غير حاجَةٌ':Added, #1: 1	غَيْرِ حَاجَةِ
u'غَيْرٌ حاجَةٌ':Added, #3: 3	غَيْرِ الْحَاجَةِ
u'غير حاجِزٌ':Added, #3: 3	غَيْرِ الْحَاجَةِ
u'غَيْرٌ حاجِزٌ':Added, #1: 1	غَيْرِ حَاجِزٍ
u'غير حادِثٌ':Added, #1: 1	غَيْرِ حَاجِزٍ
u'غَيْرٌ حادِثٌ':Added, #1: 1	غَيْرِ الْحَادِثِ
u'غير حادِثٌ':Added, #1: 1	غَيْرِ الْحَادِثِ
u'غَيْرٌ حادِثٌ':Added, #1: 1	غَيْرِ الْحَادِثَيْنِ
u'غير حادِثٌ':Added, #1: 1	غَيْرِ الْحَادِثَيْنِ
u'غير حادِثٌ':Added, #1: 1	غَيْرَ حَادِثٍ
u'غَيْرٌ حادِثٌ':Added, #1: 1	غَيْرُ حَادِثٍ
u'غَيْرٌ حادِثٌ':Added, #1: 1	غَيْرَ حَادِثٍ
u'غير حادِثٌ':Added, #1: 1	غَيْرُ حَادِثٍ
u'غَيْرٌ حادِثٌ':Added, #7: 7	غَيْرَ حَادِثَةٍ
u'غير حاذِقٌ':Added, #7: 7	غَيْرَ حَادِثَةٍ
u'غير حاذِقٌ':Added, #2: 2	غَيْرَ حَاذِقٍ
u'غَيْرٌ حاذِقٌ':Added, #2: 2	غَيْرُ حَاذِقٍ
u'غَيْرٌ حاذِقٌ':Added, #2: 2	غَيْرَ حَاذِقٍ
u'غير حارِسٌ':Added, #2: 2	غَيْرُ حَاذِقٍ
u'غَيْرٌ حارِسٌ':Added, #1: 1	غَيْرِ حَارِسٍ
u'غير حازِمٌ':Added, #1: 1	غَيْرِ حَارِسٍ
u'غَيْرٌ حازِمٌ':Added, #1: 1	غَيْرِ الْحَازِمِ
u'غير حاسِدٌ':Added, #1: 1	غَيْرِ الْحَازِمِ
u'غَيْرٌ حاسِدٌ':Added, #1: 1	غَيْرَ حَاسِدِ
u'غير حاسِر':Added, #1: 1	غَيْرَ حَاسِدِ
u'غَيْرٌ حاسِر':Added, #1: 1	غَيْرَ حَاسِرٍ
u'غير حاصِرَةٌ':Added, #1: 1	غَيْرَ حَاسِرٍ
u'غَيْرٌ حاصِرَةٌ':Added, #2: 2	غَيْرُ حَاصِرَةٍ
u'غير حاصِلٌ':Added, #2: 2	غَيْرُ حَاصِرَةٍ
u'غَيْرٌ حاصِلٌ':Added, #11: 11	غَيْرُ حَاصِلٍ
u'غير حاصِلٌ':Added, #11: 11	غَيْرُ حَاصِلٍ
u'غير حاصِلٌ':Added, #1: 1	غَيْرُ الْحَاصِلِ
u'غَيْرٌ حاصِلٌ':Added, #1: 1	غَيْرِ الْحَاصِلِ
u'غَيْرٌ حاصِلٌ':Added, #1: 1	غَيْرُ الْحَاصِلِ
u'غير حاصِلٌ':Added, #1: 1	غَيْرِ الْحَاصِلِ
u'غَيْرٌ حاصِلٌ':Added, #1: 1	غَيْرَ حَاصِلٍ
u'غير حاضِرٌ':Added, #1: 1	غَيْرَ حَاصِلٍ
u'غَيْرٌ حاضِرٌ':Added, #1: 1	غَيْرِ الْحَاضِرِ
u'غير حاضِرٌ':Added, #1: 1	غَيْرِ الْحَاضِرِ
u'غَيْرٌ حاضِرٌ':Added, #1: 1	غَيْرِ حَاضِرٍ
u'غير حاضِرٌ':Added, #1: 1	غَيْرِ حَاضِرٍ
u'غَيْرٌ حاضِرٌ':Added, #1: 1	غَيْرُ حَاضِرَةٍ
u'غير حاضِرٌ':Added, #1: 1	غَيْرُ حَاضِرَةٍ
u'غير حاضِرٌ':Added, #3: 3	غَيْرَ حَاضِرٍ
u'غَيْرٌ حاضِرٌ':Added, #3: 3	غَيْرُ حَاضِرٍ
u'غَيْرٌ حاضِرٌ':Added, #3: 3	غَيْرَ حَاضِرٍ
u'غير حاضِنٌ':Added, #3: 3	غَيْرُ حَاضِرٍ
u'غَيْرٌ حاضِنٌ':Added, #1: 1	غَيْرَ الْحَاضِنَةِ
u'غير حاضِنٌ':Added, #1: 1	غَيْرَ الْحَاضِنَةِ
u'غَيْرٌ حاضِنٌ':Added, #1: 1	غَيْرَ حَاضِنَةٍ
u'غير حافِظٌ':Added, #1: 1	غَيْرَ حَاضِنَةٍ
u'غَيْرٌ حافِظٌ':Added, #1: 1	غَيْرِ الْحَافِظِ
u'غير حافِظٌ':Added, #1: 1	غَيْرِ الْحَافِظِ
u'غَيْرٌ حافِظٌ':Added, #2: 2	غَيْرُ الْحَافِظِ
u'غير حافِظٌ':Added, #2: 2	غَيْرُ الْحَافِظِ
u'غَيْرٌ حافِظٌ':Added, #2: 2	غَيْرِ حَافِظٍ
u'غير حافِظٌ':Added, #2: 2	غَيْرِ حَافِظٍ
u'غَيْرٌ حافِظٌ':Added, #3: 3	غَيْرَ حَافِظٍ
u'غير حاكِمٌ':Added, #3: 3	غَيْرَ حَافِظٍ
u'غَيْرٌ حاكِمٌ':Added, #17: 17	غَيْرِ الْحَاكِمِ
u'غير حاكِمٌ':Added, #17: 17	غَيْرِ الْحَاكِمِ
u'غَيْرٌ حاكِمٌ':Added, #1: 1	غَيْرِ حَاكِمِ
u'غير حاكِمٌ':Added, #1: 1	غَيْرِ حَاكِمِ
u'غَيْرٌ حاكِمٌ':Added, #2: 2	غَيْرَ حَاكِمٍ
u'غير حاكِمٌ':Added, #2: 2	غَيْرَ حَاكِمٍ
u'غَيْرٌ حاكِمٌ':Added, #3: 3	غَيْرَ الْحَاكِمِ
u'غير حاكِمٌ':Added, #3: 3	غَيْرَ الْحَاكِمِ
u'غير حاكِمٌ':Added, #4: 4	غَيْرُ حَاكِمٍ
u'غَيْرٌ حاكِمٌ':Added, #4: 4	غَيْرِ حَاكِمٍ
u'غَيْرٌ حاكِمٌ':Added, #4: 4	غَيْرُ حَاكِمٍ
u'غير حاكِمٌ':Added, #4: 4	غَيْرِ حَاكِمٍ
u'غَيْرٌ حاكِمٌ':Added, #5: 5	غَيْرُ الْحَاكِمِ
u'غير حالٌ':Added, #5: 5	غَيْرُ الْحَاكِمِ
u'غَيْرٌ حالٌ':Added, #11: 11	غَيْرِ حَالِ
u'غير حالٌ':Added, #11: 11	غَيْرِ حَالِ
u'غَيْرٌ حالٌ':Added, #1: 1	غَيْرُ الْحَالِ
u'غير حالٌ':Added, #1: 1	غَيْرُ الْحَالِ
u'غَيْرٌ حالٌ':Added, #1: 1	غَيْرُ حَالِ
u'غير حالٌ':Added, #1: 1	غَيْرُ حَالِ
u'غَيْرٌ حالٌ':Added, #2: 2	غَيْرِ الْحَالِ
u'غير حالَةٌ':Added, #2: 2	غَيْرِ الْحَالِ
u'غَيْرٌ حالَةٌ':Added, #1: 1	غَيْرُ حَالَةِ
u'غير حالَةٌ':Added, #1: 1	غَيْرُ حَالَةِ
u'غَيْرٌ حالَةٌ':Added, #1: 1	غَيْرِ حَالَتِهِ
u'غير حالَةٌ':Added, #1: 1	غَيْرِ حَالَتِهِ
u'غَيْرٌ حالَةٌ':Added, #32: 32	غَيْرِ حَالَةِ
u'غير حامِلٌ':Added, #32: 32	غَيْرِ حَالَةِ
u'غَيْرٌ حامِلٌ':Added, #13: 13	غَيْرَ حَامِلٍ
u'غير حامِلٌ':Added, #13: 13	غَيْرَ حَامِلٍ
u'غير حامِلٌ':Added, #2: 2	غَيْرَ الْحَامِلِ
u'غَيْرٌ حامِلٌ':Added, #2: 2	غَيْرُ الْحَامِلِ
u'غَيْرٌ حامِلٌ':Added, #2: 2	غَيْرَ الْحَامِلِ
u'غير حامِلٌ':Added, #2: 2	غَيْرُ الْحَامِلِ
u'غَيْرٌ حامِلٌ':Added, #3: 3	غَيْرِ حَامِلٍ
u'غير حامِلٌ':Added, #3: 3	غَيْرِ حَامِلٍ
u'غَيْرٌ حامِلٌ':Added, #7: 7	غَيْرِ الْحَامِلِ
u'غير حامِلٌ':Added, #7: 7	غَيْرِ الْحَامِلِ
u'غَيْرٌ حامِلٌ':Added, #9: 9	غَيْرُ حَامِلٍ
u'غير حانوتٌ':Added, #9: 9	غَيْرُ حَامِلٍ
u'غَيْرٌ حانوتٌ':Added, #1: 1	غَيْرِ حَانُوتٍ
u'غير حائِزٌ':Added, #1: 1	غَيْرِ حَانُوتٍ
u'غَيْرٌ حائِزٌ':Added, #1: 1	غَيْرَ الْحَائِزِ
u'غير حائِزٌ':Added, #1: 1	غَيْرَ الْحَائِزِ
u'غَيْرٌ حائِزٌ':Added, #2: 2	غَيْرَ حَائِزٍ
u'غير حائِضٌ':Added, #2: 2	غَيْرَ حَائِزٍ
u'غَيْرٌ حائِضٌ':Added, #1: 1	غَيْرَ الْحَائِضِ
u'غير حائِضٌ':Added, #1: 1	غَيْرَ الْحَائِضِ
u'غَيْرٌ حائِضٌ':Added, #1: 1	غَيْرُ حَائِضٍ
u'غير حائِضٌ':Added, #1: 1	غَيْرُ حَائِضٍ
u'غَيْرٌ حائِضٌ':Added, #2: 2	غَيْرِ الْحَائِضِ
u'غير حائِضٌ':Added, #2: 2	غَيْرِ الْحَائِضِ
u'غير حائِضٌ':Added, #4: 4	غَيْرَ حَائِضٍ
u'غَيْرٌ حائِضٌ':Added, #4: 4	غَيْرِ حَائِضٍ
u'غَيْرٌ حائِضٌ':Added, #4: 4	غَيْرَ حَائِضٍ
u'غير حائِطٌ':Added, #4: 4	غَيْرِ حَائِضٍ
u'غير حائِطٌ':Added, #1: 1	غَيْرُ حَائِطِ
u'غَيْرٌ حائِطٌ':Added, #1: 1	غَيْرِ حَائِطِ
u'غَيْرٌ حائِطٌ':Added, #1: 1	غَيْرُ حَائِطِ
u'غير حائِطٌ':Added, #1: 1	غَيْرِ حَائِطِ
u'غَيْرٌ حائِطٌ':Added, #2: 2	غَيْرُ الْحَائِطِ
u'غير حائِلٌ':Added, #2: 2	غَيْرُ الْحَائِطِ
u'غَيْرٌ حائِلٌ':Added, #19: 19	غَيْرِ حَائِلٍ
u'غير حائِلٌ':Added, #19: 19	غَيْرِ حَائِلٍ
u'غير حائِلٌ':Added, #1: 1	غَيْرَ حَائِلِ
u'غَيْرٌ حائِلٌ':Added, #1: 1	غَيْرِ حَائِلِ
u'غَيْرٌ حائِلٌ':Added, #1: 1	غَيْرَ حَائِلِ
u'غير حَبٌّ':Added, #1: 1	غَيْرِ حَائِلِ
u'غَيْرٌ حَبٌّ':Added, #1: 1	غَيْرَ الْحَبِّ
u'غير حَبْسٌ':Added, #1: 1	غَيْرَ الْحَبِّ
u'غَيْرٌ حَبْسٌ':Added, #2: 2	غَيْرَ الْحَبْسِ
u'غير حَبْسٌ':Added, #2: 2	غَيْرَ الْحَبْسِ
u'غَيْرٌ حَبْسٌ':Added, #2: 2	غَيْرِ حَبْسٍ
u'غير حُبوبٌ':Added, #2: 2	غَيْرِ حَبْسٍ
u'غَيْرٌ حُبوبٌ':Added, #3: 3	غَيْرِ الْحُبُوبِ
u'غير حَجٌّ':Added, #3: 3	غَيْرِ الْحُبُوبِ
u'غَيْرٌ حَجٌّ':Added, #2: 2	غَيْرَ الْحَجِّ
u'غير حَجٌّ':Added, #2: 2	غَيْرَ الْحَجِّ
u'غَيْرٌ حَجٌّ':Added, #2: 2	غَيْرِ حَجٍّ
u'غير حَجٌّ':Added, #2: 2	غَيْرِ حَجٍّ
u'غَيْرٌ حَجٌّ':Added, #3: 3	غَيْرُ الْحَجِّ
u'غير حَجٌّ':Added, #3: 3	غَيْرُ الْحَجِّ
u'غَيْرٌ حَجٌّ':Added, #9: 9	غَيْرِ الْحَجِّ
u'غير حجاز':Added, #9: 9	غَيْرِ الْحَجِّ
u'غَيْرٌ حجاز':Added, #1: 1	غَيْرُ الْحِجَازِ
u'غير حُجَّةٌ':Added, #1: 1	غَيْرُ الْحِجَازِ
u'غَيْرٌ حُجَّةٌ':Added, #17: 17	غَيْرِ حُجَّةٍ
u'غير حُجَّةٌ':Added, #17: 17	غَيْرِ حُجَّةٍ
u'غَيْرٌ حُجَّةٌ':Added, #1: 1	غَيْرِ الْحُجَّةِ
u'غير حِجَّةٌ':Added, #1: 1	غَيْرِ الْحُجَّةِ
u'غَيْرٌ حِجَّةٌ':Added, #1: 1	غَيْرِ حِجَّةِ
u'غير حِجَّةٌ':Added, #1: 1	غَيْرِ حِجَّةِ
u'غَيْرٌ حِجَّةٌ':Added, #2: 2	غَيْرَ حِجَّةِ
u'غير حُجَّةٌ':Added, #2: 2	غَيْرَ حِجَّةِ
u'غَيْرٌ حُجَّةٌ':Added, #3: 3	غَيْرَ حُجَّةٍ
u'غير حُجَّةٌ':Added, #3: 3	غَيْرَ حُجَّةٍ
u'غَيْرٌ حُجَّةٌ':Added, #7: 7	غَيْرُ حُجَّةٍ
u'غير حَجَرٌ':Added, #7: 7	غَيْرُ حُجَّةٍ
u'غَيْرٌ حَجَرٌ':Added, #2: 2	غَيْرُ الْحَجَرِ
u'غير حَجَرٌ':Added, #2: 2	غَيْرُ الْحَجَرِ
u'غَيْرٌ حَجَرٌ':Added, #2: 2	غَيْرَ حَجَرٍ
u'غير حَجْرٌ':Added, #2: 2	غَيْرَ حَجَرٍ
u'غَيْرٌ حَجْرٌ':Added, #3: 3	غَيْرِ حَجْرٍ
u'غير حَجَرٌ':Added, #3: 3	غَيْرِ حَجْرٍ
u'غَيْرٌ حَجَرٌ':Added, #4: 4	غَيْرَ الْحَجَرِ
u'غير حَجَرٌ':Added, #4: 4	غَيْرَ الْحَجَرِ
u'غَيْرٌ حَجَرٌ':Added, #5: 5	غَيْرِ الْحَجَرِ
u'غير حَدٌّ':Added, #5: 5	غَيْرِ الْحَجَرِ
u'غَيْرٌ حَدٌّ':Added, #1: 1	غَيْرِ حَدِّ
u'غير حَدٌّ':Added, #1: 1	غَيْرِ حَدِّ
u'غَيْرٌ حَدٌّ':Added, #27: 27	غَيْرِ حَدٍّ
u'غير حَدٌّ':Added, #27: 27	غَيْرِ حَدٍّ
u'غَيْرٌ حَدٌّ':Added, #2: 2	غَيْرِ الْحَدِّ
u'غير حَدَّادٌ':Added, #2: 2	غَيْرِ الْحَدِّ
u'غَيْرٌ حَدَّادٌ':Added, #3: 3	غَيْرُ الْحَدَّادِ
u'غير حَدَثٌ':Added, #3: 3	غَيْرُ الْحَدَّادِ
u'غَيْرٌ حَدَثٌ':Added, #1: 1	غَيْرِ حَدَثِ
u'غير حَدَثٌ':Added, #1: 1	غَيْرِ حَدَثِ
u'غير حَدَثٌ':Added, #2: 2	غَيْرُ الْحَدَثِ
u'غَيْرٌ حَدَثٌ':Added, #2: 2	غَيْرِ الْحَدَثِ
u'غَيْرٌ حَدَثٌ':Added, #2: 2	غَيْرُ الْحَدَثِ
u'غير حَدَثٌ':Added, #2: 2	غَيْرِ الْحَدَثِ
u'غَيْرٌ حَدَثٌ':Added, #3: 3	غَيْرِ حَدَثٍ
u'غير حَدَثٌ':Added, #3: 3	غَيْرِ حَدَثٍ
u'غير حَدَثٌ':Added, #3: 3	غَيْرَ حَدَثِهِ
u'غَيْرٌ حَدَثٌ':Added, #3: 3	غَيْرِ حَدَثِهِ
u'غَيْرٌ حَدَثٌ':Added, #3: 3	غَيْرَ حَدَثِهِ
u'غير حُدوثٌ':Added, #3: 3	غَيْرِ حَدَثِهِ
u'غَيْرٌ حُدوثٌ':Added, #3: 3	غَيْرِ حُدُوثِ
u'غَيَّرَ حُدودٌ':Predicate, #3: 3	غَيْرِ حُدُوثِ
u'غير حُدودٌ':Added, #2: 2	غَيَّرَ حُدُودَ
u'غَيْرٌ حُدودٌ':Added, #1: 1	غَيْرَ حُدُودٍ
u'غير حُدودٌ':Added, #1: 1	غَيْرَ حُدُودٍ
u'غَيْرٌ حُدودٌ':Added, #2: 2	غَيْرُ الْحُدُودِ
u'غير حُدودٌ':Added, #2: 2	غَيْرُ الْحُدُودِ
u'غَيْرٌ حُدودٌ':Added, #4: 4	غَيْرِ حُدُودِ
u'غير حُدودٌ':Added, #4: 4	غَيْرِ حُدُودِ
u'غَيْرٌ حُدودٌ':Added, #7: 7	غَيْرِ الْحُدُودِ
u'غير حَديثٌ':Added, #7: 7	غَيْرِ الْحُدُودِ
u'غَيْرٌ حَديثٌ':Added, #11: 11	غَيْرِ حَدِيثِ
u'غير حَديثٌ':Added, #11: 11	غَيْرِ حَدِيثِ
u'غَيْرٌ حَديثٌ':Added, #1: 1	غَيْرِ الْحَدِيثِ
u'غير حَديثٌ':Added, #1: 1	غَيْرِ الْحَدِيثِ
u'غير حَديثٌ':Added, #1: 1	غَيْرُ حَدِيثٍ
u'غَيْرٌ حَديثٌ':Added, #1: 1	غَيْرُ حَدِيثِ
u'غَيْرٌ حَديثٌ':Added, #1: 1	غَيْرُ حَدِيثٍ
u'غير حَديثٌ':Added, #1: 1	غَيْرُ حَدِيثِ
u'غَيْرٌ حَديثٌ':Added, #2: 2	غَيْرَ حَدِيثِ
u'غير حَديثٌ':Added, #2: 2	غَيْرَ حَدِيثِ
u'غَيْرٌ حَديثٌ':Added, #2: 2	غَيْرِ حَدِيثِهِ
u'غير حَديثٌ':Added, #2: 2	غَيْرِ حَدِيثِهِ
u'غَيْرٌ حَديثٌ':Added, #4: 4	غَيْرِ حَدِيثٍ
u'غير حَديثٌ':Added, #4: 4	غَيْرِ حَدِيثٍ
u'غَيْرٌ حَديثٌ':Added, #5: 5	غَيْرَ حَدِيثٍ
u'غير حَديدٌ':Added, #5: 5	غَيْرَ حَدِيثٍ
u'غَيْرٌ حَديدٌ':Added, #1: 1	غَيْرُ الْحَدِيدِ
u'غير حَديدٌ':Added, #1: 1	غَيْرُ الْحَدِيدِ
u'غَيْرٌ حَديدٌ':Added, #3: 3	غَيْرَ حَدِيدٍ
u'غير حَذْف':Added, #3: 3	غَيْرَ حَدِيدٍ
u'غَيْرٌ حَذْف':Added, #1: 1	غَيْرِ الْحَذْفِ
u'غير حُرٌّ':Added, #1: 1	غَيْرِ الْحَذْفِ
u'غَيْرٌ حُرٌّ':Added, #1: 1	غَيْرُ الْحُرَّيْنِ
u'غير حُرٌّ':Added, #1: 1	غَيْرُ الْحُرَّيْنِ
u'غَيْرٌ حُرٌّ':Added, #1: 1	غَيْرُ حُرِّ
u'غير حُرٌّ':Added, #1: 1	غَيْرُ حُرِّ
u'غير حُرٌّ':Added, #1: 1	غَيْرَ حُرَّةٍ
u'غَيْرٌ حُرٌّ':Added, #1: 1	غَيْرُ حُرَّةٍ
u'غَيْرٌ حُرٌّ':Added, #1: 1	غَيْرَ حُرَّةٍ
u'غير حُرٌّ':Added, #1: 1	غَيْرُ حُرَّةٍ
u'غير حُرٌّ':Added, #2: 2	غَيْرَ الْحُرِّ
u'غَيْرٌ حُرٌّ':Added, #2: 2	غَيْرُ الْحُرِّ
u'غَيْرٌ حُرٌّ':Added, #2: 2	غَيْرَ الْحُرِّ
u'غير حُرٌّ':Added, #2: 2	غَيْرُ الْحُرِّ
u'غَيْرٌ حُرٌّ':Added, #2: 2	غَيْرُ حُرٍّ
u'غير حُرٌّ':Added, #2: 2	غَيْرُ حُرٍّ
u'غَيْرٌ حُرٌّ':Added, #3: 3	غَيْرَ حُرٍّ
u'غير حُرٌّ':Added, #3: 3	غَيْرَ حُرٍّ
u'غَيْرٌ حُرٌّ':Added, #6: 6	غَيْرِ الْحُرِّ
u'غير حَرارَةٌ':Added, #6: 6	غَيْرِ الْحُرِّ
u'غَيْرٌ حَرارَةٌ':Added, #1: 1	غَيْرِ حَرَارَةٍ
u'غير حَرامٌ':Added, #1: 1	غَيْرِ حَرَارَةٍ
u'غَيْرٌ حَرامٌ':Added, #2: 2	غَيْرِ الْحَرَامِ
u'غير حَرامٌ':Added, #2: 2	غَيْرِ الْحَرَامِ
u'غَيْرٌ حَرامٌ':Added, #4: 4	غَيْرَ حَرَامٍ
u'غير حَرامٌ':Added, #4: 4	غَيْرَ حَرَامٍ
u'غَيْرٌ حَرامٌ':Added, #6: 6	غَيْرُ حَرَامٍ
u'غير حَرْبٌ':Added, #6: 6	غَيْرُ حَرَامٍ
u'غَيْرٌ حَرْبٌ':Added, #14: 14	غَيْرِ حَرْبٍ
u'غير حَرْبٌ':Added, #14: 14	غَيْرِ حَرْبٍ
u'غَيْرٌ حَرْبٌ':Added, #1: 1	غَيْر حَرْبٍ
u'غير حَرْب':Added, #1: 1	غَيْر حَرْبٍ
u'غَيْرٌ حَرْب':Added, #1: 1	غَيْرَ حَرْبِيَّةٍ
u'غير حَرْبٌ':Added, #1: 1	غَيْرَ حَرْبِيَّةٍ
u'غَيْرٌ حَرْبٌ':Added, #9: 9	غَيْرِ الْحَرْبِ
u'غير حَرْبَة':Added, #9: 9	غَيْرِ الْحَرْبِ
u'غَيْرٌ حَرْبَة':Added, #1: 1	غَيْرَ حَرْبِيَّةٍ
u'غير حَرْبِيّ':Added, #1: 1	غَيْرَ حَرْبِيَّةٍ
u'غَيْرٌ حَرْبِيّ':Added, #1: 1	غَيْرَ حَرْبِيَّةٍ
u'غير حَرْثٌ':Added, #1: 1	غَيْرَ حَرْبِيَّةٍ
u'غَيْرٌ حَرْثٌ':Added, #2: 2	غَيْرِ الْحَرْثِ
u'غير حَرَجٌ':Added, #2: 2	غَيْرِ الْحَرْثِ
u'غَيْرٌ حَرَجٌ':Added, #13: 13	غَيْرِ حَرَجٍ
u'غير حِرْزٌ':Added, #13: 13	غَيْرِ حَرَجٍ
u'غَيْرٌ حِرْزٌ':Added, #1: 1	غَيْرِ حِرْزِهِ
u'غير حِرْزٌ':Added, #1: 1	غَيْرِ حِرْزِهِ
u'غَيْرٌ حِرْزٌ':Added, #26: 26	غَيْرِ حِرْزٍ
u'غير حِرْزٌ':Added, #26: 26	غَيْرِ حِرْزٍ
u'غَيْرٌ حِرْزٌ':Added, #2: 2	غَيْرِ حِرْزِ
u'غير حِرْزٌ':Added, #2: 2	غَيْرِ حِرْزِ
u'غَيْرٌ حِرْزٌ':Added, #4: 4	غَيْرُ حِرْزٍ
u'غير حِرْزٌ':Added, #4: 4	غَيْرُ حِرْزٍ
u'غَيْرٌ حِرْزٌ':Added, #6: 6	غَيْرِ الْحِرْزِ
u'غير حِرْصٌ':Added, #6: 6	غَيْرِ الْحِرْزِ
u'غَيْرٌ حِرْصٌ':Added, #1: 1	غَيْرِ حِرْصٍ
u'غير حَرْفٌ':Added, #1: 1	غَيْرِ حِرْصٍ
u'غَيْرٌ حَرْفٌ':Added, #3: 3	غَيْرِ حَرْفِ
u'غير حَرَمٌ':Added, #3: 3	غَيْرِ حَرْفِ
u'غَيْرٌ حَرَمٌ':Added, #1: 1	غَيْرُ الْحَرَمِ
u'غير حَرَمٌ':Added, #1: 1	غَيْرُ الْحَرَمِ
u'غَيْرٌ حَرَمٌ':Added, #2: 2	غَيْرَ الْحَرَمِ
u'غير حَرَمٌ':Added, #2: 2	غَيْرَ الْحَرَمِ
u'غَيْرٌ حَرَمٌ':Added, #2: 2	غَيْرَ حَرَمٍ
u'غير حَرَمٌ':Added, #2: 2	غَيْرَ حَرَمٍ
u'غَيْرٌ حَرَمٌ':Added, #32: 32	غَيْرِ الْحَرَمِ
u'غير حَرَمٌ':Added, #32: 32	غَيْرِ الْحَرَمِ
u'غَيْرٌ حَرَمٌ':Added, #3: 3	غَيْرِ حَرَمِ
u'غير حِرْمَانٌ':Added, #3: 3	غَيْرِ حَرَمِ
u'غَيْرٌ حِرْمَانٌ':Added, #1: 1	غَيْرُ حِرْمَانِ
u'غير حُرْمَةٌ':Added, #1: 1	غَيْرُ حِرْمَانِ
u'غَيْرٌ حُرْمَةٌ':Added, #2: 2	غَيْرُ الْحُرْمَةِ
u'غير حَرِيرٌ':Added, #2: 2	غَيْرُ الْحُرْمَةِ
u'غَيْرٌ حَرِيرٌ':Added, #11: 11	غَيْرَ حَرِيرٍ
u'غير حَرِيرٌ':Added, #11: 11	غَيْرَ حَرِيرٍ
u'غَيْرٌ حَرِيرٌ':Added, #1: 1	غَيْرُ الْحَرِيرِ
u'غير حَرِيرٌ':Added, #1: 1	غَيْرُ الْحَرِيرِ
u'غَيْرٌ حَرِيرٌ':Added, #1: 1	غَيْرِ حَرِيرٍ
u'غير حَرِيرٌ':Added, #1: 1	غَيْرِ حَرِيرٍ
u'غير حَرِيرٌ':Added, #2: 2	غَيْرَ الْحَرِيرِ
u'غَيْرٌ حَرِيرٌ':Added, #2: 2	غَيْرِ الْحَرِيرِ
u'غَيْرٌ حَرِيرٌ':Added, #2: 2	غَيْرَ الْحَرِيرِ
u'غير حَرِيرٌ':Added, #2: 2	غَيْرِ الْحَرِيرِ
u'غَيْرٌ حَرِيرٌ':Added, #2: 2	غَيْرُ حَرِيرٍ
u'غير حَرِيمٌ':Added, #2: 2	غَيْرُ حَرِيرٍ
u'غَيْرٌ حَرِيمٌ':Added, #1: 1	غَيْرَ الْحَرِيمِ
u'غير حَرِيمٌ':Added, #1: 1	غَيْرَ الْحَرِيمِ
u'غَيْرٌ حَرِيمٌ':Added, #2: 2	غَيْرِ حَرِيمِ
u'غير حساب':Added, #2: 2	غَيْرِ حَرِيمِ
u'غَيْرٌ حساب':Added, #2: 2	غَيْرِ حِسَابٍ
u'غير حِسَابٌ':Added, #2: 2	غَيْرِ حِسَابٍ
u'غَيْرٌ حِسَابٌ':Added, #2: 2	غَيْرِ حِسَابٍ
u'غير حِسْبَةٌ':Added, #2: 2	غَيْرِ حِسَابٍ
u'غَيْرٌ حِسْبَةٌ':Added, #1: 1	غَيْرِ حِسْبَةٍ
u'غير حَسَنٌ':Added, #1: 1	غَيْرِ حِسْبَةٍ
u'غَيْرٌ حَسَنٌ':Added, #1: 1	غَيْرُ الْحَسَنَاتِ
u'غير حَسَنٌ':Added, #1: 1	غَيْرُ الْحَسَنَاتِ
u'غَيْرٌ حَسَنٌ':Added, #1: 1	غَيْرُ الْحَسَنَةِ
u'غير حَسَنٌ':Added, #1: 1	غَيْرُ الْحَسَنَةِ
u'غير حَسَنٌ':Added, #2: 2	غَيْرَ الْحَسَنِ
u'غَيْرٌ حَسَنٌ':Added, #2: 2	غَيْرِ الْحَسَنِ
u'غَيْرٌ حَسَنٌ':Added, #2: 2	غَيْرَ الْحَسَنِ
u'غير حَسَنٌ':Added, #2: 2	غَيْرِ الْحَسَنِ
u'غَيْرٌ حَسَنٌ':Added, #4: 4	غَيْرُ حَسَنٍ
u'غير حَسَنَةٌ':Added, #4: 4	غَيْرُ حَسَنٍ
u'غَيْرٌ حَسَنَةٌ':Added, #1: 1	غَيْرُ الْحَسَنَاتِ
u'غير حَسَنَةٌ':Added, #1: 1	غَيْرُ الْحَسَنَاتِ
u'غَيْرٌ حَسَنَةٌ':Added, #1: 1	غَيْرُ الْحَسَنَةِ
u'غير حَسُودٌ':Added, #1: 1	غَيْرُ الْحَسَنَةِ
u'غَيْرٌ حَسُودٌ':Added, #1: 1	غَيْرَ الْحَسُودِ
u'غير حَشَفَةٌ':Added, #1: 1	غَيْرَ الْحَسُودِ
u'غَيْرٌ حَشَفَةٌ':Added, #1: 1	غَيْرِ الْحَشَفَةِ
u'غير حِشْمَةٌ':Added, #1: 1	غَيْرِ الْحَشَفَةِ
u'غَيْرٌ حِشْمَةٌ':Added, #4: 4	غَيْرِ حِشْمَةٍ
u'غير حَصْرٌ':Added, #4: 4	غَيْرِ حِشْمَةٍ
u'غَيْرٌ حَصْرٌ':Added, #2: 2	غَيْرِ حَصْرٍ
u'غير حُصُول':Added, #2: 2	غَيْرِ حَصْرٍ
u'غَيْرٌ حُصُول':Added, #1: 1	غَيْرِ حُصُولٍ
u'غير حُصُول':Added, #1: 1	غَيْرِ حُصُولٍ
u'غَيْرٌ حُصُول':Added, #3: 3	غَيْرِ حُصُولِ
u'غير حَضَرٌ':Added, #3: 3	غَيْرِ حُصُولِ
u'غَيْرٌ حَضَرٌ':Added, #1: 1	غَيْرِ الْحَضَرِ
u'غير حضرة':Added, #1: 1	غَيْرِ الْحَضَرِ
u'غَيْرٌ حضرة':Added, #3: 3	غَيْرِ حَضْرَةِ
u'غير حَضْرَةٌ':Added, #3: 3	غَيْرِ حَضْرَةِ
u'غَيْرٌ حَضْرَةٌ':Added, #3: 3	غَيْرِ حَضْرَةِ
u'غير حُضورٌ':Added, #3: 3	غَيْرِ حَضْرَةِ
u'غير حُضُورٌ':Added, #13: 13	غَيْرِ حُضُورِ
u'غَيْرٌ حُضورٌ':Added, #13: 13	غَيْرِ حُضُورِ
u'غَيْرٌ حُضُورٌ':Added, #13: 13	غَيْرِ حُضُورِ
u'غير حُضورٌ':Added, #13: 13	غَيْرِ حُضُورِ
u'غير حُضُورٌ':Added, #1: 1	غَيْرِ حُضُورٍ
u'غَيْرٌ حُضورٌ':Added, #1: 1	غَيْرِ حُضُورٍ
u'غَيْرٌ حُضُورٌ':Added, #1: 1	غَيْرِ حُضُورٍ
u'غير حُضورٌ':Added, #1: 1	غَيْرِ حُضُورٍ
u'غير حُضُورٌ':Added, #1: 1	غَيْرِ حُضُورِهِ
u'غَيْرٌ حُضورٌ':Added, #1: 1	غَيْرِ حُضُورِهِ
u'غَيْرٌ حُضُورٌ':Added, #1: 1	غَيْرِ حُضُورِهِ
u'غير حَطِيطَةٌ':Added, #1: 1	غَيْرِ حُضُورِهِ
u'غَيْرٌ حَطِيطَةٌ':Added, #1: 1	غَيْرِ حَطِيطَةٍ
u'غير حَظِيرَةٌ':Added, #1: 1	غَيْرِ حَطِيطَةٍ
u'غَيْرٌ حَظِيرَةٌ':Added, #1: 1	غَيْرِ حَظِيرَةٍ
u'غير حِفْظٌ':Added, #1: 1	غَيْرِ حَظِيرَةٍ
u'غَيْرٌ حِفْظٌ':Added, #1: 1	غَيْرِ الْحِفْظِ
u'غير حِفْظٌ':Added, #1: 1	غَيْرِ الْحِفْظِ
u'غير حِفْظٌ':Added, #1: 1	غَيْرِ حِفْظٍ
u'غَيْرٌ حِفْظٌ':Added, #1: 1	غَيْرِ حِفْظِ
u'غَيْرٌ حِفْظٌ':Added, #1: 1	غَيْرِ حِفْظٍ
u'غير حَفَظَةٌ':Added, #1: 1	غَيْرِ حِفْظِ
u'غَيْرٌ حَفَظَةٌ':Added, #1: 1	غَيْرُ الْحَفَظَةِ
u'غير حَقٌّ':Added, #1: 1	غَيْرُ الْحَفَظَةِ
u'غَيْرٌ حَقٌّ':Added, #12: 12	غَيْرِ حَقِّهِ
u'غير حَقٌّ':Added, #12: 12	غَيْرِ حَقِّهِ
u'غَيْرٌ حَقٌّ':Added, #16: 16	غَيْرِ حَقٍّ
u'غير حَقٌّ':Added, #16: 16	غَيْرِ حَقٍّ
u'غَيْرٌ حَقٌّ':Added, #1: 1	غَيْرُ حَقِّ
u'غير حَقٌّ':Added, #1: 1	غَيْرُ حَقِّ
u'غَيْرٌ حَقٌّ':Added, #2: 2	غَيْرُ الْحَقِّ
u'غير حَقٌّ':Added, #2: 2	غَيْرُ الْحَقِّ
u'غَيْرٌ حَقٌّ':Added, #2: 2	غَيْرَ حَقٍّ
u'غير حَقٌّ':Added, #2: 2	غَيْرَ حَقٍّ
u'غير حَقٌّ':Added, #4: 4	غَيْرُ حَقٍّ
u'غَيْرٌ حَقٌّ':Added, #4: 4	غَيْرِ حَقِّ
u'غَيْرٌ حَقٌّ':Added, #4: 4	غَيْرُ حَقٍّ
u'غير حَقٌّ':Added, #4: 4	غَيْرِ حَقِّ
u'غَيْرٌ حَقٌّ':Added, #5: 5	غَيْرِ الْحَقِّ
u'غير حَقٌّ':Added, #5: 5	غَيْرِ الْحَقِّ
u'غَيْرٌ حَقٌّ':Added, #7: 7	غَيْرَ الْحَقِّ
u'غير حَقٌّ':Added, #7: 7	غَيْرَ الْحَقِّ
u'غَيْرٌ حَقٌّ':Added, #7: 7	غَيْرَ حَقِّهِ
u'غير حِقَاقٌ':Added, #7: 7	غَيْرَ حَقِّهِ
u'غَيْرٌ حِقَاقٌ':Added, #1: 1	غَيْرُ الْحِقَاقِ
u'غير حقائق':Added, #1: 1	غَيْرُ الْحِقَاقِ
u'غَيْرٌ حقائق':Added, #1: 1	غَيْرِ حَقَائِقِ
u'غير حَقَائِقُ':Added, #1: 1	غَيْرِ حَقَائِقِ
u'غَيْرٌ حَقَائِقُ':Added, #1: 1	غَيْرِ حَقَائِقِ
u'غير حَقُودٌ':Added, #1: 1	غَيْرِ حَقَائِقِ
u'غَيْرٌ حَقُودٌ':Added, #1: 1	غَيْرَ الْحَقُودِ
u'غير حُقوقٌ':Added, #1: 1	غَيْرَ الْحَقُودِ
u'غير حُقُوقٌ':Added, #2: 2	غَيْرِ حُقُوقِ
u'غَيْرٌ حُقوقٌ':Added, #2: 2	غَيْرِ حُقُوقِ
u'غَيْرٌ حُقُوقٌ':Added, #2: 2	غَيْرِ حُقُوقِ
u'غير حَقِيقٌ':Added, #2: 2	غَيْرِ حُقُوقِ
u'غير حَقِيقٌ':Added, #1: 1	غَيْرَ الْحَقِيقَةِ
u'غير حَقِيقٌ':Added, #1: 1	غَيْرُ الْحَقِيقَةِ
u'غَيْرٌ حَقِيقٌ':Added, #1: 1	غَيْرِ الْحَقِيقَةِ
u'غَيْرٌ حَقِيقٌ':Added, #1: 1	غَيْرَ الْحَقِيقَةِ
u'غَيْرٌ حَقِيقٌ':Added, #1: 1	غَيْرُ الْحَقِيقَةِ
u'غير حَقِيقٌ':Added, #1: 1	غَيْرِ الْحَقِيقَةِ
u'غير حَقِيقٌ':Added, #1: 1	غَيْرَ حَقِيقَةِ
u'غَيْرٌ حَقِيقٌ':Added, #1: 1	غَيْرِ حَقِيقَةِ
u'غَيْرٌ حَقِيقٌ':Added, #1: 1	غَيْرَ حَقِيقَةِ
u'غير حَقِيقٌ':Added, #1: 1	غَيْرِ حَقِيقَةِ
u'غير حَقِيقٌ':Added, #1: 1	غَيْرُ حَقِيقَتِهِ
u'غَيْرٌ حَقِيقٌ':Added, #1: 1	غَيْرِ حَقِيقَتِهِ
u'غَيْرٌ حَقِيقٌ':Added, #1: 1	غَيْرُ حَقِيقَتِهِ
u'غير حَقِيقٌ':Added, #1: 1	غَيْرِ حَقِيقَتِهِ
u'غَيْرٌ حَقِيقٌ':Added, #2: 2	غَيْرُ حَقِيقَةِ
u'غير حَقِيقَةٌ':Added, #2: 2	غَيْرُ حَقِيقَةِ
u'غير حَقِيقَةٌ':Added, #1: 1	غَيْرَ الْحَقِيقَةِ
u'غير حَقِيقَةٌ':Added, #1: 1	غَيْرُ الْحَقِيقَةِ
u'غَيْرٌ حَقِيقَةٌ':Added, #1: 1	غَيْرِ الْحَقِيقَةِ
u'غَيْرٌ حَقِيقَةٌ':Added, #1: 1	غَيْرَ الْحَقِيقَةِ
u'غَيْرٌ حَقِيقَةٌ':Added, #1: 1	غَيْرُ الْحَقِيقَةِ
u'غير حَقِيقَةٌ':Added, #1: 1	غَيْرِ الْحَقِيقَةِ
u'غير حَقِيقَةٌ':Added, #1: 1	غَيْرَ حَقِيقَةِ
u'غَيْرٌ حَقِيقَةٌ':Added, #1: 1	غَيْرِ حَقِيقَةِ
u'غَيْرٌ حَقِيقَةٌ':Added, #1: 1	غَيْرَ حَقِيقَةِ
u'غير حَقِيقَةٌ':Added, #1: 1	غَيْرِ حَقِيقَةِ
u'غير حَقِيقَةٌ':Added, #1: 1	غَيْرُ حَقِيقَتِهِ
u'غَيْرٌ حَقِيقَةٌ':Added, #1: 1	غَيْرِ حَقِيقَتِهِ
u'غَيْرٌ حَقِيقَةٌ':Added, #1: 1	غَيْرُ حَقِيقَتِهِ
u'غير حَقِيقَةٌ':Added, #1: 1	غَيْرِ حَقِيقَتِهِ
u'غَيْرٌ حَقِيقَةٌ':Added, #2: 2	غَيْرُ حَقِيقَةِ
u'غير حَقِيقَةٌ':Added, #2: 2	غَيْرُ حَقِيقَةِ
u'غَيْرٌ حَقِيقَةٌ':Added, #3: 3	غَيْرِ حَقِيقَةٍ
u'غير حَقِيقِيٌّ':Added, #3: 3	غَيْرِ حَقِيقَةٍ
u'غير حَقِيقِيٌّ':Added, #1: 1	غَيْرَ الْحَقِيقِيِّ
u'غير حَقِيقِيٌّ':Added, #1: 1	غَيْرُ الْحَقِيقِيِّ
u'غَيْرٌ حَقِيقِيٌّ':Added, #1: 1	غَيْرِ الْحَقِيقِيِّ
u'غَيْرٌ حَقِيقِيٌّ':Added, #1: 1	غَيْرَ الْحَقِيقِيِّ
u'غَيْرٌ حَقِيقِيٌّ':Added, #1: 1	غَيْرُ الْحَقِيقِيِّ
u'غير حَقِيقِيٌّ':Added, #1: 1	غَيْرِ الْحَقِيقِيِّ
u'غير حَقِيقِيٌّ':Added, #1: 1	غَيْرَ حَقِيقِيٍّ
u'غَيْرٌ حَقِيقِيٌّ':Added, #1: 1	غَيْرُ حَقِيقِيٍّ
u'غَيْرٌ حَقِيقِيٌّ':Added, #1: 1	غَيْرَ حَقِيقِيٍّ
u'غير حَقِيقِيٌّ':Added, #1: 1	غَيْرُ حَقِيقِيٍّ
u'غَيْرٌ حَقِيقِيٌّ':Added, #1: 1	غَيْرُ حَقِيقِيَّةٍ
u'غير حُكَّامٌ':Added, #1: 1	غَيْرُ حَقِيقِيَّةٍ
u'غَيْرٌ حُكَّامٌ':Added, #1: 1	غَيْرِ الْحُكَّامِ
u'غير حِكَايَةٌ':Added, #1: 1	غَيْرِ الْحُكَّامِ
u'غَيْرٌ حِكَايَةٌ':Added, #11: 11	غَيْرِ حِكَايَةِ
u'غير حُكْمٌ':Added, #11: 11	غَيْرِ حِكَايَةِ
u'غَيْرٌ حُكْمٌ':Added, #10: 10	غَيْرِ حُكْمِ
u'غير حُكْمٌ':Added, #10: 10	غَيْرِ حُكْمِ
u'غَيْرٌ حُكْمٌ':Added, #12: 12	غَيْرِ حُكْمٍ
u'غير حُكْمٌ':Added, #12: 12	غَيْرِ حُكْمٍ
u'غَيْرٌ حُكْمٌ':Added, #1: 1	غَيْر الْحُكْمِ
u'غير حُكْم':Added, #1: 1	غَيْر الْحُكْمِ
u'غَيْرٌ حُكْم':Added, #1: 1	غَيْرِ الْحُكْمِيَّةِ
u'غير حُكْمٌ':Added, #1: 1	غَيْرِ الْحُكْمِيَّةِ
u'غَيْرٌ حُكْمٌ':Added, #1: 1	غَيْرَ حُكْمِ
u'غير حُكْمٌ':Added, #1: 1	غَيْرَ حُكْمِ
u'غَيْرٌ حُكْمٌ':Added, #1: 1	غَيْرُ حُكْمِهِ
u'غير حُكْمٌ':Added, #1: 1	غَيْرُ حُكْمِهِ
u'غَيْرٌ حُكْمٌ':Added, #2: 2	غَيْرُ حُكْمٍ
u'غير حُكْمٌ':Added, #2: 2	غَيْرُ حُكْمٍ
u'غَيْرٌ حُكْمٌ':Added, #3: 3	غَيْرُ الْحُكْمِ
u'غير حُكْمٌ':Added, #3: 3	غَيْرُ الْحُكْمِ
u'غَيْرٌ حُكْمٌ':Added, #5: 5	غَيْرِ الْحُكْمِ
u'غير حُكْمٌ':Added, #5: 5	غَيْرِ الْحُكْمِ
u'غَيْرٌ حُكْمٌ':Added, #9: 9	غَيْرُ حُكْمِ
u'غير حُكْمِيّ':Added, #9: 9	غَيْرُ حُكْمِ
u'غَيْرٌ حُكْمِيّ':Added, #1: 1	غَيْرِ الْحُكْمِيَّةِ
u'غير حُكُومَةٌ':Added, #1: 1	غَيْرِ الْحُكْمِيَّةِ
u'غَيْرٌ حُكُومَةٌ':Added, #1: 1	غَيْرِ حُكُومَةٍ
u'غير حَكِيمٌ':Added, #1: 1	غَيْرِ حُكُومَةٍ
u'غَيْرٌ حَكِيمٌ':Added, #2: 2	غَيْرِ الْحَكِيمِ
u'غير حِلٌّ':Added, #2: 2	غَيْرِ الْحَكِيمِ
u'غَيْرٌ حِلٌّ':Added, #1: 1	غَيْرَ الْحِلِّ
u'غير حِلٌّ':Added, #1: 1	غَيْرَ الْحِلِّ
u'غَيْرٌ حِلٌّ':Added, #1: 1	غَيْرُ حِلٍّ
u'غير حِلٌّ':Added, #1: 1	غَيْرُ حِلٍّ
u'غَيْرٌ حِلٌّ':Added, #2: 2	غَيْرِ حِلٍّ
u'غير حِلٌّ':Added, #2: 2	غَيْرِ حِلٍّ
u'غَيْرٌ حِلٌّ':Added, #8: 8	غَيْرِ حِلِّهِ
u'غير حلاب':Added, #8: 8	غَيْرِ حِلِّهِ
u'غَيْرٌ حلاب':Added, #1: 1	غَيْرِ حُلَابٍ
u'غير حَلالٌ':Added, #1: 1	غَيْرِ حُلَابٍ
u'غَيْرٌ حَلالٌ':Added, #1: 1	غَيْرُ الْحَلَالِ
u'غير حَلالٌ':Added, #1: 1	غَيْرُ الْحَلَالِ
u'غير حَلالٌ':Added, #1: 1	غَيْرُ حَلَالٍ
u'غَيْرٌ حَلالٌ':Added, #1: 1	غَيْرِ حَلَالٍ
u'غَيْرٌ حَلالٌ':Added, #1: 1	غَيْرُ حَلَالٍ
u'غير حَلْقٌ':Added, #1: 1	غَيْرِ حَلَالٍ
u'غَيْرٌ حَلْقٌ':Added, #2: 2	غَيْرِ الْحَلْقِ
u'غير حَلْقَةٌ':Added, #2: 2	غَيْرِ الْحَلْقِ
u'غَيْرٌ حَلْقَةٌ':Added, #1: 1	غَيْرُ الْحَلْقَةِ
u'غير حُلُمٌ':Added, #1: 1	غَيْرُ الْحَلْقَةِ
u'غَيْرٌ حُلُمٌ':Added, #3: 3	غَيْرِ حُلُمٍ
u'غير حلْوٌ':Added, #3: 3	غَيْرِ حُلُمٍ
u'غَيْرٌ حلْوٌ':Added, #1: 1	غَيْرِ الْحُلْوِ
u'غير حلْوٌ':Added, #1: 1	غَيْرِ الْحُلْوِ
u'غَيْرٌ حلْوٌ':Added, #2: 2	غَيْرُ حُلْوٍ
u'غير حَلْوانِيٌّ':Added, #2: 2	غَيْرُ حُلْوٍ
u'غَيْرٌ حَلْوانِيٌّ':Added, #1: 1	غَيْرُ الْحَلْوَانِيِّ
u'غير حَمَّادٌ':Added, #1: 1	غَيْرُ الْحَلْوَانِيِّ
u'غَيْرٌ حَمَّادٌ':Added, #1: 1	غَيْرَ حَمَّادِ
u'غير حَمَّادٌ':Added, #1: 1	غَيْرَ حَمَّادِ
u'غَيْرٌ حَمَّادٌ':Added, #2: 2	غَيْرُ حَمَّادِ
u'غير حَمَامٌ':Added, #2: 2	غَيْرُ حَمَّادِ
u'غير حَمَّامٌ':Added, #1: 1	غَيْرِ الْحَمَامِ
u'غَيْرٌ حَمَامٌ':Added, #1: 1	غَيْرَ الْحَمَّامِ
u'غَيْرٌ حَمَّامٌ':Added, #1: 1	غَيْرِ الْحَمَامِ
u'غير حَمَّامٌ':Added, #1: 1	غَيْرَ الْحَمَّامِ
u'غَيْرٌ حَمَّامٌ':Added, #3: 3	غَيْرِ الْحَمَّامِ
u'غير حَمْدٌ':Added, #3: 3	غَيْرِ الْحَمَّامِ
u'غَيْرٌ حَمْدٌ':Added, #1: 1	غَيْرَ الْحَمْدِ
u'غير حَمْلٌ':Added, #1: 1	غَيْرَ الْحَمْدِ
u'غَيْرٌ حَمْلٌ':Added, #10: 10	غَيْرِ حَمْلٍ
u'غير حَمْلٌ':Added, #10: 10	غَيْرِ حَمْلٍ
u'غَيْرٌ حَمْلٌ':Added, #1: 1	غَيْرِ حَمْلِ
u'غير حَمْلٌ':Added, #1: 1	غَيْرِ حَمْلِ
u'غَيْرٌ حَمْلٌ':Added, #3: 3	غَيْرِ الْحَمْلِ
u'غير حَنْبَلٌ':Added, #3: 3	غَيْرِ الْحَمْلِ
u'غَيْرٌ حَنْبَلٌ':Added, #1: 1	غَيْرُ حَنْبَلٍ
u'غير حِنْثٌ':Added, #1: 1	غَيْرُ حَنْبَلٍ
u'غَيْرٌ حِنْثٌ':Added, #3: 3	غَيْرُ الْحِنْثِ
u'غير حِنْثٌ':Added, #3: 3	غَيْرُ الْحِنْثِ
u'غَيْرٌ حِنْثٌ':Added, #6: 6	غَيْرِ حِنْثٍ
u'غير حَنَشٌ':Added, #6: 6	غَيْرِ حِنْثٍ
u'غَيْرٌ حَنَشٌ':Added, #1: 1	غَيْرُ حَنَشِ
u'غير حِنْطَةٌ':Added, #1: 1	غَيْرُ حَنَشِ
u'غَيْرٌ حِنْطَةٌ':Added, #1: 1	غَيْرَ حِنْطَةٍ
u'غير حِنْطَةٌ':Added, #1: 1	غَيْرَ حِنْطَةٍ
u'غَيْرٌ حِنْطَةٌ':Added, #2: 2	غَيْرَ الْحِنْطَةِ
u'غير حَنَفِيَّةٌ':Added, #2: 2	غَيْرَ الْحِنْطَةِ
u'غَيْرٌ حَنَفِيَّةٌ':Added, #4: 4	غَيْرُ الْحَنَفِيَّةِ
u'غير حَنَفِيَّةٌ':Added, #4: 4	غَيْرُ الْحَنَفِيَّةِ
u'غَيْرٌ حَنَفِيَّةٌ':Added, #7: 7	غَيْرِ الْحَنَفِيَّةِ
u'غير حَوَالَةٌ':Added, #7: 7	غَيْرِ الْحَنَفِيَّةِ
u'غَيْرٌ حَوَالَةٌ':Added, #1: 1	غَيْرِ الْحَوَالَةِ
u'غير حَوَالَةٌ':Added, #1: 1	غَيْرِ الْحَوَالَةِ
u'غَيْرٌ حَوَالَةٌ':Added, #1: 1	غَيْرِ حَوَالَةٍ
u'غير حَوامِلُ':Added, #1: 1	غَيْرِ حَوَالَةٍ
u'غَيْرٌ حَوامِلُ':Added, #1: 1	غَيْرِ الْحَوَامِلِ
u'غير حول':Added, #1: 1	غَيْرِ الْحَوَامِلِ
u'غَيْرٌ حول':Added, #1: 1	غَيْرُ حَوْلِ
u'غير حَوْلٌ':Added, #1: 1	غَيْرُ حَوْلِ
u'غَيْرٌ حَوْلٌ':Added, #1: 1	غَيْرُ حَوْلِ
u'غير حول':Added, #1: 1	غَيْرُ حَوْلِ
u'غَيْرٌ حول':Added, #4: 4	غَيْرِ حَوْلٍ
u'غير حَوْلٌ':Added, #4: 4	غَيْرِ حَوْلٍ
u'غَيْرٌ حَوْلٌ':Added, #4: 4	غَيْرِ حَوْلٍ
u'غير حَيٌّ':Added, #4: 4	غَيْرِ حَوْلٍ
u'غَيْرٌ حَيٌّ':Added, #1: 1	غَيْرُ الْحَيَّيْنِ
u'غير حَيٌّ':Added, #1: 1	غَيْرُ الْحَيَّيْنِ
u'غَيْرٌ حَيٌّ':Added, #1: 1	غَيْرِ حَيِّهِ
u'غير حَيٌّ':Added, #1: 1	غَيْرِ حَيِّهِ
u'غَيْرٌ حَيٌّ':Added, #2: 2	غَيْرُ حَيٍّ
u'غير حَيَاءٌ':Added, #2: 2	غَيْرُ حَيٍّ
u'غَيْرٌ حَيَاءٌ':Added, #1: 1	غَيْرِ حَيَاءٍ
u'غير حَيَاةٌ':Added, #1: 1	غَيْرِ حَيَاءٍ
u'غَيْرٌ حَيَاةٌ':Added, #1: 1	غَيْرِ حَيَاةٍ
u'غير حَيْضٌ':Added, #1: 1	غَيْرِ حَيَاةٍ
u'غير حَيْضٌ':Added, #1: 1	غَيْرَ الْحَيْضِ
u'غَيْرٌ حَيْضٌ':Added, #1: 1	غَيْرُ الْحَيْضِ
u'غَيْرٌ حَيْضٌ':Added, #1: 1	غَيْرَ الْحَيْضِ
u'غير حَيْضٌ':Added, #1: 1	غَيْرُ الْحَيْضِ
u'غير حَيْضٌ':Added, #1: 1	غَيْرُ حَيْضٍ
u'غَيْرٌ حَيْضٌ':Added, #1: 1	غَيْرِ حَيْضٍ
u'غَيْرٌ حَيْضٌ':Added, #1: 1	غَيْرُ حَيْضٍ
u'غير حَيْضٌ':Added, #1: 1	غَيْرِ حَيْضٍ
u'غَيْرٌ حَيْضٌ':Added, #2: 2	غَيْرَ حَيْضٍ
u'غير حَيْضٌ':Added, #2: 2	غَيْرَ حَيْضٍ
u'غَيْرٌ حَيْضٌ':Added, #4: 4	غَيْرِ الْحَيْضِ
u'غير حَيْضَةٌ':Added, #4: 4	غَيْرِ الْحَيْضِ
u'غَيْرٌ حَيْضَةٌ':Added, #1: 1	غَيْرِ حَيْضَةِ
u'غير حيطانٌ':Added, #1: 1	غَيْرِ حَيْضَةِ
u'غَيْرٌ حيطانٌ':Added, #1: 1	غَيْرِ الْحِيطَانِ
u'غير حيفٌ':Added, #1: 1	غَيْرِ الْحِيطَانِ
u'غير حَيْفٌ':Added, #6: 6	غَيْرِ حَيْفٍ
u'غَيْرٌ حيفٌ':Added, #6: 6	غَيْرِ حَيْفٍ
u'غَيْرٌ حَيْفٌ':Added, #6: 6	غَيْرِ حَيْفٍ
u'غير حِيلَةٌ':Added, #6: 6	غَيْرِ حَيْفٍ
u'غَيْرٌ حِيلَةٌ':Added, #2: 2	غَيْرَ حِيلَةٍ
u'غير حِيلَةٌ':Added, #2: 2	غَيْرَ حِيلَةٍ
u'غَيْرٌ حِيلَةٌ':Added, #9: 9	غَيْرِ حِيلَةٍ
u'غير حَيَوَانٌ':Added, #9: 9	غَيْرِ حِيلَةٍ
u'غَيْرٌ حَيَوَانٌ':Added, #17: 17	غَيْرِ الْحَيَوَانِ
u'غير حَيَوَانٌ':Added, #17: 17	غَيْرِ الْحَيَوَانِ
u'غَيْرٌ حَيَوَانٌ':Added, #1: 1	غَيْرُ الْحَيَوَانِ
u'غير حَيَوَانٌ':Added, #1: 1	غَيْرُ الْحَيَوَانِ
u'غَيْرٌ حَيَوَانٌ':Added, #2: 2	غَيْرَ الْحَيَوَانِ
u'غير حَيَوَانٌ':Added, #2: 2	غَيْرَ الْحَيَوَانِ
u'غَيْرٌ حَيَوَانٌ':Added, #2: 2	غَيْرِ الْحَيَوَانَاتِ
u'غير حَيَوَانٌ':Added, #2: 2	غَيْرِ الْحَيَوَانَاتِ
u'غَيْرٌ حَيَوَانٌ':Added, #2: 2	غَيْرَ حَيَوَانٍ
u'غير حَيَوَانٌ':Added, #2: 2	غَيْرَ حَيَوَانٍ
u'غَيْرٌ حَيَوَانٌ':Added, #3: 3	غَيْرُ حَيَوَانٍ
u'غير حَيَوَانٌ':Added, #3: 3	غَيْرُ حَيَوَانٍ
u'غَيْرٌ حَيَوَانٌ':Added, #6: 6	غَيْرِ حَيَوَانٍ
u'غير خَابِيَةٌ':Added, #6: 6	غَيْرِ حَيَوَانٍ
u'غَيْرٌ خَابِيَةٌ':Added, #1: 1	غَيْرِ الْخَابِيَةِ
u'غير خَادِمٌ':Added, #1: 1	غَيْرِ الْخَابِيَةِ
u'غير خَادِمٌ':Added, #1: 1	غَيْرَ الْخَادِمِ
u'غَيْرٌ خَادِمٌ':Added, #1: 1	غَيْرُ الْخَادِمِ
u'غَيْرٌ خَادِمٌ':Added, #1: 1	غَيْرَ الْخَادِمِ
u'غير خَادِمٌ':Added, #1: 1	غَيْرُ الْخَادِمِ
u'غَيْرٌ خَادِمٌ':Added, #1: 1	غَيْرِ خَادِمٍ
u'غير خَادِمٌ':Added, #1: 1	غَيْرِ خَادِمٍ
u'غير خَادِمٌ':Added, #1: 1	غَيْرَ خَادِمِهِ
u'غَيْرٌ خَادِمٌ':Added, #1: 1	غَيْرِ خَادِمِهِ
u'غَيْرٌ خَادِمٌ':Added, #1: 1	غَيْرَ خَادِمِهِ
u'غير خَارِجٌ':Added, #1: 1	غَيْرِ خَادِمِهِ
u'غَيْرٌ خَارِجٌ':Added, #10: 10	غَيْرَ خَارِجٍ
u'غير خَارِجٌ':Added, #10: 10	غَيْرَ خَارِجٍ
u'غَيْرٌ خَارِجٌ':Added, #12: 12	غَيْرُ خَارِجٍ
u'غير خَارِجٌ':Added, #12: 12	غَيْرُ خَارِجٍ
u'غَيْرٌ خَارِجٌ':Added, #1: 1	غَيْرُ الْخَارِجِ
u'غير خَارِجٌ':Added, #1: 1	غَيْرُ الْخَارِجِ
u'غَيْرٌ خَارِجٌ':Added, #1: 1	غَيْرُ خَارِجَةٍ
u'غير خَارِجٌ':Added, #1: 1	غَيْرُ خَارِجَةٍ
u'غَيْرٌ خَارِجٌ':Added, #1: 1	غَيْرُ خَارِجَيْنِ
u'غير خَارِجٌ':Added, #1: 1	غَيْرُ خَارِجَيْنِ
u'غَيْرٌ خَارِجٌ':Added, #2: 2	غَيْرَ خَارِجَةٍ
u'غير خَارِجٌ':Added, #2: 2	غَيْرَ خَارِجَةٍ
u'غير خَارِجٌ':Added, #3: 3	غَيْرَ الْخَارِجِ
u'غَيْرٌ خَارِجٌ':Added, #3: 3	غَيْرِ الْخَارِجِ
u'غَيْرٌ خَارِجٌ':Added, #3: 3	غَيْرَ الْخَارِجِ
u'غير خَارِقٌ':Added, #3: 3	غَيْرِ الْخَارِجِ
u'غَيْرٌ خَارِقٌ':Added, #1: 1	غَيْرُ خَارِقٍ
u'غير خَاشِعٌ':Added, #1: 1	غَيْرُ خَارِقٍ
u'غَيْرٌ خَاشِعٌ':Added, #1: 1	غَيْرُ خَاشِعٍ
u'غير خاصّ':Added, #1: 1	غَيْرُ خَاشِعٍ
u'غَيْرٌ خاصّ':Added, #1: 1	غَيْرِ الْخَاصِّ
u'غير خاصّ':Added, #1: 1	غَيْرِ الْخَاصِّ
u'غَيْرٌ خاصّ':Added, #1: 1	غَيْرَ خَاصٍّ
u'غير خاصّ':Added, #1: 1	غَيْرَ خَاصٍّ
u'غَيْرٌ خاصّ':Added, #6: 6	غَيْرُ خَاصٍّ
u'غير خَاصَّةٌ':Added, #6: 6	غَيْرُ خَاصٍّ
u'غَيْرٌ خَاصَّةٌ':Added, #1: 1	غَيْرُ خَاصَّةٍ
u'غير خَاطِبٌ':Added, #1: 1	غَيْرُ خَاصَّةٍ
u'غَيْرٌ خَاطِبٌ':Added, #1: 1	غَيْرُ خَاطِبٍ
u'غير خَافِي':Added, #1: 1	غَيْرُ خَاطِبٍ
u'غَيْرٌ خَافِي':Added, #3: 3	غَيْرُ خَافِيَةٍ
u'غير خَالٌ':Added, #3: 3	غَيْرُ خَافِيَةٍ
u'غَيْرٌ خَالٌ':Added, #4: 4	غَيْرُ خَالٍ
u'غير خَالِدٌ':Added, #4: 4	غَيْرُ خَالٍ
u'غَيْرٌ خَالِدٌ':Added, #1: 1	غَيْرُ خَالِدِ
u'غير خَالِصٌ':Added, #1: 1	غَيْرُ خَالِدِ
u'غَيْرٌ خَالِصٌ':Added, #1: 1	غَيْرُ الْخَالِصِ
u'غير خَالِصٌ':Added, #1: 1	غَيْرُ الْخَالِصِ
u'غير خَالِصٌ':Added, #1: 1	غَيْرَ خَالِصَةٍ
u'غَيْرٌ خَالِصٌ':Added, #1: 1	غَيْرُ خَالِصَةٍ
u'غَيْرٌ خَالِصٌ':Added, #1: 1	غَيْرَ خَالِصَةٍ
u'غير خَالِصٌ':Added, #1: 1	غَيْرُ خَالِصَةٍ
u'غَيْرٌ خَالِصٌ':Added, #4: 4	غَيْرُ خَالِصٍ
u'غير خَالِقٌ':Added, #4: 4	غَيْرُ خَالِصٍ
u'غير خَالِقٌ':Added, #1: 1	غَيْرُ خَالِقٍ
u'غَيْرٌ خَالِقٌ':Added, #1: 1	غَيْرِ خَالِقٍ
u'غَيْرٌ خَالِقٌ':Added, #1: 1	غَيْرُ خَالِقٍ
u'غير خَامِلٌ':Added, #1: 1	غَيْرِ خَالِقٍ
u'غَيْرٌ خَامِلٌ':Added, #1: 1	غَيْرِ الْخَامِلِ
u'غير خَانٌ':Added, #1: 1	غَيْرِ الْخَامِلِ
u'غَيْرٌ خَانٌ':Added, #1: 1	غَيْرِ الْخَانِ
u'غير خَائِبٌ':Added, #1: 1	غَيْرِ الْخَانِ
u'غَيْرٌ خَائِبٌ':Added, #1: 1	غَيْرَ خَائِبَةٍ
u'غير خَائِبٌ':Added, #1: 1	غَيْرَ خَائِبَةٍ
u'غَيْرٌ خَائِبٌ':Added, #2: 2	غَيْرُ خَائِبِ
u'غير خَائِفٌ':Added, #2: 2	غَيْرُ خَائِبِ
u'غَيْرٌ خَائِفٌ':Added, #1: 1	غَيْرِ خَائِفٍ
u'غير خَائِفٌ':Added, #1: 1	غَيْرِ خَائِفٍ
u'غَيْرٌ خَائِفٌ':Added, #2: 2	غَيْرَ خَائِفٍ
u'غير خَائِفٌ':Added, #2: 2	غَيْرَ خَائِفٍ
u'غَيْرٌ خَائِفٌ':Added, #4: 4	غَيْرُ خَائِفٍ
u'غير خَبَبٌ':Added, #4: 4	غَيْرُ خَائِفٍ
u'غَيْرٌ خَبَبٌ':Added, #2: 2	غَيْرِ خَبَبٍ
u'غير خَبَرٌ':Added, #2: 2	غَيْرِ خَبَبٍ
u'غير خَبَر':Added, #1: 1	غَيْرَ الْخَبَرِ
u'غَيْرٌ خَبَرٌ':Added, #1: 1	غَيْرَ الْخَبَرِ
u'غَيْرٌ خَبَر':Added, #1: 1	غَيْرَ الْخَبَرِ
u'غير خَبَرٌ':Added, #1: 1	غَيْرَ الْخَبَرِ
u'غير خَبَر':Added, #1: 1	غَيْرُ خَبَرِ
u'غَيْرٌ خَبَرٌ':Added, #1: 1	غَيْرُ خَبَرِ
u'غَيْرٌ خَبَر':Added, #1: 1	غَيْرُ خَبَرِ
u'غير خَبَرٌ':Added, #1: 1	غَيْرُ خَبَرِ
u'غير خَبَر':Added, #2: 2	غَيْرِ الْخَبَرِ
u'غَيْرٌ خَبَرٌ':Added, #2: 2	غَيْرِ الْخَبَرِ
u'غَيْرٌ خَبَر':Added, #2: 2	غَيْرِ الْخَبَرِ
u'غير خَبَرٌ':Added, #2: 2	غَيْرِ الْخَبَرِ
u'غير خَبَر':Added, #2: 2	غَيْرَ خَبَرٍ
u'غَيْرٌ خَبَرٌ':Added, #2: 2	غَيْرَ خَبَرٍ
u'غَيْرٌ خَبَر':Added, #2: 2	غَيْرَ خَبَرٍ
u'غير خِبْرَةٌ':Added, #2: 2	غَيْرَ خَبَرٍ
u'غَيْرٌ خِبْرَةٌ':Added, #1: 1	غَيْرِ خِبْرَةٍ
u'غير خُبْزٌ':Added, #1: 1	غَيْرِ خِبْرَةٍ
u'غَيْرٌ خُبْزٌ':Added, #1: 1	غَيْرَ الْخُبْزِ
u'غير خَبِير':Added, #1: 1	غَيْرَ الْخُبْزِ
u'غَيْرٌ خَبِير':Added, #1: 1	غَيْرُ خَبِيرَيْنِ
u'غير خَتْمٌ':Added, #1: 1	غَيْرُ خَبِيرَيْنِ
u'غَيْرٌ خَتْمٌ':Added, #1: 1	غَيْرِ خَتْمٍ
u'غير خدمة':Added, #1: 1	غَيْرِ خَتْمٍ
u'غَيْرٌ خدمة':Added, #5: 5	غَيْرِ الْخِدْمَةِ
u'غير خِدْمَةٌ':Added, #5: 5	غَيْرِ الْخِدْمَةِ
u'غَيْرٌ خِدْمَةٌ':Added, #5: 5	غَيْرِ الْخِدْمَةِ
u'غير خَرَابٌ':Added, #5: 5	غَيْرِ الْخِدْمَةِ
u'غَيْرٌ خَرَابٌ':Added, #2: 2	غَيْرِ الْخَرَابِ
u'غير خراج':Added, #2: 2	غَيْرِ الْخَرَابِ
u'غَيْرٌ خراج':Added, #1: 1	غَيْرِ الْخَرَاجِ
u'غير خَرَاجٌ':Added, #1: 1	غَيْرِ الْخَرَاجِ
u'غَيْرٌ خَرَاجٌ':Added, #1: 1	غَيْرِ الْخَرَاجِ
u'غير خَراج':Added, #1: 1	غَيْرِ الْخَرَاجِ
u'غير خَراج':Added, #1: 1	غَيْرَ الْخَرَاجِيَّةِ
u'غَيْرٌ خَراج':Added, #1: 1	غَيْرُ الْخَرَاجِيَّةِ
u'غَيْرٌ خَراج':Added, #1: 1	غَيْرَ الْخَرَاجِيَّةِ
u'غير خَراج':Added, #1: 1	غَيْرُ الْخَرَاجِيَّةِ
u'غَيْرٌ خَراج':Added, #1: 1	غَيْرُ خَرَاجِيَّةٍ
u'غير خراج':Added, #1: 1	غَيْرُ خَرَاجِيَّةٍ
u'غَيْرٌ خراج':Added, #2: 2	غَيْرِ خَرَاجِهِ
u'غير خَرَاجٌ':Added, #2: 2	غَيْرِ خَرَاجِهِ
u'غَيْرٌ خَرَاجٌ':Added, #2: 2	غَيْرِ خَرَاجِهِ
u'غير خَراج':Added, #2: 2	غَيْرِ خَرَاجِهِ
u'غَيْرٌ خَراج':Added, #2: 2	غَيْرَ خَرَاجِيَّةٍ
u'غير خراج':Added, #2: 2	غَيْرَ خَرَاجِيَّةٍ
u'غَيْرٌ خراج':Added, #4: 4	غَيْرِ خَرَاجٍ
u'غير خَرَاجٌ':Added, #4: 4	غَيْرِ خَرَاجٍ
u'غَيْرٌ خَرَاجٌ':Added, #4: 4	غَيْرِ خَرَاجٍ
u'غير خَراجِيّ':Added, #4: 4	غَيْرِ خَرَاجٍ
u'غير خَراجِيّ':Added, #1: 1	غَيْرَ الْخَرَاجِيَّةِ
u'غَيْرٌ خَراجِيّ':Added, #1: 1	غَيْرُ الْخَرَاجِيَّةِ
u'غَيْرٌ خَراجِيّ':Added, #1: 1	غَيْرَ الْخَرَاجِيَّةِ
u'غير خَراجِيّ':Added, #1: 1	غَيْرُ الْخَرَاجِيَّةِ
u'غَيْرٌ خَراجِيّ':Added, #1: 1	غَيْرُ خَرَاجِيَّةٍ
u'غير خَراجِيّ':Added, #1: 1	غَيْرُ خَرَاجِيَّةٍ
u'غَيْرٌ خَراجِيّ':Added, #2: 2	غَيْرَ خَرَاجِيَّةٍ
u'غير خَرِبٌ':Added, #2: 2	غَيْرَ خَرَاجِيَّةٍ
u'غَيْرٌ خَرِبٌ':Added, #1: 1	غَيْرِ الْخَرِبِ
u'غير خرقة':Added, #1: 1	غَيْرِ الْخَرِبِ
u'غَيْرٌ خرقة':Added, #1: 1	غَيْرِ خِرْقَةٍ
u'غير خِرْقَةٌ':Added, #1: 1	غَيْرِ خِرْقَةٍ
u'غَيْرٌ خِرْقَةٌ':Added, #1: 1	غَيْرِ خِرْقَةٍ
u'غير خُرُوجٌ':Added, #1: 1	غَيْرِ خِرْقَةٍ
u'غَيْرٌ خُرُوجٌ':Added, #1: 1	غَيْرِ خُرُوجِ
u'غير خُرُوجٌ':Added, #1: 1	غَيْرِ خُرُوجِ
u'غَيْرٌ خُرُوجٌ':Added, #2: 2	غَيْرُ الْخُرُوجِ
u'غير خُرُوجٌ':Added, #2: 2	غَيْرُ الْخُرُوجِ
u'غَيْرٌ خُرُوجٌ':Added, #5: 5	غَيْرِ خُرُوجٍ
u'غير خَزٌّ':Added, #5: 5	غَيْرِ خُرُوجٍ
u'غَيْرٌ خَزٌّ':Added, #1: 1	غَيْرُ خَزٍّ
u'غير خَزْق':Added, #1: 1	غَيْرُ خَزٍّ
u'غَيْرٌ خَزْق':Added, #1: 1	غَيْرِ خَزْقٍ
u'غير خِسَّة':Added, #1: 1	غَيْرِ خَزْقٍ
u'غَيْرٌ خِسَّة':Added, #1: 1	غَيْرِ الْخِسَّةِ
u'غير خُسْران':Added, #1: 1	غَيْرِ الْخِسَّةِ
u'غَيْرٌ خُسْران':Added, #1: 1	غَيْرِ الْخُسْرَانِ
u'غير خُسُوفٌ':Added, #1: 1	غَيْرِ الْخُسْرَانِ
u'غير خُسُوفٌ':Added, #1: 1	غَيْرَ الْخُسُوفِ
u'غَيْرٌ خُسُوفٌ':Added, #1: 1	غَيْرِ الْخُسُوفِ
u'غَيْرٌ خُسُوفٌ':Added, #1: 1	غَيْرَ الْخُسُوفِ
u'غير خَشَبٌ':Added, #1: 1	غَيْرِ الْخُسُوفِ
u'غَيْرٌ خَشَبٌ':Added, #1: 1	غَيْرَ خَشَبٍ
u'غير خَشْيَةٌ':Added, #1: 1	غَيْرَ خَشَبٍ
u'غَيْرٌ خَشْيَةٌ':Added, #1: 1	غَيْرِ خَشْيَةِ
u'غير خِصَامٌ':Added, #1: 1	غَيْرِ خَشْيَةِ
u'غَيْرٌ خِصَامٌ':Added, #2: 2	غَيْرِ الْخِصَامِ
u'غير خَصْمٌ':Added, #2: 2	غَيْرِ الْخِصَامِ
u'غير خَصْمٌ':Added, #1: 1	غَيْرَ الْخَصْمِ
u'غَيْرٌ خَصْمٌ':Added, #1: 1	غَيْرُ الْخَصْمِ
u'غَيْرٌ خَصْمٌ':Added, #1: 1	غَيْرَ الْخَصْمِ
u'غير خَصْمٌ':Added, #1: 1	غَيْرُ الْخَصْمِ
u'غير خَصْمٌ':Added, #1: 1	غَيْرَ الْخَصْمَيْنِ
u'غَيْرٌ خَصْمٌ':Added, #1: 1	غَيْرِ الْخَصْمَيْنِ
u'غَيْرٌ خَصْمٌ':Added, #1: 1	غَيْرَ الْخَصْمَيْنِ
u'غير خَصْمٌ':Added, #1: 1	غَيْرِ الْخَصْمَيْنِ
u'غَيْرٌ خَصْمٌ':Added, #25: 25	غَيْرِ خَصْمٍ
u'غير خَصْمٌ':Added, #25: 25	غَيْرِ خَصْمٍ
u'غَيْرٌ خَصْمٌ':Added, #2: 2	غَيْرِ الْخَصْمِ
u'غير خُصُومَةٌ':Added, #2: 2	غَيْرِ الْخَصْمِ
u'غَيْرٌ خُصُومَةٌ':Added, #2: 2	غَيْرِ خُصُومَةٍ
u'غير خُصُومَةٌ':Added, #2: 2	غَيْرِ خُصُومَةٍ
u'غَيْرٌ خُصُومَةٌ':Added, #4: 4	غَيْرُ الْخُصُومَةِ
u'غير خَصِيٌّ':Added, #4: 4	غَيْرُ الْخُصُومَةِ
u'غَيْرٌ خَصِيٌّ':Added, #1: 1	غَيْرِ الْخَصِيِّ
u'غير خَصِيٌّ':Added, #1: 1	غَيْرِ الْخَصِيِّ
u'غَيْرٌ خَصِيٌّ':Added, #1: 1	غَيْرَ خَصِيٍّ
u'غير خَصِيٌّ':Added, #1: 1	غَيْرَ خَصِيٍّ
u'غَيْرٌ خَصِيٌّ':Added, #1: 1	غَيْرِ خَصِيِّهِ
u'غير خُصْيَةٌ':Added, #1: 1	غَيْرِ خَصِيِّهِ
u'غَيْرٌ خُصْيَةٌ':Added, #1: 1	غَيْرِ خُصْيَةٍ
u'غير خَضِرٌ':Added, #1: 1	غَيْرِ خُصْيَةٍ
u'غَيْرٌ خَضِرٌ':Added, #1: 1	غَيْرَ الْخَضِرَةِ
u'غير خُضْرَةٌ':Added, #1: 1	غَيْرَ الْخَضِرَةِ
u'غَيْرٌ خُضْرَةٌ':Added, #2: 2	غَيْرَ الْخُضْرَةِ
u'غير خَطَأٌ':Added, #2: 2	غَيْرَ الْخُضْرَةِ
u'غَيْرٌ خَطَأٌ':Added, #1: 1	غَيْرِ خَطَأِ
u'غير خِطَابٌ':Added, #1: 1	غَيْرِ خَطَأِ
u'غَيْرٌ خِطَابٌ':Added, #1: 1	غَيْرِ الْخِطَابِ
u'غير خطبة':Added, #1: 1	غَيْرِ الْخِطَابِ
u'غير خطبة':Added, #1: 1	غَيْرَ الْخُطْبَةِ
u'غَيْرٌ خطبة':Added, #1: 1	غَيْرُ الْخُطْبَةِ
u'غَيْرٌ خطبة':Added, #1: 1	غَيْرَ الْخُطْبَةِ
u'غير خُطْبَةٌ':Added, #1: 1	غَيْرُ الْخُطْبَةِ
u'غير خُطْبَةٌ':Added, #1: 1	غَيْرَ الْخُطْبَةِ
u'غَيْرٌ خُطْبَةٌ':Added, #1: 1	غَيْرُ الْخُطْبَةِ
u'غَيْرٌ خُطْبَةٌ':Added, #1: 1	غَيْرَ الْخُطْبَةِ
u'غير خطبة':Added, #1: 1	غَيْرُ الْخُطْبَةِ
u'غَيْرٌ خطبة':Added, #1: 1	غَيْرِ خِطْبَةٍ
u'غير خِطْبَةٌ':Added, #1: 1	غَيْرِ خِطْبَةٍ
u'غَيْرٌ خِطْبَةٌ':Added, #1: 1	غَيْرِ خِطْبَةٍ
u'غير خطبة':Added, #1: 1	غَيْرِ خِطْبَةٍ
u'غَيْرٌ خطبة':Added, #3: 3	غَيْرِ خُطْبَةٍ
u'غير خُطْبَةٌ':Added, #3: 3	غَيْرِ خُطْبَةٍ
u'غَيْرٌ خُطْبَةٌ':Added, #3: 3	غَيْرِ خُطْبَةٍ
u'غير خَطَرٌ':Added, #3: 3	غَيْرِ خُطْبَةٍ
u'غَيْرٌ خَطَرٌ':Added, #3: 3	غَيْرِ خَطَرٍ
u'غير خَطَلٌ':Added, #3: 3	غَيْرِ خَطَرٍ
u'غَيْرٌ خَطَلٌ':Added, #1: 1	غَيْرِ خَطَلٍ
u'غير خُطُمٌ':Added, #1: 1	غَيْرِ خَطَلٍ
u'غَيْرٌ خُطُمٌ':Added, #1: 1	غَيْرِ خُطُمٍ
u'غير خَطِيبٌ':Added, #1: 1	غَيْرِ خُطُمٍ
u'غَيْرٌ خَطِيبٌ':Added, #1: 1	غَيْرُ الْخَطِيبِ
u'غير خُفٌّ':Added, #1: 1	غَيْرُ الْخَطِيبِ
u'غَيْرٌ خُفٌّ':Added, #1: 1	غَيْرِ الْخُفِّ
u'غير خُفٌّ':Added, #1: 1	غَيْرِ الْخُفِّ
u'غَيْرٌ خُفٌّ':Added, #2: 2	غَيْرُ الْخُفِّ
u'غير خَفَاءٌ':Added, #2: 2	غَيْرُ الْخُفِّ
u'غَيْرٌ خَفَاءٌ':Added, #1: 1	غَيْرِ خَفَاءٍ
u'غير خفاف':Added, #1: 1	غَيْرِ خَفَاءٍ
u'غَيْرٌ خفاف':Added, #1: 1	غَيْرِ الْخِفَافِ
u'غير خِفَافٌ':Added, #1: 1	غَيْرِ الْخِفَافِ
u'غَيْرٌ خِفَافٌ':Added, #1: 1	غَيْرِ الْخِفَافِ
u'غير خَفِيٌّ':Added, #1: 1	غَيْرِ الْخِفَافِ
u'غَيْرٌ خَفِيٌّ':Added, #2: 2	غَيْرُ الْخَفِيِّ
u'غير خِلاَفٌ':Added, #2: 2	غَيْرُ الْخَفِيِّ
u'غَيْرٌ خِلاَفٌ':Added, #125: 125	غَيْرِ خِلَافٍ
u'غير خِلاَفٌ':Added, #125: 125	غَيْرِ خِلَافٍ
u'غير خِلاَفٌ':Added, #1: 1	غَيْرَ الْخِلَافِ
u'غَيْرٌ خِلاَفٌ':Added, #1: 1	غَيْرِ الْخِلَافِ
u'غَيْرٌ خِلاَفٌ':Added, #1: 1	غَيْرَ الْخِلَافِ
u'غير خِلاَفٌ':Added, #1: 1	غَيْرِ الْخِلَافِ
u'غير خِلاَفٌ':Added, #1: 1	غَيْرُ خِلَافٍ
u'غَيْرٌ خِلاَفٌ':Added, #1: 1	غَيْرِ خِلَافِ
u'غَيْرٌ خِلاَفٌ':Added, #1: 1	غَيْرُ خِلَافٍ
u'غير خِلاَفٌ':Added, #1: 1	غَيْرِ خِلَافِ
u'غَيْرٌ خِلاَفٌ':Added, #2: 2	غَيْرُ الْخِلَافِ
u'غير خِلاَفِيٌّ':Added, #2: 2	غَيْرُ الْخِلَافِ
u'غَيْرٌ خِلاَفِيٌّ':Added, #1: 1	غَيْرِ خِلَافِيَّةٍ
u'غير خَلَّةٌ':Added, #1: 1	غَيْرِ خِلَافِيَّةٍ
u'غَيْرٌ خَلَّةٌ':Added, #1: 1	غَيْرِ خَلّةِ
u'غير خلط':Added, #1: 1	غَيْرِ خَلّةِ
u'غَيْرٌ خلط':Added, #1: 1	غَيْرِ الْخَلْطِ
u'غير خُلْعٌ':Added, #1: 1	غَيْرِ الْخَلْطِ
u'غير خُلْعٌ':Added, #1: 1	غَيْرُ الْخُلْعِ
u'غَيْرٌ خُلْعٌ':Added, #1: 1	غَيْرِ الْخُلْعِ
u'غَيْرٌ خُلْعٌ':Added, #1: 1	غَيْرُ الْخُلْعِ
u'غير خَلَفٌ':Added, #1: 1	غَيْرِ الْخُلْعِ
u'غَيْرٌ خَلَفٌ':Added, #1: 1	غَيْرِ خَلَفٍ
u'غير خلق':Added, #1: 1	غَيْرِ خَلَفٍ
u'غَيْرٌ خلق':Added, #1: 1	غَيْرِ الْخَلْقِ
u'غير خَلْقٌ':Added, #1: 1	غَيْرِ الْخَلْقِ
u'غَيْرٌ خَلْقٌ':Added, #1: 1	غَيْرِ الْخَلْقِ
u'غير خلقة':Added, #1: 1	غَيْرِ الْخَلْقِ
u'غَيْرٌ خلقة':Added, #1: 1	غَيْرِ الْخِلْقَةِ
u'غير خِلْقَةٌ':Added, #1: 1	غَيْرِ الْخِلْقَةِ
u'غَيْرٌ خِلْقَةٌ':Added, #1: 1	غَيْرِ الْخِلْقَةِ
u'غير خَلَلٌ':Added, #1: 1	غَيْرِ الْخِلْقَةِ
u'غَيْرٌ خَلَلٌ':Added, #3: 3	غَيْرِ خَلَلٍ
u'غير خَلْوَةٌ':Added, #3: 3	غَيْرِ خَلَلٍ
u'غَيْرٌ خَلْوَةٌ':Added, #2: 2	غَيْرِ الْخَلْوَةِ
u'غير خَلْوَةٌ':Added, #2: 2	غَيْرِ الْخَلْوَةِ
u'غَيْرٌ خَلْوَةٌ':Added, #4: 4	غَيْرِ خَلْوَةٍ
u'غير خَلِيط':Added, #4: 4	غَيْرِ خَلْوَةٍ
u'غَيْرٌ خَلِيط':Added, #1: 1	غَيْرِ الْخَلِيطَيْنِ
u'غير خَلِيلٌ':Added, #1: 1	غَيْرِ الْخَلِيطَيْنِ
u'غَيْرٌ خَلِيلٌ':Added, #1: 1	غَيْرِ الْخَلِيلِ
u'غير خَمْرٌ':Added, #1: 1	غَيْرِ الْخَلِيلِ
u'غَيْرٌ خَمْرٌ':Added, #14: 14	غَيْرِ الْخَمْرِ
u'غير خَمْرٌ':Added, #14: 14	غَيْرِ الْخَمْرِ
u'غَيْرٌ خَمْرٌ':Added, #1: 1	غَيْرُ الْخَمْرِ
u'غير خَمْرٌ':Added, #1: 1	غَيْرُ الْخَمْرِ
u'غَيْرٌ خَمْرٌ':Added, #1: 1	غَيْرِ خَمْرٍ
u'غير خَمْرٌ':Added, #1: 1	غَيْرِ خَمْرٍ
u'غَيْرٌ خَمْرٌ':Added, #2: 2	غَيْرُ خَمْرٍ
u'غير خَمْرٌ':Added, #2: 2	غَيْرُ خَمْرٍ
u'غَيْرٌ خَمْرٌ':Added, #4: 4	غَيْرَ خَمْرٍ
u'غير خَمْرٌ':Added, #4: 4	غَيْرَ خَمْرٍ
u'غَيْرٌ خَمْرٌ':Added, #5: 5	غَيْرَ الْخَمْرِ
u'غير خَمْسٌ':Added, #5: 5	غَيْرَ الْخَمْرِ
u'غير خُمْسٌ':Added, #1: 1	غَيْرِ الْخَمْسِ
u'غَيْرٌ خَمْسٌ':Added, #1: 1	غَيْرَ الْخُمْسِ
u'غَيْرٌ خُمْسٌ':Added, #1: 1	غَيْرِ الْخَمْسِ
u'غير خُمُسٌ':Added, #1: 1	غَيْرَ الْخُمْسِ
u'غَيْرٌ خُمُسٌ':Added, #1: 1	غَيْرِ خُمُسٍ
u'غير خَمْسٌ':Added, #1: 1	غَيْرِ خُمُسٍ
u'غَيْرٌ خَمْسٌ':Added, #2: 2	غَيْرَ الْخَمْسِ
u'غير خَمْسَةٌ':Added, #2: 2	غَيْرَ الْخَمْسِ
u'غير خَمْسَةٌ':Added, #1: 1	غَيْرَ الْخَمْسَةِ
u'غَيْرٌ خَمْسَةٌ':Added, #1: 1	غَيْرُ الْخَمْسَةِ
u'غَيْرٌ خَمْسَةٌ':Added, #1: 1	غَيْرَ الْخَمْسَةِ
u'غير خَمْسَةٌ':Added, #1: 1	غَيْرُ الْخَمْسَةِ
u'غير خَمْسَةٌ':Added, #1: 1	غَيْرَ خَمْسَةٍ
u'غَيْرٌ خَمْسَةٌ':Added, #1: 1	غَيْرَ خَمْسَةِ
u'غَيْرٌ خَمْسَةٌ':Added, #1: 1	غَيْرَ خَمْسَةٍ
u'غير خَمْسَةٌ':Added, #1: 1	غَيْرَ خَمْسَةِ
u'غَيْرٌ خَمْسَةٌ':Added, #2: 2	غَيْرِ الْخَمْسَةِ
u'غير خِنْزِيرٌ':Added, #2: 2	غَيْرِ الْخَمْسَةِ
u'غَيْرٌ خِنْزِيرٌ':Added, #1: 1	غَيْرَ الْخِنْزِيرِ
u'غير خِنْزِيرٌ':Added, #1: 1	غَيْرَ الْخِنْزِيرِ
u'غَيْرٌ خِنْزِيرٌ':Added, #3: 3	غَيْرِ الْخِنْزِيرِ
u'غير خِنْصَرٌ':Added, #3: 3	غَيْرِ الْخِنْزِيرِ
u'غَيْرٌ خِنْصَرٌ':Added, #1: 1	غَيْرِ خِنْصَرٍ
u'غير خِنْصَرٌ':Added, #1: 1	غَيْرِ خِنْصَرٍ
u'غَيْرٌ خِنْصَرٌ':Added, #2: 2	غَيْرِ خِنْصَرِهِ
u'غير خِنْصَرٌ':Added, #2: 2	غَيْرِ خِنْصَرِهِ
u'غَيْرٌ خِنْصَرٌ':Added, #5: 5	غَيْرِ الْخِنْصَرِ
u'غير خَوَاصُّ':Added, #5: 5	غَيْرِ الْخِنْصَرِ
u'غير خَوَاصّ':Added, #1: 1	غَيْرَ الْخَوَاصِّ
u'غَيْرٌ خَوَاصُّ':Added, #1: 1	غَيْرَ الْخَوَاصِّ
u'غَيْرٌ خَوَاصّ':Added, #1: 1	غَيْرَ الْخَوَاصِّ
u'غير خَوْفٌ':Added, #1: 1	غَيْرَ الْخَوَاصِّ
u'غَيْرٌ خَوْفٌ':Added, #1: 1	غَيْرَ خَوْفٍ
u'غير خَوْفٌ':Added, #1: 1	غَيْرَ خَوْفٍ
u'غَيْرٌ خَوْفٌ':Added, #25: 25	غَيْرِ خَوْفٍ
u'غير خَوْفٌ':Added, #25: 25	غَيْرِ خَوْفٍ
u'غير خَوْفٌ':Added, #2: 2	غَيْرَ خَوْفِ
u'غَيْرٌ خَوْفٌ':Added, #2: 2	غَيْرُ خَوْفِ
u'غَيْرٌ خَوْفٌ':Added, #2: 2	غَيْرَ خَوْفِ
u'غير خَوْفٌ':Added, #2: 2	غَيْرُ خَوْفِ
u'غَيْرٌ خَوْفٌ':Added, #5: 5	غَيْرِ الْخَوْفِ
u'غير خَوْفٌ':Added, #5: 5	غَيْرِ الْخَوْفِ
u'غَيْرٌ خَوْفٌ':Added, #5: 5	غَيْرِ خَوْفِ
u'غير خيار':Added, #5: 5	غَيْرِ خَوْفِ
u'غير خِيَارٌ':Added, #19: 19	غَيْرِ خِيَارٍ
u'غَيْرٌ خيار':Added, #19: 19	غَيْرِ خِيَارٍ
u'غَيْرٌ خِيَارٌ':Added, #19: 19	غَيْرِ خِيَارٍ
u'غير خيار':Added, #19: 19	غَيْرِ خِيَارٍ
u'غير خِيَارٌ':Added, #1: 1	غَيْرِ خِيَارِ
u'غَيْرٌ خيار':Added, #1: 1	غَيْرِ خِيَارِ
u'غَيْرٌ خِيَارٌ':Added, #1: 1	غَيْرِ خِيَارِ
u'غير خيار':Added, #1: 1	غَيْرِ خِيَارِ
u'غير خِيَارٌ':Added, #2: 2	غَيْرُ الْخِيَارِ
u'غَيْرٌ خيار':Added, #2: 2	غَيْرُ الْخِيَارِ
u'غَيْرٌ خِيَارٌ':Added, #2: 2	غَيْرُ الْخِيَارِ
u'غير خِيَانَةٌ':Added, #2: 2	غَيْرُ الْخِيَارِ
u'غَيْرٌ خِيَانَةٌ':Added, #1: 1	غَيْرِ خِيَانَةٍ
u'غير خِيَانَةٌ':Added, #1: 1	غَيْرِ خِيَانَةٍ
u'غَيْرٌ خِيَانَةٌ':Added, #3: 3	غَيْرَ الْخِيَانَةِ
u'غير خَيْرٌ':Added, #3: 3	غَيْرَ الْخِيَانَةِ
u'غير خَيْرٌ':Added, #1: 1	غَيْرَ خَيْرِ
u'غَيْرٌ خَيْرٌ':Added, #1: 1	غَيْرِ خَيْرٍ
u'غَيْرٌ خَيْرٌ':Added, #1: 1	غَيْرَ خَيْرِ
u'غير خَيْلٌ':Added, #1: 1	غَيْرِ خَيْرٍ
u'غَيْرٌ خَيْلٌ':Added, #1: 1	غَيْرِ الْخَيْلِ
u'غير خَيْلٌ':Added, #1: 1	غَيْرِ الْخَيْلِ
u'غَيْرٌ خَيْلٌ':Added, #1: 1	غَيْرِ خَيْلٍ
u'غير خَيْمَةٌ':Added, #1: 1	غَيْرِ خَيْلٍ
u'غَيْرٌ خَيْمَةٌ':Added, #1: 1	غَيْرِ خَيْمَةٍ
u'غير دَاءٌ':Added, #1: 1	غَيْرِ خَيْمَةٍ
u'غَيْرٌ دَاءٌ':Added, #1: 1	غَيْرَ دَاءٍ
u'غير دَاءٌ':Added, #1: 1	غَيْرَ دَاءٍ
u'غَيْرٌ دَاءٌ':Added, #3: 3	غَيْرِ دَاءٍ
u'غير دَاخِلٌ':Added, #3: 3	غَيْرِ دَاءٍ
u'غَيْرٌ دَاخِلٌ':Added, #10: 10	غَيْرُ دَاخِلَةٍ
u'غير دَاخِلٌ':Added, #10: 10	غَيْرُ دَاخِلَةٍ
u'غير دَاخِلٌ':Added, #1: 1	غَيْرَ الدَّاخِلِ
u'غَيْرٌ دَاخِلٌ':Added, #1: 1	غَيْرُ الدَّاخِلِ
u'غَيْرٌ دَاخِلٌ':Added, #1: 1	غَيْرَ الدَّاخِلِ
u'غير دَاخِلٌ':Added, #1: 1	غَيْرُ الدَّاخِلِ
u'غير دَاخِلٌ':Added, #1: 1	غَيْر دَاخِلٍ
u'غَيْرٌ دَاخِلٌ':Added, #1: 1	غَيْرِ دَاخِلِ
u'غَيْرٌ دَاخِلٌ':Added, #1: 1	غَيْر دَاخِلٍ
u'غير دَاخِلٌ':Added, #1: 1	غَيْرِ دَاخِلِ
u'غَيْرٌ دَاخِلٌ':Added, #1: 1	غَيْرِ دَاخِلَةِ
u'غير دَاخِلٌ':Added, #1: 1	غَيْرِ دَاخِلَةِ
u'غَيْرٌ دَاخِلٌ':Added, #2: 2	غَيْرِ الدَّاخِلِ
u'غير دَاخِلٌ':Added, #2: 2	غَيْرِ الدَّاخِلِ
u'غَيْرٌ دَاخِلٌ':Added, #2: 2	غَيْرَ دَاخِلَةٍ
u'غير دَاخِلٌ':Added, #2: 2	غَيْرَ دَاخِلَةٍ
u'غَيْرٌ دَاخِلٌ':Added, #31: 31	غَيْرُ دَاخِلٍ
u'غير دَاخِلٌ':Added, #31: 31	غَيْرُ دَاخِلٍ
u'غَيْرٌ دَاخِلٌ':Added, #3: 3	غَيْرُ دَاخِلَيْنِ
u'غير دَاخِلٌ':Added, #3: 3	غَيْرُ دَاخِلَيْنِ
u'غَيْرٌ دَاخِلٌ':Added, #6: 6	غَيْرَ دَاخِلٍ
u'غير دَاخِلَةٌ':Added, #6: 6	غَيْرَ دَاخِلٍ
u'غَيْرٌ دَاخِلَةٌ':Added, #10: 10	غَيْرُ دَاخِلَةٍ
u'غير دَاخِلَةٌ':Added, #10: 10	غَيْرُ دَاخِلَةٍ
u'غَيْرٌ دَاخِلَةٌ':Added, #1: 1	غَيْرِ دَاخِلَةِ
u'غير دَاخِلَةٌ':Added, #1: 1	غَيْرِ دَاخِلَةِ
u'غَيْرٌ دَاخِلَةٌ':Added, #2: 2	غَيْرَ دَاخِلَةٍ
u'غير دَارٌ':Added, #2: 2	غَيْرَ دَاخِلَةٍ
u'غَيْرٌ دَارٌ':Added, #10: 10	غَيْرِ دَارِ
u'غير دَارٌ':Added, #10: 10	غَيْرِ دَارِ
u'غَيْرٌ دَارٌ':Added, #1: 1	غَيْرَ الدَّارِ
u'غير دَارٌ':Added, #1: 1	غَيْرَ الدَّارِ
u'غَيْرٌ دَارٌ':Added, #1: 1	غَيْرِ دَارٍ
u'غير دَارٌ':Added, #1: 1	غَيْرِ دَارٍ
u'غَيْرٌ دَارٌ':Added, #1: 1	غَيْرَ دَارِهِ
u'غير دَارٌ':Added, #1: 1	غَيْرَ دَارِهِ
u'غَيْرٌ دَارٌ':Added, #2: 2	غَيْرِ دَارِهِ
u'غير دَارٌ':Added, #2: 2	غَيْرِ دَارِهِ
u'غَيْرٌ دَارٌ':Added, #3: 3	غَيْرِ الدَّارِ
u'غير دَارٌ':Added, #3: 3	غَيْرِ الدَّارِ
u'غَيْرٌ دَارٌ':Added, #3: 3	غَيْرَ دَارِ
u'غير دَارٌ':Added, #3: 3	غَيْرَ دَارِ
u'غَيْرٌ دَارٌ':Added, #4: 4	غَيْرُ الدَّارِ
u'غير دَاعِي':Added, #4: 4	غَيْرُ الدَّارِ
u'غير دَاعِي':Added, #2: 2	غَيْرُ دَاعِيَةٍ
u'غَيْرٌ دَاعِي':Added, #2: 2	غَيْرِ دَاعِيَةِ
u'غَيْرٌ دَاعِي':Added, #2: 2	غَيْرُ دَاعِيَةٍ
u'غير دَاعِي':Added, #2: 2	غَيْرِ دَاعِيَةِ
u'غَيْرٌ دَاعِي':Added, #3: 3	غَيْرِ الدَّاعِيَةِ
u'غير دَافِعٌ':Added, #3: 3	غَيْرِ الدَّاعِيَةِ
u'غير دَافِعٌ':Added, #1: 1	غَيْرَ دَافِعٍ
u'غَيْرٌ دَافِعٌ':Added, #1: 1	غَيْرِ دَافِعٍ
u'غَيْرٌ دَافِعٌ':Added, #1: 1	غَيْرَ دَافِعٍ
u'غير دَافِعٌ':Added, #1: 1	غَيْرِ دَافِعٍ
u'غَيْرٌ دَافِعٌ':Added, #8: 8	غَيْرُ دَافِعٍ
u'غير دَافِقٌ':Added, #8: 8	غَيْرُ دَافِعٍ
u'غَيْرٌ دَافِقٌ':Added, #1: 1	غَيْرَ دَافِقٍ
u'غير دَالَّةٌ':Added, #1: 1	غَيْرَ دَافِقٍ
u'غَيْرٌ دَالَّةٌ':Added, #2: 2	غَيْرُ دَالَّةٍ
u'غير دَائِمٌ':Added, #2: 2	غَيْرُ دَالَّةٍ
u'غَيْرٌ دَائِمٌ':Added, #1: 1	غَيْرِ الدَّائِمِ
u'غير دَائِمٌ':Added, #1: 1	غَيْرِ الدَّائِمِ
u'غَيْرٌ دَائِمٌ':Added, #1: 1	غَيْرُ دَائِمِ
u'غير دَائِمٌ':Added, #1: 1	غَيْرُ دَائِمِ
u'غَيْرٌ دَائِمٌ':Added, #1: 1	غَيْرُ دَائِمَةٍ
u'غير دَائِمٌ':Added, #1: 1	غَيْرُ دَائِمَةٍ
u'غَيْرٌ دَائِمٌ':Added, #2: 2	غَيْرَ دَائِمٍ
u'غير دَائِنٌ':Added, #2: 2	غَيْرَ دَائِمٍ
u'غير دَائِنٌ':Added, #1: 1	غَيْرُ الدَّائِنِ
u'غَيْرٌ دَائِنٌ':Added, #1: 1	غَيْرِ الدَّائِنِ
u'غَيْرٌ دَائِنٌ':Added, #1: 1	غَيْرُ الدَّائِنِ
u'غير دِبَاغٌ':Added, #1: 1	غَيْرِ الدَّائِنِ
u'غَيْرٌ دِبَاغٌ':Added, #1: 1	غَيْرَ دِبَاغٍ
u'غير دُبُرٌ':Added, #1: 1	غَيْرَ دِبَاغٍ
u'غَيْرٌ دُبُرٌ':Added, #1: 1	غَيْرِ الدُّبُرِ
u'غير دُبُرٌ':Added, #1: 1	غَيْرِ الدُّبُرِ
u'غَيْرٌ دُبُرٌ':Added, #1: 1	غَيْرَ دُبُرِهِ
u'غير دُخُولٌ':Added, #1: 1	غَيْرَ دُبُرِهِ
u'غَيْرٌ دُخُولٌ':Added, #1: 1	غَيْرِ الدُّخُولِ
u'غير دُخُولٌ':Added, #1: 1	غَيْرِ الدُّخُولِ
u'غَيْرٌ دُخُولٌ':Added, #1: 1	غَيْرَ دُخُولِ
u'غير دُخُولٌ':Added, #1: 1	غَيْرَ دُخُولِ
u'غَيْرٌ دُخُولٌ':Added, #3: 3	غَيْرُ الدُّخُولِ
u'غير دُخُولٌ':Added, #3: 3	غَيْرُ الدُّخُولِ
u'غَيْرٌ دُخُولٌ':Added, #3: 3	غَيْرِ دُخُولِ
u'غير دُخُولٌ':Added, #3: 3	غَيْرِ دُخُولِ
u'غَيْرٌ دُخُولٌ':Added, #5: 5	غَيْرِ دُخُولٍ
u'غير دَرَاهِمُ':Added, #5: 5	غَيْرِ دُخُولٍ
u'غَيْرٌ دَرَاهِمُ':Added, #5: 5	غَيْرِ الدَّرَاهِمِ
u'غير دَرَاهِمُ':Added, #5: 5	غَيْرِ الدَّرَاهِمِ
u'غَيْرٌ دَرَاهِمُ':Added, #6: 6	غَيْرُ الدَّرَاهِمِ
u'غير دَرَاهِمُ':Added, #6: 6	غَيْرُ الدَّرَاهِمِ
u'غَيْرٌ دَرَاهِمُ':Added, #9: 9	غَيْرَ الدَّرَاهِمِ
u'غير دَرْبٌ':Added, #9: 9	غَيْرَ الدَّرَاهِمِ
u'غَيْرٌ دَرْبٌ':Added, #1: 1	غَيْرِ الدَّرْبِ
u'غير درجة':Added, #1: 1	غَيْرِ الدَّرْبِ
u'غَيْرٌ درجة':Added, #1: 1	غَيْرِ الدَّرَجَةِ
u'غير دَرَجَةٌ':Added, #1: 1	غَيْرِ الدَّرَجَةِ
u'غَيْرٌ دَرَجَةٌ':Added, #1: 1	غَيْرِ الدَّرَجَةِ
u'غير درجة':Added, #1: 1	غَيْرِ الدَّرَجَةِ
u'غَيْرٌ درجة':Added, #1: 1	غَيْرِ دَرَجَةٍ
u'غير دَرَجَةٌ':Added, #1: 1	غَيْرِ دَرَجَةٍ
u'غَيْرٌ دَرَجَةٌ':Added, #1: 1	غَيْرِ دَرَجَةٍ
u'غير دَرَكٌ':Added, #1: 1	غَيْرِ دَرَجَةٍ
u'غَيْرٌ دَرَكٌ':Added, #1: 1	غَيْرِ دَرَكٍ
u'غير دِرْهَمٌ':Added, #1: 1	غَيْرِ دَرَكٍ
u'غير دِرْهَم':Added, #1: 1	غَيْرَ دِرْهَمٍ
u'غَيْرٌ دِرْهَمٌ':Added, #1: 1	غَيْرَ دِرْهَمٍ
u'غَيْرٌ دِرْهَم':Added, #1: 1	غَيْرَ دِرْهَمٍ
u'غير دِرْهَمٌ':Added, #1: 1	غَيْرَ دِرْهَمٍ
u'غير دِرْهَم':Added, #2: 2	غَيْرُ دِرْهَمَيْنِ
u'غَيْرٌ دِرْهَمٌ':Added, #2: 2	غَيْرُ دِرْهَمَيْنِ
u'غَيْرٌ دِرْهَم':Added, #2: 2	غَيْرُ دِرْهَمَيْنِ
u'غير دِرْهَمٌ':Added, #2: 2	غَيْرُ دِرْهَمَيْنِ
u'غير دِرْهَم':Added, #3: 3	غَيْرَ دِرْهَمَيْنِ
u'غَيْرٌ دِرْهَمٌ':Added, #3: 3	غَيْرَ دِرْهَمَيْنِ
u'غَيْرٌ دِرْهَم':Added, #3: 3	غَيْرَ دِرْهَمَيْنِ
u'غير دِرْهَمٌ':Added, #3: 3	غَيْرَ دِرْهَمَيْنِ
u'غير دِرْهَم':Added, #5: 5	غَيْرُ دِرْهَمٍ
u'غَيْرٌ دِرْهَمٌ':Added, #5: 5	غَيْرُ دِرْهَمٍ
u'غَيْرٌ دِرْهَم':Added, #5: 5	غَيْرُ دِرْهَمٍ
u'غير دُعَاءٌ':Added, #5: 5	غَيْرُ دِرْهَمٍ
u'غَيْرٌ دُعَاءٌ':Added, #1: 1	غَيْرَ الدُّعَاءِ
u'غير دُعَاءٌ':Added, #1: 1	غَيْرَ الدُّعَاءِ
u'غير دُعَاءٌ':Added, #1: 1	غَيْرُ دُعَاءٍ
u'غَيْرٌ دُعَاءٌ':Added, #1: 1	غَيْرُ دُعَاءِ
u'غَيْرٌ دُعَاءٌ':Added, #1: 1	غَيْرُ دُعَاءٍ
u'غير دُعَاءٌ':Added, #1: 1	غَيْرُ دُعَاءِ
u'غَيْرٌ دُعَاءٌ':Added, #2: 2	غَيْرِ دُعَاءٍ
u'غير دَعْوَةٌ':Added, #2: 2	غَيْرِ دُعَاءٍ
u'غَيْرٌ دَعْوَةٌ':Added, #1: 1	غَيْرِ دَعْوَتِهِ
u'غير دَعْوَةٌ':Added, #1: 1	غَيْرِ دَعْوَتِهِ
u'غَيْرٌ دَعْوَةٌ':Added, #20: 20	غَيْرِ دَعْوَةٍ
u'غير دُفٌّ':Added, #20: 20	غَيْرِ دَعْوَةٍ
u'غَيْرٌ دُفٌّ':Added, #1: 1	غَيْرَ الدُّفِّ
u'غير دفاء':Added, #1: 1	غَيْرَ الدُّفِّ
u'غَيْرٌ دفاء':Added, #1: 1	غَيْرَ دِفَاءِ
u'غير دَفْعٌ':Added, #1: 1	غَيْرَ دِفَاءِ
u'غَيْرٌ دَفْعٌ':Added, #1: 1	غَيْرِ دَفْعٍ
u'غير دفع':Added, #1: 1	غَيْرِ دَفْعٍ
u'غَيْرٌ دفع':Added, #1: 1	غَيْرِ دَفْعِهِ
u'غير دَفْعٌ':Added, #1: 1	غَيْرِ دَفْعِهِ
u'غَيْرٌ دَفْعٌ':Added, #1: 1	غَيْرِ دَفْعِهِ
u'غير دفع':Added, #1: 1	غَيْرِ دَفْعِهِ
u'غَيْرٌ دفع':Added, #4: 4	غَيْرِ دَفْعِ
u'غير دَفْعٌ':Added, #4: 4	غَيْرِ دَفْعِ
u'غَيْرٌ دَفْعٌ':Added, #4: 4	غَيْرِ دَفْعِ
u'غير دَفْق':Added, #4: 4	غَيْرِ دَفْعِ
u'غَيْرٌ دَفْق':Added, #2: 2	غَيْرِ دَفْقٍ
u'غير دفن':Added, #2: 2	غَيْرِ دَفْقٍ
u'غَيْرٌ دفن':Added, #1: 1	غَيْرِ الدَّفْنِ
u'غير دَفْنٌ':Added, #1: 1	غَيْرِ الدَّفْنِ
u'غَيْرٌ دَفْنٌ':Added, #1: 1	غَيْرِ الدَّفْنِ
u'غير دَقيقٌ':Added, #1: 1	غَيْرِ الدَّفْنِ
u'غَيْرٌ دَقيقٌ':Added, #1: 1	غَيْرُ الدَّقِيقِ
u'غير دَقيقٌ':Added, #1: 1	غَيْرُ الدَّقِيقِ
u'غَيْرٌ دَقيقٌ':Added, #1: 1	غَيْرِ الدَّقِيقَةِ
u'غير دَقيقَةٌ':Added, #1: 1	غَيْرِ الدَّقِيقَةِ
u'غَيْرٌ دَقيقَةٌ':Added, #1: 1	غَيْرِ الدَّقِيقَةِ
u'غير دَكَّةٌ':Added, #1: 1	غَيْرِ الدَّقِيقَةِ
u'غَيْرٌ دَكَّةٌ':Added, #1: 1	غَيْرُ الدَّكَّةِ
u'غير دَلالَةٌ':Added, #1: 1	غَيْرُ الدَّكَّةِ
u'غَيْرٌ دَلالَةٌ':Added, #14: 14	غَيْرِ دَلَالَةٍ
u'غير دَلالَةٌ':Added, #14: 14	غَيْرِ دَلَالَةٍ
u'غَيْرٌ دَلالَةٌ':Added, #2: 2	غَيْرُ الدَّلَالَةِ
u'غير دُلوكٌ':Added, #2: 2	غَيْرُ الدَّلَالَةِ
u'غَيْرٌ دُلوكٌ':Added, #1: 1	غَيْرُ الدُّلُوكِ
u'غير دَليلٌ':Added, #1: 1	غَيْرُ الدُّلُوكِ
u'غير دَليلٌ':Added, #1: 1	غَيْرُ الدَّلِيلِ
u'غَيْرٌ دَليلٌ':Added, #1: 1	غَيْرِ الدَّلِيلِ
u'غَيْرٌ دَليلٌ':Added, #1: 1	غَيْرُ الدَّلِيلِ
u'غير دَليلٌ':Added, #1: 1	غَيْرِ الدَّلِيلِ
u'غَيْرٌ دَليلٌ':Added, #1: 1	غَيْرَ دَلِيلِ
u'غير دَليلٌ':Added, #1: 1	غَيْرَ دَلِيلِ
u'غَيْرٌ دَليلٌ':Added, #2: 2	غَيْرَ الدَّلِيلِ
u'غير دَليلٌ':Added, #2: 2	غَيْرَ الدَّلِيلِ
u'غَيْرٌ دَليلٌ':Added, #2: 2	غَيْرُ دَلِيلِ
u'غير دَليلٌ':Added, #2: 2	غَيْرُ دَلِيلِ
u'غَيْرٌ دَليلٌ':Added, #3: 3	غَيْرِ دَلِيلِ
u'غير دَمٌ':Added, #3: 3	غَيْرِ دَلِيلِ
u'غير دَمٌ':Added, #1: 1	غَيْرُ دَمِ
u'غَيْرٌ دَمٌ':Added, #1: 1	غَيْرِ دَمِ
u'غَيْرٌ دَمٌ':Added, #1: 1	غَيْرُ دَمِ
u'غير دَمٌ':Added, #1: 1	غَيْرِ دَمِ
u'غير دَمٌ':Added, #2: 2	غَيْرَ الدَّمِ
u'غَيْرٌ دَمٌ':Added, #2: 2	غَيْرِ الدَّمِ
u'غَيْرٌ دَمٌ':Added, #2: 2	غَيْرَ الدَّمِ
u'غير دَمٌ':Added, #2: 2	غَيْرِ الدَّمِ
u'غَيْرٌ دَمٌ':Added, #2: 2	غَيْرَ دَمِ
u'غير دَمٌ':Added, #2: 2	غَيْرَ دَمِ
u'غَيْرٌ دَمٌ':Added, #4: 4	غَيْرُ الدَّمِ
u'غير دَمٌ':Added, #4: 4	غَيْرُ الدَّمِ
u'غَيْرٌ دَمٌ':Added, #7: 7	غَيْرِ دَمٍ
u'غير دَناءةٌ':Added, #7: 7	غَيْرِ دَمٍ
u'غَيْرٌ دَناءةٌ':Added, #1: 1	غَيْرَ دَنَاءَةِ
u'غير دَنانيرُ':Added, #1: 1	غَيْرَ دَنَاءَةِ
u'غَيْرٌ دَنانيرُ':Added, #1: 1	غَيْرِ الدَّنَانِيرِ
u'غير دَهْشَةٌ':Added, #1: 1	غَيْرِ الدَّنَانِيرِ
u'غَيْرٌ دَهْشَةٌ':Added, #1: 1	غَيْرِ دَهْشَةٍ
u'غير دُهْنٌ':Added, #1: 1	غَيْرِ دَهْشَةٍ
u'غَيْرٌ دُهْنٌ':Added, #1: 1	غَيْرُ دُهْنِ
u'غير دُهْنٌ':Added, #1: 1	غَيْرُ دُهْنِ
u'غَيْرٌ دُهْنٌ':Added, #5: 5	غَيْرِ الدُّهْنِ
u'غير دَوَابُّ':Added, #5: 5	غَيْرِ الدُّهْنِ
u'غَيْرٌ دَوَابُّ':Added, #1: 1	غَيْرِ الدَّوَابِّ
u'غير دَوَابُّ':Added, #1: 1	غَيْرِ الدَّوَابِّ
u'غَيْرٌ دَوَابُّ':Added, #2: 2	غَيْرِ دَوَابِّ
u'غير دَوامٌ':Added, #2: 2	غَيْرِ دَوَابِّ
u'غَيْرٌ دَوامٌ':Added, #1: 1	غَيْرِ دَوَامٍ
u'غير دُورٌ':Added, #1: 1	غَيْرِ دَوَامٍ
u'غَيْرٌ دُورٌ':Added, #1: 1	غَيْرِ دُورِ
u'غير دِيانَةٌ':Added, #1: 1	غَيْرِ دُورِ
u'غَيْرٌ دِيانَةٌ':Added, #1: 1	غَيْرِ الدِّيَانَةِ
u'غير دِيانَةٌ':Added, #1: 1	غَيْرِ الدِّيَانَةِ
u'غَيْرٌ دِيانَةٌ':Added, #1: 1	غَيْرِ دِيَانَةٍ
u'غير دِيَةٌ':Added, #1: 1	غَيْرِ دِيَانَةٍ
u'غَيْرٌ دِيَةٌ':Added, #1: 1	غَيْرِ دِيَةٍ
u'غير دِيَةٌ':Added, #1: 1	غَيْرِ دِيَةٍ
u'غَيْرٌ دِيَةٌ':Added, #2: 2	غَيْرِ الدِّيَةِ
u'غير دِيَةٌ':Added, #2: 2	غَيْرِ الدِّيَةِ
u'غَيْرٌ دِيَةٌ':Added, #2: 2	غَيْرُ دِيَةِ
u'غَيَّرَ دِينٌ':Predicate, #2: 2	غَيْرُ دِيَةِ
u'غير دِينٌ':Added, #1: 1	غَيَّرَ دِينَ
u'غَيْرٌ دِينٌ':Added, #17: 17	غَيْرِ دِينِ
u'غير دِينٌ':Added, #17: 17	غَيْرِ دِينِ
u'غير دِينٌ':Added, #1: 1	غَيْرَ الدِّينِ
u'غَيْرٌ دِينٌ':Added, #1: 1	غَيْرِ الدِّينِ
u'غَيْرٌ دِينٌ':Added, #1: 1	غَيْرَ الدِّينِ
u'غير دِينٌ':Added, #1: 1	غَيْرِ الدِّينِ
u'غير دِينٌ':Added, #1: 1	غَيْرَ دِينِ
u'غير دَيْنٌ':Added, #1: 1	غَيْرُ دِينِ
u'غير دَيْنٌ':Added, #1: 1	غَيْرُ دَيْنِ
u'غَيْرٌ دِينٌ':Added, #1: 1	غَيْرِ دَيْنٍ
u'غَيْرٌ دِينٌ':Added, #1: 1	غَيْرَ دِينِ
u'غَيْرٌ دَيْنٌ':Added, #1: 1	غَيْرُ دِينِ
u'غَيْرٌ دَيْنٌ':Added, #1: 1	غَيْرُ دَيْنِ
u'غير دَيْنٌ':Added, #1: 1	غَيْرِ دَيْنٍ
u'غَيْرٌ دَيْنٌ':Added, #2: 2	غَيْرِ الدَّيْنِ
u'غير دَيْنٌ':Added, #2: 2	غَيْرِ الدَّيْنِ
u'غَيْرٌ دَيْنٌ':Added, #3: 3	غَيْرَ الدَّيْنِ
u'غير دَيْنٌ':Added, #3: 3	غَيْرَ الدَّيْنِ
u'غَيْرٌ دَيْنٌ':Added, #3: 3	غَيْرَ دَيْنِ
u'غير دَيْنٌ':Added, #3: 3	غَيْرَ دَيْنِ
u'غَيْرٌ دَيْنٌ':Added, #6: 6	غَيْرِ دَيْنِ
u'غير دِينٌ':Added, #6: 6	غَيْرِ دَيْنِ
u'غَيْرٌ دِينٌ':Added, #6: 6	غَيْرِ دِينِهِ
u'غير دَيْنٌ':Added, #6: 6	غَيْرِ دِينِهِ
u'غَيْرٌ دَيْنٌ':Added, #7: 7	غَيْرُ الدَّيْنِ
u'غير دِينارٌ':Added, #7: 7	غَيْرُ الدَّيْنِ
u'غَيْرٌ دِينارٌ':Added, #2: 2	غَيْرَ الدِّينَارِ
u'غير دُيونٌ':Added, #2: 2	غَيْرَ الدِّينَارِ
u'غَيْرٌ دُيونٌ':Added, #1: 1	غَيْرِ الدُّيُونِ
u'غير ذاتِيٌّ':Added, #1: 1	غَيْرِ الدُّيُونِ
u'غَيْرٌ ذاتِيٌّ':Added, #1: 1	غَيْرُ ذَاتِيٍّ
u'غير ذاتِيٌّ':Added, #1: 1	غَيْرُ ذَاتِيٍّ
u'غير ذاتِيٌّ':Added, #1: 1	غَيْرَ ذَاتِيَّةٍ
u'غَيْرٌ ذاتِيٌّ':Added, #1: 1	غَيْرُ ذَاتِيَّةٍ
u'غَيْرٌ ذاتِيٌّ':Added, #1: 1	غَيْرَ ذَاتِيَّةٍ
u'غير ذاكِرٌ':Added, #1: 1	غَيْرُ ذَاتِيَّةٍ
u'غَيْرٌ ذاكِرٌ':Added, #2: 2	غَيْرَ ذَاكِرٍ
u'غير ذاكِرٌ':Added, #2: 2	غَيْرَ ذَاكِرٍ
u'غَيْرٌ ذاكِرٌ':Added, #4: 4	غَيْرُ ذَاكِرٍ
u'غير ذِراعٌ':Added, #4: 4	غَيْرُ ذَاكِرٍ
u'غَيْرٌ ذِراعٌ':Added, #1: 1	غَيْرُ ذِرَاعَيْنِ
u'غير ذَكاةٌ':Added, #1: 1	غَيْرُ ذِرَاعَيْنِ
u'غَيْرٌ ذَكاةٌ':Added, #1: 1	غَيْرِ الذَّكَاةِ
u'غير ذَكاةٌ':Added, #1: 1	غَيْرِ الذَّكَاةِ
u'غَيْرٌ ذَكاةٌ':Added, #4: 4	غَيْرِ ذَكَاةٍ
u'غير ذكر':Added, #4: 4	غَيْرِ ذَكَاةٍ
u'غَيْرٌ ذكر':Added, #114: 114	غَيْرِ ذِكْرِ
u'غير ذِكْرٌ':Added, #114: 114	غَيْرِ ذِكْرِ
u'غَيْرٌ ذِكْرٌ':Added, #114: 114	غَيْرِ ذِكْرِ
u'غير ذكر':Added, #114: 114	غَيْرِ ذِكْرِ
u'غَيْرٌ ذكر':Added, #1: 1	غَيْرُ الذَّكَرِ
u'غير ذَكَرٌ':Added, #1: 1	غَيْرُ الذَّكَرِ
u'غَيْرٌ ذَكَرٌ':Added, #1: 1	غَيْرُ الذَّكَرِ
u'غير ذكر':Added, #1: 1	غَيْرُ الذَّكَرِ
u'غير ذكر':Added, #1: 1	غَيْرَ ذِكْرِ
u'غَيْرٌ ذكر':Added, #1: 1	غَيْرُ ذِكْرِ
u'غَيْرٌ ذكر':Added, #1: 1	غَيْرَ ذِكْرِ
u'غير ذِكْرٌ':Added, #1: 1	غَيْرُ ذِكْرِ
u'غير ذِكْرٌ':Added, #1: 1	غَيْرَ ذِكْرٍ
u'غير ذِكْرٌ':Added, #1: 1	غَيْرَ ذِكْرِ
u'غَيْرٌ ذِكْرٌ':Added, #1: 1	غَيْرُ ذِكْرِ
u'غَيْرٌ ذِكْرٌ':Added, #1: 1	غَيْرَ ذِكْرٍ
u'غَيْرٌ ذِكْرٌ':Added, #1: 1	غَيْرَ ذِكْرِ
u'غير ذكر':Added, #1: 1	غَيْرُ ذِكْرِ
u'غَيْرٌ ذكر':Added, #1: 1	غَيْرِ ذَكَرِهِ
u'غير ذَكَرٌ':Added, #1: 1	غَيْرِ ذَكَرِهِ
u'غَيْرٌ ذَكَرٌ':Added, #1: 1	غَيْرِ ذَكَرِهِ
u'غير ذكر':Added, #1: 1	غَيْرِ ذَكَرِهِ
u'غير ذكر':Added, #2: 2	غَيْرَ الذِّكْرِ
u'غَيْرٌ ذكر':Added, #2: 2	غَيْرِ الذِّكْرِ
u'غَيْرٌ ذكر':Added, #2: 2	غَيْرَ الذِّكْرِ
u'غير ذِكْرٌ':Added, #2: 2	غَيْرِ الذِّكْرِ
u'غير ذِكْرٌ':Added, #2: 2	غَيْرَ الذِّكْرِ
u'غَيْرٌ ذِكْرٌ':Added, #2: 2	غَيْرِ الذِّكْرِ
u'غَيْرٌ ذِكْرٌ':Added, #2: 2	غَيْرَ الذِّكْرِ
u'غير ذكر':Added, #2: 2	غَيْرِ الذِّكْرِ
u'غَيْرٌ ذكر':Added, #3: 3	غَيْرِ ذِكْرِهِ
u'غير ذِكْرٌ':Added, #3: 3	غَيْرِ ذِكْرِهِ
u'غَيْرٌ ذِكْرٌ':Added, #3: 3	غَيْرِ ذِكْرِهِ
u'غير ذكر':Added, #3: 3	غَيْرِ ذِكْرِهِ
u'غَيْرٌ ذكر':Added, #4: 4	غَيْرُ الذِّكْرِ
u'غير ذِكْرٌ':Added, #4: 4	غَيْرُ الذِّكْرِ
u'غَيْرٌ ذِكْرٌ':Added, #4: 4	غَيْرُ الذِّكْرِ
u'غير ذِكْرٌ':Added, #4: 4	غَيْرُ الذِّكْرِ
u'غَيْرٌ ذِكْرٌ':Added, #66: 66	غَيْرِ ذِكْرٍ
u'غير ذَكَرٌ':Added, #66: 66	غَيْرِ ذِكْرٍ
u'غَيْرٌ ذَكَرٌ':Added, #6: 6	غَيْرِ ذَكَرٍ
u'غير ذُكورٌ':Added, #6: 6	غَيْرِ ذَكَرٍ
u'غَيْرٌ ذُكورٌ':Added, #1: 1	غَيْرَ ذُكُورٍ
u'غير ذَكِيٌّ':Added, #1: 1	غَيْرَ ذُكُورٍ
u'غير ذَكِيٌّ':Added, #1: 1	غَيْرَ ذَكِيٍّ
u'غير ذَكِيٌّ':Added, #1: 1	غَيْرُ ذَكِيٍّ
u'غَيْرٌ ذَكِيٌّ':Added, #1: 1	غَيْرِ ذَكِيٍّ
u'غَيْرٌ ذَكِيٌّ':Added, #1: 1	غَيْرَ ذَكِيٍّ
u'غَيْرٌ ذَكِيٌّ':Added, #1: 1	غَيْرُ ذَكِيٍّ
u'غير ذِلَّة':Added, #1: 1	غَيْرِ ذَكِيٍّ
u'غَيْرٌ ذِلَّة':Added, #1: 1	غَيْرِ ذِلَّةٍ
u'غير ذَمٌّ':Added, #1: 1	غَيْرِ ذِلَّةٍ
u'غَيْرٌ ذَمٌّ':Added, #1: 1	غَيْرِ ذَمٍّ
u'غير ذِمِّيٌّ':Added, #1: 1	غَيْرِ ذَمٍّ
u'غَيْرٌ ذِمِّيٌّ':Added, #1: 1	غَيْرِ الذِّمِّيِّ
u'غير ذِمِّيٌّ':Added, #1: 1	غَيْرِ الذِّمِّيِّ
u'غَيْرٌ ذِمِّيٌّ':Added, #2: 2	غَيْرَ ذِمِّيٍّ
u'غير ذَمِيمٌ':Added, #2: 2	غَيْرَ ذِمِّيٍّ
u'غَيْرٌ ذَمِيمٌ':Added, #1: 1	غَيْرَ ذَمِيمِ
u'غير ذَنْبٌ':Added, #1: 1	غَيْرَ ذَمِيمِ
u'غَيْرٌ ذَنْبٌ':Added, #3: 3	غَيْرِ ذَنْبٍ
u'غير ذَهَابٌ':Added, #3: 3	غَيْرِ ذَنْبٍ
u'غَيْرٌ ذَهَابٌ':Added, #1: 1	غَيْرِ ذَهَابِ
u'غير ذَهَبٌ':Added, #1: 1	غَيْرِ ذَهَابِ
u'غَيْرٌ ذَهَبٌ':Added, #1: 1	غَيْرُ الذَّهَبِ
u'غير ذَهَبٌ':Added, #1: 1	غَيْرُ الذَّهَبِ
u'غَيْرٌ ذَهَبٌ':Added, #2: 2	غَيْرَ الذَّهَبِ
u'غير ذَهَبٌ':Added, #2: 2	غَيْرَ الذَّهَبِ
u'غَيْرٌ ذَهَبٌ':Added, #2: 2	غَيْرَ ذَهَبٍ
u'غير ذَهَبٌ':Added, #2: 2	غَيْرَ ذَهَبٍ
u'غَيْرٌ ذَهَبٌ':Added, #4: 4	غَيْرِ ذَهَبٍ
u'غير ذَهَبٌ':Added, #4: 4	غَيْرِ ذَهَبٍ
u'غَيْرٌ ذَهَبٌ':Added, #8: 8	غَيْرِ الذَّهَبِ
u'غير رَابِحٌ':Added, #8: 8	غَيْرِ الذَّهَبِ
u'غَيْرٌ رَابِحٌ':Added, #1: 1	غَيْرَ رَابِحَةٍ
u'غير رَابِطٌ':Added, #1: 1	غَيْرَ رَابِحَةٍ
u'غَيْرٌ رَابِطٌ':Added, #1: 1	غَيْرِ رَابِطٍ
u'غير رَاتِبٌ':Added, #1: 1	غَيْرِ رَابِطٍ
u'غير رَاتِب':Added, #1: 1	غَيْرِ الرَّاتِبِ
u'غَيْرٌ رَاتِبٌ':Added, #1: 1	غَيْرِ الرَّاتِبِ
u'غَيْرٌ رَاتِب':Added, #1: 1	غَيْرِ الرَّاتِبِ
u'غير راتِب':Added, #1: 1	غَيْرِ الرَّاتِبِ
u'غير راتِب':Added, #1: 1	غَيْرَ الرَّاتِبَةِ
u'غير راتِب':Added, #1: 1	غَيْرُ الرَّاتِبَةِ
u'غَيْرٌ راتِب':Added, #1: 1	غَيْرِ الرَّاتِبَةِ
u'غَيْرٌ راتِب':Added, #1: 1	غَيْرَ الرَّاتِبَةِ
u'غَيْرٌ راتِب':Added, #1: 1	غَيْرُ الرَّاتِبَةِ
u'غير رَاتِبٌ':Added, #1: 1	غَيْرِ الرَّاتِبَةِ
u'غير رَاتِب':Added, #1: 1	غَيْرَ رَاتِبٍ
u'غَيْرٌ رَاتِبٌ':Added, #1: 1	غَيْرَ رَاتِبٍ
u'غَيْرٌ رَاتِب':Added, #1: 1	غَيْرَ رَاتِبٍ
u'غير راتِب':Added, #1: 1	غَيْرَ رَاتِبٍ
u'غير راتِب':Added, #1: 1	غَيْرَ رَاتِبَةٍ
u'غَيْرٌ راتِب':Added, #1: 1	غَيْرُ رَاتِبَةٍ
u'غَيْرٌ راتِب':Added, #1: 1	غَيْرَ رَاتِبَةٍ
u'غير رَاتِبٌ':Added, #1: 1	غَيْرُ رَاتِبَةٍ
u'غير رَاتِب':Added, #3: 3	غَيْرُ رَاتِبٍ
u'غَيْرٌ رَاتِبٌ':Added, #3: 3	غَيْرُ رَاتِبٍ
u'غَيْرٌ رَاتِب':Added, #3: 3	غَيْرُ رَاتِبٍ
u'غير رَاجِحٌ':Added, #3: 3	غَيْرُ رَاتِبٍ
u'غَيْرٌ رَاجِحٌ':Added, #1: 1	غَيْرِ الرَّاجِحِ
u'غير رَاجِحٌ':Added, #1: 1	غَيْرِ الرَّاجِحِ
u'غَيْرٌ رَاجِحٌ':Added, #1: 1	غَيْرُ رَاجِحِ
u'غير رَاجِحٌ':Added, #1: 1	غَيْرُ رَاجِحِ
u'غَيْرٌ رَاجِحٌ':Added, #2: 2	غَيْرَ رَاجِحٍ
u'غير رَاجِحٌ':Added, #2: 2	غَيْرَ رَاجِحٍ
u'غَيْرٌ رَاجِحٌ':Added, #2: 2	غَيْرَ رَاجِحِهِ
u'غير رَاجِعٌ':Added, #2: 2	غَيْرَ رَاجِحِهِ
u'غَيْرٌ رَاجِعٌ':Added, #1: 1	غَيْرُ الرَّاجِعِ
u'غير رَاجِعٌ':Added, #1: 1	غَيْرُ الرَّاجِعِ
u'غَيْرٌ رَاجِعٌ':Added, #1: 1	غَيْرُ رَاجِعٍ
u'غير رَاحِلٌ':Added, #1: 1	غَيْرُ رَاجِعٍ
u'غَيْرٌ رَاحِلٌ':Added, #2: 2	غَيْرِ الرَّاحِلَةِ
u'غير رَاحِلَةٌ':Added, #2: 2	غَيْرِ الرَّاحِلَةِ
u'غَيْرٌ رَاحِلَةٌ':Added, #2: 2	غَيْرِ الرَّاحِلَةِ
u'غير رَأْسٌ':Added, #2: 2	غَيْرِ الرَّاحِلَةِ
u'غير رَأْسٌ':Added, #1: 1	غَيْرُ رَأْسِ
u'غَيْرٌ رَأْسٌ':Added, #1: 1	غَيْرِ رَأْسِ
u'غَيْرٌ رَأْسٌ':Added, #1: 1	غَيْرُ رَأْسِ
u'غير رَأْسٌ':Added, #1: 1	غَيْرِ رَأْسِ
u'غَيْرٌ رَأْسٌ':Added, #1: 1	غَيْرَ رَأْسِهِ
u'غير رَأْسٌ':Added, #1: 1	غَيْرَ رَأْسِهِ
u'غَيْرٌ رَأْسٌ':Added, #2: 2	غَيْرُ الرَّأْسِ
u'غير رَأْسٌ':Added, #2: 2	غَيْرُ الرَّأْسِ
u'غَيْرٌ رَأْسٌ':Added, #4: 4	غَيْرَ الرَّأْسِ
u'غير رَأْسٌ':Added, #4: 4	غَيْرَ الرَّأْسِ
u'غَيْرٌ رَأْسٌ':Added, #8: 8	غَيْرِ الرَّأْسِ
u'غير رَاسِخٌ':Added, #8: 8	غَيْرِ الرَّأْسِ
u'غَيْرٌ رَاسِخٌ':Added, #1: 1	غَيْرُ رَاسِخٍ
u'غير رَاعِفٌ':Added, #1: 1	غَيْرُ رَاسِخٍ
u'غَيْرٌ رَاعِفٌ':Added, #1: 1	غَيْرِ الرَّاعِفِ
u'غير رَافِضٌ':Added, #1: 1	غَيْرِ الرَّاعِفِ
u'غَيْرٌ رَافِضٌ':Added, #1: 1	غَيْرُ رَافِضٍ
u'غير رَافِعٌ':Added, #1: 1	غَيْرُ رَافِضٍ
u'غَيْرٌ رَافِعٌ':Added, #3: 3	غَيْرُ رَافِعٍ
u'غير رَافِعٌ':Added, #3: 3	غَيْرُ رَافِعٍ
u'غَيْرٌ رَافِعٌ':Added, #3: 3	غَيْرَ رَافِعَةٍ
u'غير رَافِعَةٌ':Added, #3: 3	غَيْرَ رَافِعَةٍ
u'غَيْرٌ رَافِعَةٌ':Added, #3: 3	غَيْرَ رَافِعَةٍ
u'غير رَاكِبٌ':Added, #3: 3	غَيْرَ رَافِعَةٍ
u'غَيْرٌ رَاكِبٌ':Added, #1: 1	غَيْرَ رَاكِبٍ
u'غير رَاكِعٌ':Added, #1: 1	غَيْرَ رَاكِبٍ
u'غَيْرٌ رَاكِعٌ':Added, #1: 1	غَيْرَ رَاكِعٍ
u'غير رَاهِنٌ':Added, #1: 1	غَيْرَ رَاكِعٍ
u'غَيْرٌ رَاهِنٌ':Added, #2: 2	غَيْرَ الرَّاهِنِ
u'غير رَاهِنٌ':Added, #2: 2	غَيْرَ الرَّاهِنِ
u'غَيْرٌ رَاهِنٌ':Added, #4: 4	غَيْرِ الرَّاهِنِ
u'غير رَاوِي':Added, #4: 4	غَيْرِ الرَّاهِنِ
u'غَيْرٌ رَاوِي':Added, #2: 2	غَيْرِ رَاوِيهِ
u'غير رَأْيٌ':Added, #2: 2	غَيْرِ رَاوِيهِ
u'غَيْرٌ رَأْيٌ':Added, #1: 1	غَيْرُ الرَّأْيِ
u'غير رَأْيٌ':Added, #1: 1	غَيْرُ الرَّأْيِ
u'غير رَأْيٌ':Added, #1: 1	غَيْرِ رَأْيٍ
u'غَيْرٌ رَأْيٌ':Added, #1: 1	غَيْرِ رَأْيِ
u'غَيْرٌ رَأْيٌ':Added, #1: 1	غَيْرِ رَأْيٍ
u'غير رائِجٌ':Added, #1: 1	غَيْرِ رَأْيِ
u'غَيْرٌ رائِجٌ':Added, #3: 3	غَيْرُ رَائِجَةٍ
u'غير رَائِعٌ':Added, #3: 3	غَيْرُ رَائِجَةٍ
u'غير رَائِعٌ':Added, #1: 1	غَيْرُ الرَّائِعَةِ
u'غَيْرٌ رَائِعٌ':Added, #1: 1	غَيْرِ الرَّائِعَةِ
u'غَيْرٌ رَائِعٌ':Added, #1: 1	غَيْرُ الرَّائِعَةِ
u'غير رَائِعٌ':Added, #1: 1	غَيْرِ الرَّائِعَةِ
u'غَيْرٌ رَائِعٌ':Added, #1: 1	غَيْرَ رَائِعَةٍ
u'غير رَبُّ':Added, #1: 1	غَيْرَ رَائِعَةٍ
u'غير رَبُّ':Added, #1: 1	غَيْرُ رَبِّ
u'غَيْرٌ رَبُّ':Added, #1: 1	غَيْرِ رَبِّ
u'غَيْرٌ رَبُّ':Added, #1: 1	غَيْرُ رَبِّ
u'غير رَبُّ':Added, #1: 1	غَيْرِ رَبِّ
u'غَيْرٌ رَبُّ':Added, #2: 2	غَيْرَ رَبِّ
u'غير رَبُّ':Added, #2: 2	غَيْرَ رَبِّ
u'غَيْرٌ رَبُّ':Added, #6: 6	غَيْرِ رَبِّهِ
u'غير رباط':Added, #6: 6	غَيْرِ رَبِّهِ
u'غَيْرٌ رباط':Added, #1: 1	غَيْرُ رِبَاطٍ
u'غير رِبَاطٌ':Added, #1: 1	غَيْرُ رِبَاطٍ
u'غَيْرٌ رِبَاطٌ':Added, #1: 1	غَيْرُ رِبَاطٍ
u'غير رِباعٌ':Added, #1: 1	غَيْرُ رِبَاطٍ
u'غير رِباعٌ':Added, #1: 1	غَيْرُ الرِّبَاعِ
u'غير رِبَاعٌ':Added, #1: 1	غَيْرِ الرِّبَاعِ
u'غير رِبَاعٌ':Added, #1: 1	غَيْرُ الرِّبَاعِ
u'غَيْرٌ رِباعٌ':Added, #1: 1	غَيْرِ الرِّبَاعِ
u'غَيْرٌ رِباعٌ':Added, #1: 1	غَيْرُ الرِّبَاعِ
u'غَيْرٌ رِبَاعٌ':Added, #1: 1	غَيْرِ الرِّبَاعِ
u'غَيْرٌ رِبَاعٌ':Added, #1: 1	غَيْرُ الرِّبَاعِ
u'غير رِبْحٌ':Added, #1: 1	غَيْرِ الرِّبَاعِ
u'غَيْرٌ رِبْحٌ':Added, #1: 1	غَيْرِ رِبْحٍ
u'غير رَبْطٌ':Added, #1: 1	غَيْرِ رِبْحٍ
u'غَيْرٌ رَبْطٌ':Added, #1: 1	غَيْرِ الرَّبْطِ
u'غير رَبْطٌ':Added, #1: 1	غَيْرِ الرَّبْطِ
u'غَيْرٌ رَبْطٌ':Added, #1: 1	غَيْرِ رَبْطِ
u'غير رَبْطٌ':Added, #1: 1	غَيْرِ رَبْطِ
u'غَيْرٌ رَبْطٌ':Added, #4: 4	غَيْرِ رَبْطٍ
u'غير رُبْعٌ':Added, #4: 4	غَيْرِ رَبْطٍ
u'غَيْرٌ رُبْعٌ':Added, #1: 1	غَيْرَ الرُّبْعِ
u'غير رَبْعٌ':Added, #1: 1	غَيْرَ الرُّبْعِ
u'غَيْرٌ رَبْعٌ':Added, #1: 1	غَيْرِ رَبْعٍ
u'غير رِبَوِيّ':Added, #1: 1	غَيْرِ رَبْعٍ
u'غَيْرٌ رِبَوِيّ':Added, #1: 1	غَيْرُ رِبَوِيَّةٍ
u'غير رِبَوِيّ':Added, #1: 1	غَيْرُ رِبَوِيَّةٍ
u'غَيْرٌ رِبَوِيّ':Added, #2: 2	غَيْرِ الرِّبَوِيَّاتِ
u'غير رَبِيعٌ':Added, #2: 2	غَيْرِ الرِّبَوِيَّاتِ
u'غَيْرٌ رَبِيعٌ':Added, #1: 1	غَيْرُ الرَّبِيعِ
u'غير رِجَالٌ':Added, #1: 1	غَيْرُ الرَّبِيعِ
u'غَيْرٌ رِجَالٌ':Added, #1: 1	غَيْرِ رِجَالِهِ
u'غير رَجَبٌ':Added, #1: 1	غَيْرِ رِجَالِهِ
u'غَيْرٌ رَجَبٌ':Added, #2: 2	غَيْرِ رَجَبٍ
u'غير رُجْحانٌ':Added, #2: 2	غَيْرِ رَجَبٍ
u'غَيْرٌ رُجْحانٌ':Added, #3: 3	غَيْرِ رُجْحَانٍ
u'غير رَجْعِيٌّ':Added, #3: 3	غَيْرِ رُجْحَانٍ
u'غَيْرٌ رَجْعِيٌّ':Added, #1: 1	غَيْرِ الرَّجْعِيَّاتِ
u'غير رَجْعِيٌّ':Added, #1: 1	غَيْرِ الرَّجْعِيَّاتِ
u'غَيْرٌ رَجْعِيٌّ':Added, #1: 1	غَيْرِ الرَّجْعِيَّةِ
u'غير رَجْعِيٌّ':Added, #1: 1	غَيْرِ الرَّجْعِيَّةِ
u'غَيْرٌ رَجْعِيٌّ':Added, #1: 1	غَيْرِ رَجْعِيٍّ
u'غير رَجْعِيٌّ':Added, #1: 1	غَيْرِ رَجْعِيٍّ
u'غَيْرٌ رَجْعِيٌّ':Added, #3: 3	غَيْرِ رَجْعِيَّةٍ
u'غير رَجْعِيَّةٌ':Added, #3: 3	غَيْرِ رَجْعِيَّةٍ
u'غَيْرٌ رَجْعِيَّةٌ':Added, #1: 1	غَيْرِ الرَّجْعِيَّاتِ
u'غير رَجْعِيَّةٌ':Added, #1: 1	غَيْرِ الرَّجْعِيَّاتِ
u'غَيْرٌ رَجْعِيَّةٌ':Added, #1: 1	غَيْرِ الرَّجْعِيَّةِ
u'غير رَجْعِيَّةٌ':Added, #1: 1	غَيْرِ الرَّجْعِيَّةِ
u'غَيْرٌ رَجْعِيَّةٌ':Added, #3: 3	غَيْرِ رَجْعِيَّةٍ
u'غير رَجُلٌ':Added, #3: 3	غَيْرِ رَجْعِيَّةٍ
u'غَيْرٌ رَجُلٌ':Added, #1: 1	غَيْرِ الرَّجُلِ
u'غير رِجْلٌ':Added, #1: 1	غَيْرِ الرَّجُلِ
u'غير رِجْلٌ':Added, #1: 1	غَيْرَ الرِّجْلَيْنِ
u'غَيْرٌ رِجْلٌ':Added, #1: 1	غَيْرِ الرِّجْلَيْنِ
u'غَيْرٌ رِجْلٌ':Added, #1: 1	غَيْرَ الرِّجْلَيْنِ
u'غير رَجُلٌ':Added, #1: 1	غَيْرِ الرِّجْلَيْنِ
u'غَيْرٌ رَجُلٌ':Added, #1: 1	غَيْرَ رَجُلَيْنِ
u'غير رَجُلٌ':Added, #1: 1	غَيْرَ رَجُلَيْنِ
u'غَيْرٌ رَجُلٌ':Added, #2: 2	غَيْرِ رَجُلٍ
u'غير رَجُلٌ':Added, #2: 2	غَيْرِ رَجُلٍ
u'غَيْرٌ رَجُلٌ':Added, #4: 4	غَيْرُ رَجُلٍ
u'غير رُجُوعٌ':Added, #4: 4	غَيْرُ رَجُلٍ
u'غَيْرٌ رُجُوعٌ':Added, #11: 11	غَيْرِ رُجُوعٍ
u'غير رُجُوعٌ':Added, #11: 11	غَيْرِ رُجُوعٍ
u'غَيْرٌ رُجُوعٌ':Added, #1: 1	غَيْرُ رُجُوعٍ
u'غير رُجُوعٌ':Added, #1: 1	غَيْرُ رُجُوعٍ
u'غَيْرٌ رُجُوعٌ':Added, #1: 1	غَيْرِ رُجُوعِهِ
u'غير رُجُوعٌ':Added, #1: 1	غَيْرِ رُجُوعِهِ
u'غَيْرٌ رُجُوعٌ':Added, #2: 2	غَيْرِ الرُّجُوعِ
u'غير رَحِمٌ':Added, #2: 2	غَيْرِ الرُّجُوعِ
u'غَيْرٌ رَحِمٌ':Added, #1: 1	غَيْرِ رَحِمٍ
u'غير رُخْصَةٌ':Added, #1: 1	غَيْرِ رَحِمٍ
u'غَيْرٌ رُخْصَةٌ':Added, #1: 1	غَيْرُ رُخْصَةٍ
u'غير رُخْصَةٌ':Added, #1: 1	غَيْرُ رُخْصَةٍ
u'غَيْرٌ رُخْصَةٌ':Added, #2: 2	غَيْرِ رُخْصَةٍ
u'غير رَدٌّ':Added, #2: 2	غَيْرِ رُخْصَةٍ
u'غَيْرٌ رَدٌّ':Added, #1: 1	غَيْرِ الرَّدِّ
u'غير رَدٌّ':Added, #1: 1	غَيْرِ الرَّدِّ
u'غَيْرٌ رَدٌّ':Added, #2: 2	غَيْرُ الرَّدِّ
u'غير رَدٌّ':Added, #2: 2	غَيْرُ الرَّدِّ
u'غَيْرٌ رَدٌّ':Added, #4: 4	غَيْرِ رَدٍّ
u'غير رِدَّةٌ':Added, #4: 4	غَيْرِ رَدٍّ
u'غَيْرٌ رِدَّةٌ':Added, #1: 1	غَيْرُ الرِّدَّةِ
u'غير رِدَّةٌ':Added, #1: 1	غَيْرُ الرِّدَّةِ
u'غَيْرٌ رِدَّةٌ':Added, #2: 2	غَيْرِ الرِّدَّةِ
u'غير رِسَالَةٌ':Added, #2: 2	غَيْرِ الرِّدَّةِ
u'غَيْرٌ رِسَالَةٌ':Added, #1: 1	غَيْرِ رِسَالَةٍ
u'غير رُسُلٌ':Added, #1: 1	غَيْرِ رِسَالَةٍ
u'غير رُسُلٌ':Added, #2: 2	غَيْرُ الرُّسُلِ
u'غَيْرٌ رُسُلٌ':Added, #2: 2	غَيْرِ الرُّسُلِ
u'غَيْرٌ رُسُلٌ':Added, #2: 2	غَيْرُ الرُّسُلِ
u'غير رَسْمٌ':Added, #2: 2	غَيْرِ الرُّسُلِ
u'غَيْرٌ رَسْمٌ':Added, #2: 2	غَيْرِ رَسْمِ
u'غَيَّرَ رَسُولٌ':Subject, #2: 2	غَيْرِ رَسْمِ
u'غير رَسُولٌ':Added, #1: 1	غَيَّرَ رَسُولُ
u'غَيْرٌ رَسُولٌ':Added, #1: 1	غَيْرُ الرَّسُولِ
u'غير رَسُولٌ':Added, #1: 1	غَيْرُ الرَّسُولِ
u'غير رَسُولٌ':Added, #1: 1	غَيْرُ رَسُولِ
u'غَيْرٌ رَسُولٌ':Added, #1: 1	غَيْرِ رَسُولِ
u'غَيْرٌ رَسُولٌ':Added, #1: 1	غَيْرُ رَسُولِ
u'غير رَسُولٌ':Added, #1: 1	غَيْرِ رَسُولِ
u'غَيْرٌ رَسُولٌ':Added, #1: 1	غَيْرِ رَسُولِهِ
u'غير رَسُولٌ':Added, #1: 1	غَيْرِ رَسُولِهِ
u'غَيْرٌ رَسُولٌ':Added, #4: 4	غَيْرِ الرَّسُولِ
u'غير رشدة':Added, #4: 4	غَيْرِ الرَّسُولِ
u'غَيْرٌ رشدة':Added, #4: 4	غَيْرِ رِشْدَةٍ
u'غير رَشيدٌ':Added, #4: 4	غَيْرِ رِشْدَةٍ
u'غَيْرٌ رَشيدٌ':Added, #13: 13	غَيْرَ رَشِيدٍ
u'غير رَشيدٌ':Added, #13: 13	غَيْرَ رَشِيدٍ
u'غَيْرٌ رَشيدٌ':Added, #1: 1	غَيْرُ الرَّشِيدِ
u'غير رَشيدٌ':Added, #1: 1	غَيْرُ الرَّشِيدِ
u'غير رَشيدٌ':Added, #2: 2	غَيْرُ الرَّشِيدَةِ
u'غَيْرٌ رَشيدٌ':Added, #2: 2	غَيْرِ الرَّشِيدَةِ
u'غَيْرٌ رَشيدٌ':Added, #2: 2	غَيْرُ الرَّشِيدَةِ
u'غير رَشيدٌ':Added, #2: 2	غَيْرِ الرَّشِيدَةِ
u'غَيْرٌ رَشيدٌ':Added, #2: 2	غَيْرُ رَشِيدَةٍ
u'غير رَشيدٌ':Added, #2: 2	غَيْرُ رَشِيدَةٍ
u'غَيْرٌ رَشيدٌ':Added, #4: 4	غَيْرِ الرَّشِيدِ
u'غير رَشيدٌ':Added, #4: 4	غَيْرِ الرَّشِيدِ
u'غَيْرٌ رَشيدٌ':Added, #4: 4	غَيْرِ رَشِيدٍ
u'غير رَشيدٌ':Added, #4: 4	غَيْرِ رَشِيدٍ
u'غَيْرٌ رَشيدٌ':Added, #4: 4	غَيْرَ رَشِيدَةٍ
u'غير رَشيدٌ':Added, #4: 4	غَيْرَ رَشِيدَةٍ
u'غَيْرٌ رَشيدٌ':Added, #7: 7	غَيْرُ رَشِيدٍ
u'غير رضاع':Added, #7: 7	غَيْرُ رَشِيدٍ
u'غَيْرٌ رضاع':Added, #1: 1	غَيْرِ الرَّضَاعِ
u'غير رضاع':Added, #1: 1	غَيْرِ الرَّضَاعِ
u'غَيْرٌ رضاع':Added, #1: 1	غَيْرِ رَضَاعٍ
u'غير رِطابٌ':Added, #1: 1	غَيْرِ رَضَاعٍ
u'غير رِطَابٌ':Added, #2: 2	غَيْرُ الرِّطَابِ
u'غَيْرٌ رِطابٌ':Added, #2: 2	غَيْرُ الرِّطَابِ
u'غَيْرٌ رِطَابٌ':Added, #2: 2	غَيْرُ الرِّطَابِ
u'غير رُطَبٌ':Added, #2: 2	غَيْرُ الرِّطَابِ
u'غَيْرٌ رُطَبٌ':Added, #1: 1	غَيْر الرُّطَبِ
u'غير رَطْبٌ':Added, #1: 1	غَيْر الرُّطَبِ
u'غَيْرٌ رَطْبٌ':Added, #1: 1	غَيْرِ رَطْبٍ
u'غير رُطَبٌ':Added, #1: 1	غَيْرِ رَطْبٍ
u'غَيْرٌ رُطَبٌ':Added, #2: 2	غَيْرِ الرُّطَبِ
u'غير رعاف':Added, #2: 2	غَيْرِ الرُّطَبِ
u'غير رُعافٌ':Added, #1: 1	غَيْرِ الرُّعَافِ
u'غَيْرٌ رعاف':Added, #1: 1	غَيْرِ الرُّعَافِ
u'غَيْرٌ رُعافٌ':Added, #1: 1	غَيْرِ الرُّعَافِ
u'غير رعاف':Added, #1: 1	غَيْرِ الرُّعَافِ
u'غير رُعافٌ':Added, #1: 1	غَيْرِ رُعَافٍ
u'غَيْرٌ رعاف':Added, #1: 1	غَيْرِ رُعَافٍ
u'غَيْرٌ رُعافٌ':Added, #1: 1	غَيْرِ رُعَافٍ
u'غير رِعْديدٌ':Added, #1: 1	غَيْرِ رُعَافٍ
u'غَيْرٌ رِعْديدٌ':Added, #1: 1	غَيْرُ رِعْدِيدِ
u'غير رَغْبَةٌ':Added, #1: 1	غَيْرُ رِعْدِيدِ
u'غَيْرٌ رَغْبَةٌ':Added, #1: 1	غَيْرِ رَغْبَةِ
u'غير رَغْبَةٌ':Added, #1: 1	غَيْرِ رَغْبَةِ
u'غَيْرٌ رَغْبَةٌ':Added, #2: 2	غَيْرَ رَغْبَةٍ
u'غير رَغيفٌ':Added, #2: 2	غَيْرَ رَغْبَةٍ
u'غَيْرٌ رَغيفٌ':Added, #1: 1	غَيْرَ رَغِيفٍ
u'غير رَفْضٌ':Added, #1: 1	غَيْرَ رَغِيفٍ
u'غَيْرٌ رَفْضٌ':Added, #1: 1	غَيْرِ رَفْضٍ
u'غير رَفْعٌ':Added, #1: 1	غَيْرِ رَفْضٍ
u'غَيْرٌ رَفْعٌ':Added, #1: 1	غَيْرَ الرَّفْعِ
u'غير رَفْعٌ':Added, #1: 1	غَيْرَ الرَّفْعِ
u'غَيْرٌ رَفْعٌ':Added, #2: 2	غَيْرِ رَفْعِ
u'غير رَفْعٌ':Added, #2: 2	غَيْرِ رَفْعِ
u'غَيْرٌ رَفْعٌ':Added, #3: 3	غَيْرِ رَفْعٍ
u'غير رفقاء':Added, #3: 3	غَيْرِ رَفْعٍ
u'غَيْرٌ رفقاء':Added, #1: 1	غَيْرِ الرُّفَقَاءِ
u'غير رَفيعٌ':Added, #1: 1	غَيْرِ الرُّفَقَاءِ
u'غَيْرٌ رَفيعٌ':Added, #1: 1	غَيْرُ رَفِيعٍ
u'غير رَفيقٌ':Added, #1: 1	غَيْرُ رَفِيعٍ
u'غَيْرٌ رَفيقٌ':Added, #1: 1	غَيْرُ رَفِيقِهِ
u'غير رَقَبَةٌ':Added, #1: 1	غَيْرُ رَفِيقِهِ
u'غير رَقَبَةٌ':Added, #1: 1	غَيْرَ الرَّقَبَةِ
u'غَيْرٌ رَقَبَةٌ':Added, #1: 1	غَيْرُ الرَّقَبَةِ
u'غَيْرٌ رَقَبَةٌ':Added, #1: 1	غَيْرَ الرَّقَبَةِ
u'غير رَقَبَةٌ':Added, #1: 1	غَيْرُ الرَّقَبَةِ
u'غَيْرٌ رَقَبَةٌ':Added, #1: 1	غَيْرِ رَقَبَةِ
u'غير رَقْمٌ':Added, #1: 1	غَيْرِ رَقَبَةِ
u'غير رَقْم':Added, #1: 1	غَيْرِ الرَّقْمِ
u'غَيْرٌ رَقْمٌ':Added, #1: 1	غَيْرِ الرَّقْمِ
u'غَيْرٌ رَقْم':Added, #1: 1	غَيْرِ الرَّقْمِ
u'غير رُقِيٌّ':Added, #1: 1	غَيْرِ الرَّقْمِ
u'غَيْرٌ رُقِيٌّ':Added, #1: 1	غَيْرِ رُقِيٍّ
u'غير رَقيقٌ':Added, #1: 1	غَيْرِ رُقِيٍّ
u'غير رَقيق':Added, #1: 1	غَيْرُ الرَّقِيقِ
u'غَيْرٌ رَقيقٌ':Added, #1: 1	غَيْرُ الرَّقِيقِ
u'غَيْرٌ رَقيق':Added, #1: 1	غَيْرُ الرَّقِيقِ
u'غير رَقيقٌ':Added, #1: 1	غَيْرُ الرَّقِيقِ
u'غير رَقيقٌ':Added, #1: 1	غَيْرَ رَقِيقٍ
u'غير رَقيق':Added, #1: 1	غَيْرِ رَقِيقٍ
u'غير رَقيق':Added, #1: 1	غَيْرَ رَقِيقٍ
u'غَيْرٌ رَقيقٌ':Added, #1: 1	غَيْرِ رَقِيقٍ
u'غَيْرٌ رَقيقٌ':Added, #1: 1	غَيْرَ رَقِيقٍ
u'غَيْرٌ رَقيق':Added, #1: 1	غَيْرِ رَقِيقٍ
u'غَيْرٌ رَقيق':Added, #1: 1	غَيْرَ رَقِيقٍ
u'غير رَقيقٌ':Added, #1: 1	غَيْرِ رَقِيقٍ
u'غير رَقيقٌ':Added, #3: 3	غَيْرَ الرَّقِيقِ
u'غير رَقيق':Added, #3: 3	غَيْرِ الرَّقِيقِ
u'غير رَقيق':Added, #3: 3	غَيْرَ الرَّقِيقِ
u'غَيْرٌ رَقيقٌ':Added, #3: 3	غَيْرِ الرَّقِيقِ
u'غَيْرٌ رَقيقٌ':Added, #3: 3	غَيْرَ الرَّقِيقِ
u'غَيْرٌ رَقيق':Added, #3: 3	غَيْرِ الرَّقِيقِ
u'غَيْرٌ رَقيق':Added, #3: 3	غَيْرَ الرَّقِيقِ
u'غير ركعة':Added, #3: 3	غَيْرِ الرَّقِيقِ
u'غَيْرٌ ركعة':Added, #3: 3	غَيْرِ الرَّكْعَةِ
u'غير رَكْعَةٌ':Added, #3: 3	غَيْرِ الرَّكْعَةِ
u'غَيْرٌ رَكْعَةٌ':Added, #3: 3	غَيْرِ الرَّكْعَةِ
u'غير رُكْنٌ':Added, #3: 3	غَيْرِ الرَّكْعَةِ
u'غير رُكْنٌ':Added, #1: 1	غَيْرَ الرُّكْنَيْنِ
u'غير رُكْن':Added, #1: 1	غَيْرِ الرُّكْنَيْنِ
u'غير رُكْن':Added, #1: 1	غَيْرَ الرُّكْنَيْنِ
u'غَيْرٌ رُكْنٌ':Added, #1: 1	غَيْرِ الرُّكْنَيْنِ
u'غَيْرٌ رُكْنٌ':Added, #1: 1	غَيْرَ الرُّكْنَيْنِ
u'غَيْرٌ رُكْن':Added, #1: 1	غَيْرِ الرُّكْنَيْنِ
u'غَيْرٌ رُكْن':Added, #1: 1	غَيْرَ الرُّكْنَيْنِ
u'غير رُكْنٌ':Added, #1: 1	غَيْرِ الرُّكْنَيْنِ
u'غير رُكْنٌ':Added, #1: 1	غَيْرَ رُكْنٍ
u'غير رُكْن':Added, #1: 1	غَيْرِ رُكْنٍ
u'غير رُكْن':Added, #1: 1	غَيْرَ رُكْنٍ
u'غَيْرٌ رُكْنٌ':Added, #1: 1	غَيْرِ رُكْنٍ
u'غَيْرٌ رُكْنٌ':Added, #1: 1	غَيْرَ رُكْنٍ
u'غَيْرٌ رُكْن':Added, #1: 1	غَيْرِ رُكْنٍ
u'غَيْرٌ رُكْن':Added, #1: 1	غَيْرَ رُكْنٍ
u'غير رُكْنٌ':Added, #1: 1	غَيْرِ رُكْنٍ
u'غير رُكْن':Added, #6: 6	غَيْرُ رُكْنٍ
u'غَيْرٌ رُكْنٌ':Added, #6: 6	غَيْرُ رُكْنٍ
u'غَيْرٌ رُكْن':Added, #6: 6	غَيْرُ رُكْنٍ
u'غير رُكوبٌ':Added, #6: 6	غَيْرُ رُكْنٍ
u'غَيْرٌ رُكوبٌ':Added, #2: 2	غَيْرِ رُكُوبٍ
u'غير رُكوعٌ':Added, #2: 2	غَيْرِ رُكُوبٍ
u'غَيْرٌ رُكوعٌ':Added, #1: 1	غَيْرَ الرُّكُوعِ
u'غير رُكوعٌ':Added, #1: 1	غَيْرَ الرُّكُوعِ
u'غَيْرٌ رُكوعٌ':Added, #1: 1	غَيْرَ رُكُوعِ
u'غير رُكوعٌ':Added, #1: 1	غَيْرَ رُكُوعِ
u'غَيْرٌ رُكوعٌ':Added, #7: 7	غَيْرِ الرُّكُوعِ
u'غير رُمْحٌ':Added, #7: 7	غَيْرِ الرُّكُوعِ
u'غَيْرٌ رُمْحٌ':Added, #1: 1	غَيْرِ الرُّمْحِ
u'غير رمد':Added, #1: 1	غَيْرِ الرُّمْحِ
u'غَيْرٌ رمد':Added, #1: 1	غَيْرَ الرَّمَدِ
u'غير رَمَدٌ':Added, #1: 1	غَيْرَ الرَّمَدِ
u'غَيْرٌ رَمَدٌ':Added, #1: 1	غَيْرَ الرَّمَدِ
u'غير رمد':Added, #1: 1	غَيْرَ الرَّمَدِ
u'غَيْرٌ رمد':Added, #1: 1	غَيْرِ رَمَدٍ
u'غير رَمَدٌ':Added, #1: 1	غَيْرِ رَمَدٍ
u'غَيْرٌ رَمَدٌ':Added, #1: 1	غَيْرِ رَمَدٍ
u'غير رَمْزٌ':Added, #1: 1	غَيْرِ رَمَدٍ
u'غَيْرٌ رَمْزٌ':Added, #1: 1	غَيْرِ رَمْزِ
u'غير رَمَلٌ':Added, #1: 1	غَيْرِ رَمْزِ
u'غَيْرٌ رَمَلٌ':Added, #1: 1	غَيْرِ رَمَلٍ
u'غير رَمْيٌ':Added, #1: 1	غَيْرِ رَمَلٍ
u'غَيْرٌ رَمْيٌ':Added, #1: 1	غَيْرُ الرَّمْيِ
u'غير رَمْيٌ':Added, #1: 1	غَيْرُ الرَّمْيِ
u'غَيْرٌ رَمْيٌ':Added, #3: 3	غَيْرِ الرَّمْيِ
u'غير رهان':Added, #3: 3	غَيْرِ الرَّمْيِ
u'غير رِهانٌ':Added, #2: 2	غَيْرِ الرِّهَانِ
u'غَيْرٌ رهان':Added, #2: 2	غَيْرِ الرِّهَانِ
u'غَيْرٌ رِهانٌ':Added, #2: 2	غَيْرِ الرِّهَانِ
u'غير رَهَب':Added, #2: 2	غَيْرِ الرِّهَانِ
u'غَيْرٌ رَهَب':Added, #1: 1	غَيْرِ رَهَبٍ
u'غير رَهْنٌ':Added, #1: 1	غَيْرِ رَهَبٍ
u'غير رَهْنٌ':Added, #1: 1	غَيْرَ الرَّهْنِ
u'غَيْرٌ رَهْنٌ':Added, #1: 1	غَيْرُ الرَّهْنِ
u'غَيْرٌ رَهْنٌ':Added, #1: 1	غَيْرَ الرَّهْنِ
u'غير رَهْنٌ':Added, #1: 1	غَيْرُ الرَّهْنِ
u'غَيْرٌ رَهْنٌ':Added, #4: 4	غَيْرِ رَهْنٍ
u'غير رَهْنٌ':Added, #4: 4	غَيْرِ رَهْنٍ
u'غَيْرٌ رَهْنٌ':Added, #9: 9	غَيْرِ الرَّهْنِ
u'غير رُوَاةٌ':Added, #9: 9	غَيْرِ الرَّهْنِ
u'غَيْرٌ رُوَاةٌ':Added, #2: 2	غَيْرِ رُوَاةِ
u'غير رَواتِبُ':Added, #2: 2	غَيْرِ رُوَاةِ
u'غير رَوَاتِبُ':Added, #1: 1	غَيْرَ الرَّوَاتِبِ
u'غَيْرٌ رَواتِبُ':Added, #1: 1	غَيْرَ الرَّوَاتِبِ
u'غَيْرٌ رَوَاتِبُ':Added, #1: 1	غَيْرَ الرَّوَاتِبِ
u'غير رَواتِبُ':Added, #1: 1	غَيْرَ الرَّوَاتِبِ
u'غير رَوَاتِبُ':Added, #6: 6	غَيْرِ الرَّوَاتِبِ
u'غَيْرٌ رَواتِبُ':Added, #6: 6	غَيْرِ الرَّوَاتِبِ
u'غَيْرٌ رَوَاتِبُ':Added, #6: 6	غَيْرِ الرَّوَاتِبِ
u'غير رِواياتٌ':Added, #6: 6	غَيْرِ الرَّوَاتِبِ
u'غير رِواياتٌ':Added, #1: 1	غَيْرُ الرِّوَايَاتِ
u'غَيْرٌ رِواياتٌ':Added, #1: 1	غَيْرِ الرِّوَايَاتِ
u'غَيْرٌ رِواياتٌ':Added, #1: 1	غَيْرُ الرِّوَايَاتِ
u'غير رِوايَةٌ':Added, #1: 1	غَيْرِ الرِّوَايَاتِ
u'غَيْرٌ رِوايَةٌ':Added, #1: 1	غَيْرُ الرِّوَايَةِ
u'غير رِوايَةٌ':Added, #1: 1	غَيْرُ الرِّوَايَةِ
u'غير رِوايَةٌ':Added, #1: 1	غَيْرَ رِوَايَةِ
u'غير رِوايَةٌ':Added, #1: 1	غَيْرُ رِوَايَةِ
u'غَيْرٌ رِوايَةٌ':Added, #1: 1	غَيْرِ رِوَايَةٍ
u'غَيْرٌ رِوايَةٌ':Added, #1: 1	غَيْرَ رِوَايَةِ
u'غَيْرٌ رِوايَةٌ':Added, #1: 1	غَيْرُ رِوَايَةِ
u'غير رِوايَةٌ':Added, #1: 1	غَيْرِ رِوَايَةٍ
u'غَيْرٌ رِوايَةٌ':Added, #7: 7	غَيْرِ الرِّوَايَةِ
u'غير رِوايَةٌ':Added, #7: 7	غَيْرِ الرِّوَايَةِ
u'غَيْرٌ رِوايَةٌ':Added, #91: 91	غَيْرِ رِوَايَةِ
u'غير رَوْثٌ':Added, #91: 91	غَيْرِ رِوَايَةِ
u'غَيْرٌ رَوْثٌ':Added, #1: 1	غَيْرِ الرَّوْثِ
u'غير روحٌ':Added, #1: 1	غَيْرِ الرَّوْثِ
u'غير روحٌ':Added, #1: 1	غَيْرُ رُوحِ
u'غير روحٌ':Added, #1: 1	غَيْرَ رَوْحٍ
u'غير روحٌ':Added, #1: 1	غَيْرُ رَوْحٍ
u'غَيْرٌ روحٌ':Added, #1: 1	غَيْرُ رَوْحِ
u'غَيْرٌ روحٌ':Added, #1: 1	غَيْرُ رُوحِ
u'غَيْرٌ روحٌ':Added, #1: 1	غَيْرَ رَوْحٍ
u'غَيْرٌ روحٌ':Added, #1: 1	غَيْرُ رَوْحٍ
u'غير رَوْحٌ':Added, #1: 1	غَيْرُ رَوْحِ
u'غير رَوْحٌ':Added, #1: 1	غَيْرَ رَوْحٍ
u'غير رَوْحٌ':Added, #1: 1	غَيْرُ رَوْحٍ
u'غَيْرٌ رَوْحٌ':Added, #1: 1	غَيْرُ رَوْحِ
u'غَيْرٌ رَوْحٌ':Added, #1: 1	غَيْرَ رَوْحٍ
u'غَيْرٌ رَوْحٌ':Added, #1: 1	غَيْرُ رَوْحٍ
u'غير رَوِيٌّ':Added, #1: 1	غَيْرُ رَوْحِ
u'غير رَوِيٌّ':Added, #1: 1	غَيْرِ رَوِيّةٍ
u'غَيْرٌ رَوِيٌّ':Added, #1: 1	غَيْرِ رَوِيَّةٍ
u'غَيْرٌ رَوِيٌّ':Added, #1: 1	غَيْرِ رَوِيّةٍ
u'غير رُؤْيَةٌ':Added, #1: 1	غَيْرِ رَوِيَّةٍ
u'غَيْرٌ رُؤْيَةٌ':Added, #10: 10	غَيْرِ رُؤْيَةِ
u'غير رَوِيَّةٌ':Added, #10: 10	غَيْرِ رُؤْيَةِ
u'غير رَوِيَّةٌ':Added, #1: 1	غَيْرِ رَوِيّةٍ
u'غَيْرٌ رَوِيَّةٌ':Added, #1: 1	غَيْرِ رَوِيَّةٍ
u'غَيْرٌ رَوِيَّةٌ':Added, #1: 1	غَيْرِ رَوِيّةٍ
u'غير رُؤْيَةٌ':Added, #1: 1	غَيْرِ رَوِيَّةٍ
u'غَيْرٌ رُؤْيَةٌ':Added, #1: 1	غَيْرِ رُؤْيَتِهِ
u'غير رُؤْيَةٌ':Added, #1: 1	غَيْرِ رُؤْيَتِهِ
u'غَيْرٌ رُؤْيَةٌ':Added, #3: 3	غَيْرِ الرُّؤْيَةِ
u'غير رُؤْيَةٌ':Added, #3: 3	غَيْرِ الرُّؤْيَةِ
u'غَيْرٌ رُؤْيَةٌ':Added, #9: 9	غَيْرِ رُؤْيَةٍ
u'غير رَيْبٌ':Added, #9: 9	غَيْرِ رُؤْيَةٍ
u'غَيْرٌ رَيْبٌ':Added, #2: 2	غَيْرِ رَيْبٍ
u'غير رِيبَةٌ':Added, #2: 2	غَيْرِ رَيْبٍ
u'غَيْرٌ رِيبَةٌ':Added, #1: 1	غَيْرِ الرِّيبَةِ
u'غير رِيبَةٌ':Added, #1: 1	غَيْرِ الرِّيبَةِ
u'غَيْرٌ رِيبَةٌ':Added, #9: 9	غَيْرِ رِيبَةٍ
u'غير ريحٌ':Added, #9: 9	غَيْرِ رِيبَةٍ
u'غَيْرٌ ريحٌ':Added, #1: 1	غَيْرِ الرِّيحِ
u'غير رِيقٌ':Added, #1: 1	غَيْرِ الرِّيحِ
u'غَيْرٌ رِيقٌ':Added, #1: 1	غَيْرِ رِيقٍ
u'غير زادٌ':Added, #1: 1	غَيْرِ رِيقٍ
u'غَيْرٌ زادٌ':Added, #2: 2	غَيْرُ الزَّادِ
u'غير زَارِعٌ':Added, #2: 2	غَيْرُ الزَّادِ
u'غَيْرٌ زَارِعٌ':Added, #1: 1	غَيْرُ الزَّارِعِ
u'غير زاغٌ':Added, #1: 1	غَيْرُ الزَّارِعِ
u'غَيْرٌ زاغٌ':Added, #1: 1	غَيْرِ زَاغٍ
u'غير زانِي':Added, #1: 1	غَيْرِ زَاغٍ
u'غير زانِي':Added, #1: 1	غَيْرَ زَانِيَةٍ
u'غَيْرٌ زانِي':Added, #1: 1	غَيْرُ زَانِيَةٍ
u'غَيْرٌ زانِي':Added, #1: 1	غَيْرَ زَانِيَةٍ
u'غير زانِي':Added, #1: 1	غَيْرُ زَانِيَةٍ
u'غَيْرٌ زانِي':Added, #2: 2	غَيْرَ زَانِيَاتٍ
u'غير زائِدٌ':Added, #2: 2	غَيْرَ زَانِيَاتٍ
u'غَيْرٌ زائِدٌ':Added, #1: 1	غَيْرِ زَائِدٍ
u'غير زائِدٌ':Added, #1: 1	غَيْرِ زَائِدٍ
u'غَيْرٌ زائِدٌ':Added, #1: 1	غَيْرُ زَائِدَةٍ
u'غير زائِدٌ':Added, #1: 1	غَيْرُ زَائِدَةٍ
u'غَيْرٌ زائِدٌ':Added, #2: 2	غَيْرِ الزَّائِدِ
u'غير زائِدٌ':Added, #2: 2	غَيْرِ الزَّائِدِ
u'غَيْرٌ زائِدٌ':Added, #2: 2	غَيْرَ زَائِدَةٍ
u'غير زائِدٌ':Added, #2: 2	غَيْرَ زَائِدَةٍ
u'غَيْرٌ زائِدٌ':Added, #3: 3	غَيْرُ زَائِدٍ
u'غير زائِدٌ':Added, #3: 3	غَيْرُ زَائِدٍ
u'غَيْرٌ زائِدٌ':Added, #6: 6	غَيْرَ زَائِدٍ
u'غير زائِلٌ':Added, #6: 6	غَيْرَ زَائِدٍ
u'غير زائِلٌ':Added, #1: 1	غَيْرَ زَائِلٍ
u'غَيْرٌ زائِلٌ':Added, #1: 1	غَيْرُ زَائِلِ
u'غَيْرٌ زائِلٌ':Added, #1: 1	غَيْرَ زَائِلٍ
u'غير زائِلٌ':Added, #1: 1	غَيْرُ زَائِلِ
u'غَيْرٌ زائِلٌ':Added, #1: 1	غَيْرَ زَائِلَةٍ
u'غير زُبْدٌ':Added, #1: 1	غَيْرَ زَائِلَةٍ
u'غَيْرٌ زُبْدٌ':Added, #1: 1	غَيْرِ الزُّبْدِ
u'غير زُجاجَةٌ':Added, #1: 1	غَيْرِ الزُّبْدِ
u'غَيْرٌ زُجاجَةٌ':Added, #1: 1	غَيْرِ الزُّجَاجَةِ
u'غير زُجاجِيٌّ':Added, #1: 1	غَيْرِ الزُّجَاجَةِ
u'غَيْرٌ زُجاجِيٌّ':Added, #2: 2	غَيْرِ الزُّجَاجِيِّ
u'غير زَجْرٌ':Added, #2: 2	غَيْرِ الزُّجَاجِيِّ
u'غَيْرٌ زَجْرٌ':Added, #1: 1	غَيْرِ زَجْرِ
u'غير زِحامٌ':Added, #1: 1	غَيْرِ زَجْرِ
u'غَيْرٌ زِحامٌ':Added, #2: 2	غَيْرِ زِحَامِ
u'غير زِحامٌ':Added, #2: 2	غَيْرِ زِحَامِ
u'غَيْرٌ زِحامٌ':Added, #3: 3	غَيْرِ زِحَامٍ
u'غير زَحْفٌ':Added, #3: 3	غَيْرِ زِحَامٍ
u'غَيْرٌ زَحْفٌ':Added, #1: 1	غَيْرِ الزّحْفِ
u'غير زِراعَةٌ':Added, #1: 1	غَيْرِ الزّحْفِ
u'غَيْرٌ زِراعَةٌ':Added, #1: 1	غَيْرِ الزِّرَاعَةِ
u'غير زَرْعٌ':Added, #1: 1	غَيْرِ الزِّرَاعَةِ
u'غير زَرْعٌ':Added, #1: 1	غَيْرَ الزَّرْعِ
u'غَيْرٌ زَرْعٌ':Added, #1: 1	غَيْرِ الزَّرْعِ
u'غَيْرٌ زَرْعٌ':Added, #1: 1	غَيْرَ الزَّرْعِ
u'غير زَرْعٌ':Added, #1: 1	غَيْرِ الزَّرْعِ
u'غَيْرٌ زَرْعٌ':Added, #2: 2	غَيْرِ زَرْعٍ
u'غير زُروعٌ':Added, #2: 2	غَيْرِ زَرْعٍ
u'غَيْرٌ زُروعٌ':Added, #1: 1	غَيْرِ الزُّرُوعِ
u'غير زَعْفَرانٌ':Added, #1: 1	غَيْرِ الزُّرُوعِ
u'غَيْرٌ زَعْفَرانٌ':Added, #3: 3	غَيْرِ الزَّعْفَرَانِ
u'غير زَكاةٌ':Added, #3: 3	غَيْرِ الزَّعْفَرَانِ
u'غَيْرٌ زَكاةٌ':Added, #14: 14	غَيْرِ الزَّكَاةِ
u'غير زَكاةٌ':Added, #14: 14	غَيْرِ الزَّكَاةِ
u'غير زَكاةٌ':Added, #1: 1	غَيْرَ زَكَاةِ
u'غَيْرٌ زَكاةٌ':Added, #1: 1	غَيْرِ زَكَاةِ
u'غَيْرٌ زَكاةٌ':Added, #1: 1	غَيْرَ زَكَاةِ
u'غير زَكاةٌ':Added, #1: 1	غَيْرِ زَكَاةِ
u'غَيْرٌ زَكاةٌ':Added, #1: 1	غَيْرُ زَكَاتِهِ
u'غير زَكاةٌ':Added, #1: 1	غَيْرُ زَكَاتِهِ
u'غَيْرٌ زَكاةٌ':Added, #2: 2	غَيْرُ الزَّكَاةِ
u'غير زَكاةٌ':Added, #2: 2	غَيْرُ الزَّكَاةِ
u'غير زَكاةٌ':Added, #2: 2	غَيْرَ زَكَاةٍ
u'غَيْرٌ زَكاةٌ':Added, #2: 2	غَيْرُ زَكَاةٍ
u'غَيْرٌ زَكاةٌ':Added, #2: 2	غَيْرَ زَكَاةٍ
u'غير زَكاةٌ':Added, #2: 2	غَيْرُ زَكَاةٍ
u'غَيْرٌ زَكاةٌ':Added, #6: 6	غَيْرَ الزَّكَاةِ
u'غير زَمانٌ':Added, #6: 6	غَيْرَ الزَّكَاةِ
u'غَيْرٌ زَمانٌ':Added, #1: 1	غَيْرَ الزَّمَانِ
u'غير زَمانٌ':Added, #1: 1	غَيْرَ الزَّمَانِ
u'غَيْرٌ زَمانٌ':Added, #2: 2	غَيْرِ الزَّمَانِ
u'غير زَمانٌ':Added, #2: 2	غَيْرِ الزَّمَانِ
u'غَيْرٌ زَمانٌ':Added, #3: 3	غَيْرِ زَمَانِ
u'غير زَمَنٌ':Added, #3: 3	غَيْرِ زَمَانِ
u'غَيْرٌ زَمَنٌ':Added, #1: 1	غَيْرُ الزَّمَنِ
u'غير زَمَنٌ':Added, #1: 1	غَيْرُ الزَّمَنِ
u'غَيْرٌ زَمَنٌ':Added, #1: 1	غَيْرُ زَمَنِ
u'غير زَمِن':Added, #1: 1	غَيْرُ زَمَنِ
u'غير زَمِن':Added, #1: 1	غَيْرَ زَمِنَةٍ
u'غَيْرٌ زَمِن':Added, #1: 1	غَيْرُ زَمِنَةٍ
u'غَيْرٌ زَمِن':Added, #1: 1	غَيْرَ زَمِنَةٍ
u'غير زَمَنٌ':Added, #1: 1	غَيْرُ زَمِنَةٍ
u'غَيْرٌ زَمَنٌ':Added, #2: 2	غَيْرِ زَمَنِهِ
u'غير زَمَنٌ':Added, #2: 2	غَيْرِ زَمَنِهِ
u'غَيْرٌ زَمَنٌ':Added, #5: 5	غَيْرِ زَمَنِ
u'غير زواهق':Added, #5: 5	غَيْرِ زَمَنِ
u'غَيْرٌ زواهق':Added, #1: 1	غَيْرُ زَوَاهِقِ
u'غير زَوْجٌ':Added, #1: 1	غَيْرُ زَوَاهِقِ
u'غَيْرٌ زَوْجٌ':Added, #10: 10	غَيْرِ زَوْجٍ
u'غير زَوْجٌ':Added, #10: 10	غَيْرِ زَوْجٍ
u'غَيْرٌ زَوْجٌ':Added, #11: 11	غَيْرُ الزَّوْجِ
u'غير زَوْجٌ':Added, #11: 11	غَيْرُ الزَّوْجِ
u'غَيْرٌ زَوْجٌ':Added, #1: 1	غَيْرَ الزَّوْجِ
u'غير زَوْجٌ':Added, #1: 1	غَيْرَ الزَّوْجِ
u'غَيْرٌ زَوْجٌ':Added, #1: 1	غَيْرَ الزَّوْجَيْنِ
u'غير زَوْجٌ':Added, #1: 1	غَيْرَ الزَّوْجَيْنِ
u'غَيْرٌ زَوْجٌ':Added, #1: 1	غَيْرُ زَوْجِ
u'غير زَوْجٌ':Added, #1: 1	غَيْرُ زَوْجِ
u'غَيْرٌ زَوْجٌ':Added, #2: 2	غَيْرِ الزَّوْجَيْنِ
u'غير زَوْجٌ':Added, #2: 2	غَيْرِ الزَّوْجَيْنِ
u'غَيْرٌ زَوْجٌ':Added, #30: 30	غَيْرِ الزَّوْجِ
u'غير زَوْجٌ':Added, #30: 30	غَيْرِ الزَّوْجِ
u'غَيْرٌ زَوْجٌ':Added, #3: 3	غَيْرَ زَوْجٍ
u'غير زَوْجَةٌ':Added, #3: 3	غَيْرَ زَوْجٍ
u'غَيْرٌ زَوْجَةٌ':Added, #12: 12	غَيْرَ زَوْجَتِهِ
u'غير زَوْجَةٌ':Added, #12: 12	غَيْرَ زَوْجَتِهِ
u'غَيْرٌ زَوْجَةٌ':Added, #15: 15	غَيْرِ الزَّوْجَةِ
u'غير زَوْجَةٌ':Added, #15: 15	غَيْرِ الزَّوْجَةِ
u'غَيْرٌ زَوْجَةٌ':Added, #1: 1	غَيْرَ الزَّوْجَاتِ
u'غير زَوْجَةٌ':Added, #1: 1	غَيْرَ الزَّوْجَاتِ
u'غَيْرٌ زَوْجَةٌ':Added, #1: 1	غَيْرَ زَوْجَةٍ
u'غير زَوْجَةٌ':Added, #1: 1	غَيْرَ زَوْجَةٍ
u'غَيْرٌ زَوْجَةٌ':Added, #3: 3	غَيْرُ الزَّوْجَةِ
u'غير زَوْجَةٌ':Added, #3: 3	غَيْرُ الزَّوْجَةِ
u'غَيْرٌ زَوْجَةٌ':Added, #3: 3	غَيْرِ زَوْجَةٍ
u'غير زَوْجَةٌ':Added, #3: 3	غَيْرِ زَوْجَةٍ
u'غَيْرٌ زَوْجَةٌ':Added, #4: 4	غَيْرُ زَوْجَتِهِ
u'غير زَوْجَةٌ':Added, #4: 4	غَيْرُ زَوْجَتِهِ
u'غَيْرٌ زَوْجَةٌ':Added, #5: 5	غَيْرُ زَوْجَةٍ
u'غير زَوْجَةٌ':Added, #5: 5	غَيْرُ زَوْجَةٍ
u'غَيْرٌ زَوْجَةٌ':Added, #5: 5	غَيْرِ زَوْجَتِهِ
u'غير زَوْجِيٌّ':Added, #5: 5	غَيْرِ زَوْجَتِهِ
u'غَيْرٌ زَوْجِيٌّ':Added, #1: 1	غَيْرِ الزَّوْجِيَّةِ
u'غير زِيٌّ':Added, #1: 1	غَيْرِ الزَّوْجِيَّةِ
u'غَيْرٌ زِيٌّ':Added, #2: 2	غَيْرَ زِيِّ
u'غير زِيادَةٌ':Added, #2: 2	غَيْرَ زِيِّ
u'غَيْرٌ زِيادَةٌ':Added, #11: 11	غَيْرِ زِيَادَةِ
u'غير زِيادَةٌ':Added, #11: 11	غَيْرِ زِيَادَةِ
u'غير زِيادَةٌ':Added, #1: 1	غَيْرَ الزِّيَادَةِ
u'غَيْرٌ زِيادَةٌ':Added, #1: 1	غَيْرِ الزِّيَادَةِ
u'غَيْرٌ زِيادَةٌ':Added, #1: 1	غَيْرَ الزِّيَادَةِ
u'غير زِيادَةٌ':Added, #1: 1	غَيْرِ الزِّيَادَةِ
u'غير زِيادَةٌ':Added, #1: 1	غَيْر زِيَادَةٍ
u'غَيْرٌ زِيادَةٌ':Added, #1: 1	غَيْرَ زِيَادَةِ
u'غَيْرٌ زِيادَةٌ':Added, #1: 1	غَيْر زِيَادَةٍ
u'غير زِيادَةٌ':Added, #1: 1	غَيْرَ زِيَادَةِ
u'غَيْرٌ زِيادَةٌ':Added, #68: 68	غَيْرِ زِيَادَةٍ
u'غير زَيْتونٌ':Added, #68: 68	غَيْرِ زِيَادَةٍ
u'غَيْرٌ زَيْتونٌ':Added, #1: 1	غَيْرُ الزَّيْتُونِ
u'غير زَيْدٌ':Added, #1: 1	غَيْرُ الزَّيْتُونِ
u'غَيْرٌ زَيْدٌ':Added, #1: 1	غَيْرَ زَيْدِ
u'غير زَيْدٌ':Added, #1: 1	غَيْرَ زَيْدِ
u'غَيْرٌ زَيْدٌ':Added, #3: 3	غَيْرَ زَيْدٍ
u'غير زَيْدٌ':Added, #3: 3	غَيْرَ زَيْدٍ
u'غَيْرٌ زَيْدٌ':Added, #5: 5	غَيْرُ زَيْدٍ
u'غير زَيْدٌ':Added, #5: 5	غَيْرُ زَيْدٍ
u'غَيْرٌ زَيْدٌ':Added, #6: 6	غَيْرِ زَيْدٍ
u'غير زِينَةٌ':Added, #6: 6	غَيْرِ زَيْدٍ
u'غير زِينَةٌ':Added, #1: 1	غَيْرَ الزِّينَةِ
u'غَيْرٌ زِينَةٌ':Added, #1: 1	غَيْرِ الزِّينَةِ
u'غَيْرٌ زِينَةٌ':Added, #1: 1	غَيْرَ الزِّينَةِ
u'غير زِينَةٌ':Added, #1: 1	غَيْرِ الزِّينَةِ
u'غَيْرٌ زِينَةٌ':Added, #2: 2	غَيْرُ الزِّينَةِ
u'غير زُيوفٌ':Added, #2: 2	غَيْرُ الزِّينَةِ
u'غير زُيُوفٌ':Added, #1: 1	غَيْرِ الزُّيُوفِ
u'غَيْرٌ زُيوفٌ':Added, #1: 1	غَيْرِ الزُّيُوفِ
u'غَيْرٌ زُيُوفٌ':Added, #1: 1	غَيْرِ الزُّيُوفِ
u'غير زُيوفٌ':Added, #1: 1	غَيْرِ الزُّيُوفِ
u'غير زُيُوفٌ':Added, #1: 1	غَيْرَ زُيُوفٍ
u'غَيْرٌ زُيوفٌ':Added, #1: 1	غَيْرَ زُيُوفٍ
u'غَيْرٌ زُيُوفٌ':Added, #1: 1	غَيْرَ زُيُوفٍ
u'غير سابّ':Added, #1: 1	غَيْرَ زُيُوفٍ
u'غَيْرٌ سابّ':Added, #2: 2	غَيْرُ السَّابِّ
u'غير سَابِحٌ':Added, #2: 2	غَيْرُ السَّابِّ
u'غَيْرٌ سَابِحٌ':Added, #1: 1	غَيْرُ سَابِحٍ
u'غير سابع':Added, #1: 1	غَيْرُ سَابِحٍ
u'غير سَابعٌ':Added, #1: 1	غَيْرِ السَّابِعَةِ
u'غَيْرٌ سابع':Added, #1: 1	غَيْرِ السَّابِعَةِ
u'غَيْرٌ سَابعٌ':Added, #1: 1	غَيْرِ السَّابِعَةِ
u'غير سَابِقٌ':Added, #1: 1	غَيْرِ السَّابِعَةِ
u'غَيْرٌ سَابِقٌ':Added, #1: 1	غَيْرِ السَّابِقِ
u'غير سَابِقٌ':Added, #1: 1	غَيْرِ السَّابِقِ
u'غَيْرٌ سَابِقٌ':Added, #1: 1	غَيْرِ السَّابِقَةِ
u'غير سَابِقٌ':Added, #1: 1	غَيْرِ السَّابِقَةِ
u'غير سَابِقٌ':Added, #1: 1	غَيْرُ سَابِقٍ
u'غَيْرٌ سَابِقٌ':Added, #1: 1	غَيْرِ سَابِقِ
u'غَيْرٌ سَابِقٌ':Added, #1: 1	غَيْرُ سَابِقٍ
u'غير سَابِقٌ':Added, #1: 1	غَيْرِ سَابِقِ
u'غير سَابِقٌ':Added, #1: 1	غَيْرُ سَابِقَةٍ
u'غير سَابِقٌ':Added, #1: 1	غَيْرِ سَابِقَةٍ
u'غَيْرٌ سَابِقٌ':Added, #1: 1	غَيْرِ سَابِقَةِ
u'غَيْرٌ سَابِقٌ':Added, #1: 1	غَيْرُ سَابِقَةٍ
u'غَيْرٌ سَابِقٌ':Added, #1: 1	غَيْرِ سَابِقَةٍ
u'غير سَاتِرٌ':Added, #1: 1	غَيْرِ سَابِقَةِ
u'غَيْرٌ سَاتِرٌ':Added, #3: 3	غَيْرِ سَاتِرٍ
u'غير سَارِقٌ':Added, #3: 3	غَيْرِ سَاتِرٍ
u'غَيْرٌ سَارِقٌ':Added, #1: 1	غَيْرُ السَّارِقِ
u'غير سَارِقٌ':Added, #1: 1	غَيْرُ السَّارِقِ
u'غَيْرٌ سَارِقٌ':Added, #2: 2	غَيْرِ السَّارِقِ
u'غير سَارِقٌ':Added, #2: 2	غَيْرِ السَّارِقِ
u'غَيْرٌ سَارِقٌ':Added, #2: 2	غَيْرِ سَارِقٍ
u'غير سَاعَةٌ':Added, #2: 2	غَيْرِ سَارِقٍ
u'غَيْرٌ سَاعَةٌ':Added, #2: 2	غَيْرِ سَاعَةٍ
u'غير سَاعَةٌ':Added, #2: 2	غَيْرِ سَاعَةٍ
u'غَيْرٌ سَاعَةٌ':Added, #7: 7	غَيْرَ سَاعَةٍ
u'غير سَاقِطٌ':Added, #7: 7	غَيْرَ سَاعَةٍ
u'غَيْرٌ سَاقِطٌ':Added, #1: 1	غَيْرُ سَاقِطِ
u'غير سَاقِطٌ':Added, #1: 1	غَيْرُ سَاقِطِ
u'غَيْرٌ سَاقِطٌ':Added, #1: 1	غَيْرَ سَاقِطَةٍ
u'غير سَاقِطٌ':Added, #1: 1	غَيْرَ سَاقِطَةٍ
u'غَيْرٌ سَاقِطٌ':Added, #4: 4	غَيْرُ سَاقِطٍ
u'غير سَاقِي':Added, #4: 4	غَيْرُ سَاقِطٍ
u'غَيْرٌ سَاقِي':Added, #1: 1	غَيْرِ سَاقِيَةِ
u'غير سَاقِيَةٌ':Added, #1: 1	غَيْرِ سَاقِيَةِ
u'غَيْرٌ سَاقِيَةٌ':Added, #1: 1	غَيْرِ سَاقِيَةِ
u'غير سَاكِنٌ':Added, #1: 1	غَيْرِ سَاقِيَةِ
u'غير سَاكِنٌ':Added, #1: 1	غَيْرَ السَّاكِنِ
u'غير سَاكِنٌ':Added, #1: 1	غَيْرُ السَّاكِنِ
u'غَيْرٌ سَاكِنٌ':Added, #1: 1	غَيْرِ السَّاكِنِ
u'غَيْرٌ سَاكِنٌ':Added, #1: 1	غَيْرَ السَّاكِنِ
u'غَيْرٌ سَاكِنٌ':Added, #1: 1	غَيْرُ السَّاكِنِ
u'غير سَاكِنٌ':Added, #1: 1	غَيْرِ السَّاكِنِ
u'غَيْرٌ سَاكِنٌ':Added, #1: 1	غَيْرَ سَاكِنٍ
u'غير سَاكِنٌ':Added, #1: 1	غَيْرَ سَاكِنٍ
u'غَيْرٌ سَاكِنٌ':Added, #1: 1	غَيْرَ سَاكِنَةٍ
u'غير سَاكِنٌ':Added, #1: 1	غَيْرَ سَاكِنَةٍ
u'غَيْرٌ سَاكِنٌ':Added, #3: 3	غَيْرُ سَاكِنِ
u'غير سَاكِنٌ':Added, #3: 3	غَيْرُ سَاكِنِ
u'غَيْرٌ سَاكِنٌ':Added, #4: 4	غَيْرُ سَاكِنٍ
u'غير سَالِمٌ':Added, #4: 4	غَيْرُ سَاكِنٍ
u'غير سَالِمٌ':Added, #2: 2	غَيْرَ سَالِمٍ
u'غَيْرٌ سَالِمٌ':Added, #2: 2	غَيْرُ سَالِمٍ
u'غَيْرٌ سَالِمٌ':Added, #2: 2	غَيْرَ سَالِمٍ
u'غير سَامِعٌ':Added, #2: 2	غَيْرُ سَالِمٍ
u'غَيْرٌ سَامِعٌ':Added, #1: 1	غَيْرُ السَّامِعِ
u'غير سَامِعٌ':Added, #1: 1	غَيْرُ السَّامِعِ
u'غَيْرٌ سَامِعٌ':Added, #1: 1	غَيْرِ سَامِعٍ
u'غير سَامِعٌ':Added, #1: 1	غَيْرِ سَامِعٍ
u'غَيْرٌ سَامِعٌ':Added, #3: 3	غَيْرِ السَّامِعِ
u'غير سَائِرٌ':Added, #3: 3	غَيْرِ السَّامِعِ
u'غَيْرٌ سَائِرٌ':Added, #1: 1	غَيْرُ سَائِرٍ
u'غير سَائِسٌ':Added, #1: 1	غَيْرُ سَائِرٍ
u'غَيْرٌ سَائِسٌ':Added, #1: 1	غَيْرَ سَائِسٍ
u'غير سَائِغٌ':Added, #1: 1	غَيْرَ سَائِسٍ
u'غَيْرٌ سَائِغٌ':Added, #1: 1	غَيْرَ سَائِغٍ
u'غير سَائِغٌ':Added, #1: 1	غَيْرَ سَائِغٍ
u'غَيْرٌ سَائِغٌ':Added, #2: 2	غَيْرِ سَائِغٍ
u'غير سَائِغٌ':Added, #2: 2	غَيْرِ سَائِغٍ
u'غَيْرٌ سَائِغٌ':Added, #6: 6	غَيْرُ سَائِغٍ
u'غير سَائِقٌ':Added, #6: 6	غَيْرُ سَائِغٍ
u'غير سَائِقٌ':Added, #1: 1	غَيْرُ السَّائِقِ
u'غَيْرٌ سَائِقٌ':Added, #1: 1	غَيْرِ السَّائِقِ
u'غَيْرٌ سَائِقٌ':Added, #1: 1	غَيْرُ السَّائِقِ
u'غير سَائِقٌ':Added, #1: 1	غَيْرِ السَّائِقِ
u'غَيْرٌ سَائِقٌ':Added, #1: 1	غَيْرُ السَّائِقَةِ
u'غير سَائِقٌ':Added, #1: 1	غَيْرُ السَّائِقَةِ
u'غَيْرٌ سَائِقٌ':Added, #1: 1	غَيْرَ سَائِقٍ
u'غير سائِل':Added, #1: 1	غَيْرَ سَائِقٍ
u'غير سَائِلٌ':Added, #1: 1	غَيْرَ السَّائِلِ
u'غَيْرٌ سائِل':Added, #1: 1	غَيْرَ السَّائِلِ
u'غَيْرٌ سَائِلٌ':Added, #1: 1	غَيْرَ السَّائِلِ
u'غير سائِل':Added, #1: 1	غَيْرَ السَّائِلِ
u'غير سائِل':Added, #1: 1	غَيْرَ سَائِلٍ
u'غير سَائِلٌ':Added, #1: 1	غَيْرِ سَائِلٍ
u'غير سَائِلٌ':Added, #1: 1	غَيْرَ سَائِلٍ
u'غَيْرٌ سائِل':Added, #1: 1	غَيْرِ سَائِلٍ
u'غَيْرٌ سائِل':Added, #1: 1	غَيْرَ سَائِلٍ
u'غَيْرٌ سَائِلٌ':Added, #1: 1	غَيْرِ سَائِلٍ
u'غَيْرٌ سَائِلٌ':Added, #1: 1	غَيْرَ سَائِلٍ
u'غير سائِل':Added, #1: 1	غَيْرِ سَائِلٍ
u'غير سَائِلٌ':Added, #2: 2	غَيْرُ سَائِلٍ
u'غَيْرٌ سائِل':Added, #2: 2	غَيْرُ سَائِلٍ
u'غَيْرٌ سَائِلٌ':Added, #2: 2	غَيْرُ سَائِلٍ
u'غير سائِل':Added, #2: 2	غَيْرُ سَائِلٍ
u'غير سَائِلٌ':Added, #3: 3	غَيْرِ السَّائِلِ
u'غَيْرٌ سائِل':Added, #3: 3	غَيْرِ السَّائِلِ
u'غَيْرٌ سَائِلٌ':Added, #3: 3	غَيْرِ السَّائِلِ
u'غير سَائِمَةٌ':Added, #3: 3	غَيْرِ السَّائِلِ
u'غَيْرٌ سَائِمَةٌ':Added, #14: 14	غَيْرِ السَّائِمَةِ
u'غير سَائِمَةٌ':Added, #14: 14	غَيْرِ السَّائِمَةِ
u'غَيْرٌ سَائِمَةٌ':Added, #2: 2	غَيْرُ السَّائِمَةِ
u'غير سَبٌّ':Added, #2: 2	غَيْرُ السَّائِمَةِ
u'غَيْرٌ سَبٌّ':Added, #1: 1	غَيْرِ سَبٍّ
u'غير سِباعٌ':Added, #1: 1	غَيْرِ سَبٍّ
u'غَيْرٌ سِباعٌ':Added, #1: 1	غَيْرَ سِبَاعِهِ
u'غير سَبَبٌ':Added, #1: 1	غَيْرَ سِبَاعِهِ
u'غَيْرٌ سَبَبٌ':Added, #1: 1	غَيْرُ سَبَبِ
u'غير سَبَبٌ':Added, #1: 1	غَيْرُ سَبَبِ
u'غَيْرٌ سَبَبٌ':Added, #2: 2	غَيْرُ السَّبَبِ
u'غير سَبَبٌ':Added, #2: 2	غَيْرُ السَّبَبِ
u'غَيْرٌ سَبَبٌ':Added, #30: 30	غَيْرِ سَبَبٍ
u'غير سَبَبٌ':Added, #30: 30	غَيْرِ سَبَبٍ
u'غَيْرٌ سَبَبٌ':Added, #3: 3	غَيْرَ السَّبَبِ
u'غير سَبَبٌ':Added, #3: 3	غَيْرَ السَّبَبِ
u'غَيْرٌ سَبَبٌ':Added, #4: 4	غَيْرِ سَبَبِهِ
u'غير سَبَبٌ':Added, #4: 4	غَيْرِ سَبَبِهِ
u'غَيْرٌ سَبَبٌ':Added, #5: 5	غَيْرِ السَّبَبِ
u'غير سَبَبٌ':Added, #5: 5	غَيْرِ السَّبَبِ
u'غَيْرٌ سَبَبٌ':Added, #9: 9	غَيْرِ سَبَبِ
u'غير سَبُعٌ':Added, #9: 9	غَيْرِ سَبَبِ
u'غَيْرٌ سَبُعٌ':Added, #1: 1	غَيْرَ سَبُعٍ
u'غير سَبْعٌ':Added, #1: 1	غَيْرَ سَبُعٍ
u'غَيْرٌ سَبْعٌ':Added, #2: 2	غَيْرُ سَبْعٍ
u'غير سَبْقٌ':Added, #2: 2	غَيْرُ سَبْعٍ
u'غَيْرٌ سَبْقٌ':Added, #13: 13	غَيْرِ سَبْقِ
u'غير سَبَقٌ':Added, #13: 13	غَيْرِ سَبْقِ
u'غَيْرٌ سَبَقٌ':Added, #1: 1	غَيْرِ سَبَقٍ
u'غير سَبْيٌ':Added, #1: 1	غَيْرِ سَبَقٍ
u'غَيْرٌ سَبْيٌ':Added, #1: 1	غَيْرِ سَبْيٍ
u'غير سَبِيلٌ':Added, #1: 1	غَيْرِ سَبْيٍ
u'غَيْرٌ سَبِيلٌ':Added, #2: 2	غَيْرُ سَبِيلِ
u'غير سَبِيلٌ':Added, #2: 2	غَيْرُ سَبِيلِ
u'غَيْرٌ سَبِيلٌ':Added, #32: 32	غَيْرِ السَّبِيلَيْنِ
u'غير سَبِيلٌ':Added, #32: 32	غَيْرِ السَّبِيلَيْنِ
u'غَيْرٌ سَبِيلٌ':Added, #4: 4	غَيْرِ سَبِيلِ
u'غير سَبِيلٌ':Added, #4: 4	غَيْرِ سَبِيلِ
u'غَيْرٌ سَبِيلٌ':Added, #5: 5	غَيْرِ السَّبِيلِ
u'غير سَبِيلٌ':Added, #5: 5	غَيْرِ السَّبِيلِ
u'غَيْرٌ سَبِيلٌ':Added, #7: 7	غَيْرَ سَبِيلِ
u'غير سَتْرٌ':Added, #7: 7	غَيْرَ سَبِيلِ
u'غَيْرٌ سَتْرٌ':Added, #1: 1	غَيْرِ سَتْرِ
u'غير سترة':Added, #1: 1	غَيْرِ سَتْرِ
u'غَيْرٌ سترة':Added, #1: 1	غَيْرِ السُّتْرَةِ
u'غير سُتْرَةٌ':Added, #1: 1	غَيْرِ السُّتْرَةِ
u'غَيْرٌ سُتْرَةٌ':Added, #1: 1	غَيْرِ السُّتْرَةِ
u'غير سترة':Added, #1: 1	غَيْرِ السُّتْرَةِ
u'غَيْرٌ سترة':Added, #9: 9	غَيْرِ سُتْرَةٍ
u'غير سُتْرَةٌ':Added, #9: 9	غَيْرِ سُتْرَةٍ
u'غَيْرٌ سُتْرَةٌ':Added, #9: 9	غَيْرِ سُتْرَةٍ
u'غير سجدة':Added, #9: 9	غَيْرِ سُتْرَةٍ
u'غَيْرٌ سجدة':Added, #1: 1	غَيْرُ السَّجْدَةِ
u'غير سَجْدَةٌ':Added, #1: 1	غَيْرُ السَّجْدَةِ
u'غَيْرٌ سَجْدَةٌ':Added, #1: 1	غَيْرُ السَّجْدَةِ
u'غير سجدة':Added, #1: 1	غَيْرُ السَّجْدَةِ
u'غَيْرٌ سجدة':Added, #1: 1	غَيْرِ سَجْدَةِ
u'غير سَجْدَةٌ':Added, #1: 1	غَيْرِ سَجْدَةِ
u'غَيْرٌ سَجْدَةٌ':Added, #1: 1	غَيْرِ سَجْدَةِ
u'غير سِجْنٌ':Added, #1: 1	غَيْرِ سَجْدَةِ
u'غَيْرٌ سِجْنٌ':Added, #1: 1	غَيْرِ السِّجْنِ
u'غير سِجْنٌ':Added, #1: 1	غَيْرِ السِّجْنِ
u'غَيْرٌ سِجْنٌ':Added, #1: 1	غَيْرِ سِجْنٍ
u'غير سُجُودٌ':Added, #1: 1	غَيْرِ سِجْنٍ
u'غَيْرٌ سُجُودٌ':Added, #1: 1	غَيْرَ السُّجُودِ
u'غير سَحابَةٌ':Added, #1: 1	غَيْرَ السُّجُودِ
u'غَيْرٌ سَحابَةٌ':Added, #1: 1	غَيْرِ سَحَابَةٍ
u'غير سَدَادٌ':Added, #1: 1	غَيْرِ سَحَابَةٍ
u'غَيْرٌ سَدَادٌ':Added, #1: 1	غَيْرِ السَّدَادِ
u'غير سَدَادٌ':Added, #1: 1	غَيْرِ السَّدَادِ
u'غَيْرٌ سَدَادٌ':Added, #1: 1	غَيْرَ سَدَادٍ
u'غير سَرَاوِيلُ':Added, #1: 1	غَيْرَ سَدَادٍ
u'غَيْرٌ سَرَاوِيلُ':Added, #1: 1	غَيْرِ السَّرَاوِيلِ
u'غير سَرَف':Added, #1: 1	غَيْرِ السَّرَاوِيلِ
u'غَيْرٌ سَرَف':Added, #10: 10	غَيْرِ سَرَفٍ
u'غير سَرَف':Added, #10: 10	غَيْرِ سَرَفٍ
u'غير سَرَف':Added, #1: 1	غَيْرَ سَرَفٍ
u'غَيْرٌ سَرَف':Added, #1: 1	غَيْرُ سَرَفٍ
u'غَيْرٌ سَرَف':Added, #1: 1	غَيْرَ سَرَفٍ
u'غير سَرقَةٌ':Added, #1: 1	غَيْرُ سَرَفٍ
u'غير سَرِقَةٌ':Added, #1: 1	غَيْرَ السَّرِقَةِ
u'غَيْرٌ سَرقَةٌ':Added, #1: 1	غَيْرَ السَّرِقَةِ
u'غَيْرٌ سَرِقَةٌ':Added, #1: 1	غَيْرَ السَّرِقَةِ
u'غير سَرقَةٌ':Added, #1: 1	غَيْرَ السَّرِقَةِ
u'غير سَرِقَةٌ':Added, #1: 1	غَيْرُ سَرِقَةِ
u'غَيْرٌ سَرقَةٌ':Added, #1: 1	غَيْرُ سَرِقَةِ
u'غَيْرٌ سَرِقَةٌ':Added, #1: 1	غَيْرُ سَرِقَةِ
u'غير سَرقَةٌ':Added, #1: 1	غَيْرُ سَرِقَةِ
u'غير سَرِقَةٌ':Added, #2: 2	غَيْرِ السَّرِقَةِ
u'غَيْرٌ سَرقَةٌ':Added, #2: 2	غَيْرِ السَّرِقَةِ
u'غَيْرٌ سَرِقَةٌ':Added, #2: 2	غَيْرِ السَّرِقَةِ
u'غير سَرقَةٌ':Added, #2: 2	غَيْرِ السَّرِقَةِ
u'غير سَرِقَةٌ':Added, #3: 3	غَيْرُ السَّرِقَةِ
u'غَيْرٌ سَرقَةٌ':Added, #3: 3	غَيْرُ السَّرِقَةِ
u'غَيْرٌ سَرِقَةٌ':Added, #3: 3	غَيْرُ السَّرِقَةِ
u'غير سُرُورٌ':Added, #3: 3	غَيْرُ السَّرِقَةِ
u'غَيْرٌ سُرُورٌ':Added, #1: 1	غَيْرَ سُرُورِ
u'غير سِعَايَةٌ':Added, #1: 1	غَيْرَ سُرُورِ
u'غَيْرٌ سِعَايَةٌ':Added, #7: 7	غَيْرِ سِعَايَةٍ
u'غير سَعْدٌ':Added, #7: 7	غَيْرِ سِعَايَةٍ
u'غَيْرٌ سَعْدٌ':Added, #1: 1	غَيْرُ سَعْدٍ
u'غير سَعِيدٌ':Added, #1: 1	غَيْرُ سَعْدٍ
u'غَيْرٌ سَعِيدٌ':Added, #3: 3	غَيْرُ سَعِيدِ
u'غير سفاح':Added, #3: 3	غَيْرُ سَعِيدِ
u'غَيْرٌ سفاح':Added, #1: 1	غَيْرِ سِفَاحٍ
u'غير سِفَاحٌ':Added, #1: 1	غَيْرِ سِفَاحٍ
u'غَيْرٌ سِفَاحٌ':Added, #1: 1	غَيْرِ سِفَاحٍ
u'غير سَفَرٌ':Added, #1: 1	غَيْرِ سِفَاحٍ
u'غَيْرٌ سَفَرٌ':Added, #1: 1	غَيْرَ السَّفَرِ
u'غير سَفَرٌ':Added, #1: 1	غَيْرَ السَّفَرِ
u'غَيْرٌ سَفَرٌ':Added, #1: 1	غَيْرِ سَفَرِ
u'غير سَفَرٌ':Added, #1: 1	غَيْرِ سَفَرِ
u'غَيْرٌ سَفَرٌ':Added, #2: 2	غَيْرَ سَفَرِ
u'غير سَفَرٌ':Added, #2: 2	غَيْرَ سَفَرِ
u'غَيْرٌ سَفَرٌ':Added, #3: 3	غَيْرِ السَّفَرِ
u'غير سَفَرٌ':Added, #3: 3	غَيْرِ السَّفَرِ
u'غَيْرٌ سَفَرٌ':Added, #3: 3	غَيْرِ سَفَرٍ
u'غير سَفِينَةٌ':Added, #3: 3	غَيْرِ سَفَرٍ
u'غَيْرٌ سَفِينَةٌ':Added, #1: 1	غَيْرِ السَّفِينَةِ
u'غير سَفِينَةٌ':Added, #1: 1	غَيْرِ السَّفِينَةِ
u'غَيْرٌ سَفِينَةٌ':Added, #2: 2	غَيْرَ سَفِينَةٍ
u'غير سَفِيهٌ':Added, #2: 2	غَيْرَ سَفِينَةٍ
u'غَيْرٌ سَفِيهٌ':Added, #2: 2	غَيْرِ السَّفِيهِ
u'غير سِقَايَةٌ':Added, #2: 2	غَيْرِ السَّفِيهِ
u'غَيْرٌ سِقَايَةٌ':Added, #1: 1	غَيْرُ السِّقَايَةِ
u'غير سِقَايَةٌ':Added, #1: 1	غَيْرُ السِّقَايَةِ
u'غَيْرٌ سِقَايَةٌ':Added, #1: 1	غَيْرِ سِقَايَتِهِ
u'غير سقط':Added, #1: 1	غَيْرِ سِقَايَتِهِ
u'غَيْرٌ سقط':Added, #1: 1	غَيْرِ السَّقْطِ
u'غير سِقْطٌ':Added, #1: 1	غَيْرِ السَّقْطِ
u'غَيْرٌ سِقْطٌ':Added, #1: 1	غَيْرِ سِقْطٍ
u'غير سقط':Added, #1: 1	غَيْرِ سِقْطٍ
u'غَيْرٌ سقط':Added, #2: 2	غَيْرِ السِّقْطِ
u'غير سِقْطٌ':Added, #2: 2	غَيْرِ السِّقْطِ
u'غَيْرٌ سِقْطٌ':Added, #2: 2	غَيْرِ السِّقْطِ
u'غير سَقْفٌ':Added, #2: 2	غَيْرِ السِّقْطِ
u'غَيْرٌ سَقْفٌ':Added, #1: 1	غَيْرُ سَقْفِ
u'غير سَقَمٌ':Added, #1: 1	غَيْرُ سَقْفِ
u'غَيْرٌ سَقَمٌ':Added, #1: 1	غَيْرِ سَقَمٍ
u'غير سُقُوطٌ':Added, #1: 1	غَيْرِ سَقَمٍ
u'غير سُقُوطٌ':Added, #1: 1	غَيْرِ سُقُوطٍ
u'غَيْرٌ سُقُوطٌ':Added, #1: 1	غَيْرِ سُقُوطِ
u'غَيْرٌ سُقُوطٌ':Added, #1: 1	غَيْرِ سُقُوطٍ
u'غير سَقْيٌ':Added, #1: 1	غَيْرِ سُقُوطِ
u'غَيْرٌ سَقْيٌ':Added, #2: 2	غَيْرِ سَقْيِ
u'غير سَقْيٌ':Added, #2: 2	غَيْرِ سَقْيِ
u'غَيْرٌ سَقْيٌ':Added, #3: 3	غَيْرِ سَقْيٍ
u'غير سُكَّانٌ':Added, #3: 3	غَيْرِ سَقْيٍ
u'غَيْرٌ سُكَّانٌ':Added, #1: 1	غَيْرِ سُكَّانِ
u'غير سِكَّةٌ':Added, #1: 1	غَيْرِ سُكَّانِ
u'غَيْرٌ سِكَّةٌ':Added, #2: 2	غَيْرِ السِّكَّةِ
u'غير سكتة':Added, #2: 2	غَيْرِ السِّكَّةِ
u'غَيْرٌ سكتة':Added, #1: 1	غَيْرِ سَكْتَةٍ
u'غير سَكْتَةٌ':Added, #1: 1	غَيْرِ سَكْتَةٍ
u'غَيْرٌ سَكْتَةٌ':Added, #1: 1	غَيْرِ سَكْتَةٍ
u'غير سُكْرٌ':Added, #1: 1	غَيْرِ سَكْتَةٍ
u'غَيْرٌ سُكْرٌ':Added, #1: 1	غَيْرِ سُكْرٍ
u'غير سُكُوتٌ':Added, #1: 1	غَيْرِ سُكْرٍ
u'غَيْرٌ سُكُوتٌ':Added, #3: 3	غَيْرِ سُكُوتٍ
u'غير سِلاَحٌ':Added, #3: 3	غَيْرِ سُكُوتٍ
u'غير سِلاَحٌ':Added, #1: 1	غَيْرُ السِّلَاحِ
u'غَيْرٌ سِلاَحٌ':Added, #1: 1	غَيْرِ السِّلَاحِ
u'غَيْرٌ سِلاَحٌ':Added, #1: 1	غَيْرُ السِّلَاحِ
u'غير سِلاَحٌ':Added, #1: 1	غَيْرِ السِّلَاحِ
u'غير سِلاَحٌ':Added, #1: 1	غَيْرَ سِلَاحٍ
u'غَيْرٌ سِلاَحٌ':Added, #1: 1	غَيْرِ سِلَاحٍ
u'غَيْرٌ سِلاَحٌ':Added, #1: 1	غَيْرَ سِلَاحٍ
u'غير سلام':Added, #1: 1	غَيْرِ سِلَاحٍ
u'غَيْرٌ سلام':Added, #1: 1	غَيْرُ السَّلَامِ
u'غير سَلاَمٌ':Added, #1: 1	غَيْرُ السَّلَامِ
u'غَيْرٌ سَلاَمٌ':Added, #1: 1	غَيْرُ السَّلَامِ
u'غير سلام':Added, #1: 1	غَيْرُ السَّلَامِ
u'غَيْرٌ سلام':Added, #1: 1	غَيْرُ سَلَامِ
u'غير سَلاَمٌ':Added, #1: 1	غَيْرُ سَلَامِ
u'غَيْرٌ سَلاَمٌ':Added, #1: 1	غَيْرُ سَلَامِ
u'غير سلام':Added, #1: 1	غَيْرُ سَلَامِ
u'غَيْرٌ سلام':Added, #2: 2	غَيْرِ السَّلَامِ
u'غير سَلاَمٌ':Added, #2: 2	غَيْرِ السَّلَامِ
u'غَيْرٌ سَلاَمٌ':Added, #2: 2	غَيْرِ السَّلَامِ
u'غير سلام':Added, #2: 2	غَيْرِ السَّلَامِ
u'غَيْرٌ سلام':Added, #2: 2	غَيْرَ سَلَامٍ
u'غير سَلاَمٌ':Added, #2: 2	غَيْرَ سَلَامٍ
u'غَيْرٌ سَلاَمٌ':Added, #2: 2	غَيْرَ سَلَامٍ
u'غير سلام':Added, #2: 2	غَيْرَ سَلَامٍ
u'غَيْرٌ سلام':Added, #4: 4	غَيْرِ سَلَامٍ
u'غير سَلاَمٌ':Added, #4: 4	غَيْرِ سَلَامٍ
u'غَيْرٌ سَلاَمٌ':Added, #4: 4	غَيْرِ سَلَامٍ
u'غير سَلْبٌ':Added, #4: 4	غَيْرِ سَلَامٍ
u'غَيْرٌ سَلْبٌ':Added, #1: 1	غَيْرَ سَلْبٍ
u'غَيَّرَ سُلْطَانٌ':Subject, #1: 1	غَيْرَ سَلْبٍ
u'غير سُلْطَانٌ':Added, #1: 1	غَيَّرَ السُّلْطَانُ
u'غَيْرٌ سُلْطَانٌ':Added, #12: 12	غَيْرِ السُّلْطَانِ
u'غير سُلْطَانٌ':Added, #12: 12	غَيْرِ السُّلْطَانِ
u'غَيْرٌ سُلْطَانٌ':Added, #1: 1	غَيْرَ السُّلْطَانِ
u'غير سُلْطَانٌ':Added, #1: 1	غَيْرَ السُّلْطَانِ
u'غَيْرٌ سُلْطَانٌ':Added, #1: 1	غَيْرَ سُلْطَانٍ
u'غير سُلْطَانٌ':Added, #1: 1	غَيْرَ سُلْطَانٍ
u'غَيْرٌ سُلْطَانٌ':Added, #5: 5	غَيْرُ السُّلْطَانِ
u'غير سُلْطَانٌ':Added, #5: 5	غَيْرُ السُّلْطَانِ
u'غَيْرٌ سُلْطَانٌ':Added, #6: 6	غَيْرِ سُلْطَانٍ
u'غير سَلْطَنَةٌ':Added, #6: 6	غَيْرِ سُلْطَانٍ
u'غَيْرٌ سَلْطَنَةٌ':Added, #1: 1	غَيْرُ السَّلْطَنَةِ
u'غير سَلَفٌ':Added, #1: 1	غَيْرُ السَّلْطَنَةِ
u'غَيْرٌ سَلَفٌ':Added, #1: 1	غَيْرِ السَّلَفِ
u'غير سَلَمٌ':Added, #1: 1	غَيْرِ السَّلَفِ
u'غَيْرٌ سَلَمٌ':Added, #1: 1	غَيْرُ السَّلَمِ
u'غير سُلُوكٌ':Added, #1: 1	غَيْرُ السَّلَمِ
u'غير سُلُوك':Added, #1: 1	غَيْرِ سُلُوكٍ
u'غَيْرٌ سُلُوكٌ':Added, #1: 1	غَيْرِ سُلُوكٍ
u'غَيْرٌ سُلُوك':Added, #1: 1	غَيْرِ سُلُوكٍ
u'غير سَلِيمٌ':Added, #1: 1	غَيْرِ سُلُوكٍ
u'غَيْرٌ سَلِيمٌ':Added, #1: 1	غَيْرِ السَّلِيمِ
u'غير سَمَاعٌ':Added, #1: 1	غَيْرِ السَّلِيمِ
u'غير سَمَاعٌ':Added, #1: 1	غَيْرَ السَّمَاعِ
u'غَيْرٌ سَمَاعٌ':Added, #1: 1	غَيْرِ السَّمَاعِ
u'غَيْرٌ سَمَاعٌ':Added, #1: 1	غَيْرَ السَّمَاعِ
u'غير سَمَاعٌ':Added, #1: 1	غَيْرِ السَّمَاعِ
u'غَيْرٌ سَمَاعٌ':Added, #5: 5	غَيْرِ سَمَاعٍ
u'غير سِماكٌ':Added, #5: 5	غَيْرِ سَمَاعٍ
u'غَيْرٌ سِماكٌ':Added, #1: 1	غَيْرُ سِمَاكٍ
u'غير سَمَاوِيٌّ':Added, #1: 1	غَيْرُ سِمَاكٍ
u'غَيْرٌ سَمَاوِيٌّ':Added, #3: 3	غَيْرَ سَمَاوِيَّةٍ
u'غير سَمْعٌ':Added, #3: 3	غَيْرَ سَمَاوِيَّةٍ
u'غَيْرٌ سَمْعٌ':Added, #1: 1	غَيْرِ سَمْعٍ
u'غير سَمَكٌ':Added, #1: 1	غَيْرِ سَمْعٍ
u'غَيْرٌ سَمَكٌ':Added, #1: 1	غَيْرِ السَّمَكِ
u'غير سَمَكٌ':Added, #1: 1	غَيْرِ السَّمَكِ
u'غَيْرٌ سَمَكٌ':Added, #5: 5	غَيْرُ السَّمَكِ
u'غير سَمَكٌ':Added, #5: 5	غَيْرُ السَّمَكِ
u'غَيْرٌ سَمَكٌ':Added, #6: 6	غَيْرَ السَّمَكِ
u'غير سِنٌّ':Added, #6: 6	غَيْرَ السَّمَكِ
u'غَيْرٌ سِنٌّ':Added, #1: 1	غَيْرَ سِنٍّ
u'غير سِنٌّ':Added, #1: 1	غَيْرَ سِنٍّ
u'غَيْرٌ سِنٌّ':Added, #2: 2	غَيْرُ السِّنِّ
u'غير سِنٌّ':Added, #2: 2	غَيْرُ السِّنِّ
u'غَيْرٌ سِنٌّ':Added, #2: 2	غَيْرِ سِنٍّ
u'غير سِنٌّ':Added, #2: 2	غَيْرِ سِنٍّ
u'غَيْرٌ سِنٌّ':Added, #2: 2	غَيْرِ سِنِّهِ
u'غير سِنٌّ':Added, #2: 2	غَيْرِ سِنِّهِ
u'غَيْرٌ سِنٌّ':Added, #3: 3	غَيْرِ السِّنِّ
u'غير سَنَامٌ':Added, #3: 3	غَيْرِ السِّنِّ
u'غَيْرٌ سَنَامٌ':Added, #1: 1	غَيْرَ السَّنَامِ
u'غير سَنَامٌ':Added, #1: 1	غَيْرَ السَّنَامِ
u'غَيْرٌ سَنَامٌ':Added, #2: 2	غَيْرِ السَّنَامِ
u'غير سُنَّةٌ':Added, #2: 2	غَيْرِ السَّنَامِ
u'غير سُنَّةٌ':Added, #1: 1	غَيْرَ السُّنَّةِ
u'غَيْرٌ سُنَّةٌ':Added, #1: 1	غَيْرُ السُّنَّةِ
u'غَيْرٌ سُنَّةٌ':Added, #1: 1	غَيْرَ السُّنَّةِ
u'غير سَنَةٌ':Added, #1: 1	غَيْرُ السُّنَّةِ
u'غَيْرٌ سَنَةٌ':Added, #1: 1	غَيْرَ سَنَةٍ
u'غير سَنَةٌ':Added, #1: 1	غَيْرَ سَنَةٍ
u'غير سُنَّةٌ':Added, #2: 2	غَيْرِ سَنَةِ
u'غَيْرٌ سَنَةٌ':Added, #2: 2	غَيْرُ سُنَّةِ
u'غَيْرٌ سُنَّةٌ':Added, #2: 2	غَيْرِ سَنَةِ
u'غير سُنَّةٌ':Added, #2: 2	غَيْرُ سُنَّةِ
u'غَيْرٌ سُنَّةٌ':Added, #3: 3	غَيْرِ السُّنَّةِ
u'غير سُنَّةٌ':Added, #3: 3	غَيْرِ السُّنَّةِ
u'غَيْرٌ سُنَّةٌ':Added, #3: 3	غَيْرِ سُنَّةٍ
u'غير سَنَةٌ':Added, #3: 3	غَيْرِ سُنَّةٍ
u'غَيْرٌ سَنَةٌ':Added, #4: 4	غَيْرَ السَّنَةِ
u'غير سُنَّةٌ':Added, #4: 4	غَيْرَ السَّنَةِ
u'غَيْرٌ سُنَّةٌ':Added, #4: 4	غَيْرَ سُنَّةِ
u'غير سُنَّةٌ':Added, #4: 4	غَيْرَ سُنَّةِ
u'غَيْرٌ سُنَّةٌ':Added, #7: 7	غَيْرِ سُنَّةِ
u'غير سنن':Added, #7: 7	غَيْرِ سُنَّةِ
u'غير سنن':Added, #1: 1	غَيْرُ السُّنَنِ
u'غَيْرٌ سنن':Added, #1: 1	غَيْرِ السَّنَنِ
u'غَيْرٌ سنن':Added, #1: 1	غَيْرُ السُّنَنِ
u'غير سَنَنٌ':Added, #1: 1	غَيْرِ السَّنَنِ
u'غَيْرٌ سَنَنٌ':Added, #1: 1	غَيْرِ السَّنَنِ
u'غير سَهَرٌ':Added, #1: 1	غَيْرِ السَّنَنِ
u'غَيْرٌ سَهَرٌ':Added, #1: 1	غَيْرِ سَهَرٍ
u'غير سَهْمٌ':Added, #1: 1	غَيْرِ سَهَرٍ
u'غَيْرٌ سَهْمٌ':Added, #1: 1	غَيْرِ السَّهْمِ
u'غير سَهْمٌ':Added, #1: 1	غَيْرِ السَّهْمِ
u'غَيْرٌ سَهْمٌ':Added, #1: 1	غَيْر سَهْمِهِ
u'غير سَهْمٌ':Added, #1: 1	غَيْر سَهْمِهِ
u'غَيْرٌ سَهْمٌ':Added, #2: 2	غَيْرُ سَهْمِهِ
u'غير سَهْوٌ':Added, #2: 2	غَيْرُ سَهْمِهِ
u'غَيْرٌ سَهْوٌ':Added, #1: 1	غَيْرِ السَّهْوِ
u'غير سُوءٌ':Added, #1: 1	غَيْرِ السَّهْوِ
u'غَيْرٌ سُوءٌ':Added, #1: 1	غَيْرِ سُوءٍ
u'غير سَواءٌ':Added, #1: 1	غَيْرِ سُوءٍ
u'غَيْرٌ سَواءٌ':Added, #1: 1	غَيْرَ سَوَاءٍ
u'غير سَوادٌ':Added, #1: 1	غَيْرَ سَوَاءٍ
u'غَيْرٌ سَوادٌ':Added, #1: 1	غَيْرِ السَّوَادِ
u'غير سَوادٌ':Added, #1: 1	غَيْرِ السَّوَادِ
u'غَيْرٌ سَوادٌ':Added, #2: 2	غَيْرَ السَّوَادِ
u'غير سَوادٌ':Added, #2: 2	غَيْرَ السَّوَادِ
u'غَيْرٌ سَوادٌ':Added, #3: 3	غَيْرُ السَّوَادِ
u'غير سُؤَالٌ':Added, #3: 3	غَيْرُ السَّوَادِ
u'غَيْرٌ سُؤَالٌ':Added, #19: 19	غَيْرِ سُؤَالٍ
u'غير سُؤَالٌ':Added, #19: 19	غَيْرِ سُؤَالٍ
u'غَيْرٌ سُؤَالٌ':Added, #1: 1	غَيْرَ السُّؤَالِ
u'غير سُؤَالٌ':Added, #1: 1	غَيْرَ السُّؤَالِ
u'غَيْرٌ سُؤَالٌ':Added, #1: 1	غَيْرَ سُؤَالٍ
u'غير سُؤَالٌ':Added, #1: 1	غَيْرَ سُؤَالٍ
u'غَيْرٌ سُؤَالٌ':Added, #5: 5	غَيْرِ سُؤَالِ
u'غير سَوائِمُ':Added, #5: 5	غَيْرِ سُؤَالِ
u'غير سَوائِمُ':Added, #1: 1	غَيْرَ السَّوَائِمِ
u'غير سَوَائِمُ':Added, #1: 1	غَيْرُ السَّوَائِمِ
u'غير سَوَائِمُ':Added, #1: 1	غَيْرَ السَّوَائِمِ
u'غَيْرٌ سَوائِمُ':Added, #1: 1	غَيْرُ السَّوَائِمِ
u'غَيْرٌ سَوائِمُ':Added, #1: 1	غَيْرَ السَّوَائِمِ
u'غَيْرٌ سَوَائِمُ':Added, #1: 1	غَيْرُ السَّوَائِمِ
u'غَيْرٌ سَوَائِمُ':Added, #1: 1	غَيْرَ السَّوَائِمِ
u'غير سَوائِمُ':Added, #1: 1	غَيْرُ السَّوَائِمِ
u'غير سَوَائِمُ':Added, #2: 2	غَيْرِ السَّوَائِمِ
u'غَيْرٌ سَوائِمُ':Added, #2: 2	غَيْرِ السَّوَائِمِ
u'غَيْرٌ سَوَائِمُ':Added, #2: 2	غَيْرِ السَّوَائِمِ
u'غير سُودانُ':Added, #2: 2	غَيْرِ السَّوَائِمِ
u'غَيْرٌ سُودانُ':Added, #1: 1	غَيْرَ السُّودَانِ
u'غير سُورَةٌ':Added, #1: 1	غَيْرَ السُّودَانِ
u'غَيْرٌ سُورَةٌ':Added, #1: 1	غَيْرَ سُورَةِ
u'غير سُورَةٌ':Added, #1: 1	غَيْرَ سُورَةِ
u'غَيْرٌ سُورَةٌ':Added, #2: 2	غَيْرِ السُّورَةِ
u'غير سُوقٌ':Added, #2: 2	غَيْرِ السُّورَةِ
u'غَيْرٌ سُوقٌ':Added, #2: 2	غَيْرِ السُّوقِ
u'غير سُوقٌ':Added, #2: 2	غَيْرِ السُّوقِ
u'غَيْرٌ سُوقٌ':Added, #2: 2	غَيْرِ سُوقِهِ
u'غير سَوِيٌّ':Added, #2: 2	غَيْرِ سُوقِهِ
u'غير سَوِيٌّ':Added, #1: 1	غَيْرَ سَوِيٍّ
u'غَيْرٌ سَوِيٌّ':Added, #1: 1	غَيْرُ سَوِيٍّ
u'غَيْرٌ سَوِيٌّ':Added, #1: 1	غَيْرَ سَوِيٍّ
u'غير سَيِّدٌ':Added, #1: 1	غَيْرُ سَوِيٍّ
u'غَيْرٌ سَيِّدٌ':Added, #17: 17	غَيْرِ السَّيِّدِ
u'غير سَيِّدٌ':Added, #17: 17	غَيْرِ السَّيِّدِ
u'غَيْرٌ سَيِّدٌ':Added, #1: 1	غَيْرُ السَّيِّدِ
u'غير سَيِّدٌ':Added, #1: 1	غَيْرُ السَّيِّدِ
u'غَيْرٌ سَيِّدٌ':Added, #1: 1	غَيْرَ سَيِّدِ
u'غير سَيِّدٌ':Added, #1: 1	غَيْرَ سَيِّدِ
u'غَيْرٌ سَيِّدٌ':Added, #2: 2	غَيْرَ السَّيِّدِ
u'غير سَيِّدٌ':Added, #2: 2	غَيْرَ السَّيِّدِ
u'غَيْرٌ سَيِّدٌ':Added, #3: 3	غَيْرُ سَيِّدِهِ
u'غير سَيِّدٌ':Added, #3: 3	غَيْرُ سَيِّدِهِ
u'غَيْرٌ سَيِّدٌ':Added, #6: 6	غَيْرِ سَيِّدِهِ
u'غير سَيْرٌ':Added, #6: 6	غَيْرِ سَيِّدِهِ
u'غَيْرٌ سَيْرٌ':Added, #1: 1	غَيْرِ سَيْرٍ
u'غير سيرَةٌ':Added, #1: 1	غَيْرِ سَيْرٍ
u'غَيْرٌ سيرَةٌ':Added, #1: 1	غَيْرِ سِيرَةِ
u'غير سيرَةٌ':Added, #1: 1	غَيْرِ سِيرَةِ
u'غَيْرٌ سيرَةٌ':Added, #8: 8	غَيْرِ السّيرَةِ
u'غير سَيْفٌ':Added, #8: 8	غَيْرِ السّيرَةِ
u'غَيْرٌ سَيْفٌ':Added, #1: 1	غَيْرِ السَّيْفِ
u'غير سَيْفٌ':Added, #1: 1	غَيْرِ السَّيْفِ
u'غَيْرٌ سَيْفٌ':Added, #1: 1	غَيْرُ سَيْفِهِ
u'غير سَيَلانٌ':Added, #1: 1	غَيْرُ سَيْفِهِ
u'غَيْرٌ سَيَلانٌ':Added, #1: 1	غَيْرَ السَّيَلَانِ
u'غير سَيَلانٌ':Added, #1: 1	غَيْرَ السَّيَلَانِ
u'غَيْرٌ سَيَلانٌ':Added, #1: 1	غَيْرِ سَيَلَانِ
u'غير سُيوفٌ':Added, #1: 1	غَيْرِ سَيَلَانِ
u'غَيْرٌ سُيوفٌ':Added, #1: 1	غَيْرِ السُّيُوفِ
u'غير شَابٌّ':Added, #1: 1	غَيْرِ السُّيُوفِ
u'غَيْرٌ شَابٌّ':Added, #1: 1	غَيْرُ الشَّابَّةِ
u'غير شَاةٌ':Added, #1: 1	غَيْرُ الشَّابَّةِ
u'غَيْرٌ شَاةٌ':Added, #1: 1	غَيْرُ الشَّاةِ
u'غير شَاةٌ':Added, #1: 1	غَيْرُ الشَّاةِ
u'غَيْرٌ شَاةٌ':Added, #1: 1	غَيْرُ شَاةٍ
u'غير شَارِبٌ':Added, #1: 1	غَيْرُ شَاةٍ
u'غَيْرٌ شَارِبٌ':Added, #1: 1	غَيْرُ الشَّارِبِ
u'غير شَارِبٌ':Added, #1: 1	غَيْرُ الشَّارِبِ
u'غَيْرٌ شَارِبٌ':Added, #3: 3	غَيْرِ الشَّارِبِ
u'غير شَارِحٌ':Added, #3: 3	غَيْرِ الشَّارِبِ
u'غَيْرٌ شَارِحٌ':Added, #1: 1	غَيْرَ الشَّارِحِ
u'غير شَارِعٌ':Added, #1: 1	غَيْرَ الشَّارِحِ
u'غَيْرٌ شَارِعٌ':Added, #1: 1	غَيْرُ الشَّارِعِ
u'غير شَارِعٌ':Added, #1: 1	غَيْرُ الشَّارِعِ
u'غَيْرٌ شَارِعٌ':Added, #1: 1	غَيْرُ شَارِعٍ
u'غير شَارِعٌ':Added, #1: 1	غَيْرُ شَارِعٍ
u'غَيْرٌ شَارِعٌ':Added, #5: 5	غَيْرِ الشَّارِعِ
u'غير شافِع':Added, #5: 5	غَيْرِ الشَّارِعِ
u'غَيْرٌ شافِع':Added, #1: 1	غَيْرِ الشَّافِعِيَّةِ
u'غير شافِعِيّ':Added, #1: 1	غَيْرِ الشَّافِعِيَّةِ
u'غَيْرٌ شافِعِيّ':Added, #1: 1	غَيْرِ الشَّافِعِيَّةِ
u'غير شافِعِيّ':Added, #1: 1	غَيْرِ الشَّافِعِيَّةِ
u'غير شافِعِيّ':Added, #2: 2	غَيْرُ الشَّافِعِيِّ
u'غَيْرٌ شافِعِيّ':Added, #2: 2	غَيْرِ الشَّافِعِيِّ
u'غَيْرٌ شافِعِيّ':Added, #2: 2	غَيْرُ الشَّافِعِيِّ
u'غير شَاقٌّ':Added, #2: 2	غَيْرِ الشَّافِعِيِّ
u'غَيْرٌ شَاقٌّ':Added, #1: 1	غَيْرُ شَاقٍّ
u'غير شَاكِرٌ':Added, #1: 1	غَيْرُ شَاقٍّ
u'غَيْرٌ شَاكِرٌ':Added, #1: 1	غَيْرِ شَاكِرٍ
u'غير شَامِتٌ':Added, #1: 1	غَيْرِ شَاكِرٍ
u'غَيْرٌ شَامِتٌ':Added, #1: 1	غَيْرَ شَامِتٍ
u'غير شَامِلٌ':Added, #1: 1	غَيْرَ شَامِتٍ
u'غَيْرٌ شَامِلٌ':Added, #1: 1	غَيْرَ شَامِلٍ
u'غير شَامِلٌ':Added, #1: 1	غَيْرَ شَامِلٍ
u'غَيْرٌ شَامِلٌ':Added, #5: 5	غَيْرُ شَامِلٍ
u'غير شَامِيٌّ':Added, #5: 5	غَيْرُ شَامِلٍ
u'غَيْرٌ شَامِيٌّ':Added, #1: 1	غَيْرِ الشَّامِيِّ
u'غَيَّرَ شَاهِدٌ':Subject, #1: 1	غَيْرِ الشَّامِيِّ
u'غير شَاهِدٌ':Added, #2: 2	غَيَّرَ الشَّاهِدُ
u'غَيْرٌ شَاهِدٌ':Added, #1: 1	غَيْرِ الشَّاهِدِ
u'غير شَاهِدٌ':Added, #1: 1	غَيْرِ الشَّاهِدِ
u'غَيْرٌ شَاهِدٌ':Added, #1: 1	غَيْرُ شَاهِدٍ
u'غير شَاهِدٌ':Added, #1: 1	غَيْرُ شَاهِدٍ
u'غَيْرٌ شَاهِدٌ':Added, #1: 1	غَيْرِ شَاهِدَيْنِ
u'غير شَاوِيشٌ':Added, #1: 1	غَيْرِ شَاهِدَيْنِ
u'غَيْرٌ شَاوِيشٌ':Added, #1: 1	غَيْرِ شَاوِيشٍ
u'غير شَائِعٌ':Added, #1: 1	غَيْرِ شَاوِيشٍ
u'غَيْرٌ شَائِعٌ':Added, #1: 1	غَيْرِ شَائِعٍ
u'غير شَائِعٌ':Added, #1: 1	غَيْرِ شَائِعٍ
u'غَيْرٌ شَائِعٌ':Added, #2: 2	غَيْرَ شَائِعٍ
u'غير شَائِعٌ':Added, #2: 2	غَيْرَ شَائِعٍ
u'غَيْرٌ شَائِعٌ':Added, #2: 2	غَيْرُ شَائِعَةٍ
u'غير شَائِعٌ':Added, #2: 2	غَيْرُ شَائِعَةٍ
u'غير شَائِعٌ':Added, #3: 3	غَيْرُ الشَّائِعِ
u'غَيْرٌ شَائِعٌ':Added, #3: 3	غَيْرِ الشَّائِعِ
u'غَيْرٌ شَائِعٌ':Added, #3: 3	غَيْرُ الشَّائِعِ
u'غير شَائِعٌ':Added, #3: 3	غَيْرِ الشَّائِعِ
u'غَيْرٌ شَائِعٌ':Added, #3: 3	غَيْرُ شَائِعٍ
u'غير شَائِعَةٌ':Added, #3: 3	غَيْرُ شَائِعٍ
u'غَيْرٌ شَائِعَةٌ':Added, #2: 2	غَيْرُ شَائِعَةٍ
u'غير شَائِنٌ':Added, #2: 2	غَيْرُ شَائِعَةٍ
u'غير شَائِنٌ':Added, #1: 1	غَيْرَ شَائِنٍ
u'غَيْرٌ شَائِنٌ':Added, #1: 1	غَيْرِ شَائِنٍ
u'غَيْرٌ شَائِنٌ':Added, #1: 1	غَيْرَ شَائِنٍ
u'غير شِبَعٌ':Added, #1: 1	غَيْرِ شَائِنٍ
u'غَيْرٌ شِبَعٌ':Added, #1: 1	غَيْرِ شِبَعٍ
u'غير شُبْهَةٌ':Added, #1: 1	غَيْرِ شِبَعٍ
u'غَيْرٌ شُبْهَةٌ':Added, #3: 3	غَيْرِ شُبْهَةٍ
u'غير شُبْهَةٌ':Added, #3: 3	غَيْرِ شُبْهَةٍ
u'غَيْرٌ شُبْهَةٌ':Added, #4: 4	غَيْرِ شُبْهَةِ
u'غير شَبِيهٌ':Added, #4: 4	غَيْرِ شُبْهَةِ
u'غَيْرٌ شَبِيهٌ':Added, #1: 1	غَيْرِ الشَّبِيهَةِ
u'غير شِتَاءٌ':Added, #1: 1	غَيْرِ الشَّبِيهَةِ
u'غَيْرٌ شِتَاءٌ':Added, #1: 1	غَيْرِ الشِّتَاءِ
u'غير شَجَرٌ':Added, #1: 1	غَيْرِ الشِّتَاءِ
u'غير شَجَرٌ':Added, #1: 1	غَيْرَ الشَّجَرِ
u'غير شَجَرٌ':Added, #1: 1	غَيْرُ الشَّجَرِ
u'غَيْرٌ شَجَرٌ':Added, #1: 1	غَيْرِ الشَّجَرِ
u'غَيْرٌ شَجَرٌ':Added, #1: 1	غَيْرَ الشَّجَرِ
u'غَيْرٌ شَجَرٌ':Added, #1: 1	غَيْرُ الشَّجَرِ
u'غير شَخْبٌ':Added, #1: 1	غَيْرِ الشَّجَرِ
u'غَيْرٌ شَخْبٌ':Added, #1: 1	غَيْرِ شَخْبٍ
u'غير شَدٌّ':Added, #1: 1	غَيْرِ شَخْبٍ
u'غَيْرٌ شَدٌّ':Added, #1: 1	غَيْرِ شَدٍّ
u'غير شِدَّةٌ':Added, #1: 1	غَيْرِ شَدٍّ
u'غَيْرٌ شِدَّةٌ':Added, #4: 4	غَيْرِ شِدَّةِ
u'غير شَدِيدٌ':Added, #4: 4	غَيْرِ شِدَّةِ
u'غَيْرٌ شَدِيدٌ':Added, #1: 1	غَيْرَ الشَّدِيدِ
u'غير شَدِيدٌ':Added, #1: 1	غَيْرَ الشَّدِيدِ
u'غَيْرٌ شَدِيدٌ':Added, #1: 1	غَيْرِ الشَّدِيدَةِ
u'غير شِرَاءٌ':Added, #1: 1	غَيْرِ الشَّدِيدَةِ
u'غير شِرَاءٌ':Added, #1: 1	غَيْرَ الشِّرَاءِ
u'غير شِرَاءٌ':Added, #1: 1	غَيْرُ الشِّرَاءِ
u'غَيْرٌ شِرَاءٌ':Added, #1: 1	غَيْرِ الشِّرَاءِ
u'غَيْرٌ شِرَاءٌ':Added, #1: 1	غَيْرَ الشِّرَاءِ
u'غَيْرٌ شِرَاءٌ':Added, #1: 1	غَيْرُ الشِّرَاءِ
u'غير شِرَاءٌ':Added, #1: 1	غَيْرِ الشِّرَاءِ
u'غير شِرَاءٌ':Added, #3: 3	غَيْرِ شِرَاءٍ
u'غَيْرٌ شِرَاءٌ':Added, #3: 3	غَيْرِ شِرَاءِ
u'غَيْرٌ شِرَاءٌ':Added, #3: 3	غَيْرِ شِرَاءٍ
u'غير شَرَابٌ':Added, #3: 3	غَيْرِ شِرَاءِ
u'غَيْرٌ شَرَابٌ':Added, #1: 1	غَيْرَ شَرَابٍ
u'غير شَرَابٌ':Added, #1: 1	غَيْرَ شَرَابٍ
u'غَيْرٌ شَرَابٌ':Added, #1: 1	غَيْرُ شَرَابِهِ
u'غير شَرَائِعُ':Added, #1: 1	غَيْرُ شَرَابِهِ
u'غَيْرٌ شَرَائِعُ':Added, #2: 2	غَيْرِ الشَّرَائِعِ
u'غير شرب':Added, #2: 2	غَيْرِ الشَّرَائِعِ
u'غَيْرٌ شرب':Added, #1: 1	غَيْرِ شُرْبِ
u'غير شُرْبٌ':Added, #1: 1	غَيْرِ شُرْبِ
u'غَيْرٌ شُرْبٌ':Added, #1: 1	غَيْرِ شُرْبِ
u'غير شرب':Added, #1: 1	غَيْرِ شُرْبِ
u'غَيْرٌ شرب':Added, #2: 2	غَيْرِ الشُّرْبِ
u'غير شُرْبٌ':Added, #2: 2	غَيْرِ الشُّرْبِ
u'غَيْرٌ شُرْبٌ':Added, #2: 2	غَيْرِ الشُّرْبِ
u'غير شَرْحٌ':Added, #2: 2	غَيْرِ الشُّرْبِ
u'غَيْرٌ شَرْحٌ':Added, #1: 1	غَيْرِ شَرْحِ
u'غير شَرْطٌ':Added, #1: 1	غَيْرِ شَرْحِ
u'غَيْرٌ شَرْطٌ':Added, #102: 102	غَيْرِ شَرْطٍ
u'غير شَرْطٌ':Added, #102: 102	غَيْرِ شَرْطٍ
u'غَيْرٌ شَرْطٌ':Added, #1: 1	غَيْرَ شَرْطٍ
u'غير شَرْطٌ':Added, #1: 1	غَيْرَ شَرْطٍ
u'غَيْرٌ شَرْطٌ':Added, #25: 25	غَيْرُ شَرْطٍ
u'غير شَرْطٌ':Added, #25: 25	غَيْرُ شَرْطٍ
u'غَيْرٌ شَرْطٌ':Added, #2: 2	غَيْرَ الشَّرْطِ
u'غير شَرْطٌ':Added, #2: 2	غَيْرَ الشَّرْطِ
u'غَيْرٌ شَرْطٌ':Added, #3: 3	غَيْرِ الشَّرْطِ
u'غير شَرْطٌ':Added, #3: 3	غَيْرِ الشَّرْطِ
u'غَيْرٌ شَرْطٌ':Added, #46: 46	غَيْرِ شَرْطِ
u'غير شَرْعٌ':Added, #46: 46	غَيْرِ شَرْطِ
u'غير شَرْعٌ':Added, #1: 1	غَيْرَ الشَّرْعِ
u'غَيْرٌ شَرْعٌ':Added, #1: 1	غَيْرُ الشَّرْعِ
u'غَيْرٌ شَرْعٌ':Added, #1: 1	غَيْرَ الشَّرْعِ
u'غير شَرْعٌ':Added, #1: 1	غَيْرُ الشَّرْعِ
u'غَيْرٌ شَرْعٌ':Added, #1: 1	غَيْرَ شَرْعِ
u'غير شَرْعٌ':Added, #1: 1	غَيْرَ شَرْعِ
u'غَيْرٌ شَرْعٌ':Added, #1: 1	غَيْرُ شَرْعِهِ
u'غير شَرْعٌ':Added, #1: 1	غَيْرُ شَرْعِهِ
u'غَيْرٌ شَرْعٌ':Added, #5: 5	غَيْرِ شَرْعٍ
u'غير شَرْعِيٌّ':Added, #5: 5	غَيْرِ شَرْعٍ
u'غَيْرٌ شَرْعِيٌّ':Added, #1: 1	غَيْرُ الشَّرْعِيِّ
u'غير شَرْعِيٌّ':Added, #1: 1	غَيْرُ الشَّرْعِيِّ
u'غَيْرٌ شَرْعِيٌّ':Added, #2: 2	غَيْرِ الشَّرْعِيِّ
u'غير شَرْعِيٌّ':Added, #2: 2	غَيْرِ الشَّرْعِيِّ
u'غَيْرٌ شَرْعِيٌّ':Added, #2: 2	غَيْرِ الشَّرْعِيَّةِ
u'غير شَرْعِيٌّ':Added, #2: 2	غَيْرِ الشَّرْعِيَّةِ
u'غير شَرْعِيٌّ':Added, #2: 2	غَيْرَ شَرْعِيَّةٍ
u'غَيْرٌ شَرْعِيٌّ':Added, #2: 2	غَيْرِ شَرْعِيَّةٍ
u'غَيْرٌ شَرْعِيٌّ':Added, #2: 2	غَيْرَ شَرْعِيَّةٍ
u'غير شَرْعِيٌّ':Added, #2: 2	غَيْرِ شَرْعِيَّةٍ
u'غَيْرٌ شَرْعِيٌّ':Added, #3: 3	غَيْرَ شَرْعِيٍّ
u'غير شَرْعِيٌّ':Added, #3: 3	غَيْرَ شَرْعِيٍّ
u'غَيْرٌ شَرْعِيٌّ':Added, #4: 4	غَيْرِ شَرْعِيٍّ
u'غير شِرْكٌ':Added, #4: 4	غَيْرِ شَرْعِيٍّ
u'غير شِرْكٌ':Added, #1: 1	غَيْرَ الشِّرْكِ
u'غَيْرٌ شِرْكٌ':Added, #1: 1	غَيْرُ الشِّرْكِ
u'غَيْرٌ شِرْكٌ':Added, #1: 1	غَيْرَ الشِّرْكِ
u'غير شركاء':Added, #1: 1	غَيْرُ الشِّرْكِ
u'غَيْرٌ شركاء':Added, #1: 1	غَيْرِ الشُّرَكَاءِ
u'غير شركاء':Added, #1: 1	غَيْرِ الشُّرَكَاءِ
u'غَيْرٌ شركاء':Added, #2: 2	غَيْرُ الشُّرَكَاءِ
u'غير شركة':Added, #2: 2	غَيْرُ الشُّرَكَاءِ
u'غَيْرٌ شركة':Added, #1: 1	غَيْرَ الشَّرِكَةِ
u'غير شَرِكَةٌ':Added, #1: 1	غَيْرَ الشَّرِكَةِ
u'غَيْرٌ شَرِكَةٌ':Added, #1: 1	غَيْرَ الشَّرِكَةِ
u'غير شركة':Added, #1: 1	غَيْرَ الشَّرِكَةِ
u'غير شركة':Added, #2: 2	غَيْرِ شَرِكَةٍ
u'غَيْرٌ شركة':Added, #2: 2	غَيْرِ شَرِكَةِ
u'غَيْرٌ شركة':Added, #2: 2	غَيْرِ شَرِكَةٍ
u'غير شَرِكَةٌ':Added, #2: 2	غَيْرِ شَرِكَةِ
u'غير شَرِكَةٌ':Added, #2: 2	غَيْرِ شَرِكَةٍ
u'غَيْرٌ شَرِكَةٌ':Added, #2: 2	غَيْرِ شَرِكَةِ
u'غَيْرٌ شَرِكَةٌ':Added, #2: 2	غَيْرِ شَرِكَةٍ
u'غير شُرُوطٌ':Added, #2: 2	غَيْرِ شَرِكَةِ
u'غير شُرُوطٌ':Added, #1: 1	غَيْرُ الشُّرُوطِ
u'غَيْرٌ شُرُوطٌ':Added, #1: 1	غَيْرِ الشُّرُوطِ
u'غَيْرٌ شُرُوطٌ':Added, #1: 1	غَيْرُ الشُّرُوطِ
u'غير شُرُوطٌ':Added, #1: 1	غَيْرِ الشُّرُوطِ
u'غَيْرٌ شُرُوطٌ':Added, #1: 1	غَيْرِ شُرُوطٍ
u'غير شَرِيعَةٌ':Added, #1: 1	غَيْرِ شُرُوطٍ
u'غَيْرٌ شَرِيعَةٌ':Added, #1: 1	غَيْرِ شَرِيعَةِ
u'غير شَرِيعَةٌ':Added, #1: 1	غَيْرِ شَرِيعَةِ
u'غَيْرٌ شَرِيعَةٌ':Added, #1: 1	غَيْرِ شَرِيعَتِهِ
u'غير شَرِيعَةٌ':Added, #1: 1	غَيْرِ شَرِيعَتِهِ
u'غَيْرٌ شَرِيعَةٌ':Added, #2: 2	غَيْرِ شَرِيعَةٍ
u'غير شَرِيفٌ':Added, #2: 2	غَيْرِ شَرِيعَةٍ
u'غَيْرٌ شَرِيفٌ':Added, #1: 1	غَيْرُ شَرِيفَيْنِ
u'غير شَرِيفٌ':Added, #1: 1	غَيْرُ شَرِيفَيْنِ
u'غَيْرٌ شَرِيفٌ':Added, #2: 2	غَيْرُ الشَّرِيفِ
u'غير شَرِيفٌ':Added, #2: 2	غَيْرُ الشَّرِيفِ
u'غَيْرٌ شَرِيفٌ':Added, #2: 2	غَيْرُ الشَّرِيفَةِ
u'غير شَرِيكٌ':Added, #2: 2	غَيْرُ الشَّرِيفَةِ
u'غَيْرٌ شَرِيكٌ':Added, #1: 1	غَيْرُ الشَّرِيكِ
u'غير شَرِيكٌ':Added, #1: 1	غَيْرُ الشَّرِيكِ
u'غَيْرٌ شَرِيكٌ':Added, #1: 1	غَيْرِ شَرِيكِ
u'غير شَرِيكٌ':Added, #1: 1	غَيْرِ شَرِيكِ
u'غَيْرٌ شَرِيكٌ':Added, #2: 2	غَيْرُ شَرِيكَيْنِ
u'غير شَرِيكٌ':Added, #2: 2	غَيْرُ شَرِيكَيْنِ
u'غَيْرٌ شَرِيكٌ':Added, #3: 3	غَيْرَ شَرِيكِهِ
u'غير شَرِيكٌ':Added, #3: 3	غَيْرَ شَرِيكِهِ
u'غَيْرٌ شَرِيكٌ':Added, #6: 6	غَيْرِ الشَّرِيكِ
u'غير شَرِيكٌ':Added, #6: 6	غَيْرِ الشَّرِيكِ
u'غَيْرٌ شَرِيكٌ':Added, #8: 8	غَيْرِ شَرِيكِهِ
u'غَيَّرَ شعار':Predicate, #8: 8	غَيْرِ شَرِيكِهِ
u'غَيَّرَ شِعَارٌ':Predicate, #1: 1	غَيَّرَ شِعَارَ
u'غير شَعْرٌ':Added, #1: 1	غَيَّرَ شِعَارَ
u'غير شَعْرٌ':Added, #1: 1	غَيْرُ الشَّعْرِ
u'غير شِعْرٌ':Added, #1: 1	غَيْرِ الشّعْرِ
u'غَيْرٌ شَعْرٌ':Added, #1: 1	غَيْرِ الشّعْرِ
u'غَيْرٌ شَعْرٌ':Added, #1: 1	غَيْرُ الشَّعْرِ
u'غَيْرٌ شِعْرٌ':Added, #1: 1	غَيْرِ الشّعْرِ
u'غير شَعْرٌ':Added, #1: 1	غَيْرِ الشّعْرِ
u'غَيْرٌ شَعْرٌ':Added, #1: 1	غَيْرَ شَعْرِ
u'غير شَعْرٌ':Added, #1: 1	غَيْرَ شَعْرِ
u'غَيْرٌ شَعْرٌ':Added, #1: 1	غَيْرَ شَعْرِهِ
u'غير شَعْرٌ':Added, #1: 1	غَيْرَ شَعْرِهِ
u'غير شَعْرٌ':Added, #2: 2	غَيْرَ شَعْرٍ
u'غَيْرٌ شَعْرٌ':Added, #2: 2	غَيْرُ شَعْرٍ
u'غَيْرٌ شَعْرٌ':Added, #2: 2	غَيْرَ شَعْرٍ
u'غير شَعْرٌ':Added, #2: 2	غَيْرُ شَعْرٍ
u'غَيْرٌ شَعْرٌ':Added, #4: 4	غَيْرِ الشَّعْرِ
u'غير شُعُورٌ':Added, #4: 4	غَيْرِ الشَّعْرِ
u'غَيْرٌ شُعُورٌ':Added, #3: 3	غَيْرِ شُعُورٍ
u'غير شُعُورٌ':Added, #3: 3	غَيْرِ شُعُورٍ
u'غَيْرٌ شُعُورٌ':Added, #3: 3	غَيْرِ شُعُورِهِ
u'غير شَعِيرٌ':Added, #3: 3	غَيْرِ شُعُورِهِ
u'غَيْرٌ شَعِيرٌ':Added, #1: 1	غَيْرِ شَعِيرٍ
u'غير شَفَاعَةٌ':Added, #1: 1	غَيْرِ شَعِيرٍ
u'غَيْرٌ شَفَاعَةٌ':Added, #1: 1	غَيْرِ شَفَاعَةِ
u'غير شِفَاهِيٌّ':Added, #1: 1	غَيْرِ شَفَاعَةِ
u'غَيْرٌ شِفَاهِيٌّ':Added, #1: 1	غَيْرِ الشِّفَاهِيِّ
u'غير شَفْعٌ':Added, #1: 1	غَيْرِ الشِّفَاهِيِّ
u'غَيْرٌ شَفْعٌ':Added, #1: 1	غَيْرِ الشَّفْعِ
u'غير شَفْعٌ':Added, #1: 1	غَيْرِ الشَّفْعِ
u'غَيْرٌ شَفْعٌ':Added, #1: 1	غَيْرِ شَفْعٍ
u'غير شَفْعٌ':Added, #1: 1	غَيْرِ شَفْعٍ
u'غَيْرٌ شَفْعٌ':Added, #2: 2	غَيْرَ الشَّفْعِ
u'غير شفعة':Added, #2: 2	غَيْرَ الشَّفْعِ
u'غَيْرٌ شفعة':Added, #1: 1	غَيْرِ الشُّفْعَةِ
u'غير شُفْعَةٌ':Added, #1: 1	غَيْرِ الشُّفْعَةِ
u'غَيْرٌ شُفْعَةٌ':Added, #1: 1	غَيْرِ الشُّفْعَةِ
u'غير شِقٌّ':Added, #1: 1	غَيْرِ الشُّفْعَةِ
u'غَيْرٌ شِقٌّ':Added, #1: 1	غَيْرِ الشِّقِّ
u'غير شَقٌّ':Added, #1: 1	غَيْرِ الشِّقِّ
u'غَيْرٌ شَقٌّ':Added, #1: 1	غَيْرِ شَقٍّ
u'غير شَقِيقٌ':Added, #1: 1	غَيْرِ شَقٍّ
u'غَيْرٌ شَقِيقٌ':Added, #1: 1	غَيْرَ الشَّقِيقَةِ
u'غير شَكٌّ':Added, #1: 1	غَيْرَ الشَّقِيقَةِ
u'غير شَكٌّ':Added, #1: 1	غَيْرُ الشَّكِّ
u'غَيْرٌ شَكٌّ':Added, #1: 1	غَيْرِ الشَّكِّ
u'غَيْرٌ شَكٌّ':Added, #1: 1	غَيْرُ الشَّكِّ
u'غير شَكٌّ':Added, #1: 1	غَيْرِ الشَّكِّ
u'غَيْرٌ شَكٌّ':Added, #1: 1	غَيْرِ شَكِّ
u'غير شَكٌّ':Added, #1: 1	غَيْرِ شَكِّ
u'غَيْرٌ شَكٌّ':Added, #24: 24	غَيْرِ شَكٍّ
u'غير شَكٌّ':Added, #24: 24	غَيْرِ شَكٍّ
u'غَيْرٌ شَكٌّ':Added, #2: 2	غَيْرَ شَكٍّ
u'غير شَكْلٌ':Added, #2: 2	غَيْرَ شَكٍّ
u'غَيْرٌ شَكْلٌ':Added, #1: 1	غَيْرِ الشَّكْلِ
u'غير شَمَاتَةٌ':Added, #1: 1	غَيْرِ الشَّكْلِ
u'غَيْرٌ شَمَاتَةٌ':Added, #1: 1	غَيْرَ شَمَاتَةِ
u'غير شمس':Added, #1: 1	غَيْرَ شَمَاتَةِ
u'غَيْرٌ شمس':Added, #1: 1	غَيْرَ الشَّمْسِ
u'غير شَمْسٌ':Added, #1: 1	غَيْرَ الشَّمْسِ
u'غَيْرٌ شَمْسٌ':Added, #1: 1	غَيْرَ الشَّمْسِ
u'غير شَمْعٌ':Added, #1: 1	غَيْرَ الشَّمْسِ
u'غَيْرٌ شَمْعٌ':Added, #1: 1	غَيْرَ شَمْعٍ
u'غَيَّرَ شَهَادَةٌ':Predicate, #1: 1	غَيْرَ شَمْعٍ
u'غير شَهَادَةٌ':Added, #1: 1	غَيَّرَ الشَّهَادَةَ
u'غَيْرٌ شَهَادَةٌ':Added, #19: 19	غَيْرِ شَهَادَةٍ
u'غير شَهَادَةٌ':Added, #19: 19	غَيْرِ شَهَادَةٍ
u'غَيْرٌ شَهَادَةٌ':Added, #1: 1	غَيْرِ شَهَادَةِ
u'غير شَهَادَةٌ':Added, #1: 1	غَيْرِ شَهَادَةِ
u'غَيْرٌ شَهَادَةٌ':Added, #2: 2	غَيْرَ الشَّهَادَاتِ
u'غير شَهَادَةٌ':Added, #2: 2	غَيْرَ الشَّهَادَاتِ
u'غَيْرٌ شَهَادَةٌ':Added, #2: 2	غَيْرِ الشَّهَادَةِ
u'غير شهداء':Added, #2: 2	غَيْرِ الشَّهَادَةِ
u'غَيْرٌ شهداء':Added, #1: 1	غَيْرِ الشُّهَدَاءِ
u'غير شَهْرٌ':Added, #1: 1	غَيْرِ الشُّهَدَاءِ
u'غير شَهْرٌ':Added, #1: 1	غَيْر الشَّهْرِ
u'غَيْرٌ شَهْرٌ':Added, #1: 1	غَيْرِ الشَّهْرِ
u'غَيْرٌ شَهْرٌ':Added, #1: 1	غَيْر الشَّهْرِ
u'غير شَهْرٌ':Added, #1: 1	غَيْرِ الشَّهْرِ
u'غير شَهْرٌ':Added, #1: 1	غَيْرَ شَهْرٍ
u'غَيْرٌ شَهْرٌ':Added, #1: 1	غَيْرِ شَهْرٍ
u'غَيْرٌ شَهْرٌ':Added, #1: 1	غَيْرَ شَهْرٍ
u'غير شَهْرٌ':Added, #1: 1	غَيْرِ شَهْرٍ
u'غَيْرٌ شَهْرٌ':Added, #7: 7	غَيْرِ شَهْرِ
u'غير شَهْوَةٌ':Added, #7: 7	غَيْرِ شَهْرِ
u'غَيْرٌ شَهْوَةٌ':Added, #10: 10	غَيْرِ شَهْوَةٍ
u'غير شُهُودٌ':Added, #10: 10	غَيْرِ شَهْوَةٍ
u'غير شُهُودٌ':Added, #1: 1	غَيْرُ الشُّهُودِ
u'غَيْرٌ شُهُودٌ':Added, #1: 1	غَيْرِ الشُّهُودِ
u'غَيْرٌ شُهُودٌ':Added, #1: 1	غَيْرُ الشُّهُودِ
u'غير شُهُودٌ':Added, #1: 1	غَيْرِ الشُّهُودِ
u'غَيْرٌ شُهُودٌ':Added, #1: 1	غَيْرَ شُهُودِ
u'غير شُهُودٌ':Added, #1: 1	غَيْرَ شُهُودِ
u'غَيْرٌ شُهُودٌ':Added, #3: 3	غَيْرِ شُهُودٍ
u'غير شَهِيدٌ':Added, #3: 3	غَيْرِ شُهُودٍ
u'غَيْرٌ شَهِيدٌ':Added, #1: 1	غَيْرُ الشَّهِيدِ
u'غير شَهِيدٌ':Added, #1: 1	غَيْرُ الشَّهِيدِ
u'غَيْرٌ شَهِيدٌ':Added, #2: 2	غَيْرِ الشَّهِيدِ
u'غير شَهِيدٌ':Added, #2: 2	غَيْرِ الشَّهِيدِ
u'غَيْرٌ شَهِيدٌ':Added, #2: 2	غَيْرُ شَهِيدِ
u'غير شَوَّالٌ':Added, #2: 2	غَيْرُ شَهِيدِ
u'غَيْرٌ شَوَّالٌ':Added, #6: 6	غَيْرِ شَوَّالٍ
u'غير شَوْطٌ':Added, #6: 6	غَيْرِ شَوَّالٍ
u'غَيْرٌ شَوْطٌ':Added, #3: 3	غَيْرِ الشَّوْطِ
u'غير شَيْءٌ':Added, #3: 3	غَيْرِ الشَّوْطِ
u'غير شَيْءٌ':Added, #1: 1	غَيْرَ الشَّيْءِ
u'غَيْرٌ شَيْءٌ':Added, #1: 1	غَيْرِ الشَّيْءِ
u'غَيْرٌ شَيْءٌ':Added, #1: 1	غَيْرَ الشَّيْءِ
u'غير شَيْءٌ':Added, #1: 1	غَيْرِ الشَّيْءِ
u'غَيْرٌ شَيْءٌ':Added, #2: 2	غَيْرُ الشَّيْءِ
u'غير شَيْءٌ':Added, #2: 2	غَيْرُ الشَّيْءِ
u'غَيْرٌ شَيْءٌ':Added, #3: 3	غَيْرُ شَيْءٍ
u'غير شَيْءٌ':Added, #3: 3	غَيْرُ شَيْءٍ
u'غَيْرٌ شَيْءٌ':Added, #41: 41	غَيْرِ شَيْءٍ
u'غير شَيْخٌ':Added, #41: 41	غَيْرِ شَيْءٍ
u'غَيْرٌ شَيْخٌ':Added, #1: 1	غَيْرَ الشَّيْخِ
u'غير شَيْخٌ':Added, #1: 1	غَيْرَ الشَّيْخِ
u'غَيْرٌ شَيْخٌ':Added, #1: 1	غَيْرُ الشَّيْخَيْنِ
u'غير شَيْخٌ':Added, #1: 1	غَيْرُ الشَّيْخَيْنِ
u'غَيْرٌ شَيْخٌ':Added, #2: 2	غَيْرُ الشَّيْخِ
u'غير شَيْخٌ':Added, #2: 2	غَيْرُ الشَّيْخِ
u'غَيْرٌ شَيْخٌ':Added, #6: 6	غَيْرِ الشَّيْخِ
u'غَيَّرَ شَيْطَانٌ':Subject, #6: 6	غَيْرِ الشَّيْخِ
u'غير شِيمَةٌ':Added, #1: 1	غَيَّرَ الشَّيْطَانُ
u'غَيْرٌ شِيمَةٌ':Added, #1: 1	غَيْرَ شِيمَتِهِ
u'غير شَيْنٌ':Added, #1: 1	غَيْرَ شِيمَتِهِ
u'غَيْرٌ شَيْنٌ':Added, #8: 8	غَيْرِ شَيْنٍ
u'غير شُيُوخٌ':Added, #8: 8	غَيْرِ شَيْنٍ
u'غَيْرٌ شُيُوخٌ':Added, #1: 1	غَيْرِ شُيُوخِ
u'غير صَاحِبٌ':Added, #1: 1	غَيْرِ شُيُوخِ
u'غَيْرٌ صَاحِبٌ':Added, #21: 21	غَيْرِ صَاحِبِ
u'غير صَاحِبٌ':Added, #21: 21	غَيْرِ صَاحِبِ
u'غَيْرٌ صَاحِبٌ':Added, #3: 3	غَيْرَ صَاحِبِ
u'غير صَاحِبٌ':Added, #3: 3	غَيْرَ صَاحِبِ
u'غَيْرٌ صَاحِبٌ':Added, #3: 3	غَيْرُ صَاحِبِهِ
u'غير صَاحِبٌ':Added, #3: 3	غَيْرُ صَاحِبِهِ
u'غَيْرٌ صَاحِبٌ':Added, #4: 4	غَيْرِ صَاحِبِهِ
u'غير صَاحِبٌ':Added, #4: 4	غَيْرِ صَاحِبِهِ
u'غَيْرٌ صَاحِبٌ':Added, #6: 6	غَيْرُ صَاحِبِ
u'غير صَادِقٌ':Added, #6: 6	غَيْرُ صَاحِبِ
u'غَيْرٌ صَادِقٌ':Added, #1: 1	غَيْرُ صَادِقٍ
u'غير صَادِقٌ':Added, #1: 1	غَيْرُ صَادِقٍ
u'غَيْرٌ صَادِقٌ':Added, #1: 1	غَيْرُ صَادِقَةٍ
u'غير صَادِقٌ':Added, #1: 1	غَيْرُ صَادِقَةٍ
u'غَيْرٌ صَادِقٌ':Added, #2: 2	غَيْرَ الصَّادِقِ
u'غير صَاعٌ':Added, #2: 2	غَيْرَ الصَّادِقِ
u'غَيْرٌ صَاعٌ':Added, #1: 1	غَيْرِ الصَّاعِ
u'غير صَاعٌ':Added, #1: 1	غَيْرِ الصَّاعِ
u'غَيْرٌ صَاعٌ':Added, #2: 2	غَيْرُ صَاعٍ
u'غير صَافِي':Added, #2: 2	غَيْرُ صَاعٍ
u'غَيْرٌ صَافِي':Added, #1: 1	غَيْرُ صَافِيَةٍ
u'غير صَالِحٌ':Added, #1: 1	غَيْرُ صَافِيَةٍ
u'غير صَالِح':Added, #10: 10	غَيْرَ صَالِحٍ
u'غَيْرٌ صَالِحٌ':Added, #10: 10	غَيْرَ صَالِحٍ
u'غَيْرٌ صَالِح':Added, #10: 10	غَيْرَ صَالِحٍ
u'غير صَالِحٌ':Added, #10: 10	غَيْرَ صَالِحٍ
u'غير صَالِح':Added, #1: 1	غَيْرِ الصَّالِحِ
u'غَيْرٌ صَالِحٌ':Added, #1: 1	غَيْرِ الصَّالِحِ
u'غَيْرٌ صَالِح':Added, #1: 1	غَيْرِ الصَّالِحِ
u'غير صَالِحٌ':Added, #1: 1	غَيْرِ الصَّالِحِ
u'غير صَالِح':Added, #1: 1	غَيْرِ الصَّالِحَاتِ
u'غَيْرٌ صَالِحٌ':Added, #1: 1	غَيْرِ الصَّالِحَاتِ
u'غَيْرٌ صَالِح':Added, #1: 1	غَيْرِ الصَّالِحَاتِ
u'غير صَالِحٌ':Added, #1: 1	غَيْرِ الصَّالِحَاتِ
u'غير صَالِح':Added, #1: 1	غَيْرَ الصَّالِحَةِ
u'غَيْرٌ صَالِحٌ':Added, #1: 1	غَيْرَ الصَّالِحَةِ
u'غَيْرٌ صَالِح':Added, #1: 1	غَيْرَ الصَّالِحَةِ
u'غير صَالِحٌ':Added, #1: 1	غَيْرَ الصَّالِحَةِ
u'غير صَالِح':Added, #1: 1	غَيْرِ صَالِحَةٍ
u'غَيْرٌ صَالِحٌ':Added, #1: 1	غَيْرِ صَالِحَةٍ
u'غَيْرٌ صَالِح':Added, #1: 1	غَيْرِ صَالِحَةٍ
u'غير صَالِحٌ':Added, #1: 1	غَيْرِ صَالِحَةٍ
u'غير صَالِح':Added, #23: 23	غَيْرُ صَالِحٍ
u'غَيْرٌ صَالِحٌ':Added, #23: 23	غَيْرُ صَالِحٍ
u'غَيْرٌ صَالِح':Added, #23: 23	غَيْرُ صَالِحٍ
u'غير صَالِحٌ':Added, #23: 23	غَيْرُ صَالِحٍ
u'غير صَالِح':Added, #3: 3	غَيْرِ صَالِحٍ
u'غَيْرٌ صَالِحٌ':Added, #3: 3	غَيْرِ صَالِحٍ
u'غَيْرٌ صَالِح':Added, #3: 3	غَيْرِ صَالِحٍ
u'غير صَالِحٌ':Added, #3: 3	غَيْرِ صَالِحٍ
u'غير صَالِح':Added, #4: 4	غَيْرَ صَالِحَةٍ
u'غَيْرٌ صَالِحٌ':Added, #4: 4	غَيْرَ صَالِحَةٍ
u'غَيْرٌ صَالِح':Added, #4: 4	غَيْرَ صَالِحَةٍ
u'غير صَالِحٌ':Added, #4: 4	غَيْرَ صَالِحَةٍ
u'غير صَالِح':Added, #6: 6	غَيْرُ صَالِحَةٍ
u'غَيْرٌ صَالِحٌ':Added, #6: 6	غَيْرُ صَالِحَةٍ
u'غَيْرٌ صَالِح':Added, #6: 6	غَيْرُ صَالِحَةٍ
u'غير صَائِدٌ':Added, #6: 6	غَيْرُ صَالِحَةٍ
u'غَيْرٌ صَائِدٌ':Added, #1: 1	غَيْرِ الصَّائِدِ
u'غير صَائِدٌ':Added, #1: 1	غَيْرِ الصَّائِدِ
u'غَيْرٌ صَائِدٌ':Added, #2: 2	غَيْرَ صَائِدٍ
u'غير صَائِمٌ':Added, #2: 2	غَيْرَ صَائِدٍ
u'غَيْرٌ صَائِمٌ':Added, #1: 1	غَيْرُ صَائِمَةٍ
u'غير صَائِمٌ':Added, #1: 1	غَيْرُ صَائِمَةٍ
u'غَيْرٌ صَائِمٌ':Added, #3: 3	غَيْرُ الصَّائِمِ
u'غير صَائِمٌ':Added, #3: 3	غَيْرُ الصَّائِمِ
u'غَيْرٌ صَائِمٌ':Added, #3: 3	غَيْرُ صَائِمٍ
u'غير صَائِمٌ':Added, #3: 3	غَيْرُ صَائِمٍ
u'غَيْرٌ صَائِمٌ':Added, #5: 5	غَيْرَ صَائِمٍ
u'غير صَبٌّ':Added, #5: 5	غَيْرَ صَائِمٍ
u'غَيْرٌ صَبٌّ':Added, #1: 1	غَيْرِ صَبِّ
u'غير صُبْحٌ':Added, #1: 1	غَيْرِ صَبِّ
u'غَيْرٌ صُبْحٌ':Added, #10: 10	غَيْرِ الصُّبْحِ
u'غير صُبْحٌ':Added, #10: 10	غَيْرِ الصُّبْحِ
u'غَيْرٌ صُبْحٌ':Added, #2: 2	غَيْرَ الصُّبْحِ
u'غير صبرة':Added, #2: 2	غَيْرَ الصُّبْحِ
u'غَيْرٌ صبرة':Added, #1: 1	غَيْرِ الصُّبْرَةِ
u'غير صُبْرَةٌ':Added, #1: 1	غَيْرِ الصُّبْرَةِ
u'غَيْرٌ صُبْرَةٌ':Added, #1: 1	غَيْرِ الصُّبْرَةِ
u'غير صَبِيٌّ':Added, #1: 1	غَيْرِ الصُّبْرَةِ
u'غَيْرٌ صَبِيٌّ':Added, #2: 2	غَيْرِ الصَّبِيِّ
u'غير صَبِيٌّ':Added, #2: 2	غَيْرِ الصَّبِيِّ
u'غَيْرٌ صَبِيٌّ':Added, #3: 3	غَيْرُ الصَّبِيِّ
u'غير صَحَابَةٌ':Added, #3: 3	غَيْرُ الصَّبِيِّ
u'غَيْرٌ صَحَابَةٌ':Added, #6: 6	غَيْرِ الصَّحَابَةِ
u'غير صَحَابِيٌّ':Added, #6: 6	غَيْرِ الصَّحَابَةِ
u'غَيْرٌ صَحَابِيٌّ':Added, #13: 13	غَيْرِ الصَّحَابِيِّ
u'غير صَحَابِيٌّ':Added, #13: 13	غَيْرِ الصَّحَابِيِّ
u'غَيْرٌ صَحَابِيٌّ':Added, #1: 1	غَيْرَ الصَّحَابِيِّ
u'غير صَحَابِيٌّ':Added, #1: 1	غَيْرَ الصَّحَابِيِّ
u'غَيْرٌ صَحَابِيٌّ':Added, #1: 1	غَيْرُ صَحَابِيٍّ
u'غير صَحَابِيٌّ':Added, #1: 1	غَيْرُ صَحَابِيٍّ
u'غَيْرٌ صَحَابِيٌّ':Added, #3: 3	غَيْرُ الصَّحَابِيِّ
u'غير صَحَابِيٌّ':Added, #3: 3	غَيْرُ الصَّحَابِيِّ
u'غَيْرٌ صَحَابِيٌّ':Added, #5: 5	غَيْرِ صَحَابِيٍّ
u'غير صَحْبٌ':Added, #5: 5	غَيْرِ صَحَابِيٍّ
u'غَيْرٌ صَحْبٌ':Added, #1: 1	غَيْرِ الصَّحْبِ
u'غير صحبة':Added, #1: 1	غَيْرِ الصَّحْبِ
u'غَيْرٌ صحبة':Added, #1: 1	غَيْرِ صُحْبَةِ
u'غير صُحْبَةٌ':Added, #1: 1	غَيْرِ صُحْبَةِ
u'غَيْرٌ صُحْبَةٌ':Added, #1: 1	غَيْرِ صُحْبَةِ
u'غير صِحَّةٌ':Added, #1: 1	غَيْرِ صُحْبَةِ
u'غَيْرٌ صِحَّةٌ':Added, #1: 1	غَيْرُ صِحَّةِ
u'غير صَحْرَاءُ':Added, #1: 1	غَيْرُ صِحَّةِ
u'غير صَحْرَاءُ':Added, #1: 1	غَيْرُ الصَّحْرَاءِ
u'غَيْرٌ صَحْرَاءُ':Added, #1: 1	غَيْرِ الصَّحْرَاءِ
u'غَيْرٌ صَحْرَاءُ':Added, #1: 1	غَيْرُ الصَّحْرَاءِ
u'غير صَحِيحٌ':Added, #1: 1	غَيْرِ الصَّحْرَاءِ
u'غَيْرٌ صَحِيحٌ':Added, #15: 15	غَيْرِ الصَّحِيحِ
u'غير صَحِيحٌ':Added, #15: 15	غَيْرِ الصَّحِيحِ
u'غير صَحِيحٌ':Added, #1: 1	غَيْر الصّحِيحِ
u'غير صَحِيحٌ':Added, #1: 1	غَيْرَ الصَّحِيحِ
u'غَيْرٌ صَحِيحٌ':Added, #1: 1	غَيْرُ الصَّحِيحِ
u'غَيْرٌ صَحِيحٌ':Added, #1: 1	غَيْر الصّحِيحِ
u'غَيْرٌ صَحِيحٌ':Added, #1: 1	غَيْرَ الصَّحِيحِ
u'غير صَحِيحٌ':Added, #1: 1	غَيْرُ الصَّحِيحِ
u'غَيْرٌ صَحِيحٌ':Added, #1: 1	غَيْرِ صَحِيحِهِ
u'غير صَخْرَةٌ':Added, #1: 1	غَيْرِ صَحِيحِهِ
u'غَيْرٌ صَخْرَةٌ':Added, #1: 1	غَيْرِ صَخْرَةٍ
u'غير صداق':Added, #1: 1	غَيْرِ صَخْرَةٍ
u'غَيْرٌ صداق':Added, #1: 1	غَيْرُ الصَّدَاقِ
u'غير صَدَاقٌ':Added, #1: 1	غَيْرُ الصَّدَاقِ
u'غَيْرٌ صَدَاقٌ':Added, #1: 1	غَيْرُ الصَّدَاقِ
u'غير صداق':Added, #1: 1	غَيْرُ الصَّدَاقِ
u'غَيْرٌ صداق':Added, #2: 2	غَيْرِ صَدَاقٍ
u'غير صَدَاقٌ':Added, #2: 2	غَيْرِ صَدَاقٍ
u'غَيْرٌ صَدَاقٌ':Added, #2: 2	غَيْرِ صَدَاقٍ
u'غير صداق':Added, #2: 2	غَيْرِ صَدَاقٍ
u'غَيْرٌ صداق':Added, #5: 5	غَيْرِ الصَّدَاقِ
u'غير صَدَاقٌ':Added, #5: 5	غَيْرِ الصَّدَاقِ
u'غَيْرٌ صَدَاقٌ':Added, #5: 5	غَيْرِ الصَّدَاقِ
u'غير صدق':Added, #5: 5	غَيْرِ الصَّدَاقِ
u'غَيْرٌ صدق':Added, #1: 1	غَيْرِ الصِّدْقِ
u'غير صِدْقٌ':Added, #1: 1	غَيْرِ الصِّدْقِ
u'غَيْرٌ صِدْقٌ':Added, #1: 1	غَيْرِ الصِّدْقِ
u'غير صدقة':Added, #1: 1	غَيْرِ الصِّدْقِ
u'غير صدقة':Added, #1: 1	غَيْرَ الصَّدَقَةِ
u'غير صدقة':Added, #1: 1	غَيْرُ الصَّدَقَةِ
u'غَيْرٌ صدقة':Added, #1: 1	غَيْرِ الصَّدَقَةِ
u'غَيْرٌ صدقة':Added, #1: 1	غَيْرَ الصَّدَقَةِ
u'غَيْرٌ صدقة':Added, #1: 1	غَيْرُ الصَّدَقَةِ
u'غير صَدَقَةٌ':Added, #1: 1	غَيْرِ الصَّدَقَةِ
u'غير صَدَقَةٌ':Added, #1: 1	غَيْرَ الصَّدَقَةِ
u'غير صَدَقَةٌ':Added, #1: 1	غَيْرُ الصَّدَقَةِ
u'غَيْرٌ صَدَقَةٌ':Added, #1: 1	غَيْرِ الصَّدَقَةِ
u'غَيْرٌ صَدَقَةٌ':Added, #1: 1	غَيْرَ الصَّدَقَةِ
u'غَيْرٌ صَدَقَةٌ':Added, #1: 1	غَيْرُ الصَّدَقَةِ
u'غير صدقة':Added, #1: 1	غَيْرِ الصَّدَقَةِ
u'غير صدقة':Added, #1: 1	غَيْرَ صَدَقَةِ
u'غَيْرٌ صدقة':Added, #1: 1	غَيْرِ صَدَقَةٍ
u'غَيْرٌ صدقة':Added, #1: 1	غَيْرَ صَدَقَةِ
u'غير صَدَقَةٌ':Added, #1: 1	غَيْرِ صَدَقَةٍ
u'غير صَدَقَةٌ':Added, #1: 1	غَيْرَ صَدَقَةِ
u'غَيْرٌ صَدَقَةٌ':Added, #1: 1	غَيْرِ صَدَقَةٍ
u'غَيْرٌ صَدَقَةٌ':Added, #1: 1	غَيْرَ صَدَقَةِ
u'غير صِدِّيقٌ':Added, #1: 1	غَيْرِ صَدَقَةٍ
u'غَيْرٌ صِدِّيقٌ':Added, #1: 1	غَيْرِ الصِّدِّيقِ
u'غير صَدِيقٌ':Added, #1: 1	غَيْرِ الصِّدِّيقِ
u'غَيْرٌ صَدِيقٌ':Added, #1: 1	غَيْرِ صَدِيقِهِ
u'غير صراخ':Added, #1: 1	غَيْرِ صَدِيقِهِ
u'غَيْرٌ صراخ':Added, #1: 1	غَيْرِ الصُّرَاخِ
u'غير صِرْفٌ':Added, #1: 1	غَيْرِ الصُّرَاخِ
u'غَيْرٌ صِرْفٌ':Added, #1: 1	غَيْرُ الصِّرْفِ
u'غير صَرْفٌ':Added, #1: 1	غَيْرُ الصِّرْفِ
u'غير صَرْف':Added, #6: 6	غَيْرِ الصَّرْفِ
u'غَيْرٌ صَرْفٌ':Added, #6: 6	غَيْرِ الصَّرْفِ
u'غَيْرٌ صَرْف':Added, #6: 6	غَيْرِ الصَّرْفِ
u'غير صَرِيحٌ':Added, #6: 6	غَيْرِ الصَّرْفِ
u'غَيْرٌ صَرِيحٌ':Added, #1: 1	غَيْرَ الصَّرِيحِ
u'غير صَرِيحٌ':Added, #1: 1	غَيْرَ الصَّرِيحِ
u'غَيْرٌ صَرِيحٌ':Added, #1: 1	غَيْرِ صَرِيحٍ
u'غير صَرِيحٌ':Added, #1: 1	غَيْرِ صَرِيحٍ
u'غَيْرٌ صَرِيحٌ':Added, #1: 1	غَيْرُ صَرِيحَةٍ
u'غير صَرِيحٌ':Added, #1: 1	غَيْرُ صَرِيحَةٍ
u'غَيْرٌ صَرِيحٌ':Added, #2: 2	غَيْرُ الصَّرِيحِ
u'غير صَرِيحٌ':Added, #2: 2	غَيْرُ الصَّرِيحِ
u'غَيْرٌ صَرِيحٌ':Added, #2: 2	غَيْرِ صَرِيحِ
u'غير صَرِيحٌ':Added, #2: 2	غَيْرِ صَرِيحِ
u'غَيْرٌ صَرِيحٌ':Added, #3: 3	غَيْرِ الصَّرِيحِ
u'غير صَرِيحٌ':Added, #3: 3	غَيْرِ الصَّرِيحِ
u'غَيْرٌ صَرِيحٌ':Added, #4: 4	غَيْرُ صَرِيحٍ
u'غير صَرِيحٌ':Added, #4: 4	غَيْرُ صَرِيحٍ
u'غَيْرٌ صَرِيحٌ':Added, #6: 6	غَيْرَ صَرِيحٍ
u'غير صغار':Added, #6: 6	غَيْرَ صَرِيحٍ
u'غَيْرٌ صغار':Added, #1: 1	غَيْرِ صِغَارِ
u'غير صَغِيرٌ':Added, #1: 1	غَيْرِ صِغَارِ
u'غَيْرٌ صَغِيرٌ':Added, #1: 1	غَيْرِ صَغِيرَةٍ
u'غير صَغِيرٌ':Added, #1: 1	غَيْرِ صَغِيرَةٍ
u'غَيْرٌ صَغِيرٌ':Added, #4: 4	غَيْرِ الصَّغِيرِ
u'غير صَفٌّ':Added, #4: 4	غَيْرِ الصَّغِيرِ
u'غير صَفٌّ':Added, #3: 3	غَيْرُ الصَّفِّ
u'غَيْرٌ صَفٌّ':Added, #3: 3	غَيْرِ الصَّفِّ
u'غَيْرٌ صَفٌّ':Added, #3: 3	غَيْرُ الصَّفِّ
u'غير صِفَةٌ':Added, #3: 3	غَيْرِ الصَّفِّ
u'غَيْرٌ صِفَةٌ':Added, #1: 1	غَيْرَ صِفَاتِ
u'غير صِفَةٌ':Added, #1: 1	غَيْرَ صِفَاتِ
u'غَيْرٌ صِفَةٌ':Added, #1: 1	غَيْرُ صِفَاتِهِ
u'غير صِفَةٌ':Added, #1: 1	غَيْرُ صِفَاتِهِ
u'غير صِفَةٌ':Added, #1: 1	غَيْرَ صِفَةِ
u'غير صِفَةٌ':Added, #1: 1	غَيْرُ صِفَةِ
u'غَيْرٌ صِفَةٌ':Added, #1: 1	غَيْرِ صِفَةٍ
u'غَيْرٌ صِفَةٌ':Added, #1: 1	غَيْرَ صِفَةِ
u'غَيْرٌ صِفَةٌ':Added, #1: 1	غَيْرُ صِفَةِ
u'غير صِفَةٌ':Added, #1: 1	غَيْرِ صِفَةٍ
u'غير صِفَةٌ':Added, #1: 1	غَيْرُ صِفَتِهِ
u'غَيْرٌ صِفَةٌ':Added, #1: 1	غَيْرِ صِفَتِهِ
u'غَيْرٌ صِفَةٌ':Added, #1: 1	غَيْرُ صِفَتِهِ
u'غير صِفَةٌ':Added, #1: 1	غَيْرِ صِفَتِهِ
u'غَيْرٌ صِفَةٌ':Added, #3: 3	غَيْرِ صِفَةِ
u'غير صِفَةٌ':Added, #3: 3	غَيْرِ صِفَةِ
u'غَيْرٌ صِفَةٌ':Added, #4: 4	غَيْرُ الصِّفَةِ
u'غير صِفَةٌ':Added, #4: 4	غَيْرُ الصِّفَةِ
u'غَيْرٌ صِفَةٌ':Added, #6: 6	غَيْرِ الصِّفَةِ
u'غير صَلاَةٌ':Added, #6: 6	غَيْرِ الصِّفَةِ
u'غَيْرٌ صَلاَةٌ':Added, #110: 110	غَيْرِ الصَّلَاةِ
u'غير صَلاَةٌ':Added, #110: 110	غَيْرِ الصَّلَاةِ
u'غير صَلاَةٌ':Added, #1: 1	غَيْرَ الصَّلَاةِ
u'غَيْرٌ صَلاَةٌ':Added, #1: 1	غَيْرِ الصَّلاَةِ
u'غَيْرٌ صَلاَةٌ':Added, #1: 1	غَيْرَ الصَّلَاةِ
u'غير صَلاَةٌ':Added, #1: 1	غَيْرِ الصَّلاَةِ
u'غير صَلاَةٌ':Added, #1: 1	غَيْرِ صَلاةٍ
u'غير صَلاَةٌ':Added, #1: 1	غَيْرَ صَلَاةِ
u'غير صَلاَةٌ':Added, #1: 1	غَيْرِ صَلاَةٍ
u'غَيْرٌ صَلاَةٌ':Added, #1: 1	غَيْرِ صَلاَةِ
u'غَيْرٌ صَلاَةٌ':Added, #1: 1	غَيْرِ صَلاةٍ
u'غَيْرٌ صَلاَةٌ':Added, #1: 1	غَيْرَ صَلَاةِ
u'غَيْرٌ صَلاَةٌ':Added, #1: 1	غَيْرِ صَلاَةٍ
u'غير صَلاَةٌ':Added, #1: 1	غَيْرِ صَلاَةِ
u'غَيْرٌ صَلاَةٌ':Added, #2: 2	غَيْرُ الصَّلَاةِ
u'غير صَلاَةٌ':Added, #2: 2	غَيْرُ الصَّلَاةِ
u'غَيْرٌ صَلاَةٌ':Added, #3: 3	غَيْرِ صَلَاتِهِ
u'غير صَلاَةٌ':Added, #3: 3	غَيْرِ صَلَاتِهِ
u'غَيْرٌ صَلاَةٌ':Added, #42: 42	غَيْرِ صَلَاةٍ
u'غير صَلاَةٌ':Added, #42: 42	غَيْرِ صَلَاةٍ
u'غَيْرٌ صَلاَةٌ':Added, #5: 5	غَيْرُ صَلَاةِ
u'غير صَلاَةٌ':Added, #5: 5	غَيْرُ صَلَاةِ
u'غَيْرٌ صَلاَةٌ':Added, #9: 9	غَيْرِ صَلَاةِ
u'غير صَلاَحٌ':Added, #9: 9	غَيْرِ صَلَاةِ
u'غَيْرٌ صَلاَحٌ':Added, #1: 1	غَيْرُ الصَّلَاحِ
u'غير صَلاَحٌ':Added, #1: 1	غَيْرُ الصَّلَاحِ
u'غَيْرٌ صَلاَحٌ':Added, #1: 1	غَيْرِ صَلَاحٍ
u'غير صلْبٌ':Added, #1: 1	غَيْرِ صَلَاحٍ
u'غير صَلْبٌ':Added, #1: 1	غَيْرِ صَلْبٍ
u'غَيْرٌ صلْبٌ':Added, #1: 1	غَيْرِ صَلْبٍ
u'غَيْرٌ صَلْبٌ':Added, #1: 1	غَيْرِ صَلْبٍ
u'غير صلح':Added, #1: 1	غَيْرِ صَلْبٍ
u'غَيْرٌ صلح':Added, #2: 2	غَيْرِ الصُّلْحِ
u'غير صُلْحٌ':Added, #2: 2	غَيْرِ الصُّلْحِ
u'غَيْرٌ صُلْحٌ':Added, #2: 2	غَيْرِ الصُّلْحِ
u'غير صَلَوَاتٌ':Added, #2: 2	غَيْرِ الصُّلْحِ
u'غير صَلَوَاتٌ':Added, #1: 1	غَيْرَ الصَّلَوَاتِ
u'غَيْرٌ صَلَوَاتٌ':Added, #1: 1	غَيْرِ الصَّلَوَاتِ
u'غَيْرٌ صَلَوَاتٌ':Added, #1: 1	غَيْرَ الصَّلَوَاتِ
u'غير صَلِيبٌ':Added, #1: 1	غَيْرِ الصَّلَوَاتِ
u'غَيْرٌ صَلِيبٌ':Added, #1: 1	غَيْرَ الصَّلِيبِ
u'غير صَمَّاء':Added, #1: 1	غَيْرَ الصَّلِيبِ
u'غَيْرٌ صَمَّاء':Added, #1: 1	غَيْرُ صَمَّاءِ
u'غير صمات':Added, #1: 1	غَيْرُ صَمَّاءِ
u'غَيْرٌ صمات':Added, #1: 1	غَيْرِ صُمَاتٍ
u'غير صنائع':Added, #1: 1	غَيْرِ صُمَاتٍ
u'غَيْرٌ صنائع':Added, #1: 1	غَيْرِ الصَّنَائِعِ
u'غير صَنَائِعُ':Added, #1: 1	غَيْرِ الصَّنَائِعِ
u'غَيْرٌ صَنَائِعُ':Added, #1: 1	غَيْرِ الصَّنَائِعِ
u'غير صنع':Added, #1: 1	غَيْرِ الصَّنَائِعِ
u'غَيْرٌ صنع':Added, #18: 18	غَيْرِ صُنْعِهِ
u'غير صُنْعٌ':Added, #18: 18	غَيْرِ صُنْعِهِ
u'غَيْرٌ صُنْعٌ':Added, #18: 18	غَيْرِ صُنْعِهِ
u'غير صُنْعٌ':Added, #18: 18	غَيْرِ صُنْعِهِ
u'غَيْرٌ صُنْعٌ':Added, #1: 1	غَيْر صُنْعٍ
u'غير صنع':Added, #1: 1	غَيْر صُنْعٍ
u'غَيْرٌ صنع':Added, #6: 6	غَيْرِ صُنْعِ
u'غير صُنْعٌ':Added, #6: 6	غَيْرِ صُنْعِ
u'غير صُنْعٌ':Added, #6: 6	غَيْرِ صُنْعٍ
u'غَيْرٌ صُنْعٌ':Added, #6: 6	غَيْرِ صُنْعِ
u'غَيْرٌ صُنْعٌ':Added, #6: 6	غَيْرِ صُنْعٍ
u'غير صنعة':Added, #6: 6	غَيْرِ صُنْعِ
u'غَيْرٌ صنعة':Added, #1: 1	غَيْرَ الصَّنْعَةِ
u'غير صَنْعَةٌ':Added, #1: 1	غَيْرَ الصَّنْعَةِ
u'غَيْرٌ صَنْعَةٌ':Added, #1: 1	غَيْرَ الصَّنْعَةِ
u'غير صنعة':Added, #1: 1	غَيْرَ الصَّنْعَةِ
u'غَيْرٌ صنعة':Added, #5: 5	غَيْرِ صَنْعَةٍ
u'غير صَنْعَةٌ':Added, #5: 5	غَيْرِ صَنْعَةٍ
u'غَيْرٌ صَنْعَةٌ':Added, #5: 5	غَيْرِ صَنْعَةٍ
u'غير صِنْفٌ':Added, #5: 5	غَيْرِ صَنْعَةٍ
u'غَيْرٌ صِنْفٌ':Added, #1: 1	غَيْرِ الصِّنْفِ
u'غير صِنْفٌ':Added, #1: 1	غَيْرِ الصِّنْفِ
u'غير صِنْفٌ':Added, #1: 1	غَيْرَ صِنْفٍ
u'غَيْرٌ صِنْفٌ':Added, #1: 1	غَيْرُ صِنْفِ
u'غَيْرٌ صِنْفٌ':Added, #1: 1	غَيْرَ صِنْفٍ
u'غير صِنْفٌ':Added, #1: 1	غَيْرُ صِنْفِ
u'غَيْرٌ صِنْفٌ':Added, #4: 4	غَيْرِ صِنْفِهِ
u'غير صَوَابٌ':Added, #4: 4	غَيْرِ صِنْفِهِ
u'غير صَوَابٌ':Added, #1: 1	غَيْرَ الصَّوَابِ
u'غَيْرٌ صَوَابٌ':Added, #1: 1	غَيْرُ الصَّوَابِ
u'غَيْرٌ صَوَابٌ':Added, #1: 1	غَيْرَ الصَّوَابِ
u'غير صَوَابٌ':Added, #1: 1	غَيْرُ الصَّوَابِ
u'غَيْرٌ صَوَابٌ':Added, #2: 2	غَيْرِ الصَّوَابِ
u'غير صَوَابٌ':Added, #2: 2	غَيْرِ الصَّوَابِ
u'غَيْرٌ صَوَابٌ':Added, #3: 3	غَيْرُ صَوَابٍ
u'غير صَوْبٌ':Added, #3: 3	غَيْرُ صَوَابٍ
u'غير صَوْبٌ':Added, #1: 1	غَيْرِ صَوْبٍ
u'غَيْرٌ صَوْبٌ':Added, #1: 1	غَيْرِ صَوْبِ
u'غَيْرٌ صَوْبٌ':Added, #1: 1	غَيْرِ صَوْبٍ
u'غير صَوْتٌ':Added, #1: 1	غَيْرِ صَوْبِ
u'غَيْرٌ صَوْتٌ':Added, #1: 1	غَيْرِ صَوْتِ
u'غير صَوْتٌ':Added, #1: 1	غَيْرِ صَوْتِ
u'غَيْرٌ صَوْتٌ':Added, #7: 7	غَيْرِ صَوْتٍ
u'غير صُورٌ':Added, #7: 7	غَيْرِ صَوْتٍ
u'غير صُوَرٌ':Added, #1: 1	غَيْرِ الصُّوَرِ
u'غَيْرٌ صُورٌ':Added, #1: 1	غَيْرِ الصُّوَرِ
u'غَيْرٌ صُوَرٌ':Added, #1: 1	غَيْرِ الصُّوَرِ
u'غير صُورٌ':Added, #1: 1	غَيْرِ الصُّوَرِ
u'غير صُورٌ':Added, #1: 1	غَيْرُ صُوَرِ
u'غير صُوَرٌ':Added, #1: 1	غَيْرِ صُوَرِ
u'غير صُوَرٌ':Added, #1: 1	غَيْرُ صُوَرِ
u'غَيْرٌ صُورٌ':Added, #1: 1	غَيْرِ صُوَرِ
u'غَيْرٌ صُورٌ':Added, #1: 1	غَيْرُ صُوَرِ
u'غَيْرٌ صُوَرٌ':Added, #1: 1	غَيْرِ صُوَرِ
u'غَيْرٌ صُوَرٌ':Added, #1: 1	غَيْرُ صُوَرِ
u'غير صُورٌ':Added, #1: 1	غَيْرِ صُوَرِ
u'غَيْرٌ صُورٌ':Added, #1: 1	غَيْرَ صُورَتَيْنِ
u'غير صُورَةٌ':Added, #1: 1	غَيْرَ صُورَتَيْنِ
u'غَيْرٌ صُورَةٌ':Added, #12: 12	غَيْرِ صُورَةِ
u'غير صُورَةٌ':Added, #12: 12	غَيْرِ صُورَةِ
u'غير صُورَةٌ':Added, #1: 1	غَيْر صُورَةٍ
u'غير صُورَةٌ':Added, #1: 1	غَيْرَ صُورَةِ
u'غَيْرٌ صُورَةٌ':Added, #1: 1	غَيْرِ صُورَةٍ
u'غَيْرٌ صُورَةٌ':Added, #1: 1	غَيْر صُورَةٍ
u'غَيْرٌ صُورَةٌ':Added, #1: 1	غَيْرَ صُورَةِ
u'غير صُورَةٌ':Added, #1: 1	غَيْرِ صُورَةٍ
u'غَيْرٌ صُورَةٌ':Added, #2: 2	غَيْرُ صُورَةِ
u'غير صُورَةٌ':Added, #2: 2	غَيْرُ صُورَةِ
u'غَيْرٌ صُورَةٌ':Added, #3: 3	غَيْرُ الصُّورَةِ
u'غير صُوفٌ':Added, #3: 3	غَيْرُ الصُّورَةِ
u'غَيْرٌ صُوفٌ':Added, #4: 4	غَيْرَ الصُّوفِ
u'غير صُوفِيٌّ':Added, #4: 4	غَيْرَ الصُّوفِ
u'غَيْرٌ صُوفِيٌّ':Added, #1: 1	غَيْرِ الصُّوفِيَّةِ
u'غير صُوفِيَّةٌ':Added, #1: 1	غَيْرِ الصُّوفِيَّةِ
u'غَيْرٌ صُوفِيَّةٌ':Added, #1: 1	غَيْرِ الصُّوفِيَّةِ
u'غير صَوْمٌ':Added, #1: 1	غَيْرِ الصُّوفِيَّةِ
u'غَيْرٌ صَوْمٌ':Added, #3: 3	غَيْرَ صَوْمِ
u'غير صَوْمٌ':Added, #3: 3	غَيْرَ صَوْمِ
u'غير صَوْمٌ':Added, #4: 4	غَيْرُ الصَّوْمِ
u'غَيْرٌ صَوْمٌ':Added, #4: 4	غَيْرِ الصَّوْمِ
u'غَيْرٌ صَوْمٌ':Added, #4: 4	غَيْرُ الصَّوْمِ
u'غير صَوْمٌ':Added, #4: 4	غَيْرِ الصَّوْمِ
u'غَيْرٌ صَوْمٌ':Added, #5: 5	غَيْرِ صَوْمٍ
u'غير صَيَّادٌ':Added, #5: 5	غَيْرِ صَوْمٍ
u'غَيْرٌ صَيَّادٌ':Added, #1: 1	غَيْرِ الصَّيَّادَةِ
u'غير صَيَارِفَةٌ':Added, #1: 1	غَيْرِ الصَّيَّادَةِ
u'غَيْرٌ صَيَارِفَةٌ':Added, #4: 4	غَيْرِ الصَّيَارِفَةِ
u'غير صِيَاغَةٌ':Added, #4: 4	غَيْرِ الصَّيَارِفَةِ
u'غَيْرٌ صِيَاغَةٌ':Added, #1: 1	غَيْرِ صِيَاغَتِهِ
u'غير صِيَامٌ':Added, #1: 1	غَيْرِ صِيَاغَتِهِ
u'غَيْرٌ صِيَامٌ':Added, #1: 1	غَيْرِ الصِّيَامِ
u'غير صِيَامٌ':Added, #1: 1	غَيْرِ الصِّيَامِ
u'غَيْرٌ صِيَامٌ':Added, #3: 3	غَيْرَ الصِّيَامِ
u'غير صِيَانَةٌ':Added, #3: 3	غَيْرَ الصِّيَامِ
u'غَيْرٌ صِيَانَةٌ':Added, #1: 1	غَيْرِ صِيَانَةٍ
u'غير صَيْدٌ':Added, #1: 1	غَيْرِ صِيَانَةٍ
u'غَيْرٌ صَيْدٌ':Added, #1: 1	غَيْرِ صَيْدِ
u'غير صَيْدٌ':Added, #1: 1	غَيْرِ صَيْدِ
u'غير صَيْدٌ':Added, #2: 2	غَيْرُ الصَّيْدِ
u'غَيْرٌ صَيْدٌ':Added, #2: 2	غَيْرِ الصَّيْدِ
u'غَيْرٌ صَيْدٌ':Added, #2: 2	غَيْرُ الصَّيْدِ
u'غير صَيْدٌ':Added, #2: 2	غَيْرِ الصَّيْدِ
u'غير صَيْدٌ':Added, #2: 2	غَيْرَ صَيْدٍ
u'غَيْرٌ صَيْدٌ':Added, #2: 2	غَيْرُ صَيْدٍ
u'غَيْرٌ صَيْدٌ':Added, #2: 2	غَيْرَ صَيْدٍ
u'غير صَيْدٌ':Added, #2: 2	غَيْرُ صَيْدٍ
u'غَيْرٌ صَيْدٌ':Added, #5: 5	غَيْرَ الصَّيْدِ
u'غير صَيْدٌ':Added, #5: 5	غَيْرَ الصَّيْدِ
u'غَيْرٌ صَيْدٌ':Added, #6: 6	غَيْرِ صَيْدٍ
u'غير صِيَغٌ':Added, #6: 6	غَيْرِ صَيْدٍ
u'غَيْرٌ صِيَغٌ':Added, #1: 1	غَيْرِ الصِّيَغِ
u'غير صِيغَةٌ':Added, #1: 1	غَيْرِ الصِّيَغِ
u'غَيْرٌ صِيغَةٌ':Added, #1: 1	غَيْرَ الصِّيغَةِ
u'غير صِيغَةٌ':Added, #1: 1	غَيْرَ الصِّيغَةِ
u'غَيْرٌ صِيغَةٌ':Added, #1: 1	غَيْرِ صِيغَتِهِ
u'غير صِيغَةٌ':Added, #1: 1	غَيْرِ صِيغَتِهِ
u'غَيْرٌ صِيغَةٌ':Added, #2: 2	غَيْرِ صِيغَةِ
u'غير ضَاحِكٌ':Added, #2: 2	غَيْرِ صِيغَةِ
u'غَيْرٌ ضَاحِكٌ':Added, #1: 1	غَيْرَ ضَاحِكٍ
u'غير ضَارٌّ':Added, #1: 1	غَيْرَ ضَاحِكٍ
u'غَيْرٌ ضَارٌّ':Added, #5: 5	غَيْرَ ضَارٍّ
u'غير ضَارِبٌ':Added, #5: 5	غَيْرَ ضَارٍّ
u'غَيْرٌ ضَارِبٌ':Added, #1: 1	غَيْرُ ضَارِبٍ
u'غير ضَارِبٌ':Added, #1: 1	غَيْرُ ضَارِبٍ
u'غَيْرٌ ضَارِبٌ':Added, #3: 3	غَيْرَ ضَارِبِهِ
u'غير ضَالٌّ':Added, #3: 3	غَيْرَ ضَارِبِهِ
u'غَيْرٌ ضَالٌّ':Added, #1: 1	غَيْرَ ضَالِّ
u'غير ضَامِنٌ':Added, #1: 1	غَيْرَ ضَالِّ
u'غَيْرٌ ضَامِنٌ':Added, #1: 1	غَيْرِ الضَّامِنِ
u'غير ضَامِنٌ':Added, #1: 1	غَيْرِ الضَّامِنِ
u'غير ضَامِنٌ':Added, #1: 1	غَيْرَ ضَامِنٍ
u'غَيْرٌ ضَامِنٌ':Added, #1: 1	غَيْرُ ضَامِنٍ
u'غَيْرٌ ضَامِنٌ':Added, #1: 1	غَيْرَ ضَامِنٍ
u'غير ضَامِنٌ':Added, #1: 1	غَيْرُ ضَامِنٍ
u'غَيْرٌ ضَامِنٌ':Added, #1: 1	غَيْرُ ضَامِنَةٍ
u'غير ضَامِنٌ':Added, #1: 1	غَيْرُ ضَامِنَةٍ
u'غَيْرٌ ضَامِنٌ':Added, #2: 2	غَيْرَ ضَامِنَةٍ
u'غير ضَأْنٌ':Added, #2: 2	غَيْرَ ضَامِنَةٍ
u'غَيْرٌ ضَأْنٌ':Added, #1: 1	غَيْرِ الضَّأْنِ
u'غير ضَائِعٌ':Added, #1: 1	غَيْرِ الضَّأْنِ
u'غير ضَائِعٌ':Added, #1: 1	غَيْرَ ضَائِعٍ
u'غَيْرٌ ضَائِعٌ':Added, #1: 1	غَيْرُ ضَائِعِ
u'غَيْرٌ ضَائِعٌ':Added, #1: 1	غَيْرَ ضَائِعٍ
u'غير ضَحِيَّةٌ':Added, #1: 1	غَيْرُ ضَائِعِ
u'غَيْرٌ ضَحِيَّةٌ':Added, #1: 1	غَيْرِ الضَّحِيَّةِ
u'غير ضِدٌّ':Added, #1: 1	غَيْرِ الضَّحِيَّةِ
u'غَيْرٌ ضِدٌّ':Added, #1: 1	غَيْرِ ضِدِّ
u'غير ضَرْبٌ':Added, #1: 1	غَيْرِ ضِدِّ
u'غَيْرٌ ضَرْبٌ':Added, #1: 1	غَيْرَ ضَرْبِ
u'غير ضَرْبٌ':Added, #1: 1	غَيْرَ ضَرْبِ
u'غَيْرٌ ضَرْبٌ':Added, #2: 2	غَيْرِ ضَرْبِ
u'غير ضَرْبٌ':Added, #2: 2	غَيْرِ ضَرْبِ
u'غَيْرٌ ضَرْبٌ':Added, #3: 3	غَيْرِ ضَرْبٍ
u'غير ضَرَرٌ':Added, #3: 3	غَيْرِ ضَرْبٍ
u'غَيْرٌ ضَرَرٌ':Added, #1: 1	غَيْرِ الضَّرَرِ
u'غير ضَرَرٌ':Added, #1: 1	غَيْرِ الضَّرَرِ
u'غَيْرٌ ضَرَرٌ':Added, #1: 1	غَيْرِ ضَرَرِ
u'غير ضَرَرٌ':Added, #1: 1	غَيْرِ ضَرَرِ
u'غَيْرٌ ضَرَرٌ':Added, #30: 30	غَيْرِ ضَرَرٍ
u'غير ضرس':Added, #30: 30	غَيْرِ ضَرَرٍ
u'غَيْرٌ ضرس':Added, #4: 4	غَيْرَ الضِّرْسِ
u'غير ضِرْسٌ':Added, #4: 4	غَيْرَ الضِّرْسِ
u'غَيْرٌ ضِرْسٌ':Added, #4: 4	غَيْرَ الضِّرْسِ
u'غير ضَرُورَةٌ':Added, #4: 4	غَيْرَ الضِّرْسِ
u'غَيْرٌ ضَرُورَةٌ':Added, #1: 1	غَيْرُ ضَرُورَةٍ
u'غير ضَرُورَةٌ':Added, #1: 1	غَيْرُ ضَرُورَةٍ
u'غير ضَرُورَةٌ':Added, #2: 2	غَيْرَ ضَرُورَةٍ
u'غَيْرٌ ضَرُورَةٌ':Added, #2: 2	غَيْرِ ضَرُورَةِ
u'غَيْرٌ ضَرُورَةٌ':Added, #2: 2	غَيْرَ ضَرُورَةٍ
u'غير ضَرُورَةٌ':Added, #2: 2	غَيْرِ ضَرُورَةِ
u'غَيْرٌ ضَرُورَةٌ':Added, #4: 4	غَيْرِ الضَّرُورَةِ
u'غير ضَرُورَةٌ':Added, #4: 4	غَيْرِ الضَّرُورَةِ
u'غَيْرٌ ضَرُورَةٌ':Added, #98: 98	غَيْرِ ضَرُورَةٍ
u'غير ضَرُورِيٌّ':Added, #98: 98	غَيْرِ ضَرُورَةٍ
u'غَيْرٌ ضَرُورِيٌّ':Added, #1: 1	غَيْرَ الضَّرُورِيِّ
u'غير ضَرُورِيٌّ':Added, #1: 1	غَيْرَ الضَّرُورِيِّ
u'غَيْرٌ ضَرُورِيٌّ':Added, #1: 1	غَيْرِ الضَّرُورِيَّاتِ
u'غير ضَرُورِيٌّ':Added, #1: 1	غَيْرِ الضَّرُورِيَّاتِ
u'غَيْرٌ ضَرُورِيٌّ':Added, #1: 1	غَيْرُ ضَرُورِيِّ
u'غير ضَرُورِيٌّ':Added, #1: 1	غَيْرُ ضَرُورِيِّ
u'غير ضَرُورِيٌّ':Added, #1: 1	غَيْرَ ضَرُورِيَّةٍ
u'غير ضَرُورِيٌّ':Added, #1: 1	غَيْرُ ضَرُورِيَّةٍ
u'غَيْرٌ ضَرُورِيٌّ':Added, #1: 1	غَيْرِ ضَرُورِيَّةٍ
u'غَيْرٌ ضَرُورِيٌّ':Added, #1: 1	غَيْرَ ضَرُورِيَّةٍ
u'غَيْرٌ ضَرُورِيٌّ':Added, #1: 1	غَيْرُ ضَرُورِيَّةٍ
u'غير ضَرُورِيٌّ':Added, #1: 1	غَيْرِ ضَرُورِيَّةٍ
u'غَيْرٌ ضَرُورِيٌّ':Added, #2: 2	غَيْرَ ضَرُورِيٍّ
u'غير ضَرُورِيٌّ':Added, #2: 2	غَيْرَ ضَرُورِيٍّ
u'غَيْرٌ ضَرُورِيٌّ':Added, #3: 3	غَيْرُ ضَرُورِيٍّ
u'غير ضَرُورِيَّاتٌ':Added, #3: 3	غَيْرُ ضَرُورِيٍّ
u'غَيْرٌ ضَرُورِيَّاتٌ':Added, #1: 1	غَيْرِ الضَّرُورِيَّاتِ
u'غير ضَغِينَةٌ':Added, #1: 1	غَيْرِ الضَّرُورِيَّاتِ
u'غَيْرٌ ضَغِينَةٌ':Added, #2: 2	غَيْرِ ضَغِينَةٍ
u'غير ضِلْعٌ':Added, #2: 2	غَيْرِ ضَغِينَةٍ
u'غَيْرٌ ضِلْعٌ':Added, #2: 2	غَيْرِ ضِلْعٍ
u'غير ضَمٌّ':Added, #2: 2	غَيْرِ ضِلْعٍ
u'غَيْرٌ ضَمٌّ':Added, #2: 2	غَيْرِ ضَمِّ
u'غير ضَمَانٌ':Added, #2: 2	غَيْرِ ضَمِّ
u'غَيْرٌ ضَمَانٌ':Added, #11: 11	غَيْرِ ضَمَانٍ
u'غير ضَمَانٌ':Added, #11: 11	غَيْرِ ضَمَانٍ
u'غَيْرٌ ضَمَانٌ':Added, #1: 1	غَيْرُ الضَّمَانِ
u'غير ضَمَانٌ':Added, #1: 1	غَيْرُ الضَّمَانِ
u'غير ضَمَانٌ':Added, #1: 1	غَيْرَ ضَمَانٍ
u'غَيْرٌ ضَمَانٌ':Added, #1: 1	غَيْرُ ضَمَانِ
u'غَيْرٌ ضَمَانٌ':Added, #1: 1	غَيْرَ ضَمَانٍ
u'غير ضَمَانٌ':Added, #1: 1	غَيْرُ ضَمَانِ
u'غَيْرٌ ضَمَانٌ':Added, #4: 4	غَيْرِ الضَّمَانِ
u'غير ضَمَانٌ':Added, #4: 4	غَيْرِ الضَّمَانِ
u'غَيْرٌ ضَمَانٌ':Added, #4: 4	غَيْرِ ضَمَانِ
u'غير ضَمَّةٌ':Added, #4: 4	غَيْرِ ضَمَانِ
u'غَيْرٌ ضَمَّةٌ':Added, #1: 1	غَيْرَ الضَّمَّةِ
u'غير ضِمْنِيٌّ':Added, #1: 1	غَيْرَ الضَّمَّةِ
u'غَيْرٌ ضِمْنِيٌّ':Added, #1: 1	غَيْرِ الضِّمْنِيِّ
u'غير ضِيَاعٌ':Added, #1: 1	غَيْرِ الضِّمْنِيِّ
u'غَيْرٌ ضِيَاعٌ':Added, #3: 3	غَيْرِ الضِّيَاعِ
u'غير ضَيْعَةٌ':Added, #3: 3	غَيْرِ الضِّيَاعِ
u'غَيْرٌ ضَيْعَةٌ':Added, #1: 1	غَيْرِ ضَيْعَةٍ
u'غير ضِيقٌ':Added, #1: 1	غَيْرِ ضَيْعَةٍ
u'غَيْرٌ ضِيقٌ':Added, #1: 1	غَيْرِ ضِيقِهِ
u'غير طَارِئٌ':Added, #1: 1	غَيْرِ ضِيقِهِ
u'غَيْرٌ طَارِئٌ':Added, #1: 1	غَيْرِ الطَّارِئَيْنِ
u'غير طَارِئٌ':Added, #1: 1	غَيْرِ الطَّارِئَيْنِ
u'غَيْرٌ طَارِئٌ':Added, #1: 1	غَيْرِ طَارِئَةٍ
u'غير طَاعَةٌ':Added, #1: 1	غَيْرِ طَارِئَةٍ
u'غَيْرٌ طَاعَةٌ':Added, #1: 1	غَيْرِ الطَّاعَةِ
u'غير طَاعَةٌ':Added, #1: 1	غَيْرِ الطَّاعَةِ
u'غَيْرٌ طَاعَةٌ':Added, #1: 1	غَيْرِ طَاعَةِ
u'غير طَاعَةٌ':Added, #1: 1	غَيْرِ طَاعَةِ
u'غَيْرٌ طَاعَةٌ':Added, #2: 2	غَيْرُ طَاعَةٍ
u'غير طَاعَةٌ':Added, #2: 2	غَيْرُ طَاعَةٍ
u'غَيْرٌ طَاعَةٌ':Added, #3: 3	غَيْرِ طَاعَةٍ
u'غير طَاعُونٌ':Added, #3: 3	غَيْرِ طَاعَةٍ
u'غَيْرٌ طَاعُونٌ':Added, #1: 1	غَيْرُ الطَّاعُونِ
u'غير طَافٌ':Added, #1: 1	غَيْرُ الطَّاعُونِ
u'غَيْرٌ طَافٌ':Added, #1: 1	غَيْرَ طَافٍ
u'غير طَالِبٌ':Added, #1: 1	غَيْرَ طَافٍ
u'غَيْرٌ طَالِبٌ':Added, #1: 1	غَيْرِ الطَّالِبِ
u'غير طَالِبٌ':Added, #1: 1	غَيْرِ الطَّالِبِ
u'غَيْرٌ طَالِبٌ':Added, #1: 1	غَيْرِ طَالِبٍ
u'غير طَالِبٌ':Added, #1: 1	غَيْرِ طَالِبٍ
u'غَيْرٌ طَالِبٌ':Added, #1: 1	غَيْرُ طَالِبِهِ
u'غير طَالِبٌ':Added, #1: 1	غَيْرُ طَالِبِهِ
u'غَيْرٌ طَالِبٌ':Added, #2: 2	غَيْرُ الطَّالِبِ
u'غير طَالِبٌ':Added, #2: 2	غَيْرُ الطَّالِبِ
u'غَيْرٌ طَالِبٌ':Added, #2: 2	غَيْرُ طَالِبٍ
u'غير طَالِبٌ':Added, #2: 2	غَيْرُ طَالِبٍ
u'غَيْرٌ طَالِبٌ':Added, #3: 3	غَيْرَ طَالِبٍ
u'غير طَالِقٌ':Added, #3: 3	غَيْرَ طَالِبٍ
u'غَيْرٌ طَالِقٌ':Added, #2: 2	غَيْرَ طَالِقٍ
u'غير طَالِقٌ':Added, #2: 2	غَيْرَ طَالِقٍ
u'غَيْرٌ طَالِقٌ':Added, #5: 5	غَيْرُ طَالِقٍ
u'غير طَامِعٌ':Added, #5: 5	غَيْرُ طَالِقٍ
u'غَيْرٌ طَامِعٌ':Added, #1: 1	غَيْرِ الطَّامِعِ
u'غير طَامِعٌ':Added, #1: 1	غَيْرِ الطَّامِعِ
u'غَيْرٌ طَامِعٌ':Added, #1: 1	غَيْرُ طَامِعٍ
u'غير طَامِعٌ':Added, #1: 1	غَيْرُ طَامِعٍ
u'غَيْرٌ طَامِعٌ':Added, #2: 2	غَيْرَ طَامِعٍ
u'غَيَّرَ طَاهِرٌ':Subject, #2: 2	غَيْرَ طَامِعٍ
u'غير طَاهِرٌ':Added, #1: 1	غَيَّرَ طَاهِرٌ
u'غَيْرٌ طَاهِرٌ':Added, #10: 10	غَيْرُ طَاهِرٍ
u'غير طَاهِرٌ':Added, #10: 10	غَيْرُ طَاهِرٍ
u'غَيْرٌ طَاهِرٌ':Added, #1: 1	غَيْرِ الطَّاهِرِ
u'غير طَاهِرٌ':Added, #1: 1	غَيْرِ الطَّاهِرِ
u'غير طَاهِرٌ':Added, #1: 1	غَيْرُ طَاهِرِ
u'غَيْرٌ طَاهِرٌ':Added, #1: 1	غَيْرِ طَاهِرٍ
u'غَيْرٌ طَاهِرٌ':Added, #1: 1	غَيْرُ طَاهِرِ
u'غير طَاهِرٌ':Added, #1: 1	غَيْرِ طَاهِرٍ
u'غَيْرٌ طَاهِرٌ':Added, #2: 2	غَيْرُ الطَّاهِرِ
u'غير طَاهِرٌ':Added, #2: 2	غَيْرُ الطَّاهِرِ
u'غَيْرٌ طَاهِرٌ':Added, #7: 7	غَيْرَ طَاهِرٍ
u'غير طَائِرَةٌ':Added, #7: 7	غَيْرَ طَاهِرٍ
u'غَيْرٌ طَائِرَةٌ':Added, #1: 1	غَيْرُ طَائِرَةٍ
u'غير طَائِشٌ':Added, #1: 1	غَيْرُ طَائِرَةٍ
u'غَيْرٌ طَائِشٌ':Added, #1: 1	غَيْرُ طَائِشِ
u'غير طَائِعٌ':Added, #1: 1	غَيْرُ طَائِشِ
u'غَيْرٌ طَائِعٌ':Added, #1: 1	غَيْرَ طَائِعِ
u'غير طَائِلٌ':Added, #1: 1	غَيْرَ طَائِعِ
u'غَيْرٌ طَائِلٌ':Added, #1: 1	غَيْرَ طَائِلٍ
u'غير طَائِلٌ':Added, #1: 1	غَيْرَ طَائِلٍ
u'غير طَائِلٌ':Added, #2: 2	غَيْرَ طَائِلِ
u'غَيْرٌ طَائِلٌ':Added, #2: 2	غَيْرِ طَائِلٍ
u'غَيْرٌ طَائِلٌ':Added, #2: 2	غَيْرَ طَائِلِ
u'غير طَبْخٌ':Added, #2: 2	غَيْرِ طَائِلٍ
u'غَيْرٌ طَبْخٌ':Added, #1: 1	غَيْرُ الطَّبْخِ
u'غير طَبْخٌ':Added, #1: 1	غَيْرُ الطَّبْخِ
u'غَيْرٌ طَبْخٌ':Added, #5: 5	غَيْرِ طَبْخٍ
u'غير طَبَقَةٌ':Added, #5: 5	غَيْرِ طَبْخٍ
u'غَيْرٌ طَبَقَةٌ':Added, #2: 2	غَيْرِ الطَّبَقَةِ
u'غير طَبِيبٌ':Added, #2: 2	غَيْرِ الطَّبَقَةِ
u'غَيْرٌ طَبِيبٌ':Added, #1: 1	غَيْرُ طَبِيبَيْنِ
u'غير طَبِيعِيٌّ':Added, #1: 1	غَيْرُ طَبِيبَيْنِ
u'غَيْرٌ طَبِيعِيٌّ':Added, #1: 1	غَيْرُ الطَّبِيعِيِّ
u'غير طَبِيعِيٌّ':Added, #1: 1	غَيْرُ الطَّبِيعِيِّ
u'غير طَبِيعِيٌّ':Added, #1: 1	غَيْرَ طَبِيعِيَّةٍ
u'غير طَبِيعِيٌّ':Added, #1: 1	غَيْرُ طَبِيعِيَّةٍ
u'غَيْرٌ طَبِيعِيٌّ':Added, #1: 1	غَيْرِ طَبِيعِيَّةٍ
u'غَيْرٌ طَبِيعِيٌّ':Added, #1: 1	غَيْرَ طَبِيعِيَّةٍ
u'غَيْرٌ طَبِيعِيٌّ':Added, #1: 1	غَيْرُ طَبِيعِيَّةٍ
u'غير طَرَبٌ':Added, #1: 1	غَيْرِ طَبِيعِيَّةٍ
u'غَيْرٌ طَرَبٌ':Added, #1: 1	غَيْرِ طَرَبٍ
u'غير طَرْدٌ':Added, #1: 1	غَيْرِ طَرَبٍ
u'غَيْرٌ طَرْدٌ':Added, #1: 1	غَيْرُ الطَّرْدِ
u'غير طرف':Added, #1: 1	غَيْرُ الطَّرْدِ
u'غَيْرٌ طرف':Added, #1: 1	غَيْرِ طَرَفِ
u'غير طَرَفٌ':Added, #1: 1	غَيْرِ طَرَفِ
u'غَيْرٌ طَرَفٌ':Added, #1: 1	غَيْرِ طَرَفِ
u'غير طَرِيقٌ':Added, #1: 1	غَيْرِ طَرَفِ
u'غَيْرٌ طَرِيقٌ':Added, #10: 10	غَيْرِ طَرِيقٍ
u'غير طَرِيقٌ':Added, #10: 10	غَيْرِ طَرِيقٍ
u'غَيْرٌ طَرِيقٌ':Added, #13: 13	غَيْرِ الطَّرِيقِ
u'غير طَرِيقٌ':Added, #13: 13	غَيْرِ الطَّرِيقِ
u'غَيْرٌ طَرِيقٌ':Added, #16: 16	غَيْرِ طَرِيقِ
u'غير طَرِيقٌ':Added, #16: 16	غَيْرِ طَرِيقِ
u'غير طَرِيقٌ':Added, #1: 1	غَيْرَ طَرِيقٍ
u'غَيْرٌ طَرِيقٌ':Added, #1: 1	غَيْرُ طَرِيقِ
u'غَيْرٌ طَرِيقٌ':Added, #1: 1	غَيْرَ طَرِيقٍ
u'غير طَرِيقٌ':Added, #1: 1	غَيْرُ طَرِيقِ
u'غَيْرٌ طَرِيقٌ':Added, #2: 2	غَيْرُ طَرِيقٍ
u'غير طَرِيقٌ':Added, #2: 2	غَيْرُ طَرِيقٍ
u'غَيْرٌ طَرِيقٌ':Added, #3: 3	غَيْرَ الطَّرِيقِ
u'غير طَرِيقٌ':Added, #3: 3	غَيْرَ الطَّرِيقِ
u'غَيْرٌ طَرِيقٌ':Added, #5: 5	غَيْرِ طَرِيقِهِ
u'غير طَرِيقٌ':Added, #5: 5	غَيْرِ طَرِيقِهِ
u'غَيْرٌ طَرِيقٌ':Added, #6: 6	غَيْرَ طَرِيقِ
u'غير طَرِيقَةٌ':Added, #6: 6	غَيْرَ طَرِيقِ
u'غَيْرٌ طَرِيقَةٌ':Added, #1: 1	غَيْرُ طَرِيقَةِ
u'غير طعام':Added, #1: 1	غَيْرُ طَرِيقَةِ
u'غَيْرٌ طعام':Added, #12: 12	غَيْرِ الطَّعَامِ
u'غير طَعَامٌ':Added, #12: 12	غَيْرِ الطَّعَامِ
u'غَيْرٌ طَعَامٌ':Added, #12: 12	غَيْرِ الطَّعَامِ
u'غير طعام':Added, #12: 12	غَيْرِ الطَّعَامِ
u'غَيْرٌ طعام':Added, #1: 1	غَيْرِ طَعَامٍ
u'غير طَعَامٌ':Added, #1: 1	غَيْرِ طَعَامٍ
u'غَيْرٌ طَعَامٌ':Added, #1: 1	غَيْرِ طَعَامٍ
u'غير طعام':Added, #1: 1	غَيْرِ طَعَامٍ
u'غَيْرٌ طعام':Added, #2: 2	غَيْرُ الطَّعَامِ
u'غير طَعَامٌ':Added, #2: 2	غَيْرُ الطَّعَامِ
u'غَيْرٌ طَعَامٌ':Added, #2: 2	غَيْرُ الطَّعَامِ
u'غير طعام':Added, #2: 2	غَيْرُ الطَّعَامِ
u'غَيْرٌ طعام':Added, #2: 2	غَيْرُ طَعَامٍ
u'غير طَعَامٌ':Added, #2: 2	غَيْرُ طَعَامٍ
u'غَيْرٌ طَعَامٌ':Added, #2: 2	غَيْرُ طَعَامٍ
u'غير طَعَامٌ':Added, #2: 2	غَيْرُ طَعَامٍ
u'غَيْرٌ طَعَامٌ':Added, #3: 3	غَيْرِ الطَّعَامَيْنِ
u'غير طعام':Added, #3: 3	غَيْرِ الطَّعَامَيْنِ
u'غَيْرٌ طعام':Added, #4: 4	غَيْرَ الطَّعَامِ
u'غير طَعَامٌ':Added, #4: 4	غَيْرَ الطَّعَامِ
u'غَيْرٌ طَعَامٌ':Added, #4: 4	غَيْرَ الطَّعَامِ
u'غَيَّرَ طَعْمٌ':Predicate, #4: 4	غَيْرَ الطَّعَامِ
u'غَيَّرَ طَعْمٌ':Predicate, #1: 1	غَيَّرَ الطَّعْمَ
u'غير طُعْمٌ':Added, #2: 2	غَيَّرَ طَعْمَ
u'غَيْرٌ طُعْمٌ':Added, #1: 1	غَيْرَ الطُّعْمِ
u'غير طَعْنٌ':Added, #1: 1	غَيْرَ الطُّعْمِ
u'غير طَعْنٌ':Added, #1: 1	غَيْرَ طَعْنٍ
u'غَيْرٌ طَعْنٌ':Added, #1: 1	غَيْرِ طَعْنِ
u'غَيْرٌ طَعْنٌ':Added, #1: 1	غَيْرَ طَعْنٍ
u'غير طُعُومٌ':Added, #1: 1	غَيْرِ طَعْنِ
u'غَيْرٌ طُعُومٌ':Added, #1: 1	غَيْرِ الطُّعُومِ
u'غير طِفْلٌ':Added, #1: 1	غَيْرِ الطُّعُومِ
u'غَيْرٌ طِفْلٌ':Added, #2: 2	غَيْرِ طِفْلٍ
u'غير طِفْلٌ':Added, #2: 2	غَيْرِ طِفْلٍ
u'غَيْرٌ طِفْلٌ':Added, #3: 3	غَيْرِ الطِّفْلِ
u'غير طَلاَقٌ':Added, #3: 3	غَيْرِ الطِّفْلِ
u'غير طَلاَقٌ':Added, #1: 1	غَيْرَ طَلَاقٍ
u'غير طَلاَقٌ':Added, #1: 1	غَيْرُ طَلَاقٍ
u'غَيْرٌ طَلاَقٌ':Added, #1: 1	غَيْرِ طَلاَقٍ
u'غَيْرٌ طَلاَقٌ':Added, #1: 1	غَيْرَ طَلَاقٍ
u'غَيْرٌ طَلاَقٌ':Added, #1: 1	غَيْرُ طَلَاقٍ
u'غير طَلاَقٌ':Added, #1: 1	غَيْرِ طَلاَقٍ
u'غَيْرٌ طَلاَقٌ':Added, #3: 3	غَيْرَ الطَّلَاقِ
u'غير طَلاَقٌ':Added, #3: 3	غَيْرَ الطَّلَاقِ
u'غَيْرٌ طَلاَقٌ':Added, #4: 4	غَيْرُ الطَّلَاقِ
u'غير طَلاَقٌ':Added, #4: 4	غَيْرُ الطَّلَاقِ
u'غَيْرٌ طَلاَقٌ':Added, #4: 4	غَيْرِ طَلَاقٍ
u'غير طَلاَقٌ':Added, #4: 4	غَيْرِ طَلَاقٍ
u'غَيْرٌ طَلاَقٌ':Added, #6: 6	غَيْرِ الطَّلَاقِ
u'غير طلب':Added, #6: 6	غَيْرِ الطَّلَاقِ
u'غَيْرٌ طلب':Added, #12: 12	غَيْرِ طَلَبِ
u'غير طَلَبٌ':Added, #12: 12	غَيْرِ طَلَبِ
u'غَيْرٌ طَلَبٌ':Added, #12: 12	غَيْرِ طَلَبِ
u'غير طَلَبٌ':Added, #12: 12	غَيْرِ طَلَبِ
u'غَيْرٌ طَلَبٌ':Added, #18: 18	غَيْرِ طَلَبٍ
u'غير طلب':Added, #18: 18	غَيْرِ طَلَبٍ
u'غَيْرٌ طلب':Added, #3: 3	غَيْرِ طَلَبِهِ
u'غير طَلَبٌ':Added, #3: 3	غَيْرِ طَلَبِهِ
u'غَيْرٌ طَلَبٌ':Added, #3: 3	غَيْرِ طَلَبِهِ
u'غير طَلَبَةٌ':Added, #3: 3	غَيْرِ طَلَبِهِ
u'غَيْرٌ طَلَبَةٌ':Added, #1: 1	غَيْرِ طَلَبَةِ
u'غير طَمَعٌ':Added, #1: 1	غَيْرِ طَلَبَةِ
u'غَيْرٌ طَمَعٌ':Added, #1: 1	غَيْرِ طَمَعٍ
u'غير طَهَارَةٌ':Added, #1: 1	غَيْرِ طَمَعٍ
u'غير طَهَارَةٌ':Added, #1: 1	غَيْرَ الطَّهَارَةِ
u'غَيْرٌ طَهَارَةٌ':Added, #1: 1	غَيْرِ الطَّهَارَةِ
u'غَيْرٌ طَهَارَةٌ':Added, #1: 1	غَيْرَ الطَّهَارَةِ
u'غير طَهَارَةٌ':Added, #1: 1	غَيْرِ الطَّهَارَةِ
u'غَيْرٌ طَهَارَةٌ':Added, #1: 1	غَيْرِ طَهَارَةِ
u'غير طَهَارَةٌ':Added, #1: 1	غَيْرِ طَهَارَةِ
u'غَيْرٌ طَهَارَةٌ':Added, #26: 26	غَيْرِ طَهَارَةٍ
u'غير طُهْرٌ':Added, #26: 26	غَيْرِ طَهَارَةٍ
u'غَيْرٌ طُهْرٌ':Added, #5: 5	غَيْرِ طُهْرٍ
u'غير طواف':Added, #5: 5	غَيْرِ طُهْرٍ
u'غير طواف':Added, #2: 2	غَيْرُ طَوَافِ
u'غَيْرٌ طواف':Added, #2: 2	غَيْرِ طَوَافٍ
u'غَيْرٌ طواف':Added, #2: 2	غَيْرُ طَوَافِ
u'غير طَوَافٌ':Added, #2: 2	غَيْرِ طَوَافٍ
u'غير طَوَافٌ':Added, #2: 2	غَيْرُ طَوَافِ
u'غَيْرٌ طَوَافٌ':Added, #2: 2	غَيْرِ طَوَافٍ
u'غَيْرٌ طَوَافٌ':Added, #2: 2	غَيْرُ طَوَافِ
u'غير طوال':Added, #2: 2	غَيْرِ طَوَافٍ
u'غَيْرٌ طوال':Added, #1: 1	غَيْرَ الطِّوَالِ
u'غير طُولٌ':Added, #1: 1	غَيْرَ الطِّوَالِ
u'غَيْرٌ طُولٌ':Added, #1: 1	غَيْرِ طُولٍ
u'غير طَوِيلٌ':Added, #1: 1	غَيْرِ طُولٍ
u'غَيْرٌ طَوِيلٌ':Added, #1: 1	غَيْرِ الطَّوِيلَةِ
u'غير طِيبٌ':Added, #1: 1	غَيْرِ الطَّوِيلَةِ
u'غَيْرٌ طِيبٌ':Added, #1: 1	غَيْرِ الطِّيبِ
u'غير طِيبٌ':Added, #1: 1	غَيْرِ الطِّيبِ
u'غير طِيبٌ':Added, #1: 1	غَيْرِ طِيبٍ
u'غير طَيِّبٌ':Added, #1: 1	غَيْرِ طِيبِ
u'غَيْرٌ طِيبٌ':Added, #1: 1	غَيْرُ طَيِّبٍ
u'غَيْرٌ طِيبٌ':Added, #1: 1	غَيْرِ طِيبٍ
u'غَيْرٌ طَيِّبٌ':Added, #1: 1	غَيْرِ طِيبِ
u'غير طَيِّبٌ':Added, #1: 1	غَيْرُ طَيِّبٍ
u'غَيْرٌ طَيِّبٌ':Added, #1: 1	غَيْرَ طَيِّبَةٍ
u'غير طَيْرٌ':Added, #1: 1	غَيْرَ طَيِّبَةٍ
u'غَيْرٌ طَيْرٌ':Added, #1: 1	غَيْرَ الطَّيْرِ
u'غير طَيْرٌ':Added, #1: 1	غَيْرَ الطَّيْرِ
u'غير طَيْرٌ':Added, #1: 1	غَيْرُ طَيْرٍ
u'غَيْرٌ طَيْرٌ':Added, #1: 1	غَيْرِ طَيْرِ
u'غَيْرٌ طَيْرٌ':Added, #1: 1	غَيْرُ طَيْرٍ
u'غير طَيْرٌ':Added, #1: 1	غَيْرِ طَيْرِ
u'غَيْرٌ طَيْرٌ':Added, #2: 2	غَيْرِ الطَّيْرِ
u'غير طِينٌ':Added, #2: 2	غَيْرِ الطَّيْرِ
u'غَيْرٌ طِينٌ':Added, #1: 1	غَيْرَ الطِّينِ
u'غير طُيُورٌ':Added, #1: 1	غَيْرَ الطِّينِ
u'غَيْرٌ طُيُورٌ':Added, #2: 2	غَيْرِ الطُّيُورِ
u'غير ظالِمٌ':Added, #2: 2	غَيْرِ الطُّيُورِ
u'غير ظالِمٌ':Added, #1: 1	غَيْرَ ظَالِمٍ
u'غَيْرٌ ظالِمٌ':Added, #1: 1	غَيْرِ ظَالِمٍ
u'غَيْرٌ ظالِمٌ':Added, #1: 1	غَيْرَ ظَالِمٍ
u'غير ظالِمٌ':Added, #1: 1	غَيْرِ ظَالِمٍ
u'غَيْرٌ ظالِمٌ':Added, #2: 2	غَيْرَ ظَالِمِهِ
u'غير ظالِمٌ':Added, #2: 2	غَيْرَ ظَالِمِهِ
u'غَيْرٌ ظالِمٌ':Added, #7: 7	غَيْرِ ظَالِمِهِ
u'غير ظالِمٌ':Added, #7: 7	غَيْرِ ظَالِمِهِ
u'غَيْرٌ ظالِمٌ':Added, #8: 8	غَيْرُ ظَالِمٍ
u'غير ظاهِرٌ':Added, #8: 8	غَيْرُ ظَالِمٍ
u'غَيْرٌ ظاهِرٌ':Added, #12: 12	غَيْرَ ظَاهِرٍ
u'غير ظاهِرٌ':Added, #12: 12	غَيْرَ ظَاهِرٍ
u'غَيْرٌ ظاهِرٌ':Added, #12: 12	غَيْرُ ظَاهِرَةٍ
u'غير ظاهِرٌ':Added, #12: 12	غَيْرُ ظَاهِرَةٍ
u'غير ظاهِرٌ':Added, #1: 1	غَيْرَ الظَّاهِرَةِ
u'غَيْرٌ ظاهِرٌ':Added, #1: 1	غَيْرِ الظَّاهِرَةِ
u'غَيْرٌ ظاهِرٌ':Added, #1: 1	غَيْرَ الظَّاهِرَةِ
u'غير ظاهِرٌ':Added, #1: 1	غَيْرِ الظَّاهِرَةِ
u'غَيْرٌ ظاهِرٌ':Added, #1: 1	غَيْرُ ظَاهِرَةِ
u'غير ظاهِرٌ':Added, #1: 1	غَيْرُ ظَاهِرَةِ
u'غَيْرٌ ظاهِرٌ':Added, #2: 2	غَيْرُ الظَّاهِرِ
u'غير ظاهِرٌ':Added, #2: 2	غَيْرُ الظَّاهِرِ
u'غَيْرٌ ظاهِرٌ':Added, #2: 2	غَيْرِ ظَاهِرٍ
u'غير ظاهِرٌ':Added, #2: 2	غَيْرِ ظَاهِرٍ
u'غَيْرٌ ظاهِرٌ':Added, #2: 2	غَيْرَ ظَاهِرَةٍ
u'غير ظاهِرٌ':Added, #2: 2	غَيْرَ ظَاهِرَةٍ
u'غَيْرٌ ظاهِرٌ':Added, #35: 35	غَيْرِ ظَاهِرِ
u'غير ظاهِرٌ':Added, #35: 35	غَيْرِ ظَاهِرِ
u'غَيْرٌ ظاهِرٌ':Added, #3: 3	غَيْرِ ظَاهِرَةٍ
u'غير ظاهِرٌ':Added, #3: 3	غَيْرِ ظَاهِرَةٍ
u'غَيْرٌ ظاهِرٌ':Added, #3: 3	غَيْرِ ظَاهِرِهِ
u'غير ظاهِرٌ':Added, #3: 3	غَيْرِ ظَاهِرِهِ
u'غَيْرٌ ظاهِرٌ':Added, #4: 4	غَيْرَ الظَّاهِرِ
u'غير ظاهِرٌ':Added, #4: 4	غَيْرَ الظَّاهِرِ
u'غير ظاهِرٌ':Added, #6: 6	غَيْرَ ظَاهِرِ
u'غَيْرٌ ظاهِرٌ':Added, #6: 6	غَيْرُ ظَاهِرِ
u'غَيْرٌ ظاهِرٌ':Added, #6: 6	غَيْرَ ظَاهِرِ
u'غير ظاهِرٌ':Added, #6: 6	غَيْرُ ظَاهِرِ
u'غَيْرٌ ظاهِرٌ':Added, #6: 6	غَيْرَ ظَاهِرِهِ
u'غير ظاهِرٌ':Added, #6: 6	غَيْرَ ظَاهِرِهِ
u'غَيْرٌ ظاهِرٌ':Added, #98: 98	غَيْرُ ظَاهِرٍ
u'غير ظاهِرٌ':Added, #98: 98	غَيْرُ ظَاهِرٍ
u'غَيْرٌ ظاهِرٌ':Added, #9: 9	غَيْرِ الظَّاهِرِ
u'غير ظاهِرَة':Added, #9: 9	غَيْرِ الظَّاهِرِ
u'غَيْرٌ ظاهِرَة':Added, #12: 12	غَيْرُ ظَاهِرَةٍ
u'غير ظاهِرَة':Added, #12: 12	غَيْرُ ظَاهِرَةٍ
u'غير ظاهِرَة':Added, #1: 1	غَيْرَ الظَّاهِرَةِ
u'غَيْرٌ ظاهِرَة':Added, #1: 1	غَيْرِ الظَّاهِرَةِ
u'غَيْرٌ ظاهِرَة':Added, #1: 1	غَيْرَ الظَّاهِرَةِ
u'غير ظاهِرَة':Added, #1: 1	غَيْرِ الظَّاهِرَةِ
u'غَيْرٌ ظاهِرَة':Added, #1: 1	غَيْرُ ظَاهِرَةِ
u'غير ظاهِرَة':Added, #1: 1	غَيْرُ ظَاهِرَةِ
u'غَيْرٌ ظاهِرَة':Added, #2: 2	غَيْرَ ظَاهِرَةٍ
u'غير ظاهِرَة':Added, #2: 2	غَيْرَ ظَاهِرَةٍ
u'غَيْرٌ ظاهِرَة':Added, #3: 3	غَيْرِ ظَاهِرَةٍ
u'غير ظُفْرٌ':Added, #3: 3	غَيْرِ ظَاهِرَةٍ
u'غَيْرٌ ظُفْرٌ':Added, #1: 1	غَيْرُ الظُّفْرِ
u'غير ظِلٌّ':Added, #1: 1	غَيْرُ الظُّفْرِ
u'غَيْرٌ ظِلٌّ':Added, #1: 1	غَيْرِ ظِلٍّ
u'غير ظِلٌّ':Added, #1: 1	غَيْرِ ظِلٍّ
u'غَيْرٌ ظِلٌّ':Added, #2: 2	غَيْرَ ظِلِّ
u'غير ظُلْمٌ':Added, #2: 2	غَيْرَ ظِلِّ
u'غَيْرٌ ظُلْمٌ':Added, #2: 2	غَيْرِ ظُلْمِ
u'غير ظُلْمٌ':Added, #2: 2	غَيْرِ ظُلْمِ
u'غَيْرٌ ظُلْمٌ':Added, #5: 5	غَيْرِ ظُلْمٍ
u'غير ظلمة':Added, #5: 5	غَيْرِ ظُلْمٍ
u'غَيْرٌ ظلمة':Added, #1: 1	غَيْرِ ظُلْمَةٍ
u'غير ظُلْمَةٌ':Added, #1: 1	غَيْرِ ظُلْمَةٍ
u'غَيْرٌ ظُلْمَةٌ':Added, #1: 1	غَيْرِ ظُلْمَةٍ
u'غير ظمأة':Added, #1: 1	غَيْرِ ظُلْمَةٍ
u'غَيْرٌ ظمأة':Added, #1: 1	غَيْرِ ظِمْأَةٍ
u'غير ظَنٌّ':Added, #1: 1	غَيْرِ ظِمْأَةٍ
u'غَيْرٌ ظَنٌّ':Added, #1: 1	غَيْرَ الظَّنِّ
u'غير ظَنٌّ':Added, #1: 1	غَيْرَ الظَّنِّ
u'غَيْرٌ ظَنٌّ':Added, #1: 1	غَيْرِ ظَنٍّ
u'غير ظهار':Added, #1: 1	غَيْرِ ظَنٍّ
u'غَيْرٌ ظهار':Added, #2: 2	غَيْرِ الظِّهَارِ
u'غير ظهار':Added, #2: 2	غَيْرِ الظِّهَارِ
u'غَيْرٌ ظهار':Added, #2: 2	غَيْرِ ظِهَارٍ
u'غير ظَهْرٌ':Added, #2: 2	غَيْرِ ظِهَارٍ
u'غَيْرٌ ظَهْرٌ':Added, #1: 1	غَيْرُ الظَّهْرِ
u'غير ظَهْرٌ':Added, #1: 1	غَيْرُ الظَّهْرِ
u'غير ظُهْرٌ':Added, #1: 1	غَيْرِ ظَهْرِ
u'غَيْرٌ ظَهْرٌ':Added, #1: 1	غَيْرَ ظُهْرٍ
u'غَيْرٌ ظُهْرٌ':Added, #1: 1	غَيْرِ ظَهْرِ
u'غير ظُهْرٌ':Added, #1: 1	غَيْرَ ظُهْرٍ
u'غَيْرٌ ظُهْرٌ':Added, #2: 2	غَيْرُ الظُّهْرِ
u'غير ظُهْرٌ':Added, #2: 2	غَيْرُ الظُّهْرِ
u'غَيْرٌ ظُهْرٌ':Added, #5: 5	غَيْرِ الظُّهْرِ
u'غير ظُهورٌ':Added, #5: 5	غَيْرِ الظُّهْرِ
u'غَيْرٌ ظُهورٌ':Added, #1: 1	غَيْرِ ظُهُورٍ
u'غير ظُهورٌ':Added, #1: 1	غَيْرِ ظُهُورٍ
u'غَيْرٌ ظُهورٌ':Added, #2: 2	غَيْرِ ظُهُورِ
u'غير عَاجِزٌ':Added, #2: 2	غَيْرِ ظُهُورِ
u'غَيْرٌ عَاجِزٌ':Added, #1: 1	غَيْرِ الْعَاجِزِ
u'غير عَاجِزٌ':Added, #1: 1	غَيْرِ الْعَاجِزِ
u'غَيْرٌ عَاجِزٌ':Added, #2: 2	غَيْرُ عَاجِزٍ
u'غير عَادَةٌ':Added, #2: 2	غَيْرُ عَاجِزٍ
u'غَيْرٌ عَادَةٌ':Added, #1: 1	غَيْرِ عَادَةٍ
u'غير عَادَةٌ':Added, #1: 1	غَيْرِ عَادَةٍ
u'غَيْرٌ عَادَةٌ':Added, #1: 1	غَيْرِ عَادَتِهِ
u'غير عَادَةٌ':Added, #1: 1	غَيْرِ عَادَتِهِ
u'غَيْرٌ عَادَةٌ':Added, #2: 2	غَيْرَ الْعَادَةِ
u'غير عَادَةٌ':Added, #2: 2	غَيْرَ الْعَادَةِ
u'غَيْرٌ عَادَةٌ':Added, #5: 5	غَيْرِ الْعَادَةِ
u'غير عَادِلٌ':Added, #5: 5	غَيْرِ الْعَادَةِ
u'غَيْرٌ عَادِلٌ':Added, #1: 1	غَيْرِ الْعَادِلِ
u'غير عَادِلٌ':Added, #1: 1	غَيْرِ الْعَادِلِ
u'غَيْرٌ عَادِلٌ':Added, #1: 1	غَيْرَ عَادِلٍ
u'غير عَادِلٌ':Added, #1: 1	غَيْرَ عَادِلٍ
u'غَيْرٌ عَادِلٌ':Added, #1: 1	غَيْرَ عَادِلَةٍ
u'غير عَادِلٌ':Added, #1: 1	غَيْرَ عَادِلَةٍ
u'غَيْرٌ عَادِلٌ':Added, #1: 1	غَيْرَ عَادِلَيْنِ
u'غير عَادِلٌ':Added, #1: 1	غَيْرَ عَادِلَيْنِ
u'غَيْرٌ عَادِلٌ':Added, #2: 2	غَيْرِ عَادِلٍ
u'غير عَادِلٌ':Added, #2: 2	غَيْرِ عَادِلٍ
u'غَيْرٌ عَادِلٌ':Added, #4: 4	غَيْرُ عَادِلَةٍ
u'غير عادِم':Added, #4: 4	غَيْرُ عَادِلَةٍ
u'غَيْرٌ عادِم':Added, #1: 1	غَيْرُ عَادِمٍ
u'غير عَادِي':Added, #1: 1	غَيْرُ عَادِمٍ
u'غَيْرٌ عَادِي':Added, #1: 1	غَيْرُ الْعَادِيَةِ
u'غير عَادِيٌّ':Added, #1: 1	غَيْرُ الْعَادِيَةِ
u'غَيْرٌ عَادِيٌّ':Added, #1: 1	غَيْرِ عَادِيٍّ
u'غير عَارِفٌ':Added, #1: 1	غَيْرِ عَادِيٍّ
u'غير عَارِفٌ':Added, #1: 1	غَيْرُ الْعَارِفِ
u'غَيْرٌ عَارِفٌ':Added, #1: 1	غَيْرِ الْعَارِفِ
u'غَيْرٌ عَارِفٌ':Added, #1: 1	غَيْرُ الْعَارِفِ
u'غير عَارِفٌ':Added, #1: 1	غَيْرِ الْعَارِفِ
u'غَيْرٌ عَارِفٌ':Added, #3: 3	غَيْرُ عَارِفٍ
u'غير عَارِفٌ':Added, #3: 3	غَيْرُ عَارِفٍ
u'غَيْرٌ عَارِفٌ':Added, #4: 4	غَيْرَ عَارِفٍ
u'غير عارِيَّةٌ':Added, #4: 4	غَيْرَ عَارِفٍ
u'غَيْرٌ عارِيَّةٌ':Added, #1: 1	غَيْرَ عَارِيَّةٍ
u'غير عَازِمٌ':Added, #1: 1	غَيْرَ عَارِيَّةٍ
u'غير عَازِمٌ':Added, #2: 2	غَيْرَ عَازِمٍ
u'غَيْرٌ عَازِمٌ':Added, #2: 2	غَيْرُ عَازِمٍ
u'غَيْرٌ عَازِمٌ':Added, #2: 2	غَيْرَ عَازِمٍ
u'غير عَاصِبٌ':Added, #2: 2	غَيْرُ عَازِمٍ
u'غَيْرٌ عَاصِبٌ':Added, #1: 1	غَيْرِ الْعَاصِبِ
u'غير عَاصِمٌ':Added, #1: 1	غَيْرِ الْعَاصِبِ
u'غَيْرٌ عَاصِمٌ':Added, #2: 2	غَيْرُ عَاصِمٍ
u'غير عَاطِفٌ':Added, #2: 2	غَيْرُ عَاصِمٍ
u'غَيْرٌ عَاطِفٌ':Added, #1: 1	غَيْرُ الْعَاطِفَةِ
u'غير عَاطِفٌ':Added, #1: 1	غَيْرُ الْعَاطِفَةِ
u'غَيْرٌ عَاطِفٌ':Added, #3: 3	غَيْرَ عَاطِفَةٍ
u'غير عَاطِفَةٌ':Added, #3: 3	غَيْرَ عَاطِفَةٍ
u'غَيْرٌ عَاطِفَةٌ':Added, #1: 1	غَيْرُ الْعَاطِفَةِ
u'غير عَاطِفَةٌ':Added, #1: 1	غَيْرُ الْعَاطِفَةِ
u'غَيْرٌ عَاطِفَةٌ':Added, #3: 3	غَيْرَ عَاطِفَةٍ
u'غير عَاقِدٌ':Added, #3: 3	غَيْرَ عَاطِفَةٍ
u'غير عَاقِدٌ':Added, #1: 1	غَيْر الْعَاقِدِ
u'غَيْرٌ عَاقِدٌ':Added, #1: 1	غَيْرُ الْعَاقِدِ
u'غَيْرٌ عَاقِدٌ':Added, #1: 1	غَيْر الْعَاقِدِ
u'غير عَاقِدٌ':Added, #1: 1	غَيْرُ الْعَاقِدِ
u'غَيْرٌ عَاقِدٌ':Added, #1: 1	غَيْرُ عَاقِدٍ
u'غير عَاقِدٌ':Added, #1: 1	غَيْرُ عَاقِدٍ
u'غَيْرٌ عَاقِدٌ':Added, #2: 2	غَيْرُ الْعَاقِدَيْنِ
u'غير عَاقِدٌ':Added, #2: 2	غَيْرُ الْعَاقِدَيْنِ
u'غَيْرٌ عَاقِدٌ':Added, #5: 5	غَيْرَ عَاقِدٍ
u'غير عَاقِدٌ':Added, #5: 5	غَيْرَ عَاقِدٍ
u'غَيْرٌ عَاقِدٌ':Added, #8: 8	غَيْرِ الْعَاقِدِ
u'غير عَاقِلٌ':Added, #8: 8	غَيْرِ الْعَاقِدِ
u'غَيْرٌ عَاقِلٌ':Added, #1: 1	غَيْرُ عَاقِلٍ
u'غير عَاقِلٌ':Added, #1: 1	غَيْرُ عَاقِلٍ
u'غَيْرٌ عَاقِلٌ':Added, #2: 2	غَيْرُ الْعَاقِلِ
u'غير عَاقِلٌ':Added, #2: 2	غَيْرُ الْعَاقِلِ
u'غَيْرٌ عَاقِلٌ':Added, #3: 3	غَيْرَ الْعَاقِلِ
u'غير عَاقِلٌ':Added, #3: 3	غَيْرَ الْعَاقِلِ
u'غَيْرٌ عَاقِلٌ':Added, #4: 4	غَيْرِ عَاقِلٍ
u'غير عَاقِلٌ':Added, #4: 4	غَيْرِ عَاقِلٍ
u'غَيْرٌ عَاقِلٌ':Added, #7: 7	غَيْرِ الْعَاقِلِ
u'غير عَاقِلٌ':Added, #7: 7	غَيْرِ الْعَاقِلِ
u'غَيْرٌ عَاقِلٌ':Added, #7: 7	غَيْرَ عَاقِلٍ
u'غير عَالِمٌ':Added, #7: 7	غَيْرَ عَاقِلٍ
u'غَيْرٌ عَالِمٌ':Added, #1: 1	غَيْرَ الْعَالِمِ
u'غير عَالَمٌ':Added, #1: 1	غَيْرَ الْعَالِمِ
u'غير عَالِمٌ':Added, #1: 1	غَيْرُ عَالَمٍ
u'غَيْرٌ عَالَمٌ':Added, #1: 1	غَيْرِ عَالِمِ
u'غَيْرٌ عَالِمٌ':Added, #1: 1	غَيْرُ عَالَمٍ
u'غير عَالِمٌ':Added, #1: 1	غَيْرِ عَالِمِ
u'غَيْرٌ عَالِمٌ':Added, #1: 1	غَيْرُ عَالِمَةٍ
u'غير عَالِمٌ':Added, #1: 1	غَيْرُ عَالِمَةٍ
u'غَيْرٌ عَالِمٌ':Added, #22: 22	غَيْرُ عَالِمٍ
u'غير عَالِمٌ':Added, #22: 22	غَيْرُ عَالِمٍ
u'غَيْرٌ عَالِمٌ':Added, #2: 2	غَيْرِ عَالِمٍ
u'غير عَالِمٌ':Added, #2: 2	غَيْرِ عَالِمٍ
u'غَيْرٌ عَالِمٌ':Added, #2: 2	غَيْرَ عَالِمَيْنِ
u'غير عَالِمٌ':Added, #2: 2	غَيْرَ عَالِمَيْنِ
u'غَيْرٌ عَالِمٌ':Added, #3: 3	غَيْرُ الْعَالِمِ
u'غير عَالِمٌ':Added, #3: 3	غَيْرُ الْعَالِمِ
u'غَيْرٌ عَالِمٌ':Added, #4: 4	غَيْرِ الْعَالِمِ
u'غير عَالِمٌ':Added, #4: 4	غَيْرِ الْعَالِمِ
u'غَيْرٌ عَالِمٌ':Added, #60: 60	غَيْرَ عَالِمٍ
u'غير عَالَمٌ':Added, #60: 60	غَيْرَ عَالِمٍ
u'غَيْرٌ عَالَمٌ':Added, #6: 6	غَيْرَ عَالَمٍ
u'غير عَالِمٌ':Added, #6: 6	غَيْرَ عَالَمٍ
u'غَيْرٌ عَالِمٌ':Added, #6: 6	غَيْرَ عَالِمَةٍ
u'غير عَالِي':Added, #6: 6	غَيْرَ عَالِمَةٍ
u'غَيْرٌ عَالِي':Added, #1: 1	غَيْرِ عَالِيَةٍ
u'غير عَامٌّ':Added, #1: 1	غَيْرِ عَالِيَةٍ
u'غَيْرٌ عَامٌّ':Added, #1: 1	غَيْرِ الْعَامِّ
u'غير عَامٌّ':Added, #1: 1	غَيْرِ الْعَامِّ
u'غَيْرٌ عَامٌّ':Added, #1: 1	غَيْرِ عَامٍّ
u'غير عَامٌّ':Added, #1: 1	غَيْرِ عَامٍّ
u'غير عَامٌّ':Added, #1: 1	غَيْرَ عَامَّةٍ
u'غَيْرٌ عَامٌّ':Added, #1: 1	غَيْرِ عَامَّةٍ
u'غَيْرٌ عَامٌّ':Added, #1: 1	غَيْرَ عَامَّةٍ
u'غير عَامٌّ':Added, #1: 1	غَيْرِ عَامَّةٍ
u'غَيْرٌ عَامٌّ':Added, #2: 2	غَيْرُ الْعَامِّ
u'غير عَامٌّ':Added, #2: 2	غَيْرُ الْعَامِّ
u'غَيْرٌ عَامٌّ':Added, #2: 2	غَيْرُ عَامَّةٍ
u'غير عَامٌّ':Added, #2: 2	غَيْرُ عَامَّةٍ
u'غَيْرٌ عَامٌّ':Added, #4: 4	غَيْرُ عَامٍّ
u'غير عَامِدٌ':Added, #4: 4	غَيْرُ عَامٍّ
u'غَيْرٌ عَامِدٌ':Added, #6: 6	غَيْرَ عَامِدٍ
u'غير عَامِرٌ':Added, #6: 6	غَيْرَ عَامِدٍ
u'غَيْرٌ عَامِرٌ':Added, #1: 1	غَيْرَ عَامِرٍ
u'غير عَامِرٌ':Added, #1: 1	غَيْرَ عَامِرٍ
u'غَيْرٌ عَامِرٌ':Added, #1: 1	غَيْرُ عَامِرَةٍ
u'غير عَامِلٌ':Added, #1: 1	غَيْرُ عَامِرَةٍ
u'غير عَامِلٌ':Added, #1: 1	غَيْرَ الْعَامِلِ
u'غَيْرٌ عَامِلٌ':Added, #1: 1	غَيْرُ الْعَامِلِ
u'غَيْرٌ عَامِلٌ':Added, #1: 1	غَيْرَ الْعَامِلِ
u'غير عَامِلٌ':Added, #1: 1	غَيْرُ الْعَامِلِ
u'غير عَامِلٌ':Added, #1: 1	غَيْرُ عَامِلِ
u'غَيْرٌ عَامِلٌ':Added, #1: 1	غَيْرِ عَامِلٍ
u'غَيْرٌ عَامِلٌ':Added, #1: 1	غَيْرُ عَامِلِ
u'غير عَامِلٌ':Added, #1: 1	غَيْرِ عَامِلٍ
u'غَيْرٌ عَامِلٌ':Added, #1: 1	غَيْرُ عَامِلَةٍ
u'غير عَامِلٌ':Added, #1: 1	غَيْرُ عَامِلَةٍ
u'غير عَامِلٌ':Added, #1: 1	غَيْرَ عَامِلَتَيْنِ
u'غَيْرٌ عَامِلٌ':Added, #1: 1	غَيْرُ عَامِلَتَيْنِ
u'غَيْرٌ عَامِلٌ':Added, #1: 1	غَيْرَ عَامِلَتَيْنِ
u'غير عَامِلٌ':Added, #1: 1	غَيْرُ عَامِلَتَيْنِ
u'غَيْرٌ عَامِلٌ':Added, #2: 2	غَيْرِ الْعَامِلِ
u'غير عَامِلٌ':Added, #2: 2	غَيْرِ الْعَامِلِ
u'غَيْرٌ عَامِلٌ':Added, #3: 3	غَيْرَ عَامِلٍ
u'غير عَامِلٌ':Added, #3: 3	غَيْرَ عَامِلٍ
u'غَيْرٌ عَامِلٌ':Added, #9: 9	غَيْرُ عَامِلٍ
u'غير عَامِّيٌّ':Added, #9: 9	غَيْرُ عَامِلٍ
u'غَيْرٌ عَامِّيٌّ':Added, #2: 2	غَيْرِ الْعَامِّيِّ
u'غير عَانَةٌ':Added, #2: 2	غَيْرِ الْعَامِّيِّ
u'غَيْرٌ عَانَةٌ':Added, #2: 2	غَيْرِ الْعَانَةِ
u'غير عَائِدٌ':Added, #2: 2	غَيْرِ الْعَانَةِ
u'غَيْرٌ عَائِدٌ':Added, #1: 1	غَيْرُ عَائِدٍ
u'غير عَائِقٌ':Added, #1: 1	غَيْرُ عَائِدٍ
u'غَيْرٌ عَائِقٌ':Added, #1: 1	غَيْرِ عَائِقٍ
u'غير عَائِلٌ':Added, #1: 1	غَيْرِ عَائِقٍ
u'غَيْرٌ عَائِلٌ':Added, #1: 1	غَيْرُ الْعَائِلِ
u'غير عَائِلٌ':Added, #1: 1	غَيْرُ الْعَائِلِ
u'غَيْرٌ عَائِلٌ':Added, #3: 3	غَيْرُ عَائِلِ
u'غير عِبَادَةٌ':Added, #3: 3	غَيْرُ عَائِلِ
u'غَيْرٌ عِبَادَةٌ':Added, #1: 1	غَيْرُ الْعِبَادَاتِ
u'غير عِبَادَةٌ':Added, #1: 1	غَيْرُ الْعِبَادَاتِ
u'غَيْرٌ عِبَادَةٌ':Added, #1: 1	غَيْرِ الْعِبَادَةِ
u'غير عِبَادَةٌ':Added, #1: 1	غَيْرِ الْعِبَادَةِ
u'غَيْرٌ عِبَادَةٌ':Added, #1: 1	غَيْرُ عِبَادَةٍ
u'غير عِبَادَةٌ':Added, #1: 1	غَيْرُ عِبَادَةٍ
u'غَيْرٌ عِبَادَةٌ':Added, #3: 3	غَيْرَ عِبَادَةٍ
u'غير عِبَادَةٌ':Added, #3: 3	غَيْرَ عِبَادَةٍ
u'غَيْرٌ عِبَادَةٌ':Added, #6: 6	غَيْرِ الْعِبَادَاتِ
u'غَيَّرَ عِبَارَةٌ':Predicate, #6: 6	غَيْرِ الْعِبَادَاتِ
u'غير عِبَارَةٌ':Added, #1: 1	غَيَّرَ الْعِبَارَةَ
u'غَيْرٌ عِبَارَةٌ':Added, #1: 1	غَيْرُ عِبَارَةِ
u'غير عَبَّاسٌ':Added, #1: 1	غَيْرُ عِبَارَةِ
u'غَيْرٌ عَبَّاسٌ':Added, #1: 1	غَيْرُ الْعَبَّاسِ
u'غير عَبَثٌ':Added, #1: 1	غَيْرُ الْعَبَّاسِ
u'غَيْرٌ عَبَثٌ':Added, #3: 3	غَيْرِ عَبَثٍ
u'غير عَبْدٌ':Added, #3: 3	غَيْرِ عَبَثٍ
u'غَيْرٌ عَبْدٌ':Added, #10: 10	غَيْرُ الْعَبْدِ
u'غير عَبْدٌ':Added, #10: 10	غَيْرُ الْعَبْدِ
u'غَيْرٌ عَبْدٌ':Added, #1: 1	غَيْرُ الْعَبْدَيْنِ
u'غير عَبْدٌ':Added, #1: 1	غَيْرُ الْعَبْدَيْنِ
u'غير عَبْدٌ':Added, #1: 1	غَيْرَ عَبْدٍ
u'غير عَبْدٌ':Added, #1: 1	غَيْرَ عَبْدِ
u'غَيْرٌ عَبْدٌ':Added, #1: 1	غَيْرُ عَبْدٍ
u'غَيْرٌ عَبْدٌ':Added, #1: 1	غَيْرَ عَبْدٍ
u'غَيْرٌ عَبْدٌ':Added, #1: 1	غَيْرَ عَبْدِ
u'غير عَبْدٌ':Added, #1: 1	غَيْرُ عَبْدٍ
u'غَيْرٌ عَبْدٌ':Added, #1: 1	غَيْرُ عَبْدِهِ
u'غير عَبْدٌ':Added, #1: 1	غَيْرُ عَبْدِهِ
u'غَيْرٌ عَبْدٌ':Added, #20: 20	غَيْرُ عَبْدِ
u'غير عَبْدٌ':Added, #20: 20	غَيْرُ عَبْدِ
u'غَيْرٌ عَبْدٌ':Added, #2: 2	غَيْرِ عَبْدِ
u'غير عَبْدٌ':Added, #2: 2	غَيْرِ عَبْدِ
u'غَيْرٌ عَبْدٌ':Added, #3: 3	غَيْرِ عَبْدٍ
u'غير عَبْدٌ':Added, #3: 3	غَيْرِ عَبْدٍ
u'غَيْرٌ عَبْدٌ':Added, #3: 3	غَيْرَ عَبْدِهِ
u'غير عَبْدٌ':Added, #3: 3	غَيْرَ عَبْدِهِ
u'غَيْرٌ عَبْدٌ':Added, #6: 6	غَيْرَ الْعَبْدِ
u'غير عَبْدٌ':Added, #6: 6	غَيْرَ الْعَبْدِ
u'غَيْرٌ عَبْدٌ':Added, #7: 7	غَيْرِ الْعَبْدِ
u'غير عَبِيدٌ':Added, #7: 7	غَيْرِ الْعَبْدِ
u'غَيْرٌ عَبِيدٌ':Added, #2: 2	غَيْرِ الْعَبِيدِ
u'غير عَبِيدٌ':Added, #2: 2	غَيْرِ الْعَبِيدِ
u'غَيْرٌ عَبِيدٌ':Added, #2: 2	غَيْرُ عَبِيدِهِ
u'غير عتق':Added, #2: 2	غَيْرُ عَبِيدِهِ
u'غير عتق':Added, #1: 1	غَيْر الْعِتْقِ
u'غَيْرٌ عتق':Added, #1: 1	غَيْرِ الْعَتْقِ
u'غَيْرٌ عتق':Added, #1: 1	غَيْر الْعِتْقِ
u'غير عِتْقٌ':Added, #1: 1	غَيْرِ الْعَتْقِ
u'غَيْرٌ عِتْقٌ':Added, #1: 1	غَيْر الْعِتْقِ
u'غير عتق':Added, #1: 1	غَيْر الْعِتْقِ
u'غَيْرٌ عتق':Added, #1: 1	غَيْرِ عِتْقِ
u'غير عِتْقٌ':Added, #1: 1	غَيْرِ عِتْقِ
u'غَيْرٌ عِتْقٌ':Added, #1: 1	غَيْرِ عِتْقِ
u'غير عِتْقٌ':Added, #1: 1	غَيْرِ عِتْقِ
u'غَيْرٌ عِتْقٌ':Added, #2: 2	غَيْرِ عِتْقٍ
u'غير عتق':Added, #2: 2	غَيْرِ عِتْقٍ
u'غير عتق':Added, #5: 5	غَيْرَ الْعِتْقِ
u'غَيْرٌ عتق':Added, #5: 5	غَيْرُ الْعِتْقِ
u'غَيْرٌ عتق':Added, #5: 5	غَيْرَ الْعِتْقِ
u'غير عِتْقٌ':Added, #5: 5	غَيْرُ الْعِتْقِ
u'غير عِتْقٌ':Added, #5: 5	غَيْرَ الْعِتْقِ
u'غَيْرٌ عِتْقٌ':Added, #5: 5	غَيْرُ الْعِتْقِ
u'غَيْرٌ عِتْقٌ':Added, #5: 5	غَيْرَ الْعِتْقِ
u'غير عتق':Added, #5: 5	غَيْرُ الْعِتْقِ
u'غَيْرٌ عتق':Added, #8: 8	غَيْرِ الْعِتْقِ
u'غير عِتْقٌ':Added, #8: 8	غَيْرِ الْعِتْقِ
u'غَيْرٌ عِتْقٌ':Added, #8: 8	غَيْرِ الْعِتْقِ
u'غير عجائز':Added, #8: 8	غَيْرِ الْعِتْقِ
u'غَيْرٌ عجائز':Added, #1: 1	غَيْرِ الْعَجَائِزِ
u'غير عُجْبٌ':Added, #1: 1	غَيْرِ الْعَجَائِزِ
u'غَيْرٌ عُجْبٌ':Added, #1: 1	غَيْرُ الْعُجْبِ
u'غير عَجَبٌ':Added, #1: 1	غَيْرُ الْعُجْبِ
u'غَيْرٌ عَجَبٌ':Added, #3: 3	غَيْرِ عَجَبٍ
u'غير عجز':Added, #3: 3	غَيْرِ عَجَبٍ
u'غَيْرٌ عجز':Added, #1: 1	غَيْرُ الْعَجْزِ
u'غير عَجْزٌ':Added, #1: 1	غَيْرُ الْعَجْزِ
u'غَيْرٌ عَجْزٌ':Added, #1: 1	غَيْرُ الْعَجْزِ
u'غير عَجْزٌ':Added, #1: 1	غَيْرُ الْعَجْزِ
u'غَيْرٌ عَجْزٌ':Added, #1: 1	غَيْرِ عَجْزٍ
u'غير عَجِينٌ':Added, #1: 1	غَيْرِ عَجْزٍ
u'غَيْرٌ عَجِينٌ':Added, #1: 1	غَيْرُ الْعَجِينِ
u'غير عَدٌّ':Added, #1: 1	غَيْرُ الْعَجِينِ
u'غَيْرٌ عَدٌّ':Added, #1: 1	غَيْرِ عَدِّ
u'غير عَدَاءٌ':Added, #1: 1	غَيْرِ عَدِّ
u'غَيْرٌ عَدَاءٌ':Added, #1: 1	غَيْرَ عَدَاءٍ
u'غير عَدَالَةٌ':Added, #1: 1	غَيْرَ عَدَاءٍ
u'غَيْرٌ عَدَالَةٌ':Added, #1: 1	غَيْرِ الْعَدَالَةِ
u'غير عَدَالَةٌ':Added, #1: 1	غَيْرِ الْعَدَالَةِ
u'غَيْرٌ عَدَالَةٌ':Added, #1: 1	غَيْرُ عَدَالَتِهِ
u'غير عِدَّةٌ':Added, #1: 1	غَيْرُ عَدَالَتِهِ
u'غَيْرٌ عِدَّةٌ':Added, #1: 1	غَيْرُ الْعِدَّةِ
u'غير عِدَّةٌ':Added, #1: 1	غَيْرُ الْعِدَّةِ
u'غير عِدَّةٌ':Added, #1: 1	غَيْرُ عِدَّةِ
u'غَيْرٌ عِدَّةٌ':Added, #1: 1	غَيْرِ عِدَّةٍ
u'غَيْرٌ عِدَّةٌ':Added, #1: 1	غَيْرُ عِدَّةِ
u'غير عِدَّةٌ':Added, #1: 1	غَيْرِ عِدَّةٍ
u'غَيْرٌ عِدَّةٌ':Added, #1: 1	غَيْرِ عِدَّتِهِ
u'غَيَّرَ عَدَدٌ':Predicate, #1: 1	غَيْرِ عِدَّتِهِ
u'غَيَّرَ عَدَدٌ':Predicate, #1: 1	غَيَّرَ عَدَدَ
u'غير عَدَدٌ':Added, #2: 2	غَيَّرَ الْعَدَدَ
u'غَيْرٌ عَدَدٌ':Added, #4: 4	غَيْرِ عَدَدٍ
u'غير عَدَدِيٌّ':Added, #4: 4	غَيْرِ عَدَدٍ
u'غَيْرٌ عَدَدِيٌّ':Added, #2: 2	غَيْرِ الْعَدَدِيِّ
u'غير عَدْلٌ':Added, #2: 2	غَيْرِ الْعَدَدِيِّ
u'غَيْرٌ عَدْلٌ':Added, #13: 13	غَيْرِ الْعَدْلِ
u'غير عَدْلٌ':Added, #13: 13	غَيْرِ الْعَدْلِ
u'غَيْرٌ عَدْلٌ':Added, #13: 13	غَيْرُ عَدْلٍ
u'غير عَدْلٌ':Added, #13: 13	غَيْرُ عَدْلٍ
u'غَيْرٌ عَدْلٌ':Added, #14: 14	غَيْرِ عَدْلٍ
u'غير عَدْلٌ':Added, #14: 14	غَيْرِ عَدْلٍ
u'غير عَدْلٌ':Added, #2: 2	غَيْرَ الْعَدْلِ
u'غَيْرٌ عَدْلٌ':Added, #2: 2	غَيْرُ الْعَدْلِ
u'غَيْرٌ عَدْلٌ':Added, #2: 2	غَيْرَ الْعَدْلِ
u'غير عَدْلٌ':Added, #2: 2	غَيْرُ الْعَدْلِ
u'غَيْرٌ عَدْلٌ':Added, #3: 3	غَيْرِ عَدْلَيْنِ
u'غير عَدْلٌ':Added, #3: 3	غَيْرِ عَدْلَيْنِ
u'غَيْرٌ عَدْلٌ':Added, #40: 40	غَيْرَ عَدْلٍ
u'غير عَدْلٌ':Added, #40: 40	غَيْرَ عَدْلٍ
u'غَيْرٌ عَدْلٌ':Added, #5: 5	غَيْرُ عَدْلَيْنِ
u'غير عَدْلٌ':Added, #5: 5	غَيْرُ عَدْلَيْنِ
u'غَيْرٌ عَدْلٌ':Added, #6: 6	غَيْرَ عَدْلَيْنِ
u'غير عَدَمٌ':Added, #6: 6	غَيْرَ عَدْلَيْنِ
u'غير عَدَمٌ':Added, #1: 1	غَيْرَ عَدَمِ
u'غَيْرٌ عَدَمٌ':Added, #1: 1	غَيْرُ عَدَمِ
u'غَيْرٌ عَدَمٌ':Added, #1: 1	غَيْرَ عَدَمِ
u'غير عَدُوٌّ':Added, #1: 1	غَيْرُ عَدَمِ
u'غَيْرٌ عَدُوٌّ':Added, #1: 1	غَيْرِ الْعَدُوِّ
u'غير عَدُوٌّ':Added, #1: 1	غَيْرِ الْعَدُوِّ
u'غَيْرٌ عَدُوٌّ':Added, #1: 1	غَيْرَ عَدُوٍّ
u'غير عَدُوٌّ':Added, #1: 1	غَيْرَ عَدُوٍّ
u'غَيْرٌ عَدُوٌّ':Added, #1: 1	غَيْرِ عَدُوِّهِ
u'غير عَدُوٌّ':Added, #1: 1	غَيْرِ عَدُوِّهِ
u'غَيْرٌ عَدُوٌّ':Added, #1: 1	غَيْرِ عَدُوَّيْنِ
u'غير عُدْوَانٌ':Added, #1: 1	غَيْرِ عَدُوَّيْنِ
u'غَيْرٌ عُدْوَانٌ':Added, #1: 1	غَيْرِ عُدْوَانٍ
u'غير عُدْوَانٌ':Added, #1: 1	غَيْرِ عُدْوَانٍ
u'غَيْرٌ عُدْوَانٌ':Added, #2: 2	غَيْرِ الْعُدْوَانِ
u'غير عُدْوَانٌ':Added, #2: 2	غَيْرِ الْعُدْوَانِ
u'غَيْرٌ عُدْوَانٌ':Added, #2: 2	غَيْرَ عُدْوَانٍ
u'غير عُدُولٌ':Added, #2: 2	غَيْرَ عُدْوَانٍ
u'غير عُدُولٌ':Added, #2: 2	غَيْرُ الْعُدُولِ
u'غَيْرٌ عُدُولٌ':Added, #2: 2	غَيْرِ الْعُدُولِ
u'غَيْرٌ عُدُولٌ':Added, #2: 2	غَيْرُ الْعُدُولِ
u'غير عُدُولٌ':Added, #2: 2	غَيْرِ الْعُدُولِ
u'غَيْرٌ عُدُولٌ':Added, #5: 5	غَيْرِ عُدُولٍ
u'غير عُدُولٌ':Added, #5: 5	غَيْرِ عُدُولٍ
u'غَيْرٌ عُدُولٌ':Added, #6: 6	غَيْرَ عُدُولٍ
u'غير عُدُولٌ':Added, #6: 6	غَيْرَ عُدُولٍ
u'غَيْرٌ عُدُولٌ':Added, #9: 9	غَيْرُ عُدُولٍ
u'غير عَذَابٌ':Added, #9: 9	غَيْرُ عُدُولٍ
u'غَيْرٌ عَذَابٌ':Added, #2: 2	غَيْرِ عَذَابٍ
u'غير عَذْبٌ':Added, #2: 2	غَيْرِ عَذَابٍ
u'غَيْرٌ عَذْبٌ':Added, #1: 1	غَيْرَ عَذْبِ
u'غير عُذْرٌ':Added, #1: 1	غَيْرَ عَذْبِ
u'غَيْرٌ عُذْرٌ':Added, #1: 1	غَيْرِ عُذْرِهِ
u'غير عُذْرٌ':Added, #1: 1	غَيْرِ عُذْرِهِ
u'غَيْرٌ عُذْرٌ':Added, #235: 235	غَيْرِ عُذْرٍ
u'غير عُذْرٌ':Added, #235: 235	غَيْرِ عُذْرٍ
u'غَيْرٌ عُذْرٌ':Added, #2: 2	غَيْرُ عُذْرٍ
u'غير عُذْرٌ':Added, #2: 2	غَيْرُ عُذْرٍ
u'غَيْرٌ عُذْرٌ':Added, #5: 5	غَيْرِ عُذْرِ
u'غير عُذْرٌ':Added, #5: 5	غَيْرِ عُذْرِ
u'غَيْرٌ عُذْرٌ':Added, #6: 6	غَيْرِ الْعُذْرِ
u'غير عَذِرَةٌ':Added, #6: 6	غَيْرِ الْعُذْرِ
u'غَيْرٌ عَذِرَةٌ':Added, #1: 1	غَيْرِ الْعَذِرَةِ
u'غير عُرَاةٌ':Added, #1: 1	غَيْرِ الْعَذِرَةِ
u'غَيْرٌ عُرَاةٌ':Added, #1: 1	غَيْرِ الْعُرَاةِ
u'غير عَرَبٌ':Added, #1: 1	غَيْرِ الْعُرَاةِ
u'غَيْرٌ عَرَبٌ':Added, #1: 1	غَيْرَ الْعَرَبِ
u'غير عَرَبٌ':Added, #1: 1	غَيْرَ الْعَرَبِ
u'غَيْرٌ عَرَبٌ':Added, #1: 1	غَيْرَ عَرَبٍ
u'غير عَرَبٌ':Added, #1: 1	غَيْرَ عَرَبٍ
u'غَيْرٌ عَرَبٌ':Added, #2: 2	غَيْرُ الْعَرَبِ
u'غير عَرَبٌ':Added, #2: 2	غَيْرُ الْعَرَبِ
u'غَيْرٌ عَرَبٌ':Added, #6: 6	غَيْرِ الْعَرَبِ
u'غير عَرَبِيٌّ':Added, #6: 6	غَيْرِ الْعَرَبِ
u'غير عَرَبِيٌّ':Added, #1: 1	غَيْرَ الْعَرَبِيِّ
u'غَيْرٌ عَرَبِيٌّ':Added, #1: 1	غَيْرُ الْعَرَبِيِّ
u'غَيْرٌ عَرَبِيٌّ':Added, #1: 1	غَيْرَ الْعَرَبِيِّ
u'غير عَرَبِيٌّ':Added, #1: 1	غَيْرُ الْعَرَبِيِّ
u'غير عَرَبِيٌّ':Added, #1: 1	غَيْرُ الْعَرَبِيّاتِ
u'غَيْرٌ عَرَبِيٌّ':Added, #1: 1	غَيْرِ الْعَرَبِيّاتِ
u'غَيْرٌ عَرَبِيٌّ':Added, #1: 1	غَيْرُ الْعَرَبِيّاتِ
u'غير عَرَبِيٌّ':Added, #1: 1	غَيْرِ الْعَرَبِيّاتِ
u'غَيْرٌ عَرَبِيٌّ':Added, #1: 1	غَيْرَ الْعَرَبِيَّةِ
u'غير عَرَبِيٌّ':Added, #1: 1	غَيْرَ الْعَرَبِيَّةِ
u'غير عَرَبِيٌّ':Added, #1: 1	غَيْرَ عَرَبِيٍّ
u'غَيْرٌ عَرَبِيٌّ':Added, #1: 1	غَيْرِ عَرَبِيٍّ
u'غَيْرٌ عَرَبِيٌّ':Added, #1: 1	غَيْرَ عَرَبِيٍّ
u'غير عَرَبِيٌّ':Added, #1: 1	غَيْرِ عَرَبِيٍّ
u'غَيْرٌ عَرَبِيٌّ':Added, #1: 1	غَيْرُ عَرَبِيَّةٍ
u'غير عَرَبِيٌّ':Added, #1: 1	غَيْرُ عَرَبِيَّةٍ
u'غَيْرٌ عَرَبِيٌّ':Added, #1: 1	غَيْرُ عَرَبِيَّيْنِ
u'غير عَرَبِيٌّ':Added, #1: 1	غَيْرُ عَرَبِيَّيْنِ
u'غَيْرٌ عَرَبِيٌّ':Added, #2: 2	غَيْرِ الْعَرَبِيِّ
u'غير عَرَبِيٌّ':Added, #2: 2	غَيْرِ الْعَرَبِيِّ
u'غَيْرٌ عَرَبِيٌّ':Added, #2: 2	غَيْرِ الْعَرَبِيَّةِ
u'غير عَرَبِيٌّ':Added, #2: 2	غَيْرِ الْعَرَبِيَّةِ
u'غَيْرٌ عَرَبِيٌّ':Added, #2: 2	غَيْرُ عَرَبِيٍّ
u'غير عَرَبِيٌّ':Added, #2: 2	غَيْرُ عَرَبِيٍّ
u'غَيْرٌ عَرَبِيٌّ':Added, #2: 2	غَيْرَ عَرَبِيَّةٍ
u'غير عَرَبِيٌّ':Added, #2: 2	غَيْرَ عَرَبِيَّةٍ
u'غَيْرٌ عَرَبِيٌّ':Added, #3: 3	غَيْرُ الْعَرَبِيَّةِ
u'غير عُرْسٌ':Added, #3: 3	غَيْرُ الْعَرَبِيَّةِ
u'غَيْرٌ عُرْسٌ':Added, #4: 4	غَيْرِ عُرْسٍ
u'غير عُرْسٌ':Added, #4: 4	غَيْرِ عُرْسٍ
u'غَيْرٌ عُرْسٌ':Added, #9: 9	غَيْرِ الْعُرْسِ
u'غير عَرْشٌ':Added, #9: 9	غَيْرِ الْعُرْسِ
u'غَيْرٌ عَرْشٌ':Added, #1: 1	غَيْرُ الْعَرْشِ
u'غير عَرْضٌ':Added, #1: 1	غَيْرُ الْعَرْشِ
u'غَيْرٌ عَرْضٌ':Added, #1: 1	غَيْرِ عَرْضٍ
u'غير عَرَفَاتٌ':Added, #1: 1	غَيْرِ عَرْضٍ
u'غَيْرٌ عَرَفَاتٌ':Added, #1: 1	غَيْرِ عَرَفَاتٍ
u'غير عُرُوقٌ':Added, #1: 1	غَيْرِ عَرَفَاتٍ
u'غَيْرٌ عُرُوقٌ':Added, #2: 2	غَيْرِ الْعُرُوقِ
u'غير عُرْيَانٌ':Added, #2: 2	غَيْرِ الْعُرُوقِ
u'غَيْرٌ عُرْيَانٌ':Added, #1: 1	غَيْرَ عُرْيَانَةٍ
u'غير عَرِيضَةٌ':Added, #1: 1	غَيْرَ عُرْيَانَةٍ
u'غَيْرٌ عَرِيضَةٌ':Added, #2: 2	غَيْرَ عَرِيضَةٍ
u'غير عزل':Added, #2: 2	غَيْرَ عَرِيضَةٍ
u'غَيْرٌ عزل':Added, #1: 1	غَيْرِ عُزْلٍ
u'غير عَزْمٌ':Added, #1: 1	غَيْرِ عُزْلٍ
u'غَيْرٌ عَزْمٌ':Added, #5: 5	غَيْرِ عَزْمٍ
u'غير عَزْو':Added, #5: 5	غَيْرِ عَزْمٍ
u'غَيْرٌ عَزْو':Added, #5: 5	غَيْرِ عَزْوٍ
u'غير عسر':Added, #5: 5	غَيْرِ عَزْوٍ
u'غَيْرٌ عسر':Added, #1: 1	غَيْرِ عُسْرٍ
u'غير عُسْرٌ':Added, #1: 1	غَيْرِ عُسْرٍ
u'غَيْرٌ عُسْرٌ':Added, #1: 1	غَيْرِ عُسْرٍ
u'غير عَسْكَرٌ':Added, #1: 1	غَيْرِ عُسْرٍ
u'غَيْرٌ عَسْكَرٌ':Added, #1: 1	غَيْرِ الْعَسْكَرِ
u'غير عَشْرٌ':Added, #1: 1	غَيْرِ الْعَسْكَرِ
u'غَيْرٌ عَشْرٌ':Added, #1: 1	غَيْرَ الْعَشْرِ
u'غير عَشْرٌ':Added, #1: 1	غَيْرَ الْعَشْرِ
u'غَيْرٌ عَشْرٌ':Added, #1: 1	غَيْرَ عَشْرَةِ
u'غير عَشْرٌ':Added, #1: 1	غَيْرَ عَشْرَةِ
u'غَيْرٌ عَشْرٌ':Added, #3: 3	غَيْرِ الْعَشْرِ
u'غير عِشْرَةٌ':Added, #3: 3	غَيْرِ الْعَشْرِ
u'غَيْرٌ عِشْرَةٌ':Added, #1: 1	غَيْرِ عِشْرَةٍ
u'غير عِشْقٌ':Added, #1: 1	غَيْرِ عِشْرَةٍ
u'غَيْرٌ عِشْقٌ':Added, #1: 1	غَيْرَ الْعِشْقِ
u'غير عَشِيرٌ':Added, #1: 1	غَيْرَ الْعِشْقِ
u'غَيْرٌ عَشِيرٌ':Added, #1: 1	غَيْرِ عَشِيرَتِهِ
u'غير عَشِيرٌ':Added, #1: 1	غَيْرِ عَشِيرَتِهِ
u'غَيْرٌ عَشِيرٌ':Added, #3: 3	غَيْرِ الْعَشِيرَةِ
u'غير عَشِيرَةٌ':Added, #3: 3	غَيْرِ الْعَشِيرَةِ
u'غَيْرٌ عَشِيرَةٌ':Added, #1: 1	غَيْرِ عَشِيرَتِهِ
u'غير عَشِيرَةٌ':Added, #1: 1	غَيْرِ عَشِيرَتِهِ
u'غَيْرٌ عَشِيرَةٌ':Added, #3: 3	غَيْرِ الْعَشِيرَةِ
u'غير عَصَائِبُ':Added, #3: 3	غَيْرِ الْعَشِيرَةِ
u'غَيْرٌ عَصَائِبُ':Added, #2: 2	غَيْرُ عَصَائِبِ
u'غير عصبة':Added, #2: 2	غَيْرُ عَصَائِبِ
u'غير عصبة':Added, #1: 1	غَيْرَ الْعَصَبَةِ
u'غير عصبة':Added, #1: 1	غَيْرُ الْعَصَبَةِ
u'غَيْرٌ عصبة':Added, #1: 1	غَيْرِ الْعَصَبَةِ
u'غَيْرٌ عصبة':Added, #1: 1	غَيْرَ الْعَصَبَةِ
u'غَيْرٌ عصبة':Added, #1: 1	غَيْرُ الْعَصَبَةِ
u'غير عَصَبَةٌ':Added, #1: 1	غَيْرِ الْعَصَبَةِ
u'غير عَصَبَةٌ':Added, #1: 1	غَيْرَ الْعَصَبَةِ
u'غير عَصَبَةٌ':Added, #1: 1	غَيْرُ الْعَصَبَةِ
u'غَيْرٌ عَصَبَةٌ':Added, #1: 1	غَيْرِ الْعَصَبَةِ
u'غَيْرٌ عَصَبَةٌ':Added, #1: 1	غَيْرَ الْعَصَبَةِ
u'غَيْرٌ عَصَبَةٌ':Added, #1: 1	غَيْرُ الْعَصَبَةِ
u'غير عَصَبَةٌ':Added, #1: 1	غَيْرِ الْعَصَبَةِ
u'غَيْرٌ عَصَبَةٌ':Added, #1: 1	غَيْرَ عَصَبَاتٍ
u'غير عصبة':Added, #1: 1	غَيْرَ عَصَبَاتٍ
u'غير عصبة':Added, #1: 1	غَيْرَ عَصَبَةِ
u'غَيْرٌ عصبة':Added, #1: 1	غَيْرِ عَصَبَةٍ
u'غَيْرٌ عصبة':Added, #1: 1	غَيْرَ عَصَبَةِ
u'غير عَصَبَةٌ':Added, #1: 1	غَيْرِ عَصَبَةٍ
u'غير عَصَبَةٌ':Added, #1: 1	غَيْرَ عَصَبَةِ
u'غَيْرٌ عَصَبَةٌ':Added, #1: 1	غَيْرِ عَصَبَةٍ
u'غَيْرٌ عَصَبَةٌ':Added, #1: 1	غَيْرَ عَصَبَةِ
u'غير عَصْرٌ':Added, #1: 1	غَيْرِ عَصَبَةٍ
u'غَيْرٌ عَصْرٌ':Added, #1: 1	غَيْرُ الْعَصْرِ
u'غير عَصْرٌ':Added, #1: 1	غَيْرُ الْعَصْرِ
u'غير عَصْرٌ':Added, #1: 1	غَيْرُ عَصْرِ
u'غَيْرٌ عَصْرٌ':Added, #1: 1	غَيْرِ عَصْرِ
u'غَيْرٌ عَصْرٌ':Added, #1: 1	غَيْرُ عَصْرِ
u'غير عِصْمَةٌ':Added, #1: 1	غَيْرِ عَصْرِ
u'غَيْرٌ عِصْمَةٌ':Added, #1: 1	غَيْرِ الْعِصْمَةِ
u'غير عِصْيَانٌ':Added, #1: 1	غَيْرِ الْعِصْمَةِ
u'غَيْرٌ عِصْيَانٌ':Added, #1: 1	غَيْرِ عِصْيَانٍ
u'غير عَصِيرٌ':Added, #1: 1	غَيْرِ عِصْيَانٍ
u'غَيْرٌ عَصِيرٌ':Added, #1: 1	غَيْرُ الْعَصِيرِ
u'غير عَصِيرٌ':Added, #1: 1	غَيْرُ الْعَصِيرِ
u'غَيْرٌ عَصِيرٌ':Added, #1: 1	غَيْرِ عَصِيرِ
u'غير عَضْب':Added, #1: 1	غَيْرِ عَصِيرِ
u'غَيْرٌ عَضْب':Added, #1: 1	غَيْرَ عَضْبِ
u'غير عُضْوٌ':Added, #1: 1	غَيْرَ عَضْبِ
u'غَيْرٌ عُضْوٌ':Added, #1: 1	غَيْرَ الْعُضْوِ
u'غير عَطَاءٌ':Added, #1: 1	غَيْرَ الْعُضْوِ
u'غير عَطَاءٌ':Added, #1: 1	غَيْرَ عَطَاءٍ
u'غَيْرٌ عَطَاءٌ':Added, #1: 1	غَيْرُ عَطَاءٍ
u'غَيْرٌ عَطَاءٌ':Added, #1: 1	غَيْرَ عَطَاءٍ
u'غير عِطْرٌ':Added, #1: 1	غَيْرُ عَطَاءٍ
u'غَيْرٌ عِطْرٌ':Added, #1: 1	غَيْرَ الْعِطْرِ
u'غير عَطَشٌ':Added, #1: 1	غَيْرَ الْعِطْرِ
u'غَيْرٌ عَطَشٌ':Added, #1: 1	غَيْرِ الْعَطَشِ
u'غير عَطَشٌ':Added, #1: 1	غَيْرِ الْعَطَشِ
u'غَيْرٌ عَطَشٌ':Added, #3: 3	غَيْرِ عَطَشٍ
u'غير عطف':Added, #3: 3	غَيْرِ عَطَشٍ
u'غَيْرٌ عطف':Added, #1: 1	غَيْرِ الْعَطْفِ
u'غير عَطْفٌ':Added, #1: 1	غَيْرِ الْعَطْفِ
u'غَيْرٌ عَطْفٌ':Added, #1: 1	غَيْرِ الْعَطْفِ
u'غير عَطْفٌ':Added, #1: 1	غَيْرِ الْعَطْفِ
u'غَيْرٌ عَطْفٌ':Added, #2: 2	غَيْرِ عَطْفٍ
u'غير عَطِيَّةٌ':Added, #2: 2	غَيْرِ عَطْفٍ
u'غَيْرٌ عَطِيَّةٌ':Added, #1: 1	غَيْرِ عَطِيَّةِ
u'غير عَظْمٌ':Added, #1: 1	غَيْرِ عَطِيَّةِ
u'غير عَظْمٌ':Added, #1: 1	غَيْرُ الْعَظْمِ
u'غَيْرٌ عَظْمٌ':Added, #1: 1	غَيْرِ الْعَظْمِ
u'غَيْرٌ عَظْمٌ':Added, #1: 1	غَيْرُ الْعَظْمِ
u'غير عَظْمٌ':Added, #1: 1	غَيْرِ الْعَظْمِ
u'غَيْرٌ عَظْمٌ':Added, #1: 1	غَيْرَ عَظْمٍ
u'غير عَظِيم':Added, #1: 1	غَيْرَ عَظْمٍ
u'غَيْرٌ عَظِيم':Added, #1: 1	غَيْرُ عَظِيمٍ
u'غير عَظِيمٌ':Added, #1: 1	غَيْرُ عَظِيمٍ
u'غير عَظِيم':Added, #2: 2	غَيْرِ عَظِيمِ
u'غَيْرٌ عَظِيمٌ':Added, #2: 2	غَيْرِ عَظِيمِ
u'غَيْرٌ عَظِيم':Added, #2: 2	غَيْرِ عَظِيمِ
u'غير عَفْوٌ':Added, #2: 2	غَيْرِ عَظِيمِ
u'غَيْرٌ عَفْوٌ':Added, #1: 1	غَيْرِ عَفْوٍ
u'غير عَفِيفٌ':Added, #1: 1	غَيْرِ عَفْوٍ
u'غير عَفِيفٌ':Added, #1: 1	غَيْرَ الْعَفِيفِ
u'غَيْرٌ عَفِيفٌ':Added, #1: 1	غَيْرُ الْعَفِيفِ
u'غَيْرٌ عَفِيفٌ':Added, #1: 1	غَيْرَ الْعَفِيفِ
u'غير عَفِيفٌ':Added, #1: 1	غَيْرُ الْعَفِيفِ
u'غَيْرٌ عَفِيفٌ':Added, #1: 1	غَيْرِ الْعَفِيفَةِ
u'غير عقاب':Added, #1: 1	غَيْرِ الْعَفِيفَةِ
u'غَيْرٌ عقاب':Added, #1: 1	غَيْر عِقَابٍ
u'غير عِقَابٌ':Added, #1: 1	غَيْر عِقَابٍ
u'غَيْرٌ عِقَابٌ':Added, #1: 1	غَيْر عِقَابٍ
u'غير عَقَارٌ':Added, #1: 1	غَيْر عِقَابٍ
u'غَيْرٌ عَقَارٌ':Added, #11: 11	غَيْرِ الْعَقَارِ
u'غير عَقَارٌ':Added, #11: 11	غَيْرِ الْعَقَارِ
u'غَيْرٌ عَقَارٌ':Added, #1: 1	غَيْرِ عَقَارِهِ
u'غير عَقَارٌ':Added, #1: 1	غَيْرِ عَقَارِهِ
u'غير عَقَارٌ':Added, #2: 2	غَيْرَ عَقَارٍ
u'غَيْرٌ عَقَارٌ':Added, #2: 2	غَيْرِ عَقَارٍ
u'غَيْرٌ عَقَارٌ':Added, #2: 2	غَيْرَ عَقَارٍ
u'غير عَقَارٌ':Added, #2: 2	غَيْرِ عَقَارٍ
u'غَيْرٌ عَقَارٌ':Added, #4: 4	غَيْرَ الْعَقَارِ
u'غير عَقِبٌ':Added, #4: 4	غَيْرَ الْعَقَارِ
u'غَيْرٌ عَقِبٌ':Added, #4: 4	غَيْرِ عَقِبٍ
u'غير عقبة':Added, #4: 4	غَيْرِ عَقِبٍ
u'غَيْرٌ عقبة':Added, #1: 1	غَيْرَ الْعَقَبَةِ
u'غير عَقَبَةٌ':Added, #1: 1	غَيْرَ الْعَقَبَةِ
u'غَيْرٌ عَقَبَةٌ':Added, #1: 1	غَيْرَ الْعَقَبَةِ
u'غير عُقَدٌ':Added, #1: 1	غَيْرَ الْعَقَبَةِ
u'غَيْرٌ عُقَدٌ':Added, #1: 1	غَيْرِ عُقَدٍ
u'غير عَقْدٌ':Added, #1: 1	غَيْرِ عُقَدٍ
u'غَيْرٌ عَقْدٌ':Added, #26: 26	غَيْرِ عَقْدٍ
u'غير عَقْدٌ':Added, #26: 26	غَيْرِ عَقْدٍ
u'غَيْرٌ عَقْدٌ':Added, #2: 2	غَيْرَ عَقْدِ
u'غير عَقْدٌ':Added, #2: 2	غَيْرَ عَقْدِ
u'غير عَقْدٌ':Added, #3: 3	غَيْرَ الْعَقْدِ
u'غَيْرٌ عَقْدٌ':Added, #3: 3	غَيْرِ الْعَقْدِ
u'غَيْرٌ عَقْدٌ':Added, #3: 3	غَيْرَ الْعَقْدِ
u'غير عَقْدٌ':Added, #3: 3	غَيْرِ الْعَقْدِ
u'غير عَقْدٌ':Added, #3: 3	غَيْرُ عَقْدِ
u'غَيْرٌ عَقْدٌ':Added, #3: 3	غَيْرِ عَقْدِ
u'غَيْرٌ عَقْدٌ':Added, #3: 3	غَيْرُ عَقْدِ
u'غير عَقْدٌ':Added, #3: 3	غَيْرِ عَقْدِ
u'غَيْرٌ عَقْدٌ':Added, #5: 5	غَيْرُ الْعَقْدِ
u'غير عُقْرٌ':Added, #5: 5	غَيْرُ الْعَقْدِ
u'غَيْرٌ عُقْرٌ':Added, #1: 1	غَيْرِ عُقْرٍ
u'غير عَقْلٌ':Added, #1: 1	غَيْرِ عُقْرٍ
u'غَيْرٌ عَقْلٌ':Added, #2: 2	غَيْرَ الْعَقْلِ
u'غير عُقَلاَءُ':Added, #2: 2	غَيْرَ الْعَقْلِ
u'غير عُقَلاَءُ':Added, #1: 1	غَيْرَ الْعُقَلَاءِ
u'غَيْرٌ عُقَلاَءُ':Added, #1: 1	غَيْرُ الْعُقَلَاءِ
u'غَيْرٌ عُقَلاَءُ':Added, #1: 1	غَيْرَ الْعُقَلَاءِ
u'غير عُقَلاَءُ':Added, #1: 1	غَيْرُ الْعُقَلَاءِ
u'غَيْرٌ عُقَلاَءُ':Added, #2: 2	غَيْرِ الْعُقَلَاءِ
u'غير عَقْلِيٌّ':Added, #2: 2	غَيْرِ الْعُقَلَاءِ
u'غَيْرٌ عَقْلِيٌّ':Added, #1: 1	غَيْرُ عَقْلِيٍّ
u'غير عَقْلِيٌّ':Added, #1: 1	غَيْرُ عَقْلِيٍّ
u'غَيْرٌ عَقْلِيٌّ':Added, #2: 2	غَيْرَ عَقْلِيٍّ
u'غير عُقُوبَةٌ':Added, #2: 2	غَيْرَ عَقْلِيٍّ
u'غَيْرٌ عُقُوبَةٌ':Added, #2: 2	غَيْرِ الْعُقُوبَاتِ
u'غير عُقُوبَةٌ':Added, #2: 2	غَيْرِ الْعُقُوبَاتِ
u'غَيْرٌ عُقُوبَةٌ':Added, #2: 2	غَيْرَ عُقُوبَةٍ
u'غير عُقُودٌ':Added, #2: 2	غَيْرَ عُقُوبَةٍ
u'غَيْرٌ عُقُودٌ':Added, #1: 1	غَيْرِ الْعُقُودِ
u'غير عُقُودٌ':Added, #1: 1	غَيْرِ الْعُقُودِ
u'غَيْرٌ عُقُودٌ':Added, #1: 1	غَيْرِ عُقُودِ
u'غير عَقُورٌ':Added, #1: 1	غَيْرِ عُقُودِ
u'غَيْرٌ عَقُورٌ':Added, #1: 1	غَيْرُ الْعَقُورِ
u'غير عَقُورٌ':Added, #1: 1	غَيْرُ الْعَقُورِ
u'غير عَقُورٌ':Added, #3: 3	غَيْرَ الْعَقُورِ
u'غَيْرٌ عَقُورٌ':Added, #3: 3	غَيْرِ الْعَقُورِ
u'غَيْرٌ عَقُورٌ':Added, #3: 3	غَيْرَ الْعَقُورِ
u'غير عُقُوقٌ':Added, #3: 3	غَيْرِ الْعَقُورِ
u'غَيْرٌ عُقُوقٌ':Added, #1: 1	غَيْرُ عُقُوقٍ
u'غير عَكْسٌ':Added, #1: 1	غَيْرُ عُقُوقٍ
u'غَيْرٌ عَكْسٌ':Added, #29: 29	غَيْرِ عَكْسٍ
u'غير عِلاَجٌ':Added, #29: 29	غَيْرِ عَكْسٍ
u'غَيْرٌ عِلاَجٌ':Added, #1: 1	غَيْرِ عِلَاجِ
u'غير عِلاَجٌ':Added, #1: 1	غَيْرِ عِلَاجِ
u'غَيْرٌ عِلاَجٌ':Added, #2: 2	غَيْرِ عِلَاجٍ
u'غير عَلاَقَةٌ':Added, #2: 2	غَيْرِ عِلَاجٍ
u'غَيْرٌ عَلاَقَةٌ':Added, #2: 2	غَيْرِ عَلَاقَةٍ
u'غير عَلاَمَةٌ':Added, #2: 2	غَيْرِ عَلَاقَةٍ
u'غَيْرٌ عَلاَمَةٌ':Added, #2: 2	غَيْرِ عَلَامَةٍ
u'غير عِلَّةٌ':Added, #2: 2	غَيْرِ عَلَامَةٍ
u'غَيْرٌ عِلَّةٌ':Added, #18: 18	غَيْرِ عِلَّةٍ
u'غير عِلَّةٌ':Added, #18: 18	غَيْرِ عِلَّةٍ
u'غير عِلَّةٌ':Added, #1: 1	غَيْرَ الْعِلَّةِ
u'غَيْرٌ عِلَّةٌ':Added, #1: 1	غَيْرُ الْعِلَّةِ
u'غَيْرٌ عِلَّةٌ':Added, #1: 1	غَيْرَ الْعِلَّةِ
u'غير عِلَّةٌ':Added, #1: 1	غَيْرُ الْعِلَّةِ
u'غير عِلَّةٌ':Added, #1: 1	غَيْرَ عِلَّةٍ
u'غَيْرٌ عِلَّةٌ':Added, #1: 1	غَيْرُ عِلَّةِ
u'غَيْرٌ عِلَّةٌ':Added, #1: 1	غَيْرَ عِلَّةٍ
u'غير عِلَّةٌ':Added, #1: 1	غَيْرُ عِلَّةِ
u'غَيْرٌ عِلَّةٌ':Added, #3: 3	غَيْرِ الْعِلَّةِ
u'غير عَلَفٌ':Added, #3: 3	غَيْرِ الْعِلَّةِ
u'غَيْرٌ عَلَفٌ':Added, #1: 1	غَيْرِ عَلَفٍ
u'غير علم':Added, #1: 1	غَيْرِ عَلَفٍ
u'غَيْرٌ علم':Added, #11: 11	غَيْرِ عِلْمِهِ
u'غير عِلْمٌ':Added, #11: 11	غَيْرِ عِلْمِهِ
u'غَيْرٌ عِلْمٌ':Added, #11: 11	غَيْرِ عِلْمِهِ
u'غير علم':Added, #11: 11	غَيْرِ عِلْمِهِ
u'غير علم':Added, #1: 1	غَيْرَ الْعَلَمِ
u'غير علم':Added, #1: 1	غَيْرَ الْعِلْمِ
u'غَيْرٌ علم':Added, #1: 1	غَيْرُ الْعَلَمِ
u'غَيْرٌ علم':Added, #1: 1	غَيْرَ الْعَلَمِ
u'غَيْرٌ علم':Added, #1: 1	غَيْرَ الْعِلْمِ
u'غير عَلَمٌ':Added, #1: 1	غَيْرُ الْعَلَمِ
u'غير عَلَمٌ':Added, #1: 1	غَيْرَ الْعَلَمِ
u'غير عِلْمٌ':Added, #1: 1	غَيْرُ الْعَلَمِ
u'غَيْرٌ عَلَمٌ':Added, #1: 1	غَيْرَ الْعِلْمِ
u'غَيْرٌ عَلَمٌ':Added, #1: 1	غَيْرَ الْعَلَمِ
u'غَيْرٌ عِلْمٌ':Added, #1: 1	غَيْرُ الْعَلَمِ
u'غير علم':Added, #1: 1	غَيْرَ الْعِلْمِ
u'غَيْرٌ علم':Added, #1: 1	غَيْرَ عَلَمٍ
u'غير عَلَمٌ':Added, #1: 1	غَيْرَ عَلَمٍ
u'غَيْرٌ عَلَمٌ':Added, #1: 1	غَيْرَ عَلَمٍ
u'غير علم':Added, #1: 1	غَيْرَ عَلَمٍ
u'غَيْرٌ علم':Added, #26: 26	غَيْرِ عِلْمٍ
u'غير عِلْمٌ':Added, #26: 26	غَيْرِ عِلْمٍ
u'غَيْرٌ عِلْمٌ':Added, #26: 26	غَيْرِ عِلْمٍ
u'غير علم':Added, #26: 26	غَيْرِ عِلْمٍ
u'غَيْرٌ علم':Added, #3: 3	غَيْرُ الْعِلْمِ
u'غير عِلْمٌ':Added, #3: 3	غَيْرُ الْعِلْمِ
u'غَيْرٌ عِلْمٌ':Added, #3: 3	غَيْرُ الْعِلْمِ
u'غير علم':Added, #3: 3	غَيْرُ الْعِلْمِ
u'غَيْرٌ علم':Added, #8: 8	غَيْرِ الْعِلْمِ
u'غير عِلْمٌ':Added, #8: 8	غَيْرِ الْعِلْمِ
u'غَيْرٌ عِلْمٌ':Added, #8: 8	غَيْرِ الْعِلْمِ
u'غير علم':Added, #8: 8	غَيْرِ الْعِلْمِ
u'غَيْرٌ علم':Added, #9: 9	غَيْرِ عِلْمِ
u'غير عِلْمٌ':Added, #9: 9	غَيْرِ عِلْمِ
u'غَيْرٌ عِلْمٌ':Added, #9: 9	غَيْرِ عِلْمِ
u'غير علماء':Added, #9: 9	غَيْرِ عِلْمِ
u'غير علماء':Added, #1: 1	غَيْرَ الْعُلَمَاءِ
u'غَيْرٌ علماء':Added, #1: 1	غَيْرِ الْعُلَمَاءِ
u'غَيْرٌ علماء':Added, #1: 1	غَيْرَ الْعُلَمَاءِ
u'غير عُلَمَاءُ':Added, #1: 1	غَيْرِ الْعُلَمَاءِ
u'غير عُلَمَاءُ':Added, #1: 1	غَيْرَ الْعُلَمَاءِ
u'غَيْرٌ عُلَمَاءُ':Added, #1: 1	غَيْرِ الْعُلَمَاءِ
u'غَيْرٌ عُلَمَاءُ':Added, #1: 1	غَيْرَ الْعُلَمَاءِ
u'غير عُلُومٌ':Added, #1: 1	غَيْرِ الْعُلَمَاءِ
u'غَيْرٌ عُلُومٌ':Added, #1: 1	غَيْرِ الْعُلُومِ
u'غير عِلِّيٌّ':Added, #1: 1	غَيْرِ الْعُلُومِ
u'غير عِلِّيٌّ':Added, #1: 1	غَيْرَ الْعِلِّيَّةِ
u'غَيْرٌ عِلِّيٌّ':Added, #1: 1	غَيْرُ الْعِلِّيَّةِ
u'غَيْرٌ عِلِّيٌّ':Added, #1: 1	غَيْرَ الْعِلِّيَّةِ
u'غير عَلِيٌّ':Added, #1: 1	غَيْرُ الْعِلِّيَّةِ
u'غَيْرٌ عَلِيٌّ':Added, #1: 1	غَيْرَ عَلِيٍّ
u'غير عِلِّيٌّ':Added, #1: 1	غَيْرَ عَلِيٍّ
u'غَيْرٌ عِلِّيٌّ':Added, #2: 2	غَيْرِ الْعِلِّيَّةِ
u'غير عَلِيٌّ':Added, #2: 2	غَيْرِ الْعِلِّيَّةِ
u'غير عَلِيٌّ':Added, #2: 2	غَيْرُ عَلِيٍّ
u'غَيْرٌ عَلِيٌّ':Added, #2: 2	غَيْرُ عَلِيِّ
u'غَيْرٌ عَلِيٌّ':Added, #2: 2	غَيْرُ عَلِيٍّ
u'غير عَلِيمٌ':Added, #2: 2	غَيْرُ عَلِيِّ
u'غَيْرٌ عَلِيمٌ':Added, #1: 1	غَيْرُ الْعَلِيمِ
u'غير عَمٌّ':Added, #1: 1	غَيْرُ الْعَلِيمِ
u'غَيْرٌ عَمٌّ':Added, #1: 1	غَيْرَ عَمِّ
u'غير عَمٌّ':Added, #1: 1	غَيْرَ عَمِّ
u'غَيْرٌ عَمٌّ':Added, #1: 1	غَيْرِ عَمّهِ
u'غير عِمَارَةٌ':Added, #1: 1	غَيْرِ عَمّهِ
u'غَيْرٌ عِمَارَةٌ':Added, #1: 1	غَيْرِ عِمَارَةٍ
u'غير عِمَارَةٌ':Added, #1: 1	غَيْرِ عِمَارَةٍ
u'غَيْرٌ عِمَارَةٌ':Added, #2: 2	غَيْرُ الْعِمَارَةِ
u'غير عِمَامَةٌ':Added, #2: 2	غَيْرُ الْعِمَارَةِ
u'غَيْرٌ عِمَامَةٌ':Added, #1: 1	غَيْرَ الْعِمَامَةِ
u'غير عَمْدٌ':Added, #1: 1	غَيْرَ الْعِمَامَةِ
u'غَيْرٌ عَمْدٌ':Added, #1: 1	غَيْرُ الْعَمْدِ
u'غير عَمْدٌ':Added, #1: 1	غَيْرُ الْعَمْدِ
u'غير عَمْدٌ':Added, #1: 1	غَيْرَ عَمْدٍ
u'غَيْرٌ عَمْدٌ':Added, #1: 1	غَيْرِ عَمْدِ
u'غَيْرٌ عَمْدٌ':Added, #1: 1	غَيْرَ عَمْدٍ
u'غير عَمْدٌ':Added, #1: 1	غَيْرِ عَمْدِ
u'غَيْرٌ عَمْدٌ':Added, #2: 2	غَيْرِ الْعَمْدِ
u'غير عُمُرٌ':Added, #2: 2	غَيْرِ الْعَمْدِ
u'غير عُمُرٌ':Added, #1: 1	غَيْرَ الْعُمُرِ
u'غَيْرٌ عُمُرٌ':Added, #1: 1	غَيْرِ الْعُمُرِ
u'غَيْرٌ عُمُرٌ':Added, #1: 1	غَيْرَ الْعُمُرِ
u'غير عُمْرَانٌ':Added, #1: 1	غَيْرِ الْعُمُرِ
u'غَيْرٌ عُمْرَانٌ':Added, #1: 1	غَيْرِ الْعُمْرَانِ
u'غير عمرة':Added, #1: 1	غَيْرِ الْعُمْرَانِ
u'غَيْرٌ عمرة':Added, #2: 2	غَيْرِ عُمْرَةٍ
u'غير عُمْرَةٌ':Added, #2: 2	غَيْرِ عُمْرَةٍ
u'غَيْرٌ عُمْرَةٌ':Added, #2: 2	غَيْرِ عُمْرَةٍ
u'غير عَمَلٌ':Added, #2: 2	غَيْرِ عُمْرَةٍ
u'غَيْرٌ عَمَلٌ':Added, #18: 18	غَيْرِ عَمَلِهِ
u'غير عَمَلٌ':Added, #18: 18	غَيْرِ عَمَلِهِ
u'غير عَمَلٌ':Added, #1: 1	غَيْرَ الْعَمَلِ
u'غَيْرٌ عَمَلٌ':Added, #1: 1	غَيْرِ الْعَمَلِ
u'غَيْرٌ عَمَلٌ':Added, #1: 1	غَيْرَ الْعَمَلِ
u'غير عَمَلٌ':Added, #1: 1	غَيْرِ الْعَمَلِ
u'غير عَمَلٌ':Added, #2: 2	غَيْرَ عَمَلِ
u'غَيْرٌ عَمَلٌ':Added, #2: 2	غَيْرِ عَمَلِ
u'غَيْرٌ عَمَلٌ':Added, #2: 2	غَيْرَ عَمَلِ
u'غير عَمَلٌ':Added, #2: 2	غَيْرِ عَمَلِ
u'غَيْرٌ عَمَلٌ':Added, #5: 5	غَيْرِ عَمَلٍ
u'غير عَمَلِيٌّ':Added, #5: 5	غَيْرِ عَمَلٍ
u'غَيْرٌ عَمَلِيٌّ':Added, #1: 1	غَيْرَ عَمَلِيٍّ
u'غير عَمُودٌ':Added, #1: 1	غَيْرَ عَمَلِيٍّ
u'غَيْرٌ عَمُودٌ':Added, #1: 1	غَيْرِ عَمُودِ
u'غير عَمُودِيٌّ':Added, #1: 1	غَيْرِ عَمُودِ
u'غير عَمُودِيٌّ':Added, #1: 1	غَيْرُ عَمُودِيِّ
u'غَيْرٌ عَمُودِيٌّ':Added, #1: 1	غَيْرِ عَمُودِيِّ
u'غَيْرٌ عَمُودِيٌّ':Added, #1: 1	غَيْرُ عَمُودِيِّ
u'غير عُمُومٌ':Added, #1: 1	غَيْرِ عَمُودِيِّ
u'غير عُمُومٌ':Added, #1: 1	غَيْرَ عُمُومٍ
u'غَيْرٌ عُمُومٌ':Added, #1: 1	غَيْرُ عُمُومِ
u'غَيْرٌ عُمُومٌ':Added, #1: 1	غَيْرَ عُمُومٍ
u'غير عِنَبٌ':Added, #1: 1	غَيْرُ عُمُومِ
u'غَيْرٌ عِنَبٌ':Added, #1: 1	غَيْرُ الْعِنَبِ
u'غير عِنَبٌ':Added, #1: 1	غَيْرُ الْعِنَبِ
u'غَيْرٌ عِنَبٌ':Added, #4: 4	غَيْرِ الْعِنَبِ
u'غير عُنَّة':Added, #4: 4	غَيْرِ الْعِنَبِ
u'غير عُنَّة':Added, #1: 1	غَيْرَ الْعُنَّةِ
u'غَيْرٌ عُنَّة':Added, #1: 1	غَيْرُ الْعُنَّةِ
u'غَيْرٌ عُنَّة':Added, #1: 1	غَيْرَ الْعُنَّةِ
u'غير عُنْفٌ':Added, #1: 1	غَيْرُ الْعُنَّةِ
u'غَيْرٌ عُنْفٌ':Added, #10: 10	غَيْرِ عُنْفٍ
u'غير عنف':Added, #10: 10	غَيْرِ عُنْفٍ
u'غَيْرٌ عنف':Added, #1: 1	غَيْرِ عُنْفِهِ
u'غير عُنْفٌ':Added, #1: 1	غَيْرِ عُنْفِهِ
u'غَيْرٌ عُنْفٌ':Added, #1: 1	غَيْرِ عُنْفِهِ
u'غير عَنْوَة':Added, #1: 1	غَيْرِ عُنْفِهِ
u'غَيْرٌ عَنْوَة':Added, #2: 2	غَيْرَ عَنْوَةٍ
u'غَيَّرَ عَهْدٌ':Predicate, #2: 2	غَيْرَ عَنْوَةٍ
u'غير عَهْدٌ':Added, #1: 1	غَيَّرَ عَهْدَ
u'غَيْرٌ عَهْدٌ':Added, #1: 1	غَيْرِ عَهْدٍ
u'غير عُهْدَةٌ':Added, #1: 1	غَيْرِ عَهْدٍ
u'غَيْرٌ عُهْدَةٌ':Added, #1: 1	غَيْرُ عُهْدَةِ
u'غير عوازب':Added, #1: 1	غَيْرُ عُهْدَةِ
u'غَيْرٌ عوازب':Added, #1: 1	غَيْرُ عَوَازِبِ
u'غير عُودٌ':Added, #1: 1	غَيْرُ عَوَازِبِ
u'غَيْرٌ عُودٌ':Added, #1: 1	غَيْرُ الْعُودِ
u'غير عَوْدٌ':Added, #1: 1	غَيْرُ الْعُودِ
u'غَيْرٌ عَوْدٌ':Added, #3: 3	غَيْرِ عَوْدٍ
u'غير عَوْدَةٌ':Added, #3: 3	غَيْرِ عَوْدٍ
u'غَيْرٌ عَوْدَةٌ':Added, #1: 1	غَيْرِ عَوْدَةٍ
u'غير عَوْرَةٌ':Added, #1: 1	غَيْرِ عَوْدَةٍ
u'غَيْرٌ عَوْرَةٌ':Added, #11: 11	غَيْرِ الْعَوْرَةِ
u'غير عَوْرَةٌ':Added, #11: 11	غَيْرِ الْعَوْرَةِ
u'غير عَوْرَةٌ':Added, #1: 1	غَيْرَ عَوْرَةٍ
u'غير عَوْرَةٌ':Added, #1: 1	غَيْرُ عَوْرَةٍ
u'غَيْرٌ عَوْرَةٌ':Added, #1: 1	غَيْرُ عَوْرَةِ
u'غَيْرٌ عَوْرَةٌ':Added, #1: 1	غَيْرَ عَوْرَةٍ
u'غَيْرٌ عَوْرَةٌ':Added, #1: 1	غَيْرُ عَوْرَةٍ
u'غير عَوْرَةٌ':Added, #1: 1	غَيْرُ عَوْرَةِ
u'غَيْرٌ عَوْرَةٌ':Added, #2: 2	غَيْرِ عَوْرَةِ
u'غير عَوْرَةٌ':Added, #2: 2	غَيْرِ عَوْرَةِ
u'غَيْرٌ عَوْرَةٌ':Added, #2: 2	غَيْرِ عَوْرَتِهِ
u'غير عَوْرَةٌ':Added, #2: 2	غَيْرِ عَوْرَتِهِ
u'غَيْرٌ عَوْرَةٌ':Added, #4: 4	غَيْرَ الْعَوْرَةِ
u'غير عِوَضٌ':Added, #4: 4	غَيْرَ الْعَوْرَةِ
u'غَيْرٌ عِوَضٌ':Added, #36: 36	غَيْرِ عِوَضٍ
u'غير عَوْنٌ':Added, #36: 36	غَيْرِ عِوَضٍ
u'غَيْرٌ عَوْنٌ':Added, #4: 4	غَيْرِ عَوْنٍ
u'غير عِيَالٌ':Added, #4: 4	غَيْرِ عَوْنٍ
u'غير عِيَالٌ':Added, #1: 1	غَيْرُ عِيَالِهِ
u'غَيْرٌ عِيَالٌ':Added, #1: 1	غَيْرِ عِيَالِهِ
u'غَيْرٌ عِيَالٌ':Added, #1: 1	غَيْرُ عِيَالِهِ
u'غير عَيْبٌ':Added, #1: 1	غَيْرِ عِيَالِهِ
u'غَيْرٌ عَيْبٌ':Added, #1: 1	غَيْرِ الْعَيْبِ
u'غير عَيْبٌ':Added, #1: 1	غَيْرِ الْعَيْبِ
u'غير عَيْبٌ':Added, #1: 1	غَيْرَ عَيْبٍ
u'غَيْرٌ عَيْبٌ':Added, #1: 1	غَيْرُ عَيْبٍ
u'غَيْرٌ عَيْبٌ':Added, #1: 1	غَيْرَ عَيْبٍ
u'غير عَيْبٌ':Added, #1: 1	غَيْرُ عَيْبٍ
u'غَيْرٌ عَيْبٌ':Added, #2: 2	غَيْرَ الْعَيْبِ
u'غير عَيْبٌ':Added, #2: 2	غَيْرَ الْعَيْبِ
u'غَيْرٌ عَيْبٌ':Added, #5: 5	غَيْرِ عَيْبٍ
u'غير عِيدٌ':Added, #5: 5	غَيْرِ عَيْبٍ
u'غَيْرٌ عِيدٌ':Added, #1: 1	غَيْرَ عِيدٍ
u'غير عِيدٌ':Added, #1: 1	غَيْرَ عِيدٍ
u'غَيْرٌ عِيدٌ':Added, #5: 5	غَيْرِ الْعِيدِ
u'غير عِيدَانٌ':Added, #5: 5	غَيْرِ الْعِيدِ
u'غَيْرٌ عِيدَانٌ':Added, #1: 1	غَيْرِ عِيدَانِ
u'غير عِيسَوِيّ':Added, #1: 1	غَيْرِ عِيدَانِ
u'غَيْرٌ عِيسَوِيّ':Added, #1: 1	غَيْرِ الْعِيسَوِيِّ
u'غير عِيسَوِيّ':Added, #1: 1	غَيْرِ الْعِيسَوِيِّ
u'غير عِيسَوِيّ':Added, #1: 1	غَيْرُ الْعِيسَوِيَّةِ
u'غَيْرٌ عِيسَوِيّ':Added, #1: 1	غَيْرِ الْعِيسَوِيَّةِ
u'غَيْرٌ عِيسَوِيّ':Added, #1: 1	غَيْرُ الْعِيسَوِيَّةِ
u'غير عَيْشٌ':Added, #1: 1	غَيْرِ الْعِيسَوِيَّةِ
u'غَيْرٌ عَيْشٌ':Added, #1: 1	غَيْرَ عَيْشِ
u'غير عَيْنٌ':Added, #1: 1	غَيْرَ عَيْشِ
u'غير عَيْن':Added, #10: 10	غَيْرُ عَيْنٍ
u'غَيْرٌ عَيْنٌ':Added, #10: 10	غَيْرُ عَيْنٍ
u'غَيْرٌ عَيْن':Added, #10: 10	غَيْرُ عَيْنٍ
u'غير عَيْنٌ':Added, #10: 10	غَيْرُ عَيْنٍ
u'غير عَيْن':Added, #13: 13	غَيْرِ عَيْنٍ
u'غَيْرٌ عَيْنٌ':Added, #13: 13	غَيْرِ عَيْنٍ
u'غَيْرٌ عَيْن':Added, #13: 13	غَيْرِ عَيْنٍ
u'غير عَيْنٌ':Added, #13: 13	غَيْرِ عَيْنٍ
u'غير عَيْن':Added, #17: 17	غَيْرَ عَيْنٍ
u'غَيْرٌ عَيْنٌ':Added, #17: 17	غَيْرَ عَيْنٍ
u'غَيْرٌ عَيْن':Added, #17: 17	غَيْرَ عَيْنٍ
u'غير عين':Added, #17: 17	غَيْرَ عَيْنٍ
u'غير عَيْنٌ':Added, #18: 18	غَيْرِ الْعَيْنِ
u'غير عَيْن':Added, #18: 18	غَيْرِ الْعَيْنِ
u'غَيْرٌ عين':Added, #18: 18	غَيْرِ الْعَيْنِ
u'غَيْرٌ عَيْنٌ':Added, #18: 18	غَيْرِ الْعَيْنِ
u'غَيْرٌ عَيْن':Added, #18: 18	غَيْرِ الْعَيْنِ
u'غير عَيْنٌ':Added, #18: 18	غَيْرِ الْعَيْنِ
u'غير عَيْن':Added, #1: 1	غَيْرِ الْعَيْنَيْنِ
u'غَيْرٌ عَيْنٌ':Added, #1: 1	غَيْرِ الْعَيْنَيْنِ
u'غَيْرٌ عَيْن':Added, #1: 1	غَيْرِ الْعَيْنَيْنِ
u'غير عين':Added, #1: 1	غَيْرِ الْعَيْنَيْنِ
u'غير عَيْنٌ':Added, #2: 2	غَيْرِ عَيْنِ
u'غير عَيْن':Added, #2: 2	غَيْرِ عَيْنِ
u'غَيْرٌ عين':Added, #2: 2	غَيْرِ عَيْنِ
u'غَيْرٌ عَيْنٌ':Added, #2: 2	غَيْرِ عَيْنِ
u'غَيْرٌ عَيْن':Added, #2: 2	غَيْرِ عَيْنِ
u'غير عين':Added, #2: 2	غَيْرِ عَيْنِ
u'غير عَيْنٌ':Added, #3: 3	غَيْرُ الْعَيْنِ
u'غير عَيْن':Added, #3: 3	غَيْرُ الْعَيْنِ
u'غَيْرٌ عين':Added, #3: 3	غَيْرُ الْعَيْنِ
u'غَيْرٌ عَيْنٌ':Added, #3: 3	غَيْرُ الْعَيْنِ
u'غَيْرٌ عَيْن':Added, #3: 3	غَيْرُ الْعَيْنِ
u'غير عين':Added, #3: 3	غَيْرُ الْعَيْنِ
u'غير عَيْنٌ':Added, #4: 4	غَيْرِ عَيْنِهِ
u'غير عَيْن':Added, #4: 4	غَيْرِ عَيْنِهِ
u'غَيْرٌ عين':Added, #4: 4	غَيْرِ عَيْنِهِ
u'غَيْرٌ عَيْنٌ':Added, #4: 4	غَيْرِ عَيْنِهِ
u'غَيْرٌ عَيْن':Added, #4: 4	غَيْرِ عَيْنِهِ
u'غير عَيْنِيَّةٌ':Added, #4: 4	غَيْرِ عَيْنِهِ
u'غَيْرٌ عَيْنِيَّةٌ':Added, #1: 1	غَيْرِ الْعَيْنِيَّةِ
u'غير عُيُوبٌ':Added, #1: 1	غَيْرِ الْعَيْنِيَّةِ
u'غَيْرٌ عُيُوبٌ':Added, #1: 1	غَيْرَ عُيُوبِ
u'غير عُيُونٌ':Added, #1: 1	غَيْرَ عُيُوبِ
u'غَيْرٌ عُيُونٌ':Added, #1: 1	غَيْرِ عُيُونِ
u'غير غَاصِبٌ':Added, #1: 1	غَيْرِ عُيُونِ
u'غَيْرٌ غَاصِبٌ':Added, #10: 10	غَيْرِ الْغَاصِبِ
u'غير غَاصِبٌ':Added, #10: 10	غَيْرِ الْغَاصِبِ
u'غَيْرٌ غَاصِبٌ':Added, #1: 1	غَيْرَ الْغَاصِبِ
u'غير غَاصِبٌ':Added, #1: 1	غَيْرَ الْغَاصِبِ
u'غَيْرٌ غَاصِبٌ':Added, #1: 1	غَيْرِ غَاصِبٍ
u'غير غَاصِبٌ':Added, #1: 1	غَيْرِ غَاصِبٍ
u'غَيْرٌ غَاصِبٌ':Added, #1: 1	غَيْرِ غَاصِبِهِ
u'غير غَاصِبٌ':Added, #1: 1	غَيْرِ غَاصِبِهِ
u'غير غَاصِبٌ':Added, #2: 2	غَيْرَ غَاصِبٍ
u'غَيْرٌ غَاصِبٌ':Added, #2: 2	غَيْرُ غَاصِبٍ
u'غَيْرٌ غَاصِبٌ':Added, #2: 2	غَيْرَ غَاصِبٍ
u'غير غَاصِبٌ':Added, #2: 2	غَيْرُ غَاصِبٍ
u'غَيْرٌ غَاصِبٌ':Added, #5: 5	غَيْرُ الْغَاصِبِ
u'غير غَافِلٌ':Added, #5: 5	غَيْرُ الْغَاصِبِ
u'غير غَافِلٌ':Added, #2: 2	غَيْرَ غَافِلٍ
u'غَيْرٌ غَافِلٌ':Added, #2: 2	غَيْرُ غَافِلٍ
u'غَيْرٌ غَافِلٌ':Added, #2: 2	غَيْرَ غَافِلٍ
u'غير غَالِبٌ':Added, #2: 2	غَيْرُ غَافِلٍ
u'غَيْرٌ غَالِبٌ':Added, #1: 1	غَيْرَ الْغَالِبِ
u'غير غَالِبٌ':Added, #1: 1	غَيْرَ الْغَالِبِ
u'غَيْرٌ غَالِبٌ':Added, #1: 1	غَيْرِ غَالِبِ
u'غير غَالِبٌ':Added, #1: 1	غَيْرِ غَالِبِ
u'غَيْرٌ غَالِبٌ':Added, #1: 1	غَيْرِ غَالِبَةٍ
u'غير غَالِبٌ':Added, #1: 1	غَيْرِ غَالِبَةٍ
u'غير غَالِبٌ':Added, #3: 3	غَيْرَ غَالِبٍ
u'غَيْرٌ غَالِبٌ':Added, #3: 3	غَيْرِ غَالِبٍ
u'غَيْرٌ غَالِبٌ':Added, #3: 3	غَيْرَ غَالِبٍ
u'غير غَالِبٌ':Added, #3: 3	غَيْرِ غَالِبٍ
u'غَيْرٌ غَالِبٌ':Added, #8: 8	غَيْرِ الْغَالِبِ
u'غير غانِم':Added, #8: 8	غَيْرِ الْغَالِبِ
u'غَيْرٌ غانِم':Added, #1: 1	غَيْرِ غَانِمٍ
u'غير غَايَةٌ':Added, #1: 1	غَيْرِ غَانِمٍ
u'غَيْرٌ غَايَةٌ':Added, #1: 1	غَيْرُ الْغَايَةِ
u'غير غَايَةٌ':Added, #1: 1	غَيْرُ الْغَايَةِ
u'غَيْرٌ غَايَةٌ':Added, #2: 2	غَيْرِ غَايَةٍ
u'غير غِبٌّ':Added, #2: 2	غَيْرِ غَايَةٍ
u'غَيْرٌ غِبٌّ':Added, #1: 1	غَيْرَ الْغِبِّ
u'غير غِبٌّ':Added, #1: 1	غَيْرَ الْغِبِّ
u'غَيْرٌ غِبٌّ':Added, #1: 1	غَيْرُ غِبٍّ
u'غير غِبْطَةٌ':Added, #1: 1	غَيْرُ غِبٍّ
u'غَيْرٌ غِبْطَةٌ':Added, #3: 3	غَيْرِ غِبْطَةٍ
u'غير غُرْبَةٌ':Added, #3: 3	غَيْرِ غِبْطَةٍ
u'غَيْرٌ غُرْبَةٌ':Added, #1: 1	غَيْرَ الْغُرْبَةِ
u'غير غُرَّةٌ':Added, #1: 1	غَيْرَ الْغُرْبَةِ
u'غَيْرٌ غُرَّةٌ':Added, #1: 1	غَيْرَ الْغُرَّةِ
u'غير غَرْزٌ':Added, #1: 1	غَيْرَ الْغُرَّةِ
u'غَيْرٌ غَرْزٌ':Added, #1: 1	غَيْرِ غَرْزٍ
u'غير غَرْسٌ':Added, #1: 1	غَيْرِ غَرْزٍ
u'غَيْرٌ غَرْسٌ':Added, #1: 1	غَيْرِ غَرْسٍ
u'غير غَرَضٌ':Added, #1: 1	غَيْرِ غَرْسٍ
u'غير غَرَضٌ':Added, #1: 1	غَيْرُ غَرَضِ
u'غَيْرٌ غَرَضٌ':Added, #1: 1	غَيْرِ غَرَضِ
u'غَيْرٌ غَرَضٌ':Added, #1: 1	غَيْرُ غَرَضِ
u'غير غَرَضٌ':Added, #1: 1	غَيْرِ غَرَضِ
u'غَيْرٌ غَرَضٌ':Added, #2: 2	غَيْرِ غَرَضٍ
u'غير غَرِيمٌ':Added, #2: 2	غَيْرِ غَرَضٍ
u'غَيْرٌ غَرِيمٌ':Added, #4: 4	غَيْرِ الْغَرِيمِ
u'غير غَزْلٌ':Added, #4: 4	غَيْرِ الْغَرِيمِ
u'غير غَزْلٌ':Added, #1: 1	غَيْرُ الْغَزْلِ
u'غَيْرٌ غَزْلٌ':Added, #1: 1	غَيْرِ الْغَزْلِ
u'غَيْرٌ غَزْلٌ':Added, #1: 1	غَيْرُ الْغَزْلِ
u'غير غَزْوٌ':Added, #1: 1	غَيْرِ الْغَزْلِ
u'غَيْرٌ غَزْوٌ':Added, #1: 1	غَيْرِ غَزْوٍ
u'غير غَزْوٌ':Added, #1: 1	غَيْرِ غَزْوٍ
u'غَيْرٌ غَزْوٌ':Added, #4: 4	غَيْرِ الْغَزْوِ
u'غير غُسْلٌ':Added, #4: 4	غَيْرِ الْغَزْوِ
u'غَيْرٌ غُسْلٌ':Added, #1: 1	غَيْرَ الْغُسْلِ
u'غير غَسْلٌ':Added, #1: 1	غَيْرَ الْغُسْلِ
u'غير غُسْلٌ':Added, #1: 1	غَيْرَ غَسْلِ
u'غَيْرٌ غَسْلٌ':Added, #1: 1	غَيْرِ غُسْلِ
u'غَيْرٌ غُسْلٌ':Added, #1: 1	غَيْرَ غَسْلِ
u'غير غَسْلٌ':Added, #1: 1	غَيْرِ غُسْلِ
u'غَيْرٌ غَسْلٌ':Added, #3: 3	غَيْرِ غَسْلِهِ
u'غير غَسْلٌ':Added, #3: 3	غَيْرِ غَسْلِهِ
u'غير غُسْلٌ':Added, #4: 4	غَيْرِ غَسْلِ
u'غَيْرٌ غَسْلٌ':Added, #4: 4	غَيْرِ غُسْلٍ
u'غَيْرٌ غُسْلٌ':Added, #4: 4	غَيْرِ غَسْلِ
u'غير غَسْلٌ':Added, #4: 4	غَيْرِ غُسْلٍ
u'غَيْرٌ غَسْلٌ':Added, #5: 5	غَيْرِ غَسْلٍ
u'غير غَسِيلٌ':Added, #5: 5	غَيْرِ غَسْلٍ
u'غَيْرٌ غَسِيلٌ':Added, #1: 1	غَيْرِ الْغَسِيلِ
u'غير غِشٌّ':Added, #1: 1	غَيْرِ الْغَسِيلِ
u'غَيْرٌ غِشٌّ':Added, #1: 1	غَيْرِ غِشٍّ
u'غير غَصْبٌ':Added, #1: 1	غَيْرِ غِشٍّ
u'غَيْرٌ غَصْبٌ':Added, #1: 1	غَيْرِ الْغَصْبِ
u'غير غَصْبٌ':Added, #1: 1	غَيْرِ الْغَصْبِ
u'غَيْرٌ غَصْبٌ':Added, #6: 6	غَيْرِ غَصْبٍ
u'غير غضب':Added, #6: 6	غَيْرِ غَصْبٍ
u'غَيْرٌ غضب':Added, #1: 1	غَيْرِ الْغَضَبِ
u'غير غَضَبٌ':Added, #1: 1	غَيْرِ الْغَضَبِ
u'غَيْرٌ غَضَبٌ':Added, #1: 1	غَيْرِ الْغَضَبِ
u'غير غضب':Added, #1: 1	غَيْرِ الْغَضَبِ
u'غَيْرٌ غضب':Added, #1: 1	غَيْرِ غَضَبِهِ
u'غير غَضَبٌ':Added, #1: 1	غَيْرِ غَضَبِهِ
u'غَيْرٌ غَضَبٌ':Added, #1: 1	غَيْرِ غَضَبِهِ
u'غير غَضَبٌ':Added, #1: 1	غَيْرِ غَضَبِهِ
u'غَيْرٌ غَضَبٌ':Added, #3: 3	غَيْرِ غَضَبٍ
u'غير غُفْرَانٌ':Added, #3: 3	غَيْرِ غَضَبٍ
u'غَيْرٌ غُفْرَانٌ':Added, #1: 1	غَيْرِ غُفْرَانٍ
u'غير غفلة':Added, #1: 1	غَيْرِ غُفْرَانٍ
u'غَيْرٌ غفلة':Added, #1: 1	غَيْرِ غَفْلَةٍ
u'غير غَفْلَةٌ':Added, #1: 1	غَيْرِ غَفْلَةٍ
u'غَيْرٌ غَفْلَةٌ':Added, #1: 1	غَيْرِ غَفْلَةٍ
u'غير غُلاَمٌ':Added, #1: 1	غَيْرِ غَفْلَةٍ
u'غَيْرٌ غُلاَمٌ':Added, #1: 1	غَيْرَ غُلَامٍ
u'غير غَلَبَةٌ':Added, #1: 1	غَيْرَ غُلَامٍ
u'غير غَلَبَةٌ':Added, #1: 1	غَيْرِ غَلَبَةٍ
u'غَيْرٌ غَلَبَةٌ':Added, #1: 1	غَيْرِ غَلَبَةِ
u'غَيْرٌ غَلَبَةٌ':Added, #1: 1	غَيْرِ غَلَبَةٍ
u'غير غَلَبَةٌ':Added, #1: 1	غَيْرِ غَلَبَةِ
u'غَيْرٌ غَلَبَةٌ':Added, #4: 4	غَيْرُ غَلَبَةِ
u'غير غَلَّةٌ':Added, #4: 4	غَيْرُ غَلَبَةِ
u'غَيْرٌ غَلَّةٌ':Added, #1: 1	غَيْرَ الْغَلَّةِ
u'غير غَلَّةٌ':Added, #1: 1	غَيْرَ الْغَلَّةِ
u'غير غَلَّةٌ':Added, #1: 1	غَيْرَ غَلَّةٍ
u'غَيْرٌ غَلَّةٌ':Added, #1: 1	غَيْرِ غَلَّةِ
u'غَيْرٌ غَلَّةٌ':Added, #1: 1	غَيْرَ غَلَّةٍ
u'غير غَلَّةٌ':Added, #1: 1	غَيْرِ غَلَّةِ
u'غَيْرٌ غَلَّةٌ':Added, #3: 3	غَيْرِ غَلَّتِهِ
u'غير غَلَطٌ':Added, #3: 3	غَيْرِ غَلَّتِهِ
u'غَيْرٌ غَلَطٌ':Added, #1: 1	غَيْرُ الْغَلَطِ
u'غير غَمْس':Added, #1: 1	غَيْرُ الْغَلَطِ
u'غَيْرٌ غَمْس':Added, #1: 1	غَيْرِ غَمْسٍ
u'غير غناء':Added, #1: 1	غَيْرِ غَمْسٍ
u'غَيْرٌ غناء':Added, #1: 1	غَيْرِ الْغِنَاءِ
u'غير غِنَاءٌ':Added, #1: 1	غَيْرِ الْغِنَاءِ
u'غَيْرٌ غِنَاءٌ':Added, #1: 1	غَيْرِ الْغِنَاءِ
u'غير غِنَاءٌ':Added, #1: 1	غَيْرِ الْغِنَاءِ
u'غَيْرٌ غِنَاءٌ':Added, #2: 2	غَيْرِ غِنَاءٍ
u'غير غَنَمٌ':Added, #2: 2	غَيْرِ غِنَاءٍ
u'غَيْرٌ غَنَمٌ':Added, #2: 2	غَيْرِ الْغَنَمِ
u'غير غَنِيٌّ':Added, #2: 2	غَيْرِ الْغَنَمِ
u'غَيْرٌ غَنِيٌّ':Added, #1: 1	غَيْرَ الْغَنِيِّ
u'غير غَنِيٌّ':Added, #1: 1	غَيْرَ الْغَنِيِّ
u'غَيْرٌ غَنِيٌّ':Added, #1: 1	غَيْرُ غَنِيٍّ
u'غير غَنِيٌّ':Added, #1: 1	غَيْرُ غَنِيٍّ
u'غَيْرٌ غَنِيٌّ':Added, #4: 4	غَيْرِ الْغَنِيِّ
u'غير غَنِيمَةٌ':Added, #4: 4	غَيْرِ الْغَنِيِّ
u'غَيْرٌ غَنِيمَةٌ':Added, #2: 2	غَيْرِ الْغَنِيمَةِ
u'غير غَيْبَةٌ':Added, #2: 2	غَيْرِ الْغَنِيمَةِ
u'غَيْرٌ غَيْبَةٌ':Added, #1: 1	غَيْرِ غَيْبَةٍ
u'غير غير':Added, #1: 1	غَيْرِ غَيْبَةٍ
u'غير غَيْرٌ':Added, #1: 1	غَيْرُ غَيْرِ
u'غَيْرٌ غير':Added, #1: 1	غَيْرُ غَيْرِ
u'غَيْرٌ غَيْرٌ':Added, #1: 1	غَيْرُ غَيْرِ
u'غير غِيلَةٌ':Added, #1: 1	غَيْرُ غَيْرِ
u'غَيْرٌ غِيلَةٌ':Added, #2: 2	غَيْرِ الْغِيلَةِ
u'غير فاء':Added, #2: 2	غَيْرِ الْغِيلَةِ
u'غَيْرٌ فاء':Added, #1: 1	غَيْرِ فَاءٍ
u'غير فَاتِحٌ':Added, #1: 1	غَيْرِ فَاءٍ
u'غَيْرٌ فَاتِحٌ':Added, #1: 1	غَيْرُ الْفَاتِحِ
u'غير فَاتِحٌ':Added, #1: 1	غَيْرُ الْفَاتِحِ
u'غَيْرٌ فَاتِحٌ':Added, #1: 1	غَيْرُ الْفَاتِحَةِ
u'غير فَاتِحٌ':Added, #1: 1	غَيْرُ الْفَاتِحَةِ
u'غَيْرٌ فَاتِحٌ':Added, #7: 7	غَيْرَ الْفَاتِحَةِ
u'غير فَاتِحٌ':Added, #7: 7	غَيْرَ الْفَاتِحَةِ
u'غَيْرٌ فَاتِحٌ':Added, #8: 8	غَيْرِ الْفَاتِحَةِ
u'غير فَاتِحَةٌ':Added, #8: 8	غَيْرِ الْفَاتِحَةِ
u'غَيْرٌ فَاتِحَةٌ':Added, #1: 1	غَيْرُ الْفَاتِحَةِ
u'غير فَاتِحَةٌ':Added, #1: 1	غَيْرُ الْفَاتِحَةِ
u'غَيْرٌ فَاتِحَةٌ':Added, #7: 7	غَيْرَ الْفَاتِحَةِ
u'غير فَاتِحَةٌ':Added, #7: 7	غَيْرَ الْفَاتِحَةِ
u'غَيْرٌ فَاتِحَةٌ':Added, #8: 8	غَيْرِ الْفَاتِحَةِ
u'غير فَاحِشٌ':Added, #8: 8	غَيْرِ الْفَاتِحَةِ
u'غير فَاحِشٌ':Added, #1: 1	غَيْرُ الْفَاحِشَةِ
u'غَيْرٌ فَاحِشٌ':Added, #1: 1	غَيْرِ الْفَاحِشَةِ
u'غَيْرٌ فَاحِشٌ':Added, #1: 1	غَيْرُ الْفَاحِشَةِ
u'غير فَاحِشٌ':Added, #1: 1	غَيْرِ الْفَاحِشَةِ
u'غير فَاحِشٌ':Added, #1: 1	غَيْرَ فَاحِشَةٍ
u'غَيْرٌ فَاحِشٌ':Added, #1: 1	غَيْرِ فَاحِشَةٍ
u'غَيْرٌ فَاحِشٌ':Added, #1: 1	غَيْرَ فَاحِشَةٍ
u'غير فَاحِشٌ':Added, #1: 1	غَيْرِ فَاحِشَةٍ
u'غَيْرٌ فَاحِشٌ':Added, #6: 6	غَيْرَ فَاحِشٍ
u'غير فَادِحٌ':Added, #6: 6	غَيْرَ فَاحِشٍ
u'غَيْرٌ فَادِحٌ':Added, #3: 3	غَيْرَ فَادِحٍ
u'غير فَارٌّ':Added, #3: 3	غَيْرَ فَادِحٍ
u'غير فَارٌّ':Added, #1: 1	غَيْرَ فَارٍّ
u'غَيْرٌ فَارٌّ':Added, #1: 1	غَيْرُ فَارٍّ
u'غَيْرٌ فَارٌّ':Added, #1: 1	غَيْرَ فَارٍّ
u'غير فَاسِدٌ':Added, #1: 1	غَيْرُ فَارٍّ
u'غَيْرٌ فَاسِدٌ':Added, #1: 1	غَيْرُ الْفَاسِدِ
u'غير فَاسِدٌ':Added, #1: 1	غَيْرُ الْفَاسِدِ
u'غَيْرٌ فَاسِدٌ':Added, #1: 1	غَيْرُ فَاسِدِ
u'غير فَاسِدٌ':Added, #1: 1	غَيْرُ فَاسِدِ
u'غَيْرٌ فَاسِدٌ':Added, #3: 3	غَيْرُ فَاسِدٍ
u'غير فَاسِقٌ':Added, #3: 3	غَيْرُ فَاسِدٍ
u'غَيْرٌ فَاسِقٌ':Added, #1: 1	غَيْرُ الْفَاسِقِ
u'غير فَاسِقٌ':Added, #1: 1	غَيْرُ الْفَاسِقِ
u'غَيْرٌ فَاسِقٌ':Added, #2: 2	غَيْرِ الْفَاسِقِ
u'غير فَاسِقٌ':Added, #2: 2	غَيْرِ الْفَاسِقِ
u'غَيْرٌ فَاسِقٌ':Added, #3: 3	غَيْرَ الْفَاسِقِ
u'غير فَاصِلٌ':Added, #3: 3	غَيْرَ الْفَاسِقِ
u'غَيْرٌ فَاصِلٌ':Added, #1: 1	غَيْرُ فَاصِلَةٍ
u'غير فَاصِلٌ':Added, #1: 1	غَيْرُ فَاصِلَةٍ
u'غير فَاصِلٌ':Added, #2: 2	غَيْرَ فَاصِلٍ
u'غَيْرٌ فَاصِلٌ':Added, #2: 2	غَيْرِ فَاصِلٍ
u'غَيْرٌ فَاصِلٌ':Added, #2: 2	غَيْرَ فَاصِلٍ
u'غير فَاصِلٌ':Added, #2: 2	غَيْرِ فَاصِلٍ
u'غَيْرٌ فَاصِلٌ':Added, #2: 2	غَيْرِ فَاصِلَةٍ
u'غير فَاضِلٌ':Added, #2: 2	غَيْرِ فَاصِلَةٍ
u'غَيْرٌ فَاضِلٌ':Added, #1: 1	غَيْرَ فَاضِلَةٍ
u'غير فَاضِلٌ':Added, #1: 1	غَيْرَ فَاضِلَةٍ
u'غَيْرٌ فَاضِلٌ':Added, #3: 3	غَيْرُ فَاضِلٍ
u'غير فَاعِلٌ':Added, #3: 3	غَيْرُ فَاضِلٍ
u'غَيْرٌ فَاعِلٌ':Added, #1: 1	غَيْرُ الْفَاعِلَةِ
u'غير فَاعِلٌ':Added, #1: 1	غَيْرُ الْفَاعِلَةِ
u'غَيْرٌ فَاعِلٌ':Added, #1: 1	غَيْرُ فَاعِلٍ
u'غير فَاعِلٌ':Added, #1: 1	غَيْرُ فَاعِلٍ
u'غير فَاعِلٌ':Added, #2: 2	غَيْرَ الْفَاعِلِ
u'غَيْرٌ فَاعِلٌ':Added, #2: 2	غَيْرُ الْفَاعِلِ
u'غَيْرٌ فَاعِلٌ':Added, #2: 2	غَيْرَ الْفَاعِلِ
u'غير فَاعِلٌ':Added, #2: 2	غَيْرُ الْفَاعِلِ
u'غَيْرٌ فَاعِلٌ':Added, #4: 4	غَيْرِ الْفَاعِلِ
u'غير فَاقَةٌ':Added, #4: 4	غَيْرِ الْفَاعِلِ
u'غَيْرٌ فَاقَةٌ':Added, #1: 1	غَيْرِ فَاقَةٍ
u'غير فَاقِدٌ':Added, #1: 1	غَيْرِ فَاقَةٍ
u'غَيْرٌ فَاقِدٌ':Added, #1: 1	غَيْرِ فَاقِدِ
u'غير فَاكِهٌ':Added, #1: 1	غَيْرِ فَاقِدِ
u'غَيْرٌ فَاكِهٌ':Added, #1: 1	غَيْرُ الْفَاكِهَةِ
u'غير فَاكِهَةٌ':Added, #1: 1	غَيْرُ الْفَاكِهَةِ
u'غَيْرٌ فَاكِهَةٌ':Added, #1: 1	غَيْرُ الْفَاكِهَةِ
u'غير فَائِدَةٌ':Added, #1: 1	غَيْرُ الْفَاكِهَةِ
u'غَيْرٌ فَائِدَةٌ':Added, #17: 17	غَيْرِ فَائِدَةٍ
u'غير فَائِقٌ':Added, #17: 17	غَيْرِ فَائِدَةٍ
u'غَيْرٌ فَائِقٌ':Added, #1: 1	غَيْرِ الْفَائِقِ
u'غير فَتْقٌ':Added, #1: 1	غَيْرِ الْفَائِقِ
u'غَيْرٌ فَتْقٌ':Added, #1: 1	غَيْرِ فَتْقِ
u'غير فتنة':Added, #1: 1	غَيْرِ فَتْقِ
u'غَيْرٌ فتنة':Added, #2: 2	غَيْرِ فِتْنَةٍ
u'غير فِتْنَةٌ':Added, #2: 2	غَيْرِ فِتْنَةٍ
u'غَيْرٌ فِتْنَةٌ':Added, #2: 2	غَيْرِ فِتْنَةٍ
u'غير فُتُورٌ':Added, #2: 2	غَيْرِ فِتْنَةٍ
u'غَيْرٌ فُتُورٌ':Added, #1: 1	غَيْرِ فُتُورٍ
u'غير فَجْأَةٌ':Added, #1: 1	غَيْرِ فُتُورٍ
u'غَيْرٌ فَجْأَةٌ':Added, #4: 4	غَيْرَ فَجْأَةٍ
u'غير فَجْرٌ':Added, #4: 4	غَيْرَ فَجْأَةٍ
u'غَيْرٌ فَجْرٌ':Added, #1: 1	غَيْرَ الْفَجْرِ
u'غير فَجْرٌ':Added, #1: 1	غَيْرَ الْفَجْرِ
u'غَيْرٌ فَجْرٌ':Added, #8: 8	غَيْرِ الْفَجْرِ
u'غير فُحْشٌ':Added, #8: 8	غَيْرِ الْفَجْرِ
u'غَيْرٌ فُحْشٌ':Added, #1: 1	غَيْرِ فُحْشٍ
u'غير فَحْصٌ':Added, #1: 1	غَيْرِ فُحْشٍ
u'غَيْرٌ فَحْصٌ':Added, #2: 2	غَيْرِ فَحْصٍ
u'غير فَحْلٌ':Added, #2: 2	غَيْرِ فَحْصٍ
u'غَيْرٌ فَحْلٌ':Added, #1: 1	غَيْرَ فَحْلِ
u'غير فخر':Added, #1: 1	غَيْرَ فَحْلِ
u'غَيْرٌ فخر':Added, #1: 1	غَيْرِ فَخْرِ
u'غير فَخْرٌ':Added, #1: 1	غَيْرِ فَخْرِ
u'غَيْرٌ فَخْرٌ':Added, #1: 1	غَيْرِ فَخْرِ
u'غير فخر':Added, #1: 1	غَيْرِ فَخْرِ
u'غَيْرٌ فخر':Added, #2: 2	غَيْرُ فَخْرِ
u'غير فَخْرٌ':Added, #2: 2	غَيْرُ فَخْرِ
u'غير فَخْرٌ':Added, #2: 2	غَيْرَ فَخْرٍ
u'غَيْرٌ فَخْرٌ':Added, #2: 2	غَيْرُ فَخْرِ
u'غَيْرٌ فَخْرٌ':Added, #2: 2	غَيْرَ فَخْرٍ
u'غير فِدَاءٌ':Added, #2: 2	غَيْرُ فَخْرِ
u'غَيْرٌ فِدَاءٌ':Added, #1: 1	غَيْرِ فِدَاءٍ
u'غير فِدْيَةٌ':Added, #1: 1	غَيْرِ فِدَاءٍ
u'غَيْرٌ فِدْيَةٌ':Added, #1: 1	غَيْرُ الْفِدْيَةِ
u'غير فِدْيَةٌ':Added, #1: 1	غَيْرُ الْفِدْيَةِ
u'غَيْرٌ فِدْيَةٌ':Added, #1: 1	غَيْرِ فِدْيَةٍ
u'غير فرار':Added, #1: 1	غَيْرِ فِدْيَةٍ
u'غَيْرٌ فرار':Added, #1: 1	غَيْرِ الْفِرَارِ
u'غير فِرَارٌ':Added, #1: 1	غَيْرِ الْفِرَارِ
u'غَيْرٌ فِرَارٌ':Added, #1: 1	غَيْرِ الْفِرَارِ
u'غير فِرَاقٌ':Added, #1: 1	غَيْرِ الْفِرَارِ
u'غَيْرٌ فِرَاقٌ':Added, #1: 1	غَيْرَ الْفِرَاقِ
u'غير فَرَائِضُ':Added, #1: 1	غَيْرَ الْفِرَاقِ
u'غَيْرٌ فَرَائِضُ':Added, #2: 2	غَيْرَ الْفَرَائِضِ
u'غير فَرَائِضُ':Added, #2: 2	غَيْرَ الْفَرَائِضِ
u'غَيْرٌ فَرَائِضُ':Added, #4: 4	غَيْرِ الْفَرَائِضِ
u'غير فَرْجٌ':Added, #4: 4	غَيْرِ الْفَرَائِضِ
u'غَيْرٌ فَرْجٌ':Added, #15: 15	غَيْرِ الْفَرْجِ
u'غير فَرْجٌ':Added, #15: 15	غَيْرِ الْفَرْجِ
u'غَيْرٌ فَرْجٌ':Added, #1: 1	غَيْرَ الْفَرْجِ
u'غير فَرَجٌ':Added, #1: 1	غَيْرَ الْفَرْجِ
u'غير فَرْجٌ':Added, #2: 2	غَيْرِ فَرَجٍ
u'غَيْرٌ فَرَجٌ':Added, #2: 2	غَيْرِ فَرْجٍ
u'غَيْرٌ فَرْجٌ':Added, #2: 2	غَيْرِ فَرَجٍ
u'غير فُرْجَةٌ':Added, #2: 2	غَيْرِ فَرْجٍ
u'غَيْرٌ فُرْجَةٌ':Added, #2: 2	غَيْرِ فُرْجَةٍ
u'غير فَرْدٌ':Added, #2: 2	غَيْرِ فُرْجَةٍ
u'غَيْرٌ فَرْدٌ':Added, #1: 1	غَيْرِ فَرْدٍ
u'غير فَرَسٌ':Added, #1: 1	غَيْرِ فَرْدٍ
u'غَيْرٌ فَرَسٌ':Added, #1: 1	غَيْرُ الْفَرَسِ
u'غير فَرَسٌ':Added, #1: 1	غَيْرُ الْفَرَسِ
u'غَيْرٌ فَرَسٌ':Added, #1: 1	غَيْرُ فَرَسِ
u'غير فَرَسٌ':Added, #1: 1	غَيْرُ فَرَسِ
u'غَيْرٌ فَرَسٌ':Added, #1: 1	غَيْرَ فَرَسِهِ
u'غَيَّرَ فَرْضٌ':Predicate, #1: 1	غَيْرَ فَرَسِهِ
u'غير فَرْضٌ':Added, #2: 2	غَيَّرَ الْفَرْضَ
u'غَيْرٌ فَرْضٌ':Added, #12: 12	غَيْرُ فَرْضٍ
u'غير فَرْضٌ':Added, #12: 12	غَيْرُ فَرْضٍ
u'غَيْرٌ فَرْضٌ':Added, #1: 1	غَيْرُ فَرْضِ
u'غير فَرْضٌ':Added, #1: 1	غَيْرُ فَرْضِ
u'غَيْرٌ فَرْضٌ':Added, #3: 3	غَيْرُ الْفَرْضِ
u'غير فَرْضٌ':Added, #3: 3	غَيْرُ الْفَرْضِ
u'غير فَرْضٌ':Added, #3: 3	غَيْرَ فَرْضٍ
u'غير فَرْضٌ':Added, #3: 3	غَيْرَ فَرْضِ
u'غَيْرٌ فَرْضٌ':Added, #3: 3	غَيْرِ فَرْضٍ
u'غَيْرٌ فَرْضٌ':Added, #3: 3	غَيْرَ فَرْضٍ
u'غَيْرٌ فَرْضٌ':Added, #3: 3	غَيْرَ فَرْضِ
u'غير فَرْضٌ':Added, #3: 3	غَيْرِ فَرْضٍ
u'غَيْرٌ فَرْضٌ':Added, #6: 6	غَيْرَ الْفَرْضِ
u'غير فَرْضٌ':Added, #6: 6	غَيْرَ الْفَرْضِ
u'غَيْرٌ فَرْضٌ':Added, #7: 7	غَيْرِ الْفَرْضِ
u'غير فَرْضٌ':Added, #7: 7	غَيْرِ الْفَرْضِ
u'غَيْرٌ فَرْضٌ':Added, #7: 7	غَيْرِ فَرْضِ
u'غير فَرْطٌ':Added, #7: 7	غَيْرِ فَرْضِ
u'غَيْرٌ فَرْطٌ':Added, #1: 1	غَيْرُ فَرْطِ
u'غير فَرْعٌ':Added, #1: 1	غَيْرُ فَرْطِ
u'غَيْرٌ فَرْعٌ':Added, #1: 1	غَيْرُ الْفَرْعِ
u'غير فَرْعٌ':Added, #1: 1	غَيْرُ الْفَرْعِ
u'غَيْرٌ فَرْعٌ':Added, #1: 1	غَيْرَ فَرْعٍ
u'غير فَرْقٌ':Added, #1: 1	غَيْرَ فَرْعٍ
u'غَيْرٌ فَرْقٌ':Added, #24: 24	غَيْرِ فَرْقٍ
u'غير فُرْقَةٌ':Added, #24: 24	غَيْرِ فَرْقٍ
u'غَيْرٌ فُرْقَةٌ':Added, #1: 1	غَيْرُ فُرْقَةِ
u'غير فُرْقَةٌ':Added, #1: 1	غَيْرُ فُرْقَةِ
u'غَيْرٌ فُرْقَةٌ':Added, #2: 2	غَيْرِ الْفُرْقَةِ
u'غير فَرْقَدٌ':Added, #2: 2	غَيْرِ الْفُرْقَةِ
u'غَيْرٌ فَرْقَدٌ':Added, #1: 1	غَيْرُ الْفَرْقَدَيْنِ
u'غير فَرْوٌ':Added, #1: 1	غَيْرُ الْفَرْقَدَيْنِ
u'غَيْرٌ فَرْوٌ':Added, #2: 2	غَيْرُ الْفَرْوِ
u'غير فُرُوعٌ':Added, #2: 2	غَيْرُ الْفَرْوِ
u'غَيْرٌ فُرُوعٌ':Added, #1: 1	غَيْرِ الْفُرُوعِ
u'غير فِرْيَةٌ':Added, #1: 1	غَيْرِ الْفُرُوعِ
u'غَيْرٌ فِرْيَةٌ':Added, #1: 1	غَيْرُ الْفِرْيَةِ
u'غير فَرِيضَةٌ':Added, #1: 1	غَيْرُ الْفِرْيَةِ
u'غَيْرٌ فَرِيضَةٌ':Added, #1: 1	غَيْرِ فَرِيضَةٍ
u'غير فَرِيضَةٌ':Added, #1: 1	غَيْرِ فَرِيضَةٍ
u'غَيْرٌ فَرِيضَةٌ':Added, #2: 2	غَيْرَ فَرِيضَةٍ
u'غير فَرِيضَةٌ':Added, #2: 2	غَيْرَ فَرِيضَةٍ
u'غَيْرٌ فَرِيضَةٌ':Added, #7: 7	غَيْرِ الْفَرِيضَةِ
u'غير فَرِيقٌ':Added, #7: 7	غَيْرِ الْفَرِيضَةِ
u'غَيْرٌ فَرِيقٌ':Added, #1: 1	غَيْرِ الْفَرِيقَيْنِ
u'غير فساد':Added, #1: 1	غَيْرِ الْفَرِيقَيْنِ
u'غَيْرٌ فساد':Added, #1: 1	غَيْرُ الْفَسَادِ
u'غير فَسَادٌ':Added, #1: 1	غَيْرُ الْفَسَادِ
u'غَيْرٌ فَسَادٌ':Added, #1: 1	غَيْرُ الْفَسَادِ
u'غير فساد':Added, #1: 1	غَيْرُ الْفَسَادِ
u'غَيْرٌ فساد':Added, #4: 4	غَيْرِ فَسَادٍ
u'غير فَسَادٌ':Added, #4: 4	غَيْرِ فَسَادٍ
u'غَيْرٌ فَسَادٌ':Added, #4: 4	غَيْرِ فَسَادٍ
u'غير فساد':Added, #4: 4	غَيْرِ فَسَادٍ
u'غَيْرٌ فساد':Added, #5: 5	غَيْرِ الْفَسَادِ
u'غير فَسَادٌ':Added, #5: 5	غَيْرِ الْفَسَادِ
u'غَيْرٌ فَسَادٌ':Added, #5: 5	غَيْرِ الْفَسَادِ
u'غير فَسْخٌ':Added, #5: 5	غَيْرِ الْفَسَادِ
u'غَيْرٌ فَسْخٌ':Added, #16: 16	غَيْرِ فَسْخٍ
u'غير فَسْخٌ':Added, #16: 16	غَيْرِ فَسْخٍ
u'غَيْرٌ فَسْخٌ':Added, #1: 1	غَيْرِ الْفَسْخِ
u'غير فَسْخٌ':Added, #1: 1	غَيْرِ الْفَسْخِ
u'غَيْرٌ فَسْخٌ':Added, #2: 2	غَيْرُ فَسْخٍ
u'غير فِسْقٌ':Added, #2: 2	غَيْرُ فَسْخٍ
u'غَيْرٌ فِسْقٌ':Added, #1: 1	غَيْرِ الْفِسْقِ
u'غير فِسْقٌ':Added, #1: 1	غَيْرِ الْفِسْقِ
u'غَيْرٌ فِسْقٌ':Added, #3: 3	غَيْرِ فِسْقٍ
u'غير فَصْلٌ':Added, #3: 3	غَيْرِ فِسْقٍ
u'غَيْرٌ فَصْلٌ':Added, #113: 113	غَيْرِ فَصْلٍ
u'غير فُصُولٌ':Added, #113: 113	غَيْرِ فَصْلٍ
u'غَيْرٌ فُصُولٌ':Added, #2: 2	غَيْرِ الْفُصُولِ
u'غير فِضَّةٌ':Added, #2: 2	غَيْرِ الْفُصُولِ
u'غَيْرٌ فِضَّةٌ':Added, #1: 1	غَيْرِ الْفِضَّةِ
u'غير فِضَّةٌ':Added, #1: 1	غَيْرِ الْفِضَّةِ
u'غير فِضَّةٌ':Added, #1: 1	غَيْرُ فِضَّةٍ
u'غَيْرٌ فِضَّةٌ':Added, #1: 1	غَيْرِ فِضَّةٍ
u'غَيْرٌ فِضَّةٌ':Added, #1: 1	غَيْرُ فِضَّةٍ
u'غير فَضْلٌ':Added, #1: 1	غَيْرِ فِضَّةٍ
u'غَيْرٌ فَضْلٌ':Added, #1: 1	غَيْرِ فَضْلٍ
u'غير فَضْلٌ':Added, #1: 1	غَيْرِ فَضْلٍ
u'غَيْرٌ فَضْلٌ':Added, #7: 7	غَيْرِ فَضْلِ
u'غير فضلة':Added, #7: 7	غَيْرِ فَضْلِ
u'غَيْرٌ فضلة':Added, #1: 1	غَيْرَ فَضْلَةٍ
u'غير فَضْلَةٌ':Added, #1: 1	غَيْرَ فَضْلَةٍ
u'غَيْرٌ فَضْلَةٌ':Added, #1: 1	غَيْرَ فَضْلَةٍ
u'غير فُضُولِيٌّ':Added, #1: 1	غَيْرَ فَضْلَةٍ
u'غَيْرٌ فُضُولِيٌّ':Added, #1: 1	غَيْرِ الْفُضُولِيِّ
u'غير فَضِيلَةٌ':Added, #1: 1	غَيْرِ الْفُضُولِيِّ
u'غَيْرٌ فَضِيلَةٌ':Added, #2: 2	غَيْرِ فَضِيلَةٍ
u'غير فطرة':Added, #2: 2	غَيْرِ فَضِيلَةٍ
u'غَيْرٌ فطرة':Added, #2: 2	غَيْرِ فِطْرَةِ
u'غير فِطْرَةٌ':Added, #2: 2	غَيْرِ فِطْرَةِ
u'غَيْرٌ فِطْرَةٌ':Added, #2: 2	غَيْرِ فِطْرَةِ
u'غير فطرة':Added, #2: 2	غَيْرِ فِطْرَةِ
u'غَيْرٌ فطرة':Added, #3: 3	غَيْرِ الْفِطْرَةِ
u'غير فِطْرَةٌ':Added, #3: 3	غَيْرِ الْفِطْرَةِ
u'غَيْرٌ فِطْرَةٌ':Added, #3: 3	غَيْرِ الْفِطْرَةِ
u'غير فُطُورٌ':Added, #3: 3	غَيْرِ الْفِطْرَةِ
u'غَيْرٌ فُطُورٌ':Added, #1: 1	غَيْرِ فُطُورٍ
u'غير فَظٌّ':Added, #1: 1	غَيْرِ فُطُورٍ
u'غير فَظٌّ':Added, #1: 1	غَيْرَ فَظٍّ
u'غَيْرٌ فَظٌّ':Added, #1: 1	غَيْرُ فَظٍّ
u'غَيْرٌ فَظٌّ':Added, #1: 1	غَيْرَ فَظٍّ
u'غير فِعْلٌ':Added, #1: 1	غَيْرُ فَظٍّ
u'غَيْرٌ فِعْلٌ':Added, #13: 13	غَيْرِ فِعْلِ
u'غير فِعْلٌ':Added, #13: 13	غَيْرِ فِعْلِ
u'غَيْرٌ فِعْلٌ':Added, #16: 16	غَيْرِ فِعْلِهِ
u'غير فِعْلٌ':Added, #16: 16	غَيْرِ فِعْلِهِ
u'غَيْرٌ فِعْلٌ':Added, #1: 1	غَيْرِ الْفِعْلِ
u'غير فِعْلٌ':Added, #1: 1	غَيْرِ الْفِعْلِ
u'غَيْرٌ فِعْلٌ':Added, #2: 2	غَيْرَ الْفِعْلِ
u'غير فِعْلٌ':Added, #2: 2	غَيْرَ الْفِعْلِ
u'غَيْرٌ فِعْلٌ':Added, #2: 2	غَيْرُ فِعْلِهِ
u'غير فِعْلٌ':Added, #2: 2	غَيْرُ فِعْلِهِ
u'غَيْرٌ فِعْلٌ':Added, #5: 5	غَيْرُ الْفِعْلِ
u'غير فِعْلٌ':Added, #5: 5	غَيْرُ الْفِعْلِ
u'غَيْرٌ فِعْلٌ':Added, #7: 7	غَيْرِ فِعْلٍ
u'غير فَقْء':Added, #7: 7	غَيْرِ فِعْلٍ
u'غَيْرٌ فَقْء':Added, #2: 2	غَيْرِ الْفَقْءِ
u'غير فَقْء':Added, #2: 2	غَيْرِ الْفَقْءِ
u'غَيْرٌ فَقْء':Added, #2: 2	غَيْرِ فَقْءِ
u'غير فقر':Added, #2: 2	غَيْرِ فَقْءِ
u'غَيْرٌ فقر':Added, #1: 1	غَيْرِ الْفَقْرِ
u'غير فَقْرٌ':Added, #1: 1	غَيْرِ الْفَقْرِ
u'غَيْرٌ فَقْرٌ':Added, #1: 1	غَيْرِ الْفَقْرِ
u'غير فَقْرٌ':Added, #1: 1	غَيْرِ الْفَقْرِ
u'غَيْرٌ فَقْرٌ':Added, #3: 3	غَيْرِ فَقْرٍ
u'غير فقراء':Added, #3: 3	غَيْرِ فَقْرٍ
u'غَيْرٌ فقراء':Added, #1: 1	غَيْرِ فُقَرَاءِ
u'غير فِقْهٌ':Added, #1: 1	غَيْرِ فُقَرَاءِ
u'غَيْرٌ فِقْهٌ':Added, #1: 1	غَيْرُ الْفِقْهِ
u'غير فِقْهٌ':Added, #1: 1	غَيْرُ الْفِقْهِ
u'غَيْرٌ فِقْهٌ':Added, #2: 2	غَيْرِ الْفِقْهِ
u'غير فقهاء':Added, #2: 2	غَيْرِ الْفِقْهِ
u'غَيْرٌ فقهاء':Added, #1: 1	غَيْرُ الْفُقَهَاءِ
u'غير فَقِيرٌ':Added, #1: 1	غَيْرُ الْفُقَهَاءِ
u'غَيْرٌ فَقِيرٌ':Added, #4: 4	غَيْرِ الْفَقِيرِ
u'غير فَقِيهٌ':Added, #4: 4	غَيْرِ الْفَقِيرِ
u'غير فَقِيهٌ':Added, #4: 4	غَيْرُ الْفَقِيهِ
u'غَيْرٌ فَقِيهٌ':Added, #4: 4	غَيْرِ الْفَقِيهِ
u'غَيْرٌ فَقِيهٌ':Added, #4: 4	غَيْرُ الْفَقِيهِ
u'غير فِكْرٌ':Added, #4: 4	غَيْرِ الْفَقِيهِ
u'غَيْرٌ فِكْرٌ':Added, #1: 1	غَيْرُ الْفِكْرِ
u'غير فِكْرٌ':Added, #1: 1	غَيْرُ الْفِكْرِ
u'غَيْرٌ فِكْرٌ':Added, #2: 2	غَيْرِ فِكْرٍ
u'غير فِكْرَةٌ':Added, #2: 2	غَيْرِ فِكْرٍ
u'غَيْرٌ فِكْرَةٌ':Added, #1: 1	غَيْرِ فِكْرَةٍ
u'غير فلان':Added, #1: 1	غَيْرِ فِكْرَةٍ
u'غير فلان':Added, #1: 1	غَيْرَ التِّرْمِذِيِّ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرُ التِّرْمِذِيِّ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرَ التِّرْمِذِيِّ
u'غير فلان':Added, #1: 1	غَيْرُ التِّرْمِذِيِّ
u'غير فلان':Added, #1: 1	غَيْرَ الرَّاتِبَةِ
u'غير فلان':Added, #1: 1	غَيْرُ الرَّاتِبَةِ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرِ الرَّاتِبَةِ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرَ الرَّاتِبَةِ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرُ الرَّاتِبَةِ
u'غير فلان':Added, #1: 1	غَيْرِ الرَّاتِبَةِ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرِ الشَّافِعِيَّةِ
u'غير فلان':Added, #1: 1	غَيْرِ الشَّافِعِيَّةِ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرُ الْقُدْسِيَّةِ
u'غير فلان':Added, #1: 1	غَيْرُ الْقُدْسِيَّةِ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرَ الْمُزْدَلِفَةِ
u'غير فلان':Added, #1: 1	غَيْرَ الْمُزْدَلِفَةِ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرَ الْمِقْدَادِ
u'غير فلان':Added, #1: 1	غَيْرَ الْمِقْدَادِ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرَ الْمَكِّيِّ
u'غير فلان':Added, #1: 1	غَيْرَ الْمَكِّيِّ
u'غير فلان':Added, #1: 1	غَيْرَ بِلَالٍ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرَ بِلاَلٍ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرَ بِلَالٍ
u'غير فلان':Added, #1: 1	غَيْرَ بِلاَلٍ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرُ تَمِيمٍ
u'غير فلان':Added, #1: 1	غَيْرُ تَمِيمٍ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرِ جُبَيْرِ
u'غير فلان':Added, #1: 1	غَيْرِ جُبَيْرِ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرُ جَعْفَرِ
u'غير فلان':Added, #1: 1	غَيْرُ جَعْفَرِ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرِ حَامِدٍ
u'غير فلان':Added, #1: 1	غَيْرِ حَامِدٍ
u'غير فلان':Added, #1: 1	غَيْرَ رَاتِبَةٍ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرُ رَاتِبَةٍ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرَ رَاتِبَةٍ
u'غير فلان':Added, #1: 1	غَيْرُ رَاتِبَةٍ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرُ زُهَيْرٍ
u'غير فلان':Added, #1: 1	غَيْرُ زُهَيْرٍ
u'غير فلان':Added, #1: 1	غَيْرُ زِيَادٍ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرُ زِيَادِ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرُ زِيَادٍ
u'غير فلان':Added, #1: 1	غَيْرُ زِيَادِ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرِ غَانِمٍ
u'غير فلان':Added, #1: 1	غَيْرِ غَانِمٍ
u'غير فلان':Added, #1: 1	غَيْرَ مَكِّيٍّ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرُ مَكِّيٍّ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرَ مَكِّيٍّ
u'غير فلان':Added, #1: 1	غَيْرُ مَكِّيٍّ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرَ وَاصِفٍ
u'غير فلان':Added, #1: 1	غَيْرَ وَاصِفٍ
u'غَيْرٌ فلان':Added, #1: 1	غَيْرَ وَاصِفَةٍ
u'غير فلان':Added, #1: 1	غَيْرَ وَاصِفَةٍ
u'غَيْرٌ فلان':Added, #2: 2	غَيْرِ التَّمِيمِيِّ
u'غير فلان':Added, #2: 2	غَيْرِ التَّمِيمِيِّ
u'غير فلان':Added, #2: 2	غَيْرُ الشَّافِعِيِّ
u'غَيْرٌ فلان':Added, #2: 2	غَيْرِ الشَّافِعِيِّ
u'غَيْرٌ فلان':Added, #2: 2	غَيْرُ الشَّافِعِيِّ
u'غير فلان':Added, #2: 2	غَيْرِ الشَّافِعِيِّ
u'غَيْرٌ فلان':Added, #2: 2	غَيْرِ الْمَرْوِيِّ
u'غير فلان':Added, #2: 2	غَيْرِ الْمَرْوِيِّ
u'غَيْرٌ فلان':Added, #2: 2	غَيْرُ دَانِقٍ
u'غير فلان':Added, #2: 2	غَيْرُ دَانِقٍ
u'غَيْرٌ فلان':Added, #2: 2	غَيْرِ مَكِّيٍّ
u'غير فلان':Added, #2: 2	غَيْرِ مَكِّيٍّ
u'غَيْرٌ فلان':Added, #3: 3	غَيْرِ الصَّلَاتِيَّةِ
u'غير فلان':Added, #3: 3	غَيْرِ الصَّلَاتِيَّةِ
u'غَيْرٌ فلان':Added, #3: 3	غَيْرِ الْمَكِّيِّ
u'غير فُلاَنٌ':Added, #3: 3	غَيْرِ الْمَكِّيِّ
u'غَيْرٌ فُلاَنٌ':Added, #3: 3	غَيْرِ فُلَانٍ
u'غير فُلاَنٌ':Added, #3: 3	غَيْرِ فُلَانٍ
u'غَيْرٌ فُلاَنٌ':Added, #5: 5	غَيْرَ فُلَانٍ
u'غير فَمٌ':Added, #5: 5	غَيْرَ فُلَانٍ
u'غَيْرٌ فَمٌ':Added, #8: 8	غَيْرِ الْفَمِ
u'غير فَنَاءٌ':Added, #8: 8	غَيْرِ الْفَمِ
u'غَيْرٌ فَنَاءٌ':Added, #2: 2	غَيْرِ فَنَاءِ
u'غير فَهْمٌ':Added, #2: 2	غَيْرِ فَنَاءِ
u'غَيْرٌ فَهْمٌ':Added, #1: 1	غَيْرَ فَهْمِ
u'غير فُؤَادٌ':Added, #1: 1	غَيْرَ فَهْمِ
u'غَيْرٌ فُؤَادٌ':Added, #1: 1	غَيْرُ الْفُؤَادِ
u'غير فَيْءٌ':Added, #1: 1	غَيْرُ الْفُؤَادِ
u'غَيْرٌ فَيْءٌ':Added, #1: 1	غَيْرُ فَيْءِ
u'غير فَيْءٌ':Added, #1: 1	غَيْرُ فَيْءِ
u'غَيْرٌ فَيْءٌ':Added, #2: 2	غَيْرِ فَيْءٍ
u'غير فِيلٌ':Added, #2: 2	غَيْرِ فَيْءٍ
u'غَيْرٌ فِيلٌ':Added, #1: 1	غَيْرُ فِيلِ
u'غير قَابِضٌ':Added, #1: 1	غَيْرُ فِيلِ
u'غَيْرٌ قَابِضٌ':Added, #2: 2	غَيْرَ قَابِضٍ
u'غير قَابِضٌ':Added, #2: 2	غَيْرَ قَابِضٍ
u'غَيْرٌ قَابِضٌ':Added, #3: 3	غَيْرِ الْقَابِضِ
u'غير قَابِلٌ':Added, #3: 3	غَيْرِ الْقَابِضِ
u'غَيْرٌ قَابِلٌ':Added, #11: 11	غَيْرَ قَابِلٍ
u'غير قَابِلٌ':Added, #11: 11	غَيْرَ قَابِلٍ
u'غَيْرٌ قَابِلٌ':Added, #1: 1	غَيْرُ الْقَابِلَةِ
u'غير قَابِلٌ':Added, #1: 1	غَيْرُ الْقَابِلَةِ
u'غَيْرٌ قَابِلٌ':Added, #1: 1	غَيْرَ قَابِلَةٍ
u'غير قَابِلٌ':Added, #1: 1	غَيْرَ قَابِلَةٍ
u'غَيْرٌ قَابِلٌ':Added, #22: 22	غَيْرُ قَابِلٍ
u'غير قَابِلٌ':Added, #22: 22	غَيْرُ قَابِلٍ
u'غير قَابِلٌ':Added, #2: 2	غَيْرُ الْقَابِلِ
u'غَيْرٌ قَابِلٌ':Added, #2: 2	غَيْرِ الْقَابِلِ
u'غَيْرٌ قَابِلٌ':Added, #2: 2	غَيْرُ الْقَابِلِ
u'غير قَابِلٌ':Added, #2: 2	غَيْرِ الْقَابِلِ
u'غَيْرٌ قَابِلٌ':Added, #2: 2	غَيْرِ قَابِلٍ
u'غير قَابِلٌ':Added, #2: 2	غَيْرِ قَابِلٍ
u'غَيْرٌ قَابِلٌ':Added, #9: 9	غَيْرُ قَابِلَةٍ
u'غير قَاتِلٌ':Added, #9: 9	غَيْرُ قَابِلَةٍ
u'غَيْرٌ قَاتِلٌ':Added, #14: 14	غَيْرَ قَاتِلِهِ
u'غير قَاتِلٌ':Added, #14: 14	غَيْرَ قَاتِلِهِ
u'غير قَاتِلٌ':Added, #1: 1	غَيْرَ الْقَاتِلِ
u'غَيْرٌ قَاتِلٌ':Added, #1: 1	غَيْرُ الْقَاتِلِ
u'غَيْرٌ قَاتِلٌ':Added, #1: 1	غَيْرَ الْقَاتِلِ
u'غير قَاتِلٌ':Added, #1: 1	غَيْرُ الْقَاتِلِ
u'غَيْرٌ قَاتِلٌ':Added, #1: 1	غَيْرَ الْقَاتِلَيْنِ
u'غير قَاتِلٌ':Added, #1: 1	غَيْرَ الْقَاتِلَيْنِ
u'غير قَاتِلٌ':Added, #1: 1	غَيْرَ قَاتِلٍ
u'غَيْرٌ قَاتِلٌ':Added, #1: 1	غَيْرَ قَاتِلِ
u'غَيْرٌ قَاتِلٌ':Added, #1: 1	غَيْرَ قَاتِلٍ
u'غير قَاتِلٌ':Added, #1: 1	غَيْرَ قَاتِلِ
u'غَيْرٌ قَاتِلٌ':Added, #1: 1	غَيْرُ قَاتِلِهِ
u'غير قَاتِلٌ':Added, #1: 1	غَيْرُ قَاتِلِهِ
u'غَيْرٌ قَاتِلٌ':Added, #2: 2	غَيْرُ قَاتِلٍ
u'غير قَاتِلٌ':Added, #2: 2	غَيْرُ قَاتِلٍ
u'غَيْرٌ قَاتِلٌ':Added, #4: 4	غَيْرِ الْقَاتِلِ
u'غير قادِح':Added, #4: 4	غَيْرِ الْقَاتِلِ
u'غَيْرٌ قادِح':Added, #1: 1	غَيْرِ قَادِحٍ
u'غير قادِح':Added, #1: 1	غَيْرِ قَادِحٍ
u'غَيْرٌ قادِح':Added, #1: 1	غَيْرَ قَادِحَةٍ
u'غير قادِح':Added, #1: 1	غَيْرَ قَادِحَةٍ
u'غَيْرٌ قادِح':Added, #24: 24	غَيْرُ قَادِحٍ
u'غير قادِح':Added, #24: 24	غَيْرُ قَادِحٍ
u'غَيْرٌ قادِح':Added, #2: 2	غَيْرَ قَادِحٍ
u'غير قادِح':Added, #2: 2	غَيْرَ قَادِحٍ
u'غَيْرٌ قادِح':Added, #2: 2	غَيْرُ قَادِحَةٍ
u'غير قَادِرٌ':Added, #2: 2	غَيْرُ قَادِحَةٍ
u'غَيْرٌ قَادِرٌ':Added, #1: 1	غَيْرُ قَادِرَةٍ
u'غير قَادِرٌ':Added, #1: 1	غَيْرُ قَادِرَةٍ
u'غَيْرٌ قَادِرٌ':Added, #26: 26	غَيْرُ قَادِرٍ
u'غير قَادِرٌ':Added, #26: 26	غَيْرُ قَادِرٍ
u'غَيْرٌ قَادِرٌ':Added, #3: 3	غَيْرِ الْقَادِرِ
u'غير قَادِرٌ':Added, #3: 3	غَيْرِ الْقَادِرِ
u'غَيْرٌ قَادِرٌ':Added, #6: 6	غَيْرَ قَادِرٍ
u'غير قَادِمٌ':Added, #6: 6	غَيْرَ قَادِرٍ
u'غَيْرٌ قَادِمٌ':Added, #1: 1	غَيْرَ قَادِمٍ
u'غير قَاذِفٌ':Added, #1: 1	غَيْرَ قَادِمٍ
u'غَيْرٌ قَاذِفٌ':Added, #1: 1	غَيْرُ الْقَاذِفَةِ
u'غير قَاذِفٌ':Added, #1: 1	غَيْرُ الْقَاذِفَةِ
u'غَيْرٌ قَاذِفٌ':Added, #2: 2	غَيْرِ الْقَاذِفِ
u'غير قَارٌّ':Added, #2: 2	غَيْرِ الْقَاذِفِ
u'غَيْرٌ قَارٌّ':Added, #1: 1	غَيْرَ قَارٍّ
u'غير قَارٌّ':Added, #1: 1	غَيْرَ قَارٍّ
u'غَيْرٌ قَارٌّ':Added, #4: 4	غَيْرُ قَارٍّ
u'غير قارِع':Added, #4: 4	غَيْرُ قَارٍّ
u'غَيْرٌ قارِع':Added, #1: 1	غَيْرُ الْقَارِعِ
u'غير قَارِئٌ':Added, #1: 1	غَيْرُ الْقَارِعِ
u'غَيْرٌ قَارِئٌ':Added, #1: 1	غَيْرِ الْقَارِئِ
u'غير قَارِئٌ':Added, #1: 1	غَيْرِ الْقَارِئِ
u'غير قَارِئٌ':Added, #1: 1	غَيْرَ قَارِئٍ
u'غير قَارِئٌ':Added, #1: 1	غَيْرُ قَارِئٍ
u'غَيْرٌ قَارِئٌ':Added, #1: 1	غَيْرِ قَارِئٍ
u'غَيْرٌ قَارِئٌ':Added, #1: 1	غَيْرَ قَارِئٍ
u'غَيْرٌ قَارِئٌ':Added, #1: 1	غَيْرُ قَارِئٍ
u'غير قَارِئٌ':Added, #1: 1	غَيْرِ قَارِئٍ
u'غَيْرٌ قَارِئٌ':Added, #1: 1	غَيْرُ قَارِئَةٍ
u'غير قَاصِدٌ':Added, #1: 1	غَيْرُ قَارِئَةٍ
u'غير قَاصِدٌ':Added, #10: 10	غَيْرَ قَاصِدٍ
u'غَيْرٌ قَاصِدٌ':Added, #10: 10	غَيْرُ قَاصِدٍ
u'غَيْرٌ قَاصِدٌ':Added, #10: 10	غَيْرَ قَاصِدٍ
u'غير قَاصِدٌ':Added, #10: 10	غَيْرُ قَاصِدٍ
u'غير قَاصِدٌ':Added, #1: 1	غَيْرُ الْقَاصِدِ
u'غَيْرٌ قَاصِدٌ':Added, #1: 1	غَيْرِ الْقَاصِدِ
u'غَيْرٌ قَاصِدٌ':Added, #1: 1	غَيْرُ الْقَاصِدِ
u'غير قَاصِدٌ':Added, #1: 1	غَيْرِ الْقَاصِدِ
u'غَيْرٌ قَاصِدٌ':Added, #1: 1	غَيْرِ قَاصِدٍ
u'غير قَاصِدٌ':Added, #1: 1	غَيْرِ قَاصِدٍ
u'غَيْرٌ قَاصِدٌ':Added, #1: 1	غَيْرِ قَاصِدِهِ
u'غير قَاصِرٌ':Added, #1: 1	غَيْرِ قَاصِدِهِ
u'غير قَاصِرٌ':Added, #1: 1	غَيْرَ قَاصِرٍ
u'غَيْرٌ قَاصِرٌ':Added, #1: 1	غَيْرُ قَاصِرٍ
u'غَيْرٌ قَاصِرٌ':Added, #1: 1	غَيْرَ قَاصِرٍ
u'غير قَاطِرٌ':Added, #1: 1	غَيْرُ قَاصِرٍ
u'غَيْرٌ قَاطِرٌ':Added, #1: 1	غَيْرِ قَاطِرٍ
u'غير قَاطِعٌ':Added, #1: 1	غَيْرِ قَاطِرٍ
u'غَيْرٌ قَاطِعٌ':Added, #1: 1	غَيْرُ قَاطِعِ
u'غير قَاطِعٌ':Added, #1: 1	غَيْرُ قَاطِعِ
u'غَيْرٌ قَاطِعٌ':Added, #2: 2	غَيْرِ الْقَاطِعِ
u'غير قَاطِعٌ':Added, #2: 2	غَيْرِ الْقَاطِعِ
u'غَيْرٌ قَاطِعٌ':Added, #2: 2	غَيْرُ قَاطِعِهِ
u'غير قَاطِعٌ':Added, #2: 2	غَيْرُ قَاطِعِهِ
u'غَيْرٌ قَاطِعٌ':Added, #6: 6	غَيْرَ قَاطِعٍ
u'غير قَاطِعٌ':Added, #6: 6	غَيْرَ قَاطِعٍ
u'غَيْرٌ قَاطِعٌ':Added, #8: 8	غَيْرُ قَاطِعٍ
u'غير قَافِلٌ':Added, #8: 8	غَيْرُ قَاطِعٍ
u'غَيْرٌ قَافِلٌ':Added, #1: 1	غَيْرِ الْقَافِلَةِ
u'غير قَافِلَةٌ':Added, #1: 1	غَيْرِ الْقَافِلَةِ
u'غَيْرٌ قَافِلَةٌ':Added, #1: 1	غَيْرِ الْقَافِلَةِ
u'غير قَالِعٌ':Added, #1: 1	غَيْرِ الْقَافِلَةِ
u'غير قَالِعٌ':Added, #1: 1	غَيْرُ الْقَالِعِ
u'غَيْرٌ قَالِعٌ':Added, #1: 1	غَيْرِ الْقَالِعِ
u'غَيْرٌ قَالِعٌ':Added, #1: 1	غَيْرُ الْقَالِعِ
u'غير قَالِعٌ':Added, #1: 1	غَيْرِ الْقَالِعِ
u'غَيْرٌ قَالِعٌ':Added, #1: 1	غَيْرُ قَالِعٍ
u'غير قَانُونٌ':Added, #1: 1	غَيْرُ قَالِعٍ
u'غَيْرٌ قَانُونٌ':Added, #1: 1	غَيْرِ الْقَانُونِ
u'غير قَانُونٌ':Added, #1: 1	غَيْرِ الْقَانُونِ
u'غَيْرٌ قَانُونٌ':Added, #2: 2	غَيْرِ قَانُونٍ
u'غير قَائِدٌ':Added, #2: 2	غَيْرِ قَانُونٍ
u'غَيْرٌ قَائِدٌ':Added, #2: 2	غَيْرِ قَائِدٍ
u'غير قَائِلٌ':Added, #2: 2	غَيْرِ قَائِدٍ
u'غير قَائِلٌ':Added, #1: 1	غَيْرَ قَائِلٍ
u'غَيْرٌ قَائِلٌ':Added, #1: 1	غَيْرُ قَائِلٍ
u'غَيْرٌ قَائِلٌ':Added, #1: 1	غَيْرَ قَائِلٍ
u'غير قَائِلٌ':Added, #1: 1	غَيْرُ قَائِلٍ
u'غَيْرٌ قَائِلٌ':Added, #2: 2	غَيْرِ الْقَائِلِ
u'غير قَائِمٌ':Added, #2: 2	غَيْرِ الْقَائِلِ
u'غَيْرٌ قَائِمٌ':Added, #12: 12	غَيْرُ قَائِمٍ
u'غير قَائِمٌ':Added, #12: 12	غَيْرُ قَائِمٍ
u'غَيْرٌ قَائِمٌ':Added, #1: 1	غَيْرِ قَائِمٍ
u'غير قَائِمٌ':Added, #1: 1	غَيْرِ قَائِمٍ
u'غَيْرٌ قَائِمٌ':Added, #3: 3	غَيْرُ قَائِمَةٍ
u'غير قَائِمٌ':Added, #3: 3	غَيْرُ قَائِمَةٍ
u'غَيْرٌ قَائِمٌ':Added, #6: 6	غَيْرَ قَائِمٍ
u'غير قَائِمَةٌ':Added, #6: 6	غَيْرَ قَائِمٍ
u'غَيْرٌ قَائِمَةٌ':Added, #3: 3	غَيْرُ قَائِمَةٍ
u'غير قَبَاءٌ':Added, #3: 3	غَيْرُ قَائِمَةٍ
u'غَيْرٌ قَبَاءٌ':Added, #1: 1	غَيْرَ قَبَاءٍ
u'غير قَبَائِلُ':Added, #1: 1	غَيْرَ قَبَاءٍ
u'غَيْرٌ قَبَائِلُ':Added, #1: 1	غَيْرِ الْقَبَائِلِ
u'غير قَبْرٌ':Added, #1: 1	غَيْرِ الْقَبَائِلِ
u'غير قَبْرٌ':Added, #2: 2	غَيْرَ قَبْرِ
u'غَيْرٌ قَبْرٌ':Added, #2: 2	غَيْرِ قَبْرِ
u'غَيْرٌ قَبْرٌ':Added, #2: 2	غَيْرَ قَبْرِ
u'غير قَبْضٌ':Added, #2: 2	غَيْرِ قَبْرِ
u'غَيْرٌ قَبْضٌ':Added, #1: 1	غَيْرِ قَبْضِ
u'غير قَبْضٌ':Added, #1: 1	غَيْرِ قَبْضِ
u'غَيْرٌ قَبْضٌ':Added, #32: 32	غَيْرِ قَبْضٍ
u'غير قُبُلٌ':Added, #32: 32	غَيْرِ قَبْضٍ
u'غَيْرٌ قُبُلٌ':Added, #1: 1	غَيْرُ قُبُلٍ
u'غير قُبُلٌ':Added, #1: 1	غَيْرُ قُبُلٍ
u'غَيْرٌ قُبُلٌ':Added, #2: 2	غَيْرِ قُبُلٍ
u'غير قُبُلٌ':Added, #2: 2	غَيْرِ قُبُلٍ
u'غَيْرٌ قُبُلٌ':Added, #5: 5	غَيْرِ الْقُبُلِ
u'غير قُبْلَةٌ':Added, #5: 5	غَيْرِ الْقُبُلِ
u'غَيْرٌ قُبْلَةٌ':Added, #1: 1	غَيْرُ الْقُبْلَةِ
u'غير قِبْلَةٌ':Added, #1: 1	غَيْرُ الْقُبْلَةِ
u'غَيْرٌ قِبْلَةٌ':Added, #3: 3	غَيْرِ قِبْلَةٍ
u'غير قِبْلَةٌ':Added, #3: 3	غَيْرِ قِبْلَةٍ
u'غَيْرٌ قِبْلَةٌ':Added, #41: 41	غَيْرِ الْقِبْلَةِ
u'غير قَبُولٌ':Added, #41: 41	غَيْرِ الْقِبْلَةِ
u'غَيْرٌ قَبُولٌ':Added, #25: 25	غَيْرِ قَبُولٍ
u'غير قَبُولٌ':Added, #25: 25	غَيْرِ قَبُولٍ
u'غَيْرٌ قَبُولٌ':Added, #2: 2	غَيْرِ قَبُولِهِ
u'غير قَبُولٌ':Added, #2: 2	غَيْرِ قَبُولِهِ
u'غَيْرٌ قَبُولٌ':Added, #9: 9	غَيْرِ قَبُولِ
u'غير قَبِيحٌ':Added, #9: 9	غَيْرِ قَبُولِ
u'غَيْرٌ قَبِيحٌ':Added, #2: 2	غَيْرُ قَبِيحِ
u'غير قَبِيلٌ':Added, #2: 2	غَيْرُ قَبِيحِ
u'غَيْرٌ قَبِيلٌ':Added, #1: 1	غَيْرِ الْقَبِيلِ
u'غير قَبِيل':Added, #1: 1	غَيْرِ الْقَبِيلِ
u'غَيْرٌ قَبِيل':Added, #1: 1	غَيْرِ الْقَبِيلَتَيْنِ
u'غير قَبِيلَةٌ':Added, #1: 1	غَيْرِ الْقَبِيلَتَيْنِ
u'غَيْرٌ قَبِيلَةٌ':Added, #1: 1	غَيْرِ الْقَبِيلَةِ
u'غير قَبِيلَةٌ':Added, #1: 1	غَيْرِ الْقَبِيلَةِ
u'غَيْرٌ قَبِيلَةٌ':Added, #1: 1	غَيْرَ قَبِيلَتِهِ
u'غير قَبِيلَةٌ':Added, #1: 1	غَيْرَ قَبِيلَتِهِ
u'غَيْرٌ قَبِيلَةٌ':Added, #3: 3	غَيْرِ قَبِيلَتِهِ
u'غير قتال':Added, #3: 3	غَيْرِ قَبِيلَتِهِ
u'غَيْرٌ قتال':Added, #12: 12	غَيْرِ قِتَالٍ
u'غير قِتَالٌ':Added, #12: 12	غَيْرِ قِتَالٍ
u'غَيْرٌ قِتَالٌ':Added, #12: 12	غَيْرِ قِتَالٍ
u'غير قتال':Added, #12: 12	غَيْرِ قِتَالٍ
u'غَيْرٌ قتال':Added, #1: 1	غَيْرِ الْقِتَالِ
u'غير قِتَالٌ':Added, #1: 1	غَيْرِ الْقِتَالِ
u'غَيْرٌ قِتَالٌ':Added, #1: 1	غَيْرِ الْقِتَالِ
u'غير قَتْلٌ':Added, #1: 1	غَيْرِ الْقِتَالِ
u'غَيْرٌ قَتْلٌ':Added, #1: 1	غَيْرَ قَتْلٍ
u'غير قَتْلٌ':Added, #1: 1	غَيْرَ قَتْلٍ
u'غَيْرٌ قَتْلٌ':Added, #4: 4	غَيْرِ قَتْلٍ
u'غير قتل':Added, #4: 4	غَيْرِ قَتْلٍ
u'غير قتل':Added, #5: 5	غَيْرَ الْقَتْلِ
u'غَيْرٌ قتل':Added, #5: 5	غَيْرِ الْقَتْلِ
u'غَيْرٌ قتل':Added, #5: 5	غَيْرَ الْقَتْلِ
u'غير قَتْلٌ':Added, #5: 5	غَيْرِ الْقَتْلِ
u'غير قَتْلٌ':Added, #5: 5	غَيْرَ الْقَتْلِ
u'غَيْرٌ قَتْلٌ':Added, #5: 5	غَيْرِ الْقَتْلِ
u'غَيْرٌ قَتْلٌ':Added, #5: 5	غَيْرَ الْقَتْلِ
u'غير قتل':Added, #5: 5	غَيْرِ الْقَتْلِ
u'غَيْرٌ قتل':Added, #5: 5	غَيْرِ قَتْلِ
u'غير قَتْلٌ':Added, #5: 5	غَيْرِ قَتْلِ
u'غَيْرٌ قَتْلٌ':Added, #5: 5	غَيْرِ قَتْلِ
u'غير قتل':Added, #5: 5	غَيْرِ قَتْلِ
u'غَيْرٌ قتل':Added, #8: 8	غَيْرُ الْقَتْلِ
u'غير قَتْلٌ':Added, #8: 8	غَيْرُ الْقَتْلِ
u'غَيْرٌ قَتْلٌ':Added, #8: 8	غَيْرُ الْقَتْلِ
u'غير قِثَّاءٌ':Added, #8: 8	غَيْرُ الْقَتْلِ
u'غَيْرٌ قِثَّاءٌ':Added, #1: 1	غَيْرُ الْقِثَّاءِ
u'غير قَدْرٌ':Added, #1: 1	غَيْرُ الْقِثَّاءِ
u'غَيْرٌ قَدْرٌ':Added, #1: 1	غَيْرَ الْقَدْرِ
u'غير قَدْرٌ':Added, #1: 1	غَيْرَ الْقَدْرِ
u'غَيْرٌ قَدْرٌ':Added, #2: 2	غَيْرَ قَدْرِ
u'غير قُدْسِيّ':Added, #2: 2	غَيْرَ قَدْرِ
u'غَيْرٌ قُدْسِيّ':Added, #1: 1	غَيْرُ الْقُدْسِيَّةِ
u'غير قُدْسِيَّة':Added, #1: 1	غَيْرُ الْقُدْسِيَّةِ
u'غَيْرٌ قُدْسِيَّة':Added, #1: 1	غَيْرُ الْقُدْسِيَّةِ
u'غير قدم':Added, #1: 1	غَيْرُ الْقُدْسِيَّةِ
u'غَيْرٌ قدم':Added, #2: 2	غَيْرُ الْقَدَمِ
u'غير قَدَمٌ':Added, #2: 2	غَيْرُ الْقَدَمِ
u'غَيْرٌ قَدَمٌ':Added, #2: 2	غَيْرُ الْقَدَمِ
u'غير قذف':Added, #2: 2	غَيْرُ الْقَدَمِ
u'غَيْرٌ قذف':Added, #1: 1	غَيْرُ الْقَذْفِ
u'غير قَذْفٌ':Added, #1: 1	غَيْرُ الْقَذْفِ
u'غَيْرٌ قَذْفٌ':Added, #1: 1	غَيْرُ الْقَذْفِ
u'غير قَذْفٌ':Added, #1: 1	غَيْرُ الْقَذْفِ
u'غَيْرٌ قَذْفٌ':Added, #1: 1	غَيْرَ قَذْفٍ
u'غير قذف':Added, #1: 1	غَيْرَ قَذْفٍ
u'غَيْرٌ قذف':Added, #2: 2	غَيْرَ الْقَذْفِ
u'غير قَذْفٌ':Added, #2: 2	غَيْرَ الْقَذْفِ
u'غَيْرٌ قَذْفٌ':Added, #2: 2	غَيْرَ الْقَذْفِ
u'غير قذف':Added, #2: 2	غَيْرَ الْقَذْفِ
u'غَيْرٌ قذف':Added, #7: 7	غَيْرِ الْقَذْفِ
u'غير قَذْفٌ':Added, #7: 7	غَيْرِ الْقَذْفِ
u'غَيْرٌ قَذْفٌ':Added, #7: 7	غَيْرِ الْقَذْفِ
u'غير قِرَاءةٌ':Added, #7: 7	غَيْرِ الْقَذْفِ
u'غَيْرٌ قِرَاءةٌ':Added, #1: 1	غَيْرُ الْقِرَاءَاتِ
u'غير قِرَاءةٌ':Added, #1: 1	غَيْرُ الْقِرَاءَاتِ
u'غَيْرٌ قِرَاءةٌ':Added, #1: 1	غَيْرِ قِرَاءَتِهِ
u'غير قِرَاءةٌ':Added, #1: 1	غَيْرِ قِرَاءَتِهِ
u'غَيْرٌ قِرَاءةٌ':Added, #2: 2	غَيْرِ قِرَاءَةِ
u'غير قِرَاءةٌ':Added, #2: 2	غَيْرِ قِرَاءَةِ
u'غَيْرٌ قِرَاءةٌ':Added, #3: 3	غَيْرِ قِرَاءَةٍ
u'غير قِرَاءةٌ':Added, #3: 3	غَيْرِ قِرَاءَةٍ
u'غَيْرٌ قِرَاءةٌ':Added, #4: 4	غَيْرِ الْقِرَاءَةِ
u'غير قَرَابَةٌ':Added, #4: 4	غَيْرِ الْقِرَاءَةِ
u'غَيْرٌ قَرَابَةٌ':Added, #1: 1	غَيْرَ قَرَابَةٍ
u'غير قَرَابَةٌ':Added, #1: 1	غَيْرَ قَرَابَةٍ
u'غَيْرٌ قَرَابَةٌ':Added, #2: 2	غَيْرِ قَرَابَةِ
u'غير قَرَابَةٌ':Added, #2: 2	غَيْرِ قَرَابَةِ
u'غَيْرٌ قَرَابَةٌ':Added, #2: 2	غَيْرِ قَرَابَتِهِ
u'غير قِرَاعٌ':Added, #2: 2	غَيْرِ قَرَابَتِهِ
u'غَيْرٌ قِرَاعٌ':Added, #1: 1	غَيْرِ قِرَاعٍ
u'غير قُرْآنٌ':Added, #1: 1	غَيْرِ قِرَاعٍ
u'غير قُرْآنٌ':Added, #2: 2	غَيْرَ قُرْآنٍ
u'غير قُرْآنٌ':Added, #2: 2	غَيْرُ قُرْآنٍ
u'غَيْرٌ قُرْآنٌ':Added, #2: 2	غَيْرِ قُرْآنٍ
u'غَيْرٌ قُرْآنٌ':Added, #2: 2	غَيْرَ قُرْآنٍ
u'غَيْرٌ قُرْآنٌ':Added, #2: 2	غَيْرُ قُرْآنٍ
u'غير قُرْآنٌ':Added, #2: 2	غَيْرِ قُرْآنٍ
u'غَيْرٌ قُرْآنٌ':Added, #3: 3	غَيْرُ الْقُرْآنِ
u'غير قُرْآنٌ':Added, #3: 3	غَيْرُ الْقُرْآنِ
u'غَيْرٌ قُرْآنٌ':Added, #5: 5	غَيْرَ الْقُرْآنِ
u'غير قُرْآنٌ':Added, #5: 5	غَيْرَ الْقُرْآنِ
u'غَيْرٌ قُرْآنٌ':Added, #9: 9	غَيْرِ الْقُرْآنِ
u'غير قرائن':Added, #9: 9	غَيْرِ الْقُرْآنِ
u'غَيْرٌ قرائن':Added, #1: 1	غَيْرُ الْقَرَائِنِ
u'غير قُرْبٌ':Added, #1: 1	غَيْرُ الْقَرَائِنِ
u'غير قُرْبٌ':Added, #1: 1	غَيْرُ الْقُرْبِ
u'غَيْرٌ قُرْبٌ':Added, #1: 1	غَيْرِ الْقُرْبِ
u'غَيْرٌ قُرْبٌ':Added, #1: 1	غَيْرُ الْقُرْبِ
u'غير قُرْبَانٌ':Added, #1: 1	غَيْرِ الْقُرْبِ
u'غَيْرٌ قُرْبَانٌ':Added, #1: 1	غَيْرِ قُرْبَانٍ
u'غير قُرْبَةٌ':Added, #1: 1	غَيْرِ قُرْبَانٍ
u'غَيْرٌ قُرْبَةٌ':Added, #1: 1	غَيْرِ الْقُرْبَةِ
u'غير قُرْبَةٌ':Added, #1: 1	غَيْرِ الْقُرْبَةِ
u'غَيْرٌ قُرْبَةٌ':Added, #2: 2	غَيْرَ الْقُرْبَةِ
u'غير قُرْبَةٌ':Added, #2: 2	غَيْرَ الْقُرْبَةِ
u'غَيْرٌ قُرْبَةٌ':Added, #2: 2	غَيْرَ قُرْبَةٍ
u'غير قُرْبَةٌ':Added, #2: 2	غَيْرَ قُرْبَةٍ
u'غَيْرٌ قُرْبَةٌ':Added, #6: 6	غَيْرُ قُرْبَةٍ
u'غير قرح':Added, #6: 6	غَيْرُ قُرْبَةٍ
u'غَيْرٌ قرح':Added, #1: 1	غَيْرُ الْقُرْحِ
u'غير قُرَشِيٌّ':Added, #1: 1	غَيْرُ الْقُرْحِ
u'غَيْرٌ قُرَشِيٌّ':Added, #1: 1	غَيْرِ قُرَشِيَّةٍ
u'غير قُرَشِيٌّ':Added, #1: 1	غَيْرِ قُرَشِيَّةٍ
u'غَيْرٌ قُرَشِيٌّ':Added, #2: 2	غَيْرُ قُرَشِيٍّ
u'غير قُرَشِيٌّ':Added, #2: 2	غَيْرُ قُرَشِيٍّ
u'غَيْرٌ قُرَشِيٌّ':Added, #3: 3	غَيْرَ قُرَشِيٍّ
u'غير قَرْضٌ':Added, #3: 3	غَيْرَ قُرَشِيٍّ
u'غير قَرْضٌ':Added, #1: 1	غَيْرُ الْقَرْضِ
u'غَيْرٌ قَرْضٌ':Added, #1: 1	غَيْرِ الْقَرْضِ
u'غَيْرٌ قَرْضٌ':Added, #1: 1	غَيْرُ الْقَرْضِ
u'غير قَرْضٌ':Added, #1: 1	غَيْرِ الْقَرْضِ
u'غَيْرٌ قَرْضٌ':Added, #3: 3	غَيْرِ قَرْضٍ
u'غير قُرْعَةٌ':Added, #3: 3	غَيْرِ قَرْضٍ
u'غَيْرٌ قُرْعَةٌ':Added, #5: 5	غَيْرِ قُرْعَةٍ
u'غير قَرْنٌ':Added, #5: 5	غَيْرِ قُرْعَةٍ
u'غَيْرٌ قَرْنٌ':Added, #1: 1	غَيْرَ قَرْنِ
u'غير قَرْنٌ':Added, #1: 1	غَيْرَ قَرْنِ
u'غَيْرٌ قَرْنٌ':Added, #1: 1	غَيْرِ قَرْنِهِ
u'غير قَرِيبٌ':Added, #1: 1	غَيْرِ قَرْنِهِ
u'غَيْرٌ قَرِيبٌ':Added, #1: 1	غَيْرَ الْقَرِيبَةِ
u'غير قَرِيبٌ':Added, #1: 1	غَيْرَ الْقَرِيبَةِ
u'غَيْرٌ قَرِيبٌ':Added, #1: 1	غَيْرُ قَرِيبِهِ
u'غير قَرِيبٌ':Added, #1: 1	غَيْرُ قَرِيبِهِ
u'غير قَرِيبٌ':Added, #2: 2	غَيْرَ الْقَرِيبِ
u'غَيْرٌ قَرِيبٌ':Added, #2: 2	غَيْرُ الْقَرِيبِ
u'غَيْرٌ قَرِيبٌ':Added, #2: 2	غَيْرَ الْقَرِيبِ
u'غير قَرِيبٌ':Added, #2: 2	غَيْرُ الْقَرِيبِ
u'غَيْرٌ قَرِيبٌ':Added, #7: 7	غَيْرِ الْقَرِيبِ
u'غير قَرْيَةٌ':Added, #7: 7	غَيْرِ الْقَرِيبِ
u'غَيْرٌ قَرْيَةٌ':Added, #1: 1	غَيْرِ قَرْيَتِهِ
u'غير قُرَيْشٌ':Added, #1: 1	غَيْرِ قَرْيَتِهِ
u'غَيْرٌ قُرَيْشٌ':Added, #7: 7	غَيْرِ قُرَيْشٍ
u'غير قَرِينٌ':Added, #7: 7	غَيْرِ قُرَيْشٍ
u'غَيْرٌ قَرِينٌ':Added, #1: 1	غَيْرِ قَرِينَةِ
u'غير قَسام':Added, #1: 1	غَيْرِ قَرِينَةِ
u'غَيْرٌ قَسام':Added, #1: 1	غَيْرِ الْقَسَامَةِ
u'غير قَسام':Added, #1: 1	غَيْرِ الْقَسَامَةِ
u'غَيْرٌ قَسام':Added, #3: 3	غَيْرِ قَسَامَةٍ
u'غير قَسامَة':Added, #3: 3	غَيْرِ قَسَامَةٍ
u'غَيْرٌ قَسامَة':Added, #1: 1	غَيْرِ الْقَسَامَةِ
u'غير قَسامَة':Added, #1: 1	غَيْرِ الْقَسَامَةِ
u'غَيْرٌ قَسامَة':Added, #3: 3	غَيْرِ قَسَامَةٍ
u'غير قَسْمٌ':Added, #3: 3	غَيْرِ قَسَامَةٍ
u'غَيْرٌ قَسْمٌ':Added, #1: 1	غَيْرِ قَسْمٍ
u'غير قَسَمٌ':Added, #1: 1	غَيْرِ قَسْمٍ
u'غَيْرٌ قَسَمٌ':Added, #2: 2	غَيْرِ الْقَسَمِ
u'غير قسمة':Added, #2: 2	غَيْرِ الْقَسَمِ
u'غَيْرٌ قسمة':Added, #3: 3	غَيْرِ قِسْمَةٍ
u'غير قِسْمَةٌ':Added, #3: 3	غَيْرِ قِسْمَةٍ
u'غَيْرٌ قِسْمَةٌ':Added, #3: 3	غَيْرِ قِسْمَةٍ
u'غير قَصٌّ':Added, #3: 3	غَيْرِ قِسْمَةٍ
u'غَيْرٌ قَصٌّ':Added, #1: 1	غَيْرِ قَصٍّ
u'غير قصار':Added, #1: 1	غَيْرِ قَصٍّ
u'غَيْرٌ قصار':Added, #1: 1	غَيْرِ قِصَارِ
u'غير قصاص':Added, #1: 1	غَيْرِ قِصَارِ
u'غَيْرٌ قصاص':Added, #3: 3	غَيْرِ الْقِصَاصِ
u'غير قِصَاصٌ':Added, #3: 3	غَيْرِ الْقِصَاصِ
u'غَيْرٌ قِصَاصٌ':Added, #3: 3	غَيْرِ الْقِصَاصِ
u'غير قِصَّةٌ':Added, #3: 3	غَيْرِ الْقِصَاصِ
u'غير قِصَّةٌ':Added, #1: 1	غَيْر قِصَّةِ
u'غير قِصَّةٌ':Added, #1: 1	غَيْرَ قِصَّةِ
u'غَيْرٌ قِصَّةٌ':Added, #1: 1	غَيْرِ قِصَّةِ
u'غَيْرٌ قِصَّةٌ':Added, #1: 1	غَيْر قِصَّةِ
u'غَيْرٌ قِصَّةٌ':Added, #1: 1	غَيْرَ قِصَّةِ
u'غير قِصَّةٌ':Added, #1: 1	غَيْرِ قِصَّةِ
u'غَيْرٌ قِصَّةٌ':Added, #2: 2	غَيْرُ قِصَّةِ
u'غير قَصْدٌ':Added, #2: 2	غَيْرُ قِصَّةِ
u'غير قَصْدٌ':Added, #1: 1	غَيْرُ الْقَصْدِ
u'غَيْرٌ قَصْدٌ':Added, #1: 1	غَيْرِ الْقَصْدِ
u'غَيْرٌ قَصْدٌ':Added, #1: 1	غَيْرُ الْقَصْدِ
u'غير قَصْدٌ':Added, #1: 1	غَيْرِ الْقَصْدِ
u'غير قَصْدٌ':Added, #1: 1	غَيْر قَصْدٍ
u'غَيْرٌ قَصْدٌ':Added, #1: 1	غَيْرُ قَصْدٍ
u'غَيْرٌ قَصْدٌ':Added, #1: 1	غَيْر قَصْدٍ
u'غير قَصْدٌ':Added, #1: 1	غَيْرُ قَصْدٍ
u'غَيْرٌ قَصْدٌ':Added, #29: 29	غَيْرِ قَصْدِ
u'غير قَصْدٌ':Added, #29: 29	غَيْرِ قَصْدِ
u'غَيْرٌ قَصْدٌ':Added, #3: 3	غَيْرَ قَصْدٍ
u'غير قَصْدٌ':Added, #3: 3	غَيْرَ قَصْدٍ
u'غَيْرٌ قَصْدٌ':Added, #67: 67	غَيْرِ قَصْدٍ
u'غير قَصْدٌ':Added, #67: 67	غَيْرِ قَصْدٍ
u'غَيْرٌ قَصْدٌ':Added, #6: 6	غَيْرِ قَصْدِهِ
u'غير قَصْرٌ':Added, #6: 6	غَيْرِ قَصْدِهِ
u'غير قَصْرٌ':Added, #1: 1	غَيْرَ الْقَصْرِ
u'غَيْرٌ قَصْرٌ':Added, #1: 1	غَيْرُ الْقَصْرِ
u'غَيْرٌ قَصْرٌ':Added, #1: 1	غَيْرَ الْقَصْرِ
u'غير قَصْرٌ':Added, #1: 1	غَيْرُ الْقَصْرِ
u'غَيْرٌ قَصْرٌ':Added, #1: 1	غَيْرِ قَصْرٍ
u'غير قَصْرٌ':Added, #1: 1	غَيْرِ قَصْرٍ
u'غَيْرٌ قَصْرٌ':Added, #5: 5	غَيْرُ قَصْرٍ
u'غير قَصَصٌ':Added, #5: 5	غَيْرُ قَصْرٍ
u'غَيْرٌ قَصَصٌ':Added, #1: 1	غَيْرَ الْقَصَصِ
u'غير قَضَاءٌ':Added, #1: 1	غَيْرَ الْقَصَصِ
u'غَيْرٌ قَضَاءٌ':Added, #10: 10	غَيْرِ قَضَاءِ
u'غير قَضَاءٌ':Added, #10: 10	غَيْرِ قَضَاءِ
u'غير قَضَاءٌ':Added, #1: 1	غَيْرُ الْقَضَاءِ
u'غَيْرٌ قَضَاءٌ':Added, #1: 1	غَيْرِ الْقَضَاءِ
u'غَيْرٌ قَضَاءٌ':Added, #1: 1	غَيْرُ الْقَضَاءِ
u'غير قَضَاءٌ':Added, #1: 1	غَيْرِ الْقَضَاءِ
u'غَيْرٌ قَضَاءٌ':Added, #26: 26	غَيْرِ قَضَاءٍ
u'غير قضاة':Added, #26: 26	غَيْرِ قَضَاءٍ
u'غَيْرٌ قضاة':Added, #2: 2	غَيْرِ الْقُضَاةِ
u'غير قضاة':Added, #2: 2	غَيْرِ الْقُضَاةِ
u'غَيْرٌ قضاة':Added, #2: 2	غَيْرِ قُضَاةِ
u'غير قَطْعٌ':Added, #2: 2	غَيْرِ قُضَاةِ
u'غَيْرٌ قَطْعٌ':Added, #11: 11	غَيْرِ قَطْعِ
u'غير قَطْعٌ':Added, #11: 11	غَيْرِ قَطْعِ
u'غير قَطْعٌ':Added, #1: 1	غَيْرَ الْقَطْعِ
u'غير قَطْعٌ':Added, #1: 1	غَيْرُ الْقَطْعِ
u'غَيْرٌ قَطْعٌ':Added, #1: 1	غَيْرِ الْقَطْعِ
u'غَيْرٌ قَطْعٌ':Added, #1: 1	غَيْرَ الْقَطْعِ
u'غَيْرٌ قَطْعٌ':Added, #1: 1	غَيْرُ الْقَطْعِ
u'غير قَطْعٌ':Added, #1: 1	غَيْرِ الْقَطْعِ
u'غير قِطَعٌ':Added, #1: 1	غَيْرُ قَطْعِ
u'غَيْرٌ قَطْعٌ':Added, #1: 1	غَيْرَ قِطَعٍ
u'غَيْرٌ قِطَعٌ':Added, #1: 1	غَيْرُ قَطْعِ
u'غير قَطْع':Added, #1: 1	غَيْرَ قِطَعٍ
u'غير قَطْع':Added, #1: 1	غَيْرَ قَطْعِيَّةٍ
u'غَيْرٌ قَطْع':Added, #1: 1	غَيْرُ قَطْعِيَّةٍ
u'غَيْرٌ قَطْع':Added, #1: 1	غَيْرَ قَطْعِيَّةٍ
u'غير قَطْعٌ':Added, #1: 1	غَيْرُ قَطْعِيَّةٍ
u'غَيْرٌ قَطْعٌ':Added, #21: 21	غَيْرِ قَطْعٍ
u'غير قَطْعَة':Added, #21: 21	غَيْرِ قَطْعٍ
u'غير قَطْعَة':Added, #1: 1	غَيْرَ قَطْعِيَّةٍ
u'غَيْرٌ قَطْعَة':Added, #1: 1	غَيْرُ قَطْعِيَّةٍ
u'غَيْرٌ قَطْعَة':Added, #1: 1	غَيْرَ قَطْعِيَّةٍ
u'غير قَطْعِيّ':Added, #1: 1	غَيْرُ قَطْعِيَّةٍ
u'غير قَطْعِيّ':Added, #1: 1	غَيْرَ قَطْعِيَّةٍ
u'غَيْرٌ قَطْعِيّ':Added, #1: 1	غَيْرُ قَطْعِيَّةٍ
u'غَيْرٌ قَطْعِيّ':Added, #1: 1	غَيْرَ قَطْعِيَّةٍ
u'غير قَطْعِيَّة':Added, #1: 1	غَيْرُ قَطْعِيَّةٍ
u'غير قَطْعِيَّة':Added, #1: 1	غَيْرَ قَطْعِيَّةٍ
u'غَيْرٌ قَطْعِيَّة':Added, #1: 1	غَيْرُ قَطْعِيَّةٍ
u'غَيْرٌ قَطْعِيَّة':Added, #1: 1	غَيْرَ قَطْعِيَّةٍ
u'غير قُطْنٌ':Added, #1: 1	غَيْرُ قَطْعِيَّةٍ
u'غَيْرٌ قُطْنٌ':Added, #1: 1	غَيْرِ الْقُطْنِ
u'غير قَطِيعٌ':Added, #1: 1	غَيْرِ الْقُطْنِ
u'غَيْرٌ قَطِيعٌ':Added, #1: 1	غَيْرُ قَطِيعَةِ
u'غير قَطِيعَةٌ':Added, #1: 1	غَيْرُ قَطِيعَةِ
u'غَيْرٌ قَطِيعَةٌ':Added, #1: 1	غَيْرُ قَطِيعَةِ
u'غير قعدة':Added, #1: 1	غَيْرُ قَطِيعَةِ
u'غَيْرٌ قعدة':Added, #2: 2	غَيْرِ قَعْدَةٍ
u'غير قَعْدَةٌ':Added, #2: 2	غَيْرِ قَعْدَةٍ
u'غَيْرٌ قَعْدَةٌ':Added, #2: 2	غَيْرِ قَعْدَةٍ
u'غير قُفَّازٌ':Added, #2: 2	غَيْرِ قَعْدَةٍ
u'غَيْرٌ قُفَّازٌ':Added, #1: 1	غَيْرَ الْقُفَّازَيْنِ
u'غير قِلاَلٌ':Added, #1: 1	غَيْرَ الْقُفَّازَيْنِ
u'غَيْرٌ قِلاَلٌ':Added, #1: 1	غَيْرِ قِلَالِ
u'غير قِلَّةٌ':Added, #1: 1	غَيْرِ قِلَالِ
u'غير قِلَّةٌ':Added, #2: 2	غَيْرَ قِلَّةِ
u'غَيْرٌ قِلَّةٌ':Added, #2: 2	غَيْرِ قِلَّةٍ
u'غَيْرٌ قِلَّةٌ':Added, #2: 2	غَيْرَ قِلَّةِ
u'غير قَلِيلٌ':Added, #2: 2	غَيْرِ قِلَّةٍ
u'غير قَلِيلٌ':Added, #1: 1	غَيْرَ الْقَلِيلِ
u'غير قَلِيلٌ':Added, #1: 1	غَيْرُ الْقَلِيلِ
u'غَيْرٌ قَلِيلٌ':Added, #1: 1	غَيْرِ الْقَلِيلِ
u'غَيْرٌ قَلِيلٌ':Added, #1: 1	غَيْرَ الْقَلِيلِ
u'غَيْرٌ قَلِيلٌ':Added, #1: 1	غَيْرُ الْقَلِيلِ
u'غير قَلِيلٌ':Added, #1: 1	غَيْرِ الْقَلِيلِ
u'غَيْرٌ قَلِيلٌ':Added, #1: 1	غَيْرِ قَلِيلِ
u'غير قِمَارٌ':Added, #1: 1	غَيْرِ قَلِيلِ
u'غَيْرٌ قِمَارٌ':Added, #4: 4	غَيْرِ قِمَارٍ
u'غير قَمَرٌ':Added, #4: 4	غَيْرِ قِمَارٍ
u'غَيْرٌ قَمَرٌ':Added, #1: 1	غَيْرِ الْقَمَرَيْنِ
u'غير قِنٌّ':Added, #1: 1	غَيْرِ الْقَمَرَيْنِ
u'غَيْرٌ قِنٌّ':Added, #1: 1	غَيْرِ الْقِنِّ
u'غير قَهْرٌ':Added, #1: 1	غَيْرِ الْقِنِّ
u'غَيْرٌ قَهْرٌ':Added, #1: 1	غَيْرُ قَهْرٍ
u'غير قَهْرٌ':Added, #1: 1	غَيْرُ قَهْرٍ
u'غَيْرٌ قَهْرٌ':Added, #2: 2	غَيْرِ قَهْرٍ
u'غير قوائم':Added, #2: 2	غَيْرِ قَهْرٍ
u'غَيْرٌ قوائم':Added, #1: 1	غَيْرِ قَوَائِمِ
u'غير قَوَائِمُ':Added, #1: 1	غَيْرِ قَوَائِمِ
u'غَيْرٌ قَوَائِمُ':Added, #1: 1	غَيْرِ قَوَائِمِ
u'غير قُوتٌ':Added, #1: 1	غَيْرِ قَوَائِمِ
u'غَيْرٌ قُوتٌ':Added, #1: 1	غَيْرِ الْقُوتِ
u'غير قَوَد':Added, #1: 1	غَيْرِ الْقُوتِ
u'غَيْرٌ قَوَد':Added, #2: 2	غَيْرِ قَوَدٍ
u'غير قَوْسٌ':Added, #2: 2	غَيْرِ قَوَدٍ
u'غَيْرٌ قَوْسٌ':Added, #2: 2	غَيْرُ قَوْسِ
u'غير قول':Added, #2: 2	غَيْرُ قَوْسِ
u'غير قول':Added, #1: 1	غَيْرَ الْقَوْلِ
u'غَيْرٌ قول':Added, #1: 1	غَيْرِ الْقَوْلِ
u'غَيْرٌ قول':Added, #1: 1	غَيْرَ الْقَوْلِ
u'غير قَوْلٌ':Added, #1: 1	غَيْرِ الْقَوْلِ
u'غير قَوْلٌ':Added, #1: 1	غَيْرَ الْقَوْلِ
u'غَيْرٌ قَوْلٌ':Added, #1: 1	غَيْرِ الْقَوْلِ
u'غَيْرٌ قَوْلٌ':Added, #1: 1	غَيْرَ الْقَوْلِ
u'غير قَوْل':Added, #1: 1	غَيْرِ الْقَوْلِ
u'غير قَوْل':Added, #1: 1	غَيْرَ قَوْلِيَّةٍ
u'غَيْرٌ قَوْل':Added, #1: 1	غَيْرِ قَوْلِيَّةٍ
u'غَيْرٌ قَوْل':Added, #1: 1	غَيْرَ قَوْلِيَّةٍ
u'غير قَوْلٌ':Added, #1: 1	غَيْرِ قَوْلِيَّةٍ
u'غَيْرٌ قَوْلٌ':Added, #3: 3	غَيْرُ الْقَوْلَيْنِ
u'غير قَوْلٌ':Added, #3: 3	غَيْرُ الْقَوْلَيْنِ
u'غَيْرٌ قَوْلٌ':Added, #3: 3	غَيْرِ قَوْلٍ
u'غير قول':Added, #3: 3	غَيْرِ قَوْلٍ
u'غَيْرٌ قول':Added, #4: 4	غَيْرُ قَوْلِ
u'غير قَوْلٌ':Added, #4: 4	غَيْرُ قَوْلِ
u'غَيْرٌ قَوْلٌ':Added, #4: 4	غَيْرُ قَوْلِ
u'غير قول':Added, #4: 4	غَيْرُ قَوْلِ
u'غير قول':Added, #6: 6	غَيْرَ قَوْلِ
u'غَيْرٌ قول':Added, #6: 6	غَيْرِ قَوْلِ
u'غَيْرٌ قول':Added, #6: 6	غَيْرَ قَوْلِ
u'غير قَوْلٌ':Added, #6: 6	غَيْرِ قَوْلِ
u'غير قَوْلٌ':Added, #6: 6	غَيْرَ قَوْلِ
u'غَيْرٌ قَوْلٌ':Added, #6: 6	غَيْرِ قَوْلِ
u'غَيْرٌ قَوْلٌ':Added, #6: 6	غَيْرَ قَوْلِ
u'غير قول':Added, #6: 6	غَيْرِ قَوْلِ
u'غَيْرٌ قول':Added, #6: 6	غَيْرِ قَوْلِهِ
u'غير قَوْلٌ':Added, #6: 6	غَيْرِ قَوْلِهِ
u'غَيْرٌ قَوْلٌ':Added, #6: 6	غَيْرِ قَوْلِهِ
u'غير قَوْلَة':Added, #6: 6	غَيْرِ قَوْلِهِ
u'غير قَوْلَة':Added, #1: 1	غَيْرَ قَوْلِيَّةٍ
u'غَيْرٌ قَوْلَة':Added, #1: 1	غَيْرِ قَوْلِيَّةٍ
u'غَيْرٌ قَوْلَة':Added, #1: 1	غَيْرَ قَوْلِيَّةٍ
u'غير قَوْمٌ':Added, #1: 1	غَيْرِ قَوْلِيَّةٍ
u'غَيْرٌ قَوْمٌ':Added, #3: 3	غَيْرِ قَوْمِهِ
u'غير قَوِيٌّ':Added, #3: 3	غَيْرِ قَوْمِهِ
u'غَيْرٌ قَوِيٌّ':Added, #1: 1	غَيْرِ الْقَوِيِّ
u'غير قَوِيٌّ':Added, #1: 1	غَيْرِ الْقَوِيِّ
u'غَيْرٌ قَوِيٌّ':Added, #2: 2	غَيْرُ قَوِيَّيْنِ
u'غير قَيْءٌ':Added, #2: 2	غَيْرُ قَوِيَّيْنِ
u'غَيْرٌ قَيْءٌ':Added, #2: 2	غَيْرِ الْقَيْءِ
u'غير قِيَاسٌ':Added, #2: 2	غَيْرِ الْقَيْءِ
u'غَيْرٌ قِيَاسٌ':Added, #18: 18	غَيْرِ قِيَاسٍ
u'غير قِيَاسٌ':Added, #18: 18	غَيْرِ قِيَاسٍ
u'غَيْرٌ قِيَاسٌ':Added, #1: 1	غَيْرَ الْقِيَاسِ
u'غير قِيَاسٌ':Added, #1: 1	غَيْرَ الْقِيَاسِ
u'غَيْرٌ قِيَاسٌ':Added, #2: 2	غَيْرِ قِيَاسِ
u'غير قِيَاسٌ':Added, #2: 2	غَيْرِ قِيَاسِ
u'غَيْرٌ قِيَاسٌ':Added, #4: 4	غَيْرُ الْقِيَاسِ
u'غير قِيَاسٌ':Added, #4: 4	غَيْرُ الْقِيَاسِ
u'غَيْرٌ قِيَاسٌ':Added, #9: 9	غَيْرِ الْقِيَاسِ
u'غير قيام':Added, #9: 9	غَيْرِ الْقِيَاسِ
u'غير قِيَامٌ':Added, #10: 10	غَيْرِ الْقِيَامِ
u'غَيْرٌ قيام':Added, #10: 10	غَيْرِ الْقِيَامِ
u'غَيْرٌ قِيَامٌ':Added, #10: 10	غَيْرِ الْقِيَامِ
u'غير قيام':Added, #10: 10	غَيْرِ الْقِيَامِ
u'غير قِيَامٌ':Added, #1: 1	غَيْرَ الْقِيَامِ
u'غَيْرٌ قيام':Added, #1: 1	غَيْرَ الْقِيَامِ
u'غَيْرٌ قِيَامٌ':Added, #1: 1	غَيْرَ الْقِيَامِ
u'غير قيام':Added, #1: 1	غَيْرَ الْقِيَامِ
u'غير قِيَامٌ':Added, #3: 3	غَيْرِ قِيَامِ
u'غَيْرٌ قيام':Added, #3: 3	غَيْرِ قِيَامِ
u'غَيْرٌ قِيَامٌ':Added, #3: 3	غَيْرِ قِيَامِ
u'غير قِيَامٌ':Added, #3: 3	غَيْرِ قِيَامِ
u'غَيْرٌ قِيَامٌ':Added, #5: 5	غَيْرِ قِيَامٍ
u'غير قَيْدٌ':Added, #5: 5	غَيْرِ قِيَامٍ
u'غَيْرٌ قَيْدٌ':Added, #10: 10	غَيْرِ قَيْدِ
u'غير قَيْدٌ':Added, #10: 10	غَيْرِ قَيْدِ
u'غير قَيْدٌ':Added, #1: 1	غَيْرُ الْقَيْدِ
u'غَيْرٌ قَيْدٌ':Added, #1: 1	غَيْرِ الْقَيْدِ
u'غَيْرٌ قَيْدٌ':Added, #1: 1	غَيْرُ الْقَيْدِ
u'غَيْرٌ قَيْدٌ':Added, #1: 1	غَيْرِ الْقَيْدِ
u'غير قَيْدٌ':Added, #1: 1	غَيْرٍ قَيْدٍ
u'غَيْرٌ قَيْدٌ':Added, #22: 22	غَيْرِ قَيْدٍ
u'غير قَيْدٌ':Added, #22: 22	غَيْرِ قَيْدٍ
u'غَيْرٌ قَيْدٌ':Added, #5: 5	غَيْرُ قَيْدٍ
u'غير قِيرَاطٌ':Added, #5: 5	غَيْرُ قَيْدٍ
u'غير قِيرَاطٌ':Added, #1: 1	غَيْرَ قِيرَاطٍ
u'غَيْرٌ قِيرَاطٌ':Added, #1: 1	غَيْرِ قِيرَاطِ
u'غَيْرٌ قِيرَاطٌ':Added, #1: 1	غَيْرَ قِيرَاطٍ
u'غير قَيْلُولَةٌ':Added, #1: 1	غَيْرِ قِيرَاطِ
u'غَيْرٌ قَيْلُولَةٌ':Added, #1: 1	غَيْرِ الْقَيْلُولَةِ
u'غير قِيمَةٌ':Added, #1: 1	غَيْرِ الْقَيْلُولَةِ
u'غير قِيمَةٌ':Added, #1: 1	غَيْرَ الْقِيمَةِ
u'غير قِيمَةٌ':Added, #1: 1	غَيْرُ الْقِيمَةِ
u'غَيْرٌ قِيمَةٌ':Added, #1: 1	غَيْرِ الْقِيمَةِ
u'غَيْرٌ قِيمَةٌ':Added, #1: 1	غَيْرَ الْقِيمَةِ
u'غَيْرٌ قِيمَةٌ':Added, #1: 1	غَيْرُ الْقِيمَةِ
u'غير قِيمَةٌ':Added, #1: 1	غَيْرِ الْقِيمَةِ
u'غَيْرٌ قِيمَةٌ':Added, #1: 1	غَيْرُ قِيمَةِ
u'غير قِيمَةٌ':Added, #1: 1	غَيْرُ قِيمَةِ
u'غَيْرٌ قِيمَةٌ':Added, #1: 1	غَيْرَ قِيمَتِهِ
u'غير كَاتِبٌ':Added, #1: 1	غَيْرَ قِيمَتِهِ
u'غَيْرٌ كَاتِبٌ':Added, #1: 1	غَيْرَ الْكَاتِبِ
u'غير كَاتِبٌ':Added, #1: 1	غَيْرَ الْكَاتِبِ
u'غَيْرٌ كَاتِبٌ':Added, #1: 1	غَيْرُ كَاتِبٍ
u'غير كَاتِبٌ':Added, #1: 1	غَيْرُ كَاتِبٍ
u'غَيْرٌ كَاتِبٌ':Added, #3: 3	غَيْرَ كَاتِبٍ
u'غير كَاذِبٌ':Added, #3: 3	غَيْرَ كَاتِبٍ
u'غير كَاذِبٌ':Added, #1: 1	غَيْرَ كَاذِبِ
u'غير كَاذِبٌ':Added, #1: 1	غَيْرُ كَاذِبٍ
u'غَيْرٌ كَاذِبٌ':Added, #1: 1	غَيْرِ كَاذِبِ
u'غَيْرٌ كَاذِبٌ':Added, #1: 1	غَيْرَ كَاذِبِ
u'غَيْرٌ كَاذِبٌ':Added, #1: 1	غَيْرُ كَاذِبٍ
u'غير كَاذِبٌ':Added, #1: 1	غَيْرِ كَاذِبِ
u'غَيْرٌ كَاذِبٌ':Added, #1: 1	غَيْرَ كَاذِبَةٍ
u'غير كَاذِبٌ':Added, #1: 1	غَيْرَ كَاذِبَةٍ
u'غَيْرٌ كَاذِبٌ':Added, #1: 1	غَيْرِ كَاذِبَيْنِ
u'غير كارِث':Added, #1: 1	غَيْرِ كَاذِبَيْنِ
u'غَيْرٌ كارِث':Added, #1: 1	غَيْرُ كَارِثِ
u'غير كَارِهٌ':Added, #1: 1	غَيْرُ كَارِثِ
u'غَيْرٌ كَارِهٌ':Added, #2: 2	غَيْرِ كَارِهٍ
u'غير كَافِرٌ':Added, #2: 2	غَيْرِ كَارِهٍ
u'غير كَافِرٌ':Added, #1: 1	غَيْرَ الْكَافِرِ
u'غير كَافِرٌ':Added, #1: 1	غَيْرُ الْكَافِرِ
u'غَيْرٌ كَافِرٌ':Added, #1: 1	غَيْرِ الْكَافِرِ
u'غَيْرٌ كَافِرٌ':Added, #1: 1	غَيْرَ الْكَافِرِ
u'غَيْرٌ كَافِرٌ':Added, #1: 1	غَيْرُ الْكَافِرِ
u'غير كَافِرٌ':Added, #1: 1	غَيْرِ الْكَافِرِ
u'غَيْرٌ كَافِرٌ':Added, #1: 1	غَيْرِ كَافِرٍ
u'غير كَافِرٌ':Added, #1: 1	غَيْرِ كَافِرٍ
u'غَيْرٌ كَافِرٌ':Added, #1: 1	غَيْرِ كَافِرَةٍ
u'غير كَافِرٌ':Added, #1: 1	غَيْرِ كَافِرَةٍ
u'غَيْرٌ كَافِرٌ':Added, #2: 2	غَيْرَ كَافِرٍ
u'غير كَافِرٌ':Added, #2: 2	غَيْرَ كَافِرٍ
u'غَيْرٌ كَافِرٌ':Added, #6: 6	غَيْرُ كَافِرٍ
u'غير كَافِي':Added, #6: 6	غَيْرُ كَافِرٍ
u'غَيْرٌ كَافِي':Added, #2: 2	غَيْرُ كَافِيَةٍ
u'غير كَامِلٌ':Added, #2: 2	غَيْرُ كَافِيَةٍ
u'غير كَامِلٌ':Added, #1: 1	غَيْرَ الْكَامِلِ
u'غَيْرٌ كَامِلٌ':Added, #1: 1	غَيْرِ الْكَامِلِ
u'غَيْرٌ كَامِلٌ':Added, #1: 1	غَيْرَ الْكَامِلِ
u'غير كَامِلٌ':Added, #1: 1	غَيْرِ الْكَامِلِ
u'غير كَامِلٌ':Added, #1: 1	غَيْرَ كَامِلَةٍ
u'غير كَامِلٌ':Added, #1: 1	غَيْرُ كَامِلَةٍ
u'غَيْرٌ كَامِلٌ':Added, #1: 1	غَيْرِ كَامِلَةٍ
u'غَيْرٌ كَامِلٌ':Added, #1: 1	غَيْرَ كَامِلَةٍ
u'غَيْرٌ كَامِلٌ':Added, #1: 1	غَيْرُ كَامِلَةٍ
u'غير كَامِلٌ':Added, #1: 1	غَيْرِ كَامِلَةٍ
u'غَيْرٌ كَامِلٌ':Added, #2: 2	غَيْرَ كَامِلٍ
u'غير كَامِلٌ':Added, #2: 2	غَيْرَ كَامِلٍ
u'غَيْرٌ كَامِلٌ':Added, #3: 3	غَيْرُ كَامِلٍ
u'غير كَائِنٌ':Added, #3: 3	غَيْرُ كَامِلٍ
u'غَيْرٌ كَائِنٌ':Added, #1: 1	غَيْرُ كَائِنٍ
u'غير كبائر':Added, #1: 1	غَيْرُ كَائِنٍ
u'غَيْرٌ كبائر':Added, #1: 1	غَيْرُ الْكَبَائِرِ
u'غير كَبِيرٌ':Added, #1: 1	غَيْرُ الْكَبَائِرِ
u'غَيْرٌ كَبِيرٌ':Added, #1: 1	غَيْرِ الْكَبِيرِ
u'غير كِتَابٌ':Added, #1: 1	غَيْرِ الْكَبِيرِ
u'غَيْرٌ كِتَابٌ':Added, #1: 1	غَيْرُ الْكِتَابِ
u'غير كِتاب':Added, #1: 1	غَيْرُ الْكِتَابِ
u'غير كِتاب':Added, #1: 1	غَيْرُ الْكِتَابِيَّةِ
u'غَيْرٌ كِتاب':Added, #1: 1	غَيْرِ الْكِتَابِيَّةِ
u'غَيْرٌ كِتاب':Added, #1: 1	غَيْرُ الْكِتَابِيَّةِ
u'غير كِتَابٌ':Added, #1: 1	غَيْرِ الْكِتَابِيَّةِ
u'غَيْرٌ كِتَابٌ':Added, #1: 1	غَيْرِ الْكِتَابَيْنِ
u'غير كِتَابٌ':Added, #1: 1	غَيْرِ الْكِتَابَيْنِ
u'غَيْرٌ كِتَابٌ':Added, #2: 2	غَيْرِ الْكِتَابِ
u'غير كِتَابٌ':Added, #2: 2	غَيْرِ الْكِتَابِ
u'غَيْرٌ كِتَابٌ':Added, #2: 2	غَيْرِ كِتَابِهِ
u'غير كِتاب':Added, #2: 2	غَيْرِ كِتَابِهِ
u'غَيْرٌ كِتاب':Added, #2: 2	غَيْرُ كِتَابِيَّةٍ
u'غير كِتاب':Added, #2: 2	غَيْرُ كِتَابِيَّةٍ
u'غَيْرٌ كِتاب':Added, #3: 3	غَيْرَ الْكِتَابِيَّةِ
u'غير كِتاب':Added, #3: 3	غَيْرَ الْكِتَابِيَّةِ
u'غَيْرٌ كِتاب':Added, #3: 3	غَيْرَ كِتَابِيَّةٍ
u'غير كِتَابٌ':Added, #3: 3	غَيْرَ كِتَابِيَّةٍ
u'غَيْرٌ كِتَابٌ':Added, #4: 4	غَيْرَ الْكِتَابِ
u'غير كِتَابٌ':Added, #4: 4	غَيْرَ الْكِتَابِ
u'غَيْرٌ كِتَابٌ':Added, #4: 4	غَيْرِ كِتَابِ
u'غير كِتَابٌ':Added, #4: 4	غَيْرِ كِتَابِ
u'غَيْرٌ كِتَابٌ':Added, #6: 6	غَيْرِ كِتَابٍ
u'غير كِتابَة':Added, #6: 6	غَيْرِ كِتَابٍ
u'غير كِتابَة':Added, #1: 1	غَيْرُ الْكِتَابِيَّةِ
u'غَيْرٌ كِتابَة':Added, #1: 1	غَيْرِ الْكِتَابِيَّةِ
u'غَيْرٌ كِتابَة':Added, #1: 1	غَيْرُ الْكِتَابِيَّةِ
u'غير كِتَابَةٌ':Added, #1: 1	غَيْرِ الْكِتَابِيَّةِ
u'غَيْرٌ كِتَابَةٌ':Added, #2: 2	غَيْرِ الْكِتَابَةِ
u'غير كِتَابَةٌ':Added, #2: 2	غَيْرِ الْكِتَابَةِ
u'غَيْرٌ كِتَابَةٌ':Added, #2: 2	غَيْرِ كِتَابَةٍ
u'غير كِتابَة':Added, #2: 2	غَيْرِ كِتَابَةٍ
u'غَيْرٌ كِتابَة':Added, #2: 2	غَيْرُ كِتَابِيَّةٍ
u'غير كِتابَة':Added, #2: 2	غَيْرُ كِتَابِيَّةٍ
u'غَيْرٌ كِتابَة':Added, #3: 3	غَيْرَ الْكِتَابِيَّةِ
u'غير كِتابَة':Added, #3: 3	غَيْرَ الْكِتَابِيَّةِ
u'غَيْرٌ كِتابَة':Added, #3: 3	غَيْرَ كِتَابِيَّةٍ
u'غير كِتابِيّ':Added, #3: 3	غَيْرَ كِتَابِيَّةٍ
u'غير كِتابِيّ':Added, #1: 1	غَيْرُ الْكِتَابِيَّةِ
u'غَيْرٌ كِتابِيّ':Added, #1: 1	غَيْرِ الْكِتَابِيَّةِ
u'غَيْرٌ كِتابِيّ':Added, #1: 1	غَيْرُ الْكِتَابِيَّةِ
u'غير كِتابِيّ':Added, #1: 1	غَيْرِ الْكِتَابِيَّةِ
u'غير كِتابِيّ':Added, #1: 1	غَيْرَ الْكِتَابِيَّيْنِ
u'غَيْرٌ كِتابِيّ':Added, #1: 1	غَيْرُ الْكِتَابِيَّيْنِ
u'غَيْرٌ كِتابِيّ':Added, #1: 1	غَيْرَ الْكِتَابِيَّيْنِ
u'غير كِتابِيّ':Added, #1: 1	غَيْرُ الْكِتَابِيَّيْنِ
u'غَيْرٌ كِتابِيّ':Added, #2: 2	غَيْرُ كِتَابِيَّةٍ
u'غير كِتابِيّ':Added, #2: 2	غَيْرُ كِتَابِيَّةٍ
u'غَيْرٌ كِتابِيّ':Added, #2: 2	غَيْرَ كِتَابِيَّيْنِ
u'غير كِتابِيّ':Added, #2: 2	غَيْرَ كِتَابِيَّيْنِ
u'غَيْرٌ كِتابِيّ':Added, #3: 3	غَيْرَ الْكِتَابِيَّةِ
u'غير كِتابِيّ':Added, #3: 3	غَيْرَ الْكِتَابِيَّةِ
u'غَيْرٌ كِتابِيّ':Added, #3: 3	غَيْرَ كِتَابِيَّةٍ
u'غير كَتَّانٌ':Added, #3: 3	غَيْرَ كِتَابِيَّةٍ
u'غَيْرٌ كَتَّانٌ':Added, #1: 1	غَيْرَ الْكَتَّانِ
u'غير كُتُبٌ':Added, #1: 1	غَيْرَ الْكَتَّانِ
u'غَيْرٌ كُتُبٌ':Added, #1: 1	غَيْرِ الْكُتُبِ
u'غير كُتُبٌ':Added, #1: 1	غَيْرِ الْكُتُبِ
u'غَيْرٌ كُتُبٌ':Added, #2: 2	غَيْرِ كُتُبِ
u'غير كَثِيرٌ':Added, #2: 2	غَيْرِ كُتُبِ
u'غَيْرٌ كَثِيرٌ':Added, #1: 1	غَيْرِ الْكَثِيرِ
u'غير كَدَرٌ':Added, #1: 1	غَيْرِ الْكَثِيرِ
u'غير كَدِرٌ':Added, #1: 1	غَيْرِ الْكَدَرِ
u'غَيْرٌ كَدَرٌ':Added, #1: 1	غَيْرِ الْكَدِرِ
u'غَيْرٌ كَدِرٌ':Added, #1: 1	غَيْرِ الْكَدَرِ
u'غير كَدَرٌ':Added, #1: 1	غَيْرِ الْكَدِرِ
u'غَيْرٌ كَدَرٌ':Added, #1: 1	غَيْرِ كَدَرٍ
u'غير كَذِبٌ':Added, #1: 1	غَيْرِ كَدَرٍ
u'غَيْرٌ كَذِبٌ':Added, #1: 1	غَيْرَ كَذِبٍ
u'غير كذب':Added, #1: 1	غَيْرَ كَذِبٍ
u'غير كذب':Added, #2: 2	غَيْرَ الْكَذِبِ
u'غَيْرٌ كذب':Added, #2: 2	غَيْرِ الْكَذِبِ
u'غَيْرٌ كذب':Added, #2: 2	غَيْرَ الْكَذِبِ
u'غير كَذِبٌ':Added, #2: 2	غَيْرِ الْكَذِبِ
u'غير كَذِبٌ':Added, #2: 2	غَيْرَ الْكَذِبِ
u'غَيْرٌ كَذِبٌ':Added, #2: 2	غَيْرِ الْكَذِبِ
u'غَيْرٌ كَذِبٌ':Added, #2: 2	غَيْرَ الْكَذِبِ
u'غير كَرَاهَةٌ':Added, #2: 2	غَيْرِ الْكَذِبِ
u'غَيْرٌ كَرَاهَةٌ':Added, #108: 108	غَيْرِ كَرَاهَةٍ
u'غير كَرَاهَةٌ':Added, #108: 108	غَيْرِ كَرَاهَةٍ
u'غَيْرٌ كَرَاهَةٌ':Added, #1: 1	غَيْرَ الْكَرَاهَةِ
u'غير كَرَاهَةٌ':Added, #1: 1	غَيْرَ الْكَرَاهَةِ
u'غَيْرٌ كَرَاهَةٌ':Added, #1: 1	غَيْرِ كَرَاهَةِ
u'غير كَرَاهِيَةٌ':Added, #1: 1	غَيْرِ كَرَاهَةِ
u'غَيْرٌ كَرَاهِيَةٌ':Added, #2: 2	غَيْرِ كَرَاهِيَةٍ
u'غير كَرَّةٌ':Added, #2: 2	غَيْرِ كَرَاهِيَةٍ
u'غَيْرٌ كَرَّةٌ':Added, #1: 1	غَيْرَ كَرَّةٍ
u'غير كُرْسِيٌّ':Added, #1: 1	غَيْرَ كَرَّةٍ
u'غَيْرٌ كُرْسِيٌّ':Added, #1: 1	غَيْرُ الْكُرْسِيِّ
u'غير كَرِيهَةٌ':Added, #1: 1	غَيْرُ الْكُرْسِيِّ
u'غَيْرٌ كَرِيهَةٌ':Added, #1: 1	غَيْرَ كَرِيهَةٍ
u'غير كَسْبٌ':Added, #1: 1	غَيْرَ كَرِيهَةٍ
u'غَيْرٌ كَسْبٌ':Added, #1: 1	غَيْرِ كَسْبٍ
u'غير كَسْرٌ':Added, #1: 1	غَيْرِ كَسْبٍ
u'غَيْرٌ كَسْرٌ':Added, #1: 1	غَيْرِ كَسْرِ
u'غير كَسْرٌ':Added, #1: 1	غَيْرِ كَسْرِ
u'غَيْرٌ كَسْرٌ':Added, #6: 6	غَيْرِ كَسْرٍ
u'غير كَشْفٌ':Added, #6: 6	غَيْرِ كَسْرٍ
u'غَيْرٌ كَشْفٌ':Added, #1: 1	غَيْرِ الْكَشْفِ
u'غير كَشْفٌ':Added, #1: 1	غَيْرِ الْكَشْفِ
u'غَيْرٌ كَشْفٌ':Added, #1: 1	غَيْرِ كَشْفٍ
u'غير كَشْفٌ':Added, #1: 1	غَيْرِ كَشْفٍ
u'غَيْرٌ كَشْفٌ':Added, #4: 4	غَيْرِ كَشْفِ
u'غير كعبة':Added, #4: 4	غَيْرِ كَشْفِ
u'غَيْرٌ كعبة':Added, #4: 4	غَيْرِ الْكَعْبَةِ
u'غير كَعْبَةٌ':Added, #4: 4	غَيْرِ الْكَعْبَةِ
u'غَيْرٌ كَعْبَةٌ':Added, #4: 4	غَيْرِ الْكَعْبَةِ
u'غير كَفٌّ':Added, #4: 4	غَيْرِ الْكَعْبَةِ
u'غَيْرٌ كَفٌّ':Added, #10: 10	غَيْرِ كَفٍّ
u'غير كَفٌّ':Added, #10: 10	غَيْرِ كَفٍّ
u'غير كَفٌّ':Added, #1: 1	غَيْرَ الْكَفِّ
u'غَيْرٌ كَفٌّ':Added, #1: 1	غَيْرُ الْكَفِّ
u'غَيْرٌ كَفٌّ':Added, #1: 1	غَيْرَ الْكَفِّ
u'غير كَفٌّ':Added, #1: 1	غَيْرُ الْكَفِّ
u'غَيْرٌ كَفٌّ':Added, #1: 1	غَيْرُ الْكَفَّيْنِ
u'غير كَفٌّ':Added, #1: 1	غَيْرُ الْكَفَّيْنِ
u'غَيْرٌ كَفٌّ':Added, #3: 3	غَيْرَ كَفٍّ
u'غير كُفَاةٌ':Added, #3: 3	غَيْرَ كَفٍّ
u'غَيْرٌ كُفَاةٌ':Added, #1: 1	غَيْرَ الْكُفَاةِ
u'غير كُفَّارٌ':Added, #1: 1	غَيْرَ الْكُفَاةِ
u'غير كُفَّارٌ':Added, #1: 1	غَيْرَ الْكُفَّارِ
u'غَيْرٌ كُفَّارٌ':Added, #1: 1	غَيْرِ الْكُفَّارِ
u'غَيْرٌ كُفَّارٌ':Added, #1: 1	غَيْرَ الْكُفَّارِ
u'غير كَفَّارٌ':Added, #1: 1	غَيْرِ الْكُفَّارِ
u'غَيْرٌ كَفَّارٌ':Added, #1: 1	غَيْرَ الْكَفَّارَةِ
u'غير كُفَّارٌ':Added, #1: 1	غَيْرَ الْكَفَّارَةِ
u'غَيْرٌ كُفَّارٌ':Added, #1: 1	غَيْرَ كُفَّارٍ
u'غير كُفَّارٌ':Added, #1: 1	غَيْرَ كُفَّارٍ
u'غَيْرٌ كُفَّارٌ':Added, #2: 2	غَيْرُ كُفَّارٍ
u'غير كَفَّارٌ':Added, #2: 2	غَيْرُ كُفَّارٍ
u'غَيْرٌ كَفَّارٌ':Added, #3: 3	غَيْرُ الْكَفَّارَةِ
u'غير كَفَّارٌ':Added, #3: 3	غَيْرُ الْكَفَّارَةِ
u'غَيْرٌ كَفَّارٌ':Added, #3: 3	غَيْرُ كَفَّارَةِ
u'غير كَفَّارٌ':Added, #3: 3	غَيْرُ كَفَّارَةِ
u'غَيْرٌ كَفَّارٌ':Added, #5: 5	غَيْرِ الْكَفَّارَةِ
u'غير كَفَّارٌ':Added, #5: 5	غَيْرِ الْكَفَّارَةِ
u'غَيْرٌ كَفَّارٌ':Added, #5: 5	غَيْرِ كَفَّارَةِ
u'غير كَفَّارَةٌ':Added, #5: 5	غَيْرِ كَفَّارَةِ
u'غَيْرٌ كَفَّارَةٌ':Added, #1: 1	غَيْرَ الْكَفَّارَةِ
u'غير كَفَّارَةٌ':Added, #1: 1	غَيْرَ الْكَفَّارَةِ
u'غَيْرٌ كَفَّارَةٌ':Added, #2: 2	غَيْرُ كَفَّارَةٍ
u'غير كَفَّارَةٌ':Added, #2: 2	غَيْرُ كَفَّارَةٍ
u'غَيْرٌ كَفَّارَةٌ':Added, #3: 3	غَيْرُ الْكَفَّارَةِ
u'غير كَفَّارَةٌ':Added, #3: 3	غَيْرُ الْكَفَّارَةِ
u'غَيْرٌ كَفَّارَةٌ':Added, #3: 3	غَيْرُ كَفَّارَةِ
u'غير كَفَّارَةٌ':Added, #3: 3	غَيْرُ كَفَّارَةِ
u'غَيْرٌ كَفَّارَةٌ':Added, #4: 4	غَيْرِ كَفَّارَةٍ
u'غير كَفَّارَةٌ':Added, #4: 4	غَيْرِ كَفَّارَةٍ
u'غَيْرٌ كَفَّارَةٌ':Added, #5: 5	غَيْرِ الْكَفَّارَةِ
u'غير كَفَّارَةٌ':Added, #5: 5	غَيْرِ الْكَفَّارَةِ
u'غَيْرٌ كَفَّارَةٌ':Added, #5: 5	غَيْرِ كَفَّارَةِ
u'غير كَفَالَةٌ':Added, #5: 5	غَيْرِ كَفَّارَةِ
u'غَيْرٌ كَفَالَةٌ':Added, #3: 3	غَيْرِ كَفَالَةٍ
u'غير كُفْرٌ':Added, #3: 3	غَيْرِ كَفَالَةٍ
u'غَيْرٌ كُفْرٌ':Added, #1: 1	غَيْرُ كُفْرٍ
u'غير كُفْرٌ':Added, #1: 1	غَيْرُ كُفْرٍ
u'غَيْرٌ كُفْرٌ':Added, #2: 2	غَيْرَ كُفْرٍ
u'غير كفر':Added, #2: 2	غَيْرَ كُفْرٍ
u'غَيْرٌ كفر':Added, #5: 5	غَيْرِ الْكُفْرِ
u'غير كُفْرٌ':Added, #5: 5	غَيْرِ الْكُفْرِ
u'غَيْرٌ كُفْرٌ':Added, #5: 5	غَيْرِ الْكُفْرِ
u'غير كَفَنٌ':Added, #5: 5	غَيْرِ الْكُفْرِ
u'غير كَفَنٌ':Added, #1: 1	غَيْرُ الْكَفَنِ
u'غَيْرٌ كَفَنٌ':Added, #1: 1	غَيْرِ الْكَفَنِ
u'غَيْرٌ كَفَنٌ':Added, #1: 1	غَيْرُ الْكَفَنِ
u'غير كَفَنٌ':Added, #1: 1	غَيْرِ الْكَفَنِ
u'غَيْرٌ كَفَنٌ':Added, #4: 4	غَيْرَ الْكَفَنِ
u'غير كُفُؤٌ':Added, #4: 4	غَيْرَ الْكَفَنِ
u'غَيْرٌ كُفُؤٌ':Added, #1: 1	غَيْرَ كُفُؤَيْنِ
u'غير كُفُؤٌ':Added, #1: 1	غَيْرَ كُفُؤَيْنِ
u'غَيْرٌ كُفُؤٌ':Added, #3: 3	غَيْرِ كُفُؤٍ
u'غير كَفِيلٌ':Added, #3: 3	غَيْرِ كُفُؤٍ
u'غَيْرٌ كَفِيلٌ':Added, #1: 1	غَيْرُ كَفِيلِهِ
u'غير كلاب':Added, #1: 1	غَيْرُ كَفِيلِهِ
u'غير كلاب':Added, #1: 1	غَيْرُ الْكِلَابِ
u'غَيْرٌ كلاب':Added, #1: 1	غَيْرِ الْكِلَابِ
u'غَيْرٌ كلاب':Added, #1: 1	غَيْرُ الْكِلَابِ
u'غير كِلاَبٌ':Added, #1: 1	غَيْرِ الْكِلَابِ
u'غير كِلاَبٌ':Added, #1: 1	غَيْرُ الْكِلَابِ
u'غَيْرٌ كِلاَبٌ':Added, #1: 1	غَيْرِ الْكِلَابِ
u'غَيْرٌ كِلاَبٌ':Added, #1: 1	غَيْرُ الْكِلَابِ
u'غير كَلالَةٌ':Added, #1: 1	غَيْرِ الْكِلَابِ
u'غَيْرٌ كَلالَةٌ':Added, #1: 1	غَيْرَ كَلَالَةٍ
u'غير كَلاَمٌ':Added, #1: 1	غَيْرَ كَلَالَةٍ
u'غير كَلاَمٌ':Added, #1: 1	غَيْرَ كَلَامٍ
u'غير كَلاَمٌ':Added, #1: 1	غَيْرُ كَلَامِ
u'غَيْرٌ كَلاَمٌ':Added, #1: 1	غَيْرِ كَلَامٍ
u'غَيْرٌ كَلاَمٌ':Added, #1: 1	غَيْرَ كَلَامٍ
u'غَيْرٌ كَلاَمٌ':Added, #1: 1	غَيْرُ كَلَامِ
u'غير كَلاَمٌ':Added, #1: 1	غَيْرِ كَلَامٍ
u'غير كَلاَمٌ':Added, #2: 2	غَيْرُ الْكَلَامِ
u'غَيْرٌ كَلاَمٌ':Added, #2: 2	غَيْرِ الْكَلَامِ
u'غَيْرٌ كَلاَمٌ':Added, #2: 2	غَيْرُ الْكَلَامِ
u'غير كَلاَمٌ':Added, #2: 2	غَيْرِ الْكَلَامِ
u'غَيْرٌ كَلاَمٌ':Added, #6: 6	غَيْرِ كَلَامِ
u'غير كَلْبٌ':Added, #6: 6	غَيْرِ كَلَامِ
u'غير كَلْبٌ':Added, #1: 1	غَيْرَ كَلْبِ
u'غَيْرٌ كَلْبٌ':Added, #1: 1	غَيْرُ كَلْبِ
u'غَيْرٌ كَلْبٌ':Added, #1: 1	غَيْرَ كَلْبِ
u'غير كَلْبٌ':Added, #1: 1	غَيْرُ كَلْبِ
u'غير كَلْبٌ':Added, #2: 2	غَيْرَ الْكَلْبِ
u'غَيْرٌ كَلْبٌ':Added, #2: 2	غَيْرُ الْكَلْبِ
u'غَيْرٌ كَلْبٌ':Added, #2: 2	غَيْرَ الْكَلْبِ
u'غير كَلْبٌ':Added, #2: 2	غَيْرُ الْكَلْبِ
u'غَيْرٌ كَلْبٌ':Added, #2: 2	غَيْرِ كَلْبٍ
u'غير كَلْبٌ':Added, #2: 2	غَيْرِ كَلْبٍ
u'غَيْرٌ كَلْبٌ':Added, #8: 8	غَيْرِ الْكَلْبِ
u'غير كُلْفَةٌ':Added, #8: 8	غَيْرِ الْكَلْبِ
u'غَيْرٌ كُلْفَةٌ':Added, #2: 2	غَيْرِ كُلْفَةٍ
u'غَيَّرَ كَلِمَةٌ':Predicate, #2: 2	غَيْرِ كُلْفَةٍ
u'غير كَلِمَةٌ':Added, #2: 2	غَيَّرَ الْكَلِمَةَ
u'غَيْرٌ كَلِمَةٌ':Added, #3: 3	غَيْرَ كَلِمَةِ
u'غير كُلِّيٌّ':Added, #3: 3	غَيْرَ كَلِمَةِ
u'غَيْرٌ كُلِّيٌّ':Added, #1: 1	غَيْرُ كُلِّيَّةٍ
u'غير كُلِّيَّةٌ':Added, #1: 1	غَيْرُ كُلِّيَّةٍ
u'غَيْرٌ كُلِّيَّةٌ':Added, #1: 1	غَيْرُ كُلِّيَّةٍ
u'غير كَمَالٌ':Added, #1: 1	غَيْرُ كُلِّيَّةٍ
u'غَيْرٌ كَمَالٌ':Added, #1: 1	غَيْرِ كَمَالٍ
u'غير كِنَايَةٌ':Added, #1: 1	غَيْرِ كَمَالٍ
u'غَيْرٌ كِنَايَةٌ':Added, #2: 2	غَيْرُ كِنَايَةٍ
u'غير كُنْهٌ':Added, #2: 2	غَيْرُ كِنَايَةٍ
u'غَيْرٌ كُنْهٌ':Added, #4: 4	غَيْرِ كُنْهِهِ
u'غير كُوزٌ':Added, #4: 4	غَيْرِ كُنْهِهِ
u'غَيْرٌ كُوزٌ':Added, #1: 1	غَيْرِ الْكُوزِ
u'غير كُوفَةٌ':Added, #1: 1	غَيْرِ الْكُوزِ
u'غَيْرٌ كُوفَةٌ':Added, #5: 5	غَيْرِ الْكُوفَةِ
u'غَيَّرَ كَوْنٌ':Predicate, #5: 5	غَيْرِ الْكُوفَةِ
u'غير كَوْنٌ':Added, #1: 1	غَيَّرَ كَوْنَ
u'غَيْرٌ كَوْنٌ':Added, #1: 1	غَيْرُ كَوْنِ
u'غير كَوْنٌ':Added, #1: 1	غَيْرُ كَوْنِ
u'غَيْرٌ كَوْنٌ':Added, #2: 2	غَيْرُ كَوْنِهِ
u'غير كَوْنٌ':Added, #2: 2	غَيْرُ كَوْنِهِ
u'غَيْرٌ كَوْنٌ':Added, #3: 3	غَيْرِ كَوْنِهِ
u'غير كِيسٌ':Added, #3: 3	غَيْرِ كَوْنِهِ
u'غَيْرٌ كِيسٌ':Added, #1: 1	غَيْرِ كِيسٍ
u'غير كَيْلٌ':Added, #1: 1	غَيْرِ كِيسٍ
u'غَيْرٌ كَيْلٌ':Added, #1: 1	غَيْرِ الْكَيْلِ
u'غير كَيْلٌ':Added, #1: 1	غَيْرِ الْكَيْلِ
u'غَيْرٌ كَيْلٌ':Added, #7: 7	غَيْرِ كَيْلٍ
u'غير لاَبِثٌ':Added, #7: 7	غَيْرِ كَيْلٍ
u'غير لاَبِثٌ':Added, #1: 1	غَيْرَ لَابِثِ
u'غَيْرٌ لاَبِثٌ':Added, #1: 1	غَيْرُ لَابِثِ
u'غَيْرٌ لاَبِثٌ':Added, #1: 1	غَيْرَ لَابِثِ
u'غير لاَبِثٌ':Added, #1: 1	غَيْرُ لَابِثِ
u'غَيْرٌ لاَبِثٌ':Added, #3: 3	غَيْرُ لابِثٍ
u'غير لاَحِقٌ':Added, #3: 3	غَيْرُ لابِثٍ
u'غير لاَحِقٌ':Added, #1: 1	غَيْرَ لَاحِقٍ
u'غَيْرٌ لاَحِقٌ':Added, #1: 1	غَيْرُ لَاحِقٍ
u'غَيْرٌ لاَحِقٌ':Added, #1: 1	غَيْرَ لَاحِقٍ
u'غير لاَحِقٌ':Added, #1: 1	غَيْرُ لَاحِقٍ
u'غَيْرٌ لاَحِقٌ':Added, #1: 1	غَيْرَ لَاحِقَةٍ
u'غير لاَزِمٌ':Added, #1: 1	غَيْرَ لَاحِقَةٍ
u'غَيْرٌ لاَزِمٌ':Added, #167: 167	غَيْرُ لَازِمٍ
u'غير لاَزِمٌ':Added, #167: 167	غَيْرُ لَازِمٍ
u'غَيْرٌ لاَزِمٌ':Added, #1: 1	غَيْرُ اللَّازِمِ
u'غير لاَزِمٌ':Added, #1: 1	غَيْرُ اللَّازِمِ
u'غَيْرٌ لاَزِمٌ':Added, #1: 1	غَيْرَ لَازِمِ
u'غير لاَزِمٌ':Added, #1: 1	غَيْرَ لَازِمِ
u'غير لاَزِمٌ':Added, #1: 1	غَيْرُ لَازِمَيْنِ
u'غَيْرٌ لاَزِمٌ':Added, #1: 1	غَيْرُ لاَزِمَيْنِ
u'غَيْرٌ لاَزِمٌ':Added, #1: 1	غَيْرُ لَازِمَيْنِ
u'غير لاَزِمٌ':Added, #1: 1	غَيْرُ لاَزِمَيْنِ
u'غَيْرٌ لاَزِمٌ':Added, #34: 34	غَيْرُ لَازِمَةٍ
u'غير لاَزِمٌ':Added, #34: 34	غَيْرُ لَازِمَةٍ
u'غَيْرٌ لاَزِمٌ':Added, #3: 3	غَيْرِ اللَّازِمِ
u'غير لاَزِمٌ':Added, #3: 3	غَيْرِ اللَّازِمِ
u'غَيْرٌ لاَزِمٌ':Added, #3: 3	غَيْرِ اللَّازِمَةِ
u'غير لاَزِمٌ':Added, #3: 3	غَيْرِ اللَّازِمَةِ
u'غَيْرٌ لاَزِمٌ':Added, #3: 3	غَيْرُ لَازِمِ
u'غير لاَزِمٌ':Added, #3: 3	غَيْرُ لَازِمِ
u'غَيْرٌ لاَزِمٌ':Added, #41: 41	غَيْرَ لَازِمٍ
u'غير لاَزِمٌ':Added, #41: 41	غَيْرَ لَازِمٍ
u'غَيْرٌ لاَزِمٌ':Added, #5: 5	غَيْرَ لَازِمَةٍ
u'غير لاَزِمٌ':Added, #5: 5	غَيْرَ لَازِمَةٍ
u'غَيْرٌ لاَزِمٌ':Added, #9: 9	غَيْرِ لَازِمٍ
u'غير لاَزِمَة':Added, #9: 9	غَيْرِ لَازِمٍ
u'غَيْرٌ لاَزِمَة':Added, #34: 34	غَيْرُ لَازِمَةٍ
u'غير لاَزِمَة':Added, #34: 34	غَيْرُ لَازِمَةٍ
u'غَيْرٌ لاَزِمَة':Added, #3: 3	غَيْرِ اللَّازِمَةِ
u'غير لاَزِمَة':Added, #3: 3	غَيْرِ اللَّازِمَةِ
u'غَيْرٌ لاَزِمَة':Added, #5: 5	غَيْرَ لَازِمَةٍ
u'غير لاَمٌ':Added, #5: 5	غَيْرَ لَازِمَةٍ
u'غَيْرٌ لاَمٌ':Added, #2: 2	غَيْرِ لَامِ
u'غير لاَئِقٌ':Added, #2: 2	غَيْرِ لَامِ
u'غير لاَئِقٌ':Added, #1: 1	غَيْر لَائِقٍ
u'غَيْرٌ لاَئِقٌ':Added, #1: 1	غَيْرَ لَائِقٍ
u'غَيْرٌ لاَئِقٌ':Added, #1: 1	غَيْر لَائِقٍ
u'غير لاَئِقٌ':Added, #1: 1	غَيْرَ لَائِقٍ
u'غَيْرٌ لاَئِقٌ':Added, #1: 1	غَيْرِ لَائِقَةٍ
u'غير لاَئِقٌ':Added, #1: 1	غَيْرِ لَائِقَةٍ
u'غَيْرٌ لاَئِقٌ':Added, #1: 1	غَيْرَ لَائِقَيْنِ
u'غير لاَئِقٌ':Added, #1: 1	غَيْرَ لَائِقَيْنِ
u'غَيْرٌ لاَئِقٌ':Added, #2: 2	غَيْرُ لَائِقَةٍ
u'غير لاَئِقٌ':Added, #2: 2	غَيْرُ لَائِقَةٍ
u'غَيْرٌ لاَئِقٌ':Added, #5: 5	غَيْرِ لَائِقٍ
u'غير لاَئِقٌ':Added, #5: 5	غَيْرِ لَائِقٍ
u'غَيْرٌ لاَئِقٌ':Added, #6: 6	غَيْرُ لَائِقٍ
u'غير لبس':Added, #6: 6	غَيْرُ لَائِقٍ
u'غَيْرٌ لبس':Added, #1: 1	غَيْرِ اللّبْسِ
u'غير لَبْسٌ':Added, #1: 1	غَيْرِ اللّبْسِ
u'غير لُبْسٌ':Added, #1: 1	غَيْرِ اللّبْسِ
u'غير لِبْسٌ':Added, #1: 1	غَيْرِ اللّبْسِ
u'غَيْرٌ لَبْسٌ':Added, #1: 1	غَيْرِ اللّبْسِ
u'غَيْرٌ لُبْسٌ':Added, #1: 1	غَيْرِ اللّبْسِ
u'غَيْرٌ لِبْسٌ':Added, #1: 1	غَيْرِ اللّبْسِ
u'غير لبس':Added, #1: 1	غَيْرِ اللّبْسِ
u'غَيْرٌ لبس':Added, #3: 3	غَيْرُ اللُّبْسِ
u'غير لُبْسٌ':Added, #3: 3	غَيْرُ اللُّبْسِ
u'غَيْرٌ لُبْسٌ':Added, #3: 3	غَيْرُ اللُّبْسِ
u'غير لبن':Added, #3: 3	غَيْرُ اللُّبْسِ
u'غَيْرٌ لبن':Added, #1: 1	غَيْرِ اللَّبَنِ
u'غير لَبَنٌ':Added, #1: 1	غَيْرِ اللَّبَنِ
u'غَيْرٌ لَبَنٌ':Added, #1: 1	غَيْرِ اللَّبَنِ
u'غير لبن':Added, #1: 1	غَيْرِ اللَّبَنِ
u'غير لبن':Added, #1: 1	غَيْرُ لَبَنِ
u'غَيْرٌ لبن':Added, #1: 1	غَيْرِ لَبَنِ
u'غَيْرٌ لبن':Added, #1: 1	غَيْرُ لَبَنِ
u'غير لَبَنٌ':Added, #1: 1	غَيْرِ لَبَنِ
u'غير لَبَنٌ':Added, #1: 1	غَيْرُ لَبَنٍ
u'غير لَبَنٌ':Added, #1: 1	غَيْرُ لَبَنِ
u'غَيْرٌ لَبَنٌ':Added, #1: 1	غَيْرِ لَبَنِ
u'غَيْرٌ لَبَنٌ':Added, #1: 1	غَيْرُ لَبَنٍ
u'غَيْرٌ لَبَنٌ':Added, #1: 1	غَيْرُ لَبَنِ
u'غير لبن':Added, #1: 1	غَيْرِ لَبَنِ
u'غَيْرٌ لبن':Added, #2: 2	غَيْرُ اللَّبَنِ
u'غير لَبَنٌ':Added, #2: 2	غَيْرُ اللَّبَنِ
u'غَيْرٌ لَبَنٌ':Added, #2: 2	غَيْرُ اللَّبَنِ
u'غير لبن':Added, #2: 2	غَيْرُ اللَّبَنِ
u'غَيْرٌ لبن':Added, #9: 9	غَيْرَ اللَّبَنِ
u'غير لَبَنٌ':Added, #9: 9	غَيْرَ اللَّبَنِ
u'غَيْرٌ لَبَنٌ':Added, #9: 9	غَيْرَ اللَّبَنِ
u'غير لَبُونٌ':Added, #9: 9	غَيْرَ اللَّبَنِ
u'غَيْرٌ لَبُونٌ':Added, #1: 1	غَيْرُ اللَّبُونِ
u'غير لجاج':Added, #1: 1	غَيْرُ اللَّبُونِ
u'غَيْرٌ لجاج':Added, #2: 2	غَيْرَ اللَّجَاجِ
u'غير لَحْمٌ':Added, #2: 2	غَيْرَ اللَّجَاجِ
u'غَيْرٌ لَحْمٌ':Added, #2: 2	غَيْرِ اللَّحْمِ
u'غير لَحْمٌ':Added, #2: 2	غَيْرِ اللَّحْمِ
u'غَيْرٌ لَحْمٌ':Added, #3: 3	غَيْرُ اللَّحْمِ
u'غير لَحْمٌ':Added, #3: 3	غَيْرُ اللَّحْمِ
u'غَيْرٌ لَحْمٌ':Added, #4: 4	غَيْرَ اللَّحْمِ
u'غير لَحْمٌ':Added, #4: 4	غَيْرَ اللَّحْمِ
u'غَيْرٌ لَحْمٌ':Added, #4: 4	غَيْرَ لَحْمٍ
u'غير لَحْنٌ':Added, #4: 4	غَيْرَ لَحْمٍ
u'غَيْرٌ لَحْنٌ':Added, #1: 1	غَيْرَ لَحْنٍ
u'غير لِحْيَةٌ':Added, #1: 1	غَيْرَ لَحْنٍ
u'غَيْرٌ لِحْيَةٌ':Added, #1: 1	غَيْرِ لِحْيَةِ
u'غير لِحْيَةٌ':Added, #1: 1	غَيْرِ لِحْيَةِ
u'غَيْرٌ لِحْيَةٌ':Added, #6: 6	غَيْرِ اللِّحْيَةِ
u'غير لَدَدٌ':Added, #6: 6	غَيْرِ اللِّحْيَةِ
u'غَيْرٌ لَدَدٌ':Added, #1: 1	غَيْرِ لَدَدٍ
u'غير لُزُومٌ':Added, #1: 1	غَيْرِ لَدَدٍ
u'غَيْرٌ لُزُومٌ':Added, #2: 2	غَيْرِ لُزُومٍ
u'غير لُزُومٌ':Added, #2: 2	غَيْرِ لُزُومٍ
u'غَيْرٌ لُزُومٌ':Added, #5: 5	غَيْرِ لُزُومِ
u'غير لِسَانٌ':Added, #5: 5	غَيْرِ لُزُومِ
u'غير لِسَانٌ':Added, #1: 1	غَيْرُ اللِّسَانِ
u'غَيْرٌ لِسَانٌ':Added, #1: 1	غَيْرِ اللّسَانِ
u'غَيْرٌ لِسَانٌ':Added, #1: 1	غَيْرُ اللِّسَانِ
u'غير لِسَانٌ':Added, #1: 1	غَيْرِ اللّسَانِ
u'غير لِسَانٌ':Added, #1: 1	غَيْرَ لِسَانِ
u'غَيْرٌ لِسَانٌ':Added, #1: 1	غَيْرِ لِسَانِ
u'غَيْرٌ لِسَانٌ':Added, #1: 1	غَيْرَ لِسَانِ
u'غير لِسَانٌ':Added, #1: 1	غَيْرِ لِسَانِ
u'غَيْرٌ لِسَانٌ':Added, #1: 1	غَيْرِ لِسَانِهِ
u'غير لعان':Added, #1: 1	غَيْرِ لِسَانِهِ
u'غَيْرٌ لعان':Added, #1: 1	غَيْرِ اللِّعَانِ
u'غير لعان':Added, #1: 1	غَيْرِ اللِّعَانِ
u'غَيْرٌ لعان':Added, #6: 6	غَيْرِ لِعَانٍ
u'غير لَعِبٌ':Added, #6: 6	غَيْرِ لِعَانٍ
u'غَيْرٌ لَعِبٌ':Added, #1: 1	غَيْرِ لَعِبٍ
u'غير لَعْثَمَة':Added, #1: 1	غَيْرِ لَعِبٍ
u'غَيْرٌ لَعْثَمَة':Added, #1: 1	غَيْرِ لَعْثَمَةٍ
u'غير لُغَةٌ':Added, #1: 1	غَيْرِ لَعْثَمَةٍ
u'غير لُغَةٌ':Added, #1: 1	غَيْرَ اللُّغَةِ
u'غير لُغَةٌ':Added, #1: 1	غَيْرُ اللُّغَةِ
u'غَيْرٌ لُغَةٌ':Added, #1: 1	غَيْرِ اللُّغَةِ
u'غَيْرٌ لُغَةٌ':Added, #1: 1	غَيْرَ اللُّغَةِ
u'غَيْرٌ لُغَةٌ':Added, #1: 1	غَيْرُ اللُّغَةِ
u'غير لُغَةٌ':Added, #1: 1	غَيْرِ اللُّغَةِ
u'غَيْرٌ لُغَةٌ':Added, #1: 1	غَيْرِ لُغَةٍ
u'غير لُغَةٌ':Added, #1: 1	غَيْرِ لُغَةٍ
u'غَيْرٌ لُغَةٌ':Added, #2: 2	غَيْرُ لُغَةِ
u'غير لُغَةٌ':Added, #2: 2	غَيْرُ لُغَةِ
u'غَيْرٌ لُغَةٌ':Added, #3: 3	غَيْرِ لُغَةِ
u'غير لُغَةٌ':Added, #3: 3	غَيْرِ لُغَةِ
u'غَيْرٌ لُغَةٌ':Added, #3: 3	غَيْرِ لُغَتِهِ
u'غير لُغَوِيٌّ':Added, #3: 3	غَيْرِ لُغَتِهِ
u'غَيْرٌ لُغَوِيٌّ':Added, #1: 1	غَيْرِ اللُّغَوِيِّ
u'غَيَّرَ لَفْظٌ':Predicate, #1: 1	غَيْرِ اللُّغَوِيِّ
u'غير لَفْظٌ':Added, #1: 1	غَيَّرَ لَفْظَ
u'غَيْرٌ لَفْظٌ':Added, #11: 11	غَيْرِ لَفْظِ
u'غير لَفْظٌ':Added, #11: 11	غَيْرِ لَفْظِ
u'غَيْرٌ لَفْظٌ':Added, #1: 1	غَيْرُ لَفْظٍ
u'غير لَفْظٌ':Added, #1: 1	غَيْرُ لَفْظٍ
u'غَيْرٌ لَفْظٌ':Added, #3: 3	غَيْرِ لَفْظِهِ
u'غير لَفْظٌ':Added, #3: 3	غَيْرِ لَفْظِهِ
u'غَيْرٌ لَفْظٌ':Added, #4: 4	غَيْرُ لَفْظِ
u'غير لَفْظٌ':Added, #4: 4	غَيْرُ لَفْظِ
u'غَيْرٌ لَفْظٌ':Added, #5: 5	غَيْرِ اللَّفْظِ
u'غير لَفْظٌ':Added, #5: 5	غَيْرِ اللَّفْظِ
u'غَيْرٌ لَفْظٌ':Added, #9: 9	غَيْرِ لَفْظٍ
u'غير لَفْظِيٌّ':Added, #9: 9	غَيْرِ لَفْظٍ
u'غَيْرٌ لَفْظِيٌّ':Added, #1: 1	غَيْرِ اللَّفْظِيِّ
u'غير لَفْظِيٌّ':Added, #1: 1	غَيْرِ اللَّفْظِيِّ
u'غَيْرٌ لَفْظِيٌّ':Added, #1: 1	غَيْرُ اللَّفْظِيَّةِ
u'غير لَفْظِيٌّ':Added, #1: 1	غَيْرُ اللَّفْظِيَّةِ
u'غير لَفْظِيٌّ':Added, #2: 2	غَيْرَ لَفْظِيَّةٍ
u'غَيْرٌ لَفْظِيٌّ':Added, #2: 2	غَيْرُ لَفْظِيَّةٍ
u'غَيْرٌ لَفْظِيٌّ':Added, #2: 2	غَيْرَ لَفْظِيَّةٍ
u'غير لقطة':Added, #2: 2	غَيْرُ لَفْظِيَّةٍ
u'غَيْرٌ لقطة':Added, #1: 1	غَيْرِ اللُّقَطَةِ
u'غير لَقِيطٌ':Added, #1: 1	غَيْرِ اللُّقَطَةِ
u'غَيْرٌ لَقِيطٌ':Added, #1: 1	غَيْرِ اللَّقِيطِ
u'غير لَمْسٌ':Added, #1: 1	غَيْرِ اللَّقِيطِ
u'غَيْرٌ لَمْسٌ':Added, #1: 1	غَيْرُ اللَّمْسِ
u'غير لَمْسٌ':Added, #1: 1	غَيْرُ اللَّمْسِ
u'غَيْرٌ لَمْسٌ':Added, #1: 1	غَيْرِ لَمْسٍ
u'غير لَهْوٌ':Added, #1: 1	غَيْرِ لَمْسٍ
u'غَيْرٌ لَهْوٌ':Added, #7: 7	غَيْرِ لَهْوٍ
u'غير لَوْمٌ':Added, #7: 7	غَيْرِ لَهْوٍ
u'غَيْرٌ لَوْمٌ':Added, #1: 1	غَيْرِ لَوْمٍ
u'غير لَوْنٌ':Added, #1: 1	غَيْرِ لَوْمٍ
u'غَيْرٌ لَوْنٌ':Added, #1: 1	غَيْرُ لَوْنٍ
u'غير لَوْنٌ':Added, #1: 1	غَيْرُ لَوْنٍ
u'غير لَوْنٌ':Added, #2: 2	غَيْرِ لَوْنٍ
u'غَيْرٌ لَوْنٌ':Added, #2: 2	غَيْرِ لَوْنِ
u'غَيْرٌ لَوْنٌ':Added, #2: 2	غَيْرِ لَوْنٍ
u'غير لئام':Added, #2: 2	غَيْرِ لَوْنِ
u'غَيْرٌ لئام':Added, #1: 1	غَيْرِ لِئَامِ
u'غير لَيْثٌ':Added, #1: 1	غَيْرِ لِئَامِ
u'غَيْرٌ لَيْثٌ':Added, #1: 1	غَيْرِ لَيْثٍ
u'غير لَيْثٌ':Added, #1: 1	غَيْرِ لَيْثٍ
u'غَيْرٌ لَيْثٌ':Added, #2: 2	غَيْرُ اللَّيْثِ
u'غير لَيْلٌ':Added, #2: 2	غَيْرُ اللَّيْثِ
u'غَيْرٌ لَيْلٌ':Added, #1: 1	غَيْرِ اللَّيْلِ
u'غير لَيْلٌ':Added, #1: 1	غَيْرِ اللَّيْلِ
u'غَيْرٌ لَيْلٌ':Added, #1: 1	غَيْرِ لَيْلَةِ
u'غَيَّرَ مَاءٌ':Predicate, #1: 1	غَيْرِ لَيْلَةِ
u'غير مَاءٌ':Added, #1: 1	غَيَّرَ الْمَاءَ
u'غَيْرٌ مَاءٌ':Added, #11: 11	غَيْرِ مَاءٍ
u'غير مَاءٌ':Added, #11: 11	غَيْرِ مَاءٍ
u'غَيْرٌ مَاءٌ':Added, #12: 12	غَيْرُ الْمَاءِ
u'غير مَاءٌ':Added, #12: 12	غَيْرُ الْمَاءِ
u'غَيْرٌ مَاءٌ':Added, #1: 1	غَيْرَ مَاءٍ
u'غير مَاءٌ':Added, #1: 1	غَيْرَ مَاءٍ
u'غَيْرٌ مَاءٌ':Added, #27: 27	غَيْرِ الْمَاءِ
u'غير مَاءٌ':Added, #27: 27	غَيْرِ الْمَاءِ
u'غَيْرٌ مَاءٌ':Added, #2: 2	غَيْرَ مَاءِ
u'غير مَاءٌ':Added, #2: 2	غَيْرَ مَاءِ
u'غَيْرٌ مَاءٌ':Added, #5: 5	غَيْرِ مَاءِ
u'غير مَاءٌ':Added, #5: 5	غَيْرِ مَاءِ
u'غَيْرٌ مَاءٌ':Added, #9: 9	غَيْرَ الْمَاءِ
u'غير مازِح':Added, #9: 9	غَيْرَ الْمَاءِ
u'غَيْرٌ مازِح':Added, #1: 1	غَيْرُ مَازِحٍ
u'غير مَاشِي':Added, #1: 1	غَيْرُ مَازِحٍ
u'غَيْرٌ مَاشِي':Added, #2: 2	غَيْرُ الْمَاشِيَةِ
u'غير مَاشِي':Added, #2: 2	غَيْرُ الْمَاشِيَةِ
u'غَيْرٌ مَاشِي':Added, #4: 4	غَيْرِ الْمَاشِيَةِ
u'غير مَاشِيَةٌ':Added, #4: 4	غَيْرِ الْمَاشِيَةِ
u'غَيْرٌ مَاشِيَةٌ':Added, #2: 2	غَيْرُ الْمَاشِيَةِ
u'غير مَاشِيَةٌ':Added, #2: 2	غَيْرُ الْمَاشِيَةِ
u'غَيْرٌ مَاشِيَةٌ':Added, #4: 4	غَيْرِ الْمَاشِيَةِ
u'غير مَاعِزٌ':Added, #4: 4	غَيْرِ الْمَاشِيَةِ
u'غَيْرٌ مَاعِزٌ':Added, #1: 1	غَيْرِ مَاعِزٍ
u'غير مَأْكُولٌ':Added, #1: 1	غَيْرِ مَاعِزٍ
u'غَيْرٌ مَأْكُولٌ':Added, #11: 11	غَيْرِ مَأْكُولٍ
u'غير مَأْكُولٌ':Added, #11: 11	غَيْرِ مَأْكُولٍ
u'غَيْرٌ مَأْكُولٌ':Added, #12: 12	غَيْرَ مَأْكُولٍ
u'غير مَأْكُولٌ':Added, #12: 12	غَيْرَ مَأْكُولٍ
u'غَيْرٌ مَأْكُولٌ':Added, #19: 19	غَيْرُ مَأْكُولٍ
u'غير مَأْكُولٌ':Added, #19: 19	غَيْرُ مَأْكُولٍ
u'غَيْرٌ مَأْكُولٌ':Added, #1: 1	غَيْرُ الْمَأْكُولَاتِ
u'غير مَأْكُولٌ':Added, #1: 1	غَيْرُ الْمَأْكُولَاتِ
u'غير مَأْكُولٌ':Added, #1: 1	غَيْرُ الْمَأْكُولَةِ
u'غَيْرٌ مَأْكُولٌ':Added, #1: 1	غَيْرِ الْمَأْكُولَةِ
u'غَيْرٌ مَأْكُولٌ':Added, #1: 1	غَيْرُ الْمَأْكُولَةِ
u'غير مَأْكُولٌ':Added, #1: 1	غَيْرِ الْمَأْكُولَةِ
u'غير مَأْكُولٌ':Added, #1: 1	غَيْر مَأْكُولَةٍ
u'غير مَأْكُولٌ':Added, #1: 1	غَيْرَ مَأْكُولَةٍ
u'غَيْرٌ مَأْكُولٌ':Added, #1: 1	غَيْرُ مَأْكُولَةِ
u'غَيْرٌ مَأْكُولٌ':Added, #1: 1	غَيْر مَأْكُولَةٍ
u'غَيْرٌ مَأْكُولٌ':Added, #1: 1	غَيْرَ مَأْكُولَةٍ
u'غير مَأْكُولٌ':Added, #1: 1	غَيْرُ مَأْكُولَةِ
u'غَيْرٌ مَأْكُولٌ':Added, #1: 1	غَيْرِ مَأْكُولَيْنِ
u'غير مَأْكُولٌ':Added, #1: 1	غَيْرِ مَأْكُولَيْنِ
u'غَيْرٌ مَأْكُولٌ':Added, #25: 25	غَيْرِ الْمَأْكُولِ
u'غير مَأْكُولٌ':Added, #25: 25	غَيْرِ الْمَأْكُولِ
u'غير مَأْكُولٌ':Added, #2: 2	غَيْرَ الْمَأْكُولِ
u'غَيْرٌ مَأْكُولٌ':Added, #2: 2	غَيْرُ الْمَأْكُولِ
u'غَيْرٌ مَأْكُولٌ':Added, #2: 2	غَيْرَ الْمَأْكُولِ
u'غير مَأْكُولٌ':Added, #2: 2	غَيْرُ الْمَأْكُولِ
u'غَيْرٌ مَأْكُولٌ':Added, #3: 3	غَيْرَ مَأْكُولَةِ
u'غير مَأْكُولٌ':Added, #3: 3	غَيْرَ مَأْكُولَةِ
u'غَيْرٌ مَأْكُولٌ':Added, #4: 4	غَيْرُ مَأْكُولَةٍ
u'غير مَأْكُولٌ':Added, #4: 4	غَيْرُ مَأْكُولَةٍ
u'غير مَأْكُولٌ':Added, #5: 5	غَيْرُ مَأْكُولِ
u'غَيْرٌ مَأْكُولٌ':Added, #5: 5	غَيْرِ مَأْكُولِ
u'غَيْرٌ مَأْكُولٌ':Added, #5: 5	غَيْرُ مَأْكُولِ
u'غير مَأْكُولٌ':Added, #5: 5	غَيْرِ مَأْكُولِ
u'غَيْرٌ مَأْكُولٌ':Added, #7: 7	غَيْرَ مَأْكُولِ
u'غير مَالٌ':Added, #7: 7	غَيْرَ مَأْكُولِ
u'غَيْرٌ مَالٌ':Added, #13: 13	غَيْرَ مَالٍ
u'غير مَالٌ':Added, #13: 13	غَيْرَ مَالٍ
u'غَيْرٌ مَالٌ':Added, #18: 18	غَيْرِ مَالِ
u'غير مَالٌ':Added, #18: 18	غَيْرِ مَالِ
u'غَيْرٌ مَالٌ':Added, #1: 1	غَيْرَ الْمَالِ
u'غير مَالٌ':Added, #1: 1	غَيْرَ الْمَالِ
u'غَيْرٌ مَالٌ':Added, #20: 20	غَيْرِ الْمَالِ
u'غير مَالٌ':Added, #20: 20	غَيْرِ الْمَالِ
u'غَيْرٌ مَالٌ':Added, #29: 29	غَيْرِ مَالٍ
u'غير مَالٌ':Added, #29: 29	غَيْرِ مَالٍ
u'غير مَالٌ':Added, #2: 2	غَيْرَ مَالِ
u'غَيْرٌ مَالٌ':Added, #2: 2	غَيْرُ مَالٍ
u'غَيْرٌ مَالٌ':Added, #2: 2	غَيْرَ مَالِ
u'غير مَالٌ':Added, #2: 2	غَيْرُ مَالٍ
u'غَيْرٌ مَالٌ':Added, #3: 3	غَيْرُ مَالِ
u'غير مَالٌ':Added, #3: 3	غَيْرُ مَالِ
u'غَيْرٌ مَالٌ':Added, #4: 4	غَيْرِ مَالِهِ
u'غير مَالٌ':Added, #4: 4	غَيْرِ مَالِهِ
u'غَيْرٌ مَالٌ':Added, #5: 5	غَيْرُ الْمَالِ
u'غير مالِك':Added, #5: 5	غَيْرُ الْمَالِ
u'غَيْرٌ مالِك':Added, #1: 1	غَيْرِ الْمَالِكِيَّةِ
u'غير مَالِكٌ':Added, #1: 1	غَيْرِ الْمَالِكِيَّةِ
u'غَيْرٌ مَالِكٌ':Added, #1: 1	غَيْرُ مَالِكِ
u'غير مَالِكٌ':Added, #1: 1	غَيْرُ مَالِكِ
u'غَيْرٌ مَالِكٌ':Added, #1: 1	غَيْرَ مَالِكِهِ
u'غير مَالِكٌ':Added, #1: 1	غَيْرَ مَالِكِهِ
u'غَيْرٌ مَالِكٌ':Added, #27: 27	غَيْرِ الْمَالِكِ
u'غير مَالِكٌ':Added, #27: 27	غَيْرِ الْمَالِكِ
u'غَيْرٌ مَالِكٌ':Added, #35: 35	غَيْرُ مَالِكٍ
u'غير مَالِكٌ':Added, #35: 35	غَيْرُ مَالِكٍ
u'غَيْرٌ مَالِكٌ':Added, #3: 3	غَيْرِ مَالِكِ
u'غير مَالِكٌ':Added, #3: 3	غَيْرِ مَالِكِ
u'غَيْرٌ مَالِكٌ':Added, #4: 4	غَيْرِ مَالِكِهِ
u'غير مَالِكٌ':Added, #4: 4	غَيْرِ مَالِكِهِ
u'غير مَالِكٌ':Added, #6: 6	غَيْرَ الْمَالِكِ
u'غَيْرٌ مَالِكٌ':Added, #6: 6	غَيْرُ الْمَالِكِ
u'غَيْرٌ مَالِكٌ':Added, #6: 6	غَيْرَ الْمَالِكِ
u'غير مَالِكٌ':Added, #6: 6	غَيْرُ الْمَالِكِ
u'غَيْرٌ مَالِكٌ':Added, #8: 8	غَيْرَ مَالِكٍ
u'غير مَالِكٌ':Added, #8: 8	غَيْرَ مَالِكٍ
u'غَيْرٌ مَالِكٌ':Added, #9: 9	غَيْرِ مَالِكٍ
u'غير مالِكِيّ':Added, #9: 9	غَيْرِ مَالِكٍ
u'غَيْرٌ مالِكِيّ':Added, #1: 1	غَيْرِ الْمَالِكِيَّةِ
u'غير مَأْلُوفٌ':Added, #1: 1	غَيْرِ الْمَالِكِيَّةِ
u'غَيْرٌ مَأْلُوفٌ':Added, #1: 1	غَيْرَ الْمَأْلُوفِ
u'غير مَأْلُوفٌ':Added, #1: 1	غَيْرَ الْمَأْلُوفِ
u'غَيْرٌ مَأْلُوفٌ':Added, #1: 1	غَيْرُ مَأْلُوفٍ
u'غير مَأْلُوفٌ':Added, #1: 1	غَيْرُ مَأْلُوفٍ
u'غَيْرٌ مَأْلُوفٌ':Added, #1: 1	غَيْرُ مَأْلُوفَةٍ
u'غير مَأْلُوفٌ':Added, #1: 1	غَيْرُ مَأْلُوفَةٍ
u'غَيْرٌ مَأْلُوفٌ':Added, #2: 2	غَيْرِ مَأْلُوفٍ
u'غير مَالِيٌّ':Added, #2: 2	غَيْرِ مَأْلُوفٍ
u'غير مَالِيٌّ':Added, #1: 1	غَيْرَ الْمَالِيَّةِ
u'غَيْرٌ مَالِيٌّ':Added, #1: 1	غَيْرِ الْمَالِيَّةِ
u'غَيْرٌ مَالِيٌّ':Added, #1: 1	غَيْرَ الْمَالِيَّةِ
u'غير مَالِيٌّ':Added, #1: 1	غَيْرِ الْمَالِيَّةِ
u'غَيْرٌ مَالِيٌّ':Added, #1: 1	غَيْرِ مَالِيَّةٍ
u'غير مَالِيٌّ':Added, #1: 1	غَيْرِ مَالِيَّةٍ
u'غَيْرٌ مَالِيٌّ':Added, #2: 2	غَيْرُ الْمَالِيَّةِ
u'غير مَالِيٌّ':Added, #2: 2	غَيْرُ الْمَالِيَّةِ
u'غَيْرٌ مَالِيٌّ':Added, #2: 2	غَيْرُ مَالِيٍّ
u'غير مَالِيٌّ':Added, #2: 2	غَيْرُ مَالِيٍّ
u'غير مَالِيٌّ':Added, #3: 3	غَيْرَ مَالِيٍّ
u'غَيْرٌ مَالِيٌّ':Added, #3: 3	غَيْرِ مَالِيٍّ
u'غَيْرٌ مَالِيٌّ':Added, #3: 3	غَيْرَ مَالِيٍّ
u'غير مَأْمَنٌ':Added, #3: 3	غَيْرِ مَالِيٍّ
u'غَيْرٌ مَأْمَنٌ':Added, #1: 1	غَيْرِ مَأْمَنٍ
u'غير مَأْمُورٌ':Added, #1: 1	غَيْرِ مَأْمَنٍ
u'غَيْرٌ مَأْمُورٌ':Added, #1: 1	غَيْرُ مَأْمُورَةٍ
u'غير مَأْمُورٌ':Added, #1: 1	غَيْرُ مَأْمُورَةٍ
u'غَيْرٌ مَأْمُورٌ':Added, #21: 21	غَيْرُ مَأْمُورٍ
u'غير مَأْمُورٌ':Added, #21: 21	غَيْرُ مَأْمُورٍ
u'غَيْرٌ مَأْمُورٌ':Added, #2: 2	غَيْرِ مَأْمُورٍ
u'غير مَأْمُورٌ':Added, #2: 2	غَيْرِ مَأْمُورٍ
u'غَيْرٌ مَأْمُورٌ':Added, #3: 3	غَيْرَ مَأْمُورٍ
u'غير مَأْمُورٌ':Added, #3: 3	غَيْرَ مَأْمُورٍ
u'غَيْرٌ مَأْمُورٌ':Added, #4: 4	غَيْرِ الْمَأْمُورِ
u'غير مَأْمُونٌ':Added, #4: 4	غَيْرِ الْمَأْمُورِ
u'غَيْرٌ مَأْمُونٌ':Added, #10: 10	غَيْرُ مَأْمُونٍ
u'غير مَأْمُونٌ':Added, #10: 10	غَيْرُ مَأْمُونٍ
u'غَيْرٌ مَأْمُونٌ':Added, #19: 19	غَيْرَ مَأْمُونٍ
u'غير مَأْمُونٌ':Added, #19: 19	غَيْرَ مَأْمُونٍ
u'غَيْرٌ مَأْمُونٌ':Added, #1: 1	غَيْرُ الْمَأْمُونَةِ
u'غير مَأْمُونٌ':Added, #1: 1	غَيْرُ الْمَأْمُونَةِ
u'غَيْرٌ مَأْمُونٌ':Added, #1: 1	غَيْرِ مَأْمُونِ
u'غير مَأْمُونٌ':Added, #1: 1	غَيْرِ مَأْمُونِ
u'غير مَأْمُونٌ':Added, #1: 1	غَيْرُ مَأْمُونَةِ
u'غير مَأْمُونٌ':Added, #1: 1	غَيْرِ مَأْمُونَةٍ
u'غَيْرٌ مَأْمُونٌ':Added, #1: 1	غَيْرِ مَأْمُونَةِ
u'غَيْرٌ مَأْمُونٌ':Added, #1: 1	غَيْرُ مَأْمُونَةِ
u'غَيْرٌ مَأْمُونٌ':Added, #1: 1	غَيْرِ مَأْمُونَةٍ
u'غير مَأْمُونٌ':Added, #1: 1	غَيْرِ مَأْمُونَةِ
u'غَيْرٌ مَأْمُونٌ':Added, #3: 3	غَيْرُ مَأْمُونَةٍ
u'غير مَأْمُونٌ':Added, #3: 3	غَيْرُ مَأْمُونَةٍ
u'غَيْرٌ مَأْمُونٌ':Added, #4: 4	غَيْرِ الْمَأْمُونَةِ
u'غير مَأْمُونٌ':Added, #4: 4	غَيْرِ الْمَأْمُونَةِ
u'غَيْرٌ مَأْمُونٌ':Added, #4: 4	غَيْرِ مَأْمُونٍ
u'غير مَأْمُونٌ':Added, #4: 4	غَيْرِ مَأْمُونٍ
u'غَيْرٌ مَأْمُونٌ':Added, #4: 4	غَيْرَ مَأْمُونَةٍ
u'غير مَانِعٌ':Added, #4: 4	غَيْرَ مَأْمُونَةٍ
u'غَيْرٌ مَانِعٌ':Added, #12: 12	غَيْرَ مَانِعٍ
u'غير مَانِعٌ':Added, #12: 12	غَيْرَ مَانِعٍ
u'غَيْرٌ مَانِعٌ':Added, #13: 13	غَيْرِ مَانِعٍ
u'غير مَانِعٌ':Added, #13: 13	غَيْرِ مَانِعٍ
u'غَيْرٌ مَانِعٌ':Added, #13: 13	غَيْرُ مَانِعَةٍ
u'غير مَانِعٌ':Added, #13: 13	غَيْرُ مَانِعَةٍ
u'غَيْرٌ مَانِعٌ':Added, #1: 1	غَيْرُ الْمَانِعِ
u'غير مَانِعٌ':Added, #1: 1	غَيْرُ الْمَانِعِ
u'غَيْرٌ مَانِعٌ':Added, #1: 1	غَيْرِ مَانِعِ
u'غير مَانِعٌ':Added, #1: 1	غَيْرِ مَانِعِ
u'غَيْرٌ مَانِعٌ':Added, #1: 1	غَيْرِ مَانِعَةٍ
u'غير مَانِعٌ':Added, #1: 1	غَيْرِ مَانِعَةٍ
u'غَيْرٌ مَانِعٌ':Added, #4: 4	غَيْرَ مَانِعَةٍ
u'غير مَانِعٌ':Added, #4: 4	غَيْرَ مَانِعَةٍ
u'غَيْرٌ مَانِعٌ':Added, #70: 70	غَيْرُ مَانِعٍ
u'غير مَأْهُولٌ':Added, #70: 70	غَيْرُ مَانِعٍ
u'غَيْرٌ مَأْهُولٌ':Added, #1: 1	غَيْرِ الْمَأْهُولِ
u'غير مَائِعٌ':Added, #1: 1	غَيْرِ الْمَأْهُولِ
u'غَيْرٌ مَائِعٌ':Added, #1: 1	غَيْرَ الْمَائِعِ
u'غير مَائِعٌ':Added, #1: 1	غَيْرَ الْمَائِعِ
u'غَيْرٌ مَائِعٌ':Added, #1: 1	غَيْرِ الْمَائِعَاتِ
u'غير مَائِعٌ':Added, #1: 1	غَيْرِ الْمَائِعَاتِ
u'غير مَائِعٌ':Added, #2: 2	غَيْرَ مَائِعٍ
u'غَيْرٌ مَائِعٌ':Added, #2: 2	غَيْرِ مَائِعٍ
u'غَيْرٌ مَائِعٌ':Added, #2: 2	غَيْرَ مَائِعٍ
u'غير مَائِلٌ':Added, #2: 2	غَيْرِ مَائِعٍ
u'غَيْرٌ مَائِلٌ':Added, #1: 1	غَيْرِ الْمَائِلِ
u'غير مَائِلٌ':Added, #1: 1	غَيْرِ الْمَائِلِ
u'غير مَائِلٌ':Added, #1: 1	غَيْرُ مَائِلٍ
u'غَيْرٌ مَائِلٌ':Added, #1: 1	غَيْرِ مَائِلٍ
u'غَيْرٌ مَائِلٌ':Added, #1: 1	غَيْرُ مَائِلٍ
u'غير مَائِلٌ':Added, #1: 1	غَيْرِ مَائِلٍ
u'غَيْرٌ مَائِلٌ':Added, #3: 3	غَيْرَ مَائِلٍ
u'غير مَائِيُّ':Added, #3: 3	غَيْرَ مَائِلٍ
u'غَيْرٌ مَائِيُّ':Added, #2: 2	غَيْرُ الْمَائِيِّ
u'غير مُبَاحٌ':Added, #2: 2	غَيْرُ الْمَائِيِّ
u'غَيْرٌ مُبَاحٌ':Added, #12: 12	غَيْرُ مُبَاحٍ
u'غير مُبَاحٌ':Added, #12: 12	غَيْرُ مُبَاحٍ
u'غَيْرٌ مُبَاحٌ':Added, #1: 1	غَيْرَ الْمُبَاحِ
u'غير مُبَاحٌ':Added, #1: 1	غَيْرَ الْمُبَاحِ
u'غير مُبَاحٌ':Added, #1: 1	غَيْرَ مُبَاحِ
u'غَيْرٌ مُبَاحٌ':Added, #1: 1	غَيْرُ مُبَاحِ
u'غَيْرٌ مُبَاحٌ':Added, #1: 1	غَيْرَ مُبَاحِ
u'غير مُبَاحٌ':Added, #1: 1	غَيْرُ مُبَاحِ
u'غَيْرٌ مُبَاحٌ':Added, #1: 1	غَيْرِ مُبَاحَةٍ
u'غير مُبَاحٌ':Added, #1: 1	غَيْرِ مُبَاحَةٍ
u'غَيْرٌ مُبَاحٌ':Added, #2: 2	غَيْرُ مُبَاحَةٍ
u'غير مُبَاحٌ':Added, #2: 2	غَيْرُ مُبَاحَةٍ
u'غَيْرٌ مُبَاحٌ':Added, #3: 3	غَيْرُ الْمُبَاحِ
u'غير مُبَاحٌ':Added, #3: 3	غَيْرُ الْمُبَاحِ
u'غَيْرٌ مُبَاحٌ':Added, #3: 3	غَيْرَ مُبَاحٍ
u'غير مُبَاحٌ':Added, #3: 3	غَيْرَ مُبَاحٍ
u'غَيْرٌ مُبَاحٌ':Added, #4: 4	غَيْرِ الْمُبَاحِ
u'غير مُبَاحٌ':Added, #4: 4	غَيْرِ الْمُبَاحِ
u'غَيْرٌ مُبَاحٌ':Added, #5: 5	غَيْرَ مُبَاحَةٍ
u'غير مُبَادَرَةٌ':Added, #5: 5	غَيْرَ مُبَاحَةٍ
u'غَيْرٌ مُبَادَرَةٌ':Added, #1: 1	غَيْرَ الْمُبَادَرَةِ
u'غير مُبَادَرَةٌ':Added, #1: 1	غَيْرَ الْمُبَادَرَةِ
u'غَيْرٌ مُبَادَرَةٌ':Added, #1: 1	غَيْرِ مُبَادَرَةٍ
u'غير مُبَادَلَةٌ':Added, #1: 1	غَيْرِ مُبَادَرَةٍ
u'غَيْرٌ مُبَادَلَةٌ':Added, #1: 1	غَيْرِ مُبَادَلَةٍ
u'غير مَبَادِئُ':Added, #1: 1	غَيْرِ مُبَادَلَةٍ
u'غَيْرٌ مَبَادِئُ':Added, #1: 1	غَيْرِ مَبَادِئِ
u'غير مُبَاشِرٌ':Added, #1: 1	غَيْرِ مَبَادِئِ
u'غَيْرٌ مُبَاشِرٌ':Added, #1: 1	غَيْرُ مُبَاشِرٍ
u'غير مُبَاشِرٌ':Added, #1: 1	غَيْرُ مُبَاشِرٍ
u'غَيْرٌ مُبَاشِرٌ':Added, #2: 2	غَيْرُ مُبَاشِرَيْنِ
u'غير مُبَاشَرَةٌ':Added, #2: 2	غَيْرُ مُبَاشِرَيْنِ
u'غَيْرٌ مُبَاشَرَةٌ':Added, #1: 1	غَيْرُ الْمُبَاشَرَةِ
u'غير مُبَاشَرَةٌ':Added, #1: 1	غَيْرُ الْمُبَاشَرَةِ
u'غَيْرٌ مُبَاشَرَةٌ':Added, #1: 1	غَيْرِ مُبَاشَرَةِ
u'غير مُبَاشَرَةٌ':Added, #1: 1	غَيْرِ مُبَاشَرَةِ
u'غَيْرٌ مُبَاشَرَةٌ':Added, #2: 2	غَيْرِ مُبَاشَرَةٍ
u'غير مُبَالاَةٌ':Added, #2: 2	غَيْرِ مُبَاشَرَةٍ
u'غَيْرٌ مُبَالاَةٌ':Added, #1: 1	غَيْرِ مُبَالَاةٍ
u'غير مُبَالَغَةٌ':Added, #1: 1	غَيْرِ مُبَالَاةٍ
u'غَيْرٌ مُبَالَغَةٌ':Added, #1: 1	غَيْرِ مُبَالَغَةٍ
u'غير مُبْتاع':Added, #1: 1	غَيْرِ مُبَالَغَةٍ
u'غَيْرٌ مُبْتاع':Added, #1: 1	غَيْرُ الْمُبْتَاعِ
u'غير مُبْتَدَأٌ':Added, #1: 1	غَيْرُ الْمُبْتَاعِ
u'غَيْرٌ مُبْتَدَأٌ':Added, #1: 1	غَيْرِ الْمُبْتَدَأِ
u'غير مُبْتَدِعٌ':Added, #1: 1	غَيْرِ الْمُبْتَدَأِ
u'غَيْرٌ مُبْتَدِعٌ':Added, #1: 1	غَيْرِ الْمُبْتَدِعِ
u'غير مُبتدَعٌ':Added, #1: 1	غَيْرِ الْمُبْتَدِعِ
u'غَيْرٌ مُبتدَعٌ':Added, #1: 1	غَيْرُ مُبْتَدَعٍ
u'غير مُبْتَدِعٌ':Added, #1: 1	غَيْرُ مُبْتَدَعٍ
u'غَيْرٌ مُبْتَدِعٌ':Added, #1: 1	غَيْرُ مُبْتَدِعٍ
u'غير مُبْتَدِئٌ':Added, #1: 1	غَيْرُ مُبْتَدِعٍ
u'غَيْرٌ مُبْتَدِئٌ':Added, #1: 1	غَيْرُ مُبْتَدِئٍ
u'غير مُبْتَذَلٌ':Added, #1: 1	غَيْرُ مُبْتَدِئٍ
u'غَيْرٌ مُبْتَذَلٌ':Added, #1: 1	غَيْر مُبْتَذَلٍ
u'غير مُبْتَذَلٌ':Added, #1: 1	غَيْر مُبْتَذَلٍ
u'غَيْرٌ مُبْتَذَلٌ':Added, #2: 2	غَيْرُ مُبْتَذَلٍ
u'غير مُبْتَلٌّ':Added, #2: 2	غَيْرُ مُبْتَذَلٍ
u'غَيْرٌ مُبْتَلٌّ':Added, #1: 1	غَيْرَ مُبْتَلٍّ
u'غير مَبْتُوت':Added, #1: 1	غَيْرَ مُبْتَلٍّ
u'غَيْرٌ مَبْتُوت':Added, #1: 1	غَيْرِ الْمَبْتُوتَةِ
u'غير مُبَدِّلٌ':Added, #1: 1	غَيْرِ الْمَبْتُوتَةِ
u'غَيْرٌ مُبَدِّلٌ':Added, #1: 1	غَيْرَ مُبَدِّلٍ
u'غير مُبَرِّحٌ':Added, #1: 1	غَيْرَ مُبَدِّلٍ
u'غَيْرٌ مُبَرِّحٌ':Added, #1: 1	غَيْرُ الْمُبَرِّحِ
u'غير مُبَرِّحٌ':Added, #1: 1	غَيْرُ الْمُبَرِّحِ
u'غير مُبَرِّحٌ':Added, #1: 1	غَيْر مُبَرِّحٍ
u'غير مُبَرِّحٌ':Added, #1: 1	غَيْرَ مُبَرّحٍ
u'غَيْرٌ مُبَرِّحٌ':Added, #1: 1	غَيْرُ مُبَرِّحٍ
u'غَيْرٌ مُبَرِّحٌ':Added, #1: 1	غَيْر مُبَرِّحٍ
u'غَيْرٌ مُبَرِّحٌ':Added, #1: 1	غَيْرَ مُبَرّحٍ
u'غير مُبَرِّحٌ':Added, #1: 1	غَيْرُ مُبَرِّحٍ
u'غَيْرٌ مُبَرِّحٌ':Added, #21: 21	غَيْرَ مُبَرِّحٍ
u'غير مَبْرِيٌّ':Added, #21: 21	غَيْرَ مُبَرِّحٍ
u'غَيْرٌ مَبْرِيٌّ':Added, #1: 1	غَيْرَ الْمَبْرِيِّ
u'غير مُبْرِئٌ':Added, #1: 1	غَيْرَ الْمَبْرِيِّ
u'غَيْرٌ مُبْرِئٌ':Added, #2: 2	غَيْرُ مُبْرِئَةٍ
u'غير مَبْسُوطٌ':Added, #2: 2	غَيْرُ مُبْرِئَةٍ
u'غَيْرٌ مَبْسُوطٌ':Added, #1: 1	غَيْرِ الْمَبْسُوطِ
u'غير مُبَشِّرٌ':Added, #1: 1	غَيْرِ الْمَبْسُوطِ
u'غَيْرٌ مُبَشِّرٌ':Added, #2: 2	غَيْرُ مُبَشِّرِ
u'غير مُبْصِرٌ':Added, #2: 2	غَيْرُ مُبَشِّرِ
u'غَيْرٌ مُبْصِرٌ':Added, #1: 1	غَيْرِ مُبْصِرٍ
u'غير مُبْطِلٌ':Added, #1: 1	غَيْرِ مُبْصِرٍ
u'غَيْرٌ مُبْطِلٌ':Added, #12: 12	غَيْرُ مُبْطِلٍ
u'غير مُبْطِلٌ':Added, #12: 12	غَيْرُ مُبْطِلٍ
u'غَيْرٌ مُبْطِلٌ':Added, #3: 3	غَيْرِ مُبْطِلٍ
u'غير مَبْعُوثٌ':Added, #3: 3	غَيْرِ مُبْطِلٍ
u'غَيْرٌ مَبْعُوثٌ':Added, #1: 1	غَيْرُ مَبْعُوثٍ
u'غير مُبَلَّطٌ':Added, #1: 1	غَيْرُ مَبْعُوثٍ
u'غَيْرٌ مُبَلَّطٌ':Added, #2: 2	غَيْرِ مُبَلَّطٍ
u'غير مَبْلُول':Added, #2: 2	غَيْرِ مُبَلَّطٍ
u'غَيْرٌ مَبْلُول':Added, #1: 1	غَيْرَ مَبْلُولٍ
u'غير مَبْنِيٌّ':Added, #1: 1	غَيْرَ مَبْلُولٍ
u'غَيْرٌ مَبْنِيٌّ':Added, #12: 12	غَيْرُ مَبْنِيٍّ
u'غير مَبْنِيٌّ':Added, #12: 12	غَيْرُ مَبْنِيٍّ
u'غَيْرٌ مَبْنِيٌّ':Added, #1: 1	غَيْرِ الْمَبْنِيِّ
u'غير مَبْنِيٌّ':Added, #1: 1	غَيْرِ الْمَبْنِيِّ
u'غَيْرٌ مَبْنِيٌّ':Added, #1: 1	غَيْرِ مَبْنِيَّةٍ
u'غير مَبْنِيٌّ':Added, #1: 1	غَيْرِ مَبْنِيَّةٍ
u'غَيْرٌ مَبْنِيٌّ':Added, #2: 2	غَيْرَ مَبْنِيَّةٍ
u'غير مَبْنِيٌّ':Added, #2: 2	غَيْرَ مَبْنِيَّةٍ
u'غَيْرٌ مَبْنِيٌّ':Added, #4: 4	غَيْرَ مَبْنِيٍّ
u'غير مَبْنِيٌّ':Added, #4: 4	غَيْرَ مَبْنِيٍّ
u'غَيْرٌ مَبْنِيٌّ':Added, #5: 5	غَيْرُ مَبْنِيَّةٍ
u'غير مُبْهَمٌ':Added, #5: 5	غَيْرُ مَبْنِيَّةٍ
u'غير مُبْهَمٌ':Added, #1: 1	غَيْرُ مُبْهَمٍ
u'غَيْرٌ مُبْهَمٌ':Added, #1: 1	غَيْرِ مُبْهَمٍ
u'غَيْرٌ مُبْهَمٌ':Added, #1: 1	غَيْرُ مُبْهَمٍ
u'غير مُبِيحٌ':Added, #1: 1	غَيْرِ مُبْهَمٍ
u'غَيْرٌ مُبِيحٌ':Added, #1: 1	غَيْرُ مُبِيحٍ
u'غير مُبِيحٌ':Added, #1: 1	غَيْرُ مُبِيحٍ
u'غَيْرٌ مُبِيحٌ':Added, #2: 2	غَيْرِ مُبِيحٍ
u'غير مَبِيعٌ':Added, #2: 2	غَيْرِ مُبِيحٍ
u'غَيْرٌ مَبِيعٌ':Added, #18: 18	غَيْرِ الْمَبِيعِ
u'غير مَبِيعٌ':Added, #18: 18	غَيْرِ الْمَبِيعِ
u'غَيْرٌ مَبِيعٌ':Added, #1: 1	غَيْر الْمَبِيعِ
u'غير مَبِيعٌ':Added, #1: 1	غَيْر الْمَبِيعِ
u'غَيْرٌ مَبِيعٌ':Added, #1: 1	غَيْر مَبِيعٍ
u'غير مَبِيعٌ':Added, #1: 1	غَيْر مَبِيعٍ
u'غَيْرٌ مَبِيعٌ':Added, #1: 1	غَيْرُ مَبِيعَةٍ
u'غير مَبِيعٌ':Added, #1: 1	غَيْرُ مَبِيعَةٍ
u'غَيْرٌ مَبِيعٌ':Added, #2: 2	غَيْرُ الْمَبِيعِ
u'غير مَبِيعٌ':Added, #2: 2	غَيْرُ الْمَبِيعِ
u'غَيْرٌ مَبِيعٌ':Added, #4: 4	غَيْرَ الْمَبِيعِ
u'غير مُبَيَّنٌ':Added, #4: 4	غَيْرَ الْمَبِيعِ
u'غَيْرٌ مُبَيَّنٌ':Added, #1: 1	غَيْرُ مُبَيّنٍ
u'غير مُبَيَّنٌ':Added, #1: 1	غَيْرُ مُبَيّنٍ
u'غَيْرٌ مُبَيَّنٌ':Added, #1: 1	غَيْرَ مُبَيَّنَاتٍ
u'غير مُبِينٌ':Added, #1: 1	غَيْرَ مُبَيَّنَاتٍ
u'غَيْرٌ مُبِينٌ':Added, #2: 2	غَيْرُ مُبِينٍ
u'غير مُبَيَّنٌ':Added, #2: 2	غَيْرُ مُبِينٍ
u'غَيْرٌ مُبَيَّنٌ':Added, #3: 3	غَيْرَ مُبَيَّنٍ
u'غير مُبَيَّنٌ':Added, #3: 3	غَيْرَ مُبَيَّنٍ
u'غَيْرٌ مُبَيَّنٌ':Added, #4: 4	غَيْرُ مُبَيَّنٍ
u'غير مُتَأَخِّرٌ':Added, #4: 4	غَيْرُ مُبَيَّنٍ
u'غَيْرٌ مُتَأَخِّرٌ':Added, #1: 1	غَيْرِ الْمُتَأَخِّرِ
u'غير مُتارَكَة':Added, #1: 1	غَيْرِ الْمُتَأَخِّرِ
u'غَيْرٌ مُتارَكَة':Added, #1: 1	غَيْرِ مُتَارَكَةٍ
u'غير مُتارَكَة':Added, #1: 1	غَيْرِ مُتَارَكَةٍ
u'غَيْرٌ مُتارَكَة':Added, #2: 2	غَيْرِ الْمُتَارَكَةِ
u'غير مُتَأَصِّلٌ':Added, #2: 2	غَيْرِ الْمُتَارَكَةِ
u'غَيْرٌ مُتَأَصِّلٌ':Added, #1: 1	غَيْرُ مُتَأَصِّلَةٍ
u'غير مَتَاعٌ':Added, #1: 1	غَيْرُ مُتَأَصِّلَةٍ
u'غير مَتَاعٌ':Added, #1: 1	غَيْرَ مَتَاعِ
u'غَيْرٌ مَتَاعٌ':Added, #1: 1	غَيْرِ مَتَاعِ
u'غَيْرٌ مَتَاعٌ':Added, #1: 1	غَيْرَ مَتَاعِ
u'غير مُتَأَكِّدٌ':Added, #1: 1	غَيْرِ مَتَاعِ
u'غَيْرٌ مُتَأَكِّدٌ':Added, #1: 1	غَيْرُ الْمُتَأَكِّدِ
u'غير مُتَأَكِّدٌ':Added, #1: 1	غَيْرُ الْمُتَأَكِّدِ
u'غَيْرٌ مُتَأَكِّدٌ':Added, #2: 2	غَيْرَ مُتَأَكِّدٍ
u'غير مُتَأَكِّدٌ':Added, #2: 2	غَيْرَ مُتَأَكِّدٍ
u'غَيْرٌ مُتَأَكِّدٌ':Added, #3: 3	غَيْرِ الْمُتَأَكِّدِ
u'غير مُتَأَكِّدٌ':Added, #3: 3	غَيْرِ الْمُتَأَكِّدِ
u'غَيْرٌ مُتَأَكِّدٌ':Added, #4: 4	غَيْرُ مُتَأَكِّدٍ
u'غير مُتَأَمِّلٌ':Added, #4: 4	غَيْرُ مُتَأَكِّدٍ
u'غَيْرٌ مُتَأَمِّلٌ':Added, #1: 1	غَيْرِ الْمُتَأَمِّلِ
u'غير مُتَأَهِّلٌ':Added, #1: 1	غَيْرِ الْمُتَأَمِّلِ
u'غير مُتَأَهِّلٌ':Added, #1: 1	غَيْرُ مُتَأَهِّلٍ
u'غَيْرٌ مُتَأَهِّلٌ':Added, #1: 1	غَيْرِ مُتَأَهِّلٍ
u'غَيْرٌ مُتَأَهِّلٌ':Added, #1: 1	غَيْرُ مُتَأَهِّلٍ
u'غير مُتَبايِن':Added, #1: 1	غَيْرِ مُتَأَهِّلٍ
u'غَيْرٌ مُتَبايِن':Added, #1: 1	غَيْرُ مُتَبَايِنَةٍ
u'غير مُتَبَحِّرٌ':Added, #1: 1	غَيْرُ مُتَبَايِنَةٍ
u'غَيْرٌ مُتَبَحِّرٌ':Added, #1: 1	غَيْرَ مُتَبَحِّرٍ
u'غير مُتَبَرِّج':Added, #1: 1	غَيْرَ مُتَبَحِّرٍ
u'غَيْرٌ مُتَبَرِّج':Added, #5: 5	غَيْرَ مُتَبَرِّجَاتٍ
u'غير مُتَبَرِّعٌ':Added, #5: 5	غَيْرَ مُتَبَرِّجَاتٍ
u'غَيْرٌ مُتَبَرِّعٌ':Added, #10: 10	غَيْرُ مُتَبَرِّعٍ
u'غير مُتَبَرِّعٌ':Added, #10: 10	غَيْرُ مُتَبَرِّعٍ
u'غَيْرٌ مُتَبَرِّعٌ':Added, #1: 1	غَيْرِ مُتَبَرِّعٍ
u'غير مُتَبَرِّعٌ':Added, #1: 1	غَيْرِ مُتَبَرِّعٍ
u'غَيْرٌ مُتَبَرِّعٌ':Added, #2: 2	غَيْرِ الْمُتَبَرِّعِ
u'غير مُتَبَرِّعٌ':Added, #2: 2	غَيْرِ الْمُتَبَرِّعِ
u'غَيْرٌ مُتَبَرِّعٌ':Added, #6: 6	غَيْرَ مُتَبَرِّعٍ
u'غير مُتَتَابِعٌ':Added, #6: 6	غَيْرَ مُتَبَرِّعٍ
u'غَيْرٌ مُتَتَابِعٌ':Added, #1: 1	غَيْرُ مُتَتَابِعٍ
u'غير مُتَتَابِعٌ':Added, #1: 1	غَيْرُ مُتَتَابِعٍ
u'غَيْرٌ مُتَتَابِعٌ':Added, #3: 3	غَيْرِ الْمُتَتَابِعِ
u'غير مُتَتَبِّع':Added, #3: 3	غَيْرِ الْمُتَتَابِعِ
u'غَيْرٌ مُتَتَبِّع':Added, #1: 1	غَيْرِ الْمُتَتَبِّعِ
u'غير مُتَجَانِسٌ':Added, #1: 1	غَيْرِ الْمُتَتَبِّعِ
u'غير مُتَجَانِسٌ':Added, #1: 1	غَيْرُ مُتَجَانِسَيْنِ
u'غَيْرٌ مُتَجَانِسٌ':Added, #1: 1	غَيْرِ مُتَجَانِسَيْنِ
u'غَيْرٌ مُتَجَانِسٌ':Added, #1: 1	غَيْرُ مُتَجَانِسَيْنِ
u'غير مُتَجَاوِزٌ':Added, #1: 1	غَيْرِ مُتَجَانِسَيْنِ
u'غَيْرٌ مُتَجَاوِزٌ':Added, #1: 1	غَيْرَ مُتَجَاوِزٍ
u'غير مُتَجَاوِزٌ':Added, #1: 1	غَيْرَ مُتَجَاوِزٍ
u'غَيْرٌ مُتَجَاوِزٌ':Added, #2: 2	غَيْرُ مُتَجَاوِزٍ
u'غير مُتَّجَهٌ':Added, #2: 2	غَيْرُ مُتَجَاوِزٍ
u'غَيْرٌ مُتَّجَهٌ':Added, #1: 1	غَيْرَ مُتَّجَهٍ
u'غير مُتَّجِهٌ':Added, #1: 1	غَيْرَ مُتَّجَهٍ
u'غَيْرٌ مُتَّجِهٌ':Added, #2: 2	غَيْرُ مُتَّجِهٍ
u'غير مُتَّجَهٌ':Added, #2: 2	غَيْرُ مُتَّجِهٍ
u'غَيْرٌ مُتَّجَهٌ':Added, #6: 6	غَيْرُ مُتَّجَهٍ
u'غير مُتَحَتِّم':Added, #6: 6	غَيْرُ مُتَّجَهٍ
u'غَيْرٌ مُتَحَتِّم':Added, #1: 1	غَيْرُ مُتَحَتِّمٍ
u'غير مُتَّحِدٌ':Added, #1: 1	غَيْرُ مُتَحَتِّمٍ
u'غير مُتَّحِدٌ':Added, #1: 1	غَيْرُ مُتَّحِدٍ
u'غَيْرٌ مُتَّحِدٌ':Added, #1: 1	غَيْرِ مُتَّحِدِ
u'غَيْرٌ مُتَّحِدٌ':Added, #1: 1	غَيْرُ مُتَّحِدٍ
u'غير مُتَحَرِّكٌ':Added, #1: 1	غَيْرِ مُتَّحِدِ
u'غَيْرٌ مُتَحَرِّكٌ':Added, #1: 1	غَيْرَ مُتَحَرِّكٍ
u'غير مُتَحَقِّق':Added, #1: 1	غَيْرَ مُتَحَرِّكٍ
u'غَيْرٌ مُتَحَقِّق':Added, #18: 18	غَيْرُ مُتَحَقِّقٍ
u'غير مُتَحَقِّق':Added, #18: 18	غَيْرُ مُتَحَقِّقٍ
u'غير مُتَحَقِّق':Added, #1: 1	غَيْرَ مُتَحَقِّقٍ
u'غَيْرٌ مُتَحَقِّق':Added, #1: 1	غَيْرُ مُتَحَقِّقِ
u'غَيْرٌ مُتَحَقِّق':Added, #1: 1	غَيْرَ مُتَحَقِّقٍ
u'غير مُتَحَقِّق':Added, #1: 1	غَيْرُ مُتَحَقِّقِ
u'غَيْرٌ مُتَحَقِّق':Added, #8: 8	غَيْرُ مُتَحَقِّقَةٍ
u'غير مُتَحَيِّرٌ':Added, #8: 8	غَيْرُ مُتَحَقِّقَةٍ
u'غَيْرٌ مُتَحَيِّرٌ':Added, #1: 1	غَيْرِ مُتَحَيِّرَةٍ
u'غير مُتَحَيِّرٌ':Added, #1: 1	غَيْرِ مُتَحَيِّرَةٍ
u'غَيْرٌ مُتَحَيِّرٌ':Added, #3: 3	غَيْرِ الْمُتَحَيِّرَةِ
u'غير مُتَحَيِّزٌ':Added, #3: 3	غَيْرِ الْمُتَحَيِّرَةِ
u'غَيْرٌ مُتَحَيِّزٌ':Added, #1: 1	غَيْرُ مُتَحَيِّزٍ
u'غير مُتَّخَذ':Added, #1: 1	غَيْرُ مُتَحَيِّزٍ
u'غَيْرٌ مُتَّخَذ':Added, #1: 1	غَيْرَ مُتَّخَذَةٍ
u'غير مُتَداعِي':Added, #1: 1	غَيْرَ مُتَّخَذَةٍ
u'غَيْرٌ مُتَداعِي':Added, #1: 1	غَيْرِ الْمُتَدَاعِيَيْنِ
u'غير مُتَرَبِّعٌ':Added, #1: 1	غَيْرِ الْمُتَدَاعِيَيْنِ
u'غَيْرٌ مُتَرَبِّعٌ':Added, #1: 1	غَيْرَ مُتَرَبِّعٍ
u'غير مُتَرَتِّب':Added, #1: 1	غَيْرَ مُتَرَبِّعٍ
u'غَيْرٌ مُتَرَتِّب':Added, #1: 1	غَيْرَ مُتَرَتِّبَةٍ
u'غير مُتَرْجِمٌ':Added, #1: 1	غَيْرَ مُتَرَتِّبَةٍ
u'غَيْرٌ مُتَرْجِمٌ':Added, #1: 1	غَيْرُ الْمُتَرْجِمِ
u'غير مُتَرَدِّدٌ':Added, #1: 1	غَيْرُ الْمُتَرْجِمِ
u'غَيْرٌ مُتَرَدِّدٌ':Added, #1: 1	غَيْرُ مُتَرَدِّدٍ
u'غير مُتَرَدِّدٌ':Added, #1: 1	غَيْرُ مُتَرَدِّدٍ
u'غَيْرٌ مُتَرَدِّدٌ':Added, #2: 2	غَيْرَ مُتَرَدِّدٍ
u'غير مُتَرَصِّدٌ':Added, #2: 2	غَيْرَ مُتَرَدِّدٍ
u'غَيْرٌ مُتَرَصِّدٌ':Added, #1: 1	غَيْرَ الْمُتَرَصِّدِ
u'غير مَتْرُوكٌ':Added, #1: 1	غَيْرَ الْمُتَرَصِّدِ
u'غَيْرٌ مَتْرُوكٌ':Added, #1: 1	غَيْرُ مَتْرُوكِ
u'غير مُتَزَوِّجٌ':Added, #1: 1	غَيْرُ مَتْرُوكِ
u'غير مُتَزَوِّجٌ':Added, #1: 1	غَيْرُ الْمُتَزَوِّجِ
u'غَيْرٌ مُتَزَوِّجٌ':Added, #1: 1	غَيْرِ الْمُتَزَوِّجِ
u'غَيْرٌ مُتَزَوِّجٌ':Added, #1: 1	غَيْرُ الْمُتَزَوِّجِ
u'غير مُتَزَوِّجٌ':Added, #1: 1	غَيْرِ الْمُتَزَوِّجِ
u'غَيْرٌ مُتَزَوِّجٌ':Added, #1: 1	غَيْرِ الْمُتَزَوِّجَةِ
u'غير مُتَزَوِّجٌ':Added, #1: 1	غَيْرِ الْمُتَزَوِّجَةِ
u'غَيْرٌ مُتَزَوِّجٌ':Added, #1: 1	غَيْرُ مُتَزَوِّجٍ
u'غير مُتَزَوِّجٌ':Added, #1: 1	غَيْرُ مُتَزَوِّجٍ
u'غَيْرٌ مُتَزَوِّجٌ':Added, #1: 1	غَيْرِ مُتَزَوِّجَةٍ
u'غير مُتَسابِق':Added, #1: 1	غَيْرِ مُتَزَوِّجَةٍ
u'غَيْرٌ مُتَسابِق':Added, #1: 1	غَيْرَ الْمُتَسَابِقَيْنِ
u'غير مُتَسَارِعٌ':Added, #1: 1	غَيْرَ الْمُتَسَابِقَيْنِ
u'غَيْرٌ مُتَسَارِعٌ':Added, #1: 1	غَيْرَ مُتَسَارِعٍ
u'غير مُتَسَاهِلٌ':Added, #1: 1	غَيْرَ مُتَسَارِعٍ
u'غَيْرٌ مُتَسَاهِلٌ':Added, #2: 2	غَيْرَ مُتَسَاهِلٍ
u'غير مُتَسَاوِي':Added, #2: 2	غَيْرَ مُتَسَاهِلٍ
u'غَيْرٌ مُتَسَاوِي':Added, #1: 1	غَيْرِ الْمُتَسَاوِيَيْنِ
u'غير مُتَسَاوِي':Added, #1: 1	غَيْرِ الْمُتَسَاوِيَيْنِ
u'غَيْرٌ مُتَسَاوِي':Added, #1: 1	غَيْرُ مُتَسَاوِيَةٍ
u'غير مُتَسَاوِي':Added, #1: 1	غَيْرُ مُتَسَاوِيَةٍ
u'غَيْرٌ مُتَسَاوِي':Added, #1: 1	غَيْرُ مُتَسَاوِيَيْنِ
u'غير مُتَّسَعٌ':Added, #1: 1	غَيْرُ مُتَسَاوِيَيْنِ
u'غَيْرٌ مُتَّسَعٌ':Added, #1: 1	غَيْرَ الْمُتَّسَعِ
u'غير مُتَّسَعٌ':Added, #1: 1	غَيْرَ الْمُتَّسَعِ
u'غَيْرٌ مُتَّسَعٌ':Added, #1: 1	غَيْرَ مُتَّسَعَةٍ
u'غير مُتَّسِقٌ':Added, #1: 1	غَيْرَ مُتَّسَعَةٍ
u'غَيْرٌ مُتَّسِقٌ':Added, #1: 1	غَيْرُ مُتَّسِقَةٍ
u'غير مُتَصَرِّفٌ':Added, #1: 1	غَيْرُ مُتَّسِقَةٍ
u'غَيْرٌ مُتَصَرِّفٌ':Added, #1: 1	غَيْرُ الْمُتَصَرِّفِ
u'غير مُتَصَرِّفٌ':Added, #1: 1	غَيْرُ الْمُتَصَرِّفِ
u'غَيْرٌ مُتَصَرِّفٌ':Added, #1: 1	غَيْرُ مُتَصَرِّفٍ
u'غير مُتَصَرِّفٌ':Added, #1: 1	غَيْرُ مُتَصَرِّفٍ
u'غَيْرٌ مُتَصَرِّفٌ':Added, #1: 1	غَيْرُ مُتَصَرِّفَةٍ
u'غير مُتَّصِف':Added, #1: 1	غَيْرُ مُتَصَرِّفَةٍ
u'غَيْرٌ مُتَّصِف':Added, #1: 1	غَيْرُ مُتَّصِفٍ
u'غير مُتَّصِف':Added, #1: 1	غَيْرُ مُتَّصِفٍ
u'غَيْرٌ مُتَّصِف':Added, #2: 2	غَيْرَ مُتَّصِفٍ
u'غير مُتَّصِلٌ':Added, #2: 2	غَيْرَ مُتَّصِفٍ
u'غَيْرٌ مُتَّصِلٌ':Added, #19: 19	غَيْرُ مُتَّصِلٍ
u'غير مُتَّصِلٌ':Added, #19: 19	غَيْرُ مُتَّصِلٍ
u'غَيْرٌ مُتَّصِلٌ':Added, #1: 1	غَيْر مُتَّصِلٍ
u'غير مُتَّصِلٌ':Added, #1: 1	غَيْر مُتَّصِلٍ
u'غَيْرٌ مُتَّصِلٌ':Added, #1: 1	غَيْرُ مُتَّصِلَيْنِ
u'غير مُتَّصِلٌ':Added, #1: 1	غَيْرُ مُتَّصِلَيْنِ
u'غَيْرٌ مُتَّصِلٌ':Added, #2: 2	غَيْرُ مُتَّصِلِ
u'غير مُتَّصِلٌ':Added, #2: 2	غَيْرُ مُتَّصِلِ
u'غَيْرٌ مُتَّصِلٌ':Added, #2: 2	غَيْرَ مُتَّصِلَةٍ
u'غير مُتَّصِلٌ':Added, #2: 2	غَيْرَ مُتَّصِلَةٍ
u'غَيْرٌ مُتَّصِلٌ':Added, #3: 3	غَيْرِ مُتَّصِلٍ
u'غير مُتَّصِلٌ':Added, #3: 3	غَيْرِ مُتَّصِلٍ
u'غَيْرٌ مُتَّصِلٌ':Added, #4: 4	غَيْرُ مُتَّصِلَةٍ
u'غير مُتَّصِلٌ':Added, #4: 4	غَيْرُ مُتَّصِلَةٍ
u'غَيْرٌ مُتَّصِلٌ':Added, #5: 5	غَيْرَ مُتَّصِلٍ
u'غير مُتَصَلِّبٌ':Added, #5: 5	غَيْرَ مُتَّصِلٍ
u'غَيْرٌ مُتَصَلِّبٌ':Added, #1: 1	غَيْرِ الْمُتَصَلِّبِ
u'غير مُتَضادّ':Added, #1: 1	غَيْرِ الْمُتَصَلِّبِ
u'غَيْرٌ مُتَضادّ':Added, #1: 1	غَيْرُ مُتَضَادَّةٍ
u'غير مُتَضادّ':Added, #1: 1	غَيْرُ مُتَضَادَّةٍ
u'غَيْرٌ مُتَضادّ':Added, #1: 1	غَيْرُ مُتَضَادَّيْنِ
u'غير مُتَضَجِّر':Added, #1: 1	غَيْرُ مُتَضَادَّيْنِ
u'غير مُتَضَجِّر':Added, #1: 1	غَيْرَ مُتَضَجِّرٍ
u'غَيْرٌ مُتَضَجِّر':Added, #1: 1	غَيْرُ مُتَضَجِّرٍ
u'غَيْرٌ مُتَضَجِّر':Added, #1: 1	غَيْرَ مُتَضَجِّرٍ
u'غير مُتَّضِح':Added, #1: 1	غَيْرُ مُتَضَجِّرٍ
u'غَيْرٌ مُتَّضِح':Added, #1: 1	غَيْرُ مُتَّضِحٍ
u'غير مُتَّضِح':Added, #1: 1	غَيْرُ مُتَّضِحٍ
u'غَيْرٌ مُتَّضِح':Added, #3: 3	غَيْرَ مُتَّضِحِ
u'غير مُتَضَرِّرٌ':Added, #3: 3	غَيْرَ مُتَّضِحِ
u'غَيْرٌ مُتَضَرِّرٌ':Added, #1: 1	غَيْرُ مُتَضَرِّرٍ
u'غير مُتَضَمِّن':Added, #1: 1	غَيْرُ مُتَضَرِّرٍ
u'غَيْرٌ مُتَضَمِّن':Added, #1: 1	غَيْرُ مُتَضَمِّنٍ
u'غير مُتَضَمِّن':Added, #1: 1	غَيْرُ مُتَضَمِّنٍ
u'غَيْرٌ مُتَضَمِّن':Added, #1: 1	غَيْرَ مُتَضَمِّنَةٍ
u'غير مُتَطَاوِلٌ':Added, #1: 1	غَيْرَ مُتَضَمِّنَةٍ
u'غَيْرٌ مُتَطَاوِلٌ':Added, #1: 1	غَيْرِ مُتَطَاوِلَةٍ
u'غير مُتَطَرِّفٌ':Added, #1: 1	غَيْرِ مُتَطَاوِلَةٍ
u'غَيْرٌ مُتَطَرِّفٌ':Added, #1: 1	غَيْرُ مُتَطَرِّفٍ
u'غير مُتَطَلِّعٌ':Added, #1: 1	غَيْرُ مُتَطَرِّفٍ
u'غَيْرٌ مُتَطَلِّعٌ':Added, #1: 1	غَيْرَ مُتَطَلِّعٍ
u'غير مُتَطَوِّعٌ':Added, #1: 1	غَيْرَ مُتَطَلِّعٍ
u'غَيْرٌ مُتَطَوِّعٌ':Added, #1: 1	غَيْرَ مُتَطَوِّعٍ
u'غير مُتَطَوِّعٌ':Added, #1: 1	غَيْرَ مُتَطَوِّعٍ
u'غَيْرٌ مُتَطَوِّعٌ':Added, #2: 2	غَيْرُ مُتَطَوِّعٍ
u'غير مُتَظَاهِرٌ':Added, #2: 2	غَيْرُ مُتَطَوِّعٍ
u'غَيْرٌ مُتَظَاهِرٌ':Added, #1: 1	غَيْرِ مُتَظَاهِرٍ
u'غير مُتَظَاهِرٌ':Added, #1: 1	غَيْرِ مُتَظَاهِرٍ
u'غَيْرٌ مُتَظَاهِرٌ':Added, #2: 2	غَيْرَ مُتَظَاهِرٍ
u'غير مُتَعَارَفٌ':Added, #2: 2	غَيْرَ مُتَظَاهِرٍ
u'غَيْرٌ مُتَعَارَفٌ':Added, #1: 1	غَيْرِ الْمُتَعَارَفِ
u'غير مُتَعَارَفٌ':Added, #1: 1	غَيْرِ الْمُتَعَارَفِ
u'غَيْرٌ مُتَعَارَفٌ':Added, #1: 1	غَيْرُ مُتَعَارَفَةٍ
u'غير مُتَعَارَفٌ':Added, #1: 1	غَيْرُ مُتَعَارَفَةٍ
u'غَيْرٌ مُتَعَارَفٌ':Added, #25: 25	غَيْرُ مُتَعَارَفٍ
u'غير مُتَعَارَفٌ':Added, #25: 25	غَيْرُ مُتَعَارَفٍ
u'غَيْرٌ مُتَعَارَفٌ':Added, #3: 3	غَيْرَ مُتَعَارَفٍ
u'غير مُتَعَارَفٌ':Added, #3: 3	غَيْرَ مُتَعَارَفٍ
u'غَيْرٌ مُتَعَارَفٌ':Added, #6: 6	غَيْرِ مُتَعَارَفٍ
u'غير مُتَعَاقِدٌ':Added, #6: 6	غَيْرِ مُتَعَارَفٍ
u'غَيْرٌ مُتَعَاقِدٌ':Added, #2: 2	غَيْرِ الْمُتَعَاقِدَيْنِ
u'غير مُتَعامِل':Added, #2: 2	غَيْرِ الْمُتَعَاقِدَيْنِ
u'غَيْرٌ مُتَعامِل':Added, #1: 1	غَيْرَ مُتَعَامِلَيْنِ
u'غير مُتْعِبٌ':Added, #1: 1	غَيْرَ مُتَعَامِلَيْنِ
u'غَيْرٌ مُتْعِبٌ':Added, #1: 1	غَيْرُ مُتْعِبٍ
u'غير مُتَعَبِّدٌ':Added, #1: 1	غَيْرُ مُتْعِبٍ
u'غَيْرٌ مُتَعَبِّدٌ':Added, #2: 2	غَيْرُ مُتَعَبِّدٍ
u'غير مُتْعَةٌ':Added, #2: 2	غَيْرُ مُتَعَبِّدٍ
u'غَيْرٌ مُتْعَةٌ':Added, #1: 1	غَيْرُ الْمُتْعَةِ
u'غير مُتْعَةٌ':Added, #1: 1	غَيْرُ الْمُتْعَةِ
u'غَيْرٌ مُتْعَةٌ':Added, #1: 1	غَيْرِ مُتْعَةٍ
u'غير مُتَعَدِّدٌ':Added, #1: 1	غَيْرِ مُتْعَةٍ
u'غَيْرٌ مُتَعَدِّدٌ':Added, #1: 1	غَيْرُ مُتَعَدِّدَةٍ
u'غير مُتَعَدِّدٌ':Added, #1: 1	غَيْرُ مُتَعَدِّدَةٍ
u'غَيْرٌ مُتَعَدِّدٌ':Added, #1: 1	غَيْرُ مُتَعَدِّدَيْنِ
u'غير مُتَعَدِّدٌ':Added, #1: 1	غَيْرُ مُتَعَدِّدَيْنِ
u'غَيْرٌ مُتَعَدِّدٌ':Added, #4: 4	غَيْرُ مُتَعَدِّدٍ
u'غير مُتَعَدِّي':Added, #4: 4	غَيْرُ مُتَعَدِّدٍ
u'غَيْرٌ مُتَعَدِّي':Added, #1: 1	غَيْرُ الْمُتَعَدِّيَةِ
u'غير مُتَعَدِّي':Added, #1: 1	غَيْرُ الْمُتَعَدِّيَةِ
u'غير مُتَعَدِّي':Added, #1: 1	غَيْرُ مُتَعَدِّيَةٍ
u'غَيْرٌ مُتَعَدِّي':Added, #1: 1	غَيْرُ مُتَعَدّيَةٍ
u'غَيْرٌ مُتَعَدِّي':Added, #1: 1	غَيْرُ مُتَعَدِّيَةٍ
u'غير مُتَعَدِّي':Added, #1: 1	غَيْرُ مُتَعَدّيَةٍ
u'غير مُتَعَدِّي':Added, #1: 1	غَيْرَ مُتَعَدّيَيْنِ
u'غَيْرٌ مُتَعَدِّي':Added, #1: 1	غَيْرُ مُتَعَدِّيَيْنِ
u'غَيْرٌ مُتَعَدِّي':Added, #1: 1	غَيْرَ مُتَعَدّيَيْنِ
u'غير مُتَعَذِّرٌ':Added, #1: 1	غَيْرُ مُتَعَدِّيَيْنِ
u'غَيْرٌ مُتَعَذِّرٌ':Added, #1: 1	غَيْرُ مُتَعَذِّرَةٍ
u'غير مُتَعَذِّرٌ':Added, #1: 1	غَيْرُ مُتَعَذِّرَةٍ
u'غَيْرٌ مُتَعَذِّرٌ':Added, #3: 3	غَيْرُ مُتَعَذِّرٍ
u'غير مُتَعَلِّقٌ':Added, #3: 3	غَيْرُ مُتَعَذِّرٍ
u'غَيْرٌ مُتَعَلِّقٌ':Added, #1: 1	غَيْرِ مُتَعَلِّقَةٍ
u'غير مُتَعَلِّقٌ':Added, #1: 1	غَيْرِ مُتَعَلِّقَةٍ
u'غير مُتَعَلِّقٌ':Added, #2: 2	غَيْرَ مُتَعَلِّقٍ
u'غير مُتَعَلِّقٌ':Added, #2: 2	غَيْرُ مُتَعَلِّقِ
u'غَيْرٌ مُتَعَلِّقٌ':Added, #2: 2	غَيْرِ مُتَعَلِّقِ
u'غَيْرٌ مُتَعَلِّقٌ':Added, #2: 2	غَيْرَ مُتَعَلِّقٍ
u'غَيْرٌ مُتَعَلِّقٌ':Added, #2: 2	غَيْرُ مُتَعَلِّقِ
u'غير مُتَعَلِّقٌ':Added, #2: 2	غَيْرِ مُتَعَلِّقِ
u'غَيْرٌ مُتَعَلِّقٌ':Added, #2: 2	غَيْرُ مُتَعَلِّقَةٍ
u'غير مُتَعَلِّقٌ':Added, #2: 2	غَيْرُ مُتَعَلِّقَةٍ
u'غَيْرٌ مُتَعَلِّقٌ':Added, #8: 8	غَيْرُ مُتَعَلِّقٍ
u'غير مُتَعَلِّمٌ':Added, #8: 8	غَيْرُ مُتَعَلِّقٍ
u'غَيْرٌ مُتَعَلِّمٌ':Added, #1: 1	غَيْرَ مُتَعَلِّمٍ
u'غير مُتَعَمِّدٌ':Added, #1: 1	غَيْرَ مُتَعَلِّمٍ
u'غَيْرٌ مُتَعَمِّدٌ':Added, #1: 1	غَيْرِ الْمُتَعَمِّدِ
u'غير مُتَعَمِّدٌ':Added, #1: 1	غَيْرِ الْمُتَعَمِّدِ
u'غَيْرٌ مُتَعَمِّدٌ':Added, #2: 2	غَيْرَ مُتَعَمِّدٍ
u'غير مُتَغَلِّب':Added, #2: 2	غَيْرَ مُتَعَمِّدٍ
u'غَيْرٌ مُتَغَلِّب':Added, #1: 1	غَيْرِ الْمُتَغَلِّبِ
u'غير مُتَغَيِّرٌ':Added, #1: 1	غَيْرِ الْمُتَغَلِّبِ
u'غَيْرٌ مُتَغَيِّرٌ':Added, #14: 14	غَيْرَ مُتَغَيِّرٍ
u'غير مُتَغَيِّرٌ':Added, #14: 14	غَيْرَ مُتَغَيِّرٍ
u'غَيْرٌ مُتَغَيِّرٌ':Added, #1: 1	غَيْرُ الْمُتَغَيِّرِ
u'غير مُتَغَيِّرٌ':Added, #1: 1	غَيْرُ الْمُتَغَيِّرِ
u'غَيْرٌ مُتَغَيِّرٌ':Added, #1: 1	غَيْرُ مُتَغَيِّرٍ
u'غير مُتَغَيِّرٌ':Added, #1: 1	غَيْرُ مُتَغَيِّرٍ
u'غَيْرٌ مُتَغَيِّرٌ':Added, #4: 4	غَيْرِ مُتَغَيِّرٍ
u'غير مُتَفاوِت':Added, #4: 4	غَيْرِ مُتَغَيِّرٍ
u'غير مُتَفاوِت':Added, #1: 1	غَيْرَ مُتَفَاوِتٍ
u'غَيْرٌ مُتَفاوِت':Added, #1: 1	غَيْرُ مُتَفَاوِتٍ
u'غَيْرٌ مُتَفاوِت':Added, #1: 1	غَيْرَ مُتَفَاوِتٍ
u'غير مُتَفاوِت':Added, #1: 1	غَيْرُ مُتَفَاوِتٍ
u'غير مُتَفاوِت':Added, #1: 1	غَيْرَ مُتَفَاوِتَةٍ
u'غَيْرٌ مُتَفاوِت':Added, #1: 1	غَيْرُ مُتَفَاوِتَةٍ
u'غَيْرٌ مُتَفاوِت':Added, #1: 1	غَيْرَ مُتَفَاوِتَةٍ
u'غير مُتَفاوِض':Added, #1: 1	غَيْرُ مُتَفَاوِتَةٍ
u'غَيْرٌ مُتَفاوِض':Added, #1: 1	غَيْرِ الْمُتَفَاوِضَيْنِ
u'غير مُتَفَتِّتٌ':Added, #1: 1	غَيْرِ الْمُتَفَاوِضَيْنِ
u'غَيْرٌ مُتَفَتِّتٌ':Added, #1: 1	غَيْرِ الْمُتَفَتِّتِ
u'غير مُتَفَتِّتٌ':Added, #1: 1	غَيْرِ الْمُتَفَتِّتِ
u'غَيْرٌ مُتَفَتِّتٌ':Added, #1: 1	غَيْرُ الْمُتَفَتِّتَةِ
u'غير مُتَفَرِّقٌ':Added, #1: 1	غَيْرُ الْمُتَفَتِّتَةِ
u'غَيْرٌ مُتَفَرِّقٌ':Added, #1: 1	غَيْرُ مُتَفَرِّقَةٍ
u'غير مُتَفَسِّخٌ':Added, #1: 1	غَيْرُ مُتَفَرِّقَةٍ
u'غَيْرٌ مُتَفَسِّخٌ':Added, #1: 1	غَيْرَ مُتَفَسِّخَةٍ
u'غير مُتَّفَقٌ':Added, #1: 1	غَيْرَ مُتَفَسِّخَةٍ
u'غَيْرٌ مُتَّفَقٌ':Added, #1: 1	غَيْرُ مُتَّفَقٍ
u'غير مُتَّفِقٌ':Added, #1: 1	غَيْرُ مُتَّفَقٍ
u'غَيْرٌ مُتَّفِقٌ':Added, #1: 1	غَيْرُ مُتّفِقَتَيْنِ
u'غير مُتَّفَقٌ':Added, #1: 1	غَيْرُ مُتّفِقَتَيْنِ
u'غَيْرٌ مُتَّفَقٌ':Added, #2: 2	غَيْرَ مُتَّفَقٍ
u'غير مُتَقَابِلٌ':Added, #2: 2	غَيْرَ مُتَّفَقٍ
u'غَيْرٌ مُتَقَابِلٌ':Added, #1: 1	غَيْرَ مُتَقَابِلَيْنِ
u'غير مُتَقادِم':Added, #1: 1	غَيْرَ مُتَقَابِلَيْنِ
u'غَيْرٌ مُتَقادِم':Added, #1: 1	غَيْرَ مُتَقَادِمٍ
u'غير مُتَقَدِّمٌ':Added, #1: 1	غَيْرَ مُتَقَادِمٍ
u'غَيْرٌ مُتَقَدِّمٌ':Added, #1: 1	غَيْرِ الْمُتَقَدِّمَةِ
u'غير مُتَقَدِّمٌ':Added, #1: 1	غَيْرِ الْمُتَقَدِّمَةِ
u'غَيْرٌ مُتَقَدِّمٌ':Added, #1: 1	غَيْرُ مُتَقَدِّمٍ
u'غير مُتَقَدِّمٌ':Added, #1: 1	غَيْرُ مُتَقَدِّمٍ
u'غَيْرٌ مُتَقَدِّمٌ':Added, #2: 2	غَيْرَ مُتَقَدِّمٍ
u'غير مُتْقِنٌ':Added, #2: 2	غَيْرَ مُتَقَدِّمٍ
u'غَيْرٌ مُتْقِنٌ':Added, #1: 1	غَيْرُ مُتْقِنٍ
u'غير مُتَكَافِئ':Added, #1: 1	غَيْرُ مُتْقِنٍ
u'غَيْرٌ مُتَكَافِئ':Added, #1: 1	غَيْرِ الْمُتَكَافِئَيْنِ
u'غير مُتَكَافِئ':Added, #1: 1	غَيْرِ الْمُتَكَافِئَيْنِ
u'غَيْرٌ مُتَكَافِئ':Added, #1: 1	غَيْرَ مُتَكَافِئَيْنِ
u'غير مُتَكامِل':Added, #1: 1	غَيْرَ مُتَكَافِئَيْنِ
u'غَيْرٌ مُتَكامِل':Added, #1: 1	غَيْرَ مُتَكَامِلٍ
u'غير مُتَكامِل':Added, #1: 1	غَيْرَ مُتَكَامِلٍ
u'غَيْرٌ مُتَكامِل':Added, #3: 3	غَيْرُ مُتَكَامِلٍ
u'غير مُتَكَرِّرٌ':Added, #3: 3	غَيْرُ مُتَكَامِلٍ
u'غَيْرٌ مُتَكَرِّرٌ':Added, #1: 1	غَيْرُ مُتَكَرِّرَةٍ
u'غير مُتَكَرِّرٌ':Added, #1: 1	غَيْرُ مُتَكَرِّرَةٍ
u'غَيْرٌ مُتَكَرِّرٌ':Added, #4: 4	غَيْرُ مُتَكَرِّرٍ
u'غير مُتَكَلِّمٌ':Added, #4: 4	غَيْرُ مُتَكَرِّرٍ
u'غَيْرٌ مُتَكَلِّمٌ':Added, #4: 4	غَيْرِ الْمُتَكَلِّمِ
u'غير مُتَلاَزِمٌ':Added, #4: 4	غَيْرِ الْمُتَكَلِّمِ
u'غَيْرٌ مُتَلاَزِمٌ':Added, #1: 1	غَيْرُ مُتَلَازِمَيْنِ
u'غير مُتَلاَصِقٌ':Added, #1: 1	غَيْرُ مُتَلَازِمَيْنِ
u'غَيْرٌ مُتَلاَصِقٌ':Added, #1: 1	غَيْرَ مُتَلَاصِقَيْنِ
u'غير مُتَلَبِّسٌ':Added, #1: 1	غَيْرَ مُتَلَاصِقَيْنِ
u'غَيْرٌ مُتَلَبِّسٌ':Added, #1: 1	غَيْرِ الْمُتَلَبِّسِ
u'غير مُتَلَذِّذ':Added, #1: 1	غَيْرِ الْمُتَلَبِّسِ
u'غَيْرٌ مُتَلَذِّذ':Added, #1: 1	غَيْرَ مُتَلَذِّذٍ
u'غير مُتْلِفٌ':Added, #1: 1	غَيْرَ مُتَلَذِّذٍ
u'غَيْرٌ مُتْلِفٌ':Added, #1: 1	غَيْرِ الْمُتْلِفِ
u'غير مُتْلِفٌ':Added, #1: 1	غَيْرِ الْمُتْلِفِ
u'غَيْرٌ مُتْلِفٌ':Added, #1: 1	غَيْرُ مُتْلِفٍ
u'غير مُتَلَوِّنٌ':Added, #1: 1	غَيْرُ مُتْلِفٍ
u'غَيْرٌ مُتَلَوِّنٌ':Added, #1: 1	غَيْرِ الْمُتَلَوِّنِ
u'غير مُتَمَاثِلٌ':Added, #1: 1	غَيْرِ الْمُتَلَوِّنِ
u'غَيْرٌ مُتَمَاثِلٌ':Added, #1: 1	غَيْرُ مُتَمَاثِلَيْنِ
u'غير مُتَمَاثِلٌ':Added, #1: 1	غَيْرُ مُتَمَاثِلَيْنِ
u'غَيْرٌ مُتَمَاثِلٌ':Added, #2: 2	غَيْرِ الْمُتَمَاثِلِ
u'غير مُتَمَاثِلٌ':Added, #2: 2	غَيْرِ الْمُتَمَاثِلِ
u'غَيْرٌ مُتَمَاثِلٌ':Added, #2: 2	غَيْرِ مُتَمَاثِلِ
u'غير مُتَمَتِّعٌ':Added, #2: 2	غَيْرِ مُتَمَاثِلِ
u'غَيْرٌ مُتَمَتِّعٌ':Added, #1: 1	غَيْرُ الْمُتَمَتِّعِ
u'غير مُتَمَتِّعٌ':Added, #1: 1	غَيْرُ الْمُتَمَتِّعِ
u'غَيْرٌ مُتَمَتِّعٌ':Added, #2: 2	غَيْرَ مُتَمَتِّعٍ
u'غير مُتَمَتِّعٌ':Added, #2: 2	غَيْرَ مُتَمَتِّعٍ
u'غَيْرٌ مُتَمَتِّعٌ':Added, #5: 5	غَيْرُ مُتَمَتِّعٍ
u'غير مُتَمَذْهِب':Added, #5: 5	غَيْرُ مُتَمَتِّعٍ
u'غَيْرٌ مُتَمَذْهِب':Added, #1: 1	غَيْرَ مُتَمَذْهِبٍ
u'غير مُتَمَكِّنٌ':Added, #1: 1	غَيْرَ مُتَمَذْهِبٍ
u'غَيْرٌ مُتَمَكِّنٌ':Added, #1: 1	غَيْرُ الْمُتَمَكِّنِ
u'غير مُتَمَكِّنٌ':Added, #1: 1	غَيْرُ الْمُتَمَكِّنِ
u'غير مُتَمَكِّنٌ':Added, #1: 1	غَيْرَ مُتَمَكِّنٍ
u'غَيْرٌ مُتَمَكِّنٌ':Added, #1: 1	غَيْرِ مُتَمَكِّنٍ
u'غَيْرٌ مُتَمَكِّنٌ':Added, #1: 1	غَيْرَ مُتَمَكِّنٍ
u'غير مُتَمَكِّنٌ':Added, #1: 1	غَيْرِ مُتَمَكِّنٍ
u'غَيْرٌ مُتَمَكِّنٌ':Added, #9: 9	غَيْرُ مُتَمَكِّنٍ
u'غير مُتَمَوِّل':Added, #9: 9	غَيْرُ مُتَمَكِّنٍ
u'غَيْرٌ مُتَمَوِّل':Added, #1: 1	غَيْرِ الْمُتَمَوِّلِ
u'غير مُتَمَوِّل':Added, #1: 1	غَيْرِ الْمُتَمَوِّلِ
u'غَيْرٌ مُتَمَوِّل':Added, #9: 9	غَيْرَ مُتَمَوِّلٍ
u'غير مُتَمَيِّزٌ':Added, #9: 9	غَيْرَ مُتَمَوِّلٍ
u'غَيْرٌ مُتَمَيِّزٌ':Added, #10: 10	غَيْرَ مُتَمَيِّزٍ
u'غير مُتَمَيِّزٌ':Added, #10: 10	غَيْرَ مُتَمَيِّزٍ
u'غير مُتَمَيِّزٌ':Added, #1: 1	غَيْرَ الْمُتَمَيِّزِ
u'غَيْرٌ مُتَمَيِّزٌ':Added, #1: 1	غَيْرُ الْمُتَمَيِّزِ
u'غَيْرٌ مُتَمَيِّزٌ':Added, #1: 1	غَيْرَ الْمُتَمَيِّزِ
u'غير مُتَمَيِّزٌ':Added, #1: 1	غَيْرُ الْمُتَمَيِّزِ
u'غير مُتَمَيِّزٌ':Added, #1: 1	غَيْر مُتَمَيِّزٍ
u'غَيْرٌ مُتَمَيِّزٌ':Added, #1: 1	غَيْرِ مُتَمَيِّزٍ
u'غَيْرٌ مُتَمَيِّزٌ':Added, #1: 1	غَيْر مُتَمَيِّزٍ
u'غير مُتَمَيِّزٌ':Added, #1: 1	غَيْرِ مُتَمَيِّزٍ
u'غَيْرٌ مُتَمَيِّزٌ':Added, #1: 1	غَيْرَ مُتَمَيِّزَةٍ
u'غير مُتَمَيِّزٌ':Added, #1: 1	غَيْرَ مُتَمَيِّزَةٍ
u'غَيْرٌ مُتَمَيِّزٌ':Added, #2: 2	غَيْرِ الْمُتَمَيِّزِ
u'غير مُتَمَيِّزٌ':Added, #2: 2	غَيْرِ الْمُتَمَيِّزِ
u'غَيْرٌ مُتَمَيِّزٌ':Added, #2: 2	غَيْرُ مُتَمَيِّزٍ
u'غير مُتَمَيِّزٌ':Added, #2: 2	غَيْرُ مُتَمَيِّزٍ
u'غَيْرٌ مُتَمَيِّزٌ':Added, #6: 6	غَيْرُ مُتَمَيِّزَةٍ
u'غير مَتْنٌ':Added, #6: 6	غَيْرُ مُتَمَيِّزَةٍ
u'غَيْرٌ مَتْنٌ':Added, #1: 1	غَيْرُ مَتْنِ
u'غير مُتَنازَع':Added, #1: 1	غَيْرُ مَتْنِ
u'غَيْرٌ مُتَنازَع':Added, #1: 1	غَيْرِ الْمُتَنَازَعِ
u'غير مُتَنَاقِضٌ':Added, #1: 1	غَيْرِ الْمُتَنَازَعِ
u'غَيْرٌ مُتَنَاقِضٌ':Added, #2: 2	غَيْرُ مُتَنَاقِضٍ
u'غير مُتَناهِي':Added, #2: 2	غَيْرُ مُتَنَاقِضٍ
u'غَيْرٌ مُتَناهِي':Added, #2: 2	غَيْرِ مُتَنَاهِيَةٍ
u'غير مُتَناهِي':Added, #2: 2	غَيْرِ مُتَنَاهِيَةٍ
u'غَيْرٌ مُتَناهِي':Added, #5: 5	غَيْرُ مُتَنَاهِيَةٍ
u'غير مُتَنَاوَلٌ':Added, #5: 5	غَيْرُ مُتَنَاهِيَةٍ
u'غَيْرٌ مُتَنَاوَلٌ':Added, #1: 1	غَيْرُ مُتَنَاوَلَةٍ
u'غير مُتَنَوِّعٌ':Added, #1: 1	غَيْرُ مُتَنَاوَلَةٍ
u'غَيْرٌ مُتَنَوِّعٌ':Added, #1: 1	غَيْرَ مُتَنَوِّعٍ
u'غير مُتَنَوِّعٌ':Added, #1: 1	غَيْرَ مُتَنَوِّعٍ
u'غَيْرٌ مُتَنَوِّعٌ':Added, #6: 6	غَيْرُ مُتَنَوِّعٍ
u'غير مُتَّهَمٌ':Added, #6: 6	غَيْرُ مُتَنَوِّعٍ
u'غَيْرٌ مُتَّهَمٌ':Added, #11: 11	غَيْرَ مُتَّهَمٍ
u'غير مُتَّهَمٌ':Added, #11: 11	غَيْرَ مُتَّهَمٍ
u'غَيْرٌ مُتَّهَمٌ':Added, #1: 1	غَيْرَ الْمُتَّهَمِ
u'غير مُتَّهَمٌ':Added, #1: 1	غَيْرَ الْمُتَّهَمِ
u'غير مُتَّهَمٌ':Added, #1: 1	غَيْرَ مُتّهَمٍ
u'غير مُتَّهَمٌ':Added, #1: 1	غَيْرُ مُتَّهَمِ
u'غير مُتَّهَمٌ':Added, #1: 1	غَيْرِ مُتَّهَمٍ
u'غَيْرٌ مُتَّهَمٌ':Added, #1: 1	غَيْرِ مُتَّهَمِ
u'غَيْرٌ مُتَّهَمٌ':Added, #1: 1	غَيْرَ مُتّهَمٍ
u'غَيْرٌ مُتَّهَمٌ':Added, #1: 1	غَيْرُ مُتَّهَمِ
u'غَيْرٌ مُتَّهَمٌ':Added, #1: 1	غَيْرِ مُتَّهَمٍ
u'غير مُتَّهَمٌ':Added, #1: 1	غَيْرِ مُتَّهَمِ
u'غَيْرٌ مُتَّهَمٌ':Added, #1: 1	غَيْرُ مُتَّهَمَةٍ
u'غير مُتَّهَمٌ':Added, #1: 1	غَيْرُ مُتَّهَمَةٍ
u'غَيْرٌ مُتَّهَمٌ':Added, #1: 1	غَيْرَ مُتَّهَمَيْنِ
u'غير مُتَّهَمٌ':Added, #1: 1	غَيْرَ مُتَّهَمَيْنِ
u'غَيْرٌ مُتَّهَمٌ':Added, #24: 24	غَيْرُ مُتَّهَمٍ
u'غير مُتَّهَمٌ':Added, #24: 24	غَيْرُ مُتَّهَمٍ
u'غَيْرٌ مُتَّهَمٌ':Added, #2: 2	غَيْرَ مُتَّهَمَةٍ
u'غير مُتَّهَمٌ':Added, #2: 2	غَيْرَ مُتَّهَمَةٍ
u'غَيْرٌ مُتَّهَمٌ':Added, #2: 2	غَيْرُ مُتَّهَمَيْنِ
u'غير مُتَوَاتِرٌ':Added, #2: 2	غَيْرُ مُتَّهَمَيْنِ
u'غير مُتَوَاتِرٌ':Added, #1: 1	غَيْرَ الْمُتَوَاتِرِ
u'غَيْرٌ مُتَوَاتِرٌ':Added, #1: 1	غَيْرُ الْمُتَوَاتِرِ
u'غَيْرٌ مُتَوَاتِرٌ':Added, #1: 1	غَيْرَ الْمُتَوَاتِرِ
u'غير مُتَوَاتِرٌ':Added, #1: 1	غَيْرُ الْمُتَوَاتِرِ
u'غير مُتَوَاتِرٌ':Added, #1: 1	غَيْرَ مُتَوَاتِرٍ
u'غَيْرٌ مُتَوَاتِرٌ':Added, #1: 1	غَيْرُ مُتَوَاتِرٍ
u'غَيْرٌ مُتَوَاتِرٌ':Added, #1: 1	غَيْرَ مُتَوَاتِرٍ
u'غير مُتَوَاتِرٌ':Added, #1: 1	غَيْرُ مُتَوَاتِرٍ
u'غير مُتَوَاتِرٌ':Added, #1: 1	غَيْرَ مُتَوَاتِرَةٍ
u'غَيْرٌ مُتَوَاتِرٌ':Added, #1: 1	غَيْرُ مُتَوَاتِرَةٍ
u'غَيْرٌ مُتَوَاتِرٌ':Added, #1: 1	غَيْرَ مُتَوَاتِرَةٍ
u'غير مُتَوَاتِرٌ':Added, #1: 1	غَيْرُ مُتَوَاتِرَةٍ
u'غَيْرٌ مُتَوَاتِرٌ':Added, #1: 1	غَيْرَ مُتَوَاتِرَيْنِ
u'غير مُتَوَاتِرٌ':Added, #1: 1	غَيْرَ مُتَوَاتِرَيْنِ
u'غَيْرٌ مُتَوَاتِرٌ':Added, #2: 2	غَيْرِ الْمُتَوَاتِرِ
u'غير مُتَوَاتِرٌ':Added, #2: 2	غَيْرِ الْمُتَوَاتِرِ
u'غَيْرٌ مُتَوَاتِرٌ':Added, #2: 2	غَيْرِ الْمُتَوَاتِرَيْنِ
u'غير مُتَوَالِي':Added, #2: 2	غَيْرِ الْمُتَوَاتِرَيْنِ
u'غَيْرٌ مُتَوَالِي':Added, #1: 1	غَيْرَ مُتَوَالِيَةٍ
u'غير مُتَوَالِي':Added, #1: 1	غَيْرَ مُتَوَالِيَةٍ
u'غَيْرٌ مُتَوَالِي':Added, #1: 1	غَيْرِ مُتَوَالِيَتَيْنِ
u'غير مُتَوَجِّه':Added, #1: 1	غَيْرِ مُتَوَالِيَتَيْنِ
u'غَيْرٌ مُتَوَجِّه':Added, #1: 1	غَيْرَ مُتَوَجِّهٍ
u'غير مُتَوَجِّه':Added, #1: 1	غَيْرَ مُتَوَجِّهٍ
u'غَيْرٌ مُتَوَجِّه':Added, #2: 2	غَيْرُ مُتَوَجِّهٍ
u'غير مُتَوَطِّن':Added, #2: 2	غَيْرُ مُتَوَجِّهٍ
u'غَيْرٌ مُتَوَطِّن':Added, #1: 1	غَيْرُ الْمُتَوَطِّنِ
u'غير مُتَوَفِّر':Added, #1: 1	غَيْرُ الْمُتَوَطِّنِ
u'غَيْرٌ مُتَوَفِّر':Added, #1: 1	غَيْرُ مُتَوَفِّرٍ
u'غير مُتَوَقَّعٌ':Added, #1: 1	غَيْرُ مُتَوَفِّرٍ
u'غير مُتَوَقِّعٌ':Added, #1: 1	غَيْرُ مُتَوَقَّعِ
u'غير مُتَوَقِّعٌ':Added, #1: 1	غَيْرَ مُتَوَقِّعٍ
u'غَيْرٌ مُتَوَقَّعٌ':Added, #1: 1	غَيْرُ مُتَوَقِّعٍ
u'غَيْرٌ مُتَوَقِّعٌ':Added, #1: 1	غَيْرُ مُتَوَقَّعِ
u'غَيْرٌ مُتَوَقِّعٌ':Added, #1: 1	غَيْرَ مُتَوَقِّعٍ
u'غير مُتَوَقَّعٌ':Added, #1: 1	غَيْرُ مُتَوَقِّعٍ
u'غَيْرٌ مُتَوَقَّعٌ':Added, #2: 2	غَيْرُ مُتَوَقَّعٍ
u'غير مُتَوَقِّف':Added, #2: 2	غَيْرُ مُتَوَقَّعٍ
u'غَيْرٌ مُتَوَقِّف':Added, #1: 1	غَيْرَ الْمُتَوَقِّفِ
u'غير مُتَوَقِّف':Added, #1: 1	غَيْرَ الْمُتَوَقِّفِ
u'غَيْرٌ مُتَوَقِّف':Added, #1: 1	غَيْرُ مُتَوَقِّفِ
u'غير مُتَوَقِّف':Added, #1: 1	غَيْرُ مُتَوَقِّفِ
u'غَيْرٌ مُتَوَقِّف':Added, #1: 1	غَيْرَ مُتَوَقِّفَةٍ
u'غير مُتَوَقِّف':Added, #1: 1	غَيْرَ مُتَوَقِّفَةٍ
u'غَيْرٌ مُتَوَقِّف':Added, #2: 2	غَيْرُ مُتَوَقِّفَةٍ
u'غير مُتَوَقِّف':Added, #2: 2	غَيْرُ مُتَوَقِّفَةٍ
u'غَيْرٌ مُتَوَقِّف':Added, #4: 4	غَيْرَ مُتَوَقِّفٍ
u'غير مُتَوَقِّف':Added, #4: 4	غَيْرَ مُتَوَقِّفٍ
u'غَيْرٌ مُتَوَقِّف':Added, #8: 8	غَيْرُ مُتَوَقِّفٍ
u'غير مُتَوَلِّدٌ':Added, #8: 8	غَيْرُ مُتَوَقِّفٍ
u'غَيْرٌ مُتَوَلِّدٌ':Added, #19: 19	غَيْرَ مُتَوَلِّدَةٍ
u'غير مُتَوَلِّدٌ':Added, #19: 19	غَيْرَ مُتَوَلِّدَةٍ
u'غَيْرٌ مُتَوَلِّدٌ':Added, #2: 2	غَيْرُ الْمُتَوَلِّدَةِ
u'غير مُتَوَلِّدٌ':Added, #2: 2	غَيْرُ الْمُتَوَلِّدَةِ
u'غَيْرٌ مُتَوَلِّدٌ':Added, #2: 2	غَيْرَ مُتَوَلِّدٍ
u'غير مُتَوَلِّدٌ':Added, #2: 2	غَيْرَ مُتَوَلِّدٍ
u'غَيْرٌ مُتَوَلِّدٌ':Added, #3: 3	غَيْرِ الْمُتَوَلِّدَةِ
u'غير مُتَوَلِّدٌ':Added, #3: 3	غَيْرِ الْمُتَوَلِّدَةِ
u'غَيْرٌ مُتَوَلِّدٌ':Added, #6: 6	غَيْرُ مُتَوَلِّدَةٍ
u'غير مُتَيَسِّرٌ':Added, #6: 6	غَيْرُ مُتَوَلِّدَةٍ
u'غَيْرٌ مُتَيَسِّرٌ':Added, #1: 1	غَيْرَ مُتَيَسِّرٍ
u'غير مُتَيَقِّظٌ':Added, #1: 1	غَيْرَ مُتَيَسِّرٍ
u'غَيْرٌ مُتَيَقِّظٌ':Added, #1: 1	غَيْرِ مُتَيَقِّظٍ
u'غير مُتَيَقِّن':Added, #1: 1	غَيْرِ مُتَيَقِّظٍ
u'غَيْرٌ مُتَيَقِّن':Added, #5: 5	غَيْرُ مُتَيَقِّنٍ
u'غير مِثَالٌ':Added, #5: 5	غَيْرُ مُتَيَقِّنٍ
u'غَيْرٌ مِثَالٌ':Added, #7: 7	غَيْرِ مِثَالٍ
u'غير مُثْبَتٌ':Added, #7: 7	غَيْرِ مِثَالٍ
u'غَيْرٌ مُثْبَتٌ':Added, #1: 1	غَيْرَ مُثْبَتٍ
u'غير مُثْخَنٌ':Added, #1: 1	غَيْرَ مُثْبَتٍ
u'غَيْرٌ مُثْخَنٌ':Added, #1: 1	غَيْرَ مُثْخَنٍ
u'غير مثل':Added, #1: 1	غَيْرَ مُثْخَنٍ
u'غير مثل':Added, #1: 1	غَيْرَ الْمِثْلِ
u'غير مثل':Added, #1: 1	غَيْرُ الْمَثَلِ
u'غَيْرٌ مثل':Added, #1: 1	غَيْرُ الْمِثْلِ
u'غَيْرٌ مثل':Added, #1: 1	غَيْرَ الْمِثْلِ
u'غَيْرٌ مثل':Added, #1: 1	غَيْرُ الْمَثَلِ
u'غير مَثَلٌ':Added, #1: 1	غَيْرُ الْمِثْلِ
u'غير مِثْلٌ':Added, #1: 1	غَيْرُ الْمَثَلِ
u'غير مِثْلٌ':Added, #1: 1	غَيْرَ الْمِثْلِ
u'غَيْرٌ مَثَلٌ':Added, #1: 1	غَيْرُ الْمِثْلِ
u'غَيْرٌ مِثْلٌ':Added, #1: 1	غَيْرُ الْمَثَلِ
u'غَيْرٌ مِثْلٌ':Added, #1: 1	غَيْرَ الْمِثْلِ
u'غير مثل':Added, #1: 1	غَيْرُ الْمِثْلِ
u'غَيْرٌ مثل':Added, #1: 1	غَيْرِ مِثْلِهِ
u'غير مِثْلٌ':Added, #1: 1	غَيْرِ مِثْلِهِ
u'غَيْرٌ مِثْلٌ':Added, #1: 1	غَيْرِ مِثْلِهِ
u'غير مِثْلِيٌّ':Added, #1: 1	غَيْرِ مِثْلِهِ
u'غَيْرٌ مِثْلِيٌّ':Added, #15: 15	غَيْرِ الْمِثْلِيِّ
u'غير مِثْلِيٌّ':Added, #15: 15	غَيْرِ الْمِثْلِيِّ
u'غير مِثْلِيٌّ':Added, #2: 2	غَيْرَ الْمِثْلِيِّ
u'غَيْرٌ مِثْلِيٌّ':Added, #2: 2	غَيْرُ الْمِثْلِيِّ
u'غَيْرٌ مِثْلِيٌّ':Added, #2: 2	غَيْرَ الْمِثْلِيِّ
u'غير مِثْلِيٌّ':Added, #2: 2	غَيْرُ الْمِثْلِيِّ
u'غير مِثْلِيٌّ':Added, #2: 2	غَيْرَ مِثْلِيَّةٍ
u'غَيْرٌ مِثْلِيٌّ':Added, #2: 2	غَيْرُ مِثْلِيَّةٍ
u'غَيْرٌ مِثْلِيٌّ':Added, #2: 2	غَيْرَ مِثْلِيَّةٍ
u'غير مِثْلِيٌّ':Added, #2: 2	غَيْرُ مِثْلِيَّةٍ
u'غَيْرٌ مِثْلِيٌّ':Added, #3: 3	غَيْرُ مِثْلِيٍّ
u'غير مِثْلِيٌّ':Added, #3: 3	غَيْرُ مِثْلِيٍّ
u'غَيْرٌ مِثْلِيٌّ':Added, #4: 4	غَيْرِ الْمِثْلِيَّاتِ
u'غير مِثْلِيٌّ':Added, #4: 4	غَيْرِ الْمِثْلِيَّاتِ
u'غَيْرٌ مِثْلِيٌّ':Added, #5: 5	غَيْرِ مِثْلِيٍّ
u'غير مِثْلِيٌّ':Added, #5: 5	غَيْرِ مِثْلِيٍّ
u'غَيْرٌ مِثْلِيٌّ':Added, #6: 6	غَيْرَ مِثْلِيٍّ
u'غير مُثْمِر':Added, #6: 6	غَيْرَ مِثْلِيٍّ
u'غير مُثْمِر':Added, #1: 1	غَيْرُ مُثْمِرَةٍ
u'غَيْرٌ مُثْمِر':Added, #1: 1	غَيْرِ مُثْمِرَةٍ
u'غَيْرٌ مُثْمِر':Added, #1: 1	غَيْرُ مُثْمِرَةٍ
u'غير مُثْمِر':Added, #1: 1	غَيْرِ مُثْمِرَةٍ
u'غَيْرٌ مُثْمِر':Added, #2: 2	غَيْرِ الْمُثْمِرَةِ
u'غير مُثْمِر':Added, #2: 2	غَيْرِ الْمُثْمِرَةِ
u'غَيْرٌ مُثْمِر':Added, #2: 2	غَيْرُ مُثْمِرٍ
u'غير مُثْمِر':Added, #2: 2	غَيْرُ مُثْمِرٍ
u'غَيْرٌ مُثْمِر':Added, #4: 4	غَيْرَ مُثْمِرَةٍ
u'غير مُجَازَفَةٌ':Added, #4: 4	غَيْرَ مُثْمِرَةٍ
u'غَيْرٌ مُجَازَفَةٌ':Added, #1: 1	غَيْرِ مُجَازَفَةٍ
u'غير مَجَازِيٌّ':Added, #1: 1	غَيْرِ مُجَازَفَةٍ
u'غَيْرٌ مَجَازِيٌّ':Added, #1: 1	غَيْرُ الْمَجَازِيِّ
u'غير مجَاعَةٌ':Added, #1: 1	غَيْرُ الْمَجَازِيِّ
u'غَيْرٌ مجَاعَةٌ':Added, #1: 1	غَيْرِ مَجَاعَةٍ
u'غير مُجَامَعَةٌ':Added, #1: 1	غَيْرِ مَجَاعَةٍ
u'غَيْرٌ مُجَامَعَةٌ':Added, #1: 1	غَيْرَ مُجَامَعَةٍ
u'غير مُجَاهِدٌ':Added, #1: 1	غَيْرَ مُجَامَعَةٍ
u'غَيْرٌ مُجَاهِدٌ':Added, #1: 1	غَيْرَ مُجَاهِدٍ
u'غير مُجْبَرٌ':Added, #1: 1	غَيْرَ مُجَاهِدٍ
u'غير مُجْبِرٌ':Added, #1: 1	غَيْرِ الْمُجْبَرِ
u'غير مُجْبِرٌ':Added, #1: 1	غَيْرَ الْمُجْبِرِ
u'غَيْرٌ مُجْبَرٌ':Added, #1: 1	غَيْرُ الْمُجْبِرِ
u'غَيْرٌ مُجْبِرٌ':Added, #1: 1	غَيْرِ الْمُجْبَرِ
u'غَيْرٌ مُجْبِرٌ':Added, #1: 1	غَيْرَ الْمُجْبِرِ
u'غير مُجْبَرٌ':Added, #1: 1	غَيْرُ الْمُجْبِرِ
u'غَيْرٌ مُجْبَرٌ':Added, #1: 1	غَيْرَ الْمُجْبَرَةِ
u'غير مُجْبِرٌ':Added, #1: 1	غَيْرَ الْمُجْبَرَةِ
u'غَيْرٌ مُجْبِرٌ':Added, #1: 1	غَيْرُ مُجْبِرٍ
u'غير مُجْبَرٌ':Added, #1: 1	غَيْرُ مُجْبِرٍ
u'غَيْرٌ مُجْبَرٌ':Added, #3: 3	غَيْرُ الْمُجْبَرِ
u'غير مُجْبَرٌ':Added, #3: 3	غَيْرُ الْمُجْبَرِ
u'غير مُجْبَرٌ':Added, #3: 3	غَيْرُ الْمُجْبَرَةِ
u'غَيْرٌ مُجْبَرٌ':Added, #3: 3	غَيْرِ الْمُجْبَرَةِ
u'غَيْرٌ مُجْبَرٌ':Added, #3: 3	غَيْرُ الْمُجْبَرَةِ
u'غير مُجْبَرٌ':Added, #3: 3	غَيْرِ الْمُجْبَرَةِ
u'غَيْرٌ مُجْبَرٌ':Added, #3: 3	غَيْرِ مُجْبَرٍ
u'غير مُجْبَرٌ':Added, #3: 3	غَيْرِ مُجْبَرٍ
u'غير مُجْبَرٌ':Added, #4: 4	غَيْرَ مُجْبَرٍ
u'غير مُجْبِرٌ':Added, #4: 4	غَيْرُ مُجْبَرٍ
u'غَيْرٌ مُجْبَرٌ':Added, #4: 4	غَيْرَ مُجْبِرٍ
u'غَيْرٌ مُجْبَرٌ':Added, #4: 4	غَيْرَ مُجْبَرٍ
u'غَيْرٌ مُجْبِرٌ':Added, #4: 4	غَيْرُ مُجْبَرٍ
u'غير مُجْبِرٌ':Added, #4: 4	غَيْرَ مُجْبِرٍ
u'غَيْرٌ مُجْبِرٌ':Added, #6: 6	غَيْرِ الْمُجْبِرِ
u'غير مُجْبَرٌ':Added, #6: 6	غَيْرِ الْمُجْبِرِ
u'غَيْرٌ مُجْبَرٌ':Added, #9: 9	غَيْرَ مُجْبَرَةٍ
u'غير مَجْبُورٌ':Added, #9: 9	غَيْرَ مُجْبَرَةٍ
u'غَيْرٌ مَجْبُورٌ':Added, #1: 1	غَيْرَ مَجْبُورٍ
u'غير مُجْتَهِد':Added, #1: 1	غَيْرَ مَجْبُورٍ
u'غَيْرٌ مُجْتَهِد':Added, #13: 13	غَيْرِ الْمُجْتَهِدِ
u'غير مُجْتَهِد':Added, #13: 13	غَيْرِ الْمُجْتَهِدِ
u'غَيْرٌ مُجْتَهِد':Added, #1: 1	غَيْرَ الْمُجْتَهِدِ
u'غير مُجْتَهِد':Added, #1: 1	غَيْرَ الْمُجْتَهِدِ
u'غَيْرٌ مُجْتَهِد':Added, #2: 2	غَيْرِ مُجْتَهِدٍ
u'غير مُجْتَهِد':Added, #2: 2	غَيْرِ مُجْتَهِدٍ
u'غَيْرٌ مُجْتَهِد':Added, #5: 5	غَيْرَ مُجْتَهِدٍ
u'غير مُجْتَهِد':Added, #5: 5	غَيْرَ مُجْتَهِدٍ
u'غَيْرٌ مُجْتَهِد':Added, #6: 6	غَيْرُ الْمُجْتَهِدِ
u'غير مُجْتَهِد':Added, #6: 6	غَيْرُ الْمُجْتَهِدِ
u'غَيْرٌ مُجْتَهِد':Added, #8: 8	غَيْرُ مُجْتَهِدٍ
u'غير مُجْحِفٌ':Added, #8: 8	غَيْرُ مُجْتَهِدٍ
u'غَيْرٌ مُجْحِفٌ':Added, #2: 2	غَيْرِ مُجْحِفَةٍ
u'غير مَجْدٌ':Added, #2: 2	غَيْرِ مُجْحِفَةٍ
u'غَيْرٌ مَجْدٌ':Added, #1: 1	غَيْرِ الْمَجْدِ
u'غير مُجِدٌّ':Added, #1: 1	غَيْرِ الْمَجْدِ
u'غَيْرٌ مُجِدٌّ':Added, #1: 1	غَيْرِ مُجِدٍّ
u'غير مَجْدٌ':Added, #1: 1	غَيْرِ مُجِدٍّ
u'غَيْرٌ مَجْدٌ':Added, #2: 2	غَيْرُ الْمَجْدِ
u'غير مُجَدَّدُ':Added, #2: 2	غَيْرُ الْمَجْدِ
u'غَيْرٌ مُجَدَّدُ':Added, #1: 1	غَيْرِ الْمُجَدَّدِ
u'غير مُجَرَّدٌ':Added, #1: 1	غَيْرِ الْمُجَدَّدِ
u'غَيْرٌ مُجَرَّدٌ':Added, #1: 1	غَيْرَ الْمُجَرَّدِ
u'غير مُجَرَّدٌ':Added, #1: 1	غَيْرَ الْمُجَرَّدِ
u'غير مُجَرَّدٌ':Added, #1: 1	غَيْرَ مُجَرَّدٍ
u'غير مُجَرَّدٌ':Added, #1: 1	غَيْرُ مُجَرَّدٍ
u'غَيْرٌ مُجَرَّدٌ':Added, #1: 1	غَيْرِ مُجَرَّدِ
u'غَيْرٌ مُجَرَّدٌ':Added, #1: 1	غَيْرَ مُجَرَّدٍ
u'غَيْرٌ مُجَرَّدٌ':Added, #1: 1	غَيْرُ مُجَرَّدٍ
u'غير مُجَرَّدٌ':Added, #1: 1	غَيْرِ مُجَرَّدِ
u'غَيْرٌ مُجَرَّدٌ':Added, #2: 2	غَيْرُ مُجَرَّدِ
u'غير مُجَرَّدٌ':Added, #2: 2	غَيْرُ مُجَرَّدِ
u'غَيْرٌ مُجَرَّدٌ':Added, #3: 3	غَيْرِ الْمُجَرَّدِ
u'غير مُجَرَّدٌ':Added, #3: 3	غَيْرِ الْمُجَرَّدِ
u'غَيْرٌ مُجَرَّدٌ':Added, #3: 3	غَيْرَ مُجَرَّدِ
u'غير مَجْزُوم':Added, #3: 3	غَيْرَ مُجَرَّدِ
u'غَيْرٌ مَجْزُوم':Added, #1: 1	غَيْرَ مَجْزُومٍ
u'غير مَجْزُوم':Added, #1: 1	غَيْرَ مَجْزُومٍ
u'غَيْرٌ مَجْزُوم':Added, #3: 3	غَيْرُ مَجْزُومٍ
u'غير مُجَفَّفٌ':Added, #3: 3	غَيْرُ مَجْزُومٍ
u'غَيْرٌ مُجَفَّفٌ':Added, #1: 1	غَيْرُ الْمُجَفَّفِ
u'غير مَجْلِسٌ':Added, #1: 1	غَيْرُ الْمُجَفَّفِ
u'غَيْرٌ مَجْلِسٌ':Added, #2: 2	غَيْرُ مَجْلِسِ
u'غير مَجْلِسٌ':Added, #2: 2	غَيْرُ مَجْلِسِ
u'غَيْرٌ مَجْلِسٌ':Added, #53: 53	غَيْرِ مَجْلِسِ
u'غير مَجْلِسٌ':Added, #53: 53	غَيْرِ مَجْلِسِ
u'غَيْرٌ مَجْلِسٌ':Added, #6: 6	غَيْرِ الْمَجْلِسِ
u'غير مَجْلِسٌ':Added, #6: 6	غَيْرِ الْمَجْلِسِ
u'غَيْرٌ مَجْلِسٌ':Added, #7: 7	غَيْرِ مَجْلِسِهِ
u'غير مَجْلُوب':Added, #7: 7	غَيْرِ مَجْلِسِهِ
u'غَيْرٌ مَجْلُوب':Added, #1: 1	غَيْرُ مَجْلُوبِ
u'غير مُجْمَلٌ':Added, #1: 1	غَيْرُ مَجْلُوبِ
u'غَيْرٌ مُجْمَلٌ':Added, #1: 1	غَيْرُ مُجْمَلَةٍ
u'غير مُجْمَلٌ':Added, #1: 1	غَيْرُ مُجْمَلَةٍ
u'غَيْرٌ مُجْمَلٌ':Added, #2: 2	غَيْرُ مُجْمَلٍ
u'غير مَجْمُوعٌ':Added, #2: 2	غَيْرُ مُجْمَلٍ
u'غَيْرٌ مَجْمُوعٌ':Added, #1: 1	غَيْرُ الْمَجْمُوعِ
u'غير مَجْمُوعٌ':Added, #1: 1	غَيْرُ الْمَجْمُوعِ
u'غَيْرٌ مَجْمُوعٌ':Added, #1: 1	غَيْرَ مَجْمُوعٍ
u'غير مَجْنُونٌ':Added, #1: 1	غَيْرَ مَجْمُوعٍ
u'غَيْرٌ مَجْنُونٌ':Added, #1: 1	غَيْرِ الْمَجْنُونِ
u'غير مَجْنُونٌ':Added, #1: 1	غَيْرِ الْمَجْنُونِ
u'غَيْرٌ مَجْنُونٌ':Added, #2: 2	غَيْرَ مَجْنُونٍ
u'غير مَجْنِيٌّ':Added, #2: 2	غَيْرَ مَجْنُونٍ
u'غَيْرٌ مَجْنِيٌّ':Added, #4: 4	غَيْرِ الْمَجْنِيِّ
u'غير مَجْهُولٌ':Added, #4: 4	غَيْرِ الْمَجْنِيِّ
u'غَيْرٌ مَجْهُولٌ':Added, #1: 1	غَيْرَ الْمَجْهُولِ
u'غير مَجْهُولٌ':Added, #1: 1	غَيْرَ الْمَجْهُولِ
u'غَيْرٌ مَجْهُولٌ':Added, #1: 1	غَيْرَ مَجْهُولٍ
u'غير مَجُوسِيٌّ':Added, #1: 1	غَيْرَ مَجْهُولٍ
u'غَيْرٌ مَجُوسِيٌّ':Added, #1: 1	غَيْرِ مَجُوسِيٍّ
u'غير مَجُوسِيٌّ':Added, #1: 1	غَيْرِ مَجُوسِيٍّ
u'غَيْرٌ مَجُوسِيٌّ':Added, #2: 2	غَيْرَ مَجُوسِيٍّ
u'غير مَجِيءٌ':Added, #2: 2	غَيْرَ مَجُوسِيٍّ
u'غَيْرٌ مَجِيءٌ':Added, #1: 1	غَيْرُ مَجِيءِ
u'غير مُجِيدٌ':Added, #1: 1	غَيْرُ مَجِيءِ
u'غَيْرٌ مُجِيدٌ':Added, #1: 1	غَيْرَ مُجِيدِهِ
u'غير مُحَابَاةٌ':Added, #1: 1	غَيْرَ مُجِيدِهِ
u'غَيْرٌ مُحَابَاةٌ':Added, #1: 1	غَيْرِ مُحَابَاةٍ
u'غير مُحَاذَاةٌ':Added, #1: 1	غَيْرِ مُحَابَاةٍ
u'غَيْرٌ مُحَاذَاةٌ':Added, #1: 1	غَيْرِ مُحَاذَاةِ
u'غير مُحَاذَاةٌ':Added, #1: 1	غَيْرِ مُحَاذَاةِ
u'غَيْرٌ مُحَاذَاةٌ':Added, #1: 1	غَيْرِ مُحَاذَاتِهِ
u'غير مُحَاذِي':Added, #1: 1	غَيْرِ مُحَاذَاتِهِ
u'غَيْرٌ مُحَاذِي':Added, #1: 1	غَيْرُ مُحَاذِيَةٍ
u'غير مُحَارِبٌ':Added, #1: 1	غَيْرُ مُحَاذِيَةٍ
u'غَيْرٌ مُحَارِبٌ':Added, #1: 1	غَيْرُ الْمُحَارِبِ
u'غير مُحَارِبٌ':Added, #1: 1	غَيْرُ الْمُحَارِبِ
u'غَيْرٌ مُحَارِبٌ':Added, #1: 1	غَيْرَ مُحَارِبٍ
u'غير مُحَارَبَةٌ':Added, #1: 1	غَيْرَ مُحَارِبٍ
u'غَيْرٌ مُحَارَبَةٌ':Added, #1: 1	غَيْرِ مُحَارَبَةٍ
u'غير مُحَارَبَةٌ':Added, #1: 1	غَيْرِ مُحَارَبَةٍ
u'غَيْرٌ مُحَارَبَةٌ':Added, #4: 4	غَيْرِ الْمُحَارَبَةِ
u'غير مَحَارِمُ':Added, #4: 4	غَيْرِ الْمُحَارَبَةِ
u'غَيْرٌ مَحَارِمُ':Added, #1: 1	غَيْرَ الْمَحَارِمِ
u'غير مَحَارِمُ':Added, #1: 1	غَيْرَ الْمَحَارِمِ
u'غَيْرٌ مَحَارِمُ':Added, #2: 2	غَيْرُ الْمَحَارِمِ
u'غير مَحَارِمُ':Added, #2: 2	غَيْرُ الْمَحَارِمِ
u'غَيْرٌ مَحَارِمُ':Added, #3: 3	غَيْرِ الْمَحَارِمِ
u'غير مُحَاسَبَةٌ':Added, #3: 3	غَيْرِ الْمَحَارِمِ
u'غَيْرٌ مُحَاسَبَةٌ':Added, #1: 1	غَيْرِ مُحَاسَبَةٍ
u'غير مُحاصَّة':Added, #1: 1	غَيْرِ مُحَاسَبَةٍ
u'غَيْرٌ مُحاصَّة':Added, #1: 1	غَيْرُ الْمُحَاصَّةِ
u'غير مُحَاكَمَةٌ':Added, #1: 1	غَيْرُ الْمُحَاصَّةِ
u'غَيْرٌ مُحَاكَمَةٌ':Added, #1: 1	غَيْرِ مُحَاكَمَةٍ
u'غير مَحْبُوبٌ':Added, #1: 1	غَيْرِ مُحَاكَمَةٍ
u'غَيْرٌ مَحْبُوبٌ':Added, #1: 1	غَيْرَ مَحْبُوبٍ
u'غير مَحْبُوبٌ':Added, #1: 1	غَيْرَ مَحْبُوبٍ
u'غَيْرٌ مَحْبُوبٌ':Added, #2: 2	غَيْرُ مَحْبُوبٍ
u'غير مَحْبُوبٌ':Added, #2: 2	غَيْرُ مَحْبُوبٍ
u'غَيْرٌ مَحْبُوبٌ':Added, #2: 2	غَيْرُ مَحْبُوبَةٍ
u'غير مَحْبُوسٌ':Added, #2: 2	غَيْرُ مَحْبُوبَةٍ
u'غَيْرٌ مَحْبُوسٌ':Added, #1: 1	غَيْرَ مَحْبُوسٍ
u'غير مَحْبُوسٌ':Added, #1: 1	غَيْرَ مَحْبُوسٍ
u'غَيْرٌ مَحْبُوسٌ':Added, #2: 2	غَيْرُ مَحْبُوسَةٍ
u'غير مَحْبُوسٌ':Added, #2: 2	غَيْرُ مَحْبُوسَةٍ
u'غَيْرٌ مَحْبُوسٌ':Added, #4: 4	غَيْرُ مَحْبُوسٍ
u'غير مُحْتَاجٌ':Added, #4: 4	غَيْرُ مَحْبُوسٍ
u'غَيْرٌ مُحْتَاجٌ':Added, #14: 14	غَيْرَ مُحْتَاجٍ
u'غير مُحْتَاجٌ':Added, #14: 14	غَيْرَ مُحْتَاجٍ
u'غَيْرٌ مُحْتَاجٌ':Added, #1: 1	غَيْرَ مُحْتَاجَةٍ
u'غير مُحْتَاجٌ':Added, #1: 1	غَيْرَ مُحْتَاجَةٍ
u'غَيْرٌ مُحْتَاجٌ':Added, #1: 1	غَيْرَ مُحْتَاجَيْنِ
u'غير مُحْتَاجٌ':Added, #1: 1	غَيْرَ مُحْتَاجَيْنِ
u'غَيْرٌ مُحْتَاجٌ':Added, #2: 2	غَيْرُ الْمُحْتَاجِ
u'غير مُحْتَاجٌ':Added, #2: 2	غَيْرُ الْمُحْتَاجِ
u'غَيْرٌ مُحْتَاجٌ':Added, #4: 4	غَيْرِ الْمُحْتَاجِ
u'غير مُحْتَاجٌ':Added, #4: 4	غَيْرِ الْمُحْتَاجِ
u'غَيْرٌ مُحْتَاجٌ':Added, #4: 4	غَيْرُ مُحْتَاجَةٍ
u'غير مُحْتَاجٌ':Added, #4: 4	غَيْرُ مُحْتَاجَةٍ
u'غَيْرٌ مُحْتَاجٌ':Added, #54: 54	غَيْرُ مُحْتَاجٍ
u'غير مُحْتَاجٌ':Added, #54: 54	غَيْرُ مُحْتَاجٍ
u'غَيْرٌ مُحْتَاجٌ':Added, #5: 5	غَيْرِ مُحْتَاجٍ
u'غير مُحْتَجٌّ':Added, #5: 5	غَيْرِ مُحْتَاجٍ
u'غَيْرٌ مُحْتَجٌّ':Added, #1: 1	غَيْرُ مُحْتَجِّ
u'غير مُحْتَجٌّ':Added, #1: 1	غَيْرُ مُحْتَجِّ
u'غَيْرٌ مُحْتَجٌّ':Added, #37: 37	غَيْرُ مُحْتَجٍّ
u'غير مُحْتَرِفٌ':Added, #37: 37	غَيْرُ مُحْتَجٍّ
u'غير مُحْتَرِفٌ':Added, #1: 1	غَيْرَ مُحْتَرِفٍ
u'غَيْرٌ مُحْتَرِفٌ':Added, #1: 1	غَيْرِ مُحْتَرِفٍ
u'غَيْرٌ مُحْتَرِفٌ':Added, #1: 1	غَيْرَ مُحْتَرِفٍ
u'غير مُحْتَرَمٌ':Added, #1: 1	غَيْرِ مُحْتَرِفٍ
u'غَيْرٌ مُحْتَرَمٌ':Added, #11: 11	غَيْرِ الْمُحْتَرَمَةِ
u'غير مُحْتَرَمٌ':Added, #11: 11	غَيْرِ الْمُحْتَرَمَةِ
u'غَيْرٌ مُحْتَرَمٌ':Added, #1: 1	غَيْرُ الْمُحْتَرَمِ
u'غير مُحْتَرَمٌ':Added, #1: 1	غَيْرُ الْمُحْتَرَمِ
u'غَيْرٌ مُحْتَرَمٌ':Added, #1: 1	غَيْرُ الْمُحْتَرَمَةِ
u'غير مُحْتَرَمٌ':Added, #1: 1	غَيْرُ الْمُحْتَرَمَةِ
u'غَيْرٌ مُحْتَرَمٌ':Added, #2: 2	غَيْرِ مُحْتَرَمَةٍ
u'غير مُحْتَرَمٌ':Added, #2: 2	غَيْرِ مُحْتَرَمَةٍ
u'غَيْرٌ مُحْتَرَمٌ':Added, #3: 3	غَيْرَ الْمُحْتَرَمِ
u'غير مُحْتَرَمٌ':Added, #3: 3	غَيْرَ الْمُحْتَرَمِ
u'غَيْرٌ مُحْتَرَمٌ':Added, #3: 3	غَيْرِ مُحْتَرَمٍ
u'غير مُحْتَرَمٌ':Added, #3: 3	غَيْرِ مُحْتَرَمٍ
u'غَيْرٌ مُحْتَرَمٌ':Added, #3: 3	غَيْرَ مُحْتَرَمَةٍ
u'غير مُحْتَرَمٌ':Added, #3: 3	غَيْرَ مُحْتَرَمَةٍ
u'غَيْرٌ مُحْتَرَمٌ':Added, #4: 4	غَيْرِ الْمُحْتَرَمِ
u'غير مُحْتَرَمٌ':Added, #4: 4	غَيْرِ الْمُحْتَرَمِ
u'غَيْرٌ مُحْتَرَمٌ':Added, #5: 5	غَيْرَ مُحْتَرَمٍ
u'غير مُحْتَرَمٌ':Added, #5: 5	غَيْرَ مُحْتَرَمٍ
u'غَيْرٌ مُحْتَرَمٌ':Added, #8: 8	غَيْرُ مُحْتَرَمٍ
u'غير مُحْتَسِبٌ':Added, #8: 8	غَيْرُ مُحْتَرَمٍ
u'غير مُحْتَسِبٌ':Added, #1: 1	غَيْرُ الْمُحْتَسِبِ
u'غَيْرٌ مُحْتَسِبٌ':Added, #1: 1	غَيْرِ الْمُحْتَسِبِ
u'غَيْرٌ مُحْتَسِبٌ':Added, #1: 1	غَيْرُ الْمُحْتَسِبِ
u'غير مُحْتَسِبٌ':Added, #1: 1	غَيْرِ الْمُحْتَسِبِ
u'غير مُحْتَسِبٌ':Added, #1: 1	غَيْرَ مُحْتَسِبٍ
u'غَيْرٌ مُحْتَسِبٌ':Added, #1: 1	غَيْرِ مُحْتَسِبٍ
u'غَيْرٌ مُحْتَسِبٌ':Added, #1: 1	غَيْرَ مُحْتَسِبٍ
u'غير مُحْتَسَبٌ':Added, #1: 1	غَيْرِ مُحْتَسِبٍ
u'غَيْرٌ مُحْتَسَبٌ':Added, #2: 2	غَيْرُ مُحْتَسَبَةٍ
u'غير مُحْتَشِمٌ':Added, #2: 2	غَيْرُ مُحْتَسَبَةٍ
u'غَيْرٌ مُحْتَشِمٌ':Added, #1: 1	غَيْرَ مُحْتَشِمِ
u'غير مُحْتَضَرٌ':Added, #1: 1	غَيْرَ مُحْتَشِمِ
u'غَيْرٌ مُحْتَضَرٌ':Added, #1: 1	غَيْرَ مُحْتَضَرِ
u'غير مُحْتَفَلٌ':Added, #1: 1	غَيْرَ مُحْتَضَرِ
u'غَيْرٌ مُحْتَفَلٌ':Added, #1: 1	غَيْرُ مُحْتَفَلٍ
u'غير مُحْتَقِرٌ':Added, #1: 1	غَيْرُ مُحْتَفَلٍ
u'غَيْرٌ مُحْتَقِرٌ':Added, #1: 1	غَيْرَ مُحْتَقِرٍ
u'غير مُحَتَّم':Added, #1: 1	غَيْرَ مُحْتَقِرٍ
u'غَيْرٌ مُحَتَّم':Added, #1: 1	غَيْرَ مُحَتَّمٍ
u'غير مُحْتَمَلٌ':Added, #1: 1	غَيْرَ مُحَتَّمٍ
u'غَيْرٌ مُحْتَمَلٌ':Added, #1: 1	غَيْرِ الْمُحْتَمَلِ
u'غير مُحْتَمَلٌ':Added, #1: 1	غَيْرِ الْمُحْتَمَلِ
u'غَيْرٌ مُحْتَمَلٌ':Added, #2: 2	غَيْرَ مُحْتَمَلٍ
u'غير مُحْتَمَلٌ':Added, #2: 2	غَيْرَ مُحْتَمَلٍ
u'غَيْرٌ مُحْتَمَلٌ':Added, #2: 2	غَيْرِ مُحْتَمَلَةٍ
u'غير مُحْتَمَلٌ':Added, #2: 2	غَيْرِ مُحْتَمَلَةٍ
u'غَيْرٌ مُحْتَمَلٌ':Added, #3: 3	غَيْرِ مُحْتَمَلٍ
u'غير مُحْتَمَلٌ':Added, #3: 3	غَيْرِ مُحْتَمَلٍ
u'غَيْرٌ مُحْتَمَلٌ':Added, #5: 5	غَيْرُ مُحْتَمَلٍ
u'غير مَحْجُوبٌ':Added, #5: 5	غَيْرُ مُحْتَمَلٍ
u'غَيْرٌ مَحْجُوبٌ':Added, #2: 2	غَيْرَ مَحْجُوبٍ
u'غير مَحْجُورٌ':Added, #2: 2	غَيْرَ مَحْجُوبٍ
u'غَيْرٌ مَحْجُورٌ':Added, #11: 11	غَيْرُ مَحْجُورٍ
u'غير مَحْجُورٌ':Added, #11: 11	غَيْرُ مَحْجُورٍ
u'غَيْرٌ مَحْجُورٌ':Added, #1: 1	غَيْرُ مَحْجُورِ
u'غير مَحْجُورٌ':Added, #1: 1	غَيْرُ مَحْجُورِ
u'غَيْرٌ مَحْجُورٌ':Added, #1: 1	غَيْرُ مَحْجُورَيْنِ
u'غير مَحْجُورٌ':Added, #1: 1	غَيْرُ مَحْجُورَيْنِ
u'غَيْرٌ مَحْجُورٌ':Added, #3: 3	غَيْرِ مَحْجُورٍ
u'غير مَحْجُورٌ':Added, #3: 3	غَيْرِ مَحْجُورٍ
u'غَيْرٌ مَحْجُورٌ':Added, #6: 6	غَيْرِ الْمَحْجُورِ
u'غير مَحْجُورٌ':Added, #6: 6	غَيْرِ الْمَحْجُورِ
u'غَيْرٌ مَحْجُورٌ':Added, #7: 7	غَيْرَ مَحْجُورٍ
u'غير مُحْدِثٌ':Added, #7: 7	غَيْرَ مَحْجُورٍ
u'غَيْرٌ مُحْدِثٌ':Added, #1: 1	غَيْرُ الْمُحْدِثِ
u'غير مُحْدَثٌ':Added, #1: 1	غَيْرُ الْمُحْدِثِ
u'غَيْرٌ مُحْدَثٌ':Added, #1: 1	غَيْرُ مُحْدَثٍ
u'غير مُحْدَثٌ':Added, #1: 1	غَيْرُ مُحْدَثٍ
u'غَيْرٌ مُحْدَثٌ':Added, #1: 1	غَيْرُ مُحْدَثَةٍ
u'غير مُحْدِثٌ':Added, #1: 1	غَيْرُ مُحْدَثَةٍ
u'غَيْرٌ مُحْدِثٌ':Added, #2: 2	غَيْرِ الْمُحْدِثِ
u'غير مُحْدِثٌ':Added, #2: 2	غَيْرِ الْمُحْدِثِ
u'غَيْرٌ مُحْدِثٌ':Added, #2: 2	غَيْرَ مُحْدِثٍ
u'غير مُحْدِثٌ':Added, #2: 2	غَيْرَ مُحْدِثٍ
u'غَيْرٌ مُحْدِثٌ':Added, #3: 3	غَيْرُ مُحْدِثٍ
u'غير مُحَدَّدٌ':Added, #3: 3	غَيْرُ مُحْدِثٍ
u'غَيْرٌ مُحَدَّدٌ':Added, #1: 1	غَيْرِ الْمُحَدَّدِ
u'غير مُحَدَّدٌ':Added, #1: 1	غَيْرِ الْمُحَدَّدِ
u'غَيْرٌ مُحَدَّدٌ':Added, #1: 1	غَيْرِ الْمُحَدَّدَةِ
u'غير مُحَدَّدٌ':Added, #1: 1	غَيْرِ الْمُحَدَّدَةِ
u'غير مُحَدِّدٌ':Added, #1: 1	غَيْرَ مُحَدَّدٍ
u'غَيْرٌ مُحَدَّدٌ':Added, #1: 1	غَيْرَ مُحَدِّدٍ
u'غَيْرٌ مُحَدِّدٌ':Added, #1: 1	غَيْرَ مُحَدَّدٍ
u'غير مَحْدُودٌ':Added, #1: 1	غَيْرَ مُحَدِّدٍ
u'غَيْرٌ مَحْدُودٌ':Added, #1: 1	غَيْرِ الْمَحْدُودِ
u'غير مَحْدُودٌ':Added, #1: 1	غَيْرِ الْمَحْدُودِ
u'غَيْرٌ مَحْدُودٌ':Added, #1: 1	غَيْرُ الْمَحْدُودَةِ
u'غير مَحْدُودٌ':Added, #1: 1	غَيْرُ الْمَحْدُودَةِ
u'غَيْرٌ مَحْدُودٌ':Added, #1: 1	غَيْرُ مَحْدُودِ
u'غير مَحْدُودٌ':Added, #1: 1	غَيْرُ مَحْدُودِ
u'غَيْرٌ مَحْدُودٌ':Added, #1: 1	غَيْرَ مَحْدُودَيْنِ
u'غير مَحْدُودٌ':Added, #1: 1	غَيْرَ مَحْدُودَيْنِ
u'غَيْرٌ مَحْدُودٌ':Added, #3: 3	غَيْرُ الْمَحْدُودِ
u'غير مَحْدُودٌ':Added, #3: 3	غَيْرُ الْمَحْدُودِ
u'غَيْرٌ مَحْدُودٌ':Added, #6: 6	غَيْرَ مَحْدُودٍ
u'غير مَحْدُودٌ':Added, #6: 6	غَيْرَ مَحْدُودٍ
u'غَيْرٌ مَحْدُودٌ':Added, #7: 7	غَيْرُ مَحْدُودٍ
u'غير مِحْرَابٌ':Added, #7: 7	غَيْرُ مَحْدُودٍ
u'غَيْرٌ مِحْرَابٌ':Added, #1: 1	غَيْرِ مِحْرَابِ
u'غير مُحَرَّرٌ':Added, #1: 1	غَيْرِ مِحْرَابِ
u'غَيْرٌ مُحَرَّرٌ':Added, #4: 4	غَيْرُ مُحَرَّرَةٍ
u'غير مُحَرَّرٌ':Added, #4: 4	غَيْرُ مُحَرَّرَةٍ
u'غَيْرٌ مُحَرَّرٌ':Added, #9: 9	غَيْرُ مُحَرَّرٍ
u'غير مُحَرِّكٌ':Added, #9: 9	غَيْرُ مُحَرَّرٍ
u'غَيْرٌ مُحَرِّكٌ':Added, #1: 1	غَيْرَ مُحَرِّكٍ
u'غير مَحْرَمٌ':Added, #1: 1	غَيْرَ مُحَرِّكٍ
u'غَيْرٌ مَحْرَمٌ':Added, #10: 10	غَيْرِ الْمَحْرَمِ
u'غير مَحْرَمٌ':Added, #10: 10	غَيْرِ الْمَحْرَمِ
u'غَيْرٌ مَحْرَمٌ':Added, #10: 10	غَيْرَ مَحْرَمٍ
u'غير مَحْرَمٌ':Added, #10: 10	غَيْرَ مَحْرَمٍ
u'غَيْرٌ مَحْرَمٌ':Added, #18: 18	غَيْرُ مَحْرَمٍ
u'غير مُحَرَّمٌ':Added, #18: 18	غَيْرُ مَحْرَمٍ
u'غَيْرٌ مُحَرَّمٌ':Added, #19: 19	غَيْرُ مُحَرَّمٍ
u'غير مَحْرَمٌ':Added, #19: 19	غَيْرُ مُحَرَّمٍ
u'غير مُحْرِمٌ':Added, #1: 1	غَيْرَ الْمَحْرَمِ
u'غَيْرٌ مَحْرَمٌ':Added, #1: 1	غَيْرَ الْمُحْرِمِ
u'غَيْرٌ مُحْرِمٌ':Added, #1: 1	غَيْرَ الْمَحْرَمِ
u'غير مُحْرِمٌ':Added, #1: 1	غَيْرَ الْمُحْرِمِ
u'غَيْرٌ مُحْرِمٌ':Added, #1: 1	غَيْرِ مُحْرِمٍ
u'غير مُحَرَّمٌ':Added, #1: 1	غَيْرِ مُحْرِمٍ
u'غير مُحَرَّمٌ':Added, #1: 1	غَيْرَ مُحَرَّمَةٍ
u'غير مُحْرِمٌ':Added, #1: 1	غَيْرُ مُحَرَّمَةٍ
u'غَيْرٌ مُحَرَّمٌ':Added, #1: 1	غَيْرُ مُحْرِمَةٍ
u'غَيْرٌ مُحَرَّمٌ':Added, #1: 1	غَيْرَ مُحَرَّمَةٍ
u'غَيْرٌ مُحْرِمٌ':Added, #1: 1	غَيْرُ مُحَرَّمَةٍ
u'غير مَحْرَمٌ':Added, #1: 1	غَيْرُ مُحْرِمَةٍ
u'غير مَحْرَمٌ':Added, #1: 1	غَيْرَ مَحْرَمِهِ
u'غَيْرٌ مَحْرَمٌ':Added, #1: 1	غَيْرِ مَحْرَمِهِ
u'غَيْرٌ مَحْرَمٌ':Added, #1: 1	غَيْرَ مَحْرَمِهِ
u'غير مَحْرَمٌ':Added, #1: 1	غَيْرِ مَحْرَمِهِ
u'غَيْرٌ مَحْرَمٌ':Added, #23: 23	غَيْرِ مَحْرَمٍ
u'غير مُحْرِمٌ':Added, #23: 23	غَيْرِ مَحْرَمٍ
u'غَيْرٌ مُحْرِمٌ':Added, #2: 2	غَيْرُ الْمُحْرِمِ
u'غير مُحَرَّمٌ':Added, #2: 2	غَيْرُ الْمُحْرِمِ
u'غَيْرٌ مُحَرَّمٌ':Added, #2: 2	غَيْرُ مُحَرَّمَاتٍ
u'غير مُحْرِمٌ':Added, #2: 2	غَيْرُ مُحَرَّمَاتٍ
u'غَيْرٌ مُحْرِمٌ':Added, #36: 36	غَيْرَ مُحْرِمٍ
u'غير مَحْرَمٌ':Added, #36: 36	غَيْرَ مُحْرِمٍ
u'غير مُحَرَّمٌ':Added, #3: 3	غَيْرُ الْمَحْرَمِ
u'غير مُحَرَّمٌ':Added, #3: 3	غَيْرَ الْمُحَرَّمِ
u'غير مُحَرَّمٌ':Added, #3: 3	غَيْرُ الْمُحَرَّمِ
u'غَيْرٌ مَحْرَمٌ':Added, #3: 3	غَيْرِ الْمُحَرَّمِ
u'غَيْرٌ مُحَرَّمٌ':Added, #3: 3	غَيْرُ الْمَحْرَمِ
u'غَيْرٌ مُحَرَّمٌ':Added, #3: 3	غَيْرَ الْمُحَرَّمِ
u'غَيْرٌ مُحَرَّمٌ':Added, #3: 3	غَيْرُ الْمُحَرَّمِ
u'غير مُحَرَّمٌ':Added, #3: 3	غَيْرِ الْمُحَرَّمِ
u'غير مُحْرِمٌ':Added, #6: 6	غَيْرَ مُحَرَّمٍ
u'غَيْرٌ مُحَرَّمٌ':Added, #6: 6	غَيْرُ مُحْرِمٍ
u'غَيْرٌ مُحْرِمٌ':Added, #6: 6	غَيْرَ مُحَرَّمٍ
u'غير مُحْرِمٌ':Added, #6: 6	غَيْرُ مُحْرِمٍ
u'غَيْرٌ مُحْرِمٌ':Added, #7: 7	غَيْرِ الْمُحْرِمِ
u'غير مُحَرَّمٌ':Added, #7: 7	غَيْرِ الْمُحْرِمِ
u'غَيْرٌ مُحَرَّمٌ':Added, #7: 7	غَيْرِ مُحَرَّمٍ
u'غير مُحْسِنٌ':Added, #7: 7	غَيْرِ مُحَرَّمٍ
u'غير مُحْسِنٌ':Added, #1: 1	غَيْرُ مُحْسِنِ
u'غَيْرٌ مُحْسِنٌ':Added, #1: 1	غَيْرِ مُحْسِنِ
u'غَيْرٌ مُحْسِنٌ':Added, #1: 1	غَيْرُ مُحْسِنِ
u'غير مَحْسُوبٌ':Added, #1: 1	غَيْرِ مُحْسِنِ
u'غَيْرٌ مَحْسُوبٌ':Added, #10: 10	غَيْرُ مَحْسُوبٍ
u'غير مَحْسُوبٌ':Added, #10: 10	غَيْرُ مَحْسُوبٍ
u'غَيْرٌ مَحْسُوبٌ':Added, #1: 1	غَيْرِ مَحْسُوبٍ
u'غير مَحْسُوبٌ':Added, #1: 1	غَيْرِ مَحْسُوبٍ
u'غير مَحْسُوبٌ':Added, #1: 1	غَيْرَ مَحْسُوبَةٍ
u'غَيْرٌ مَحْسُوبٌ':Added, #1: 1	غَيْرِ مَحْسُوبَةٍ
u'غَيْرٌ مَحْسُوبٌ':Added, #1: 1	غَيْرَ مَحْسُوبَةٍ
u'غير مَحْسُوبٌ':Added, #1: 1	غَيْرِ مَحْسُوبَةٍ
u'غَيْرٌ مَحْسُوبٌ':Added, #4: 4	غَيْرُ مَحْسُوبَةٍ
u'غير مَحْسُوبٌ':Added, #4: 4	غَيْرُ مَحْسُوبَةٍ
u'غَيْرٌ مَحْسُوبٌ':Added, #5: 5	غَيْرَ مَحْسُوبٍ
u'غير مَحْسُوسٌ':Added, #5: 5	غَيْرَ مَحْسُوبٍ
u'غَيْرٌ مَحْسُوسٌ':Added, #1: 1	غَيْرِ الْمَحْسُوسِ
u'غير مَحْسُوسٌ':Added, #1: 1	غَيْرِ الْمَحْسُوسِ
u'غَيْرٌ مَحْسُوسٌ':Added, #1: 1	غَيْرِ الْمَحْسُوسَاتِ
u'غير مَحْسُوسٌ':Added, #1: 1	غَيْرِ الْمَحْسُوسَاتِ
u'غَيْرٌ مَحْسُوسٌ':Added, #1: 1	غَيْرِ الْمَحْسُوسَةِ
u'غير مَحْسُوسٌ':Added, #1: 1	غَيْرِ الْمَحْسُوسَةِ
u'غير مَحْسُوسٌ':Added, #1: 1	غَيْرَ مَحْسُوسٍ
u'غير مَحْسُوسٌ':Added, #1: 1	غَيْرُ مَحْسُوسٍ
u'غَيْرٌ مَحْسُوسٌ':Added, #1: 1	غَيْرِ مَحْسُوسٍ
u'غَيْرٌ مَحْسُوسٌ':Added, #1: 1	غَيْرَ مَحْسُوسٍ
u'غَيْرٌ مَحْسُوسٌ':Added, #1: 1	غَيْرُ مَحْسُوسٍ
u'غير مَحْشُوّ':Added, #1: 1	غَيْرِ مَحْسُوسٍ
u'غَيْرٌ مَحْشُوّ':Added, #1: 1	غَيْرُ مَحْشُوٍّ
u'غير مُحَصَّبٌ':Added, #1: 1	غَيْرُ مَحْشُوٍّ
u'غَيْرٌ مُحَصَّبٌ':Added, #1: 1	غَيْرَ مُحَصَّبٍ
u'غير مُحْصَنٌ':Added, #1: 1	غَيْرَ مُحَصَّبٍ
u'غَيْرٌ مُحْصَنٌ':Added, #14: 14	غَيْرِ الْمُحْصَنِ
u'غير مُحْصَنٌ':Added, #14: 14	غَيْرِ الْمُحْصَنِ
u'غَيْرٌ مُحْصَنٌ':Added, #15: 15	غَيْرُ مُحْصَنٍ
u'غير مُحْصَنٌ':Added, #15: 15	غَيْرُ مُحْصَنٍ
u'غَيْرٌ مُحْصَنٌ':Added, #1: 1	غَيْرَ الْمُحْصَنِ
u'غير مُحْصَنٌ':Added, #1: 1	غَيْرَ الْمُحْصَنِ
u'غَيْرٌ مُحْصَنٌ':Added, #1: 1	غَيْرَ مُحْصَنَاتٍ
u'غير مُحْصَنٌ':Added, #1: 1	غَيْرَ مُحْصَنَاتٍ
u'غَيْرٌ مُحْصَنٌ':Added, #21: 21	غَيْرَ مُحْصَنٍ
u'غير مُحْصَنٌ':Added, #21: 21	غَيْرَ مُحْصَنٍ
u'غَيْرٌ مُحْصَنٌ':Added, #2: 2	غَيْرَ الْمُحْصَنَةِ
u'غير مُحْصَنٌ':Added, #2: 2	غَيْرَ الْمُحْصَنَةِ
u'غَيْرٌ مُحْصَنٌ':Added, #2: 2	غَيْرِ مُحْصَنٍ
u'غير مُحْصَنٌ':Added, #2: 2	غَيْرِ مُحْصَنٍ
u'غير مُحْصَنٌ':Added, #2: 2	غَيْرُ مُحْصَنَةٍ
u'غَيْرٌ مُحْصَنٌ':Added, #2: 2	غَيْرِ مُحْصَنَةٍ
u'غَيْرٌ مُحْصَنٌ':Added, #2: 2	غَيْرُ مُحْصَنَةٍ
u'غير مُحْصَنٌ':Added, #2: 2	غَيْرِ مُحْصَنَةٍ
u'غَيْرٌ مُحْصَنٌ':Added, #3: 3	غَيْرُ الْمُحْصَنِ
u'غير مُحْصَنٌ':Added, #3: 3	غَيْرُ الْمُحْصَنِ
u'غَيْرٌ مُحْصَنٌ':Added, #3: 3	غَيْرَ مُحْصَنَيْنِ
u'غير مُحْصَنٌ':Added, #3: 3	غَيْرَ مُحْصَنَيْنِ
u'غَيْرٌ مُحْصَنٌ':Added, #5: 5	غَيْرَ مُحْصَنَةٍ
u'غير مَحْصُود':Added, #5: 5	غَيْرَ مُحْصَنَةٍ
u'غَيْرٌ مَحْصُود':Added, #1: 1	غَيْرِ الْمَحْصُودِ
u'غير مَحْصُود':Added, #1: 1	غَيْرِ الْمَحْصُودِ
u'غَيْرٌ مَحْصُود':Added, #2: 2	غَيْرَ مَحْصُودٍ
u'غير مَحْصُورٌ':Added, #2: 2	غَيْرَ مَحْصُودٍ
u'غَيْرٌ مَحْصُورٌ':Added, #14: 14	غَيْرُ مَحْصُورٍ
u'غير مَحْصُورٌ':Added, #14: 14	غَيْرُ مَحْصُورٍ
u'غَيْرٌ مَحْصُورٌ':Added, #1: 1	غَيْرَ الْمَحْصُورِ
u'غير مَحْصُورٌ':Added, #1: 1	غَيْرَ الْمَحْصُورِ
u'غَيْرٌ مَحْصُورٌ':Added, #1: 1	غَيْرَ مَحْصُورَةٍ
u'غير مَحْصُورٌ':Added, #1: 1	غَيْرَ مَحْصُورَةٍ
u'غَيْرٌ مَحْصُورٌ':Added, #1: 1	غَيْرُ مَحْصُورَيْنِ
u'غير مَحْصُورٌ':Added, #1: 1	غَيْرُ مَحْصُورَيْنِ
u'غَيْرٌ مَحْصُورٌ':Added, #2: 2	غَيْرُ الْمَحْصُورِ
u'غير مَحْصُورٌ':Added, #2: 2	غَيْرُ الْمَحْصُورِ
u'غَيْرٌ مَحْصُورٌ':Added, #2: 2	غَيْرَ مَحْصُورَيْنِ
u'غير مَحْصُورٌ':Added, #2: 2	غَيْرَ مَحْصُورَيْنِ
u'غَيْرٌ مَحْصُورٌ':Added, #3: 3	غَيْرِ الْمَحْصُورَاتِ
u'غير مَحْصُورٌ':Added, #3: 3	غَيْرِ الْمَحْصُورَاتِ
u'غَيْرٌ مَحْصُورٌ':Added, #3: 3	غَيْرِ مَحْصُورَاتٍ
u'غير مَحْصُورٌ':Added, #3: 3	غَيْرِ مَحْصُورَاتٍ
u'غَيْرٌ مَحْصُورٌ':Added, #4: 4	غَيْرِ الْمَحْصُورِ
u'غير مَحْصُورٌ':Added, #4: 4	غَيْرِ الْمَحْصُورِ
u'غَيْرٌ مَحْصُورٌ':Added, #4: 4	غَيْرَ مَحْصُورَاتٍ
u'غير مَحْصُورٌ':Added, #4: 4	غَيْرَ مَحْصُورَاتٍ
u'غير مَحْصُورٌ':Added, #6: 6	غَيْرَ مَحْصُورٍ
u'غَيْرٌ مَحْصُورٌ':Added, #6: 6	غَيْرِ مَحْصُورٍ
u'غَيْرٌ مَحْصُورٌ':Added, #6: 6	غَيْرَ مَحْصُورٍ
u'غير مَحْصُورٌ':Added, #6: 6	غَيْرِ مَحْصُورٍ
u'غَيْرٌ مَحْصُورٌ':Added, #9: 9	غَيْرُ مَحْصُورَةٍ
u'غير مَحْض':Added, #9: 9	غَيْرُ مَحْصُورَةٍ
u'غَيْرٌ مَحْض':Added, #1: 1	غَيْرُ مَحْضَةٍ
u'غير مَحْضٌ':Added, #1: 1	غَيْرُ مَحْضَةٍ
u'غير مَحْضٌ':Added, #2: 2	غَيْرَ مَحْضِ
u'غَيْرٌ مَحْضٌ':Added, #2: 2	غَيْرِ مَحْضِ
u'غَيْرٌ مَحْضٌ':Added, #2: 2	غَيْرَ مَحْضِ
u'غير مَحْضَرٌ':Added, #2: 2	غَيْرِ مَحْضِ
u'غَيْرٌ مَحْضَرٌ':Added, #1: 1	غَيْرِ مَحْضَرِ
u'غير مَحْظُورٌ':Added, #1: 1	غَيْرِ مَحْضَرِ
u'غَيْرٌ مَحْظُورٌ':Added, #1: 1	غَيْرَ الْمَحْظُورِ
u'غير مَحْظُورٌ':Added, #1: 1	غَيْرَ الْمَحْظُورِ
u'غَيْرٌ مَحْظُورٌ':Added, #1: 1	غَيْرِ مَحْظُورَةٍ
u'غير مَحْظُورٌ':Added, #1: 1	غَيْرِ مَحْظُورَةٍ
u'غَيْرٌ مَحْظُورٌ':Added, #2: 2	غَيْرِ مَحْظُورٍ
u'غير مَحْظُورٌ':Added, #2: 2	غَيْرِ مَحْظُورٍ
u'غَيْرٌ مَحْظُورٌ':Added, #4: 4	غَيْرُ مَحْظُورٍ
u'غير مَحْظُورٌ':Added, #4: 4	غَيْرُ مَحْظُورٍ
u'غَيْرٌ مَحْظُورٌ':Added, #5: 5	غَيْرَ مَحْظُورٍ
u'غير مَحْظُوظٌ':Added, #5: 5	غَيْرَ مَحْظُورٍ
u'غَيْرٌ مَحْظُوظٌ':Added, #1: 1	غَيْرَ مَحْظُوظٍ
u'غير مَحْفُوظٌ':Added, #1: 1	غَيْرَ مَحْظُوظٍ
u'غَيْرٌ مَحْفُوظٌ':Added, #10: 10	غَيْرُ مَحْفُوظَةٍ
u'غير مَحْفُوظٌ':Added, #10: 10	غَيْرُ مَحْفُوظَةٍ
u'غَيْرٌ مَحْفُوظٌ':Added, #1: 1	غَيْرِ مَحْفُوظٍ
u'غير مَحْفُوظٌ':Added, #1: 1	غَيْرِ مَحْفُوظٍ
u'غَيْرٌ مَحْفُوظٌ':Added, #1: 1	غَيْرَ مَحْفُوظَةٍ
u'غير مَحْفُوظٌ':Added, #1: 1	غَيْرَ مَحْفُوظَةٍ
u'غَيْرٌ مَحْفُوظٌ':Added, #1: 1	غَيْرُ مَحْفُوظَيْنِ
u'غير مَحْفُوظٌ':Added, #1: 1	غَيْرُ مَحْفُوظَيْنِ
u'غَيْرٌ مَحْفُوظٌ':Added, #2: 2	غَيْرَ مَحْفُوظٍ
u'غير مَحْفُوظٌ':Added, #2: 2	غَيْرَ مَحْفُوظٍ
u'غَيْرٌ مَحْفُوظٌ':Added, #49: 49	غَيْرُ مَحْفُوظٍ
u'غير مُحِقٌّ':Added, #49: 49	غَيْرُ مَحْفُوظٍ
u'غَيْرٌ مُحِقٌّ':Added, #12: 12	غَيْرُ مُحِقٍّ
u'غير مُحَقَّقٌ':Added, #12: 12	غَيْرُ مُحِقٍّ
u'غَيْرٌ مُحَقَّقٌ':Added, #1: 1	غَيْرِ مُحَقَّقٍ
u'غير مُحَقَّقٌ':Added, #1: 1	غَيْرِ مُحَقَّقٍ
u'غَيْرٌ مُحَقَّقٌ':Added, #1: 1	غَيْرَ مُحَقَّقَةٍ
u'غير مُحَقَّقٌ':Added, #1: 1	غَيْرَ مُحَقَّقَةٍ
u'غَيْرٌ مُحَقَّقٌ':Added, #1: 1	غَيْرَ مُحَقَّقَيْنِ
u'غير مُحَقَّقٌ':Added, #1: 1	غَيْرَ مُحَقَّقَيْنِ
u'غير مُحَقِّقٌ':Added, #2: 2	غَيْرُ مُحَقَّقِ
u'غَيْرٌ مُحَقَّقٌ':Added, #2: 2	غَيْرُ مُحَقِّقٍ
u'غَيْرٌ مُحَقِّقٌ':Added, #2: 2	غَيْرُ مُحَقَّقِ
u'غير مُحَقَّقٌ':Added, #2: 2	غَيْرُ مُحَقِّقٍ
u'غَيْرٌ مُحَقَّقٌ':Added, #2: 2	غَيْرُ مُحَقَّقَةٍ
u'غير مُحَقَّقٌ':Added, #2: 2	غَيْرُ مُحَقَّقَةٍ
u'غَيْرٌ مُحَقَّقٌ':Added, #4: 4	غَيْرَ مُحَقَّقٍ
u'غير مُحَقَّقٌ':Added, #4: 4	غَيْرَ مُحَقَّقٍ
u'غَيْرٌ مُحَقَّقٌ':Added, #9: 9	غَيْرُ مُحَقَّقٍ
u'غير مُحْكَمٌ':Added, #9: 9	غَيْرُ مُحَقَّقٍ
u'غَيْرٌ مُحْكَمٌ':Added, #2: 2	غَيْرَ مُحْكَمٍ
u'غير مَحْكُومٌ':Added, #2: 2	غَيْرَ مُحْكَمٍ
u'غَيْرٌ مَحْكُومٌ':Added, #1: 1	غَيْرِ الْمَحْكُومِ
u'غير مَحْكُومٌ':Added, #1: 1	غَيْرِ الْمَحْكُومِ
u'غَيْرٌ مَحْكُومٌ':Added, #2: 2	غَيْرَ الْمَحْكُومِ
u'غير مَحْكُومٌ':Added, #2: 2	غَيْرَ الْمَحْكُومِ
u'غَيْرٌ مَحْكُومٌ':Added, #3: 3	غَيْرَ مَحْكُومٍ
u'غير مَحْكُومٌ':Added, #3: 3	غَيْرَ مَحْكُومٍ
u'غَيْرٌ مَحْكُومٌ':Added, #4: 4	غَيْرُ مَحْكُومٍ
u'غير مَحَلٌّ':Added, #4: 4	غَيْرُ مَحْكُومٍ
u'غَيْرٌ مَحَلٌّ':Added, #1: 1	غَيْرُ مَحَلِّهِ
u'غير مَحَلٌّ':Added, #1: 1	غَيْرُ مَحَلِّهِ
u'غَيْرٌ مَحَلٌّ':Added, #2: 2	غَيْرِ مَحَلٍّ
u'غير مَحَلٌّ':Added, #2: 2	غَيْرِ مَحَلٍّ
u'غَيْرٌ مَحَلٌّ':Added, #3: 3	غَيْرَ الْمَحَلِّ
u'غير مَحَلٌّ':Added, #3: 3	غَيْرَ الْمَحَلِّ
u'غَيْرٌ مَحَلٌّ':Added, #4: 4	غَيْرُ مَحَلِّ
u'غير مَحَلٌّ':Added, #4: 4	غَيْرُ مَحَلِّ
u'غَيْرٌ مَحَلٌّ':Added, #65: 65	غَيْرِ مَحَلِّهِ
u'غير مَحَلٌّ':Added, #65: 65	غَيْرِ مَحَلِّهِ
u'غَيْرٌ مَحَلٌّ':Added, #6: 6	غَيْرِ الْمَحَلِّ
u'غير مَحَلٌّ':Added, #6: 6	غَيْرِ الْمَحَلِّ
u'غَيْرٌ مَحَلٌّ':Added, #6: 6	غَيْرَ مَحَلِّ
u'غير مَحَلٌّ':Added, #6: 6	غَيْرَ مَحَلِّ
u'غَيْرٌ مَحَلٌّ':Added, #86: 86	غَيْرِ مَحَلِّ
u'غير مَحَلَّةٌ':Added, #86: 86	غَيْرِ مَحَلِّ
u'غَيْرٌ مَحَلَّةٌ':Added, #1: 1	غَيْرِ الْمَحَلَّةِ
u'غير مُحَلِّل':Added, #1: 1	غَيْرِ الْمَحَلَّةِ
u'غَيْرٌ مُحَلِّل':Added, #1: 1	غَيْرُ الْمُحَلِّلِ
u'غير مُحَلِّل':Added, #1: 1	غَيْرُ الْمُحَلِّلِ
u'غَيْرٌ مُحَلِّل':Added, #1: 1	غَيْرَ مُحَلّلِ
u'غير مُحَلِّل':Added, #1: 1	غَيْرَ مُحَلّلِ
u'غَيْرٌ مُحَلِّل':Added, #5: 5	غَيْرِ مُحَلِّلٍ
u'غير مَحْلُوجٌ':Added, #5: 5	غَيْرِ مُحَلِّلٍ
u'غَيْرٌ مَحْلُوجٌ':Added, #1: 1	غَيْرَ مَحْلُوجٍ
u'غير مَحْلُوجٌ':Added, #1: 1	غَيْرَ مَحْلُوجٍ
u'غَيْرٌ مَحْلُوجٌ':Added, #2: 2	غَيْرَ الْمَحْلُوجِ
u'غير مُحَمَّدٌ':Added, #2: 2	غَيْرَ الْمَحْلُوجِ
u'غير مُحَمَّدٌ':Added, #1: 1	غَيْرَ مُحَمّدٍ
u'غَيْرٌ مُحَمَّدٌ':Added, #1: 1	غَيْرَ مُحَمَّدٍ
u'غَيْرٌ مُحَمَّدٌ':Added, #1: 1	غَيْرَ مُحَمّدٍ
u'غير مُحَمَّدٌ':Added, #1: 1	غَيْرَ مُحَمَّدٍ
u'غير مُحَمَّدٌ':Added, #2: 2	غَيْرُ مُحَمَّدٍ
u'غَيْرٌ مُحَمَّدٌ':Added, #2: 2	غَيْرِ مُحَمَّدٍ
u'غَيْرٌ مُحَمَّدٌ':Added, #2: 2	غَيْرُ مُحَمَّدٍ
u'غير مُحَمَّدٌ':Added, #2: 2	غَيْرِ مُحَمَّدٍ
u'غَيْرٌ مُحَمَّدٌ':Added, #7: 7	غَيْرُ مُحَمَّدِ
u'غير مَحْمَدَةٌ':Added, #7: 7	غَيْرُ مُحَمَّدِ
u'غَيْرٌ مَحْمَدَةٌ':Added, #1: 1	غَيْرِ مَحْمَدَةٍ
u'غير مَحْمَلٌ':Added, #1: 1	غَيْرِ مَحْمَدَةٍ
u'غَيْرٌ مَحْمَلٌ':Added, #1: 1	غَيْرِ مَحْمَلِ
u'غير مَحْمُودٌ':Added, #1: 1	غَيْرِ مَحْمَلِ
u'غَيْرٌ مَحْمُودٌ':Added, #1: 1	غَيْرَ مَحْمُودٍ
u'غير مَحْمُودٌ':Added, #1: 1	غَيْرَ مَحْمُودٍ
u'غَيْرٌ مَحْمُودٌ':Added, #1: 1	غَيْرَ مَحْمُودَةٍ
u'غير مَحْمُودٌ':Added, #1: 1	غَيْرَ مَحْمُودَةٍ
u'غَيْرٌ مَحْمُودٌ':Added, #2: 2	غَيْرُ مَحْمُودٍ
u'غير مَحْمُودٌ':Added, #2: 2	غَيْرُ مَحْمُودٍ
u'غَيْرٌ مَحْمُودٌ':Added, #4: 4	غَيْرُ مَحْمُودَةٍ
u'غير مَحْمُولٌ':Added, #4: 4	غَيْرُ مَحْمُودَةٍ
u'غَيْرٌ مَحْمُولٌ':Added, #2: 2	غَيْرُ مَحْمُولٍ
u'غير مَحْمُولٌ':Added, #2: 2	غَيْرُ مَحْمُولٍ
u'غَيْرٌ مَحْمُولٌ':Added, #2: 2	غَيْرَ مَحْمُولَةٍ
u'غير مُحَنَّكٌ':Added, #2: 2	غَيْرَ مَحْمُولَةٍ
u'غَيْرٌ مُحَنَّكٌ':Added, #1: 1	غَيْرِ الْمُحَنَّكَةِ
u'غير مُحِيطٌ':Added, #1: 1	غَيْرِ الْمُحَنَّكَةِ
u'غَيْرٌ مُحِيطٌ':Added, #1: 1	غَيْرِ الْمُحِيطِ
u'غير مُحِيطٌ':Added, #1: 1	غَيْرِ الْمُحِيطِ
u'غَيْرٌ مُحِيطٌ':Added, #5: 5	غَيْرُ مُحِيطٍ
u'غير مُحِيطٌ':Added, #5: 5	غَيْرُ مُحِيطٍ
u'غَيْرٌ مُحِيطٌ':Added, #6: 6	غَيْرَ مُحِيطٍ
u'غير مُخاصِم':Added, #6: 6	غَيْرَ مُحِيطٍ
u'غَيْرٌ مُخاصِم':Added, #2: 2	غَيْرِ مُخَاصِمٍ
u'غير مُخَاصَمَةٌ':Added, #2: 2	غَيْرِ مُخَاصِمٍ
u'غَيْرٌ مُخَاصَمَةٌ':Added, #1: 1	غَيْرَ الْمُخَاصَمَةِ
u'غير مُخَاطَبٌ':Added, #1: 1	غَيْرَ الْمُخَاصَمَةِ
u'غَيْرٌ مُخَاطَبٌ':Added, #10: 10	غَيْرُ مُخَاطَبَةٍ
u'غير مُخَاطِبٌ':Added, #10: 10	غَيْرُ مُخَاطَبَةٍ
u'غَيْرٌ مُخَاطِبٌ':Added, #1: 1	غَيْرُ الْمُخَاطِبِ
u'غير مُخَاطَبٌ':Added, #1: 1	غَيْرُ الْمُخَاطِبِ
u'غَيْرٌ مُخَاطَبٌ':Added, #1: 1	غَيْرِ مُخَاطَبٍ
u'غير مُخَاطَبٌ':Added, #1: 1	غَيْرِ مُخَاطَبٍ
u'غَيْرٌ مُخَاطَبٌ':Added, #1: 1	غَيْرَ مُخَاطَبَةٍ
u'غير مُخَاطَبٌ':Added, #1: 1	غَيْرَ مُخَاطَبَةٍ
u'غَيْرٌ مُخَاطَبٌ':Added, #1: 1	غَيْرُ مُخَاطَبَيْنِ
u'غير مُخَاطَبٌ':Added, #1: 1	غَيْرُ مُخَاطَبَيْنِ
u'غَيْرٌ مُخَاطَبٌ':Added, #33: 33	غَيْرُ مُخَاطَبٍ
u'غير مُخَاطَبٌ':Added, #33: 33	غَيْرُ مُخَاطَبٍ
u'غَيْرٌ مُخَاطَبٌ':Added, #3: 3	غَيْرَ الْمُخَاطَبِ
u'غير مُخَاطَبٌ':Added, #3: 3	غَيْرَ الْمُخَاطَبِ
u'غَيْرٌ مُخَاطَبٌ':Added, #3: 3	غَيْرَ مُخَاطَبٍ
u'غير مُخَاطَبٌ':Added, #3: 3	غَيْرَ مُخَاطَبٍ
u'غَيْرٌ مُخَاطَبٌ':Added, #4: 4	غَيْرِ الْمُخَاطَبِ
u'غير مُخَاطَبَةٌ':Added, #4: 4	غَيْرِ الْمُخَاطَبِ
u'غَيْرٌ مُخَاطَبَةٌ':Added, #10: 10	غَيْرُ مُخَاطَبَةٍ
u'غير مُخَاطَبَةٌ':Added, #10: 10	غَيْرُ مُخَاطَبَةٍ
u'غَيْرٌ مُخَاطَبَةٌ':Added, #1: 1	غَيْرَ مُخَاطَبَةٍ
u'غير مُخَاطَرَةٌ':Added, #1: 1	غَيْرَ مُخَاطَبَةٍ
u'غَيْرٌ مُخَاطَرَةٌ':Added, #1: 1	غَيْرِ مُخَاطَرَةٍ
u'غير مَخَافَةٌ':Added, #1: 1	غَيْرِ مُخَاطَرَةٍ
u'غير مَخَافَة':Added, #2: 2	غَيْرِ مَخَافَةٍ
u'غَيْرٌ مَخَافَةٌ':Added, #2: 2	غَيْرِ مَخَافَةٍ
u'غَيْرٌ مَخَافَة':Added, #2: 2	غَيْرِ مَخَافَةٍ
u'غير مُخَالِفٌ':Added, #2: 2	غَيْرِ مَخَافَةٍ
u'غَيْرٌ مُخَالِفٌ':Added, #19: 19	غَيْرُ مُخَالِفٍ
u'غير مُخَالِفٌ':Added, #19: 19	غَيْرُ مُخَالِفٍ
u'غَيْرٌ مُخَالِفٌ':Added, #1: 1	غَيْرُ مُخَالِفَةٍ
u'غير مُخَالِفٌ':Added, #1: 1	غَيْرُ مُخَالِفَةٍ
u'غَيْرٌ مُخَالِفٌ':Added, #2: 2	غَيْرِ مُخَالِفٍ
u'غير مُخَالِفٌ':Added, #2: 2	غَيْرِ مُخَالِفٍ
u'غَيْرٌ مُخَالِفٌ':Added, #4: 4	غَيْرَ مُخَالِفٍ
u'غير مُخَالَفَةٌ':Added, #4: 4	غَيْرَ مُخَالِفٍ
u'غَيْرٌ مُخَالَفَةٌ':Added, #11: 11	غَيْرِ مُخَالَفَةٍ
u'غير مُخَالَفَةٌ':Added, #11: 11	غَيْرِ مُخَالَفَةٍ
u'غَيْرٌ مُخَالَفَةٌ':Added, #1: 1	غَيْرَ الْمُخَالَفَةِ
u'غير مُخَالَفَةٌ':Added, #1: 1	غَيْرَ الْمُخَالَفَةِ
u'غير مُخَالَفَةٌ':Added, #1: 1	غَيْر مُخَالَفَةٍ
u'غَيْرٌ مُخَالَفَةٌ':Added, #1: 1	غَيْرِ مُخَالَفَةِ
u'غَيْرٌ مُخَالَفَةٌ':Added, #1: 1	غَيْر مُخَالَفَةٍ
u'غير مُخْبِرٌ':Added, #1: 1	غَيْرِ مُخَالَفَةِ
u'غَيْرٌ مُخْبِرٌ':Added, #1: 1	غَيْرَ مُخْبِرٍ
u'غير مُخْتَارٌ':Added, #1: 1	غَيْرَ مُخْبِرٍ
u'غَيْرٌ مُخْتَارٌ':Added, #1: 1	غَيْرَ الْمُخْتَارِ
u'غير مُخْتَارٌ':Added, #1: 1	غَيْرَ الْمُخْتَارِ
u'غَيْرٌ مُخْتَارٌ':Added, #1: 1	غَيْرِ مُخْتَارِ
u'غير مُخْتَارٌ':Added, #1: 1	غَيْرِ مُخْتَارِ
u'غَيْرٌ مُخْتَارٌ':Added, #2: 2	غَيْرُ الْمُخْتَارِ
u'غير مُخْتَارٌ':Added, #2: 2	غَيْرُ الْمُخْتَارِ
u'غَيْرٌ مُخْتَارٌ':Added, #3: 3	غَيْرَ مُخْتَارٍ
u'غير مُخْتَارٌ':Added, #3: 3	غَيْرَ مُخْتَارٍ
u'غَيْرٌ مُخْتَارٌ':Added, #9: 9	غَيْرُ مُخْتَارٍ
u'غير مُخْتَصّ':Added, #9: 9	غَيْرُ مُخْتَارٍ
u'غير مُخْتَصّ':Added, #1: 1	غَيْرُ الْمُخْتَصِّ
u'غَيْرٌ مُخْتَصّ':Added, #1: 1	غَيْرِ الْمُخْتَصِّ
u'غَيْرٌ مُخْتَصّ':Added, #1: 1	غَيْرُ الْمُخْتَصِّ
u'غير مُخْتَصّ':Added, #1: 1	غَيْرِ الْمُخْتَصِّ
u'غَيْرٌ مُخْتَصّ':Added, #22: 22	غَيْرُ مُخْتَصٍّ
u'غير مُخْتَصّ':Added, #22: 22	غَيْرُ مُخْتَصٍّ
u'غَيْرٌ مُخْتَصّ':Added, #3: 3	غَيْرَ مُخْتَصٍّ
u'غير مُخْتَصّ':Added, #3: 3	غَيْرَ مُخْتَصٍّ
u'غَيْرٌ مُخْتَصّ':Added, #7: 7	غَيْرُ مُخْتَصَّةٍ
u'غير مُخْتَصَرٌ':Added, #7: 7	غَيْرُ مُخْتَصَّةٍ
u'غَيْرٌ مُخْتَصَرٌ':Added, #1: 1	غَيْرِ الْمُخْتَصَرِ
u'غير مُخْتَصَرٌ':Added, #1: 1	غَيْرِ الْمُخْتَصَرِ
u'غَيْرٌ مُخْتَصَرٌ':Added, #1: 1	غَيْرِ مُخْتَصَرِهِ
u'غير مُخْتَلِطٌ':Added, #1: 1	غَيْرِ مُخْتَصَرِهِ
u'غَيْرٌ مُخْتَلِطٌ':Added, #1: 1	غَيْرِ الْمُخْتَلِطِ
u'غير مُخْتَلَفٌ':Added, #1: 1	غَيْرِ الْمُخْتَلِطِ
u'غَيْرٌ مُخْتَلَفٌ':Added, #1: 1	غَيْرِ الْمُخْتَلَفِ
u'غير مُخْتَلَفٌ':Added, #1: 1	غَيْرِ الْمُخْتَلَفِ
u'غَيْرٌ مُخْتَلَفٌ':Added, #1: 1	غَيْرَ مُخْتَلَفٍ
u'غير مُخْتَلِفٌ':Added, #1: 1	غَيْرَ مُخْتَلَفٍ
u'غَيْرٌ مُخْتَلِفٌ':Added, #1: 1	غَيْرُ مُخْتَلِفَةٍ
u'غير مُخْتَلِفٌ':Added, #1: 1	غَيْرُ مُخْتَلِفَةٍ
u'غَيْرٌ مُخْتَلِفٌ':Added, #3: 3	غَيْرَ مُخْتَلِفٍ
u'غير مُخْتَلَفٌ':Added, #3: 3	غَيْرَ مُخْتَلِفٍ
u'غير مُخْتَلِفٌ':Added, #6: 6	غَيْرُ مُخْتَلَفٍ
u'غَيْرٌ مُخْتَلَفٌ':Added, #6: 6	غَيْرُ مُخْتَلِفٍ
u'غَيْرٌ مُخْتَلِفٌ':Added, #6: 6	غَيْرُ مُخْتَلَفٍ
u'غير مُخْتَمِر':Added, #6: 6	غَيْرُ مُخْتَلِفٍ
u'غَيْرٌ مُخْتَمِر':Added, #1: 1	غَيْرَ مُخْتَمِرَةٍ
u'غير مَخْتُومٌ':Added, #1: 1	غَيْرَ مُخْتَمِرَةٍ
u'غَيْرٌ مَخْتُومٌ':Added, #1: 1	غَيْرُ مَخْتُومٍ
u'غير مَخْتُومٌ':Added, #1: 1	غَيْرُ مَخْتُومٍ
u'غَيْرٌ مَخْتُومٌ':Added, #4: 4	غَيْرَ مَخْتُومَةٍ
u'غير مَخْتُومٌ':Added, #4: 4	غَيْرَ مَخْتُومَةٍ
u'غَيْرٌ مَخْتُومٌ':Added, #5: 5	غَيْرَ مَخْتُومٍ
u'غير مَخْتُونٌ':Added, #5: 5	غَيْرَ مَخْتُومٍ
u'غَيْرٌ مَخْتُونٌ':Added, #1: 1	غَيْرَ الْمَخْتُونِ
u'غير مَخْتُونٌ':Added, #1: 1	غَيْرَ الْمَخْتُونِ
u'غَيْرٌ مَخْتُونٌ':Added, #3: 3	غَيْرَ مَخْتُونٍ
u'غير مُخَدَّرٌ':Added, #3: 3	غَيْرَ مَخْتُونٍ
u'غَيْرٌ مُخَدَّرٌ':Added, #1: 1	غَيْرُ الْمُخَدَّرَةِ
u'غير مُخَدَّرٌ':Added, #1: 1	غَيْرُ الْمُخَدَّرَةِ
u'غَيْرٌ مُخَدَّرٌ':Added, #1: 1	غَيْرُ مُخَدَّرَةٍ
u'غير مُخَدَّرٌ':Added, #1: 1	غَيْرُ مُخَدَّرَةٍ
u'غَيْرٌ مُخَدَّرٌ':Added, #2: 2	غَيْرَ مُخَدَّرَةٍ
u'غير مَخْدُوعٌ':Added, #2: 2	غَيْرَ مُخَدَّرَةٍ
u'غَيْرٌ مَخْدُوعٌ':Added, #1: 1	غَيْرَ مَخْدُوعٍ
u'غير مَخْذُولٌ':Added, #1: 1	غَيْرَ مَخْدُوعٍ
u'غَيْرٌ مَخْذُولٌ':Added, #1: 1	غَيْرِ مَخْذُولِ
u'غير مَخْرَجٌ':Added, #1: 1	غَيْرِ مَخْذُولِ
u'غير مَخْرَجٌ':Added, #1: 1	غَيْرُ مَخْرَجِ
u'غير مُخْرِجٌ':Added, #1: 1	غَيْرِ مَخْرَجِ
u'غير مُخْرِجٌ':Added, #1: 1	غَيْرَ مُخْرِجِ
u'غَيْرٌ مَخْرَجٌ':Added, #1: 1	غَيْرُ مُخْرِجِ
u'غَيْرٌ مَخْرَجٌ':Added, #1: 1	غَيْرُ مَخْرَجِ
u'غَيْرٌ مُخْرِجٌ':Added, #1: 1	غَيْرِ مَخْرَجِ
u'غَيْرٌ مُخْرِجٌ':Added, #1: 1	غَيْرَ مُخْرِجِ
u'غير مُخْرِجٌ':Added, #1: 1	غَيْرُ مُخْرِجِ
u'غَيْرٌ مُخْرِجٌ':Added, #1: 1	غَيْرُ مُخْرِجِهِ
u'غير مُخْرِجٌ':Added, #1: 1	غَيْرُ مُخْرِجِهِ
u'غَيْرٌ مُخْرِجٌ':Added, #2: 2	غَيْرُ مُخْرِجٍ
u'غير مَخْرَجٌ':Added, #2: 2	غَيْرُ مُخْرِجٍ
u'غَيْرٌ مَخْرَجٌ':Added, #2: 2	غَيْرِ مَخْرَجِهِ
u'غير مَخْرَجٌ':Added, #2: 2	غَيْرِ مَخْرَجِهِ
u'غَيْرٌ مَخْرَجٌ':Added, #3: 3	غَيْرِ الْمَخْرَجِ
u'غير مُخَصَّصٌ':Added, #3: 3	غَيْرِ الْمَخْرَجِ
u'غَيْرٌ مُخَصَّصٌ':Added, #1: 1	غَيْرُ مُخَصَّصٍ
u'غير مَخْصُوصٌ':Added, #1: 1	غَيْرُ مُخَصَّصٍ
u'غَيْرٌ مَخْصُوصٌ':Added, #1: 1	غَيْر مَخْصُوصٍ
u'غير مَخْصُوصٌ':Added, #1: 1	غَيْر مَخْصُوصٍ
u'غَيْرٌ مَخْصُوصٌ':Added, #4: 4	غَيْرُ مَخْصُوصٍ
u'غير مُخْطِئٌ':Added, #4: 4	غَيْرُ مَخْصُوصٍ
u'غَيْرٌ مُخْطِئٌ':Added, #1: 1	غَيْرُ مُخْطِئَةٍ
u'غير مُخْطِئٌ':Added, #1: 1	غَيْرُ مُخْطِئَةٍ
u'غَيْرٌ مُخْطِئٌ':Added, #2: 2	غَيْرُ مُخْطِئٍ
u'غير مُخِلٌّ':Added, #2: 2	غَيْرُ مُخْطِئٍ
u'غَيْرٌ مُخِلٌّ':Added, #1: 1	غَيْرِ مُخِلَّيْنِ
u'غير مُخِلٌّ':Added, #1: 1	غَيْرِ مُخِلَّيْنِ
u'غَيْرٌ مُخِلٌّ':Added, #3: 3	غَيْرُ مُخِلَّةٍ
u'غير مُخِلٌّ':Added, #3: 3	غَيْرُ مُخِلَّةٍ
u'غَيْرٌ مُخِلٌّ':Added, #7: 7	غَيْرُ مُخِلٍّ
u'غير مِخْلاَفٌ':Added, #7: 7	غَيْرُ مُخِلٍّ
u'غَيْرٌ مِخْلاَفٌ':Added, #1: 1	غَيْرِ مِخْلاَفِ
u'غير مِخْلاَفٌ':Added, #1: 1	غَيْرِ مِخْلاَفِ
u'غَيْرٌ مِخْلاَفٌ':Added, #2: 2	غَيْرِ مِخْلَافِ
u'غير مُخَلِّصٌ':Added, #2: 2	غَيْرِ مِخْلَافِ
u'غَيْرٌ مُخَلِّصٌ':Added, #1: 1	غَيْرُ مُخَلِّصٍ
u'غير مُخَلِّصٌ':Added, #1: 1	غَيْرُ مُخَلِّصٍ
u'غَيْرٌ مُخَلِّصٌ':Added, #1: 1	غَيْرَ مُخَلِّصَةٍ
u'غير مُخْلِصٌ':Added, #1: 1	غَيْرَ مُخَلِّصَةٍ
u'غَيْرٌ مُخْلِصٌ':Added, #2: 2	غَيْرُ مُخْلِصٍ
u'غير مَخْلُوطٌ':Added, #2: 2	غَيْرُ مُخْلِصٍ
u'غَيْرٌ مَخْلُوطٌ':Added, #1: 1	غَيْرِ مَخْلُوطٍ
u'غير مَخْلُوطٌ':Added, #1: 1	غَيْرِ مَخْلُوطٍ
u'غَيْرٌ مَخْلُوطٌ':Added, #3: 3	غَيْرِ الْمَخْلُوطِ
u'غير مَخْلُوطٌ':Added, #3: 3	غَيْرِ الْمَخْلُوطِ
u'غَيْرٌ مَخْلُوطٌ':Added, #7: 7	غَيْرَ مَخْلُوطٍ
u'غير مَخْلُوقٌ':Added, #7: 7	غَيْرَ مَخْلُوطٍ
u'غَيْرٌ مَخْلُوقٌ':Added, #12: 12	غَيْرُ مَخْلُوقٍ
u'غير مَخْلُوقٌ':Added, #12: 12	غَيْرُ مَخْلُوقٍ
u'غَيْرٌ مَخْلُوقٌ':Added, #1: 1	غَيْرُ مَخْلُوقَةٍ
u'غير مَخُوفٌ':Added, #1: 1	غَيْرُ مَخْلُوقَةٍ
u'غير مَخُوفٌ':Added, #1: 1	غَيْرَ الْمَخُوفِ
u'غَيْرٌ مَخُوفٌ':Added, #1: 1	غَيْرُ الْمَخُوفِ
u'غَيْرٌ مَخُوفٌ':Added, #1: 1	غَيْرَ الْمَخُوفِ
u'غير مَخُوفٌ':Added, #1: 1	غَيْرُ الْمَخُوفِ
u'غَيْرٌ مَخُوفٌ':Added, #2: 2	غَيْرِ مَخُوفٍ
u'غير مَخُوفٌ':Added, #2: 2	غَيْرِ مَخُوفٍ
u'غَيْرٌ مَخُوفٌ':Added, #5: 5	غَيْرِ الْمَخُوفِ
u'غير مَخُوفٌ':Added, #5: 5	غَيْرِ الْمَخُوفِ
u'غَيْرٌ مَخُوفٌ':Added, #5: 5	غَيْرَ مَخُوفٍ
u'غير مَخُوفٌ':Added, #5: 5	غَيْرَ مَخُوفٍ
u'غَيْرٌ مَخُوفٌ':Added, #6: 6	غَيْرُ مَخُوفٍ
u'غير مُخَيَّرٌ':Added, #6: 6	غَيْرُ مَخُوفٍ
u'غَيْرٌ مُخَيَّرٌ':Added, #2: 2	غَيْرُ الْمُخَيَّرِ
u'غير مُخَيَّرٌ':Added, #2: 2	غَيْرُ الْمُخَيَّرِ
u'غَيْرٌ مُخَيَّرٌ':Added, #2: 2	غَيْرُ مُخَيَّرٍ
u'غير مَخِيضٌ':Added, #2: 2	غَيْرُ مُخَيَّرٍ
u'غَيْرٌ مَخِيضٌ':Added, #1: 1	غَيْرِ الْمَخِيضِ
u'غير مَخِيضٌ':Added, #1: 1	غَيْرِ الْمَخِيضِ
u'غَيْرٌ مَخِيضٌ':Added, #2: 2	غَيْرُ الْمَخِيضِ
u'غير مِخْيَطٌ':Added, #2: 2	غَيْرُ الْمَخِيضِ
u'غَيْرٌ مِخْيَطٌ':Added, #1: 1	غَيْرَ مِخْيَطٍ
u'غير مُدٌّ':Added, #1: 1	غَيْرَ مِخْيَطٍ
u'غَيْرٌ مُدٌّ':Added, #1: 1	غَيْرُ مُدِّ
u'غير مُدَاهَنَةٌ':Added, #1: 1	غَيْرُ مُدِّ
u'غَيْرٌ مُدَاهَنَةٌ':Added, #1: 1	غَيْرِ مُدَاهَنَةٍ
u'غير مُدَاوَمَةٌ':Added, #1: 1	غَيْرِ مُدَاهَنَةٍ
u'غَيْرٌ مُدَاوَمَةٌ':Added, #1: 1	غَيْرِ مُدَاوَمَةِ
u'غير مُدَاوَمَةٌ':Added, #1: 1	غَيْرِ مُدَاوَمَةِ
u'غَيْرٌ مُدَاوَمَةٌ':Added, #2: 2	غَيْرُ الْمُدَاوَمَةِ
u'غير مُدْبِرٌ':Added, #2: 2	غَيْرُ الْمُدَاوَمَةِ
u'غَيْرٌ مُدْبِرٌ':Added, #11: 11	غَيْرَ مُدْبِرٍ
u'غير مُدَبَّرٌ':Added, #11: 11	غَيْرَ مُدْبِرٍ
u'غَيْرٌ مُدَبَّرٌ':Added, #1: 1	غَيْرُ الْمُدَبَّرِ
u'غير مُدَبَّرٌ':Added, #1: 1	غَيْرُ الْمُدَبَّرِ
u'غَيْرٌ مُدَبَّرٌ':Added, #1: 1	غَيْرُ مُدَبَّرَةٍ
u'غير مُدَبَّرٌ':Added, #1: 1	غَيْرُ مُدَبَّرَةٍ
u'غَيْرٌ مُدَبَّرٌ':Added, #2: 2	غَيْرَ مُدَبَّرَةٍ
u'غير مُدَبَّرٌ':Added, #2: 2	غَيْرَ مُدَبَّرَةٍ
u'غَيْرٌ مُدَبَّرٌ':Added, #3: 3	غَيْرَ مُدَبَّرٍ
u'غير مُدَبَّرٌ':Added, #3: 3	غَيْرَ مُدَبَّرٍ
u'غَيْرٌ مُدَبَّرٌ':Added, #4: 4	غَيْرُ مُدَبَّرٍ
u'غير مَدْبُوغٌ':Added, #4: 4	غَيْرُ مُدَبَّرٍ
u'غَيْرٌ مَدْبُوغٌ':Added, #12: 12	غَيْرَ مَدْبُوغٍ
u'غير مَدْبُوغٌ':Added, #12: 12	غَيْرَ مَدْبُوغٍ
u'غير مَدْبُوغٌ':Added, #1: 1	غَيْرَ الْمَدْبُوغِ
u'غَيْرٌ مَدْبُوغٌ':Added, #1: 1	غَيْرُ الْمَدْبُوغِ
u'غَيْرٌ مَدْبُوغٌ':Added, #1: 1	غَيْرَ الْمَدْبُوغِ
u'غير مَدْبُوغٌ':Added, #1: 1	غَيْرُ الْمَدْبُوغِ
u'غَيْرٌ مَدْبُوغٌ':Added, #1: 1	غَيْرُ مَدْبُوغٍ
u'غير مَدْبُوغٌ':Added, #1: 1	غَيْرُ مَدْبُوغٍ
u'غَيْرٌ مَدْبُوغٌ':Added, #5: 5	غَيْرِ مَدْبُوغٍ
u'غير مُدَّةٌ':Added, #5: 5	غَيْرِ مَدْبُوغٍ
u'غَيْرٌ مُدَّةٌ':Added, #1: 1	غَيْرِ الْمُدَّةِ
u'غير مُدَّةٌ':Added, #1: 1	غَيْرِ الْمُدَّةِ
u'غَيْرٌ مُدَّةٌ':Added, #2: 2	غَيْرِ مُدَّةِ
u'غير مُدَّةٌ':Added, #2: 2	غَيْرِ مُدَّةِ
u'غَيْرٌ مُدَّةٌ':Added, #5: 5	غَيْرِ مُدَّةٍ
u'غير مُدَّخَر':Added, #5: 5	غَيْرِ مُدَّةٍ
u'غَيْرٌ مُدَّخَر':Added, #1: 1	غَيْرِ الْمُدَّخَرِ
u'غير مَدْخَلٌ':Added, #1: 1	غَيْرِ الْمُدَّخَرِ
u'غَيْرٌ مَدْخَلٌ':Added, #2: 2	غَيْرِ مَدْخَلٍ
u'غَيَّرَ مَدْخُولٌ':Predicate, #2: 2	غَيْرِ مَدْخَلٍ
u'غير مَدْخُولٌ':Added, #1: 1	غَيَّرَ الْمَدْخُولَ
u'غَيْرٌ مَدْخُولٌ':Added, #11: 11	غَيْرُ مَدْخُولٍ
u'غير مَدْخُولٌ':Added, #11: 11	غَيْرُ مَدْخُولٍ
u'غَيْرٌ مَدْخُولٌ':Added, #12: 12	غَيْرَ مَدْخُولَةٍ
u'غير مَدْخُولٌ':Added, #12: 12	غَيْرَ مَدْخُولَةٍ
u'غَيْرٌ مَدْخُولٌ':Added, #15: 15	غَيْرِ الْمَدْخُولَةِ
u'غير مَدْخُولٌ':Added, #15: 15	غَيْرِ الْمَدْخُولَةِ
u'غَيْرٌ مَدْخُولٌ':Added, #1: 1	غَيْرِ الْمَدْخُولَيْنِ
u'غير مَدْخُولٌ':Added, #1: 1	غَيْرِ الْمَدْخُولَيْنِ
u'غَيْرٌ مَدْخُولٌ':Added, #1: 1	غَيْرُ مَدْخُولِ
u'غير مَدْخُولٌ':Added, #1: 1	غَيْرُ مَدْخُولِ
u'غَيْرٌ مَدْخُولٌ':Added, #1: 1	غَيْرِ مَدْخُولَةٍ
u'غير مَدْخُولٌ':Added, #1: 1	غَيْرِ مَدْخُولَةٍ
u'غَيْرٌ مَدْخُولٌ':Added, #20: 20	غَيْرُ الْمَدْخُولِ
u'غير مَدْخُولٌ':Added, #20: 20	غَيْرُ الْمَدْخُولِ
u'غَيْرٌ مَدْخُولٌ':Added, #2: 2	غَيْرُ مَدْخُولَاتٍ
u'غير مَدْخُولٌ':Added, #2: 2	غَيْرُ مَدْخُولَاتٍ
u'غَيْرٌ مَدْخُولٌ':Added, #35: 35	غَيْرِ الْمَدْخُولِ
u'غير مَدْخُولٌ':Added, #35: 35	غَيْرِ الْمَدْخُولِ
u'غَيْرٌ مَدْخُولٌ':Added, #3: 3	غَيْرَ الْمَدْخُولَةِ
u'غير مَدْخُولٌ':Added, #3: 3	غَيْرَ الْمَدْخُولَةِ
u'غَيْرٌ مَدْخُولٌ':Added, #3: 3	غَيْرُ مَدْخُولَةٍ
u'غير مَدْخُولٌ':Added, #3: 3	غَيْرُ مَدْخُولَةٍ
u'غَيْرٌ مَدْخُولٌ':Added, #48: 48	غَيْرَ مَدْخُولٍ
u'غير مَدْخُولٌ':Added, #48: 48	غَيْرَ مَدْخُولٍ
u'غَيْرٌ مَدْخُولٌ':Added, #4: 4	غَيْرُ الْمَدْخُولَةِ
u'غير مَدْخُولٌ':Added, #4: 4	غَيْرُ الْمَدْخُولَةِ
u'غَيْرٌ مَدْخُولٌ':Added, #7: 7	غَيْرَ الْمَدْخُولِ
u'غير مَدْخُولٌ':Added, #7: 7	غَيْرَ الْمَدْخُولِ
u'غَيْرٌ مَدْخُولٌ':Added, #8: 8	غَيْرِ مَدْخُولٍ
u'غير مُدَرِّسٌ':Added, #8: 8	غَيْرِ مَدْخُولٍ
u'غَيْرٌ مُدَرِّسٌ':Added, #1: 1	غَيْرَ مُدَرِّسٍ
u'غير مَدْرَسَةٌ':Added, #1: 1	غَيْرَ مُدَرِّسٍ
u'غَيْرٌ مَدْرَسَةٌ':Added, #1: 1	غَيْرِ مَدْرَسَتِهِ
u'غير مُدْرِكٌ':Added, #1: 1	غَيْرِ مَدْرَسَتِهِ
u'غَيْرٌ مُدْرِكٌ':Added, #1: 1	غَيْرِ الْمُدْرِكِ
u'غير مُدْرِكٌ':Added, #1: 1	غَيْرِ الْمُدْرِكِ
u'غير مُدْرِكٌ':Added, #1: 1	غَيْرَ مُدْرِكٍ
u'غَيْرٌ مُدْرِكٌ':Added, #1: 1	غَيْرِ مُدْرِكٍ
u'غَيْرٌ مُدْرِكٌ':Added, #1: 1	غَيْرَ مُدْرِكٍ
u'غير مُدْرِكٌ':Added, #1: 1	غَيْرِ مُدْرِكٍ
u'غَيْرٌ مُدْرِكٌ':Added, #2: 2	غَيْرُ مُدْرِكٍ
u'غير مُدْرَكٌ':Added, #2: 2	غَيْرُ مُدْرِكٍ
u'غَيْرٌ مُدْرَكٌ':Added, #3: 3	غَيْرَ مُدْرَكٍ
u'غير مَدْعُوٌّ':Added, #3: 3	غَيْرَ مُدْرَكٍ
u'غَيْرٌ مَدْعُوٌّ':Added, #3: 3	غَيْرُ مَدْعُوٍّ
u'غير مُدَّعِي':Added, #3: 3	غَيْرُ مَدْعُوٍّ
u'غَيْرٌ مُدَّعِي':Added, #1: 1	غَيْرِ الْمُدَّعِيَةِ
u'غير مُدَّعِي':Added, #1: 1	غَيْرِ الْمُدَّعِيَةِ
u'غَيْرٌ مُدَّعِي':Added, #1: 1	غَيْرِ الْمُدَّعِيَيْنِ
u'غير مَدْفُوعٌ':Added, #1: 1	غَيْرِ الْمُدَّعِيَيْنِ
u'غَيْرٌ مَدْفُوعٌ':Added, #2: 2	غَيْرُ الْمَدْفُوعِ
u'غير مَدْفُوعٌ':Added, #2: 2	غَيْرُ الْمَدْفُوعِ
u'غَيْرٌ مَدْفُوعٌ':Added, #2: 2	غَيْرُ مَدْفُوعٍ
u'غير مَدْفُونٌ':Added, #2: 2	غَيْرُ مَدْفُوعٍ
u'غَيْرٌ مَدْفُونٌ':Added, #1: 1	غَيْرَ مَدْفُونٍ
u'غير مَدْقُوق':Added, #1: 1	غَيْرَ مَدْفُونٍ
u'غَيْرٌ مَدْقُوق':Added, #1: 1	غَيْرِ الْمَدْقُوقَةِ
u'غير مَدْقُوق':Added, #1: 1	غَيْرِ الْمَدْقُوقَةِ
u'غَيْرٌ مَدْقُوق':Added, #2: 2	غَيْرَ مَدْقُوقٍ
u'غير مُدَلَّس':Added, #2: 2	غَيْرَ مَدْقُوقٍ
u'غَيْرٌ مُدَلَّس':Added, #1: 1	غَيْرَ مُدَلَّسٍ
u'غير مَدْلُولٌ':Added, #1: 1	غَيْرَ مُدَلَّسٍ
u'غَيْرٌ مَدْلُولٌ':Added, #1: 1	غَيْرَ الْمَدْلُولِ
u'غير مَدْلُولٌ':Added, #1: 1	غَيْرَ الْمَدْلُولِ
u'غير مَدْلُولٌ':Added, #1: 1	غَيْرَ مَدْلُولٍ
u'غَيْرٌ مَدْلُولٌ':Added, #1: 1	غَيْرُ مَدْلُولِ
u'غَيْرٌ مَدْلُولٌ':Added, #1: 1	غَيْرَ مَدْلُولٍ
u'غير مَدْلُولٌ':Added, #1: 1	غَيْرُ مَدْلُولِ
u'غَيْرٌ مَدْلُولٌ':Added, #1: 1	غَيْرَ مَدْلُولِهِ
u'غير مَدْلُولٌ':Added, #1: 1	غَيْرَ مَدْلُولِهِ
u'غير مَدْلُولٌ':Added, #2: 2	غَيْرُ مَدْلُولِهِ
u'غَيْرٌ مَدْلُولٌ':Added, #2: 2	غَيْرِ مَدْلُولِهِ
u'غَيْرٌ مَدْلُولٌ':Added, #2: 2	غَيْرُ مَدْلُولِهِ
u'غير مَدْلُولٌ':Added, #2: 2	غَيْرِ مَدْلُولِهِ
u'غَيْرٌ مَدْلُولٌ':Added, #3: 3	غَيْرُ مَدْلُولٍ
u'غير مَدَنِيٌّ':Added, #3: 3	غَيْرُ مَدْلُولٍ
u'غَيْرٌ مَدَنِيٌّ':Added, #1: 1	غَيْرِ الْمَدَنِيِّ
u'غير مُدَوَّرٌ':Added, #1: 1	غَيْرِ الْمَدَنِيِّ
u'غَيْرٌ مُدَوَّرٌ':Added, #1: 1	غَيْرَ مُدَوَّرٍ
u'غير مُدَوَّنٌ':Added, #1: 1	غَيْرَ مُدَوَّرٍ
u'غَيْرٌ مُدَوَّنٌ':Added, #13: 13	غَيْرِ الْمُدَوَّنَةِ
u'غير مُدَوَّنَةٌ':Added, #13: 13	غَيْرِ الْمُدَوَّنَةِ
u'غَيْرٌ مُدَوَّنَةٌ':Added, #13: 13	غَيْرِ الْمُدَوَّنَةِ
u'غير مِدْيَانٌ':Added, #13: 13	غَيْرِ الْمُدَوَّنَةِ
u'غَيْرٌ مِدْيَانٌ':Added, #1: 1	غَيْرِ الْمِدْيَانِ
u'غير مُدِيرٌ':Added, #1: 1	غَيْرِ الْمِدْيَانِ
u'غَيْرٌ مُدِيرٌ':Added, #1: 1	غَيْرُ مُدِيرٍ
u'غير مُدِيرٌ':Added, #1: 1	غَيْرُ مُدِيرٍ
u'غَيْرٌ مُدِيرٌ':Added, #1: 1	غَيْرَ مُدِيرَيْنِ
u'غير مُدِيرٌ':Added, #1: 1	غَيْرَ مُدِيرَيْنِ
u'غَيْرٌ مُدِيرٌ':Added, #4: 4	غَيْرُ الْمُدِيرِ
u'غير مُدِيرٌ':Added, #4: 4	غَيْرُ الْمُدِيرِ
u'غَيْرٌ مُدِيرٌ':Added, #5: 5	غَيْرَ مُدِيرٍ
u'غير مَدِينٌ':Added, #5: 5	غَيْرَ مُدِيرٍ
u'غَيْرٌ مَدِينٌ':Added, #1: 1	غَيْرِ مَدِينَةِ
u'غير مَدِينٌ':Added, #1: 1	غَيْرِ مَدِينَةِ
u'غَيْرٌ مَدِينٌ':Added, #3: 3	غَيْرِ الْمَدِينِ
u'غير مَدِينٌ':Added, #3: 3	غَيْرِ الْمَدِينِ
u'غَيْرٌ مَدِينٌ':Added, #7: 7	غَيْرِ الْمَدِينَةِ
u'غير مَدِينَةٌ':Added, #7: 7	غَيْرِ الْمَدِينَةِ
u'غَيْرٌ مَدِينَةٌ':Added, #1: 1	غَيْرِ مَدِينَةِ
u'غير مَدِينَةٌ':Added, #1: 1	غَيْرِ مَدِينَةِ
u'غَيْرٌ مَدِينَةٌ':Added, #7: 7	غَيْرِ الْمَدِينَةِ
u'غير مَدْيُونٌ':Added, #7: 7	غَيْرِ الْمَدِينَةِ
u'غَيْرٌ مَدْيُونٌ':Added, #1: 1	غَيْرَ الْمَدْيُونِ
u'غير مَدْيُونٌ':Added, #1: 1	غَيْرَ الْمَدْيُونِ
u'غَيْرٌ مَدْيُونٌ':Added, #1: 1	غَيْرُ مَدْيُونٍ
u'غير مَدْيُونٌ':Added, #1: 1	غَيْرُ مَدْيُونٍ
u'غَيْرٌ مَدْيُونٌ':Added, #2: 2	غَيْرُ الْمَدْيُونِ
u'غير مَدْيُونٌ':Added, #2: 2	غَيْرُ الْمَدْيُونِ
u'غَيْرٌ مَدْيُونٌ':Added, #3: 3	غَيْرِ الْمَدْيُونِ
u'غير مَدْيُونٌ':Added, #3: 3	غَيْرِ الْمَدْيُونِ
u'غير مَدْيُونٌ':Added, #4: 4	غَيْرَ مَدْيُونٍ
u'غَيْرٌ مَدْيُونٌ':Added, #4: 4	غَيْرِ مَدْيُونٍ
u'غَيْرٌ مَدْيُونٌ':Added, #4: 4	غَيْرَ مَدْيُونٍ
u'غير مَذْبَحٌ':Added, #4: 4	غَيْرِ مَدْيُونٍ
u'غَيْرٌ مَذْبَحٌ':Added, #1: 1	غَيْرَ الْمَذْبَحِ
u'غير مَذْبَحٌ':Added, #1: 1	غَيْرَ الْمَذْبَحِ
u'غَيْرٌ مَذْبَحٌ':Added, #5: 5	غَيْرِ الْمَذْبَحِ
u'غير مَذْبُوحٌ':Added, #5: 5	غَيْرِ الْمَذْبَحِ
u'غَيْرٌ مَذْبُوحٌ':Added, #1: 1	غَيْرَ مَذْبُوحٍ
u'غير مُذَكِّرَةٌ':Added, #1: 1	غَيْرَ مَذْبُوحٍ
u'غَيْرٌ مُذَكِّرَةٌ':Added, #1: 1	غَيْرُ مُذَكِّرَةٍ
u'غير مَذْكُورٌ':Added, #1: 1	غَيْرُ مُذَكِّرَةٍ
u'غَيْرٌ مَذْكُورٌ':Added, #12: 12	غَيْرِ الْمَذْكُورِ
u'غير مَذْكُورٌ':Added, #12: 12	غَيْرِ الْمَذْكُورِ
u'غَيْرٌ مَذْكُورٌ':Added, #12: 12	غَيْرِ مَذْكُورٍ
u'غير مَذْكُورٌ':Added, #12: 12	غَيْرِ مَذْكُورٍ
u'غَيْرٌ مَذْكُورٌ':Added, #1: 1	غَيْرُ الْمَذْكُورَةِ
u'غير مَذْكُورٌ':Added, #1: 1	غَيْرُ الْمَذْكُورَةِ
u'غَيْرٌ مَذْكُورٌ':Added, #28: 28	غَيْرُ مَذْكُورٍ
u'غير مَذْكُورٌ':Added, #28: 28	غَيْرُ مَذْكُورٍ
u'غَيْرٌ مَذْكُورٌ':Added, #2: 2	غَيْرُ الْمَذْكُورِ
u'غير مَذْكُورٌ':Added, #2: 2	غَيْرُ الْمَذْكُورِ
u'غَيْرٌ مَذْكُورٌ':Added, #2: 2	غَيْرِ الْمَذْكُورَاتِ
u'غير مَذْكُورٌ':Added, #2: 2	غَيْرِ الْمَذْكُورَاتِ
u'غَيْرٌ مَذْكُورٌ':Added, #3: 3	غَيْرَ الْمَذْكُورِ
u'غير مَذْكُورٌ':Added, #3: 3	غَيْرَ الْمَذْكُورِ
u'غَيْرٌ مَذْكُورٌ':Added, #3: 3	غَيْرَ مَذْكُورٍ
u'غير مَذْكُورٌ':Added, #3: 3	غَيْرَ مَذْكُورٍ
u'غَيْرٌ مَذْكُورٌ':Added, #7: 7	غَيْرُ مَذْكُورَةٍ
u'غير مُذَمَّمٌ':Added, #7: 7	غَيْرُ مَذْكُورَةٍ
u'غَيْرٌ مُذَمَّمٌ':Added, #1: 1	غَيْرَ مُذَمّمِ
u'غير مَذْمُومٌ':Added, #1: 1	غَيْرَ مُذَمّمِ
u'غَيْرٌ مَذْمُومٌ':Added, #1: 1	غَيْرَ مَذْمُومٍ
u'غير مَذْمُومٌ':Added, #1: 1	غَيْرَ مَذْمُومٍ
u'غَيْرٌ مَذْمُومٌ':Added, #1: 1	غَيْرُ مَذْمُومَةٍ
u'غير مَذْمُومٌ':Added, #1: 1	غَيْرُ مَذْمُومَةٍ
u'غَيْرٌ مَذْمُومٌ':Added, #3: 3	غَيْرُ مَذْمُومٍ
u'غير مَذْهَبٌ':Added, #3: 3	غَيْرُ مَذْمُومٍ
u'غَيْرٌ مَذْهَبٌ':Added, #1: 1	غَيْرَ الْمَذْهَبِ
u'غير مَذْهَبٌ':Added, #1: 1	غَيْرَ الْمَذْهَبِ
u'غَيْرٌ مَذْهَبٌ':Added, #1: 1	غَيْرَ الْمَذْهَبَيْنِ
u'غير مَذْهَبٌ':Added, #1: 1	غَيْرَ الْمَذْهَبَيْنِ
u'غَيْرٌ مَذْهَبٌ':Added, #1: 1	غَيْرُ مَذْهَبٍ
u'غير مَذْهَبٌ':Added, #1: 1	غَيْرُ مَذْهَبٍ
u'غَيْرٌ مَذْهَبٌ':Added, #1: 1	غَيْرَ مَذْهَبِهِ
u'غير مَذْهَبٌ':Added, #1: 1	غَيْرَ مَذْهَبِهِ
u'غير مَذْهَبٌ':Added, #2: 2	غَيْرُ مَذْهَبِ
u'غَيْرٌ مَذْهَبٌ':Added, #2: 2	غَيْرِ مَذْهَبِ
u'غَيْرٌ مَذْهَبٌ':Added, #2: 2	غَيْرُ مَذْهَبِ
u'غير مَذْهَبٌ':Added, #2: 2	غَيْرِ مَذْهَبِ
u'غَيْرٌ مَذْهَبٌ':Added, #4: 4	غَيْرِ الْمَذْهَبِ
u'غير مَذْهَبٌ':Added, #4: 4	غَيْرِ الْمَذْهَبِ
u'غَيْرٌ مَذْهَبٌ':Added, #4: 4	غَيْرِ مَذْهَبِهِ
u'غير مرٌّ':Added, #4: 4	غَيْرِ مَذْهَبِهِ
u'غَيْرٌ مرٌّ':Added, #1: 1	غَيْرُ الْمَرَّةِ
u'غير مرٌّ':Added, #1: 1	غَيْرُ الْمَرَّةِ
u'غَيْرٌ مرٌّ':Added, #1: 1	غَيْرَ مَرّةٍ
u'غير مرٌّ':Added, #1: 1	غَيْرَ مَرّةٍ
u'غَيْرٌ مرٌّ':Added, #2: 2	غَيْرُ مَرَّةٍ
u'غير مرٌّ':Added, #2: 2	غَيْرُ مَرَّةٍ
u'غَيْرٌ مرٌّ':Added, #81: 81	غَيْرَ مَرَّةٍ
u'غير مَرْء':Added, #81: 81	غَيْرَ مَرَّةٍ
u'غير مَرْء':Added, #1: 1	غَيْرَ الْمَرْئِيَّةِ
u'غَيْرٌ مَرْء':Added, #1: 1	غَيْرُ الْمَرْئِيَّةِ
u'غَيْرٌ مَرْء':Added, #1: 1	غَيْرَ الْمَرْئِيَّةِ
u'غير مَرْء':Added, #1: 1	غَيْرُ الْمَرْئِيَّةِ
u'غَيْرٌ مَرْء':Added, #3: 3	غَيْرُ مَرْئِيَّةٍ
u'غير مَرْء':Added, #3: 3	غَيْرُ مَرْئِيَّةٍ
u'غَيْرٌ مَرْء':Added, #4: 4	غَيْرِ مَرْئِيَّةٍ
u'غير مَرْء':Added, #4: 4	غَيْرِ مَرْئِيَّةٍ
u'غَيْرٌ مَرْء':Added, #5: 5	غَيْرِ الْمَرْئِيَّةِ
u'غير مَرْء':Added, #5: 5	غَيْرِ الْمَرْئِيَّةِ
u'غَيْرٌ مَرْء':Added, #5: 5	غَيْرَ مَرْئِيَّةٍ
u'غير مُرابَحَة':Added, #5: 5	غَيْرَ مَرْئِيَّةٍ
u'غَيْرٌ مُرابَحَة':Added, #1: 1	غَيْرَ مُرَابَحَةٍ
u'غير مُرَاجَعَةٌ':Added, #1: 1	غَيْرَ مُرَابَحَةٍ
u'غَيْرٌ مُرَاجَعَةٌ':Added, #1: 1	غَيْرِ مُرَاجَعَةٍ
u'غير مُرَاجَعَةٌ':Added, #1: 1	غَيْرِ مُرَاجَعَةٍ
u'غَيْرٌ مُرَاجَعَةٌ':Added, #9: 9	غَيْرِ مُرَاجَعَةِ
u'غير مراد':Added, #9: 9	غَيْرِ مُرَاجَعَةِ
u'غَيْرٌ مراد':Added, #1: 1	غَيْرِ مُرَادِ
u'غير مُرَادٌ':Added, #1: 1	غَيْرِ مُرَادِ
u'غَيْرٌ مُرَادٌ':Added, #1: 1	غَيْرِ مُرَادِ
u'غير مراد':Added, #1: 1	غَيْرِ مُرَادِ
u'غَيْرٌ مراد':Added, #1: 1	غَيْرُ مُرَادِهِ
u'غير مُرَادٌ':Added, #1: 1	غَيْرُ مُرَادِهِ
u'غَيْرٌ مُرَادٌ':Added, #1: 1	غَيْرُ مُرَادِهِ
u'غير مُرَادٌ':Added, #1: 1	غَيْرُ مُرَادِهِ
u'غَيْرٌ مُرَادٌ':Added, #1: 1	غَيْرُ مُرَادَيْنِ
u'غير مراد':Added, #1: 1	غَيْرُ مُرَادَيْنِ
u'غَيْرٌ مراد':Added, #21: 21	غَيْرَ مُرَادٍ
u'غير مُرَادٌ':Added, #21: 21	غَيْرَ مُرَادٍ
u'غَيْرٌ مُرَادٌ':Added, #21: 21	غَيْرَ مُرَادٍ
u'غير مراد':Added, #21: 21	غَيْرَ مُرَادٍ
u'غَيْرٌ مراد':Added, #2: 2	غَيْرُ مُرَادِ
u'غير مُرَادٌ':Added, #2: 2	غَيْرُ مُرَادِ
u'غَيْرٌ مُرَادٌ':Added, #2: 2	غَيْرُ مُرَادِ
u'غير مُرَادٌ':Added, #2: 2	غَيْرُ مُرَادِ
u'غَيْرٌ مُرَادٌ':Added, #2: 2	غَيْرَ مُرَادَةٍ
u'غير مراد':Added, #2: 2	غَيْرَ مُرَادَةٍ
u'غَيْرٌ مراد':Added, #3: 3	غَيْرِ الْمُرَادِ
u'غير مُرَادٌ':Added, #3: 3	غَيْرِ الْمُرَادِ
u'غَيْرٌ مُرَادٌ':Added, #3: 3	غَيْرِ الْمُرَادِ
u'غير مراد':Added, #3: 3	غَيْرِ الْمُرَادِ
u'غَيْرٌ مراد':Added, #3: 3	غَيْرِ مُرَادِهِ
u'غير مُرَادٌ':Added, #3: 3	غَيْرِ مُرَادِهِ
u'غَيْرٌ مُرَادٌ':Added, #3: 3	غَيْرِ مُرَادِهِ
u'غير مراد':Added, #3: 3	غَيْرِ مُرَادِهِ
u'غَيْرٌ مراد':Added, #4: 4	غَيْرَ الْمُرَادِ
u'غير مُرَادٌ':Added, #4: 4	غَيْرَ الْمُرَادِ
u'غَيْرٌ مُرَادٌ':Added, #4: 4	غَيْرَ الْمُرَادِ
u'غير مراد':Added, #4: 4	غَيْرَ الْمُرَادِ
u'غَيْرٌ مراد':Added, #5: 5	غَيْرُ الْمُرَادِ
u'غير مُرَادٌ':Added, #5: 5	غَيْرُ الْمُرَادِ
u'غَيْرٌ مُرَادٌ':Added, #5: 5	غَيْرُ الْمُرَادِ
u'غير مراد':Added, #5: 5	غَيْرُ الْمُرَادِ
u'غَيْرٌ مراد':Added, #71: 71	غَيْرُ مُرَادٍ
u'غير مُرَادٌ':Added, #71: 71	غَيْرُ مُرَادٍ
u'غَيْرٌ مُرَادٌ':Added, #71: 71	غَيْرُ مُرَادٍ
u'غير مُرَادٌ':Added, #71: 71	غَيْرُ مُرَادٍ
u'غَيْرٌ مُرَادٌ':Added, #8: 8	غَيْرُ مُرَادَةٍ
u'غير مُرَادِفٌ':Added, #8: 8	غَيْرُ مُرَادَةٍ
u'غَيْرٌ مُرَادِفٌ':Added, #1: 1	غَيْرُ مُرَادِفَةٍ
u'غير مُرَاسَلَةٌ':Added, #1: 1	غَيْرُ مُرَادِفَةٍ
u'غَيْرٌ مُرَاسَلَةٌ':Added, #1: 1	غَيْرِ مُرَاسَلَةٍ
u'غير مراسيل':Added, #1: 1	غَيْرِ مُرَاسَلَةٍ
u'غَيْرٌ مراسيل':Added, #1: 1	غَيْرِ مَرَاسِيلِ
u'غير مَرَاسِيلُ':Added, #1: 1	غَيْرِ مَرَاسِيلِ
u'غَيْرٌ مَرَاسِيلُ':Added, #1: 1	غَيْرِ مَرَاسِيلِ
u'غير مُراضاة':Added, #1: 1	غَيْرِ مَرَاسِيلِ
u'غَيْرٌ مُراضاة':Added, #1: 1	غَيْرِ مُرَاضَاةِ
u'غير مُرَاعَاةٌ':Added, #1: 1	غَيْرِ مُرَاضَاةِ
u'غَيْرٌ مُرَاعَاةٌ':Added, #10: 10	غَيْرِ مُرَاعَاةِ
u'غير مُرَاعَاةٌ':Added, #10: 10	غَيْرِ مُرَاعَاةِ
u'غَيْرٌ مُرَاعَاةٌ':Added, #3: 3	غَيْرِ مُرَاعَاةٍ
u'غير مُرَافَعَةٌ':Added, #3: 3	غَيْرِ مُرَاعَاةٍ
u'غَيْرٌ مُرَافَعَةٌ':Added, #1: 1	غَيْرِ مُرَافَعَةٍ
u'غير مُرَاقِبٌ':Added, #1: 1	غَيْرِ مُرَافَعَةٍ
u'غَيْرٌ مُرَاقِبٌ':Added, #1: 1	غَيْرَ مُرَاقِبٍ
u'غير مُرَاهِقٌ':Added, #1: 1	غَيْرَ مُرَاقِبٍ
u'غَيْرٌ مُرَاهِقٌ':Added, #1: 1	غَيْرِ الْمُرَاهِقِ
u'غير مُرَاهِقٌ':Added, #1: 1	غَيْرِ الْمُرَاهِقِ
u'غَيْرٌ مُرَاهِقٌ':Added, #1: 1	غَيْرِ مُرَاهِقٍ
u'غير مُرَاهِقٌ':Added, #1: 1	غَيْرِ مُرَاهِقٍ
u'غَيْرٌ مُرَاهِقٌ':Added, #2: 2	غَيْرُ الْمُرَاهِقِ
u'غير مُرَاهِقٌ':Added, #2: 2	غَيْرُ الْمُرَاهِقِ
u'غَيْرٌ مُرَاهِقٌ':Added, #2: 2	غَيْرُ مُرَاهِقٍ
u'غير مُرَاهِقٌ':Added, #2: 2	غَيْرُ مُرَاهِقٍ
u'غَيْرٌ مُرَاهِقٌ':Added, #3: 3	غَيْرَ مُرَاهِقٍ
u'غير مُرَاهِقٌ':Added, #3: 3	غَيْرَ مُرَاهِقٍ
u'غَيْرٌ مُرَاهِقٌ':Added, #4: 4	غَيْرَ مُرَاهِقَةٍ
u'غير مُرَبَّعٌ':Added, #4: 4	غَيْرَ مُرَاهِقَةٍ
u'غَيْرٌ مُرَبَّعٌ':Added, #1: 1	غَيْرَ الْمُرَبَّعِ
u'غير مُرَبَّعٌ':Added, #1: 1	غَيْرَ الْمُرَبَّعِ
u'غَيْرٌ مُرَبَّعٌ':Added, #1: 1	غَيْرِ مُرَبَّعٍ
u'غير مُرَبَّعٌ':Added, #1: 1	غَيْرِ مُرَبَّعٍ
u'غَيْرٌ مُرَبَّعٌ':Added, #2: 2	غَيْرُ الْمُرَبَّعِ
u'غير مَرْبُوط':Added, #2: 2	غَيْرُ الْمُرَبَّعِ
u'غَيْرٌ مَرْبُوط':Added, #1: 1	غَيْرِ الْمَرْبُوطِ
u'غير مَرْبُوط':Added, #1: 1	غَيْرِ الْمَرْبُوطِ
u'غَيْرٌ مَرْبُوط':Added, #1: 1	غَيْرُ مَرْبُوطَةٍ
u'غير مَرْبُوط':Added, #1: 1	غَيْرُ مَرْبُوطَةٍ
u'غَيْرٌ مَرْبُوط':Added, #3: 3	غَيْرِ الْمَرْبُوطَةِ
u'غير مَرَّةٌ':Added, #3: 3	غَيْرِ الْمَرْبُوطَةِ
u'غَيْرٌ مَرَّةٌ':Added, #1: 1	غَيْرُ الْمَرَّةِ
u'غير مَرَّةٌ':Added, #1: 1	غَيْرُ الْمَرَّةِ
u'غَيْرٌ مَرَّةٌ':Added, #1: 1	غَيْرَ مَرّةٍ
u'غير مَرَّةٌ':Added, #1: 1	غَيْرَ مَرّةٍ
u'غَيْرٌ مَرَّةٌ':Added, #2: 2	غَيْرُ مَرَّةٍ
u'غير مَرَّةٌ':Added, #2: 2	غَيْرُ مَرَّةٍ
u'غَيْرٌ مَرَّةٌ':Added, #81: 81	غَيْرَ مَرَّةٍ
u'غير مُرَتَّبٌ':Added, #81: 81	غَيْرَ مَرَّةٍ
u'غير مُرَتِّبٌ':Added, #1: 1	غَيْرِ الْمُرَتَّبِ
u'غَيْرٌ مُرَتَّبٌ':Added, #1: 1	غَيْرُ الْمُرَتِّبِ
u'غَيْرٌ مُرَتِّبٌ':Added, #1: 1	غَيْرِ الْمُرَتَّبِ
u'غير مُرَتَّبٌ':Added, #1: 1	غَيْرُ الْمُرَتِّبِ
u'غَيْرٌ مُرَتَّبٌ':Added, #1: 1	غَيْرِ مُرَتَّبَةٍ
u'غير مُرَتَّبٌ':Added, #1: 1	غَيْرِ مُرَتَّبَةٍ
u'غَيْرٌ مُرَتَّبٌ':Added, #2: 2	غَيْرَ مُرَتَّبٍ
u'غير مُرَتَّبٌ':Added, #2: 2	غَيْرَ مُرَتَّبٍ
u'غَيْرٌ مُرَتَّبٌ':Added, #3: 3	غَيْرُ مُرَتَّبٍ
u'غير مُرَتَّبٌ':Added, #3: 3	غَيْرُ مُرَتَّبٍ
u'غَيْرٌ مُرَتَّبٌ':Added, #7: 7	غَيْرَ مُرَتَّبَةٍ
u'غير مُرْتَبِطٌ':Added, #7: 7	غَيْرَ مُرَتَّبَةٍ
u'غَيْرٌ مُرْتَبِطٌ':Added, #2: 2	غَيْرَ مُرْتَبِطٍ
u'غير مُرْتَبِطٌ':Added, #2: 2	غَيْرَ مُرْتَبِطٍ
u'غَيْرٌ مُرْتَبِطٌ':Added, #3: 3	غَيْرُ مُرْتَبِطَةٍ
u'غير مُرْتَدٌّ':Added, #3: 3	غَيْرُ مُرْتَبِطَةٍ
u'غَيْرٌ مُرْتَدٌّ':Added, #1: 1	غَيْرِ الْمُرْتَدِّ
u'غير مُرْتَدٌّ':Added, #1: 1	غَيْرِ الْمُرْتَدِّ
u'غَيْرٌ مُرْتَدٌّ':Added, #3: 3	غَيْرَ مُرْتَدٍّ
u'غير مُرْتَفِعٌ':Added, #3: 3	غَيْرَ مُرْتَدٍّ
u'غَيْرٌ مُرْتَفِعٌ':Added, #1: 1	غَيْرُ مُرْتَفِعٍ
u'غير مُرْتَكِبٌ':Added, #1: 1	غَيْرُ مُرْتَفِعٍ
u'غَيْرٌ مُرْتَكِبٌ':Added, #1: 1	غَيْرَ مُرْتَكِبٍ
u'غير مُرْتَكِبٌ':Added, #1: 1	غَيْرَ مُرْتَكِبٍ
u'غَيْرٌ مُرْتَكِبٌ':Added, #2: 2	غَيْرُ مُرْتَكِبٍ
u'غير مُرْتَهِنٌ':Added, #2: 2	غَيْرُ مُرْتَكِبٍ
u'غَيْرٌ مُرْتَهِنٌ':Added, #1: 1	غَيْرُ الْمُرْتَهِنِ
u'غير مُرْتَهِنٌ':Added, #1: 1	غَيْرُ الْمُرْتَهِنِ
u'غَيْرٌ مُرْتَهِنٌ':Added, #5: 5	غَيْرِ الْمُرْتَهِنِ
u'غير مُرَجِّحٌ':Added, #5: 5	غَيْرِ الْمُرْتَهِنِ
u'غَيْرٌ مُرَجِّحٌ':Added, #13: 13	غَيْرِ مُرَجِّحٍ
u'غير مُرَجَّحٌ':Added, #13: 13	غَيْرِ مُرَجِّحٍ
u'غير مُرَجِّحٌ':Added, #1: 1	غَيْرِ مُرَجَّحِ
u'غَيْرٌ مُرَجَّحٌ':Added, #1: 1	غَيْرُ مُرَجِّحٍ
u'غَيْرٌ مُرَجِّحٌ':Added, #1: 1	غَيْرِ مُرَجَّحِ
u'غير مُرَجَّحٌ':Added, #1: 1	غَيْرُ مُرَجِّحٍ
u'غَيْرٌ مُرَجَّحٌ':Added, #2: 2	غَيْرِ مُرَجَّحٍ
u'غير مَرْجِعٌ':Added, #2: 2	غَيْرِ مُرَجَّحٍ
u'غَيْرٌ مَرْجِعٌ':Added, #1: 1	غَيْرِ مَرْجِعِهِ
u'غير مَرْجُوّ':Added, #1: 1	غَيْرِ مَرْجِعِهِ
u'غير مَرْجُوّ':Added, #1: 1	غَيْرُ مَرْجُوٍّ
u'غَيْرٌ مَرْجُوّ':Added, #1: 1	غَيْرُ مَرْجُوِّ
u'غَيْرٌ مَرْجُوّ':Added, #1: 1	غَيْرُ مَرْجُوٍّ
u'غير مَرْجُوّ':Added, #1: 1	غَيْرُ مَرْجُوِّ
u'غير مَرْجُوّ':Added, #2: 2	غَيْرَ مَرْجُوٍّ
u'غَيْرٌ مَرْجُوّ':Added, #2: 2	غَيْرَ مَرْجُوِّ
u'غَيْرٌ مَرْجُوّ':Added, #2: 2	غَيْرَ مَرْجُوٍّ
u'غير مُرَخَّصٌ':Added, #2: 2	غَيْرَ مَرْجُوِّ
u'غَيْرٌ مُرَخَّصٌ':Added, #2: 2	غَيْرُ مُرَخَّصٍ
u'غير مَرَدَةٌ':Added, #2: 2	غَيْرُ مُرَخَّصٍ
u'غَيْرٌ مَرَدَةٌ':Added, #2: 2	غَيْرِ الْمَرَدَةِ
u'غير مَرْدُودٌ':Added, #2: 2	غَيْرِ الْمَرَدَةِ
u'غَيْرٌ مَرْدُودٌ':Added, #1: 1	غَيْرَ مَرْدُودَةٍ
u'غير مَرْدُودٌ':Added, #1: 1	غَيْرَ مَرْدُودَةٍ
u'غَيْرٌ مَرْدُودٌ':Added, #2: 2	غَيْرُ مَرْدُودَةٍ
u'غير مَرْدُودٌ':Added, #2: 2	غَيْرُ مَرْدُودَةٍ
u'غير مَرْدُودٌ':Added, #3: 3	غَيْرَ مَرْدُودٍ
u'غَيْرٌ مَرْدُودٌ':Added, #3: 3	غَيْرُ مَرْدُودٍ
u'غَيْرٌ مَرْدُودٌ':Added, #3: 3	غَيْرَ مَرْدُودٍ
u'غير مَرْزُوقٌ':Added, #3: 3	غَيْرُ مَرْدُودٍ
u'غير مَرْزُوقٌ':Added, #1: 1	غَيْرَ مَرْزُوقٍ
u'غَيْرٌ مَرْزُوقٌ':Added, #1: 1	غَيْرُ مَرْزُوقٍ
u'غَيْرٌ مَرْزُوقٌ':Added, #1: 1	غَيْرَ مَرْزُوقٍ
u'غير مُرْسَلٌ':Added, #1: 1	غَيْرُ مَرْزُوقٍ
u'غير مُرْسَلٌ':Added, #1: 1	غَيْرَ الْمُرْسَلِ
u'غَيْرٌ مُرْسَلٌ':Added, #1: 1	غَيْرِ الْمُرْسَلِ
u'غَيْرٌ مُرْسَلٌ':Added, #1: 1	غَيْرَ الْمُرْسَلِ
u'غير مُرْسَلٌ':Added, #1: 1	غَيْرِ الْمُرْسَلِ
u'غَيْرٌ مُرْسَلٌ':Added, #1: 1	غَيْرَ مُرْسَلٍ
u'غير مَرْسُومٌ':Added, #1: 1	غَيْرَ مُرْسَلٍ
u'غَيْرٌ مَرْسُومٌ':Added, #1: 1	غَيْرُ مَرْسُومَةٍ
u'غير مَرْسُومٌ':Added, #1: 1	غَيْرُ مَرْسُومَةٍ
u'غَيْرٌ مَرْسُومٌ':Added, #4: 4	غَيْرُ مَرْسُومٍ
u'غير مُرَصَّعٌ':Added, #4: 4	غَيْرُ مَرْسُومٍ
u'غَيْرٌ مُرَصَّعٌ':Added, #1: 1	غَيْرِ مُرَصَّعٍ
u'غير مُرَصَّعٌ':Added, #1: 1	غَيْرِ مُرَصَّعٍ
u'غَيْرٌ مُرَصَّعٌ':Added, #3: 3	غَيْرَ مُرَصَّعٍ
u'غير مَرْصُوصٌ':Added, #3: 3	غَيْرَ مُرَصَّعٍ
u'غَيْرٌ مَرْصُوصٌ':Added, #1: 1	غَيْرَ مَرْصُوصٍ
u'غير مَرَضٌ':Added, #1: 1	غَيْرَ مَرْصُوصٍ
u'غير مَرَضٌ':Added, #2: 2	غَيْرَ مَرَضِ
u'غَيْرٌ مَرَضٌ':Added, #2: 2	غَيْرِ مَرَضِ
u'غَيْرٌ مَرَضٌ':Added, #2: 2	غَيْرَ مَرَضِ
u'غير مَرَضٌ':Added, #2: 2	غَيْرِ مَرَضِ
u'غَيْرٌ مَرَضٌ':Added, #7: 7	غَيْرِ مَرَضٍ
u'غير مَرْضاة':Added, #7: 7	غَيْرِ مَرَضٍ
u'غَيْرٌ مَرْضاة':Added, #3: 3	غَيْرِ مَرْضَاةِ
u'غير مُرْضِعٌ':Added, #3: 3	غَيْرِ مَرْضَاةِ
u'غَيْرٌ مُرْضِعٌ':Added, #2: 2	غَيْرِ الْمُرْضِعِ
u'غير مُرْضِعٌ':Added, #2: 2	غَيْرِ الْمُرْضِعِ
u'غَيْرٌ مُرْضِعٌ':Added, #2: 2	غَيْرَ مُرْضِعٍ
u'غير مُرْضِعٌ':Added, #2: 2	غَيْرَ مُرْضِعٍ
u'غَيْرٌ مُرْضِعٌ':Added, #6: 6	غَيْرِ الْمُرْضِعَةِ
u'غير مُرْضِي':Added, #6: 6	غَيْرِ الْمُرْضِعَةِ
u'غَيْرٌ مُرْضِي':Added, #1: 1	غَيْرَ مُرْضِيَةٍ
u'غير مَرْعِيٌّ':Added, #1: 1	غَيْرَ مُرْضِيَةٍ
u'غَيْرٌ مَرْعِيٌّ':Added, #3: 3	غَيْرُ مَرْعِيٍّ
u'غير مَرْغُوبٌ':Added, #3: 3	غَيْرُ مَرْعِيٍّ
u'غَيْرٌ مَرْغُوبٌ':Added, #3: 3	غَيْرَ مَرْغُوبٍ
u'غير مَرْغُوبٌ':Added, #3: 3	غَيْرَ مَرْغُوبٍ
u'غَيْرٌ مَرْغُوبٌ':Added, #5: 5	غَيْرُ مَرْغُوبٍ
u'غير مَرْفُوعٌ':Added, #5: 5	غَيْرُ مَرْغُوبٍ
u'غَيْرٌ مَرْفُوعٌ':Added, #17: 17	غَيْرُ مَرْفُوعٍ
u'غير مَرْفُوعٌ':Added, #17: 17	غَيْرُ مَرْفُوعٍ
u'غير مَرْفُوعٌ':Added, #1: 1	غَيْرَ مَرفُوعٍ
u'غَيْرٌ مَرْفُوعٌ':Added, #1: 1	غَيْرِ مَرْفُوعٍ
u'غَيْرٌ مَرْفُوعٌ':Added, #1: 1	غَيْرَ مَرفُوعٍ
u'غير مَرْفُوعٌ':Added, #1: 1	غَيْرِ مَرْفُوعٍ
u'غَيْرٌ مَرْفُوعٌ':Added, #26: 26	غَيْرَ مَرْفُوعٍ
u'غير مَرْفُوعٌ':Added, #26: 26	غَيْرَ مَرْفُوعٍ
u'غَيْرٌ مَرْفُوعٌ':Added, #2: 2	غَيْرُ مَرْفُوعَةٍ
u'غير مُرَكَّبٌ':Added, #2: 2	غَيْرُ مَرْفُوعَةٍ
u'غَيْرٌ مُرَكَّبٌ':Added, #1: 1	غَيْرَ الْمُرَكَّبِ
u'غير مُرَكَّبٌ':Added, #1: 1	غَيْرَ الْمُرَكَّبِ
u'غَيْرٌ مُرَكَّبٌ':Added, #2: 2	غَيْرُ مُرَكَّبٍ
u'غير مُرَكَّبٌ':Added, #2: 2	غَيْرُ مُرَكَّبٍ
u'غَيْرٌ مُرَكَّبٌ':Added, #2: 2	غَيْرُ مُرَكَّبَةٍ
u'غير مُرَكَّبٌ':Added, #2: 2	غَيْرُ مُرَكَّبَةٍ
u'غَيْرٌ مُرَكَّبٌ':Added, #3: 3	غَيْرِ الْمُرَكَّبِ
u'غير مَرْكُوبٌ':Added, #3: 3	غَيْرِ الْمُرَكَّبِ
u'غَيْرٌ مَرْكُوبٌ':Added, #1: 1	غَيْرِ الْمَرْكُوبِ
u'غير مَرْكُوبٌ':Added, #1: 1	غَيْرِ الْمَرْكُوبِ
u'غَيْرٌ مَرْكُوبٌ':Added, #1: 1	غَيْرُ مَرْكُوبِهِ
u'غير مَرْهُونٌ':Added, #1: 1	غَيْرُ مَرْكُوبِهِ
u'غَيْرٌ مَرْهُونٌ':Added, #1: 1	غَيْرُ الْمَرْهُونِ
u'غير مَرْهُونٌ':Added, #1: 1	غَيْرُ الْمَرْهُونِ
u'غَيْرٌ مَرْهُونٌ':Added, #2: 2	غَيْرَ مَرْهُونٍ
u'غير مَرْهُونٌ':Added, #2: 2	غَيْرَ مَرْهُونٍ
u'غَيْرٌ مَرْهُونٌ':Added, #3: 3	غَيْرِ الْمَرْهُونِ
u'غير مَرْهُونٌ':Added, #3: 3	غَيْرِ الْمَرْهُونِ
u'غَيْرٌ مَرْهُونٌ':Added, #3: 3	غَيْرُ مَرْهُونٍ
u'غير مَرْهُونٌ':Added, #3: 3	غَيْرُ مَرْهُونٍ
u'غَيْرٌ مَرْهُونٌ':Added, #4: 4	غَيْرَ الْمَرْهُونِ
u'غير مُرَوَّحٌ':Added, #4: 4	غَيْرَ الْمَرْهُونِ
u'غير مُرَوِّحٌ':Added, #1: 1	غَيْرَ مُرَوّحِ
u'غَيْرٌ مُرَوَّحٌ':Added, #1: 1	غَيْرَ مُرَوّحِ
u'غَيْرٌ مُرَوِّحٌ':Added, #1: 1	غَيْرَ مُرَوّحِ
u'غير مَرْوِيّ':Added, #1: 1	غَيْرَ مُرَوّحِ
u'غَيْرٌ مَرْوِيّ':Added, #2: 2	غَيْرِ الْمَرْوِيِّ
u'غير مُرِيدٌ':Added, #2: 2	غَيْرِ الْمَرْوِيِّ
u'غَيْرٌ مُرِيدٌ':Added, #13: 13	غَيْرَ مُرِيدٍ
u'غير مُرِيدٌ':Added, #13: 13	غَيْرَ مُرِيدٍ
u'غير مُرِيدٌ':Added, #1: 1	غَيْرَ مُرِيدِ
u'غَيْرٌ مُرِيدٌ':Added, #1: 1	غَيْرِ مُرِيدِ
u'غَيْرٌ مُرِيدٌ':Added, #1: 1	غَيْرَ مُرِيدِ
u'غير مُرِيدٌ':Added, #1: 1	غَيْرِ مُرِيدِ
u'غَيْرٌ مُرِيدٌ':Added, #2: 2	غَيْرُ مُرِيدٍ
u'غير مَرِيضٌ':Added, #2: 2	غَيْرُ مُرِيدٍ
u'غَيْرٌ مَرِيضٌ':Added, #1: 1	غَيْرُ الْمَرِيضِ
u'غير مَرِيضٌ':Added, #1: 1	غَيْرُ الْمَرِيضِ
u'غَيْرٌ مَرِيضٌ':Added, #3: 3	غَيْرِ الْمَرِيضِ
u'غير مُزَاحِمٌ':Added, #3: 3	غَيْرِ الْمَرِيضِ
u'غَيْرٌ مُزَاحِمٌ':Added, #2: 2	غَيْرِ مُزَاحِمٍ
u'غير مُزَاحَمَةٌ':Added, #2: 2	غَيْرِ مُزَاحِمٍ
u'غَيْرٌ مُزَاحَمَةٌ':Added, #2: 2	غَيْرِ مُزَاحَمَةٍ
u'غير مُزَارِعٌ':Added, #2: 2	غَيْرِ مُزَاحَمَةٍ
u'غَيْرٌ مُزَارِعٌ':Added, #1: 1	غَيْرُ مُزَارِعٍ
u'غير مَزَارِعُ':Added, #1: 1	غَيْرُ مُزَارِعٍ
u'غَيْرٌ مَزَارِعُ':Added, #2: 2	غَيْرُ الْمَزَارِعِ
u'غير مُزَايَدَةٌ':Added, #2: 2	غَيْرُ الْمَزَارِعِ
u'غَيْرٌ مُزَايَدَةٌ':Added, #2: 2	غَيْرِ الْمُزَايَدَةِ
u'غير مُزَفَّتٌ':Added, #2: 2	غَيْرِ الْمُزَايَدَةِ
u'غَيْرٌ مُزَفَّتٌ':Added, #3: 3	غَيْرِ الْمُزَفَّتِ
u'غير مَزْمُومٌ':Added, #3: 3	غَيْرِ الْمُزَفَّتِ
u'غَيْرٌ مَزْمُومٌ':Added, #1: 1	غَيْرُ مَزْمُومٍ
u'غير مَزِيَّةٌ':Added, #1: 1	غَيْرُ مَزْمُومٍ
u'غَيْرٌ مَزِيَّةٌ':Added, #1: 1	غَيْرِ مَزِيَّةٍ
u'غير مَزِيدٌ':Added, #1: 1	غَيْرِ مَزِيَّةٍ
u'غَيْرٌ مَزِيدٌ':Added, #2: 2	غَيْرُ الْمَزِيدِ
u'غير مُزِيل':Added, #2: 2	غَيْرُ الْمَزِيدِ
u'غَيْرٌ مُزِيل':Added, #2: 2	غَيْرِ مُزِيلٍ
u'غير مُزِيل':Added, #2: 2	غَيْرِ مُزِيلٍ
u'غير مُزِيل':Added, #3: 3	غَيْرَ مُزِيلٍ
u'غَيْرٌ مُزِيل':Added, #3: 3	غَيْرُ مُزِيلٍ
u'غَيْرٌ مُزِيل':Added, #3: 3	غَيْرَ مُزِيلٍ
u'غير مَسٌّ':Added, #3: 3	غَيْرُ مُزِيلٍ
u'غَيْرٌ مَسٌّ':Added, #2: 2	غَيْرُ مَسِّ
u'غير مَسٌّ':Added, #2: 2	غَيْرُ مَسِّ
u'غَيْرٌ مَسٌّ':Added, #5: 5	غَيْرِ مَسٍّ
u'غير مُسَابَقَةٌ':Added, #5: 5	غَيْرِ مَسٍّ
u'غَيْرٌ مُسَابَقَةٌ':Added, #1: 1	غَيْرِ مُسَابَقَةِ
u'غير مَسَاجِدُ':Added, #1: 1	غَيْرِ مُسَابَقَةِ
u'غَيْرٌ مَسَاجِدُ':Added, #18: 18	غَيْرِ الْمَسَاجِدِ
u'غير مَسَاجِدُ':Added, #18: 18	غَيْرِ الْمَسَاجِدِ
u'غَيْرٌ مَسَاجِدُ':Added, #3: 3	غَيْرَ الْمَسَاجِدِ
u'غير مَسَاجِدُ':Added, #3: 3	غَيْرَ الْمَسَاجِدِ
u'غَيْرٌ مَسَاجِدُ':Added, #5: 5	غَيْرِ مَسَاجِدِ
u'غير مُسَافِرٌ':Added, #5: 5	غَيْرِ مَسَاجِدِ
u'غَيْرٌ مُسَافِرٌ':Added, #1: 1	غَيْرِ مُسَافِرٍ
u'غير مُسَافِرٌ':Added, #1: 1	غَيْرِ مُسَافِرٍ
u'غَيْرٌ مُسَافِرٌ':Added, #3: 3	غَيْرِ الْمُسَافِرِ
u'غير مُسَافِرٌ':Added, #3: 3	غَيْرِ الْمُسَافِرِ
u'غَيْرٌ مُسَافِرٌ':Added, #3: 3	غَيْرَ مُسَافِرٍ
u'غير مُساقاة':Added, #3: 3	غَيْرَ مُسَافِرٍ
u'غَيْرٌ مُساقاة':Added, #1: 1	غَيْرِ الْمُسَاقَاةِ
u'غير مساكين':Added, #1: 1	غَيْرِ الْمُسَاقَاةِ
u'غَيْرٌ مساكين':Added, #1: 1	غَيْرِ الْمَسَاكِينِ
u'غير مساكين':Added, #1: 1	غَيْرِ الْمَسَاكِينِ
u'غَيْرٌ مساكين':Added, #1: 1	غَيْرِ مَسَاكِينِ
u'غير مساكين':Added, #1: 1	غَيْرِ مَسَاكِينِ
u'غَيْرٌ مساكين':Added, #1: 1	غَيْرِ مَسَاكِينِهِ
u'غير مَسْأَلَةٌ':Added, #1: 1	غَيْرِ مَسَاكِينِهِ
u'غَيْرٌ مَسْأَلَةٌ':Added, #11: 11	غَيْرِ مَسْأَلَةِ
u'غير مَسْأَلَةٌ':Added, #11: 11	غَيْرِ مَسْأَلَةِ
u'غَيْرٌ مَسْأَلَةٌ':Added, #1: 1	غَيْرُ الْمَسْأَلَةِ
u'غير مَسْأَلَةٌ':Added, #1: 1	غَيْرُ الْمَسْأَلَةِ
u'غَيْرٌ مَسْأَلَةٌ':Added, #1: 1	غَيْرَ مَسْأَلَةٍ
u'غير مَسْأَلَةٌ':Added, #1: 1	غَيْرَ مَسْأَلَةٍ
u'غَيْرٌ مَسْأَلَةٌ':Added, #27: 27	غَيْرِ مَسْأَلَةٍ
u'غير مَسْأَلَةٌ':Added, #27: 27	غَيْرِ مَسْأَلَةٍ
u'غَيْرٌ مَسْأَلَةٌ':Added, #2: 2	غَيْرِ الْمَسْأَلَةِ
u'غير مَسْأَلَةٌ':Added, #2: 2	غَيْرِ الْمَسْأَلَةِ
u'غَيْرٌ مَسْأَلَةٌ':Added, #2: 2	غَيْرَ مَسْأَلَةِ
u'غير مَسْأَلَةٌ':Added, #2: 2	غَيْرَ مَسْأَلَةِ
u'غَيْرٌ مَسْأَلَةٌ':Added, #9: 9	غَيْرُ مَسْأَلَةِ
u'غير مُسامَحَة':Added, #9: 9	غَيْرُ مَسْأَلَةِ
u'غَيْرٌ مُسامَحَة':Added, #1: 1	غَيْرِ مُسَامَحَةِ
u'غير مَسَائِلُ':Added, #1: 1	غَيْرِ مُسَامَحَةِ
u'غَيْرٌ مَسَائِلُ':Added, #4: 4	غَيْرِ الْمَسَائِلِ
u'غير مَسْبُوق':Added, #4: 4	غَيْرِ الْمَسَائِلِ
u'غير مَسْبُوق':Added, #1: 1	غَيْرَ مَسْبُوقٍ
u'غَيْرٌ مَسْبُوق':Added, #1: 1	غَيْرِ مَسْبُوقٍ
u'غَيْرٌ مَسْبُوق':Added, #1: 1	غَيْرَ مَسْبُوقٍ
u'غير مَسْبُوق':Added, #1: 1	غَيْرِ مَسْبُوقٍ
u'غَيْرٌ مَسْبُوق':Added, #1: 1	غَيْرُ مَسْبُوقَةٍ
u'غير مَسْبُوق':Added, #1: 1	غَيْرُ مَسْبُوقَةٍ
u'غَيْرٌ مَسْبُوق':Added, #2: 2	غَيْرُ مَسْبُوقٍ
u'غير مَسْبُوق':Added, #2: 2	غَيْرُ مَسْبُوقٍ
u'غَيْرٌ مَسْبُوق':Added, #3: 3	غَيْرِ الْمَسْبُوقِ
u'غير مُسْتَأْجِرٌ':Added, #3: 3	غَيْرِ الْمَسْبُوقِ
u'غَيْرٌ مُسْتَأْجِرٌ':Added, #1: 1	غَيْرُ مُسْتَأْجِرٍ
u'غير مُسْتَأْجِرٌ':Added, #1: 1	غَيْرُ مُسْتَأْجِرٍ
u'غير مُسْتَأْجِرٌ':Added, #2: 2	غَيْرَ الْمُسْتَأْجِرِ
u'غير مُسْتَأْجِرٌ':Added, #2: 2	غَيْرُ الْمُسْتَأْجِرِ
u'غَيْرٌ مُسْتَأْجِرٌ':Added, #2: 2	غَيْرِ الْمُسْتَأْجِرِ
u'غَيْرٌ مُسْتَأْجِرٌ':Added, #2: 2	غَيْرَ الْمُسْتَأْجِرِ
u'غَيْرٌ مُسْتَأْجِرٌ':Added, #2: 2	غَيْرُ الْمُسْتَأْجِرِ
u'غير مُسْتَأْجِرٌ':Added, #2: 2	غَيْرِ الْمُسْتَأْجِرِ
u'غَيْرٌ مُسْتَأْجِرٌ':Added, #2: 2	غَيْرَ مُسْتَأْجِرٍ
u'غير مُسْتَأْجِرٌ':Added, #2: 2	غَيْرَ مُسْتَأْجِرٍ
u'غَيْرٌ مُسْتَأْجِرٌ':Added, #2: 2	غَيْرِ مُسْتَأْجِرِهِ
u'غير مُسْتَبْدِلٌ':Added, #2: 2	غَيْرِ مُسْتَأْجِرِهِ
u'غَيْرٌ مُسْتَبْدِلٌ':Added, #2: 2	غَيْرَ مُسْتَبْدِلٍ
u'غير مُسْتَبْدِلٌ':Added, #2: 2	غَيْرَ مُسْتَبْدِلٍ
u'غَيْرٌ مُسْتَبْدِلٌ':Added, #3: 3	غَيْرُ مُسْتَبْدِلٍ
u'غير مُسْتَبْعَدٌ':Added, #3: 3	غَيْرُ مُسْتَبْدِلٍ
u'غَيْرٌ مُسْتَبْعَدٌ':Added, #4: 4	غَيْرُ مُسْتَبْعَدٍ
u'غير مُسْتَتِرٌ':Added, #4: 4	غَيْرُ مُسْتَبْعَدٍ
u'غَيْرٌ مُسْتَتِرٌ':Added, #1: 1	غَيْرُ مُسْتَتِرٍ
u'غير مُسْتَتِرٌ':Added, #1: 1	غَيْرُ مُسْتَتِرٍ
u'غَيْرٌ مُسْتَتِرٌ':Added, #2: 2	غَيْرَ مُسْتَتِرٍ
u'غير مُسْتَتِرٌ':Added, #2: 2	غَيْرَ مُسْتَتِرٍ
u'غَيْرٌ مُسْتَتِرٌ':Added, #3: 3	غَيْرُ مُسْتَتِرَةٍ
u'غير مُسْتَثْناة':Added, #3: 3	غَيْرُ مُسْتَتِرَةٍ
u'غَيْرٌ مُسْتَثْناة':Added, #2: 2	غَيْرُ مُسْتَثْنَاةٍ
u'غير مُسْتَحَبٌّ':Added, #2: 2	غَيْرُ مُسْتَثْنَاةٍ
u'غَيْرٌ مُسْتَحَبٌّ':Added, #13: 13	غَيْرُ مُسْتَحَبٍّ
u'غير مُسْتَحَبٌّ':Added, #13: 13	غَيْرُ مُسْتَحَبٍّ
u'غَيْرٌ مُسْتَحَبٌّ':Added, #1: 1	غَيْرَ مُسْتَحَبٍّ
u'غير مُسْتَحَبٌّ':Added, #1: 1	غَيْرَ مُسْتَحَبٍّ
u'غَيْرٌ مُسْتَحَبٌّ':Added, #1: 1	غَيْرُ مُسْتَحَبَّةٍ
u'غير مُسْتَحَبٌّ':Added, #1: 1	غَيْرُ مُسْتَحَبَّةٍ
u'غَيْرٌ مُسْتَحَبٌّ':Added, #3: 3	غَيْرِ مُسْتَحَبٍّ
u'غير مُسْتَحَبٌّ':Added, #3: 3	غَيْرِ مُسْتَحَبٍّ
u'غَيْرٌ مُسْتَحَبٌّ':Added, #6: 6	غَيْرِ الْمُسْتَحَبِّ
u'غير مُسْتَحْسَنٌ':Added, #6: 6	غَيْرِ الْمُسْتَحَبِّ
u'غَيْرٌ مُسْتَحْسَنٌ':Added, #2: 2	غَيْرِ الْمُسْتَحْسَنَةِ
u'غير مُسْتَحْسَنٌ':Added, #2: 2	غَيْرِ الْمُسْتَحْسَنَةِ
u'غَيْرٌ مُسْتَحْسَنٌ':Added, #3: 3	غَيْرُ مُسْتَحْسَنٍ
u'غير مُسْتَحِقٌّ':Added, #3: 3	غَيْرُ مُسْتَحْسَنٍ
u'غَيْرٌ مُسْتَحِقٌّ':Added, #10: 10	غَيْرِ الْمُسْتَحِقِّ
u'غير مُسْتَحَقٌّ':Added, #10: 10	غَيْرِ الْمُسْتَحِقِّ
u'غَيْرٌ مُسْتَحَقٌّ':Added, #15: 15	غَيْرُ مُسْتَحَقَّةٍ
u'غير مُسْتَحَقٌّ':Added, #15: 15	غَيْرُ مُسْتَحَقَّةٍ
u'غير مُسْتَحِقٌّ':Added, #1: 1	غَيْرَ الْمُسْتَحَقِّ
u'غَيْرٌ مُسْتَحَقٌّ':Added, #1: 1	غَيْرَ الْمُسْتَحِقِّ
u'غَيْرٌ مُسْتَحِقٌّ':Added, #1: 1	غَيْرَ الْمُسْتَحَقِّ
u'غير مُسْتَحَقٌّ':Added, #1: 1	غَيْرَ الْمُسْتَحِقِّ
u'غير مُسْتَحَقٌّ':Added, #1: 1	غَيْرَ مُسْتَحَقِّ
u'غير مُسْتَحِقٌّ':Added, #1: 1	غَيْرُ مُسْتَحَقِّ
u'غير مُسْتَحِقٌّ':Added, #1: 1	غَيْرُ مُسْتَحِقِّ
u'غَيْرٌ مُسْتَحَقٌّ':Added, #1: 1	غَيْرِ مُسْتَحِقٍّ
u'غَيْرٌ مُسْتَحَقٌّ':Added, #1: 1	غَيْرَ مُسْتَحَقِّ
u'غَيْرٌ مُسْتَحِقٌّ':Added, #1: 1	غَيْرُ مُسْتَحَقِّ
u'غَيْرٌ مُسْتَحِقٌّ':Added, #1: 1	غَيْرُ مُسْتَحِقِّ
u'غير مُسْتَحَقٌّ':Added, #1: 1	غَيْرِ مُسْتَحِقٍّ
u'غَيْرٌ مُسْتَحَقٌّ':Added, #1: 1	غَيْرِ مُسْتَحَقِّهِ
u'غير مُسْتَحَقٌّ':Added, #1: 1	غَيْرِ مُسْتَحَقِّهِ
u'غَيْرٌ مُسْتَحَقٌّ':Added, #2: 2	غَيْرَ مُسْتَحَقَّةٍ
u'غير مُسْتَحِقٌّ':Added, #2: 2	غَيْرَ مُسْتَحَقَّةٍ
u'غَيْرٌ مُسْتَحِقٌّ':Added, #2: 2	غَيْرِ مُسْتَحِقِّهِ
u'غير مُسْتَحَقٌّ':Added, #2: 2	غَيْرِ مُسْتَحِقِّهِ
u'غَيْرٌ مُسْتَحَقٌّ':Added, #34: 34	غَيْرُ مُسْتَحَقٍّ
u'غير مُسْتَحَقٌّ':Added, #34: 34	غَيْرُ مُسْتَحَقٍّ
u'غَيْرٌ مُسْتَحَقٌّ':Added, #3: 3	غَيْرِ الْمُسْتَحَقِّ
u'غير مُسْتَحَقٌّ':Added, #3: 3	غَيْرِ الْمُسْتَحَقِّ
u'غير مُسْتَحِقٌّ':Added, #3: 3	غَيْرَ مُسْتَحَقٍّ
u'غَيْرٌ مُسْتَحَقٌّ':Added, #3: 3	غَيْرَ مُسْتَحِقٍّ
u'غَيْرٌ مُسْتَحِقٌّ':Added, #3: 3	غَيْرَ مُسْتَحَقٍّ
u'غير مُسْتَحَقٌّ':Added, #3: 3	غَيْرَ مُسْتَحِقٍّ
u'غَيْرٌ مُسْتَحَقٌّ':Added, #4: 4	غَيْرِ مُسْتَحَقٍّ
u'غير مُسْتَحِقٌّ':Added, #4: 4	غَيْرِ مُسْتَحَقٍّ
u'غَيْرٌ مُسْتَحِقٌّ':Added, #7: 7	غَيْرُ مُسْتَحِقٍّ
u'غير مُسْتَحِلٌ':Added, #7: 7	غَيْرُ مُسْتَحِقٍّ
u'غَيْرٌ مُسْتَحِلٌ':Added, #1: 1	غَيْرَ مُسْتَحِلٍ
u'غير مُسْتَحِيلٌ':Added, #1: 1	غَيْرَ مُسْتَحِلٍ
u'غَيْرٌ مُسْتَحِيلٌ':Added, #1: 1	غَيْرِ مُسْتَحِيلٍ
u'غير مُسْتَحِيلٌ':Added, #1: 1	غَيْرِ مُسْتَحِيلٍ
u'غَيْرٌ مُسْتَحِيلٌ':Added, #1: 1	غَيْرَ مُسْتَحِيلَةِ
u'غير مُسْتَحِيلٌ':Added, #1: 1	غَيْرَ مُسْتَحِيلَةِ
u'غَيْرٌ مُسْتَحِيلٌ':Added, #7: 7	غَيْرُ مُسْتَحِيلٍ
u'غير مُسْتَخْرَجٌ':Added, #7: 7	غَيْرُ مُسْتَحِيلٍ
u'غَيْرٌ مُسْتَخْرَجٌ':Added, #1: 1	غَيْرَ الْمُسْتَخْرَجِ
u'غير مُسْتَخْرَجٌ':Added, #1: 1	غَيْرَ الْمُسْتَخْرَجِ
u'غَيْرٌ مُسْتَخْرَجٌ':Added, #2: 2	غَيْرُ مُسْتَخْرَجٍ
u'غير مُسْتَخْرَجٌ':Added, #2: 2	غَيْرُ مُسْتَخْرَجٍ
u'غَيْرٌ مُسْتَخْرَجٌ':Added, #3: 3	غَيْرَ مُسْتَخْرَجٍ
u'غير مُسْتَدام':Added, #3: 3	غَيْرَ مُسْتَخْرَجٍ
u'غَيْرٌ مُسْتَدام':Added, #2: 2	غَيْرِ مُسْتَدَامٍ
u'غير مُسْتَدِيرٌ':Added, #2: 2	غَيْرِ مُسْتَدَامٍ
u'غَيْرٌ مُسْتَدِيرٌ':Added, #1: 1	غَيْرَ مُسْتَدِيرٍ
u'غير مُسْتَدِيمٌ':Added, #1: 1	غَيْرَ مُسْتَدِيرٍ
u'غَيْرٌ مُسْتَدِيمٌ':Added, #1: 1	غَيْرِ مُسْتَدِيمٍ
u'غير مُسْتَرْسِلٌ':Added, #1: 1	غَيْرِ مُسْتَدِيمٍ
u'غَيْرٌ مُسْتَرْسِلٌ':Added, #2: 2	غَيْرِ الْمُسْتَرْسِلِ
u'غير مُسْتَطَاعٌ':Added, #2: 2	غَيْرِ الْمُسْتَرْسِلِ
u'غَيْرٌ مُسْتَطَاعٌ':Added, #1: 1	غَيْرَ مُسْتَطَاعٍ
u'غير مُسْتَعَارٌ':Added, #1: 1	غَيْرَ مُسْتَطَاعٍ
u'غَيْرٌ مُسْتَعَارٌ':Added, #1: 1	غَيْرُ مُسْتَعَارَةٍ
u'غير مُسْتَعْمَلٌ':Added, #1: 1	غَيْرُ مُسْتَعَارَةٍ
u'غَيْرٌ مُسْتَعْمَلٌ':Added, #14: 14	غَيْرُ مُسْتَعْمَلٍ
u'غير مُسْتَعْمَلٌ':Added, #14: 14	غَيْرُ مُسْتَعْمَلٍ
u'غير مُسْتَعْمَلٌ':Added, #1: 1	غَيْرَ الْمُسْتَعْمَلِ
u'غَيْرٌ مُسْتَعْمَلٌ':Added, #1: 1	غَيْرُ الْمُسْتَعْمَلِ
u'غَيْرٌ مُسْتَعْمَلٌ':Added, #1: 1	غَيْرَ الْمُسْتَعْمَلِ
u'غير مُسْتَعْمَلٌ':Added, #1: 1	غَيْرُ الْمُسْتَعْمَلِ
u'غَيْرٌ مُسْتَعْمَلٌ':Added, #1: 1	غَيْرِ مُسْتَعْمَلٍ
u'غير مُسْتَعْمِلٌ':Added, #1: 1	غَيْرِ مُسْتَعْمَلٍ
u'غَيْرٌ مُسْتَعْمِلٌ':Added, #2: 2	غَيْرُ مُسْتَعْمِلٍ
u'غير مُسْتَعْمَلٌ':Added, #2: 2	غَيْرُ مُسْتَعْمِلٍ
u'غَيْرٌ مُسْتَعْمَلٌ':Added, #3: 3	غَيْرِ الْمُسْتَعْمَلِ
u'غير مُسْتَعْمَلٌ':Added, #3: 3	غَيْرِ الْمُسْتَعْمَلِ
u'غَيْرٌ مُسْتَعْمَلٌ':Added, #5: 5	غَيْرَ مُسْتَعْمَلٍ
u'غير مُسْتَعْمَلٌ':Added, #5: 5	غَيْرَ مُسْتَعْمَلٍ
u'غَيْرٌ مُسْتَعْمَلٌ':Added, #6: 6	غَيْرُ مُسْتَعْمَلَةٍ
u'غير مُسْتَعِيرٌ':Added, #6: 6	غَيْرُ مُسْتَعْمَلَةٍ
u'غَيْرٌ مُسْتَعِيرٌ':Added, #2: 2	غَيْرُ مُسْتَعِيرٍ
u'غير مُسْتَغْرِقٌ':Added, #2: 2	غَيْرُ مُسْتَعِيرٍ
u'غَيْرٌ مُسْتَغْرِقٌ':Added, #16: 16	غَيْرَ مُسْتَغْرِقٍ
u'غير مُسْتَغْرِقٌ':Added, #16: 16	غَيْرَ مُسْتَغْرِقٍ
u'غير مُسْتَغْرِقٌ':Added, #1: 1	غَيْرَ الْمُسْتَغْرِقِ
u'غَيْرٌ مُسْتَغْرِقٌ':Added, #1: 1	غَيْرُ الْمُسْتَغْرِقِ
u'غَيْرٌ مُسْتَغْرِقٌ':Added, #1: 1	غَيْرَ الْمُسْتَغْرِقِ
u'غير مُسْتَغْرِقٌ':Added, #1: 1	غَيْرُ الْمُسْتَغْرِقِ
u'غَيْرٌ مُسْتَغْرِقٌ':Added, #1: 1	غَيْرَ الْمُسْتَغْرِقَةِ
u'غير مُسْتَغْرِقٌ':Added, #1: 1	غَيْرَ الْمُسْتَغْرِقَةِ
u'غَيْرٌ مُسْتَغْرِقٌ':Added, #1: 1	غَيْرَ مُسْتَغْرِقَةٍ
u'غير مُسْتَغْرِقٌ':Added, #1: 1	غَيْرَ مُسْتَغْرِقَةٍ
u'غَيْرٌ مُسْتَغْرِقٌ':Added, #2: 2	غَيْرِ الْمُسْتَغْرِقِ
u'غير مُسْتَغْرِقٌ':Added, #2: 2	غَيْرِ الْمُسْتَغْرِقِ
u'غَيْرٌ مُسْتَغْرِقٌ':Added, #5: 5	غَيْرُ مُسْتَغْرِقٍ
u'غير مُسْتَفاد':Added, #5: 5	غَيْرُ مُسْتَغْرِقٍ
u'غَيْرٌ مُسْتَفاد':Added, #1: 1	غَيْرَ مُسْتَفَادٍ
u'غير مُسْتَفاد':Added, #1: 1	غَيْرَ مُسْتَفَادٍ
u'غَيْرٌ مُسْتَفاد':Added, #5: 5	غَيْرُ مُسْتَفَادٍ
u'غير مُسْتَقْبَح':Added, #5: 5	غَيْرُ مُسْتَفَادٍ
u'غَيْرٌ مُسْتَقْبَح':Added, #1: 1	غَيْرُ مُسْتَقْبَحٍ
u'غير مُسْتَقْبَلٌ':Added, #1: 1	غَيْرُ مُسْتَقْبَحٍ
u'غير مُسْتَقْبَلٌ':Added, #1: 1	غَيْرَ مُسْتَقْبَلٍ
u'غير مُسْتَقْبِلٌ':Added, #1: 1	غَيْرَ مُسْتَقْبَلِ
u'غير مُسْتَقْبِلٌ':Added, #1: 1	غَيْرَ مُسْتَقْبِلِ
u'غَيْرٌ مُسْتَقْبَلٌ':Added, #1: 1	غَيْرُ مُسْتَقْبِلٍ
u'غَيْرٌ مُسْتَقْبَلٌ':Added, #1: 1	غَيْرَ مُسْتَقْبَلٍ
u'غَيْرٌ مُسْتَقْبِلٌ':Added, #1: 1	غَيْرَ مُسْتَقْبَلِ
u'غَيْرٌ مُسْتَقْبِلٌ':Added, #1: 1	غَيْرَ مُسْتَقْبِلِ
u'غير مُسْتَقْبِلٌ':Added, #1: 1	غَيْرُ مُسْتَقْبِلٍ
u'غَيْرٌ مُسْتَقْبِلٌ':Added, #4: 4	غَيْرَ مُسْتَقْبِلٍ
u'غير مُسْتَقِرٌّ':Added, #4: 4	غَيْرَ مُسْتَقْبِلٍ
u'غَيْرٌ مُسْتَقِرٌّ':Added, #16: 16	غَيْرَ مُسْتَقِرٍّ
u'غير مُسْتَقِرٌّ':Added, #16: 16	غَيْرَ مُسْتَقِرٍّ
u'غَيْرٌ مُسْتَقِرٌّ':Added, #1: 1	غَيْرَ مُسْتَقِرَّيْنِ
u'غير مُسْتَقِرٌّ':Added, #1: 1	غَيْرَ مُسْتَقِرَّيْنِ
u'غَيْرٌ مُسْتَقِرٌّ':Added, #21: 21	غَيْرُ مُسْتَقِرٍّ
u'غير مُسْتَقَرٌّ':Added, #21: 21	غَيْرُ مُسْتَقِرٍّ
u'غير مُسْتَقَرٌّ':Added, #2: 2	غَيْرَ مُسْتَقَرٍّ
u'غَيْرٌ مُسْتَقَرٌّ':Added, #2: 2	غَيْرِ مُسْتَقَرٍّ
u'غَيْرٌ مُسْتَقَرٌّ':Added, #2: 2	غَيْرَ مُسْتَقَرٍّ
u'غير مُسْتَقَرٌّ':Added, #2: 2	غَيْرِ مُسْتَقَرٍّ
u'غَيْرٌ مُسْتَقَرٌّ':Added, #3: 3	غَيْرُ مُسْتَقَرٍّ
u'غير مُسْتَقِرٌّ':Added, #3: 3	غَيْرُ مُسْتَقَرٍّ
u'غَيْرٌ مُسْتَقِرٌّ':Added, #3: 3	غَيْرَ مُسْتَقِرَّةٍ
u'غير مُسْتَقِرٌّ':Added, #3: 3	غَيْرَ مُسْتَقِرَّةٍ
u'غَيْرٌ مُسْتَقِرٌّ':Added, #5: 5	غَيْرِ مُسْتَقِرٍّ
u'غير مُسْتَقِرٌّ':Added, #5: 5	غَيْرِ مُسْتَقِرٍّ
u'غَيْرٌ مُسْتَقِرٌّ':Added, #8: 8	غَيْرُ مُسْتَقِرَّةٍ
u'غير مُسْتَقِلٌّ':Added, #8: 8	غَيْرُ مُسْتَقِرَّةٍ
u'غَيْرٌ مُسْتَقِلٌّ':Added, #12: 12	غَيْرَ مُسْتَقِلٍّ
u'غير مُسْتَقِلٌّ':Added, #12: 12	غَيْرَ مُسْتَقِلٍّ
u'غَيْرٌ مُسْتَقِلٌّ':Added, #14: 14	غَيْرُ مُسْتَقِلٍّ
u'غير مُسْتَقِلٌّ':Added, #14: 14	غَيْرُ مُسْتَقِلٍّ
u'غَيْرٌ مُسْتَقِلٌّ':Added, #1: 1	غَيْرَ مُسْتَقِلَّيْنِ
u'غير مُسْتَقِلٌّ':Added, #1: 1	غَيْرَ مُسْتَقِلَّيْنِ
u'غير مُسْتَقِلٌّ':Added, #2: 2	غَيْرُ الْمُسْتَقِلِّ
u'غَيْرٌ مُسْتَقِلٌّ':Added, #2: 2	غَيْرِ الْمُسْتَقِلِّ
u'غَيْرٌ مُسْتَقِلٌّ':Added, #2: 2	غَيْرُ الْمُسْتَقِلِّ
u'غير مُسْتَقِلٌّ':Added, #2: 2	غَيْرِ الْمُسْتَقِلِّ
u'غَيْرٌ مُسْتَقِلٌّ':Added, #3: 3	غَيْرِ مُسْتَقِلٍّ
u'غير مُسْتَقِلٌّ':Added, #3: 3	غَيْرِ مُسْتَقِلٍّ
u'غَيْرٌ مُسْتَقِلٌّ':Added, #4: 4	غَيْرَ الْمُسْتَقِلِّ
u'غير مُسْتَقِلٌّ':Added, #4: 4	غَيْرَ الْمُسْتَقِلِّ
u'غير مُسْتَقِلٌّ':Added, #4: 4	غَيْرَ مُسْتَقِلَّةٍ
u'غَيْرٌ مُسْتَقِلٌّ':Added, #4: 4	غَيْرُ مُسْتَقِلَّةٍ
u'غَيْرٌ مُسْتَقِلٌّ':Added, #4: 4	غَيْرَ مُسْتَقِلَّةٍ
u'غير مُسْتَقِيمٌ':Added, #4: 4	غَيْرُ مُسْتَقِلَّةٍ
u'غير مُسْتَقِيمٌ':Added, #1: 1	غَيْرَ مُسْتَقِيمٍ
u'غَيْرٌ مُسْتَقِيمٌ':Added, #1: 1	غَيْرَ مُسْتَقِيمِ
u'غَيْرٌ مُسْتَقِيمٌ':Added, #1: 1	غَيْرَ مُسْتَقِيمٍ
u'غير مُسْتَقِيمٌ':Added, #1: 1	غَيْرَ مُسْتَقِيمِ
u'غَيْرٌ مُسْتَقِيمٌ':Added, #1: 1	غَيْرُ مُسْتَقِيمَةِ
u'غير مُسْتَقِيمٌ':Added, #1: 1	غَيْرُ مُسْتَقِيمَةِ
u'غَيْرٌ مُسْتَقِيمٌ':Added, #57: 57	غَيْرُ مُسْتَقِيمٍ
u'غير مُسْتَقِيمٌ':Added, #57: 57	غَيْرُ مُسْتَقِيمٍ
u'غَيْرٌ مُسْتَقِيمٌ':Added, #7: 7	غَيْرُ مُسْتَقِيمَةٍ
u'غير مُسْتَلِبٌ':Added, #7: 7	غَيْرُ مُسْتَقِيمَةٍ
u'غَيْرٌ مُسْتَلِبٌ':Added, #1: 1	غَيْرَ مُسْتَلِبٍ
u'غير مُسْتَلْزِمٌ':Added, #1: 1	غَيْرَ مُسْتَلِبٍ
u'غَيْرٌ مُسْتَلْزِمٌ':Added, #1: 1	غَيْرِ مُسْتَلْزِمٍ
u'غير مُسْتَلْزِمٌ':Added, #1: 1	غَيْرِ مُسْتَلْزِمٍ
u'غَيْرٌ مُسْتَلْزِمٌ':Added, #1: 1	غَيْرَ مُسْتَلْزِمَةٍ
u'غير مُسْتَلْزِمٌ':Added, #1: 1	غَيْرَ مُسْتَلْزِمَةٍ
u'غير مُسْتَلْزِمٌ':Added, #4: 4	غَيْرَ مُسْتَلْزِمٍ
u'غَيْرٌ مُسْتَلْزِمٌ':Added, #4: 4	غَيْرُ مُسْتَلْزِمٍ
u'غَيْرٌ مُسْتَلْزِمٌ':Added, #4: 4	غَيْرَ مُسْتَلْزِمٍ
u'غير مُسْتَلِمٌ':Added, #4: 4	غَيْرُ مُسْتَلْزِمٍ
u'غَيْرٌ مُسْتَلِمٌ':Added, #1: 1	غَيْرَ مُسْتَلِمٍ
u'غير مُسْتَمَدٌّ':Added, #1: 1	غَيْرَ مُسْتَلِمٍ
u'غَيْرٌ مُسْتَمَدٌّ':Added, #1: 1	غَيْرُ مُسْتَمَدٍّ
u'غير مُسْتَمِرٌّ':Added, #1: 1	غَيْرُ مُسْتَمَدٍّ
u'غَيْرٌ مُسْتَمِرٌّ':Added, #1: 1	غَيْرَ الْمُسْتَمِرِّ
u'غير مُسْتَمِرٌّ':Added, #1: 1	غَيْرَ الْمُسْتَمِرِّ
u'غَيْرٌ مُسْتَمِرٌّ':Added, #1: 1	غَيْرُ مُسْتَمِرٍّ
u'غير مُسْتَمِرٌّ':Added, #1: 1	غَيْرُ مُسْتَمِرٍّ
u'غَيْرٌ مُسْتَمِرٌّ':Added, #1: 1	غَيْرُ مُسْتَمِرَّةٍ
u'غير مُسْتَمْسِك':Added, #1: 1	غَيْرُ مُسْتَمِرَّةٍ
u'غَيْرٌ مُسْتَمْسِك':Added, #1: 1	غَيْرُ مُسْتَمْسِكٍ
u'غير مُسْتَنَدٌ':Added, #1: 1	غَيْرُ مُسْتَمْسِكٍ
u'غَيْرٌ مُسْتَنَدٌ':Added, #10: 10	غَيْرِ مُسْتَنَدٍ
u'غير مُسْتَنِدٌ':Added, #10: 10	غَيْرِ مُسْتَنَدٍ
u'غير مُسْتَنِدٌ':Added, #3: 3	غَيْرُ مُسْتَنِدٍ
u'غَيْرٌ مُسْتَنِدٌ':Added, #3: 3	غَيْرِ مُسْتَنِدٍ
u'غَيْرٌ مُسْتَنِدٌ':Added, #3: 3	غَيْرُ مُسْتَنِدٍ
u'غير مُسْتَنِدٌ':Added, #3: 3	غَيْرِ مُسْتَنِدٍ
u'غَيْرٌ مُسْتَنِدٌ':Added, #3: 3	غَيْرُ مُسْتَنِدَةٍ
u'غير مُسْتَنِدٌ':Added, #3: 3	غَيْرُ مُسْتَنِدَةٍ
u'غَيْرٌ مُسْتَنِدٌ':Added, #5: 5	غَيْرَ مُسْتَنِدٍ
u'غير مُسْتَنْكَرٌ':Added, #5: 5	غَيْرَ مُسْتَنِدٍ
u'غَيْرٌ مُسْتَنْكَرٌ':Added, #8: 8	غَيْرُ مُسْتَنْكَرٍ
u'غير مُسْتَنِيب':Added, #8: 8	غَيْرُ مُسْتَنْكَرٍ
u'غَيْرٌ مُسْتَنِيب':Added, #1: 1	غَيْرَ مُسْتَنِيبٍ
u'غير مُسْتَهْزِئٌ':Added, #1: 1	غَيْرَ مُسْتَنِيبٍ
u'غَيْرٌ مُسْتَهْزِئٌ':Added, #2: 2	غَيْرُ مُسْتَهْزِئٍ
u'غير مُسْتَهَلٌّ':Added, #2: 2	غَيْرُ مُسْتَهْزِئٍ
u'غَيْرٌ مُسْتَهَلٌّ':Added, #1: 1	غَيْرَ الْمُسْتَهَلِّ
u'غير مُسْتَهْلِكٌ':Added, #1: 1	غَيْرَ الْمُسْتَهَلِّ
u'غَيْرٌ مُسْتَهْلِكٌ':Added, #1: 1	غَيْرَ مُسْتَهْلِكٍ
u'غير مُسْتَوْجِبٌ':Added, #1: 1	غَيْرَ مُسْتَهْلِكٍ
u'غَيْرٌ مُسْتَوْجِبٌ':Added, #1: 1	غَيْرُ مُسْتَوْجِبٍ
u'غير مُسْتَوْجِبٌ':Added, #1: 1	غَيْرُ مُسْتَوْجِبٍ
u'غَيْرٌ مُسْتَوْجِبٌ':Added, #2: 2	غَيْرَ مُسْتَوْجِبٍ
u'غير مَسْتُورٌ':Added, #2: 2	غَيْرَ مُسْتَوْجِبٍ
u'غَيْرٌ مَسْتُورٌ':Added, #1: 1	غَيْرُ مَسْتُورٍ
u'غير مُسْتَوْطِن':Added, #1: 1	غَيْرُ مَسْتُورٍ
u'غير مُسْتَوْطِن':Added, #1: 1	غَيْرُ مُسْتَوْطِنٍ
u'غَيْرٌ مُسْتَوْطِن':Added, #1: 1	غَيْرِ مُسْتَوْطِنٍ
u'غَيْرٌ مُسْتَوْطِن':Added, #1: 1	غَيْرُ مُسْتَوْطِنٍ
u'غير مُسْتَوْطِن':Added, #1: 1	غَيْرِ مُسْتَوْطِنٍ
u'غَيْرٌ مُسْتَوْطِن':Added, #2: 2	غَيْرِ الْمُسْتَوْطِنِ
u'غير مُسْتَوْعِبٌ':Added, #2: 2	غَيْرِ الْمُسْتَوْطِنِ
u'غَيْرٌ مُسْتَوْعِبٌ':Added, #1: 1	غَيْرِ مُسْتَوْعِبَةٍ
u'غير مُسْتَوِي':Added, #1: 1	غَيْرِ مُسْتَوْعِبَةٍ
u'غَيْرٌ مُسْتَوِي':Added, #1: 1	غَيْرُ مُسْتَوِيَيْنِ
u'غير مُسْتَوى':Added, #1: 1	غَيْرُ مُسْتَوِيَيْنِ
u'غَيْرٌ مُسْتَوى':Added, #1: 1	غَيْرُ مُسْتَوِيَيْنِ
u'غير مَسْجِدٌ':Added, #1: 1	غَيْرُ مُسْتَوِيَيْنِ
u'غَيْرٌ مَسْجِدٌ':Added, #19: 19	غَيْرِ مَسْجِدٍ
u'غير مَسْجِدٌ':Added, #19: 19	غَيْرِ مَسْجِدٍ
u'غَيْرٌ مَسْجِدٌ':Added, #1: 1	غَيْرِ الْمَسْجِدَيْنِ
u'غير مَسْجِدٌ':Added, #1: 1	غَيْرِ الْمَسْجِدَيْنِ
u'غير مَسْجِدٌ':Added, #1: 1	غَيْر مَسْجِدِ
u'غَيْرٌ مَسْجِدٌ':Added, #1: 1	غَيْرَ مَسْجِدِ
u'غَيْرٌ مَسْجِدٌ':Added, #1: 1	غَيْر مَسْجِدِ
u'غير مَسْجِدٌ':Added, #1: 1	غَيْرَ مَسْجِدِ
u'غَيْرٌ مَسْجِدٌ':Added, #1: 1	غَيْرِ مَسْجِدِهِ
u'غير مَسْجِدٌ':Added, #1: 1	غَيْرِ مَسْجِدِهِ
u'غَيْرٌ مَسْجِدٌ':Added, #2: 2	غَيْرُ الْمَسْجِدِ
u'غير مَسْجِدٌ':Added, #2: 2	غَيْرُ الْمَسْجِدِ
u'غَيْرٌ مَسْجِدٌ':Added, #39: 39	غَيْرِ الْمَسْجِدِ
u'غير مَسْجِدٌ':Added, #39: 39	غَيْرِ الْمَسْجِدِ
u'غَيْرٌ مَسْجِدٌ':Added, #3: 3	غَيْرِ مَسْجِدِ
u'غير مَسْجِدٌ':Added, #3: 3	غَيْرِ مَسْجِدِ
u'غَيْرٌ مَسْجِدٌ':Added, #4: 4	غَيْرَ الْمَسْجِدِ
u'غير مَسْجِدٌ':Added, #4: 4	غَيْرَ الْمَسْجِدِ
u'غَيْرٌ مَسْجِدٌ':Added, #6: 6	غَيْرَ مَسْجِدٍ
u'غير مُسَجَّلٌ':Added, #6: 6	غَيْرَ مَسْجِدٍ
u'غَيْرٌ مُسَجَّلٌ':Added, #1: 1	غَيْرَ الْمُسَجَّلِ
u'غير مُسَجَّلٌ':Added, #1: 1	غَيْرَ الْمُسَجَّلِ
u'غَيْرٌ مُسَجَّلٌ':Added, #1: 1	غَيْرِ مُسَجَّلٍ
u'غير مَسْحٌ':Added, #1: 1	غَيْرِ مُسَجَّلٍ
u'غَيْرٌ مَسْحٌ':Added, #1: 1	غَيْرِ مَسْحٍ
u'غير مَسْحُوقٌ':Added, #1: 1	غَيْرِ مَسْحٍ
u'غير مَسْحُوق':Added, #1: 1	غَيْرِ مَسْحُوقٍ
u'غَيْرٌ مَسْحُوقٌ':Added, #1: 1	غَيْرِ مَسْحُوقٍ
u'غَيْرٌ مَسْحُوق':Added, #1: 1	غَيْرِ مَسْحُوقٍ
u'غير مَسْخُوط':Added, #1: 1	غَيْرِ مَسْحُوقٍ
u'غَيْرٌ مَسْخُوط':Added, #1: 1	غَيْرُ مَسْخُوطٍ
u'غير مُسَدَّدٌ':Added, #1: 1	غَيْرُ مَسْخُوطٍ
u'غَيْرٌ مُسَدَّدٌ':Added, #1: 1	غَيْرُ مُسَدَّدِ
u'غير مَسْدُودٌ':Added, #1: 1	غَيْرُ مُسَدَّدِ
u'غَيْرٌ مَسْدُودٌ':Added, #1: 1	غَيْرُ مَسْدُودٍ
u'غير مُسْرِفٌ':Added, #1: 1	غَيْرُ مَسْدُودٍ
u'غَيْرٌ مُسْرِفٌ':Added, #3: 3	غَيْرَ مُسْرِفٍ
u'غير مُسَطَّحٌ':Added, #3: 3	غَيْرَ مُسْرِفٍ
u'غَيْرٌ مُسَطَّحٌ':Added, #1: 1	غَيْرُ مُسَطَّحٍ
u'غير مِسْعَرٌ':Added, #1: 1	غَيْرُ مُسَطَّحٍ
u'غير مِسْعَرٌ':Added, #1: 1	غَيْرُ مِسْعَرٍ
u'غَيْرٌ مِسْعَرٌ':Added, #1: 1	غَيْرِ مِسْعَرٍ
u'غَيْرٌ مِسْعَرٌ':Added, #1: 1	غَيْرُ مِسْعَرٍ
u'غير مَسْفُوحٌ':Added, #1: 1	غَيْرِ مِسْعَرٍ
u'غير مَسْفُوحٌ':Added, #1: 1	غَيْرَ الْمَسْفُوحِ
u'غَيْرٌ مَسْفُوحٌ':Added, #1: 1	غَيْرُ الْمَسْفُوحِ
u'غَيْرٌ مَسْفُوحٌ':Added, #1: 1	غَيْرَ الْمَسْفُوحِ
u'غير مَسْفُوحٌ':Added, #1: 1	غَيْرُ الْمَسْفُوحِ
u'غَيْرٌ مَسْفُوحٌ':Added, #1: 1	غَيْرَ مَسْفُوحٍ
u'غير مَسْفُوحٌ':Added, #1: 1	غَيْرَ مَسْفُوحٍ
u'غَيْرٌ مَسْفُوحٌ':Added, #2: 2	غَيْرِ الْمَسْفُوحِ
u'غير مَسْفُوحٌ':Added, #2: 2	غَيْرِ الْمَسْفُوحِ
u'غَيْرٌ مَسْفُوحٌ':Added, #2: 2	غَيْرُ مَسْفُوحٍ
u'غير مُسَقَّف':Added, #2: 2	غَيْرُ مَسْفُوحٍ
u'غَيْرٌ مُسَقَّف':Added, #1: 1	غَيْرِ الْمُسَقَّفِ
u'غير مُسَقَّف':Added, #1: 1	غَيْرِ الْمُسَقَّفِ
u'غَيْرٌ مُسَقَّف':Added, #1: 1	غَيْرِ مُسَقَّفٍ
u'غير مِسْكٌ':Added, #1: 1	غَيْرِ مُسَقَّفٍ
u'غَيْرٌ مِسْكٌ':Added, #1: 1	غَيْرَ مِسْكٍ
u'غير مُسْكِرٌ':Added, #1: 1	غَيْرَ مِسْكٍ
u'غَيْرٌ مُسْكِرٌ':Added, #1: 1	غَيْرِ مُسْكِرٍ
u'غير مُسْكِرٌ':Added, #1: 1	غَيْرِ مُسْكِرٍ
u'غير مُسْكِرٌ':Added, #3: 3	غَيْرُ الْمُسْكِرِ
u'غَيْرٌ مُسْكِرٌ':Added, #3: 3	غَيْرِ الْمُسْكِرِ
u'غَيْرٌ مُسْكِرٌ':Added, #3: 3	غَيْرُ الْمُسْكِرِ
u'غير مُسْكِرٌ':Added, #3: 3	غَيْرِ الْمُسْكِرِ
u'غَيْرٌ مُسْكِرٌ':Added, #3: 3	غَيْرَ مُسْكِرٍ
u'غير مَسْكَنٌ':Added, #3: 3	غَيْرَ مُسْكِرٍ
u'غير مَسْكَنٌ':Added, #1: 1	غَيْرُ الْمَسْكَنِ
u'غَيْرٌ مَسْكَنٌ':Added, #1: 1	غَيْرِ الْمَسْكَنِ
u'غَيْرٌ مَسْكَنٌ':Added, #1: 1	غَيْرُ الْمَسْكَنِ
u'غير مَسْكَنٌ':Added, #1: 1	غَيْرِ الْمَسْكَنِ
u'غير مَسْكَنٌ':Added, #1: 1	غَيْرَ مَسْكَنٍ
u'غَيْرٌ مَسْكَنٌ':Added, #1: 1	غَيْرُ مَسْكَنٍ
u'غَيْرٌ مَسْكَنٌ':Added, #1: 1	غَيْرَ مَسْكَنٍ
u'غير مَسْكَنٌ':Added, #1: 1	غَيْرُ مَسْكَنٍ
u'غَيْرٌ مَسْكَنٌ':Added, #1: 1	غَيْرِ مَسْكَنِهِ
u'غير مَسْكَنَةٌ':Added, #1: 1	غَيْرِ مَسْكَنِهِ
u'غَيْرٌ مَسْكَنَةٌ':Added, #3: 3	غَيْرِ مَسْكَنَةٍ
u'غير مَسْكُوكَة':Added, #3: 3	غَيْرِ مَسْكَنَةٍ
u'غَيْرٌ مَسْكُوكَة':Added, #1: 1	غَيْرَ مَسْكُوكَةٍ
u'غير مَسْكُونٌ':Added, #1: 1	غَيْرَ مَسْكُوكَةٍ
u'غَيْرٌ مَسْكُونٌ':Added, #1: 1	غَيْرِ الْمَسْكُونَةِ
u'غير مَسْكُونٌ':Added, #1: 1	غَيْرِ الْمَسْكُونَةِ
u'غَيْرٌ مَسْكُونٌ':Added, #3: 3	غَيْرِ مَسْكُونَةٍ
u'غير مَسْكُونٌ':Added, #3: 3	غَيْرِ مَسْكُونَةٍ
u'غَيْرٌ مَسْكُونٌ':Added, #4: 4	غَيْرَ مَسْكُونَةٍ
u'غير مِسْكِينٌ':Added, #4: 4	غَيْرَ مَسْكُونَةٍ
u'غير مِسْكِينٌ':Added, #1: 1	غَيْرُ الْمِسْكِينِ
u'غَيْرٌ مِسْكِينٌ':Added, #1: 1	غَيْرِ الْمِسْكِينِ
u'غَيْرٌ مِسْكِينٌ':Added, #1: 1	غَيْرُ الْمِسْكِينِ
u'غير مِسْكِينٌ':Added, #1: 1	غَيْرِ الْمِسْكِينِ
u'غَيْرٌ مِسْكِينٌ':Added, #1: 1	غَيْرُ مِسْكِينِ
u'غير مُسْلِمٌ':Added, #1: 1	غَيْرُ مِسْكِينِ
u'غَيْرٌ مُسْلِمٌ':Added, #1: 1	غَيْرِ الْمُسْلِمَةِ
u'غير مُسَلَّمٌ':Added, #1: 1	غَيْرِ الْمُسْلِمَةِ
u'غير مُسْلِمٌ':Added, #1: 1	غَيْرُ مُسَلَّمَةِ
u'غير مُسْلِمٌ':Added, #1: 1	غَيْرَ مُسْلِمَةٍ
u'غير مُسْلِمٌ':Added, #1: 1	غَيْرُ مُسْلِمَةٍ
u'غَيْرٌ مُسَلَّمٌ':Added, #1: 1	غَيْرِ مُسْلِمَةٍ
u'غَيْرٌ مُسْلِمٌ':Added, #1: 1	غَيْرُ مُسَلَّمَةِ
u'غَيْرٌ مُسْلِمٌ':Added, #1: 1	غَيْرَ مُسْلِمَةٍ
u'غَيْرٌ مُسْلِمٌ':Added, #1: 1	غَيْرُ مُسْلِمَةٍ
u'غير مُسْلِمٌ':Added, #1: 1	غَيْرِ مُسْلِمَةٍ
u'غَيْرٌ مُسْلِمٌ':Added, #2: 2	غَيْرُ الْمُسْلِمِ
u'غير مُسْلِمٌ':Added, #2: 2	غَيْرُ الْمُسْلِمِ
u'غَيْرٌ مُسْلِمٌ':Added, #2: 2	غَيْرِ الْمُسْلِمَاتِ
u'غير مُسَلَّمٌ':Added, #2: 2	غَيْرِ الْمُسْلِمَاتِ
u'غَيْرٌ مُسَلَّمٌ':Added, #2: 2	غَيْرَ مُسَلَّمٍ
u'غير مُسَلَّمٌ':Added, #2: 2	غَيْرَ مُسَلَّمٍ
u'غَيْرٌ مُسَلَّمٌ':Added, #3: 3	غَيْرِ الْمُسَلَّمِ
u'غير مُسْلِمٌ':Added, #3: 3	غَيْرِ الْمُسَلَّمِ
u'غَيْرٌ مُسْلِمٌ':Added, #4: 4	غَيْرَ الْمُسْلِمِ
u'غير مُسَلَّمٌ':Added, #4: 4	غَيْرَ الْمُسْلِمِ
u'غَيْرٌ مُسَلَّمٌ':Added, #55: 55	غَيْرُ مُسَلَّمٍ
u'غير مُسْلِمٌ':Added, #55: 55	غَيْرُ مُسَلَّمٍ
u'غَيْرٌ مُسْلِمٌ':Added, #6: 6	غَيْرُ مُسْلِمٍ
u'غير مُسَلَّمٌ':Added, #6: 6	غَيْرُ مُسْلِمٍ
u'غَيْرٌ مُسَلَّمٌ':Added, #6: 6	غَيْرُ مُسَلَّمَةٍ
u'غير مُسْلِمٌ':Added, #6: 6	غَيْرُ مُسَلَّمَةٍ
u'غَيْرٌ مُسْلِمٌ':Added, #7: 7	غَيْرِ الْمُسْلِمِ
u'غير مُسْلِمٌ':Added, #7: 7	غَيْرِ الْمُسْلِمِ
u'غَيْرٌ مُسْلِمٌ':Added, #9: 9	غَيْرَ مُسْلِمٍ
u'غير مُسَلَّمَةٌ':Added, #9: 9	غَيْرَ مُسْلِمٍ
u'غَيْرٌ مُسَلَّمَةٌ':Added, #1: 1	غَيْرُ مُسَلَّمَةِ
u'غير مُسَلَّمَةٌ':Added, #1: 1	غَيْرُ مُسَلَّمَةِ
u'غَيْرٌ مُسَلَّمَةٌ':Added, #6: 6	غَيْرُ مُسَلَّمَةٍ
u'غير مَسْلُوبٌ':Added, #6: 6	غَيْرُ مُسَلَّمَةٍ
u'غَيْرٌ مَسْلُوبٌ':Added, #1: 1	غَيْرُ مَسْلُوبَةٍ
u'غير مسلوخ':Added, #1: 1	غَيْرُ مَسْلُوبَةٍ
u'غير مسلوخ':Added, #1: 1	غَيْرَ مَسْلُوخَتَيْنِ
u'غَيْرٌ مسلوخ':Added, #1: 1	غَيْرُ مَسْلُوخَتَيْنِ
u'غَيْرٌ مسلوخ':Added, #1: 1	غَيْرَ مَسْلُوخَتَيْنِ
u'غير مسلوخ':Added, #1: 1	غَيْرُ مَسْلُوخَتَيْنِ
u'غَيْرٌ مسلوخ':Added, #2: 2	غَيْرِ مَسْلُوخَةٍ
u'غير مسلوخ':Added, #2: 2	غَيْرِ مَسْلُوخَةٍ
u'غَيْرٌ مسلوخ':Added, #6: 6	غَيْرَ مَسْلُوخَةٍ
u'غير مَسْلُوكٌ':Added, #6: 6	غَيْرَ مَسْلُوخَةٍ
u'غَيْرٌ مَسْلُوكٌ':Added, #1: 1	غَيْرِ الْمَسْلُوكِ
u'غير مَسْلُوكٌ':Added, #1: 1	غَيْرِ الْمَسْلُوكِ
u'غير مَسْلُوكٌ':Added, #1: 1	غَيْرَ مَسْلُوكٍ
u'غَيْرٌ مَسْلُوكٌ':Added, #1: 1	غَيْرَ مَسْلُوكِ
u'غَيْرٌ مَسْلُوكٌ':Added, #1: 1	غَيْرَ مَسْلُوكٍ
u'غير مَسْلُوكٌ':Added, #1: 1	غَيْرَ مَسْلُوكِ
u'غَيْرٌ مَسْلُوكٌ':Added, #5: 5	غَيْرِ مَسْلُوكٍ
u'غير مُسَمّاة':Added, #5: 5	غَيْرِ مَسْلُوكٍ
u'غَيْرٌ مُسَمّاة':Added, #1: 1	غَيْرَ مُسَمَّاةٍ
u'غير مُسَمَّرٌ':Added, #1: 1	غَيْرَ مُسَمَّاةٍ
u'غَيْرٌ مُسَمَّرٌ':Added, #1: 1	غَيْرُ الْمُسَمَّرِ
u'غير مُسَمَّرٌ':Added, #1: 1	غَيْرُ الْمُسَمَّرِ
u'غَيْرٌ مُسَمَّرٌ':Added, #1: 1	غَيْرُ الْمُسَمَّرَةِ
u'غير مَسْمُوحٌ':Added, #1: 1	غَيْرُ الْمُسَمَّرَةِ
u'غَيْرٌ مَسْمُوحٌ':Added, #1: 1	غَيْرُ مَسْمُوحٍ
u'غير مَسْمُوعٌ':Added, #1: 1	غَيْرُ مَسْمُوحٍ
u'غَيْرٌ مَسْمُوعٌ':Added, #13: 13	غَيْرُ مَسْمُوعٍ
u'غير مَسْمُوعٌ':Added, #13: 13	غَيْرُ مَسْمُوعٍ
u'غير مَسْمُوعٌ':Added, #1: 1	غَيْرَ الْمَسْمُوعِ
u'غَيْرٌ مَسْمُوعٌ':Added, #1: 1	غَيْرِ الْمَسْمُوعِ
u'غَيْرٌ مَسْمُوعٌ':Added, #1: 1	غَيْرَ الْمَسْمُوعِ
u'غير مَسْمُوعٌ':Added, #1: 1	غَيْرِ الْمَسْمُوعِ
u'غير مَسْمُوعٌ':Added, #3: 3	غَيْرَ مَسْمُوعٍ
u'غَيْرٌ مَسْمُوعٌ':Added, #3: 3	غَيْرِ مَسْمُوعٍ
u'غَيْرٌ مَسْمُوعٌ':Added, #3: 3	غَيْرَ مَسْمُوعٍ
u'غير مَسْمُوعٌ':Added, #3: 3	غَيْرِ مَسْمُوعٍ
u'غَيْرٌ مَسْمُوعٌ':Added, #7: 7	غَيْرُ مَسْمُوعَةٍ
u'غير مَسْمُومٌ':Added, #7: 7	غَيْرُ مَسْمُوعَةٍ
u'غَيْرٌ مَسْمُومٌ':Added, #1: 1	غَيْرُ مَسْمُومٍ
u'غير مُسَمَّى':Added, #1: 1	غَيْرُ مَسْمُومٍ
u'غَيْرٌ مُسَمَّى':Added, #1: 1	غَيْرِ الْمُسَمَّيَاتِ
u'غير مُسِنٌّ':Added, #1: 1	غَيْرِ الْمُسَمَّيَاتِ
u'غَيْرٌ مُسِنٌّ':Added, #1: 1	غَيْرِ الْمُسِنَّةِ
u'غير مُسْنَدٌ':Added, #1: 1	غَيْرِ الْمُسِنَّةِ
u'غَيْرٌ مُسْنَدٌ':Added, #2: 2	غَيْرِ الْمُسْنَدِ
u'غير مَسْنُونٌ':Added, #2: 2	غَيْرِ الْمُسْنَدِ
u'غَيْرٌ مَسْنُونٌ':Added, #1: 1	غَيْرَ مَسْنُونٍ
u'غير مَسْنُونٌ':Added, #1: 1	غَيْرَ مَسْنُونٍ
u'غَيْرٌ مَسْنُونٌ':Added, #1: 1	غَيْرُ مَسْنُونَةٍ
u'غير مَسْنُونٌ':Added, #1: 1	غَيْرُ مَسْنُونَةٍ
u'غَيْرٌ مَسْنُونٌ':Added, #2: 2	غَيْرَ مَسْنُونَةٍ
u'غير مَسْنُونٌ':Added, #2: 2	غَيْرَ مَسْنُونَةٍ
u'غَيْرٌ مَسْنُونٌ':Added, #5: 5	غَيْرُ مَسْنُونٍ
u'غير مُسَوِّغٌ':Added, #5: 5	غَيْرُ مَسْنُونٍ
u'غَيْرٌ مُسَوِّغٌ':Added, #3: 3	غَيْرِ مُسَوِّغٍ
u'غير مُسِيءٌ':Added, #3: 3	غَيْرِ مُسَوِّغٍ
u'غَيْرٌ مُسِيءٌ':Added, #1: 1	غَيْرَ مُسِيءٍ
u'غير مَسِيحٌ':Added, #1: 1	غَيْرَ مُسِيءٍ
u'غَيْرٌ مَسِيحٌ':Added, #1: 1	غَيْرِ الْمَسِيحِ
u'غير مَسِيسٌ':Added, #1: 1	غَيْرِ الْمَسِيحِ
u'غَيْرٌ مَسِيسٌ':Added, #5: 5	غَيْرِ مَسِيسٍ
u'غير مُشَابِهٌ':Added, #5: 5	غَيْرِ مَسِيسٍ
u'غَيْرٌ مُشَابِهٌ':Added, #1: 1	غَيْرُ مُشَابِهٍ
u'غير مُشَابِهٌ':Added, #1: 1	غَيْرُ مُشَابِهٍ
u'غَيْرٌ مُشَابِهٌ':Added, #1: 1	غَيْرُ مُشَابِهَةٍ
u'غير مُشار':Added, #1: 1	غَيْرُ مُشَابِهَةٍ
u'غير مُشار':Added, #1: 1	غَيْرُ الْمُشَارِ
u'غَيْرٌ مُشار':Added, #1: 1	غَيْرِ الْمُشَارِ
u'غَيْرٌ مُشار':Added, #1: 1	غَيْرُ الْمُشَارِ
u'غير مُشار':Added, #1: 1	غَيْرِ الْمُشَارِ
u'غير مُشار':Added, #2: 2	غَيْرَ مُشَارٍ
u'غَيْرٌ مُشار':Added, #2: 2	غَيْرِ مُشَارٍ
u'غَيْرٌ مُشار':Added, #2: 2	غَيْرَ مُشَارٍ
u'غير مُشار':Added, #2: 2	غَيْرِ مُشَارٍ
u'غَيْرٌ مُشار':Added, #3: 3	غَيْرُ مُشَارٍ
u'غير مُشَارِكٌ':Added, #3: 3	غَيْرُ مُشَارٍ
u'غَيْرٌ مُشَارِكٌ':Added, #1: 1	غَيْرَ الْمُشَارِكِ
u'غير مُشَارِكٌ':Added, #1: 1	غَيْرَ الْمُشَارِكِ
u'غَيْرٌ مُشَارِكٌ':Added, #1: 1	غَيْرَ مُشَارِكٍ
u'غير مُشَارَكَةٌ':Added, #1: 1	غَيْرَ مُشَارِكٍ
u'غَيْرٌ مُشَارَكَةٌ':Added, #1: 1	غَيْرِ الْمُشَارَكَةِ
u'غير مُشَارَكَةٌ':Added, #1: 1	غَيْرِ الْمُشَارَكَةِ
u'غَيْرٌ مُشَارَكَةٌ':Added, #2: 2	غَيْرِ مُشَارَكَةٍ
u'غير مُشاعٌ':Added, #2: 2	غَيْرِ مُشَارَكَةٍ
u'غَيْرٌ مُشاعٌ':Added, #1: 1	غَيْرِ الْمُشَاعِ
u'غير مُشاعٌ':Added, #1: 1	غَيْرِ الْمُشَاعِ
u'غَيْرٌ مُشاعٌ':Added, #1: 1	غَيْرِ الْمُشَاعَةِ
u'غير مُشاعٌ':Added, #1: 1	غَيْرِ الْمُشَاعَةِ
u'غَيْرٌ مُشاعٌ':Added, #1: 1	غَيْرُ مُشَاعٍ
u'غير مُشاعٌ':Added, #1: 1	غَيْرُ مُشَاعٍ
u'غَيْرٌ مُشاعٌ':Added, #4: 4	غَيْرَ مُشَاعٍ
u'غير مُشَاهَدٌ':Added, #4: 4	غَيْرَ مُشَاعٍ
u'غَيْرٌ مُشَاهَدٌ':Added, #1: 1	غَيْرُ مُشَاهَدٍ
u'غير مُشَاهَدٌ':Added, #1: 1	غَيْرُ مُشَاهَدٍ
u'غَيْرٌ مُشَاهَدٌ':Added, #1: 1	غَيْرَ مُشَاهَدَةٍ
u'غير مُشَاهَدٌ':Added, #1: 1	غَيْرَ مُشَاهَدَةٍ
u'غَيْرٌ مُشَاهَدٌ':Added, #3: 3	غَيْرُ مُشَاهَدَةٍ
u'غير مُشَاهَدَةٌ':Added, #3: 3	غَيْرُ مُشَاهَدَةٍ
u'غَيْرٌ مُشَاهَدَةٌ':Added, #1: 1	غَيْرَ مُشَاهَدَةٍ
u'غير مُشَاهَدَةٌ':Added, #1: 1	غَيْرَ مُشَاهَدَةٍ
u'غَيْرٌ مُشَاهَدَةٌ':Added, #3: 3	غَيْرُ مُشَاهَدَةٍ
u'غير مُشاهَرَة':Added, #3: 3	غَيْرُ مُشَاهَدَةٍ
u'غَيْرٌ مُشاهَرَة':Added, #1: 1	غَيْرَ مُشَاهَرَةٍ
u'غير مُشْتَبِهٌ':Added, #1: 1	غَيْرَ مُشَاهَرَةٍ
u'غَيْرٌ مُشْتَبِهٌ':Added, #1: 1	غَيْرِ الْمُشْتَبِهَاتِ
u'غير مُشْتَبَهٌ':Added, #1: 1	غَيْرِ الْمُشْتَبِهَاتِ
u'غير مُشْتَبَهٌ':Added, #1: 1	غَيْرُ مُشْتَبَهٍ
u'غير مُشْتَبِهٌ':Added, #1: 1	غَيْرِ مُشْتَبَهٍ
u'غَيْرٌ مُشْتَبَهٌ':Added, #1: 1	غَيْرَ مُشْتَبِهٍ
u'غَيْرٌ مُشْتَبَهٌ':Added, #1: 1	غَيْرُ مُشْتَبَهٍ
u'غَيْرٌ مُشْتَبِهٌ':Added, #1: 1	غَيْرِ مُشْتَبَهٍ
u'غير مُشْتَرِط':Added, #1: 1	غَيْرَ مُشْتَبِهٍ
u'غَيْرٌ مُشْتَرِط':Added, #1: 1	غَيْرِ مُشْتَرِطِ
u'غير مُشْتَرَكٌ':Added, #1: 1	غَيْرِ مُشْتَرِطِ
u'غير مُشْتَرِكٌ':Added, #1: 1	غَيْرُ الْمُشْتَرَكِ
u'غَيْرٌ مُشْتَرَكٌ':Added, #1: 1	غَيْرِ الْمُشْتَرِكِ
u'غَيْرٌ مُشْتَرِكٌ':Added, #1: 1	غَيْرُ الْمُشْتَرَكِ
u'غير مُشْتَرَكٌ':Added, #1: 1	غَيْرِ الْمُشْتَرِكِ
u'غَيْرٌ مُشْتَرَكٌ':Added, #1: 1	غَيْرِ الْمُشْتَرَكَةِ
u'غير مُشْتَرَكٌ':Added, #1: 1	غَيْرِ الْمُشْتَرَكَةِ
u'غَيْرٌ مُشْتَرَكٌ':Added, #1: 1	غَيْرُ مُشْتَرَكٍ
u'غير مُشْتَرَكٌ':Added, #1: 1	غَيْرُ مُشْتَرَكٍ
u'غَيْرٌ مُشْتَرَكٌ':Added, #1: 1	غَيْرُ مُشْتَرَكَةٍ
u'غير مُشْتَرَكٌ':Added, #1: 1	غَيْرُ مُشْتَرَكَةٍ
u'غَيْرٌ مُشْتَرَكٌ':Added, #3: 3	غَيْرِ الْمُشْتَرَكِ
u'غير مُشْتَرَكٌ':Added, #3: 3	غَيْرِ الْمُشْتَرَكِ
u'غَيْرٌ مُشْتَرَكٌ':Added, #4: 4	غَيْرِ مُشْتَرَكٍ
u'غير مُشْتَرِي':Added, #4: 4	غَيْرِ مُشْتَرَكٍ
u'غَيْرٌ مُشْتَرِي':Added, #2: 2	غَيْرِ مُشْتَرِيهِ
u'غير مُشْتَقٌّ':Added, #2: 2	غَيْرِ مُشْتَرِيهِ
u'غير مُشْتَقٌّ':Added, #1: 1	غَيْرَ مُشْتَقٍّ
u'غَيْرٌ مُشْتَقٌّ':Added, #1: 1	غَيْرِ مُشْتَقٍّ
u'غَيْرٌ مُشْتَقٌّ':Added, #1: 1	غَيْرَ مُشْتَقٍّ
u'غير مُشْتَقٌّ':Added, #1: 1	غَيْرِ مُشْتَقٍّ
u'غَيْرٌ مُشْتَقٌّ':Added, #1: 1	غَيْرَ مُشْتَقّةٍ
u'غير مُشْتَقٌّ':Added, #1: 1	غَيْرَ مُشْتَقّةٍ
u'غَيْرٌ مُشْتَقٌّ':Added, #2: 2	غَيْرَ الْمُشْتَقِّ
u'غير مُشْتَقٌّ':Added, #2: 2	غَيْرَ الْمُشْتَقِّ
u'غَيْرٌ مُشْتَقٌّ':Added, #3: 3	غَيْرُ مُشْتَقٍّ
u'غير مُشْتَمِلٌ':Added, #3: 3	غَيْرُ مُشْتَقٍّ
u'غير مُشْتَمِلٌ':Added, #1: 1	غَيْرَ مُشْتَمِلٍ
u'غَيْرٌ مُشْتَمِلٌ':Added, #1: 1	غَيْرُ مُشْتَمِلٍ
u'غَيْرٌ مُشْتَمِلٌ':Added, #1: 1	غَيْرَ مُشْتَمِلٍ
u'غير مُشْتَمِلٌ':Added, #1: 1	غَيْرُ مُشْتَمِلٍ
u'غَيْرٌ مُشْتَمِلٌ':Added, #2: 2	غَيْرُ مُشْتَمِلَةٍ
u'غير مُشْتَهاة':Added, #2: 2	غَيْرُ مُشْتَمِلَةٍ
u'غير مُشْتَهاة':Added, #1: 1	غَيْرَ الْمُشْتَهَاةِ
u'غَيْرٌ مُشْتَهاة':Added, #1: 1	غَيْرِ الْمُشْتَهَاةِ
u'غَيْرٌ مُشْتَهاة':Added, #1: 1	غَيْرَ الْمُشْتَهَاةِ
u'غير مُشْتَهاة':Added, #1: 1	غَيْرِ الْمُشْتَهَاةِ
u'غير مُشْتَهاة':Added, #1: 1	غَيْرَ مُشْتَهَاةٍ
u'غَيْرٌ مُشْتَهاة':Added, #1: 1	غَيْرِ مُشْتَهَاةٍ
u'غَيْرٌ مُشْتَهاة':Added, #1: 1	غَيْرَ مُشْتَهَاةٍ
u'غير مُشْتَهاة':Added, #1: 1	غَيْرِ مُشْتَهَاةٍ
u'غَيْرٌ مُشْتَهاة':Added, #2: 2	غَيْرُ الْمُشْتَهَاةِ
u'غير مُشْتَهاة':Added, #2: 2	غَيْرُ الْمُشْتَهَاةِ
u'غَيْرٌ مُشْتَهاة':Added, #3: 3	غَيْرُ مُشْتَهَاةٍ
u'غير مَشْدُودٌ':Added, #3: 3	غَيْرُ مُشْتَهَاةٍ
u'غَيْرٌ مَشْدُودٌ':Added, #2: 2	غَيْرَ مَشْدُودٍ
u'غير مُشْرِفٌ':Added, #2: 2	غَيْرَ مَشْدُودٍ
u'غَيْرٌ مُشْرِفٌ':Added, #1: 1	غَيْرَ مُشْرِفٍ
u'غير مُشْرِفٌ':Added, #1: 1	غَيْرَ مُشْرِفٍ
u'غَيْرٌ مُشْرِفٌ':Added, #5: 5	غَيْرُ مُشْرِفٍ
u'غير مُشْرِقٌ':Added, #5: 5	غَيْرُ مُشْرِفٍ
u'غَيْرٌ مُشْرِقٌ':Added, #1: 1	غَيْرَ مُشْرِقٍ
u'غير مَشْرُوبٌ':Added, #1: 1	غَيْرَ مُشْرِقٍ
u'غَيْرٌ مَشْرُوبٌ':Added, #1: 1	غَيْرُ مَشْرُوبٍ
u'غير مَشْرُوطٌ':Added, #1: 1	غَيْرُ مَشْرُوبٍ
u'غَيْرٌ مَشْرُوطٌ':Added, #1: 1	غَيْرِ الْمَشْرُوطِ
u'غير مَشْرُوطٌ':Added, #1: 1	غَيْرِ الْمَشْرُوطِ
u'غَيْرٌ مَشْرُوطٌ':Added, #1: 1	غَيْرُ الْمَشْرُوطَةِ
u'غير مَشْرُوطٌ':Added, #1: 1	غَيْرُ الْمَشْرُوطَةِ
u'غَيْرٌ مَشْرُوطٌ':Added, #1: 1	غَيْرِ مَشْرُوطَةٍ
u'غير مَشْرُوطٌ':Added, #1: 1	غَيْرِ مَشْرُوطَةٍ
u'غَيْرٌ مَشْرُوطٌ':Added, #2: 2	غَيْرُ الْمَشْرُوطِ
u'غير مَشْرُوطٌ':Added, #2: 2	غَيْرُ الْمَشْرُوطِ
u'غَيْرٌ مَشْرُوطٌ':Added, #2: 2	غَيْرَ مَشْرُوطَةٍ
u'غير مَشْرُوطٌ':Added, #2: 2	غَيْرَ مَشْرُوطَةٍ
u'غَيْرٌ مَشْرُوطٌ':Added, #5: 5	غَيْرَ مَشْرُوطٍ
u'غير مَشْرُوطٌ':Added, #5: 5	غَيْرَ مَشْرُوطٍ
u'غَيْرٌ مَشْرُوطٌ':Added, #6: 6	غَيْرُ مَشْرُوطَةٍ
u'غير مَشْرُوطٌ':Added, #6: 6	غَيْرُ مَشْرُوطَةٍ
u'غَيْرٌ مَشْرُوطٌ':Added, #7: 7	غَيْرُ مَشْرُوطٍ
u'غير مَشْرُوعٌ':Added, #7: 7	غَيْرُ مَشْرُوطٍ
u'غَيْرٌ مَشْرُوعٌ':Added, #11: 11	غَيْرُ مَشْرُوعَةٍ
u'غير مَشْرُوعٌ':Added, #11: 11	غَيْرُ مَشْرُوعَةٍ
u'غير مَشْرُوعٌ':Added, #1: 1	غَيْر الْمَشْرُوعِ
u'غير مَشْرُوعٌ':Added, #1: 1	غَيْرَ الْمَشْرُوعِ
u'غَيْرٌ مَشْرُوعٌ':Added, #1: 1	غَيْرُ الْمَشْرُوعِ
u'غَيْرٌ مَشْرُوعٌ':Added, #1: 1	غَيْر الْمَشْرُوعِ
u'غَيْرٌ مَشْرُوعٌ':Added, #1: 1	غَيْرَ الْمَشْرُوعِ
u'غير مَشْرُوعٌ':Added, #1: 1	غَيْرُ الْمَشْرُوعِ
u'غَيْرٌ مَشْرُوعٌ':Added, #1: 1	غَيْرِ الْمَشْرُوعَيْنِ
u'غير مَشْرُوعٌ':Added, #1: 1	غَيْرِ الْمَشْرُوعَيْنِ
u'غير مَشْرُوعٌ':Added, #1: 1	غَيْرَ مَشْرُوعَةٍ
u'غَيْرٌ مَشْرُوعٌ':Added, #1: 1	غَيْرِ مَشْرُوعَةٍ
u'غَيْرٌ مَشْرُوعٌ':Added, #1: 1	غَيْرَ مَشْرُوعَةٍ
u'غير مَشْرُوعٌ':Added, #1: 1	غَيْرِ مَشْرُوعَةٍ
u'غَيْرٌ مَشْرُوعٌ':Added, #22: 22	غَيْرَ مَشْرُوعٍ
u'غير مَشْرُوعٌ':Added, #22: 22	غَيْرَ مَشْرُوعٍ
u'غَيْرٌ مَشْرُوعٌ':Added, #6: 6	غَيْرِ مَشْرُوعٍ
u'غير مَشْرُوعٌ':Added, #6: 6	غَيْرِ مَشْرُوعٍ
u'غَيْرٌ مَشْرُوعٌ':Added, #7: 7	غَيْرِ الْمَشْرُوعِ
u'غير مَشْرُوعٌ':Added, #7: 7	غَيْرِ الْمَشْرُوعِ
u'غَيْرٌ مَشْرُوعٌ':Added, #93: 93	غَيْرُ مَشْرُوعٍ
u'غير مَشْغُولٌ':Added, #93: 93	غَيْرُ مَشْرُوعٍ
u'غَيْرٌ مَشْغُولٌ':Added, #1: 1	غَيْرُ مَشْغُولَتَيْنِ
u'غير مَشْغُولٌ':Added, #1: 1	غَيْرُ مَشْغُولَتَيْنِ
u'غَيْرٌ مَشْغُولٌ':Added, #3: 3	غَيْرُ مَشْغُولَةٍ
u'غير مَشْغُولٌ':Added, #3: 3	غَيْرُ مَشْغُولَةٍ
u'غَيْرٌ مَشْغُولٌ':Added, #6: 6	غَيْرَ مَشْغُولٍ
u'غير مَشَقَّةٌ':Added, #6: 6	غَيْرَ مَشْغُولٍ
u'غَيْرٌ مَشَقَّةٌ':Added, #12: 12	غَيْرِ مَشَقَّةٍ
u'غير مَشْقُوقٌ':Added, #12: 12	غَيْرِ مَشَقَّةٍ
u'غَيْرٌ مَشْقُوقٌ':Added, #14: 14	غَيْرَ مَشْقُوقٍ
u'غير مَشْقُوقٌ':Added, #14: 14	غَيْرَ مَشْقُوقٍ
u'غَيْرٌ مَشْقُوقٌ':Added, #1: 1	غَيْرُ مَشْقُوقِ
u'غير مَشْقُوقٌ':Added, #1: 1	غَيْرُ مَشْقُوقِ
u'غير مَشْقُوقٌ':Added, #1: 1	غَيْرَ مَشْقُوقَةٍ
u'غَيْرٌ مَشْقُوقٌ':Added, #1: 1	غَيْرِ مَشْقُوقَةٍ
u'غَيْرٌ مَشْقُوقٌ':Added, #1: 1	غَيْرَ مَشْقُوقَةٍ
u'غير مُشْكِلٌ':Added, #1: 1	غَيْرِ مَشْقُوقَةٍ
u'غير مُشْكِلٌ':Added, #1: 1	غَيْرَ الْمُشْكِلِ
u'غَيْرٌ مُشْكِلٌ':Added, #1: 1	غَيْرِ الْمُشْكِلِ
u'غَيْرٌ مُشْكِلٌ':Added, #1: 1	غَيْرَ الْمُشْكِلِ
u'غير مُشْكِلٌ':Added, #1: 1	غَيْرِ الْمُشْكِلِ
u'غَيْرٌ مُشْكِلٌ':Added, #2: 2	غَيْرُ الْمُشْكِلِ
u'غير مُشْكِلٌ':Added, #2: 2	غَيْرُ الْمُشْكِلِ
u'غَيْرٌ مُشْكِلٌ':Added, #3: 3	غَيْرِ مُشْكِلٍ
u'غير مُشْكِلٌ':Added, #3: 3	غَيْرِ مُشْكِلٍ
u'غَيْرٌ مُشْكِلٌ':Added, #6: 6	غَيْرُ مُشْكِلٍ
u'غير مُشْكِلٌ':Added, #6: 6	غَيْرُ مُشْكِلٍ
u'غَيْرٌ مُشْكِلٌ':Added, #7: 7	غَيْرَ مُشْكِلٍ
u'غير مَشْكُور':Added, #7: 7	غَيْرَ مُشْكِلٍ
u'غير مَشْكُور':Added, #1: 1	غَيْرُ مَشْكُورَةٍ
u'غَيْرٌ مَشْكُور':Added, #1: 1	غَيْرِ مَشْكُورَةٍ
u'غَيْرٌ مَشْكُور':Added, #1: 1	غَيْرُ مَشْكُورَةٍ
u'غير مَشْكُوكٌ':Added, #1: 1	غَيْرِ مَشْكُورَةٍ
u'غَيْرٌ مَشْكُوكٌ':Added, #1: 1	غَيْرَ مَشْكُوكٍ
u'غير مَشْهُودٌ':Added, #1: 1	غَيْرَ مَشْكُوكٍ
u'غَيْرٌ مَشْهُودٌ':Added, #2: 2	غَيْرَ الْمَشْهُودِ
u'غير مَشْهُودٌ':Added, #2: 2	غَيْرَ الْمَشْهُودِ
u'غَيْرٌ مَشْهُودٌ':Added, #2: 2	غَيْرُ مَشْهُودٍ
u'غير مَشْهُودٌ':Added, #2: 2	غَيْرُ مَشْهُودٍ
u'غَيْرٌ مَشْهُودٌ':Added, #3: 3	غَيْرِ الْمَشْهُودِ
u'غير مَشْهُودٌ':Added, #3: 3	غَيْرِ الْمَشْهُودِ
u'غَيْرٌ مَشْهُودٌ':Added, #4: 4	غَيْرُ الْمَشْهُودِ
u'غير مَشْهُورٌ':Added, #4: 4	غَيْرُ الْمَشْهُودِ
u'غَيْرٌ مَشْهُورٌ':Added, #15: 15	غَيْرُ مَشْهُورٍ
u'غير مَشْهُورٌ':Added, #15: 15	غَيْرُ مَشْهُورٍ
u'غَيْرٌ مَشْهُورٌ':Added, #1: 1	غَيْرُ الْمَشْهُورِ
u'غير مَشْهُورٌ':Added, #1: 1	غَيْرُ الْمَشْهُورِ
u'غَيْرٌ مَشْهُورٌ':Added, #1: 1	غَيْرِ الْمَشْهُورَةِ
u'غير مَشْهُورٌ':Added, #1: 1	غَيْرِ الْمَشْهُورَةِ
u'غَيْرٌ مَشْهُورٌ':Added, #1: 1	غَيْرِ مَشْهُورٍ
u'غير مَشْهُورٌ':Added, #1: 1	غَيْرِ مَشْهُورٍ
u'غير مَشْهُورٌ':Added, #1: 1	غَيْرَ مَشْهُورَةٍ
u'غَيْرٌ مَشْهُورٌ':Added, #1: 1	غَيْرِ مَشْهُورَةٍ
u'غَيْرٌ مَشْهُورٌ':Added, #1: 1	غَيْرَ مَشْهُورَةٍ
u'غير مَشْهُورٌ':Added, #1: 1	غَيْرِ مَشْهُورَةٍ
u'غَيْرٌ مَشْهُورٌ':Added, #1: 1	غَيْرَ مَشْهُورَيْنِ
u'غير مَشْهُورٌ':Added, #1: 1	غَيْرَ مَشْهُورَيْنِ
u'غَيْرٌ مَشْهُورٌ':Added, #3: 3	غَيْرِ الْمَشْهُورِ
u'غير مَشْهُورٌ':Added, #3: 3	غَيْرِ الْمَشْهُورِ
u'غَيْرٌ مَشْهُورٌ':Added, #6: 6	غَيْرَ مَشْهُورٍ
u'غير مَشْهُورٌ':Added, #6: 6	غَيْرَ مَشْهُورٍ
u'غَيْرٌ مَشْهُورٌ':Added, #6: 6	غَيْرُ مَشْهُورَةٍ
u'غير مَشُوبٌ':Added, #6: 6	غَيْرُ مَشْهُورَةٍ
u'غَيْرٌ مَشُوبٌ':Added, #1: 1	غَيْرَ مَشُوبِ
u'غير مَشُوبٌ':Added, #1: 1	غَيْرَ مَشُوبِ
u'غَيْرٌ مَشُوبٌ':Added, #2: 2	غَيْرِ مَشُوبٍ
u'غير مَشُورَةٌ':Added, #2: 2	غَيْرِ مَشُوبٍ
u'غَيْرٌ مَشُورَةٌ':Added, #1: 1	غَيْرِ مَشُورَةِ
u'غير مَشُورَةٌ':Added, #1: 1	غَيْرِ مَشُورَةِ
u'غَيْرٌ مَشُورَةٌ':Added, #4: 4	غَيْرِ مَشُورَةٍ
u'غير مُشَوِّشٌ':Added, #4: 4	غَيْرِ مَشُورَةٍ
u'غَيْرٌ مُشَوِّشٌ':Added, #1: 1	غَيْرِ مُشَوِّشٍ
u'غير مَشْيٌ':Added, #1: 1	غَيْرِ مُشَوِّشٍ
u'غَيْرٌ مَشْيٌ':Added, #1: 1	غَيْرِ مَشْيٍ
u'غير مَشِيئَةٌ':Added, #1: 1	غَيْرِ مَشْيٍ
u'غير مَشِيئَةٌ':Added, #1: 1	غَيْرُ الْمَشِيئَةِ
u'غَيْرٌ مَشِيئَةٌ':Added, #1: 1	غَيْرِ الْمَشِيئَةِ
u'غَيْرٌ مَشِيئَةٌ':Added, #1: 1	غَيْرُ الْمَشِيئَةِ
u'غير مَشِيئَةٌ':Added, #1: 1	غَيْرِ الْمَشِيئَةِ
u'غير مَشِيئَةٌ':Added, #1: 1	غَيْرُ مَشِيئَةٍ
u'غَيْرٌ مَشِيئَةٌ':Added, #1: 1	غَيْرِ مَشِيئَةِ
u'غَيْرٌ مَشِيئَةٌ':Added, #1: 1	غَيْرُ مَشِيئَةٍ
u'غير مَشِيئَةٌ':Added, #1: 1	غَيْرِ مَشِيئَةِ
u'غَيْرٌ مَشِيئَةٌ':Added, #4: 4	غَيْرِ مَشِيئَةٍ
u'غير مُصَابٌ':Added, #4: 4	غَيْرِ مَشِيئَةٍ
u'غَيْرٌ مُصَابٌ':Added, #1: 1	غَيْرَ مُصَابَةٍ
u'غير مُصادِف':Added, #1: 1	غَيْرَ مُصَابَةٍ
u'غَيْرٌ مُصادِف':Added, #1: 1	غَيْرُ مُصَادِفٍ
u'غير مُصَادَقٌ':Added, #1: 1	غَيْرُ مُصَادِفٍ
u'غَيْرٌ مُصَادَقٌ':Added, #1: 1	غَيْرِ مُصَادَقَةٍ
u'غير مُصَادَقَةٌ':Added, #1: 1	غَيْرِ مُصَادَقَةٍ
u'غَيْرٌ مُصَادَقَةٌ':Added, #1: 1	غَيْرِ مُصَادَقَةٍ
u'غير مَصَارِفُ':Added, #1: 1	غَيْرِ مُصَادَقَةٍ
u'غَيْرٌ مَصَارِفُ':Added, #1: 1	غَيْرِ الْمَصَارِفِ
u'غير مُصَالِحٌ':Added, #1: 1	غَيْرِ الْمَصَارِفِ
u'غَيْرٌ مُصَالِحٌ':Added, #1: 1	غَيْرَ الْمُصَالِحِ
u'غير مِصْبَاحٌ':Added, #1: 1	غَيْرَ الْمُصَالِحِ
u'غَيْرٌ مِصْبَاحٌ':Added, #1: 1	غَيْرِ مِصْبَاحٍ
u'غير مَصْبُوغ':Added, #1: 1	غَيْرِ مِصْبَاحٍ
u'غَيْرٌ مَصْبُوغ':Added, #1: 1	غَيْرَ مَصْبُوغٍ
u'غير مَصْبُوغ':Added, #1: 1	غَيْرَ مَصْبُوغٍ
u'غَيْرٌ مَصْبُوغ':Added, #1: 1	غَيْرِ مَصْبُوغَةٍ
u'غير مَصْبُوغ':Added, #1: 1	غَيْرِ مَصْبُوغَةٍ
u'غَيْرٌ مَصْبُوغ':Added, #2: 2	غَيْرِ الْمَصْبُوغِ
u'غير مُصَحَّحٌ':Added, #2: 2	غَيْرِ الْمَصْبُوغِ
u'غَيْرٌ مُصَحَّحٌ':Added, #1: 1	غَيْرُ الْمُصَحَّحِ
u'غير مُصَحِّحٌ':Added, #1: 1	غَيْرُ الْمُصَحَّحِ
u'غَيْرٌ مُصَحِّحٌ':Added, #1: 1	غَيْرُ مُصَحِّحٍ
u'غير مُصْحَفٌ':Added, #1: 1	غَيْرُ مُصَحِّحٍ
u'غَيْرٌ مُصْحَفٌ':Added, #1: 1	غَيْرُ الْمُصْحَفِ
u'غير مُصْحَفٌ':Added, #1: 1	غَيْرُ الْمُصْحَفِ
u'غَيْرٌ مُصْحَفٌ':Added, #2: 2	غَيْرِ الْمُصْحَفِ
u'غير مَصْدَرٌ':Added, #2: 2	غَيْرِ الْمُصْحَفِ
u'غَيْرٌ مَصْدَرٌ':Added, #1: 1	غَيْرِ مَصْدَرٍ
u'غير مَصْدَرٌ':Added, #1: 1	غَيْرِ مَصْدَرٍ
u'غَيْرٌ مَصْدَرٌ':Added, #2: 2	غَيْرِ الْمَصْدَرِ
u'غير مُصَدِّقٌ':Added, #2: 2	غَيْرِ الْمَصْدَرِ
u'غَيْرٌ مُصَدِّقٌ':Added, #1: 1	غَيْرِ الْمُصَدِّقِ
u'غير مُصَدِّقٌ':Added, #1: 1	غَيْرِ الْمُصَدِّقِ
u'غَيْرٌ مُصَدِّقٌ':Added, #1: 1	غَيْرَ مُصَدِّقٍ
u'غير مُصَدَّقٌ':Added, #1: 1	غَيْرَ مُصَدِّقٍ
u'غَيْرٌ مُصَدَّقٌ':Added, #2: 2	غَيْرُ مُصَدَّقَةٍ
u'غير مُصَدَّقٌ':Added, #2: 2	غَيْرُ مُصَدَّقَةٍ
u'غَيْرٌ مُصَدَّقٌ':Added, #4: 4	غَيْرُ مُصَدَّقٍ
u'غير مِصْرٌ':Added, #4: 4	غَيْرُ مُصَدَّقٍ
u'غَيْرٌ مِصْرٌ':Added, #17: 17	غَيْرِ الْمِصْرِ
u'غير مُصِرٌّ':Added, #17: 17	غَيْرِ الْمِصْرِ
u'غير مِصْرٌ':Added, #1: 1	غَيْرِ الْمُصِرِّ
u'غَيْرٌ مُصِرٌّ':Added, #1: 1	غَيْرَ الْمِصْرِ
u'غَيْرٌ مِصْرٌ':Added, #1: 1	غَيْرِ الْمُصِرِّ
u'غير مُصِرٌّ':Added, #1: 1	غَيْرَ الْمِصْرِ
u'غير مِصْرٌ':Added, #1: 1	غَيْرَ مُصِرٍّ
u'غَيْرٌ مُصِرٌّ':Added, #1: 1	غَيْرَ مِصْرِ
u'غَيْرٌ مِصْرٌ':Added, #1: 1	غَيْرَ مُصِرٍّ
u'غير مِصْرٌ':Added, #1: 1	غَيْرَ مِصْرِ
u'غَيْرٌ مِصْرٌ':Added, #1: 1	غَيْرَ مِصْرِهِ
u'غير مِصْرٌ':Added, #1: 1	غَيْرَ مِصْرِهِ
u'غَيْرٌ مِصْرٌ':Added, #3: 3	غَيْرِ مِصْرِ
u'غير مِصْرٌ':Added, #3: 3	غَيْرِ مِصْرِ
u'غَيْرٌ مِصْرٌ':Added, #3: 3	غَيْرِ مِصْرِهِ
u'غير مِصْرٌ':Added, #3: 3	غَيْرِ مِصْرِهِ
u'غَيْرٌ مِصْرٌ':Added, #9: 9	غَيْرِ مِصْرٍ
u'غير مُصَرَّحٌ':Added, #9: 9	غَيْرِ مِصْرٍ
u'غَيْرٌ مُصَرَّحٌ':Added, #1: 1	غَيْرَ مُصَرَّحٍ
u'غير مُصَرَّحٌ':Added, #1: 1	غَيْرَ مُصَرَّحٍ
u'غَيْرٌ مُصَرَّحٌ':Added, #2: 2	غَيْرُ مُصَرَّحٍ
u'غير مَصْرِفٌ':Added, #2: 2	غَيْرُ مُصَرَّحٍ
u'غَيْرٌ مَصْرِفٌ':Added, #1: 1	غَيْرِ الْمَصْرِفِ
u'غير مَصْرِفٌ':Added, #1: 1	غَيْرِ الْمَصْرِفِ
u'غَيْرٌ مَصْرِفٌ':Added, #1: 1	غَيْرَ مَصْرِفٍ
u'غير مُصَرِّفٌ':Added, #1: 1	غَيْرَ مَصْرِفٍ
u'غَيْرٌ مُصَرِّفٌ':Added, #1: 1	غَيْرِ مُصَرِّفِهِ
u'غير مَصْرِفٌ':Added, #1: 1	غَيْرِ مُصَرِّفِهِ
u'غَيْرٌ مَصْرِفٌ':Added, #2: 2	غَيْرُ مَصْرِفٍ
u'غير مَصْرِفٌ':Added, #2: 2	غَيْرُ مَصْرِفٍ
u'غَيْرٌ مَصْرِفٌ':Added, #2: 2	غَيْرِ مَصْرِفِهِ
u'غير مَصْرُوفٌ':Added, #2: 2	غَيْرِ مَصْرِفِهِ
u'غير مَصْرُوف':Added, #1: 1	غَيْرُ الْمَصْرُوفِ
u'غَيْرٌ مَصْرُوفٌ':Added, #1: 1	غَيْرُ الْمَصْرُوفِ
u'غَيْرٌ مَصْرُوف':Added, #1: 1	غَيْرُ الْمَصْرُوفِ
u'غير مَصْرُوفٌ':Added, #1: 1	غَيْرُ الْمَصْرُوفِ
u'غير مَصْرُوف':Added, #1: 1	غَيْرَ مَصْرُوفٍ
u'غَيْرٌ مَصْرُوفٌ':Added, #1: 1	غَيْرَ مَصْرُوفٍ
u'غَيْرٌ مَصْرُوف':Added, #1: 1	غَيْرَ مَصْرُوفٍ
u'غير مَصْرُوفٌ':Added, #1: 1	غَيْرَ مَصْرُوفٍ
u'غَيْرٌ مَصْرُوفٌ':Added, #1: 1	غَيْرُ مَصْرُوفَةٍ
u'غير مَصْرُوفٌ':Added, #1: 1	غَيْرُ مَصْرُوفَةٍ
u'غير مَصْرُوف':Added, #1: 1	غَيْرُ مَصْرُوفَتَيْنِ
u'غَيْرٌ مَصْرُوفٌ':Added, #1: 1	غَيْرُ مَصْرُوفَتَيْنِ
u'غَيْرٌ مَصْرُوف':Added, #1: 1	غَيْرُ مَصْرُوفَتَيْنِ
u'غير مَصْرُوفٌ':Added, #1: 1	غَيْرُ مَصْرُوفَتَيْنِ
u'غير مَصْرُوف':Added, #4: 4	غَيْرُ مَصْرُوفٍ
u'غَيْرٌ مَصْرُوفٌ':Added, #4: 4	غَيْرُ مَصْرُوفٍ
u'غَيْرٌ مَصْرُوف':Added, #4: 4	غَيْرُ مَصْرُوفٍ
u'غير مِصْرِيٌّ':Added, #4: 4	غَيْرُ مَصْرُوفٍ
u'غَيْرٌ مِصْرِيٌّ':Added, #1: 1	غَيْرَ مِصْرِيَّةٍ
u'غير مُصْطَلَحٌ':Added, #1: 1	غَيْرَ مِصْرِيَّةٍ
u'غير مُصْطَلَحٌ':Added, #1: 1	غَيْرَ الْمُصْطَلَحِ
u'غَيْرٌ مُصْطَلَحٌ':Added, #1: 1	غَيْرُ الْمُصْطَلَحِ
u'غَيْرٌ مُصْطَلَحٌ':Added, #1: 1	غَيْرَ الْمُصْطَلَحِ
u'غير مَصْلٌ':Added, #1: 1	غَيْرُ الْمُصْطَلَحِ
u'غَيْرٌ مَصْلٌ':Added, #1: 1	غَيْرِ الْمَصْلِ
u'غير مُصْلِحٌ':Added, #1: 1	غَيْرِ الْمَصْلِ
u'غَيْرٌ مُصْلِحٌ':Added, #1: 1	غَيْرُ مُصْلِحٍ
u'غير مُصْلِحٌ':Added, #1: 1	غَيْرُ مُصْلِحٍ
u'غَيْرٌ مُصْلِحٌ':Added, #1: 1	غَيْرَ مُصْلِحَةٍ
u'غير مُصْلِحٌ':Added, #1: 1	غَيْرَ مُصْلِحَةٍ
u'غَيْرٌ مُصْلِحٌ':Added, #4: 4	غَيْرَ مُصْلِحٍ
u'غير مَصْلَحَةٌ':Added, #4: 4	غَيْرَ مُصْلِحٍ
u'غَيْرٌ مَصْلَحَةٌ':Added, #1: 1	غَيْرِ مَصْلَحَةٍ
u'غير مُصَنِّفٌ':Added, #1: 1	غَيْرِ مَصْلَحَةٍ
u'غَيْرٌ مُصَنِّفٌ':Added, #2: 2	غَيْرِ الْمُصَنِّفِ
u'غير مُصَنِّفٌ':Added, #2: 2	غَيْرِ الْمُصَنِّفِ
u'غَيْرٌ مُصَنِّفٌ':Added, #3: 3	غَيْرُ الْمُصَنِّفِ
u'غير مُصَنِّفٌ':Added, #3: 3	غَيْرُ الْمُصَنِّفِ
u'غَيْرٌ مُصَنِّفٌ':Added, #5: 5	غَيْرَ الْمُصَنِّفِ
u'غير مَصْنُوعٌ':Added, #5: 5	غَيْرَ الْمُصَنِّفِ
u'غير مَصْنُوعٌ':Added, #1: 1	غَيْرُ الْمَصْنُوعِ
u'غَيْرٌ مَصْنُوعٌ':Added, #1: 1	غَيْرِ الْمَصْنُوعِ
u'غَيْرٌ مَصْنُوعٌ':Added, #1: 1	غَيْرُ الْمَصْنُوعِ
u'غير مَصْنُوعٌ':Added, #1: 1	غَيْرِ الْمَصْنُوعِ
u'غير مَصْنُوعٌ':Added, #1: 1	غَيْرَ مَصْنُوعٍ
u'غَيْرٌ مَصْنُوعٌ':Added, #1: 1	غَيْرُ مَصْنُوعٍ
u'غَيْرٌ مَصْنُوعٌ':Added, #1: 1	غَيْرَ مَصْنُوعٍ
u'غير مَصْنُوعٌ':Added, #1: 1	غَيْرُ مَصْنُوعٍ
u'غَيْرٌ مَصْنُوعٌ':Added, #2: 2	غَيْرَ الْمَصْنُوعِ
u'غير مُصَوَّرٌ':Added, #2: 2	غَيْرَ الْمَصْنُوعِ
u'غَيْرٌ مُصَوَّرٌ':Added, #1: 1	غَيْرِ الْمُصَوَّرَةِ
u'غير مُصَوَّرٌ':Added, #1: 1	غَيْرِ الْمُصَوَّرَةِ
u'غَيْرٌ مُصَوَّرٌ':Added, #1: 1	غَيْرِ مُصَوَّرٍ
u'غير مُصَوَّرٌ':Added, #1: 1	غَيْرِ مُصَوَّرٍ
u'غَيْرٌ مُصَوَّرٌ':Added, #1: 1	غَيْرُ مُصَوَّرَةٍ
u'غير مُصَوَّرٌ':Added, #1: 1	غَيْرُ مُصَوَّرَةٍ
u'غَيْرٌ مُصَوَّرٌ':Added, #2: 2	غَيْرَ مُصَوَّرٍ
u'غير مُصَوَّرٌ':Added, #2: 2	غَيْرَ مُصَوَّرٍ
u'غير مُصَوَّرٌ':Added, #2: 2	غَيْرَ مُصَوَّرَةٍ
u'غَيْرٌ مُصَوَّرٌ':Added, #2: 2	غَيْرِ مُصَوَّرَةٍ
u'غَيْرٌ مُصَوَّرٌ':Added, #2: 2	غَيْرَ مُصَوَّرَةٍ
u'غير مَصُوغٌ':Added, #2: 2	غَيْرِ مُصَوَّرَةٍ
u'غَيْرٌ مَصُوغٌ':Added, #1: 1	غَيْرَ مَصُوغٍ
u'غير مُصِيبٌ':Added, #1: 1	غَيْرَ مَصُوغٍ
u'غَيْرٌ مُصِيبٌ':Added, #1: 1	غَيْرِ مُصِيبِ
u'غير مُضَادٌّ':Added, #1: 1	غَيْرِ مُصِيبِ
u'غَيْرٌ مُضَادٌّ':Added, #1: 1	غَيْرُ مُضَادٍّ
u'غير مُضَارَبَةٌ':Added, #1: 1	غَيْرُ مُضَادٍّ
u'غَيْرٌ مُضَارَبَةٌ':Added, #3: 3	غَيْرِ الْمُضَارَبَةِ
u'غير مُضَاعَفٌ':Added, #3: 3	غَيْرِ الْمُضَارَبَةِ
u'غير مُضَاعَفٌ':Added, #1: 1	غَيْرَ مُضَاعَفٍ
u'غَيْرٌ مُضَاعَفٌ':Added, #1: 1	غَيْرُ مُضَاعَفٍ
u'غَيْرٌ مُضَاعَفٌ':Added, #1: 1	غَيْرَ مُضَاعَفٍ
u'غير مُضَاعَفٌ':Added, #1: 1	غَيْرُ مُضَاعَفٍ
u'غَيْرٌ مُضَاعَفٌ':Added, #1: 1	غَيْرِ مُضَاعَفَةٍ
u'غير مُضَاعَفَةٌ':Added, #1: 1	غَيْرِ مُضَاعَفَةٍ
u'غَيْرٌ مُضَاعَفَةٌ':Added, #1: 1	غَيْرِ مُضَاعَفَةٍ
u'غير مُضَافٌ':Added, #1: 1	غَيْرِ مُضَاعَفَةٍ
u'غَيْرٌ مُضَافٌ':Added, #1: 1	غَيْرُ الْمُضَافِ
u'غير مُضَافٌ':Added, #1: 1	غَيْرُ الْمُضَافِ
u'غَيْرٌ مُضَافٌ':Added, #1: 1	غَيْرِ مُضَافَةٍ
u'غير مُضَافٌ':Added, #1: 1	غَيْرِ مُضَافَةٍ
u'غَيْرٌ مُضَافٌ':Added, #25: 25	غَيْرُ مُضَافٍ
u'غير مُضَافٌ':Added, #25: 25	غَيْرُ مُضَافٍ
u'غَيْرٌ مُضَافٌ':Added, #3: 3	غَيْرِ مُضَافٍ
u'غير مُضَافٌ':Added, #3: 3	غَيْرِ مُضَافٍ
u'غَيْرٌ مُضَافٌ':Added, #4: 4	غَيْرُ مُضَافَةٍ
u'غير مُضَافٌ':Added, #4: 4	غَيْرُ مُضَافَةٍ
u'غَيْرٌ مُضَافٌ':Added, #5: 5	غَيْرَ مُضَافٍ
u'غير مَضْبُوطٌ':Added, #5: 5	غَيْرَ مُضَافٍ
u'غير مَضْبُوطٌ':Added, #1: 1	غَيْرَ مَضْبُوطَةٍ
u'غَيْرٌ مَضْبُوطٌ':Added, #1: 1	غَيْرُ مَضْبُوطَةٍ
u'غَيْرٌ مَضْبُوطٌ':Added, #1: 1	غَيْرَ مَضْبُوطَةٍ
u'غير مَضْبُوطٌ':Added, #1: 1	غَيْرُ مَضْبُوطَةٍ
u'غَيْرٌ مَضْبُوطٌ':Added, #2: 2	غَيْرَ مَضْبُوطٍ
u'غير مَضْبُوطٌ':Added, #2: 2	غَيْرَ مَضْبُوطٍ
u'غَيْرٌ مَضْبُوطٌ':Added, #7: 7	غَيْرُ مَضْبُوطٍ
u'غير مُضِرٌّ':Added, #7: 7	غَيْرُ مَضْبُوطٍ
u'غَيْرٌ مُضِرٌّ':Added, #1: 1	غَيْرُ الْمُضِرِّ
u'غير مُضِرٌّ':Added, #1: 1	غَيْرُ الْمُضِرِّ
u'غَيْرٌ مُضِرٌّ':Added, #1: 1	غَيْرَ مُضِرَّةٍ
u'غير مُضِرٌّ':Added, #1: 1	غَيْرَ مُضِرَّةٍ
u'غَيْرٌ مُضِرٌّ':Added, #2: 2	غَيْرُ مُضِرٍّ
u'غير مُضِرٌّ':Added, #2: 2	غَيْرُ مُضِرٍّ
u'غَيْرٌ مُضِرٌّ':Added, #7: 7	غَيْرَ مُضِرٍّ
u'غير مِضْرَبٌ':Added, #7: 7	غَيْرَ مُضِرٍّ
u'غَيْرٌ مِضْرَبٌ':Added, #1: 1	غَيْرِ الْمِضْرَبِ
u'غير مَضَرَّةٌ':Added, #1: 1	غَيْرِ الْمِضْرَبِ
u'غَيْرٌ مَضَرَّةٌ':Added, #2: 2	غَيْرِ مَضَرَّةٍ
u'غير مَضْرُوبٌ':Added, #2: 2	غَيْرِ مَضَرَّةٍ
u'غَيْرٌ مَضْرُوبٌ':Added, #1: 1	غَيْرَ الْمَضْرُوبِ
u'غير مَضْرُوبٌ':Added, #1: 1	غَيْرَ الْمَضْرُوبِ
u'غَيْرٌ مَضْرُوبٌ':Added, #1: 1	غَيْرِ الْمَضْرُوبَةِ
u'غير مَضْرُوبٌ':Added, #1: 1	غَيْرِ الْمَضْرُوبَةِ
u'غير مَضْرُوبٌ':Added, #1: 1	غَيْرُ مَضْرُوبٍ
u'غَيْرٌ مَضْرُوبٌ':Added, #1: 1	غَيْرِ مَضْرُوبٍ
u'غَيْرٌ مَضْرُوبٌ':Added, #1: 1	غَيْرُ مَضْرُوبٍ
u'غير مَضْرُوبٌ':Added, #1: 1	غَيْرِ مَضْرُوبٍ
u'غَيْرٌ مَضْرُوبٌ':Added, #1: 1	غَيْرُ مَضْرُوبَةٍ
u'غير مَضْرُوبٌ':Added, #1: 1	غَيْرُ مَضْرُوبَةٍ
u'غير مَضْرُوبٌ':Added, #2: 2	غَيْرُ الْمَضْرُوبِ
u'غَيْرٌ مَضْرُوبٌ':Added, #2: 2	غَيْرِ الْمَضْرُوبِ
u'غَيْرٌ مَضْرُوبٌ':Added, #2: 2	غَيْرُ الْمَضْرُوبِ
u'غير مَضْرُوبٌ':Added, #2: 2	غَيْرِ الْمَضْرُوبِ
u'غَيْرٌ مَضْرُوبٌ':Added, #2: 2	غَيْرِ مَضْرُوبَةٍ
u'غير مَضْرُوبٌ':Added, #2: 2	غَيْرِ مَضْرُوبَةٍ
u'غَيْرٌ مَضْرُوبٌ':Added, #3: 3	غَيْرَ مَضْرُوبَيْنِ
u'غير مَضْرُوبٌ':Added, #3: 3	غَيْرَ مَضْرُوبَيْنِ
u'غَيْرٌ مَضْرُوبٌ':Added, #5: 5	غَيْرَ مَضْرُوبَةٍ
u'غير مَضْرُوبٌ':Added, #5: 5	غَيْرَ مَضْرُوبَةٍ
u'غَيْرٌ مَضْرُوبٌ':Added, #9: 9	غَيْرَ مَضْرُوبٍ
u'غير مُضْطَرٌّ':Added, #9: 9	غَيْرَ مَضْرُوبٍ
u'غير مُضْطَرٌّ':Added, #1: 1	غَيْرُ الْمُضْطَرِّ
u'غَيْرٌ مُضْطَرٌّ':Added, #1: 1	غَيْرِ الْمُضْطَرِّ
u'غَيْرٌ مُضْطَرٌّ':Added, #1: 1	غَيْرُ الْمُضْطَرِّ
u'غير مُضْطَرٌّ':Added, #1: 1	غَيْرِ الْمُضْطَرِّ
u'غَيْرٌ مُضْطَرٌّ':Added, #1: 1	غَيْرُ مُضْطَرَّةٍ
u'غير مُضْطَرٌّ':Added, #1: 1	غَيْرُ مُضْطَرَّةٍ
u'غَيْرٌ مُضْطَرٌّ':Added, #22: 22	غَيْرُ مُضْطَرٍّ
u'غير مُضْطَرٌّ':Added, #22: 22	غَيْرُ مُضْطَرٍّ
u'غَيْرٌ مُضْطَرٌّ':Added, #2: 2	غَيْرِ مُضْطَرٍّ
u'غير مُضْطَرٌّ':Added, #2: 2	غَيْرِ مُضْطَرٍّ
u'غَيْرٌ مُضْطَرٌّ':Added, #9: 9	غَيْرَ مُضْطَرٍّ
u'غير مُضْطَرِبٌ':Added, #9: 9	غَيْرَ مُضْطَرٍّ
u'غَيْرٌ مُضْطَرِبٌ':Added, #1: 1	غَيْرَ مُضْطَرِبٍ
u'غير مُضْطَرِبٌ':Added, #1: 1	غَيْرَ مُضْطَرِبٍ
u'غَيْرٌ مُضْطَرِبٌ':Added, #1: 1	غَيْرَ مُضْطَرِبَةٍ
u'غير مُضْطَرِبٌ':Added, #1: 1	غَيْرَ مُضْطَرِبَةٍ
u'غَيْرٌ مُضْطَرِبٌ':Added, #3: 3	غَيْرُ مُضْطَرِبٍ
u'غير مَضْغٌ':Added, #3: 3	غَيْرُ مُضْطَرِبٍ
u'غَيْرٌ مَضْغٌ':Added, #6: 6	غَيْرِ مَضْغٍ
u'غير مُضْغَةٌ':Added, #6: 6	غَيْرِ مَضْغٍ
u'غَيْرٌ مُضْغَةٌ':Added, #1: 1	غَيْرَ مُضْغَةٍ
u'غير مَضْمَضَةٌ':Added, #1: 1	غَيْرَ مُضْغَةٍ
u'غَيْرٌ مَضْمَضَةٌ':Added, #2: 2	غَيْرِ مَضْمَضَةٍ
u'غير مُضَمَّن':Added, #2: 2	غَيْرِ مَضْمَضَةٍ
u'غير مُضَمَّن':Added, #1: 1	غَيْرُ مُضَمَّنٍ
u'غَيْرٌ مُضَمَّن':Added, #1: 1	غَيْرِ مُضَمَّنٍ
u'غَيْرٌ مُضَمَّن':Added, #1: 1	غَيْرُ مُضَمَّنٍ
u'غير مُضَمَّن':Added, #1: 1	غَيْرِ مُضَمَّنٍ
u'غَيْرٌ مُضَمَّن':Added, #2: 2	غَيْرَ مُضَمَّنٍ
u'غير مَضْمُومٌ':Added, #2: 2	غَيْرَ مُضَمَّنٍ
u'غير مَضْمُومٌ':Added, #1: 1	غَيْرَ مَضْمُومٍ
u'غَيْرٌ مَضْمُومٌ':Added, #1: 1	غَيْرُ مَضْمُومٍ
u'غَيْرٌ مَضْمُومٌ':Added, #1: 1	غَيْرَ مَضْمُومٍ
u'غير مَضْمُومٌ':Added, #1: 1	غَيْرُ مَضْمُومٍ
u'غَيْرٌ مَضْمُومٌ':Added, #1: 1	غَيْرُ مَضْمُومَةٍ
u'غير مَضْمُونٌ':Added, #1: 1	غَيْرُ مَضْمُومَةٍ
u'غَيْرٌ مَضْمُونٌ':Added, #15: 15	غَيْرَ مَضْمُونٍ
u'غير مَضْمُونٌ':Added, #15: 15	غَيْرَ مَضْمُونٍ
u'غَيْرٌ مَضْمُونٌ':Added, #1: 1	غَيْرِ الْمَضْمُونَةِ
u'غير مَضْمُونٌ':Added, #1: 1	غَيْرِ الْمَضْمُونَةِ
u'غَيْرٌ مَضْمُونٌ':Added, #1: 1	غَيْرُ مَضْمُونَةِ
u'غير مَضْمُونٌ':Added, #1: 1	غَيْرُ مَضْمُونَةِ
u'غَيْرٌ مَضْمُونٌ':Added, #24: 24	غَيْرُ مَضْمُونَةٍ
u'غير مَضْمُونٌ':Added, #24: 24	غَيْرُ مَضْمُونَةٍ
u'غير مَضْمُونٌ':Added, #2: 2	غَيْرُ الْمَضْمُونِ
u'غَيْرٌ مَضْمُونٌ':Added, #2: 2	غَيْرِ الْمَضْمُونِ
u'غَيْرٌ مَضْمُونٌ':Added, #2: 2	غَيْرُ الْمَضْمُونِ
u'غير مَضْمُونٌ':Added, #2: 2	غَيْرِ الْمَضْمُونِ
u'غَيْرٌ مَضْمُونٌ':Added, #2: 2	غَيْرَ مَضْمُونَةٍ
u'غير مَضْمُونٌ':Added, #2: 2	غَيْرَ مَضْمُونَةٍ
u'غَيْرٌ مَضْمُونٌ':Added, #3: 3	غَيْرُ الْمَضْمُونَةِ
u'غير مَضْمُونٌ':Added, #3: 3	غَيْرُ الْمَضْمُونَةِ
u'غَيْرٌ مَضْمُونٌ':Added, #3: 3	غَيْرِ مَضْمُونَةٍ
u'غير مَضْمُونٌ':Added, #3: 3	غَيْرِ مَضْمُونَةٍ
u'غَيْرٌ مَضْمُونٌ':Added, #5: 5	غَيْرِ مَضْمُونٍ
u'غير مَضْمُونٌ':Added, #5: 5	غَيْرِ مَضْمُونٍ
u'غَيْرٌ مَضْمُونٌ':Added, #70: 70	غَيْرُ مَضْمُونٍ
u'غير مُضَيِّع':Added, #70: 70	غَيْرُ مَضْمُونٍ
u'غَيْرٌ مُضَيِّع':Added, #2: 2	غَيْرُ مُضَيِّعٍ
u'غير مُطَابِقٌ':Added, #2: 2	غَيْرُ مُضَيِّعٍ
u'غَيْرٌ مُطَابِقٌ':Added, #1: 1	غَيْرَ الْمُطَابِقِ
u'غير مُطَابِقٌ':Added, #1: 1	غَيْرَ الْمُطَابِقِ
u'غَيْرٌ مُطَابِقٌ':Added, #1: 1	غَيْرَ مُطَابِقَةٍ
u'غير مُطَابِقٌ':Added, #1: 1	غَيْرَ مُطَابِقَةٍ
u'غَيْرٌ مُطَابِقٌ':Added, #1: 1	غَيْرُ مُطَابِقَيْنِ
u'غير مُطَابِقٌ':Added, #1: 1	غَيْرُ مُطَابِقَيْنِ
u'غَيْرٌ مُطَابِقٌ':Added, #21: 21	غَيْرُ مُطَابِقٍ
u'غير مُطَابِقٌ':Added, #21: 21	غَيْرُ مُطَابِقٍ
u'غير مُطَابِقٌ':Added, #3: 3	غَيْرُ الْمُطَابِقِ
u'غَيْرٌ مُطَابِقٌ':Added, #3: 3	غَيْرِ الْمُطَابِقِ
u'غَيْرٌ مُطَابِقٌ':Added, #3: 3	غَيْرُ الْمُطَابِقِ
u'غير مُطَابِقٌ':Added, #3: 3	غَيْرِ الْمُطَابِقِ
u'غَيْرٌ مُطَابِقٌ':Added, #3: 3	غَيْرِ مُطَابِقٍ
u'غير مُطَابِقٌ':Added, #3: 3	غَيْرِ مُطَابِقٍ
u'غَيْرٌ مُطَابِقٌ':Added, #3: 3	غَيْرُ مُطَابِقَةٍ
u'غير مُطَابِقٌ':Added, #3: 3	غَيْرُ مُطَابِقَةٍ
u'غَيْرٌ مُطَابِقٌ':Added, #8: 8	غَيْرَ مُطَابِقٍ
u'غير مُطَابَقَةٌ':Added, #8: 8	غَيْرَ مُطَابِقٍ
u'غَيْرٌ مُطَابَقَةٌ':Added, #1: 1	غَيْرِ مُطَابَقَةٍ
u'غير مُطاق':Added, #1: 1	غَيْرِ مُطَابَقَةٍ
u'غَيْرٌ مُطاق':Added, #1: 1	غَيْرَ مُطَاقِ
u'غير مُطَالَبٌ':Added, #1: 1	غَيْرَ مُطَاقِ
u'غَيْرٌ مُطَالَبٌ':Added, #15: 15	غَيْرُ مُطَالَبٍ
u'غير مُطَالَبٌ':Added, #15: 15	غَيْرُ مُطَالَبٍ
u'غَيْرٌ مُطَالَبٌ':Added, #2: 2	غَيْرَ مُطَالَبٍ
u'غير مُطَالَبٌ':Added, #2: 2	غَيْرَ مُطَالَبٍ
u'غَيْرٌ مُطَالَبٌ':Added, #2: 2	غَيْرِ مُطَالَبَةِ
u'غير مُطَالَبٌ':Added, #2: 2	غَيْرِ مُطَالَبَةِ
u'غَيْرٌ مُطَالَبٌ':Added, #2: 2	غَيْرِ مُطَالَبَتِهِ
u'غير مُطَالَبٌ':Added, #2: 2	غَيْرِ مُطَالَبَتِهِ
u'غَيْرٌ مُطَالَبٌ':Added, #5: 5	غَيْرِ مُطَالَبَةٍ
u'غير مُطَالَبَةٌ':Added, #5: 5	غَيْرِ مُطَالَبَةٍ
u'غَيْرٌ مُطَالَبَةٌ':Added, #2: 2	غَيْرِ مُطَالَبَةِ
u'غير مُطَالَبَةٌ':Added, #2: 2	غَيْرِ مُطَالَبَةِ
u'غَيْرٌ مُطَالَبَةٌ':Added, #2: 2	غَيْرِ مُطَالَبَتِهِ
u'غير مُطَالَبَةٌ':Added, #2: 2	غَيْرِ مُطَالَبَتِهِ
u'غَيْرٌ مُطَالَبَةٌ':Added, #5: 5	غَيْرِ مُطَالَبَةٍ
u'غير مُطْبِقٌ':Added, #5: 5	غَيْرِ مُطَالَبَةٍ
u'غَيْرٌ مُطْبِقٌ':Added, #1: 1	غَيْرِ مُطْبِقٍ
u'غير مُطْبِقٌ':Added, #1: 1	غَيْرِ مُطْبِقٍ
u'غَيْرٌ مُطْبِقٌ':Added, #4: 4	غَيْرَ مُطْبِقٍ
u'غير مَطْبُوخٌ':Added, #4: 4	غَيْرَ مُطْبِقٍ
u'غير مَطْبُوخٌ':Added, #1: 1	غَيْرَ الْمَطْبُوخِ
u'غير مَطْبُوخٌ':Added, #1: 1	غَيْرُ الْمَطْبُوخِ
u'غَيْرٌ مَطْبُوخٌ':Added, #1: 1	غَيْرِ الْمَطْبُوخِ
u'غَيْرٌ مَطْبُوخٌ':Added, #1: 1	غَيْرَ الْمَطْبُوخِ
u'غَيْرٌ مَطْبُوخٌ':Added, #1: 1	غَيْرُ الْمَطْبُوخِ
u'غير مَطْبُوخٌ':Added, #1: 1	غَيْرِ الْمَطْبُوخِ
u'غَيْرٌ مَطْبُوخٌ':Added, #1: 1	غَيْرُ مَطْبُوخَةٍ
u'غير مَطْبُوخٌ':Added, #1: 1	غَيْرُ مَطْبُوخَةٍ
u'غير مَطْبُوخٌ':Added, #3: 3	غَيْرَ مَطْبُوخٍ
u'غير مَطْبُوخٌ':Added, #3: 3	غَيْرُ مَطْبُوخٍ
u'غَيْرٌ مَطْبُوخٌ':Added, #3: 3	غَيْرِ مَطْبُوخٍ
u'غَيْرٌ مَطْبُوخٌ':Added, #3: 3	غَيْرَ مَطْبُوخٍ
u'غَيْرٌ مَطْبُوخٌ':Added, #3: 3	غَيْرُ مَطْبُوخٍ
u'غير مَطْبُوعٌ':Added, #3: 3	غَيْرِ مَطْبُوخٍ
u'غَيْرٌ مَطْبُوعٌ':Added, #1: 1	غَيْرِ الْمَطْبُوعِ
u'غير مَطْبُوعٌ':Added, #1: 1	غَيْرِ الْمَطْبُوعِ
u'غَيْرٌ مَطْبُوعٌ':Added, #1: 1	غَيْرُ مَطْبُوعَةٍ
u'غير مَطْبُوعَةٌ':Added, #1: 1	غَيْرُ مَطْبُوعَةٍ
u'غَيْرٌ مَطْبُوعَةٌ':Added, #1: 1	غَيْرُ مَطْبُوعَةٍ
u'غير مَطْحُونٌ':Added, #1: 1	غَيْرُ مَطْبُوعَةٍ
u'غَيْرٌ مَطْحُونٌ':Added, #1: 1	غَيْرُ مَطْحُونٍ
u'غير مَطْحُونٌ':Added, #1: 1	غَيْرُ مَطْحُونٍ
u'غَيْرٌ مَطْحُونٌ':Added, #2: 2	غَيْرَ مَطْحُونٍ
u'غير مَطَرٌ':Added, #2: 2	غَيْرَ مَطْحُونٍ
u'غَيْرٌ مَطَرٌ':Added, #1: 1	غَيْرُ الْمَطَرِ
u'غير مَطَرٌ':Added, #1: 1	غَيْرُ الْمَطَرِ
u'غير مَطَرٌ':Added, #1: 1	غَيْرُ مَطَرٍ
u'غَيْرٌ مَطَرٌ':Added, #1: 1	غَيْرِ مَطَرٍ
u'غَيْرٌ مَطَرٌ':Added, #1: 1	غَيْرُ مَطَرٍ
u'غير مُطْرِبٌ':Added, #1: 1	غَيْرِ مَطَرٍ
u'غير مُطْرِبٌ':Added, #1: 1	غَيْرَ مُطْرِبٍ
u'غير مُطْرِبٌ':Added, #1: 1	غَيْرُ مُطْرِبٍ
u'غَيْرٌ مُطْرِبٌ':Added, #1: 1	غَيْرِ مُطْرِبٍ
u'غَيْرٌ مُطْرِبٌ':Added, #1: 1	غَيْرَ مُطْرِبٍ
u'غَيْرٌ مُطْرِبٌ':Added, #1: 1	غَيْرُ مُطْرِبٍ
u'غير مُطَّرِدٌ':Added, #1: 1	غَيْرِ مُطْرِبٍ
u'غَيْرٌ مُطَّرِدٌ':Added, #10: 10	غَيْرُ مُطَّرِدٍ
u'غير مُطَّرِدٌ':Added, #10: 10	غَيْرُ مُطَّرِدٍ
u'غَيْرٌ مُطَّرِدٌ':Added, #1: 1	غَيْرُ الْمُطَّرِدِ
u'غير مُطَّرِدٌ':Added, #1: 1	غَيْرُ الْمُطَّرِدِ
u'غَيْرٌ مُطَّرِدٌ':Added, #1: 1	غَيْرِ مُطَّرِدٍ
u'غير مُطَّرِدٌ':Added, #1: 1	غَيْرِ مُطَّرِدٍ
u'غَيْرٌ مُطَّرِدٌ':Added, #3: 3	غَيْرَ مُطَّرِدٍ
u'غير مُطَّرِدٌ':Added, #3: 3	غَيْرَ مُطَّرِدٍ
u'غَيْرٌ مُطَّرِدٌ':Added, #4: 4	غَيْرُ مُطَّرِدَةٍ
u'غير مَطْرُوقٌ':Added, #4: 4	غَيْرُ مُطَّرِدَةٍ
u'غَيْرٌ مَطْرُوقٌ':Added, #1: 1	غَيْرِ الْمَطْرُوقِ
u'غير مَطْرُوقٌ':Added, #1: 1	غَيْرِ الْمَطْرُوقِ
u'غَيْرٌ مَطْرُوقٌ':Added, #2: 2	غَيْرِ مَطْرُوقٍ
u'غير مَطْرُوقٌ':Added, #2: 2	غَيْرِ مَطْرُوقٍ
u'غَيْرٌ مَطْرُوقٌ':Added, #4: 4	غَيْرَ مَطْرُوقٍ
u'غير مَطْعَنٌ':Added, #4: 4	غَيْرَ مَطْرُوقٍ
u'غَيْرٌ مَطْعَنٌ':Added, #1: 1	غَيْرِ مَطْعَنٍ
u'غير مَطْعُوم':Added, #1: 1	غَيْرِ مَطْعَنٍ
u'غَيْرٌ مَطْعُوم':Added, #5: 5	غَيْرَ مَطْعُومٍ
u'غير مَطْعُونٌ':Added, #5: 5	غَيْرَ مَطْعُومٍ
u'غَيْرٌ مَطْعُونٌ':Added, #1: 1	غَيْرُ مَطْعُونٍ
u'غير مَطْلَعٌ':Added, #1: 1	غَيْرُ مَطْعُونٍ
u'غَيْرٌ مَطْلَعٌ':Added, #1: 1	غَيْرُ مَطْلَعِ
u'غير مُطْلَقٌ':Added, #1: 1	غَيْرُ مَطْلَعِ
u'غير مُطْلَقٌ':Added, #1: 1	غَيْرُ الْمُطْلَقِ
u'غَيْرٌ مُطْلَقٌ':Added, #1: 1	غَيْرِ الْمُطْلَقِ
u'غَيْرٌ مُطْلَقٌ':Added, #1: 1	غَيْرُ الْمُطْلَقِ
u'غير مُطَلَّقٌ':Added, #1: 1	غَيْرِ الْمُطْلَقِ
u'غَيْرٌ مُطَلَّقٌ':Added, #1: 1	غَيْرِ الْمُطَلَّقَاتِ
u'غير مُطَلَّقٌ':Added, #1: 1	غَيْرِ الْمُطَلَّقَاتِ
u'غير مُطْلَقٌ':Added, #1: 1	غَيْرِ الْمُطَلَّقَةِ
u'غير مُطْلَقٌ':Added, #1: 1	غَيْرُ الْمُطْلَقَةِ
u'غَيْرٌ مُطَلَّقٌ':Added, #1: 1	غَيْرِ الْمُطْلَقَةِ
u'غَيْرٌ مُطْلَقٌ':Added, #1: 1	غَيْرِ الْمُطَلَّقَةِ
u'غَيْرٌ مُطْلَقٌ':Added, #1: 1	غَيْرُ الْمُطْلَقَةِ
u'غير مُطْلَقٌ':Added, #1: 1	غَيْرِ الْمُطْلَقَةِ
u'غير مُطْلَقٌ':Added, #1: 1	غَيْرَ مُطْلَقِ
u'غَيْرٌ مُطْلَقٌ':Added, #1: 1	غَيْرُ مُطْلَقِ
u'غَيْرٌ مُطْلَقٌ':Added, #1: 1	غَيْرَ مُطْلَقِ
u'غير مُطْلَقٌ':Added, #1: 1	غَيْرُ مُطْلَقِ
u'غَيْرٌ مُطْلَقٌ':Added, #2: 2	غَيْرِ مُطْلَقِ
u'غير مُطَلَّقٌ':Added, #2: 2	غَيْرِ مُطْلَقِ
u'غير مُطَلَّقٌ':Added, #2: 2	غَيْرَ مُطَلَّقَةٍ
u'غَيْرٌ مُطَلَّقٌ':Added, #2: 2	غَيْرُ مُطَلَّقَةٍ
u'غَيْرٌ مُطَلَّقٌ':Added, #2: 2	غَيْرَ مُطَلَّقَةٍ
u'غير مُطْلَقٌ':Added, #2: 2	غَيْرُ مُطَلَّقَةٍ
u'غَيْرٌ مُطْلَقٌ':Added, #4: 4	غَيْرُ مُطْلَقٍ
u'غير مَطْلُوبٌ':Added, #4: 4	غَيْرُ مُطْلَقٍ
u'غَيْرٌ مَطْلُوبٌ':Added, #10: 10	غَيْرُ مَطْلُوبٍ
u'غير مَطْلُوبٌ':Added, #10: 10	غَيْرُ مَطْلُوبٍ
u'غَيْرٌ مَطْلُوبٌ':Added, #11: 11	غَيْرُ مَطْلُوبَةٍ
u'غير مَطْلُوبٌ':Added, #11: 11	غَيْرُ مَطْلُوبَةٍ
u'غير مَطْلُوبٌ':Added, #1: 1	غَيْرُ الْمَطْلُوبِ
u'غَيْرٌ مَطْلُوبٌ':Added, #1: 1	غَيْرِ الْمَطْلُوبِ
u'غَيْرٌ مَطْلُوبٌ':Added, #1: 1	غَيْرُ الْمَطْلُوبِ
u'غير مَطْلُوبٌ':Added, #1: 1	غَيْرِ الْمَطْلُوبِ
u'غَيْرٌ مَطْلُوبٌ':Added, #1: 1	غَيْرَ مَطْلُوبِ
u'غير مَطْلُوبٌ':Added, #1: 1	غَيْرَ مَطْلُوبِ
u'غَيْرٌ مَطْلُوبٌ':Added, #2: 2	غَيْرَ مَطْلُوبٍ
u'غير مَطْمَعٌ':Added, #2: 2	غَيْرَ مَطْلُوبٍ
u'غَيْرٌ مَطْمَعٌ':Added, #2: 2	غَيْرِ مَطْمَعٍ
u'غير مَطْمُوسٌ':Added, #2: 2	غَيْرِ مَطْمَعٍ
u'غَيْرٌ مَطْمُوسٌ':Added, #1: 1	غَيْرُ مَطْمُوسَةِ
u'غير مُطَهِّرٌ':Added, #1: 1	غَيْرُ مَطْمُوسَةِ
u'غَيْرٌ مُطَهِّرٌ':Added, #14: 14	غَيْرُ مُطَهِّرٍ
u'غير مُطَهِّرٌ':Added, #14: 14	غَيْرُ مُطَهِّرٍ
u'غَيْرٌ مُطَهِّرٌ':Added, #1: 1	غَيْرُ الْمُطَهِّرِ
u'غير مُطَهَّرٌ':Added, #1: 1	غَيْرُ الْمُطَهِّرِ
u'غير مُطَهِّرٌ':Added, #1: 1	غَيْرُ مُطَهَّرٍ
u'غَيْرٌ مُطَهَّرٌ':Added, #1: 1	غَيْرِ مُطَهِّرٍ
u'غَيْرٌ مُطَهِّرٌ':Added, #1: 1	غَيْرُ مُطَهَّرٍ
u'غير مُطَهِّرٌ':Added, #1: 1	غَيْرِ مُطَهِّرٍ
u'غَيْرٌ مُطَهِّرٌ':Added, #1: 1	غَيْرُ مُطَهِّرَةٍ
u'غير مُطَهِّرٌ':Added, #1: 1	غَيْرُ مُطَهِّرَةٍ
u'غَيْرٌ مُطَهِّرٌ':Added, #2: 2	غَيْرِ الْمُطَهِّرِ
u'غير مُطَهَّرٌ':Added, #2: 2	غَيْرِ الْمُطَهِّرِ
u'غير مُطَهِّرٌ':Added, #2: 2	غَيْرَ مُطَهّرٍ
u'غَيْرٌ مُطَهَّرٌ':Added, #2: 2	غَيْرَ مُطَهّرٍ
u'غَيْرٌ مُطَهِّرٌ':Added, #2: 2	غَيْرَ مُطَهّرٍ
u'غير مُطَهِّرٌ':Added, #2: 2	غَيْرَ مُطَهّرٍ
u'غَيْرٌ مُطَهِّرٌ':Added, #3: 3	غَيْرَ مُطَهِّرٍ
u'غير مُطَيَّب':Added, #3: 3	غَيْرَ مُطَهِّرٍ
u'غَيْرٌ مُطَيَّب':Added, #1: 1	غَيْرِ الْمُطَيَّبِ
u'غير مُطَيَّب':Added, #1: 1	غَيْرِ الْمُطَيَّبِ
u'غَيْرٌ مُطَيَّب':Added, #2: 2	غَيْرِ مُطَيَّبٍ
u'غير مُطَيَّب':Added, #2: 2	غَيْرِ مُطَيَّبٍ
u'غَيْرٌ مُطَيَّب':Added, #5: 5	غَيْرَ مُطَيَّبٍ
u'غير مَظْلُومٌ':Added, #5: 5	غَيْرَ مُطَيَّبٍ
u'غَيْرٌ مَظْلُومٌ':Added, #1: 1	غَيْرَ مَظْلُومٍ
u'غير مَظْنُون':Added, #1: 1	غَيْرَ مَظْلُومٍ
u'غَيْرٌ مَظْنُون':Added, #1: 1	غَيْرَ مَظْنُونٍ
u'غير مَظْنُون':Added, #1: 1	غَيْرَ مَظْنُونٍ
u'غَيْرٌ مَظْنُون':Added, #1: 1	غَيْرُ مَظْنُونَةٍ
u'غير مَظْنُون':Added, #1: 1	غَيْرُ مَظْنُونَةٍ
u'غَيْرٌ مَظْنُون':Added, #2: 2	غَيْرُ مَظْنُونٍ
u'غير مُظْهِرٌ':Added, #2: 2	غَيْرُ مَظْنُونٍ
u'غَيْرٌ مُظْهِرٌ':Added, #1: 1	غَيْرُ مُظْهِرٍ
u'غير مُظْهِرٌ':Added, #1: 1	غَيْرُ مُظْهِرٍ
u'غَيْرٌ مُظْهِرٌ':Added, #1: 1	غَيْرُ مُظْهِرَاتٍ
u'غير مُظْهِرٌ':Added, #1: 1	غَيْرُ مُظْهِرَاتٍ
u'غَيْرٌ مُظْهِرٌ':Added, #4: 4	غَيْرَ مُظْهِرٍ
u'غير مُعَادٌ':Added, #4: 4	غَيْرَ مُظْهِرٍ
u'غَيْرٌ مُعَادٌ':Added, #1: 1	غَيْرِ الْمُعَادِ
u'غير مُعَادٌ':Added, #1: 1	غَيْرِ الْمُعَادِ
u'غَيْرٌ مُعَادٌ':Added, #1: 1	غَيْرُ الْمُعَادَةِ
u'غير مُعَادٌ':Added, #1: 1	غَيْرُ الْمُعَادَةِ
u'غَيْرٌ مُعَادٌ':Added, #1: 1	غَيْرِ مُعَادَةٍ
u'غير مُعَادِلٌ':Added, #1: 1	غَيْرِ مُعَادَةٍ
u'غَيْرٌ مُعَادِلٌ':Added, #3: 3	غَيْرُ مُعَادِلٍ
u'غير مُعَارٌ':Added, #3: 3	غَيْرُ مُعَادِلٍ
u'غَيْرٌ مُعَارٌ':Added, #1: 1	غَيْرِ الْمُعَارِ
u'غير مُعارِضٌ':Added, #1: 1	غَيْرِ الْمُعَارِ
u'غَيْرٌ مُعارِضٌ':Added, #11: 11	غَيْرِ مُعَارِضٍ
u'غير مُعارِضٌ':Added, #11: 11	غَيْرِ مُعَارِضٍ
u'غير مُعارِضٌ':Added, #1: 1	غَيْرَ مُعَارِضٍ
u'غَيْرٌ مُعارِضٌ':Added, #1: 1	غَيْرُ مُعَارِضٍ
u'غَيْرٌ مُعارِضٌ':Added, #1: 1	غَيْرَ مُعَارِضٍ
u'غير مُعَارَضَةٌ':Added, #1: 1	غَيْرُ مُعَارِضٍ
u'غَيْرٌ مُعَارَضَةٌ':Added, #1: 1	غَيْرِ مُعَارَضَةِ
u'غير مُعَارَضَةٌ':Added, #1: 1	غَيْرِ مُعَارَضَةِ
u'غَيْرٌ مُعَارَضَةٌ':Added, #2: 2	غَيْرِ مُعَارَضَةٍ
u'غير مُعَاقَبٌ':Added, #2: 2	غَيْرِ مُعَارَضَةٍ
u'غَيْرٌ مُعَاقَبٌ':Added, #1: 1	غَيْرَ مُعَاقَبٍ
u'غير مُعَالَجٌ':Added, #1: 1	غَيْرَ مُعَاقَبٍ
u'غَيْرٌ مُعَالَجٌ':Added, #1: 1	غَيْرِ مُعَالَجَتِهِ
u'غير مُعَالَجٌ':Added, #1: 1	غَيْرِ مُعَالَجَتِهِ
u'غَيْرٌ مُعَالَجٌ':Added, #3: 3	غَيْرِ مُعَالَجَةٍ
u'غير مُعَالَجَةٌ':Added, #3: 3	غَيْرِ مُعَالَجَةٍ
u'غَيْرٌ مُعَالَجَةٌ':Added, #1: 1	غَيْرِ مُعَالَجَتِهِ
u'غير مُعَالَجَةٌ':Added, #1: 1	غَيْرِ مُعَالَجَتِهِ
u'غَيْرٌ مُعَالَجَةٌ':Added, #3: 3	غَيْرِ مُعَالَجَةٍ
u'غير مَعَالِمُ':Added, #3: 3	غَيْرِ مُعَالَجَةٍ
u'غَيْرٌ مَعَالِمُ':Added, #1: 1	غَيْرِ الْمَعَالِمِ
u'غير مُعاناة':Added, #1: 1	غَيْرِ الْمَعَالِمِ
u'غَيْرٌ مُعاناة':Added, #1: 1	غَيْرِ مُعَانَاةٍ
u'غير مُعَاوَدَةٌ':Added, #1: 1	غَيْرِ مُعَانَاةٍ
u'غَيْرٌ مُعَاوَدَةٌ':Added, #1: 1	غَيْرِ مُعَاوَدَةٍ
u'غير مُعَبِّرٌ':Added, #1: 1	غَيْرِ مُعَاوَدَةٍ
u'غَيْرٌ مُعَبِّرٌ':Added, #1: 1	غَيْرُ الْمُعَبِّرِ
u'غير مُعْتَادٌ':Added, #1: 1	غَيْرُ الْمُعَبِّرِ
u'غَيْرٌ مُعْتَادٌ':Added, #10: 10	غَيْرِ مُعْتَادٍ
u'غير مُعْتَادٌ':Added, #10: 10	غَيْرِ مُعْتَادٍ
u'غَيْرٌ مُعْتَادٌ':Added, #15: 15	غَيْرَ مُعْتَادٍ
u'غير مُعْتَادٌ':Added, #15: 15	غَيْرَ مُعْتَادٍ
u'غَيْرٌ مُعْتَادٌ':Added, #1: 1	غَيْرُ الْمُعْتَادَةِ
u'غير مُعْتَادٌ':Added, #1: 1	غَيْرُ الْمُعْتَادَةِ
u'غَيْرٌ مُعْتَادٌ':Added, #23: 23	غَيْرُ مُعْتَادٍ
u'غير مُعْتَادٌ':Added, #23: 23	غَيْرُ مُعْتَادٍ
u'غَيْرٌ مُعْتَادٌ':Added, #4: 4	غَيْرَ الْمُعْتَادِ
u'غير مُعْتَادٌ':Added, #4: 4	غَيْرَ الْمُعْتَادِ
u'غَيْرٌ مُعْتَادٌ':Added, #5: 5	غَيْرُ مُعْتَادَةٍ
u'غير مُعْتَادٌ':Added, #5: 5	غَيْرُ مُعْتَادَةٍ
u'غَيْرٌ مُعْتَادٌ':Added, #7: 7	غَيْرِ الْمُعْتَادِ
u'غير مُعْتَادٌ':Added, #7: 7	غَيْرِ الْمُعْتَادِ
u'غَيْرٌ مُعْتَادٌ':Added, #9: 9	غَيْرِ مُعْتَادَةٍ
u'غير مُعْتَبَرٌ':Added, #9: 9	غَيْرِ مُعْتَادَةٍ
u'غَيْرٌ مُعْتَبَرٌ':Added, #10: 10	غَيْرَ مُعْتَبَرٍ
u'غير مُعْتَبَرٌ':Added, #10: 10	غَيْرَ مُعْتَبَرٍ
u'غَيْرٌ مُعْتَبَرٌ':Added, #11: 11	غَيْرُ مُعْتَبَرِ
u'غير مُعْتَبَرٌ':Added, #11: 11	غَيْرُ مُعْتَبَرِ
u'غَيْرٌ مُعْتَبَرٌ':Added, #156: 156	غَيْرُ مُعْتَبَرٍ
u'غير مُعْتَبَرٌ':Added, #156: 156	غَيْرُ مُعْتَبَرٍ
u'غَيْرٌ مُعْتَبَرٌ':Added, #1: 1	غَيْرِ الْمُعْتَبَرَةِ
u'غير مُعْتَبَرٌ':Added, #1: 1	غَيْرِ الْمُعْتَبَرَةِ
u'غَيْرٌ مُعْتَبَرٌ':Added, #1: 1	غَيْرَ مُعْتَبَرِ
u'غير مُعْتَبَرٌ':Added, #1: 1	غَيْرَ مُعْتَبَرِ
u'غَيْرٌ مُعْتَبَرٌ':Added, #2: 2	غَيْرِ مُعْتَبَرٍ
u'غير مُعْتَبَرٌ':Added, #2: 2	غَيْرِ مُعْتَبَرٍ
u'غير مُعْتَبَرٌ':Added, #2: 2	غَيْرَ مُعْتَبَرَةٍ
u'غَيْرٌ مُعْتَبَرٌ':Added, #2: 2	غَيْرِ مُعْتَبَرَةٍ
u'غَيْرٌ مُعْتَبَرٌ':Added, #2: 2	غَيْرَ مُعْتَبَرَةٍ
u'غير مُعْتَبَرٌ':Added, #2: 2	غَيْرِ مُعْتَبَرَةٍ
u'غَيْرٌ مُعْتَبَرٌ':Added, #58: 58	غَيْرُ مُعْتَبَرَةٍ
u'غير مُعْتَبَرٌ':Added, #58: 58	غَيْرُ مُعْتَبَرَةٍ
u'غَيْرٌ مُعْتَبَرٌ':Added, #5: 5	غَيْرُ الْمُعْتَبَرِ
u'غير مُعْتَدٌّ':Added, #5: 5	غَيْرُ الْمُعْتَبَرِ
u'غَيْرٌ مُعْتَدٌّ':Added, #1: 1	غَيْرِ الْمُعْتَدَّةِ
u'غير مُعْتَدٌّ':Added, #1: 1	غَيْرِ الْمُعْتَدَّةِ
u'غَيْرٌ مُعْتَدٌّ':Added, #1: 1	غَيْرِ مُعْتَدٍّ
u'غير مُعْتَدٌّ':Added, #1: 1	غَيْرِ مُعْتَدٍّ
u'غَيْرٌ مُعْتَدٌّ':Added, #26: 26	غَيْرُ مُعْتَدٍّ
u'غير مُعْتَدٌّ':Added, #26: 26	غَيْرُ مُعْتَدٍّ
u'غَيْرٌ مُعْتَدٌّ':Added, #2: 2	غَيْرَ الْمُعْتَدَّةِ
u'غير مُعْتَدٌّ':Added, #2: 2	غَيْرَ الْمُعْتَدَّةِ
u'غَيْرٌ مُعْتَدٌّ':Added, #2: 2	غَيْرُ مُعْتَدَّةٍ
u'غير مُعْتَدٌّ':Added, #2: 2	غَيْرُ مُعْتَدَّةٍ
u'غَيْرٌ مُعْتَدٌّ':Added, #7: 7	غَيْرَ مُعْتَدٍّ
u'غير مُعْتَدِلٌ':Added, #7: 7	غَيْرَ مُعْتَدٍّ
u'غَيْرٌ مُعْتَدِلٌ':Added, #1: 1	غَيْرُ مُعْتَدِلٍ
u'غير مُعْتَدِلٌ':Added, #1: 1	غَيْرُ مُعْتَدِلٍ
u'غَيْرٌ مُعْتَدِلٌ':Added, #1: 1	غَيْرُ مُعْتَدِلَةٍ
u'غير مُعْتَرِضٌ':Added, #1: 1	غَيْرُ مُعْتَدِلَةٍ
u'غَيْرٌ مُعْتَرِضٌ':Added, #1: 1	غَيْرُ مُعْتَرِضٍ
u'غير مُعْتَرِفٌ':Added, #1: 1	غَيْرُ مُعْتَرِضٍ
u'غَيْرٌ مُعْتَرِفٌ':Added, #1: 1	غَيْرَ مُعْتَرِفٍ
u'غير مُعْتَرِفٌ':Added, #1: 1	غَيْرَ مُعْتَرِفٍ
u'غَيْرٌ مُعْتَرِفٌ':Added, #2: 2	غَيْرُ مُعْتَرِفٍ
u'غير مُعْتَرَكٌ':Added, #2: 2	غَيْرُ مُعْتَرِفٍ
u'غير مُعْتَرَكٌ':Added, #1: 1	غَيْرِ مُعْتَرَكٍ
u'غَيْرٌ مُعْتَرَكٌ':Added, #1: 1	غَيْرِ مُعْتَرَكِ
u'غَيْرٌ مُعْتَرَكٌ':Added, #1: 1	غَيْرِ مُعْتَرَكٍ
u'غير مُعْتَزِلٌ':Added, #1: 1	غَيْرِ مُعْتَرَكِ
u'غَيْرٌ مُعْتَزِلٌ':Added, #2: 2	غَيْرِ الْمُعْتَزِلَةِ
u'غير مُعْتَزِلَةٌ':Added, #2: 2	غَيْرِ الْمُعْتَزِلَةِ
u'غَيْرٌ مُعْتَزِلَةٌ':Added, #2: 2	غَيْرِ الْمُعْتَزِلَةِ
u'غير مُعْتَقٌ':Added, #2: 2	غَيْرِ الْمُعْتَزِلَةِ
u'غير مُعْتَقٌ':Added, #2: 2	غَيْرَ الْمُعْتَقِ
u'غير مُعْتَقٌ':Added, #2: 2	غَيْرُ الْمُعْتَقِ
u'غَيْرٌ مُعْتَقٌ':Added, #2: 2	غَيْرِ الْمُعْتَقِ
u'غَيْرٌ مُعْتَقٌ':Added, #2: 2	غَيْرَ الْمُعْتَقِ
u'غَيْرٌ مُعْتَقٌ':Added, #2: 2	غَيْرُ الْمُعْتَقِ
u'غير مُعْتَقِدٌ':Added, #2: 2	غَيْرِ الْمُعْتَقِ
u'غَيْرٌ مُعْتَقِدٌ':Added, #3: 3	غَيْرَ مُعْتَقِدٍ
u'غير مُعْتَقِدٌ':Added, #3: 3	غَيْرَ مُعْتَقِدٍ
u'غَيْرٌ مُعْتَقِدٌ':Added, #9: 9	غَيْرُ مُعْتَقِدٍ
u'غير مُعْتَمَدٌ':Added, #9: 9	غَيْرُ مُعْتَقِدٍ
u'غَيْرٌ مُعْتَمَدٌ':Added, #11: 11	غَيْرُ مُعْتَمَدٍ
u'غير مُعْتَمَدٌ':Added, #11: 11	غَيْرُ مُعْتَمَدٍ
u'غَيْرٌ مُعْتَمَدٌ':Added, #1: 1	غَيْرُ الْمُعْتَمَدِ
u'غير مُعْتَمَدٌ':Added, #1: 1	غَيْرُ الْمُعْتَمَدِ
u'غير مُعْتَمِدٌ':Added, #1: 1	غَيْرَ مُعْتَمَدٍ
u'غَيْرٌ مُعْتَمَدٌ':Added, #1: 1	غَيْرُ مُعْتَمِدٍ
u'غَيْرٌ مُعْتَمِدٌ':Added, #1: 1	غَيْرَ مُعْتَمَدٍ
u'غير مُعْتَمَدٌ':Added, #1: 1	غَيْرُ مُعْتَمِدٍ
u'غير مُعْتَمَدٌ':Added, #1: 1	غَيْرُ مُعْتَمَدَةٍ
u'غَيْرٌ مُعْتَمَدٌ':Added, #1: 1	غَيْرِ مُعْتَمَدَةٍ
u'غَيْرٌ مُعْتَمَدٌ':Added, #1: 1	غَيْرُ مُعْتَمَدَةٍ
u'غير مُعْتَمَدٌ':Added, #1: 1	غَيْرِ مُعْتَمَدَةٍ
u'غَيْرٌ مُعْتَمَدٌ':Added, #2: 2	غَيْرِ مُعْتَمَدٍ
u'غير مُعْتَمِرٌ':Added, #2: 2	غَيْرِ مُعْتَمَدٍ
u'غَيْرٌ مُعْتَمِرٌ':Added, #1: 1	غَيْرَ الْمُعْتَمِرِ
u'غير مُعْتَمِرٌ':Added, #1: 1	غَيْرَ الْمُعْتَمِرِ
u'غَيْرٌ مُعْتَمِرٌ':Added, #1: 1	غَيْرَ مُعْتَمِرٍ
u'غير مَعْتُوهٌ':Added, #1: 1	غَيْرَ مُعْتَمِرٍ
u'غَيْرٌ مَعْتُوهٌ':Added, #5: 5	غَيْرُ مَعْتُوهَةٍ
u'غير مُعْجَبٌ':Added, #5: 5	غَيْرُ مَعْتُوهَةٍ
u'غَيْرٌ مُعْجَبٌ':Added, #1: 1	غَيْرَ الْمُعْجَبِ
u'غير مُعْجَبٌ':Added, #1: 1	غَيْرَ الْمُعْجَبِ
u'غَيْرٌ مُعْجَبٌ':Added, #1: 1	غَيْرُ مُعْجَبٍ
u'غير مُعْجِزٌ':Added, #1: 1	غَيْرُ مُعْجَبٍ
u'غَيْرٌ مُعْجِزٌ':Added, #1: 1	غَيْرُ مُعْجِزٍ
u'غير مُعْجِزٌ':Added, #1: 1	غَيْرُ مُعْجِزٍ
u'غَيْرٌ مُعْجِزٌ':Added, #1: 1	غَيْرِ مُعْجِزَةٍ
u'غير مُعْجِزَةٌ':Added, #1: 1	غَيْرِ مُعْجِزَةٍ
u'غَيْرٌ مُعْجِزَةٌ':Added, #1: 1	غَيْرِ مُعْجِزَةٍ
u'غير مُعَجَّلٌ':Added, #1: 1	غَيْرِ مُعْجِزَةٍ
u'غير مُعَجَّلٌ':Added, #1: 1	غَيْرُ الْمُعَجَّلِ
u'غَيْرٌ مُعَجَّلٌ':Added, #1: 1	غَيْرِ الْمُعَجَّلِ
u'غَيْرٌ مُعَجَّلٌ':Added, #1: 1	غَيْرُ الْمُعَجَّلِ
u'غير مُعَجَّلٌ':Added, #1: 1	غَيْرِ الْمُعَجَّلِ
u'غير مُعَجِّلٌ':Added, #1: 1	غَيْرَ مُعَجَّلٍ
u'غَيْرٌ مُعَجَّلٌ':Added, #1: 1	غَيْرَ مُعَجِّلٍ
u'غَيْرٌ مُعَجِّلٌ':Added, #1: 1	غَيْرَ مُعَجَّلٍ
u'غير مُعَجَّلٌ':Added, #1: 1	غَيْرَ مُعَجِّلٍ
u'غَيْرٌ مُعَجَّلٌ':Added, #1: 1	غَيْرَ مُعَجَّلَةٍ
u'غير مُعْجَمٌ':Added, #1: 1	غَيْرَ مُعَجَّلَةٍ
u'غَيْرٌ مُعْجَمٌ':Added, #1: 1	غَيْرَ مُعْجَمِ
u'غير مُعْجَمَةٌ':Added, #1: 1	غَيْرَ مُعْجَمِ
u'غير مُعْجَمَةٌ':Added, #1: 1	غَيْرَ مُعْجَمَةٍ
u'غير مُعْجَمَةٌ':Added, #1: 1	غَيْرُ مُعْجَمَةٍ
u'غَيْرٌ مُعْجَمَةٌ':Added, #1: 1	غَيْرِ مُعْجَمَةٍ
u'غَيْرٌ مُعْجَمَةٌ':Added, #1: 1	غَيْرَ مُعْجَمَةٍ
u'غَيْرٌ مُعْجَمَةٌ':Added, #1: 1	غَيْرُ مُعْجَمَةٍ
u'غير مُعْجَمَةٌ':Added, #1: 1	غَيْرِ مُعْجَمَةٍ
u'غَيْرٌ مُعْجَمَةٌ':Added, #2: 2	غَيْرِ الْمُعْجَمَةِ
u'غير مُعَدٌّ':Added, #2: 2	غَيْرِ الْمُعْجَمَةِ
u'غَيْرٌ مُعَدٌّ':Added, #1: 1	غَيْرَ الْمُعَدِّ
u'غير مُعَدٌّ':Added, #1: 1	غَيْرَ الْمُعَدِّ
u'غير مُعَدٌّ':Added, #1: 1	غَيْرَ مُعَدٍّ
u'غَيْرٌ مُعَدٌّ':Added, #1: 1	غَيْرُ مُعَدٍّ
u'غَيْرٌ مُعَدٌّ':Added, #1: 1	غَيْرَ مُعَدٍّ
u'غير مُعَدٌّ':Added, #1: 1	غَيْرُ مُعَدٍّ
u'غَيْرٌ مُعَدٌّ':Added, #2: 2	غَيْرِ مُعَدٍّ
u'غير مُعَدٌّ':Added, #2: 2	غَيْرِ مُعَدٍّ
u'غَيْرٌ مُعَدٌّ':Added, #2: 2	غَيْرُ مُعَدَّةٍ
u'غير مَعْدِنٌ':Added, #2: 2	غَيْرُ مُعَدَّةٍ
u'غَيْرٌ مَعْدِنٌ':Added, #1: 1	غَيْرَ الْمَعْدِنِ
u'غير مَعْدِنٌ':Added, #1: 1	غَيْرَ الْمَعْدِنِ
u'غَيْرٌ مَعْدِنٌ':Added, #2: 2	غَيْرِ مَعْدِنِهِ
u'غير مَعْدِنٌ':Added, #2: 2	غَيْرِ مَعْدِنِهِ
u'غَيْرٌ مَعْدِنٌ':Added, #5: 5	غَيْرِ الْمَعْدِنِ
u'غير مَعْدُودٌ':Added, #5: 5	غَيْرِ الْمَعْدِنِ
u'غَيْرٌ مَعْدُودٌ':Added, #1: 1	غَيْرِ الْمَعْدُودِ
u'غير مَعْدُودٌ':Added, #1: 1	غَيْرِ الْمَعْدُودِ
u'غَيْرٌ مَعْدُودٌ':Added, #1: 1	غَيْرَ مَعْدُودٍ
u'غير مَعْدُودٌ':Added, #1: 1	غَيْرَ مَعْدُودٍ
u'غَيْرٌ مَعْدُودٌ':Added, #6: 6	غَيْرُ مَعْدُودٍ
u'غير مَعْدُول':Added, #6: 6	غَيْرُ مَعْدُودٍ
u'غَيْرٌ مَعْدُول':Added, #1: 1	غَيْرَ مَعْدُولَةٍ
u'غير مَعْدُول':Added, #1: 1	غَيْرَ مَعْدُولَةٍ
u'غَيْرٌ مَعْدُول':Added, #2: 2	غَيْرُ مَعْدُولٍ
u'غير مَعْدُومٌ':Added, #2: 2	غَيْرُ مَعْدُولٍ
u'غير مَعْدُومٌ':Added, #1: 1	غَيْرَ مَعْدُومٍ
u'غَيْرٌ مَعْدُومٌ':Added, #1: 1	غَيْرُ مَعْدُومٍ
u'غَيْرٌ مَعْدُومٌ':Added, #1: 1	غَيْرَ مَعْدُومٍ
u'غير مُعَذَّبٌ':Added, #1: 1	غَيْرُ مَعْدُومٍ
u'غَيْرٌ مُعَذَّبٌ':Added, #1: 1	غَيْرَ مُعَذَّبٍ
u'غير مَعْذُورٌ':Added, #1: 1	غَيْرَ مُعَذَّبٍ
u'غَيْرٌ مَعْذُورٌ':Added, #10: 10	غَيْرَ مَعْذُورٍ
u'غير مَعْذُورٌ':Added, #10: 10	غَيْرَ مَعْذُورٍ
u'غَيْرٌ مَعْذُورٌ':Added, #17: 17	غَيْرُ مَعْذُورٍ
u'غير مَعْذُورٌ':Added, #17: 17	غَيْرُ مَعْذُورٍ
u'غَيْرٌ مَعْذُورٌ':Added, #21: 21	غَيْرِ الْمَعْذُورِ
u'غير مَعْذُورٌ':Added, #21: 21	غَيْرِ الْمَعْذُورِ
u'غير مَعْذُورٌ':Added, #2: 2	غَيْرَ الْمَعْذُورِ
u'غَيْرٌ مَعْذُورٌ':Added, #2: 2	غَيْرُ الْمَعْذُورِ
u'غَيْرٌ مَعْذُورٌ':Added, #2: 2	غَيْرَ الْمَعْذُورِ
u'غير مَعْذُورٌ':Added, #2: 2	غَيْرُ الْمَعْذُورِ
u'غَيْرٌ مَعْذُورٌ':Added, #3: 3	غَيْرِ مَعْذُورٍ
u'غير مُعْرَبٌ':Added, #3: 3	غَيْرِ مَعْذُورٍ
u'غَيْرٌ مُعْرَبٌ':Added, #2: 2	غَيْرُ مُعْرَبٍ
u'غير مُعَرَّضٌ':Added, #2: 2	غَيْرُ مُعْرَبٍ
u'غير مُعَرَّضٌ':Added, #1: 1	غَيْرَ مُعَرَّضٍ
u'غَيْرٌ مُعَرَّضٌ':Added, #1: 1	غَيْرُ مُعَرَّضٍ
u'غَيْرٌ مُعَرَّضٌ':Added, #1: 1	غَيْرَ مُعَرَّضٍ
u'غير مُعَرَّفٌ':Added, #1: 1	غَيْرُ مُعَرَّضٍ
u'غَيْرٌ مُعَرَّفٌ':Added, #1: 1	غَيْرُ الْمُعَرَّفِ
u'غير مُعَرَّفٌ':Added, #1: 1	غَيْرُ الْمُعَرَّفِ
u'غَيْرٌ مُعَرَّفٌ':Added, #1: 1	غَيْرُ مُعَرَّفٍ
u'غير مَعْرِفَةٌ':Added, #1: 1	غَيْرُ مُعَرَّفٍ
u'غير مَعْرِفَة':Added, #1: 1	غَيْرَ مَعْرِفَةٍ
u'غَيْرٌ مَعْرِفَةٌ':Added, #1: 1	غَيْرَ مَعْرِفَةٍ
u'غَيْرٌ مَعْرِفَة':Added, #1: 1	غَيْرَ مَعْرِفَةٍ
u'غير مَعْرِفَةٌ':Added, #1: 1	غَيْرَ مَعْرِفَةٍ
u'غير مَعْرِفَةٌ':Added, #2: 2	غَيْرُ مَعْرِفَةِ
u'غير مَعْرِفَة':Added, #2: 2	غَيْرِ مَعْرِفَةِ
u'غير مَعْرِفَة':Added, #2: 2	غَيْرُ مَعْرِفَةِ
u'غَيْرٌ مَعْرِفَةٌ':Added, #2: 2	غَيْرِ مَعْرِفَةِ
u'غَيْرٌ مَعْرِفَةٌ':Added, #2: 2	غَيْرُ مَعْرِفَةِ
u'غَيْرٌ مَعْرِفَة':Added, #2: 2	غَيْرِ مَعْرِفَةِ
u'غَيْرٌ مَعْرِفَة':Added, #2: 2	غَيْرُ مَعْرِفَةِ
u'غير مَعْرِفَةٌ':Added, #2: 2	غَيْرِ مَعْرِفَةِ
u'غير مَعْرِفَة':Added, #9: 9	غَيْرِ مَعْرِفَةٍ
u'غَيْرٌ مَعْرِفَةٌ':Added, #9: 9	غَيْرِ مَعْرِفَةٍ
u'غَيْرٌ مَعْرِفَة':Added, #9: 9	غَيْرِ مَعْرِفَةٍ
u'غير مُعَرَّق':Added, #9: 9	غَيْرِ مَعْرِفَةٍ
u'غَيْرٌ مُعَرَّق':Added, #1: 1	غَيْرَ الْمُعَرَّقِ
u'غير مَعْرَكَةٌ':Added, #1: 1	غَيْرَ الْمُعَرَّقِ
u'غير مَعْرَكَةٌ':Added, #1: 1	غَيْرِ مَعْرَكَةٍ
u'غَيْرٌ مَعْرَكَةٌ':Added, #1: 1	غَيْرِ مَعْرَكَةِ
u'غَيْرٌ مَعْرَكَةٌ':Added, #1: 1	غَيْرِ مَعْرَكَةٍ
u'غير مَعْرُوفٌ':Added, #1: 1	غَيْرِ مَعْرَكَةِ
u'غير مَعْرُوفٌ':Added, #1: 1	غَيْرَ الْمَعْرُوفِ
u'غَيْرٌ مَعْرُوفٌ':Added, #1: 1	غَيْرُ الْمَعْرُوفِ
u'غَيْرٌ مَعْرُوفٌ':Added, #1: 1	غَيْرَ الْمَعْرُوفِ
u'غير مَعْرُوفٌ':Added, #1: 1	غَيْرُ الْمَعْرُوفِ
u'غَيْرٌ مَعْرُوفٌ':Added, #1: 1	غَيْرَ الْمَعْرُوفَةِ
u'غير مَعْرُوفٌ':Added, #1: 1	غَيْرَ الْمَعْرُوفَةِ
u'غير مَعْرُوفٌ':Added, #1: 1	غَيْرُ مَعْرُوفِ
u'غَيْرٌ مَعْرُوفٌ':Added, #1: 1	غَيْرِ مَعْرُوفِ
u'غَيْرٌ مَعْرُوفٌ':Added, #1: 1	غَيْرُ مَعْرُوفِ
u'غير مَعْرُوفٌ':Added, #1: 1	غَيْرِ مَعْرُوفِ
u'غير مَعْرُوفٌ':Added, #1: 1	غَيْرُ مَعْرُوفَةِ
u'غَيْرٌ مَعْرُوفٌ':Added, #1: 1	غَيْرِ مَعْرُوفَةٍ
u'غَيْرٌ مَعْرُوفٌ':Added, #1: 1	غَيْرُ مَعْرُوفَةِ
u'غير مَعْرُوفٌ':Added, #1: 1	غَيْرِ مَعْرُوفَةٍ
u'غَيْرٌ مَعْرُوفٌ':Added, #1: 1	غَيْرُ مَعْرُوفَتَيْنِ
u'غير مَعْرُوفٌ':Added, #1: 1	غَيْرُ مَعْرُوفَتَيْنِ
u'غَيْرٌ مَعْرُوفٌ':Added, #1: 1	غَيْرَ مَعْرُوفَيْنِ
u'غير مَعْرُوفٌ':Added, #1: 1	غَيْرَ مَعْرُوفَيْنِ
u'غَيْرٌ مَعْرُوفٌ':Added, #2: 2	غَيْرَ مَعْرُوفِ
u'غير مَعْرُوفٌ':Added, #2: 2	غَيْرَ مَعْرُوفِ
u'غَيْرٌ مَعْرُوفٌ':Added, #2: 2	غَيْرَ مَعْرُوفَةِ
u'غير مَعْرُوفٌ':Added, #2: 2	غَيْرَ مَعْرُوفَةِ
u'غَيْرٌ مَعْرُوفٌ':Added, #39: 39	غَيْرُ مَعْرُوفٍ
u'غير مَعْرُوفٌ':Added, #39: 39	غَيْرُ مَعْرُوفٍ
u'غَيْرٌ مَعْرُوفٌ':Added, #4: 4	غَيْرِ مَعْرُوفٍ
u'غير مَعْرُوفٌ':Added, #4: 4	غَيْرِ مَعْرُوفٍ
u'غَيْرٌ مَعْرُوفٌ':Added, #4: 4	غَيْرُ مَعْرُوفَةٍ
u'غير مَعْرُوفٌ':Added, #4: 4	غَيْرُ مَعْرُوفَةٍ
u'غَيْرٌ مَعْرُوفٌ':Added, #6: 6	غَيْرَ مَعْرُوفَةٍ
u'غير مَعْرُوفٌ':Added, #6: 6	غَيْرَ مَعْرُوفَةٍ
u'غَيْرٌ مَعْرُوفٌ':Added, #7: 7	غَيْرَ مَعْرُوفٍ
u'غير معز':Added, #7: 7	غَيْرَ مَعْرُوفٍ
u'غَيْرٌ معز':Added, #2: 2	غَيْرَ مُعْزٍ
u'غير مُعَزَّزٌ':Added, #2: 2	غَيْرَ مُعْزٍ
u'غَيْرٌ مُعَزَّزٌ':Added, #1: 1	غَيْرُ مُعَزَّزٍ
u'غير مَعْزُولٌ':Added, #1: 1	غَيْرُ مُعَزَّزٍ
u'غَيْرٌ مَعْزُولٌ':Added, #1: 1	غَيْرَ مَعْزُولٍ
u'غير مُعْسِرٌ':Added, #1: 1	غَيْرَ مَعْزُولٍ
u'غَيْرٌ مُعْسِرٌ':Added, #1: 1	غَيْرِ مُعْسِرٍ
u'غير مُعْسِرٌ':Added, #1: 1	غَيْرِ مُعْسِرٍ
u'غَيْرٌ مُعْسِرٌ':Added, #4: 4	غَيْرُ مُعْسِرٍ
u'غير مَعْصُومٌ':Added, #4: 4	غَيْرُ مُعْسِرٍ
u'غَيْرٌ مَعْصُومٌ':Added, #11: 11	غَيْرُ مَعْصُومٍ
u'غير مَعْصُومٌ':Added, #11: 11	غَيْرُ مَعْصُومٍ
u'غير مَعْصُومٌ':Added, #1: 1	غَيْرَ الْمَعْصُومِ
u'غير مَعْصُومٌ':Added, #1: 1	غَيْرُ الْمَعْصُومِ
u'غَيْرٌ مَعْصُومٌ':Added, #1: 1	غَيْرِ الْمَعْصُومِ
u'غَيْرٌ مَعْصُومٌ':Added, #1: 1	غَيْرَ الْمَعْصُومِ
u'غَيْرٌ مَعْصُومٌ':Added, #1: 1	غَيْرُ الْمَعْصُومِ
u'غير مَعْصُومٌ':Added, #1: 1	غَيْرِ الْمَعْصُومِ
u'غَيْرٌ مَعْصُومٌ':Added, #1: 1	غَيْرَ مَعْصُومِ
u'غير مَعْصُومٌ':Added, #1: 1	غَيْرَ مَعْصُومِ
u'غَيْرٌ مَعْصُومٌ':Added, #1: 1	غَيْرُ مَعْصُومَةٍ
u'غير مَعْصُومٌ':Added, #1: 1	غَيْرُ مَعْصُومَةٍ
u'غَيْرٌ مَعْصُومٌ':Added, #1: 1	غَيْرُ مَعْصُومَيْنِ
u'غير مَعْصُومٌ':Added, #1: 1	غَيْرُ مَعْصُومَيْنِ
u'غَيْرٌ مَعْصُومٌ':Added, #6: 6	غَيْرِ مَعْصُومٍ
u'غير مَعْصُومٌ':Added, #6: 6	غَيْرِ مَعْصُومٍ
u'غَيْرٌ مَعْصُومٌ':Added, #8: 8	غَيْرَ مَعْصُومٍ
u'غير مَعْصِيَةٌ':Added, #8: 8	غَيْرَ مَعْصُومٍ
u'غَيْرٌ مَعْصِيَةٌ':Added, #18: 18	غَيْرِ مَعْصِيَةٍ
u'غير مَعْصِيَةٌ':Added, #18: 18	غَيْرِ مَعْصِيَةٍ
u'غير مَعْصِيَةٌ':Added, #1: 1	غَيْرَ الْمَعْصِيَةِ
u'غَيْرٌ مَعْصِيَةٌ':Added, #1: 1	غَيْرُ الْمَعْصِيَةِ
u'غَيْرٌ مَعْصِيَةٌ':Added, #1: 1	غَيْرَ الْمَعْصِيَةِ
u'غير مَعْصِيَةٌ':Added, #1: 1	غَيْرُ الْمَعْصِيَةِ
u'غير مَعْصِيَةٌ':Added, #2: 2	غَيْرَ مَعْصِيَةٍ
u'غَيْرٌ مَعْصِيَةٌ':Added, #2: 2	غَيْرِ مَعْصِيَةِ
u'غَيْرٌ مَعْصِيَةٌ':Added, #2: 2	غَيْرَ مَعْصِيَةٍ
u'غير مَعْصِيَةٌ':Added, #2: 2	غَيْرِ مَعْصِيَةِ
u'غَيْرٌ مَعْصِيَةٌ':Added, #4: 4	غَيْرِ الْمَعْصِيَةِ
u'غير مُعْطاة':Added, #4: 4	غَيْرِ الْمَعْصِيَةِ
u'غَيْرٌ مُعْطاة':Added, #1: 1	غَيْرُ مُعْطَاةٍ
u'غير مَعْطُوف':Added, #1: 1	غَيْرُ مُعْطَاةٍ
u'غَيْرٌ مَعْطُوف':Added, #1: 1	غَيْرَ الْمَعْطُوفَةِ
u'غير مَعْطُوف':Added, #1: 1	غَيْرَ الْمَعْطُوفَةِ
u'غَيْرٌ مَعْطُوف':Added, #1: 1	غَيْرَ مَعْطُوفٍ
u'غير مَعْطُوف':Added, #1: 1	غَيْرَ مَعْطُوفٍ
u'غَيْرٌ مَعْطُوف':Added, #5: 5	غَيْرُ مَعْطُوفٍ
u'غير مَعْطُوف':Added, #5: 5	غَيْرُ مَعْطُوفٍ
u'غَيْرٌ مَعْطُوف':Added, #9: 9	غَيْرُ الْمَعْطُوفِ
u'غير مُعْظَمٌ':Added, #9: 9	غَيْرُ الْمَعْطُوفِ
u'غَيْرٌ مُعْظَمٌ':Added, #1: 1	غَيْرِ الْمُعْظَمِ
u'غير مَعْفُوٌّ':Added, #1: 1	غَيْرِ الْمُعْظَمِ
u'غَيْرٌ مَعْفُوٌّ':Added, #4: 4	غَيْرِ مَعْفُوٍّ
u'غير مَعْفُوٌّ':Added, #4: 4	غَيْرِ مَعْفُوٍّ
u'غير مَعْفُوٌّ':Added, #8: 8	غَيْرَ مَعْفُوٍّ
u'غَيْرٌ مَعْفُوٌّ':Added, #8: 8	غَيْرُ مَعْفُوٍّ
u'غَيْرٌ مَعْفُوٌّ':Added, #8: 8	غَيْرَ مَعْفُوٍّ
u'غير مُعَقَّبٌ':Added, #8: 8	غَيْرُ مَعْفُوٍّ
u'غَيْرٌ مُعَقَّبٌ':Added, #1: 1	غَيْرَ مُعَقَّبٍ
u'غير مَعْقُودٌ':Added, #1: 1	غَيْرَ مُعَقَّبٍ
u'غَيْرٌ مَعْقُودٌ':Added, #2: 2	غَيْرُ مَعْقُودَةٍ
u'غير مَعْقُودٌ':Added, #2: 2	غَيْرُ مَعْقُودَةٍ
u'غَيْرٌ مَعْقُودٌ':Added, #4: 4	غَيْرِ الْمَعْقُودِ
u'غير مَعْقُودٌ':Added, #4: 4	غَيْرِ الْمَعْقُودِ
u'غَيْرٌ مَعْقُودٌ':Added, #8: 8	غَيْرُ مَعْقُودٍ
u'غير مَعْقُولٌ':Added, #8: 8	غَيْرُ مَعْقُودٍ
u'غَيْرٌ مَعْقُولٌ':Added, #1: 1	غَيْرَ الْمَعْقُولِ
u'غير مَعْقُولٌ':Added, #1: 1	غَيْرَ الْمَعْقُولِ
u'غَيْرٌ مَعْقُولٌ':Added, #1: 1	غَيْرِ الْمَعْقُولَةِ
u'غير مَعْقُولٌ':Added, #1: 1	غَيْرِ الْمَعْقُولَةِ
u'غير مَعْقُولٌ':Added, #1: 1	غَيْرَ مَعْقُولَةٍ
u'غَيْرٌ مَعْقُولٌ':Added, #1: 1	غَيْرُ مَعْقُولَةِ
u'غَيْرٌ مَعْقُولٌ':Added, #1: 1	غَيْرَ مَعْقُولَةٍ
u'غير مَعْقُولٌ':Added, #1: 1	غَيْرُ مَعْقُولَةِ
u'غَيْرٌ مَعْقُولٌ':Added, #23: 23	غَيْرُ مَعْقُولٍ
u'غير مَعْقُولٌ':Added, #23: 23	غَيْرُ مَعْقُولٍ
u'غَيْرٌ مَعْقُولٌ':Added, #2: 2	غَيْرِ الْمَعْقُولِ
u'غير مَعْقُولٌ':Added, #2: 2	غَيْرِ الْمَعْقُولِ
u'غير مَعْقُولٌ':Added, #2: 2	غَيْرَ مَعْقُولِ
u'غَيْرٌ مَعْقُولٌ':Added, #2: 2	غَيْرِ مَعْقُولِ
u'غَيْرٌ مَعْقُولٌ':Added, #2: 2	غَيْرَ مَعْقُولِ
u'غير مَعْقُولٌ':Added, #2: 2	غَيْرِ مَعْقُولِ
u'غَيْرٌ مَعْقُولٌ':Added, #5: 5	غَيْرِ مَعْقُولٍ
u'غير مَعْقُولٌ':Added, #5: 5	غَيْرِ مَعْقُولٍ
u'غَيْرٌ مَعْقُولٌ':Added, #7: 7	غَيْرُ مَعْقُولَةٍ
u'غير مَعْقُولٌ':Added, #7: 7	غَيْرُ مَعْقُولَةٍ
u'غَيْرٌ مَعْقُولٌ':Added, #9: 9	غَيْرُ مَعْقُولِ
u'غير مُعَلَّقٌ':Added, #9: 9	غَيْرُ مَعْقُولِ
u'غَيْرٌ مُعَلَّقٌ':Added, #1: 1	غَيْرُ الْمُعَلَّقِ
u'غير مُعَلَّقٌ':Added, #1: 1	غَيْرُ الْمُعَلَّقِ
u'غير مُعَلَّقٌ':Added, #1: 1	غَيْرَ مُعَلَّقَةٍ
u'غَيْرٌ مُعَلَّقٌ':Added, #1: 1	غَيْرُ مُعَلَّقَةٍ
u'غَيْرٌ مُعَلَّقٌ':Added, #1: 1	غَيْرَ مُعَلَّقَةٍ
u'غير مُعَلَّقٌ':Added, #1: 1	غَيْرُ مُعَلَّقَةٍ
u'غَيْرٌ مُعَلَّقٌ':Added, #2: 2	غَيْرِ الْمُعَلَّقِ
u'غير مُعَلَّقٌ':Added, #2: 2	غَيْرِ الْمُعَلَّقِ
u'غَيْرٌ مُعَلَّقٌ':Added, #2: 2	غَيْرِ مُعَلَّقٍ
u'غير مُعَلَّقٌ':Added, #2: 2	غَيْرِ مُعَلَّقٍ
u'غَيْرٌ مُعَلَّقٌ':Added, #5: 5	غَيْرُ مُعَلَّقٍ
u'غير مُعَلَّقٌ':Added, #5: 5	غَيْرُ مُعَلَّقٍ
u'غَيْرٌ مُعَلَّقٌ':Added, #9: 9	غَيْرَ مُعَلَّقٍ
u'غير مُعَلَّلٌ':Added, #9: 9	غَيْرَ مُعَلَّقٍ
u'غَيْرٌ مُعَلَّلٌ':Added, #1: 1	غَيْرِ الْمُعَلَّلِ
u'غير مُعَلَّلٌ':Added, #1: 1	غَيْرِ الْمُعَلَّلِ
u'غَيْرٌ مُعَلَّلٌ':Added, #2: 2	غَيْرُ مُعَلَّلٍ
u'غير مُعَلَّلٌ':Added, #2: 2	غَيْرُ مُعَلَّلٍ
u'غَيْرٌ مُعَلَّلٌ':Added, #2: 2	غَيْرُ مُعَلَّلَةٍ
u'غير مُعَلَّلٌ':Added, #2: 2	غَيْرُ مُعَلَّلَةٍ
u'غَيْرٌ مُعَلَّلٌ':Added, #3: 3	غَيْرَ مُعَلَّلٍ
u'غير مُعَلَّلٌ':Added, #3: 3	غَيْرَ مُعَلَّلٍ
u'غَيْرٌ مُعَلَّلٌ':Added, #3: 3	غَيْرَ مُعَلَّلَةٍ
u'غير مُعَلَّمٌ':Added, #3: 3	غَيْرَ مُعَلَّلَةٍ
u'غَيْرٌ مُعَلَّمٌ':Added, #12: 12	غَيْرُ مُعَلَّمٍ
u'غير مُعَلَّمٌ':Added, #12: 12	غَيْرُ مُعَلَّمٍ
u'غير مُعَلِّمٌ':Added, #1: 1	غَيْرُ الْمُعَلَّمِ
u'غَيْرٌ مُعَلَّمٌ':Added, #1: 1	غَيْرُ الْمُعَلِّمِ
u'غَيْرٌ مُعَلِّمٌ':Added, #1: 1	غَيْرُ الْمُعَلَّمِ
u'غير مُعَلَّمٌ':Added, #1: 1	غَيْرُ الْمُعَلِّمِ
u'غير مُعَلِّمٌ':Added, #1: 1	غَيْرُ مُعَلّمٍ
u'غَيْرٌ مُعَلَّمٌ':Added, #1: 1	غَيْرُ مُعَلّمٍ
u'غَيْرٌ مُعَلِّمٌ':Added, #1: 1	غَيْرُ مُعَلّمٍ
u'غير مُعَلَّمٌ':Added, #1: 1	غَيْرُ مُعَلّمٍ
u'غَيْرٌ مُعَلَّمٌ':Added, #3: 3	غَيْرَ الْمُعَلَّمِ
u'غير مُعَلَّمٌ':Added, #3: 3	غَيْرَ الْمُعَلَّمِ
u'غَيْرٌ مُعَلَّمٌ':Added, #4: 4	غَيْرِ الْمُعَلَّمِ
u'غير مُعَلَّمٌ':Added, #4: 4	غَيْرِ الْمُعَلَّمِ
u'غَيْرٌ مُعَلَّمٌ':Added, #4: 4	غَيْرِ مُعَلَّمٍ
u'غير مُعَلَّمٌ':Added, #4: 4	غَيْرِ مُعَلَّمٍ
u'غَيْرٌ مُعَلَّمٌ':Added, #7: 7	غَيْرَ مُعَلَّمٍ
u'غير مَعْلُوفٌ':Added, #7: 7	غَيْرَ مُعَلَّمٍ
u'غَيْرٌ مَعْلُوفٌ':Added, #1: 1	غَيْرِ الْمَعْلُوفَةِ
u'غير مَعْلُولٌ':Added, #1: 1	غَيْرِ الْمَعْلُوفَةِ
u'غَيْرٌ مَعْلُولٌ':Added, #1: 1	غَيْرُ الْمَعْلُولِ
u'غير مَعْلُولٌ':Added, #1: 1	غَيْرُ الْمَعْلُولِ
u'غَيْرٌ مَعْلُولٌ':Added, #6: 6	غَيْرُ مَعْلُولٍ
u'غير مَعْلُومٌ':Added, #6: 6	غَيْرُ مَعْلُولٍ
u'غَيْرٌ مَعْلُومٌ':Added, #12: 12	غَيْرَ مَعْلُومٍ
u'غير مَعْلُومٌ':Added, #12: 12	غَيْرَ مَعْلُومٍ
u'غَيْرٌ مَعْلُومٌ':Added, #1: 1	غَيْرَ مَعْلُومَةِ
u'غير مَعْلُومٌ':Added, #1: 1	غَيْرَ مَعْلُومَةِ
u'غَيْرٌ مَعْلُومٌ':Added, #1: 1	غَيْرَ مَعْلُومَيْنِ
u'غير مَعْلُومٌ':Added, #1: 1	غَيْرَ مَعْلُومَيْنِ
u'غَيْرٌ مَعْلُومٌ':Added, #23: 23	غَيْرُ مَعْلُومَةٍ
u'غير مَعْلُومٌ':Added, #23: 23	غَيْرُ مَعْلُومَةٍ
u'غَيْرٌ مَعْلُومٌ':Added, #2: 2	غَيْرِ الْمَعْلُومِ
u'غير مَعْلُومٌ':Added, #2: 2	غَيْرِ الْمَعْلُومِ
u'غَيْرٌ مَعْلُومٌ':Added, #2: 2	غَيْرَ مَعْلُومِ
u'غير مَعْلُومٌ':Added, #2: 2	غَيْرَ مَعْلُومِ
u'غَيْرٌ مَعْلُومٌ':Added, #2: 2	غَيْرِ مَعْلُومَةٍ
u'غير مَعْلُومٌ':Added, #2: 2	غَيْرِ مَعْلُومَةٍ
u'غَيْرٌ مَعْلُومٌ':Added, #3: 3	غَيْرِ مَعْلُومَةِ
u'غير مَعْلُومٌ':Added, #3: 3	غَيْرِ مَعْلُومَةِ
u'غَيْرٌ مَعْلُومٌ':Added, #4: 4	غَيْرِ مَعْلُومِ
u'غير مَعْلُومٌ':Added, #4: 4	غَيْرِ مَعْلُومِ
u'غير مَعْلُومٌ':Added, #6: 6	غَيْرُ مَعْلُومِ
u'غَيْرٌ مَعْلُومٌ':Added, #6: 6	غَيْرِ مَعْلُومٍ
u'غَيْرٌ مَعْلُومٌ':Added, #6: 6	غَيْرُ مَعْلُومِ
u'غير مَعْلُومٌ':Added, #6: 6	غَيْرِ مَعْلُومٍ
u'غَيْرٌ مَعْلُومٌ':Added, #6: 6	غَيْرَ مَعْلُومَةٍ
u'غير مَعْلُومٌ':Added, #6: 6	غَيْرَ مَعْلُومَةٍ
u'غَيْرٌ مَعْلُومٌ':Added, #93: 93	غَيْرُ مَعْلُومٍ
u'غير مَعْمَعَةٌ':Added, #93: 93	غَيْرُ مَعْلُومٍ
u'غَيْرٌ مَعْمَعَةٌ':Added, #1: 1	غَيْرِ مَعْمَعَةِ
u'غير مَعْمُولٌ':Added, #1: 1	غَيْرِ مَعْمَعَةِ
u'غَيْرٌ مَعْمُولٌ':Added, #15: 15	غَيْرُ مَعْمُولٍ
u'غير مَعْمُولٌ':Added, #15: 15	غَيْرُ مَعْمُولٍ
u'غَيْرٌ مَعْمُولٌ':Added, #19: 19	غَيْرَ مَعْمُولٍ
u'غير مَعْمُولٌ':Added, #19: 19	غَيْرَ مَعْمُولٍ
u'غَيْرٌ مَعْمُولٌ':Added, #1: 1	غَيْرِ الْمَعْمُولِ
u'غير مَعْمُولٌ':Added, #1: 1	غَيْرِ الْمَعْمُولِ
u'غَيْرٌ مَعْمُولٌ':Added, #1: 1	غَيْرِ مَعْمُولِهِ
u'غير مَعْمُولٌ':Added, #1: 1	غَيْرِ مَعْمُولِهِ
u'غَيْرٌ مَعْمُولٌ':Added, #2: 2	غَيْرَ الْمَعْمُولِ
u'غير مَعْمُولٌ':Added, #2: 2	غَيْرَ الْمَعْمُولِ
u'غَيْرٌ مَعْمُولٌ':Added, #2: 2	غَيْرَ مَعْمُولَةٍ
u'غير مُعَنِّفٌ':Added, #2: 2	غَيْرَ مَعْمُولَةٍ
u'غَيْرٌ مُعَنِّفٌ':Added, #2: 2	غَيْرَ مُعَنِّفٍ
u'غير مَعْهُودٌ':Added, #2: 2	غَيْرَ مُعَنِّفٍ
u'غَيْرٌ مَعْهُودٌ':Added, #1: 1	غَيْرِ الْمَعْهُودِ
u'غير مَعْهُودٌ':Added, #1: 1	غَيْرِ الْمَعْهُودِ
u'غير مَعْهُودٌ':Added, #1: 1	غَيْرَ مَعْهُودٍ
u'غَيْرٌ مَعْهُودٌ':Added, #1: 1	غَيْرِ مَعْهُودٍ
u'غَيْرٌ مَعْهُودٌ':Added, #1: 1	غَيْرَ مَعْهُودٍ
u'غير مَعْهُودٌ':Added, #1: 1	غَيْرِ مَعْهُودٍ
u'غَيْرٌ مَعْهُودٌ':Added, #2: 2	غَيْرِ مَعْهُودَةٍ
u'غير مَعْهُودٌ':Added, #2: 2	غَيْرِ مَعْهُودَةٍ
u'غَيْرٌ مَعْهُودٌ':Added, #8: 8	غَيْرُ مَعْهُودٍ
u'غير مُعَوَّلٌ':Added, #8: 8	غَيْرُ مَعْهُودٍ
u'غير مُعَوَّلٌ':Added, #1: 1	غَيْرَ مُعَوّلٍ
u'غَيْرٌ مُعَوَّلٌ':Added, #1: 1	غَيْرِ مُعَوَّلٍ
u'غَيْرٌ مُعَوَّلٌ':Added, #1: 1	غَيْرَ مُعَوّلٍ
u'غير مُعَوَّلٌ':Added, #1: 1	غَيْرِ مُعَوَّلٍ
u'غَيْرٌ مُعَوَّلٌ':Added, #5: 5	غَيْرُ مُعَوَّلٍ
u'غير مَعِيبٌ':Added, #5: 5	غَيْرُ مُعَوَّلٍ
u'غير مَعِيبٌ':Added, #1: 1	غَيْرَ الْمَعِيبِ
u'غَيْرٌ مَعِيبٌ':Added, #1: 1	غَيْرُ الْمَعِيبِ
u'غَيْرٌ مَعِيبٌ':Added, #1: 1	غَيْرَ الْمَعِيبِ
u'غير مَعِيبٌ':Added, #1: 1	غَيْرُ الْمَعِيبِ
u'غَيْرٌ مَعِيبٌ':Added, #1: 1	غَيْرَ مَعِيبِ
u'غير مَعِيبٌ':Added, #1: 1	غَيْرَ مَعِيبِ
u'غَيْرٌ مَعِيبٌ':Added, #2: 2	غَيْرِ الْمَعِيبِ
u'غير مَعِيبٌ':Added, #2: 2	غَيْرِ الْمَعِيبِ
u'غَيْرٌ مَعِيبٌ':Added, #9: 9	غَيْرَ مَعِيبٍ
u'غير مُعِيدٌ':Added, #9: 9	غَيْرَ مَعِيبٍ
u'غَيْرٌ مُعِيدٌ':Added, #2: 2	غَيْرَ مُعِيدٍ
u'غير مُعَيَّنٌ':Added, #2: 2	غَيْرَ مُعِيدٍ
u'غَيْرٌ مُعَيَّنٌ':Added, #10: 10	غَيْرُ مُعَيَّنَةٍ
u'غير مُعَيَّنٌ':Added, #10: 10	غَيْرُ مُعَيَّنَةٍ
u'غَيْرٌ مُعَيَّنٌ':Added, #18: 18	غَيْرُ الْمُعَيَّنِ
u'غير مَعِينٌ':Added, #18: 18	غَيْرُ الْمُعَيَّنِ
u'غَيْرٌ مَعِينٌ':Added, #1: 1	غَيْرِ الْمَعِينِ
u'غير مُعَيَّنٌ':Added, #1: 1	غَيْرِ الْمَعِينِ
u'غير مُعَيَّنٌ':Added, #1: 1	غَيْرَ الْمُعَيَّنَةِ
u'غَيْرٌ مُعَيَّنٌ':Added, #1: 1	غَيْرُ الْمُعَيَّنَةِ
u'غَيْرٌ مُعَيَّنٌ':Added, #1: 1	غَيْرَ الْمُعَيَّنَةِ
u'غير مُعَيَّنٌ':Added, #1: 1	غَيْرُ الْمُعَيَّنَةِ
u'غَيْرٌ مُعَيَّنٌ':Added, #1: 1	غَيْرُ الْمُعَيَّنَيْنِ
u'غير مَعِينٌ':Added, #1: 1	غَيْرُ الْمُعَيَّنَيْنِ
u'غير مُعِينٌ':Added, #1: 1	غَيْرَ مَعِينٍ
u'غَيْرٌ مَعِينٌ':Added, #1: 1	غَيْرُ مُعِينٍ
u'غَيْرٌ مُعِينٌ':Added, #1: 1	غَيْرَ مَعِينٍ
u'غير مُعَيَّنٌ':Added, #1: 1	غَيْرُ مُعِينٍ
u'غَيْرٌ مُعَيَّنٌ':Added, #1: 1	غَيْرُ مُعَيَّنَاتٍ
u'غير مُعَيَّنٌ':Added, #1: 1	غَيْرُ مُعَيَّنَاتٍ
u'غير مُعَيَّنٌ':Added, #1: 1	غَيْرَ مُعَيَّنَةِ
u'غَيْرٌ مُعَيَّنٌ':Added, #1: 1	غَيْرُ مُعَيَّنَةِ
u'غَيْرٌ مُعَيَّنٌ':Added, #1: 1	غَيْرَ مُعَيَّنَةِ
u'غير مُعَيَّنٌ':Added, #1: 1	غَيْرُ مُعَيَّنَةِ
u'غَيْرٌ مُعَيَّنٌ':Added, #23: 23	غَيْرِ مُعَيَّنَةٍ
u'غير مُعَيَّنٌ':Added, #23: 23	غَيْرِ مُعَيَّنَةٍ
u'غَيْرٌ مُعَيَّنٌ':Added, #24: 24	غَيْرَ مُعَيَّنَةٍ
u'غير مُعَيَّنٌ':Added, #24: 24	غَيْرَ مُعَيَّنَةٍ
u'غَيْرٌ مُعَيَّنٌ':Added, #2: 2	غَيْرَ الْمُعَيَّنِ
u'غير مُعِينٌ':Added, #2: 2	غَيْرَ الْمُعَيَّنِ
u'غَيْرٌ مُعِينٌ':Added, #2: 2	غَيْرَ مُعِينٍ
u'غير مُعَيَّنٌ':Added, #2: 2	غَيْرَ مُعِينٍ
u'غَيْرٌ مُعَيَّنٌ':Added, #2: 2	غَيْرِ مُعَيَّنَاتٍ
u'غير مُعَيَّنٌ':Added, #2: 2	غَيْرِ مُعَيَّنَاتٍ
u'غَيْرٌ مُعَيَّنٌ':Added, #3: 3	غَيْرَ مُعَيَّنَيْنِ
u'غير مُعَيَّنٌ':Added, #3: 3	غَيْرَ مُعَيَّنَيْنِ
u'غَيْرٌ مُعَيَّنٌ':Added, #46: 46	غَيْرُ مُعَيَّنٍ
u'غير مُعَيَّنٌ':Added, #46: 46	غَيْرُ مُعَيَّنٍ
u'غَيْرٌ مُعَيَّنٌ':Added, #50: 50	غَيْرِ الْمُعَيَّنِ
u'غير مُعِينٌ':Added, #50: 50	غَيْرِ الْمُعَيَّنِ
u'غَيْرٌ مُعِينٌ':Added, #5: 5	غَيْرِ مُعِينٍ
u'غير مُعَيَّنٌ':Added, #5: 5	غَيْرِ مُعِينٍ
u'غَيْرٌ مُعَيَّنٌ':Added, #64: 64	غَيْرَ مُعَيَّنٍ
u'غير مُعَيَّنٌ':Added, #64: 64	غَيْرَ مُعَيَّنٍ
u'غَيْرٌ مُعَيَّنٌ':Added, #79: 79	غَيْرِ مُعَيَّنٍ
u'غير مُعَيَّنٌ':Added, #79: 79	غَيْرِ مُعَيَّنٍ
u'غَيْرٌ مُعَيَّنٌ':Added, #8: 8	غَيْرِ الْمُعَيَّنَةِ
u'غير مُغالِي':Added, #8: 8	غَيْرِ الْمُعَيَّنَةِ
u'غَيْرٌ مُغالِي':Added, #1: 1	غَيْرَ الْمُغَالِيَةِ
u'غير مُغالِي':Added, #1: 1	غَيْرَ الْمُغَالِيَةِ
u'غَيْرٌ مُغالِي':Added, #1: 1	غَيْرَ مُغَالِيَةٍ
u'غير مَغْرِبٌ':Added, #1: 1	غَيْرَ مُغَالِيَةٍ
u'غَيْرٌ مَغْرِبٌ':Added, #1: 1	غَيْرَ الْمَغْرِبِ
u'غير مَغْرِبٌ':Added, #1: 1	غَيْرَ الْمَغْرِبِ
u'غَيْرٌ مَغْرِبٌ':Added, #1: 1	غَيْرَ مَغْرِبٍ
u'غير مَغْرِبٌ':Added, #1: 1	غَيْرَ مَغْرِبٍ
u'غَيْرٌ مَغْرِبٌ':Added, #4: 4	غَيْرِ الْمَغْرِبِ
u'غير مُغْرِق':Added, #4: 4	غَيْرِ الْمَغْرِبِ
u'غَيْرٌ مُغْرِق':Added, #1: 1	غَيْرُ الْمُغْرِقِ
u'غير مُغْرِق':Added, #1: 1	غَيْرُ الْمُغْرِقِ
u'غَيْرٌ مُغْرِق':Added, #1: 1	غَيْرُ مُغْرِقٍ
u'غير مَغْرُورٌ':Added, #1: 1	غَيْرُ مُغْرِقٍ
u'غَيْرٌ مَغْرُورٌ':Added, #1: 1	غَيْرِ مَغْرُورٍ
u'غير مَغْرُورٌ':Added, #1: 1	غَيْرِ مَغْرُورٍ
u'غَيْرٌ مَغْرُورٌ':Added, #3: 3	غَيْرُ مَغْرُورٍ
u'غير مَغْسُولٌ':Added, #3: 3	غَيْرُ مَغْرُورٍ
u'غَيْرٌ مَغْسُولٌ':Added, #1: 1	غَيْرَ الْمَغْسُولِ
u'غير مَغْسُولٌ':Added, #1: 1	غَيْرَ الْمَغْسُولِ
u'غَيْرٌ مَغْسُولٌ':Added, #1: 1	غَيْرَ مَغْسُولَةٍ
u'غير مَغْسُولٌ':Added, #1: 1	غَيْرَ مَغْسُولَةٍ
u'غَيْرٌ مَغْسُولٌ':Added, #2: 2	غَيْرِ الْمَغْسُولِ
u'غير مَغْشُوشٌ':Added, #2: 2	غَيْرِ الْمَغْسُولِ
u'غَيْرٌ مَغْشُوشٌ':Added, #2: 2	غَيْرَ مَغْشُوشَةٍ
u'غير مَغْصُوب':Added, #2: 2	غَيْرَ مَغْشُوشَةٍ
u'غَيْرٌ مَغْصُوب':Added, #1: 1	غَيْرِ الْمَغْصُوبِ
u'غير مَغْصُوب':Added, #1: 1	غَيْرِ الْمَغْصُوبِ
u'غَيْرٌ مَغْصُوب':Added, #1: 1	غَيْرِ الْمَغْصُوبَةِ
u'غير مَغْصُوب':Added, #1: 1	غَيْرِ الْمَغْصُوبَةِ
u'غَيْرٌ مَغْصُوب':Added, #1: 1	غَيْرَ مَغْصُوبَةٍ
u'غير مَغْصُوب':Added, #1: 1	غَيْرَ مَغْصُوبَةٍ
u'غَيْرٌ مَغْصُوب':Added, #5: 5	غَيْرَ الْمَغْصُوبِ
u'غير مَغْضُوبٌ':Added, #5: 5	غَيْرَ الْمَغْصُوبِ
u'غَيْرٌ مَغْضُوبٌ':Added, #30: 30	غَيْرِ الْمَغْضُوبِ
u'غير مَغْفُورٌ':Added, #30: 30	غَيْرِ الْمَغْضُوبِ
u'غَيْرٌ مَغْفُورٌ':Added, #1: 1	غَيْرُ مَغْفُورٍ
u'غير مَغْفُورٌ':Added, #1: 1	غَيْرُ مَغْفُورٍ
u'غَيْرٌ مَغْفُورٌ':Added, #2: 2	غَيْرَ مَغْفُورٍ
u'غير مُغِلّ':Added, #2: 2	غَيْرَ مَغْفُورٍ
u'غَيْرٌ مُغِلّ':Added, #10: 10	غَيْرِ الْمُغِلِّ
u'غير مُغَلَّظ':Added, #10: 10	غَيْرِ الْمُغِلِّ
u'غير مُغَلَّظ':Added, #1: 1	غَيْرَ مُغَلَّظٍ
u'غَيْرٌ مُغَلَّظ':Added, #1: 1	غَيْرِ مُغَلَّظٍ
u'غَيْرٌ مُغَلَّظ':Added, #1: 1	غَيْرَ مُغَلَّظٍ
u'غير مُغْلَقٌ':Added, #1: 1	غَيْرِ مُغَلَّظٍ
u'غَيْرٌ مُغْلَقٌ':Added, #4: 4	غَيْرَ مُغْلَقٍ
u'غير مَغْلُوبٌ':Added, #4: 4	غَيْرَ مُغْلَقٍ
u'غَيْرٌ مَغْلُوبٌ':Added, #1: 1	غَيْرُ الْمَغْلُوبِ
u'غير مَغْلُوبٌ':Added, #1: 1	غَيْرُ الْمَغْلُوبِ
u'غَيْرٌ مَغْلُوبٌ':Added, #1: 1	غَيْرَ مَغْلُوبٍ
u'غير مَغْلُوبٌ':Added, #1: 1	غَيْرَ مَغْلُوبٍ
u'غَيْرٌ مَغْلُوبٌ':Added, #2: 2	غَيْرُ مَغْلُوبٍ
u'غير مَغْمُودٌ':Added, #2: 2	غَيْرُ مَغْلُوبٍ
u'غَيْرٌ مَغْمُودٌ':Added, #1: 1	غَيْرَ مَغْمُودٍ
u'غير مَغْمِيّ':Added, #1: 1	غَيْرَ مَغْمُودٍ
u'غَيْرٌ مَغْمِيّ':Added, #1: 1	غَيْرُ مَغْمِيَّةٍ
u'غير مُغَنِّي':Added, #1: 1	غَيْرُ مَغْمِيَّةٍ
u'غير مُغْنِي':Added, #1: 1	غَيْرَ مُغَنِّيَةٍ
u'غَيْرٌ مُغَنِّي':Added, #1: 1	غَيْرَ مُغْنِيَةٍ
u'غَيْرٌ مُغْنِي':Added, #1: 1	غَيْرَ مُغَنِّيَةٍ
u'غير مُغَنِّي':Added, #1: 1	غَيْرَ مُغْنِيَةٍ
u'غَيْرٌ مُغَنِّي':Added, #2: 2	غَيْرُ مُغَنِّيَةٍ
u'غير مُغَيِّرٌ':Added, #2: 2	غَيْرُ مُغَنِّيَةٍ
u'غَيْرٌ مُغَيِّرٌ':Added, #1: 1	غَيْرِ مُغَيِّرٍ
u'غير مُفَارِقٌ':Added, #1: 1	غَيْرِ مُغَيِّرٍ
u'غَيْرٌ مُفَارِقٌ':Added, #1: 1	غَيْرِ مُفَارِقَةٍ
u'غير مُفَارِقٌ':Added, #1: 1	غَيْرِ مُفَارِقَةٍ
u'غَيْرٌ مُفَارِقٌ':Added, #2: 2	غَيْرُ مُفَارِقٍ
u'غير مَفَاصِلُ':Added, #2: 2	غَيْرُ مُفَارِقٍ
u'غَيْرٌ مَفَاصِلُ':Added, #1: 1	غَيْرِ الْمَفَاصِلِ
u'غير مُفَاوِضٌ':Added, #1: 1	غَيْرِ الْمَفَاصِلِ
u'غَيْرٌ مُفَاوِضٌ':Added, #1: 1	غَيْرِ الْمُفَاوِضِ
u'غير مُفَاوِضٌ':Added, #1: 1	غَيْرِ الْمُفَاوِضِ
u'غَيْرٌ مُفَاوِضٌ':Added, #1: 1	غَيْرُ مُفَاوِضٍ
u'غير مُفَاوِضٌ':Added, #1: 1	غَيْرُ مُفَاوِضٍ
u'غَيْرٌ مُفَاوِضٌ':Added, #2: 2	غَيْرِ مُفَاوِضٍ
u'غير مُفَاوَضَةٌ':Added, #2: 2	غَيْرِ مُفَاوِضٍ
u'غَيْرٌ مُفَاوَضَةٌ':Added, #1: 1	غَيْرُ الْمُفَاوَضَةِ
u'غير مُفَاوَضَةٌ':Added, #1: 1	غَيْرُ الْمُفَاوَضَةِ
u'غير مُفَاوَضَةٌ':Added, #1: 1	غَيْرَ مُفَاوَضَةٍ
u'غَيْرٌ مُفَاوَضَةٌ':Added, #1: 1	غَيْرِ مُفَاوَضَةٍ
u'غَيْرٌ مُفَاوَضَةٌ':Added, #1: 1	غَيْرَ مُفَاوَضَةٍ
u'غير مُفْتَرِسٌ':Added, #1: 1	غَيْرِ مُفَاوَضَةٍ
u'غَيْرٌ مُفْتَرِسٌ':Added, #1: 1	غَيْرُ مُفْتَرِسِ
u'غير مُفْتَرِشٌ':Added, #1: 1	غَيْرُ مُفْتَرِسِ
u'غَيْرٌ مُفْتَرِشٌ':Added, #4: 4	غَيْرَ مُفْتَرِشٍ
u'غير مُفْتَرَضٌ':Added, #4: 4	غَيْرَ مُفْتَرِشٍ
u'غَيْرٌ مُفْتَرَضٌ':Added, #1: 1	غَيْرِ مُفْتَرَضِ
u'غير مُفْتَقِرٌ':Added, #1: 1	غَيْرِ مُفْتَرَضِ
u'غَيْرٌ مُفْتَقِرٌ':Added, #2: 2	غَيْرَ مُفْتَقِرٍ
u'غير مُفْتَقِرٌ':Added, #2: 2	غَيْرَ مُفْتَقِرٍ
u'غَيْرٌ مُفْتَقِرٌ':Added, #2: 2	غَيْرَ مُفْتَقِرَةٍ
u'غير مُفْتَقِرٌ':Added, #2: 2	غَيْرَ مُفْتَقِرَةٍ
u'غَيْرٌ مُفْتَقِرٌ':Added, #4: 4	غَيْرُ مُفْتَقِرٍ
u'غير مَفْتُونٌ':Added, #4: 4	غَيْرُ مُفْتَقِرٍ
u'غَيْرٌ مَفْتُونٌ':Added, #3: 3	غَيْرَ مَفْتُونٍ
u'غير مُفْرَدٌ':Added, #3: 3	غَيْرَ مَفْتُونٍ
u'غَيْرٌ مُفْرَدٌ':Added, #1: 1	غَيْرُ الْمُفْرَدِ
u'غير مُفْرَدٌ':Added, #1: 1	غَيْرُ الْمُفْرَدِ
u'غَيْرٌ مُفْرَدٌ':Added, #1: 1	غَيْرُ مُفْرَدٍ
u'غير مُفْرَدٌ':Added, #1: 1	غَيْرُ مُفْرَدٍ
u'غَيْرٌ مُفْرَدٌ':Added, #4: 4	غَيْرِ الْمُفْرَدِ
u'غير مُفْرَز':Added, #4: 4	غَيْرِ الْمُفْرَدِ
u'غَيْرٌ مُفْرَز':Added, #1: 1	غَيْرُ مُفْرَزٍ
u'غير مُفْرِطٌ':Added, #1: 1	غَيْرُ مُفْرَزٍ
u'غَيْرٌ مُفْرِطٌ':Added, #1: 1	غَيْرِ الْمُفْرِطِ
u'غير مُفَرَّع':Added, #1: 1	غَيْرِ الْمُفْرِطِ
u'غَيْرٌ مُفَرَّع':Added, #2: 2	غَيْرُ مُفَرَّعٍ
u'غير مَفْرُوضٌ':Added, #2: 2	غَيْرُ مُفَرَّعٍ
u'غَيْرٌ مَفْرُوضٌ':Added, #1: 1	غَيْرَ الْمَفْرُوضِ
u'غير مَفْرُوضٌ':Added, #1: 1	غَيْرَ الْمَفْرُوضِ
u'غَيْرٌ مَفْرُوضٌ':Added, #1: 1	غَيْرِ الْمَفْرُوضَةِ
u'غير مَفْرُوضٌ':Added, #1: 1	غَيْرِ الْمَفْرُوضَةِ
u'غَيْرٌ مَفْرُوضٌ':Added, #1: 1	غَيْرِ مَفْرُوضَةٍ
u'غير مَفْرُوضٌ':Added, #1: 1	غَيْرِ مَفْرُوضَةٍ
u'غَيْرٌ مَفْرُوضٌ':Added, #2: 2	غَيْرُ الْمَفْرُوضَةِ
u'غير مَفْرُوضٌ':Added, #2: 2	غَيْرُ الْمَفْرُوضَةِ
u'غَيْرٌ مَفْرُوضٌ':Added, #2: 2	غَيْرُ مَفْرُوضَةٍ
u'غير مُفْسِدٌ':Added, #2: 2	غَيْرُ مَفْرُوضَةٍ
u'غَيْرٌ مُفْسِدٌ':Added, #1: 1	غَيْرُ الْمُفْسِدَةِ
u'غير مُفْسِدٌ':Added, #1: 1	غَيْرُ الْمُفْسِدَةِ
u'غَيْرٌ مُفْسِدٌ':Added, #1: 1	غَيْرُ مُفْسِدَةٍ
u'غير مُفْسِدٌ':Added, #1: 1	غَيْرُ مُفْسِدَةٍ
u'غَيْرٌ مُفْسِدٌ':Added, #2: 2	غَيْرِ مُفْسِدٍ
u'غير مُفْسِدٌ':Added, #2: 2	غَيْرِ مُفْسِدٍ
u'غَيْرٌ مُفْسِدٌ':Added, #38: 38	غَيْرُ مُفْسِدٍ
u'غير مُفْسِدٌ':Added, #38: 38	غَيْرُ مُفْسِدٍ
u'غَيْرٌ مُفْسِدٌ':Added, #3: 3	غَيْرِ الْمُفْسِدِ
u'غير مُفْسِدٌ':Added, #3: 3	غَيْرِ الْمُفْسِدِ
u'غَيْرٌ مُفْسِدٌ':Added, #5: 5	غَيْرَ مُفْسِدَةٍ
u'غير مُفْسِدٌ':Added, #5: 5	غَيْرَ مُفْسِدَةٍ
u'غَيْرٌ مُفْسِدٌ':Added, #7: 7	غَيْرَ مُفْسِدٍ
u'غير مُفَسَّرٌ':Added, #7: 7	غَيْرَ مُفْسِدٍ
u'غير مُفَسَّرٌ':Added, #1: 1	غَيْرُ الْمُفَسَّرِ
u'غَيْرٌ مُفَسَّرٌ':Added, #1: 1	غَيْرِ الْمُفَسَّرِ
u'غَيْرٌ مُفَسَّرٌ':Added, #1: 1	غَيْرُ الْمُفَسَّرِ
u'غير مُفَسَّرٌ':Added, #1: 1	غَيْرِ الْمُفَسَّرِ
u'غَيْرٌ مُفَسَّرٌ':Added, #1: 1	غَيْرَ مُفَسَّرَةٍ
u'غير مُفَسَّرٌ':Added, #1: 1	غَيْرَ مُفَسَّرَةٍ
u'غَيْرٌ مُفَسَّرٌ':Added, #2: 2	غَيْرَ مُفَسَّرٍ
u'غير مَفْسُوخ':Added, #2: 2	غَيْرَ مُفَسَّرٍ
u'غَيْرٌ مَفْسُوخ':Added, #1: 1	غَيْرَ مَفْسُوخٍ
u'غير مُفَصَّلٌ':Added, #1: 1	غَيْرَ مَفْسُوخٍ
u'غَيْرٌ مُفَصَّلٌ':Added, #1: 1	غَيْرِ الْمُفَصَّلِ
u'غير مَفْصِلٌ':Added, #1: 1	غَيْرِ الْمُفَصَّلِ
u'غَيْرٌ مَفْصِلٌ':Added, #3: 3	غَيْرِ الْمَفْصِلِ
u'غير مَفْصِلٌ':Added, #3: 3	غَيْرِ الْمَفْصِلِ
u'غَيْرٌ مَفْصِلٌ':Added, #3: 3	غَيْرِ مَفْصِلٍ
u'غير مَفْصُولٌ':Added, #3: 3	غَيْرِ مَفْصِلٍ
u'غَيْرٌ مَفْصُولٌ':Added, #1: 1	غَيْرَ الْمَفْصُولَةِ
u'غير مَفْصُولٌ':Added, #1: 1	غَيْرَ الْمَفْصُولَةِ
u'غَيْرٌ مَفْصُولٌ':Added, #1: 1	غَيْرَ مَفْصُولٍ
u'غير مَفْصُولٌ':Added, #1: 1	غَيْرَ مَفْصُولٍ
u'غَيْرٌ مَفْصُولٌ':Added, #1: 1	غَيْرَ مَفْصُولَةٍ
u'غير مُفْضِي':Added, #1: 1	غَيْرَ مَفْصُولَةٍ
u'غَيْرٌ مُفْضِي':Added, #2: 2	غَيْرَ مُفْضِيَةٍ
u'غير مُفْضِي':Added, #2: 2	غَيْرَ مُفْضِيَةٍ
u'غَيْرٌ مُفْضِي':Added, #3: 3	غَيْرُ مُفْضِيَةٍ
u'غير مُفْطِر':Added, #3: 3	غَيْرُ مُفْضِيَةٍ
u'غَيْرٌ مُفْطِر':Added, #2: 2	غَيْرُ مُفْطِرٍ
u'غير مَفْقُودٌ':Added, #2: 2	غَيْرُ مُفْطِرٍ
u'غَيْرٌ مَفْقُودٌ':Added, #1: 1	غَيْرُ مَفْقُودٍ
u'غير مَفْقُودٌ':Added, #1: 1	غَيْرُ مَفْقُودٍ
u'غَيْرٌ مَفْقُودٌ':Added, #2: 2	غَيْرَ مَفْقُودٍ
u'غير مُفْلِسٌ':Added, #2: 2	غَيْرَ مَفْقُودٍ
u'غَيْرٌ مُفْلِسٌ':Added, #1: 1	غَيْرُ الْمُفْلِسِ
u'غير مُفْلِسٌ':Added, #1: 1	غَيْرُ الْمُفْلِسِ
u'غير مُفْلِسٌ':Added, #1: 1	غَيْر مُفْلِسِ
u'غَيْرٌ مُفْلِسٌ':Added, #1: 1	غَيْرَ مُفْلِسٍ
u'غَيْرٌ مُفْلِسٌ':Added, #1: 1	غَيْر مُفْلِسِ
u'غير مُفْلِسٌ':Added, #1: 1	غَيْرَ مُفْلِسٍ
u'غَيْرٌ مُفْلِسٌ':Added, #3: 3	غَيْرِ الْمُفْلِسِ
u'غير مَفْهُومٌ':Added, #3: 3	غَيْرِ الْمُفْلِسِ
u'غَيْرٌ مَفْهُومٌ':Added, #2: 2	غَيْرُ الْمَفْهُومِ
u'غير مَفْهُومٌ':Added, #2: 2	غَيْرُ الْمَفْهُومِ
u'غَيْرٌ مَفْهُومٌ':Added, #2: 2	غَيْرَ مَفْهُومٍ
u'غير مَفْهُومٌ':Added, #2: 2	غَيْرَ مَفْهُومٍ
u'غَيْرٌ مَفْهُومٌ':Added, #2: 2	غَيْرُ مَفْهُومَةٍ
u'غير مَفْهُومٌ':Added, #2: 2	غَيْرُ مَفْهُومَةٍ
u'غير مَفْهُومٌ':Added, #4: 4	غَيْرُ مَفْهُومٍ
u'غَيْرٌ مَفْهُومٌ':Added, #4: 4	غَيْرُ مَفْهُومِ
u'غَيْرٌ مَفْهُومٌ':Added, #4: 4	غَيْرُ مَفْهُومٍ
u'غير مُفَوَّضٌ':Added, #4: 4	غَيْرُ مَفْهُومِ
u'غير مُفَوَّضٌ':Added, #1: 1	غَيْرُ الْمُفَوَّضَةِ
u'غَيْرٌ مُفَوَّضٌ':Added, #1: 1	غَيْرِ الْمُفَوَّضَةِ
u'غَيْرٌ مُفَوَّضٌ':Added, #1: 1	غَيْرُ الْمُفَوَّضَةِ
u'غير مُفَوَّضٌ':Added, #1: 1	غَيْرِ الْمُفَوَّضَةِ
u'غَيْرٌ مُفَوَّضٌ':Added, #2: 2	غَيْرِ الْمُفَوَّضِ
u'غير مُفَوَّضٌ':Added, #2: 2	غَيْرِ الْمُفَوَّضِ
u'غَيْرٌ مُفَوَّضٌ':Added, #2: 2	غَيْرُ مُفَوَّضٍ
u'غير مُفِيدٌ':Added, #2: 2	غَيْرُ مُفَوَّضٍ
u'غَيْرٌ مُفِيدٌ':Added, #14: 14	غَيْرَ مُفِيدٍ
u'غير مُفِيدٌ':Added, #14: 14	غَيْرَ مُفِيدٍ
u'غَيْرٌ مُفِيدٌ':Added, #1: 1	غَيْرِ الْمُفِيدِ
u'غير مُفِيدٌ':Added, #1: 1	غَيْرِ الْمُفِيدِ
u'غَيْرٌ مُفِيدٌ':Added, #1: 1	غَيْرُ مُفِيدَةٍ
u'غير مُفِيدٌ':Added, #1: 1	غَيْرُ مُفِيدَةٍ
u'غَيْرٌ مُفِيدٌ':Added, #3: 3	غَيْرَ مُفِيدَةٍ
u'غير مُفِيدٌ':Added, #3: 3	غَيْرَ مُفِيدَةٍ
u'غَيْرٌ مُفِيدٌ':Added, #69: 69	غَيْرُ مُفِيدٍ
u'غير مُقَابِلٌ':Added, #69: 69	غَيْرُ مُفِيدٍ
u'غَيْرٌ مُقَابِلٌ':Added, #1: 1	غَيْرُ مُقَابِلٍ
u'غير مُقَابَلٌ':Added, #1: 1	غَيْرُ مُقَابِلٍ
u'غير مُقَابِلٌ':Added, #1: 1	غَيْرِ مُقَابَلَةِ
u'غَيْرٌ مُقَابَلٌ':Added, #1: 1	غَيْرَ مُقَابِلَةٍ
u'غَيْرٌ مُقَابِلٌ':Added, #1: 1	غَيْرِ مُقَابَلَةِ
u'غير مُقَابَلٌ':Added, #1: 1	غَيْرَ مُقَابِلَةٍ
u'غَيْرٌ مُقَابَلٌ':Added, #2: 2	غَيْرُ مُقَابَلٍ
u'غير مُقَابَلٌ':Added, #2: 2	غَيْرُ مُقَابَلٍ
u'غير مُقَابَلٌ':Added, #2: 2	غَيْرُ مُقَابَلَةٍ
u'غَيْرٌ مُقَابَلٌ':Added, #2: 2	غَيْرِ مُقَابَلَةٍ
u'غَيْرٌ مُقَابَلٌ':Added, #2: 2	غَيْرُ مُقَابَلَةٍ
u'غير مُقَابِلٌ':Added, #2: 2	غَيْرِ مُقَابَلَةٍ
u'غَيْرٌ مُقَابِلٌ':Added, #4: 4	غَيْرِ مُقَابِلٍ
u'غير مُقَابَلَةٌ':Added, #4: 4	غَيْرِ مُقَابِلٍ
u'غَيْرٌ مُقَابَلَةٌ':Added, #1: 1	غَيْرِ مُقَابَلَةِ
u'غير مُقَابَلَةٌ':Added, #1: 1	غَيْرِ مُقَابَلَةِ
u'غير مُقَابَلَةٌ':Added, #2: 2	غَيْرُ مُقَابَلَةٍ
u'غَيْرٌ مُقَابَلَةٌ':Added, #2: 2	غَيْرِ مُقَابَلَةٍ
u'غَيْرٌ مُقَابَلَةٌ':Added, #2: 2	غَيْرُ مُقَابَلَةٍ
u'غير مقارب':Added, #2: 2	غَيْرِ مُقَابَلَةٍ
u'غَيْرٌ مقارب':Added, #1: 1	غَيْرَ مُقَارِبِ
u'غير مُقَارِبٌ':Added, #1: 1	غَيْرَ مُقَارِبِ
u'غَيْرٌ مُقَارِبٌ':Added, #1: 1	غَيْرَ مُقَارِبِ
u'غير مُقَارَبَةٌ':Added, #1: 1	غَيْرَ مُقَارِبِ
u'غَيْرٌ مُقَارَبَةٌ':Added, #1: 1	غَيْرِ مُقَارَبَةِ
u'غير مُقَارَنٌ':Added, #1: 1	غَيْرِ مُقَارَبَةِ
u'غَيْرٌ مُقَارَنٌ':Added, #1: 1	غَيْرِ الْمُقَارَنَةِ
u'غير مُقَارَنٌ':Added, #1: 1	غَيْرِ الْمُقَارَنَةِ
u'غير مُقَارَنٌ':Added, #1: 1	غَيْرَ مُقَارَنٍ
u'غير مُقَارِنٌ':Added, #1: 1	غَيْرُ مُقَارَنٍ
u'غَيْرٌ مُقَارَنٌ':Added, #1: 1	غَيْرَ مُقَارِنٍ
u'غَيْرٌ مُقَارَنٌ':Added, #1: 1	غَيْرَ مُقَارَنٍ
u'غَيْرٌ مُقَارِنٌ':Added, #1: 1	غَيْرُ مُقَارَنٍ
u'غير مُقَارِنٌ':Added, #1: 1	غَيْرَ مُقَارِنٍ
u'غَيْرٌ مُقَارِنٌ':Added, #1: 1	غَيْرَ مُقَارِنَةٍ
u'غير مُقَارَنَةٌ':Added, #1: 1	غَيْرَ مُقَارِنَةٍ
u'غَيْرٌ مُقَارَنَةٌ':Added, #1: 1	غَيْرِ الْمُقَارَنَةِ
u'غير مُقاسَمَة':Added, #1: 1	غَيْرِ الْمُقَارَنَةِ
u'غَيْرٌ مُقاسَمَة':Added, #1: 1	غَيْرُ الْمُقَاسَمَةِ
u'غير مَقَاصِدُ':Added, #1: 1	غَيْرُ الْمُقَاسَمَةِ
u'غَيْرٌ مَقَاصِدُ':Added, #1: 1	غَيْرِ الْمَقَاصِدِ
u'غير مَقَاصِدُ':Added, #1: 1	غَيْرِ الْمَقَاصِدِ
u'غير مَقَاصِدُ':Added, #1: 1	غَيْرَ مَقَاصِدِ
u'غَيْرٌ مَقَاصِدُ':Added, #1: 1	غَيْرِ مَقَاصِدِ
u'غَيْرٌ مَقَاصِدُ':Added, #1: 1	غَيْرَ مَقَاصِدِ
u'غير مَقَامٌ':Added, #1: 1	غَيْرِ مَقَاصِدِ
u'غَيْرٌ مَقَامٌ':Added, #1: 1	غَيْرِ الْمَقَامِ
u'غير مَقَامٌ':Added, #1: 1	غَيْرِ الْمَقَامِ
u'غَيْرٌ مَقَامٌ':Added, #3: 3	غَيْرِ مَقَامِ
u'غير مَقْبَرَةٌ':Added, #3: 3	غَيْرِ مَقَامِ
u'غَيْرٌ مَقْبَرَةٌ':Added, #1: 1	غَيْرِ الْمَقْبَرَةِ
u'غير مَقْبَرَةٌ':Added, #1: 1	غَيْرِ الْمَقْبَرَةِ
u'غَيْرٌ مَقْبَرَةٌ':Added, #1: 1	غَيْرِ مَقْبَرَةِ
u'غير مَقْبُوضٌ':Added, #1: 1	غَيْرِ مَقْبَرَةِ
u'غَيْرٌ مَقْبُوضٌ':Added, #10: 10	غَيْرُ مَقْبُوضٍ
u'غير مَقْبُوضٌ':Added, #10: 10	غَيْرُ مَقْبُوضٍ
u'غَيْرٌ مَقْبُوضٌ':Added, #11: 11	غَيْرُ مَقْبُوضَةٍ
u'غير مَقْبُوضٌ':Added, #11: 11	غَيْرُ مَقْبُوضَةٍ
u'غَيْرٌ مَقْبُوضٌ':Added, #13: 13	غَيْرَ مَقْبُوضٍ
u'غير مَقْبُوضٌ':Added, #13: 13	غَيْرَ مَقْبُوضٍ
u'غير مَقْبُوضٌ':Added, #1: 1	غَيْرَ الْمَقْبُوضِ
u'غَيْرٌ مَقْبُوضٌ':Added, #1: 1	غَيْرِ الْمَقْبُوضِ
u'غَيْرٌ مَقْبُوضٌ':Added, #1: 1	غَيْرَ الْمَقْبُوضِ
u'غير مَقْبُوضٌ':Added, #1: 1	غَيْرِ الْمَقْبُوضِ
u'غَيْرٌ مَقْبُوضٌ':Added, #1: 1	غَيْرِ مَقْبُوضٍ
u'غير مَقْبُوضٌ':Added, #1: 1	غَيْرِ مَقْبُوضٍ
u'غَيْرٌ مَقْبُوضٌ':Added, #3: 3	غَيْرَ مَقْبُوضَةٍ
u'غير مَقْبُولٌ':Added, #3: 3	غَيْرَ مَقْبُوضَةٍ
u'غَيْرٌ مَقْبُولٌ':Added, #1: 1	غَيْرِ الْمَقْبُولِ
u'غير مَقْبُولٌ':Added, #1: 1	غَيْرِ الْمَقْبُولِ
u'غير مَقْبُولٌ':Added, #2: 2	غَيْرَ مَقْبُولِ
u'غَيْرٌ مَقْبُولٌ':Added, #2: 2	غَيْرُ مَقْبُولِ
u'غَيْرٌ مَقْبُولٌ':Added, #2: 2	غَيْرَ مَقْبُولِ
u'غير مَقْبُولٌ':Added, #2: 2	غَيْرُ مَقْبُولِ
u'غَيْرٌ مَقْبُولٌ':Added, #45: 45	غَيْرُ مَقْبُولَةٍ
u'غير مَقْبُولٌ':Added, #45: 45	غَيْرُ مَقْبُولَةٍ
u'غَيْرٌ مَقْبُولٌ':Added, #57: 57	غَيْرُ مَقْبُولٍ
u'غير مَقْبُولٌ':Added, #57: 57	غَيْرُ مَقْبُولٍ
u'غَيْرٌ مَقْبُولٌ':Added, #5: 5	غَيْرِ مَقْبُولٍ
u'غير مُقْتَرِنٌ':Added, #5: 5	غَيْرِ مَقْبُولٍ
u'غَيْرٌ مُقْتَرِنٌ':Added, #1: 1	غَيْرِ مُقْتَرِنٍ
u'غير مُقْتَرِنٌ':Added, #1: 1	غَيْرِ مُقْتَرِنٍ
u'غَيْرٌ مُقْتَرِنٌ':Added, #2: 2	غَيْرَ مُقْتَرِنٍ
u'غير مُقْتَصِر':Added, #2: 2	غَيْرَ مُقْتَرِنٍ
u'غير مُقْتَصِر':Added, #1: 1	غَيْرَ مُقْتَصِرٍ
u'غَيْرٌ مُقْتَصِر':Added, #1: 1	غَيْرُ مُقْتَصِرٍ
u'غَيْرٌ مُقْتَصِر':Added, #1: 1	غَيْرَ مُقْتَصِرٍ
u'غير مُقْتَطَعٌ':Added, #1: 1	غَيْرُ مُقْتَصِرٍ
u'غَيْرٌ مُقْتَطَعٌ':Added, #2: 2	غَيْرَ مُقْتَطَعٍ
u'غير مَقْتَلٌ':Added, #2: 2	غَيْرَ مُقْتَطَعٍ
u'غَيْرٌ مَقْتَلٌ':Added, #1: 1	غَيْرَ مَقْتَلٍ
u'غير مَقْتَلٌ':Added, #1: 1	غَيْرَ مَقْتَلٍ
u'غَيْرٌ مَقْتَلٌ':Added, #7: 7	غَيْرِ مَقْتَلٍ
u'غير مَقْتُولٌ':Added, #7: 7	غَيْرِ مَقْتَلٍ
u'غَيْرٌ مَقْتُولٌ':Added, #2: 2	غَيْرِ الْمَقْتُولِ
u'غير مُقَدَّرٌ':Added, #2: 2	غَيْرِ الْمَقْتُولِ
u'غَيْرٌ مُقَدَّرٌ':Added, #10: 10	غَيْرُ مُقَدَّرَةٍ
u'غير مُقَدَّرٌ':Added, #10: 10	غَيْرُ مُقَدَّرَةٍ
u'غَيْرٌ مُقَدَّرٌ':Added, #1: 1	غَيْرَ الْمُقَدَّرِ
u'غير مُقَدَّرٌ':Added, #1: 1	غَيْرَ الْمُقَدَّرِ
u'غَيْرٌ مُقَدَّرٌ':Added, #1: 1	غَيْرِ الْمُقَدَّرَاتِ
u'غير مُقَدَّرٌ':Added, #1: 1	غَيْرِ الْمُقَدَّرَاتِ
u'غَيْرٌ مُقَدَّرٌ':Added, #1: 1	غَيْرِ الْمُقَدَّرَةِ
u'غير مُقَدِّرٌ':Added, #1: 1	غَيْرِ الْمُقَدَّرَةِ
u'غَيْرٌ مُقَدِّرٌ':Added, #1: 1	غَيْرَ مُقَدِّرٍ
u'غير مُقَدَّرٌ':Added, #1: 1	غَيْرَ مُقَدِّرٍ
u'غير مُقَدَّرٌ':Added, #1: 1	غَيْرُ مُقَدَّرَةِ
u'غَيْرٌ مُقَدَّرٌ':Added, #1: 1	غَيْرِ مُقَدَّرَةٍ
u'غَيْرٌ مُقَدَّرٌ':Added, #1: 1	غَيْرُ مُقَدَّرَةِ
u'غير مُقَدَّرٌ':Added, #1: 1	غَيْرِ مُقَدَّرَةٍ
u'غَيْرٌ مُقَدَّرٌ':Added, #1: 1	غَيْرُ مُقَدَّرَيْنِ
u'غير مُقَدَّرٌ':Added, #1: 1	غَيْرُ مُقَدَّرَيْنِ
u'غَيْرٌ مُقَدَّرٌ':Added, #2: 2	غَيْرُ الْمُقَدَّرِ
u'غير مُقَدَّرٌ':Added, #2: 2	غَيْرُ الْمُقَدَّرِ
u'غَيْرٌ مُقَدَّرٌ':Added, #2: 2	غَيْرَ مُقَدَّرَةٍ
u'غير مُقَدَّرٌ':Added, #2: 2	غَيْرَ مُقَدَّرَةٍ
u'غَيْرٌ مُقَدَّرٌ':Added, #42: 42	غَيْرُ مُقَدَّرٍ
u'غير مُقَدَّرٌ':Added, #42: 42	غَيْرُ مُقَدَّرٍ
u'غَيْرٌ مُقَدَّرٌ':Added, #8: 8	غَيْرَ مُقَدَّرٍ
u'غير مُقَدَّمٌ':Added, #8: 8	غَيْرَ مُقَدَّرٍ
u'غَيْرٌ مُقَدَّمٌ':Added, #1: 1	غَيْرِ الْمُقَدَّمِ
u'غير مُقَدَّمٌ':Added, #1: 1	غَيْرِ الْمُقَدَّمِ
u'غَيْرٌ مُقَدَّمٌ':Added, #2: 2	غَيْرُ مُقَدَّمٍ
u'غير مَقْدُورٌ':Added, #2: 2	غَيْرُ مُقَدَّمٍ
u'غَيْرٌ مَقْدُورٌ':Added, #16: 16	غَيْرُ مَقْدُورٍ
u'غير مَقْدُورٌ':Added, #16: 16	غَيْرُ مَقْدُورٍ
u'غير مَقْدُورٌ':Added, #1: 1	غَيْرَ الْمَقْدُورِ
u'غَيْرٌ مَقْدُورٌ':Added, #1: 1	غَيْرُ الْمَقْدُورِ
u'غَيْرٌ مَقْدُورٌ':Added, #1: 1	غَيْرَ الْمَقْدُورِ
u'غير مَقْدُورٌ':Added, #1: 1	غَيْرُ الْمَقْدُورِ
u'غَيْرٌ مَقْدُورٌ':Added, #1: 1	غَيْرِ مَقْدُورِ
u'غير مَقْدُورٌ':Added, #1: 1	غَيْرِ مَقْدُورِ
u'غير مَقْدُورٌ':Added, #1: 1	غَيْرُ مَقْدُورَةِ
u'غَيْرٌ مَقْدُورٌ':Added, #1: 1	غَيْرِ مَقْدُورَةِ
u'غَيْرٌ مَقْدُورٌ':Added, #1: 1	غَيْرُ مَقْدُورَةِ
u'غير مَقْدُورٌ':Added, #1: 1	غَيْرِ مَقْدُورَةِ
u'غَيْرٌ مَقْدُورٌ':Added, #2: 2	غَيْرِ مَقْدُورٍ
u'غير مَقْدُورٌ':Added, #2: 2	غَيْرِ مَقْدُورٍ
u'غَيْرٌ مَقْدُورٌ':Added, #3: 3	غَيْرَ مَقْدُورِ
u'غير مَقْدُورٌ':Added, #3: 3	غَيْرَ مَقْدُورِ
u'غَيْرٌ مَقْدُورٌ':Added, #5: 5	غَيْرِ الْمَقْدُورِ
u'غير مَقْدُورٌ':Added, #5: 5	غَيْرِ الْمَقْدُورِ
u'غَيْرٌ مَقْدُورٌ':Added, #8: 8	غَيْرَ مَقْدُورٍ
u'غير مَقْدُورٌ':Added, #8: 8	غَيْرَ مَقْدُورٍ
u'غَيْرٌ مَقْدُورٌ':Added, #9: 9	غَيْرُ مَقْدُورِ
u'غير مَقَرٌّ':Added, #9: 9	غَيْرُ مَقْدُورِ
u'غَيْرٌ مَقَرٌّ':Added, #1: 1	غَيْرُ الْمَقَرِّ
u'غير مُقَرَّرٌ':Added, #1: 1	غَيْرُ الْمَقَرِّ
u'غَيْرٌ مُقَرَّرٌ':Added, #1: 1	غَيْرُ مُقَرَّرَةٍ
u'غير مُقْرِضٌ':Added, #1: 1	غَيْرُ مُقَرَّرَةٍ
u'غَيْرٌ مُقْرِضٌ':Added, #1: 1	غَيْرِ الْمُقْرِضِ
u'غير مَقْرُونٌ':Added, #1: 1	غَيْرِ الْمُقْرِضِ
u'غير مَقْرُونٌ':Added, #1: 1	غَيْرُ مَقْرُونٍ
u'غَيْرٌ مَقْرُونٌ':Added, #1: 1	غَيْرِ مَقْرُونٍ
u'غَيْرٌ مَقْرُونٌ':Added, #1: 1	غَيْرُ مَقْرُونٍ
u'غير مَقْرُونٌ':Added, #1: 1	غَيْرِ مَقْرُونٍ
u'غَيْرٌ مَقْرُونٌ':Added, #1: 1	غَيْرِ مَقْرُونَةٍ
u'غير مَقْرُونٌ':Added, #1: 1	غَيْرِ مَقْرُونَةٍ
u'غَيْرٌ مَقْرُونٌ':Added, #2: 2	غَيْرَ مَقْرُونٍ
u'غير مَقْرُونٌ':Added, #2: 2	غَيْرَ مَقْرُونٍ
u'غَيْرٌ مَقْرُونٌ':Added, #5: 5	غَيْرَ مَقْرُونَةٍ
u'غير مَقْسُومٌ':Added, #5: 5	غَيْرَ مَقْرُونَةٍ
u'غَيْرٌ مَقْسُومٌ':Added, #19: 19	غَيْرَ مَقْسُومٍ
u'غير مَقْسُومٌ':Added, #19: 19	غَيْرَ مَقْسُومٍ
u'غَيْرٌ مَقْسُومٌ':Added, #1: 1	غَيْرُ الْمَقْسُومِ
u'غير مَقْسُومٌ':Added, #1: 1	غَيْرُ الْمَقْسُومِ
u'غَيْرٌ مَقْسُومٌ':Added, #2: 2	غَيْرِ مَقْسُومٍ
u'غير مَقْسُومٌ':Added, #2: 2	غَيْرِ مَقْسُومٍ
u'غَيْرٌ مَقْسُومٌ':Added, #2: 2	غَيْرِ مَقْسُومَةٍ
u'غير مَقْسُومٌ':Added, #2: 2	غَيْرِ مَقْسُومَةٍ
u'غَيْرٌ مَقْسُومٌ':Added, #5: 5	غَيْرُ مَقْسُومَةٍ
u'غير مَقْسُومٌ':Added, #5: 5	غَيْرُ مَقْسُومَةٍ
u'غَيْرٌ مَقْسُومٌ':Added, #7: 7	غَيْرُ مَقْسُومٍ
u'غير مَقْسُومٌ':Added, #7: 7	غَيْرُ مَقْسُومٍ
u'غَيْرٌ مَقْسُومٌ':Added, #7: 7	غَيْرَ مَقْسُومَةٍ
u'غير مُقَصِّرٌ':Added, #7: 7	غَيْرَ مَقْسُومَةٍ
u'غَيْرٌ مُقَصِّرٌ':Added, #1: 1	غَيْرِ الْمُقَصِّرِ
u'غير مُقَصِّرٌ':Added, #1: 1	غَيْرِ الْمُقَصِّرِ
u'غَيْرٌ مُقَصِّرٌ':Added, #1: 1	غَيْرِ مُقَصِّرٍ
u'غير مُقَصِّرٌ':Added, #1: 1	غَيْرِ مُقَصِّرٍ
u'غَيْرٌ مُقَصِّرٌ':Added, #1: 1	غَيْرُ مُقَصِّرَةٍ
u'غير مُقَصِّرٌ':Added, #1: 1	غَيْرُ مُقَصِّرَةٍ
u'غَيْرٌ مُقَصِّرٌ':Added, #8: 8	غَيْرُ مُقَصِّرٍ
u'غير مَقْصُودٌ':Added, #8: 8	غَيْرُ مُقَصِّرٍ
u'غَيْرٌ مَقْصُودٌ':Added, #1: 1	غَيْرُ مَقْصُودَيْنِ
u'غير مَقْصُودٌ':Added, #1: 1	غَيْرُ مَقْصُودَيْنِ
u'غَيْرٌ مَقْصُودٌ':Added, #24: 24	غَيْرُ مَقْصُودَةٍ
u'غير مَقْصُودٌ':Added, #24: 24	غَيْرُ مَقْصُودَةٍ
u'غَيْرٌ مَقْصُودٌ':Added, #28: 28	غَيْرَ مَقْصُودٍ
u'غير مَقْصُودٌ':Added, #28: 28	غَيْرَ مَقْصُودٍ
u'غَيْرٌ مَقْصُودٌ':Added, #2: 2	غَيْرَ الْمَقْصُودِ
u'غير مَقْصُودٌ':Added, #2: 2	غَيْرَ الْمَقْصُودِ
u'غَيْرٌ مَقْصُودٌ':Added, #2: 2	غَيْرُ الْمَقْصُودَةِ
u'غير مَقْصُودٌ':Added, #2: 2	غَيْرُ الْمَقْصُودَةِ
u'غَيْرٌ مَقْصُودٌ':Added, #2: 2	غَيْرَ مَقْصُودِ
u'غير مَقْصُودٌ':Added, #2: 2	غَيْرَ مَقْصُودِ
u'غَيْرٌ مَقْصُودٌ':Added, #3: 3	غَيْرِ مَقْصُودٍ
u'غير مَقْصُودٌ':Added, #3: 3	غَيْرِ مَقْصُودٍ
u'غَيْرٌ مَقْصُودٌ':Added, #4: 4	غَيْرِ الْمَقْصُودِ
u'غير مَقْصُودٌ':Added, #4: 4	غَيْرِ الْمَقْصُودِ
u'غَيْرٌ مَقْصُودٌ':Added, #5: 5	غَيْرِ مَقْصُودِهِ
u'غير مَقْصُودٌ':Added, #5: 5	غَيْرِ مَقْصُودِهِ
u'غَيْرٌ مَقْصُودٌ':Added, #8: 8	غَيْرُ الْمَقْصُودِ
u'غير مَقْصُودٌ':Added, #8: 8	غَيْرُ الْمَقْصُودِ
u'غَيْرٌ مَقْصُودٌ':Added, #8: 8	غَيْرَ مَقْصُودَةٍ
u'غير مَقْصُودٌ':Added, #8: 8	غَيْرَ مَقْصُودَةٍ
u'غَيْرٌ مَقْصُودٌ':Added, #93: 93	غَيْرُ مَقْصُودٍ
u'غير مَقْصُورٌ':Added, #93: 93	غَيْرُ مَقْصُودٍ
u'غَيْرٌ مَقْصُورٌ':Added, #1: 1	غَيْرَ الْمَقْصُورِ
u'غير مَقْصُورٌ':Added, #1: 1	غَيْرَ الْمَقْصُورِ
u'غَيْرٌ مَقْصُورٌ':Added, #1: 1	غَيْرُ مَقْصُورَةٍ
u'غير مَقْصُورٌ':Added, #1: 1	غَيْرُ مَقْصُورَةٍ
u'غَيْرٌ مَقْصُورٌ':Added, #3: 3	غَيْرَ مَقْصُورٍ
u'غير مَقْصُورٌ':Added, #3: 3	غَيْرَ مَقْصُورٍ
u'غَيْرٌ مَقْصُورٌ':Added, #3: 3	غَيْرَ مَقْصُورَةٍ
u'غير مَقْصُورٌ':Added, #3: 3	غَيْرَ مَقْصُورَةٍ
u'غَيْرٌ مَقْصُورٌ':Added, #5: 5	غَيْرُ مَقْصُورٍ
u'غير مَقْصُورَةٌ':Added, #5: 5	غَيْرُ مَقْصُورٍ
u'غَيْرٌ مَقْصُورَةٌ':Added, #1: 1	غَيْرُ مَقْصُورَةٍ
u'غير مَقْصُورَةٌ':Added, #1: 1	غَيْرُ مَقْصُورَةٍ
u'غَيْرٌ مَقْصُورَةٌ':Added, #3: 3	غَيْرَ مَقْصُورَةٍ
u'غير مَقْضِيّ':Added, #3: 3	غَيْرَ مَقْصُورَةٍ
u'غَيْرٌ مَقْضِيّ':Added, #4: 4	غَيْرِ الْمَقْضِيِّ
u'غير مُقَطَّع':Added, #4: 4	غَيْرِ الْمَقْضِيِّ
u'غَيْرٌ مُقَطَّع':Added, #1: 1	غَيْرُ مُقَطَّعَةٍ
u'غير مَقْطُورَةٌ':Added, #1: 1	غَيْرُ مُقَطَّعَةٍ
u'غَيْرٌ مَقْطُورَةٌ':Added, #1: 1	غَيْرُ مَقْطُورَةٍ
u'غير مَقْطُورَةٌ':Added, #1: 1	غَيْرُ مَقْطُورَةٍ
u'غَيْرٌ مَقْطُورَةٌ':Added, #3: 3	غَيْرَ مَقْطُورَةٍ
u'غير مَقْطُوعٌ':Added, #3: 3	غَيْرَ مَقْطُورَةٍ
u'غَيْرٌ مَقْطُوعٌ':Added, #1: 1	غَيْرُ الْمَقْطُوعِ
u'غير مَقْطُوعٌ':Added, #1: 1	غَيْرُ الْمَقْطُوعِ
u'غَيْرٌ مَقْطُوعٌ':Added, #21: 21	غَيْرُ مَقْطُوعٍ
u'غير مَقْطُوعٌ':Added, #21: 21	غَيْرُ مَقْطُوعٍ
u'غَيْرٌ مَقْطُوعٌ':Added, #2: 2	غَيْرِ الْمَقْطُوعِ
u'غير مَقْطُوعٌ':Added, #2: 2	غَيْرِ الْمَقْطُوعِ
u'غَيْرٌ مَقْطُوعٌ':Added, #3: 3	غَيْرِ مَقْطُوعٍ
u'غير مَقْطُوعٌ':Added, #3: 3	غَيْرِ مَقْطُوعٍ
u'غَيْرٌ مَقْطُوعٌ':Added, #4: 4	غَيْرَ مَقْطُوعٍ
u'غير مُقَعَّرٌ':Added, #4: 4	غَيْرَ مَقْطُوعٍ
u'غَيْرٌ مُقَعَّرٌ':Added, #1: 1	غَيْرُ مُقَعَّرَةٍ
u'غير مُقْفَلٌ':Added, #1: 1	غَيْرُ مُقَعَّرَةٍ
u'غَيْرٌ مُقْفَلٌ':Added, #1: 1	غَيْرِ مُقْفَلٍ
u'غير مُقَلَّدٌ':Added, #1: 1	غَيْرِ مُقْفَلٍ
u'غَيْرٌ مُقَلَّدٌ':Added, #1: 1	غَيْرَ مُقَلَّدٍ
u'غير مُقَلَّدٌ':Added, #1: 1	غَيْرَ مُقَلَّدٍ
u'غير مُقَلِّدٌ':Added, #2: 2	غَيْرَ مُقَلَّدِهِ
u'غَيْرٌ مُقَلَّدٌ':Added, #2: 2	غَيْرِ مُقَلِّدِهِ
u'غَيْرٌ مُقَلِّدٌ':Added, #2: 2	غَيْرَ مُقَلَّدِهِ
u'غير مُقَلِّدٌ':Added, #2: 2	غَيْرِ مُقَلِّدِهِ
u'غَيْرٌ مُقَلِّدٌ':Added, #4: 4	غَيْرَ مُقَلِّدٍ
u'غير مُقَلَّدٌ':Added, #4: 4	غَيْرَ مُقَلِّدٍ
u'غَيْرٌ مُقَلَّدٌ':Added, #4: 4	غَيْرِ مُقَلَّدِهِ
u'غير مَقْلُوبٌ':Added, #4: 4	غَيْرِ مُقَلَّدِهِ
u'غَيْرٌ مَقْلُوبٌ':Added, #2: 2	غَيْرَ مَقْلُوبٍ
u'غير مَقْلِيٌّ':Added, #2: 2	غَيْرَ مَقْلُوبٍ
u'غَيْرٌ مَقْلِيٌّ':Added, #1: 1	غَيْرِ الْمَقْلِيَّةِ
u'غير مَقْلِيٌّ':Added, #1: 1	غَيْرِ الْمَقْلِيَّةِ
u'غَيْرٌ مَقْلِيٌّ':Added, #1: 1	غَيْرَ مَقْلِيٍّ
u'غير مَقْلِيٌّ':Added, #1: 1	غَيْرَ مَقْلِيٍّ
u'غَيْرٌ مَقْلِيٌّ':Added, #1: 1	غَيْرُ مَقْلِيَّةٍ
u'غير مُقَنَّعٌ':Added, #1: 1	غَيْرُ مَقْلِيَّةٍ
u'غير مُقْنِعٌ':Added, #1: 1	غَيْرَ مُقَنَّعٍ
u'غَيْرٌ مُقَنَّعٌ':Added, #1: 1	غَيْرَ مُقْنِعٍ
u'غَيْرٌ مُقْنِعٌ':Added, #1: 1	غَيْرَ مُقَنَّعٍ
u'غير مَقْهُور':Added, #1: 1	غَيْرَ مُقْنِعٍ
u'غَيْرٌ مَقْهُور':Added, #1: 1	غَيْرَ الْمَقْهُورِ
u'غير مَقْهُور':Added, #1: 1	غَيْرَ الْمَقْهُورِ
u'غَيْرٌ مَقْهُور':Added, #1: 1	غَيْرَ مَقْهُورٍ
u'غير مَقْهُور':Added, #1: 1	غَيْرَ مَقْهُورٍ
u'غَيْرٌ مَقْهُور':Added, #4: 4	غَيْرِ مَقْهُورٍ
u'غير مِقْيَاسٌ':Added, #4: 4	غَيْرِ مَقْهُورٍ
u'غَيْرٌ مِقْيَاسٌ':Added, #1: 1	غَيْرِ مِقْيَاسِ
u'غير مُقَيَّدٌ':Added, #1: 1	غَيْرِ مِقْيَاسِ
u'غَيْرٌ مُقَيَّدٌ':Added, #18: 18	غَيْرَ مُقَيَّدٍ
u'غير مُقَيَّدٌ':Added, #18: 18	غَيْرَ مُقَيَّدٍ
u'غَيْرٌ مُقَيَّدٌ':Added, #1: 1	غَيْرُ الْمُقَيَّدِ
u'غير مُقَيَّدٌ':Added, #1: 1	غَيْرُ الْمُقَيَّدِ
u'غير مُقَيِّدٌ':Added, #1: 1	غَيْرَ مُقَيّدٍ
u'غير مُقَيِّدٌ':Added, #1: 1	غَيْرَ مُقَيّدٍ
u'غَيْرٌ مُقَيَّدٌ':Added, #1: 1	غَيْرَ مُقَيِّدٍ
u'غَيْرٌ مُقَيِّدٌ':Added, #1: 1	غَيْرَ مُقَيّدٍ
u'غَيْرٌ مُقَيِّدٌ':Added, #1: 1	غَيْرَ مُقَيّدٍ
u'غير مُقَيَّدٌ':Added, #1: 1	غَيْرَ مُقَيِّدٍ
u'غَيْرٌ مُقَيَّدٌ':Added, #23: 23	غَيْرُ مُقَيَّدٍ
u'غير مُقَيَّدٌ':Added, #23: 23	غَيْرُ مُقَيَّدٍ
u'غَيْرٌ مُقَيَّدٌ':Added, #2: 2	غَيْرِ الْمُقَيَّدِ
u'غير مُقَيَّدٌ':Added, #2: 2	غَيْرِ الْمُقَيَّدِ
u'غَيْرٌ مُقَيَّدٌ':Added, #2: 2	غَيْرِ مُقَيَّدٍ
u'غير مُقَيَّدٌ':Added, #2: 2	غَيْرِ مُقَيَّدٍ
u'غَيْرٌ مُقَيَّدٌ':Added, #3: 3	غَيْرَ مُقَيَّدَةٍ
u'غير مُقَيَّدٌ':Added, #3: 3	غَيْرَ مُقَيَّدَةٍ
u'غَيْرٌ مُقَيَّدٌ':Added, #6: 6	غَيْرُ مُقَيَّدَةٍ
u'غير مُقِيمٌ':Added, #6: 6	غَيْرُ مُقَيَّدَةٍ
u'غير مُقِيمٌ':Added, #1: 1	غَيْرُ مُقِيمٍ
u'غَيْرٌ مُقِيمٌ':Added, #1: 1	غَيْرِ مُقِيمٍ
u'غَيْرٌ مُقِيمٌ':Added, #1: 1	غَيْرُ مُقِيمٍ
u'غير مُكابِر':Added, #1: 1	غَيْرِ مُقِيمٍ
u'غَيْرٌ مُكابِر':Added, #1: 1	غَيْرُ مُكَابِرٍ
u'غير مُكَابَرَةٌ':Added, #1: 1	غَيْرُ مُكَابِرٍ
u'غَيْرٌ مُكَابَرَةٌ':Added, #1: 1	غَيْرَ مُكَابَرَةٍ
u'غير مُكَاتَبَةٌ':Added, #1: 1	غَيْرَ مُكَابَرَةٍ
u'غَيْرٌ مُكَاتَبَةٌ':Added, #1: 1	غَيْرُ الْمُكَاتَبَاتِ
u'غير مُكَاتَبَةٌ':Added, #1: 1	غَيْرُ الْمُكَاتَبَاتِ
u'غَيْرٌ مُكَاتَبَةٌ':Added, #1: 1	غَيْرَ الْمُكَاتَبَةِ
u'غير مُكَاتَبَةٌ':Added, #1: 1	غَيْرَ الْمُكَاتَبَةِ
u'غَيْرٌ مُكَاتَبَةٌ':Added, #1: 1	غَيْرِ مُكَاتَبَةٍ
u'غير مُكَاتَبَةٌ':Added, #1: 1	غَيْرِ مُكَاتَبَةٍ
u'غَيْرٌ مُكَاتَبَةٌ':Added, #2: 2	غَيْرُ الْمُكَاتَبَةِ
u'غير مُكَاتَبَةٌ':Added, #2: 2	غَيْرُ الْمُكَاتَبَةِ
u'غَيْرٌ مُكَاتَبَةٌ':Added, #4: 4	غَيْرِ الْمُكَاتَبَةِ
u'غير مكار':Added, #4: 4	غَيْرِ الْمُكَاتَبَةِ
u'غَيْرٌ مكار':Added, #1: 1	غَيْرُ مُكَارٍ
u'غير مكارم':Added, #1: 1	غَيْرُ مُكَارٍ
u'غَيْرٌ مكارم':Added, #1: 1	غَيْرَ مَكَارِمِ
u'غير مَكَارِمُ':Added, #1: 1	غَيْرَ مَكَارِمِ
u'غَيْرٌ مَكَارِمُ':Added, #1: 1	غَيْرَ مَكَارِمِ
u'غير مُكَافِئٌ':Added, #1: 1	غَيْرَ مَكَارِمِ
u'غَيْرٌ مُكَافِئٌ':Added, #1: 1	غَيْرِ مُكَافِئٍ
u'غير مُكَافِئٌ':Added, #1: 1	غَيْرِ مُكَافِئٍ
u'غَيْرٌ مُكَافِئٌ':Added, #1: 1	غَيْرَ مُكَافِئِهِ
u'غير مُكَافِئٌ':Added, #1: 1	غَيْرَ مُكَافِئِهِ
u'غَيْرٌ مُكَافِئٌ':Added, #2: 2	غَيْرَ مُكَافِئٍ
u'غير مَكَانٌ':Added, #2: 2	غَيْرَ مُكَافِئٍ
u'غَيْرٌ مَكَانٌ':Added, #1: 1	غَيْرَ الْمَكَانِ
u'غير مَكَانٌ':Added, #1: 1	غَيْرَ الْمَكَانِ
u'غير مَكَانٌ':Added, #1: 1	غَيْرَ مَكَانِ
u'غَيْرٌ مَكَانٌ':Added, #1: 1	غَيْرِ مَكَانٍ
u'غَيْرٌ مَكَانٌ':Added, #1: 1	غَيْرَ مَكَانِ
u'غير مَكَانٌ':Added, #1: 1	غَيْرِ مَكَانٍ
u'غَيْرٌ مَكَانٌ':Added, #6: 6	غَيْرِ مَكَانِهِ
u'غير مَكَانٌ':Added, #6: 6	غَيْرِ مَكَانِهِ
u'غَيْرٌ مَكَانٌ':Added, #7: 7	غَيْرِ الْمَكَانِ
u'غير مَكَانٌ':Added, #7: 7	غَيْرِ الْمَكَانِ
u'غَيْرٌ مَكَانٌ':Added, #9: 9	غَيْرِ مَكَانِ
u'غير مُكَبِّرٌ':Added, #9: 9	غَيْرِ مَكَانِ
u'غَيْرٌ مُكَبِّرٌ':Added, #5: 5	غَيْرَ مُكَبِّرٍ
u'غير مَكْبُوس':Added, #5: 5	غَيْرَ مُكَبِّرٍ
u'غَيْرٌ مَكْبُوس':Added, #2: 2	غَيْرُ مَكْبُوسٍ
u'غير مُكْتَسَبٌ':Added, #2: 2	غَيْرُ مَكْبُوسٍ
u'غير مُكْتَسِبٌ':Added, #1: 1	غَيْرِ مُكْتَسَبٍ
u'غَيْرٌ مُكْتَسَبٌ':Added, #1: 1	غَيْرِ مُكْتَسِبٍ
u'غَيْرٌ مُكْتَسِبٌ':Added, #1: 1	غَيْرِ مُكْتَسَبٍ
u'غير مُكْتَسَبٌ':Added, #1: 1	غَيْرِ مُكْتَسِبٍ
u'غَيْرٌ مُكْتَسَبٌ':Added, #1: 1	غَيْرُ مُكْتَسَبَةٍ
u'غير مُكْتَسَبٌ':Added, #1: 1	غَيْرُ مُكْتَسَبَةٍ
u'غَيْرٌ مُكْتَسَبٌ':Added, #2: 2	غَيْرُ مُكْتَسَبٍ
u'غير مُكْتَنِزٌ':Added, #2: 2	غَيْرُ مُكْتَسَبٍ
u'غَيْرٌ مُكْتَنِزٌ':Added, #1: 1	غَيْرَ مُكْتَنِزٍ
u'غير مَكْتُوبٌ':Added, #1: 1	غَيْرَ مُكْتَنِزٍ
u'غَيْرٌ مَكْتُوبٌ':Added, #1: 1	غَيْرُ مَكْتُوبٍ
u'غير مَكْتُوبٌ':Added, #1: 1	غَيْرُ مَكْتُوبٍ
u'غَيْرٌ مَكْتُوبٌ':Added, #1: 1	غَيْرِ مَكْتُوبَةٍ
u'غير مَكْتُوبٌ':Added, #1: 1	غَيْرِ مَكْتُوبَةٍ
u'غَيْرٌ مَكْتُوبٌ':Added, #2: 2	غَيْرَ مَكْتُوبٍ
u'غير مَكْتُوبٌ':Added, #2: 2	غَيْرَ مَكْتُوبٍ
u'غَيْرٌ مَكْتُوبٌ':Added, #3: 3	غَيْرِ الْمَكْتُوبَةِ
u'غير مَكْتُوفٌ':Added, #3: 3	غَيْرِ الْمَكْتُوبَةِ
u'غَيْرٌ مَكْتُوفٌ':Added, #1: 1	غَيْرَ مَكْتُوفٍ
u'غير مُكْثٌ':Added, #1: 1	غَيْرَ مَكْتُوفٍ
u'غَيْرٌ مُكْثٌ':Added, #3: 3	غَيْرِ مُكْثٍ
u'غير مُكَرَّرٌ':Added, #3: 3	غَيْرِ مُكْثٍ
u'غير مُكَرِّرٌ':Added, #1: 1	غَيْرُ مُكَرَّرٍ
u'غَيْرٌ مُكَرَّرٌ':Added, #1: 1	غَيْرُ مُكَرِّرٍ
u'غَيْرٌ مُكَرِّرٌ':Added, #1: 1	غَيْرُ مُكَرَّرٍ
u'غير مُكَرَّرٌ':Added, #1: 1	غَيْرُ مُكَرِّرٍ
u'غَيْرٌ مُكَرَّرٌ':Added, #1: 1	غَيْرُ مُكَرَّرَيْنِ
u'غير مُكَرَّرٌ':Added, #1: 1	غَيْرُ مُكَرَّرَيْنِ
u'غير مُكَرَّرٌ':Added, #2: 2	غَيْرَ مُكَرَّرٍ
u'غَيْرٌ مُكَرَّرٌ':Added, #2: 2	غَيْرِ مُكَرَّرٍ
u'غَيْرٌ مُكَرَّرٌ':Added, #2: 2	غَيْرَ مُكَرَّرٍ
u'غير مُكْرَهٌ':Added, #2: 2	غَيْرِ مُكَرَّرٍ
u'غَيْرٌ مُكْرَهٌ':Added, #1: 1	غَيْرِ الْمُكْرَهِ
u'غير مُكْرَهٌ':Added, #1: 1	غَيْرِ الْمُكْرَهِ
u'غَيْرٌ مُكْرَهٌ':Added, #1: 1	غَيْرِ مُكْرَهٍ
u'غير مُكْرَهٌ':Added, #1: 1	غَيْرِ مُكْرَهٍ
u'غَيْرٌ مُكْرَهٌ':Added, #1: 1	غَيْرُ مُكْرَهَيْنِ
u'غير مُكْرَهٌ':Added, #1: 1	غَيْرُ مُكْرَهَيْنِ
u'غَيْرٌ مُكْرَهٌ':Added, #21: 21	غَيْرُ مُكْرَهٍ
u'غير مُكْرِهٌ':Added, #21: 21	غَيْرُ مُكْرَهٍ
u'غَيْرٌ مُكْرِهٌ':Added, #2: 2	غَيْرِ الْمُكْرِهِ
u'غير مُكْرَهٌ':Added, #2: 2	غَيْرِ الْمُكْرِهِ
u'غير مُكْرَهٌ':Added, #2: 2	غَيْرَ مُكْرَهَةٍ
u'غَيْرٌ مُكْرَهٌ':Added, #2: 2	غَيْرُ مُكْرَهَةٍ
u'غَيْرٌ مُكْرَهٌ':Added, #2: 2	غَيْرَ مُكْرَهَةٍ
u'غير مُكْرَهٌ':Added, #2: 2	غَيْرُ مُكْرَهَةٍ
u'غَيْرٌ مُكْرَهٌ':Added, #2: 2	غَيْرَ مُكْرَهَيْنِ
u'غير مُكْرَهٌ':Added, #2: 2	غَيْرَ مُكْرَهَيْنِ
u'غَيْرٌ مُكْرَهٌ':Added, #6: 6	غَيْرَ مُكْرَهٍ
u'غير مَكْرُوهٌ':Added, #6: 6	غَيْرَ مُكْرَهٍ
u'غَيْرٌ مَكْرُوهٌ':Added, #11: 11	غَيْرِ مَكْرُوهٍ
u'غير مَكْرُوهٌ':Added, #11: 11	غَيْرِ مَكْرُوهٍ
u'غَيْرٌ مَكْرُوهٌ':Added, #1: 1	غَيْرِ الْمَكْرُوهَةِ
u'غير مَكْرُوهٌ':Added, #1: 1	غَيْرِ الْمَكْرُوهَةِ
u'غَيْرٌ مَكْرُوهٌ':Added, #32: 32	غَيْرُ مَكْرُوهٍ
u'غير مَكْرُوهٌ':Added, #32: 32	غَيْرُ مَكْرُوهٍ
u'غَيْرٌ مَكْرُوهٌ':Added, #4: 4	غَيْرُ مَكْرُوهِ
u'غير مَكْرُوهٌ':Added, #4: 4	غَيْرُ مَكْرُوهِ
u'غَيْرٌ مَكْرُوهٌ':Added, #5: 5	غَيْرَ مَكْرُوهٍ
u'غير مَكْرُوهٌ':Added, #5: 5	غَيْرَ مَكْرُوهٍ
u'غَيْرٌ مَكْرُوهٌ':Added, #6: 6	غَيْرُ مَكْرُوهَةٍ
u'غير مَكْرُوهَةٌ':Added, #6: 6	غَيْرُ مَكْرُوهَةٍ
u'غَيْرٌ مَكْرُوهَةٌ':Added, #1: 1	غَيْرِ الْمَكْرُوهَةِ
u'غير مَكْرُوهَةٌ':Added, #1: 1	غَيْرِ الْمَكْرُوهَةِ
u'غَيْرٌ مَكْرُوهَةٌ':Added, #6: 6	غَيْرُ مَكْرُوهَةٍ
u'غير مُكَسَّرٌ':Added, #6: 6	غَيْرُ مَكْرُوهَةٍ
u'غَيْرٌ مُكَسَّرٌ':Added, #2: 2	غَيْرِ مُكَسَّرٍ
u'غير مَكْسُورٌ':Added, #2: 2	غَيْرِ مُكَسَّرٍ
u'غَيْرٌ مَكْسُورٌ':Added, #1: 1	غَيْرَ مَكْسُورَةٍ
u'غير مَكْسُورٌ':Added, #1: 1	غَيْرَ مَكْسُورَةٍ
u'غَيْرٌ مَكْسُورٌ':Added, #2: 2	غَيْرَ مَكْسُورٍ
u'غير مَكْشُوفٌ':Added, #2: 2	غَيْرَ مَكْسُورٍ
u'غَيْرٌ مَكْشُوفٌ':Added, #1: 1	غَيْرَ مَكْشُوفٍ
u'غير مُكَفِّنٌ':Added, #1: 1	غَيْرَ مَكْشُوفٍ
u'غَيْرٌ مُكَفِّنٌ':Added, #1: 1	غَيْرُ الْمُكَفِّنِ
u'غير مَكْفُولٌ':Added, #1: 1	غَيْرُ الْمُكَفِّنِ
u'غير مَكْفُولٌ':Added, #1: 1	غَيْرَ مَكْفُولٍ
u'غَيْرٌ مَكْفُولٌ':Added, #1: 1	غَيْرُ مَكْفُولٍ
u'غَيْرٌ مَكْفُولٌ':Added, #1: 1	غَيْرَ مَكْفُولٍ
u'غير مُكَلَّفٌ':Added, #1: 1	غَيْرُ مَكْفُولٍ
u'غَيْرٌ مُكَلَّفٌ':Added, #10: 10	غَيْرَ الْمُكَلَّفِ
u'غير مُكَلَّفٌ':Added, #10: 10	غَيْرَ الْمُكَلَّفِ
u'غير مُكَلَّفٌ':Added, #1: 1	غَيْرُ مُكَلَّفَةٍ
u'غَيْرٌ مُكَلَّفٌ':Added, #1: 1	غَيْرِ مُكَلَّفَةٍ
u'غَيْرٌ مُكَلَّفٌ':Added, #1: 1	غَيْرُ مُكَلَّفَةٍ
u'غير مُكَلَّفٌ':Added, #1: 1	غَيْرِ مُكَلَّفَةٍ
u'غَيْرٌ مُكَلَّفٌ':Added, #1: 1	غَيْرَ مُكَلَّفَيْنِ
u'غير مُكَلَّفٌ':Added, #1: 1	غَيْرَ مُكَلَّفَيْنِ
u'غَيْرٌ مُكَلَّفٌ':Added, #21: 21	غَيْرِ الْمُكَلَّفِ
u'غير مُكَلَّفٌ':Added, #21: 21	غَيْرِ الْمُكَلَّفِ
u'غَيْرٌ مُكَلَّفٌ':Added, #22: 22	غَيْرِ مُكَلَّفٍ
u'غير مُكَلَّفٌ':Added, #22: 22	غَيْرِ مُكَلَّفٍ
u'غَيْرٌ مُكَلَّفٌ':Added, #23: 23	غَيْرَ مُكَلَّفٍ
u'غير مُكَلَّفٌ':Added, #23: 23	غَيْرَ مُكَلَّفٍ
u'غَيْرٌ مُكَلَّفٌ':Added, #2: 2	غَيْرِ الْمُكَلَّفَةِ
u'غير مُكَلَّفٌ':Added, #2: 2	غَيْرِ الْمُكَلَّفَةِ
u'غَيْرٌ مُكَلَّفٌ':Added, #3: 3	غَيْرُ الْمُكَلَّفِ
u'غير مُكَلَّفٌ':Added, #3: 3	غَيْرُ الْمُكَلَّفِ
u'غَيْرٌ مُكَلَّفٌ':Added, #59: 59	غَيْرُ مُكَلَّفٍ
u'غير مَكِّيّ':Added, #59: 59	غَيْرُ مُكَلَّفٍ
u'غَيْرٌ مَكِّيّ':Added, #1: 1	غَيْرَ الْمَكِّيِّ
u'غير مَكِّيّ':Added, #1: 1	غَيْرَ الْمَكِّيِّ
u'غير مَكِّيّ':Added, #1: 1	غَيْرَ مَكِّيٍّ
u'غَيْرٌ مَكِّيّ':Added, #1: 1	غَيْرُ مَكِّيٍّ
u'غَيْرٌ مَكِّيّ':Added, #1: 1	غَيْرَ مَكِّيٍّ
u'غير مَكِّيّ':Added, #1: 1	غَيْرُ مَكِّيٍّ
u'غَيْرٌ مَكِّيّ':Added, #2: 2	غَيْرِ مَكِّيٍّ
u'غير مَكِّيّ':Added, #2: 2	غَيْرِ مَكِّيٍّ
u'غَيْرٌ مَكِّيّ':Added, #3: 3	غَيْرِ الْمَكِّيِّ
u'غير مُكَيَّفٌ':Added, #3: 3	غَيْرِ الْمَكِّيِّ
u'غَيْرٌ مُكَيَّفٌ':Added, #1: 1	غَيْرُ مُكَيَّفَةٍ
u'غير مَكِيلٌ':Added, #1: 1	غَيْرُ مُكَيَّفَةٍ
u'غَيْرٌ مَكِيلٌ':Added, #10: 10	غَيْرِ الْمَكِيلِ
u'غير مَكِيلٌ':Added, #10: 10	غَيْرِ الْمَكِيلِ
u'غَيْرٌ مَكِيلٌ':Added, #1: 1	غَيْرَ مَكِيلٍ
u'غير مَكِيل':Added, #1: 1	غَيْرَ مَكِيلٍ
u'غَيْرٌ مَكِيل':Added, #2: 2	غَيْرِ مَكِيلَةٍ
u'غير مَكِيلٌ':Added, #2: 2	غَيْرِ مَكِيلَةٍ
u'غَيْرٌ مَكِيلٌ':Added, #3: 3	غَيْرُ الْمَكِيلِ
u'غير مَكِيلٌ':Added, #3: 3	غَيْرُ الْمَكِيلِ
u'غَيْرٌ مَكِيلٌ':Added, #4: 4	غَيْرَ الْمَكِيلِ
u'غير مَكِيلٌ':Added, #4: 4	غَيْرَ الْمَكِيلِ
u'غَيْرٌ مَكِيلٌ':Added, #4: 4	غَيْرِ مَكِيلٍ
u'غير مُلاَءةٌ':Added, #4: 4	غَيْرِ مَكِيلٍ
u'غَيْرٌ مُلاَءةٌ':Added, #2: 2	غَيْرِ مُلَاءَةٍ
u'غير مُلاَبَسَةٌ':Added, #2: 2	غَيْرِ مُلَاءَةٍ
u'غَيْرٌ مُلاَبَسَةٌ':Added, #1: 1	غَيْرِ مُلَابَسَةٍ
u'غير مُلاَحَظَةٌ':Added, #1: 1	غَيْرِ مُلَابَسَةٍ
u'غَيْرٌ مُلاَحَظَةٌ':Added, #2: 2	غَيْرِ مُلَاحَظَةِ
u'غير مُلاَزِمٌ':Added, #2: 2	غَيْرِ مُلَاحَظَةِ
u'غَيْرٌ مُلاَزِمٌ':Added, #1: 1	غَيْرِ الْمُلَازِمِ
u'غير مُلاَزِمٌ':Added, #1: 1	غَيْرِ الْمُلَازِمِ
u'غَيْرٌ مُلاَزِمٌ':Added, #1: 1	غَيْرَ مُلازِمِ
u'غير مُلاَصِقٌ':Added, #1: 1	غَيْرَ مُلازِمِ
u'غَيْرٌ مُلاَصِقٌ':Added, #1: 1	غَيْرُ الْمُلَاصِقِ
u'غير مُلاَصِقٌ':Added, #1: 1	غَيْرُ الْمُلَاصِقِ
u'غَيْرٌ مُلاَصِقٌ':Added, #1: 1	غَيْرَ مُلَاصِقٍ
u'غير مِلاَطٌ':Added, #1: 1	غَيْرَ مُلَاصِقٍ
u'غَيْرٌ مِلاَطٌ':Added, #1: 1	غَيْرِ مِلَاطٍ
u'غير مُلاَقَاةٌ':Added, #1: 1	غَيْرِ مِلَاطٍ
u'غَيْرٌ مُلاَقَاةٌ':Added, #1: 1	غَيْرِ مُلَاقَاةٍ
u'غير مُلاَئِمٌ':Added, #1: 1	غَيْرِ مُلَاقَاةٍ
u'غَيْرٌ مُلاَئِمٌ':Added, #1: 1	غَيْرِ الْمُلَائِمِ
u'غير مُلاَئِمٌ':Added, #1: 1	غَيْرِ الْمُلَائِمِ
u'غَيْرٌ مُلاَئِمٌ':Added, #1: 1	غَيْرِ مُلَائِمٍ
u'غير مُلاَئِمٌ':Added, #1: 1	غَيْرِ مُلَائِمٍ
u'غَيْرٌ مُلاَئِمٌ':Added, #2: 2	غَيْرُ مُلَائِمَةٍ
u'غير مُلاَئِمٌ':Added, #2: 2	غَيْرُ مُلَائِمَةٍ
u'غَيْرٌ مُلاَئِمٌ':Added, #3: 3	غَيْرَ مُلَائِمٍ
u'غير مُلاَئِمٌ':Added, #3: 3	غَيْرَ مُلَائِمٍ
u'غَيْرٌ مُلاَئِمٌ':Added, #5: 5	غَيْرُ مُلَائِمٍ
u'غير مَلْبُوس':Added, #5: 5	غَيْرُ مُلَائِمٍ
u'غَيْرٌ مَلْبُوس':Added, #1: 1	غَيْرُ مَلْبُوسَةٍ
u'غير مَلْبُوس':Added, #1: 1	غَيْرُ مَلْبُوسَةٍ
u'غَيْرٌ مَلْبُوس':Added, #2: 2	غَيْرُ الْمَلْبُوسِ
u'غير مَلْبُوس':Added, #2: 2	غَيْرُ الْمَلْبُوسِ
u'غَيْرٌ مَلْبُوس':Added, #2: 2	غَيْرُ مَلْبُوسٍ
u'غير مِلَّةٌ':Added, #2: 2	غَيْرُ مَلْبُوسٍ
u'غَيْرٌ مِلَّةٌ':Added, #1: 1	غَيْرِ الْمِلَّةِ
u'غير مِلَّةٌ':Added, #1: 1	غَيْرِ الْمِلَّةِ
u'غَيْرٌ مِلَّةٌ':Added, #7: 7	غَيْرِ مِلَّةِ
u'غير مُلْتاث':Added, #7: 7	غَيْرِ مِلَّةِ
u'غَيْرٌ مُلْتاث':Added, #1: 1	غَيْرِ مُلْتَاثٍ
u'غير مُلْتَزِمٌ':Added, #1: 1	غَيْرِ مُلْتَاثٍ
u'غَيْرٌ مُلْتَزِمٌ':Added, #1: 1	غَيْرَ مُلْتَزِمٍ
u'غير مُلْتَزِمٌ':Added, #1: 1	غَيْرَ مُلْتَزِمٍ
u'غَيْرٌ مُلْتَزِمٌ':Added, #1: 1	غَيْرُ مُلْتَزِمَةِ
u'غير مُلْتَزِمٌ':Added, #1: 1	غَيْرُ مُلْتَزِمَةِ
u'غَيْرٌ مُلْتَزِمٌ':Added, #5: 5	غَيْرُ مُلْتَزِمٍ
u'غير مُلْتَصِقٌ':Added, #5: 5	غَيْرُ مُلْتَزِمٍ
u'غَيْرٌ مُلْتَصِقٌ':Added, #1: 1	غَيْرُ الْمُلْتَصِقَيْنِ
u'غير مُلْتَفِت':Added, #1: 1	غَيْرُ الْمُلْتَصِقَيْنِ
u'غَيْرٌ مُلْتَفِت':Added, #5: 5	غَيْرَ مُلْتَفِتٍ
u'غير مُلْتَقِط':Added, #5: 5	غَيْرَ مُلْتَفِتٍ
u'غَيْرٌ مُلْتَقِط':Added, #1: 1	غَيْرَ الْمُلْتَقِطِ
u'غير مُلْتَقِط':Added, #1: 1	غَيْرَ الْمُلْتَقِطِ
u'غَيْرٌ مُلْتَقِط':Added, #1: 1	غَيْرِ مُلْتَقِطٍ
u'غير مُلْتَقِط':Added, #1: 1	غَيْرِ مُلْتَقِطٍ
u'غَيْرٌ مُلْتَقِط':Added, #3: 3	غَيْرُ الْمُلْتَقِطِ
u'غير مُلْتَقِط':Added, #3: 3	غَيْرُ الْمُلْتَقِطِ
u'غَيْرٌ مُلْتَقِط':Added, #6: 6	غَيْرِ الْمُلْتَقِطِ
u'غير مُلْتَئِمٌ':Added, #6: 6	غَيْرِ الْمُلْتَقِطِ
u'غَيْرٌ مُلْتَئِمٌ':Added, #2: 2	غَيْرُ مُلْتَئِمٍ
u'غير مَلْجَأٌ':Added, #2: 2	غَيْرُ مُلْتَئِمٍ
u'غَيْرٌ مَلْجَأٌ':Added, #1: 1	غَيْرُ مَلْجَأٍ
u'غير مَلْحَظٌ':Added, #1: 1	غَيْرُ مَلْجَأٍ
u'غَيْرٌ مَلْحَظٌ':Added, #1: 1	غَيْرُ الْمَلْحَظِ
u'غير مَلْحَظٌ':Added, #1: 1	غَيْرُ الْمَلْحَظِ
u'غير مَلْحَظٌ':Added, #1: 1	غَيْرُ مَلْحَظٍ
u'غَيْرٌ مَلْحَظٌ':Added, #1: 1	غَيْرِ مَلْحَظِ
u'غَيْرٌ مَلْحَظٌ':Added, #1: 1	غَيْرُ مَلْحَظٍ
u'غير مَلْحَظٌ':Added, #1: 1	غَيْرِ مَلْحَظِ
u'غَيْرٌ مَلْحَظٌ':Added, #1: 1	غَيْرُ مَلْحَظِهِ
u'غير مَلْحَظٌ':Added, #1: 1	غَيْرُ مَلْحَظِهِ
u'غَيْرٌ مَلْحَظٌ':Added, #3: 3	غَيْرُ مَلْحَظِ
u'غير مُلْحَقٌ':Added, #3: 3	غَيْرُ مَلْحَظِ
u'غير مُلْحَقٌ':Added, #1: 1	غَيْرُ مُلْحَقٍ
u'غَيْرٌ مُلْحَقٌ':Added, #1: 1	غَيْرِ مُلْحَقٍ
u'غَيْرٌ مُلْحَقٌ':Added, #1: 1	غَيْرُ مُلْحَقٍ
u'غير مُلْحَقٌ':Added, #1: 1	غَيْرِ مُلْحَقٍ
u'غَيْرٌ مُلْحَقٌ':Added, #2: 2	غَيْرَ مُلْحَقٍ
u'غير مَلْحُوظٌ':Added, #2: 2	غَيْرَ مُلْحَقٍ
u'غَيْرٌ مَلْحُوظٌ':Added, #2: 2	غَيْرُ مَلْحُوظٍ
u'غير مُلْزِمٌ':Added, #2: 2	غَيْرُ مَلْحُوظٍ
u'غَيْرٌ مُلْزِمٌ':Added, #13: 13	غَيْرُ مُلْزِمٍ
u'غير مُلْزَمٌ':Added, #13: 13	غَيْرُ مُلْزِمٍ
u'غَيْرٌ مُلْزَمٌ':Added, #1: 1	غَيْرِ الْمُلْزَمِ
u'غير مُلْزِمٌ':Added, #1: 1	غَيْرِ الْمُلْزَمِ
u'غَيْرٌ مُلْزِمٌ':Added, #1: 1	غَيْرَ مُلْزِمٍ
u'غير مُلْزَمٌ':Added, #1: 1	غَيْرَ مُلْزِمٍ
u'غَيْرٌ مُلْزَمٌ':Added, #3: 3	غَيْرُ مُلْزَمٍ
u'غير مُلْزِمٌ':Added, #3: 3	غَيْرُ مُلْزَمٍ
u'غَيْرٌ مُلْزِمٌ':Added, #4: 4	غَيْرُ مُلْزِمَةٍ
u'غير مَلْزُوم':Added, #4: 4	غَيْرُ مُلْزِمَةٍ
u'غَيْرٌ مَلْزُوم':Added, #3: 3	غَيْرُ مَلْزُومٍ
u'غير مُلَفَّقٌ':Added, #3: 3	غَيْرُ مَلْزُومٍ
u'غَيْرٌ مُلَفَّقٌ':Added, #2: 2	غَيْرَ مُلَفَّقَةٍ
u'غير مَلْفُوظٌ':Added, #2: 2	غَيْرَ مُلَفَّقَةٍ
u'غَيْرٌ مَلْفُوظٌ':Added, #2: 2	غَيْرِ الْمَلْفُوظِ
u'غير مَلْفُوظٌ':Added, #2: 2	غَيْرِ الْمَلْفُوظِ
u'غَيْرٌ مَلْفُوظٌ':Added, #2: 2	غَيْرَ مَلْفُوظٍ
u'غير مَلْفُوظٌ':Added, #2: 2	غَيْرَ مَلْفُوظٍ
u'غَيْرٌ مَلْفُوظٌ':Added, #6: 6	غَيْرُ مَلْفُوظٍ
u'غير مِلْكٌ':Added, #6: 6	غَيْرُ مَلْفُوظٍ
u'غَيْرٌ مِلْكٌ':Added, #18: 18	غَيْرِ مِلْكٍ
u'غير مَلَكٌ':Added, #18: 18	غَيْرِ مِلْكٍ
u'غَيْرٌ مَلَكٌ':Added, #1: 1	غَيْرُ الْمَلَكَيْنِ
u'غير مِلْكٌ':Added, #1: 1	غَيْرُ الْمَلَكَيْنِ
u'غَيْرٌ مِلْكٌ':Added, #1: 1	غَيْرَ مِلْكِ
u'غير مِلْكٌ':Added, #1: 1	غَيْرَ مِلْكِ
u'غَيْرٌ مِلْكٌ':Added, #2: 2	غَيْرَ مِلْكِهِ
u'غير مِلْكٌ':Added, #2: 2	غَيْرَ مِلْكِهِ
u'غَيْرٌ مِلْكٌ':Added, #3: 3	غَيْرُ مِلْكِهِ
u'غير مِلْكٌ':Added, #3: 3	غَيْرُ مِلْكِهِ
u'غَيْرٌ مِلْكٌ':Added, #72: 72	غَيْرِ الْمِلْكِ
u'غير مِلْكٌ':Added, #72: 72	غَيْرِ الْمِلْكِ
u'غَيْرٌ مِلْكٌ':Added, #90: 90	غَيْرِ مِلْكِهِ
u'غير مِلْكٌ':Added, #90: 90	غَيْرِ مِلْكِهِ
u'غَيْرٌ مِلْكٌ':Added, #9: 9	غَيْرِ مِلْكِ
u'غير مَلْمُوسٌ':Added, #9: 9	غَيْرِ مِلْكِ
u'غَيْرٌ مَلْمُوسٌ':Added, #1: 1	غَيْرُ الْمَلْمُوسَةِ
u'غير مَلْمُوسٌ':Added, #1: 1	غَيْرُ الْمَلْمُوسَةِ
u'غَيْرٌ مَلْمُوسٌ':Added, #1: 1	غَيْرَ مَلْمُوسَةٍ
u'غير مَلْمُوسٌ':Added, #1: 1	غَيْرَ مَلْمُوسَةٍ
u'غَيْرٌ مَلْمُوسٌ':Added, #2: 2	غَيْرُ مَلْمُوسَةٍ
u'غير مُلَوَّثٌ':Added, #2: 2	غَيْرُ مَلْمُوسَةٍ
u'غَيْرٌ مُلَوَّثٌ':Added, #1: 1	غَيْرُ الْمُلَوَّثِ
u'غير مُلَوَّثٌ':Added, #1: 1	غَيْرُ الْمُلَوَّثِ
u'غَيْرٌ مُلَوَّثٌ':Added, #2: 2	غَيْرِ الْمُلَوَّثِ
u'غير مُلُوكٌ':Added, #2: 2	غَيْرِ الْمُلَوَّثِ
u'غَيْرٌ مُلُوكٌ':Added, #1: 1	غَيْرُ الْمُلُوكِ
u'غير مَلُومٌ':Added, #1: 1	غَيْرُ الْمُلُوكِ
u'غَيْرٌ مَلُومٌ':Added, #1: 1	غَيْرُ مَلُومٍ
u'غير مَلُومٌ':Added, #1: 1	غَيْرُ مَلُومٍ
u'غَيْرٌ مَلُومٌ':Added, #1: 1	غَيْرَ مَلُومَةٍ
u'غير مَلُومٌ':Added, #1: 1	غَيْرَ مَلُومَةٍ
u'غَيْرٌ مَلُومٌ':Added, #2: 2	غَيْرَ مَلُومٍ
u'غير مَلِيءٌ':Added, #2: 2	غَيْرَ مَلُومٍ
u'غَيْرٌ مَلِيءٌ':Added, #2: 2	غَيْرِ الْمَلِيءِ
u'غير مُمَاثِلٌ':Added, #2: 2	غَيْرِ الْمَلِيءِ
u'غَيْرٌ مُمَاثِلٌ':Added, #1: 1	غَيْرَ الْمُمَاثِلَةِ
u'غير مُمَاسَّةٌ':Added, #1: 1	غَيْرَ الْمُمَاثِلَةِ
u'غَيْرٌ مُمَاسَّةٌ':Added, #1: 1	غَيْرِ مُمَاسَّةٍ
u'غير مُمَاطِلٌ':Added, #1: 1	غَيْرِ مُمَاسَّةٍ
u'غَيْرٌ مُمَاطِلٌ':Added, #3: 3	غَيْرُ مُمَاطِلٍ
u'غير مَمَالِيكُ':Added, #3: 3	غَيْرُ مُمَاطِلٍ
u'غَيْرٌ مَمَالِيكُ':Added, #1: 1	غَيْرَ مَمَالِيكِهِ
u'غير مُمْتَازٌ':Added, #1: 1	غَيْرَ مَمَالِيكِهِ
u'غَيْرٌ مُمْتَازٌ':Added, #1: 1	غَيْرُ مُمْتَازٍ
u'غير مُمْتَازٌ':Added, #1: 1	غَيْرُ مُمْتَازٍ
u'غَيْرٌ مُمْتَازٌ':Added, #1: 1	غَيْرُ مُمْتَازَةٍ
u'غير مُمْتَثِل':Added, #1: 1	غَيْرُ مُمْتَازَةٍ
u'غَيْرٌ مُمْتَثِل':Added, #1: 1	غَيْرَ مُمْتَثِلٍ
u'غير مُمْتَثِل':Added, #1: 1	غَيْرَ مُمْتَثِلٍ
u'غَيْرٌ مُمْتَثِل':Added, #1: 1	غَيْرَ مُمْتَثِلَةٍ
u'غير مُمْتَثِل':Added, #1: 1	غَيْرَ مُمْتَثِلَةٍ
u'غَيْرٌ مُمْتَثِل':Added, #2: 2	غَيْرُ مُمْتَثِلٍ
u'غير مُمْتَحِنٌ':Added, #2: 2	غَيْرُ مُمْتَثِلٍ
u'غَيْرٌ مُمْتَحِنٌ':Added, #1: 1	غَيْرَ مُمْتَحِنٍ
u'غير مُمْتَدٌّ':Added, #1: 1	غَيْرَ مُمْتَحِنٍ
u'غير مُمْتَدٌّ':Added, #3: 3	غَيْرَ مُمْتَدٍّ
u'غَيْرٌ مُمْتَدٌّ':Added, #3: 3	غَيْرِ مُمْتَدٍّ
u'غَيْرٌ مُمْتَدٌّ':Added, #3: 3	غَيْرَ مُمْتَدٍّ
u'غير مُمْتَدٌّ':Added, #3: 3	غَيْرِ مُمْتَدٍّ
u'غَيْرٌ مُمْتَدٌّ':Added, #4: 4	غَيْرِ الْمُمْتَدِّ
u'غير مُمْتَدٌّ':Added, #4: 4	غَيْرِ الْمُمْتَدِّ
u'غَيْرٌ مُمْتَدٌّ':Added, #5: 5	غَيْرُ مُمْتَدٍّ
u'غير مُمْتَنِعٌ':Added, #5: 5	غَيْرُ مُمْتَدٍّ
u'غَيْرٌ مُمْتَنِعٌ':Added, #31: 31	غَيْرُ مُمْتَنِعٍ
u'غير مُمْتَنِعٌ':Added, #31: 31	غَيْرُ مُمْتَنِعٍ
u'غَيْرٌ مُمْتَنِعٌ':Added, #3: 3	غَيْرُ مُمْتَنِعَةٍ
u'غير مُمْتَنِعٌ':Added, #3: 3	غَيْرُ مُمْتَنِعَةٍ
u'غَيْرٌ مُمْتَنِعٌ':Added, #5: 5	غَيْرِ مُمْتَنِعٍ
u'غير مُمْتَنِعٌ':Added, #5: 5	غَيْرِ مُمْتَنِعٍ
u'غَيْرٌ مُمْتَنِعٌ':Added, #9: 9	غَيْرَ مُمْتَنِعٍ
u'غير مُمْتَهَنٌ':Added, #9: 9	غَيْرَ مُمْتَنِعٍ
u'غَيْرٌ مُمْتَهَنٌ':Added, #1: 1	غَيْرَ مُمْتَهَنٍ
u'غير مُمَدَّدٌ':Added, #1: 1	غَيْرَ مُمْتَهَنٍ
u'غَيْرٌ مُمَدَّدٌ':Added, #1: 1	غَيْرَ مُمَدَّدَةٍ
u'غير مَمْدوحٌ':Added, #1: 1	غَيْرَ مُمَدَّدَةٍ
u'غير مَمْدوحٌ':Added, #1: 1	غَيْرُ مَمْدُوحٍ
u'غَيْرٌ مَمْدوحٌ':Added, #1: 1	غَيْرِ مَمْدُوحٍ
u'غَيْرٌ مَمْدوحٌ':Added, #1: 1	غَيْرُ مَمْدُوحٍ
u'غير مَمْدُودٌ':Added, #1: 1	غَيْرِ مَمْدُوحٍ
u'غَيْرٌ مَمْدُودٌ':Added, #1: 1	غَيْرَ مَمْدُودَةٍ
u'غير مَمْدُودٌ':Added, #1: 1	غَيْرَ مَمْدُودَةٍ
u'غَيْرٌ مَمْدُودٌ':Added, #3: 3	غَيْرِ مَمْدُودٍ
u'غير مَمْدُودٌ':Added, #3: 3	غَيْرِ مَمْدُودٍ
u'غَيْرٌ مَمْدُودٌ':Added, #4: 4	غَيْرَ مَمْدُودٍ
u'غير مَمَرٌّ':Added, #4: 4	غَيْرَ مَمْدُودٍ
u'غَيْرٌ مَمَرٌّ':Added, #2: 2	غَيْرِ مَمَرِّ
u'غير مُمْسِكٌ':Added, #2: 2	غَيْرِ مَمَرِّ
u'غَيْرٌ مُمْسِكٌ':Added, #1: 1	غَيْرَ مُمْسِكَةٍ
u'غير مَمْسُوس':Added, #1: 1	غَيْرَ مُمْسِكَةٍ
u'غَيْرٌ مَمْسُوس':Added, #1: 1	غَيْرُ الْمَمْسُوسَةِ
u'غير مَمْسُوس':Added, #1: 1	غَيْرُ الْمَمْسُوسَةِ
u'غير مَمْسُوس':Added, #1: 1	غَيْرَ مَمْسُوسَةٍ
u'غَيْرٌ مَمْسُوس':Added, #1: 1	غَيْرِ مَمْسُوسَةٍ
u'غَيْرٌ مَمْسُوس':Added, #1: 1	غَيْرَ مَمْسُوسَةٍ
u'غير مَمْسُوس':Added, #1: 1	غَيْرِ مَمْسُوسَةٍ
u'غَيْرٌ مَمْسُوس':Added, #4: 4	غَيْرِ الْمَمْسُوسَةِ
u'غير مَمْقُوتٌ':Added, #4: 4	غَيْرِ الْمَمْسُوسَةِ
u'غَيْرٌ مَمْقُوتٌ':Added, #1: 1	غَيْرَ مَمْقُوتِ
u'غير مُمْكِنٌ':Added, #1: 1	غَيْرَ مَمْقُوتِ
u'غير مُمْكِن':Added, #131: 131	غَيْرُ مُمْكِنٍ
u'غَيْرٌ مُمْكِنٌ':Added, #131: 131	غَيْرُ مُمْكِنٍ
u'غَيْرٌ مُمْكِن':Added, #131: 131	غَيْرُ مُمْكِنٍ
u'غير مُمْكِنٌ':Added, #131: 131	غَيْرُ مُمْكِنٍ
u'غير مُمْكِنٌ':Added, #2: 2	غَيْرَ مُمْكِنِ
u'غير مُمْكِن':Added, #2: 2	غَيْرِ مُمْكِنٍ
u'غير مُمْكِن':Added, #2: 2	غَيْرَ مُمْكِنِ
u'غَيْرٌ مُمْكِنٌ':Added, #2: 2	غَيْرِ مُمْكِنٍ
u'غَيْرٌ مُمْكِنٌ':Added, #2: 2	غَيْرَ مُمْكِنِ
u'غَيْرٌ مُمْكِن':Added, #2: 2	غَيْرِ مُمْكِنٍ
u'غَيْرٌ مُمْكِن':Added, #2: 2	غَيْرَ مُمْكِنِ
u'غير مُمْكِنٌ':Added, #2: 2	غَيْرِ مُمْكِنٍ
u'غَيْرٌ مُمْكِنٌ':Added, #2: 2	غَيْرُ مُمْكِنَةٍ
u'غير مُمْكِنٌ':Added, #2: 2	غَيْرُ مُمْكِنَةٍ
u'غير مُمْكِن':Added, #4: 4	غَيْرُ مُمْكِنِ
u'غَيْرٌ مُمْكِنٌ':Added, #4: 4	غَيْرُ مُمْكِنِ
u'غَيْرٌ مُمْكِن':Added, #4: 4	غَيْرُ مُمْكِنِ
u'غير مُمْكِنٌ':Added, #4: 4	غَيْرُ مُمْكِنِ
u'غير مُمْكِن':Added, #7: 7	غَيْرَ مُمْكِنٍ
u'غَيْرٌ مُمْكِنٌ':Added, #7: 7	غَيْرَ مُمْكِنٍ
u'غَيْرٌ مُمْكِن':Added, #7: 7	غَيْرَ مُمْكِنٍ
u'غير مَمْلُوءٌ':Added, #7: 7	غَيْرَ مُمْكِنٍ
u'غَيْرٌ مَمْلُوءٌ':Added, #1: 1	غَيْرَ مَمْلُوءٍ
u'غير مَمْلُوكٌ':Added, #1: 1	غَيْرَ مَمْلُوءٍ
u'غَيْرٌ مَمْلُوكٌ':Added, #14: 14	غَيْرِ مَمْلُوكَةٍ
u'غير مَمْلُوكٌ':Added, #14: 14	غَيْرِ مَمْلُوكَةٍ
u'غَيْرٌ مَمْلُوكٌ':Added, #1: 1	غَيْر الْمَمْلُوكِ
u'غير مَمْلُوكٌ':Added, #1: 1	غَيْر الْمَمْلُوكِ
u'غَيْرٌ مَمْلُوكٌ':Added, #1: 1	غَيْرُ مَمْلُوكَاتٍ
u'غير مَمْلُوكٌ':Added, #1: 1	غَيْرُ مَمْلُوكَاتٍ
u'غير مَمْلُوكٌ':Added, #1: 1	غَيْرَ مَمْلُوكِهِ
u'غَيْرٌ مَمْلُوكٌ':Added, #1: 1	غَيْرِ مَمْلُوكِهِ
u'غَيْرٌ مَمْلُوكٌ':Added, #1: 1	غَيْرَ مَمْلُوكِهِ
u'غير مَمْلُوكٌ':Added, #1: 1	غَيْرِ مَمْلُوكِهِ
u'غَيْرٌ مَمْلُوكٌ':Added, #21: 21	غَيْرِ مَمْلُوكٍ
u'غير مَمْلُوكٌ':Added, #21: 21	غَيْرِ مَمْلُوكٍ
u'غَيْرٌ مَمْلُوكٌ':Added, #24: 24	غَيْرُ مَمْلُوكَةٍ
u'غير مَمْلُوكٌ':Added, #24: 24	غَيْرُ مَمْلُوكَةٍ
u'غَيْرٌ مَمْلُوكٌ':Added, #26: 26	غَيْرَ مَمْلُوكٍ
u'غير مَمْلُوكٌ':Added, #26: 26	غَيْرَ مَمْلُوكٍ
u'غَيْرٌ مَمْلُوكٌ':Added, #2: 2	غَيْرِ الْمَمْلُوكَةِ
u'غير مَمْلُوكٌ':Added, #2: 2	غَيْرِ الْمَمْلُوكَةِ
u'غَيْرٌ مَمْلُوكٌ':Added, #3: 3	غَيْرُ الْمَمْلُوكِ
u'غير مَمْلُوكٌ':Added, #3: 3	غَيْرُ الْمَمْلُوكِ
u'غير مَمْلُوكٌ':Added, #5: 5	غَيْرَ الْمَمْلُوكِ
u'غَيْرٌ مَمْلُوكٌ':Added, #5: 5	غَيْرِ الْمَمْلُوكِ
u'غَيْرٌ مَمْلُوكٌ':Added, #5: 5	غَيْرَ الْمَمْلُوكِ
u'غير مَمْلُوكٌ':Added, #5: 5	غَيْرِ الْمَمْلُوكِ
u'غَيْرٌ مَمْلُوكٌ':Added, #6: 6	غَيْرَ مَمْلُوكَةٍ
u'غير مَمْلُوكٌ':Added, #6: 6	غَيْرَ مَمْلُوكَةٍ
u'غَيْرٌ مَمْلُوكٌ':Added, #87: 87	غَيْرُ مَمْلُوكٍ
u'غير مَمْنُوعٌ':Added, #87: 87	غَيْرُ مَمْلُوكٍ
u'غَيْرٌ مَمْنُوعٌ':Added, #1: 1	غَيْرَ مَمْنُوعٍ
u'غير مَمْنُوعٌ':Added, #1: 1	غَيْرَ مَمْنُوعٍ
u'غَيْرٌ مَمْنُوعٌ':Added, #23: 23	غَيْرُ مَمْنُوعٍ
u'غير مَمْنُوعٌ':Added, #23: 23	غَيْرُ مَمْنُوعٍ
u'غَيْرٌ مَمْنُوعٌ':Added, #2: 2	غَيْرُ مَمْنُوعَةٍ
u'غير مَمْنُونٌ':Added, #2: 2	غَيْرُ مَمْنُوعَةٍ
u'غَيْرٌ مَمْنُونٌ':Added, #1: 1	غَيْرَ مَمْنُونٍ
u'غير مَمْنُونٌ':Added, #1: 1	غَيْرَ مَمْنُونٍ
u'غَيْرٌ مَمْنُونٌ':Added, #3: 3	غَيْرُ مَمْنُونٍ
u'غير مُمَيِّزٌ':Added, #3: 3	غَيْرُ مَمْنُونٍ
u'غَيْرٌ مُمَيِّزٌ':Added, #10: 10	غَيْرِ الْمُمَيِّزَةِ
u'غير مُمَيِّزٌ':Added, #10: 10	غَيْرِ الْمُمَيِّزَةِ
u'غَيْرٌ مُمَيِّزٌ':Added, #14: 14	غَيْرُ الْمُمَيِّزِ
u'غير مُمَيَّزٌ':Added, #14: 14	غَيْرُ الْمُمَيِّزِ
u'غَيْرٌ مُمَيَّزٌ':Added, #1: 1	غَيْرَ الْمُمَيَّزِ
u'غير مُمَيِّزٌ':Added, #1: 1	غَيْرَ الْمُمَيَّزِ
u'غَيْرٌ مُمَيِّزٌ':Added, #1: 1	غَيْرَ الْمُمَيِّزَةِ
u'غير مُمَيَّزٌ':Added, #1: 1	غَيْرَ الْمُمَيِّزَةِ
u'غير مُمَيَّزٌ':Added, #1: 1	غَيْرَ مُمَيَّزٍ
u'غير مُمَيِّزٌ':Added, #1: 1	غَيْرُ مُمَيّزٍ
u'غَيْرٌ مُمَيَّزٌ':Added, #1: 1	غَيْرُ مُمَيّزٍ
u'غَيْرٌ مُمَيَّزٌ':Added, #1: 1	غَيْرَ مُمَيَّزٍ
u'غَيْرٌ مُمَيِّزٌ':Added, #1: 1	غَيْرُ مُمَيّزٍ
u'غير مُمَيِّزٌ':Added, #1: 1	غَيْرُ مُمَيّزٍ
u'غَيْرٌ مُمَيِّزٌ':Added, #1: 1	غَيْرَ مُمَيِّزَيْنِ
u'غير مُمَيِّزٌ':Added, #1: 1	غَيْرَ مُمَيِّزَيْنِ
u'غَيْرٌ مُمَيِّزٌ':Added, #20: 20	غَيْرِ الْمُمَيِّزِ
u'غير مُمَيِّزٌ':Added, #20: 20	غَيْرِ الْمُمَيِّزِ
u'غَيْرٌ مُمَيِّزٌ':Added, #21: 21	غَيْرَ مُمَيِّزَةٍ
u'غير مُمَيِّزٌ':Added, #21: 21	غَيْرَ مُمَيِّزَةٍ
u'غَيْرٌ مُمَيِّزٌ':Added, #28: 28	غَيْرُ مُمَيِّزَةٍ
u'غير مُمَيِّزٌ':Added, #28: 28	غَيْرُ مُمَيِّزَةٍ
u'غَيْرٌ مُمَيِّزٌ':Added, #2: 2	غَيْرَ الْمُمَيِّزِ
u'غير مُمَيِّزٌ':Added, #2: 2	غَيْرَ الْمُمَيِّزِ
u'غَيْرٌ مُمَيِّزٌ':Added, #34: 34	غَيْرَ مُمَيِّزٍ
u'غير مُمَيَّزٌ':Added, #34: 34	غَيْرَ مُمَيِّزٍ
u'غَيْرٌ مُمَيَّزٌ':Added, #3: 3	غَيْرِ مُمَيَّزٍ
u'غير مُمَيِّزٌ':Added, #3: 3	غَيْرِ مُمَيَّزٍ
u'غَيْرٌ مُمَيِّزٌ':Added, #3: 3	غَيْرِ مُمَيِّزَةٍ
u'غير مُمَيِّزٌ':Added, #3: 3	غَيْرِ مُمَيِّزَةٍ
u'غَيْرٌ مُمَيِّزٌ':Added, #4: 4	غَيْرُ الْمُمَيِّزَةِ
u'غير مُمَيِّزٌ':Added, #4: 4	غَيْرُ الْمُمَيِّزَةِ
u'غير مُمَيِّزٌ':Added, #6: 6	غَيْرُ مُمَيِّزٍ
u'غَيْرٌ مُمَيِّزٌ':Added, #6: 6	غَيْرِ مُمَيِّزٍ
u'غَيْرٌ مُمَيِّزٌ':Added, #6: 6	غَيْرُ مُمَيِّزٍ
u'غير مَنٌّ':Added, #6: 6	غَيْرِ مُمَيِّزٍ
u'غَيْرٌ مَنٌّ':Added, #1: 1	غَيْرُ الْمَنِّ
u'غير مُنَادَاةٌ':Added, #1: 1	غَيْرُ الْمَنِّ
u'غير مُنَادَاةٌ':Added, #1: 1	غَيْرَ الْمُنَادَاةِ
u'غَيْرٌ مُنَادَاةٌ':Added, #1: 1	غَيْرُ الْمُنَادَاةِ
u'غَيْرٌ مُنَادَاةٌ':Added, #1: 1	غَيْرَ الْمُنَادَاةِ
u'غَيَّرَ مَنَارٌ':Predicate, #1: 1	غَيْرُ الْمُنَادَاةِ
u'غير مُنَازَعٌ':Added, #6: 6	غَيَّرَ مَنَارَ
u'غَيْرٌ مُنَازَعٌ':Added, #1: 1	غَيْرُ مُنَازَعٍ
u'غير مُنَازِعٌ':Added, #1: 1	غَيْرُ مُنَازَعٍ
u'غَيْرٌ مُنَازِعٌ':Added, #2: 2	غَيْرِ مُنَازِعٍ
u'غير مُنَازَعٌ':Added, #2: 2	غَيْرِ مُنَازِعٍ
u'غَيْرٌ مُنَازَعٌ':Added, #4: 4	غَيْرِ مُنَازَعَةٍ
u'غير مُنَازَعَةٌ':Added, #4: 4	غَيْرِ مُنَازَعَةٍ
u'غَيْرٌ مُنَازَعَةٌ':Added, #4: 4	غَيْرِ مُنَازَعَةٍ
u'غير مُنَاسِبٌ':Added, #4: 4	غَيْرِ مُنَازَعَةٍ
u'غَيْرٌ مُنَاسِبٌ':Added, #11: 11	غَيْرُ مُنَاسِبٍ
u'غير مُنَاسِبٌ':Added, #11: 11	غَيْرُ مُنَاسِبٍ
u'غير مُنَاسِبٌ':Added, #1: 1	غَيْرُ الْمُنَاسِبِ
u'غَيْرٌ مُنَاسِبٌ':Added, #1: 1	غَيْرِ الْمُنَاسِبِ
u'غَيْرٌ مُنَاسِبٌ':Added, #1: 1	غَيْرُ الْمُنَاسِبِ
u'غير مُنَاسِبٌ':Added, #1: 1	غَيْرِ الْمُنَاسِبِ
u'غَيْرٌ مُنَاسِبٌ':Added, #1: 1	غَيْرِ الْمُنَاسِبَةِ
u'غير مُنَاسِبٌ':Added, #1: 1	غَيْرِ الْمُنَاسِبَةِ
u'غَيْرٌ مُنَاسِبٌ':Added, #3: 3	غَيْرَ مُنَاسِبٍ
u'غير مَنَاسِكُ':Added, #3: 3	غَيْرَ مُنَاسِبٍ
u'غَيْرٌ مَنَاسِكُ':Added, #2: 2	غَيْرِ الْمَنَاسِكِ
u'غير مُنَاشَدَةٌ':Added, #2: 2	غَيْرِ الْمَنَاسِكِ
u'غَيْرٌ مُنَاشَدَةٌ':Added, #1: 1	غَيْرِ مُنَاشَدَةٍ
u'غير مُنَافَسَةٌ':Added, #1: 1	غَيْرِ مُنَاشَدَةٍ
u'غَيْرٌ مُنَافَسَةٌ':Added, #1: 1	غَيْرُ الْمُنَافَسَةِ
u'غير مَنَافِعُ':Added, #1: 1	غَيْرُ الْمُنَافَسَةِ
u'غَيْرٌ مَنَافِعُ':Added, #1: 1	غَيْرِ الْمَنَافِعِ
u'غير مُنَافِي':Added, #1: 1	غَيْرِ الْمَنَافِعِ
u'غَيْرٌ مُنَافِي':Added, #1: 1	غَيْرُ مُنَافِيَةٍ
u'غير مُنَاقِضٌ':Added, #1: 1	غَيْرُ مُنَافِيَةٍ
u'غَيْرٌ مُنَاقِضٌ':Added, #1: 1	غَيْرَ مُنَاقِضٍ
u'غير مُنَاقِضٌ':Added, #1: 1	غَيْرَ مُنَاقِضٍ
u'غَيْرٌ مُنَاقِضٌ':Added, #1: 1	غَيْرَ مُنَاقِضَةٍ
u'غير مُناوَلَة':Added, #1: 1	غَيْرَ مُنَاقِضَةٍ
u'غَيْرٌ مُناوَلَة':Added, #1: 1	غَيْرِ مُنَاوَلَةٍ
u'غير مِنْبَرٌ':Added, #1: 1	غَيْرِ مُنَاوَلَةٍ
u'غَيْرٌ مِنْبَرٌ':Added, #1: 1	غَيْرِ مِنْبَرٍ
u'غير مُنْبَسِطٌ':Added, #1: 1	غَيْرِ مِنْبَرٍ
u'غَيْرٌ مُنْبَسِطٌ':Added, #2: 2	غَيْرُ مُنْبَسِطَةٍ
u'غير مُنْتِجٌ':Added, #2: 2	غَيْرُ مُنْبَسِطَةٍ
u'غَيْرٌ مُنْتِجٌ':Added, #2: 2	غَيْرُ مُنْتِجٍ
u'غير مُنْتَخَبٌ':Added, #2: 2	غَيْرُ مُنْتِجٍ
u'غَيْرٌ مُنْتَخَبٌ':Added, #1: 1	غَيْرِ الْمُنْتَخَبِ
u'غير مُنْتَزَع':Added, #1: 1	غَيْرِ الْمُنْتَخَبِ
u'غَيْرٌ مُنْتَزَع':Added, #1: 1	غَيْرِ مُنْتَزَعٍ
u'غير مُنْتَسِبٌ':Added, #1: 1	غَيْرِ مُنْتَزَعٍ
u'غَيْرٌ مُنْتَسِبٌ':Added, #1: 1	غَيْرَ الْمُنْتَسِبِ
u'غير مُنْتَشِر':Added, #1: 1	غَيْرَ الْمُنْتَسِبِ
u'غَيْرٌ مُنْتَشِر':Added, #1: 1	غَيْرِ مُنْتَشِرٍ
u'غير مُنْتَشِر':Added, #1: 1	غَيْرِ مُنْتَشِرٍ
u'غير مُنْتَشِر':Added, #1: 1	غَيْرَ مُنْتَشِرَةٍ
u'غَيْرٌ مُنْتَشِر':Added, #1: 1	غَيْرِ مُنْتَشِرَةٍ
u'غَيْرٌ مُنْتَشِر':Added, #1: 1	غَيْرَ مُنْتَشِرَةٍ
u'غير مُنْتَشِر':Added, #1: 1	غَيْرِ مُنْتَشِرَةٍ
u'غَيْرٌ مُنْتَشِر':Added, #5: 5	غَيْرَ مُنْتَشِرٍ
u'غير مُنْتَصِبٌ':Added, #5: 5	غَيْرَ مُنْتَشِرٍ
u'غَيْرٌ مُنْتَصِبٌ':Added, #1: 1	غَيْرِ الْمُنْتَصِبِ
u'غير مُنْتَصِبٌ':Added, #1: 1	غَيْرِ الْمُنْتَصِبِ
u'غَيْرٌ مُنْتَصِبٌ':Added, #2: 2	غَيْرَ مُنْتَصِبٍ
u'غير مُنْتَظِمٌ':Added, #2: 2	غَيْرَ مُنْتَصِبٍ
u'غير مُنْتَظِمٌ':Added, #1: 1	غَيْرَ مُنْتَظِمٍ
u'غَيْرٌ مُنْتَظِمٌ':Added, #1: 1	غَيْرِ مُنْتَظِمٍ
u'غَيْرٌ مُنْتَظِمٌ':Added, #1: 1	غَيْرَ مُنْتَظِمٍ
u'غير مُنْتَظِمٌ':Added, #1: 1	غَيْرِ مُنْتَظِمٍ
u'غير مُنْتَظِمٌ':Added, #1: 1	غَيْرَ مُنْتَظِمَةٍ
u'غير مُنْتَظِمٌ':Added, #1: 1	غَيْرُ مُنْتَظِمَةٍ
u'غَيْرٌ مُنْتَظِمٌ':Added, #1: 1	غَيْرِ مُنْتَظِمَةِ
u'غَيْرٌ مُنْتَظِمٌ':Added, #1: 1	غَيْرَ مُنْتَظِمَةٍ
u'غَيْرٌ مُنْتَظِمٌ':Added, #1: 1	غَيْرُ مُنْتَظِمَةٍ
u'غير مُنْتَظِمٌ':Added, #1: 1	غَيْرِ مُنْتَظِمَةِ
u'غَيْرٌ مُنْتَظِمٌ':Added, #4: 4	غَيْرُ مُنْتَظِمٍ
u'غير مُنْتَفِخٌ':Added, #4: 4	غَيْرُ مُنْتَظِمٍ
u'غَيْرٌ مُنْتَفِخٌ':Added, #2: 2	غَيْرَ مُنْتَفِخَةٍ
u'غير مُنْتَفِعٌ':Added, #2: 2	غَيْرَ مُنْتَفِخَةٍ
u'غَيْرٌ مُنْتَفِعٌ':Added, #4: 4	غَيْرُ مُنْتَفِعٍ
u'غير مُنْتَقِلٌ':Added, #4: 4	غَيْرُ مُنْتَفِعٍ
u'غَيْرٌ مُنْتَقِلٌ':Added, #1: 1	غَيْرُ الْمُنْتَقِلِ
u'غير مُنْتَقِلٌ':Added, #1: 1	غَيْرُ الْمُنْتَقِلِ
u'غَيْرٌ مُنْتَقِلٌ':Added, #1: 1	غَيْرَ مُنْتَقِلٍ
u'غير مُنْتَقِلٌ':Added, #1: 1	غَيْرَ مُنْتَقِلٍ
u'غَيْرٌ مُنْتَقِلٌ':Added, #1: 1	غَيْرُ مُنْتَقِلَةٍ
u'غير مُنْتَهِكٌ':Added, #1: 1	غَيْرُ مُنْتَقِلَةٍ
u'غَيْرٌ مُنْتَهِكٌ':Added, #1: 1	غَيْرِ مُنْتَهِكٍ
u'غير مُنْجَزٌ':Added, #1: 1	غَيْرِ مُنْتَهِكٍ
u'غَيْرٌ مُنْجَزٌ':Added, #1: 1	غَيْرُ الْمُنْجَزِ
u'غير مُنَجِّس':Added, #1: 1	غَيْرُ الْمُنْجَزِ
u'غَيْرٌ مُنَجِّس':Added, #1: 1	غَيْرَ مُنَجِّسٍ
u'غير مُنْحَرِفٌ':Added, #1: 1	غَيْرَ مُنَجِّسٍ
u'غير مُنْحَرِفٌ':Added, #1: 1	غَيْرَ مُنْحَرِفٍ
u'غَيْرٌ مُنْحَرِفٌ':Added, #1: 1	غَيْرُ مُنْحَرِفٍ
u'غَيْرٌ مُنْحَرِفٌ':Added, #1: 1	غَيْرَ مُنْحَرِفٍ
u'غير مُنْحَصِرٌ':Added, #1: 1	غَيْرُ مُنْحَرِفٍ
u'غَيْرٌ مُنْحَصِرٌ':Added, #11: 11	غَيْرُ مُنْحَصِرٍ
u'غير مُنْحَصِرٌ':Added, #11: 11	غَيْرُ مُنْحَصِرٍ
u'غَيْرٌ مُنْحَصِرٌ':Added, #1: 1	غَيْرِ مُنْحَصِرٍ
u'غير مُنْحَصِرٌ':Added, #1: 1	غَيْرِ مُنْحَصِرٍ
u'غَيْرٌ مُنْحَصِرٌ':Added, #3: 3	غَيْرِ مُنْحَصِرَةٍ
u'غير مُنْحَصِرٌ':Added, #3: 3	غَيْرِ مُنْحَصِرَةٍ
u'غَيْرٌ مُنْحَصِرٌ':Added, #5: 5	غَيْرُ مُنْحَصِرَةٍ
u'غير مَنْدُوبٌ':Added, #5: 5	غَيْرُ مُنْحَصِرَةٍ
u'غَيْرٌ مَنْدُوبٌ':Added, #1: 1	غَيْرِ الْمَنْدُوبِ
u'غير مَنْدُوبٌ':Added, #1: 1	غَيْرِ الْمَنْدُوبِ
u'غَيْرٌ مَنْدُوبٌ':Added, #1: 1	غَيْرَ مَنْدُوبٍ
u'غير مَنْدُوبٌ':Added, #1: 1	غَيْرَ مَنْدُوبٍ
u'غَيْرٌ مَنْدُوبٌ':Added, #1: 1	غَيْرُ مَنْدُوبَةٍ
u'غير مَنْدُوبٌ':Added, #1: 1	غَيْرُ مَنْدُوبَةٍ
u'غَيْرٌ مَنْدُوبٌ':Added, #3: 3	غَيْرُ مَنْدُوبٍ
u'غير مَنْذُور':Added, #3: 3	غَيْرُ مَنْدُوبٍ
u'غَيْرٌ مَنْذُور':Added, #1: 1	غَيْرِ الْمَنْذُورِ
u'غير مَنْذُور':Added, #1: 1	غَيْرِ الْمَنْذُورِ
u'غَيْرٌ مَنْذُور':Added, #1: 1	غَيْرِ الْمَنْذُورَةِ
u'غير مَنْذُور':Added, #1: 1	غَيْرِ الْمَنْذُورَةِ
u'غَيْرٌ مَنْذُور':Added, #1: 1	غَيْرَ مَنْذُورٍ
u'غير مَنْذُور':Added, #1: 1	غَيْرَ مَنْذُورٍ
u'غَيْرٌ مَنْذُور':Added, #2: 2	غَيْرِ مَنْذُورٍ
u'غير مَنْزِلٌ':Added, #2: 2	غَيْرِ مَنْذُورٍ
u'غَيْرٌ مَنْزِلٌ':Added, #1: 1	غَيْرِ الْمَنْزِلِ
u'غير مَنْزِلٌ':Added, #1: 1	غَيْرِ الْمَنْزِلِ
u'غَيْرٌ مَنْزِلٌ':Added, #5: 5	غَيْرِ مَنْزِلِهِ
u'غير مَنْزِلَةٌ':Added, #5: 5	غَيْرِ مَنْزِلِهِ
u'غير مَنْزِلَةٌ':Added, #1: 1	غَيْرَ مَنْزِلَتِهِ
u'غَيْرٌ مَنْزِلَةٌ':Added, #1: 1	غَيْرِ مَنْزِلَتِهِ
u'غَيْرٌ مَنْزِلَةٌ':Added, #1: 1	غَيْرَ مَنْزِلَتِهِ
u'غير مَنْزُوعٌ':Added, #1: 1	غَيْرِ مَنْزِلَتِهِ
u'غَيْرٌ مَنْزُوعٌ':Added, #1: 1	غَيْرَ الْمَنْزُوعِ
u'غير مَنْزُوعٌ':Added, #1: 1	غَيْرَ الْمَنْزُوعِ
u'غَيْرٌ مَنْزُوعٌ':Added, #4: 4	غَيْرِ الْمَنْزُوعِ
u'غير مَنْزُول':Added, #4: 4	غَيْرِ الْمَنْزُوعِ
u'غَيْرٌ مَنْزُول':Added, #1: 1	غَيْرِ الْمَنْزُولِ
u'غير مَنْسُوبٌ':Added, #1: 1	غَيْرِ الْمَنْزُولِ
u'غَيْرٌ مَنْسُوبٌ':Added, #14: 14	غَيْرُ مَنْسُوبٍ
u'غير مَنْسُوبٌ':Added, #14: 14	غَيْرُ مَنْسُوبٍ
u'غَيْرٌ مَنْسُوبٌ':Added, #1: 1	غَيْرِ مَنْسُوبٍ
u'غير مَنْسُوبٌ':Added, #1: 1	غَيْرِ مَنْسُوبٍ
u'غَيْرٌ مَنْسُوبٌ':Added, #1: 1	غَيْرَ مَنْسُوبَةٍ
u'غير مَنْسُوبٌ':Added, #1: 1	غَيْرَ مَنْسُوبَةٍ
u'غَيْرٌ مَنْسُوبٌ':Added, #6: 6	غَيْرَ مَنْسُوبٍ
u'غير مَنْسُوجٌ':Added, #6: 6	غَيْرَ مَنْسُوبٍ
u'غَيْرٌ مَنْسُوجٌ':Added, #1: 1	غَيْرِ الْمَنْسُوجِ
u'غير مَنْسُوجٌ':Added, #1: 1	غَيْرِ الْمَنْسُوجِ
u'غَيْرٌ مَنْسُوجٌ':Added, #1: 1	غَيْرُ مَنْسُوجَةٍ
u'غير مَنْسُوجٌ':Added, #1: 1	غَيْرُ مَنْسُوجَةٍ
u'غَيْرٌ مَنْسُوجٌ':Added, #2: 2	غَيْرَ الْمَنْسُوجِ
u'غير مَنْسُوجٌ':Added, #2: 2	غَيْرَ الْمَنْسُوجِ
u'غَيْرٌ مَنْسُوجٌ':Added, #2: 2	غَيْرُ مَنْسُوجٍ
u'غير مَنْسُوخٌ':Added, #2: 2	غَيْرُ مَنْسُوجٍ
u'غير مَنْسُوخٌ':Added, #1: 1	غَيْرَ مَنْسُوخَةٍ
u'غَيْرٌ مَنْسُوخٌ':Added, #1: 1	غَيْرُ مَنْسُوخَةٍ
u'غَيْرٌ مَنْسُوخٌ':Added, #1: 1	غَيْرَ مَنْسُوخَةٍ
u'غير مَنْسُوخٌ':Added, #1: 1	غَيْرُ مَنْسُوخَةٍ
u'غَيْرٌ مَنْسُوخٌ':Added, #3: 3	غَيْرُ مَنْسُوخٍ
u'غير مَنْسُوخٌ':Added, #3: 3	غَيْرُ مَنْسُوخٍ
u'غَيْرٌ مَنْسُوخٌ':Added, #4: 4	غَيْرَ مَنْسُوخٍ
u'غير مَنْسِيٌّ':Added, #4: 4	غَيْرَ مَنْسُوخٍ
u'غير مَنْسِيٌّ':Added, #1: 1	غَيْرُ الْمَنْسِيِّ
u'غَيْرٌ مَنْسِيٌّ':Added, #1: 1	غَيْرِ الْمَنْسِيِّ
u'غَيْرٌ مَنْسِيٌّ':Added, #1: 1	غَيْرُ الْمَنْسِيِّ
u'غير مَنْشُورٌ':Added, #1: 1	غَيْرِ الْمَنْسِيِّ
u'غَيْرٌ مَنْشُورٌ':Added, #1: 1	غَيْرِ الْمَنْشُورَةِ
u'غير مُنْشِئٌ':Added, #1: 1	غَيْرِ الْمَنْشُورَةِ
u'غَيْرٌ مُنْشِئٌ':Added, #1: 1	غَيْرُ مُنْشِئٍ
u'غير مَنْصِبٌ':Added, #1: 1	غَيْرُ مُنْشِئٍ
u'غَيْرٌ مَنْصِبٌ':Added, #1: 1	غَيْرُ مَنْصِبِهِ
u'غير مُنْصَرِفٌ':Added, #1: 1	غَيْرُ مَنْصِبِهِ
u'غَيْرٌ مُنْصَرِفٌ':Added, #1: 1	غَيْرُ مُنْصَرِفَةٍ
u'غير مُنْصَرِفٌ':Added, #1: 1	غَيْرُ مُنْصَرِفَةٍ
u'غَيْرٌ مُنْصَرِفٌ':Added, #2: 2	غَيْرَ مُنْصَرِفٍ
u'غير مُنْصَرِفٌ':Added, #2: 2	غَيْرَ مُنْصَرِفٍ
u'غَيْرٌ مُنْصَرِفٌ':Added, #8: 8	غَيْرُ مُنْصَرِفٍ
u'غير مُنْصِفٌ':Added, #8: 8	غَيْرُ مُنْصَرِفٍ
u'غَيْرٌ مُنْصِفٌ':Added, #1: 1	غَيْرُ مُنْصِفٍ
u'غير مَنْصُوبٌ':Added, #1: 1	غَيْرُ مُنْصِفٍ
u'غَيْرٌ مَنْصُوبٌ':Added, #1: 1	غَيْرِ الْمَنْصُوبِ
u'غير مَنْصُوبٌ':Added, #1: 1	غَيْرِ الْمَنْصُوبِ
u'غَيْرٌ مَنْصُوبٌ':Added, #1: 1	غَيْرَ مَنْصُوبٍ
u'غير مَنْصُوبٌ':Added, #1: 1	غَيْرَ مَنْصُوبٍ
u'غَيْرٌ مَنْصُوبٌ':Added, #1: 1	غَيْرِ مَنْصُوبَةٍ
u'غير مَنْصُوبٌ':Added, #1: 1	غَيْرِ مَنْصُوبَةٍ
u'غَيْرٌ مَنْصُوبٌ':Added, #1: 1	غَيْرَ مَنْصُوبِهِ
u'غير مَنْصُورٌ':Added, #1: 1	غَيْرَ مَنْصُوبِهِ
u'غَيْرٌ مَنْصُورٌ':Added, #1: 1	غَيْرُ الْمَنْصُورِ
u'غير مَنْصُورٌ':Added, #1: 1	غَيْرُ الْمَنْصُورِ
u'غير مَنْصُورٌ':Added, #1: 1	غَيْرُ مَنْصُورٍ
u'غَيْرٌ مَنْصُورٌ':Added, #1: 1	غَيْرِ مَنْصُورٍ
u'غَيْرٌ مَنْصُورٌ':Added, #1: 1	غَيْرُ مَنْصُورٍ
u'غير مَنْصُوصٌ':Added, #1: 1	غَيْرِ مَنْصُورٍ
u'غَيْرٌ مَنْصُوصٌ':Added, #10: 10	غَيْرِ الْمَنْصُوصِ
u'غير مَنْصُوصٌ':Added, #10: 10	غَيْرِ الْمَنْصُوصِ
u'غَيْرٌ مَنْصُوصٌ':Added, #18: 18	غَيْرُ مَنْصُوصٍ
u'غير مَنْصُوصٌ':Added, #18: 18	غَيْرُ مَنْصُوصٍ
u'غَيْرٌ مَنْصُوصٌ':Added, #1: 1	غَيْرُ الْمَنْصُوصِ
u'غير مَنْصُوصٌ':Added, #1: 1	غَيْرُ الْمَنْصُوصِ
u'غَيْرٌ مَنْصُوصٌ':Added, #1: 1	غَيْرِ مَنْصُوصٍ
u'غير مَنْصُوصٌ':Added, #1: 1	غَيْرِ مَنْصُوصٍ
u'غَيْرٌ مَنْصُوصٌ':Added, #1: 1	غَيْرِ مَنْصُوصَةٍ
u'غير مَنْصُوصٌ':Added, #1: 1	غَيْرِ مَنْصُوصَةٍ
u'غَيْرٌ مَنْصُوصٌ':Added, #3: 3	غَيْرَ الْمَنْصُوصِ
u'غير مَنْصُوصٌ':Added, #3: 3	غَيْرَ الْمَنْصُوصِ
u'غَيْرٌ مَنْصُوصٌ':Added, #3: 3	غَيْرَ مَنْصُوصٍ
u'غير مَنْصُوصٌ':Added, #3: 3	غَيْرَ مَنْصُوصٍ
u'غَيْرٌ مَنْصُوصٌ':Added, #4: 4	غَيْرُ مَنْصُوصَةٍ
u'غير مُنْضَبِط':Added, #4: 4	غَيْرُ مَنْصُوصَةٍ
u'غَيْرٌ مُنْضَبِط':Added, #2: 2	غَيْرُ مُنْضَبِطَةٍ
u'غير مُنْضَبِط':Added, #2: 2	غَيْرُ مُنْضَبِطَةٍ
u'غَيْرٌ مُنْضَبِط':Added, #3: 3	غَيْرَ مُنْضَبِطٍ
u'غير مُنْضَبِط':Added, #3: 3	غَيْرَ مُنْضَبِطٍ
u'غَيْرٌ مُنْضَبِط':Added, #9: 9	غَيْرُ مُنْضَبِطٍ
u'غير مُنْضَمٌّ':Added, #9: 9	غَيْرُ مُنْضَبِطٍ
u'غَيْرٌ مُنْضَمٌّ':Added, #1: 1	غَيْرَ مُنْضَمٍّ
u'غير مَنْطُوقٌ':Added, #1: 1	غَيْرَ مُنْضَمٍّ
u'غَيْرٌ مَنْطُوقٌ':Added, #1: 1	غَيْرَ مَنْطُوقٍ
u'غير مَنْطُوقٌ':Added, #1: 1	غَيْرَ مَنْطُوقٍ
u'غَيْرٌ مَنْطُوقٌ':Added, #2: 2	غَيْرِ الْمَنْطُوقِ
u'غير مَنْظُورٌ':Added, #2: 2	غَيْرِ الْمَنْطُوقِ
u'غَيْرٌ مَنْظُورٌ':Added, #1: 1	غَيْرَ مَنْظُورٍ
u'غير مَنْظُورٌ':Added, #1: 1	غَيْرَ مَنْظُورٍ
u'غَيْرٌ مَنْظُورٌ':Added, #4: 4	غَيْرُ مَنْظُورٍ
u'غير مَنْعٌ':Added, #4: 4	غَيْرُ مَنْظُورٍ
u'غير مَنْعٌ':Added, #1: 1	غَيْرَ مَنْعٍ
u'غَيْرٌ مَنْعٌ':Added, #1: 1	غَيْرِ مَنْعِ
u'غَيْرٌ مَنْعٌ':Added, #1: 1	غَيْرَ مَنْعٍ
u'غير مَنْعٌ':Added, #1: 1	غَيْرِ مَنْعِ
u'غَيْرٌ مَنْعٌ':Added, #5: 5	غَيْرِ مَنْعٍ
u'غير مُنْعَكِسٌ':Added, #5: 5	غَيْرِ مَنْعٍ
u'غَيْرٌ مُنْعَكِسٌ':Added, #2: 2	غَيْرَ مُنْعَكِسٍ
u'غير مُنْعَكِسٌ':Added, #2: 2	غَيْرَ مُنْعَكِسٍ
u'غَيْرٌ مُنْعَكِسٌ':Added, #3: 3	غَيْرُ مُنْعَكِسَةٍ
u'غير مُنْعَكِسٌ':Added, #3: 3	غَيْرُ مُنْعَكِسَةٍ
u'غَيْرٌ مُنْعَكِسٌ':Added, #7: 7	غَيْرُ مُنْعَكِسٍ
u'غير مُنَفَّذٌ':Added, #7: 7	غَيْرُ مُنْعَكِسٍ
u'غَيْرٌ مُنَفَّذٌ':Added, #1: 1	غَيْرِ مُنَفَّذَةٍ
u'غير مُنْفَرِدٌ':Added, #1: 1	غَيْرِ مُنَفَّذَةٍ
u'غير مُنْفَرِدٌ':Added, #1: 1	غَيْرَ الْمُنْفَرِدِ
u'غَيْرٌ مُنْفَرِدٌ':Added, #1: 1	غَيْرِ الْمُنْفَرِدِ
u'غَيْرٌ مُنْفَرِدٌ':Added, #1: 1	غَيْرَ الْمُنْفَرِدِ
u'غير مُنْفَرِدٌ':Added, #1: 1	غَيْرِ الْمُنْفَرِدِ
u'غَيْرٌ مُنْفَرِدٌ':Added, #1: 1	غَيْرُ مُنْفَرِدٍ
u'غير مُنْفَصِلٌ':Added, #1: 1	غَيْرُ مُنْفَرِدٍ
u'غَيْرٌ مُنْفَصِلٌ':Added, #1: 1	غَيْرَ مُنْفَصِلٍ
u'غير مُنْفَصِلٌ':Added, #1: 1	غَيْرَ مُنْفَصِلٍ
u'غَيْرٌ مُنْفَصِلٌ':Added, #2: 2	غَيْرُ مُنْفَصِلٍ
u'غير مَنْفَعَةٌ':Added, #2: 2	غَيْرُ مُنْفَصِلٍ
u'غَيْرٌ مَنْفَعَةٌ':Added, #1: 1	غَيْرِ الْمَنْفَعَةِ
u'غير مَنْفَعَةٌ':Added, #1: 1	غَيْرِ الْمَنْفَعَةِ
u'غَيْرٌ مَنْفَعَةٌ':Added, #9: 9	غَيْرِ مَنْفَعَةٍ
u'غير مَنْفِيٌّ':Added, #9: 9	غَيْرِ مَنْفَعَةٍ
u'غير مَنْفِيٌّ':Added, #1: 1	غَيْرُ الْمَنْفِيِّ
u'غَيْرٌ مَنْفِيٌّ':Added, #1: 1	غَيْرِ الْمَنْفِيِّ
u'غَيْرٌ مَنْفِيٌّ':Added, #1: 1	غَيْرُ الْمَنْفِيِّ
u'غير مَنْفِيٌّ':Added, #1: 1	غَيْرِ الْمَنْفِيِّ
u'غَيْرٌ مَنْفِيٌّ':Added, #1: 1	غَيْرُ مَنْفِيَّةٍ
u'غير مُنْقَبِضٌ':Added, #1: 1	غَيْرُ مَنْفِيَّةٍ
u'غَيْرٌ مُنْقَبِضٌ':Added, #1: 1	غَيْرُ مُنْقَبِضٍ
u'غير مُنَقَّحٌ':Added, #1: 1	غَيْرُ مُنْقَبِضٍ
u'غَيْرٌ مُنَقَّحٌ':Added, #1: 1	غَيْرُ مُنَقَّحٍ
u'غير مُنَقَّحٌ':Added, #1: 1	غَيْرُ مُنَقَّحٍ
u'غَيْرٌ مُنَقَّحٌ':Added, #1: 1	غَيْرَ مُنَقَّحَةٍ
u'غير مُنْقَرِضٌ':Added, #1: 1	غَيْرَ مُنَقَّحَةٍ
u'غَيْرٌ مُنْقَرِضٌ':Added, #1: 1	غَيْرُ مُنْقَرِضَةٍ
u'غير مُنْقَسِم':Added, #1: 1	غَيْرُ مُنْقَرِضَةٍ
u'غَيْرٌ مُنْقَسِم':Added, #1: 1	غَيْرِ الْمُنْقَسِمِ
u'غير مُنْقَسِم':Added, #1: 1	غَيْرِ الْمُنْقَسِمِ
u'غَيْرٌ مُنْقَسِم':Added, #1: 1	غَيْرَ مُنْقَسِمٍ
u'غير مُنْقَضِي':Added, #1: 1	غَيْرَ مُنْقَسِمٍ
u'غَيْرٌ مُنْقَضِي':Added, #2: 2	غَيْرُ مُنْقَضِيَةٍ
u'غير مُنْقَطِعٌ':Added, #2: 2	غَيْرُ مُنْقَضِيَةٍ
u'غَيْرٌ مُنْقَطِعٌ':Added, #2: 2	غَيْرُ مُنْقَطِعِ
u'غير مُنْقَطِعٌ':Added, #2: 2	غَيْرُ مُنْقَطِعِ
u'غَيْرٌ مُنْقَطِعٌ':Added, #4: 4	غَيْرُ مُنْقَطِعٍ
u'غير مُنْقَطِعٌ':Added, #4: 4	غَيْرُ مُنْقَطِعٍ
u'غَيْرٌ مُنْقَطِعٌ':Added, #5: 5	غَيْرَ مُنْقَطِعٍ
u'غير مَنْقُوشٌ':Added, #5: 5	غَيْرَ مُنْقَطِعٍ
u'غَيْرٌ مَنْقُوشٌ':Added, #1: 1	غَيْرِ مَنْقُوشٍ
u'غير مَنْقُوشٌ':Added, #1: 1	غَيْرِ مَنْقُوشٍ
u'غَيْرٌ مَنْقُوشٌ':Added, #1: 1	غَيْرَ مَنْقُوشَةٍ
u'غير مَنْقُوشٌ':Added, #1: 1	غَيْرَ مَنْقُوشَةٍ
u'غَيْرٌ مَنْقُوشٌ':Added, #5: 5	غَيْرَ مَنْقُوشٍ
u'غير مَنْقُوص':Added, #5: 5	غَيْرَ مَنْقُوشٍ
u'غَيْرٌ مَنْقُوص':Added, #1: 1	غَيْر مَنْقُوصٍ
u'غير مَنْقُوص':Added, #1: 1	غَيْر مَنْقُوصٍ
u'غَيْرٌ مَنْقُوص':Added, #7: 7	غَيْرَ مَنْقُوصٍ
u'غير مَنْقُوض':Added, #7: 7	غَيْرَ مَنْقُوصٍ
u'غير مَنْقُوض':Added, #1: 1	غَيْرَ مَنْقُوضٍ
u'غَيْرٌ مَنْقُوض':Added, #1: 1	غَيْرُ مَنْقُوضٍ
u'غَيْرٌ مَنْقُوض':Added, #1: 1	غَيْرَ مَنْقُوضٍ
u'غير مَنْقُوطٌ':Added, #1: 1	غَيْرُ مَنْقُوضٍ
u'غَيْرٌ مَنْقُوطٌ':Added, #1: 1	غَيْرَ مَنْقُوطٍ
u'غير مَنْقُولٌ':Added, #1: 1	غَيْرَ مَنْقُوطٍ
u'غَيْرٌ مَنْقُولٌ':Added, #13: 13	غَيْرَ مَنْقُولٍ
u'غير مَنْقُولٌ':Added, #13: 13	غَيْرَ مَنْقُولٍ
u'غَيْرٌ مَنْقُولٌ':Added, #14: 14	غَيْرِ الْمَنْقُولِ
u'غير مَنْقُولٌ':Added, #14: 14	غَيْرِ الْمَنْقُولِ
u'غَيْرٌ مَنْقُولٌ':Added, #1: 1	غَيْر الْمَنْقُولِ
u'غير مَنْقُولٌ':Added, #1: 1	غَيْر الْمَنْقُولِ
u'غَيْرٌ مَنْقُولٌ':Added, #1: 1	غَيْرُ مَنْقُولَيْنِ
u'غير مَنْقُولٌ':Added, #1: 1	غَيْرُ مَنْقُولَيْنِ
u'غَيْرٌ مَنْقُولٌ':Added, #2: 2	غَيْرَ الْمَنْقُولِ
u'غير مَنْقُولٌ':Added, #2: 2	غَيْرَ الْمَنْقُولِ
u'غَيْرٌ مَنْقُولٌ':Added, #3: 3	غَيْرُ الْمَنْقُولِ
u'غير مَنْقُولٌ':Added, #3: 3	غَيْرُ الْمَنْقُولِ
u'غَيْرٌ مَنْقُولٌ':Added, #3: 3	غَيْرِ مَنْقُولٍ
u'غير مَنْقُولٌ':Added, #3: 3	غَيْرِ مَنْقُولٍ
u'غَيْرٌ مَنْقُولٌ':Added, #5: 5	غَيْرُ مَنْقُولٍ
u'غير مُنْكَرٌ':Added, #5: 5	غَيْرُ مَنْقُولٍ
u'غَيْرٌ مُنْكَرٌ':Added, #1: 1	غَيْرُ مُنْكَرِ
u'غير مُنْكِرٌ':Added, #1: 1	غَيْرُ مُنْكَرِ
u'غَيْرٌ مُنْكِرٌ':Added, #1: 1	غَيْرُ مُنْكِرَةٍ
u'غير مُنْكَرٌ':Added, #1: 1	غَيْرُ مُنْكِرَةٍ
u'غَيْرٌ مُنْكَرٌ':Added, #2: 2	غَيْرُ الْمُنْكَرِ
u'غير مُنْكَرٌ':Added, #2: 2	غَيْرُ الْمُنْكَرِ
u'غير مُنْكِرٌ':Added, #3: 3	غَيْرُ مُنْكَرٍ
u'غَيْرٌ مُنْكَرٌ':Added, #3: 3	غَيْرَ مُنْكِرٍ
u'غَيْرٌ مُنْكِرٌ':Added, #3: 3	غَيْرُ مُنْكَرٍ
u'غير مُنَكِّسٌ':Added, #3: 3	غَيْرَ مُنْكِرٍ
u'غير مُنَكِّسٌ':Added, #1: 1	غَيْرَ مُنَكِّسٍ
u'غَيْرٌ مُنَكِّسٌ':Added, #1: 1	غَيْرُ مُنَكِّسٍ
u'غَيْرٌ مُنَكِّسٌ':Added, #1: 1	غَيْرَ مُنَكِّسٍ
u'غير مَنْكُوح':Added, #1: 1	غَيْرُ مُنَكِّسٍ
u'غَيْرٌ مَنْكُوح':Added, #2: 2	غَيْرِ الْمَنْكُوحَةِ
u'غير مِنْهَاجٌ':Added, #2: 2	غَيْرِ الْمَنْكُوحَةِ
u'غَيْرٌ مِنْهَاجٌ':Added, #2: 2	غَيْرِ الْمِنْهَاجِ
u'غير مَنْهِيٌّ':Added, #2: 2	غَيْرِ الْمِنْهَاجِ
u'غَيْرٌ مَنْهِيٌّ':Added, #10: 10	غَيْرُ مَنْهِيٍّ
u'غير مَنْهِيٌّ':Added, #10: 10	غَيْرُ مَنْهِيٍّ
u'غَيْرٌ مَنْهِيٌّ':Added, #1: 1	غَيْرِ مَنْهِيٍّ
u'غير مَنْهِيٌّ':Added, #1: 1	غَيْرِ مَنْهِيٍّ
u'غير مَنْهِيٌّ':Added, #1: 1	غَيْرَ مَنْهِيَّةٍ
u'غَيْرٌ مَنْهِيٌّ':Added, #1: 1	غَيْرُ مَنْهِيَّةٍ
u'غَيْرٌ مَنْهِيٌّ':Added, #1: 1	غَيْرَ مَنْهِيَّةٍ
u'غير مَنْهِيٌّ':Added, #1: 1	غَيْرُ مَنْهِيَّةٍ
u'غَيْرٌ مَنْهِيٌّ':Added, #2: 2	غَيْرُ الْمَنْهِيِّ
u'غير مَنْهِيٌّ':Added, #2: 2	غَيْرُ الْمَنْهِيِّ
u'غَيْرٌ مَنْهِيٌّ':Added, #2: 2	غَيْرَ مَنْهِيٍّ
u'غير مَنْهِيٌّ':Added, #2: 2	غَيْرَ مَنْهِيٍّ
u'غَيْرٌ مَنْهِيٌّ':Added, #5: 5	غَيْرِ الْمَنْهِيِّ
u'غير مَنُوطٌ':Added, #5: 5	غَيْرِ الْمَنْهِيِّ
u'غَيْرٌ مَنُوطٌ':Added, #2: 2	غَيْرُ مَنُوطٍ
u'غير مَنُونٌ':Added, #2: 2	غَيْرُ مَنُوطٍ
u'غَيْرٌ مَنُونٌ':Added, #1: 1	غَيْرَ مَنُونٍ
u'غير مَنِيٌّ':Added, #1: 1	غَيْرَ مَنُونٍ
u'غَيْرٌ مَنِيٌّ':Added, #2: 2	غَيْرِ الْمَنِيِّ
u'غير مُهَاجِرٌ':Added, #2: 2	غَيْرِ الْمَنِيِّ
u'غَيْرٌ مُهَاجِرٌ':Added, #1: 1	غَيْرَ مُهَاجِرٍ
u'غير مُهَاجِرٌ':Added, #1: 1	غَيْرَ مُهَاجِرٍ
u'غَيْرٌ مُهَاجِرٌ':Added, #1: 1	غَيْرُ مُهَاجِرَاتٍ
u'غير مَهَانَةٌ':Added, #1: 1	غَيْرُ مُهَاجِرَاتٍ
u'غَيْرٌ مَهَانَةٌ':Added, #1: 1	غَيْرِ مَهَانَةٍ
u'غير مُهْتَدِي':Added, #1: 1	غَيْرِ مَهَانَةٍ
u'غَيْرٌ مُهْتَدِي':Added, #1: 1	غَيْرُ مُهْتَدِيَةٍ
u'غير مَهْجُورٌ':Added, #1: 1	غَيْرُ مُهْتَدِيَةٍ
u'غَيْرٌ مَهْجُورٌ':Added, #2: 2	غَيْرُ مَهْجُورَةٍ
u'غير مُهْدَر':Added, #2: 2	غَيْرُ مَهْجُورَةٍ
u'غَيْرٌ مُهْدَر':Added, #1: 1	غَيْرَ مُهْدَرَةٍ
u'غير مُهْدَر':Added, #1: 1	غَيْرَ مُهْدَرَةٍ
u'غَيْرٌ مُهْدَر':Added, #2: 2	غَيْرُ مُهْدَرَةٍ
u'غير مَهْرٌ':Added, #2: 2	غَيْرُ مُهْدَرَةٍ
u'غَيْرٌ مَهْرٌ':Added, #13: 13	غَيْرِ مَهْرٍ
u'غير مَهْرٌ':Added, #13: 13	غَيْرِ مَهْرٍ
u'غير مَهْرٌ':Added, #1: 1	غَيْرُ الْمَهْرِ
u'غَيْرٌ مَهْرٌ':Added, #1: 1	غَيْرِ الْمَهْرِ
u'غَيْرٌ مَهْرٌ':Added, #1: 1	غَيْرُ الْمَهْرِ
u'غير مَهْرٌ':Added, #1: 1	غَيْرِ الْمَهْرِ
u'غَيْرٌ مَهْرٌ':Added, #1: 1	غَيْرِ مَهْرِ
u'غير مَهْرٌ':Added, #1: 1	غَيْرِ مَهْرِ
u'غَيْرٌ مَهْرٌ':Added, #4: 4	غَيْرَ الْمَهْرِ
u'غير مَهَلٌ':Added, #4: 4	غَيْرَ الْمَهْرِ
u'غَيْرٌ مَهَلٌ':Added, #1: 1	غَيْرِ مَهَلٍ
u'غير مُهْلَةٌ':Added, #1: 1	غَيْرِ مَهَلٍ
u'غَيْرٌ مُهْلَةٌ':Added, #2: 2	غَيْرِ مُهْلَةٍ
u'غير مُهْلِكٌ':Added, #2: 2	غَيْرِ مُهْلَةٍ
u'غَيْرٌ مُهْلِكٌ':Added, #1: 1	غَيْرَ مُهْلِكٍ
u'غير مُهِمٌّ':Added, #1: 1	غَيْرَ مُهْلِكٍ
u'غَيْرٌ مُهِمٌّ':Added, #1: 1	غَيْرُ مُهِمٍّ
u'غير مُهْمِلٌ':Added, #1: 1	غَيْرُ مُهِمٍّ
u'غَيْرٌ مُهْمِلٌ':Added, #1: 1	غَيْرِ مُهْمِلٍ
u'غير مِهْنَةٌ':Added, #1: 1	غَيْرِ مُهْمِلٍ
u'غَيْرٌ مِهْنَةٌ':Added, #1: 1	غَيْرِ الْمِهْنَةِ
u'غير مَوَاتٌ':Added, #1: 1	غَيْرِ الْمِهْنَةِ
u'غَيْرٌ مَوَاتٌ':Added, #1: 1	غَيْرِ مَوَاتٍ
u'غير مَوَاتٌ':Added, #1: 1	غَيْرِ مَوَاتٍ
u'غَيْرٌ مَوَاتٌ':Added, #3: 3	غَيْرِ الْمَوَاتِ
u'غير مُوَاجِهٌ':Added, #3: 3	غَيْرِ الْمَوَاتِ
u'غَيْرٌ مُوَاجِهٌ':Added, #1: 1	غَيْرُ مُوَاجِهٍ
u'غير مَوَاضِعُ':Added, #1: 1	غَيْرُ مُوَاجِهٍ
u'غَيْرٌ مَوَاضِعُ':Added, #1: 1	غَيْرِ الْمَوَاضِعِ
u'غير مَوَاضِعُ':Added, #1: 1	غَيْرِ الْمَوَاضِعِ
u'غَيْرٌ مَوَاضِعُ':Added, #1: 1	غَيْرِ مَوَاضِعِهِ
u'غير مَوَاضِعُ':Added, #1: 1	غَيْرِ مَوَاضِعِهِ
u'غَيْرٌ مَوَاضِعُ':Added, #2: 2	غَيْرِ مَوَاضِعِ
u'غير مُوَاطِنٌ':Added, #2: 2	غَيْرِ مَوَاضِعِ
u'غَيْرٌ مُوَاطِنٌ':Added, #1: 1	غَيْرِ مُوَاطِنِ
u'غير مُواعَدَة':Added, #1: 1	غَيْرِ مُوَاطِنِ
u'غَيْرٌ مُواعَدَة':Added, #1: 1	غَيْرِ مُوَاعَدَةٍ
u'غير مُوَافِقٌ':Added, #1: 1	غَيْرِ مُوَاعَدَةٍ
u'غَيْرٌ مُوَافِقٌ':Added, #11: 11	غَيْرُ مُوَافِقٍ
u'غير مُوَافِقٌ':Added, #11: 11	غَيْرُ مُوَافِقٍ
u'غَيْرٌ مُوَافِقٌ':Added, #1: 1	غَيْرِ الْمُوَافِقَيْنِ
u'غير مُوَافِقٌ':Added, #1: 1	غَيْرِ الْمُوَافِقَيْنِ
u'غير مُوَافِقٌ':Added, #1: 1	غَيْرَ مُوَافِقَةٍ
u'غَيْرٌ مُوَافِقٌ':Added, #1: 1	غَيْرُ مُوَافِقَةٍ
u'غَيْرٌ مُوَافِقٌ':Added, #1: 1	غَيْرَ مُوَافِقَةٍ
u'غير مُوَافِقٌ':Added, #1: 1	غَيْرُ مُوَافِقَةٍ
u'غَيْرٌ مُوَافِقٌ':Added, #3: 3	غَيْرَ مُوَافِقٍ
u'غير مُوَافَقَةٌ':Added, #3: 3	غَيْرَ مُوَافِقٍ
u'غير مُوَافَقَةٌ':Added, #1: 1	غَيْرَ الْمُوَافَقَةِ
u'غَيْرٌ مُوَافَقَةٌ':Added, #1: 1	غَيْرِ الْمُوَافَقَةِ
u'غَيْرٌ مُوَافَقَةٌ':Added, #1: 1	غَيْرَ الْمُوَافَقَةِ
u'غير مُوَافَقَةٌ':Added, #1: 1	غَيْرِ الْمُوَافَقَةِ
u'غَيْرٌ مُوَافَقَةٌ':Added, #1: 1	غَيْرُ مُوَافَقَةٍ
u'غير مُوَافَقَةٌ':Added, #1: 1	غَيْرُ مُوَافَقَةٍ
u'غَيْرٌ مُوَافَقَةٌ':Added, #2: 2	غَيْرِ مُوَافَقَةٍ
u'غير مَوَالِي':Added, #2: 2	غَيْرِ مُوَافَقَةٍ
u'غَيْرٌ مَوَالِي':Added, #14: 14	غَيْرَ مَوَالِيهِ
u'غير مَوَالِي':Added, #14: 14	غَيْرَ مَوَالِيهِ
u'غَيْرٌ مَوَالِي':Added, #8: 8	غَيْرِ مَوَالِيهِ
u'غير مُؤَامَرَةٌ':Added, #8: 8	غَيْرِ مَوَالِيهِ
u'غَيْرٌ مُؤَامَرَةٌ':Added, #1: 1	غَيْرِ مُؤَامَرَتِهِ
u'غير مُؤَامَرَةٌ':Added, #1: 1	غَيْرِ مُؤَامَرَتِهِ
u'غَيْرٌ مُؤَامَرَةٌ':Added, #2: 2	غَيْرِ مُؤَامَرَةٍ
u'غير مَوَانِعُ':Added, #2: 2	غَيْرِ مُؤَامَرَةٍ
u'غَيْرٌ مَوَانِعُ':Added, #1: 1	غَيْرِ الْمَوَانِعِ
u'غير مُؤَبَّدٌ':Added, #1: 1	غَيْرِ الْمَوَانِعِ
u'غير مُؤَبَّدٌ':Added, #1: 1	غَيْرَ مُؤَبَّدٍ
u'غَيْرٌ مُؤَبَّدٌ':Added, #1: 1	غَيْرُ مُؤَبَّدٍ
u'غَيْرٌ مُؤَبَّدٌ':Added, #1: 1	غَيْرَ مُؤَبَّدٍ
u'غير مُؤَبَّدٌ':Added, #1: 1	غَيْرُ مُؤَبَّدٍ
u'غَيْرٌ مُؤَبَّدٌ':Added, #1: 1	غَيْرِ مُؤَبَّدَةٍ
u'غير مَوْتٌ':Added, #1: 1	غَيْرِ مُؤَبَّدَةٍ
u'غَيْرٌ مَوْتٌ':Added, #1: 1	غَيْرُ مَوْتِهِ
u'غير مَوْتٌ':Added, #1: 1	غَيْرُ مَوْتِهِ
u'غَيْرٌ مَوْتٌ':Added, #3: 3	غَيْرِ الْمَوْتِ
u'غير مَوْتٌ':Added, #3: 3	غَيْرِ الْمَوْتِ
u'غَيْرٌ مَوْتٌ':Added, #3: 3	غَيْرِ مَوْتِ
u'غير مَوْتٌ':Added, #3: 3	غَيْرِ مَوْتِ
u'غَيْرٌ مَوْتٌ':Added, #4: 4	غَيْرُ الْمَوْتِ
u'غير مُؤْتَمَنٌ':Added, #4: 4	غَيْرُ الْمَوْتِ
u'غَيْرٌ مُؤْتَمَنٌ':Added, #1: 1	غَيْرِ الْمُؤْتَمَنِ
u'غير مُؤْتَمَنٌ':Added, #1: 1	غَيْرِ الْمُؤْتَمَنِ
u'غَيْرٌ مُؤْتَمَنٌ':Added, #1: 1	غَيْرَ مُؤْتَمَنٍ
u'غير مُؤْتَمَنٌ':Added, #1: 1	غَيْرَ مُؤْتَمَنٍ
u'غَيْرٌ مُؤْتَمَنٌ':Added, #3: 3	غَيْرُ مُؤْتَمَنٍ
u'غير مُؤَثِّرٌ':Added, #3: 3	غَيْرُ مُؤْتَمَنٍ
u'غير مُؤَثِّرٌ':Added, #1: 1	غَيْرَ الْمُؤَثِّرِ
u'غَيْرٌ مُؤَثِّرٌ':Added, #1: 1	غَيْرِ الْمُؤَثِّرِ
u'غَيْرٌ مُؤَثِّرٌ':Added, #1: 1	غَيْرَ الْمُؤَثِّرِ
u'غير مُؤَثِّرٌ':Added, #1: 1	غَيْرِ الْمُؤَثِّرِ
u'غَيْرٌ مُؤَثِّرٌ':Added, #1: 1	غَيْرُ الْمُؤَثِّرَةِ
u'غير مُؤَثِّرٌ':Added, #1: 1	غَيْرُ الْمُؤَثِّرَةِ
u'غير مُؤَثِّرٌ':Added, #1: 1	غَيْر مُؤَثِّرٍ
u'غَيْرٌ مُؤَثِّرٌ':Added, #1: 1	غَيْرِ مُؤَثِّرٍ
u'غَيْرٌ مُؤَثِّرٌ':Added, #1: 1	غَيْر مُؤَثِّرٍ
u'غير مُؤَثِّرٌ':Added, #1: 1	غَيْرِ مُؤَثِّرٍ
u'غَيْرٌ مُؤَثِّرٌ':Added, #1: 1	غَيْرَ مُؤَثِّرَةٍ
u'غير مُؤَثِّرٌ':Added, #1: 1	غَيْرَ مُؤَثِّرَةٍ
u'غَيْرٌ مُؤَثِّرٌ':Added, #28: 28	غَيْرُ مُؤَثِّرٍ
u'غير مُؤَثِّرٌ':Added, #28: 28	غَيْرُ مُؤَثِّرٍ
u'غَيْرٌ مُؤَثِّرٌ':Added, #3: 3	غَيْرُ مُؤَثِّرَةٍ
u'غير مُؤَثِّرٌ':Added, #3: 3	غَيْرُ مُؤَثِّرَةٍ
u'غَيْرٌ مُؤَثِّرٌ':Added, #9: 9	غَيْرَ مُؤَثِّرٍ
u'غير مُوثَقٌ':Added, #9: 9	غَيْرَ مُؤَثِّرٍ
u'غَيْرٌ مُوثَقٌ':Added, #2: 2	غَيْرَ مُوثَقٍ
u'غير مَوْثُوقٌ':Added, #2: 2	غَيْرَ مُوثَقٍ
u'غير مَوْثُوقٌ':Added, #1: 1	غَيْرَ الْمَوْثُوقِ
u'غَيْرٌ مَوْثُوقٌ':Added, #1: 1	غَيْرِ الْمَوْثُوقِ
u'غَيْرٌ مَوْثُوقٌ':Added, #1: 1	غَيْرَ الْمَوْثُوقِ
u'غير مَوْثُوقٌ':Added, #1: 1	غَيْرِ الْمَوْثُوقِ
u'غير مَوْثُوقٌ':Added, #1: 1	غَيْرَ مَوْثُوقٍ
u'غَيْرٌ مَوْثُوقٌ':Added, #1: 1	غَيْرِ مَوْثُوقٍ
u'غَيْرٌ مَوْثُوقٌ':Added, #1: 1	غَيْرَ مَوْثُوقٍ
u'غير مَوْثُوقٌ':Added, #1: 1	غَيْرِ مَوْثُوقٍ
u'غَيْرٌ مَوْثُوقٌ':Added, #8: 8	غَيْرُ مَوْثُوقٍ
u'غير مُوجَبٌ':Added, #8: 8	غَيْرُ مَوْثُوقٍ
u'غَيْرٌ مُوجَبٌ':Added, #1: 1	غَيْرِ مُوجَبِ
u'غير مُوجِبٌ':Added, #1: 1	غَيْرِ مُوجَبِ
u'غَيْرٌ مُوجِبٌ':Added, #2: 2	غَيْرُ مُوجِبِ
u'غير مُوجِبٌ':Added, #2: 2	غَيْرُ مُوجِبِ
u'غَيْرٌ مُوجِبٌ':Added, #35: 35	غَيْرُ مُوجِبٍ
u'غير مُوجِبٌ':Added, #35: 35	غَيْرُ مُوجِبٍ
u'غَيْرٌ مُوجِبٌ':Added, #3: 3	غَيْرَ الْمُوجِبِ
u'غير مُوجِبٌ':Added, #3: 3	غَيْرَ الْمُوجِبِ
u'غَيْرٌ مُوجِبٌ':Added, #5: 5	غَيْرُ مُوجِبَةٍ
u'غير مُوجِبٌ':Added, #5: 5	غَيْرُ مُوجِبَةٍ
u'غَيْرٌ مُوجِبٌ':Added, #8: 8	غَيْرَ مُوجِبٍ
u'غير مُوجِبٌ':Added, #8: 8	غَيْرَ مُوجِبٍ
u'غَيْرٌ مُوجِبٌ':Added, #9: 9	غَيْرِ مُوجِبٍ
u'غير مُوجِبٌ':Added, #9: 9	غَيْرِ مُوجِبٍ
u'غَيْرٌ مُوجِبٌ':Added, #9: 9	غَيْرَ مُوجِبَةٍ
u'غير مُوجِد':Added, #9: 9	غَيْرَ مُوجِبَةٍ
u'غَيْرٌ مُوجِد':Added, #1: 1	غَيْرِ الْمُوجِدِ
u'غير مُؤَجَّرٌ':Added, #1: 1	غَيْرِ الْمُوجِدِ
u'غَيْرٌ مُؤَجَّرٌ':Added, #1: 1	غَيْرِ الْمُؤَجَّرِ
u'غير مُؤَجَّرٌ':Added, #1: 1	غَيْرِ الْمُؤَجَّرِ
u'غَيْرٌ مُؤَجَّرٌ':Added, #1: 1	غَيْرَ مُؤَجَّرٍ
u'غير مُؤَجِّرٌ':Added, #1: 1	غَيْرَ مُؤَجَّرٍ
u'غَيْرٌ مُؤَجِّرٌ':Added, #2: 2	غَيْرِ الْمُؤَجِّرِ
u'غير مُؤَجَّلٌ':Added, #2: 2	غَيْرِ الْمُؤَجِّرِ
u'غَيْرٌ مُؤَجَّلٌ':Added, #1: 1	غَيْرَ الْمُؤَجَّلِ
u'غير مُؤَجَّلٌ':Added, #1: 1	غَيْرَ الْمُؤَجَّلِ
u'غَيْرٌ مُؤَجَّلٌ':Added, #1: 1	غَيْرِ مُؤَجَّلٍ
u'غير مُؤَجَّلٌ':Added, #1: 1	غَيْرِ مُؤَجَّلٍ
u'غير مُؤَجَّلٌ':Added, #1: 1	غَيْرَ مُؤَجَّلَةٍ
u'غَيْرٌ مُؤَجَّلٌ':Added, #1: 1	غَيْرُ مُؤَجَّلَةٍ
u'غَيْرٌ مُؤَجَّلٌ':Added, #1: 1	غَيْرَ مُؤَجَّلَةٍ
u'غير مُؤَجَّلٌ':Added, #1: 1	غَيْرُ مُؤَجَّلَةٍ
u'غَيْرٌ مُؤَجَّلٌ':Added, #2: 2	غَيْرِ الْمُؤَجَّلِ
u'غير مُؤَجَّلٌ':Added, #2: 2	غَيْرِ الْمُؤَجَّلِ
u'غَيْرٌ مُؤَجَّلٌ':Added, #3: 3	غَيْرُ مُؤَجَّلٍ
u'غير مُؤَجَّلٌ':Added, #3: 3	غَيْرُ مُؤَجَّلٍ
u'غَيْرٌ مُؤَجَّلٌ':Added, #6: 6	غَيْرَ مُؤَجَّلٍ
u'غير مُوَجَّهٌ':Added, #6: 6	غَيْرَ مُؤَجَّلٍ
u'غَيْرٌ مُوَجَّهٌ':Added, #1: 1	غَيْرَ مُوَجَّهٍ
u'غير مَوْجُودٌ':Added, #1: 1	غَيْرَ مُوَجَّهٍ
u'غَيْرٌ مَوْجُودٌ':Added, #16: 16	غَيْرُ مَوْجُودَةٍ
u'غير مَوْجُودٌ':Added, #16: 16	غَيْرُ مَوْجُودَةٍ
u'غَيْرٌ مَوْجُودٌ':Added, #1: 1	غَيْرُ الْمَوْجُودِ
u'غير مَوْجُودٌ':Added, #1: 1	غَيْرُ الْمَوْجُودِ
u'غَيْرٌ مَوْجُودٌ':Added, #1: 1	غَيْرِ مَوْجُودَةٍ
u'غير مَوْجُودٌ':Added, #1: 1	غَيْرِ مَوْجُودَةٍ
u'غَيْرٌ مَوْجُودٌ':Added, #2: 2	غَيْرِ الْمَوْجُودَةِ
u'غير مَوْجُودٌ':Added, #2: 2	غَيْرِ الْمَوْجُودَةِ
u'غَيْرٌ مَوْجُودٌ':Added, #2: 2	غَيْرَ مَوْجُودَةٍ
u'غير مَوْجُودٌ':Added, #2: 2	غَيْرَ مَوْجُودَةٍ
u'غَيْرٌ مَوْجُودٌ':Added, #4: 4	غَيْرِ الْمَوْجُودِ
u'غير مَوْجُودٌ':Added, #4: 4	غَيْرِ الْمَوْجُودِ
u'غَيْرٌ مَوْجُودٌ':Added, #4: 4	غَيْرِ مَوْجُودٍ
u'غير مَوْجُودٌ':Added, #4: 4	غَيْرِ مَوْجُودٍ
u'غَيْرٌ مَوْجُودٌ':Added, #69: 69	غَيْرُ مَوْجُودٍ
u'غير مَوْجُودٌ':Added, #69: 69	غَيْرُ مَوْجُودٍ
u'غَيْرٌ مَوْجُودٌ':Added, #7: 7	غَيْرَ مَوْجُودٍ
u'غير مُوحِي':Added, #7: 7	غَيْرَ مَوْجُودٍ
u'غَيْرٌ مُوحِي':Added, #1: 1	غَيْرَ مُوحِيَةٍ
u'غير مُؤَخَّرٌ':Added, #1: 1	غَيْرَ مُوحِيَةٍ
u'غَيْرٌ مُؤَخَّرٌ':Added, #1: 1	غَيْرَ مُؤَخَّرٍ
u'غير مُؤَدّاة':Added, #1: 1	غَيْرَ مُؤَخَّرٍ
u'غَيْرٌ مُؤَدّاة':Added, #3: 3	غَيْرُ مُؤَدَّاةٍ
u'غير مُودِعٌ':Added, #3: 3	غَيْرُ مُؤَدَّاةٍ
u'غير مُودِعٌ':Added, #1: 1	غَيْرُ الْمُودِعِ
u'غَيْرٌ مُودِعٌ':Added, #1: 1	غَيْرِ الْمُودِعِ
u'غَيْرٌ مُودِعٌ':Added, #1: 1	غَيْرُ الْمُودِعِ
u'غير مُودَعٌ':Added, #1: 1	غَيْرِ الْمُودِعِ
u'غَيْرٌ مُودَعٌ':Added, #2: 2	غَيْرِ الْمُودَعَةِ
u'غير مُؤَذِّنٌ':Added, #2: 2	غَيْرِ الْمُودَعَةِ
u'غَيْرٌ مُؤَذِّنٌ':Added, #1: 1	غَيْرِ الْمُؤَذِّنِ
u'غير مُؤَذِّنٌ':Added, #1: 1	غَيْرِ الْمُؤَذِّنِ
u'غَيْرٌ مُؤَذِّنٌ':Added, #2: 2	غَيْرُ الْمُؤَذِّنِ
u'غير مُؤْذِي':Added, #2: 2	غَيْرُ الْمُؤَذِّنِ
u'غَيْرٌ مُؤْذِي':Added, #1: 1	غَيْرَ مُؤْذِيَةٍ
u'غير مُؤَرِّخٌ':Added, #1: 1	غَيْرَ مُؤْذِيَةٍ
u'غَيْرٌ مُؤَرِّخٌ':Added, #1: 1	غَيْرَ الْمُؤَرِّخِ
u'غير مَوْرُوثٌ':Added, #1: 1	غَيْرَ الْمُؤَرِّخِ
u'غير مَوْرُوثٌ':Added, #1: 1	غَيْرَ مَوْرُوثٍ
u'غَيْرٌ مَوْرُوثٌ':Added, #1: 1	غَيْرِ مَوْرُوثِ
u'غَيْرٌ مَوْرُوثٌ':Added, #1: 1	غَيْرَ مَوْرُوثٍ
u'غير مَوْرُوثٌ':Added, #1: 1	غَيْرِ مَوْرُوثِ
u'غَيْرٌ مَوْرُوثٌ':Added, #1: 1	غَيْرُ مَوْرُوثَةٍ
u'غير مَوْرُوثٌ':Added, #1: 1	غَيْرُ مَوْرُوثَةٍ
u'غَيْرٌ مَوْرُوثٌ':Added, #3: 3	غَيْرُ مَوْرُوثٍ
u'غير مَوْزُونٌ':Added, #3: 3	غَيْرُ مَوْرُوثٍ
u'غَيْرٌ مَوْزُونٌ':Added, #1: 1	غَيْرَ مَوْزُونَةٍ
u'غير مَوْزُونٌ':Added, #1: 1	غَيْرَ مَوْزُونَةٍ
u'غَيْرٌ مَوْزُونٌ':Added, #2: 2	غَيْرَ مَوْزُونٍ
u'غير مَوْزُونٌ':Added, #2: 2	غَيْرَ مَوْزُونٍ
u'غَيْرٌ مَوْزُونٌ':Added, #4: 4	غَيْرُ مَوْزُونٍ
u'غير مُوَسَّد':Added, #4: 4	غَيْرُ مَوْزُونٍ
u'غَيْرٌ مُوَسَّد':Added, #1: 1	غَيْرَ مُوَسّدٍ
u'غير مُوسِرٌ':Added, #1: 1	غَيْرَ مُوَسّدٍ
u'غَيْرٌ مُوسِرٌ':Added, #3: 3	غَيْرُ مُوسِرٍ
u'غير مَوْصُوفٌ':Added, #3: 3	غَيْرُ مُوسِرٍ
u'غَيْرٌ مَوْصُوفٌ':Added, #13: 13	غَيْرِ مَوْصُوفٍ
u'غير مَوْصُوفٌ':Added, #13: 13	غَيْرِ مَوْصُوفٍ
u'غير مَوْصُوفٌ':Added, #1: 1	غَيْرُ مَوْصُوفَةٍ
u'غَيْرٌ مَوْصُوفٌ':Added, #1: 1	غَيْرِ مَوْصُوفَةٍ
u'غَيْرٌ مَوْصُوفٌ':Added, #1: 1	غَيْرُ مَوْصُوفَةٍ
u'غير مَوْصُوفٌ':Added, #1: 1	غَيْرِ مَوْصُوفَةٍ
u'غير مَوْصُوفٌ':Added, #2: 2	غَيْرَ الْمَوْصُوفِ
u'غَيْرٌ مَوْصُوفٌ':Added, #2: 2	غَيْرِ الْمَوْصُوفِ
u'غَيْرٌ مَوْصُوفٌ':Added, #2: 2	غَيْرَ الْمَوْصُوفِ
u'غير مَوْصُوفٌ':Added, #2: 2	غَيْرِ الْمَوْصُوفِ
u'غير مَوْصُوفٌ':Added, #4: 4	غَيْرَ مَوْصُوفٍ
u'غَيْرٌ مَوْصُوفٌ':Added, #4: 4	غَيْرُ مَوْصُوفٍ
u'غَيْرٌ مَوْصُوفٌ':Added, #4: 4	غَيْرَ مَوْصُوفٍ
u'غير مَوْصُوفٌ':Added, #4: 4	غَيْرُ مَوْصُوفٍ
u'غَيْرٌ مَوْصُوفٌ':Added, #4: 4	غَيْرَ مَوْصُوفَةٍ
u'غير مَوْصُولٌ':Added, #4: 4	غَيْرَ مَوْصُوفَةٍ
u'غَيْرٌ مَوْصُولٌ':Added, #1: 1	غَيْرِ الْمَوْصُولِ
u'غير مَوْصُولٌ':Added, #1: 1	غَيْرِ الْمَوْصُولِ
u'غَيْرٌ مَوْصُولٌ':Added, #1: 1	غَيْرُ مَوْصُولَةٍ
u'غير مَوْصُولٌ':Added, #1: 1	غَيْرُ مَوْصُولَةٍ
u'غير مَوْصُولٌ':Added, #2: 2	غَيْرَ مَوْصُولٍ
u'غَيْرٌ مَوْصُولٌ':Added, #2: 2	غَيْرُ مَوْصُولٍ
u'غَيْرٌ مَوْصُولٌ':Added, #2: 2	غَيْرَ مَوْصُولٍ
u'غَيَّرَ مَوْضِعٌ':Predicate, #2: 2	غَيْرُ مَوْصُولٍ
u'غير مَوْضِعٌ':Added, #1: 1	غَيَّرَ مَوْضِعَ
u'غَيْرٌ مَوْضِعٌ':Added, #2: 2	غَيْرَ الْمَوْضِعِ
u'غير مَوْضِعٌ':Added, #2: 2	غَيْرَ الْمَوْضِعِ
u'غَيْرٌ مَوْضِعٌ':Added, #2: 2	غَيْرَ مَوْضِعٍ
u'غير مَوْضِعٌ':Added, #2: 2	غَيْرَ مَوْضِعٍ
u'غير مَوْضِعٌ':Added, #4: 4	غَيْرَ مَوْضِعِ
u'غَيْرٌ مَوْضِعٌ':Added, #4: 4	غَيْرُ مَوْضِعِ
u'غَيْرٌ مَوْضِعٌ':Added, #4: 4	غَيْرَ مَوْضِعِ
u'غير مَوْضِعٌ':Added, #4: 4	غَيْرُ مَوْضِعِ
u'غَيْرٌ مَوْضِعٌ':Added, #58: 58	غَيْرِ مَوْضِعِهِ
u'غير مَوْضِعٌ':Added, #58: 58	غَيْرِ مَوْضِعِهِ
u'غَيْرٌ مَوْضِعٌ':Added, #65: 65	غَيْرِ مَوْضِعِ
u'غير مَوْضِعٌ':Added, #65: 65	غَيْرِ مَوْضِعِ
u'غَيْرٌ مَوْضِعٌ':Added, #89: 89	غَيْرِ مَوْضِعٍ
u'غير مَوْضِعٌ':Added, #89: 89	غَيْرِ مَوْضِعٍ
u'غَيْرٌ مَوْضِعٌ':Added, #8: 8	غَيْرِ الْمَوْضِعِ
u'غير مَوْضُوعٌ':Added, #8: 8	غَيْرِ الْمَوْضِعِ
u'غَيْرٌ مَوْضُوعٌ':Added, #11: 11	غَيْرِ مَوْضُوعِهِ
u'غير مَوْضُوعٌ':Added, #11: 11	غَيْرِ مَوْضُوعِهِ
u'غَيْرٌ مَوْضُوعٌ':Added, #12: 12	غَيْرُ مَوْضُوعٍ
u'غير مَوْضُوعٌ':Added, #12: 12	غَيْرُ مَوْضُوعٍ
u'غَيْرٌ مَوْضُوعٌ':Added, #1: 1	غَيْرِ مَوْضُوعٍ
u'غير مَوْضُوعٌ':Added, #1: 1	غَيْرِ مَوْضُوعٍ
u'غَيْرٌ مَوْضُوعٌ':Added, #1: 1	غَيْرِ مَوْضُوعَةٍ
u'غير مَوْضُوعٌ':Added, #1: 1	غَيْرِ مَوْضُوعَةٍ
u'غَيْرٌ مَوْضُوعٌ':Added, #1: 1	غَيْرَ مَوْضُوعَتَيْنِ
u'غير مَوْضُوعٌ':Added, #1: 1	غَيْرَ مَوْضُوعَتَيْنِ
u'غَيْرٌ مَوْضُوعٌ':Added, #1: 1	غَيْرُ مَوْضُوعِهِ
u'غير مَوْضُوعٌ':Added, #1: 1	غَيْرُ مَوْضُوعِهِ
u'غَيْرٌ مَوْضُوعٌ':Added, #1: 1	غَيْرُ مَوْضُوعَيْنِ
u'غير مَوْضُوعٌ':Added, #1: 1	غَيْرُ مَوْضُوعَيْنِ
u'غَيْرٌ مَوْضُوعٌ':Added, #2: 2	غَيْرُ الْمَوْضُوعِ
u'غير مَوْضُوعٌ':Added, #2: 2	غَيْرُ الْمَوْضُوعِ
u'غَيْرٌ مَوْضُوعٌ':Added, #2: 2	غَيْرَ مَوْضُوعَةٍ
u'غير مَوْضُوعٌ':Added, #2: 2	غَيْرَ مَوْضُوعَةٍ
u'غَيْرٌ مَوْضُوعٌ':Added, #3: 3	غَيْرَ مَوْضُوعٍ
u'غير مَوْضُوعٌ':Added, #3: 3	غَيْرَ مَوْضُوعٍ
u'غَيْرٌ مَوْضُوعٌ':Added, #6: 6	غَيْرُ مَوْضُوعَةٍ
u'غير مَوْضُوعَةٌ':Added, #6: 6	غَيْرُ مَوْضُوعَةٍ
u'غَيْرٌ مَوْضُوعَةٌ':Added, #1: 1	غَيْرِ مَوْضُوعَةٍ
u'غير مَوْضُوعَةٌ':Added, #1: 1	غَيْرِ مَوْضُوعَةٍ
u'غَيْرٌ مَوْضُوعَةٌ':Added, #2: 2	غَيْرَ مَوْضُوعَةٍ
u'غير مَوْضُوعَةٌ':Added, #2: 2	غَيْرَ مَوْضُوعَةٍ
u'غَيْرٌ مَوْضُوعَةٌ':Added, #6: 6	غَيْرُ مَوْضُوعَةٍ
u'غير مُوَطَّأٌ':Added, #6: 6	غَيْرُ مَوْضُوعَةٍ
u'غَيْرٌ مُوَطَّأٌ':Added, #1: 1	غَيْرِ الْمُوَطّأِ
u'غير مَوْطِنٌ':Added, #1: 1	غَيْرِ الْمُوَطّأِ
u'غَيْرٌ مَوْطِنٌ':Added, #1: 1	غَيْرِ مَوْطِنٍ
u'غير مُوَفَّقٌ':Added, #1: 1	غَيْرِ مَوْطِنٍ
u'غَيْرٌ مُوَفَّقٌ':Added, #1: 1	غَيْرَ الْمُوَفَّقِ
u'غير مُوَفَّقٌ':Added, #1: 1	غَيْرَ الْمُوَفَّقِ
u'غَيْرٌ مُوَفَّقٌ':Added, #1: 1	غَيْرُ مُوَفَّقَيْنِ
u'غير مُوَقِّتٌ':Added, #1: 1	غَيْرُ مُوَفَّقَيْنِ
u'غَيْرٌ مُوَقِّتٌ':Added, #1: 1	غَيْرُ مُوَقِّتٍ
u'غير مُوَقَّتٌ':Added, #1: 1	غَيْرُ مُوَقِّتٍ
u'غَيْرٌ مُوَقَّتٌ':Added, #1: 1	غَيْرُ مُوَقَّتَةٍ
u'غير مُوَقَّتٌ':Added, #1: 1	غَيْرُ مُوَقَّتَةٍ
u'غَيْرٌ مُوَقَّتٌ':Added, #2: 2	غَيْرَ مُوَقَّتٍ
u'غير مُوَقَّتٌ':Added, #2: 2	غَيْرَ مُوَقَّتٍ
u'غَيْرٌ مُوَقَّتٌ':Added, #7: 7	غَيْرُ مُوَقَّتٍ
u'غير مَوْقِعٌ':Added, #7: 7	غَيْرُ مُوَقَّتٍ
u'غَيْرٌ مَوْقِعٌ':Added, #1: 1	غَيْرِ مَوْقِعِهِ
u'غير مَوْقِفٌ':Added, #1: 1	غَيْرِ مَوْقِعِهِ
u'غَيْرٌ مَوْقِفٌ':Added, #1: 1	غَيْرَ مَوْقِفِ
u'غير مُوقِنٌ':Added, #1: 1	غَيْرَ مَوْقِفِ
u'غَيْرٌ مُوقِنٌ':Added, #1: 1	غَيْرَ مُوقِنَيْنِ
u'غير مَوْقُوفٌ':Added, #1: 1	غَيْرَ مُوقِنَيْنِ
u'غَيْرٌ مَوْقُوفٌ':Added, #1: 1	غَيْرِ مَوْقُوفَةٍ
u'غير مَوْقُوفٌ':Added, #1: 1	غَيْرِ مَوْقُوفَةٍ
u'غَيْرٌ مَوْقُوفٌ':Added, #2: 2	غَيْرِ الْمَوْقُوفِ
u'غير مَوْقُوفٌ':Added, #2: 2	غَيْرِ الْمَوْقُوفِ
u'غَيْرٌ مَوْقُوفٌ':Added, #2: 2	غَيْرِ الْمَوْقُوفَةِ
u'غير مَوْقُوفٌ':Added, #2: 2	غَيْرِ الْمَوْقُوفَةِ
u'غَيْرٌ مَوْقُوفٌ':Added, #2: 2	غَيْرَ مَوْقُوفَةٍ
u'غير مَوْقُوفٌ':Added, #2: 2	غَيْرَ مَوْقُوفَةٍ
u'غَيْرٌ مَوْقُوفٌ':Added, #4: 4	غَيْرُ مَوْقُوفٍ
u'غير مَوْقُوفٌ':Added, #4: 4	غَيْرُ مَوْقُوفٍ
u'غَيْرٌ مَوْقُوفٌ':Added, #5: 5	غَيْرَ مَوْقُوفٍ
u'غير مُؤَكَّدٌ':Added, #5: 5	غَيْرَ مَوْقُوفٍ
u'غَيْرٌ مُؤَكَّدٌ':Added, #1: 1	غَيْرُ مُؤَكَّدٍ
u'غير مُؤَكِّدٌ':Added, #1: 1	غَيْرُ مُؤَكَّدٍ
u'غَيْرٌ مُؤَكِّدٌ':Added, #1: 1	غَيْرَ مُؤَكِّدَةٍ
u'غير مُؤَكَّدٌ':Added, #1: 1	غَيْرَ مُؤَكِّدَةٍ
u'غير مُؤَكَّدٌ':Added, #2: 2	غَيْرُ الْمُؤَكَّدَةِ
u'غَيْرٌ مُؤَكَّدٌ':Added, #2: 2	غَيْرِ الْمُؤَكَّدَةِ
u'غَيْرٌ مُؤَكَّدٌ':Added, #2: 2	غَيْرُ الْمُؤَكَّدَةِ
u'غير مُؤَكَّدٌ':Added, #2: 2	غَيْرِ الْمُؤَكَّدَةِ
u'غير مُؤَكَّدٌ':Added, #2: 2	غَيْرَ مُؤَكَّدَةٍ
u'غير مُؤَكَّدٌ':Added, #2: 2	غَيْرُ مُؤَكَّدَةٍ
u'غَيْرٌ مُؤَكَّدٌ':Added, #2: 2	غَيْرِ مُؤَكَّدَةٍ
u'غَيْرٌ مُؤَكَّدٌ':Added, #2: 2	غَيْرَ مُؤَكَّدَةٍ
u'غَيْرٌ مُؤَكَّدٌ':Added, #2: 2	غَيْرُ مُؤَكَّدَةٍ
u'غير مُوَكِّلٌ':Added, #2: 2	غَيْرِ مُؤَكَّدَةٍ
u'غَيْرٌ مُوَكِّلٌ':Added, #1: 1	غَيْرُ الْمُوَكِّلِ
u'غير مُوَكِّلٌ':Added, #1: 1	غَيْرُ الْمُوَكِّلِ
u'غَيْرٌ مُوَكِّلٌ':Added, #1: 1	غَيْرُ مُوَكِّلٍ
u'غير مُوَكِّلٌ':Added, #1: 1	غَيْرُ مُوَكِّلٍ
u'غَيْرٌ مُوَكِّلٌ':Added, #5: 5	غَيْرِ الْمُوَكِّلِ
u'غير مُوَلِّدٌ':Added, #5: 5	غَيْرِ الْمُوَكِّلِ
u'غَيْرٌ مُوَلِّدٌ':Added, #1: 1	غَيْرُ مُوَلِّدٍ
u'غير مُوَلَّدٌ':Added, #1: 1	غَيْرُ مُوَلِّدٍ
u'غَيْرٌ مُوَلَّدٌ':Added, #1: 1	غَيْرَ مُوَلَّدَةٍ
u'غير مَوْلِدٌ':Added, #1: 1	غَيْرَ مُوَلَّدَةٍ
u'غَيْرٌ مَوْلِدٌ':Added, #1: 1	غَيْرِ مَوْلِدِهِ
u'غير مُؤَلَّفٌ':Added, #1: 1	غَيْرِ مَوْلِدِهِ
u'غَيْرٌ مُؤَلَّفٌ':Added, #2: 2	غَيْرَ مُؤَلَّفٍ
u'غير مُؤْلِمٌ':Added, #2: 2	غَيْرَ مُؤَلَّفٍ
u'غَيْرٌ مُؤْلِمٌ':Added, #1: 1	غَيْرُ الْمُؤْلِمِ
u'غير مُؤْمِنٌ':Added, #1: 1	غَيْرُ الْمُؤْلِمِ
u'غَيْرٌ مُؤْمِنٌ':Added, #1: 1	غَيْرِ الْمُؤْمِنِ
u'غير مُؤْمِنٌ':Added, #1: 1	غَيْرِ الْمُؤْمِنِ
u'غير مُؤْمِنٌ':Added, #1: 1	غَيْرُ الْمُؤْمِنَةِ
u'غَيْرٌ مُؤْمِنٌ':Added, #1: 1	غَيْرِ الْمُؤْمِنَةِ
u'غَيْرٌ مُؤْمِنٌ':Added, #1: 1	غَيْرُ الْمُؤْمِنَةِ
u'غير مُؤَمَّنٌ':Added, #1: 1	غَيْرِ الْمُؤْمِنَةِ
u'غَيْرٌ مُؤَمَّنٌ':Added, #1: 1	غَيْرِ مُؤَمَّنٍ
u'غير مُؤْمِنٌ':Added, #1: 1	غَيْرِ مُؤَمَّنٍ
u'غَيْرٌ مُؤْمِنٌ':Added, #1: 1	غَيْرَ مُؤْمِنَةٍ
u'غير مُؤْمِنٌ':Added, #1: 1	غَيْرَ مُؤْمِنَةٍ
u'غَيْرٌ مُؤْمِنٌ':Added, #2: 2	غَيْرُ مُؤْمِنٍ
u'غير مَوْهِبَةٌ':Added, #2: 2	غَيْرُ مُؤْمِنٍ
u'غَيْرٌ مَوْهِبَةٌ':Added, #1: 1	غَيْرِ مَوْهِبَتِهِ
u'غير مَوْهُوبٌ':Added, #1: 1	غَيْرِ مَوْهِبَتِهِ
u'غَيْرٌ مَوْهُوبٌ':Added, #4: 4	غَيْرُ مَوْهُوبٍ
u'غير مَوْهُوبٌ':Added, #4: 4	غَيْرُ مَوْهُوبٍ
u'غَيْرٌ مَوْهُوبٌ':Added, #9: 9	غَيْرِ الْمَوْهُوبِ
u'غير مِئْزَرُ':Added, #9: 9	غَيْرِ الْمَوْهُوبِ
u'غير مِئْزَرُ':Added, #1: 1	غَيْرِ مِئْزَرٍ
u'غَيْرٌ مِئْزَرُ':Added, #1: 1	غَيْرِ مِئْزَرِ
u'غَيْرٌ مِئْزَرُ':Added, #1: 1	غَيْرِ مِئْزَرٍ
u'غير مِيرَاثٌ':Added, #1: 1	غَيْرِ مِئْزَرِ
u'غَيْرٌ مِيرَاثٌ':Added, #1: 1	غَيْرُ الْمِيرَاثِ
u'غير مِيرَاثٌ':Added, #1: 1	غَيْرُ الْمِيرَاثِ
u'غير مِيرَاثٌ':Added, #2: 2	غَيْرَ الْمِيرَاثِ
u'غَيْرٌ مِيرَاثٌ':Added, #2: 2	غَيْرِ الْمِيرَاثِ
u'غَيْرٌ مِيرَاثٌ':Added, #2: 2	غَيْرَ الْمِيرَاثِ
u'غير مِيرَاثٌ':Added, #2: 2	غَيْرِ الْمِيرَاثِ
u'غَيْرٌ مِيرَاثٌ':Added, #2: 2	غَيْرِ مِيرَاثٍ
u'غير مِيعَادٌ':Added, #2: 2	غَيْرِ مِيرَاثٍ
u'غَيْرٌ مِيعَادٌ':Added, #3: 3	غَيْرِ مِيعَادٍ
u'غير مِيقَاتٌ':Added, #3: 3	غَيْرِ مِيعَادٍ
u'غَيْرٌ مِيقَاتٌ':Added, #1: 1	غَيْرِ الْمِيقَاتِ
u'غير مِيقَاتٌ':Added, #1: 1	غَيْرِ الْمِيقَاتِ
u'غَيْرٌ مِيقَاتٌ':Added, #2: 2	غَيْرِ مِيقَاتِهِ
u'غير ميل':Added, #2: 2	غَيْرِ مِيقَاتِهِ
u'غير ميل':Added, #1: 1	غَيْرُ مِيلٍ
u'غير مِيلٌ':Added, #1: 1	غَيْرِ مَيْلٍ
u'غير مَيْلٌ':Added, #1: 1	غَيْرُ مِيلٍ
u'غَيْرٌ ميل':Added, #1: 1	غَيْرِ مَيْلٍ
u'غَيْرٌ ميل':Added, #1: 1	غَيْرُ مِيلٍ
u'غَيْرٌ مِيلٌ':Added, #1: 1	غَيْرِ مَيْلٍ
u'غَيْرٌ مَيْلٌ':Added, #1: 1	غَيْرُ مِيلٍ
u'غير مَيَلاَنٌ':Added, #1: 1	غَيْرِ مَيْلٍ
u'غَيْرٌ مَيَلاَنٌ':Added, #1: 1	غَيْرِ مَيَلَانٍ
u'غير مَيْمُونٌ':Added, #1: 1	غَيْرِ مَيَلَانٍ
u'غَيْرٌ مَيْمُونٌ':Added, #1: 1	غَيْرُ مَيْمُونٍ
u'غير نَابٌ':Added, #1: 1	غَيْرُ مَيْمُونٍ
u'غَيْرٌ نَابٌ':Added, #1: 1	غَيْرَ نَابٍ
u'غير نَابِتٌ':Added, #1: 1	غَيْرَ نَابٍ
u'غَيْرٌ نَابِتٌ':Added, #1: 1	غَيْرِ النَّابِتِ
u'غير نَابِي':Added, #1: 1	غَيْرِ النَّابِتِ
u'غَيْرٌ نَابِي':Added, #1: 1	غَيْرَ نَابِيَةٍ
u'غير نَاجِزٌ':Added, #1: 1	غَيْرَ نَابِيَةٍ
u'غير نَاجِزٌ':Added, #1: 1	غَيْرَ نَاجِزٍ
u'غَيْرٌ نَاجِزٌ':Added, #1: 1	غَيْرِ نَاجِزٍ
u'غَيْرٌ نَاجِزٌ':Added, #1: 1	غَيْرَ نَاجِزٍ
u'غير نَادِرٌ':Added, #1: 1	غَيْرِ نَاجِزٍ
u'غَيْرٌ نَادِرٌ':Added, #18: 18	غَيْرُ نَادِرٍ
u'غير نَادِرٌ':Added, #18: 18	غَيْرُ نَادِرٍ
u'غَيْرٌ نَادِرٌ':Added, #1: 1	غَيْرِ النَّادِرَةِ
u'غير نَادِرَةٌ':Added, #1: 1	غَيْرِ النَّادِرَةِ
u'غَيْرٌ نَادِرَةٌ':Added, #1: 1	غَيْرِ النَّادِرَةِ
u'غير نَازِلٌ':Added, #1: 1	غَيْرِ النَّادِرَةِ
u'غَيْرٌ نَازِلٌ':Added, #16: 16	غَيْرُ نَازِلٍ
u'غير نَازِلٌ':Added, #16: 16	غَيْرُ نَازِلٍ
u'غَيْرٌ نَازِلٌ':Added, #1: 1	غَيْرِ النَّازِلَةِ
u'غير نَازِلٌ':Added, #1: 1	غَيْرِ النَّازِلَةِ
u'غَيْرٌ نَازِلٌ':Added, #1: 1	غَيْرَ نَازِلٍ
u'غير نَازِلٌ':Added, #1: 1	غَيْرَ نَازِلٍ
u'غَيْرٌ نَازِلٌ':Added, #2: 2	غَيْرُ نَازِلَةٍ
u'غير نَازِلَةٌ':Added, #2: 2	غَيْرُ نَازِلَةٍ
u'غَيْرٌ نَازِلَةٌ':Added, #1: 1	غَيْرِ النَّازِلَةِ
u'غير نَازِلَةٌ':Added, #1: 1	غَيْرِ النَّازِلَةِ
u'غَيْرٌ نَازِلَةٌ':Added, #2: 2	غَيْرُ نَازِلَةٍ
u'غير نَاسٌ':Added, #2: 2	غَيْرُ نَازِلَةٍ
u'غَيْرٌ نَاسٌ':Added, #1: 1	غَيْرِ النَّاسِ
u'غير نَاسٌ':Added, #1: 1	غَيْرِ النَّاسِ
u'غير نَاسٌ':Added, #2: 2	غَيْرَ نَاسٍ
u'غَيْرٌ نَاسٌ':Added, #2: 2	غَيْرُ نَاسٍ
u'غَيْرٌ نَاسٌ':Added, #2: 2	غَيْرَ نَاسٍ
u'غَيَّرَ نَاسِخٌ':Subject, #2: 2	غَيْرُ نَاسٍ
u'غَيَّرَ نَاسِخ':Subject, #1: 1	غَيَّرَ النَّاسِخُ
u'غير نَاسِخٌ':Added, #1: 1	غَيَّرَ النَّاسِخُ
u'غير نَاسِخ':Added, #1: 1	غَيْرُ نَاسِخٍ
u'غَيْرٌ نَاسِخٌ':Added, #1: 1	غَيْرُ نَاسِخٍ
u'غَيْرٌ نَاسِخ':Added, #1: 1	غَيْرُ نَاسِخٍ
u'غير ناسِي':Added, #1: 1	غَيْرُ نَاسِخٍ
u'غَيْرٌ ناسِي':Added, #1: 1	غَيْرَ النَّاسِيَةِ
u'غير نَاشِزٌ':Added, #1: 1	غَيْرَ النَّاسِيَةِ
u'غَيْرٌ نَاشِزٌ':Added, #1: 1	غَيْرُ نَاشِزٍ
u'غير نَاشِزٌ':Added, #1: 1	غَيْرُ نَاشِزٍ
u'غَيْرٌ نَاشِزٌ':Added, #1: 1	غَيْرَ نَاشِزَةٍ
u'غير نَاشِئٌ':Added, #1: 1	غَيْرَ نَاشِزَةٍ
u'غَيْرٌ نَاشِئٌ':Added, #1: 1	غَيْرُ نَاشِئٍ
u'غير نَاشِئٌ':Added, #1: 1	غَيْرُ نَاشِئٍ
u'غَيْرٌ نَاشِئٌ':Added, #3: 3	غَيْرِ نَاشِئٍ
u'غير نَاطِقٌ':Added, #3: 3	غَيْرِ نَاشِئٍ
u'غَيْرٌ نَاطِقٌ':Added, #1: 1	غَيْرِ النَّاطِقِ
u'غير نَاطِقٌ':Added, #1: 1	غَيْرِ النَّاطِقِ
u'غَيْرٌ نَاطِقٌ':Added, #1: 1	غَيْرِ نَاطِقٍ
u'غير نَاظِرٌ':Added, #1: 1	غَيْرِ نَاطِقٍ
u'غير نَاظِرٌ':Added, #2: 2	غَيْرَ نَاظِرٍ
u'غَيْرٌ نَاظِرٌ':Added, #2: 2	غَيْرُ نَاظِرٍ
u'غَيْرٌ نَاظِرٌ':Added, #2: 2	غَيْرَ نَاظِرٍ
u'غير ناعِل':Added, #2: 2	غَيْرُ نَاظِرٍ
u'غَيْرٌ ناعِل':Added, #1: 1	غَيْرَ نَاعِلِ
u'غير نَافِذٌ':Added, #1: 1	غَيْرَ نَاعِلِ
u'غَيْرٌ نَافِذٌ':Added, #14: 14	غَيْرِ نَافِذٍ
u'غير نَافِذٌ':Added, #14: 14	غَيْرِ نَافِذٍ
u'غَيْرٌ نَافِذٌ':Added, #16: 16	غَيْرَ نَافِذَةٍ
u'غير نَافِذٌ':Added, #16: 16	غَيْرَ نَافِذَةٍ
u'غَيْرٌ نَافِذٌ':Added, #1: 1	غَيْرُ النَّافِذَةِ
u'غير نَافِذٌ':Added, #1: 1	غَيْرُ النَّافِذَةِ
u'غَيْرٌ نَافِذٌ':Added, #1: 1	غَيْرُ نَافِذَيْنِ
u'غير نَافِذٌ':Added, #1: 1	غَيْرُ نَافِذَيْنِ
u'غَيْرٌ نَافِذٌ':Added, #22: 22	غَيْرُ نَافِذٍ
u'غير نَافِذٌ':Added, #22: 22	غَيْرُ نَافِذٍ
u'غَيْرٌ نَافِذٌ':Added, #27: 27	غَيْرُ نَافِذَةٍ
u'غير نَافِذٌ':Added, #27: 27	غَيْرُ نَافِذَةٍ
u'غَيْرٌ نَافِذٌ':Added, #2: 2	غَيْرِ نَافِذَيْنِ
u'غير نَافِذٌ':Added, #2: 2	غَيْرِ نَافِذَيْنِ
u'غير نَافِذٌ':Added, #4: 4	غَيْرُ النَّافِذِ
u'غَيْرٌ نَافِذٌ':Added, #4: 4	غَيْرِ النَّافِذِ
u'غَيْرٌ نَافِذٌ':Added, #4: 4	غَيْرُ النَّافِذِ
u'غير نَافِذٌ':Added, #4: 4	غَيْرِ النَّافِذِ
u'غَيْرٌ نَافِذٌ':Added, #52: 52	غَيْرِ نَافِذَةٍ
u'غير نَافِذٌ':Added, #52: 52	غَيْرِ نَافِذَةٍ
u'غَيْرٌ نَافِذٌ':Added, #5: 5	غَيْرِ النَّافِذَةِ
u'غير نَافِذٌ':Added, #5: 5	غَيْرِ النَّافِذَةِ
u'غَيْرٌ نَافِذٌ':Added, #8: 8	غَيْرَ نَافِذٍ
u'غير نَافِذَةٌ':Added, #8: 8	غَيْرَ نَافِذٍ
u'غَيْرٌ نَافِذَةٌ':Added, #16: 16	غَيْرَ نَافِذَةٍ
u'غير نَافِذَةٌ':Added, #16: 16	غَيْرَ نَافِذَةٍ
u'غَيْرٌ نَافِذَةٌ':Added, #1: 1	غَيْرُ النَّافِذَةِ
u'غير نَافِذَةٌ':Added, #1: 1	غَيْرُ النَّافِذَةِ
u'غَيْرٌ نَافِذَةٌ':Added, #27: 27	غَيْرُ نَافِذَةٍ
u'غير نَافِذَةٌ':Added, #27: 27	غَيْرُ نَافِذَةٍ
u'غَيْرٌ نَافِذَةٌ':Added, #52: 52	غَيْرِ نَافِذَةٍ
u'غير نَافِذَةٌ':Added, #52: 52	غَيْرِ نَافِذَةٍ
u'غَيْرٌ نَافِذَةٌ':Added, #5: 5	غَيْرِ النَّافِذَةِ
u'غير نَافِعٌ':Added, #5: 5	غَيْرِ النَّافِذَةِ
u'غير نَافِعٌ':Added, #1: 1	غَيْرَ نَافِعٍ
u'غير نَافِعٌ':Added, #1: 1	غَيْرُ نَافِعِ
u'غَيْرٌ نَافِعٌ':Added, #1: 1	غَيْرِ نَافِعٍ
u'غَيْرٌ نَافِعٌ':Added, #1: 1	غَيْرَ نَافِعٍ
u'غَيْرٌ نَافِعٌ':Added, #1: 1	غَيْرُ نَافِعِ
u'غير نَافِعٌ':Added, #1: 1	غَيْرِ نَافِعٍ
u'غير نَافِعٌ':Added, #1: 1	غَيْرُ نَافِعَةٍ
u'غَيْرٌ نَافِعٌ':Added, #1: 1	غَيْرِ نَافِعَةٍ
u'غَيْرٌ نَافِعٌ':Added, #1: 1	غَيْرُ نَافِعَةٍ
u'غير نَافِعٌ':Added, #1: 1	غَيْرِ نَافِعَةٍ
u'غَيْرٌ نَافِعٌ':Added, #5: 5	غَيْرُ نَافِعٍ
u'غير نَاقِدٌ':Added, #5: 5	غَيْرُ نَافِعٍ
u'غَيْرٌ نَاقِدٌ':Added, #1: 1	غَيْرُ نَاقِدٍ
u'غير نَاقِصٌ':Added, #1: 1	غَيْرُ نَاقِدٍ
u'غَيْرٌ نَاقِصٌ':Added, #1: 1	غَيْرَ نَاقِصٍ
u'غير نَاقِصٌ':Added, #1: 1	غَيْرَ نَاقِصٍ
u'غَيْرٌ نَاقِصٌ':Added, #2: 2	غَيْرَ نَاقِصَةٍ
u'غير نَاقِلٌ':Added, #2: 2	غَيْرَ نَاقِصَةٍ
u'غَيْرٌ نَاقِلٌ':Added, #1: 1	غَيْرُ نَاقِلٍ
u'غير نَاكِحٌ':Added, #1: 1	غَيْرُ نَاقِلٍ
u'غَيْرٌ نَاكِحٌ':Added, #1: 1	غَيْرُ النَّاكِحِ
u'غير نَامِي':Added, #1: 1	غَيْرُ النَّاكِحِ
u'غَيْرٌ نَامِي':Added, #1: 1	غَيْرِ نَامِيَةٍ
u'غير نَاهِضٌ':Added, #1: 1	غَيْرِ نَامِيَةٍ
u'غَيْرٌ نَاهِضٌ':Added, #1: 1	غَيْرُ نَاهِضٍ
u'غير نَاوِي':Added, #1: 1	غَيْرُ نَاهِضٍ
u'غَيْرٌ نَاوِي':Added, #1: 1	غَيْرَ نَاوِيهِ
u'غَيَّرَ نَأْيٌ':Subject, #1: 1	غَيْرَ نَاوِيهِ
u'غير نَائِبٌ':Added, #1: 1	غَيَّرَ النَّأْيُ
u'غير نَائِبٌ':Added, #1: 1	غَيْرَ نَائِبٍ
u'غَيْرٌ نَائِبٌ':Added, #1: 1	غَيْرِ نَائِبٍ
u'غَيْرٌ نَائِبٌ':Added, #1: 1	غَيْرَ نَائِبٍ
u'غير نَائِبٌ':Added, #1: 1	غَيْرِ نَائِبٍ
u'غَيْرٌ نَائِبٌ':Added, #1: 1	غَيْرَ نَائِبَةٍ
u'غير نَائِبٌ':Added, #1: 1	غَيْرَ نَائِبَةٍ
u'غَيْرٌ نَائِبٌ':Added, #1: 1	غَيْرُ نَائِبِهِ
u'غير نَائِبَةٌ':Added, #1: 1	غَيْرُ نَائِبِهِ
u'غَيْرٌ نَائِبَةٌ':Added, #1: 1	غَيْرَ نَائِبَةٍ
u'غير نَائِلٌ':Added, #1: 1	غَيْرَ نَائِبَةٍ
u'غَيْرٌ نَائِلٌ':Added, #1: 1	غَيْرُ نَائِلٍ
u'غير نَائِمٌ':Added, #1: 1	غَيْرُ نَائِلٍ
u'غير نَائِمٌ':Added, #1: 1	غَيْرَ نَائِمِ
u'غَيْرٌ نَائِمٌ':Added, #1: 1	غَيْرُ نَائِمٍ
u'غَيْرٌ نَائِمٌ':Added, #1: 1	غَيْرَ نَائِمِ
u'غير نَائِمٌ':Added, #1: 1	غَيْرُ نَائِمٍ
u'غَيْرٌ نَائِمٌ':Added, #2: 2	غَيْرِ النَّائِمَةِ
u'غير نَائِمٌ':Added, #2: 2	غَيْرِ النَّائِمَةِ
u'غَيْرٌ نَائِمٌ':Added, #2: 2	غَيْرَ نَائِمٍ
u'غير نَبِيٌّ':Added, #2: 2	غَيْرَ نَائِمٍ
u'غَيْرٌ نَبِيٌّ':Added, #24: 24	غَيْرِ النَّبِيِّ
u'غير نَبِيٌّ':Added, #24: 24	غَيْرِ النَّبِيِّ
u'غَيْرٌ نَبِيٌّ':Added, #4: 4	غَيْرُ النَّبِيِّ
u'غير نَبِيٌّ':Added, #4: 4	غَيْرُ النَّبِيِّ
u'غَيْرٌ نَبِيٌّ':Added, #6: 6	غَيْرَ النَّبِيِّ
u'غير نَبِيذٌ':Added, #6: 6	غَيْرَ النَّبِيِّ
u'غَيْرٌ نَبِيذٌ':Added, #1: 1	غَيْرِ النَّبِيذِ
u'غير نَتْفٌ':Added, #1: 1	غَيْرِ النَّبِيذِ
u'غَيْرٌ نَتْفٌ':Added, #1: 1	غَيْرِ نَتْفِ
u'غير نَجَاسَةٌ':Added, #1: 1	غَيْرِ نَتْفِ
u'غَيْرٌ نَجَاسَةٌ':Added, #1: 1	غَيْرِ النَّجَاسَةِ
u'غير نَجَاسَةٌ':Added, #1: 1	غَيْرِ النَّجَاسَةِ
u'غَيْرٌ نَجَاسَةٌ':Added, #5: 5	غَيْرِ نَجَاسَةٍ
u'غير نُجُومٌ':Added, #5: 5	غَيْرِ نَجَاسَةٍ
u'غَيْرٌ نُجُومٌ':Added, #1: 1	غَيْرَ النُّجُومِ
u'غير نَحْوٌ':Added, #1: 1	غَيْرَ النُّجُومِ
u'غير نَحْوٌ':Added, #1: 1	غَيْرُ النَّحْوِ
u'غَيْرٌ نَحْوٌ':Added, #1: 1	غَيْرِ النَّحْوِ
u'غَيْرٌ نَحْوٌ':Added, #1: 1	غَيْرُ النَّحْوِ
u'غير نَحْوٌ':Added, #1: 1	غَيْرِ النَّحْوِ
u'غَيْرٌ نَحْوٌ':Added, #1: 1	غَيْرُ نَحْوِ
u'غير نَحْوٌ':Added, #1: 1	غَيْرُ نَحْوِ
u'غير نَحْوٌ':Added, #3: 3	غَيْرَ نَحْوِ
u'غَيْرٌ نَحْوٌ':Added, #3: 3	غَيْرِ نَحْوِ
u'غَيْرٌ نَحْوٌ':Added, #3: 3	غَيْرَ نَحْوِ
u'غير نُخَالَةٌ':Added, #3: 3	غَيْرِ نَحْوِ
u'غَيْرٌ نُخَالَةٌ':Added, #3: 3	غَيْرِ نُخَالَةٍ
u'غير نَخْلٌ':Added, #3: 3	غَيْرِ نُخَالَةٍ
u'غَيْرٌ نَخْلٌ':Added, #1: 1	غَيْرَ النَّخْلِ
u'غير نَخْلٌ':Added, #1: 1	غَيْرَ النَّخْلِ
u'غَيْرٌ نَخْلٌ':Added, #3: 3	غَيْرُ النَّخْلِ
u'غير نَخْلٌ':Added, #3: 3	غَيْرُ النَّخْلِ
u'غَيْرٌ نَخْلٌ':Added, #8: 8	غَيْرِ النَّخْلِ
u'غير نَخِيلٌ':Added, #8: 8	غَيْرِ النَّخْلِ
u'غير نَخِيلٌ':Added, #1: 1	غَيْرَ النَّخِيلِ
u'غَيْرٌ نَخِيلٌ':Added, #1: 1	غَيْرُ النَّخِيلِ
u'غَيْرٌ نَخِيلٌ':Added, #1: 1	غَيْرَ النَّخِيلِ
u'غير نِدَاءٌ':Added, #1: 1	غَيْرُ النَّخِيلِ
u'غَيْرٌ نِدَاءٌ':Added, #1: 1	غَيْرُ النِّدَاءِ
u'غير نِدَاءٌ':Added, #1: 1	غَيْرُ النِّدَاءِ
u'غَيْرٌ نِدَاءٌ':Added, #1: 1	غَيْرِ نِدَاءٍ
u'غير نِدَاءٌ':Added, #1: 1	غَيْرِ نِدَاءٍ
u'غَيْرٌ نِدَاءٌ':Added, #2: 2	غَيْرِ النِّدَاءِ
u'غير نِدَاءٌ':Added, #2: 2	غَيْرِ النِّدَاءِ
u'غَيْرٌ نِدَاءٌ':Added, #2: 2	غَيْرِ نِدَاءِ
u'غير نِدَاءٌ':Added, #2: 2	غَيْرِ نِدَاءِ
u'غَيْرٌ نِدَاءٌ':Added, #4: 4	غَيْرِ النّدَاءِ
u'غير نَدَامَةٌ':Added, #4: 4	غَيْرِ النّدَاءِ
u'غَيْرٌ نَدَامَةٌ':Added, #1: 1	غَيْرِ نَدَامَةٍ
u'غير نَدْبٌ':Added, #1: 1	غَيْرِ نَدَامَةٍ
u'غَيْرٌ نَدْبٌ':Added, #3: 3	غَيْرِ نَدْبٍ
u'غير نذر':Added, #3: 3	غَيْرِ نَدْبٍ
u'غَيْرٌ نذر':Added, #1: 1	غَيْرَ نَذْرِ
u'غير نَذْرٌ':Added, #1: 1	غَيْرَ نَذْرِ
u'غير نَذْرٌ':Added, #1: 1	غَيْرَ نَذْرٍ
u'غَيْرٌ نَذْرٌ':Added, #1: 1	غَيْرَ نَذْرِ
u'غَيْرٌ نَذْرٌ':Added, #1: 1	غَيْرَ نَذْرٍ
u'غير نذر':Added, #1: 1	غَيْرَ نَذْرِ
u'غَيْرٌ نذر':Added, #3: 3	غَيْرِ النَّذْرِ
u'غير نَذْرٌ':Added, #3: 3	غَيْرِ النَّذْرِ
u'غَيْرٌ نَذْرٌ':Added, #3: 3	غَيْرِ النَّذْرِ
u'غير نَذْرٌ':Added, #3: 3	غَيْرِ النَّذْرِ
u'غَيْرٌ نَذْرٌ':Added, #7: 7	غَيْرِ نَذْرٍ
u'غير نزاع':Added, #7: 7	غَيْرِ نَذْرٍ
u'غَيْرٌ نزاع':Added, #17: 17	غَيْرِ نِزَاعٍ
u'غير نِزَاعٌ':Added, #17: 17	غَيْرِ نِزَاعٍ
u'غَيْرٌ نِزَاعٌ':Added, #17: 17	غَيْرِ نِزَاعٍ
u'غير نزاع':Added, #17: 17	غَيْرِ نِزَاعٍ
u'غَيْرٌ نزاع':Added, #1: 1	غَيْرِ النِّزَاعِ
u'غير نِزَاعٌ':Added, #1: 1	غَيْرِ النِّزَاعِ
u'غَيْرٌ نِزَاعٌ':Added, #1: 1	غَيْرِ النِّزَاعِ
u'غير نزر':Added, #1: 1	غَيْرِ النِّزَاعِ
u'غَيْرٌ نزر':Added, #1: 1	غَيْرَ نَزْرِ
u'غير نَزْرٌ':Added, #1: 1	غَيْرَ نَزْرِ
u'غَيْرٌ نَزْرٌ':Added, #1: 1	غَيْرَ نَزْرِ
u'غير نَزْعٌ':Added, #1: 1	غَيْرَ نَزْرِ
u'غَيْرٌ نَزْعٌ':Added, #2: 2	غَيْرِ نَزْعِ
u'غير نَزْعٌ':Added, #2: 2	غَيْرِ نَزْعِ
u'غَيْرٌ نَزْعٌ':Added, #4: 4	غَيْرِ نَزْعٍ
u'غير نُزْهَةٌ':Added, #4: 4	غَيْرِ نَزْعٍ
u'غَيْرٌ نُزْهَةٌ':Added, #2: 2	غَيْرَ نُزْهَةٍ
u'غير نَزُورٌ':Added, #2: 2	غَيْرَ نُزْهَةٍ
u'غَيْرٌ نَزُورٌ':Added, #1: 1	غَيْرَ نَزُورِ
u'غير نِساءٌ':Added, #1: 1	غَيْرَ نَزُورِ
u'غَيْرٌ نِساءٌ':Added, #1: 1	غَيْرُ نِسَاءٍ
u'غير نِساءٌ':Added, #1: 1	غَيْرُ نِسَاءٍ
u'غَيْرٌ نِساءٌ':Added, #2: 2	غَيْرَ النِّسَاءِ
u'غير نِساءٌ':Added, #2: 2	غَيْرَ النِّسَاءِ
u'غَيْرٌ نِساءٌ':Added, #2: 2	غَيْرِ نِسَاءِ
u'غير نِساءٌ':Added, #2: 2	غَيْرِ نِسَاءِ
u'غَيْرٌ نِساءٌ':Added, #4: 4	غَيْرُ النِّسَاءِ
u'غير نِساءٌ':Added, #4: 4	غَيْرُ النِّسَاءِ
u'غَيْرٌ نِساءٌ':Added, #6: 6	غَيْرِ النِّسَاءِ
u'غير نَسَبٌ':Added, #6: 6	غَيْرِ النِّسَاءِ
u'غير نِسَبٌ':Added, #1: 1	غَيْرِ النّسَبِ
u'غَيْرٌ نَسَبٌ':Added, #1: 1	غَيْرِ النّسَبِ
u'غَيْرٌ نِسَبٌ':Added, #1: 1	غَيْرِ النّسَبِ
u'غير نَسَبٌ':Added, #1: 1	غَيْرِ النّسَبِ
u'غَيْرٌ نَسَبٌ':Added, #1: 1	غَيْرِ نَسَبِهِ
u'غير نَسَبٌ':Added, #1: 1	غَيْرِ نَسَبِهِ
u'غَيْرٌ نَسَبٌ':Added, #2: 2	غَيْرَ نَسَبِهِ
u'غير نِسْبَةٌ':Added, #2: 2	غَيْرَ نَسَبِهِ
u'غَيْرٌ نِسْبَةٌ':Added, #3: 3	غَيْرِ نِسْبَةٍ
u'غير نسخة':Added, #3: 3	غَيْرِ نِسْبَةٍ
u'غَيْرٌ نسخة':Added, #1: 1	غَيْرِ نُسْخَةِ
u'غير نُسْخَةٌ':Added, #1: 1	غَيْرِ نُسْخَةِ
u'غَيْرٌ نُسْخَةٌ':Added, #1: 1	غَيْرِ نُسْخَةِ
u'غير نسخة':Added, #1: 1	غَيْرِ نُسْخَةِ
u'غَيْرٌ نسخة':Added, #3: 3	غَيْرِ نُسْخَةٍ
u'غير نُسْخَةٌ':Added, #3: 3	غَيْرِ نُسْخَةٍ
u'غَيْرٌ نُسْخَةٌ':Added, #3: 3	غَيْرِ نُسْخَةٍ
u'غير نُسُكٌ':Added, #3: 3	غَيْرِ نُسْخَةٍ
u'غَيْرٌ نُسُكٌ':Added, #1: 1	غَيْرِ النُّسُكِ
u'غير نَسْلٌ':Added, #1: 1	غَيْرِ النُّسُكِ
u'غَيْرٌ نَسْلٌ':Added, #1: 1	غَيْرِ نَسْلِهِ
u'غير نَسْلٌ':Added, #1: 1	غَيْرِ نَسْلِهِ
u'غَيْرٌ نَسْلٌ':Added, #2: 2	غَيْر نَسْلٍ
u'غير نَسْلٌ':Added, #2: 2	غَيْر نَسْلٍ
u'غَيْرٌ نَسْلٌ':Added, #6: 6	غَيْرِ نَسْلٍ
u'غير نِسْيَانٌ':Added, #6: 6	غَيْرِ نَسْلٍ
u'غَيْرٌ نِسْيَانٌ':Added, #1: 1	غَيْرَ نِسْيَانٍ
u'غير نِسْيَانٌ':Added, #1: 1	غَيْرَ نِسْيَانٍ
u'غَيْرٌ نِسْيَانٌ':Added, #4: 4	غَيْرِ نِسْيَانٍ
u'غير نَسِيبٌ':Added, #4: 4	غَيْرِ نِسْيَانٍ
u'غَيْرٌ نَسِيبٌ':Added, #4: 4	غَيْرُ نَسِيبٍ
u'غير نَصٌّ':Added, #4: 4	غَيْرُ نَسِيبٍ
u'غير نَصٌّ':Added, #1: 1	غَيْرُ النَّصِّ
u'غَيْرٌ نَصٌّ':Added, #1: 1	غَيْرِ النَّصِّ
u'غَيْرٌ نَصٌّ':Added, #1: 1	غَيْرُ النَّصِّ
u'غير نَصٌّ':Added, #1: 1	غَيْرِ النَّصِّ
u'غَيْرٌ نَصٌّ':Added, #1: 1	غَيْرِ نَصٍّ
u'غير نَصٌّ':Added, #1: 1	غَيْرِ نَصٍّ
u'غَيْرٌ نَصٌّ':Added, #2: 2	غَيْرُ نَصٍّ
u'غير نصاب':Added, #2: 2	غَيْرُ نَصٍّ
u'غير نصاب':Added, #1: 1	غَيْرَ نِصَابٍ
u'غَيْرٌ نصاب':Added, #1: 1	غَيْرُ نِصَابٍ
u'غَيْرٌ نصاب':Added, #1: 1	غَيْرَ نِصَابٍ
u'غير نِصَابٌ':Added, #1: 1	غَيْرُ نِصَابٍ
u'غير نِصَابٌ':Added, #1: 1	غَيْرَ نِصَابٍ
u'غَيْرٌ نِصَابٌ':Added, #1: 1	غَيْرُ نِصَابٍ
u'غَيْرٌ نِصَابٌ':Added, #1: 1	غَيْرَ نِصَابٍ
u'غير نصاب':Added, #1: 1	غَيْرُ نِصَابٍ
u'غَيْرٌ نصاب':Added, #4: 4	غَيْرِ النِّصَابِ
u'غير نِصَابٌ':Added, #4: 4	غَيْرِ النِّصَابِ
u'غَيْرٌ نِصَابٌ':Added, #4: 4	غَيْرِ النِّصَابِ
u'غير نصب':Added, #4: 4	غَيْرِ النِّصَابِ
u'غَيْرٌ نصب':Added, #2: 2	غَيْرِ نَصْبِ
u'غير نَصْبٌ':Added, #2: 2	غَيْرِ نَصْبِ
u'غَيْرٌ نَصْبٌ':Added, #2: 2	غَيْرِ نَصْبِ
u'غير نَصْرَانِيٌّ':Added, #2: 2	غَيْرِ نَصْبِ
u'غَيْرٌ نَصْرَانِيٌّ':Added, #1: 1	غَيْرِ النَّصْرَانِيَّةِ
u'غير نَصْرَانِيٌّ':Added, #1: 1	غَيْرِ النَّصْرَانِيَّةِ
u'غَيْرٌ نَصْرَانِيٌّ':Added, #1: 1	غَيْرَ نَصْرَانِيَّةٍ
u'غير نَصْرَانِيَّةٌ':Added, #1: 1	غَيْرَ نَصْرَانِيَّةٍ
u'غَيْرٌ نَصْرَانِيَّةٌ':Added, #1: 1	غَيْرِ النَّصْرَانِيَّةِ
u'غير نَصْرَانِيَّةٌ':Added, #1: 1	غَيْرِ النَّصْرَانِيَّةِ
u'غَيْرٌ نَصْرَانِيَّةٌ':Added, #1: 1	غَيْرَ نَصْرَانِيَّةٍ
u'غير نِصْفٌ':Added, #1: 1	غَيْرَ نَصْرَانِيَّةٍ
u'غَيْرٌ نِصْفٌ':Added, #1: 1	غَيْرِ نِصْفِ
u'غير نِصْفٌ':Added, #1: 1	غَيْرِ نِصْفِ
u'غَيْرٌ نِصْفٌ':Added, #2: 2	غَيْرَ النِّصْفِ
u'غير نِصْفٌ':Added, #2: 2	غَيْرَ النِّصْفِ
u'غَيْرٌ نِصْفٌ':Added, #3: 3	غَيْرَ نِصْفِ
u'غير نِصْفٌ':Added, #3: 3	غَيْرَ نِصْفِ
u'غَيْرٌ نِصْفٌ':Added, #4: 4	غَيْرِ النِّصْفِ
u'غير نُصُوصٌ':Added, #4: 4	غَيْرِ النِّصْفِ
u'غَيْرٌ نُصُوصٌ':Added, #1: 1	غَيْرِ النُّصُوصِ
u'غير نَصِيبٌ':Added, #1: 1	غَيْرِ النُّصُوصِ
u'غير نَصِيبٌ':Added, #1: 1	غَيْرَ نَصِيبِهِ
u'غَيْرٌ نَصِيبٌ':Added, #1: 1	غَيْرِ نَصِيبِهِ
u'غَيْرٌ نَصِيبٌ':Added, #1: 1	غَيْرَ نَصِيبِهِ
u'غير نَصِيحٌ':Added, #1: 1	غَيْرِ نَصِيبِهِ
u'غَيْرٌ نَصِيحٌ':Added, #2: 2	غَيْرِ النَّصِيحَةِ
u'غير نَصِيحَةٌ':Added, #2: 2	غَيْرِ النَّصِيحَةِ
u'غَيْرٌ نَصِيحَةٌ':Added, #2: 2	غَيْرِ النَّصِيحَةِ
u'غير نَضِيج':Added, #2: 2	غَيْرِ النَّصِيحَةِ
u'غَيْرٌ نَضِيج':Added, #1: 1	غَيْرَ نَضِيجٍ
u'غير نُطْقٌ':Added, #1: 1	غَيْرَ نَضِيجٍ
u'غَيْرٌ نُطْقٌ':Added, #1: 1	غَيْرُ النُّطْقِ
u'غير نُطْقٌ':Added, #1: 1	غَيْرُ النُّطْقِ
u'غَيْرٌ نُطْقٌ':Added, #1: 1	غَيْرِ نُطْقٍ
u'غير نَظَّامٌ':Added, #1: 1	غَيْرِ نُطْقٍ
u'غَيْرٌ نَظَّامٌ':Added, #1: 1	غَيْرُ النَّظَّامِ
u'غير نَظَرٌ':Added, #1: 1	غَيْرُ النَّظَّامِ
u'غَيْرٌ نَظَرٌ':Added, #1: 1	غَيْرَ نَظَرٍ
u'غير نَظَرٌ':Added, #1: 1	غَيْرَ نَظَرٍ
u'غَيْرٌ نَظَرٌ':Added, #4: 4	غَيْرِ النَّظَرِ
u'غير نَظَرٌ':Added, #4: 4	غَيْرِ النَّظَرِ
u'غَيْرٌ نَظَرٌ':Added, #84: 84	غَيْرِ نَظَرٍ
u'غير نَظَرِيٌّ':Added, #84: 84	غَيْرِ نَظَرٍ
u'غَيْرٌ نَظَرِيٌّ':Added, #1: 1	غَيْرُ نَظَرِيٍّ
u'غَيَّرَ نَظْمٌ':Predicate, #1: 1	غَيْرُ نَظَرِيٍّ
u'غير نَظْمٌ':Added, #1: 1	غَيَّرَ نَظْمَ
u'غَيْرٌ نَظْمٌ':Added, #1: 1	غَيْرِ النَّظْمِ
u'غير نَظْمٌ':Added, #1: 1	غَيْرِ النَّظْمِ
u'غَيْرٌ نَظْمٌ':Added, #1: 1	غَيْرِ نَظْمِهِ
u'غير نعام':Added, #1: 1	غَيْرِ نَظْمِهِ
u'غَيْرٌ نعام':Added, #1: 1	غَيْرِ النَّعَامِ
u'غير نَعَامٌ':Added, #1: 1	غَيْرِ النَّعَامِ
u'غَيْرٌ نَعَامٌ':Added, #1: 1	غَيْرِ النَّعَامِ
u'غير نَعَامَةٌ':Added, #1: 1	غَيْرِ النَّعَامِ
u'غَيْرٌ نَعَامَةٌ':Added, #1: 1	غَيْرَ نَعَامَةٍ
u'غير نَعْلٌ':Added, #1: 1	غَيْرَ نَعَامَةٍ
u'غَيْرٌ نَعْلٌ':Added, #1: 1	غَيْرِ نَعْلٍ
u'غير نَعَمٌ':Added, #1: 1	غَيْرِ نَعْلٍ
u'غير نَعَمٌ':Added, #1: 1	غَيْرُ النَّعَمِ
u'غَيْرٌ نَعَمٌ':Added, #1: 1	غَيْرِ النَّعَمِ
u'غَيْرٌ نَعَمٌ':Added, #1: 1	غَيْرُ النَّعَمِ
u'غير نفاس':Added, #1: 1	غَيْرِ النَّعَمِ
u'غَيْرٌ نفاس':Added, #1: 1	غَيْرُ نِفَاسٍ
u'غير نِفَاسٌ':Added, #1: 1	غَيْرُ نِفَاسٍ
u'غَيْرٌ نِفَاسٌ':Added, #1: 1	غَيْرُ نِفَاسٍ
u'غير نفاس':Added, #1: 1	غَيْرُ نِفَاسٍ
u'غَيْرٌ نفاس':Added, #2: 2	غَيْرِ نِفَاسٍ
u'غير نِفَاسٌ':Added, #2: 2	غَيْرِ نِفَاسٍ
u'غَيْرٌ نِفَاسٌ':Added, #2: 2	غَيْرِ نِفَاسٍ
u'غير نَفاسَة':Added, #2: 2	غَيْرِ نِفَاسٍ
u'غَيْرٌ نَفاسَة':Added, #1: 1	غَيْرِ نَفَاسَةٍ
u'غير نَفْثٌ':Added, #1: 1	غَيْرِ نَفَاسَةٍ
u'غَيْرٌ نَفْثٌ':Added, #1: 1	غَيْرِ نَفْثٍ
u'غير نفر':Added, #1: 1	غَيْرِ نَفْثٍ
u'غَيْرٌ نفر':Added, #1: 1	غَيْرِ النَّفَرِ
u'غير نَفَرٌ':Added, #1: 1	غَيْرِ النَّفَرِ
u'غَيْرٌ نَفَرٌ':Added, #1: 1	غَيْرِ النَّفَرِ
u'غير نَفْسٌ':Added, #1: 1	غَيْرِ النَّفَرِ
u'غير نَفْسٌ':Added, #1: 1	غَيْرُ نَفْسٍ
u'غَيْرٌ نَفْسٌ':Added, #1: 1	غَيْرِ نَفْسِ
u'غَيْرٌ نَفْسٌ':Added, #1: 1	غَيْرُ نَفْسٍ
u'غير نَفْسٌ':Added, #1: 1	غَيْرِ نَفْسِ
u'غَيْرٌ نَفْسٌ':Added, #3: 3	غَيْرِ النَّفْسِ
u'غير نَفْسٌ':Added, #3: 3	غَيْرِ النَّفْسِ
u'غَيْرٌ نَفْسٌ':Added, #3: 3	غَيْرُ نَفْسِ
u'غير نَفْسٌ':Added, #3: 3	غَيْرُ نَفْسِ
u'غير نَفْسٌ':Added, #4: 4	غَيْرَ نَفْسِهِ
u'غَيْرٌ نَفْسٌ':Added, #4: 4	غَيْرُ نَفْسِهِ
u'غَيْرٌ نَفْسٌ':Added, #4: 4	غَيْرَ نَفْسِهِ
u'غير نَفْسٌ':Added, #4: 4	غَيْرُ نَفْسِهِ
u'غَيْرٌ نَفْسٌ':Added, #6: 6	غَيْرِ نَفْسِهِ
u'غير نَفْعٌ':Added, #6: 6	غَيْرِ نَفْسِهِ
u'غَيْرٌ نَفْعٌ':Added, #4: 4	غَيْرِ نَفْعٍ
u'غير نَفَقَةٌ':Added, #4: 4	غَيْرِ نَفْعٍ
u'غير نَفَقَةٌ':Added, #1: 1	غَيْرُ النَّفَقَةِ
u'غَيْرٌ نَفَقَةٌ':Added, #1: 1	غَيْرِ النَّفَقَةِ
u'غَيْرٌ نَفَقَةٌ':Added, #1: 1	غَيْرُ النَّفَقَةِ
u'غير نَفَقَةٌ':Added, #1: 1	غَيْرِ النَّفَقَةِ
u'غير نَفَقَةٌ':Added, #1: 1	غَيْر نَفَقَةِ
u'غَيْرٌ نَفَقَةٌ':Added, #1: 1	غَيْرُ نَفَقَةِ
u'غَيْرٌ نَفَقَةٌ':Added, #1: 1	غَيْر نَفَقَةِ
u'غير نَفَقَةٌ':Added, #1: 1	غَيْرُ نَفَقَةِ
u'غَيْرٌ نَفَقَةٌ':Added, #2: 2	غَيْرِ نَفَقَةٍ
u'غير نَفَقَةٌ':Added, #2: 2	غَيْرِ نَفَقَةٍ
u'غَيْرٌ نَفَقَةٌ':Added, #3: 3	غَيْرَ النَّفَقَةِ
u'غير نَفْلٌ':Added, #3: 3	غَيْرَ النَّفَقَةِ
u'غَيْرٌ نَفْلٌ':Added, #1: 1	غَيْرِ النَّفْلِ
u'غير نَفْلٌ':Added, #1: 1	غَيْرِ النَّفْلِ
u'غَيْرٌ نَفْلٌ':Added, #2: 2	غَيْرُ النَّفْلِ
u'غير نُفُوذٌ':Added, #2: 2	غَيْرُ النَّفْلِ
u'غير نُفُوذٌ':Added, #1: 1	غَيْرِ نُفُوذٍ
u'غَيْرٌ نُفُوذٌ':Added, #1: 1	غَيْرِ نُفُوذِ
u'غَيْرٌ نُفُوذٌ':Added, #1: 1	غَيْرِ نُفُوذٍ
u'غير نَفْيٌ':Added, #1: 1	غَيْرِ نُفُوذِ
u'غَيْرٌ نَفْيٌ':Added, #1: 1	غَيْرِ نَفْيٍ
u'غير نَفْيٌ':Added, #1: 1	غَيْرِ نَفْيٍ
u'غَيْرٌ نَفْيٌ':Added, #2: 2	غَيْرُ نَفْيِ
u'غير نَفْيٌ':Added, #2: 2	غَيْرُ نَفْيِ
u'غَيْرٌ نَفْيٌ':Added, #3: 3	غَيْرَ النَّفْيِ
u'غير نَفْيٌ':Added, #3: 3	غَيْرَ النَّفْيِ
u'غَيْرٌ نَفْيٌ':Added, #4: 4	غَيْرِ نَفْيِ
u'غير نَفْيٌ':Added, #4: 4	غَيْرِ نَفْيِ
u'غَيْرٌ نَفْيٌ':Added, #6: 6	غَيْرِ النَّفْيِ
u'غير نَفِيرٌ':Added, #6: 6	غَيْرِ النَّفْيِ
u'غَيْرٌ نَفِيرٌ':Added, #1: 1	غَيْرِ النَّفِيرِ
u'غير نَقْدٌ':Added, #1: 1	غَيْرِ النَّفِيرِ
u'غير نَقْد':Added, #11: 11	غَيْرِ النَّقْدَيْنِ
u'غَيْرٌ نَقْدٌ':Added, #11: 11	غَيْرِ النَّقْدَيْنِ
u'غَيْرٌ نَقْد':Added, #11: 11	غَيْرِ النَّقْدَيْنِ
u'غير نَقْدٌ':Added, #11: 11	غَيْرِ النَّقْدَيْنِ
u'غير نَقْدٌ':Added, #1: 1	غَيْرَ النَّقْدِ
u'غير نَقْد':Added, #1: 1	غَيْرُ النَّقْدِ
u'غير نَقْد':Added, #1: 1	غَيْرَ النَّقْدِ
u'غَيْرٌ نَقْدٌ':Added, #1: 1	غَيْرُ النَّقْدِ
u'غَيْرٌ نَقْدٌ':Added, #1: 1	غَيْرَ النَّقْدِ
u'غَيْرٌ نَقْد':Added, #1: 1	غَيْرُ النَّقْدِ
u'غَيْرٌ نَقْد':Added, #1: 1	غَيْرَ النَّقْدِ
u'غير نَقْدٌ':Added, #1: 1	غَيْرُ النَّقْدِ
u'غير نَقْد':Added, #1: 1	غَيْرُ النَّقْدَيْنِ
u'غَيْرٌ نَقْدٌ':Added, #1: 1	غَيْرُ النَّقْدَيْنِ
u'غَيْرٌ نَقْد':Added, #1: 1	غَيْرُ النَّقْدَيْنِ
u'غير نَقْدٌ':Added, #1: 1	غَيْرُ النَّقْدَيْنِ
u'غير نَقْدٌ':Added, #1: 1	غَيْرَ نَقْدِ
u'غير نَقْدٌ':Added, #1: 1	غَيْرُ نَقْدٍ
u'غير نَقْد':Added, #1: 1	غَيْرُ نَقْدِ
u'غير نَقْد':Added, #1: 1	غَيْرَ نَقْدِ
u'غير نَقْد':Added, #1: 1	غَيْرُ نَقْدٍ
u'غَيْرٌ نَقْدٌ':Added, #1: 1	غَيْرُ نَقْدِ
u'غَيْرٌ نَقْدٌ':Added, #1: 1	غَيْرَ نَقْدِ
u'غَيْرٌ نَقْدٌ':Added, #1: 1	غَيْرُ نَقْدٍ
u'غَيْرٌ نَقْد':Added, #1: 1	غَيْرُ نَقْدِ
u'غَيْرٌ نَقْد':Added, #1: 1	غَيْرَ نَقْدِ
u'غَيْرٌ نَقْد':Added, #1: 1	غَيْرُ نَقْدٍ
u'غير نَقْدٌ':Added, #1: 1	غَيْرُ نَقْدِ
u'غير نَقْد':Added, #1: 1	غَيْرَ نَقْدَيْنِ
u'غَيْرٌ نَقْدٌ':Added, #1: 1	غَيْرَ نَقْدَيْنِ
u'غَيْرٌ نَقْد':Added, #1: 1	غَيْرَ نَقْدَيْنِ
u'غير نَقْدٌ':Added, #1: 1	غَيْرَ نَقْدَيْنِ
u'غير نَقْد':Added, #2: 2	غَيْرَ النَّقْدَيْنِ
u'غَيْرٌ نَقْدٌ':Added, #2: 2	غَيْرَ النَّقْدَيْنِ
u'غَيْرٌ نَقْد':Added, #2: 2	غَيْرَ النَّقْدَيْنِ
u'غير نَقْدٌ':Added, #2: 2	غَيْرَ النَّقْدَيْنِ
u'غير نَقْد':Added, #4: 4	غَيْرِ النَّقْدِ
u'غَيْرٌ نَقْدٌ':Added, #4: 4	غَيْرِ النَّقْدِ
u'غَيْرٌ نَقْد':Added, #4: 4	غَيْرِ النَّقْدِ
u'غير نَقْدٌ':Added, #4: 4	غَيْرِ النَّقْدِ
u'غير نَقْد':Added, #5: 5	غَيْرِ نَقْدٍ
u'غَيْرٌ نَقْدٌ':Added, #5: 5	غَيْرِ نَقْدٍ
u'غَيْرٌ نَقْد':Added, #5: 5	غَيْرِ نَقْدٍ
u'غير نَقْدٌ':Added, #5: 5	غَيْرِ نَقْدٍ
u'غير نَقْد':Added, #6: 6	غَيْرَ نَقْدٍ
u'غَيْرٌ نَقْدٌ':Added, #6: 6	غَيْرَ نَقْدٍ
u'غَيْرٌ نَقْد':Added, #6: 6	غَيْرَ نَقْدٍ
u'غير نَقْدٌ':Added, #6: 6	غَيْرَ نَقْدٍ
u'غير نَقْد':Added, #8: 8	غَيْرِ نَقْدِ
u'غَيْرٌ نَقْدٌ':Added, #8: 8	غَيْرِ نَقْدِ
u'غَيْرٌ نَقْد':Added, #8: 8	غَيْرِ نَقْدِ
u'غير نَقْشٌ':Added, #8: 8	غَيْرِ نَقْدِ
u'غير نَقْشٌ':Added, #1: 1	غَيْرِ نَقْشٍ
u'غَيْرٌ نَقْشٌ':Added, #1: 1	غَيْرِ نَقْشِ
u'غَيْرٌ نَقْشٌ':Added, #1: 1	غَيْرِ نَقْشٍ
u'غير نَقْصٌ':Added, #1: 1	غَيْرِ نَقْشِ
u'غَيْرٌ نَقْصٌ':Added, #2: 2	غَيْرِ نَقْصِ
u'غير نَقْصٌ':Added, #2: 2	غَيْرِ نَقْصِ
u'غَيْرٌ نَقْصٌ':Added, #7: 7	غَيْرِ نَقْصٍ
u'غير نُقْصَانٌ':Added, #7: 7	غَيْرِ نَقْصٍ
u'غَيْرٌ نُقْصَانٌ':Added, #1: 1	غَيْرُ النُّقْصَانِ
u'غير نُقْصَانٌ':Added, #1: 1	غَيْرُ النُّقْصَانِ
u'غَيْرٌ نُقْصَانٌ':Added, #2: 2	غَيْرِ نُقْصَانٍ
u'غير نَقْضٌ':Added, #2: 2	غَيْرِ نُقْصَانٍ
u'غَيْرٌ نَقْضٌ':Added, #2: 2	غَيْرُ نَقْضٍ
u'غير نَقْضٌ':Added, #2: 2	غَيْرُ نَقْضٍ
u'غَيْرٌ نَقْضٌ':Added, #3: 3	غَيْرِ نَقْضٍ
u'غير نَقْضٌ':Added, #3: 3	غَيْرِ نَقْضٍ
u'غَيْرٌ نَقْضٌ':Added, #4: 4	غَيْرِ نَقْضِ
u'غير نقل':Added, #4: 4	غَيْرِ نَقْضِ
u'غَيْرٌ نقل':Added, #1: 1	غَيْرِ النَّقْلِ
u'غير نَقْلٌ':Added, #1: 1	غَيْرِ النَّقْلِ
u'غَيْرٌ نَقْلٌ':Added, #1: 1	غَيْرِ النَّقْلِ
u'غير نقل':Added, #1: 1	غَيْرِ النَّقْلِ
u'غَيْرٌ نقل':Added, #2: 2	غَيْرِ نَقْلِ
u'غير نَقْلٌ':Added, #2: 2	غَيْرِ نَقْلِ
u'غَيْرٌ نَقْلٌ':Added, #2: 2	غَيْرِ نَقْلِ
u'غير نقل':Added, #2: 2	غَيْرِ نَقْلِ
u'غَيْرٌ نقل':Added, #2: 2	غَيْرِ نَقْلِهِ
u'غير نَقْلٌ':Added, #2: 2	غَيْرِ نَقْلِهِ
u'غَيْرٌ نَقْلٌ':Added, #2: 2	غَيْرِ نَقْلِهِ
u'غير نَقْلٌ':Added, #2: 2	غَيْرِ نَقْلِهِ
u'غَيْرٌ نَقْلٌ':Added, #7: 7	غَيْرِ نَقْلٍ
u'غير نُقُودٌ':Added, #7: 7	غَيْرِ نَقْلٍ
u'غَيْرٌ نُقُودٌ':Added, #2: 2	غَيْرِ النُّقُودِ
u'غير نَقِيٌّ':Added, #2: 2	غَيْرِ النُّقُودِ
u'غَيْرٌ نَقِيٌّ':Added, #1: 1	غَيْرَ نَقِيَّةٍ
u'غير نَقِيبٌ':Added, #1: 1	غَيْرَ نَقِيَّةٍ
u'غَيْرٌ نَقِيبٌ':Added, #1: 1	غَيْرِ النَّقِيبَيْنِ
u'غير نَقِيبٌ':Added, #1: 1	غَيْرِ النَّقِيبَيْنِ
u'غَيْرٌ نَقِيبٌ':Added, #1: 1	غَيْرِ نَقِيبِهِ
u'غير نكاح':Added, #1: 1	غَيْرِ نَقِيبِهِ
u'غَيْرٌ نكاح':Added, #10: 10	غَيْرِ النِّكَاحِ
u'غير نِكَاحٌ':Added, #10: 10	غَيْرِ النِّكَاحِ
u'غَيْرٌ نِكَاحٌ':Added, #10: 10	غَيْرِ النِّكَاحِ
u'غير نكاح':Added, #10: 10	غَيْرِ النِّكَاحِ
u'غَيْرٌ نكاح':Added, #1: 1	غَيْرِ نِكَاحِهِ
u'غير نِكَاحٌ':Added, #1: 1	غَيْرِ نِكَاحِهِ
u'غَيْرٌ نِكَاحٌ':Added, #1: 1	غَيْرِ نِكَاحِهِ
u'غير نكاح':Added, #1: 1	غَيْرِ نِكَاحِهِ
u'غَيْرٌ نكاح':Added, #3: 3	غَيْرُ النِّكَاحِ
u'غير نِكَاحٌ':Added, #3: 3	غَيْرُ النِّكَاحِ
u'غَيْرٌ نِكَاحٌ':Added, #3: 3	غَيْرُ النِّكَاحِ
u'غير نكاح':Added, #3: 3	غَيْرُ النِّكَاحِ
u'غَيْرٌ نكاح':Added, #4: 4	غَيْرَ النِّكَاحِ
u'غير نِكَاحٌ':Added, #4: 4	غَيْرَ النِّكَاحِ
u'غَيْرٌ نِكَاحٌ':Added, #4: 4	غَيْرَ النِّكَاحِ
u'غير نكاح':Added, #4: 4	غَيْرَ النِّكَاحِ
u'غَيْرٌ نكاح':Added, #6: 6	غَيْرِ نِكَاحٍ
u'غير نِكَاحٌ':Added, #6: 6	غَيْرِ نِكَاحٍ
u'غَيْرٌ نِكَاحٌ':Added, #6: 6	غَيْرِ نِكَاحٍ
u'غير نِكَايَةٌ':Added, #6: 6	غَيْرِ نِكَاحٍ
u'غَيْرٌ نِكَايَةٌ':Added, #3: 3	غَيْرِ نِكَايَةٍ
u'غير نَكِرٌ':Added, #3: 3	غَيْرِ نِكَايَةٍ
u'غَيْرٌ نَكِرٌ':Added, #1: 1	غَيْرِ النَّكِرَةِ
u'غير نكرة':Added, #1: 1	غَيْرِ النَّكِرَةِ
u'غَيْرٌ نكرة':Added, #1: 1	غَيْرِ النَّكِرَةِ
u'غير نَكِرَةٌ':Added, #1: 1	غَيْرِ النَّكِرَةِ
u'غَيْرٌ نَكِرَةٌ':Added, #1: 1	غَيْرِ النَّكِرَةِ
u'غير نُكُولٌ':Added, #1: 1	غَيْرِ النَّكِرَةِ
u'غَيْرٌ نُكُولٌ':Added, #2: 2	غَيْرِ نُكُولٍ
u'غير نَكِيرٌ':Added, #2: 2	غَيْرِ نُكُولٍ
u'غَيْرٌ نَكِيرٌ':Added, #1: 1	غَيْر نَكِيرٍ
u'غير نَكِيرٌ':Added, #1: 1	غَيْر نَكِيرٍ
u'غَيْرٌ نَكِيرٌ':Added, #5: 5	غَيْرِ نَكِيرِ
u'غير نَكِيرٌ':Added, #5: 5	غَيْرِ نَكِيرِ
u'غَيْرٌ نَكِيرٌ':Added, #84: 84	غَيْرِ نَكِيرٍ
u'غير نَمِرٌ':Added, #84: 84	غَيْرِ نَكِيرٍ
u'غَيْرٌ نَمِرٌ':Added, #1: 1	غَيْرُ النَّمِرَةِ
u'غير نهار':Added, #1: 1	غَيْرُ النَّمِرَةِ
u'غَيْرٌ نهار':Added, #1: 1	غَيْرِ النَّهَارِ
u'غير نَهَارٌ':Added, #1: 1	غَيْرِ النَّهَارِ
u'غَيْرٌ نَهَارٌ':Added, #1: 1	غَيْرِ النَّهَارِ
u'غير نِهَايَةٌ':Added, #1: 1	غَيْرِ النَّهَارِ
u'غَيْرٌ نِهَايَةٌ':Added, #1: 1	غَيْرِ النِّهَايَةِ
u'غير نِهَايَةٌ':Added, #1: 1	غَيْرِ النِّهَايَةِ
u'غَيْرٌ نِهَايَةٌ':Added, #5: 5	غَيْرِ نِهَايَةٍ
u'غير نَهْيٌ':Added, #5: 5	غَيْرِ نِهَايَةٍ
u'غَيْرٌ نَهْيٌ':Added, #1: 1	غَيْرِ نَهْيِ
u'غير نَهْيٌ':Added, #1: 1	غَيْرِ نَهْيِ
u'غَيْرٌ نَهْيٌ':Added, #2: 2	غَيْرِ النَّهْيِ
u'غير نَهْيٌ':Added, #2: 2	غَيْرِ النَّهْيِ
u'غَيْرٌ نَهْيٌ':Added, #3: 3	غَيْرِ نَهْيٍ
u'غير نَوَازِلُ':Added, #3: 3	غَيْرِ نَهْيٍ
u'غَيْرٌ نَوَازِلُ':Added, #2: 2	غَيْرِ النَّوَازِلِ
u'غير نَوْبَةٌ':Added, #2: 2	غَيْرِ النَّوَازِلِ
u'غَيْرٌ نَوْبَةٌ':Added, #1: 1	غَيْرِ النَّوْبَةِ
u'غير نَوْبَةٌ':Added, #1: 1	غَيْرِ النَّوْبَةِ
u'غَيْرٌ نَوْبَةٌ':Added, #2: 2	غَيْرِ نَوْبَةِ
u'غير نَوْبَةٌ':Added, #2: 2	غَيْرِ نَوْبَةِ
u'غَيْرٌ نَوْبَةٌ':Added, #4: 4	غَيْرِ نَوْبَتِهِ
u'غير نَوْحٌ':Added, #4: 4	غَيْرِ نَوْبَتِهِ
u'غَيْرٌ نَوْحٌ':Added, #2: 2	غَيْرِ نَوْحٍ
u'غير نَوْرٌ':Added, #2: 2	غَيْرِ نَوْحٍ
u'غَيْرٌ نَوْرٌ':Added, #1: 1	غَيْرِ نَوْرٍ
u'غير نَوْعٌ':Added, #1: 1	غَيْرِ نَوْرٍ
u'غَيْرٌ نَوْعٌ':Added, #1: 1	غَيْرُ النَّوْعِ
u'غير نَوْعٌ':Added, #1: 1	غَيْرُ النَّوْعِ
u'غَيْرٌ نَوْعٌ':Added, #1: 1	غَيْرَ نَوْعِهِ
u'غير نَوْعٌ':Added, #1: 1	غَيْرَ نَوْعِهِ
u'غَيْرٌ نَوْعٌ':Added, #5: 5	غَيْرِ نَوْعِ
u'غير نَوْعٌ':Added, #5: 5	غَيْرِ نَوْعِ
u'غَيْرٌ نَوْعٌ':Added, #7: 7	غَيْرِ نَوْعِهِ
u'غير نَوْمٌ':Added, #7: 7	غَيْرِ نَوْعِهِ
u'غير نَوْمٌ':Added, #1: 1	غَيْرَ نَوْمٍ
u'غير نَوْمٌ':Added, #1: 1	غَيْرُ نَوْمٍ
u'غَيْرٌ نَوْمٌ':Added, #1: 1	غَيْرُ نَوْمِ
u'غَيْرٌ نَوْمٌ':Added, #1: 1	غَيْرَ نَوْمٍ
u'غَيْرٌ نَوْمٌ':Added, #1: 1	غَيْرُ نَوْمٍ
u'غير نَوْمٌ':Added, #1: 1	غَيْرُ نَوْمِ
u'غَيْرٌ نَوْمٌ':Added, #2: 2	غَيْرِ نَوْمٍ
u'غير نِيْءٌ':Added, #2: 2	غَيْرِ نَوْمٍ
u'غير نِيْءٌ':Added, #1: 1	غَيْرَ النِّيءِ
u'غَيْرٌ نِيْءٌ':Added, #1: 1	غَيْرِ النِّيءِ
u'غَيْرٌ نِيْءٌ':Added, #1: 1	غَيْرَ النِّيءِ
u'غير نِيَابَةٌ':Added, #1: 1	غَيْرِ النِّيءِ
u'غَيْرٌ نِيَابَةٌ':Added, #2: 2	غَيْرِ نِيَابَةٍ
u'غير نِيَامٌ':Added, #2: 2	غَيْرِ نِيَابَةٍ
u'غَيْرٌ نِيَامٌ':Added, #2: 2	غَيْرُ نِيَامٍ
u'غَيَّرَ نِيَّةٌ':Predicate, #2: 2	غَيْرُ نِيَامٍ
u'غَيَّرَ نِيَّةٌ':Predicate, #1: 1	غَيَّرَ نِيَّةَ
u'غير نِيَّةٌ':Added, #2: 2	غَيَّرَ النِّيَّةَ
u'غَيْرٌ نِيَّةٌ':Added, #20: 20	غَيْرِ نِيَّةِ
u'غير نِيَّةٌ':Added, #20: 20	غَيْرِ نِيَّةِ
u'غَيْرٌ نِيَّةٌ':Added, #2: 2	غَيْرُ نِيَّةِ
u'غير نِيَّةٌ':Added, #2: 2	غَيْرُ نِيَّةِ
u'غَيْرٌ نِيَّةٌ':Added, #2: 2	غَيْرِ نِيَّتِهِ
u'غير نِيَّةٌ':Added, #2: 2	غَيْرِ نِيَّتِهِ
u'غَيْرٌ نِيَّةٌ':Added, #3: 3	غَيْرُ النِّيَّةِ
u'غير نِيَّةٌ':Added, #3: 3	غَيْرُ النِّيَّةِ
u'غَيْرٌ نِيَّةٌ':Added, #4: 4	غَيْرِ النِّيَّةِ
u'غير نِيَّةٌ':Added, #4: 4	غَيْرِ النِّيَّةِ
u'غَيْرٌ نِيَّةٌ':Added, #74: 74	غَيْرِ نِيَّةٍ
u'غير نِيَّةٌ':Added, #74: 74	غَيْرِ نِيَّةٍ
u'غَيْرٌ نِيَّةٌ':Added, #7: 7	غَيْرَ النِّيَّةِ
u'غير هَالِكٌ':Added, #7: 7	غَيْرَ النِّيَّةِ
u'غَيْرٌ هَالِكٌ':Added, #1: 1	غَيْرِ هَالِكٍ
u'غير هَائِبٌ':Added, #1: 1	غَيْرِ هَالِكٍ
u'غَيْرٌ هَائِبٌ':Added, #1: 1	غَيْرَ هَائِبٍ
u'غير هِبَةٌ':Added, #1: 1	غَيْرَ هَائِبٍ
u'غير هِبَةٌ':Added, #1: 1	غَيْرُ الْهِبَةِ
u'غَيْرٌ هِبَةٌ':Added, #1: 1	غَيْرِ الْهِبَةِ
u'غَيْرٌ هِبَةٌ':Added, #1: 1	غَيْرُ الْهِبَةِ
u'غير هِبَةٌ':Added, #1: 1	غَيْرِ الْهِبَةِ
u'غَيْرٌ هِبَةٌ':Added, #1: 1	غَيْرِ هِبَةِ
u'غير هَتْكٌ':Added, #1: 1	غَيْرِ هِبَةِ
u'غَيْرٌ هَتْكٌ':Added, #1: 1	غَيْرِ هَتْكِ
u'غير هِدَايَةٌ':Added, #1: 1	غَيْرِ هَتْكِ
u'غَيْرٌ هِدَايَةٌ':Added, #1: 1	غَيْرِ هِدَايَتِهِ
u'غير هِدَايَةٌ':Added, #1: 1	غَيْرِ هِدَايَتِهِ
u'غَيْرٌ هِدَايَةٌ':Added, #2: 2	غَيْرِ الْهِدَايَةِ
u'غير هَدْمٌ':Added, #2: 2	غَيْرِ الْهِدَايَةِ
u'غَيْرٌ هَدْمٌ':Added, #1: 1	غَيْرِ هَدْمٍ
u'غير هُدْنَةٌ':Added, #1: 1	غَيْرِ هَدْمٍ
u'غَيْرٌ هُدْنَةٌ':Added, #1: 1	غَيْرِ الْهُدْنَةِ
u'غير هَدِيٌّ':Added, #1: 1	غَيْرِ الْهُدْنَةِ
u'غَيْرٌ هَدِيٌّ':Added, #1: 1	غَيْرِ الْهَدِيَّةِ
u'غير هَدْيٌ':Added, #1: 1	غَيْرِ الْهَدِيَّةِ
u'غَيْرٌ هَدْيٌ':Added, #1: 1	غَيْرَ هَدْيٍ
u'غير هَدِيَّةٌ':Added, #1: 1	غَيْرَ هَدْيٍ
u'غَيْرٌ هَدِيَّةٌ':Added, #1: 1	غَيْرِ الْهَدِيَّةِ
u'غير هِرٌّ':Added, #1: 1	غَيْرِ الْهَدِيَّةِ
u'غير هِرٌّ':Added, #1: 1	غَيْرُ الْهِرِّ
u'غَيْرٌ هِرٌّ':Added, #1: 1	غَيْرِ الْهِرِّ
u'غَيْرٌ هِرٌّ':Added, #1: 1	غَيْرُ الْهِرِّ
u'غير هَرَب':Added, #1: 1	غَيْرِ الْهِرِّ
u'غَيْرٌ هَرَب':Added, #1: 1	غَيْرِ هَرَبٍ
u'غير هَرَمٌ':Added, #1: 1	غَيْرِ هَرَبٍ
u'غَيْرٌ هَرَمٌ':Added, #1: 1	غَيْرَ الْهَرَمِ
u'غير هَزّ':Added, #1: 1	غَيْرَ الْهَرَمِ
u'غَيْرٌ هَزّ':Added, #1: 1	غَيْرِ هَزٍّ
u'غير هشام':Added, #1: 1	غَيْرِ هَزٍّ
u'غير هشام':Added, #1: 1	غَيْرُ هِشَامٍ
u'غَيْرٌ هشام':Added, #1: 1	غَيْرُ هِشَامِ
u'غَيْرٌ هشام':Added, #1: 1	غَيْرُ هِشَامٍ
u'غير هِشَامٌ':Added, #1: 1	غَيْرُ هِشَامِ
u'غير هِشَامٌ':Added, #1: 1	غَيْرُ هِشَامٍ
u'غَيْرٌ هِشَامٌ':Added, #1: 1	غَيْرُ هِشَامِ
u'غَيْرٌ هِشَامٌ':Added, #1: 1	غَيْرُ هِشَامٍ
u'غير هِلاَلٌ':Added, #1: 1	غَيْرُ هِشَامِ
u'غَيْرٌ هِلاَلٌ':Added, #1: 1	غَيْرُ هِلَالٍ
u'غير هِلاَلٌ':Added, #1: 1	غَيْرُ هِلَالٍ
u'غَيْرٌ هِلاَلٌ':Added, #2: 2	غَيْرِ هِلَالِ
u'غير هَمْزٌ':Added, #2: 2	غَيْرِ هِلَالِ
u'غَيْرٌ هَمْزٌ':Added, #2: 2	غَيْرِ هَمْزٍ
u'غير همزة':Added, #2: 2	غَيْرِ هَمْزٍ
u'غَيْرٌ همزة':Added, #1: 1	غَيْرُ هَمْزَةٍ
u'غير هَمْزَةٌ':Added, #1: 1	غَيْرُ هَمْزَةٍ
u'غَيْرٌ هَمْزَةٌ':Added, #1: 1	غَيْرُ هَمْزَةٍ
u'غير هِمْلاج':Added, #1: 1	غَيْرُ هَمْزَةٍ
u'غَيْرٌ هِمْلاج':Added, #1: 1	غَيْرَ هِمْلَاجٍ
u'غير هَيُوبٌ':Added, #1: 1	غَيْرَ هِمْلَاجٍ
u'غَيْرٌ هَيُوبٌ':Added, #1: 1	غَيْرَ هَيُوبِ
u'غَيَّرَ هَيْئَةٌ':Predicate, #1: 1	غَيْرَ هَيُوبِ
u'غير هَيْئَةٌ':Added, #4: 4	غَيَّرَ هَيْئَةَ
u'غَيْرٌ هَيْئَةٌ':Added, #1: 1	غَيْرِ الْهَيْئَةِ
u'غير وَاثِقٌ':Added, #1: 1	غَيْرِ الْهَيْئَةِ
u'غَيْرٌ وَاثِقٌ':Added, #1: 1	غَيْرُ وَاثِقٍ
u'غير وَاجِبٌ':Added, #1: 1	غَيْرُ وَاثِقٍ
u'غَيْرٌ وَاجِبٌ':Added, #10: 10	غَيْرِ وَاجِبٍ
u'غير وَاجِبٌ':Added, #10: 10	غَيْرِ وَاجِبٍ
u'غَيْرٌ وَاجِبٌ':Added, #15: 15	غَيْرِ الْوَاجِبِ
u'غير وَاجِبٌ':Added, #15: 15	غَيْرِ الْوَاجِبِ
u'غَيْرٌ وَاجِبٌ':Added, #16: 16	غَيْرَ وَاجِبٍ
u'غير وَاجِبٌ':Added, #16: 16	غَيْرَ وَاجِبٍ
u'غَيْرٌ وَاجِبٌ':Added, #1: 1	غَيْرُ وَاجِبِ
u'غير وَاجِبٌ':Added, #1: 1	غَيْرُ وَاجِبِ
u'غَيْرٌ وَاجِبٌ':Added, #1: 1	غَيْرُ وَاجِبِهِ
u'غير وَاجِبٌ':Added, #1: 1	غَيْرُ وَاجِبِهِ
u'غَيْرٌ وَاجِبٌ':Added, #1: 1	غَيْرُ وَاجِبَيْنِ
u'غير وَاجِبٌ':Added, #1: 1	غَيْرُ وَاجِبَيْنِ
u'غَيْرٌ وَاجِبٌ':Added, #3: 3	غَيْرَ وَاجِبِ
u'غير وَاجِبٌ':Added, #3: 3	غَيْرَ وَاجِبِ
u'غَيْرٌ وَاجِبٌ':Added, #4: 4	غَيْرِ الْوَاجِبَةِ
u'غير وَاجِبٌ':Added, #4: 4	غَيْرِ الْوَاجِبَةِ
u'غَيْرٌ وَاجِبٌ':Added, #50: 50	غَيْرُ وَاجِبَةٍ
u'غير وَاجِبٌ':Added, #50: 50	غَيْرُ وَاجِبَةٍ
u'غَيْرٌ وَاجِبٌ':Added, #5: 5	غَيْرِ وَاجِبَةٍ
u'غير وَاجِبٌ':Added, #5: 5	غَيْرِ وَاجِبَةٍ
u'غَيْرٌ وَاجِبٌ':Added, #6: 6	غَيْرَ وَاجِبَةٍ
u'غير وَاجِبٌ':Added, #6: 6	غَيْرَ وَاجِبَةٍ
u'غَيْرٌ وَاجِبٌ':Added, #7: 7	غَيْرَ الْوَاجِبِ
u'غير وَاجِبٌ':Added, #7: 7	غَيْرَ الْوَاجِبِ
u'غَيْرٌ وَاجِبٌ':Added, #96: 96	غَيْرُ وَاجِبٍ
u'غير وَاجِدٌ':Added, #96: 96	غَيْرُ وَاجِبٍ
u'غَيْرٌ وَاجِدٌ':Added, #12: 12	غَيْرُ وَاجِدٍ
u'غير وَاجِدٌ':Added, #12: 12	غَيْرُ وَاجِدٍ
u'غَيْرٌ وَاجِدٌ':Added, #1: 1	غَيْرِ وَاجِدِهِ
u'غير وَاجِدٌ':Added, #1: 1	غَيْرِ وَاجِدِهِ
u'غَيْرٌ وَاجِدٌ':Added, #2: 2	غَيْرَ وَاجِدٍ
u'غير واحد':Added, #2: 2	غَيْرَ وَاجِدٍ
u'غَيْرٌ واحد':Added, #101: 101	غَيْرِ وَاحِدٍ
u'غير وَاحِدٌ':Added, #101: 101	غَيْرِ وَاحِدٍ
u'غَيْرٌ وَاحِدٌ':Added, #101: 101	غَيْرِ وَاحِدٍ
u'غير واحد':Added, #101: 101	غَيْرِ وَاحِدٍ
u'غَيْرٌ واحد':Added, #12: 12	غَيْرَ وَاحِدَةٍ
u'غير وَاحِدٌ':Added, #12: 12	غَيْرَ وَاحِدَةٍ
u'غَيْرٌ وَاحِدٌ':Added, #12: 12	غَيْرَ وَاحِدَةٍ
u'غير واحد':Added, #12: 12	غَيْرَ وَاحِدَةٍ
u'غَيْرٌ واحد':Added, #1: 1	غَيْرِ الْوَاحِدِ
u'غير وَاحِدٌ':Added, #1: 1	غَيْرِ الْوَاحِدِ
u'غَيْرٌ وَاحِدٌ':Added, #1: 1	غَيْرِ الْوَاحِدِ
u'غير واحد':Added, #1: 1	غَيْرِ الْوَاحِدِ
u'غَيْرٌ واحد':Added, #1: 1	غَيْرَ الْوَاحِدَةِ
u'غير وَاحِدٌ':Added, #1: 1	غَيْرَ الْوَاحِدَةِ
u'غَيْرٌ وَاحِدٌ':Added, #1: 1	غَيْرَ الْوَاحِدَةِ
u'غير واحد':Added, #1: 1	غَيْرَ الْوَاحِدَةِ
u'غَيْرٌ واحد':Added, #1: 1	غَيْرِ وَاحِدِهِ
u'غير وَاحِدٌ':Added, #1: 1	غَيْرِ وَاحِدِهِ
u'غَيْرٌ وَاحِدٌ':Added, #1: 1	غَيْرِ وَاحِدِهِ
u'غير واحد':Added, #1: 1	غَيْرِ وَاحِدِهِ
u'غَيْرٌ واحد':Added, #27: 27	غَيْرَ وَاحِدٍ
u'غير وَاحِدٌ':Added, #27: 27	غَيْرَ وَاحِدٍ
u'غَيْرٌ وَاحِدٌ':Added, #27: 27	غَيْرَ وَاحِدٍ
u'غير واحد':Added, #27: 27	غَيْرَ وَاحِدٍ
u'غَيْرٌ واحد':Added, #2: 2	غَيْرُ وَاحِدَةٍ
u'غير وَاحِدٌ':Added, #2: 2	غَيْرُ وَاحِدَةٍ
u'غَيْرٌ وَاحِدٌ':Added, #2: 2	غَيْرُ وَاحِدَةٍ
u'غير واحد':Added, #2: 2	غَيْرُ وَاحِدَةٍ
u'غَيْرٌ واحد':Added, #3: 3	غَيْرِ وَاحِدَةٍ
u'غير وَاحِدٌ':Added, #3: 3	غَيْرِ وَاحِدَةٍ
u'غَيْرٌ وَاحِدٌ':Added, #3: 3	غَيْرِ وَاحِدَةٍ
u'غير واحد':Added, #3: 3	غَيْرِ وَاحِدَةٍ
u'غَيْرٌ واحد':Added, #4: 4	غَيْرُ وَاحِدِ
u'غير وَاحِدٌ':Added, #4: 4	غَيْرُ وَاحِدِ
u'غَيْرٌ وَاحِدٌ':Added, #4: 4	غَيْرُ وَاحِدِ
u'غير واحد':Added, #4: 4	غَيْرُ وَاحِدِ
u'غَيْرٌ واحد':Added, #571: 571	غَيْرُ وَاحِدٍ
u'غير وَاحِدٌ':Added, #571: 571	غَيْرُ وَاحِدٍ
u'غَيْرٌ وَاحِدٌ':Added, #571: 571	غَيْرُ وَاحِدٍ
u'غير واحد':Added, #571: 571	غَيْرُ وَاحِدٍ
u'غَيْرٌ واحد':Added, #5: 5	غَيْرُ الْوَاحِدِ
u'غير وَاحِدٌ':Added, #5: 5	غَيْرُ الْوَاحِدِ
u'غَيْرٌ وَاحِدٌ':Added, #5: 5	غَيْرُ الْوَاحِدِ
u'غير واحد':Added, #5: 5	غَيْرُ الْوَاحِدِ
u'غَيْرٌ واحد':Added, #7: 7	غَيْرُ الْوَاحِدَةِ
u'غير وَاحِدٌ':Added, #7: 7	غَيْرُ الْوَاحِدَةِ
u'غَيْرٌ وَاحِدٌ':Added, #7: 7	غَيْرُ الْوَاحِدَةِ
u'غير وَارِثٌ':Added, #7: 7	غَيْرُ الْوَاحِدَةِ
u'غَيْرٌ وَارِثٌ':Added, #11: 11	غَيْرِ الْوَارِثِ
u'غير وَارِثٌ':Added, #11: 11	غَيْرِ الْوَارِثِ
u'غَيْرٌ وَارِثٌ':Added, #16: 16	غَيْرُ وَارِثٍ
u'غير وَارِثٌ':Added, #16: 16	غَيْرُ وَارِثٍ
u'غَيْرٌ وَارِثٌ':Added, #17: 17	غَيْرِ وَارِثٍ
u'غير وَارِثٌ':Added, #17: 17	غَيْرِ وَارِثٍ
u'غَيْرٌ وَارِثٌ':Added, #1: 1	غَيْرَ الْوَارِثِ
u'غير وَارِثٌ':Added, #1: 1	غَيْرَ الْوَارِثِ
u'غَيْرٌ وَارِثٌ':Added, #1: 1	غَيْرُ وَارِثِهِ
u'غير وَارِثٌ':Added, #1: 1	غَيْرُ وَارِثِهِ
u'غَيْرٌ وَارِثٌ':Added, #1: 1	غَيْرُ وَارِثَيْنِ
u'غير وَارِثٌ':Added, #1: 1	غَيْرُ وَارِثَيْنِ
u'غَيْرٌ وَارِثٌ':Added, #2: 2	غَيْرُ وَارِثَةٍ
u'غير وَارِثٌ':Added, #2: 2	غَيْرُ وَارِثَةٍ
u'غَيْرٌ وَارِثٌ':Added, #31: 31	غَيْرَ وَارِثٍ
u'غير وَارِثٌ':Added, #31: 31	غَيْرَ وَارِثٍ
u'غَيْرٌ وَارِثٌ':Added, #3: 3	غَيْرُ الْوَارِثِ
u'غير وَارِثٌ':Added, #3: 3	غَيْرُ الْوَارِثِ
u'غَيْرٌ وَارِثٌ':Added, #3: 3	غَيْرَ وَارِثَةٍ
u'غير وَارِدٌ':Added, #3: 3	غَيْرَ وَارِثَةٍ
u'غَيْرٌ وَارِدٌ':Added, #19: 19	غَيْرُ وَارِدٍ
u'غير وَارِدٌ':Added, #19: 19	غَيْرُ وَارِدٍ
u'غَيْرٌ وَارِدٌ':Added, #1: 1	غَيْرَ وَارِدٍ
u'غير وَارِدٌ':Added, #1: 1	غَيْرَ وَارِدٍ
u'غَيْرٌ وَارِدٌ':Added, #1: 1	غَيْرُ وَارِدَةٍ
u'غير وَاسِطٌ':Added, #1: 1	غَيْرُ وَارِدَةٍ
u'غَيْرٌ وَاسِطٌ':Added, #17: 17	غَيْرِ وَاسِطَةٍ
u'غير وَاسِطٌ':Added, #17: 17	غَيْرِ وَاسِطَةٍ
u'غَيْرٌ وَاسِطٌ':Added, #2: 2	غَيْرِ وَاسِطَةِ
u'غير واصِف':Added, #2: 2	غَيْرِ وَاسِطَةِ
u'غَيْرٌ واصِف':Added, #1: 1	غَيْرَ وَاصِفٍ
u'غير واصِف':Added, #1: 1	غَيْرَ وَاصِفٍ
u'غَيْرٌ واصِف':Added, #1: 1	غَيْرَ وَاصِفَةٍ
u'غير واصِفَة':Added, #1: 1	غَيْرَ وَاصِفَةٍ
u'غَيْرٌ واصِفَة':Added, #1: 1	غَيْرَ وَاصِفَةٍ
u'غير وَاصِلٌ':Added, #1: 1	غَيْرَ وَاصِفَةٍ
u'غَيْرٌ وَاصِلٌ':Added, #1: 1	غَيْرُ وَاصِلٍ
u'غير وَاضِحٌ':Added, #1: 1	غَيْرُ وَاصِلٍ
u'غَيْرٌ وَاضِحٌ':Added, #1: 1	غَيْرُ وَاضِحِ
u'غير وَاضِحٌ':Added, #1: 1	غَيْرُ وَاضِحِ
u'غَيْرٌ وَاضِحٌ':Added, #7: 7	غَيْرُ وَاضِحٍ
u'غير وَاضِعٌ':Added, #7: 7	غَيْرُ وَاضِحٍ
u'غَيْرٌ وَاضِعٌ':Added, #1: 1	غَيْرُ الْوَاضِعِ
u'غير وَاضِعٌ':Added, #1: 1	غَيْرُ الْوَاضِعِ
u'غَيْرٌ وَاضِعٌ':Added, #1: 1	غَيْرِ وَاضِعٍ
u'غير وَاضِعٌ':Added, #1: 1	غَيْرِ وَاضِعٍ
u'غَيْرٌ وَاضِعٌ':Added, #2: 2	غَيْرِ الْوَاضِعِ
u'غير وَاطِئٌ':Added, #2: 2	غَيْرِ الْوَاضِعِ
u'غَيْرٌ وَاطِئٌ':Added, #1: 1	غَيْرِ الْوَاطِئِ
u'غير وَافِي':Added, #1: 1	غَيْرِ الْوَاطِئِ
u'غَيْرٌ وَافِي':Added, #1: 1	غَيْرُ وَافِيَةٍ
u'غير وَاقِعٌ':Added, #1: 1	غَيْرُ وَافِيَةٍ
u'غَيْرٌ وَاقِعٌ':Added, #1: 1	غَيْرِ وَاقِعٍ
u'غير وَاقِعٌ':Added, #1: 1	غَيْرِ وَاقِعٍ
u'غير وَاقِعٌ':Added, #1: 1	غَيْرُ وَاقِعَةٍ
u'غَيْرٌ وَاقِعٌ':Added, #1: 1	غَيْرِ وَاقِعَةٍ
u'غَيْرٌ وَاقِعٌ':Added, #1: 1	غَيْرُ وَاقِعَةٍ
u'غير وَاقِعٌ':Added, #1: 1	غَيْرِ وَاقِعَةٍ
u'غير وَاقِعٌ':Added, #3: 3	غَيْرَ الْوَاقِعِ
u'غَيْرٌ وَاقِعٌ':Added, #3: 3	غَيْرِ الْوَاقِعِ
u'غَيْرٌ وَاقِعٌ':Added, #3: 3	غَيْرَ الْوَاقِعِ
u'غير وَاقِعٌ':Added, #3: 3	غَيْرِ الْوَاقِعِ
u'غَيْرٌ وَاقِعٌ':Added, #40: 40	غَيْرُ وَاقِعٍ
u'غير وَاقِعٌ':Added, #40: 40	غَيْرُ وَاقِعٍ
u'غَيْرٌ وَاقِعٌ':Added, #8: 8	غَيْرَ وَاقِعٍ
u'غير وَاقِعَةٌ':Added, #8: 8	غَيْرَ وَاقِعٍ
u'غير وَاقِعَةٌ':Added, #1: 1	غَيْرُ وَاقِعَةٍ
u'غَيْرٌ وَاقِعَةٌ':Added, #1: 1	غَيْرِ وَاقِعَةٍ
u'غَيْرٌ وَاقِعَةٌ':Added, #1: 1	غَيْرُ وَاقِعَةٍ
u'غير واقِف':Added, #1: 1	غَيْرِ وَاقِعَةٍ
u'غَيْرٌ واقِف':Added, #1: 1	غَيْرُ الْوَاقِفِيَّةِ
u'غير وَاقِفٌ':Added, #1: 1	غَيْرُ الْوَاقِفِيَّةِ
u'غير وَاقِفٌ':Added, #2: 2	غَيْرُ الْوَاقِفِ
u'غَيْرٌ وَاقِفٌ':Added, #2: 2	غَيْرِ الْوَاقِفِ
u'غَيْرٌ وَاقِفٌ':Added, #2: 2	غَيْرُ الْوَاقِفِ
u'غير وَاقِفٌ':Added, #2: 2	غَيْرِ الْوَاقِفِ
u'غَيْرٌ وَاقِفٌ':Added, #3: 3	غَيْرَ الْوَاقِفِ
u'غير وَالِدٌ':Added, #3: 3	غَيْرَ الْوَاقِفِ
u'غير وَالِدٌ':Added, #1: 1	غَيْرُ وَالِدٍ
u'غَيْرٌ وَالِدٌ':Added, #1: 1	غَيْرُ وَالِدِ
u'غَيْرٌ وَالِدٌ':Added, #1: 1	غَيْرُ وَالِدٍ
u'غير وَالِدٌ':Added, #1: 1	غَيْرُ وَالِدِ
u'غير وَالِدٌ':Added, #1: 1	غَيْرَ وَالِدَةٍ
u'غَيْرٌ وَالِدٌ':Added, #1: 1	غَيْرُ وَالِدَةٍ
u'غَيْرٌ وَالِدٌ':Added, #1: 1	غَيْرَ وَالِدَةٍ
u'غير وَالِدٌ':Added, #1: 1	غَيْرُ وَالِدَةٍ
u'غَيْرٌ وَالِدٌ':Added, #1: 1	غَيْرِ وَالِدِهِ
u'غير وَالِدٌ':Added, #1: 1	غَيْرِ وَالِدِهِ
u'غَيْرٌ وَالِدٌ':Added, #4: 4	غَيْرِ الْوَالِدِ
u'غير وَالِدٌ':Added, #4: 4	غَيْرِ الْوَالِدِ
u'غَيْرٌ وَالِدٌ':Added, #9: 9	غَيْرِ الْوَالِدَيْنِ
u'غير وَاهِبٌ':Added, #9: 9	غَيْرِ الْوَالِدَيْنِ
u'غَيْرٌ وَاهِبٌ':Added, #4: 4	غَيْرِ الْوَاهِبِ
u'غير وَبَاءٌ':Added, #4: 4	غَيْرِ الْوَاهِبِ
u'غَيْرٌ وَبَاءٌ':Added, #1: 1	غَيْرُ الْوَبَاءِ
u'غير وَثَنِيٌّ':Added, #1: 1	غَيْرُ الْوَبَاءِ
u'غَيْرٌ وَثَنِيٌّ':Added, #1: 1	غَيْرِ وَثَنِيٍّ
u'غير وَجَعٌ':Added, #1: 1	غَيْرِ وَثَنِيٍّ
u'غَيْرٌ وَجَعٌ':Added, #1: 1	غَيْرِ وَجَعٍ
u'غير وَجْهٌ':Added, #1: 1	غَيْرِ وَجَعٍ
u'غَيْرٌ وَجْهٌ':Added, #15: 15	غَيْرِ وَجْهٍ
u'غير وَجْهٌ':Added, #15: 15	غَيْرِ وَجْهٍ
u'غَيْرٌ وَجْهٌ':Added, #1: 1	غَيْرُ الْوَجْهَيْنِ
u'غير وَجْهٌ':Added, #1: 1	غَيْرُ الْوَجْهَيْنِ
u'غَيْرٌ وَجْهٌ':Added, #1: 1	غَيْرَ وَجْهِهِ
u'غير وَجْهٌ':Added, #1: 1	غَيْرَ وَجْهِهِ
u'غَيْرٌ وَجْهٌ':Added, #29: 29	غَيْرِ وَجْهِ
u'غير وَجْهٌ':Added, #29: 29	غَيْرِ وَجْهِ
u'غَيْرٌ وَجْهٌ':Added, #29: 29	غَيْرِ وَجْهِهِ
u'غير وَجْهٌ':Added, #29: 29	غَيْرِ وَجْهِهِ
u'غَيْرٌ وَجْهٌ':Added, #2: 2	غَيْرُ وَجْهِ
u'غير وَجْهٌ':Added, #2: 2	غَيْرُ وَجْهِ
u'غَيْرٌ وَجْهٌ':Added, #37: 37	غَيْرِ الْوَجْهِ
u'غير وَجْهٌ':Added, #37: 37	غَيْرِ الْوَجْهِ
u'غَيْرٌ وَجْهٌ':Added, #4: 4	غَيْرَ وَجْهِ
u'غير وَجْهٌ':Added, #4: 4	غَيْرَ وَجْهِ
u'غَيْرٌ وَجْهٌ':Added, #5: 5	غَيْرُ الْوَجْهِ
u'غير وَجْهٌ':Added, #5: 5	غَيْرُ الْوَجْهِ
u'غَيْرٌ وَجْهٌ':Added, #7: 7	غَيْرَ الْوَجْهِ
u'غير وُجُوبٌ':Added, #7: 7	غَيْرَ الْوَجْهِ
u'غَيْرٌ وُجُوبٌ':Added, #1: 1	غَيْرَ وُجُوبِ
u'غير وُجُوبٌ':Added, #1: 1	غَيْرَ وُجُوبِ
u'غَيْرٌ وُجُوبٌ':Added, #1: 1	غَيْرُ وُجُوبِهِ
u'غير وُجُوبٌ':Added, #1: 1	غَيْرُ وُجُوبِهِ
u'غَيْرٌ وُجُوبٌ':Added, #3: 3	غَيْرُ الْوُجُوبِ
u'غير وُجُوبٌ':Added, #3: 3	غَيْرُ الْوُجُوبِ
u'غَيْرٌ وُجُوبٌ':Added, #4: 4	غَيْرِ الْوُجُوبِ
u'غير وُجُوبٌ':Added, #4: 4	غَيْرِ الْوُجُوبِ
u'غير وُجُوبٌ':Added, #5: 5	غَيْرِ وُجُوبٍ
u'غَيْرٌ وُجُوبٌ':Added, #5: 5	غَيْرِ وُجُوبِ
u'غَيْرٌ وُجُوبٌ':Added, #5: 5	غَيْرِ وُجُوبٍ
u'غير وُجُودٌ':Added, #5: 5	غَيْرِ وُجُوبِ
u'غير وُجُودٌ':Added, #1: 1	غَيْرَ الْوُجُودِ
u'غير وُجُودٌ':Added, #1: 1	غَيْرُ الْوُجُودِ
u'غَيْرٌ وُجُودٌ':Added, #1: 1	غَيْرِ الْوُجُودِ
u'غَيْرٌ وُجُودٌ':Added, #1: 1	غَيْرَ الْوُجُودِ
u'غَيْرٌ وُجُودٌ':Added, #1: 1	غَيْرُ الْوُجُودِ
u'غير وُجُودٌ':Added, #1: 1	غَيْرِ الْوُجُودِ
u'غَيْرٌ وُجُودٌ':Added, #1: 1	غَيْرُ وُجُودِهِ
u'غير وُجُودٌ':Added, #1: 1	غَيْرُ وُجُودِهِ
u'غَيْرٌ وُجُودٌ':Added, #4: 4	غَيْرِ وُجُودِ
u'غير وُجُودِيٌّ':Added, #4: 4	غَيْرِ وُجُودِ
u'غَيْرٌ وُجُودِيٌّ':Added, #1: 1	غَيْرُ وُجُودِيٍّ
u'غير وَحْشِيٌّ':Added, #1: 1	غَيْرُ وُجُودِيٍّ
u'غَيْرٌ وَحْشِيٌّ':Added, #1: 1	غَيْرِ الْوَحْشِيِّ
u'غير وَحْشِيٌّ':Added, #1: 1	غَيْرِ الْوَحْشِيِّ
u'غَيْرٌ وَحْشِيٌّ':Added, #1: 1	غَيْرُ وَحْشِيٍّ
u'غير وَحْيٌ':Added, #1: 1	غَيْرُ وَحْشِيٍّ
u'غَيْرٌ وَحْيٌ':Added, #2: 2	غَيْرِ وَحْيٍ
u'غير وَدِيعٌ':Added, #2: 2	غَيْرِ وَحْيٍ
u'غير وَدِيعٌ':Added, #1: 1	غَيْرَ الْوَدِيعِ
u'غَيْرٌ وَدِيعٌ':Added, #1: 1	غَيْرِ الْوَدِيعِ
u'غَيْرٌ وَدِيعٌ':Added, #1: 1	غَيْرَ الْوَدِيعِ
u'غير وَدِيعٌ':Added, #1: 1	غَيْرِ الْوَدِيعِ
u'غَيْرٌ وَدِيعٌ':Added, #1: 1	غَيْرَ الْوَدِيعَةِ
u'غير وَدِيعَةٌ':Added, #1: 1	غَيْرَ الْوَدِيعَةِ
u'غَيْرٌ وَدِيعَةٌ':Added, #1: 1	غَيْرَ الْوَدِيعَةِ
u'غير وَدِيعَةٌ':Added, #1: 1	غَيْرَ الْوَدِيعَةِ
u'غَيْرٌ وَدِيعَةٌ':Added, #3: 3	غَيْرَ وَدِيعَةٍ
u'غير وِرَاثَةٌ':Added, #3: 3	غَيْرَ وَدِيعَةٍ
u'غَيْرٌ وِرَاثَةٌ':Added, #1: 1	غَيْرِ الْوِرَاثَةِ
u'غير وَرَثَةٌ':Added, #1: 1	غَيْرِ الْوِرَاثَةِ
u'غير وَرَثَةٌ':Added, #1: 1	غَيْرَ وَرَثَةٍ
u'غَيْرٌ وَرَثَةٌ':Added, #1: 1	غَيْرُ وَرَثَةٍ
u'غَيْرٌ وَرَثَةٌ':Added, #1: 1	غَيْرَ وَرَثَةٍ
u'غير وَرَثَةٌ':Added, #1: 1	غَيْرُ وَرَثَةٍ
u'غير وَرَثَةٌ':Added, #1: 1	غَيْرَ وَرَثَتِهِ
u'غَيْرٌ وَرَثَةٌ':Added, #1: 1	غَيْرُ وَرَثَتِهِ
u'غَيْرٌ وَرَثَةٌ':Added, #1: 1	غَيْرَ وَرَثَتِهِ
u'غير وَرَثَةٌ':Added, #1: 1	غَيْرُ وَرَثَتِهِ
u'غَيْرٌ وَرَثَةٌ':Added, #3: 3	غَيْرِ الْوَرَثَةِ
u'غير ورق':Added, #3: 3	غَيْرِ الْوَرَثَةِ
u'غَيْرٌ ورق':Added, #1: 1	غَيْرُ الْوَرَقِ
u'غير وَرَقٌ':Added, #1: 1	غَيْرُ الْوَرَقِ
u'غَيْرٌ وَرَقٌ':Added, #1: 1	غَيْرُ الْوَرَقِ
u'غير وَرَمٌ':Added, #1: 1	غَيْرُ الْوَرَقِ
u'غَيْرٌ وَرَمٌ':Added, #1: 1	غَيْرِ وَرَمٍ
u'غير وُرُودٌ':Added, #1: 1	غَيْرِ وَرَمٍ
u'غَيْرٌ وُرُودٌ':Added, #1: 1	غَيْرِ وُرُودِ
u'غير وَزْنٌ':Added, #1: 1	غَيْرِ وُرُودِ
u'غَيْرٌ وَزْنٌ':Added, #1: 1	غَيْرُ وَزْنِ
u'غير وَزْنٌ':Added, #1: 1	غَيْرُ وَزْنِ
u'غَيْرٌ وَزْنٌ':Added, #2: 2	غَيْرِ الْوَزْنِ
u'غير وَزْنٌ':Added, #2: 2	غَيْرِ الْوَزْنِ
u'غَيْرٌ وَزْنٌ':Added, #5: 5	غَيْرِ وَزْنٍ
u'غير وَسَاطَةٌ':Added, #5: 5	غَيْرِ وَزْنٍ
u'غَيْرٌ وَسَاطَةٌ':Added, #1: 1	غَيْرِ وَسَاطَةٍ
u'غير وسط':Added, #1: 1	غَيْرِ وَسَاطَةٍ
u'غَيْرٌ وسط':Added, #1: 1	غَيْرِ وَسَطِ
u'غير وَسَطٌ':Added, #1: 1	غَيْرِ وَسَطِ
u'غَيْرٌ وَسَطٌ':Added, #1: 1	غَيْرِ وَسَطِ
u'غير وسط':Added, #1: 1	غَيْرِ وَسَطِ
u'غَيْرٌ وسط':Added, #2: 2	غَيْرِ الْوَسَطِ
u'غير وَسَطٌ':Added, #2: 2	غَيْرِ الْوَسَطِ
u'غَيْرٌ وَسَطٌ':Added, #2: 2	غَيْرِ الْوَسَطِ
u'غير وسط':Added, #2: 2	غَيْرِ الْوَسَطِ
u'غَيْرٌ وسط':Added, #2: 2	غَيْرَ وَسَطِ
u'غير وَسَطٌ':Added, #2: 2	غَيْرَ وَسَطِ
u'غَيْرٌ وَسَطٌ':Added, #2: 2	غَيْرَ وَسَطِ
u'غير وَسْوَسَةٌ':Added, #2: 2	غَيْرَ وَسَطِ
u'غَيْرٌ وَسْوَسَةٌ':Added, #1: 1	غَيْرِ وَسْوَسَةٍ
u'غير وَشْمٌ':Added, #1: 1	غَيْرِ وَسْوَسَةٍ
u'غَيْرٌ وَشْمٌ':Added, #1: 1	غَيْرُ الْوَشْمِ
u'غير وَشِيكٌ':Added, #1: 1	غَيْرُ الْوَشْمِ
u'غَيْرٌ وَشِيكٌ':Added, #1: 1	غَيْرُ وَشِيكَةِ
u'غير وَصْفٌ':Added, #1: 1	غَيْرُ وَشِيكَةِ
u'غير وَصْفٌ':Added, #1: 1	غَيْر الْوَصْفِ
u'غَيْرٌ وَصْفٌ':Added, #1: 1	غَيْرُ الْوَصْفِ
u'غَيْرٌ وَصْفٌ':Added, #1: 1	غَيْر الْوَصْفِ
u'غير وَصْفٌ':Added, #1: 1	غَيْرُ الْوَصْفِ
u'غير وَصْفٌ':Added, #1: 1	غَيْرَ وَصْفٍ
u'غَيْرٌ وَصْفٌ':Added, #1: 1	غَيْرُ وَصْفِ
u'غَيْرٌ وَصْفٌ':Added, #1: 1	غَيْرَ وَصْفٍ
u'غير وَصْفٌ':Added, #1: 1	غَيْرُ وَصْفِ
u'غَيْرٌ وَصْفٌ':Added, #3: 3	غَيْرِ الْوَصْفِ
u'غير وَصْفٌ':Added, #3: 3	غَيْرِ الْوَصْفِ
u'غَيْرٌ وَصْفٌ':Added, #3: 3	غَيْرِ وَصْفٍ
u'غير وَصْلٌ':Added, #3: 3	غَيْرِ وَصْفٍ
u'غير وَصْلٌ':Added, #1: 1	غَيْرَ وَصْلٍ
u'غَيْرٌ وَصْلٌ':Added, #1: 1	غَيْرِ وَصْلٍ
u'غَيْرٌ وَصْلٌ':Added, #1: 1	غَيْرَ وَصْلٍ
u'غير وُصُولٌ':Added, #1: 1	غَيْرِ وَصْلٍ
u'غَيْرٌ وُصُولٌ':Added, #1: 1	غَيْرِ وُصُولِهِ
u'غير وَصِيٌّ':Added, #1: 1	غَيْرِ وُصُولِهِ
u'غَيْرٌ وَصِيٌّ':Added, #14: 14	غَيْرِ وَصِيَّةٍ
u'غير وَصِيٌّ':Added, #14: 14	غَيْرِ وَصِيَّةٍ
u'غَيْرٌ وَصِيٌّ':Added, #1: 1	غَيْرُ الْوَصِيَّةِ
u'غير وَصِيٌّ':Added, #1: 1	غَيْرُ الْوَصِيَّةِ
u'غير وَصِيٌّ':Added, #1: 1	غَيْرُ وَصِيٍّ
u'غَيْرٌ وَصِيٌّ':Added, #1: 1	غَيْرِ وَصِيٍّ
u'غَيْرٌ وَصِيٌّ':Added, #1: 1	غَيْرُ وَصِيٍّ
u'غير وَصِيٌّ':Added, #1: 1	غَيْرِ وَصِيٍّ
u'غَيْرٌ وَصِيٌّ':Added, #2: 2	غَيْرِ الْوَصِيِّ
u'غير وَصِيٌّ':Added, #2: 2	غَيْرِ الْوَصِيِّ
u'غَيْرٌ وَصِيٌّ':Added, #2: 2	غَيْرِ الْوَصِيَّةِ
u'غير وَصِيٌّ':Added, #2: 2	غَيْرِ الْوَصِيَّةِ
u'غَيْرٌ وَصِيٌّ':Added, #2: 2	غَيْرُ وَصِيَّةٍ
u'غير وَصِيَّةٌ':Added, #2: 2	غَيْرُ وَصِيَّةٍ
u'غَيْرٌ وَصِيَّةٌ':Added, #14: 14	غَيْرِ وَصِيَّةٍ
u'غير وَصِيَّةٌ':Added, #14: 14	غَيْرِ وَصِيَّةٍ
u'غَيْرٌ وَصِيَّةٌ':Added, #1: 1	غَيْرُ الْوَصِيَّةِ
u'غير وَصِيَّةٌ':Added, #1: 1	غَيْرُ الْوَصِيَّةِ
u'غَيْرٌ وَصِيَّةٌ':Added, #2: 2	غَيْرِ الْوَصِيَّةِ
u'غير وَصِيَّةٌ':Added, #2: 2	غَيْرِ الْوَصِيَّةِ
u'غَيْرٌ وَصِيَّةٌ':Added, #2: 2	غَيْرُ وَصِيَّةٍ
u'غير وَضْعٌ':Added, #2: 2	غَيْرُ وَصِيَّةٍ
u'غَيْرٌ وَضْعٌ':Added, #1: 1	غَيْرَ الْوَضْعِ
u'غير وَضْعٌ':Added, #1: 1	غَيْرَ الْوَضْعِ
u'غَيْرٌ وَضْعٌ':Added, #1: 1	غَيْرَ وَضْعِ
u'غير وَضْعٌ':Added, #1: 1	غَيْرَ وَضْعِ
u'غَيْرٌ وَضْعٌ':Added, #1: 1	غَيْرِ وَضْعِهِ
u'غير وَضْعٌ':Added, #1: 1	غَيْرِ وَضْعِهِ
u'غَيْرٌ وَضْعٌ':Added, #2: 2	غَيْرُ الْوَضْعِ
u'غير وَضْعٌ':Added, #2: 2	غَيْرُ الْوَضْعِ
u'غَيْرٌ وَضْعٌ':Added, #2: 2	غَيْر وَضْعِ
u'غير وَضْعٌ':Added, #2: 2	غَيْر وَضْعِ
u'غَيْرٌ وَضْعٌ':Added, #3: 3	غَيْرِ وَضْعِ
u'غير وَضْعٌ':Added, #3: 3	غَيْرِ وَضْعِ
u'غَيْرٌ وَضْعٌ':Added, #5: 5	غَيْرِ وَضْعٍ
u'غير وُضُوءٌ':Added, #5: 5	غَيْرِ وَضْعٍ
u'غَيْرٌ وُضُوءٌ':Added, #1: 1	غَيْرُ الْوُضُوءِ
u'غير وُضُوءٌ':Added, #1: 1	غَيْرُ الْوُضُوءِ
u'غَيْرٌ وُضُوءٌ':Added, #4: 4	غَيْرِ الْوُضُوءِ
u'غير وُضُوءٌ':Added, #4: 4	غَيْرِ الْوُضُوءِ
u'غَيْرٌ وُضُوءٌ':Added, #86: 86	غَيْرِ وُضُوءٍ
u'غير وَطْءٌ':Added, #86: 86	غَيْرِ وُضُوءٍ
u'غَيْرٌ وَطْءٌ':Added, #10: 10	غَيْرِ وَطْءٍ
u'غير وَطْءٌ':Added, #10: 10	غَيْرِ وَطْءٍ
u'غَيْرٌ وَطْءٌ':Added, #1: 1	غَيْرُ وَطْءٍ
u'غير وَطْءٌ':Added, #1: 1	غَيْرُ وَطْءٍ
u'غَيْرٌ وَطْءٌ':Added, #2: 2	غَيْرُ الْوَطْءِ
u'غير وَطْءٌ':Added, #2: 2	غَيْرُ الْوَطْءِ
u'غَيْرٌ وَطْءٌ':Added, #2: 2	غَيْرِ وَطْءِ
u'غير وَطْءٌ':Added, #2: 2	غَيْرِ وَطْءِ
u'غير وَطْءٌ':Added, #4: 4	غَيْرَ الْوَطْءِ
u'غَيْرٌ وَطْءٌ':Added, #4: 4	غَيْرِ الْوَطْءِ
u'غَيْرٌ وَطْءٌ':Added, #4: 4	غَيْرَ الْوَطْءِ
u'غير وَطَنٌ':Added, #4: 4	غَيْرِ الْوَطْءِ
u'غَيْرٌ وَطَنٌ':Added, #5: 5	غَيْرِ وَطَنِهِ
u'غير وَظِيفٌ':Added, #5: 5	غَيْرِ وَطَنِهِ
u'غَيْرٌ وَظِيفٌ':Added, #1: 1	غَيْرِ وَظِيفَةِ
u'غير وَظِيفَةٌ':Added, #1: 1	غَيْرِ وَظِيفَةِ
u'غَيْرٌ وَظِيفَةٌ':Added, #1: 1	غَيْرِ وَظِيفَةِ
u'غير وَعْدٌ':Added, #1: 1	غَيْرِ وَظِيفَةِ
u'غَيْرٌ وَعْدٌ':Added, #1: 1	غَيْرُ الْوَعْدِ
u'غير وَعْدٌ':Added, #1: 1	غَيْرُ الْوَعْدِ
u'غير وَعْدٌ':Added, #1: 1	غَيْرَ وَعْدٍ
u'غير وَعْدٌ':Added, #1: 1	غَيْرُ وَعْدٍ
u'غَيْرٌ وَعْدٌ':Added, #1: 1	غَيْرِ وَعْدٍ
u'غَيْرٌ وَعْدٌ':Added, #1: 1	غَيْرَ وَعْدٍ
u'غَيْرٌ وَعْدٌ':Added, #1: 1	غَيْرُ وَعْدٍ
u'غير وَغْدٌ':Added, #1: 1	غَيْرِ وَعْدٍ
u'غير وَغْدٌ':Added, #1: 1	غَيْرَ وَغْدٍ
u'غَيْرٌ وَغْدٌ':Added, #1: 1	غَيْرُ وَغْدٍ
u'غَيْرٌ وَغْدٌ':Added, #1: 1	غَيْرَ وَغْدٍ
u'غير وَغْلٌ':Added, #1: 1	غَيْرُ وَغْدٍ
u'غَيْرٌ وَغْلٌ':Added, #1: 1	غَيْرِ وَغْلٍ
u'غير وَفَاءٌ':Added, #1: 1	غَيْرِ وَغْلٍ
u'غَيْرٌ وَفَاءٌ':Added, #16: 16	غَيْرِ وَفَاءٍ
u'غير وقاع':Added, #16: 16	غَيْرِ وَفَاءٍ
u'غَيْرٌ وقاع':Added, #2: 2	غَيْرِ الْوِقَاعِ
u'غير وَقْتٌ':Added, #2: 2	غَيْرِ الْوِقَاعِ
u'غَيْرٌ وَقْتٌ':Added, #12: 12	غَيْرِ الْوَقْتِ
u'غير وَقْت':Added, #12: 12	غَيْرِ الْوَقْتِ
u'غَيْرٌ وَقْت':Added, #1: 1	غَيْرِ الْوَقْتِيَّةِ
u'غير وَقْتٌ':Added, #1: 1	غَيْرِ الْوَقْتِيَّةِ
u'غَيْرٌ وَقْتٌ':Added, #21: 21	غَيْرِ وَقْتِهِ
u'غير وَقْتٌ':Added, #21: 21	غَيْرِ وَقْتِهِ
u'غَيْرٌ وَقْتٌ':Added, #2: 2	غَيْرِ الْوَقْتَيْنِ
u'غير وَقْتٌ':Added, #2: 2	غَيْرِ الْوَقْتَيْنِ
u'غَيْرٌ وَقْتٌ':Added, #2: 2	غَيْرُ وَقْتِ
u'غير وَقْتٌ':Added, #2: 2	غَيْرُ وَقْتِ
u'غَيْرٌ وَقْتٌ':Added, #39: 39	غَيْرِ وَقْتِ
u'غير وَقْتٌ':Added, #39: 39	غَيْرِ وَقْتِ
u'غَيْرٌ وَقْتٌ':Added, #3: 3	غَيْرِ وَقْتٍ
u'غير وَقْتٌ':Added, #3: 3	غَيْرِ وَقْتٍ
u'غَيْرٌ وَقْتٌ':Added, #4: 4	غَيْرَ وَقْتِ
u'غير وَقْتِيّ':Added, #4: 4	غَيْرَ وَقْتِ
u'غَيْرٌ وَقْتِيّ':Added, #1: 1	غَيْرِ الْوَقْتِيَّةِ
u'غير وَقْفٌ':Added, #1: 1	غَيْرِ الْوَقْتِيَّةِ
u'غير وَقْفٌ':Added, #1: 1	غَيْرُ الْوَقْفِ
u'غَيْرٌ وَقْفٌ':Added, #1: 1	غَيْرِ الْوَقْفِ
u'غَيْرٌ وَقْفٌ':Added, #1: 1	غَيْرُ الْوَقْفِ
u'غير وَقْفٌ':Added, #1: 1	غَيْرِ الْوَقْفِ
u'غير وَقْفٌ':Added, #1: 1	غَيْر وَقْفِ
u'غير وَقْفٌ':Added, #1: 1	غَيْرَ وَقْفٍ
u'غَيْرٌ وَقْفٌ':Added, #1: 1	غَيْرُ وَقْفٍ
u'غَيْرٌ وَقْفٌ':Added, #1: 1	غَيْر وَقْفِ
u'غَيْرٌ وَقْفٌ':Added, #1: 1	غَيْرَ وَقْفٍ
u'غير وَقْفٌ':Added, #1: 1	غَيْرُ وَقْفٍ
u'غير وَقْفٌ':Added, #2: 2	غَيْرِ وَقْفٍ
u'غَيْرٌ وَقْفٌ':Added, #2: 2	غَيْرِ وَقْفِ
u'غَيْرٌ وَقْفٌ':Added, #2: 2	غَيْرِ وَقْفٍ
u'غير وُقُوعٌ':Added, #2: 2	غَيْرِ وَقْفِ
u'غَيْرٌ وُقُوعٌ':Added, #1: 1	غَيْرِ الْوُقُوعِ
u'غير وُقُوعٌ':Added, #1: 1	غَيْرِ الْوُقُوعِ
u'غَيْرٌ وُقُوعٌ':Added, #1: 1	غَيْرِ وُقُوعِ
u'غير وُقُوفٌ':Added, #1: 1	غَيْرِ وُقُوعِ
u'غَيْرٌ وُقُوفٌ':Added, #1: 1	غَيْرِ وُقُوفٍ
u'غير وَكِيلٌ':Added, #1: 1	غَيْرِ وُقُوفٍ
u'غَيْرٌ وَكِيلٌ':Added, #1: 1	غَيْرَ وَكِيلِ
u'غير وَكِيلٌ':Added, #1: 1	غَيْرَ وَكِيلِ
u'غَيْرٌ وَكِيلٌ':Added, #2: 2	غَيْرِ الْوَكِيلِ
u'غير وَكِيلٌ':Added, #2: 2	غَيْرِ الْوَكِيلِ
u'غَيْرٌ وَكِيلٌ':Added, #6: 6	غَيْرُ الْوَكِيلِ
u'غير وُلاَةٌ':Added, #6: 6	غَيْرُ الْوَكِيلِ
u'غير وُلاَةٌ':Added, #1: 1	غَيْرَ الْوُلَاةِ
u'غَيْرٌ وُلاَةٌ':Added, #1: 1	غَيْرِ الْوُلَاةِ
u'غَيْرٌ وُلاَةٌ':Added, #1: 1	غَيْرَ الْوُلَاةِ
u'غير وِلاَدَةٌ':Added, #1: 1	غَيْرِ الْوُلَاةِ
u'غَيْرٌ وِلاَدَةٌ':Added, #1: 1	غَيْرِ الْوِلَادَةِ
u'غير وِلاَدَةٌ':Added, #1: 1	غَيْرِ الْوِلَادَةِ
u'غَيْرٌ وِلاَدَةٌ':Added, #2: 2	غَيْرِ وِلَادَةٍ
u'غير وِلاَيَةٌ':Added, #2: 2	غَيْرِ وِلَادَةٍ
u'غَيْرٌ وِلاَيَةٌ':Added, #1: 1	غَيْرِ وِلَايَةٍ
u'غير وِلاَيَةٌ':Added, #1: 1	غَيْرِ وِلَايَةٍ
u'غَيْرٌ وِلاَيَةٌ':Added, #3: 3	غَيْرِ وِلَايَةِ
u'غير وِلاَيَةٌ':Added, #3: 3	غَيْرِ وِلَايَةِ
u'غَيْرٌ وِلاَيَةٌ':Added, #5: 5	غَيْرِ وِلَايَتِهِ
u'غير ولد':Added, #5: 5	غَيْرِ وِلَايَتِهِ
u'غَيْرٌ ولد':Added, #1: 1	غَيْر وَلَدِ
u'غير وَلَدٌ':Added, #1: 1	غَيْر وَلَدِ
u'غير وَلَدٌ':Added, #1: 1	غَيْر وَلَدِ
u'غَيْرٌ وَلَدٌ':Added, #1: 1	غَيْرَ وَلَدٍ
u'غَيْرٌ وَلَدٌ':Added, #1: 1	غَيْر وَلَدِ
u'غير ولد':Added, #1: 1	غَيْرَ وَلَدٍ
u'غَيْرٌ ولد':Added, #1: 1	غَيْرُ وَلَدِهِ
u'غير وَلَدٌ':Added, #1: 1	غَيْرُ وَلَدِهِ
u'غَيْرٌ وَلَدٌ':Added, #1: 1	غَيْرُ وَلَدِهِ
u'غير ولد':Added, #1: 1	غَيْرُ وَلَدِهِ
u'غير ولد':Added, #2: 2	غَيْرُ الْوَلَدِ
u'غَيْرٌ ولد':Added, #2: 2	غَيْرِ الْوَلَدِ
u'غَيْرٌ ولد':Added, #2: 2	غَيْرُ الْوَلَدِ
u'غير وَلَدٌ':Added, #2: 2	غَيْرِ الْوَلَدِ
u'غير وَلَدٌ':Added, #2: 2	غَيْرُ الْوَلَدِ
u'غَيْرٌ وَلَدٌ':Added, #2: 2	غَيْرِ الْوَلَدِ
u'غَيْرٌ وَلَدٌ':Added, #2: 2	غَيْرُ الْوَلَدِ
u'غير ولد':Added, #2: 2	غَيْرِ الْوَلَدِ
u'غَيْرٌ ولد':Added, #3: 3	غَيْرَ وَلَدِهِ
u'غير وَلَدٌ':Added, #3: 3	غَيْرَ وَلَدِهِ
u'غَيْرٌ وَلَدٌ':Added, #3: 3	غَيْرَ وَلَدِهِ
u'غير ولد':Added, #3: 3	غَيْرَ وَلَدِهِ
u'غَيْرٌ ولد':Added, #4: 4	غَيْرَ وَلَدِ
u'غير وَلَدٌ':Added, #4: 4	غَيْرَ وَلَدِ
u'غَيْرٌ وَلَدٌ':Added, #4: 4	غَيْرَ وَلَدِ
u'غير ولد':Added, #4: 4	غَيْرَ وَلَدِ
u'غَيْرٌ ولد':Added, #5: 5	غَيْرِ وَلَدِ
u'غير وَلَدٌ':Added, #5: 5	غَيْرِ وَلَدِ
u'غَيْرٌ وَلَدٌ':Added, #5: 5	غَيْرِ وَلَدِ
u'غير وَلَدٌ':Added, #5: 5	غَيْرِ وَلَدِ
u'غَيْرٌ وَلَدٌ':Added, #69: 69	غَيْرِ وَلَدٍ
u'غير وَلَدٌ':Added, #69: 69	غَيْرِ وَلَدٍ
u'غَيْرٌ وَلَدٌ':Added, #6: 6	غَيْر وَلَدٍ
u'غير ولد':Added, #6: 6	غَيْر وَلَدٍ
u'غَيْرٌ ولد':Added, #6: 6	غَيْرِ وَلَدِهِ
u'غير وَلَدٌ':Added, #6: 6	غَيْرِ وَلَدِهِ
u'غَيْرٌ وَلَدٌ':Added, #6: 6	غَيْرِ وَلَدِهِ
u'غير وَلِيٌّ':Added, #6: 6	غَيْرِ وَلَدِهِ
u'غَيْرٌ وَلِيٌّ':Added, #11: 11	غَيْرِ الْوَلِيِّ
u'غير وَلِيٌّ':Added, #11: 11	غَيْرِ الْوَلِيِّ
u'غَيْرٌ وَلِيٌّ':Added, #18: 18	غَيْرُ الْوَلِيِّ
u'غير وَلِيٌّ':Added, #18: 18	غَيْرُ الْوَلِيِّ
u'غَيْرٌ وَلِيٌّ':Added, #1: 1	غَيْرُ وَلِيِّ
u'غير وَلِيٌّ':Added, #1: 1	غَيْرُ وَلِيِّ
u'غير وَلِيٌّ':Added, #1: 1	غَيْرَ وَلِيِّهِ
u'غَيْرٌ وَلِيٌّ':Added, #1: 1	غَيْرِ وَلِيِّهِ
u'غَيْرٌ وَلِيٌّ':Added, #1: 1	غَيْرَ وَلِيِّهِ
u'غير وَلِيٌّ':Added, #1: 1	غَيْرِ وَلِيِّهِ
u'غَيْرٌ وَلِيٌّ':Added, #2: 2	غَيْرَ الْوَلِيِّ
u'غير وَلِيٌّ':Added, #2: 2	غَيْرَ الْوَلِيِّ
u'غَيْرٌ وَلِيٌّ':Added, #2: 2	غَيْرَ وَلِيٍّ
u'غير وَلِيٌّ':Added, #2: 2	غَيْرَ وَلِيٍّ
u'غَيْرٌ وَلِيٌّ':Added, #5: 5	غَيْرِ وَلِيٍّ
u'غير وَلِيٌّ':Added, #5: 5	غَيْرِ وَلِيٍّ
u'غَيْرٌ وَلِيٌّ':Added, #9: 9	غَيْرُ وَلِيٍّ
u'غير وَلِيدٌ':Added, #9: 9	غَيْرُ وَلِيٍّ
u'غَيْرٌ وَلِيدٌ':Added, #1: 1	غَيْرُ الْوَلِيدِ
u'غير وَلِيمَةٌ':Added, #1: 1	غَيْرُ الْوَلِيدِ
u'غَيْرٌ وَلِيمَةٌ':Added, #1: 1	غَيْرُ الْوَلِيمَةِ
u'غير وَلِيمَةٌ':Added, #1: 1	غَيْرُ الْوَلِيمَةِ
u'غير وَلِيمَةٌ':Added, #1: 1	غَيْرُ وَلِيمَةِ
u'غَيْرٌ وَلِيمَةٌ':Added, #1: 1	غَيْرِ وَلِيمَةٍ
u'غَيْرٌ وَلِيمَةٌ':Added, #1: 1	غَيْرُ وَلِيمَةِ
u'غير وَلِيمَةٌ':Added, #1: 1	غَيْرِ وَلِيمَةٍ
u'غَيْرٌ وَلِيمَةٌ':Added, #3: 3	غَيْرِ وَلِيمَةِ
u'غير وَهَنٌ':Added, #3: 3	غَيْرِ وَلِيمَةِ
u'غَيْرٌ وَهَنٌ':Added, #1: 1	غَيْرِ وَهَنٍ
u'غير يَابِسٌ':Added, #1: 1	غَيْرِ وَهَنٍ
u'غَيْرٌ يَابِسٌ':Added, #1: 1	غَيْرِ الْيَابِسَاتِ
u'غير يَاقُوتٌ':Added, #1: 1	غَيْرِ الْيَابِسَاتِ
u'غَيْرٌ يَاقُوتٌ':Added, #2: 2	غَيْرَ يَاقُوتَةٍ
u'غير يَدٌ':Added, #2: 2	غَيْرَ يَاقُوتَةٍ
u'غير يَدٌ':Added, #1: 1	غَيْرَ الْيَدِ
u'غَيْرٌ يَدٌ':Added, #1: 1	غَيْرِ الْيَدِ
u'غَيْرٌ يَدٌ':Added, #1: 1	غَيْرَ الْيَدِ
u'غير يَدٌ':Added, #1: 1	غَيْرِ الْيَدِ
u'غير يَدٌ':Added, #1: 1	غَيْرِ يَدٍ
u'غَيْرٌ يَدٌ':Added, #1: 1	غَيْرِ يَدِ
u'غَيْرٌ يَدٌ':Added, #1: 1	غَيْرِ يَدٍ
u'غير يَدٌ':Added, #1: 1	غَيْرِ يَدِ
u'غير يَدٌ':Added, #1: 1	غَيْرَ يَدِهِ
u'غَيْرٌ يَدٌ':Added, #1: 1	غَيْرُ يَدِهِ
u'غَيْرٌ يَدٌ':Added, #1: 1	غَيْرَ يَدِهِ
u'غير يَدٌ':Added, #1: 1	غَيْرُ يَدِهِ
u'غَيْرٌ يَدٌ':Added, #2: 2	غَيْرُ يَدِ
u'غير يسار':Added, #2: 2	غَيْرُ يَدِ
u'غير يَسَارٌ':Added, #1: 1	غَيْرِ يَسَارٍ
u'غَيْرٌ يسار':Added, #1: 1	غَيْرِ يَسَارٍ
u'غَيْرٌ يَسَارٌ':Added, #1: 1	غَيْرِ يَسَارٍ
u'غير يَسِيرٌ':Added, #1: 1	غَيْرِ يَسَارٍ
u'غير يَسِيرٌ':Added, #1: 1	غَيْرَ الْيَسِيرِ
u'غَيْرٌ يَسِيرٌ':Added, #1: 1	غَيْرِ الْيَسِيرِ
u'غَيْرٌ يَسِيرٌ':Added, #1: 1	غَيْرَ الْيَسِيرِ
u'غير يَسِيرٌ':Added, #1: 1	غَيْرِ الْيَسِيرِ
u'غَيْرٌ يَسِيرٌ':Added, #1: 1	غَيْرُ يَسِيرٍ
u'غير يَقِينٌ':Added, #1: 1	غَيْرُ يَسِيرٍ
u'غَيْرٌ يَقِينٌ':Added, #1: 1	غَيْرُ يَقِينٍ
u'غير يَقِينٌ':Added, #1: 1	غَيْرُ يَقِينٍ
u'غَيْرٌ يَقِينٌ':Added, #2: 2	غَيْرُ الْيَقِينِ
u'غير يَقِينٌ':Added, #2: 2	غَيْرُ الْيَقِينِ
u'غَيْرٌ يَقِينٌ':Added, #5: 5	غَيْرِ يَقِينٍ
u'غير يَمِينٌ':Added, #5: 5	غَيْرِ يَقِينٍ
u'غَيْرٌ يَمِينٌ':Added, #1: 1	غَيْرَ اليَمِينِ
u'غير يَمِينٌ':Added, #1: 1	غَيْرَ اليَمِينِ
u'غير يَمِينٌ':Added, #1: 1	غَيْرَ يَمِينٍ
u'غَيْرٌ يَمِينٌ':Added, #1: 1	غَيْرِ يَمِينِ
u'غَيْرٌ يَمِينٌ':Added, #1: 1	غَيْرَ يَمِينٍ
u'غير يَمِينٌ':Added, #1: 1	غَيْرِ يَمِينِ
u'غَيْرٌ يَمِينٌ':Added, #2: 2	غَيْرِ الْيَمِينِ
u'غير يَمِينٌ':Added, #2: 2	غَيْرِ الْيَمِينِ
u'غَيْرٌ يَمِينٌ':Added, #39: 39	غَيْرِ يَمِينٍ
u'غير يَمِينٌ':Added, #39: 39	غَيْرِ يَمِينٍ
u'غَيْرٌ يَمِينٌ':Added, #3: 3	غَيْرُ الْيَمِينِ
u'غير يَمِينٌ':Added, #3: 3	غَيْرُ الْيَمِينِ
u'غَيْرٌ يَمِينٌ':Added, #3: 3	غَيْرُ يَمِينٍ
u'غير يَمِينٌ':Added, #3: 3	غَيْرُ يَمِينٍ
u'غَيْرٌ يَمِينٌ':Added, #6: 6	غَيْرَ الْيَمِينِ
u'غير يَهُودِيٌّ':Added, #6: 6	غَيْرَ الْيَمِينِ
u'غَيْرٌ يَهُودِيٌّ':Added, #1: 1	غَيْرَ الْيَهُودِيِّ
u'غير يَهُودِيٌّ':Added, #1: 1	غَيْرَ الْيَهُودِيِّ
u'غَيْرٌ يَهُودِيٌّ':Added, #1: 1	غَيْرَ الْيَهُودِيَّةِ
u'غير يَهُودِيٌّ':Added, #1: 1	غَيْرَ الْيَهُودِيَّةِ
u'غَيْرٌ يَهُودِيٌّ':Added, #2: 2	غَيْرُ الْيَهُودِيِّ
u'غير يَوْمٌ':Added, #2: 2	غَيْرُ الْيَهُودِيِّ
u'غَيْرٌ يَوْمٌ':Added, #1: 1	غَيْرِ الْيَوْمَيْنِ
u'غير يَوْمٌ':Added, #1: 1	غَيْرِ الْيَوْمَيْنِ
u'غَيْرٌ يَوْمٌ':Added, #1: 1	غَيْرُ يَوْمِ
u'غير يَوْمٌ':Added, #1: 1	غَيْرُ يَوْمِ
u'غَيْرٌ يَوْمٌ':Added, #23: 23	غَيْرِ يَوْمِ
u'غير يَوْمٌ':Added, #23: 23	غَيْرِ يَوْمِ
u'غَيْرٌ يَوْمٌ':Added, #2: 2	غَيْرَ يَوْمٍ
u'غير يَوْمٌ':Added, #2: 2	غَيْرَ يَوْمٍ
u'غَيْرٌ يَوْمٌ':Added, #3: 3	غَيْرَ يَوْمِ
u'غير يَوْمٌ':Added, #3: 3	غَيْرَ يَوْمِ
u'غَيْرٌ يَوْمٌ':Added, #4: 4	غَيْرِ الْيَوْمِ
u'غَيْظٌ أَصْحَابٌ':Added, #4: 4	غَيْرِ الْيَوْمِ
u'غَيْظٌ عَدُوٌّ':Added, #1: 1	غَيْظِ أَصْحَابِهِ
u'غَيْمٌ مَانِعٌ':Added, #1: 1	غَيْظَ الْعَدُوِّ
u'غَيْمٌ وَطَش':Added, #1: 1	غَيْمٍ مَانِعٍ
u'غُيُوثٌ سَمَاءٌ':Added, #1: 1	غَيْمٍ وَطَشٍ
u'فَاءَ ظِلٌّ':Subject, #1: 1	غُيُوثَ السّمَاءِ
u'فَاءَ قَسَمٌ':Predicate, #2: 2	فَاءَ الظِّلُّ
u'فَاتَ اِبْنٌ':Predicate, #2: 2	أَفَاءَ قَسَمَ
u'فَاتَ أَجَلٌ':Subject, #3: 3	فَاتَ ابْنَ
u'فَاتَ أحَدٌ':Subject, #3: 3	فَاتَ الْأَجَلُ
u'فَاتَ أَدَاءٌ':Subject, #3: 3	فَاتَ أَحَدُ
u'فَاتَ إِدْرَاكٌ':Subject, #1: 1	فَاتَ الْأَدَاءُ
u'فَاتَ إِذْنٌ':Subject, #1: 1	فَاتَ إدْرَاكُهُ
u'فَاتَ إِرْشَادٌ':Subject, #1: 1	فَاتَ إذْنُهُ
u'فَاتَ أصل':Subject, #1: 1	فَاتَ الْإِرْشَادُ
u'فَاتَ أًصْلٌ':Subject, #4: 4	فَاتَ الْأَصْلُ
u'فَاتَ أَكْثَرُ':Subject, #4: 4	فَاتَ الْأَصْلُ
u'فَاتَ أَمْرٌ':Subject, #1: 1	فَاتَ أَكْثَرُ
u'فَاتَ إِمْساكٌ':Subject, #1: 1	فَاتَ أَمْرُهُ
u'فَاتَ إِمْكانٌ':Subject, #3: 3	فَاتَ الْإِمْسَاكُ
u'فَاتَ أَوَّلُ':Predicate, #1: 1	فَاتَ الْإِمْكَانُ
u'فَاتَ أَوَّلُ':Subject, #1: 1	فَاتَ الْأَوَّلِينَ
u'فَاتَ بِرٌّ':Predicate, #2: 2	فَاتَ الْأَوَّلُ
u'فَاتَ بِرٌّ':Subject, #2: 2	فَاتَ الْبِرَّ
u'فَاتَ بَعْضٌ':Subject, #6: 6	فَاتَ الْبِرُّ
u'فَاتَ بَعْضٌ':Subject, #1: 1	فَاتَ الْبَعْضُ
u'فَاتَ بَعْضٌ':Subject, #1: 1	فَاتَ بَعْضُهُ
u'فَاتَ بَيَانٌ':Subject, #4: 4	فَاتَ بَعْضُ
u'فَاتَ بَيَانٌ':Subject, #1: 1	فَاتَ بَيَانُهُ
u'فَاتَ تَحْصِيلٌ':Subject, #2: 2	فَاتَ الْبَيَانُ
u'فَاتَ تَدَارُكٌ':Subject, #1: 1	فَاتَ تَحْصِيلُ
u'فَاتَ تَدَارُكٌ':Subject, #1: 1	فَاتَ التَّدَارُكُ
u'فَاتَ تَدَارُكٌ':Subject, #1: 1	فَاتَ تَدَارُكُ
u'فَاتَ تَسْلِيمٌ':Subject, #1: 1	فَاتَ تَدَارُكُهُ
u'فَاتَ تَسْلِيمٌ':Subject, #1: 1	فَاتَ تَسْلِيمُ
u'فَاتَ تَمَكُّنٌ':Subject, #3: 3	فَاتَ التَّسْلِيمُ
u'فَاتَ ثَلاثَةٌ':Subject, #8: 8	فَاتَ التَّمَكُّنُ
u'فَاتَ جَازٌ':Predicate, #1: 1	فَاتَ ثَلَاثَةُ
u'فَاتَ جُزْءٌ':Subject, #1: 1	فَاتَ جَازَ
u'فَاتَ جَزَاءٌ':Subject, #2: 2	فَاتَ جُزْءٌ
u'فَاتَ جَمَالٌ':Subject, #1: 1	فَاتَ الْجَزَاءُ
u'فَاتَ جِنْسٌ':Subject, #1: 1	فَاتَ جَمَالُهُ
u'فَاتَ حَجٌّ':Subject, #1: 1	فَاتَ جِنْسُ
u'فَاتَ حَجٌّ':Subject, #1: 1	فَاتَ حَجُّهُ
u'فَاتَ حَرْثٌ':Subject, #5: 5	فَاتَ الْحَجُّ
u'فَاتَ حُكْمٌ':Subject, #1: 1	فَاتَ الْحَرْثُ
u'فَاتَ خَبَرٌ':Subject, #1: 1	فَاتَ الْحُكْمُ
u'فَاتَ خَبَر':Subject, #1: 1	فَاتَ الْخَبَرُ
u'فَاتَ رَأْيٌ':Subject, #1: 1	فَاتَ الْخَبَرُ
u'فَاتَ رَجُلٌ':Predicate, #1: 1	فَاتَ رَأْيُهُ
u'فَاتَ رَدٌّ':Predicate, #1: 1	فَاتَ الرَّجُلَ
u'فَاتَ رَدٌّ':Subject, #2: 2	فَاتَ رَدَّ
u'فَاتَ رَدٌّ':Subject, #1: 1	فَاتَ الرَّدُّ
u'فَاتَ رِضاً':Subject, #1: 1	فَاتَ رَدُّ
u'فَاتَ رُكْنٌ':Subject, #1: 1	فَاتَ رِضَاهُ
u'فَاتَ رُكْن':Subject, #1: 1	فَاتَ الرُّكْنُ
u'فَاتَ رُكْنٌ':Subject, #1: 1	فَاتَ الرُّكْنُ
u'فَاتَ رُكْنٌ':Subject, #1: 1	فَاتَ رُكْنٌ
u'فَاتَ رُكْن':Subject, #1: 1	فَاتَ رُكْنُ
u'فَاتَ رُكْن':Subject, #1: 1	فَاتَ رُكْنٌ
u'فَاتَ رَمْيٌ':Subject, #1: 1	فَاتَ رُكْنُ
u'فَاتَ سَامِعٌ':Predicate, #1: 1	فَاتَ الرَّمْيُ
u'فَاتَ سِتْرٌ':Subject, #1: 1	فَاتَ السَّامِعَ
u'فَاتَ سُجُودٌ':Subject, #1: 1	فَاتَ السِّتْرُ
u'فَاتَ شَرْطٌ':Subject, #1: 1	فَاتَ السُّجُودُ
u'فَاتَ شَرْطٌ':Subject, #1: 1	فَاتَ شَرْطُهُ
u'فَاتَ شَرْطٌ':Subject, #4: 4	فَاتَ شَرْطٌ
u'فَاتَ شَرْطٌ':Subject, #5: 5	فَاتَ الشَّرْطُ
u'فَاتَ شَهْرٌ':Subject, #7: 7	فَاتَ شَرْطُ
u'فَاتَ شَيْءٌ':Subject, #1: 1	فَاتَ الشَّهْرُ
u'فَاتَ صَبِيٌّ':Predicate, #3: 3	فَاتَ شَيْءٌ
u'فَاتَ صُورَةٌ':Subject, #1: 1	فَاتَ الصَّبِيَّ
u'فَاتَ صَوْمٌ':Subject, #1: 1	فَاتَ صُورَةُ
u'فَاتَ ضَرَرٌ':Subject, #2: 2	فَاتَ صَوْمُ
u'فَاتَ عَامٌ':Subject, #1: 1	فَاتَ الضَّرَرُ
u'فَاتَ عَبْدٌ':Predicate, #1: 1	فَاتَ الْعَامُ
u'فَاتَ عتق':Subject, #1: 1	فَاتَ الْعَبْدَ
u'فَاتَ عِتْقٌ':Subject, #1: 1	فَاتَ الْعِتْقُ
u'فَاتَ عَدَدٌ':Subject, #1: 1	فَاتَ الْعِتْقُ
u'فَاتَ عَدَمٌ':Subject, #1: 1	فَاتَ الْعَدَدُ
u'فَاتَ عند':Predicate, #1: 1	فَاتَ عَدَمُ
u'فَاتَ عِوَضٌ':Subject, #1: 1	فَاتَ عِنْدَ
u'فَاتَ عِيدٌ':Subject, #2: 2	فَاتَ الْعِوَضُ
u'فَاتَ غَرَضٌ':Subject, #1: 1	فَاتَ الْعِيدُ
u'فَاتَ غَرَضٌ':Subject, #1: 1	فَاتَ غَرَضُهُ
u'فَاتَ فَسْخٌ':Subject, #2: 2	فَاتَ الْغَرَضُ
u'فَاتَ قَبْضٌ':Subject, #2: 2	فَاتَ الْفَسْخُ
u'فَاتَ قتال':Subject, #1: 1	فَاتَ الْقَبْضُ
u'فَاتَ قِتَالٌ':Subject, #1: 1	فَاتَ الْقِتَالُ
u'فَاتَ قدرة':Predicate, #1: 1	فَاتَ الْقِتَالُ
u'فَاتَ قُدْرَةٌ':Predicate, #1: 1	فَاتَ الْقُدْرَةَ
u'فَاتَ قَسْمٌ':Subject, #1: 1	فَاتَ الْقُدْرَةَ
u'فَاتَكَ رُكوعٌ':Subject, #1: 1	فَاتَ الْقَسْمُ
u'فَاتَ كَسْبٌ':Subject, #2: 2	فَاتَكَ الرُّكُوعُ
u'فَاتَ لاَزِمٌ':Subject, #1: 1	فَاتَ كَسْبُهُ
u'فَاتَ لَحْمٌ':Subject, #1: 1	فَاتَ اللَّازِمُ
u'فَاتَ مَالٌ':Subject, #1: 1	فَاتَ اللَّحْمُ
u'فَاتَ مَبِيعٌ':Subject, #1: 1	فَاتَ الْمَالُ
u'فَاتَ مَجْمُوعٌ':Subject, #3: 3	فَاتَ الْمَبِيعُ
u'فَاتَ مَحَلٌّ':Subject, #1: 1	فَاتَ الْمَجْمُوعُ
u'فَاتَ مَحَلٌّ':Subject, #3: 3	فَاتَ مَحَلُّ
u'فَاتَ مَحَلٌّ':Subject, #3: 3	فَاتَ مَحَلُّهُ
u'فَاتَ مُسَلَّمٌ':Subject, #8: 8	فَاتَ الْمَحَلُّ
u'فَاتَ مَصْرِفٌ':Subject, #1: 1	فَاتَ الْمُسَلَّمُ
u'فَاتَ مُصَنِّفٌ':Predicate, #1: 1	فَاتَ الْمَصْرِفُ
u'فَاتَ مُصَنِّفٌ':Subject, #3: 3	فَاتَ الْمُصَنِّفَ
u'فَاتَ مَطْلَبٌ':Subject, #1: 1	فَاتَ الْمُصَنِّفُ
u'فَاتَ مَعْقُودٌ':Subject, #1: 1	فَاتَ مَطْلَبُهُ
u'فَاتَ مَعْلُولٌ':Subject, #1: 1	فَاتَ الْمَعْقُودُ
u'فَاتَ مُعَيَّنٌ':Subject, #1: 1	فَاتَ الْمَعْلُولُ
u'فَاتَ مَقْصِدٌ':Subject, #1: 1	فَاتَ الْمُعَيَّنُ
u'فَاتَ مَقْصُودٌ':Subject, #1: 1	فَاتَ مَقْصِدُهُ
u'فَاتَ مِلْكٌ':Subject, #2: 2	فَاتَ الْمَقْصُودُ
u'فَاتَ مِلْكٌ':Subject, #1: 1	فَاتَ الْمِلْكُ
u'فَاتَ مُؤَذِّنٌ':Predicate, #1: 1	فَاتَ مِلْكُ
u'فَاتَ مَوْضِعٌ':Subject, #1: 1	فَاتَ الْمُؤَذِّنَ
u'فَاتَ نِصْفٌ':Subject, #1: 1	فَاتَ مَوْضِعُ
u'فَاتَ نِصْفٌ':Subject, #2: 2	فَاتَ النِّصْفُ
u'فَاتَ نَمَاءٌ':Subject, #2: 2	فَاتَ نِصْفُ
u'فَاتَ وَجَبٌ':Predicate, #3: 3	فَاتَ النَّمَاءُ
u'فَاتَ وَصْفٌ':Subject, #2: 2	فَاتَ وَجَبَ
u'فَاتَ وَصْفٌ':Subject, #1: 1	فَاتَ وَصْفُ
u'فَاتَ وَقْتٌ':Subject, #2: 2	فَاتَ الْوَصْفُ
u'فَاتَ وَقْتٌ':Subject, #15: 15	فَاتَ وَقْتُ
u'فَاتَ وَقْتٌ':Subject, #20: 20	فَاتَ الْوَقْتُ
u'فَاتَ وُقُوفٌ':Predicate, #4: 4	فَاتَ وَقْتُهُ
u'فَاتَ يَمِينٌ':Subject, #1: 1	فَاتَ الْوُقُوفَ
u'فَاجَأَ رَجُلٌ':Predicate, #1: 1	فَاتَ الْيَمِينُ
u'فَاحَ ريحٌ':Subject, #1: 1	فَاجَأَ الرَّجُلَ
u'فَاحَ ريحٌ':Subject, #1: 1	فَاحَ رِيحُ
u'فَاخَرَ عقبة':Subject, #1: 1	فَاحَ رِيحُهُ
u'فَاخَرَ عُقْبَةٌ':Subject, #1: 1	فَاخَرَ عُقْبَةُ
u'فَادَى رَسُولٌ':Subject, #1: 1	فَاخَرَ عُقْبَةُ
u'فَارَ ضِغْنٌ':Subject, #1: 1	فَادَى رَسُولُ
u'فَارَقَ إِتْلاَفٌ':Subject, #1: 1	فَارَ ضِغْنُهُ
u'فَارَقَ إِجْزَاءٌ':Predicate, #1: 1	فَارَقَ إتْلَافُ
u'فَارَقَ أَخٌ':Predicate, #1: 1	فَارَقَ إجْزَاءَ
u'فَارَقَ إِدْرَاكٌ':Predicate, #1: 1	فَارَقَ الْأَخَ
u'فَارَقَ أَرْبَعَةٌ':Predicate, #1: 1	فَارَقَ إدْرَاكَ
u'فَارَقَ أرْضٌ':Predicate, #1: 1	فَارَقَ الْأَرْبَعَةَ
u'فَارَقَ إِسْلامٌ':Predicate, #4: 4	فَارَقَ الْأَرْضَ
u'فَارَقَ أَكْثَرُ':Predicate, #1: 1	فَارَقَ الْإِسْلَامَ
u'فَارَقَ أُمٌّ':Predicate, #4: 4	فَارَقَ أَكْثَرَ
u'فَارَقَ إمَامٌ':Predicate, #1: 1	فَارَقَ الْأُمَّ
u'فَارَقَ أَمينٌ':Predicate, #3: 3	فَارَقَ الْإِمَامَ
u'فَارَقَ أوامر':Predicate, #1: 1	فَارَقَ أَمِينَ
u'فَارَقَ أَوامِرُ':Predicate, #1: 1	فَارَقَ أَوَامِرَ
u'فَارَقَ أَوْثَانٌ':Predicate, #1: 1	فَارَقَ أَوَامِرَ
u'فَارَقَ أَوَّلُ':Subject, #1: 1	فَارَقَ الْأَوْثَانَ
u'فَارَقَ بَائِعٌ':Predicate, #1: 1	فَارَقَ الْأَوَّلُ
u'فَارَقَ بدن':Predicate, #2: 2	فَارَقَ الْبَائِعَ
u'فَارَقَ بَدَنٌ':Predicate, #2: 2	فَارَقَ الْبَدَنَ
u'فَارَقَ بَعْضٌ':Predicate, #2: 2	فَارَقَ الْبَدَنَ
u'فَارَقَ بَعْضٌ':Predicate, #1: 1	فَارَقَ الْبَعْضَ
u'فَارَقَ بَقاءٌ':Predicate, #1: 1	فَارَقَ بَعْضَ
u'فَارَقَ بُنْيانٌ':Predicate, #1: 1	فَارَقَ بَقَاءَ
u'فَارَقَ بَيْعٌ':Predicate, #1: 1	فَارَقَ الْبُنْيَانَ
u'فَارَقَ بُيُوتٌ':Predicate, #9: 9	فَارَقَ الْبَيْعَ
u'فَارَقَ بُيُوتٌ':Predicate, #2: 2	فَارَقَ الْبُيُوتَ
u'فَارَقَ تَلَفٌ':Predicate, #4: 4	فَارَقَ بُيُوتَ
u'فَارَقَ ثُبُوتٌ':Predicate, #1: 1	فَارَقَ تَلَفَ
u'فَارَقَ جَمَاعَةٌ':Predicate, #2: 2	فَارَقَ ثُبُوتَ
u'فَارَقَ جَوَازٌ':Predicate, #11: 11	فَارَقَ الْجَمَاعَةَ
u'فَارَقَ حَدٌّ':Predicate, #1: 1	فَارَقَ جَوَازَ
u'فَارَقَ حُرْمَةٌ':Predicate, #1: 1	فَارَقَ حَدَّ
u'فَارَقَ حُكْمٌ':Predicate, #1: 1	فَارَقَ حُرْمَةَ
u'فَارَقَ حَلْقٌ':Predicate, #2: 2	فَارَقَ حُكْمَ
u'فَارَقَ حُلَلٌ':Predicate, #1: 1	فَارَقَ الْحَلْقَ
u'فَارَقَ خَارِجٌ':Predicate, #1: 1	فَارَقَ الْحُلَلَ
u'فَارَقَ خَمْرٌ':Predicate, #1: 1	فَارَقَ الْخَارِجَ
u'فَارَقَ خيار':Predicate, #1: 1	فَارَقَ الْخَمْرَ
u'فَارَقَ خِيَارٌ':Predicate, #1: 1	فَارَقَ خِيَارَ
u'فَارَقَ خِيَامٌ':Predicate, #1: 1	فَارَقَ خِيَارَ
u'فَارَ قِدْرٌ':Subject, #1: 1	فَارَقَ خِيَامَ
u'فَارَقَ دُودٌ':Predicate, #1: 1	فَارَ الْقِدْرُ
u'فَارَقَ دُودٌ':Subject, #1: 1	فَارَقَ دُودَ
u'فَارَقَ دِينٌ':Predicate, #1: 1	فَارَقَ دُودُ
u'فَارَقَ رَبُّ':Subject, #1: 1	فَارَقَ دِينَ
u'فَارَقَ رَجُلٌ':Subject, #1: 1	فَارَقَ رَبُّ
u'فَارَقَ روحٌ':Subject, #3: 3	فَارَقَ الرَّجُلُ
u'فَارَقَ زَكاةٌ':Predicate, #2: 2	فَارَقَ الرُّوحُ
u'فَارَقَ سَائِرٌ':Predicate, #1: 1	فَارَقَ الزَّكَاةَ
u'فَارَقَ سجدة':Predicate, #1: 1	فَارَقَ سَائِرَ
u'فَارَقَ سَجْدَةٌ':Predicate, #1: 1	فَارَقَ السَّجْدَةَ
u'فَارَقَ سلام':Predicate, #1: 1	فَارَقَ السَّجْدَةَ
u'فَارَقَ سَلاَمٌ':Predicate, #1: 1	فَارَقَ السَّلَامَ
u'فَارَقَ سَلَمٌ':Subject, #1: 1	فَارَقَ السَّلَامَ
u'فَارَقَ سورٌ':Predicate, #1: 1	فَارَقَ السَّلَمُ
u'فَارَقَ شِرَاءٌ':Predicate, #2: 2	فَارَقَ سُورَ
u'فَارَقَ شَهَادَةٌ':Predicate, #1: 1	فَارَقَ شِرَاءَ
u'فَارَقَ صِحَّةٌ':Predicate, #1: 1	فَارَقَ الشَّهَادَةَ
u'فَارَقَ صداق':Predicate, #5: 5	فَارَقَ صِحَّةَ
u'فَارَقَ صَدَاقٌ':Predicate, #1: 1	فَارَقَ الصَّدَاقَ
u'فَارَقَ صدقة':Predicate, #1: 1	فَارَقَ الصَّدَاقَ
u'فَارَقَ صَدَقَةٌ':Predicate, #1: 1	فَارَقَ الصَّدَقَةَ
u'فَارَقَ صدقة':Predicate, #1: 1	فَارَقَ الصَّدَقَةَ
u'فَارَقَ صَدَقَةٌ':Predicate, #1: 1	فَارَقَ صَدَقَةَ
u'فَارَقَ صَرْفٌ':Predicate, #1: 1	فَارَقَ صَدَقَةَ
u'فَارَقَ صَرْف':Predicate, #1: 1	فَارَقَ الصَّرْفَ
u'فَارَقَ صِفَةٌ':Predicate, #1: 1	فَارَقَ الصَّرْفَ
u'فَارَقَ صَلاَةٌ':Predicate, #1: 1	فَارَقَ صِفَةَ
u'فَارَقَ صَلاَةٌ':Predicate, #1: 1	فَارَقَ صَلَاةَ
u'فَارَقَ صَوْمٌ':Predicate, #4: 4	فَارَقَ الصَّلَاةَ
u'فَارَقَ صَوْمٌ':Predicate, #1: 1	فَارَقَ صَوْمَ
u'فَارَقَ صَيْدٌ':Predicate, #2: 2	فَارَقَ الصَّوْمَ
u'فَارَقَ ضَمَانٌ':Predicate, #2: 2	فَارَقَ صَيْدَ
u'فَارَقَ ضَمَانٌ':Predicate, #1: 1	فَارَقَ الضَّمَانَ
u'فَارَقَ طعام':Predicate, #1: 1	فَارَقَ ضَمَانَ
u'فَارَقَ طَعَامٌ':Predicate, #1: 1	فَارَقَ الطَّعَامَ
u'فَارَقَ طَلاَقٌ':Predicate, #1: 1	فَارَقَ الطَّعَامَ
u'فَارَقَ طَلاَقٌ':Subject, #2: 2	فَارَقَ الطَّلَاقَ
u'فَارَقَ طَهَارَةٌ':Predicate, #1: 1	فَارَقَ الطَّلَاقُ
u'فَارَقَ ظهار':Predicate, #1: 1	فَارَقَ الطَّهَارَةَ
u'فَارَقَ عَاجِزٌ':Predicate, #2: 2	فَارَقَ الظِّهَارَ
u'فَارَقَ عَبْدٌ':Predicate, #1: 1	فَارَقَ الْعَاجِزَ
u'فَارَقَ عجاف':Predicate, #2: 2	فَارَقَ الْعَبْدَ
u'فَارَقَ عِجَافٌ':Predicate, #1: 1	فَارَقَ الْعِجَافَ
u'فَارَقَ عُجْبٌ':Predicate, #1: 1	فَارَقَ الْعِجَافَ
u'فَارَقَ عِدَّةٌ':Subject, #1: 1	فَارَقَ الْعُجْبَ
u'فَارَقَ عَدَمٌ':Predicate, #1: 1	فَارَقَ الْعِدَّةُ
u'فَارَقَ عُشْرٌ':Predicate, #12: 12	فَارَقَ عَدَمَ
u'فَارَقَ عُشْرٌ':Predicate, #1: 1	فَارَقَ الْعُشْرَ
u'فَارَقَ عُمْرَانٌ':Predicate, #1: 1	فَارَقَ عُشْرَ
u'فَارَقَ عمرة':Predicate, #2: 2	فَارَقَ الْعُمْرَانَ
u'فَارَقَ عُمْرَةٌ':Predicate, #1: 1	فَارَقَ الْعُمْرَةَ
u'فَارَقَ عُيُوبٌ':Predicate, #1: 1	فَارَقَ الْعُمْرَةَ
u'فَارَقَ غُسْلٌ':Subject, #1: 1	فَارَقَ الْعُيُوبَ
u'فَارَقَ غير':Subject, #1: 1	فَارَقَ غُسْلُ
u'فَارَقَ غَيْرٌ':Subject, #1: 1	فَارَقَ غَيْرُهُ
u'فَارَقَ فِعْلٌ':Predicate, #1: 1	فَارَقَ غَيْرُهُ
u'فَارَقَ فَقِيرٌ':Predicate, #1: 1	فَارَقَ الْفِعْلَ
u'فَارَقَ قِبْلَةٌ':Predicate, #1: 1	فَارَقَ الْفَقِيرَ
u'فَارَقَ قِرَاءةٌ':Predicate, #1: 1	فَارَقَ قِبْلَةَ
u'فَارَقَ قلب':Subject, #1: 1	فَارَقَ قِرَاءَةَ
u'فَارَقَ قَلْبٌ':Subject, #1: 1	فَارَقَ الْقَلْبُ
u'فَارَقَ قَلْب':Subject, #1: 1	فَارَقَ الْقَلْبُ
u'فَارَقَ قِنٌّ':Predicate, #1: 1	فَارَقَ الْقَلْبُ
u'فَارَقَ قول':Predicate, #1: 1	فَارَقَ الْقِنَّ
u'فَارَقَ قَوْلٌ':Predicate, #1: 1	فَارَقَ قَوْلَ
u'فَارَقَ قيام':Subject, #1: 1	فَارَقَ قَوْلَ
u'فَارَقَ قِيَامٌ':Subject, #1: 1	فَارَقَ الْقِيَامُ
u'فَارَقَ لَفْظٌ':Predicate, #1: 1	فَارَقَ الْقِيَامُ
u'فَارَقَ مَاءٌ':Subject, #1: 1	فَارَقَ لَفْظَ
u'فَارَقَ مَالٌ':Predicate, #1: 1	فَارَقَ الْمَاءُ
u'فَارَقَ مَأْمُورٌ':Predicate, #1: 1	فَارَقَ الْمَالَ
u'فَارَقَ مَجْلِسٌ':Predicate, #1: 1	فَارَقَ الْمَأْمُورَ
u'فَارَقَ مَجْلِسٌ':Predicate, #1: 1	فَارَقَ الْمَجْلِسَ
u'فَارَقَ مَجْنُونٌ':Subject, #1: 1	فَارَقَ مَجْلِسَ
u'فَارَقَ مَرِيضٌ':Subject, #1: 1	فَارَقَ الْمَجْنُونُ
u'فَارَقَ مُسَافِرٌ':Subject, #2: 2	فَارَقَ الْمَرِيضُ
u'فَارَقَ مَسْأَلَةٌ':Predicate, #2: 2	فَارَقَ الْمُسَافِرُ
u'فَارَقَ مُسْتَأْجِرٌ':Predicate, #2: 2	فَارَقَ مَسْأَلَةَ
u'فَارَقَ مُسْتَحِقٌّ':Subject, #1: 1	فَارَقَ الْمُسْتَأْجِرَ
u'فَارَقَ مَسْجِدٌ':Predicate, #1: 1	فَارَقَ الْمُسْتَحِقُّ
u'فَارَقَ مَعْرُوفٌ':Subject, #1: 1	فَارَقَ الْمَسْجِدَ
u'فَارَقَ مَنْعٌ':Predicate, #1: 1	فَارَقَ مَعْرُوفُ
u'فَارَقَ مَهْرٌ':Predicate, #1: 1	فَارَقَ مَنْعَ
u'فَارَقَ نَدْبٌ':Predicate, #1: 1	فَارَقَ الْمَهْرَ
u'فَارَقَ نَظِيرٌ':Subject, #1: 1	فَارَقَ نَدْبَ
u'فَارَقَ نكاح':Predicate, #1: 1	فَارَقَ نَظِيرُهُ
u'فَارَقَ نِكَاحٌ':Predicate, #2: 2	فَارَقَ النِّكَاحَ
u'فَارَقَ هلاك':Predicate, #2: 2	فَارَقَ النِّكَاحَ
u'فَارَقَ هَلاَكٌ':Predicate, #1: 1	فَارَقَ الْهَلَاكَ
u'فَارَقَ هلاك':Subject, #1: 1	فَارَقَ الْهَلَاكَ
u'فَارَقَ هَلاَكٌ':Subject, #1: 1	فَارَقَ الْهَلَاكُ
u'فَارَقَ وَجْهٌ':Predicate, #1: 1	فَارَقَ الْهَلَاكُ
u'فَارَقَ وُجُوبٌ':Predicate, #1: 1	فَارَقَ الْوَجْهَ
u'فَارَقَ وَصِيٌّ':Predicate, #3: 3	فَارَقَ وُجُوبَ
u'فَارَقَ وَصِيَّةٌ':Predicate, #2: 2	فَارَقَ الْوَصِيَّةَ
u'فَارَقَ وَطْءٌ':Predicate, #2: 2	فَارَقَ الْوَصِيَّةَ
u'فَارَقَ وَطْءٌ':Subject, #1: 1	فَارَقَ وَطْءَ
u'فَارَقَ وَكِيلٌ':Subject, #1: 1	فَارَقَ الْوَطْءُ
u'فَارَقَ يَمِينٌ':Subject, #4: 4	فَارَقَ الْوَكِيلُ
u'فَازَ بَائِعٌ':Subject, #1: 1	فَارَقَ الْيَمِينُ
u'فَازَ ذكر':Subject, #1: 1	فَازَ الْبَائِعُ
u'فَازَ ذَكَرٌ':Subject, #1: 1	فَازَ الذَّكَرُ
u'فَازَ رَجُلٌ':Subject, #1: 1	فَازَ الذَّكَرُ
u'فَازَ مَالِكٌ':Subject, #1: 1	فَازَ الرّجُلُ
u'فَازَ مُرْتَهِنٌ':Subject, #1: 1	فَازَ الْمَالِكُ
u'فَاضَ إمَامٌ':Subject, #1: 1	فَازَ الْمُرْتَهِنُ
u'فَاضَ رَسُولٌ':Subject, #7: 7	أَفَاضَ الْإِمَامُ
u'فَاضَ قَالٌ':Predicate, #14: 14	أَفَاضَ رَسُولُ
u'فَاضَ قَوْمٌ':Subject, #1: 1	أَفَاضَ قَالَ
u'فَاضَ مَاءٌ':Predicate, #1: 1	أَفَاضَ الْقَوْمُ
u'فَاضَ مَاءٌ':Subject, #2: 2	أَفَاضَ الْمَاءَ
u'فَاضَ مَاءٌ':Subject, #1: 1	فَاضَ مَاءُ
u'فَاضَ مُصَنِّفٌ':Subject, #2: 2	فَاضَ الْمَاءُ
u'فَاضَ نَاسٌ':Subject, #1: 1	أَفَاضَ الْمُصَنِّفُ
u'فَاضَ نَاسٌ':Subject, #1: 1	أَفَاضَ النّاسُ
u'فَاضَ نَبِيٌّ':Subject, #9: 9	أَفَاضَ النَّاسُ
u'فَاضَ يَوْمٌ':Predicate, #2: 2	أَفَاضَ النَّبِيُّ
u'فَاقَ أَبٌ':Subject, #3: 3	أَفَاضَ يَوْمَ
u'فَاقَ آخِرُ':Predicate, #1: 1	أَفَاقَ الْأَبُ
u'فَاقَ أَكْثَرُ':Predicate, #1: 1	أَفَاقَ آخِرَ
u'فَاقَ إمَامٌ':Subject, #2: 2	أَفَاقَ أَكْثَرَ
u'فَاقَ بَعْضٌ':Predicate, #1: 1	أَفَاقَ الْإِمَامُ
u'فَاقَ رَسُولٌ':Subject, #1: 1	أَفَاقَ بَعْضَ
u'فَاقَ سَكْرَان':Subject, #1: 1	أَفَاقَ رَسُولُ
u'فَاقَ عند':Predicate, #1: 1	أَفَاقَ السَّكْرَانُ
u'فَاقَ قَالٌ':Predicate, #1: 1	أَفَاقَ عِنْدَ
u'فَاقَ لَحْظ':Predicate, #5: 5	أَفَاقَ قَالَ
u'فَاقَ لَيْلٌ':Predicate, #1: 1	أَفَاقَ لَحْظَةً
u'فَاقَ مَجْنُونٌ':Subject, #1: 1	أَفَاقَ لَيْلَةً
u'فَاقَ مَجْنُونٌ':Subject, #19: 19	أَفَاقَ الْمَجْنُونُ
u'فَاقَ مَرِيضٌ':Subject, #4: 4	أَفَاقَ مَجْنُونٌ
u'فَاقَ مَعْتُوهٌ':Subject, #4: 4	أَفَاقَ الْمَرِيضُ
u'فَاقَ وَصِيٌّ':Subject, #1: 1	أَفَاقَ الْمَعْتُوهُ
u'فَالَ شَاعِر':Subject, #2: 2	أَفَاقَ الْوَصِيُّ
u'فَاوَضَ مُسْلِمٌ':Subject, #1: 1	فَالَ الشّاعِرُ
u'فَتَحَ أَبْوَابٌ':Predicate, #1: 1	فَاوَضَ الْمُسْلِمُ
u'فَتْحٌ أَبْوَابٌ':Added, #1: 1	فَتَحَ أَبْوَابَ
u'فَتْحٌ أَبْوَابٌ':Added, #1: 1	فَتْحُ أَبْوَابٍ
u'فَتْحٌ أَبْوَابٌ':Added, #1: 1	فَتْحِ أَبْوَابِ
u'فَتْحٌ أَبْوَابٌ':Added, #2: 2	فَتْحِ الْأَبْوَابِ
u'فَتَحَ أَرَاضِي':Predicate, #3: 3	فَتْحُ أَبْوَابِ
u'فَتْحٌ أَرْجاءُ':Added, #1: 1	فَتَحَ الْأَرَاضِيَ
u'فَتْحٌ أَرْجَاءٌ':Added, #1: 1	فَتْحِ الْأَرْجَاءِ
u'فَتْحٌ أرْضٌ':Added, #1: 1	فَتْحِ الْأَرْجَاءِ
u'فَتَحَ أَسْفَلُ':Predicate, #1: 1	فَتْحُ الْأَرْضِ
u'فَتْحٌ أَسْواقٌ':Added, #1: 1	فَتَحَ أَسْفَلَ
u'فَتْحٌ أَصابِعُ':Added, #1: 1	فَتْحَ الْأَسْوَاقِ
u'فَتَحَ إِصْطَبْلٌ':Predicate, #1: 1	فَتْحُ أَصَابِعِ
u'فَتَحَ إلَهٌ':Subject, #1: 1	فَتَحَ الْإِصْطَبْلَ
u'فَتَحَ إمَامٌ':Subject, #1: 1	فَتَحَ الْإِلَهُ
u'فَتْحٌ إمَامٌ':Added, #9: 9	فَتَحَ الْإِمَامُ
u'فَتَحَ إِنْسانٌ':Subject, #2: 2	فَتْحِ الْإِمَامِ
u'فَتَحَ إِنْسانٌ':Subject, #1: 1	فَتَحَ الْإِنْسَانُ
u'فَتَحَ باء':Predicate, #1: 1	فَتَحَ إنْسَانٌ
u'فَتْحٌ باء':Added, #1: 1	فَتَحَ الْبَاءَ
u'فَتْحٌ باء':Added, #1: 1	فَتْحَ الْبَاءِ
u'فَتَحَ بَابٌ':Predicate, #1: 1	فَتْحِ الْبَاءِ
u'فَتَحَ بَابٌ':Predicate, #12: 12	فَتَحَ بَابَ
u'فَتْحٌ بَابٌ':Added, #15: 15	فَتَحَ الْبَابَ
u'فَتْحٌ بَابٌ':Added, #11: 11	فَتْحُ بَابِ
u'فَتْحٌ بَابٌ':Added, #17: 17	فَتْحِ الْبَابِ
u'فَتْحٌ بَابٌ':Added, #17: 17	فَتْحِ بَابٍ
u'فَتْحٌ بَابٌ':Added, #1: 1	فَتْحَ بَابِهِ
u'فَتْحٌ بَابٌ':Added, #1: 1	فَتْحِ بَابِهِ
u'فَتْحٌ بَابٌ':Added, #24: 24	فَتْحُ بَابٍ
u'فَتْحٌ بَابٌ':Added, #2: 2	فَتْحَ الْبَابِ
u'فَتْحٌ بَابٌ':Added, #3: 3	فَتْحُ الْبَابِ
u'فَتْحٌ بَابٌ':Added, #3: 3	فَتْحَ بَابٍ
u'فَتْحٌ بَابٌ':Added, #3: 3	فَتْحُ بَابِهِ
u'فَتْحٌ بَابٌ':Added, #4: 4	فَتْحَ بَابِ
u'فَتَحَ بَعْضٌ':Subject, #7: 7	فَتْحِ بَابِ
u'فَتْحٌ بِلادٌ':Added, #1: 1	فَتَحَ بَعْضُ
u'فَتْحٌ بوَاسِيرُ':Added, #1: 1	فَتْحِ الْبِلَادِ
u'فَتْحٌ بَوَاسِيرُ':Added, #1: 1	فَتْحَ الْبَوَاسِيرِ
u'فَتْحٌ بَيْتٌ':Added, #1: 1	فَتْحَ الْبَوَاسِيرِ
u'فتحة بَابٌ':Added, #3: 3	فَتْحُ بَيْتِ
u'فَتْحَةٌ بَابٌ':Added, #1: 1	فَتْحَةُ الْبَابِ
u'فتحة بِنَاءٌ':Added, #1: 1	فَتْحَةُ الْبَابِ
u'فَتْحَةٌ بِنَاءٌ':Added, #1: 1	فَتْحَةُ الْبِنَاءِ
u'فتحة حاء':Added, #1: 1	فَتْحَةُ الْبِنَاءِ
u'فَتْحَةٌ حاء':Added, #1: 1	فَتْحَةُ الْحَاءِ
u'فتحة قَمِيصٌ':Added, #1: 1	فَتْحَةُ الْحَاءِ
u'فَتْحَةٌ قَمِيصٌ':Added, #1: 1	فَتْحَةُ الْقَمِيصِ
u'فتحة لاَمٌ':Added, #1: 1	فَتْحَةُ الْقَمِيصِ
u'فَتْحَةٌ لاَمٌ':Added, #1: 1	فَتْحَةَ اللَّامِ
u'فتحة همزة':Added, #1: 1	فَتْحَةَ اللَّامِ
u'فَتْحَةٌ همزة':Added, #1: 1	فَتْحَةِ هَمْزَةِ
u'فتحة هَمْزَةٌ':Added, #1: 1	فَتْحَةِ هَمْزَةِ
u'فَتْحَةٌ هَمْزَةٌ':Added, #1: 1	فَتْحَةِ هَمْزَةِ
u'فَتَحَ تاء':Predicate, #1: 1	فَتْحَةِ هَمْزَةِ
u'فَتَحَ تاء':Predicate, #1: 1	فَتَحَ تَاءَ
u'فَتْحٌ تاء':Added, #2: 2	فَتَحَ التَّاءَ
u'فَتْحٌ تاء':Added, #1: 1	فَتْحَ التَّاءِ
u'فَتْحٌ تاء':Added, #1: 1	فَتْحُ التَّاءِ
u'فَتْحٌ تاء':Added, #1: 1	فَتْحَ تَاءِ
u'فَتْحٌ تاء':Added, #1: 1	فَتْحِ تَاءِ
u'فَتْحٌ تاء':Added, #2: 2	فَتْحِ التَّاءِ
u'فَتَحَ تَاجِرٌ':Subject, #2: 2	فَتْحُ تَاءِ
u'فَتْحٌ تَحْصِيلٌ':Added, #3: 3	فَتَحَ التَّاجِرُ
u'فَتْحٌ ثَالِثٌ':Added, #1: 1	فَتْحِ تَحْصِيلِ
u'فَتْحٌ حاء':Added, #1: 1	فَتْحُ ثَالِثِهِ
u'فَتْحٌ حاء':Added, #1: 1	فَتْحَ الْحَاءِ
u'فَتْحٌ حاصِلٌ':Added, #1: 1	فَتْحُ الْحَاءِ
u'فَتَحَ حانوتٌ':Predicate, #1: 1	فَتْحٍ حَاصِلٍ
u'فَتْحٌ حانوتٌ':Added, #3: 3	فَتَحَ الْحَانُوتَ
u'فَتَحَ حِجْرٌ':Predicate, #1: 1	فَتْحَ الْحَانُوتِ
u'فَتَحَ حِرْزٌ':Predicate, #1: 1	فَتَحَ الْحِجْرَ
u'فَتْحٌ حِصْنٌ':Added, #1: 1	فَتَحَ الْحِرْزَ
u'فَتَحَ حَوانِيتُ':Predicate, #2: 2	فَتْحِ الْحِصْنِ
u'فَتْحٌ خاء':Added, #1: 1	فَتَحَ حَوَانِيتَ
u'فَتْحٌ خَوْخَةٌ':Added, #1: 1	فَتْحُ الْخَاءِ
u'فَتْحٌ دَارٌ':Added, #1: 1	فَتْحِ خَوْخَةٍ
u'فَتَحَ دَالٌ':Predicate, #1: 1	فَتْحِ دَارِ
u'فَتْحٌ دَالٌ':Added, #1: 1	فَتَحَ الدَّالَ
u'فَتْحٌ دَالٌ':Added, #1: 1	فَتْحُ دَالِ
u'فَتْحٌ دَالٌ':Added, #2: 2	فَتْحَ الدَّالِ
u'فَتَحَ دُكَّانٌ':Predicate, #2: 2	فَتْحِ الدَّالِ
u'فَتْحٌ راء':Added, #1: 1	فَتَحَ الدُّكَّانَ
u'فَتْحٌ راء':Added, #1: 1	فَتْحُ الرّاءِ
u'فَتْحٌ راء':Added, #1: 1	فَتْحُ الرَّاءِ
u'فَتَحَ رَأْسٌ':Predicate, #1: 1	فَتْحِ الرَّاءِ
u'فَتْحٌ رَأْسٌ':Added, #7: 7	فَتَحَ رَأْسَ
u'فَتَحَ رباط':Predicate, #1: 1	فَتْحِ رَأْسِ
u'فَتَحَ رِبَاطٌ':Predicate, #1: 1	فَتَحَ الرِّبَاطَ
u'فَتَحَ رَجُلٌ':Subject, #1: 1	فَتَحَ الرِّبَاطَ
u'فَتْحٌ رَجُلٌ':Added, #1: 1	فَتَحَ رَجُلٌ
u'فَتَحَ رَسُولٌ':Subject, #1: 1	فَتْحِ الرَّجُلِ
u'فَتْحٌ زاي':Added, #9: 9	فَتَحَ رَسُولُ
u'فَتْحٌ زاي':Added, #1: 1	فَتْحُ الزَّايِ
u'فَتْحٌ زِقٌّ':Added, #1: 1	فَتْحِ الزَّايِ
u'فَتَحَ سَدَدٌ':Predicate, #2: 2	فَتْحِ الزِّقِّ
u'فَتَحَ سَوادٌ':Predicate, #1: 1	فَتَحَ سَدَدَ
u'فَتَحَ سَوادٌ':Predicate, #1: 1	فَتَحَ سَوَادَ
u'فَتْحٌ سَوادٌ':Added, #3: 3	فَتَحَ السَّوَادَ
u'فَتْحٌ سِين':Added, #2: 2	فَتْحِ السَّوَادِ
u'فَتَحَ شافِعِيّ':Subject, #1: 1	فَتْحِ السِّينِ
u'فَتْحٌ شُبَّاكٌ':Added, #1: 1	فَتَحَ الشَّافِعِيُّ
u'فَتْحٌ شَيْءٌ':Added, #1: 1	فَتْحُ شُبَّاكِ
u'فَتَحَ شَيْخٌ':Subject, #1: 1	فَتْحِ شَيْءٍ
u'فَتَحَ صَاحِبٌ':Subject, #1: 1	فَتَحَ الشَّيْخُ
u'فَتَحَ صُنْدُوقٌ':Predicate, #2: 2	فَتَحَ صَاحِبُ
u'فَتْحٌ ضاد':Added, #1: 1	فَتَحَ الصُّنْدُوقَ
u'فَتَحَ طَائِفٌ':Predicate, #1: 1	فَتْحِ الضَّادِ
u'فَتْحٌ طَائِفٌ':Added, #1: 1	فَتَحَ الطَّائِفَ
u'فَتْحٌ طَرِيقٌ':Added, #1: 1	فَتْحِ الطَّائِفِ
u'فَتْحٌ طَرِيقٌ':Added, #1: 1	فَتْحِ الطَّرِيقِ
u'فَتَحَ عَبْدٌ':Subject, #3: 3	فَتْحُ الطَّرِيقِ
u'فَتَحَ عَسْكَرٌ':Subject, #1: 1	فَتَحَ عَبْدٌ
u'فَتَحَ عُمَرٌ':Subject, #2: 2	فَتَحَ الْعَسْكَرُ
u'فَتْحٌ عين':Added, #1: 1	فَتَحَ عُمَرُ
u'فَتْحٌ عين':Added, #1: 1	فَتْحُ عَيْنِهِ
u'فَتْحٌ عَيْنٌ':Added, #1: 1	فَتْحِ عَيْنِهِ
u'فَتْحٌ عَيْنٌ':Added, #1: 1	فَتْحُ عَيْنِهِ
u'فَتْحٌ عَيْن':Added, #1: 1	فَتْحِ عَيْنِهِ
u'فَتْحٌ عَيْن':Added, #1: 1	فَتْحُ عَيْنِهِ
u'فَتَحَ غير':Subject, #1: 1	فَتْحِ عَيْنِهِ
u'فَتَحَ غَيْرٌ':Subject, #2: 2	فَتَحَ غَيْرُ
u'فَتَحَ فَاهٌ':Subject, #2: 2	فَتَحَ غَيْرُ
u'فَتَحَ فُتُوحٌ':Predicate, #6: 6	فَتَحَ فَاهُ
u'فَتْحٌ فُقَّاعٌ':Added, #1: 1	فَتَحَ الْفُتُوحَ
u'فَتْحٌ فُقَّاعٌ':Added, #1: 1	فَتْحِ الْفُقَّاعِ
u'فَتَحَ فلان':Predicate, #1: 1	فَتْحِ فُقَّاعِهِ
u'فَتَحَ فلان':Predicate, #4: 4	فَتَحَ خَيْبَرَ
u'فَتَحَ فلان':Subject, #7: 7	فَتَحَ مَكَّةَ
u'فَتْحٌ فلان':Added, #1: 1	فَتَحَ الشَّافِعِيُّ
u'فَتْحٌ فلان':Added, #1: 1	فَتْحِ الْيَرْمُوكِ
u'فَتْحٌ قَبْرٌ':Added, #1: 1	فَتْحِ خَيْبَرٍ
u'فَتْحٌ قَدِيرٌ':Added, #1: 1	فَتْحَ الْقَبْرِ
u'فَتْحٌ قَدِيرٌ':Added, #1: 1	فَتْحُ الْقَدِيرِ
u'فَتْحٌ قَدِيرٌ':Added, #2816: 2816	فَتْحِ الْقَدِيرِ
u'فَتْحٌ قَفَصٌ':Added, #3: 3	فَتْحَ الْقَدِيرِ
u'فَتْحٌ قُفْلٌ':Added, #1: 1	فَتْحِ الْقَفَصِ
u'فَتْحٌ قلعة':Added, #1: 1	فَتْحِ قُفْلِهِ
u'فَتْحٌ قَلْعَةٌ':Added, #1: 1	فَتْحُ الْقَلْعَةِ
u'فَتَحَ قَيْدٌ':Predicate, #1: 1	فَتْحُ الْقَلْعَةِ
u'فَتَحَ كِتَابٌ':Predicate, #1: 1	فَتَحَ قَيْدَ
u'فَتْحٌ كِتَابٌ':Added, #5: 5	فَتَحَ الْكِتَابَ
u'فَتْحٌ كُوَّةٌ':Added, #1: 1	فَتْحِ الْكِتَابِ
u'فَتَحَ لاَمٌ':Predicate, #2: 2	فَتْحِ كُوَّةٍ
u'فَتْحٌ لاَمٌ':Added, #1: 1	فَتَحَ اللَّامَ
u'فَتْحٌ لاَمٌ':Added, #1: 1	فَتْحِ اللَّامِ
u'فَتْحٌ لَحْدٌ':Added, #1: 1	فَتْحِ لَامِ
u'فَتْحٌ لَحْدٌ':Added, #1: 1	فَتْحِ لَحْدِ
u'فَتْحٌ لَحْدٌ':Added, #2: 2	فَتْحِ لَحْدٍ
u'فَتَحَ مَاءٌ':Predicate, #3: 3	فَتْحِ اللَّحْدِ
u'فَتْحٌ مُحَمَّدٌ':Added, #1: 1	فَتَحَ الْمَاءَ
u'فَتْحٌ مَدَائِنُ':Added, #1: 1	فَتْحِ مُحَمّدٍ
u'فَتْحٌ مَدِينٌ':Added, #1: 1	فَتْحِ الْمَدَائِنِ
u'فَتْحٌ مَدِينَةٌ':Added, #1: 1	فَتْحَ مَدِينَةِ
u'فَتَحَ مِقْدَارٌ':Predicate, #1: 1	فَتْحَ مَدِينَةِ
u'فَتْحٌ مَنَافِذُ':Added, #1: 1	فَتَحَ مِقْدَارَ
u'فَتْحٌ مَوَادُّ':Added, #1: 1	فَتْحِ الْمَنَافِذِ
u'فَتْحٌ مِيمٌ':Added, #2: 2	فَتْحُ مَوَادِّ
u'فَتْحٌ مِيمٌ':Added, #1: 1	فَتْحِ الْمِيمِ
u'فَتَحَ نَهْرٌ':Predicate, #3: 3	فَتْحُ الْمِيمِ
u'فَتْحٌ نُونٌ':Added, #1: 1	فَتَحَ النَّهْرَ
u'فَتْحٌ هاء':Added, #4: 4	فَتْحِ النُّونِ
u'فَتَحَ همزة':Predicate, #1: 1	فَتْحُ الْهَاءِ
u'فَتَحَ هَمْزَةٌ':Predicate, #1: 1	فَتَحَ هَمْزَةَ
u'فَتْحٌ همزة':Added, #1: 1	فَتَحَ هَمْزَةَ
u'فَتْحٌ هَمْزَةٌ':Added, #1: 1	فَتْحِ الْهَمْزَةِ
u'فَتْحٌ همزة':Added, #1: 1	فَتْحِ الْهَمْزَةِ
u'فَتْحٌ هَمْزَةٌ':Added, #1: 1	فَتْحُ هَمْزَةِ
u'فَتْحٌ همزة':Added, #1: 1	فَتْحُ هَمْزَةِ
u'فَتْحٌ هَمْزَةٌ':Added, #3: 3	فَتْحُ الْهَمْزَةِ
u'فَتْحٌ يَمَامٌ':Added, #3: 3	فَتْحُ الْهَمْزَةِ
u'فَتْحٌ يَمَامٌ':Added, #1: 1	فَتْحُ الْيَمَامَةِ
u'فَتَرَ عِشْقٌ':Subject, #1: 1	فَتْحِ الْيَمَامَةِ
u'فَتَرَ وَحْيٌ':Subject, #1: 1	فَتَرَ عِشْقُهُ
u'فَتَرَ يَوْمٌ':Subject, #1: 1	فَتَرَ الْوَحْيُ
u'فَتَّشَ قَوْمٌ':Subject, #1: 1	فَتَرَ يَوْمُ
u'فَتَقَ أَمْعاءٌ':Predicate, #1: 1	فَتَّشَ الْقَوْمُ
u'فَتَقَ أَمْعَاءٌ':Predicate, #2: 2	فَتَقَ الأَمْعَاءَ
u'فَتَقَ أَمْعاءٌ':Predicate, #2: 2	فَتَقَ الأَمْعَاءَ
u'فَتَقَ أَمْعَاءٌ':Predicate, #4: 4	فَتَقَ الْأَمْعَاءَ
u'فَتَقَ أُمُورٌ':Predicate, #4: 4	فَتَقَ الْأَمْعَاءَ
u'فَتْقٌ بَعْضٌ':Added, #1: 1	فَتَقَ الْأُمُورَ
u'فَتَقَ ثَوْبٌ':Predicate, #1: 1	فَتْقِ بَعْضِ
u'فَتْقٌ فِرَاشٌ':Added, #1: 1	فَتَقَ الثَّوْبَ
u'فَتْقٌ فِرَاشٌ':Added, #1: 1	فَتْقَ الْفِرَاشِ
u'فَتَقَ قَمِيصٌ':Predicate, #1: 1	فَتْقِ الْفِرَاشِ
u'فَتْقٌ مُسْتَتِرٌ':Added, #1: 1	فَتَقَ قَمِيصَ
u'فَتْكٌ اِبْنٌ':Added, #1: 1	فَتْقِ الْمُسْتَتِرِ
u'فَتْلَةٌ دَلْوٌ':Added, #1: 1	فَتْكِ ابْنِ
u'فَتَلَ خَيَّاطٌ':Subject, #1: 1	فَتْلَةَ دَلْوٍ
u'فُتُوحٌ بِلادٌ':Added, #1: 1	فَتَلَ الْخَيَّاطُ
u'فُتُورٌ حَرٌّ':Added, #1: 1	فُتُوحِ الْبِلَادِ
u'فُتُورٌ حَواسٌّ':Added, #1: 1	فُتُورِ الْحَرِّ
u'فُتُورٌ حَوَاسُّ':Added, #2: 2	فُتُورُ الْحَوَاسِّ
u'فُتُورٌ ذكر':Added, #2: 2	فُتُورُ الْحَوَاسِّ
u'فُتُورٌ ذَكَرٌ':Added, #1: 1	فُتُورِ الذَّكَرِ
u'فُتُورٌ رَغْبَةٌ':Added, #1: 1	فُتُورِ الذَّكَرِ
u'فُتُورٌ شَرِيعَةٌ':Added, #1: 1	فُتُورَ رَغْبَةٍ
u'فُتُورٌ غضب':Added, #1: 1	فُتُورِ الشَّرِيعَةِ
u'فُتُورٌ غَضَبٌ':Added, #1: 1	فُتُورِ غَضَبِهِ
u'فَتِيَ بَعْضٌ':Predicate, #1: 1	فُتُورِ غَضَبِهِ
u'فَتِيَ عَامٌّ':Predicate, #1: 1	أَفْتَى بَعْضَ
u'فَتِيَ عُمَرٌ':Predicate, #1: 1	أَفْتَى الْعَامَّةَ
u'فَتِيَ نَاسٌ':Predicate, #1: 1	أَفْتَى عُمَرَ
u'فَجْأَةٌ سَمَاعٌ':Added, #2: 2	أَفْتَى النَّاسَ
u'فِجَاجٌ مَدِينٌ':Added, #2: 2	فَجْأَةِ السَّمَاعِ
u'فِجَاجٌ مَدِينَةٌ':Added, #1: 1	فِجَاجُ الْمَدِينَةِ
u'فَجَأَ عَدُوٌّ':Subject, #1: 1	فِجَاجُ الْمَدِينَةِ
u'فَجْرٌ آخِرُ':Added, #1: 1	فَجَأَ الْعَدُوُّ
u'فَجْرٌ أَوَّلُ':Added, #2: 2	فَجْرِ آخِرِ
u'فَجْرٌ ثَامِنٌ':Added, #6: 6	فَجْرِ أَوَّلِ
u'فَجَرَ رَجُلٌ':Subject, #1: 1	فَجْرِ الثَّامِنِ
u'فَجْرٌ سابع':Added, #1: 1	فَجَرَ الرَّجُلُ
u'فَجْرٌ سَابعٌ':Added, #1: 1	فَجْرِ السَّابِعِ
u'فَجْرٌ غَدٌ':Added, #1: 1	فَجْرِ السَّابِعِ
u'فَجْرٌ غَدٌ':Added, #1: 1	فَجْرُ الْغَدِ
u'فَجَرَ كفر':Predicate, #1: 1	فَجْرِ الْغَدِ
u'فَجْرٌ لَيْلٌ':Added, #1: 1	فَجَرَ كَفَرَ
u'فَجَرَ مَاءٌ':Subject, #3: 3	فَجْرِ لَيْلَةِ
u'فَجْرٌ مُقِيمٌ':Added, #1: 1	فَجَرَ الْمَاءُ
u'فَجْرٌ نَحْرٌ':Added, #1: 1	فَجْرِ الْمُقِيمِ
u'فَجْرٌ يَوْمٌ':Added, #2: 2	فَجْرِ النَّحْرِ
u'فَجْرٌ يَوْمٌ':Added, #1: 1	فَجْرَ يَوْمٍ
u'فَجْرٌ يَوْمٌ':Added, #1: 1	فَجْرُ يَوْمِ
u'فَجْرٌ يَوْمٌ':Added, #1: 1	فَجْرَ يَوْمِهِ
u'فَجْرٌ يَوْمٌ':Added, #20: 20	فَجْرِ يَوْمِ
u'فُجُورٌ فَاجِرٌ':Added, #2: 2	فَجْرَ يَوْمِ
u'فَحُشَ بُعْدٌ':Subject, #1: 1	فُجُورِ الْفَاجِرِ
u'فَحُشَ تَأْخِيرٌ':Subject, #1: 1	فَحُشَ بُعْدُهُ
u'فُحْشٌ تَأْخِيرٌ':Added, #3: 3	فَحُشَ التَّأْخِيرُ
u'فَحُشَ تَخَلُّفٌ':Subject, #1: 1	فُحْشِ التَّأْخِيرِ
u'فُحْشٌ تَخَلُّفٌ':Added, #1: 1	فَحُشَ التَّخَلُّفُ
u'فَحُشَ تَفاوُت':Subject, #1: 1	فُحْشِ التَّخَلُّفِ
u'فُحْشٌ تَفاوُت':Added, #1: 1	فَحُشَ التَّفَاوُتُ
u'فُحْشٌ تَفاوُت':Added, #1: 1	فُحْشُ التَّفَاوُتِ
u'فُحْشٌ جَوَابٌ':Added, #2: 2	فُحْشِ التَّفَاوُتِ
u'فُحْشٌ ضِيقٌ':Added, #1: 1	فُحْشِ الْجَوَابِ
u'فُحْشٌ عِبَارَةٌ':Added, #1: 1	فُحْشِ ضِيقِ
u'فَحُشَ غلب':Predicate, #1: 1	فُحْشِ الْعِبَارَةِ
u'فُحْشٌ غير':Added, #1: 1	فَحُشَ غَلَبَ
u'فُحْشٌ غَيْرٌ':Added, #1: 1	فُحْشَ غَيْرِهِ
u'فُحْشٌ قول':Added, #1: 1	فُحْشَ غَيْرِهِ
u'فُحْشٌ قَوْلٌ':Added, #1: 1	فُحْشِ الْقَوْلِ
u'فُحْشٌ مُخَالَفَةٌ':Added, #1: 1	فُحْشِ الْقَوْلِ
u'فُحْشٌ مَعْصِيَةٌ':Added, #4: 4	فُحْشِ الْمُخَالَفَةِ
u'فَحُشَ نُقْصَانٌ':Subject, #1: 1	فُحْشَ الْمَعْصِيَةِ
u'فَحَصَ أَحْنَف':Subject, #1: 1	فَحُشَ النُّقْصَانُ
u'فَحْصٌ عَالِمٌ':Added, #1: 1	فَحَصَ الْأَحْنَفُ
u'فَحْصٌ عَالِمٌ':Added, #1: 1	فَحْصَ الْعَالِمِ
u'فُحُوصٌ أرْضٌ':Added, #1: 1	فَحْصِ الْعَالِمِ
u'فُحُوصٌ صبر':Added, #1: 1	فُحُوصُ أَرْضِهِ
u'فُحُوصٌ صَبْرٌ':Added, #1: 1	فُحُوصِ صَبْرِهِ
u'فخر إِسْلامٌ':Added, #1: 1	فُحُوصِ صَبْرِهِ
u'فَخْرٌ إِسْلامٌ':Added, #154: 154	فَخْرِ الْإِسْلَامِ
u'فخر إِسْلامٌ':Added, #154: 154	فَخْرِ الْإِسْلَامِ
u'فَخْرٌ إِسْلامٌ':Added, #24: 24	فَخْرَ الْإِسْلَامِ
u'فخر إِسْلامٌ':Added, #24: 24	فَخْرَ الْإِسْلَامِ
u'فَخْرٌ إِسْلامٌ':Added, #291: 291	فَخْرُ الْإِسْلَامِ
u'فخر أئِمَّةٌ':Added, #291: 291	فَخْرُ الْإِسْلَامِ
u'فَخْرٌ أئِمَّةٌ':Added, #1: 1	فَخْرِ الْأَئِمَّةِ
u'فخر دِينٌ':Added, #1: 1	فَخْرِ الْأَئِمَّةِ
u'فَخْرٌ دِينٌ':Added, #119: 119	فَخْرُ الدِّينِ
u'فخر دِينٌ':Added, #119: 119	فَخْرُ الدِّينِ
u'فَخْرٌ دِينٌ':Added, #29: 29	فَخْرِ الدِّينِ
u'فخر دِينٌ':Added, #29: 29	فَخْرِ الدِّينِ
u'فَخْرٌ دِينٌ':Added, #8: 8	فَخْرَ الدِّينِ
u'فخر رُؤَسَاءُ':Added, #8: 8	فَخْرَ الدِّينِ
u'فَخْرٌ رُؤَسَاءُ':Added, #1: 1	فَخْرُ الرُّؤَسَاءِ
u'فِدَاءٌ أَسيرٌ':Added, #1: 1	فَخْرُ الرُّؤَسَاءِ
u'فِدَاءٌ أَسيرٌ':Added, #1: 1	فِدَاءَ الْأَسِيرِ
u'فِدَاءٌ أُمٌّ':Added, #2: 2	فِدَاءُ الْأَسِيرِ
u'فِدَاءٌ أهْلٌ':Added, #1: 1	فِدَاءَ الْأُمِّ
u'فِدَاءٌ أهْلٌ':Added, #1: 1	فِدَاءُ أَهْلِ
u'فِدَاءٌ أهْلٌ':Added, #1: 1	فِدَاءِ أَهْلِ
u'فِدَاءٌ أَوْلاَدٌ':Added, #2: 2	فِدَاءَ أَهْلِ
u'فِدَاءٌ بَدْرٌ':Added, #1: 1	فِدَاءُ أَوْلَادِهِ
u'فِدَاءٌ بِنْتٌ':Added, #3: 3	فِدَاءِ بَدْرٍ
u'فِدَاءٌ جِنَايَةٌ':Added, #2: 2	فِدَاءَ الْبِنْتِ
u'فِدَاءٌ جِنَايَةٌ':Added, #1: 1	فِدَاءِ الْجِنَايَةِ
u'فِدَاءٌ خدمة':Added, #1: 1	فِدَاءُ جِنَايَتِهِ
u'فِدَاءٌ خِدْمَةٌ':Added, #2: 2	فِدَاءِ خِدْمَتِهِ
u'فِدَاءٌ ذَبيحٌ':Added, #2: 2	فِدَاءِ خِدْمَتِهِ
u'فِدَاءٌ ذكر':Added, #1: 1	فِدَاءِ الذَّبِيحِ
u'فِدَاءٌ ذَكَرٌ':Added, #1: 1	فِدَاءُ الذَّكَرِ
u'فِدَاءٌ ذَكَرٌ':Added, #1: 1	فِدَاءُ الذَّكَرِ
u'فِدَاءٌ سَالِمٌ':Added, #2: 2	فِدَاءُ ذَكَرٍ
u'فِدَاءٌ سَلْمٌ':Added, #1: 1	فِدَاءَ سَالِمٍ
u'فِدَاءٌ سُهَيْلٌ':Added, #1: 1	فِدَاءِ سَلْمٍ
u'فِدَاءٌ سَيِّدٌ':Added, #2: 2	فِدَاءِ سُهَيْلِ
u'فِدَاءٌ شَيْءٌ':Added, #1: 1	فِدَاءِ السَّيِّدِ
u'فِدَاءٌ صَيْدٌ':Added, #1: 1	فِدَاءِ شَيْءٍ
u'فِدَاءٌ عَبْدٌ':Added, #2: 2	فِدَاءَ صَيْدٍ
u'فِدَاءٌ قَرِيبٌ':Added, #1: 1	فِدَاءَ الْعَبْدِ
u'فِدَاءٌ مُسْلِمٌ':Added, #1: 1	فِدَاءِ الْقَرِيبِ
u'فِدَاءٌ مُعْتَقٌ':Added, #1: 1	فِدَاءُ الْمُسْلِمِ
u'فِدَاءٌ نِصْفٌ':Added, #1: 1	فِدَاءُ مُعْتَقٍ
u'فِدَاءٌ نَفْسٌ':Added, #1: 1	فِدَاءِ النِّصْفِ
u'فِدَاءٌ نَفْسٌ':Added, #1: 1	فِدَاءُ النَّفْسِ
u'فِدَاءٌ ولد':Added, #2: 2	فِدَاءُ نَفْسِهِ
u'فِدَاءٌ وَلَدٌ':Added, #1: 1	فِدَاءُ الْوَلَدِ
u'فِدَاءٌ ولد':Added, #1: 1	فِدَاءُ الْوَلَدِ
u'فِدَاءٌ وَلَدٌ':Added, #2: 2	فِدَاءَ وَلَدِهِ
u'فَدَى أحَدٌ':Subject, #2: 2	فِدَاءَ وَلَدِهِ
u'فَدَى بَطَلٌ':Predicate, #1: 1	فَدَى أَحَدُ
u'فَدَى حالِق':Subject, #1: 1	فَدَى بَطَلَ
u'فَدَى حَقٌّ':Predicate, #2: 2	فَدَى الْحَالِقُ
u'فَدَى خَمْسَةٌ':Predicate, #1: 1	فَدَى حَقَّ
u'فَدَى رَجُلٌ':Predicate, #1: 1	فَدَى خَمْسَةَ
u'فَدَى رَهْنٌ':Predicate, #1: 1	فَدَى رَجُلاً
u'فَدَى طَيْرٌ':Predicate, #1: 1	فَدَى الرَّهْنَ
u'فَدَى عَبْدٌ':Predicate, #1: 1	فَدَى طَيْرَ
u'فَدَى مَرْهُونٌ':Predicate, #2: 2	فَدَى الْعَبْدَ
u'فَدَى مَرِيضٌ':Predicate, #1: 1	فَدَى الْمَرْهُونَ
u'فَدَى مِلْكٌ':Predicate, #1: 1	فَدَى الْمَرِيضَ
u'فَدَى نِصْفٌ':Predicate, #1: 1	فَدَى مِلْكَ
u'فَدَى واحد':Subject, #1: 1	فَدَى النِّصْفَ
u'فَدَى وَاحِدٌ':Subject, #1: 1	فَدَى الْوَاحِدُ
u'فَدَى وَاهِبٌ':Subject, #1: 1	فَدَى الْوَاحِدُ
u'فَدَى وَدِيعٌ':Predicate, #1: 1	فَدَى الْوَاهِبُ
u'فَدَى وَدِيعَةٌ':Predicate, #1: 1	فَدَى الْوَدِيعَةَ
u'فرار زَوْجٌ':Added, #1: 1	فَدَى الْوَدِيعَةَ
u'فِرَارٌ زَوْجٌ':Added, #1: 1	فِرَارَ الزَّوْجِ
u'فرار نَاسٌ':Added, #1: 1	فِرَارَ الزَّوْجِ
u'فِرَارٌ نَاسٌ':Added, #1: 1	فِرَارُ النَّاسِ
u'فِرَاسَةٌ مُؤْمِنٌ':Added, #1: 1	فِرَارُ النَّاسِ
u'فِرَاشٌ أَبٌ':Added, #4: 4	فِرَاسَةَ الْمُؤْمِنِ
u'فِرَاشٌ أحَدٌ':Added, #1: 1	فِرَاشِ الْأَبِ
u'فِرَاشٌ أُمٌّ':Added, #1: 1	فِرَاشِ أَحَدِ
u'فِرَاشٌ أُمٌّ':Added, #1: 1	فِرَاشَ أُمِّ
u'فِرَاشٌ أُمٌّ':Added, #1: 1	فِرَاشُ أُمِّ
u'فِرَاشٌ أُمٌّ':Added, #1: 1	فِرَاشِ أُمِّ
u'فِرَاشٌ أمَةٌ':Added, #1: 1	فِرَاشُ أُمِّهِ
u'فِرَاشٌ أمَةٌ':Added, #1: 1	فِرَاشُ الْأَمَةِ
u'فِرَاشٌ اِمْرَأَةٌ':Added, #1: 1	فِرَاشِ الْأَمَةِ
u'فِرَاشٌ إِنْسانٌ':Added, #1: 1	فِرَاشِ امْرَأَتِهِ
u'فِرَاشٌ أَوَّلُ':Added, #1: 1	فِرَاشِ إنْسَانٍ
u'فِرَاشٌ أَوَّلُ':Added, #1: 1	فِرَاشَ الْأَوَّلِ
u'فِرَاشٌ أَوَّلُ':Added, #1: 1	فِرَاشُ الْأَوَّلِ
u'فِرَاشٌ بَيْتٌ':Added, #1: 1	فِرَاشِ الْأَوَّلِ
u'فِرَاشٌ حُرِّيَّةٌ':Added, #1: 1	فِرَاشِ الْبَيْتِ
u'فِرَاشٌ حَرِيرٌ':Added, #2: 2	فِرَاشِ الْحُرِّيَّةِ
u'فِرَاشٌ ذَهَبٌ':Added, #2: 2	فِرَاشِ الْحَرِيرِ
u'فِرَاشٌ رَجُلٌ':Added, #1: 1	فِرَاشُ الذَّهَبِ
u'فِرَاشٌ رَسُولٌ':Added, #1: 1	فِرَاشِ رَجُلٍ
u'فِرَاشٌ رَسُولٌ':Added, #2: 2	فِرَاشِ رَسُولِ
u'فِرَاشٌ زَوْجٌ':Added, #5: 5	فِرَاشُ رَسُولِ
u'فِرَاشٌ زَوْجٌ':Added, #1: 1	فِرَاش الزَّوْجِ
u'فِرَاشٌ زَوْجٌ':Added, #1: 1	فِرَاشَ الزَّوْجِ
u'فِرَاشٌ زَوْجٌ':Added, #1: 1	فِرَاشُ الزَّوْجِ
u'فِرَاشٌ زَوْجٌ':Added, #1: 1	فِرَاشَ زَوْجٍ
u'فِرَاشٌ زَوْجٌ':Added, #2: 2	فِرَاشِ الزَّوْجِ
u'فِرَاشٌ زَوْجَةٌ':Added, #2: 2	فِرَاشِ زَوْجٍ
u'فِرَاشٌ سَيِّدٌ':Added, #1: 1	فِرَاشِ الزَّوْجَةِ
u'فِرَاشٌ طَاهِرٌ':Added, #1: 1	فِرَاشِ السَّيِّدِ
u'فِرَاشٌ عَبْدٌ':Added, #2: 2	فِرَاشٍ طَاهِرٍ
u'فِرَاشٌ عظام':Added, #1: 1	فِرَاشِ الْعَبْدِ
u'فِرَاشٌ عِظَامٌ':Added, #1: 1	فِرَاشُ الْعِظَامِ
u'فِرَاشٌ عَظْمٌ':Added, #1: 1	فِرَاشُ الْعِظَامِ
u'فِرَاشٌ غير':Added, #2: 2	فِرَاشَ الْعَظْمِ
u'فِرَاشٌ غَيْرٌ':Added, #1: 1	فِرَاشِ الْغَيْرِ
u'فِرَاشٌ فَاسِدٌ':Added, #1: 1	فِرَاشِ الْغَيْرِ
u'فِرَاشٌ مَبْسُوطٌ':Added, #1: 1	فِرَاشٍ فَاسِدٍ
u'فِرَاشٌ مِلْكٌ':Added, #1: 1	فِرَاشٍ مَبْسُوطٍ
u'فِرَاشٌ مَنْكُوح':Added, #3: 3	فِرَاشِ الْمِلْكِ
u'فِرَاشٌ مَنْكُوح':Added, #1: 1	فِرَاشُ الْمَنْكُوحَةِ
u'فِرَاشٌ نَبِيٌّ':Added, #1: 1	فِرَاشِ الْمَنْكُوحَةِ
u'فِرَاشٌ نكاح':Added, #1: 1	فِرَاشِ النَّبِيِّ
u'فِرَاشٌ نِكَاحٌ':Added, #1: 1	فِرَاشُ النِّكَاحِ
u'فِرَاشٌ نكاح':Added, #1: 1	فِرَاشُ النِّكَاحِ
u'فِرَاشٌ نكاح':Added, #3: 3	فِرَاشَ النِّكَاحِ
u'فِرَاشٌ نِكَاحٌ':Added, #3: 3	فِرَاشِ النِّكَاحِ
u'فِرَاشٌ نِكَاحٌ':Added, #3: 3	فِرَاشَ النِّكَاحِ
u'فِرَاشٌ نكاح':Added, #3: 3	فِرَاشِ النِّكَاحِ
u'فِرَاشٌ نِكَاحٌ':Added, #3: 3	فِرَاشِ نِكَاحٍ
u'فِرَاشٌ نكرة':Added, #3: 3	فِرَاشِ نِكَاحٍ
u'فِرَاشٌ نَكِرَةٌ':Added, #1: 1	فِرَاشٍ نَكِرَةٍ
u'فِرَاشٌ واحد':Added, #1: 1	فِرَاشٍ نَكِرَةٍ
u'فِرَاشٌ وَاحِدٌ':Added, #5: 5	فِرَاشٍ وَاحِدٍ
u'فراغ إِجَابَةٌ':Added, #5: 5	فِرَاشٍ وَاحِدٍ
u'فَرَاغٌ إِجَابَةٌ':Added, #1: 1	فَرَاغِ الْإِجَابَةِ
u'فراغ أَجَلٌ':Added, #1: 1	فَرَاغِ الْإِجَابَةِ
u'فَرَاغٌ أَجَلٌ':Added, #5: 5	فَرَاغِ الْأَجَلِ
u'فراغ أَذَانٌ':Added, #5: 5	فَرَاغِ الْأَجَلِ
u'فَرَاغٌ أَذَانٌ':Added, #4: 4	فَرَاغِ الْأَذَانِ
u'فراغ أَرْبَعَةٌ':Added, #4: 4	فَرَاغِ الْأَذَانِ
u'فَرَاغٌ أَرْبَعَةٌ':Added, #1: 1	فَرَاغِ الْأَرْبَعَةِ
u'فراغ أرْضٌ':Added, #1: 1	فَرَاغِ الْأَرْبَعَةِ
u'فَرَاغٌ أرْضٌ':Added, #1: 1	فَرَاغِ الْأَرْضِ
u'فراغ أُسْبُوعٌ':Added, #1: 1	فَرَاغِ الْأَرْضِ
u'فَرَاغٌ أُسْبُوعٌ':Added, #1: 1	فَرَاغِ الْأُسْبُوعِ
u'فراغ أَعْضَاءٌ':Added, #1: 1	فَرَاغِ الْأُسْبُوعِ
u'فَرَاغٌ أَعْضَاءٌ':Added, #1: 1	فَرَاغِ الْأَعْضَاءِ
u'فراغ أَعْمَالٌ':Added, #1: 1	فَرَاغِ الْأَعْضَاءِ
u'فَرَاغٌ أَعْمَالٌ':Added, #2: 2	فَرَاغِ الْأَعْمَالِ
u'فراغ إقْرَارٌ':Added, #2: 2	فَرَاغِ الْأَعْمَالِ
u'فَرَاغٌ إقْرَارٌ':Added, #1: 1	فَرَاغِ الْإِقْرَارِ
u'فراغ أكل':Added, #1: 1	فَرَاغِ الْإِقْرَارِ
u'فراغ أَكْلٌ':Added, #1: 1	فَرَاغِ الْأَكْلِ
u'فَرَاغٌ أكل':Added, #1: 1	فَرَاغِ الْأَكْلِ
u'فَرَاغٌ أَكْلٌ':Added, #1: 1	فَرَاغِ الْأَكْلِ
u'فراغ إمَامٌ':Added, #1: 1	فَرَاغِ الْأَكْلِ
u'فَرَاغٌ إمَامٌ':Added, #2: 2	فَرَاغِ إمَامِهِ
u'فراغ إمَامٌ':Added, #2: 2	فَرَاغِ إمَامِهِ
u'فَرَاغٌ إمَامٌ':Added, #4: 4	فَرَاغَ الْإِمَامِ
u'فراغ إمَامٌ':Added, #4: 4	فَرَاغَ الْإِمَامِ
u'فَرَاغٌ إمَامٌ':Added, #6: 6	فَرَاغَ إمَامِهِ
u'فراغ إمَامٌ':Added, #6: 6	فَرَاغَ إمَامِهِ
u'فَرَاغٌ إمَامٌ':Added, #91: 91	فَرَاغِ الْإِمَامِ
u'فراغ أَوَّلُ':Added, #91: 91	فَرَاغِ الْإِمَامِ
u'فَرَاغٌ أَوَّلُ':Added, #1: 1	فَرَاغَ الْأَوَّلِ
u'فراغ بَيَانٌ':Added, #1: 1	فَرَاغَ الْأَوَّلِ
u'فَرَاغٌ بَيَانٌ':Added, #1: 1	فَرَاغِ بَيَانِ
u'فراغ تَشَهُّدٌ':Added, #1: 1	فَرَاغِ بَيَانِ
u'فَرَاغٌ تَشَهُّدٌ':Added, #3: 3	فَرَاغِ التَّشَهُّدِ
u'فراغ تَلَفُّظٌ':Added, #3: 3	فَرَاغِ التَّشَهُّدِ
u'فَرَاغٌ تَلَفُّظٌ':Added, #1: 1	فَرَاغِ التَّلَفُّظِ
u'فراغ ثَانِي':Added, #1: 1	فَرَاغِ التَّلَفُّظِ
u'فَرَاغٌ ثَانِي':Added, #1: 1	فَرَاغِ الثَّانِيَةِ
u'فراغ ثَانِيَةٌ':Added, #1: 1	فَرَاغِ الثَّانِيَةِ
u'فَرَاغٌ ثَانِيَةٌ':Added, #1: 1	فَرَاغِ الثَّانِيَةِ
u'فراغ حاجَةٌ':Added, #1: 1	فَرَاغِ الثَّانِيَةِ
u'فَرَاغٌ حاجَةٌ':Added, #2: 2	فَرَاغَ الْحَاجَةِ
u'فراغ حَجٌّ':Added, #2: 2	فَرَاغَ الْحَاجَةِ
u'فَرَاغٌ حَجٌّ':Added, #2: 2	فَرَاغِ الْحَجِّ
u'فراغ حُكْمٌ':Added, #2: 2	فَرَاغِ الْحَجِّ
u'فَرَاغٌ حُكْمٌ':Added, #2: 2	فَرَاغِ الْحُكْمِ
u'فراغ خدمة':Added, #2: 2	فَرَاغِ الْحُكْمِ
u'فَرَاغٌ خدمة':Added, #2: 2	فَرَاغِ الْخِدْمَةِ
u'فراغ خِدْمَةٌ':Added, #2: 2	فَرَاغِ الْخِدْمَةِ
u'فَرَاغٌ خِدْمَةٌ':Added, #2: 2	فَرَاغِ الْخِدْمَةِ
u'فراغ خطبة':Added, #2: 2	فَرَاغِ الْخِدْمَةِ
u'فَرَاغٌ خطبة':Added, #2: 2	فَرَاغِ الْخُطْبَةِ
u'فراغ خُطْبَةٌ':Added, #2: 2	فَرَاغِ الْخُطْبَةِ
u'فَرَاغٌ خُطْبَةٌ':Added, #2: 2	فَرَاغِ الْخُطْبَةِ
u'فراغ دُعَاءٌ':Added, #2: 2	فَرَاغِ الْخُطْبَةِ
u'فَرَاغٌ دُعَاءٌ':Added, #2: 2	فَرَاغِ الدُّعَاءِ
u'فراغ دفن':Added, #2: 2	فَرَاغِ الدُّعَاءِ
u'فَرَاغٌ دفن':Added, #2: 2	فَرَاغِ دَفْنِهِ
u'فراغ دَفْنٌ':Added, #2: 2	فَرَاغِ دَفْنِهِ
u'فَرَاغٌ دَفْنٌ':Added, #2: 2	فَرَاغِ دَفْنِهِ
u'فراغ ذكر':Added, #2: 2	فَرَاغِ دَفْنِهِ
u'فَرَاغٌ ذكر':Added, #1: 1	فَرَاغِ الذِّكْرِ
u'فراغ ذِكْرٌ':Added, #1: 1	فَرَاغِ الذِّكْرِ
u'فَرَاغٌ ذِكْرٌ':Added, #1: 1	فَرَاغِ الذِّكْرِ
u'فراغ ذِمَّةٌ':Added, #1: 1	فَرَاغِ الذِّكْرِ
u'فَرَاغٌ ذِمَّةٌ':Added, #1: 1	فَرَاغُ ذِمَّةِ
u'فراغ ذِمَّةٌ':Added, #1: 1	فَرَاغُ ذِمَّةِ
u'فَرَاغٌ ذِمَّةٌ':Added, #1: 1	فَرَاغُ ذِمَّتِهِ
u'فراغ ذِمَّةٌ':Added, #1: 1	فَرَاغُ ذِمَّتِهِ
u'فَرَاغٌ ذِمَّةٌ':Added, #2: 2	فَرَاغَ الذِّمَّةِ
u'فراغ ذِمَّةٌ':Added, #2: 2	فَرَاغَ الذِّمَّةِ
u'فَرَاغٌ ذِمَّةٌ':Added, #2: 2	فَرَاغِ ذِمَّتِهِ
u'فراغ ذِمَّةٌ':Added, #2: 2	فَرَاغِ ذِمَّتِهِ
u'فَرَاغٌ ذِمَّةٌ':Added, #3: 3	فَرَاغَ ذِمَّتِهِ
u'فراغ ذِمَّةٌ':Added, #3: 3	فَرَاغَ ذِمَّتِهِ
u'فَرَاغٌ ذِمَّةٌ':Added, #5: 5	فَرَاغُ الذِّمَّةِ
u'فراغ رِجَالٌ':Added, #5: 5	فَرَاغُ الذِّمَّةِ
u'فَرَاغٌ رِجَالٌ':Added, #1: 1	فَرَاغِ الرِّجَالِ
u'فراغ رحم':Added, #1: 1	فَرَاغِ الرِّجَالِ
u'فَرَاغٌ رحم':Added, #1: 1	فَرَاغِ رَحِمِ
u'فراغ رَحِمٌ':Added, #1: 1	فَرَاغِ رَحِمِ
u'فَرَاغٌ رَحِمٌ':Added, #1: 1	فَرَاغِ رَحِمِ
u'فراغ رحم':Added, #1: 1	فَرَاغِ رَحِمِ
u'فَرَاغٌ رحم':Added, #28: 28	فَرَاغِ الرَّحِمِ
u'فراغ رَحِمٌ':Added, #28: 28	فَرَاغِ الرَّحِمِ
u'فَرَاغٌ رَحِمٌ':Added, #28: 28	فَرَاغِ الرَّحِمِ
u'فراغ رَسُولٌ':Added, #28: 28	فَرَاغِ الرَّحِمِ
u'فراغ رَسُولٌ':Added, #1: 1	فَرَاغُ رَسُولِ
u'فَرَاغٌ رَسُولٌ':Added, #1: 1	فَرَاغِ رَسُولِ
u'فَرَاغٌ رَسُولٌ':Added, #1: 1	فَرَاغُ رَسُولِ
u'فراغ زَوْجٌ':Added, #1: 1	فَرَاغِ رَسُولِ
u'فَرَاغٌ زَوْجٌ':Added, #1: 1	فَرَاغِ الزَّوْجِ
u'فراغ سلام':Added, #1: 1	فَرَاغِ الزَّوْجِ
u'فَرَاغٌ سلام':Added, #1: 1	فَرَاغِ السَّلَامِ
u'فراغ سَلاَمٌ':Added, #1: 1	فَرَاغِ السَّلَامِ
u'فَرَاغٌ سَلاَمٌ':Added, #1: 1	فَرَاغِ السَّلَامِ
u'فراغ شَهْرٌ':Added, #1: 1	فَرَاغِ السَّلَامِ
u'فَرَاغٌ شَهْرٌ':Added, #1: 1	فَرَاغِ الشَّهْرِ
u'فراغ صَلاَةٌ':Added, #1: 1	فَرَاغِ الشَّهْرِ
u'فراغ صَلاَةٌ':Added, #1: 1	فَرَاغ الصَّلَاةِ
u'فَرَاغٌ صَلاَةٌ':Added, #1: 1	فَرَاغَ الصَّلَاةِ
u'فَرَاغٌ صَلاَةٌ':Added, #1: 1	فَرَاغ الصَّلَاةِ
u'فراغ صَلاَةٌ':Added, #1: 1	فَرَاغَ الصَّلَاةِ
u'فَرَاغٌ صَلاَةٌ':Added, #1: 1	فَرَاغِ صَلَاتِهِ
u'فراغ صَلاَةٌ':Added, #1: 1	فَرَاغِ صَلَاتِهِ
u'فَرَاغٌ صَلاَةٌ':Added, #2: 2	فَرَاغِ الصَّلَاةِ
u'فراغ صَوْمٌ':Added, #2: 2	فَرَاغِ الصَّلَاةِ
u'فَرَاغٌ صَوْمٌ':Added, #1: 1	فَرَاغِ الصَّوْمِ
u'فراغ صَوْمٌ':Added, #1: 1	فَرَاغِ الصَّوْمِ
u'فَرَاغٌ صَوْمٌ':Added, #1: 1	فَرَاغِ صَوْمِ
u'فراغ صِيَامٌ':Added, #1: 1	فَرَاغِ صَوْمِ
u'فَرَاغٌ صِيَامٌ':Added, #1: 1	فَرَاغِ الصِّيَامِ
u'فراغ طَائِفٌ':Added, #1: 1	فَرَاغِ الصِّيَامِ
u'فَرَاغٌ طَائِفٌ':Added, #1: 1	فَرَاغَ الطَّائِفَةِ
u'فراغ طواف':Added, #1: 1	فَرَاغَ الطَّائِفَةِ
u'فَرَاغٌ طواف':Added, #2: 2	فَرَاغِ الطَّوَافِ
u'فراغ طَوَافٌ':Added, #2: 2	فَرَاغِ الطَّوَافِ
u'فَرَاغٌ طَوَافٌ':Added, #2: 2	فَرَاغِ الطَّوَافِ
u'فراغ عِدَّةٌ':Added, #2: 2	فَرَاغِ الطَّوَافِ
u'فَرَاغٌ عِدَّةٌ':Added, #1: 1	فَرَاغِ عِدَّةٍ
u'فراغ عِدَّةٌ':Added, #1: 1	فَرَاغِ عِدَّةٍ
u'فَرَاغٌ عِدَّةٌ':Added, #3: 3	فَرَاغِ الْعِدَّةِ
u'فراغ عمرة':Added, #3: 3	فَرَاغِ الْعِدَّةِ
u'فَرَاغٌ عمرة':Added, #1: 1	فَرَاغُ الْعُمْرَةِ
u'فراغ عُمْرَةٌ':Added, #1: 1	فَرَاغُ الْعُمْرَةِ
u'فَرَاغٌ عُمْرَةٌ':Added, #1: 1	فَرَاغُ الْعُمْرَةِ
u'فراغ عمرة':Added, #1: 1	فَرَاغُ الْعُمْرَةِ
u'فَرَاغٌ عمرة':Added, #2: 2	فَرَاغِ الْعُمْرَةِ
u'فراغ عُمْرَةٌ':Added, #2: 2	فَرَاغِ الْعُمْرَةِ
u'فَرَاغٌ عُمْرَةٌ':Added, #2: 2	فَرَاغِ الْعُمْرَةِ
u'فراغ عَمَلٌ':Added, #2: 2	فَرَاغِ الْعُمْرَةِ
u'فَرَاغٌ عَمَلٌ':Added, #1: 1	فَرَاغَ الْعَمَلِ
u'فراغ عَمَلٌ':Added, #1: 1	فَرَاغَ الْعَمَلِ
u'فَرَاغٌ عَمَلٌ':Added, #1: 1	فَرَاغِ عَمَلِهِ
u'فراغ عَمَلٌ':Added, #1: 1	فَرَاغِ عَمَلِهِ
u'فَرَاغٌ عَمَلٌ':Added, #6: 6	فَرَاغِ الْعَمَلِ
u'فراغ غَسْلٌ':Added, #6: 6	فَرَاغِ الْعَمَلِ
u'فَرَاغٌ غَسْلٌ':Added, #2: 2	فَرَاغِ غَسْلِهِ
u'فراغ فراغ':Added, #2: 2	فَرَاغِ غَسْلِهِ
u'فَرَاغٌ فراغ':Added, #1: 1	فَرَاغَ الْفَرَاغِ
u'فراغ فَرَاغٌ':Added, #1: 1	فَرَاغَ الْفَرَاغِ
u'فَرَاغٌ فَرَاغٌ':Added, #1: 1	فَرَاغَ الْفَرَاغِ
u'فراغ قَارِئٌ':Added, #1: 1	فَرَاغَ الْفَرَاغِ
u'فراغ قَارِئٌ':Added, #1: 1	فَرَاغَ الْقَارِئِ
u'فَرَاغٌ قَارِئٌ':Added, #1: 1	فَرَاغِ الْقَارِئِ
u'فَرَاغٌ قَارِئٌ':Added, #1: 1	فَرَاغَ الْقَارِئِ
u'فراغ قلب':Added, #1: 1	فَرَاغِ الْقَارِئِ
u'فراغ قلب':Added, #1: 1	فَرَاغَ الْقَلْبِ
u'فَرَاغٌ قلب':Added, #1: 1	فَرَاغِ الْقَلْبِ
u'فَرَاغٌ قلب':Added, #1: 1	فَرَاغَ الْقَلْبِ
u'فراغ قَلْبٌ':Added, #1: 1	فَرَاغِ الْقَلْبِ
u'فراغ قَلْبٌ':Added, #1: 1	فَرَاغَ الْقَلْبِ
u'فراغ قَلْب':Added, #1: 1	فَرَاغِ الْقَلْبِ
u'فراغ قَلْب':Added, #1: 1	فَرَاغَ الْقَلْبِ
u'فَرَاغٌ قَلْبٌ':Added, #1: 1	فَرَاغِ الْقَلْبِ
u'فَرَاغٌ قَلْبٌ':Added, #1: 1	فَرَاغَ الْقَلْبِ
u'فَرَاغٌ قَلْب':Added, #1: 1	فَرَاغِ الْقَلْبِ
u'فَرَاغٌ قَلْب':Added, #1: 1	فَرَاغَ الْقَلْبِ
u'فراغ قلب':Added, #1: 1	فَرَاغِ الْقَلْبِ
u'فَرَاغٌ قلب':Added, #2: 2	فَرَاغُ الْقَلْبِ
u'فراغ قَلْبٌ':Added, #2: 2	فَرَاغُ الْقَلْبِ
u'فراغ قَلْب':Added, #2: 2	فَرَاغُ الْقَلْبِ
u'فَرَاغٌ قَلْبٌ':Added, #2: 2	فَرَاغُ الْقَلْبِ
u'فَرَاغٌ قَلْب':Added, #2: 2	فَرَاغُ الْقَلْبِ
u'فراغ كِتَابٌ':Added, #2: 2	فَرَاغُ الْقَلْبِ
u'فَرَاغٌ كِتَابٌ':Added, #1: 1	فَرَاغِ الْكِتَابِ
u'فراغ كَيْلٌ':Added, #1: 1	فَرَاغِ الْكِتَابِ
u'فَرَاغٌ كَيْلٌ':Added, #1: 1	فَرَاغُ كَيْلِهِ
u'فراغ لَفْظٌ':Added, #1: 1	فَرَاغُ كَيْلِهِ
u'فَرَاغٌ لَفْظٌ':Added, #2: 2	فَرَاغِ لَفْظِ
u'فراغ مَالٌ':Added, #2: 2	فَرَاغِ لَفْظِ
u'فَرَاغٌ مَالٌ':Added, #1: 1	فَرَاغُ الْمَالِ
u'فراغ مَحَلٌّ':Added, #1: 1	فَرَاغُ الْمَالِ
u'فَرَاغٌ مَحَلٌّ':Added, #1: 1	فَرَاغِ الْمَحَلِّ
u'فراغ مَحَلٌّ':Added, #1: 1	فَرَاغِ الْمَحَلِّ
u'فَرَاغٌ مَحَلٌّ':Added, #1: 1	فَرَاغِ مَحَلِّ
u'فراغ مُدَّةٌ':Added, #1: 1	فَرَاغِ مَحَلِّ
u'فَرَاغٌ مُدَّةٌ':Added, #5: 5	فَرَاغِ مُدَّةِ
u'فراغ مُدَّةٌ':Added, #5: 5	فَرَاغِ مُدَّةِ
u'فَرَاغٌ مُدَّةٌ':Added, #6: 6	فَرَاغِ الْمُدَّةِ
u'فراغ مُساقاة':Added, #6: 6	فَرَاغِ الْمُدَّةِ
u'فَرَاغٌ مُساقاة':Added, #1: 1	فَرَاغِ الْمُسَاقَاةِ
u'فراغ مَنَاسِكُ':Added, #1: 1	فَرَاغِ الْمُسَاقَاةِ
u'فَرَاغٌ مَنَاسِكُ':Added, #1: 1	فَرَاغِ الْمَنَاسِكِ
u'فراغ مُؤَذِّنٌ':Added, #1: 1	فَرَاغِ الْمَنَاسِكِ
u'فَرَاغٌ مُؤَذِّنٌ':Added, #2: 2	فَرَاغَ الْمُؤَذِّنِ
u'فراغ مُؤَذِّنٌ':Added, #2: 2	فَرَاغَ الْمُؤَذِّنِ
u'فَرَاغٌ مُؤَذِّنٌ':Added, #6: 6	فَرَاغِ الْمُؤَذِّنِ
u'فراغ نَائِبٌ':Added, #6: 6	فَرَاغِ الْمُؤَذِّنِ
u'فَرَاغٌ نَائِبٌ':Added, #3: 3	فَرَاغِ النَّائِبِ
u'فراغ نُسُكٌ':Added, #3: 3	فَرَاغِ النَّائِبِ
u'فَرَاغٌ نُسُكٌ':Added, #2: 2	فَرَاغِ نُسُكِهِ
u'فراغ نَفَقَةٌ':Added, #2: 2	فَرَاغِ نُسُكِهِ
u'فَرَاغٌ نَفَقَةٌ':Added, #1: 1	فَرَاغِ نَفَقَةٍ
u'فراغ واحد':Added, #1: 1	فَرَاغِ نَفَقَةٍ
u'فَرَاغٌ واحد':Added, #1: 1	فَرَاغُ وَاحِدَةٍ
u'فراغ وَاحِدٌ':Added, #1: 1	فَرَاغُ وَاحِدَةٍ
u'فَرَاغٌ وَاحِدٌ':Added, #1: 1	فَرَاغُ وَاحِدَةٍ
u'فراغ وُضُوءٌ':Added, #1: 1	فَرَاغُ وَاحِدَةٍ
u'فَرَاغٌ وُضُوءٌ':Added, #4: 4	فَرَاغِ الْوُضُوءِ
u'فراغ يَدٌ':Added, #4: 4	فَرَاغِ الْوُضُوءِ
u'فَرَاغٌ يَدٌ':Added, #1: 1	فَرَاغُ الْيَدِ
u'فراغ يَمِينٌ':Added, #1: 1	فَرَاغُ الْيَدِ
u'فَرَاغٌ يَمِينٌ':Added, #2: 2	فَرَاغِ الْيَمِينِ
u'فِرَاقٌ أَزْواجٌ':Added, #2: 2	فَرَاغِ الْيَمِينِ
u'فِرَاقٌ أُمَّةٌ':Added, #1: 1	فِرَاقِ الْأَزْوَاجِ
u'فِرَاقٌ أهْلٌ':Added, #1: 1	فِرَاقِ الْأُمَّةِ
u'فِرَاقٌ أَوَّلُ':Added, #1: 1	فِرَاقِ أَهْلِهِ
u'فِرَاقٌ بَلَدٌ':Added, #2: 2	فِرَاقِ الْأَوَّلِ
u'فِرَاقٌ بَيْتٌ':Added, #1: 1	فِرَاقِ الْبَلَدِ
u'فِرَاقٌ حَيَاةٌ':Added, #3: 3	فِرَاقِ الْبَيْتِ
u'فِرَاقٌ خامس':Added, #1: 1	فِرَاقِ الْحَيَاةِ
u'فِرَاقٌ خَامِسٌ':Added, #1: 1	فِرَاقِ خَامِسَةِ
u'فِرَاقٌ دَارٌ':Added, #1: 1	فِرَاقِ خَامِسَةِ
u'فِرَاقٌ دِينٌ':Added, #1: 1	فِرَاقِ دَارِ
u'فِرَاقٌ زانِي':Added, #2: 2	فِرَاقِ دِينِ
u'فِرَاقٌ زانِي':Added, #1: 1	فِرَاقُ الزَّانِيَةِ
u'فِرَاقٌ زَوْجٌ':Added, #1: 1	فِرَاقِ الزَّانِيَةِ
u'فِرَاقٌ زَوْجٌ':Added, #1: 1	فِرَاقُ الزَّوْجِ
u'فِرَاقٌ زَوْجَةٌ':Added, #1: 1	فِرَاقِ الزَّوْجِ
u'فِرَاقٌ زَوْجَةٌ':Added, #1: 1	فِرَاقَ زَوْجَةٍ
u'فِرَاقٌ زَوْجَةٌ':Added, #1: 1	فِرَاقِ زَوْجَتِهِ
u'فِرَاقٌ شِرْكٌ':Added, #2: 2	فِرَاقِ الزَّوْجَةِ
u'فِرَاقٌ ضَرَّةٌ':Added, #1: 1	فِرَاقِ الشِّرْكِ
u'فِرَاقٌ عَبْدٌ':Added, #1: 1	فِرَاقَ الضَّرَّةِ
u'فِرَاقٌ عُجُولٌ':Added, #2: 2	فِرَاقُ الْعَبْدِ
u'فِرَاقٌ غير':Added, #1: 1	فِرَاقَ الْعُجُولِ
u'فِرَاقٌ غَيْرٌ':Added, #1: 1	فِرَاقَ غَيْرِ
u'فِرَاقٌ غير':Added, #1: 1	فِرَاقَ غَيْرِ
u'فِرَاقٌ غَيْرٌ':Added, #2: 2	فِرَاقُ غَيْرِ
u'فِرَاقٌ فلان':Added, #2: 2	فِرَاقُ غَيْرِ
u'فِرَاقٌ قَافِلٌ':Added, #1: 1	فِرَاقَ شُعَيْبٍ
u'فِرَاقٌ قَافِلَةٌ':Added, #1: 1	فِرَاقُ الْقَافِلَةِ
u'فِرَاقٌ قَوْمٌ':Added, #1: 1	فِرَاقُ الْقَافِلَةِ
u'فِرَاقٌ مَأْلُوفٌ':Added, #1: 1	فِرَاقُ قَوْمِهِ
u'فِرَاقٌ مُصَرَّحٌ':Added, #1: 1	فِرَاقَ الْمَأْلُوفِ
u'فِرَاقٌ مُعْتَقٌ':Added, #1: 1	فِرَاقُ الْمُصَرَّحِ
u'فِرَاقٌ نَبِيٌّ':Added, #1: 1	فِرَاقُ الْمُعْتَقَةِ
u'فِرَاقٌ ولد':Added, #1: 1	فِرَاقِ النَّبِيِّ
u'فِرَاقٌ وَلَدٌ':Added, #1: 1	فِرَاقِ الْوَلَدِ
u'فَرَّ بَعْضٌ':Subject, #1: 1	فِرَاقِ الْوَلَدِ
u'فَرَّ ثَالِثٌ':Predicate, #1: 1	فَرَّ بَعْضُ
u'فَرَّ ثَانِي':Predicate, #1: 1	فَرَّ الثَّالِثَةَ
u'فَرَّ ثَانِيَةٌ':Predicate, #1: 1	فَرَّ الثَّانِيَةَ
u'فَرْجٌ اِبْنَة':Added, #1: 1	فَرَّ الثَّانِيَةَ
u'فَرْجٌ اِبْنَة':Added, #1: 1	فَرْجَ ابْنَتِهِ
u'فَرْجٌ أَجْنَبِيٌّ':Added, #1: 1	فَرْجِ ابْنَتِهِ
u'فَرْجٌ آدَمِيٌّ':Added, #1: 1	فَرْجِ الْأَجْنَبِيِّ
u'فَرْجٌ آدَمِيٌّ':Added, #1: 1	فَرْجُ آدَمِيٍّ
u'فَرْجٌ آدَمِيٌّ':Added, #1: 1	فَرْجَ آدَمِيَّةٍ
u'فَرْجٌ آدَمِيٌّ':Added, #1: 1	فَرْجَ الْآدَمِيِّ
u'فَرْجٌ آدَمِيٌّ':Added, #3: 3	فَرْجَ آدَمِيٍّ
u'فَرْجٌ أَصْلِيٌّ':Added, #3: 3	فَرْجِ آدَمِيٍّ
u'فَرْجٌ الْمَرْأَةُ':Added, #3: 3	فَرْجٍ أَصْلِيٍّ
u'فَرْجٌ الْمَرْأَةُ':Added, #1: 1	فَرْجَ الْمَرْأَةِ
u'فَرْجٌ الْمَرْأَةُ':Added, #34: 34	فَرْجِ الْمَرْأَةِ
u'فَرْجٌ أُمٌّ':Added, #6: 6	فَرْجُ الْمَرْأَةِ
u'فَرْجٌ أُمٌّ':Added, #1: 1	فَرْجَ الْأُمِّ
u'فَرْجٌ أُمٌّ':Added, #1: 1	فَرْجُ الْأُمِّ
u'فَرْجٌ أُمٌّ':Added, #1: 1	فَرْجَ أُمِّ
u'فَرْجٌ أُمٌّ':Added, #1: 1	فَرْجِ أُمِّهِ
u'فَرْجٌ أمَةٌ':Added, #2: 2	فَرْجِ الْأُمِّ
u'فَرْجٌ أمَةٌ':Added, #1: 1	فَرْجِ أَمَتِهِ
u'فَرْجٌ أمَةٌ':Added, #2: 2	فَرْجَ الْأَمَةِ
u'فَرْجٌ اِمْرَأَةٌ':Added, #2: 2	فَرْجَ أَمَتِهِ
u'فَرْجٌ اِمْرَأَةٌ':Added, #16: 16	فَرْجِ امْرَأَةٍ
u'فَرْجٌ اِمْرَأَةٌ':Added, #3: 3	فَرْجَ امْرَأَتِهِ
u'فَرْجٌ اِمْرَأَةٌ':Added, #6: 6	فَرْجَ امْرَأَةٍ
u'فَرْجٌ إِنْسانٌ':Added, #7: 7	فَرْجِ امْرَأَتِهِ
u'فَرْجٌ بَائِنٌ':Added, #1: 1	فَرْجَ الْإِنْسَانِ
u'فَرْجٌ بَقَرٌ':Added, #1: 1	فَرْجٍ بَائِنٍ
u'فَرْجٌ بِكْرٌ':Added, #1: 1	فَرْجِ بَقَرَةٍ
u'فَرْجٌ بِكْرٌ':Added, #1: 1	فَرْجَ بِكْرٍ
u'فَرْجٌ بَهيمٌ':Added, #1: 1	فَرْجِ بِكْرٍ
u'فَرْجٌ بَهِيمَةٌ':Added, #5: 5	فَرْجِ الْبَهِيمَةِ
u'فَرْجٌ بَهِيمَةٌ':Added, #2: 2	فَرْجِ بَهِيمَةٍ
u'فَرْجٌ بَهِيمَةٌ':Added, #3: 3	فَرْجَ بَهِيمَةٍ
u'فَرَّجَ بَيْنٌ':Predicate, #5: 5	فَرْجِ الْبَهِيمَةِ
u'فَرْجٌ ثَيِّبٌ':Added, #11: 11	فَرَّجَ بَيْنَ
u'فَرَجٌ ثَيِّبٌ':Added, #1: 1	فَرْجَ الثَّيِّبِ
u'فَرْجٌ ثَيِّبٌ':Added, #1: 1	فَرَجِ ثَيِّبٍ
u'فَرْجٌ جَارِي':Added, #2: 2	فَرْجِ ثَيِّبٍ
u'فَرْجٌ جَارِيَةٌ':Added, #1: 1	فَرْجَ جَارِيَتِهِ
u'فَرْجٌ حُرٌّ':Added, #1: 1	فَرْجَ جَارِيَتِهِ
u'فَرْجٌ حَرامٌ':Added, #1: 1	فَرْجُ حُرٍّ
u'فَرْجٌ حَيٌّ':Added, #1: 1	فَرْجٍ حَرَامٍ
u'فَرْجٌ حَيَّةٌ':Added, #1: 1	فَرْجِ حَيَّةٍ
u'فَرْجٌ حَيَوَانٌ':Added, #1: 1	فَرْجِ حَيَّةٍ
u'فَرْجٌ رِجَالٌ':Added, #1: 1	فَرْجِ الْحَيَوَانِ
u'فَرْجٌ رَجُلٌ':Added, #1: 1	فَرْجِ الرِّجَالِ
u'فَرْجٌ رَجُلٌ':Added, #1: 1	فَرْجِ الرَّجُلِ
u'فَرْجٌ رَسُولٌ':Added, #3: 3	فَرْجَ الرَّجُلِ
u'فَرْجٌ زانِي':Added, #1: 1	فَرْجَ رَسُولِ
u'فَرْجٌ زَوْجٌ':Added, #1: 1	فَرْجِ الزَّانِيَيْنِ
u'فَرْجٌ زَوْجَةٌ':Added, #1: 1	فَرْجِ الزَّوْجِ
u'فَرَجٌ شدائد':Added, #4: 4	فَرْجِ زَوْجَتِهِ
u'فَرْجٌ صَغِيرٌ':Added, #1: 1	فَرَجُ الشَّدَائِدِ
u'فَرْجٌ صَغِيرٌ':Added, #1: 1	فَرْجَ صَغِيرَةٍ
u'فَرْجٌ صَغِيرٌ':Added, #2: 2	فَرْجِ الصَّغِيرَةِ
u'فَرْجٌ صَغِيرٌ':Added, #2: 2	فَرْجِ صَغِيرَةٍ
u'فَرْجٌ غُلاَمٌ':Added, #3: 3	فَرْجِ الصَّغِيرِ
u'فَرْجٌ غُلاَمٌ':Added, #1: 1	فَرْجِ الْغُلَامِ
u'فَرْجٌ غير':Added, #2: 2	فَرْجِ الْغُلامِ
u'فَرْجٌ غَيْرٌ':Added, #1: 1	فَرْجِ غَيْرِ
u'فَرْجٌ غير':Added, #1: 1	فَرْجِ غَيْرِ
u'فَرْجٌ غَيْرٌ':Added, #2: 2	فَرْجِ غَيْرِهِ
u'فَرْجٌ مُحَرَّمٌ':Added, #2: 2	فَرْجِ غَيْرِهِ
u'فَرْجٌ مَخْصُوصٌ':Added, #8: 8	فَرْجٍ مُحَرَّمٍ
u'فَرْجٌ مُطَلَّقٌ':Added, #1: 1	فَرْجٍ مَخْصُوصٍ
u'فَرْجٌ مَمْلُوكٌ':Added, #1: 1	فَرْجِ الْمُطَلَّقَةِ
u'فَرْجٌ نِساءٌ':Added, #1: 1	فَرْجُ مَمْلُوكَةٍ
u'فَرْجٌ نَفْسٌ':Added, #8: 8	فَرْجِ النِّسَاءِ
u'فَرْجٌ واحد':Added, #4: 4	فَرْجَ نَفْسِهِ
u'فَرْجٌ وَاحِدٌ':Added, #1: 1	فَرْجَ وَاحِدٍ
u'فَرِحَ إبْلِيسُ':Subject, #1: 1	فَرْجَ وَاحِدٍ
u'فرح رَجُلٌ':Added, #1: 1	فَرِحَ إبْلِيسُ
u'فَرَحٌ رَجُلٌ':Added, #1: 1	فَرَحِ رَجُلٍ
u'فرح سَاعَةٌ':Added, #1: 1	فَرَحِ رَجُلٍ
u'فَرَحٌ سَاعَةٌ':Added, #1: 1	فَرَحُ سَاعَةٍ
u'فرح عَبْدٌ':Added, #1: 1	فَرَحُ سَاعَةٍ
u'فَرَحٌ عَبْدٌ':Added, #1: 1	فَرَحُ الْعَبْدِ
u'فرح عُقَلاَءُ':Added, #1: 1	فَرَحُ الْعَبْدِ
u'فَرَحٌ عُقَلاَءُ':Added, #1: 1	فَرَحِ الْعُقَلَاءِ
u'فرح نَفْسٌ':Added, #1: 1	فَرَحِ الْعُقَلَاءِ
u'فَرَحٌ نَفْسٌ':Added, #1: 1	فَرَحِ النّفْسِ
u'فَرَّخَ طَيْرٌ':Subject, #1: 1	فَرَحِ النّفْسِ
u'فَرَّ رَجُلٌ':Subject, #1: 1	فَرَّخَ الطَّيْرُ
u'فَرَسَ فلان':Predicate, #2: 2	فَرَّ رَجُلٌ
u'فَرْشٌ بسط':Added, #1: 1	فَرَسَ حُذَيْفَةَ
u'فَرْشٌ بُسُطٌ':Added, #4: 4	فَرْشِ الْبُسُطِ
u'فَرَشَ رَجُلٌ':Subject, #4: 4	فَرْشِ الْبُسُطِ
u'فَرَشَ رَجُلٌ':Subject, #1: 1	فَرَشَ الرَّجُلُ
u'فَرْشٌ زَوْجَةٌ':Added, #2: 2	فَرَشَ رَجُلٌ
u'فَرَّ شَفِيعٌ':Subject, #1: 1	فَرْشِ الزَّوْجَاتِ
u'فَرَشَ كُمٌّ':Predicate, #1: 1	فَرَّ الشَّفِيعُ
u'فَرْشٌ مَسْجِدٌ':Added, #1: 1	فَرَشَ كُمَّ
u'فَرْشٌ مَلَلٌ':Added, #1: 1	فَرْشَ مَسْجِدٍ
u'فَرْشٌ واحد':Added, #1: 1	فَرْشَ مَلَلٍ
u'فَرْشٌ وَاحِدٌ':Added, #1: 1	فَرْشٍ وَاحِدٍ
u'فَرْضٌ أَبٌ':Added, #1: 1	فَرْشٍ وَاحِدٍ
u'فَرْضٌ إِبِلٌ':Added, #2: 2	فَرْضُ الْأَبِ
u'فَرْضٌ إِبِلٌ':Added, #1: 1	فَرْضَ الإِبِلِ
u'فَرْضٌ اِبْنٌ':Added, #1: 1	فَرْضِ الإِبِلِ
u'فَرْضٌ اِبْنَة':Added, #1: 1	فَرْضِ الاِبْنَتَيْنِ
u'فَرْضٌ اِبْنَة':Added, #1: 1	فَرْضِ ابْنَةِ
u'فَرْضٌ اِتِّبَاعٌ':Added, #1: 1	فَرْضِ الاِبْنَةِ
u'فَرْضٌ اِتِّحَادٌ':Added, #1: 1	فَرْضِ اتِّبَاعِ
u'فَرْضٌ إِجَابَةٌ':Added, #1: 1	فَرْضِ اتِّحَادِ
u'فَرَضَ أُجْرَةٌ':Predicate, #1: 1	فَرْضِ الْإِجَابَةِ
u'فَرَضَ اِحْتِمَالٌ':Predicate, #1: 1	فَرَضَ أُجْرَةَ
u'فَرْضٌ أحَدٌ':Added, #1: 1	فَرَضَ احْتِمَالَ
u'فَرْضٌ أَخٌ':Added, #2: 2	فَرْضِ أَحَدِ
u'فَرْضٌ أُخْتٌ':Added, #1: 1	فَرْضُ الْأَخِ
u'فَرْضٌ أُخْتٌ':Added, #1: 1	فَرْضِ الأُخْتِ
u'فَرْضٌ أُخْتٌ':Added, #1: 1	فَرْضَ الْأُخْتِ
u'فَرْضٌ أُخْتٌ':Added, #1: 1	فَرْضُ الْأُخْتِ
u'فَرْضٌ أُخْتٌ':Added, #2: 2	فَرْضِ الْأُخْتِ
u'فَرْضٌ أَخَوَاتٌ':Added, #2: 2	فَرْضِ الْأُخْتَيْنِ
u'فَرْضٌ إِخْوَةٌ':Added, #1: 1	فَرْضُ الْأَخَوَاتِ
u'فَرْضٌ أَذَانٌ':Added, #1: 1	فَرْضِ الإِخْوَةِ
u'فَرْضٌ أَرْبَعَةٌ':Added, #1: 1	فَرْضُ الْأَذَانِ
u'فَرْضٌ اِسْتِعْمالٌ':Added, #1: 1	فَرْضُ أَرْبَعَةٍ
u'فَرْضٌ إِسْلامٌ':Added, #1: 1	فَرْضُ اسْتِعْمَالِ
u'فَرْضٌ إِسْلامٌ':Added, #1: 1	فَرْضَ الْإِسْلَامِ
u'فَرْضٌ إِسْلامٌ':Added, #3: 3	فَرْضُ الْإِسْلَامِ
u'فَرْضٌ أَصْحَابٌ':Added, #5: 5	فَرْضِ الْإِسْلَامِ
u'فَرْضٌ أَصْحَابٌ':Added, #1: 1	فَرْضِ الْأَصْحَابِ
u'فَرْضٌ أصل':Added, #2: 2	فَرْضَ الْأَصْحَابِ
u'فَرْضٌ أًصْلٌ':Added, #1: 1	فَرْضِ أَصْلِ
u'فَرْضٌ أصل':Added, #1: 1	فَرْضِ أَصْلِ
u'فَرْضٌ أًصْلٌ':Added, #1: 1	فَرْضَ الْأَصْلِ
u'فَرَضَ إِصْلاحٌ':Predicate, #1: 1	فَرْضَ الْأَصْلِ
u'فَرْضٌ اِعْتِبارٌ':Added, #1: 1	فَرَضَ الْإِصْلَاحَ
u'فَرَضَ أَعْطِيَةٌ':Predicate, #1: 1	فَرْضِ اعْتِبَارِ
u'فَرْضٌ أُمٌّ':Added, #1: 1	فَرَضَ الأَعْطِيةَ
u'فَرْضٌ أُمٌّ':Added, #1: 1	فَرْضِ الأُمِّ
u'فَرْضٌ أُمٌّ':Added, #1: 1	فَرْضَ الْأُمِّ
u'فَرْضٌ أُمٌّ':Added, #2: 2	فَرْضُ الْأُمِّ
u'فَرَضَ إمَامٌ':Subject, #3: 3	فَرْضِ الْأُمِّ
u'فَرْضٌ إمَامٌ':Added, #1: 1	فَرَضَ الْإِمَامُ
u'فَرْضٌ إمَامٌ':Added, #1: 1	فَرْضَ الْإِمَامِ
u'فَرْضٌ إمَامَةٌ':Added, #5: 5	فَرْضُ الْإِمَامِ
u'فَرَضَ إِمْكانٌ':Predicate, #1: 1	فَرْضِ الْإِمَامَةِ
u'فَرْضٌ إِمْكانٌ':Added, #1: 1	فَرَضَ إمْكَانَ
u'فَرْضٌ اِنْتِفاء':Added, #1: 1	فَرْضِ إمْكَانِهِ
u'فَرْضٌ اِنْفِرادٌ':Added, #2: 2	فَرْضِ انْتِفَاءِ
u'فَرَضَ أَوَّلُ':Predicate, #1: 1	فَرْضُ انْفِرَادِ
u'فَرْضٌ أَوَّلُ':Added, #1: 1	فَرَضَ الْأَوَّلَ
u'فَرْضٌ إيمَانٌ':Added, #1: 1	فَرْضِ الْأَوَّلِ
u'فَرْضٌ بَاطِلٌ':Added, #2: 2	فَرْضِ الْإِيمَانِ
u'فَرْضٌ بَصيرٌ':Added, #1: 1	فَرْضُ الْبَاطِلِ
u'فَرْضٌ بَعْضٌ':Added, #1: 1	فَرْضَ الْبَصِيرِ
u'فَرْضٌ بَقاءٌ':Added, #1: 1	فَرْضَ بَعْضِهِ
u'فَرْضٌ بناتٌ':Added, #1: 1	فَرْضِ بَقَاءِ
u'فَرْضٌ بِنْتٌ':Added, #3: 3	فَرْضِ الْبَنَاتِ
u'فَرْضٌ بِنْتٌ':Added, #1: 1	فَرْضِ الْبِنْتَيْنِ
u'فَرْضٌ بِنْتٌ':Added, #1: 1	فَرْضِ بِنْتِ
u'فَرْضٌ تَأَخُّرٌ':Added, #3: 3	فَرْضِ الْبِنْتِ
u'فَرْضٌ تَحْرِيم':Added, #1: 1	فَرْضِ تَأَخُّرِهِ
u'فَرْضٌ تَرَبُّصٌ':Added, #1: 1	فَرْضِ التَّحْرِيمَةِ
u'فَرْضٌ تَرْتِيبٌ':Added, #1: 1	فَرْضِ التَّرَبُّصِ
u'فَرْضٌ تَسْلِيمٌ':Added, #1: 1	فَرْضِ التَّرْتِيبِ
u'فَرْضٌ تَشَهُّدٌ':Added, #1: 1	فَرْضِ تَسْلِيمِهِ
u'فَرْضٌ تَعَلُّقٌ':Added, #1: 1	فَرْضِ التَّشَهُّدِ
u'فَرْضٌ تَغَيُّرٌ':Added, #1: 1	فَرْضُ تَعَلُّقِ
u'فَرْضٌ تَقَنُّعٌ':Added, #1: 1	فَرْضِ التَّغَيُّرِ
u'فَرْضٌ تَكْرارٌ':Added, #1: 1	فَرْضَ التَّقَنُّعِ
u'فَرْضٌ تَوَجُّهٌ':Added, #1: 1	فَرْضِ التَّكْرَارِ
u'فَرْضٌ تَيَمُّمٌ':Added, #2: 2	فَرْضُ التَّوَجُّهِ
u'فَرْضٌ تَيَمُّمٌ':Added, #1: 1	فَرْضِ التَّيَمُّمِ
u'فَرْضٌ ثَانِي':Added, #3: 3	فَرْضَ التَّيَمُّمِ
u'فَرْضٌ ثَانِيَةٌ':Added, #1: 1	فَرْضِ الثَّانِيَةِ
u'فَرْضٌ ثُبُوتٌ':Added, #1: 1	فَرْضِ الثَّانِيَةِ
u'فَرْضٌ ثَلاثَةٌ':Added, #2: 2	فَرْضِ ثُبُوتِهِ
u'فَرَضَ جِزْيَةٌ':Predicate, #1: 1	فَرْضُ ثَلَاثَةٍ
u'فَرْضٌ جِزْيَةٌ':Added, #1: 1	فَرَضَ الْجِزْيَةَ
u'فَرْضٌ جَمَاعَةٌ':Added, #1: 1	فَرْضُ الْجِزْيَةِ
u'فَرْضٌ جَمَاعَةٌ':Added, #1: 1	فَرْضُ الْجَمَاعَةِ
u'فَرْضٌ جمعة':Added, #1: 1	فَرْضِ الْجَمَاعَةِ
u'فَرْضٌ جُمُعَةٌ':Added, #1: 1	فَرْضَ الْجُمُعَةِ
u'فَرْضٌ جمعة':Added, #1: 1	فَرْضَ الْجُمُعَةِ
u'فَرْضٌ جُمُعَةٌ':Added, #2: 2	فَرْضِ الْجُمُعَةِ
u'فَرْضٌ جمعة':Added, #2: 2	فَرْضِ الْجُمُعَةِ
u'فَرْضٌ جُمُعَةٌ':Added, #7: 7	فَرْضُ الْجُمُعَةِ
u'فَرَضَ جُمْهُورٌ':Subject, #7: 7	فَرْضُ الْجُمُعَةِ
u'فَرْضٌ جَمِيع':Added, #1: 1	فَرَضَ الْجُمْهُورُ
u'فَرْضٌ جهاد':Added, #4: 4	فَرْضِ الْجَمِيعِ
u'فَرْضٌ جِهَادٌ':Added, #3: 3	فَرْضُ الْجِهَادِ
u'فَرْضٌ جهاد':Added, #3: 3	فَرْضُ الْجِهَادِ
u'فَرْضٌ جِهَادٌ':Added, #6: 6	فَرْضِ الْجِهَادِ
u'فَرْضٌ جَوَابٌ':Added, #6: 6	فَرْضِ الْجِهَادِ
u'فَرْضٌ جَوَابٌ':Added, #1: 1	فَرْضُ جَوَابِ
u'فَرْضٌ حادِثٌ':Added, #2: 2	فَرْضُ الْجَوَابِ
u'فَرَضَ حاكِمٌ':Subject, #1: 1	فَرْضُ الْحَادِثَةِ
u'فَرْضٌ حاكِمٌ':Added, #2: 2	فَرَضَ الْحَاكِمُ
u'فَرْضٌ حاكِمٌ':Added, #1: 1	فَرْضُ الْحَاكِمِ
u'فَرَضَ حَجٌّ':Predicate, #3: 3	فَرْضِ الْحَاكِمِ
u'فَرْضٌ حَجٌّ':Added, #1: 1	فَرَضَ الْحَجَّ
u'فَرْضٌ حَجٌّ':Added, #13: 13	فَرْضِ الْحَجِّ
u'فَرْضٌ حَجٌّ':Added, #17: 17	فَرْضُ الْحَجِّ
u'فَرْضٌ حجاب':Added, #5: 5	فَرْضَ الْحَجِّ
u'فَرْضٌ حِجابٌ':Added, #1: 1	فَرْضُ الْحِجَابِ
u'فَرْضٌ حِجَّةٌ':Added, #1: 1	فَرْضُ الْحِجَابِ
u'فَرَضَ حُرْمَةٌ':Predicate, #2: 2	فَرْضُ حِجَّةِ
u'فَرْضٌ حُرِّيَّةٌ':Added, #1: 1	فَرَضَ الْحُرْمَةَ
u'فَرَضَ حَصْرٌ':Subject, #1: 1	فَرْضِ الْحُرِّيَّةِ
u'فَرْضٌ حِفْظٌ':Added, #1: 1	فَرَضَ حَصْرُ
u'فَرْضٌ خُبْزٌ':Added, #1: 1	فَرْضَ الْحِفْظِ
u'فَرْضٌ خِلاَفٌ':Added, #1: 1	فَرْضِ الْخُبْزِ
u'فَرْضٌ خِلاَفٌ':Added, #1: 1	فَرْضُ الْخِلَافِ
u'فَرْضٌ خُمُسٌ':Added, #1: 1	فَرْضِ خِلَافٍ
u'فَرْضٌ خَمْسٌ':Added, #1: 1	فَرْضِ الْخُمُسِ
u'فَرْضٌ خَمْسَةٌ':Added, #1: 1	فَرْضِ خَمْسِ
u'فَرْضٌ دَعْوَةٌ':Added, #3: 3	فَرْضُ خَمْسَةٍ
u'فَرَضَ دونٌ':Predicate, #1: 1	فَرْضُ الدَّعْوَةِ
u'فَرَضَ دِيَةٌ':Predicate, #1: 1	فَرَضَ دُونَ
u'فَرْضٌ دِيَةٌ':Added, #3: 3	فَرَضَ الدِّيَةَ
u'فَرْضٌ راح':Added, #1: 1	فَرْضِ الدِّيَةِ
u'فَرْضٌ رَأْسٌ':Added, #1: 1	فَرْضُ الرَّاحَتَيْنِ
u'فَرْضٌ رُبَاعِيُّ':Added, #2: 2	فَرْضَ الرَّأْسِ
u'فَرْضٌ رِجْلٌ':Added, #1: 1	فَرْضٍ رُبَاعِيٍّ
u'فَرْضٌ رِجْلٌ':Added, #1: 1	فَرْضَ الرِّجْلَيْنِ
u'فَرَضَ رَدٌّ':Predicate, #1: 1	فَرْضُ الرِّجْلَيْنِ
u'فَرَضَ رَسُولٌ':Subject, #1: 1	فَرَضَ الرَّدَّ
u'فَرَضَ رِفادَةٌ':Predicate, #34: 34	فَرَضَ رَسُولُ
u'فَرْضٌ رُكوعٌ':Added, #1: 1	فَرَضَ الرّفَادَةَ
u'فَرْضٌ رُكوعٌ':Added, #1: 1	فَرْضِ الرُّكُوعِ
u'فَرَضَ زَكاةٌ':Predicate, #2: 2	فَرْضُ الرُّكُوعِ
u'فَرْضٌ زَكاةٌ':Added, #14: 14	فَرَضَ زَكَاةَ
u'فَرْضٌ زَكاةٌ':Added, #1: 1	فَرْضَ الزَّكَاةِ
u'فَرْضٌ زَكاةٌ':Added, #1: 1	فَرْضِ الزَّكَاةِ
u'فَرْضٌ زَكاةٌ':Added, #1: 1	فَرْضِ زَكَاةِ
u'فَرْضٌ زَكَواتٌ':Added, #2: 2	فَرْضُ الزَّكَاةِ
u'فَرْضٌ زَكَواتٌ':Added, #1: 1	فَرْضَ الزَّكَوَاتِ
u'فَرَضَ زَوْجٌ':Subject, #1: 1	فَرْضُ الزَّكَوَاتِ
u'فَرْضٌ زَوْجٌ':Added, #4: 4	فَرَضَ الزَّوْجُ
u'فَرْضٌ زَوْجٌ':Added, #1: 1	فَرْضُ الزَّوْجَيْنِ
u'فَرْضٌ زَوْجٌ':Added, #4: 4	فَرْضِ الزَّوْجَيْنِ
u'فَرْضٌ زَوْجٌ':Added, #5: 5	فَرْضُ الزَّوْجِ
u'فَرْضٌ زَوْجَةٌ':Added, #7: 7	فَرْضِ الزَّوْجِ
u'فَرْضٌ زَوْجِيٌّ':Added, #2: 2	فَرْضُ الزَّوْجَةِ
u'فَرْضٌ زِيادَةٌ':Added, #1: 1	فَرْضِ الزَّوْجِيَّةِ
u'فَرْضٌ سَائِرٌ':Added, #2: 2	فَرْضِ زِيَادَةٍ
u'فَرْضٌ سَبْعَةٌ':Added, #1: 1	فَرْضُ سَائِرِ
u'فَرْضٌ سَتْرٌ':Added, #4: 4	فَرْضُ سَبْعَةٍ
u'فَرْضٌ سِتْرٌ':Added, #1: 1	فَرْضِ السَّتْرِ
u'فَرْضٌ سَتْرٌ':Added, #1: 1	فَرْضَ السِّتْرِ
u'فَرْضٌ سِتْرٌ':Added, #1: 1	فَرْضَ سَتْرِ
u'فَرْضٌ سَتْرٌ':Added, #2: 2	فَرْضُ السِّتْرِ
u'فَرْضٌ سُجُودٌ':Added, #4: 4	فَرْضَ السَّتْرِ
u'فَرْضٌ سَنَةٌ':Added, #2: 2	فَرْضَ السُّجُودِ
u'فَرْضٌ سُؤَالٌ':Added, #1: 1	فَرْضِ سَنَةٍ
u'فَرْضٌ سُؤَالٌ':Added, #1: 1	فَرْضَ السُّؤَالِ
u'فَرْضٌ سُؤَالٌ':Added, #1: 1	فَرْضُ السُّؤَالِ
u'فَرْضٌ سُؤَالٌ':Added, #1: 1	فَرْضِ السُّؤَالِ
u'فَرَضَ سَيِّدٌ':Subject, #1: 1	فَرْضِ سُؤَالٍ
u'فَرْضٌ شَخْصٌ':Added, #1: 1	فَرَضَ السَّيِّدُ
u'فَرَضَ صَاحِبٌ':Subject, #3: 3	فَرْضِ الشَّخْصِ
u'فَرْضٌ صُبْحٌ':Added, #2: 2	فَرَضَ صَاحِبُ
u'فَرْضٌ صَبِيٌّ':Added, #1: 1	فَرْضِ الصُّبْحِ
u'فَرْضٌ صِحَّةٌ':Added, #1: 1	فَرْضَ الصَّبِيِّ
u'فَرْضٌ صِحَّةٌ':Added, #1: 1	فَرْضِ صِحَّةِ
u'فَرَضَ صداق':Predicate, #5: 5	فَرْضِ صِحَّتِهِ
u'فَرَضَ صَدَاقٌ':Predicate, #1: 1	فَرَضَ صَدَاقَ
u'فَرَضَ صداق':Predicate, #1: 1	فَرَضَ صَدَاقَ
u'فَرَضَ صَدَاقٌ':Predicate, #2: 2	فَرَضَ الصَّدَاقَ
u'فَرْضٌ صداق':Added, #2: 2	فَرَضَ الصَّدَاقَ
u'فَرْضٌ صَدَاقٌ':Added, #1: 1	فَرْضُ الصَّدَاقِ
u'فَرْضٌ صدق':Added, #1: 1	فَرْضُ الصَّدَاقِ
u'فَرْضٌ صِدْقٌ':Added, #1: 1	فَرْضَ صِدْقِهِ
u'فَرْضٌ صدق':Added, #1: 1	فَرْضَ صِدْقِهِ
u'فَرْضٌ صِدْقٌ':Added, #2: 2	فَرْضِ صِدْقِ
u'فَرَضَ صدقة':Predicate, #2: 2	فَرْضِ صِدْقِ
u'فَرَضَ صَدَقَةٌ':Predicate, #5: 5	فَرَضَ صَدَقَةَ
u'فَرْضٌ صَدَقَةٌ':Added, #5: 5	فَرَضَ صَدَقَةَ
u'فَرْضٌ صدقة':Added, #1: 1	فَرْضَ الصَّدَقَاتِ
u'فَرْضٌ صَدَقَةٌ':Added, #1: 1	فَرْضِ صَدَقَةِ
u'فَرْضٌ صدقة':Added, #1: 1	فَرْضِ صَدَقَةِ
u'فَرْضٌ صَدَقَةٌ':Added, #2: 2	فَرْضُ صَدَقَةِ
u'فَرْضٌ صدقة':Added, #2: 2	فَرْضُ صَدَقَةِ
u'فَرْضٌ صَدَقَةٌ':Added, #3: 3	فَرْضُ الصَّدَقَةِ
u'فَرَضَ صَلاَةٌ':Predicate, #3: 3	فَرْضُ الصَّدَقَةِ
u'فَرَضَ صَلاَةٌ':Predicate, #1: 1	فَرَضَ الصَّلَاةَ
u'فَرْضٌ صَلاَةٌ':Added, #1: 1	فَرَضَ الصَّلاَةَ
u'فَرْضٌ صَلاَةٌ':Added, #12: 12	فَرْضُ الصَّلَاةِ
u'فَرْضٌ صَلاَةٌ':Added, #12: 12	فَرْضِ الصَّلَاةِ
u'فَرْضٌ صَلاَةٌ':Added, #1: 1	فَرْضَ الصَّلاَةِ
u'فَرْضٌ صَلاَةٌ':Added, #1: 1	فَرْضُ الصّلَاةِ
u'فَرْضٌ صَلاَةٌ':Added, #1: 1	فَرْضَ صَلَاةِ
u'فَرْضٌ صَلاَةٌ':Added, #1: 1	فَرْضُ صَلَاةِ
u'فَرْضٌ صَلاَةٌ':Added, #2: 2	فَرْضَ الصَّلَاةِ
u'فَرْضٌ صَلاَةٌ':Added, #2: 2	فَرْضِ صَلَاةٍ
u'فَرْضٌ صَلاَةٌ':Added, #3: 3	فَرْضِ الصَّلاَةِ
u'فَرْضٌ صَلَوَاتٌ':Added, #3: 3	فَرْضِ صَلَاةِ
u'فَرْضٌ صَلَوَاتٌ':Added, #2: 2	فَرْضُ الصّلَوَاتِ
u'فَرْضٌ صَلَوَاتٌ':Added, #2: 2	فَرْضُ الصَّلَوَاتِ
u'فَرْضٌ صِنْفٌ':Added, #2: 2	فَرْضِ الصَّلَوَاتِ
u'فَرْضٌ صِنْفٌ':Added, #1: 1	فَرْضُ صِنْفٍ
u'فَرْضٌ صُورَةٌ':Added, #2: 2	فَرْضُ صِنْفَيْنِ
u'فَرْضٌ صَوْمٌ':Added, #1: 1	فَرْضُ صُورَةِ
u'فَرْضٌ صَوْمٌ':Added, #1: 1	فَرْضَ الصَّوْمِ
u'فَرْضٌ صَوْمٌ':Added, #1: 1	فَرْضِ صَوْمِ
u'فَرَضَ طَاعَةٌ':Predicate, #2: 2	فَرْضُ الصَّوْمِ
u'فَرْضٌ طَاعَةٌ':Added, #1: 1	فَرَضَ طَاعَةَ
u'فَرْضٌ طَهَارَةٌ':Added, #1: 1	فَرْضِ طَاعَةِ
u'فَرْضٌ طَهَارَةٌ':Added, #3: 3	فَرْضَ الطَّهَارَةِ
u'فَرْضٌ طهر':Added, #4: 4	فَرْضِ الطَّهَارَةِ
u'فَرْضٌ طُهْرٌ':Added, #1: 1	فَرْضِ الطُّهْرِ
u'فَرْضٌ ظاهِرٌ':Added, #1: 1	فَرْضِ الطُّهْرِ
u'فَرَضَ ظُهْرٌ':Predicate, #1: 1	فَرْضَ الظَّاهِرِ
u'فَرْضٌ ظُهْرٌ':Added, #1: 1	فَرَضَ الظُّهْرَ
u'فَرْضٌ ظُهْرٌ':Added, #1: 1	فَرْضُ الظُّهْرِ
u'فَرْضٌ عَبْدٌ':Added, #3: 3	فَرْضَ الظُّهْرِ
u'فَرْضٌ عِتْقٌ':Added, #1: 1	فَرْضُ الْعَبْدِ
u'فَرْضٌ عَجْزٌ':Added, #1: 1	فَرْضُ عِتْقٍ
u'فَرْضٌ عَدَالَةٌ':Added, #1: 1	فَرْضُ عَجْزٍ
u'فَرْضٌ عَدَمٌ':Added, #1: 1	فَرْضَ عَدَالَتِهِ
u'فَرْضٌ عَدَمٌ':Added, #1: 1	فَرْضِ عَدَمِهِ
u'فَرْضٌ عِشَاءٌ':Added, #5: 5	فَرْضِ عَدَمِ
u'فَرَضَ عَطَاءٌ':Predicate, #1: 1	فَرْضَ الْعِشَاءِ
u'فَرْضٌ عَطَاءٌ':Added, #1: 1	فَرَضَ الْعَطَاءَ
u'فَرْضٌ عَقْلٌ':Added, #1: 1	فَرْضِ الْعَطَاءِ
u'فَرْضٌ عَقْلِيٌّ':Added, #1: 1	فَرْضِ الْعَقْلِ
u'فَرْضٌ علم':Added, #1: 1	فَرْضِ عَقْلِيَّةِ
u'فَرْضٌ عِلْمٌ':Added, #1: 1	فَرْضُ الْعِلْمِ
u'فَرْضٌ علم':Added, #1: 1	فَرْضُ الْعِلْمِ
u'فَرْضٌ عِلْمٌ':Added, #1: 1	فَرْضِ عِلْمِهِ
u'فَرَضَ عُمَرٌ':Subject, #1: 1	فَرْضِ عِلْمِهِ
u'فَرْضٌ عُمُرٌ':Added, #6: 6	فَرَضَ عُمَرُ
u'فَرْضٌ عمرة':Added, #1: 1	فَرْضُ الْعُمُرِ
u'فَرْضٌ عُمْرَةٌ':Added, #1: 1	فَرْضِ الْعُمْرَةِ
u'فَرْضٌ عَمَلٌ':Added, #1: 1	فَرْضِ الْعُمْرَةِ
u'فَرَضَ عين':Predicate, #2: 2	فَرْضِ الْعَمَلِ
u'فَرَضَ عَيْنٌ':Predicate, #1: 1	فَرَضَ الْعَيْنَ
u'فَرَضَ عَيْن':Predicate, #1: 1	فَرَضَ الْعَيْنَ
u'فَرْضٌ عين':Added, #1: 1	فَرَضَ الْعَيْنَ
u'فَرْضٌ عَيْنٌ':Added, #10: 10	فَرْضَ الْعَيْنِ
u'فَرْضٌ عَيْن':Added, #10: 10	فَرْضَ الْعَيْنِ
u'فَرْضٌ عين':Added, #10: 10	فَرْضَ الْعَيْنِ
u'فَرْضٌ عَيْنٌ':Added, #25: 25	فَرْضِ الْعَيْنِ
u'فَرْضٌ عَيْن':Added, #25: 25	فَرْضِ الْعَيْنِ
u'فَرْضٌ عَيْنٌ':Added, #25: 25	فَرْضِ الْعَيْنِ
u'فَرْضٌ عَيْن':Added, #31: 31	فَرْضَ عَيْنٍ
u'فَرْضٌ عين':Added, #31: 31	فَرْضَ عَيْنٍ
u'فَرْضٌ عَيْنٌ':Added, #3: 3	فَرْضُ الْعَيْنِ
u'فَرْضٌ عَيْن':Added, #3: 3	فَرْضُ الْعَيْنِ
u'فَرْضٌ عَيْنٌ':Added, #3: 3	فَرْضُ الْعَيْنِ
u'فَرْضٌ عَيْن':Added, #3: 3	فَرْضِ عَيْنٍ
u'فَرْضٌ عَيْنٌ':Added, #3: 3	فَرْضِ عَيْنٍ
u'فَرْضٌ عَيْن':Added, #74: 74	فَرْضُ عَيْنٍ
u'فَرْضٌ غَائِبٌ':Added, #74: 74	فَرْضُ عَيْنٍ
u'فَرَضَ غُرْمٌ':Predicate, #1: 1	فَرْضُ الْغَائِبِ
u'فَرْضٌ غُرْمٌ':Added, #1: 1	فَرَضَ الْغُرْمَ
u'فَرْضٌ غَسْلٌ':Added, #1: 1	فَرْضَ الْغُرْمِ
u'فَرْضٌ غَسْلٌ':Added, #1: 1	فَرْضِ الْغَسْلِ
u'فَرْضٌ غُسْلٌ':Added, #1: 1	فَرْضَ غَسْلِ
u'فَرْضٌ غَسْلٌ':Added, #1: 1	فَرْضُ غُسْلِ
u'فَرْضٌ غُسْلٌ':Added, #2: 2	فَرْضُ الْغَسْلِ
u'فَرْضٌ غُسْلٌ':Added, #2: 2	فَرْضُ غُسْلِهِ
u'فَرْضٌ غُسْلٌ':Added, #3: 3	فَرْضَ الْغُسْلِ
u'فَرْضٌ غُسْلٌ':Added, #3: 3	فَرْضِ الْغُسْلِ
u'فَرْضٌ غَنَمٌ':Added, #6: 6	فَرْضُ الْغُسْلِ
u'فَرْضٌ غَنِيمَةٌ':Added, #1: 1	فَرْضُ الْغَنَمِ
u'فَرْضٌ غير':Added, #1: 1	فَرْضُ الْغَنِيمَةِ
u'فَرْضٌ غَيْرٌ':Added, #3: 3	فَرْضَ غَيْرِ
u'فَرْضٌ غير':Added, #3: 3	فَرْضَ غَيْرِ
u'فَرْضٌ غَيْرٌ':Added, #3: 3	فَرْضِ غَيْرِهِ
u'فَرَضَ فَارِضٌ':Subject, #3: 3	فَرْضِ غَيْرِهِ
u'فَرْضٌ فَجْرٌ':Added, #1: 1	فَرَضَ فَارِضٌ
u'فَرْضٌ فَجْرٌ':Added, #1: 1	فَرْضُ الْفَجْرِ
u'فَرَضَ فَرَائِضُ':Predicate, #2: 2	فَرْضِ فَجْرِهِ
u'فَرَضَ فَرَائِضُ':Predicate, #2: 2	فَرَضَ الْفَرَائِضَ
u'فَرْضٌ فَرِيقٌ':Added, #6: 6	فَرَضَ فَرَائِضَ
u'فَرَضَ فقهاء':Subject, #1: 1	فَرْضِ الْفَرِيقَيْنِ
u'فَرْضٌ فَهْمٌ':Added, #1: 1	فَرَضَ الْفُقَهَاءُ
u'فَرْضٌ قَادِرٌ':Added, #1: 1	فَرْضِ فَهْمِ
u'فَرْضٌ قَارِئٌ':Added, #1: 1	فَرْضِ الْقَادِرِ
u'فَرْضٌ قِبْلَةٌ':Added, #7: 7	فَرْضُ الْقَارِئِ
u'فَرْضٌ قِبْلَةٌ':Added, #1: 1	فَرْضَ الْقِبْلَةِ
u'فَرْضٌ قِرَاءةٌ':Added, #1: 1	فَرْضِ الْقِبْلَةِ
u'فَرْضٌ قِرَاءةٌ':Added, #17: 17	فَرْضِ الْقِرَاءَةِ
u'فَرْضٌ قِرَاءةٌ':Added, #19: 19	فَرْضُ الْقِرَاءَةِ
u'فَرْضٌ قرائن':Added, #22: 22	فَرْضَ الْقِرَاءَةِ
u'فَرْضٌ قَضَاءٌ':Added, #1: 1	فَرْضِ الْقَرَائِنِ
u'فَرْضٌ قَضَاءٌ':Added, #1: 1	فَرْضُ الْقَضَاءِ
u'فَرْضٌ قَطْعٌ':Added, #2: 2	فَرْضِ الْقَضَاءِ
u'فَرْضٌ قعدة':Added, #1: 1	فَرْضُ قَطْعِ
u'فَرْضٌ قعدة':Added, #1: 1	فَرْضَ الْقِعْدَةِ
u'فَرْضٌ قَعْدَةٌ':Added, #3: 3	فَرْضَ الْقَعْدَةِ
u'فَرْضٌ قَوْمٌ':Added, #3: 3	فَرْضَ الْقَعْدَةِ
u'فَرْضٌ قيام':Added, #1: 1	فَرْضُ الْقَوْمِ
u'فَرْضٌ قيام':Added, #1: 1	فَرْضَ قِيَامِ
u'فَرْضٌ قِيَامٌ':Added, #1: 1	فَرْضُ قِيَامِ
u'فَرْضٌ قِيَامٌ':Added, #1: 1	فَرْضَ قِيَامِ
u'فَرْضٌ قيام':Added, #1: 1	فَرْضُ قِيَامِ
u'فَرْضٌ قِيَامٌ':Added, #2: 2	فَرْضِ الْقِيَامِ
u'فَرْضٌ قيام':Added, #2: 2	فَرْضِ الْقِيَامِ
u'فَرْضٌ قيام':Added, #3: 3	فَرْضَ الْقِيَامِ
u'فَرْضٌ قِيَامٌ':Added, #3: 3	فَرْضُ الْقِيَامِ
u'فَرْضٌ قِيَامٌ':Added, #3: 3	فَرْضَ الْقِيَامِ
u'فَرْضٌ كَفٌّ':Added, #3: 3	فَرْضُ الْقِيَامِ
u'فَرْضٌ كِفَايَةٌ':Added, #1: 1	فَرْضُ كَفٍّ
u'فَرْضٌ كِفَايَةٌ':Added, #192: 192	فَرْضُ كِفَايَةٍ
u'فَرْضٌ كِفَايَةٌ':Added, #1: 1	فَرْضِ الْكِفَايَاتِ
u'فَرْضٌ كِفَايَةٌ':Added, #26: 26	فَرْضُ الْكِفَايَةِ
u'فَرْضٌ كِفَايَةٌ':Added, #28: 28	فَرْضَ الْكِفَايَةِ
u'فَرْضٌ كِفَايَةٌ':Added, #41: 41	فَرْضِ الْكِفَايَةِ
u'فَرْضٌ كِفَايَةٌ':Added, #45: 45	فَرْضَ كِفَايَةٍ
u'فَرَضَ كَلاَمٌ':Predicate, #7: 7	فَرْضِ كِفَايَةٍ
u'فَرْضٌ كَلاَمٌ':Added, #3: 3	فَرَضَ الْكَلَامَ
u'فَرْضٌ كَلاَمٌ':Added, #1: 1	فَرْضَ الْكَلَامِ
u'فَرْضٌ كَلاَمٌ':Added, #1: 1	فَرْضَ كَلَامِ
u'فَرْضٌ كَلاَمٌ':Added, #1: 1	فَرْضُ كَلَامِهِ
u'فَرْضٌ كَلاَمٌ':Added, #1: 1	فَرْضِ كَلَامِهِ
u'فَرْضٌ كَلاَمٌ':Added, #2: 2	فَرْضُ كَلَامِ
u'فَرْضٌ كَوْنٌ':Added, #3: 3	فَرْضُ الْكَلَامِ
u'فَرْضٌ مَاءٌ':Added, #1: 1	فَرْضُ كَوْنِ
u'فَرْضٌ مَالٌ':Added, #1: 1	فَرْضِ مَاءٍ
u'فَرْضٌ مَالٌ':Added, #1: 1	فَرْضُ الْمَالِ
u'فَرْضٌ مَالٌ':Added, #1: 1	فَرْضِ الْمَالِ
u'فَرْضٌ مَالِكٌ':Added, #1: 1	فَرْضِ مَالٍ
u'فَرْضٌ مُتَابَعٌ':Added, #1: 1	فَرْضُ الْمَالِكِ
u'فَرْضٌ مُتَابَعٌ':Added, #1: 1	فَرْضَ الْمُتَابَعَةِ
u'فَرْضٌ مُتَابَعَةٌ':Added, #3: 3	فَرْضِ الْمُتَابَعَةِ
u'فَرْضٌ مُتَابَعَةٌ':Added, #1: 1	فَرْضَ الْمُتَابَعَةِ
u'فَرْضٌ مُتَّسَعٌ':Added, #3: 3	فَرْضِ الْمُتَابَعَةِ
u'فَرْضٌ مُتْعَةٌ':Added, #1: 1	فَرْضٍ مُتَّسَعٍ
u'فَرَضَ مثل':Predicate, #1: 1	فَرْضِ الْمُتْعَةِ
u'فَرَضَ مِثْلٌ':Predicate, #1: 1	فَرَضَ الْمِثْلَ
u'فَرْضٌ مثل':Added, #1: 1	فَرَضَ الْمِثْلَ
u'فَرْضٌ مِثْلٌ':Added, #1: 1	فَرْضِ الْمِثْلِ
u'فَرْضٌ مُجْمَعٌ':Added, #1: 1	فَرْضِ الْمِثْلِ
u'فَرْضٌ مَجْمُوعٌ':Added, #1: 1	فَرْضٍ مُجْمَعٍ
u'فَرْضٌ مَرِيضٌ':Added, #5: 5	فَرْضِ الْمَجْمُوعِ
u'فَرْضٌ مُسَافِرٌ':Added, #1: 1	فَرْضِ الْمَرِيضِ
u'فَرْضٌ مُسَافِرٌ':Added, #1: 1	فَرْضَ الْمُسَافِرِ
u'فَرْضٌ مُسَافِرٌ':Added, #1: 1	فَرْضِ الْمُسَافِرِ
u'فَرَضَ مَسْأَلَةٌ':Predicate, #5: 5	فَرْضُ الْمُسَافِرِ
u'فَرْضٌ مَسْأَلَةٌ':Added, #7: 7	فَرَضَ الْمَسْأَلَةَ
u'فَرْضٌ مَسْأَلَةٌ':Added, #17: 17	فَرْضُ الْمَسْأَلَةِ
u'فَرْضٌ مَسْأَلَةٌ':Added, #1: 1	فَرْضُ مَسْأَلَةٍ
u'فَرْضٌ مَسْأَلَةٌ':Added, #26: 26	فَرْضَ الْمَسْأَلَةِ
u'فَرْضٌ مَسْأَلَةٌ':Added, #2: 2	فَرْضَ مَسْأَلَةِ
u'فَرْضٌ مُسْتَفاد':Added, #5: 5	فَرْضِ الْمَسْأَلَةِ
u'فَرْضٌ مَسْحٌ':Added, #4: 4	فَرْضِ الْمُسْتَفَادِ
u'فَرْضٌ مَسْحٌ':Added, #2: 2	فَرْضُ الْمَسْحِ
u'فَرْضٌ مَسْحٌ':Added, #3: 3	فَرْضَ الْمَسْحِ
u'فَرَضَ مَشْرُوطٌ':Subject, #4: 4	فَرْضِ الْمَسْحِ
u'فَرْضٌ مَضْمَضَةٌ':Added, #1: 1	فَرَضَ الْمَشْرُوطُ
u'فَرْضٌ مُطْلَقٌ':Added, #1: 1	فَرْضِ الْمَضْمَضَةِ
u'فَرْضٌ مُعْسِرٌ':Added, #1: 1	فَرْضٍ مُطْلَقٍ
u'فَرْضٌ مَقَامٌ':Added, #1: 1	فَرْضُ الْمُعْسِرِ
u'فَرْضٌ مَقَامٌ':Added, #1: 1	فَرْضَ مَقَامِ
u'فَرْضٌ مَقَامٌ':Added, #1: 1	فَرْضِ مَقَامِ
u'فَرْضٌ مَقَامٌ':Added, #2: 2	فَرْضِ الْمَقَامِ
u'فَرْضٌ مُقَدَّرٌ':Added, #6: 6	فَرْضَ الْمَقَامِ
u'فَرْضٌ مُقِيمٌ':Added, #1: 1	فَرْضٍ مُقَدَّرٍ
u'فَرَضَ مَهْرٌ':Predicate, #1: 1	فَرْضَ الْمُقِيمِ
u'فَرْضٌ مَهْرٌ':Added, #1: 1	فَرَضَ مَهْرَ
u'فَرَضَ مَوَارِيثُ':Predicate, #1: 1	فَرْضِ الْمَهْرِ
u'فَرْضٌ مِيرَاثٌ':Added, #1: 1	فَرَضَ الْمَوَارِيثَ
u'فَرْضٌ نزاع':Added, #1: 1	فَرْضِ مِيرَاثِ
u'فَرْضٌ نِزَاعٌ':Added, #1: 1	فَرْضِ النِّزَاعِ
u'فَرْضٌ نصاب':Added, #1: 1	فَرْضِ النِّزَاعِ
u'فَرْضٌ نِصَابٌ':Added, #1: 1	فَرْضَ نِصَابٍ
u'فَرْضٌ نصاب':Added, #1: 1	فَرْضَ نِصَابٍ
u'فَرْضٌ نِصَابٌ':Added, #2: 2	فَرْضَ النِّصَابِ
u'فَرْضٌ نصاب':Added, #2: 2	فَرْضَ النِّصَابِ
u'فَرْضٌ نِصَابٌ':Added, #2: 2	فَرْضِ نِصَابٍ
u'فَرْضٌ نصاب':Added, #2: 2	فَرْضِ نِصَابٍ
u'فَرْضٌ نِصَابٌ':Added, #3: 3	فَرْضُ النِّصَابِ
u'فَرْضٌ نَفْسٌ':Added, #3: 3	فَرْضُ النِّصَابِ
u'فَرْضٌ نَفْسٌ':Added, #1: 1	فَرْضَ نَفْسِهِ
u'فَرْضٌ نَفْسٌ':Added, #1: 1	فَرْضُ نَفْسِهِ
u'فَرَضَ نَفَقَةٌ':Predicate, #1: 1	فَرْضِ نَفْسِهِ
u'فَرَضَ نَفَقَةٌ':Predicate, #3: 3	فَرَضَ نَفَقَةَ
u'فَرْضٌ نَفَقَةٌ':Added, #4: 4	فَرَضَ النَّفَقَةَ
u'فَرْضٌ نَفَقَةٌ':Added, #10: 10	فَرْضَ النَّفَقَةِ
u'فَرْضٌ نَفَقَةٌ':Added, #1: 1	فَرْضَ نَفَقَةٍ
u'فَرْضٌ نَفَقَةٌ':Added, #3: 3	فَرْضُ النَّفَقَةِ
u'فَرْضٌ نَفَقَةٌ':Added, #3: 3	فَرْضِ نَفَقَةِ
u'فَرْضٌ هجرة':Added, #6: 6	فَرْضِ النَّفَقَةِ
u'فَرْضٌ هجرة':Added, #1: 1	فَرْضُ الْهِجْرَةِ
u'فَرْضٌ هِجْرَةٌ':Added, #1: 1	فَرْضِ الْهِجْرَةِ
u'فَرْضٌ هِجْرَةٌ':Added, #1: 1	فَرْضُ الْهِجْرَةِ
u'فَرْضٌ واحد':Added, #1: 1	فَرْضِ الْهِجْرَةِ
u'فَرْضٌ وَاحِدٌ':Added, #3: 3	فَرْضٍ وَاحِدٍ
u'فَرْضٌ وَجْهٌ':Added, #3: 3	فَرْضٍ وَاحِدٍ
u'فَرْضٌ وُجُوبٌ':Added, #1: 1	فَرْضِ الْوَجْهِ
u'فَرْضٌ وُجُودٌ':Added, #1: 1	فَرْضِ الْوُجُوبِ
u'فَرْضٌ وُجُودٌ':Added, #1: 1	فَرْضِ وُجُودِ
u'فَرْضٌ وُجُودٌ':Added, #1: 1	فَرْضَ وُجُودِهِ
u'فَرْضٌ وُرُودٌ':Added, #3: 3	فَرْضِ وُجُودِهِ
u'فَرَضَ وَصِيٌّ':Predicate, #1: 1	فَرْضِ وُرُودِ
u'فَرْضٌ وَصِيٌّ':Added, #1: 1	فَرَضَ الْوَصِيَّةَ
u'فَرْضٌ وَصِيٌّ':Added, #1: 1	فَرْضَ الْوَصِيَّةِ
u'فَرَضَ وَصِيَّةٌ':Predicate, #1: 1	فَرْضُ الْوَصِيَّةِ
u'فَرْضٌ وَصِيَّةٌ':Added, #1: 1	فَرَضَ الْوَصِيَّةَ
u'فَرْضٌ وَصِيَّةٌ':Added, #1: 1	فَرْضَ الْوَصِيَّةِ
u'فَرْضٌ وُضُوءٌ':Added, #1: 1	فَرْضُ الْوَصِيَّةِ
u'فَرْضٌ وُضُوءٌ':Added, #2: 2	فَرْضَ الْوُضُوءِ
u'فَرْضٌ وُضُوءٌ':Added, #6: 6	فَرْضِ الْوُضُوءِ
u'فَرَضَ وَقْتٌ':Predicate, #7: 7	فَرْضُ الْوُضُوءِ
u'فَرْضٌ وَقْتٌ':Added, #2: 2	فَرَضَ الْوَقْتَ
u'فَرْضٌ وَقْتٌ':Added, #1: 1	فَرْضُ وَقْتٍ
u'فَرْضٌ وَقْتٌ':Added, #1: 1	فَرْضِ وَقْتِهِ
u'فَرْضٌ وَقْتٌ':Added, #23: 23	فَرْضُ الْوَقْتِ
u'فَرْضٌ وَقْتٌ':Added, #2: 2	فَرْضُ وَقْتِهِ
u'فَرْضٌ وَقْتٌ':Added, #33: 33	فَرْضَ الْوَقْتِ
u'فَرْضٌ وُقُوعٌ':Added, #53: 53	فَرْضِ الْوَقْتِ
u'فَرْضٌ وُقُوعٌ':Added, #1: 1	فَرْضُ وُقُوعِ
u'فَرْضٌ وُقُوعٌ':Added, #1: 1	فَرْضُ وُقُوعِهِ
u'فَرْضٌ ولد':Added, #5: 5	فَرْضِ وُقُوعِهِ
u'فَرْضٌ وَلَدٌ':Added, #1: 1	فَرْضَ وَلَدِ
u'فَرْضٌ يَوْمٌ':Added, #1: 1	فَرْضَ وَلَدِ
u'فَرْضٌ يَوْمٌ':Added, #1: 1	فَرْضُ يَوْمٍ
u'فَرَّطَ إمَامٌ':Subject, #1: 1	فَرْضِ يَوْمِ
u'فَرَّطَ إمَامٌ':Subject, #1: 1	فَرَّطَ إمَامُهُ
u'فَرَّ طَائِرٌ':Subject, #3: 3	فَرَّطَ الْإِمَامُ
u'فَرْطٌ جهل':Added, #1: 1	فَرَّ الطَّائِرُ
u'فَرْطٌ جَهْلٌ':Added, #1: 1	فَرْطِ الْجَهْلِ
u'فَرْطٌ جهل':Added, #1: 1	فَرْطِ الْجَهْلِ
u'فَرْطٌ جَهْلٌ':Added, #1: 1	فَرْطِ جَهْلِهِ
u'فَرْطٌ حُبٌّ':Added, #1: 1	فَرْطِ جَهْلِهِ
u'فَرْطٌ خَفَاءٌ':Added, #1: 1	فَرْطُ الْحُبِّ
u'فَرَّطَ دونٌ':Predicate, #1: 1	فَرْطِ الْخَفَاءِ
u'فَرْطٌ ذَكاءٌ':Added, #1: 1	فَرَّطَ دُونَ
u'فَرَّطَ زَوْجٌ':Subject, #1: 1	فَرْطُ الذَّكَاءِ
u'فَرَّطَ سقط':Predicate, #1: 1	فَرَّطَ الزَّوْجُ
u'فَرَّطَ سَقَطٌ':Predicate, #1: 1	فَرَّطَ سَقَطَ
u'فَرَّطَ شَاعِر':Subject, #1: 1	فَرَّطَ سَقَطَ
u'فَرْطٌ شَبَقٌ':Added, #1: 1	فَرَّطَ شَاعِرٌ
u'فَرْطٌ شَبَقٌ':Added, #1: 1	فَرْطِ الشَّبَقِ
u'فَرْطٌ شَبَقٌ':Added, #2: 2	فَرْطَ الشَّبَقِ
u'فَرْطٌ شَفَقَةٌ':Added, #4: 4	فَرْطُ الشَّبَقِ
u'فَرْطٌ شكر':Added, #1: 1	فَرْطَ شَفَقَةِ
u'فَرْطٌ شُكْرٌ':Added, #1: 1	فَرْطِ شُكْرِ
u'فَرْطٌ شَهْوَةٌ':Added, #1: 1	فَرْطِ شُكْرِ
u'فَرْطٌ شَهْوَةٌ':Added, #1: 1	فَرْطُ الشَّهْوَةِ
u'فَرْطٌ شَهْوَةٌ':Added, #1: 1	فَرْطُ شَهْوَةٍ
u'فَرَّطَ صَاحِبٌ':Subject, #1: 1	فَرْطِ شَهْوَتِهِ
u'فَرَّطَ ضَمِنٌ':Predicate, #1: 1	فَرَّطَ صَاحِبُ
u'فَرْطٌ غَيْرَةٌ':Added, #4: 4	فَرَّطَ ضَمِنَ
u'فَرْطٌ قُرْبٌ':Added, #1: 1	فَرْطُ الْغَيْرَةِ
u'فَرَّطَ مُرْتَهِنٌ':Subject, #1: 1	فَرْطِ الْقُرْبِ
u'فَرْطٌ هُجُومٌ':Added, #1: 1	فَرَّطَ مُرْتَهِنُهُ
u'فَرْطٌ هُجُومٌ':Added, #1: 1	فَرْطُ هُجُومٍ
u'فَرْطٌ هُجُومٌ':Added, #1: 1	فَرْطِ هُجُومٍ
u'فَرَّطَ وَكِيلٌ':Subject, #1: 1	فَرْطِ هُجُومِهِ
u'فَرْعٌ اِبْنٌ':Added, #1: 1	فَرَّطَ الْوَكِيلُ
u'فَرْعٌ أَدَاءٌ':Added, #2: 2	فَرْعِ ابْنِ
u'فَرْعٌ إِرَادَةٌ':Added, #1: 1	فَرْعُ الْأَدَاءِ
u'فَرْعٌ اِسْتِقْرارٌ':Added, #1: 1	فَرْعُ إرَادَةِ
u'فَرْعٌ اِسْتِقْلالٌ':Added, #1: 1	فَرْعُ اسْتِقْرَارِهِ
u'فَرْعٌ اِشْتِراطٌ':Added, #1: 1	فَرْعُ اسْتِقْلَالِ
u'فَرَّعَ أَصْحَابٌ':Subject, #1: 1	فَرْعُ اشْتِرَاطِ
u'فَرَّعَ أَصْحَابٌ':Subject, #1: 1	فَرَّعَ أَصْحَابُهُ
u'فَرْعٌ أًصْلٌ':Added, #1: 1	فَرَّعَ الْأَصْحَابُ
u'فَرْعٌ أًصْلٌ':Added, #1: 1	فَرْعَ أَصْلٍ
u'فَرْعٌ أصل':Added, #1: 1	فَرْعُ أَصْلٍ
u'فَرْعٌ أًصْلٌ':Added, #1: 1	فَرْعِ أَصْلِهِ
u'فَرْعٌ أصل':Added, #1: 1	فَرْعِ أَصْلِهِ
u'فَرْعٌ أصل':Added, #1: 1	فَرْعُ الْأَصْلِ
u'فَرْعٌ أًصْلٌ':Added, #1: 1	فَرْعِ الْأَصْلِ
u'فَرْعٌ أًصْلٌ':Added, #1: 1	فَرْعُ الْأَصْلِ
u'فَرْعٌ أُصولٌ':Added, #1: 1	فَرْعِ الْأَصْلِ
u'فَرْعٌ أَصيلٌ':Added, #1: 1	فَرْعُ الْأُصُولِ
u'فَرْعٌ اِعْتِبارٌ':Added, #1: 1	فَرْعُ الْأَصِيلِ
u'فَرْعٌ اِفْتِرَاشٌ':Added, #2: 2	فَرْعُ اعْتِبَارِ
u'فَرْعٌ اِلْتِصَاقٌ':Added, #1: 1	فَرْعُ افْتِرَاشِ
u'فَرْعٌ أُمومَةٌ':Added, #1: 1	فَرْعُ الْتِصَاقِ
u'فَرْعٌ اِنْتِقالٌ':Added, #4: 4	فَرْعُ الْأُمُومَةِ
u'فَرْعٌ إِنْسانٌ':Added, #1: 1	فَرْعُ انْتِقَالِ
u'فَرْعٌ اِنْعِقَادٌ':Added, #1: 1	فَرْعِ الْإِنْسَانِ
u'فَرْعٌ إيقَاعٌ':Added, #1: 1	فَرْعُ انْعِقَادِ
u'فَرْعٌ بَزّاز':Added, #1: 1	فَرْعُ إيقَاعِ
u'فَرْعٌ بَزّازَة':Added, #1: 1	فَرْعَ الْبَزَّازِيَّةِ
u'فَرَّعَ بَعْضٌ':Subject, #1: 1	فَرْعَ الْبَزَّازِيَّةِ
u'فَرْعٌ بَقاءٌ':Added, #2: 2	فَرَّعَ بَعْضُ
u'فَرْعٌ تَجْنِيس':Added, #1: 1	فَرْعُ بَقَاءِ
u'فَرْعٌ تَحْرِيمٌ':Added, #1: 1	فَرْعُ التَّجْنِيسِ
u'فَرْعٌ تَحْسِين':Added, #1: 1	فَرْعُ التَّحْرِيمِ
u'فَرْعٌ تَحَقُّقٌ':Added, #1: 1	فَرْعُ التَّحْسِينِ
u'فَرْعٌ تَخْصِيصٌ':Added, #2: 2	فَرْعُ تَحَقُّقِ
u'فَرْعٌ تَدْبِيرٌ':Added, #1: 1	فَرْعُ تَخْصِيصٍ
u'فَرْعٌ تَسْلِيمٌ':Added, #1: 1	فَرْعِ التَّدْبِيرِ
u'فَرْعٌ تَشْبِيهٌ':Added, #1: 1	فَرْعُ تَسْلِيمِ
u'فَرْعٌ تَصَوُّرٌ':Added, #1: 1	فَرْعُ تَشْبِيهِ
u'فَرْعٌ تَصَوُّرٌ':Added, #1: 1	فَرْعُ التَّصَوُّرِ
u'فَرْعٌ تَعْجِيل':Added, #5: 5	فَرْعُ تَصَوُّرِهِ
u'فَرْعٌ تَعَقُّلٌ':Added, #1: 1	فَرْعُ تَعْجِيلِ
u'فَرْعٌ تَعَقُّلٌ':Added, #1: 1	فَرْعُ تَعَقُّلِ
u'فَرْعٌ تَعْلِيقٌ':Added, #1: 1	فَرْعُ تَعَقُّلِهِ
u'فَرْعٌ تَعْلِيلٌ':Added, #1: 1	فَرْعُ التَّعْلِيقِ
u'فَرْعٌ تَقَدُّمٌ':Added, #1: 1	فَرْعُ تَعْلِيلِ
u'فَرْعٌ تَقْديمٌ':Added, #1: 1	فَرْعُ تَقَدُّمِ
u'فَرْعٌ تَكْذيبٌ':Added, #1: 1	فَرْعُ تَقْدِيمِ
u'فَرْعٌ تَكْرارٌ':Added, #1: 1	فَرْعَ التَّكْذِيبِ
u'فَرْعٌ تَكَرُّرٌ':Added, #1: 1	فَرْعَ تَكْرَارِ
u'فَرْعٌ تَكْليفٌ':Added, #1: 1	فَرْعُ تَكَرُّرِ
u'فَرْعٌ تَكْليفٌ':Added, #1: 1	فَرْعُ التَّكْلِيفِ
u'فَرْعٌ تَمْوِيتٌ':Added, #1: 1	فَرْعُ تَكْلِيفِ
u'فَرْعٌ تَوَقُّفٌ':Added, #1: 1	فَرْعُ تَمْوِيتِهِ
u'فَرْعٌ ثُبُوتٌ':Added, #1: 1	فَرْعُ التَّوَقُّفِ
u'فَرْعٌ ثُبُوتٌ':Added, #2: 2	فَرْعُ الثُّبُوتِ
u'فَرْعٌ ثُبُوتٌ':Added, #2: 2	فَرْعُ ثُبُوتِهِ
u'فَرْعٌ ثَمَنٌ':Added, #6: 6	فَرْعُ ثُبُوتِ
u'فَرْعٌ جِهَةٌ':Added, #1: 1	فَرْعُ الثَّمَنِ
u'فَرْعٌ جَوَابٌ':Added, #1: 1	فَرْعَ جِهَةِ
u'فَرْعٌ جَوَازٌ':Added, #1: 1	فَرْعُ الْجَوَابِ
u'فَرْعٌ جَوَاهِرُ':Added, #7: 7	فَرْعُ جَوَازِ
u'فَرْعٌ حُكْمٌ':Added, #1: 1	فَرْعِ الْجَوَاهِرِ
u'فَرْعٌ حُكْمٌ':Added, #1: 1	فَرْعَ الْحُكْمِ
u'فَرْعٌ حُكْمٌ':Added, #1: 1	فَرْعُ الْحُكْمِ
u'فَرْعٌ حُكْمٌ':Added, #1: 1	فَرْعُ حُكْمِ
u'فَرْعٌ حَلْقٌ':Added, #1: 1	فَرْعُ حُكْمِهِ
u'فَرْعٌ حَمْلٌ':Added, #1: 1	فَرْعُ الْحَلْقِ
u'فَرْعٌ خان':Added, #1: 1	فَرْعُ حَمْلِ
u'فَرْعٌ خانَة':Added, #2: 2	فَرْعِ الْخَانِيَّةِ
u'فَرْعٌ خَبَر':Added, #2: 2	فَرْعِ الْخَانِيَّةِ
u'فَرْعٌ خُلاصَة':Added, #1: 1	فَرْعُ الْخَبَرِيَّةِ
u'فَرْعٌ خَلِيفَةٌ':Added, #1: 1	فَرْعُ الْخُلَاصَةِ
u'فَرْعٌ دُخُولٌ':Added, #1: 1	فَرْعُ الْخَلِيفَةِ
u'فَرْعٌ دَلالَةٌ':Added, #1: 1	فَرْعُ الدُّخُولِ
u'فَرْعٌ دَمٌ':Added, #1: 1	فَرْعُ دَلَالَةِ
u'فَرْعٌ رِبَوِيّ':Added, #1: 1	فَرْعُ دَمِ
u'فَرْعٌ رِقٌّ':Added, #1: 1	فَرْعُ رِبَوِيَّةِ
u'فَرْعٌ رَوْضَةٌ':Added, #1: 1	فَرْعُ الرِّقِّ
u'فَرْعٌ زَوْجَةٌ':Added, #1: 1	فَرْعِ الرَّوْضَةِ
u'فَرْعٌ سَمَاعٌ':Added, #1: 1	فَرْعُ الزَّوْجَةِ
u'فَرَّعَ شافِع':Subject, #1: 1	فَرْعُ سَمَاعِ
u'فَرَّعَ شافِعِيّ':Subject, #1: 1	فَرَّعَ الشَّافِعِيَّةُ
u'فَرْعٌ شُرُوعٌ':Added, #1: 1	فَرَّعَ الشَّافِعِيَّةُ
u'فَرْعٌ شُغْلٌ':Added, #1: 1	فَرْعُ الشُّرُوعِ
u'فَرْعٌ شُغْل':Added, #1: 1	فَرْعُ شُغْلِ
u'فَرْعٌ شُمُول':Added, #1: 1	فَرْعُ شُغْلِ
u'فَرْعٌ شَهَادَةٌ':Added, #1: 1	فَرْعُ شُمُولِ
u'فَرْعٌ شَيْءٌ':Added, #2: 2	فَرْعُ شَهَادَةِ
u'فَرْعٌ صِحَّةٌ':Added, #1: 1	فَرْعِ الشَّيْءِ
u'فَرْعٌ صِحَّةٌ':Added, #1: 1	فَرْعُ صِحَّةِ
u'فَرْعٌ صِحَّةٌ':Added, #1: 1	فَرْعُ صِحَّتِهِ
u'فَرْعٌ صدق':Added, #3: 3	فَرْعُ الصِّحَّةِ
u'فَرْعٌ صِدْقٌ':Added, #1: 1	فَرْعُ صِدْقِهِ
u'فَرْعٌ صِفَةٌ':Added, #1: 1	فَرْعُ صِدْقِهِ
u'فَرْعٌ ضَمَانٌ':Added, #1: 1	فَرْعُ صِفَاتِ
u'فَرْعٌ طلب':Added, #1: 1	فَرْعُ الضَّمَانِ
u'فَرْعٌ طَلَبٌ':Added, #1: 1	فَرْعُ الطَّلَبِ
u'فَرْعٌ طلب':Added, #1: 1	فَرْعُ الطَّلَبِ
u'فَرْعٌ طَلَبٌ':Added, #1: 1	فَرْعُ طَلَبِ
u'فَرْعٌ طَهَارَةٌ':Added, #1: 1	فَرْعُ طَلَبِ
u'فَرْعٌ ظُهورٌ':Added, #2: 2	فَرْعُ طَهَارَتِهِ
u'فَرْعٌ عَتِيقٌ':Added, #1: 1	فَرْعُ ظُهُورِ
u'فَرْعٌ عَدَمٌ':Added, #1: 1	فَرْعُ الْعَتِيقِ
u'فَرْعٌ عُصَاةٌ':Added, #1: 1	فَرْعُ عَدَمِ
u'فَرْعٌ علم':Added, #1: 1	فَرْعِ الْعُصَاةِ
u'فَرْعٌ عِلْمٌ':Added, #1: 1	فَرْعُ عِلْمِهِ
u'فَرْعٌ علم':Added, #1: 1	فَرْعُ عِلْمِهِ
u'فَرْعٌ عِلْمٌ':Added, #2: 2	فَرْعُ الْعِلْمِ
u'فَرْعٌ عِماد':Added, #2: 2	فَرْعُ الْعِلْمِ
u'فَرْعٌ عِمادَة':Added, #1: 1	فَرْعِ الْعِمَادِيَّةِ
u'فَرْعٌ عُمُومٌ':Added, #1: 1	فَرْعِ الْعِمَادِيَّةِ
u'فَرَّعَ عين':Subject, #1: 1	فَرْعُ عُمُومِ
u'فَرَّعَ عَيْنٌ':Subject, #1: 1	فَرَّعَ عَيْنُ
u'فَرَّعَ عَيْن':Subject, #1: 1	فَرَّعَ عَيْنُ
u'فَرْعٌ غَصْبٌ':Added, #1: 1	فَرَّعَ عَيْنُ
u'فَرْعٌ غُلاَمٌ':Added, #1: 1	فَرْعِ غَصْبِ
u'فَرْعٌ فَرْعٌ':Added, #1: 1	فَرْعِ الْغُلَامِ
u'فَرْعٌ فَرْعٌ':Added, #1: 1	فَرْعَ الْفَرْعِ
u'فَرْعٌ فَرْعٌ':Added, #1: 1	فَرْعُ فَرْعِهِ
u'فَرْعٌ فُصُولٌ':Added, #3: 3	فَرْعِ الْفَرْعِ
u'فَرْعٌ فِعْلٌ':Added, #1: 1	فَرْعِ الْفُصُولِ
u'فَرَّعَ فلان':Subject, #1: 1	فَرْعَ الْفِعْلِ
u'فَرْعٌ فلان':Added, #1: 1	فَرَّعَ الشَّافِعِيَّةُ
u'فَرْعٌ فلان':Added, #1: 1	فَرْعَ الْبَزَّازِيَّةِ
u'فَرْعٌ فلان':Added, #1: 1	فَرْعِ الْعِمَادِيَّةِ
u'فَرْعٌ قَبُولٌ':Added, #2: 2	فَرْعِ الْخَانِيَّةِ
u'فَرَّعَ قول':Predicate, #1: 1	فَرْعُ قَبُولِ
u'فَرَّعَ قَوْلٌ':Predicate, #1: 1	فَرَّعَ قَوْلَ
u'فَرْعٌ قول':Added, #1: 1	فَرَّعَ قَوْلَ
u'فَرْعٌ قَوْلٌ':Added, #1: 1	فَرْعُ قَوْلِ
u'فَرْعٌ قول':Added, #1: 1	فَرْعُ قَوْلِ
u'فَرْعٌ قَوْلٌ':Added, #1: 1	فَرْعُ قَوْلِهِ
u'فَرْعٌ قِيَاسٌ':Added, #1: 1	فَرْعُ قَوْلِهِ
u'فَرْعٌ قِيَاسٌ':Added, #1: 1	فَرْعُ الْقِيَاسِ
u'فَرْعٌ قِيَاسٌ':Added, #1: 1	فَرْعَ قِيَاسٍ
u'فَرْعٌ كَلاَمٌ':Added, #1: 1	فَرْعُ قِيَاسٍ
u'فَرْعٌ كَوْنٌ':Added, #1: 1	فَرْعُ الْكَلَامِ
u'فَرْعٌ كَوْنٌ':Added, #1: 1	فَرْعَ كَوْنِ
u'فَرْعٌ كَوْنٌ':Added, #1: 1	فَرْعُ كَوْنِ
u'فَرْعٌ مَالٌ':Added, #1: 1	فَرْعُ كَوْنِهِ
u'فَرْعٌ مَانِعٌ':Added, #5: 5	فَرْعُ الْمَالِ
u'فَرَّعَ مُحَمَّدٌ':Subject, #1: 1	فَرْعِ الْمَانِعِ
u'فَرْعٌ مُخْتَلَفٌ':Added, #1: 1	فَرَّعَ مُحَمَّدٌ
u'فَرْعٌ مَدْيُونٌ':Added, #2: 2	فَرْعٍ مُخْتَلَفٍ
u'فَرْعٌ مَذْكُورٌ':Added, #1: 1	فَرْعُ الْمَدْيُونِ
u'فَرْعٌ مَسْأَلَةٌ':Added, #1: 1	فَرْعٍ مَذْكُورٍ
u'فَرَّعَ مَسَائِلُ':Predicate, #6: 6	فَرْعُ مَسْأَلَةِ
u'فَرْعٌ مَسْكُوتٌ':Added, #2: 2	فَرَّعَ مَسَائِلَ
u'فَرْعٌ مَعْرِفَةٌ':Added, #1: 1	فَرْعٍ مَسْكُوتٍ
u'فَرْعٌ مَعْرِفَة':Added, #1: 1	فَرْعُ الْمَعْرِفَةِ
u'فَرْعٌ مَعْرِفَةٌ':Added, #1: 1	فَرْعُ الْمَعْرِفَةِ
u'فَرْعٌ مَعْرِفَة':Added, #4: 4	فَرْعُ مَعْرِفَةِ
u'فَرْعٌ مَعْلُوم':Added, #4: 4	فَرْعُ مَعْرِفَةِ
u'فَرْعٌ مَعْلُومَة':Added, #1: 1	فَرْعُ مَعْلُومِيَّةِ
u'فَرْعٌ مُفْرَدٌ':Added, #1: 1	فَرْعُ مَعْلُومِيَّةِ
u'فَرْعٌ مُلاَحَظَةٌ':Added, #1: 1	فَرْعَ الْمُفْرَدِ
u'فَرْعٌ مِلْكٌ':Added, #1: 1	فَرْعُ الْمُلَاحَظَةِ
u'فَرْعٌ مِلْكٌ':Added, #2: 2	فَرْعُ مِلْكِهِ
u'فَرْعٌ مُنَازَعٌ':Added, #3: 3	فَرْعُ الْمِلْكِ
u'فَرْعٌ مَنْصُوصٌ':Added, #1: 1	فَرْعٍ مُنَازَعٍ
u'فَرْعٌ نَجَاسَةٌ':Added, #1: 1	فَرْعٍ مَنْصُوصٍ
u'فَرْعٌ نَسَبٌ':Added, #1: 1	فَرْعُ نَجَاسَةِ
u'فَرْعٌ نَصٌّ':Added, #9: 9	فَرْعُ النَّسَبِ
u'فَرْعٌ نَفْسٌ':Added, #2: 2	فَرْعُ النَّصِّ
u'فَرْعٌ نكاح':Added, #1: 1	فَرْعَ نَفْسِهِ
u'فَرْعٌ نكاح':Added, #1: 1	فَرْعُ النِّكَاحِ
u'فَرْعٌ نِكَاحٌ':Added, #1: 1	فَرْعِ النِّكَاحِ
u'فَرْعٌ نِكَاحٌ':Added, #1: 1	فَرْعُ النِّكَاحِ
u'فَرْعٌ وَاقِعٌ':Added, #1: 1	فَرْعِ النِّكَاحِ
u'فَرْعٌ وَجْهٌ':Added, #1: 1	فَرْعُ الْوَاقِعَاتِ
u'فَرْعٌ وُجُوبٌ':Added, #1: 1	فَرْعَ الْوَجْهَيْنِ
u'فَرْعٌ وُجُوبٌ':Added, #1: 1	فَرْعُ وُجُوبِهِ
u'فَرْعٌ وُجُودٌ':Added, #2: 2	فَرْعُ الْوُجُوبِ
u'فَرْعٌ وُجُودٌ':Added, #1: 1	فَرْعُ الْوُجُودِ
u'فَرْعٌ وُجُودٌ':Added, #3: 3	فَرْعُ وُجُودِ
u'فَرَّعَ وَضْعٌ':Predicate, #7: 7	فَرْعُ وُجُودِهِ
u'فَرْعٌ وَضْعٌ':Added, #1: 1	فَرَّعَ الْوَضْعَ
u'فَرْعٌ وِلاَيَةٌ':Added, #1: 1	فَرْعُ الْوَضْعِ
u'فَرْعٌ وِلاَيَةٌ':Added, #2: 2	فَرْعُ الْوِلَايَةِ
u'فَرْعٌ ولد':Added, #2: 2	فَرْعُ وِلَايَةِ
u'فَرْعٌ وَلَدٌ':Added, #1: 1	فَرْعُ الْوَلَدِ
u'فَرَغَ أَبٌ':Subject, #1: 1	فَرْعُ الْوَلَدِ
u'فَرَغَ اِبْنٌ':Subject, #1: 1	فَرَغَ الْأَبُ
u'فَرَغَ أرْضٌ':Predicate, #3: 3	فَرَغَ ابْنُ
u'فَرَغَ إمَامٌ':Subject, #1: 1	أَفْرَغَ الْأَرْضَ
u'فَرَغَ إمَامٌ':Subject, #1: 1	فَرَغَ الإِمَامُ
u'فَرَغَ إمَامٌ':Subject, #32: 32	فَرَغَ الْإِمَامُ
u'فَرَغَ إِناءٌ':Predicate, #4: 4	فَرَغَ إمَامُهُ
u'فَرَغَ أهْلٌ':Subject, #1: 1	أَفْرَغَ الْإِنَاءَ
u'فَرَغَ باقِي':Predicate, #1: 1	فَرَغَ أَهْلُ
u'فَرَّغَ بَيْتٌ':Predicate, #2: 2	أَفْرَغَ بَاقِيَ
u'فَرَغَ ثَالِثٌ':Subject, #1: 1	فَرَّغَ الْبَيْتَ
u'فَرَغَ جَازٌ':Predicate, #1: 1	فَرَغَ الثَّالِثُ
u'فَرَغَ حائِكٌ':Subject, #1: 1	فَرَغَ جَازَ
u'فَرَغَ حَجٌّ':Subject, #1: 1	فَرَغَ الْحَائِكُ
u'فَرَغَ خَلِيفَةٌ':Subject, #1: 1	فَرَغَ حَجُّهُ
u'فَرَّغَ دَارٌ':Predicate, #1: 1	فَرَغَ خَلِيفَتُهُ
u'فَرَغَ دَخَلٌ':Predicate, #1: 1	فَرَّغَ الدَّارَ
u'فَرَغَ رَجُلٌ':Subject, #1: 1	فَرَغَ دَخَلَ
u'فَرَغَ رَسُولٌ':Subject, #1: 1	فَرَغَ الرَّجُلُ
u'فَرَغَ ركب':Predicate, #33: 33	فَرَغَ رَسُولُ
u'فَرَغَ سَبْعَةٌ':Subject, #1: 1	فَرَغَ رَكِبَ
u'فَرَغَ شَرَعٌ':Predicate, #1: 1	فَرَغَ سَبْعَةٌ
u'فَرَغَ عَبْدٌ':Subject, #2: 2	فَرَغَ شَرَعَ
u'فَرَغَ عتبة':Subject, #1: 1	فَرَغَ الْعَبْدُ
u'فَرَغَ فَاتِحٌ':Predicate, #1: 1	فَرَغَ عُتْبَةُ
u'فَرَغَ فَاتِحَةٌ':Predicate, #1: 1	فَرَغَ الْفَاتِحَةَ
u'فَرَغَ فلان':Subject, #1: 1	فَرَغَ الْفَاتِحَةَ
u'فَرَغَ قَارِئٌ':Subject, #1: 1	فَرَغَ بِلَالٌ
u'فَرَغَ قَالٌ':Predicate, #1: 1	فَرَغَ الْقَارِئُ
u'فَرَغَ قَوْمٌ':Subject, #50: 50	فَرَغَ قَالَ
u'فَرَغَ قَوْمٌ':Subject, #1: 1	فَرَغَ قَوْمٌ
u'فَرَغَ مَاءٌ':Subject, #4: 4	فَرَغَ الْقَوْمُ
u'فَرَغَ مَالٌ':Subject, #2: 2	فَرَغَ مَاءُ
u'فَرَغَ مَأْمُورٌ':Subject, #3: 3	فَرَغَ الْمَالُ
u'فَرَغَ مُتَمَتِّعٌ':Subject, #1: 1	فَرَغَ الْمَأْمُورُ
u'فَرَغَ مُتَمَتِّعٌ':Subject, #1: 1	فَرَغَ الْمُتَمَتِّعُ
u'فَرَغَ مَسْبُوق':Subject, #1: 1	فَرَغَ مُتَمَتِّعٌ
u'فَرَغَ مُصَنِّفٌ':Subject, #1: 1	فَرَغَ الْمَسْبُوقُ
u'فَرَغَ مُؤَذِّنٌ':Subject, #4: 4	فَرَغَ الْمُصَنِّفُ
u'فَرَغَ نَاسٌ':Subject, #4: 4	فَرَغَ الْمُؤَذِّنُ
u'فَرَغَ نَبِيٌّ':Subject, #2: 2	فَرَغَ النَّاسُ
u'فَرَغَ نَزَلٌ':Predicate, #3: 3	فَرَغَ النَّبِيُّ
u'فَرَغَ نِساءٌ':Subject, #1: 1	فَرَغَ نَزَلَ
u'فَرَغَ نِصْفٌ':Subject, #1: 1	فَرَغَ النّسَاءُ
u'فَرَغَ وَقْتٌ':Subject, #1: 1	فَرَغَ نِصْفُ
u'فَرَّ فرار':Predicate, #1: 1	فَرَغَ الْوَقْتُ
u'فَرَّ فِرَارٌ':Predicate, #1: 1	فَرَّ فِرَارَ
u'فَرْفَرَ لَحْمٌ':Predicate, #1: 1	فَرَّ فِرَارَ
u'فَرَّقَ اِبْنٌ':Subject, #1: 1	فَرْفَرَ اللّحْمَ
u'فَرَّقَ أَجْزَاءٌ':Predicate, #8: 8	فَرَّقَ ابْنُ
u'فَرَّقَ أَجْنَبِيٌّ':Subject, #1: 1	فَرَّقَ الْأَجْزَاءَ
u'فَرَّقَ أَصْحَابٌ':Subject, #4: 4	فَرَّقَ الْأَجْنَبِيُّ
u'فَرَّقَ أصل':Subject, #6: 6	فَرَّقَ الْأَصْحَابُ
u'فَرَّقَ أًصْلٌ':Subject, #1: 1	فَرَّقَ الْأَصْلُ
u'فرق أصل':Added, #1: 1	فَرَّقَ الْأَصْلُ
u'فرق أًصْلٌ':Added, #1: 1	فَرْقَ الْأَصْلِ
u'فَرْقٌ أصل':Added, #1: 1	فَرْقَ الْأَصْلِ
u'فَرْقٌ أًصْلٌ':Added, #1: 1	فَرْقَ الْأَصْلِ
u'فرق أَعَمُّ':Added, #1: 1	فَرْقَ الْأَصْلِ
u'فَرْقٌ أَعَمُّ':Added, #1: 1	فَرْقَ الْأَعَمِّ
u'فَرَّقَ إمَامٌ':Subject, #1: 1	فَرْقَ الْأَعَمِّ
u'فَرَّقَ أَمْوَالٌ':Predicate, #5: 5	فَرَّقَ الْإِمَامُ
u'فَرَّقَ إِنْسانٌ':Subject, #1: 1	فَرَّقَ الْأَمْوَالَ
u'فَرَّقَ أهْلٌ':Subject, #1: 1	فَرَّقَ إنْسَانٌ
u'فَرَّقَ إِيجَابٌ':Predicate, #1: 1	فَرَّقَ أَهْلُ
u'فَرَّقَ بَعْضٌ':Subject, #1: 1	فَرَّقَ الْإِيجَابَ
u'فَرَّقَ بَيْنٌ':Predicate, #1: 1	فَرَّقَ بَعْضُ
u'فَرَّقَ بَيْنٌ':Predicate, #189: 189	فَرَّقَ بَيْنَ
u'فرق بَيْنٌ':Added, #1: 1	فَرَّقَ بَيْنَكَ
u'فَرْقٌ بَيْنٌ':Added, #1: 1	فَرْقَ بَيْنِ
u'فَرَّقَ جُمْهُورٌ':Subject, #1: 1	فَرْقَ بَيْنِ
u'فَرَّقَ حاكِمٌ':Subject, #1: 1	فَرَّقَ الْجُمْهُورُ
u'فَرَّقَ حَديثٌ':Predicate, #8: 8	فَرَّقَ الْحَاكِمُ
u'فَرَّقَ حِصَّةٌ':Predicate, #1: 1	فَرَّقَ حَدِيثَ
u'فَرَّقَ حَلْوانِيٌّ':Subject, #2: 2	فَرَّقَ حِصَّةَ
u'فَرَّقَ خَشْيَةٌ':Predicate, #1: 1	فَرَّقَ الْحَلْوَانِيُّ
u'فرق خُلاصَة':Added, #1: 1	فَرَّقَ خَشْيَةَ
u'فَرْقٌ خُلاصَة':Added, #1: 1	فَرْقُ الْخُلَاصَةِ
u'فَرَّقَ خلق':Predicate, #1: 1	فَرْقُ الْخُلَاصَةِ
u'فَرَّقَ خَلْقٌ':Predicate, #1: 1	فَرَّقَ الْخَلْقَ
u'فرق رَأْسٌ':Added, #1: 1	فَرَّقَ الْخَلْقَ
u'فَرْقٌ رَأْسٌ':Added, #1: 1	فَرْقِ الرَّأْسِ
u'فَرَّقَ رَسُولٌ':Subject, #1: 1	فَرْقِ الرَّأْسِ
u'فَرَّقَ زَوْجٌ':Subject, #3: 3	فَرَّقَ رَسُولُ
u'فرق زَيْتٌ':Added, #1: 1	فَرَّقَ الزَّوْجُ
u'فَرْقٌ زَيْتٌ':Added, #1: 1	فَرْقُ زَيْتٍ
u'فَرَّقَ سُلْطَانٌ':Subject, #1: 1	فَرْقُ زَيْتٍ
u'فَرَّقَ شافِع':Subject, #1: 1	فَرَّقَ السُّلْطَانُ
u'فَرَّقَ شافِعِيّ':Subject, #1: 1	فَرَّقَ الشَّافِعِيَّةُ
u'فَرَّقَ شَرْعٌ':Subject, #1: 1	فَرَّقَ الشَّافِعِيَّةُ
u'فرق شَعْرٌ':Added, #2: 2	فَرَّقَ الشَّرْعُ
u'فرق شَعْرٌ':Added, #1: 1	فَرْقُ الشَّعْرِ
u'فَرْقٌ شَعْرٌ':Added, #1: 1	فَرْقِ الشَّعْرِ
u'فَرْقٌ شَعْرٌ':Added, #1: 1	فَرْقُ الشَّعْرِ
u'فرق شَعَرٌ':Added, #1: 1	فَرْقِ الشَّعْرِ
u'فرق شَعْرٌ':Added, #1: 1	فَرْقِ شَعَرٍ
u'فَرْقٌ شَعَرٌ':Added, #1: 1	فَرْقِ شَعْرٍ
u'فَرْقٌ شَعْرٌ':Added, #1: 1	فَرْقِ شَعَرٍ
u'فَرَّقَ شُهُودٌ':Predicate, #1: 1	فَرْقِ شَعْرٍ
u'فَرَّقَ شَيْخٌ':Subject, #2: 2	فَرَّقَ الشُّهُودَ
u'فَرَّقَ صَوْمٌ':Predicate, #1: 1	فَرَّقَ الشَّيْخُ
u'فَرَّقَ صِيعَانٌ':Predicate, #1: 1	فَرَّقَ الصَّوْمَ
u'فرق ضلال':Added, #1: 1	فَرَّقَ الصِّيعَانَ
u'فَرْقٌ ضلال':Added, #1: 1	فَرْقِ الضَّلَالِ
u'فرق ضَلاَلٌ':Added, #1: 1	فَرْقِ الضَّلَالِ
u'فَرْقٌ ضَلاَلٌ':Added, #1: 1	فَرْقِ الضَّلَالِ
u'فَرَّقَ طعام':Predicate, #1: 1	فَرْقِ الضَّلَالِ
u'فَرَّقَ طَعَامٌ':Predicate, #1: 1	فَرَّقَ الطَّعَامَ
u'فَرَّقَ طعام':Predicate, #1: 1	فَرَّقَ الطَّعَامَ
u'فَرَّقَ طَعَامٌ':Predicate, #2: 2	فَرَّقَ طَعَامَ
u'فَرَّقَ طَلاَقٌ':Predicate, #2: 2	فَرَّقَ طَعَامَ
u'فَرَّقَ طَوَائِفُ':Subject, #4: 4	فَرَّقَ الطَّلَاقَ
u'فَرَّقَ عَقْدٌ':Predicate, #1: 1	فَرَّقَ طَوَائِفُ
u'فَرَّقَ عُقُودٌ':Predicate, #1: 1	فَرَّقَ عَقْدَ
u'فَرَّقَ علم':Predicate, #1: 1	فَرَّقَ الْعُقُودَ
u'فَرَّقَ عِلْمٌ':Predicate, #1: 1	فَرَّقَ الْعِلْمَ
u'فَرَّقَ عُمَرٌ':Subject, #1: 1	فَرَّقَ الْعِلْمَ
u'فَرَّقَ غُسْلٌ':Predicate, #1: 1	فَرَّقَ عُمَرُ
u'فَرَّقَ غير':Subject, #1: 1	فَرَّقَ الْغُسْلَ
u'فَرَّقَ غَيْرٌ':Subject, #1: 1	فَرَّقَ غَيْرُ
u'فَرَّقَ فَارِقٌ':Subject, #1: 1	فَرَّقَ غَيْرُ
u'فَرَّقَ فطرة':Predicate, #1: 1	فَرَّقَ الْفَارِقُ
u'فَرَّقَ فِطْرَةٌ':Predicate, #2: 2	فَرَّقَ فِطْرَةَ
u'فَرَّقَ فِعْلٌ':Predicate, #2: 2	فَرَّقَ فِطْرَةَ
u'فَرَّقَ فِعْلٌ':Predicate, #1: 1	فَرَّقَ فِعْلَ
u'فَرَّقَ فقهاء':Subject, #2: 2	فَرَّقَ الْفِعْلَ
u'فرق فقهاء':Added, #1: 1	فَرَّقَ الْفُقَهَاءُ
u'فَرْقٌ فقهاء':Added, #1: 1	فَرْقِ الْفُقَهَاءِ
u'فَرَّقَ فَقِيهٌ':Subject, #1: 1	فَرْقِ الْفُقَهَاءِ
u'فَرَّقَ فلان':Subject, #1: 1	فَرَّقَ الْفَقِيهُ
u'فَرَّقَ فلان':Subject, #1: 1	فَرَّقَ الْبَيْهَقِيُّ
u'فَرَّقَ قَالٌ':Predicate, #1: 1	فَرَّقَ الشَّافِعِيَّةُ
u'فَرَّقَ قَفَّالٌ':Subject, #1: 1	فَرَّقَ قَالَ
u'فرق قول':Added, #1: 1	فَرَّقَ الْقَفَّالُ
u'فَرْقٌ قول':Added, #1: 1	فَرْقَ الْقَوْلِ
u'فرق قَوْلٌ':Added, #1: 1	فَرْقَ الْقَوْلِ
u'فَرْقٌ قَوْلٌ':Added, #1: 1	فَرْقَ الْقَوْلِ
u'فَرَّقَ كَلاَمٌ':Predicate, #1: 1	فَرْقَ الْقَوْلِ
u'فَرَّقَ مَالِكٌ':Subject, #2: 2	فَرَّقَ الْكَلَامَ
u'فَرَّقَ مَالِكٌ':Subject, #1: 1	فَرَّقَ مَالِكٌ
u'فَرَّقَ مُبْتاع':Subject, #3: 3	فَرَّقَ الْمَالِكُ
u'فرق مَجْمُوعٌ':Added, #1: 1	فَرَّقَ الْمُبْتَاعُ
u'فَرْقٌ مَجْمُوعٌ':Added, #1: 1	فَرْقِ الْمَجْمُوعِ
u'فَرَّقَ مُحَمَّدٌ':Subject, #1: 1	فَرْقِ الْمَجْمُوعِ
u'فرق مُحَمَّدٌ':Added, #3: 3	فَرَّقَ مُحَمَّدٌ
u'فَرْقٌ مُحَمَّدٌ':Added, #1: 1	فَرْقَ مُحَمَّدِ
u'فَرَّقَ مُصَنِّفٌ':Subject, #1: 1	فَرْقَ مُحَمَّدِ
u'فرق مُصَنِّفٌ':Added, #6: 6	فَرَّقَ الْمُصَنِّفُ
u'فَرْقٌ مُصَنِّفٌ':Added, #1: 1	فَرْقَ الْمُصَنِّفِ
u'فَرَّقَ مَظْلُومٌ':Predicate, #1: 1	فَرْقَ الْمُصَنِّفِ
u'فَرَّقَ مُعْتَرِضٌ':Subject, #1: 1	فَرَّقَ الْمَظْلُومَةَ
u'فَرَّقَ مُفَرِّقٌ':Subject, #4: 4	فَرَّقَ الْمُعْتَرِضُ
u'فَرَّقَ مَوْتٌ':Subject, #1: 1	فَرَّقَ الْمُفَرِّقُ
u'فَرْقٌ مُؤَثِّرٌ':Added, #1: 1	فَرَّقَ الْمَوْتُ
u'فَرَّقَ نَبِيٌّ':Subject, #1: 1	فَرْقٍ مُؤَثِّرٍ
u'فرق نَصٌّ':Added, #1: 1	فَرَّقَ النَّبِيُّ
u'فَرْقٌ نَصٌّ':Added, #1: 1	فَرْقِ النَّصِّ
u'فَرَّقَ نِيَّةٌ':Predicate, #1: 1	فَرْقِ النَّصِّ
u'فَرَّقَ نِيَّةٌ':Predicate, #1: 1	فَرَّقَ نِيَّةَ
u'فَرَّقَ وَصِيٌّ':Predicate, #5: 5	فَرَّقَ النِّيَّةَ
u'فَرَّقَ وَلِيٌّ':Subject, #1: 1	فَرَّقَ وَصِيَّةً
u'فَرَّ قَوْمٌ':Subject, #1: 1	فَرَّقَ الْوَلِيُّ
u'فَرْكٌ شَيْءٌ':Added, #1: 1	فَرَّ قَوْمٌ
u'فَرْكٌ مَنِيٌّ':Added, #1: 1	فَرْكُ شَيْءٍ
u'فَرْكٌ يَابِسٌ':Added, #1: 1	فَرْكِ الْمَنِيِّ
u'فَرْكٌ يَابِسٌ':Added, #1: 1	فَرْكِ الْيَابِسِ
u'فَرَّ مُسْلِمٌ':Subject, #4: 4	فَرْكُ يَابِسِهِ
u'فَرَّ نَاسٌ':Subject, #1: 1	فَرَّ الْمُسْلِمُ
u'فُرُوضٌ أبدانٌ':Added, #1: 1	فَرَّ النَّاسُ
u'فُرُوضٌ أعْيانٌ':Added, #1: 1	فُرُوضِ الْأَبْدَانِ
u'فُرُوضٌ أَعْيَانٌ':Added, #10: 10	فُرُوضِ الْأَعْيَانِ
u'فُرُوضٌ أعْيانٌ':Added, #10: 10	فُرُوضِ الْأَعْيَانِ
u'فُرُوضٌ أَعْيَانٌ':Added, #1: 1	فُرُوضَ الْأَعْيَانِ
u'فُرُوضٌ أَنْصِبَةٌ':Added, #1: 1	فُرُوضَ الْأَعْيَانِ
u'فُرُوضٌ أَنْوَاعٌ':Added, #1: 1	فُرُوضِ أَنْصِبَةِ
u'فُرُوضٌ حَجٌّ':Added, #1: 1	فُرُوضِ أَنْوَاعِ
u'فُرُوضٌ دِينٌ':Added, #2: 2	فُرُوضِ الْحَجِّ
u'فُرُوضٌ ركعة':Added, #1: 1	فُرُوضِ الدِّينِ
u'فُرُوضٌ رَكْعَةٌ':Added, #1: 1	فُرُوضِ الرَّكْعَةِ
u'فُرُوضٌ صَلاَةٌ':Added, #1: 1	فُرُوضِ الرَّكْعَةِ
u'فُرُوضٌ صَلاَةٌ':Added, #10: 10	فُرُوضِ الصَّلَاةِ
u'فُرُوضٌ صَلاَةٌ':Added, #1: 1	فُرُوضَ الصَّلَاةِ
u'فُرُوضٌ غَنَمٌ':Added, #2: 2	فُرُوضِ صَلَاةِ
u'فُرُوضٌ فَرِيقٌ':Added, #1: 1	فُرُوضَ الْغَنَمِ
u'فُرُوضٌ كَفَّارٌ':Added, #1: 1	فُرُوضَ الْفَرِيقَيْنِ
u'فُرُوضٌ كَفَّارَةٌ':Added, #1: 1	فُرُوضُ الْكَفَّارَةِ
u'فُرُوضٌ كِفَايَةٌ':Added, #1: 1	فُرُوضُ الْكَفَّارَةِ
u'فُرُوضٌ كِفَايَةٌ':Added, #1: 1	فُرُوضُ كِفَايَاتٍ
u'فُرُوضٌ كِفَايَةٌ':Added, #29: 29	فُرُوضِ الْكِفَايَاتِ
u'فُرُوضٌ كِفَايَةٌ':Added, #2: 2	فُرُوضُ الْكِفَايَةِ
u'فُرُوضٌ كِفَايَةٌ':Added, #3: 3	فُرُوضُ الْكِفَايَاتِ
u'فُرُوضٌ مَسْأَلَةٌ':Added, #42: 42	فُرُوضِ الْكِفَايَةِ
u'فُرُوضٌ نكاح':Added, #1: 1	فُرُوضُ الْمَسْأَلَةِ
u'فُرُوضٌ نِكَاحٌ':Added, #1: 1	فُرُوضِ النِّكَاحِ
u'فُرُوضٌ نهار':Added, #1: 1	فُرُوضِ النِّكَاحِ
u'فُرُوضٌ نَهَارٌ':Added, #1: 1	فُرُوضِ النَّهَارِ
u'فُرُوضٌ وُضُوءٌ':Added, #1: 1	فُرُوضِ النَّهَارِ
u'فُرُوضٌ وُضُوءٌ':Added, #1: 1	فُرُوضَ الْوُضُوءِ
u'فُرُوضٌ وُضُوءٌ':Added, #1: 1	فُرُوضُ الْوُضُوءِ
u'فُرُوعٌ اِبْنٌ':Added, #3: 3	فُرُوضِ الْوُضُوءِ
u'فُرُوعٌ أَحْكَامٌ':Added, #7: 7	فُرُوعِ ابْنِ
u'فُرُوعٌ أخْلاقٌ':Added, #2: 2	فُرُوعِ الْأَحْكَامِ
u'فُرُوعٌ أَخْلاَقٌ':Added, #1: 1	فُرُوعِ الْأَخْلَاقِ
u'فُرُوعٌ إِسْلامٌ':Added, #1: 1	فُرُوعِ الْأَخْلَاقِ
u'فُرُوعٌ أصل':Added, #3: 3	فُرُوعِ الْإِسْلَامِ
u'فُرُوعٌ أًصْلٌ':Added, #1: 1	فُرُوعِ الْأَصْلِ
u'فُرُوعٌ أُصولٌ':Added, #1: 1	فُرُوعِ الْأَصْلِ
u'فُرُوعٌ أُصولٌ':Added, #1: 1	فُرُوعُ أُصُولٍ
u'فُرُوعٌ إضافَةٌ':Added, #1: 1	فُرُوعِ أُصُولِهِ
u'فُرُوعٌ أطايب':Added, #1: 1	فُرُوعِ الْإِضَافَةِ
u'فُرُوعٌ أَعْمَالٌ':Added, #1: 1	فُرُوعَ الْأَطَايِبِ
u'فُرُوعٌ أَوَّلُ':Added, #1: 1	فُرُوعِ الْأَعْمَالِ
u'فُرُوعٌ بَابٌ':Added, #3: 3	فُرُوعَ الْأَوَّلِ
u'فُرُوعٌ بَابٌ':Added, #1: 1	فُرُوعِ الْبَابَيْنِ
u'فُرُوعٌ تَأْخِيرٌ':Added, #1: 1	فُرُوعُ بَابِ
u'فُرُوعٌ تَحْسِين':Added, #1: 1	فُرُوعِ تَأْخِيرِ
u'فُرُوعٌ تَعْلِيقٌ':Added, #1: 1	فُرُوعُ التَّحْسِينِ
u'فُرُوعٌ تَعْلِيقٌ':Added, #1: 1	فُرُوعِ التَّعْلِيقِ
u'فُرُوعٌ تَنَازُعٌ':Added, #1: 1	فُرُوعِ تَعْلِيقِهِ
u'فُرُوعٌ جِدال':Added, #1: 1	فُرُوعِ التَّنَازُعِ
u'فُرُوعٌ جهاد':Added, #1: 1	فُرُوعِ الْجِدَالِ
u'فُرُوعٌ جِهَادٌ':Added, #1: 1	فُرُوعِ الْجِهَادِ
u'فُرُوعٌ جهاز':Added, #1: 1	فُرُوعِ الْجِهَادِ
u'فُرُوعٌ جِهَازٌ':Added, #1: 1	فُرُوعِ الْجِهَازِ
u'فُرُوعٌ جَوَازٌ':Added, #1: 1	فُرُوعِ الْجِهَازِ
u'فُرُوعٌ حاكِمٌ':Added, #1: 1	فُرُوعُ جَوَازِ
u'فُرُوعٌ حَقِيقٌ':Added, #1: 1	فُرُوعِ الْحَاكِمِ
u'فُرُوعٌ حَقِيقَةٌ':Added, #1: 1	فُرُوعِ الْحَقِيقَةِ
u'فُرُوعٌ خلق':Added, #1: 1	فُرُوعِ الْحَقِيقَةِ
u'فُرُوعٌ خَلْقٌ':Added, #1: 1	فُرُوعِ خَلْقِ
u'فُرُوعٌ خَلْوَةٌ':Added, #1: 1	فُرُوعِ خَلْقِ
u'فُرُوعٌ دَوْحٌ':Added, #1: 1	فُرُوعِ الْخَلْوَةِ
u'فُرُوعٌ دِينٌ':Added, #1: 1	فُرُوعَ دَوْحِ
u'فُرُوعٌ زِيادَةٌ':Added, #3: 3	فُرُوعِ الدِّينِ
u'فُرُوعٌ شافِع':Added, #1: 1	فُرُوعِ الزِّيَادَةِ
u'فُرُوعٌ شافِعِيّ':Added, #3: 3	فُرُوعِ الشَّافِعِيَّةِ
u'فُرُوعٌ شَرْعٌ':Added, #3: 3	فُرُوعِ الشَّافِعِيَّةِ
u'فُرُوعٌ شَرِيعَةٌ':Added, #1: 1	فُرُوعِ الشَّرْعِ
u'فُرُوعٌ شَرِيعَةٌ':Added, #2: 2	فُرُوعُ الشَّرِيعَةِ
u'فُرُوعٌ شَرِيعَةٌ':Added, #3: 3	فُرُوعَ الشَّرِيعَةِ
u'فُرُوعٌ شَكٌّ':Added, #8: 8	فُرُوعِ الشَّرِيعَةِ
u'فُرُوعٌ ضَمَانٌ':Added, #1: 1	فُرُوع الشَّكِّ
u'فُرُوعٌ عَتِيقٌ':Added, #1: 1	فُرُوعِ الضَّمَانِ
u'فُرُوعٌ عَدَمٌ':Added, #1: 1	فُرُوعِ الْعَتِيقِ
u'فُرُوعٌ عِلَّةٌ':Added, #2: 2	فُرُوعِ عَدَمِ
u'فُرُوعٌ عِلَّةٌ':Added, #1: 1	فُرُوعَ الْعِلَّةِ
u'فُرُوعٌ عِلَّةٌ':Added, #1: 1	فُرُوعُ عِلَّةٍ
u'فُرُوعٌ عُمُومٌ':Added, #1: 1	فُرُوعِ عِلَّتِهِ
u'فُرُوعٌ فَجْرٌ':Added, #1: 1	فُرُوعِ عُمُومِ
u'فُرُوعٌ فَرِيقٌ':Added, #1: 1	فُرُوعِ الْفَجْرِ
u'فُرُوعٌ فَسْخٌ':Added, #1: 1	فُرُوعِ الْفَرِيقَيْنِ
u'فُرُوعٌ فِقْهٌ':Added, #1: 1	فُرُوعِ الْفَسْخِ
u'فُرُوعٌ فلان':Added, #10: 10	فُرُوعِ الْفِقْهِ
u'فُرُوعٌ قَاعِدٌ':Added, #3: 3	فُرُوعِ الشَّافِعِيَّةِ
u'فُرُوعٌ قَاعِدٌ':Added, #1: 1	فُرُوع الْقَاعِدَةِ
u'فُرُوعٌ قَدَرٌ':Added, #3: 3	فُرُوعِ الْقَاعِدَةِ
u'فُرُوعٌ قِسْمٌ':Added, #1: 1	فُرُوعِ الْقَدَرِ
u'فُرُوعٌ قَضَاءٌ':Added, #3: 3	فُرُوعِ الْقِسْمِ
u'فُرُوعٌ قول':Added, #2: 2	فُرُوعِ الْقَضَاءِ
u'فُرُوعٌ قَوْلٌ':Added, #1: 1	فُرُوعِ الْقَوْلِ
u'فُرُوعٌ قول':Added, #1: 1	فُرُوعِ الْقَوْلِ
u'فُرُوعٌ قَوْلٌ':Added, #1: 1	فُرُوعِ قَوْلِهِ
u'فُرُوعٌ لبن':Added, #1: 1	فُرُوعِ قَوْلِهِ
u'فُرُوعٌ لَبَنٌ':Added, #1: 1	فُرُوعِ اللَّبَنِ
u'فُرُوعٌ لُزُومٌ':Added, #1: 1	فُرُوعِ اللَّبَنِ
u'فُرُوعٌ مَذْهَبٌ':Added, #2: 2	فُرُوعِ لُزُومِ
u'فُرُوعٌ مَسْأَلَةٌ':Added, #1: 1	فُرُوعِ مَذْهَبِهِ
u'فُرُوعٌ مَسْأَلَةٌ':Added, #1: 1	فُرُوعُ الْمَسْأَلَةِ
u'فُرُوعٌ مَسْأَلَةٌ':Added, #2: 2	فُرُوعِ مَسْأَلَةِ
u'فُرُوعٌ مَسَائِلُ':Added, #8: 8	فُرُوعِ الْمَسْأَلَةِ
u'فُرُوعٌ مَعْلُومٌ':Added, #1: 1	فُرُوعِ مَسَائِلِ
u'فُرُوعٌ نَاسٌ':Added, #1: 1	فُرُوعِ مَعْلُومَاتِ
u'فُرُوعٌ نَفْسٌ':Added, #1: 1	فُرُوعُ النّاسِ
u'فُرُوعٌ نكاح':Added, #1: 1	فُرُوعِ نَفْسِ
u'فُرُوعٌ نِكَاحٌ':Added, #1: 1	فُرُوعِ النِّكَاحِ
u'فُرُوعٌ وَجْهٌ':Added, #1: 1	فُرُوعِ النِّكَاحِ
u'فُرُوعٌ وُجُوبٌ':Added, #2: 2	فُرُوعِ الْوَجْهَيْنِ
u'فُرُوقٌ شَيْخٌ':Added, #2: 2	فُرُوعِ وُجُوبِ
u'فُرُوقٌ عَبْدٌ':Added, #1: 1	فُرُوقِ الشَّيْخِ
u'فَرَّ يَوْمٌ':Predicate, #2: 2	فُرُوقِ عَبْدِ
u'فَزِعَ أهْلٌ':Subject, #1: 1	فَرَّ يَوْمَ
u'فَزَّعَ رَجُلٌ':Predicate, #2: 2	فَزِعَ أَهْلُ
u'فَزِعَ نَاسٌ':Subject, #1: 1	فَزَّعَ رَجُلاً
u'فَزَعٌ يَوْمٌ':Added, #5: 5	فَزِعَ النَّاسُ
u'فساد إجَارَةٌ':Added, #1: 1	فَزَعِ يَوْمِ
u'فَسَادٌ إجَارَةٌ':Added, #1: 1	فَسَادِ الْإِجَارَةِ
u'فساد إجَارَةٌ':Added, #1: 1	فَسَادِ الْإِجَارَةِ
u'فَسَادٌ إجَارَةٌ':Added, #2: 2	فَسَادُ إجَارَةِ
u'فساد إجَارَةٌ':Added, #2: 2	فَسَادُ إجَارَةِ
u'فَسَادٌ إجَارَةٌ':Added, #3: 3	فَسَادُ الْإِجَارَةِ
u'فساد إجَارَةٌ':Added, #3: 3	فَسَادُ الْإِجَارَةِ
u'فَسَادٌ إجَارَةٌ':Added, #5: 5	فَسَادَ الْإِجَارَةِ
u'فساد أَجْسَادٌ':Added, #5: 5	فَسَادَ الْإِجَارَةِ
u'فَسَادٌ أَجْسَادٌ':Added, #1: 1	فَسَادِ الْأَجْسَادِ
u'فساد أَجَلٌ':Added, #1: 1	فَسَادِ الْأَجْسَادِ
u'فَسَادٌ أَجَلٌ':Added, #1: 1	فَسَادَ الْأَجَلِ
u'فساد إِحْرَامٌ':Added, #1: 1	فَسَادَ الْأَجَلِ
u'فساد إِحْرَامٌ':Added, #1: 1	فَسَادَ الْإِحْرَامِ
u'فَسَادٌ إِحْرَامٌ':Added, #1: 1	فَسَادُ الْإِحْرَامِ
u'فَسَادٌ إِحْرَامٌ':Added, #1: 1	فَسَادَ الْإِحْرَامِ
u'فساد أَحْوالٌ':Added, #1: 1	فَسَادُ الْإِحْرَامِ
u'فساد أحْوَالٌ':Added, #1: 1	فَسَادِ أَحْوَالِ
u'فَسَادٌ أَحْوالٌ':Added, #1: 1	فَسَادِ أَحْوَالِ
u'فَسَادٌ أحْوَالٌ':Added, #1: 1	فَسَادِ أَحْوَالِ
u'فساد أخْبَارٌ':Added, #1: 1	فَسَادِ أَحْوَالِ
u'فساد أَخْبَارٌ':Added, #1: 1	فَسَادِ أَخْبَارِ
u'فَسَادٌ أخْبَارٌ':Added, #1: 1	فَسَادِ أَخْبَارِ
u'فَسَادٌ أَخْبَارٌ':Added, #1: 1	فَسَادِ أَخْبَارِ
u'فساد اِخْتِيَارٌ':Added, #1: 1	فَسَادِ أَخْبَارِ
u'فَسَادٌ اِخْتِيَارٌ':Added, #1: 1	فَسَادِ اخْتِيَارٍ
u'فساد اِخْتِيَارٌ':Added, #1: 1	فَسَادِ اخْتِيَارٍ
u'فَسَادٌ اِخْتِيَارٌ':Added, #1: 1	فَسَادِ اخْتِيَارِهِ
u'فساد أخْذٌ':Added, #1: 1	فَسَادِ اخْتِيَارِهِ
u'فَسَادٌ أخْذٌ':Added, #1: 1	فَسَادَ أَخْذِ
u'فساد أخْلاقٌ':Added, #1: 1	فَسَادَ أَخْذِ
u'فساد أَخْلاَقٌ':Added, #1: 1	فَسَادَ أَخْلَاقِهِ
u'فَسَادٌ أخْلاقٌ':Added, #1: 1	فَسَادَ أَخْلَاقِهِ
u'فَسَادٌ أَخْلاَقٌ':Added, #1: 1	فَسَادَ أَخْلَاقِهِ
u'فساد أَدَاءٌ':Added, #1: 1	فَسَادَ أَخْلَاقِهِ
u'فَسَادٌ أَدَاءٌ':Added, #2: 2	فَسَادِ الْأَدَاءِ
u'فساد أَدَاءٌ':Added, #2: 2	فَسَادِ الْأَدَاءِ
u'فَسَادٌ أَدَاءٌ':Added, #5: 5	فَسَادَ الْأَدَاءِ
u'فساد أرْضٌ':Added, #5: 5	فَسَادَ الْأَدَاءِ
u'فَسَادٌ أرْضٌ':Added, #1: 1	فَسَادُ الْأَرْضِ
u'فساد اِسْتِدْلاَلٌ':Added, #1: 1	فَسَادُ الْأَرْضِ
u'فَسَادٌ اِسْتِدْلاَلٌ':Added, #1: 1	فَسَادُ اسْتِدْلَالِ
u'فساد أصل':Added, #1: 1	فَسَادُ اسْتِدْلَالِ
u'فساد أًصْلٌ':Added, #1: 1	فَسَادُ الْأَصْلِ
u'فَسَادٌ أصل':Added, #1: 1	فَسَادُ الْأَصْلِ
u'فَسَادٌ أًصْلٌ':Added, #1: 1	فَسَادُ الْأَصْلِ
u'فساد أُصولٌ':Added, #1: 1	فَسَادُ الْأَصْلِ
u'فَسَادٌ أُصولٌ':Added, #1: 1	فَسَادُ أُصُولِ
u'فساد إِطْلاعٌ':Added, #1: 1	فَسَادُ أُصُولِ
u'فَسَادٌ إِطْلاعٌ':Added, #1: 1	فَسَادَ الْإِطْلَاعِ
u'فساد اِعْتِكافٌ':Added, #1: 1	فَسَادَ الْإِطْلَاعِ
u'فَسَادٌ اِعْتِكافٌ':Added, #1: 1	فَسَادُ اعْتِكَافِهِ
u'فساد إِفْرَازٌ':Added, #1: 1	فَسَادُ اعْتِكَافِهِ
u'فَسَادٌ إِفْرَازٌ':Added, #2: 2	فَسَادِ الْإِفْرَازِ
u'فساد إقالَةٌ':Added, #2: 2	فَسَادِ الْإِفْرَازِ
u'فَسَادٌ إقالَةٌ':Added, #1: 1	فَسَادُ الْإِقَالَةِ
u'فساد اِقْتِداءٌ':Added, #1: 1	فَسَادُ الْإِقَالَةِ
u'فَسَادٌ اِقْتِداءٌ':Added, #1: 1	فَسَادُ اقْتِدَاءِ
u'فساد اِقْتِضَاءٌ':Added, #1: 1	فَسَادُ اقْتِدَاءِ
u'فَسَادٌ اِقْتِضَاءٌ':Added, #1: 1	فَسَادَ اقْتِضَاءِ
u'فساد إقْرَارٌ':Added, #1: 1	فَسَادَ اقْتِضَاءِ
u'فساد إقْرَارٌ':Added, #1: 1	فَسَادُ الْإِقْرَارِ
u'فَسَادٌ إقْرَارٌ':Added, #1: 1	فَسَادِ الْإِقْرَارِ
u'فَسَادٌ إقْرَارٌ':Added, #1: 1	فَسَادُ الْإِقْرَارِ
u'فساد إلْغَاءٌ':Added, #1: 1	فَسَادِ الْإِقْرَارِ
u'فَسَادٌ إلْغَاءٌ':Added, #1: 1	فَسَادُ الْإِلْغَاءِ
u'فساد أَمْرٌ':Added, #1: 1	فَسَادُ الْإِلْغَاءِ
u'فَسَادٌ أَمْرٌ':Added, #1: 1	فَسَادَ أَمْرِهِ
u'فساد أهْلٌ':Added, #1: 1	فَسَادَ أَمْرِهِ
u'فَسَادٌ أهْلٌ':Added, #1: 1	فَسَادُ أَهْلِهِ
u'فساد أَهْوَاءٌ':Added, #1: 1	فَسَادُ أَهْلِهِ
u'فَسَادٌ أَهْوَاءٌ':Added, #1: 1	فَسَادَ الأَهْوَاءِ
u'فساد أَوَّلُ':Added, #1: 1	فَسَادَ الأَهْوَاءِ
u'فَسَادٌ أَوَّلُ':Added, #1: 1	فَسَادُ الْأَوَّلِ
u'فساد أَوَّلُ':Added, #1: 1	فَسَادُ الْأَوَّلِ
u'فَسَادٌ أَوَّلُ':Added, #1: 1	فَسَادُ الْأَوَّلَيْنِ
u'فساد بَاطن':Added, #1: 1	فَسَادُ الْأَوَّلَيْنِ
u'فساد باطِنٌ':Added, #2: 2	فَسَادِ الْبَاطِنِ
u'فَسَادٌ بَاطن':Added, #2: 2	فَسَادِ الْبَاطِنِ
u'فَسَادٌ باطِنٌ':Added, #2: 2	فَسَادِ الْبَاطِنِ
u'فساد بَاطن':Added, #2: 2	فَسَادِ الْبَاطِنِ
u'فساد باطِنٌ':Added, #3: 3	فَسَادُ الْبَاطِنِ
u'فَسَادٌ بَاطن':Added, #3: 3	فَسَادُ الْبَاطِنِ
u'فَسَادٌ باطِنٌ':Added, #3: 3	فَسَادُ الْبَاطِنِ
u'فساد بَراءةٌ':Added, #3: 3	فَسَادُ الْبَاطِنِ
u'فَسَادٌ بَراءةٌ':Added, #2: 2	فَسَادَ الْبَرَاءَةِ
u'فساد بَعْضٌ':Added, #2: 2	فَسَادَ الْبَرَاءَةِ
u'فَسَادٌ بَعْضٌ':Added, #1: 1	فَسَادُ بَعْضِ
u'فساد بَعْضٌ':Added, #1: 1	فَسَادُ بَعْضِ
u'فساد بَعْضٌ':Added, #2: 2	فَسَادَ الْبَعْضِ
u'فَسَادٌ بَعْضٌ':Added, #2: 2	فَسَادِ الْبَعْضِ
u'فَسَادٌ بَعْضٌ':Added, #2: 2	فَسَادَ الْبَعْضِ
u'فساد بَعْضٌ':Added, #2: 2	فَسَادِ الْبَعْضِ
u'فَسَادٌ بَعْضٌ':Added, #2: 2	فَسَادَ بَعْضِ
u'فساد بَيْتٌ':Added, #2: 2	فَسَادَ بَعْضِ
u'فَسَادٌ بَيْتٌ':Added, #1: 1	فَسَادِ بَيْتِ
u'فساد بَيْعٌ':Added, #1: 1	فَسَادِ بَيْتِ
u'فَسَادٌ بَيْعٌ':Added, #13: 13	فَسَادُ الْبَيْعِ
u'فساد بَيْعٌ':Added, #13: 13	فَسَادُ الْبَيْعِ
u'فَسَادٌ بَيْعٌ':Added, #18: 18	فَسَادَ الْبَيْعِ
u'فساد بَيْعٌ':Added, #18: 18	فَسَادَ الْبَيْعِ
u'فَسَادٌ بَيْعٌ':Added, #19: 19	فَسَادِ الْبَيْعِ
u'فساد بَيْعٌ':Added, #19: 19	فَسَادِ الْبَيْعِ
u'فساد بَيْعٌ':Added, #1: 1	فَسَادَ بَيْعِ
u'فساد بَيْعٌ':Added, #1: 1	فَسَادُ بَيْعِ
u'فَسَادٌ بَيْعٌ':Added, #1: 1	فَسَادِ بَيْعِ
u'فَسَادٌ بَيْعٌ':Added, #1: 1	فَسَادَ بَيْعِ
u'فَسَادٌ بَيْعٌ':Added, #1: 1	فَسَادُ بَيْعِ
u'فساد تَخْصِيصٌ':Added, #1: 1	فَسَادِ بَيْعِ
u'فَسَادٌ تَخْصِيصٌ':Added, #1: 1	فَسَادِ تَخْصِيصِ
u'فساد تَسْمِيَة':Added, #1: 1	فَسَادِ تَخْصِيصِ
u'فَسَادٌ تَسْمِيَة':Added, #10: 10	فَسَادِ التَّسْمِيَةِ
u'فساد تَسْمِيَة':Added, #10: 10	فَسَادِ التَّسْمِيَةِ
u'فَسَادٌ تَسْمِيَة':Added, #1: 1	فَسَادُ التَّسْمِيَةِ
u'فساد تَسْمِيَة':Added, #1: 1	فَسَادُ التَّسْمِيَةِ
u'فساد تَسْمِيَة':Added, #1: 1	فَسَادُ تَسْمِيَةٍ
u'فَسَادٌ تَسْمِيَة':Added, #1: 1	فَسَادِ تَسْمِيَةٍ
u'فَسَادٌ تَسْمِيَة':Added, #1: 1	فَسَادُ تَسْمِيَةٍ
u'فساد تَسْمِيَة':Added, #1: 1	فَسَادِ تَسْمِيَةٍ
u'فَسَادٌ تَسْمِيَة':Added, #2: 2	فَسَادَ التَّسْمِيَةِ
u'فساد تَصَوُّرٌ':Added, #2: 2	فَسَادَ التَّسْمِيَةِ
u'فَسَادٌ تَصَوُّرٌ':Added, #1: 1	فَسَادِ تَصَوُّرٍ
u'فساد تَصَوُّرٌ':Added, #1: 1	فَسَادِ تَصَوُّرٍ
u'فَسَادٌ تَصَوُّرٌ':Added, #2: 2	فَسَادِ التَّصَوُّرِ
u'فساد تَعْلِيلٌ':Added, #2: 2	فَسَادِ التَّصَوُّرِ
u'فَسَادٌ تَعْلِيلٌ':Added, #1: 1	فَسَادِ تَعْلِيلِ
u'فساد تَعْلِيمٌ':Added, #1: 1	فَسَادِ تَعْلِيلِ
u'فَسَادٌ تَعْلِيمٌ':Added, #1: 1	فَسَادَ تَعْلِيمِهِ
u'فساد تَقْليدٌ':Added, #1: 1	فَسَادَ تَعْلِيمِهِ
u'فساد تَقْليد':Added, #1: 1	فَسَادَ التَّقْلِيدِ
u'فَسَادٌ تَقْليدٌ':Added, #1: 1	فَسَادَ التَّقْلِيدِ
u'فَسَادٌ تَقْليد':Added, #1: 1	فَسَادَ التَّقْلِيدِ
u'فساد تَقْليدٌ':Added, #1: 1	فَسَادَ التَّقْلِيدِ
u'فساد تَقْليد':Added, #4: 4	فَسَادِ التَّقْلِيدِ
u'فَسَادٌ تَقْليدٌ':Added, #4: 4	فَسَادِ التَّقْلِيدِ
u'فَسَادٌ تَقْليد':Added, #4: 4	فَسَادِ التَّقْلِيدِ
u'فساد تَقْيِيد':Added, #4: 4	فَسَادِ التَّقْلِيدِ
u'فَسَادٌ تَقْيِيد':Added, #1: 1	فَسَادُ التَّقْيِيدِ
u'فساد تَنْفِيذٌ':Added, #1: 1	فَسَادُ التَّقْيِيدِ
u'فَسَادٌ تَنْفِيذٌ':Added, #1: 1	فَسَادُ التَّنْفِيذِ
u'فساد تَوْلِيَةٌ':Added, #1: 1	فَسَادُ التَّنْفِيذِ
u'فَسَادٌ تَوْلِيَةٌ':Added, #1: 1	فَسَادَ تَوْلِيَتِهِ
u'فساد تَيَمُّمٌ':Added, #1: 1	فَسَادَ تَوْلِيَتِهِ
u'فَسَادٌ تَيَمُّمٌ':Added, #2: 2	فَسَادُ التَّيَمُّمِ
u'فساد جَدْب':Added, #2: 2	فَسَادُ التَّيَمُّمِ
u'فَسَادٌ جَدْب':Added, #1: 1	فَسَادُ الْجَدْبِ
u'فساد جمع':Added, #1: 1	فَسَادُ الْجَدْبِ
u'فَسَادٌ جمع':Added, #1: 1	فَسَادُ الْجَمْعِ
u'فساد جَمْعٌ':Added, #1: 1	فَسَادُ الْجَمْعِ
u'فَسَادٌ جَمْعٌ':Added, #1: 1	فَسَادُ الْجَمْعِ
u'فساد جِهَةٌ':Added, #1: 1	فَسَادُ الْجَمْعِ
u'فَسَادٌ جِهَةٌ':Added, #1: 1	فَسَادَ جِهَةِ
u'فساد جَوْهَرٌ':Added, #1: 1	فَسَادَ جِهَةِ
u'فَسَادٌ جَوْهَرٌ':Added, #2: 2	فَسَادُ جَوْهَرِ
u'فساد حالٌ':Added, #2: 2	فَسَادُ جَوْهَرِ
u'فَسَادٌ حالٌ':Added, #1: 1	فَسَادِ حَالٍ
u'فساد حَجٌّ':Added, #1: 1	فَسَادِ حَالٍ
u'فَسَادٌ حَجٌّ':Added, #2: 2	فَسَادَ الْحَجِّ
u'فساد حَجٌّ':Added, #2: 2	فَسَادَ الْحَجِّ
u'فَسَادٌ حَجٌّ':Added, #4: 4	فَسَادُ الْحَجِّ
u'فساد حُكَّامٌ':Added, #4: 4	فَسَادُ الْحَجِّ
u'فَسَادٌ حُكَّامٌ':Added, #1: 1	فَسَادِ الْحُكَّامِ
u'فساد حُكْمٌ':Added, #1: 1	فَسَادِ الْحُكَّامِ
u'فَسَادٌ حُكْمٌ':Added, #1: 1	فَسَادُ الْحُكْمِ
u'فساد حُكْمٌ':Added, #1: 1	فَسَادُ الْحُكْمِ
u'فَسَادٌ حُكْمٌ':Added, #1: 1	فَسَادُ حُكْمِهِ
u'فساد حَوَالَةٌ':Added, #1: 1	فَسَادُ حُكْمِهِ
u'فَسَادٌ حَوَالَةٌ':Added, #2: 2	فَسَادِ الْحَوَالَةِ
u'فساد حَيْضٌ':Added, #2: 2	فَسَادِ الْحَوَالَةِ
u'فَسَادٌ حَيْضٌ':Added, #1: 1	فَسَادِ حَيْضٍ
u'فساد خُفٌّ':Added, #1: 1	فَسَادِ حَيْضٍ
u'فَسَادٌ خُفٌّ':Added, #1: 1	فَسَادِ الْخُفِّ
u'فساد خُلْعٌ':Added, #1: 1	فَسَادِ الْخُفِّ
u'فَسَادٌ خُلْعٌ':Added, #3: 3	فَسَادُ الْخُلْعِ
u'فساد خلق':Added, #3: 3	فَسَادُ الْخُلْعِ
u'فساد خلق':Added, #1: 1	فَسَادَ الْخَلْقِ
u'فَسَادٌ خلق':Added, #1: 1	فَسَادُ الْخَلْقِ
u'فَسَادٌ خلق':Added, #1: 1	فَسَادَ الْخَلْقِ
u'فساد خَلْقٌ':Added, #1: 1	فَسَادُ الْخَلْقِ
u'فساد خَلْقٌ':Added, #1: 1	فَسَادَ الْخَلْقِ
u'فَسَادٌ خَلْقٌ':Added, #1: 1	فَسَادُ الْخَلْقِ
u'فَسَادٌ خَلْقٌ':Added, #1: 1	فَسَادَ الْخَلْقِ
u'فساد دَمٌ':Added, #1: 1	فَسَادُ الْخَلْقِ
u'فَسَادٌ دَمٌ':Added, #1: 1	فَسَادَ الدَّمِ
u'فساد دَوْرٌ':Added, #1: 1	فَسَادَ الدَّمِ
u'فَسَادٌ دَوْرٌ':Added, #5: 5	فَسَادِ الدَّوْرِ
u'فساد دِينٌ':Added, #5: 5	فَسَادِ الدَّوْرِ
u'فَسَادٌ دِينٌ':Added, #1: 1	فَسَادِ الدِّينِ
u'فساد دِينٌ':Added, #1: 1	فَسَادِ الدِّينِ
u'فَسَادٌ دِينٌ':Added, #2: 2	فَسَادُ الدِّينِ
u'فساد رحم':Added, #2: 2	فَسَادُ الدِّينِ
u'فَسَادٌ رحم':Added, #2: 2	فَسَادِ الرَّحِمِ
u'فساد رَحِمٌ':Added, #2: 2	فَسَادِ الرَّحِمِ
u'فَسَادٌ رَحِمٌ':Added, #2: 2	فَسَادِ الرَّحِمِ
u'فساد رَدٌّ':Added, #2: 2	فَسَادِ الرَّحِمِ
u'فَسَادٌ رَدٌّ':Added, #3: 3	فَسَادِ الرَّدِّ
u'فساد رِقٌّ':Added, #3: 3	فَسَادِ الرَّدِّ
u'فَسَادٌ رِقٌّ':Added, #1: 1	فَسَادُ رِقِّ
u'فساد رُكْنٌ':Added, #1: 1	فَسَادُ رِقِّ
u'فساد رُكْن':Added, #1: 1	فَسَادِ الرُّكْنِ
u'فَسَادٌ رُكْنٌ':Added, #1: 1	فَسَادِ الرُّكْنِ
u'فَسَادٌ رُكْن':Added, #1: 1	فَسَادِ الرُّكْنِ
u'فساد رَهْنٌ':Added, #1: 1	فَسَادِ الرُّكْنِ
u'فساد رَهْنٌ':Added, #1: 1	فَسَادُ الرَّهْنِ
u'فَسَادٌ رَهْنٌ':Added, #1: 1	فَسَادِ الرَّهْنِ
u'فَسَادٌ رَهْنٌ':Added, #1: 1	فَسَادُ الرَّهْنِ
u'فساد رَهْنٌ':Added, #1: 1	فَسَادِ الرَّهْنِ
u'فَسَادٌ رَهْنٌ':Added, #1: 1	فَسَادِ رَهْنِهِ
u'فساد زَمانٌ':Added, #1: 1	فَسَادِ رَهْنِهِ
u'فَسَادٌ زَمانٌ':Added, #12: 12	فَسَادِ الزَّمَانِ
u'فساد زَوْجَةٌ':Added, #12: 12	فَسَادِ الزَّمَانِ
u'فَسَادٌ زَوْجَةٌ':Added, #1: 1	فَسَادَ زَوْجَةِ
u'فساد سَبَبٌ':Added, #1: 1	فَسَادَ زَوْجَةِ
u'فَسَادٌ سَبَبٌ':Added, #1: 1	فَسَادِ السَّبَبِ
u'فساد سَبَبٌ':Added, #1: 1	فَسَادِ السَّبَبِ
u'فَسَادٌ سَبَبٌ':Added, #1: 1	فَسَادَ سَبَبِ
u'فساد سَبَبٌ':Added, #1: 1	فَسَادَ سَبَبِ
u'فَسَادٌ سَبَبٌ':Added, #3: 3	فَسَادَ السَّبَبِ
u'فساد سجدة':Added, #3: 3	فَسَادَ السَّبَبِ
u'فَسَادٌ سجدة':Added, #1: 1	فَسَادُ سَجْدَتِهِ
u'فساد سَجْدَةٌ':Added, #1: 1	فَسَادُ سَجْدَتِهِ
u'فَسَادٌ سَجْدَةٌ':Added, #1: 1	فَسَادُ سَجْدَتِهِ
u'فساد سِجِلٌّ':Added, #1: 1	فَسَادُ سَجْدَتِهِ
u'فَسَادٌ سِجِلٌّ':Added, #1: 1	فَسَادَ السِّجِلِّ
u'فساد شَرْطٌ':Added, #1: 1	فَسَادَ السِّجِلِّ
u'فساد شَرْطٌ':Added, #1: 1	فَسَادَ الشَّرْطِ
u'فَسَادٌ شَرْطٌ':Added, #1: 1	فَسَادُ الشَّرْطِ
u'فَسَادٌ شَرْطٌ':Added, #1: 1	فَسَادَ الشَّرْطِ
u'فساد شَرْطٌ':Added, #1: 1	فَسَادُ الشَّرْطِ
u'فَسَادٌ شَرْطٌ':Added, #2: 2	فَسَادَ شَرْطِ
u'فساد شَرْطٌ':Added, #2: 2	فَسَادَ شَرْطِ
u'فَسَادٌ شَرْطٌ':Added, #5: 5	فَسَادِ الشَّرْطِ
u'فساد شركة':Added, #5: 5	فَسَادِ الشَّرْطِ
u'فَسَادٌ شركة':Added, #1: 1	فَسَادِ الشِّرْكَةِ
u'فساد شِرْكَةٌ':Added, #1: 1	فَسَادِ الشِّرْكَةِ
u'فَسَادٌ شِرْكَةٌ':Added, #1: 1	فَسَادِ الشِّرْكَةِ
u'فساد شركة':Added, #1: 1	فَسَادِ الشِّرْكَةِ
u'فَسَادٌ شركة':Added, #2: 2	فَسَادِ الشَّرِكَةِ
u'فساد شَرِكَةٌ':Added, #2: 2	فَسَادِ الشَّرِكَةِ
u'فَسَادٌ شَرِكَةٌ':Added, #2: 2	فَسَادِ الشَّرِكَةِ
u'فساد شركة':Added, #2: 2	فَسَادِ الشَّرِكَةِ
u'فَسَادٌ شركة':Added, #3: 3	فَسَادُ الشَّرِكَةِ
u'فساد شَرِكَةٌ':Added, #3: 3	فَسَادُ الشَّرِكَةِ
u'فَسَادٌ شَرِكَةٌ':Added, #3: 3	فَسَادُ الشَّرِكَةِ
u'فساد شَفْعٌ':Added, #3: 3	فَسَادُ الشَّرِكَةِ
u'فَسَادٌ شَفْعٌ':Added, #1: 1	فَسَادُ الشَّفْعِ
u'فساد شَفْعٌ':Added, #1: 1	فَسَادُ الشَّفْعِ
u'فَسَادٌ شَفْعٌ':Added, #8: 8	فَسَادَ الشَّفْعِ
u'فساد شَيْءٌ':Added, #8: 8	فَسَادَ الشَّفْعِ
u'فَسَادٌ شَيْءٌ':Added, #1: 1	فَسَادَ الشَّيْءِ
u'فساد شَيْءٌ':Added, #1: 1	فَسَادَ الشَّيْءِ
u'فَسَادٌ شَيْءٌ':Added, #1: 1	فَسَادِ شَيْءٍ
u'فساد شَيْءٌ':Added, #1: 1	فَسَادِ شَيْءٍ
u'فَسَادٌ شَيْءٌ':Added, #2: 2	فَسَادِ الشَّيْءِ
u'فساد شَيْطَانٌ':Added, #2: 2	فَسَادِ الشَّيْءِ
u'فَسَادٌ شَيْطَانٌ':Added, #1: 1	فَسَادِ الشَّيْطَانِ
u'فساد صَالِحٌ':Added, #1: 1	فَسَادِ الشَّيْطَانِ
u'فساد صَالِح':Added, #1: 1	فَسَادُ صَالِحٍ
u'فَسَادٌ صَالِحٌ':Added, #1: 1	فَسَادُ صَالِحٍ
u'فَسَادٌ صَالِح':Added, #1: 1	فَسَادُ صَالِحٍ
u'فساد صُبْحٌ':Added, #1: 1	فَسَادُ صَالِحٍ
u'فَسَادٌ صُبْحٌ':Added, #3: 3	فَسَادِ الصُّبْحِ
u'فساد صداق':Added, #3: 3	فَسَادِ الصُّبْحِ
u'فَسَادٌ صداق':Added, #3: 3	فَسَادِ الصَّدَاقِ
u'فساد صَدَاقٌ':Added, #3: 3	فَسَادِ الصَّدَاقِ
u'فَسَادٌ صَدَاقٌ':Added, #3: 3	فَسَادِ الصَّدَاقِ
u'فساد صَرْفٌ':Added, #3: 3	فَسَادِ الصَّدَاقِ
u'فساد صَرْفٌ':Added, #1: 1	فَسَادَ الصَّرْفِ
u'فساد صَرْف':Added, #1: 1	فَسَادُ الصَّرْفِ
u'فساد صَرْف':Added, #1: 1	فَسَادَ الصَّرْفِ
u'فَسَادٌ صَرْفٌ':Added, #1: 1	فَسَادُ الصَّرْفِ
u'فَسَادٌ صَرْفٌ':Added, #1: 1	فَسَادَ الصَّرْفِ
u'فَسَادٌ صَرْف':Added, #1: 1	فَسَادُ الصَّرْفِ
u'فَسَادٌ صَرْف':Added, #1: 1	فَسَادَ الصَّرْفِ
u'فساد صَرْفٌ':Added, #1: 1	فَسَادُ الصَّرْفِ
u'فساد صَرْف':Added, #2: 2	فَسَادِ الصَّرْفِ
u'فَسَادٌ صَرْفٌ':Added, #2: 2	فَسَادِ الصَّرْفِ
u'فَسَادٌ صَرْف':Added, #2: 2	فَسَادِ الصَّرْفِ
u'فساد صَلاَةٌ':Added, #2: 2	فَسَادِ الصَّرْفِ
u'فَسَادٌ صَلاَةٌ':Added, #15: 15	فَسَادَ صَلَاةِ
u'فساد صَلاَةٌ':Added, #15: 15	فَسَادَ صَلَاةِ
u'فَسَادٌ صَلاَةٌ':Added, #16: 16	فَسَادَ الصَّلَاةِ
u'فساد صَلاَةٌ':Added, #16: 16	فَسَادَ الصَّلَاةِ
u'فَسَادٌ صَلاَةٌ':Added, #1: 1	فَسَاد صَلَاتِهِ
u'فساد صَلاَةٌ':Added, #1: 1	فَسَاد صَلَاتِهِ
u'فَسَادٌ صَلاَةٌ':Added, #2: 2	فَسَادَ صَلَاةٍ
u'فساد صَلاَةٌ':Added, #2: 2	فَسَادَ صَلَاةٍ
u'فَسَادٌ صَلاَةٌ':Added, #6: 6	فَسَادِ صَلَاةِ
u'فساد صَلاَةٌ':Added, #6: 6	فَسَادِ صَلَاةِ
u'فَسَادٌ صَلاَةٌ':Added, #6: 6	فَسَادُ صَلَاتِهِ
u'فساد صَلاَةٌ':Added, #6: 6	فَسَادُ صَلَاتِهِ
u'فَسَادٌ صَلاَةٌ':Added, #7: 7	فَسَادَ صَلَاتِهِ
u'فساد صَلاَةٌ':Added, #7: 7	فَسَادَ صَلَاتِهِ
u'فَسَادٌ صَلاَةٌ':Added, #8: 8	فَسَادُ الصَّلَاةِ
u'فساد صَلاَةٌ':Added, #8: 8	فَسَادُ الصَّلَاةِ
u'فَسَادٌ صَلاَةٌ':Added, #9: 9	فَسَادِ الصَّلَاةِ
u'فساد صَلاَةٌ':Added, #9: 9	فَسَادِ الصَّلَاةِ
u'فَسَادٌ صَلاَةٌ':Added, #9: 9	فَسَادُ صَلَاةِ
u'فساد صَلاَةٌ':Added, #9: 9	فَسَادُ صَلَاةِ
u'فَسَادٌ صَلاَةٌ':Added, #9: 9	فَسَادِ صَلَاتِهِ
u'فساد صلح':Added, #9: 9	فَسَادِ صَلَاتِهِ
u'فَسَادٌ صلح':Added, #1: 1	فَسَاد الصُّلْحِ
u'فساد صُلْحٌ':Added, #1: 1	فَسَاد الصُّلْحِ
u'فَسَادٌ صُلْحٌ':Added, #1: 1	فَسَاد الصُّلْحِ
u'فساد صلح':Added, #1: 1	فَسَاد الصُّلْحِ
u'فَسَادٌ صلح':Added, #2: 2	فَسَادِ الصُّلْحِ
u'فساد صُلْحٌ':Added, #2: 2	فَسَادِ الصُّلْحِ
u'فَسَادٌ صُلْحٌ':Added, #2: 2	فَسَادِ الصُّلْحِ
u'فساد صلح':Added, #2: 2	فَسَادِ الصُّلْحِ
u'فَسَادٌ صلح':Added, #4: 4	فَسَادَ الصُّلْحِ
u'فساد صُلْحٌ':Added, #4: 4	فَسَادَ الصُّلْحِ
u'فَسَادٌ صُلْحٌ':Added, #4: 4	فَسَادَ الصُّلْحِ
u'فساد صُورَةٌ':Added, #4: 4	فَسَادَ الصُّلْحِ
u'فَسَادٌ صُورَةٌ':Added, #1: 1	فَسَادُ الصُّورَةِ
u'فساد صَوْمٌ':Added, #1: 1	فَسَادُ الصُّورَةِ
u'فساد صَوْمٌ':Added, #1: 1	فَسَادُ صَوْمِ
u'فَسَادٌ صَوْمٌ':Added, #1: 1	فَسَادِ صَوْمِ
u'فَسَادٌ صَوْمٌ':Added, #1: 1	فَسَادُ صَوْمِ
u'فساد صَوْمٌ':Added, #1: 1	فَسَادِ صَوْمِ
u'فَسَادٌ صَوْمٌ':Added, #1: 1	فَسَادَ صَوْمِهِ
u'فساد صَوْمٌ':Added, #1: 1	فَسَادَ صَوْمِهِ
u'فساد صَوْمٌ':Added, #2: 2	فَسَادُ صَوْمِهِ
u'فَسَادٌ صَوْمٌ':Added, #2: 2	فَسَادِ صَوْمِهِ
u'فَسَادٌ صَوْمٌ':Added, #2: 2	فَسَادُ صَوْمِهِ
u'فساد صَوْمٌ':Added, #2: 2	فَسَادِ صَوْمِهِ
u'فَسَادٌ صَوْمٌ':Added, #6: 6	فَسَادِ الصَّوْمِ
u'فساد صَوْمٌ':Added, #6: 6	فَسَادِ الصَّوْمِ
u'فَسَادٌ صَوْمٌ':Added, #7: 7	فَسَادُ الصَّوْمِ
u'فساد صِيغَةٌ':Added, #7: 7	فَسَادُ الصَّوْمِ
u'فَسَادٌ صِيغَةٌ':Added, #1: 1	فَسَادُ الصِّيغَةِ
u'فساد ضِدٌّ':Added, #1: 1	فَسَادُ الصِّيغَةِ
u'فَسَادٌ ضِدٌّ':Added, #1: 1	فَسَادِ ضِدِّهِ
u'فساد طَبْعٌ':Added, #1: 1	فَسَادِ ضِدِّهِ
u'فَسَادٌ طَبْعٌ':Added, #1: 1	فَسَادِ الطَّبْعِ
u'فساد طَرْدٌ':Added, #1: 1	فَسَادِ الطَّبْعِ
u'فَسَادٌ طَرْدٌ':Added, #1: 1	فَسَادِ الطَّرْدِ
u'فساد طعام':Added, #1: 1	فَسَادِ الطَّرْدِ
u'فَسَادٌ طعام':Added, #2: 2	فَسَادِ الطَّعَامِ
u'فساد طَعَامٌ':Added, #2: 2	فَسَادِ الطَّعَامِ
u'فَسَادٌ طَعَامٌ':Added, #2: 2	فَسَادِ الطَّعَامِ
u'فساد طَوِيَّةٌ':Added, #2: 2	فَسَادِ الطَّعَامِ
u'فَسَادٌ طَوِيَّةٌ':Added, #1: 1	فَسَادِ الطَّوِيَّةِ
u'فساد ظاهِرٌ':Added, #1: 1	فَسَادِ الطَّوِيَّةِ
u'فَسَادٌ ظاهِرٌ':Added, #1: 1	فَسَادُ الظَّاهِرِ
u'فساد ظَنٌّ':Added, #1: 1	فَسَادُ الظَّاهِرِ
u'فَسَادٌ ظَنٌّ':Added, #1: 1	فَسَادِ الظَّنِّ
u'فساد ظُهْرٌ':Added, #1: 1	فَسَادِ الظَّنِّ
u'فَسَادٌ ظُهْرٌ':Added, #1: 1	فَسَادُ الظُّهْرِ
u'فساد ظُهْرٌ':Added, #1: 1	فَسَادُ الظُّهْرِ
u'فَسَادٌ ظُهْرٌ':Added, #3: 3	فَسَادَ الظُّهْرِ
u'فساد عَاقِبٌ':Added, #3: 3	فَسَادَ الظُّهْرِ
u'فَسَادٌ عَاقِبٌ':Added, #1: 1	فَسَادِ عَاقِبَتِهِ
u'فساد عَاقِبَةٌ':Added, #1: 1	فَسَادِ عَاقِبَتِهِ
u'فَسَادٌ عَاقِبَةٌ':Added, #1: 1	فَسَادِ عَاقِبَتِهِ
u'فساد عَالَمٌ':Added, #1: 1	فَسَادِ عَاقِبَتِهِ
u'فساد عَالَمٌ':Added, #1: 1	فَسَادُ الْعَالَمِ
u'فَسَادٌ عَالَمٌ':Added, #1: 1	فَسَادِ الْعَالَمِ
u'فَسَادٌ عَالَمٌ':Added, #1: 1	فَسَادُ الْعَالَمِ
u'فساد عِبَارَةٌ':Added, #1: 1	فَسَادِ الْعَالَمِ
u'فَسَادٌ عِبَارَةٌ':Added, #1: 1	فَسَادَ عِبَارَتِهِ
u'فساد عزل':Added, #1: 1	فَسَادَ عِبَارَتِهِ
u'فَسَادٌ عزل':Added, #1: 1	فَسَادُ عَزْلِ
u'فساد عَسْكَرٌ':Added, #1: 1	فَسَادُ عَزْلِ
u'فَسَادٌ عَسْكَرٌ':Added, #1: 1	فَسَادُ عَسْكَرِهِ
u'فساد عِشَاءٌ':Added, #1: 1	فَسَادُ عَسْكَرِهِ
u'فَسَادٌ عِشَاءٌ':Added, #2: 2	فَسَادُ الْعِشَاءِ
u'فساد عَصْرٌ':Added, #2: 2	فَسَادُ الْعِشَاءِ
u'فَسَادٌ عَصْرٌ':Added, #1: 1	فَسَادُ الْعَصْرِ
u'فساد عَصْرٌ':Added, #1: 1	فَسَادُ الْعَصْرِ
u'فَسَادٌ عَصْرٌ':Added, #2: 2	فَسَادَ الْعَصْرِ
u'فساد عَظِيم':Added, #2: 2	فَسَادَ الْعَصْرِ
u'فَسَادٌ عَظِيم':Added, #1: 1	فَسَادٍ عَظِيمٍ
u'فساد عَقْدٌ':Added, #1: 1	فَسَادٍ عَظِيمٍ
u'فَسَادٌ عَقْدٌ':Added, #11: 11	فَسَادُ الْعَقْدِ
u'فساد عَقْدٌ':Added, #11: 11	فَسَادُ الْعَقْدِ
u'فساد عَقْدٌ':Added, #1: 1	فَسَادَ عَقْدِ
u'فساد عَقْدٌ':Added, #1: 1	فَسَادُ عَقْدٍ
u'فَسَادٌ عَقْدٌ':Added, #1: 1	فَسَادِ عَقْدِ
u'فَسَادٌ عَقْدٌ':Added, #1: 1	فَسَادَ عَقْدِ
u'فَسَادٌ عَقْدٌ':Added, #1: 1	فَسَادُ عَقْدٍ
u'فساد عَقْدٌ':Added, #1: 1	فَسَادِ عَقْدِ
u'فَسَادٌ عَقْدٌ':Added, #29: 29	فَسَادِ الْعَقْدِ
u'فساد عَقْدٌ':Added, #29: 29	فَسَادِ الْعَقْدِ
u'فَسَادٌ عَقْدٌ':Added, #31: 31	فَسَادَ الْعَقْدِ
u'فساد عَقْلٌ':Added, #31: 31	فَسَادَ الْعَقْدِ
u'فَسَادٌ عَقْلٌ':Added, #3: 3	فَسَادِ الْعَقْلِ
u'فساد عِلَّةٌ':Added, #3: 3	فَسَادِ الْعَقْلِ
u'فساد عِلَّةٌ':Added, #1: 1	فَسَادَ الْعِلَّةِ
u'فساد عِلَّةٌ':Added, #1: 1	فَسَادُ الْعِلَّةِ
u'فَسَادٌ عِلَّةٌ':Added, #1: 1	فَسَادِ الْعِلَّةِ
u'فَسَادٌ عِلَّةٌ':Added, #1: 1	فَسَادَ الْعِلَّةِ
u'فَسَادٌ عِلَّةٌ':Added, #1: 1	فَسَادُ الْعِلَّةِ
u'فساد عمرة':Added, #1: 1	فَسَادِ الْعِلَّةِ
u'فَسَادٌ عمرة':Added, #2: 2	فَسَادِ الْعُمْرَةِ
u'فساد عُمْرَةٌ':Added, #2: 2	فَسَادِ الْعُمْرَةِ
u'فَسَادٌ عُمْرَةٌ':Added, #2: 2	فَسَادِ الْعُمْرَةِ
u'فساد عَمَلٌ':Added, #2: 2	فَسَادِ الْعُمْرَةِ
u'فساد عَمَلٌ':Added, #1: 1	فَسَادَ الْعَمَلِ
u'فَسَادٌ عَمَلٌ':Added, #1: 1	فَسَادِ الْعَمَلِ
u'فَسَادٌ عَمَلٌ':Added, #1: 1	فَسَادَ الْعَمَلِ
u'فساد عِوَضٌ':Added, #1: 1	فَسَادِ الْعَمَلِ
u'فساد عِوَضٌ':Added, #1: 1	فَسَادَ الْعِوَضِ
u'فَسَادٌ عِوَضٌ':Added, #1: 1	فَسَادِ الْعِوَضِ
u'فَسَادٌ عِوَضٌ':Added, #1: 1	فَسَادَ الْعِوَضِ
u'فساد غِذَاءٌ':Added, #1: 1	فَسَادِ الْعِوَضِ
u'فَسَادٌ غِذَاءٌ':Added, #3: 3	فَسَادِ الْغِذَاءِ
u'فساد فِرَاشٌ':Added, #3: 3	فَسَادِ الْغِذَاءِ
u'فَسَادٌ فِرَاشٌ':Added, #1: 1	فَسَادَ الْفِرَاشِ
u'فساد فِرَاشٌ':Added, #1: 1	فَسَادَ الْفِرَاشِ
u'فَسَادٌ فِرَاشٌ':Added, #2: 2	فَسَادِ الْفِرَاشِ
u'فساد فَرْضٌ':Added, #2: 2	فَسَادِ الْفِرَاشِ
u'فساد فَرْضٌ':Added, #1: 1	فَسَادَ فَرْضِ
u'فَسَادٌ فَرْضٌ':Added, #1: 1	فَسَادُ فَرْضِ
u'فَسَادٌ فَرْضٌ':Added, #1: 1	فَسَادَ فَرْضِ
u'فساد فَسْخٌ':Added, #1: 1	فَسَادُ فَرْضِ
u'فَسَادٌ فَسْخٌ':Added, #1: 1	فَسَادُ الْفَسْخِ
u'فساد قَبْضٌ':Added, #1: 1	فَسَادُ الْفَسْخِ
u'فَسَادٌ قَبْضٌ':Added, #1: 1	فَسَادَ الْقَبْضِ
u'فساد قَدِيمٌ':Added, #1: 1	فَسَادَ الْقَبْضِ
u'فَسَادٌ قَدِيمٌ':Added, #1: 1	فَسَادَ الْقَدِيمِ
u'فساد قراض':Added, #1: 1	فَسَادَ الْقَدِيمِ
u'فساد قراض':Added, #1: 1	فَسَادَ الْقِرَاضِ
u'فَسَادٌ قراض':Added, #1: 1	فَسَادِ الْقِرَاضِ
u'فَسَادٌ قراض':Added, #1: 1	فَسَادَ الْقِرَاضِ
u'فساد قَرْضٌ':Added, #1: 1	فَسَادِ الْقِرَاضِ
u'فَسَادٌ قَرْضٌ':Added, #1: 1	فَسَادَ الْقَرْضِ
u'فساد قَرْضٌ':Added, #1: 1	فَسَادَ الْقَرْضِ
u'فَسَادٌ قَرْضٌ':Added, #2: 2	فَسَادِ الْقَرْضِ
u'فساد قَضَاءٌ':Added, #2: 2	فَسَادِ الْقَرْضِ
u'فَسَادٌ قَضَاءٌ':Added, #3: 3	فَسَادُ الْقَضَاءِ
u'فساد قضاة':Added, #3: 3	فَسَادُ الْقَضَاءِ
u'فَسَادٌ قضاة':Added, #1: 1	فَسَادِ قُضَاةِ
u'فساد قلب':Added, #1: 1	فَسَادِ قُضَاةِ
u'فَسَادٌ قلب':Added, #1: 1	فَسَادِ الْقَلْبِ
u'فساد قَلْبٌ':Added, #1: 1	فَسَادِ الْقَلْبِ
u'فساد قَلْب':Added, #1: 1	فَسَادِ الْقَلْبِ
u'فَسَادٌ قَلْبٌ':Added, #1: 1	فَسَادِ الْقَلْبِ
u'فَسَادٌ قَلْب':Added, #1: 1	فَسَادِ الْقَلْبِ
u'فساد قَهْقَه':Added, #1: 1	فَسَادِ الْقَلْبِ
u'فَسَادٌ قَهْقَه':Added, #1: 1	فَسَادَ الْقَهْقَهَةِ
u'فساد قَهْقَهَة':Added, #1: 1	فَسَادَ الْقَهْقَهَةِ
u'فَسَادٌ قَهْقَهَة':Added, #1: 1	فَسَادَ الْقَهْقَهَةِ
u'فساد قول':Added, #1: 1	فَسَادَ الْقَهْقَهَةِ
u'فَسَادٌ قول':Added, #10: 10	فَسَادُ قَوْلِ
u'فساد قَوْلٌ':Added, #10: 10	فَسَادُ قَوْلِ
u'فَسَادٌ قَوْلٌ':Added, #10: 10	فَسَادُ قَوْلِ
u'فساد قول':Added, #10: 10	فَسَادُ قَوْلِ
u'فَسَادٌ قول':Added, #1: 1	فَسَادَ قَوْلِ
u'فساد قَوْلٌ':Added, #1: 1	فَسَادَ قَوْلِ
u'فَسَادٌ قَوْلٌ':Added, #1: 1	فَسَادَ قَوْلِ
u'فساد قول':Added, #1: 1	فَسَادَ قَوْلِ
u'فَسَادٌ قول':Added, #1: 1	فَسَادِ قَوْلِهِ
u'فساد قَوْلٌ':Added, #1: 1	فَسَادِ قَوْلِهِ
u'فَسَادٌ قَوْلٌ':Added, #1: 1	فَسَادِ قَوْلِهِ
u'فساد قول':Added, #1: 1	فَسَادِ قَوْلِهِ
u'فَسَادٌ قول':Added, #2: 2	فَسَادُ قَوْلِهِ
u'فساد قَوْلٌ':Added, #2: 2	فَسَادُ قَوْلِهِ
u'فَسَادٌ قَوْلٌ':Added, #2: 2	فَسَادُ قَوْلِهِ
u'فساد قِيَاسٌ':Added, #2: 2	فَسَادُ قَوْلِهِ
u'فَسَادٌ قِيَاسٌ':Added, #1: 1	فَسَادِ قِيَاسِ
u'فساد قِيَاسٌ':Added, #1: 1	فَسَادِ قِيَاسِ
u'فَسَادٌ قِيَاسٌ':Added, #1: 1	فَسَادَ قِيَاسِهِ
u'فساد قِيَاسٌ':Added, #1: 1	فَسَادَ قِيَاسِهِ
u'فَسَادٌ قِيَاسٌ':Added, #3: 3	فَسَادَ الْقِيَاسِ
u'فساد كِتَابَةٌ':Added, #3: 3	فَسَادَ الْقِيَاسِ
u'فساد كِتَابَةٌ':Added, #1: 1	فَسَادَ الْكِتَابَةِ
u'فَسَادٌ كِتَابَةٌ':Added, #1: 1	فَسَادِ الْكِتَابَةِ
u'فَسَادٌ كِتَابَةٌ':Added, #1: 1	فَسَادَ الْكِتَابَةِ
u'فساد كِتَابَةٌ':Added, #1: 1	فَسَادِ الْكِتَابَةِ
u'فَسَادٌ كِتَابَةٌ':Added, #2: 2	فَسَادُ الْكِتَابَةِ
u'فساد كِرَاءٌ':Added, #2: 2	فَسَادُ الْكِتَابَةِ
u'فَسَادٌ كِرَاءٌ':Added, #1: 1	فَسَادُ الْكِرَاءِ
u'فساد كَفَالَةٌ':Added, #1: 1	فَسَادُ الْكِرَاءِ
u'فَسَادٌ كَفَالَةٌ':Added, #1: 1	فَسَادِ الْكَفَالَةِ
u'فساد كَلاَمٌ':Added, #1: 1	فَسَادِ الْكَفَالَةِ
u'فَسَادٌ كَلاَمٌ':Added, #1: 1	فَسَادُ كَلَامِهِ
u'فساد لعان':Added, #1: 1	فَسَادُ كَلَامِهِ
u'فَسَادٌ لعان':Added, #1: 1	فَسَادَ لِعَانِهِ
u'فساد لُغَةٌ':Added, #1: 1	فَسَادَ لِعَانِهِ
u'فَسَادٌ لُغَةٌ':Added, #1: 1	فَسَادِ اللُّغَةِ
u'فساد مَاءٌ':Added, #1: 1	فَسَادِ اللُّغَةِ
u'فساد مَاءٌ':Added, #1: 1	فَسَادَ الْمَاءِ
u'فَسَادٌ مَاءٌ':Added, #1: 1	فَسَادُ الْمَاءِ
u'فَسَادٌ مَاءٌ':Added, #1: 1	فَسَادَ الْمَاءِ
u'فساد مَاءٌ':Added, #1: 1	فَسَادُ الْمَاءِ
u'فَسَادٌ مَاءٌ':Added, #2: 2	فَسَادِ الْمَاءِ
u'فساد مَادَّةٌ':Added, #2: 2	فَسَادِ الْمَاءِ
u'فَسَادٌ مَادَّةٌ':Added, #1: 1	فَسَادُ الْمَادَّةِ
u'فساد مَالٌ':Added, #1: 1	فَسَادُ الْمَادَّةِ
u'فَسَادٌ مَالٌ':Added, #1: 1	فَسَادُ مَالِهِ
u'فساد مُبَادَلَةٌ':Added, #1: 1	فَسَادُ مَالِهِ
u'فَسَادٌ مُبَادَلَةٌ':Added, #1: 1	فَسَادُ الْمُبَادَلَةِ
u'فساد مَتَاعٌ':Added, #1: 1	فَسَادُ الْمُبَادَلَةِ
u'فَسَادٌ مَتَاعٌ':Added, #1: 1	فَسَادِ مَتَاعٍ
u'فساد مَحْكُومٌ':Added, #1: 1	فَسَادِ مَتَاعٍ
u'فَسَادٌ مَحْكُومٌ':Added, #1: 1	فَسَادِ الْمَحْكُومِ
u'فساد مُدَّةٌ':Added, #1: 1	فَسَادِ الْمَحْكُومِ
u'فَسَادٌ مُدَّةٌ':Added, #1: 1	فَسَادَ الْمُدَّةِ
u'فساد مُدْرَكٌ':Added, #1: 1	فَسَادَ الْمُدَّةِ
u'فَسَادٌ مُدْرَكٌ':Added, #1: 1	فَسَادِ مُدْرَكِهِ
u'فساد مَذْهَبٌ':Added, #1: 1	فَسَادِ مُدْرَكِهِ
u'فَسَادٌ مَذْهَبٌ':Added, #1: 1	فَسَادُ مَذْهَبِهِ
u'فساد مَسْبُوق':Added, #1: 1	فَسَادُ مَذْهَبِهِ
u'فَسَادٌ مَسْبُوق':Added, #1: 1	فَسَادَ الْمَسْبُوقِ
u'فساد مُضَارَبَةٌ':Added, #1: 1	فَسَادَ الْمَسْبُوقِ
u'فَسَادٌ مُضَارَبَةٌ':Added, #1: 1	فَسَادَ الْمُضَارَبَةِ
u'فساد مُعَامَلَةٌ':Added, #1: 1	فَسَادَ الْمُضَارَبَةِ
u'فَسَادٌ مُعَامَلَةٌ':Added, #2: 2	فَسَادُ الْمُعَامَلَةِ
u'فساد مَعِدَةٌ':Added, #2: 2	فَسَادُ الْمُعَامَلَةِ
u'فَسَادٌ مَعِدَةٌ':Added, #1: 1	فَسَادُ الْمَعِدَةِ
u'فساد مَعْصِيَةٌ':Added, #1: 1	فَسَادُ الْمَعِدَةِ
u'فَسَادٌ مَعْصِيَةٌ':Added, #1: 1	فَسَادِ الْمَعْصِيَةِ
u'فساد مُعْظَمٌ':Added, #1: 1	فَسَادِ الْمَعْصِيَةِ
u'فَسَادٌ مُعْظَمٌ':Added, #1: 1	فَسَادُ مُعْظَمِ
u'فساد مَغْرِبٌ':Added, #1: 1	فَسَادُ مُعْظَمِ
u'فَسَادٌ مَغْرِبٌ':Added, #1: 1	فَسَادَ الْمَغْرِبِ
u'فساد مَغْسُولٌ':Added, #1: 1	فَسَادَ الْمَغْرِبِ
u'فَسَادٌ مَغْسُولٌ':Added, #1: 1	فَسَادِ الْمَغْسُولِ
u'فساد مَقَالَةٌ':Added, #1: 1	فَسَادِ الْمَغْسُولِ
u'فَسَادٌ مَقَالَةٌ':Added, #2: 2	فَسَادَ مَقَالَتِهِ
u'فساد مَقْسُومٌ':Added, #2: 2	فَسَادَ مَقَالَتِهِ
u'فَسَادٌ مَقْسُومٌ':Added, #1: 1	فَسَادُ الْمَقْسُومِ
u'فساد مِلْكٌ':Added, #1: 1	فَسَادُ الْمَقْسُومِ
u'فَسَادٌ مِلْكٌ':Added, #1: 1	فَسَادُ الْمِلْكِ
u'فساد مِلْكٌ':Added, #1: 1	فَسَادُ الْمِلْكِ
u'فَسَادٌ مِلْكٌ':Added, #1: 1	فَسَادُ مِلْكِ
u'فساد مِلْكٌ':Added, #1: 1	فَسَادُ مِلْكِ
u'فَسَادٌ مِلْكٌ':Added, #7: 7	فَسَادِ الْمِلْكِ
u'فساد مَنْعٌ':Added, #7: 7	فَسَادِ الْمِلْكِ
u'فَسَادٌ مَنْعٌ':Added, #1: 1	فَسَادَ الْمَنْعِ
u'فساد مَنْهِيٌّ':Added, #1: 1	فَسَادَ الْمَنْعِ
u'فَسَادٌ مَنْهِيٌّ':Added, #3: 3	فَسَادِ الْمَنْهِيِّ
u'فساد مَنْهِيٌّ':Added, #3: 3	فَسَادِ الْمَنْهِيِّ
u'فَسَادٌ مَنْهِيٌّ':Added, #4: 4	فَسَادَ الْمَنْهِيِّ
u'فساد مَوْضِعٌ':Added, #4: 4	فَسَادَ الْمَنْهِيِّ
u'فَسَادٌ مَوْضِعٌ':Added, #1: 1	فَسَادِ مَوْضِعِ
u'فساد نَاسٌ':Added, #1: 1	فَسَادِ مَوْضِعِ
u'فَسَادٌ نَاسٌ':Added, #2: 2	فَسَادِ النَّاسِ
u'فساد نَحْوٌ':Added, #2: 2	فَسَادِ النَّاسِ
u'فَسَادٌ نَحْوٌ':Added, #1: 1	فَسَادِ نَحْوِ
u'فساد نِساءٌ':Added, #1: 1	فَسَادِ نَحْوِ
u'فَسَادٌ نِساءٌ':Added, #1: 1	فَسَادِ النِّسَاءِ
u'فساد نُسُكٌ':Added, #1: 1	فَسَادِ النِّسَاءِ
u'فساد نُسُكٌ':Added, #1: 1	فَسَادَ النُّسُكِ
u'فَسَادٌ نُسُكٌ':Added, #1: 1	فَسَادِ النُّسُكِ
u'فَسَادٌ نُسُكٌ':Added, #1: 1	فَسَادَ النُّسُكِ
u'فساد نُسُكٌ':Added, #1: 1	فَسَادِ النُّسُكِ
u'فَسَادٌ نُسُكٌ':Added, #2: 2	فَسَادِ نُسُكِهِ
u'فساد نُسُكٌ':Added, #2: 2	فَسَادِ نُسُكِهِ
u'فَسَادٌ نُسُكٌ':Added, #3: 3	فَسَادُ النُّسُكِ
u'فساد نَظَرٌ':Added, #3: 3	فَسَادُ النُّسُكِ
u'فَسَادٌ نَظَرٌ':Added, #1: 1	فَسَادِ النَّظَرِ
u'فساد نَظَرٌ':Added, #1: 1	فَسَادِ النَّظَرِ
u'فَسَادٌ نَظَرٌ':Added, #2: 2	فَسَادَ النَّظَرِ
u'فساد نقل':Added, #2: 2	فَسَادَ النَّظَرِ
u'فَسَادٌ نقل':Added, #1: 1	فَسَادِ نَقْلِهِ
u'فساد نَقْلٌ':Added, #1: 1	فَسَادِ نَقْلِهِ
u'فَسَادٌ نَقْلٌ':Added, #1: 1	فَسَادِ نَقْلِهِ
u'فساد نكاح':Added, #1: 1	فَسَادِ نَقْلِهِ
u'فَسَادٌ نكاح':Added, #11: 11	فَسَادِ النِّكَاحِ
u'فساد نِكَاحٌ':Added, #11: 11	فَسَادِ النِّكَاحِ
u'فَسَادٌ نِكَاحٌ':Added, #11: 11	فَسَادِ النِّكَاحِ
u'فساد نكاح':Added, #11: 11	فَسَادِ النِّكَاحِ
u'فَسَادٌ نكاح':Added, #19: 19	فَسَادَ النِّكَاحِ
u'فساد نِكَاحٌ':Added, #19: 19	فَسَادَ النِّكَاحِ
u'فَسَادٌ نِكَاحٌ':Added, #19: 19	فَسَادَ النِّكَاحِ
u'فساد نكاح':Added, #19: 19	فَسَادَ النِّكَاحِ
u'فساد نكاح':Added, #1: 1	فَسَادُ نِكَاحٍ
u'فَسَادٌ نكاح':Added, #1: 1	فَسَادُ نِكَاحِ
u'فَسَادٌ نكاح':Added, #1: 1	فَسَادُ نِكَاحٍ
u'فساد نِكَاحٌ':Added, #1: 1	فَسَادُ نِكَاحِ
u'فساد نِكَاحٌ':Added, #1: 1	فَسَادُ نِكَاحٍ
u'فَسَادٌ نِكَاحٌ':Added, #1: 1	فَسَادُ نِكَاحِ
u'فَسَادٌ نِكَاحٌ':Added, #1: 1	فَسَادُ نِكَاحٍ
u'فساد نكاح':Added, #1: 1	فَسَادُ نِكَاحِ
u'فَسَادٌ نكاح':Added, #1: 1	فَسَادُ نِكَاحِهِ
u'فساد نِكَاحٌ':Added, #1: 1	فَسَادُ نِكَاحِهِ
u'فَسَادٌ نِكَاحٌ':Added, #1: 1	فَسَادُ نِكَاحِهِ
u'فساد نكاح':Added, #1: 1	فَسَادُ نِكَاحِهِ
u'فساد نكاح':Added, #2: 2	فَسَادَ نِكَاحِ
u'فَسَادٌ نكاح':Added, #2: 2	فَسَادِ نِكَاحِ
u'فَسَادٌ نكاح':Added, #2: 2	فَسَادَ نِكَاحِ
u'فساد نِكَاحٌ':Added, #2: 2	فَسَادِ نِكَاحِ
u'فساد نِكَاحٌ':Added, #2: 2	فَسَادَ نِكَاحِ
u'فَسَادٌ نِكَاحٌ':Added, #2: 2	فَسَادِ نِكَاحِ
u'فَسَادٌ نِكَاحٌ':Added, #2: 2	فَسَادَ نِكَاحِ
u'فساد نكاح':Added, #2: 2	فَسَادِ نِكَاحِ
u'فَسَادٌ نكاح':Added, #2: 2	فَسَادَ نِكَاحِهِ
u'فساد نِكَاحٌ':Added, #2: 2	فَسَادَ نِكَاحِهِ
u'فَسَادٌ نِكَاحٌ':Added, #2: 2	فَسَادَ نِكَاحِهِ
u'فساد نكاح':Added, #2: 2	فَسَادَ نِكَاحِهِ
u'فَسَادٌ نكاح':Added, #3: 3	فَسَادِ نِكَاحِهِ
u'فساد نِكَاحٌ':Added, #3: 3	فَسَادِ نِكَاحِهِ
u'فَسَادٌ نِكَاحٌ':Added, #3: 3	فَسَادِ نِكَاحِهِ
u'فساد نكاح':Added, #3: 3	فَسَادِ نِكَاحِهِ
u'فَسَادٌ نكاح':Added, #5: 5	فَسَادُ النِّكَاحِ
u'فساد نِكَاحٌ':Added, #5: 5	فَسَادُ النِّكَاحِ
u'فَسَادٌ نِكَاحٌ':Added, #5: 5	فَسَادُ النِّكَاحِ
u'فساد نهار':Added, #5: 5	فَسَادُ النِّكَاحِ
u'فَسَادٌ نهار':Added, #1: 1	فَسَادِ النَّهَارِ
u'فساد نَهَارٌ':Added, #1: 1	فَسَادِ النَّهَارِ
u'فَسَادٌ نَهَارٌ':Added, #1: 1	فَسَادِ النَّهَارِ
u'فساد نِيَابَةٌ':Added, #1: 1	فَسَادِ النَّهَارِ
u'فَسَادٌ نِيَابَةٌ':Added, #1: 1	فَسَادِ النِّيَابَةِ
u'فساد نِيَّةٌ':Added, #1: 1	فَسَادِ النِّيَابَةِ
u'فساد نِيَّةٌ':Added, #1: 1	فَسَادَ النِّيَّةِ
u'فَسَادٌ نِيَّةٌ':Added, #1: 1	فَسَادِ النِّيَّةِ
u'فَسَادٌ نِيَّةٌ':Added, #1: 1	فَسَادَ النِّيَّةِ
u'فساد نِيَّةٌ':Added, #1: 1	فَسَادِ النِّيَّةِ
u'فَسَادٌ نِيَّةٌ':Added, #1: 1	فَسَادُ نِيَّتِهِ
u'فساد نِيَّةٌ':Added, #1: 1	فَسَادُ نِيَّتِهِ
u'فَسَادٌ نِيَّةٌ':Added, #2: 2	فَسَادُ النِّيَّةِ
u'فساد نِيَّةٌ':Added, #2: 2	فَسَادُ النِّيَّةِ
u'فَسَادٌ نِيَّةٌ':Added, #2: 2	فَسَادِ نِيَّتِهِ
u'فساد هِبَةٌ':Added, #2: 2	فَسَادِ نِيَّتِهِ
u'فَسَادٌ هِبَةٌ':Added, #1: 1	فَسَادَ الْهِبَةِ
u'فساد هَوَاءٌ':Added, #1: 1	فَسَادَ الْهِبَةِ
u'فساد هَوَاءٌ':Added, #2: 2	فَسَادَ الْهَوَاءِ
u'فَسَادٌ هَوَاءٌ':Added, #2: 2	فَسَادُ الْهَوَاءِ
u'فَسَادٌ هَوَاءٌ':Added, #2: 2	فَسَادَ الْهَوَاءِ
u'فساد هَوَاءٌ':Added, #2: 2	فَسَادُ الْهَوَاءِ
u'فَسَادٌ هَوَاءٌ':Added, #5: 5	فَسَادِ الْهَوَاءِ
u'فساد وَصْفٌ':Added, #5: 5	فَسَادِ الْهَوَاءِ
u'فَسَادٌ وَصْفٌ':Added, #1: 1	فَسَادُ الْوَصْفِ
u'فساد وَضْعٌ':Added, #1: 1	فَسَادُ الْوَصْفِ
u'فَسَادٌ وَضْعٌ':Added, #16: 16	فَسَادُ الْوَضْعِ
u'فساد وَضْعٌ':Added, #16: 16	فَسَادُ الْوَضْعِ
u'فَسَادٌ وَضْعٌ':Added, #19: 19	فَسَادِ الْوَضْعِ
u'فساد وَضْعٌ':Added, #19: 19	فَسَادِ الْوَضْعِ
u'فَسَادٌ وَضْعٌ':Added, #1: 1	فَسَادَ وَضْعٍ
u'فساد وَضْعٌ':Added, #1: 1	فَسَادَ وَضْعٍ
u'فَسَادٌ وَضْعٌ':Added, #3: 3	فَسَادَ الْوَضْعِ
u'فساد وَقْتٌ':Added, #3: 3	فَسَادَ الْوَضْعِ
u'فَسَادٌ وَقْتٌ':Added, #1: 1	فَسَادَ الْوَقْتِ
u'فساد وَقْتِيّ':Added, #1: 1	فَسَادَ الْوَقْتِ
u'فَسَادٌ وَقْتِيّ':Added, #1: 1	فَسَادِ الْوَقْتِيَّاتِ
u'فساد وَقْف':Added, #1: 1	فَسَادِ الْوَقْتِيَّاتِ
u'فَسَادٌ وَقْف':Added, #1: 1	فَسَادَ الْوَقْفِيَّةِ
u'فساد وَقْفَة':Added, #1: 1	فَسَادَ الْوَقْفِيَّةِ
u'فَسَادٌ وَقْفَة':Added, #1: 1	فَسَادَ الْوَقْفِيَّةِ
u'فساد وَقْفِيّ':Added, #1: 1	فَسَادَ الْوَقْفِيَّةِ
u'فَسَادٌ وَقْفِيّ':Added, #1: 1	فَسَادَ الْوَقْفِيَّةِ
u'فساد وَقْفِيَّة':Added, #1: 1	فَسَادَ الْوَقْفِيَّةِ
u'فَسَادٌ وَقْفِيَّة':Added, #1: 1	فَسَادَ الْوَقْفِيَّةِ
u'فساد وِكَالَةٌ':Added, #1: 1	فَسَادَ الْوَقْفِيَّةِ
u'فَسَادٌ وِكَالَةٌ':Added, #1: 1	فَسَادَ الْوِكَالَةِ
u'فساد وِلاَيَةٌ':Added, #1: 1	فَسَادَ الْوِكَالَةِ
u'فَسَادٌ وِلاَيَةٌ':Added, #2: 2	فَسَادِ وِلَايَتِهِ
u'فَسَا صَائِمٌ':Subject, #2: 2	فَسَادِ وِلَايَتِهِ
u'فَسَخَ إجَارَةٌ':Predicate, #1: 1	فَسَا الصَّائِمُ
u'فَسْخٌ إجَارَةٌ':Added, #3: 3	فَسَخَ الْإِجَارَةَ
u'فَسْخٌ إجَارَةٌ':Added, #18: 18	فَسْخُ الْإِجَارَةِ
u'فَسْخٌ إجَارَةٌ':Added, #27: 27	فَسْخِ الْإِجَارَةِ
u'فَسَخَ أَجِيرٌ':Subject, #4: 4	فَسْخَ الْإِجَارَةِ
u'فَسَخَ أحَدٌ':Subject, #2: 2	فَسَخَ الْأَجِيرُ
u'فَسْخٌ أحَدٌ':Added, #2: 2	فَسَخَ أَحَدُ
u'فَسَخَ أصل':Predicate, #1: 1	فَسْخِ أَحَدِ
u'فَسَخَ أًصْلٌ':Predicate, #1: 1	فَسَخَ أَصْلَ
u'فَسْخٌ أصل':Added, #1: 1	فَسَخَ أَصْلَ
u'فَسْخٌ أًصْلٌ':Added, #1: 1	فَسْخَ أَصْلِ
u'فَسْخٌ إقالَةٌ':Added, #1: 1	فَسْخَ أَصْلِ
u'فَسْخٌ إقالَةٌ':Added, #1: 1	فَسْخَ الْإِقَالَةِ
u'فَسْخٌ الْمَرْأَةُ':Added, #1: 1	فَسْخِ الْإِقَالَةِ
u'فَسْخٌ أَوَّلُ':Added, #2: 2	فَسْخِ الْمَرْأَةِ
u'فَسْخٌ أَوَّلُ':Added, #2: 2	فَسْخُ الْأَوَّلِ
u'فَسْخٌ أَوَّلُ':Added, #4: 4	فَسْخَ الْأَوَّلِ
u'فَسَخَ بَائِعٌ':Subject, #4: 4	فَسْخِ الْأَوَّلِ
u'فَسْخٌ بَائِعٌ':Added, #8: 8	فَسَخَ الْبَائِعُ
u'فَسْخٌ بَائِعٌ':Added, #1: 1	فَسْخُ الْبَائِعِ
u'فَسْخٌ بَائِعٌ':Added, #1: 1	فَسْخُ بَائِعِهِ
u'فَسْخٌ بَائِعٌ':Added, #2: 2	فَسْخَ الْبَائِعِ
u'فَسَخَ بَطَلٌ':Predicate, #4: 4	فَسْخِ الْبَائِعِ
u'فَسْخٌ بَقِيَّةٌ':Added, #1: 1	فَسَخَ بَطَلَ
u'فَسَخَ بِيَعٌ':Predicate, #2: 2	فَسْخِ بَقِيَّةِ
u'فَسَخَ بَيْعٌ':Predicate, #1: 1	فَسَخَ الْبِيَعَ
u'فَسْخٌ بَيْعٌ':Added, #44: 44	فَسَخَ الْبَيْعَ
u'فَسْخٌ بَيْعٌ':Added, #19: 19	فَسْخَ الْبَيْعِ
u'فَسْخٌ بَيْعٌ':Added, #1: 1	فَسْخُ الْبَيْعَتَيْنِ
u'فَسْخٌ بَيْعٌ':Added, #1: 1	فَسْخَ بَيْعٍ
u'فَسْخٌ بَيْعٌ':Added, #1: 1	فَسْخِ بَيْعٍ
u'فَسْخٌ بَيْعٌ':Added, #1: 1	فَسْخِ بَيْعِ
u'فَسْخٌ بَيْعٌ':Added, #26: 26	فَسْخُ الْبَيْعِ
u'فَسْخٌ بَيْعٌ':Added, #27: 27	فَسْخِ الْبَيْعِ
u'فَسْخٌ بَيْعٌ':Added, #2: 2	فَسْخُ بَيْعٍ
u'فَسْخٌ بيوع':Added, #2: 2	فَسْخِ بَيْعِهِ
u'فَسْخٌ تَخَالُفٌ':Added, #1: 1	فَسْخِ بُيُوعِ
u'فَسْخٌ تَدْبِيرٌ':Added, #1: 1	فَسْخَ التَّخَالُفِ
u'فَسَخَ تَصَرُّفٌ':Predicate, #2: 2	فَسْخِ التَّدْبِيرِ
u'فَسْخٌ تَصَرُّفٌ':Added, #1: 1	فَسَخَ التَّصَرُّفَ
u'فَسْخٌ تَعْيِينٌ':Added, #1: 1	فَسْخُ تَصَرُّفِهِ
u'فَسْخٌ تَوْكِيلٌ':Added, #1: 1	فَسْخُ التَّعْيِينِ
u'فَسْخٌ جَمِيع':Added, #1: 1	فَسْخَ التَّوْكِيلِ
u'فَسَخَ حاكِمٌ':Subject, #1: 1	فَسْخُ الْجَمِيعِ
u'فَسْخٌ حاكِمٌ':Added, #7: 7	فَسَخَ الْحَاكِمُ
u'فَسْخٌ حَجٌّ':Added, #3: 3	فَسْخِ الْحَاكِمِ
u'فَسْخٌ حَجٌّ':Added, #1: 1	فَسْخُ حَجٍّ
u'فَسْخٌ حَجٌّ':Added, #5: 5	فَسْخُ الْحَجِّ
u'فَسْخٌ حَجٌّ':Added, #6: 6	فَسْخَ الْحَجِّ
u'فَسَخَ حُكْمٌ':Predicate, #6: 6	فَسْخِ الْحَجِّ
u'فَسْخٌ حَوَالَةٌ':Added, #1: 1	فَسَخَ حُكْمَ
u'فَسْخٌ حَوَالَةٌ':Added, #1: 1	فَسْخُ الْحَوَالَةِ
u'فَسْخٌ خُلْعٌ':Added, #1: 1	فَسْخِ الْحَوَالَةِ
u'فَسْخٌ خيار':Added, #1: 1	فَسْخَ الْخُلْعِ
u'فَسْخٌ خِيَارٌ':Added, #2: 2	فَسْخِ الْخِيَارِ
u'فَسَخَ دَرَاهِمُ':Predicate, #2: 2	فَسْخِ الْخِيَارِ
u'فَسْخٌ دَيْنٌ':Added, #1: 1	فَسَخَ دَرَاهِمَ
u'فَسْخٌ دَيْنٌ':Added, #10: 10	فَسْخُ الدَّيْنِ
u'فَسْخٌ دَيْنٌ':Added, #12: 12	فَسْخُ دَيْنٍ
u'فَسْخٌ دَيْنٌ':Added, #1: 1	فَسْخِ الدَّيْنِ
u'فَسْخٌ دَيْنٌ':Added, #1: 1	فَسْخِ دَيْنٍ
u'فَسْخٌ دَيْنٌ':Added, #2: 2	فَسْخَ دَيْنٍ
u'فَسْخٌ دِينارٌ':Added, #5: 5	فَسْخَ الدَّيْنِ
u'فَسْخٌ رَاهِنٌ':Added, #1: 1	فَسْخُ دِينَارَيْنِ
u'فَسَخَ رَبُّ':Subject, #1: 1	فَسْخِ الرَّاهِنِ
u'فَسْخٌ رَهْنٌ':Added, #1: 1	فَسَخَ رَبُّ
u'فَسْخٌ رَهْنٌ':Added, #1: 1	فَسْخُ الرَّهْنِ
u'فَسْخٌ رَهْنٌ':Added, #2: 2	فَسْخَ الرَّهْنِ
u'فَسْخٌ زَوْجٌ':Added, #6: 6	فَسْخِ الرَّهْنِ
u'فَسْخٌ سَبَبٌ':Added, #2: 2	فَسْخِ الزَّوْجِ
u'فَسْخٌ سَبَبٌ':Added, #1: 1	فَسْخُ السَّبَبِ
u'فَسَخَ سَلَمٌ':Predicate, #1: 1	فَسْخِ السَّبَبِ
u'فَسَخَ سَيِّدٌ':Subject, #3: 3	فَسَخَ السَّلَمَ
u'فَسْخٌ سَيِّدٌ':Added, #4: 4	فَسَخَ السَّيِّدُ
u'فَسْخٌ سَيِّدٌ':Added, #1: 1	فَسْخِ سَيِّدِهِ
u'فَسَخَ شِرَاءٌ':Predicate, #2: 2	فَسْخِ السَّيِّدِ
u'فَسَخَ شركة':Predicate, #1: 1	فَسَخَ الشِّرَاءَ
u'فَسَخَ شَرِكَةٌ':Predicate, #1: 1	فَسَخَ الشَّرِكَةَ
u'فَسْخٌ شركة':Added, #1: 1	فَسَخَ الشَّرِكَةَ
u'فَسْخٌ شَرِكَةٌ':Added, #1: 1	فَسْخُ الشَّرِكَةِ
u'فَسْخٌ شركة':Added, #1: 1	فَسْخُ الشَّرِكَةِ
u'فَسْخٌ شَرِكَةٌ':Added, #3: 3	فَسْخَ الشَّرِكَةِ
u'فَسْخٌ شفعة':Added, #3: 3	فَسْخَ الشَّرِكَةِ
u'فَسْخٌ شُفْعَةٌ':Added, #1: 1	فَسْخُ الشُّفْعَةِ
u'فَسْخٌ شَهَادَةٌ':Added, #1: 1	فَسْخُ الشُّفْعَةِ
u'فَسْخٌ شَهَادَةٌ':Added, #1: 1	فَسْخَ الشَّهَادَةِ
u'فَسَخَ صَاحِبٌ':Subject, #2: 2	فَسْخِ الشَّهَادَةِ
u'فَسَخَ صَاحِبٌ':Subject, #1: 1	فَسَخَ صَاحِبُ
u'فَسَخَ صَبَّاغٌ':Subject, #3: 3	فَسَخَ صَاحِبُهُ
u'فَسْخٌ صَحِيحٌ':Added, #1: 1	فَسَخَ الصَّبَّاغُ
u'فَسَخَ صلح':Predicate, #1: 1	فَسْخ الصَّحِيحِ
u'فَسَخَ صُلْحٌ':Predicate, #1: 1	فَسَخَ الصُّلْحَ
u'فَسْخٌ صلح':Added, #1: 1	فَسَخَ الصُّلْحَ
u'فَسْخٌ صُلْحٌ':Added, #2: 2	فَسْخُ الصُّلْحِ
u'فَسَخَ طعام':Predicate, #2: 2	فَسْخُ الصُّلْحِ
u'فَسَخَ طَعَامٌ':Predicate, #1: 1	فَسَخَ الطَّعَامَ
u'فَسَخَ ظالِمٌ':Subject, #1: 1	فَسَخَ الطَّعَامَ
u'فَسْخٌ ظالِمٌ':Added, #1: 1	فَسَخَ الظَّالِمُ
u'فَسَخَ عَامِلٌ':Subject, #1: 1	فَسْخُ الظَّالِمِ
u'فَسْخٌ عَامِلٌ':Added, #3: 3	فَسَخَ الْعَامِلُ
u'فَسْخٌ عتق':Added, #1: 1	فَسْخُ الْعَامِلِ
u'فَسْخٌ عتق':Added, #1: 1	فَسْخَ الْعِتْقِ
u'فَسْخٌ عِتْقٌ':Added, #1: 1	فَسْخِ الْعِتْقِ
u'فَسْخٌ عِتْقٌ':Added, #1: 1	فَسْخَ الْعِتْقِ
u'فَسَخَ عَزِيمَةٌ':Predicate, #1: 1	فَسْخِ الْعِتْقِ
u'فَسَخَ عَقْدٌ':Predicate, #1: 1	فَسَخَ عَزِيمَةَ
u'فَسَخَ عَقْدٌ':Subject, #28: 28	فَسَخَ الْعَقْدَ
u'فَسْخٌ عَقْدٌ':Added, #1: 1	فَسَخَ الْعَقْدُ
u'فَسْخٌ عَقْدٌ':Added, #1: 1	فَسْخِ عَقْدٍ
u'فَسْخٌ عَقْدٌ':Added, #20: 20	فَسْخُ الْعَقْدِ
u'فَسْخٌ عَقْدٌ':Added, #20: 20	فَسْخِ الْعَقْدِ
u'فَسْخٌ عَقْدٌ':Added, #34: 34	فَسْخَ الْعَقْدِ
u'فَسْخٌ عَقْدٌ':Added, #3: 3	فَسْخُ عَقْدٍ
u'فَسْخٌ عَقْدٌ':Added, #3: 3	فَسْخِ عَقْدِ
u'فَسْخٌ عَقْدٌ':Added, #3: 3	فَسْخُ عَقْدِهِ
u'فَسْخٌ عُقُودٌ':Added, #4: 4	فَسْخُ عَقْدِ
u'فَسْخٌ عُقُودٌ':Added, #1: 1	فَسْخِ الْعُقُودِ
u'فَسْخٌ عمرة':Added, #4: 4	فَسْخُ الْعُقُودِ
u'فَسْخٌ عُمْرَةٌ':Added, #1: 1	فَسْخُ الْعُمْرَةِ
u'فَسَخَ عَهْدٌ':Predicate, #1: 1	فَسْخُ الْعُمْرَةِ
u'فَسْخٌ عَيْبٌ':Added, #1: 1	فَسَخَ الْعَهْدَ
u'فَسَخَ عين':Predicate, #1: 1	فَسْخُ الْعَيْبِ
u'فَسَخَ عَيْنٌ':Predicate, #1: 1	فَسَخَ الْعَيْنَ
u'فَسَخَ عَيْن':Predicate, #1: 1	فَسَخَ الْعَيْنَ
u'فَسْخٌ فَاسِدٌ':Added, #1: 1	فَسَخَ الْعَيْنَ
u'فَسْخٌ فَاسِدٌ':Added, #1: 1	فَسْخُ الْفَاسِدِ
u'فَسْخٌ فَاسِدٌ':Added, #1: 1	فَسْخِ الْفَاسِدِ
u'فَسْخٌ فَسْخٌ':Added, #2: 2	فَسْخَ الْفَاسِدِ
u'فَسْخٌ فِعْلٌ':Added, #1: 1	فَسْخِ الْفَسْخِ
u'فَسَخَ فُلاَنٌ':Subject, #3: 3	فَسْخُ فِعْلِهِ
u'فَسْخٌ قراض':Added, #1: 1	فَسَخَ فُلَانٌ
u'فَسْخٌ قسمة':Added, #4: 4	فَسْخِ الْقِرَاضِ
u'فَسْخٌ قِسْمَةٌ':Added, #1: 1	فَسْخِ الْقِسْمَةِ
u'فَسْخٌ قسمة':Added, #1: 1	فَسْخِ الْقِسْمَةِ
u'فَسْخٌ قِسْمَةٌ':Added, #1: 1	فَسْخِ قِسْمَةِ
u'فَسْخٌ قسمة':Added, #1: 1	فَسْخِ قِسْمَةِ
u'فَسْخٌ قِسْمَةٌ':Added, #2: 2	فَسْخُ الْقِسْمَةِ
u'فَسْخٌ قسمة':Added, #2: 2	فَسْخُ الْقِسْمَةِ
u'فَسْخٌ قِسْمَةٌ':Added, #4: 4	فَسْخَ الْقِسْمَةِ
u'فَسْخٌ قَضَاءٌ':Added, #4: 4	فَسْخَ الْقِسْمَةِ
u'فَسْخٌ قُلْفَةٌ':Added, #1: 1	فَسْخُ الْقَضَاءِ
u'فَسَخَ كَاذِبٌ':Subject, #1: 1	فَسْخُ الْقُلْفَةِ
u'فَسَخَ كِتَابَةٌ':Predicate, #1: 1	فَسَخَ الْكَاذِبُ
u'فَسْخٌ كِتَابَةٌ':Added, #1: 1	فَسَخَ الْكِتَابَةَ
u'فَسْخٌ كِتَابَةٌ':Added, #10: 10	فَسْخَ الْكِتَابَةِ
u'فَسْخٌ كِتَابَةٌ':Added, #14: 14	فَسْخُ الْكِتَابَةِ
u'فَسْخٌ كِتَابَةٌ':Added, #1: 1	فَسْخِ كِتَابَةِ
u'فَسَخَ كِرَاءٌ':Predicate, #8: 8	فَسْخِ الْكِتَابَةِ
u'فَسْخٌ كِرَاءٌ':Added, #1: 1	فَسَخَ الْكِرَاءَ
u'فَسْخٌ كِرَاءٌ':Added, #2: 2	فَسْخُ الْكِرَاءِ
u'فَسَخَ مَالِكٌ':Subject, #2: 2	فَسْخِ الْكِرَاءِ
u'فَسْخٌ مُخْتَلَفٌ':Added, #2: 2	فَسَخَ الْمَالِكُ
u'فَسَخَ مُساقاة':Predicate, #1: 1	فَسْخَ الْمُخْتَلَفِ
u'فَسْخٌ مُسْتَأْجِرٌ':Added, #1: 1	فَسَخَ الْمُسَاقَاةَ
u'فَسَخَ مَظْلُومٌ':Subject, #2: 2	فَسْخِ الْمُسْتَأْجِرِ
u'فَسْخٌ مَظْلُومٌ':Added, #3: 3	فَسَخَ الْمَظْلُومُ
u'فَسْخٌ مَظْلُومٌ':Added, #1: 1	فَسْخَ الْمَظْلُومِ
u'فَسْخٌ مُعَامَلَةٌ':Added, #1: 1	فَسْخِ الْمَظْلُومِ
u'فَسْخٌ مُعْتَقٌ':Added, #1: 1	فَسْخِ الْمُعَامَلَةِ
u'فَسْخٌ مُعْتَقٌ':Added, #1: 1	فَسْخِ الْمُعْتَقَةِ
u'فَسْخٌ مِلْكٌ':Added, #2: 2	فَسْخُ الْمُعْتَقَةِ
u'فَسَخَ مُؤَجِّرٌ':Subject, #1: 1	فَسْخَ الْمِلْكِ
u'فَسَخَ مُؤَجِّرٌ':Subject, #1: 1	فَسَخَ الْمُؤَجِّرُ
u'فَسْخٌ مُودِعٌ':Added, #1: 1	فَسَخَ مُؤَجِّرُ
u'فَسْخٌ مُودِعٌ':Added, #1: 1	فَسْخَ الْمُودِعِ
u'فَسَخَ مُوَرِّث':Subject, #2: 2	فَسْخِ الْمُودِعِ
u'فَسَخَ مَوْقُوفٌ':Predicate, #1: 1	فَسَخَ الْمُوَرِّثُ
u'فَسَخَ نكاح':Predicate, #1: 1	فَسَخَ الْمَوْقُوفَ
u'فَسَخَ نِكَاحٌ':Predicate, #2: 2	فَسَخَ نِكَاحَ
u'فَسَخَ نكاح':Predicate, #2: 2	فَسَخَ نِكَاحَ
u'فَسَخَ نِكَاحٌ':Predicate, #3: 3	فَسَخَ النِّكَاحَ
u'فَسْخٌ نكاح':Added, #3: 3	فَسَخَ النِّكَاحَ
u'فَسْخٌ نِكَاحٌ':Added, #13: 13	فَسْخَ النِّكَاحِ
u'فَسْخٌ نكاح':Added, #13: 13	فَسْخَ النِّكَاحِ
u'فَسْخٌ نِكَاحٌ':Added, #16: 16	فَسْخُ النِّكَاحِ
u'فَسْخٌ نكاح':Added, #16: 16	فَسْخُ النِّكَاحِ
u'فَسْخٌ نكاح':Added, #1: 1	فَسْخَ نِكَاحِهِ
u'فَسْخٌ نِكَاحٌ':Added, #1: 1	فَسْخُ نِكَاحِهِ
u'فَسْخٌ نِكَاحٌ':Added, #1: 1	فَسْخَ نِكَاحِهِ
u'فَسْخٌ نكاح':Added, #1: 1	فَسْخُ نِكَاحِهِ
u'فَسْخٌ نكاح':Added, #2: 2	فَسْخَ نِكَاحٍ
u'فَسْخٌ نِكَاحٌ':Added, #2: 2	فَسْخَ نِكَاحِ
u'فَسْخٌ نِكَاحٌ':Added, #2: 2	فَسْخَ نِكَاحٍ
u'فَسْخٌ نكاح':Added, #2: 2	فَسْخَ نِكَاحِ
u'فَسْخٌ نِكَاحٌ':Added, #2: 2	فَسْخِ نِكَاحِهِ
u'فَسْخٌ نكاح':Added, #2: 2	فَسْخِ نِكَاحِهِ
u'فَسْخٌ نِكَاحٌ':Added, #34: 34	فَسْخِ النِّكَاحِ
u'فَسْخٌ نكاح':Added, #34: 34	فَسْخِ النِّكَاحِ
u'فَسْخٌ نِكَاحٌ':Added, #5: 5	فَسْخِ نِكَاحِ
u'فَسْخٌ نكاح':Added, #5: 5	فَسْخِ نِكَاحِ
u'فَسْخٌ نِكَاحٌ':Added, #7: 7	فَسْخُ نِكَاحِ
u'فَسْخٌ نَمَاءٌ':Added, #7: 7	فَسْخُ نِكَاحِ
u'فَسَخَ نِيَّةٌ':Predicate, #1: 1	فَسْخُ النَّمَاءِ
u'فَسَخَ وَجَبٌ':Predicate, #1: 1	فَسَخَ النِّيَّةَ
u'فَسَخَ وَكِيلٌ':Subject, #1: 1	فَسَخَ وَجَبَ
u'فَسْخٌ وِلاَيَةٌ':Added, #1: 1	فَسَخَ الْوَكِيلُ
u'فَسَخَ وَلِيٌّ':Subject, #1: 1	فَسْخَ الْوِلَايَةِ
u'فَسْخٌ يَمِينٌ':Added, #1: 1	فَسَخَ وَلِيُّهُ
u'فَسَدَ إِحْرَامٌ':Subject, #13: 13	فَسْخِ الْيَمِينِ
u'فَسَدَ إِحْرَامٌ':Subject, #1: 1	فَسَدَ إحْرَامٌ
u'فَسَدَ إِحْرَامٌ':Subject, #1: 1	فَسَدَ الْإِحْرَامُ
u'فَسَدَ أَدَاءٌ':Subject, #3: 3	فَسَدَ إحْرَامُهُ
u'فَسَدَ إِذْنٌ':Subject, #1: 1	فَسَدَ الْأَدَاءُ
u'فَسَدَ أرْضٌ':Subject, #1: 1	فَسَدَ الْإِذْنُ
u'فَسَدَ أصل':Subject, #1: 1	فَسَدَ أَرْضُ
u'فَسَدَ أًصْلٌ':Subject, #1: 1	فَسَدَ الْأَصْلُ
u'فَسَدَ اِعْتِكافٌ':Subject, #1: 1	فَسَدَ الْأَصْلُ
u'فَسَدَ اِقْتِداءٌ':Subject, #20: 20	فَسَدَ اعْتِكَافُهُ
u'فَسَدَ إقْرَارٌ':Subject, #1: 1	فَسَدَ اقْتِدَاءُ
u'فَسَدَ أقْرَبُ':Subject, #1: 1	فَسَدَ الْإِقْرَارُ
u'فَسَدَ أَمْرٌ':Subject, #1: 1	فَسَدَ أَقْرَبُ
u'فَسَدَ أَمْرٌ':Subject, #1: 1	فَسَدَ الْأَمْرُ
u'فَسَدَ أهْلٌ':Subject, #1: 1	فَسَدَ أَمْرُ
u'فَسَدَ أَوَّلُ':Subject, #1: 1	فَسَدَ أَهْلُ
u'فَسَدَ بَذْرٌ':Subject, #2: 2	فَسَدَ الْأَوَّلُ
u'فَسَدَ بَعْضٌ':Subject, #1: 1	فَسَدَ الْبَذْرُ
u'فَسَدَ بِئْرٌ':Subject, #1: 1	فَسَدَ بَعْضُ
u'فَسَدَ بَيْعٌ':Subject, #1: 1	فَسَدَ بِئْرُ
u'فَسَدَ بَيْعٌ':Subject, #118: 118	فَسَدَ الْبَيْعُ
u'فَسَدَ تَفْسِيرٌ':Subject, #1: 1	فَسَدَ بَيْعُهُ
u'فَسَدَ جُزْءٌ':Subject, #1: 1	فَسَدَ التَّفْسِيرُ
u'فَسَدَ جَسَدٌ':Subject, #2: 2	فَسَدَ الْجُزْءُ
u'فَسَدَ جَيْشٌ':Subject, #3: 3	فَسَدَ الْجَسَدُ
u'فَسَدَ حالٌ':Subject, #1: 1	فَسَدَ جَيْشٌ
u'فَسَدَ حَبٌّ':Subject, #1: 1	فَسَدَ حَالُ
u'فَسَدَ حَجٌّ':Subject, #2: 2	فَسَدَ الْحَبُّ
u'فَسَدَ حَجٌّ':Subject, #20: 20	فَسَدَ حَجُّهُ
u'فَسَدَ خُفٌّ':Subject, #7: 7	فَسَدَ الْحَجُّ
u'فَسَدَ خلق':Subject, #1: 1	فَسَدَ الْخُفُّ
u'فَسَدَ خَلْقٌ':Subject, #1: 1	فَسَدَ الْخَلْقُ
u'فَسَدَ خَمْسٌ':Subject, #1: 1	فَسَدَ الْخَلْقُ
u'فَسَدَ دَمٌ':Subject, #1: 1	فَسَدَ الْخَمْسُ
u'فَسَدَ دِينٌ':Subject, #1: 1	فَسَدَ الدَّمُ
u'فَسَدَ رَجُلٌ':Subject, #1: 1	فَسَدَ الدِّينُ
u'فَسَدَ رَهْنٌ':Subject, #1: 1	فَسَدَ الرَّجُلُ
u'فَسَدَ زَرْعٌ':Subject, #3: 3	فَسَدَ الرَّهْنُ
u'فَسَدَ زَرْعٌ':Subject, #2: 2	فَسَدَ الزَّرْعُ
u'فَسَدَ زَمانٌ':Subject, #2: 2	فَسَدَ زَرْعُهُ
u'فَسَدَ سَائِرٌ':Subject, #5: 5	فَسَدَ الزَّمَانُ
u'فَسَدَ سِجِلٌّ':Subject, #1: 1	فَسَدَ سَائِرُ
u'فَسَدَ سقط':Predicate, #1: 1	فَسَدَ السِّجِلُّ
u'فَسَدَ سَقَطٌ':Predicate, #1: 1	فَسَدَ سَقَطَ
u'فَسَدَ سَلَمٌ':Subject, #1: 1	فَسَدَ سَقَطَ
u'فَسَدَ سَمْعٌ':Subject, #1: 1	فَسَدَ السَّلَمُ
u'فَسَدَ سَواءٌ':Subject, #1: 1	فَسَدَ سَمْعُهُ
u'فَسَدَ شِرَاءٌ':Subject, #1: 1	فَسَدَ سَوَاءٌ
u'فَسَدَ شَرْطٌ':Subject, #1: 1	فَسَدَ الشِّرَاءُ
u'فَسَدَ شَفْعٌ':Subject, #12: 12	فَسَدَ الشَّرْطُ
u'فَسَدَ شَيْءٌ':Subject, #7: 7	فَسَدَ الشَّفْعُ
u'فَسَدَ صداق':Subject, #1: 1	فَسَدَ الشَّيْءُ
u'فَسَدَ صَدَاقٌ':Subject, #2: 2	فَسَدَ الصَّدَاقُ
u'فَسَدَ صَرْفٌ':Subject, #2: 2	فَسَدَ الصَّدَاقُ
u'فَسَدَ صَرْف':Subject, #3: 3	فَسَدَ الصَّرْفُ
u'فَسَدَ صلح':Subject, #3: 3	فَسَدَ الصَّرْفُ
u'فَسَدَ صُلْحٌ':Subject, #6: 6	فَسَدَ الصُّلْحُ
u'فَسَدَ صَوْمٌ':Subject, #6: 6	فَسَدَ الصُّلْحُ
u'فَسَدَ صَوْمٌ':Subject, #2: 2	فَسَدَ الصَّوْمُ
u'فَسَدَ صَوْمٌ':Subject, #3: 3	فَسَدَ صَوْمُ
u'فَسَدَ ضَمَانٌ':Subject, #61: 61	فَسَدَ صَوْمُهُ
u'فَسَدَ ضَمِنٌ':Predicate, #1: 1	فَسَدَ الضَّمَانُ
u'فَسَدَ طَبْعٌ':Subject, #1: 1	فَسَدَ ضَمِنَ
u'فَسَدَ ظُهْرٌ':Subject, #1: 1	فَسَدَ الطَّبْعُ
u'فَسَدَ عَقْدٌ':Subject, #4: 4	فَسَدَ ظُهْرُهُ
u'فَسَدَ عَقْدٌ':Subject, #2: 2	فَسَدَ عَقْدُ
u'فَسَدَ عَقْلٌ':Subject, #58: 58	فَسَدَ الْعَقْدُ
u'فَسَدَ عَمَلٌ':Subject, #2: 2	فَسَدَ عَقْلُهُ
u'فَسَدَ عند':Predicate, #1: 1	فَسَدَ الْعَمَلُ
u'فَسَدَ عِوَضٌ':Subject, #4: 4	فَسَدَ عِنْدَ
u'فَسَدَ عِوَضٌ':Subject, #1: 1	فَسَدَ عِوَضُ
u'فَسَدَ غير':Subject, #2: 2	فَسَدَ الْعِوَضُ
u'فَسَدَ غَيْرٌ':Subject, #1: 1	فَسَدَ غَيْرُهُ
u'فَسَدَ فَجْرٌ':Subject, #1: 1	فَسَدَ غَيْرُهُ
u'فَسَدَ فَرْضٌ':Subject, #1: 1	فَسَدَ فَجْرُهُ
u'فَسَدَ فَرْضٌ':Subject, #1: 1	فَسَدَ الْفَرْضُ
u'فَسَدَ فَرْضٌ':Subject, #1: 1	فَسَدَ فَرْضُ
u'فَسَدَ قَالٌ':Predicate, #2: 2	فَسَدَ فَرْضُهُ
u'فَسَدَ قَبْضٌ':Subject, #2: 2	فَسَدَ قَالَ
u'فَسَدَ قراض':Subject, #2: 2	فَسَدَ الْقَبْضُ
u'فَسَدَ قَضَاءٌ':Subject, #5: 5	فَسَدَ الْقِرَاضُ
u'فَسَدَ قِيَاسٌ':Subject, #1: 1	فَسَدَ الْقَضَاءُ
u'فَسَدَ كِرَاءٌ':Subject, #1: 1	فَسَدَ الْقِيَاسُ
u'فَسَدَ لبن':Subject, #2: 2	فَسَدَ الْكِرَاءُ
u'فَسَدَ لَبِنٌ':Subject, #1: 1	فَسَدَ اللَّبِنُ
u'فَسَدَ لَحْمٌ':Subject, #1: 1	فَسَدَ اللَّبِنُ
u'فَسَدَ لعان':Subject, #1: 1	فَسَدَ اللَّحْمُ
u'فَسَدَ مَاءٌ':Subject, #1: 1	فَسَدَ لِعَانُهُ
u'فَسَدَ مَتَاعٌ':Subject, #2: 2	فَسَدَ الْمَاءُ
u'فَسَدَ مُتَضَمَّن':Subject, #3: 3	فَسَدَ الْمَتَاعُ
u'فَسَدَ مُتَضَمِّن':Subject, #1: 1	فَسَدَ الْمُتَضَمَّنُ
u'فَسَدَ مَجْمُوعٌ':Subject, #1: 1	فَسَدَ الْمُتَضَمِّنُ
u'فَسَدَ مُفَسَّرٌ':Subject, #1: 1	فَسَدَ مَجْمُوعُ
u'فَسَدَ مَكْتُوبٌ':Subject, #1: 1	فَسَدَ الْمُفَسَّرُ
u'فَسَدَ مَلِكٌ':Subject, #1: 1	فَسَدَ الْمَكْتُوبُ
u'فَسَدَ مِلْكٌ':Subject, #1: 1	فَسَدَ الْمَلِكُ
u'فَسَدَ مَهْرٌ':Subject, #1: 1	فَسَدَ الْمِلْكُ
u'فَسَدَ نَاسٌ':Subject, #1: 1	فَسَدَ الْمَهْرُ
u'فَسَدَ نُسُكٌ':Subject, #4: 4	فَسَدَ النَّاسُ
u'فَسَدَ نَصِيبٌ':Subject, #7: 7	فَسَدَ نُسُكُهُ
u'فَسَدَ نكاح':Subject, #1: 1	فَسَدَ نَصِيبُ
u'فَسَدَ نِكَاحٌ':Subject, #25: 25	فَسَدَ النِّكَاحُ
u'فَسَدَ نكاح':Subject, #25: 25	فَسَدَ النِّكَاحُ
u'فَسَدَ نِكَاحٌ':Subject, #3: 3	فَسَدَ نِكَاحُهُ
u'فَسَدَ نكاح':Subject, #3: 3	فَسَدَ نِكَاحُهُ
u'فَسَدَ نِكَاحٌ':Subject, #9: 9	فَسَدَ نِكَاحُ
u'فَسَدَ نُكْتَةٌ':Subject, #9: 9	فَسَدَ نِكَاحُ
u'فَسَدَ هضم':Subject, #1: 1	فَسَدَ النُّكْتَةُ
u'فَسَدَ هَضْمٌ':Subject, #1: 1	فَسَدَ هَضْمُهُ
u'فَسَدَ وَجَبٌ':Predicate, #1: 1	فَسَدَ هَضْمُهُ
u'فَسَدَ وَصْفٌ':Subject, #2: 2	فَسَدَ وَجَبَ
u'فَسَدَ وُضُوءٌ':Subject, #1: 1	فَسَدَ وَصْفُ
u'فَسَدَ وَقْفٌ':Subject, #1: 1	فَسَدَ وُضُوءُهُ
u'فَسَّرَ اِبْنٌ':Subject, #1: 1	فَسَدَ الْوَقْفُ
u'فَسَّرَ إتْمَامٌ':Predicate, #8: 8	فَسَّرَ ابْنُ
u'فَسَّرَ إِجْحَافٌ':Predicate, #1: 1	فَسَّرَ الْإِتْمَامَ
u'فَسَّرَ أَجْزَاءٌ':Predicate, #1: 1	فَسَّرَ الْإِجْحَافَ
u'فَسَّرَ إِخْوَةٌ':Predicate, #1: 1	فَسَّرَ الْأَجْزَاءَ
u'فَسَّرَ إِذْنٌ':Predicate, #1: 1	فَسَّرَ الْإِخْوَةَ
u'فَسَّرَ أَصْحَابٌ':Subject, #1: 1	فَسَّرَ الْإِذْنَ
u'فَسَّرَ أُصولٌ':Predicate, #4: 4	فَسَّرَ الْأَصْحَابُ
u'فَسَّرَ ألف':Predicate, #1: 1	فَسَّرَ أُصُولَ
u'فَسَّرَ ألْفٌ':Predicate, #4: 4	فَسَّرَ الْأَلْفَ
u'فَسَّرَ أَلْفٌ':Predicate, #4: 4	فَسَّرَ الْأَلْفَ
u'فَسَّرَ إمَامٌ':Subject, #4: 4	فَسَّرَ الْأَلْفَ
u'فَسَّرَ إيمَانٌ':Predicate, #3: 3	فَسَّرَ الْإِمَامُ
u'فَسَّرَ بَاضِعٌ':Predicate, #1: 1	فَسَّرَ الْإِيمَانَ
u'فَسَّرَ بِشارَةٌ':Predicate, #1: 1	فَسَّرَ الْبَاضِعَةَ
u'فَسَّرَ بَعْضٌ':Predicate, #1: 1	فَسَّرَ الْبِشَارَةَ
u'فَسَّرَ تَبْدِيلٌ':Predicate, #1: 1	فَسَّرَ الْبَعْضَ
u'فَسَّرَ تَغَيُّرٌ':Predicate, #1: 1	فَسَّرَ التَّبْدِيلَ
u'فَسَّرَ تَمْر':Predicate, #1: 1	فَسَّرَ تَغَيُّرَ
u'فَسَّرَ تَنْفِيذٌ':Predicate, #1: 1	فَسَّرَ التَّمْرَ
u'فَسَّرَ تَوَشُّحٌ':Predicate, #1: 1	فَسَّرَ التَّنْفِيذَ
u'فَسَّرَ ثَانِي':Predicate, #1: 1	فَسَّرَ التَّوَشُّحَ
u'فَسَّرَ جَوْهَرِيٌّ':Subject, #1: 1	فَسَّرَ الثَّانِيَ
u'فَسَّرَ حَذْف':Predicate, #3: 3	فَسَّرَ الْجَوْهَرِيُّ
u'فَسَّرَ حَقٌّ':Predicate, #1: 1	فَسَّرَ الْحَذْفَ
u'فَسَّرَ حَقِيقٌ':Predicate, #1: 1	فَسَّرَ الْحَقَّ
u'فَسَّرَ حَقِيقَةٌ':Predicate, #1: 1	فَسَّرَ حَقِيقَةَ
u'فَسَّرَ خَادِمٌ':Predicate, #1: 1	فَسَّرَ حَقِيقَةَ
u'فَسَّرَ خَتْمٌ':Predicate, #1: 1	فَسَّرَ الْخَادِمَ
u'فَسَّرَ دَابَّةٌ':Predicate, #1: 1	فَسَّرَ خَتْمَ
u'فَسَّرَ دُلوكٌ':Predicate, #1: 1	فَسَّرَ الدَّابَّةَ
u'فَسَّرَ ذَوْدٌ':Predicate, #1: 1	فَسَّرَ دُلُوكَ
u'فَسَّرَ رَسُولٌ':Subject, #1: 1	فَسَّرَ الذَّوْدَ
u'فَسَّرَ زَكاةٌ':Predicate, #2: 2	فَسَّرَ رَسُولُ
u'فَسَّرَ زُيوفٌ':Predicate, #1: 1	فَسَّرَ الزَّكَاةَ
u'فَسَّرَ زُيُوفٌ':Predicate, #1: 1	فَسَّرَ الزُّيُوفَ
u'فَسَّرَ سَبِيلٌ':Predicate, #1: 1	فَسَّرَ الزُّيُوفَ
u'فَسَّرَ سَعْدٌ':Subject, #2: 2	فَسَّرَ السَّبِيلَ
u'فَسَّرَ سَعِيدٌ':Subject, #1: 1	فَسَّرَ سَعْدُ
u'فَسَّرَ شافِعِيّ':Subject, #1: 1	فَسَّرَ سَعِيدُ
u'فَسَّرَ شمس':Subject, #3: 3	فَسَّرَ الشَّافِعِيُّ
u'فَسَّرَ شَمْسٌ':Subject, #2: 2	فَسَّرَ شَمْسُ
u'فَسَّرَ شُمُول':Predicate, #2: 2	فَسَّرَ شَمْسُ
u'فَسَّرَ شَيْخٌ':Subject, #1: 1	فَسَّرَ شُمُولَ
u'فَسَّرَ صَاحِبٌ':Subject, #1: 1	فَسَّرَ الشَّيْخُ
u'فَسَّرَ صِحَّةٌ':Predicate, #2: 2	فَسَّرَ صَاحِبُ
u'فَسَّرَ صدقة':Predicate, #1: 1	فَسَّرَ الصِّحَّةَ
u'فَسَّرَ صَدَقَةٌ':Predicate, #1: 1	فَسَّرَ الصَّدَقَةَ
u'فَسَّرَ صَرْفٌ':Predicate, #1: 1	فَسَّرَ الصَّدَقَةَ
u'فَسَّرَ صَرْف':Predicate, #1: 1	فَسَّرَ الصَّرْفَ
u'فَسَّرَ ضَيْعَةٌ':Predicate, #1: 1	فَسَّرَ الصَّرْفَ
u'فَسَّرَ طَاعُونٌ':Predicate, #1: 1	فَسَّرَ الضَّيْعَةَ
u'فَسَّرَ عُذْرٌ':Predicate, #1: 1	فَسَّرَ الطَّاعُونَ
u'فَسَّرَ عِصْمَةٌ':Predicate, #1: 1	فَسَّرَ الْعُذْرَ
u'فَسَّرَ عَقَارٌ':Predicate, #1: 1	فَسَّرَ الْعِصْمَةَ
u'فَسَّرَ عَقْلٌ':Predicate, #1: 1	فَسَّرَ الْعَقَارَ
u'فَسَّرَ عَمَلٌ':Predicate, #1: 1	فَسَّرَ الْعَقْلَ
u'فَسَّرَ غُسْلٌ':Predicate, #2: 2	فَسَّرَ الْعَمَلَ
u'فَسَّرَ غَيْبَةٌ':Predicate, #1: 1	فَسَّرَ الْغُسْلَ
u'فَسَّرَ فَاحِشٌ':Predicate, #1: 1	فَسَّرَ الْغَيْبَةَ
u'فَسَّرَ فخر':Subject, #1: 1	فَسَّرَ الْفَاحِشَةَ
u'فَسَّرَ فَخْرٌ':Subject, #1: 1	فَسَّرَ فَخْرُ
u'فَسَّرَ فُرْجَةٌ':Predicate, #1: 1	فَسَّرَ فَخْرُ
u'فَسَّرَ فلان':Subject, #1: 1	فَسَّرَ الْفُرْجَةَ
u'فَسَّرَ قَبِيحٌ':Predicate, #3: 3	فَسَّرَ الشَّافِعِيُّ
u'فَسَّرَ قَصْرٌ':Predicate, #1: 1	فَسَّرَ الْقَبِيحَ
u'فَسَّرَ قَلِيلٌ':Predicate, #1: 1	فَسَّرَ الْقَصْرَ
u'فَسَّرَ قول':Predicate, #1: 1	فَسَّرَ قَلِيلَ
u'فَسَّرَ قَوْلٌ':Predicate, #1: 1	فَسَّرَ الْقَوْلَ
u'فَسَّرَ قول':Predicate, #1: 1	فَسَّرَ الْقَوْلَ
u'فَسَّرَ قَوْلٌ':Predicate, #1: 1	فَسَّرَ قَوْلَ
u'فَسَّرَ قِيَاسٌ':Predicate, #1: 1	فَسَّرَ قَوْلَ
u'فَسَّرَ كَسَادٌ':Predicate, #1: 1	فَسَّرَ قِيَاسَ
u'فَسَّرَ كَفَالَةٌ':Predicate, #1: 1	فَسَّرَ الْكَسَادَ
u'فَسَّرَ كفر':Predicate, #1: 1	فَسَّرَ الْكَفَالَةَ
u'فَسَّرَ كُفْرٌ':Predicate, #1: 1	فَسَّرَ كُفْرَ
u'فَسَّرَ كِنَايَةٌ':Predicate, #1: 1	فَسَّرَ كُفْرَ
u'فَسَّرَ كَوْنٌ':Predicate, #1: 1	فَسَّرَ الْكِنَايَةَ
u'فَسَّرَ لَفْظٌ':Predicate, #1: 1	فَسَّرَ كَوْنَ
u'فَسَّرَ مَالِكٌ':Subject, #2: 2	فَسَّرَ اللَّفْظَ
u'فَسَّرَ مَانِعٌ':Predicate, #1: 1	فَسَّرَ مَالِكٌ
u'فَسَّرَ مَتَاعٌ':Predicate, #1: 1	فَسَّرَ الْمَانِعَ
u'فَسَّرَ مُتَشَابِهٌ':Predicate, #1: 1	فَسَّرَ الْمَتَاعَ
u'فَسَّرَ مثل':Predicate, #2: 2	فَسَّرَ الْمُتَشَابِهَ
u'فَسَّرَ مِثْلٌ':Predicate, #1: 1	فَسَّرَ الْمِثْلَ
u'فَسَّرَ مُجَاهِدٌ':Subject, #1: 1	فَسَّرَ الْمِثْلَ
u'فَسَّرَ مُحَمَّدٌ':Subject, #1: 1	فَسَّرَ مُجَاهِدٌ
u'فَسَّرَ مراد':Predicate, #2: 2	فَسَّرَ مُحَمَّدٌ
u'فَسَّرَ مُرَادٌ':Predicate, #1: 1	فَسَّرَ مُرَادَ
u'فَسَّرَ مراد':Predicate, #1: 1	فَسَّرَ مُرَادَ
u'فَسَّرَ مُرَادٌ':Predicate, #2: 2	فَسَّرَ الْمُرَادَ
u'فَسَّرَ مَرَاعِي':Predicate, #2: 2	فَسَّرَ الْمُرَادَ
u'فَسَّرَ مُرَاهِقٌ':Predicate, #1: 1	فَسَّرَ الْمَرَاعِيَ
u'فَسَّرَ مُصَنِّفٌ':Subject, #1: 1	فَسَّرَ الْمُرَاهِقَ
u'فَسَّرَ مَنْطُوقٌ':Predicate, #3: 3	فَسَّرَ الْمُصَنِّفُ
u'فَسَّرَ نَبِيٌّ':Subject, #1: 1	فَسَّرَ الْمَنْطُوقَ
u'فَسَّرَ نسخة':Predicate, #2: 2	فَسَّرَ النَّبِيُّ
u'فَسَّرَ نُسْخَةٌ':Predicate, #1: 1	فَسَّرَ النُّسْخَةَ
u'فَسَّرَ نَصٌّ':Predicate, #1: 1	فَسَّرَ النُّسْخَةَ
u'فَسَّرَ نصاب':Predicate, #1: 1	فَسَّرَ النَّصَّ
u'فَسَّرَ نِصَابٌ':Predicate, #1: 1	فَسَّرَ النِّصَابَ
u'فَسَّرَ نكاح':Predicate, #1: 1	فَسَّرَ النِّصَابَ
u'فَسَّرَ نِكَاحٌ':Predicate, #1: 1	فَسَّرَ النِّكَاحَ
u'فَسَّرَ نَوَوِيٌّ':Subject, #1: 1	فَسَّرَ النِّكَاحَ
u'فَسَّرَ نِيَّةٌ':Predicate, #1: 1	فَسَّرَ النَّوَوِيُّ
u'فَسَّرَ وَاجِبٌ':Predicate, #1: 1	فَسَّرَ النِّيَّةَ
u'فَسَّرَ وَجْهٌ':Predicate, #1: 1	فَسَّرَ الْوَاجِبَ
u'فَسَّرَ وَدِيعٌ':Predicate, #1: 1	فَسَّرَ وَجْهَ
u'فَسَّرَ وَدِيعَةٌ':Predicate, #2: 2	فَسَّرَ الْوَدِيعَةَ
u'فَسَّرَ وَقْفٌ':Predicate, #2: 2	فَسَّرَ الْوَدِيعَةَ
u'فَسَّرَ وَكْز':Predicate, #1: 1	فَسَّرَ الْوَقْفَ
u'فِسْقٌ أَبٌ':Added, #1: 1	فَسَّرَ الْوَكْزَ
u'فِسْقٌ أحَدٌ':Added, #1: 1	فِسْقَ الْأَبِ
u'فَسَقَ أصل':Subject, #1: 1	فِسْقِ أَحَدِ
u'فَسَقَ أًصْلٌ':Subject, #1: 1	فَسَقَ الْأَصْلُ
u'فِسْقٌ أصل':Added, #1: 1	فَسَقَ الْأَصْلُ
u'فِسْقٌ أًصْلٌ':Added, #2: 2	فِسْقِ الْأَصْلِ
u'فِسْقٌ بَاطن':Added, #2: 2	فِسْقِ الْأَصْلِ
u'فِسْقٌ باطِنٌ':Added, #1: 1	فِسْقٍ بَاطِنٍ
u'فِسْقٌ رَاوِي':Added, #1: 1	فِسْقٍ بَاطِنٍ
u'فِسْقٌ رَجُلٌ':Added, #1: 1	فِسْقِ رَاوِيهِ
u'فَسَقَ شَاهِدٌ':Subject, #1: 1	فِسْقِ رَجُلٍ
u'فِسْقٌ شَاهِدٌ':Added, #2: 2	فَسَقَ الشَّاهِدُ
u'فِسْقٌ شَاهِدٌ':Added, #1: 1	فِسْقُ الشَّاهِدَيْنِ
u'فِسْقٌ شَاهِدٌ':Added, #2: 2	فِسْقَ الشَّاهِدَيْنِ
u'فِسْقٌ شَاهِدٌ':Added, #3: 3	فِسْقَ الشَّاهِدِ
u'فِسْقٌ شَاهِدٌ':Added, #4: 4	فِسْقُ الشَّاهِدِ
u'فِسْقٌ شَاهِدٌ':Added, #4: 4	فِسْقِ الشَّاهِدِ
u'فِسْقٌ شُهُودٌ':Added, #5: 5	فِسْقِ الشَّاهِدَيْنِ
u'فِسْقٌ شُهُودٌ':Added, #1: 1	فِسْقُ الشُّهُودِ
u'فِسْقٌ شُهُودٌ':Added, #2: 2	فِسْقَ الشُّهُودِ
u'فِسْقٌ طَارِئٌ':Added, #5: 5	فِسْقِ الشُّهُودِ
u'فِسْقٌ ظاهِرٌ':Added, #3: 3	فِسْقٍ طَارِئٍ
u'فِسْقٌ فَاسِقٌ':Added, #1: 1	فِسْقٍ ظَاهِرٍ
u'فِسْقٌ قَائِلٌ':Added, #1: 1	فِسْقُ الْفَاسِقِ
u'فَسَقَ كَاتِبٌ':Subject, #1: 1	فِسْقَ قَائِلِهِ
u'فِسْقٌ كفر':Added, #2: 2	فَسَقَ الْكَاتِبُ
u'فِسْقٌ كُفْرٌ':Added, #1: 1	فِسْقُ الْكُفْرِ
u'فَسَقَ مُرْتَهِنٌ':Subject, #1: 1	فِسْقُ الْكُفْرِ
u'فِسْقٌ مُسْتَأْجِرٌ':Added, #1: 1	فَسَقَ الْمُرْتَهِنُ
u'فِسْقٌ مُعَيَّنٌ':Added, #1: 1	فِسْقِ مُسْتَأْجِرٍ
u'فِسْقٌ مُقَارِنٌ':Added, #1: 1	فِسْقَ الْمُعَيَّنِ
u'فَسَقَ نَاظِرٌ':Subject, #1: 1	فِسْقٍ مُقَارِنٍ
u'فِسْقٌ نَاظِرٌ':Added, #1: 1	فَسَقَ النَّاظِرُ
u'فِسْقٌ وَالِدٌ':Added, #1: 1	فِسْقِ النَّاظِرِ
u'فَسَقَ وَجَارٌ':Predicate, #1: 1	فِسْقَ الْوَالِدَيْنِ
u'فِسْقٌ ولد':Added, #1: 1	فَسَقَ وَجَارَ
u'فِسْقٌ وَلَدٌ':Added, #3: 3	فِسْقَ الْوَلَدِ
u'فَسَقَ وَلِيٌّ':Subject, #3: 3	فِسْقَ الْوَلَدِ
u'فِسْقٌ وَلِيٌّ':Added, #3: 3	فَسَقَ الْوَلِيُّ
u'فِسْقٌ وَلِيٌّ':Added, #1: 1	فِسْقَ الْوَلِيِّ
u'فِسْقٌ وَلِيٌّ':Added, #1: 1	فِسْقُ الْوَلِيِّ
u'فَشَا إِسْلامٌ':Subject, #3: 3	فِسْقِ الْوَلِيِّ
u'فَشَا أَمْرٌ':Subject, #2: 2	فَشَا الْإِسْلَامُ
u'فَشَا ذكر':Subject, #1: 1	فَشَا أَمْرُ
u'فَشَا ذِكْرٌ':Subject, #1: 1	فَشَا ذِكْرُ
u'فَشَلٌ بَعْضٌ':Added, #1: 1	فَشَا ذِكْرُ
u'فَصَاحَةٌ اِبْنٌ':Added, #1: 1	فَشَلُ بَعْضِ
u'فَصَاحَةٌ أحَدٌ':Added, #1: 1	فَصَاحَةُ ابْنِ
u'فَصَاحَةٌ أَلْفَاظٌ':Added, #1: 1	فَصَاحَةُ أَحَدِ
u'فَصَاحَةٌ أَلْفَاظٌ':Added, #1: 1	فَصَاحَةِ الْأَلْفَاظِ
u'فَصَاحَةٌ عَرَبٌ':Added, #2: 2	فَصَاحَةُ الْأَلْفَاظِ
u'فَصَاحَةٌ قُرْآنٌ':Added, #1: 1	فَصَاحَةِ الْعَرَبِ
u'فَصَاحَةٌ لِسَانٌ':Added, #1: 1	فَصَاحَةَ الْقُرْآنِ
u'فَصَدَ أَجْنَبِيٌّ':Subject, #1: 1	فَصَاحَةُ لِسَانِهِ
u'فَصْلٌ إبَاءٌ':Added, #1: 1	فَصَدَ أَجْنَبِيٌّ
u'فَصْلٌ إِبِلٌ':Added, #1: 1	فَصْلِ الْإِبَاءِ
u'فَصَّلَ اِبْنٌ':Subject, #1: 1	فَصْلُ الْإِبِلِ
u'فَصْلٌ إجَارَةٌ':Added, #2: 2	فَصَّلَ ابْنُ
u'فَصْلٌ إجَارَةٌ':Added, #2: 2	فَصْلِ إجَارَةِ
u'فَصْلٌ أَجَلٌ':Added, #2: 2	فَصْلِ الْإِجَارَةِ
u'فَصَلَ أحَدٌ':Subject, #1: 1	فَصْلِ الْأَجَلِ
u'فَصَلَ أَحْكَامٌ':Predicate, #1: 1	فَصَلَ أَحَدُ
u'فَصْلٌ أَحْكَامٌ':Added, #1: 1	فَصَلَ أَحْكَامَ
u'فَصْلٌ اِخْتِلاَفٌ':Added, #2: 2	فَصْلِ أَحْكَامِ
u'فَصَلَ آخِرُ':Predicate, #1: 1	فَصْلِ اخْتِلَافِ
u'فَصَلَ أَخِيرٌ':Predicate, #1: 1	فَصَلَ آخِرَ
u'فَصْلٌ أَدَاءٌ':Added, #1: 1	فَصَلَ الْأَخِيرَةَ
u'فَصْلٌ آدابٌ':Added, #2: 2	فَصْلِ أَدَاءِ
u'فَصْلٌ آدَمِيٌّ':Added, #2: 2	فَصْلِ آدَابِ
u'فَصْلٌ أَذَانٌ':Added, #1: 1	فَصْلُ الْآدَمِيِّ
u'فَصْلٌ إِرْثٌ':Added, #1: 1	فَصْلِ الْأَذَانِ
u'فَصْلٌ أرْضٌ':Added, #1: 1	فَصْلِ الْإِرْثِ
u'فَصْلٌ أَرْكانٌ':Added, #2: 2	فَصْلِ أَرْضِ
u'فَصْلٌ أَرْكَانٌ':Added, #1: 1	فَصْلِ أَرْكَانِ
u'فَصْلٌ أَرْكانٌ':Added, #1: 1	فَصْلِ أَرْكَانِ
u'فَصْلٌ أَرْكَانٌ':Added, #1: 1	فَصْلِ الْأَرْكَانِ
u'فَصْلٌ إِزَالَةٌ':Added, #1: 1	فَصْلِ الْأَرْكَانِ
u'فَصْلٌ أَسْآرٌ':Added, #1: 1	فَصْلِ إزَالَةِ
u'فَصْلٌ اِسْتِنابَة':Added, #1: 1	فَصْلِ الْأَسْآرِ
u'فَصْلٌ إِسْقاطٌ':Added, #3: 3	فَصْلِ اسْتِنَابَةِ
u'فَصْلٌ اِشْتِراطٌ':Added, #1: 1	فَصْلِ إسْقَاطِ
u'فَصْلٌ أَصْحَابٌ':Added, #1: 1	فَصْلِ اشْتِرَاطِ
u'فَصْلٌ إضافَةٌ':Added, #1: 1	فَصْلِ أَصْحَابِ
u'فَصْلٌ إِعْتاقٌ':Added, #5: 5	فَصْلِ إضَافَةِ
u'فَصْلٌ إِعْتاقٌ':Added, #1: 1	فَصْلِ إعْتَاقِ
u'فَصْلٌ اِعْتِبارٌ':Added, #2: 2	فَصْلِ الْإِعْتَاقِ
u'فَصْلٌ أَعْذَارٌ':Added, #1: 1	فَصْلِ اعْتِبَارِ
u'فَصْلٌ إقالَةٌ':Added, #2: 2	فَصْلِ الْأَعْذَارِ
u'فَصْلٌ إقامَةٌ':Added, #1: 1	فَصْلُ الْإِقَالَةِ
u'فَصْلٌ إقْرَارٌ':Added, #1: 1	فَصْلِ إقَامَةِ
u'فَصْلٌ إقْرَارٌ':Added, #1: 1	فَصْلُ إقْرَارِ
u'فَصْلٌ إقْرَارٌ':Added, #1: 1	فَصْلِ إقْرَارِ
u'فَصْلٌ أكل':Added, #8: 8	فَصْلِ الْإِقْرَارِ
u'فَصْلٌ أَكْلٌ':Added, #2: 2	فَصْلَ الْأَكْلِ
u'فَصْلٌ أكل':Added, #2: 2	فَصْلَ الْأَكْلِ
u'فَصْلٌ أَكْلٌ':Added, #8: 8	فَصْلِ الْأَكْلِ
u'فَصْلٌ أَلْفَاظٌ':Added, #8: 8	فَصْلِ الْأَكْلِ
u'فَصْلٌ أُمٌّ':Added, #1: 1	فَصْلُ أَلْفَاظِ
u'فَصَّلَ إمَامٌ':Subject, #1: 1	فَصْلُ أُمِّ
u'فَصْلٌ أمَانٌ':Added, #1: 1	فَصَّلَ الْإِمَامُ
u'فَصْلٌ اِمْتِناعٌ':Added, #1: 1	فَصْلِ الْأَمَانِ
u'فَصْلٌ أَمْرٌ':Added, #1: 1	فَصْلِ امْتِنَاعِهِ
u'فَصْلٌ أَمْرٌ':Added, #11: 11	فَصْلِ الْأَمْرِ
u'فَصْلٌ أَمْرٌ':Added, #1: 1	فَصْلَ الْأَمْرِ
u'فَصْلٌ أُمَّهَاتٌ':Added, #1: 1	فَصْلُ الْأَمْرِ
u'فَصْلٌ اِنْتِهاءٌ':Added, #1: 1	فَصْلِ أُمَّهَاتِ
u'فَصْلٌ أَهْلِيٌّ':Added, #1: 1	فَصْلِ انْتِهَاءِ
u'فَصْلٌ أهْلِيَّةٌ':Added, #1: 1	فَصْلِ الْأَهْلِيَّةِ
u'فَصْلٌ أَوْقَاتٌ':Added, #1: 1	فَصْلِ الْأَهْلِيَّةِ
u'فَصْلٌ أَوَّلُ':Added, #1: 1	فَصْلِ الْأَوْقَاتِ
u'فَصَلَ بَائِعٌ':Subject, #1: 1	فَصْلُ الْأَوَّلِ
u'فَصْلٌ بِدَعٌ':Added, #2: 2	فَصَلَ الْبَائِعُ
u'فَصْلٌ بَرْدٌ':Added, #1: 1	فَصْلِ الْبِدَعِ
u'فَصَّلَ بَعْضٌ':Subject, #1: 1	فَصْلِ الْبَرْدِ
u'فَصْلٌ بَقَرٌ':Added, #2: 2	فَصَّلَ بَعْضُ
u'فَصْلٌ بِكْرٌ':Added, #1: 1	فَصْلَ الْبَقَرِ
u'فَصْلٌ بِنَاءٌ':Added, #1: 1	فَصْلُ الْبِكْرِ
u'فَصْلٌ بَيَاضٌ':Added, #3: 3	فَصْلِ الْبِنَاءِ
u'فَصْلٌ بَيَانٌ':Added, #1: 1	فَصْلِ بَيَاضِ
u'فَصْلٌ بَيَانٌ':Added, #1: 1	فَصْلِ الْبَيَانِ
u'فَصْلٌ بَيْعٌ':Added, #2: 2	فَصْلِ بَيَانِ
u'فَصْلٌ بَيْعٌ':Added, #2: 2	فَصْلَ الْبَيْعِ
u'فَصَّلَ بَيْنٌ':Predicate, #5: 5	فَصْلِ الْبَيْعِ
u'فَصَلَ بَيْنٌ':Predicate, #13: 13	فَصَّلَ بَيْنَ
u'فَصْلٌ بَيِّنَةٌ':Added, #29: 29	فَصَلَ بَيْنَ
u'فَصْلٌ تَحْرِيمٌ':Added, #3: 3	فَصْلِ الْبَيِّنَةِ
u'فَصْلٌ تَحْلِيف':Added, #1: 1	فَصْلِ تَحْرِيمِ
u'فَصْلٌ تَحْلِيلٌ':Added, #2: 2	فَصْلِ التَّحْلِيفِ
u'فَصْلٌ تَخَالُفٌ':Added, #1: 1	فَصْلِ التَّحْلِيلِ
u'فَصْلٌ تَدْبِيرٌ':Added, #1: 1	فَصْلِ التَّخَالُفِ
u'فَصْلٌ تَرَاوِيحُ':Added, #2: 2	فَصْلِ التَّدْبِيرِ
u'فَصْلٌ تَرْجِيحٌ':Added, #1: 1	فَصْلِ التَّرَاوِيحِ
u'فَصْلٌ تَزْوِيجٌ':Added, #5: 5	فَصْلِ التَّرْجِيحِ
u'فَصْلٌ تَسْمِيَة':Added, #1: 1	فَصْلِ تَزْوِيجِ
u'فَصْلٌ تَشَاجُرٌ':Added, #1: 1	فَصْلِ تَسْمِيَةِ
u'فَصْلٌ تَصْدِيقٌ':Added, #1: 1	فَصْلِ التَّشَاجُرِ
u'فَصْلٌ تَصَرُّفٌ':Added, #1: 1	فَصْلِ التَّصْدِيقِ
u'فَصْلٌ تَصْيِير':Added, #1: 1	فَصْلِ التَّصَرُّفِ
u'فَصْلٌ تَضْمِين':Added, #1: 1	فَصْلِ التَّصْيِيرِ
u'فَصْلٌ تَعَارُضٌ':Added, #1: 1	فَصْلِ التَّضْمِينِ
u'فَصْلٌ تَعَارُضٌ':Added, #2: 2	فَصْلُ التَّعَارُضِ
u'فَصْلٌ تَعْزِير':Added, #9: 9	فَصْلِ التَّعَارُضِ
u'فَصْلٌ تَعْلِيقٌ':Added, #6: 6	فَصْلِ التَّعْزِيرِ
u'فَصْلٌ تَعْلِيقٌ':Added, #1: 1	فَصْلِ التَّعْلِيقِ
u'فَصْلٌ تَعْلِيقٌ':Added, #1: 1	فَصْلِ تَعْلِيقِ
u'فَصْلٌ تَعْلِيقٌ':Added, #1: 1	فَصْلِ تَعْلِيقِهِ
u'فَصْلٌ تَعْلِيمٌ':Added, #2: 2	فَصْلِ التَّعْلِيقَاتِ
u'فَصَلَ تَفْسِيرٌ':Predicate, #2: 2	فَصْلِ تَعْلِيمِ
u'فَصَّلَ تَفْصِيلٌ':Predicate, #1: 1	فَصَلَ التَّفْسِيرَ
u'فَصْلٌ تَكْذيبٌ':Added, #1: 1	فَصَّلَ التَّفْصِيلَ
u'فَصْلٌ تَكْفيرٌ':Added, #1: 1	فَصْلِ التَّكْذِيبِ
u'فَصْلٌ تَلْفيقٌ':Added, #1: 1	فَصْلُ التَّكْفِيرِ
u'فَصْلٌ تَمْكِين':Added, #1: 1	فَصْلِ التَّلْفِيقِ
u'فَصْلٌ تَنَاقُضٌ':Added, #1: 1	فَصْلِ التَّمْكِينِ
u'فَصْلٌ تَنْبِيهٌ':Added, #7: 7	فَصْلِ التَّنَاقُضِ
u'فَصْلٌ تَنْجِيسٌ':Added, #1: 1	فَصْلِ تَنْبِيهِ
u'فَصْلٌ تَوابِعُ':Added, #1: 1	فَصْلِ التَّنْجِيسِ
u'فَصْلٌ تَوَابِعُ':Added, #1: 1	فَصْلُ التَّوَابِعِ
u'فَصْلٌ تَوَارُثٌ':Added, #1: 1	فَصْلُ التَّوَابِعِ
u'فَصْلٌ تَوَكُّلٌ':Added, #1: 1	فَصْلِ التَّوَارُثِ
u'فَصْلٌ تَوْكِيلٌ':Added, #1: 1	فَصْلِ التَّوَكُّلِ
u'فَصْلٌ تَوْلِيَةٌ':Added, #4: 4	فَصْلِ التَّوْكِيلِ
u'فَصْلٌ تَيَمُّمٌ':Added, #1: 1	فَصْلِ التَّوْلِيَةِ
u'فَصْلٌ تَيَمُّمٌ':Added, #1: 1	فَصْلُ التَّيَمُّمِ
u'فَصَلَ ثَالِثٌ':Predicate, #1: 1	فَصْلِ التَّيَمُّمِ
u'فَصْلٌ ثَانِي':Added, #2: 2	فَصَلَ الثَّالِثَةَ
u'فَصْلٌ ثَانِيَةٌ':Added, #1: 1	فَصْلُ الثَّانِيَةِ
u'فَصَلَ ثَمَنٌ':Predicate, #1: 1	فَصْلُ الثَّانِيَةِ
u'فَصَّلَ ثَمَنٌ':Predicate, #1: 1	فَصَلَ الثَّمَنَ
u'فَصْلٌ ثَمَنٌ':Added, #1: 1	فَصَّلَ الثَّمَنَ
u'فَصْلٌ جَارِي':Added, #1: 1	فَصْلُ الثَّمَنِ
u'فَصْلٌ جَارِيَةٌ':Added, #1: 1	فَصْلِ الْجَارِيَةِ
u'فَصْلٌ جُحُود':Added, #1: 1	فَصْلِ الْجَارِيَةِ
u'فَصْلٌ جَزَاءٌ':Added, #1: 1	فَصْلِ الْجُحُودِ
u'فَصْلٌ جِزْيَةٌ':Added, #1: 1	فَصْلِ جَزَاءِ
u'فَصْلٌ جَنَابَةٌ':Added, #2: 2	فَصْلِ الْجِزْيَةِ
u'فَصْلٌ جِنَايَةٌ':Added, #1: 1	فَصْلِ الْجَنَابَةِ
u'فَصْلٌ جَنِينٌ':Added, #3: 3	فَصْلِ الْجِنَايَةِ
u'فَصْلٌ جوارح':Added, #2: 2	فَصْلِ الْجَنِينِ
u'فَصْلٌ جوارح':Added, #1: 1	فَصْلَ الْجَوَارِحِ
u'فَصْلٌ جَوَارِحُ':Added, #1: 1	فَصْلِ الْجَوَارِحِ
u'فَصْلٌ جَوَارِحُ':Added, #1: 1	فَصْلَ الْجَوَارِحِ
u'فَصْلٌ حاكِمٌ':Added, #1: 1	فَصْلِ الْجَوَارِحِ
u'فَصْلٌ حَبْسٌ':Added, #10: 10	فَصْلِ الْحَاكِمِ
u'فَصْلٌ حَبْسٌ':Added, #1: 1	فَصْلُ الْحَبْسِ
u'فَصْلٌ حَجٌّ':Added, #6: 6	فَصْلِ الْحَبْسِ
u'فَصْلٌ حَدٌّ':Added, #2: 2	فَصْلِ الْحَجِّ
u'فَصْلٌ حَدَثٌ':Added, #1: 1	فَصْلِ الْحَدِّ
u'فَصْلٌ حَرٌّ':Added, #4: 4	فَصْلِ الْحَدَثِ
u'فَصْلٌ حُرٌّ':Added, #1: 1	فَصْلِ الْحَرِّ
u'فَصْلٌ حُروفٌ':Added, #1: 1	فَصْلِ الْحُرِّ
u'فَصْلٌ حِفْظٌ':Added, #1: 1	فَصْلِ الْحُرُوفِ
u'فَصْلٌ حُكْمٌ':Added, #1: 1	فَصْلِ حِفْظِ
u'فَصْلٌ حُكْمٌ':Added, #1: 1	فَصْلَ الْحُكْمِ
u'فَصْلٌ حُكْمٌ':Added, #1: 1	فَصْلُ الْحُكْمِ
u'فَصْلٌ حُكْمٌ':Added, #1: 1	فَصْلِ الْحُكْمِ
u'فَصْلٌ حُكْمٌ':Added, #1: 1	فَصْلَ حُكْمٍ
u'فَصْلٌ حُكْمٌ':Added, #1: 1	فَصْلُ حُكْمِ
u'فَصْلٌ حُكُومَةٌ':Added, #1: 1	فَصْلِ حُكْمِ
u'فَصْلٌ حُلِيٌّ':Added, #1: 1	فَصْلُ حُكُومَةٍ
u'فَصْلٌ حَمَّامٌ':Added, #1: 1	فَصْلِ الْحُلِيِّ
u'فَصْلٌ حَمْلٌ':Added, #2: 2	فَصْلِ الْحَمَّامِ
u'فَصْلٌ حَمْلٌ':Added, #1: 1	فَصْلُ الْحَمْلِ
u'فَصْلٌ حيطانٌ':Added, #1: 1	فَصْلِ الْحَمْلِ
u'فَصْلٌ خدمة':Added, #1: 1	فَصْلِ الْحِيطَانِ
u'فَصْلٌ خِدْمَةٌ':Added, #1: 1	فَصْلِ الْخِدْمَةِ
u'فَصْلٌ خراج':Added, #1: 1	فَصْلِ الْخِدْمَةِ
u'فَصْلٌ خَرَاجٌ':Added, #1: 1	فَصْلِ الْخَرَاجِ
u'فَصَلَ خُصُومَةٌ':Predicate, #1: 1	فَصْلِ الْخَرَاجِ
u'فَصْلٌ خُصُومَةٌ':Added, #1: 1	فَصَلَ الْخُصُومَةَ
u'فَصْلٌ خُصُومَةٌ':Added, #2: 2	فَصْلِ الْخُصُومَاتِ
u'فَصْلٌ خُصُومَةٌ':Added, #2: 2	فَصْلِ الْخُصُومَةِ
u'فَصْلٌ خُصُومَةٌ':Added, #3: 3	فَصْلُ الْخُصُومَاتِ
u'فَصْلٌ خَطَأٌ':Added, #5: 5	فَصْلُ الْخُصُومَةِ
u'فَصْلٌ خَطَّابٌ':Added, #2: 2	فَصْلِ الْخَطَأِ
u'فَصْلٌ خِطَابٌ':Added, #1: 1	فَصْلِ الْخَطَّابِ
u'فَصْلٌ خِطَابٌ':Added, #1: 1	فَصْلِ خِطَابِ
u'فَصْلٌ خِطَابٌ':Added, #2: 2	فَصْلَ الْخِطَابِ
u'فَصْلٌ خِطَابٌ':Added, #3: 3	فَصْلِ الْخِطَابِ
u'فَصَّلَ خِلاَفٌ':Predicate, #4: 4	فَصْلُ الْخِطَابِ
u'فَصْلٌ خُلْعٌ':Added, #1: 1	فَصَّلَ خِلَافَ
u'فَصْلٌ خُلْعٌ':Added, #1: 1	فَصْلُ الْخُلْعِ
u'فَصْلٌ خَلْوَةٌ':Added, #4: 4	فَصْلِ الْخُلْعِ
u'فَصْلٌ خيار':Added, #1: 1	فَصْلِ الْخَلْوَةِ
u'فَصْلٌ خِيَارٌ':Added, #1: 1	فَصْلُ الْخِيَارِ
u'فَصْلٌ خيار':Added, #1: 1	فَصْلُ الْخِيَارِ
u'فَصْلٌ خِيَارٌ':Added, #2: 2	فَصْلِ خِيَارِ
u'فَصْلٌ خَيَّاطٌ':Added, #2: 2	فَصْلِ خِيَارِ
u'فَصْلٌ دَارٌ':Added, #1: 1	فَصْلِ الْخَيَّاطِ
u'فَصْلٌ دفع':Added, #1: 1	فَصْلُ الدَّارِ
u'فَصْلٌ دَفْعٌ':Added, #1: 1	فَصْلِ الدَّفْعِ
u'فَصْلٌ دفع':Added, #1: 1	فَصْلِ الدَّفْعِ
u'فَصْلٌ دَفْعٌ':Added, #1: 1	فَصْلِ دَفْعِ
u'فَصْلٌ دفن':Added, #1: 1	فَصْلِ دَفْعِ
u'فَصْلٌ دَفْنٌ':Added, #1: 1	فَصْلِ الدَّفْنِ
u'فَصْلٌ دَمٌ':Added, #1: 1	فَصْلِ الدَّفْنِ
u'فَصْلٌ دُورٌ':Added, #1: 1	فَصْلِ دَمِ
u'فَصْلٌ دِيَةٌ':Added, #2: 2	فَصْلِ الدُّورِ
u'فَصْلٌ دَيْنٌ':Added, #1: 1	فَصْلُ الدِّيَةِ
u'فَصْلٌ ذال':Added, #1: 1	فَصْلِ الدَّيْنِ
u'فَصْلٌ ذَمٌّ':Added, #1: 1	فَصْلِ الذَّالِ
u'فَصَلَ رابع':Predicate, #1: 1	فَصْلِ ذَمِّ
u'فَصَلَ رَابِعٌ':Predicate, #1: 1	فَصَلَ الرَّابِعَةَ
u'فَصْلٌ رابع':Added, #1: 1	فَصَلَ الرَّابِعَةَ
u'فَصْلٌ رَابِعٌ':Added, #1: 1	فَصْلُ الرَّابِعَةِ
u'فَصْلٌ رَبِيعٌ':Added, #1: 1	فَصْلُ الرَّابِعَةِ
u'فَصْلٌ رَجُلٌ':Added, #2: 2	فَصْلِ الرَّبِيعِ
u'فَصْلٌ رُجُوعٌ':Added, #1: 1	فَصْلِ رَجُلٍ
u'فَصْلٌ رَدٌّ':Added, #2: 2	فَصْلِ الرُّجُوعِ
u'فَصْلٌ رِدَّةٌ':Added, #1: 1	فَصْلِ الرَّدِّ
u'فَصَلَ رَضيعٌ':Subject, #1: 1	فَصْلِ الرِّدَّةِ
u'فَصْلٌ رُطوبَةٌ':Added, #1: 1	فَصَلَ الرَّضِيعُ
u'فَصْلٌ رُكوعٌ':Added, #1: 1	فَصْلِ الرُّطُوبَةِ
u'فَصْلٌ رَمْيٌ':Added, #1: 1	فَصْلِ الرُّكُوعِ
u'فَصْلٌ رَهْنٌ':Added, #1: 1	فَصْلِ الرَّمْيِ
u'فَصْلٌ رُؤْيَةٌ':Added, #2: 2	فَصْلِ الرَّهْنِ
u'فَصْلٌ زَكاةٌ':Added, #2: 2	فَصْلِ رُؤْيَةِ
u'فَصْلٌ زَكاةٌ':Added, #1: 1	فَصْلُ الزَّكَاةِ
u'فَصْلٌ زَكاةٌ':Added, #1: 1	فَصْلَ زَكَاةِ
u'فَصْلٌ زَكاةٌ':Added, #2: 2	فَصْلِ زَكَاةِ
u'فَصْلٌ زِيادَةٌ':Added, #3: 3	فَصْلِ الزَّكَاةِ
u'فَصْلٌ سَاحَةٌ':Added, #2: 2	فَصْلِ الزِّيَادَةِ
u'فَصْلٌ سَتْرٌ':Added, #1: 1	فَصْلِ السَّاحَةِ
u'فَصْلٌ سُجُودٌ':Added, #1: 1	فَصْلِ سَتْرِ
u'فَصْلٌ سَرقَةٌ':Added, #1: 1	فَصْلِ سُجُودِ
u'فَصْلٌ سَرِقَةٌ':Added, #2: 2	فَصْلِ السَّرِقَةِ
u'فَصْلٌ سَفَرٌ':Added, #2: 2	فَصْلِ السَّرِقَةِ
u'فَصْلٌ سِلاَحٌ':Added, #1: 1	فَصْلِ السَّفَرِ
u'فَصْلٌ سَلَبٌ':Added, #1: 1	فَصْلِ السِّلَاحِ
u'فَصْلٌ سَهْوٌ':Added, #1: 1	فَصْلُ السَّلَبِ
u'فَصْلٌ سورٌ':Added, #1: 1	فَصْلِ السَّهْوِ
u'فَصْلٌ سُورَةٌ':Added, #1: 1	فَصْلَ السُّورَتَيْنِ
u'فَصَّلَ شافِع':Subject, #2: 2	فَصْلَ السُّورَةِ
u'فَصَّلَ شافِعِيّ':Subject, #1: 1	فَصَّلَ الشَّافِعِيَّةُ
u'فَصْلٌ شِتَاءٌ':Added, #1: 1	فَصَّلَ الشَّافِعِيَّةُ
u'فَصْلٌ شَجَّةٌ':Added, #1: 1	فَصْلِ الشِّتَاءِ
u'فَصْلٌ شِرَاءٌ':Added, #1: 1	فَصْلِ الشَّجَّةِ
u'فَصْلٌ شِرَاءٌ':Added, #2: 2	فَصْلَ الشِّرَاءِ
u'فَصْلٌ شِرَاءٌ':Added, #2: 2	فَصْلِ شِرَاءِ
u'فَصْلٌ شَرَائِطُ':Added, #7: 7	فَصْلِ الشِّرَاءِ
u'فَصْلٌ شركة':Added, #7: 7	فَصْلِ شَرَائِطِ
u'فَصْلٌ شَرِكَةٌ':Added, #2: 2	فَصْلِ شَرِكَةِ
u'فَصْلٌ شُرُوطٌ':Added, #2: 2	فَصْلِ شَرِكَةِ
u'فَصْلٌ شُرُوطٌ':Added, #1: 1	فَصْلِ شُرُوطِ
u'فَصْلٌ شفعة':Added, #4: 4	فَصْلِ الشُّرُوطِ
u'فَصْلٌ شُفْعَةٌ':Added, #1: 1	فَصْلَ الشُّفْعَةِ
u'فَصْلٌ شَهَادَةٌ':Added, #1: 1	فَصْلَ الشُّفْعَةِ
u'فَصْلٌ شَهَادَةٌ':Added, #1: 1	فَصْلِ شَهَادَةِ
u'فَصْلٌ صَبْغٌ':Added, #3: 3	فَصْلِ الشَّهَادَةِ
u'فَصْلٌ صَرَامَةٌ':Added, #1: 1	فَصْلُ الصَّبْغِ
u'فَصْلٌ صَلاَةٌ':Added, #1: 1	فَصْلِ صَرَامَةٍ
u'فَصْلٌ صَلاَةٌ':Added, #1: 1	فَصْلِ صَلَاةِ
u'فَصْلٌ صلح':Added, #7: 7	فَصْلِ الصَّلَاةِ
u'فَصْلٌ صُلْحٌ':Added, #2: 2	فَصْلِ الصُّلْحِ
u'فَصْلٌ ضاد':Added, #2: 2	فَصْلِ الصُّلْحِ
u'فَصْلٌ ضَرَرٌ':Added, #1: 1	فَصْلِ الضَّادِ
u'فَصْلٌ ضَعِيفٌ':Added, #2: 2	فَصْلَ الضَّرَرِ
u'فَصْلٌ ضَمِيرٌ':Added, #5: 5	فَصْلِ الضَّعِيفِ
u'فَصْلٌ طَرْدٌ':Added, #1: 1	فَصْلِ الضَّمِيرِ
u'فَصْلٌ طَلاَقٌ':Added, #1: 1	فَصْلِ الطَّرْدِ
u'فَصْلٌ ظهار':Added, #9: 9	فَصْلِ الطَّلَاقِ
u'فَصْلٌ عَامِلٌ':Added, #1: 1	فَصْلُ الظِّهَارِ
u'فَصَلَ عَبْدٌ':Predicate, #1: 1	فَصْلِ الْعَامِلِ
u'فَصْلٌ عَبْدٌ':Added, #1: 1	فَصَلَ عَبْدَ
u'فَصْلٌ عتق':Added, #1: 1	فَصْلِ الْعَبْدِ
u'فَصْلٌ عِتْقٌ':Added, #2: 2	فَصْلِ الْعِتْقِ
u'فَصْلٌ عَدَمٌ':Added, #2: 2	فَصْلِ الْعِتْقِ
u'فَصْلٌ عُرُوضٌ':Added, #1: 1	فَصْلِ عَدَمِ
u'فَصْلٌ عزل':Added, #1: 1	فَصْلَ الْعُرُوضِ
u'فَصْلٌ عِلَّةٌ':Added, #1: 1	فَصْلِ الْعَزْلِ
u'فَصْلٌ عِمَارَةٌ':Added, #5: 5	فَصْلِ الْعِلَّةِ
u'فَصْلٌ عَمْدٌ':Added, #1: 1	فَصْلِ الْعِمَارَةِ
u'فَصْلٌ عمرة':Added, #1: 1	فَصْلِ الْعَمْدِ
u'فَصْلٌ عُمْرَةٌ':Added, #1: 1	فَصْلِ الْعُمْرَةِ
u'فَصَلَ عند':Predicate, #1: 1	فَصْلِ الْعُمْرَةِ
u'فَصْلٌ عَوَارِضُ':Added, #1: 1	فَصَلَ عِنْدَ
u'فَصْلٌ عين':Added, #5: 5	فَصْلِ الْعَوَارِضِ
u'فَصْلٌ عَيْنٌ':Added, #1: 1	فَصْلِ الْعَيْنِ
u'فَصْلٌ عَيْن':Added, #1: 1	فَصْلِ الْعَيْنِ
u'فَصْلٌ عُيُوبٌ':Added, #1: 1	فَصْلِ الْعَيْنِ
u'فَصْلٌ غُرُورٌ':Added, #1: 1	فَصْلِ الْعُيُوبِ
u'فَصْلٌ غُسْلٌ':Added, #1: 1	فَصْلِ الْغُرُورِ
u'فَصْلٌ غُسْلٌ':Added, #1: 1	فَصْلَ الْغُسْلِ
u'فَصْلٌ غُسْلٌ':Added, #1: 1	فَصْلِ الْغُسْلِ
u'فَصْلٌ غَنَمٌ':Added, #2: 2	فَصْلِ غُسْلِ
u'فَصْلٌ فَاسِدٌ':Added, #1: 1	فَصْلِ الْغَنَمِ
u'فَصْلٌ فَرْجٌ':Added, #1: 1	فَصْلِ الْفَاسِدِ
u'فَصْلٌ فَسْخٌ':Added, #1: 1	فَصْلَ الْفَرْجِ
u'فَصْلٌ فَصِيلٌ':Added, #1: 1	فَصْلِ فَسْخِ
u'فَصْلٌ فِضَّةٌ':Added, #1: 1	فَصْلَ الْفَصِيلِ
u'فَصْلٌ فِضَّةٌ':Added, #1: 1	فَصْلَ الْفِضَّةِ
u'فَصَّلَ فلان':Subject, #5: 5	فَصْلِ الْفِضَّةِ
u'فَصَّلَ فلان':Subject, #1: 1	فَصَّلَ الشَّافِعِيَّةُ
u'فَصْلٌ قَافٌ':Added, #1: 1	فَصَّلَ الْقُرْطُبِيُّ
u'فَصْلٌ قتل':Added, #1: 1	فَصْلِ الْقَافِ
u'فَصْلٌ قَتْلٌ':Added, #1: 1	فَصْلِ قَتْلِ
u'فَصْلٌ قِرَاءةٌ':Added, #1: 1	فَصْلِ قَتْلِ
u'فَصْلٌ قِرَاءةٌ':Added, #2: 2	فَصْلِ قِرَاءَةِ
u'فَصْلٌ قُرْآنٌ':Added, #8: 8	فَصْلِ الْقِرَاءَةِ
u'فَصَّلَ قُرْطُبِيّ':Subject, #1: 1	فَصْلِ الْقُرْآنِ
u'فَصْلٌ قَزٌّ':Added, #1: 1	فَصَّلَ الْقُرْطُبِيُّ
u'فَصْلٌ قَسْمٌ':Added, #1: 1	فَصْلِ الْقَزِّ
u'فَصْلٌ قسمة':Added, #1: 1	فَصْلِ الْقَسْمِ
u'فَصْلٌ قِسْمَةٌ':Added, #2: 2	فَصْلِ قِسْمَةِ
u'فَصْلٌ قَصِيلٌ':Added, #2: 2	فَصْلِ قِسْمَةِ
u'فَصْلٌ قَضَاءٌ':Added, #1: 1	فَصْلَ الْقَصِيلِ
u'فَصْلٌ قَضَاءٌ':Added, #16: 16	فَصْلِ الْقَضَاءِ
u'فَصْلٌ قَضَاءٌ':Added, #1: 1	فَصْلِ قَضَاءِ
u'فَصْلٌ قَضَاءٌ':Added, #3: 3	فَصْلُ الْقَضَاءِ
u'فَصْلٌ قول':Added, #6: 6	فَصْلَ الْقَضَاءِ
u'فَصْلٌ قَوْلٌ':Added, #1: 1	فَصْلُ قَوْلِ
u'فَصْلٌ قيام':Added, #1: 1	فَصْلُ قَوْلِ
u'فَصْلٌ قِيَامٌ':Added, #1: 1	فَصْلِ الْقِيَامِ
u'فَصْلٌ كَامِلٌ':Added, #1: 1	فَصْلِ الْقِيَامِ
u'فَصْلٌ كِتَابَةٌ':Added, #2: 2	فَصْلٍ كَامِلٍ
u'فَصْلٌ كَرَاهَةٌ':Added, #2: 2	فَصْلِ الْكِتَابَةِ
u'فَصْلٌ كَفٌّ':Added, #1: 1	فَصْلِ كَرَاهَةِ
u'فَصْلٌ كَفَاءةٌ':Added, #1: 1	فَصْلِ الْكَفِّ
u'فَصْلٌ كَفَّارٌ':Added, #1: 1	فَصْلِ الْكَفَاءَةِ
u'فَصْلٌ كَفَّارٌ':Added, #1: 1	فَصْلِ الْكَفَّارَةِ
u'فَصْلٌ كَفَّارَةٌ':Added, #1: 1	فَصْلِ كَفَّارَةِ
u'فَصْلٌ كَفَّارَةٌ':Added, #1: 1	فَصْلِ الْكَفَّارَةِ
u'فَصْلٌ كَفَالَةٌ':Added, #1: 1	فَصْلِ كَفَّارَةِ
u'فَصْلٌ كَفَنٌ':Added, #2: 2	فَصْلِ الْكَفَالَةِ
u'فَصَلَ كَلاَمٌ':Predicate, #1: 1	فَصْلِ الْكَفَنِ
u'فَصْلٌ كِنَايَةٌ':Added, #1: 1	فَصَلَ الْكَلَامَ
u'فَصْلٌ كَيْفِيَّةٌ':Added, #6: 6	فَصْلِ الْكِنَايَاتِ
u'فَصْلٌ لَقِيطٌ':Added, #3: 3	فَصْلِ كَيْفِيَّةِ
u'فَصْلٌ مَاءٌ':Added, #1: 1	فَصْلِ اللَّقِيطِ
u'فَصْلٌ مَاءٌ':Added, #1: 1	فَصْلُ الْمَاءِ
u'فَصْلٌ مَأْكُولٌ':Added, #1: 1	فَصْلِ الْمَاءِ
u'فَصْلٌ مَالٌ':Added, #1: 1	فَصْلِ الْمَأْكُولِ
u'فَصْلٌ مَأْمُورٌ':Added, #2: 2	فَصْلِ مَالِ
u'فَصْلٌ مُتَفَرِّقٌ':Added, #1: 1	فَصْلِ الْمَأْمُورِ
u'فَصْلٌ مُتَفَرِّقٌ':Added, #15: 15	فَصْلِ الْمُتَفَرِّقَاتِ
u'فَصْلٌ مُجْتَهِد':Added, #1: 1	فَصْلِ مُتَفَرِّقَاتِ
u'فَصْلٌ مُحَرَّمٌ':Added, #2: 2	فَصْلٍ مُجْتَهِدٍ
u'فَصْلٌ مَحْظُورٌ':Added, #6: 6	فَصْلِ الْمُحَرَّمَاتِ
u'فَصْلٌ مَحْكُومٌ':Added, #1: 1	فَصْلُ الْمَحْظُورَاتِ
u'فَصْلٌ مُخْتَلِفٌ':Added, #1: 1	فَصْلِ الْمَحْكُومِ
u'فَصْلٌ مُخَدَّرٌ':Added, #1: 1	فَصْلٍ مُخْتَلِفٍ
u'فَصْلٌ مَرَضٌ':Added, #1: 1	فَصْلُ الْمُخَدَّرَةِ
u'فَصْلٌ مَسَائِلُ':Added, #1: 1	فَصْلُ الْمَرَضِ
u'فَصْلٌ مَسْبُوق':Added, #1: 1	فَصْلِ مَسَائِلِ
u'فَصْلٌ مَسْجِدٌ':Added, #1: 1	فَصْلِ الْمَسْبُوقِ
u'فَصْلٌ مَسْحٌ':Added, #2: 2	فَصْلِ الْمَسْجِدِ
u'فَصْلٌ مَشْيٌ':Added, #1: 1	فَصْلِ الْمَسْحِ
u'فَصْلٌ مَشِيئَةٌ':Added, #1: 1	فَصْلِ الْمَشْيِ
u'فَصْلٌ مَصَارِفُ':Added, #4: 4	فَصْلِ الْمَشِيئَةِ
u'فَصَلَ مُصَنِّفٌ':Subject, #1: 1	فَصْلِ مَصَارِفِ
u'فَصْلٌ مُعْتَدٌّ':Added, #1: 1	فَصَلَ الْمُصَنِّفُ
u'فَصْلٌ مَعْرِفَةٌ':Added, #1: 1	فَصْلِ الْمُعْتَدَّةِ
u'فَصْلٌ مَعْرِفَة':Added, #1: 1	فَصْلُ مَعْرِفَةِ
u'فَصْلٌ مَغْصُوب':Added, #1: 1	فَصْلُ مَعْرِفَةِ
u'فَصْلٌ مُفْرَدٌ':Added, #1: 1	فَصْلُ الْمَغْصُوبِ
u'فَصْلٌ مَفْقُودٌ':Added, #2: 2	فَصْلٍ مُفْرَدٍ
u'فَصْلٌ مَقَالٌ':Added, #1: 1	فَصْلَ الْمَفْقُودِ
u'فَصْلٌ مَكْرُوهٌ':Added, #1: 1	فَصْلِ الْمَقَالِ
u'فَصْلٌ مَكْرُوهٌ':Added, #1: 1	فَصْلِ الْمَكْرُوهِ
u'فَصْلٌ مَكْرُوهَةٌ':Added, #1: 1	فَصْلِ مَكْرُوهَاتِ
u'فَصْلٌ مَوَاقِيتُ':Added, #1: 1	فَصْلِ مَكْرُوهَاتِ
u'فَصْلٌ مَوْتٌ':Added, #3: 3	فَصْلِ الْمَوَاقِيتِ
u'فَصْلٌ مَوْتٌ':Added, #1: 1	فَصْلِ مَوْتِ
u'فَصْلٌ مِيَاهٌ':Added, #5: 5	فَصْلِ الْمَوْتِ
u'فَصْلٌ مِيرَاثٌ':Added, #2: 2	فَصْلَ الْمِيَاهِ
u'فَصْلٌ نَجَاسَةٌ':Added, #1: 1	فَصْلِ الْمِيرَاثِ
u'فَصْلٌ نَجَسٌ':Added, #2: 2	فَصْلِ النَّجَاسَةِ
u'فَصْلٌ نذر':Added, #1: 1	فَصْلِ النَّجَسِ
u'فَصْلٌ نَذْرٌ':Added, #1: 1	فَصْلِ النَّذْرِ
u'فَصْلٌ نُزْهَةٌ':Added, #1: 1	فَصْلِ النَّذْرِ
u'فَصْلٌ نصب':Added, #1: 1	فَصْلِ النُّزْهَةِ
u'فَصْلٌ نَصْبٌ':Added, #1: 1	فَصْلِ النَّصْبِ
u'فَصَلَ نَفْسٌ':Predicate, #1: 1	فَصْلِ النَّصْبِ
u'فَصْلٌ نَفَقَةٌ':Added, #1: 1	فَصَلَ نَفْسَ
u'فَصْلٌ نُقْصَانٌ':Added, #1: 1	فَصْلِ النَّفَقَةِ
u'فَصْلٌ نكاح':Added, #7: 7	فَصْلِ النُّقْصَانِ
u'فَصْلٌ نِكَاحٌ':Added, #2: 2	فَصْلِ نِكَاحِ
u'فَصْلٌ نكاح':Added, #2: 2	فَصْلِ نِكَاحِ
u'فَصْلٌ نِكَاحٌ':Added, #3: 3	فَصْلِ النِّكَاحِ
u'فَصْلٌ نَكِرٌ':Added, #3: 3	فَصْلِ النِّكَاحِ
u'فَصْلٌ نكرة':Added, #1: 1	فَصْلُ النَّكِرَةِ
u'فَصْلٌ نَكِرَةٌ':Added, #1: 1	فَصْلُ النَّكِرَةِ
u'فَصْلٌ نَهْيٌ':Added, #1: 1	فَصْلُ النَّكِرَةِ
u'فَصْلٌ نَيْرُوزٌ':Added, #2: 2	فَصْلِ النَّهْيِ
u'فَصْلٌ هِبَةٌ':Added, #1: 1	فَصْلِ النَّيْرُوزِ
u'فَصْلٌ هلاك':Added, #3: 3	فَصْلِ الْهِبَةِ
u'فَصْلٌ هَلاَكٌ':Added, #1: 1	فَصْلِ الْهَلَاكِ
u'فَصْلٌ وَاجِبٌ':Added, #1: 1	فَصْلِ الْهَلَاكِ
u'فَصْلٌ واحد':Added, #1: 1	فَصْلِ الْوَاجِبِ
u'فَصْلٌ وَاحِدٌ':Added, #12: 12	فَصْلٍ وَاحِدٍ
u'فَصْلٌ وُجُوبٌ':Added, #12: 12	فَصْلٍ وَاحِدٍ
u'فَصْلٌ وَدِيعٌ':Added, #1: 1	فَصْلُ الْوُجُوبِ
u'فَصْلٌ وَدِيعَةٌ':Added, #7: 7	فَصْلِ الْوَدِيعَةِ
u'فَصْلٌ وَصِيٌّ':Added, #7: 7	فَصْلِ الْوَدِيعَةِ
u'فَصْلٌ وَصِيَّةٌ':Added, #1: 1	فَصْلَ الْوَصِيَّةِ
u'فَصْلٌ وُضُوءٌ':Added, #1: 1	فَصْلَ الْوَصِيَّةِ
u'فَصْلٌ وَطْءٌ':Added, #1: 1	فَصْلِ الْوُضُوءِ
u'فَصْلٌ وَكِيلٌ':Added, #1: 1	فَصْلُ الْوَطْءِ
u'فَصْلٌ وَلاَءٌ':Added, #2: 2	فَصْلِ الْوَكِيلِ
u'فَصْلٌ وِلاَيَةٌ':Added, #1: 1	فَصْلُ الْوَلَاءِ
u'فَصْلٌ وِلاَيَةٌ':Added, #1: 1	فَصْلِ الْوِلَايَةِ
u'فَصْلٌ ولد':Added, #2: 2	فَصْلُ الْوِلَايَةِ
u'فَصْلٌ وَلَدٌ':Added, #1: 1	فَصْلِ الْوَلَدِ
u'فَصْلٌ يَسِيرٌ':Added, #1: 1	فَصْلِ الْوَلَدِ
u'فَصْلٌ يَمِينٌ':Added, #6: 6	فَصْلٍ يَسِيرٍ
u'فُصُولٌ اِبْنٌ':Added, #6: 6	فَصْلِ الْيَمِينِ
u'فُصُولٌ أَدَاءٌ':Added, #1: 1	فُصُولِ ابْنِ
u'فُصُولٌ آدابٌ':Added, #1: 1	فُصُولُ الْأَدَاءِ
u'فُصُولٌ أَرْبَعَةٌ':Added, #9: 9	فُصُولِ آدَابِ
u'فُصُولٌ إقْرَارٌ':Added, #3: 3	فُصُولٍ أَرْبَعَةٍ
u'فُصُولٌ أَمْرٌ':Added, #2: 2	فُصُولِ الْإِقْرَارِ
u'فُصُولٌ إِنْكارٌ':Added, #8: 8	فُصُولِ الْأَمْرِ
u'فُصُولٌ أَنْوَاعٌ':Added, #1: 1	فُصُولِ الْإِنْكَارِ
u'فُصُولٌ أَنْوَاعٌ':Added, #1: 1	فُصُولَ أَنْوَاعِهِ
u'فُصُولٌ بَابٌ':Added, #2: 2	فُصُولُ أَنْوَاعِهِ
u'فُصُولٌ بَيْعٌ':Added, #1: 1	فُصُولِ الْبَابِ
u'فُصُولٌ تَشْطِيرٌ':Added, #2: 2	فُصُولِ الْبَيْعِ
u'فُصُولٌ تَعْجِيل':Added, #1: 1	فُصُولِ تَشْطِيرِ
u'فُصُولٌ تَعْجِيل':Added, #1: 1	فُصُولِ التَّعْجِيلِ
u'فُصُولٌ تَعْزِير':Added, #1: 1	فُصُولِ تَعْجِيلِ
u'فُصُولٌ تَعَلُّمٌ':Added, #2: 2	فُصُولِ التَّعْزِيرِ
u'فُصُولٌ تَكَسُّبٌ':Added, #1: 1	فُصُولِ تَعَلُّمِ
u'فُصُولٌ تَوْبَةٌ':Added, #2: 2	فُصُولِ التَّكَسُّبِ
u'فُصُولٌ حِفْظٌ':Added, #8: 8	فُصُولِ التَّوْبَةِ
u'فُصُولٌ خطبة':Added, #3: 3	فُصُولِ حِفْظِ
u'فُصُولٌ خُطْبَةٌ':Added, #1: 1	فُصُولِ خُطْبَةٍ
u'فُصُولٌ خطبة':Added, #1: 1	فُصُولِ خُطْبَةٍ
u'فُصُولٌ خُطْبَةٌ':Added, #2: 2	فُصُولِ الْخُطْبَةِ
u'فُصُولٌ خَلْوَةٌ':Added, #2: 2	فُصُولِ الْخُطْبَةِ
u'فُصُولٌ رَدٌّ':Added, #1: 1	فُصُولَ الْخَلْوَةِ
u'فُصُولٌ سلام':Added, #1: 1	فُصُولِ رَدِّ
u'فُصُولٌ سَلاَمٌ':Added, #2: 2	فُصُولِ السَّلَامِ
u'فُصُولٌ سَنَةٌ':Added, #2: 2	فُصُولِ السَّلَامِ
u'فُصُولٌ صِحَّةٌ':Added, #6: 6	فُصُولِ السَّنَةِ
u'فُصُولٌ صلح':Added, #1: 1	فُصُولِ الصِّحَّةِ
u'فُصُولٌ صُلْحٌ':Added, #1: 1	فُصُولِ صُلْحِ
u'فُصُولٌ طَاعَةٌ':Added, #1: 1	فُصُولِ صُلْحِ
u'فُصُولٌ طِبٌّ':Added, #1: 1	فُصُولِ طَاعَةِ
u'فُصُولٌ طِبٌّ':Added, #1: 1	فُصُول الطِّبِّ
u'فُصُولٌ طلب':Added, #9: 9	فُصُولِ الطِّبِّ
u'فُصُولٌ طَلَبٌ':Added, #1: 1	فُصُولِ الطَّلَبِ
u'فُصُولٌ طلب':Added, #1: 1	فُصُولِ الطَّلَبِ
u'فُصُولٌ طَلَبٌ':Added, #1: 1	فُصُولِ طَلَبِ
u'فُصُولٌ عِدَّةٌ':Added, #1: 1	فُصُولِ طَلَبِ
u'فُصُولٌ عِدَّةٌ':Added, #10: 10	فُصُولِ الْعِدَّةِ
u'فُصُولٌ عَسْكَرٌ':Added, #2: 2	فُصُولُ الْعِدَّةِ
u'فُصُولٌ علم':Added, #1: 1	فُصُولِ الْعَسْكَرِ
u'فُصُولٌ عِلْمٌ':Added, #9: 9	فُصُولِ الْعِلْمِ
u'فُصُولٌ عِماد':Added, #9: 9	فُصُولِ الْعِلْمِ
u'فُصُولٌ عِمادَة':Added, #1: 1	فُصُولِ الْعِمَادِيَّةِ
u'فُصُولٌ فَرَائِضُ':Added, #1: 1	فُصُولِ الْعِمَادِيَّةِ
u'فُصُولٌ فَصْلٌ':Added, #1: 1	فُصُولِ الْفَرَائِضِ
u'فُصُولٌ فلان':Added, #1: 1	فُصُولِ فَصْلٍ
u'فُصُولٌ قيام':Added, #1: 1	فُصُولِ الْعِمَادِيَّةِ
u'فُصُولٌ قِيَامٌ':Added, #2: 2	فُصُولِ الْقِيَامِ
u'فُصُولٌ كِتَابٌ':Added, #2: 2	فُصُولِ الْقِيَامِ
u'فُصُولٌ كِتَابَةٌ':Added, #1: 1	فُصُولِ كِتَابِ
u'فُصُولٌ كذب':Added, #1: 1	فُصُولِ الْكِتَابَةِ
u'فُصُولٌ كَذِبٌ':Added, #2: 2	فُصُولِ الْكَذِبِ
u'فُصُولٌ كَسْبٌ':Added, #2: 2	فُصُولِ الْكَذِبِ
u'فُصُولٌ كَسْبٌ':Added, #1: 1	فُصُولِ الْكَسْبِ
u'فُصُولٌ كَلاَمٌ':Added, #1: 1	فُصُولِ كَسْبِ
u'فُصُولٌ كِنَايَةٌ':Added, #1: 1	فُصُولُ الْكَلَامِ
u'فُصُولٌ لِبَاسٌ':Added, #1: 1	فُصُولِ الْكِنَايَاتِ
u'فُصُولٌ مَسَائِلُ':Added, #8: 8	فُصُولِ اللِّبَاسِ
u'فُصُولٌ مُصَافَحَةٌ':Added, #1: 1	فُصُولِ مَسَائِلِ
u'فُصُولٌ مُفْرَدٌ':Added, #1: 1	فُصُولِ الْمُصَافَحَةِ
u'فُصُولٌ نَفَقَةٌ':Added, #1: 1	فُصُولِ الْمُفْرَدَاتِ
u'فُصُولٌ هجرة':Added, #1: 1	فُصُولِ النَّفَقَةِ
u'فُصُولٌ هِجْرَةٌ':Added, #1: 1	فُصُولِ الْهِجْرَةِ
u'فَضَاءٌ أرْضٌ':Added, #1: 1	فُصُولِ الْهِجْرَةِ
u'فَضَاءٌ خَالٌ':Added, #1: 1	فَضَاءِ الْأَرْضِ
u'فَضَاءٌ فَمٌ':Added, #1: 1	فَضَاءٍ خَالٍ
u'فَضَاءٌ قَبْرٌ':Added, #1: 1	فَضَاءِ فَمِهِ
u'فَضَاءٌ وَاسِعٌ':Added, #1: 1	فَضَاءِ الْقَبْرِ
u'فَضَّ ضاد':Subject, #2: 2	فَضَاءٍ وَاسِعٍ
u'فَضَلَ أَبٌ':Subject, #1: 1	فَضَّ ضَادٌ
u'فَضْلٌ اِبْنٌ':Added, #1: 1	فَضَلَ الْأَبُ
u'فَضَلَ أحَدٌ':Subject, #1: 1	فَضْلُ ابْنِ
u'فَضْلٌ أحَدٌ':Added, #1: 1	فَضَلَ أَحَدُ
u'فَضْلٌ أحَدٌ':Added, #1: 1	فَضْلُ أَحَدِ
u'فَضْلٌ أدَب':Added, #1: 1	فَضْلِ أَحَدِ
u'فَضْلٌ آدَمِيٌّ':Added, #1: 1	فَضْلِ الْأَدَبِ
u'فَضَّلَ أَذَانٌ':Predicate, #1: 1	فَضْلُ الْآدَمِيِّ
u'فَضْلٌ أَرْبَعَةٌ':Added, #1: 1	فَضَّلَ الْأَذَانَ
u'فَضْلٌ أرْضٌ':Added, #1: 1	فَضْلَ أَرْبَعَةٍ
u'فَضْلٌ إِرْهَابٌ':Added, #2: 2	فَضْلُ أَرْضٍ
u'فَضَّلَ أَشْقَر':Predicate, #2: 2	فَضْلِ الْإِرْهَابِ
u'فَضْلٌ إِعْتاقٌ':Added, #1: 1	فَضَّلَ الأَشْقَرَ
u'فَضْلٌ اِعْتِناءٌ':Added, #1: 1	فَضْلِ إِعْتَاقِ
u'فَضْلٌ اِعْتِناءٌ':Added, #1: 1	فَضْلُ اعْتِنَاءِ
u'فَضَّلَ إِفْرَادٌ':Predicate, #2: 2	فَضْلِ اعْتِنَاءٍ
u'فَضْلٌ إِفْرَادٌ':Added, #1: 1	فَضَّلَ الْإِفْرَادَ
u'فَضْلٌ إِقْراضٌ':Added, #1: 1	فَضْلُ الْإِفْرَادِ
u'فَضَلَ أقَلُّ':Subject, #1: 1	فَضْلِ الإِقْرَاضِ
u'فَضْلٌ أكل':Added, #1: 1	فَضَلَ أَقَلُّ
u'فَضْلٌ أَكْلٌ':Added, #1: 1	فَضْلِ الْأَكْلِ
u'فَضْلٌ أُمٌّ':Added, #1: 1	فَضْلِ الْأَكْلِ
u'فَضْلٌ إمَامٌ':Added, #1: 1	فَضْلِ أُمِّ
u'فَضْلٌ أنبياء':Added, #1: 1	فَضْلِ الإِمَامِ
u'فَضْلٌ إِنْسانٌ':Added, #2: 2	فَضْلِ الْأَنْبِيَاءِ
u'فَضْلٌ أنصار':Added, #1: 1	فَضْلِ الْإِنْسَانِ
u'فَضْلٌ أَنْصارٌ':Added, #1: 1	فَضْلِ الأَنْصَارِ
u'فَضْلٌ أَنْصَارٌ':Added, #1: 1	فَضْلِ الأَنْصَارِ
u'فَضْلٌ إِنْعامٌ':Added, #1: 1	فَضْلِ الأَنْصَارِ
u'فَضْلٌ أهْلٌ':Added, #1: 1	فَضْلُ الْإِنْعَامِ
u'فَضْلٌ أهْلٌ':Added, #1: 1	فَضْلَ أَهْلِ
u'فَضْلٌ أَوَّلُ':Added, #1: 1	فَضْلِ أَهْلِ
u'فَضْلٌ أَوَّلُ':Added, #1: 1	فَضْلِ أَوَّلِ
u'فَضَّلَ بِرٌّ':Predicate, #2: 2	فَضْلَ أَوَّلِ
u'فَضْلٌ بِرٌّ':Added, #1: 1	فَضَّلَ بِرَّ
u'فَضَّلَ بَعْضٌ':Predicate, #1: 1	فَضْلِ بِرِّ
u'فَضَّلَ بَعْضٌ':Predicate, #2: 2	فَضَّلَ الْبَعْضَ
u'فَضَلَ بَعْضٌ':Subject, #3: 3	فَضَّلَ بَعْضَ
u'فَضْلٌ بَعْضٌ':Added, #1: 1	فَضَلَ بَعْضُ
u'فَضْلٌ بَعْضٌ':Added, #1: 1	فَضْلَ الْبَعْضِ
u'فَضْلٌ بَعْضٌ':Added, #1: 1	فَضْلِ بَعْضِ
u'فَضْلٌ بُقْعَةٌ':Added, #2: 2	فَضْلُ بَعْضِهِ
u'فَضْلٌ بَلاغَةٌ':Added, #1: 1	فَضْلَ الْبُقْعَةِ
u'فَضْلٌ بِنَاءٌ':Added, #1: 1	فَضْلِ الْبَلَاغَةِ
u'فَضْلٌ بِنَاءٌ':Added, #1: 1	فَضْلِ بِنَاءِ
u'فَضْلٌ بِئْرٌ':Added, #2: 2	فَضْلُ بِنَاءٍ
u'فَضْلٌ بِئْرٌ':Added, #1: 1	فَضْلَ بِئْرِ
u'فَضْلٌ بِئْرٌ':Added, #2: 2	فَضْلُ بِئْرِ
u'فَضْلٌ بَيَانٌ':Added, #2: 2	فَضْلِ بِئْرِ
u'فَضْلٌ تَأْخِيرٌ':Added, #1: 1	فَضْلَ الْبَيَانِ
u'فَضْلٌ تَأْكِيدٌ':Added, #1: 1	فَضْلِ التَّأْخِيرِ
u'فَضْلٌ تَأَمُّلٌ':Added, #1: 1	فَضْلُ تَأْكِيدٍ
u'فَضْلٌ تِجَارَةٌ':Added, #1: 1	فَضْلِ تَأَمُّلٍ
u'فَضَّلَ تُرْبَةٌ':Predicate, #1: 1	فَضْلِ التِّجَارَةِ
u'فَضْلٌ تُرْبَةٌ':Added, #2: 2	فَضَّلَ التُّرْبَةَ
u'فَضْلٌ تَرْتِيبٌ':Added, #1: 1	فَضْلِ التُّرْبَةِ
u'فَضْلٌ تَسْبِيحٌ':Added, #1: 1	فَضْلِ التَّرْتِيبِ
u'فَضْلٌ تَطَوُّعٌ':Added, #1: 1	فَضْلَ التَّسْبِيحِ
u'فَضْلٌ تَقَدُّمٌ':Added, #1: 1	فَضْلَ التَّطَوُّعِ
u'فَضْلٌ تَكْبِير':Added, #1: 1	فَضْلُ التَّقَدُّمِ
u'فَضْلٌ تَكْبِير':Added, #1: 1	فَضْلَ التَّكْبِيرَةِ
u'فَضْلٌ تَكْرارٌ':Added, #1: 1	فَضْلِ التَّكْبِيرَةِ
u'فَضْلٌ تَمَكُّنٌ':Added, #1: 1	فَضْلِ التَّكْرَارِ
u'فَضْلٌ ثَانِي':Added, #1: 1	فَضْلَ تَمَكُّنٍ
u'فَضْلٌ ثَانِيَةٌ':Added, #2: 2	فَضْلَ الثَّانِيَةِ
u'فَضَلَ ثَمَنٌ':Subject, #2: 2	فَضْلَ الثَّانِيَةِ
u'فَضْلٌ ثَمَنٌ':Added, #1: 1	فَضَلَ الثَّمَنُ
u'فَضْلٌ ثَمَنٌ':Added, #1: 1	فَضْلَ الثَّمَنِ
u'فَضْلٌ ثَوْبٌ':Added, #1: 1	فَضْلِ ثَمَنِهِ
u'فَضَّلَ جَامِعٌ':Predicate, #1: 1	فَضْلُ ثَوْبَيْنِ
u'فَضْلٌ جِسْمٌ':Added, #1: 1	فَضَّلَ الْجَامِعَ
u'فَضْلٌ جَمَاعَةٌ':Added, #1: 1	فَضْلُ جِسْمٍ
u'فَضْلٌ جَمَاعَةٌ':Added, #10: 10	فَضْلُ الْجَمَاعَةِ
u'فَضْلٌ جَمَاعَةٌ':Added, #15: 15	فَضْلِ الْجَمَاعَةِ
u'فَضْلٌ جمع':Added, #21: 21	فَضْلَ الْجَمَاعَةِ
u'فَضْلٌ جَمْعٌ':Added, #2: 2	فَضْلِ الْجَمْعِ
u'فَضْلٌ جمعة':Added, #2: 2	فَضْلِ الْجَمْعِ
u'فَضْلٌ جُمُعَةٌ':Added, #2: 2	فَضْلِ الْجُمُعَةِ
u'فَضْلٌ جهاد':Added, #2: 2	فَضْلِ الْجُمُعَةِ
u'فَضْلٌ جِهَادٌ':Added, #1: 1	فَضْلُ الْجِهَادِ
u'فَضْلٌ جهاد':Added, #1: 1	فَضْلُ الْجِهَادِ
u'فَضْلٌ جِهَادٌ':Added, #2: 2	فَضْلِ الْجِهَادِ
u'فَضْلٌ جواد':Added, #2: 2	فَضْلِ الْجِهَادِ
u'فَضْلٌ جَوَادٌ':Added, #1: 1	فَضْلُ الْجَوَادِ
u'فَضْلٌ حاجَةٌ':Added, #1: 1	فَضْلُ الْجَوَادِ
u'فَضَّلَ حَجٌّ':Predicate, #1: 1	فَضْلِ حَاجَتِهِ
u'فَضْلٌ حَجٌّ':Added, #1: 1	فَضَّلَ الْحَجَّ
u'فَضْلٌ حَجٌّ':Added, #1: 1	فَضْلِ الْحَجِّ
u'فَضْلٌ حِجَامَةٌ':Added, #3: 3	فَضْلَ الْحَجِّ
u'فَضْلٌ حَرَسٌ':Added, #1: 1	فَضْلِ الْحِجَامَةِ
u'فَضْلٌ حُرِّيَّةٌ':Added, #1: 1	فَضْلِ الْحَرَسِ
u'فَضْلٌ حُسْنٌ':Added, #1: 1	فَضْلُ الْحُرِّيَّةِ
u'فَضْلٌ حِفْظٌ':Added, #1: 1	فَضْلِ حُسْنِ
u'فَضْلٌ حِفْظٌ':Added, #1: 1	فَضْلُ حِفْظٍ
u'فَضْلٌ حِفْظٌ':Added, #1: 1	فَضْلُ حِفْظِ
u'فَضْلٌ حِفْظٌ':Added, #1: 1	فَضْلِ حِفْظِ
u'فَضْلٌ حمق':Added, #2: 2	فَضْلِ حِفْظِهِ
u'فَضْلٌ حُمْقٌ':Added, #1: 1	فَضْلُ حُمْقٍ
u'فَضْلٌ حَمْلٌ':Added, #1: 1	فَضْلُ حُمْقٍ
u'فَضْلٌ حِمْلٌ':Added, #1: 1	فَضْلُ حَمْلِهِ
u'فَضْلٌ حُمُولَةٌ':Added, #1: 1	فَضْلُ حِمْلِهِ
u'فَضْلٌ حَنوطٌ':Added, #5: 5	فَضْلُ حُمُولَةٍ
u'فَضْلٌ خدمة':Added, #2: 2	فَضْلُ حَنُوطِ
u'فَضْلٌ خِدْمَةٌ':Added, #1: 1	فَضْلِ الْخِدْمَةِ
u'فَضْلٌ خراج':Added, #1: 1	فَضْلِ الْخِدْمَةِ
u'فَضْلٌ خَرَاجٌ':Added, #2: 2	فَضْلِ خَرَاجِهِ
u'فَضْلٌ خَلْعٌ':Added, #2: 2	فَضْلِ خَرَاجِهِ
u'فَضْلٌ خُلَفَاءُ':Added, #1: 1	فَضْلِ خَلْعِ
u'فَضْلٌ خلقة':Added, #1: 1	فَضْلَ الْخُلَفَاءِ
u'فَضْلٌ خِلْقَةٌ':Added, #1: 1	فَضْلَ الْخِلْقَةِ
u'فَضْلٌ خَيْرٌ':Added, #1: 1	فَضْلَ الْخِلْقَةِ
u'فَضْلٌ دَارٌ':Added, #1: 1	فَضْلُ الْخَيْرِ
u'فَضْلٌ دَرَجٌ':Added, #1: 1	فَضْلُ الدَّارِ
u'فَضْلٌ درجة':Added, #1: 1	فَضْلُ دَرَجَتَيْنِ
u'فَضْلٌ دَرَجَةٌ':Added, #3: 3	فَضْلُ دَرَجَةٍ
u'فَضْلٌ دِرْهَمٌ':Added, #3: 3	فَضْلُ دَرَجَةٍ
u'فَضْلٌ دِرْهَم':Added, #1: 1	فَضْلُ دِرْهَمٍ
u'فَضْلٌ دُعَاءٌ':Added, #1: 1	فَضْلُ دِرْهَمٍ
u'فَضْلٌ دُهْنٌ':Added, #1: 1	فَضْلَ الدُّعَاءِ
u'فَضَلَ دَيْنٌ':Subject, #2: 2	فَضْلُ دُهْنِ
u'فَضَّلَ ذكر':Predicate, #1: 1	فَضَلَ الدَّيْنُ
u'فَضَّلَ ذَكَرٌ':Predicate, #1: 1	فَضَّلَ الذَّكَرَ
u'فَضْلٌ ذكر':Added, #1: 1	فَضَّلَ الذَّكَرَ
u'فَضْلٌ ذِكْرٌ':Added, #2: 2	فَضْلِ الذِّكْرِ
u'فَضْلٌ رَبُّ':Added, #2: 2	فَضْلِ الذِّكْرِ
u'فَضْلٌ رِبْحٌ':Added, #1: 1	فَضْلِ رَبِّهِ
u'فَضْلٌ رِبْحٌ':Added, #1: 1	فَضْلِ الرِّبْحِ
u'فَضْلٌ رِجَالٌ':Added, #2: 2	فَضْلُ رِبْحٍ
u'فَضْلٌ رَجَبٌ':Added, #1: 1	فَضْلُ الرِّجَالِ
u'فَضْلٌ رحمة':Added, #1: 1	فَضْلِ رَجَبٍ
u'فَضْلٌ رَحْمَةٌ':Added, #2: 2	فَضْلَ رَحْمَتِهِ
u'فَضْلٌ رِزْقٌ':Added, #2: 2	فَضْلَ رَحْمَتِهِ
u'فَضْلٌ رِسَالَةٌ':Added, #1: 1	فَضْلُ رِزْقِهِ
u'فَضْلٌ رَسُولٌ':Added, #1: 1	فَضْلَ الرِّسَالَةِ
u'فَضْلٌ رُطوبَةٌ':Added, #3: 3	فَضْلَ رَسُولِ
u'فَضْلٌ رُطوبَةٌ':Added, #1: 1	فَضْلَ الرُّطُوبَةِ
u'فَضْلٌ رَمْيٌ':Added, #1: 1	فَضْلِ رُطُوبَةٍ
u'فَضْلٌ رَوَاجٌ':Added, #1: 1	فَضْلِ الرَّمْيِ
u'فَضْلٌ زادٌ':Added, #1: 1	فَضْلُ الرَّوَاجِ
u'فَضْلٌ زادٌ':Added, #2: 2	فَضْلَ الزَّادِ
u'فَضَّلَ زَرْعٌ':Predicate, #2: 2	فَضْلُ زَادٍ
u'فَضْلٌ زَرْعٌ':Added, #1: 1	فَضَّلَ الزَّرْعَ
u'فَضْلٌ زَرْعٌ':Added, #1: 1	فَضْلِ الزَّرْعِ
u'فَضْلٌ زِمامٌ':Added, #1: 1	فَضْلُ زَرْعٍ
u'فَضْلٌ زَيْتٌ':Added, #1: 1	فَضْلَ زِمَامِ
u'فَضْلٌ زَيْدٌ':Added, #1: 1	فَضْلِ الزَّيْتِ
u'فَضَّلَ سَابِقٌ':Predicate, #2: 2	فَضْلُ زَيْدٍ
u'فَضْلٌ سَابِقٌ':Added, #1: 1	فَضَّلَ السَّابِقَةَ
u'فَضْلٌ سَبْقٌ':Added, #1: 1	فَضْلٍ سَابِقٍ
u'فَضْلٌ سُجُودٌ':Added, #1: 1	فَضْلَ السَّبْقِ
u'فَضْلٌ سِكَّةٌ':Added, #1: 1	فَضْلِ سُجُودِ
u'فَضْلٌ سِكَّةٌ':Added, #1: 1	فَضْلُ السِّكَّةِ
u'فَضْلٌ سِنٌّ':Added, #1: 1	فَضْلِ السِّكَّةِ
u'فَضْلٌ سُنَّةٌ':Added, #1: 1	فَضْلُ السِّنِّ
u'فَضْلٌ سِواكٌ':Added, #1: 1	فَضْلِ السُّنَّةِ
u'فَضْلٌ سُؤْرٌ':Added, #1: 1	فَضْلِ السِّوَاكِ
u'فَضْلٌ سُورَةٌ':Added, #1: 1	فَضْلَ سُؤْرِهِ
u'فَضْلٌ سُورَةٌ':Added, #1: 1	فَضْلِ سُورَةٍ
u'فَضْلٌ شجَاعٌ':Added, #1: 1	فَضْلِ سُورَةِ
u'فَضْلٌ شَجَاعَةٌ':Added, #1: 1	فَضْلِ الشَّجَاعَةِ
u'فَضَّلَ شَجَرٌ':Predicate, #1: 1	فَضْلِ الشَّجَاعَةِ
u'فَضْلٌ شَرَابٌ':Added, #1: 1	فَضَّلَ الشَّجَرَ
u'فَضْلٌ شَهَادَةٌ':Added, #2: 2	فَضْلَ شَرَابِهِ
u'فَضْلٌ شَهْرٌ':Added, #3: 3	فَضْلِ الشَّهَادَةِ
u'فَضَلَ شَيْءٌ':Subject, #1: 1	فَضْلِ شَهْرِ
u'فَضْلٌ صَحَابَةٌ':Added, #90: 90	فَضَلَ شَيْءٌ
u'فَضْلٌ صِحَّةٌ':Added, #1: 1	فَضْلِ الصَّحَابَةِ
u'فَضْلٌ صدقة':Added, #1: 1	فَضْلِ الصِّحَّةِ
u'فَضْلٌ صَدَقَةٌ':Added, #1: 1	فَضْلِ الصَّدَقَةِ
u'فَضْلٌ صدقة':Added, #1: 1	فَضْلِ الصَّدَقَةِ
u'فَضْلٌ صَدَقَةٌ':Added, #2: 2	فَضْلِ صَدَقَةِ
u'فَضْلٌ صِدِّيقٌ':Added, #2: 2	فَضْلِ صَدَقَةِ
u'فَضْلٌ صَفٌّ':Added, #1: 1	فَضْلِ الصّدّيقِ
u'فَضْلٌ صَفٌّ':Added, #1: 1	فَضْلُ الصَّفِّ
u'فَضَّلَ صَلاَةٌ':Predicate, #5: 5	فَضْلِ الصَّفِّ
u'فَضْلٌ صَلاَةٌ':Added, #1: 1	فَضَّلَ الصَّلَاةَ
u'فَضْلٌ صَلاَةٌ':Added, #1: 1	فَضْلِ الصَّلاَةِ
u'فَضْلٌ صَلاَةٌ':Added, #1: 1	فَضْلُ صَلَاةِ
u'فَضْلٌ صَلاَةٌ':Added, #2: 2	فَضْلَ الصَّلَاةِ
u'فَضْلٌ صَلاَةٌ':Added, #2: 2	فَضْلُ الصَّلَاةِ
u'فَضْلٌ صَلاَةٌ':Added, #2: 2	فَضْلِ صَلاَةِ
u'فَضْلٌ صَلاَةٌ':Added, #3: 3	فَضْلُ صَلاَةِ
u'فَضْلٌ صِلَةٌ':Added, #7: 7	فَضْلِ الصَّلَاةِ
u'فَضْلٌ صَوْمٌ':Added, #1: 1	فَضْلَ صِلَةِ
u'فَضْلٌ صَوْمٌ':Added, #1: 1	فَضْلَ صَوْمِ
u'فَضْلٌ صَوْمٌ':Added, #1: 1	فَضْلِ صَوْمِهِ
u'فَضْلٌ صَوْمٌ':Added, #4: 4	فَضْلِ الصَّوْمِ
u'فَضْلٌ صِيَامٌ':Added, #4: 4	فَضْلِ صَوْمِ
u'فَضْلٌ ضَرَرٌ':Added, #1: 1	فَضْلُ صِيَامِهِ
u'فَضْلٌ طعام':Added, #1: 1	فَضْلِ الضَّرَرِ
u'فَضْلٌ طَعَامٌ':Added, #1: 1	فَضْلُ طَعَامٍ
u'فَضْلٌ طعام':Added, #1: 1	فَضْلُ طَعَامٍ
u'فَضْلٌ طَعَامٌ':Added, #1: 1	فَضْلِ طَعَامِهِ
u'فَضْلٌ طَهُورٌ':Added, #1: 1	فَضْلِ طَعَامِهِ
u'فَضَّلَ طَوَاحِنُ':Predicate, #1: 1	فَضْلِ طَهُورِ
u'فَضْلٌ طواف':Added, #1: 1	فَضَّلَ الطَّوَاحِنَ
u'فَضْلٌ طَوَافٌ':Added, #1: 1	فَضْلُ الطَّوَافِ
u'فَضْلٌ ظُهْرٌ':Added, #1: 1	فَضْلُ الطَّوَافِ
u'فَضْلٌ ظَهْرٌ':Added, #1: 1	فَضْلَ الظُّهْرِ
u'فَضْلٌ عَالِمٌ':Added, #3: 3	فَضْلُ ظَهْرٍ
u'فَضْلٌ عَالِمٌ':Added, #1: 1	فَضْلَ الْعَالِمِ
u'فَضْلٌ عَامِلٌ':Added, #5: 5	فَضْلُ الْعَالِمِ
u'فَضْلٌ عَبَاءةٌ':Added, #1: 1	فَضْلِ الْعَامِلِ
u'فَضْلٌ عِبَادَةٌ':Added, #1: 1	فَضْلِ عَبَاءَةٍ
u'فَضْلٌ عِبَادَةٌ':Added, #1: 1	فَضْلُ الْعِبَادَةِ
u'فَضَّلَ عَبَّاسٌ':Predicate, #6: 6	فَضْلِ الْعِبَادَةِ
u'فَضْلٌ عتق':Added, #1: 1	فَضَّلَ الْعَبَّاسَ
u'فَضْلٌ عِتْقٌ':Added, #1: 1	فَضْلِ الْعِتْقِ
u'فَضْلٌ عَدَدٌ':Added, #1: 1	فَضْلِ الْعِتْقِ
u'فَضْلٌ عَدَدٌ':Added, #1: 1	فَضْلُ الْعَدَدِ
u'فَضْلٌ عَدُوٌّ':Added, #1: 1	فَضْلَ عَدَدٍ
u'فَضْلٌ عِرَاقٌ':Added, #1: 1	فَضْلُ الْعَدُوِّ
u'فَضْلٌ عَشْرٌ':Added, #1: 1	فَضْلِ الْعِرَاقِ
u'فَضْلٌ عَظِيم':Added, #2: 2	فَضْلُ عَشْرِ
u'فَضْلٌ عَفْوٌ':Added, #2: 2	فَضْلٍ عَظِيمٍ
u'فَضْلٌ عَقْلٌ':Added, #2: 2	فَضْلِ الْعَفْوِ
u'فَضْلٌ عَقْلٌ':Added, #1: 1	فَضْلُ الْعَقْلِ
u'فَضْلٌ عَقْلٌ':Added, #1: 1	فَضْلِ الْعَقْلِ
u'فَضْلٌ علم':Added, #2: 2	فَضْلَ عَقْلِهِ
u'فَضْلٌ علم':Added, #1: 1	فَضْلَ عِلْمِهِ
u'فَضْلٌ عِلْمٌ':Added, #1: 1	فَضْلِ عِلْمِهِ
u'فَضْلٌ عِلْمٌ':Added, #1: 1	فَضْلَ عِلْمِهِ
u'فَضْلٌ علم':Added, #1: 1	فَضْلِ عِلْمِهِ
u'فَضْلٌ عِلْمٌ':Added, #2: 2	فَضْلَ الْعِلْمِ
u'فَضْلٌ علم':Added, #2: 2	فَضْلَ الْعِلْمِ
u'فَضْلٌ عِلْمٌ':Added, #4: 4	فَضْلُ الْعِلْمِ
u'فَضْلٌ علم':Added, #4: 4	فَضْلُ الْعِلْمِ
u'فَضْلٌ عِلْمٌ':Added, #5: 5	فَضْلِ الْعِلْمِ
u'فَضْلٌ علماء':Added, #5: 5	فَضْلِ الْعِلْمِ
u'فَضْلٌ عُلَمَاءُ':Added, #1: 1	فَضْلِ الْعُلَمَاءِ
u'فَضْلٌ عَلِيٌّ':Added, #1: 1	فَضْلِ الْعُلَمَاءِ
u'فَضَّلَ عُمَرٌ':Subject, #1: 1	فَضْلِ عَلِيِّ
u'فَضْلٌ عَمَلٌ':Added, #1: 1	فَضَّلَ عُمَرُ
u'فَضْلٌ عُمُومٌ':Added, #1: 1	فَضْلَ الْعَمَلِ
u'فَضْلٌ عِيَادَةٌ':Added, #2: 2	فَضْلَ الْعُمُومِ
u'فَضْلٌ عَيْنٌ':Added, #1: 1	فَضْلِ الْعِيَادَةِ
u'فَضْلٌ عَيْن':Added, #1: 1	فَضْلِ عَيْنٍ
u'فَضْلٌ عُيُونٌ':Added, #1: 1	فَضْلِ عَيْنٍ
u'فَضْلٌ غُسْلٌ':Added, #1: 1	فَضْلِ عُيُونِ
u'فَضْلٌ غُسْلٌ':Added, #1: 1	فَضْلُ غُسْلِ
u'فَضْلٌ غُسْلٌ':Added, #1: 1	فَضْلِ غُسْلِ
u'فَضَلَ غَلَّةٌ':Subject, #2: 2	فَضْلَ الْغُسْلِ
u'فَضْلٌ غَلَّةٌ':Added, #1: 1	فَضَلَ غَلَّةُ
u'فَضْلٌ غَلَّةٌ':Added, #1: 1	فَضْلَ الْغَلَّةِ
u'فَضْلٌ غَلَّةٌ':Added, #1: 1	فَضْلِ غَلَّاتِ
u'فَضْلٌ غَنِيٌّ':Added, #1: 1	فَضْلَ غَلَّةِ
u'فَضْلٌ فَاتِحٌ':Added, #1: 1	فَضْلِ الْغَنِيِّ
u'فَضْلٌ فَاتِحٌ':Added, #1: 1	فَضْلُ الْفَاتِحَةِ
u'فَضْلٌ فَاتِحَةٌ':Added, #1: 1	فَضْلِ فَاتِحَةِ
u'فَضْلٌ فَاتِحَةٌ':Added, #1: 1	فَضْلُ الْفَاتِحَةِ
u'فَضْلٌ فَتَّاحٌ':Added, #1: 1	فَضْلِ فَاتِحَةِ
u'فَضْلٌ فَرَائِضُ':Added, #1: 1	فَضْلِ الْفَتَّاحِ
u'فَضْلٌ فَرَسٌ':Added, #1: 1	فَضْلِ الْفَرَائِضِ
u'فَضْلٌ فَرِيضَةٌ':Added, #1: 1	فَضْلُ فَرَسٍ
u'فَضَلَ فَضْلٌ':Subject, #1: 1	فَضْلَ الْفَرِيضَةِ
u'فَضْلٌ فَقِيرٌ':Added, #5: 5	فَضَلَ فَضْلٌ
u'فَضْلٌ فِكْرٌ':Added, #1: 1	فَضْلِ الْفَقِيرِ
u'فَضْلٌ فلان':Added, #1: 1	فَضْلِ فِكْرٍ
u'فَضَلَ فَلَكٌ':Predicate, #1: 1	فَضْلِ الزُّبَيْرِ
u'فَضُلَ قَاتِلٌ':Subject, #2: 2	فَضَلَ فَلَكَ
u'فَضْلٌ قَائِلٌ':Added, #1: 1	فَضُلَ الْقَاتِلُ
u'فَضْلٌ قَبْرٌ':Added, #1: 1	فَضْلِ قَائِلِهِ
u'فَضْلٌ قتال':Added, #1: 1	فَضْلِ الْقَبْرِ
u'فَضْلٌ قِتَالٌ':Added, #1: 1	فَضْلِ قِتَالِ
u'فَضْلٌ قَدْرٌ':Added, #1: 1	فَضْلِ قِتَالِ
u'فَضْلٌ قِرَاءةٌ':Added, #1: 1	فَضْلُ الْقَدْرِ
u'فَضْلٌ قِرَاءةٌ':Added, #1: 1	فَضْلُ قِرَاءَةِ
u'فَضْلٌ قُرْبٌ':Added, #3: 3	فَضْلِ الْقِرَاءَةِ
u'فَضْلٌ قَضَاءٌ':Added, #1: 1	فَضْلَ الْقُرْبِ
u'فَضْلٌ قَوام':Added, #1: 1	فَضْلِ الْقَضَاءِ
u'فَضْلٌ قَوام':Added, #1: 1	فَضْلُ الْقَوَامِيَّةِ
u'فَضْلٌ قُوَّةٌ':Added, #1: 1	فَضْلِ الْقَوَامِيَّةِ
u'فَضْلٌ قُوَّة':Added, #1: 1	فَضْلُ قُوَّةِ
u'فَضْلٌ قُوتٌ':Added, #1: 1	فَضْلُ قُوَّةِ
u'فَضْلٌ قيام':Added, #1: 1	فَضْلُ قُوتِ
u'فَضْلٌ قِيَامٌ':Added, #1: 1	فَضْلُ الْقِيَامِ
u'فَضْلٌ قِيمَةٌ':Added, #1: 1	فَضْلُ الْقِيَامِ
u'فَضْلٌ قِيمَةٌ':Added, #1: 1	فَضْلُ الْقِيمَةِ
u'فَضْلٌ قِيمَةٌ':Added, #2: 2	فَضْلِ الْقِيمَةِ
u'فَضْلٌ قِيمَةٌ':Added, #2: 2	فَضْلُ قِيمَةِ
u'فَضْلٌ قِيمَةٌ':Added, #2: 2	فَضْلُ قِيمَتِهِ
u'فَضْلٌ كِرَاءٌ':Added, #7: 7	فَضْلَ الْقِيمَةِ
u'فَضْلٌ كَسْبٌ':Added, #1: 1	فَضْلُ كِرَاءٍ
u'فَضْلٌ كَشْفٌ':Added, #8: 8	فَضْلَ كَسْبِهِ
u'فَضْلٌ كعبة':Added, #1: 1	فَضْلَ الْكَشْفِ
u'فَضْلٌ كَعْبَةٌ':Added, #2: 2	فَضْلَ الْكَعْبَةِ
u'فَضْلٌ كَلَأٌ':Added, #2: 2	فَضْلَ الْكَعْبَةِ
u'فَضْلٌ كَلَأٌ':Added, #1: 1	فَضْلِ الْكَلَأِ
u'فَضْلٌ كَلاَمٌ':Added, #3: 3	فَضْلَ الْكَلَأِ
u'فَضْلٌ لبن':Added, #1: 1	فَضْلَ كَلَامِ
u'فَضْلٌ لَبَنٌ':Added, #1: 1	فَضْلَ اللَّبَنِ
u'فَضْلٌ لبن':Added, #1: 1	فَضْلَ اللَّبَنِ
u'فَضْلٌ لَبَنٌ':Added, #3: 3	فَضْلُ اللَّبَنِ
u'فَضْلٌ لَحْدٌ':Added, #3: 3	فَضْلُ اللَّبَنِ
u'فَضْلٌ لِسَانٌ':Added, #1: 1	فَضْلِ اللَّحْدِ
u'فَضْلٌ لَيْلٌ':Added, #1: 1	فَضْلِ اللِّسَانِ
u'فَضْلٌ مَاءٌ':Added, #1: 1	فَضْلِ لَيْلَةِ
u'فَضْلٌ مَاءٌ':Added, #14: 14	فَضْلَ الْمَاءِ
u'فَضْلٌ مَاءٌ':Added, #1: 1	فَضْلُ مَاءِ
u'فَضْلٌ مَاءٌ':Added, #1: 1	فَضْلِ مَاءِ
u'فَضْلٌ مَاءٌ':Added, #24: 24	فَضْلِ الْمَاءِ
u'فَضْلٌ مَاءٌ':Added, #2: 2	فَضْلُ مَاءٍ
u'فَضْلٌ مَاءٌ':Added, #7: 7	فَضْلُ الْمَاءِ
u'فَضْلٌ مَاءٌ':Added, #7: 7	فَضْلَ مَاءٍ
u'فَضَلَ مَالٌ':Subject, #9: 9	فَضْلِ مَاءٍ
u'فَضْلٌ مَالٌ':Added, #3: 3	فَضَلَ الْمَالُ
u'فَضْلٌ مَالٌ':Added, #1: 1	فَضْلُ الْمَالِ
u'فَضْلٌ مَالٌ':Added, #1: 1	فَضْلِ الْمَالِ
u'فَضْلٌ مَالٌ':Added, #1: 1	فَضْلَ مَالِ
u'فَضْلٌ مَالٌ':Added, #1: 1	فَضْلِ مَالٍ
u'فَضْلٌ مَالٌ':Added, #1: 1	فَضْلَ مَالِهِ
u'فَضْلٌ مُبَادَرَةٌ':Added, #3: 3	فَضْلُ مَالٍ
u'فَضْلٌ مَجْدٌ':Added, #1: 1	فَضْلِ الْمُبَادَرَةِ
u'فَضْلٌ مُحْدِثٌ':Added, #1: 1	فَضْلُ مَجْدٍ
u'فَضْلٌ مُحَرَّمٌ':Added, #1: 1	فَضْلِ الْمُحْدِثِ
u'فَضْلٌ مَحْسُودٌ':Added, #1: 1	فَضْلَ الْمُحَرَّمِ
u'فَضْلٌ مَدِينٌ':Added, #1: 1	فَضْلِ الْمَحْسُودِ
u'فَضْلٌ مَدِينٌ':Added, #1: 1	فَضْلُ الْمَدِينَةِ
u'فَضْلٌ مَدِينٌ':Added, #1: 1	فَضْلِ الْمَدِينَةِ
u'فَضْلٌ مَدِينَةٌ':Added, #2: 2	فَضْلَ الْمَدِينَةِ
u'فَضْلٌ مَدِينَةٌ':Added, #1: 1	فَضْلُ الْمَدِينَةِ
u'فَضْلٌ مَدِينَةٌ':Added, #1: 1	فَضْلِ الْمَدِينَةِ
u'فَضْلٌ مَزِيَّةٌ':Added, #2: 2	فَضْلَ الْمَدِينَةِ
u'فَضْلٌ مَسَاجِدُ':Added, #1: 1	فَضْلُ مَزِيَّةٍ
u'فَضَّلَ مَسْحٌ':Predicate, #1: 1	فَضْلِ الْمَسَاجِدِ
u'فَضْلٌ مَسِيرٌ':Added, #1: 1	فَضَّلَ الْمَسْحَ
u'فَضْلٌ مَشَاهِدُ':Added, #1: 1	فَضْلِ الْمَسِيرِ
u'فَضْلٌ مَشْهَدٌ':Added, #1: 1	فَضْلِ مَشَاهِدِ
u'فَضْلٌ مَشْيٌ':Added, #1: 1	فَضْلَ الْمَشْهَدِ
u'فَضْلٌ مَشْيٌ':Added, #1: 1	فَضْلِ الْمَشْيِ
u'فَضْلٌ مُطْلَقٌ':Added, #2: 2	فَضْلُ الْمَشْيِ
u'فَضْلٌ مُعَاوَنَةٌ':Added, #1: 1	فَضْلِ مُطْلَقِ
u'فَضْلٌ مَعْرِفَةٌ':Added, #1: 1	فَضْلَ الْمُعَاوَنَةِ
u'فَضْلٌ مَعْرِفَة':Added, #1: 1	فَضْلُ الْمَعْرِفَةِ
u'فَضْلٌ مَمْلُوكٌ':Added, #1: 1	فَضْلُ الْمَعْرِفَةِ
u'فَضْلٌ مَنٌّ':Added, #1: 1	فَضْلِ الْمَمْلُوكِ
u'فَضْلٌ مُؤْمِنٌ':Added, #1: 1	فَضْلِ مَنّهِ
u'فَضْلٌ مَيْمَنَةٌ':Added, #1: 1	فَضْلِ الْمُؤْمِنِ
u'فَضْلٌ نَظَرٌ':Added, #1: 1	فَضْلِ مَيْمَنَةِ
u'فَضْلٌ نَظَرٌ':Added, #1: 1	فَضْلِ النَّظَرِ
u'فَضْلٌ نَفْسٌ':Added, #1: 1	فَضْلُ نَظَرٍ
u'فَضْلٌ نَفَقَةٌ':Added, #3: 3	فَضْلِ نَفْسِهِ
u'فَضَّلَ نَفِيسٌ':Predicate, #3: 3	فَضْلِ النَّفَقَةِ
u'فَضْلٌ نُقْصَانٌ':Added, #1: 1	فَضَّلَ نَفِيسَ
u'فَضْلٌ نكاح':Added, #1: 1	فَضْلَ النُّقْصَانِ
u'فَضْلٌ نِكَاحٌ':Added, #1: 1	فَضْلِ النِّكَاحِ
u'فَضْلٌ نَوْمٌ':Added, #1: 1	فَضْلِ النِّكَاحِ
u'فَضْلٌ نِيَابَةٌ':Added, #1: 1	فَضْلِ النَّوْمِ
u'فَضْلٌ هجرة':Added, #1: 1	فَضْلِ النِّيَابَةِ
u'فَضْلٌ هِجْرَةٌ':Added, #2: 2	فَضْلِ الْهِجْرَةِ
u'فَضْلٌ هضم':Added, #2: 2	فَضْلِ الْهِجْرَةِ
u'فَضْلٌ هَضْمٌ':Added, #1: 1	فَضْلِ الْهَضْمِ
u'فَضْلٌ هَيْبَةٌ':Added, #1: 1	فَضْلِ الْهَضْمِ
u'فَضْلٌ وَزْنٌ':Added, #1: 1	فَضْلِ الْهَيْبَةِ
u'فَضَلَ وَصِيٌّ':Predicate, #1: 1	فَضْلُ الْوَزْنِ
u'فَضَّلَ وَصِيٌّ':Subject, #1: 1	فَضَلَ وَصِيَّةً
u'فَضْلٌ وَضُوءٌ':Added, #1: 1	فَضَّلَ الْوَصِيُّ
u'فَضْلٌ وَضُوءٌ':Added, #1: 1	فَضْلَ وَضُوءِ
u'فَضْلٌ وَقْتٌ':Added, #2: 2	فَضْلِ وَضُوءِ
u'فَضَلَ وَلَهٌ':Subject, #1: 1	فَضْلِ الْوَقْتِ
u'فَضْلٌ يَدٌ':Added, #1: 1	فَضَلَ وَلَهُ
u'فَضَلَ يَوْمٌ':Subject, #1: 1	فَضْلِ يَدِهِ
u'فَضْلٌ يَوْمٌ':Added, #2: 2	فَضَلَ يَوْمٌ
u'فُضُولٌ أَمْوَالٌ':Added, #2: 2	فَضْلِ يَوْمِ
u'فُضُولٌ ثَمَنٌ':Added, #1: 1	فُضُولُ أَمْوَالٍ
u'فُضُولٌ حاجَةٌ':Added, #1: 1	فُضُولَ الثَّمَنِ
u'فُضُولٌ حَوائِجُ':Added, #1: 1	فُضُولِ الْحَاجَةِ
u'فُضُولٌ شَهَوَاتٌ':Added, #2: 2	فُضُولِ الْحَوَائِجِ
u'فُضُولٌ طرف':Added, #1: 1	فُضُولِ الشَّهَوَاتِ
u'فُضُولٌ طَرْفٌ':Added, #1: 1	فُضُولَ الطَّرْفِ
u'فُضُولٌ طلب':Added, #1: 1	فُضُولَ الطَّرْفِ
u'فُضُولٌ طَلَبٌ':Added, #1: 1	فُضُولِ الطَّلَبِ
u'فُضُولٌ علم':Added, #1: 1	فُضُولِ الطَّلَبِ
u'فُضُولٌ عِلْمٌ':Added, #1: 1	فُضُولِ عِلْمِهِ
u'فُضُولٌ عَيْشٌ':Added, #1: 1	فُضُولِ عِلْمِهِ
u'فُضُولٌ عَيْشٌ':Added, #1: 1	فُضُولَ الْعَيْشِ
u'فُضُولٌ غِذَاءٌ':Added, #1: 1	فُضُولِ الْعَيْشِ
u'فُضُولٌ قُوتٌ':Added, #1: 1	فُضُولِ الْغِذَاءِ
u'فُضُولٌ كَسْبٌ':Added, #1: 1	فُضُولُ قُوتٍ
u'فُضُولٌ كَلاَمٌ':Added, #2: 2	فُضُولِ الْكَسْبِ
u'فُضُولٌ كَلاَمٌ':Added, #2: 2	فُضُولُ الْكَلَامِ
u'فُضُولٌ كَلاَمٌ':Added, #2: 2	فُضُولِ الْكَلَامِ
u'فُضُولٌ مَالٌ':Added, #3: 3	فُضُولَ الْكَلَامِ
u'فُضُولٌ مَالٌ':Added, #1: 1	فُضُولَ الْمَالِ
u'فُضُولٌ مَعَاشٌ':Added, #1: 1	فُضُولِ الْمَالِ
u'فُضُولٌ مَنْطِقٌ':Added, #1: 1	فُضُولِ مَعَاشِهِ
u'فَطَرَ صَائِمٌ':Subject, #1: 1	فُضُولَ الْمَنْطِقِ
u'فَطَرَ فطرة':Predicate, #1: 1	فَطَرَ الصَّائِمُ
u'فَطَرَ فِطْرَةٌ':Predicate, #1: 1	فَطَرَ الْفِطْرَةَ
u'فَطَرَ نَاسٌ':Predicate, #1: 1	فَطَرَ الْفِطْرَةَ
u'فَطِنَ أحَدٌ':Subject, #6: 6	فَطَرَ النَّاسَ
u'فَطِنَ رَسُولٌ':Subject, #1: 1	فَطِنَ أَحَدُ
u'فَعَلَ أَبٌ':Subject, #1: 1	فَطِنَ رَسُولُ
u'فَعَلَ اِبْنٌ':Subject, #5: 5	فَعَلَ الْأَبُ
u'فَعَلَ أَجْنَبِيٌّ':Subject, #13: 13	فَعَلَ ابْنُ
u'فَعَلَ أَجْنَبِيٌّ':Subject, #1: 1	فَعَلَ أَجْنَبِيٌّ
u'فَعَلَ أحَدٌ':Predicate, #2: 2	فَعَلَ الْأَجْنَبِيُّ
u'فَعَلَ أحَدٌ':Subject, #2: 2	فَعَلَ أَحَدَ
u'فَعَلَ أحَدٌ':Subject, #1: 1	فَعَلَ أَحَدُ
u'فَعَلَ أَحْسَنُ':Predicate, #2: 2	فَعَلَ أَحَدٌ
u'فَعَلَ أخْذٌ':Predicate, #1: 1	فَعَلَ أَحْسَنَ
u'فَعَلَ إِخْوَانٌ':Subject, #1: 1	فَعَلَ الْأَخْذَ
u'فَعَلَ أَزْواجٌ':Subject, #1: 1	فَعَلَ الْإِخْوَانُ
u'فَعَلَ أَزْواجٌ':Subject, #1: 1	فَعَلَ أَزْوَاجُ
u'فَعَلَ أُسْتَاذٌ':Subject, #1: 1	فَعَلَ أَزْوَاجُهُ
u'فَعَلَ أَصْحَابٌ':Subject, #1: 1	فَعَلَ الْأُسْتَاذُ
u'فَعَلَ أَصْحَابٌ':Subject, #1: 1	فَعَلَ أَصْحَابُهُ
u'فَعَلَ أصل':Predicate, #2: 2	فَعَلَ أَصْحَابُ
u'فَعَلَ أًصْلٌ':Predicate, #2: 2	فَعَلَ الْأَصْلَ
u'فَعَلَ أصل':Subject, #2: 2	فَعَلَ الْأَصْلَ
u'فَعَلَ أًصْلٌ':Subject, #3: 3	فَعَلَ الْأَصْلُ
u'فَعَلَ أَصْلَحُ':Predicate, #3: 3	فَعَلَ الْأَصْلُ
u'فَعَلَ إِظْهارٌ':Subject, #1: 1	فَعَلَ الْأَصْلَحَ
u'فَعَلَ أفْضَلُ':Predicate, #1: 1	فَعَلَ إظْهَارُ
u'فَعَلَ إمَامٌ':Subject, #2: 2	فَعَلَ الْأَفْضَلَ
u'فَعَلَ إمَامٌ':Subject, #1: 1	فَعَلَ إِمَامُهُ
u'فَعَلَ إمَامٌ':Subject, #3: 3	فَعَلَ إمَامُهُ
u'فَعَلَ إِمْساكٌ':Predicate, #9: 9	فَعَلَ الْإِمَامُ
u'فَعَلَ أَمينٌ':Subject, #1: 1	فَعَلَ الْإِمْسَاكَ
u'فَعَلَ إِنْسانٌ':Subject, #1: 1	فَعَلَ الْأَمِينُ
u'فَعَلَ أهْلٌ':Subject, #1: 1	فَعَلَ الإِنْسَانُ
u'فَعَلَ أَوَّلُ':Subject, #6: 6	فَعَلَ أَهْلُ
u'فَعَلَ إيمَانٌ':Predicate, #2: 2	فَعَلَ الْأَوَّلُ
u'فَعَلَ بَائِعٌ':Subject, #1: 1	فَعَلَ الْإِيمَانَ
u'فَعَلَ بَرٌّ':Predicate, #1: 1	فَعَلَ الْبَائِعُ
u'فَعَلَ بَطَلٌ':Predicate, #1: 1	فَعَلَ بَرَّ
u'فَعَلَ بَعْضٌ':Predicate, #4: 4	فَعَلَ بَطَلَ
u'فَعَلَ بَعْضٌ':Subject, #6: 6	فَعَلَ بَعْضَ
u'فَعَلَ بَقِيَّةٌ':Predicate, #2: 2	فَعَلَ بَعْضُ
u'فَعَلَ تَرْكٌ':Predicate, #1: 1	فَعَلَ بَقِيَّةَ
u'فَعَلَ جَازٌ':Predicate, #1: 1	فَعَلَ التَّرْكَ
u'فَعَلَ جَعْدٌ':Subject, #8: 8	فَعَلَ جَازَ
u'فَعَلَ جَمِيع':Predicate, #1: 1	فَعَلَ الْجَعْدُ
u'فَعَلَ حاجٌّ':Subject, #2: 2	فَعَلَ الْجَمِيعَ
u'فَعَلَ حاطِبٌ':Subject, #1: 1	فَعَلَ الْحَاجُّ
u'فَعَلَ حاكِمٌ':Subject, #1: 1	فَعَلَ حَاطِبُ
u'فَعَلَ حِجَّةٌ':Predicate, #4: 4	فَعَلَ الْحَاكِمُ
u'فَعَلَ حَسَنٌ':Predicate, #1: 1	فَعَلَ الْحِجَّةَ
u'فَعَلَ حُقْنَةٌ':Predicate, #1: 1	فَعَلَ حَسَنَةً
u'فَعَلَ حَمْز':Subject, #3: 3	فَعَلَ الْحُقْنَةَ
u'فَعَلَ خَادِمٌ':Subject, #1: 1	فَعَلَ حَمْزَةُ
u'فَعَلَ خَالِدٌ':Subject, #1: 1	فَعَلَ خَادِمُ
u'فَعَلَ خَطِيبٌ':Subject, #2: 2	فَعَلَ خَالِدٌ
u'فَعَلَ خِلاَفٌ':Predicate, #1: 1	فَعَلَ الْخَطِيبُ
u'فَعَلَ خُلَفَاءُ':Subject, #6: 6	فَعَلَ خِلَافَ
u'فَعَلَ خَلِيلٌ':Subject, #1: 1	فَعَلَ الْخُلَفَاءُ
u'فَعَلَ خَيْرٌ':Predicate, #1: 1	فَعَلَ الْخَلِيلُ
u'فَعَلَ رَاهِنٌ':Subject, #1: 1	فَعَلَ الْخَيْرَ
u'فَعَلَ رَبُّ':Predicate, #2: 2	فَعَلَ الرَّاهِنُ
u'فَعَلَ رَجُلٌ':Subject, #2: 2	فَعَلَ رَبّكَ
u'فَعَلَ رَدٌّ':Predicate, #3: 3	فَعَلَ الرَّجُلُ
u'فَعَلَ رَسُولٌ':Subject, #2: 2	فَعَلَ رَدَّ
u'فَعَلَ رُهْبانٌ':Subject, #36: 36	فَعَلَ رَسُولُ
u'فَعَلَ رُهْبَانٌ':Subject, #1: 1	فَعَلَ الرُّهْبَانُ
u'فَعَلَ رَهْطٌ':Subject, #1: 1	فَعَلَ الرُّهْبَانُ
u'فَعَلَ زُفَرٌ':Subject, #2: 2	فَعَلَ الرَّهْطُ
u'فَعَلَ زَوْجٌ':Subject, #1: 1	فَعَلَ زُفَرُ
u'فَعَلَ زَيْدٌ':Subject, #5: 5	فَعَلَ الزَّوْجُ
u'فَعَلَ سَائِرٌ':Subject, #1: 1	فَعَلَ زَيْدٌ
u'فَعَلَ سِتٌّ':Subject, #1: 1	فَعَلَ سَائِرُ
u'فَعَلَ سِرَاجٌ':Subject, #1: 1	فَعَلَ السِّتَّةُ
u'فَعَلَ سَعْدٌ':Subject, #1: 1	فَعَلَ السِّرَاجُ
u'فَعَلَ سَعْدٌ':Subject, #1: 1	فَعَلَ سَعْدٌ
u'فَعَلَ سقط':Predicate, #2: 2	فَعَلَ سَعْدُ
u'فَعَلَ سَقَطٌ':Predicate, #2: 2	فَعَلَ سَقَطَ
u'فَعَلَ سَهْلٌ':Subject, #2: 2	فَعَلَ سَقَطَ
u'فَعَلَ سَيِّدٌ':Subject, #2: 2	فَعَلَ سَهْلٌ
u'فَعَلَ شَارِحٌ':Subject, #1: 1	فَعَلَ سَيّدُ
u'فَعَلَ شمس':Subject, #5: 5	فَعَلَ الشَّارِحُ
u'فَعَلَ شَمْسٌ':Subject, #1: 1	فَعَلَ شَمْسُ
u'فَعَلَ شَيْخٌ':Subject, #1: 1	فَعَلَ شَمْسُ
u'فَعَلَ شَيْخٌ':Subject, #1: 1	فَعَلَ الشَّيْخُ
u'فَعَلَ صَاحِبٌ':Subject, #1: 1	فَعَلَ شَيْخُهُ
u'فَعَلَ صَبِيٌّ':Subject, #2: 2	فَعَلَ صَاحِبُ
u'فَعَلَ صَحَابَةٌ':Subject, #1: 1	فَعَلَ الصَّبِيُّ
u'فَعَلَ صَدْرٌ':Subject, #2: 2	فَعَلَ الصَّحَابَةُ
u'فَعَلَ صِدِّيقٌ':Subject, #1: 1	فَعَلَ صَدْرُ
u'فَعَلَ صَغِيرٌ':Predicate, #1: 1	فَعَلَ الصِّدِّيقُ
u'فَعَلَ صِفَةٌ':Predicate, #1: 1	فَعَلَ صَغِيرَةً
u'فَعَلَ صَفْوَان':Subject, #1: 1	فَعَلَ الصِّفَةَ
u'فَعَلَ صَوْمٌ':Predicate, #1: 1	فَعَلَ صَفْوَانُ
u'فَعَلَ ضَرَرٌ':Predicate, #1: 1	فَعَلَ الصَّوْمَ
u'فَعَلَ ضَمِنٌ':Predicate, #1: 1	فَعَلَ الضَّرَرَ
u'فَعَلَ طَلْحٌ':Subject, #15: 15	فَعَلَ ضَمِنَ
u'فَعَلَ طلحة':Subject, #1: 1	فَعَلَ طَلْحَةُ
u'فَعَلَ طواف':Predicate, #1: 1	فَعَلَ طَلْحَةُ
u'فَعَلَ طَوَافٌ':Predicate, #1: 1	فَعَلَ الطَّوَافَ
u'فَعَلَ ظاهِرٌ':Predicate, #1: 1	فَعَلَ الطَّوَافَ
u'فَعَلَ عِبَادَةٌ':Predicate, #1: 1	فَعَلَ الظَّاهِرَ
u'فَعَلَ عَبْدٌ':Subject, #1: 1	فَعَلَ الْعِبَادَةَ
u'فَعَلَ عَبْدٌ':Subject, #2: 2	فَعَلَ عَبْدُ
u'فَعَلَ عِدَّةٌ':Predicate, #3: 3	فَعَلَ الْعَبْدُ
u'فَعَلَ عُرْوَةٌ':Subject, #1: 1	فَعَلَ عِدَّةَ
u'فَعَلَ علماء':Subject, #1: 1	فَعَلَ عُرْوَةُ
u'فَعَلَ عُلَمَاءُ':Subject, #2: 2	فَعَلَ الْعُلَمَاءُ
u'فَعَلَ عَلِيٌّ':Subject, #2: 2	فَعَلَ الْعُلَمَاءُ
u'فَعَلَ عُمَرٌ':Subject, #6: 6	فَعَلَ عَلِيٌّ
u'فَعَلَ عند':Predicate, #24: 24	فَعَلَ عُمَرُ
u'فَعَلَ عين':Predicate, #1: 1	فَعَلَ عِنْدَ
u'فَعَلَ عَيْنٌ':Predicate, #3: 3	فَعَلَ عَيْنَ
u'فَعَلَ عَيْن':Predicate, #3: 3	فَعَلَ عَيْنَ
u'فَعَلَ غير':Predicate, #3: 3	فَعَلَ عَيْنَ
u'فَعَلَ غَيْرٌ':Predicate, #1: 1	فَعَلَ غَيْرَ
u'فَعَلَ غير':Subject, #1: 1	فَعَلَ غَيْرَ
u'فَعَلَ غَيْرٌ':Subject, #3: 3	فَعَلَ غَيْرُ
u'فَعَلَ غير':Subject, #3: 3	فَعَلَ غَيْرُ
u'فَعَلَ غَيْرٌ':Subject, #5: 5	فَعَلَ غَيْرُهُ
u'فَعَلَ فخر':Subject, #5: 5	فَعَلَ غَيْرُهُ
u'فَعَلَ فَخْرٌ':Subject, #2: 2	فَعَلَ فَخْرُ
u'فَعَلَ فرار':Predicate, #2: 2	فَعَلَ فَخْرُ
u'فَعَلَ فِرَارٌ':Predicate, #1: 1	فَعَلَ الْفِرَارَ
u'فَعَلَ فَرْضٌ':Predicate, #1: 1	فَعَلَ الْفِرَارَ
u'فَعَلَ فَرْضٌ':Predicate, #1: 1	فَعَلَ فَرْضَ
u'فَعَلَ فِعْلٌ':Predicate, #2: 2	فَعَلَ الْفَرْضَ
u'فَعَلَ فِعْلٌ':Predicate, #3: 3	فَعَلَ فِعْلَ
u'فَعَلَ فَلًا':Predicate, #4: 4	فَعَلَ الْفِعْلَ
u'فَعَلَ فلان':Predicate, #1: 1	فَعَلَ فَلاَ
u'فَعَلَ فلان':Subject, #1: 1	فَعَلَ سُفْيَانَ
u'فَعَلَ فلان':Subject, #1: 1	فَعَلَ الزُّبَيْرُ
u'فَعَلَ فلان':Subject, #1: 1	فَعَلَ حَمْزَةُ
u'فَعَلَ فُلاَنٌ':Subject, #1: 1	فَعَلَ شُعَيْبٌ
u'فَعَلَ فلان':Subject, #1: 1	فَعَلَ فُلاَنٌ
u'فَعَلَ فلان':Subject, #1: 1	فَعَلَ مُعَاوِيَةُ
u'فَعَلَ فُلاَنٌ':Subject, #3: 3	فَعَلَ عُثْمَانُ
u'فَعَلَ قَابِلٌ':Subject, #5: 5	فَعَلَ فُلَانٌ
u'فَعَلَ قَالٌ':Predicate, #1: 1	فَعَلَ الْقَابِلُ
u'فَعَلَ قتل':Predicate, #5: 5	فَعَلَ قَالَ
u'فَعَلَ قَهْقَه':Predicate, #1: 1	فَعَلَ قَتَلَ
u'فَعَلَ قَهْقَهَة':Predicate, #1: 1	فَعَلَ الْقَهْقَهَةَ
u'فَعَلَ قَوْمٌ':Subject, #1: 1	فَعَلَ الْقَهْقَهَةَ
u'فَعَلَ قَوْمٌ':Subject, #1: 1	فَعَلَ قَوْمٌ
u'فَعَلَ كَافِرٌ':Subject, #2: 2	فَعَلَ الْقَوْمُ
u'فَعَلَ كَبِيرٌ':Predicate, #1: 1	فَعَلَ الْكَافِرُ
u'فَعَلَ كِتَابٌ':Subject, #1: 1	فَعَلَ الْكَبِيرَةَ
u'فَعَلَ كرهة':Subject, #1: 1	فَعَلَ الْكِتَابُ
u'فَعَلَ كَعْبٌ':Subject, #1: 1	فَعَلَ كَرِهْتُهُ
u'فَعَلَ كَعْبٌ':Subject, #1: 1	فَعَلَ كَعْبٌ
u'فَعَلَ كَفَّارٌ':Predicate, #2: 2	فَعَلَ كَعْبُ
u'فَعَلَ كُفَّارٌ':Subject, #1: 1	فَعَلَ الْكَفَّارَةَ
u'فَعَلَ كَفَّارَةٌ':Predicate, #1: 1	فَعَلَ الْكُفَّارُ
u'فَعَلَ كَفِيلٌ':Subject, #1: 1	فَعَلَ الْكَفَّارَةَ
u'فَعَلَ مَالٌ':Subject, #1: 1	فَعَلَ الْكَفِيلُ
u'فَعَلَ مَالِكٌ':Subject, #1: 1	فَعَلَ الْمَالُ
u'فَعَلَ مَأْمُورٌ':Predicate, #2: 2	فَعَلَ مَالِكٌ
u'فَعَلَ مُبْتَدِعٌ':Subject, #6: 6	فَعَلَ الْمَأْمُورَ
u'فَعَلَ مثل':Predicate, #1: 1	فَعَلَ الْمُبْتَدِعَةُ
u'فَعَلَ مِثْلٌ':Predicate, #29: 29	فَعَلَ مِثْلَ
u'فَعَلَ مُحْتَمَلٌ':Predicate, #29: 29	فَعَلَ مِثْلَ
u'فَعَلَ مُحْرِمٌ':Subject, #1: 1	فَعَلَ الْمُحْتَمَلَ
u'فَعَلَ مَحْظُورٌ':Predicate, #1: 1	فَعَلَ الْمُحْرِمُ
u'فَعَلَ مُحَمَّدٌ':Subject, #1: 1	فَعَلَ مَحْظُورَ
u'فَعَلَ مُحَمَّدٌ':Subject, #1: 1	فَعَلَ مُحَمَّدٌ
u'فَعَلَ مُخْتَلَفٌ':Predicate, #1: 1	فَعَلَ مُحَمَّدُ
u'فَعَلَ مرٌّ':Predicate, #1: 1	فَعَلَ الْمُخْتَلَفَ
u'فَعَلَ مُرْتَهِنٌ':Subject, #1: 1	فَعَلَ مَرَّةً
u'فَعَلَ مَسْكٌ':Subject, #1: 1	فَعَلَ الْمُرْتَهِنُ
u'فَعَلَ مَسْلُولٌ':Subject, #1: 1	فَعَلَ مَسْكُ
u'فَعَلَ مُصَنِّفٌ':Subject, #1: 1	فَعَلَ الْمَسْلُولُ
u'فَعَلَ مُعانَقَة':Predicate, #7: 7	فَعَلَ الْمُصَنِّفُ
u'فَعَلَ مُعاوِيَة':Subject, #1: 1	فَعَلَ الْمُعَانَقَةَ
u'فَعَلَ مُعَجَّلٌ':Predicate, #1: 1	فَعَلَ مُعَاوِيَةُ
u'فَعَلَ مَعْصِيَةٌ':Predicate, #1: 1	فَعَلَ الْمُعَجَّلَ
u'فَعَلَ مُعَلَّقٌ':Predicate, #2: 2	فَعَلَ الْمَعْصِيَةَ
u'فَعَلَ مُقَلِّدٌ':Subject, #2: 2	فَعَلَ الْمُعَلَّقَ
u'فَعَلَ مُكْرَهٌ':Subject, #1: 1	فَعَلَ الْمُقَلِّدُ
u'فَعَلَ مَكْرُوهٌ':Predicate, #1: 1	فَعَلَ الْمُكْرَهُ
u'فَعَلَ مُكَلَّفٌ':Subject, #1: 1	فَعَلَ الْمَكْرُوهَ
u'فَعَلَ مَلَكٌ':Subject, #2: 2	فَعَلَ الْمُكَلَّفُ
u'فَعَلَ مُمْكِنٌ':Predicate, #2: 2	فَعَلَ الْمَلَكُ
u'فَعَلَ مُمْكِن':Predicate, #2: 2	فَعَلَ الْمُمْكِنَ
u'فَعَلَ مَنْسِيٌّ':Predicate, #2: 2	فَعَلَ الْمُمْكِنَ
u'فَعَلَ مَنْهِيٌّ':Predicate, #1: 1	فَعَلَ الْمَنْسِيَّ
u'فَعَلَ مُؤَجِّرٌ':Subject, #1: 1	فَعَلَ الْمَنْهِيَّ
u'فَعَلَ مُودَعٌ':Subject, #2: 2	فَعَلَ الْمُؤَجِّرُ
u'فَعَلَ مُؤَذِّنٌ':Subject, #2: 2	فَعَلَ الْمُودَعُ
u'فَعَلَ مُوَكِّلٌ':Subject, #1: 1	فَعَلَ الْمُؤَذِّنُ
u'فَعَلَ مُؤَلِّفٌ':Subject, #1: 1	فَعَلَ الْمُوَكِّلُ
u'فَعَلَ نَاسٌ':Subject, #2: 2	فَعَلَ الْمُؤَلِّفُ
u'فَعَلَ نَاظِمٌ':Subject, #1: 1	فَعَلَ النَّاسُ
u'فَعَلَ نَبِيٌّ':Subject, #1: 1	فَعَلَ النَّاظِمُ
u'فَعَلَ نَظِيرٌ':Predicate, #27: 27	فَعَلَ النَّبِيُّ
u'فَعَلَ نفر':Subject, #1: 1	فَعَلَ نَظِيرَ
u'فَعَلَ نَفَرٌ':Subject, #1: 1	فَعَلَ النَّفَرُ
u'فَعَلَ نفر':Subject, #1: 1	فَعَلَ النَّفَرُ
u'فَعَلَ نَفَرٌ':Subject, #2: 2	فَعَلَ النّفَرُ
u'فَعَلَ نَفْسٌ':Predicate, #2: 2	فَعَلَ النّفَرُ
u'فَعَلَ وَاجِبٌ':Predicate, #1: 1	فَعَلَ نَفْسَ
u'فَعَلَ واحد':Subject, #7: 7	فَعَلَ الْوَاجِبَ
u'فَعَلَ وَاحِدٌ':Subject, #1: 1	فَعَلَ وَاحِدٌ
u'فَعَلَ وَجَبٌ':Predicate, #1: 1	فَعَلَ وَاحِدٌ
u'فَعَلَ وَرَثَةٌ':Subject, #1: 1	فَعَلَ وَجَبَ
u'فَعَلَ وَصِيٌّ':Subject, #1: 1	فَعَلَ الْوَرَثَةُ
u'فَعَلَ وُضُوءٌ':Predicate, #2: 2	فَعَلَ الْوَصِيُّ
u'فَعَلَ وقع':Predicate, #1: 1	فَعَلَ الْوُضُوءَ
u'فَعَلَ وَكِيلٌ':Subject, #2: 2	فَعَلَ وَقَعَ
u'فَعَلَ وَكِيلٌ':Subject, #1: 1	فَعَلَ وَكِيلُ
u'فَعَلَ وَكِيلٌ':Subject, #1: 1	فَعَلَ وَكِيلُهُ
u'فَعَلَ ولد':Subject, #6: 6	فَعَلَ الْوَكِيلُ
u'فَعَلَ وَلَدٌ':Subject, #1: 1	فَعَلَ الْوَلَدُ
u'فَعَلَ وَلَهٌ':Subject, #1: 1	فَعَلَ الْوَلَدُ
u'فَعَلَ وَهَلٌ':Predicate, #2: 2	فَعَلَ وَلَهُ
u'فَعَلَ يَعْقُوبٌ':Subject, #2: 2	فَعَلَ وَهَلَكَ
u'فَعَلَ يهود':Subject, #1: 1	فَعَلَ يَعْقُوبُ
u'فَعَلَ يَهُودٌ':Subject, #1: 1	فَعَلَ الْيَهُودُ
u'فَعَلَ يَوْمٌ':Predicate, #1: 1	فَعَلَ الْيَهُودُ
u'فَغَرَ فَاهٌ':Subject, #1: 1	فَعَلَ الْيَوْمَ
u'فَقَأَ أَجْنَبِيٌّ':Subject, #2: 2	فَغَرَ فَاهُ
u'فَقَأَ أَجْنَبِيٌّ':Subject, #1: 1	فَقَأَ أَجْنَبِيٌّ
u'فَقَأَ أصْغَرٌ':Subject, #1: 1	فَقَأَ الْأَجْنَبِيُّ
u'فَقَأَ أَصْغَرُ':Subject, #1: 1	فَقَأَ الْأَصْغَرُ
u'فَقَأَ أعْوَر':Subject, #1: 1	فَقَأَ الْأَصْغَرُ
u'فَقَأَ أعْوَر':Subject, #3: 3	فَقَأَ أَعْوَرُ
u'فَقَأَ رَبُّ':Subject, #3: 3	فَقَأَ الْأَعْوَرُ
u'فَقَأَ رَجُلٌ':Subject, #1: 1	فَقَأَ رَبُّ
u'فَقَأَ سَالِمٌ':Subject, #8: 8	فَقَأَ رَجُلٌ
u'فَقَأَ صَاحِبٌ':Subject, #1: 1	فَقَأَ سَالِمُ
u'فَقَأَ صَحِيحٌ':Subject, #1: 1	فَقَأَ صَاحِبُ
u'فَقَأَ عَبْدٌ':Subject, #1: 1	فَقَأَ صَحِيحُ
u'فَقَأَ عين':Predicate, #2: 2	فَقَأَ الْعَبْدُ
u'فَقَأَ عَيْنٌ':Predicate, #27: 27	فَقَأَ عَيْنَ
u'فَقَأَ عَيْن':Predicate, #27: 27	فَقَأَ عَيْنَ
u'فَقَأَ عين':Predicate, #27: 27	فَقَأَ عَيْنَ
u'فَقَأَ عَيْنٌ':Predicate, #2: 2	فَقَأَ الْعَيْنَ
u'فَقَأَ عَيْن':Predicate, #2: 2	فَقَأَ الْعَيْنَ
u'فَقَأَ مُحْرِمٌ':Subject, #2: 2	فَقَأَ الْعَيْنَ
u'فَقَأَ ولد':Subject, #1: 1	فَقَأَ مُحْرِمٌ
u'فَقَأَ وَلَدٌ':Subject, #1: 1	فَقَأَ الْوَلَدُ
u'فَقْدٌ أَبٌ':Added, #1: 1	فَقَأَ الْوَلَدُ
u'فَقْدٌ أَبٌ':Added, #1: 1	فَقْدُ الْأَبِ
u'فَقْدٌ إِبِلٌ':Added, #4: 4	فَقْدِ الْأَبِ
u'فَقْدٌ إِبْهَامٌ':Added, #1: 1	فَقْدِ إبِلِ
u'فَقْدٌ أثَرٌ':Added, #1: 1	فَقْدَ الْإِبْهَامِ
u'فَقَدَ أحَدٌ':Predicate, #1: 1	فَقْدُ أَثَرِ
u'فَقْدٌ أَخٌ':Added, #1: 1	فَقَدَ أَحَدَ
u'فَقَدَ إِزَارٌ':Predicate, #1: 1	فَقْدِ الْأَخِ
u'فَقْدٌ أسْنَانٌ':Added, #1: 1	فَقَدَ الْإِزَارَ
u'فَقْدٌ أُصْبُعٌ':Added, #1: 1	فَقْدُ الْأَسْنَانِ
u'فَقْدٌ أصل':Added, #1: 1	فَقْدِ أُصْبُعٍ
u'فَقْدٌ أًصْلٌ':Added, #1: 1	فَقْدِ الْأَصْلِ
u'فَقْدٌ اِعْتِقادٌ':Added, #1: 1	فَقْدِ الْأَصْلِ
u'فَقْدٌ أَعْضَاءٌ':Added, #1: 1	فَقْدُ اعْتِقَادِ
u'فَقْدٌ أَعْوَانٌ':Added, #1: 1	فَقْدُ الْأَعْضَاءِ
u'فَقْدٌ أقَلُّ':Added, #1: 1	فَقْدِ الْأَعْوَانِ
u'فَقْدٌ آلةٌ':Added, #1: 1	فَقْدِ الْأَقَلِّ
u'فَقْدٌ إلْهَامٌ':Added, #1: 1	فَقْدِ آلَةٍ
u'فَقْدٌ أُمٌّ':Added, #2: 2	فَقْدُ الْإِلْهَامِ
u'فُقْدَانٌ أَطْرافٌ':Added, #1: 1	فَقْدِ الْأُمِّ
u'فُقْدَانٌ أَطْرَافٌ':Added, #1: 1	فُقْدَانُ الْأَطْرَافِ
u'فَقْدٌ أنَامِلُ':Added, #1: 1	فُقْدَانُ الْأَطْرَافِ
u'فُقْدَانٌ بَيِّنَةٌ':Added, #1: 1	فَقْدَ الْأَنَامِلِ
u'فُقْدَانٌ دَليلٌ':Added, #1: 1	فُقْدَانِ الْبَيِّنَةِ
u'فُقْدَانٌ رَبِيعٌ':Added, #1: 1	فُقْدَانِ الدَّلِيلِ
u'فَقْدٌ أهْلٌ':Added, #1: 1	فُقْدَانَ الرّبِيعِ
u'فَقْدٌ أَهْلِيٌّ':Added, #1: 1	فَقْدِ الْأَهْلِ
u'فَقْدٌ أهْلِيَّةٌ':Added, #1: 1	فَقْدِ أَهْلِيَّةِ
u'فَقَدَ بساط':Predicate, #1: 1	فَقْدِ أَهْلِيَّةِ
u'فَقَدَ بِساطٌ':Predicate, #1: 1	فَقَدَ الْبِسَاطَ
u'فَقْدٌ بَصَرٌ':Added, #1: 1	فَقَدَ الْبِسَاطَ
u'فَقْدٌ بَصَرٌ':Added, #1: 1	فَقْدِ الْبَصَرِ
u'فَقَدَ بَصيرٌ':Predicate, #1: 1	فَقْدِ بَصَرٍ
u'فَقْدٌ بَعْضٌ':Added, #1: 1	فَقَدَ الْبَصِيرَ
u'فَقْدٌ بَعْضٌ':Added, #1: 1	فَقْدَ بَعْضِ
u'فَقْدٌ بناتٌ':Added, #1: 1	فَقْدِ بَعْضِ
u'فَقَدَ بِنْتٌ':Predicate, #1: 1	فَقْدِ الْبَنَاتِ
u'فَقْدٌ بِنْتٌ':Added, #1: 1	فَقَدَ بِنْتَ
u'فَقْدٌ بَيْتٌ':Added, #6: 6	فَقْدِ بِنْتِ
u'فَقْدٌ بَيِّنَةٌ':Added, #1: 1	فَقْدِ بَيْتِ
u'فَقَدَ تُرَابٌ':Predicate, #2: 2	فَقْدِ الْبَيِّنَةِ
u'فَقْدٌ تَرْتِيبٌ':Added, #1: 1	فَقَدَ التُّرَابَ
u'فَقْدٌ تَسْمِيَة':Added, #1: 1	فَقْدِ التَّرْتِيبِ
u'فَقْدٌ تَعَارُضٌ':Added, #2: 2	فَقْدِ التَّسْمِيَةِ
u'فَقْدٌ تَعْلِيمٌ':Added, #1: 1	فَقْدِ تَعَارُضِ
u'فَقْدٌ ثَلاثَةٌ':Added, #1: 1	فَقْدِ التَّعْلِيمِ
u'فَقْدٌ ثَلاثَةٌ':Added, #1: 1	فَقْدَ الثَّلَاثَةِ
u'فَقْدٌ حاجِبٌ':Added, #1: 1	فَقْدُ الثَّلَاثَةِ
u'فَقَدَ حاكِمٌ':Subject, #1: 1	فَقْدِ الْحَاجِبِ
u'فَقْدٌ حاكِمٌ':Added, #1: 1	فَقَدَ الْحَاكِمُ
u'فَقَدَ حَلالٌ':Predicate, #3: 3	فَقْدِ الْحَاكِمِ
u'فَقَدَ حُوتٌ':Predicate, #1: 1	فَقَدَ الْحَلَالَ
u'فَقْدٌ حَيٌّ':Added, #1: 1	فَقَدَ الْحُوتَ
u'فَقْدٌ خِبْرَةٌ':Added, #1: 1	فَقْدِ الْحَيِّ
u'فَقَدَ دَابَّةٌ':Predicate, #2: 2	فَقْدِ خِبْرَةٍ
u'فَقْدٌ دَليلٌ':Added, #1: 1	فَقَدَ الدَّابَّةَ
u'فَقْدٌ دِينٌ':Added, #1: 1	فَقْدِ الدَّلِيلِ
u'فَقْدٌ ذَوْقٌ':Added, #2: 2	فَقْدُ الدِّينِ
u'فَقْدٌ ذَوْقٌ':Added, #1: 1	فَقْدُ الذَّوْقِ
u'فَقْدٌ رِجَالٌ':Added, #1: 1	فَقْدُ ذَوْقٍ
u'فَقْدٌ رِدَاءٌ':Added, #1: 1	فَقْدِ الرِّجَالِ
u'فَقَدَ رَسُولٌ':Subject, #1: 1	فَقْدِ الرِّدَاءِ
u'فَقْدٌ زَعيمٌ':Added, #1: 1	فَقَدَ رَسُولُ
u'فَقْدٌ سَبَبٌ':Added, #1: 1	فَقْدَ الزَّعِيمِ
u'فَقْدٌ سَمْعٌ':Added, #2: 2	فَقْدِ السَّبَبِ
u'فَقَدَ شَرْطٌ':Predicate, #1: 1	فَقْدَ السَّمْعِ
u'فَقْدٌ شَرْطٌ':Added, #1: 1	فَقَدَ الشَّرْطَ
u'فَقْدٌ شَرْطٌ':Added, #1: 1	فَقْدُ الشَّرْطِ
u'فَقْدٌ شَرْطٌ':Added, #1: 1	فَقْدَ شَرْطٍ
u'فَقْدٌ شَرْطٌ':Added, #1: 1	فَقْدُ شَرْطِ
u'فَقْدٌ شَرْطٌ':Added, #2: 2	فَقْدِ الشَّرْطَيْنِ
u'فَقْدٌ شَرْطٌ':Added, #2: 2	فَقْدَ شَرْطِ
u'فَقْدٌ شَرْطٌ':Added, #2: 2	فَقْدِ شَرْطٍ
u'فَقْدٌ شَرْطٌ':Added, #3: 3	فَقْدِ شَرْطِ
u'فَقْدٌ شَرْطٌ':Added, #4: 4	فَقْدِ الشَّرْطِ
u'فَقْدٌ شُرُوطٌ':Added, #4: 4	فَقْدِ شَرْطِهِ
u'فَقْدٌ شُرُوطٌ':Added, #1: 1	فَقْدِ الشُّرُوطِ
u'فَقَدَ شَعْرٌ':Predicate, #1: 1	فَقْدِ شُرُوطِ
u'فَقَدَ شَعْرٌ':Predicate, #1: 1	فَقَدَ الشَّعْرَ
u'فَقْدٌ شَعْرٌ':Added, #1: 1	فَقَدَ شَعْرَ
u'فَقْدٌ شَيْءٌ':Added, #1: 1	فَقْدِ شَعْرِهِ
u'فَقْدٌ صِفَةٌ':Added, #2: 2	فَقْدَ شَيْءٍ
u'فَقْدٌ صِفَةٌ':Added, #1: 1	فَقْدِ صِفَةٍ
u'فَقْدٌ صَوْتٌ':Added, #2: 2	فَقْدِ الصِّفَةِ
u'فَقْدٌ طعام':Added, #1: 1	فَقْدُ الصَّوْتِ
u'فَقْدٌ طَعَامٌ':Added, #1: 1	فَقْدُ الطَّعَامِ
u'فَقَدَ طهر':Predicate, #1: 1	فَقْدُ الطَّعَامِ
u'فَقْدٌ طَوْلٌ':Added, #1: 1	فَقَدَ طَهُرَ
u'فَقْدٌ عَاقِلٌ':Added, #1: 1	فَقْدِ الطَّوْلِ
u'فَقَدَ عَالِمٌ':Subject, #1: 1	فَقْدِ الْعَاقِلَةِ
u'فَقْدٌ عَائِقٌ':Added, #1: 1	فَقَدَ الْعَالِمُ
u'فَقْدٌ عَصَبَةٌ':Added, #1: 1	فَقْدَ الْعَائِقِ
u'فَقْدٌ عصبة':Added, #1: 1	فَقْدِ الْعَصَبَاتِ
u'فَقْدٌ عَصَبَةٌ':Added, #1: 1	فَقْدِ الْعَصَبَةِ
u'فَقْدٌ عَقْدٌ':Added, #1: 1	فَقْدِ الْعَصَبَةِ
u'فَقَدَ علم':Predicate, #1: 1	فَقْدِ الْعَقْدِ
u'فَقَدَ عِلْمٌ':Predicate, #1: 1	فَقَدَ الْعِلْمَ
u'فَقَدَ عَمَلٌ':Subject, #1: 1	فَقَدَ الْعِلْمَ
u'فَقْدٌ عُيُوبٌ':Added, #1: 1	فَقَدَ عَمَلُ
u'فَقْدٌ غُرَّةٌ':Added, #1: 1	فَقْدُ الْعُيُوبِ
u'فَقَدَ غضب':Predicate, #1: 1	فَقْدِ الْغُرَّةِ
u'فَقَدَ غَضَبٌ':Predicate, #2: 2	فَقَدَ الْغَضَبَ
u'فَقْدٌ غير':Added, #2: 2	فَقَدَ الْغَضَبَ
u'فَقْدٌ غَيْرٌ':Added, #4: 4	فَقْدِ غَيْرِهِ
u'فَقَدَ فَرْضٌ':Predicate, #4: 4	فَقْدِ غَيْرِهِ
u'فَقْدٌ فَرْعٌ':Added, #1: 1	فَقَدَ الْفَرْضَ
u'فَقْدٌ فَهْمٌ':Added, #1: 1	فَقْدِ الْفَرْعِ
u'فَقْدٌ قَارِئٌ':Added, #1: 1	فَقْدِ فَهْمِ
u'فَقْدٌ قَاعِدٌ':Added, #1: 1	فَقْدِ الْقَارِئِ
u'فَقَدَ قَالٌ':Predicate, #1: 1	فَقْدَ الْقَاعِدِ
u'فَقْدٌ قدرة':Added, #1: 1	فَقَدَ قَالَ
u'فَقْدٌ قُدْرَةٌ':Added, #1: 1	فَقْدِ الْقُدْرَةِ
u'فَقْدٌ كُتُبٌ':Added, #1: 1	فَقْدِ الْقُدْرَةِ
u'فَقَدَ كَلَأٌ':Predicate, #1: 1	فَقْدِ الْكُتُبِ
u'فَقَدَ مَاءٌ':Predicate, #1: 1	فَقَدَ الْكَلَأَ
u'فَقْدٌ مَاءٌ':Added, #4: 4	فَقَدَ الْمَاءَ
u'فَقْدٌ مَاءٌ':Added, #11: 11	فَقْدُ الْمَاءِ
u'فَقَدَ مثل':Predicate, #15: 15	فَقْدِ الْمَاءِ
u'فَقَدَ مِثْلٌ':Predicate, #1: 1	فَقَدَ الْمِثْلَ
u'فَقْدٌ مثل':Added, #1: 1	فَقَدَ الْمِثْلَ
u'فَقْدٌ مِثْلٌ':Added, #2: 2	فَقْدِ الْمِثْلِ
u'فَقْدٌ مَحْرَمٌ':Added, #2: 2	فَقْدِ الْمِثْلِ
u'فَقْدٌ مَحْرَمٌ':Added, #1: 1	فَقْدَ الْمَحْرَمِ
u'فَقْدٌ مَحْرَمٌ':Added, #1: 1	فَقْدُ الْمَحْرَمِ
u'فَقْدٌ مُرُوءةٌ':Added, #2: 2	فَقْدِ الْمَحْرَمِ
u'فَقْدٌ مَصْلَحَةٌ':Added, #1: 1	فَقْدِ الْمُرُوءَةِ
u'فَقْدٌ مَعْرِفَةٌ':Added, #1: 1	فَقْدِ مَصْلَحَةِ
u'فَقْدٌ مَعْرِفَة':Added, #1: 1	فَقْدَ مَعْرِفَةِ
u'فَقْدٌ مُمْسِكٌ':Added, #1: 1	فَقْدَ مَعْرِفَةِ
u'فَقْدٌ مَنْصِبٌ':Added, #1: 1	فَقْدِ الْمُمْسِكِ
u'فَقْدٌ مَنْصُوصٌ':Added, #1: 1	فَقْدُ الْمَنْصِبِ
u'فَقْدٌ مَنْفَعَةٌ':Added, #1: 1	فَقْدِ الْمَنْصُوصِ
u'فَقَدَ مَوْجُودٌ':Predicate, #1: 1	فَقْدُ مَنْفَعَةِ
u'فَقْدٌ نَاظِرٌ':Added, #1: 1	فَقَدَ الْمَوْجُودَ
u'فَقْدٌ نَسَبٌ':Added, #1: 1	فَقْدِ النَّاظِرِ
u'فَقَدَ نَصٌّ':Predicate, #1: 1	فَقْدِ النَّسَبِ
u'فَقْدٌ نَصٌّ':Added, #1: 1	فَقَدَ نَصَّ
u'فَقْدٌ نصاب':Added, #3: 3	فَقْدِ النَّصِّ
u'فَقْدٌ نِصَابٌ':Added, #2: 2	فَقْدُ النِّصَابِ
u'فَقَدَ نعمة':Predicate, #2: 2	فَقْدُ النِّصَابِ
u'فَقَدَ نِعْمَةٌ':Predicate, #1: 1	فَقَدَ نِعْمَةَ
u'فَقْدٌ نفاس':Added, #1: 1	فَقَدَ نِعْمَةَ
u'فَقْدٌ نِفَاسٌ':Added, #1: 1	فَقْدُ النِّفَاسِ
u'فَقْدٌ نِيَّةٌ':Added, #1: 1	فَقْدُ النِّفَاسِ
u'فَقْدٌ نِيَّةٌ':Added, #1: 1	فَقْدِ النِّيَّةِ
u'فَقْدٌ نِيَّةٌ':Added, #1: 1	فَقْدُ نِيَّةِ
u'فَقَدَ وَاجِبٌ':Predicate, #1: 1	فَقْدِ نِيَّةِ
u'فَقْدٌ وَاجِبٌ':Added, #2: 2	فَقَدَ الْوَاجِبَ
u'فَقْدٌ وَاجِبٌ':Added, #1: 1	فَقْدَ الْوَاجِبِ
u'فَقْدٌ واحد':Added, #1: 1	فَقْدِ الْوَاجِبِ
u'فَقْدٌ وَاحِدٌ':Added, #1: 1	فَقْدَ الْوَاحِدَةِ
u'فَقْدٌ وَالِدٌ':Added, #1: 1	فَقْدَ الْوَاحِدَةِ
u'فَقَدَ وَجَبٌ':Predicate, #1: 1	فَقْدَ وَالِدِهِ
u'فَقْدٌ ولد':Added, #1: 1	فَقَدَ وَجَبَ
u'فَقْدٌ وَلَدٌ':Added, #1: 1	فَقْدِ وَلَدِ
u'فَقْدٌ وَلِيٌّ':Added, #1: 1	فَقْدِ وَلَدِ
u'فَقْدٌ وَلِيٌّ':Added, #2: 2	فَقْدِ الْوَلِيِّ
u'فقر غير':Added, #3: 3	فَقْدُ الْوَلِيِّ
u'فقر غَيْرٌ':Added, #1: 1	فَقْرَ غَيْرِهِ
u'فَقْرٌ غير':Added, #1: 1	فَقْرَ غَيْرِهِ
u'فَقْرٌ غَيْرٌ':Added, #1: 1	فَقْرَ غَيْرِهِ
u'فقر قلب':Added, #1: 1	فَقْرَ غَيْرِهِ
u'فقر قلب':Added, #1: 1	فَقْرَ الْقَلْبِ
u'فَقْرٌ قلب':Added, #1: 1	فَقْرُ الْقَلْبِ
u'فَقْرٌ قلب':Added, #1: 1	فَقْرَ الْقَلْبِ
u'فقر قَلْبٌ':Added, #1: 1	فَقْرُ الْقَلْبِ
u'فقر قَلْبٌ':Added, #1: 1	فَقْرَ الْقَلْبِ
u'فقر قَلْب':Added, #1: 1	فَقْرُ الْقَلْبِ
u'فقر قَلْب':Added, #1: 1	فَقْرَ الْقَلْبِ
u'فَقْرٌ قَلْبٌ':Added, #1: 1	فَقْرُ الْقَلْبِ
u'فَقْرٌ قَلْبٌ':Added, #1: 1	فَقْرَ الْقَلْبِ
u'فَقْرٌ قَلْب':Added, #1: 1	فَقْرُ الْقَلْبِ
u'فَقْرٌ قَلْب':Added, #1: 1	فَقْرَ الْقَلْبِ
u'فقر قلب':Added, #1: 1	فَقْرُ الْقَلْبِ
u'فَقْرٌ قلب':Added, #2: 2	فَقْرِ الْقَلْبِ
u'فقر قَلْبٌ':Added, #2: 2	فَقْرِ الْقَلْبِ
u'فقر قَلْب':Added, #2: 2	فَقْرِ الْقَلْبِ
u'فَقْرٌ قَلْبٌ':Added, #2: 2	فَقْرِ الْقَلْبِ
u'فَقْرٌ قَلْب':Added, #2: 2	فَقْرِ الْقَلْبِ
u'فَقْرٌ مُدْقِعٌ':Added, #2: 2	فَقْرِ الْقَلْبِ
u'فَقِرَ مُقْرِضٌ':Predicate, #6: 6	فَقْرٍ مُدْقِعٍ
u'فقر وَاجِدٌ':Added, #1: 1	أَفْقَرَ الْمُقْرِضَ
u'فَقْرٌ وَاجِدٌ':Added, #1: 1	فَقْرِ الْوَاجِدِ
u'فقر وَالِدٌ':Added, #1: 1	فَقْرِ الْوَاجِدِ
u'فَقْرٌ وَالِدٌ':Added, #1: 1	فَقْرُ وَالِدِهِ
u'فِقْهٌ أصْغَرٌ':Added, #1: 1	فَقْرُ وَالِدِهِ
u'فِقْهٌ أَصْغَرُ':Added, #1: 1	فِقْهِ الْأَصْغَرِ
u'فِقْهٌ إمَامٌ':Added, #1: 1	فِقْهِ الْأَصْغَرِ
u'فِقْهٌ أئِمَّةٌ':Added, #1: 1	فِقْهُ الْإِمَامِ
u'فِقْهٌ بَابٌ':Added, #1: 1	فِقْهِ الْأَئِمَّةِ
u'فِقْهٌ تَعَبُّدٌ':Added, #1: 1	فِقْهِ الْبَابِ
u'فِقْهٌ تَفْوِيضٌ':Added, #1: 1	فِقْهُ التَّعَبُّدِ
u'فِقْهٌ جَالِسٌ':Added, #1: 1	فِقْهُ تَفْوِيضِ
u'فِقْهٌ جمع':Added, #1: 1	فِقْهٍ جَالِسٍ
u'فِقْهٌ جَمْعٌ':Added, #1: 1	فِقْهَ الْجَمْعِ
u'فَقِهَ حَديثٌ':Predicate, #1: 1	فِقْهَ الْجَمْعِ
u'فِقْهٌ حَديثٌ':Added, #1: 1	فَقِهَ حَدِيثَ
u'فِقْهٌ حَديثٌ':Added, #1: 1	فِقْهُ الْحَدِيثِ
u'فِقْهٌ حَديثٌ':Added, #1: 1	فِقْهِ حَدِيثِ
u'فِقْهٌ حَسَنٌ':Added, #2: 2	فِقْهُ حَدِيثِ
u'فِقْهٌ حَنَفِيَّةٌ':Added, #1: 1	فِقْهٍ حَسَنٍ
u'فَقِهَ رَجُلٌ':Subject, #3: 3	فِقْهِ الْحَنَفِيَّةِ
u'فِقْهٌ رَجُلٌ':Added, #1: 1	فَقِهَ الرَّجُلُ
u'فِقْهٌ رَجُلٌ':Added, #2: 2	فِقْهُ الرَّجُلِ
u'فِقْهٌ شَرْعِيٌّ':Added, #6: 6	فِقْهِ الرَّجُلِ
u'فِقْهٌ صَلاَةٌ':Added, #1: 1	فِقْهِ شَرْعِيٍّ
u'فِقْهٌ صَلاَةٌ':Added, #1: 1	فِقْهِ الصَّلَاةِ
u'فِقْهٌ عَالِمٌ':Added, #2: 2	فِقْهَ صَلَاتِهِ
u'فِقْهٌ عَرَبِيٌّ':Added, #1: 1	فِقْهِ الْعَالِمِ
u'فِقْهٌ عَرَبِيٌّ':Added, #11: 11	فِقْهِ الْعَرَبِيَّةِ
u'فِقْهٌ عَطَاءٌ':Added, #1: 1	فِقْهِ الْعَرَبِيِّ
u'فِقْهٌ عَكْسٌ':Added, #1: 1	فِقْهِ عَطَاءٍ
u'فِقْهٌ فقراء':Added, #1: 1	فِقْهُ الْعَكْسِ
u'فِقْهٌ فِقْهٌ':Added, #1: 1	فِقْهِ الْفُقَرَاءِ
u'فِقْهٌ قول':Added, #1: 1	فِقْهِ الْفِقْهِ
u'فِقْهٌ قَوْلٌ':Added, #1: 1	فِقْهُ قَوْلِهِ
u'فِقْهٌ لُغَةٌ':Added, #1: 1	فِقْهُ قَوْلِهِ
u'فِقْهٌ مَسْأَلَةٌ':Added, #3: 3	فِقْهِ اللُّغَةِ
u'فِقْهٌ مَسْأَلَةٌ':Added, #1: 1	فِقْهِ الْمَسْأَلَةِ
u'فِقْهٌ مَسَائِلُ':Added, #2: 2	فِقْهُ الْمَسْأَلَةِ
u'فِقْهٌ مُسَلَّمٌ':Added, #1: 1	فِقْهِ الْمَسَائِلِ
u'فِقْهٌ مُسْلِمٌ':Added, #1: 1	فِقْهُ مُسَلَّمٍ
u'فِكَاكٌ بَعْضٌ':Added, #1: 1	فِقْهُ مُسْلِمٍ
u'فِكَاكٌ حَجَرٌ':Added, #1: 1	فِكَاكِ الْبَعْضِ
u'فِكَاكٌ رِقابٌ':Added, #1: 1	فِكَاكُ الْحَجَرِ
u'فِكَاكٌ رَقَبَةٌ':Added, #1: 1	فِكَاكِ الرِّقَابِ
u'فِكَاكٌ رَقَبَةٌ':Added, #1: 1	فِكَاكَ رَقَبَتِهِ
u'فِكَاكٌ رَهْنٌ':Added, #3: 3	فِكَاكِ رَقَبَتِهِ
u'فِكَاكٌ رَهْنٌ':Added, #3: 3	فِكَاكُ الرَّهْنِ
u'فِكَاكٌ نَفْسٌ':Added, #3: 3	فِكَاكِ الرَّهْنِ
u'فَكَّ حاكِمٌ':Subject, #1: 1	فِكَاكِ نَفْسِهِ
u'فَكَّ حَجْرٌ':Predicate, #1: 1	فَكَّ الْحَاكِمُ
u'فَكَّ خَتْمٌ':Predicate, #3: 3	فَكَّ الْحَجْرَ
u'فَكَّرَ صَائِمٌ':Subject, #1: 1	فَكَّ الْخَتْمَ
u'فَكَّرَ عَاشِقٌ':Subject, #2: 2	فَكَّرَ الصَّائِمُ
u'فِكْرٌ قَاطِعٌ':Added, #1: 1	فَكَّرَ الْعَاشِقُ
u'فِكْرٌ قلب':Added, #1: 1	فِكْرٍ قَاطِعٍ
u'فِكْرٌ قَلْبٌ':Added, #1: 1	فِكْرِ الْقَلْبِ
u'فِكْرٌ قَلْب':Added, #1: 1	فِكْرِ الْقَلْبِ
u'فِكْرٌ قلب':Added, #1: 1	فِكْرِ الْقَلْبِ
u'فِكْرٌ قَلْبٌ':Added, #1: 1	فِكْرَ قَلْبِهِ
u'فِكْرٌ قَلْب':Added, #1: 1	فِكْرَ قَلْبِهِ
u'فَكَّرَ نَاسٌ':Subject, #1: 1	فِكْرَ قَلْبِهِ
u'فَكَّ رهان':Predicate, #1: 1	فَكَّرَ النَّاسُ
u'فَكَّ رِهانٌ':Predicate, #3: 3	فَكَّ رِهَانَ
u'فَكَّ رَهْنٌ':Predicate, #3: 3	فَكَّ رِهَانَ
u'فَكَّ سَيِّدٌ':Subject, #2: 2	فَكَّ الرَّهْنَ
u'فَكَّ مُرْتَهِنٌ':Subject, #1: 1	فَكَّ السَّيِّدُ
u'فَلَجَ يَوْمٌ':Predicate, #2: 2	فَكَّ الْمُرْتَهِنُ
u'فَلَحَ قَالٌ':Predicate, #1: 1	فَلَجَ يَوْمَ
u'فَلِحَ قَالٌ':Predicate, #1: 1	أَفْلَحَ قَالَ
u'فَلَّسَ بَائِعٌ':Subject, #1: 1	أَفْلَحَ قَالَ
u'فَلِسَ بَطَلٌ':Predicate, #1: 1	فَلَّسَ الْبَائِعُ
u'فَلَّسَ ثَانِي':Predicate, #1: 1	فَلِسَ بَطَلَ
u'فَلِسَ حامِلٌ':Subject, #2: 2	فَلَّسَ ثَانِيَةً
u'فَلَّسَ رَاهِنٌ':Subject, #1: 1	فَلِسَ الْحَامِلُ
u'فَلِسَ رَاهِنٌ':Subject, #1: 1	فَلَّسَ الرَّاهِنُ
u'فَلِسَ رَبُّ':Subject, #1: 1	فَلِسَ رَاهِنُهُ
u'فَلَّسَ رَبُّ':Subject, #1: 1	فَلِسَ رَبُّ
u'فَلَّسَ رَجُلٌ':Subject, #1: 1	فَلَّسَ رَبُّ
u'فَلَّسَ مُبْتاع':Subject, #2: 2	فَلَّسَ رَجُلٌ
u'فَلَقَ حَبٌّ':Predicate, #3: 3	فَلَّسَ الْمُبْتَاعُ
u'فَلَقَ حَبَّةٌ':Predicate, #8: 8	فَلَقَ الْحَبَّةَ
u'فَلَكَ أَجْرٌ':Subject, #8: 8	فَلَقَ الْحَبَّةَ
u'فَلَكَ أَجْرٌ':Subject, #1: 1	فَلَكَ أَجْرٌ
u'فَلَكَ أخْذٌ':Subject, #2: 2	فَلَكَ أَجْرُ
u'فَلَكَ أخْذٌ':Subject, #1: 1	فَلَكَ أَخْذُ
u'فَلَكَ أَرْبَعَةٌ':Subject, #1: 1	فَلَكَ أَخْذُهُ
u'فَلَكَ ألْفٌ':Subject, #1: 1	فَلَكَ أَرْبَعَةُ
u'فَلَكَ أَلْفٌ':Subject, #14: 14	فَلَكَ أَلْفٌ
u'فَلَكَ ألف':Subject, #14: 14	فَلَكَ أَلْفٌ
u'فَلَكَ ألْفٌ':Subject, #1: 1	فَلَكَ الْأَلْفُ
u'فَلَكَ أَلْفٌ':Subject, #1: 1	فَلَكَ الْأَلْفُ
u'فَلَكَ بَعْضٌ':Subject, #1: 1	فَلَكَ الْأَلْفُ
u'فَلَكَ بَعيرٌ':Subject, #1: 1	فَلَكَ بَعْضُ
u'فَلَكَ بَيِّنَةٌ':Subject, #1: 1	فَلَكَ الْبَعِيرُ
u'فَلْكَةٌ مِغْزَلٌ':Added, #1: 1	فَلَكَ بَيِّنَةٌ
u'فَلَكَ ثَلاثَةٌ':Subject, #2: 2	فَلْكَةِ مِغْزَلٍ
u'فَلَكَ حَسَنٌ':Subject, #1: 1	فَلَكَ ثَلَاثَةُ
u'فَلَكَ حَسَنَةٌ':Subject, #1: 1	فَلَكَ حَسَنَةٌ
u'فَلَكَ حَمْدٌ':Subject, #1: 1	فَلَكَ حَسَنَةٌ
u'فَلَكَ خُصُومَةٌ':Subject, #4: 4	فَلَكَ الْحَمْدُ
u'فَلَكَ خيار':Subject, #1: 1	فَلَكَ الْخُصُومَةُ
u'فَلَكَ خِيَارٌ':Subject, #1: 1	فَلَكَ الْخِيَارُ
u'فَلَكَ دِرْهَمٌ':Subject, #1: 1	فَلَكَ الْخِيَارُ
u'فَلَكَ دِرْهَم':Subject, #1: 1	فَلَكَ دِرْهَمُ
u'فَلَكَ دِرْهَمٌ':Subject, #1: 1	فَلَكَ دِرْهَمُ
u'فَلَكَ دِرْهَم':Subject, #22: 22	فَلَكَ دِرْهَمٌ
u'فَلَكَ دِينارٌ':Subject, #22: 22	فَلَكَ دِرْهَمٌ
u'فَلَكَ رُبْعٌ':Subject, #4: 4	فَلَكَ دِينَارٌ
u'فَلَكَ رُجُوعٌ':Subject, #1: 1	فَلَكَ الرُّبْعُ
u'فَلَكَ زِيادَةٌ':Subject, #1: 1	فَلَكَ الرُّجُوعُ
u'فَلَكَ سَلَبٌ':Subject, #1: 1	فَلَكَ زِيَادَةُ
u'فَلَكَ شِرَاءٌ':Subject, #5: 5	فَلَكَ سَلَبُهُ
u'فَلَكَ طلب':Subject, #1: 1	فَلَكَ شِرَاءُ
u'فَلَكَ طَلَبٌ':Subject, #1: 1	فَلَكَ طَلَبُ
u'فَلَكَ عَشْرٌ':Subject, #1: 1	فَلَكَ طَلَبُ
u'فَلَكَ عَمَلٌ':Subject, #1: 1	فَلَكَ عَشْرَةُ
u'فَلَكَ فَضْلٌ':Subject, #1: 1	فَلَكَ عَمَلُهُ
u'فَلَكَ قتل':Subject, #1: 1	فَلَكَ الْفَضْلُ
u'فَلَكَ قَتْلٌ':Subject, #1: 1	فَلَكَ قَتْلُهُ
u'فَلَكَ مَالٌ':Subject, #1: 1	فَلَكَ قَتْلُهُ
u'فَلَكَ مَنْعٌ':Subject, #1: 1	فَلَكَ مَالُهُ
u'فَلَكَ نِصْفٌ':Subject, #1: 1	فَلَكَ مَنْعُهُ
u'فَلَكَ نِصْفٌ':Subject, #10: 10	فَلَكَ نِصْفُ
u'فَلَكَ نِصْفٌ':Subject, #20: 20	فَلَكَ نِصْفُهُ
u'فَلَكَ نَقْضٌ':Subject, #4: 4	فَلَكَ النِّصْفُ
u'فَلَكَ وَجْهٌ':Subject, #1: 1	فَلَكَ نَقْضُ
u'فَلَكَ يَمِينٌ':Subject, #2: 2	فَلَكَ وَجْهُ
u'فَلِيَ رجعة':Subject, #7: 7	فَلَكَ يَمِينُهُ
u'فَلِيَ رَجْعَةٌ':Subject, #1: 1	فَلِيَ الرَّجْعَةُ
u'فَلِيَ رَدٌّ':Subject, #1: 1	فَلِيَ الرَّجْعَةُ
u'فَلِيَ شفعة':Subject, #1: 1	فَلِيَ الرَّدُّ
u'فَلِيَ شُفْعَةٌ':Subject, #1: 1	فَلِيَ الشُّفْعَةُ
u'فَلِيَ مَهْرٌ':Subject, #1: 1	فَلِيَ الشُّفْعَةُ
u'فَلِيَ نَارٌ':Subject, #1: 1	فَلِيَ الْمَهْرُ
u'فَلِيَ نِصْفٌ':Subject, #1: 1	فَلِيَ النَّارُ
u'فَنَاءٌ أَدْهانٌ':Added, #1: 1	فَلِيَ النِّصْفُ
u'فَنَاءٌ أُمَّةٌ':Added, #1: 1	فَنَاءِ الْأَدْهَانِ
u'فَنَاءٌ أهْلٌ':Added, #2: 2	فَنَاءِ الْأُمَّةِ
u'فَنَاءٌ بَلَّةٌ':Added, #1: 1	فَنَاءُ الأَهْلِ
u'فَنَاءٌ خلق':Added, #1: 1	فَنَاءِ الْبَلَّةِ
u'فَنَاءٌ خَلْقٌ':Added, #2: 2	فَنَاءِ الْخَلْقِ
u'فَنَاءٌ صِرْفٌ':Added, #2: 2	فَنَاءِ الْخَلْقِ
u'فَنَاءٌ صِرْفٌ':Added, #1: 1	فَنَاءٍ صِرْفٍ
u'فَنَاءٌ نَفْسٌ':Added, #1: 1	فَنَاءَ صِرْفٍ
u'فَنِيَ دَقيقٌ':Subject, #1: 1	فَنَاءُ النَّفْسِ
u'فَنِيَ زادٌ':Subject, #1: 1	فَنِيَ دَقِيقُهُ
u'فَنِيَ مَاءٌ':Subject, #1: 1	فَنِيَ زَادُهُ
u'فَنِيَ مَالٌ':Subject, #1: 1	فَنِيَ مَاءُ
u'فَهِمَ اِبْنٌ':Subject, #1: 1	فَنِيَ الْمَالُ
u'فَهْمٌ أحَدٌ':Added, #1: 1	فَهِمَ ابْنُ
u'فَهِمَ آدَمِيٌّ':Predicate, #1: 1	فَهْمِ أَحَدِ
u'فَهْمٌ إشارَة':Added, #1: 1	أَفْهَمَ الْآدَمِيِّينَ
u'فَهْمٌ إشارَة':Added, #1: 1	فَهْمِ إشَارَتِهِ
u'فَهْمٌ أصل':Added, #1: 1	فَهْمِ الْإِشَارَةِ
u'فَهْمٌ أًصْلٌ':Added, #1: 1	فَهْمِ أَصْلِ
u'فَهِمَ أَكْثَرُ':Subject, #1: 1	فَهْمِ أَصْلِ
u'فَهْمٌ أَكْثَرُ':Added, #1: 1	فَهِمَ أَكْثَرُ
u'فَهِمَ إمَامٌ':Subject, #1: 1	فَهْمِ أَكْثَرِهِ
u'فَهْمٌ أُمَّةٌ':Added, #1: 1	فَهِمَ الْإِمَامُ
u'فَهِمَ اِنْتِهاءٌ':Predicate, #1: 1	فَهْمَ الْأُمَّةِ
u'فَهْمٌ أهْلٌ':Added, #1: 1	فَهِمَ انْتِهَاءَ
u'فَهِمَ آيَةٌ':Predicate, #2: 2	فَهْمُ أَهْلِ
u'فَهِمَ بُخَارِيٌّ':Subject, #1: 1	فَهِمَ الْآيَةَ
u'فَهْمٌ بَصيرٌ':Added, #1: 1	فَهِمَ الْبُخَارِيُّ
u'فَهِمَ بَعْضٌ':Subject, #1: 1	فَهْمِ الْبَصِيرِ
u'فَهِمَ بَعْضٌ':Subject, #1: 1	فَهِمَ بَعْضٌ
u'فَهْمٌ بَعْضٌ':Added, #2: 2	فَهِمَ بَعْضُ
u'فَهْمٌ بَقاءٌ':Added, #1: 1	فَهْمِ بَعْضِ
u'فَهْمٌ بَلاغَةٌ':Added, #1: 1	فَهْمُ الْبَقَاءِ
u'فَهْمٌ تَخْصِيصٌ':Added, #1: 1	فَهْمِ الْبَلَاغَةِ
u'فَهْمٌ تَعَدُّدٌ':Added, #1: 1	فَهْمُ تَخْصِيصِ
u'فَهْمٌ تَعْرِيضٌ':Added, #1: 1	فَهْمِ تَعَدُّدِهِ
u'فَهْمٌ تَعْلِيلٌ':Added, #1: 1	فَهْمُ التَّعْرِيضِ
u'فَهْمٌ تَعْلِيلٌ':Added, #2: 2	فَهْمَ التَّعْلِيلِ
u'فَهْمٌ تَوَاجُدٌ':Added, #2: 2	فَهْمِ التَّعْلِيلِ
u'فَهْمٌ ثُبُوتٌ':Added, #1: 1	فَهْمِ التَّوَاجُدِ
u'فَهْمٌ جَابِرٌ':Added, #1: 1	فَهْمِ ثُبُوتِهِ
u'فَهَّمَ جَانِبٌ':Predicate, #1: 1	فَهْمُ جَابِرٍ
u'فَهْمٌ جُزْءٌ':Added, #1: 1	فَهَّمَ الْجَانِبَ
u'فَهْمٌ جُزْءٌ':Added, #1: 1	فَهْمَ الْجُزْءِ
u'فَهْمٌ جِنْسٌ':Added, #1: 1	فَهْمُ الْجُزْءِ
u'فَهْمٌ حاجَةٌ':Added, #1: 1	فَهْمِ الْجِنْسِ
u'فَهْمٌ حالٌ':Added, #1: 1	فَهْمِ الْحَاجَةِ
u'فَهْمٌ حَديثٌ':Added, #1: 1	فَهْمُ الْحَالِ
u'فَهِمَ حَصْرٌ':Predicate, #1: 1	فَهْمِ الْحَدِيثِ
u'فَهِمَ حُكْمٌ':Predicate, #2: 2	فَهِمَ الْحَصْرَ
u'فَهْمٌ حُكْمٌ':Added, #1: 1	فَهِمَ الْحُكْمَ
u'فَهْمٌ حُكْمٌ':Added, #1: 1	فَهْمُ الْحُكْمِ
u'فَهِمَ حكمة':Predicate, #2: 2	فَهْمِ الْحُكْمِ
u'فَهِمَ حِكْمَةٌ':Predicate, #1: 1	فَهِمَ الْحِكْمَةَ
u'فَهْمٌ خَصْمٌ':Added, #1: 1	فَهِمَ الْحِكْمَةَ
u'فَهِمَ خِطَابٌ':Predicate, #1: 1	فَهْمِ خَصْمِهِ
u'فَهْمٌ خِطَابٌ':Added, #1: 1	فَهِمَ الْخِطَابَ
u'فَهْمٌ خِطَابٌ':Added, #1: 1	فَهْمُ الْخِطَابِ
u'فَهْمٌ خِطَابٌ':Added, #1: 1	فَهْمِ خِطَابِ
u'فَهْمٌ خِطَابٌ':Added, #3: 3	فَهْمَ الْخِطَابِ
u'فَهْمٌ خطبة':Added, #6: 6	فَهْمِ الْخِطَابِ
u'فَهْمٌ خُطْبَةٌ':Added, #1: 1	فَهْمِ الْخُطْبَةِ
u'فَهْمٌ دَلالَةٌ':Added, #1: 1	فَهْمِ الْخُطْبَةِ
u'فَهْمٌ دِينٌ':Added, #1: 1	فَهْمَ دَلَالَةِ
u'فَهْمٌ دَيْنٌ':Added, #1: 1	فَهْمَ دِينِ
u'فَهْمٌ ذاتِيٌّ':Added, #2: 2	فَهْمِ دَيْنِ
u'فَهْمٌ ذاتِيٌّ':Added, #1: 1	فَهْمُ الذَّاتِيِّ
u'فَهِمَ رَسُولٌ':Subject, #1: 1	فَهْمُ ذَاتِيَّاتِهِ
u'فَهْمٌ رَسُولٌ':Added, #1: 1	فَهِمَ رَسُولُ
u'فَهِمَ رَمْيٌ':Predicate, #1: 1	فَهْمُ رَسُولِ
u'فَهْمٌ رُؤْيَةٌ':Added, #1: 1	أَفْهَمَ الرَّمْيَ
u'فَهْمٌ سَامِعٌ':Added, #1: 1	فَهْمَ الرّؤْيَةِ
u'فَهْمٌ سَامِعٌ':Added, #1: 1	فَهْمُ السَّامِعِ
u'فَهْمٌ سَامِعٌ':Added, #1: 1	فَهْمِ سَامِعِهِ
u'فَهْمٌ سَبَبٌ':Added, #8: 8	فَهْمِ السَّامِعِ
u'فَهِمَ سَلَفٌ':Subject, #1: 1	فَهْمِ السَّبَبِ
u'فَهْمٌ سُنَّةٌ':Added, #1: 1	فَهِمَ السَّلَفُ
u'فَهْمٌ سنن':Added, #1: 1	فَهْمَ سُنَّةِ
u'فَهْمٌ سِياقٌ':Added, #5: 5	فَهْمِ السُّنَنِ
u'فَهْمٌ شَاهِدٌ':Added, #1: 1	فَهْمِ سِيَاقِ
u'فَهْمٌ شَاهِدٌ':Added, #1: 1	فَهْمُ الشَّاهِدَيْنِ
u'فَهِمَ شَرِيعَةٌ':Predicate, #2: 2	فَهْمِ الشَّاهِدَيْنِ
u'فَهْمٌ شَرِيعَةٌ':Added, #1: 1	فَهِمَ الشَّرِيعَةَ
u'فَهْمٌ شُهُودٌ':Added, #1: 1	فَهْمِ الشَّرِيعَةِ
u'فَهِمَ شَيْءٌ':Predicate, #1: 1	فَهْمُ الشُّهُودِ
u'فَهْمٌ شَيْءٌ':Added, #1: 1	فَهِمَ الشَّيْءَ
u'فَهِمَ صَاحِبٌ':Subject, #2: 2	فَهْمِ شَيْءٍ
u'فَهْمٌ صَاحِبٌ':Added, #3: 3	فَهِمَ صَاحِبُ
u'فَهْمٌ صِحَّةٌ':Added, #1: 1	فَهْمُ صَاحِبِ
u'فَهْمٌ صُوفِيٌّ':Added, #1: 1	فَهْمِ الصِّحَّةِ
u'فَهْمٌ صُوفِيَّةٌ':Added, #1: 1	فَهْمُ الصُّوفِيَّةِ
u'فَهْمٌ طَالِبٌ':Added, #1: 1	فَهْمُ الصُّوفِيَّةِ
u'فَهْمٌ طَبَرِيّ':Added, #1: 1	فَهْمِ الطَّالِبِ
u'فَهْمٌ ظاهِرٌ':Added, #1: 1	فَهْمَ الطَّبَرِيِّ
u'فَهْمٌ عَامِّيٌّ':Added, #1: 1	فَهْمِ ظَاهِرِ
u'فَهْمٌ عِبَارَةٌ':Added, #1: 1	فَهْمُ الْعَامِّيِّ
u'فَهْمٌ عِبَارَةٌ':Added, #1: 1	فَهْمِ الْعِبَارَةِ
u'فَهْمٌ عِبَارَةٌ':Added, #1: 1	فَهْمِ عِبَارَاتِهِ
u'فَهْمٌ عِبَارَةٌ':Added, #1: 1	فَهْمُ عِبَارَةِ
u'فَهْمٌ عِبَارَةٌ':Added, #1: 1	فَهْمِ عِبَارَةِ
u'فَهْمٌ عِلَّةٌ':Added, #1: 1	فَهْمِ عِبَارَتِهِ
u'فَهْمٌ علماء':Added, #1: 1	فَهْمُ الْعِلَّةِ
u'فَهْمٌ عُلَمَاءُ':Added, #1: 1	فَهْمِ الْعُلَمَاءِ
u'فَهْمٌ علماء':Added, #1: 1	فَهْمِ الْعُلَمَاءِ
u'فَهْمٌ عُلَمَاءُ':Added, #2: 2	فَهْمُ الْعُلَمَاءِ
u'فَهِمَ عُمَرٌ':Subject, #2: 2	فَهْمُ الْعُلَمَاءِ
u'فَهْمٌ عُمُومٌ':Added, #1: 1	فَهِمَ عُمَرُ
u'فَهْمٌ عُمُومٌ':Added, #1: 1	فَهْمِ الْعُمُومِ
u'فَهِمَ عند':Predicate, #1: 1	فَهْمُ عُمُومِ
u'فَهْمٌ غير':Added, #1: 1	أَفْهَمَ عِنْدَ
u'فَهْمٌ غَيْرٌ':Added, #1: 1	فَهْمِ غَيْرِ
u'فَهْمٌ غير':Added, #1: 1	فَهْمِ غَيْرِ
u'فَهْمٌ غَيْرٌ':Added, #1: 1	فَهْمُ غَيْرِهِ
u'فَهْمٌ فرق':Added, #1: 1	فَهْمُ غَيْرِهِ
u'فَهْمٌ فَرْقٌ':Added, #2: 2	فَهْمِ الْفَرْقِ
u'فَهِمَ فَصْلٌ':Predicate, #2: 2	فَهْمِ الْفَرْقِ
u'فَهِمَ فِقْهٌ':Predicate, #1: 1	فَهِمَ الْفَصْلَ
u'فَهْمٌ فلان':Added, #1: 1	فَهِمَ الْفِقْهَ
u'فَهْمٌ قُرْآنٌ':Added, #1: 1	فَهْمَ الطَّبَرِيِّ
u'فَهْمٌ قُرْآنٌ':Added, #2: 2	فَهْمَ الْقُرْآنِ
u'فَهْمٌ قُلُوبٌ':Added, #2: 2	فَهْمِ الْقُرْآنِ
u'فَهْمٌ قَوَاعِدُ':Added, #1: 1	فَهْمُ الْقُلُوبِ
u'فَهْمٌ قول':Added, #1: 1	فَهْمِ قَوَاعِدِ
u'فَهْمٌ قول':Added, #1: 1	فَهْمُ قَوْلِهِ
u'فَهْمٌ قَوْلٌ':Added, #1: 1	فَهْمِ قَوْلِهِ
u'فَهْمٌ قَوْلٌ':Added, #1: 1	فَهْمُ قَوْلِهِ
u'فَهْمٌ قول':Added, #1: 1	فَهْمِ قَوْلِهِ
u'فَهْمٌ قَوْلٌ':Added, #3: 3	فَهْمِ قَوْلِ
u'فَهِمَ قَوْمٌ':Subject, #3: 3	فَهْمِ قَوْلِ
u'فَهِمَ كَافِرٌ':Subject, #2: 2	فَهِمَ قَوْمٌ
u'فَهْمٌ كِتَابٌ':Added, #1: 1	فَهِمَ الْكَافِرُ
u'فَهْمٌ كِتَابٌ':Added, #1: 1	فَهْمُ الْكِتَابِ
u'فَهْمٌ كِتَابٌ':Added, #1: 1	فَهْمِ الْكِتَابِ
u'فَهِمَ كَلاَمٌ':Predicate, #1: 1	فَهْمِ كِتَابِهِ
u'فَهِمَ كَلاَمٌ':Predicate, #1: 1	فَهِمَ الْكَلَامَ
u'فَهْمٌ كَلاَمٌ':Added, #2: 2	فَهِمَ كَلَامَ
u'فَهْمٌ كَلاَمٌ':Added, #11: 11	فَهْمِ كَلَامِ
u'فَهْمٌ كَلاَمٌ':Added, #1: 1	فَهْمِ الْكَلَامِ
u'فَهْمٌ كَلاَمٌ':Added, #2: 2	فَهْمُ الْكَلَامِ
u'فَهْمٌ كَوْنٌ':Added, #2: 2	فَهْمُ كَلَامِ
u'فَهْمٌ لاَزِمٌ':Added, #1: 1	فَهْمِ كَوْنِهِ
u'فَهْمٌ لُغَةٌ':Added, #1: 1	فَهْمَ اللَّازِمِ
u'فَهْمٌ لَفْظٌ':Added, #7: 7	فَهْمِ اللُّغَةِ
u'فَهِمَ مُتَرْجِمٌ':Subject, #1: 1	فَهْمِ اللَّفْظِ
u'فَهْمٌ مُتَعَلِّمٌ':Added, #1: 1	فَهِمَ الْمُتَرْجِمُ
u'فَهْمٌ مُتَعَلِّمٌ':Added, #1: 1	فَهْمُ الْمُتَعَلِّمِ
u'فَهْمٌ مُتَكَلِّمٌ':Added, #2: 2	فَهْمِ الْمُتَعَلِّمِ
u'فَهْمٌ مَجَازٌ':Added, #1: 1	فَهْمِ الْمُتَكَلِّمِ
u'فَهِمَ مُخَاطَبٌ':Subject, #1: 1	فَهْمِ الْمَجَازِ
u'فَهْمٌ مُخَاطَبٌ':Added, #1: 1	فَهِمَ الْمُخَاطَبُ
u'فَهِمَ مُخَالَفَةٌ':Predicate, #1: 1	فَهْمِ الْمُخَاطَبِ
u'فَهِمَ مُخَالَفَةٌ':Predicate, #1: 1	فَهِمَ الْمُخَالَفَةَ
u'فَهْمٌ مراد':Added, #1: 1	فَهِمَ مُخَالَفَةَ
u'فَهْمٌ مُرَادٌ':Added, #1: 1	فَهْمَ الْمُرَادِ
u'فَهْمٌ مراد':Added, #1: 1	فَهْمَ الْمُرَادِ
u'فَهْمٌ مُرَادٌ':Added, #1: 1	فَهْمِ مُرَادِ
u'فَهْمٌ مراد':Added, #1: 1	فَهْمِ مُرَادِ
u'فَهْمٌ مُرَادٌ':Added, #3: 3	فَهْمِ الْمُرَادِ
u'فَهِمَ مَسْأَلَةٌ':Predicate, #3: 3	فَهْمِ الْمُرَادِ
u'فَهْمٌ مَسْأَلَةٌ':Added, #1: 1	فَهِمَ الْمَسْأَلَةَ
u'فَهْمٌ مَسَائِلُ':Added, #2: 2	فَهْمِ الْمَسْأَلَةِ
u'فَهِمَ مُصَنِّفٌ':Subject, #1: 1	فَهْمَ الْمَسَائِلِ
u'فَهْمٌ مُصَنِّفٌ':Added, #3: 3	فَهِمَ الْمُصَنِّفُ
u'فَهْمٌ مُضْمَرٌ':Added, #1: 1	فَهْمِ الْمُصَنِّفِ
u'فَهِمَ مَعَانِي':Predicate, #1: 1	فَهْمِ الْمُضْمَرِ
u'فَهْمٌ مَعَانِي':Added, #1: 1	فَهِمَ الْمَعَانِيَ
u'فَهْمٌ مَعَانِي':Added, #1: 1	فَهْمِ مَعَانِيهِ
u'فَهْمٌ مَفْهُومٌ':Added, #2: 2	فَهْمُ مَعَانِيهِ
u'فَهْمٌ مَفْهُومٌ':Added, #1: 1	فَهْمُ مَفْهُومِ
u'فَهْمٌ مَقَاصِدُ':Added, #2: 2	فَهْمَ الْمَفْهُومِ
u'فَهْمٌ مُقَدِّمٌ':Added, #1: 1	فَهْمِ الْمَقَاصِدِ
u'فَهْمٌ مُقَدِّمَةٌ':Added, #1: 1	فَهْمُ الْمُقَدِّمَةِ
u'فَهِمَ مَقْرُوءٌ':Predicate, #1: 1	فَهْمُ الْمُقَدِّمَةِ
u'فَهِمَ مَقْصُودٌ':Predicate, #1: 1	فَهِمَ الْمَقْرُوءَ
u'فَهْمٌ مَقْصُودٌ':Added, #1: 1	فَهِمَ الْمَقْصُودَ
u'فَهْمٌ مَقْصُودٌ':Added, #1: 1	فَهْمَ الْمَقْصُودِ
u'فَهْمٌ مَنَاطٌ':Added, #5: 5	فَهْمِ الْمَقْصُودِ
u'فَهْمٌ نَاسٌ':Added, #1: 1	فَهْمِ الْمَنَاطِ
u'فَهْمٌ نذر':Added, #1: 1	فَهْمُ النَّاسِ
u'فَهْمٌ نَذْرٌ':Added, #1: 1	فَهْمَ النَّذْرِ
u'فَهْمٌ نِسْبَةٌ':Added, #1: 1	فَهْمَ النَّذْرِ
u'فَهْمٌ وَجْهٌ':Added, #1: 1	فَهْمِ النِّسْبَةِ
u'فَوَاتٌ أَدَاءٌ':Added, #1: 1	فَهْمِ وَجْهِ
u'فَوَاتٌ أَدَاءٌ':Added, #1: 1	فَوَاتُ أَدَاءِ
u'فَوَاتٌ أُصْبُعٌ':Added, #1: 1	فَوَاتَ الْأَدَاءِ
u'فَوَاتٌ أُصْبُعٌ':Added, #1: 1	فَوَاتِ الْأُصْبُعِ
u'فَوَاتٌ أَصْحَابٌ':Added, #1: 1	فَوَاتِ الْأُصْبُعَيْنِ
u'فَوَاتٌ أًصْلٌ':Added, #3: 3	فَوَاتَ أَصْحَابِهِ
u'فَوَاتٌ أصل':Added, #1: 1	فَوَاتَ أَصْلٍ
u'فَوَاتٌ أًصْلٌ':Added, #2: 2	فَوَاتَ الْأَصْلِ
u'فَوَاتٌ أصل':Added, #2: 2	فَوَاتَ الْأَصْلِ
u'فَوَاتٌ أصل':Added, #3: 3	فَوَاتُ الْأَصْلِ
u'فَوَاتٌ أًصْلٌ':Added, #3: 3	فَوَاتِ الْأَصْلِ
u'فَوَاتٌ أًصْلٌ':Added, #3: 3	فَوَاتُ الْأَصْلِ
u'فَوَاتٌ أَمْرٌ':Added, #3: 3	فَوَاتِ الْأَصْلِ
u'فَوَاتٌ أَهْلِيٌّ':Added, #2: 2	فَوَاتَ أَمْرٍ
u'فَوَاتٌ أهْلِيَّةٌ':Added, #1: 1	فَوَاتُ أَهْلِيَّتِهِ
u'فَوَاتٌ أَوَّلُ':Added, #1: 1	فَوَاتُ أَهْلِيَّتِهِ
u'فَوَاتٌ أَوَّلُ':Added, #1: 1	فَوَاتِ أَوَّلِهِ
u'فَوَاتٌ أيَّامٌ':Added, #3: 3	فَوَاتُ أَوَّلِ
u'فَوَاتٌ أَيَّامٌ':Added, #2: 2	فَوَاتَ أَيَّامِ
u'فَوَاتٌ بَدَلٌ':Added, #2: 2	فَوَاتَ أَيَّامِ
u'فَوَاتٌ بَرٌّ':Added, #1: 1	فَوَاتِ الْبَدَلِ
u'فَوَاتٌ بِرٌّ':Added, #1: 1	فَوَاتِ الْبَرِّ
u'فَوَاتٌ بِرٌّ':Added, #1: 1	فَوَاتِ الْبِرِّ
u'فَوَاتٌ بَصَرٌ':Added, #2: 2	فَوَاتُ الْبِرِّ
u'فَوَاتٌ بَعْضٌ':Added, #1: 1	فَوَاتِ الْبَصَرِ
u'فَوَاتٌ بَعْضٌ':Added, #1: 1	فَوَاتَ بَعْضِهِ
u'فَوَاتٌ بَعْضٌ':Added, #2: 2	فَوَاتُ بَعْضِ
u'فَوَاتٌ بَيْتٌ':Added, #5: 5	فَوَاتِ بَعْضِ
u'فَوَاتٌ تَبَع':Added, #1: 1	فَوَاتِ الْبَيْتِ
u'فَوَاتٌ تَحِيَّةٌ':Added, #2: 2	فَوَاتُ التَّبَعِ
u'فَوَاتٌ تَسْلِيمٌ':Added, #3: 3	فَوَاتِ التَّحِيَّةِ
u'فَوَاتٌ تَسْلِيمٌ':Added, #1: 1	فَوَاتَ التَّسْلِيمِ
u'فَوَاتٌ تَصْدِيقٌ':Added, #1: 1	فَوَاتِ تَسْلِيمِ
u'فَوَاتٌ ثَانِي':Added, #1: 1	فَوَاتِ التَّصْدِيقِ
u'فَوَاتٌ ثَانِيَةٌ':Added, #1: 1	فَوَاتَ الثَّانِيَةِ
u'فَوَاتٌ ثَمَنٌ':Added, #1: 1	فَوَاتَ الثَّانِيَةِ
u'فَوَاتٌ ثَوابٌ':Added, #1: 1	فَوَاتَ الثَّمَنِ
u'فَوَاتٌ ثَوابٌ':Added, #1: 1	فَوَاتُ ثَوَابٍ
u'فَوَاتٌ ثَوابٌ':Added, #1: 1	فَوَاتِ ثَوَابِهِ
u'فَوَاتٌ جُزْءٌ':Added, #2: 2	فَوَاتِ الثَّوَابِ
u'فَوَاتٌ جُزْءٌ':Added, #1: 1	فَوَاتُ الْجُزْءِ
u'فَوَاتٌ جُزْءٌ':Added, #2: 2	فَوَاتَ جُزْءٍ
u'فَوَاتٌ جَزْم':Added, #2: 2	فَوَاتُ جُزْءٍ
u'فَوَاتٌ جِسْمٌ':Added, #1: 1	فَوَاتِ الْجَزْمِ
u'فَوَاتٌ جَمَاعَةٌ':Added, #3: 3	فَوَاتَ الْجِسْمِ
u'فَوَاتٌ جَمَاعَةٌ':Added, #1: 1	فَوَاتُ الْجَمَاعَةِ
u'فَوَاتٌ جَمَاعَةٌ':Added, #1: 1	فَوَاتِ الْجَمَاعَةِ
u'فَوَاتٌ جمعة':Added, #6: 6	فَوَاتَ الْجَمَاعَةِ
u'فَوَاتٌ جُمُعَةٌ':Added, #11: 11	فَوَاتِ الْجُمُعَةِ
u'فَوَاتٌ جمعة':Added, #11: 11	فَوَاتِ الْجُمُعَةِ
u'فَوَاتٌ جُمُعَةٌ':Added, #1: 1	فَوَاتُ الْجُمُعَةِ
u'فَوَاتٌ جمعة':Added, #1: 1	فَوَاتُ الْجُمُعَةِ
u'فَوَاتٌ جُمُعَةٌ':Added, #4: 4	فَوَاتَ الْجُمُعَةِ
u'فَوَاتٌ جِنْسٌ':Added, #4: 4	فَوَاتَ الْجُمُعَةِ
u'فَوَاتٌ جَوَازٌ':Added, #2: 2	فَوَاتَ جِنْسِ
u'فَوَاتٌ جَوْدَةٌ':Added, #1: 1	فَوَاتِ جَوَازِ
u'فَوَاتٌ حادِثٌ':Added, #1: 1	فَوَاتِ الْجَوْدَةِ
u'فَوَاتٌ حاضِرٌ':Added, #1: 1	فَوَاتَ الْحَادِثَةِ
u'فَوَاتٌ حاضِرٌ':Added, #1: 1	فَوَاتِ الْحَاضِرَةِ
u'فَوَاتٌ حَجٌّ':Added, #2: 2	فَوَاتَ الْحَاضِرَةِ
u'فَوَاتٌ حَجٌّ':Added, #11: 11	فَوَاتَ الْحَجِّ
u'فَوَاتٌ حَجٌّ':Added, #13: 13	فَوَاتِ الْحَجِّ
u'فَوَاتٌ حَجٌّ':Added, #1: 1	فَوَاتِ حَجٍّ
u'فَوَاتٌ حَقٌّ':Added, #2: 2	فَوَاتُ الْحَجِّ
u'فَوَاتٌ حَقٌّ':Added, #1: 1	فَوَاتِ حَقٍّ
u'فَوَاتٌ حَقٌّ':Added, #1: 1	فَوَاتُ حَقِّهِ
u'فَوَاتٌ حَقٌّ':Added, #2: 2	فَوَاتِ الْحَقِّ
u'فَوَاتٌ حَقٌّ':Added, #2: 2	فَوَاتُ حَقِّ
u'فَوَاتٌ حَقٌّ':Added, #2: 2	فَوَاتِ حَقِّ
u'فَوَاتٌ حُكْمٌ':Added, #2: 2	فَوَاتَ حَقِّهِ
u'فَوَاتٌ حُكْمٌ':Added, #1: 1	فَوَاتَ حُكْمِ
u'فَوَاتٌ حَوائِجُ':Added, #1: 1	فَوَاتُ حُكْمِهِ
u'فَوَاتٌ حَيَاةٌ':Added, #1: 1	فَوَاتِ الْحَوَائِجِ
u'فَوَاتٌ خُشُوعٌ':Added, #1: 1	فَوَاتِ الْحَيَاةِ
u'فَوَاتٌ دُخُولٌ':Added, #1: 1	فَوَاتَ خُشُوعٍ
u'فَوَاتٌ رَاتِبٌ':Added, #1: 1	فَوَاتُ الدُّخُولِ
u'فَوَاتٌ رَاتِب':Added, #1: 1	فَوَاتَ رَاتِبِهِ
u'فَوَاتٌ رَأْيٌ':Added, #1: 1	فَوَاتَ رَاتِبِهِ
u'فَوَاتٌ رِبْحٌ':Added, #1: 1	فَوَاتُ رَأْيِهِ
u'فَوَاتٌ رجعة':Added, #1: 1	فَوَاتُ رِبْحٍ
u'فَوَاتٌ رَجْعَةٌ':Added, #1: 1	فَوَاتُ الرَّجْعَةِ
u'فَوَاتٌ رفقة':Added, #1: 1	فَوَاتُ الرَّجْعَةِ
u'فَوَاتٌ رفقة':Added, #1: 1	فَوَاتُ الرُّفْقَةِ
u'فَوَاتٌ رُفْقَةٌ':Added, #1: 1	فَوَاتِ الرُّفْقَةِ
u'فَوَاتٌ رُفْقَةٌ':Added, #1: 1	فَوَاتُ الرُّفْقَةِ
u'فَوَاتٌ رفقة':Added, #1: 1	فَوَاتِ الرُّفْقَةِ
u'فَوَاتٌ رُفْقَةٌ':Added, #1: 1	فَوَاتَ رُفْقَةٍ
u'فَوَاتٌ رفقة':Added, #1: 1	فَوَاتَ رُفْقَةٍ
u'فَوَاتٌ رُفْقَةٌ':Added, #1: 1	فَوَاتِ رُفْقَتِهِ
u'فَوَاتٌ رفقة':Added, #1: 1	فَوَاتِ رُفْقَتِهِ
u'فَوَاتٌ رُفْقَةٌ':Added, #2: 2	فَوَاتِ رُفْقَةٍ
u'فَوَاتٌ ركعة':Added, #2: 2	فَوَاتِ رُفْقَةٍ
u'فَوَاتٌ ركعة':Added, #1: 1	فَوَاتَ الرَّكْعَةِ
u'فَوَاتٌ رَكْعَةٌ':Added, #1: 1	فَوَاتُ الرَّكْعَةِ
u'فَوَاتٌ رَكْعَةٌ':Added, #1: 1	فَوَاتَ الرَّكْعَةِ
u'فَوَاتٌ ركعة':Added, #1: 1	فَوَاتُ الرَّكْعَةِ
u'فَوَاتٌ رَكْعَةٌ':Added, #8: 8	فَوَاتَ رَكْعَةٍ
u'فَوَاتٌ رُكْنٌ':Added, #8: 8	فَوَاتَ رَكْعَةٍ
u'فَوَاتٌ رُكْنٌ':Added, #1: 1	فَوَاتُ رُكْنِهِ
u'فَوَاتٌ رُكْن':Added, #1: 1	فَوَاتِ رُكْنِهِ
u'فَوَاتٌ رُكْن':Added, #1: 1	فَوَاتُ رُكْنِهِ
u'فَوَاتٌ رُكوعٌ':Added, #1: 1	فَوَاتِ رُكْنِهِ
u'فَوَاتٌ روحٌ':Added, #1: 1	فَوَاتِ الرُّكُوعِ
u'فَوَاتٌ زائِدٌ':Added, #1: 1	فَوَاتَ رُوحِهِ
u'فَوَاتٌ زَرْعٌ':Added, #1: 1	فَوَاتِ الزَّائِدِ
u'فَوَاتٌ زَوْجٌ':Added, #1: 1	فَوَاتِ الزَّرْعِ
u'فَوَاتٌ سِتٌّ':Added, #1: 1	فَوَاتِ زَوْجٍ
u'فَوَاتٌ سُفْلٌ':Added, #1: 1	فَوَاتِ السِّتِّ
u'فَوَاتٌ سَلاَمَةٌ':Added, #1: 1	فَوَاتِ السُّفْلِ
u'فَوَاتٌ سِلْعَةٌ':Added, #1: 1	فَوَاتِ سَلَامَةِ
u'فَوَاتٌ سَمْعٌ':Added, #3: 3	فَوَاتِ السِّلْعَةِ
u'فَوَاتٌ سِنٌّ':Added, #1: 1	فَوَاتُ السَّمْعِ
u'فَوَاتٌ سُنَّةٌ':Added, #1: 1	فَوَاتَ السِّنِّ
u'فَوَاتٌ سُوقٌ':Added, #1: 1	فَوَاتِ السُّنَّةِ
u'فَوَاتٌ شَرْطٌ':Added, #1: 1	فَوَاتِ السُّوقِ
u'فَوَاتٌ شَرْطٌ':Added, #1: 1	فَوَاتَ شَرْطِ
u'فَوَاتٌ شَرْطٌ':Added, #1: 1	فَوَاتُ شَرْطِ
u'فَوَاتٌ شَرْطٌ':Added, #3: 3	فَوَاتَ الشَّرْطِ
u'فَوَاتٌ شَرْطٌ':Added, #4: 4	فَوَاتِ الشَّرْطِ
u'فَوَاتٌ شَرْطٌ':Added, #4: 4	فَوَاتِ شَرْطٍ
u'فَوَاتٌ شعار':Added, #5: 5	فَوَاتِ شَرْطِ
u'فَوَاتٌ شِعَارٌ':Added, #1: 1	فَوَاتُ شِعَارٍ
u'فَوَاتٌ شَعْرٌ':Added, #1: 1	فَوَاتُ شِعَارٍ
u'فَوَاتٌ شَعْرٌ':Added, #1: 1	فَوَاتِ الشَّعْرِ
u'فَوَاتٌ شَيْءٌ':Added, #2: 2	فَوَاتُ الشَّعْرِ
u'فَوَاتٌ شَيْءٌ':Added, #1: 1	فَوَاتِ شَيْءٍ
u'فَوَاتٌ صُبْحٌ':Added, #3: 3	فَوَاتُ شَيْءٍ
u'فَوَاتٌ صِفَةٌ':Added, #1: 1	فَوَاتُ الصُّبْحِ
u'فَوَاتٌ صِفَةٌ':Added, #1: 1	فَوَاتُ الصِّفَةِ
u'فَوَاتٌ صِفَةٌ':Added, #1: 1	فَوَاتِ صِفَةٍ
u'فَوَاتٌ صَلاَةٌ':Added, #1: 1	فَوَاتِ صِفَةِ
u'فَوَاتٌ صَلاَةٌ':Added, #1: 1	فَوَاتُ الصَّلَاةِ
u'فَوَاتٌ صَلاَةٌ':Added, #1: 1	فَوَاتُ صَلَاةِ
u'فَوَاتٌ صَلاَةٌ':Added, #3: 3	فَوَاتَ الصَّلَاةِ
u'فَوَاتٌ صُورَةٌ':Added, #4: 4	فَوَاتِ الصَّلَاةِ
u'فَوَاتٌ صُورَةٌ':Added, #1: 1	فَوَاتَ الصُّورَةِ
u'فَوَاتٌ صَوْمٌ':Added, #2: 2	فَوَاتُ الصُّورَةِ
u'فَوَاتٌ طرف':Added, #2: 2	فَوَاتِ الصَّوْمِ
u'فَوَاتٌ طَرَفٌ':Added, #1: 1	فَوَاتَ الطَّرَفِ
u'فَوَاتٌ عَدَالَةٌ':Added, #1: 1	فَوَاتَ الطَّرَفِ
u'فَوَاتٌ عَدُوٌّ':Added, #1: 1	فَوَاتَ الْعَدَالَةِ
u'فَوَاتٌ عُضْوٌ':Added, #1: 1	فَوَاتَ عَدُوِّهِ
u'فَوَاتٌ عَقْلٌ':Added, #2: 2	فَوَاتَ الْعُضْوِ
u'فَوَاتٌ عَقْلٌ':Added, #1: 1	فَوَاتُ الْعَقْلِ
u'فَوَاتٌ عُلْوٌ':Added, #1: 1	فَوَاتِ عَقْلِهِ
u'فَوَاتٌ عُلُوٌّ':Added, #1: 1	فَوَاتِ الْعُلْوِ
u'فَوَاتٌ عِمَارَةٌ':Added, #2: 2	فَوَاتِ الْعُلُوِّ
u'فَوَاتٌ عمرة':Added, #1: 1	فَوَاتِ عِمَارَةِ
u'فَوَاتٌ عُمْرَةٌ':Added, #1: 1	فَوَاتِ الْعُمْرَةِ
u'فَوَاتٌ عين':Added, #1: 1	فَوَاتِ الْعُمْرَةِ
u'فَوَاتٌ عَيْنٌ':Added, #1: 1	فَوَاتِ عَيْنِ
u'فَوَاتٌ عَيْنٌ':Added, #1: 1	فَوَاتَ عَيْنٍ
u'فَوَاتٌ عَيْنٌ':Added, #1: 1	فَوَاتُ عَيْنٍ
u'فَوَاتٌ عَيْنٌ':Added, #1: 1	فَوَاتِ عَيْنٍ
u'فَوَاتٌ عَيْن':Added, #1: 1	فَوَاتِ عَيْنِ
u'فَوَاتٌ عَيْن':Added, #1: 1	فَوَاتَ عَيْنٍ
u'فَوَاتٌ عَيْن':Added, #1: 1	فَوَاتُ عَيْنٍ
u'فَوَاتٌ عَيْن':Added, #1: 1	فَوَاتِ عَيْنٍ
u'فَوَاتٌ عين':Added, #1: 1	فَوَاتِ عَيْنِ
u'فَوَاتٌ عَيْنٌ':Added, #2: 2	فَوَاتِ الْعَيْنِ
u'فَوَاتٌ عَيْن':Added, #2: 2	فَوَاتِ الْعَيْنِ
u'فَوَاتٌ غَايَةٌ':Added, #2: 2	فَوَاتِ الْعَيْنِ
u'فَوَاتٌ غَرَضٌ':Added, #1: 1	فَوَاتِ الْغَايَةِ
u'فَوَاتٌ فَرِيضَةٌ':Added, #1: 1	فَوَاتَ غَرَضٍ
u'فَوَاتٌ فَضَائِلُ':Added, #1: 1	فَوَاتُ فَرِيضَةٍ
u'فَوَاتٌ فَضِيلٌ':Added, #1: 1	فَوَاتِ الْفَضَائِلِ
u'فَوَاتٌ فَضِيلٌ':Added, #1: 1	فَوَاتِ الْفَضِيلَةِ
u'فَوَاتٌ فَضِيلٌ':Added, #1: 1	فَوَاتَ فَضِيلَةِ
u'فَوَاتٌ فَضِيلَةٌ':Added, #1: 1	فَوَاتُ فَضِيلَةِ
u'فَوَاتٌ فَضِيلَةٌ':Added, #1: 1	فَوَاتِ الْفَضِيلَةِ
u'فَوَاتٌ فَضِيلَةٌ':Added, #1: 1	فَوَاتَ فَضِيلَةِ
u'فَوَاتٌ فَهْمٌ':Added, #1: 1	فَوَاتُ فَضِيلَةِ
u'فَوَاتٌ قَدْرٌ':Added, #1: 1	فَوَاتُ فَهْمِ
u'فَوَاتٌ قطعة':Added, #2: 2	فَوَاتِ قَدْرِ
u'فَوَاتٌ قِطْعَةٌ':Added, #1: 1	فَوَاتُ قِطْعَةٍ
u'فَوَاتٌ كَثْرَةٌ':Added, #1: 1	فَوَاتُ قِطْعَةٍ
u'فَوَاتٌ مَالٌ':Added, #1: 1	فَوَاتُ كَثْرَةِ
u'فَوَاتٌ مَالِيٌّ':Added, #1: 1	فَوَاتِ مَالِهِ
u'فَوَاتٌ مَالِيٌّ':Added, #1: 1	فَوَاتَ الْمَالِيَّةِ
u'فَوَاتٌ مَأْمُورٌ':Added, #3: 3	فَوَاتِ الْمَالِيَّةِ
u'فَوَاتٌ مَبِيعٌ':Added, #1: 1	فَوَاتِ الْمَأْمُورِ
u'فَوَاتٌ مَبِيعٌ':Added, #1: 1	فَوَاتِ الْمَبِيعِ
u'فَوَاتٌ مَجِيءٌ':Added, #2: 2	فَوَاتَ الْمَبِيعِ
u'فَوَاتٌ مَحَلٌّ':Added, #1: 1	فَوَاتِ مَجِيءِ
u'فَوَاتٌ مَحَلٌّ':Added, #1: 1	فَوَاتِ مَحَلِّ
u'فَوَاتٌ مَحَلِّيٌّ':Added, #3: 3	فَوَاتِ الْمَحَلِّ
u'فَوَاتٌ مَحَلِّيٌّ':Added, #1: 1	فَوَاتَ الْمَحَلِّيَّةِ
u'فَوَاتٌ مَحَلِّيَّةٌ':Added, #1: 1	فَوَاتِ الْمَحَلِّيَّةِ
u'فَوَاتٌ مَحَلِّيَّةٌ':Added, #1: 1	فَوَاتَ الْمَحَلِّيَّةِ
u'فَوَاتٌ مَشْرُوطٌ':Added, #1: 1	فَوَاتِ الْمَحَلِّيَّةِ
u'فَوَاتٌ مَشَقَّةٌ':Added, #1: 1	فَوَاتَ الْمَشْرُوطِ
u'فَوَاتٌ مَصَالِحُ':Added, #1: 1	فَوَاتُ الْمَشَقَّةِ
u'فَوَاتٌ مَصْلَحَةٌ':Added, #1: 1	فَوَاتِ مَصَالِحِ
u'فَوَاتٌ مُصِيبٌ':Added, #3: 3	فَوَاتِ مَصْلَحَةٍ
u'فَوَاتٌ مُصِيبَةٌ':Added, #1: 1	فَوَاتِ مُصِيبَتِهِ
u'فَوَاتٌ مَضْمُونٌ':Added, #1: 1	فَوَاتِ مُصِيبَتِهِ
u'فَوَاتٌ مَعْقُودٌ':Added, #1: 1	فَوَاتِ الْمَضْمُونِ
u'فَوَاتٌ مَعْقُودٌ':Added, #1: 1	فَوَاتُ الْمَعْقُودِ
u'فَوَاتٌ مَعْقُودٌ':Added, #2: 2	فَوَاتَ الْمَعْقُودِ
u'فَوَاتٌ مَقَاصِدُ':Added, #3: 3	فَوَاتِ الْمَعْقُودِ
u'فَوَاتٌ مَقَاصِدُ':Added, #1: 1	فَوَاتُ الْمَقَاصِدِ
u'فَوَاتٌ مَقْصُودٌ':Added, #1: 1	فَوَاتِ الْمَقَاصِدِ
u'فَوَاتٌ مَقْصُودٌ':Added, #12: 12	فَوَاتِ الْمَقْصُودِ
u'فَوَاتٌ مَقْصُودٌ':Added, #1: 1	فَوَاتِ مَقْصُودِهِ
u'فَوَاتٌ مَكْتُوبٌ':Added, #2: 2	فَوَاتِ مَقْصُودِ
u'فَوَاتٌ مِلْكٌ':Added, #2: 2	فَوَاتِ الْمَكْتُوبَةِ
u'فَوَاتٌ مَنْفَعَةٌ':Added, #1: 1	فَوَاتُ مِلْكِ
u'فَوَاتٌ مَنْفَعَةٌ':Added, #1: 1	فَوَاتُ الْمَنْفَعَةِ
u'فَوَاتٌ مَنْفَعَةٌ':Added, #1: 1	فَوَاتِ الْمَنْفَعَةِ
u'فَوَاتٌ مَنْفَعَةٌ':Added, #1: 1	فَوَاتُ مَنْفَعَةِ
u'فَوَاتٌ مُهْجَةٌ':Added, #1: 1	فَوَاتِ مَنْفَعَةٍ
u'فَوَاتٌ مُهِمٌّ':Added, #1: 1	فَوَاتَ مُهْجَتِهِ
u'فَوَاتٌ مُوالاة':Added, #1: 1	فَوَاتُ مُهِمٍّ
u'فَوَاتٌ نَازِلٌ':Added, #3: 3	فَوَاتِ الْمُوَالَاةِ
u'فَوَاتٌ نَازِلٌ':Added, #1: 1	فَوَاتَ النَّازِلَةِ
u'فَوَاتٌ نَازِلَةٌ':Added, #1: 1	فَوَاتُ النَّازِلَةِ
u'فَوَاتٌ نَازِلَةٌ':Added, #1: 1	فَوَاتَ النَّازِلَةِ
u'فَوَاتٌ نعمة':Added, #1: 1	فَوَاتُ النَّازِلَةِ
u'فَوَاتٌ نِعْمَةٌ':Added, #6: 6	فَوَاتِ نِعْمَةِ
u'فَوَاتٌ نَعِيمٌ':Added, #6: 6	فَوَاتِ نِعْمَةِ
u'فَوَاتٌ نَفْسٌ':Added, #1: 1	فَوَاتِ نَعِيمٍ
u'فَوَاتٌ نَفْسٌ':Added, #1: 1	فَوَاتُ النَّفْسِ
u'فَوَاتٌ نَفْسٌ':Added, #1: 1	فَوَاتِ نَفْسِ
u'فَوَاتٌ نَفْسٌ':Added, #1: 1	فَوَاتَ نَفْسِهِ
u'فَوَاتٌ نَفْسٌ':Added, #1: 1	فَوَاتِ نَفْسِهِ
u'فَوَاتٌ نَفْسٌ':Added, #2: 2	فَوَاتَ نَفْسِ
u'فَوَاتٌ هِبَةٌ':Added, #3: 3	فَوَاتِ النَّفْسِ
u'فَوَاتٌ وَاجِبٌ':Added, #2: 2	فَوَاتِ الْهِبَةِ
u'فَوَاتٌ واحد':Added, #1: 1	فَوَاتُ وَاجِبٍ
u'فَوَاتٌ وَاحِدٌ':Added, #1: 1	فَوَاتَ الْوَاحِدَةِ
u'فَوَاتٌ وَصْفٌ':Added, #1: 1	فَوَاتَ الْوَاحِدَةِ
u'فَوَاتٌ وَصْفٌ':Added, #1: 1	فَوَاتَ الْوَصْفِ
u'فَوَاتٌ وَصْفٌ':Added, #1: 1	فَوَاتِ وَصْفِهِ
u'فَوَاتٌ وَصْفٌ':Added, #2: 2	فَوَاتُ الْوَصْفِ
u'فَوَاتٌ وَصْفٌ':Added, #2: 2	فَوَاتِ وَصْفٍ
u'فَوَاتٌ وَصْفٌ':Added, #3: 3	فَوَاتِ الْوَصْفِ
u'فَوَاتٌ وَقْتٌ':Added, #3: 3	فَوَاتُ وَصْفٍ
u'فَوَاتٌ وَقْتٌ':Added, #14: 14	فَوَاتِ الْوَقْتِ
u'فَوَاتٌ وَقْتٌ':Added, #17: 17	فَوَاتَ الْوَقْتِ
u'فَوَاتٌ وَقْتٌ':Added, #1: 1	فَوَاتُ الْوَقْتِ
u'فَوَاتٌ وَقْتٌ':Added, #1: 1	فَوَاتَ وَقْتِهِ
u'فَوَاتٌ وَقْتٌ':Added, #1: 1	فَوَاتُ وَقْتِهِ
u'فَوَاتٌ وَقْتٌ':Added, #2: 2	فَوَاتُ وَقْتِ
u'فَوَاتٌ وُقُوفٌ':Added, #2: 2	فَوَاتِ وَقْتِ
u'فَوَاتٌ وُقُوفٌ':Added, #1: 1	فَوَاتَ الْوُقُوفِ
u'فَوَاتٌ وُقُوفٌ':Added, #1: 1	فَوَاتُ الْوُقُوفِ
u'فَوَاتٌ وُقُوفٌ':Added, #1: 1	فَوَاتَ وُقُوفِ
u'فَوَاتٌ يَدٌ':Added, #4: 4	فَوَاتِ الْوُقُوفِ
u'فَوَاتٌ يَدٌ':Added, #1: 1	فَوَاتِ يَدِ
u'فَوَاقٌ نَاقَةٌ':Added, #2: 2	فَوَاتُ الْيَدِ
u'فَوَاقٌ نَاقَة':Added, #1: 1	فَوَاقَ نَاقَةٍ
u'فَوَّتَ أَدَاءٌ':Predicate, #1: 1	فَوَاقَ نَاقَةٍ
u'فَوَّتَ إِرَاقَةٌ':Predicate, #2: 2	فَوَّتَ الْأَدَاءَ
u'فَوَّتَ اِكْتِسَابٌ':Predicate, #1: 1	فَوَّتَ الْإِرَاقَةَ
u'فَوَّتَ إِمْكانٌ':Predicate, #1: 1	فَوَّتَ اكْتِسَابَ
u'فَوَّتَ أَمْنٌ':Predicate, #3: 3	فَوَّتَ إمْكَانَ
u'فَوَّتَ بِرٌّ':Predicate, #1: 1	فَوَّتَ الْأَمْنَ
u'فَوَّتَ بَعْضٌ':Predicate, #6: 6	فَوَّتَ الْبِرَّ
u'فَوَّتَ تَحِيَّةٌ':Predicate, #1: 1	فَوَّتَ بَعْضَ
u'فَوَّتَ جَمَالٌ':Predicate, #1: 1	فَوَّتَ التَّحِيَّةَ
u'فَوَّتَ جمعة':Predicate, #1: 1	فَوَّتَ الْجَمَالَ
u'فَوَّتَ جُمُعَةٌ':Predicate, #1: 1	فَوَّتَ الْجُمُعَةَ
u'فَوَّتَ جِنْسٌ':Predicate, #1: 1	فَوَّتَ الْجُمُعَةَ
u'فَوَّتَ حَقٌّ':Predicate, #5: 5	فَوَّتَ جِنْسَ
u'فَوَّتَ حَقٌّ':Predicate, #1: 1	فَوَّتَ الْحَقَّ
u'فَوَّتَ ذِمَّةٌ':Predicate, #1: 1	فَوَّتَ حَقَّ
u'فَوَّتَ رَدٌّ':Predicate, #1: 1	فَوَّتَ الذِّمَّةَ
u'فَوَّتَ رُكْنٌ':Predicate, #1: 1	فَوَّتَ الرَّدَّ
u'فَوَّتَ رُكْن':Predicate, #1: 1	فَوَّتَ رُكْنَ
u'فَوَّتَ زِراعَةٌ':Predicate, #1: 1	فَوَّتَ رُكْنَ
u'فَوَّتَ سَفَرٌ':Predicate, #1: 1	فَوَّتَ الزِّرَاعَةَ
u'فَوَّتَ سُنَّةٌ':Predicate, #1: 1	فَوَّتَ السَّفَرَ
u'فَوَّتَ صَلاَةٌ':Predicate, #1: 1	فَوَّتَ السُّنَّةَ
u'فَوَّتَ صَوْمٌ':Predicate, #1: 1	فَوَّتَ الصَّلَاةَ
u'فَوَّتَ عَمَلٌ':Predicate, #1: 1	فَوَّتَ صَوْمَ
u'فَوَّتَ غَرَضٌ':Predicate, #1: 1	فَوَّتَ الْعَمَلَ
u'فَوَّتَ قَاتِلٌ':Subject, #1: 1	فَوَّتَ الْغَرَضَ
u'فَوَّتَ مَاءٌ':Predicate, #1: 1	فَوَّتَ قَاتِلُهُ
u'فَوَّتَ مَالٌ':Predicate, #2: 2	فَوَّتَ الْمَاءَ
u'فَوَّتَ مَالٌ':Predicate, #1: 1	فَوَّتَ مَالَ
u'فَوَّتَ مَرْتَبَةٌ':Predicate, #2: 2	فَوَّتَ الْمَالَ
u'فَوَّتَ مَقْصُودٌ':Predicate, #1: 1	فَوَّتَ مَرْتَبَةَ
u'فَوَّتَ مِلْكٌ':Predicate, #1: 1	فَوَّتَ الْمَقْصُودَ
u'فَوَّتَ مَنَافِعُ':Predicate, #1: 1	فَوَّتَ الْمِلْكَ
u'فَوَّتَ مَنْفَعَةٌ':Predicate, #1: 1	فَوَّتَ الْمَنَافِعَ
u'فَوَّتَ مَوْقُوفٌ':Predicate, #2: 2	فَوَّتَ مَنْفَعَةَ
u'فَوَّتَ نَظِيرٌ':Subject, #1: 1	فَوَّتَ الْمَوْقُوفَ
u'فَوَّتَ وُجُوبٌ':Predicate, #1: 1	فَوَّتَ نَظِيرُ
u'فَوْرٌ أَذَانٌ':Added, #2: 2	فَوَّتَ وُجُوبَ
u'فَوْرٌ أَذَانٌ':Added, #1: 1	فَوْرِ الْأَذَانِ
u'فَوْرٌ إِرْسَالٌ':Added, #3: 3	فَوْرَ الْأَذَانِ
u'فَوْرٌ إِرْسَالٌ':Added, #4: 4	فَوْرُ الْإِرْسَالِ
u'فَوْرٌ أكل':Added, #4: 4	فَوْرِ الْإِرْسَالِ
u'فَوْرٌ أَكْلٌ':Added, #1: 1	فَوْرِ أَكْلِ
u'فَوَرَانٌ دَمٌ':Added, #1: 1	فَوْرِ أَكْلِ
u'فَوَرَانٌ غضب':Added, #1: 1	فَوَرَانِ الدَّمِ
u'فَوَرَانٌ غَضَبٌ':Added, #2: 2	فَوَرَانِ الْغَضَبِ
u'فَوَرَانٌ قِدْرٌ':Added, #2: 2	فَوَرَانِ الْغَضَبِ
u'فَوْرٌ أَنْوَاعٌ':Added, #1: 1	فَوَرَانِ الْقِدْرِ
u'فَوْرٌ أَوَّلُ':Added, #1: 1	فَوْرَ أَنْوَاعِ
u'فَوْرٌ أَوَّلُ':Added, #1: 1	فَوْرُ الْأَوَّلِ
u'فَوْرٌ تَسْمِيَة':Added, #2: 2	فَوْرِ الْأَوَّلِ
u'فَوْرٌ تَمَكُّنٌ':Added, #1: 1	فَوْرَ التَّسْمِيَةِ
u'فَوْرٌ خَبَرٌ':Added, #1: 1	فَوْرِ تَمَكُّنِهِ
u'فَوْرٌ خَبَر':Added, #1: 1	فَوْرِ الْخَبَرِ
u'فَوْرٌ دُخُولٌ':Added, #1: 1	فَوْرِ الْخَبَرِ
u'فَوْرٌ رَغيفٌ':Added, #2: 2	فَوْرِ دُخُولِهِ
u'فَوْرٌ سُؤَالٌ':Added, #1: 1	فَوْرِ الرَّغِيفِ
u'فَوْرٌ شفق':Added, #1: 1	فَوْرَ السُّؤَالِ
u'فَوْرٌ شَفَقٌ':Added, #1: 1	فَوْرُ الشَّفَقِ
u'فَوْرٌ شِكايَة':Added, #1: 1	فَوْرُ الشَّفَقِ
u'فَوْرٌ صَلاَةٌ':Added, #1: 1	فَوْرِ الشِّكَايَةِ
u'فَوْرٌ صَلاَةٌ':Added, #1: 1	فَوْرُ الصَّلَاةِ
u'فَوْرٌ صَلاَةٌ':Added, #2: 2	فَوْرِ الصَّلَاةِ
u'فَوْرٌ علم':Added, #5: 5	فَوْرَ الصَّلَاةِ
u'فَوْرٌ عِلْمٌ':Added, #1: 1	فَوْرِ عِلْمِهِ
u'فَوْرٌ علم':Added, #1: 1	فَوْرِ عِلْمِهِ
u'فَوْرٌ عِلْمٌ':Added, #2: 2	فَوْرِ الْعِلْمِ
u'فَوْرٌ فَتْحٌ':Added, #2: 2	فَوْرِ الْعِلْمِ
u'فَوْرٌ قَدْرٌ':Added, #2: 2	فَوْرِ الْفَتْحِ
u'فَوْرٌ قِدْرٌ':Added, #1: 1	فَوْرِ الْقَدْرِ
u'فَوْرٌ قَطْعٌ':Added, #2: 2	فَوْرِ الْقِدْرِ
u'فَوْرٌ قول':Added, #1: 1	فَوْرِ الْقَطْعِ
u'فَوْرٌ قَوْلٌ':Added, #1: 1	فَوْرِ قَوْلِ
u'فَوْرٌ كَلاَمٌ':Added, #1: 1	فَوْرِ قَوْلِ
u'فَوْرٌ نَخْس':Added, #1: 1	فَوْرِ كَلَامِهِ
u'فَوْرٌ نخسة':Added, #4: 4	فَوْرِ النَّخْسِ
u'فَوْرٌ نُكُولٌ':Added, #2: 2	فَوْرِ النَّخْسَةِ
u'فَوْرٌ هَزِيمَةٌ':Added, #2: 2	فَوْرِ النُّكُولِ
u'فَوْرٌ واحد':Added, #2: 2	فَوْرِ الْهَزِيمَةِ
u'فَوْرٌ وَاحِدٌ':Added, #11: 11	فَوْرٍ وَاحِدٍ
u'فَوْرٌ وِلاَدَةٌ':Added, #11: 11	فَوْرٍ وَاحِدٍ
u'فَوْزٌ سَعِيدٌ':Added, #1: 1	فَوْرِ الْوِلَادَةِ
u'فَوْزٌ فَرْعٌ':Added, #1: 1	فَوْزُ السَّعِيدِ
u'فَوَّضَ أَجْنَبِيٌّ':Subject, #1: 1	فَوْز الْفَرْعِ
u'فَوَّضَ أَدَاءٌ':Predicate, #1: 1	فَوَّضَ أَجْنَبِيٌّ
u'فَوَّضَ أَمْرٌ':Predicate, #1: 1	فَوَّضَ أَدَاءَ
u'فَوَّضَ إِمْساكٌ':Predicate, #11: 11	فَوَّضَ الْأَمْرَ
u'فَوَّضَ بَيَانٌ':Predicate, #1: 1	فَوَّضَ الْإِمْسَاكَ
u'فَوَّضَ تَطْلِيقٌ':Predicate, #1: 1	فَوَّضَ بَيَانَ
u'فَوَّضَ تَطْلِيقٌ':Predicate, #1: 1	فَوَّضَ تَطْلِيقَ
u'فَوَّضَ تَوْلِيَةٌ':Predicate, #2: 2	فَوَّضَ التَّطْلِيقَ
u'فَوَّضَ ثَلاثُ':Predicate, #1: 1	فَوَّضَ التَّوْلِيَةَ
u'فَوَّضَ خَلِيفَةٌ':Subject, #1: 1	فَوَّضَ الثَّلَاثَ
u'فَوَّضَ خيار':Predicate, #2: 2	فَوَّضَ الْخَلِيفَةُ
u'فَوَّضَ خِيَارٌ':Predicate, #1: 1	فَوَّضَ الْخِيَارَ
u'فَوَّضَ خِيرَةٌ':Predicate, #1: 1	فَوَّضَ الْخِيَارَ
u'فَوَّضَ رَأْيٌ':Predicate, #1: 1	فَوَّضَ الْخِيَرَةَ
u'فَوَّضَ شَرْعٌ':Subject, #2: 2	فَوَّضَ الرَّأْيَ
u'فَوَّضَ طَلاَقٌ':Predicate, #1: 1	فَوَّضَ الشَّرْعُ
u'فَوَّضَ طَلاَقٌ':Predicate, #1: 1	فَوَّضَ الطَّلَاقَ
u'فَوَّضَ فَسْخٌ':Predicate, #3: 3	فَوَّضَ طَلَاقَ
u'فَوَّضَ فلان':Subject, #2: 2	فَوَّضَ الْفَسْخَ
u'فَوَّضَ واحد':Predicate, #2: 2	فَوَّضَ عُثْمَانُ
u'فَوَّضَ وَاحِدٌ':Predicate, #1: 1	فَوَّضَ وَاحِدَةً
u'فَيْءٌ ألْفٌ':Added, #1: 1	فَوَّضَ وَاحِدَةً
u'فَيْءٌ تُلولٌ':Added, #2: 2	فَيْءَ أَلْفَيْنِ
u'فَيْءٌ ثَلاثَةٌ':Added, #1: 1	فَيْءَ التُّلُولِ
u'فَيْءٌ زَوالٌ':Added, #2: 2	فَيْءَ ثَلَاثَةِ
u'فَيْءٌ زَوالٌ':Added, #2: 2	فَيْءُ الزَّوَالِ
u'فَيْءٌ شَجَرَةٌ':Added, #7: 7	فَيْءِ الزَّوَالِ
u'فَيْءٌ شَجَرَةٌ':Added, #1: 1	فَيْءُ الشّجَرَةِ
u'فَيْءٌ شَيْءٌ':Added, #2: 2	فَيْءِ الشّجَرَةِ
u'فَيْءٌ عقاب':Added, #1: 1	فَيْءُ الشَّيْءِ
u'فَيْءٌ عُقَابٌ':Added, #1: 1	فَيْءُ عُقَابِ
u'فَيْءٌ مُحَمَّدٌ':Added, #1: 1	فَيْءُ عُقَابِ
u'فَيْءٌ مَعْذُورٌ':Added, #1: 1	فَيْءِ مُحَمّدٍ
u'فَيْضٌ دُموعٌ':Added, #1: 1	فَيْءَ الْمَعْذُورِ
u'فَيْضٌ رحمة':Added, #1: 1	فَيْضُ الدُّمُوعِ
u'فَيْضٌ رَحْمَةٌ':Added, #1: 1	فَيْضُ الرَّحْمَةِ
u'فَيْضٌ فَتَّاحٌ':Added, #1: 1	فَيْضُ الرَّحْمَةِ
u'فَيْضٌ فَضْلٌ':Added, #1: 1	فَيْضِ الْفَتَّاحِ
u'فَيْضٌ فَضْلٌ':Added, #1: 1	فَيْضِ الْفَضْلِ
u'فَيْضٌ مدد':Added, #1: 1	فَيْضِ فَضْلِهِ
u'فَيْضٌ مَدَدٌ':Added, #2: 2	فَيْضِ مَدَدِهِ
u'فَيْئَةٌ قَادِرٌ':Added, #2: 2	فَيْضِ مَدَدِهِ
u'فَيْئَةٌ مَعْذُورٌ':Added, #1: 1	فَيْئَةِ الْقَادِرِ
u'قَاءَ أقَلُّ':Predicate, #1: 1	فَيْئَةَ الْمَعْذُورِ
u'قَاءَ شَيْطَانٌ':Subject, #3: 3	قَاءَ أَقَلَّ
u'قَاءَ صَغِيرٌ':Subject, #2: 2	قَاءَ الشَّيْطَانُ
u'قَاءَ مرٌّ':Predicate, #1: 1	قَاءَ الصَّغِيرُ
u'قَاءَ مرٌّ':Predicate, #1: 1	قَاءَ مَرَّةً
u'قَاءَ مِلْءٌ':Predicate, #1: 1	قَاءَ مُرَّةً
u'قَابَلَ أرْضٌ':Predicate, #7: 7	قَاءَ مِلْءَ
u'قَابَلَ ألف':Predicate, #1: 1	قَابَلَ الْأَرْضَ
u'قَابَلَ ألْفٌ':Predicate, #6: 6	قَابَلَ الْأَلْفَ
u'قَابَلَ أَلْفٌ':Predicate, #6: 6	قَابَلَ الْأَلْفَ
u'قَابَلَ إمَامٌ':Subject, #6: 6	قَابَلَ الْأَلْفَ
u'قَابَلَ إيمَانٌ':Predicate, #1: 1	قَابَلَ الْإِمَامُ
u'قَابَلَ بَدَلٌ':Predicate, #1: 1	قَابَلَ الْإِيمَانَ
u'قَابَلَ بَذْرٌ':Predicate, #6: 6	قَابَلَ الْبَدَلَ
u'قَابَلَ بَطْنٌ':Predicate, #1: 1	قَابَلَ بَذْرَ
u'قَابَلَ بَعْضٌ':Predicate, #1: 1	قَابَلَ الْبَطْنَ
u'قَابَلَ تَرْجِيحٌ':Predicate, #1: 1	قَابَلَ الْبَعْضَ
u'قَابَلَ تَطَوُّعٌ':Predicate, #1: 1	قَابَلَ تَرْجِيحَ
u'قَابَلَ ثَمَنٌ':Predicate, #1: 1	قَابَلَ التَّطَوُّعَ
u'قَابَلَ ثِيابٌ':Predicate, #2: 2	قَابَلَ الثَّمَنَ
u'قَابَلَ جُمْلَةٌ':Predicate, #1: 1	قَابَلَ الثِّيَابَ
u'قَابَلَ جَوَازٌ':Predicate, #4: 4	قَابَلَ الْجُمْلَةَ
u'قَابَلَ دِرْهَمٌ':Predicate, #1: 1	قَابَلَ الْجَوَازَ
u'قَابَلَ دِرْهَم':Predicate, #3: 3	قَابَلَ الدِّرْهَمَ
u'قَابَلَ دِينارٌ':Predicate, #3: 3	قَابَلَ الدِّرْهَمَ
u'قَابَلَ شَجَرٌ':Predicate, #1: 1	قَابَلَ الدِّينَارَ
u'قَابَلَ شَيْءٌ':Predicate, #1: 1	قَابَلَ الشَّجَرَ
u'قَابَلَ شَيْءٌ':Subject, #1: 1	قَابَلَ الشَّيْءَ
u'قَابَلَ صَحِيحٌ':Predicate, #1: 1	قَابَلَ الشَّيْءُ
u'قَابَلَ طَلاَقٌ':Predicate, #2: 2	قَابَلَ الصَّحِيحَ
u'قَابَلَ عَرْضٌ':Predicate, #2: 2	قَابَلَ الطَّلَاقَ
u'قَابَلَ علم':Predicate, #1: 1	قَابَلَ الْعَرْضَ
u'قَابَلَ عِلْمٌ':Predicate, #1: 1	قَابَلَ الْعِلْمَ
u'قَابَلَ عَوْرَةٌ':Predicate, #1: 1	قَابَلَ الْعِلْمَ
u'قَابَلَ عين':Predicate, #1: 1	قَابَلَ الْعَوْرَةَ
u'قَابَلَ عَيْنٌ':Predicate, #2: 2	قَابَلَ الْعَيْنَ
u'قَابَلَ عَيْن':Predicate, #2: 2	قَابَلَ الْعَيْنَ
u'قَابَلَ فَاسِدٌ':Predicate, #2: 2	قَابَلَ الْعَيْنَ
u'قَابَلَ فَذٌّ':Predicate, #1: 1	قَابَلَ الْفَاسِدَ
u'قَابَلَ فرد':Predicate, #1: 1	قَابَلَ الْفَذَّ
u'قَابَلَ فَرْدٌ':Predicate, #1: 1	قَابَلَ الْفَرْدَ
u'قَابَلَ فَرْضٌ':Predicate, #1: 1	قَابَلَ الْفَرْدَ
u'قَابَلَ فِضَّةٌ':Predicate, #3: 3	قَابَلَ الْفَرْضَ
u'قَابَلَ فِعْلٌ':Predicate, #1: 1	قَابَلَ الْفِضَّةَ
u'قَابَلَ قمر':Subject, #1: 1	قَابَلَ فِعْلَ
u'قَابَلَ قَمَرٌ':Subject, #1: 1	قَابَلَ الْقَمَرُ
u'قَابَلَ لَفْظَةٌ':Predicate, #1: 1	قَابَلَ الْقَمَرُ
u'قَابَلَ مَاءٌ':Predicate, #1: 1	قَابَلَ لَفْظَةَ
u'قَابَلَ مَبِيعٌ':Predicate, #1: 1	قَابَلَ الْمَاءَ
u'قَابَلَ مَسْنُونٌ':Predicate, #1: 1	قَابَلَ الْمَبِيعَ
u'قَابَلَ مَسِيسٌ':Predicate, #1: 1	قَابَلَ الْمَسْنُونَ
u'قَابَلَ مُصَنِّفٌ':Subject, #1: 1	قَابَلَ الْمَسِيسَ
u'قَابَلَ مَغْرِبٌ':Predicate, #1: 1	قَابَلَ الْمُصَنِّفُ
u'قَابَلَ مَوْهُوبٌ':Predicate, #1: 1	قَابَلَ الْمَغْرِبَ
u'قَابَلَ نَتْفٌ':Predicate, #1: 1	قَابَلَ الْمَوْهُوبَةَ
u'قَابَلَ نِصْفٌ':Predicate, #1: 1	قَابَلَ النَّتْفَ
u'قَابَلَ نِصْفٌ':Predicate, #1: 1	قَابَلَ النِّصْفَ
u'قَابَلَ نَقْدٌ':Predicate, #1: 1	قَابَلَ نِصْفَ
u'قَابَلَ نَقْد':Predicate, #2: 2	قَابَلَ النَّقْدَ
u'قَابِلِيَّةٌ خَيْرٌ':Added, #2: 2	قَابَلَ النَّقْدَ
u'قَابِلِيَّةٌ طَهَارَةٌ':Added, #1: 1	قَابِلِيَّةِ الْخَيْرِ
u'قَابِلِيَّةٌ عين':Added, #1: 1	قَابِلِيَّةِ الطَّهَارَةِ
u'قَابِلِيَّةٌ عَيْنٌ':Added, #1: 1	قَابِلِيَّةُ الْعَيْنِ
u'قَابِلِيَّةٌ عَيْن':Added, #1: 1	قَابِلِيَّةُ الْعَيْنِ
u'قَابِلِيَّةٌ مِلْكٌ':Added, #1: 1	قَابِلِيَّةُ الْعَيْنِ
u'قَابِلِيَّةٌ نَفْسٌ':Added, #1: 1	قَابِلِيَّةُ الْمِلْكِ
u'قَابِلِيَّةٌ نِيَّةٌ':Added, #1: 1	قَابِلِيَّةِ النَّفْسِ
u'قَابَلَ يَقِينٌ':Predicate, #1: 1	قَابِلِيَّةُ النِّيَّةِ
u'قَاتَلَ أَجِيرٌ':Subject, #3: 3	قَابَلَ الْيَقِينَ
u'قَاتَلَ أَصْحَابٌ':Predicate, #2: 2	قَاتَلَ الْأَجِيرُ
u'قَاتَلَ أهْلٌ':Predicate, #1: 1	قَاتَلَ أَصْحَابَ
u'قَاتَلَ أهْلٌ':Subject, #7: 7	قَاتَلَ أَهْلَ
u'قَاتَلَ بَاغِي':Predicate, #1: 1	قَاتَلَ أَهْلُ
u'قَاتَلَ تَاجِرٌ':Subject, #1: 1	قَاتَلَ الْبَاغِيَةَ
u'قَاتَلَ جِنٌّ':Predicate, #1: 1	قَاتَلَ التَّاجِرُ
u'قَاتَلَ خُزَاعَةٌ':Predicate, #1: 1	قَاتَلَ الْجِنَّ
u'قَاتَلَ دونٌ':Predicate, #1: 1	قَاتَلَ خُزَاعَةَ
u'قَاتَلَ رَجُلٌ':Subject, #1: 1	قَاتَلَ دُونَ
u'قَاتَلَ رَسُولٌ':Predicate, #1: 1	قَاتَلَ الرَّجُلُ
u'قَاتَلَ رَسُولٌ':Subject, #2: 2	قَاتَلَ رَسُولَ
u'قَاتَلَ صِدِّيقٌ':Subject, #6: 6	قَاتَلَ رَسُولُ
u'قَاتَلَ عَبْدٌ':Subject, #2: 2	قَاتَلَ الصِّدِّيقُ
u'قَاتَلَ عَصَبِيٌّ':Predicate, #1: 1	قَاتَلَ الْعَبْدُ
u'قَاتَلَ عَلِيٌّ':Subject, #2: 2	قَاتَلَ عَصَبِيَّةً
u'قَاتَلَ عُمَرٌ':Predicate, #5: 5	قَاتَلَ عَلِيٌّ
u'قَاتَلَ فلان':Subject, #1: 1	قَاتَلَ عُمَرَ
u'قَاتَلَ فِئَةٌ':Predicate, #1: 1	قَاتَلَ الزُّبَيْرُ
u'قَاتَلَ قتل':Predicate, #1: 1	قَاتَلَ الْفِئَةَ
u'قَاتَلَ قَوْمٌ':Predicate, #2: 2	قَاتَلَ قُتِلَ
u'قَاتَلَ كُفَّارٌ':Predicate, #4: 4	قَاتَلَ الْقَوْمَ
u'قَاتَلَ لُصُوصٌ':Predicate, #1: 1	قَاتَلَ الْكُفَّارَ
u'قَاتَلَ مُسْلِمٌ':Predicate, #2: 2	قَاتَلَ اللُّصُوصَ
u'قَاتَلَ مُسْلِمٌ':Subject, #1: 1	قَاتَلَ الْمُسْلِمِينَ
u'قَاتَلَ مَشْهُودٌ':Subject, #1: 1	قَاتَلَ مُسْلِمٌ
u'قَاتَلَ مُنْقَلِبٌ':Predicate, #1: 1	قَاتَلَ الْمَشْهُودُ
u'قَاتَلَ نِساءٌ':Subject, #1: 1	قَاتَلَ الْمُنْقَلِبِينَ
u'قَاتَلَ يهود':Predicate, #3: 3	قَاتَلَ النِّسَاءُ
u'قَاتَلَ يَهُودٌ':Predicate, #1: 1	قَاتَلَ الْيَهُودَ
u'قَاتَلَ يَوْمٌ':Predicate, #1: 1	قَاتَلَ الْيَهُودَ
u'قَادَ إبْلِيسُ':Subject, #5: 5	قَاتَلَ يَوْمَ
u'قَادَ بَعيرٌ':Predicate, #1: 1	قَادَ إبْلِيسُ
u'قَادَ رَجُلٌ':Subject, #2: 2	قَادَ بَعِيرَ
u'قَادَ قَتِيلٌ':Subject, #2: 2	قَادَ الرَّجُلُ
u'قَادَ نَاسٌ':Predicate, #1: 1	قَادَ الْقَتِيلُ
u'قَارَبَ أرْضٌ':Predicate, #2: 2	قَادَ النّاسَ
u'قَارَبَ بُرْء':Predicate, #1: 1	قَارَبَ الْأَرْضَ
u'قَارَبَ بُنْيانٌ':Subject, #1: 1	قَارَبَ الْبُرْءَ
u'قَارَبَ تمام':Predicate, #1: 1	قَارَبَ الْبُنْيَانُ
u'قَارَبَ تَمامٌ':Predicate, #4: 4	قَارَبَ التَّمَامَ
u'قَارَبَ ثَمانِين':Predicate, #4: 4	قَارَبَ التَّمَامَ
u'قَارَبَ حُلُمٌ':Predicate, #1: 1	قَارَبَ ثَمَانِينَ
u'قَارَبَ دَيْنٌ':Subject, #1: 1	قَارَبَ الْحُلُمَ
u'قَارَبَ زَوالٌ':Predicate, #1: 1	قَارَبَ الدَّيْنُ
u'قَارَبَ شَيْءٌ':Predicate, #1: 1	قَارَبَ الزَّوَالَ
u'قَارَبَ طُلُوعٌ':Subject, #3: 3	قَارَبَ الشَّيْءَ
u'قَارَبَ ظُهْرٌ':Predicate, #1: 1	قَارَبَ طُلُوعُهُ
u'قَارَبَ عتق':Predicate, #1: 1	قَارَبَ الظُّهْرَ
u'قَارَبَ عِتْقٌ':Predicate, #1: 1	قَارَبَ الْعِتْقَ
u'قَارَبَ عَطَبٌ':Predicate, #1: 1	قَارَبَ الْعِتْقَ
u'قَارَبَ عِقْدٌ':Predicate, #1: 1	قَارَبَ الْعَطَبَ
u'قَارَبَ فلان':Predicate, #1: 1	قَارَبَ الْعِقْدَ
u'قَارَبَ قَدْرٌ':Predicate, #1: 1	قَارَبَ مَكَّةَ
u'قَارَبَ قَوْمٌ':Subject, #1: 1	قَارَبَ الْقَدْرَ
u'قَارَبَ قَيْءٌ':Subject, #1: 1	قَارَبَ الْقَوْمُ
u'قَارَبَ قِيَامَةٌ':Predicate, #1: 1	قَارَبَ الْقَيْءُ
u'قَارَبَ كفر':Predicate, #1: 1	قَارَبَ الْقِيَامَةَ
u'قَارَبَ كُفْرٌ':Predicate, #4: 4	قَارَبَ الْكُفْرَ
u'قَارَبَ مَاءٌ':Predicate, #4: 4	قَارَبَ الْكُفْرَ
u'قَارَبَ مَوْتٌ':Predicate, #1: 1	قَارَبَ الْمَاءَ
u'قَارَبَ مِيقَاتٌ':Predicate, #2: 2	قَارَبَ الْمَوْتَ
u'قَارَبَ نَصٌّ':Predicate, #1: 1	قَارَبَ الْمِيقَاتَ
u'قَارَبَ وفاة':Predicate, #2: 2	قَارَبَ النَّصَّ
u'قَارَبَ وَفَاةٌ':Predicate, #1: 1	قَارَبَ الْوَفَاةَ
u'قَارَضَ مَرِيضٌ':Subject, #1: 1	قَارَبَ الْوَفَاةَ
u'قَارَضَ وَلِيٌّ':Subject, #3: 3	قَارَضَ الْمَرِيضُ
u'قَارَفَ أَعْمَالٌ':Predicate, #1: 1	قَارَضَ وَلِيُّ
u'قَارَفَ لَيْلٌ':Predicate, #1: 1	قَارَفَ الْأَعْمَالَ
u'قَارَنَ اِبْتِداءٌ':Subject, #1: 1	قَارَفَ لَيْلَةَ
u'قَارَنَ أخْذٌ':Predicate, #1: 1	قَارَنَ ابْتِدَاءُ
u'قَارَنَ أَدَاءٌ':Predicate, #1: 1	قَارَنَ الْأَخْذَ
u'قَارَنَ إِسْلامٌ':Predicate, #3: 3	قَارَنَ الْأَدَاءَ
u'قَارَنَ اِعْتِقادٌ':Predicate, #5: 5	قَارَنَ الْإِسْلَامَ
u'قَارَنَ إفْلاَسٌ':Predicate, #2: 2	قَارَنَ اعْتِقَادَ
u'قَارَنَ إمَامٌ':Predicate, #1: 1	قَارَنَ الْإِفْلَاسَ
u'قَارَنَ إمَامٌ':Subject, #1: 1	قَارَنَ الْإِمَامَ
u'قَارَنَ بُلُوغٌ':Predicate, #1: 1	قَارَنَ الْإِمَامُ
u'قَارَنَ حُدوثٌ':Predicate, #1: 1	قَارَنَ الْبُلُوغَ
u'قَارَنَ حُرْمَةٌ':Predicate, #1: 1	قَارَنَ حُدُوثَ
u'قَارَنَ خَوْفٌ':Subject, #1: 1	قَارَنَ الْحُرْمَةَ
u'قَارَنَ زَمَنٌ':Subject, #1: 1	قَارَنَ الْخَوْفُ
u'قَارَنَ سَبَبٌ':Predicate, #1: 1	قَارَنَ زَمَنُ
u'قَارَنَ سَلَفٌ':Predicate, #3: 3	قَارَنَ سَبَبَ
u'قَارَنَ شُرُوعٌ':Predicate, #1: 1	قَارَنَ السَّلَفَ
u'قَارَنَ صَلاَةٌ':Predicate, #1: 1	قَارَنَ الشُّرُوعَ
u'قَارَنَ عتق':Subject, #2: 2	قَارَنَ الصَّلَاةَ
u'قَارَنَ عِتْقٌ':Subject, #2: 2	قَارَنَ عِتْقُهُ
u'قَارَنَ عَصْرٌ':Predicate, #2: 2	قَارَنَ عِتْقُهُ
u'قَارَنَ عَقْدٌ':Predicate, #1: 1	قَارَنَ الْعَصْرَ
u'قَارَنَ علم':Predicate, #2: 2	قَارَنَ الْعَقْدَ
u'قَارَنَ عِلْمٌ':Predicate, #2: 2	قَارَنَ الْعِلْمَ
u'قَارَنَ غُنْمٌ':Subject, #2: 2	قَارَنَ الْعِلْمَ
u'قَارَنَ فِعْلٌ':Predicate, #1: 1	قَارَنَ الْغُنْمُ
u'قَارَنَ قَبُولٌ':Predicate, #1: 1	قَارَنَ الْفِعْلَ
u'قَارَنَ مَانِعٌ':Predicate, #1: 1	قَارَنَ الْقَبُولَ
u'قَارَنَ مَنْعٌ':Predicate, #2: 2	قَارَنَ الْمَانِعَ
u'قَارَنَ وُجُوبٌ':Predicate, #1: 1	قَارَنَ مَنْعَ
u'قَارَنَ وُجُودٌ':Subject, #1: 1	قَارَنَ الْوُجُوبَ
u'قَارَنَ وُضُوءٌ':Subject, #1: 1	قَارَنَ وُجُودُ
u'قَارَنَ وَقْفٌ':Predicate, #1: 1	قَارَنَ الْوُضُوءُ
u'قَارَنَ يسار':Subject, #1: 1	قَارَنَ الْوَقْفَ
u'قَارَنَ يَسَارٌ':Subject, #1: 1	قَارَنَ يَسَارُهُ
u'قَاسَ اِبْنٌ':Subject, #1: 1	قَارَنَ يَسَارُهُ
u'قَاسَ أحَدٌ':Predicate, #2: 2	قَاسَ ابْنُ
u'قَاسَ إِحْرَامٌ':Predicate, #1: 1	قَاسَ أَحَدَ
u'قَاسَ بَيْضَةٌ':Predicate, #2: 2	قَاسَ الْإِحْرَامَ
u'قَاسَ بَيْعٌ':Predicate, #1: 1	قَاسَ الْبَيْضَةَ
u'قَاسَ بَيْعٌ':Predicate, #1: 1	قَاسَ الْبَيْعَ
u'قَاسَ جَمَاعَةٌ':Subject, #1: 1	قَاسَ بَيْعَ
u'قَاسَ حَمْلٌ':Predicate, #2: 2	قَاسَ جَمَاعَةٌ
u'قَاسَ خَارِجٌ':Predicate, #1: 1	قَاسَ حَمْلَ
u'قَاسَ خُرُوجٌ':Predicate, #1: 1	قَاسَ الْخَارِجَ
u'قَاسَ رَجْعِيٌّ':Predicate, #1: 1	قَاسَ الْخُرُوجَ
u'قَاسَ رَجْعِيَّةٌ':Predicate, #1: 1	قَاسَ الرَّجْعِيَّةَ
u'قَاسَ شافِعِيّ':Subject, #1: 1	قَاسَ الرَّجْعِيَّةَ
u'قَاسَ شَعْرٌ':Predicate, #3: 3	قَاسَ الشَّافِعِيُّ
u'قَاسَ فَصْلٌ':Predicate, #1: 1	قَاسَ الشَّعْرَ
u'قَاسَ فلان':Subject, #1: 1	قَاسَ فَصْلَ
u'قَاسَ لبن':Predicate, #3: 3	قَاسَ الشَّافِعِيُّ
u'قَاسَ لَبَنٌ':Predicate, #1: 1	قَاسَ لَبَنَ
u'قَاسَمَ أَخٌ':Predicate, #1: 1	قَاسَ لَبَنَ
u'قَاسَمَ أَخٌ':Predicate, #1: 1	قَاسَمَ أَخَ
u'قَاسَمَ إِخْوَةٌ':Predicate, #1: 1	قَاسَمَ الْأَخَ
u'قَاسَمَ بَائِعٌ':Predicate, #1: 1	قَاسَمَ الإِخْوَةَ
u'قَاسَمَ رَبُّ':Predicate, #2: 2	قَاسَمَ الْبَائِعَ
u'قَاسَ مَسْأَلَةٌ':Predicate, #1: 1	قَاسَمَ رَبَّ
u'قَاسَ مَسْأَلَةٌ':Predicate, #1: 1	قَاسَ الْمَسْأَلَةَ
u'قَاسَمَ شَفِيعٌ':Predicate, #2: 2	قَاسَ مَسْأَلَةَ
u'قَاسَمَ مَالٌ':Predicate, #1: 1	قَاسَمَ الشَّفِيعَ
u'قَاسَمَ مُرْتَهِنٌ':Subject, #1: 1	قَاسَمَ مَالَ
u'قَاسَمَ مُضَارِبٌ':Subject, #1: 1	قَاسَمَ الْمُرْتَهِنُ
u'قَاسَمَ وَاقِفٌ':Subject, #1: 1	قَاسَمَ الْمُضَارِبُ
u'قَاسَمَ وَرَثَةٌ':Predicate, #1: 1	قَاسَمَ الْوَاقِفُ
u'قَاسَمَ وَصِيٌّ':Subject, #3: 3	قَاسَمَ الْوَرَثَةَ
u'قَاسَ نَائِمٌ':Predicate, #6: 6	قَاسَمَ الْوَصِيُّ
u'قَاسَ نَفَلٌ':Predicate, #1: 1	قَاسَ النَّائِمَةَ
u'قَاصَّ غَنَمٌ':Predicate, #1: 1	قَاسَ النَّفَلَ
u'قَاصَّ نَاسٌ':Predicate, #1: 1	قَاصَّ الْغَنَمَ
u'قَاضَى أهْلٌ':Predicate, #1: 1	قَاصَّ النَّاسَ
u'قَاضَى دِمَشْقُ':Predicate, #1: 1	قَاضَى أَهْلَ
u'قَاضَى رَسُولٌ':Subject, #1: 1	قَاضَى دِمَشْقَ
u'قَاضَى مِصْرٌ':Predicate, #1: 1	قَاضَى رَسُولُ
u'قَاطَعَ شَرِيكٌ':Subject, #2: 2	قَاضَى مِصْرَ
u'قَاطَعَ مُعَلِّمٌ':Subject, #1: 1	قَاطَعَ الشَّرِيكُ
u'قَاطَعَ نَبِيٌّ':Subject, #1: 1	قَاطَعَ الْمُعَلِّمُ
u'قَافَ جَبَلٌ':Subject, #1: 1	قَاطَعَ النَّبِيُّ
u'قَالَ أَبٌ':Subject, #1: 1	قَافَ جَبَلٌ
u'قَالَ أَبٌ':Subject, #1: 1	قَالَ أَبٌ
u'قَالَ آباءٌ':Subject, #31: 31	قَالَ الْأَبُ
u'قَالَ إِبْرَاقٌ':Subject, #1: 1	قَالَ الْآبَاءُ
u'قَالَ إبْلِيسُ':Subject, #1: 1	قَالَ الْإِبْرَاقُ
u'قَالَ اِبْنٌ':Predicate, #2: 2	قَالَ إبْلِيسُ
u'قَالَ اِبْنٌ':Subject, #5: 5	قَالَ ابْنَ
u'قَالَ اِبْنٌ':Subject, #10363: 10363	قَالَ ابْنُ
u'قَالَ اِبْنٌ':Subject, #10: 10	قَالَ ابْنُهُ
u'قَالٌ اِبْنٌ':Added, #1: 1	قَالَ ابْنَاهُ
u'قَالَ أَبِيّ':Subject, #6: 6	قَالَ ابْنِ
u'قَالَ أبْيَاتٌ':Predicate, #2: 2	قَالَ الْأَبِيُّ
u'قَالَ أَبْيَض':Subject, #1: 1	قَالَ أَبْيَاتَ
u'قَالَ إِتْقَانٌ':Subject, #2: 2	قَالَ أَبْيَضُ
u'قَالَ إثْرٌ':Predicate, #1: 1	قَالَ الْإِتْقَانُ
u'قَالَ أثَرٌ':Predicate, #1: 1	قَالَ إثْرَ
u'قَالَ أثَرٌ':Subject, #2: 2	قَالَ أَثَرَ
u'قَالَ أَثْناءُ':Predicate, #1: 1	قَالَ أَثَرُ
u'قَالَ إِجَابَةٌ':Subject, #1: 1	قَالَ أَثْنَاءَ
u'قَالَ إجَارَةٌ':Subject, #1: 1	قَالَ إجَابَةُ
u'قَالَ إجَارَةٌ':Subject, #1: 1	قَالَ إجَارَةُ
u'قَالَ أَجْدَع':Subject, #3: 3	قَالَ الْإِجَارَةُ
u'قَالَ أَجْرٌ':Subject, #2: 2	قَالَ الْأَجْدَعُ
u'قَالَ أَجْرٌ':Subject, #1: 1	قَالَ أَجْرُ
u'قَالٌ أَجْرٌ':Added, #1: 1	قَالَ الْأَجْرُ
u'قَالَ أَجَلٌ':Subject, #1: 1	قَالَ أَجْرِهِ
u'قَالَ أجْمَع':Predicate, #1: 1	قَالَ الْأَجَلُ
u'قَالَ أجْمَع':Subject, #1: 1	قَالَ أَجْمَعَ
u'قَالَ أَجْنَبِيٌّ':Subject, #1: 1	قَالَ أَجْمَعُ
u'قَالَ أَجْنَبِيٌّ':Subject, #11: 11	قَالَ الْأَجْنَبِيُّ
u'قَالَ أَجِيرٌ':Subject, #7: 7	قَالَ أَجْنَبِيٌّ
u'قَالَ أَحادِيثُ':Subject, #3: 3	قَالَ الْأَجِيرُ
u'قَالَ أَحادِيثُ':Subject, #1: 1	قَالَ الأَحَادِيثُ
u'قَالَ أحَدٌ':Predicate, #1: 1	قَالَ الْأَحَادِيثُ
u'قَالَ أحَدٌ':Subject, #5: 5	قَالَ أَحَدَ
u'قَالَ أحَدٌ':Subject, #16: 16	قَالَ أَحَدٌ
u'قَالَ أحَدٌ':Subject, #1: 1	أَقَالَ أَحَدُ
u'قَالَ إِحْرَامٌ':Subject, #39: 39	قَالَ أَحَدُ
u'قَالَ أَحْسَنُ':Predicate, #1: 1	قَالَ الْإِحْرَامُ
u'قَالَ أَحْسَنُ':Subject, #1: 1	قَالَ أَحْسَنَ
u'قَالَ أَحْسَنُ':Subject, #1: 1	قَالَ الْأَحْسَنُ
u'قَالَ أَحَقُّ':Subject, #3: 3	قَالَ أَحْسَنُ
u'قَالَ أحْمَق':Subject, #3: 3	قَالَ أَحَقُّ
u'قَالَ أَحْنَف':Subject, #1: 1	قَالَ أَحْمَقُ
u'قَالَ أَحْنَف':Subject, #1: 1	قَالَ الأَحْنَفُ
u'قَالَ أَخٌ':Subject, #4: 4	قَالَ الْأَحْنَفُ
u'قَالَ أَخْبَثٌ':Predicate, #2: 2	قَالَ أَخٌ
u'قَالَ اِخْتِيَارٌ':Subject, #1: 1	قَالَ أَخْبَثَ
u'قَالَ آخِرُ':Predicate, #1: 1	قَالَ اخْتِيَارُ
u'قَالَ آخِرُ':Subject, #5: 5	قَالَ آخِرَ
u'قَالَ إِخْوَةٌ':Subject, #11: 11	قَالَ آخِرُ
u'قَالَ آدَمُ':Subject, #2: 2	قَالَ إخْوَةُ
u'قَالَ آدَمِيٌّ':Subject, #2: 2	قَالَ آدَمُ
u'قَالَ أَدِيبٌ':Subject, #2: 2	قَالَ الْآدَمِيُّ
u'قَالَ أَذَانٌ':Subject, #1: 1	قَالَ الْأَدِيبُ
u'قَالَ أرْبَابٌ':Subject, #1: 1	قَالَ الْأَذَانُ
u'قَالَ أرْبَابٌ':Subject, #1: 1	قَالَ أَرْبَابُ
u'قَالَ أَرْبَعُ':Predicate, #1: 1	قَالَ الْأَرْبَابُ
u'قَالَ أَرْبَعَةٌ':Subject, #1: 1	قَالَ أَرْبَعَ
u'قَالَ أَرْبَعَةٌ':Subject, #1: 1	قَالَ الأَرْبَعَةُ
u'قَالَ أَرْبَعَةٌ':Subject, #1: 1	قَالَ الْأَرْبَعَةُ
u'قَالَ أَرْبَعَةٌ':Subject, #2: 2	قَالَ أَرْبَعَةٌ
u'قَالٌ أَرْبَعَةٌ':Added, #3: 3	قَالَ أَرْبَعَةُ
u'قَالَ إِرْسَالٌ':Subject, #1: 1	قَالَ أَرْبَعَةٍ
u'قَالَ أرْضٌ':Subject, #1: 1	قَالَ إرْسَالُ
u'قَالَ أَرْواحٌ':Subject, #2: 2	قَالَ أَرْضُ
u'قَالَ أَرْواحٌ':Subject, #1: 1	قَالَ أَرْوَاحُ
u'قَالَ إِزَارٌ':Subject, #1: 1	قَالَ الْأَرْوَاحُ
u'قَالَ أَزْرَق':Subject, #1: 1	قَالَ الْإِزَارُ
u'قَالَ أَساطيرُ':Subject, #4: 4	قَالَ الْأَزْرَقُ
u'قَالَ أُسْتَاذٌ':Subject, #2: 2	قَالَ أَسَاطِيرُ
u'قَالَ أُسْتَاذٌ':Subject, #1: 1	قَالَ الأُسْتَاذُ
u'قَالَ اِسْتِدْلاَلٌ':Subject, #87: 87	قَالَ الْأُسْتَاذُ
u'قَالَ اِسْتِعْمالٌ':Subject, #1: 1	قَالَ الاِسْتِدْلاَلُ
u'قَالَ أَسَدٌ':Subject, #1: 1	قَالَ اسْتِعْمَالُ
u'قَالَ إِسْكافٌ':Subject, #1: 1	قَالَ أَسَدٌ
u'قَالَ إِسْلامٌ':Subject, #3: 3	قَالَ الْإِسْكَافُ
u'قَالَ إِسْلامٌ':Subject, #1: 1	قَالَ الإِسْلاَمُ
u'قَالَ اِسْمٌ':Subject, #1: 1	قَالَ الْإِسْلَامُ
u'قَالَ إِسْنادٌ':Subject, #1: 1	قَالَ اسْمُ
u'قَالَ إِسْنادٌ':Subject, #1: 1	قَالَ إسْنَادٌ
u'قَالَ أسْوَد':Subject, #1: 1	قَالَ إسْنَادُهُ
u'قَالَ أَسيرٌ':Subject, #5: 5	قَالَ الأَسْوَدُ
u'قَالَ أَسيرٌ':Subject, #1: 1	قَالَ أَسِيرُ
u'قَالَ إشارَة':Predicate, #5: 5	قَالَ الْأَسِيرُ
u'قَالَ اِشْتِباهٌ':Subject, #1: 1	قَالَ الْإِشَارَةَ
u'قَالَ اِشْتِراطٌ':Subject, #1: 1	قَالَ اشْتِبَاهُ
u'قَالَ أَشْجَعُ':Subject, #1: 1	قَالَ اشْتِرَاطُ
u'قَالَ أَشَدُّ':Predicate, #1: 1	قَالَ أَشْجَعُ
u'قَالَ إِشْراكٌ':Subject, #1: 1	قَالَ أَشَدَّ
u'قَالَ أَشْعَث':Subject, #2: 2	قَالَ الْإِشْرَاكُ
u'قَالَ أَشْهَب':Subject, #1: 1	قَالَ الأَشْعَثُ
u'قَالَ أشْهَرُ':Subject, #113: 113	قَالَ أَشْهَبُ
u'قَالَ أَشْهُرٌ':Subject, #1: 1	قَالَ الْأَشْهَرُ
u'قَالَ أَشْيَاخٌ':Subject, #1: 1	قَالَ الْأَشْهُرُ
u'قَالَ أَصْحَابٌ':Subject, #1: 1	قَالَ الْأَشْيَاخُ
u'قَالَ أَصْحَابٌ':Subject, #11: 11	قَالَ أَصْحَابُهُ
u'قَالَ أَصْحَابٌ':Subject, #253: 253	قَالَ الْأَصْحَابُ
u'قَالَ أَصْدَقُ':Subject, #35: 35	قَالَ أَصْحَابُ
u'قَالَ أصْغَرٌ':Subject, #1: 1	قَالَ أَصْدَقُ
u'قَالَ أَصْغَرُ':Subject, #1: 1	قَالَ أَصْغَرُ
u'قَالَ أصل':Predicate, #1: 1	قَالَ أَصْغَرُ
u'قَالَ أًصْلٌ':Predicate, #1: 1	قَالَ الْأَصْلَ
u'قَالَ أصل':Subject, #1: 1	قَالَ الْأَصْلَ
u'قَالَ أًصْلٌ':Subject, #12: 12	قَالَ الْأَصْلُ
u'قَالَ أصل':Subject, #12: 12	قَالَ الْأَصْلُ
u'قَالَ أًصْلٌ':Subject, #1: 1	قَالَ أَصْلُهُ
u'قَالَ إِصْلاحٌ':Subject, #1: 1	قَالَ أَصْلُهُ
u'قَالٌ أصلان':Added, #2: 2	قَالَ إصْلَاحُ
u'قَالَ أَصْلَحُ':Predicate, #1: 1	قَالَ الْأَصْلَانِ
u'قَالَ أَصَمّ':Subject, #1: 1	قَالَ أَصْلَحَكَ
u'قَالَ أُصولٌ':Subject, #1: 1	قَالَ الْأَصَمُّ
u'قَالَ إِطْعامٌ':Subject, #4: 4	قَالَ الْأُصُولُ
u'قَالَ أظهر':Subject, #1: 1	قَالَ إطْعَامُ
u'قَالَ أعْرَابِيٌّ':Subject, #1: 1	قَالَ الْأَظْهَرُ
u'قَالَ أعْرَابِيٌّ':Subject, #2: 2	قَالَ الْأَعْرَابِيُّ
u'قَالَ أَعْلاَمٌ':Subject, #3: 3	قَالَ أَعْرَابِيٌّ
u'قَالَ أعْلَمُ':Subject, #1: 1	قَالَ أَعْلَامٌ
u'قَالَ أعْمَش':Subject, #4: 4	قَالَ أَعْلَمُ
u'قَالَ أعْمَش':Subject, #28: 28	قَالَ الأَعْمَشُ
u'قَالَ أَغْنِيَاء':Subject, #6: 6	قَالَ الْأَعْمَشُ
u'قَالَ اِفْتِتَاحٌ':Subject, #1: 1	قَالَ الْأَغْنِيَاءُ
u'قَالَ أفْضَلُ':Subject, #1: 1	قَالَ افْتِتَاحُ
u'قَالَ أفْضَلُ':Subject, #1: 1	قَالَ أَفْضَلُ
u'قَالَ إقالَةٌ':Subject, #2: 2	قَالَ الْأَفْضَلُ
u'قَالَ أقْبَحُ':Predicate, #1: 1	قَالَ الْإِقَالَةُ
u'قَالَ اِقْتِطاعٌ':Subject, #1: 1	قَالَ أَقْبَحَ
u'قَالَ إقْرَارٌ':Subject, #1: 1	قَالَ اقْتِطَاعُ
u'قَالَ أقْرَع':Subject, #1: 1	قَالَ إقْرَارُهُ
u'قَالَ أقَلُّ':Predicate, #3: 3	قَالَ الْأَقْرَعُ
u'قَالَ أقَلُّ':Subject, #2: 2	قَالَ أَقَلَّ
u'قَالَ أكَّارٌ':Subject, #1: 1	قَالَ الْأَقَلُّ
u'قَالَ أكْبَرُ':Subject, #1: 1	قَالَ الْأَكَّارُ
u'قَالَ أَكْثَرُ':Predicate, #4: 4	قَالَ أَكْبَرُ
u'قَالَ أَكْثَرُ':Subject, #1: 1	قَالَ أَكْثَرَ
u'قَالَ أَكْثَرُ':Subject, #13: 13	قَالَ الْأَكْثَرُ
u'قَالَ أَكْلٌ':Subject, #67: 67	قَالَ أَكْثَرُ
u'قَالَ أَكْمَلُ':Subject, #1: 1	قَالَ أَكْلٌ
u'قَالَ اِلْتِحَاقٌ':Subject, #10: 10	قَالَ الْأَكْمَلُ
u'قَالَ إلْغَاءٌ':Subject, #1: 1	قَالَ الْتِحَاقَاتُ
u'قَالَ ألف':Predicate, #1: 1	قَالَ إلْغَاءُ
u'قَالَ ألْفٌ':Predicate, #2: 2	قَالَ أَلْفَ
u'قَالَ أَلْفٌ':Predicate, #2: 2	قَالَ أَلْفَ
u'قَالَ ألف':Subject, #2: 2	قَالَ أَلْفَ
u'قَالَ ألْفٌ':Subject, #2: 2	قَالَ الْأَلْفُ
u'قَالَ أَلْفٌ':Subject, #2: 2	قَالَ الْأَلْفُ
u'قَالَ ألف':Subject, #2: 2	قَالَ الْأَلْفُ
u'قَالَ ألْفٌ':Subject, #2: 2	قَالَ أَلْفُ
u'قَالَ أَلْفٌ':Subject, #2: 2	قَالَ أَلْفُ
u'قَالَ ألْفٌ':Subject, #2: 2	قَالَ أَلْفُ
u'قَالَ أَلْفٌ':Subject, #3: 3	قَالَ أَلْفٌ
u'قَالٌ ألْفٌ':Added, #3: 3	قَالَ أَلْفٌ
u'قَالَ أَلْفَاظٌ':Subject, #2: 2	قَالَ أَلْفَيْنِ
u'قَالٌ ألْقٌ':Added, #1: 1	قَالَ أَلْفَاظُ
u'قَالَ اللَّهُمَّ':Predicate, #2: 2	قَالَ أَلْقِ
u'قَالَ الْمَرْءُ':Subject, #56: 56	قَالَ اللَّهُمَّ
u'قَالَ الْمَرْأَةُ':Subject, #1: 1	قَالَ الْمَرْءُ
u'قَالَ ألُوفٌ':Subject, #2: 2	قَالَ الْمَرْأَةُ
u'قَالَ ألُوفٌ':Subject, #1: 1	قَالَ أُلُوفٌ
u'قَالَ أُمٌّ':Subject, #1: 1	قَالَ أُلُوفُ
u'قَالَ أُمٌّ':Subject, #1: 1	قَالَ أُمُّهُ
u'قَالَ إمَامٌ':Predicate, #4: 4	قَالَ أُمُّ
u'قَالَ إمَامٌ':Subject, #1: 1	قَالَ الْإِمَامَ
u'قَالَ إمَامٌ':Subject, #107: 107	قَالَ إمَامُ
u'قَالَ إمَامٌ':Subject, #1: 1	قَالَ إمَامٌ
u'قَالَ إمَامٌ':Subject, #1: 1	قَالَ إمَامُهُ
u'قَالَ إمَامٌ':Subject, #59: 59	قَالَ الإِمَامُ
u'قَالٌ إمَامٌ':Added, #899: 899	قَالَ الْإِمَامُ
u'قَالَ أُمَّةٌ':Predicate, #2: 2	قَالَ الْإِمَامِ
u'قَالَ آمِرٌ':Subject, #1: 1	قَالَ أُمَّةَ
u'قَالَ أَمْرٌ':Subject, #10: 10	قَالَ الْآمِرُ
u'قَالَ أَمْرٌ':Subject, #1: 1	قَالَ أَمْرٌ
u'قَالَ أَمْرٌ':Subject, #5: 5	قَالَ الْأَمْرُ
u'قَالَ أمراء':Subject, #7: 7	قَالَ أَمْرُ
u'قَالَ أمراء':Subject, #1: 1	قَالَ الْأُمَرَاءُ
u'قَالَ اِمْرَأَةٌ':Subject, #3: 3	قَالَ أُمَرَاءُ
u'قَالَ اِمْرَأَةٌ':Subject, #19: 19	قَالَ امْرَأَتُهُ
u'قَالَ اِمْرَأَةٌ':Subject, #4: 4	قَالَ امْرَأَةُ
u'قَالَ اِمْرُؤٌ':Subject, #7: 7	قَالَ امْرَأَةٌ
u'قَالٌ أَمْس':Added, #8: 8	قَالَ امْرُؤُ
u'قَالَ أَمْوَالٌ':Subject, #3: 3	قَالَ أَمْسِ
u'قَالَ أُمُورٌ':Subject, #3: 3	قَالَ أَمْوَالٌ
u'قَالَ أُمُورٌ':Subject, #1: 1	قَالَ أُمُورٌ
u'قَالَ أُمِّيٌّ':Subject, #1: 1	قَالَ أُمُورُ
u'قَالَ أَميرٌ':Subject, #1: 1	قَالَ الْأُمِّيُّ
u'قَالَ أَميرٌ':Subject, #1: 1	قَالَ الأَمِيرُ
u'قَالَ أَميرٌ':Subject, #39: 39	قَالَ الْأَمِيرُ
u'قَالَ أَمينٌ':Subject, #7: 7	قَالَ أَمِيرُ
u'قَالَ أَمينٌ':Subject, #1: 1	قَالَ أَمِينُهُ
u'قَالَ أنبياء':Subject, #2: 2	قَالَ الْأَمِينُ
u'قَالَ أنبياء':Subject, #1: 1	قَالَ الأَنْبِيَاءُ
u'قَالَ إِنْسانٌ':Subject, #2: 2	قَالَ الْأَنْبِيَاءُ
u'قَالَ إِنْسانٌ':Subject, #2: 2	قَالَ الْإِنْسَانُ
u'قَالَ إِنْسانٌ':Subject, #3: 3	قَالَ إِنْسَانٌ
u'قَالَ أنصار':Subject, #6: 6	قَالَ إنْسَانٌ
u'قَالَ أَنْصارٌ':Subject, #2: 2	قَالَ الْأَنْصَارُ
u'قَالَ أَنْصَارٌ':Subject, #2: 2	قَالَ الْأَنْصَارُ
u'قَالَ أهْلٌ':Subject, #2: 2	قَالَ الْأَنْصَارُ
u'قَالٌ أهْوَازٌ':Added, #89: 89	قَالَ أَهْلُ
u'قَالَ أوْجَهُ':Subject, #1: 1	قَالَ الأَهْوَازِ
u'قَالَ أوْسَطُ':Subject, #3: 3	قَالَ الْأَوْجَهُ
u'قَالَ أَوَّلُ':Predicate, #1: 1	قَالَ أَوْسَطُ
u'قَالَ أَوَّلُ':Subject, #7: 7	قَالَ أَوَّلَ
u'قَالَ أَوَّلُ':Subject, #1: 1	قَالَ الأَوَّلُ
u'قَالَ أَوَّلُ':Subject, #20: 20	قَالَ الْأَوَّلُ
u'قَالَ أَوَّلُ':Subject, #30: 30	قَالَ أَوَّلُ
u'قَالَ أَوَّلُ':Subject, #3: 3	قَالَ الْأَوّلُ
u'قَالَ أَوْلاَدٌ':Subject, #6: 6	قَالَ أَوّلُ
u'قَالَ أئِمَّةٌ':Subject, #1: 1	قَالَ أَوْلَادُ
u'قَالَ أئِمَّةٌ':Subject, #1: 1	قَالَ أَئِمَّةٌ
u'قَالَ أئِمَّةٌ':Subject, #27: 27	قَالَ الْأَئِمَّةُ
u'قَالَ أيَّامٌ':Subject, #6: 6	قَالَ أَئِمَّةُ
u'قَالَ أَيَّامٌ':Subject, #1: 1	قَالَ الْأَيَّامُ
u'قَالَ آيَةٌ':Subject, #1: 1	قَالَ الْأَيَّامُ
u'قَالَ آيَةٌ':Subject, #1: 1	قَالَ آيَةٌ
u'قَالَ إِيجَابٌ':Subject, #1: 1	قَالَ آيَةُ
u'قَالٌ أَيْسَرُ':Added, #1: 1	قَالَ إيجَابُ
u'قَالَ أَيْمَانٌ':Predicate, #1: 1	قَالَ الْأَيْسَرِ
u'قَالَ أَيْمَانٌ':Subject, #1: 1	قَالَ أَيْمَانَ
u'قَالَ إيمَانٌ':Subject, #1: 1	قَالَ الْأَيْمَانُ
u'قَالَ إيمَانٌ':Subject, #1: 1	قَالَ إيمَانٌ
u'قَالَ أَيْمَانٌ':Subject, #3: 3	قَالَ الْإِيمَانُ
u'قَالَ أَيْنٌ':Predicate, #3: 3	قَالَ أَيْمَانُ
u'قَالَ بَابٌ':Subject, #13: 13	قَالَ أَيْنَ
u'قَالَ بادِئٌ':Subject, #3: 3	قَالَ بَابُ
u'قَالَ بَاطِلٌ':Subject, #1: 1	قَالَ الْبَادِئُ
u'قَالَ بَاطن':Subject, #1: 1	قَالَ بَاطِلٌ
u'قَالَ باطِنٌ':Subject, #1: 1	قَالَ بَاطِنُ
u'قَالَ بَاعٌ':Predicate, #1: 1	قَالَ بَاطِنُ
u'قَالَ بالِغٌ':Subject, #5: 5	قَالَ بَاعَ
u'قَالَ بَائِعٌ':Subject, #5: 5	قَالَ الْبَالِغُ
u'قَالَ بَائِعٌ':Subject, #148: 148	قَالَ الْبَائِعُ
u'قَالَ بَائِعٌ':Subject, #1: 1	قَالَ بَائِعُهُ
u'قَالَ بَائِعٌ':Subject, #3: 3	أَقَالَ الْبَائِعُ
u'قَالَ بَتِّيّ':Subject, #4: 4	قَالَ بَائِعُ
u'قَالَ بُحْتُرِيّ':Subject, #1: 1	قَالَ الْبَتِّيُّ
u'قَالَ بُخَارِيٌّ':Subject, #4: 4	قَالَ الْبُحْتُرِيُّ
u'قَالَ بَدْءٌ':Subject, #80: 80	قَالَ الْبُخَارِيُّ
u'قَالَ بَدْرٌ':Subject, #1: 1	قَالَ بَدْءُ
u'قَالَ بَدْرٌ':Subject, #1: 1	قَالَ بَدْرٌ
u'قَالَ بَدْرٌ':Subject, #4: 4	قَالَ بَدْرُ
u'قَالَ بَدَلٌ':Predicate, #5: 5	قَالَ الْبَدْرُ
u'قَالَ بَدَلٌ':Subject, #21: 21	قَالَ بَدَلَ
u'قَالَ بَدَلٌ':Subject, #1: 1	قَالَ بَدَلٌ
u'قَالَ بدنة':Subject, #1: 1	قَالَ بَدَلُ
u'قَالَ بَدِيعٌ':Subject, #1: 1	قَالَ الْبَدَنَةُ
u'قَالَ بِرٌّ':Predicate, #3: 3	قَالَ بَدِيعُ
u'قَالَ بِرٌّ':Subject, #1: 1	قَالَ الْبِرَّ
u'قَالَ براءٌ':Subject, #2: 2	قَالَ الْبِرُّ
u'قَالَ بَراءٌ':Subject, #8: 8	قَالَ الْبَرَاءُ
u'قَالَ بَرَكَةٌ':Subject, #8: 8	قَالَ الْبَرَاءُ
u'قَالَ بُرْهانٌ':Subject, #1: 1	قَالَ بَرَكَاتُ
u'قَالَ بُرْهَانٌ':Subject, #1: 1	قَالَ بُرْهَانٌ
u'قَالَ بُرْهانٌ':Subject, #1: 1	قَالَ بُرْهَانٌ
u'قَالَ بُرْهَانٌ':Subject, #4: 4	قَالَ بُرْهَانُ
u'قَالَ بُرْهانٌ':Subject, #4: 4	قَالَ بُرْهَانُ
u'قَالَ بُرْهَانٌ':Subject, #5: 5	قَالَ الْبُرْهَانُ
u'قَالَ بَرِيَّةٌ':Subject, #5: 5	قَالَ الْبُرْهَانُ
u'قَالَ بَزَّارٌ':Subject, #1: 1	قَالَ بَرِيَّةٌ
u'قَالَ بَزَّارٌ':Subject, #2: 2	قَالَ الْبَزّارُ
u'قَالَ بُسْرٌ':Subject, #44: 44	قَالَ الْبَزَّارُ
u'قَالَ بِشْرٌ':Subject, #6: 6	قَالَ بُسْرٌ
u'قَالَ بِشْرٌ':Subject, #16: 16	قَالَ بِشْرٌ
u'قَالَ بصراء':Subject, #3: 3	قَالَ بِشْرُ
u'قَالَ بِضْعٌ':Predicate, #1: 1	قَالَ الْبُصَرَاءُ
u'قَالَ بِضْعٌ':Subject, #1: 1	قَالَ بِضْعَةَ
u'قَالَ بِطانَةٌ':Subject, #1: 1	قَالَ بِضْعٌ
u'قَالَ بَطَلٌ':Predicate, #1: 1	قَالَ بِطَانَةُ
u'قَالَ بعثة':Subject, #1: 1	قَالَ بَطَلَ
u'قَالَ بَعْضٌ':Predicate, #1: 1	قَالَ بَعَثْتُهُ
u'قَالَ بَعْضٌ':Subject, #2: 2	قَالَ بَعْضَ
u'قَالَ بَعْضٌ':Subject, #1: 1	قَالَ بَعْضُهُ
u'قَالَ بَعْضٌ':Subject, #23: 23	قَالَ بَعْضٌ
u'قَالَ بَعْضٌ':Subject, #3: 3	قَالَ الْبَعْضُ
u'قَالٌ بَعْضٌ':Added, #986: 986	قَالَ بَعْضُ
u'قَالَ بَقّار':Subject, #2: 2	قَالَ بَعْضِ
u'قَالَ بَقِيَّةٌ':Subject, #1: 1	قَالَ الْبَقَّارُ
u'قَالَ بله':Subject, #4: 4	قَالَ بَقِيَّةُ
u'قَالَ بِنَاءٌ':Subject, #1: 1	قَالَ بِلَهُ
u'قَالَ بِنْتٌ':Subject, #6: 6	قَالَ بِنَاءُ
u'قَالَ بَوْلٌ':Predicate, #1: 1	قَالَ بِنْتُ
u'قَالَ بَوْلٌ':Subject, #1: 1	قَالَ الْبَوْلَ
u'قَالَ بَوْنٌ':Subject, #1: 1	قَالَ الْبَوْلُ
u'قَالَ بِئْسٌ':Predicate, #1: 1	قَالَ بَوْنٌ
u'قَالَ بَيَاضٌ':Subject, #7: 7	قَالَ بِئْسَ
u'قَالَ بَيَّاعٌ':Subject, #1: 1	قَالَ بَيَاضُ
u'قَالَ بَيَانٌ':Subject, #1: 1	قَالَ الْبَيَّاعُ
u'قَالَ بَيْتٌ':Predicate, #1: 1	قَالَ بَيَانُ
u'قَالَ بَيْتٌ':Subject, #1: 1	قَالَ بَيْتَ
u'قَالٌ بَيْتٌ':Added, #2: 2	قَالَ الْبَيْتُ
u'قَالٌ بِيدٌ':Added, #1: 1	قَالَ بَيْتِ
u'قَالٌ بِيدٌ':Added, #1: 1	قَالَ بِيَدِ
u'قَالَ بَيْضاوِيّ':Subject, #8: 8	قَالَ بِيَدِهِ
u'قَالَ بَيْعٌ':Predicate, #10: 10	قَالَ الْبَيْضَاوِيُّ
u'قَالَ بَيْعٌ':Subject, #12: 12	أَقَالَ الْبَيْعَ
u'قَالَ بَيْعٌ':Subject, #3: 3	قَالَ بَيْعُ
u'قَالَ بَيْنٌ':Predicate, #5: 5	قَالَ الْبَيْعُ
u'قَالَ بَيْنٌ':Predicate, #13: 13	قَالَ بَيْنَ
u'قَالَ بَيِّنَةٌ':Subject, #8: 8	قَالَ بَيْنَكُنَّ
u'قَالَ تَابِعٌ':Subject, #1: 1	قَالَ الْبَيِّنَةُ
u'قَالَ تَابِعِيٌّ':Subject, #1: 1	قَالَ تَابِعُ
u'قَالَ تَاجٌ':Subject, #3: 3	قَالَ التَّابِعِيُّ
u'قَالَ تَاجٌ':Subject, #14: 14	قَالَ التَّاجُ
u'قَالَ تَاجِرٌ':Subject, #16: 16	قَالَ تَاجُ
u'قَالَ تَبْرِيزِيّ':Subject, #2: 2	قَالَ التَّاجِرُ
u'قَالَ تَبْصِرَة':Subject, #3: 3	قَالَ التَّبْرِيزِيُّ
u'قَالَ تِبْنٌ':Subject, #1: 1	قَالَ التَّبْصِرَةُ
u'قَالَ تَثْنِيَةٌ':Subject, #1: 1	قَالَ تِبْنُ
u'قَالَ تِجَارَةٌ':Predicate, #1: 1	قَالَ تَثْنِيَةُ
u'قَالَ تِجَارَةٌ':Subject, #2: 2	قَالَ التِّجَارَةَ
u'قَالَ تَحْرِيمٌ':Subject, #1: 1	قَالَ التِّجَارَةُ
u'قَالَ تَحْقِيقٌ':Subject, #1: 1	قَالَ التَّحْرِيمُ
u'قَالَ تَحْكِيمٌ':Subject, #1: 1	قَالَ التَّحْقِيقُ
u'قَالَ تَحْلِيقٌ':Subject, #1: 1	قَالَ التَّحْكِيمُ
u'قَالَ تَرْكٌ':Subject, #1: 1	قَالَ التَّحْلِيقُ
u'قَالَ تِسْعَةٌ':Predicate, #2: 2	قَالَ تَرْكُ
u'قَالَ تِسْعَةٌ':Subject, #1: 1	قَالَ تِسْعَةَ
u'قَالَ تَسْلِيم':Predicate, #1: 1	قَالَ تِسْعَةُ
u'قَالَ تَسْمِيَة':Subject, #1: 1	قَالَ تَسْلِيمَةً
u'قَالَ تَصْحِيحٌ':Subject, #1: 1	قَالَ تَسْمِيَةُ
u'قَالَ تَصَرُّفٌ':Subject, #1: 1	قَالَ تَصْحِيحُ
u'قَالَ تَصَرُّفٌ':Subject, #1: 1	قَالَ تَصَرُّفَاتُ
u'قَالَ تَعْرِيضٌ':Subject, #2: 2	قَالَ تَصَرُّفُ
u'قَالَ تَعْزِير':Subject, #1: 1	قَالَ التَّعْرِيضُ
u'قَالَ تَعْلِيقٌ':Subject, #1: 1	قَالَ التَّعْزِيرُ
u'قَالَ تَعْلِيمٌ':Subject, #3: 3	قَالَ التَّعْلِيقُ
u'قَالَ تَفاوُت':Subject, #1: 1	قَالَ التَّعْلِيمُ
u'قَالَ تَفْسِيرٌ':Subject, #1: 1	قَالَ التَّفَاوُتُ
u'قَالَ تَفْسِيرٌ':Subject, #1: 1	قَالَ تَفْسِيرُ
u'قَالَ تَفْصِيلٌ':Subject, #1: 1	قَالَ تَفْسِيرُهُ
u'قَالَ تَقابُض':Subject, #1: 1	قَالَ التَّفْصِيلُ
u'قَالَ تَقِيٌّ':Subject, #1: 1	قَالَ التَّقَابُضُ
u'قَالَ تَقِيٌّ':Subject, #1: 1	قَالَ التَّقِيُّ
u'قَالَ تَكْبِير':Subject, #2: 2	قَالَ تَقِيُّ
u'قَالَ تَكْبيرٌ':Subject, #1: 1	قَالَ تَكْبِيرَةُ
u'قَالَ تَكْرارٌ':Subject, #2: 2	قَالَ التَّكْبِيرُ
u'قَالَ تَكَلُّمٌ':Predicate, #1: 1	قَالَ التَّكْرَارُ
u'قَالَ تِلِمْسانِيّ':Subject, #1: 1	قَالَ تَكَلّمَ
u'قَالَ تِلْميذٌ':Subject, #1: 1	قَالَ التِّلِمْسَانِيُّ
u'قَالَ تِلْميذٌ':Subject, #2: 2	قَالَ تِلْمِيذُ
u'قَالَ تَمٌّ':Predicate, #5: 5	قَالَ تِلْمِيذُهُ
u'قَالَ تمام':Predicate, #1: 1	قَالَ تَمَّ
u'قَالَ تَمامٌ':Predicate, #1: 1	قَالَ تَمَامَ
u'قَالَ تمام':Subject, #1: 1	قَالَ تَمَامَ
u'قَالَ تَمامٌ':Subject, #1: 1	قَالَ تَمَامُ
u'قَالَ تَمَتُّعٌ':Predicate, #1: 1	قَالَ تَمَامُ
u'قَالَ تِمْثالٌ':Subject, #1: 1	قَالَ تَمَتّعَ
u'قَالَ تَمْرَةٌ':Subject, #1: 1	قَالَ التِّمْثَالُ
u'قَالَ تَمْلِيكٌ':Subject, #2: 2	قَالَ تَمْرَةٌ
u'قَالَ تَنْبِيهٌ':Subject, #1: 1	قَالَ تَمْلِيكُ
u'قَالَ تَنَحْنُحٌ':Subject, #1: 1	قَالَ تَنْبِيهٌ
u'قَالَ تَنَصُّفٌ':Subject, #1: 1	قَالَ التَّنَحْنُحُ
u'قَالَ تونِسِيّ':Subject, #1: 1	قَالَ تَنَصُّفُ
u'قَالَ تَيَمُّمٌ':Subject, #4: 4	قَالَ التُّونِسِيُّ
u'قَالَ ثَابِتٌ':Subject, #2: 2	قَالَ التَّيَمُّمُ
u'قَالَ ثَالِثٌ':Predicate, #20: 20	قَالَ ثَابِتٌ
u'قَالَ ثَالِثٌ':Subject, #2: 2	قَالَ الثَّالِثَةَ
u'قَالَ ثَالِثٌ':Subject, #1: 1	قَالَ الثّالِثُ
u'قَالَ ثَالِثٌ':Subject, #1: 1	قَالَ الثَّالِثَةُ
u'قَالَ ثَانِي':Predicate, #5: 5	قَالَ الثَّالِثُ
u'قَالَ ثَانِي':Subject, #1: 1	قَالَ الثَّانِيَةَ
u'قَالَ ثَانِيَةٌ':Predicate, #2: 2	قَالَ الثَّانِيَةُ
u'قَالَ ثَانِيَةٌ':Subject, #1: 1	قَالَ الثَّانِيَةَ
u'قَالَ ثَعْلَبٌ':Subject, #2: 2	قَالَ الثَّانِيَةُ
u'قَالَ ثَعْلَبٌ':Subject, #1: 1	قَالَ الثَّعْلَبُ
u'قَالَ ثَعْلَبٌ':Subject, #3: 3	قَالَ ثَعْلَبُ
u'قَالَ ثِقَة':Subject, #8: 8	قَالَ ثَعْلَبٌ
u'قَالَ ثِقَة':Subject, #1: 1	قَالَ ثِقَاتٌ
u'قَالَ ثَلاثُ':Predicate, #1: 1	قَالَ ثِقَاتُ
u'قَالَ ثَلاثُ':Predicate, #1: 1	قَالَ الثَّلَاثَ
u'قَالَ ثَلاثُ':Predicate, #1: 1	قَالَ ثَلاثَ
u'قَالَ ثَلاثُ':Predicate, #1: 1	قَالَ ثَلاَثَ
u'قَالَ ثَلاثُ':Subject, #6: 6	قَالَ ثَلَاثَ
u'قَالَ ثَلاثَةٌ':Predicate, #4: 4	قَالَ ثَلَاثُ
u'قَالَ ثَلاثَةٌ':Predicate, #11: 11	قَالَ ثَلَاثَةَ
u'قَالَ ثَلاثَةٌ':Predicate, #1: 1	أَقَالَ ثَلاَثَةَ
u'قَالَ ثَلاثَةٌ':Subject, #1: 1	قَالَ ثَلاَثَةَ
u'قَالَ ثَلاثَةٌ':Subject, #1: 1	قَالَ ثَلاَثَةُ
u'قَالَ ثَلاثَةٌ':Subject, #2: 2	قَالَ الثَّلَاثَةُ
u'قَالَ ثَلاثَةٌ':Subject, #2: 2	قَالَ ثَلَاثَةٌ
u'قَالَ ثَمانِيَةٌ':Subject, #3: 3	قَالَ ثَلَاثَةُ
u'قَالَ ثَمَرَةٌ':Subject, #3: 3	قَالَ ثَمَانِيَةُ
u'قَالَ ثَمَنٌ':Subject, #1: 1	قَالَ الثَّمَرَةُ
u'قَالَ ثَمَنٌ':Subject, #1: 1	قَالَ ثَمَنُهُ
u'قَالَ ثَوْبٌ':Subject, #3: 3	قَالَ ثَمَنُ
u'قَالَ ثَوْرٌ':Subject, #5: 5	قَالَ ثَوْبٌ
u'قَالَ ثَوْرٌ':Subject, #1: 1	قَالَ ثَوْرٌ
u'قَالَ ثَوْرِيٌّ':Subject, #1: 1	قَالَ ثَوْرُ
u'قَالَ جَابِرٌ':Subject, #9: 9	قَالَ الثَّوْرِيُّ
u'قَالَ جَابِرٌ':Subject, #66: 66	قَالَ جَابِرٌ
u'قَالَ جاَحِظٌ':Subject, #8: 8	قَالَ جَابِرُ
u'قَالَ جَارٌ':Subject, #8: 8	قَالَ الْجَاحِظُ
u'قَالَ جَارِي':Predicate, #1: 1	قَالَ جَارُ
u'قَالَ جَارِي':Subject, #1: 1	قَالَ جَارِيَةً
u'قَالَ جَارِي':Subject, #1: 1	قَالَ الْجَارِيَةُ
u'قَالَ جَارِيَةٌ':Subject, #3: 3	قَالَ جَارِيَةٌ
u'قَالَ جَارِيَةٌ':Subject, #1: 1	قَالَ الْجَارِيَةُ
u'قَالَ جَازٌ':Predicate, #3: 3	قَالَ جَارِيَةٌ
u'قَالَ جَامِعٌ':Subject, #3: 3	قَالَ جَازَ
u'قَالَ جَاهِلٌ':Subject, #1: 1	قَالَ جَامِعُ
u'قَالَ جَائِزٌ':Subject, #1: 1	قَالَ الْجَاهِلَةُ
u'قَالَ جَبَلِيٌّ':Subject, #3: 3	قَالَ جَائِزٌ
u'قَالَ جِرَاحَةٌ':Subject, #3: 3	قَالَ الْجَبَلِيُّ
u'قَالَ جَرِيرٌ':Subject, #1: 1	قَالَ جِرَاحَتُهُ
u'قَالَ جَرِيرٌ':Subject, #13: 13	قَالَ جَرِيرُ
u'قَالَ جُزْءٌ':Subject, #24: 24	قَالَ جَرِيرٌ
u'قَالَ جَسَدٌ':Predicate, #1: 1	قَالَ جُزْءٌ
u'قَالَ جَصَّاصٌ':Subject, #1: 1	قَالَ الْجَسَدَ
u'قَالَ جَلٌّ':Predicate, #5: 5	قَالَ الْجَصَّاصُ
u'قَالَ جَلّاب':Subject, #2: 2	قَالَ جَلَّ
u'قَالَ جَلاَلٌ':Subject, #2: 2	قَالَ الْجَلَّابُ
u'قَالَ جَلاَلٌ':Subject, #13: 13	قَالَ جَلَالُ
u'قَالٌ جلد':Added, #51: 51	قَالَ الْجَلَالُ
u'قَالٌ جِلْدٌ':Added, #1: 1	قَالَ الْجِلْدِ
u'قَالَ جلسة':Subject, #1: 1	قَالَ الْجِلْدِ
u'قَالَ جِلْسَةٌ':Subject, #1: 1	قَالَ الْجِلْسَةُ
u'قَالَ جَمَاعَةٌ':Subject, #1: 1	قَالَ الْجِلْسَةُ
u'قَالَ جَمَاعَةٌ':Subject, #1: 1	قَالَ الْجَمَاعَةُ
u'قَالٌ جَمَاعَةٌ':Added, #247: 247	قَالَ جَمَاعَةٌ
u'قَالَ جَمَّالٌ':Subject, #3: 3	قَالَ جَمَاعَةٍ
u'قَالَ جَمَالٌ':Subject, #1: 1	قَالَ الْجَمَّالُ
u'قَالَ جَمَاهِيرُ':Subject, #1: 1	قَالَ جَمَالُ
u'قَالَ جمع':Predicate, #2: 2	قَالَ جَمَاهِيرُ
u'قَالَ جَمْعٌ':Subject, #1: 1	قَالَ جَمَعَ
u'قَالَ جمع':Subject, #18: 18	قَالَ جَمْعٌ
u'قَالَ جُمَعٌ':Subject, #1: 1	قَالَ جُمَعُ
u'قَالٌ جمع':Added, #1: 1	قَالَ جُمَعُ
u'قَالٌ جُمَعٌ':Added, #1: 1	قَالَ جُمَعِ
u'قَالَ جمعة':Predicate, #1: 1	قَالَ جُمَعِ
u'قَالَ جُمُعَةٌ':Predicate, #1: 1	قَالَ الْجُمُعَةَ
u'قَالَ جُمْلَةٌ':Subject, #1: 1	قَالَ الْجُمُعَةَ
u'قَالَ جُمْهُورٌ':Subject, #1: 1	قَالَ جُمْلَةُ
u'قَالَ جُمْهُورٌ':Subject, #19: 19	قَالَ جُمْهُورُ
u'قَالٌ جُمْهُورٌ':Added, #25: 25	قَالَ الْجُمْهُورُ
u'قَالٌ جُمْهُورٌ':Added, #1: 1	قَالَ الْجُمْهُورِ
u'قَالَ جَنْبٌ':Subject, #1: 1	قَالَ جُمْهُورِ
u'قَالَ جَنَّةٌ':Subject, #1: 1	قَالَ الْجَنْبُ
u'قَالَ جَنَّةٌ':Subject, #1: 1	قَالَ الْجَنّةُ
u'قَالَ جُنْدُبٌ':Subject, #1: 1	قَالَ جَنَّةُ
u'قَالَ جِنْسٌ':Subject, #1: 1	قَالَ جُنْدُبٌ
u'قَالَ جِنْسٌ':Subject, #1: 1	قَالَ جِنْسٌ
u'قَالَ جهاد':Subject, #1: 1	قَالَ جِنْسُ
u'قَالَ جِهَادٌ':Subject, #1: 1	قَالَ الْجِهَادُ
u'قَالَ جَهالَة':Subject, #1: 1	قَالَ الْجِهَادُ
u'قَالَ جِهَةٌ':Subject, #1: 1	قَالَ الْجَهَالَةُ
u'قَالَ جُهْدٌ':Subject, #2: 2	قَالَ الْجِهَةُ
u'قَالَ جَوَابٌ':Subject, #1: 1	قَالَ جُهْدُ
u'قَالَ جَوَابٌ':Subject, #1: 1	قَالَ جَوَابٌ
u'قَالَ جَوَابٌ':Subject, #3: 3	قَالَ جَوَابُ
u'قَالَ جَوْنٌ':Subject, #5: 5	قَالَ الْجَوَابُ
u'قَالَ جَوْهَرِيٌّ':Subject, #1: 1	قَالَ الْجَوْنُ
u'قَالَ حارٌّ':Subject, #61: 61	قَالَ الْجَوْهَرِيُّ
u'قَالَ حارِثٌ':Subject, #1: 1	قَالَ حَارٌّ
u'قَالَ حارِثٌ':Subject, #19: 19	قَالَ الْحَارِثُ
u'قَالَ حاسِبٌ':Subject, #1: 1	قَالَ حَارِثَةُ
u'قَالَ حاضِرٌ':Subject, #1: 1	قَالَ الْحَاسِبُ
u'قَالَ حاضِرٌ':Subject, #1: 1	قَالَ الْحَاضِرُ
u'قَالَ حافِظٌ':Subject, #1: 1	قَالَ حَاضِرٌ
u'قَالَ حافِظٌ':Subject, #1: 1	قَالَ حَافِظُ
u'قَالَ حاكِمٌ':Subject, #80: 80	قَالَ الْحَافِظُ
u'قَالَ حاكِمٌ':Subject, #135: 135	قَالَ الْحَاكِمُ
u'قَالَ حالٌ':Predicate, #1: 1	قَالَ حَاكِمٌ
u'قَالَ حالَةٌ':Predicate, #2: 2	قَالَ حَالَ
u'قَالَ حالَةٌ':Subject, #4: 4	قَالَ حَالَةَ
u'قَالَ حامِلٌ':Subject, #1: 1	قَالَ الْحَالَةُ
u'قَالَ حامِلٌ':Subject, #1: 1	قَالَ الْحَامِلُ
u'قَالَ حانوتِيٌّ':Subject, #1: 1	قَالَ حَامِلٌ
u'قَالَ حائِطٌ':Subject, #1: 1	قَالَ الْحَانُوتِيُّ
u'قَالَ حُبٌّ':Subject, #1: 1	قَالَ الْحَائِطُ
u'قَالَ حَبٌّ':Subject, #1: 1	قَالَ حُبُّ
u'قَالَ حَبَّةٌ':Subject, #1: 1	قَالَ حَبَّةُ
u'قَالَ حَبْرٌ':Subject, #1: 1	قَالَ حَبَّةُ
u'قَالَ حَبْسٌ':Subject, #1: 1	قَالَ حَبْرُ
u'قَالَ حبلة':Predicate, #5: 5	قَالَ حَبْسٌ
u'قَالَ حَبيبٌ':Subject, #1: 1	قَالَ الْحَبَلَةَ
u'قَالَ حَجٌّ':Predicate, #3: 3	قَالَ حَبِيبُ
u'قَالَ حَجٌّ':Subject, #2: 2	قَالَ حَجَّ
u'قَالَ حَجٌّ':Subject, #1: 1	قَالَ حَجٌّ
u'قَالَ حُجَّةٌ':Subject, #2: 2	قَالَ الْحَجُّ
u'قَالَ حِجَّةٌ':Subject, #1: 1	قَالَ حُجَّةُ
u'قَالَ حُجَّةٌ':Subject, #1: 1	قَالَ حِجَّةٌ
u'قَالَ حَجَرٌ':Predicate, #2: 2	قَالَ الْحُجَّةُ
u'قَالَ حَدَّادٌ':Subject, #1: 1	قَالَ حَجَرَ
u'قَالَ حُدودٌ':Subject, #1: 1	قَالَ الْحَدَّادُ
u'قَالَ حَديثٌ':Subject, #1: 1	قَالَ حُدُودٌ
u'قَالَ حَديثٌ':Subject, #10: 10	قَالَ حَدِيثُ
u'قَالَ حَديثٌ':Subject, #1: 1	قَالَ الْحَدِيثُ
u'قَالَ حُذَّاقٌ':Subject, #4: 4	قَالَ حَدِيثٌ
u'قَالَ حُرٌّ':Subject, #1: 1	قَالَ الْحُذَّاقُ
u'قَالَ حُرٌّ':Subject, #3: 3	قَالَ الْحُرُّ
u'قَالَ حَرْبٌ':Subject, #3: 3	قَالَ حُرٌّ
u'قَالَ حَرْبٌ':Subject, #1: 1	قَالَ حَرْبُ
u'قَالَ حُرْمَةٌ':Subject, #9: 9	قَالَ حَرْبٌ
u'قَالَ حَرْمَلَة':Subject, #1: 1	قَالَ الْحُرْمَةُ
u'قَالَ حَرِيرِيٌّ':Subject, #4: 4	قَالَ حَرْمَلَةُ
u'قَالَ حسام':Subject, #2: 2	قَالَ الْحَرِيرِيُّ
u'قَالَ حُسَامٌ':Subject, #1: 1	قَالَ الْحُسَامُ
u'قَالَ حسام':Subject, #1: 1	قَالَ الْحُسَامُ
u'قَالَ حُسَامٌ':Subject, #1: 1	قَالَ حُسَامُ
u'قَالَ حَسَنٌ':Subject, #1: 1	قَالَ حُسَامُ
u'قَالَ حَسَنٌ':Subject, #130: 130	قَالَ الْحَسَنُ
u'قَالَ حَسَنٌ':Subject, #1: 1	قَالَ الْحَسَنَاتُ
u'قَالَ حَسَنٌ':Subject, #1: 1	قَالَ حَسَنَةٌ
u'قَالَ حُسْنٌ':Subject, #2: 2	قَالَ الْحَسَنَةُ
u'قَالَ حَسَنٌ':Subject, #2: 2	قَالَ حُسْنُ
u'قَالٌ حَسَنٌ':Added, #4: 4	قَالَ حَسَنٌ
u'قَالٌ حَسَنٌ':Added, #1: 1	قَالَ الْحَسَنِ
u'قَالَ حَسَنَةٌ':Subject, #1: 1	قَالَ حَسَنٍ
u'قَالَ حَسَنَةٌ':Subject, #1: 1	قَالَ الْحَسَنَاتُ
u'قَالَ حَسَنَةٌ':Subject, #1: 1	قَالَ حَسَنَةٌ
u'قَالَ حَشْوٌ':Subject, #2: 2	قَالَ الْحَسَنَةُ
u'قَالَ حِصَّةٌ':Subject, #1: 1	قَالَ حَشْوُهُ
u'قَالَ حِصْنٌ':Subject, #1: 1	قَالَ حِصَّةُ
u'قَالَ حَضَرٌ':Predicate, #1: 1	قَالَ حِصْنٌ
u'قَالَ حَضْرَمِيٌّ':Subject, #1: 1	قَالَ حَضَرَ
u'قَالَ حَطَّابٌ':Subject, #1: 1	قَالَ الْحَضْرَمِيُّ
u'قَالَ حَطَبٌ':Subject, #10: 10	قَالَ الْحَطَّابُ
u'قَالَ حُطَيْئَةٌ':Subject, #1: 1	قَالَ الْحَطَبُ
u'قَالَ حَفْصٌ':Subject, #4: 4	قَالَ الْحُطَيْئَةُ
u'قَالَ حَفْصٌ':Subject, #1: 1	قَالَ حَفْصُ
u'قَالَ حَفِيدٌ':Subject, #4: 4	قَالَ حَفْصٌ
u'قَالَ حَقٌّ':Predicate, #2: 2	قَالَ حَفِيدُهُ
u'قَالَ حَقٌّ':Subject, #1: 1	قَالَ الْحَقَّ
u'قَالَ حَقٌّ':Subject, #1: 1	قَالَ حَقُّ
u'قَالَ حَقٌّ':Subject, #1: 1	قَالَ حَقُّهُ
u'قَالَ حَقٌّ':Subject, #2: 2	قَالَ حَقٌّ
u'قَالَ حِكَايَةٌ':Predicate, #4: 4	قَالَ الْحَقُّ
u'قَالَ حَكَمٌ':Predicate, #1: 1	قَالَ حِكَايَةَ
u'قَالَ حَكَمٌ':Subject, #3: 3	قَالَ حَكَمَ
u'قَالَ حُكْمٌ':Subject, #11: 11	قَالَ الْحَكَمُ
u'قَالَ حُكْمٌ':Subject, #1: 1	قَالَ حُكْمٌ
u'قَالَ حُكْمٌ':Subject, #1: 1	قَالَ حُكْمُهُ
u'قَالَ حكماء':Subject, #2: 2	قَالَ الْحُكْمُ
u'قَالَ حكمة':Subject, #3: 3	قَالَ الْحُكَمَاءُ
u'قَالَ حِكْمَةٌ':Subject, #1: 1	قَالَ الْحِكْمَةُ
u'قَالَ حُكُومَةٌ':Subject, #1: 1	قَالَ الْحِكْمَةُ
u'قَالَ حَكِيمٌ':Subject, #1: 1	قَالَ حُكُومَةٌ
u'قَالَ حِلٌّ':Subject, #1: 1	قَالَ الْحَكِيمُ
u'قَالَ حَلالٌ':Subject, #1: 1	قَالَ الْحِلُّ
u'قَالَ حَلالٌ':Subject, #3: 3	قَالَ الْحَلَالُ
u'قَالَ حَلْقٌ':Subject, #5: 5	قَالَ حَلَالُ
u'قَالٌ حَلْقَةٌ':Added, #1: 1	قَالَ الْحَلْقُ
u'قَالَ حَلْوانِيٌّ':Subject, #1: 1	قَالَ حَلْقَةِ
u'قَالَ حِلْيَةٌ':Subject, #39: 39	قَالَ الْحَلْوَانِيُّ
u'قَالَ حَمَّادٌ':Subject, #1: 1	قَالَ الْحِلْيَةُ
u'قَالَ حِمَارٌ':Subject, #6: 6	قَالَ حَمَّادُ
u'قَالَ حِمَارٌ':Subject, #1: 1	قَالَ الْحِمَارُ
u'قَالَ حَمْدٌ':Subject, #1: 1	قَالَ حِمَارُ
u'قَالَ حمر':Subject, #19: 19	قَالَ الْحَمْدُ
u'قَالَ حَمْز':Subject, #1: 1	قَالَ حُمْرٌ
u'قَالَ حَمَلٌ':Subject, #5: 5	قَالَ حَمْزَةُ
u'قَالَ حَنْبَلٌ':Subject, #2: 2	قَالَ حَمَلُ
u'قَالَ حَنْبَلٌ':Subject, #13: 13	قَالَ حَنْبَلٌ
u'قَالَ حِنْطَةٌ':Predicate, #2: 2	قَالَ حَنْبَلُ
u'قَالَ حِنْطَةٌ':Subject, #1: 1	قَالَ الْحِنْطَةَ
u'قَالَ حِنْطَةٌ':Subject, #1: 1	قَالَ حِنْطَةٌ
u'قَالَ حَنْظَلٌ':Subject, #1: 1	قَالَ حِنْطَةُ
u'قَالَ حَنَفِيَّةٌ':Subject, #1: 1	قَالَ حَنْظَلَةُ
u'قَالَ حَنِيفٌ':Subject, #20: 20	قَالَ الْحَنَفِيَّةُ
u'قَالَ حَوَارِيٌّ':Subject, #1: 1	قَالَ الْحَنِيفَةُ
u'قَالَ حَوَالَةٌ':Subject, #1: 1	قَالَ الْحَوَارِيُّ
u'قَالَ حول':Predicate, #1: 1	قَالَ الْحَوَالَةُ
u'قَالَ حَوْلٌ':Predicate, #1: 1	قَالَ حَوْلاً
u'قَالَ حَيٌّ':Predicate, #1: 1	قَالَ حَوْلاً
u'قَالَ حَيٌّ':Subject, #5: 5	قَالَ حَيَّ
u'قَالَ حَيْضٌ':Subject, #2: 2	قَالَ الْحَيُّ
u'قَالَ حِيلَةٌ':Subject, #1: 1	قَالَ حَيْضُ
u'قَالَ خَابِيَةٌ':Subject, #3: 3	قَالَ الْحِيلَةُ
u'قَالَ خَاتِمٌ':Subject, #1: 1	قَالَ خَابِيَةُ
u'قَالَ خَاتِمَةٌ':Subject, #1: 1	قَالَ خَاتِمَةٌ
u'قَالَ خَارِجٌ':Subject, #1: 1	قَالَ خَاتِمَةٌ
u'قَالَ خَارِجٌ':Subject, #1: 1	قَالَ خَارِجَةُ
u'قَالَ خَاصِرَةٌ':Subject, #4: 4	قَالَ الْخَارِجُ
u'قَالَ خَاطِبٌ':Subject, #1: 1	قَالَ الْخَاصِرَةُ
u'قَالٌ خَالٌ':Added, #5: 5	قَالَ الْخَاطِبُ
u'قَالَ خَالِدٌ':Subject, #1: 1	قَالَ الْخَالِ
u'قَالَ خَالِدٌ':Subject, #25: 25	قَالَ خَالِدٌ
u'قَالٌ خَالِدٌ':Added, #7: 7	قَالَ خَالِدُ
u'قَالَ خامس':Subject, #1: 1	قَالَ خَالِدِ
u'قَالَ خَامِسٌ':Subject, #1: 1	قَالَ الْخَامِسُ
u'قَالٌ خِبَاءٌ':Added, #1: 1	قَالَ الْخَامِسُ
u'قَالَ خَبَّازٌ':Subject, #1: 1	قَالَ خِبَاءٍ
u'قَالَ خُبْزٌ':Subject, #1: 1	قَالَ الْخَبَّازُ
u'قَالَ خَبِيث':Predicate, #2: 2	قَالَ الْخُبْزُ
u'قَالَ خَتَنٌ':Subject, #1: 1	قَالَ خَبِيثَ
u'قَالَ خَدِيج':Subject, #1: 1	قَالَ الْخَتَنُ
u'قَالَ خُرْء':Subject, #1: 1	قَالَ خَدِيجَةُ
u'قَالَ خرق':Predicate, #1: 1	قَالَ خُرْءُ
u'قَالَ خَصْمٌ':Subject, #1: 1	قَالَ خَرَقَ
u'قَالَ خَصْمٌ':Subject, #10: 10	قَالَ الْخَصْمُ
u'قَالَ خُصُومَةٌ':Subject, #1: 1	قَالَ خَصْمُ
u'قَالَ خضر':Subject, #1: 1	قَالَ خُصُومَةُ
u'قَالَ خَضِرٌ':Subject, #1: 1	قَالَ الْخَضِرُ
u'قَالَ خُضْرَةٌ':Subject, #1: 1	قَالَ الْخَضِرُ
u'قَالَ خَطَأٌ':Subject, #1: 1	قَالَ الْخُضْرَةُ
u'قَالَ خَطَأٌ':Subject, #1: 1	قَالَ الْخَطَأُ
u'قَالَ خطباء':Subject, #1: 1	قَالَ خَطَأٌ
u'قَالَ خطر':Predicate, #2: 2	قَالَ خُطَبَاءُ
u'قَالَ خَطَرٌ':Predicate, #6: 6	قَالَ خَطَرَ
u'قَالَ خَطِيبٌ':Subject, #6: 6	قَالَ خَطَرَ
u'قَالَ خفاف':Subject, #15: 15	قَالَ الْخَطِيبُ
u'قَالَ خُلاصَة':Subject, #1: 1	قَالَ خُفَافُ
u'قَالَ خِلاَفٌ':Predicate, #1: 1	قَالَ الْخُلَاصَةُ
u'قَالَ خِلاَفٌ':Subject, #1: 1	قَالَ خِلَافَ
u'قَالَ خِلاَفٌ':Subject, #1: 1	قَالَ خِلَافٌ
u'قَالَ خُلْعٌ':Subject, #3: 3	قَالَ الْخِلَافُ
u'قَالَ خَلْفٌ':Predicate, #1: 1	قَالَ الْخُلْعُ
u'قَالَ خَلَفٌ':Subject, #1: 1	قَالَ خَلْفَ
u'قَالَ خَلْفٌ':Subject, #10: 10	قَالَ خَلَفٌ
u'قَالَ خَلَفٌ':Subject, #1: 1	قَالَ خَلْفُ
u'قَالَ خلق':Predicate, #3: 3	قَالَ خَلَفُ
u'قَالَ خلق':Predicate, #1: 1	قَالَ خَلَقَ
u'قَالَ خلق':Subject, #1: 1	قَالَ خُلِقَ
u'قَالَ خلق':Subject, #1: 1	قَالَ الْخَلْقُ
u'قَالَ خَلْقٌ':Subject, #1: 1	قَالَ الْخُلُقُ
u'قَالَ خُلُقٌ':Subject, #1: 1	قَالَ الْخَلْقُ
u'قَالَ خُلُق':Subject, #1: 1	قَالَ الْخُلُقُ
u'قَالَ خَلْقٌ':Subject, #1: 1	قَالَ الْخُلُقُ
u'قَالَ خُلُقٌ':Subject, #1: 1	قَالَ خَلْقٌ
u'قَالَ خُلُق':Subject, #1: 1	قَالَ خُلُقٌ
u'قَالَ خَلِيفَةٌ':Subject, #1: 1	قَالَ خُلُقٌ
u'قَالَ خَلِيفَةٌ':Subject, #11: 11	قَالَ الْخَلِيفَةُ
u'قَالَ خَلِيلٌ':Subject, #1: 1	قَالَ خَلِيفَةُ
u'قَالَ خَلِيلِيّ':Subject, #11: 11	قَالَ الْخَلِيلُ
u'قَالَ خَمْرٌ':Subject, #1: 1	قَالَ الْخَلِيلِيُّ
u'قَالَ خَمْسٌ':Predicate, #1: 1	قَالَ الْخَمْرُ
u'قَالَ خَمْسٌ':Subject, #2: 2	قَالَ خَمْسَ
u'قَالَ خَمْسَةٌ':Predicate, #1: 1	قَالَ خَمْسٌ
u'قَالَ خَمْسَةٌ':Subject, #2: 2	قَالَ خَمْسَةَ
u'قَالَ خَمْسَةٌ':Subject, #1: 1	قَالَ الْخَمْسَةُ
u'قَالَ خَمْسَةٌ':Subject, #1: 1	قَالَ خَمْسَةُ
u'قَالَ خَوْفٌ':Subject, #2: 2	قَالَ خَمْسَةٌ
u'قَالَ خيار':Subject, #1: 1	قَالَ خَوْفٌ
u'قَالَ خِيَارٌ':Subject, #1: 1	قَالَ خِيَارُ
u'قَالَ خَيَّاطٌ':Subject, #1: 1	قَالَ خِيَارُ
u'قَالَ خَيْرٌ':Subject, #1: 1	قَالَ الْخَيَّاطُ
u'قَالَ خَيْرٌ':Subject, #3: 3	قَالَ خَيْرُ
u'قَالَ خَيْرِيٌّ':Subject, #6: 6	قَالَ الْخَيْرُ
u'قَالَ خَيْلٌ':Subject, #1: 1	قَالَ الْخَيْرِيُّ
u'قَالَ دَابَّةٌ':Subject, #1: 1	قَالَ الْخَيْلُ
u'قَالَ دَاخِلٌ':Subject, #1: 1	قَالَ دَابَّةٌ
u'قَالَ دَارٌ':Predicate, #2: 2	قَالَ الدَّاخِلُ
u'قَالَ دَارٌ':Subject, #1: 1	قَالَ الدَّارَ
u'قَالَ دَارٌ':Subject, #2: 2	قَالَ دَارُ
u'قَالٌ دَارٌ':Added, #5: 5	قَالَ الدَّارُ
u'قَالَ دَافِعٌ':Subject, #1: 1	قَالَ دَارِهِ
u'قَالَ دَامِي':Subject, #5: 5	قَالَ الدَّافِعُ
u'قَالَ دَائِنٌ':Subject, #1: 1	قَالَ دَامِيَاتُ
u'قَالَ دُبُرٌ':Predicate, #4: 4	قَالَ الدَّائِنُ
u'قَالٌ دُبُرٌ':Added, #2: 2	قَالَ دُبُرَ
u'قَالَ دَحْضٌ':Subject, #1: 1	قَالَ دُبُرِ
u'قَالَ دَخَلٌ':Predicate, #1: 1	قَالَ دَحْضٌ
u'قَالَ دُخُولٌ':Subject, #7: 7	قَالَ دَخَلَ
u'قَالَ دَرَاهِمُ':Subject, #2: 2	قَالَ دُخُولُ
u'قَالَ دَرَاهِمُ':Subject, #12: 12	قَالَ دَرَاهِمُ
u'قَالَ دِرْهَمٌ':Subject, #1: 1	قَالَ الدَّرَاهِمُ
u'قَالَ دِرْهَم':Subject, #1: 1	قَالَ الدِّرْهَمُ
u'قَالَ دِرْهَمٌ':Subject, #1: 1	قَالَ الدِّرْهَمُ
u'قَالَ دِرْهَم':Subject, #21: 21	قَالَ دِرْهَمٌ
u'قَالَ دُرَيْهِمٌ':Subject, #21: 21	قَالَ دِرْهَمٌ
u'قَالَ دَسْتٌ':Subject, #3: 3	قَالَ دُرَيْهِمٌ
u'قَالَ دُعَاءٌ':Subject, #1: 1	قَالَ دَسْتُ
u'قَالَ دفع':Predicate, #3: 3	قَالَ الدُّعَاءُ
u'قَالَ دفعة':Subject, #3: 3	قَالَ دَفَعَ
u'قَالَ دَفْق':Subject, #1: 1	قَالَ دَفَعْتُهُ
u'قَالَ دُفُوفٌ':Subject, #1: 1	قَالَ الدَّفْقُ
u'قَالَ دَلٌّ':Predicate, #1: 1	قَالَ الدُّفُوفُ
u'قَالَ دَمٌ':Predicate, #2: 2	قَالَ دَلَّ
u'قَالَ دَهْرٌ':Subject, #1: 1	قَالَ الدَّمَ
u'قَالَ دَوَرانٌ':Subject, #1: 1	قَالَ الدَّهْرُ
u'قَالَ دونٌ':Predicate, #1: 1	قَالَ الدَّوَرَانُ
u'قَالَ دِيَةٌ':Subject, #6: 6	قَالَ دُونَ
u'قَالَ دِيَةٌ':Subject, #1: 1	قَالَ الدِّيَةُ
u'قَالَ دِينٌ':Subject, #2: 2	قَالَ دِيَةُ
u'قَالَ دَيْنٌ':Subject, #2: 2	قَالَ دِينُ
u'قَالَ دَيْنٌ':Subject, #2: 2	قَالَ دَيْنٌ
u'قَالَ دِينارٌ':Subject, #5: 5	قَالَ الدَّيْنُ
u'قَالَ دِينارٌ':Subject, #1: 1	قَالَ الدِّينَارُ
u'قَالَ ذكر':Predicate, #2: 2	قَالَ دِينَارٌ
u'قَالَ ذكر':Predicate, #2: 2	قَالَ ذُكِرَ
u'قَالَ ذَكَرٌ':Predicate, #31: 31	قَالَ ذَكَرَ
u'قَالَ ذكر':Subject, #31: 31	قَالَ ذَكَرَ
u'قَالَ ذِكْرٌ':Subject, #2: 2	قَالَ ذِكْرُ
u'قَالَ ذِمِّيٌّ':Subject, #2: 2	قَالَ ذِكْرُ
u'قَالَ ذِمِّيٌّ':Subject, #1: 1	قَالَ ذِمِّيٌّ
u'قَالَ ذَهَبٌ':Predicate, #4: 4	قَالَ الذِّمِّيُّ
u'قَالَ ذَهَبٌ':Subject, #7: 7	قَالَ ذَهَبَ
u'قَالَ ذَهَبِيٌّ':Subject, #2: 2	قَالَ الذَّهَبُ
u'قَالَ رابع':Subject, #12: 12	قَالَ الذَّهَبِيُّ
u'قَالَ رَابِعٌ':Subject, #1: 1	قَالَ الرّابِعُ
u'قَالَ رابع':Subject, #1: 1	قَالَ الرّابِعُ
u'قَالَ رَابِعٌ':Subject, #1: 1	قَالَ رَابِعٌ
u'قَالَ رَاجِزٌ':Subject, #1: 1	قَالَ رَابِعٌ
u'قَالَ رَاجِزٌ':Subject, #15: 15	قَالَ الرَّاجِزُ
u'قَالَ رَاحِلٌ':Subject, #27: 27	قَالَ الرّاجِزُ
u'قَالَ رَاحِلَةٌ':Subject, #1: 1	قَالَ رَاحِلَةٌ
u'قَالَ رَأْسٌ':Subject, #1: 1	قَالَ رَاحِلَةٌ
u'قَالَ رَأْسٌ':Subject, #1: 1	قَالَ رَأْسُ
u'قَالٌ رَأْسٌ':Added, #2: 2	قَالَ الرَّأْسُ
u'قَالَ راغِب':Subject, #1: 1	قَالَ رَأْسِ
u'قَالَ رَافِعٌ':Subject, #1: 1	قَالَ الرَّاغِبُ
u'قَالَ رَاكِبٌ':Subject, #3: 3	قَالَ رَافِعٌ
u'قَالَ رَاهِبٌ':Subject, #1: 1	قَالَ الرَّاكِبُ
u'قَالَ رَاهِنٌ':Subject, #4: 4	قَالَ الرَّاهِبُ
u'قَالَ رَاوِي':Predicate, #23: 23	قَالَ الرَّاهِنُ
u'قَالٌ رَاوِي':Added, #1: 1	قَالَ رَاوِيَةً
u'قَالَ رَائِحٌ':Predicate, #3: 3	قَالَ رَاوِيهِ
u'قَالَ رَائِحَةٌ':Predicate, #1: 1	قَالَ رَائِحَةَ
u'قَالَ رايَة':Subject, #1: 1	قَالَ رَائِحَةَ
u'قَالَ رَبُّ':Subject, #1: 1	قَالَ رَايَةُ
u'قَالَ رَبُّ':Subject, #1: 1	قَالَ الرَّبُّ
u'قَالَ رَبُّ':Subject, #65: 65	قَالَ رَبُّ
u'قَالٌ رَبُّ':Added, #6: 6	قَالَ رَبُّهُ
u'قَالَ رُبُعٌ':Predicate, #6: 6	قَالَ رَبِّ
u'قَالَ رُبْعٌ':Subject, #1: 1	قَالَ رُبُعَ
u'قَالَ رَبِيعٌ':Subject, #2: 2	قَالَ رُبْعُ
u'قَالَ رَبِيعَةٌ':Subject, #16: 16	قَالَ الرَّبِيعُ
u'قَالَ رِجَالٌ':Subject, #24: 24	قَالَ رَبِيعَةُ
u'قَالَ رَجُلٌ':Subject, #2: 2	قَالَ رِجَالٌ
u'قَالَ رَجُلٌ':Subject, #171: 171	قَالَ الرَّجُلُ
u'قَالَ رَجُلٌ':Subject, #238: 238	قَالَ رَجُلٌ
u'قَالٌ رَجُلٌ':Added, #3: 3	قَالَ الرّجُلُ
u'قَالَ رَجْمٌ':Subject, #1: 1	قَالَ الرَّجُلَيْنِ
u'قَالَ رُجُوعٌ':Subject, #1: 1	قَالَ الرَّجْمُ
u'قَالَ رحم':Predicate, #1: 1	قَالَ الرُّجُوعُ
u'قَالَ رَحِمٌ':Predicate, #2: 2	قَالَ رَحِمَ
u'قَالَ رَحْمَن':Subject, #2: 2	قَالَ رَحِمَ
u'قَالٌ رَحْمَن':Added, #3: 3	قَالَ الرَّحْمَنُ
u'قَالَ رَحِيمٌ':Subject, #1: 1	قَالَ الرَّحْمَنِ
u'قَالَ رَدٌّ':Predicate, #2: 2	قَالَ الرَّحِيمُ
u'قَالَ رَدٌّ':Subject, #1: 1	قَالَ رَدَّ
u'قَالَ رِدَاءٌ':Subject, #1: 1	قَالَ رَدُّهُ
u'قَالَ رِزْقٌ':Subject, #1: 1	قَالَ الرِّدَاءُ
u'قَالَ رِسَالَةٌ':Subject, #1: 1	قَالَ رِزْقُ
u'قَالَ رَسُولٌ':Predicate, #1: 1	قَالَ رِسَالَتُهُ
u'قَالَ رَسُولٌ':Subject, #3: 3	قَالَ رَسُولَ
u'قَالَ رَسُولٌ':Subject, #15: 15	قَالَ الرَّسُولُ
u'قَالَ رَسُولٌ':Subject, #1: 1	أَقَالَ رَسُولُ
u'قَالَ رَسُولٌ':Subject, #1: 1	قَالَ رَسُولٌ
u'قَالَ رَسُولٌ':Subject, #2: 2	قَالَ الرّسُولُ
u'قَالٌ رَسُولٌ':Added, #3305: 3305	قَالَ رَسُولُ
u'قَالَ رَشيدٌ':Subject, #1: 1	قَالَ رَسُولِ
u'قَالَ رَشيدٌ':Subject, #1: 1	قَالَ رَشِيدُ
u'قَالَ رَضِيٌّ':Subject, #3: 3	قَالَ الرَّشِيدُ
u'قَالَ رِعايَةٌ':Subject, #2: 2	قَالَ الرَّضِيُّ
u'قَالَ رَعْدٌ':Subject, #1: 1	قَالَ الرِّعَايَةُ
u'قَالَ رَعْيٌ':Subject, #1: 1	قَالَ الرَّعْدُ
u'قَالَ رَفْعٌ':Subject, #1: 1	قَالَ رَعْيُ
u'قَالَ رَقَبَةٌ':Subject, #1: 1	قَالَ رَفْعُ
u'قَالَ رِقَّةٌ':Subject, #1: 1	قَالَ الرَّقَبَةُ
u'قَالَ رَقْمٌ':Subject, #1: 1	قَالَ رِقَّةُ
u'قَالَ رَقْم':Subject, #1: 1	قَالَ رَقْمُهُ
u'قَالَ رَقيمٌ':Subject, #1: 1	قَالَ رَقْمُهُ
u'قَالَ ركب':Predicate, #1: 1	قَالَ الرّقِيمُ
u'قَالَ رُكْنٌ':Subject, #2: 2	قَالَ رَكِبَ
u'قَالَ رُكْن':Subject, #4: 4	قَالَ رُكْنُ
u'قَالَ رَمادِيٌّ':Subject, #4: 4	قَالَ رُكْنُ
u'قَالَ رُمَّانِيٌّ':Subject, #1: 1	قَالَ الرَّمَادِيُّ
u'قَالَ رَمَضانُ':Predicate, #2: 2	قَالَ الرُّمَّانِيُّ
u'قَالَ رَمَضانُ':Subject, #2: 2	قَالَ رَمَضَانَ
u'قَالَ رَمْلِيٌّ':Subject, #1: 1	قَالَ رَمَضَانُ
u'قَالَ رَهْطٌ':Subject, #932: 932	قَالَ الرَّمْلِيُّ
u'قَالَ رَهْنٌ':Subject, #2: 2	قَالَ الرَّهْطُ
u'قَالَ روحٌ':Subject, #1: 1	قَالَ الرَّهْنُ
u'قَالَ روحٌ':Subject, #1: 1	قَالَ الرّوحُ
u'قَالَ رَوْحٌ':Subject, #1: 1	قَالَ الرُّوحُ
u'قَالَ روحٌ':Subject, #1: 1	قَالَ الرّوحُ
u'قَالَ رَوْحٌ':Subject, #3: 3	قَالَ رَوْحٌ
u'قَالَ رَئِيسٌ':Subject, #3: 3	قَالَ رَوْحٌ
u'قَالَ رَئِيسٌ':Subject, #1: 1	قَالَ رَئِيسُ
u'قَالَ رِياحٌ':Subject, #2: 2	قَالَ الرّئِيسُ
u'قَالَ زادٌ':Predicate, #1: 1	قَالَ رِيَاحٌ
u'قَالَ زادٌ':Subject, #1: 1	قَالَ زَادَ
u'قَالَ زَجَّاجٌ':Subject, #1: 1	قَالَ الزَّادُ
u'قَالَ زِرٌّ':Subject, #14: 14	قَالَ الزَّجَّاجُ
u'قَالَ زَرْعٌ':Subject, #1: 1	قَالَ زِرُّ
u'قَالَ زَعيمٌ':Subject, #1: 1	قَالَ الزَّرْعُ
u'قَالَ زُفَرٌ':Predicate, #1: 1	قَالَ الزَّعِيمُ
u'قَالَ زُفَرٌ':Subject, #1: 1	قَالَ زُفَرَ
u'قَالَ زُفَرٌ':Subject, #1: 1	قَالَ زُفَرٌ
u'قَالَ زَكاةٌ':Subject, #49: 49	قَالَ زُفَرُ
u'قَالَ زَكاةٌ':Subject, #1: 1	قَالَ زَكَاةٌ
u'قَالَ زَكاةٌ':Subject, #3: 3	قَالَ الزَّكَاةُ
u'قَالَ زَمانٌ':Predicate, #4: 4	قَالَ زَكَاةُ
u'قَالَ زَمانٌ':Subject, #1: 1	قَالَ زَمَانَ
u'قَالَ زَنِيم':Subject, #1: 1	قَالَ الزَّمَانُ
u'قَالَ زَوْجٌ':Subject, #1: 1	قَالَ الزّنِيمُ
u'قَالَ زَوْجٌ':Subject, #10: 10	قَالَ زَوْجُ
u'قَالَ زَوْجَةٌ':Predicate, #158: 158	قَالَ الزَّوْجُ
u'قَالَ زَوْجَةٌ':Subject, #1: 1	قَالَ زَوْجَةَ
u'قَالَ زَيْدٌ':Subject, #1: 1	قَالَ الزَّوْجَاتُ
u'قَالَ زَيْدٌ':Subject, #31: 31	قَالَ زَيْدُ
u'قَالَ زَيْنٌ':Subject, #54: 54	قَالَ زَيْدٌ
u'قَالَ زَيْنٌ':Subject, #1: 1	قَالَ الزَّيْنُ
u'قَالَ زَيْنَبٌ':Subject, #1: 1	قَالَ زَيْنُ
u'قَالَ سابع':Subject, #6: 6	قَالَ زَيْنَبُ
u'قَالَ سَابعٌ':Subject, #1: 1	قَالَ السَّابِعَةُ
u'قَالَ سَارِقٌ':Subject, #1: 1	قَالَ السَّابِعَةُ
u'قَالَ سَاعَةٌ':Predicate, #4: 4	قَالَ السَّارِقُ
u'قَالَ سَاعِدٌ':Subject, #1: 1	قَالَ السَّاعَةَ
u'قَالَ سَاكِنٌ':Subject, #1: 1	قَالَ سَاعِدَةُ
u'قَالَ سَالِمٌ':Subject, #2: 2	قَالَ السَّاكِنُ
u'قَالَ سَالِمٌ':Subject, #28: 28	قَالَ سَالِمٌ
u'قَالَ سَامِريٌّ':Subject, #5: 5	قَالَ سَالِمُ
u'قَالَ سَامِعٌ':Subject, #6: 6	قَالَ السَّامِرِيُّ
u'قَالَ سَائِبٌ':Subject, #1: 1	قَالَ السَّامِعُ
u'قَالَ سَائِبٌ':Subject, #1: 1	قَالَ سَائِبَةٌ
u'قَالَ سَائِقٌ':Subject, #6: 6	قَالَ السَّائِبُ
u'قَالَ سائِل':Predicate, #1: 1	قَالَ السَّائِقُ
u'قَالَ سَائِلٌ':Predicate, #2: 2	قَالَ السَّائِلَ
u'قَالَ سائِل':Subject, #2: 2	قَالَ السَّائِلَ
u'قَالَ سَائِلٌ':Subject, #11: 11	قَالَ السَّائِلُ
u'قَالَ سائِل':Subject, #11: 11	قَالَ السَّائِلُ
u'قَالَ سَائِلٌ':Subject, #1: 1	قَالَ سَائِلُ
u'قَالَ سِباعٌ':Subject, #1: 1	قَالَ سَائِلُ
u'قَالَ سَبَبٌ':Subject, #1: 1	قَالَ السِّبَاعُ
u'قَالَ سَبَبٌ':Subject, #1: 1	قَالَ السَّبَبُ
u'قَالَ سَبْتِيّ':Subject, #1: 1	قَالَ سَبَبُ
u'قَالَ سَبْعٌ':Predicate, #1: 1	قَالَ السَّبْتِيُّ
u'قَالَ سَبْعَةٌ':Predicate, #3: 3	قَالَ سَبْعَ
u'قَالَ سَبْعَةٌ':Subject, #1: 1	قَالَ سَبْعَةَ
u'قَالَ سَبِيلٌ':Subject, #1: 1	قَالَ السَّبْعَةُ
u'قَالَ سَبِيلٌ':Subject, #1: 1	قَالَ سَبِيلُهُ
u'قَالَ سِتٌّ':Subject, #2: 2	قَالَ السَّبِيلُ
u'قَالَ سُجُودٌ':Subject, #1: 1	قَالَ سِتَّةُ
u'قَالَ سَحابَةٌ':Subject, #1: 1	قَالَ السُّجُودُ
u'قَالَ سِحْرٌ':Subject, #1: 1	قَالَ سَحَابَةٌ
u'قَالَ سِرَاجٌ':Subject, #1: 1	قَالَ السِّحْرُ
u'قَالَ سِرْدَابٌ':Subject, #3: 3	قَالَ السِّرَاجُ
u'قَالَ سُرُوجِيّ':Subject, #2: 2	قَالَ السِّرْدَابُ
u'قَالَ سَرِيٌّ':Predicate, #4: 4	قَالَ السُّرُوجِيُّ
u'قَالَ سَرِيٌّ':Subject, #1: 1	قَالَ سَرِيَّةً
u'قَالٌ سَرِيٌّ':Added, #1: 1	قَالَ السَّرِيُّ
u'قَالٌ سَرِيَّةٌ':Added, #1: 1	قَالَ سَرِيَّةٍ
u'قَالَ سَطِيح':Subject, #1: 1	قَالَ سَرِيَّةٍ
u'قَالَ سَعْدٌ':Subject, #2: 2	قَالَ سَطِيحٌ
u'قَالَ سَعْدٌ':Subject, #13: 13	قَالَ سَعْدُ
u'قَالَ سَعْدٌ':Subject, #31: 31	قَالَ سَعْدٌ
u'قَالَ سَعْدَانٌ':Subject, #6: 6	قَالَ السَّعْدُ
u'قَالَ سَعْدَانٌ':Subject, #1: 1	قَالَ السَّعْدَانُ
u'قَالَ سَعِيدٌ':Subject, #2: 2	قَالَ سَعْدَانُ
u'قَالَ سَفِينَةٌ':Subject, #60: 60	قَالَ سَعِيدُ
u'قَالَ سَفِيهٌ':Subject, #2: 2	قَالَ سَفِينَةُ
u'قَالَ سكر':Subject, #1: 1	قَالَ السَّفِيهُ
u'قَالَ سَكْرَان':Subject, #1: 1	قَالَ السَّكَرُ
u'قَالَ سَكْرَان':Subject, #1: 1	قَالَ سَكْرَانُ
u'قَالَ سلام':Subject, #3: 3	قَالَ السَّكْرَانُ
u'قَالَ سَلاَمٌ':Subject, #10: 10	قَالَ السَّلَامُ
u'قَالَ سلام':Subject, #10: 10	قَالَ السَّلَامُ
u'قَالَ سلام':Subject, #1: 1	قَالَ سَلامٌ
u'قَالَ سَلاَمٌ':Subject, #1: 1	قَالَ سَلَامُ
u'قَالَ سَلاَمٌ':Subject, #1: 1	قَالَ سَلامٌ
u'قَالَ سلام':Subject, #1: 1	قَالَ سَلَامُ
u'قَالَ سَلاَمٌ':Subject, #2: 2	قَالَ السَّلاَمُ
u'قَالَ سلام':Subject, #2: 2	قَالَ السَّلاَمُ
u'قَالَ سِلامٌ':Subject, #4: 4	قَالَ السّلَامُ
u'قَالَ سَلاَمٌ':Subject, #4: 4	قَالَ السّلَامُ
u'قَالَ سلام':Subject, #4: 4	قَالَ السّلَامُ
u'قَالَ سَلاَمٌ':Subject, #8: 8	قَالَ سَلَامٌ
u'قَالَ سَلاَمَةٌ':Subject, #8: 8	قَالَ سَلَامٌ
u'قَالَ سُلْطَانٌ':Subject, #1: 1	قَالَ سَلَامَةُ
u'قَالَ سُلْطَانٌ':Subject, #10: 10	قَالَ السُّلْطَانُ
u'قَالَ سَلَفٌ':Subject, #1: 1	قَالَ سُلْطَانُ
u'قَالَ سَلَمٌ':Predicate, #3: 3	قَالَ السَّلَفُ
u'قَالَ سَلَمٌ':Subject, #1: 1	أَقَالَ السَّلَمَ
u'قَالَ سَلْمٌ':Subject, #1: 1	قَالَ سَلَمُ
u'قَالَ سَلْمٌ':Subject, #1: 1	قَالَ سَلْمٌ
u'قَالَ سلمة':Subject, #1: 1	قَالَ سَلْمُ
u'قَالَ سِماكٌ':Subject, #14: 14	قَالَ سَلَمَةُ
u'قَالَ سِماكٌ':Subject, #2: 2	قَالَ سِمَاكُ
u'قَالَ سمرة':Subject, #4: 4	قَالَ سِمَاكٌ
u'قَالَ سمعة':Subject, #1: 1	قَالَ سَمُرَةُ
u'قَالَ سِنَانٌ':Subject, #10: 10	قَالَ سَمِعْتُهُ
u'قَالَ سِنَانٌ':Subject, #1: 1	قَالَ سِنَانُ
u'قَالَ سَنَةٌ':Predicate, #2: 2	قَالَ سِنَانٌ
u'قَالَ سُنَّةٌ':Subject, #2: 2	قَالَ سَنَةَ
u'قَالَ سُنَّةٌ':Subject, #2: 2	قَالَ السُّنَّةُ
u'قَالَ سَنَدٌ':Subject, #2: 2	قَالَ سُنَّةُ
u'قَالٌ سنن':Added, #17: 17	قَالَ سَنَدٌ
u'قَالٌ سَنَنٌ':Added, #1: 1	قَالَ سَنَنِهِ
u'قَالَ سَهْلٌ':Subject, #1: 1	قَالَ سَنَنِهِ
u'قَالَ سَهْلٌ':Subject, #15: 15	قَالَ سَهْلٌ
u'قَالَ سَهْمٌ':Subject, #3: 3	قَالَ سَهْلُ
u'قَالَ سُهَيْلٌ':Subject, #2: 2	قَالَ سَهْمٌ
u'قَالَ سَواءٌ':Subject, #3: 3	قَالَ سُهَيْلٌ
u'قَالَ سَوادٌ':Subject, #6: 6	قَالَ سَوَاءٌ
u'قَالَ سُوقٌ':Predicate, #1: 1	قَالَ السَّوَادُ
u'قَالَ سِياقٌ':Subject, #2: 2	قَالَ السُّوقَ
u'قَالَ سَيِّدٌ':Subject, #1: 1	قَالَ سِيَاقُ
u'قَالَ سَيِّدٌ':Subject, #2: 2	قَالَ سَيِّدُ
u'قَالَ سَيِّدٌ':Subject, #2: 2	قَالَ سَيِّدُهُ
u'قَالَ سَيْفٌ':Subject, #47: 47	قَالَ السَّيِّدُ
u'قَالَ سَيْفٌ':Subject, #1: 1	قَالَ سَيْفُ
u'قَالَ شَاةٌ':Subject, #2: 2	قَالَ سَيْفٌ
u'قَالَ شَاذَّ':Subject, #6: 6	قَالَ شَاةٌ
u'قَالَ شَاذّ':Subject, #1: 1	قَالَ الشَّاذُّ
u'قَالَ شاذِلِيّ':Subject, #1: 1	قَالَ الشَّاذُّ
u'قَالَ شَارِحٌ':Subject, #6: 6	قَالَ الشَّاذِلِيُّ
u'قَالَ شَارِحٌ':Subject, #1: 1	قَالَ شَارِحٌ
u'قَالَ شَارِحٌ':Subject, #30: 30	قَالَ شَارِحُ
u'قَالَ شَارِحٌ':Subject, #36: 36	قَالَ شَارِحُهُ
u'قَالٌ شَارِحٌ':Added, #395: 395	قَالَ الشَّارِحُ
u'قَالَ شَارِعٌ':Subject, #2: 2	قَالَ الشَّارِحِ
u'قَالَ شَاعِر':Subject, #7: 7	قَالَ الشَّارِعُ
u'قَالَ شَاعِر':Subject, #176: 176	قَالَ الشَّاعِرُ
u'قَالَ شَاعِر':Subject, #1: 1	قَالَ شَاعِرُ
u'قَالَ شافِع':Subject, #84: 84	قَالَ الشّاعِرُ
u'قَالَ شافِعِيّ':Subject, #6: 6	قَالَ الشَّافِعِيَّةُ
u'قَالَ شافِعِيّ':Subject, #1: 1	قَالَ الشَّافِعيُّ
u'قَالَ شافِعِيّ':Subject, #539: 539	قَالَ الشَّافِعِيُّ
u'قَالَ شَاهِدٌ':Subject, #6: 6	قَالَ الشَّافِعِيَّةُ
u'قَالَ شَاهِدٌ':Subject, #17: 17	قَالَ الشَّاهِدُ
u'قَالَ شَاهِدٌ':Subject, #1: 1	قَالَ شَاهِدٌ
u'قَالَ شَاهِدٌ':Subject, #1: 1	قَالَ شَاهِدُ
u'قَالَ شِبْرٌ':Subject, #1: 1	قَالَ شَاهِدُهُ
u'قَالَ شُبْهَةٌ':Predicate, #1: 1	قَالَ شِبْرٌ
u'قَالَ شُبْهَةٌ':Subject, #1: 1	قَالَ شُبْهَةَ
u'قَالَ شِتَاءٌ':Subject, #2: 2	قَالَ شُبْهَةُ
u'قَالَ شَخْصٌ':Subject, #1: 1	قَالَ الشِّتَاءُ
u'قَالَ شَرٌّ':Subject, #17: 17	قَالَ شَخْصٌ
u'قَالَ شَرٌّ':Subject, #1: 1	قَالَ شَرُّ
u'قَالَ شَرٌّ':Subject, #2: 2	قَالَ شَرٌّ
u'قَالَ شَرَابٌ':Subject, #2: 2	قَالَ شَرُّهُ
u'قَالَ شُرَّاحٌ':Subject, #2: 2	قَالَ الشَّرَابُ
u'قَالَ شُرَّاحٌ':Subject, #35: 35	قَالَ شُرَّاحُهُ
u'قَالَ شَرَطٌ':Predicate, #4: 4	قَالَ الشُّرَّاحُ
u'قَالَ شَرْطٌ':Subject, #1: 1	قَالَ شَرَطَ
u'قَالَ شَرْطٌ':Subject, #1: 1	قَالَ الشَّرْطُ
u'قَالَ شرف':Subject, #1: 1	قَالَ شَرْطُ
u'قَالَ شَرَفٌ':Subject, #2: 2	قَالَ شَرَفُ
u'قَالَ شرف':Subject, #2: 2	قَالَ شَرَفُ
u'قَالَ شَرَفٌ':Subject, #4: 4	قَالَ الشَّرَفُ
u'قَالَ شِرْكٌ':Subject, #4: 4	قَالَ الشَّرَفُ
u'قَالَ شركاء':Subject, #1: 1	قَالَ الشِّرْكُ
u'قَالَ شركة':Predicate, #1: 1	قَالَ الشُّرَكَاءُ
u'قَالَ شَرِكَةٌ':Predicate, #1: 1	قَالَ شَرِكَةَ
u'قَالَ شركة':Subject, #1: 1	قَالَ شَرِكَةَ
u'قَالَ شَرِكَةٌ':Subject, #1: 1	قَالَ الشَّرِكَةُ
u'قَالَ شَرِيفٌ':Subject, #1: 1	قَالَ الشَّرِكَةُ
u'قَالَ شَرِيكٌ':Subject, #18: 18	قَالَ الشَّرِيفُ
u'قَالَ شُعْبَةٌ':Predicate, #5: 5	قَالَ الشَّرِيكُ
u'قَالَ شُعْبَةٌ':Subject, #1: 1	قَالَ شُعْبَةَ
u'قَالَ شَعْبِيٌّ':Subject, #129: 129	قَالَ شُعْبَةُ
u'قَالَ شَعِثٌ':Subject, #25: 25	قَالَ الشَّعْبِيُّ
u'قَالَ شَعْرٌ':Predicate, #1: 1	قَالَ الشَّعِثَةُ
u'قَالَ شَعْرٌ':Subject, #1: 1	قَالَ الشَّعْرَ
u'قَالَ شِعْرٌ':Subject, #1: 1	قَالَ الشَّعْرُ
u'قَالَ شَعْرَاءُ':Subject, #1: 1	قَالَ الشِّعْرُ
u'قَالَ شُعُوبٌ':Subject, #1: 1	قَالَ شَعْرَاءُ
u'قَالَ شَفَاعَةٌ':Predicate, #1: 1	قَالَ شُعُوبٌ
u'قَالَ شَفَاعَةٌ':Subject, #1: 1	قَالَ الشَّفَاعَةَ
u'قَالَ شفعة':Subject, #1: 1	قَالَ شَفَاعَةُ
u'قَالَ شُفْعَةٌ':Subject, #1: 1	قَالَ الشُّفْعَةُ
u'قَالَ شفعة':Subject, #1: 1	قَالَ الشُّفْعَةُ
u'قَالَ شُفْعَةٌ':Subject, #1: 1	قَالَ شُفْعَتُهُ
u'قَالَ شَفِيعٌ':Subject, #1: 1	قَالَ شُفْعَتُهُ
u'قَالَ شَكٌّ':Subject, #33: 33	قَالَ الشَّفِيعُ
u'قَالَ شَلَبِيّ':Subject, #2: 2	قَالَ الشَّكُّ
u'قَالَ شمس':Subject, #2: 2	قَالَ الشَّلَبِيُّ
u'قَالَ شَمْسٌ':Subject, #208: 208	قَالَ شَمْسُ
u'قَالَ شمس':Subject, #208: 208	قَالَ شَمْسُ
u'قَالَ شَمْسٌ':Subject, #3: 3	قَالَ الشَّمْسُ
u'قَالَ شِهَابٌ':Subject, #3: 3	قَالَ الشَّمْسُ
u'قَالَ شِهَابٌ':Subject, #2: 2	قَالَ شِهَابٌ
u'قَالَ شَهَادَةٌ':Subject, #3: 3	قَالَ شِهَابُ
u'قَالَ شهداء':Subject, #3: 3	قَالَ شَهَادَةُ
u'قَالَ شَهْرٌ':Predicate, #1: 1	قَالَ الشّهَدَاءُ
u'قَالَ شَهْرٌ':Predicate, #1: 1	قَالَ الشَّهْرَ
u'قَالَ شَهْرٌ':Subject, #1: 1	قَالَ شَهْرَ
u'قَالَ شَهْرٌ':Subject, #1: 1	قَالَ الشَّهْرُ
u'قَالَ شَهْرٌ':Subject, #1: 1	قَالَ شَهْرٌ
u'قَالَ شُهُودٌ':Subject, #1: 1	قَالَ شَهْرُ
u'قَالَ شُهُودٌ':Subject, #14: 14	قَالَ شُهُودُ
u'قَالَ شَهِيدٌ':Subject, #27: 27	قَالَ الشُّهُودُ
u'قَالَ شَيْءٌ':Subject, #1: 1	قَالَ الشَّهِيدُ
u'قَالَ شَيْءٌ':Subject, #1: 1	قَالَ الشَّيْءُ
u'قَالَ شيب':Subject, #3: 3	قَالَ شَيْءٌ
u'قَالَ شَيْبٌ':Subject, #1: 1	قَالَ شَيْبُ
u'قَالَ شَيْبان':Subject, #1: 1	قَالَ شَيْبُ
u'قَالَ شَيْبانِيّ':Subject, #4: 4	قَالَ شَيْبَانُ
u'قَالَ شَيْبَةٌ':Subject, #1: 1	قَالَ الشَّيْبَانِيُّ
u'قَالَ شَيْخٌ':Predicate, #4: 4	قَالَ شَيْبَةُ
u'قَالَ شَيْخٌ':Subject, #1: 1	قَالَ الشَّيْخَ
u'قَالَ شَيْخٌ':Subject, #139: 139	قَالَ شَيْخُ
u'قَالَ شَيْخٌ':Subject, #2537: 2537	قَالَ الشَّيْخُ
u'قَالَ شَيْخٌ':Subject, #2: 2	قَالَ شَيْخُهُ
u'قَالَ شَيْخٌ':Subject, #4: 4	قَالَ شَيْخٌ
u'قَالٌ شَيْخٌ':Added, #5: 5	قَالَ الشّيْخُ
u'قَالَ شِيرازِيّ':Subject, #1: 1	قَالَ شَيْخِ
u'قَالَ شَيْطَانٌ':Subject, #10: 10	قَالَ الشِّيرَازِيُّ
u'قَالَ شِيعِيٌّ':Subject, #4: 4	قَالَ الشَّيْطَانُ
u'قَالَ شُيُوخٌ':Subject, #1: 1	قَالَ الشِّيعِيُّ
u'قَالَ صَاحِبٌ':Subject, #3: 3	قَالَ شُيُوخُ
u'قَالَ صَاحِبٌ':Subject, #1: 1	قَالَ الصَّاحِبُ
u'قَالَ صَاحِبٌ':Subject, #2: 2	قَالَ صَاحِبٌ
u'قَالَ صَاحِبٌ':Subject, #641: 641	قَالَ صَاحِبُ
u'قَالٌ صَاحِبٌ':Added, #7: 7	قَالَ صَاحِبُهُ
u'قَالَ صَالِحٌ':Subject, #1: 1	قَالَ صَاحِبِ
u'قَالَ صَالِح':Subject, #11: 11	قَالَ صَالِحُ
u'قَالَ صَالِحٌ':Subject, #11: 11	قَالَ صَالِحُ
u'قَالَ صَالِح':Subject, #17: 17	قَالَ صَالِحٌ
u'قَالَ صَالِحٌ':Subject, #17: 17	قَالَ صَالِحٌ
u'قَالَ صَالِح':Subject, #1: 1	قَالَ صَالِحَةٌ
u'قَالٌ صَالِحٌ':Added, #1: 1	قَالَ صَالِحَةٌ
u'قَالٌ صَالِح':Added, #1: 1	قَالَ صَالِحِ
u'قَالَ صَامِتٌ':Subject, #1: 1	قَالَ صَالِحِ
u'قَالَ صَانِعٌ':Subject, #1: 1	قَالَ صَامِتُ
u'قَالَ صَائِغٌ':Subject, #4: 4	قَالَ الصَّانِعُ
u'قَالَ صَائِمٌ':Subject, #1: 1	قَالَ الصَّائِغُ
u'قَالَ صَائِمٌ':Subject, #1: 1	قَالَ صَائِمٌ
u'قَالَ صبر':Subject, #2: 2	قَالَ الصَّائِمُ
u'قَالَ صَبْرٌ':Subject, #1: 1	قَالَ الصَّبْرُ
u'قَالَ صَبِيٌّ':Subject, #1: 1	قَالَ الصَّبْرُ
u'قَالَ صَحَابَةٌ':Subject, #4: 4	قَالَ الصَّبِيُّ
u'قَالَ صَحَابِيٌّ':Subject, #2: 2	قَالَ الصَّحَابَةُ
u'قَالَ صحبة':Predicate, #9: 9	قَالَ الصَّحَابِيُّ
u'قَالَ صُحْبَةٌ':Predicate, #1: 1	قَالَ الصّحْبَةَ
u'قَالَ صِحَّةٌ':Subject, #1: 1	قَالَ الصّحْبَةَ
u'قَالَ صِحَّةٌ':Subject, #1: 1	قَالَ الصِّحَّةُ
u'قَالَ صَحِيحٌ':Subject, #2: 2	قَالَ صِحَّةُ
u'قَالَ صَخْرٌ':Subject, #11: 11	قَالَ الصَّحِيحُ
u'قَالَ صَدْرٌ':Subject, #1: 1	قَالَ صَخْرُ
u'قَالَ صَدْرٌ':Subject, #25: 25	قَالَ صَدْرُ
u'قَالَ صدق':Predicate, #91: 91	قَالَ الصَّدْرُ
u'قَالَ صدقة':Subject, #8: 8	قَالَ صَدَقَ
u'قَالَ صَدَقَةٌ':Subject, #1: 1	قَالَ صَدَقَةُ
u'قَالَ صدقة':Subject, #1: 1	قَالَ صَدَقَةُ
u'قَالَ صَدَقَةٌ':Subject, #6: 6	قَالَ صَدَقَةٌ
u'قَالَ صَدِيدٌ':Subject, #6: 6	قَالَ صَدَقَةٌ
u'قَالَ صِدِّيقٌ':Subject, #3: 3	قَالَ صَدِيدُ
u'قَالَ صَعْبٌ':Subject, #3: 3	قَالَ الصِّدِّيقُ
u'قَالَ صَعْبٌ':Subject, #1: 1	قَالَ الصّعْبُ
u'قَالَ صغار':Subject, #1: 1	قَالَ الصَّعْبُ
u'قَالَ صغار':Subject, #1: 1	قَالَ الصِّغَارُ
u'قَالَ صَفَّارٌ':Subject, #1: 1	قَالَ صِغَارٌ
u'قَالَ صَفْوَان':Subject, #2: 2	قَالَ الصَّفَّارُ
u'قَالَ صَفِيٌّ':Subject, #5: 5	قَالَ صَفْوَانُ
u'قَالَ صَلاَةٌ':Predicate, #14: 14	قَالَ الصَّفِيُّ
u'قَالَ صَلاَةٌ':Subject, #1: 1	قَالَ الصّلَاةَ
u'قَالَ صَلاَةٌ':Subject, #1: 1	قَالَ الصَّلاَةُ
u'قَالَ صَلاَةٌ':Subject, #1: 1	قَالَ صَلاةُ
u'قَالَ صَلاَةٌ':Subject, #1: 1	قَالَ صَلَاتُهُ
u'قَالَ صَلاَةٌ':Subject, #2: 2	قَالَ صَلَاةٌ
u'قَالَ صَلاَةٌ':Subject, #2: 2	قَالَ صَلَاةُ
u'قَالَ صَلاَةٌ':Subject, #2: 2	قَالَ صَلاَةُ
u'قَالَ صَلاَحٌ':Subject, #4: 4	قَالَ الصَّلَاةُ
u'قَالَ صَلْتٌ':Subject, #2: 2	قَالَ الصَّلَاحُ
u'قَالَ صلح':Subject, #1: 1	قَالَ صَلْتٌ
u'قَالَ صُلْحٌ':Subject, #3: 3	قَالَ الصُّلْحُ
u'قَالَ صَلَوَاتٌ':Subject, #3: 3	قَالَ الصُّلْحُ
u'قَالَ صَلَوَاتٌ':Subject, #1: 1	قَالَ الصَّلَوَاتُ
u'قَالَ صَمْتٌ':Subject, #1: 1	قَالَ صَلَوَاتُ
u'قَالَ صَنَوْبَرِيٌّ':Subject, #1: 1	قَالَ صَمْتٌ
u'قَالَ صُورَةٌ':Subject, #1: 1	قَالَ الصَّنَوْبَرِيُّ
u'قَالَ صُوفِيٌّ':Subject, #1: 1	قَالَ صُورَتُهُ
u'قَالَ صُوفِيَّةٌ':Subject, #2: 2	قَالَ الصُّوفِيَّةُ
u'قَالَ صَوْمٌ':Predicate, #2: 2	قَالَ الصُّوفِيَّةُ
u'قَالَ صَوْمٌ':Subject, #1: 1	قَالَ صَوْمَ
u'قَالَ صَوْمٌ':Subject, #1: 1	قَالَ الصَّوْمُ
u'قَالٌ صَوْمٌ':Added, #7: 7	قَالَ صَوْمُ
u'قَالَ صِيَامٌ':Subject, #1: 1	قَالَ الصَّوْمِ
u'قَالَ صَيْدَلانِيّ':Subject, #1: 1	قَالَ صِيَامُ
u'قَالَ صَيْرَفِيٌّ':Subject, #10: 10	قَالَ الصَّيْدَلَانِيُّ
u'قَالَ ضَارِبٌ':Subject, #37: 37	قَالَ الصَّيْرَفِيُّ
u'قَالَ ضَامِنٌ':Subject, #1: 1	قَالَ الضَّارِبُ
u'قَالٌ ضَبْط':Added, #4: 4	قَالَ الضَّامِنُ
u'قَالَ ضرار':Subject, #1: 1	قَالَ الضَّبْطَيْنِ
u'قَالَ ضَرَبٌ':Predicate, #1: 1	قَالَ ضِرَارٌ
u'قَالَ ضِفْدَعٌ':Subject, #1: 1	قَالَ ضَرَبَ
u'قَالَ ضَمَانٌ':Subject, #1: 1	قَالَ الضِّفْدَعُ
u'قَالَ ضَمَّةٌ':Subject, #1: 1	قَالَ الضَّمَانُ
u'قَالَ ضَمْرٌ':Subject, #1: 1	قَالَ ضَمّةُ
u'قَالَ ضمرة':Subject, #1: 1	قَالَ ضَمْرَةُ
u'قَالَ ضَمِنٌ':Predicate, #1: 1	قَالَ ضَمْرَةُ
u'قَالَ ضَمِيرٌ':Subject, #3: 3	قَالَ ضَمِنَ
u'قَالَ ضَمِيرٌ':Subject, #1: 1	قَالَ الضَّمِيرُ
u'قَالَ ضِيَاءٌ':Subject, #1: 1	قَالَ ضَمِيرٌ
u'قَالَ طَارِقٌ':Subject, #3: 3	قَالَ الضِّيَاءُ
u'قَالَ طَاعَةٌ':Subject, #1: 1	قَالَ طَارِقُ
u'قَالَ طَافٌ':Predicate, #1: 1	قَالَ الطَّاعَةُ
u'قَالَ طَالِبٌ':Subject, #1: 1	قَالَ طَافَ
u'قَالَ طَالِبٌ':Subject, #1: 1	قَالَ طَالِبُ
u'قَالَ طَالِبٌ':Subject, #2: 2	قَالَ طَالِبٌ
u'قَالَ طَالِقٌ':Subject, #30: 30	قَالَ الطَّالِبُ
u'قَالَ طَاهِرٌ':Subject, #7: 7	قَالَ طَالِقٌ
u'قَالَ طَائِفٌ':Subject, #1: 1	قَالَ طَاهِرٌ
u'قَالٌ طَائِفٌ':Added, #9: 9	قَالَ طَائِفَةٌ
u'قَالَ طِبٌّ':Subject, #1: 1	قَالَ طَائِفَةٍ
u'قَالَ طَبَرِيّ':Subject, #1: 1	قَالَ الطِّبُّ
u'قَالَ طَبِيبٌ':Subject, #38: 38	قَالَ الطَّبَرِيُّ
u'قَالَ طَحَّانٌ':Subject, #1: 1	قَالَ الطَّبِيبُ
u'قَالَ طَرَفٌ':Subject, #1: 1	قَالَ الطَّحَّانُ
u'قَالَ طرف':Subject, #1: 1	قَالَ طَرَفَاهُ
u'قَالَ طَرَفٌ':Subject, #1: 1	قَالَ طَرَفُهُ
u'قَالَ طَرَفَةٌ':Subject, #1: 1	قَالَ طَرَفُهُ
u'قَالَ طَرِيقٌ':Subject, #4: 4	قَالَ طَرَفَةُ
u'قَالَ طَسْت':Subject, #2: 2	قَالَ الطَّرِيقُ
u'قَالَ طعام':Subject, #2: 2	قَالَ الطَّسْتُ
u'قَالَ طَعَامٌ':Subject, #1: 1	قَالَ الطَّعَامُ
u'قَالَ طَلاَقٌ':Predicate, #1: 1	قَالَ الطَّعَامُ
u'قَالَ طَلاَقٌ':Subject, #2: 2	قَالَ طَلَاقَ
u'قَالَ طَلاَقٌ':Subject, #11: 11	قَالَ الطَّلَاقُ
u'قَالَ طَلاَقٌ':Subject, #1: 1	قَالَ الطَّلاَقُ
u'قَالَ طَلاَقٌ':Subject, #1: 1	قَالَ طَلاَقُ
u'قَالَ طلب':Subject, #2: 2	قَالَ طَلَاقٌ
u'قَالَ طَلَبٌ':Subject, #3: 3	قَالَ طَلَبُ
u'قَالَ طَلْحٌ':Subject, #3: 3	قَالَ طَلَبُ
u'قَالَ طلحة':Subject, #10: 10	قَالَ طَلْحَةُ
u'قَالَ طَمَعٌ':Subject, #10: 10	قَالَ طَلْحَةُ
u'قَالَ طَنَابِيرُ':Subject, #2: 2	قَالَ الطَّمَعُ
u'قَالَ طَهَارَةٌ':Subject, #1: 1	قَالَ الطَّنَابِيرُ
u'قَالَ طهر':Predicate, #1: 1	قَالَ الطَّهَارَةُ
u'قَالَ طَوَالِقُ':Subject, #1: 1	قَالَ طَهُرَ
u'قَالَ طَوَائِفُ':Subject, #2: 2	قَالَ طَوَالِقُ
u'قَالَ طَيِّبٌ':Subject, #3: 3	قَالَ طَوَائِفُ
u'قَالَ ظالِمٌ':Subject, #1: 1	قَالَ الطّيّبَاتُ
u'قَالَ ظاهِر':Subject, #1: 1	قَالَ ظَالِمٌ
u'قَالَ ظاهِرٌ':Subject, #1: 1	قَالَ الظَّاهِرِيَّةُ
u'قَالَ ظاهِرٌ':Subject, #1: 1	قَالَ ظَاهِرُ
u'قَالَ ظاهِرٌ':Subject, #1: 1	قَالَ ظَاهِرُهُ
u'قَالَ ظاهِرٌ':Subject, #3: 3	قَالَ الظَّاهِرُ
u'قَالَ ظاهِرَة':Subject, #3: 3	قَالَ ظَاهِرٌ
u'قَالَ ظاهِرِيّ':Subject, #1: 1	قَالَ الظَّاهِرِيَّةُ
u'قَالَ ظَرْفٌ':Subject, #1: 1	قَالَ الظَّاهِرِيَّةُ
u'قَالَ ظَنٌّ':Predicate, #1: 1	قَالَ ظَرْفُ
u'قَالَ ظَنٌّ':Subject, #1: 1	قَالَ ظَنَّ
u'قَالَ ظهار':Subject, #1: 1	قَالَ الظَّنُّ
u'قَالَ ظِهارَةٌ':Subject, #1: 1	قَالَ الظِّهَارُ
u'قَالَ ظُهْرٌ':Predicate, #1: 1	قَالَ ظِهَارَةُ
u'قَالَ ظُهْرٌ':Predicate, #1: 1	قَالَ الظُّهْرَ
u'قَالَ ظَهيرٌ':Subject, #1: 1	قَالَ ظُهْرَ
u'قَالَ ظَهيرٌ':Subject, #1: 1	قَالَ الظَّهِيرُ
u'قَالٌ عَاجِلٌ':Added, #9: 9	قَالَ ظَهِيرُ
u'قَالٌ عَاجِلٌ':Added, #1: 1	قَالَ عَاجِلِهِ
u'قَالَ عَادٌ':Predicate, #4: 4	قَالَ عَاجِلِ
u'قَالَ عَادَةٌ':Subject, #2: 2	قَالَ عَادَ
u'قَالَ عَارِفٌ':Subject, #1: 1	قَالَ عَادَةُ
u'قَالَ عَارِمٌ':Subject, #3: 3	قَالَ الْعَارِفُ
u'قَالَ عارِيَّةٌ':Subject, #2: 2	قَالَ عَارِمٌ
u'قَالَ عَاصِمٌ':Subject, #2: 2	قَالَ عَارِيَّةٌ
u'قَالَ عَافِي':Subject, #10: 10	قَالَ عَاصِمٌ
u'قَالَ عَافِيَةٌ':Subject, #1: 1	قَالَ الْعَافِيَةُ
u'قَالَ عَاقِدٌ':Subject, #1: 1	قَالَ الْعَافِيَةُ
u'قَالَ عَالِمٌ':Subject, #1: 1	قَالَ الْعَاقِدُ
u'قَالَ عَالِمٌ':Subject, #1: 1	قَالَ الْعَالِمُ
u'قَالَ عَامٌ':Predicate, #1: 1	قَالَ عَالِمٌ
u'قَالَ عَامٌّ':Subject, #5: 5	قَالَ عَامَ
u'قَالَ عَامٌّ':Subject, #2: 2	قَالَ الْعَامَّةُ
u'قَالَ عَامِرٌ':Subject, #45: 45	قَالَ عَامَّةُ
u'قَالَ عَامِرٌ':Subject, #4: 4	قَالَ عَامِرُ
u'قَالَ عَامِلٌ':Subject, #9: 9	قَالَ عَامِرٌ
u'قَالَ عَامِلٌ':Subject, #1: 1	قَالَ عَامِلُ
u'قَالٌ عَامِلٌ':Added, #7: 7	قَالَ الْعَامِلُ
u'قَالَ عَامِّيٌّ':Subject, #1: 1	قَالَ عَامِلِهِ
u'قَالَ عَائِدٌ':Subject, #2: 2	قَالَ الْعَامِّيُّ
u'قَالَ عَائِشٌ':Subject, #1: 1	قَالَ عَائِدٌ
u'قَالَ عِبَادٌ':Subject, #2: 2	قَالَ عَائِشَةُ
u'قَالَ عِبَارَةٌ':Subject, #1: 1	قَالَ الْعِبَادُ
u'قَالَ عِبَارَةٌ':Subject, #1: 1	قَالَ عِبَارَتُهُ
u'قَالَ عَبَّاسٌ':Subject, #2: 2	قَالَ عِبَارَةُ
u'قَالَ عَبَّاسٌ':Subject, #1: 1	قَالَ عَبّاسُ
u'قَالَ عَبَّاسٌ':Subject, #24: 24	قَالَ الْعَبَّاسُ
u'قَالَ عَبَّاسٌ':Subject, #3: 3	قَالَ عَبَّاسٌ
u'قَالَ عَبَّاسٌ':Subject, #4: 4	قَالَ عَبَّاسُ
u'قَالَ عَبَايَةٌ':Subject, #7: 7	قَالَ الْعَبّاسُ
u'قَالَ عَبْدٌ':Predicate, #1: 1	قَالَ عَبَايَةُ
u'قَالَ عَبْدٌ':Subject, #2: 2	قَالَ عَبْدَ
u'قَالَ عَبْدٌ':Subject, #114: 114	قَالَ الْعَبْدُ
u'قَالَ عَبْدٌ':Subject, #14: 14	قَالَ عَبْدُهُ
u'قَالَ عَبْدٌ':Subject, #7: 7	قَالَ عَبْدٌ
u'قَالَ عبرة':Subject, #856: 856	قَالَ عَبْدُ
u'قَالَ عِبْرَةٌ':Subject, #5: 5	قَالَ الْعِبْرَةُ
u'قَالَ عَبِيدٌ':Subject, #5: 5	قَالَ الْعِبْرَةُ
u'قَالَ عتاق':Subject, #5: 5	قَالَ عَبِيدُ
u'قَالَ عَتاقَة':Subject, #1: 1	قَالَ الْعَتَاقُ
u'قَالَ عتبة':Subject, #1: 1	قَالَ الْعَتَاقَةُ
u'قَالَ عتق':Predicate, #5: 5	قَالَ عُتْبَةُ
u'قَالَ عتق':Subject, #5: 5	قَالَ عَتَقَ
u'قَالَ عِتْقٌ':Subject, #1: 1	قَالَ الْعِتْقُ
u'قَالَ عَجَّاجٌ':Subject, #1: 1	قَالَ الْعِتْقُ
u'قَالَ عَجَمِيٌّ':Subject, #5: 5	قَالَ الْعَجّاجُ
u'قَالَ عَجْوَةٌ':Subject, #1: 1	قَالَ الْعَجَمِيُّ
u'قَالَ عَدَّاءٌ':Subject, #1: 1	قَالَ عَجْوَةُ
u'قَالَ عَدَاوَةٌ':Subject, #3: 3	قَالَ الْعَدَّاءُ
u'قَالَ عِدَّةٌ':Predicate, #1: 1	قَالَ عَدَاوَتُهُ
u'قَالَ عِدَّةٌ':Subject, #1: 1	قَالَ عِدَّةَ
u'قَالَ عَدَدٌ':Predicate, #2: 2	قَالَ عِدَّةُ
u'قَالَ عَدَدٌ':Subject, #5: 5	قَالَ عَدَدَ
u'قَالَ عَدْلٌ':Subject, #1: 1	قَالَ الْعَدَدُ
u'قَالَ عَدْلِيٌّ':Subject, #2: 2	قَالَ الْعَدْلُ
u'قَالَ عَدْلِيَّةٌ':Subject, #1: 1	قَالَ عَدْلِيَّةٌ
u'قَالَ عَدُوٌّ':Predicate, #1: 1	قَالَ عَدْلِيَّةٌ
u'قَالَ عَدُوٌّ':Subject, #2: 2	قَالَ عَدُوَّ
u'قَالَ عُدُولٌ':Subject, #2: 2	قَالَ عَدُوُّ
u'قَالَ عِرَاكٌ':Subject, #2: 2	قَالَ عُدُولٌ
u'قَالَ عَرَبٌ':Subject, #1: 1	قَالَ عِرَاكُ
u'قَالَ عَرَبِيٌّ':Subject, #1: 1	قَالَ الْعَرَبُ
u'قَالَ عَرَبِيٌّ':Subject, #1: 1	قَالَ الْعَرَبِيُّ
u'قَالَ عرف':Predicate, #1: 1	قَالَ عَرَبِيٌّ
u'قَالَ عرف':Subject, #1: 1	قَالَ عُرِفَ
u'قَالَ عُرْفٌ':Subject, #1: 1	قَالَ الْعُرْفُ
u'قَالَ عَرَقٌ':Subject, #1: 1	قَالَ الْعُرْفُ
u'قَالَ عُرْوَةٌ':Subject, #1: 1	قَالَ عَرَقُ
u'قَالَ عَرِيفٌ':Subject, #53: 53	قَالَ عُرْوَةُ
u'قَالَ عَزٌّ':Predicate, #2: 2	قَالَ الْعَرِيفُ
u'قَالَ عِزٌّ':Subject, #3: 3	قَالَ عَزَّ
u'قَالَ عَزْمٌ':Subject, #8: 8	قَالَ الْعِزُّ
u'قَالَ عسر':Predicate, #1: 1	قَالَ عَزْمُ
u'قَالَ عَشَاءٌ':Subject, #2: 2	قَالَ عَسِرَ
u'قَالَ عُشْرٌ':Subject, #1: 1	قَالَ عَشَاءُ
u'قَالَ عُشْرٌ':Subject, #1: 1	قَالَ الْعُشْرُ
u'قَالَ عُشْرٌ':Subject, #1: 1	قَالَ عُشْرٌ
u'قَالَ عَشْرٌ':Subject, #1: 1	قَالَ عُشْرُ
u'قَالَ عِشْرُون':Predicate, #2: 2	قَالَ عَشْرَةٌ
u'قَالَ عِصَامٌ':Subject, #1: 1	قَالَ عِشْرُونَ
u'قَالَ عَطَاءٌ':Subject, #1: 1	قَالَ عِصَامُ
u'قَالَ عَطَاءٌ':Subject, #77: 77	قَالَ عَطَاءٌ
u'قَالَ عَطِيَّةٌ':Subject, #9: 9	قَالَ عَطَاءُ
u'قَالَ عَطِيَّةٌ':Subject, #1: 1	قَالَ عَطِيّةُ
u'قَالَ عَظِيمٌ':Subject, #3: 3	قَالَ عَطِيَّةُ
u'قَالَ عَظِيم':Subject, #1: 1	قَالَ عَظِيمَةُ
u'قَالَ عَظِيم':Subject, #1: 1	قَالَ عَظِيمَةُ
u'قَالَ عِفْرِيتٌ':Subject, #3: 3	قَالَ عَظِيمٌ
u'قَالَ عَفْوٌ':Subject, #1: 1	قَالَ عِفْرِيتٌ
u'قَالٌ عَقَارٌ':Added, #1: 1	قَالَ الْعَفْوُ
u'قَالَ عقال':Predicate, #1: 1	قَالَ الْعَقَارِ
u'قَالَ عِقَالٌ':Predicate, #2: 2	قَالَ عِقَالاً
u'قَالَ عَقِبٌ':Predicate, #2: 2	قَالَ عِقَالاً
u'قَالَ عقبة':Subject, #18: 18	قَالَ عَقِبَ
u'قَالَ عُقْبَةٌ':Subject, #12: 12	قَالَ عُقْبَةُ
u'قَالَ عَقْدٌ':Predicate, #12: 12	قَالَ عُقْبَةُ
u'قَالَ عَقْدٌ':Subject, #3: 3	أَقَالَ الْعَقْدَ
u'قَالَ عَقْدٌ':Subject, #1: 1	قَالَ عَقْدٌ
u'قَالَ عَقْلٌ':Subject, #1: 1	قَالَ عَقْدُ
u'قَالَ عُقَلاَءُ':Subject, #1: 1	قَالَ الْعَقْلُ
u'قَالَ عُقُوبَةٌ':Subject, #2: 2	قَالَ الْعُقَلَاءُ
u'قَالَ عَقِيبٌ':Predicate, #1: 1	قَالَ الْعُقُوبَاتُ
u'قَالَ عُكّاشَة':Subject, #3: 3	قَالَ عَقِيبَ
u'قَالَ عَلاءٌ':Predicate, #1: 1	قَالَ عُكّاشَةُ
u'قَالَ عَلاءٌ':Subject, #1: 1	قَالَ الْعَلاَءَ
u'قَالَ عَلاءٌ':Subject, #1: 1	قَالَ الْعَلاءُ
u'قَالَ عَلاءٌ':Subject, #2: 2	قَالَ الْعَلاَءُ
u'قَالَ علام':Predicate, #3: 3	قَالَ عَلَاءٌ
u'قَالَ عَلاَمَةٌ':Subject, #4: 4	قَالَ عَلَامَ
u'قَالَ عَلَقَةٌ':Subject, #2: 2	قَالَ عَلَامَةُ
u'قَالَ عَلْقَم':Subject, #1: 1	قَالَ الْعَلَقَةُ
u'قَالَ عَلْقَمَة':Subject, #11: 11	قَالَ عَلْقَمَةُ
u'قَالَ علم':Predicate, #11: 11	قَالَ عَلْقَمَةُ
u'قَالَ علم':Subject, #2: 2	قَالَ عُلِمَ
u'قَالَ عِلْمٌ':Subject, #1: 1	قَالَ الْعِلْمُ
u'قَالَ علم':Subject, #1: 1	قَالَ الْعِلْمُ
u'قَالَ عِلْمٌ':Subject, #2: 2	قَالَ عِلْمُ
u'قَالَ علماء':Subject, #2: 2	قَالَ عِلْمُ
u'قَالَ عُلَمَاءُ':Subject, #14: 14	قَالَ عُلَمَاءُ
u'قَالَ علماء':Subject, #14: 14	قَالَ عُلَمَاءُ
u'قَالَ عُلَمَاءُ':Subject, #93: 93	قَالَ الْعُلَمَاءُ
u'قَالَ عُلُوجٌ':Subject, #93: 93	قَالَ الْعُلَمَاءُ
u'قَالَ عَلِيٌّ':Predicate, #1: 1	قَالَ عُلُوجُ
u'قَالَ عَلِيٌّ':Subject, #1: 1	قَالَ عَلِيَّ
u'قَالَ عَلِيٌّ':Subject, #46: 46	قَالَ عَلِيُّ
u'قَالَ عَمٌّ':Subject, #79: 79	قَالَ عَلِيٌّ
u'قَالَ عَمٌّ':Subject, #1: 1	قَالَ عَمٌّ
u'قَالَ عِمَادٌ':Subject, #2: 2	قَالَ الْعَمُّ
u'قَالَ عُمَارَةٌ':Subject, #1: 1	قَالَ الْعِمَادُ
u'قَالَ عَمَائِمُ':Subject, #3: 3	قَالَ عُمَارَةُ
u'قَالَ عُمَرٌ':Predicate, #1: 1	قَالَ الْعَمَائِمُ
u'قَالَ عَمْرٌ':Subject, #3: 3	قَالَ عُمَرَ
u'قَالَ عُمَرٌ':Subject, #1: 1	قَالَ عَمْرُ
u'قَالَ عمرة':Subject, #357: 357	قَالَ عُمَرُ
u'قَالَ عُمْرَةٌ':Subject, #1: 1	قَالَ الْعُمْرَةُ
u'قَالَ عمرة':Subject, #1: 1	قَالَ الْعُمْرَةُ
u'قَالَ عُمْرَةٌ':Subject, #1: 1	قَالَ عُمْرَةُ
u'قَالَ عمرة':Subject, #1: 1	قَالَ عُمْرَةُ
u'قَالَ عَمُودٌ':Subject, #6: 6	قَالَ عَمْرَةُ
u'قَالَ عَمِيرٌ':Subject, #1: 1	قَالَ عَمُودُهُ
u'قَالَ عَمِيرَةٌ':Subject, #1: 1	قَالَ عَمِيرَةُ
u'قَالَ عِنَبٌ':Predicate, #1: 1	قَالَ عَمِيرَةُ
u'قَالَ عَنْتَرٌ':Subject, #1: 1	قَالَ الْعِنَبَ
u'قَالَ عَنْتَرَةٌ':Subject, #2: 2	قَالَ عَنْتَرَةُ
u'قَالَ عند':Predicate, #2: 2	قَالَ عَنْتَرَةُ
u'قَالَ عَهْدٌ':Subject, #70: 70	قَالَ عِنْدَ
u'قَالَ عَهْدٌ':Subject, #1: 1	قَالَ عَهْدٌ
u'قَالَ عِوَضٌ':Subject, #1: 1	قَالَ عَهْدُ
u'قَالَ عَوْنٌ':Subject, #1: 1	قَالَ عِوَضٌ
u'قَالَ عَيْبٌ':Subject, #2: 2	قَالَ عَوْنُ
u'قَالَ عين':Subject, #1: 1	قَالَ الْعَيْبُ
u'قَالَ عَيْنٌ':Subject, #3: 3	قَالَ الْعَيْنُ
u'قَالَ عَيْن':Subject, #3: 3	قَالَ الْعَيْنُ
u'قَالَ عين':Subject, #3: 3	قَالَ الْعَيْنُ
u'قَالَ عَيْنٌ':Subject, #8: 8	قَالَ عَيْنُ
u'قَالَ عَيْن':Subject, #8: 8	قَالَ عَيْنُ
u'قَالَ غَابٌ':Predicate, #8: 8	قَالَ عَيْنُ
u'قَالَ غَاصِبٌ':Subject, #2: 2	قَالَ غَابَ
u'قَالَ غَاصِبٌ':Subject, #17: 17	قَالَ الْغَاصِبُ
u'قَالَ غَالِبٌ':Subject, #1: 1	قَالَ غَاصِبُ
u'قَالَ غَائِبٌ':Subject, #2: 2	قَالَ غَالِبٌ
u'قَالَ غَبِيٌّ':Subject, #2: 2	قَالَ الْغَائِبُ
u'قَالَ غُدَّةٌ':Subject, #1: 1	قَالَ الْغَبِيُّ
u'قَالَ غرماء':Subject, #1: 1	قَالَ غُدَّةٌ
u'قَالَ غرماء':Subject, #1: 1	قَالَ غُرَمَاءُ
u'قَالَ غَرِيزَةٌ':Subject, #9: 9	قَالَ الْغُرَمَاءُ
u'قَالَ غَرِيقٌ':Subject, #1: 1	قَالَ غَرِيزَةُ
u'قَالَ غَرِيمٌ':Subject, #1: 1	قَالَ الْغَرِيقُ
u'قَالَ غَزْوَةٌ':Subject, #8: 8	قَالَ الْغَرِيمُ
u'قَالَ غَسّال':Subject, #1: 1	قَالَ غَزْوَةٌ
u'قَالَ غِشٌّ':Subject, #1: 1	قَالَ الْغَسَّالُ
u'قَالَ غَضٌّ':Subject, #2: 2	قَالَ غِشُّهُ
u'قَالَ غفر':Predicate, #1: 1	قَالَ غَضُّ
u'قَالَ غُلاَمٌ':Subject, #1: 1	قَالَ غُفِرَ
u'قَالَ غُلاَمٌ':Subject, #1: 1	قَالَ الْغُلاَمُ
u'قَالَ غُلاَمٌ':Subject, #1: 1	قَالَ غُلَامٌ
u'قَالَ غُلاَمٌ':Subject, #1: 1	قَالَ غُلَامُ
u'قَالَ غُلاَمٌ':Subject, #1: 1	قَالَ غُلَامُهُ
u'قَالَ غَلَبَةٌ':Subject, #3: 3	قَالَ الْغُلَامُ
u'قَالَ غَيْبٌ':Subject, #1: 1	قَالَ الْغَلَبَةُ
u'قَالَ غَيْبَةٌ':Subject, #1: 1	قَالَ غَيْبٌ
u'قَالَ غير':Predicate, #1: 1	قَالَ غَيْبَةُ
u'قَالَ غَيْرٌ':Predicate, #29: 29	قَالَ غَيْرَ
u'قَالَ غير':Subject, #29: 29	قَالَ غَيْرَ
u'قَالَ غَيْرٌ':Subject, #103: 103	قَالَ غَيْرُهُ
u'قَالَ غير':Subject, #103: 103	قَالَ غَيْرُهُ
u'قَالَ غَيْرٌ':Subject, #2: 2	قَالَ الْغَيْرُ
u'قَالَ غير':Subject, #2: 2	قَالَ الْغَيْرُ
u'قَالَ غَيْرٌ':Subject, #50: 50	قَالَ غَيْرُ
u'قَالٌ غير':Added, #50: 50	قَالَ غَيْرُ
u'قَالٌ غَيْرٌ':Added, #1: 1	قَالَ غَيْرِ
u'قَالٌ غير':Added, #1: 1	قَالَ غَيْرِ
u'قَالٌ غَيْرٌ':Added, #1: 1	قَالَ غَيْرِهِ
u'قَالَ فَارِسٌ':Predicate, #1: 1	قَالَ غَيْرِهِ
u'قَالَ فَارِسٌ':Subject, #1: 1	قَالَ فَارِسَ
u'قَالَ فَارِسِيٌّ':Subject, #1: 1	قَالَ فَارِسٌ
u'قَالَ فَارِضٌ':Subject, #8: 8	قَالَ الْفَارِسِيُّ
u'قَالَ فَاسِقٌ':Subject, #1: 1	قَالَ الْفَارِضُ
u'قَالَ فَاسِقٌ':Subject, #1: 1	قَالَ فَاسِقٌ
u'قَالَ فاسِيّ':Subject, #2: 2	قَالَ الْفَاسِقُ
u'قَالَ فَاضِلٌ':Subject, #1: 1	قَالَ الْفَاسِيُّ
u'قَالَ فَاضِلٌ':Subject, #13: 13	قَالَ الْفَاضِلُ
u'قَالَ فَاطِمٌ':Subject, #1: 1	قَالَ فَاضِلٌ
u'قَالَ فَاطِمٌ':Subject, #1: 1	قَالَ فَاطِمَةٌ
u'قَالَ فَاكِهَانِيٌّ':Subject, #2: 2	قَالَ فَاطِمَةُ
u'قَالَ فَائِدَةٌ':Subject, #26: 26	قَالَ الْفَاكِهَانِيُّ
u'قَالَ فَائِدَةٌ':Subject, #1: 1	قَالَ فَائِدَةٌ
u'قَالَ فَتْحٌ':Subject, #1: 1	قَالَ فَائِدَتُهُ
u'قَالَ فَتْحٌ':Subject, #1: 1	قَالَ الْفَتْحُ
u'قَالَ فَتِيٌّ':Subject, #1: 1	قَالَ فَتْحُ
u'قَالَ فَجْرٌ':Subject, #10: 10	قَالَ الْفَتِيُّ
u'قَالَ فخر':Subject, #1: 1	قَالَ الْفَجْرُ
u'قَالَ فَخْرٌ':Subject, #59: 59	قَالَ فَخْرُ
u'قَالَ فخر':Subject, #59: 59	قَالَ فَخْرُ
u'قَالَ فَخْرٌ':Subject, #7: 7	قَالَ الْفَخْرُ
u'قَالَ فَرَّاءٌ':Subject, #7: 7	قَالَ الْفَخْرُ
u'قَالَ فِرَاشٌ':Subject, #12: 12	قَالَ الْفَرَّاءُ
u'قَالَ فَرَائِضُ':Subject, #1: 1	قَالَ فِرَاشُهُ
u'قَالَ فَرَائِضُ':Subject, #1: 1	قَالَ فَرَائِضُ
u'قَالَ فَرْجٌ':Subject, #1: 1	قَالَ فَرَائِضُهُ
u'قَالَ فَرَزْدَقٌ':Subject, #1: 1	قَالَ فَرْجٌ
u'قَالَ فَرَسٌ':Subject, #7: 7	قَالَ الْفَرَزْدَقُ
u'قَالَ فَرْضٌ':Predicate, #1: 1	قَالَ فَرَسٌ
u'قَالَ فَرْضٌ':Subject, #1: 1	قَالَ فَرْضَ
u'قَالَ فَرْضٌ':Subject, #1: 1	قَالَ الْفَرْضُ
u'قَالَ فَرْعٌ':Subject, #1: 1	قَالَ فَرْضٌ
u'قَالَ فَرْعٌ':Subject, #1: 1	قَالَ الْفَرْعُ
u'قَالَ فِرْعَوْنُ':Subject, #4: 4	قَالَ فَرْعٌ
u'قَالَ فَرْقَدٌ':Subject, #2: 2	قَالَ فِرْعَوْنُ
u'قَالَ فَرْوَةٌ':Subject, #3: 3	قَالَ فَرْقَدٌ
u'قَالَ فُرُوعٌ':Subject, #3: 3	قَالَ فَرْوَةُ
u'قَالَ فَرِيقٌ':Subject, #2: 2	قَالَ الْفُرُوعُ
u'قَالَ فَرِيقٌ':Subject, #1: 1	قَالَ الْفَرِيقُ
u'قَالَ فَزارَة':Subject, #1: 1	قَالَ فَرِيقٌ
u'قَالَ فساد':Subject, #1: 1	قَالَ فَزَارَةُ
u'قَالَ فَسَادٌ':Subject, #1: 1	قَالَ الْفَسَادُ
u'قَالَ فساد':Subject, #1: 1	قَالَ الْفَسَادُ
u'قَالَ فَسَادٌ':Subject, #1: 1	قَالَ فَسَادُ
u'قَالَ فَصٌّ':Subject, #1: 1	قَالَ فَسَادُ
u'قَالَ فَصْلٌ':Subject, #1: 1	قَالَ فَصٌّ
u'قَالَ فَصْلٌ':Subject, #1: 1	قَالَ الْفَصْلُ
u'قَالَ فِضَّةٌ':Subject, #1: 1	قَالَ فَصْلُ
u'قَالَ فَضْلٌ':Subject, #1: 1	قَالَ الْفِضّةُ
u'قَالَ فَضْلٌ':Subject, #12: 12	قَالَ الْفَضْلُ
u'قَالَ فَضْلٌ':Subject, #1: 1	قَالَ فَضْلُ
u'قَالَ فُضُولِيٌّ':Subject, #7: 7	قَالَ فَضْلٌ
u'قَالَ فُضُولِيٌّ':Subject, #1: 1	قَالَ فُضُولِيٌّ
u'قَالَ فطرة':Subject, #4: 4	قَالَ الْفُضُولِيُّ
u'قَالَ فِطْرَةٌ':Subject, #1: 1	قَالَ الْفِطْرَةُ
u'قَالَ فَقْرٌ':Subject, #1: 1	قَالَ الْفِطْرَةُ
u'قَالَ فقهاء':Subject, #1: 1	قَالَ فَقْرٌ
u'قَالَ فقهاء':Subject, #20: 20	قَالَ الْفُقَهَاءُ
u'قَالَ فَقِيرٌ':Subject, #2: 2	قَالَ فُقَهَاءُ
u'قَالَ فَقِيهٌ':Subject, #6: 6	قَالَ الْفَقِيرُ
u'قَالٌ فَقِيهٌ':Added, #318: 318	قَالَ الْفَقِيهُ
u'قَالَ فَكٌّ':Subject, #3: 3	قَالَ الْفَقِيهِ
u'قَالَ فَلًا':Predicate, #1: 1	قَالَ فَكُّ
u'قَالَ فلان':Predicate, #7: 7	قَالَ فَلاَ
u'قَالَ فلان':Predicate, #1: 1	قَالَ عَفَّانَ
u'قَالَ فلان':Predicate, #1: 1	قَالَ مُعَاوِيَةَ
u'قَالَ فلان':Predicate, #1: 1	قَالَ هَارُونَ
u'قَالَ فلان':Subject, #6: 6	قَالَ الرَّازِيَّ
u'قَالَ فلان':Subject, #10: 10	قَالَ الزَّمَخْشَرِيُّ
u'قَالَ فلان':Subject, #10: 10	قَالَ مَكْحُولٌ
u'قَالَ فلان':Subject, #143: 143	قَالَ التِّرْمِذِيُّ
u'قَالَ فلان':Subject, #15: 15	قَالَ جَعْفَرٌ
u'قَالَ فلان':Subject, #16: 16	قَالَ الزُّبَيْرُ
u'قَالَ فلان':Subject, #17: 17	قَالَ جَعْفَرُ
u'قَالَ فلان':Subject, #18: 18	قَالَ مُعَاوِيَةُ
u'قَالَ فلان':Subject, #1: 1	قَالَ التِّلِمْسَانِيُّ
u'قَالَ فلان':Subject, #1: 1	قَالَ الرَّاغِبُ
u'قَالَ فلان':Subject, #1: 1	قَالَ الزُّبَيْدِيُّ
u'قَالَ فلان':Subject, #1: 1	قَالَ الشَّافِعيُّ
u'قَالَ فلان':Subject, #1: 1	قَالَ الظَّاهِرِيَّةُ
u'قَالَ فلان':Subject, #1: 1	قَالَ الْفَاسِيُّ
u'قَالَ فلان':Subject, #1: 1	قَالَ الْقَصَّابُ
u'قَالَ فلان':Subject, #1: 1	قَالَ الْقَيْسِيُّ
u'قَالَ فلان':Subject, #1: 1	قَالَ الْمُتَصَدِّقُ
u'قَالَ فلان':Subject, #1: 1	قَالَ الْمَنُوفِيُّ
u'قَالَ فلان':Subject, #1: 1	قَالَ النَّجَاشِيُّ
u'قَالَ فلان':Subject, #1: 1	قَالَ الْهَاشِمِيُّ
u'قَالَ فلان':Subject, #1: 1	قَالَ بُقْرَاطُ
u'قَالَ فلان':Subject, #1: 1	قَالَ بِلالٌ
u'قَالَ فلان':Subject, #1: 1	قَالَ جُبَيْرُ
u'قَالَ فلان':Subject, #1: 1	قَالَ حَاتِمٌ
u'قَالَ فلان':Subject, #1: 1	قَالَ خَدِيجَةُ
u'قَالَ فلان':Subject, #1: 1	قَالَ رَايَةُ
u'قَالَ فلان':Subject, #1: 1	قَالَ رُوَيْشِدُ
u'قَالَ فلان':Subject, #1: 1	قَالَ سِنِمّارُ
u'قَالَ فلان':Subject, #1: 1	قَالَ عَمْروٌ
u'قَالَ فُلاَنٌ':Subject, #1: 1	قَالَ فَزَارَةُ
u'قَالَ فلان':Subject, #1: 1	قَالَ فُلَانُ
u'قَالَ فلان':Subject, #20: 20	قَالَ حُذَيْفَةُ
u'قَالَ فلان':Subject, #213: 213	قَالَ سُفْيَانُ
u'قَالَ فلان':Subject, #21: 21	قَالَ زُهَيْرٌ
u'قَالَ فلان':Subject, #22: 22	قَالَ الْمُنْذِرِيُّ
u'قَالَ فلان':Subject, #253: 253	قَالَ الْبَيْهَقِيُّ
u'قَالَ فلان':Subject, #2: 2	قَالَ الشَّلَبِيُّ
u'قَالَ فلان':Subject, #2: 2	قَالَ الْمَكِّيُّ
u'قَالَ فلان':Subject, #2: 2	قَالَ بُرَيْدَةُ
u'قَالَ فلان':Subject, #2: 2	قَالَ بِلَالٌ
u'قَالَ فلان':Subject, #2: 2	قَالَ تَمِيمُ
u'قَالَ فلان':Subject, #2: 2	قَالَ جُبَيْرٌ
u'قَالَ فلان':Subject, #2: 2	قَالَ حَامِدٌ
u'قَالَ فلان':Subject, #2: 2	قَالَ حَفْصَةُ
u'قَالَ فلان':Subject, #2: 2	قَالَ رِفَاعَةُ
u'قَالَ فلان':Subject, #2: 2	قَالَ زُبَيْدٌ
u'قَالَ فُلاَنٌ':Subject, #2: 2	قَالَ عَوْفُ
u'قَالَ فلان':Subject, #2: 2	قَالَ فُلانٌ
u'قَالَ فلان':Subject, #33: 33	قَالَ الطَّبَرَانِيُّ
u'قَالَ فلان':Subject, #38: 38	قَالَ الطَّبَرِيُّ
u'قَالَ فلان':Subject, #39: 39	قَالَ الْقُرْطُبِيُّ
u'قَالَ فلان':Subject, #3: 3	قَالَ الدَّمِيرِيُّ
u'قَالَ فلان':Subject, #3: 3	قَالَ الرَّحْمَنُ
u'قَالَ فلان':Subject, #3: 3	قَالَ الْعَوْفِيُّ
u'قَالَ فلان':Subject, #3: 3	قَالَ تَمِيمٌ
u'قَالَ فلان':Subject, #3: 3	قَالَ زِيَادُ
u'قَالَ فلان':Subject, #3: 3	قَالَ هَارُونُ
u'قَالَ فلان':Subject, #46: 46	قَالَ عُثْمَانُ
u'قَالَ فلان':Subject, #4: 4	قَالَ الْبُحْتُرِيُّ
u'قَالَ فلان':Subject, #4: 4	قَالَ الْحَازِمِيُّ
u'قَالَ فلان':Subject, #4: 4	قَالَ حَرْمَلَةُ
u'قَالَ فُلاَنٌ':Subject, #4: 4	قَالَ عُبَيْدَةُ
u'قَالَ فلان':Subject, #51: 51	قَالَ فُلَانٌ
u'قَالَ فلان':Subject, #539: 539	قَالَ الشَّافِعِيُّ
u'قَالَ فلان':Subject, #5: 5	قَالَ حَمْزَةُ
u'قَالَ فلان':Subject, #5: 5	قَالَ دَاوُدُ
u'قَالَ فلان':Subject, #5: 5	قَالَ شُعَيْبٌ
u'قَالَ فلان':Subject, #5: 5	قَالَ عَفَّانُ
u'قَالَ فلان':Subject, #5: 5	قَالَ لُقْمَانُ
u'قَالَ فلان':Subject, #670: 670	قَالَ الْحَارِثِيُّ
u'قَالَ فلان':Subject, #6: 6	قَالَ الزّبَيْرُ
u'قَالَ فلان':Subject, #6: 6	قَالَ الشَّاذِلِيُّ
u'قَالَ فلان':Subject, #6: 6	قَالَ الشَّافِعِيَّةُ
u'قَالَ فلان':Subject, #6: 6	قَالَ قَيْسٌ
u'قَالَ فلان':Subject, #73: 73	قَالَ النَّاشِرِيُّ
u'قَالَ فلان':Subject, #7: 7	قَالَ زُهَيْرُ
u'قَالَ فلان':Subject, #7: 7	قَالَ زِيَادٌ
u'قَالَ فلان':Subject, #80: 80	قَالَ قَتَادَةُ
u'قَالَ فلان':Subject, #8: 8	قَالَ بِلاَلٌ
u'قَالَ فُلاَنٌ':Subject, #9: 9	قَالَ عَوْفٌ
u'قَالٌ فلان':Added, #9: 9	قَالَ فُلَانَةُ
u'قَالٌ فلان':Added, #17: 17	قَالَ الدَّمِيرِيِّ
u'قَالٌ فلان':Added, #1: 1	قَالَ الرَّحْمَنِ
u'قَالَ فَلَكٌ':Predicate, #1: 1	قَالَ الْمُنْذِرِيِّ
u'قَالَ فَمٌ':Subject, #2: 2	قَالَ فَلَكَ
u'قَالَ فَهَّامٌ':Subject, #2: 2	قَالَ الْفَمُ
u'قَالَ قَابِضٌ':Subject, #1: 1	قَالَ الْفَهَّامَةُ
u'قَالَ قابُوس':Subject, #3: 3	قَالَ الْقَابِضُ
u'قَالَ قَاتِلٌ':Subject, #1: 1	قَالَ قَابُوسُ
u'قَالَ قَاذِفٌ':Subject, #6: 6	قَالَ الْقَاتِلُ
u'قَالَ قَارِئٌ':Subject, #3: 3	قَالَ الْقَاذِفُ
u'قَالَ قَارِئٌ':Subject, #1: 1	قَالَ قَارِئُ
u'قَالَ قَاسِمٌ':Subject, #4: 4	قَالَ الْقَارِئُ
u'قَالَ قَاسِمٌ':Subject, #23: 23	قَالَ الْقَاسِمُ
u'قَالَ قَاسِمٌ':Subject, #2: 2	قَالَ قَاسِمُ
u'قَالَ قَاطِعٌ':Subject, #3: 3	قَالَ قَاسِمٌ
u'قَالَ قَاطِعٌ':Subject, #1: 1	قَالَ قَاطِعُ
u'قَالَ قَاعِدٌ':Subject, #6: 6	قَالَ الْقَاطِعُ
u'قَالَ قَالٌ':Predicate, #1: 1	قَالَ الْقَاعِدُ
u'قَالَ قَائِلٌ':Subject, #2819: 2819	قَالَ قَالَ
u'قَالَ قَائِلٌ':Subject, #27: 27	قَالَ الْقَائِلُ
u'قَالَ قَائِمٌ':Subject, #72: 72	قَالَ قَائِلٌ
u'قَالَ قَتاد':Subject, #1: 1	قَالَ الْقَائِمُ
u'قَالَ قتل':Predicate, #80: 80	قَالَ قَتَادَةُ
u'قَالَ قتل':Predicate, #9: 9	قَالَ قَتَلَ
u'قَالَ قتل':Subject, #9: 9	قَالَ قُتِلَ
u'قَالَ قَتْلٌ':Subject, #1: 1	قَالَ قَتْلُ
u'قَالَ قُتَيْبَةٌ':Subject, #1: 1	قَالَ قَتْلُ
u'قَالٌ قَدَحٌ':Added, #10: 10	قَالَ قُتَيْبَةُ
u'قَالَ قَدْرٌ':Subject, #1: 1	قَالَ قَدَحِ
u'قَالَ قَدْرٌ':Subject, #1: 1	قَالَ الْقَدْرُ
u'قَالَ قدم':Predicate, #1: 1	قَالَ قَدْرُ
u'قَالَ قُدُّوسٌ':Subject, #13: 13	قَالَ قَدِمَ
u'قَالَ قذف':Subject, #1: 1	قَالَ الْقُدُّوسُ
u'قَالَ قَذْفٌ':Subject, #1: 1	قَالَ الْقَذْفُ
u'قَالَ قُرْء':Subject, #1: 1	قَالَ الْقَذْفُ
u'قَالَ قِرَاءةٌ':Subject, #1: 1	قَالَ الْقُرْءُ
u'قَالَ قرأة':Subject, #1: 1	قَالَ قِرَاءَةٌ
u'قَالَ قراض':Subject, #1: 1	قَالَ قَرَأْتُهُ
u'قَالَ قُرْآنٌ':Subject, #2: 2	قَالَ قِرَاضٌ
u'قَالَ قُرَّةٌ':Subject, #3: 3	قَالَ الْقُرْآنُ
u'قَالَ قُرْطُبِيّ':Subject, #2: 2	قَالَ قُرَّةُ
u'قَالَ قَرْيَةٌ':Subject, #39: 39	قَالَ الْقُرْطُبِيُّ
u'قَالَ قَرِيضٌ':Predicate, #1: 1	قَالَ قَرْيَةٌ
u'قَالَ قَسَمٌ':Predicate, #1: 1	قَالَ الْقَرِيضَ
u'قَالَ قسمة':Predicate, #1: 1	قَالَ قَسَمَ
u'قَالَ قِسْمَةٌ':Predicate, #1: 1	قَالَ قِسْمَةَ
u'قَالَ قَصّاب':Subject, #1: 1	قَالَ قِسْمَةَ
u'قَالَ قصاص':Predicate, #1: 1	قَالَ الْقَصَّابُ
u'قَالَ قِصَاصٌ':Predicate, #1: 1	قَالَ الْقِصَاصَ
u'قَالَ قَصْدٌ':Subject, #1: 1	قَالَ الْقِصَاصَ
u'قَالَ قِصَرٌ':Subject, #1: 1	قَالَ قَصْدُ
u'قَالَ قَصَصٌ':Subject, #2: 2	قَالَ قِصَرُ
u'قَالَ قَصْعَةٌ':Subject, #1: 1	قَالَ الْقَصَصُ
u'قَالَ قَضَاءٌ':Subject, #1: 1	قَالَ قَصْعَةُ
u'قَالَ قَضَاءٌ':Subject, #2: 2	قَالَ الْقَضَاءُ
u'قَالَ قَضِيَّةٌ':Subject, #2: 2	قَالَ قَضَاءُ
u'قَالَ قُطْبٌ':Subject, #3: 3	قَالَ قَضِيَّةُ
u'قَالَ قُطْرُبٌ':Subject, #1: 1	قَالَ الْقُطْبُ
u'قَالَ قَطْعٌ':Subject, #1: 1	قَالَ قُطْرُبٌ
u'قَالَ قَطِيعٌ':Subject, #1: 1	قَالَ الْقَطْعُ
u'قَالَ قَطِيعَةٌ':Subject, #1: 1	قَالَ قَطِيعَةُ
u'قَالَ قَطِيعِيّ':Subject, #1: 1	قَالَ قَطِيعَةُ
u'قَالَ قَفَّالٌ':Subject, #1: 1	قَالَ الْقَطِيعِيُّ
u'قَالَ قَفِيز':Subject, #93: 93	قَالَ الْقَفَّالُ
u'قَالَ قَفِيز':Subject, #1: 1	قَالَ الْقَفِيزُ
u'قَالَ قَفِيز':Subject, #2: 2	قَالَ قَفِيزٌ
u'قَالَ قِلاَلٌ':Subject, #2: 2	قَالَ قَفِيزُ
u'قَالَ قِلاَلٌ':Subject, #1: 1	قَالَ الْقِلَالُ
u'قَالَ قُلَّةٌ':Subject, #1: 1	قَالَ قِلاَلُ
u'قَالَ قِنٌّ':Subject, #2: 2	قَالَ الْقُلَّةُ
u'قَالَ قِنْطَارٌ':Subject, #1: 1	قَالَ قِنٌّ
u'قَالَ قَهْقَه':Subject, #1: 1	قَالَ الْقِنْطَارُ
u'قَالَ قَهْقَهَة':Subject, #1: 1	قَالَ الْقَهْقَهَةُ
u'قَالَ قَوَابِلُ':Subject, #1: 1	قَالَ الْقَهْقَهَةُ
u'قَالَ قَوَاعِدُ':Subject, #5: 5	قَالَ الْقَوَابِلُ
u'قَالَ قَوَّالٌ':Subject, #2: 2	قَالَ الْقَوَاعِدُ
u'قَالَ قُوتٌ':Subject, #1: 1	قَالَ الْقَوَّالُ
u'قَالَ قُوتٌ':Subject, #1: 1	قَالَ الْقُوتُ
u'قَالَ قول':Predicate, #1: 1	قَالَ قُوتُ
u'قَالَ قَوْلٌ':Predicate, #1: 1	قَالَ الْقَوْلَ
u'قَالَ قول':Predicate, #1: 1	قَالَ الْقَوْلَ
u'قَالَ قَوْلٌ':Predicate, #2: 2	قَالَ قَوْلَ
u'قَالَ قول':Subject, #2: 2	قَالَ قَوْلَ
u'قَالَ قَوْلٌ':Subject, #14: 14	قَالَ قَوْلُهُ
u'قَالَ قول':Subject, #14: 14	قَالَ قَوْلُهُ
u'قَالَ قَوْلٌ':Subject, #5: 5	قَالَ الْقَوْلُ
u'قَالَ قول':Subject, #5: 5	قَالَ الْقَوْلُ
u'قَالَ قَوْلٌ':Subject, #5: 5	قَالَ قَوْلُ
u'قَالٌ قَوْلٌ':Added, #5: 5	قَالَ قَوْلُ
u'قَالَ قَوْمٌ':Subject, #3: 3	قَالَ الْقَوْلَيْنِ
u'قَالَ قَوْمٌ':Subject, #2: 2	قَالَ قَوْمُ
u'قَالَ قَوْمٌ':Subject, #44: 44	قَالَ قَوْمٌ
u'قَالَ قِيَاسٌ':Subject, #6: 6	قَالَ الْقَوْمُ
u'قَالَ قِيَاسٌ':Subject, #3: 3	قَالَ الْقِيَاسُ
u'قَالَ قَيْس':Subject, #4: 4	قَالَ قِيَاسُ
u'قَالَ قَيْصَرٌ':Subject, #6: 6	قَالَ قَيْسٌ
u'قَالَ قَيِّمٌ':Subject, #1: 1	قَالَ قَيْصَرُ
u'قَالَ قِيمَةٌ':Subject, #5: 5	قَالَ الْقَيِّمُ
u'قَالٌ كَاتِبٌ':Added, #3: 3	قَالَ قِيمَتُهُ
u'قَالَ كَاذِبٌ':Subject, #1: 1	قَالَ كَاتِبِ
u'قَالَ كَاسِرٌ':Subject, #1: 1	قَالَ الْكَاذِبُ
u'قَالَ كَافٌّ':Subject, #1: 1	قَالَ الْكَاسِرُ
u'قَالَ كَافَّةٌ':Subject, #1: 1	قَالَ كَافَّةُ
u'قَالَ كَافِرٌ':Predicate, #1: 1	قَالَ كَافَّةُ
u'قَالَ كَافِرٌ':Subject, #1: 1	قَالَ كَافِرَةً
u'قَالَ كَافِرٌ':Subject, #4: 4	قَالَ كَافِرٌ
u'قَالَ كبائر':Subject, #9: 9	قَالَ الْكَافِرُ
u'قَالَ كبراء':Subject, #1: 1	قَالَ الْكَبَائِرُ
u'قَالَ كِتَابٌ':Subject, #1: 1	قَالَ كُبَرَاءُ
u'قَالَ كِتَابٌ':Subject, #1: 1	قَالَ كِتَابُ
u'قَالَ كَثْرَةٌ':Subject, #2: 2	قَالَ الْكِتَابُ
u'قَالَ كَثِيرٌ':Predicate, #3: 3	قَالَ كَثْرَةُ
u'قَالَ كَثِيرٌ':Subject, #1: 1	قَالَ كَثِيرَ
u'قَالَ كَثِيرٌ':Subject, #1: 1	قَالَ الْكَثِيرُ
u'قَالَ كذب':Predicate, #2: 2	قَالَ كَثِيرُ
u'قَالَ كِرَاءٌ':Subject, #4: 4	قَالَ كَذَبَ
u'قَالَ كُرَاعٌ':Subject, #1: 1	قَالَ كِرَاءُ
u'قَالَ كَرْمٌ':Subject, #1: 1	قَالَ كُرَاعٌ
u'قَالٌ كَرِيمٌ':Added, #1: 1	قَالَ كَرْمٌ
u'قَالَ كَسْرٌ':Subject, #1: 1	قَالَ الْكَرِيمِ
u'قَالَ كَشَّافٌ':Subject, #1: 1	قَالَ كَسْرُ
u'قَالَ كعاب':Subject, #1: 1	قَالَ الْكَشَّافُ
u'قَالَ كعاب':Subject, #1: 1	قَالَ كَعَابٌ
u'قَالَ كِعَابٌ':Subject, #1: 1	قَالَ كِعَابُ
u'قَالَ كَعْبٌ':Subject, #1: 1	قَالَ كِعَابُ
u'قَالَ كَعْبٌ':Subject, #11: 11	قَالَ كَعْبُ
u'قَالَ كَفَّارَةٌ':Subject, #24: 24	قَالَ كَعْبٌ
u'قَالَ كفر':Predicate, #1: 1	قَالَ كَفَّارَةٌ
u'قَالَ كِفْلٌ':Subject, #2: 2	قَالَ كَفَرَ
u'قَالَ كَفِيلٌ':Subject, #1: 1	قَالَ كِفْلٌ
u'قَالَ كَفِيلٌ':Subject, #19: 19	قَالَ الْكَفِيلُ
u'قَالَ كلاب':Subject, #1: 1	أَقَالَ الْكَفِيلُ
u'قَالَ كِلاَبٌ':Subject, #1: 1	قَالَ الْكِلَابُ
u'قَالَ كَلاَمٌ':Subject, #1: 1	قَالَ الْكِلَابُ
u'قَالَ كَلاَمٌ':Subject, #1: 1	قَالَ كَلَامُ
u'قَالَ كَلاَمٌ':Subject, #1: 1	قَالَ كَلاَمُ
u'قَالَ كُلْثُومٌ':Subject, #2: 2	قَالَ الْكَلَامُ
u'قَالَ كَلِمَةٌ':Subject, #1: 1	قَالَ كُلْثُومٌ
u'قَالَ كَمَالٌ':Subject, #1: 1	قَالَ الْكَلِمَاتُ
u'قَالَ كِمَامٌ':Subject, #15: 15	قَالَ الْكَمَالُ
u'قَالَ كُمَيْتٌ':Subject, #1: 1	قَالَ كِمَامُ
u'قَالَ كُهُولٌ':Subject, #7: 7	قَالَ الْكُمَيْتُ
u'قَالَ لاَزِمٌ':Subject, #1: 1	قَالَ الْكُهُولُ
u'قَالَ لُبْسَةٌ':Subject, #1: 1	قَالَ لَازِمٌ
u'قَالَ لَبَّيْكَ':Predicate, #1: 1	قَالَ لُبْسَةُ
u'قَالَ لَبَّيْكَ':Predicate, #1: 1	قَالَ لَبّيْكَ
u'قَالَ لَحْمٌ':Predicate, #8: 8	قَالَ لَبَّيْكَ
u'قَالَ لَحْمٌ':Subject, #1: 1	قَالَ لَحْمَ
u'قَالَ لِحْيَانِيٌّ':Subject, #1: 1	قَالَ اللَّحْمُ
u'قَالَ لِسَانٌ':Subject, #2: 2	قَالَ اللِّحْيَانِيُّ
u'قَالَ لِصٌّ':Subject, #1: 1	قَالَ لِسَانُ
u'قَالَ لُصُوصٌ':Subject, #1: 1	قَالَ اللِّصُّ
u'قَالَ لعنة':Predicate, #1: 1	قَالَ اللُّصُوصُ
u'قَالَ لَعْنَةٌ':Predicate, #1: 1	قَالَ لَعْنَةَ
u'قَالَ لعنة':Subject, #1: 1	قَالَ لَعْنَةَ
u'قَالَ لَعْنَةٌ':Subject, #2: 2	قَالَ لَعْنَةُ
u'قَالَ لَغْوٌ':Subject, #2: 2	قَالَ لَعْنَةُ
u'قَالَ لِفْتٌ':Subject, #1: 1	قَالَ اللَّغْوُ
u'قَالَ لَقِيطٌ':Subject, #1: 1	قَالَ لِفْتٌ
u'قَالَ لَيْثٌ':Subject, #1: 1	قَالَ اللَّقِيطُ
u'قَالَ لَيْثٌ':Subject, #15: 15	قَالَ اللَّيْثُ
u'قَالَ لَيْثٌ':Subject, #2: 2	قَالَ لَيْثٌ
u'قَالَ لَيْلٌ':Predicate, #2: 2	قَالَ لَيْثُ
u'قَالَ لَيْلٌ':Predicate, #1: 1	قَالَ لَيْلَةً
u'قَالَ مَاءٌ':Subject, #5: 5	قَالَ لَيْلَةَ
u'قَالَ ماح':Subject, #2: 2	قَالَ الْمَاءُ
u'قَالَ مَالٌ':Predicate, #1: 1	قَالَ مَاحَةُ
u'قَالَ مَالٌ':Subject, #2: 2	قَالَ مَالَكَ
u'قَالَ مَالٌ':Subject, #1: 1	قَالَ مَالُ
u'قَالَ مَالٌ':Subject, #1: 1	قَالَ مَالُهُ
u'قَالَ مَالٌ':Subject, #2: 2	قَالَ الْمَالُ
u'قَالَ مَالِكٌ':Subject, #4: 4	قَالَ مَالٌ
u'قَالَ مالِك':Subject, #1: 1	أَقَالَ مَالِكٌ
u'قَالَ مَالِكٌ':Subject, #1: 1	قَالَ الْمَالِكِيَّةُ
u'قَالَ مَالِكٌ':Subject, #2064: 2064	قَالَ مَالِكٌ
u'قَالَ مَالِكٌ':Subject, #20: 20	قَالَ مَالِكُ
u'قَالَ مَالِكٌ':Subject, #2: 2	قَالَ مَالِكُهُ
u'قَالٌ مَالِكٌ':Added, #35: 35	قَالَ الْمَالِكُ
u'قَالَ مالِكِيّ':Subject, #1: 1	قَالَ مَالِكٍ
u'قَالَ مَأْمُورٌ':Subject, #1: 1	قَالَ الْمَالِكِيَّةُ
u'قَالَ مَأْمُونٌ':Subject, #6: 6	قَالَ الْمَأْمُورُ
u'قَالَ مُبَارَكٌ':Subject, #6: 6	قَالَ الْمَأْمُونُ
u'قَالَ مُبْتاع':Subject, #1: 1	قَالَ الْمُبَارَكُ
u'قَالَ مُبْتاع':Subject, #1: 1	قَالَ مُبْتَاعُهُ
u'قَالَ مُبْتَدِئٌ':Subject, #4: 4	قَالَ الْمُبْتَاعُ
u'قَالَ مبرَّد':Subject, #1: 1	قَالَ الْمُبْتَدِئُ
u'قَالَ مُبَرَّدٌ':Subject, #1: 1	قَالَ الْمُبَرّدُ
u'قَالَ مُبَرِّدٌ':Subject, #1: 1	قَالَ الْمُبَرّدُ
u'قَالَ مُبَرِّدٌ':Subject, #1: 1	قَالَ الْمُبَرّدُ
u'قَالَ مُبْرِئٌ':Subject, #3: 3	قَالَ الْمُبَرِّدُ
u'قَالَ مَبْعُوثٌ':Subject, #1: 1	قَالَ الْمُبْرِئُ
u'قَالَ مُبِيحٌ':Subject, #1: 1	قَالَ الْمَبْعُوثُ
u'قَالَ مَبِيعٌ':Subject, #1: 1	قَالَ الْمُبِيحُ
u'قَالَ مُبَيَّنٌ':Subject, #1: 1	قَالَ الْمَبِيعُ
u'قَالَ مُتَأَخِّرٌ':Subject, #1: 1	قَالَ الْمُبَيَّنُ
u'قَالَ مَتَاعٌ':Subject, #1: 1	قَالَ مُتَأَخِّرٌ
u'قَالَ مَتَاعٌ':Subject, #1: 1	قَالَ الْمَتَاعُ
u'قَالَ مُتَزَوِّجٌ':Subject, #1: 1	قَالَ مَتَاعُهُ
u'قَالَ مُتَصَدِّق':Subject, #1: 1	قَالَ الْمُتَزَوِّجُ
u'قَالَ مُتَغَلِّب':Subject, #1: 1	قَالَ الْمُتَصَدِّقُ
u'قَالَ مُتَلَمِّسٌ':Subject, #1: 1	قَالَ مُتَغَلِّبٌ
u'قَالَ مُتَنَاقِضٌ':Subject, #1: 1	قَالَ الْمُتَلَمِّسُ
u'قَالَ مُتَوَسِّطٌ':Subject, #1: 1	قَالَ الْمُتَنَاقِضُ
u'قَالَ مثل':Predicate, #4: 4	قَالَ الْمُتَوَسِّطُ
u'قَالَ مِثْلٌ':Predicate, #20: 20	قَالَ مِثْلَ
u'قَالَ مثل':Subject, #20: 20	قَالَ مِثْلَ
u'قَالَ مِثْلٌ':Subject, #16: 16	قَالَ مِثْلُ
u'قَالٌ مثل':Added, #16: 16	قَالَ مِثْلُ
u'قَالٌ مِثْلٌ':Added, #1: 1	قَالَ مِثْلِهِ
u'قَالَ مُجالِد':Subject, #1: 1	قَالَ مِثْلِهِ
u'قَالَ مُجالِد':Subject, #1: 1	قَالَ الْمُجَالِدُ
u'قَالَ مُجَاهِدٌ':Subject, #3: 3	قَالَ مُجَالِدٌ
u'قَالَ مُجَاهِدٌ':Subject, #1: 1	قَالَ الْمُجَاهِدُ
u'قَالَ مُجَاوِرٌ':Subject, #59: 59	قَالَ مُجَاهِدٌ
u'قَالَ مُجْتَهِد':Subject, #1: 1	قَالَ الْمُجَاوِرُ
u'قَالَ مُجْتَهِد':Subject, #1: 1	قَالَ الْمُجْتَهِدُ
u'قَالَ مَجْدٌ':Subject, #2: 2	قَالَ مُجْتَهِدٌ
u'قَالَ مَجْدٌ':Subject, #458: 458	قَالَ الْمَجْدُ
u'قَالَ مَجْرُوحٌ':Subject, #4: 4	قَالَ مَجْدُ
u'قَالَ مَجَلَّةٌ':Subject, #2: 2	قَالَ الْمَجْرُوحُ
u'قَالَ مَجْنُونٌ':Subject, #1: 1	قَالَ مَجَلّةُ
u'قَالَ مَجْنِيٌّ':Subject, #2: 2	قَالَ الْمَجْنُونُ
u'قَالَ مَجُوسِيٌّ':Subject, #3: 3	قَالَ الْمَجْنِيُّ
u'قَالَ مُحَارِبٌ':Subject, #1: 1	قَالَ مَجُوسِيٌّ
u'قَالَ مَحَارِيبُ':Subject, #1: 1	قَالَ مُحَارِبُ
u'قَالَ مُحِبٌّ':Subject, #1: 1	قَالَ مَحَارِيبُ
u'قَالَ مَحْبُوبٌ':Subject, #28: 28	قَالَ الْمُحِبُّ
u'قَالَ مَحْبُوسٌ':Subject, #1: 1	قَالَ مَحْبُوبُ
u'قَالَ مُحْتَالٌ':Subject, #1: 1	قَالَ الْمَحْبُوسُ
u'قَالَ مِحْجَن':Subject, #1: 1	قَالَ الْمُحْتَالُ
u'قَالَ مُحَدِّثٌ':Subject, #1: 1	قَالَ مِحْجَنٌ
u'قَالَ مُحْرِمٌ':Predicate, #1: 1	قَالَ الْمُحَدِّثُ
u'قَالَ مُحَرَّمٌ':Subject, #1: 1	قَالَ مُحْرِمِينَ
u'قَالَ مُحْرِمٌ':Subject, #1: 1	قَالَ الْمُحَرّمُ
u'قَالٌ مُحَشِّي':Added, #1: 1	قَالَ مُحْرِمٌ
u'قَالٌ مُحَشّىً':Added, #1: 1	قَالَ مُحَشِّيهِ
u'قَالَ مَحْصُورٌ':Subject, #1: 1	قَالَ مُحَشِّيهِ
u'قَالَ مَحْفُوظٌ':Subject, #1: 1	قَالَ الْمَحْصُورُ
u'قَالَ مُحَقِّقٌ':Subject, #1: 1	قَالَ مَحْفُوظٌ
u'قَالَ مُحَقِّقٌ':Subject, #1: 1	قَالَ مُحَقِّقٌ
u'قَالَ مُحَقِّقٌ':Subject, #1: 1	قَالَ مُحَقِّقُ
u'قَالَ مُحَكِّمٌ':Subject, #31: 31	قَالَ الْمُحَقِّقُ
u'قَالَ مَحَلٌّ':Subject, #1: 1	قَالَ الْمُحَكِّمُ
u'قَالَ مُحَلِّل':Subject, #1: 1	قَالَ مَحَلُّ
u'قَالَ مَحَلِّيٌّ':Subject, #2: 2	قَالَ الْمُحَلِّلُ
u'قَالَ مُحَمَّدٌ':Subject, #1: 1	قَالَ الْمَحَلِّيُّ
u'قَالَ مُحَمَّدٌ':Subject, #12: 12	قَالَ مُحَمّدُ
u'قَالَ مُحَمَّدٌ':Subject, #166: 166	قَالَ مُحَمَّدُ
u'قَالَ مُحَمَّدٌ':Subject, #2: 2	قَالَ مُحَمّدٌ
u'قَالٌ مُحَمَّدٌ':Added, #851: 851	قَالَ مُحَمَّدٌ
u'قَالَ مَحْمُودٌ':Subject, #3: 3	قَالَ مُحَمَّدٍ
u'قَالَ مَحْمُودٌ':Subject, #4: 4	قَالَ مَحْمُودٌ
u'قَالَ مُحِيل':Subject, #4: 4	قَالَ مَحْمُودُ
u'قَالَ مُخَاطَبٌ':Subject, #6: 6	قَالَ الْمُحِيلُ
u'قَالَ مُخَالِفٌ':Subject, #1: 1	قَالَ مُخَاطَبٌ
u'قَالَ مُخْبِرٌ':Subject, #1: 1	قَالَ الْمُخَالِفُ
u'قَالَ مُخْتَارٌ':Subject, #3: 3	قَالَ الْمُخْبِرُ
u'قَالَ مُخْرِجٌ':Subject, #1: 1	قَالَ الْمُخْتَارُ
u'قَالَ مُخْرِجٌ':Subject, #1: 1	قَالَ مُخْرِجُ
u'قَالَ مُخَنَّث':Subject, #8: 8	قَالَ الْمُخْرِجُ
u'قَالَ مَدَارِيٌّ':Subject, #1: 1	قَالَ الْمُخَنَّثُ
u'قَالَ مُدَبَّرٌ':Subject, #1: 1	قَالَ الْمَدَارِيُّ
u'قَالَ مُدْرِكٌ':Subject, #1: 1	قَالَ الْمُدَبَّرَةُ
u'قَالَ مَدْفُوعٌ':Subject, #1: 1	قَالَ مُدْرِكُ
u'قَالَ مَدَنِيٌّ':Subject, #1: 1	قَالَ مَدْفُوعٌ
u'قَالَ مَدْيُونٌ':Subject, #1: 1	قَالَ الْمَدَنِيُّ
u'قَالَ مَذْكُورٌ':Subject, #15: 15	قَالَ الْمَدْيُونُ
u'قَالَ مَذْهَبٌ':Subject, #1: 1	قَالَ الْمَذْكُورُ
u'قَالَ مرٌّ':Predicate, #1: 1	قَالَ مَذْهَبُ
u'قَالَ مرٌّ':Predicate, #13: 13	قَالَ مَرَّةً
u'قَالَ مَرٌّ':Predicate, #5: 5	قَالَ مَرَّ
u'قَالَ مرٌّ':Subject, #5: 5	قَالَ مَرَّ
u'قَالٌ مرٌّ':Added, #1: 1	قَالَ مُرّةُ
u'قَالٌ مرٌّ':Added, #1: 1	قَالَ مَرَّاتٍ
u'قَالَ مراد':Subject, #2: 2	قَالَ مَرَّتَيْنِ
u'قَالَ مُرَادٌ':Subject, #10: 10	قَالَ الْمُرَادُ
u'قَالَ مراد':Subject, #10: 10	قَالَ الْمُرَادُ
u'قَالَ مُرَادٌ':Subject, #1: 1	قَالَ مُرَادُ
u'قَالَ مراد':Subject, #1: 1	قَالَ مُرَادُ
u'قَالَ مُرَادٌ':Subject, #4: 4	قَالَ مُرَادُهُ
u'قَالٌ مَرَّةٌ':Added, #4: 4	قَالَ مُرَادُهُ
u'قَالَ مُرْتَهِنٌ':Subject, #1: 1	قَالَ مَرَّاتٍ
u'قَالَ مَرْجُوعٌ':Subject, #33: 33	قَالَ الْمُرْتَهِنُ
u'قَالَ مَرْحُومٌ':Subject, #2: 2	قَالَ الْمَرْجُوعُ
u'قَالَ مَرْزُبان':Subject, #5: 5	قَالَ الْمَرْحُومُ
u'قَالَ مُرْسِلٌ':Subject, #1: 1	قَالَ الْمَرْزُبَانُ
u'قَالَ مرو':Subject, #3: 3	قَالَ الْمُرْسِلُ
u'قَالَ مُرُوءةٌ':Subject, #2: 2	قَالَ مُرُوهُ
u'قَالَ مُرُوءةٌ':Subject, #1: 1	قَالَ الْمُرُوءَةُ
u'قَالَ مُرُورٌ':Subject, #1: 1	قَالَ مُرُوءَةُ
u'قَالٌ مرى':Added, #1: 1	قَالَ مُرُورُ
u'قَالَ مَرِيضٌ':Subject, #2: 2	قَالَ مُرِيهِ
u'قَالَ مُزَارِعٌ':Subject, #26: 26	قَالَ الْمَرِيضُ
u'قَالَ مُسَافِرٌ':Subject, #2: 2	قَالَ الْمُزَارِعُ
u'قَالَ مُسَافِرٌ':Subject, #1: 1	قَالَ مُسَافِرٌ
u'قَالَ مَسْأَلَةٌ':Subject, #3: 3	قَالَ الْمُسَافِرُ
u'قَالَ مَسْأَلَةٌ':Subject, #1: 1	قَالَ الْمَسْأَلَةُ
u'قَالَ مَسْبُوق':Subject, #1: 1	قَالَ مَسْأَلَةُ
u'قَالَ مُسْتَأْجِرٌ':Subject, #1: 1	قَالَ الْمَسْبُوقُ
u'قَالَ مُسْتَأْجِرٌ':Subject, #22: 22	قَالَ الْمُسْتَأْجِرُ
u'قَالَ مُسْتَحِقٌّ':Subject, #2: 2	قَالَ مُسْتَأْجِرُ
u'قَالَ مُسْتَحِقٌّ':Subject, #4: 4	قَالَ الْمُسْتَحِقُّ
u'قَالَ مُسْتَعِيرٌ':Subject, #5: 5	قَالَ مُسْتَحِقُّ
u'قَالَ مُسْتَنَدٌ':Subject, #2: 2	قَالَ الْمُسْتَعِيرُ
u'قَالَ مُسْتَوْدَعٌ':Subject, #1: 1	قَالَ مُسْتَنَدُهُ
u'قَالَ مُسْتَوْرِدٌ':Subject, #6: 6	قَالَ الْمُسْتَوْدَعُ
u'قَالَ مُسْتَوْعِبٌ':Subject, #1: 1	قَالَ الْمُسْتَوْرِدُ
u'قَالٌ مُسْتَوْعِبٌ':Added, #1: 1	قَالَ الْمُسْتَوْعِبُ
u'قَالَ مَسْجِدٌ':Predicate, #1: 1	قَالَ الْمُسْتَوْعِبِ
u'قَالَ مَسْجِدٌ':Subject, #1: 1	قَالَ مَسْجِدَ
u'قَالَ مَسَدٌ':Subject, #1: 1	قَالَ الْمَسْجِدُ
u'قَالَ مُسَدِّدٌ':Subject, #1: 1	قَالَ الْمَسَدُ
u'قَالَ مُسَدَّدٌ':Subject, #1: 1	قَالَ مُسَدِّدٌ
u'قَالَ مَسْرُوقٌ':Subject, #8: 8	قَالَ مُسَدَّدٌ
u'قَالَ مَسْرُوقٌ':Subject, #3: 3	قَالَ الْمَسْرُوقُ
u'قَالَ مُسَعَّرٌ':Subject, #7: 7	قَالَ مَسْرُوقٌ
u'قَالَ مِسْعَرٌ':Subject, #1: 1	قَالَ مُسَعَّرٌ
u'قَالَ مِسْعَرٌ':Subject, #2: 2	قَالَ مِسْعَرُ
u'قَالَ مُسْلِمٌ':Subject, #5: 5	قَالَ مِسْعَرٌ
u'قَالَ مُسْلِمٌ':Subject, #13: 13	قَالَ مُسْلِمٌ
u'قَالَ مُسَلَّمٌ':Subject, #14: 14	قَالَ الْمُسْلِمُ
u'قَالَ مُسْلِمٌ':Subject, #2: 2	قَالَ الْمُسَلَّمُ
u'قَالَ مَسِيحٌ':Subject, #4: 4	قَالَ مُسْلِمُ
u'قَالَ مُشَاوِرٌ':Subject, #3: 3	قَالَ الْمَسِيحُ
u'قَالَ مَشَايِخُ':Subject, #1: 1	قَالَ الْمُشَاوِرُ
u'قَالَ مَشَايِخُ':Subject, #15: 15	قَالَ مَشَايِخُ
u'قَالٌ مُشْتَرِي':Added, #19: 19	قَالَ الْمَشَايِخُ
u'قَالَ مُشْرِك':Subject, #1: 1	قَالَ مُشْتَرِيهِ
u'قَالَ مُشْكِلٌ':Subject, #1: 1	قَالَ الْمُشْرِكُ
u'قَالَ مَشْهُودٌ':Subject, #1: 1	قَالَ الْمُشْكِلُ
u'قَالَ مَشْهُورٌ':Subject, #8: 8	قَالَ الْمَشْهُودُ
u'قَالَ مَشْيٌ':Subject, #1: 1	قَالَ الْمَشْهُورُ
u'قَالَ مُصَالِحٌ':Subject, #1: 1	قَالَ الْمَشْيُ
u'قَالَ مُصَنِّفٌ':Subject, #1: 1	قَالَ الْمُصَالِحُ
u'قَالَ مُصَنَّفٌ':Subject, #1632: 1632	قَالَ الْمُصَنِّفُ
u'قَالَ مُصَنِّفٌ':Subject, #1: 1	قَالَ الْمُصَنَّفُ
u'قَالٌ مُصَنِّفٌ':Added, #1: 1	قَالَ مُصَنِّفُهُ
u'قَالَ مُصِيبٌ':Subject, #2: 2	قَالَ الْمُصَنِّفِ
u'قَالَ مُضَارِبٌ':Subject, #3: 3	قَالَ الْمُصِيبُ
u'قَالٌ مَضَارِبُ':Added, #26: 26	قَالَ الْمُضَارِبُ
u'قَالَ مُضَاعَفٌ':Subject, #1: 1	قَالَ الْمَضَارِبِ
u'قَالَ مُضَاعَفَةٌ':Subject, #1: 1	قَالَ مُضَاعَفَةٌ
u'قَالَ مَضْرُوبٌ':Subject, #1: 1	قَالَ مُضَاعَفَةٌ
u'قَالٌ مَضْرُوبٌ':Added, #1: 1	قَالَ الْمَضْرُوبُ
u'قَالَ مُضْغَةٌ':Subject, #1: 1	قَالَ مَضْرُوبَةٍ
u'قَالَ مَضْمُونٌ':Subject, #1: 1	قَالَ مُضْغَةُ
u'قَالَ مَطَرٌ':Subject, #2: 2	قَالَ الْمَضْمُونُ
u'قَالَ مُطْعِمٌ':Subject, #4: 4	قَالَ مَطَرٌ
u'قَالَ مَطْلُوبٌ':Subject, #1: 1	قَالَ الْمُطْعِمُ
u'قَالَ مَظَاهِرُ':Subject, #11: 11	قَالَ الْمَطْلُوبُ
u'قَالَ مَظْلُومٌ':Subject, #1: 1	قَالَ الْمَظَاهِرُ
u'قَالٌ مَعَادِنُ':Added, #2: 2	قَالَ الْمَظْلُومُ
u'قَالَ مَعَاذٌ':Predicate, #1: 1	قَالَ الْمَعَادِنِ
u'قَالَ معاصر':Subject, #1: 1	قَالَ مَعَاذَ
u'قَالَ معاصر':Subject, #1: 1	قَالَ الْمَعَاصِرُ
u'قَالَ مَعَاصِرُ':Subject, #1: 1	قَالَ الْمُعَاصِرُ
u'قَالَ مُعَاصِرٌ':Subject, #1: 1	قَالَ الْمَعَاصِرُ
u'قَالَ مُعاوِيَة':Predicate, #1: 1	قَالَ الْمُعَاصِرُ
u'قَالَ مُعاوِيَة':Subject, #1: 1	قَالَ مُعَاوِيَةَ
u'قَالَ مُعَايِنٌ':Subject, #18: 18	قَالَ مُعَاوِيَةُ
u'قَالَ مُعْتَبَرٌ':Subject, #1: 1	قَالَ مُعَايِنٌ
u'قَالَ مُعْتَرِضٌ':Subject, #2: 2	قَالَ الْمُعْتَبَرُ
u'قَالَ مُعْتَزِلٌ':Subject, #6: 6	قَالَ الْمُعْتَرِضُ
u'قَالَ مُعْتَزِلَةٌ':Subject, #2: 2	قَالَ مُعْتَزِلَةُ
u'قَالَ مُعْتَقٌ':Subject, #2: 2	قَالَ مُعْتَزِلَةُ
u'قَالَ مَعْدِنٌ':Subject, #1: 1	قَالَ الْمُعْتَقُ
u'قَالَ مَعْدُودٌ':Predicate, #2: 2	قَالَ الْمَعْدِنُ
u'قَالَ مَعْرِفَةٌ':Subject, #1: 1	قَالَ مَعْدُودَةً
u'قَالَ مَعْرِفَة':Subject, #2: 2	قَالَ مَعْرِفَةُ
u'قَالَ مَعْرُوفٌ':Subject, #2: 2	قَالَ مَعْرِفَةُ
u'قَالَ مَعْزُولٌ':Subject, #1: 1	قَالَ الْمَعْرُوفُ
u'قَالَ مَعْزُولٌ':Subject, #2: 2	قَالَ الْمَعْزُولُ
u'قَالَ مُعْسِرٌ':Subject, #2: 2	قَالَ مَعْزُولٌ
u'قَالَ مُعْسِرٌ':Subject, #1: 1	قَالَ الْمُعْسِرُ
u'قَالَ مُعَقَّبٌ':Subject, #3: 3	قَالَ مُعْسِرٌ
u'قَالَ مُعَقِّبٌ':Subject, #1: 1	قَالَ الْمُعَقّبَاتُ
u'قَالَ مَعْقِلٌ':Subject, #1: 1	قَالَ الْمُعَقّبَاتُ
u'قَالَ مَعْقِلٌ':Subject, #1: 1	قَالَ مَعْقِلُ
u'قَالَ مَعْقُولٌ':Predicate, #2: 2	قَالَ مَعْقِلٌ
u'قَالَ مُعَلِّقٌ':Subject, #1: 1	قَالَ مَعْقُولَةً
u'قَالَ مُعَلِّلٌ':Subject, #1: 1	قَالَ الْمُعَلِّقُ
u'قَالَ مُعَلِّمٌ':Subject, #1: 1	قَالَ الْمُعَلِّلُ
u'قَالَ مَعْلُوفٌ':Predicate, #3: 3	قَالَ الْمُعَلِّمُ
u'قَالَ مُعَمَّرٌ':Subject, #1: 1	قَالَ مَعْلُوفَةً
u'قَالَ مُعِير':Subject, #1: 1	قَالَ الْمُعَمَّرُ
u'قَالٌ مَغْرِبٌ':Added, #2: 2	قَالَ الْمُعِيرُ
u'قَالَ مَغْصُوب':Subject, #1: 1	قَالَ الْمَغْرِبِ
u'قَالَ مُفَسِّرٌ':Subject, #6: 6	قَالَ الْمَغْصُوبُ
u'قَالَ مُفْطِر':Predicate, #2: 2	قَالَ الْمُفَسِّرُ
u'قَالَ مُفْلِسٌ':Subject, #1: 1	قَالَ مُفْطِرِينَ
u'قَالَ مُقَاتِلٌ':Subject, #1: 1	قَالَ الْمُفْلِسُ
u'قَالَ مَقَامٌ':Subject, #5: 5	قَالَ مُقَاتِلٌ
u'قَالَ مُقْتَرَحٌ':Subject, #1: 1	قَالَ الْمَقَامُ
u'قَالَ مُقْتَرِحٌ':Subject, #1: 1	قَالَ الْمُقْتَرَحُ
u'قَالَ مَقْتُولٌ':Subject, #8: 8	قَالَ الْمُقْتَرِحُ
u'قَالَ مِقْدَامٌ':Subject, #2: 2	قَالَ الْمَقْتُولُ
u'قَالَ مِقْدَامٌ':Subject, #1: 1	قَالَ مِقْدَامُ
u'قَالَ مُقَدَّرٌ':Subject, #2: 2	قَالَ الْمِقْدَامُ
u'قَالَ مَقْدِسِيٌّ':Predicate, #1: 1	قَالَ الْمُقَدَّرُ
u'قَالَ مَقْذُوفٌ':Subject, #57: 57	قَالَ الْمَقْدِسِيَّ
u'قَالَ مَقَرٌّ':Subject, #1: 1	قَالَ الْمَقْذُوفُ
u'قَالَ مُقْرِضٌ':Subject, #1: 1	قَالَ الْمَقَرُّ
u'قَالَ مَقْصُودٌ':Subject, #1: 1	قَالَ الْمُقْرِضُ
u'قَالَ مَقْضِيّ':Subject, #1: 1	قَالَ الْمَقْصُودُ
u'قَالَ مَقْطُوعٌ':Subject, #3: 3	قَالَ الْمَقْضِيُّ
u'قَالَ مَكَانٌ':Predicate, #1: 1	قَالَ الْمَقْطُوعُ
u'قَالَ مَكَانٌ':Subject, #6: 6	قَالَ مَكَانَ
u'قَالَ مَكْتُوبٌ':Subject, #1: 1	قَالَ مَكَانُ
u'قَالَ مَكْتُوبٌ':Subject, #1: 1	قَالَ الْمَكْتُوبُ
u'قَالَ مَكْحُول':Subject, #1: 1	قَالَ مَكْتُوبٌ
u'قَالَ مُكْرِهٌ':Subject, #10: 10	قَالَ مَكْحُولٌ
u'قَالَ مُكْرَهٌ':Subject, #2: 2	قَالَ الْمُكْرِهُ
u'قَالَ مَكْرُوهٌ':Subject, #3: 3	قَالَ الْمُكْرَهُ
u'قَالَ مُكَعْبَر':Subject, #1: 1	قَالَ مَكْرُوهٌ
u'قَالَ مَكْفُولٌ':Subject, #1: 1	قَالَ الْمُكَعْبَرُ
u'قَالٌ مُكَلَّفٌ':Added, #3: 3	قَالَ الْمَكْفُولُ
u'قَالَ مَكِّيّ':Subject, #1: 1	قَالَ مُكَلَّفَةٍ
u'قَالَ مَلأٌ':Subject, #2: 2	قَالَ الْمَكِّيُّ
u'قَالَ مَلاَعِنُ':Subject, #1: 1	قَالَ الْمَلَأُ
u'قَالَ مَلاَئِكَةٌ':Subject, #1: 1	قَالَ الْمَلَاعِنُ
u'قَالَ مِلَّةٌ':Predicate, #1: 1	قَالَ الْمَلَائِكَةُ
u'قَالَ مُلْتَقِط':Subject, #1: 1	قَالَ مِلّةَ
u'قَالَ مُلْحِدٌ':Subject, #3: 3	قَالَ الْمُلْتَقِطُ
u'قَالَ مَلَكٌ':Predicate, #1: 1	قَالَ الْمُلْحِدُ
u'قَالَ مَلَكٌ':Subject, #1: 1	قَالَ مَلَكَ
u'قَالَ مَلِكٌ':Subject, #12: 12	قَالَ الْمَلَكُ
u'قَالَ مُلْكٌ':Subject, #1: 1	قَالَ الْمَلِكُ
u'قَالَ مَلَكٌ':Subject, #1: 1	قَالَ الْمُلْكُ
u'قَالَ مَلَكٌ':Subject, #1: 1	قَالَ مَلَكُ
u'قَالَ مِلْكٌ':Subject, #2: 2	قَالَ مَلَكٌ
u'قَالَ مَمْلُوكٌ':Subject, #2: 2	قَالَ مِلْكُهُ
u'قَالَ مَمْلُوكٌ':Subject, #1: 1	قَالَ مَمْلُوكٌ
u'قَالَ مُمَيِّزٌ':Subject, #2: 2	قَالَ الْمَمْلُوكُ
u'قَالَ مَنٌّ':Subject, #1: 1	قَالَ الْمُمَيِّزُ
u'قَالَ مُنَاسَبَةٌ':Subject, #1: 1	قَالَ الْمَنُّ
u'قَالَ مُنَافِقٌ':Subject, #1: 1	قَالَ الْمُنَاسَبَةُ
u'قَالَ مُنْذِرٌ':Subject, #1: 1	قَالَ الْمُنَافِقُ
u'قَالَ مَنْسُوخٌ':Subject, #1: 1	قَالَ الْمُنْذِرُ
u'قَالَ مُنْشِئٌ':Subject, #1: 1	قَالَ مَنْسُوخٌ
u'قَالَ مَنْصُورٌ':Subject, #1: 1	قَالَ مُنْشِئٌ
u'قَالَ مَنْصُورٌ':Subject, #11: 11	قَالَ مَنْصُورٌ
u'قَالَ مَنْصُورٌ':Subject, #1: 1	قَالَ الْمَنْصُورُ
u'قَالَ مُنْفَرِدٌ':Subject, #2: 2	قَالَ مَنْصُورُ
u'قَالَ مَنْفَعَةٌ':Subject, #1: 1	قَالَ الْمُنْفَرِدُ
u'قَالَ مَنْقُولٌ':Subject, #1: 1	قَالَ مَنْفَعَةُ
u'قَالَ مُنْكِرٌ':Subject, #1: 1	قَالَ الْمَنْقُولُ
u'قَالَ مَنْكُوح':Subject, #1: 1	قَالَ الْمُنْكِرُ
u'قَالَ مِنْهَاجٌ':Subject, #1: 1	قَالَ مَنْكُوحَةُ
u'قَالَ مَنْهِيٌّ':Subject, #1: 1	قَالَ الْمِنْهَاجُ
u'قَالَ مَنُوفِيّ':Subject, #1: 1	قَالَ مَنْهِيٌّ
u'قَالَ مَنِيٌّ':Subject, #1: 1	قَالَ الْمَنُوفِيُّ
u'قَالَ مُهَاجِرٌ':Subject, #1: 1	قَالَ الْمَنِيُّ
u'قَالَ مَهْدِيٌّ':Subject, #1: 1	قَالَ مُهَاجِرٌ
u'قَالَ مَهْرٌ':Subject, #1: 1	قَالَ مَهْدِيُّ
u'قَالَ مَوْتٌ':Subject, #1: 1	قَالَ الْمَهْرُ
u'قَالَ مَوْتٌ':Subject, #1: 1	قَالَ مَوْتٌ
u'قَالَ مَوْتٌ':Subject, #1: 1	قَالَ مَوْتُ
u'قَالَ مُوَثَّقٌ':Subject, #2: 2	قَالَ الْمَوْتُ
u'قَالَ مُوجِبٌ':Subject, #1: 1	قَالَ الْمُوَثَّقُ
u'قَالَ مُؤَجِّرٌ':Subject, #1: 1	قَالَ مُوجِبُ
u'قَالَ مُؤَجِّرٌ':Subject, #1: 1	قَالَ مُؤَجِّرٌ
u'قَالَ مَوْجُودٌ':Subject, #7: 7	قَالَ الْمُؤَجِّرُ
u'قَالٌ مُؤَخِّرٌ':Added, #1: 1	قَالَ مَوْجُودٌ
u'قَالٌ مُؤَخَّرٌ':Added, #1: 1	قَالَ مُؤَخِّرَتِهِ
u'قَالَ مُودَعٌ':Subject, #1: 1	قَالَ مُؤَخَّرِهِ
u'قَالَ مُودِعٌ':Subject, #18: 18	قَالَ الْمُودَعُ
u'قَالَ مُؤَذِّنٌ':Subject, #5: 5	قَالَ الْمُودِعُ
u'قَالَ مُؤَذِّنٌ':Subject, #13: 13	قَالَ الْمُؤَذِّنُ
u'قَالَ مُؤَرِّخٌ':Subject, #1: 1	قَالَ الْمُؤَذّنُ
u'قَالَ مُوَرِّقٌ':Subject, #1: 1	قَالَ الْمُؤَرِّخُ
u'قَالَ مَوْضِعٌ':Predicate, #1: 1	قَالَ الْمُوَرِّقُ
u'قَالَ مَوْضِعٌ':Subject, #1: 1	قَالَ مَوْضِعَ
u'قَالَ مُوَفَّقٌ':Subject, #1: 1	قَالَ مَوْضِعُهُ
u'قَالَ مَوْقُوفٌ':Subject, #3: 3	قَالَ الْمُوَفَّقُ
u'قَالَ مَوْقُوفٌ':Subject, #1: 1	قَالَ مَوْقُوفَةٌ
u'قَالَ مُوَكَّلٌ':Subject, #2: 2	قَالَ الْمَوْقُوفُ
u'قَالَ مُوَكِّلٌ':Subject, #1: 1	قَالَ الْمُوَكَّلُ
u'قَالَ مُوَكِّلٌ':Subject, #1: 1	قَالَ مُوَكِّلُهُ
u'قَالَ مُؤَلَّفٌ':Subject, #23: 23	قَالَ الْمُوَكِّلُ
u'قَالَ مُؤَلِّفٌ':Subject, #1: 1	قَالَ الْمُؤَلَّفُ
u'قَالَ مُؤَلِّفٌ':Subject, #1: 1	قَالَ مُؤَلِّفُ
u'قَالَ مُؤَلِّفٌ':Subject, #3: 3	قَالَ مُؤَلِّفُهُ
u'قَالَ مُؤَلَّفٌ':Subject, #58: 58	قَالَ الْمُؤَلِّفُ
u'قَالَ مُؤَلِّفٌ':Subject, #74: 74	قَالَ الْمُؤَلّفُ
u'قَالَ مُؤَمَّلٌ':Subject, #74: 74	قَالَ الْمُؤَلّفُ
u'قَالَ مُؤْمِنٌ':Subject, #1: 1	قَالَ مُؤَمَّلٌ
u'قَالَ مَوْهُوبٌ':Subject, #2: 2	قَالَ الْمُؤْمِنُ
u'قَالَ مِيرَاثٌ':Subject, #8: 8	قَالَ الْمَوْهُوبُ
u'قَالَ ميل':Subject, #1: 1	قَالَ الْمِيرَاثُ
u'قَالَ مِيلٌ':Subject, #1: 1	قَالَ مِيلٌ
u'قَالَ مَيْمُونٌ':Subject, #1: 1	قَالَ مِيلٌ
u'قَالَ مَيْمُونٌ':Subject, #1: 1	قَالَ مَيْمُونٌ
u'قَالَ نَابٌ':Subject, #1: 1	قَالَ مَيْمُونُ
u'قَالَ نَابِغٌ':Subject, #1: 1	قَالَ نَابُ
u'قَالَ نَابِغٌ':Subject, #2: 2	قَالَ النَّابِغَةُ
u'قَالَ نَاجِي':Subject, #6: 6	قَالَ النّابِغَةُ
u'قَالَ نَارٌ':Subject, #2: 2	قَالَ نَاجِيَةُ
u'قَالَ نَاسٌ':Predicate, #1: 1	قَالَ النّارُ
u'قَالَ نَاسٌ':Subject, #1: 1	قَالَ النَّاسَ
u'قَالَ نَاسٌ':Subject, #13: 13	قَالَ النَّاسُ
u'قَالَ نَاسٌ':Subject, #2: 2	قَالَ نَاسٌ
u'قَالٌ نَاسٌ':Added, #4: 4	قَالَ النّاسُ
u'قَالَ نَاشِئٌ':Subject, #1: 1	قَالَ النَّاسِ
u'قَالَ نَاظِرٌ':Subject, #1: 1	قَالَ نَاشِئَةُ
u'قَالَ نَاظِرٌ':Subject, #1: 1	قَالَ نَاظِرٌ
u'قَالَ نَاظِمٌ':Subject, #4: 4	قَالَ النَّاظِرُ
u'قَالَ نَاظِمٌ':Subject, #161: 161	قَالَ النَّاظِمُ
u'قَالٌ نَاظِمٌ':Added, #43: 43	قَالَ نَاظِمُ
u'قَالَ نَافِعٌ':Subject, #2: 2	قَالَ النَّاظِمِ
u'قَالَ نَافِعٌ':Subject, #3: 3	قَالَ نَافِعُ
u'قَالَ نَاقَةٌ':Subject, #76: 76	قَالَ نَافِعٌ
u'قَالَ نَاقَة':Subject, #1: 1	قَالَ نَاقَةٌ
u'قَالَ نَاقِصٌ':Subject, #1: 1	قَالَ نَاقَةٌ
u'قَالَ نَائِبٌ':Subject, #1: 1	قَالَ نَاقِصَةٌ
u'قَالَ نَبِيٌّ':Predicate, #1: 1	قَالَ النَّائِبُ
u'قَالَ نَبِيٌّ':Subject, #1: 1	قَالَ النَّبِيَّ
u'قَالَ نَبِيٌّ':Subject, #2: 2	قَالَ نَبِيُّ
u'قَالَ نَبِيذٌ':Subject, #437: 437	قَالَ النَّبِيُّ
u'قَالَ نَجاشِيّ':Subject, #2: 2	قَالَ نَبِيذُ
u'قَالَ نَجْمٌ':Subject, #1: 1	قَالَ النَّجَاشِيُّ
u'قَالَ نَجْمٌ':Subject, #13: 13	قَالَ نَجْمُ
u'قَالَ نُحَاةٌ':Subject, #1: 1	قَالَ النَّجْمُ
u'قَالَ نُحَاةٌ':Subject, #1: 1	قَالَ نُحَاةُ
u'قَالَ نَحَّاسٌ':Subject, #2: 2	قَالَ النُّحَاةُ
u'قَالَ نَحْوٌ':Predicate, #1: 1	قَالَ النّحّاسُ
u'قَالَ نَحْوٌ':Subject, #3: 3	قَالَ نَحْوَ
u'قَالَ نَحْوٌ':Subject, #1: 1	قَالَ نَحْوُ
u'قَالَ نِدَاءٌ':Subject, #1: 1	قَالَ نَحْوُهُ
u'قَالَ نَذِيرٌ':Subject, #1: 1	قَالَ نِدَاءُ
u'قَالَ نَذِيرٌ':Subject, #1: 1	قَالَ النّذِيرُ
u'قَالَ نَزَّالٌ':Subject, #1: 1	قَالَ النَّذِيرُ
u'قَالَ نَزَلٌ':Predicate, #1: 1	قَالَ النَّزَّالُ
u'قَالَ نِساءٌ':Subject, #2: 2	قَالَ نَزَلَ
u'قَالَ نِساءٌ':Subject, #2: 2	قَالَ نِسَاءٌ
u'قَالَ نِساءٌ':Subject, #4: 4	قَالَ النِّسَاءُ
u'قَالَ نَسَّاجٌ':Subject, #9: 9	قَالَ نِسَاءُ
u'قَالَ نَسَبٌ':Subject, #1: 1	قَالَ النَّسَّاجُ
u'قَالَ نُسُكٌ':Subject, #1: 1	قَالَ النَّسَبُ
u'قَالَ نَشْوَان':Predicate, #1: 1	قَالَ النُّسُكُ
u'قَالَ نَشْوَان':Subject, #1: 1	قَالَ نَشْوَانَ
u'قَالَ نَصٌّ':Predicate, #1: 1	قَالَ النَّشْوَانُ
u'قَالَ نَصٌّ':Subject, #1: 1	قَالَ نَصَّ
u'قَالَ نصاب':Subject, #1: 1	قَالَ النَّصُّ
u'قَالَ نِصَابٌ':Subject, #1: 1	قَالَ نِصَابُ
u'قَالَ نَصْرٌ':Subject, #1: 1	قَالَ نِصَابُ
u'قَالَ نَصْرٌ':Subject, #1: 1	قَالَ نَصْرٌ
u'قَالَ نَصْرَانِيٌّ':Subject, #5: 5	قَالَ نَصْرُ
u'قَالَ نَصْرَانِيٌّ':Subject, #2: 2	قَالَ النَّصْرَانِيَّةُ
u'قَالَ نَصْرَانِيَّةٌ':Subject, #3: 3	قَالَ النَّصْرَانِيُّ
u'قَالَ نِصْفٌ':Predicate, #2: 2	قَالَ النَّصْرَانِيَّةُ
u'قَالَ نِصْفٌ':Subject, #8: 8	قَالَ نِصْفَ
u'قَالَ نِصْفٌ':Subject, #3: 3	قَالَ نِصْفُهُ
u'قَالَ نِصْفٌ':Subject, #4: 4	قَالَ النِّصْفُ
u'قَالَ نَصِيبٌ':Subject, #9: 9	قَالَ نِصْفُ
u'قَالَ نَصِير':Subject, #1: 1	قَالَ نَصِيبُ
u'قَالَ نَظَّامٌ':Subject, #2: 2	قَالَ نَصِيرٌ
u'قَالَ نَظَرٌ':Predicate, #1: 1	قَالَ النَّظَّامُ
u'قَالَ نَظَرٌ':Subject, #3: 3	قَالَ نَظَرَ
u'قَالَ نَظَرٌ':Subject, #2: 2	قَالَ النَّظَرُ
u'قَالَ نَعْلٌ':Subject, #5: 5	قَالَ نَظَرٌ
u'قَالٌ نَعَمٌ':Added, #1: 1	قَالَ النَّعْلُ
u'قَالَ نُعْمَانُ':Subject, #1: 1	قَالَ النَّعَمِ
u'قَالَ نُعْمَانُ':Subject, #1: 1	قَالَ النّعْمَانُ
u'قَالَ نُعْمَانُ':Subject, #1: 1	قَالَ نُعْمَانُ
u'قَالَ نعمة':Subject, #3: 3	قَالَ النُّعْمَانُ
u'قَالَ نِعْمَةٌ':Subject, #1: 1	قَالَ نِعْمَةٌ
u'قَالَ نَفْسٌ':Subject, #1: 1	قَالَ نِعْمَةٌ
u'قَالَ نَفْسٌ':Subject, #1: 1	قَالَ نَفْسٌ
u'قَالَ نَفَقَةٌ':Subject, #1: 1	قَالَ نَفْسُهُ
u'قَالَ نَفَقَةٌ':Subject, #1: 1	قَالَ النَّفَقَةُ
u'قَالَ نَقْدٌ':Subject, #1: 1	قَالَ نَفَقَةُ
u'قَالَ نَقْد':Subject, #1: 1	قَالَ نَقْدُ
u'قَالَ نقل':Predicate, #1: 1	قَالَ نَقْدُ
u'قَالَ نقل':Subject, #1: 1	قَالَ نُقِلَ
u'قَالَ نَقْلٌ':Subject, #1: 1	قَالَ نَقْلُهُ
u'قَالَ نكاح':Subject, #1: 1	قَالَ نَقْلُهُ
u'قَالَ نِكَاحٌ':Subject, #1: 1	قَالَ نِكَاحُ
u'قَالَ نمر':Subject, #1: 1	قَالَ نِكَاحُ
u'قَالَ نَمِرٌ':Subject, #1: 1	قَالَ النَّمِرُ
u'قَالَ نَهْرٌ':Subject, #1: 1	قَالَ النَّمِرُ
u'قَالَ نَوَاجِذُ':Subject, #2: 2	قَالَ نَهْرٌ
u'قَالَ نَوَوِيٌّ':Subject, #1: 1	قَالَ نَوَاجِذُهُ
u'قَالٌ ه':Added, #280: 280	قَالَ النَّوَوِيُّ
u'قَالٌ هات':Added, #6: 6	قَالَ هَاتِ
u'قَالَ هَاشِمٌ':Subject, #6: 6	قَالَ هَاتِ
u'قَالَ هاشِمِيّ':Subject, #1: 1	قَالَ هَاشِمٌ
u'قَالَ هِبَةٌ':Subject, #1: 1	قَالَ الْهَاشِمِيُّ
u'قَالَ هِبَةٌ':Subject, #2: 2	قَالَ هِبَةٌ
u'قَالَ هُبَيْرَة':Subject, #3: 3	قَالَ الْهِبَةُ
u'قَالَ هَدِيٌّ':Predicate, #1: 1	قَالَ هُبَيْرَةُ
u'قَالَ هَدِيٌّ':Subject, #1: 1	قَالَ هَدِيَّةً
u'قَالَ هَدِيَّةٌ':Subject, #1: 1	قَالَ هَدِيَّةٌ
u'قَالَ هَرِمٌ':Subject, #1: 1	قَالَ هَدِيَّةٌ
u'قَالَ هَرَوِيّ':Subject, #1: 1	قَالَ هَرِمُ
u'قَالَ هَرَوِيّ':Subject, #20: 20	قَالَ الْهَرَوِيُّ
u'قَالَ هشام':Subject, #3: 3	قَالَ هَرَوِيٌّ
u'قَالَ هِشَامٌ':Subject, #10: 10	قَالَ هِشَامُ
u'قَالَ هشام':Subject, #10: 10	قَالَ هِشَامُ
u'قَالَ هِشَامٌ':Subject, #80: 80	قَالَ هِشَامٌ
u'قَالَ هلاك':Subject, #80: 80	قَالَ هِشَامٌ
u'قَالَ هَلاَكٌ':Subject, #1: 1	قَالَ الْهَلَاكُ
u'قَالَ هلاك':Subject, #1: 1	قَالَ الْهَلَاكُ
u'قَالَ هَلاَكٌ':Subject, #1: 1	قَالَ هَلَاكُ
u'قَالَ هِلاَلٌ':Subject, #1: 1	قَالَ هَلَاكُ
u'قَالَ هِلاَلٌ':Subject, #1: 1	قَالَ هِلاَلٌ
u'قَالَ هِلاَلٌ':Subject, #20: 20	قَالَ هِلَالٌ
u'قَالَ هَلَكٌ':Predicate, #2: 2	قَالَ هِلَالُ
u'قَالَ هَنَاءٌ':Subject, #5: 5	قَالَ هَلَكَ
u'قَالٌ هَنَوَاتٌ':Added, #1: 1	قَالَ هَنَاءٌ
u'قَالَ وَاثِقٌ':Subject, #1: 1	قَالَ هَنَوَاتٍ
u'قَالَ وَاجِبٌ':Subject, #3: 3	قَالَ الْوَاثِقُ
u'قَالَ وَاجِبٌ':Subject, #1: 1	قَالَ الْوَاجِبُ
u'قَالَ وَاجِدٌ':Subject, #1: 1	قَالَ وَاجِبٌ
u'قَالَ واحد':Predicate, #1: 1	قَالَ الْوَاجِدُ
u'قَالَ وَاحِدٌ':Predicate, #26: 26	قَالَ وَاحِدَةً
u'قَالَ واحد':Subject, #26: 26	قَالَ وَاحِدَةً
u'قَالَ وَاحِدٌ':Subject, #16: 16	قَالَ وَاحِدٌ
u'قَالَ واحد':Subject, #16: 16	قَالَ وَاحِدٌ
u'قَالَ وَاحِدٌ':Subject, #1: 1	قَالَ الْوَاحِدَةُ
u'قَالَ واحد':Subject, #1: 1	قَالَ الْوَاحِدَةُ
u'قَالَ وَاحِدٌ':Subject, #1: 1	قَالَ وَاحِدُ
u'قَالَ واحد':Subject, #1: 1	قَالَ وَاحِدُ
u'قَالَ وَاحِدٌ':Subject, #2: 2	قَالَ الْوَاحِدُ
u'قَالَ واحد':Subject, #2: 2	قَالَ الْوَاحِدُ
u'قَالَ وَاحِدٌ':Subject, #3: 3	قَالَ وَاحِدَةٌ
u'قَالٌ واحد':Added, #3: 3	قَالَ وَاحِدَةٌ
u'قَالٌ وَاحِدٌ':Added, #1: 1	قَالَ وَاحِدٍ
u'قَالَ وَارِثٌ':Subject, #1: 1	قَالَ وَاحِدٍ
u'قَالَ وَارِثٌ':Subject, #14: 14	قَالَ الْوَارِثُ
u'قَالَ وَارِثٌ':Subject, #1: 1	قَالَ وَارِثٌ
u'قَالَ وَارِدٌ':Subject, #1: 1	قَالَ وَارِثُ
u'قَالَ وَازِنٌ':Subject, #1: 1	قَالَ وَارِدُ
u'قَالَ وَاسِطٌ':Subject, #1: 1	قَالَ وَازِنٌ
u'قَالَ وَاضِعٌ':Subject, #1: 1	قَالَ الْوَاسِطَةُ
u'قَالَ وَاطِئٌ':Subject, #1: 1	قَالَ الْوَاضِعُ
u'قَالَ وَاقِعٌ':Subject, #1: 1	قَالَ الْوَاطِئُ
u'قَالَ وَاقِعٌ':Subject, #1: 1	قَالَ وَاقِعٌ
u'قَالَ وَاقِفٌ':Subject, #1: 1	قَالَ وَاقِعُ
u'قَالَ وَالِدٌ':Subject, #14: 14	قَالَ الْوَاقِفُ
u'قَالَ وَالِدٌ':Subject, #2: 2	قَالَ وَالِدُهُ
u'قَالَ وَالِدٌ':Subject, #4: 4	قَالَ وَالِدُ
u'قَالٌ وَالِدٌ':Added, #6: 6	قَالَ الْوَالِدُ
u'قَالَ وَاهِبٌ':Subject, #3: 3	قَالَ الْوَالِدَيْنِ
u'قَالَ وبر':Subject, #10: 10	قَالَ الْوَاهِبُ
u'قَالَ وَبَرٌ':Subject, #2: 2	قَالَ وَبَرُ
u'قَالَ وَتَرٌ':Predicate, #2: 2	قَالَ وَبَرُ
u'قَالَ وَثَنِيٌّ':Subject, #2: 2	قَالَ وَتَرَكَ
u'قَالَ وَجَبٌ':Predicate, #1: 1	قَالَ الْوَثَنِيُّ
u'قَالَ وَجْهٌ':Subject, #3: 3	قَالَ وَجَبَ
u'قَالَ وَجِيهٌ':Subject, #1: 1	قَالَ وَجْهُ
u'قَالَ وَدِيعٌ':Predicate, #1: 1	قَالَ وَجِيهُ
u'قَالَ وَدِيعٌ':Subject, #1: 1	قَالَ وَدِيعَةَ
u'قَالَ وَدِيعَةٌ':Predicate, #1: 1	قَالَ وَدِيعَةُ
u'قَالَ وَدِيعَةٌ':Subject, #1: 1	قَالَ وَدِيعَةَ
u'قَالَ وَدِيعَةٌ':Subject, #1: 1	قَالَ وَدِيعَةٌ
u'قَالَ وَرَثَةٌ':Subject, #1: 1	قَالَ وَدِيعَةُ
u'قَالَ وَرَثَةٌ':Subject, #2: 2	قَالَ وَرَثَتُهُ
u'قَالَ وَرَثَةٌ':Subject, #4: 4	قَالَ الْوَرَثَةُ
u'قَالَ وَرَعٌ':Subject, #5: 5	قَالَ وَرَثَةُ
u'قَالَ وَرَقَةٌ':Subject, #1: 1	قَالَ الْوَرَعُ
u'قَالٌ وَزْنٌ':Added, #5: 5	قَالَ وَرَقَةُ
u'قَالَ وَزِيرٌ':Subject, #1: 1	قَالَ وَزْنِ
u'قَالَ وسط':Predicate, #1: 1	قَالَ الْوَزِيرُ
u'قَالَ وَسَطٌ':Predicate, #1: 1	قَالَ وَسَطَ
u'قَالَ وَصِيٌّ':Subject, #1: 1	قَالَ وَسَطَ
u'قَالَ وَصِيٌّ':Subject, #1: 1	قَالَ الْوَصِيَّةُ
u'قَالَ وَصِيٌّ':Subject, #1: 1	قَالَ وَصِيٌّ
u'قَالَ وَصِيَّةٌ':Subject, #31: 31	قَالَ الْوَصِيُّ
u'قَالَ وَضْعٌ':Subject, #1: 1	قَالَ الْوَصِيَّةُ
u'قَالَ وَظِيفٌ':Subject, #1: 1	قَالَ وَضْعُ
u'قَالَ وَظِيفَةٌ':Subject, #1: 1	قَالَ وَظِيفَةُ
u'قَالَ وَقَارٌ':Subject, #1: 1	قَالَ وَظِيفَةُ
u'قَالَ وَقَارٌ':Subject, #1: 1	قَالَ الْوَقَارُ
u'قَالَ وَقْتٌ':Predicate, #1: 1	قَالَ وَقَارُهُ
u'قَالَ وقع':Predicate, #3: 3	قَالَ وَقْتَ
u'قَالَ وَقْفٌ':Subject, #1: 1	قَالَ وَقَعَ
u'قَالَ وَقْفٌ':Subject, #1: 1	قَالَ الْوَقْفُ
u'قَالَ وَقْفٌ':Subject, #1: 1	قَالَ وَقْفُ
u'قَالَ وقفة':Subject, #2: 2	قَالَ وَقْفٌ
u'قَالَ وَكِيلٌ':Subject, #3: 3	قَالَ وَقَفْتُهُ
u'قَالَ وَكِيلٌ':Subject, #1: 1	أَقَالَ الْوَكِيلُ
u'قَالَ وَكِيلٌ':Subject, #2: 2	قَالَ وَكِيلُ
u'قَالَ وَلاَءٌ':Subject, #44: 44	قَالَ الْوَكِيلُ
u'قَالَ وَلاَءٌ':Subject, #1: 1	قَالَ الْوَلَاءُ
u'قَالَ ولد':Predicate, #2: 2	قَالَ الْوَلاَءُ
u'قَالَ ولد':Predicate, #1: 1	قَالَ وَلَدَ
u'قَالَ وَلَدٌ':Predicate, #1: 1	قَالَ وُلِدَ
u'قَالَ ولد':Subject, #1: 1	قَالَ وَلَدَ
u'قَالَ وَلَدٌ':Subject, #2: 2	قَالَ الْوَلَدُ
u'قَالَ ولد':Subject, #2: 2	قَالَ الْوَلَدُ
u'قَالَ وَلَدٌ':Subject, #3: 3	قَالَ وَلَدُ
u'قَالَ ولد':Subject, #3: 3	قَالَ وَلَدُ
u'قَالَ وَلَدٌ':Subject, #4: 4	قَالَ وَلَدُهُ
u'قَالٌ ولد':Added, #4: 4	قَالَ وَلَدُهُ
u'قَالٌ وَلَدٌ':Added, #1: 1	قَالَ وَلَدِ
u'قَالَ وَلَهٌ':Subject, #1: 1	قَالَ وَلَدِ
u'قَالَ وَلِيٌّ':Subject, #13: 13	قَالَ وَلَهُ
u'قَالَ وَلِيٌّ':Subject, #10: 10	قَالَ وَلِيُّ
u'قَالَ وَلِيٌّ':Subject, #2: 2	قَالَ وَلِيٌّ
u'قَالَ وَلِيدٌ':Subject, #38: 38	قَالَ الْوَلِيُّ
u'قَالَ وهاب':Predicate, #24: 24	قَالَ الْوَلِيدُ
u'قَالَ وهبة':Subject, #1: 1	قَالَ وَهَابَ
u'قَالَ وهبة':Subject, #1: 1	قَالَ وَهَبْتُهُ
u'قَالَ يَتِيمٌ':Subject, #2: 2	قَالَ وَهِبَتُهُ
u'قَالَ يَعْقُوبٌ':Predicate, #2: 2	قَالَ الْيَتِيمُ
u'قَالَ يَعْقُوبٌ':Subject, #1: 1	قَالَ يَعْقُوبَ
u'قَالَ يمان':Subject, #47: 47	قَالَ يَعْقُوبُ
u'قَالَ يَمِينٌ':Subject, #1: 1	قَالَ الْيَمَانُ
u'قَالَ يَمِينٌ':Subject, #1: 1	قَالَ الْيَمِينُ
u'قَالٌ يَمِينٌ':Added, #1: 1	قَالَ يَمِينٌ
u'قَالَ يَنَابِيعُ':Subject, #1: 1	قَالَ يَمِينٍ
u'قَالَ يَهُودِيٌّ':Subject, #1: 1	قَالَ الْيَنَابِيعُ
u'قَالَ يَهُودِيٌّ':Subject, #5: 5	قَالَ يَهُودِيٌّ
u'قَالَ يَوْمٌ':Predicate, #7: 7	قَالَ الْيَهُودِيُّ
u'قَالَ يَوْمٌ':Predicate, #15: 15	قَالَ الْيَوْمَ
u'قَالَ يَوْمٌ':Subject, #65: 65	قَالَ يَوْمَ
u'قَالَ يَوْمٌ':Subject, #1: 1	قَالَ يَوْمٌ
u'قَالَ يَوْمٌ':Subject, #1: 1	قَالَ يَوْمُهُ
u'قَالَ يَوْمٌ':Subject, #2: 2	قَالَ الْيَوْمُ
u'قَامَ أَبٌ':Subject, #3: 3	قَالَ يَوْمُ
u'قَامَ أَبٌ':Subject, #2: 2	أَقَامَ الْأَبُ
u'قَامَ اِبْنٌ':Subject, #3: 3	قَامَ الْأَبُ
u'قَامَ اِبْنٌ':Subject, #1: 1	قَامَ ابْنُهُ
u'قَامَ اِبْنٌ':Subject, #2: 2	أَقَامَ ابْنُ
u'قَامَ أَجَلٌ':Predicate, #6: 6	قَامَ ابْنُ
u'قَامَ إِجْمَاعٌ':Subject, #1: 1	أَقَامَ الْأَجَلَ
u'قَامَ أَجْنَبِيٌّ':Predicate, #11: 11	قَامَ الْإِجْمَاعُ
u'قَامَ أَجْنَبِيٌّ':Subject, #1: 1	أَقَامَ الْأَجْنَبِيَّ
u'قَامَ أحَدٌ':Subject, #5: 5	أَقَامَ الْأَجْنَبِيُّ
u'قَامَ أحَدٌ':Subject, #1: 1	أَقَامَ أَحَدٌ
u'قَامَ أحَدٌ':Subject, #1: 1	قَامَ أَحَدُ
u'قَامَ أحَدٌ':Subject, #6: 6	قَامَ أَحَدٌ
u'قَامَ أَخٌ':Subject, #7: 7	أَقَامَ أَحَدُ
u'قَامَ آدَمُ':Subject, #8: 8	أَقَامَ الْأَخُ
u'قَامَ إِذْنٌ':Subject, #1: 1	أَقَامَ آدَمُ
u'قَامَ أَرْبَعَةٌ':Predicate, #1: 1	قَامَ الْإِذْنُ
u'قَامَ أَرْبَعَةٌ':Subject, #1: 1	أَقَامَ أَرْبَعَةَ
u'قَامَ أَسْفَلُ':Predicate, #1: 1	أَقَامَ أَرْبَعَةٌ
u'قَامَ إِسْلامٌ':Subject, #1: 1	أَقَامَ أَسْفَلَ
u'قَامَ إِسْلامٌ':Subject, #1: 1	قَامَ الإِسْلاَمُ
u'قَامَ أَشْهُرٌ':Predicate, #4: 4	قَامَ الْإِسْلَامُ
u'قَامَ أَصْحَابٌ':Subject, #1: 1	أَقَامَ الْأَشْهُرَ
u'قَامَ اِعْتِدالٌ':Predicate, #1: 1	قَامَ أَصْحَابُ
u'قَامَ أعْرَابِيٌّ':Subject, #1: 1	أَقَامَ اعْتِدَالَ
u'قَامَ أَعْيَارٌ':Predicate, #2: 2	قَامَ أَعْرَابِيٌّ
u'قَامَ أفْضَلُ':Predicate, #1: 1	أَقَامَ الْأَعْيَارَ
u'قَامَ أَقْوَالٌ':Predicate, #1: 1	أَقَامَ الأَفْضَلَ
u'قَامَ أَقْوَامٌ':Subject, #1: 1	أَقَامَ أَقْوَالَ
u'قَامَ أكْبَرُ':Subject, #1: 1	قَامَ أَقْوَامٌ
u'قَامَ أَكْثَرُ':Predicate, #1: 1	أَقَامَ الْأَكْبَرُ
u'قَامَ أَكْثَرُ':Predicate, #3: 3	أَقَامَ الْأَكْثَرَ
u'قَامَ أكل':Predicate, #6: 6	أَقَامَ أَكْثَرَ
u'قَامَ أَكْلٌ':Predicate, #1: 1	أَقَامَ الْأَكْلَ
u'قَامَ إمَامٌ':Subject, #1: 1	أَقَامَ الْأَكْلَ
u'قَامَ إمَامٌ':Subject, #2: 2	أَقَامَ الْإِمَامُ
u'قَامَ إمَامٌ':Subject, #36: 36	قَامَ الْإِمَامُ
u'قَامَ إمَامٌ':Subject, #3: 3	قَامَ الإِمَامُ
u'قَامَ إمَامٌ':Subject, #3: 3	قَامَ إمَامٌ
u'قَامَ آمِرٌ':Subject, #7: 7	قَامَ إمَامُهُ
u'قَامَ أُمِّيٌّ':Subject, #1: 1	قَامَ الْآمِرُ
u'قَامَ أَميرٌ':Subject, #1: 1	قَامَ الْأُمِّيُّ
u'قَامَ إِنْسانٌ':Subject, #1: 1	قَامَ الْأَمِيرُ
u'قَامَ إِنْفاقٌ':Subject, #2: 2	قَامَ إنْسَانٌ
u'قَامَ أهْلٌ':Subject, #1: 1	قَامَ الْإِنْفَاقُ
u'قَامَ أَهْلِيٌّ':Predicate, #4: 4	أَقَامَ أَهْلُ
u'قَامَ أهْلِيَّةٌ':Predicate, #1: 1	أَقَامَ الْأَهْلِيَّةَ
u'قَامَ أَوَّلُ':Subject, #1: 1	أَقَامَ الْأَهْلِيَّةَ
u'قَامَ أَوْلاَدٌ':Subject, #6: 6	أَقَامَ الْأَوَّلُ
u'قَامَ أَوْلِيَاءُ':Subject, #1: 1	أَقَامَ أَوْلَادُ
u'قَامَ أئِمَّةٌ':Subject, #1: 1	قَامَ الْأَوْلِيَاءُ
u'قَامَ أيَّامٌ':Predicate, #1: 1	أَقَامَ الْأَئِمَّةُ
u'قَامَ أَيَّامٌ':Predicate, #1: 1	أَقَامَ أَيَّامَ
u'قَامَ بالٌ':Predicate, #1: 1	أَقَامَ أَيَّامَ
u'قَامَ بَالٌ':Predicate, #1: 1	قَامَ بَالَ
u'قَامَ بَائِعٌ':Subject, #1: 1	قَامَ بَالَ
u'قَامَ بُرْهانٌ':Subject, #23: 23	أَقَامَ الْبَائِعُ
u'قَامَ بُرْهَانٌ':Subject, #1: 1	قَامَ الْبُرْهَانُ
u'قَامَ بَطَلٌ':Predicate, #1: 1	قَامَ الْبُرْهَانُ
u'قَامَ بَعْضٌ':Predicate, #2: 2	قَامَ بَطَلَ
u'قَامَ بَعْضٌ':Subject, #3: 3	أَقَامَ بَعْضَ
u'قَامَ بَقِيَّةٌ':Predicate, #6: 6	قَامَ بَعْضُ
u'قَامَ بَقِيَّةٌ':Subject, #1: 1	أَقَامَ بَقِيَّةَ
u'قَامَ بَيْنٌ':Predicate, #1: 1	قَامَ بَقِيَّةُ
u'قَامَ بَيِّنَةٌ':Predicate, #7: 7	قَامَ بَيْنَ
u'قَامَ بَيِّنَةٌ':Subject, #388: 388	أَقَامَ الْبَيِّنَةَ
u'قَامَةٌ إِنْسانٌ':Added, #1: 1	أَقَامَ بَيِّنَةٌ
u'قَامَةٌ رَجُلٌ':Added, #1: 1	قَامَةِ الْإِنْسَانِ
u'قَامَةٌ رَجُلٌ':Added, #1: 1	قَامَةُ الرَّجُلِ
u'قَامَةٌ شَخْصٌ':Added, #9: 9	قَامَةِ الرَّجُلِ
u'قَامَةٌ مَارٌّ':Added, #1: 1	قَامَةِ شَخْصِ
u'قَامَ تارِك':Subject, #1: 1	قَامَةِ الْمَارِّ
u'قَامَ تِسْعَةٌ':Predicate, #3: 3	أَقَامَ تَارِكٌ
u'قَامَ تَصَدُّقٌ':Predicate, #1: 1	أَقَامَ تِسْعَةَ
u'قَامَ ثَالِثٌ':Predicate, #1: 1	أَقَامَ التَّصَدُّقَ
u'قَامَ ثَالِثٌ':Subject, #1: 1	قَامَ الثَّالِثَةَ
u'قَامَ ثَالِثٌ':Subject, #2: 2	أَقَامَ الثَّالِثُ
u'قَامَ ثَانِي':Predicate, #3: 3	أَقَامَ ثَالِثٌ
u'قَامَ ثَانِيَةٌ':Predicate, #2: 2	قَامَ الثَّانِيَةَ
u'قَامَ ثَلاثَةٌ':Predicate, #2: 2	قَامَ الثَّانِيَةَ
u'قَامَ ثَمانِيَةٌ':Predicate, #1: 1	أَقَامَ ثَلَاثَةَ
u'قَامَ جَالِسٌ':Subject, #1: 1	أَقَامَ ثَمَانِيَةَ
u'قَامَ جَانِبٌ':Predicate, #1: 1	قَامَ الْجَالِسُ
u'قَامَ جَبَلٌ':Subject, #1: 1	قَامَ جَانِبَ
u'قَامَ جَمَاعَةٌ':Subject, #1: 1	قَامَ الْجَبَلُ
u'قَامَ جمعة':Predicate, #1: 1	قَامَ جَمَاعَةٌ
u'قَامَ جُمُعَةٌ':Predicate, #3: 3	أَقَامَ الْجُمُعَةَ
u'قَامَ حاضِرٌ':Subject, #3: 3	أَقَامَ الْجُمُعَةَ
u'قَامَ حاكِمٌ':Subject, #3: 3	أَقَامَ الْحَاضِرُ
u'قَامَ حاكِمٌ':Subject, #6: 6	أَقَامَ الْحَاكِمُ
u'قَامَ حَدٌّ':Predicate, #8: 8	قَامَ الْحَاكِمُ
u'قَامَ حَدٌّ':Predicate, #2: 2	أَقَامَ حَدَّ
u'قَامَ حَقٌّ':Subject, #9: 9	أَقَامَ الْحَدَّ
u'قَامَ حَمَلٌ':Predicate, #1: 1	قَامَ الْحَقُّ
u'قَامَ حَيٌّ':Subject, #1: 1	قَامَ حَمَلَ
u'قَامَ خَارِجٌ':Predicate, #1: 1	أَقَامَ الْحَيُّ
u'قَامَ خَارِجٌ':Subject, #1: 1	أَقَامَ خَارِجَ
u'قَامَ خَارِجٌ':Subject, #1: 1	أَقَامَ خَارِجٌ
u'قَامَ خراج':Subject, #28: 28	أَقَامَ الْخَارِجُ
u'قَامَ خَرَاجٌ':Subject, #1: 1	قَامَ الْخَرَاجُ
u'قَامَ خَصْمٌ':Subject, #1: 1	قَامَ الْخَرَاجُ
u'قَامَ خَصْمٌ':Subject, #1: 1	أَقَامَ الْخَصْمُ
u'قَامَ خطباء':Subject, #1: 1	أَقَامَ خَصْمُهُ
u'قَامَ خَلْفٌ':Predicate, #2: 2	قَامَ خُطَبَاءُ
u'قَامَ خَلِيفَةٌ':Subject, #1: 1	قَامَ خَلْفَ
u'قَامَ خَمْسَةٌ':Predicate, #1: 1	قَامَ الْخَلِيفَةُ
u'قَامَ دَاخِلٌ':Subject, #3: 3	أَقَامَ خَمْسَةَ
u'قَامَ دَلالَةٌ':Subject, #2: 2	أَقَامَ الدَّاخِلُ
u'قَامَ دَليلٌ':Predicate, #1: 1	قَامَ دَلَالَةُ
u'قَامَ دَليلٌ':Subject, #3: 3	أَقَامَ الدَّلِيلَ
u'قَامَ دَليلٌ':Subject, #10: 10	قَامَ دَلِيلُ
u'قَامَ دَليلٌ':Subject, #1: 1	قَامَ الدّلِيلُ
u'قَامَ دَليلٌ':Subject, #2: 2	قَامَ دَلِيلُهُ
u'قَامَ دونٌ':Predicate, #56: 56	قَامَ الدَّلِيلُ
u'قَامَ دِينٌ':Predicate, #1: 1	أَقَامَ دُونَ
u'قَامَ ذِمِّيٌّ':Subject, #1: 1	أَقَامَ الدِّينَ
u'قَامَ ذِمِّيٌّ':Subject, #1: 1	أَقَامَ ذِمِّيٌّ
u'قَامَ رابع':Subject, #2: 2	أَقَامَ الذِّمِّيُّ
u'قَامَ رَابِعٌ':Subject, #1: 1	قَامَ الرَّابِعُ
u'قَامَ رَاهِنٌ':Subject, #1: 1	قَامَ الرَّابِعُ
u'قَامَ رَاهِنٌ':Subject, #1: 1	قَامَ الرَّاهِنُ
u'قَامَ رَأْيٌ':Predicate, #7: 7	أَقَامَ الرَّاهِنُ
u'قَامَ رَأْيٌ':Subject, #1: 1	أَقَامَ رَأْيَ
u'قَامَ رَبُّ':Subject, #1: 1	قَامَ رَأْيُهُ
u'قَامَ رَبُّ':Subject, #1: 1	قَامَ رَبُّهُ
u'قَامَ رُبُعٌ':Subject, #7: 7	أَقَامَ رَبُّ
u'قَامَ رَبِيعَةٌ':Subject, #1: 1	قَامَ رُبُعُ
u'قَامَ رِجَالٌ':Subject, #1: 1	قَامَ رَبِيعَةُ
u'قَامَ رَجُلٌ':Predicate, #1: 1	قَامَ الرِّجَالُ
u'قَامَ رَجُلٌ':Subject, #1: 1	أَقَامَ الرَّجُلَ
u'قَامَ رَجُلٌ':Subject, #10: 10	أَقَامَ الرَّجُلُ
u'قَامَ رَجُلٌ':Subject, #35: 35	قَامَ رَجُلٌ
u'قَامَ رَجُلٌ':Subject, #64: 64	أَقَامَ رَجُلٌ
u'قَامَ رَسُولٌ':Subject, #8: 8	قَامَ الرَّجُلُ
u'قَامَ رَسُولٌ':Subject, #28: 28	أَقَامَ رَسُولُ
u'قَامَ رَشيدٌ':Subject, #72: 72	قَامَ رَسُولُ
u'قَامَ رَمَضانُ':Predicate, #1: 1	قَامَ الرَّشِيدُ
u'قَامَ زادٌ':Predicate, #11: 11	قَامَ رَمَضَانَ
u'قَامَ زادٌ':Predicate, #1: 1	أَقَامَ زَادَ
u'قَامَ زَوْجٌ':Subject, #1: 1	قَامَ زَادَ
u'قَامَ زَوْجٌ':Subject, #1: 1	أَقَامَ زَوْجُ
u'قَامَ زَيْدٌ':Subject, #25: 25	أَقَامَ الزَّوْجُ
u'قَامَ زَيْدٌ':Subject, #1: 1	أَقَامَ زَيْدٌ
u'قَامَ سَاعَةٌ':Predicate, #49: 49	قَامَ زَيْدٌ
u'قَامَ سَاكِنٌ':Subject, #1: 1	قَامَ سَاعَةَ
u'قَامَ سائِل':Subject, #2: 2	أَقَامَ السَّاكِنُ
u'قَامَ سَائِلٌ':Subject, #2: 2	قَامَ سَائِلٌ
u'قَامَ سَبَبٌ':Subject, #2: 2	قَامَ سَائِلٌ
u'قَامَ سَبْعٌ':Predicate, #1: 1	قَامَ السَّبَبُ
u'قَامَ سَبْعَةٌ':Predicate, #2: 2	أَقَامَ سَبْعَ
u'قَامَ سَتْرٌ':Subject, #1: 1	أَقَامَ سَبْعَةَ
u'قَامَ سَعْدٌ':Subject, #1: 1	قَامَ السَّتْرُ
u'قَامَ سَفَرٌ':Subject, #1: 1	أَقَامَ سَعْدٌ
u'قَامَ سِقَايَةٌ':Predicate, #1: 1	قَامَ السَّفَرُ
u'قَامَ سقط':Predicate, #1: 1	أَقَامَ سِقَايَةَ
u'قَامَ سَقَطٌ':Predicate, #6: 6	قَامَ سَقَطَ
u'قَامَ سَلِسٌ':Predicate, #6: 6	قَامَ سَقَطَ
u'قَامَ سُلْطَانٌ':Subject, #1: 1	قَامَ سَلِسَ
u'قَامَ سُنَّةٌ':Predicate, #1: 1	قَامَ السُّلْطَانُ
u'قَامَ سَهْلٌ':Subject, #1: 1	أَقَامَ السُّنَّةَ
u'قَامَ سَيِّدٌ':Subject, #1: 1	قَامَ سَهْلُ
u'قَامَ شَابٌّ':Subject, #4: 4	أَقَامَ السَّيِّدُ
u'قَامَ شافِعِيّ':Subject, #1: 1	قَامَ الشَّابُّ
u'قَامَ شَاهِدٌ':Subject, #1: 1	أَقَامَ الشَّافِعِيُّ
u'قَامَ شَاهِدٌ':Subject, #1: 1	أَقَامَ شَاهِدٌ
u'قَامَ شَاهِدٌ':Subject, #1: 1	قَامَ شَاهِدٌ
u'قَامَ شُبْهَةٌ':Predicate, #2: 2	أَقَامَ الشَّاهِدُ
u'قَامَ شَخْصٌ':Subject, #1: 1	أَقَامَ شُبْهَةَ
u'قَامَ شَرْطٌ':Subject, #2: 2	أَقَامَ شَخْصٌ
u'قَامَ شَرْعٌ':Subject, #1: 1	قَامَ شَرْطُ
u'قَامَ شَرِيكٌ':Subject, #1: 1	أَقَامَ الشَّرْعُ
u'قَامَ شَرِيكٌ':Subject, #1: 1	أَقَامَ الشَّرِيكُ
u'قَامَ شَطْرٌ':Predicate, #1: 1	قَامَ الشَّرِيكُ
u'قَامَ شَفِيعٌ':Subject, #1: 1	أَقَامَ شَطْرَ
u'قَامَ شَفِيعٌ':Subject, #2: 2	قَامَ الشَّفِيعُ
u'قَامَ شَهَادَةٌ':Predicate, #7: 7	أَقَامَ الشَّفِيعُ
u'قَامَ شَهْرٌ':Predicate, #2: 2	أَقَامَ الشَّهَادَةَ
u'قَامَ شَهْرٌ':Predicate, #1: 1	أَقَامَ الشَّهْرَ
u'قَامَ شَهْرٌ':Predicate, #1: 1	أَقَامَ شَهْرَ
u'قَامَ شُهُودٌ':Subject, #1: 1	قَامَ الشَّهْرَ
u'قَامَ شُهُودٌ':Subject, #1: 1	أَقَامَ الشُّهُودُ
u'قَامَ شَيْءٌ':Predicate, #1: 1	قَامَ الشُّهُودُ
u'قَامَ شَيْءٌ':Subject, #1: 1	أَقَامَ الشَّيْءَ
u'قَامَ شَيْخٌ':Subject, #2: 2	قَامَ شَيْءٌ
u'قَامَ صَاحِبٌ':Subject, #1: 1	أَقَامَ الشَّيْخُ
u'قَامَ صَاحِبٌ':Subject, #17: 17	أَقَامَ صَاحِبُ
u'قَامَ صَلاَةٌ':Predicate, #1: 1	قَامَ صَاحِبُ
u'قَامَ صَلاَةٌ':Predicate, #11: 11	أَقَامَ الصَّلاَةَ
u'قَامَ طَالِبٌ':Subject, #4: 4	أَقَامَ الصَّلَاةَ
u'قَامَ طعام':Predicate, #7: 7	أَقَامَ الطَّالِبُ
u'قَامَ طَعَامٌ':Predicate, #1: 1	أَقَامَ الطَّعَامَ
u'قَامَ ظَنٌّ':Predicate, #1: 1	أَقَامَ الطَّعَامَ
u'قَامَ عَادٌ':Predicate, #1: 1	أَقَامَ الظَّنَّ
u'قَامَ عَادَةٌ':Predicate, #2: 2	قَامَ عَادَ
u'قَامَ عَامٌ':Predicate, #1: 1	أَقَامَ الْعَادَةَ
u'قَامَ عَبْدٌ':Subject, #1: 1	أَقَامَ عَامَ
u'قَامَ عَبْدٌ':Subject, #20: 20	أَقَامَ الْعَبْدُ
u'قَامَ عَبْدٌ':Subject, #2: 2	أَقَامَ عَبْدٌ
u'قَامَ عَبْدٌ':Subject, #2: 2	قَامَ الْعَبْدُ
u'قَامَ عَبْدٌ':Subject, #4: 4	أَقَامَ عَبْدُ
u'قَامَ عتبة':Subject, #9: 9	قَامَ عَبْدُ
u'قَامَ عجز':Predicate, #1: 1	قَامَ عُتْبَةُ
u'قَامَ عَجُوزٌ':Predicate, #1: 1	قَامَ عَجَزَ
u'قَامَ عُدٌّ':Predicate, #1: 1	أَقَامَ الْعَجُوزَ
u'قَامَ عَدْلٌ':Subject, #4: 4	قَامَ عُدَّ
u'قَامَ عَدُوٌّ':Subject, #1: 1	أَقَامَ الْعَدْلُ
u'قَامَ عَرَضٌ':Subject, #1: 1	أَقَامَ الْعَدُوُّ
u'قَامَ عَزْمٌ':Subject, #1: 1	قَامَ الْعَرَضُ
u'قَامَ عَسْكَرٌ':Subject, #1: 1	قَامَ الْعَزْمُ
u'قَامَ عِشَاءٌ':Predicate, #1: 1	أَقَامَ الْعَسْكَرُ
u'قَامَ عَشْرٌ':Predicate, #3: 3	أَقَامَ الْعِشَاءَ
u'قَامَ عصبة':Predicate, #2: 2	قَامَ الْعَشْرَ
u'قَامَ عَصَبَةٌ':Predicate, #1: 1	أَقَامَ عَصَبَةَ
u'قَامَ عصبة':Subject, #1: 1	أَقَامَ عَصَبَةَ
u'قَامَ عَصَبَةٌ':Subject, #1: 1	قَامَ عَصَبَةُ
u'قَامَ عَصْرٌ':Predicate, #1: 1	قَامَ عَصَبَةُ
u'قَامَ عَقِبٌ':Predicate, #1: 1	أَقَامَ الْعَصْرَ
u'قَامَ عَلِيٌّ':Subject, #1: 1	قَامَ عَقِبَ
u'قَامَ عَلِيٌّ':Subject, #1: 1	قَامَ عَلِيُّ
u'قَامَ عُمَرٌ':Subject, #5: 5	قَامَ عَلِيٌّ
u'قَامَ عُمَرٌ':Subject, #14: 14	قَامَ عُمَرُ
u'قَامَ عند':Predicate, #1: 1	أَقَامَ عُمَرُ
u'قَامَ عند':Predicate, #1: 1	أَقَامَ عِنْدَهُنَّ
u'قَامَ عند':Predicate, #22: 22	أَقَامَ عِنْدَ
u'قَامَ عِوَضٌ':Subject, #8: 8	قَامَ عِنْدَ
u'قَامَ عِيدٌ':Predicate, #1: 1	قَامَ الْعِوَضُ
u'قَامَ عُيُونٌ':Subject, #1: 1	أَقَامَ الْعِيدَ
u'قَامَ غَاصِبٌ':Subject, #1: 1	قَامَ الْعُيُونُ
u'قَامَ غرماء':Subject, #8: 8	أَقَامَ الْغَاصِبُ
u'قَامَ غَرِيمٌ':Subject, #5: 5	قَامَ الْغُرَمَاءُ
u'قَامَ غَرِيمٌ':Subject, #1: 1	قَامَ غَرِيمُهُ
u'قَامَ غُلاَمٌ':Subject, #7: 7	أَقَامَ الْغَرِيمُ
u'قَامَ غير':Subject, #2: 2	أَقَامَ الْغُلَامُ
u'قَامَ غَيْرٌ':Subject, #1: 1	أَقَامَ غَيْرُ
u'قَامَ غير':Subject, #1: 1	أَقَامَ غَيْرُ
u'قَامَ غَيْرٌ':Subject, #3: 3	قَامَ غَيْرُهُ
u'قَامَ غير':Subject, #3: 3	قَامَ غَيْرُهُ
u'قَامَ غَيْرٌ':Subject, #5: 5	أَقَامَ غَيْرُهُ
u'قَامَ فساد':Subject, #5: 5	أَقَامَ غَيْرُهُ
u'قَامَ فَسَادٌ':Subject, #1: 1	قَامَ فَسَادُهُ
u'قَامَ فِعْلٌ':Subject, #1: 1	قَامَ فَسَادُهُ
u'قَامَ فلان':Subject, #1: 1	قَامَ فِعْلُهُ
u'قَامَ فلان':Subject, #1: 1	أَقَامَ الشَّافِعِيُّ
u'قَامَ فلان':Subject, #1: 1	أَقَامَ بِلَالٌ
u'قَامَ فُلاَنٌ':Subject, #1: 1	أَقَامَ بِلاَلٌ
u'قَامَ فلان':Subject, #1: 1	قَامَ فُلاَنٌ
u'قَامَ فلان':Subject, #1: 1	قَامَ مُعَاوِيَةُ
u'قَامَ فلان':Subject, #2: 2	أَقَامَ عُثْمَانُ
u'قَامَ فلان':Subject, #2: 2	قَامَ الزُّبَيْرُ
u'قَامَ فلان':Subject, #2: 2	قَامَ الْمِقْدَادُ
u'قَامَ فُلاَنٌ':Subject, #2: 2	قَامَ زِيَادٌ
u'قَامَ فَيْءٌ':Subject, #4: 4	قَامَ فُلَانٌ
u'قَامَ قَاتِلٌ':Subject, #1: 1	قَامَ الْفَيْءُ
u'قَامَ قَاذِفٌ':Subject, #5: 5	أَقَامَ الْقَاتِلُ
u'قَامَ قَاذِفٌ':Subject, #1: 1	قَامَ الْقَاذِفُ
u'قَامَ قَاطِعٌ':Subject, #5: 5	أَقَامَ الْقَاذِفُ
u'قَامَ قَالٌ':Predicate, #1: 1	قَامَ الْقَاطِعُ
u'قَامَ قَائِمٌ':Subject, #6: 6	قَامَ قَالَ
u'قَامَ قتل':Predicate, #1: 1	قَامَ قَائِمٌ
u'قَامَ قَدْرٌ':Predicate, #1: 1	أَقَامَ قَتَلَ
u'قَامَ قول':Subject, #3: 3	قَامَ قَدْرَ
u'قَامَ قَوْلٌ':Subject, #1: 1	أَقَامَ الْقَوْلُ
u'قَامَ قَوْمٌ':Subject, #1: 1	أَقَامَ الْقَوْلُ
u'قَامَ قَوْمٌ':Subject, #1: 1	قَامَ قَوْمٌ
u'قَامَ قَوْمٌ':Subject, #21: 21	قَامَ الْقَوْمُ
u'قَامَ قَيِّمٌ':Subject, #2: 2	أَقَامَ قَوْمٌ
u'قَامَ قَيِّمٌ':Subject, #1: 1	أَقَامَ الْقَيِّمُ
u'قَامَ قِيمَةٌ':Predicate, #1: 1	أَقَامَ قَيِّمُ
u'قَامَ كَافِرٌ':Subject, #1: 1	أَقَامَ الْقِيمَةَ
u'قَامَ كَفِيلٌ':Subject, #1: 1	أَقَامَ كَافِرٌ
u'قَامَ كَفِيلٌ':Subject, #1: 1	قَامَ الْكَفِيلُ
u'قَامَ كَلاَمٌ':Predicate, #3: 3	أَقَامَ الْكَفِيلُ
u'قَامَ كَوْنٌ':Subject, #1: 1	أَقَامَ الْكَلَامَ
u'قَامَ لعان':Subject, #1: 1	قَامَ كَوْنُهُ
u'قَامَ لَفْظٌ':Subject, #1: 1	قَامَ اللِّعَانُ
u'قَامَ لَفْظَةٌ':Subject, #1: 1	قَامَ لَفْظُ
u'قَامَ لَيْلٌ':Predicate, #1: 1	قَامَ لَفْظَةٌ
u'قَامَ لَيْلٌ':Predicate, #1: 1	قَامَ اللَّيْلَةَ
u'قَامَ لَيْلٌ':Predicate, #3: 3	قَامَ اللَّيْلَ
u'قَامَ لَيْلٌ':Predicate, #6: 6	قَامَ لَيْلَةَ
u'قَامَ مَالٌ':Subject, #7: 7	قَامَ لَيْلَةً
u'قَامَ مَالِكٌ':Subject, #2: 2	أَقَامَ الْمَالُ
u'قَامَ مَالِكٌ':Subject, #1: 1	أَقَامَ مَالِكٌ
u'قَامَ مَالِكٌ':Subject, #1: 1	قَامَ الْمَالِكُ
u'قَامَ مَالِكٌ':Subject, #1: 1	قَامَ مَالِكٌ
u'قَامَ مَأْمُورٌ':Subject, #7: 7	أَقَامَ الْمَالِكُ
u'قَامَ مَأْمُورٌ':Subject, #1: 1	قَامَ الْمَأْمُورُ
u'قَامَ مَانِعٌ':Subject, #2: 2	أَقَامَ الْمَأْمُورُ
u'قَامَ مُتَطَوِّعٌ':Subject, #4: 4	قَامَ الْمَانِعُ
u'قَامَ مَحْبُوسٌ':Subject, #1: 1	قَامَ الْمُتَطَوِّعُ
u'قَامَ مُحْتَالٌ':Subject, #1: 1	أَقَامَ الْمَحْبُوسُ
u'قَامَ مَحْكُومٌ':Subject, #1: 1	أَقَامَ الْمُحْتَالُ
u'قَامَ مُحَمَّدٌ':Subject, #1: 1	أَقَامَ الْمَحْكُومُ
u'قَامَ مُحَمَّدٌ':Subject, #1: 1	قَامَ مُحَمَّدٌ
u'قَامَ مَخْرَجٌ':Predicate, #2: 2	أَقَامَ مُحَمَّدٌ
u'قَامَ مُدَبَّرٌ':Subject, #1: 1	أَقَامَ الْمَخْرَجَ
u'قَامَ مُدَّةٌ':Predicate, #1: 1	قَامَ الْمُدَبَّرُ
u'قَامَ مُدْرِكٌ':Subject, #1: 1	أَقَامَ مُدَّةَ
u'قَامَ مَدْفُوعٌ':Subject, #1: 1	قَامَ مُدْرِكُ
u'قَامَ مَدْيُونٌ':Subject, #2: 2	قَامَ الْمَدْفُوعُ
u'قَامَ مُرْتَهِنٌ':Subject, #2: 2	أَقَامَ الْمَدْيُونُ
u'قَامَ مُرْتَهِنٌ':Subject, #2: 2	قَامَ الْمُرْتَهِنُ
u'قَامَ مُسَافِرٌ':Subject, #3: 3	أَقَامَ الْمُرْتَهِنُ
u'قَامَ مُسَافِرٌ':Subject, #2: 2	قَامَ الْمُسَافِرُ
u'قَامَ مَسْبُوق':Subject, #5: 5	أَقَامَ الْمُسَافِرُ
u'قَامَ مَسْبُوق':Subject, #1: 1	قَامَ مَسْبُوقٌ
u'قَامَ مُسْتَأْجِرٌ':Subject, #9: 9	قَامَ الْمَسْبُوقُ
u'قَامَ مُسْتَحِقٌّ':Subject, #2: 2	أَقَامَ الْمُسْتَأْجِرُ
u'قَامَ مُسْتَحِقٌّ':Subject, #1: 1	قَامَ مُسْتَحِقُّ
u'قَامَ مُسْتَحِقٌّ':Subject, #2: 2	أَقَامَ الْمُسْتَحِقُّ
u'قَامَ مُسْتَعِيرٌ':Subject, #4: 4	قَامَ مُسْتَحِقٌّ
u'قَامَ مُسْتَقْبِلٌ':Predicate, #3: 3	أَقَامَ الْمُسْتَعِيرُ
u'قَامَ مُسْتَهْلِكٌ':Subject, #2: 2	قَامَ مُسْتَقْبِلَ
u'قَامَ مُسْلِمٌ':Subject, #1: 1	أَقَامَ الْمُسْتَهْلِكُ
u'قَامَ مُسْلِمٌ':Subject, #2: 2	أَقَامَ الْمُسْلِمُ
u'قَامَ مَشْهُودٌ':Subject, #5: 5	أَقَامَ مُسْلِمٌ
u'قَامَ مُصَرِّحٌ':Subject, #7: 7	أَقَامَ الْمَشْهُودُ
u'قَامَ مُضَارِبٌ':Subject, #1: 1	أَقَامَ الْمُصَرِّحُ
u'قَامَ مُعَامِلٌ':Subject, #3: 3	أَقَامَ الْمُضَارِبُ
u'قَامَ مُعاوِيَة':Subject, #1: 1	قَامَ الْمُعَامِلُ
u'قَامَ مُعَيَّنٌ':Subject, #1: 1	قَامَ مُعَاوِيَةُ
u'قَامَ مَغْرِبٌ':Predicate, #1: 1	قَامَ الْمُعَيَّنُ
u'قَامَ مَغْصُوب':Subject, #2: 2	أَقَامَ الْمَغْرِبَ
u'قَامَ مَقَامٌ':Predicate, #1: 1	أَقَامَ الْمَغْصُوبُ
u'قَامَ مَقَامٌ':Predicate, #2: 2	قَامَ مَقَامَكَ
u'قَامَ مَقَامٌ':Subject, #83: 83	قَامَ مَقَامَ
u'قَامَ مَقْذُوفٌ':Subject, #1: 1	قَامَ مَقَامُهُ
u'قَامَ مَقْضِيّ':Subject, #1: 1	أَقَامَ الْمَقْذُوفُ
u'قَامَ مَقْطُوعٌ':Subject, #2: 2	أَقَامَ الْمَقْضِيُّ
u'قَامَ مَقْطُوعَةٌ':Subject, #1: 1	أَقَامَ الْمَقْطُوعَةُ
u'قَامَ مُكْرِهٌ':Subject, #1: 1	أَقَامَ الْمَقْطُوعَةُ
u'قَامَ مَكْفُولٌ':Subject, #1: 1	قَامَ الْمُكْرِهُ
u'قَامَ مُلْتَقِط':Subject, #1: 1	أَقَامَ الْمَكْفُولُ
u'قَامَ مَمْلُوكٌ':Subject, #1: 1	أَقَامَ الْمُلْتَقِطُ
u'قَامَ مَنَارٌ':Predicate, #1: 1	قَامَ مَمْلُوكُهُ
u'قَامَ مُؤَجِّرٌ':Subject, #1: 1	أَقَامَ مَنَارَ
u'قَامَ مُودِعٌ':Subject, #1: 1	أَقَامَ الْمُؤَجِّرُ
u'قَامَ مُؤَذِّنٌ':Subject, #5: 5	أَقَامَ الْمُودِعُ
u'قَامَ مُؤَذِّنٌ':Subject, #1: 1	قَامَ الْمُؤَذِّنُ
u'قَامَ مَوْضِعٌ':Predicate, #7: 7	أَقَامَ الْمُؤَذِّنُ
u'قَامَ مُوَكِّلٌ':Subject, #1: 1	قَامَ مَوْضِعَ
u'قَامَ مَوْهُوبٌ':Subject, #2: 2	أَقَامَ الْمُوَكِّلُ
u'قَامَ نَاسٌ':Subject, #2: 2	أَقَامَ الْمَوْهُوبُ
u'قَامَ نَاسٌ':Subject, #1: 1	أَقَامَ النَّاسُ
u'قَامَ نَاسٌ':Subject, #1: 1	قَامَ نَاسٌ
u'قَامَ نَاظِرٌ':Subject, #3: 3	قَامَ النَّاسُ
u'قَامَ نَبِيٌّ':Subject, #1: 1	أَقَامَ النَّاظِرُ
u'قَامَ نَبِيٌّ':Subject, #10: 10	قَامَ النَّبِيُّ
u'قَامَ نَبِيٌّ':Subject, #3: 3	قَامَ نَبِيُّ
u'قَامَ نَزَلٌ':Predicate, #4: 4	أَقَامَ النَّبِيُّ
u'قَامَ نِساءٌ':Subject, #1: 1	قَامَ نَزَلَ
u'قَامَ نُسُكٌ':Predicate, #1: 1	قَامَ النِّسَاءُ
u'قَامَ نَصٌّ':Subject, #1: 1	أَقَامَ النُّسُكَ
u'قَامَ نَصٌّ':Subject, #1: 1	قَامَ النَّصُّ
u'قَامَ نَصْرَانِيٌّ':Subject, #1: 1	قَامَ نَصٌّ
u'قَامَ نَصْرَانِيٌّ':Subject, #1: 1	أَقَامَ نَصْرَانِيٌّ
u'قَامَ نِصْفٌ':Predicate, #2: 2	أَقَامَ النَّصْرَانِيُّ
u'قَامَ نِصْفٌ':Predicate, #1: 1	أَقَامَ النِّصْفَ
u'قَامَ نَظَرٌ':Subject, #2: 2	قَامَ نِصْفَ
u'قَامَ نُكُولٌ':Predicate, #1: 1	قَامَ النَّظَرُ
u'قَامَ واحد':Subject, #1: 1	أَقَامَ النُّكُولَ
u'قَامَ وَاحِدٌ':Subject, #1: 1	أَقَامَ الْوَاحِدُ
u'قَامَ واحد':Subject, #1: 1	أَقَامَ الْوَاحِدُ
u'قَامَ وَاحِدٌ':Subject, #5: 5	أَقَامَ وَاحِدٌ
u'قَامَ واحد':Subject, #5: 5	أَقَامَ وَاحِدٌ
u'قَامَ وَاحِدٌ':Subject, #5: 5	قَامَ وَاحِدٌ
u'قَامَ وَارِثٌ':Subject, #5: 5	قَامَ وَاحِدٌ
u'قَامَ وَارِثٌ':Subject, #13: 13	قَامَ وَارِثُهُ
u'قَامَ وَارِثٌ':Subject, #1: 1	أَقَامَ وَارِثُهُ
u'قَامَ وَارِثٌ':Subject, #4: 4	أَقَامَ الْوَارِثُ
u'قَامَ وَاهِبٌ':Subject, #4: 4	قَامَ الْوَارِثُ
u'قَامَ وَتَرٌ':Predicate, #2: 2	أَقَامَ الْوَاهِبُ
u'قَامَ وَجَبٌ':Predicate, #1: 1	قَامَ وَتَرَكَ
u'قَامَ وَرَثَةٌ':Subject, #1: 1	قَامَ وَجَبَ
u'قَامَ وَرَثَةٌ':Subject, #1: 1	أَقَامَ وَرَثَةُ
u'قَامَ وَرَثَةٌ':Subject, #1: 1	قَامَ وَرَثَةُ
u'قَامَ وَرَثَةٌ':Subject, #1: 1	قَامَ وَرَثَتُهُ
u'قَامَ وسط':Predicate, #4: 4	أَقَامَ الْوَرَثَةُ
u'قَامَ وَسَطٌ':Predicate, #2: 2	قَامَ وَسَطَهُنَّ
u'قَامَ وَصِيٌّ':Predicate, #2: 2	قَامَ وَسَطَهُنَّ
u'قَامَ وَصِيٌّ':Subject, #1: 1	أَقَامَ الْوَصِيَّ
u'قَامَ وَصِيٌّ':Subject, #1: 1	أَقَامَ وَصِيُّهُ
u'قَامَ وَقْتٌ':Subject, #1: 1	قَامَ الْوَصِيُّ
u'قَامَ وَكِيلٌ':Predicate, #2: 2	قَامَ الْوَقْتُ
u'قَامَ وَكِيلٌ':Subject, #1: 1	أَقَامَ الْوَكِيلَ
u'قَامَ وَكِيلٌ':Subject, #1: 1	قَامَ وَكِيلُ
u'قَامَ وَكِيلٌ':Subject, #4: 4	قَامَ الْوَكِيلُ
u'قَامَ ولد':Subject, #5: 5	أَقَامَ الْوَكِيلُ
u'قَامَ وَلَدٌ':Subject, #1: 1	أَقَامَ الْوَلَدُ
u'قَامَ ولد':Subject, #1: 1	أَقَامَ الْوَلَدُ
u'قَامَ وَلَدٌ':Subject, #1: 1	قَامَ وَلَدُهُ
u'قَامَ وَلِيٌّ':Subject, #1: 1	قَامَ وَلَدُهُ
u'قَامَ وَلِيٌّ':Subject, #1: 1	أَقَامَ وَلِيُّ
u'قَامَ وَلِيٌّ':Subject, #1: 1	قَامَ وَلِيُّ
u'قَامَ وَلِيٌّ':Subject, #2: 2	قَامَ الْوَلِيُّ
u'قَامَ يَدٌ':Predicate, #5: 5	قَامَ وَلِيُّهُ
u'قَامَ يَوْمٌ':Predicate, #1: 1	أَقَامَ يَدَ
u'قَامَ يَوْمٌ':Predicate, #1: 1	أَقَامَ يَوْمَ
u'قبال نِساءٌ':Added, #6: 6	قَامَ يَوْمَ
u'قَبَحَ بُخْلٌ':Predicate, #3: 3	أَقْبَالِ النِّسَاءِ
u'قُبْحٌ تَرْكٌ':Added, #1: 1	أَقْبَحَ الْبُخْلَ
u'قَبَحَ تَزْهِيدٌ':Predicate, #1: 1	قُبْحَ تَرْكِهِ
u'قُبْحٌ تَصْدِيقٌ':Added, #1: 1	أَقْبَحَ التَّزْهِيدَ
u'قُبْحٌ تَضْيِيقٌ':Added, #1: 1	قُبْحِ تَصْدِيقِ
u'قَبَحَ تَفْرِيطٌ':Predicate, #1: 1	قُبْحِ التَّضْيِيقِ
u'قُبْحٌ خَطٌّ':Added, #1: 1	أَقْبَحَ التَّفْرِيطَ
u'قُبْحٌ ذكر':Added, #1: 1	قُبْحَ خَطِّ
u'قُبْحٌ ذِكْرٌ':Added, #1: 1	قُبْحُ ذِكْرِ
u'قُبْحٌ رَدٌّ':Added, #1: 1	قُبْحُ ذِكْرِ
u'قُبْحٌ رَفْعٌ':Added, #1: 1	قُبْحَ الرَّدِّ
u'قُبْحٌ سِحْرٌ':Added, #1: 1	قُبْحَ رَفْعِ
u'قَبُحَ شَيْءٌ':Subject, #1: 1	قُبْحِ السِّحْرِ
u'قَبَّحَ صِفَةٌ':Predicate, #1: 1	قَبُحَ الشَّيْءُ
u'قُبْحٌ صُورَةٌ':Added, #1: 1	قَبَّحَ الصِّفَةَ
u'قُبْحٌ ظاهِرٌ':Added, #2: 2	قُبْحِ صُورَتِهِ
u'قُبْحٌ ظُلْمٌ':Added, #1: 1	قُبْحِ ظَاهِرِهِ
u'قُبْحٌ عَمَلٌ':Added, #1: 1	قُبْحَ الظُّلْمِ
u'قُبْحٌ غضب':Added, #1: 1	قُبْحِ عَمَلِهِ
u'قُبْحٌ غَضَبٌ':Added, #1: 1	قُبْحِ الْغَضَبِ
u'قُبْحٌ فعال':Added, #1: 1	قُبْحِ الْغَضَبِ
u'قُبْحٌ فِعَالٌ':Added, #1: 1	قُبْحِ الْفِعَالِ
u'قُبْحٌ فِعْلٌ':Added, #1: 1	قُبْحِ الْفِعَالِ
u'قَبَحَ قَارِئٌ':Predicate, #1: 1	قُبْحِ فِعْلٍ
u'قُبْحٌ قَبِيحٌ':Added, #1: 1	أَقْبَحَ الْقَارِئَ
u'قُبْحٌ قَطِيعٌ':Added, #1: 1	قُبْحَ الْقَبِيحِ
u'قُبْحٌ قَطِيعَةٌ':Added, #1: 1	قُبْحَ الْقَطِيعَةِ
u'قُبْحٌ قول':Added, #1: 1	قُبْحَ الْقَطِيعَةِ
u'قُبْحٌ قَوْلٌ':Added, #1: 1	قُبْحِ الْقَوْلِ
u'قَبَحَ كذب':Predicate, #1: 1	قُبْحِ الْقَوْلِ
u'قَبَحَ كَذِبٌ':Predicate, #1: 1	أَقْبَحَ الْكَذِبَ
u'قُبْحٌ كذب':Added, #1: 1	أَقْبَحَ الْكَذِبَ
u'قُبْحٌ كَذِبٌ':Added, #2: 2	قُبْحُ الْكَذِبِ
u'قُبْحٌ كفر':Added, #2: 2	قُبْحُ الْكَذِبِ
u'قُبْحٌ كُفْرٌ':Added, #1: 1	قُبْحِ الْكُفْرِ
u'قُبْحٌ كُفْرَانٌ':Added, #1: 1	قُبْحِ الْكُفْرِ
u'قُبْحٌ مُخَالَفَةٌ':Added, #1: 1	قُبْحَ الْكُفْرَانِ
u'قُبْحٌ مَعْصِيَةٌ':Added, #1: 1	قُبْحِ الْمُخَالَفَةِ
u'قُبْحٌ مَنْظَرٌ':Added, #2: 2	قُبْحِ الْمَعْصِيَةِ
u'قُبْحٌ مَنْظَرٌ':Added, #1: 1	قُبْحِ الْمَنْظَرِ
u'قُبْحٌ مَنْهِيٌّ':Added, #1: 1	قُبْحُ مَنْظَرِ
u'قُبْحٌ هِجَاءٌ':Added, #3: 3	قُبْحَ الْمَنْهِيِّ
u'قُبْحٌ وَجْهٌ':Added, #1: 1	قُبْحَ هِجَاءٍ
u'قَبْرٌ اِبْنٌ':Added, #1: 1	قُبْحِ وَجْهِهِ
u'قَبْرٌ اِبْنٌ':Added, #2: 2	قَبْرِ ابْنِهِ
u'قَبْرٌ اِبْنٌ':Added, #3: 3	قَبْرِ ابْنِ
u'قَبْرٌ اِبْنَة':Added, #3: 3	قَبْرَ ابْنِهِ
u'قَبْرٌ الْمَرْأَةُ':Added, #1: 1	قَبْرِ ابْنَتِهِ
u'قَبْرٌ أُمٌّ':Added, #3: 3	قَبْرُ الْمَرْأَةِ
u'قَبْرٌ أُمٌّ':Added, #1: 1	قَبْرِ أُمّهِ
u'قَبْرٌ أُمٌّ':Added, #2: 2	قَبْرَ أُمّهِ
u'قَبْرٌ أُمٌّ':Added, #3: 3	قَبْرِ أُمِّهِ
u'قَبْرٌ إمَامٌ':Added, #5: 5	قَبْرَ أُمِّهِ
u'قَبْرٌ اِمْرَأَةٌ':Added, #1: 1	قَبْرِ الْإِمَامِ
u'قَبْرٌ اِمْرَأَةٌ':Added, #1: 1	قَبْرُ امْرَأَةٍ
u'قَبْرٌ براءٌ':Added, #6: 6	قَبْرِ امْرَأَةٍ
u'قَبْرٌ بَراءٌ':Added, #1: 1	قَبْرِ الْبَرَاءِ
u'قَبْرٌ بَعْضٌ':Added, #1: 1	قَبْرِ الْبَرَاءِ
u'قَبْرٌ بِنْتٌ':Added, #1: 1	قَبْرِ بَعْضِ
u'قَبْرٌ جَديدٌ':Added, #2: 2	قَبْرِ بِنْتٍ
u'قَبْرٌ خُلَفَاءُ':Added, #2: 2	قَبْرٍ جَدِيدٍ
u'قَبْرٌ خَلِيلٌ':Added, #1: 1	قَبْرِ الْخُلَفَاءِ
u'قَبْرٌ ذِمِّيٌّ':Added, #1: 1	قَبْرِ الْخَلِيلِ
u'قَبْرٌ رَجُلٌ':Added, #1: 1	قَبْرِ الذِّمِّيِّ
u'قَبْرٌ رَجُلٌ':Added, #1: 1	قَبْرَ رَجُلٍ
u'قَبْرٌ رَجُلٌ':Added, #2: 2	قَبْرُ رَجُلٍ
u'قَبْرٌ رَسُولٌ':Added, #4: 4	قَبْرُ الرَّجُلِ
u'قَبْرٌ رَسُولٌ':Added, #15: 15	قَبْرِ رَسُولِ
u'قَبْرٌ رَسُولٌ':Added, #1: 1	قَبْرَ الرّسُولِ
u'قَبْرٌ رَسُولٌ':Added, #1: 1	قَبْرِ الرَّسُولِ
u'قَبْرٌ رَطْبٌ':Added, #7: 7	قَبْرَ رَسُولِ
u'قَبْرٌ سَعْدٌ':Added, #1: 1	قَبْرٍ رَطْبٍ
u'قَبْرٌ سَعْدٌ':Added, #1: 1	قَبْرَ سَعْدِ
u'قَبْرٌ سَعْدٌ':Added, #1: 1	قَبْرِ سَعْدٍ
u'قَبْرٌ سَعْدٌ':Added, #1: 1	قَبْرِ سَعْدِ
u'قَبْرٌ سِقْطٌ':Added, #2: 2	قَبْرَ سَعْدٍ
u'قَبْرٌ سَيِّدٌ':Added, #2: 2	قَبْرَ سِقْطٍ
u'قَبْرٌ شَخْصٌ':Added, #1: 1	قَبْرَ سَيِّدِ
u'قَبْرٌ عَبْدٌ':Added, #1: 1	قَبْرِ شَخْصٍ
u'قَبْرٌ عَبْدٌ':Added, #1: 1	قَبْرِ عَبْدِ
u'قَبْرٌ عَلِيٌّ':Added, #2: 2	قَبْرَ عَبْدِ
u'قَبْرٌ غير':Added, #1: 1	قَبْرِ عَلِيٍّ
u'قَبْرٌ غَيْرٌ':Added, #1: 1	قَبْرِ غَيْرِهِ
u'قَبْرٌ غير':Added, #1: 1	قَبْرِ غَيْرِهِ
u'قَبْرٌ غير':Added, #2: 2	قَبْرُ غَيْرِ
u'قَبْرٌ غَيْرٌ':Added, #2: 2	قَبْرِ غَيْرِ
u'قَبْرٌ غَيْرٌ':Added, #2: 2	قَبْرُ غَيْرِ
u'قَبْرٌ فُلاَنٌ':Added, #2: 2	قَبْرِ غَيْرِ
u'قَبْرٌ فُلاَنٌ':Added, #1: 1	قَبْرُ فُلَانٍ
u'قَبْرٌ فُلاَنٌ':Added, #1: 1	قَبْرِ فُلَانٍ
u'قَبْرٌ فُلاَنٌ':Added, #1: 1	قَبْرُ فُلَانَةِ
u'قَبْرٌ قَرَابَةٌ':Added, #2: 2	قَبْرُ فُلاَنٍ
u'قَبْرٌ قَرِيبٌ':Added, #1: 1	قَبْرِ قَرَابَتِهِ
u'قَبْرٌ كَافِرٌ':Added, #1: 1	قَبْرِ قَرِيبِهِ
u'قَبْرٌ مَبْنِيٌّ':Added, #1: 1	قَبْرِ الْكَافِرِ
u'قَبْرٌ مُحْتَرَمٌ':Added, #1: 1	قَبْرٍ مَبْنِيٍّ
u'قَبْرٌ مُسَطَّحٌ':Added, #1: 1	قَبْرٍ مُحْتَرَمٍ
u'قَبْرٌ مُسْلِمٌ':Added, #1: 1	قَبْرٍ مُسَطَّحٍ
u'قَبْرٌ مُسْلِمٌ':Added, #1: 1	قَبْرِ مُسْلِمٍ
u'قَبْرٌ مُشْرِك':Added, #2: 2	قَبْرُ الْمُسْلِمِ
u'قَبْرٌ مَعْرُوفٌ':Added, #1: 1	قَبْرِ الْمُشْرِكِ
u'قَبْرٌ مُعَظَّمٌ':Added, #1: 1	قَبْرٍ مَعْرُوفٍ
u'قَبْرٌ مَنْبُوذٌ':Added, #2: 2	قَبْرَ مُعَظَّمٍ
u'قَبْرٌ نَبِيٌّ':Added, #4: 4	قَبْرٍ مَنْبُوذٍ
u'قَبْرٌ نَبِيٌّ':Added, #10: 10	قَبْرَ النَّبِيِّ
u'قَبْرٌ نَبِيٌّ':Added, #1: 1	قَبْرُ نَبِيِّ
u'قَبْرٌ واحد':Added, #20: 20	قَبْرِ النَّبِيِّ
u'قَبْرٌ وَاحِدٌ':Added, #32: 32	قَبْرٍ وَاحِدٍ
u'قَبْرٌ ولد':Added, #32: 32	قَبْرٍ وَاحِدٍ
u'قَبْرٌ وَلَدٌ':Added, #1: 1	قَبْرُ وَلَدِ
u'قَبْرٌ وَلِيٌّ':Added, #1: 1	قَبْرُ وَلَدِ
u'قَبْرٌ وَلِيٌّ':Added, #1: 1	قَبْرَ وَلِيِّهِ
u'قَبَضَ أَبٌ':Subject, #3: 3	قَبْرِ وَلِيٍّ
u'قَبْضٌ أَبٌ':Added, #7: 7	قَبَضَ الْأَبُ
u'قَبْضٌ أَبٌ':Added, #1: 1	قَبْضَ الْأَبِ
u'قَبْضٌ أَبٌ':Added, #3: 3	قَبْضُ الْأَبِ
u'قَبْضٌ إِبْرِيقٌ':Added, #7: 7	قَبْضِ الْأَبِ
u'قَبْضٌ إجَارَةٌ':Added, #2: 2	قَبْضُ الْإِبْرِيقِ
u'قَبَضَ أَجْرٌ':Predicate, #2: 2	قَبْضِ الْإِجَارَةِ
u'قَبْضٌ أَجْرٌ':Added, #3: 3	قَبَضَ الْأَجْرَ
u'قَبْضٌ أَجْرٌ':Added, #2: 2	قَبْضُ الْأَجْرِ
u'قَبَضَ أُجْرَةٌ':Predicate, #3: 3	قَبْضِ الْأَجْرِ
u'قَبَضَ أُجْرَةٌ':Predicate, #1: 1	قَبَضَ أُجْرَةَ
u'قَبْضٌ أُجْرَةٌ':Added, #2: 2	قَبَضَ الْأُجْرَةَ
u'قَبْضٌ أُجْرَةٌ':Added, #1: 1	قَبْضِ أُجْرَةِ
u'قَبْضٌ أُجْرَةٌ':Added, #1: 1	قَبْضُ الْأُجْرَةِ
u'قَبْضٌ أُجْرَةٌ':Added, #3: 3	قَبْضَ الْأُجْرَةِ
u'قَبَضَ أَجْنَبِيٌّ':Subject, #7: 7	قَبْضِ الْأُجْرَةِ
u'قَبْضٌ أَجْنَبِيٌّ':Added, #2: 2	قَبَضَ الْأَجْنَبِيُّ
u'قَبَضَ أحَدٌ':Predicate, #1: 1	قَبْضَ الْأَجْنَبِيِّ
u'قَبَضَ أحَدٌ':Subject, #2: 2	قَبَضَ أَحَدَ
u'قَبْضٌ أحَدٌ':Added, #9: 9	قَبَضَ أَحَدُ
u'قَبْضٌ أحَدٌ':Added, #12: 12	قَبْضِ أَحَدِ
u'قَبْضٌ أحَدٌ':Added, #2: 2	قَبْضَ أَحَدِ
u'قَبَضَ أَخٌ':Subject, #7: 7	قَبْضُ أَحَدِ
u'قَبْضٌ أَخٌ':Added, #3: 3	قَبَضَ الْأَخُ
u'قَبَضَ أَرْدَأَ':Predicate, #1: 1	قَبْضِ الْأَخِ
u'قَبَضَ أرْضٌ':Predicate, #1: 1	قَبَضَ أَرْدَأَ
u'قَبْضٌ أرْضٌ':Added, #3: 3	قَبَضَ الْأَرْضَ
u'قَبْضٌ أَرْواحٌ':Added, #2: 2	قَبْضِ الْأَرْضِ
u'قَبْضٌ اِسْتيفاءٌ':Added, #2: 2	قَبْضَ الْأَرْوَاحِ
u'قَبْضٌ أَصابِعُ':Added, #2: 2	قَبْضُ اسْتِيفَاءٍ
u'قَبْضٌ أُصولٌ':Added, #3: 3	قَبْضِ الْأَصَابِعِ
u'قَبَضَ أَكْثَرُ':Predicate, #1: 1	قَبْضُ الْأُصُولِ
u'قَبَضَ أَكْثَرُ':Predicate, #1: 1	قَبَضَ أَكْثَرَ
u'قَبَضَ ألف':Predicate, #1: 1	قَبَضَ الْأَكْثَرَ
u'قَبَضَ ألْفٌ':Predicate, #1: 1	قَبَضَ أَلْفَ
u'قَبَضَ أَلْفٌ':Predicate, #1: 1	قَبَضَ أَلْفَ
u'قَبَضَ ألف':Predicate, #1: 1	قَبَضَ أَلْفَ
u'قَبَضَ ألْفٌ':Predicate, #4: 4	قَبَضَ الْأَلْفَ
u'قَبَضَ أَلْفٌ':Predicate, #4: 4	قَبَضَ الْأَلْفَ
u'قَبْضٌ ألْفٌ':Added, #4: 4	قَبَضَ الْأَلْفَ
u'قَبْضٌ ألف':Added, #1: 1	قَبْضِ الْأَلْفَيْنِ
u'قَبْضٌ ألْفٌ':Added, #2: 2	قَبْضِ الْأَلْفِ
u'قَبْضٌ أَلْفٌ':Added, #2: 2	قَبْضِ الْأَلْفِ
u'قَبْضٌ الْمَرْأَةُ':Added, #2: 2	قَبْضِ الْأَلْفِ
u'قَبْضٌ إمَامٌ':Added, #3: 3	قَبْضِ الْمَرْأَةِ
u'قَبْضٌ إمَامٌ':Added, #1: 1	قَبْضَ الْإِمَامِ
u'قَبْضٌ أمَانَةٌ':Added, #1: 1	قَبْضِ الْإِمَامِ
u'قَبْضٌ أمَانَةٌ':Added, #2: 2	قَبْضَ أَمَانَةٍ
u'قَبْضٌ أمَانَةٌ':Added, #2: 2	قَبْضُ أَمَانَةٍ
u'قَبْضٌ أمَانَةٌ':Added, #3: 3	قَبْضِ الْأَمَانَةِ
u'قَبْضٌ أمَانَةٌ':Added, #5: 5	قَبْضَ الْأَمَانَةِ
u'قَبَضَ أمَةٌ':Predicate, #5: 5	قَبْضُ الْأَمَانَةِ
u'قَبَضَ أمَةٌ':Predicate, #1: 1	قَبَضَ الْأَمَةَ
u'قَبَضَ آمِرٌ':Subject, #1: 1	قَبَضَ أَمَةَ
u'قَبْضٌ آمِرٌ':Added, #1: 1	قَبَضَ الْآمِرُ
u'قَبَضَ أَمْوَالٌ':Predicate, #1: 1	قَبْضُ الْآمِرِ
u'قَبْضٌ أَمْوَالٌ':Added, #1: 1	قَبَضَ أَمْوَالَ
u'قَبْضٌ أَمْوَالٌ':Added, #1: 1	قَبْضَ الْأَمْوَالِ
u'قَبْضٌ أَمْوَالٌ':Added, #1: 1	قَبْضُ الْأَمْوَالِ
u'قَبْضٌ أَمْوَالٌ':Added, #1: 1	قَبْضُ أَمْوَالِ
u'قَبَضَ أهْلٌ':Subject, #1: 1	قَبْضَ أَمْوَالِهِ
u'قَبْضٌ أوائل':Added, #1: 1	قَبَضَ أَهْلُ
u'قَبَضَ أَوَّلُ':Subject, #1: 1	قَبْضَ الْأَوَائِلِ
u'قَبْضٌ أَوَّلُ':Added, #3: 3	قَبَضَ الْأَوَّلُ
u'قَبْضٌ أَوَّلُ':Added, #1: 1	قَبْضِ الْأَوَّلِ
u'قَبَضَ باقِي':Predicate, #2: 2	قَبْضُ الْأَوَّلِ
u'قَبَضَ بَائِعٌ':Subject, #1: 1	قَبَضَ الْبَاقِيَ
u'قَبْضٌ بَائِعٌ':Added, #10: 10	قَبَضَ الْبَائِعُ
u'قَبْضٌ بَائِعٌ':Added, #13: 13	قَبْضِ الْبَائِعِ
u'قَبْضٌ بَائِعٌ':Added, #2: 2	قَبْضَ الْبَائِعِ
u'قَبَضَ بَدَلٌ':Predicate, #6: 6	قَبْضُ الْبَائِعِ
u'قَبْضٌ بَدَلٌ':Added, #5: 5	قَبَضَ بَدَلَ
u'قَبْضٌ بَدَلٌ':Added, #13: 13	قَبْضِ الْبَدَلِ
u'قَبْضٌ بَدَلٌ':Added, #1: 1	قَبْضَ بَدَلِ
u'قَبْضٌ بَدَلٌ':Added, #2: 2	قَبْضِ بَدَلِهِ
u'قَبْضٌ بَدَلٌ':Added, #4: 4	قَبْضُ بَدَلِهِ
u'قَبْضٌ بَدَلٌ':Added, #5: 5	قَبْضَ الْبَدَلِ
u'قَبْضٌ بَدَلٌ':Added, #5: 5	قَبْضِ الْبَدَلَيْنِ
u'قَبْضٌ بَدَلٌ':Added, #7: 7	قَبْضُ الْبَدَلِ
u'قَبْضٌ بَدَلٌ':Added, #8: 8	قَبْضُ الْبَدَلَيْنِ
u'قَبْضٌ بَدَلٌ':Added, #8: 8	قَبْضُ بَدَلِ
u'قَبَضَ بَذْرٌ':Predicate, #9: 9	قَبْضِ بَدَلِ
u'قَبْضٌ بَذْرٌ':Added, #2: 2	قَبَضَ الْبَذْرَ
u'قَبَضَ بُرٌّ':Predicate, #2: 2	قَبْضُ الْبَذْرِ
u'قَبْضٌ بَصَرٌ':Added, #1: 1	قَبَضَ الْبُرَّ
u'قَبَضَ بَعْضٌ':Predicate, #1: 1	قَبْضُ الْبَصَرِ
u'قَبَضَ بَعْضٌ':Predicate, #10: 10	قَبَضَ بَعْضَ
u'قَبَضَ بَعْضٌ':Subject, #5: 5	قَبَضَ الْبَعْضَ
u'قَبْضٌ بَعْضٌ':Added, #1: 1	قَبَضَ بَعْضُ
u'قَبْضٌ بَعْضٌ':Added, #1: 1	قَبْضُ بَعْضِهِ
u'قَبْضٌ بَعْضٌ':Added, #2: 2	قَبْضُ الْبَعْضِ
u'قَبْضٌ بَعْضٌ':Added, #4: 4	قَبْضِ الْبَعْضِ
u'قَبْضٌ بَعْضٌ':Added, #4: 4	قَبْضِ بَعْضِهِ
u'قَبَضَ بَقِيَّةٌ':Predicate, #6: 6	قَبْضِ بَعْضِ
u'قَبْضٌ بَيْعٌ':Added, #1: 1	قَبَضَ بَقِيَّةَ
u'قبضة إِصْبَعٌ':Added, #4: 4	قَبْضِ الْبَيْعِ
u'قبضة إِصْبَعٌ':Added, #1: 1	قَبْضَةٍ إصْبَعٍ
u'قَبْضَةٌ إِصْبَعٌ':Added, #1: 1	قَبْضَةِ إصْبَعٍ
u'قَبْضَةٌ إِصْبَعٌ':Added, #1: 1	قَبْضَةٍ إصْبَعٍ
u'قبضة إمَامٌ':Added, #1: 1	قَبْضَةِ إصْبَعٍ
u'قَبْضَةٌ إمَامٌ':Added, #5: 5	قَبْضَةِ الْإِمَامِ
u'قبضة حِنْطَةٌ':Added, #5: 5	قَبْضَةِ الْإِمَامِ
u'قَبْضَةٌ حِنْطَةٌ':Added, #1: 1	قَبْضَةَ حِنْطَةٍ
u'قبضة زَوْجٌ':Added, #1: 1	قَبْضَةَ حِنْطَةٍ
u'قَبْضَةٌ زَوْجٌ':Added, #2: 2	قَبْضَةِ الزَّوْجِ
u'قبضة سَيِّدٌ':Added, #2: 2	قَبْضَةِ الزَّوْجِ
u'قَبْضَةٌ سَيِّدٌ':Added, #1: 1	قَبْضَةِ سَيِّدِهِ
u'قبضة سَيْفٌ':Added, #1: 1	قَبْضَةِ سَيِّدِهِ
u'قَبْضَةٌ سَيْفٌ':Added, #1: 1	قَبْضَةِ السَّيْفِ
u'قبضة شَيْطَانٌ':Added, #1: 1	قَبْضَةِ السَّيْفِ
u'قَبْضَةٌ شَيْطَانٌ':Added, #1: 1	قَبْضَةِ الشّيْطَانِ
u'قبضة طعام':Added, #1: 1	قَبْضَةِ الشّيْطَانِ
u'قبضة طَعَامٌ':Added, #1: 1	قَبْضَةُ طَعَامٍ
u'قَبْضَةٌ طعام':Added, #1: 1	قَبْضَةُ طَعَامٍ
u'قَبْضَةٌ طَعَامٌ':Added, #1: 1	قَبْضَةُ طَعَامٍ
u'قبضة يَدٌ':Added, #1: 1	قَبْضَةُ طَعَامٍ
u'قَبْضَةٌ يَدٌ':Added, #1: 1	قَبْضَةِ الْيَدِ
u'قَبَضَ تمام':Predicate, #1: 1	قَبْضَةِ الْيَدِ
u'قَبَضَ تَمامٌ':Predicate, #1: 1	قَبَضَ تَمَامَ
u'قَبْضٌ تمام':Added, #1: 1	قَبَضَ تَمَامَ
u'قَبْضٌ تَمامٌ':Added, #1: 1	قَبْضُ تَمَامِ
u'قَبْضٌ ثِمارٌ':Added, #1: 1	قَبْضُ تَمَامِ
u'قَبَّضَ ثَمَنٌ':Predicate, #2: 2	قَبْضَ الثِّمَارِ
u'قَبَضَ ثَمَنٌ':Predicate, #1: 1	قَبَّضَ الثَّمَنَ
u'قَبْضٌ ثَمَنٌ':Added, #59: 59	قَبَضَ الثَّمَنَ
u'قَبْضٌ ثَمَنٌ':Added, #12: 12	قَبْضَ الثَّمَنِ
u'قَبْضٌ ثَمَنٌ':Added, #15: 15	قَبْضِ ثَمَنِهِ
u'قَبْضٌ ثَمَنٌ':Added, #19: 19	قَبْضُ الثَّمَنِ
u'قَبْضٌ ثَمَنٌ':Added, #1: 1	قَبْضَ ثَمَنٍ
u'قَبْضٌ ثَمَنٌ':Added, #1: 1	قَبْضِ ثَمَنٍ
u'قَبْضٌ ثَمَنٌ':Added, #2: 2	قَبْضِ ثَمَنِ
u'قَبْضٌ ثَمَنٌ':Added, #2: 2	قَبْضُ ثَمَنِهِ
u'قَبْضٌ ثَمَنٌ':Added, #3: 3	قَبْضَ ثَمَنِهِ
u'قَبَضَ ثَوْبٌ':Predicate, #97: 97	قَبْضِ الثَّمَنِ
u'قَبْضٌ ثَوْبٌ':Added, #3: 3	قَبَضَ الثَّوْبَ
u'قَبْضٌ ثَوْبٌ':Added, #1: 1	قَبْضُ الثَّوْبِ
u'قَبَضَ جَارِي':Predicate, #1: 1	قَبْضِ الثَّوْبِ
u'قَبَضَ جَارِي':Predicate, #1: 1	قَبَضَ جَارِيَةً
u'قَبَضَ جَارِيَةٌ':Predicate, #6: 6	قَبَضَ الْجَارِيَةَ
u'قَبْضٌ جَائِرٌ':Added, #6: 6	قَبَضَ الْجَارِيَةَ
u'قَبْضٌ جَديدٌ':Added, #1: 1	قَبْضُ الْجَائِرِ
u'قَبْضٌ جُزْءٌ':Added, #4: 4	قَبْضٍ جَدِيدٍ
u'قَبْضٌ جُمْلَةٌ':Added, #1: 1	قَبْضُ الْجُزْءِ
u'قَبَضَ جَمِيع':Predicate, #1: 1	قَبْضُ الْجُمْلَةِ
u'قَبْضٌ جَمِيع':Added, #2: 2	قَبَضَ الْجَمِيعَ
u'قَبْضٌ جَمِيع':Added, #2: 2	قَبْضُ الْجَمِيعِ
u'قَبَضَ جِنْسٌ':Predicate, #2: 2	قَبْضِ الْجَمِيعِ
u'قَبَضَ جياد':Predicate, #1: 1	قَبَضَ جِنْسَ
u'قَبَضَ جِيَادٌ':Predicate, #3: 3	قَبَضَ الْجِيَادَ
u'قَبَضَ حاضِرٌ':Subject, #3: 3	قَبَضَ الْجِيَادَ
u'قَبَضَ حاكِمٌ':Subject, #1: 1	قَبَضَ الْحَاضِرُ
u'قَبْضٌ حاكِمٌ':Added, #2: 2	قَبَضَ الْحَاكِمُ
u'قَبْضٌ حاكِمٌ':Added, #2: 2	قَبْضَ الْحَاكِمِ
u'قَبَضَ حَديدٌ':Predicate, #2: 2	قَبْضِ الْحَاكِمِ
u'قَبْضٌ حِصَّةٌ':Added, #1: 1	قَبَضَ الْحَدِيدَ
u'قَبْضٌ حِصَّةٌ':Added, #1: 1	قَبْضَ الْحِصَّةِ
u'قَبْضٌ حِصَّةٌ':Added, #2: 2	قَبْضَ حِصَّةِ
u'قَبَضَ حَقٌّ':Predicate, #2: 2	قَبْضَ حِصَّتِهِ
u'قَبْضٌ حَقٌّ':Added, #1: 1	قَبَضَ الْحَقَّ
u'قَبْضٌ حَقٌّ':Added, #1: 1	قَبْضِ الْحَقِّ
u'قَبْضٌ حَقٌّ':Added, #1: 1	قَبْضُ حَقِّهِ
u'قَبْضٌ حَقٌّ':Added, #2: 2	قَبْضِ حَقٍّ
u'قَبْضٌ حَقٌّ':Added, #3: 3	قَبْضَ حَقِّهِ
u'قَبْضٌ حُقوقٌ':Added, #4: 4	قَبْضِ حَقِّهِ
u'قَبْضٌ حُقُوقٌ':Added, #4: 4	قَبْضِ حُقُوقِهِ
u'قَبْضٌ حَقِيقِيٌّ':Added, #4: 4	قَبْضِ حُقُوقِهِ
u'قَبَضَ حِنْطَةٌ':Predicate, #1: 1	قَبْضٍ حَقِيقِيٍّ
u'قَبَضَ حَوَالَةٌ':Predicate, #3: 3	قَبَضَ الْحِنْطَةَ
u'قَبْضٌ خَارِجٌ':Added, #1: 1	قَبَضَ الْحَوَالَةَ
u'قَبْضٌ خراج':Added, #1: 1	قَبْضِ الْخَارِجِ
u'قَبْضٌ خَرَاجٌ':Added, #2: 2	قَبْضِ الْخَرَاجِ
u'قَبَضَ خَطِيبٌ':Subject, #2: 2	قَبْضِ الْخَرَاجِ
u'قَبَضَ خَمْرٌ':Predicate, #1: 1	قَبَضَ الْخَطِيبُ
u'قَبْضٌ خَمْرٌ':Added, #2: 2	قَبَضَ الْخَمْرَ
u'قَبْضٌ خَمْرٌ':Added, #1: 1	قَبْضَ الْخَمْرِ
u'قَبَضَ دَابَّةٌ':Predicate, #6: 6	قَبْضِ الْخَمْرِ
u'قَبْضٌ دَابَّةٌ':Added, #1: 1	قَبَضَ الدَّابَّةَ
u'قَبَضَ دَارٌ':Predicate, #2: 2	قَبْضِ الدَّابَّةِ
u'قَبْضٌ دَارٌ':Added, #19: 19	قَبَضَ الدَّارَ
u'قَبْضٌ دَارٌ':Added, #1: 1	قَبْضُ الدَّارِ
u'قَبْضٌ دَارٌ':Added, #3: 3	قَبْضَ الدَّارِ
u'قَبَضَ دَرَاهِمُ':Predicate, #5: 5	قَبْضِ الدَّارِ
u'قَبَضَ دَرَاهِمُ':Predicate, #15: 15	قَبَضَ الدَّرَاهِمَ
u'قَبْضٌ دَرَاهِمُ':Added, #1: 1	قَبَضَ دَرَاهِمَ
u'قَبْضٌ دَرَاهِمُ':Added, #1: 1	قَبْضَ الدَّرَاهِمِ
u'قَبَضَ دِرْهَمٌ':Predicate, #6: 6	قَبْضِ الدَّرَاهِمِ
u'قَبَضَ دِرْهَم':Predicate, #2: 2	قَبَضَ الدِّرْهَمَ
u'قَبْضٌ دِرْهَمٌ':Added, #2: 2	قَبَضَ الدِّرْهَمَ
u'قَبْضٌ دِرْهَم':Added, #1: 1	قَبْضِ دِرْهَمٍ
u'قَبَضَ دفع':Predicate, #1: 1	قَبْضِ دِرْهَمٍ
u'قَبَضَ دَنانيرُ':Predicate, #1: 1	قَبَضَ دُفِعَ
u'قَبْضٌ دَنانيرُ':Added, #4: 4	قَبَضَ الدَّنَانِيرَ
u'قَبْضٌ دُهْنٌ':Added, #3: 3	قَبْضِ الدَّنَانِيرِ
u'قَبَضَ دَيْنٌ':Predicate, #1: 1	قَبْضَ الدُّهْنِ
u'قَبَضَ دَيْنٌ':Predicate, #15: 15	قَبَضَ الدَّيْنَ
u'قَبْضٌ دَيْنٌ':Added, #1: 1	قَبَضَ دَيْنَ
u'قَبْضٌ دَيْنٌ':Added, #11: 11	قَبْضِ دَيْنِهِ
u'قَبْضٌ دَيْنٌ':Added, #15: 15	قَبْضِ الدَّيْنِ
u'قَبْضٌ دَيْنٌ':Added, #1: 1	قَبْضُ دَيْنِهِ
u'قَبْضٌ دَيْنٌ':Added, #2: 2	قَبْضِ دَيْنٍ
u'قَبْضٌ دَيْنٌ':Added, #3: 3	قَبْضُ دَيْنِ
u'قَبْضٌ دَيْنٌ':Added, #3: 3	قَبْضَ دَيْنِهِ
u'قَبْضٌ دَيْنٌ':Added, #6: 6	قَبْضَ الدَّيْنِ
u'قَبْضٌ دِينارٌ':Added, #8: 8	قَبْضُ الدَّيْنِ
u'قَبَضَ دُيونٌ':Predicate, #1: 1	قَبْضُ الدِّينَارِ
u'قَبْضٌ دُيونٌ':Added, #1: 1	قَبَضَ الدُّيُونَ
u'قَبْضٌ دُيونٌ':Added, #1: 1	قَبْضَ دُيُونِ
u'قَبْضٌ دُيونٌ':Added, #1: 1	قَبْضُ دُيُونِ
u'قَبْضٌ دُيونٌ':Added, #1: 1	قَبْضِ دُيُونِ
u'قَبْضٌ دُيونٌ':Added, #2: 2	قَبْضَ دُيُونِهِ
u'قَبَضَ ذَهَبٌ':Predicate, #3: 3	قَبْضِ الدُّيُونِ
u'قَبْضٌ رَاجِعٌ':Added, #1: 1	قَبَضَ الذَّهَبَ
u'قَبَضَ رَأْسٌ':Predicate, #1: 1	قَبْضِ الرَّاجِعِ
u'قَبْضٌ رَأْسٌ':Added, #9: 9	قَبَضَ رَأْسَ
u'قَبْضٌ رَأْسٌ':Added, #12: 12	قَبْضُ رَأْسِ
u'قَبْضٌ رَأْسٌ':Added, #13: 13	قَبْضِ رَأْسِ
u'قَبَضَ رَاهِنٌ':Subject, #5: 5	قَبْضَ رَأْسِ
u'قَبْضٌ رَاهِنٌ':Added, #1: 1	قَبَضَ الرَّاهِنُ
u'قَبْضٌ رَاهِنٌ':Added, #1: 1	قَبْضُ الرَّاهِنِ
u'قَبَضَ رَبُّ':Subject, #1: 1	قَبْضِ الرَّاهِنِ
u'قَبْضٌ رَبُّ':Added, #10: 10	قَبَضَ رَبُّ
u'قَبْضٌ رَبُّ':Added, #1: 1	قَبْضِ رَبِّ
u'قَبْضٌ رَبُّ':Added, #2: 2	قَبْضِ رَبِّهِ
u'قَبَضَ رِبْحٌ':Predicate, #4: 4	قَبْضُ رَبِّ
u'قَبَضَ رَجُلٌ':Subject, #1: 1	قَبَضَ الرِّبْحَ
u'قَبَضَ رَسُولٌ':Subject, #6: 6	قَبَضَ رَجُلٌ
u'قَبَضَ رَسُولٌ':Subject, #1: 1	قَبَضَ الرَّسُولُ
u'قَبْضٌ رَسُولٌ':Added, #1: 1	قَبَضَ رَسُولُ
u'قَبْضٌ رَسُولٌ':Added, #2: 2	قَبْضَ الرَّسُولِ
u'قَبْضٌ رَسُولٌ':Added, #2: 2	قَبْضِ رَسُولِهِ
u'قَبْضٌ رَصاصٌ':Added, #4: 4	قَبْضُ الرَّسُولِ
u'قَبَضَ رَهْنٌ':Predicate, #1: 1	قَبْضِ الرَّصَاصِ
u'قَبْضٌ رَهْنٌ':Added, #8: 8	قَبَضَ الرَّهْنَ
u'قَبْضٌ رَهْنٌ':Added, #5: 5	قَبْضِ الرَّهْنِ
u'قَبْضٌ رَهْنٌ':Added, #8: 8	قَبْضُ الرَّهْنِ
u'قَبَضَ روحٌ':Predicate, #9: 9	قَبْضَ الرَّهْنِ
u'قَبْضٌ روحٌ':Added, #1: 1	قَبَضَ رُوحَكَ
u'قَبْضٌ روحٌ':Added, #1: 1	قَبْضِ الرُّوحِ
u'قَبْضٌ روحٌ':Added, #1: 1	قَبْضَ رُوحِ
u'قَبْضٌ ريعٌ':Added, #1: 1	قَبْضِ رُوحِهِ
u'قَبْضٌ رَيْعٌ':Added, #1: 1	قَبْضِ رَيْعِ
u'قَبْضٌ زائِدٌ':Added, #1: 1	قَبْضِ رَيْعِ
u'قَبَضَ زَرْعٌ':Predicate, #1: 1	قَبْضُ الزَّائِدِ
u'قَبْضٌ زَكاةٌ':Added, #1: 1	قَبَضَ زَرْعَ
u'قَبْضٌ زَكاةٌ':Added, #1: 1	قَبْضُ الزَّكَاةِ
u'قَبَضَ زَوْجٌ':Subject, #4: 4	قَبْضِ الزَّكَاةِ
u'قَبْضٌ زَوْجٌ':Added, #2: 2	قَبَضَ الزَّوْجُ
u'قَبْضٌ زَوْجٌ':Added, #1: 1	قَبْضَ الزَّوْجِ
u'قَبْضٌ زَوْجٌ':Added, #1: 1	قَبْضُ زَوْجِ
u'قَبْضٌ زَوْجٌ':Added, #1: 1	قَبْضِ زَوْجِ
u'قَبْضٌ زَوْجٌ':Added, #3: 3	قَبْضُ الزَّوْجِ
u'قَبْضٌ زَوْجَةٌ':Added, #3: 3	قَبْضِ الزَّوْجِ
u'قَبَضَ زِيادَةٌ':Predicate, #2: 2	قَبْضِ الزَّوْجَةِ
u'قَبْضٌ زِيادَةٌ':Added, #4: 4	قَبَضَ الزِّيَادَةَ
u'قَبْضٌ زِيادَةٌ':Added, #1: 1	قَبْضِ الزِّيَادَةِ
u'قَبَضَ زَيْدٌ':Subject, #4: 4	قَبْضُ الزِّيَادَةِ
u'قَبَضَ زُيوفٌ':Predicate, #1: 1	قَبَضَ زَيْدٌ
u'قَبَضَ زُيُوفٌ':Predicate, #2: 2	قَبَضَ الزُّيُوفَ
u'قَبْضٌ زُيوفٌ':Added, #2: 2	قَبَضَ الزُّيُوفَ
u'قَبْضٌ زُيُوفٌ':Added, #1: 1	قَبْضَ الزُّيُوفِ
u'قَبْضٌ سَاجِدٌ':Added, #1: 1	قَبْضَ الزُّيُوفِ
u'قَبْضٌ سَفِيهٌ':Added, #1: 1	قَبْضُ السَّاجِدِ
u'قَبْضٌ سَفِيهٌ':Added, #1: 1	قَبْضِ السَّفِيهِ
u'قَبَضَ سِلْعَةٌ':Predicate, #3: 3	قَبْضُ السَّفِيهِ
u'قَبْضٌ سِلْعَةٌ':Added, #1: 1	قَبَضَ السِّلْعَةَ
u'قَبَضَ سَلَفٌ':Predicate, #3: 3	قَبْضِ السِّلْعَةِ
u'قَبْضٌ سَلَمٌ':Added, #2: 2	قَبَضَ السَّلَفَ
u'قَبْضٌ سَلَمٌ':Added, #1: 1	قَبْضِ السَّلَمِ
u'قَبَضَ سَلِيمٌ':Predicate, #1: 1	قَبْضُ سَلَمِهِ
u'قَبْضٌ سَهْمٌ':Added, #1: 1	قَبَضَ السَّلِيمَ
u'قَبَضَ سَواءٌ':Subject, #1: 1	قَبْضِ سَهْمِهِ
u'قَبَضَ سَيِّدٌ':Subject, #1: 1	قَبَضَ سَوَاءٌ
u'قَبَضَ سَيْفٌ':Predicate, #2: 2	قَبَضَ السَّيِّدُ
u'قَبْضٌ شَائِعٌ':Added, #2: 2	قَبَضَ السَّيْفَ
u'قَبْضٌ شِرَاءٌ':Added, #1: 1	قَبْضَ الشَّائِعِ
u'قَبْضٌ شِرَاءٌ':Added, #14: 14	قَبْضِ الشِّرَاءِ
u'قَبَضَ شَرِيكٌ':Subject, #1: 1	قَبْضَ الشِّرَاءِ
u'قَبَضَ شَرِيكٌ':Subject, #2: 2	قَبَضَ شَرِيكُهُ
u'قَبْضٌ شَفِيعٌ':Added, #7: 7	قَبَضَ الشَّرِيكُ
u'قَبْضٌ شَيْءٌ':Added, #1: 1	قَبْضَ الشَّفِيعِ
u'قَبْضٌ شَيْءٌ':Added, #1: 1	قَبْضِ الشَّيْءِ
u'قَبْضٌ شَيْءٌ':Added, #2: 2	قَبْضَ شَيْءٍ
u'قَبْضٌ شَيْءٌ':Added, #2: 2	قَبْضُ شَيْءٍ
u'قَبْضٌ صَاحِبٌ':Added, #3: 3	قَبْضِ شَيْءٍ
u'قَبْضٌ صَاحِبٌ':Added, #1: 1	قَبْضَ صَاحِبِ
u'قَبَضَ صَبِيٌّ':Subject, #1: 1	قَبْضِ صَاحِبِ
u'قَبْضٌ صَبِيٌّ':Added, #6: 6	قَبَضَ الصَّبِيُّ
u'قَبْضٌ صَبِيٌّ':Added, #1: 1	قَبْضُ الصَّبِيِّ
u'قَبْضٌ صَحِيحٌ':Added, #2: 2	قَبْضِ الصَّبِيِّ
u'قَبْضٌ صداق':Added, #1: 1	قَبْضِ الصَّحِيحِ
u'قَبْضٌ صَدَاقٌ':Added, #2: 2	قَبْضُ صَدَاقِ
u'قَبْضٌ صداق':Added, #2: 2	قَبْضُ صَدَاقِ
u'قَبْضٌ صَدَاقٌ':Added, #3: 3	قَبْضُ الصَّدَاقِ
u'قَبْضٌ صداق':Added, #3: 3	قَبْضُ الصَّدَاقِ
u'قَبْضٌ صَدَاقٌ':Added, #4: 4	قَبْضَ الصَّدَاقِ
u'قَبْضٌ صداق':Added, #4: 4	قَبْضَ الصَّدَاقِ
u'قَبْضٌ صَدَاقٌ':Added, #5: 5	قَبْضِ الصَّدَاقِ
u'قَبَضَ صدقة':Predicate, #5: 5	قَبْضِ الصَّدَاقِ
u'قَبَضَ صَدَقَةٌ':Predicate, #1: 1	قَبَضَ الصَّدَقَةَ
u'قَبْضٌ صدقة':Added, #1: 1	قَبَضَ الصَّدَقَةَ
u'قَبْضٌ صَدَقَةٌ':Added, #2: 2	قَبْضَ الصَّدَقَةِ
u'قَبْضٌ صدقة':Added, #2: 2	قَبْضَ الصَّدَقَةِ
u'قَبْضٌ صَدَقَةٌ':Added, #3: 3	قَبْضِ الصَّدَقَةِ
u'قَبَضَ صَغِيرٌ':Subject, #3: 3	قَبْضِ الصَّدَقَةِ
u'قَبْضٌ صَغِيرٌ':Added, #1: 1	قَبَضَ الصَّغِيرُ
u'قَبْضٌ صَغِيرٌ':Added, #1: 1	قَبْضُ الصَّغِيرِ
u'قَبْضٌ صلح':Added, #1: 1	قَبْضِ الصَّغِيرِ
u'قَبْضٌ صُلْحٌ':Added, #5: 5	قَبْضِ الصُّلْحِ
u'قَبْضٌ ضَامِنٌ':Added, #5: 5	قَبْضِ الصُّلْحِ
u'قَبَضَ ضَمَانٌ':Predicate, #1: 1	قَبْضِ الضَّامِنِ
u'قَبْضٌ ضَمَانٌ':Added, #1: 1	قَبَضَ الضَّمَانَ
u'قَبْضٌ ضَمَانٌ':Added, #1: 1	قَبْضَ الضَّمَانِ
u'قَبْضٌ ضَمَانٌ':Added, #1: 1	قَبْضِ ضَمَانٍ
u'قَبْضٌ ضَمَانٌ':Added, #3: 3	قَبْضَ ضَمَانٍ
u'قَبْضٌ ضَمَانٌ':Added, #7: 7	قَبْضِ الضَّمَانِ
u'قَبْضٌ ضَيْعَةٌ':Added, #7: 7	قَبْضُ ضَمَانٍ
u'قَبْضٌ طَالِبٌ':Added, #1: 1	قَبْضَ الضَّيْعَةِ
u'قَبْضٌ طَالِبٌ':Added, #1: 1	قَبْضَ الطَّالِبِ
u'قَبْضٌ طَالِبٌ':Added, #1: 1	قَبْضُ الطَّالِبِ
u'قَبَضَ طعام':Predicate, #1: 1	قَبْضِ الطَّالِبِ
u'قَبَضَ طَعَامٌ':Predicate, #1: 1	قَبَضَ الطَّعَامَ
u'قَبْضٌ طعام':Added, #1: 1	قَبَضَ الطَّعَامَ
u'قَبْضٌ طعام':Added, #1: 1	قَبْضَ الطَّعَامِ
u'قَبْضٌ طَعَامٌ':Added, #1: 1	قَبْضِ الطَّعَامِ
u'قَبْضٌ طَعَامٌ':Added, #1: 1	قَبْضَ الطَّعَامِ
u'قَبْضٌ طِفْلٌ':Added, #1: 1	قَبْضِ الطَّعَامِ
u'قَبَضَ ظالِمٌ':Subject, #1: 1	قَبْضُ الطِّفْلِ
u'قَبْضٌ عارِيَّةٌ':Added, #1: 1	قَبَضَ الظَّالِمُ
u'قَبَضَ عَاقِدٌ':Subject, #1: 1	قَبْضَ الْعَارِيَّةِ
u'قَبْضٌ عَاقِدٌ':Added, #1: 1	قَبَضَ الْعَاقِدُ
u'قَبَضَ عَبْدٌ':Predicate, #4: 4	قَبْضُ الْعَاقِدِ
u'قَبَضَ عَبْدٌ':Subject, #19: 19	قَبَضَ الْعَبْدَ
u'قَبَضَ عَبْدٌ':Subject, #1: 1	قَبَضَ عَبْدُ
u'قَبْضٌ عَبْدٌ':Added, #4: 4	قَبَضَ الْعَبْدُ
u'قَبْضٌ عَبْدٌ':Added, #2: 2	قَبْضَ الْعَبْدِ
u'قَبْضٌ عَبْدٌ':Added, #2: 2	قَبْضَ عَبْدٍ
u'قَبْضٌ عَبْدٌ':Added, #4: 4	قَبْضُ الْعَبْدِ
u'قَبَضَ عَدْلٌ':Subject, #5: 5	قَبْضِ الْعَبْدِ
u'قَبْضٌ عَدْلٌ':Added, #1: 1	قَبَضَ الْعَدْلُ
u'قَبْضٌ عَدْلٌ':Added, #1: 1	قَبْضُ الْعَدْلِ
u'قَبْضٌ عَدْلِيٌّ':Added, #1: 1	قَبْضِ الْعَدْلِ
u'قَبْضٌ عَدْلِيَّةٌ':Added, #1: 1	قَبْضِ الْعَدْلِيَّاتِ
u'قَبَضَ عُرُوضٌ':Predicate, #1: 1	قَبْضِ الْعَدْلِيَّاتِ
u'قَبْضٌ عَطَاءٌ':Added, #1: 1	قَبَضَ الْعُرُوضَ
u'قَبْضٌ عَقَارٌ':Added, #1: 1	قَبْضِ الْعَطَاءِ
u'قَبْضٌ عَقَارٌ':Added, #1: 1	قَبْضُ الْعَقَارِ
u'قَبْضٌ علماء':Added, #1: 1	قَبْضِ الْعَقَارِ
u'قَبْضٌ عُلَمَاءُ':Added, #3: 3	قَبْضِ الْعُلَمَاءِ
u'قَبْضٌ عِمَامَةٌ':Added, #3: 3	قَبْضِ الْعُلَمَاءِ
u'قَبَّضَ عُمَرٌ':Subject, #1: 1	قَبْضَ الْعِمَامَةِ
u'قَبَضَ عند':Predicate, #1: 1	قَبَّضَ عُمَرُ
u'قَبَضَ عِوَضٌ':Predicate, #2: 2	قَبَضَ عِنْدَ
u'قَبْضٌ عِوَضٌ':Added, #3: 3	قَبَضَ الْعِوَضَ
u'قَبْضٌ عِوَضٌ':Added, #1: 1	قَبْضُ عِوَضِهِ
u'قَبْضٌ عِوَضٌ':Added, #2: 2	قَبْضُ الْعِوَضِ
u'قَبْضٌ عِوَضٌ':Added, #3: 3	قَبْضُ الْعِوَضَيْنِ
u'قَبْضٌ عِوَضٌ':Added, #3: 3	قَبْضُ عِوَضِ
u'قَبْضٌ عِوَضٌ':Added, #5: 5	قَبْضِ الْعِوَضِ
u'قَبَضَ عين':Predicate, #7: 7	قَبْضِ الْعِوَضَيْنِ
u'قَبَضَ عَيْنٌ':Predicate, #7: 7	قَبَضَ الْعَيْنَ
u'قَبَضَ عَيْن':Predicate, #7: 7	قَبَضَ الْعَيْنَ
u'قَبْضٌ عين':Added, #7: 7	قَبَضَ الْعَيْنَ
u'قَبْضٌ عَيْنٌ':Added, #1: 1	قَبْضِ عَيْنِ
u'قَبْضٌ عَيْنٌ':Added, #1: 1	قَبْضَ عَيْنٍ
u'قَبْضٌ عَيْن':Added, #1: 1	قَبْضِ عَيْنِ
u'قَبْضٌ عَيْن':Added, #1: 1	قَبْضَ عَيْنٍ
u'قَبْضٌ عين':Added, #1: 1	قَبْضِ عَيْنِ
u'قَبْضٌ عَيْنٌ':Added, #2: 2	قَبْضُ الْعَيْنِ
u'قَبْضٌ عَيْن':Added, #2: 2	قَبْضُ الْعَيْنِ
u'قَبْضٌ عين':Added, #2: 2	قَبْضُ الْعَيْنِ
u'قَبْضٌ عَيْنٌ':Added, #2: 2	قَبْضُ عَيْنِ
u'قَبْضٌ عَيْن':Added, #2: 2	قَبْضُ عَيْنِ
u'قَبْضٌ عين':Added, #2: 2	قَبْضُ عَيْنِ
u'قَبْضٌ عَيْنٌ':Added, #8: 8	قَبْضِ الْعَيْنِ
u'قَبْضٌ عَيْن':Added, #8: 8	قَبْضِ الْعَيْنِ
u'قَبْضٌ غَاصِبٌ':Added, #8: 8	قَبْضِ الْعَيْنِ
u'قَبْضٌ غَاصِبٌ':Added, #1: 1	قَبْضَ الْغَاصِبِ
u'قَبْضٌ غَاصِبٌ':Added, #1: 1	قَبْضُ الْغَاصِبِ
u'قَبْضٌ غَاصِبٌ':Added, #1: 1	قَبْضِ الْغَاصِبِ
u'قَبَضَ غرماء':Subject, #1: 1	قَبْضِ غَاصِبِ
u'قَبَضَ غرماء':Subject, #1: 1	قَبَضَ الْغُرَمَاءُ
u'قَبَضَ غَرِيمٌ':Subject, #1: 1	قَبَضَ غُرَمَاءُ
u'قَبْضٌ غَرِيمٌ':Added, #1: 1	قَبَضَ الْغَرِيمُ
u'قَبْضٌ غِشٌّ':Added, #1: 1	قَبْضِ الْغَرِيمِ
u'قَبْضٌ غَصْبٌ':Added, #1: 1	قَبْضِ الْغِشِّ
u'قَبْضٌ غَصْبٌ':Added, #1: 1	قَبْضِ الْغَصْبِ
u'قَبْضٌ غَصْبٌ':Added, #2: 2	قَبْضَ الْغَصْبِ
u'قَبَضَ غَلَّةٌ':Predicate, #3: 3	قَبْضُ غَصْبٍ
u'قَبَضَ غير':Predicate, #1: 1	قَبَضَ الْغَلَّةَ
u'قَبَضَ غَيْرٌ':Predicate, #2: 2	قَبَضَ غَيْرَ
u'قَبْضٌ غير':Added, #2: 2	قَبَضَ غَيْرَ
u'قَبْضٌ غَيْرٌ':Added, #3: 3	قَبْضُ غَيْرِ
u'قَبْضٌ غير':Added, #3: 3	قَبْضُ غَيْرِ
u'قَبْضٌ غَيْرٌ':Added, #4: 4	قَبْضَ غَيْرِ
u'قَبَضَ فِرْعَوْنُ':Predicate, #4: 4	قَبْضَ غَيْرِ
u'قَبْضٌ فَقِيرٌ':Added, #1: 1	قَبَضَ فِرْعَوْنَ
u'قَبْضٌ فَقِيرٌ':Added, #1: 1	قَبْضَ الْفَقِيرِ
u'قَبْضٌ فَقِيرٌ':Added, #1: 1	قَبْضُ الْفَقِيرِ
u'قَبْضٌ فُلُوسٌ':Added, #1: 1	قَبْضِ الْفَقِيرِ
u'قَبَضَ قَابِلٌ':Subject, #1: 1	قَبْضِ الْفُلُوسِ
u'قَبَضَ قَالٌ':Predicate, #1: 1	قَبَضَ الْقَابِلُ
u'قَبْضٌ قَائِمٌ':Added, #1: 1	قَبَضَ قَالَ
u'قَبْضٌ قَبْضٌ':Added, #1: 1	قَبْضٍ قَائِمٍ
u'قَبْضٌ قَدْرٌ':Added, #1: 1	قَبْضُ الْقَبْضِ
u'قَبَضَ قَرْضٌ':Predicate, #1: 1	قَبْضَ الْقَدْرِ
u'قَبَضَ قَرْنٌ':Subject, #1: 1	قَبَضَ الْقَرْضَ
u'قَبْضٌ قُطْنٌ':Added, #1: 1	قَبَضَ قَرْنُهُ
u'قَبَضَ قلب':Predicate, #1: 1	قَبْضُ الْقُطْنِ
u'قَبَضَ قَلْبٌ':Predicate, #1: 1	قَبَضَ الْقَلْبَ
u'قَبَضَ قَلْب':Predicate, #1: 1	قَبَضَ الْقَلْبَ
u'قَبَضَ قِيمَةٌ':Predicate, #1: 1	قَبَضَ الْقَلْبَ
u'قَبْضٌ قِيمَةٌ':Added, #1: 1	قَبَضَ الْقِيمَةَ
u'قَبْضٌ كَبِيرٌ':Added, #4: 4	قَبْضِ الْقِيمَةِ
u'قَبْضٌ كِتَابَةٌ':Added, #1: 1	قَبْضَ الْكَبِيرِ
u'قَبَضَ كِرَاءٌ':Predicate, #1: 1	قَبْضِ الْكِتَابَةِ
u'قَبَضَ كِرْباس':Predicate, #1: 1	قَبَضَ الْكِرَاءَ
u'قَبْضٌ كَفٌّ':Added, #1: 1	قَبَضَ الْكِرْبَاسَ
u'قَبْضٌ كَفٌّ':Added, #1: 1	قَبْضَ الْكَفِّ
u'قَبْضٌ كَفٌّ':Added, #1: 1	قَبْضُ الْكَفِّ
u'قَبَضَ كَفِيلٌ':Subject, #1: 1	قَبْضَ كَفِّ
u'قَبَضَ لَقِيطٌ':Predicate, #1: 1	قَبَضَ الْكَفِيلُ
u'قَبَضَ مَالٌ':Predicate, #1: 1	قَبَضَ اللَّقِيطَ
u'قَبَضَ مَالٌ':Predicate, #14: 14	قَبَضَ الْمَالَ
u'قَبْضٌ مَالٌ':Added, #7: 7	قَبَضَ مَالَ
u'قَبْضٌ مَالٌ':Added, #11: 11	قَبْضِ الْمَالِ
u'قَبْضٌ مَالٌ':Added, #1: 1	قَبْضِ الْمَالَيْنِ
u'قَبْضٌ مَالٌ':Added, #1: 1	قَبْضِ مَالِ
u'قَبْضٌ مَالٌ':Added, #2: 2	قَبْضُ الْمَالِ
u'قَبْضٌ مَالٌ':Added, #2: 2	قَبْضُ مَالِ
u'قَبْضٌ مَالٌ':Added, #2: 2	قَبْضِ مَالٍ
u'قَبْضٌ مَالِكٌ':Added, #2: 2	قَبْضَ مَالِهِ
u'قَبَضَ مُبْتاع':Subject, #1: 1	قَبْضِ الْمَالِكِ
u'قَبَضَ مَبْلَغٌ':Predicate, #2: 2	قَبَضَ الْمُبْتَاعُ
u'قَبَضَ مَبِيعٌ':Predicate, #1: 1	قَبَضَ مَبْلَغَ
u'قَبَضَ مَبِيعٌ':Subject, #15: 15	قَبَضَ الْمَبِيعَ
u'قَبْضٌ مَبِيعٌ':Added, #1: 1	قَبَضَ الْمَبِيعُ
u'قَبْضٌ مَبِيعٌ':Added, #1: 1	قَبْض الْمَبِيعِ
u'قَبْضٌ مَبِيعٌ':Added, #1: 1	قَبْضِ مَبِيعٍ
u'قَبْضٌ مَبِيعٌ':Added, #46: 46	قَبْضِ الْمَبِيعِ
u'قَبْضٌ مَبِيعٌ':Added, #4: 4	قَبْضُ الْمَبِيعِ
u'قَبَضَ مَتَاعٌ':Predicate, #8: 8	قَبْضَ الْمَبِيعِ
u'قَبْضٌ مَتَاعٌ':Added, #2: 2	قَبَضَ الْمَتَاعَ
u'قَبْضٌ مُتَّصِلٌ':Added, #1: 1	قَبْضِ الْمَتَاعِ
u'قَبَضَ مُتَوَسِّطٌ':Subject, #1: 1	قَبْضُ الْمُتَّصِلِ
u'قَبْضٌ مثل':Added, #1: 1	قَبَضَ الْمُتَوَسِّطُ
u'قَبْضٌ مِثْلٌ':Added, #1: 1	قَبْضِ الْمِثْلِ
u'قَبْضٌ مَثْمُون':Added, #1: 1	قَبْضِ الْمِثْلِ
u'قَبْضٌ مَحَاضِرُ':Added, #2: 2	قَبْضِ الْمَثْمُونِ
u'قَبْضٌ مُحْتَالٌ':Added, #3: 3	قَبْضِ الْمَحَاضِرِ
u'قَبْضٌ مَحْجُورٌ':Added, #6: 6	قَبْضِ الْمُحْتَالِ
u'قَبْضٌ مُحِيل':Added, #1: 1	قَبْضُ الْمَحْجُورِ
u'قَبْضٌ مُرْتَدٌّ':Added, #1: 1	قَبْضِ الْمُحِيلِ
u'قَبَضَ مُرْتَهِنٌ':Subject, #1: 1	قَبْضَ الْمُرْتَدِّ
u'قَبَضَ مُرْتَهِنٌ':Subject, #1: 1	قَبَضَ مُرْتَهِنٌ
u'قَبْضٌ مُرْتَهِنٌ':Added, #4: 4	قَبَضَ الْمُرْتَهِنُ
u'قَبْضٌ مُرْتَهِنٌ':Added, #2: 2	قَبْضَ الْمُرْتَهِنِ
u'قَبْضٌ مُرْتَهِنٌ':Added, #4: 4	قَبْضُ الْمُرْتَهِنِ
u'قَبْضٌ مَرْهُونٌ':Added, #8: 8	قَبْضِ الْمُرْتَهِنِ
u'قَبْضٌ مَرْهُونٌ':Added, #2: 2	قَبْضُ الْمَرْهُونِ
u'قَبْضٌ مساكين':Added, #2: 2	قَبْضِ الْمَرْهُونِ
u'قَبَضَ مُسْتَأْجِرٌ':Subject, #1: 1	قَبْضُ الْمَسَاكِينِ
u'قَبْضٌ مُسْتَأْجِرٌ':Added, #5: 5	قَبَضَ الْمُسْتَأْجِرُ
u'قَبْضٌ مُسْتَأْجِرٌ':Added, #1: 1	قَبْضُ الْمُسْتَأْجِرِ
u'قَبْضٌ مُسْتَحِقٌّ':Added, #2: 2	قَبْضِ الْمُسْتَأْجِرِ
u'قَبْضٌ مُسْتَحَقٌّ':Added, #1: 1	قَبْضُ الْمُسْتَحِقِّ
u'قَبْضٌ مُسْتَحِقٌّ':Added, #1: 1	قَبْضُ الْمُسْتَحَقَّةِ
u'قَبْضٌ مُسْتَعِيرٌ':Added, #3: 3	قَبْضِ الْمُسْتَحِقِّ
u'قَبَضَ مُسَلَّمٌ':Predicate, #1: 1	قَبْضَ الْمُسْتَعِيرِ
u'قَبْضٌ مُسَلَّمٌ':Added, #1: 1	قَبَضَ الْمُسَلَّمَ
u'قَبْضٌ مُسَلَّمٌ':Added, #1: 1	قَبْضِ الْمُسَلَّمِ
u'قَبْضٌ مُشاعٌ':Added, #2: 2	قَبْضُ الْمُسَلَّمِ
u'قَبَضَ مَشْهُودٌ':Subject, #2: 2	قَبْضُ الْمُشَاعِ
u'قَبْضٌ مَشْهُودٌ':Added, #1: 1	قَبَضَ الْمَشْهُودُ
u'قَبَضَ مُصَالِحٌ':Subject, #1: 1	قَبْضِ الْمَشْهُودِ
u'قَبَضَ مُضَارِبٌ':Subject, #1: 1	قَبَضَ الْمُصَالِحُ
u'قَبْضٌ مَضْمُونٌ':Added, #2: 2	قَبَضَ الْمُضَارِبُ
u'قَبْضٌ مَضْمُونٌ':Added, #1: 1	قَبْضِ الْمَضْمُونِ
u'قَبَضَ مُعَجَّلٌ':Predicate, #2: 2	قَبْضٍ مَضْمُونٍ
u'قَبْضٌ مُعَجَّلٌ':Added, #1: 1	قَبَضَ الْمُعَجَّلَ
u'قَبْضٌ مَعْقُودٌ':Added, #1: 1	قَبْضِ مُعَجَّلِ
u'قَبْضٌ مَعْقُودٌ':Added, #2: 2	قَبْضُ الْمَعْقُودِ
u'قَبَضَ مَعْلُومٌ':Predicate, #3: 3	قَبْضِ الْمَعْقُودِ
u'قَبَضَ مَعِيبٌ':Predicate, #1: 1	قَبَضَ مَعْلُومَ
u'قَبْضٌ مُعَيَّنٌ':Added, #1: 1	قَبَضَ الْمَعِيبَ
u'قَبَضَ مَغْصُوب':Predicate, #2: 2	قَبْضِ الْمُعَيَّنِ
u'قَبْضٌ مَغْصُوب':Added, #1: 1	قَبَضَ الْمَغْصُوبَ
u'قَبَضَ مِقْدَارٌ':Predicate, #2: 2	قَبْضُ الْمَغْصُوبِ
u'قَبَضَ مُقْرِضٌ':Subject, #1: 1	قَبَضَ الْمِقْدَارَ
u'قَبَضَ مَقْضِيّ':Subject, #1: 1	قَبَضَ الْمُقْرِضُ
u'قَبَضَ مَكَاتِبُ':Subject, #2: 2	قَبَضَ الْمَقْضِيُّ
u'قَبْضٌ مَكِيلٌ':Added, #1: 1	قَبَضَ الْمَكَاتِبُ
u'قَبْضٌ مَكِيلٌ':Added, #1: 1	قَبْضِ الْمَكِيلِ
u'قَبَضَ مَلاَئِكَةٌ':Subject, #2: 2	قَبْضُ مَكِيلٍ
u'قَبْضٌ مُلْتَقِط':Added, #1: 1	قَبَضَ الْمَلَائِكَةُ
u'قَبَضَ مِلْكٌ':Predicate, #1: 1	قَبْضِ الْمُلْتَقِطِ
u'قَبْضٌ مِلْكٌ':Added, #1: 1	قَبَضَ مِلْكَ
u'قَبْضٌ مُمَيِّزٌ':Added, #2: 2	قَبْضِ مِلْكِهِ
u'قَبْضٌ مَنَافِعُ':Added, #1: 1	قَبْضُ مُمَيِّزٍ
u'قَبْضٌ مَنْذُور':Added, #1: 1	قَبْضُ الْمَنَافِعِ
u'قَبْضٌ مَنْفَعَةٌ':Added, #1: 1	قَبْضِ الْمَنْذُورِ
u'قَبْضٌ مَنْقُولٌ':Added, #3: 3	قَبْضِ الْمَنْفَعَةِ
u'قَبْضٌ مَنْكُوح':Added, #1: 1	قَبْضَ الْمَنْقُولِ
u'قَبَضَ مَهْرٌ':Predicate, #1: 1	قَبْضُ الْمَنْكُوحَةِ
u'قَبَضَ مَهْرٌ':Subject, #3: 3	قَبَضَ مَهْرَ
u'قَبْضٌ مَهْرٌ':Added, #1: 1	قَبَضَ مَهْرُ
u'قَبْضٌ مَهْرٌ':Added, #15: 15	قَبْضِ الْمَهْرِ
u'قَبْضٌ مَهْرٌ':Added, #1: 1	قَبْضَ الْمَهْرِ
u'قَبْضٌ مَهْرٌ':Added, #1: 1	قَبْضُ الْمَهْرِ
u'قَبْضٌ مَهْرٌ':Added, #1: 1	قَبْضَ مَهْرِ
u'قَبَضَ مُؤَجِّرٌ':Subject, #4: 4	قَبْضُ مَهْرِ
u'قَبْضٌ مُؤَجِّرٌ':Added, #1: 1	قَبَضَ الْمُؤَجِّرُ
u'قَبْضٌ مُودَعٌ':Added, #1: 1	قَبْضُ الْمُؤَجِّرِ
u'قَبْضٌ مَوْقُوفٌ':Added, #2: 2	قَبْضَ الْمُودَعِ
u'قَبَضَ مُوَكِّلٌ':Subject, #1: 1	قَبْضُ الْمَوْقُوفِ
u'قَبْضٌ مُوَكِّلٌ':Added, #4: 4	قَبَضَ الْمُوَكِّلُ
u'قَبْضٌ مُوَكِّلٌ':Added, #1: 1	قَبْضُ الْمُوَكِّلِ
u'قَبْضٌ مُوَكِّلٌ':Added, #2: 2	قَبْضِ الْمُوَكِّلِ
u'قَبَضَ مَوْهُوبٌ':Predicate, #4: 4	قَبْضَ الْمُوَكِّلِ
u'قَبْضٌ مَوْهُوبٌ':Added, #1: 1	قَبَضَ الْمَوْهُوبَ
u'قَبْضٌ مَوْهُوبٌ':Added, #2: 2	قَبْضَ الْمَوْهُوبِ
u'قَبْضٌ مَوْهُوبٌ':Added, #2: 2	قَبْضُ الْمَوْهُوبِ
u'قَبَضَ نَاظِرٌ':Subject, #4: 4	قَبْضِ الْمَوْهُوبِ
u'قَبَضَ نُجُومٌ':Predicate, #1: 1	قَبَضَ النَّاظِرُ
u'قَبْضٌ نُجُومٌ':Added, #3: 3	قَبَضَ النُّجُومَ
u'قَبَضَ نَخِيلٌ':Predicate, #3: 3	قَبْضِ النُّجُومِ
u'قَبْضٌ نصاب':Added, #1: 1	قَبَضَ النَّخِيلَ
u'قَبْضٌ نِصَابٌ':Added, #1: 1	قَبْضِ النِّصَابِ
u'قَبَضَ نِصْفٌ':Predicate, #1: 1	قَبْضِ النِّصَابِ
u'قَبَضَ نِصْفٌ':Predicate, #1: 1	قَبَضَ النِّصْفَ
u'قَبْضٌ نِصْفٌ':Added, #3: 3	قَبَضَ نِصْفَ
u'قَبْضٌ نِصْفٌ':Added, #1: 1	قَبْضِ النِّصْفِ
u'قَبْضٌ نِصْفٌ':Added, #1: 1	قَبْضَ نِصْفِ
u'قَبَضَ نَصِيبٌ':Predicate, #1: 1	قَبْضُ نِصْفِ
u'قَبَضَ نَصِيبٌ':Predicate, #1: 1	قَبَضَ النَّصِيبَ
u'قَبْضٌ نَصِيبٌ':Added, #1: 1	قَبَضَ نَصِيبَ
u'قَبْضٌ نَصِيبٌ':Added, #2: 2	قَبْضَ نَصِيبِ
u'قَبْضٌ نَصِيبٌ':Added, #2: 2	قَبْضُ نَصِيبِ
u'قَبْضٌ نَصِيبٌ':Added, #2: 2	قَبْضُ نَصِيبِهِ
u'قَبْضٌ نَصِيبٌ':Added, #3: 3	قَبْضَ نَصِيبِهِ
u'قَبَضَ نَفْسٌ':Predicate, #4: 4	قَبْضِ نَصِيبِهِ
u'قَبْضٌ نَفْسٌ':Added, #1: 1	قَبَضَ نَفْسَ
u'قَبْضٌ نَفْسٌ':Added, #1: 1	قَبْضُ نَفْسِ
u'قَبْضٌ نَفْسٌ':Added, #1: 1	قَبْضِ نَفْسِ
u'قَبَضَ نَفَقَةٌ':Predicate, #1: 1	قَبْضِ نَفْسِهِ
u'قَبْضٌ نَفَقَةٌ':Added, #1: 1	قَبَضَ نَفَقَةَ
u'قَبْضٌ نَفَقَةٌ':Added, #1: 1	قَبْضِ النَّفَقَةِ
u'قَبَضَ نَقْدٌ':Predicate, #1: 1	قَبْضُ نَفَقَتِهِ
u'قَبَضَ نَقْد':Predicate, #1: 1	قَبَضَ النَّقْدَ
u'قَبَضَ نكرة':Subject, #1: 1	قَبَضَ النَّقْدَ
u'قَبَضَ نَكِرَةٌ':Subject, #1: 1	قَبَضَ نَكِرَةٌ
u'قَبْضٌ هِبَةٌ':Added, #1: 1	قَبَضَ نَكِرَةٌ
u'قَبْضٌ هِبَةٌ':Added, #12: 12	قَبْضِ الْهِبَةِ
u'قَبْضٌ هِبَةٌ':Added, #1: 1	قَبْضَ الْهِبَةِ
u'قَبْضٌ هِبَةٌ':Added, #1: 1	قَبْضِ هِبَةٍ
u'قَبَضَ واحد':Subject, #6: 6	قَبْضُ الْهِبَةِ
u'قَبَضَ وَاحِدٌ':Subject, #2: 2	قَبَضَ وَاحِدٌ
u'قَبْضٌ واحد':Added, #2: 2	قَبَضَ وَاحِدٌ
u'قَبْضٌ وَاحِدٌ':Added, #1: 1	قَبْضَ الْوَاحِدِ
u'قَبَضَ وَارِثٌ':Subject, #1: 1	قَبْضَ الْوَاحِدِ
u'قَبْضٌ وَارِثٌ':Added, #1: 1	قَبَضَ الْوَارِثُ
u'قَبْضٌ وَارِثٌ':Added, #1: 1	قَبْضِ وَارِثٍ
u'قَبَضَ وَاهِبٌ':Subject, #2: 2	قَبْضُ الْوَارِثِ
u'قَبْضٌ وَاهِبٌ':Added, #1: 1	قَبَضَ الْوَاهِبُ
u'قَبْضٌ وَاهِبٌ':Added, #1: 1	قَبْضَ الْوَاهِبِ
u'قَبْضٌ وَدِيعٌ':Added, #2: 2	قَبْضُ الْوَاهِبِ
u'قَبْضٌ وَدِيعٌ':Added, #1: 1	قَبْضَ الْوَدِيعَةِ
u'قَبْضٌ وَدِيعٌ':Added, #1: 1	قَبْضُ الْوَدِيعَةِ
u'قَبْضٌ وَدِيعَةٌ':Added, #1: 1	قَبْضِ الْوَدِيعَةِ
u'قَبْضٌ وَدِيعَةٌ':Added, #1: 1	قَبْضَ الْوَدِيعَةِ
u'قَبْضٌ وَدِيعَةٌ':Added, #1: 1	قَبْضُ الْوَدِيعَةِ
u'قَبْضٌ وَدِيعَةٌ':Added, #1: 1	قَبْضِ الْوَدِيعَةِ
u'قَبَضَ وَرَثَةٌ':Subject, #1: 1	قَبْضِ وَدِيعَةٍ
u'قَبْضٌ وَرَثَةٌ':Added, #1: 1	قَبَضَ وَرَثَتُهُ
u'قَبَضَ وَصِيٌّ':Subject, #4: 4	قَبْضِ الْوَرَثَةِ
u'قَبْضٌ وفاة':Added, #1: 1	قَبَضَ الْوَصِيُّ
u'قَبْضٌ وَفَاةٌ':Added, #1: 1	قَبْضَ وَفَاةٍ
u'قَبَضَ وَكِيلٌ':Subject, #1: 1	قَبْضَ وَفَاةٍ
u'قَبْضٌ وَكِيلٌ':Added, #11: 11	قَبَضَ الْوَكِيلُ
u'قَبْضٌ وَكِيلٌ':Added, #1: 1	قَبْضِ وَكِيلِ
u'قَبْضٌ وَكِيلٌ':Added, #1: 1	قَبْضَ وَكِيلِهِ
u'قَبْضٌ وَكِيلٌ':Added, #1: 1	قَبْضِ وَكِيلِهِ
u'قَبْضٌ وَكِيلٌ':Added, #2: 2	قَبْضَ الْوَكِيلِ
u'قَبْضٌ وَكِيلٌ':Added, #2: 2	قَبْضُ الْوَكِيلِ
u'قَبْضٌ ولد':Added, #6: 6	قَبْضِ الْوَكِيلِ
u'قَبْضٌ وَلَدٌ':Added, #2: 2	قَبْضُ الْوَلَدِ
u'قَبَضَ وَلَهٌ':Subject, #2: 2	قَبْضُ الْوَلَدِ
u'قَبَضَ وَلِيٌّ':Subject, #2: 2	قَبَضَ وَلَهُ
u'قَبْضٌ وَلِيٌّ':Added, #1: 1	قَبَضَ الْوَلِيُّ
u'قَبَضَ وَهَلٌ':Predicate, #2: 2	قَبْضِ وَلِيِّ
u'قَبَضَ يَدٌ':Predicate, #1: 1	قَبَضَ وَهَلَكَ
u'قَبِلَ أَبٌ':Subject, #1: 1	قَبَضَ الْيَدَ
u'قَبَّلَ أَبٌ':Subject, #10: 10	قَبِلَ الْأَبُ
u'قَبِلَ اِبْنٌ':Predicate, #1: 1	قَبَّلَ الْأَبُ
u'قَبِلَ اِبْنٌ':Subject, #1: 1	قَبِلَ ابْنَ
u'قَبَّلَ اِبْنٌ':Subject, #1: 1	قَبِلَ ابْنُ
u'قَبِلَ أُجْرَةٌ':Predicate, #2: 2	قَبَّلَ ابْنُ
u'قَبَّلَ أَجْنَبِيٌّ':Predicate, #3: 3	قَبِلَ أُجْرَةَ
u'قَبِلَ أحَدٌ':Subject, #5: 5	قَبَّلَ أَجْنَبِيَّةً
u'قَبَّلَ أحَدٌ':Subject, #1: 1	قَبِلَ أَحَدٌ
u'قَبِلَ أحَدٌ':Subject, #1: 1	قَبَّلَ أَحَدٌ
u'قَبِلَ أخْذٌ':Predicate, #2: 2	قَبِلَ أَحَدُ
u'قَبَلٌ إِرْسَالٌ':Added, #1: 1	قَبِلَ أَخْذَ
u'قَبَّلَ أرْضٌ':Predicate, #1: 1	قَبَلَ الْإِرْسَالِ
u'قَبِلَ اِسْتِحْقَاقٌ':Predicate, #1: 1	قَبَّلَ الْأَرْضَ
u'قَبِلَ أصل':Predicate, #1: 1	قَبِلَ اسْتِحْقَاقَ
u'قَبِلَ أًصْلٌ':Predicate, #1: 1	قَبِلَ أَصْلَ
u'قَبِلَ إقْرَارٌ':Predicate, #1: 1	قَبِلَ أَصْلَ
u'قَبِلَ أكَّارٌ':Subject, #2: 2	قَبِلَ الْإِقْرَارَ
u'قَبَّلَ أُمٌّ':Predicate, #1: 1	قَبِلَ الْأَكَّارُ
u'قَبِلَ إمَامٌ':Subject, #1: 1	قَبَّلَ أُمَّ
u'قَبَّلَ اِمْرَأَةٌ':Predicate, #8: 8	قَبِلَ الْإِمَامُ
u'قَبِلَ بَانٌ':Predicate, #3: 3	قَبَّلَ امْرَأَةَ
u'قَبِلَ بَائِعٌ':Subject, #1: 1	قَبِلَ بَانَ
u'قَبِلَ بَدَلٌ':Predicate, #7: 7	قَبِلَ الْبَائِعُ
u'قَبِلَ بَراءةٌ':Predicate, #1: 1	قَبِلَ الْبَدَلَ
u'قَبِلَ بَعْضٌ':Predicate, #2: 2	قَبِلَ الْبَرَاءَةَ
u'قَبَّلَ بَعْضٌ':Predicate, #1: 1	قَبِلَ بَعْضَ
u'قَبِلَ بَعْضٌ':Subject, #2: 2	قَبَّلَ بَعْضَ
u'قَبِلَ بَيْعٌ':Predicate, #1: 1	قَبِلَ الْبَعْضُ
u'قَبِلَ بَيْعٌ':Subject, #5: 5	قَبِلَ الْبَيْعَ
u'قَبَّلَ بَيْنٌ':Predicate, #1: 1	قَبِلَ الْبَيْعُ
u'قَبِلَ بَيِّنَةٌ':Predicate, #1: 1	قَبَّلَ بَيْنَ
u'قَبِلَ تَصَادُقٌ':Predicate, #3: 3	قَبِلَ الْبَيِّنَةَ
u'قَبِلَ تَصْدِيقٌ':Subject, #1: 1	قَبِلَ التَّصَادُقَ
u'قَبِلَ تَصَرُّفٌ':Predicate, #1: 1	قَبِلَ التَّصْدِيقُ
u'قَبِلَ تَعْلِيقٌ':Predicate, #1: 1	قَبِلَ التَّصَرُّفَ
u'قَبِلَ تَعْلِيمٌ':Predicate, #3: 3	قَبِلَ التَّعْلِيقَ
u'قَبِلَ تَعْلِيمٌ':Predicate, #1: 1	قَبِلَ التّعْلِيمَ
u'قَبِلَ تَهْنِئَةٌ':Predicate, #2: 2	قَبِلَ التَّعْلِيمَ
u'قَبِلَ تَوْكِيلٌ':Predicate, #1: 1	قَبِلَ التَّهْنِئَةَ
u'قَبِلَ تَوْلِيَةٌ':Predicate, #1: 1	قَبِلَ التَّوْكِيلَ
u'قَبِلَ ثَوْبٌ':Predicate, #1: 1	قَبِلَ التَّوْلِيَةَ
u'قَبِلَ جَازٌ':Predicate, #1: 1	قَبِلَ الثَّوْبَ
u'قَبِلَ جَائِزٌ':Predicate, #7: 7	قَبِلَ جَازَ
u'قَبِلَ جَائِزَةٌ':Predicate, #1: 1	قَبِلَ الْجَائِزَةَ
u'قَبِلَ جُرْحٌ':Predicate, #1: 1	قَبِلَ الْجَائِزَةَ
u'قَبِلَ جِزْيَةٌ':Predicate, #1: 1	قَبِلَ جُرْحَ
u'قَبِلَ جوائز':Predicate, #1: 1	قَبِلَ الْجِزْيَةَ
u'قَبِلَ جَوَائِزُ':Predicate, #1: 1	قَبِلَ الْجَوَائِزَ
u'قَبِلَ حاكِمٌ':Subject, #1: 1	قَبِلَ الْجَوَائِزَ
u'قَبِلَ حالٌ':Predicate, #1: 1	قَبِلَ الْحَاكِمُ
u'قَبَّلَ حَجَرٌ':Predicate, #1: 1	قَبِلَ حَالَ
u'قَبَّلَ حُرٌّ':Predicate, #8: 8	قَبَّلَ الْحَجَرَ
u'قَبَّلَ حَسَنٌ':Predicate, #1: 1	قَبَّلَ حُرَّةً
u'قَبِلَ حَصَلٌ':Predicate, #1: 1	قَبَّلَ الْحَسَنَ
u'قَبِلَ حِفْظٌ':Predicate, #1: 1	قَبِلَ حَصَلَ
u'قَبِلَ حَوَالَةٌ':Predicate, #1: 1	قَبِلَ الْحِفْظَ
u'قَبِلَ حَيٌّ':Subject, #9: 9	قَبِلَ الْحَوَالَةَ
u'قَبَّلَ خَالِدٌ':Subject, #1: 1	قَبِلَ الْحَيُّ
u'قَبِلَ خَبَرٌ':Predicate, #1: 1	قَبَّلَ خَالِدُ
u'قَبِلَ خَبَر':Predicate, #3: 3	قَبِلَ خَبَرَ
u'قَبَّلَ خَدٌّ':Predicate, #3: 3	قَبِلَ خَبَرَ
u'قَبِلَ خُلْعٌ':Predicate, #1: 1	قَبَّلَ خَدَّ
u'قَبِلَ دَابَّةٌ':Predicate, #1: 1	قَبِلَ الْخُلْعَ
u'قَبِلَ دُخُولٌ':Predicate, #1: 1	قَبِلَ الدَّابَّةَ
u'قَبِلَ دفع':Predicate, #1: 1	قَبِلَ الدُّخُولَ
u'قَبِلَ دَفْعٌ':Predicate, #1: 1	قَبِلَ الدَّفْعَ
u'قَبِلَ دِيَةٌ':Predicate, #1: 1	قَبِلَ الدَّفْعَ
u'قَبِلَ دَيْنٌ':Predicate, #3: 3	قَبِلَ الدِّيَةَ
u'قَبَّلَ ذكر':Subject, #1: 1	قَبِلَ الدَّيْنَ
u'قَبَّلَ ذَكَرٌ':Subject, #1: 1	قَبَّلَ الذَّكَرُ
u'قَبِلَ ذِمَّةٌ':Predicate, #1: 1	قَبَّلَ الذَّكَرُ
u'قَبَّلَ رَأْسٌ':Predicate, #3: 3	قَبِلَ الذِّمَّةَ
u'قَبِلَ رَبُّ':Subject, #1: 1	قَبَّلَ رَأْسَ
u'قَبَّلَ رَجُلٌ':Subject, #1: 1	قَبِلَ رَبُّ
u'قَبَّلَ رَسُولٌ':Predicate, #4: 4	قَبَّلَ الرَّجُلُ
u'قَبَّلَ رَسُولٌ':Subject, #1: 1	قَبَّلَ رَسُولَ
u'قَبِلَ رَشيدٌ':Subject, #2: 2	قَبَّلَ رَسُولُ
u'قَبِلَ رَقيقٌ':Subject, #1: 1	قَبِلَ رَشِيدٌ
u'قَبِلَ رَقيق':Subject, #1: 1	قَبِلَ الرَّقِيقُ
u'قَبَّلَ رُكْنٌ':Predicate, #1: 1	قَبِلَ الرَّقِيقُ
u'قَبَّلَ رُكْن':Predicate, #1: 1	قَبَّلَ الرُّكْنَ
u'قَبِلَ رَهْنٌ':Predicate, #1: 1	قَبَّلَ الرُّكْنَ
u'قَبِلَ زَوْجٌ':Subject, #3: 3	قَبِلَ الرَّهْنَ
u'قَبِلَ زِيادَةٌ':Predicate, #4: 4	قَبِلَ الزَّوْجُ
u'قَبِلَ زِيادَةٌ':Predicate, #1: 1	قَبِلَ زِيَادَةَ
u'قَبِلَ زَيْدٌ':Subject, #2: 2	قَبِلَ الزِّيَادَةَ
u'قَبِلَ سَبْرٌ':Predicate, #1: 1	قَبِلَ زَيْدٌ
u'قَبِلَ سَلَفٌ':Subject, #1: 1	قَبِلَ السَّبْرَ
u'قَبِلَ سَواءٌ':Subject, #1: 1	قَبِلَ السَّلَفُ
u'قَبِلَ سُؤَالٌ':Predicate, #1: 1	قَبِلَ سَوَاءٌ
u'قَبِلَ سَيِّدٌ':Subject, #1: 1	قَبِلَ سُؤَالَ
u'قَبَّلَ شَابٌّ':Subject, #1: 1	قَبِلَ السَّيِّدُ
u'قَبِلَ شافِعِيّ':Subject, #1: 1	قَبَّلَ شَابٌّ
u'قَبِلَ شَرْطٌ':Predicate, #1: 1	قَبِلَ الشَّافِعِيُّ
u'قَبِلَ شَهَادَةٌ':Predicate, #2: 2	قَبِلَ الشَّرْطَ
u'قَبِلَ شَهَادَةٌ':Predicate, #10: 10	قَبِلَ شَهَادَةَ
u'قَبِلَ شَيْخٌ':Subject, #2: 2	قَبِلَ الشَّهَادَةَ
u'قَبِلَ صدقة':Predicate, #1: 1	قَبِلَ الشَّيْخُ
u'قَبِلَ صَدَقَةٌ':Predicate, #1: 1	قَبِلَ صَدَقَتَكَ
u'قَبِلَ صَغِيرٌ':Subject, #1: 1	قَبِلَ صَدَقَتَكَ
u'قَبِلَ صلح':Predicate, #1: 1	قَبِلَ الصَّغِيرُ
u'قَبِلَ صُلْحٌ':Predicate, #1: 1	قَبِلَ الصُّلْحَ
u'قَبِلَ طَالِبٌ':Subject, #1: 1	قَبِلَ الصُّلْحَ
u'قَبِلَ طَلاَقٌ':Predicate, #2: 2	قَبِلَ الطَّالِبُ
u'قَبِلَ عَبْدٌ':Subject, #1: 1	قَبِلَ الطَّلَاقَ
u'قَبَّلَ عتبة':Predicate, #12: 12	قَبِلَ الْعَبْدُ
u'قَبَّلَ عَتَبَةٌ':Predicate, #1: 1	قَبَّلَ عَتَبَةَ
u'قَبِلَ عتق':Predicate, #1: 1	قَبَّلَ عَتَبَةَ
u'قَبِلَ عزل':Predicate, #2: 2	قَبِلَ عَتَقَ
u'قَبِلَ عَقْدٌ':Subject, #1: 1	قَبِلَ عَزْلَ
u'قَبِلَ عَمَلٌ':Predicate, #1: 1	قَبِلَ الْعَقْدُ
u'قَبِلَ عُمُومٌ':Predicate, #1: 1	قَبِلَ الْعَمَلَ
u'قَبِلَ عند':Predicate, #2: 2	قَبِلَ الْعُمُومَ
u'قَبِلَ عِوَضٌ':Predicate, #1: 1	قَبِلَ عِنْدَ
u'قَبِلَ غَائِبٌ':Subject, #1: 1	قَبِلَ الْعِوَضَ
u'قَبِلَ غَرِيمٌ':Subject, #1: 1	قَبِلَ الْغَائِبُ
u'قَبِلَ غير':Predicate, #2: 2	قَبِلَ الْغَرِيمُ
u'قَبِلَ غَيْرٌ':Predicate, #1: 1	أَقْبَلَ غَيْرَ
u'قَبِلَ غير':Predicate, #1: 1	أَقْبَلَ غَيْرَ
u'قَبِلَ غَيْرٌ':Predicate, #3: 3	قَبِلَ غَيْرَ
u'قَبِلَ فَسْخٌ':Predicate, #3: 3	قَبِلَ غَيْرَ
u'قَبِلَ فُضُولِيٌّ':Subject, #1: 1	قَبِلَ الْفَسْخَ
u'قَبَّلَ فلان':Predicate, #2: 2	قَبِلَ فُضُولِيٌّ
u'قَبِلَ فلان':Subject, #1: 1	قَبَّلَ عُثْمَانَ
u'قَبِلَ فُلاَنٌ':Subject, #1: 1	قَبِلَ الشَّافِعِيُّ
u'قَبَّلَ فلان':Subject, #1: 1	قَبِلَ فُلَانٌ
u'قَبِلَ قَالٌ':Predicate, #1: 1	قَبَّلَ مُعَاوِيَةُ
u'قَبِلَ قَبْضٌ':Predicate, #3: 3	أَقْبَلَ قَالَ
u'قَبِلَ قول':Predicate, #1: 1	قَبِلَ الْقَبْضَ
u'قَبِلَ قَوْلٌ':Predicate, #3: 3	قَبِلَ قَوْلَ
u'قَبِلَ كِتَابٌ':Predicate, #3: 3	قَبِلَ قَوْلَ
u'قَبِلَ كِتَابَةٌ':Predicate, #4: 4	قَبِلَ الْكِتَابَ
u'قَبِلَ كَفَالَةٌ':Predicate, #3: 3	قَبِلَ الْكِتَابَةَ
u'قَبِلَ كَفِيلٌ':Subject, #1: 1	قَبِلَ الْكَفَالَةَ
u'قَبِلَ لُزُومٌ':Predicate, #1: 1	قَبِلَ الْكَفِيلُ
u'قَبِلَ مَالٌ':Predicate, #1: 1	قَبِلَ اللُّزُومَ
u'قَبِلَ مَالٌ':Predicate, #1: 1	قَبِلَ مَالَ
u'قَبِلَ مَأْمُورٌ':Subject, #2: 2	قَبِلَ الْمَالَ
u'قَبِلَ مُحْتَالٌ':Subject, #1: 1	قَبِلَ مَأْمُورٌ
u'قَبِلَ مَدْفُوعٌ':Subject, #1: 1	قَبِلَ الْمُحْتَالُ
u'قَبِلَ مراسيل':Predicate, #1: 1	قَبِلَ الْمَدْفُوعُ
u'قَبِلَ مَرَاسِيلُ':Predicate, #1: 1	قَبِلَ مَرَاسِيلَ
u'قَبِلَ مُرْتَهِنٌ':Subject, #1: 1	قَبِلَ مَرَاسِيلَ
u'قَبِلَ مُرْسَلٌ':Predicate, #1: 1	قَبِلَ الْمُرْتَهِنُ
u'قَبِلَ مُسْتَأْجِرٌ':Subject, #1: 1	قَبِلَ الْمُرْسَلَ
u'قَبِلَ مَشُورَةٌ':Predicate, #1: 1	قَبِلَ الْمُسْتَأْجِرُ
u'قَبِلَ مُعَارَضَةٌ':Predicate, #1: 1	قَبِلَ مَشُورَةَ
u'قَبَّلَ مُعاوِيَة':Subject, #1: 1	قَبِلَ الْمُعَارَضَةَ
u'قَبِلَ مُعْتَادٌ':Predicate, #1: 1	قَبَّلَ مُعَاوِيَةُ
u'قَبِلَ مُعَمَّرٌ':Subject, #1: 1	قَبِلَ الْمُعْتَادَ
u'قَبِلَ مَكْتُوبٌ':Subject, #1: 1	قَبِلَ الْمُعَمَّرُ
u'قَبِلَ مَوْهُوبٌ':Subject, #1: 1	قَبِلَ الْمَكْتُوبُ
u'قَبِلَ نَحْوٌ':Predicate, #2: 2	قَبِلَ الْمَوْهُوبُ
u'قَبِلَ نَفَذٌ':Predicate, #4: 4	أَقْبَلَ نَحْوَ
u'قَبِلَ نقل':Predicate, #1: 1	قَبِلَ نَفَذَ
u'قَبِلَ نَقْلٌ':Predicate, #1: 1	قَبِلَ النَّقْلَ
u'قَبِلَ نقل':Predicate, #1: 1	قَبِلَ النَّقْلَ
u'قَبِلَ نَقْلٌ':Predicate, #1: 1	قَبِلَ نَقْلَ
u'قَبِلَ نكاح':Predicate, #1: 1	قَبِلَ نَقْلَ
u'قَبِلَ نِكَاحٌ':Predicate, #2: 2	قَبِلَ نِكَاحَ
u'قَبِلَ نكاح':Predicate, #2: 2	قَبِلَ نِكَاحَ
u'قَبِلَ نِكَاحٌ':Predicate, #6: 6	قَبِلَ النِّكَاحَ
u'قَبِلَ هِبَةٌ':Predicate, #6: 6	قَبِلَ النِّكَاحَ
u'قَبِلَ هَدِيٌّ':Predicate, #3: 3	قَبِلَ الْهِبَةَ
u'قَبِلَ هَدِيٌّ':Predicate, #1: 1	قَبِلَ هَدِيَّةَ
u'قَبِلَ هَدِيَّةٌ':Predicate, #3: 3	أَقْبَلَ هَدِيَّةً
u'قَبَّلَ واحد':Predicate, #1: 1	قَبِلَ هَدِيَّةَ
u'قَبَّلَ وَاحِدٌ':Predicate, #1: 1	قَبَّلَ وَاحِدَةً
u'قَبِلَ وَارِثٌ':Subject, #1: 1	قَبَّلَ وَاحِدَةً
u'قَبِلَ وَارِثٌ':Subject, #1: 1	قَبِلَ الْوَارِثُ
u'قَبِلَ وَدِيعٌ':Predicate, #2: 2	قَبِلَ وَارِثُهُ
u'قَبِلَ وَدِيعَةٌ':Predicate, #3: 3	قَبِلَ الْوَدِيعَةَ
u'قَبِلَ وِصَايَةٌ':Predicate, #3: 3	قَبِلَ الْوَدِيعَةَ
u'قَبِلَ وَصِيٌّ':Predicate, #1: 1	قَبِلَ الْوِصَايَةَ
u'قَبِلَ وَصِيٌّ':Subject, #8: 8	قَبِلَ الْوَصِيَّةَ
u'قَبِلَ وَصِيَّةٌ':Predicate, #5: 5	قَبِلَ الْوَصِيُّ
u'قَبِلَ وَقْفٌ':Predicate, #8: 8	قَبِلَ الْوَصِيَّةَ
u'قَبِلَ وَكِيلٌ':Subject, #2: 2	قَبِلَ الْوَقْفَ
u'قَبِلَ وَلاَءٌ':Predicate, #2: 2	قَبِلَ الْوَكِيلُ
u'قَبِلَ ولد':Subject, #1: 1	قَبِلَ الْوَلَاءَ
u'قَبِلَ وَلَدٌ':Subject, #2: 2	قَبِلَ وَلَدُ
u'قَبِلَ وَلِيٌّ':Subject, #2: 2	قَبِلَ وَلَدُ
u'قَبَّلَ يَدٌ':Predicate, #2: 2	قَبِلَ وَلِيُّهُ
u'قَبِلَ يَوْمٌ':Predicate, #6: 6	قَبَّلَ يَدَ
u'قُبُورٌ أقارب':Added, #1: 1	أَقْبَلَ يَوْمَ
u'قُبُورٌ أقارب':Added, #1: 1	قُبُورَ أَقَارِبِهِ
u'قُبُورٌ أَكْثَرُ':Added, #1: 1	قُبُورِ أَقَارِبِهِ
u'قُبُورٌ أنبياء':Added, #1: 1	قُبُورَ أَكْثَرِ
u'قُبُورٌ أهْلٌ':Added, #11: 11	قُبُورِ الْأَنْبِيَاءِ
u'قُبُورٌ أهْلٌ':Added, #2: 2	قُبُورُ أَهْلِ
u'قُبُورٌ أَوْلِيَاءُ':Added, #3: 3	قُبُورِ أَهْلِ
u'قُبُورٌ أَوْلِيَاءُ':Added, #1: 1	قُبُورُ الْأَوْلِيَاءِ
u'قُبُورٌ ثَلاثَةٌ':Added, #4: 4	قُبُورِ الْأَوْلِيَاءِ
u'قُبُورٌ جَاهِلِيٌّ':Added, #1: 1	قُبُورُ الثّلَاثَةِ
u'قُبُورٌ جَاهِلِيَّةٌ':Added, #1: 1	قُبُورِ الْجَاهِلِيَّةِ
u'قُبُورٌ سَائِرٌ':Added, #1: 1	قُبُورِ الْجَاهِلِيَّةِ
u'قُبُورٌ شهداء':Added, #2: 2	قُبُورُ سَائِرِ
u'قُبُورٌ شهداء':Added, #1: 1	قُبُورَ الشُّهَدَاءِ
u'قُبُورٌ علماء':Added, #4: 4	قُبُورِ الشُّهَدَاءِ
u'قُبُورٌ علماء':Added, #1: 1	قُبُورَ الْعُلَمَاءِ
u'قُبُورٌ عُلَمَاءُ':Added, #1: 1	قُبُورِ الْعُلَمَاءِ
u'قُبُورٌ عُلَمَاءُ':Added, #1: 1	قُبُورَ الْعُلَمَاءِ
u'قُبُورٌ علماء':Added, #1: 1	قُبُورِ الْعُلَمَاءِ
u'قُبُورٌ عُلَمَاءُ':Added, #1: 1	قُبُورِ عُلَمَاءِ
u'قُبُورٌ غير':Added, #1: 1	قُبُورِ عُلَمَاءِ
u'قُبُورٌ غَيْرٌ':Added, #1: 1	قُبُورِ غَيْرِ
u'قُبُورٌ مَشَايِخُ':Added, #1: 1	قُبُورِ غَيْرِ
u'قَبُولٌ أَبٌ':Added, #2: 2	قُبُورِ الْمَشَايِخِ
u'قَبُولٌ أَبٌ':Added, #1: 1	قَبُولَ الْأَبِ
u'قَبُولٌ أَبٌ':Added, #1: 1	قَبُولُ الْأَبِ
u'قَبُولٌ إِبْطَالٌ':Added, #2: 2	قَبُولِ الْأَبِ
u'قَبُولٌ اِبْنٌ':Added, #1: 1	قَبُولِ الْإِبْطَالِ
u'قَبُولٌ أُجْرَةٌ':Added, #1: 1	قَبُولِ ابْنِ
u'قَبُولٌ أَجَلٌ':Added, #1: 1	قَبُولُ الْأُجْرَةِ
u'قَبُولٌ إِجْمَاعٌ':Added, #1: 1	قَبُولُ الْأَجَلِ
u'قَبُولٌ أَجْنَبِيٌّ':Added, #2: 2	قَبُولِ الْإِجْمَاعِ
u'قَبُولٌ أَجْنَبِيٌّ':Added, #1: 1	قَبُولِ الْأَجْنَبِيِّ
u'قَبُولٌ أَجْوَدُ':Added, #2: 2	قَبُولُ أَجْنَبِيٍّ
u'قَبُولٌ أَحْجارٌ':Added, #2: 2	قَبُولِ الْأَجْوَدِ
u'قَبُولٌ أحَدٌ':Added, #1: 1	قَبُولِ الْأَحْجَارِ
u'قَبُولٌ أحَدٌ':Added, #1: 1	قَبُولَ أَحَدِ
u'قَبُولٌ أحَدٌ':Added, #1: 1	قَبُولُ أَحَدٍ
u'قَبُولٌ أَحْكَامٌ':Added, #1: 1	قَبُولُ أَحَدِ
u'قَبُولٌ أخْبَارٌ':Added, #1: 1	قَبُولِ الْأَحْكَامِ
u'قَبُولٌ أخْبَارٌ':Added, #1: 1	قَبُولَ أَخْبَارِ
u'قَبُولٌ أَخْبَارٌ':Added, #1: 1	قَبُولِ أَخْبَارِ
u'قَبُولٌ أَخْبَارٌ':Added, #1: 1	قَبُولَ أَخْبَارِ
u'قَبُولٌ أخْبَارٌ':Added, #1: 1	قَبُولِ أَخْبَارِ
u'قَبُولٌ أَخْبَارٌ':Added, #1: 1	قَبُولِ الْأَخْبَارِ
u'قَبُولٌ أخْبَارٌ':Added, #1: 1	قَبُولِ الْأَخْبَارِ
u'قَبُولٌ أَخْبَارٌ':Added, #2: 2	قَبُولِ أَخْبَارِهِ
u'قَبُولٌ أَرْبَعُ':Added, #2: 2	قَبُولِ أَخْبَارِهِ
u'قَبُولٌ أرْضٌ':Added, #2: 2	قَبُولِ الْأَرْبَعِ
u'قَبُولٌ إِسْلامٌ':Added, #1: 1	قَبُولِ الْأَرْضِ
u'قَبُولٌ إِسْلامٌ':Added, #1: 1	قَبُولِ إسْلَامِهِ
u'قَبُولٌ أصل':Added, #1: 1	قَبُولُ الْإِسْلَامِ
u'قَبُولٌ أًصْلٌ':Added, #1: 1	قَبُولِ أَصْلِ
u'قَبُولٌ أَصيلٌ':Added, #1: 1	قَبُولِ أَصْلِ
u'قَبُولٌ إِطْلاقٌ':Added, #3: 3	قَبُولُ الْأَصِيلِ
u'قَبُولٌ إِعْتاقٌ':Added, #1: 1	قَبُولَ الْإِطْلَاقِ
u'قَبُولٌ إقالَةٌ':Added, #3: 3	قَبُولُ الْإِعْتَاقِ
u'قَبُولٌ إقْرَارٌ':Added, #1: 1	قَبُولُ الْإِقَالَةِ
u'قَبُولٌ إقْرَارٌ':Added, #1: 1	قَبُولَ إقْرَارِهِ
u'قَبُولٌ إقْرَارٌ':Added, #1: 1	قَبُولُ الْإِقْرَارِ
u'قَبُولٌ إقْرَارٌ':Added, #2: 2	قَبُولِ إقْرَارِ
u'قَبُولٌ إقْرَارٌ':Added, #2: 2	قَبُولِ الْإِقْرَارِ
u'قَبُولٌ أقَلُّ':Added, #7: 7	قَبُولِ إقْرَارِهِ
u'قَبُولٌ ألف':Added, #1: 1	قَبُولُ الْأَقَلِّ
u'قَبُولٌ ألْفٌ':Added, #1: 1	قَبُولِ الْأَلْفِ
u'قَبُولٌ أَلْفٌ':Added, #1: 1	قَبُولِ الْأَلْفِ
u'قَبُولٌ الْمَرْأَةُ':Added, #1: 1	قَبُولِ الْأَلْفِ
u'قَبُولٌ الْمَرْأَةُ':Added, #1: 1	قَبُولَ الْمَرْأَةِ
u'قَبُولٌ الْمَرْأَةُ':Added, #2: 2	قَبُولُ الْمَرْأَةِ
u'قَبُولٌ إلْهَامٌ':Added, #6: 6	قَبُولِ الْمَرْأَةِ
u'قَبُولٌ أمَةٌ':Added, #1: 1	قَبُولِ الْإِلْهَامَيْنِ
u'قَبُولٌ أُمَّةٌ':Added, #1: 1	قَبُولُ الْأَمَةِ
u'قَبُولٌ أَمْرٌ':Added, #1: 1	قَبُولِ الْأُمَّةِ
u'قَبُولٌ أَوَّلُ':Added, #1: 1	قَبُولِ الْأَمْرِ
u'قَبُولٌ أَوَّلُ':Added, #1: 1	قَبُولُ الْأَوَّلِ
u'قَبُولٌ أَوَّلُ':Added, #1: 1	قَبُولِ الْأَوَّلِ
u'قَبُولٌ أَوَّلُ':Added, #1: 1	قَبُولَ الْأَوَّلَيْنِ
u'قَبُولٌ إِيجَابٌ':Added, #2: 2	قَبُولَ الْأَوَّلِ
u'قَبُولٌ إيمَانٌ':Added, #1: 1	قَبُولِ إيجَابٍ
u'قَبُولٌ إيمَانٌ':Added, #1: 1	قَبُولُ الْإِيمَانِ
u'قَبُولٌ أَيْمَانٌ':Added, #1: 1	قَبُولِ الْإِيمَانِ
u'قَبُولٌ بَائِعٌ':Added, #1: 1	قَبُولِ أَيْمَانِ
u'قَبُولٌ بَدَلٌ':Added, #1: 1	قَبُولُ الْبَائِعِ
u'قَبُولٌ بُسْرٌ':Added, #1: 1	قَبُولُ بَدَلِ
u'قَبُولٌ بَطْنٌ':Added, #1: 1	قَبُولُ بُسْرٍ
u'قَبُولٌ بَطْنٌ':Added, #1: 1	قَبُولَ الْبَطْنِ
u'قَبُولٌ بَعْضٌ':Added, #1: 1	قَبُولُ الْبَطْنِ
u'قَبُولٌ بَعْضٌ':Added, #1: 1	قَبُولِ الْبَعْضِ
u'قَبُولٌ بَيَانٌ':Added, #2: 2	قَبُولُ بَعْضِ
u'قَبُولٌ بَيْعٌ':Added, #1: 1	قَبُولِ الْبَيَانِ
u'قَبُولٌ بَيْعٌ':Added, #1: 1	قَبُولُ الْبَيْعِ
u'قَبُولٌ بَيِّنَةٌ':Added, #4: 4	قَبُولِ الْبَيْعِ
u'قَبُولٌ بَيِّنَةٌ':Added, #12: 12	قَبُولِ الْبَيِّنَةِ
u'قَبُولٌ بَيِّنَةٌ':Added, #1: 1	قَبُولَ بَيِّنَتِهِ
u'قَبُولٌ بَيِّنَةٌ':Added, #1: 1	قَبُولُ بَيِّنَتِهِ
u'قَبُولٌ بَيِّنَةٌ':Added, #2: 2	قَبُولُ بَيِّنَةِ
u'قَبُولٌ بَيِّنَةٌ':Added, #5: 5	قَبُولُ الْبَيِّنَةِ
u'قَبُولٌ بَيِّنَةٌ':Added, #8: 8	قَبُولَ الْبَيِّنَةِ
u'قَبُولٌ تَأْدِيبٌ':Added, #9: 9	قَبُولِ بَيِّنَةِ
u'قَبُولٌ تَجْرِيح':Added, #1: 1	قَبُولُ التَّأْدِيبِ
u'قَبُولٌ تَحْكِيمٌ':Added, #1: 1	قَبُولِ التَّجْرِيحِ
u'قَبُولٌ تَخْصِيصٌ':Added, #1: 1	قَبُولِ التَّحْكِيمِ
u'قَبُولٌ تَخْيِيرٌ':Added, #1: 1	قَبُولُ التَّخْصِيصِ
u'قَبُولٌ تَرْجِيحٌ':Added, #1: 1	قَبُولُ التَّخْيِيرِ
u'قَبُولٌ تَرْجِيحٌ':Added, #1: 1	قَبُولُ التَّرْجِيحِ
u'قَبُولٌ تَزْكِيَةٌ':Added, #3: 3	قَبُولِ التَّرْجِيحِ
u'قَبُولٌ تَزْكِيَةٌ':Added, #1: 1	قَبُولِ التَّزْكِيَةِ
u'قَبُولٌ تَزْكِيَةٌ':Added, #1: 1	قَبُولِ تَزْكِيَةِ
u'قَبُولٌ تَزَوُّجٌ':Added, #2: 2	قَبُولُ تَزْكِيَةِ
u'قَبُولٌ تَعْدِيلٌ':Added, #1: 1	قَبُولُ التَّزَوُّجِ
u'قَبُولٌ تَعَلُّمٌ':Added, #1: 1	قَبُولُ تَعْدِيلِ
u'قَبُولٌ تَعْلِيقٌ':Added, #1: 1	قَبُولِ التَّعَلُّمِ
u'قَبُولٌ تَعْلِيلٌ':Added, #1: 1	قَبُولِ التَّعْلِيقِ
u'قَبُولٌ تَفْسِيرٌ':Added, #1: 1	قَبُولِ التَّعْلِيلِ
u'قَبُولٌ تَفْسِيرٌ':Added, #1: 1	قَبُولِ التَّفْسِيرِ
u'قَبُولٌ تَفْسِيرٌ':Added, #1: 1	قَبُولِ تَفْسِيرِهِ
u'قَبُولٌ تَفْسِيرٌ':Added, #3: 3	قَبُولُ التَّفْسِيرِ
u'قَبُولٌ تَقْليدٌ':Added, #3: 3	قَبُولُ تَفْسِيرِهِ
u'قَبُولٌ تَقْليد':Added, #1: 1	قَبُولُ تَقْلِيدِ
u'قَبُولٌ تَهْنِئَةٌ':Added, #1: 1	قَبُولُ تَقْلِيدِ
u'قَبُولٌ تَهْنِئَةٌ':Added, #1: 1	قَبُولِ تَهْنِئَةٍ
u'قَبُولٌ تَهْنِئَةٌ':Added, #3: 3	قَبُولِ التَّهْنِئَةِ
u'قَبُولٌ تَوْبَةٌ':Added, #4: 4	قَبُولَ التَّهْنِئَةِ
u'قَبُولٌ تَوْبَةٌ':Added, #12: 12	قَبُولِ تَوْبَةِ
u'قَبُولٌ تَوْبَةٌ':Added, #1: 1	قَبُولَ تَوْبَةِ
u'قَبُولٌ تَوْبَةٌ':Added, #3: 3	قَبُولَ التَّوْبَةِ
u'قَبُولٌ تَوْبَةٌ':Added, #3: 3	قَبُولُ التَّوْبَةِ
u'قَبُولٌ تَوْبَةٌ':Added, #3: 3	قَبُولَ تَوْبَتِهِ
u'قَبُولٌ تَوْبَةٌ':Added, #4: 4	قَبُولُ تَوْبَتِهِ
u'قَبُولٌ تَوْبَةٌ':Added, #5: 5	قَبُولِ التَّوْبَةِ
u'قَبُولٌ تَوْقِيعٌ':Added, #6: 6	قَبُولِ تَوْبَتِهِ
u'قَبُولٌ تَوَلُّدٌ':Added, #1: 1	قَبُولُ تَوْقِيعَاتِهِ
u'قَبُولٌ تَوْلِيَةٌ':Added, #1: 1	قَبُولِ تَوَلُّدِ
u'قَبُولٌ ثَمَنٌ':Added, #1: 1	قَبُولُ تَوْلِيَةِ
u'قَبُولٌ ثَمَنٌ':Added, #1: 1	قَبُولُ ثَمَنِ
u'قَبُولٌ ثَوابٌ':Added, #1: 1	قَبُولَ ثَمَنِهِ
u'قَبُولٌ ثَوابٌ':Added, #1: 1	قَبُولُ الثَّوَابِ
u'قَبُولٌ جَديدٌ':Added, #1: 1	قَبُولِ الثَّوَابِ
u'قَبُولٌ جِزْيَةٌ':Added, #1: 1	قَبُولٍ جَدِيدٍ
u'قَبُولٌ جِزْيَةٌ':Added, #1: 1	قَبُولِ جِزْيَةٍ
u'قَبُولٌ جِزْيَةٌ':Added, #3: 3	قَبُولَ الْجِزْيَةِ
u'قَبُولٌ جلد':Added, #7: 7	قَبُولِ الْجِزْيَةِ
u'قَبُولٌ جِلْدٌ':Added, #1: 1	قَبُولُ الْجِلْدِ
u'قَبُولٌ جلد':Added, #1: 1	قَبُولُ الْجِلْدِ
u'قَبُولٌ جِلْدٌ':Added, #1: 1	قَبُولُ جِلْدِ
u'قَبُولٌ جلد':Added, #1: 1	قَبُولُ جِلْدِ
u'قَبُولٌ جِلْدٌ':Added, #1: 1	قَبُولُ جِلْدِهِ
u'قَبُولٌ جَمِيع':Added, #1: 1	قَبُولُ جِلْدِهِ
u'قَبُولٌ جِنْسٌ':Added, #2: 2	قَبُولُ الْجَمِيعِ
u'قَبُولٌ جَوَابٌ':Added, #1: 1	قَبُولُ جِنْسٍ
u'قَبُولٌ حاضِرٌ':Added, #1: 1	قَبُولِ الْجَوَابِ
u'قَبُولٌ حاضِرٌ':Added, #1: 1	قَبُولُ الْحَاضِرِ
u'قَبُولٌ حَدَثٌ':Added, #1: 1	قَبُولِ الْحَاضِرِ
u'قَبُولٌ حَديثٌ':Added, #1: 1	قَبُولِ الْحَدَثِ
u'قَبُولٌ حَديثٌ':Added, #1: 1	قَبُولِ حَدِيثِ
u'قَبُولٌ حَسَنٌ':Added, #2: 2	قَبُولِ الْحَدِيثِ
u'قَبُولٌ حَسَنَةٌ':Added, #2: 2	قَبُولَ حَسَنَاتِهِ
u'قَبُولٌ حِصَّةٌ':Added, #2: 2	قَبُولَ حَسَنَاتِهِ
u'قَبُولٌ حَقٌّ':Added, #1: 1	قَبُولِ حِصَّتِهِ
u'قَبُولٌ حَقٌّ':Added, #1: 1	قَبُولُ الْحَقِّ
u'قَبُولٌ حُكْمٌ':Added, #3: 3	قَبُولِ الْحَقِّ
u'قَبُولٌ حُكْمٌ':Added, #1: 1	قَبُولَ حُكْمِهِ
u'قَبُولٌ حَوَالَةٌ':Added, #5: 5	قَبُولِ حُكْمِ
u'قَبُولٌ حَوَالَةٌ':Added, #10: 10	قَبُولُ الْحَوَالَةِ
u'قَبُولٌ حَوَالَةٌ':Added, #1: 1	قَبُولِ حَوَالَةِ
u'قَبُولٌ حَوَالَةٌ':Added, #2: 2	قَبُولَ الْحَوَالَةِ
u'قَبُولٌ خَبَرٌ':Added, #2: 2	قَبُولِ الْحَوَالَةِ
u'قَبُولٌ خَبَر':Added, #12: 12	قَبُولُ خَبَرِهِ
u'قَبُولٌ خَبَرٌ':Added, #12: 12	قَبُولُ خَبَرِهِ
u'قَبُولٌ خَبَر':Added, #13: 13	قَبُولِ خَبَرِ
u'قَبُولٌ خَبَرٌ':Added, #13: 13	قَبُولِ خَبَرِ
u'قَبُولٌ خَبَرٌ':Added, #1: 1	قَبُولُ خَبَرٍ
u'قَبُولٌ خَبَر':Added, #1: 1	قَبُولُ خَبَرِ
u'قَبُولٌ خَبَر':Added, #1: 1	قَبُولُ خَبَرٍ
u'قَبُولٌ خَبَرٌ':Added, #1: 1	قَبُولُ خَبَرِ
u'قَبُولٌ خَبَر':Added, #1: 1	قَبُولَ خَبَرِهِ
u'قَبُولٌ خَبَرٌ':Added, #1: 1	قَبُولَ خَبَرِهِ
u'قَبُولٌ خَبَر':Added, #2: 2	قَبُولُ الْخَبَرِ
u'قَبُولٌ خَبَرٌ':Added, #2: 2	قَبُولُ الْخَبَرِ
u'قَبُولٌ خَبَر':Added, #3: 3	قَبُولِ الْخَبَرِ
u'قَبُولٌ خَبَرٌ':Added, #3: 3	قَبُولِ الْخَبَرِ
u'قَبُولٌ خَبَر':Added, #3: 3	قَبُولَ خَبَرِ
u'قَبُولٌ خَبَرٌ':Added, #3: 3	قَبُولَ خَبَرِ
u'قَبُولٌ خَبَر':Added, #4: 4	قَبُولِ خَبَرِهِ
u'قَبُولٌ خدمة':Added, #4: 4	قَبُولِ خَبَرِهِ
u'قَبُولٌ خِدْمَةٌ':Added, #3: 3	قَبُولُ خِدْمَتِهِ
u'قَبُولٌ خَرْسَاء':Added, #3: 3	قَبُولُ خِدْمَتِهِ
u'قَبُولٌ خَصِيٌّ':Added, #1: 1	قَبُولَ الْخَرْسَاءِ
u'قَبُولٌ خِطَابٌ':Added, #1: 1	قَبُولِ خَصِيٍّ
u'قَبُولٌ خَمْرٌ':Added, #1: 1	قَبُولِ خِطَابِ
u'قَبُولٌ خَمْرٌ':Added, #1: 1	قَبُولَ الْخَمْرِ
u'قَبُولٌ خوارج':Added, #3: 3	قَبُولِ الْخَمْرِ
u'قَبُولٌ خَوَارِجُ':Added, #2: 2	قَبُولَ الْخَوَارِجِ
u'قَبُولٌ خيار':Added, #2: 2	قَبُولَ الْخَوَارِجِ
u'قَبُولٌ خِيَارٌ':Added, #1: 1	قَبُولِ الْخِيَارِ
u'قَبُولٌ خَيْرٌ':Added, #1: 1	قَبُولِ الْخِيَارِ
u'قَبُولٌ دَاعِي':Added, #1: 1	قَبُولِ الْخَيْرِ
u'قَبُولٌ دَلالَةٌ':Added, #1: 1	قَبُولِ الدَّاعِيَةِ
u'قَبُولٌ دِيَةٌ':Added, #1: 1	قَبُولُ دَلَالَةِ
u'قَبُولٌ دَيْنٌ':Added, #1: 1	قَبُولَ الدِّيَةِ
u'قَبُولٌ دِينٌ':Added, #1: 1	قَبُولِ الدَّيْنِ
u'قَبُولٌ دَيْنٌ':Added, #1: 1	قَبُولِ دِينٍ
u'قَبُولٌ دَيْنٌ':Added, #2: 2	قَبُولُ الدَّيْنِ
u'قَبُولٌ ذِمَّةٌ':Added, #2: 2	قَبُولِ دَيْنِ
u'قَبُولٌ ذَنَبٌ':Added, #1: 1	قَبُولِ الذِّمَّةِ
u'قَبُولٌ رَأْسٌ':Added, #2: 2	قَبُولُ الذَّنَبِ
u'قَبُولٌ رَأْسٌ':Added, #1: 1	قَبُولُ رَأْسِ
u'قَبُولٌ رَاعِي':Added, #2: 2	قَبُولُ الرَّأْسِ
u'قَبُولٌ رَبُّ':Added, #1: 1	قَبُولُ الرَّاعِيَةِ
u'قَبُولٌ رَجُلٌ':Added, #1: 1	قَبُولِ رَبِّ
u'قَبُولٌ رَجُلٌ':Added, #1: 1	قَبُولَ الرَّجُلِ
u'قَبُولٌ رَجُلٌ':Added, #1: 1	قَبُولِ الرَّجُلَيْنِ
u'قَبُولٌ رَجُلٌ':Added, #1: 1	قَبُولُ رَجُلٍ
u'قَبُولٌ رُجُوعٌ':Added, #4: 4	قَبُولِ رَجُلٍ
u'قَبُولٌ رُجُوعٌ':Added, #1: 1	قَبُولِ رُجُوعِ
u'قَبُولٌ رُجُوعٌ':Added, #1: 1	قَبُولَ رُجُوعِهِ
u'قَبُولٌ رُجُوعٌ':Added, #1: 1	قَبُولِ رُجُوعِهِ
u'قَبُولٌ رُخْصَةٌ':Added, #2: 2	قَبُولِ الرُّجُوعِ
u'قَبُولٌ رُخْصَةٌ':Added, #1: 1	قَبُولَ الرُّخْصَةِ
u'قَبُولٌ رَدٌّ':Added, #4: 4	قَبُولِ الرُّخْصَةِ
u'قَبُولٌ رَدٌّ':Added, #1: 1	قَبُولُ رَدِّ
u'قَبُولٌ رَدِيءٌ':Added, #1: 1	قَبُولِ رَدِّ
u'قَبُولٌ رَدِيءٌ':Added, #1: 1	قَبُولُ رَدِيءٍ
u'قَبُولٌ رَهْنٌ':Added, #3: 3	قَبُولُ الرَّدِيءِ
u'قَبُولٌ رِواياتٌ':Added, #1: 1	قَبُولِ الرَّهْنِ
u'قَبُولٌ رِوايَةٌ':Added, #1: 1	قَبُولِ رِوَايَاتِ
u'قَبُولٌ رِوايَةٌ':Added, #1: 1	قَبُولَ الرِّوَايَةِ
u'قَبُولٌ رِوايَةٌ':Added, #1: 1	قَبُولِ الرِّوَايَةِ
u'قَبُولٌ رِوايَةٌ':Added, #1: 1	قَبُولَ رِوَايَةِ
u'قَبُولٌ رِوايَةٌ':Added, #2: 2	قَبُولَ رِوَايَتِهِ
u'قَبُولٌ رِوايَةٌ':Added, #4: 4	قَبُولُ رِوَايَةِ
u'قَبُولٌ رِوايَةٌ':Added, #4: 4	قَبُولُ رِوَايَتِهِ
u'قَبُولٌ رِوايَةٌ':Added, #5: 5	قَبُولِ رِوَايَتِهِ
u'قَبُولٌ زائِدٌ':Added, #8: 8	قَبُولِ رِوَايَةِ
u'قَبُولٌ زَكاةٌ':Added, #1: 1	قَبُولِ الزَّائِدِ
u'قَبُولٌ زَكاةٌ':Added, #1: 1	قَبُولِ الزَّكَاةِ
u'قَبُولٌ زَوْجٌ':Added, #1: 1	قَبُولِ زَكَاةٍ
u'قَبُولٌ زَوْجٌ':Added, #1: 1	قَبُولَ الزَّوْجِ
u'قَبُولٌ زِيادَةٌ':Added, #7: 7	قَبُولِ الزَّوْجِ
u'قَبُولٌ زِيادَةٌ':Added, #1: 1	قَبُولَ الزِّيَادَةِ
u'قَبُولٌ زِيادَةٌ':Added, #1: 1	قَبُولِ زِيَادَةِ
u'قَبُولٌ زِيادَةٌ':Added, #4: 4	قَبُولُ الزِّيَادَةِ
u'قَبُولٌ زَيْدٌ':Added, #8: 8	قَبُولِ الزِّيَادَةِ
u'قَبُولٌ سترة':Added, #1: 1	قَبُولُ زَيْدٍ
u'قَبُولٌ سُتْرَةٌ':Added, #1: 1	قَبُولُ السُّتْرَةِ
u'قَبُولٌ سِعَايَةٌ':Added, #1: 1	قَبُولُ السُّتْرَةِ
u'قَبُولٌ سَفَرْجَلٌ':Added, #1: 1	قَبُولَ السِّعَايَةِ
u'قَبُولٌ سَفِيرٌ':Added, #1: 1	قَبُولِ السَّفَرْجَلَةِ
u'قَبُولٌ سَلَمٌ':Added, #1: 1	قَبُولِ سَفِيرٍ
u'قَبُولٌ سَلَمٌ':Added, #2: 2	قَبُولَ السَّلَمِ
u'قَبُولٌ سَلِيمٌ':Added, #3: 3	قَبُولِ السَّلَمِ
u'قَبُولٌ سَيِّدٌ':Added, #1: 1	قَبُولِ السَّلِيمِ
u'قَبُولٌ شَاذَّ':Added, #1: 1	قَبُولُ السَّيِّدِ
u'قَبُولٌ شَاذّ':Added, #1: 1	قَبُولِ الشَّاذِّ
u'قَبُولٌ شافِعِيّ':Added, #1: 1	قَبُولِ الشَّاذِّ
u'قَبُولٌ شَاهِدٌ':Added, #1: 1	قَبُولِ الشَّافِعِيِّ
u'قَبُولٌ شَاهِدٌ':Added, #1: 1	قَبُولَ شَاهِدٍ
u'قَبُولٌ شُبْهَةٌ':Added, #1: 1	قَبُولِ شَاهِدٍ
u'قَبُولٌ شَخْصٌ':Added, #1: 1	قَبُولِ الشُّبْهَةِ
u'قَبُولٌ شِرَاءٌ':Added, #1: 1	قَبُولُ الشَّخْصِ
u'قَبُولٌ شَرِيكٌ':Added, #1: 1	قَبُولِ الشِّرَاءِ
u'قَبُولٌ شَفَاعَةٌ':Added, #1: 1	قَبُولَ شَرِيكِهِ
u'قَبُولٌ شَهَادَةٌ':Added, #1: 1	قَبُولِ شَفَاعَتِهِ
u'قَبُولٌ شَهَادَةٌ':Added, #11: 11	قَبُولُ الشَّهَادَةِ
u'قَبُولٌ شَهَادَةٌ':Added, #13: 13	قَبُولَ شَهَادَةِ
u'قَبُولٌ شَهَادَةٌ':Added, #14: 14	قَبُولُ شَهَادَةِ
u'قَبُولٌ شَهَادَةٌ':Added, #17: 17	قَبُولُ شَهَادَتِهِ
u'قَبُولٌ شَهَادَةٌ':Added, #1: 1	قَبُولَ شَهَادَتِهِ
u'قَبُولٌ شَهَادَةٌ':Added, #26: 26	قَبُولِ شَهَادَتِهِ
u'قَبُولٌ شَهَادَةٌ':Added, #37: 37	قَبُولَ الشَّهَادَةِ
u'قَبُولٌ شَهَادَةٌ':Added, #42: 42	قَبُولِ شَهَادَةِ
u'قَبُولٌ صَاحِبٌ':Added, #67: 67	قَبُولِ الشَّهَادَةِ
u'قَبُولٌ صَاحِبٌ':Added, #1: 1	قَبُولِ صَاحِبِ
u'قَبُولٌ صَبْغٌ':Added, #1: 1	قَبُولِ صَاحِبِهِ
u'قَبُولٌ صَبِيٌّ':Added, #1: 1	قَبُولُ الصَّبْغِ
u'قَبُولٌ صَحَابِيٌّ':Added, #1: 1	قَبُولُ الصَّبِيِّ
u'قَبُولٌ صداق':Added, #1: 1	قَبُولِ الصَّحَابِيِّ
u'قَبُولٌ صَدَاقٌ':Added, #1: 1	قَبُولِ الصَّدَاقِ
u'قَبُولٌ صدق':Added, #1: 1	قَبُولِ الصَّدَاقِ
u'قَبُولٌ صِدْقٌ':Added, #1: 1	قَبُولِ الصِّدْقِ
u'قَبُولٌ صدقة':Added, #1: 1	قَبُولِ الصِّدْقِ
u'قَبُولٌ صَدَقَةٌ':Added, #1: 1	قَبُولَ الصَّدَقَةِ
u'قَبُولٌ صدقة':Added, #1: 1	قَبُولَ الصَّدَقَةِ
u'قَبُولٌ صدقة':Added, #1: 1	قَبُولَ صَدَقَةٍ
u'قَبُولٌ صَدَقَةٌ':Added, #1: 1	قَبُولِ صَدَقَةِ
u'قَبُولٌ صَدَقَةٌ':Added, #1: 1	قَبُولَ صَدَقَةٍ
u'قَبُولٌ صدقة':Added, #1: 1	قَبُولِ صَدَقَةِ
u'قَبُولٌ صَدَقَةٌ':Added, #5: 5	قَبُولِ الصَّدَقَةِ
u'قَبُولٌ صَرْفٌ':Added, #5: 5	قَبُولِ الصَّدَقَةِ
u'قَبُولٌ صَرْف':Added, #1: 1	قَبُولُ الصَّرْفِ
u'قَبُولٌ صِفَةٌ':Added, #1: 1	قَبُولُ الصَّرْفِ
u'قَبُولٌ صَلاَةٌ':Added, #2: 2	قَبُولُ صِفَتِهِ
u'قَبُولٌ صلح':Added, #1: 1	قَبُولِ الصَّلَاةِ
u'قَبُولٌ صُلْحٌ':Added, #1: 1	قَبُولِ الصُّلْحِ
u'قَبُولٌ صلح':Added, #1: 1	قَبُولِ الصُّلْحِ
u'قَبُولٌ صُلْحٌ':Added, #2: 2	قَبُولُ الصُّلْحِ
u'قَبُولٌ صَوْمٌ':Added, #2: 2	قَبُولُ الصُّلْحِ
u'قَبُولٌ صَوْمٌ':Added, #1: 1	قَبُولُ الصَّوْمِ
u'قَبُولٌ طَاعَةٌ':Added, #1: 1	قَبُولِ صَوْمٍ
u'قَبُولٌ طَالِبٌ':Added, #1: 1	قَبُولِ الطَّاعَةِ
u'قَبُولٌ طَالِبٌ':Added, #1: 1	قَبُولَ الطَّالِبِ
u'قَبُولٌ طَالِبٌ':Added, #2: 2	قَبُولُ الطَّالِبِ
u'قَبُولٌ طَبِيعَةٌ':Added, #5: 5	قَبُولِ الطَّالِبِ
u'قَبُولٌ عارِيَّةٌ':Added, #1: 1	قَبُولِ الطَّبِيعَةِ
u'قَبُولٌ عارِيَّةٌ':Added, #1: 1	قَبُولُ عَارِيَّةٍ
u'قَبُولٌ عَامِلٌ':Added, #1: 1	قَبُولُ عَارِيَّتِهِ
u'قَبُولٌ عَبْدٌ':Added, #1: 1	قَبُولِ الْعَامِلِ
u'قَبُولٌ عَبْدٌ':Added, #15: 15	قَبُولِ الْعَبْدِ
u'قَبُولٌ عَبْدٌ':Added, #1: 1	قَبُولِ عَبْدٍ
u'قَبُولٌ عَبْدٌ':Added, #3: 3	قَبُولَ الْعَبْدِ
u'قَبُولٌ عَبِيدٌ':Added, #4: 4	قَبُولُ الْعَبْدِ
u'قَبُولٌ عتاق':Added, #1: 1	قَبُولِ عَبِيدٍ
u'قَبُولٌ عتق':Added, #1: 1	قَبُولِ الْعَتَاقِ
u'قَبُولٌ عتق':Added, #1: 1	قَبُولَ الْعِتْقِ
u'قَبُولٌ عِتْقٌ':Added, #1: 1	قَبُولِ الْعِتْقِ
u'قَبُولٌ عِتْقٌ':Added, #1: 1	قَبُولَ الْعِتْقِ
u'قَبُولٌ عَتِيقٌ':Added, #1: 1	قَبُولِ الْعِتْقِ
u'قَبُولٌ عَدْلٌ':Added, #1: 1	قَبُولُ الْعَتِيقِ
u'قَبُولٌ عُذْرٌ':Added, #1: 1	قَبُولَ الْعَدْلِ
u'قَبُولٌ عَطَاءٌ':Added, #1: 1	قَبُولِ عُذْرِ
u'قَبُولٌ عَطِيَّةٌ':Added, #2: 2	قَبُولُ الْعَطَاءِ
u'قَبُولٌ عَقْدٌ':Added, #2: 2	قَبُولِ الْعَطِيَّةِ
u'قَبُولٌ عَقْدٌ':Added, #1: 1	قَبُولُ عَقْدِ
u'قَبُولٌ عَقْدٌ':Added, #1: 1	قَبُولِ عَقْدٍ
u'قَبُولٌ عَقْدٌ':Added, #1: 1	قَبُولِ عَقْدِ
u'قَبُولٌ عَقْدٌ':Added, #1: 1	قَبُولُ عَقْدِهِ
u'قَبُولٌ عَقْدٌ':Added, #2: 2	قَبُولُ الْعَقْدِ
u'قَبُولٌ عَقْدٌ':Added, #5: 5	قَبُولَ الْعَقْدِ
u'قَبُولٌ عُمُرٌ':Added, #5: 5	قَبُولِ الْعَقْدِ
u'قَبُولٌ عَمَلٌ':Added, #1: 1	قَبُولِ الْعُمُرِ
u'قَبُولٌ عِوَضٌ':Added, #2: 2	قَبُولِ الْعَمَلِ
u'قَبُولٌ عِوَضٌ':Added, #1: 1	قَبُولُ الْعِوَضِ
u'قَبُولٌ عِوَضٌ':Added, #1: 1	قَبُولِ عِوَضٍ
u'قَبُولٌ عِوَضٌ':Added, #2: 2	قَبُولَ الْعِوَضِ
u'قَبُولٌ عَيْبٌ':Added, #2: 2	قَبُولِ الْعِوَضِ
u'قَبُولٌ عين':Added, #1: 1	قَبُولِ الْعَيْبِ
u'قَبُولٌ عين':Added, #1: 1	قَبُولُ الْعَيْنِ
u'قَبُولٌ عَيْنٌ':Added, #1: 1	قَبُولِ الْعَيْنِ
u'قَبُولٌ عَيْنٌ':Added, #1: 1	قَبُولُ الْعَيْنِ
u'قَبُولٌ عَيْن':Added, #1: 1	قَبُولِ الْعَيْنِ
u'قَبُولٌ عَيْن':Added, #1: 1	قَبُولُ الْعَيْنِ
u'قَبُولٌ غَائِبٌ':Added, #1: 1	قَبُولِ الْعَيْنِ
u'قَبُولٌ غَائِبٌ':Added, #1: 1	قَبُولَ الْغَائِبِ
u'قَبُولٌ غَرِيمٌ':Added, #2: 2	قَبُولِ الْغَائِبِ
u'قَبُولٌ غير':Added, #1: 1	قَبُولِ غَرِيمِهِ
u'قَبُولٌ غَيْرٌ':Added, #1: 1	قَبُولُ الْغَيْرِ
u'قَبُولٌ غير':Added, #1: 1	قَبُولُ الْغَيْرِ
u'قَبُولٌ غير':Added, #1: 1	قَبُولَ غَيْرِ
u'قَبُولٌ غَيْرٌ':Added, #1: 1	قَبُولُ غَيْرِ
u'قَبُولٌ غَيْرٌ':Added, #1: 1	قَبُولَ غَيْرِ
u'قَبُولٌ غير':Added, #1: 1	قَبُولُ غَيْرِ
u'قَبُولٌ غَيْرٌ':Added, #2: 2	قَبُولِ غَيْرِ
u'قَبُولٌ غير':Added, #2: 2	قَبُولِ غَيْرِ
u'قَبُولٌ غَيْرٌ':Added, #2: 2	قَبُولِ غَيْرِهِ
u'قَبُولٌ فَاسِقٌ':Added, #2: 2	قَبُولِ غَيْرِهِ
u'قَبُولٌ فِدَاءٌ':Added, #1: 1	قَبُولَ الْفَاسِقِ
u'قَبُولٌ فَرْعٌ':Added, #1: 1	قَبُولُ الْفِدَاءِ
u'قَبُولٌ فرق':Added, #1: 1	قَبُولِ الْفَرْعِ
u'قَبُولٌ فَرْقٌ':Added, #1: 1	قَبُولِ الْفَرْقِ
u'قَبُولٌ فُرُوقٌ':Added, #1: 1	قَبُولِ الْفَرْقِ
u'قَبُولٌ فَسْخٌ':Added, #1: 1	قَبُولُ فُرُوقٍ
u'قَبُولٌ فِعْلٌ':Added, #4: 4	قَبُولِ الْفَسْخِ
u'قَبُولٌ فلان':Added, #1: 1	قَبُولِ الْفِعْلِ
u'قَبُولٌ قَابِلٌ':Added, #1: 1	قَبُولِ الشَّافِعِيِّ
u'قَبُولٌ قَبْضٌ':Added, #1: 1	قَبُولِ قَابِلٍ
u'قَبُولٌ قَتَلَةٌ':Added, #1: 1	قَبُولِ قَبْضِ
u'قَبُولٌ قَدْرٌ':Added, #1: 1	قَبُولِ قَتَلَةِ
u'قَبُولٌ قَرْضٌ':Added, #1: 1	قَبُولُ قَدْرِ
u'قَبُولٌ قِسْمٌ':Added, #1: 1	قَبُولُ قَرْضِ
u'قَبُولٌ قسمة':Added, #1: 1	قَبُولُ الْقِسْمِ
u'قَبُولٌ قِسْمَةٌ':Added, #3: 3	قَبُولِ الْقِسْمَةِ
u'قَبُولٌ قَضَاءٌ':Added, #3: 3	قَبُولِ الْقِسْمَةِ
u'قَبُولٌ قول':Added, #1: 1	قَبُولُ قَضَاءِ
u'قَبُولٌ قَوْلٌ':Added, #16: 16	قَبُولَ قَوْلِهِ
u'قَبُولٌ قول':Added, #16: 16	قَبُولَ قَوْلِهِ
u'قَبُولٌ قول':Added, #1: 1	قَبُولُ الْقَوْلِ
u'قَبُولٌ قَوْلٌ':Added, #1: 1	قَبُولِ الْقَوْلِ
u'قَبُولٌ قَوْلٌ':Added, #1: 1	قَبُولُ الْقَوْلِ
u'قَبُولٌ قَوْلٌ':Added, #1: 1	قَبُولِ الْقَوْلِ
u'قَبُولٌ قول':Added, #1: 1	قَبُولَ قَوْلٍ
u'قَبُولٌ قَوْلٌ':Added, #20: 20	قَبُولُ قَوْلِ
u'قَبُولٌ قول':Added, #20: 20	قَبُولُ قَوْلِ
u'قَبُولٌ قَوْلٌ':Added, #24: 24	قَبُولِ قَوْلِ
u'قَبُولٌ قول':Added, #24: 24	قَبُولِ قَوْلِ
u'قَبُولٌ قَوْلٌ':Added, #37: 37	قَبُولُ قَوْلِهِ
u'قَبُولٌ قول':Added, #37: 37	قَبُولُ قَوْلِهِ
u'قَبُولٌ قَوْلٌ':Added, #46: 46	قَبُولِ قَوْلِهِ
u'قَبُولٌ قول':Added, #46: 46	قَبُولِ قَوْلِهِ
u'قَبُولٌ قَوْلٌ':Added, #8: 8	قَبُولَ قَوْلِ
u'قَبُولٌ قَيِّمٌ':Added, #8: 8	قَبُولَ قَوْلِ
u'قَبُولٌ قَيِّمٌ':Added, #1: 1	قَبُولُ الْقَيِّمِ
u'قَبُولٌ قِيمَةٌ':Added, #1: 1	قَبُولِ قَيِّمِ
u'قَبُولٌ قِيمَةٌ':Added, #11: 11	قَبُولِ الْقِيمَةِ
u'قَبُولٌ قِيمَةٌ':Added, #1: 1	قَبُولُ قِيمَةِ
u'قَبُولٌ كَافِرٌ':Added, #1: 1	قَبُولِ قِيمَتِهِ
u'قَبُولٌ كِتَابٌ':Added, #1: 1	قَبُولَ الْكَافِرِ
u'قَبُولٌ كِتَابٌ':Added, #1: 1	قَبُولُ كِتَابٍ
u'قَبُولٌ كِتاب':Added, #1: 1	قَبُولِ كِتَابِ
u'قَبُولٌ كِتَابٌ':Added, #1: 1	قَبُولُ كِتَابِيَّةٍ
u'قَبُولٌ كِتَابٌ':Added, #2: 2	قَبُولَ الْكِتَابِ
u'قَبُولٌ كِتَابَةٌ':Added, #2: 2	قَبُولِ الْكِتَابِ
u'قَبُولٌ كِتابَة':Added, #1: 1	قَبُولِ الْكِتَابَةِ
u'قَبُولٌ كِتَابَةٌ':Added, #1: 1	قَبُولُ كِتَابِيَّةٍ
u'قَبُولٌ كِتابِيّ':Added, #2: 2	قَبُولُ الْكِتَابَةِ
u'قَبُولٌ كُتُبٌ':Added, #1: 1	قَبُولُ كِتَابِيَّةٍ
u'قَبُولٌ كَفِيلٌ':Added, #1: 1	قَبُولِ كُتُبِ
u'قَبُولٌ كَمَالٌ':Added, #1: 1	قَبُولِ الْكَفِيلِ
u'قَبُولٌ لَحْمٌ':Added, #1: 1	قَبُولِ الْكَمَالِ
u'قَبُولٌ لَفْظٌ':Added, #1: 1	قَبُولِ لَحْمِ
u'قَبُولٌ مَاءٌ':Added, #1: 1	قَبُولِ اللَّفْظِ
u'قَبُولٌ مَالٌ':Added, #3: 3	قَبُولُ الْمَاءِ
u'قَبُولٌ مَالٌ':Added, #1: 1	قَبُولَ الْمَالِ
u'قَبُولٌ مَالٌ':Added, #1: 1	قَبُولِ الْمَالِ
u'قَبُولٌ مَالٌ':Added, #1: 1	قَبُولُ مَالِ
u'قَبُولٌ مَالٌ':Added, #1: 1	قَبُولِ مَالٍ
u'قَبُولٌ مَالٌ':Added, #2: 2	قَبُولُ الْمَالِ
u'قَبُولٌ مَالِكٌ':Added, #2: 2	قَبُولُ مَالِهِ
u'قَبُولٌ مَبِيعٌ':Added, #1: 1	قَبُولُ الْمَالِكِ
u'قَبُولٌ مُتَطَبِّبٌ':Added, #1: 1	قَبُولِ الْمَبِيعِ
u'قَبُولٌ مثل':Added, #1: 1	قَبُولُ الْمُتَطَبِّبِ
u'قَبُولٌ مِثْلٌ':Added, #1: 1	قَبُولَ الْمِثْلِ
u'قَبُولٌ مثل':Added, #1: 1	قَبُولَ الْمِثْلِ
u'قَبُولٌ مِثْلٌ':Added, #1: 1	قَبُولِ مِثْلِهِ
u'قَبُولٌ مثل':Added, #1: 1	قَبُولِ مِثْلِهِ
u'قَبُولٌ مِثْلٌ':Added, #2: 2	قَبُولُ الْمِثْلِ
u'قَبُولٌ مثل':Added, #2: 2	قَبُولُ الْمِثْلِ
u'قَبُولٌ مِثْلٌ':Added, #2: 2	قَبُولِ مِثْلِ
u'قَبُولٌ مثل':Added, #2: 2	قَبُولِ مِثْلِ
u'قَبُولٌ مِثْلٌ':Added, #5: 5	قَبُولَ مِثْلِهِ
u'قَبُولٌ مِثْلِيٌّ':Added, #5: 5	قَبُولَ مِثْلِهِ
u'قَبُولٌ مَجْنُونٌ':Added, #1: 1	قَبُولُ الْمِثْلِيِّ
u'قَبُولٌ مُحْتَاجٌ':Added, #1: 1	قَبُولُ الْمَجْنُونِ
u'قَبُولٌ مُحْتَالٌ':Added, #1: 1	قَبُولُ الْمُحْتَاجِ
u'قَبُولٌ مُحْتَضَرٌ':Added, #2: 2	قَبُولَ الْمُحْتَالِ
u'قَبُولٌ مُحَرَّمٌ':Added, #1: 1	قَبُولِ الْمُحْتَضَرِ
u'قَبُولٌ مَحَلٌّ':Added, #1: 1	قَبُولُ مُحَرَّمٍ
u'قَبُولٌ مَحَلٌّ':Added, #2: 2	قَبُولَ الْمَحَلِّ
u'قَبُولٌ مُخَاطَبٌ':Added, #3: 3	قَبُولِ الْمَحَلِّ
u'قَبُولٌ مُخَاطَبٌ':Added, #1: 1	قَبُولُ الْمُخَاطَبِ
u'قَبُولٌ مُخْتَلِطٌ':Added, #1: 1	قَبُولُ مُخَاطَبٍ
u'قَبُولٌ مَدْيُونٌ':Added, #1: 1	قَبُولِ الْمُخْتَلِطِ
u'قَبُولٌ مراسيل':Added, #1: 1	قَبُولِ الْمَدْيُونِ
u'قَبُولٌ مَرَاسِيلُ':Added, #2: 2	قَبُولِ مَرَاسِيلِ
u'قَبُولٌ مراسيل':Added, #2: 2	قَبُولِ مَرَاسِيلِ
u'قَبُولٌ مَرَاسِيلُ':Added, #3: 3	قَبُولُ الْمَرَاسِيلِ
u'قَبُولٌ مُرْتَهِنٌ':Added, #3: 3	قَبُولُ الْمَرَاسِيلِ
u'قَبُولٌ مُرْسِلٌ':Added, #1: 1	قَبُولَ الْمُرْتَهِنِ
u'قَبُولٌ مُرْسَلٌ':Added, #1: 1	قَبُولَ الْمُرْسِلِ
u'قَبُولٌ مُرْسَلٌ':Added, #1: 1	قَبُولُ مُرْسَلِ
u'قَبُولٌ مُرْسَلٌ':Added, #1: 1	قَبُولِ مُرْسَلِهِ
u'قَبُولٌ مُرْسَلٌ':Added, #2: 2	قَبُولَ الْمُرْسَلِ
u'قَبُولٌ مُرْسَلٌ':Added, #2: 2	قَبُولُ الْمُرْسَلِ
u'قَبُولٌ مُرْسَلٌ':Added, #2: 2	قَبُولِ مُرْسَلِ
u'قَبُولٌ مُرْسَلٌ':Added, #3: 3	قَبُولُ مُرْسَلِهِ
u'قَبُولٌ مُسامَحَة':Added, #7: 7	قَبُولِ الْمُرْسَلِ
u'قَبُولٌ مُسْتَحِقٌّ':Added, #1: 1	قَبُولَ الْمُسَامَحَةِ
u'قَبُولٌ مَسْتُورٌ':Added, #1: 1	قَبُولُ مُسْتَحِقِّهِ
u'قَبُولٌ مَسْتُورٌ':Added, #1: 1	قَبُولَ الْمَسْتُورِ
u'قَبُولٌ مَسْتُورٌ':Added, #1: 1	قَبُولُ الْمَسْتُورِ
u'قَبُولٌ مَسْلَكٌ':Added, #1: 1	قَبُولِ الْمَسْتُورِ
u'قَبُولٌ مُسْنَدٌ':Added, #1: 1	قَبُولِ الْمَسْلَكِ
u'قَبُولٌ مَضْمُومٌ':Added, #1: 1	قَبُولِ الْمُسْنَدِ
u'قَبُولٌ مَعْرُوفٌ':Added, #1: 1	قَبُولِ الْمَضْمُومِ
u'قَبُولٌ مَعِيبٌ':Added, #1: 1	قَبُولُ مَعْرُوفِهِ
u'قَبُولٌ مَعِيبٌ':Added, #1: 1	قَبُولُ الْمَعِيبِ
u'قَبُولٌ مُعَيَّنٌ':Added, #2: 2	قَبُولِ الْمَعِيبِ
u'قَبُولٌ مُفَوَّضٌ':Added, #2: 2	قَبُولُ الْمُعَيَّنِ
u'قَبُولٌ مَقْصُورٌ':Added, #1: 1	قَبُولِ الْمُفَوَّضِ
u'قَبُولٌ مُكَاتَبَةٌ':Added, #1: 1	قَبُولُ الْمَقْصُورِ
u'قَبُولٌ مَكْرُوهٌ':Added, #1: 1	قَبُولِ الْمُكَاتَبَةِ
u'قَبُولٌ مَكْفُولٌ':Added, #1: 1	قَبُولُ الْمَكْرُوهِ
u'قَبُولٌ مَكْفُولٌ':Added, #3: 3	قَبُولِ الْمَكْفُولِ
u'قَبُولٌ مُمَيِّزٌ':Added, #5: 5	قَبُولُ الْمَكْفُولِ
u'قَبُولٌ مُمَيِّزٌ':Added, #2: 2	قَبُولُ الْمُمَيِّزِ
u'قَبُولٌ مُمَيِّزٌ':Added, #2: 2	قَبُولِ الْمُمَيِّزِ
u'قَبُولٌ مُنَاقَشَةٌ':Added, #2: 2	قَبُولُ مُمَيِّزٍ
u'قَبُولٌ مَنْعٌ':Added, #1: 1	قَبُولِ الْمُنَاقَشَةِ
u'قَبُولٌ مَهْرٌ':Added, #1: 1	قَبُولَ الْمَنْعِ
u'قَبُولٌ مَهْرٌ':Added, #1: 1	قَبُولَ الْمَهْرِ
u'قَبُولٌ مُؤَذِّنٌ':Added, #2: 2	قَبُولُ الْمَهْرِ
u'قَبُولٌ مَوْصُولٌ':Added, #1: 1	قَبُولُ الْمُؤَذِّنِ
u'قَبُولٌ مَوْقُوفٌ':Added, #1: 1	قَبُولِ الْمَوْصُولِ
u'قَبُولٌ مَوْقُوفٌ':Added, #1: 1	قَبُولَ الْمَوْقُوفِ
u'قَبُولٌ مَوْقُوفٌ':Added, #1: 1	قَبُولُ الْمَوْقُوفِ
u'قَبُولٌ نَاظِرٌ':Added, #1: 1	قَبُولِ الْمَوْقُوفِ
u'قَبُولٌ نَاكِحٌ':Added, #1: 1	قَبُولُ نَاظِرِهِ
u'قَبُولٌ نذر':Added, #1: 1	قَبُولِ نَاكِحٍ
u'قَبُولٌ نَذْرٌ':Added, #1: 1	قَبُولُ النَّذْرِ
u'قَبُولٌ نِساءٌ':Added, #1: 1	قَبُولُ النَّذْرِ
u'قَبُولٌ نصح':Added, #1: 1	قَبُولُ النِّسَاءِ
u'قَبُولٌ نِصْفٌ':Added, #1: 1	قَبُولِ نُصْحِهِ
u'قَبُولٌ نِصْفٌ':Added, #1: 1	قَبُولَ نِصْفِ
u'قَبُولٌ نِصْفٌ':Added, #2: 2	قَبُولِ نِصْفِ
u'قَبُولٌ نَصِيبٌ':Added, #5: 5	قَبُولُ نِصْفِ
u'قَبُولٌ نَصِيبٌ':Added, #1: 1	قَبُولَ نَصِيبِ
u'قَبُولٌ نَعْلٌ':Added, #3: 3	قَبُولِ نَصِيبِ
u'قَبُولٌ نَفْسٌ':Added, #2: 2	قَبُولِ النَّعْلِ
u'قَبُولٌ نكاح':Added, #1: 1	قَبُولِ النَّفْسِ
u'قَبُولٌ نكاح':Added, #1: 1	قَبُولَ نِكَاحِ
u'قَبُولٌ نِكَاحٌ':Added, #1: 1	قَبُولِ نِكَاحٍ
u'قَبُولٌ نِكَاحٌ':Added, #1: 1	قَبُولَ نِكَاحِ
u'قَبُولٌ نكاح':Added, #1: 1	قَبُولِ نِكَاحٍ
u'قَبُولٌ نِكَاحٌ':Added, #3: 3	قَبُولُ النِّكَاحِ
u'قَبُولٌ نكاح':Added, #3: 3	قَبُولُ النِّكَاحِ
u'قَبُولٌ نِكَاحٌ':Added, #7: 7	قَبُولِ النِّكَاحِ
u'قَبُولٌ نكاح':Added, #7: 7	قَبُولِ النِّكَاحِ
u'قَبُولٌ نِكَاحٌ':Added, #8: 8	قَبُولِ نِكَاحِ
u'قَبُولٌ نِيَابَةٌ':Added, #8: 8	قَبُولِ نِكَاحِ
u'قَبُولٌ نِيَابَةٌ':Added, #1: 1	قَبُولُ النِّيَابَةِ
u'قَبُولٌ هِبَةٌ':Added, #1: 1	قَبُولِ النِّيَابَةِ
u'قَبُولٌ هِبَةٌ':Added, #11: 11	قَبُولِ الْهِبَةِ
u'قَبُولٌ هِبَةٌ':Added, #1: 1	قَبُولُ هِبَةٍ
u'قَبُولٌ هِبَةٌ':Added, #1: 1	قَبُولِ هِبَةِ
u'قَبُولٌ هِبَةٌ':Added, #1: 1	قَبُولِ هِبَتِهِ
u'قَبُولٌ هِبَةٌ':Added, #4: 4	قَبُولُ هِبَةِ
u'قَبُولٌ هَدِيٌّ':Added, #9: 9	قَبُولُ الْهِبَةِ
u'قَبُولٌ هَدِيٌّ':Added, #10: 10	قَبُولِ الْهَدِيَّةِ
u'قَبُولٌ هَدِيٌّ':Added, #12: 12	قَبُولُ الْهَدِيَّةِ
u'قَبُولٌ هَدِيٌّ':Added, #1: 1	قَبُولُ الْهَدِيّةِ
u'قَبُولٌ هَدِيٌّ':Added, #1: 1	قَبُولَ هَدِيَّةِ
u'قَبُولٌ هَدِيٌّ':Added, #1: 1	قَبُولُ هَدِيّةِ
u'قَبُولٌ هَدِيٌّ':Added, #1: 1	قَبُولِ هَدِيَّةٍ
u'قَبُولٌ هَدِيٌّ':Added, #2: 2	قَبُولَ الْهَدِيَّةِ
u'قَبُولٌ هَدِيٌّ':Added, #2: 2	قَبُولِ هَدِيَّةِ
u'قَبُولٌ هَدِيٌّ':Added, #3: 3	قَبُولُ هَدِيَّةِ
u'قَبُولٌ هَدِيٌّ':Added, #4: 4	قَبُولُ هَدِيَّةٍ
u'قَبُولٌ هَدِيَّةٌ':Added, #6: 6	قَبُولُ هَدِيَّتِهِ
u'قَبُولٌ هَدِيَّةٌ':Added, #10: 10	قَبُولِ الْهَدِيَّةِ
u'قَبُولٌ هَدِيَّةٌ':Added, #12: 12	قَبُولُ الْهَدِيَّةِ
u'قَبُولٌ هَدِيَّةٌ':Added, #1: 1	قَبُولُ الْهَدِيّةِ
u'قَبُولٌ هَدِيَّةٌ':Added, #1: 1	قَبُولَ هَدِيَّةِ
u'قَبُولٌ هَدِيَّةٌ':Added, #1: 1	قَبُولُ هَدِيّةِ
u'قَبُولٌ هَدِيَّةٌ':Added, #1: 1	قَبُولِ هَدِيَّةٍ
u'قَبُولٌ هَدِيَّةٌ':Added, #2: 2	قَبُولَ الْهَدِيَّةِ
u'قَبُولٌ هَدِيَّةٌ':Added, #2: 2	قَبُولِ هَدِيَّةِ
u'قَبُولٌ هَدِيَّةٌ':Added, #3: 3	قَبُولُ هَدِيَّةِ
u'قَبُولٌ هَدِيَّةٌ':Added, #4: 4	قَبُولُ هَدِيَّةٍ
u'قَبُولٌ واحد':Added, #6: 6	قَبُولُ هَدِيَّتِهِ
u'قَبُولٌ واحد':Added, #1: 1	قَبُولَ الْوَاحِدِ
u'قَبُولٌ وَاحِدٌ':Added, #1: 1	قَبُولُ الْوَاحِدِ
u'قَبُولٌ وَاحِدٌ':Added, #1: 1	قَبُولَ الْوَاحِدِ
u'قَبُولٌ واحد':Added, #1: 1	قَبُولُ الْوَاحِدِ
u'قَبُولٌ وَاحِدٌ':Added, #1: 1	قَبُولِ وَاحِدٍ
u'قَبُولٌ واحد':Added, #1: 1	قَبُولِ وَاحِدٍ
u'قَبُولٌ وَاحِدٌ':Added, #3: 3	قَبُولِ الْوَاحِدِ
u'قَبُولٌ وَارِثٌ':Added, #3: 3	قَبُولِ الْوَاحِدِ
u'قَبُولٌ وَارِثٌ':Added, #1: 1	قَبُولُ الْوَارِثِ
u'قَبُولٌ وَارِثٌ':Added, #1: 1	قَبُولَ وَارِثِهِ
u'قَبُولٌ ودائع':Added, #2: 2	قَبُولَ الْوَارِثِ
u'قَبُولٌ وَدَائِعُ':Added, #1: 1	قَبُولُ الْوَدَائِعِ
u'قَبُولٌ ودائع':Added, #1: 1	قَبُولُ الْوَدَائِعِ
u'قَبُولٌ وَدَائِعُ':Added, #3: 3	قَبُولِ الْوَدَائِعِ
u'قَبُولٌ وَدِيعٌ':Added, #3: 3	قَبُولِ الْوَدَائِعِ
u'قَبُولٌ وَدِيعٌ':Added, #1: 1	قَبُولَ الْوَدِيعَةِ
u'قَبُولٌ وَدِيعٌ':Added, #7: 7	قَبُولِ الْوَدِيعَةِ
u'قَبُولٌ وَدِيعَةٌ':Added, #8: 8	قَبُولُ الْوَدِيعَةِ
u'قَبُولٌ وَدِيعَةٌ':Added, #1: 1	قَبُولَ الْوَدِيعَةِ
u'قَبُولٌ وَدِيعَةٌ':Added, #1: 1	قَبُولَ وَدِيعَةٍ
u'قَبُولٌ وَدِيعَةٌ':Added, #7: 7	قَبُولِ الْوَدِيعَةِ
u'قَبُولٌ وَصِيٌّ':Added, #8: 8	قَبُولُ الْوَدِيعَةِ
u'قَبُولٌ وَصِيٌّ':Added, #1: 1	قَبُولُ الْوَصِيِّ
u'قَبُولٌ وَصِيٌّ':Added, #1: 1	قَبُول الْوَصِيَّةِ
u'قَبُولٌ وَصِيٌّ':Added, #1: 1	قَبُولُ وَصِيَّةٍ
u'قَبُولٌ وَصِيٌّ':Added, #2: 2	قَبُولِ الْوَصِيِّ
u'قَبُولٌ وَصِيٌّ':Added, #5: 5	قَبُولُ الْوَصِيَّةِ
u'قَبُولٌ وَصِيَّةٌ':Added, #5: 5	قَبُولِ الْوَصِيَّةِ
u'قَبُولٌ وَصِيَّةٌ':Added, #1: 1	قَبُول الْوَصِيَّةِ
u'قَبُولٌ وَصِيَّةٌ':Added, #1: 1	قَبُولُ وَصِيَّةٍ
u'قَبُولٌ وَصِيَّةٌ':Added, #5: 5	قَبُولُ الْوَصِيَّةِ
u'قَبُولٌ وَقْفٌ':Added, #5: 5	قَبُولِ الْوَصِيَّةِ
u'قَبُولٌ وَكِيلٌ':Added, #1: 1	قَبُولِ الْوَقْفِ
u'قَبُولٌ وِلاَيَةٌ':Added, #5: 5	قَبُولِ الْوَكِيلِ
u'قَبُولٌ وِلاَيَةٌ':Added, #1: 1	قَبُولُ وِلَايَةِ
u'قَبُولٌ وَلِيٌّ':Added, #1: 1	قَبُولُ وِلَايَتِهِ
u'قَبُولٌ وَلِيٌّ':Added, #1: 1	قَبُولُ الْوَلِيِّ
u'قتال اِبْنٌ':Added, #2: 2	قَبُولِ الْوَلِيِّ
u'قِتَالٌ اِبْنٌ':Added, #1: 1	قِتَالُ ابْنِ
u'قتال اِبْنٌ':Added, #1: 1	قِتَالُ ابْنِ
u'قِتَالٌ اِبْنٌ':Added, #2: 2	قِتَالِ ابْنِ
u'قتال أَصْحَابٌ':Added, #2: 2	قِتَالِ ابْنِ
u'قِتَالٌ أَصْحَابٌ':Added, #1: 1	قِتَالِ أَصْحَابِهِ
u'قتال أهْلٌ':Added, #1: 1	قِتَالِ أَصْحَابِهِ
u'قِتَالٌ أهْلٌ':Added, #2: 2	قِتَالَ أَهْلِ
u'قتال أهْلٌ':Added, #2: 2	قِتَالَ أَهْلِ
u'قِتَالٌ أهْلٌ':Added, #42: 42	قِتَالِ أَهْلِ
u'قتال أهْلٌ':Added, #42: 42	قِتَالِ أَهْلِ
u'قِتَالٌ أهْلٌ':Added, #5: 5	قِتَالُ أَهْلِ
u'قتال أئِمَّةٌ':Added, #5: 5	قِتَالُ أَهْلِ
u'قِتَالٌ أئِمَّةٌ':Added, #1: 1	قِتَالِ أَئِمَّةِ
u'قتال بَدْرٌ':Added, #1: 1	قِتَالِ أَئِمَّةِ
u'قِتَالٌ بَدْرٌ':Added, #1: 1	قِتَالِ بَدْرٍ
u'قتال بُغاةٌ':Added, #1: 1	قِتَالِ بَدْرٍ
u'قِتَالٌ بُغاةٌ':Added, #11: 11	قِتَالِ الْبُغَاةِ
u'قتال بُغاةٌ':Added, #11: 11	قِتَالِ الْبُغَاةِ
u'قِتَالٌ بُغاةٌ':Added, #2: 2	قِتَالُ الْبُغَاةِ
u'قتال تَتَر':Added, #2: 2	قِتَالُ الْبُغَاةِ
u'قِتَالٌ تَتَر':Added, #1: 1	قِتَالُ التَّتَرِ
u'قتال تَنْزِيلٌ':Added, #1: 1	قِتَالُ التَّتَرِ
u'قِتَالٌ تَنْزِيلٌ':Added, #1: 1	قِتَالِ التَّنْزِيلِ
u'قتال خوارج':Added, #1: 1	قِتَالِ التَّنْزِيلِ
u'قِتَالٌ خوارج':Added, #1: 1	قِتَالُ الْخَوَارِجِ
u'قتال خَوَارِجُ':Added, #1: 1	قِتَالُ الْخَوَارِجِ
u'قِتَالٌ خَوَارِجُ':Added, #1: 1	قِتَالُ الْخَوَارِجِ
u'قتال خوارج':Added, #1: 1	قِتَالُ الْخَوَارِجِ
u'قِتَالٌ خوارج':Added, #2: 2	قِتَالَ الْخَوَارِجِ
u'قتال خَوَارِجُ':Added, #2: 2	قِتَالَ الْخَوَارِجِ
u'قِتَالٌ خَوَارِجُ':Added, #2: 2	قِتَالَ الْخَوَارِجِ
u'قتال دفاع':Added, #2: 2	قِتَالَ الْخَوَارِجِ
u'قِتَالٌ دفاع':Added, #1: 1	قِتَالُ دِفَاعٍ
u'قتال دِفَاعٌ':Added, #1: 1	قِتَالُ دِفَاعٍ
u'قِتَالٌ دِفَاعٌ':Added, #1: 1	قِتَالُ دِفَاعٍ
u'قتال دَفْعٌ':Added, #1: 1	قِتَالُ دِفَاعٍ
u'قِتَالٌ دَفْعٌ':Added, #1: 1	قِتَالُ دَفْعٍ
u'قتال ذِمِّيٌّ':Added, #1: 1	قِتَالُ دَفْعٍ
u'قِتَالٌ ذِمِّيٌّ':Added, #1: 1	قِتَالُ الذِّمِّيِّ
u'قتال رِجَالٌ':Added, #1: 1	قِتَالُ الذِّمِّيِّ
u'قِتَالٌ رِجَالٌ':Added, #1: 1	قِتَالَ الرِّجَالِ
u'قتال رِدَّةٌ':Added, #1: 1	قِتَالَ الرِّجَالِ
u'قِتَالٌ رِدَّةٌ':Added, #1: 1	قِتَالِ الرِّدَّةِ
u'قتال رَسُولٌ':Added, #1: 1	قِتَالِ الرِّدَّةِ
u'قِتَالٌ رَسُولٌ':Added, #2: 2	قِتَالِ رَسُولِ
u'قتال رُومٌ':Added, #2: 2	قِتَالِ رَسُولِ
u'قِتَالٌ رُومٌ':Added, #1: 1	قِتَالِ الرُّومِ
u'قتال شجاع':Added, #1: 1	قِتَالِ الرُّومِ
u'قتال شجَاعٌ':Added, #1: 1	قِتَالِ الشُّجَاعِ
u'قِتَالٌ شجاع':Added, #1: 1	قِتَالِ الشُّجَاعِ
u'قِتَالٌ شجَاعٌ':Added, #1: 1	قِتَالِ الشُّجَاعِ
u'قتال صَحَابَةٌ':Added, #1: 1	قِتَالِ الشُّجَاعِ
u'قِتَالٌ صَحَابَةٌ':Added, #1: 1	قِتَالِ الصَّحَابَةِ
u'قتال ضَرْبٌ':Added, #1: 1	قِتَالِ الصَّحَابَةِ
u'قِتَالٌ ضَرْبٌ':Added, #2: 2	قِتَالِ الضَّرْبِ
u'قتال طَائِفٌ':Added, #2: 2	قِتَالِ الضَّرْبِ
u'قِتَالٌ طَائِفٌ':Added, #1: 1	قِتَالِ الطَّائِفَةِ
u'قتال عَاصِمٌ':Added, #1: 1	قِتَالِ الطَّائِفَةِ
u'قِتَالٌ عَاصِمٌ':Added, #1: 1	قِتَالَ عَاصِمٍ
u'قتال عَدُوٌّ':Added, #1: 1	قِتَالَ عَاصِمٍ
u'قتال عَدُوٌّ':Added, #1: 1	قِتَالَ الْعَدُوِّ
u'قِتَالٌ عَدُوٌّ':Added, #1: 1	قِتَالُ الْعَدُوِّ
u'قِتَالٌ عَدُوٌّ':Added, #1: 1	قِتَالَ الْعَدُوِّ
u'قتال عَدُوٌّ':Added, #1: 1	قِتَالُ الْعَدُوِّ
u'قِتَالٌ عَدُوٌّ':Added, #2: 2	قِتَالِ عَدُوِّ
u'قتال عَدُوٌّ':Added, #2: 2	قِتَالِ عَدُوِّ
u'قِتَالٌ عَدُوٌّ':Added, #4: 4	قِتَالِ الْعَدُوِّ
u'قتال عَلِيٌّ':Added, #4: 4	قِتَالِ الْعَدُوِّ
u'قِتَالٌ عَلِيٌّ':Added, #1: 1	قِتَالِ عَلِيٍّ
u'قتال غَزْوٌ':Added, #1: 1	قِتَالِ عَلِيٍّ
u'قِتَالٌ غَزْوٌ':Added, #1: 1	قِتَالَ غَزْوٍ
u'قتال غير':Added, #1: 1	قِتَالَ غَزْوٍ
u'قتال غَيْرٌ':Added, #1: 1	قِتَالَ غَيْرِهِ
u'قِتَالٌ غير':Added, #1: 1	قِتَالَ غَيْرِهِ
u'قِتَالٌ غَيْرٌ':Added, #1: 1	قِتَالَ غَيْرِهِ
u'قتال غير':Added, #1: 1	قِتَالَ غَيْرِهِ
u'قتال غَيْرٌ':Added, #2: 2	قِتَالِ غَيْرِهِ
u'قِتَالٌ غير':Added, #2: 2	قِتَالِ غَيْرِهِ
u'قِتَالٌ غَيْرٌ':Added, #2: 2	قِتَالِ غَيْرِهِ
u'قتال فتنة':Added, #2: 2	قِتَالِ غَيْرِهِ
u'قِتَالٌ فتنة':Added, #1: 1	قِتَالَ فِتْنَةٍ
u'قتال فِتْنَةٌ':Added, #1: 1	قِتَالَ فِتْنَةٍ
u'قِتَالٌ فِتْنَةٌ':Added, #1: 1	قِتَالَ فِتْنَةٍ
u'قتال فِئَةٌ':Added, #1: 1	قِتَالَ فِتْنَةٍ
u'قِتَالٌ فِئَةٌ':Added, #1: 1	قِتَالِ الْفِئَةِ
u'قتال فِئَةٌ':Added, #1: 1	قِتَالِ الْفِئَةِ
u'قِتَالٌ فِئَةٌ':Added, #2: 2	قِتَالَ الْفِئَةِ
u'قتال كَافِرٌ':Added, #2: 2	قِتَالَ الْفِئَةِ
u'قِتَالٌ كَافِرٌ':Added, #1: 1	قِتَالُ الْكَافِرِ
u'قتال كُفَّارٌ':Added, #1: 1	قِتَالُ الْكَافِرِ
u'قِتَالٌ كُفَّارٌ':Added, #1: 1	قِتَالَ الْكُفَّارِ
u'قتال كُفَّارٌ':Added, #1: 1	قِتَالَ الْكُفَّارِ
u'قِتَالٌ كُفَّارٌ':Added, #1: 1	قِتَالَ كُفَّارٍ
u'قتال كُفَّارٌ':Added, #1: 1	قِتَالَ كُفَّارٍ
u'قِتَالٌ كُفَّارٌ':Added, #20: 20	قِتَالِ الْكُفَّارِ
u'قتال كُفَّارٌ':Added, #20: 20	قِتَالِ الْكُفَّارِ
u'قِتَالٌ كُفَّارٌ':Added, #2: 2	قِتَالِ كُفَّارٍ
u'قتال كُفَّارٌ':Added, #2: 2	قِتَالِ كُفَّارٍ
u'قِتَالٌ كُفَّارٌ':Added, #4: 4	قِتَالُ الْكُفَّارِ
u'قتال لُصُوصٌ':Added, #4: 4	قِتَالُ الْكُفَّارِ
u'قِتَالٌ لُصُوصٌ':Added, #1: 1	قِتَالَ اللُّصُوصِ
u'قتال لُصُوصٌ':Added, #1: 1	قِتَالَ اللُّصُوصِ
u'قِتَالٌ لُصُوصٌ':Added, #2: 2	قِتَالِ اللُّصُوصِ
u'قتال مُبَاحٌ':Added, #2: 2	قِتَالِ اللُّصُوصِ
u'قِتَالٌ مُبَاحٌ':Added, #1: 1	قِتَالٍ مُبَاحٍ
u'قتال مُتَكَافِئ':Added, #1: 1	قِتَالٍ مُبَاحٍ
u'قِتَالٌ مُتَكَافِئ':Added, #1: 1	قِتَالِ مُتَكَافِئَيْنِ
u'قتال مُسْلِمٌ':Added, #1: 1	قِتَالِ مُتَكَافِئَيْنِ
u'قِتَالٌ مُسْلِمٌ':Added, #1: 1	قِتَالُ الْمُسْلِمِ
u'قتال مُسْلِمٌ':Added, #1: 1	قِتَالُ الْمُسْلِمِ
u'قِتَالٌ مُسْلِمٌ':Added, #1: 1	قِتَالُ مُسْلِمٍ
u'قتال مُضْطَرٌّ':Added, #1: 1	قِتَالُ مُسْلِمٍ
u'قِتَالٌ مُضْطَرٌّ':Added, #1: 1	قِتَالِ الْمُضْطَرِّ
u'قتال مَلاَئِكَةٌ':Added, #1: 1	قِتَالِ الْمُضْطَرِّ
u'قِتَالٌ مَلاَئِكَةٌ':Added, #1: 1	قِتَالِ الْمَلَائِكَةِ
u'قتال هِنْدٌ':Added, #1: 1	قِتَالِ الْمَلَائِكَةِ
u'قِتَالٌ هِنْدٌ':Added, #1: 1	قِتَالِ الْهِنْدِ
u'قتال يهود':Added, #1: 1	قِتَالِ الْهِنْدِ
u'قتال يَهُودٌ':Added, #1: 1	قِتَالِ الْيَهُودِ
u'قِتَالٌ يهود':Added, #1: 1	قِتَالِ الْيَهُودِ
u'قِتَالٌ يَهُودٌ':Added, #1: 1	قِتَالِ الْيَهُودِ
u'قَتَلَ أَبٌ':Predicate, #1: 1	قِتَالِ الْيَهُودِ
u'قَتَلَ أَبٌ':Subject, #10: 10	قَتَلَ الْأَبَ
u'قتل أَبٌ':Added, #11: 11	قَتَلَ الْأَبُ
u'قتل أَبٌ':Added, #1: 1	قَتْلَ الْأَبِ
u'قَتْلٌ أَبٌ':Added, #1: 1	قَتْلُ الْأَبِ
u'قَتْلٌ أَبٌ':Added, #1: 1	قَتْلَ الْأَبِ
u'قتل أَبٌ':Added, #1: 1	قَتْلُ الْأَبِ
u'قَتْلٌ أَبٌ':Added, #2: 2	قَتْلِ الْأَبِ
u'قَتَلَ اِبْنٌ':Predicate, #2: 2	قَتْلِ الْأَبِ
u'قَتَلَ اِبْنٌ':Subject, #15: 15	قَتَلَ ابْنَ
u'قَتَلَ اِبْنٌ':Subject, #1: 1	قَتَلَ ابْنٌ
u'قتل اِبْنٌ':Added, #1: 1	قَتَلَ ابْنُ
u'قَتْلٌ اِبْنٌ':Added, #10: 10	قَتْلِ ابْنِ
u'قتل اِبْنٌ':Added, #10: 10	قَتْلِ ابْنِ
u'قَتْلٌ اِبْنٌ':Added, #3: 3	قَتْلُ ابْنِ
u'قتل اِبْنٌ':Added, #3: 3	قَتْلُ ابْنِ
u'قَتْلٌ اِبْنٌ':Added, #4: 4	قَتْلِ ابْنِهِ
u'قَتَلَ أَجْنَبِيٌّ':Subject, #4: 4	قَتْلِ ابْنِهِ
u'قتل أَجِيرٌ':Added, #1: 1	قَتَلَ أَجْنَبِيٌّ
u'قَتْلٌ أَجِيرٌ':Added, #1: 1	قَتْلِ الْأَجِيرِ
u'قتل آحَادٌ':Added, #1: 1	قَتْلِ الْأَجِيرِ
u'قَتْلٌ آحَادٌ':Added, #1: 1	قَتْلِ آحَادٍ
u'قَتَلَ أَحِبَّةٌ':Predicate, #1: 1	قَتْلِ آحَادٍ
u'قَتَلَ أحَدٌ':Predicate, #1: 1	قَتَلَ الْأَحِبّةَ
u'قَتَلَ أحَدٌ':Subject, #4: 4	قَتَلَ أَحَدَ
u'قَتَلَ أحَدٌ':Subject, #2: 2	قَتَلَ أَحَدٌ
u'قتل أحَدٌ':Added, #8: 8	قَتَلَ أَحَدُ
u'قَتْلٌ أحَدٌ':Added, #1: 1	قَتْلُ أَحَدٍ
u'قتل أحَدٌ':Added, #1: 1	قَتْلُ أَحَدٍ
u'قتل أحَدٌ':Added, #2: 2	قَتْلِ أَحَدٍ
u'قَتْلٌ أحَدٌ':Added, #2: 2	قَتْلِ أَحَدِ
u'قَتْلٌ أحَدٌ':Added, #2: 2	قَتْلِ أَحَدٍ
u'قتل أخرَس':Added, #2: 2	قَتْلِ أَحَدِ
u'قَتْلٌ أخرَس':Added, #1: 1	قَتْلُ الْأَخْرَسِ
u'قتل آدَمِيٌّ':Added, #1: 1	قَتْلُ الْأَخْرَسِ
u'قَتْلٌ آدَمِيٌّ':Added, #10: 10	قَتْلِ الْآدَمِيِّ
u'قتل آدَمِيٌّ':Added, #10: 10	قَتْلِ الْآدَمِيِّ
u'قَتْلٌ آدَمِيٌّ':Added, #1: 1	قَتْلُ آدَمِيٍّ
u'قتل آدَمِيٌّ':Added, #1: 1	قَتْلُ آدَمِيٍّ
u'قَتْلٌ آدَمِيٌّ':Added, #3: 3	قَتْلِ آدَمِيٍّ
u'قتل أَرْبَعَةٌ':Added, #3: 3	قَتْلِ آدَمِيٍّ
u'قَتْلٌ أَرْبَعَةٌ':Added, #1: 1	قَتْلَ أَرْبَعَةٍ
u'قتل أَرْبَعَةٌ':Added, #1: 1	قَتْلَ أَرْبَعَةٍ
u'قَتْلٌ أَرْبَعَةٌ':Added, #2: 2	قَتْلِ أَرْبَعَةٍ
u'قتل أَسيرٌ':Added, #2: 2	قَتْلِ أَرْبَعَةٍ
u'قَتْلٌ أَسيرٌ':Added, #1: 1	قَتْلُ أَسِيرِ
u'قتل أَسيرٌ':Added, #1: 1	قَتْلُ أَسِيرِ
u'قتل أَسيرٌ':Added, #1: 1	قَتْلَ الْأَسِيرِ
u'قَتْلٌ أَسيرٌ':Added, #1: 1	قَتْلِ الْأَسِيرِ
u'قَتْلٌ أَسيرٌ':Added, #1: 1	قَتْلَ الْأَسِيرِ
u'قتل أَسيرٌ':Added, #1: 1	قَتْلِ الْأَسِيرِ
u'قَتْلٌ أَسيرٌ':Added, #3: 3	قَتْلُ الْأَسِيرِ
u'قَتَلَ أصل':Subject, #3: 3	قَتْلُ الْأَسِيرِ
u'قَتَلَ أًصْلٌ':Subject, #1: 1	قَتَلَ الْأَصْلُ
u'قَتَلَ أكْبَرُ':Predicate, #1: 1	قَتَلَ الْأَصْلُ
u'قَتَلَ أَكْثَرُ':Predicate, #1: 1	قَتَلَ الْأَكْبَرَ
u'قتل ألف':Added, #2: 2	قَتَلَ أَكْثَرَ
u'قتل ألْفٌ':Added, #1: 1	قَتْلِ أَلْفِ
u'قتل أَلْفٌ':Added, #1: 1	قَتْلِ أَلْفِ
u'قَتْلٌ ألف':Added, #1: 1	قَتْلِ أَلْفِ
u'قَتْلٌ ألْفٌ':Added, #1: 1	قَتْلِ أَلْفِ
u'قَتْلٌ أَلْفٌ':Added, #1: 1	قَتْلِ أَلْفِ
u'قَتَلَ الْمَرْأَةُ':Predicate, #1: 1	قَتْلِ أَلْفِ
u'قتل الْمَرْأَةُ':Added, #2: 2	قَتَلَ الْمَرْأَةَ
u'قتل الْمَرْأَةُ':Added, #1: 1	قَتْلَ الْمَرْأَةِ
u'قتل الْمَرْأَةُ':Added, #1: 1	قَتْلُ الْمَرْأَةِ
u'قَتْلٌ الْمَرْأَةُ':Added, #1: 1	قَتْلِ الْمَرْأَةِ
u'قَتْلٌ الْمَرْأَةُ':Added, #1: 1	قَتْلَ الْمَرْأَةِ
u'قَتْلٌ الْمَرْأَةُ':Added, #1: 1	قَتْلُ الْمَرْأَةِ
u'قَتَلَ أُمٌّ':Predicate, #1: 1	قَتْلِ الْمَرْأَةِ
u'قَتَلَ أُمٌّ':Subject, #2: 2	قَتَلَ أُمَّ
u'قتل أُمٌّ':Added, #1: 1	قَتَلَ أُمُّ
u'قَتْلٌ أُمٌّ':Added, #1: 1	قَتْلُ الْأُمِّ
u'قتل أُمٌّ':Added, #1: 1	قَتْلُ الْأُمِّ
u'قَتْلٌ أُمٌّ':Added, #1: 1	قَتْلُ أُمِّهِ
u'قتل إمَامٌ':Added, #1: 1	قَتْلُ أُمِّهِ
u'قَتْلٌ إمَامٌ':Added, #2: 2	قَتْلَ الْإِمَامِ
u'قتل إمَامٌ':Added, #2: 2	قَتْلَ الْإِمَامِ
u'قَتْلٌ إمَامٌ':Added, #3: 3	قَتْلِ الإِمَامِ
u'قَتَلَ أمَةٌ':Predicate, #3: 3	قَتْلِ الإِمَامِ
u'قتل أمَةٌ':Added, #2: 2	قَتَلَ الْأَمَةَ
u'قَتْلٌ أمَةٌ':Added, #2: 2	قَتْلِ الْأَمَةِ
u'قَتَلَ آمِرٌ':Subject, #2: 2	قَتْلِ الْأَمَةِ
u'قتل آمِرٌ':Added, #1: 1	قَتَلَ الْآمِرُ
u'قَتْلٌ آمِرٌ':Added, #1: 1	قَتْلِ الْآمِرِ
u'قتل اِمْرَأَةٌ':Added, #1: 1	قَتْلِ الْآمِرِ
u'قتل اِمْرَأَةٌ':Added, #1: 1	قَتْلُ امْرَأَةٍ
u'قَتْلٌ اِمْرَأَةٌ':Added, #1: 1	قَتْلِ امْرَأَةٍ
u'قَتْلٌ اِمْرَأَةٌ':Added, #1: 1	قَتْلُ امْرَأَةٍ
u'قَتَلَ أَميرٌ':Predicate, #1: 1	قَتْلِ امْرَأَةٍ
u'قَتَلَ أَميرٌ':Subject, #1: 1	قَتَلَ الْأَمِيرَ
u'قتل إِناثٌ':Added, #1: 1	قَتَلَ الْأَمِيرُ
u'قَتْلٌ إِناثٌ':Added, #1: 1	قَتْلَ الْإِنَاثِ
u'قتل أنبياء':Added, #1: 1	قَتْلَ الْإِنَاثِ
u'قَتْلٌ أنبياء':Added, #1: 1	قَتْلِ الْأَنْبِيَاءِ
u'قَتَلَ إِنْسانٌ':Subject, #1: 1	قَتْلِ الْأَنْبِيَاءِ
u'قتل إِنْسانٌ':Added, #3: 3	قَتَلَ إنْسَانٌ
u'قتل إِنْسانٌ':Added, #1: 1	قَتْلُ الْإِنْسَانِ
u'قَتْلٌ إِنْسانٌ':Added, #1: 1	قَتْلِ الْإِنْسَانِ
u'قَتْلٌ إِنْسانٌ':Added, #1: 1	قَتْلُ الْإِنْسَانِ
u'قتل إِنْسانٌ':Added, #1: 1	قَتْلِ الْإِنْسَانِ
u'قَتْلٌ إِنْسانٌ':Added, #1: 1	قَتْلَ إنْسَانٍ
u'قتل إِنْسانٌ':Added, #1: 1	قَتْلَ إنْسَانٍ
u'قَتْلٌ إِنْسانٌ':Added, #4: 4	قَتْلِ إنْسَانٍ
u'قتل إِنْسِيٌّ':Added, #4: 4	قَتْلِ إنْسَانٍ
u'قَتْلٌ إِنْسِيٌّ':Added, #1: 1	قَتْلُ الْإِنْسِيِّ
u'قتل أَنْفُسٌ':Added, #1: 1	قَتْلُ الْإِنْسِيِّ
u'قَتْلٌ أَنْفُسٌ':Added, #1: 1	قَتْلَ الْأَنْفُسِ
u'قتل أهْلٌ':Added, #1: 1	قَتْلَ الْأَنْفُسِ
u'قَتْلٌ أهْلٌ':Added, #3: 3	قَتْلِ أَهْلِ
u'قتل أَوْزَاغٌ':Added, #3: 3	قَتْلِ أَهْلِ
u'قَتْلٌ أَوْزَاغٌ':Added, #1: 1	قَتْلَ الْأَوْزَاغِ
u'قَتَلَ أَوَّلُ':Predicate, #1: 1	قَتْلَ الْأَوْزَاغِ
u'قتل أَوَّلُ':Added, #1: 1	قَتَلَ الْأَوَّلَ
u'قتل أَوَّلُ':Added, #1: 1	قَتْلَ الْأَوَّلِ
u'قَتْلٌ أَوَّلُ':Added, #1: 1	قَتْلُ الْأَوَّلِ
u'قَتْلٌ أَوَّلُ':Added, #1: 1	قَتْلَ الْأَوَّلِ
u'قتل أَوْلاَدٌ':Added, #1: 1	قَتْلُ الْأَوَّلِ
u'قتل أَوْلاَدٌ':Added, #1: 1	قَتْلَ الْأَوْلَادِ
u'قَتْلٌ أَوْلاَدٌ':Added, #1: 1	قَتْلِ الْأَوْلَادِ
u'قَتْلٌ أَوْلاَدٌ':Added, #1: 1	قَتْلَ الْأَوْلَادِ
u'قتل أَوْلاَدٌ':Added, #1: 1	قَتْلِ الْأَوْلَادِ
u'قَتْلٌ أَوْلاَدٌ':Added, #1: 1	قَتْلَ أَوْلَادِ
u'قتل أَوْلاَدٌ':Added, #1: 1	قَتْلَ أَوْلَادِ
u'قَتْلٌ أَوْلاَدٌ':Added, #2: 2	قَتْلُ الْأَوْلَادِ
u'قَتَلَ بادِئٌ':Subject, #2: 2	قَتْلُ الْأَوْلَادِ
u'قَتَلَ بَاغِي':Predicate, #2: 2	قَتَلَ الْبَادِئُ
u'قَتَلَ باقِي':Predicate, #3: 3	قَتَلَ الْبَاغِيَ
u'قَتَلَ بَائِعٌ':Subject, #1: 1	قَتَلَ الْبَاقِيَ
u'قَتَلَ بَدَوِيٌّ':Subject, #1: 1	قَتَلَ الْبَائِعُ
u'قتل بَراغِيثُ':Added, #1: 1	قَتَلَ الْبَدَوِيُّ
u'قَتْلٌ بَراغِيثُ':Added, #1: 1	قَتْلُ الْبَرَاغِيثِ
u'قتل بُرْغوثٌ':Added, #1: 1	قَتْلُ الْبَرَاغِيثِ
u'قتل بُرْغوثٌ':Added, #1: 1	قَتْلَ الْبُرْغُوثِ
u'قَتْلٌ بُرْغوثٌ':Added, #1: 1	قَتْلِ الْبُرْغُوثِ
u'قَتْلٌ بُرْغوثٌ':Added, #1: 1	قَتْلَ الْبُرْغُوثِ
u'قَتَلَ بِضْعٌ':Predicate, #1: 1	قَتْلِ الْبُرْغُوثِ
u'قتل بَعْضٌ':Added, #1: 1	قَتَلَ بِضْعَةَ
u'قتل بَعْضٌ':Added, #1: 1	قَتْلَ بَعْضِ
u'قتل بَعْضٌ':Added, #1: 1	قَتْلُ بَعْضِ
u'قَتْلٌ بَعْضٌ':Added, #1: 1	قَتْلِ بَعْضِ
u'قَتْلٌ بَعْضٌ':Added, #1: 1	قَتْلَ بَعْضِ
u'قَتْلٌ بَعْضٌ':Added, #1: 1	قَتْلُ بَعْضِ
u'قتل بَعوضٌ':Added, #1: 1	قَتْلِ بَعْضِ
u'قَتْلٌ بَعوضٌ':Added, #3: 3	قَتْلِ الْبَعُوضِ
u'قتل بُغاةٌ':Added, #3: 3	قَتْلِ الْبَعُوضِ
u'قَتْلٌ بُغاةٌ':Added, #1: 1	قَتْلُ الْبُغَاةِ
u'قتل بِكْرٌ':Added, #1: 1	قَتْلُ الْبُغَاةِ
u'قَتْلٌ بِكْرٌ':Added, #1: 1	قَتْلَ الْبِكْرِ
u'قتل بناتٌ':Added, #1: 1	قَتْلَ الْبِكْرِ
u'قَتْلٌ بناتٌ':Added, #1: 1	قَتْلِ الْبَنَاتِ
u'قَتَلَ بَهيمٌ':Predicate, #1: 1	قَتْلِ الْبَنَاتِ
u'قتل بَهيمٌ':Added, #2: 2	قَتَلَ الْبَهِيمَةَ
u'قَتْلٌ بَهيمٌ':Added, #1: 1	قَتْلِ بَهِيمَتِهِ
u'قتل بَهيمٌ':Added, #1: 1	قَتْلِ بَهِيمَتِهِ
u'قَتْلٌ بَهيمٌ':Added, #2: 2	قَتْلِ الْبَهِيمَةِ
u'قَتَلَ بَهِيمَةٌ':Predicate, #2: 2	قَتْلِ الْبَهِيمَةِ
u'قتل بَهِيمَةٌ':Added, #2: 2	قَتَلَ الْبَهِيمَةَ
u'قَتْلٌ بَهِيمَةٌ':Added, #1: 1	قَتْلِ بَهِيمَتِهِ
u'قتل بَهِيمَةٌ':Added, #1: 1	قَتْلِ بَهِيمَتِهِ
u'قَتْلٌ بَهِيمَةٌ':Added, #2: 2	قَتْلِ الْبَهِيمَةِ
u'قتل تارِك':Added, #2: 2	قَتْلِ الْبَهِيمَةِ
u'قَتْلٌ تارِك':Added, #2: 2	قَتْلَ تَارِكِ
u'قتل تارِك':Added, #2: 2	قَتْلَ تَارِكِ
u'قَتْلٌ تارِك':Added, #3: 3	قَتْلِ تَارِكِ
u'قَتَلَ تِسْعَةٌ':Subject, #3: 3	قَتْلِ تَارِكِ
u'قَتَلَ ثَالِثٌ':Subject, #1: 1	قَتَلَ تِسْعَةٌ
u'قَتَلَ ثَلاثَةٌ':Predicate, #1: 1	قَتَلَ الثَّالِثُ
u'قتل ثَلاثَةٌ':Added, #1: 1	قَتَلَ ثَلَاثَةَ
u'قَتْلٌ ثَلاثَةٌ':Added, #1: 1	قَتْلُ الثَّلَاثَةِ
u'قَتَلَ جَارِي':Predicate, #1: 1	قَتْلُ الثَّلَاثَةِ
u'قَتَلَ جَارِي':Predicate, #1: 1	قَتَلَ الْجَارِيَةَ
u'قَتَلَ جَارِيَةٌ':Predicate, #6: 6	قَتَلَ جَارِيَةً
u'قتل جَاسُوسٌ':Added, #1: 1	قَتَلَ الْجَارِيَةَ
u'قتل جَاسُوسٌ':Added, #1: 1	قَتْلُ الْجَاسُوسِ
u'قَتْلٌ جَاسُوسٌ':Added, #1: 1	قَتْلِ الْجَاسُوسِ
u'قَتْلٌ جَاسُوسٌ':Added, #1: 1	قَتْلُ الْجَاسُوسِ
u'قتل جَانِي':Added, #1: 1	قَتْلِ الْجَاسُوسِ
u'قَتْلٌ جَانِي':Added, #1: 1	قَتْلِ الْجَانِيَةِ
u'قتل جَاهِلِيٌّ':Added, #1: 1	قَتْلِ الْجَانِيَةِ
u'قَتْلٌ جَاهِلِيٌّ':Added, #1: 1	قَتْلَ الْجَاهِلِيَّةِ
u'قتل جَاهِلِيَّةٌ':Added, #1: 1	قَتْلَ الْجَاهِلِيَّةِ
u'قَتْلٌ جَاهِلِيَّةٌ':Added, #1: 1	قَتْلَ الْجَاهِلِيَّةِ
u'قَتَلَ جَرَادٌ':Predicate, #1: 1	قَتْلَ الْجَاهِلِيَّةِ
u'قتل جَراد':Added, #1: 1	قَتَلَ الْجَرَادَ
u'قَتْلٌ جَراد':Added, #1: 1	قَتْلِ جَرَادَتَيْنِ
u'قتل جِرْجِير':Added, #1: 1	قَتْلِ جَرَادَتَيْنِ
u'قَتْلٌ جِرْجِير':Added, #1: 1	قَتْلِ جِرْجِيرٍ
u'قَتَلَ جَمَاعَةٌ':Subject, #1: 1	قَتْلِ جِرْجِيرٍ
u'قَتَلَ جَمَاعَةٌ':Subject, #12: 12	قَتَلَ جَمَاعَةٌ
u'قتل جَمَاعَةٌ':Added, #1: 1	قَتَلَ الْجَمَاعَةُ
u'قَتْلٌ جَمَاعَةٌ':Added, #4: 4	قَتْلُ الْجَمَاعَةِ
u'قتل جَمَاعَةٌ':Added, #4: 4	قَتْلُ الْجَمَاعَةِ
u'قَتْلٌ جَمَاعَةٌ':Added, #8: 8	قَتْلِ الْجَمَاعَةِ
u'قتل جَمَلٌ':Added, #8: 8	قَتْلِ الْجَمَاعَةِ
u'قَتْلٌ جَمَلٌ':Added, #1: 1	قَتْلِ الْجَمَلِ
u'قتل جِنَانٌ':Added, #1: 1	قَتْلِ الْجَمَلِ
u'قَتْلٌ جِنَانٌ':Added, #1: 1	قَتْلِ الْجِنَانِ
u'قتل جِنِّيٌّ':Added, #1: 1	قَتْلِ الْجِنَانِ
u'قَتْلٌ جِنِّيٌّ':Added, #1: 1	قَتْلُ الْجِنِّيِّ
u'قَتَلَ جَنِينٌ':Predicate, #1: 1	قَتْلُ الْجِنِّيِّ
u'قتل جَنِينٌ':Added, #1: 1	قَتَلَ الْجَنِينَ
u'قَتْلٌ جَنِينٌ':Added, #1: 1	قَتْلُ الْجَنِينِ
u'قتل جَنِينٌ':Added, #1: 1	قَتْلُ الْجَنِينِ
u'قَتْلٌ جَنِينٌ':Added, #1: 1	قَتْلَ جَنِينٍ
u'قتل جَهْم':Added, #1: 1	قَتْلَ جَنِينٍ
u'قَتْلٌ جَهْم':Added, #1: 1	قَتْلِ الْجَهْمِيَّةِ
u'قَتَلَ حاجِبٌ':Predicate, #1: 1	قَتْلِ الْجَهْمِيَّةِ
u'قَتَلَ حارِثٌ':Predicate, #1: 1	قَتَلَ حَاجِبَ
u'قَتَلَ حاكِمٌ':Subject, #3: 3	قَتَلَ الْحَارِثَ
u'قتل حاكِمٌ':Added, #1: 1	قَتَلَ الْحَاكِمُ
u'قَتْلٌ حاكِمٌ':Added, #1: 1	قَتْلِ الْحَاكِمِ
u'قتل حاكِمٌ':Added, #1: 1	قَتْلِ الْحَاكِمِ
u'قَتْلٌ حاكِمٌ':Added, #2: 2	قَتْلِ حَاكِمٍ
u'قَتَلَ حامِلٌ':Predicate, #2: 2	قَتْلِ حَاكِمٍ
u'قَتَلَ حَبَشَة':Predicate, #1: 1	قَتَلَ الْحَامِلَ
u'قَتَلَ حَجَرٌ':Subject, #1: 1	قَتَلَ الْحَبَشَةَ
u'قَتَلَ حَجَرٌ':Subject, #1: 1	قَتَلَ الْحَجَرُ
u'قَتَلَ حُرٌّ':Predicate, #1: 1	قَتَلَ حَجَرُهُ
u'قَتَلَ حُرٌّ':Predicate, #2: 2	قَتَلَ الْحُرَّ
u'قَتَلَ حَرٌّ':Subject, #3: 3	قَتَلَ حُرَّةً
u'قَتَلَ حُرٌّ':Subject, #1: 1	قَتَلَ الْحَرُّ
u'قَتَلَ حُرٌّ':Subject, #1: 1	قَتَلَ الْحُرُّ
u'قتل حُرٌّ':Added, #3: 3	قَتَلَ حُرٌّ
u'قَتْلٌ حُرٌّ':Added, #2: 2	قَتْلَ الْحُرِّ
u'قتل حُرٌّ':Added, #2: 2	قَتْلَ الْحُرِّ
u'قَتْلٌ حُرٌّ':Added, #5: 5	قَتْلِ الْحُرِّ
u'قتل حُرٌّ':Added, #5: 5	قَتْلِ الْحُرِّ
u'قَتْلٌ حُرٌّ':Added, #8: 8	قَتْلُ الْحُرِّ
u'قَتَلَ حُزْنٌ':Subject, #8: 8	قَتْلُ الْحُرِّ
u'قَتَلَ حَسَنٌ':Subject, #1: 1	قَتَلَ الْحُزْنُ
u'قتل حَشَرَةٌ':Added, #1: 1	قَتَلَ الْحَسَنُ
u'قَتْلٌ حَشَرَةٌ':Added, #1: 1	قَتْلِ الْحَشَرَاتِ
u'قَتَلَ حَلالٌ':Subject, #1: 1	قَتْلِ الْحَشَرَاتِ
u'قتل حَلالٌ':Added, #3: 3	قَتَلَ الْحَلَالُ
u'قَتْلٌ حَلالٌ':Added, #1: 1	قَتْلِ حَلَالٍ
u'قَتَلَ حَمَامٌ':Predicate, #1: 1	قَتْلِ حَلَالٍ
u'قَتَلَ حَمْز':Predicate, #1: 1	قَتَلَ الْحَمَامَ
u'قَتَلَ حَيٌّ':Predicate, #2: 2	قَتَلَ حَمْزَةَ
u'قَتَلَ حَيٌّ':Predicate, #2: 2	قَتَلَ الْحَيَّةَ
u'قتل حَيٌّ':Added, #2: 2	قَتَلَ حَيَّةً
u'قتل حَيٌّ':Added, #1: 1	قَتْلُ حَيَّاتِ
u'قَتْلٌ حَيٌّ':Added, #1: 1	قَتْلِ حَيَّاتِ
u'قَتْلٌ حَيٌّ':Added, #1: 1	قَتْلُ حَيَّاتِ
u'قتل حَيٌّ':Added, #1: 1	قَتْلِ حَيَّاتِ
u'قَتْلٌ حَيٌّ':Added, #2: 2	قَتْلِ حَيَّةٍ
u'قتل حَيٌّ':Added, #2: 2	قَتْلِ حَيَّةٍ
u'قَتْلٌ حَيٌّ':Added, #3: 3	قَتْلِ الْحَيَّاتِ
u'قتل حَيٌّ':Added, #3: 3	قَتْلِ الْحَيَّاتِ
u'قَتْلٌ حَيٌّ':Added, #5: 5	قَتْلِ الْحَيَّةِ
u'قتل حَيٌّ':Added, #5: 5	قَتْلِ الْحَيَّةِ
u'قَتْلٌ حَيٌّ':Added, #7: 7	قَتْلُ الْحَيَّةِ
u'قتل حَيَّاتٌ':Added, #7: 7	قَتْلُ الْحَيَّةِ
u'قتل حَيَّاتٌ':Added, #1: 1	قَتْلُ حَيَّاتِ
u'قَتْلٌ حَيَّاتٌ':Added, #1: 1	قَتْلِ حَيَّاتِ
u'قَتْلٌ حَيَّاتٌ':Added, #1: 1	قَتْلُ حَيَّاتِ
u'قتل حَيَّاتٌ':Added, #1: 1	قَتْلِ حَيَّاتِ
u'قَتْلٌ حَيَّاتٌ':Added, #3: 3	قَتْلِ الْحَيَّاتِ
u'قَتَلَ حَيَّةٌ':Predicate, #3: 3	قَتْلِ الْحَيَّاتِ
u'قتل حَيَّةٌ':Added, #2: 2	قَتَلَ الْحَيَّةَ
u'قتل حَيَّةٌ':Added, #1: 1	قَتْلُ حَيَّاتِ
u'قَتْلٌ حَيَّةٌ':Added, #1: 1	قَتْلِ حَيَّاتِ
u'قَتْلٌ حَيَّةٌ':Added, #1: 1	قَتْلُ حَيَّاتِ
u'قتل حَيَّةٌ':Added, #1: 1	قَتْلِ حَيَّاتِ
u'قَتْلٌ حَيَّةٌ':Added, #2: 2	قَتْلِ حَيَّةٍ
u'قتل حَيَّةٌ':Added, #2: 2	قَتْلِ حَيَّةٍ
u'قَتْلٌ حَيَّةٌ':Added, #3: 3	قَتْلِ الْحَيَّاتِ
u'قتل حَيَّةٌ':Added, #3: 3	قَتْلِ الْحَيَّاتِ
u'قَتْلٌ حَيَّةٌ':Added, #5: 5	قَتْلِ الْحَيَّةِ
u'قتل حَيَّةٌ':Added, #5: 5	قَتْلِ الْحَيَّةِ
u'قَتْلٌ حَيَّةٌ':Added, #7: 7	قَتْلُ الْحَيَّةِ
u'قتل حَيَوَانٌ':Added, #7: 7	قَتْلُ الْحَيَّةِ
u'قتل حَيَوَانٌ':Added, #1: 1	قَتْلَ الْحَيَوَانِ
u'قَتْلٌ حَيَوَانٌ':Added, #1: 1	قَتْلُ الْحَيَوَانِ
u'قَتْلٌ حَيَوَانٌ':Added, #1: 1	قَتْلَ الْحَيَوَانِ
u'قتل حَيَوَانٌ':Added, #1: 1	قَتْلُ الْحَيَوَانِ
u'قَتْلٌ حَيَوَانٌ':Added, #1: 1	قَتْلُ حَيَوَانٍ
u'قتل حَيَوَانٌ':Added, #1: 1	قَتْلُ حَيَوَانٍ
u'قَتْلٌ حَيَوَانٌ':Added, #2: 2	قَتْلِ الْحَيَوَانِ
u'قَتَلَ خَالِدٌ':Subject, #2: 2	قَتْلِ الْحَيَوَانِ
u'قَتَلَ خَالِدٌ':Subject, #1: 1	قَتَلَ خَالِدٌ
u'قتل خَطَأٌ':Added, #1: 1	قَتَلَ خَالِدُ
u'قَتْلٌ خَطَأٌ':Added, #18: 18	قَتْلِ الْخَطَأِ
u'قتل خَطَأٌ':Added, #18: 18	قَتْلِ الْخَطَأِ
u'قتل خَطَأٌ':Added, #1: 1	قَتْلَ خَطَأٍ
u'قَتْلٌ خَطَأٌ':Added, #1: 1	قَتْلِ خَطَأٍ
u'قَتْلٌ خَطَأٌ':Added, #1: 1	قَتْلٍ خَطَأٍ
u'قَتْلٌ خَطَأٌ':Added, #1: 1	قَتْلَ خَطَأٍ
u'قتل خَطَأٌ':Added, #1: 1	قَتْلِ خَطَأٍ
u'قتل خَطَأٌ':Added, #3: 3	قَتْلَ الْخَطَأِ
u'قَتْلٌ خَطَأٌ':Added, #3: 3	قَتْلُ الْخَطَأِ
u'قَتْلٌ خَطَأٌ':Added, #3: 3	قَتْلَ الْخَطَأِ
u'قتل خَطَأٌ':Added, #3: 3	قَتْلُ الْخَطَأِ
u'قَتْلٌ خَطَأٌ':Added, #3: 3	قَتْلُ خَطَأٍ
u'قتل خَطَاطِيفُ':Added, #3: 3	قَتْلُ خَطَأٍ
u'قَتْلٌ خَطَاطِيفُ':Added, #3: 3	قَتْلِ الْخَطَاطِيفِ
u'قتل خَطَّافٌ':Added, #3: 3	قَتْلِ الْخَطَاطِيفِ
u'قتل خُطَّافٌ':Added, #1: 1	قَتْلِ الْخَطَّافِ
u'قَتْلٌ خَطَّافٌ':Added, #1: 1	قَتْلِ الْخُطَّافِ
u'قَتْلٌ خُطَّافٌ':Added, #1: 1	قَتْلِ الْخَطَّافِ
u'قتل خُفَّاشٌ':Added, #1: 1	قَتْلِ الْخُطَّافِ
u'قَتْلٌ خُفَّاشٌ':Added, #1: 1	قَتْلِ الْخُفَّاشِ
u'قَتَلَ خلق':Predicate, #1: 1	قَتْلِ الْخُفَّاشِ
u'قَتَلَ خَلْقٌ':Predicate, #1: 1	قَتَلَ الْخَلْقَ
u'قتل خَمْسَةٌ':Added, #1: 1	قَتَلَ الْخَلْقَ
u'قَتْلٌ خَمْسَةٌ':Added, #1: 1	قَتْلِ الْخَمْسَةِ
u'قتل خوارج':Added, #1: 1	قَتْلِ الْخَمْسَةِ
u'قَتْلٌ خوارج':Added, #1: 1	قَتْلُ الْخَوَارِجِ
u'قتل خَوَارِجُ':Added, #1: 1	قَتْلُ الْخَوَارِجِ
u'قَتْلٌ خَوَارِجُ':Added, #1: 1	قَتْلُ الْخَوَارِجِ
u'قَتَلَ دَخَلٌ':Predicate, #1: 1	قَتْلُ الْخَوَارِجِ
u'قتل دُعَاةٌ':Added, #1: 1	قَتَلَ دَخَلَ
u'قَتْلٌ دُعَاةٌ':Added, #2: 2	قَتْلَ الدُّعَاةِ
u'قتل دَوَابُّ':Added, #2: 2	قَتْلَ الدُّعَاةِ
u'قَتْلٌ دَوَابُّ':Added, #1: 1	قَتْلَ الدَّوَابِّ
u'قتل دَوَابُّ':Added, #1: 1	قَتْلَ الدَّوَابِّ
u'قَتْلٌ دَوَابُّ':Added, #3: 3	قَتْلِ الدَّوَابِّ
u'قتل دَوَابُّ':Added, #3: 3	قَتْلِ الدَّوَابِّ
u'قَتْلٌ دَوَابُّ':Added, #3: 3	قَتْلِ دَوَابِّ
u'قتل دُودٌ':Added, #3: 3	قَتْلِ دَوَابِّ
u'قَتْلٌ دُودٌ':Added, #1: 1	قَتْلِ دُودِ
u'قتل ذُرِّيَّةٌ':Added, #1: 1	قَتْلِ دُودِ
u'قَتْلٌ ذُرِّيَّةٌ':Added, #2: 2	قَتْلِ الذُّرِّيَّةِ
u'قَتَلَ ذِمِّيٌّ':Predicate, #2: 2	قَتْلِ الذُّرِّيَّةِ
u'قَتَلَ ذِمِّيٌّ':Subject, #1: 1	قَتَلَ الذِّمِّيَّ
u'قتل ذِمِّيٌّ':Added, #2: 2	قَتَلَ الذِّمِّيُّ
u'قَتْلٌ ذِمِّيٌّ':Added, #1: 1	قَتْلَ الذِّمِّيِّ
u'قتل ذِمِّيٌّ':Added, #1: 1	قَتْلَ الذِّمِّيِّ
u'قَتْلٌ ذِمِّيٌّ':Added, #1: 1	قَتْلَ ذِمِّيٍّ
u'قتل ذِمِّيٌّ':Added, #1: 1	قَتْلَ ذِمِّيٍّ
u'قَتْلٌ ذِمِّيٌّ':Added, #2: 2	قَتْلُ الذِّمِّيِّ
u'قتل ذِمِّيٌّ':Added, #2: 2	قَتْلُ الذِّمِّيِّ
u'قتل ذِمِّيٌّ':Added, #2: 2	قَتْلُ ذِمِّيٍّ
u'قَتْلٌ ذِمِّيٌّ':Added, #2: 2	قَتْلِ ذِمِّيٍّ
u'قَتْلٌ ذِمِّيٌّ':Added, #2: 2	قَتْلُ ذِمِّيٍّ
u'قتل ذِمِّيٌّ':Added, #2: 2	قَتْلِ ذِمِّيٍّ
u'قَتْلٌ ذِمِّيٌّ':Added, #7: 7	قَتْلِ الذِّمِّيِّ
u'قتل ذِئْبٌ':Added, #7: 7	قَتْلِ الذِّمِّيِّ
u'قَتْلٌ ذِئْبٌ':Added, #2: 2	قَتْلِ الذِّئْبِ
u'قتل ذِئْبٌ':Added, #2: 2	قَتْلِ الذِّئْبِ
u'قتل ذِئْبٌ':Added, #3: 3	قَتْلَ الذِّئْبِ
u'قَتْلٌ ذِئْبٌ':Added, #3: 3	قَتْلُ الذِّئْبِ
u'قَتْلٌ ذِئْبٌ':Added, #3: 3	قَتْلَ الذِّئْبِ
u'قَتَلَ رابع':Subject, #3: 3	قَتْلُ الذِّئْبِ
u'قَتَلَ رَابِعٌ':Subject, #1: 1	قَتَلَ رَابِعٌ
u'قتل رابع':Added, #1: 1	قَتَلَ رَابِعٌ
u'قَتْلٌ رابع':Added, #1: 1	قَتْلِ رَابِعٍ
u'قتل رَابِعٌ':Added, #1: 1	قَتْلِ رَابِعٍ
u'قَتْلٌ رَابِعٌ':Added, #1: 1	قَتْلِ رَابِعٍ
u'قتل رَاهِبٌ':Added, #1: 1	قَتْلِ رَابِعٍ
u'قَتْلٌ رَاهِبٌ':Added, #2: 2	قَتْلِ الرَّاهِبِ
u'قتل رَاهِبٌ':Added, #2: 2	قَتْلِ الرَّاهِبِ
u'قَتْلٌ رَاهِبٌ':Added, #2: 2	قَتْلُ رَاهِبٍ
u'قَتَلَ رِجَالٌ':Predicate, #2: 2	قَتْلُ رَاهِبٍ
u'قتل رِجَالٌ':Added, #2: 2	قَتَلَ الرِّجَالَ
u'قتل رِجَالٌ':Added, #1: 1	قَتْلَ الرّجَالِ
u'قَتْلٌ رِجَالٌ':Added, #1: 1	قَتْلَ الرِّجَالِ
u'قَتْلٌ رِجَالٌ':Added, #1: 1	قَتْلَ الرّجَالِ
u'قَتَلَ رَجُلٌ':Predicate, #1: 1	قَتْلَ الرِّجَالِ
u'قَتَلَ رَجُلٌ':Predicate, #13: 13	قَتَلَ رَجُلاً
u'قَتَلَ رَجُلٌ':Subject, #4: 4	قَتَلَ الرَّجُلَ
u'قَتَلَ رَجُلٌ':Subject, #34: 34	قَتَلَ رَجُلٌ
u'قتل رَجُلٌ':Added, #9: 9	قَتَلَ الرَّجُلُ
u'قَتْلٌ رَجُلٌ':Added, #1: 1	قَتْلَ الرَّجُلِ
u'قتل رَجُلٌ':Added, #1: 1	قَتْلَ الرَّجُلِ
u'قَتْلٌ رَجُلٌ':Added, #21: 21	قَتْلِ رَجُلٍ
u'قتل رَجُلٌ':Added, #21: 21	قَتْلِ رَجُلٍ
u'قَتْلٌ رَجُلٌ':Added, #2: 2	قَتْلِ الرَّجُلِ
u'قتل رَجُلٌ':Added, #2: 2	قَتْلِ الرَّجُلِ
u'قَتْلٌ رَجُلٌ':Added, #2: 2	قَتْلَ رَجُلٍ
u'قتل رِدْء':Added, #2: 2	قَتْلَ رَجُلٍ
u'قَتْلٌ رِدْء':Added, #1: 1	قَتْلِ الرِّدْءِ
u'قتل رِدَّةٌ':Added, #1: 1	قَتْلِ الرِّدْءِ
u'قَتْلٌ رِدَّةٌ':Added, #1: 1	قَتْلَ الرِّدَّةِ
u'قتل رِدَّةٌ':Added, #1: 1	قَتْلَ الرِّدَّةِ
u'قَتْلٌ رِدَّةٌ':Added, #1: 1	قَتْلُ رِدَّةٍ
u'قتل رِدَّةٌ':Added, #1: 1	قَتْلُ رِدَّةٍ
u'قَتْلٌ رِدَّةٌ':Added, #4: 4	قَتْلِ الرِّدَّةِ
u'قتل رِدَّةٌ':Added, #4: 4	قَتْلِ الرِّدَّةِ
u'قَتْلٌ رِدَّةٌ':Added, #5: 5	قَتْلُ الرِّدَّةِ
u'قَتَلَ رَسُولٌ':Subject, #5: 5	قَتْلُ الرِّدَّةِ
u'قتل رَسُولٌ':Added, #6: 6	قَتَلَ رَسُولُ
u'قتل رَسُولٌ':Added, #1: 1	قَتْلَ الرّسُولِ
u'قَتْلٌ رَسُولٌ':Added, #1: 1	قَتْلُ الرّسُولِ
u'قَتْلٌ رَسُولٌ':Added, #1: 1	قَتْلَ الرّسُولِ
u'قتل رَسُولٌ':Added, #1: 1	قَتْلُ الرّسُولِ
u'قَتْلٌ رَسُولٌ':Added, #1: 1	قَتْلَ رَسُولِ
u'قتل رَسُولٌ':Added, #1: 1	قَتْلَ رَسُولِ
u'قَتْلٌ رَسُولٌ':Added, #2: 2	قَتْلِ الرّسُولِ
u'قتل رَقَبَةٌ':Added, #2: 2	قَتْلِ الرّسُولِ
u'قَتْلٌ رَقَبَةٌ':Added, #2: 2	قَتْلِ رَقَبَةٍ
u'قَتَلَ رَقيقٌ':Predicate, #2: 2	قَتْلِ رَقَبَةٍ
u'قَتَلَ رَقيق':Predicate, #2: 2	قَتَلَ رَقِيقَ
u'قَتَلَ رَقيقٌ':Subject, #2: 2	قَتَلَ رَقِيقَ
u'قَتَلَ رَقيق':Subject, #2: 2	قَتَلَ رَقِيقٌ
u'قتل رَقيقٌ':Added, #2: 2	قَتَلَ رَقِيقٌ
u'قتل رَقيق':Added, #1: 1	قَتْلَ رَقِيقِهِ
u'قَتْلٌ رَقيقٌ':Added, #1: 1	قَتْلَ رَقِيقِهِ
u'قَتْلٌ رَقيق':Added, #1: 1	قَتْلَ رَقِيقِهِ
u'قتل رَقيقٌ':Added, #1: 1	قَتْلَ رَقِيقِهِ
u'قتل رَقيق':Added, #2: 2	قَتْلِ الرَّقِيقِ
u'قَتْلٌ رَقيقٌ':Added, #2: 2	قَتْلِ الرَّقِيقِ
u'قَتْلٌ رَقيق':Added, #2: 2	قَتْلِ الرَّقِيقِ
u'قتل رهائن':Added, #2: 2	قَتْلِ الرَّقِيقِ
u'قتل رهائن':Added, #1: 1	قَتْلَ الرّهَائِنِ
u'قَتْلٌ رهائن':Added, #1: 1	قَتْلُ الرَّهَائِنِ
u'قَتْلٌ رهائن':Added, #1: 1	قَتْلَ الرّهَائِنِ
u'قتل رَهائِنُ':Added, #1: 1	قَتْلُ الرَّهَائِنِ
u'قتل رَهائِنُ':Added, #1: 1	قَتْلَ الرّهَائِنِ
u'قَتْلٌ رَهائِنُ':Added, #1: 1	قَتْلُ الرَّهَائِنِ
u'قَتْلٌ رَهائِنُ':Added, #1: 1	قَتْلَ الرّهَائِنِ
u'قتل رُهْبانٌ':Added, #1: 1	قَتْلُ الرَّهَائِنِ
u'قتل رُهْبَانٌ':Added, #1: 1	قَتْلِ الرُّهْبَانِ
u'قَتْلٌ رُهْبانٌ':Added, #1: 1	قَتْلِ الرُّهْبَانِ
u'قَتْلٌ رُهْبَانٌ':Added, #1: 1	قَتْلِ الرُّهْبَانِ
u'قتل رُهْبانٌ':Added, #1: 1	قَتْلِ الرُّهْبَانِ
u'قتل رُهْبَانٌ':Added, #2: 2	قَتْلُ الرُّهْبَانِ
u'قَتْلٌ رُهْبانٌ':Added, #2: 2	قَتْلُ الرُّهْبَانِ
u'قَتْلٌ رُهْبَانٌ':Added, #2: 2	قَتْلُ الرُّهْبَانِ
u'قتل زُنْبورٌ':Added, #2: 2	قَتْلُ الرُّهْبَانِ
u'قَتْلٌ زُنْبورٌ':Added, #2: 2	قَتْلُ الزُّنْبُورِ
u'قتل زِنْديقٌ':Added, #2: 2	قَتْلُ الزُّنْبُورِ
u'قَتْلٌ زِنْديقٌ':Added, #1: 1	قَتْلِ الزِّنْدِيقِ
u'قَتَلَ زَوْجٌ':Predicate, #1: 1	قَتْلِ الزِّنْدِيقِ
u'قَتَلَ زَوْجٌ':Subject, #1: 1	قَتَلَ زَوْجَ
u'قتل زَوْجَةٌ':Added, #1: 1	قَتَلَ الزَّوْجُ
u'قَتْلٌ زَوْجَةٌ':Added, #1: 1	قَتْلِ زَوْجَتِهِ
u'قَتَلَ زَيْدٌ':Predicate, #1: 1	قَتْلِ زَوْجَتِهِ
u'قَتَلَ زَيْدٌ':Subject, #2: 2	قَتَلَ زَيْدَ
u'قتل زَيْدٌ':Added, #1: 1	قَتَلَ زَيْدٌ
u'قَتْلٌ زَيْدٌ':Added, #2: 2	قَتْلُ زَيْدِ
u'قتل زَيْدٌ':Added, #2: 2	قَتْلُ زَيْدِ
u'قَتْلٌ زَيْدٌ':Added, #4: 4	قَتْلِ زَيْدٍ
u'قتل سابّ':Added, #4: 4	قَتْلِ زَيْدٍ
u'قتل سابّ':Added, #1: 1	قَتْلَ السَّابِّ
u'قَتْلٌ سابّ':Added, #1: 1	قَتْلُ السَّابِّ
u'قَتْلٌ سابّ':Added, #1: 1	قَتْلَ السَّابِّ
u'قتل سَاحِرٌ':Added, #1: 1	قَتْلُ السَّابِّ
u'قتل سَاحِرٌ':Added, #1: 1	قَتْلَ السَّاحِرِ
u'قَتْلٌ سَاحِرٌ':Added, #1: 1	قَتْلِ السَّاحِرِ
u'قَتْلٌ سَاحِرٌ':Added, #1: 1	قَتْلَ السَّاحِرِ
u'قتل سَالِمٌ':Added, #1: 1	قَتْلِ السَّاحِرِ
u'قَتْلٌ سَالِمٌ':Added, #2: 2	قَتْلِ سَالِمٍ
u'قَتَلَ سِباعٌ':Predicate, #2: 2	قَتْلِ سَالِمٍ
u'قتل سِباعٌ':Added, #1: 1	قَتَلَ سِبَاعَ
u'قتل سِباعٌ':Added, #1: 1	قَتْلَ السِّبَاعِ
u'قَتْلٌ سِباعٌ':Added, #1: 1	قَتْلُ السِّبَاعِ
u'قَتْلٌ سِباعٌ':Added, #1: 1	قَتْلَ السِّبَاعِ
u'قتل سَبُعٌ':Added, #1: 1	قَتْلُ السِّبَاعِ
u'قَتْلٌ سَبُعٌ':Added, #1: 1	قَتْلُ السَّبُعِ
u'قتل سِنَّوْرٌ':Added, #1: 1	قَتْلُ السَّبُعِ
u'قَتْلٌ سِنَّوْرٌ':Added, #1: 1	قَتْلُ السِّنَّوْرِ
u'قَتَلَ سَهْمٌ':Subject, #1: 1	قَتْلُ السِّنَّوْرِ
u'قَتَلَ سَيِّدٌ':Subject, #4: 4	قَتَلَ السَّهْمُ
u'قتل سَيِّدٌ':Added, #5: 5	قَتَلَ السَّيِّدُ
u'قَتْلٌ سَيِّدٌ':Added, #1: 1	قَتْلَ السَّيِّدِ
u'قتل سَيْفٌ':Added, #1: 1	قَتْلَ السَّيِّدِ
u'قَتْلٌ سَيْفٌ':Added, #1: 1	قَتْلَ السَّيْفِ
u'قتل شَارِبٌ':Added, #1: 1	قَتْلَ السَّيْفِ
u'قَتْلٌ شَارِبٌ':Added, #1: 1	قَتْلُ شَارِبِ
u'قتل شَارِبٌ':Added, #1: 1	قَتْلُ شَارِبِ
u'قَتْلٌ شَارِبٌ':Added, #2: 2	قَتْلَ شَارِبِ
u'قَتَلَ شَاهِدٌ':Subject, #2: 2	قَتْلَ شَارِبِ
u'قَتَلَ شَخْصٌ':Subject, #1: 1	قَتَلَ الشَّاهِدُ
u'قتل شَخْصٌ':Added, #1: 1	قَتَلَ شَخْصٌ
u'قتل شَخْصٌ':Added, #1: 1	قَتْلَ شَخْصٍ
u'قتل شَخْصٌ':Added, #1: 1	قَتْلُ شَخْصٍ
u'قَتْلٌ شَخْصٌ':Added, #1: 1	قَتْلِ شَخْصٍ
u'قَتْلٌ شَخْصٌ':Added, #1: 1	قَتْلَ شَخْصٍ
u'قَتْلٌ شَخْصٌ':Added, #1: 1	قَتْلُ شَخْصٍ
u'قتل شَرِيكٌ':Added, #1: 1	قَتْلِ شَخْصٍ
u'قَتْلٌ شَرِيكٌ':Added, #1: 1	قَتْلُ شَرِيكِ
u'قتل شَهِيدٌ':Added, #1: 1	قَتْلُ شَرِيكِ
u'قَتْلٌ شَهِيدٌ':Added, #1: 1	قَتْلَ الشَّهِيدِ
u'قتل شَيْءٌ':Added, #1: 1	قَتْلَ الشَّهِيدِ
u'قتل شَيْءٌ':Added, #1: 1	قَتْلُ شَيْءٍ
u'قَتْلٌ شَيْءٌ':Added, #1: 1	قَتْلِ شَيْءٍ
u'قَتْلٌ شَيْءٌ':Added, #1: 1	قَتْلُ شَيْءٍ
u'قتل شُيُوخٌ':Added, #1: 1	قَتْلِ شَيْءٍ
u'قَتْلٌ شُيُوخٌ':Added, #2: 2	قَتْلِ الشُّيُوخِ
u'قَتَلَ صَاحِبٌ':Subject, #2: 2	قَتْلِ الشُّيُوخِ
u'قتل صَاحِبٌ':Added, #1: 1	قَتَلَ صَاحِبُ
u'قَتْلٌ صَاحِبٌ':Added, #5: 5	قَتْلَ صَاحِبِهِ
u'قتل صَاحِبٌ':Added, #5: 5	قَتْلَ صَاحِبِهِ
u'قَتْلٌ صَاحِبٌ':Added, #6: 6	قَتْلِ صَاحِبِهِ
u'قتل صبر':Added, #6: 6	قَتْلِ صَاحِبِهِ
u'قَتْلٌ صبر':Added, #1: 1	قَتْلِ الصَّبْرِ
u'قتل صَبْرٌ':Added, #1: 1	قَتْلِ الصَّبْرِ
u'قَتْلٌ صَبْرٌ':Added, #1: 1	قَتْلِ الصَّبْرِ
u'قَتَلَ صَبِيٌّ':Subject, #1: 1	قَتْلِ الصَّبْرِ
u'قتل صَبِيٌّ':Added, #6: 6	قَتَلَ الصَّبِيُّ
u'قتل صَبِيٌّ':Added, #1: 1	قَتْلَ الصَّبِيِّ
u'قَتْلٌ صَبِيٌّ':Added, #1: 1	قَتْلُ الصَّبِيِّ
u'قَتْلٌ صَبِيٌّ':Added, #1: 1	قَتْلَ الصَّبِيِّ
u'قتل صَبِيٌّ':Added, #1: 1	قَتْلُ الصَّبِيِّ
u'قَتْلٌ صَبِيٌّ':Added, #1: 1	قَتْلُ صَبِيٍّ
u'قتل صَبِيٌّ':Added, #1: 1	قَتْلُ صَبِيٍّ
u'قَتْلٌ صَبِيٌّ':Added, #5: 5	قَتْلِ الصَّبِيِّ
u'قتل صِبْيَانٌ':Added, #5: 5	قَتْلِ الصَّبِيِّ
u'قَتْلٌ صِبْيَانٌ':Added, #4: 4	قَتْلِ الصِّبْيَانِ
u'قَتَلَ صَحِيحٌ':Subject, #4: 4	قَتْلِ الصِّبْيَانِ
u'قتل صُرَدٌ':Added, #1: 1	قَتَلَ الصَّحِيحُ
u'قَتْلٌ صُرَدٌ':Added, #1: 1	قَتْلِ الصُّرَدِ
u'قَتَلَ صغار':Predicate, #1: 1	قَتْلِ الصُّرَدِ
u'قَتَلَ صَيْدٌ':Predicate, #1: 1	قَتَلَ صِغَارَ
u'قَتَلَ صَيْدٌ':Predicate, #14: 14	قَتَلَ الصَّيْدَ
u'قتل صَيْدٌ':Added, #3: 3	قَتَلَ صَيْدَ
u'قَتْلٌ صَيْدٌ':Added, #10: 10	قَتْلُ الصَّيْدِ
u'قتل صَيْدٌ':Added, #10: 10	قَتْلُ الصَّيْدِ
u'قَتْلٌ صَيْدٌ':Added, #18: 18	قَتْلِ صَيْدِ
u'قتل صَيْدٌ':Added, #18: 18	قَتْلِ صَيْدِ
u'قَتْلٌ صَيْدٌ':Added, #19: 19	قَتْلِ صَيْدٍ
u'قتل صَيْدٌ':Added, #19: 19	قَتْلِ صَيْدٍ
u'قتل صَيْدٌ':Added, #1: 1	قَتْلَ صَيْدٍ
u'قَتْلٌ صَيْدٌ':Added, #1: 1	قَتْلُ صَيْدٍ
u'قَتْلٌ صَيْدٌ':Added, #1: 1	قَتْلَ صَيْدٍ
u'قتل صَيْدٌ':Added, #1: 1	قَتْلُ صَيْدٍ
u'قَتْلٌ صَيْدٌ':Added, #2: 2	قَتْلُ صَيْدِ
u'قتل صَيْدٌ':Added, #2: 2	قَتْلُ صَيْدِ
u'قَتْلٌ صَيْدٌ':Added, #38: 38	قَتْلِ الصَّيْدِ
u'قتل صَيْدٌ':Added, #38: 38	قَتْلِ الصَّيْدِ
u'قَتْلٌ صَيْدٌ':Added, #6: 6	قَتْلَ الصَّيْدِ
u'قتل ضرار':Added, #6: 6	قَتْلَ الصَّيْدِ
u'قَتْلٌ ضرار':Added, #1: 1	قَتْلَ ضِرَارِ
u'قتل ضعفاء':Added, #1: 1	قَتْلَ ضِرَارِ
u'قَتْلٌ ضعفاء':Added, #1: 1	قَتْلِ الضّعَفَاءِ
u'قتل ضَفَادِعُ':Added, #1: 1	قَتْلِ الضّعَفَاءِ
u'قَتْلٌ ضَفَادِعُ':Added, #4: 4	قَتْلُ الضَّفَادِعِ
u'قتل طَالِبٌ':Added, #4: 4	قَتْلُ الضَّفَادِعِ
u'قَتْلٌ طَالِبٌ':Added, #1: 1	قَتْلِ الطَّالِبِ
u'قتل طَالِبٌ':Added, #1: 1	قَتْلِ الطَّالِبِ
u'قَتْلٌ طَالِبٌ':Added, #1: 1	قَتْلُ طَالِبِهِ
u'قتل طَائِعٌ':Added, #1: 1	قَتْلُ طَالِبِهِ
u'قَتْلٌ طَائِعٌ':Added, #1: 1	قَتْلُ طَائِعٍ
u'قتل طَائِفٌ':Added, #1: 1	قَتْلُ طَائِعٍ
u'قَتْلٌ طَائِفٌ':Added, #1: 1	قَتْلِ طَائِفَةٍ
u'قتل طِفْلٌ':Added, #1: 1	قَتْلِ طَائِفَةٍ
u'قَتْلٌ طِفْلٌ':Added, #1: 1	قَتْلِ الطِّفْلِ
u'قتل عَادٌ':Added, #1: 1	قَتْلِ الطِّفْلِ
u'قَتْلٌ عَادٌ':Added, #6: 6	قَتْلَ عَادٍ
u'قَتَلَ عَادِلٌ':Predicate, #6: 6	قَتْلَ عَادٍ
u'قَتَلَ عَادِلٌ':Subject, #2: 2	قَتَلَ الْعَادِلَ
u'قَتَلَ عَادِلٌ':Subject, #2: 2	قَتَلَ الْعَادِلُ
u'قتل عَادِلٌ':Added, #4: 4	قَتَلَ عَادِلٌ
u'قتل عَادِلٌ':Added, #1: 1	قَتْلَ الْعَادِلِ
u'قَتْلٌ عَادِلٌ':Added, #1: 1	قَتْلُ الْعَادِلِ
u'قَتْلٌ عَادِلٌ':Added, #1: 1	قَتْلَ الْعَادِلِ
u'قَتَلَ عَاصِي':Predicate, #1: 1	قَتْلُ الْعَادِلِ
u'قَتَلَ عَامٌ':Predicate, #1: 1	قَتَلَ الْعَاصِيَ
u'قتل عِبَادٌ':Added, #1: 1	قَتَلَ عَامَ
u'قَتْلٌ عِبَادٌ':Added, #1: 1	قَتْلُ عِبَادِ
u'قَتَلَ عَبْدٌ':Predicate, #1: 1	قَتْلُ عِبَادِ
u'قَتَلَ عَبْدٌ':Predicate, #10: 10	قَتَلَ عَبْدَ
u'قَتَلَ عَبْدٌ':Subject, #7: 7	قَتَلَ الْعَبْدَ
u'قَتَلَ عَبْدٌ':Subject, #18: 18	قَتَلَ عَبْدٌ
u'قَتَلَ عَبْدٌ':Subject, #3: 3	قَتَلَ عَبْدُ
u'قَتَلَ عَبْدٌ':Subject, #3: 3	قَتَلَ عَبْدُهُ
u'قتل عَبْدٌ':Added, #53: 53	قَتَلَ الْعَبْدُ
u'قَتْلٌ عَبْدٌ':Added, #1: 1	قَتْلَ عَبْدِ
u'قتل عَبْدٌ':Added, #1: 1	قَتْلَ عَبْدِ
u'قَتْلٌ عَبْدٌ':Added, #3: 3	قَتْلُ الْعَبْدِ
u'قتل عَبْدٌ':Added, #3: 3	قَتْلُ الْعَبْدِ
u'قتل عَبْدٌ':Added, #3: 3	قَتْلِ عَبْدٍ
u'قَتْلٌ عَبْدٌ':Added, #3: 3	قَتْلِ عَبْدِ
u'قَتْلٌ عَبْدٌ':Added, #3: 3	قَتْلِ عَبْدٍ
u'قتل عَبْدٌ':Added, #3: 3	قَتْلِ عَبْدِ
u'قَتْلٌ عَبْدٌ':Added, #7: 7	قَتْلِ عَبْدِهِ
u'قتل عَبْدٌ':Added, #7: 7	قَتْلِ عَبْدِهِ
u'قَتْلٌ عَبْدٌ':Added, #8: 8	قَتْلِ الْعَبْدِ
u'قتل عُدَاةٌ':Added, #8: 8	قَتْلِ الْعَبْدِ
u'قَتْلٌ عُدَاةٌ':Added, #2: 2	قَتْلِ الْعُدَاةِ
u'قتل عَدُوٌّ':Added, #2: 2	قَتْلِ الْعُدَاةِ
u'قَتْلٌ عَدُوٌّ':Added, #1: 1	قَتْلُ الْعَدُوِّ
u'قتل عَدُوٌّ':Added, #1: 1	قَتْلُ الْعَدُوِّ
u'قَتْلٌ عَدُوٌّ':Added, #2: 2	قَتْلِ الْعَدُوِّ
u'قَتَلَ عُرْوَةٌ':Predicate, #2: 2	قَتْلِ الْعَدُوِّ
u'قَتَلَ عقبة':Predicate, #1: 1	قَتَلَ عُرْوَةَ
u'قَتَلَ عُقْبَةٌ':Predicate, #3: 3	قَتَلَ عُقْبَةَ
u'قتل عَقْرَبٌ':Added, #3: 3	قَتَلَ عُقْبَةَ
u'قَتْلٌ عَقْرَبٌ':Added, #2: 2	قَتْلُ الْعَقْرَبِ
u'قَتَلَ عُكّاشَة':Subject, #2: 2	قَتْلُ الْعَقْرَبِ
u'قتل عَلاءٌ':Added, #1: 1	قَتَلَ عُكّاشَةُ
u'قَتْلٌ عَلاءٌ':Added, #1: 1	قَتْلُ الْعَلَاءِ
u'قَتَلَ عَلِيٌّ':Predicate, #1: 1	قَتْلُ الْعَلَاءِ
u'قَتَلَ عَلِيٌّ':Subject, #1: 1	قَتَلَ عَلِيَّ
u'قتل عَلِيٌّ':Added, #1: 1	قَتَلَ عَلِيٌّ
u'قتل عَلِيٌّ':Added, #1: 1	قَتْلَ عَلِيٍّ
u'قَتْلٌ عَلِيٌّ':Added, #1: 1	قَتْلُ عَلِيٍّ
u'قَتْلٌ عَلِيٌّ':Added, #1: 1	قَتْلَ عَلِيٍّ
u'قَتَلَ عَمْدٌ':Predicate, #1: 1	قَتْلُ عَلِيٍّ
u'قتل عَمْدٌ':Added, #1: 1	قَتَلَ الْعَمْدَ
u'قتل عَمْدٌ':Added, #1: 1	قَتْلُ عَمْدٍ
u'قَتْلٌ عَمْدٌ':Added, #1: 1	قَتْلِ عَمْدٍ
u'قَتْلٌ عَمْدٌ':Added, #1: 1	قَتْلٍ عَمْدٍ
u'قَتْلٌ عَمْدٌ':Added, #1: 1	قَتْلُ عَمْدٍ
u'قتل عَمْدٌ':Added, #1: 1	قَتْلِ عَمْدٍ
u'قَتْلٌ عَمْدٌ':Added, #27: 27	قَتْلِ الْعَمْدِ
u'قتل عَمْدٌ':Added, #27: 27	قَتْلِ الْعَمْدِ
u'قتل عَمْدٌ':Added, #3: 3	قَتْلَ الْعَمْدِ
u'قَتْلٌ عَمْدٌ':Added, #3: 3	قَتْلُ الْعَمْدِ
u'قَتْلٌ عَمْدٌ':Added, #3: 3	قَتْلَ الْعَمْدِ
u'قتل عَمْدٌ':Added, #3: 3	قَتْلُ الْعَمْدِ
u'قَتْلٌ عَمْدٌ':Added, #4: 4	قَتْلَ عَمْدٍ
u'قَتَلَ عُمَرٌ':Subject, #4: 4	قَتْلَ عَمْدٍ
u'قَتَلَ عند':Predicate, #1: 1	قَتَلَ عُمَرُ
u'قتل عَنْكَبُوتٌ':Added, #3: 3	قَتَلَ عِنْدَ
u'قَتْلٌ عَنْكَبُوتٌ':Added, #1: 1	قَتْلُ الْعَنْكَبُوتِ
u'قَتَلَ غَاصِبٌ':Predicate, #1: 1	قَتْلُ الْعَنْكَبُوتِ
u'قتل غُرَابٌ':Added, #1: 1	قَتَلَ الْغَاصِبَ
u'قَتْلٌ غُرَابٌ':Added, #1: 1	قَتْلُ غُرَابِ
u'قتل غُرَابٌ':Added, #1: 1	قَتْلُ غُرَابِ
u'قَتْلٌ غُرَابٌ':Added, #2: 2	قَتْلِ الْغُرَابِ
u'قَتَلَ غَرِيمٌ':Subject, #2: 2	قَتْلِ الْغُرَابِ
u'قَتَلَ غير':Predicate, #1: 1	قَتَلَ الْغَرِيمُ
u'قَتَلَ غَيْرٌ':Predicate, #10: 10	قَتَلَ غَيْرَ
u'قتل غير':Added, #10: 10	قَتَلَ غَيْرَ
u'قتل غَيْرٌ':Added, #1: 1	قَتْلِ الْغَيْرِ
u'قَتْلٌ غير':Added, #1: 1	قَتْلِ الْغَيْرِ
u'قَتْلٌ غَيْرٌ':Added, #1: 1	قَتْلِ الْغَيْرِ
u'قتل غير':Added, #1: 1	قَتْلِ الْغَيْرِ
u'قتل غير':Added, #1: 1	قَتْلَ غَيْرِ
u'قتل غَيْرٌ':Added, #1: 1	قَتْلُ غَيْرِ
u'قتل غَيْرٌ':Added, #1: 1	قَتْلَ غَيْرِ
u'قَتْلٌ غير':Added, #1: 1	قَتْلُ غَيْرِ
u'قَتْلٌ غير':Added, #1: 1	قَتْلَ غَيْرِ
u'قَتْلٌ غَيْرٌ':Added, #1: 1	قَتْلُ غَيْرِ
u'قَتْلٌ غَيْرٌ':Added, #1: 1	قَتْلَ غَيْرِ
u'قتل غير':Added, #1: 1	قَتْلُ غَيْرِ
u'قتل غير':Added, #1: 1	قَتْلَ غَيْرِهِ
u'قتل غَيْرٌ':Added, #1: 1	قَتْلُ غَيْرِهِ
u'قتل غَيْرٌ':Added, #1: 1	قَتْلَ غَيْرِهِ
u'قَتْلٌ غير':Added, #1: 1	قَتْلُ غَيْرِهِ
u'قَتْلٌ غير':Added, #1: 1	قَتْلَ غَيْرِهِ
u'قَتْلٌ غَيْرٌ':Added, #1: 1	قَتْلُ غَيْرِهِ
u'قَتْلٌ غَيْرٌ':Added, #1: 1	قَتْلَ غَيْرِهِ
u'قتل غير':Added, #1: 1	قَتْلُ غَيْرِهِ
u'قتل غَيْرٌ':Added, #3: 3	قَتْلِ غَيْرِ
u'قَتْلٌ غير':Added, #3: 3	قَتْلِ غَيْرِ
u'قَتْلٌ غَيْرٌ':Added, #3: 3	قَتْلِ غَيْرِ
u'قتل غير':Added, #3: 3	قَتْلِ غَيْرِ
u'قتل غَيْرٌ':Added, #9: 9	قَتْلِ غَيْرِهِ
u'قَتْلٌ غير':Added, #9: 9	قَتْلِ غَيْرِهِ
u'قَتْلٌ غَيْرٌ':Added, #9: 9	قَتْلِ غَيْرِهِ
u'قتل غِيلَةٌ':Added, #9: 9	قَتْلِ غَيْرِهِ
u'قَتْلٌ غِيلَةٌ':Added, #1: 1	قَتْلِ غِيلَةٍ
u'قتل غِيلَةٌ':Added, #1: 1	قَتْلِ غِيلَةٍ
u'قَتْلٌ غِيلَةٌ':Added, #2: 2	قَتْلُ الْغِيلَةِ
u'قتل غِيلَةٌ':Added, #2: 2	قَتْلُ الْغِيلَةِ
u'قَتْلٌ غِيلَةٌ':Added, #2: 2	قَتْلَ غِيلَةٍ
u'قتل غِيلَةٌ':Added, #2: 2	قَتْلَ غِيلَةٍ
u'قَتْلٌ غِيلَةٌ':Added, #6: 6	قَتْلِ الْغِيلَةِ
u'قتل فَأْرٌ':Added, #6: 6	قَتْلِ الْغِيلَةِ
u'قَتْلٌ فَأْرٌ':Added, #1: 1	قَتْلُ الْفَأْرَةِ
u'قتل فَاسِقٌ':Added, #1: 1	قَتْلُ الْفَأْرَةِ
u'قَتْلٌ فَاسِقٌ':Added, #1: 1	قَتْلُ فَاسِقٍ
u'قتل فَاعِلٌ':Added, #1: 1	قَتْلُ فَاسِقٍ
u'قتل فَاعِلٌ':Added, #1: 1	قَتْلُ فَاعِلِ
u'قَتْلٌ فَاعِلٌ':Added, #1: 1	قَتْلِ فَاعِلِ
u'قَتْلٌ فَاعِلٌ':Added, #1: 1	قَتْلُ فَاعِلِ
u'قَتَلَ فَرْخٌ':Predicate, #1: 1	قَتْلِ فَاعِلِ
u'قَتَلَ فَرَسٌ':Predicate, #1: 1	قَتَلَ فَرْخَ
u'قتل فَرَسٌ':Added, #1: 1	قَتَلَ فَرَسَ
u'قَتْلٌ فَرَسٌ':Added, #1: 1	قَتْلِ الْفَرَسِ
u'قَتَلَ فَلًا':Predicate, #1: 1	قَتْلِ الْفَرَسِ
u'قَتَلَ فلان':Predicate, #1: 1	قَتَلَ فَلاَ
u'قَتَلَ فلان':Predicate, #1: 1	قَتَلَ عُثْمَانَ
u'قَتَلَ فلان':Predicate, #1: 1	قَتَلَ مُعَاوِيَةَ
u'قَتَلَ فلان':Predicate, #2: 2	قَتَلَ حَمْزَةَ
u'قَتَلَ فلان':Subject, #3: 3	قَتَلَ عُبَيْدَةَ
u'قتل فلان':Added, #2: 2	قَتَلَ عُثْمَانُ
u'قَتْلٌ فلان':Added, #1: 1	قَتْلُ الْعَامِرِيّيْنِ
u'قتل فلان':Added, #1: 1	قَتْلُ الْعَامِرِيّيْنِ
u'قَتْلٌ فلان':Added, #1: 1	قَتْلَ بِلَالٍ
u'قتل فلان':Added, #1: 1	قَتْلَ بِلَالٍ
u'قَتْلٌ فلان':Added, #1: 1	قَتْلِ جَرَادَتَيْنِ
u'قتل فلان':Added, #1: 1	قَتْلِ جَرَادَتَيْنِ
u'قَتْلٌ فلان':Added, #1: 1	قَتْلُ جَعْفَرٍ
u'قتل فُلاَنٌ':Added, #1: 1	قَتْلُ جَعْفَرٍ
u'قَتْلٌ فُلاَنٌ':Added, #2: 2	قَتْلُ فُلَانٍ
u'قتل فَوَاسِقُ':Added, #2: 2	قَتْلُ فُلَانٍ
u'قَتْلٌ فَوَاسِقُ':Added, #4: 4	قَتْلِ الْفَوَاسِقِ
u'قتل فِئَةٌ':Added, #4: 4	قَتْلِ الْفَوَاسِقِ
u'قَتْلٌ فِئَةٌ':Added, #1: 1	قَتْلُ الْفِئَةِ
u'قَتَلَ قَاتِلٌ':Predicate, #1: 1	قَتْلُ الْفِئَةِ
u'قتل قَاتِلٌ':Added, #6: 6	قَتَلَ الْقَاتِلَ
u'قتل قَاتِلٌ':Added, #1: 1	قَتْلَ الْقَاتِلِ
u'قَتْلٌ قَاتِلٌ':Added, #1: 1	قَتْلِ الْقَاتِلِ
u'قَتْلٌ قَاتِلٌ':Added, #1: 1	قَتْلَ الْقَاتِلِ
u'قتل قَاتِلٌ':Added, #1: 1	قَتْلِ الْقَاتِلِ
u'قَتْلٌ قَاتِلٌ':Added, #1: 1	قَتْلِ قَاتِلِهِ
u'قتل قَاتِلٌ':Added, #1: 1	قَتْلِ قَاتِلِهِ
u'قَتْلٌ قَاتِلٌ':Added, #2: 2	قَتْلُ قَاتِلِهِ
u'قتل قَاتِلٌ':Added, #2: 2	قَتْلُ قَاتِلِهِ
u'قَتْلٌ قَاتِلٌ':Added, #3: 3	قَتْلُ الْقَاتِلِ
u'قَتَلَ قَاطِعٌ':Predicate, #3: 3	قَتْلُ الْقَاتِلِ
u'قَتَلَ قَاطِعٌ':Predicate, #1: 1	قَتَلَ الْقَاطِعَ
u'قَتَلَ قَاطِعٌ':Subject, #1: 1	قَتَلَ قَاطِعَ
u'قَتَلَ قَاطِعٌ':Subject, #1: 1	قَتَلَ الْقَاطِعُ
u'قتل قَاطِعٌ':Added, #1: 1	قَتَلَ قَاطِعُ
u'قَتْلٌ قَاطِعٌ':Added, #1: 1	قَتْلَ قَاطِعِ
u'قتل قَاطِعٌ':Added, #1: 1	قَتْلَ قَاطِعِ
u'قَتْلٌ قَاطِعٌ':Added, #2: 2	قَتْلِ الْقَاطِعِ
u'قَتَلَ قتل':Predicate, #2: 2	قَتْلِ الْقَاطِعِ
u'قتل قُرَادٌ':Added, #5: 5	قَتَلَ قُتِلَ
u'قَتْلٌ قُرَادٌ':Added, #1: 1	قَتْلُ الْقُرَادِ
u'قتل قَرِيبٌ':Added, #1: 1	قَتْلُ الْقُرَادِ
u'قَتْلٌ قَرِيبٌ':Added, #1: 1	قَتْلُ الْقَرِيبِ
u'قتل قصاص':Added, #1: 1	قَتْلُ الْقَرِيبِ
u'قَتْلٌ قصاص':Added, #1: 1	قَتْلِ الْقِصَاصِ
u'قتل قِصَاصٌ':Added, #1: 1	قَتْلِ الْقِصَاصِ
u'قَتْلٌ قِصَاصٌ':Added, #1: 1	قَتْلِ الْقِصَاصِ
u'قتل قصاص':Added, #1: 1	قَتْلِ الْقِصَاصِ
u'قتل قصاص':Added, #1: 1	قَتْلَ قِصَاصٍ
u'قتل قصاص':Added, #1: 1	قَتْلُ قِصَاصٍ
u'قَتْلٌ قصاص':Added, #1: 1	قَتْلِ قِصَاصٍ
u'قَتْلٌ قصاص':Added, #1: 1	قَتْلَ قِصَاصٍ
u'قَتْلٌ قصاص':Added, #1: 1	قَتْلُ قِصَاصٍ
u'قتل قِصَاصٌ':Added, #1: 1	قَتْلِ قِصَاصٍ
u'قتل قِصَاصٌ':Added, #1: 1	قَتْلَ قِصَاصٍ
u'قتل قِصَاصٌ':Added, #1: 1	قَتْلُ قِصَاصٍ
u'قَتْلٌ قِصَاصٌ':Added, #1: 1	قَتْلِ قِصَاصٍ
u'قَتْلٌ قِصَاصٌ':Added, #1: 1	قَتْلَ قِصَاصٍ
u'قَتْلٌ قِصَاصٌ':Added, #1: 1	قَتْلُ قِصَاصٍ
u'قتل قصاص':Added, #1: 1	قَتْلِ قِصَاصٍ
u'قَتْلٌ قصاص':Added, #2: 2	قَتْلَ الْقِصَاصِ
u'قتل قِصَاصٌ':Added, #2: 2	قَتْلَ الْقِصَاصِ
u'قَتْلٌ قِصَاصٌ':Added, #2: 2	قَتْلَ الْقِصَاصِ
u'قتل قصاص':Added, #2: 2	قَتْلَ الْقِصَاصِ
u'قَتْلٌ قصاص':Added, #3: 3	قَتْلُ الْقِصَاصِ
u'قتل قِصَاصٌ':Added, #3: 3	قَتْلُ الْقِصَاصِ
u'قَتْلٌ قِصَاصٌ':Added, #3: 3	قَتْلُ الْقِصَاصِ
u'قَتَلَ قَمْلٌ':Predicate, #3: 3	قَتْلُ الْقِصَاصِ
u'قتل قَمْلٌ':Added, #1: 1	قَتَلَ الْقَمْلَ
u'قَتْلٌ قَمْلٌ':Added, #3: 3	قَتْلُ الْقَمْلِ
u'قتل قَمْلٌ':Added, #3: 3	قَتْلُ الْقَمْلِ
u'قَتْلٌ قَمْلٌ':Added, #4: 4	قَتْلِ الْقَمْلِ
u'قَتَلَ قَمْلَةٌ':Predicate, #4: 4	قَتْلِ الْقَمْلِ
u'قتل قَمْلَةٌ':Added, #4: 4	قَتَلَ الْقَمْلَةَ
u'قتل قَمْلَةٌ':Added, #1: 1	قَتْلُ قَمْلَةٍ
u'قَتْلٌ قَمْلَةٌ':Added, #1: 1	قَتْلِ قَمْلَةٍ
u'قَتْلٌ قَمْلَةٌ':Added, #1: 1	قَتْلُ قَمْلَةٍ
u'قتل قَمْلَةٌ':Added, #1: 1	قَتْلِ قَمْلَةٍ
u'قَتْلٌ قَمْلَةٌ':Added, #4: 4	قَتْلُ الْقَمْلَةِ
u'قتل قَمْلَةٌ':Added, #4: 4	قَتْلُ الْقَمْلَةِ
u'قَتْلٌ قَمْلَةٌ':Added, #5: 5	قَتْلِ الْقَمْلَةِ
u'قَتَلَ قُنُوطٌ':Subject, #5: 5	قَتْلِ الْقَمْلَةِ
u'قتل قَوْمٌ':Added, #1: 1	قَتَلَ الْقُنُوطُ
u'قَتْلٌ قَوْمٌ':Added, #1: 1	قَتْلِ قَوْمٍ
u'قَتَلَ كَافِرٌ':Subject, #1: 1	قَتْلِ قَوْمٍ
u'قَتَلَ كَافِرٌ':Subject, #2: 2	قَتَلَ الْكَافِرُ
u'قتل كَافِرٌ':Added, #2: 2	قَتَلَ كَافِرٌ
u'قَتْلٌ كَافِرٌ':Added, #10: 10	قَتْلِ كَافِرٍ
u'قتل كَافِرٌ':Added, #10: 10	قَتْلِ كَافِرٍ
u'قَتْلٌ كَافِرٌ':Added, #2: 2	قَتْلُ الْكَافِرِ
u'قتل كَافِرٌ':Added, #2: 2	قَتْلُ الْكَافِرِ
u'قَتْلٌ كَافِرٌ':Added, #2: 2	قَتْلَ كَافِرٍ
u'قتل كَافِرٌ':Added, #2: 2	قَتْلَ كَافِرٍ
u'قَتْلٌ كَافِرٌ':Added, #6: 6	قَتْلِ الْكَافِرِ
u'قَتَلَ كَثِيرٌ':Predicate, #6: 6	قَتْلِ الْكَافِرِ
u'قَتَلَ كَثِيرٌ':Subject, #1: 1	قَتَلَ كَثِيرَ
u'قتل كَعْبٌ':Added, #1: 1	قَتَلَ كَثِيرُهُ
u'قَتْلٌ كَعْبٌ':Added, #2: 2	قَتْلَ كَعْبِ
u'قتل كَعْبٌ':Added, #2: 2	قَتْلَ كَعْبِ
u'قَتْلٌ كَعْبٌ':Added, #3: 3	قَتْلِ كَعْبِ
u'قتل كُفَّارٌ':Added, #3: 3	قَتْلِ كَعْبِ
u'قَتْلٌ كُفَّارٌ':Added, #1: 1	قَتْلِ الْكُفَّارِ
u'قتل كُفْرٌ':Added, #1: 1	قَتْلِ الْكُفَّارِ
u'قَتْلٌ كُفْرٌ':Added, #1: 1	قَتْلَ كُفْرٍ
u'قتل كلاب':Added, #1: 1	قَتْلَ كُفْرٍ
u'قَتْلٌ كلاب':Added, #1: 1	قَتْلِ الْكِلاَبِ
u'قتل كِلاَبٌ':Added, #1: 1	قَتْلِ الْكِلاَبِ
u'قَتْلٌ كِلاَبٌ':Added, #1: 1	قَتْلِ الْكِلاَبِ
u'قتل كلاب':Added, #1: 1	قَتْلِ الْكِلاَبِ
u'قَتْلٌ كلاب':Added, #2: 2	قَتْلُ الْكِلَابِ
u'قتل كِلاَبٌ':Added, #2: 2	قَتْلُ الْكِلَابِ
u'قَتْلٌ كِلاَبٌ':Added, #2: 2	قَتْلُ الْكِلَابِ
u'قتل كلاب':Added, #2: 2	قَتْلُ الْكِلَابِ
u'قَتْلٌ كلاب':Added, #4: 4	قَتْلِ الْكِلَابِ
u'قتل كِلاَبٌ':Added, #4: 4	قَتْلِ الْكِلَابِ
u'قَتْلٌ كِلاَبٌ':Added, #4: 4	قَتْلِ الْكِلَابِ
u'قَتَلَ كَلْبٌ':Predicate, #4: 4	قَتْلِ الْكِلَابِ
u'قَتَلَ كَلْبٌ':Subject, #1: 1	قَتَلَ كَلْبَ
u'قتل كَلْبٌ':Added, #4: 4	قَتَلَ الْكَلْبُ
u'قَتْلٌ كَلْبٌ':Added, #2: 2	قَتْلُ الْكَلْبِ
u'قتل كَلْبٌ':Added, #2: 2	قَتْلُ الْكَلْبِ
u'قَتْلٌ كَلْبٌ':Added, #6: 6	قَتْلِ الْكَلْبِ
u'قَتَلَ لَطِيم':Predicate, #6: 6	قَتْلِ الْكَلْبِ
u'قَتَلَ لَيْلٌ':Predicate, #1: 1	قَتَلَ لَطِيمَ
u'قَتَلَ مَالِكٌ':Predicate, #1: 1	قَتَلَ لَيْلَةَ
u'قتل مَالِكٌ':Added, #1: 1	قَتَلَ مَالِكَ
u'قَتْلٌ مَالِكٌ':Added, #1: 1	قَتْلِ مَالِكِ
u'قَتَلَ مَانِعٌ':Subject, #1: 1	قَتْلِ مَالِكِ
u'قَتَلَ مُتَقَطِّعٌ':Subject, #1: 1	قَتَلَ الْمَانِعُ
u'قتل مُجَاهَرَةٌ':Added, #1: 1	قَتَلَ مُتَقَطِّعُ
u'قَتْلٌ مُجَاهَرَةٌ':Added, #1: 1	قَتْلِ الْمُجَاهَرَةِ
u'قَتَلَ مَجْنُونٌ':Subject, #1: 1	قَتْلِ الْمُجَاهَرَةِ
u'قَتَلَ مَجُوسِيٌّ':Subject, #2: 2	قَتَلَ مَجْنُونٌ
u'قتل مُحَارِبٌ':Added, #1: 1	قَتَلَ الْمَجُوسِيُّ
u'قتل مُحَارِبٌ':Added, #1: 1	قَتْلَ الْمُحَارِبِ
u'قَتْلٌ مُحَارِبٌ':Added, #1: 1	قَتْلُ الْمُحَارِبِ
u'قَتْلٌ مُحَارِبٌ':Added, #1: 1	قَتْلَ الْمُحَارِبِ
u'قتل مُحَارَبَةٌ':Added, #1: 1	قَتْلُ الْمُحَارِبِ
u'قَتْلٌ مُحَارَبَةٌ':Added, #1: 1	قَتْلِ الْمُحَارَبَةِ
u'قتل مُحَارَبَةٌ':Added, #1: 1	قَتْلِ الْمُحَارَبَةِ
u'قَتْلٌ مُحَارَبَةٌ':Added, #1: 1	قَتْلَ مُحَارَبَةٍ
u'قتل مُحَارَبَةٌ':Added, #1: 1	قَتْلَ مُحَارَبَةٍ
u'قَتْلٌ مُحَارَبَةٌ':Added, #2: 2	قَتْلُ الْمُحَارَبَةِ
u'قَتَلَ مُحْرِمٌ':Subject, #2: 2	قَتْلُ الْمُحَارَبَةِ
u'قَتَلَ مُحْرِمٌ':Subject, #21: 21	قَتَلَ الْمُحْرِمُ
u'قتل مُحْرِمٌ':Added, #5: 5	قَتَلَ مُحْرِمٌ
u'قَتْلٌ مُحْرِمٌ':Added, #2: 2	قَتْلِ الْمُحْرِمِ
u'قتل مُحْرِمٌ':Added, #2: 2	قَتْلِ الْمُحْرِمِ
u'قَتْلٌ مُحْرِمٌ':Added, #3: 3	قَتْلُ الْمُحْرِمِ
u'قَتْلٌ مَحْظُورٌ':Added, #3: 3	قَتْلُ الْمُحْرِمِ
u'قَتَلَ مُخْتَارٌ':Subject, #1: 1	قَتْلٍ مَحْظُورٍ
u'قَتَلَ مُدَبَّرٌ':Predicate, #1: 1	قَتَلَ الْمُخْتَارُ
u'قَتَلَ مُدَبَّرٌ':Subject, #1: 1	قَتَلَ الْمُدَبَّرَ
u'قَتَلَ مُدَبَّرٌ':Subject, #1: 1	قَتَلَ مُدَبَّرٌ
u'قتل مُدْبِرٌ':Added, #30: 30	قَتَلَ الْمُدَبَّرُ
u'قَتْلٌ مُدْبِرٌ':Added, #1: 1	قَتْلُ الْمُدْبِرِ
u'قَتَلَ مَدْيُونٌ':Subject, #1: 1	قَتْلُ الْمُدْبِرِ
u'قَتَلَ مَدْيُونٌ':Subject, #1: 1	قَتَلَ الْمَدْيُونُ
u'قَتَلَ مُرْتَدٌّ':Predicate, #1: 1	قَتَلَ مَدْيُونٌ
u'قَتَلَ مُرْتَدٌّ':Predicate, #1: 1	قَتَلَ الْمُرْتَدَّ
u'قَتَلَ مُرْتَدٌّ':Predicate, #1: 1	قَتَلَ الْمُرْتَدَّةَ
u'قَتَلَ مُرْتَدٌّ':Subject, #1: 1	قَتَلَ مُرْتَدَّةً
u'قَتَلَ مُرْتَدٌّ':Subject, #1: 1	قَتَلَ مُرْتَدٌّ
u'قتل مُرْتَدٌّ':Added, #4: 4	قَتَلَ الْمُرْتَدُّ
u'قتل مُرْتَدٌّ':Added, #1: 1	قَتْلُ الْمُرْتَدّةِ
u'قَتْلٌ مُرْتَدٌّ':Added, #1: 1	قَتْلِ الْمُرْتَدَّةِ
u'قَتْلٌ مُرْتَدٌّ':Added, #1: 1	قَتْلُ الْمُرْتَدّةِ
u'قتل مُرْتَدٌّ':Added, #1: 1	قَتْلِ الْمُرْتَدَّةِ
u'قَتْلٌ مُرْتَدٌّ':Added, #2: 2	قَتْلَ الْمُرْتَدِّ
u'قتل مُرْتَدٌّ':Added, #2: 2	قَتْلَ الْمُرْتَدِّ
u'قَتْلٌ مُرْتَدٌّ':Added, #4: 4	قَتْلُ الْمُرْتَدِّ
u'قتل مُرْتَدٌّ':Added, #4: 4	قَتْلُ الْمُرْتَدِّ
u'قَتْلٌ مُرْتَدٌّ':Added, #6: 6	قَتْلِ الْمُرْتَدِّ
u'قَتَلَ مُرْتَهِنٌ':Predicate, #6: 6	قَتْلِ الْمُرْتَدِّ
u'قَتَلَ مَرْزُبان':Predicate, #1: 1	قَتَلَ الْمُرْتَهِنَ
u'قَتَلَ مَرْهُونٌ':Predicate, #1: 1	قَتَلَ مَرْزُبَانَ
u'قَتَلَ مَرِيضٌ':Predicate, #1: 1	قَتَلَ الْمَرْهُونَ
u'قتل مَرِيضٌ':Added, #1: 1	قَتَلَ الْمَرِيضَ
u'قَتْلٌ مَرِيضٌ':Added, #1: 1	قَتْلِ الْمَرِيضِ
u'قَتْلٌ مُسْتَحِقٌّ':Added, #1: 1	قَتْلِ الْمَرِيضِ
u'قَتْلٌ مُسْتَقْبَلٌ':Added, #1: 1	قَتْلٍ مُسْتَحِقٍّ
u'قَتَلَ مُسْتَوْرِدٌ':Predicate, #1: 1	قَتْلٍ مُسْتَقْبَلٍ
u'قَتَلَ مُسْلِمٌ':Predicate, #1: 1	قَتَلَ الْمُسْتَوْرِدَ
u'قَتَلَ مُسْلِمٌ':Subject, #3: 3	قَتَلَ الْمُسْلِمَ
u'قَتَلَ مُسْلِمٌ':Subject, #5: 5	قَتَلَ الْمُسْلِمُ
u'قتل مُسْلِمٌ':Added, #6: 6	قَتَلَ مُسْلِمٌ
u'قَتْلٌ مُسْلِمٌ':Added, #15: 15	قَتْلِ مُسْلِمٍ
u'قتل مُسْلِمٌ':Added, #15: 15	قَتْلِ مُسْلِمٍ
u'قَتْلٌ مُسْلِمٌ':Added, #1: 1	قَتْلُ مُسْلِمٍ
u'قتل مُسْلِمٌ':Added, #1: 1	قَتْلُ مُسْلِمٍ
u'قَتْلٌ مُسْلِمٌ':Added, #29: 29	قَتْلِ الْمُسْلِمِ
u'قتل مُسْلِمٌ':Added, #29: 29	قَتْلِ الْمُسْلِمِ
u'قَتْلٌ مُسْلِمٌ':Added, #4: 4	قَتْلَ مُسْلِمٍ
u'قتل مُسْلِمٌ':Added, #4: 4	قَتْلَ مُسْلِمٍ
u'قَتْلٌ مُسْلِمٌ':Added, #8: 8	قَتْلُ الْمُسْلِمِ
u'قتل مُسْلِمٌ':Added, #8: 8	قَتْلُ الْمُسْلِمِ
u'قَتْلٌ مُسْلِمٌ':Added, #9: 9	قَتْلَ الْمُسْلِمِ
u'قتل مُشْرِك':Added, #9: 9	قَتْلَ الْمُسْلِمِ
u'قَتْلٌ مُشْرِك':Added, #1: 1	قَتْلِ الْمُشْرِكِ
u'قتل مُشْرِك':Added, #1: 1	قَتْلِ الْمُشْرِكِ
u'قتل مُشْرِك':Added, #1: 1	قَتْلُ مُشْرِكٍ
u'قَتْلٌ مُشْرِك':Added, #1: 1	قَتْلِ مُشْرِكٍ
u'قَتْلٌ مُشْرِك':Added, #1: 1	قَتْلُ مُشْرِكٍ
u'قتل مُضْطَرٌّ':Added, #1: 1	قَتْلِ مُشْرِكٍ
u'قَتْلٌ مُضْطَرٌّ':Added, #1: 1	قَتْلُ الْمُضْطَرِّ
u'قَتْلٌ مَضْمُونٌ':Added, #1: 1	قَتْلُ الْمُضْطَرِّ
u'قَتَلَ مُعاوِيَة':Predicate, #1: 1	قَتْلٍ مَضْمُونٍ
u'قتل مَعْصُومٌ':Added, #1: 1	قَتَلَ مُعَاوِيَةَ
u'قَتْلٌ مَعْصُومٌ':Added, #1: 1	قَتْلِ الْمَعْصُومِ
u'قتل مَعْصُومٌ':Added, #1: 1	قَتْلِ الْمَعْصُومِ
u'قتل مَعْصُومٌ':Added, #1: 1	قَتْلَ مَعْصُومِ
u'قَتْلٌ مَعْصُومٌ':Added, #1: 1	قَتْلُ مَعْصُومٍ
u'قَتْلٌ مَعْصُومٌ':Added, #1: 1	قَتْلَ مَعْصُومِ
u'قتل مَعْصُومٌ':Added, #1: 1	قَتْلُ مَعْصُومٍ
u'قَتْلٌ مَعْصُومٌ':Added, #2: 2	قَتْلِ مَعْصُومٍ
u'قَتَلَ مُعَيَّنٌ':Subject, #2: 2	قَتْلِ مَعْصُومٍ
u'قتل مُعَيَّنٌ':Added, #1: 1	قَتَلَ الْمُعَيَّنُ
u'قَتْلٌ مُعَيَّنٌ':Added, #2: 2	قَتْلِ مُعَيَّنٍ
u'قَتَلَ مَغْصُوب':Subject, #2: 2	قَتْلِ مُعَيَّنٍ
u'قَتَلَ مُقَاتِلٌ':Predicate, #1: 1	قَتَلَ الْمَغْصُوبُ
u'قَتَلَ مَقْتُولٌ':Predicate, #1: 1	قَتَلَ الْمُقَاتِلَةَ
u'قَتَلَ مَقْطُوعٌ':Predicate, #1: 1	قَتَلَ الْمَقْتُولَ
u'قتل مُكْرَهٌ':Added, #1: 1	قَتَلَ مَقْطُوعَ
u'قَتْلٌ مُكْرَهٌ':Added, #1: 1	قَتْلِ الْمُكْرَهِ
u'قَتَلَ مَمْلُوكٌ':Predicate, #1: 1	قَتْلِ الْمُكْرَهِ
u'قتل مُنَافِقٌ':Added, #1: 1	قَتَلَ مَمْلُوكَ
u'قَتْلٌ مُنَافِقٌ':Added, #1: 1	قَتْلِ الْمُنَافِقِ
u'قَتَلَ مَنْجَنِيقٌ':Subject, #1: 1	قَتْلِ الْمُنَافِقِ
u'قَتَلَ مُنْذِرٌ':Subject, #1: 1	قَتَلَ الْمَنْجَنِيقُ
u'قتل مُنْفَرِدٌ':Added, #1: 1	قَتَلَ الْمُنْذِرُ
u'قَتْلٌ مُنْفَرِدٌ':Added, #1: 1	قَتْلَ الْمُنْفَرِدِ
u'قتل مُهْدَر':Added, #1: 1	قَتْلَ الْمُنْفَرِدِ
u'قَتْلٌ مُهْدَر':Added, #1: 1	قَتْلُ الْمُهْدَرِ
u'قتل مُؤْذِي':Added, #1: 1	قَتْلُ الْمُهْدَرِ
u'قَتْلٌ مُؤْذِي':Added, #2: 2	قَتْلُ الْمُؤْذِيَاتِ
u'قتل مُوَرِّث':Added, #2: 2	قَتْلُ الْمُؤْذِيَاتِ
u'قَتْلٌ مُوَرِّث':Added, #1: 1	قَتْلِ الْمُوَرِّثِ
u'قتل مَوْرُوثٌ':Added, #1: 1	قَتْلِ الْمُوَرِّثِ
u'قَتْلٌ مَوْرُوثٌ':Added, #1: 1	قَتْلِ الْمَوْرُوثِ
u'قتل مَوْرُوثٌ':Added, #1: 1	قَتْلِ الْمَوْرُوثِ
u'قَتْلٌ مَوْرُوثٌ':Added, #2: 2	قَتْلَ مَوْرُوثِهِ
u'قَتْلٌ مَوْصُوفٌ':Added, #2: 2	قَتْلَ مَوْرُوثِهِ
u'قَتَلَ مُوصِي':Predicate, #2: 2	قَتْلٍ مَوْصُوفٍ
u'قَتَلَ مَوْقُوفٌ':Predicate, #2: 2	قَتَلَ الْمُوصِيَ
u'قَتَلَ مُوَكِّلٌ':Subject, #1: 1	قَتَلَ الْمَوْقُوفَ
u'قتل مُؤْمِنٌ':Added, #1: 1	قَتَلَ مُوَكِّلُهُ
u'قَتْلٌ مُؤْمِنٌ':Added, #1: 1	قَتْلُ الْمُؤْمِنِ
u'قتل مُؤْمِنٌ':Added, #1: 1	قَتْلُ الْمُؤْمِنِ
u'قتل مُؤْمِنٌ':Added, #1: 1	قَتْلَ مُؤْمِنٍ
u'قَتْلٌ مُؤْمِنٌ':Added, #1: 1	قَتْلُ مُؤْمِنٍ
u'قَتْلٌ مُؤْمِنٌ':Added, #1: 1	قَتْلَ مُؤْمِنٍ
u'قتل مُؤْمِنٌ':Added, #1: 1	قَتْلُ مُؤْمِنٍ
u'قَتْلٌ مُؤْمِنٌ':Added, #7: 7	قَتْلِ الْمُؤْمِنِ
u'قتل مُؤْمِنٌ':Added, #7: 7	قَتْلِ الْمُؤْمِنِ
u'قَتْلٌ مُؤْمِنٌ':Added, #9: 9	قَتْلِ مُؤْمِنٍ
u'قَتَلَ نَاسٌ':Predicate, #9: 9	قَتْلِ مُؤْمِنٍ
u'قتل نَاسٌ':Added, #13: 13	قَتَلَ النَّاسَ
u'قَتْلٌ نَاسٌ':Added, #1: 1	قَتْلِ نَاسٍ
u'قتل نَاسٌ':Added, #1: 1	قَتْلِ نَاسٍ
u'قَتْلٌ نَاسٌ':Added, #3: 3	قَتْلِ النَّاسِ
u'قَتَلَ نَبِيٌّ':Subject, #3: 3	قَتْلِ النَّاسِ
u'قتل نَحْلٌ':Added, #3: 3	قَتَلَ النَّبِيُّ
u'قَتْلٌ نَحْلٌ':Added, #1: 1	قَتْلِ النَّحْلِ
u'قتل نَحْلٌ':Added, #1: 1	قَتْلِ النَّحْلِ
u'قَتْلٌ نَحْلٌ':Added, #2: 2	قَتْلُ النَّحْلِ
u'قتل نَحْلٌ':Added, #2: 2	قَتْلُ النَّحْلِ
u'قَتْلٌ نَحْلٌ':Added, #2: 2	قَتْلُ نَحْلٍ
u'قَتَلَ نِساءٌ':Predicate, #2: 2	قَتْلُ نَحْلٍ
u'قتل نِساءٌ':Added, #1: 1	قَتَلَ النِّسَاءَ
u'قتل نِساءٌ':Added, #1: 1	قَتْلَ النِّسَاءِ
u'قَتْلٌ نِساءٌ':Added, #1: 1	قَتْلِ النّسَاءِ
u'قَتْلٌ نِساءٌ':Added, #1: 1	قَتْلَ النِّسَاءِ
u'قتل نِساءٌ':Added, #1: 1	قَتْلِ النّسَاءِ
u'قَتْلٌ نِساءٌ':Added, #2: 2	قَتْلُ النِّسَاءِ
u'قتل نِساءٌ':Added, #2: 2	قَتْلُ النِّسَاءِ
u'قَتْلٌ نِساءٌ':Added, #31: 31	قَتْلِ النِّسَاءِ
u'قَتَلَ نُعْمَانُ':Predicate, #31: 31	قَتْلِ النِّسَاءِ
u'قَتَلَ نُعْمَانُ':Subject, #2: 2	قَتَلَ النّعْمَانَ
u'قَتَلَ نَفَذٌ':Predicate, #1: 1	قَتَلَ النّعْمَانُ
u'قَتَلَ نَفْسٌ':Predicate, #1: 1	قَتَلَ نَفَذَ
u'قتل نَفْسٌ':Added, #1: 1	قَتَلَ النَّفْسَ
u'قَتْلٌ نَفْسٌ':Added, #12: 12	قَتْلُ النَّفْسِ
u'قتل نَفْسٌ':Added, #12: 12	قَتْلُ النَّفْسِ
u'قَتْلٌ نَفْسٌ':Added, #16: 16	قَتْلِ النَّفْسِ
u'قتل نَفْسٌ':Added, #16: 16	قَتْلِ النَّفْسِ
u'قَتْلٌ نَفْسٌ':Added, #19: 19	قَتْلِ نَفْسِهِ
u'قتل نَفْسٌ':Added, #19: 19	قَتْلِ نَفْسِهِ
u'قَتْلٌ نَفْسٌ':Added, #2: 2	قَتْلُ نَفْسٍ
u'قتل نَفْسٌ':Added, #2: 2	قَتْلُ نَفْسٍ
u'قَتْلٌ نَفْسٌ':Added, #3: 3	قَتْلُ نَفْسِهِ
u'قتل نَفْسٌ':Added, #3: 3	قَتْلُ نَفْسِهِ
u'قَتْلٌ نَفْسٌ':Added, #6: 6	قَتْلَ نَفْسِهِ
u'قتل نَفْسٌ':Added, #6: 6	قَتْلَ نَفْسِهِ
u'قَتْلٌ نَفْسٌ':Added, #7: 7	قَتْلَ نَفْسٍ
u'قتل نَفْسٌ':Added, #7: 7	قَتْلَ نَفْسٍ
u'قَتْلٌ نَفْسٌ':Added, #9: 9	قَتْلَ النَّفْسِ
u'قتل نَفْسٌ':Added, #9: 9	قَتْلَ النَّفْسِ
u'قَتْلٌ نَفْسٌ':Added, #9: 9	قَتْلِ نَفْسٍ
u'قتل نُفُوسٌ':Added, #9: 9	قَتْلِ نَفْسٍ
u'قتل نُفُوسٌ':Added, #1: 1	قَتْلُ النُّفُوسِ
u'قَتْلٌ نُفُوسٌ':Added, #1: 1	قَتْلِ النُّفُوسِ
u'قَتْلٌ نُفُوسٌ':Added, #1: 1	قَتْلُ النُّفُوسِ
u'قتل نَمْلٌ':Added, #1: 1	قَتْلِ النُّفُوسِ
u'قَتْلٌ نَمْلٌ':Added, #1: 1	قَتْلِ النَّمْلِ
u'قتل نَمْلٌ':Added, #1: 1	قَتْلِ النَّمْلِ
u'قَتْلٌ نَمْلٌ':Added, #2: 2	قَتْلَ النَّمْلِ
u'قتل نَمْلٌ':Added, #2: 2	قَتْلَ النَّمْلِ
u'قَتْلٌ نَمْلٌ':Added, #8: 8	قَتْلُ النَّمْلِ
u'قتل نَمْلَةٌ':Added, #8: 8	قَتْلُ النَّمْلِ
u'قَتْلٌ نَمْلَةٌ':Added, #1: 1	قَتْلُ النَّمْلَةِ
u'قتل نَمْلَةٌ':Added, #1: 1	قَتْلُ النَّمْلَةِ
u'قَتْلٌ نَمْلَةٌ':Added, #4: 4	قَتْلِ النَّمْلَةِ
u'قتل هُدْهُدٌ':Added, #4: 4	قَتْلِ النَّمْلَةِ
u'قَتْلٌ هُدْهُدٌ':Added, #1: 1	قَتْلُ الْهُدْهُدِ
u'قَتَلَ هِرٌّ':Predicate, #1: 1	قَتْلُ الْهُدْهُدِ
u'قتل هِرٌّ':Added, #1: 1	قَتَلَ هِرَّةَ
u'قتل هِرٌّ':Added, #2: 2	قَتْلَ الْهِرِّ
u'قَتْلٌ هِرٌّ':Added, #2: 2	قَتْلِ الْهِرِّ
u'قَتْلٌ هِرٌّ':Added, #2: 2	قَتْلَ الْهِرِّ
u'قتل هِرٌّ':Added, #2: 2	قَتْلِ الْهِرِّ
u'قَتْلٌ هِرٌّ':Added, #4: 4	قَتْلُ الْهِرِّ
u'قتل هشام':Added, #4: 4	قَتْلُ الْهِرِّ
u'قَتْلٌ هشام':Added, #1: 1	قَتْلَ هِشَامِ
u'قتل هِشَامٌ':Added, #1: 1	قَتْلَ هِشَامِ
u'قَتْلٌ هِشَامٌ':Added, #1: 1	قَتْلَ هِشَامِ
u'قتل هَوَامٌّ':Added, #1: 1	قَتْلَ هِشَامِ
u'قَتْلٌ هَوَامٌّ':Added, #2: 2	قَتْلُ الْهَوَامِّ
u'قتل هَوَامٌّ':Added, #2: 2	قَتْلُ الْهَوَامِّ
u'قَتْلٌ هَوَامٌّ':Added, #3: 3	قَتْلِ الْهَوَامِّ
u'قَتَلَ واحد':Subject, #3: 3	قَتْلِ الْهَوَامِّ
u'قَتَلَ وَاحِدٌ':Subject, #1: 1	قَتَلَ الْوَاحِدُ
u'قَتَلَ واحد':Subject, #1: 1	قَتَلَ الْوَاحِدُ
u'قَتَلَ وَاحِدٌ':Subject, #9: 9	قَتَلَ وَاحِدٌ
u'قتل واحد':Added, #9: 9	قَتَلَ وَاحِدٌ
u'قتل واحد':Added, #1: 1	قَتْلَ الْوَاحِدِ
u'قَتْلٌ واحد':Added, #1: 1	قَتْلُ الْوَاحِدِ
u'قَتْلٌ واحد':Added, #1: 1	قَتْلَ الْوَاحِدِ
u'قتل وَاحِدٌ':Added, #1: 1	قَتْلُ الْوَاحِدِ
u'قتل وَاحِدٌ':Added, #1: 1	قَتْلَ الْوَاحِدِ
u'قَتْلٌ وَاحِدٌ':Added, #1: 1	قَتْلُ الْوَاحِدِ
u'قَتْلٌ وَاحِدٌ':Added, #1: 1	قَتْلَ الْوَاحِدِ
u'قَتْلٌ واحد':Added, #1: 1	قَتْلُ الْوَاحِدِ
u'قَتْلٌ وَاحِدٌ':Added, #1: 1	قَتْلٍ وَاحِدٍ
u'قتل واحد':Added, #1: 1	قَتْلٍ وَاحِدٍ
u'قَتْلٌ واحد':Added, #2: 2	قَتْلِ الْوَاحِدِ
u'قتل وَاحِدٌ':Added, #2: 2	قَتْلِ الْوَاحِدِ
u'قَتْلٌ وَاحِدٌ':Added, #2: 2	قَتْلِ الْوَاحِدِ
u'قتل واحد':Added, #2: 2	قَتْلِ الْوَاحِدِ
u'قتل واحد':Added, #3: 3	قَتْلُ وَاحِدٍ
u'قَتْلٌ واحد':Added, #3: 3	قَتْلِ وَاحِدٍ
u'قَتْلٌ واحد':Added, #3: 3	قَتْلُ وَاحِدٍ
u'قتل وَاحِدٌ':Added, #3: 3	قَتْلِ وَاحِدٍ
u'قتل وَاحِدٌ':Added, #3: 3	قَتْلُ وَاحِدٍ
u'قَتْلٌ وَاحِدٌ':Added, #3: 3	قَتْلِ وَاحِدٍ
u'قَتْلٌ وَاحِدٌ':Added, #3: 3	قَتْلُ وَاحِدٍ
u'قتل وَارِثٌ':Added, #3: 3	قَتْلِ وَاحِدٍ
u'قتل وَارِثٌ':Added, #1: 1	قَتْلَ الْوَارِثِ
u'قَتْلٌ وَارِثٌ':Added, #1: 1	قَتْلِ الْوَارِثِ
u'قَتْلٌ وَارِثٌ':Added, #1: 1	قَتْلَ الْوَارِثِ
u'قَتَلَ وَالِدٌ':Subject, #1: 1	قَتْلِ الْوَارِثِ
u'قتل وَالِدٌ':Added, #1: 1	قَتَلَ الْوَالِدُ
u'قَتْلٌ وَالِدٌ':Added, #2: 2	قَتْلِ الْوَالِدِ
u'قتل وَالِدٌ':Added, #2: 2	قَتْلِ الْوَالِدِ
u'قَتْلٌ وَالِدٌ':Added, #2: 2	قَتْلُ وَالِدِهِ
u'قَتَلَ وَاهِبٌ':Predicate, #2: 2	قَتْلُ وَالِدِهِ
u'قتل وبر':Added, #2: 2	قَتَلَ الْوَاهِبَ
u'قَتْلٌ وبر':Added, #1: 1	قَتْلِ الْوَبْرِ
u'قتل وَبْرٌ':Added, #1: 1	قَتْلِ الْوَبْرِ
u'قَتْلٌ وَبْرٌ':Added, #1: 1	قَتْلِ الْوَبْرِ
u'قتل وَزَغٌ':Added, #1: 1	قَتْلِ الْوَبْرِ
u'قَتْلٌ وَزَغٌ':Added, #3: 3	قَتْلِ الْوَزَغِ
u'قتل وَزَغَةٌ':Added, #3: 3	قَتْلِ الْوَزَغِ
u'قَتْلٌ وَزَغَةٌ':Added, #1: 1	قَتْلِ الْوَزَغَةِ
u'قتل وصفاء':Added, #1: 1	قَتْلِ الْوَزَغَةِ
u'قَتْلٌ وصفاء':Added, #1: 1	قَتْلِ الْوُصَفَاءِ
u'قَتَلَ وَصِيٌّ':Subject, #1: 1	قَتْلِ الْوُصَفَاءِ
u'قَتَلَ ولد':Predicate, #4: 4	قَتَلَ الْوَصِيُّ
u'قَتَلَ وَلَدٌ':Predicate, #5: 5	قَتَلَ الْوَلَدَ
u'قَتَلَ ولد':Subject, #5: 5	قَتَلَ الْوَلَدَ
u'قَتَلَ وَلَدٌ':Subject, #1: 1	قَتَلَ الْوَلَدُ
u'قتل ولد':Added, #1: 1	قَتَلَ الْوَلَدُ
u'قَتْلٌ ولد':Added, #2: 2	قَتْلُ وَلَدِهِ
u'قتل وَلَدٌ':Added, #2: 2	قَتْلُ وَلَدِهِ
u'قَتْلٌ وَلَدٌ':Added, #2: 2	قَتْلُ وَلَدِهِ
u'قتل ولد':Added, #2: 2	قَتْلُ وَلَدِهِ
u'قَتْلٌ ولد':Added, #3: 3	قَتْلِ الْوَلَدِ
u'قتل وَلَدٌ':Added, #3: 3	قَتْلِ الْوَلَدِ
u'قَتْلٌ وَلَدٌ':Added, #3: 3	قَتْلِ الْوَلَدِ
u'قتل ولد':Added, #3: 3	قَتْلِ الْوَلَدِ
u'قَتْلٌ ولد':Added, #3: 3	قَتْلَ وَلَدِهِ
u'قتل وَلَدٌ':Added, #3: 3	قَتْلَ وَلَدِهِ
u'قَتْلٌ وَلَدٌ':Added, #3: 3	قَتْلَ وَلَدِهِ
u'قتل ولد':Added, #3: 3	قَتْلَ وَلَدِهِ
u'قَتْلٌ ولد':Added, #4: 4	قَتْلِ وَلَدِهِ
u'قتل وَلَدٌ':Added, #4: 4	قَتْلِ وَلَدِهِ
u'قَتْلٌ وَلَدٌ':Added, #4: 4	قَتْلِ وَلَدِهِ
u'قتل ولدان':Added, #4: 4	قَتْلِ وَلَدِهِ
u'قَتْلٌ ولدان':Added, #3: 3	قَتْلِ الْوِلْدَانِ
u'قَتَلَ وَلِيٌّ':Predicate, #3: 3	قَتْلِ الْوِلْدَانِ
u'قَتَلَ وَلِيٌّ':Subject, #1: 1	قَتَلَ وَلِيَّ
u'قَتَلَ وَلِيٌّ':Subject, #1: 1	قَتَلَ الْوَلِيُّ
u'قَتَلَ وَلِيٌّ':Subject, #1: 1	قَتَلَ وَلِيُّ
u'قَتَلَ يهود':Predicate, #1: 1	قَتَلَ وَلِيُّهُ
u'قَتَلَ يَهُودٌ':Predicate, #1: 1	قَتَلَ الْيَهُودَ
u'قتل يهود':Added, #1: 1	قَتَلَ الْيَهُودَ
u'قتل يَهُودٌ':Added, #1: 1	قَتْلَ الْيَهُودِ
u'قَتْلٌ يهود':Added, #1: 1	قَتْلَ الْيَهُودِ
u'قَتْلٌ يَهُودٌ':Added, #1: 1	قَتْلَ الْيَهُودِ
u'قَتَلَ يَهُودِيٌّ':Predicate, #1: 1	قَتْلَ الْيَهُودِ
u'قتل يَهُودِيٌّ':Added, #1: 1	قَتَلَ الْيَهُودِيَّ
u'قَتْلٌ يَهُودِيٌّ':Added, #1: 1	قَتْلِ الْيَهُودِيِّ
u'قَتَلَ يَوْمٌ':Predicate, #1: 1	قَتْلِ الْيَهُودِيِّ
u'قَحَطَ مَطَرٌ':Subject, #3: 3	قَتَلَ يَوْمَ
u'قَحْطٌ مَطَرٌ':Added, #2: 2	قَحَطَ الْمَطَرُ
u'قَحْطٌ مَطَرٌ':Added, #1: 1	قَحْطِ الْمَطَرِ
u'قَحَمَ كَلاَمٌ':Predicate, #2: 2	قَحْطَ الْمَطَرِ
u'قَحَمَ لَفْظٌ':Predicate, #1: 1	أَقْحَمَ الْكَلَامَ
u'قَحَمَ لِوَاءٌ':Predicate, #1: 1	أَقْحَمَ لَفْظَ
u'قَدْحٌ شَهَادَةٌ':Added, #1: 1	أَقْحَمَ اللّوَاءَ
u'قَدْحٌ عِرْضٌ':Added, #1: 1	قَدْحِ الشَّهَادَةِ
u'قَدَّدَ صَاحِبٌ':Subject, #1: 1	قَدْحَ عِرْضٍ
u'قَدَرَ أَبٌ':Subject, #1: 1	قَدَّدَ صَاحِبُهُ
u'قَدْرٌ إِبْلاَغٌ':Added, #1: 1	قَدَرَ الْأَبُ
u'قَدَرَ اِبْنٌ':Subject, #1: 1	قَدْرَ الْإِبْلَاغِ
u'قَدْرٌ إِتْلاَفٌ':Added, #1: 1	قَدَرَ ابْنُ
u'قَدَّرَ إجَارَةٌ':Predicate, #1: 1	قَدْرِ الْإِتْلَافِ
u'قَدْرٌ إجَارَةٌ':Added, #2: 2	قَدَّرَ الْإِجَارَةَ
u'قَدْرٌ اِجْتِهَادٌ':Added, #1: 1	قَدْرَ إجَارَةِ
u'قَدْرٌ أَجْذَاعٌ':Added, #1: 1	قَدْرِ اجْتِهَادِ
u'قَدْرٌ أَجْرٌ':Added, #1: 1	قَدْرِ الْأَجْذَاعِ
u'قَدْرٌ أَجْرٌ':Added, #2: 2	قَدْرَ أَجْرِ
u'قَدْرٌ أَجْرٌ':Added, #2: 2	قَدْرِ الْأَجْرِ
u'قَدْرٌ أَجْرٌ':Added, #4: 4	قَدْرُ أَجْرِ
u'قَدْرٌ أُجْرَةٌ':Added, #5: 5	قَدْرِ أَجْرِ
u'قَدْرٌ أُجْرَةٌ':Added, #1: 1	قَدْرِ أُجْرَةِ
u'قَدْرٌ أُجْرَةٌ':Added, #1: 1	قَدْرِ أُجْرَتِهِ
u'قَدْرٌ أُجْرَةٌ':Added, #1: 1	قَدْرُ الْأُجْرَةِ
u'قَدْرٌ أُجْرَةٌ':Added, #2: 2	قَدْرُ أُجْرَةِ
u'قَدْرٌ أُجْرَةٌ':Added, #3: 3	قَدْرَ الْأُجْرَةِ
u'قَدْرٌ أُجْرَةٌ':Added, #5: 5	قَدْرَ أُجْرَةِ
u'قَدْرٌ أُجْرَةٌ':Added, #8: 8	قَدْرَ أُجْرَتِهِ
u'قَدْرٌ إِجْزَاءٌ':Added, #9: 9	قَدْرِ الْأُجْرَةِ
u'قَدْرٌ إِجْزَاءٌ':Added, #1: 1	قَدْرُ الْإِجْزَاءِ
u'قَدْرٌ أَجَلٌ':Added, #3: 3	قَدْرِ الْإِجْزَاءِ
u'قَدْرٌ أَجَلٌ':Added, #10: 10	قَدْرِ الْأَجَلِ
u'قَدْرٌ أَجَلٌ':Added, #1: 1	قَدْرَ أَجَلِ
u'قَدْرٌ أَجَلٌ':Added, #1: 1	قَدْرُ الْأَجَلِ
u'قَدْرٌ أَجَلٌ':Added, #2: 2	قَدْرِ أَجَلٍ
u'قَدْرٌ أُجُورٌ':Added, #3: 3	قَدْرَ الْأَجَلِ
u'قَدَرَ اِحْترَازٌ':Subject, #1: 1	قَدْرَ أُجُورِ
u'قَدْرٌ اِحْتِمَالٌ':Added, #1: 1	قَدَرَ احْتِرَازٌ
u'قَدَرَ أحَدٌ':Subject, #1: 1	قَدْرِ احْتِمَالِ
u'قَدَّرَ أَحْوالٌ':Predicate, #2: 2	قَدَرَ أَحَدٌ
u'قَدَّرَ أحْوَالٌ':Predicate, #1: 1	قَدَّرَ أَحْوَالَ
u'قَدْرٌ اِخْتِرَاعٌ':Added, #1: 1	قَدَّرَ أَحْوَالَ
u'قَدْرٌ أُخْرَى':Added, #1: 1	قَدْرِ اخْتِرَاعِ
u'قَدْرٌ أَخِيرٌ':Added, #1: 1	قَدْرِ الأُخْرَيَيْنِ
u'قَدْرٌ أَدَاءٌ':Added, #1: 1	قَدْرِ الْأَخِيرِ
u'قَدْرٌ أَذَانٌ':Added, #5: 5	قَدْرَ أَدَاءِ
u'قَدْرٌ أَذَانٌ':Added, #1: 1	قَدْرُ أَذَانَيْنِ
u'قَدْرٌ إِذْنٌ':Added, #2: 2	قَدْرَ أَذَانٍ
u'قَدْرٌ أَرْبَعُ':Added, #2: 2	قَدْرِ إذْنِهِ
u'قَدْرٌ أَرْبَعُ':Added, #1: 1	قَدْرِ الْأَرْبَعِ
u'قَدْرٌ أَرْبَعُ':Added, #2: 2	قَدْرِ أَرْبَعِ
u'قَدْرٌ أَرْبَعُ':Added, #4: 4	قَدْرُ أَرْبَعِ
u'قَدْرٌ أَرْبَعَةٌ':Added, #5: 5	قَدْرَ أَرْبَعِ
u'قَدْرٌ اِرْتِفَاعٌ':Added, #4: 4	قَدْرَ أَرْبَعَةِ
u'قَدْرٌ إِرْثٌ':Added, #1: 1	قَدْرَ ارْتِفَاعِ
u'قَدْرٌ إِرْثٌ':Added, #1: 1	قَدْرَ إرْثِهِ
u'قَدْرٌ إِرْثٌ':Added, #2: 2	قَدْرِ إرْثِهِ
u'قَدْرٌ إِرْثٌ':Added, #2: 2	قَدْرِ الْإِرْثِ
u'قَدَّرَ أَرْزَاقٌ':Predicate, #3: 3	قَدْرُ إرْثِهِ
u'قَدْرٌ أَرْزَاقٌ':Added, #1: 1	قَدَّرَ أَرْزَاقَ
u'قَدْرٌ أرْضٌ':Added, #1: 1	قَدْرَ الْأَرْزَاقِ
u'قَدْرٌ أرْضٌ':Added, #1: 1	قَدْرِ أَرْضِهِ
u'قَدْرٌ أرْضٌ':Added, #1: 1	قَدْرِ الأَرْضِ
u'قَدْرٌ أرْضٌ':Added, #1: 1	قَدْرَ الْأَرْضِ
u'قَدْرٌ أرْضٌ':Added, #1: 1	قَدْرِ الْأَرْضِ
u'قَدْرٌ إِزَارٌ':Added, #1: 1	قَدْرِ الْأَرْضَيْنِ
u'قَدْرٌ اِسْتِحْقَاقٌ':Added, #1: 1	قَدْرَ إزَارٍ
u'قَدْرٌ اِسْتِدَارَةٌ':Added, #1: 1	قَدْرُ اسْتِحْقَاقِ
u'قَدْرٌ إِسْراعٌ':Added, #1: 1	قَدْرِ اسْتِدَارَةِ
u'قَدْرٌ إِسْراعٌ':Added, #1: 1	قَدْرَ إسْرَاعِ
u'قَدْرٌ إِسْلامٌ':Added, #1: 1	قَدْرُ إسْرَاعِ
u'قَدْرٌ اِشْتِراطٌ':Added, #1: 1	قَدْرُ الْإِسْلَامِ
u'قَدَّرَ أَشْيَاءٌ':Predicate, #1: 1	قَدْرِ اشْتِرَاطِ
u'قَدْرٌ أُصْبُعٌ':Added, #1: 1	قَدَّرَ الْأَشْيَاءَ
u'قَدْرٌ إِصْبَعٌ':Added, #1: 1	قَدْرِ أُصْبُعٍ
u'قَدْرٌ أُصْبُعٌ':Added, #1: 1	قَدْرُ إصْبَعٍ
u'قَدْرٌ أُصْبُعٌ':Added, #3: 3	قَدْرَ أُصْبُعَيْنِ
u'قَدْرٌ أُصْبُعٌ':Added, #6: 6	قَدْرَ أُصْبُعٍ
u'قَدْرٌ أصل':Added, #6: 6	قَدْرُ أُصْبُعٍ
u'قَدْرٌ أًصْلٌ':Added, #1: 1	قَدْرُ الْأَصْلِ
u'قَدْرٌ إِطالَةٌ':Added, #1: 1	قَدْرُ الْأَصْلِ
u'قَدْرٌ إِطْعامٌ':Added, #1: 1	قَدْرَ الْإِطَالَةِ
u'قَدْرٌ إِطْعامٌ':Added, #1: 1	قَدْرَ الْإِطْعَامِ
u'قَدْرٌ أعْيانٌ':Added, #1: 1	قَدْرُ الْإِطْعَامِ
u'قَدْرٌ أَعْيَانٌ':Added, #1: 1	قَدْرِ الْأَعْيَانِ
u'قَدْرٌ أقَلُّ':Added, #1: 1	قَدْرِ الْأَعْيَانِ
u'قَدْرٌ أقَلُّ':Added, #1: 1	قَدْرَ أَقَلِّ
u'قَدْرٌ أقَلُّ':Added, #1: 1	قَدْرُ أَقَلِّ
u'قَدْرٌ أقَلُّ':Added, #1: 1	قَدْرُ الْأَقَلِّ
u'قَدْرٌ أَكْثَرُ':Added, #1: 1	قَدْرِ الْأَقَلِّ
u'قَدْرٌ أكل':Added, #1: 1	قَدْرُ أَكْثَرِ
u'قَدْرٌ أَكْلٌ':Added, #1: 1	قَدْرِ أَكْلِهِ
u'قَدْرٌ ألف':Added, #1: 1	قَدْرِ أَكْلِهِ
u'قَدْرٌ ألْفٌ':Added, #1: 1	قَدْرِ الْأَلْفِ
u'قَدْرٌ أَلْفٌ':Added, #1: 1	قَدْرِ الْأَلْفِ
u'قَدْرٌ ألْفٌ':Added, #1: 1	قَدْرِ الْأَلْفِ
u'قَدْرٌ ألف':Added, #1: 1	قَدْرَ أَلْفَيْنِ
u'قَدْرٌ ألف':Added, #2: 2	قَدْرَ أَلْفِ
u'قَدْرٌ ألْفٌ':Added, #2: 2	قَدْرُ أَلْفِ
u'قَدْرٌ ألْفٌ':Added, #2: 2	قَدْرَ أَلْفِ
u'قَدْرٌ أَلْفٌ':Added, #2: 2	قَدْرُ أَلْفِ
u'قَدْرٌ أَلْفٌ':Added, #2: 2	قَدْرَ أَلْفِ
u'قَدَرٌ اللهُ':Added, #2: 2	قَدْرُ أَلْفِ
u'قَدَّرَ إمَامٌ':Subject, #2: 2	قَدَرِ اللهِ
u'قَدْرٌ أمَانَةٌ':Added, #2: 2	قَدَّرَ الْإِمَامُ
u'قَدْرٌ أمَانَةٌ':Added, #1: 1	قَدْرُ الْأَمَانَةِ
u'قَدَّرَ أَمْطَارٌ':Predicate, #2: 2	قَدْرِ الْأَمَانَةِ
u'قَدْرٌ إِمْكانٌ':Added, #1: 1	قَدَّرَ الأَمْطَارَ
u'قَدْرٌ إِمْكانٌ':Added, #1: 1	قَدْرَ إمْكَانِ
u'قَدْرٌ إِمْكانٌ':Added, #1: 1	قَدْرُ إمْكَانِ
u'قَدْرٌ إِمْكانٌ':Added, #2: 2	قَدْرِ الْإِمْكَانِ
u'قَدْرٌ أَمْلاكٌ':Added, #3: 3	قَدْرَ إمْكَانِهِ
u'قَدْرٌ أَمْلاَكٌ':Added, #3: 3	قَدْرِ الْأَمْلَاكِ
u'قَدْرٌ إِمْهالٌ':Added, #3: 3	قَدْرِ الْأَمْلَاكِ
u'قَدْرٌ أَمْوَالٌ':Added, #1: 1	قَدْرَ الْإِمْهَالِ
u'قَدْرٌ إِناءٌ':Added, #2: 2	قَدْرِ الْأَمْوَالِ
u'قَدْرٌ أَنْصِبَاءُ':Added, #1: 1	قَدْرُ إنَاءِ
u'قَدْرٌ أَنْصِبَاءُ':Added, #1: 1	قَدْرِ الأَنْصِبَاءِ
u'قَدْرٌ أَنْصِبَاءُ':Added, #1: 1	قَدْرَ الْأَنْصِبَاءِ
u'قَدْرٌ إِنْفاقٌ':Added, #8: 8	قَدْرِ الْأَنْصِبَاءِ
u'قَدْرٌ أُنْمُلَةٌ':Added, #2: 2	قَدْرِ الْإِنْفَاقِ
u'قَدْرٌ أُنْمُلَةٌ':Added, #4: 4	قَدْرِ الْأُنْمُلَةِ
u'قَدْرٌ أُنْمُلَةٌ':Added, #4: 4	قَدْرَ أُنْمُلَةٍ
u'قَدْرٌ آنِيَةٌ':Added, #9: 9	قَدْرَ الْأُنْمُلَةِ
u'قَدَرَ أهْلٌ':Subject, #1: 1	قَدْرُ آنِيَةِ
u'قَدَرَ أَوَّلُ':Subject, #1: 1	قَدَرَ أَهْلُ
u'قَدَّرَ أَوَّلُ':Subject, #1: 1	قَدَرَ الْأَوَّلُ
u'قَدْرٌ أَوَّلُ':Added, #4: 4	قَدَّرَ الْأَوَّلُ
u'قَدْرٌ أيَّامٌ':Added, #1: 1	قَدْرَ الْأَوَّلِ
u'قَدْرٌ أَيَّامٌ':Added, #1: 1	قَدْرَ الأَيَّامِ
u'قَدْرٌ أيَّامٌ':Added, #1: 1	قَدْرَ الأَيَّامِ
u'قَدْرٌ أيَّامٌ':Added, #1: 1	قَدْرُ أَيَّامِ
u'قَدْرٌ أَيَّامٌ':Added, #1: 1	قَدْرِ أَيَّامِ
u'قَدْرٌ أَيَّامٌ':Added, #1: 1	قَدْرُ أَيَّامِ
u'قَدْرٌ أيَّامٌ':Added, #1: 1	قَدْرِ أَيَّامِ
u'قَدْرٌ أَيَّامٌ':Added, #3: 3	قَدْرَ الْأَيَّامِ
u'قَدْرٌ آيَةٌ':Added, #3: 3	قَدْرَ الْأَيَّامِ
u'قَدْرٌ بَابٌ':Added, #5: 5	قَدْرَ آيَةٍ
u'قَدَرَ بَائِعٌ':Subject, #1: 1	قَدْرِ الْبَابِ
u'قَدْرٌ بَحْثٌ':Added, #2: 2	قَدَرَ الْبَائِعُ
u'قَدْرٌ بَدَلٌ':Added, #1: 1	قَدْرِ الْبَحْثِ
u'قَدْرٌ بَدَلٌ':Added, #1: 1	قَدْرَ بَدَلِ
u'قَدْرٌ بَدَلٌ':Added, #1: 1	قَدْرِ بَدَلٍ
u'قَدْرٌ بَدَلٌ':Added, #1: 1	قَدْرِ بَدَلِ
u'قَدْرٌ بدن':Added, #6: 6	قَدْرِ الْبَدَلِ
u'قَدْرٌ بَدَنٌ':Added, #2: 2	قَدْرِ الْبَدَنِ
u'قَدْرٌ بَذْرٌ':Added, #2: 2	قَدْرِ الْبَدَنِ
u'قَدْرٌ بَذْرٌ':Added, #1: 1	قَدْرِ بَذْرِهِ
u'قَدْرٌ بَذْرٌ':Added, #2: 2	قَدْرُ الْبَذْرِ
u'قَدْرٌ بَذْرٌ':Added, #3: 3	قَدْرُ بَذْرِهِ
u'قَدْرٌ بَذْرٌ':Added, #4: 4	قَدْرَ الْبَذْرِ
u'قَدْرٌ بَسْمَلَةٌ':Added, #4: 4	قَدْرَ بَذْرِهِ
u'قَدْرٌ بُعْدٌ':Added, #2: 2	قَدْرِ الْبَسْمَلَةِ
u'قَدْرٌ بُعْدٌ':Added, #1: 1	قَدْرُ الْبُعْدِ
u'قَدْرٌ بُعْدٌ':Added, #1: 1	قَدْرِ الْبُعْدِ
u'قَدَرَ بَعْضٌ':Subject, #1: 1	قَدْرُ الْبُعْدَيْنِ
u'قَدَّرَ بَعْضٌ':Subject, #1: 1	قَدَرَ بَعْضُ
u'قَدْرٌ بَعْضٌ':Added, #1: 1	قَدَّرَ بَعْضُ
u'قَدْرٌ بَعْضٌ':Added, #1: 1	قَدْرُ بَعْضِ
u'قَدْرٌ بَقاءٌ':Added, #1: 1	قَدْرِ بَعْضِهِ
u'قَدْرٌ بَقْلٌ':Added, #1: 1	قَدْرِ الْبَقَاءِ
u'قَدْرٌ بَقِيَّةٌ':Added, #1: 1	قَدْرِ بَقْلٍ
u'قَدْرٌ بَكارَةٌ':Added, #1: 1	قَدْرَ بَقِيَّةِ
u'قَدْرٌ بَلاءٌ':Added, #1: 1	قَدْرَ الْبَكَارَةِ
u'قَدَّرَ بِنَاءٌ':Predicate, #1: 1	قَدْرِ الْبَلَاءِ
u'قَدْرٌ بِنَاءٌ':Added, #2: 2	قَدَّرَ الْبِنَاءَ
u'قَدْرٌ بِنَاءٌ':Added, #2: 2	قَدْرَ الْبِنَاءِ
u'قَدْرٌ بَنَفْسَجٌ':Added, #2: 2	قَدْرِ الْبِنَاءِ
u'قَدْرٌ بَيْتٌ':Added, #1: 1	قَدْرُ الْبَنَفْسَجِ
u'قَدْرٌ بَيْتٌ':Added, #1: 1	قَدْرَ الْبَيْتِ
u'قَدْرٌ بيض':Added, #1: 1	قَدْرِ الْبَيْتِ
u'قَدْرٌ بَيْعٌ':Added, #1: 1	قَدْرَ الْبَيْضِ
u'قدرة أَبٌ':Added, #1: 1	قَدْرِ الْبَيْعِ
u'قُدْرَةٌ أَبٌ':Added, #1: 1	قُدْرَةِ الْأَبِ
u'قدرة إِثْبَاتٌ':Added, #1: 1	قُدْرَةِ الْأَبِ
u'قُدْرَةٌ إِثْبَاتٌ':Added, #5: 5	قُدْرَةِ إثْبَاتِ
u'قدرة أثَرٌ':Added, #5: 5	قُدْرَةِ إثْبَاتِ
u'قُدْرَةٌ أثَرٌ':Added, #1: 1	قُدْرَةُ أَثَرٍ
u'قدرة أَجِيرٌ':Added, #1: 1	قُدْرَةُ أَثَرٍ
u'قُدْرَةٌ أَجِيرٌ':Added, #2: 2	قُدْرَةُ الْأَجِيرِ
u'قدرة أَدَاءٌ':Added, #2: 2	قُدْرَةُ الْأَجِيرِ
u'قُدْرَةٌ أَدَاءٌ':Added, #2: 2	قُدْرَةِ الْأَدَاءِ
u'قدرة اِسْتِعْمالٌ':Added, #2: 2	قُدْرَةِ الْأَدَاءِ
u'قُدْرَةٌ اِسْتِعْمالٌ':Added, #1: 1	قُدْرَةِ اسْتِعْمَالِ
u'قدرة أَكْثَرُ':Added, #1: 1	قُدْرَةِ اسْتِعْمَالِ
u'قُدْرَةٌ أَكْثَرُ':Added, #1: 1	قُدْرَةُ الْأَكْثَرِ
u'قدرة الْمَرْأَةُ':Added, #1: 1	قُدْرَةُ الْأَكْثَرِ
u'قُدْرَةٌ الْمَرْأَةُ':Added, #1: 1	قُدْرَةِ الْمَرْأَةِ
u'قدرة إِنْسانٌ':Added, #1: 1	قُدْرَةِ الْمَرْأَةِ
u'قُدْرَةٌ إِنْسانٌ':Added, #2: 2	قُدْرَةَ الْإِنْسَانِ
u'قدرة أَوَّلُ':Added, #2: 2	قُدْرَةَ الْإِنْسَانِ
u'قُدْرَةٌ أَوَّلُ':Added, #1: 1	قُدْرَةِ الْأَوَّلِ
u'قدرة بَائِعٌ':Added, #1: 1	قُدْرَةِ الْأَوَّلِ
u'قُدْرَةٌ بَائِعٌ':Added, #1: 1	قُدْرَةَ الْبَائِعِ
u'قدرة تَامٌّ':Added, #1: 1	قُدْرَةَ الْبَائِعِ
u'قُدْرَةٌ تَامٌّ':Added, #1: 1	قُدْرَةٍ تَامَّةٍ
u'قدرة تَسْلِيمٌ':Added, #1: 1	قُدْرَةٍ تَامَّةٍ
u'قُدْرَةٌ تَسْلِيمٌ':Added, #2: 2	قُدْرَةِ تَسْلِيمِهِ
u'قدرة تَشَكُّلٌ':Added, #2: 2	قُدْرَةِ تَسْلِيمِهِ
u'قُدْرَةٌ تَشَكُّلٌ':Added, #1: 1	قُدْرَةَ التَّشَكُّلِ
u'قدرة تَصَرُّفٌ':Added, #1: 1	قُدْرَةَ التَّشَكُّلِ
u'قُدْرَةٌ تَصَرُّفٌ':Added, #1: 1	قُدْرَةُ التَّصَرُّفِ
u'قدرة حامِلٌ':Added, #1: 1	قُدْرَةُ التَّصَرُّفِ
u'قُدْرَةٌ حامِلٌ':Added, #1: 1	قُدْرَةِ الْحَامِلِ
u'قدرة حِفْظٌ':Added, #1: 1	قُدْرَةِ الْحَامِلِ
u'قُدْرَةٌ حِفْظٌ':Added, #2: 2	قُدْرَةُ الْحِفْظِ
u'قدرة حِفْظٌ':Added, #2: 2	قُدْرَةُ الْحِفْظِ
u'قُدْرَةٌ حِفْظٌ':Added, #2: 2	قُدْرَةُ حِفْظِ
u'قدرة حَقِيقٌ':Added, #2: 2	قُدْرَةُ حِفْظِ
u'قُدْرَةٌ حَقِيقٌ':Added, #1: 1	قُدْرَةِ الْحَقِيقَةِ
u'قدرة حَقِيقَةٌ':Added, #1: 1	قُدْرَةِ الْحَقِيقَةِ
u'قُدْرَةٌ حَقِيقَةٌ':Added, #1: 1	قُدْرَةِ الْحَقِيقَةِ
u'قدرة خَالِقٌ':Added, #1: 1	قُدْرَةِ الْحَقِيقَةِ
u'قُدْرَةٌ خَالِقٌ':Added, #1: 1	قُدْرَةِ الْخَالِقِ
u'قدرة خلق':Added, #1: 1	قُدْرَةِ الْخَالِقِ
u'قدرة خَلْقٌ':Added, #3: 3	قُدْرَةُ الْخَلْقِ
u'قُدْرَةٌ خلق':Added, #3: 3	قُدْرَةُ الْخَلْقِ
u'قُدْرَةٌ خَلْقٌ':Added, #3: 3	قُدْرَةُ الْخَلْقِ
u'قدرة رَبُّ':Added, #3: 3	قُدْرَةُ الْخَلْقِ
u'قُدْرَةٌ رَبُّ':Added, #1: 1	قُدْرَةِ الرَّبِّ
u'قدرة رَجُلٌ':Added, #1: 1	قُدْرَةِ الرَّبِّ
u'قُدْرَةٌ رَجُلٌ':Added, #1: 1	قُدْرَةُ الرَّجُلِ
u'قدرة رَسُولٌ':Added, #1: 1	قُدْرَةُ الرَّجُلِ
u'قُدْرَةٌ رَسُولٌ':Added, #1: 1	قُدْرَةِ رَسُولِ
u'قدرة زَوْجَةٌ':Added, #1: 1	قُدْرَةِ رَسُولِ
u'قُدْرَةٌ زَوْجَةٌ':Added, #2: 2	قُدْرَةِ الزَّوْجَةِ
u'قدرة زَيْدٌ':Added, #2: 2	قُدْرَةِ الزَّوْجَةِ
u'قُدْرَةٌ زَيْدٌ':Added, #1: 1	قُدْرَةُ زَيْدٍ
u'قدرة سَفَرٌ':Added, #1: 1	قُدْرَةُ زَيْدٍ
u'قُدْرَةٌ سَفَرٌ':Added, #1: 1	قُدْرَةُ السَّفَرِ
u'قدرة سُلْطَانٌ':Added, #1: 1	قُدْرَةُ السَّفَرِ
u'قُدْرَةٌ سُلْطَانٌ':Added, #1: 1	قُدْرَةَ السُّلْطَانِ
u'قدرة شَاهِدٌ':Added, #1: 1	قُدْرَةَ السُّلْطَانِ
u'قُدْرَةٌ شَاهِدٌ':Added, #1: 1	قُدْرَةِ الشَّاهِدِ
u'قدرة طَاعَةٌ':Added, #1: 1	قُدْرَةِ الشَّاهِدِ
u'قُدْرَةٌ طَاعَةٌ':Added, #3: 3	قُدْرَةَ الطَّاعَةِ
u'قدرة طَبِيعَةٌ':Added, #3: 3	قُدْرَةَ الطَّاعَةِ
u'قُدْرَةٌ طَبِيعَةٌ':Added, #1: 1	قُدْرَةِ الطَّبِيعَةِ
u'قدرة عَاقِدٌ':Added, #1: 1	قُدْرَةِ الطَّبِيعَةِ
u'قُدْرَةٌ عَاقِدٌ':Added, #1: 1	قُدْرَةَ الْعَاقِدِ
u'قدرة عِبَادٌ':Added, #1: 1	قُدْرَةَ الْعَاقِدِ
u'قُدْرَةٌ عِبَادٌ':Added, #1: 1	قُدْرَةِ الْعِبَادِ
u'قدرة عَبْدٌ':Added, #1: 1	قُدْرَةِ الْعِبَادِ
u'قُدْرَةٌ عَبْدٌ':Added, #1: 1	قُدْرَةَ الْعَبْدِ
u'قدرة عَبْدٌ':Added, #1: 1	قُدْرَةَ الْعَبْدِ
u'قُدْرَةٌ عَبْدٌ':Added, #1: 1	قُدْرَةِ عَبْدٍ
u'قدرة عَبْدٌ':Added, #1: 1	قُدْرَةِ عَبْدٍ
u'قُدْرَةٌ عَبْدٌ':Added, #5: 5	قُدْرَةِ الْعَبْدِ
u'قدرة عَمٌّ':Added, #5: 5	قُدْرَةِ الْعَبْدِ
u'قُدْرَةٌ عَمٌّ':Added, #2: 2	قُدْرَةُ الْعَمِّ
u'قدرة غير':Added, #2: 2	قُدْرَةُ الْعَمِّ
u'قدرة غَيْرٌ':Added, #4: 4	قُدْرَةَ الْغَيْرِ
u'قُدْرَةٌ غير':Added, #4: 4	قُدْرَةَ الْغَيْرِ
u'قُدْرَةٌ غَيْرٌ':Added, #4: 4	قُدْرَةَ الْغَيْرِ
u'قدرة فَاعِلٌ':Added, #4: 4	قُدْرَةَ الْغَيْرِ
u'قُدْرَةٌ فَاعِلٌ':Added, #1: 1	قُدْرَةُ الْفَاعِلِ
u'قدرة فَسْخٌ':Added, #1: 1	قُدْرَةُ الْفَاعِلِ
u'قُدْرَةٌ فَسْخٌ':Added, #1: 1	قُدْرَةِ الْفَسْخِ
u'قدرة قَادِرٌ':Added, #1: 1	قُدْرَةِ الْفَسْخِ
u'قُدْرَةٌ قَادِرٌ':Added, #1: 1	قُدْرَةِ الْقَادِرِ
u'قدرة قَادِرٌ':Added, #1: 1	قُدْرَةِ الْقَادِرِ
u'قُدْرَةٌ قَادِرٌ':Added, #1: 1	قُدْرَةِ قَادِرٍ
u'قدرة كَسْبٌ':Added, #1: 1	قُدْرَةِ قَادِرٍ
u'قُدْرَةٌ كَسْبٌ':Added, #1: 1	قُدْرَةُ الْكَسْبِ
u'قدرة كَفِيلٌ':Added, #1: 1	قُدْرَةُ الْكَسْبِ
u'قُدْرَةٌ كَفِيلٌ':Added, #1: 1	قُدْرَةُ الْكَفِيلِ
u'قدرة مَانِعٌ':Added, #1: 1	قُدْرَةُ الْكَفِيلِ
u'قُدْرَةٌ مَانِعٌ':Added, #1: 1	قُدْرَةِ الْمَانِعِ
u'قدرة مُتَكَلِّمٌ':Added, #1: 1	قُدْرَةِ الْمَانِعِ
u'قُدْرَةٌ مُتَكَلِّمٌ':Added, #1: 1	قُدْرَةِ الْمُتَكَلِّمِ
u'قدرة مُحْتَالٌ':Added, #1: 1	قُدْرَةِ الْمُتَكَلِّمِ
u'قُدْرَةٌ مُحْتَالٌ':Added, #1: 1	قُدْرَةُ الْمُحْتَالِ
u'قدرة مُحِيل':Added, #1: 1	قُدْرَةُ الْمُحْتَالِ
u'قُدْرَةٌ مُحِيل':Added, #1: 1	قُدْرَةُ الْمُحِيلِ
u'قدرة مَعْصِيَةٌ':Added, #1: 1	قُدْرَةُ الْمُحِيلِ
u'قدرة مَعْصِيَةٌ':Added, #2: 2	قُدْرَةَ الْمَعْصِيَةِ
u'قُدْرَةٌ مَعْصِيَةٌ':Added, #2: 2	قُدْرَةِ الْمَعْصِيَةِ
u'قُدْرَةٌ مَعْصِيَةٌ':Added, #2: 2	قُدْرَةَ الْمَعْصِيَةِ
u'قدرة مُكْرِهٌ':Added, #2: 2	قُدْرَةِ الْمَعْصِيَةِ
u'قُدْرَةٌ مُكْرِهٌ':Added, #3: 3	قُدْرَةُ الْمُكْرِهِ
u'قدرة مُكَلَّفٌ':Added, #3: 3	قُدْرَةُ الْمُكْرِهِ
u'قُدْرَةٌ مُكَلَّفٌ':Added, #1: 1	قُدْرَةُ الْمُكَلَّفِ
u'قدرة نُزُولٌ':Added, #1: 1	قُدْرَةُ الْمُكَلَّفِ
u'قُدْرَةٌ نُزُولٌ':Added, #1: 1	قُدْرَةُ النُّزُولِ
u'قدرة وُصُولٌ':Added, #1: 1	قُدْرَةُ النُّزُولِ
u'قُدْرَةٌ وُصُولٌ':Added, #1: 1	قُدْرَةُ الْوُصُولِ
u'قدرة وَكِيلٌ':Added, #1: 1	قُدْرَةُ الْوُصُولِ
u'قُدْرَةٌ وَكِيلٌ':Added, #1: 1	قُدْرَةُ الْوَكِيلِ
u'قدرة وَلِيٌّ':Added, #1: 1	قُدْرَةُ الْوَكِيلِ
u'قُدْرَةٌ وَلِيٌّ':Added, #1: 1	قُدْرَةِ الْوَلِيِّ
u'قدرة يَدٌ':Added, #1: 1	قُدْرَةِ الْوَلِيِّ
u'قُدْرَةٌ يَدٌ':Added, #1: 1	قُدْرَةُ الْيَدِ
u'قَدْرٌ تَجَاوُزٌ':Added, #1: 1	قُدْرَةُ الْيَدِ
u'قَدْرٌ تَجْهِيزٌ':Added, #1: 1	قَدْرِ التَّجَاوُزِ
u'قَدْرٌ تَحْرِيم':Added, #2: 2	قَدْرِ التَّجْهِيزِ
u'قَدْرٌ تَحْرِيم':Added, #2: 2	قَدْرَ التَّحْرِيمَةِ
u'قَدْرٌ تَرَبُّصٌ':Added, #2: 2	قَدْرُ التَّحْرِيمَةِ
u'قَدْرٌ تَرِكَةٌ':Added, #1: 1	قَدْرِ التَّرَبُّصِ
u'قَدْرٌ تَرِكَةٌ':Added, #1: 1	قَدْرُ التَّرِكَةِ
u'قَدْرٌ تَرْوِيحَةٌ':Added, #2: 2	قَدْرِ التَّرِكَةِ
u'قَدْرٌ تَرْوِيحَة':Added, #1: 1	قَدْرَ تَرْوِيحَةٍ
u'قَدْرٌ تَسْبِيحَةٌ':Added, #1: 1	قَدْرَ تَرْوِيحَةٍ
u'قَدْرٌ تَسْبِيحَةٌ':Added, #2: 2	قَدْرَ تَسْبِيحَةٍ
u'قَدْرٌ تَسْلِيمٌ':Added, #2: 2	قَدْرُ تَسْبِيحَةٍ
u'قَدْرٌ تَشَهُّدٌ':Added, #1: 1	قَدْرَ التَّسْلِيمِ
u'قَدَرٌ تَشَهُّدٌ':Added, #104: 104	قَدْرَ التَّشَهُّدِ
u'قَدْرٌ تَشَهُّدٌ':Added, #1: 1	قَدَرَ التَّشَهُّدِ
u'قَدْرٌ تَشَهُّدٌ':Added, #1: 1	قَدْرُ التَّشَهُّدِ
u'قَدْرٌ تَضْعِيفٌ':Added, #7: 7	قَدْرِ التَّشَهُّدِ
u'قَدْرٌ تَطْرِيفٌ':Added, #1: 1	قَدْرِ التَّضْعِيفِ
u'قَدْرٌ تَعْزِير':Added, #1: 1	قَدْرَ التَّطْرِيفِ
u'قَدْرٌ تَعْزِير':Added, #1: 1	قَدْرُ تَعْزِيرِ
u'قَدْرٌ تَفاوُت':Added, #3: 3	قَدْرَ التَّعْزِيرِ
u'قَدْرٌ تَفاوُت':Added, #1: 1	قَدْرَ التَّفَاوُتِ
u'قَدْرٌ تَفاوُت':Added, #4: 4	قَدْرُ التَّفَاوُتِ
u'قَدْرٌ تَفْضِيلٌ':Added, #4: 4	قَدْرِ التَّفَاوُتِ
u'قَدْرٌ تَقَاضِي':Added, #1: 1	قَدْرِ تَفْضِيلِهِ
u'قَدْرٌ تَكْبيرٌ':Added, #1: 1	قَدْرُ تَقَاضِيهِ
u'قَدْرٌ تَكْبِير':Added, #1: 1	قَدْرَ تَكْبِيرِ
u'قَدْرٌ تَكْبِير':Added, #1: 1	قَدْرَ تَكْبِيرَةِ
u'قَدْرٌ تَكْبِير':Added, #1: 1	قَدْرِ تَكْبِيرَةٍ
u'قَدْرٌ تَكْبِير':Added, #2: 2	قَدْرَ تَكْبِيرَةٍ
u'قَدْرٌ تَمْر':Added, #5: 5	قَدْرُ تَكْبِيرَةٍ
u'قَدْرٌ ثَابِتٌ':Added, #1: 1	قَدْرُ التَّمْرِ
u'قَدْرٌ ثَانِي':Added, #3: 3	قَدْرِ الثَّابِتِ
u'قَدْرٌ ثَانِي':Added, #1: 1	قَدْرِ الثَّانِيَةِ
u'قَدْرٌ ثَانِيَةٌ':Added, #2: 2	قَدْرُ الثَّانِيَةِ
u'قَدْرٌ ثَانِيَةٌ':Added, #1: 1	قَدْرِ الثَّانِيَةِ
u'قَدْرٌ ثَرْوَة':Added, #2: 2	قَدْرُ الثَّانِيَةِ
u'قَدْرٌ ثَقْبٌ':Added, #1: 1	قَدْرِ الثَّرْوَةِ
u'قَدْرٌ ثَلاثُ':Added, #1: 1	قَدْرَ ثَقْبِ
u'قَدْرٌ ثَلاثُ':Added, #11: 11	قَدْرَ ثَلَاثِ
u'قَدْرٌ ثَلاثُ':Added, #16: 16	قَدْرُ ثَلَاثِ
u'قَدْرٌ ثَلاثَةٌ':Added, #1: 1	قَدْرِ ثَلَاثِ
u'قَدْرٌ ثَلاثَةٌ':Added, #4: 4	قَدْرَ ثَلَاثَةِ
u'قَدْرٌ ثَمانِيَةٌ':Added, #8: 8	قَدْرُ ثَلَاثَةِ
u'قَدَّرَ ثَمَنٌ':Predicate, #1: 1	قَدْرَ ثَمَانِيَةِ
u'قَدَّرَ ثَمَنٌ':Predicate, #1: 1	قَدَّرَ ثَمَنَ
u'قَدْرٌ ثَمَنٌ':Added, #4: 4	قَدَّرَ الثَّمَنَ
u'قَدْرٌ ثَمَنٌ':Added, #12: 12	قَدْرَ الثَّمَنِ
u'قَدْرٌ ثَمَنٌ':Added, #1: 1	قَدْرَ ثَمَنِ
u'قَدْرٌ ثَمَنٌ':Added, #1: 1	قَدْرِ ثَمَنٍ
u'قَدْرٌ ثَمَنٌ':Added, #1: 1	قَدْرَ ثَمَنِهِ
u'قَدْرٌ ثَمَنٌ':Added, #2: 2	قَدْرِ ثَمَنِ
u'قَدْرٌ ثَمَنٌ':Added, #2: 2	قَدْرُ ثَمَنِهِ
u'قَدْرٌ ثَمَنٌ':Added, #38: 38	قَدْرِ الثَّمَنِ
u'قَدْرٌ ثَمَنٌ':Added, #3: 3	قَدْرُ الثَّمَنِ
u'قَدْرٌ ثَوابٌ':Added, #4: 4	قَدْرِ ثَمَنِهِ
u'قَدْرٌ ثَوابٌ':Added, #1: 1	قَدْرِ الثَّوَابِ
u'قَدْرٌ ثَوْبٌ':Added, #1: 1	قَدْرِ ثَوَابٍ
u'قَدْرٌ جَارِي':Added, #1: 1	قَدْرُ ثَوْبٍ
u'قَدْرٌ جَارِيَةٌ':Added, #1: 1	قَدْرَ الْجَارِيَةِ
u'قَدْرٌ جَانِبٌ':Added, #1: 1	قَدْرَ الْجَارِيَةِ
u'قَدْرٌ جَاهٌ':Added, #1: 1	قَدْرُ الْجَانِبِ
u'قَدْرٌ جُرْحٌ':Added, #1: 1	قَدْرِ جَاهِهِ
u'قَدْرٌ جُرْحٌ':Added, #1: 1	قَدْرُ الْجُرْحِ
u'قَدْرٌ جُرْحٌ':Added, #1: 1	قَدْرِ الْجُرْحِ
u'قَدْرٌ جُرْمٌ':Added, #1: 1	قَدْرَ جُرْحِ
u'قَدْرٌ جُزْءٌ':Added, #2: 2	قَدْرِ جُرْمِهِ
u'قَدْرٌ جِزْيَةٌ':Added, #1: 1	قَدْرَ جُزْءٍ
u'قَدْرٌ جَسَدٌ':Added, #4: 4	قَدْرِ الْجِزْيَةِ
u'قَدَّ رَجُلٌ':Subject, #1: 1	قَدْرِ الْجَسَدِ
u'قَدْرٌ جلسة':Added, #1: 1	قَدَّ رَجُلٌ
u'قَدْرٌ جلسة':Added, #1: 1	قَدْرَ جِلْسَةِ
u'قَدْرٌ جَلْسَةٌ':Added, #1: 1	قَدْرِ جَلْسَةِ
u'قَدْرٌ جِلْسَةٌ':Added, #1: 1	قَدْرِ جَلْسَةِ
u'قَدْرٌ جلسة':Added, #1: 1	قَدْرَ جِلْسَةِ
u'قَدْرٌ جِلْسَةٌ':Added, #2: 2	قَدْرُ جِلْسَةِ
u'قَدْرٌ جُلُوسٌ':Added, #2: 2	قَدْرُ جِلْسَةِ
u'قَدْرٌ جُلُوسٌ':Added, #1: 1	قَدْرَ الْجُلُوسِ
u'قَدْرٌ جُلُوسٌ':Added, #1: 1	قَدْرُ الْجُلُوسِ
u'قَدْرٌ جُلُوسٌ':Added, #1: 1	قَدْرِ الْجُلُوسِ
u'قَدْرٌ جَمَاجِمُ':Added, #1: 1	قَدْرَ جُلُوسِ
u'قَدْرٌ جمعة':Added, #1: 1	قَدْرِ الْجَمَاجِمِ
u'قَدْرٌ جُمُعَةٌ':Added, #2: 2	قَدْرَ جُمُعَةٍ
u'قَدْرٌ جَمَلٌ':Added, #2: 2	قَدْرَ جُمُعَةٍ
u'قَدَّرَ جُمْلَةٌ':Predicate, #1: 1	قَدْرَ جَمَلٍ
u'قَدْرٌ جناح':Added, #1: 1	قَدَّرَ الْجُمْلَةَ
u'قَدْرٌ جَنَاحٌ':Added, #1: 1	قَدْرَ جَنَاحِ
u'قَدْرٌ جَهْدٌ':Added, #1: 1	قَدْرَ جَنَاحِ
u'قَدْرٌ حاجَةٌ':Added, #1: 1	قَدْرَ الْجَهْدِ
u'قَدْرٌ حاجَةٌ':Added, #10: 10	قَدْرُ الْحَاجَةِ
u'قَدْرٌ حاجَةٌ':Added, #10: 10	قَدْرِ حَاجَتِهِ
u'قَدْرٌ حاجَةٌ':Added, #14: 14	قَدْرَ الْحَاجَةِ
u'قَدْرٌ حاجَةٌ':Added, #16: 16	قَدْرَ حَاجَتِهِ
u'قَدْرٌ حاجَةٌ':Added, #32: 32	قَدْرِ الْحَاجَةِ
u'قَدْرٌ حاصِلٌ':Added, #5: 5	قَدْرِ حَاجَةِ
u'قَدْرٌ حاصِلٌ':Added, #1: 1	قَدْرَ الْحَاصِلِ
u'قَدَرَ حاكِمٌ':Subject, #1: 1	قَدْرِ الْحَاصِلِ
u'قَدْرٌ حالٌ':Added, #1: 1	قَدَرَ الْحَاكِمُ
u'قَدْرٌ حالٌ':Added, #1: 1	قَدْرِ الْحَالِ
u'قَدْرٌ حالٌ':Added, #5: 5	قَدْرِ حَالِهِ
u'قَدْرٌ حائِطٌ':Added, #7: 7	قَدْرِ حَالِ
u'قَدْرٌ حَبٌّ':Added, #1: 1	قَدْرَ الْحَائِطِ
u'قَدْرٌ حَبٌّ':Added, #1: 1	قَدْرَ الْحَبَّةِ
u'قَدْرٌ حَبَّةٌ':Added, #1: 1	قَدْرِ حَبِّ
u'قَدْرٌ حِجَامَةٌ':Added, #1: 1	قَدْرَ الْحَبَّةِ
u'قَدْرٌ حَجْرٌ':Added, #1: 1	قَدْرَ الْحِجَامَةِ
u'قَدْرٌ حَدٌّ':Added, #1: 1	قَدْرِ الْحَجْرِ
u'قَدَّرَ حَرٌّ':Predicate, #1: 1	قَدْرُ حَدِّ
u'قَدْرٌ حَرامٌ':Added, #1: 1	قَدَّرَ الْحَرَّ
u'قَدْرٌ حَرامٌ':Added, #11: 11	قَدْرَ الْحَرَامِ
u'قَدْرٌ حَرامٌ':Added, #5: 5	قَدْرُ الْحَرَامِ
u'قَدَّرَ حَرْثٌ':Predicate, #8: 8	قَدْرِ الْحَرَامِ
u'قَدْرٌ حُروفٌ':Added, #1: 1	قَدَّرَ الْحَرْثَ
u'قَدْرٌ حُرِّيَّةٌ':Added, #2: 2	قَدْرَ حُرُوفِ
u'قَدْرٌ حَشَفَةٌ':Added, #1: 1	قَدْرِ حُرِّيَّتِهِ
u'قَدْرٌ حَشَفَةٌ':Added, #1: 1	قَدْرِ حَشَفَةٍ
u'قَدْرٌ حَشَفَةٌ':Added, #1: 1	قَدْرَ حَشَفَتِهِ
u'قَدْرٌ حَشَفَةٌ':Added, #5: 5	قَدْرُ الْحَشَفَةِ
u'قَدْرٌ حَشَفَةٌ':Added, #6: 6	قَدْرِ الْحَشَفَةِ
u'قَدْرٌ حَصَاةٌ':Added, #8: 8	قَدْرَ الْحَشَفَةِ
u'قَدْرٌ حِصَّةٌ':Added, #1: 1	قَدْرَ حَصَاةِ
u'قَدْرٌ حِصَّةٌ':Added, #16: 16	قَدْرَ حِصَّتِهِ
u'قَدْرٌ حِصَّةٌ':Added, #2: 2	قَدْرُ الْحِصَّةِ
u'قَدْرٌ حِصَّةٌ':Added, #2: 2	قَدْرَ حِصَّةِ
u'قَدْرٌ حِصَّةٌ':Added, #2: 2	قَدْرِ حِصَّةِ
u'قَدْرٌ حِصَّةٌ':Added, #4: 4	قَدْرِ حِصَّتِهِ
u'قَدَرَ حَصْرٌ':Subject, #7: 7	قَدْرُ حِصَّتِهِ
u'قَدْرٌ حِصَصٌ':Added, #1: 1	قَدَرَ حَصْرُهُ
u'قَدْرٌ حَظٌّ':Added, #6: 6	قَدْرِ الْحِصَصِ
u'قَدْرٌ حَظٌّ':Added, #1: 1	قَدْرُ حَظِّ
u'قَدْرٌ حَظٌّ':Added, #1: 1	قَدْرُ حَظِّهِ
u'قَدْرٌ حَقٌّ':Added, #4: 4	قَدْرَ حَظِّهِ
u'قَدْرٌ حَقٌّ':Added, #10: 10	قَدْرِ حَقِّ
u'قَدْرٌ حَقٌّ':Added, #1: 1	قَدْرِ الْحَقِّ
u'قَدْرٌ حَقٌّ':Added, #1: 1	قَدْرُ حَقِّ
u'قَدْرٌ حَقٌّ':Added, #29: 29	قَدْرِ حَقِّهِ
u'قَدْرٌ حَقٌّ':Added, #30: 30	قَدْرَ حَقِّهِ
u'قَدْرٌ حكمة':Added, #8: 8	قَدْرُ حَقِّهِ
u'قَدْرٌ حِكْمَةٌ':Added, #1: 1	قَدْرَ الْحِكْمَةِ
u'قَدْرٌ حُكُومَةٌ':Added, #1: 1	قَدْرَ الْحِكْمَةِ
u'قَدْرٌ حُكُومَةٌ':Added, #1: 1	قَدْرُ الْحُكُومَةِ
u'قَدْرٌ حَلٌّ':Added, #3: 3	قَدْرِ الْحُكُومَةِ
u'قَدْرٌ حلاب':Added, #1: 1	قَدْرُ الْحَلِّ
u'قَدْرٌ حلب':Added, #1: 1	قَدْرَ الْحِلاَبِ
u'قَدْرٌ حِلْيَةٌ':Added, #1: 1	قَدْرَ حَلْبِهِ
u'قَدْرٌ حَمَامٌ':Added, #1: 1	قَدْرَ الْحِلْيَةِ
u'قَدْرٌ حِمَّصٌ':Added, #2: 2	قَدْرِ الْحَمَامِ
u'قَدْرٌ حِمَّصٌ':Added, #2: 2	قَدْرُ الْحِمَّصَةِ
u'قَدْرٌ حِمَّصٌ':Added, #2: 2	قَدْرِ الْحِمَّصَةِ
u'قَدْرٌ حَمْلٌ':Added, #8: 8	قَدْرَ الْحِمَّصَةِ
u'قَدْرٌ حَوْضٌ':Added, #3: 3	قَدْرَ حَمْلِ
u'قَدْرٌ حَوْضٌ':Added, #1: 1	قَدْرُ الْحَوْضِ
u'قَدْرٌ حَيْضٌ':Added, #3: 3	قَدْرَ الْحَوْضِ
u'قَدْرٌ حَيْضٌ':Added, #10: 10	قَدْرِ الْحَيْضِ
u'قَدْرٌ حَيْضَةٌ':Added, #2: 2	قَدْرُ الْحَيْضِ
u'قَدْرٌ حَيْضَةٌ':Added, #2: 2	قَدْرَ الْحَيْضَةِ
u'قَدْرٌ خَارِجٌ':Added, #2: 2	قَدْرُ الْحَيْضَةِ
u'قَدْرٌ خَارِجٌ':Added, #1: 1	قَدْرَ الْخَارِجِ
u'قَدْرٌ خَالِصٌ':Added, #1: 1	قَدْرِ الْخَارِجِ
u'قَدْرٌ خَالِصٌ':Added, #1: 1	قَدْرِ الْخَالِصِ
u'قَدْرٌ خَالِصٌ':Added, #1: 1	قَدْرِ خَالِصِ
u'قَدْرٌ خَتْم':Added, #3: 3	قَدْرَ الْخَالِصِ
u'قَدْرٌ خدمة':Added, #1: 1	قَدْرَ الْخَتْمَاتِ
u'قَدْرٌ خِدْمَةٌ':Added, #1: 1	قَدْرِ الْخِدْمَةِ
u'قَدْرٌ خراج':Added, #1: 1	قَدْرِ الْخِدْمَةِ
u'قَدْرٌ خَرَاجٌ':Added, #1: 1	قَدْرُ خَرَاجِ
u'قَدْرٌ خراج':Added, #1: 1	قَدْرُ خَرَاجِ
u'قَدْرٌ خراج':Added, #3: 3	قَدْرَ الْخَرَاجِ
u'قَدْرٌ خَرَاجٌ':Added, #3: 3	قَدْرُ الْخَرَاجِ
u'قَدْرٌ خَرَاجٌ':Added, #3: 3	قَدْرَ الْخَرَاجِ
u'قَدْرٌ خراج':Added, #3: 3	قَدْرُ الْخَرَاجِ
u'قَدْرٌ خَرَاجٌ':Added, #4: 4	قَدْرِ الْخَرَاجِ
u'قَدْرٌ خَطٌّ':Added, #4: 4	قَدْرِ الْخَرَاجِ
u'قَدْرٌ خطبة':Added, #1: 1	قَدْرَ الْخَطِّ
u'قَدْرٌ خُطْبَةٌ':Added, #1: 1	قَدْرِ الْخُطْبَةِ
u'قَدْرٌ خطبة':Added, #1: 1	قَدْرِ الْخُطْبَةِ
u'قَدْرٌ خُطْبَةٌ':Added, #2: 2	قَدْرُ الْخُطْبَةِ
u'قَدْرٌ خطر':Added, #2: 2	قَدْرُ الْخُطْبَةِ
u'قَدْرٌ خَطَرٌ':Added, #1: 1	قَدْرِ خَطَرِ
u'قَدْرٌ خُطْوَةٌ':Added, #1: 1	قَدْرِ خَطَرِ
u'قَدْرٌ خُلَفَاءُ':Added, #1: 1	قَدْرَ خُطْوَةٍ
u'قَدَّرَ خَمْرٌ':Predicate, #1: 1	قَدْرُ الْخُلَفَاءِ
u'قَدْرٌ خَمْسٌ':Added, #1: 1	قَدَّرَ الْخَمْرَ
u'قَدْرٌ خُمُسٌ':Added, #1: 1	قَدْرِ خَمْسِ
u'قَدْرٌ خَمْسٌ':Added, #1: 1	قَدْرُ خُمُسِ
u'قَدْرٌ خَمْسَةٌ':Added, #3: 3	قَدْرُ خَمْسِ
u'قَدْرٌ خَمْسَةٌ':Added, #1: 1	قَدْرَ خَمْسَةِ
u'قَدْرٌ خَمْسَةٌ':Added, #1: 1	قَدْرُ خَمْسَةِ
u'قَدْرٌ خِنْصَرٌ':Added, #2: 2	قَدْرَ خَمْسَةٍ
u'قَدْرٌ خِيَانَةٌ':Added, #1: 1	قَدْرَ الْخِنْصَرِ
u'قَدْرٌ خِيَانَةٌ':Added, #2: 2	قَدْرُ الْخِيَانَةِ
u'قَدْرٌ دَائِرَةٌ':Added, #5: 5	قَدْرَ الْخِيَانَةِ
u'قَدْرٌ دَرَاهِمُ':Added, #1: 1	قَدْرُ الدَّائِرَةِ
u'قَدْرٌ دَرَاهِمُ':Added, #1: 1	قَدْرَ دَرَاهِمِهِ
u'قَدْرٌ دَرَجَةٌ':Added, #3: 3	قَدْرِ الدَّرَاهِمِ
u'قَدْرٌ دِرْهَمٌ':Added, #1: 1	قَدْرِ دَرَجَاتِ
u'قَدْرٌ دِرْهَم':Added, #136: 136	قَدْرِ الدِّرْهَمِ
u'قَدْرٌ دِرْهَمٌ':Added, #136: 136	قَدْرِ الدِّرْهَمِ
u'قَدْرٌ دِرْهَم':Added, #18: 18	قَدْرَ الدِّرْهَمِ
u'قَدْرٌ دِرْهَمٌ':Added, #18: 18	قَدْرَ الدِّرْهَمِ
u'قَدْرٌ دِرْهَم':Added, #1: 1	قَدْرَ الدِّرْهَمَيْنِ
u'قَدْرٌ دِرْهَمٌ':Added, #1: 1	قَدْرَ الدِّرْهَمَيْنِ
u'قَدْرٌ دِرْهَم':Added, #1: 1	قَدْرَ دِرْهَمِهِ
u'قَدْرٌ دِرْهَمٌ':Added, #1: 1	قَدْرَ دِرْهَمِهِ
u'قَدْرٌ دِرْهَم':Added, #1: 1	قَدْرُ دِرْهَمَيْنِ
u'قَدْرٌ دِرْهَمٌ':Added, #1: 1	قَدْرُ دِرْهَمَيْنِ
u'قَدْرٌ دِرْهَم':Added, #4: 4	قَدْرَ دِرْهَمٍ
u'قَدْرٌ دِرْهَمٌ':Added, #4: 4	قَدْرَ دِرْهَمٍ
u'قَدْرٌ دِرْهَم':Added, #7: 7	قَدْرُ الدِّرْهَمِ
u'قَدَّرَ دَلْوٌ':Predicate, #7: 7	قَدْرُ الدِّرْهَمِ
u'قَدْرٌ دَمٌ':Added, #2: 2	قَدَّرَ الدَّلْوَ
u'قَدْرٌ دُهْنٌ':Added, #1: 1	قَدْرِ الدَّمِ
u'قَدْرٌ دُهْنٌ':Added, #1: 1	قَدْرُ الدُّهْنِ
u'قَدْرٌ دَواءٌ':Added, #2: 2	قَدْرَ الدُّهْنِ
u'قَدْرٌ دَوْرٌ':Added, #2: 2	قَدْرَ الدَّوَاءِ
u'قَدْرٌ دَوْرٌ':Added, #1: 1	قَدْرِ الدَّوْرِ
u'قَدْرٌ دِيَةٌ':Added, #4: 4	قَدْرَ الدَّوْرِ
u'قَدْرٌ دِيَةٌ':Added, #11: 11	قَدْرِ الدِّيَةِ
u'قَدْرٌ دِيَةٌ':Added, #1: 1	قَدْرَ دِيَةِ
u'قَدْرٌ دِيَةٌ':Added, #2: 2	قَدْرُ دِيَةِ
u'قَدْرٌ دِينٌ':Added, #3: 3	قَدْرَ الدِّيَةِ
u'قَدْرٌ دَيْنٌ':Added, #1: 1	قَدْرِ الدِّينِ
u'قَدْرٌ دَيْنٌ':Added, #1: 1	قَدْرُ الدَّيْنَيْنِ
u'قَدْرٌ دِينٌ':Added, #1: 1	قَدْرِ الدَّيْنَيْنِ
u'قَدْرٌ دَيْنٌ':Added, #1: 1	قَدْرِ دِينِهِ
u'قَدْرٌ دَيْنٌ':Added, #26: 26	قَدْرِ الدَّيْنِ
u'قَدْرٌ دَيْنٌ':Added, #2: 2	قَدْرِ دَيْنِهِ
u'قَدْرٌ دَيْنٌ':Added, #33: 33	قَدْرَ الدَّيْنِ
u'قَدْرٌ دَيْنٌ':Added, #3: 3	قَدْرُ الدَّيْنِ
u'قَدْرٌ دَيْنٌ':Added, #3: 3	قَدْرَ دَيْنِهِ
u'قَدْرٌ دِينارٌ':Added, #4: 4	قَدْرُ دَيْنِهِ
u'قَدْرٌ ذاهِب':Added, #1: 1	قَدْرُ الدِّينَارِ
u'قَدْرٌ ذِراعٌ':Added, #1: 1	قَدْرُ الذَّاهِبِ
u'قَدْرٌ ذِراعٌ':Added, #10: 10	قَدْرَ ذِرَاعٍ
u'قَدْرٌ ذِراعٌ':Added, #1: 1	قَدْرُ الذِّرَاعِ
u'قَدْرٌ ذِراعٌ':Added, #1: 1	قَدْرِ الذِّرَاعِ
u'قَدْرٌ ذِراعٌ':Added, #1: 1	قَدْرِ ذِرَاعَيْنِ
u'قَدْرٌ ذِراعٌ':Added, #2: 2	قَدْرَ ذِرَاعَيْنِ
u'قَدْرٌ ذِراعٌ':Added, #4: 4	قَدْرَ الذِّرَاعِ
u'قَدْرٌ ذُرْعانٌ':Added, #4: 4	قَدْرُ ذِرَاعٍ
u'قَدْرٌ ذُرْعانٌ':Added, #2: 2	قَدْرَ ذُرْعَانِ
u'قَدْرٌ ذَنْبٌ':Added, #2: 2	قَدْرِ ذُرْعَانِ
u'قَدْرٌ ذَهَابٌ':Added, #2: 2	قَدْرِ الذَّنْبِ
u'قَدْرٌ ذَهَابٌ':Added, #1: 1	قَدْرَ ذَهَابِهِ
u'قَدْرٌ ذَهَبٌ':Added, #1: 1	قَدْرُ ذَهَابِهِ
u'قَدْرٌ ذَهَبٌ':Added, #1: 1	قَدْرُ الذَّهَبِ
u'قَدْرٌ رَاحَةٌ':Added, #2: 2	قَدْرِ الذَّهَبِ
u'قَدْرٌ رَأْسٌ':Added, #2: 2	قَدْرَ الرَّاحَةِ
u'قَدْرٌ رَأْسٌ':Added, #2: 2	قَدْرُ رَأْسِ
u'قَدْرٌ رَأْسٌ':Added, #40: 40	قَدْرِ رَأْسِ
u'قَدْرٌ رِبْحٌ':Added, #5: 5	قَدْرَ رَأْسِ
u'قَدْرٌ رُبُعٌ':Added, #8: 8	قَدْرِ الرِّبْحِ
u'قَدْرٌ رُبُعٌ':Added, #1: 1	قَدْرَ الرُّبُعِ
u'قَدْرٌ رُبُعٌ':Added, #1: 1	قَدْرَ رُبُعِهِ
u'قَدْرٌ رُبُعٌ':Added, #1: 1	قَدْرُ رُبُعِهِ
u'قَدْرٌ رُبُعٌ':Added, #2: 2	قَدْرُ الرُّبُعِ
u'قَدْرٌ رُبْعٌ':Added, #2: 2	قَدْرِ الرُّبُعِ
u'قَدْرٌ رُبُعٌ':Added, #3: 3	قَدْرَ الرُّبْعِ
u'قَدْرٌ رُبْعٌ':Added, #3: 3	قَدْرَ رُبُعِ
u'قَدْرٌ رُبْعٌ':Added, #5: 5	قَدْرَ رُبْعِ
u'قَدْرٌ رُبْعٌ':Added, #5: 5	قَدْرُ رُبْعِ
u'قَدْرٌ رُبُوبِيٌّ':Added, #6: 6	قَدْرُ الرُّبْعِ
u'قَدَرَ رَجُلٌ':Subject, #1: 1	قَدْرَ الرُّبُوبِيَّةِ
u'قَدْرٌ رَجُلٌ':Added, #1: 1	قَدَرَ الرَّجُلُ
u'قَدْرٌ رُجُوعٌ':Added, #2: 2	قَدْرِ الرَّجُلِ
u'قَدَّرَ رَحْمَن':Subject, #1: 1	قَدْرَ رُجُوعٍ
u'قَدَّرَ رَدٌّ':Predicate, #1: 1	قَدَّرَ الرَّحْمَنُ
u'قَدْرٌ رَسُولٌ':Added, #1: 1	قَدَّرَ الرَّدَّ
u'قَدْرٌ رَضْخ':Added, #1: 1	قَدْرِ الرَّسُولِ
u'قَدَّرَ رِطْلٌ':Predicate, #1: 1	قَدْرِ الرَّضْخِ
u'قَدْرٌ رِطْلٌ':Added, #1: 1	قَدَّرَ الرِّطْلَ
u'قَدْرٌ رَغْبَةٌ':Added, #2: 2	قَدْرُ الرِّطْلِ
u'قَدْرٌ رِقٌّ':Added, #2: 2	قَدْرِ الرَّغْبَةِ
u'قَدْرٌ رَقَب':Added, #2: 2	قَدْرَ رِقِّهِ
u'قَدْرٌ رَقْمٌ':Added, #1: 1	قَدْرَ الرَّقَبَتَيْنِ
u'قَدْرٌ رَقْم':Added, #2: 2	قَدْرَ الرَّقْمِ
u'قَدْرٌ ركعة':Added, #2: 2	قَدْرَ الرَّقْمِ
u'قَدْرٌ رَكْعَةٌ':Added, #1: 1	قَدْرُ الرَّكْعَةِ
u'قَدْرٌ ركعة':Added, #1: 1	قَدْرُ الرَّكْعَةِ
u'قَدْرٌ رَكْعَةٌ':Added, #2: 2	قَدْرَ رَكْعَةٍ
u'قَدْرٌ ركعة':Added, #2: 2	قَدْرَ رَكْعَةٍ
u'قَدْرٌ رَكْعَةٌ':Added, #3: 3	قَدْرُ رَكْعَةٍ
u'قَدْرٌ رُكْنٌ':Added, #3: 3	قَدْرُ رَكْعَةٍ
u'قَدْرٌ رُكْن':Added, #1: 1	قَدْرُ الرُّكْنِ
u'قَدْرٌ رُكْنٌ':Added, #1: 1	قَدْرُ الرُّكْنِ
u'قَدْرٌ رُكْنٌ':Added, #1: 1	قَدْرُ رُكْنٍ
u'قَدْرٌ رُكْن':Added, #1: 1	قَدْرِ رُكْنٍ
u'قَدْرٌ رُكْن':Added, #1: 1	قَدْرُ رُكْنٍ
u'قَدْرٌ رُكوعٌ':Added, #1: 1	قَدْرِ رُكْنٍ
u'قَدْرٌ رُكوعٌ':Added, #1: 1	قَدْرِ الرُّكُوعِ
u'قَدْرٌ رُكوعٌ':Added, #1: 1	قَدْرِ رُكُوعِ
u'قَدْرٌ رُكوعٌ':Added, #1: 1	قَدْرِ رُكُوعِهِ
u'قَدْرٌ رُمَّانٌ':Added, #3: 3	قَدْرَ رُكُوعِهِ
u'قَدْرٌ رُمْحٌ':Added, #1: 1	قَدْرُ الرُّمَّانِ
u'قَدْرٌ رُمْحٌ':Added, #1: 1	قَدْرَ رُمْحِ
u'قَدْرٌ رُمْحٌ':Added, #2: 2	قَدْرُ رُمْحٍ
u'قَدْرٌ رُمْحٌ':Added, #2: 2	قَدْرِ رُمْحٍ
u'قَدْرٌ رَمْيٌ':Added, #6: 6	قَدْرَ رُمْحٍ
u'قَدْرٌ رَهْنٌ':Added, #1: 1	قَدْرَ رَمْيِ
u'قَدْرٌ ريعٌ':Added, #6: 6	قَدْرِ الرَّهْنِ
u'قَدْرٌ رَيْعٌ':Added, #1: 1	قَدْرَ رَيْعِ
u'قَدْرٌ زادٌ':Added, #1: 1	قَدْرَ رَيْعِ
u'قَدْرٌ زائِدٌ':Added, #1: 1	قَدْرَ الزَّادِ
u'قَدْرٌ زَكاةٌ':Added, #1: 1	قَدْرٍ زَائِدٍ
u'قَدْرٌ زَكاةٌ':Added, #10: 10	قَدْرُ الزَّكَاةِ
u'قَدْرٌ زَكاةٌ':Added, #1: 1	قَدْرُ زَكَاةِ
u'قَدْرٌ زَكاةٌ':Added, #1: 1	قَدْرَ زَكَاتِهِ
u'قَدْرٌ زَكاةٌ':Added, #1: 1	قَدْرُ زَكَاتِهِ
u'قَدْرٌ زَكاةٌ':Added, #20: 20	قَدْرِ الزَّكَاةِ
u'قَدْرٌ زَكاةٌ':Added, #25: 25	قَدْرَ الزَّكَاةِ
u'قَدْرٌ زَمانٌ':Added, #2: 2	قَدْرَ زَكَاةِ
u'قَدْرٌ زَمَنٌ':Added, #2: 2	قَدْرِ الزَّمَانِ
u'قَدْرٌ زَمَنٌ':Added, #1: 1	قَدْرُ الزَّمَنِ
u'قَدْرٌ زَمَنٌ':Added, #1: 1	قَدْرَ زَمَنِهِ
u'قَدْرٌ زَمَنٌ':Added, #2: 2	قَدْرِ الزَّمَنِ
u'قَدَرَ زَوْجٌ':Subject, #4: 4	قَدْرُ زَمَنِ
u'قَدَرَ زَوْجٌ':Subject, #1: 1	قَدَرَ زَوْجُ
u'قَدَّرَ زِيادَةٌ':Predicate, #2: 2	قَدَرَ الزَّوْجُ
u'قَدْرٌ زِيادَةٌ':Added, #1: 1	قَدَّرَ الزِّيَادَةَ
u'قَدْرٌ زِيادَةٌ':Added, #1: 1	قَدْرَ زِيَادَةِ
u'قَدْرٌ زِيادَةٌ':Added, #1: 1	قَدْرِ زِيَادَتِهِ
u'قَدْرٌ زِيادَةٌ':Added, #3: 3	قَدْرَ الزِّيَادَةِ
u'قَدْرٌ سَابِقٌ':Added, #8: 8	قَدْرِ الزِّيَادَةِ
u'قَدْرٌ سَاحَةٌ':Added, #1: 1	قَدْرِ السَّابِقَةِ
u'قَدْرٌ سَاقِطٌ':Added, #1: 1	قَدْرَ السَّاحَةِ
u'قَدَّرَ سَبَبٌ':Predicate, #1: 1	قَدْرَ السَّاقِطِ
u'قَدْرٌ سِتٌّ':Added, #2: 2	قَدَّرَ السَّبَبَ
u'قَدْرٌ سِتٌّ':Added, #2: 2	قَدْرَ سِتَّةِ
u'قَدْرٌ سَتْرٌ':Added, #2: 2	قَدْرُ سِتَّةِ
u'قَدْرٌ سترة':Added, #1: 1	قَدْرَ سَتْرِ
u'قَدْرٌ سُتْرَةٌ':Added, #1: 1	قَدْرِ السُّتْرَةِ
u'قَدْرٌ سَخْلَة':Added, #1: 1	قَدْرِ السُّتْرَةِ
u'قَدْرٌ سَدٌّ':Added, #1: 1	قَدْرَ السَّخْلَةِ
u'قَدْرٌ سَدٌّ':Added, #1: 1	قَدْرَ سَدِّ
u'قَدْرٌ سَرقَةٌ':Added, #1: 1	قَدْرِ سَدِّ
u'قَدْرٌ سَرِقَةٌ':Added, #1: 1	قَدْرَ السَّرِقَةِ
u'قَدْرٌ سُرُورٌ':Added, #1: 1	قَدْرَ السَّرِقَةِ
u'قَدْرٌ سَعَةٌ':Added, #1: 1	قَدْرِ السُّرُورِ
u'قَدْرٌ سَفَرٌ':Added, #1: 1	قَدْرِ سَعَةِ
u'قَدْرٌ سَقْيٌ':Added, #1: 1	قَدْرَ سَفَرٍ
u'قَدْرٌ سُكَّانٌ':Added, #1: 1	قَدْرَ سَقْيِهِ
u'قَدْرٌ سكتة':Added, #1: 1	قَدْرِ السُّكَّانِ
u'قَدْرٌ سَكْتَةٌ':Added, #1: 1	قَدْرَ السَّكْتَةِ
u'قَدْرٌ سلام':Added, #1: 1	قَدْرَ السَّكْتَةِ
u'قَدْرٌ سَلاَمٌ':Added, #2: 2	قَدْرِ السَّلَامِ
u'قَدْرٌ سَلَمٌ':Added, #2: 2	قَدْرِ السَّلَامِ
u'قَدْرٌ سَمَاعٌ':Added, #1: 1	قَدْرَ السَّلَمِ
u'قَدْرٌ سِمْسِم':Added, #1: 1	قَدْرِ سَمَاعِ
u'قَدْرٌ سِمْسِم':Added, #1: 1	قَدْرَ سِمْسِمَةٍ
u'قَدْرٌ سِنٌّ':Added, #1: 1	قَدْرِ سِمْسِمَةٍ
u'قَدْرٌ سَنَامٌ':Added, #1: 1	قَدْرِ سِنِّ
u'قَدْرٌ سَنَةٌ':Added, #1: 1	قَدْرِ السَّنَامِ
u'قَدْرٌ سُنَّةٌ':Added, #1: 1	قَدْرُ السَّنَةِ
u'قَدْرٌ سهام':Added, #2: 2	قَدْرِ السُّنَّةِ
u'قَدْرٌ سِهَامٌ':Added, #6: 6	قَدْرِ سِهَامِ
u'قَدْرٌ سَهْمٌ':Added, #6: 6	قَدْرِ سِهَامِ
u'قَدْرٌ سَهْمٌ':Added, #1: 1	قَدْرِ سَهْمِ
u'قَدْرٌ سُورَةٌ':Added, #1: 1	قَدْرَ سَهْمِهِ
u'قَدْرٌ سُورَةٌ':Added, #1: 1	قَدْرَ سُورَةٍ
u'قَدْرٌ سُورَةٌ':Added, #1: 1	قَدْرَ سُورَةِ
u'قَدْرٌ سُورَةٌ':Added, #1: 1	قَدْرُ سُورَةٍ
u'قَدْرٌ سَوْطٌ':Added, #2: 2	قَدْرَ السُّورَةِ
u'قَدْرٌ سَيْرٌ':Added, #1: 1	قَدْرُ سَوْطِ
u'قَدْرٌ شِبْرٌ':Added, #1: 1	قَدْرِ السَّيْرِ
u'قَدْرٌ شِبْرٌ':Added, #1: 1	قَدْرَ الشِّبْرِ
u'قَدْرٌ شِبْرٌ':Added, #1: 1	قَدْرِ الشِّبْرِ
u'قَدْرٌ شِبْرٌ':Added, #4: 4	قَدْرَ شِبْرَيْنِ
u'قَدْرٌ شِبَعٌ':Added, #9: 9	قَدْرَ شِبْرٍ
u'قَدْرٌ شِبَعٌ':Added, #1: 1	قَدْرَ الشِّبَعِ
u'قَدْرٌ شَجَّةٌ':Added, #1: 1	قَدْرِ الشِّبَعِ
u'قَدْرٌ شُخُوصٌ':Added, #2: 2	قَدْرُ شَجَّتِهِ
u'قَدْرٌ شراك':Added, #1: 1	قَدْرِ شُخُوصِ
u'قَدْرٌ شِرَاكٌ':Added, #2: 2	قَدْرَ الشِّرَاكِ
u'قَدْرٌ شرب':Added, #2: 2	قَدْرَ الشِّرَاكِ
u'قَدْرٌ شرب':Added, #1: 1	قَدْرَ الشِّرْبِ
u'قَدْرٌ شِرْبٌ':Added, #1: 1	قَدْرِ الشِّرْبِ
u'قَدْرٌ شِرْبٌ':Added, #1: 1	قَدْرَ الشِّرْبِ
u'قَدَّرَ شَرْعٌ':Subject, #1: 1	قَدْرِ الشِّرْبِ
u'قَدْرٌ شَقٌّ':Added, #3: 3	قَدَّرَ الشَّرْعُ
u'قَدْرٌ شَوْقٌ':Added, #1: 1	قَدْرِ الشَّقِّ
u'قَدْرٌ شَيْءٌ':Added, #1: 1	قَدْرِ الشَّوْقِ
u'قَدْرٌ شَيْنٌ':Added, #1: 1	قَدْرِ الشَّيْءِ
u'قَدَّرَ صَاحِبٌ':Subject, #1: 1	قَدْرِ الشَّيْنِ
u'قَدْرٌ صَاعٌ':Added, #1: 1	قَدَّرَ صَاحِبُ
u'قَدْرٌ صَاعٌ':Added, #1: 1	قَدْرَ الصَّاعِ
u'قَدْرٌ صَاعٌ':Added, #1: 1	قَدْرِ الصَّاعِ
u'قَدْرٌ صَاعٌ':Added, #1: 1	قَدْرُ صَاعٍ
u'قَدْرٌ صبر':Added, #2: 2	قَدْرَ صَاعٍ
u'قَدْرٌ صَبْرٌ':Added, #1: 1	قَدْرَ الصَّبْرِ
u'قَدْرٌ صبرة':Added, #1: 1	قَدْرَ الصَّبْرِ
u'قَدْرٌ صُبْرَةٌ':Added, #1: 1	قَدْرَ الصُّبْرَةِ
u'قَدْرٌ صَحَابَةٌ':Added, #1: 1	قَدْرَ الصُّبْرَةِ
u'قَدْرٌ صداق':Added, #1: 1	قَدْرَ الصَّحَابَةِ
u'قَدْرٌ صَدَاقٌ':Added, #1: 1	قَدْرَ الصَّدَاقِ
u'قَدْرٌ صداق':Added, #1: 1	قَدْرَ الصَّدَاقِ
u'قَدْرٌ صَدَاقٌ':Added, #1: 1	قَدْرَ صَدَاقِ
u'قَدْرٌ صداق':Added, #1: 1	قَدْرَ صَدَاقِ
u'قَدْرٌ صَدَاقٌ':Added, #5: 5	قَدْرِ الصَّدَاقِ
u'قَدْرٌ صدقة':Added, #5: 5	قَدْرِ الصَّدَاقِ
u'قَدْرٌ صدقة':Added, #1: 1	قَدْرُ الصَّدَقَةِ
u'قَدْرٌ صَدَقَةٌ':Added, #1: 1	قَدْرِ الصَّدَقَةِ
u'قَدْرٌ صَدَقَةٌ':Added, #1: 1	قَدْرُ الصَّدَقَةِ
u'قَدْرٌ صدقة':Added, #1: 1	قَدْرِ الصَّدَقَةِ
u'قَدْرٌ صَدَقَةٌ':Added, #1: 1	قَدْرَ صَدَقَةٍ
u'قَدْرٌ صِغَرٌ':Added, #1: 1	قَدْرَ صَدَقَةٍ
u'قَدْرٌ صَفٌّ':Added, #1: 1	قَدْرِ الصِّغَرِ
u'قَدْرٌ صَفٌّ':Added, #1: 1	قَدْرِ الصَّفَّيْنِ
u'قَدْرٌ صَفٌّ':Added, #1: 1	قَدْرَ صَفَّيْنِ
u'قَدْرٌ صَفٌّ':Added, #1: 1	قَدْرُ صَفَّيْنِ
u'قَدْرٌ صُفُوفٌ':Added, #1: 1	قَدْرِ صَفَّيْنِ
u'قَدْرٌ صَلاَةٌ':Added, #2: 2	قَدْرَ الصُّفُوفِ
u'قَدْرٌ صَلاَةٌ':Added, #1: 1	قَدْرَ صَلَاةٍ
u'قَدْرٌ صَلاَةٌ':Added, #1: 1	قَدْرُ صَلَاةٍ
u'قَدْرٌ صَلاَةٌ':Added, #1: 1	قَدْرِ صَلَاةٍ
u'قَدْرٌ صَلاَةٌ':Added, #2: 2	قَدْرَ الصَّلَاةِ
u'قَدْرٌ صَلاَةٌ':Added, #2: 2	قَدْرِ الصَّلَاةِ
u'قَدْرٌ صَلاَةٌ':Added, #2: 2	قَدْرَ صَلَاةِ
u'قَدْرٌ صَلاَةٌ':Added, #2: 2	قَدْرُ صَلاَةِ
u'قَدْرٌ صَلاَةٌ':Added, #3: 3	قَدْرُ الصَّلَاةِ
u'قَدْرٌ صَنْج':Added, #3: 3	قَدْرُ صَلَاةِ
u'قَدْرٌ صَنْج':Added, #1: 1	قَدْرَ الصَّنْجَةِ
u'قَدْرٌ صِيَاغَةٌ':Added, #1: 1	قَدْرُ صَنْجَةِ
u'قَدْرٌ صِيَامٌ':Added, #1: 1	قَدْرَ الصِّيَاغَةِ
u'قَدْرٌ ضَرَرٌ':Added, #1: 1	قَدْرَ الصِّيَامِ
u'قَدْرٌ ضَرَرٌ':Added, #1: 1	قَدْرِ الضَّرَرِ
u'قَدْرٌ ضَرُورَةٌ':Added, #1: 1	قَدْرُ ضَرَرِ
u'قَدْرٌ ضَمَانٌ':Added, #1: 1	قَدْرِ الضَّرُورَةِ
u'قَدْرٌ ضَمَانٌ':Added, #1: 1	قَدْرَ الضَّمَانِ
u'قَدْرٌ ضَمَانٌ':Added, #1: 1	قَدْرُ ضَمَانِهِ
u'قَدْرٌ ضَمَانٌ':Added, #2: 2	قَدْرُ الضَّمَانِ
u'قَدْرٌ ضِيَافَةٌ':Added, #5: 5	قَدْرِ الضَّمَانِ
u'قَدْرٌ ضِيَافَةٌ':Added, #1: 1	قَدْرَ الضِّيَافَةِ
u'قَدْرٌ طَاقٌ':Added, #1: 1	قَدْرِ الضِّيَافَةِ
u'قَدْرٌ طَاقَةٌ':Added, #1: 1	قَدْرَ الطَّاقَتَيْنِ
u'قَدْرٌ طَاقَةٌ':Added, #1: 1	قَدْرَ الطَّاقَةِ
u'قَدْرٌ طَاقَةٌ':Added, #1: 1	قَدْرِ الطَّاقَةِ
u'قَدْرٌ طَاقَةٌ':Added, #1: 1	قَدْرُ طَاقَةِ
u'قَدْرٌ طَاقَةٌ':Added, #1: 1	قَدْرَ طَاقَتِهِ
u'قَدْرٌ طَاقَةٌ':Added, #3: 3	قَدْرِ طَاقَةِ
u'قَدْرٌ طحن':Added, #4: 4	قَدْرِ طَاقَتِهِ
u'قَدْرٌ طَرِيقٌ':Added, #1: 1	قَدْرَ طَحْنِهِ
u'قَدْرٌ طَرِيقٌ':Added, #1: 1	قَدْرِ الطَّرِيقِ
u'قَدْرٌ طعام':Added, #2: 2	قَدْرَ الطَّرِيقِ
u'قَدْرٌ طَعَامٌ':Added, #1: 1	قَدْرِ الطَّعَامِ
u'قَدْرٌ طلب':Added, #1: 1	قَدْرِ الطَّعَامِ
u'قَدْرٌ طَلَبٌ':Added, #1: 1	قَدْرَ الطَّلَبِ
u'قَدْرٌ طُمَأْنِينَةٌ':Added, #1: 1	قَدْرَ الطَّلَبِ
u'قَدْرٌ طَهَارَةٌ':Added, #1: 1	قَدْرِ الطُّمَأْنِينَةِ
u'قَدْرٌ طَهَارَةٌ':Added, #1: 1	قَدْرُ الطَّهَارَةِ
u'قَدْرٌ طهر':Added, #1: 1	قَدْرِ الطَّهَارَةِ
u'قَدْرٌ طُهْرٌ':Added, #3: 3	قَدْرُ الطُّهْرِ
u'قَدْرٌ طهر':Added, #3: 3	قَدْرُ الطُّهْرِ
u'قَدْرٌ طُهْرٌ':Added, #5: 5	قَدْرِ الطُّهْرِ
u'قَدْرٌ طَوْقٌ':Added, #5: 5	قَدْرِ الطُّهْرِ
u'قَدْرٌ طُولٌ':Added, #1: 1	قَدْرَ الطَّوْقِ
u'قَدْرٌ طُولٌ':Added, #1: 1	قَدْرِ طُولِ
u'قَدْرٌ طُولٌ':Added, #1: 1	قَدْرَ طُولِهِ
u'قَدْرٌ ظُفْرٌ':Added, #2: 2	قَدْرَ طُولِ
u'قَدْرٌ ظِلٌّ':Added, #3: 3	قَدْرَ الظُّفْرِ
u'قَدْرٌ ظِلٌّ':Added, #1: 1	قَدْرَ ظِلِّهِ
u'قَدْرٌ ظِلٌّ':Added, #2: 2	قَدْرَ ظِلِّ
u'قَدْرٌ ظُلْمٌ':Added, #2: 2	قَدْرِ ظِلِّهِ
u'قَدْرٌ ظُلْمٌ':Added, #1: 1	قَدْرِ الظُّلْمِ
u'قَدَرَ عَاجِزٌ':Subject, #2: 2	قَدْرَ ظُلْمِهِ
u'قَدْرٌ عَادَةٌ':Added, #2: 2	قَدَرَ الْعَاجِزُ
u'قَدْرٌ عَادَةٌ':Added, #1: 1	قَدْرَ عَادَةِ
u'قَدْرٌ عَادَةٌ':Added, #1: 1	قَدْرِ عَادَةِ
u'قَدْرٌ عَادَةٌ':Added, #5: 5	قَدْرِ الْعَادَةِ
u'قَدَرَ عتق':Predicate, #8: 8	قَدْرَ الْعَادَةِ
u'قَدَرَ عِتْقٌ':Predicate, #1: 1	قَدَرَ عِتْقَ
u'قَدْرٌ عتق':Added, #1: 1	قَدَرَ عِتْقَ
u'قَدْرٌ عِتْقٌ':Added, #1: 1	قَدْرَ الْعِتْقِ
u'قَدْرٌ عَدَسَةٌ':Added, #1: 1	قَدْرَ الْعِتْقِ
u'قَدَّرَ عَدْلٌ':Subject, #1: 1	قَدْرَ الْعَدَسَةِ
u'قَدْرٌ عَرْضٌ':Added, #1: 1	قَدَّرَ الْعَدْلُ
u'قَدْرٌ عَرْضٌ':Added, #1: 1	قَدْرَ عَرْضِ
u'قَدْرٌ عَرْضٌ':Added, #3: 3	قَدْرِ عَرْضِ
u'قَدْرٌ عرف':Added, #4: 4	قَدْرُ عَرْضِ
u'قَدْرٌ عُرْفٌ':Added, #1: 1	قَدْرِ الْعُرْفِ
u'قَدْرٌ عَرَقٌ':Added, #1: 1	قَدْرِ الْعُرْفِ
u'قَدْرٌ عسر':Added, #1: 1	قَدْرَ الْعَرَقِ
u'قَدْرٌ عُسْرٌ':Added, #1: 1	قَدْرِ عُسْرِهِ
u'قَدْرٌ عُشْرٌ':Added, #1: 1	قَدْرِ عُسْرِهِ
u'قَدْرٌ عَشْرٌ':Added, #1: 1	قَدْرُ الْعُشْرِ
u'قَدْرٌ عُشْرٌ':Added, #1: 1	قَدْرُ عَشْرِ
u'قَدْرٌ عُصْفُر':Added, #2: 2	قَدْرَ الْعُشْرِ
u'قَدْرٌ عُضْوٌ':Added, #1: 1	قَدْرَ الْعُصْفُرِ
u'قَدْرٌ عَظْمٌ':Added, #1: 1	قَدْرِ الْعُضْوِ
u'قَدْرٌ عِظَمٌ':Added, #1: 1	قَدْرَ عَظْمِ
u'قَدَّرَ عَفْوٌ':Predicate, #3: 3	قَدْرِ عِظَمِ
u'قَدْرٌ عَقْلٌ':Added, #1: 1	قَدَّرَ الْعَفْوَ
u'قَدْرٌ عُقُولٌ':Added, #3: 3	قَدْرِ عَقْلِهِ
u'قَدْرٌ علم':Added, #1: 1	قَدْرِ الْعُقُولِ
u'قَدْرٌ عِلْمٌ':Added, #1: 1	قَدْرِ الْعِلْمِ
u'قَدْرٌ علم':Added, #1: 1	قَدْرِ الْعِلْمِ
u'قَدْرٌ عِلْمٌ':Added, #2: 2	قَدْرِ عِلْمِهِ
u'قَدَّرَ علماء':Subject, #2: 2	قَدْرِ عِلْمِهِ
u'قَدَّرَ عُلَمَاءُ':Subject, #1: 1	قَدَّرَ الْعُلَمَاءُ
u'قَدْرٌ عُلُوٌّ':Added, #1: 1	قَدَّرَ الْعُلَمَاءُ
u'قَدْرٌ عِمَامَةٌ':Added, #1: 1	قَدْرَ عُلُوِّ
u'قَدْرٌ عِمَامَةٌ':Added, #1: 1	قَدْرُ عِمَامَةِ
u'قَدْرٌ عُمْقٌ':Added, #1: 1	قَدْرَ عِمَامَتِهِ
u'قَدْرٌ عَمَلٌ':Added, #1: 1	قَدْرُ عُمْقِ
u'قَدْرٌ عَمَلٌ':Added, #1: 1	قَدْرِ عَمَلِهِ
u'قَدْرٌ عَمَلٌ':Added, #2: 2	قَدْرَ عَمَلِ
u'قَدْرٌ عَمَلٌ':Added, #4: 4	قَدْرَ عَمَلِهِ
u'قَدْرٌ عَنَاءٌ':Added, #6: 6	قَدْرِ الْعَمَلِ
u'قَدْرٌ عِنَايَةٌ':Added, #1: 1	قَدْرِ الْعَنَاءِ
u'قَدْرٌ عَوْرَةٌ':Added, #1: 1	قَدْرِ الْعِنَايَةِ
u'قَدَّرَ عِوَضٌ':Predicate, #1: 1	قَدْرِ الْعَوْرَةِ
u'قَدْرٌ عِوَضٌ':Added, #1: 1	قَدَّرَ الْعِوَضَ
u'قَدْرٌ عِوَضٌ':Added, #1: 1	قَدْرِ عِوَضِهِ
u'قَدَّرَ عَيْبٌ':Predicate, #5: 5	قَدْرِ الْعِوَضِ
u'قَدْرٌ عَيْبٌ':Added, #1: 1	قَدَّرَ الْعَيْبَ
u'قَدْرٌ عَيْبٌ':Added, #1: 1	قَدْرَ الْعَيْبِ
u'قَدْرٌ عَيْبٌ':Added, #1: 1	قَدْرُ الْعَيْبِ
u'قَدْرٌ عَيْشٌ':Added, #1: 1	قَدْرَ عَيْبِهِ
u'قَدْرٌ عَيْنٌ':Added, #1: 1	قَدْرَ عَيْشِهِ
u'قَدْرٌ عَيْن':Added, #1: 1	قَدْرِ عَيْنٍ
u'قَدْرٌ عين':Added, #1: 1	قَدْرِ عَيْنٍ
u'قَدْرٌ عَيْنٌ':Added, #1: 1	قَدْرُ عَيْنِهِ
u'قَدْرٌ عَيْن':Added, #1: 1	قَدْرُ عَيْنِهِ
u'قَدَرَ غَاصِبٌ':Subject, #1: 1	قَدْرُ عَيْنِهِ
u'قَدْرٌ غُرَّةٌ':Added, #1: 1	قَدَرَ الْغَاصِبُ
u'قَدْرٌ غُرْمٌ':Added, #2: 2	قَدْرِ الْغُرَّةِ
u'قَدْرٌ غُسْلٌ':Added, #1: 1	قَدْرُ غُرْمِهِ
u'قَدْرٌ غِشٌّ':Added, #4: 4	قَدْرُ الْغُسْلِ
u'قَدْرٌ غِشٌّ':Added, #1: 1	قَدْرِ الْغِشِّ
u'قَدْرٌ غِشٌّ':Added, #1: 1	قَدْرِ غِشِّهِ
u'قَدْرٌ غِشٌّ':Added, #2: 2	قَدْرُ الْغِشِّ
u'قَدْرٌ غُصْنٌ':Added, #5: 5	قَدْرَ الْغِشِّ
u'قَدْرٌ غَلاَءٌ':Added, #1: 1	قَدْرَ الْغُصْنِ
u'قَدْرٌ غَلاَءٌ':Added, #3: 3	قَدْرِ الْغَلَاءِ
u'قَدْرٌ غَلَّةٌ':Added, #5: 5	قَدْرِ غَلَاءِ
u'قَدْرٌ غَلَّةٌ':Added, #1: 1	قَدْرِ الْغَلَّةِ
u'قَدْرٌ غَنَمٌ':Added, #1: 1	قَدْرَ غَلَّةِ
u'قَدْرٌ غَوْرٌ':Added, #1: 1	قَدْرَ الْغَنَمِ
u'قَدَّرَ غَيْبَةٌ':Predicate, #1: 1	قَدْرُ غَوْرِهِ
u'قَدْرٌ غَيْبَةٌ':Added, #1: 1	قَدَّرَ الْغَيْبَةَ
u'قَدْرٌ غير':Added, #1: 1	قَدْرُ الْغَيْبَةِ
u'قَدْرٌ غَيْرٌ':Added, #1: 1	قَدْرَ الْغَيْرِ
u'قَدْرٌ فَاتِحٌ':Added, #1: 1	قَدْرَ الْغَيْرِ
u'قَدْرٌ فَاتِحَةٌ':Added, #7: 7	قَدْرَ الْفَاتِحَةِ
u'قَدْرٌ فَرْسَخٌ':Added, #7: 7	قَدْرَ الْفَاتِحَةِ
u'قَدْرٌ فَرْسَخٌ':Added, #1: 1	قَدْرُ الْفَرْسَخِ
u'قَدْرٌ فَرْسَخٌ':Added, #1: 1	قَدْرُ فَرْسَخٍ
u'قَدْرٌ فَرْضٌ':Added, #1: 1	قَدْرَ فَرْسَخَيْنِ
u'قَدْرٌ فَرْضٌ':Added, #1: 1	قَدْرُ فَرْضِ
u'قَدْرٌ فَرْضٌ':Added, #1: 1	قَدْرِ فَرْضِهِ
u'قَدْرٌ فَرْضٌ':Added, #4: 4	قَدْرَ الْفَرْضِ
u'قَدْرٌ فَرْضٌ':Added, #4: 4	قَدْرِ الْفَرْضِ
u'قَدْرٌ فرق':Added, #5: 5	قَدْرُ الْفَرْضِ
u'قَدْرٌ فرق':Added, #1: 1	قَدْرَ الْفَرَقِ
u'قَدْرٌ فرق':Added, #1: 1	قَدْرَ الْفَرْقِ
u'قَدْرٌ فَرْقٌ':Added, #1: 1	قَدْرُ الْفَرَقِ
u'قَدْرٌ فُرُوضٌ':Added, #1: 1	قَدْرَ الْفَرْقِ
u'قَدْرٌ فِضَّةٌ':Added, #1: 1	قَدْرِ الْفُرُوضِ
u'قَدْرٌ فِضَّةٌ':Added, #1: 1	قَدْرُ الْفِضَّةِ
u'قَدْرٌ فِضَّةٌ':Added, #1: 1	قَدْرُ فِضَّةِ
u'قَدْرٌ فِعْلٌ':Added, #3: 3	قَدْرَ الْفِضَّةِ
u'قَدَّرَ فلان':Predicate, #1: 1	قَدْرُ فِعْلِهِ
u'قَدَّرَ فلان':Subject, #1: 1	قَدَّرَ جُبْرَانَ
u'قَدْرٌ فلان':Added, #1: 1	قَدَّرَ الرَّحْمَنُ
u'قَدْرٌ فلان':Added, #1: 1	قَدْرَ الْقَصْرِيَّةِ
u'قَدْرٌ فلان':Added, #1: 1	قَدْرَ سِمْسِمَةٍ
u'قَدْرٌ فَهْمٌ':Added, #1: 1	قَدْرِ سِمْسِمَةٍ
u'قَدْرٌ فُول':Added, #2: 2	قَدْرِ فَهْمِهِ
u'قَدْرٌ قَامَةٌ':Added, #1: 1	قَدْرَ الْفُولَةِ
u'قَدْرٌ قَامَةٌ':Added, #1: 1	قَدْرَ قَامَتِهِ
u'قَدْرٌ قَامَةٌ':Added, #1: 1	قَدْرِ قَامَتِهِ
u'قَدْرٌ قَامَةٌ':Added, #2: 2	قَدْرُ قَامَةٍ
u'قَدْرٌ قَامَةٌ':Added, #2: 2	قَدْرُ قَامَةِ
u'قَدْرٌ قَامَةٌ':Added, #5: 5	قَدْرَ قَامَةٍ
u'قَدْرٌ قبضة':Added, #5: 5	قَدْرَ قَامَةِ
u'قَدْرٌ قَبْضَةٌ':Added, #1: 1	قَدْرَ قَبْضَةٍ
u'قَدْرٌ قبضة':Added, #1: 1	قَدْرَ قَبْضَةٍ
u'قَدْرٌ قَبْضَةٌ':Added, #2: 2	قَدْرُ الْقَبْضَةِ
u'قَدْرٌ قِرَاءةٌ':Added, #2: 2	قَدْرُ الْقَبْضَةِ
u'قَدْرٌ قِرَاءةٌ':Added, #12: 12	قَدْرَ قِرَاءَةِ
u'قَدْرٌ قِرَاءةٌ':Added, #1: 1	قَدْرِ قِرَاءَةِ
u'قَدْرٌ قِرَاءةٌ':Added, #1: 1	قَدْرَ قِرَاءَتِهِ
u'قَدْرٌ قِرَاءةٌ':Added, #2: 2	قَدْرَ الْقِرَاءَةِ
u'قَدْرٌ قِرَاءةٌ':Added, #2: 2	قَدْرُ قِرَاءَتِهِ
u'قَدْرٌ قِرَاءةٌ':Added, #5: 5	قَدْرُ الْقِرَاءَةِ
u'قَدْرٌ قِرْبَةٌ':Added, #7: 7	قَدْرِ الْقِرَاءَةِ
u'قَدْرٌ قَرْضٌ':Added, #1: 1	قَدْرُ الْقِرْبَةِ
u'قَدْرٌ قَرْيَةٌ':Added, #1: 1	قَدْرُ الْقَرْضِ
u'قَدْرٌ قَصْر':Added, #1: 1	قَدْرِ قَرْيَةِ
u'قَدْرٌ قَصْرِيَّة':Added, #1: 1	قَدْرَ الْقَصْرِيَّةِ
u'قَدْرٌ قعدة':Added, #1: 1	قَدْرَ الْقَصْرِيَّةِ
u'قَدْرٌ قَعْدَةٌ':Added, #1: 1	قَدْرَ قَعْدَةٍ
u'قَدْرٌ قَلَنْسُوَةٌ':Added, #1: 1	قَدْرَ قَعْدَةٍ
u'قَدْرٌ قَلِيلٌ':Added, #1: 1	قَدْرِ قَلَنْسُوَةٍ
u'قَدْرٌ قُوَّةٌ':Added, #1: 1	قَدْرِ الْقَلِيلِ
u'قَدْرٌ قُوَّة':Added, #1: 1	قَدْرَ قُوَّةِ
u'قَدْرٌ قُوَّةٌ':Added, #1: 1	قَدْرَ قُوَّةِ
u'قَدْرٌ قُوَّةٌ':Added, #1: 1	قَدْرَ قُوَّتِهِ
u'قَدْرٌ قُوَّة':Added, #1: 1	قَدْرِ قُوَّتِهِ
u'قَدْرٌ قُوَّة':Added, #1: 1	قَدْرَ قُوَّتِهِ
u'قَدْرٌ قُوتٌ':Added, #1: 1	قَدْرِ قُوَّتِهِ
u'قَدْرٌ قُوتٌ':Added, #1: 1	قَدْرِ قُوتِ
u'قَدْرٌ قيام':Added, #4: 4	قَدْرَ قُوتِهِ
u'قَدْرٌ قِيَامٌ':Added, #1: 1	قَدْرِ قِيَامِهِ
u'قَدْرٌ قيام':Added, #1: 1	قَدْرِ قِيَامِهِ
u'قَدْرٌ قِيَامٌ':Added, #2: 2	قَدْرَ قِيَامِهِ
u'قَدْرٌ قِيَمٌ':Added, #2: 2	قَدْرَ قِيَامِهِ
u'قَدْرٌ قِيَمٌ':Added, #1: 1	قَدْرِ قِيَمِ
u'قَدَّرَ قِيمَةٌ':Predicate, #2: 2	قَدْرِ الْقِيَمِ
u'قَدْرٌ قِيمَةٌ':Added, #1: 1	قَدَّرَ الْقِيمَةَ
u'قَدْرٌ قِيمَةٌ':Added, #11: 11	قَدْرَ الْقِيمَةِ
u'قَدْرٌ قِيمَةٌ':Added, #13: 13	قَدْرِ الْقِيمَةِ
u'قَدْرٌ قِيمَةٌ':Added, #19: 19	قَدْرِ قِيمَةِ
u'قَدْرٌ قِيمَةٌ':Added, #23: 23	قَدْرَ قِيمَةِ
u'قَدْرٌ قِيمَةٌ':Added, #2: 2	قَدْرُ الْقِيمَةِ
u'قَدْرٌ قِيمَةٌ':Added, #6: 6	قَدْرِ قِيمَتِهِ
u'قَدْرٌ قِيمَةٌ':Added, #7: 7	قَدْرُ قِيمَتِهِ
u'قَدْرٌ قِيمَةٌ':Added, #8: 8	قَدْرُ قِيمَةِ
u'قَدَّرَ كَثْرَةٌ':Predicate, #8: 8	قَدْرَ قِيمَتِهِ
u'قَدَّرَ كَثِيرٌ':Predicate, #1: 1	قَدَّرَ الْكَثْرَةَ
u'قَدْرٌ كَثِيرٌ':Added, #1: 1	قَدَّرَ الْكَثِيرَ
u'قَدْرٌ كَسْبٌ':Added, #1: 1	قَدْرُ الْكَثِيرِ
u'قَدْرٌ كَسْبٌ':Added, #1: 1	قَدْرُ كَسْبِهِ
u'قَدْرٌ كَسْرٌ':Added, #2: 2	قَدْرَ كَسْبِهِ
u'قَدْرٌ كَعْبٌ':Added, #1: 1	قَدْرُ الْكَسْرِ
u'قَدْرٌ كَعْبٌ':Added, #1: 1	قَدْرَ الْكَعْبَيْنِ
u'قَدْرٌ كَفٌّ':Added, #1: 1	قَدْرُ الْكَعْبَيْنِ
u'قَدْرٌ كَفٌّ':Added, #1: 1	قَدْرَ الْكَفِّ
u'قَدْرٌ كَفٌّ':Added, #1: 1	قَدْرِ الْكَفِّ
u'قَدْرٌ كَفٌّ':Added, #2: 2	قَدْرُ الْكَفِّ
u'قَدْرٌ كَفَّارٌ':Added, #3: 3	قَدْرُ كَفٍّ
u'قَدْرٌ كَفَّارَةٌ':Added, #1: 1	قَدْرِ الْكَفَّارَةِ
u'قَدْرٌ كِفَايَةٌ':Added, #1: 1	قَدْرِ الْكَفَّارَةِ
u'قَدْرٌ كِفَايَةٌ':Added, #10: 10	قَدْرِ الْكِفَايَةِ
u'قَدْرٌ كِفَايَةٌ':Added, #17: 17	قَدْرَ كِفَايَتِهِ
u'قَدْرٌ كِفَايَةٌ':Added, #2: 2	قَدْرَ الْكِفَايَةِ
u'قَدْرٌ كِفَايَةٌ':Added, #3: 3	قَدْرُ الْكِفَايَةِ
u'قَدْرٌ كِفَايَةٌ':Added, #3: 3	قَدْرِ كِفَايَتِهِ
u'قَدْرٌ كَفَنٌ':Added, #4: 4	قَدْرُ كِفَايَتِهِ
u'قَدْرٌ كُلْفَةٌ':Added, #1: 1	قَدْرُ كَفَنِ
u'قَدْرٌ كَمَالٌ':Added, #1: 1	قَدْرَ الْكُلْفَةِ
u'قَدْرٌ كَوْنٌ':Added, #1: 1	قَدْرِ كَمَالِ
u'قَدْرٌ كَيْلٌ':Added, #1: 1	قَدْرَ كَوْنِهِ
u'قَدْرٌ لبن':Added, #3: 3	قَدْرِ الْكَيْلِ
u'قَدْرٌ لَبَنٌ':Added, #2: 2	قَدْرِ اللَّبَنِ
u'قَدْرٌ لَحْظ':Added, #2: 2	قَدْرِ اللَّبَنِ
u'قَدْرٌ لَحْظَة':Added, #1: 1	قَدْرُ لَحْظَةٍ
u'قَدْرٌ لَحْمٌ':Added, #1: 1	قَدْرُ لَحْظَةٍ
u'قَدْرٌ لَحْمٌ':Added, #1: 1	قَدْرُ اللَّحْمِ
u'قَدْرٌ لمعة':Added, #1: 1	قَدْرَ لَحْمِهِ
u'قَدْرٌ مَاءٌ':Added, #1: 1	قَدْرُ لُمْعَةٍ
u'قَدْرٌ مَاءٌ':Added, #1: 1	قَدْرَ مَاءِ
u'قَدْرٌ مَاءٌ':Added, #1: 1	قَدْرِ مَاءِ
u'قَدْرٌ مَاءٌ':Added, #2: 2	قَدْرُ الْمَاءِ
u'قَدْرٌ مَاعُونٌ':Added, #2: 2	قَدْرِ الْمَاءِ
u'قَدْرٌ مَأْكَلٌ':Added, #1: 1	قَدْرِ الْمَاعُونِ
u'قَدْرٌ مَأْكُولٌ':Added, #1: 1	قَدْرُ مَأْكَلِهِ
u'قَدْرٌ مَالٌ':Added, #2: 2	قَدْرُ مَأْكُولٍ
u'قَدْرٌ مَالٌ':Added, #11: 11	قَدْرِ الْمَالَيْنِ
u'قَدْرٌ مَالٌ':Added, #17: 17	قَدْرِ الْمَالِ
u'قَدْرٌ مَالٌ':Added, #1: 1	قَدْرَ الْمَالِ
u'قَدْرٌ مَالٌ':Added, #1: 1	قَدْر الْمَالَيْنِ
u'قَدْرٌ مَالٌ':Added, #2: 2	قَدْرِ مَالِ
u'قَدْرٌ مَالٌ':Added, #2: 2	قَدْرُ مَالِهِ
u'قَدْرٌ مَالٌ':Added, #2: 2	قَدْرِ مَالِهِ
u'قَدْرٌ مَالٌ':Added, #3: 3	قَدْرَ مَالِهِ
u'قَدَرَ مَالِكٌ':Subject, #4: 4	قَدْرُ الْمَالِ
u'قَدْرٌ مَالِكٌ':Added, #2: 2	قَدَرَ الْمَالِكُ
u'قَدْرٌ مَالِيٌّ':Added, #1: 1	قَدْرَ مَالِكٍ
u'قَدْرٌ مَائِعٌ':Added, #2: 2	قَدْرِ مَالِيَّةِ
u'قَدْرٌ مَائِعٌ':Added, #1: 1	قَدْرُ الْمَائِعِ
u'قَدْرٌ مُبَاحٌ':Added, #1: 1	قَدْرِ الْمَائِعِ
u'قَدْرٌ مَبِيعٌ':Added, #1: 1	قَدْرُ الْمُبَاحِ
u'قَدْرٌ مَبِيعٌ':Added, #19: 19	قَدْرِ الْمَبِيعِ
u'قَدْرٌ مَبِيعٌ':Added, #2: 2	قَدْرُ الْمَبِيعِ
u'قَدْرٌ مُتَتَابِعٌ':Added, #3: 3	قَدْرَ الْمَبِيعِ
u'قَدْرٌ مُتَعَارَفٌ':Added, #1: 1	قَدْرَ الْمُتَتَابِعِ
u'قَدْرٌ مُتْعَةٌ':Added, #1: 1	قَدْرٍ مُتَعَارَفٍ
u'قَدْرٌ مُتْعَةٌ':Added, #1: 1	قَدْرَ الْمُتْعَةِ
u'قَدْرٌ مُتْعَةٌ':Added, #2: 2	قَدْرُ الْمُتْعَةِ
u'قَدْرٌ مُتَقَدِّمٌ':Added, #2: 2	قَدْرِ الْمُتْعَةِ
u'قَدْرٌ مَجّ':Added, #1: 1	قَدْرِ الْمُتَقَدِّمِ
u'قَدْرٌ مَجْمُوعٌ':Added, #1: 1	قَدْرَ الْمَجَّةِ
u'قَدْرٌ مُحَابَاةٌ':Added, #1: 1	قَدْرٍ مَجْمُوعٍ
u'قَدْرٌ مُحَابَاةٌ':Added, #2: 2	قَدْرُ الْمُحَابَاةِ
u'قَدْرٌ مُحَابَاةٌ':Added, #2: 2	قَدْرِ الْمُحَابَاةِ
u'قَدْرٌ مُحَرَّمٌ':Added, #6: 6	قَدْرَ الْمُحَابَاةِ
u'قَدْرٌ مُحْرِمٌ':Added, #1: 1	قَدْرَ الْمُحَرَّمِ
u'قَدْرٌ مَحَلٌّ':Added, #1: 1	قَدْرَ الْمُحْرِمِ
u'قَدْرٌ مَحَلٌّ':Added, #1: 1	قَدْرُ الْمَحَلِّ
u'قَدْرٌ مَحَلٌّ':Added, #1: 1	قَدْرَ مَحَلِّ
u'قَدَّرَ مُحَمَّدٌ':Subject, #2: 2	قَدْرَ الْمَحَلِّ
u'قَدْرٌ مَحْمُولٌ':Added, #2: 2	قَدَّرَ مُحَمَّدٌ
u'قَدْرٌ مُخَالِفٌ':Added, #1: 1	قَدْرُ الْمَحْمُولِ
u'قَدْرٌ مُخْتَلِطٌ':Added, #1: 1	قَدْرِ الْمُخَالِفِ
u'قَدْرٌ مَخْرَجٌ':Added, #1: 1	قَدْرِ الْمُخْتَلِطِ
u'قَدْرٌ مَخْصُوصٌ':Added, #3: 3	قَدْرِ مَخْرَجِ
u'قَدْرٌ مَخْصُوصٌ':Added, #1: 1	قَدْرِ الْمَخْصُوصِ
u'قَدْرٌ مَخْلُوطٌ':Added, #2: 2	قَدْرٍ مَخْصُوصٍ
u'قَدْرٌ مَخْلُوقٌ':Added, #1: 1	قَدْرَ الْمَخْلُوطِ
u'قَدْرٌ مُدٌّ':Added, #1: 1	قَدْرُ الْمَخْلُوقِ
u'قَدْرٌ مُدٌّ':Added, #1: 1	قَدْرَ الْمُدِّ
u'قَدْرٌ مُدٌّ':Added, #1: 1	قَدْرُ الْمُدِّ
u'قَدْرٌ مُدٌّ':Added, #1: 1	قَدْرُ مُدٍّ
u'قَدْرٌ مُدٌّ':Added, #1: 1	قَدْرَ مُدَّيْنِ
u'قَدْرٌ مَدٌّ':Added, #1: 1	قَدْرُ مُدَّيْنِ
u'قَدَّرَ مُدَّةٌ':Predicate, #3: 3	قَدْرُ مَدِّ
u'قَدْرٌ مُدَّةٌ':Added, #1: 1	قَدَّرَ الْمُدَّةَ
u'قَدْرٌ مُدَّةٌ':Added, #1: 1	قَدْرَ مُدَّةٍ
u'قَدْرٌ مُدَّةٌ':Added, #2: 2	قَدْرِ الْمُدَّةِ
u'قَدْرٌ مُدَّةٌ':Added, #2: 2	قَدْرَ مُدَّةِ
u'قَدْرٌ مُدَّةٌ':Added, #2: 2	قَدْرُ مُدَّةِ
u'قَدْرٌ مُدَّةٌ':Added, #4: 4	قَدْرُ الْمُدَّةِ
u'قَدْرٌ مَدْخَلٌ':Added, #5: 5	قَدْرِ مُدَّةِ
u'قَدْرٌ مَدْفُوعٌ':Added, #2: 2	قَدْرَ مَدْخَلِ
u'قَدْرٌ مَدْفُوعٌ':Added, #1: 1	قَدْرَ الْمَدْفُوعِ
u'قَدْرٌ مِدْماك':Added, #1: 1	قَدْرِ الْمَدْفُوعِ
u'قَدْرٌ مَرْفِقٌ':Added, #2: 2	قَدْرَ مِدْمَاكَيْنِ
u'قَدْرٌ مَرْفِق':Added, #2: 2	قَدْرِ الْمَرْفِقِ
u'قَدْرٌ مَرَمَّة':Added, #2: 2	قَدْرِ الْمَرْفِقِ
u'قَدْرٌ مَرْهُونٌ':Added, #1: 1	قَدْرَ الْمَرَمَّةِ
u'قَدَرَ مَرِيضٌ':Subject, #3: 3	قَدْرِ الْمَرْهُونِ
u'قَدْرٌ مِسَاحَةٌ':Added, #1: 1	قَدَرَ الْمَرِيضُ
u'قَدْرٌ مِسَاحَةٌ':Added, #1: 1	قَدْرَ مِسَاحَةِ
u'قَدْرٌ مَسَافَةٌ':Added, #3: 3	قَدْرِ مِسَاحَةِ
u'قَدْرٌ مَسَافَةٌ':Added, #1: 1	قَدْرُ الْمَسَافَةِ
u'قَدْرٌ مَسَافَةٌ':Added, #1: 1	قَدْرِ مَسَافَةِ
u'قَدْرٌ مَسَافَةٌ':Added, #1: 1	قَدْرِ مَسَافَتِهِ
u'قَدْرٌ مَسَافَةٌ':Added, #2: 2	قَدْرَ الْمَسَافَةِ
u'قَدْرٌ مَسْأَلَةٌ':Added, #4: 4	قَدْرِ الْمَسَافَةِ
u'قَدْرٌ مُسْتَحَقٌّ':Added, #1: 1	قَدْرِ الْمَسْأَلَةِ
u'قَدْرٌ مُسْتَحَقٌّ':Added, #1: 1	قَدْرِ الْمُسْتَحَقِّ
u'قَدْرٌ مِسْكٌ':Added, #2: 2	قَدْرَ الْمُسْتَحَقِّ
u'قَدْرٌ مُسَلَّمٌ':Added, #1: 1	قَدْرُ الْمِسْكِ
u'قَدْرٌ مَسِيرٌ':Added, #1: 1	قَدْرُ الْمُسَلَّمِ
u'قَدْرٌ مَسِيرٌ':Added, #1: 1	قَدْرُ الْمَسِيرِ
u'قَدْرٌ مَسِيرَةٌ':Added, #1: 1	قَدْرِ الْمَسِيرِ
u'قَدْرٌ مُشْتَرَكٌ':Added, #1: 1	قَدْرَ مَسِيرَةِ
u'قَدْرٌ مَشْرُوطٌ':Added, #1: 1	قَدْرٍ مُشْتَرَكٍ
u'قَدْرٌ مَشْغُولٌ':Added, #5: 5	قَدْرِ الْمَشْرُوطِ
u'قَدْرٌ مُصْحَفٌ':Added, #1: 1	قَدْرِ الْمَشْغُولِ
u'قَدَّرَ مُصَنِّفٌ':Subject, #1: 1	قَدْرِ الْمُصْحَفِ
u'قَدْرٌ مُصَنِّفٌ':Added, #1: 1	قَدَّرَ الْمُصَنِّفُ
u'قَدْرٌ مُصِيبٌ':Added, #1: 1	قَدْرُ الْمُصَنِّفِ
u'قَدْرٌ مُصِيبَةٌ':Added, #1: 1	قَدْرَ مُصِيبَةٍ
u'قَدْرٌ مُضْغَةٌ':Added, #1: 1	قَدْرَ مُصِيبَةٍ
u'قَدْرٌ مَضْمُونٌ':Added, #1: 1	قَدْرِ الْمُضْغَةِ
u'قَدْرٌ مَضْمُونٌ':Added, #1: 1	قَدْرَ الْمَضْمُونِ
u'قَدْرٌ مُعَجَّلٌ':Added, #2: 2	قَدْرُ الْمَضْمُونِ
u'قَدْرٌ مُعَجَّلٌ':Added, #1: 1	قَدْرِ الْمُعَجَّلِ
u'قَدَرَ مَعْذُورٌ':Subject, #2: 2	قَدْرَ الْمُعَجَّلِ
u'قَدَرَ مَعْذُورٌ':Subject, #2: 2	قَدَرَ الْمَعْذُورُ
u'قَدْرٌ مَعْرُوفٌ':Added, #2: 2	قَدَرَ مَعْذُورٌ
u'قَدِرَ مُعْسِرٌ':Subject, #1: 1	قَدْرَ الْمَعْرُوفِ
u'قَدْرٌ مُعْظَمٌ':Added, #1: 1	قَدِرَ الْمُعْسِرُ
u'قَدْرٌ مَعْفُوٌّ':Added, #2: 2	قَدْرَ مُعْظَمِ
u'قَدْرٌ مَعْقُودٌ':Added, #1: 1	قَدْرُ الْمَعْفُوِّ
u'قَدْرٌ مَعْقُودٌ':Added, #1: 1	قَدْرَ الْمَعْقُودِ
u'قَدْرٌ مَعْلُومٌ':Added, #1: 1	قَدْرِ الْمَعْقُودِ
u'قَدْرٌ مَعْلُومٌ':Added, #1: 1	قَدْرَ مَعْلُومٍ
u'قَدْرٌ مُعَوَّضٌ':Added, #6: 6	قَدْرٍ مَعْلُومٍ
u'قَدْرٌ مُعَيَّنٌ':Added, #2: 2	قَدْرِ الْمُعَوَّضِ
u'قَدْرٌ مَفْرُوضٌ':Added, #6: 6	قَدْرٍ مُعَيَّنٍ
u'قَدَّرَ مُفْطِر':Subject, #1: 1	قَدْرِ الْمَفْرُوضِ
u'قَدْرٌ مَفْعُولٌ':Added, #1: 1	قَدَّرَ الْمُفْطِرُ
u'قَدْرٌ مَفْعُولٌ':Added, #1: 1	قَدْرِ الْمَفْعُولِ
u'قَدْرٌ مَقَامٌ':Added, #2: 2	قَدْرَ الْمَفْعُولِ
u'قَدْرٌ مُقَامٌ':Added, #1: 1	قَدْرُ مَقَامِ
u'قَدْرٌ مَقْبُوضٌ':Added, #1: 1	قَدْرِ مُقَامِهِ
u'قَدْرٌ مُقَرَّرٌ':Added, #2: 2	قَدْرِ الْمَقْبُوضِ
u'قَدْرٌ مُكَاتَبَةٌ':Added, #1: 1	قَدْرَ الْمُقَرَّرِ
u'قَدْرٌ مَكَانٌ':Added, #1: 1	قَدْرَ مُكَاتَبَةِ
u'قَدْرٌ مَكَانٌ':Added, #1: 1	قَدْرِ الْمَكَانِ
u'قَدْرٌ مَكِيلٌ':Added, #1: 1	قَدْرُ مَكَانِ
u'قَدْرٌ مِلْكٌ':Added, #2: 2	قَدْرِ الْمَكِيلِ
u'قَدْرٌ مِلْكٌ':Added, #11: 11	قَدْرِ الْمِلْكِ
u'قَدْرٌ مِلْكٌ':Added, #1: 1	قَدْرُ الْمِلْكَيْنِ
u'قَدْرٌ مِلْكٌ':Added, #1: 1	قَدْرِ الْمِلْكَيْنِ
u'قَدْرٌ مِلْكٌ':Added, #1: 1	قَدْرُ مِلْكِ
u'قَدْرٌ مِلْكٌ':Added, #1: 1	قَدْرَ مِلْكِهِ
u'قَدْرٌ مِلْكٌ':Added, #2: 2	قَدْرُ الْمِلْكِ
u'قَدْرٌ مَمَرٌّ':Added, #3: 3	قَدْرِ مِلْكِهِ
u'قَدْرٌ مَمَرٌّ':Added, #1: 1	قَدْرَ الْمَمَرِّ
u'قَدْرٌ مَمَرٌّ':Added, #1: 1	قَدْرِ الْمَمَرِّ
u'قَدْرٌ مَمْسُوح':Added, #2: 2	قَدْرُ مَمَرِّ
u'قَدْرٌ مُمْكِنٌ':Added, #1: 1	قَدْرِ الْمَمْسُوحِ
u'قَدْرٌ مُمْكِن':Added, #1: 1	قَدْرُ الْمُمْكِنِ
u'قَدَّرَ مَنَازِلُ':Predicate, #1: 1	قَدْرُ الْمُمْكِنِ
u'قَدْرٌ مَنْخَرٌ':Added, #1: 1	قَدَّرَ الْمَنَازِلَ
u'قَدْرٌ مَنْخَرٌ':Added, #1: 1	قَدْرَ مَنْخَرِ
u'قَدْرٌ مَنْزِلَةٌ':Added, #1: 1	قَدْرُ مَنْخَرِ
u'قَدْرٌ مَنْسِيٌّ':Added, #1: 1	قَدْرِ الْمَنْزِلَةِ
u'قَدَرَ مُنْفَرِدٌ':Subject, #1: 1	قَدْرَ الْمَنْسِيِّ
u'قَدْرٌ مَنْفَعَةٌ':Added, #1: 1	قَدَرَ الْمُنْفَرِدُ
u'قَدْرٌ مَنْفَعَةٌ':Added, #2: 2	قَدْرُ الْمَنْفَعَةِ
u'قَدْرٌ مُنْفَق':Added, #5: 5	قَدْرِ الْمَنْفَعَةِ
u'قَدْرٌ مَهْرٌ':Added, #2: 2	قَدْرِ الْمُنْفَقِ
u'قَدْرٌ مَهْرٌ':Added, #1: 1	قَدْرِ الْمَهْرَيْنِ
u'قَدْرٌ مَهْرٌ':Added, #1: 1	قَدْرِ مَهْرِهِ
u'قَدْرٌ مَهْرٌ':Added, #22: 22	قَدْرِ الْمَهْرِ
u'قَدْرٌ مَهْرٌ':Added, #2: 2	قَدْرَ الْمَهْرِ
u'قَدْرٌ مَهْرٌ':Added, #2: 2	قَدْرُ الْمَهْرِ
u'قَدْرٌ مَهْرٌ':Added, #4: 4	قَدْرَ مَهْرِ
u'قَدْرٌ مَهْرٌ':Added, #4: 4	قَدْرُ مَهْرِ
u'قَدْرٌ مُهْلَةٌ':Added, #9: 9	قَدْرِ مَهْرِ
u'قَدْرٌ مُهُورٌ':Added, #1: 1	قَدْرَ مُهْلَةِ
u'قَدْرٌ مَوَارِيثُ':Added, #1: 1	قَدْرِ مُهُورِ
u'قَدْرٌ مَوَارِيثُ':Added, #1: 1	قَدْرِ الْمَوَارِيثِ
u'قَدْرٌ مُوالاة':Added, #1: 1	قَدْرِ مَوَارِيثِ
u'قَدْرٌ مُؤَخَّرٌ':Added, #1: 1	قَدْرُ الْمُوَالَاةِ
u'قَدْرٌ مُؤَخَّرٌ':Added, #1: 1	قَدْرَ مُؤَخَّرِ
u'قَدْرٌ مُؤَخِّرٌ':Added, #1: 1	قَدْرُ مُؤَخَّرِ
u'قَدْرٌ مُؤَخِّرٌ':Added, #2: 2	قَدْرَ مُؤَخِّرَةِ
u'قَدْرٌ مَوْضِعٌ':Added, #3: 3	قَدْرُ مُؤَخِّرَةِ
u'قَدْرٌ مَوْضِعٌ':Added, #1: 1	قَدْرِ الْمَوْضِعِ
u'قَدْرٌ مَوْضِعٌ':Added, #1: 1	قَدْرِ مَوْضِعِ
u'قَدْرٌ مَوْعُودٌ':Added, #2: 2	قَدْرُ مَوْضِعِ
u'قَدَّرَ مُوَكِّلٌ':Subject, #2: 2	قَدْرَ الْمَوْعُودِ
u'قَدَرٌ مُوم':Added, #2: 2	قَدَّرَ الْمُوَكِّلُ
u'قَدْرٌ مُؤَنٌ':Added, #1: 1	قَدَرَ مُومٍ
u'قَدْرٌ مِيرَاثٌ':Added, #2: 2	قَدْرَ الْمُؤَنِ
u'قَدْرٌ مِيرَاثٌ':Added, #18: 18	قَدْرِ الْمِيرَاثِ
u'قَدْرٌ مِيرَاثٌ':Added, #1: 1	قَدْرُ الْمِيرَاثِ
u'قَدْرٌ مِيرَاثٌ':Added, #2: 2	قَدْرَ مِيرَاثِهِ
u'قَدْرٌ مَيْسَرَةٌ':Added, #5: 5	قَدْرِ مِيرَاثِهِ
u'قَدْرٌ ميل':Added, #2: 2	قَدْرِ الْمَيْسَرَةِ
u'قَدْرٌ ميل':Added, #1: 1	قَدْرَ الْمِيلِ
u'قَدْرٌ مِيلٌ':Added, #1: 1	قَدْرُ الْمِيلِ
u'قَدْرٌ مِيلٌ':Added, #1: 1	قَدْرَ الْمِيلِ
u'قَدْرٌ ميل':Added, #1: 1	قَدْرُ الْمِيلِ
u'قَدْرٌ ميل':Added, #1: 1	قَدْرَ مِيلٍ
u'قَدْرٌ مِيلٌ':Added, #1: 1	قَدْرُ مِيلٍ
u'قَدْرٌ مِيلٌ':Added, #1: 1	قَدْرَ مِيلٍ
u'قَدْرٌ مِيلٌ':Added, #1: 1	قَدْرُ مِيلٍ
u'قَدْرٌ ميل':Added, #1: 1	قَدْرِ مِيلَيْنِ
u'قَدْرٌ مِيلٌ':Added, #2: 2	قَدْرِ الْمِيلِ
u'قَدْرٌ ميل':Added, #2: 2	قَدْرِ الْمِيلِ
u'قَدْرٌ مِيلٌ':Added, #6: 6	قَدْرِ مِيلٍ
u'قَدْرٌ نَارٌ':Added, #6: 6	قَدْرِ مِيلٍ
u'قَدْرٌ نَاصِيَةٌ':Added, #1: 1	قَدْرِ النَّارِ
u'قَدْرٌ نَاصِيَةٌ':Added, #3: 3	قَدْرِ النَّاصِيَةِ
u'قَدْرٌ نَاقِصٌ':Added, #7: 7	قَدْرُ النَّاصِيَةِ
u'قَدْرٌ نُبُوَّةٌ':Added, #1: 1	قَدْرِ النَّاقِصِ
u'قَدْرٌ نِتَاجٌ':Added, #1: 1	قَدْرِ نُبُوَّتِهِ
u'قَدْرٌ نَجَاسَةٌ':Added, #1: 1	قَدْرِ النِّتَاجِ
u'قَدْرٌ نَجَاسَةٌ':Added, #1: 1	قَدْرَ النَّجَاسَةِ
u'قَدْرٌ نُجُومٌ':Added, #1: 1	قَدْرُ النَّجَاسَةِ
u'قَدْرٌ نُجُومٌ':Added, #3: 3	قَدْرُ النُّجُومِ
u'قَدْرٌ نُحَاسٌ':Added, #3: 3	قَدْرِ النُّجُومِ
u'قَدْرٌ نَحْوٌ':Added, #1: 1	قَدْرُ النُّحَاسِ
u'قَدْرٌ نذر':Added, #1: 1	قَدْرِ نَحْوِ
u'قَدْرٌ نَذْرٌ':Added, #1: 1	قَدْرُ نَذْرِهِ
u'قَدْرٌ نَسَبٌ':Added, #1: 1	قَدْرُ نَذْرِهِ
u'قَدَّرَ نِسْبَةٌ':Predicate, #1: 1	قَدْرِ النَّسَبِ
u'قَدْرٌ نِسْبَةٌ':Added, #1: 1	قَدَّرَ نِسْبَةَ
u'قَدْرٌ نشاط':Added, #1: 1	قَدْرِ نِسْبَةِ
u'قَدْرٌ نَشَاطٌ':Added, #2: 2	قَدْرِ نَشَاطِهِ
u'قَدْرٌ نصاب':Added, #2: 2	قَدْرِ نَشَاطِهِ
u'قَدْرٌ نصاب':Added, #1: 1	قَدْرَ نِصَابِ
u'قَدْرٌ نصاب':Added, #1: 1	قَدْرُ نِصَابٍ
u'قَدْرٌ نِصَابٌ':Added, #1: 1	قَدْرِ نِصَابِ
u'قَدْرٌ نِصَابٌ':Added, #1: 1	قَدْرَ نِصَابِ
u'قَدْرٌ نِصَابٌ':Added, #1: 1	قَدْرُ نِصَابٍ
u'قَدْرٌ نصاب':Added, #1: 1	قَدْرِ نِصَابِ
u'قَدْرٌ نِصَابٌ':Added, #2: 2	قَدْرُ النِّصَابِ
u'قَدْرٌ نصاب':Added, #2: 2	قَدْرُ النِّصَابِ
u'قَدْرٌ نِصَابٌ':Added, #3: 3	قَدْرَ نِصَابٍ
u'قَدْرٌ نصاب':Added, #3: 3	قَدْرَ نِصَابٍ
u'قَدْرٌ نِصَابٌ':Added, #4: 4	قَدْرَ النِّصَابِ
u'قَدْرٌ نصاب':Added, #4: 4	قَدْرَ النِّصَابِ
u'قَدْرٌ نِصَابٌ':Added, #8: 8	قَدْرِ النِّصَابِ
u'قَدْرٌ نصب':Added, #8: 8	قَدْرِ النِّصَابِ
u'قَدْرٌ نَصَبٌ':Added, #1: 1	قَدْرِ النَّصَبِ
u'قَدْرٌ نِصْفٌ':Added, #1: 1	قَدْرِ النَّصَبِ
u'قَدْرٌ نِصْفٌ':Added, #11: 11	قَدْرَ نِصْفِ
u'قَدْرٌ نِصْفٌ':Added, #1: 1	قَدْرَ نِصْفٍ
u'قَدْرٌ نِصْفٌ':Added, #2: 2	قَدْرِ النِّصْفِ
u'قَدْرٌ نِصْفٌ':Added, #2: 2	قَدْرُ نِصْفِهِ
u'قَدْرٌ نِصْفٌ':Added, #5: 5	قَدْرَ النِّصْفِ
u'قَدْرٌ نَصِيبٌ':Added, #5: 5	قَدْرُ نِصْفِ
u'قَدْرٌ نَصِيبٌ':Added, #1: 1	قَدْرِ النَّصِيبِ
u'قَدْرٌ نَصِيبٌ':Added, #1: 1	قَدْرُ نَصِيبِ
u'قَدْرٌ نَصِيبٌ':Added, #1: 1	قَدْرِ نَصِيبٍ
u'قَدْرٌ نَصِيبٌ':Added, #1: 1	قَدْرِ نَصِيبِ
u'قَدْرٌ نَصِيبٌ':Added, #2: 2	قَدْرُ نَصِيبِهِ
u'قَدْرٌ نَصِيبٌ':Added, #3: 3	قَدْرَ نَصِيبِ
u'قَدْرٌ نَصِيبٌ':Added, #6: 6	قَدْرِ نَصِيبِهِ
u'قَدْرٌ نعمة':Added, #8: 8	قَدْرَ نَصِيبِهِ
u'قَدْرٌ نِعْمَةٌ':Added, #1: 1	قَدْرُ النِّعْمَةِ
u'قَدْرٌ نعمة':Added, #1: 1	قَدْرُ النِّعْمَةِ
u'قَدْرٌ نِعْمَةٌ':Added, #1: 1	قَدْرَ نِعْمَةِ
u'قَدْرٌ نعمة':Added, #1: 1	قَدْرَ نِعْمَةِ
u'قَدْرٌ نِعْمَةٌ':Added, #2: 2	قَدْرِ النِّعْمَةِ
u'قَدْرٌ نعمة':Added, #2: 2	قَدْرِ النِّعْمَةِ
u'قَدْرٌ نِعْمَةٌ':Added, #4: 4	قَدْرَ النِّعْمَةِ
u'قَدْرٌ نَفْسٌ':Added, #4: 4	قَدْرَ النِّعْمَةِ
u'قَدْرٌ نَفْعٌ':Added, #2: 2	قَدْرِ نَفْسِهِ
u'قَدْرٌ نَفَقَةٌ':Added, #1: 1	قَدْرِ نَفْعِهِ
u'قَدْرٌ نَفَقَةٌ':Added, #1: 1	قَدْرُ نَفَقَتِهِ
u'قَدْرٌ نَفَقَةٌ':Added, #2: 2	قَدْرُ النَّفَقَةِ
u'قَدْرٌ نَفَقَةٌ':Added, #4: 4	قَدْرَ النَّفَقَةِ
u'قَدْرٌ نَفَقَةٌ':Added, #4: 4	قَدْرَ نَفَقَةِ
u'قَدْرٌ نَفَقَةٌ':Added, #4: 4	قَدْرَ نَفَقَتِهِ
u'قَدْرٌ نَقْدٌ':Added, #6: 6	قَدْرِ النَّفَقَةِ
u'قَدْرٌ نَقْد':Added, #1: 1	قَدْرُ النَّقْدِ
u'قَدْرٌ نَقْدٌ':Added, #1: 1	قَدْرُ النَّقْدِ
u'قَدْرٌ نَقْد':Added, #2: 2	قَدْرِ نَقْدِ
u'قَدْرٌ نَقْصٌ':Added, #2: 2	قَدْرِ نَقْدِ
u'قَدْرٌ نَقْصٌ':Added, #1: 1	قَدْرِ نَقْصِ
u'قَدْرٌ نَقْصٌ':Added, #1: 1	قَدْرَ نَقْصِهِ
u'قَدْرٌ نَقْصٌ':Added, #2: 2	قَدْرُ نَقْصِ
u'قَدْرٌ نَقْصٌ':Added, #3: 3	قَدْرُ النَّقْصِ
u'قَدْرٌ نَقْصٌ':Added, #3: 3	قَدْرِ النَّقْصِ
u'قَدْرٌ نُقْصَانٌ':Added, #5: 5	قَدْرَ النَّقْصِ
u'قَدْرٌ نُقْصَانٌ':Added, #1: 1	قَدْرِ النُّقْصَانِ
u'قَدْرٌ نُقْصَانٌ':Added, #1: 1	قَدْرَ نُقْصَانِ
u'قَدْرٌ نُقْصَانٌ':Added, #2: 2	قَدْرَ النُّقْصَانِ
u'قَدْرٌ نُقْصَانٌ':Added, #2: 2	قَدْرُ نُقْصَانِ
u'قَدْرٌ نَوْبَةٌ':Added, #3: 3	قَدْرُ النُّقْصَانِ
u'قَدْرٌ نِيَّةٌ':Added, #1: 1	قَدْرَ نَوْبَتِهِ
u'قَدْرٌ هِبَةٌ':Added, #1: 1	قَدْرِ نِيَّتِهِ
u'قَدْرٌ هُدْهُدٌ':Added, #1: 1	قَدْرَ الْهِبَةِ
u'قَدْرٌ وَاجِبٌ':Added, #1: 1	قَدْرَ الْهُدْهُدِ
u'قَدْرٌ وَاجِبٌ':Added, #12: 12	قَدْرُ الْوَاجِبِ
u'قَدْرٌ وَاجِبٌ':Added, #19: 19	قَدْرَ الْوَاجِبِ
u'قَدَرَ واحد':Subject, #19: 19	قَدْرِ الْوَاجِبِ
u'قَدَرَ وَاحِدٌ':Subject, #1: 1	قَدَرَ وَاحِدٌ
u'قَدْرٌ واحد':Added, #1: 1	قَدَرَ وَاحِدٌ
u'قَدْرٌ وَاحِدٌ':Added, #1: 1	قَدْرٍ وَاحِدٍ
u'قَدَرَ وَجَبٌ':Predicate, #1: 1	قَدْرٍ وَاحِدٍ
u'قَدْرٌ وُجُودٌ':Added, #2: 2	قَدَرَ وَجَبَ
u'قَدَّرَ وَزْنٌ':Predicate, #1: 1	قَدْرِ وُجُودِهِ
u'قَدْرٌ وَزْنٌ':Added, #1: 1	قَدَّرَ الْوَزْنَ
u'قَدَّرَ وسط':Predicate, #1: 1	قَدْرَ وَزْنِهِ
u'قَدَّرَ وَسَطٌ':Predicate, #1: 1	قَدَّرَ الْوَسَطَ
u'قَدْرٌ وَصِيٌّ':Added, #1: 1	قَدَّرَ الْوَسَطَ
u'قَدْرٌ وَصِيٌّ':Added, #1: 1	قَدْرِ الْوَصِيَّةِ
u'قَدْرٌ وَصِيَّةٌ':Added, #1: 1	قَدْرُ وَصِيَّتِهِ
u'قَدْرٌ وَصِيَّةٌ':Added, #1: 1	قَدْرِ الْوَصِيَّةِ
u'قَدْرٌ وُضُوءٌ':Added, #1: 1	قَدْرُ وَصِيَّتِهِ
u'قَدْرٌ وَظَائِفُ':Added, #1: 1	قَدْرِ وُضُوءٍ
u'قَدْرٌ وَقْتٌ':Added, #1: 1	قَدْرِ وَظَائِفِ
u'قَدَّرَ وَقْفٌ':Predicate, #1: 1	قَدْرِ الْوَقْتِ
u'قَدْرٌ وُقُوفٌ':Added, #1: 1	قَدَّرَ الْوَقْفَ
u'قَدَرَ وَكِيلٌ':Subject, #1: 1	قَدْرِ الْوُقُوفِ
u'قَدَّرَ وَكِيلٌ':Subject, #3: 3	قَدَرَ الْوَكِيلُ
u'قَدْرٌ وَلاَءٌ':Added, #4: 4	قَدَّرَ الْوَكِيلُ
u'قَدَرَ ولد':Subject, #1: 1	قَدْرَ الْوَلَاءِ
u'قَدَرَ وَلَدٌ':Subject, #1: 1	قَدَرَ الْوَلَدُ
u'قَدْرٌ يسار':Added, #1: 1	قَدَرَ الْوَلَدُ
u'قَدْرٌ يَسَارٌ':Added, #1: 1	قَدْرِ الْيَسَارِ
u'قَدْرٌ يسار':Added, #1: 1	قَدْرِ الْيَسَارِ
u'قَدْرٌ يَسَارٌ':Added, #1: 1	قَدْرِ يَسَارِ
u'قَدْرٌ يُسْرٌ':Added, #1: 1	قَدْرِ يَسَارِ
u'قَدْرٌ يُسْرٌ':Added, #1: 1	قَدْرِ يُسْرِ
u'قَدْرٌ يَسِيرٌ':Added, #3: 3	قَدْرِ يُسْرِهِ
u'قَدْرٌ يَسِيرٌ':Added, #1: 1	قَدْرُ الْيَسِيرِ
u'قَدْرٌ يَسِيرٌ':Added, #1: 1	قَدْرِ يَسِيرٍ
u'قَدَرَ يَوْمٌ':Predicate, #5: 5	قَدْرٍ يَسِيرٍ
u'قَدْرٌ يَوْمٌ':Added, #2: 2	قَدَرَ يَوْمَ
u'قَدَّمَ إبَاحَةٌ':Predicate, #1: 1	قَدْرَ يَوْمٍ
u'قَدَّمَ إبَاحَةٌ':Predicate, #1: 1	قَدَّمَ إبَاحَةَ
u'قَدَّمَ اِبْنٌ':Predicate, #1: 1	قَدَّمَ الْإِبَاحَةَ
u'قَدَّمَ اِبْنٌ':Subject, #1: 1	قَدَّمَ ابْنَ
u'قَدِمَ اِبْنٌ':Subject, #3: 3	قَدَّمَ ابْنُ
u'قَدَّمَ إِثْبَاتٌ':Predicate, #6: 6	قَدِمَ ابْنُ
u'قَدَّمَ إجَارَةٌ':Predicate, #2: 2	قَدَّمَ الْإِثْبَاتَ
u'قَدَّمَ أُجْرَةٌ':Predicate, #2: 2	قَدَّمَ الْإِجَارَةَ
u'قَدَّمَ أُجْرَةٌ':Predicate, #1: 1	قَدَّمَ الْأُجْرَةَ
u'قَدِمَ أَجْنَبِيٌّ':Subject, #2: 2	قَدَّمَ أُجْرَةَ
u'قَدِمَ أحَدٌ':Subject, #1: 1	قَدِمَ الْأَجْنَبِيُّ
u'قَدَّمَ إِحْرَامٌ':Predicate, #1: 1	قَدِمَ أَحَدٌ
u'قَدِمَ إِحْرَامٌ':Subject, #7: 7	قَدَّمَ الْإِحْرَامَ
u'قَدِمَ أَحَقُّ':Predicate, #1: 1	قَدِمَ الْإِحْرَامُ
u'قَدَّمَ أَحْكَامٌ':Predicate, #1: 1	قَدِمَ أَحَقَّ
u'قَدِمَ أَخٌ':Subject, #2: 2	قَدَّمَ أَحْكَامَ
u'قَدَّمَ أُخْتٌ':Predicate, #1: 1	قَدِمَ الْأَخُ
u'قَدَّمَ أخْذٌ':Predicate, #1: 1	قَدَّمَ الْأُخْتَ
u'قَدَّمَ أَدَاءٌ':Predicate, #1: 1	قَدَّمَ أَخْذَ
u'قَدَّمَ آدَمِيٌّ':Predicate, #1: 1	قَدَّمَ الْأَدَاءَ
u'قَدَّمَ أَذَانٌ':Predicate, #1: 1	قَدَّمَ الْآدَمِيَّ
u'قَدَّمَ إِذْنٌ':Predicate, #1: 1	قَدَّمَ أَذَانَ
u'قَدَّمَ أرْبَابٌ':Predicate, #2: 2	قَدَّمَ الْإِذْنَ
u'قَدَّمَ أَرْبَعَةٌ':Predicate, #1: 1	قَدَّمَ أَرْبَابَ
u'قَدِمَ أَرْبَعَةٌ':Subject, #2: 2	قَدَّمَ أَرْبَعَةَ
u'قَدِمَ أرْضٌ':Predicate, #1: 1	قَدِمَ أَرْبَعَةٌ
u'قَدَّمَ أَسْبَقُ':Subject, #3: 3	قَدِمَ أَرْضَ
u'قدم أَسْماءٌ':Added, #1: 1	قَدَّمَ الْأَسْبَقُ
u'قِدَمٌ أَسْماءٌ':Added, #1: 1	قِدَمِ الْأَسْمَاءِ
u'قَدَّمَ إشارَة':Predicate, #1: 1	قِدَمِ الْأَسْمَاءِ
u'قَدَّمَ أَشْرِبَةٌ':Predicate, #2: 2	قَدَّمَ الْإِشَارَةَ
u'قَدِمَ أَصْحَابٌ':Subject, #2: 2	قَدَّمَ الْأَشْرِبَةَ
u'قَدَّمَ أَصْحَابٌ':Subject, #1: 1	قَدِمَ أَصْحَابُ
u'قَدِمَ أُصولٌ':Subject, #3: 3	قَدَّمَ الْأَصْحَابُ
u'قَدَمَ أعْرَج':Predicate, #1: 1	قَدِمَ الْأُصُولُ
u'قَدَّمَ أعْلَمُ':Predicate, #1: 1	قَدَمَ أَعْرَجَ
u'قَدَّمَ أَعْمَالٌ':Predicate, #3: 3	قَدَّمَ الْأَعْلَمَ
u'قَدَّمَ إِفْرَادٌ':Predicate, #1: 1	قَدَّمَ الْأَعْمَالَ
u'قَدَّمَ أقارب':Predicate, #1: 1	قَدَّمَ الْإِفْرَادَ
u'قَدَّمَ أقْرأُ':Predicate, #1: 1	قَدَّمَ أَقَارِبَ
u'قَدَّمَ أقْرَع':Predicate, #1: 1	قَدَّمَ الْأَقْرَأَ
u'قَدَّمَ أكْبَرُ':Predicate, #1: 1	قَدَّمَ الْأَقْرَعَ
u'قَدَّمَ إمَامٌ':Subject, #1: 1	قَدَّمَ الْأَكْبَرَ
u'قَدَّمَ أمَةٌ':Predicate, #10: 10	قَدَّمَ الْإِمَامُ
u'قَدَّمَ أَمْرٌ':Predicate, #1: 1	قَدَّمَ الْأَمَةَ
u'قَدِمَ أَميرٌ':Subject, #1: 1	قَدَّمَ الْأَمْرَ
u'قَدِمَ أهْلٌ':Subject, #3: 3	قَدِمَ الْأَمِيرُ
u'قَدَّمَ أَوَّلُ':Predicate, #5: 5	قَدِمَ أَهْلُ
u'قَدَّمَ أَوَّلُ':Predicate, #10: 10	قَدَّمَ الْأَوَّلَ
u'قَدِمَ أَوَّلُ':Subject, #1: 1	قَدَّمَ أَوَّلَ
u'قَدَّمَ أَوْلاَدٌ':Predicate, #1: 1	قَدِمَ أَوَّلُ
u'قَدَّمَ إِيجَابٌ':Predicate, #1: 1	قَدَّمَ أَوْلَادَ
u'قَدَّمَ بَابٌ':Predicate, #1: 1	قَدَّمَ الْإِيجَابَ
u'قَدَّمَ بَاطِلٌ':Predicate, #3: 3	قَدَّمَ بَابَ
u'قَدِمَ بَائِعٌ':Subject, #1: 1	قَدَّمَ الْبَاطِلَ
u'قَدَّمَ بَصَرٌ':Predicate, #1: 1	قَدِمَ الْبَائِعُ
u'قَدَّمَ بَعْضٌ':Predicate, #1: 1	قَدَّمَ الْبَصَرَ
u'قَدَّمَ بَعْضٌ':Subject, #1: 1	قَدَّمَ بَعْضَ
u'قَدِمَ بَغْدادُ':Predicate, #1: 1	قَدَّمَ بَعْضُ
u'قَدِمَ بِلادٌ':Predicate, #5: 5	قَدِمَ بَغْدَادَ
u'قَدِمَ بَلَدٌ':Predicate, #1: 1	قَدِمَ بِلَادَ
u'قَدَّمَ بِنَاءٌ':Predicate, #1: 1	قَدِمَ الْبَلَدَ
u'قَدَّمَ بَيَانٌ':Predicate, #2: 2	قَدَّمَ الْبِنَاءَ
u'قَدَّمَ بَيِّنَةٌ':Predicate, #4: 4	قَدَّمَ بَيَانَ
u'قَدَّمَ بَيِّنَةٌ':Predicate, #1: 1	قَدَّمَ الْبَيِّنَةَ
u'قَدِمَ بَيِّنَةٌ':Subject, #1: 1	قَدَّمَ بَيِّنَةَ
u'قَدَّمَ تَابِعٌ':Predicate, #1: 1	قَدِمَ بَيِّنَةُ
u'قَدِمَ تَاجِرٌ':Subject, #1: 1	قَدَّمَ التَّابِعَ
u'قَدَّمَ تَبَع':Predicate, #1: 1	قَدِمَ تَاجِرٌ
u'قَدَّمَ تَبَعِيّ':Predicate, #1: 1	قَدَّمَ تَبَعِيَّةَ
u'قَدَّمَ تَبَعِيَّة':Predicate, #1: 1	قَدَّمَ تَبَعِيَّةَ
u'قَدِمَ تَتَر':Subject, #1: 1	قَدَّمَ تَبَعِيَّةَ
u'قَدَّمَ تَحْرِيمٌ':Predicate, #1: 1	قَدِمَ التَّتَرُ
u'قدم تَحْرِيمٌ':Added, #4: 4	قَدَّمَ التَّحْرِيمَ
u'قِدَمٌ تَحْرِيمٌ':Added, #1: 1	قِدَمِ تَحْرِيمِهِ
u'قَدَّمَ تُرَابٌ':Predicate, #1: 1	قِدَمِ تَحْرِيمِهِ
u'قَدَّمَ تَرَاوِيحُ':Predicate, #1: 1	قَدَّمَ التُّرَابَ
u'قَدَّمَ تَطَوُّعٌ':Predicate, #1: 1	قَدَّمَ التَّرَاوِيحَ
u'قَدَّمَ تَعْلِيقٌ':Predicate, #1: 1	قَدَّمَ التَّطَوُّعَ
u'قَدَّمَ تَكْبيرٌ':Predicate, #2: 2	قَدَّمَ التَّعْلِيقَ
u'قَدَّمَ تَيَمُّمٌ':Predicate, #1: 1	قَدَّمَ التَّكْبِيرَ
u'قَدَّمَ ثَانِي':Predicate, #2: 2	قَدَّمَ التَّيَمُّمَ
u'قَدَّمَ ثَانِي':Predicate, #1: 1	قَدَّمَ الثَّانِيَ
u'قَدَّمَ ثَانِي':Predicate, #1: 1	قَدَّمَ ثَانِيَةَ
u'قَدَّمَ ثَانِيَةٌ':Predicate, #3: 3	قَدَّمَ الثَّانِيَةَ
u'قَدَّمَ ثَانِيَةٌ':Predicate, #1: 1	قَدَّمَ ثَانِيَةَ
u'قَدَّمَ ثَلاثَةٌ':Predicate, #3: 3	قَدَّمَ الثَّانِيَةَ
u'قَدَّمَ ثَمَنٌ':Predicate, #1: 1	قَدَّمَ ثَلَاثَةَ
u'قَدَّمَ ثَناءٌ':Predicate, #1: 1	قَدَّمَ الثَّمَنَ
u'قَدَّمَ ثَوْبٌ':Predicate, #1: 1	قَدَّمَ الثَّنَاءَ
u'قَدِمَ جَابِي':Predicate, #4: 4	قَدَّمَ الثَّوْبَ
u'قَدِمَ جَابِيَةٌ':Predicate, #1: 1	قَدِمَ الْجَابِيَةَ
u'قَدِمَ جَازٌ':Predicate, #1: 1	قَدِمَ الْجَابِيَةَ
u'قَدَّمَ جَازٌ':Predicate, #1: 1	قَدِمَ جَازَ
u'قَدَّمَ جَزَاءٌ':Predicate, #1: 1	قَدَّمَ جَازَ
u'قَدَّمَ جِنَايَةٌ':Predicate, #13: 13	قَدَّمَ الْجَزَاءَ
u'قَدَّمَ جَوَابٌ':Predicate, #2: 2	قَدَّمَ جِنَايَةَ
u'قَدَّمَ جَوَازٌ':Predicate, #1: 1	قَدَّمَ الْجَوَابَ
u'قَدِمَ حاجٌّ':Subject, #2: 2	قَدَّمَ الْجَوَازَ
u'قَدِمَ حارِثٌ':Subject, #6: 6	قَدِمَ الْحَاجُّ
u'قَدَّمَ حاضِرٌ':Predicate, #2: 2	قَدِمَ الْحَارِثُ
u'قَدَّمَ حاكِمٌ':Subject, #2: 2	قَدَّمَ الْحَاضِرَةَ
u'قَدَّمَ حَجٌّ':Predicate, #2: 2	قَدَّمَ الْحَاكِمُ
u'قَدَّمَ حِجَّةٌ':Predicate, #2: 2	قَدَّمَ الْحَجَّ
u'قَدَّمَ حَدٌّ':Predicate, #1: 1	قَدَّمَ حِجَّةَ
u'قَدَّمَ حُدودٌ':Predicate, #3: 3	قَدَّمَ حَدَّ
u'قَدَّمَ حُرْمَةٌ':Predicate, #1: 1	قَدَّمَ الْحُدُودَ
u'قَدَّمَ حُرِّيَّةٌ':Predicate, #1: 1	قَدَّمَ حُرْمَةَ
u'قَدِمَ حَسَنٌ':Subject, #1: 1	قَدَّمَ الْحُرِّيَّةَ
u'قَدَّمَ حَقِيقٌ':Predicate, #1: 1	قَدِمَ الْحَسَنُ
u'قَدَّمَ حَقِيقَةٌ':Predicate, #1: 1	قَدَّمَ حَقِيقَةَ
u'قَدَّمَ حِكَايَةٌ':Predicate, #1: 1	قَدَّمَ حَقِيقَةَ
u'قَدَّمَ حُكْم':Predicate, #1: 1	قَدَّمَ حِكَايَةَ
u'قَدَّمَ حُكْمٌ':Predicate, #1: 1	قَدَّمَ الْحُكْمِيَّةَ
u'قَدَّمَ حُكْمٌ':Predicate, #2: 2	قَدَّمَ الْحُكْمَ
u'قَدَّمَ حُكْمِيّ':Predicate, #4: 4	قَدَّمَ حُكْمَ
u'قَدَّمَ حَلاَوَةٌ':Predicate, #1: 1	قَدَّمَ الْحُكْمِيَّةَ
u'قَدَّمَ حَلْقٌ':Predicate, #1: 1	قَدَّمَ الْحَلَاوَةَ
u'قَدَّمَ حَمْدٌ':Predicate, #3: 3	قَدَّمَ الْحَلْقَ
u'قَدَّمَ خَبَرٌ':Predicate, #1: 1	قَدَّمَ الْحَمْدَ
u'قَدَّمَ خَبَر':Predicate, #1: 1	قَدَّمَ الْخَبَرَ
u'قَدَمَ خَرَابٌ':Subject, #1: 1	قَدَّمَ الْخَبَرَ
u'قَدُمَ خَرَابٌ':Subject, #1: 1	قَدَمَ خَرَابُهُ
u'قَدَّمَ خُسُوفٌ':Predicate, #2: 2	قَدُمَ خَرَابُهُ
u'قَدَّمَ خِلاَفٌ':Predicate, #1: 1	قَدَّمَ الْخُسُوفَ
u'قدم خلائق':Added, #1: 1	قَدَّمَ الْخِلَافَ
u'قِدَمٌ خلائق':Added, #1: 1	قِدَمِ الْخَلَائِقِ
u'قدم خَلائِقُ':Added, #1: 1	قِدَمِ الْخَلَائِقِ
u'قِدَمٌ خَلائِقُ':Added, #1: 1	قِدَمِ الْخَلَائِقِ
u'قَدِمَ خَلِيفَةٌ':Subject, #1: 1	قِدَمِ الْخَلَائِقِ
u'قَدَّمَ خِنْزِيرٌ':Predicate, #1: 1	قَدِمَ الْخَلِيفَةُ
u'قَدَّمَ خيار':Predicate, #2: 2	قَدَّمَ الْخِنْزِيرَ
u'قَدَّمَ خِيَارٌ':Predicate, #2: 2	قَدَّمَ خِيَارَ
u'قَدَّمَ دُخُولٌ':Predicate, #2: 2	قَدَّمَ خِيَارَ
u'قَدَّمَ دَليلٌ':Predicate, #1: 1	قَدَّمَ الدُّخُولَ
u'قَدَّمَ دَليلٌ':Predicate, #1: 1	قَدَّمَ الدَّلِيلَ
u'قَدِمَ دُهْنٌ':Subject, #1: 1	قَدَّمَ دَلِيلَ
u'قَدَّمَ دَيْنٌ':Predicate, #1: 1	قَدِمَ دُهْنٌ
u'قَدَّمَ ذكر':Predicate, #1: 1	قَدَّمَ الدَّيْنَ
u'قَدَّمَ ذِكْرٌ':Predicate, #15: 15	قَدَّمَ ذِكْرَ
u'قَدَّمَ رَأْسٌ':Predicate, #15: 15	قَدَّمَ ذِكْرَ
u'قَدِمَ رَاكِبٌ':Subject, #1: 1	قَدَّمَ رَأْسَ
u'قَدِمَ رَبُّ':Subject, #1: 1	قَدِمَ رَاكِبٌ
u'قَدِمَ رَبُّ':Subject, #1: 1	قَدِمَ رَبُّ
u'قَدَّمَ رَجُلٌ':Predicate, #1: 1	قَدِمَ رَبُّهُ
u'قَدِمَ رَجُلٌ':Subject, #1: 1	قَدَّمَ رَجُلاً
u'قَدِمَ رَجُلٌ':Subject, #5: 5	قَدِمَ الرَّجُلُ
u'قَدِمَ رَسُولٌ':Subject, #5: 5	قَدِمَ رَجُلٌ
u'قَدِمَ رَسُولٌ':Subject, #1: 1	قَدِمَ الرّسُولُ
u'قَدَّمَ رَسُولٌ':Subject, #1: 1	قَدِمَ الرَّسُولُ
u'قَدِمَ رَسُولٌ':Subject, #3: 3	قَدَّمَ رَسُولُ
u'قَدِمَ رَكْبٌ':Subject, #91: 91	قَدِمَ رَسُولُ
u'قَدَّمَ ركعة':Predicate, #2: 2	قَدِمَ رَكْبٌ
u'قَدَّمَ رَكْعَةٌ':Predicate, #1: 1	قَدَّمَ الرَّكْعَةَ
u'قَدَّمَ رُكْنٌ':Predicate, #1: 1	قَدَّمَ الرَّكْعَةَ
u'قَدَّمَ رُكْن':Predicate, #1: 1	قَدَّمَ الرُّكْنَ
u'قَدَّمَ رُكوعٌ':Predicate, #1: 1	قَدَّمَ الرُّكْنَ
u'قَدَّمَ رَمْيٌ':Predicate, #4: 4	قَدَّمَ الرُّكُوعَ
u'قَدِمَ رَهْطٌ':Subject, #2: 2	قَدَّمَ الرَّمْيَ
u'قَدَّمَ رَهْنٌ':Predicate, #2: 2	قَدِمَ رَهْطٌ
u'قَدَّمَ رِوايَةٌ':Predicate, #2: 2	قَدَّمَ الرَّهْنَ
u'قَدَّمَ رِوايَةٌ':Predicate, #1: 1	قَدَّمَ الرِّوَايَةَ
u'قَدَّمَ زَكاةٌ':Predicate, #2: 2	قَدَّمَ رِوَايَةَ
u'قَدَّمَ زَكاةٌ':Predicate, #1: 1	قَدَّمَ زَكَاةَ
u'قَدِمَ زَوْجٌ':Subject, #7: 7	قَدَّمَ الزَّكَاةَ
u'قَدَّمَ زَوْجَةٌ':Predicate, #4: 4	قَدِمَ الزَّوْجُ
u'قَدَّمَ زَيْدٌ':Subject, #1: 1	قَدَّمَ الزَّوْجَةَ
u'قَدِمَ زَيْدٌ':Subject, #1: 1	قَدَّمَ زَيْدٌ
u'قَدِمَ زَيْدٌ':Subject, #50: 50	قَدِمَ زَيْدٌ
u'قَدَّمَ سَابِقٌ':Predicate, #7: 7	قَدِمَ زَيْدُ
u'قَدَّمَ سَبْعَةٌ':Predicate, #3: 3	قَدَّمَ السَّابِقَ
u'قَدَّمَ سُجُودٌ':Predicate, #1: 1	قَدَّمَ السَّبْعَةَ
u'قَدِمَ سَعْدٌ':Subject, #1: 1	قَدَّمَ السُّجُودَ
u'قَدَّمَ سَعِيدٌ':Predicate, #1: 1	قَدِمَ سَعْدٌ
u'قَدِمَ سَعِيدٌ':Subject, #1: 1	قَدَّمَ سَعِيدَ
u'قَدَّمَ سُلْطَانٌ':Subject, #3: 3	قَدِمَ سَعِيدُ
u'قَدِمَ سَلِيطٌ':Subject, #1: 1	قَدَّمَ السُّلْطَانُ
u'قَدَّمَ سَمْعٌ':Predicate, #1: 1	قَدِمَ سَلِيطُ
u'قَدَّمَ سَمَكٌ':Predicate, #1: 1	قَدَّمَ السَّمْعَ
u'قَدَّمَ سُنَّةٌ':Predicate, #1: 1	قَدَّمَ السَّمَكَ
u'قَدِمَ سَيِّدٌ':Subject, #1: 1	قَدَّمَ سُنَّةَ
u'قَدَّمَ شَارِحٌ':Subject, #1: 1	قَدِمَ سَيِّدُ
u'قَدَّمَ شَارِعٌ':Subject, #4: 4	قَدَّمَ الشَّارِحُ
u'قَدَّمَ شافِع':Subject, #2: 2	قَدَّمَ الشَّارِعُ
u'قَدَّمَ شافِعِيّ':Subject, #1: 1	قَدَّمَ الشَّافِعِيَّةُ
u'قَدَّمَ شافِعِيّ':Subject, #1: 1	قَدَّمَ الشَّافِعِيَّةُ
u'قَدِمَ شَخْصٌ':Subject, #3: 3	قَدَّمَ الشَّافِعِيُّ
u'قدم شِرَاءٌ':Added, #1: 1	قَدِمَ شَخْصٌ
u'قِدَمٌ شِرَاءٌ':Added, #1: 1	قِدَمِ الشِّرَاءِ
u'قَدَّمَ شَرْطٌ':Predicate, #1: 1	قِدَمِ الشِّرَاءِ
u'قَدَّمَ شَرْطٌ':Predicate, #1: 1	قَدَّمَ شَرْطَ
u'قَدَّمَ شَرْعٌ':Subject, #32: 32	قَدَّمَ الشَّرْطَ
u'قَدَّمَ شَفِيعٌ':Predicate, #1: 1	قَدَّمَ الشَّرْعُ
u'قَدِمَ شَفِيعٌ':Subject, #2: 2	قَدَّمَ الشَّفِيعَ
u'قَدِمَ شَيْخٌ':Subject, #2: 2	قَدِمَ الشَّفِيعُ
u'قَدَّمَ شَيْخٌ':Subject, #1: 1	قَدِمَ الشَّيْخُ
u'قَدِمَ شَيْخٌ':Subject, #1: 1	قَدَّمَ الشَّيْخُ
u'قَدَّمَ صَاحِبٌ':Subject, #1: 1	قَدِمَ شَيْخٌ
u'قَدِمَ صَاحِبٌ':Subject, #1: 1	قَدَّمَ صَاحِبُ
u'قَدَّمَ صَائِمٌ':Predicate, #1: 1	قَدِمَ صَاحِبُهُ
u'قَدِمَ صَحَابَةٌ':Subject, #1: 1	قَدَّمَ الصَّائِمَ
u'قَدَّمَ صِحَّةٌ':Predicate, #1: 1	قَدِمَ الصَّحَابَةُ
u'قَدَّمَ صَرِيحٌ':Predicate, #3: 3	قَدَّمَ الصِّحَّةَ
u'قَدِمَ صَفْوَان':Subject, #1: 1	قَدَّمَ الصَّرِيحَ
u'قَدَّمَ صَلاَةٌ':Predicate, #1: 1	قَدِمَ صَفْوَانُ
u'قَدَّمَ صَلاَةٌ':Predicate, #2: 2	قَدَّمَ الصَّلَاةَ
u'قَدَّمَ صَوْمٌ':Predicate, #3: 3	قَدَّمَ صَلَاةَ
u'قَدِمَ ضِمَادٌ':Subject, #1: 1	قَدَّمَ صَوْمَ
u'قَدِمَ طَالِبٌ':Subject, #1: 1	قَدِمَ ضِمَادٌ
u'قَدَّمَ طعام':Predicate, #2: 2	قَدِمَ الطَّالِبُ
u'قَدَّمَ طَعَامٌ':Predicate, #2: 2	قَدَّمَ الطَّعَامَ
u'قَدَّمَ طَلاَقٌ':Predicate, #2: 2	قَدَّمَ الطَّعَامَ
u'قَدَّمَ طَهَارَةٌ':Predicate, #12: 12	قَدَّمَ الطَّلَاقَ
u'قَدَّمَ طواف':Predicate, #1: 1	قَدَّمَ الطَّهَارَةَ
u'قَدَّمَ طَوَافٌ':Predicate, #1: 1	قَدَّمَ طَوَافَ
u'قَدَّمَ طواف':Predicate, #1: 1	قَدَّمَ طَوَافَ
u'قَدَّمَ طَوَافٌ':Predicate, #2: 2	قَدَّمَ الطَّوَافَ
u'قَدَّمَ ظاهِرٌ':Predicate, #2: 2	قَدَّمَ الطَّوَافَ
u'قَدَّمَ ظهار':Predicate, #1: 1	قَدَّمَ الظَّاهِرَ
u'قَدَّمَ ظُهْرٌ':Predicate, #2: 2	قَدَّمَ الظِّهَارَ
u'قَدَّمَ عَادَةٌ':Predicate, #2: 2	قَدَّمَ الظُّهْرَ
u'قَدُمَ عَالَمٌ':Subject, #1: 1	قَدَّمَ الْعَادَةَ
u'قدم عَالَمٌ':Added, #2: 2	قَدُمَ الْعَالَمُ
u'قِدَمٌ عَالَمٌ':Added, #1: 1	قِدَمُ الْعَالَمِ
u'قدم عَالَمٌ':Added, #1: 1	قِدَمُ الْعَالَمِ
u'قدم عَالَمٌ':Added, #4: 4	قِدَمَ الْعَالَمِ
u'قِدَمٌ عَالَمٌ':Added, #4: 4	قِدَمِ الْعَالَمِ
u'قِدَمٌ عَالَمٌ':Added, #4: 4	قِدَمَ الْعَالَمِ
u'قَدَّمَ عَامٌّ':Predicate, #4: 4	قِدَمِ الْعَالَمِ
u'قَدَّمَ عَبْدٌ':Predicate, #1: 1	قَدَّمَ الْعَامَّ
u'قَدِمَ عَبْدٌ':Subject, #1: 1	قَدَّمَ عَبْدَ
u'قَدِمَ عَبْدٌ':Subject, #1: 1	قَدِمَ الْعَبْدُ
u'قَدَّمَ عتق':Predicate, #9: 9	قَدِمَ عَبْدُ
u'قَدَّمَ عِتْقٌ':Predicate, #1: 1	قَدَّمَ الْعِتْقَ
u'قَدَّمَ عَدَمٌ':Predicate, #1: 1	قَدَّمَ الْعِتْقَ
u'قَدِمَ عِرَاقٌ':Predicate, #3: 3	قَدَّمَ عَدَمَ
u'قَدَّمَ عزل':Predicate, #1: 1	قَدِمَ الْعِرَاقَ
u'قَدَّمَ عِشَاءٌ':Predicate, #2: 2	قَدَّمَ الْعَزْلَ
u'قَدِمَ عَشَاءٌ':Subject, #3: 3	قَدَّمَ الْعِشَاءَ
u'قَدِمَ عَطَاءٌ':Subject, #2: 2	قَدِمَ الْعَشَاءُ
u'قَدِمَ عَطَاءٌ':Subject, #1: 1	قَدِمَ عَطَاءٌ
u'قَدَّمَ عَقْدٌ':Predicate, #1: 1	قَدِمَ عَطَاءُ
u'قَدِمَ عَلِيٌّ':Subject, #1: 1	قَدَّمَ الْعَقْدَ
u'قَدِمَ عَلِيٌّ':Subject, #1: 1	قَدِمَ عَلِيُّ
u'قَدِمَ عُمَرٌ':Subject, #3: 3	قَدِمَ عَلِيٌّ
u'قَدَّمَ عمرة':Predicate, #11: 11	قَدِمَ عُمَرُ
u'قَدَّمَ عُمْرَةٌ':Predicate, #2: 2	قَدَّمَ الْعُمْرَةَ
u'قَدَّمَ عَمَلٌ':Predicate, #2: 2	قَدَّمَ الْعُمْرَةَ
u'قَدِمَ عند':Predicate, #1: 1	قَدَّمَ الْعَمَلَ
u'قَدَّمَ عند':Predicate, #1: 1	قَدِمَ عِنْدَ
u'قَدُمَ عَهْدٌ':Subject, #1: 1	قَدَّمَ عِنْدَ
u'قَدَّمَ عَيْبٌ':Predicate, #1: 1	قَدُمَ الْعَهْدُ
u'قدم عَيْبٌ':Added, #1: 1	قَدَّمَ الْعَيْبَ
u'قِدَمٌ عَيْبٌ':Added, #1: 1	قِدَمَ الْعَيْبِ
u'قدم عَيْبٌ':Added, #1: 1	قِدَمَ الْعَيْبِ
u'قِدَمٌ عَيْبٌ':Added, #2: 2	قِدَمِ الْعَيْبِ
u'قَدَّمَ غَاصِبٌ':Subject, #2: 2	قِدَمِ الْعَيْبِ
u'قَدَّمَ غَائِبٌ':Subject, #2: 2	قَدَّمَ الْغَاصِبُ
u'قَدِمَ غَائِبٌ':Subject, #2: 2	قَدَّمَ الْغَائِبُ
u'قَدِمَ غَائِبٌ':Subject, #2: 2	قَدِمَ غَائِبٌ
u'قَدَّمَ غرباء':Predicate, #42: 42	قَدِمَ الْغَائِبُ
u'قَدَّمَ غرماء':Subject, #1: 1	قَدَّمَ الْغُرَبَاءَ
u'قَدَّمَ غَسْلٌ':Predicate, #1: 1	قَدَّمَ الْغُرَمَاءُ
u'قَدَّمَ غُلاَمٌ':Predicate, #2: 2	قَدَّمَ غَسْلَ
u'قَدَّمَ غَنَمٌ':Predicate, #1: 1	قَدَّمَ الْغُلَامَ
u'قَدِمَ غَنِيٌّ':Subject, #1: 1	قَدَّمَ الْغَنَمَ
u'قَدِمَ غير':Predicate, #1: 1	قَدِمَ غَنِيٌّ
u'قَدِمَ غَيْرٌ':Predicate, #1: 1	أَقْدَمَ غَيْرَ
u'قَدَّمَ غير':Predicate, #1: 1	أَقْدَمَ غَيْرَ
u'قَدَّمَ غَيْرٌ':Predicate, #2: 2	قَدَّمَ غَيْرَ
u'قَدِمَ فَاطِمٌ':Subject, #2: 2	قَدَّمَ غَيْرَ
u'قَدَّمَ فَرْضٌ':Predicate, #1: 1	قَدِمَ فَاطِمَةُ
u'قَدَّمَ فَصْلٌ':Predicate, #1: 1	قَدَّمَ فَرْضَ
u'قَدَّمَ فِضَّةٌ':Predicate, #6: 6	قَدَّمَ فَصْلَ
u'قَدَّمَ فِعْلٌ':Predicate, #1: 1	قَدَّمَ الْفِضَّةَ
u'قَدِمَ فلان':Predicate, #1: 1	قَدَّمَ الْفِعْلَ
u'قَدِمَ فلان':Predicate, #15: 15	قَدِمَ مَكّةَ
u'قَدِمَ فلان':Predicate, #1: 1	أَقْدَمَ خَيْبَرَ
u'قَدِمَ فلان':Predicate, #2: 2	قَدِمَ خَيْبَرَ
u'قَدَّمَ فلان':Subject, #52: 52	قَدِمَ مَكَّةَ
u'قَدِمَ فلان':Subject, #1: 1	قَدَّمَ الشَّافِعِيَّةُ
u'قَدِمَ فلان':Subject, #1: 1	قَدِمَ حُذَيْفَةُ
u'قَدِمَ فلان':Subject, #1: 1	قَدِمَ رِفَاعَةُ
u'قَدِمَ فلان':Subject, #1: 1	قَدِمَ عَقِيلٌ
u'قَدَّمَ فُلاَنٌ':Subject, #1: 1	قَدِمَ عَقِيلُ
u'قَدِمَ فلان':Subject, #1: 1	قَدَّمَ فُلَانٌ
u'قَدِمَ فلان':Subject, #2: 2	قَدِمَ جَعْفَرُ
u'قَدَّمَ فلان':Subject, #2: 2	قَدِمَ عُثْمَانُ
u'قَدِمَ فلان':Subject, #3: 3	قَدَّمَ الشَّافِعِيُّ
u'قَدِمَ فُلاَنٌ':Subject, #3: 3	قَدِمَ مُعَاوِيَةُ
u'قَدِمَ فلان':Subject, #74: 74	قَدِمَ فُلَانٌ
u'قَدَمَ فُلاَنٌ':Subject, #8: 8	قَدِمَ جَعْفَرٌ
u'قَدِمَ قَالٌ':Predicate, #9: 9	قَدَمَ فُلَانٌ
u'قَدِمَ قَاهِرٌ':Predicate, #9: 9	قَدِمَ قَالَ
u'قَدَّمَ قَبُولٌ':Predicate, #1: 1	قَدِمَ الْقَاهِرَةَ
u'قَدَّمَ قِرَانٌ':Predicate, #2: 2	قَدَّمَ الْقَبُولَ
u'قدم قُرْآنٌ':Added, #1: 1	قَدَّمَ الْقِرَانَ
u'قِدَمٌ قُرْآنٌ':Added, #1: 1	قِدَمِ الْقُرْآنِ
u'قَدَّمَ قُرْعَةٌ':Predicate, #1: 1	قِدَمِ الْقُرْآنِ
u'قَدَّمَ قَسَمٌ':Predicate, #1: 1	قَدَّمَ الْقُرْعَةَ
u'قَدَّمَ قول':Predicate, #1: 1	قَدَّمَ الْقَسَمَ
u'قَدَّمَ قَوْلٌ':Predicate, #3: 3	قَدَّمَ الْقَوْلَ
u'قَدَّمَ قول':Predicate, #3: 3	قَدَّمَ الْقَوْلَ
u'قَدَّمَ قَوْلٌ':Predicate, #5: 5	قَدَّمَ قَوْلَ
u'قَدَّمَ قول':Subject, #5: 5	قَدَّمَ قَوْلَ
u'قَدَّمَ قَوْلٌ':Subject, #1: 1	قَدَّمَ قَوْلُهُ
u'قَدِمَ قَوْمٌ':Subject, #1: 1	قَدَّمَ قَوْلُهُ
u'قَدَّمَ قَوْمٌ':Subject, #1: 1	قَدِمَ الْقَوْمُ
u'قَدَّمَ قِيَاسٌ':Predicate, #1: 1	قَدَّمَ قَوْمٌ
u'قَدَّمَ كَافِرٌ':Subject, #1: 1	قَدَّمَ الْقِيَاسَ
u'قَدَّمَ كَافِرٌ':Subject, #1: 1	قَدَّمَ الْكَافِرُ
u'قَدَّمَ كَرَاهَةٌ':Predicate, #1: 1	قَدَّمَ كَافِرٌ
u'قَدَّمَ كَرَاهَةٌ':Predicate, #1: 1	قَدَّمَ الْكَرَاهَةَ
u'قَدَّمَ كَفَّارٌ':Predicate, #1: 1	قَدَّمَ كَرَاهَةَ
u'قَدَّمَ كَفَّارَةٌ':Predicate, #4: 4	قَدَّمَ الْكَفَّارَةَ
u'قَدَّمَ كَلاَمٌ':Predicate, #4: 4	قَدَّمَ الْكَفَّارَةَ
u'قَدَّمَ كَلاَمٌ':Predicate, #1: 1	قَدَّمَ كَلَامَ
u'قدم كَلاَمٌ':Added, #4: 4	قَدَّمَ الْكَلَامَ
u'قِدَمٌ كَلاَمٌ':Added, #1: 1	قِدَمِ كَلَامِ
u'قدم كَلاَمٌ':Added, #1: 1	قِدَمِ كَلَامِ
u'قِدَمٌ كَلاَمٌ':Added, #4: 4	قِدَمِ الْكَلَامِ
u'قَدَّمَ كَلْبٌ':Predicate, #4: 4	قِدَمِ الْكَلَامِ
u'قَدِمَ كُوفَةٌ':Predicate, #1: 1	قَدَّمَ الْكَلْبَ
u'قَدِمَ كُوفِيٌّ':Subject, #6: 6	قَدِمَ الْكُوفَةَ
u'قَدَّمَ لعنة':Predicate, #3: 3	قَدِمَ الْكُوفِيُّ
u'قَدَّمَ لَعْنَةٌ':Predicate, #1: 1	قَدَّمَ اللَّعْنَةَ
u'قَدَّمَ لَفْظٌ':Predicate, #1: 1	قَدَّمَ اللَّعْنَةَ
u'قَدِمَ لَيْلٌ':Predicate, #4: 4	قَدَّمَ لَفْظَ
u'قَدِمَ مَآبٌ':Predicate, #1: 1	قَدِمَ لَيْلَةً
u'قَدَّمَ مَالٌ':Predicate, #1: 1	قَدِمَ مَآبَ
u'قَدِمَ مَالٌ':Subject, #1: 1	قَدَّمَ الْمَالَ
u'قَدِمَ مَالِكٌ':Subject, #2: 2	قَدِمَ مَالُ
u'قَدَّمَ مَالِكٌ':Subject, #1: 1	قَدِمَ الْمَالِكُ
u'قَدَّمَ مَالِكٌ':Subject, #1: 1	قَدَّمَ الْمَالِكُ
u'قَدَّمَ مُتَأَخِّرٌ':Predicate, #1: 1	قَدَّمَ مَالِكٌ
u'قَدَّمَ متبوع':Predicate, #1: 1	قَدَّمَ الْمُتَأَخِّرَةَ
u'قَدَّمَ مَجَازٌ':Predicate, #1: 1	قَدَّمَ الْمَتْبُوعَ
u'قَدَّمَ مُحَابَاةٌ':Predicate, #1: 1	قَدَّمَ الْمَجَازَ
u'قَدِمَ مُحَمَّدٌ':Subject, #1: 1	قَدَّمَ الْمُحَابَاةَ
u'قَدَّمَ مُحِيل':Predicate, #1: 1	قَدِمَ مُحَمّدُ
u'قَدِمَ مَدِينٌ':Predicate, #1: 1	قَدَّمَ الْمُحِيلَ
u'قَدِمَ مَدِينٌ':Predicate, #105: 105	قَدِمَ الْمَدِينَةَ
u'قَدِمَ مَدِينَةٌ':Predicate, #2: 2	أَقْدَمَ الْمَدِينَةَ
u'قَدِمَ مَدِينَةٌ':Predicate, #105: 105	قَدِمَ الْمَدِينَةَ
u'قَدَّمَ مَذْهَبٌ':Predicate, #2: 2	أَقْدَمَ الْمَدِينَةَ
u'قَدِمَ مرٌّ':Predicate, #2: 2	قَدَّمَ الْمَذْهَبَ
u'قَدِمَ مُرْتَدٌّ':Subject, #1: 1	قَدِمَ مَرَّةً
u'قَدَّمَ مَرِيضٌ':Predicate, #1: 1	قَدِمَ الْمُرْتَدُّ
u'قَدِمَ مُزَارِعٌ':Subject, #1: 1	قَدَّمَ الْمَرِيضَ
u'قَدَّمَ مُسَافِرٌ':Predicate, #1: 1	قَدِمَ الْمُزَارِعُ
u'قَدِمَ مُسَافِرٌ':Subject, #1: 1	قَدَّمَ الْمُسَافِرَ
u'قَدِمَ مُسَافِرٌ':Subject, #10: 10	قَدِمَ الْمُسَافِرُ
u'قَدَّمَ مَسْأَلَةٌ':Predicate, #3: 3	قَدِمَ مُسَافِرٌ
u'قَدَّمَ مَسْحٌ':Predicate, #1: 1	قَدَّمَ الْمَسْأَلَةَ
u'قَدِمَ مَسْرُوقٌ':Subject, #1: 1	قَدَّمَ مَسْحَ
u'قَدَّمَ مُشَاةٌ':Predicate, #1: 1	قَدِمَ مَسْرُوقٌ
u'قَدَّمَ مَشِيئَةٌ':Predicate, #4: 4	قَدَّمَ الْمُشَاةَ
u'قَدِمَ مِصْرٌ':Predicate, #13: 13	قَدَّمَ الْمَشِيئَةَ
u'قَدِمَ مِصْرٌ':Predicate, #1: 1	قَدِمَ مِصْرَ
u'قَدَّمَ مَصَفٌّ':Subject, #7: 7	قَدِمَ الْمِصْرَ
u'قَدَّمَ مُصَنِّفٌ':Subject, #1: 1	قَدَّمَ الْمَصَفُّ
u'قَدَّمَ مَضْمَضَةٌ':Predicate, #38: 38	قَدَّمَ الْمُصَنِّفُ
u'قَدَّمَ مَظْرُوفٌ':Predicate, #2: 2	قَدَّمَ الْمَضْمَضَةَ
u'قَدِمَ مُعاوِيَة':Subject, #2: 2	قَدَّمَ الْمَظْرُوفَ
u'قَدِمَ مُعْتَمِرٌ':Subject, #3: 3	قَدِمَ مُعَاوِيَةُ
u'قَدَّمَ مَعْدُودٌ':Predicate, #1: 1	قَدِمَ الْمُعْتَمِرُ
u'قدم مَعْلُولٌ':Added, #1: 1	قَدَّمَ الْمَعْدُودَ
u'قِدَمٌ مَعْلُولٌ':Added, #1: 1	قِدَمُ الْمَعْلُولِ
u'قَدَّمَ مَغْرِبٌ':Predicate, #1: 1	قِدَمُ الْمَعْلُولِ
u'قَدَّمَ مُفْسِدٌ':Predicate, #1: 1	قَدَّمَ الْمَغْرِبَ
u'قَدِمَ مَفْقُودٌ':Subject, #1: 1	قَدَّمَ الْمُفْسِدَ
u'قَدَّمَ مُقَامٌ':Predicate, #5: 5	قَدِمَ الْمَفْقُودُ
u'قَدَّمَ مَنْصُوصٌ':Predicate, #1: 1	قَدَّمَ الْمُقَامَ
u'قَدَّمَ مُوجِبٌ':Predicate, #1: 1	قَدَّمَ الْمَنْصُوصَ
u'قَدَّمَ مُؤَخَّرٌ':Predicate, #1: 1	قَدَّمَ مُوجِبَ
u'قَدِمَ مُودِعٌ':Subject, #2: 2	قَدَّمَ الْمُؤَخَّرَ
u'قَدَّمَ مُؤَذِّنٌ':Subject, #1: 1	قَدِمَ الْمُودِعُ
u'قَدَّمَ مُؤَلِّفٌ':Subject, #1: 1	قَدَّمَ الْمُؤَذِّنُ
u'قَدَّمَ مَيْتٌ':Predicate, #7: 7	قَدَّمَ الْمُؤَلِّفُ
u'قَدَّمَ مَيْتَةٌ':Predicate, #2: 2	قَدَّمَ الْمَيْتَةَ
u'قَدِمَ نَاسٌ':Subject, #2: 2	قَدَّمَ الْمَيْتَةَ
u'قَدِمَ نَاسٌ':Subject, #3: 3	قَدِمَ النَّاسُ
u'قَدَّمَ نَاقِصٌ':Predicate, #6: 6	قَدِمَ نَاسٌ
u'قَدِمَ نَبِيٌّ':Subject, #1: 1	قَدَّمَ النَّاقِصَ
u'قَدَّمَ نَبِيٌّ':Subject, #13: 13	قَدِمَ النَّبِيُّ
u'قَدَّمَ نِدَاءٌ':Predicate, #2: 2	قَدَّمَ النَّبِيُّ
u'قَدَّمَ نذر':Predicate, #1: 1	قَدَّمَ النِّدَاءَ
u'قَدَّمَ نَذْرٌ':Predicate, #2: 2	قَدَّمَ النَّذْرَ
u'قَدَّمَ نِساءٌ':Predicate, #2: 2	قَدَّمَ النَّذْرَ
u'قَدِمَ نَصْرَانِيٌّ':Subject, #1: 1	قَدَّمَ النِّسَاءَ
u'قَدَّمَ نَقْدٌ':Predicate, #1: 1	قَدِمَ النَّصْرَانِيُّ
u'قَدَّمَ نَقْد':Predicate, #2: 2	قَدَّمَ النَّقْدَ
u'قَدِمَ نَقْضٌ':Subject, #2: 2	قَدَّمَ النَّقْدَ
u'قَدَّمَ نكاح':Predicate, #1: 1	قَدِمَ نَقْضُ
u'قَدَّمَ نِكَاحٌ':Predicate, #4: 4	قَدَّمَ النِّكَاحَ
u'قَدَّمَ نَوْعٌ':Predicate, #4: 4	قَدَّمَ النِّكَاحَ
u'قَدَّمَ نِيَّةٌ':Predicate, #1: 1	قَدَّمَ النَّوْعَ
u'قَدَّمَ هِبَةٌ':Predicate, #1: 1	قَدَّمَ النِّيَّةَ
u'قَدَّ مَهْرٌ':Predicate, #4: 4	قَدَّمَ هِبَةَ
u'قَدِمَ واحد':Subject, #1: 1	قَدَّ الْمَهْرَ
u'قَدِمَ وَاحِدٌ':Subject, #1: 1	قَدِمَ وَاحِدٌ
u'قَدِمَ وَارِثٌ':Subject, #1: 1	قَدِمَ وَاحِدٌ
u'قَدِمَ وبر':Subject, #1: 1	قَدِمَ وَارِثٌ
u'قَدِمَ وَبَرٌ':Subject, #1: 1	قَدِمَ وَبَرٌ
u'قَدَّمَ وَجْهٌ':Predicate, #1: 1	قَدِمَ وَبَرٌ
u'قَدَّمَ وُجُوبٌ':Predicate, #2: 2	قَدَّمَ الْوَجْهَ
u'قَدَّمَ وَصِيٌّ':Predicate, #2: 2	قَدَّمَ وُجُوبَ
u'قَدَّمَ وَصِيٌّ':Subject, #1: 1	قَدَّمَ الْوَصِيَّةَ
u'قَدَّمَ وَصِيَّةٌ':Predicate, #3: 3	قَدَّمَ الْوَصِيُّ
u'قَدَّمَ وُضُوءٌ':Predicate, #1: 1	قَدَّمَ الْوَصِيَّةَ
u'قَدَّمَ وَعْظٌ':Predicate, #1: 1	قَدَّمَ الْوُضُوءَ
u'قَدِمَ وَفْدٌ':Subject, #1: 1	قَدَّمَ الْوَعْظَ
u'قَدِمَ وَفْدٌ':Subject, #11: 11	قَدِمَ وَفْدُ
u'قَدَّمَ وَقْت':Predicate, #2: 2	قَدِمَ وَفْدٌ
u'قَدَّمَ وَقْتِيّ':Predicate, #1: 1	قَدَّمَ الْوَقْتِيَّةَ
u'قَدَّمَ وُقُوعٌ':Predicate, #1: 1	قَدَّمَ الْوَقْتِيَّةَ
u'قَدَّمَ وُقُوفٌ':Predicate, #1: 1	قَدَّمَ الْوُقُوعَ
u'قَدِمَ وَكِيلٌ':Subject, #1: 1	قَدَّمَ الْوُقُوفَ
u'قَدَّمَ ولد':Predicate, #1: 1	قَدِمَ الْوَكِيلُ
u'قَدَّمَ وَلَدٌ':Predicate, #1: 1	قَدَّمَ الْوَلَدَ
u'قَدَّمَ وَلِيٌّ':Subject, #1: 1	قَدَّمَ الْوَلَدَ
u'قَدَّمَ وَلِيٌّ':Subject, #1: 1	قَدَّمَ الْوَلِيُّ
u'قَدِمَ وَلِيدٌ':Subject, #2: 2	قَدَّمَ وَلِيُّ
u'قَدِمَ يمن':Predicate, #1: 1	قَدِمَ الْوَلِيدُ
u'قَدِمَ يَمَنُ':Predicate, #4: 4	قَدِمَ الْيَمَنَ
u'قَدَّمَ يَمِينٌ':Predicate, #4: 4	قَدِمَ الْيَمَنَ
u'قَدِمَ يَوْمٌ':Predicate, #1: 1	قَدَّمَ يَمِينَ
u'قَدِمَ يَوْمٌ':Predicate, #1: 1	قَدِمَ الْيَوْمَ
u'قَدِمَ يَوْمٌ':Subject, #2: 2	قَدِمَ يَوْمَ
u'قُدُومٌ أَبٌ':Added, #4: 4	قَدِمَ الْيَوْمُ
u'قُدُومٌ أَشْعَث':Added, #1: 1	قُدُومِ الْأَبِ
u'قُدُومٌ أَصْحَابٌ':Added, #1: 1	قُدُومُ الْأَشْعَثِ
u'قُدُومٌ أَميرٌ':Added, #1: 1	قُدُومَ أَصْحَابِ
u'قُدُومٌ بَائِعٌ':Added, #4: 4	قُدُومِ الْأَمِيرِ
u'قُدُومٌ حاجٌّ':Added, #1: 1	قُدُومَ الْبَائِعِ
u'قُدُومٌ حاجٌّ':Added, #11: 11	قُدُومِ الْحَاجِّ
u'قُدُومٌ خَالِدٌ':Added, #1: 1	قُدُومَ الْحَاجِّ
u'قُدُومٌ خَلِيفَةٌ':Added, #1: 1	قُدُومُ خَالِدٍ
u'قُدُومٌ رَسُولٌ':Added, #1: 1	قُدُومِ الْخَلِيفَةِ
u'قُدُومٌ رَسُولٌ':Added, #1: 1	قُدُومِ الرّسُولِ
u'قُدُومٌ رَسُولٌ':Added, #2: 2	قُدُومَ رَسُولِ
u'قُدُومٌ رَسُولٌ':Added, #2: 2	قُدُومُ رَسُولِ
u'قُدُومٌ زَيْدٌ':Added, #2: 2	قُدُومِ رَسُولِ
u'قُدُومٌ زَيْدٌ':Added, #1: 1	قُدُومُ زَيْدِ
u'قُدُومٌ زَيْدٌ':Added, #27: 27	قُدُومِ زَيْدٍ
u'قُدُومٌ سَفِينَةٌ':Added, #3: 3	قُدُومُ زَيْدٍ
u'قُدُومٌ سَيِّدٌ':Added, #2: 2	قُدُومَ السَّفِينَةِ
u'قُدُومٌ سَيْفٌ':Added, #1: 1	قُدُومِ سَيِّدِهِ
u'قُدُومٌ ضِمام':Added, #1: 1	قُدُومَ سَيْفٍ
u'قُدُومٌ عَامِلٌ':Added, #1: 1	قُدُومُ ضِمَامِ
u'قُدُومٌ عَلِيٌّ':Added, #1: 1	قُدُومِ الْعَامِلِ
u'قُدُومٌ غَائِبٌ':Added, #1: 1	قُدُومِ عَلِيٍّ
u'قُدُومٌ غَائِبٌ':Added, #1: 1	قُدُومَ غَائِبٍ
u'قُدُومٌ غَائِبٌ':Added, #1: 1	قُدُومُ غَائِبٍ
u'قُدُومٌ غَائِبٌ':Added, #2: 2	قُدُومِ الْغَائِبِ
u'قُدُومٌ فلان':Added, #2: 2	قُدُومِ غَائِبٍ
u'قُدُومٌ فُلاَنٌ':Added, #1: 1	قُدُومِ جَعْفَرٍ
u'قُدُومٌ فُلاَنٌ':Added, #1: 1	قُدُومَ فُلَانٍ
u'قُدُومٌ فلان':Added, #1: 1	قُدُومِ فُلَانِ
u'قُدُومٌ فُلاَنٌ':Added, #2: 2	قُدُومِ جَعْفَرِ
u'قُدُومٌ فُلاَنٌ':Added, #36: 36	قُدُومِ فُلَانٍ
u'قُدُومٌ قوافل':Added, #5: 5	قُدُومُ فُلَانٍ
u'قُدُومٌ قَوَافِلُ':Added, #1: 1	قُدُومَ قَوَافِلِ
u'قُدُومٌ كَعْبٌ':Added, #1: 1	قُدُومَ قَوَافِلِ
u'قُدُومٌ كَعْبٌ':Added, #1: 1	قُدُومُ كَعْبٍ
u'قُدُومٌ مَدِينٌ':Added, #1: 1	قُدُومِ كَعْبٍ
u'قُدُومٌ مَدِينَةٌ':Added, #1: 1	قُدُومِ الْمَدِينَةِ
u'قُدُومٌ مُسَافِرٌ':Added, #1: 1	قُدُومِ الْمَدِينَةِ
u'قُدُومٌ مَسْجِدٌ':Added, #2: 2	قُدُومُ الْمُسَافِرِ
u'قُدُومٌ مُسْلِمٌ':Added, #1: 1	قُدُومِ الْمَسْجِدِ
u'قُدُومٌ مُصَدِّقٌ':Added, #1: 1	قُدُومِ الْمُسْلِمِ
u'قُدُومٌ نَبِيٌّ':Added, #1: 1	قُدُومِ الْمُصَدِّقِ
u'قُدُومٌ واحد':Added, #2: 2	قُدُومِ النَّبِيِّ
u'قُدُومٌ وَاحِدٌ':Added, #1: 1	قُدُومِ وَاحِدٍ
u'قُدُومٌ وَفْدٌ':Added, #1: 1	قُدُومِ وَاحِدٍ
u'قُدُومٌ وَفْدٌ':Added, #2: 2	قُدُومَ وَفْدِ
u'قَذَارَةٌ بدن':Added, #5: 5	قُدُومُ وَفْدِ
u'قَذَارَةٌ بَدَنٌ':Added, #1: 1	قَذَارَةِ الْبَدَنِ
u'قَذَرٌ طَاهِرٌ':Added, #1: 1	قَذَارَةِ الْبَدَنِ
u'قَذَفَ اِبْنٌ':Predicate, #1: 1	قَذَرٍ طَاهِرٍ
u'قذف أجَانِبُ':Added, #2: 2	قَذَفَ ابْنَ
u'قَذْفٌ أجَانِبُ':Added, #3: 3	قَذْفِ الْأَجَانِبِ
u'قذف أَجْنَاسٌ':Added, #3: 3	قَذْفِ الْأَجَانِبِ
u'قَذْفٌ أَجْنَاسٌ':Added, #1: 1	قَذْفِ الْأَجْنَاسِ
u'قَذَفَ أَجْنَبِيٌّ':Predicate, #1: 1	قَذْفِ الْأَجْنَاسِ
u'قَذَفَ أَجْنَبِيٌّ':Predicate, #11: 11	قَذَفَ أَجْنَبِيَّةً
u'قَذَفَ أَجْنَبِيٌّ':Subject, #1: 1	قَذَفَ الْأَجْنَبِيَّةَ
u'قَذَفَ أَجْنَبِيٌّ':Subject, #1: 1	قَذَفَ أَجْنَبِيٌّ
u'قذف أَجْنَبِيٌّ':Added, #2: 2	قَذَفَ الْأَجْنَبِيُّ
u'قَذْفٌ أَجْنَبِيٌّ':Added, #1: 1	قَذْفَ الْأَجْنَبِيِّ
u'قذف أَجْنَبِيٌّ':Added, #1: 1	قَذْفَ الْأَجْنَبِيِّ
u'قذف أَجْنَبِيٌّ':Added, #1: 1	قَذْفَ الْأَجْنَبِيَّةِ
u'قَذْفٌ أَجْنَبِيٌّ':Added, #1: 1	قَذْفِ الْأَجْنَبِيَّةِ
u'قَذْفٌ أَجْنَبِيٌّ':Added, #1: 1	قَذْفَ الْأَجْنَبِيَّةِ
u'قذف أَجْنَبِيٌّ':Added, #1: 1	قَذْفِ الْأَجْنَبِيَّةِ
u'قَذْفٌ أَجْنَبِيٌّ':Added, #2: 2	قَذْفِ الْأَجْنَبِيِّ
u'قذف أخرَس':Added, #2: 2	قَذْفِ الْأَجْنَبِيِّ
u'قذف أخرَس':Added, #1: 1	قَذْفَ الْأَخْرَسِ
u'قذف أخرَس':Added, #1: 1	قَذْفُ الْأَخْرَسِ
u'قَذْفٌ أخرَس':Added, #1: 1	قَذْفِ الْأَخْرَسِ
u'قَذْفٌ أخرَس':Added, #1: 1	قَذْفَ الْأَخْرَسِ
u'قَذْفٌ أخرَس':Added, #1: 1	قَذْفُ الْأَخْرَسِ
u'قَذَفَ أَرْبَعُ':Predicate, #1: 1	قَذْفِ الْأَخْرَسِ
u'قَذَفَ أَزْواجٌ':Predicate, #2: 2	قَذَفَ أَرْبَعَ
u'قذف أَصَمّ':Added, #1: 1	قَذَفَ أَزْوَاجَ
u'قَذْفٌ أَصَمّ':Added, #1: 1	قَذْفُ الْأَصَمِّ
u'قَذَفَ الْمَرْأَةُ':Predicate, #1: 1	قَذْفُ الْأَصَمِّ
u'قَذَفَ أُمٌّ':Predicate, #1: 1	قَذَفَ الْمَرْأَةَ
u'قَذَفَ أُمٌّ':Predicate, #1: 1	قَذَفَ الْأُمَّ
u'قذف أُمٌّ':Added, #6: 6	قَذَفَ أُمَّ
u'قَذْفٌ أُمٌّ':Added, #1: 1	قَذْفِ أُمِّهِ
u'قذف أُمٌّ':Added, #1: 1	قَذْفِ أُمِّهِ
u'قَذْفٌ أُمٌّ':Added, #2: 2	قَذْفِ أُمِّ
u'قذف أُمٌّ':Added, #2: 2	قَذْفِ أُمِّ
u'قَذْفٌ أُمٌّ':Added, #3: 3	قَذْفِ الْأُمِّ
u'قَذَفَ اِمْرَأَةٌ':Predicate, #3: 3	قَذْفِ الْأُمِّ
u'قذف اِمْرَأَةٌ':Added, #6: 6	قَذَفَ امْرَأَةَ
u'قَذْفٌ اِمْرَأَةٌ':Added, #1: 1	قَذْفِ امْرَأَةٍ
u'قذف اِمْرَأَةٌ':Added, #1: 1	قَذْفِ امْرَأَةٍ
u'قَذْفٌ اِمْرَأَةٌ':Added, #1: 1	قَذْفِ امْرَأَتِهِ
u'قذف إِنْسانٌ':Added, #1: 1	قَذْفِ امْرَأَتِهِ
u'قَذْفٌ إِنْسانٌ':Added, #1: 1	قَذْفِ إنْسَانٍ
u'قَذَفَ أهْلٌ':Predicate, #1: 1	قَذْفِ إنْسَانٍ
u'قَذَفَ بِنْتٌ':Predicate, #1: 1	قَذَفَ أَهْلَ
u'قَذَفَ جَمَاعَةٌ':Predicate, #1: 1	قَذَفَ بِنْتَ
u'قَذَفَ حالَةٌ':Predicate, #1: 1	قَذَفَ الْجَمَاعَةَ
u'قذف حَبَشَة':Added, #1: 1	قَذَفَ حَالَةَ
u'قَذْفٌ حَبَشَة':Added, #2: 2	قَذْفَ الْحَبَشَةِ
u'قَذَفَ حَجَرٌ':Predicate, #2: 2	قَذْفَ الْحَبَشَةِ
u'قَذَفَ حَدٌّ':Subject, #1: 1	قَذَفَ الْحَجَرَ
u'قَذَفَ حُرٌّ':Subject, #1: 1	قَذَفَ حَدُّ
u'قَذَفَ حَصَاةٌ':Predicate, #3: 3	قَذَفَ الْحُرُّ
u'قذف خَرْسَاء':Added, #1: 1	قَذَفَ الْحَصَاةَ
u'قَذْفٌ خَرْسَاء':Added, #1: 1	قَذْفَ الْخَرْسَاءِ
u'قذف دَمٌ':Added, #1: 1	قَذْفَ الْخَرْسَاءِ
u'قَذْفٌ دَمٌ':Added, #1: 1	قَذْفِ الدَّمِ
u'قَذَفَ رَجُلٌ':Subject, #1: 1	قَذْفِ الدَّمِ
u'قَذَفَ رَجُلٌ':Subject, #15: 15	قَذَفَ الرَّجُلُ
u'قذف رَجُلٌ':Added, #5: 5	قَذَفَ رَجُلٌ
u'قذف رَجُلٌ':Added, #3: 3	قَذْفُ الرَّجُلِ
u'قَذْفٌ رَجُلٌ':Added, #3: 3	قَذْفِ الرَّجُلِ
u'قَذْفٌ رَجُلٌ':Added, #3: 3	قَذْفُ الرَّجُلِ
u'قذف رَسُولٌ':Added, #3: 3	قَذْفِ الرَّجُلِ
u'قَذْفٌ رَسُولٌ':Added, #1: 1	قَذْفُ رَسُولِ
u'قَذَفَ رَقيقٌ':Subject, #1: 1	قَذْفُ رَسُولِ
u'قَذَفَ رَقيق':Subject, #1: 1	قَذَفَ الرَّقِيقُ
u'قَذَفَ زَوْجٌ':Subject, #1: 1	قَذَفَ الرَّقِيقُ
u'قذف زَوْجٌ':Added, #1: 1	قَذَفَ الزَّوْجُ
u'قَذْفٌ زَوْجٌ':Added, #1: 1	قَذْفُ الزَّوْجِ
u'قذف زَوْجٌ':Added, #1: 1	قَذْفُ الزَّوْجِ
u'قَذْفٌ زَوْجٌ':Added, #8: 8	قَذْفِ الزَّوْجِ
u'قذف زَوْجَةٌ':Added, #8: 8	قَذْفِ الزَّوْجِ
u'قَذْفٌ زَوْجَةٌ':Added, #1: 1	قَذْفِ الزَّوْجَةِ
u'قذف زَوْجَةٌ':Added, #1: 1	قَذْفِ الزَّوْجَةِ
u'قَذْفٌ زَوْجَةٌ':Added, #1: 1	قَذْفَ زَوْجَتِهِ
u'قذف زَوْجَةٌ':Added, #1: 1	قَذْفَ زَوْجَتِهِ
u'قَذْفٌ زَوْجَةٌ':Added, #2: 2	قَذْفُ الزَّوْجَةِ
u'قذف زَوْجَةٌ':Added, #2: 2	قَذْفُ الزَّوْجَةِ
u'قَذْفٌ زَوْجَةٌ':Added, #3: 3	قَذْفِ الزَّوْجَاتِ
u'قذف زَيْدٌ':Added, #3: 3	قَذْفِ الزَّوْجَاتِ
u'قَذْفٌ زَيْدٌ':Added, #1: 1	قَذْفَ زَيْدٍ
u'قَذَفَ سَائِرٌ':Predicate, #1: 1	قَذْفَ زَيْدٍ
u'قذف سَكْرَان':Added, #2: 2	قَذَفَ سَائِرَ
u'قَذْفٌ سَكْرَان':Added, #1: 1	قَذْفِ السَّكْرَانِ
u'قَذَفَ سَيِّدٌ':Subject, #1: 1	قَذْفِ السَّكْرَانِ
u'قَذَفَ صَبِيٌّ':Predicate, #1: 1	قَذَفَ السَّيِّدُ
u'قَذْفٌ صَرِيحٌ':Added, #1: 1	قَذَفَ صَبِيَّةً
u'قذف صَغِيرٌ':Added, #2: 2	قَذْفٍ صَرِيحٍ
u'قَذْفٌ صَغِيرٌ':Added, #1: 1	قَذْفِ الصَّغِيرِ
u'قذف صَغِيرٌ':Added, #1: 1	قَذْفِ الصَّغِيرِ
u'قَذْفٌ صَغِيرٌ':Added, #1: 1	قَذْفَ الصَّغِيرَةِ
u'قذف صَغِيرٌ':Added, #1: 1	قَذْفَ الصَّغِيرَةِ
u'قَذْفٌ صَغِيرٌ':Added, #1: 1	قَذْفِ صَغِيرَةٍ
u'قذف صَغِيرٌ':Added, #1: 1	قَذْفِ صَغِيرَةٍ
u'قَذْفٌ صَغِيرٌ':Added, #2: 2	قَذْفُ الصَّغِيرَةِ
u'قَذَفَ ضَرَّةٌ':Predicate, #2: 2	قَذْفُ الصَّغِيرَةِ
u'قَذَفَ عَائِشٌ':Predicate, #2: 2	قَذَفَ ضَرَّةَ
u'قَذَفَ عَبْدٌ':Predicate, #2: 2	قَذَفَ عَائِشَةَ
u'قَذَفَ عَبْدٌ':Subject, #1: 1	قَذَفَ عَبْدَ
u'قذف عَفِيفٌ':Added, #2: 2	قَذَفَ الْعَبْدُ
u'قَذْفٌ عَفِيفٌ':Added, #1: 1	قَذْفَ الْعَفِيفَةِ
u'قَذَفَ غير':Predicate, #1: 1	قَذْفَ الْعَفِيفَةِ
u'قَذَفَ غَيْرٌ':Predicate, #6: 6	قَذَفَ غَيْرَ
u'قَذَفَ قَاذِفٌ':Subject, #6: 6	قَذَفَ غَيْرَ
u'قذف قَاذِفٌ':Added, #1: 1	قَذَفَ قَاذِفٌ
u'قَذْفٌ قَاذِفٌ':Added, #1: 1	قَذْفِ الْقَاذِفِ
u'قَذَفَ كَافِرٌ':Subject, #1: 1	قَذْفِ الْقَاذِفِ
u'قذف كَافِرٌ':Added, #1: 1	قَذَفَ الْكَافِرُ
u'قَذْفٌ كَافِرٌ':Added, #1: 1	قَذْفُ كَافِرَةٍ
u'قَذَفَ مَجْنُونٌ':Predicate, #1: 1	قَذْفُ كَافِرَةٍ
u'قَذَفَ مَجْنُونٌ':Predicate, #1: 1	قَذَفَ الْمَجْنُونَ
u'قَذَفَ مَجْهُولٌ':Predicate, #2: 2	قَذَفَ مَجْنُونَةً
u'قَذَفَ مَجْهُولٌ':Predicate, #1: 1	قَذَفَ مَجْهُولَ
u'قَذَفَ مَحْدُودٌ':Subject, #1: 1	قَذَفَ مَجْهُولَةَ
u'قَذَفَ مُحْصَنٌ':Predicate, #3: 3	قَذَفَ الْمَحْدُودُ
u'قَذَفَ مُحْصَنٌ':Predicate, #1: 1	قَذَفَ الْمُحْصَنَ
u'قَذَفَ مُحْصَنٌ':Predicate, #1: 1	قَذَفَ الْمُحْصَنَةَ
u'قذف مُحْصَنٌ':Added, #4: 4	قَذَفَ مُحْصَنَةً
u'قَذْفٌ مُحْصَنٌ':Added, #1: 1	قَذْفَ الْمُحْصَنِ
u'قذف مُحْصَنٌ':Added, #1: 1	قَذْفَ الْمُحْصَنِ
u'قَذْفٌ مُحْصَنٌ':Added, #1: 1	قَذْفُ الْمُحْصَنَاتِ
u'قذف مُحْصَنٌ':Added, #1: 1	قَذْفُ الْمُحْصَنَاتِ
u'قَذْفٌ مُحْصَنٌ':Added, #1: 1	قَذْفُ الْمُحْصَنَةِ
u'قذف مُحْصَنٌ':Added, #1: 1	قَذْفُ الْمُحْصَنَةِ
u'قَذْفٌ مُحْصَنٌ':Added, #1: 1	قَذْفِ مُحْصَنٍ
u'قذف مُحْصَنٌ':Added, #1: 1	قَذْفِ مُحْصَنٍ
u'قَذْفٌ مُحْصَنٌ':Added, #2: 2	قَذْفَ الْمُحْصَنَاتِ
u'قذف مُحْصَنٌ':Added, #2: 2	قَذْفَ الْمُحْصَنَاتِ
u'قَذْفٌ مُحْصَنٌ':Added, #2: 2	قَذْفَ الْمُحْصَنَةِ
u'قذف مُحْصَنٌ':Added, #2: 2	قَذْفَ الْمُحْصَنَةِ
u'قَذْفٌ مُحْصَنٌ':Added, #2: 2	قَذْفِ مُحْصَنَةٍ
u'قذف مُحْصَنٌ':Added, #2: 2	قَذْفِ مُحْصَنَةٍ
u'قَذْفٌ مُحْصَنٌ':Added, #4: 4	قَذْفُ الْمُحْصَنِ
u'قذف مُحْصَنٌ':Added, #4: 4	قَذْفُ الْمُحْصَنِ
u'قَذْفٌ مُحْصَنٌ':Added, #5: 5	قَذْفِ الْمُحْصَنَاتِ
u'قَذَفَ مَرِيضٌ':Subject, #5: 5	قَذْفِ الْمُحْصَنَاتِ
u'قَذَفَ مُسْلِمٌ':Subject, #1: 1	قَذَفَ الْمَرِيضُ
u'قذف مُسْلِمٌ':Added, #1: 1	قَذَفَ مُسْلِمٌ
u'قَذْفٌ مُسْلِمٌ':Added, #1: 1	قَذْفُ مُسْلِمَةٍ
u'قذف مُسْلِمٌ':Added, #1: 1	قَذْفُ مُسْلِمَةٍ
u'قَذْفٌ مُسْلِمٌ':Added, #4: 4	قَذْفِ مُسْلِمٍ
u'قَذْفٌ مُضَافٌ':Added, #4: 4	قَذْفِ مُسْلِمٍ
u'قذف مُطَلَّقٌ':Added, #1: 1	قَذْفٍ مُضَافٍ
u'قَذْفٌ مُطَلَّقٌ':Added, #1: 1	قَذْفِ الْمُطَلَّقَةِ
u'قذف مُكَلَّفٌ':Added, #1: 1	قَذْفِ الْمُطَلَّقَةِ
u'قَذْفٌ مُكَلَّفٌ':Added, #1: 1	قَذْفُ الْمُكَلَّفِ
u'قذف مَمْلُوكٌ':Added, #1: 1	قَذْفُ الْمُكَلَّفِ
u'قَذْفٌ مَمْلُوكٌ':Added, #1: 1	قَذْفَ الْمَمْلُوكِ
u'قذف مَنْكُوح':Added, #1: 1	قَذْفَ الْمَمْلُوكِ
u'قَذْفٌ مَنْكُوح':Added, #1: 1	قَذْفِ الْمَنْكُوحَةِ
u'قذف نَائِمٌ':Added, #1: 1	قَذْفِ الْمَنْكُوحَةِ
u'قَذْفٌ نَائِمٌ':Added, #1: 1	قَذْفُ النَّائِمِ
u'قذف نَبِيٌّ':Added, #1: 1	قَذْفُ النَّائِمِ
u'قَذْفٌ نَبِيٌّ':Added, #1: 1	قَذْفِ النَّبِيِّ
u'قذف نُجُومٌ':Added, #1: 1	قَذْفِ النَّبِيِّ
u'قَذْفٌ نُجُومٌ':Added, #1: 1	قَذْفِ النّجُومِ
u'قذف نَحْوٌ':Added, #1: 1	قَذْفِ النّجُومِ
u'قَذْفٌ نَحْوٌ':Added, #1: 1	قَذْفَ نَحْوِ
u'قَذَفَ نَصْرَانِيٌّ':Predicate, #1: 1	قَذْفَ نَحْوِ
u'قَذَفَ هِلاَلٌ':Subject, #1: 1	قَذَفَ نَصْرَانِيَّةً
u'قَذَفَ هِلاَلٌ':Subject, #1: 1	قَذَفَ هِلالُ
u'قَذَفَ هِلاَلٌ':Subject, #1: 1	قَذَفَ هِلَالٌ
u'قَذَفَ هِلاَلٌ':Subject, #1: 1	قَذَفَ هِلَالُ
u'قَذَفَ واحد':Predicate, #1: 1	قَذَفَ هِلاَلُ
u'قَذَفَ وَاحِدٌ':Predicate, #1: 1	قَذَفَ وَاحِدَةً
u'قَذَفَ ولد':Subject, #1: 1	قَذَفَ وَاحِدَةً
u'قَذَفَ وَلَدٌ':Subject, #1: 1	قَذَفَ الْوَلَدُ
u'قَذَفَ يَوْمٌ':Predicate, #1: 1	قَذَفَ الْوَلَدُ
u'قَذَى مَسْجِدٌ':Predicate, #2: 2	قَذَفَ يَوْمَ
u'قَرَأَ اِبْنٌ':Subject, #1: 1	قَذَى الْمَسْجِدَ
u'قَرَأَ اِبْنٌ':Subject, #13: 13	قَرَأَ ابْنُ
u'قَرَأَ أحَدٌ':Subject, #1: 1	قَرَأَ ابْنُهُ
u'قَرَأَ آخِرُ':Predicate, #2: 2	قَرَأَ أَحَدٌ
u'قَرَأَ أُسْتَاذٌ':Subject, #3: 3	قَرَأَ آخِرَ
u'قَرَأَ أعْمَش':Subject, #1: 1	قَرَأَ الْأُسْتَاذُ
u'قَرَأَ أقَلُّ':Predicate, #1: 1	قَرَأَ الأَعْمَشُ
u'قَرَأَ أَكْثَرُ':Predicate, #2: 2	قَرَأَ أَقَلَّ
u'قَرَأَ ألف':Predicate, #2: 2	قَرَأَ أَكْثَرَ
u'قَرَأَ ألْفٌ':Predicate, #1: 1	قَرَأَ أَلْفَ
u'قَرَأَ أَلْفٌ':Predicate, #1: 1	قَرَأَ أَلْفَ
u'قَرَأَ أُمٌّ':Predicate, #1: 1	قَرَأَ أَلْفَ
u'قَرَأَ إمَامٌ':Subject, #1: 1	قَرَأَ أُمَّ
u'قَرَأَ إمَامٌ':Subject, #1: 1	قَرَأَ إمَامٌ
u'قَرَأَ إمَامٌ':Subject, #24: 24	قَرَأَ الْإِمَامُ
u'قَرَأَ آيٌ':Predicate, #3: 3	قَرَأَ إمَامُهُ
u'قَرَأَ آيَةٌ':Predicate, #1: 1	قَرَأَ آيَ
u'قَرَأَ آيَةٌ':Predicate, #1: 1	قَرَأَ الآيَةَ
u'قَرَأَ آيَةٌ':Predicate, #2: 2	قَرَأَ الْآيَةَ
u'قَرَّ أَبٌ':Subject, #64: 64	قَرَأَ آيَةَ
u'قَرَابَةٌ أَبٌ':Added, #9: 9	أَقَرَّ الْأَبُ
u'قَرَابَةٌ أَبٌ':Added, #1: 1	قَرَابَةُ أَبٍ
u'قَرَابَةٌ أَبٌ':Added, #6: 6	قَرَابَةَ الْأَبِ
u'قَرَابَةٌ أَبٌ':Added, #7: 7	قَرَابَةِ الْأَبِ
u'قَرَابَةٌ أبَدٌ':Added, #8: 8	قَرَابَةُ الْأَبِ
u'قَرَابَةٌ اِبْنٌ':Added, #1: 1	قَرَابَةُ الْأَبَدِ
u'قَرَابَةٌ أَخٌ':Added, #1: 1	قَرَابَةِ ابْنِ
u'قَرَابَةٌ أَخٌ':Added, #1: 1	قَرَابَةُ الْأَخِ
u'قَرَابَةٌ أُخْتٌ':Added, #4: 4	قَرَابَةَ الْأَخِ
u'قَرَابَةٌ أُخْتٌ':Added, #1: 1	قَرَابَةَ الْأُخْتِ
u'قَرَابَةٌ أخْوَالٌ':Added, #1: 1	قَرَابَةُ الْأُخْتِ
u'قَرَابَةٌ إِخْوَةٌ':Added, #1: 1	قَرَابَةِ الْأَخْوَالِ
u'قَرَابَةٌ أُخُوَّةٌ':Added, #1: 1	قَرَابَةُ الْإِخْوَةِ
u'قَرَابَةٌ أُمٌّ':Added, #3: 3	قَرَابَةَ الْأُخُوَّةِ
u'قَرَابَةٌ أُمٌّ':Added, #1: 1	قَرَابَةِ أُمِّ
u'قَرَابَةٌ أُمٌّ':Added, #1: 1	قَرَابَةَ أُمِّهِ
u'قَرَابَةٌ أُمٌّ':Added, #1: 1	قَرَابَةِ أُمِّهِ
u'قَرَابَةٌ أُمٌّ':Added, #27: 27	قَرَابَةِ الْأُمِّ
u'قَرَابَةٌ أُمٌّ':Added, #3: 3	قَرَابَةُ أُمِّهِ
u'قَرَابَةٌ أُمٌّ':Added, #7: 7	قَرَابَةَ الْأُمِّ
u'قَرَابَةٌ إمَامٌ':Added, #8: 8	قَرَابَةُ الْأُمِّ
u'قَرَابَةٌ أمَةٌ':Added, #1: 1	قَرَابَةِ الْإِمَامِ
u'قَرَابَةٌ أَوْلاَدٌ':Added, #1: 1	قَرَابَةِ الْأَمَةِ
u'قَرَابَةٌ أَوْلاَدٌ':Added, #1: 1	قَرَابَةُ الْأَوْلَادِ
u'قَرَابَةٌ بَعْض':Added, #1: 1	قَرَابَةِ الْأَوْلَادِ
u'قَرَابَةٌ حاصِلٌ':Added, #1: 1	قَرَابَةٍ بَعْضِيَّةٍ
u'قَرَابَةٌ حَمْلٌ':Added, #1: 1	قَرَابَةٍ حَاصِلَةٍ
u'قَرَابَةٌ رحم':Added, #1: 1	قَرَابَةِ حَمْلٍ
u'قَرَابَةٌ رَحِمٌ':Added, #1: 1	قَرَابَةُ الرَّحِمِ
u'قَرَابَةٌ رَسُولٌ':Added, #1: 1	قَرَابَةُ الرَّحِمِ
u'قَرَابَةٌ رَسُولٌ':Added, #1: 1	قَرَابَةَ رَسُولِ
u'قَرَابَةٌ رَسُولٌ':Added, #3: 3	قَرَابَةُ رَسُولِ
u'قَرَابَةٌ سَبَبٌ':Added, #3: 3	قَرَابَةِ رَسُولِ
u'قَرَابَةٌ صَغِيرٌ':Added, #1: 1	قَرَابَةُ السَّبَبِ
u'قَرَابَةٌ عُمُوم':Added, #1: 1	قَرَابَةِ الصَّغِيرِ
u'قَرَابَةٌ عُمُومَة':Added, #1: 1	قَرَابَةُ الْعُمُومَةِ
u'قَرَابَةٌ غَيْبٌ':Added, #1: 1	قَرَابَةُ الْعُمُومَةِ
u'قَرَابَةٌ غير':Added, #1: 1	قَرَابَةُ غَيْبٍ
u'قَرَابَةٌ غَيْرٌ':Added, #1: 1	قَرَابَةُ غَيْرِهِ
u'قَرَابَةٌ فُلاَنٌ':Added, #1: 1	قَرَابَةُ غَيْرِهِ
u'قَرَابَةٌ كَبِيرٌ':Added, #1: 1	قَرَابَةِ فُلَانٍ
u'قَرَابَةٌ مَحْرَم':Added, #1: 1	قَرَابَةُ الْكَبِيرَيْنِ
u'قَرَابَةٌ مَحْرَمَة':Added, #1: 1	قَرَابَةُ مَحْرَمِيَّةٍ
u'قَرَابَةٌ مُؤَبَّدٌ':Added, #1: 1	قَرَابَةُ مَحْرَمِيَّةٍ
u'قَرَابَةٌ مَوْلُودٌ':Added, #1: 1	قَرَابَةٍ مُؤَبَّدَةٍ
u'قَرَابَةٌ مُؤَيَّدٌ':Added, #1: 1	قَرَابَةِ الْمَوْلُودِ
u'قَرَابَةٌ نَبِيٌّ':Added, #2: 2	قَرَابَةٍ مُؤَيَّدَةٍ
u'قَرَابَةٌ نَبِيٌّ':Added, #1: 1	قَرَابَةَ النَّبِيِّ
u'قَرَابَةٌ هَاشِمٌ':Added, #1: 1	قَرَابَةِ النَّبِيِّ
u'قَرَابَةٌ واحد':Added, #1: 1	قَرَابَةَ هَاشِمٍ
u'قَرَابَةٌ وَاحِدٌ':Added, #9: 9	قَرَابَةٍ وَاحِدَةٍ
u'قَرَابَةٌ وَاقِفٌ':Added, #9: 9	قَرَابَةٍ وَاحِدَةٍ
u'قَرَابَةٌ وَلاَءٌ':Added, #2: 2	قَرَابَةِ الْوَاقِفِ
u'قَرَابَةٌ وَلاَءٌ':Added, #1: 1	قَرَابَةُ الْوَلَاءِ
u'قَرَابَةٌ وِلاَدَةٌ':Added, #1: 1	قَرَابَةِ الْوَلَاءِ
u'قَرَابَةٌ وِلاَدَةٌ':Added, #1: 1	قَرَابَةِ الْوِلَادَةِ
u'قَرَابَةٌ ولد':Added, #2: 2	قَرَابَةُ الْوِلَادَةِ
u'قَرَابَةٌ وَلَدٌ':Added, #1: 1	قَرَابَةِ وَلَدِهِ
u'قَرَأَ بَعْضٌ':Predicate, #1: 1	قَرَابَةِ وَلَدِهِ
u'قَرَأَ بَعْضٌ':Predicate, #1: 1	قَرَأَ الْبَعْضَ
u'قَرَأَ بَقَرٌ':Predicate, #5: 5	قَرَأَ بَعْضَ
u'قَرَأَ بَقَرٌ':Predicate, #1: 1	أَقْرَأَ الْبَقَرَةَ
u'قَرَّ اِبْنٌ':Predicate, #3: 3	قَرَأَ الْبَقَرَةَ
u'قَرَّ اِبْنٌ':Subject, #1: 1	أَقَرَّ ابْنَ
u'قَرَّ اِبْنٌ':Subject, #2: 2	أَقَرَّ ابْنُ
u'قَرَأَ تَشَهُّدٌ':Predicate, #3: 3	أَقَرَّ ابْنٌ
u'قَرَأَ تِلْميذٌ':Subject, #2: 2	قَرَأَ التَّشَهُّدَ
u'قَرَأَ ثَانِي':Predicate, #2: 2	قَرَأَ التِّلْمِيذُ
u'قَرَأَ ثَانِيَةٌ':Predicate, #2: 2	قَرَأَ الثَّانِيَةَ
u'قَرَأَ جَازٌ':Predicate, #2: 2	قَرَأَ الثَّانِيَةَ
u'قَرَأَ جَرِيرٌ':Subject, #1: 1	قَرَأَ جَازَ
u'قَرَأَ جمعة':Predicate, #2: 2	قَرَأَ جَرِيرٌ
u'قَرَأَ جُمُعَةٌ':Predicate, #1: 1	قَرَأَ الْجُمُعَةَ
u'قَرَأَ جمعة':Subject, #1: 1	قَرَأَ الْجُمُعَةَ
u'قَرَأَ جُمُعَةٌ':Subject, #1: 1	قَرَأَ الْجُمُعَةُ
u'قَرَأَ جَمِيع':Predicate, #1: 1	قَرَأَ الْجُمُعَةُ
u'قَرَّ أَجْنَبِيٌّ':Subject, #2: 2	قَرَأَ الْجَمِيعَ
u'قَرَّ أَجْنَبِيٌّ':Subject, #1: 1	أَقَرَّ أَجْنَبِيٌّ
u'قَرَّ أَجِيرٌ':Subject, #1: 1	أَقَرَّ الْأَجْنَبِيُّ
u'قَرَّ أحَدٌ':Subject, #4: 4	أَقَرَّ الْأَجِيرُ
u'قَرَأَ حَديثٌ':Predicate, #33: 33	أَقَرَّ أَحَدُ
u'قَرَأَ حَرْفٌ':Predicate, #1: 1	قَرَأَ الْحَدِيثَ
u'قَرَأَ حَرْفٌ':Predicate, #1: 1	قَرَأَ حَرْفَ
u'قَرَأَ حَسَنٌ':Subject, #2: 2	قَرَأَ الْحَرْفَ
u'قَرَأَ حَمْدٌ':Predicate, #1: 1	قَرَأَ الْحَسَنُ
u'قَرَأَ حَمْدٌ':Subject, #1: 1	قَرَأَ الْحَمْدَ
u'قَرَأَ حَيَوَانٌ':Subject, #2: 2	قَرَأَ الْحَمْدُ
u'قَرَّ أَخٌ':Subject, #1: 1	قَرَأَ حَيَوَانٌ
u'قَرَأَ خَارِجٌ':Predicate, #3: 3	أَقَرَّ الْأَخُ
u'قَرَّ أخرَس':Subject, #1: 1	قَرَأَ خَارِجَ
u'قَرَأَ خَطِيبٌ':Subject, #1: 1	أَقَرَّ الْأَخْرَسُ
u'قَرَأَ خَلْفٌ':Predicate, #5: 5	قَرَأَ الْخَطِيبُ
u'قَرَأَ ذكر':Predicate, #7: 7	قَرَأَ خَلْفَ
u'قَرَأَ ذِكْرٌ':Predicate, #1: 1	قَرَأَ ذِكْرَ
u'قَرَأَ رَاجِعٌ':Subject, #1: 1	قَرَأَ ذِكْرَ
u'قرار أرْضٌ':Added, #1: 1	قَرَأَ رَاجِعٌ
u'قَرَارٌ أرْضٌ':Added, #1: 1	قَرَارِ أَرْضِ
u'قرار أرْضٌ':Added, #1: 1	قَرَارِ أَرْضِ
u'قَرَارٌ أرْضٌ':Added, #1: 1	قَرَارِ أَرْضِهِ
u'قرار أرْضٌ':Added, #1: 1	قَرَارِ أَرْضِهِ
u'قَرَارٌ أرْضٌ':Added, #1: 1	قَرَارِ الْأَرْضِ
u'قَرَّ أَرْبَعُ':Predicate, #1: 1	قَرَارِ الْأَرْضِ
u'قَرَّ أَرْبَعَةٌ':Subject, #8: 8	أَقَرَّ أَرْبَعَ
u'قرار بِنَاءٌ':Added, #1: 1	أَقَرَّ أَرْبَعَةٌ
u'قَرَارٌ بِنَاءٌ':Added, #1: 1	قَرَارِ الْبِنَاءِ
u'قرار بِئْرٌ':Added, #1: 1	قَرَارِ الْبِنَاءِ
u'قَرَارٌ بِئْرٌ':Added, #1: 1	قَرَارِ الْبِئْرِ
u'قرار تَصَرُّفٌ':Added, #1: 1	قَرَارِ الْبِئْرِ
u'قَرَارٌ تَصَرُّفٌ':Added, #1: 1	قَرَارِ التَّصَرُّفِ
u'قرار ثَمَنٌ':Added, #1: 1	قَرَارِ التَّصَرُّفِ
u'قَرَارٌ ثَمَنٌ':Added, #1: 1	قَرَارِ الثَّمَنِ
u'قَرَأَ رَجُلٌ':Subject, #1: 1	قَرَارِ الثَّمَنِ
u'قَرَأَ رَجُلٌ':Subject, #3: 3	قَرَأَ الرَّجُلُ
u'قرار رُجُوعٌ':Added, #5: 5	قَرَأَ رَجُلٌ
u'قَرَارٌ رُجُوعٌ':Added, #2: 2	قَرَارَ الرُّجُوعِ
u'قرار رِواقٌ':Added, #2: 2	قَرَارَ الرُّجُوعِ
u'قَرَارٌ رِواقٌ':Added, #1: 1	قَرَارُ الرِّوَاقِ
u'قَرَأَ رَسُولٌ':Subject, #1: 1	قَرَارُ الرِّوَاقِ
u'قرار ضَمَانٌ':Added, #22: 22	قَرَأَ رَسُولُ
u'قَرَارٌ ضَمَانٌ':Added, #12: 12	قَرَارُ الضَّمَانِ
u'قرار ضَمَانٌ':Added, #12: 12	قَرَارُ الضَّمَانِ
u'قرار ضَمَانٌ':Added, #1: 1	قَرَارَ ضَمَانِ
u'قرار ضَمَانٌ':Added, #1: 1	قَرَارُ ضَمَانِ
u'قَرَارٌ ضَمَانٌ':Added, #1: 1	قَرَارِ ضَمَانِ
u'قَرَارٌ ضَمَانٌ':Added, #1: 1	قَرَارَ ضَمَانِ
u'قَرَارٌ ضَمَانٌ':Added, #1: 1	قَرَارُ ضَمَانِ
u'قرار ضَمَانٌ':Added, #1: 1	قَرَارِ ضَمَانِ
u'قَرَارٌ ضَمَانٌ':Added, #1: 1	قَرَارُ ضَمَانِهِ
u'قرار ضَمَانٌ':Added, #1: 1	قَرَارُ ضَمَانِهِ
u'قَرَارٌ ضَمَانٌ':Added, #8: 8	قَرَارَ الضَّمَانِ
u'قرار ضَيْعَةٌ':Added, #8: 8	قَرَارَ الضَّمَانِ
u'قَرَارٌ ضَيْعَةٌ':Added, #1: 1	قَرَارِ الضَّيْعَةِ
u'قرار عُلْوٌ':Added, #1: 1	قَرَارِ الضَّيْعَةِ
u'قَرَارٌ عُلْوٌ':Added, #1: 1	قَرَارُ الْعُلْوِ
u'قرار عُلُوٌّ':Added, #1: 1	قَرَارُ الْعُلْوِ
u'قرار عُلُوٌّ':Added, #2: 2	قَرَارَ الْعُلُوِّ
u'قَرَارٌ عُلُوٌّ':Added, #2: 2	قَرَارِ الْعُلُوِّ
u'قَرَارٌ عُلُوٌّ':Added, #2: 2	قَرَارَ الْعُلُوِّ
u'قرار عُلْوٌ':Added, #2: 2	قَرَارِ الْعُلُوِّ
u'قَرَارٌ عُلْوٌ':Added, #3: 3	قَرَارِ الْعُلْوِ
u'قرار عِمَارَةٌ':Added, #3: 3	قَرَارِ الْعُلْوِ
u'قَرَارٌ عِمَارَةٌ':Added, #2: 2	قَرَارِ الْعِمَارَةِ
u'قرار عين':Added, #2: 2	قَرَارِ الْعِمَارَةِ
u'قرار عَيْنٌ':Added, #13: 13	قَرَارِ الْعَيْنِ
u'قرار عَيْن':Added, #13: 13	قَرَارِ الْعَيْنِ
u'قَرَارٌ عين':Added, #13: 13	قَرَارِ الْعَيْنِ
u'قَرَارٌ عَيْنٌ':Added, #13: 13	قَرَارِ الْعَيْنِ
u'قَرَارٌ عَيْن':Added, #13: 13	قَرَارِ الْعَيْنِ
u'قرار عين':Added, #13: 13	قَرَارِ الْعَيْنِ
u'قرار عَيْنٌ':Added, #1: 1	قَرَار الْعَيْنِ
u'قرار عَيْن':Added, #1: 1	قَرَار الْعَيْنِ
u'قَرَارٌ عين':Added, #1: 1	قَرَار الْعَيْنِ
u'قَرَارٌ عَيْنٌ':Added, #1: 1	قَرَار الْعَيْنِ
u'قَرَارٌ عَيْن':Added, #1: 1	قَرَار الْعَيْنِ
u'قرار عين':Added, #1: 1	قَرَار الْعَيْنِ
u'قرار عَيْنٌ':Added, #1: 1	قَرَارَ عَيْنِ
u'قرار عَيْن':Added, #1: 1	قَرَارَ عَيْنِ
u'قَرَارٌ عين':Added, #1: 1	قَرَارَ عَيْنِ
u'قَرَارٌ عَيْنٌ':Added, #1: 1	قَرَارَ عَيْنِ
u'قَرَارٌ عَيْن':Added, #1: 1	قَرَارَ عَيْنِ
u'قرار عين':Added, #1: 1	قَرَارَ عَيْنِ
u'قرار عَيْنٌ':Added, #26: 26	قَرَارِ عَيْنِ
u'قرار عَيْن':Added, #26: 26	قَرَارِ عَيْنِ
u'قَرَارٌ عين':Added, #26: 26	قَرَارِ عَيْنِ
u'قَرَارٌ عَيْنٌ':Added, #26: 26	قَرَارِ عَيْنِ
u'قَرَارٌ عَيْن':Added, #26: 26	قَرَارِ عَيْنِ
u'قرار عَيْنٌ':Added, #26: 26	قَرَارِ عَيْنِ
u'قرار عَيْن':Added, #2: 2	قَرَارِ عَيْنٍ
u'قَرَارٌ عَيْنٌ':Added, #2: 2	قَرَارِ عَيْنٍ
u'قَرَارٌ عَيْن':Added, #2: 2	قَرَارِ عَيْنٍ
u'قرار عُيُونٌ':Added, #2: 2	قَرَارِ عَيْنٍ
u'قَرَارٌ عُيُونٌ':Added, #2: 2	قَرَارِ عُيُونِ
u'قرار عُيُونٌ':Added, #2: 2	قَرَارِ عُيُونِ
u'قَرَارٌ عُيُونٌ':Added, #3: 3	قَرَارِ الْعُيُونِ
u'قرار عُيُونٌ':Added, #3: 3	قَرَارِ الْعُيُونِ
u'قَرَارٌ عُيُونٌ':Added, #4: 4	قَرَارَ عُيُونِ
u'قرار غُرْمٌ':Added, #4: 4	قَرَارَ عُيُونِ
u'قَرَارٌ غُرْمٌ':Added, #1: 1	قَرَارُ الْغُرْمِ
u'قرار مَاءٌ':Added, #1: 1	قَرَارُ الْغُرْمِ
u'قَرَارٌ مَاءٌ':Added, #4: 4	قَرَارِ الْمَاءِ
u'قرار مَحْمَلٌ':Added, #4: 4	قَرَارِ الْمَاءِ
u'قَرَارٌ مَحْمَلٌ':Added, #1: 1	قَرَارُ الْمَحْمَلِ
u'قرار مِلْكٌ':Added, #1: 1	قَرَارُ الْمَحْمَلِ
u'قَرَارٌ مِلْكٌ':Added, #2: 2	قَرَارُ الْمِلْكِ
u'قرار هَاوِي':Added, #2: 2	قَرَارُ الْمِلْكِ
u'قَرَارٌ هَاوِي':Added, #1: 1	قَرَارِ الْهَاوِيَةِ
u'قَرَّ أُسْتَاذٌ':Subject, #1: 1	قَرَارِ الْهَاوِيَةِ
u'قَرَأَ سجدة':Predicate, #1: 1	أَقَرَّ الْأُسْتَاذُ
u'قَرَأَ سَجْدَةٌ':Predicate, #2: 2	قَرَأَ سَجْدَةَ
u'قَرَأَ سجدة':Predicate, #2: 2	قَرَأَ سَجْدَةَ
u'قَرَأَ سَجْدَةٌ':Predicate, #9: 9	قَرَأَ السَّجْدَةَ
u'قَرَأَ سَواءٌ':Subject, #9: 9	قَرَأَ السَّجْدَةَ
u'قَرَأَ سُورَةٌ':Predicate, #1: 1	قَرَأَ سَوَاءٌ
u'قَرَأَ سُورَةٌ':Predicate, #17: 17	قَرَأَ السُّورَةَ
u'قَرَأَ سُورَةٌ':Predicate, #29: 29	قَرَأَ سُورَةَ
u'قَرَأَ شَطْرٌ':Predicate, #2: 2	أَقْرَأَ سُورَةَ
u'قَرَأَ شَيْخٌ':Subject, #1: 1	قَرَأَ شَطْرَ
u'قَرَأَ عَامٌ':Predicate, #1: 1	قَرَأَ الشَّيْخُ
u'قَرَأَ عَامِرٌ':Subject, #2: 2	قَرَأَ عَامَ
u'قَرَأَ عَبْدٌ':Subject, #1: 1	قَرَأَ عَامِرٌ
u'قَرَأَ عَشْرٌ':Predicate, #2: 2	قَرَأَ عَبْدُ
u'قَرَأَ عَشْرٌ':Predicate, #1: 1	قَرَأَ عَشْرَ
u'قَرَأَ عَلْقَم':Subject, #4: 4	قَرَأَ الْعَشْرَ
u'قَرَأَ عَلْقَمَة':Subject, #1: 1	قَرَأَ عَلْقَمَةُ
u'قَرَأَ علم':Predicate, #1: 1	قَرَأَ عَلْقَمَةُ
u'قَرَأَ عِلْمٌ':Predicate, #1: 1	أَقْرَأَ عِلْمَ
u'قَرَأَ عُمَرٌ':Subject, #1: 1	أَقْرَأَ عِلْمَ
u'قَرَأَ عند':Predicate, #7: 7	قَرَأَ عُمَرُ
u'قَرَأَ عَهْدٌ':Predicate, #6: 6	قَرَأَ عِنْدَ
u'قَرَأَ غُلاَمٌ':Subject, #1: 1	قَرَأَ الْعَهْدَ
u'قَرَأَ غير':Predicate, #1: 1	قَرَأَ غُلَامٌ
u'قَرَأَ غَيْرٌ':Predicate, #3: 3	قَرَأَ غَيْرَ
u'قَرَأَ غير':Subject, #3: 3	قَرَأَ غَيْرَ
u'قَرَأَ غَيْرٌ':Subject, #1: 1	قَرَأَ غَيْرُهُ
u'قَرَأَ فَاتِحٌ':Predicate, #1: 1	قَرَأَ غَيْرُهُ
u'قَرَأَ فَاتِحٌ':Predicate, #1: 1	قَرَأَ فَاتِحَةَ
u'قَرَأَ فَاتِحَةٌ':Predicate, #44: 44	قَرَأَ الْفَاتِحَةَ
u'قَرَأَ فَاتِحَةٌ':Predicate, #1: 1	قَرَأَ فَاتِحَةَ
u'قَرَأَ فلان':Subject, #44: 44	قَرَأَ الْفَاتِحَةَ
u'قَرَأَ فلان':Subject, #1: 1	قَرَأَ قَتَادَةُ
u'قَرَأَ فلان':Subject, #1: 1	قَرَأَ لُقْمَانُ
u'قَرَأَ قَارِئٌ':Subject, #1: 1	قَرَأَ مُعَاوِيَةُ
u'قَرَأَ قَارِئٌ':Subject, #1: 1	قَرَأَ الْقَارِئُ
u'قَرَأَ قَتاد':Subject, #3: 3	قَرَأَ قَارِئٌ
u'قَرَأَ قَدْرٌ':Predicate, #1: 1	قَرَأَ قَتَادَةُ
u'قَرَأَ قَدْرٌ':Predicate, #1: 1	قَرَأَ الْقَدْرَ
u'قَرَأَ قِرَاءةٌ':Predicate, #3: 3	قَرَأَ قَدْرَ
u'قَرَأَ قُرْآنٌ':Predicate, #3: 3	قَرَأَ قِرَاءَةَ
u'قَرَأَ قُرْآنٌ':Predicate, #5: 5	أَقْرَأَ الْقُرْآنَ
u'قَرَأَ قطعة':Predicate, #62: 62	قَرَأَ الْقُرْآنَ
u'قَرَأَ قِطْعَةٌ':Predicate, #1: 1	قَرَأَ قِطْعَةَ
u'قَرَأَ قُنُوتٌ':Predicate, #1: 1	قَرَأَ قِطْعَةَ
u'قَرَأَ قَوْمٌ':Subject, #1: 1	قَرَأَ الْقُنُوتَ
u'قَرَأَ كِتَابٌ':Predicate, #1: 1	قَرَأَ قَوْمٌ
u'قَرَأَ كِتَابٌ':Predicate, #5: 5	قَرَأَ كِتَابَ
u'قَرَأَ كُتُبٌ':Predicate, #6: 6	قَرَأَ الْكِتَابَ
u'قَرَأَ كَعْبٌ':Subject, #1: 1	قَرَأَ الْكُتُبَ
u'قَرَأَ كَلاَمٌ':Subject, #1: 1	قَرَأَ كَعْبٌ
u'قَرَأَ مَالِكٌ':Subject, #1: 1	قَرَأَ كَلَامُ
u'قَرَّ إمَامٌ':Subject, #2: 2	قَرَأَ مَالِكٌ
u'قَرَأَ مثل':Predicate, #1: 1	أَقَرَّ الْإِمَامُ
u'قَرَأَ مِثْلٌ':Predicate, #1: 1	قَرَأَ مِثْلَ
u'قَرَأَ مُجَاهِدٌ':Subject, #1: 1	قَرَأَ مِثْلَ
u'قَرَأَ مُحْدِثٌ':Subject, #2: 2	قَرَأَ مُجَاهِدٌ
u'قَرَّ أَمْرٌ':Subject, #1: 1	قَرَأَ الْمُحْدِثُ
u'قَرَّ آمِرٌ':Subject, #1: 1	قَرَّ الْأَمْرُ
u'قَرَأَ مَسْبُوق':Subject, #4: 4	أَقَرَّ الْآمِرُ
u'قَرَأَ مُسْتَحَبٌّ':Predicate, #1: 1	قَرَأَ الْمَسْبُوقُ
u'قَرَأَ مُعاوِيَة':Subject, #1: 1	قَرَأَ الْمُسْتَحَبَّ
u'قَرَأَ مِقْدَارٌ':Predicate, #1: 1	قَرَأَ مُعَاوِيَةُ
u'قَرَأَ مَكَانٌ':Predicate, #11: 11	قَرَأَ مِقْدَارَ
u'قَرَأَ مَكْتُوبٌ':Predicate, #1: 1	قَرَأَ مَكَانَ
u'قَرَأَ مَكْتُوبٌ':Subject, #1: 1	قَرَأَ الْمَكْتُوبَ
u'قَرَأَ مُنَافِقٌ':Predicate, #1: 1	قَرَأَ الْمَكْتُوبُ
u'قَرَأَ نَاسٌ':Subject, #1: 1	قَرَأَ الْمُنَافِقِينَ
u'قَرَأَ نَبِيٌّ':Subject, #1: 1	قَرَأَ نَاسٌ
u'قَرَأَ نَبِيٌّ':Subject, #1: 1	قَرَأَ نَبِيُّ
u'قَرَأَ نَجْمٌ':Predicate, #2: 2	قَرَأَ النَّبِيُّ
u'قَرَأَ نَحْوٌ':Predicate, #3: 3	قَرَأَ النَّجْمَ
u'قَرَّ إِنْسانٌ':Subject, #1: 1	قَرَأَ النَّحْوَ
u'قُرْآنٌ شَارِعٌ':Added, #1: 1	أَقَرَّ إنْسَانٌ
u'قَرَأَ نصب':Predicate, #1: 1	قُرْآنَ الشَّارِعِ
u'قَرَأَ نَصْبٌ':Predicate, #1: 1	قَرَأَ النَّصْبَ
u'قَرَأَ نِصْفٌ':Predicate, #1: 1	قَرَأَ النَّصْبَ
u'قِرَانٌ عَدَدٌ':Added, #3: 3	قَرَأَ نِصْفَ
u'قِرَانٌ غَسْلٌ':Added, #4: 4	قِرَانُ الْعَدَدِ
u'قُرْآنٌ فَجْرٌ':Added, #1: 1	قِرَانُ الْغَسْلِ
u'قَرَأَ نَفْسٌ':Predicate, #11: 11	قُرْآنَ الْفَجْرِ
u'قِرَانٌ فلان':Added, #1: 1	قَرَأَ نَفْسَ
u'قِرَانٌ قول':Added, #2: 2	قِرَانِ الْمَكِّيِّ
u'قِرَانٌ قَوْلٌ':Added, #1: 1	قِرَانُ قَوْلِ
u'قُرْآنٌ مُحَمَّدٌ':Added, #1: 1	قِرَانُ قَوْلِ
u'قِرَانٌ مُدَّةٌ':Added, #1: 1	قُرْآنِ مُحَمَّدٍ
u'قُرْآنٌ مُشْتَمِلٌ':Added, #1: 1	قِرَانِ الْمُدَّةِ
u'قِرَانٌ مَكِّيّ':Added, #1: 1	قُرْآنٍ مُشْتَمِلٍ
u'قُرْآنٌ مُنْكِرٌ':Added, #2: 2	قِرَانِ الْمَكِّيِّ
u'قِرَانٌ نِيَّةٌ':Added, #1: 1	قُرْآنُ الْمُنْكِرِ
u'قِرَانٌ نِيَّةٌ':Added, #1: 1	قِرَانَ النِّيَّةِ
u'قِرَانٌ نِيَّةٌ':Added, #1: 1	قِرَانُ نِيَّةِ
u'قَرَّ أهْلٌ':Predicate, #5: 5	قِرَانُ النِّيَّةِ
u'قَرَّ أهْلٌ':Subject, #2: 2	أَقَرَّ أَهْلَ
u'قَرَأَ وَاجِبٌ':Predicate, #2: 2	أَقَرَّ أَهْلُهُ
u'قَرَأَ واحد':Subject, #1: 1	قَرَأَ الْوَاجِبَ
u'قَرَأَ وَاحِدٌ':Subject, #1: 1	قَرَأَ وَاحِدٌ
u'قَرَأَ وَراء':Predicate, #1: 1	قَرَأَ وَاحِدٌ
u'قَرَّ أَوَّلُ':Subject, #1: 1	قَرَأَ وَرَاءَ
u'قَرَأَ يَدٌ':Subject, #2: 2	أَقَرَّ الْأَوَّلُ
u'قَرَأَ يَوْمٌ':Predicate, #1: 1	قَرَأَ يَدُ
u'قُرْبٌ إِبِلٌ':Added, #2: 2	قَرَأَ يَوْمَ
u'قُرْبٌ إِبِلٌ':Added, #1: 1	قُرْبَ الإِبِلِ
u'قَرُبَ أَجَلٌ':Subject, #1: 1	قُرْبُ الإِبِلِ
u'قُرْبٌ أَجَلٌ':Added, #3: 3	قَرُبَ الْأَجَلُ
u'قَرِبَ أَجْنَبِيٌّ':Predicate, #1: 1	قُرْبِ الْأَجَلِ
u'قَرَّبَ أَجِيرٌ':Subject, #1: 1	قَرِبَ الْأَجْنَبِيَّةَ
u'قَرُبَ اِحْتِمَالٌ':Subject, #1: 1	قَرَّبَ الْأَجِيرُ
u'قُرْبٌ آخِرُ':Added, #1: 1	قَرُبَ احْتِمَالُ
u'قُرْبٌ أَدْيانٌ':Added, #2: 2	قُرْبِ آخِرِ
u'قَرُبَ أَذَانٌ':Subject, #1: 1	قُرْبُ الْأَدْيَانِ
u'قُرْبٌ أرْضٌ':Added, #2: 2	قَرُبَ الْأَذَانُ
u'قَرُبَ إِسْلامٌ':Subject, #1: 1	قُرْبِ الْأَرْضِ
u'قُرْبٌ اِسْمٌ':Added, #1: 1	قَرُبَ إسْلَامُهُ
u'قُرْبٌ أصل':Added, #1: 1	قُرْبِ اسْمِهِ
u'قُرْبٌ أًصْلٌ':Added, #4: 4	قُرْبِ أَصْلِهِ
u'قَرُبَ أَصَمّ':Subject, #4: 4	قُرْبِ أَصْلِهِ
u'قُرْبٌ أفْضَلُ':Added, #2: 2	قَرُبَ الْأَصَمُّ
u'قُرْبٌ إقامَةٌ':Added, #1: 1	قُرْبُ الْأَفْضَلِ
u'قَرَّ بالِغٌ':Subject, #1: 1	قُرْبَ إقَامَةِ
u'قَرَّبَ أُمٌّ':Predicate, #1: 1	أَقَرَّ الْبَالِغُ
u'قُرْبٌ إمَامٌ':Added, #1: 1	قَرَّبَ أُمَّ
u'قُرْبٌ إمَامٌ':Added, #1: 1	قُرْبَ الإِمَامِ
u'قَرُبَ أَمْرٌ':Subject, #1: 1	قُرْبَ الْإِمَامِ
u'قُرْبَانٌ أَجْنَبِيٌّ':Added, #1: 1	قَرُبَ الْأَمْرُ
u'قُرْبَانٌ الْمَرْأَةُ':Added, #1: 1	قُرْبَانُ الْأَجْنَبِيَّةِ
u'قُرْبَانٌ اِمْرَأَةٌ':Added, #2: 2	قُرْبَانُ الْمَرْأَةِ
u'قُرْبَانٌ اِمْرَأَةٌ':Added, #1: 1	قُرْبَانَ امْرَأَتِهِ
u'قُرْبَانٌ اِمْرَأَةٌ':Added, #1: 1	قُرْبَانِ امْرَأَتِهِ
u'قُرْبَانٌ حُرٌّ':Added, #3: 3	قُرْبَانُ امْرَأَتِهِ
u'قُرْبَانٌ رابع':Added, #2: 2	قُرْبَانُ الْحُرَّةِ
u'قُرْبَانٌ رَابِعٌ':Added, #1: 1	قُرْبَانَ الرَّابِعَةِ
u'قَرُبَ إِنْزالٌ':Subject, #1: 1	قُرْبَانَ الرَّابِعَةِ
u'قُرْبٌ إِنْزالٌ':Added, #1: 1	قَرُبَ الْإِنْزَالُ
u'قُرْبَانٌ زَوْجٌ':Added, #1: 1	قُرْبَ الْإِنْزَالِ
u'قَرَّبَ إِنْسانٌ':Subject, #2: 2	قُرْبَانِ الزَّوْجِ
u'قُرْبَانٌ سَيِّدٌ':Added, #1: 1	قَرَّبَ إنْسَانٌ
u'قُرْبَانٌ صَلاَةٌ':Added, #1: 1	قُرْبَانِ سَيِّدِهِ
u'قُرْبَانٌ صَلاَةٌ':Added, #1: 1	قُرْبَانُ الصَّلَاةِ
u'قُرْبٌ اِنْقِضاءٌ':Added, #4: 4	قُرْبَانِ الصَّلَاةِ
u'قُرْبَانٌ مَسْجِدٌ':Added, #1: 1	قُرْبَ انْقِضَاءِ
u'قُرْبَانٌ مَكَانٌ':Added, #1: 1	قُرْبَانِ الْمَسْجِدِ
u'قُرْبَانٌ مَنْكُوح':Added, #1: 1	قُرْبَانَ مَكَانِ
u'قُرْبَانٌ واحد':Added, #2: 2	قُرْبَانِ الْمَنْكُوحَةِ
u'قُرْبَانٌ وَاحِدٌ':Added, #1: 1	قُرْبَانِ وَاحِدَةٍ
u'قَرُبَ أوَانٌ':Subject, #1: 1	قُرْبَانِ وَاحِدَةٍ
u'قَرَّ بَائِعٌ':Subject, #1: 1	قَرُبَ أَوَانُ
u'قَرَّ بَائِعٌ':Subject, #1: 1	أَقَرَّ بَائِعُ
u'قَرِبَ باقِي':Predicate, #41: 41	أَقَرَّ الْبَائِعُ
u'قَرِبَ باقِيَةٌ':Predicate, #1: 1	قَرِبَ الْبَاقِيَةَ
u'قُرْبٌ بالِغٌ':Added, #1: 1	قَرِبَ الْبَاقِيَةَ
u'قُرْبٌ بَرٌّ':Added, #1: 1	قُرْبُ الْبَالِغِ
u'قَرُبَ بُعْدٌ':Subject, #1: 1	قُرْبَ الْبَرِّ
u'قَرَّبَ بَقَرٌ':Predicate, #1: 1	قَرُبَ الْبُعْدُ
u'قُرْبٌ بَلَدٌ':Added, #5: 5	قَرَّبَ بَقَرَةً
u'قَرُبَ بُلُوغٌ':Subject, #1: 1	قُرْبَ بَلَدِ
u'قُرْبٌ بُلُوغٌ':Added, #1: 1	قَرُبَ بُلُوغُ
u'قُرْبٌ بَيْتٌ':Added, #1: 1	قُرْبَ بُلُوغِهِ
u'قُرْبٌ بُيُوتٌ':Added, #1: 1	قُرْبَ الْبَيْتِ
u'قَرُبَ تَحْدِيدٌ':Subject, #1: 1	قُرْبَ الْبُيُوتِ
u'قُرْبٌ تَدْبِيرٌ':Added, #1: 1	قَرُبَ تَحْدِيدُهُ
u'قُرْبٌ تَسْلِيمٌ':Added, #1: 1	قُرْبَ التَّدْبِيرِ
u'قُرْبٌ تَسْلِيمٌ':Added, #1: 1	قُرْبَ التَّسْلِيمِ
u'قَرُبَ تَغَيُّرٌ':Subject, #1: 1	قُرْبَ تَسْلِيمِ
u'قَرُبَ تَفْلِيسٌ':Subject, #1: 1	قَرُبَ تَغَيُّرُهُ
u'قَرُبَ ثَالِثٌ':Subject, #1: 1	قَرُبَ تَفْلِيسُهُ
u'قَرِبَ ثَانِي':Predicate, #1: 1	قَرُبَ الثَّالِثُ
u'قَرِبَ ثَانِيَةٌ':Predicate, #1: 1	قَرِبَ الثَّانِيَةَ
u'قُرْبٌ ثِقَةٌ':Added, #1: 1	قَرِبَ الثَّانِيَةَ
u'قَرِبَ ثَلاثُ':Predicate, #1: 1	قُرْبَ ثِقَةٍ
u'قَرُبَ جَازٌ':Predicate, #1: 1	قَرِبَ الثَّلَاثَ
u'قَرِبَ جَازٌ':Predicate, #2: 2	قَرُبَ جَازَ
u'قَرُبَ جَائِزٌ':Subject, #5: 5	أَقْرَبَ جَازَ
u'قُرْبٌ جُلُوسٌ':Added, #1: 1	قَرُبَ جَائِزٌ
u'قُرْبٌ حائِطٌ':Added, #1: 1	قُرْبَ جُلُوسِهِ
u'قَرُبَ حَجٌّ':Subject, #1: 1	قُرْبَ الْحَائِطِ
u'قَرُبَ حَرْثٌ':Subject, #1: 1	قَرُبَ الْحَجُّ
u'قُرْبٌ حَرْثٌ':Added, #1: 1	قَرُبَ الْحَرْثُ
u'قُرْبٌ حَرَمٌ':Added, #1: 1	قُرْبَ الْحَرْثِ
u'قَرُبَ حُضورٌ':Subject, #3: 3	قُرْبَ الْحَرَمِ
u'قَرُبَ حُضُورٌ':Subject, #2: 2	قَرُبَ حُضُورُ
u'قُرْبٌ حِلٌّ':Added, #2: 2	قَرُبَ حُضُورُ
u'قَرُبَ حول':Subject, #1: 1	قُرْبُ الْحِلِّ
u'قَرُبَ حَوْلٌ':Subject, #4: 4	قَرُبَ الْحَوْلُ
u'قُرْبٌ حول':Added, #4: 4	قَرُبَ الْحَوْلُ
u'قُرْبٌ حَوْلٌ':Added, #1: 1	قُرْبَ الْحَوْلِ
u'قُرْبٌ دَارٌ':Added, #1: 1	قُرْبَ الْحَوْلِ
u'قُرْبٌ دَارٌ':Added, #1: 1	قُرْبَ دَارٍ
u'قَرَّبَ دَجاج':Predicate, #2: 2	قُرْبَ دَارِهِ
u'قُرْبٌ درجة':Added, #3: 3	قَرَّبَ دَجَاجَةً
u'قُرْبٌ دَرَجَةٌ':Added, #2: 2	قُرْبِ الدَّرَجَةِ
u'قُرْبٌ دِيَارٌ':Added, #2: 2	قُرْبِ الدَّرَجَةِ
u'قُرْبٌ رابِغ':Added, #1: 1	قُرْبُ الدِّيَارِ
u'قَرُبَ زَمانٌ':Subject, #1: 1	قُرْبَ رَابِغٍ
u'قُرْبٌ زَمانٌ':Added, #2: 2	قَرُبَ الزَّمَانُ
u'قُرْبٌ زَمانٌ':Added, #2: 2	قُرْبُ الزَّمَانِ
u'قَرُبَ زَمَنٌ':Subject, #3: 3	قُرْبِ الزَّمَانِ
u'قَرُبَ زَمَنٌ':Subject, #2: 2	قَرُبَ زَمَنُ
u'قَرُبَ زَمَنٌ':Subject, #3: 3	قَرُبَ زَمَنُهُ
u'قَرُبَ زَوالٌ':Subject, #4: 4	قَرُبَ الزَّمَنُ
u'قُرْبٌ زَوالٌ':Added, #1: 1	قَرُبَ زَوَالُ
u'قُرْبٌ زَوالٌ':Added, #1: 1	قُرْبِ الزَّوَالِ
u'قُرْبٌ زَوالٌ':Added, #1: 1	قُرْبَ زَوَالِهِ
u'قُرْبٌ سَاتِرٌ':Added, #1: 1	قُرْبُ زَوَالِهِ
u'قُرْبٌ سَاعَةٌ':Added, #1: 1	قُرْبَ السَّاتِرِ
u'قُرْبٌ سَاعَةٌ':Added, #1: 1	قُرْبَ السَّاعَةِ
u'قُرْبٌ سَحَرٌ':Added, #1: 1	قُرْبِ السّاعَةِ
u'قَرُبَ سَفَرٌ':Subject, #1: 1	قُرْبُ السّحَرِ
u'قَرِبَ سقط':Predicate, #1: 1	قَرُبَ السَّفَرُ
u'قَرِبَ سَقَطٌ':Predicate, #1: 1	أَقْرَبَ سَقَطَ
u'قُرْبٌ سَلاَطِينُ':Added, #1: 1	أَقْرَبَ سَقَطَ
u'قُرْبٌ سُؤْدُدٌ':Added, #1: 1	قُرْبِ السَّلَاطِينِ
u'قُرْبٌ سَيِّدٌ':Added, #1: 1	قُرْبِ سُؤْدُدِ
u'قُرْبٌ شَخْصٌ':Added, #1: 1	قُرْبِ سَيِّدِهِ
u'قُرْبٌ شِفَاءٌ':Added, #1: 1	قُرْبِ الشَّخْصِ
u'قُرْبٌ شَمَّاسٌ':Added, #1: 1	قُرْبُ الشِّفَاءِ
u'قُرْبٌ شَيْطَانٌ':Added, #1: 1	قُرْبَ شَمّاسٍ
u'قُرْبٌ شَيْطَانٌ':Added, #1: 1	قُرْبَ الشَّيْطَانِ
u'قَرُبَ صَاحِبٌ':Subject, #1: 1	قُرْبَ شَيْطَانٍ
u'قَرُبَ صُبْحٌ':Subject, #1: 1	قَرُبَ صَاحِبُهُ
u'قُرْبٌ صُبْحٌ':Added, #1: 1	قَرُبَ الصُّبْحُ
u'قُرْبٌ ضَبْطٌ':Added, #1: 1	قُرْبَ الصُّبْحِ
u'قَرَّ بَطَلٌ':Predicate, #1: 1	قُرْبُ الضَّبْطِ
u'قُرْبٌ طُلُوعٌ':Added, #1: 1	أَقَرَّ بَطَلَ
u'قُرْبٌ طُلُوعٌ':Added, #1: 1	قُرْبَ طُلُوعِ
u'قُرْبٌ ظُهْرٌ':Added, #1: 1	قُرْبِ طُلُوعِ
u'قُرْبٌ عَامِرٌ':Added, #1: 1	قُرْبِ الظُّهْرِ
u'قُرْبٌ عَدُوٌّ':Added, #1: 1	قُرْبِ الْعَامِرِ
u'قَرَّ بَعْضٌ':Subject, #3: 3	قُرْبِ الْعَدُوِّ
u'قُرْبٌ عَقْدٌ':Added, #2: 2	أَقَرَّ بَعْضُ
u'قُرْبٌ علم':Added, #1: 1	قُرْبَ الْعَقْدِ
u'قُرْبٌ عِلْمٌ':Added, #1: 1	قُرْبُ عِلْمٍ
u'قَرُبَ عَهْدٌ':Subject, #1: 1	قُرْبُ عِلْمٍ
u'قَرُبَ عَهْدٌ':Subject, #10: 10	قَرُبَ عَهْدُهُ
u'قَرُبَ عَهْدٌ':Subject, #1: 1	قَرُبَ الْعَهْدُ
u'قُرْبٌ عَهْدٌ':Added, #1: 1	قَرُبَ عَهْدُ
u'قُرْبٌ عَهْدٌ':Added, #1: 1	قُرْبَ عَهْدِ
u'قُرْبٌ عَهْدٌ':Added, #1: 1	قُرْبِ عَهْدِ
u'قُرْبٌ عَهْدٌ':Added, #1: 1	قُرْبِ عَهْدِهِ
u'قُرْبٌ عَوْدٌ':Added, #7: 7	قُرْبِ الْعَهْدِ
u'قُرْبٌ غُرُوبٌ':Added, #1: 1	قُرْبِ عَوْدِ
u'قُرْبٌ غُرُوبٌ':Added, #1: 1	قُرْبَ الْغُرُوبِ
u'قُرْبٌ غُرُوبٌ':Added, #1: 1	قُرْبُ الْغُرُوبِ
u'قُرْبٌ غَيْبَةٌ':Added, #1: 1	قُرْبِ الْغُرُوبِ
u'قَرُبَ فَجْرٌ':Subject, #1: 1	قُرْبَ غَيْبَةِ
u'قُرْبٌ فَجْرٌ':Added, #2: 2	قَرُبَ الْفَجْرُ
u'قُرْبٌ فُرْنٌ':Added, #7: 7	قُرْبَ الْفَجْرِ
u'قَرُبَ فَصْلٌ':Subject, #1: 1	قُرْبَ فُرْنٍ
u'قُرْبٌ فَصْلٌ':Added, #5: 5	قَرُبَ الْفَصْلُ
u'قَرُبَ فِطْرٌ':Subject, #3: 3	قُرْبِ الْفَصْلِ
u'قُرْبٌ فِعْلٌ':Added, #1: 1	قَرُبَ الْفِطْرُ
u'قَرِبَ قَالٌ':Predicate, #2: 2	قُرْبُ الْفِعْلِ
u'قُرْبٌ قَرَابَةٌ':Added, #1: 1	أَقْرَبَ قَالَ
u'قُرْبٌ قَرَابَةٌ':Added, #1: 1	قُرْبِ الْقَرَابَةِ
u'قُرْبٌ قَرَابَةٌ':Added, #2: 2	قُرْبَ الْقَرَابَةِ
u'قَرُبَ مَاءٌ':Subject, #7: 7	قُرْبُ الْقَرَابَةِ
u'قُرْبٌ مَاءٌ':Added, #1: 1	قَرُبَ الْمَاءُ
u'قَرُبَ مَحَلٌّ':Subject, #7: 7	قُرْبِ الْمَاءِ
u'قَرُبَ مُدَّةٌ':Subject, #1: 1	قَرُبَ مَحَلُّ
u'قُرْبٌ مُدَّةٌ':Added, #1: 1	قَرُبَ مُدَّةُ
u'قُرْبٌ مُرَاجَعَةٌ':Added, #1: 1	قُرْبِ الْمُدَّةِ
u'قَرُبَ مُرُورٌ':Subject, #1: 1	قُرْبِ الْمُرَاجَعَةِ
u'قُرْبٌ مَزَارِعُ':Added, #1: 1	قَرُبَ مُرُورُهُ
u'قُرْبٌ مَسَافَةٌ':Added, #1: 1	قُرْبَ الْمَزَارِعِ
u'قُرْبٌ مَسَافَةٌ':Added, #1: 1	قُرْبَ الْمَسَافَةِ
u'قُرْبٌ مَسَافَةٌ':Added, #1: 1	قُرْبَ مَسَافَةٍ
u'قُرْبٌ مَسَافَةٌ':Added, #2: 2	قُرْبُ الْمَسَافَةِ
u'قَرُبَ مُسَافِرٌ':Subject, #8: 8	قُرْبِ الْمَسَافَةِ
u'قُرْبٌ مَسْجِدٌ':Added, #1: 1	قَرُبَ الْمُسَافِرُ
u'قُرْبٌ مَسْجِدٌ':Added, #2: 2	قُرْبَ الْمَسْجِدِ
u'قَرُبَ مَكَانٌ':Subject, #2: 2	قُرْبِ الْمَسْجِدِ
u'قُرْبٌ مَكَانٌ':Added, #4: 4	قَرُبَ مَكَانُهُ
u'قُرْبٌ مَكَانَةٌ':Added, #1: 1	قُرْبِ الْمَكَانِ
u'قُرْبٌ مُنَاسَبَةٌ':Added, #1: 1	قُرْبَ مَكَانَةٍ
u'قُرْبٌ مِنْبَرٌ':Added, #1: 1	قُرْبِ الْمُنَاسَبَةِ
u'قُرْبٌ مَنْزِلٌ':Added, #1: 1	قُرْبُ الْمِنْبَرِ
u'قُرْبٌ مَنْزِلٌ':Added, #1: 1	قُرْبِ الْمَنْزِلِ
u'قُرْبٌ مَنْزِلَةٌ':Added, #2: 2	قُرْبَ الْمَنْزِلِ
u'قَرُبَ مَوْتٌ':Subject, #1: 1	قُرْبُ الْمَنْزِلَةِ
u'قُرْبٌ مَوْتٌ':Added, #3: 3	قَرُبَ مَوْتُهُ
u'قَرَّبَ نَارٌ':Predicate, #1: 1	قُرْبِ الْمَوْتِ
u'قُرْبٌ نَارٌ':Added, #2: 2	قَرَّبَ النَّارَ
u'قُرْبٌ نَاسٌ':Added, #1: 1	قُرْبَ النَّارِ
u'قَرِبَ نَبِيٌّ':Predicate, #1: 1	قُرْبُ النَّاسِ
u'قُرْبٌ نَجَاسَةٌ':Added, #1: 1	أَقْرَبَ النَّبِيِّينَ
u'قُرْبٌ نِساءٌ':Added, #1: 1	قُرْبَ النَّجَاسَةِ
u'قُرْبٌ نَسَبٌ':Added, #1: 1	قُرْبَ النِّسَاءِ
u'قُرْبٌ نصرة':Added, #1: 1	قُرْبُ النَّسَبِ
u'قُرْبٌ نُصْرَةٌ':Added, #3: 3	قُرْبُ النُّصْرَةِ
u'قُرْبٌ نهار':Added, #3: 3	قُرْبُ النُّصْرَةِ
u'قُرْبٌ نَهَارٌ':Added, #1: 1	قُرْبَ النَّهَارِ
u'قَرُبَ واحد':Predicate, #1: 1	قُرْبَ النَّهَارِ
u'قَرِبَ واحد':Predicate, #2: 2	قَرُبَ وَاحِدَةً
u'قَرُبَ وَاحِدٌ':Predicate, #2: 2	قَرِبَ وَاحِدَةً
u'قَرِبَ وَاحِدٌ':Predicate, #2: 2	قَرُبَ وَاحِدَةً
u'قُرْبٌ وُجُوبٌ':Added, #2: 2	قَرِبَ وَاحِدَةً
u'قُرْبٌ وسط':Added, #2: 2	قُرْبِ الْوُجُوبِ
u'قُرْبٌ وَسَطٌ':Added, #1: 1	قُرْبِ وَسَطِ
u'قُرْبٌ وَقْتٌ':Added, #1: 1	قُرْبِ وَسَطِ
u'قُرْبٌ وَقْتٌ':Added, #1: 1	قُرْبِ الْوَقْتِ
u'قَرُبَ وُقُوعٌ':Subject, #1: 1	قُرْبَ وَقْتِ
u'قُرْبٌ وِلاَدَةٌ':Added, #1: 1	قَرُبَ وُقُوعُ
u'قربى رَسُولٌ':Added, #3: 3	قُرْبَ الْوِلَادَةِ
u'قُرْبَى رَسُولٌ':Added, #2: 2	قُرْبَى رَسُولِ
u'قُرْبٌ يسار':Added, #2: 2	قُرْبَى رَسُولِ
u'قُرْبٌ يَسَارٌ':Added, #2: 2	قُرْبِ يَسَارِهِ
u'قَرَّ بَيْعٌ':Predicate, #2: 2	قُرْبِ يَسَارِهِ
u'قَرَّ بَيْنٌ':Predicate, #1: 1	أَقَرَّ بَيْعَ
u'قَرِبَ يَوْمٌ':Predicate, #5: 5	أَقَرَّ بَيْنَ
u'قُرَّةٌ أَعْيُنٌ':Added, #1: 1	قَرِبَ يَوْمَ
u'قُرَّةٌ أَعْيُنٌ':Added, #2: 2	قُرَّةَ أَعْيُنٍ
u'قُرَّةٌ حَيَاءٌ':Added, #5: 5	قُرَّةِ أَعْيُنٍ
u'قُرَّةٌ عين':Added, #1: 1	قُرَّةِ الْحَيَاءِ
u'قُرَّةٌ عَيْنٌ':Added, #1: 1	قُرَّةَ الْعَيْنِ
u'قُرَّةٌ عَيْن':Added, #1: 1	قُرَّةَ الْعَيْنِ
u'قُرَّةٌ عَيْنٌ':Added, #1: 1	قُرَّةَ الْعَيْنِ
u'قُرَّةٌ عَيْن':Added, #1: 1	قُرَّةُ عَيْنٍ
u'قُرَّةٌ عين':Added, #1: 1	قُرَّةُ عَيْنٍ
u'قُرَّةٌ عين':Added, #1: 1	قُرَّةَ عَيْنِهِ
u'قُرَّةٌ عَيْنٌ':Added, #1: 1	قُرَّةِ عَيْنِهِ
u'قُرَّةٌ عَيْنٌ':Added, #1: 1	قُرَّةَ عَيْنِهِ
u'قُرَّةٌ عَيْن':Added, #1: 1	قُرَّةِ عَيْنِهِ
u'قُرَّةٌ عَيْن':Added, #1: 1	قُرَّةَ عَيْنِهِ
u'قُرَّةٌ عَيْنٌ':Added, #1: 1	قُرَّةِ عَيْنِهِ
u'قُرَّةٌ عَيْن':Added, #3: 3	قُرَّةَ عَيْنٍ
u'قُرَّةٌ عين':Added, #3: 3	قُرَّةَ عَيْنٍ
u'قُرَّةٌ عَيْنٌ':Added, #6: 6	قُرَّةِ الْعَيْنِ
u'قُرَّةٌ عَيْن':Added, #6: 6	قُرَّةِ الْعَيْنِ
u'قُرَّةٌ عُيُونٌ':Added, #6: 6	قُرَّةِ الْعَيْنِ
u'قُرَّةٌ مَذْكُورٌ':Added, #1: 1	قُرَّةَ عُيُونِ
u'قَرَّ جَازٌ':Predicate, #1: 1	قُرَّةَ الْمَذْكُورِ
u'قَرَّ حاضِرٌ':Subject, #1: 1	أَقَرَّ جَازَ
u'قَرَّ حاكِمٌ':Subject, #2: 2	أَقَرَّ الْحَاضِرُ
u'قَرَّ حالٌ':Predicate, #1: 1	أَقَرَّ الْحَاكِمُ
u'قَرَّ حالَةٌ':Predicate, #2: 2	أَقَرَّ حَالَ
u'قَرَّ حُرٌّ':Subject, #1: 1	أَقَرَّ حَالَةَ
u'قَرَّ حُرٌّ':Subject, #1: 1	أَقَرَّ حُرٌّ
u'قَرَّ حَكَمٌ':Predicate, #8: 8	أَقَرَّ الْحُرُّ
u'قَرَّ حَلٌّ':Predicate, #2: 2	أَقَرَّ حَكَمَ
u'قَرَّ خَصْمٌ':Subject, #1: 1	أَقَرَّ حَلَّ
u'قَرَّ خَصِيٌّ':Subject, #7: 7	أَقَرَّ الْخَصْمُ
u'قَرَّ خَمْسٌ':Predicate, #2: 2	أَقَرَّ الْخَصِيُّ
u'قَرَّ دَافِعٌ':Subject, #1: 1	أَقَرَّ خَمْسَ
u'قَرَّ ذِمِّيٌّ':Subject, #2: 2	أَقَرَّ الدَّافِعُ
u'قَرَّ ذِمِّيٌّ':Subject, #1: 1	أَقَرَّ ذِمِّيٌّ
u'قَرَّرَ إبَاحَةٌ':Predicate, #2: 2	أَقَرَّ الذِّمِّيُّ
u'قَرَّرَ اِبْنٌ':Subject, #1: 1	قَرَّرَ الْإِبَاحَةَ
u'قَرَّرَ أصل':Predicate, #3: 3	قَرَّرَ ابْنُ
u'قَرَّرَ أًصْلٌ':Predicate, #1: 1	قَرَّرَ الْأَصْلَ
u'قَرَّرَ أهْلٌ':Subject, #1: 1	قَرَّرَ الْأَصْلَ
u'قَرَّ رَاهِنٌ':Subject, #1: 1	قَرَّرَ أَهْلُ
u'قَرَّرَ أئِمَّةٌ':Subject, #11: 11	أَقَرَّ الرَّاهِنُ
u'قَرَّ رَبُّ':Subject, #1: 1	قَرَّرَ الْأَئِمَّةُ
u'قَرَّرَ بَعْضٌ':Subject, #9: 9	أَقَرَّ رَبُّ
u'قَرَّرَ تَرْتِيبٌ':Predicate, #2: 2	قَرَّرَ بَعْضُ
u'قَرَّرَ تَنَزُّلٌ':Predicate, #1: 1	قَرَّرَ تَرْتِيبَ
u'قَرَّ رَجُلٌ':Subject, #1: 1	قَرَّرَ التَّنَزُّلَ
u'قَرَّ رَجُلٌ':Subject, #14: 14	أَقَرَّ رَجُلٌ
u'قَرَّرَ حُكْمٌ':Predicate, #54: 54	أَقَرَّ الرَّجُلُ
u'قَرَّرَ رَسُولٌ':Subject, #1: 1	قَرَّرَ حُكْمَ
u'قَرَّ رَسُولٌ':Subject, #1: 1	قَرَّرَ الرَّسُولُ
u'قَرَّرَ شَارِعٌ':Subject, #2: 2	أَقَرَّ الرَّسُولُ
u'قَرَّرَ شَيْخٌ':Subject, #2: 2	قَرَّرَ الشَّارِعُ
u'قَرَّرَ قَصْرٌ':Predicate, #3: 3	قَرَّرَ الشَّيْخُ
u'قَرَّرَ مُحَقِّقٌ':Subject, #1: 1	قَرَّرَ الْقَصْرَ
u'قَرَّرَ مَذْهَبٌ':Predicate, #1: 1	قَرَّرَ الْمُحَقِّقُ
u'قَرَّرَ مراد':Predicate, #1: 1	قَرَّرَ الْمَذْهَبَ
u'قَرَّرَ مُرَادٌ':Predicate, #2: 2	قَرَّرَ الْمُرَادَ
u'قَرَّرَ مُصَنِّفٌ':Subject, #2: 2	قَرَّرَ الْمُرَادَ
u'قَرَّرَ مَقَالَةٌ':Predicate, #1: 1	قَرَّرَ الْمُصَنِّفُ
u'قَرَّرَ مَقْدِسِيٌّ':Predicate, #1: 1	قَرَّرَ مَقَالَةَ
u'قَرَّرَ مَنْعٌ':Predicate, #1: 1	قَرَّرَ الْمَقْدِسِيَّ
u'قَرَّرَ نَاظِرٌ':Subject, #1: 1	قَرَّرَ مَنْعَ
u'قَرَّرَ نَبِيٌّ':Subject, #3: 3	قَرَّرَ النَّاظِرُ
u'قَرَّرَ نَحْوٌ':Predicate, #1: 1	قَرَّرَ النَّبِيُّ
u'قَرَّرَ وَاقِفٌ':Subject, #1: 1	قَرَّرَ نَحْوَ
u'قَرَّ رَوْضٌ':Predicate, #1: 1	قَرَّرَ الْوَاقِفُ
u'قَرَّ زَارِعٌ':Subject, #1: 1	أَقَرَّ الرَّوْضَ
u'قَرَّ زَوْجٌ':Subject, #1: 1	أَقَرَّ الزَّارِعُ
u'قَرَّ زَيْدٌ':Subject, #37: 37	أَقَرَّ الزَّوْجُ
u'قَرَّ زَيْدٌ':Subject, #1: 1	أَقَرَّ زَيْدُ
u'قَرَّ سَارِقٌ':Subject, #2: 2	أَقَرَّ زَيْدٌ
u'قَرَّ سَاكِنٌ':Subject, #3: 3	أَقَرَّ السَّارِقُ
u'قَرَسَ بَرْدٌ':Subject, #1: 1	أَقَرَّ السَّاكِنُ
u'قَرَّ سَفِيهٌ':Subject, #1: 1	قَرَسَ الْبَرْدُ
u'قَرَّ سَيِّدٌ':Subject, #1: 1	أَقَرَّ السَّفِيهُ
u'قَرَّ شَاهِدٌ':Subject, #8: 8	أَقَرَّ السَّيِّدُ
u'قَرَّ شَخْصٌ':Subject, #1: 1	أَقَرَّ الشَّاهِدُ
u'قَرَّ شِرَاءٌ':Predicate, #2: 2	أَقَرَّ شَخْصٌ
u'قَرَّ شركاء':Subject, #1: 1	أَقَرَّ الشِّرَاءَ
u'قَرَّ شَرِيكٌ':Subject, #1: 1	أَقَرَّ شُرَكَاءُ
u'قَرَّ شَفِيعٌ':Subject, #1: 1	أَقَرَّ شَرِيكُهُ
u'قَرَّ شُهُودٌ':Subject, #1: 1	أَقَرَّ الشَّفِيعُ
u'قَرَّ شَيْءٌ':Subject, #1: 1	أَقَرَّ الشُّهُودُ
u'قَرَّ صَاحِبٌ':Subject, #2: 2	قَرَّ الشَّيْءُ
u'قَرَّ صَانِعٌ':Subject, #6: 6	أَقَرَّ صَاحِبُ
u'قَرَّ صَبِيٌّ':Subject, #1: 1	أَقَرَّ الصَّانِعُ
u'قَرَّ صَحِيحٌ':Subject, #5: 5	أَقَرَّ الصَّبِيُّ
u'قَرَّ صلح':Subject, #1: 1	أَقَرَّ الصَّحِيحُ
u'قَرَّ صُلْحٌ':Subject, #1: 1	أَقَرَّ الصُّلْحُ
u'قَرْضٌ آدَمِيٌّ':Added, #1: 1	أَقَرَّ الصُّلْحُ
u'قَرَّ ضَارِبٌ':Subject, #2: 2	قَرْضُ آدَمِيٍّ
u'قَرْضٌ ألف':Added, #1: 1	أَقَرَّ الضَّارِبُ
u'قَرْضٌ ألف':Added, #1: 1	قَرْضَ أَلْفِ
u'قَرْضٌ ألْفٌ':Added, #1: 1	قَرْضِ أَلْفِ
u'قَرْضٌ ألْفٌ':Added, #1: 1	قَرْضَ أَلْفِ
u'قَرْضٌ أَلْفٌ':Added, #1: 1	قَرْضِ أَلْفِ
u'قَرْضٌ أَلْفٌ':Added, #1: 1	قَرْضَ أَلْفِ
u'قَرْضٌ أمَةٌ':Added, #1: 1	قَرْضِ أَلْفِ
u'قَرِضَ بَذْرٌ':Predicate, #2: 2	قَرْضُ الْأَمَةِ
u'قَرَضَ بَيْتٌ':Predicate, #1: 1	أَقْرَضَ الْبَذْرَ
u'قَرْضٌ ثَمَنٌ':Added, #2: 2	قَرَضَ بَيْتَ
u'قَرْضٌ ثَمَنٌ':Added, #1: 1	قَرْضُ الثَّمَنِ
u'قَرَضَ ثَوْبٌ':Predicate, #1: 1	قَرْضِ الثَّمَنِ
u'قَرْضٌ جَارِي':Added, #1: 1	قَرَضَ الثَّوْبَ
u'قَرْضٌ جَارِيَةٌ':Added, #1: 1	قَرْضِ الْجَارِيَةِ
u'قَرْضٌ جَديدٌ':Added, #1: 1	قَرْضِ الْجَارِيَةِ
u'قَرْضٌ جِهَةٌ':Added, #2: 2	قَرْضٍ جَدِيدٍ
u'قَرْضٌ جَوَاهِرُ':Added, #1: 1	قَرْضُ جِهَةٍ
u'قَرْضٌ حِنْطَةٌ':Added, #2: 2	قَرْضُ الْجَوَاهِرِ
u'قَرْضٌ حَيَوَانٌ':Added, #1: 1	قَرْضِ الْحِنْطَةِ
u'قَرْضٌ حَيَوَانٌ':Added, #1: 1	قَرْضُ الْحَيَوَانِ
u'قَرْضٌ حَيَوَانٌ':Added, #1: 1	قَرْضِ الْحَيَوَانِ
u'قَرْضٌ خُبْزٌ':Added, #2: 2	قَرْضُ حَيَوَانٍ
u'قَرْضٌ خَمْسَةٌ':Added, #2: 2	قَرْضِ الْخُبْزِ
u'قَرْضٌ دَارٌ':Added, #2: 2	قَرْضَ الْخَمْسَةِ
u'قَرِضَ دَرَاهِمُ':Predicate, #1: 1	قَرْضِ دَارٍ
u'قَرِضَ دَرَاهِمُ':Predicate, #1: 1	أَقْرَضَ دَرَاهِمَ
u'قَرْضٌ دَرَاهِمُ':Added, #2: 2	أَقْرَضَ الدَّرَاهِمَ
u'قَرْضٌ دِرْهَمٌ':Added, #1: 1	قَرْضَ الدَّرَاهِمِ
u'قَرْضٌ دِرْهَم':Added, #1: 1	قَرْضَ دِرْهَمَيْنِ
u'قَرْضٌ دَيْنٌ':Added, #1: 1	قَرْضَ دِرْهَمَيْنِ
u'قَرِضَ رَجُلٌ':Predicate, #1: 1	قَرْضِ دَيْنٍ
u'قَرْضٌ رَقيقٌ':Added, #1: 1	أَقْرَضَ رَجُلاً
u'قَرْضٌ رَقيق':Added, #1: 1	قَرْضُ الرَّقِيقِ
u'قَرْضٌ شَرِيكٌ':Added, #1: 1	قَرْضُ الرَّقِيقِ
u'قَرْضٌ شَيْءٌ':Added, #2: 2	قَرْضِ الشَّرِيكِ
u'قَرْضٌ طعام':Added, #1: 1	قَرْضُ الشَّيْءِ
u'قَرْضٌ طَعَامٌ':Added, #1: 1	قَرْضُ طَعَامٍ
u'قَرِضَ عَبْدٌ':Predicate, #1: 1	قَرْضُ طَعَامٍ
u'قَرْضٌ عِرْضٌ':Added, #1: 1	أَقْرَضَ الْعَبْدَ
u'قَرْضٌ عَقَارٌ':Added, #1: 1	قَرْضِ عِرْضِهِ
u'قَرْضٌ عين':Added, #1: 1	قَرْضَ الْعَقَارِ
u'قَرْضٌ عَيْنٌ':Added, #1: 1	قَرْضِ الْعَيْنِ
u'قَرْضٌ عَيْن':Added, #1: 1	قَرْضِ الْعَيْنِ
u'قَرْضٌ غَرِيمٌ':Added, #1: 1	قَرْضِ الْعَيْنِ
u'قَرْضٌ فَأْرٌ':Added, #2: 2	قَرْضِ غَرِيمِهِ
u'قَرْضٌ فَأْرٌ':Added, #1: 1	قَرْضِ الْفَأْرِ
u'قَرْضٌ فَأْرٌ':Added, #2: 2	قَرْضِ فَأْرٍ
u'قَرْضٌ فَاسِدٌ':Added, #6: 6	قَرْضُ فَأْرٍ
u'قَرْضٌ كَعْكٌ':Added, #1: 1	قَرْضٍ فَاسِدٍ
u'قَرْضٌ لبن':Added, #1: 1	قَرْضُ كَعْكٍ
u'قَرْضٌ لَبِنٌ':Added, #1: 1	قَرْضُ اللَّبِنِ
u'قَرِضَ مَاءٌ':Predicate, #1: 1	قَرْضُ اللَّبِنِ
u'قَرْضٌ مَاءٌ':Added, #1: 1	أَقْرَضَ الْمَاءَ
u'قَرْضٌ مَاءٌ':Added, #1: 1	قَرْضِ الْمَاءِ
u'قَرِضَ مَالٌ':Predicate, #2: 2	قَرْضُ الْمَاءِ
u'قَرْضٌ مَالٌ':Added, #5: 5	أَقْرَضَ مَالَ
u'قَرْضٌ مَالٌ':Added, #1: 1	قَرْضُ مَالِ
u'قَرْضٌ مرٌّ':Added, #1: 1	قَرْض مَالِهِ
u'قَرْضٌ مُشاعٌ':Added, #1: 1	قَرْضُ مَرَّتَيْنِ
u'قَرْضٌ مُصْرَانٌ':Added, #3: 3	قَرْضُ الْمُشَاعِ
u'قَرْضٌ مَمْلُوكٌ':Added, #1: 1	قَرْضُ الْمُصْرَانِ
u'قَرْضٌ مَنَافِعُ':Added, #1: 1	قَرْضُ مَمْلُوكٍ
u'قَرْضٌ مُؤَجَّلٌ':Added, #4: 4	قَرْضُ الْمَنَافِعِ
u'قَرْضٌ نَابٌ':Added, #2: 2	قَرْضٍ مُؤَجَّلٍ
u'قَرِضَ وَدِيعٌ':Predicate, #1: 1	قَرْضَ نَابٍ
u'قَرِضَ وَدِيعَةٌ':Predicate, #1: 1	أَقْرَضَ الْوَدِيعَةَ
u'قَرَّ طَالِبٌ':Subject, #1: 1	أَقْرَضَ الْوَدِيعَةَ
u'قَرَّ ظالِمٌ':Subject, #9: 9	أَقَرَّ الطَّالِبُ
u'قَرَعَ أسْوَد':Predicate, #1: 1	أَقَرَّ الظَّالِمُ
u'قَرِعَ أسْوَد':Predicate, #1: 1	أَقْرَعَ أَسْوَدَ
u'قَرَّ عَامِلٌ':Subject, #1: 1	أَقْرَعَ أَسْوَدَ
u'قَرَّ عَامِلٌ':Subject, #1: 1	أَقَرَّ الْعَامِلُ
u'قَرَعَ بَابٌ':Predicate, #1: 1	أَقَرَّ عَامِلُ
u'قَرَّ عَبْدٌ':Subject, #1: 1	قَرَعَ الْبَابَ
u'قَرَّ عَبْدٌ':Subject, #2: 2	أَقَرَّ عَبْدُ
u'قَرَّ عَبْدٌ':Subject, #73: 73	أَقَرَّ الْعَبْدُ
u'قَرَعَ بَيْنٌ':Predicate, #7: 7	أَقَرَّ عَبْدٌ
u'قَرِعَ بَيْنٌ':Predicate, #22: 22	أَقْرَعَ بَيْنَ
u'قَرَعَ بَيْنٌ':Predicate, #22: 22	أَقْرَعَ بَيْنَ
u'قَرِعَ بَيْنٌ':Predicate, #4: 4	أَقْرَعَ بَيْنَهُنَّ
u'قَرَعَ حَديثٌ':Predicate, #4: 4	أَقْرَعَ بَيْنَهُنَّ
u'قَرِعَ حَديثٌ':Predicate, #1: 1	أَقْرَعَ الْحَدِيثَ
u'قَرَّ عَدْلٌ':Subject, #1: 1	أَقْرَعَ الْحَدِيثَ
u'قَرَعَ غير':Subject, #3: 3	أَقَرَّ الْعَدْلُ
u'قَرَعَ غَيْرٌ':Subject, #1: 1	قَرَعَ غَيْرُهُ
u'قَرَعَ قَالٌ':Predicate, #1: 1	قَرَعَ غَيْرُهُ
u'قَرِعَ قَالٌ':Predicate, #1: 1	أَقْرَعَ قَالَ
u'قَرَعَ مرٌّ':Predicate, #1: 1	أَقْرَعَ قَالَ
u'قَرِعَ مرٌّ':Predicate, #1: 1	أَقْرَعَ مَرَّةً
u'قَرَّ عُمَرٌ':Subject, #1: 1	أَقْرَعَ مَرَّةً
u'قَرَّ عند':Predicate, #1: 1	أَقَرَّ عُمَرُ
u'قَرَّ غَاصِبٌ':Subject, #28: 28	أَقَرَّ عِنْدَ
u'قَرَّ غَائِبٌ':Subject, #6: 6	أَقَرَّ الْغَاصِبُ
u'قَرَّ غرماء':Subject, #1: 1	أَقَرَّ الْغَائِبُ
u'قَرَّ غرماء':Subject, #1: 1	أَقَرَّ الْغُرَمَاءُ
u'قَرَّ غَرِيمٌ':Subject, #1: 1	أَقَرَّ غُرَمَاءُ
u'قَرَّ غير':Subject, #16: 16	أَقَرَّ الْغَرِيمُ
u'قَرَّ غَيْرٌ':Subject, #2: 2	أَقَرَّ غَيْرُ
u'قَرَّ فُلاَنٌ':Subject, #2: 2	أَقَرَّ غَيْرُ
u'قَرَّ فُلاَنٌ':Subject, #17: 17	أَقَرَّ فُلَانُ
u'قَرَّ قَابِضٌ':Subject, #54: 54	أَقَرَّ فُلَانٌ
u'قَرَّ قَاتِلٌ':Subject, #1: 1	أَقَرَّ الْقَابِضُ
u'قَرَّ قَاطِعٌ':Subject, #3: 3	أَقَرَّ الْقَاتِلُ
u'قَرَّ قَالٌ':Predicate, #5: 5	أَقَرَّ الْقَاطِعُ
u'قَرَّ قَائِلٌ':Subject, #1: 1	أَقَرَّ قَالَ
u'قَرَّ قَائِمٌ':Subject, #1: 1	أَقَرَّ الْقَائِلُ
u'قَرَّ قَسام':Predicate, #1: 1	أَقَرَّ قَائِمٌ
u'قَرَّ قَسامَة':Predicate, #3: 3	أَقَرَّ الْقَسَامَةَ
u'قَرَّ قَوْمٌ':Subject, #3: 3	أَقَرَّ الْقَسَامَةَ
u'قَرَّ قَوْمٌ':Subject, #1: 1	أَقَرَّ الْقَوْمُ
u'قَرَّ كُفَّارٌ':Subject, #1: 1	أَقَرَّ قَوْمٌ
u'قَرَّ كَفِيلٌ':Subject, #1: 1	أَقَرَّ الْكُفَّارُ
u'قَرَّ لَقِيطٌ':Subject, #4: 4	أَقَرَّ الْكَفِيلُ
u'قَرَّ مَاعِزٌ':Subject, #2: 2	أَقَرَّ اللَّقِيطُ
u'قَرَّ مَالٌ':Predicate, #1: 1	أَقَرَّ مَاعِزٌ
u'قَرَّ مَأْمُورٌ':Predicate, #2: 2	أَقَرَّ الْمَالَ
u'قَرَّ مُتَطَوِّعٌ':Predicate, #1: 1	أَقَرَّ الْمَأْمُورَ
u'قَرَّ مَجْنِيٌّ':Subject, #1: 1	أَقَرَّ الْمُتَطَوِّعَ
u'قَرَّ مَجْهُولٌ':Subject, #2: 2	أَقَرَّ الْمَجْنِيُّ
u'قَرَّ مَحْبُوسٌ':Subject, #1: 1	أَقَرَّ مَجْهُولٌ
u'قَرَّ مَحْجُورٌ':Subject, #2: 2	أَقَرَّ الْمَحْبُوسُ
u'قَرَّ مُحِيل':Subject, #2: 2	أَقَرَّ الْمَحْجُورُ
u'قَرَّ مُدَبَّرٌ':Subject, #1: 1	أَقَرَّ الْمُحِيلُ
u'قَرَّ مَدْيُونٌ':Subject, #3: 3	أَقَرَّ الْمُدَبَّرُ
u'قَرَّ مرٌّ':Predicate, #2: 2	أَقَرَّ الْمَدْيُونُ
u'قَرَّ مُرَاهِقٌ':Subject, #3: 3	أَقَرَّ مَرَّةً
u'قَرَّ مُرْتَهِنٌ':Subject, #1: 1	أَقَرَّ مُرَاهِقٌ
u'قَرَّ مُرْسِلٌ':Subject, #11: 11	أَقَرَّ الْمُرْتَهِنُ
u'قَرَّ مَرِيضٌ':Subject, #1: 1	أَقَرَّ الْمُرْسِلُ
u'قَرَّ مُسْتَحِقٌّ':Subject, #37: 37	أَقَرَّ الْمَرِيضُ
u'قَرَّ مُسْتَعِيرٌ':Subject, #2: 2	أَقَرَّ الْمُسْتَحِقُّ
u'قَرَّ مُسْتَوْدَعٌ':Subject, #2: 2	أَقَرَّ الْمُسْتَعِيرُ
u'قَرَّ مُسْلِمٌ':Subject, #1: 1	أَقَرَّ الْمُسْتَوْدَعُ
u'قَرَّ مُسْلِمٌ':Subject, #1: 1	أَقَرَّ الْمُسْلِمُ
u'قَرَّ مَشْهُودٌ':Subject, #1: 1	أَقَرَّ مُسْلِمٌ
u'قَرَّ مُضَارِبٌ':Subject, #1: 1	أَقَرَّ الْمَشْهُودُ
u'قَرَّ مُطْلَقٌ':Predicate, #7: 7	أَقَرَّ الْمُضَارِبُ
u'قَرَّ مَطْلُوبٌ':Subject, #1: 1	أَقَرَّ مُطْلَقَ
u'قَرَّ مَعْزُولٌ':Subject, #10: 10	أَقَرَّ الْمَطْلُوبُ
u'قَرَّ مُفْلِسٌ':Subject, #1: 1	أَقَرَّ الْمَعْزُولُ
u'قَرَّ مَقْضِيّ':Subject, #2: 2	أَقَرَّ مُفْلِسٌ
u'قَرَّ مَكْفُولٌ':Subject, #2: 2	أَقَرَّ الْمَقْضِيُّ
u'قَرَّ مُلْتَقِط':Subject, #2: 2	أَقَرَّ الْمَكْفُولُ
u'قَرَّ مَنْصُوبٌ':Subject, #3: 3	أَقَرَّ الْمُلْتَقِطُ
u'قَرَّ مُنْكَرٌ':Predicate, #2: 2	أَقَرَّ مَنْصُوبُ
u'قَرَّ مُنْكِرٌ':Subject, #1: 1	قَرَّ الْمُنْكَرَ
u'قَرَّ مُؤَجِّرٌ':Subject, #1: 1	أَقَرَّ الْمُنْكِرُ
u'قَرَّ مُودَعٌ':Subject, #1: 1	أَقَرَّ الْمُؤَجِّرُ
u'قَرَّ مَوْقُوفٌ':Subject, #3: 3	أَقَرَّ الْمُودَعُ
u'قَرَّ مُوَكِّلٌ':Subject, #1: 1	أَقَرَّ الْمَوْقُوفُ
u'قَرَنَ أَرْبَعَةٌ':Predicate, #3: 3	أَقَرَّ الْمُوَكِّلُ
u'قَرَنَ إِسَاءةٌ':Predicate, #1: 1	قَرَنَ أَرْبَعَةَ
u'قَرَنَ اِسْمٌ':Predicate, #1: 1	قَرَنَ الْإِسَاءَةَ
u'قَرَنَ أَطْرافٌ':Predicate, #1: 1	قَرَنَ اسْمَ
u'قَرَنَ أَطْرَافٌ':Predicate, #1: 1	قَرَنَ أَطْرَافَ
u'قَرَّ نَاطِقٌ':Subject, #1: 1	قَرَنَ أَطْرَافَ
u'قَرَّ نَاظِرٌ':Subject, #1: 1	أَقَرَّ النَّاطِقُ
u'قَرْنٌ اِمْرَأَةٌ':Added, #1: 1	أَقَرَّ نَاظِرُ
u'قَرَنَ إيقَاعٌ':Predicate, #1: 1	قَرْنِ امْرَأَةٍ
u'قَرْنٌ بَقَرٌ':Added, #2: 2	قَرَنَ الْإِيقَاعَ
u'قَرْنٌ بَقَرٌ':Added, #1: 1	قَرْنِ الْبَقَرِ
u'قَرْنٌ بَهائِمُ':Added, #3: 3	قَرْنِ الْبَقَرَةِ
u'قَرَنَ بَيَانٌ':Predicate, #1: 1	قَرْنِ الْبَهَائِمِ
u'قَرَنَ بَيْنٌ':Predicate, #1: 1	قَرَنَ بَيَانَ
u'قَرْنٌ ثَعَالِبُ':Added, #6: 6	قَرَنَ بَيْنَ
u'قَرْنٌ ثَوْرٌ':Added, #1: 1	قَرْنُ الثَّعَالِبِ
u'قَرَنَ جَازٌ':Predicate, #2: 2	قَرْنِ ثَوْرٍ
u'قَرْنٌ جَبَلٌ':Added, #1: 1	قَرَنَ جَازَ
u'قَرَنَ حَجٌّ':Predicate, #1: 1	قَرْنِ الْجَبَلِ
u'قَرَنَ حَديثٌ':Predicate, #1: 1	قَرَنَ الْحَجَّ
u'قَرْنٌ حَيَوَانٌ':Added, #1: 1	قَرَنَ الْحَدِيثَ
u'قَرَنَ خَشْيَةٌ':Predicate, #1: 1	قَرْنِ الْحَيَوَانِ
u'قَرَنَ ذكر':Predicate, #1: 1	قَرَنَ خَشْيَةَ
u'قَرَنَ ذِكْرٌ':Predicate, #1: 1	قَرَنَ الذِّكْرَ
u'قَرَنَ ذكر':Predicate, #1: 1	قَرَنَ الذِّكْرَ
u'قَرَنَ ذِكْرٌ':Predicate, #1: 1	قَرَنَ ذِكْرَ
u'قَرَنَ رَسُولٌ':Subject, #1: 1	قَرَنَ ذِكْرَ
u'قَرَنَ رَفْعٌ':Predicate, #1: 1	قَرَنَ رَسُولُ
u'قَرَنَ رُكْنٌ':Predicate, #1: 1	قَرَنَ الرَّفْعَ
u'قَرَنَ رُكْن':Predicate, #3: 3	قَرَنَ الرُّكْنَ
u'قَرَنَ زَكاةٌ':Predicate, #3: 3	قَرَنَ الرُّكْنَ
u'قَرَّ نَسَبٌ':Predicate, #1: 1	قَرَنَ الزَّكَاةَ
u'قَرْنٌ شَاةٌ':Added, #1: 1	أَقَرَّ النَّسَبَ
u'قَرْنٌ شَاةٌ':Added, #1: 1	قَرْنُ الشَّاةِ
u'قَرَنَ شَارِعٌ':Subject, #1: 1	قَرْنُ شَاةٍ
u'قَرْنٌ شَعَرٌ':Added, #1: 1	قَرَنَ الشَّارِعُ
u'قَرْنٌ شمس':Added, #1: 1	قَرْنِ الشَّعَرِ
u'قَرْنٌ شَمْسٌ':Added, #6: 6	قَرْنُ الشَّمْسِ
u'قَرَنَ شَهْرٌ':Predicate, #6: 6	قَرْنُ الشَّمْسِ
u'قَرَنَ شَيْءٌ':Predicate, #1: 1	قَرَنَ الشَّهْرَ
u'قَرْنٌ شَيْطَانٌ':Added, #1: 1	قَرَنَ الشَّيْءَ
u'قَرْنٌ شَيْطَانٌ':Added, #1: 1	قَرْنَ الشَّيْطَانِ
u'قَرْنٌ شَيْطَانٌ':Added, #3: 3	قَرْنُ الشّيْطَانِ
u'قَرَّ نَصٌّ':Predicate, #8: 8	قَرْنُ الشَّيْطَانِ
u'قَرْنٌ صَحَابَةٌ':Added, #3: 3	أَقَرَّ النَّصَّ
u'قَرْنٌ صَحَابَةٌ':Added, #1: 1	قَرْنَ الصَّحَابَةِ
u'قَرَنَ صَلاَةٌ':Predicate, #4: 4	قَرْنِ الصَّحَابَةِ
u'قَرَّ نُصُوصٌ':Predicate, #1: 1	قَرَنَ صَلَاةَ
u'قَرَنَ طَلاَقٌ':Predicate, #1: 1	أَقَرَّ النُّصُوصَ
u'قَرْنٌ ظَهْرٌ':Added, #1: 1	قَرَنَ الطَّلَاقَ
u'قَرْنٌ ظُهْرٌ':Added, #2: 2	قَرْنَ الظّهْرِ
u'قَرَنَ عمرة':Predicate, #2: 2	قَرْنَ الظّهْرِ
u'قَرَنَ عُمْرَةٌ':Predicate, #1: 1	قَرَنَ الْعُمْرَةَ
u'قَرَّ نَفْعٌ':Predicate, #1: 1	قَرَنَ الْعُمْرَةَ
u'قَرَنَ فِعْلٌ':Predicate, #1: 1	أَقَرَّ نَفْعَ
u'قَرَنَ فلان':Subject, #1: 1	قَرَنَ الْفِعْلَ
u'قَرَنَ فلان':Subject, #1: 1	قَرَنَ الزّبَيْرُ
u'قَرَنَ قَالٌ':Predicate, #1: 1	قَرَنَ الْمَكِّيُّ
u'قَرْنٌ كَبْشٌ':Added, #1: 1	قَرَنَ قَالَ
u'قَرَنَ كِتَابَةٌ':Predicate, #1: 1	قَرْنَ الْكَبْشِ
u'قَرَنَ كَلاَمٌ':Predicate, #1: 1	قَرَنَ الْكِتَابَةَ
u'قَرَنَ مَالٌ':Predicate, #1: 1	قَرَنَ الْكَلَامَ
u'قَرَنَ مُرَاجَعَةٌ':Predicate, #1: 1	قَرَنَ الْمَالَ
u'قَرَنَ مُسْتَعْمَلٌ':Predicate, #1: 1	قَرَنَ الْمُرَاجَعَةَ
u'قَرَنَ مُصَنِّفٌ':Subject, #1: 1	قَرَنَ الْمُسْتَعْمَلَ
u'قَرَنَ مَكِّيّ':Subject, #1: 1	قَرَنَ الْمُصَنِّفُ
u'قَرْنٌ مَنَازِلُ':Added, #1: 1	قَرَنَ الْمَكِّيُّ
u'قَرْنٌ مَنَازِلُ':Added, #4: 4	قَرْنُ الْمَنَازِلِ
u'قَرَنَ نَهْيٌ':Predicate, #5: 5	قَرْنَ الْمَنَازِلِ
u'قَرْنٌ نِيَّةٌ':Added, #1: 1	قَرَنَ النَّهْيَ
u'قَرْنٌ نِيَّةٌ':Added, #1: 1	قَرْنُ النِّيَّةِ
u'قَرْنٌ هَدْيٌ':Added, #1: 1	قَرْنِ النِّيَّةِ
u'قَرْنٌ وَاجِبٌ':Added, #1: 1	قَرْنِ الْهَدْيِ
u'قَرَنَ وَصْفٌ':Predicate, #1: 1	قَرْنُ الْوَاجِبِ
u'قَرَّ نَوَوِيٌّ':Subject, #4: 4	قَرَنَ الْوَصْفَ
u'قَرْنٌ يهود':Added, #1: 1	أَقَرَّ النَّوَوِيُّ
u'قَرْنٌ يَهُودٌ':Added, #3: 3	قَرْنِ الْيَهُودِ
u'قَرَنَ يَوْمٌ':Predicate, #3: 3	قَرْنِ الْيَهُودِ
u'قَرَّ واحد':Subject, #1: 1	قَرَنَ الْيَوْمَ
u'قَرَّ وَاحِدٌ':Subject, #4: 4	أَقَرَّ وَاحِدٌ
u'قَرَّ وَارِثٌ':Subject, #4: 4	أَقَرَّ وَاحِدٌ
u'قَرَّ وَاقِفٌ':Subject, #16: 16	أَقَرَّ الْوَارِثُ
u'قَرَّ وَالِدٌ':Subject, #1: 1	أَقَرَّ الْوَاقِفُ
u'قُرُوحٌ أَمْعاءٌ':Added, #1: 1	أَقَرَّ الْوَالِدُ
u'قُرُوحٌ أَمْعَاءٌ':Added, #2: 2	قُرُوحِ الْأَمْعَاءِ
u'قُرُوحٌ حَلْقٌ':Added, #2: 2	قُرُوحِ الْأَمْعَاءِ
u'قُرُوحٌ عين':Added, #1: 1	قُرُوحِ الْحَلْقِ
u'قُرُوحٌ عين':Added, #1: 1	قُرُوحَ الْعَيْنِ
u'قُرُوحٌ عَيْنٌ':Added, #1: 1	قُرُوحِ الْعَيْنِ
u'قُرُوحٌ عَيْنٌ':Added, #1: 1	قُرُوحَ الْعَيْنِ
u'قُرُوحٌ عَيْن':Added, #1: 1	قُرُوحِ الْعَيْنِ
u'قُرُوحٌ عَيْن':Added, #1: 1	قُرُوحَ الْعَيْنِ
u'قُرُوحٌ فَمٌ':Added, #1: 1	قُرُوحِ الْعَيْنِ
u'قَرَّ وَرَثَةٌ':Subject, #1: 1	قُرُوحِ الْفَمِ
u'قَرَّ وَرَثَةٌ':Subject, #1: 1	أَقَرَّ وَرَثَةٌ
u'قَرَّ وَصِيٌّ':Subject, #6: 6	أَقَرَّ الْوَرَثَةُ
u'قَرَّ وَصِيٌّ':Subject, #30: 30	أَقَرَّ الْوَصِيُّ
u'قَرَّ وَقْتٌ':Predicate, #4: 4	أَقَرَّ وَصِيُّ
u'قَرَّ وَكِيلٌ':Subject, #1: 1	أَقَرَّ وَقْتَ
u'قَرَّ وَكِيلٌ':Subject, #1: 1	أَقَرَّ وَكِيلُ
u'قَرَّ ولد':Subject, #26: 26	أَقَرَّ الْوَكِيلُ
u'قَرَّ وَلَدٌ':Subject, #2: 2	أَقَرَّ الْوَلَدُ
u'قَرَّ وَلِيٌّ':Subject, #2: 2	أَقَرَّ الْوَلَدُ
u'قَرَّ وَلِيٌّ':Subject, #2: 2	أَقَرَّ الْوَلِيُّ
u'قُرُونٌ اِمْرَأَةٌ':Added, #2: 2	أَقَرَّ وَلِيُّ
u'قُرُونٌ ثِيرانٌ':Added, #1: 1	قُرُونَ امْرَأَةٍ
u'قُرُونٌ نِساءٌ':Added, #1: 1	قُرُونُ الثّيرَانِ
u'قُرُونٌ وُعُولٌ':Added, #3: 3	قُرُونِ النِّسَاءِ
u'قَرِيرٌ عين':Added, #1: 1	قُرُونِ الْوُعُولِ
u'قَرِيرٌ عَيْنٌ':Added, #1: 1	قَرِيرُ الْعَيْنِ
u'قَرِيرٌ عَيْن':Added, #1: 1	قَرِيرُ الْعَيْنِ
u'قَرِيرٌ عَيْنٌ':Added, #1: 1	قَرِيرُ الْعَيْنِ
u'قَرِيرٌ عَيْن':Added, #4: 4	قَرِيرَ عَيْنٍ
u'قَرَّ يَهُودِيٌّ':Subject, #4: 4	قَرِيرَ عَيْنٍ
u'قَرَّ يَوْمٌ':Predicate, #1: 1	أَقَرَّ يَهُودِيٌّ
u'قَرَّ يَوْمٌ':Predicate, #1: 1	أَقَرَّ الْيَوْمَ
u'قَسَا قلب':Subject, #1: 1	أَقَرَّ يَوْمَ
u'قَسَا قَلْبٌ':Subject, #3: 3	قَسَا قَلْبُهُ
u'قَسَا قَلْب':Subject, #3: 3	قَسَا قَلْبُهُ
u'قَسَطَ بَعيرٌ':Subject, #3: 3	قَسَا قَلْبُهُ
u'قَسَّطَ خراج':Predicate, #1: 1	قَسَطَ الْبَعِيرُ
u'قَسَّطَ خَرَاجٌ':Predicate, #1: 1	قَسَّطَ الْخَرَاجَ
u'قَسَّطَ طعام':Predicate, #1: 1	قَسَّطَ الْخَرَاجَ
u'قَسَّطَ طَعَامٌ':Predicate, #1: 1	قَسَّطَ الطَّعَامَ
u'قَسْمٌ أَبٌ':Added, #1: 1	قَسَّطَ الطَّعَامَ
u'قَسَمَ آبارٌ':Predicate, #1: 1	قَسْمُ الْأَبِ
u'قَسْمٌ إِبِلٌ':Added, #1: 1	قَسَمَ الْآبَارَ
u'قَسَّمَ اِبْنٌ':Subject, #1: 1	قَسْمِ الإِبِلِ
u'قَسْمٌ إِجْبَارٌ':Added, #2: 2	قَسَّمَ ابْنُ
u'قَسَّمَ أَجْرٌ':Predicate, #1: 1	قَسْمِ الْإِجْبَارِ
u'قَسَّمَ أَحْوالٌ':Predicate, #1: 1	قَسَّمَ الْأَجْرَ
u'قَسَّمَ أحْوَالٌ':Predicate, #1: 1	قَسَّمَ الْأَحْوَالَ
u'قَسَّمَ أرْبَابٌ':Subject, #1: 1	قَسَّمَ الْأَحْوَالَ
u'قَسْمٌ إِرْثٌ':Added, #1: 1	قَسَّمَ أَرْبَابُ
u'قَسَمَ أرْضٌ':Predicate, #1: 1	قَسْمُ الْإِرْثِ
u'قَسَّمَ أرْضٌ':Predicate, #1: 1	قَسَمَ الْأَرْضَ
u'قَسْمٌ أرْضٌ':Added, #1: 1	قَسَّمَ الْأَرْضَ
u'قَسْمٌ أرْضٌ':Added, #1: 1	قَسْمِ أَرْضِ
u'قَسْمٌ أرْضٌ':Added, #1: 1	قَسْمَ الْأَرْضِ
u'قَسْمٌ إِسْلامٌ':Added, #1: 1	قَسْمِ الْأَرْضِ
u'قَسْمٌ إِسْلامٌ':Added, #1: 1	قَسْمِ الإِسْلاَمِ
u'قَسَّمَ أَصْحَابٌ':Subject, #2: 2	قَسْمِ الْإِسْلَامِ
u'قَسَّمَ أَعْمَالٌ':Predicate, #2: 2	قَسَّمَ الْأَصْحَابُ
u'قَسْمٌ أعْيانٌ':Added, #1: 1	قَسَّمَ الْأَعْمَالَ
u'قَسْمٌ أَعْيَانٌ':Added, #1: 1	قَسْمِ الْأَعْيَانِ
u'قَسَّمَ ألف':Predicate, #1: 1	قَسْمِ الْأَعْيَانِ
u'قَسَّمَ ألْفٌ':Predicate, #1: 1	قَسَّمَ الْأَلْفَ
u'قَسَّمَ أَلْفٌ':Predicate, #1: 1	قَسَّمَ الْأَلْفَ
u'قَسَمَ ألف':Predicate, #1: 1	قَسَّمَ الْأَلْفَ
u'قَسَمَ ألْفٌ':Predicate, #3: 3	قَسَمَ الْأَلْفَ
u'قَسَمَ أَلْفٌ':Predicate, #3: 3	قَسَمَ الْأَلْفَ
u'قَسْمٌ الْمَرْأَةُ':Added, #3: 3	قَسَمَ الْأَلْفَ
u'قَسْمٌ إمَاءٌ':Added, #1: 1	قَسْمُ الْمَرْأَةِ
u'قَسَمَ إمَامٌ':Subject, #1: 1	قَسْمَ الْإِمَاءِ
u'قَسَّمَ إمَامٌ':Subject, #5: 5	قَسَمَ الْإِمَامُ
u'قَسْمٌ أَمْوَالٌ':Added, #7: 7	قَسَّمَ الْإِمَامُ
u'قَسْمٌ أَمْوَالٌ':Added, #1: 1	قَسْمَ الأَمْوَالِ
u'قَسْمٌ أَميرٌ':Added, #1: 1	قَسْمِ الأَمْوَالِ
u'قَسَّمَ أهْلٌ':Subject, #1: 1	قَسْمِ أَمِيرِ
u'قَسَّمَ باقِي':Predicate, #2: 2	قَسَّمَ أَهْلُ
u'قَسَّمَ بَشَرٌ':Predicate, #1: 1	قَسَّمَ الْبَاقِيَ
u'قَسْمٌ بَعْلٌ':Added, #1: 1	قَسَّمَ الْبَشَرَ
u'قَسْمٌ بَقْلٌ':Added, #1: 1	قَسْمَ الْبَعْلِ
u'قَسْمٌ بَلَحٌ':Added, #1: 1	قَسْمُ الْبَقْلِ
u'قَسَمَ بِئْرٌ':Predicate, #1: 1	قَسْمُ الْبَلَحِ
u'قَسَّمَ بَيْنٌ':Predicate, #1: 1	قَسَمَ الْبِئْرَ
u'قَسَمَ بَيْنٌ':Predicate, #3: 3	قَسَّمَ بَيْنَ
u'قَسَمَ بَيْنٌ':Predicate, #3: 3	قَسَمَ بَيْنَهُنَّ
u'قَسَّمَ تَرِكَةٌ':Predicate, #5: 5	قَسَمَ بَيْنَ
u'قَسْمٌ تَرِكَة':Added, #4: 4	قَسَّمَ التَّرِكَةَ
u'قَسْمٌ تَرِكَةٌ':Added, #1: 1	قَسْمِ التَّرِكَاتِ
u'قَسْمٌ تَرِكَةٌ':Added, #1: 1	قَسْمَ تَرِكَتِهِ
u'قَسْمٌ تَرِكَةٌ':Added, #2: 2	قَسْمِ التَّرِكَةِ
u'قَسْمٌ ثَمَرَةٌ':Added, #3: 3	قَسْمِ تَرِكَتِهِ
u'قَسَمَ ثَمَنٌ':Predicate, #1: 1	قَسْمَ ثَمَرَةِ
u'قَسَّمَ جَامِعٌ':Predicate, #2: 2	قَسَمَ الثَّمَنَ
u'قَسْمٌ جَاهِلِيٌّ':Added, #1: 1	قَسَّمَ الْجَامِعَ
u'قَسْمٌ جَاهِلِيَّةٌ':Added, #1: 1	قَسْمِ الْجَاهِلِيَّةِ
u'قَسْمٌ جَدِيدٌ':Added, #1: 1	قَسْمِ الْجَاهِلِيَّةِ
u'قَسْمٌ جَمَاعَةٌ':Added, #1: 1	قَسْمَ الْجَدِيدَةِ
u'قَسَّمَ حاكِمٌ':Subject, #1: 1	قَسْمِ الْجَمَاعَةِ
u'قَسَمَ حاكِمٌ':Subject, #1: 1	قَسَّمَ الْحَاكِمُ
u'قَسْمٌ حاكِمٌ':Added, #3: 3	قَسَمَ الْحَاكِمُ
u'قَسْمٌ حَبْسٌ':Added, #1: 1	قَسْمُ الْحَاكِمِ
u'قَسَمَ حُرٌّ':Predicate, #1: 1	قَسْمَ الْحَبْسِ
u'قَسْمٌ حُرٌّ':Added, #1: 1	قَسَمَ حُرَّةً
u'قَسْمٌ حُرٌّ':Added, #1: 1	قَسْمِ الْحُرَّةِ
u'قَسَّمَ حُروفٌ':Predicate, #7: 7	قَسْمُ حُرَّةٍ
u'قَسَّمَ حِصَّةٌ':Predicate, #1: 1	قَسَّمَ حُرُوفَ
u'قَسَّمَ حَنَفِيَّةٌ':Subject, #1: 1	قَسَّمَ حِصَّةَ
u'قَسَّمَ خلق':Predicate, #3: 3	قَسَّمَ الْحَنَفِيَّةُ
u'قَسَّمَ خَلْقٌ':Predicate, #2: 2	قَسَّمَ الْخَلْقَ
u'قَسَّمَ خَلِيلٌ':Subject, #2: 2	قَسَّمَ الْخَلْقَ
u'قَسْمٌ خُمُسٌ':Added, #1: 1	قَسَّمَ الْخَلِيلُ
u'قَسْمٌ خُمُسٌ':Added, #1: 1	قَسْمِ الْخُمُسِ
u'قَسَّمَ دَارٌ':Predicate, #1: 1	قَسْمِ خُمُسِ
u'قَسَّمَ دُورٌ':Predicate, #1: 1	قَسَّمَ الدَّارَ
u'قَسَمَ دَيْنٌ':Predicate, #1: 1	قَسَّمَ الدُّورَ
u'قَسْمٌ دَيْنٌ':Added, #1: 1	قَسَمَ الدَّيْنَ
u'قَسَّمَ ذَهَبِيٌّ':Predicate, #1: 1	قَسْمُ الدَّيْنِ
u'قَسَمَ رَسُولٌ':Subject, #1: 1	قَسَّمَ الذَّهَبِيَّةَ
u'قَسَّمَ رَسُولٌ':Subject, #29: 29	قَسَمَ رَسُولُ
u'قَسْمٌ رَسُولٌ':Added, #4: 4	قَسَّمَ رَسُولُ
u'قَسَمَ ريعٌ':Predicate, #1: 1	قَسْمِ رَسُولِ
u'قَسَّمَ زَكاةٌ':Predicate, #1: 1	قَسَمَ الرِّيعَ
u'قَسْمٌ زَكاةٌ':Added, #1: 1	قَسَّمَ الزَّكَاةَ
u'قَسْمٌ زَكاةٌ':Added, #1: 1	قَسْمِ الزَّكَاةِ
u'قَسْمٌ زَوْجٌ':Added, #1: 1	قَسْمَ زَكَاةِ
u'قَسْمٌ زَوْجَةٌ':Added, #1: 1	قَسْمُ الزَّوْجِ
u'قَسْمٌ سَفَرٌ':Added, #1: 1	قَسْمِ الزَّوْجَاتِ
u'قَسَمَ سِلاَحٌ':Predicate, #2: 2	قَسْمِ السَّفَرِ
u'قَسَّمَ سِلاَحٌ':Predicate, #1: 1	قَسَمَ السِّلَاحَ
u'قَسَمَ سَنَةٌ':Predicate, #1: 1	قَسَّمَ السِّلَاحَ
u'قَسَمَ سَهْمٌ':Predicate, #1: 1	قَسَمَ السَّنَةَ
u'قَسَّمَ شافِع':Subject, #2: 2	قَسَمَ سَهْمَ
u'قَسَّمَ شافِعِيّ':Subject, #1: 1	قَسَّمَ الشَّافِعِيَّةُ
u'قَسَمَ شركاء':Subject, #1: 1	قَسَّمَ الشَّافِعِيَّةُ
u'قَسْمٌ شَعَرٌ':Added, #1: 1	قَسَمَ الشُّرَكَاءُ
u'قَسْمٌ شَيْءٌ':Added, #1: 1	قَسْمِ شَعَرِهِ
u'قَسْمٌ صَاحِبٌ':Added, #1: 1	قَسْمُ الشَّيْءِ
u'قَسَّمَ صبرة':Predicate, #2: 2	قَسْمَ صَاحِبِهِ
u'قَسَّمَ صُبْرَةٌ':Predicate, #1: 1	قَسَّمَ الصُّبْرَةَ
u'قَسْمٌ صَدَقَةٌ':Added, #1: 1	قَسَّمَ الصُّبْرَةَ
u'قَسْمٌ صدقة':Added, #1: 1	قَسْمُ الصَّدَقَاتِ
u'قَسْمٌ صَدَقَةٌ':Added, #1: 1	قَسْمَ صَدَقَتِهِ
u'قَسْمٌ صَدَقَةٌ':Added, #1: 1	قَسْمَ صَدَقَتِهِ
u'قَسَمَ صَيْرَفِيٌّ':Subject, #28: 28	قَسْمِ الصَّدَقَاتِ
u'قَسْمٌ عَاصِبٌ':Added, #1: 1	قَسَمَ الصَّيْرَفِيُّ
u'قَسَّمَ عَامٌّ':Predicate, #1: 1	قَسْمُ الْعَاصِبِ
u'قَسْمٌ عَامٌّ':Added, #1: 1	قَسَّمَ الْعَامَّ
u'قَسْمٌ عَرْصَةٌ':Added, #1: 1	قَسْمِ عَامَّةِ
u'قَسْمٌ عُلْوٌ':Added, #1: 1	قَسْمِ عَرْصَتِهِ
u'قَسَّمَ عَلِيٌّ':Subject, #1: 1	قَسْمُ الْعُلْوِ
u'قَسَّمَ عُمَرٌ':Subject, #1: 1	قَسَّمَ عَلِيٌّ
u'قَسَمَ عُمَرٌ':Subject, #1: 1	قَسَّمَ عُمَرُ
u'قَسَمَ عين':Predicate, #2: 2	قَسَمَ عُمَرُ
u'قَسَمَ عَيْنٌ':Predicate, #1: 1	قَسَمَ الْعَيْنَ
u'قَسَمَ عَيْن':Predicate, #1: 1	قَسَمَ الْعَيْنَ
u'قَسْمٌ غَاصِبٌ':Added, #1: 1	قَسَمَ الْعَيْنَ
u'قَسَّمَ غَنَائِمُ':Predicate, #1: 1	قَسْمُ الْغَاصِبِ
u'قَسَّمَ غَنَائِمُ':Predicate, #1: 1	قَسَّمَ الْغَنَائِمَ
u'قَسَمَ غَنَائِمُ':Predicate, #3: 3	قَسَّمَ غَنَائِمَ
u'قَسْمٌ غَنَائِمُ':Added, #5: 5	قَسَمَ غَنَائِمَ
u'قَسَمَ غَنِيمَةٌ':Predicate, #4: 4	قَسْمِ الْغَنَائِمِ
u'قَسْمٌ غَنِيمَةٌ':Added, #2: 2	قَسَمَ غَنِيمَةَ
u'قَسْمٌ غَنِيمَةٌ':Added, #2: 2	قَسْمَ الْغَنِيمَةِ
u'قَسْمٌ غير':Added, #3: 3	قَسْمِ الْغَنِيمَةِ
u'قَسْمٌ غَيْرٌ':Added, #2: 2	قَسْمِ غَيْرِهِ
u'قَسَّمَ فخر':Subject, #2: 2	قَسْمِ غَيْرِهِ
u'قَسَّمَ فَخْرٌ':Subject, #1: 1	قَسَّمَ فَخْرُ
u'قَسْمٌ فَرِيضَةٌ':Added, #1: 1	قَسَّمَ فَخْرُ
u'قَسَمَ فلان':Predicate, #1: 1	قَسْمَ فَرِيضَةٍ
u'قَسَّمَ فلان':Subject, #2: 2	قَسَمَ خَيْبَرَ
u'قَسَمَ فَيْءٌ':Predicate, #1: 1	قَسَّمَ الشَّافِعِيَّةُ
u'قَسْمٌ فَيْءٌ':Added, #1: 1	قَسَمَ الْفَيْءَ
u'قَسْمٌ فَيْءٌ':Added, #1: 1	قَسْمُ الْفَيْءِ
u'قَسْمٌ قَاسِمٌ':Added, #35: 35	قَسْمِ الْفَيْءِ
u'قَسَّمَ قتل':Predicate, #1: 1	قَسْمَ الْقَاسِمِ
u'قَسَّمَ قَتْلٌ':Predicate, #1: 1	قَسَّمَ الْقَتْلَ
u'قَسَمَ قَوْمٌ':Subject, #1: 1	قَسَّمَ الْقَتْلَ
u'قَسْمٌ كَرَاهَةٌ':Added, #1: 1	قَسَمَ الْقَوْمُ
u'قَسْمٌ لَحْمٌ':Added, #1: 1	قَسْمِ الْكَرَاهَةِ
u'قَسْمٌ لَغْوٌ':Added, #1: 1	قَسْمُ اللَّحْمِ
u'قَسَّمَ لَفْظٌ':Predicate, #1: 1	قَسْمَ لَغْوِهِ
u'قَسْمٌ مَاءٌ':Added, #1: 1	قَسَّمَ اللَّفْظَ
u'قَسَّمَ مَالٌ':Predicate, #1: 1	قَسْمُ الْمَاءِ
u'قَسَمَ مَالٌ':Predicate, #1: 1	قَسَّمَ الْمَالَ
u'قَسَّمَ مَالٌ':Predicate, #1: 1	قَسَمَ مَالَ
u'قَسَمَ مَالٌ':Predicate, #1: 1	قَسَّمَ مَالَ
u'قَسْمٌ مَالٌ':Added, #2: 2	قَسَمَ الْمَالَ
u'قَسْمٌ مَالٌ':Added, #1: 1	قَسْمُ الْمَالِ
u'قَسْمٌ مَالٌ':Added, #1: 1	قَسْمِ الْمَالِ
u'قَسْمٌ مَالٌ':Added, #1: 1	قَسْمُ مَالِ
u'قَسْمٌ مَالٌ':Added, #1: 1	قَسْمِ مَالِ
u'قَسْمٌ مَالٌ':Added, #1: 1	قَسْمُ مَالِهِ
u'قَسَمَ مَتَاعٌ':Predicate, #4: 4	قَسْمِ مَالِهِ
u'قَسَّمَ مَسْأَلَةٌ':Predicate, #1: 1	قَسَمَ الْمَتَاعَ
u'قَسَمَ مَسْأَلَةٌ':Predicate, #1: 1	قَسَّمَ مَسْأَلَةَ
u'قَسَّمَ مُصَنِّفٌ':Subject, #2: 2	قَسَمَ الْمَسْأَلَةَ
u'قَسَمَ مُضَارِبٌ':Subject, #1: 1	قَسَّمَ الْمُصَنِّفُ
u'قَسَّمَ مقارِنُ':Predicate, #3: 3	قَسَمَ الْمُضَارِبُ
u'قَسَّمَ مُقَارِنٌ':Predicate, #1: 1	قَسَّمَ الْمُقَارِنَ
u'قَسْمٌ مَقْصُودٌ':Added, #1: 1	قَسَّمَ الْمُقَارِنَ
u'قَسْمٌ مَنَافِعُ':Added, #1: 1	قَسْمِ الْمَقْصُودِ
u'قَسَمَ مِيرَاثٌ':Predicate, #2: 2	قَسْمِ الْمَنَافِعِ
u'قَسَمَ مِيرَاثٌ':Predicate, #1: 1	قَسَمَ الْمِيرَاثَ
u'قَسْمٌ مِيرَاثٌ':Added, #1: 1	قَسَمَ مِيرَاثَ
u'قَسْمٌ مِيرَاثٌ':Added, #1: 1	قَسْمِ مِيرَاثِهِ
u'قَسَّمَ نَاسٌ':Subject, #6: 6	قَسْمِ الْمِيرَاثِ
u'قَسَمَ نَبِيٌّ':Subject, #1: 1	قَسَّمَ النَّاسُ
u'قَسْمٌ نخلة':Added, #1: 1	قَسَمَ النَّبِيُّ
u'قَسْمٌ نَخْلَةٌ':Added, #1: 1	قَسْمُ نَخْلَةٍ
u'قَسَّمَ نَصٌّ':Predicate, #1: 1	قَسْمُ نَخْلَةٍ
u'قَسْمٌ نَفْسٌ':Added, #1: 1	قَسَّمَ النَّصَّ
u'قَسَّمَ نَهْيٌ':Predicate, #1: 1	قَسْمِ نَفْسِهِ
u'قَسَّمَ هجرة':Predicate, #1: 1	قَسَّمَ النَّهْيَ
u'قَسَّمَ هِجْرَةٌ':Predicate, #1: 1	قَسَّمَ الْهِجْرَةَ
u'قَسَمَ وَرَثَةٌ':Subject, #1: 1	قَسَّمَ الْهِجْرَةَ
u'قَسَّمَ وَصِيٌّ':Predicate, #2: 2	قَسَمَ الْوَرَثَةُ
u'قَسَّمَ وَصِيٌّ':Subject, #1: 1	قَسَّمَ الْوَصِيَّةَ
u'قَسَمَ وَصِيٌّ':Subject, #1: 1	قَسَّمَ الْوَصِيُّ
u'قَسَّمَ وَصِيَّةٌ':Predicate, #3: 3	قَسَمَ الْوَصِيُّ
u'قَسْمٌ وَقْفٌ':Added, #1: 1	قَسَّمَ الْوَصِيَّةَ
u'قَسَمَ يَوْمٌ':Predicate, #1: 1	قَسْمُ الْوَقْفِ
u'قَسْوَةٌ قلب':Added, #2: 2	قَسَمَ يَوْمَ
u'قَسْوَةٌ قَلْبٌ':Added, #1: 1	قَسْوَةِ الْقَلْبِ
u'قَسْوَةٌ قَلْب':Added, #1: 1	قَسْوَةِ الْقَلْبِ
u'قَسْوَةٌ قلب':Added, #1: 1	قَسْوَةِ الْقَلْبِ
u'قَسْوَةٌ قلب':Added, #1: 1	قَسْوَةَ قَلْبِهِ
u'قَسْوَةٌ قَلْبٌ':Added, #1: 1	قَسْوَةِ قَلْبِهِ
u'قَسْوَةٌ قَلْبٌ':Added, #1: 1	قَسْوَةَ قَلْبِهِ
u'قَسْوَةٌ قَلْب':Added, #1: 1	قَسْوَةِ قَلْبِهِ
u'قَسْوَةٌ قَلْب':Added, #1: 1	قَسْوَةَ قَلْبِهِ
u'قَسْوَةٌ قلب':Added, #1: 1	قَسْوَةِ قَلْبِهِ
u'قَسْوَةٌ قلب':Added, #2: 2	قَسْوَةَ الْقَلْبِ
u'قَسْوَةٌ قَلْبٌ':Added, #2: 2	قَسْوَةُ الْقَلْبِ
u'قَسْوَةٌ قَلْبٌ':Added, #2: 2	قَسْوَةَ الْقَلْبِ
u'قَسْوَةٌ قَلْب':Added, #2: 2	قَسْوَةُ الْقَلْبِ
u'قَسْوَةٌ قَلْب':Added, #2: 2	قَسْوَةَ الْقَلْبِ
u'قَشَفٌ إِحْرَامٌ':Added, #2: 2	قَسْوَةُ الْقَلْبِ
u'قَشِفَ رَجُلٌ':Subject, #1: 1	قَشَفِ الْإِحْرَامِ
u'قَصَّ أَظْفارٌ':Predicate, #1: 1	قَشِفَ الرَّجُلُ
u'قَصَّ أَظْفارٌ':Predicate, #3: 3	قَصَّ الْأَظْفَارَ
u'قَصَّ أقَلُّ':Predicate, #5: 5	قَصَّ أَظْفَارَ
u'قَصَّ أَكْثَرُ':Predicate, #3: 3	قَصَّ أَقَلَّ
u'قَصَّ ثَلاثَةٌ':Predicate, #2: 2	قَصَّ أَكْثَرَ
u'قَصَّ حَديثٌ':Predicate, #1: 1	قَصَّ ثَلَاثَةَ
u'قَصَّ حَوافِرُ':Predicate, #2: 2	قَصَّ الْحَدِيثَ
u'قَصَّ خَمْسَةٌ':Predicate, #1: 1	قَصَّ حَوَافِرَ
u'قَصَدَ أَبٌ':Subject, #6: 6	قَصَّ خَمْسَةَ
u'قَصْدٌ إبَاحَةٌ':Added, #3: 3	قَصَدَ الْأَبُ
u'قَصْدٌ إبَاحَةٌ':Added, #1: 1	قَصْدُ إبَاحَةِ
u'قَصْدٌ إبَاحَةٌ':Added, #1: 1	قَصْدِ إبَاحَتِهِ
u'قَصْدٌ إبَاحَةٌ':Added, #1: 1	قَصْدِ الْإِبَاحَةِ
u'قَصْدٌ اِبْتِداءٌ':Added, #2: 2	قَصْدُ الْإِبَاحَةِ
u'قَصَدَ إِبْطَالٌ':Predicate, #1: 1	قَصْدِ ابْتِدَاءٍ
u'قَصْدٌ إِبْطَالٌ':Added, #3: 3	قَصَدَ إبْطَالَ
u'قَصَدَ أَبْعَدُ':Predicate, #2: 2	قَصْدِ الْإِبْطَالِ
u'قَصْدٌ أَبْعَدُ':Added, #2: 2	قَصَدَ الْأَبْعَدَ
u'قَصَدَ اِتِّساعٌ':Predicate, #1: 1	قَصْدُ الْأَبْعَدِ
u'قَصَدَ إِتْلاَفٌ':Predicate, #1: 1	قَصَدَ اتِّسَاعَ
u'قَصْدٌ إِتْلاَفٌ':Added, #1: 1	قَصَدَ إتْلَافَ
u'قَصَدَ إتْمَامٌ':Predicate, #1: 1	قَصْدُ الْإِتْلَافِ
u'قَصْدٌ إِتْيانٌ':Added, #1: 1	قَصَدَ إتْمَامَ
u'قَصَدَ إِثْبَاتٌ':Predicate, #1: 1	قَصْدِ إتْيَانِهِ
u'قَصْدٌ إِثْبَاتٌ':Added, #4: 4	قَصَدَ إثْبَاتَ
u'قَصَدَ إِجَابَةٌ':Predicate, #1: 1	قَصْدِ إثْبَاتِهِ
u'قَصْدٌ إجَازَةٌ':Added, #1: 1	قَصَدَ الْإِجَابَةَ
u'قَصَدَ أَجْرٌ':Predicate, #1: 1	قَصْدِ الْإِجَازَةِ
u'قَصَدَ أحَدٌ':Predicate, #1: 1	قَصَدَ الْأَجْرَ
u'قَصَدَ إِحْرَازٌ':Predicate, #2: 2	قَصَدَ أَحَدَ
u'قَصْدٌ إِحْرَازٌ':Added, #1: 1	قَصَدَ إحْرَازَ
u'قَصْدٌ إِحْرَامٌ':Added, #1: 1	قَصْدِ الْإِحْرَازِ
u'قَصْدٌ إِحْرَامٌ':Added, #1: 1	قَصْدَ الْإِحْرَامِ
u'قَصْدٌ إِحْرَامٌ':Added, #1: 1	قَصْدِ الْإِحْرَامِ
u'قَصَدَ أحْزَابٌ':Subject, #2: 2	قَصْدُ إحْرَامٍ
u'قَصْدٌ إِحْلاَلٌ':Added, #1: 1	قَصَدَ الْأَحْزَابُ
u'قَصَدَ إِخْبَارٌ':Predicate, #7: 7	قَصْدِ الْإِحْلَالِ
u'قَصْدٌ إِخْبَارٌ':Added, #2: 2	قَصَدَ الْإِخْبَارَ
u'قَصْدٌ اِخْتِصَاصٌ':Added, #1: 1	قَصْدِ الْإِخْبَارِ
u'قَصَدَ أخْذٌ':Predicate, #1: 1	قَصْدِ اخْتِصَاصِ
u'قَصَدَ أخْذٌ':Predicate, #1: 1	قَصَدَ الْأَخْذَ
u'قَصْدٌ أخْذٌ':Added, #2: 2	قَصَدَ أَخْذَ
u'قَصْدٌ إِخْرَاجٌ':Added, #1: 1	قَصْدُ الْأَخْذِ
u'قَصْدٌ إِخْرَاجٌ':Added, #1: 1	قَصْدِ إخْرَاجِ
u'قَصَدَ أَدَاءٌ':Predicate, #1: 1	قَصْدَ الْإِخْرَاجِ
u'قَصَدَ أَدَاءٌ':Predicate, #1: 1	قَصَدَ الْأَدَاءَ
u'قَصْدٌ أَدَاءٌ':Added, #4: 4	قَصَدَ أَدَاءَ
u'قَصْدٌ أَدَاءٌ':Added, #1: 1	قَصْدِ الْأَدَاءِ
u'قَصَدَ إِرَاقَةٌ':Predicate, #5: 5	قَصْدِ أَدَاءِ
u'قَصَدَ إِرْثٌ':Predicate, #1: 1	قَصَدَ الْإِرَاقَةَ
u'قَصَدَ إِرْضاءٌ':Predicate, #1: 1	قَصَدَ الْإِرْثَ
u'قَصَدَ إِزَالَةٌ':Predicate, #1: 1	قَصَدَ إرْضَاءَ
u'قَصْدٌ إِزَالَةٌ':Added, #2: 2	قَصَدَ إزَالَةَ
u'قَصْدٌ إِزَالَةٌ':Added, #1: 1	قَصْدُ إزَالَةِ
u'قَصْدٌ إِزَالَةٌ':Added, #1: 1	قَصْدَ الْإِزَالَةِ
u'قَصَدَ إِزْهَاقٌ':Predicate, #1: 1	قَصْدِ الْإِزَالَةِ
u'قَصَدَ اِسْتِبَاحَةٌ':Predicate, #1: 1	قَصَدَ إزْهَاقَ
u'قَصَدَ اِسْتِخْلاَصٌ':Predicate, #1: 1	قَصَدَ اسْتِبَاحَةَ
u'قَصْدٌ اِسْتِعْجالٌ':Added, #1: 1	قَصَدَ اسْتِخْلَاصَ
u'قَصْدٌ اِسْتِعْمالٌ':Added, #1: 1	قَصْدِ اسْتِعْجَالِهِ
u'قَصْدٌ اِسْتِقْبالٌ':Added, #1: 1	قَصْدُ اسْتِعْمَالِ
u'قَصْدٌ اِسْتِلْحاق':Added, #1: 1	قَصْدُ اسْتِقْبَالِ
u'قَصَدَ إِسْقاطٌ':Predicate, #1: 1	قَصْدُ اسْتِلْحَاقٍ
u'قَصَدَ إِسْقاطٌ':Predicate, #1: 1	قَصَدَ الْإِسْقَاطَ
u'قَصَدَ إِسْقاطٌ':Predicate, #2: 2	قَصَدَ إِسْقَاطَ
u'قَصْدٌ إِسْقاطٌ':Added, #5: 5	قَصَدَ إسْقَاطَ
u'قَصَدَ اِسْمٌ':Predicate, #1: 1	قَصْدُ إسْقَاطِ
u'قَصَدَ إصابَةٌ':Predicate, #1: 1	قَصَدَ اسْمَ
u'قَصَدَ أصل':Predicate, #2: 2	قَصَدَ إصَابَةَ
u'قَصَدَ أًصْلٌ':Predicate, #1: 1	قَصَدَ الْأَصْلَ
u'قَصَدَ إِصْلاحٌ':Predicate, #1: 1	قَصَدَ الْأَصْلَ
u'قَصَدَ إِصْلاحٌ':Predicate, #1: 1	قَصَدَ إصْلَاحَ
u'قَصْدٌ إِصْلاحٌ':Added, #1: 1	قَصَدَ الْإِصْلَاحَ
u'قَصْدٌ إِصْلاحٌ':Added, #1: 1	قَصْدُ إصْلَاحِ
u'قَصْدٌ إِصْلاحٌ':Added, #1: 1	قَصْدِ إصْلَاحِ
u'قَصْدٌ إِصْلاحٌ':Added, #1: 1	قَصْدُ الْإِصْلَاحِ
u'قَصْدٌ إِصْلاحٌ':Added, #2: 2	قَصْدَ الْإِصْلَاحِ
u'قَصْدٌ إِضْرابٌ':Added, #9: 9	قَصْدِ الْإِصْلَاحِ
u'قَصَدَ إِطْلاقٌ':Predicate, #1: 1	قَصْدَ الْإِضْرَابِ
u'قَصَدَ إِظْهارٌ':Predicate, #2: 2	قَصَدَ إطْلَاقَ
u'قَصْدٌ إِظْهارٌ':Added, #1: 1	قَصَدَ إظْهَارَ
u'قَصَدَ إِعْتاقٌ':Predicate, #1: 1	قَصْدِ إظْهَارِهِ
u'قَصْدٌ إعْرَاضٌ':Added, #1: 1	قَصَدَ إعْتَاقَ
u'قَصَدَ إعْلاَمٌ':Predicate, #2: 2	قَصْدِ الْإِعْرَاضِ
u'قَصْدٌ إعْلاَمٌ':Added, #3: 3	قَصَدَ الْإِعْلَامَ
u'قَصْدٌ إعْلاَمٌ':Added, #1: 1	قَصْدَ الْإِعْلَامِ
u'قَصْدٌ إفَادَةٌ':Added, #5: 5	قَصْدِ الْإِعْلَامِ
u'قَصْدٌ أَفْرَادٌ':Added, #1: 1	قَصْدِ الْإِفَادَةِ
u'قَصْدٌ أَفْعَالٌ':Added, #1: 1	قَصْدِ الْأَفْرَادِ
u'قَصَدَ إقامَةٌ':Predicate, #1: 1	قَصْدُ أَفْعَالِ
u'قَصَدَ إقْرَارٌ':Predicate, #6: 6	قَصَدَ إقَامَةَ
u'قَصْدٌ إقْرَارٌ':Added, #1: 1	قَصَدَ الْإِقْرَارَ
u'قَصْدٌ أقْرَبُ':Added, #1: 1	قَصْدِ الْإِقْرَارِ
u'قَصْدٌ إكْرَامٌ':Added, #2: 2	قَصْدُ أَقْرَبِ
u'قَصَدَ أكل':Predicate, #1: 1	قَصْدِ الْإِكْرَامِ
u'قَصَدَ أَكْلٌ':Predicate, #2: 2	قَصَدَ الْأَكْلَ
u'قَصْدٌ أكل':Added, #2: 2	قَصَدَ الْأَكْلَ
u'قَصْدٌ أكل':Added, #1: 1	قَصْدَ الْأَكْلِ
u'قَصْدٌ أكل':Added, #1: 1	قَصْدُ الْأَكْلِ
u'قَصْدٌ أَكْلٌ':Added, #1: 1	قَصْدِ الْأَكْلِ
u'قَصْدٌ أَكْلٌ':Added, #1: 1	قَصْدَ الْأَكْلِ
u'قَصْدٌ أَكْلٌ':Added, #1: 1	قَصْدُ الْأَكْلِ
u'قَصْدٌ اِلْتِذاذٌ':Added, #1: 1	قَصْدِ الْأَكْلِ
u'قَصَدَ اِلْتِزَامٌ':Predicate, #3: 3	قَصْدِ الْتِذَاذٍ
u'قَصَدَ إلْحَاقٌ':Predicate, #1: 1	قَصَدَ الْتِزَامَ
u'قَصَدَ إلْحَاقٌ':Predicate, #1: 1	قَصَدَ الْإِلْحَاقَ
u'قَصْدٌ إِلْزَامٌ':Added, #1: 1	قَصَدَ إلْحَاقَ
u'قَصْدٌ إِلْزَامٌ':Added, #1: 1	قَصْدَ الْإِلْزَامِ
u'قَصْدٌ الْمَرْأَةُ':Added, #1: 1	قَصْدِ الْإِلْزَامِ
u'قَصْدٌ الْمَرْأَةُ':Added, #1: 1	قَصْدَ الْمَرْأَةِ
u'قَصَدَ إمَاطَةٌ':Predicate, #1: 1	قَصْدُ الْمَرْأَةِ
u'قَصْدٌ إمَامٌ':Added, #1: 1	قَصَدَ إمَاطَةَ
u'قَصْدٌ اِمْتِثَالٌ':Added, #1: 1	قَصْدُ الْإِمَامِ
u'قَصْدٌ أَمْرٌ':Added, #1: 1	قَصْدِ امْتِثَالٍ
u'قَصْدٌ إِمْساكٌ':Added, #1: 1	قَصْدُ أَمْرٍ
u'قَصَدَ إِمْلاءٌ':Predicate, #2: 2	قَصْدِ الْإِمْسَاكِ
u'قَصْدٌ أُمُورٌ':Added, #1: 1	قَصَدَ الْإِمْلَاءَ
u'قَصَدَ اِنْتِفاعٌ':Predicate, #1: 1	قَصْدِ الْأُمُورِ
u'قَصْدٌ اِنْخِرامٌ':Added, #1: 1	قَصَدَ انْتِفَاعَ
u'قَصْدٌ إِنْزالٌ':Added, #1: 1	قَصْدِ انْخِرَامِ
u'قَصَدَ إِنْشاءٌ':Predicate, #1: 1	قَصْدِ الْإِنْزَالِ
u'قَصَدَ إِنْشاءٌ':Predicate, #1: 1	قَصَدَ إنْشَاءَ
u'قَصْدٌ إِنْشاءٌ':Added, #2: 2	قَصَدَ الْإِنْشَاءَ
u'قَصْدٌ إِنْفاقٌ':Added, #1: 1	قَصْدِ الْإِنْشَاءِ
u'قَصَدَ إِنْكارٌ':Predicate, #1: 1	قَصْدِ الْإِنْفَاقِ
u'قَصَدَ أَنْوَاعٌ':Predicate, #1: 1	قَصَدَ الْإِنْكَارَ
u'قَصَدَ أهْلٌ':Predicate, #1: 1	قَصَدَ الْأَنْوَاعَ
u'قَصَدَ أهْلٌ':Subject, #1: 1	قَصَدَ أَهْلَ
u'قَصْدٌ إِهْلاَكٌ':Added, #1: 1	قَصَدَ أَهْلُ
u'قَصْدٌ إِهْلاَكٌ':Added, #1: 1	قَصْدُ الْإِهْلَاكِ
u'قَصَدَ أوائل':Subject, #2: 2	قَصْدِ الْإِهْلَاكِ
u'قَصَدَ إِيثَارٌ':Predicate, #1: 1	قَصَدَ الْأَوَائِلُ
u'قَصَدَ إِيجَابٌ':Predicate, #1: 1	قَصَدَ الْإِيثَارَ
u'قَصَدَ إيرَادٌ':Predicate, #2: 2	قَصَدَ إيجَابَ
u'قَصَدَ إيصَالٌ':Predicate, #1: 1	قَصَدَ إيرَادَ
u'قَصَدَ إيقَاعٌ':Predicate, #1: 1	قَصَدَ إيصَالَ
u'قَصَدَ إيقَاعٌ':Predicate, #1: 1	قَصَدَ الْإِيقَاعَ
u'قَصْدٌ إيقَاعٌ':Added, #8: 8	قَصَدَ إيقَاعَ
u'قَصْدٌ إيقَاعٌ':Added, #1: 1	قَصْدُ الْإِيقَاعِ
u'قَصْدٌ إيقَاعٌ':Added, #1: 1	قَصْدِ الْإِيقَاعِ
u'قَصْدٌ إِينَاسٌ':Added, #1: 1	قَصْدُ إيقَاعِ
u'قَصْدٌ باتٌّ':Added, #1: 1	قَصْدِ إينَاسٍ
u'قَصَدَ بَائِعٌ':Subject, #1: 1	قَصْدِ الْبَاتِّ
u'قَصْدٌ بَائِنٌ':Added, #1: 1	قَصَدَ الْبَائِعُ
u'قَصْدٌ بَدَل':Added, #1: 1	قَصْدٍ بَائِنٍ
u'قَصْدٌ بَدَلِيَّة':Added, #1: 1	قَصْدُ الْبَدَلِيَّةِ
u'قَصَدَ بِرٌّ':Predicate, #1: 1	قَصْدُ الْبَدَلِيَّةِ
u'قَصَدَ بُسْتانٌ':Predicate, #2: 2	قَصَدَ الْبِرَّ
u'قَصَدَ بَعْضٌ':Predicate, #2: 2	قَصَدَ الْبُسْتَانَ
u'قَصْدٌ بِقاعٌ':Added, #2: 2	قَصَدَ بَعْضَ
u'قَصَدَ بَلَدٌ':Predicate, #1: 1	قَصْدُ الْبِقَاعِ
u'قَصْدٌ بَلَدٌ':Added, #1: 1	قَصَدَ الْبَلَدَ
u'قَصَدَ بَيَانٌ':Predicate, #3: 3	قَصْدُ الْبَلَدِ
u'قَصْدٌ بَيَانٌ':Added, #7: 7	قَصَدَ بَيَانَ
u'قَصْدٌ بَيْتٌ':Added, #2: 2	قَصْدَ الْبَيَانِ
u'قَصَدَ بَيْعٌ':Predicate, #1: 1	قَصْدِ الْبَيْتِ
u'قَصْدٌ تَأْبِيدٌ':Added, #1: 1	قَصَدَ الْبَيْعَ
u'قَصَدَ تَأْجِيلٌ':Predicate, #1: 1	قَصْدِ التَّأْبِيدِ
u'قَصْدٌ تَأْدِيبٌ':Added, #1: 1	قَصَدَ التَّأْجِيلَ
u'قَصَدَ تَأْسِيسٌ':Predicate, #2: 2	قَصْدُ التَّأْدِيبِ
u'قَصْدٌ تَأْسِيسٌ':Added, #2: 2	قَصَدَ التَّأْسِيسَ
u'قَصَدَ تَأْكِيدٌ':Predicate, #1: 1	قَصْدُ تَأْسِيسِ
u'قَصَدَ تَأْكِيدٌ':Predicate, #1: 1	قَصَدَ التَّأْكِيدَ
u'قَصْدٌ تَأْكِيدٌ':Added, #1: 1	قَصَدَ تَأْكِيدَ
u'قَصْدٌ تَأْكِيدٌ':Added, #1: 1	قَصْدَ تَأْكِيدِ
u'قَصْدٌ تَأْكِيدٌ':Added, #2: 2	قَصْدُ التَّأْكِيدِ
u'قَصَدَ تَأَلُّفٌ':Predicate, #3: 3	قَصْدِ التَّأْكِيدِ
u'قَصْدٌ تَبْجِيل':Added, #1: 1	قَصَدَ تَأَلُّفَ
u'قَصْدٌ تِجَارَةٌ':Added, #1: 1	قَصْدِ التَّبْجِيلِ
u'قَصْدٌ تِجَارَةٌ':Added, #1: 1	قَصْدُ التِّجَارَةِ
u'قَصَدَ تَجْوِيدٌ':Predicate, #3: 3	قَصْدِ التِّجَارَةِ
u'قَصَدَ تَحْسِينٌ':Predicate, #1: 1	قَصَدَ تَجْوِيدَ
u'قَصَدَ تَحْصِيلٌ':Predicate, #1: 1	قَصَدَ تَحْسِينَ
u'قَصْدٌ تَحْصِيلٌ':Added, #1: 1	قَصَدَ تَحْصِيلَ
u'قَصَدَ تَحْقِيقٌ':Predicate, #2: 2	قَصْدِ تَحْصِيلِ
u'قَصْدٌ تَحْقِيقٌ':Added, #1: 1	قَصَدَ تَحْقِيقَ
u'قَصْدٌ تَحْقِيقٌ':Added, #1: 1	قَصْدِ التَّحْقِيقِ
u'قَصَدَ تَحَلُّلٌ':Predicate, #1: 1	قَصْدِ تَحْقِيقِهِ
u'قَصْدٌ تَحَلُّلٌ':Added, #1: 1	قَصَدَ التَّحَلُّلَ
u'قَصْدٌ تَحْلِيلٌ':Added, #1: 1	قَصْدِ التَّحَلُّلِ
u'قَصْدٌ تَحَيُّزٌ':Added, #1: 1	قَصْدُ التَّحْلِيلِ
u'قَصْدٌ تَحَيُّل':Added, #1: 1	قَصْدُ التَّحَيُّزِ
u'قَصَدَ تَخْصِيصٌ':Predicate, #1: 1	قَصْدِ التَّحَيُّلِ
u'قَصَدَ تَخْصِيصٌ':Predicate, #1: 1	قَصَدَ التَّخْصِيصَ
u'قَصْدٌ تَخْصِيصٌ':Added, #2: 2	قَصَدَ تَخْصِيصَ
u'قَصْدٌ تَخْصِيصٌ':Added, #1: 1	قَصْدُ التَّخْصِيصِ
u'قَصَدَ تَخْفِيفٌ':Predicate, #1: 1	قَصْدُ تَخْصِيصِ
u'قَصْدٌ تَخْفِيفٌ':Added, #1: 1	قَصَدَ التَّخْفِيفَ
u'قَصَدَ تَخَلُّصٌ':Predicate, #1: 1	قَصْدِ التَّخْفِيفِ
u'قَصْدٌ تَخَلُّلٌ':Added, #1: 1	قَصَدَ التَّخَلُّصَ
u'قَصْدٌ تَدْلِيس':Added, #2: 2	قَصْدِ تَخَلُّلٍ
u'قَصْدٌ تَذْكِيَةٌ':Added, #1: 1	قَصْدِ التَّدْلِيسِ
u'قَصْدٌ تَرْفِيع':Added, #1: 1	قَصْدُ التَّذْكِيَةِ
u'قَصَدَ تَرْفِيه':Predicate, #1: 1	قَصْدِ التَّرْفِيعِ
u'قَصَدَ تَرْكٌ':Predicate, #1: 1	قَصَدَ التَّرْفِيهَ
u'قَصَدَ تَرْوِيج':Predicate, #3: 3	قَصَدَ تَرْكَ
u'قَصَدَ تَزَوُّجٌ':Predicate, #1: 1	قَصَدَ تَرْوِيجَ
u'قَصْدٌ تَزَيُّنٌ':Added, #1: 1	قَصَدَ التَّزَوُّجَ
u'قَصَدَ تَسْبِيحٌ':Predicate, #2: 2	قَصْدِ التَّزَيُّنِ
u'قَصْدٌ تَسْمِيَة':Added, #1: 1	قَصَدَ التَّسْبِيحَ
u'قَصَدَ تَسْمِينٌ':Predicate, #1: 1	قَصْدُ التَّسْمِيَةِ
u'قَصَدَ تَشْبِيه':Predicate, #1: 1	قَصَدَ تَسْمِينَ
u'قَصْدٌ تَشْبِيه':Added, #1: 1	قَصَدَ التَّشْبِيهَ
u'قَصْدٌ تَشْبِيه':Added, #1: 1	قَصْدَ التّشْبِيهِ
u'قَصْدٌ تَشْرِيعٌ':Added, #1: 1	قَصْدَ التَّشْبِيهِ
u'قَصْدٌ تَشْرِيعٌ':Added, #1: 1	قَصْدُ التَّشْرِيعِ
u'قَصَدَ تَصْحِيحٌ':Predicate, #1: 1	قَصْدِ التَّشْرِيعِ
u'قَصَدَ تَصَدُّقٌ':Predicate, #1: 1	قَصَدَ تَصْحِيحَ
u'قَصْدٌ تَصَدُّقٌ':Added, #2: 2	قَصَدَ التَّصَدُّقَ
u'قَصْدٌ تَضْحِيَةٌ':Added, #1: 1	قَصْدُ تَصَدُّقٍ
u'قَصَدَ تَضْيِيعٌ':Predicate, #1: 1	قَصْدِ التَّضْحِيَةِ
u'قَصَدَ تَطْهِيرٌ':Predicate, #1: 1	قَصَدَ التَّضْيِيعَ
u'قَصْدٌ تَطْهِيرٌ':Added, #1: 1	قَصَدَ تَطْهِيرَ
u'قَصَدَ تَطَيُّبٌ':Predicate, #1: 1	قَصْدِ التَّطْهِيرِ
u'قَصْدٌ تَعَجُّبٌ':Added, #1: 1	قَصَدَ التَّطَيُّبَ
u'قَصْدٌ تَعَدُّدٌ':Added, #1: 1	قَصْدِ التّعَجّبِ
u'قَصْدٌ تَعَدُّدٌ':Added, #1: 1	قَصْدِ التَّعَدُّدِ
u'قَصَدَ تَعْرِيفٌ':Predicate, #1: 1	قَصْدِ تَعَدُّدِ
u'قَصَدَ تَعْرِيفٌ':Predicate, #1: 1	قَصَدَ تَعْرِيفَ
u'قَصْدٌ تَعْرِيفٌ':Added, #3: 3	قَصَدَ التَّعْرِيفَ
u'قَصَدَ تَعْظِيمٌ':Predicate, #1: 1	قَصْدُ التَّعْرِيفِ
u'قَصْدٌ تَعْظِيمٌ':Added, #1: 1	قَصَدَ تَعْظِيمَ
u'قَصْدٌ تَعْظِيمٌ':Added, #1: 1	قَصْدَ التّعْظِيمِ
u'قَصْدٌ تَعْظِيمٌ':Added, #1: 1	قَصْدُ التَّعْظِيمِ
u'قَصَدَ تَعْلِيقٌ':Predicate, #1: 1	قَصْدِ التَّعْظِيمِ
u'قَصَدَ تَعْلِيقٌ':Predicate, #12: 12	قَصَدَ التَّعْلِيقَ
u'قَصْدٌ تَعْلِيقٌ':Added, #1: 1	قَصَدَ تَعْلِيقَ
u'قَصْدٌ تَعْلِيقٌ':Added, #1: 1	قَصْدُ التَّعْلِيقِ
u'قَصْدٌ تَعْلِيقٌ':Added, #1: 1	قَصْدِ تَعْلِيقِ
u'قَصَدَ تَعْلِيمٌ':Predicate, #2: 2	قَصْدِ التَّعْلِيقِ
u'قَصَدَ تَعْلِيمٌ':Predicate, #2: 2	قَصَدَ التَّعْلِيمَ
u'قَصْدٌ تَعْلِيمٌ':Added, #2: 2	قَصَدَ تَعْلِيمَ
u'قَصْدٌ تَعْلِيمٌ':Added, #1: 1	قَصْدُ التَّعْلِيمِ
u'قَصْدٌ تَعْلِيمٌ':Added, #1: 1	قَصْدِ التَّعْلِيمِ
u'قَصْدٌ تَعْمِيمٌ':Added, #1: 1	قَصْدِ تَعْلِيمِهِ
u'قَصْدٌ تَعْمِيمٌ':Added, #1: 1	قَصْدِ تَعْمِيمِهِ
u'قَصْدٌ تَعْمِيمٌ':Added, #5: 5	قَصْدُ التَّعْمِيمِ
u'قَصَدَ تَعْيِينٌ':Predicate, #6: 6	قَصْدِ التَّعْمِيمِ
u'قَصْدٌ تَعْيِينٌ':Added, #1: 1	قَصَدَ التَّعْيِينَ
u'قَصْدٌ تَغْطِيَةٌ':Added, #1: 1	قَصْدَ التَّعْيِينِ
u'قَصَدَ تَغْلِيطٌ':Predicate, #1: 1	قَصْدِ التَّغْطِيَةِ
u'قَصْدٌ تَغَيُّبٌ':Added, #1: 1	قَصَدَ التَّغْلِيطَ
u'قَصَدَ تَغَيُّرٌ':Predicate, #1: 1	قَصْدُ التَّغَيُّبِ
u'قَصَدَ تَغْيِيرٌ':Predicate, #1: 1	قَصَدَ تَغَيُّرَ
u'قَصَدَ تَفْرِيطٌ':Predicate, #1: 1	قَصَدَ تَغْيِيرَ
u'قَصَدَ تَفْضِيلٌ':Predicate, #1: 1	قَصَدَ التَّفْرِيطَ
u'قَصَدَ تَفْهِيمٌ':Predicate, #1: 1	قَصَدَ تَفْضِيلَهُنَّ
u'قَصَدَ تَفْوِيضٌ':Predicate, #2: 2	قَصَدَ التَّفْهِيمَ
u'قَصَدَ تَقْديرٌ':Predicate, #1: 1	قَصَدَ تَفْوِيضَ
u'قَصَدَ تَقْديمٌ':Predicate, #1: 1	قَصَدَ التَّقْدِيرَ
u'قَصَدَ تَقَرُّبٌ':Predicate, #1: 1	قَصَدَ تَقْدِيمَ
u'قَصْدٌ تَقَرُّبٌ':Added, #6: 6	قَصَدَ التَّقَرُّبَ
u'قَصْدٌ تَقَرُّبٌ':Added, #14: 14	قَصْدِ التَّقَرُّبِ
u'قَصْدٌ تَقَرُّبٌ':Added, #1: 1	قَصْدَ التَّقَرُّبِ
u'قَصَدَ تَقْليلٌ':Predicate, #2: 2	قَصْدُ التَّقَرُّبِ
u'قَصْدٌ تَقْليلٌ':Added, #1: 1	قَصَدَ تَقْلِيلَ
u'قَصْدٌ تَقْيِيد':Added, #1: 1	قَصْدِ التَّقْلِيلِ
u'قَصْدٌ تَقْيِيد':Added, #1: 1	قَصْدِ التَّقْيِيدِ
u'قَصْدٌ تَكْثيرٌ':Added, #1: 1	قَصْدِ تَقْيِيدِ
u'قَصَدَ تَكْرارٌ':Predicate, #1: 1	قَصْدَ التّكْثِيرِ
u'قَصْدٌ تَكْرارٌ':Added, #1: 1	قَصَدَ التَّكْرَارَ
u'قَصَدَ تَكَرُّرٌ':Predicate, #1: 1	قَصْدِ تَكْرَارِ
u'قَصْدٌ تَكَلُّمٌ':Added, #3: 3	قَصَدَ تَكَرُّرَ
u'قَصْدٌ تَكْليفٌ':Added, #2: 2	قَصْدِ التَّكَلُّمِ
u'قَصْدٌ تَكْميلٌ':Added, #1: 1	قَصْدَ التَّكْلِيفِ
u'قَصْدٌ تَلَذُّذٌ':Added, #1: 1	قَصْدُ التَّكْمِيلِ
u'قَصَدَ تَلَفُّظٌ':Predicate, #1: 1	قَصْدِ تَلَذُّذٍ
u'قَصْدٌ تَلَفُّظٌ':Added, #1: 1	قَصَدَ التَّلَفُّظَ
u'قَصَدَ تَمْثيلٌ':Predicate, #1: 1	قَصْدُ التَّلَفُّظِ
u'قَصَدَ تَمَلُّك':Predicate, #1: 1	قَصَدَ التَّمْثِيلَ
u'قَصْدٌ تَمَلُّكٌ':Added, #2: 2	قَصَدَ التَّمَلُّكَ
u'قَصْدٌ تَمَلُّك':Added, #1: 1	قَصْدِ تَمَلُّكِهِ
u'قَصَدَ تَمْلِيكٌ':Subject, #8: 8	قَصْدِ التَّمَلُّكِ
u'قَصْدٌ تَمَوُّلٌ':Added, #1: 1	قَصَدَ تَمْلِيكُهُ
u'قَصَدَ تَنْبِيه':Predicate, #3: 3	قَصْدِ التَّمَوُّلِ
u'قَصْدٌ تَنْبِيه':Added, #3: 3	قَصَدَ التَّنْبِيهَ
u'قَصْدٌ تَنْبِيه':Added, #1: 1	قَصْدُ التَّنْبِيهِ
u'قَصَدَ تَنْجِيزٌ':Predicate, #3: 3	قَصْدِ التَّنْبِيهِ
u'قَصَدَ تَنْجِيزٌ':Predicate, #2: 2	قَصَدَ التَّنْجِيزَ
u'قَصَدَ تَنَحِّي':Predicate, #4: 4	قَصَدَ تَنْجِيزَ
u'قَصْدٌ تَنْظِيفٌ':Added, #1: 1	قَصَدَ التَّنَحِّيَ
u'قَصَدَ تَنَفُّلٌ':Predicate, #1: 1	قَصْدُ التَّنْظِيفِ
u'قَصَدَ تَنْفِيذٌ':Predicate, #1: 1	قَصَدَ التَّنَفُّلَ
u'قَصْدٌ تَنْوِيرٌ':Added, #2: 2	قَصَدَ تَنْفِيذَ
u'قَصْدٌ تَوْبَةٌ':Added, #3: 3	قَصْدِ التَّنْوِيرِ
u'قَصْدٌ تَوَدُّدٌ':Added, #1: 1	قَصْدِ التَّوْبَةِ
u'قَصْدٌ تَوْزِيعٌ':Added, #1: 1	قَصْد التَّوَدُّدِ
u'قَصَدَ تَوْسِعَة':Predicate, #1: 1	قَصْدِ التَّوْزِيعِ
u'قَصْدٌ تَوَطُّنٌ':Added, #1: 1	قَصَدَ التَّوْسِعَةَ
u'قَصَدَ تَوْكِيدٌ':Predicate, #1: 1	قَصْدِ التَّوَطُّنِ
u'قَصْدٌ تَوْكِيدٌ':Added, #1: 1	قَصَدَ التَّوْكِيدَ
u'قَصْدٌ تَوْكِيدٌ':Added, #1: 1	قَصْدِ التَّوْكِيدِ
u'قَصَدَ ثَلاثُ':Predicate, #1: 1	قَصْدِ تَوْكِيدٍ
u'قَصْدٌ ثَناءٌ':Added, #1: 1	قَصَدَ الثَّلَاثَ
u'قَصَدَ ثَوابٌ':Predicate, #9: 9	قَصْدِ الثَّنَاءِ
u'قَصْدٌ ثَوابٌ':Added, #1: 1	قَصَدَ الثَّوَابَ
u'قَصْدٌ ثَوابٌ':Added, #1: 1	قَصْدُ الثَّوَابِ
u'قَصْدٌ ثَوابٌ':Added, #4: 4	قَصْدِ ثَوَابِ
u'قَصَدَ جَبْرٌ':Predicate, #5: 5	قَصْدِ الثَّوَابِ
u'قَصَدَ جُثَّة':Predicate, #1: 1	قَصَدَ جَبْرَ
u'قَصْدٌ جَديدٌ':Added, #1: 1	قَصَدَ جُثَّةَ
u'قَصْدٌ جَرٌّ':Added, #1: 1	قَصْدٍ جَدِيدٍ
u'قَصَدَ جَرْيٌ':Predicate, #1: 1	قَصْدُ جَرٍّ
u'قَصَدَ جُلُوسٌ':Predicate, #1: 1	قَصَدَ الْجَرْيَ
u'قَصْدٌ جُلُوسٌ':Added, #1: 1	قَصَدَ الْجُلُوسَ
u'قَصَدَ جَمَاعَةٌ':Predicate, #2: 2	قَصْدَ الْجُلُوسِ
u'قَصْدٌ جَمَالٌ':Added, #1: 1	قَصَدَ الْجَمَاعَةَ
u'قَصْدٌ جَمْرَةٌ':Added, #1: 1	قَصْدِ الْجَمَالِ
u'قَصْدٌ جَمْرَة':Added, #1: 1	قَصْدُ الْجَمْرَةِ
u'قَصَدَ جمع':Predicate, #1: 1	قَصْدُ الْجَمْرَةِ
u'قَصَدَ جَمْعٌ':Predicate, #2: 2	قَصَدَ جَمْعَ
u'قَصْدٌ جمع':Added, #2: 2	قَصَدَ جَمْعَ
u'قَصْدٌ جَمْعٌ':Added, #1: 1	قَصْدَ الْجَمْعِ
u'قَصْدٌ جمع':Added, #1: 1	قَصْدَ الْجَمْعِ
u'قَصْدٌ جَمْعٌ':Added, #1: 1	قَصْدِ جَمْعِ
u'قَصْدٌ جمعة':Added, #1: 1	قَصْدِ جَمْعِ
u'قَصْدٌ جُمُعَةٌ':Added, #1: 1	قَصْدُ الْجُمُعَةِ
u'قَصْدٌ جَمِيع':Added, #1: 1	قَصْدُ الْجُمُعَةِ
u'قَصَدَ جِنَايَةٌ':Predicate, #1: 1	قَصْدُ الْجَمِيعِ
u'قَصْدٌ جِنَايَةٌ':Added, #1: 1	قَصَدَ الْجِنَايَةَ
u'قَصْدٌ جِنَايَةٌ':Added, #1: 1	قَصْدُ جِنَايَةٍ
u'قَصَدَ جهاد':Predicate, #3: 3	قَصْدِ الْجِنَايَةِ
u'قَصَدَ جِهَادٌ':Predicate, #2: 2	قَصَدَ الْجِهَادَ
u'قَصَدَ جهر':Predicate, #2: 2	قَصَدَ الْجِهَادَ
u'قَصَدَ جَهْرٌ':Predicate, #1: 1	قَصَدَ الْجَهْرَ
u'قَصَدَ جَوَابٌ':Predicate, #1: 1	قَصَدَ الْجَهْرَ
u'قَصْدٌ جَوَابٌ':Added, #1: 1	قَصَدَ الْجَوَابَ
u'قَصْدٌ جَوَابٌ':Added, #1: 1	قَصْدُ جَوَابِهِ
u'قَصَدَ حاضِرٌ':Subject, #3: 3	قَصْدِ الْجَوَابِ
u'قَصْدٌ حافِرٌ':Added, #1: 1	قَصَدَ الْحَاضِرُ
u'قَصَدَ حامِلٌ':Subject, #2: 2	قَصْدُ الْحَافِرِ
u'قَصْدٌ حَثّ':Added, #1: 1	قَصَدَ الْحَامِلُ
u'قَصَدَ حَجٌّ':Predicate, #2: 2	قَصْدِ الْحَثِّ
u'قَصَدَ حَجٌّ':Subject, #1: 1	قَصَدَ الْحَجَّ
u'قَصْدٌ حَجٌّ':Added, #1: 1	قَصَدَ الْحَجُّ
u'قَصْدٌ حَجٌّ':Added, #1: 1	قَصْدِ الْحَجِّ
u'قَصْدٌ حَجْرٌ':Added, #2: 2	قَصْدُ الْحَجِّ
u'قَصَدَ حَدٌّ':Predicate, #1: 1	قَصْدِ حَجْرِ
u'قَصْدٌ حَرامٌ':Added, #1: 1	قَصَدَ الْحَدَّ
u'قَصَدَ حِرْمَانٌ':Predicate, #1: 1	قَصْدِ الْحَرَامِ
u'قَصَدَ حِرْمَانٌ':Predicate, #1: 1	قَصَدَ حِرْمَانَهُنَّ
u'قَصْدٌ حِرْمَانٌ':Added, #2: 2	قَصَدَ حِرْمَانَ
u'قَصْدٌ حُروفٌ':Added, #1: 1	قَصْدَ حِرْمَانِ
u'قَصَدَ حَزّ':Predicate, #1: 1	قَصْدُ حُرُوفِ
u'قَصَدَ حِسْبَةٌ':Predicate, #1: 1	قَصَدَ الْحَزَّ
u'قَصْدٌ حَصْرٌ':Added, #1: 1	قَصَدَ الْحِسْبَةَ
u'قَصْدٌ حَصْرٌ':Added, #1: 1	قَصْدُ الْحَصْرِ
u'قَصْدٌ حَصْرٌ':Added, #1: 1	قَصْدِ الْحَصْرِ
u'قَصَدَ حِفْظٌ':Predicate, #1: 1	قَصْدِ حَصْرِ
u'قَصَدَ حِفْظٌ':Predicate, #1: 1	قَصَدَ حِفْظَ
u'قَصْدٌ حَفِيرَةٌ':Added, #2: 2	قَصَدَ الْحِفْظَ
u'قَصْدٌ حَقٌّ':Added, #1: 1	قَصْدِ الْحَفِيرَةِ
u'قَصَدَ حَقِيقٌ':Predicate, #1: 1	قَصْدِ الْحَقِّ
u'قَصْدٌ حَقِيقٌ':Added, #1: 1	قَصَدَ الْحَقِيقَةَ
u'قَصَدَ حَقِيقَةٌ':Predicate, #2: 2	قَصْدِ الْحَقِيقَةِ
u'قَصْدٌ حَقِيقَةٌ':Added, #1: 1	قَصَدَ الْحَقِيقَةَ
u'قَصَدَ حِكَايَةٌ':Predicate, #2: 2	قَصْدِ الْحَقِيقَةِ
u'قَصْدٌ حِكَايَةٌ':Added, #2: 2	قَصَدَ حِكَايَةَ
u'قَصْدٌ حكمة':Added, #1: 1	قَصْدِ الْحِكَايَةِ
u'قَصْدٌ حِكْمَةٌ':Added, #1: 1	قَصْدِ حِكْمَةٍ
u'قَصَدَ حِلٌّ':Predicate, #1: 1	قَصْدِ حِكْمَةٍ
u'قَصْدٌ حِلٌّ':Added, #1: 1	قَصَدَ حِلَّ
u'قَصْدٌ حَلاَوَةٌ':Added, #1: 1	قَصْدُ حِلِّ
u'قَصَدَ حَمْلٌ':Predicate, #1: 1	قَصْدِ الْحَلَاوَةِ
u'قَصَدَ حِنْثٌ':Predicate, #1: 1	قَصَدَ حَمْلَ
u'قَصْدٌ حِيلَةٌ':Added, #1: 1	قَصَدَ الْحِنْثَ
u'قَصْدٌ حِيلَةٌ':Added, #1: 1	قَصْدُ الْحِيلَةِ
u'قَصْدٌ خَارِجٌ':Added, #1: 1	قَصْدِ حِيلَةِ
u'قَصَدَ خُرُوجٌ':Predicate, #1: 1	قَصْدِ الْخَارِجِ
u'قَصْدٌ خُرُوجٌ':Added, #2: 2	قَصَدَ الْخُرُوجَ
u'قَصْدٌ خَصْمٌ':Added, #1: 1	قَصْدَ الْخُرُوجِ
u'قَصَدَ خِطَابٌ':Predicate, #1: 1	قَصْدِ خَصْمِهِ
u'قَصْدٌ خِطَابٌ':Added, #1: 1	قَصَدَ خِطَابَ
u'قَصْدٌ خِطَابٌ':Added, #1: 1	قَصْدِ الْخِطَابِ
u'قَصْدٌ خِطَابٌ':Added, #1: 1	قَصْدَ خِطَابِ
u'قَصْدٌ خطبة':Added, #2: 2	قَصْدَ الْخِطَابِ
u'قَصْدٌ خُطْبَةٌ':Added, #5: 5	قَصْدِ الْخُطْبَةِ
u'قَصَدَ خِلاَفٌ':Predicate, #5: 5	قَصْدِ الْخُطْبَةِ
u'قَصْدٌ خُلْعٌ':Added, #1: 1	قَصَدَ خِلَافَ
u'قَصْدٌ خُلْعٌ':Added, #1: 1	قَصْدُ الْخُلْعِ
u'قَصْدٌ خَلِيٌّ':Added, #3: 3	قَصْدِ الْخُلْعِ
u'قَصْدٌ خَلِيَّةٌ':Added, #1: 1	قَصْدُ الْخَلِيَّةِ
u'قَصْدٌ خَمْرِيٌّ':Added, #1: 1	قَصْدُ الْخَلِيَّةِ
u'قَصْدٌ خَمْرِيٌّ':Added, #1: 1	قَصْدُ الْخَمْرِيَّةِ
u'قَصَدَ خِيَاطَةٌ':Predicate, #1: 1	قَصْدِ الْخَمْرِيَّةِ
u'قَصْدٌ خِيَانَةٌ':Added, #1: 1	قَصَدَ الْخِيَاطَةَ
u'قَصْدٌ خِيَانَةٌ':Added, #1: 1	قَصْدُ الْخِيَانَةِ
u'قَصْدٌ خَيْرٌ':Added, #1: 1	قَصْدَ خِيَانَةٍ
u'قَصْدٌ دَافِعٌ':Added, #1: 1	قَصْدُ الْخَيْرِ
u'قَصَدَ دُخُولٌ':Predicate, #2: 2	قَصْدِ الدَّافِعِ
u'قَصْدٌ دُخُولٌ':Added, #4: 4	قَصَدَ دُخُولَ
u'قَصْدٌ دَرٌّ':Added, #3: 3	قَصْدِ دُخُولِ
u'قَصْدٌ دُعَاءٌ':Added, #1: 1	قَصْدِ الدَّرِّ
u'قَصَدَ دفع':Predicate, #3: 3	قَصْدِ الدُّعَاءِ
u'قَصَدَ دَفْعٌ':Predicate, #2: 2	قَصَدَ الدَّفْعَ
u'قَصَدَ دفع':Predicate, #2: 2	قَصَدَ الدَّفْعَ
u'قَصَدَ دَفْعٌ':Predicate, #2: 2	قَصَدَ دَفْعَ
u'قَصَدَ دَلالَةٌ':Predicate, #2: 2	قَصَدَ دَفْعَ
u'قَصْدٌ دَوامٌ':Added, #1: 1	قَصَدَ الدَّلَالَةَ
u'قَصْدٌ دِينِيٌّ':Added, #1: 1	قَصْدِ الدَّوَامِ
u'قَصْدٌ ذَكاةٌ':Added, #1: 1	قَصْدَ الدِّينِيِّ
u'قَصَدَ ذكر':Predicate, #1: 1	قَصْدِ الذَّكَاةِ
u'قَصَدَ ذِكْرٌ':Predicate, #1: 1	قَصَدَ الذِّكْرَ
u'قَصَدَ ذكر':Predicate, #1: 1	قَصَدَ الذِّكْرَ
u'قَصَدَ ذِكْرٌ':Predicate, #1: 1	قَصَدَ ذِكْرَ
u'قَصْدٌ ذكر':Added, #1: 1	قَصَدَ ذِكْرَ
u'قَصْدٌ ذِكْرٌ':Added, #1: 1	قَصْدِ الذِّكْرِ
u'قَصَدَ ذَمٌّ':Predicate, #1: 1	قَصْدِ الذِّكْرِ
u'قَصَدَ رَبُّ':Subject, #1: 1	قَصَدَ ذَمَّ
u'قَصْدٌ رِبْحٌ':Added, #2: 2	قَصَدَ رَبُّ
u'قَصْدٌ رجعة':Added, #3: 3	قَصْدِ الرِّبْحِ
u'قَصْدٌ رَجْعَةٌ':Added, #1: 1	قَصْدِ الرَّجْعَةِ
u'قَصْدٌ رَجُلٌ':Added, #1: 1	قَصْدِ الرَّجْعَةِ
u'قَصَدَ رُجُوعٌ':Predicate, #2: 2	قَصْدُ الرَّجُلِ
u'قَصْدٌ رُجُوعٌ':Added, #2: 2	قَصَدَ الرُّجُوعَ
u'قَصْدٌ رُجُوعٌ':Added, #1: 1	قَصْدُ الرُّجُوعِ
u'قَصْدٌ رحمة':Added, #6: 6	قَصْدِ الرُّجُوعِ
u'قَصْدٌ رَحْمَةٌ':Added, #1: 1	قَصْدُ رَحْمَةِ
u'قَصَدَ رَدٌّ':Predicate, #1: 1	قَصْدُ رَحْمَةِ
u'قَصَدَ رَدٌّ':Predicate, #2: 2	قَصَدَ رَدَّ
u'قَصْدٌ رَدٌّ':Added, #3: 3	قَصَدَ الرَّدَّ
u'قَصْدٌ رَدٌّ':Added, #1: 1	قَصْدُ الرَّدِّ
u'قَصْدٌ رَدٌّ':Added, #1: 1	قَصْدَ رَدِّ
u'قَصْدٌ رَسُولٌ':Added, #4: 4	قَصْدِ الرَّدِّ
u'قَصْدٌ رِضْوان':Added, #1: 1	قَصْدُ الرَّسُولِ
u'قَصْدٌ رِضْوان':Added, #1: 1	قَصْدَ الرِّضْوَانِ
u'قَصْدٌ رَفْضٌ':Added, #1: 1	قَصْدِ الرِّضْوَانِ
u'قَصْدٌ رَفْضٌ':Added, #1: 1	قَصْدِ رَفْضِ
u'قَصَدَ رَفْعٌ':Predicate, #2: 2	قَصْدِ الرَّفْضِ
u'قَصْدٌ رَفْعٌ':Added, #3: 3	قَصَدَ رَفْعَ
u'قَصَدَ رِفْقٌ':Predicate, #2: 2	قَصْدُ رَفْعِ
u'قَصَدَ رِفْقٌ':Predicate, #1: 1	قَصَدَ رِفْقَ
u'قَصْدٌ رَقيقٌ':Added, #2: 2	قَصَدَ الرِّفْقَ
u'قَصْدٌ رَقيق':Added, #1: 1	قَصْدَ الرَّقِيقِ
u'قَصَدَ رُكوبٌ':Predicate, #1: 1	قَصْدَ الرَّقِيقِ
u'قَصَدَ رَمْيٌ':Predicate, #1: 1	قَصَدَ الرُّكُوبَ
u'قَصْدٌ رَمْيٌ':Added, #4: 4	قَصَدَ الرَّمْيَ
u'قَصَدَ رِوايَةٌ':Predicate, #1: 1	قَصْدِ الرَّمْيِ
u'قَصَدَ رَوْضَةٌ':Predicate, #1: 1	قَصَدَ رِوَايَةَ
u'قَصْدٌ زَجْرٌ':Added, #1: 1	قَصَدَ الرَّوْضَةَ
u'قَصْدٌ زَجْرٌ':Added, #1: 1	قَصْدَ الزَّجْرِ
u'قَصَدَ زَوْجٌ':Subject, #1: 1	قَصْدِ زَجْرِهِ
u'قَصْدٌ زَوْجٌ':Added, #3: 3	قَصَدَ الزَّوْجُ
u'قَصَدَ زَوْجَةٌ':Predicate, #1: 1	قَصْدُ الزَّوْجِ
u'قَصْدٌ زَوْجَةٌ':Added, #1: 1	قَصَدَ الزَّوْجَةَ
u'قَصْدٌ زِيادَةٌ':Added, #1: 1	قَصْدِ الزَّوْجَةِ
u'قَصْدٌ زِيادَةٌ':Added, #1: 1	قَصْدِ الزِّيَادَةِ
u'قَصَدَ زِيارَةٌ':Predicate, #2: 2	قَصْدِ زِيَادَةٍ
u'قَصْدٌ زِينَةٌ':Added, #1: 1	قَصَدَ زِيَارَةَ
u'قَصْدٌ سَاحِرٌ':Added, #1: 1	قَصْدِ الزِّينَةِ
u'قَصَدَ سَبَبٌ':Predicate, #1: 1	قَصْدُ السَّاحِرِ
u'قَصْدٌ سَبِيلٌ':Added, #2: 2	قَصَدَ السَّبَبَ
u'قَصَدَ سَتْرٌ':Predicate, #4: 4	قَصْدُ السَّبِيلِ
u'قَصْدٌ سَتْرٌ':Added, #1: 1	قَصَدَ سَتْرَ
u'قَصَدَ سجدة':Predicate, #1: 1	قَصْدَ السَّتْرِ
u'قَصَدَ سَجْدَةٌ':Predicate, #1: 1	قَصَدَ السَّجْدَةَ
u'قَصَدَ سَرقَةٌ':Predicate, #1: 1	قَصَدَ السَّجْدَةَ
u'قَصَدَ سَرِقَةٌ':Predicate, #2: 2	قَصَدَ سَرِقَةَ
u'قَصَدَ سَفَرٌ':Predicate, #2: 2	قَصَدَ سَرِقَةَ
u'قَصْدٌ سَفَرٌ':Added, #1: 1	قَصَدَ السَّفَرَ
u'قَصَدَ سَقَّاءٌ':Subject, #4: 4	قَصْدِ السَّفَرِ
u'قَصْدٌ سكر':Added, #2: 2	قَصَدَ السَّقَّاءُ
u'قَصْدٌ سُكْرٌ':Added, #1: 1	قَصْدِ السُّكْرِ
u'قَصْدٌ سَلْبٌ':Added, #1: 1	قَصْدِ السُّكْرِ
u'قَصَدَ سُلْطَانٌ':Subject, #1: 1	قَصْدَ السَّلْبِ
u'قَصَدَ سَمَاعٌ':Predicate, #1: 1	قَصَدَ السُّلْطَانُ
u'قَصْدٌ سُنَّةٌ':Added, #5: 5	قَصَدَ سَمَاعَ
u'قَصْدٌ سَيْرٌ':Added, #2: 2	قَصْدِ السُّنَّةِ
u'قَصَدَ شَارِعٌ':Subject, #1: 1	قَصْدِ سَيْرِ
u'قَصْدٌ شَارِعٌ':Added, #3: 3	قَصَدَ الشَّارِعُ
u'قَصْدٌ شَارِعٌ':Added, #2: 2	قَصْدُ الشَّارِعِ
u'قَصْدٌ شَارِعٌ':Added, #3: 3	قَصْدَ الشَّارِعِ
u'قَصَدَ شافِعِيّ':Subject, #5: 5	قَصْدِ الشَّارِعِ
u'قَصَدَ شَاهِدٌ':Subject, #1: 1	قَصَدَ الشَّافِعِيُّ
u'قَصْدٌ شَخْصٌ':Added, #2: 2	قَصَدَ الشَّاهِدُ
u'قَصْدٌ شَخْصٌ':Added, #1: 1	قَصْدِ شَخْصٍ
u'قَصَدَ شَرْعٌ':Subject, #2: 2	قَصْدِ الشَّخْصِ
u'قَصْدٌ شرف':Added, #1: 1	قَصَدَ الشَّرْعُ
u'قَصْدٌ شَرَفٌ':Added, #1: 1	قَصْدِ الشَّرَفِ
u'قَصَدَ شركة':Predicate, #1: 1	قَصْدِ الشَّرَفِ
u'قَصَدَ شِرْكَةٌ':Predicate, #3: 3	قَصَدَ الشِّرْكَةَ
u'قَصَدَ شُرُوعٌ':Predicate, #3: 3	قَصَدَ الشِّرْكَةَ
u'قَصْدٌ شَرِيعَةٌ':Added, #3: 3	قَصَدَ الشُّرُوعَ
u'قَصْدٌ شَعْرٌ':Added, #2: 2	قَصْدَ الشَّرِيعَةِ
u'قَصْدٌ شِعْرٌ':Added, #1: 1	قَصْدَ الشّعْرِ
u'قَصَدَ شكر':Predicate, #1: 1	قَصْدَ الشّعْرِ
u'قَصَدَ شُكْرٌ':Predicate, #3: 3	قَصَدَ الشُّكْرَ
u'قَصَدَ شَمٌّ':Predicate, #3: 3	قَصَدَ الشُّكْرَ
u'قَصَدَ شَمٌّ':Predicate, #1: 1	قَصَدَ الشَّمَّ
u'قَصْدٌ شهرة':Added, #2: 2	قَصَدَ شَمَّ
u'قَصْدٌ شُهْرَةٌ':Added, #1: 1	قَصْدِ الشُّهْرَةِ
u'قَصْدٌ شَيْءٌ':Added, #1: 1	قَصْدِ الشُّهْرَةِ
u'قَصْدٌ شَيْءٌ':Added, #1: 1	قَصْدِ شَيْءٍ
u'قَصْدٌ شَيْءٌ':Added, #2: 2	قَصْدُ الشَّيْءِ
u'قَصَدَ شَيْخٌ':Subject, #2: 2	قَصْدُ شَيْءٍ
u'قَصْدٌ صَاحِبٌ':Added, #1: 1	قَصَدَ الشَّيْخُ
u'قَصْدٌ صَاحِبٌ':Added, #1: 1	قَصْدَ صَاحِبِ
u'قَصْدٌ صَاحِبٌ':Added, #1: 1	قَصْدَ صَاحِبِهِ
u'قَصَدَ صِحَّةٌ':Predicate, #1: 1	قَصْدِ صَاحِبِهِ
u'قَصْدٌ صِحَّةٌ':Added, #2: 2	قَصَدَ صِحَّةَ
u'قَصَدَ صداق':Predicate, #1: 1	قَصْدِ الصِّحَّةِ
u'قَصَدَ صَدَاقٌ':Predicate, #1: 1	قَصَدَ الصَّدَاقَ
u'قَصَدَ صَرْفٌ':Predicate, #1: 1	قَصَدَ الصَّدَاقَ
u'قَصَدَ صَرْف':Predicate, #1: 1	قَصَدَ صَرْفَ
u'قَصْدٌ صَرْفٌ':Added, #1: 1	قَصَدَ صَرْفَ
u'قَصْدٌ صَرْف':Added, #1: 1	قَصْدِ الصَّرْفِ
u'قَصْدٌ صَرِيحٌ':Added, #1: 1	قَصْدِ الصَّرْفِ
u'قَصْدٌ صَعِيدٌ':Added, #1: 1	قَصْدُ الصَّرِيحِ
u'قَصْدٌ صَعِيدٌ':Added, #1: 1	قَصْدُ الصَّعِيدِ
u'قَصْدٌ صَلاَةٌ':Added, #1: 1	قَصْدِ الصَّعِيدِ
u'قَصَدَ صَوْمٌ':Predicate, #3: 3	قَصْدِ الصَّلَاةِ
u'قَصْدٌ صَوْمٌ':Added, #1: 1	قَصَدَ الصَّوْمَ
u'قَصْدٌ صَوْمٌ':Added, #1: 1	قَصْدَ الصَّوْمِ
u'قَصَدَ صِيَانَةٌ':Predicate, #1: 1	قَصْدَ صَوْمِ
u'قَصْدٌ صَيْدٌ':Added, #1: 1	قَصَدَ الصِّيَانَةَ
u'قَصْدٌ صَيْدٌ':Added, #1: 1	قَصْدِ الصَّيْدِ
u'قَصَدَ ضَارِبٌ':Subject, #1: 1	قَصْدِ صَيْدِ
u'قَصَدَ ضَرْبٌ':Predicate, #1: 1	قَصَدَ الضَّارِبُ
u'قَصَدَ ضَرْبٌ':Predicate, #1: 1	قَصَدَ الضَّرْبَ
u'قَصْدٌ ضَرَرٌ':Added, #3: 3	قَصَدَ ضَرْبَ
u'قَصْدٌ ضَرَرٌ':Added, #1: 1	قَصْدُ الضَّرَرِ
u'قَصَدَ ضَمَانٌ':Predicate, #3: 3	قَصْدِ الضَّرَرِ
u'قَصَدَ طَاعَةٌ':Predicate, #1: 1	قَصَدَ ضَمَانَ
u'قَصْدٌ طَاعَةٌ':Added, #2: 2	قَصَدَ الطَّاعَةَ
u'قَصْدٌ طَاعَةٌ':Added, #1: 1	قَصْدُ الطَّاعَةِ
u'قَصْدٌ طَالِبٌ':Added, #1: 1	قَصْدِ طَاعَةِ
u'قَصَدَ طَلاَقٌ':Predicate, #1: 1	قَصْدِ الطَّالِبِ
u'قَصْدٌ طَلاَقٌ':Added, #2: 2	قَصَدَ الطَّلَاقَ
u'قَصْدٌ طَلاَقٌ':Added, #2: 2	قَصْدَ الطَّلَاقِ
u'قَصْدٌ طَلاَقٌ':Added, #2: 2	قَصْدِ الطَّلَاقِ
u'قَصَدَ ظَرْفٌ':Predicate, #3: 3	قَصْدُ الطَّلَاقِ
u'قَصَدَ ظهار':Predicate, #2: 2	قَصَدَ الظَّرْفَ
u'قَصَدَ عَاقِدٌ':Subject, #3: 3	قَصَدَ الظِّهَارَ
u'قَصْدٌ عِبَادَةٌ':Added, #1: 1	قَصَدَ الْعَاقِدُ
u'قَصَدَ عَبْدٌ':Predicate, #1: 1	قَصْدِ الْعِبَادَةِ
u'قَصَدَ عَبْدٌ':Subject, #1: 1	قَصَدَ الْعَبْدَ
u'قَصَدَ عتق':Predicate, #1: 1	قَصَدَ الْعَبْدُ
u'قَصَدَ عِتْقٌ':Predicate, #2: 2	قَصَدَ الْعِتْقَ
u'قَصْدٌ عَدَدٌ':Added, #2: 2	قَصَدَ الْعِتْقَ
u'قَصْدٌ عَدَدٌ':Added, #1: 1	قَصْدِ الْعَدَدِ
u'قَصَدَ عَدَمٌ':Predicate, #1: 1	قَصْدِ عَدَدٍ
u'قَصْدٌ عَدَمٌ':Added, #1: 1	قَصَدَ عَدَمَ
u'قَصْدٌ عَدَمٌ':Added, #1: 1	قَصْدُ عَدَمِ
u'قَصَدَ عَدُوٌّ':Predicate, #1: 1	قَصْدِ عَدَمِ
u'قَصْدٌ عَدُوٌّ':Added, #2: 2	قَصَدَ الْعَدُوَّ
u'قَصْدٌ عَدُوٌّ':Added, #1: 1	قَصْدَ الْعَدُوِّ
u'قَصَدَ عرفة':Predicate, #1: 1	قَصْدِ الْعَدُوِّ
u'قَصْدٌ عُضْوٌ':Added, #1: 1	قَصَدَ عَرَفَةَ
u'قَصْدٌ عَفْوٌ':Added, #1: 1	قَصْدُ عُضْوٍ
u'قَصْدٌ علم':Added, #1: 1	قَصْدِ الْعَفْوِ
u'قَصْدٌ عَلَمٌ':Added, #1: 1	قَصْدَ الْعَلَمِ
u'قَصَدَ عُمَرٌ':Subject, #1: 1	قَصْدَ الْعَلَمِ
u'قَصْدٌ عَمَلٌ':Added, #1: 1	قَصَدَ عُمَرُ
u'قَصَدَ عُمُومٌ':Predicate, #1: 1	قَصْدِ الْعَمَلِ
u'قَصَدَ عُمُومٌ':Predicate, #1: 1	قَصَدَ الْعُمُومَ
u'قَصْدٌ عُمُومٌ':Added, #1: 1	قَصَدَ عُمُومَ
u'قَصْدٌ عُمُومٌ':Added, #1: 1	قَصْدُ الْعُمُومِ
u'قَصْدٌ عناد':Added, #3: 3	قَصْدِ الْعُمُومِ
u'قَصْدٌ عِنَادٌ':Added, #1: 1	قَصْدِ عِنَادٍ
u'قَصَدَ عند':Predicate, #1: 1	قَصْدِ عِنَادٍ
u'قَصْدٌ عَوْدٌ':Added, #2: 2	قَصَدَ عِنْدَ
u'قَصَدَ عِوَض':Predicate, #1: 1	قَصْدُ الْعَوْدِ
u'قَصْدٌ عِوَض':Added, #1: 1	قَصَدَ الْعِوَضِيَّةَ
u'قَصْدٌ عِوَضٌ':Added, #1: 1	قَصْدِ الْعِوَضِيَّةِ
u'قَصْدٌ عين':Added, #2: 2	قَصْدِ الْعِوَضِ
u'قَصْدٌ عين':Added, #1: 1	قَصْدَ الْعَيْنِ
u'قَصْدٌ عَيْنٌ':Added, #1: 1	قَصْدِ الْعَيْنِ
u'قَصْدٌ عَيْنٌ':Added, #1: 1	قَصْدَ الْعَيْنِ
u'قَصْدٌ عَيْن':Added, #1: 1	قَصْدِ الْعَيْنِ
u'قَصْدٌ عَيْن':Added, #1: 1	قَصْدَ الْعَيْنِ
u'قَصْدٌ عين':Added, #1: 1	قَصْدِ الْعَيْنِ
u'قَصْدٌ عَيْنٌ':Added, #1: 1	قَصْدُ عَيْنِ
u'قَصْدٌ عَيْن':Added, #1: 1	قَصْدُ عَيْنِ
u'قَصْدٌ عين':Added, #1: 1	قَصْدُ عَيْنِ
u'قَصْدٌ عين':Added, #1: 1	قَصْدُ عَيْنِهِ
u'قَصْدٌ عَيْنٌ':Added, #1: 1	قَصْدِ عَيْنِهِ
u'قَصْدٌ عَيْنٌ':Added, #1: 1	قَصْدُ عَيْنِهِ
u'قَصْدٌ عَيْن':Added, #1: 1	قَصْدِ عَيْنِهِ
u'قَصْدٌ عَيْن':Added, #1: 1	قَصْدُ عَيْنِهِ
u'قَصَدَ غَافِلٌ':Subject, #1: 1	قَصْدِ عَيْنِهِ
u'قَصْدٌ غَايَةٌ':Added, #1: 1	قَصَدَ الْغَافِلُ
u'قَصْدٌ غَايَةٌ':Added, #1: 1	قَصْدَ الْغَايَةِ
u'قَصَدَ غَزْوٌ':Predicate, #1: 1	قَصْدِ الْغَايَةِ
u'قَصَدَ غير':Predicate, #1: 1	قَصَدَ الْغَزْوَ
u'قَصَدَ غَيْرٌ':Predicate, #6: 6	قَصَدَ غَيْرَ
u'قَصْدٌ غير':Added, #6: 6	قَصَدَ غَيْرَ
u'قَصْدٌ غَيْرٌ':Added, #1: 1	قَصْدَ غَيْرِ
u'قَصْدٌ غير':Added, #1: 1	قَصْدَ غَيْرِ
u'قَصْدٌ غير':Added, #1: 1	قَصْدُ غَيْرِهِ
u'قَصْدٌ غَيْرٌ':Added, #1: 1	قَصْدِ غَيْرِهِ
u'قَصْدٌ غَيْرٌ':Added, #1: 1	قَصْدُ غَيْرِهِ
u'قَصْدٌ فَاسِدٌ':Added, #1: 1	قَصْدِ غَيْرِهِ
u'قَصْدٌ فَاعِلٌ':Added, #1: 1	قَصْدٍ فَاسِدٍ
u'قَصَدَ فَتْحٌ':Predicate, #4: 4	قَصْدُ فَاعِلِهِ
u'قَصْدٌ فَتْحٌ':Added, #1: 1	قَصَدَ الْفَتْحَ
u'قَصَدَ فرار':Predicate, #1: 1	قَصْدِ الْفَتْحِ
u'قَصَدَ فِرَارٌ':Predicate, #7: 7	قَصَدَ الْفِرَارَ
u'قَصْدٌ فرار':Added, #7: 7	قَصَدَ الْفِرَارَ
u'قَصْدٌ فِرَارٌ':Added, #1: 1	قَصْدِ الْفِرَارِ
u'قَصْدٌ فرار':Added, #1: 1	قَصْدِ الْفِرَارِ
u'قَصْدٌ فِرَارٌ':Added, #3: 3	قَصْدُ الْفِرَارِ
u'قَصْدٌ فِرَاقٌ':Added, #3: 3	قَصْدُ الْفِرَارِ
u'قَصَدَ فرح':Predicate, #1: 1	قَصْدُ الْفِرَاقِ
u'قَصَدَ فَرَحٌ':Predicate, #1: 1	قَصَدَ الْفَرَحَ
u'قَصَدَ فرق':Predicate, #1: 1	قَصَدَ الْفَرَحَ
u'قَصَدَ فَرْقٌ':Predicate, #1: 1	قَصَدَ الْفَرْقَ
u'قَصَدَ فَرِيقٌ':Subject, #1: 1	قَصَدَ الْفَرْقَ
u'قَصْدٌ فساد':Added, #1: 1	قَصَدَ الْفَرِيقُ
u'قَصْدٌ فساد':Added, #1: 1	قَصْدَ الْفَسَادِ
u'قَصْدٌ فَسَادٌ':Added, #1: 1	قَصْدُ الْفَسَادِ
u'قَصْدٌ فَسَادٌ':Added, #1: 1	قَصْدَ الْفَسَادِ
u'قَصْدٌ فساد':Added, #1: 1	قَصْدُ الْفَسَادِ
u'قَصْدٌ فَسَادٌ':Added, #6: 6	قَصْدِ الْفَسَادِ
u'قَصَدَ فَسْخٌ':Predicate, #6: 6	قَصْدِ الْفَسَادِ
u'قَصَدَ فَصْلٌ':Predicate, #1: 1	قَصَدَ الْفَسْخَ
u'قَصَدَ فِعْلٌ':Predicate, #1: 1	قَصَدَ فَصْلَ
u'قَصَدَ فِعْلٌ':Predicate, #1: 1	قَصَدَ الْفِعْلَ
u'قَصْدٌ فِعْلٌ':Added, #2: 2	قَصَدَ فِعْلَ
u'قَصْدٌ فِعْلٌ':Added, #2: 2	قَصْدِ فِعْلِ
u'قَصْدٌ فِعْلٌ':Added, #3: 3	قَصْدُ الْفِعْلِ
u'قَصَدَ فلان':Predicate, #6: 6	قَصْدِ الْفِعْلِ
u'قَصَدَ فلان':Subject, #8: 8	قَصَدَ مَكَّةَ
u'قَصَدَ فلان':Subject, #1: 1	قَصَدَ الشَّافِعِيُّ
u'قَصْدٌ فلان':Added, #1: 1	قَصَدَ الْمُتَصَدِّقُ
u'قَصْدٌ فلان':Added, #1: 1	قَصْدَ الرِّضْوَانِ
u'قَصْدٌ فلان':Added, #1: 1	قَصْدِ الرِّضْوَانِ
u'قَصْدٌ فُؤَادٌ':Added, #1: 1	قَصْدَ الْمُتَصَدِّقِ
u'قَصَدَ قَادِرٌ':Subject, #1: 1	قَصْدُ الْفُؤَادِ
u'قَصْدٌ قُبُورٌ':Added, #1: 1	قَصَدَ الْقَادِرُ
u'قَصْدٌ قَبِيحٌ':Added, #2: 2	قَصْدُ الْقُبُورِ
u'قَصْدٌ قتال':Added, #1: 1	قَصْدُ الْقَبِيحِ
u'قَصْدٌ قِتَالٌ':Added, #6: 6	قَصْدِ الْقِتَالِ
u'قَصَدَ قتل':Predicate, #6: 6	قَصْدِ الْقِتَالِ
u'قَصَدَ قَتْلٌ':Predicate, #3: 3	قَصَدَ قَتْلَ
u'قَصْدٌ قتل':Added, #3: 3	قَصَدَ قَتْلَ
u'قَصْدٌ قَتْلٌ':Added, #1: 1	قَصْدُ قَتْلِهِ
u'قَصْدٌ قتل':Added, #1: 1	قَصْدُ قَتْلِهِ
u'قَصْدٌ قَتْلٌ':Added, #2: 2	قَصْدِ الْقَتْلِ
u'قَصْدٌ قتل':Added, #2: 2	قَصْدِ الْقَتْلِ
u'قَصْدٌ قَتْلٌ':Added, #3: 3	قَصْدُ الْقَتْلِ
u'قَصَدَ قِرَاءةٌ':Predicate, #3: 3	قَصْدُ الْقَتْلِ
u'قَصَدَ قِرَاءةٌ':Predicate, #1: 1	قَصَدَ قِرَاءَةَ
u'قَصْدٌ قِرَاءةٌ':Added, #4: 4	قَصَدَ الْقِرَاءَةَ
u'قَصْدٌ قِرَاءةٌ':Added, #1: 1	قَصْدَ الْقِرَاءَةِ
u'قَصْدٌ قِرَاءةٌ':Added, #3: 3	قَصْدُ الْقِرَاءَةِ
u'قَصْدٌ قِرَاءةٌ':Added, #3: 3	قَصْدِ الْقِرَاءَةِ
u'قَصَدَ قُرْآنٌ':Predicate, #3: 3	قَصْدِ قِرَاءَةِ
u'قَصْدٌ قُرْآنٌ':Added, #3: 3	قَصَدَ الْقُرْآنَ
u'قَصْدٌ قُرْآنٌ':Added, #2: 2	قَصْدُ الْقُرْآنِ
u'قَصَدَ قُرْبَةٌ':Predicate, #4: 4	قَصْدِ الْقُرْآنِ
u'قَصْدٌ قُرْبَةٌ':Added, #4: 4	قَصَدَ الْقُرْبَةَ
u'قَصْدٌ قُرْبَةٌ':Added, #12: 12	قَصْدُ الْقُرْبَةِ
u'قَصْدٌ قُرْبَةٌ':Added, #1: 1	قَصْدَ الْقُرْبَةِ
u'قَصْدٌ قُرْبَةٌ':Added, #1: 1	قَصْدِ قُرْبَةٍ
u'قَصْدٌ قَصْرٌ':Added, #8: 8	قَصْدِ الْقُرْبَةِ
u'قَصَدَ قَضَاءٌ':Predicate, #1: 1	قَصْدُ الْقَصْرِ
u'قَصَدَ قَطْعٌ':Predicate, #1: 1	قَصَدَ قَضَاءَ
u'قَصَدَ قَطْعٌ':Predicate, #1: 1	قَصَدَ الْقَطْعَ
u'قَصْدٌ قَطْعٌ':Added, #4: 4	قَصَدَ قَطْعَ
u'قَصْدٌ قَطْعٌ':Added, #1: 1	قَصْدِ الْقَطْعِ
u'قَصْدٌ قلب':Added, #2: 2	قَصْدُ قَطْعِ
u'قَصْدٌ قلب':Added, #1: 1	قَصْدُ الْقَلْبِ
u'قَصْدٌ قَلْبٌ':Added, #1: 1	قَصْدِ الْقَلْبِ
u'قَصْدٌ قَلْبٌ':Added, #1: 1	قَصْدُ الْقَلْبِ
u'قَصْدٌ قَلْب':Added, #1: 1	قَصْدِ الْقَلْبِ
u'قَصْدٌ قَلْب':Added, #1: 1	قَصْدُ الْقَلْبِ
u'قَصْدٌ قَوَد':Added, #1: 1	قَصْدِ الْقَلْبِ
u'قَصْدٌ قول':Added, #2: 2	قَصْدَ الْقَوَدِ
u'قَصْدٌ قَوْلٌ':Added, #1: 1	قَصْدِ قَوْلِ
u'قَصَدَ قيام':Predicate, #1: 1	قَصْدِ قَوْلِ
u'قَصَدَ قِيَامٌ':Predicate, #1: 1	قَصَدَ الْقِيَامَ
u'قَصْدٌ كبر':Added, #1: 1	قَصَدَ الْقِيَامَ
u'قَصْدٌ كِبْرٌ':Added, #2: 2	قَصْدِ الْكِبْرِ
u'قَصْدٌ كِتَابَةٌ':Added, #2: 2	قَصْدِ الْكِبْرِ
u'قَصَدَ كِتْمَانٌ':Predicate, #1: 1	قَصْدِ كِتَابَةِ
u'قَصَدَ كَثْرَةٌ':Predicate, #1: 1	قَصَدَ الْكِتْمَانَ
u'قَصَدَ كذب':Predicate, #1: 1	قَصَدَ الْكَثْرَةَ
u'قَصَدَ كَذِبٌ':Predicate, #2: 2	قَصَدَ الْكَذِبَ
u'قَصْدٌ كَرَامَةٌ':Added, #2: 2	قَصَدَ الْكَذِبَ
u'قَصَدَ كعبة':Predicate, #1: 1	قَصْدَ الْكَرَامَةِ
u'قَصَدَ كَعْبَةٌ':Predicate, #1: 1	قَصَدَ الْكَعْبَةَ
u'قَصْدٌ كعبة':Added, #1: 1	قَصَدَ الْكَعْبَةَ
u'قَصْدٌ كَعْبَةٌ':Added, #2: 2	قَصْدُ الْكَعْبَةِ
u'قَصَدَ كَفَّارٌ':Predicate, #2: 2	قَصْدُ الْكَعْبَةِ
u'قَصَدَ كُفَّارٌ':Subject, #1: 1	قَصَدَ الْكَفَّارَةَ
u'قَصَدَ كَفَّارَةٌ':Predicate, #1: 1	قَصَدَ الْكُفَّارُ
u'قَصَدَ كفر':Predicate, #1: 1	قَصَدَ الْكَفَّارَةَ
u'قَصَدَ كُفْرٌ':Predicate, #2: 2	قَصَدَ الْكُفْرَ
u'قَصْدٌ كَنْزٌ':Added, #2: 2	قَصَدَ الْكُفْرَ
u'قَصْدٌ لبس':Added, #1: 1	قَصْدُ كَنْزِهِ
u'قَصْدٌ لُبْسٌ':Added, #1: 1	قَصْدِ اللُّبْسِ
u'قَصْدٌ لبن':Added, #1: 1	قَصْدِ اللُّبْسِ
u'قَصْدٌ لَبَنٌ':Added, #2: 2	قَصْدِ اللَّبَنِ
u'قَصْدٌ لَحْمٌ':Added, #2: 2	قَصْدِ اللَّبَنِ
u'قَصَدَ لَذَّةٌ':Predicate, #2: 2	قَصْدُ اللَّحْمِ
u'قَصْدٌ لَذَّةٌ':Added, #1: 1	قَصَدَ اللَّذَّةَ
u'قَصْدٌ لَذَّةٌ':Added, #10: 10	قَصْدِ اللَّذَّةِ
u'قَصَدَ لُزُومٌ':Predicate, #1: 1	قَصْدِ لَذَّةٍ
u'قَصَدَ لعب':Predicate, #3: 3	قَصَدَ لُزُومَ
u'قَصَدَ لَعِبٌ':Predicate, #1: 1	قَصَدَ اللَّعِبَ
u'قَصْدٌ لعب':Added, #1: 1	قَصَدَ اللَّعِبَ
u'قَصْدٌ لَعِبٌ':Added, #1: 1	قَصْدَ اللَّعِبِ
u'قَصْدٌ لعب':Added, #1: 1	قَصْدَ اللَّعِبِ
u'قَصْدٌ لَعِبٌ':Added, #2: 2	قَصْدِ اللَّعِبِ
u'قَصَدَ لَفْظٌ':Predicate, #2: 2	قَصْدِ اللَّعِبِ
u'قَصْدٌ لَفْظٌ':Added, #1: 1	قَصَدَ لَفْظَ
u'قَصْدٌ لَفْظٌ':Added, #2: 2	قَصْدِ لَفْظِ
u'قَصَدَ لَمْسٌ':Predicate, #3: 3	قَصْدُ اللَّفْظِ
u'قَصْدٌ مَالٌ':Added, #1: 1	قَصَدَ لَمْسَ
u'قَصَدَ مَالِكٌ':Predicate, #2: 2	قَصْدِ الْمَالِ
u'قَصَدَ مَالِكٌ':Subject, #2: 2	قَصَدَ الْمَالِكَ
u'قَصْدٌ مَالِكٌ':Added, #2: 2	قَصَدَ الْمَالِكُ
u'قَصْدٌ مَالِكٌ':Added, #1: 1	قَصْدُ الْمَالِكِ
u'قَصْدٌ مُبَاحٌ':Added, #2: 2	قَصْدِ الْمَالِكِ
u'قَصْدٌ مُبَاحٌ':Added, #1: 1	قَصْدٍ مُبَاحٍ
u'قَصَدَ مُبَاشَرَةٌ':Predicate, #1: 1	قَصْدَ مُبَاحٍ
u'قَصَدَ مُبَالَغَةٌ':Predicate, #1: 1	قَصَدَ مُبَاشَرَةَ
u'قَصْدٌ مُبَالَغَةٌ':Added, #1: 1	قَصَدَ الْمُبَالَغَةَ
u'قَصْدٌ مُبَالَغَةٌ':Added, #1: 1	قَصْدُ الْمُبَالَغَةِ
u'قَصَدَ مُبَاهَاةٌ':Predicate, #1: 1	قَصْدِ الْمُبَالَغَةِ
u'قَصْدٌ مُبَاهَاةٌ':Added, #1: 1	قَصَدَ الْمُبَاهَاةَ
u'قَصْدٌ مُبَاهَاةٌ':Added, #1: 1	قَصْدُ الْمُبَاهَاةِ
u'قَصْدٌ مَبْتُوت':Added, #2: 2	قَصْدِ الْمُبَاهَاةِ
u'قَصَدَ مُتَابَعٌ':Predicate, #1: 1	قَصْدُ الْمَبْتُوتَةِ
u'قَصَدَ مُتَابَعَةٌ':Predicate, #1: 1	قَصَدَ مُتَابَعَةَ
u'قَصَدَ مُتَصَدِّق':Subject, #1: 1	قَصَدَ مُتَابَعَةَ
u'قَصْدٌ مُتَصَدِّق':Added, #1: 1	قَصَدَ الْمُتَصَدِّقُ
u'قَصَدَ مُتَكَلِّمٌ':Subject, #1: 1	قَصْدَ الْمُتَصَدِّقِ
u'قَصْدٌ مُتَكَلِّمٌ':Added, #1: 1	قَصَدَ الْمُتَكَلِّمُ
u'قَصْدٌ مُتَكَلِّمٌ':Added, #1: 1	قَصْدُ الْمُتَكَلِّمِ
u'قَصْدٌ مَجَازٌ':Added, #3: 3	قَصْدِ الْمُتَكَلِّمِ
u'قَصْدٌ مَجَازٌ':Added, #2: 2	قَصْدُ الْمَجَازِ
u'قَصْدٌ مُجَازَاةٌ':Added, #2: 2	قَصْدِ الْمَجَازِ
u'قَصَدَ مُجَاوَزَةٌ':Predicate, #1: 1	قَصْدَ الْمُجَازَاةِ
u'قَصَدَ مَجْدُود':Subject, #4: 4	قَصَدَ مُجَاوَزَةَ
u'قَصَدَ مُجَرَّدٌ':Predicate, #1: 1	قَصَدَ الْمَجْدُودُ
u'قَصْدٌ مُجَرَّدٌ':Added, #3: 3	قَصَدَ مُجَرَّدَ
u'قَصْدٌ مَجْلِسٌ':Added, #1: 1	قَصْدِ مُجَرَّدِ
u'قَصَدَ مُحَابَاةٌ':Predicate, #1: 1	قَصْدِ مَجْلِسِ
u'قَصْدٌ مُحَابَاةٌ':Added, #1: 1	قَصَدَ الْمُحَابَاةَ
u'قَصْدٌ مُحَابَاةٌ':Added, #2: 2	قَصْدُ الْمُحَابَاةِ
u'قَصْدٌ مُحْتَاجٌ':Added, #2: 2	قَصْدِ الْمُحَابَاةِ
u'قَصْدٌ مُحَرَّمٌ':Added, #1: 1	قَصْدٍ مُحْتَاجٍ
u'قَصَدَ مَحْمُولٌ':Subject, #1: 1	قَصْدَ الْمُحَرَّمِ
u'قَصَدَ مُخَالَفَةٌ':Predicate, #1: 1	قَصَدَ مَحْمُولُهُ
u'قَصْدٌ مُخَالَفَةٌ':Added, #1: 1	قَصَدَ مُخَالَفَةَ
u'قَصْدٌ مُخْبِرٌ':Added, #2: 2	قَصْدِ الْمُخَالَفَةِ
u'قَصْدٌ مُخْرِجٌ':Added, #1: 1	قَصْدِ الْمُخْبِرِ
u'قَصْدٌ مَدٌّ':Added, #1: 1	قَصْدِ الْمُخْرِجِ
u'قَصَدَ مَدْحٌ':Predicate, #1: 1	قَصْدِ مَدِّ
u'قَصْدٌ مَدْحٌ':Added, #1: 1	قَصَدَ مَدْحَ
u'قَصَدَ مَدْلُولٌ':Predicate, #1: 1	قَصْدُ الْمَدْحِ
u'قَصَدَ مَدَنِيٌّ':Subject, #1: 1	قَصَدَ مَدْلُولَ
u'قَصْدٌ مُرَاءاةٌ':Added, #1: 1	قَصَدَ مَدَنِيٌّ
u'قَصْدٌ مُرَاجَعَةٌ':Added, #1: 1	قَصْدِ الْمُرَاءَاةِ
u'قَصَدَ مُرْتَدٌّ':Subject, #1: 1	قَصْدِ الْمُرَاجَعَةِ
u'قَصْدٌ مُرْسِلٌ':Added, #2: 2	قَصَدَ الْمُرْتَدُّ
u'قَصَدَ مَسٌّ':Predicate, #1: 1	قَصْدِ مُرْسِلِهِ
u'قَصْدٌ مَسَاجِدُ':Added, #2: 2	قَصَدَ مَسَّ
u'قَصْدٌ مَسَافَةٌ':Added, #2: 2	قَصْدُ الْمَسَاجِدِ
u'قَصْدٌ مُسَاوَاةٌ':Added, #1: 1	قَصْدِ مَسَافَةٍ
u'قَصَدَ مُسْتَأْجِرٌ':Subject, #1: 1	قَصْدَ مُسَاوَاتِهِ
u'قَصَدَ مُسْتَعْمِلٌ':Subject, #1: 1	قَصَدَ الْمُسْتَأْجِرُ
u'قَصَدَ مَسْجِدٌ':Predicate, #1: 1	قَصَدَ الْمُسْتَعْمِلُ
u'قَصْدٌ مَسْجِدٌ':Added, #3: 3	قَصَدَ الْمَسْجِدَ
u'قَصَدَ مَسْحٌ':Predicate, #1: 1	قَصْدُ الْمَسْجِدِ
u'قَصْدٌ مَسْرُوقٌ':Added, #2: 2	قَصَدَ مَسْحَ
u'قَصَدَ مَسْكَنٌ':Predicate, #1: 1	قَصْدِ الْمَسْرُوقِ
u'قَصَدَ مَسِيرَةٌ':Predicate, #1: 1	قَصَدَ الْمَسْكَنَ
u'قَصْدٌ مُشَارِكٌ':Added, #5: 5	قَصَدَ مَسِيرَةَ
u'قَصَدَ مُشَارَكَةٌ':Predicate, #1: 1	قَصْد الْمُشَارِكِ
u'قَصَدَ مُشَاكَلَةٌ':Predicate, #1: 1	قَصَدَ الْمُشَارَكَةَ
u'قَصْدٌ مَشْيٌ':Added, #1: 1	قَصَدَ الْمُشَاكَلَةَ
u'قَصْدٌ مِصْرٌ':Added, #1: 1	قَصْدِ الْمَشْيِ
u'قَصَدَ مَصْلَحَةٌ':Predicate, #2: 2	قَصْدُ مِصْرٍ
u'قَصَدَ مَصْلَحَةٌ':Predicate, #1: 1	قَصَدَ الْمَصْلَحَةَ
u'قَصَدَ مُصَنِّفٌ':Subject, #1: 1	قَصَدَ مَصْلَحَةَ
u'قَصَدَ مَضْمَضَةٌ':Predicate, #2: 2	قَصَدَ الْمُصَنِّفُ
u'قَصْدٌ مَطْلُوبٌ':Added, #1: 1	قَصَدَ الْمَضْمَضَةَ
u'قَصَدَ مُعَاوَنَةٌ':Predicate, #1: 1	قَصْدٍ مَطْلُوبٍ
u'قَصْدٌ مُعَبِّرٌ':Added, #1: 1	قَصَدَ مُعَاوَنَةَ
u'قَصْدٌ مَعْرُوفٌ':Added, #1: 1	قَصْدِ الْمُعَبِّرِ
u'قَصَدَ مَعْصِيَةٌ':Predicate, #1: 1	قَصْدَ الْمَعْرُوفِ
u'قَصْدٌ مَعْصِيَةٌ':Added, #1: 1	قَصَدَ الْمَعْصِيَةَ
u'قَصْدٌ مَعْصِيَةٌ':Added, #1: 1	قَصْدَ مَعْصِيَةٍ
u'قَصْدٌ مَعْهُودٌ':Added, #2: 2	قَصْدِ الْمَعْصِيَةِ
u'قَصَدَ مَعِيٌّ':Predicate, #1: 1	قَصْدِ مَعْهُودٍ
u'قَصْدٌ مَعِيٌّ':Added, #1: 1	قَصَدَ الْمَعِيَّةَ
u'قَصَدَ مَعِيَّةٌ':Predicate, #1: 1	قَصْدَ الْمَعِيَّةِ
u'قَصْدٌ مَعِيَّةٌ':Added, #1: 1	قَصَدَ الْمَعِيَّةَ
u'قَصْدٌ مُعَيَّنٌ':Added, #1: 1	قَصْدَ الْمَعِيَّةِ
u'قَصْدٌ مُعَيَّنٌ':Added, #1: 1	قَصْدِ الْمُعَيَّنَةِ
u'قَصْدٌ مُغالَبَة':Added, #2: 2	قَصْدٍ مُعَيَّنٍ
u'قَصَدَ مُقَابَلٌ':Predicate, #1: 1	قَصْدِ الْمُغَالَبَةِ
u'قَصَدَ مُقَابَلَةٌ':Predicate, #1: 1	قَصَدَ مُقَابَلَةَ
u'قَصْدٌ مُقَارِنٌ':Added, #1: 1	قَصَدَ مُقَابَلَةَ
u'قَصْدٌ مَقَاصِدُ':Added, #1: 1	قَصْدٍ مُقَارِنٍ
u'قَصَدَ مُكَافَأَةٌ':Predicate, #1: 1	قَصْدَ الْمَقَاصِدِ
u'قَصَدَ مُكَافَأَةٌ':Predicate, #1: 1	قَصَدَ مُكَافَأَةَ
u'قَصْدٌ مُكَافَأَةٌ':Added, #3: 3	قَصَدَ الْمُكَافَأَةَ
u'قَصَدَ مُكْثٌ':Predicate, #1: 1	قَصْدِ الْمُكَافَأَةِ
u'قَصَدَ مُكْرَهٌ':Subject, #1: 1	قَصَدَ الْمُكْثَ
u'قَصْدٌ مَكْرُوهٌ':Added, #2: 2	قَصَدَ الْمُكْرَهُ
u'قَصَدَ مُلاَزَمَةٌ':Predicate, #1: 1	قَصْدِ الْمَكْرُوهِ
u'قَصَدَ مُلاَطَفَةٌ':Predicate, #1: 1	قَصَدَ مُلَازَمَةَ
u'قَصْدٌ مُلاَطَفَةٌ':Added, #1: 1	قَصَدَ الْمُلَاطَفَةَ
u'قَصْدٌ مِلْكٌ':Added, #1: 1	قَصْدَ الْمُلَاطَفَةِ
u'قَصَدَ مُمَاطَلَةٌ':Predicate, #1: 1	قَصْدَ الْمِلْكِ
u'قَصَدَ مُنافاة':Predicate, #1: 1	قَصَدَ الْمُمَاطَلَةَ
u'قَصْدٌ مُنَاقَشَةٌ':Added, #1: 1	قَصَدَ مُنَافَاةَ
u'قَصَدَ مَنْعٌ':Predicate, #1: 1	قَصْدُ مُنَاقَشَةِ
u'قَصَدَ مَنْعٌ':Predicate, #1: 1	قَصَدَ الْمَنْعَ
u'قَصْدٌ مَنْعٌ':Added, #2: 2	قَصَدَ مَنْعَ
u'قَصْدٌ مَنْعٌ':Added, #1: 1	قَصْدِ الْمَنْعِ
u'قَصْدٌ مُودِعٌ':Added, #2: 2	قَصْدِ مَنْعٍ
u'قَصْدٌ مُؤَذِّنٌ':Added, #1: 1	قَصْدُ الْمُودِعِ
u'قَصْدٌ مُؤَذِّنٌ':Added, #1: 1	قَصْدَ الْمُؤَذِّنِ
u'قَصَدَ مُوَرِّث':Subject, #1: 1	قَصْدِ الْمُؤَذِّنِ
u'قَصَدَ مُوَكِّلٌ':Predicate, #1: 1	قَصَدَ الْمُوَرِّثُ
u'قَصْدٌ مُوَكِّلٌ':Added, #1: 1	قَصَدَ الْمُوَكِّلَ
u'قَصَدَ مَوْهُوبٌ':Subject, #1: 1	قَصْدِ الْمُوَكِّلِ
u'قَصَدَ ناذِر':Subject, #1: 1	قَصَدَ الْمَوْهُوبُ
u'قَصْدٌ ناذِر':Added, #4: 4	قَصَدَ النَّاذِرُ
u'قَصْدٌ ناذِر':Added, #1: 1	قَصْدَ النَّاذِرِ
u'قَصَدَ نَاسٌ':Subject, #2: 2	قَصْدُ النَّاذِرِ
u'قَصْدٌ نَاسٌ':Added, #1: 1	قَصَدَ النَّاسُ
u'قَصْدٌ نَاسٌ':Added, #1: 1	قَصْدِ النَّاسِ
u'قَصْدٌ نَاظِرٌ':Added, #3: 3	قَصْدُ النَّاسِ
u'قَصْدٌ نَافِلَةٌ':Added, #2: 2	قَصْدَ النَّاظِرِ
u'قَصْدٌ نَبِيٌّ':Added, #1: 1	قَصْدِ النَّافِلَةِ
u'قَصْدٌ نَحْوٌ':Added, #3: 3	قَصْدِ النَّبِيِّ
u'قَصَدَ نِدَاءٌ':Predicate, #1: 1	قَصْدَ نَحْوِ
u'قَصَدَ نِدَاءٌ':Predicate, #1: 1	قَصَدَ نِدَاءَ
u'قَصْدٌ نَدْبٌ':Added, #3: 3	قَصَدَ النِّدَاءَ
u'قَصَدَ نَزْعٌ':Predicate, #1: 1	قَصْدِ النَّدْبِ
u'قَصْدٌ نِساءٌ':Added, #1: 1	قَصَدَ النَّزْعَ
u'قَصَدَ نُسُكٌ':Predicate, #1: 1	قَصْدِ النِّسَاءِ
u'قَصْدٌ نُسُكٌ':Added, #1: 1	قَصَدَ النُّسُكَ
u'قَصْدٌ نُسُكٌ':Added, #1: 1	قَصْدُ النُّسُكِ
u'قَصْدٌ نصاب':Added, #3: 3	قَصْدِ النُّسُكِ
u'قَصْدٌ نِصَابٌ':Added, #1: 1	قَصْدَ النِّصَابِ
u'قَصْدٌ نَظَرٌ':Added, #1: 1	قَصْدَ النِّصَابِ
u'قَصْدٌ نَظَرٌ':Added, #1: 1	قَصْدَ النَّظَرِ
u'قَصَدَ نَفْسٌ':Predicate, #2: 2	قَصْدِ نَظَرٍ
u'قَصْدٌ نَفْسٌ':Added, #1: 1	قَصَدَ النَّفْسَ
u'قَصْدٌ نَفْلٌ':Added, #1: 1	قَصْدَ نَفْسِ
u'قَصَدَ نَفْيٌ':Predicate, #1: 1	قَصْدِ النَّفْلِ
u'قَصَدَ نَفْيٌ':Predicate, #1: 1	قَصَدَ النَّفْيَ
u'قَصْدٌ نَفْيٌ':Added, #5: 5	قَصَدَ نَفْيَ
u'قَصْدٌ نقل':Added, #1: 1	قَصْدُ نَفْيِ
u'قَصْدٌ نَقْلٌ':Added, #1: 1	قَصْدِ النَّقْلِ
u'قَصْدٌ نِكَايَةٌ':Added, #1: 1	قَصْدِ النَّقْلِ
u'قَصْدٌ نِيَّةٌ':Added, #1: 1	قَصْدِ النِّكَايَةِ
u'قَصْدٌ نِيَّةٌ':Added, #1: 1	قَصْدِ النِّيَّةِ
u'قَصَدَ هِبَةٌ':Predicate, #1: 1	قَصْدِ نِيَّةٍ
u'قَصْدٌ هِبَةٌ':Added, #1: 1	قَصَدَ الْهِبَةَ
u'قَصْدٌ هَدْمٌ':Added, #1: 1	قَصْدَ هِبَتِهِ
u'قَصْدٌ هَدِيٌّ':Added, #1: 1	قَصْدَ هَدْمِ
u'قَصْدٌ هَدِيَّةٌ':Added, #1: 1	قَصْدِ الْهَدِيَّةِ
u'قَصْدٌ هَزْلٌ':Added, #1: 1	قَصْدِ الْهَدِيَّةِ
u'قَصَدَ واحد':Subject, #1: 1	قَصْدِ الْهَزْلِ
u'قَصَدَ وَاحِدٌ':Subject, #1: 1	قَصَدَ وَاحِدٌ
u'قَصْدٌ واحد':Added, #1: 1	قَصَدَ وَاحِدٌ
u'قَصْدٌ وَاحِدٌ':Added, #3: 3	قَصْدٍ وَاحِدٍ
u'قَصْدٌ وَارِثٌ':Added, #3: 3	قَصْدٍ وَاحِدٍ
u'قَصَدَ وَاقِفٌ':Subject, #1: 1	قَصْدَ الْوَارِثِ
u'قَصْدٌ وَاقِفٌ':Added, #1: 1	قَصَدَ الْوَاقِفُ
u'قَصْدٌ وَاقِفٌ':Added, #1: 1	قَصْدِ الْوَاقِفِ
u'قَصْدٌ وَاهِبٌ':Added, #5: 5	قَصْدَ الْوَاقِفِ
u'قَصْدٌ وَجْهٌ':Added, #1: 1	قَصْدَ الْوَاهِبِ
u'قَصْدٌ وُجُوبٌ':Added, #1: 1	قَصْدُ وَجْهِ
u'قَصْدٌ وُجُودٌ':Added, #1: 1	قَصْدِ الْوُجُوبِ
u'قَصْدٌ وَحْدَةٌ':Added, #1: 1	قَصْدُ وُجُودِ
u'قَصْدٌ وَزْنٌ':Added, #1: 1	قَصْدُ الْوَحْدَةِ
u'قَصْدٌ وَسَائِلُ':Added, #1: 1	قَصْدِ وَزْنِهِ
u'قَصَدَ وُصُولٌ':Predicate, #1: 1	قَصْدَ الْوَسَائِلِ
u'قَصْدٌ وَصِيٌّ':Added, #4: 4	قَصَدَ الْوُصُولَ
u'قَصْدٌ وَصِيٌّ':Added, #1: 1	قَصْدُ الْوَصِيَّةِ
u'قَصْدٌ وَصِيَّةٌ':Added, #1: 1	قَصْدِ الْوَصِيَّةِ
u'قَصْدٌ وَصِيَّةٌ':Added, #1: 1	قَصْدُ الْوَصِيَّةِ
u'قَصْدٌ وَضْعٌ':Added, #1: 1	قَصْدِ الْوَصِيَّةِ
u'قَصَدَ وَطْءٌ':Predicate, #1: 1	قَصْدِ وَضْعِهِ
u'قَصَدَ وَفَاءٌ':Predicate, #1: 1	قَصَدَ وَطْءَ
u'قَصْدٌ وَفَاءٌ':Added, #1: 1	قَصَدَ الْوَفَاءَ
u'قَصْدٌ وَفَاءٌ':Added, #1: 1	قَصْدُ الْوَفَاءِ
u'قَصَدَ وَقْفٌ':Predicate, #1: 1	قَصْدِ الْوَفَاءِ
u'قَصْدٌ وُقُوفٌ':Added, #1: 1	قَصَدَ وَقْفَ
u'قَصَدَ وَكِيلٌ':Subject, #1: 1	قَصْدِ الْوُقُوفِ
u'قَصْدٌ وَكِيلٌ':Added, #1: 1	قَصَدَ الْوَكِيلُ
u'قَصْدٌ وَلِيٌّ':Added, #2: 2	قَصْدُ الْوَكِيلِ
u'قَصَدَ يَمِينٌ':Predicate, #4: 4	قَصْدِ الْوَلِيِّ
u'قَصْدٌ يَمِينٌ':Added, #5: 5	قَصَدَ الْيَمِينَ
u'قَصْرٌ إبَاحَةٌ':Added, #2: 2	قَصْدِ الْيَمِينِ
u'قَصَرَ اِبْتِغَاءٌ':Predicate, #1: 1	قَصْرُ إبَاحَتِهِ
u'قَصَّرَ اِبْنٌ':Predicate, #1: 1	قَصَرَ ابْتِغَاءَ
u'قَصْرٌ اِبْنٌ':Added, #1: 1	قَصَّرَ ابْنَ
u'قِصَرٌ أَجَلٌ':Added, #1: 1	قَصْرَ ابْنِ
u'قَصَّرَ أَجِيرٌ':Subject, #1: 1	قِصَرِ الْأَجَلِ
u'قَصَّرَ أحَدٌ':Subject, #2: 2	قَصَّرَ الْأَجِيرُ
u'قَصْرٌ أَحْوالٌ':Added, #1: 1	قَصَّرَ أَحَدٌ
u'قَصْرٌ أحْوَالٌ':Added, #1: 1	قَصْرُ الْأَحْوَالِ
u'قَصَرَ أَصْحَابٌ':Subject, #1: 1	قَصْرُ الْأَحْوَالِ
u'قِصَرٌ أَعْمَارٌ':Added, #1: 1	قَصَرَ أَصْحَابُ
u'قَصْرٌ إِفْرَادٌ':Added, #1: 1	قِصَرِ أَعْمَارِ
u'قَصْرٌ أَفْرَادٌ':Added, #1: 1	قَصْرُ إفْرَادٍ
u'قَصَّرَ إمَامٌ':Subject, #2: 2	قَصْرِ الْأَفْرَادِ
u'قَصُرَ أَمَلٌ':Subject, #2: 2	قَصَّرَ الْإِمَامُ
u'قَصْرٌ أَمَلٌ':Added, #1: 1	قَصُرَ أَمَلُهُ
u'قِصَرٌ أَمَلٌ':Added, #1: 1	قَصْرِ الأَمَلِ
u'قَصَّرَ أُمِّيٌّ':Subject, #2: 2	قِصَرُ الْأَمَلِ
u'قِصَرٌ أَهْلِيٌّ':Added, #3: 3	قَصَّرَ الْأُمِّيُّ
u'قِصَرٌ أهْلِيَّةٌ':Added, #1: 1	قِصَرُ أَهْلِيَّتِهِ
u'قَصْرٌ أَوْصَافٌ':Added, #1: 1	قِصَرُ أَهْلِيَّتِهِ
u'قَصَّرَ أئِمَّةٌ':Subject, #1: 1	قَصْرُ الْأَوْصَافِ
u'قَصَرَ آيَةٌ':Predicate, #1: 1	قَصَّرَ الْأَئِمَّةُ
u'قَصَرَ آيَةٌ':Predicate, #1: 1	قَصَرَ الْآيَةَ
u'قَصْرٌ آيَةٌ':Added, #1: 1	قَصَرَ آيَةَ
u'قِصَرٌ بَاعٌ':Added, #1: 1	قَصْرِ الآيَةِ
u'قِصَرٌ بَاعٌ':Added, #1: 1	قِصَرِ الْبَاعِ
u'قَصَّرَ بَعْضٌ':Subject, #1: 1	قِصَرِ بَاعِهِ
u'قَصْرٌ بَعْضٌ':Added, #2: 2	قَصَّرَ بَعْضُ
u'قَصَرَ بَيَانٌ':Predicate, #1: 1	قَصْرُ بَعْضِ
u'قَصَرَ بَيْعٌ':Predicate, #1: 1	قَصَرَ الْبَيَانَ
u'قَصْرٌ تَبَع':Added, #1: 1	قَصَرَ الْبَيْعَ
u'قَصْرٌ تَخْرِيجٌ':Added, #1: 1	قَصْرَ التَّبَعِ
u'قَصْرٌ تَسْمِيَة':Added, #1: 1	قَصْرُ تَخْرِيجِ
u'قَصَرَ تَصَرُّفٌ':Predicate, #1: 1	قَصْرُ التَّسْمِيَةِ
u'قَصْرٌ تَعَوُّذٌ':Added, #1: 1	قَصَرَ تَصَرُّفَ
u'قَصُرَ تَوَهُّمٌ':Subject, #1: 1	قَصْرُ التَّعَوُّذِ
u'قَصَرَ ثَمانِيَةٌ':Predicate, #1: 1	قَصُرَ تَوَهُّمُ
u'قَصَّرَ ثَوْبٌ':Predicate, #1: 1	قَصَرَ ثَمَانِيَةَ
u'قَصَرَ ثَوْبٌ':Predicate, #2: 2	قَصَّرَ الثَّوْبَ
u'قَصْرٌ ثَوْبٌ':Added, #5: 5	قَصَرَ الثَّوْبَ
u'قِصَرٌ جِدار':Added, #1: 1	قَصْرَ الثَّوْبِ
u'قَصَرَ جمع':Predicate, #1: 1	قِصَرِ الْجِدَارِ
u'قَصَّرَ جَمِيع':Subject, #2: 2	قَصَرَ جَمَعَ
u'قَصَرَ جُنْدِيٌّ':Subject, #1: 1	قَصَّرَ الْجَمِيعُ
u'قَصْرٌ جَوَازٌ':Added, #1: 1	قَصَرَ الْجُنْدِيُّ
u'قَصْرٌ جَوَازٌ':Added, #1: 1	قَصْرِ الْجَوَازِ
u'قَصَرَ حالَةٌ':Predicate, #1: 1	قَصْرِ جَوَازِ
u'قَصْرٌ حُدودٌ':Added, #1: 1	قَصَرَ حَالَةَ
u'قَصَرَ حُكْمٌ':Predicate, #1: 1	قَصْرُ الْحُدُودِ
u'قَصْرٌ حُكْمٌ':Added, #1: 1	قَصَرَ حُكْمَ
u'قَصْرٌ حُكْمٌ':Added, #2: 2	قَصْرُ الْحُكْمِ
u'قَصَّرَ حَلٌّ':Predicate, #3: 3	قَصْرَ الْحُكْمِ
u'قَصْرٌ حِلٌّ':Added, #3: 3	قَصَّرَ حَلَّ
u'قَصْرٌ حِلٌّ':Added, #1: 1	قَصْرُ الْحِلِّ
u'قَصْرٌ حَمْدٌ':Added, #1: 1	قَصْرِ الْحِلِّ
u'قَصَرَ خِطَابٌ':Subject, #1: 1	قَصْرَ الْحَمْدِ
u'قِصَرٌ خطبة':Added, #1: 1	قَصَرَ الْخِطَابُ
u'قِصَرٌ خُطْبَةٌ':Added, #1: 1	قِصَرُ الْخُطْبَةِ
u'قَصَرَ خِلاَفٌ':Predicate, #1: 1	قِصَرُ الْخُطْبَةِ
u'قَصُرَ خِلاَفٌ':Subject, #1: 1	قَصَرَ الْخِلَافَ
u'قَصْرٌ خِلاَفٌ':Added, #1: 1	قَصُرَ الْخِلَافُ
u'قَصْرٌ خَمْرٌ':Added, #1: 1	قَصْرُ الْخِلَافِ
u'قَصُرَ رَأْسٌ':Subject, #1: 1	قَصْرُ الْخَمْرِ
u'قَصْرٌ رُبَاعِيُّ':Added, #1: 1	قَصُرَ رَأْسُ
u'قَصْرٌ رُبَاعِيُّ':Added, #1: 1	قَصْرُ الرُّبَاعِيَّةِ
u'قَصْرٌ رُبَاعِيُّ':Added, #1: 1	قَصْرِ الرُّبَاعِيَّةِ
u'قَصَّرَ رِبْحٌ':Subject, #3: 3	قَصْرُ رُبَاعِيَّةٍ
u'قَصَّرَ رَجُلٌ':Subject, #1: 1	قَصَّرَ رِبْحُ
u'قَصْرٌ رَجُلٌ':Added, #2: 2	قَصَّرَ الرَّجُلُ
u'قَصْرٌ رُجُوعٌ':Added, #1: 1	قَصْرَ رَجُلٍ
u'قَصَرَ رِسَالَةٌ':Predicate, #1: 1	قَصْرُ الرُّجُوعِ
u'قَصْرٌ رَضيعٌ':Added, #1: 1	قَصَرَ الرِّسَالَةَ
u'قَصُرَ زَمانٌ':Subject, #1: 1	قَصْرَ الرَّضِيعِ
u'قَصُرَ زَمَنٌ':Subject, #4: 4	قَصُرَ الزَّمَانُ
u'قَصَرَ زَمَنٌ':Subject, #2: 2	قَصُرَ زَمَنُهُ
u'قَصُرَ زَمَنٌ':Subject, #3: 3	قَصَرَ زَمَنُ
u'قَصُرَ زَمَنٌ':Subject, #4: 4	قَصُرَ زَمَنُ
u'قِصَرٌ زَمَنٌ':Added, #8: 8	قَصُرَ الزَّمَنُ
u'قِصَرٌ زَمَنٌ':Added, #1: 1	قِصَرِ زَمَنِ
u'قَصْرٌ سَعْدٌ':Added, #3: 3	قِصَرِ الزَّمَنِ
u'قَصُرَ سَفَرٌ':Subject, #1: 1	قَصْرَ سَعْدٍ
u'قَصُرَ سَفَرٌ':Subject, #1: 1	قَصُرَ السَّفَرُ
u'قَصُرَ سَهْمٌ':Subject, #1: 1	قَصُرَ سَفَرُهُ
u'قَصُرَ شرب':Subject, #1: 1	قَصُرَ سَهْمُهُ
u'قَصُرَ شُرْبٌ':Subject, #1: 1	قَصُرَ الشُّرْبُ
u'قَصَرَ شَرْطٌ':Predicate, #1: 1	قَصُرَ الشُّرْبُ
u'قَصْرٌ شفعة':Added, #1: 1	قَصَرَ الشَّرْطَ
u'قَصْرٌ شُفْعَةٌ':Added, #1: 1	قَصْرِ الشُّفْعَةِ
u'قَصَرَ شَهَادَةٌ':Predicate, #1: 1	قَصْرِ الشُّفْعَةِ
u'قَصَّرَ صَاحِبٌ':Subject, #1: 1	قَصَرَ الشَّهَادَةَ
u'قَصْرٌ صَبِيٌّ':Added, #2: 2	قَصَّرَ صَاحِبُ
u'قَصْرٌ صِحَّةٌ':Added, #1: 1	قَصْرِ الصَّبِيِّ
u'قَصْرٌ صِفَةٌ':Added, #1: 1	قَصْرَ صِحَّتِهِ
u'قَصَرَ صَلاَةٌ':Predicate, #1: 1	قَصْرُ الصِّفَاتِ
u'قَصَرَ صَلاَةٌ':Predicate, #1: 1	قَصَرَ الصَّلاةَ
u'قَصَرَ صَلاَةٌ':Predicate, #3: 3	قَصَرَ الصَّلاَةَ
u'قَصْرٌ صَلاَةٌ':Added, #9: 9	قَصَرَ الصَّلَاةَ
u'قَصْرٌ صَلاَةٌ':Added, #11: 11	قَصْرُ الصَّلَاةِ
u'قَصْرٌ صَلاَةٌ':Added, #17: 17	قَصْرِ الصَّلَاةِ
u'قَصْرٌ صَلاَةٌ':Added, #1: 1	قَصْرَ الصَّلاَةِ
u'قَصْرٌ صَلاَةٌ':Added, #1: 1	قَصْرِ الصَّلاَةِ
u'قَصْرٌ صَلاَةٌ':Added, #2: 2	قَصْرِ صَلَاةِ
u'قَصْرٌ صَوْمٌ':Added, #3: 3	قَصْرَ الصَّلَاةِ
u'قَصْرٌ طَائِفٌ':Added, #1: 1	قَصْرَ الصَّوْمِ
u'قَصْرٌ طَرْد':Added, #3: 3	قَصْرَ الطَّائِفِ
u'قَصْرٌ طَرْدَة':Added, #1: 1	قَصْرِ الطَّرْدِيَّةِ
u'قَصْرٌ طَرْدِيّ':Added, #1: 1	قَصْرِ الطَّرْدِيَّةِ
u'قَصْرٌ طَهَارَةٌ':Added, #1: 1	قَصْرِ الطَّرْدِيَّةِ
u'قَصَّرَ طَوِيلٌ':Predicate, #1: 1	قَصْرُ طَهَارَتِهِ
u'قَصَرَ ظِلٌّ':Subject, #1: 1	قَصَّرَ الطَّوِيلَ
u'قَصَرَ ظُهْرٌ':Predicate, #1: 1	قَصَرَ الظِّلُّ
u'قَصْرٌ ظُهْرٌ':Added, #2: 2	قَصَرَ الظُّهْرَ
u'قَصَرَ عَامٌّ':Predicate, #1: 1	قَصْرُ الظُّهْرِ
u'قَصْرٌ عَامٌّ':Added, #1: 1	قَصَرَ الْعَامَّ
u'قَصْرٌ عَامٌّ':Added, #1: 1	قَصْرَ الْعَامِّ
u'قَصَّرَ عَامِلٌ':Subject, #2: 2	قَصْرُ الْعَامِّ
u'قَصَّرَ عَامِلٌ':Subject, #1: 1	قَصَّرَ الْعَامِلُ
u'قَصَّرَ عِبَادٌ':Subject, #2: 2	قَصَّرَ عَامِلٌ
u'قَصَّرَ عَبْدٌ':Subject, #1: 1	قَصَّرَ عِبَادُهُ
u'قَصَّرَ عَبْدٌ':Subject, #1: 1	قَصَّرَ الْعَبْدُ
u'قَصْرٌ عَدَدٌ':Added, #1: 1	قَصَّرَ عَبْدُ
u'قَصْرٌ عَدَمٌ':Added, #1: 1	قَصْرُ عَدَدٍ
u'قَصَرَ عِشَاءٌ':Predicate, #1: 1	قَصْرَ عَدَمِ
u'قَصَرَ عَصْرٌ':Predicate, #1: 1	قَصَرَ الْعِشَاءَ
u'قَصُرَ عَقْلٌ':Subject, #2: 2	قَصَرَ الْعَصْرَ
u'قَصْرٌ عَمَلٌ':Added, #1: 1	قَصُرَ الْعَقْلُ
u'قَصْرٌ عَمَلٌ':Added, #1: 1	قَصْرُ عَمَلِ
u'قَصَرَ عُمُومٌ':Predicate, #2: 2	قَصْرِ الْعَمَلِ
u'قَصْرٌ عُمُومٌ':Added, #1: 1	قَصَرَ الْعُمُومَ
u'قِصَرٌ عنق':Added, #1: 1	قَصْرُ عُمُومِ
u'قِصَرٌ عُنُقٌ':Added, #1: 1	قِصَرُ الْعُنُقِ
u'قَصْرٌ غَدَاءٌ':Added, #1: 1	قِصَرُ الْعُنُقِ
u'قَصَرَ فَرْضٌ':Predicate, #1: 1	قَصْرَ الْغَدَاءِ
u'قَصَرَ فساد':Predicate, #1: 1	قَصَرَ الْفَرْضَ
u'قَصَرَ فَسَادٌ':Predicate, #1: 1	قَصَرَ الْفَسَادَ
u'قَصُرَ فَصْلٌ':Subject, #1: 1	قَصَرَ الْفَسَادَ
u'قَصَرَ فَصْلٌ':Subject, #14: 14	قَصُرَ الْفَصْلُ
u'قِصَرٌ فَصْلٌ':Added, #1: 1	قَصَرَ الْفَصْلُ
u'قَصْرٌ فَصْلٌ':Added, #1: 1	قِصَرُ الْفَصْلِ
u'قَصْرٌ فَصْلٌ':Added, #1: 1	قَصْرِ فَصْلٍ
u'قِصَرٌ فَصْلٌ':Added, #2: 2	قَصْرُ الْفَصْلِ
u'قَصْرٌ فَصْلٌ':Added, #6: 6	قِصَرِ الْفَصْلِ
u'قَصْرٌ فِعْلٌ':Added, #9: 9	قَصْرِ الْفَصْلِ
u'قَصْرٌ فلان':Added, #1: 1	قَصْرَ فِعْلِهِ
u'قَصُرَ فَهْمٌ':Subject, #1: 1	قَصْرُ الْمَكِّيِّ
u'قَصَّرَ قَابِضٌ':Subject, #3: 3	قَصُرَ فَهْمُهُ
u'قَصَّرَ قَابِضٌ':Subject, #1: 1	قَصَّرَ الْقَابِضُ
u'قَصَرَ قَالٌ':Predicate, #1: 1	قَصَّرَ قَابِضُ
u'قَصْرٌ قِرَاءةٌ':Added, #1: 1	قَصَرَ قَالَ
u'قَصَرَ قَصَرٌ':Predicate, #1: 1	قَصْرِ الْقِرَاءَةِ
u'قَصْرٌ كَرَاهَةٌ':Added, #1: 1	قَصَرَ قَصَرَ
u'قَصْرٌ كَفَّارٌ':Added, #1: 1	قَصْرِ الْكَرَاهَةِ
u'قَصْرٌ كَفَّارَةٌ':Added, #1: 1	قَصْرِ الْكَفَّارَةِ
u'قَصَرَ كَلاَمٌ':Predicate, #1: 1	قَصْرِ الْكَفَّارَةِ
u'قَصْرٌ لَفْظٌ':Added, #1: 1	قَصَرَ الْكَلَامَ
u'قَصْرٌ لَفْظٌ':Added, #2: 2	قَصْرُ اللَّفْظِ
u'قِصَرٌ لَيْلٌ':Added, #2: 2	قَصْرِ اللَّفْظِ
u'قَصَّرَ مَالٌ':Subject, #1: 1	قِصَرِ اللَّيْلِ
u'قَصَرَ مَالِكٌ':Subject, #1: 1	قَصَّرَ الْمَالُ
u'قَصَرَ مُتَلَذِّذ':Subject, #1: 1	قَصَرَ مَالِكٌ
u'قَصْرٌ مَجَازٌ':Added, #1: 1	قَصَرَ الْمُتَلَذِّذُ
u'قَصْرٌ مَجُوسٌ':Added, #1: 1	قَصْرِ الْمَجَازَاتِ
u'قَصْرٌ مَدَائِنُ':Added, #2: 2	قَصْرِ الْمَجُوسِ
u'قِصَرٌ مُدَّةٌ':Added, #1: 1	قَصْرَ الْمَدَائِنِ
u'قَصْرٌ مُدَّةٌ':Added, #1: 1	قِصَرُ مُدَّتِهِ
u'قِصَرٌ مُدَّةٌ':Added, #2: 2	قَصْرِ الْمُدَّةِ
u'قَصْرٌ مراد':Added, #2: 2	قِصَرِ الْمُدَّةِ
u'قَصْرٌ مُرَادٌ':Added, #1: 1	قَصْرُ الْمُرَادِ
u'قَصَّرَ مَرْكُوبٌ':Subject, #1: 1	قَصْرُ الْمُرَادِ
u'قَصْرٌ مَسَافَةٌ':Added, #1: 1	قَصَّرَ الْمَرْكُوبُ
u'قَصْرٌ مُسَافِرٌ':Added, #1: 1	قَصْرِ الْمَسَافَةِ
u'قَصْرٌ مُسَافِرٌ':Added, #1: 1	قَصْرِ الْمُسَافِرِ
u'قَصْرٌ مُسَافِرٌ':Added, #1: 1	قَصْرُ مُسَافِرِ
u'قَصْرٌ مُسْنَدٌ':Added, #2: 2	قَصْرُ الْمُسَافِرِ
u'قَصْرٌ مَعْرُوفٌ':Added, #2: 2	قَصْرَ الْمُسْنَدِ
u'قَصْرٌ مَكِّيّ':Added, #1: 1	قَصْرَ الْمَعْرُوفِ
u'قَصْرٌ مُلاَقَاةٌ':Added, #1: 1	قَصْرُ الْمَكِّيِّ
u'قَصْرٌ مُلاَمَسَةٌ':Added, #1: 1	قَصْرِ مُلَاقَاةِ
u'قَصْرٌ مَمْدُودٌ':Added, #1: 1	قَصْرُ الْمُلَامَسَةِ
u'قَصْرٌ مَنْسِيٌّ':Added, #1: 1	قَصْرِ الْمَمْدُودِ
u'قَصْرٌ مَنْعٌ':Added, #1: 1	قَصْرُ الْمَنْسِيَّةِ
u'قَصْرٌ مَوْصُوفٌ':Added, #1: 1	قَصْرُ مَنْعِ
u'قَصَرَ نَبِيٌّ':Subject, #1: 1	قَصْرُ الْمَوْصُوفِ
u'قَصْرٌ نَجَفٌ':Added, #1: 1	قَصَرَ النَّبِيُّ
u'قَصْرٌ نُشُوزٌ':Added, #1: 1	قَصْرِ النَّجَفِ
u'قَصْرٌ نَظَرٌ':Added, #1: 1	قَصْرَ النُّشُوزِ
u'قَصُرَ نهار':Subject, #1: 1	قَصْرِ النَّظَرِ
u'قَصُرَ نَهَارٌ':Subject, #1: 1	قَصُرَ نَهَارُهُ
u'قَصْرٌ وُجُوبٌ':Added, #1: 1	قَصُرَ نَهَارُهُ
u'قَصْرٌ يَدٌ':Added, #1: 1	قَصْرِ وُجُوبِ
u'قَصْرٌ يَدٌ':Added, #10: 10	قَصْرِ يَدِهِ
u'قَصْرٌ يَدٌ':Added, #18: 18	قَصْرُ يَدِهِ
u'قَصْرٌ يَدٌ':Added, #1: 1	قَصْرَ يَدِ
u'قِصَرٌ يَدٌ':Added, #1: 1	قَصْرُ يَدِ
u'قِصَرٌ يَدٌ':Added, #1: 1	قِصَرَ يَدِ
u'قِصَرٌ يَدٌ':Added, #1: 1	قِصَرِ يَدِ
u'قِصَرٌ يَدٌ':Added, #1: 1	قِصَرُ يَدِهِ
u'قَصْرٌ يَدٌ':Added, #1: 1	قِصَرِ يَدِهِ
u'قَصْرٌ يَدٌ':Added, #2: 2	قَصْرُ الْيَدِ
u'قَصْرٌ يَدٌ':Added, #5: 5	قَصْرِ يَدِ
u'قَصْرٌ يَمِينٌ':Added, #6: 6	قَصْرَ يَدِهِ
u'قَصَّ سِتٌّ':Predicate, #1: 1	قَصْرَ يَمِينِهِ
u'قَصَّ شَارِبٌ':Predicate, #2: 2	قَصَّ سِتَّةَ
u'قَصَّ شَعْرٌ':Predicate, #1: 1	قَصَّ الشَّارِبَ
u'قَصَصٌ أَحْبارٌ':Added, #1: 1	قَصَّ الشَّعْرَ
u'قَصَصٌ أَحْبَارٌ':Added, #2: 2	قَصَصِ الْأَحْبَارِ
u'قَصَصٌ أخيار':Added, #2: 2	قَصَصِ الْأَحْبَارِ
u'قَصَصٌ أَخْيَارٌ':Added, #2: 2	قَصَصِ الْأَخْيَارِ
u'قَصَصٌ أنبياء':Added, #2: 2	قَصَصِ الْأَخْيَارِ
u'قَصَصٌ أنبياء':Added, #1: 1	قَصَصَ الْأَنْبِيَاءِ
u'قَصَصٌ قُرْآنٌ':Added, #2: 2	قَصَصِ الْأَنْبِيَاءِ
u'قَصَّ ظُفْرٌ':Predicate, #3: 3	قَصَصِ الْقُرْآنِ
u'قَصَّ قَاصٌّ':Subject, #1: 1	قَصَّ ظُفْرَ
u'قَصَّ قِصَّةٌ':Predicate, #1: 1	قَصَّ الْقَاصُّ
u'قَصَّ مُحْرِمٌ':Subject, #2: 2	قَصَّ الْقِصَّةَ
u'قُصُورٌ إِدْرَاكٌ':Added, #3: 3	قَصَّ الْمُحْرِمُ
u'قُصُورٌ آلةٌ':Added, #1: 1	قُصُورُ إِدْرَاكِهِ
u'قُصُورٌ تَأَمُّلٌ':Added, #1: 1	قُصُورِ الْآلَةِ
u'قُصُورٌ تَبَع':Added, #1: 1	قُصُورِ التَّأَمُّلِ
u'قُصُورٌ تَبَع':Added, #1: 1	قُصُورَ التَّبَعِيَّةِ
u'قُصُورٌ تَبَعِيّ':Added, #2: 2	قُصُورِ التَّبَعِيَّةِ
u'قُصُورٌ تَبَعِيّ':Added, #1: 1	قُصُورَ التَّبَعِيَّةِ
u'قُصُورٌ تَبَعِيَّة':Added, #2: 2	قُصُورِ التَّبَعِيَّةِ
u'قُصُورٌ تَبَعِيَّة':Added, #1: 1	قُصُورَ التَّبَعِيَّةِ
u'قُصُورٌ ذَهَبٌ':Added, #2: 2	قُصُورِ التَّبَعِيَّةِ
u'قُصُورٌ رَأْيٌ':Added, #1: 1	قُصُورَ الذّهَبِ
u'قُصُورٌ رُتْبَةٌ':Added, #1: 1	قُصُورَ الرَّأْيِ
u'قُصُورٌ سَبَبِيَّةٌ':Added, #1: 1	قُصُورُ رُتْبَةِ
u'قُصُورٌ سَمَاءٌ':Added, #1: 1	قُصُورَ السَّبَبِيَّةِ
u'قُصُورٌ شَفَقَةٌ':Added, #1: 1	قُصُورُ السَّمَاءِ
u'قُصُورٌ شَفَقَةٌ':Added, #1: 1	قُصُورَ الشَّفَقَةِ
u'قُصُورٌ شَفَقَةٌ':Added, #1: 1	قُصُورِ شَفَقَةِ
u'قُصُورٌ شَفَقَةٌ':Added, #2: 2	قُصُورِ الشَّفَقَةِ
u'قُصُورٌ شَهَادَةٌ':Added, #3: 3	قُصُورُ الشَّفَقَةِ
u'قُصُورٌ فَهْمٌ':Added, #2: 2	قُصُورِ الشَّهَادَةِ
u'قُصُورٌ لَفْظٌ':Added, #1: 1	قُصُورِ فَهْمِهِ
u'قُصُورٌ مَالِيٌّ':Added, #1: 1	قُصُورِ لَفْظِهِ
u'قُصُورٌ مَعَانِي':Added, #1: 1	قُصُورُ مَالِيَّةِ
u'قُصُورٌ مَلْحَظٌ':Added, #1: 1	قُصُورُ مَعَانِيهِ
u'قُصُورٌ نَظَرٌ':Added, #1: 1	قُصُورَ مَلْحَظِ
u'قُصُورٌ نَظَرٌ':Added, #1: 1	قُصُورِ النَّظَرِ
u'قُصُورٌ نَظَرٌ':Added, #1: 1	قُصُورُ نَظَرٍ
u'قُصُورٌ نَظَرٌ':Added, #1: 1	قُصُورُ نَظَرِ
u'قُصُورٌ هِمَمٌ':Added, #2: 2	قُصُورِ نَظَرِهِ
u'قُصُورٌ هِمَمٌ':Added, #1: 1	قُصُورُ الْهِمَمِ
u'قُصُورٌ وِلاَيَةٌ':Added, #1: 1	قُصُورِ الْهِمَمِ
u'قَضَاءٌ اِبْنٌ':Added, #1: 1	قُصُورِ الْوِلَايَةِ
u'قَضَاءٌ أَجْوَدُ':Added, #1: 1	قَضَاءِ ابْنِ
u'قَضَاءٌ إِحْرَامٌ':Added, #1: 1	قَضَاءَ الْأَجْوَدِ
u'قَضَاءٌ إِحْرَامٌ':Added, #1: 1	قَضَاءِ الْإِحْرَامِ
u'قَضَاءٌ أُخْرَى':Added, #4: 4	قَضَاءُ الْإِحْرَامِ
u'قَضَاءٌ أَخِيرٌ':Added, #11: 11	قَضَاءُ الْأُخْرَيَيْنِ
u'قَضَاءٌ أَرْبَعُ':Added, #1: 1	قَضَاءُ الْأَخِيرِ
u'قَضَاءٌ أَرْبَعُ':Added, #2: 2	قَضَاءَ أَرْبَعِ
u'قَضَاءٌ أَرْبَعُ':Added, #3: 3	قَضَاءِ الْأَرْبَعِ
u'قَضَاءٌ أَرْبَعُ':Added, #7: 7	قَضَاءُ أَرْبَعِ
u'قَضَاءٌ أَرْبَعَةٌ':Added, #7: 7	قَضَاءُ الْأَرْبَعِ
u'قَضَاءٌ اِسْتِحْقَاقٌ':Added, #1: 1	قَضَاءُ أَرْبَعَةِ
u'قَضَاءٌ اِسْتِحْقَاقٌ':Added, #1: 1	قَضَاءُ اسْتِحْقَاقٍ
u'قَضَاءٌ إِظْهارٌ':Added, #2: 2	قَضَاءَ اسْتِحْقَاقٍ
u'قَضَاءٌ إِعانَةٌ':Added, #1: 1	قَضَاءُ إظْهَارِ
u'قَضَاءٌ أَعْمَالٌ':Added, #2: 2	قَضَاءُ إعَانَةٍ
u'قَضَاءٌ أَعْمَالٌ':Added, #1: 1	قَضَاءَ الْأَعْمَالِ
u'قَضَاءٌ إِلْزَامٌ':Added, #1: 1	قَضَاءُ الْأَعْمَالِ
u'قَضَاءٌ إِلْزَامٌ':Added, #1: 1	قَضَاءِ الْإِلْزَامِ
u'قَضَاءٌ الْمَرْأَةُ':Added, #2: 2	قَضَاءُ إلْزَامٍ
u'قَضَاءٌ أَمْرٌ':Added, #4: 4	قَضَاءُ الْمَرْأَةِ
u'قَضَاءٌ أهْوَازٌ':Added, #1: 1	قَضَاءِ الْأَمْرِ
u'قَضَاءٌ أَوْطَارٌ':Added, #1: 1	قَضَاءَ الْأَهْوَازِ
u'قَضَاءٌ أَوَّلُ':Added, #1: 1	قَضَاءِ الْأَوْطَارِ
u'قَضَاءٌ أَوَّلُ':Added, #2: 2	قَضَاءُ أَوَّلِ
u'قَضَاءٌ أَوَّلُ':Added, #4: 4	قَضَاءِ الْأَوَّلِ
u'قَضَاءٌ أَوَّلُ':Added, #5: 5	قَضَاءُ الْأَوَّلِ
u'قَضَاءٌ أولى':Added, #8: 8	قَضَاءَ الْأَوَّلِ
u'قَضَاءٌ أوْلَى':Added, #11: 11	قَضَاءُ الْأُولَيَيْنِ
u'قَضَاءٌ أيَّامٌ':Added, #11: 11	قَضَاءُ الْأُولَيَيْنِ
u'قَضَاءٌ أَيَّامٌ':Added, #1: 1	قَضَاءِ أَيَّامٍ
u'قَضَاءٌ أيَّامٌ':Added, #1: 1	قَضَاءِ أَيَّامٍ
u'قَضَاءٌ أَيَّامٌ':Added, #1: 1	قَضَاءُ أَيَّامِهِ
u'قَضَاءٌ أيَّامٌ':Added, #1: 1	قَضَاءُ أَيَّامِهِ
u'قَضَاءٌ أَيَّامٌ':Added, #3: 3	قَضَاءُ أَيَّامِ
u'قَضَاءٌ أيَّامٌ':Added, #3: 3	قَضَاءُ أَيَّامِ
u'قَضَاءٌ أَيَّامٌ':Added, #4: 4	قَضَاءُ أَيَّامٍ
u'قَضَاءٌ أيَّامٌ':Added, #4: 4	قَضَاءُ أَيَّامٍ
u'قَضَاءٌ أَيَّامٌ':Added, #5: 5	قَضَاءَ أَيَّامِ
u'قَضَاءٌ بَدَلٌ':Added, #5: 5	قَضَاءَ أَيَّامِ
u'قَضَاءٌ بَزّاز':Added, #1: 1	قَضَاءِ بَدَلِ
u'قَضَاءٌ بَزّازَة':Added, #3: 3	قَضَاءِ الْبَزَّازِيَّةِ
u'قَضَاءٌ بصرة':Added, #3: 3	قَضَاءِ الْبَزَّازِيَّةِ
u'قَضَاءٌ بصرة':Added, #3: 3	قَضَاءِ الْبَصْرَةِ
u'قَضَاءٌ بَعْضٌ':Added, #6: 6	قَضَاءَ الْبَصْرَةِ
u'قَضَاءٌ بَعْضٌ':Added, #1: 1	قَضَاءُ الْبَعْضِ
u'قَضَاءٌ بَعْضٌ':Added, #2: 2	قَضَاءَ بَعْضِ
u'قَضَاءٌ بَعْضٌ':Added, #3: 3	قَضَاءِ بَعْضِ
u'قَضَاءٌ بَقِيَّةٌ':Added, #5: 5	قَضَاءِ الْبَعْضِ
u'قَضَاءٌ بَلَدٌ':Added, #1: 1	قَضَاءِ بَقِيَّةِ
u'قَضَاءٌ تَتِمَّةٌ':Added, #1: 1	قَضَاءَ بَلَدٍ
u'قَضَاءٌ تَرَاوِيحُ':Added, #1: 1	قَضَاءِ تَتِمَّةِ
u'قَضَاءٌ تَرَبُّصٌ':Added, #2: 2	قَضَاءُ التَّرَاوِيحِ
u'قَضَاءٌ تَرْكٌ':Added, #1: 1	قَضَاءُ التَّرَبُّصِ
u'قَضَاءٌ تَرْكٌ':Added, #2: 2	قَضَاءِ التَّرْكِ
u'قَضَاءٌ تَرْكٌ':Added, #4: 4	قَضَاءُ تَرْكٍ
u'قَضَاءٌ تِسْعَةٌ':Added, #7: 7	قَضَاءَ تَرْكٍ
u'قَضَاءٌ تِسْعَةٌ':Added, #1: 1	قَضَاءُ تِسْعَةٍ
u'قَضَاءٌ تَطَوُّعٌ':Added, #1: 1	قَضَاءُ تِسْعَةِ
u'قَضَاءٌ تَطَوُّعٌ':Added, #1: 1	قَضَاءَ التَّطَوُّعِ
u'قَضَاءٌ تَطَوُّعٌ':Added, #1: 1	قَضَاءُ تَطَوُّعٍ
u'قَضَاءٌ تَطَوُّعٌ':Added, #2: 2	قَضَاءُ التَّطَوُّعِ
u'قَضَاءٌ تَكْبيرٌ':Added, #2: 2	قَضَاءِ التَّطَوُّعِ
u'قَضَاءٌ تَنَفُّلٌ':Added, #1: 1	قَضَاءِ التَّكْبِيرِ
u'قَضَاءٌ ثَالِثٌ':Added, #1: 1	قَضَاءِ التَّنَفُّلِ
u'قَضَاءٌ ثَانِي':Added, #1: 1	قَضَاءَ الثَّالِثِ
u'قَضَاءٌ ثَانِيَةٌ':Added, #2: 2	قَضَاءُ الثَّانِيَةِ
u'قَضَاءٌ ثَلاثُ':Added, #2: 2	قَضَاءُ الثَّانِيَةِ
u'قَضَاءٌ ثَمانِيَةٌ':Added, #3: 3	قَضَاءُ ثَلَاثِ
u'قَضَاءٌ جَامِعٌ':Added, #1: 1	قَضَاءُ ثَمَانِيَةٍ
u'قَضَاءٌ جَامِعٌ':Added, #1: 1	قَضَاءُ الْجَامِعِ
u'قَضَاءٌ جماع':Added, #4: 4	قَضَاءِ الْجَامِعِ
u'قَضَاءٌ جِمَاعٌ':Added, #1: 1	قَضَاءِ الْجِمَاعِ
u'قَضَاءٌ جمع':Added, #1: 1	قَضَاءِ الْجِمَاعِ
u'قَضَاءٌ جَمْعٌ':Added, #1: 1	قَضَاءِ الْجَمْعِ
u'قَضَاءٌ حاجَةٌ':Added, #1: 1	قَضَاءِ الْجَمْعِ
u'قَضَاءٌ حاجَةٌ':Added, #1: 1	قَضَاءِ الْحَاجَاتِ
u'قَضَاءٌ حاجَةٌ':Added, #1: 1	قَضَاءُ حَاجَةٍ
u'قَضَاءٌ حاجَةٌ':Added, #3: 3	قَضَاءِ حَاجَةٍ
u'قَضَاءٌ حاجَةٌ':Added, #40: 40	قَضَاءِ الْحَاجَةِ
u'قَضَاءٌ حاجَةٌ':Added, #5: 5	قَضَاءَ الْحَاجَةِ
u'قَضَاءٌ حاجَةٌ':Added, #5: 5	قَضَاءُ الْحَاجَةِ
u'قَضَاءٌ حاكِمٌ':Added, #8: 8	قَضَاءِ حَاجَتِهِ
u'قَضَاءٌ حَجٌّ':Added, #1: 1	قَضَاءِ الْحَاكِمِ
u'قَضَاءٌ حَجٌّ':Added, #13: 13	قَضَاءُ الْحَجِّ
u'قَضَاءٌ حَجٌّ':Added, #1: 1	قَضَاءَ الْحَجِّ
u'قَضَاءٌ حَجّ':Added, #1: 1	قَضَاءُ حَجِّهِ
u'قَضَاءٌ حَجٌّ':Added, #2: 2	قَضَاءُ حَجَّتَيْنِ
u'قَضَاءٌ حِجَّةٌ':Added, #9: 9	قَضَاءِ الْحَجِّ
u'قَضَاءٌ حِجَّةٌ':Added, #1: 1	قَضَاءُ الْحِجَّةِ
u'قَضَاءٌ حَقٌّ':Added, #1: 1	قَضَاءَ حِجَّةٍ
u'قَضَاءٌ حَقٌّ':Added, #1: 1	قَضَاءِ الْحَقِّ
u'قَضَاءٌ حَقٌّ':Added, #1: 1	قَضَاءَ حَقٍّ
u'قَضَاءٌ حَقٌّ':Added, #1: 1	قَضَاءَ حَقِّ
u'قَضَاءٌ حَقٌّ':Added, #1: 1	قَضَاءُ حَقٍّ
u'قَضَاءٌ حَقٌّ':Added, #2: 2	قَضَاءُ حَقِّ
u'قَضَاءٌ حَقٌّ':Added, #3: 3	قَضَاءِ حَقِّ
u'قَضَاءٌ حُقوقٌ':Added, #5: 5	قَضَاءُ حَقِّهِ
u'قَضَاءٌ حُقوقٌ':Added, #1: 1	قَضَاءَ الْحُقُوقِ
u'قَضَاءٌ حُقُوقٌ':Added, #1: 1	قَضَاءِ الْحُقُوقِ
u'قَضَاءٌ حُقُوقٌ':Added, #1: 1	قَضَاءَ الْحُقُوقِ
u'قَضَاءٌ حَنَفِيَّةٌ':Added, #1: 1	قَضَاءِ الْحُقُوقِ
u'قَضَاءٌ حَوائِجُ':Added, #1: 1	قَضَاءَ الْحَنَفِيَّةِ
u'قَضَاءٌ حَوائِجُ':Added, #1: 1	قَضَاءُ حَوَائِجِ
u'قَضَاءٌ حَوائِجُ':Added, #2: 2	قَضَاءِ حَوَائِجِهِ
u'قَضَاءٌ خَارِجٌ':Added, #5: 5	قَضَاءِ الْحَوَائِجِ
u'قَضَاءٌ خَارِجِيٌّ':Added, #3: 3	قَضَاءَ الْخَارِجِ
u'قَضَاءٌ خَارِجِيٌّ':Added, #1: 1	قَضَاءُ الْخَارِجِيِّ
u'قَضَاءٌ خِزَانَةٌ':Added, #1: 1	قَضَاءِ الْخَارِجِيِّ
u'قَضَاءٌ خُلاصَة':Added, #1: 1	قَضَاءِ الْخِزَانَةِ
u'قَضَاءٌ خُلَفَاءُ':Added, #2: 2	قَضَاءُ الْخُلَاصَةِ
u'قَضَاءٌ خلق':Added, #1: 1	قَضَاءُ الْخُلَفَاءِ
u'قَضَاءٌ خَلْقٌ':Added, #1: 1	قَضَاءِ الْخَلْقِ
u'قَضَاءٌ خَلِيفَةٌ':Added, #1: 1	قَضَاءِ الْخَلْقِ
u'قَضَاءٌ خَلِيفَةٌ':Added, #1: 1	قَضَاءِ الْخَلِيفَةِ
u'قَضَاءٌ خَلِيفَةٌ':Added, #1: 1	قَضَاءُ خَلِيفَتِهِ
u'قَضَاءٌ خَمْسٌ':Added, #2: 2	قَضَاءَ الْخَلِيفَةِ
u'قَضَاءٌ خَمْسٌ':Added, #1: 1	قَضَاءُ الْخَمْسِ
u'قَضَاءٌ خَمْسَةٌ':Added, #1: 1	قَضَاءِ الْخَمْسِ
u'قَضَاءٌ خَمْسَةٌ':Added, #1: 1	قَضَاءُ خَمْسَةِ
u'قَضَاءٌ دَرَاهِمُ':Added, #3: 3	قَضَاءُ خَمْسَةٍ
u'قَضَاءٌ دَيْنٌ':Added, #1: 1	قَضَاءُ الدَّرَاهِمِ
u'قَضَاءٌ دَيْنٌ':Added, #10: 10	قَضَاءُ دَيْنِ
u'قَضَاءٌ دَيْنٌ':Added, #155: 155	قَضَاءِ الدَّيْنِ
u'قَضَاءٌ دِينٌ':Added, #19: 19	قَضَاءِ دَيْنِ
u'قَضَاءٌ دِينٌ':Added, #1: 1	قَضَاءَ دِينِ
u'قَضَاءٌ دِينٌ':Added, #1: 1	قَضَاءِ دِينٍ
u'قَضَاءٌ دِينٌ':Added, #1: 1	قَضَاءُ دِينِهِ
u'قَضَاءٌ دَيْنٌ':Added, #1: 1	قَضَاءِ دِينِهِ
u'قَضَاءٌ دَيْنٌ':Added, #22: 22	قَضَاءِ دَيْنٍ
u'قَضَاءٌ دَيْنٌ':Added, #28: 28	قَضَاءُ الدَّيْنِ
u'قَضَاءٌ دَيْنٌ':Added, #39: 39	قَضَاءَ الدَّيْنِ
u'قَضَاءٌ دَيْنٌ':Added, #3: 3	قَضَاءَ دَيْنٍ
u'قَضَاءٌ دَيْنٌ':Added, #47: 47	قَضَاءِ دَيْنِهِ
u'قَضَاءٌ دَيْنٌ':Added, #7: 7	قَضَاءُ دَيْنِهِ
u'قَضَاءٌ دَيْنٌ':Added, #9: 9	قَضَاءَ دَيْنِ
u'قَضَاءٌ دُيونٌ':Added, #9: 9	قَضَاءَ دَيْنِهِ
u'قَضَاءٌ دُيونٌ':Added, #10: 10	قَضَاءِ دُيُونِهِ
u'قَضَاءٌ دُيونٌ':Added, #1: 1	قَضَاءَ الدُّيُونِ
u'قَضَاءٌ دُيونٌ':Added, #1: 1	قَضَاءَ دُيُونِهِ
u'قَضَاءٌ دُيونٌ':Added, #2: 2	قَضَاءُ دُيُونٍ
u'قَضَاءٌ دُيونٌ':Added, #2: 2	قَضَاءِ دُيُونِ
u'قَضَاءٌ دُيونٌ':Added, #3: 3	قَضَاءُ الدُّيُونِ
u'قَضَاءٌ دُيونٌ':Added, #3: 3	قَضَاءُ دُيُونِهِ
u'قَضَاءٌ رَاهِنٌ':Added, #8: 8	قَضَاءِ الدُّيُونِ
u'قَضَاءٌ رَجَبٌ':Added, #1: 1	قَضَاءِ الرَّاهِنِ
u'قَضَاءٌ رَجُلٌ':Added, #1: 1	قَضَاءُ رَجَبٍ
u'قَضَاءٌ رَجُلٌ':Added, #1: 1	قَضَاءُ الرَّجُلِ
u'قَضَاءٌ رِدَّةٌ':Added, #1: 1	قَضَاءُ رَجُلٍ
u'قَضَاءٌ رَسُولٌ':Added, #1: 1	قَضَاءِ رِدَّتِهِ
u'قَضَاءٌ رَسُولٌ':Added, #13: 13	قَضَاءِ رَسُولِ
u'قَضَاءٌ رَسُولٌ':Added, #6: 6	قَضَاءُ رَسُولِ
u'قَضَاءٌ ركعة':Added, #8: 8	قَضَاءَ رَسُولِ
u'قَضَاءٌ ركعة':Added, #1: 1	قَضَاءُ الرَّكْعَةِ
u'قَضَاءٌ رَكْعَةٌ':Added, #1: 1	قَضَاءِ الرَّكْعَةِ
u'قَضَاءٌ رَكْعَةٌ':Added, #1: 1	قَضَاءُ الرَّكْعَةِ
u'قَضَاءٌ ركعة':Added, #1: 1	قَضَاءِ الرَّكْعَةِ
u'قَضَاءٌ ركعة':Added, #2: 2	قَضَاءَ رَكْعَةٍ
u'قَضَاءٌ رَكْعَةٌ':Added, #2: 2	قَضَاءِ رَكْعَةٍ
u'قَضَاءٌ رَكْعَةٌ':Added, #2: 2	قَضَاءَ رَكْعَةٍ
u'قَضَاءٌ ركعة':Added, #2: 2	قَضَاءِ رَكْعَةٍ
u'قَضَاءٌ رَكْعَةٌ':Added, #6: 6	قَضَاءُ رَكْعَةٍ
u'قَضَاءٌ رَواتِبُ':Added, #6: 6	قَضَاءُ رَكْعَةٍ
u'قَضَاءٌ رَوَاتِبُ':Added, #1: 1	قَضَاءِ رَوَاتِبِ
u'قَضَاءٌ زَمَنٌ':Added, #1: 1	قَضَاءِ رَوَاتِبِ
u'قَضَاءٌ زَيْدٌ':Added, #1: 1	قَضَاءِ زَمَنِ
u'قَضَاءٌ سَائِرٌ':Added, #1: 1	قَضَاءَ زَيْدٍ
u'قَضَاءٌ سَبْعٌ':Added, #1: 1	قَضَاءُ سَائِرِ
u'قَضَاءٌ سَبْعٌ':Added, #1: 1	قَضَاءُ السَّبْعِ
u'قَضَاءٌ سَبْعَةٌ':Added, #1: 1	قَضَاءُ سَبْعٍ
u'قَضَاءٌ سَبْعَةٌ':Added, #1: 1	قَضَاءُ سَبْعَةٍ
u'قَضَاءٌ سِتٌّ':Added, #1: 1	قَضَاءُ سَبْعَةِ
u'قَضَاءٌ سجدة':Added, #1: 1	قَضَاءُ سِتَّةِ
u'قَضَاءٌ سَجْدَةٌ':Added, #1: 1	قَضَاءُ سَجْدَةٍ
u'قَضَاءٌ سِعَايَةٌ':Added, #1: 1	قَضَاءُ سَجْدَةٍ
u'قَضَاءٌ سَلَمٌ':Added, #2: 2	قَضَاءِ سِعَايَتِهِ
u'قَضَاءٌ سُنَّةٌ':Added, #1: 1	قَضَاءُ السَّلَمِ
u'قَضَاءٌ سنن':Added, #1: 1	قَضَاءِ سُنَّةِ
u'قَضَاءٌ سُورَةٌ':Added, #4: 4	قَضَاءِ السُّنَنِ
u'قَضَاءٌ شافِعِيّ':Added, #1: 1	قَضَاءَ السُّورَةِ
u'قَضَاءٌ شافِعِيّ':Added, #1: 1	قَضَاءُ الشَّافِعِيِّ
u'قَضَاءٌ شَفْعٌ':Added, #2: 2	قَضَاءِ الشَّافِعِيِّ
u'قَضَاءٌ شَفْعٌ':Added, #1: 1	قَضَاءُ الشَّفْعَيْنِ
u'قَضَاءٌ شَهْرٌ':Added, #7: 7	قَضَاءُ الشَّفْعِ
u'قَضَاءٌ شَهْرٌ':Added, #1: 1	قَضَاءَ الشَّهْرِ
u'قَضَاءٌ شَهْرٌ':Added, #1: 1	قَضَاءِ الشَّهْرِ
u'قَضَاءٌ شَهْرٌ':Added, #1: 1	قَضَاءُ شَهْرٍ
u'قَضَاءٌ شَهْرٌ':Added, #2: 2	قَضَاءُ الشَّهْرِ
u'قَضَاءٌ شَهْرٌ':Added, #2: 2	قَضَاءِ شَهْرِ
u'قَضَاءٌ شَهْوَةٌ':Added, #4: 4	قَضَاءُ شَهْرِ
u'قَضَاءٌ شَهْوَةٌ':Added, #12: 12	قَضَاءِ الشَّهْوَةِ
u'قَضَاءٌ شَهْوَةٌ':Added, #1: 1	قَضَاءَ شَهْوَةِ
u'قَضَاءٌ شَهْوَةٌ':Added, #1: 1	قَضَاءِ شَهْوَةِ
u'قَضَاءٌ شَهْوَةٌ':Added, #1: 1	قَضَاءِ شَهْوَتِهِ
u'قَضَاءٌ شَهْوَةٌ':Added, #24: 24	قَضَاءَ الشَّهْوَةِ
u'قَضَاءٌ شَهْوَةٌ':Added, #27: 27	قَضَاءُ الشَّهْوَةِ
u'قَضَاءٌ شَهْوَةٌ':Added, #2: 2	قَضَاءُ شَهْوَةٍ
u'قَضَاءٌ شَيْءٌ':Added, #3: 3	قَضَاءُ شَهْوَةِ
u'قَضَاءٌ شَيْءٌ':Added, #17: 17	قَضَاءُ شَيْءٍ
u'قَضَاءٌ صَلاَةٌ':Added, #1: 1	قَضَاءِ شَيْءٍ
u'قَضَاءٌ صَلاَةٌ':Added, #1: 1	قَضَاءَ صَلَاةٍ
u'قَضَاءٌ صَلاَةٌ':Added, #1: 1	قَضَاءَ صَلَاةِ
u'قَضَاءٌ صَلاَةٌ':Added, #1: 1	قَضَاءِ صَلَاةٍ
u'قَضَاءٌ صَلاَةٌ':Added, #20: 20	قَضَاءِ الصَّلَاةِ
u'قَضَاءٌ صَلاَةٌ':Added, #2: 2	قَضَاءَ الصَّلَاةِ
u'قَضَاءٌ صَلاَةٌ':Added, #3: 3	قَضَاءِ صَلَاةِ
u'قَضَاءٌ صَلاَةٌ':Added, #5: 5	قَضَاءُ صَلَاةٍ
u'قَضَاءٌ صَلاَةٌ':Added, #7: 7	قَضَاءُ صَلَاةِ
u'قَضَاءٌ صَلَوَاتٌ':Added, #9: 9	قَضَاءُ الصَّلَاةِ
u'قَضَاءٌ صَلَوَاتٌ':Added, #13: 13	قَضَاءُ الصَّلَوَاتِ
u'قَضَاءٌ صَلَوَاتٌ':Added, #1: 1	قَضَاءُ صَلَوَاتٍ
u'قَضَاءٌ صَلَوَاتٌ':Added, #1: 1	قَضَاءِ صَلَوَاتِ
u'قَضَاءٌ صَلَوَاتٌ':Added, #1: 1	قَضَاءُ صَلَوَاتِهِ
u'قَضَاءٌ صَلَوَاتٌ':Added, #4: 4	قَضَاءِ الصَّلَوَاتِ
u'قَضَاءٌ صَوْمٌ':Added, #4: 4	قَضَاءُ صَلَوَاتِ
u'قَضَاءٌ صَوْمٌ':Added, #18: 18	قَضَاءُ الصَّوْمِ
u'قَضَاءٌ صَوْمٌ':Added, #1: 1	قَضَاءِ صَوْمٍ
u'قَضَاءٌ صَوْمٌ':Added, #20: 20	قَضَاءِ الصَّوْمِ
u'قَضَاءٌ صَوْمٌ':Added, #2: 2	قَضَاءُ صَوْمِ
u'قَضَاءٌ صَوْمٌ':Added, #3: 3	قَضَاءَ صَوْمِ
u'قَضَاءٌ صَوْمٌ':Added, #3: 3	قَضَاءِ صَوْمِ
u'قَضَاءٌ صِيَامٌ':Added, #4: 4	قَضَاءَ الصَّوْمِ
u'قَضَاءٌ صِيَامٌ':Added, #1: 1	قَضَاءِ صِيَامِ
u'قَضَاءٌ ضِعْفٌ':Added, #2: 2	قَضَاءُ الصِّيَامِ
u'قَضَاءٌ طعام':Added, #2: 2	قَضَاءُ ضِعْفِ
u'قَضَاءٌ طَعَامٌ':Added, #1: 1	قَضَاءُ الطَّعَامِ
u'قَضَاءٌ ظُهْرٌ':Added, #1: 1	قَضَاءُ الطَّعَامِ
u'قَضَاءٌ ظُهْرٌ':Added, #1: 1	قَضَاءِ الظُّهْرِ
u'قَضَاءٌ ظُهْرٌ':Added, #1: 1	قَضَاءِ ظُهْرَيْنِ
u'قَضَاءٌ عَادَةٌ':Added, #4: 4	قَضَاءُ الظُّهْرِ
u'قَضَاءٌ عَادَةٌ':Added, #1: 1	قَضَاءَ الْعَادَةِ
u'قَضَاءٌ عَادَةٌ':Added, #1: 1	قَضَاءُ الْعَادَةِ
u'قَضَاءٌ عِبَادَةٌ':Added, #1: 1	قَضَاءِ الْعَادَةِ
u'قَضَاءٌ عِبَادَةٌ':Added, #1: 1	قَضَاءُ الْعِبَادَةِ
u'قَضَاءٌ عِبَادَةٌ':Added, #1: 1	قَضَاءُ عِبَادَاتِ
u'قَضَاءٌ عِبَادَةٌ':Added, #2: 2	قَضَاءُ الْعِبَادَاتِ
u'قَضَاءٌ عَبْدٌ':Added, #3: 3	قَضَاءِ الْعِبَادَاتِ
u'قَضَاءٌ عَبْدٌ':Added, #1: 1	قَضَاءُ الْعَبْدِ
u'قَضَاءٌ عَتّابِيّ':Added, #1: 1	قَضَاءِ الْعَبْدِ
u'قَضَاءٌ عِدَّةٌ':Added, #1: 1	قَضَاءِ الْعَتَّابِيَّةِ
u'قَضَاءٌ عُرْفِيٌّ':Added, #2: 2	قَضَاءِ عِدَّةٍ
u'قَضَاءٌ عِشَاءٌ':Added, #2: 2	قَضَاءٍ عُرْفِيٍّ
u'قَضَاءٌ عِشَاءٌ':Added, #11: 11	قَضَاءُ الْعِشَاءِ
u'قَضَاءٌ عَشْرٌ':Added, #2: 2	قَضَاءَ الْعِشَاءِ
u'قَضَاءٌ عَشْرٌ':Added, #1: 1	قَضَاءُ الْعَشْرِ
u'قَضَاءٌ عَشْرٌ':Added, #1: 1	قَضَاءِ الْعَشْرِ
u'قَضَاءٌ عَصْرٌ':Added, #1: 1	قَضَاءُ عَشْرٍ
u'قَضَاءٌ عَصْرٌ':Added, #1: 1	قَضَاءُ عَصْرِ
u'قَضَاءٌ عَصْرٌ':Added, #2: 2	قَضَاءُ الْعَصْرِ
u'قَضَاءٌ عَقْلٌ':Added, #3: 3	قَضَاءِ الْعَصْرِ
u'قَضَاءٌ عَلِيٌّ':Added, #1: 1	قَضَاءُ الْعَقْلِ
u'قَضَاءٌ عَلِيٌّ':Added, #1: 1	قَضَاءَ عَلِيٍّ
u'قَضَاءٌ عمرة':Added, #1: 1	قَضَاءِ عَلِيٍّ
u'قَضَاءٌ عُمْرَةٌ':Added, #1: 1	قَضَاءُ عُمْرَتِهِ
u'قَضَاءٌ عمرة':Added, #1: 1	قَضَاءُ عُمْرَتِهِ
u'قَضَاءٌ عُمْرَةٌ':Added, #2: 2	قَضَاءِ عُمْرَتِهِ
u'قَضَاءٌ عمرة':Added, #2: 2	قَضَاءِ عُمْرَتِهِ
u'قَضَاءٌ عُمْرَةٌ':Added, #6: 6	قَضَاءُ عُمْرَةٍ
u'قَضَاءٌ عمرة':Added, #6: 6	قَضَاءُ عُمْرَةٍ
u'قَضَاءٌ عُمْرَةٌ':Added, #9: 9	قَضَاءُ الْعُمْرَةِ
u'قَضَاءٌ عِيدٌ':Added, #9: 9	قَضَاءُ الْعُمْرَةِ
u'قَضَاءٌ غَائِبٌ':Added, #1: 1	قَضَاءُ الْعِيدَيْنِ
u'قَضَاءٌ غَائِبٌ':Added, #1: 1	قَضَاءَ الْغَائِبِ
u'قَضَاءٌ غَرَضٌ':Added, #1: 1	قَضَاءُ الْغَائِبِ
u'قَضَاءٌ غَضْبَان':Added, #2: 2	قَضَاءِ غَرَضِهِ
u'قَضَاءٌ غير':Added, #1: 1	قَضَاءِ الْغَضْبَانِ
u'قَضَاءٌ غَيْرٌ':Added, #1: 1	قَضَاءَ غَيْرِ
u'قَضَاءٌ غير':Added, #1: 1	قَضَاءَ غَيْرِ
u'قَضَاءٌ غَيْرٌ':Added, #1: 1	قَضَاءُ غَيْرِهِ
u'قَضَاءٌ غير':Added, #1: 1	قَضَاءُ غَيْرِهِ
u'قَضَاءٌ غَيْرٌ':Added, #2: 2	قَضَاءِ الْغَيْرِ
u'قَضَاءٌ غير':Added, #2: 2	قَضَاءِ الْغَيْرِ
u'قَضَاءٌ غَيْرٌ':Added, #2: 2	قَضَاءِ غَيْرِهِ
u'قَضَاءٌ فَاسِدٌ':Added, #2: 2	قَضَاءِ غَيْرِهِ
u'قَضَاءٌ فَتْحٌ':Added, #1: 1	قَضَاءِ الْفَاسِدِ
u'قَضَاءٌ فَرَائِضُ':Added, #1: 1	قَضَاءِ الْفَتْحِ
u'قَضَاءٌ فَرَائِضُ':Added, #1: 1	قَضَاءَ الْفَرَائِضِ
u'قَضَاءٌ فَرَائِضُ':Added, #3: 3	قَضَاءُ الْفَرَائِضِ
u'قَضَاءٌ فَرْضٌ':Added, #4: 4	قَضَاءِ الْفَرَائِضِ
u'قَضَاءٌ فَرْضٌ':Added, #1: 1	قَضَاءِ فَرْضِهِ
u'قَضَاءٌ فَرْضٌ':Added, #2: 2	قَضَاءِ الْفَرْضِ
u'قَضَاءٌ فُضُولِيٌّ':Added, #4: 4	قَضَاءِ فَرْضٍ
u'قَضَاءٌ فُضُولِيٌّ':Added, #1: 1	قَضَاءُ الْفُضُولِيِّ
u'قَضَاءٌ فِطْرٌ':Added, #1: 1	قَضَاءِ الْفُضُولِيِّ
u'قَضَاءٌ فلان':Added, #1: 1	قَضَاءُ فِطْرِهِ
u'قَضَاءٌ فلان':Added, #1: 1	قَضَاءِ الْبِيرَةِ
u'قَضَاءٌ فلان':Added, #1: 1	قَضَاءُ الرَّمَضَانَاتِ
u'قَضَاءٌ فلان':Added, #1: 1	قَضَاءُ الشَّافِعِيِّ
u'قَضَاءٌ فلان':Added, #1: 1	قَضَاءُ الصَّلَاتَيْنِ
u'قَضَاءٌ فلان':Added, #1: 1	قَضَاءِ الْعَتَّابِيَّةِ
u'قَضَاءٌ فلان':Added, #1: 1	قَضَاءُ رَمَضَانَيْنِ
u'قَضَاءٌ فُلاَنٌ':Added, #2: 2	قَضَاءِ الشَّافِعِيِّ
u'قَضَاءٌ فلان':Added, #2: 2	قَضَاءِ فُلَانٍ
u'قَضَاءٌ قَاصِرٌ':Added, #3: 3	قَضَاءِ الْبَزَّازِيَّةِ
u'قَضَاءٌ قَرْضٌ':Added, #1: 1	قَضَاءٍ قَاصِرٍ
u'قَضَاءٌ قَضَاءٌ':Added, #1: 1	قَضَاءِ الْقَرْضِ
u'قَضَاءٌ قضاة':Added, #4: 4	قَضَاءِ الْقَضَاءِ
u'قَضَاءٌ قضاة':Added, #1: 1	قَضَاءَ الْقُضَاةِ
u'قَضَاءٌ قضاة':Added, #1: 1	قَضَاءُ الْقُضَاةِ
u'قَضَاءٌ قَوْمٌ':Added, #1: 1	قَضَاءِ قُضَاةِ
u'قَضَاءٌ قِيمَةٌ':Added, #1: 1	قَضَاءَ قَوْمٍ
u'قَضَاءٌ كَاتِبٌ':Added, #1: 1	قَضَاءَ قِيمَةِ
u'قَضَاءٌ كَامِلٌ':Added, #1: 1	قَضَاءِ الْكَاتِبِ
u'قَضَاءٌ كَفِيلٌ':Added, #1: 1	قَضَاءَ كَامِلٍ
u'قَضَاءٌ كُورَةٌ':Added, #2: 2	قَضَاءِ الْكَفِيلِ
u'قَضَاءٌ كُوفَةٌ':Added, #4: 4	قَضَاءِ كُورَةِ
u'قَضَاءٌ لَذَّةٌ':Added, #2: 2	قَضَاءِ الْكُوفَةِ
u'قَضَاءٌ لُزُومٌ':Added, #1: 1	قَضَاءُ لَذَّةٍ
u'قَضَاءٌ لَيْلٌ':Added, #1: 1	قَضَاءَ لُزُومِ
u'قَضَاءٌ مُتَبَرِّعٌ':Added, #1: 1	قَضَاءِ اللَّيْلِ
u'قَضَاءٌ مَتْرُوكٌ':Added, #1: 1	قَضَاءِ مُتَبَرِّعٍ
u'قَضَاءٌ مَتْرُوكٌ':Added, #1: 1	قَضَاءَ الْمَتْرُوكِ
u'قَضَاءٌ مَتْرُوكٌ':Added, #1: 1	قَضَاءُ الْمَتْرُوكَاتِ
u'قَضَاءٌ مَتْرُوكٌ':Added, #1: 1	قَضَاءَ الْمَتْرُوكَةِ
u'قَضَاءٌ مثل':Added, #2: 2	قَضَاءِ الْمَتْرُوكَةِ
u'قَضَاءٌ مثل':Added, #1: 1	قَضَاءُ مِثْلِ
u'قَضَاءٌ مِثْلٌ':Added, #1: 1	قَضَاءِ مِثْلِ
u'قَضَاءٌ مِثْلٌ':Added, #1: 1	قَضَاءُ مِثْلِ
u'قَضَاءٌ مُجْتَهِد':Added, #1: 1	قَضَاءِ مِثْلِ
u'قَضَاءٌ مَجْمُوعٌ':Added, #1: 1	قَضَاءِ الْمُجْتَهِدِ
u'قَضَاءٌ مُحَكَّمٌ':Added, #1: 1	قَضَاءُ الْمَجْمُوعَةِ
u'قَضَاءٌ مُحَكَّمٌ':Added, #1: 1	قَضَاءُ الْمُحَكَّمِ
u'قَضَاءٌ مُدَّةٌ':Added, #1: 1	قَضَاءِ الْمُحَكَّمِ
u'قَضَاءٌ مَدِينٌ':Added, #1: 1	قَضَاءُ مُدَّةِ
u'قَضَاءٌ مَدِينَةٌ':Added, #2: 2	قَضَاءَ مَدِينَةِ
u'قَضَاءٌ مَدِينَةٌ':Added, #1: 1	قَضَاءَ مَدِينَةٍ
u'قَضَاءٌ مَدْيُونٌ':Added, #2: 2	قَضَاءَ مَدِينَةِ
u'قَضَاءٌ مَطْلُوبٌ':Added, #1: 1	قَضَاءِ مَدْيُونِ
u'قَضَاءٌ مَغْرِبٌ':Added, #1: 1	قَضَاءَ الْمَطْلُوبِ
u'قَضَاءٌ مُكَاتَبَةٌ':Added, #1: 1	قَضَاءُ الْمَغْرِبِ
u'قَضَاءٌ مُكَلَّفٌ':Added, #2: 2	قَضَاءِ مُكَاتَبَةِ
u'قَضَاءٌ مِلْكٌ':Added, #1: 1	قَضَاءُ الْمُكَلَّفِ
u'قَضَاءٌ مِلْكٌ':Added, #1: 1	قَضَاءَ مِلْكٍ
u'قَضَاءٌ مَنَاسِكُ':Added, #2: 2	قَضَاءُ مِلْكٍ
u'قَضَاءٌ مَنْذُور':Added, #2: 2	قَضَاءِ الْمَنَاسِكِ
u'قَضَاءٌ مَنْذُور':Added, #1: 1	قَضَاءَ الْمَنْذُورِ
u'قَضَاءٌ مَهْرٌ':Added, #2: 2	قَضَاءُ الْمَنْذُورِ
u'قَضَاءٌ مُوَكِّلٌ':Added, #1: 1	قَضَاءَ الْمَهْرِ
u'قَضَاءٌ مِيرَاثٌ':Added, #3: 3	قَضَاءِ الْمُوَكِّلِ
u'قَضَاءٌ نَاحِي':Added, #1: 1	قَضَاءَ الْمِيرَاثِ
u'قَضَاءٌ نَاحِي':Added, #1: 1	قَضَاءَ نَاحِيَةٍ
u'قَضَاءٌ نَاحِيَةٌ':Added, #1: 1	قَضَاءُ نَاحِيَةٍ
u'قَضَاءٌ نَاحِيَةٌ':Added, #1: 1	قَضَاءَ نَاحِيَةٍ
u'قَضَاءٌ نَبِيٌّ':Added, #1: 1	قَضَاءُ نَاحِيَةٍ
u'قَضَاءٌ نَبِيٌّ':Added, #1: 1	قَضَاءُ النَّبِيِّ
u'قَضَاءٌ نُجُومٌ':Added, #1: 1	قَضَاءِ النَّبِيِّ
u'قَضَاءٌ نَذْرٌ':Added, #1: 1	قَضَاءِ النُّجُومِ
u'قَضَاءٌ نذر':Added, #1: 1	قَضَاءُ نَذْرٍ
u'قَضَاءٌ نَذْرٌ':Added, #1: 1	قَضَاءُ نَذْرِهِ
u'قَضَاءٌ نُسُكٌ':Added, #1: 1	قَضَاءُ نَذْرِهِ
u'قَضَاءٌ نُسُكٌ':Added, #10: 10	قَضَاءِ نُسُكِهِ
u'قَضَاءٌ نُسُكٌ':Added, #1: 1	قَضَاءَ النُّسُكِ
u'قَضَاءٌ نُسُكٌ':Added, #1: 1	قَضَاءُ النُّسُكِ
u'قَضَاءٌ نِصْفٌ':Added, #1: 1	قَضَاءَ نُسُكِهِ
u'قَضَاءٌ نِصْفٌ':Added, #1: 1	قَضَاءُ النِّصْفِ
u'قَضَاءٌ نِصْفٌ':Added, #1: 1	قَضَاءِ النِّصْفِ
u'قَضَاءٌ نِصْفٌ':Added, #1: 1	قَضَاءُ نِصْفِهِ
u'قَضَاءٌ نَصِيبٌ':Added, #1: 1	قَضَاءِ نِصْفَيْنِ
u'قَضَاءٌ نَفْلٌ':Added, #3: 3	قَضَاءَ نَصِيبِهِ
u'قَضَاءٌ نَفْلٌ':Added, #1: 1	قَضَاءَ النَّفْلِ
u'قَضَاءٌ نَفْلٌ':Added, #1: 1	قَضَاءُ نَفْلٍ
u'قَضَاءٌ نَفْلٌ':Added, #3: 3	قَضَاءِ النَّفْلِ
u'قَضَاءٌ نَهْمَةٌ':Added, #4: 4	قَضَاءُ النَّفْلِ
u'قَضَاءٌ نَوَافِلُ':Added, #1: 1	قَضَاءُ نَهْمَةِ
u'قَضَاءٌ نَوَافِلُ':Added, #1: 1	قَضَاءَ النَّوَافِلِ
u'قَضَاءٌ نَوَافِلُ':Added, #1: 1	قَضَاءِ النَّوَافِلِ
u'قَضَاءٌ وَاجِبٌ':Added, #3: 3	قَضَاءُ النَّوَافِلِ
u'قَضَاءٌ وَاجِبٌ':Added, #2: 2	قَضَاءُ الْوَاجِبِ
u'قَضَاءٌ واحد':Added, #2: 2	قَضَاءُ وَاجِبِ
u'قَضَاءٌ وَاحِدٌ':Added, #1: 1	قَضَاءِ الْوَاحِدِ
u'قَضَاءٌ واحد':Added, #1: 1	قَضَاءِ الْوَاحِدِ
u'قَضَاءٌ وَاحِدٌ':Added, #1: 1	قَضَاءٍ وَاحِدٍ
u'قَضَاءٌ وِرْدٌ':Added, #1: 1	قَضَاءٍ وَاحِدٍ
u'قَضَاءٌ وَزْنٌ':Added, #1: 1	قَضَاءُ وِرْدِهِ
u'قَضَاءٌ وَطَرٌ':Added, #1: 1	قَضَاءُ وَزْنِ
u'قَضَاءٌ وَكِيلٌ':Added, #1: 1	قَضَاءُ الْوَطَرِ
u'قَضَاءٌ يَسِيرٌ':Added, #1: 1	قَضَاءُ وَكِيلِ
u'قَضَاءٌ يمن':Added, #1: 1	قَضَاءَ الْيَسِيرِ
u'قَضَاءٌ يَمَنُ':Added, #1: 1	قَضَاءَ الْيَمَنِ
u'قَضَاءٌ يَوْمٌ':Added, #1: 1	قَضَاءَ الْيَمَنِ
u'قَضَاءٌ يَوْمٌ':Added, #17: 17	قَضَاءُ يَوْمٍ
u'قَضَاءٌ يَوْمٌ':Added, #1: 1	قَضَاءَ الْيَوْمِ
u'قَضَاءٌ يَوْمٌ':Added, #1: 1	قَضَاءِ يَوْمَيْنِ
u'قَضَاءٌ يَوْمٌ':Added, #4: 4	قَضَاءِ يَوْمٍ
u'قَضَاءٌ يَوْمٌ':Added, #4: 4	قَضَاءِ يَوْمِ
u'قَضَاءٌ يَوْمٌ':Added, #6: 6	قَضَاءُ الْيَوْمِ
u'قَضَاءٌ يَوْمٌ':Added, #7: 7	قَضَاءُ يَوْمِ
u'قَضَاءٌ يَوْمٌ':Added, #8: 8	قَضَاءَ يَوْمٍ
u'قَضْمٌ فَحْلٌ':Added, #9: 9	قَضَاءُ يَوْمَيْنِ
u'قَضَى أَبٌ':Subject, #1: 1	قَضْمَ الْفَحْلِ
u'قَضَى اِبْنٌ':Subject, #1: 1	قَضَى الْأَبُ
u'قَضَى أَجْنَبِيٌّ':Subject, #4: 4	قَضَى ابْنُ
u'قَضَى أَجْوَدُ':Predicate, #1: 1	قَضَى أَجْنَبِيٌّ
u'قَضَى أحَدٌ':Subject, #2: 2	قَضَى أَجْوَدَ
u'قَضَى أَخِيرٌ':Predicate, #3: 3	قَضَى أَحَدُ
u'قَضَى أَرْبَعُ':Predicate, #2: 2	قَضَى الْأَخِيرَةَ
u'قَضَى أَرْبَعَةٌ':Predicate, #1: 1	قَضَى الْأَرْبَعَ
u'قَضَى أَرْدَأَ':Predicate, #2: 2	قَضَى أَرْبَعَةَ
u'قَضَى أَكْثَرُ':Predicate, #1: 1	قَضَى أَرْدَأَ
u'قَضَى ألف':Predicate, #1: 1	قَضَى أَكْثَرَ
u'قَضَى ألْفٌ':Predicate, #2: 2	قَضَى الْأَلْفَ
u'قَضَى أَلْفٌ':Predicate, #2: 2	قَضَى الْأَلْفَ
u'قَضَى إمَامٌ':Subject, #2: 2	قَضَى الْأَلْفَ
u'قَضَى إمَامٌ':Subject, #1: 1	قَضَى الْإِمَامُ
u'قَضَى أَميرٌ':Subject, #2: 2	قَضَى الإِمَامُ
u'قَضَى أيَّامٌ':Predicate, #1: 1	قَضَى الأَمِيرُ
u'قَضَى أَيَّامٌ':Predicate, #3: 3	قَضَى أَيَّامَ
u'قَضَى بَصيرٌ':Subject, #3: 3	قَضَى أَيَّامَ
u'قَضَى بَعْضٌ':Predicate, #1: 1	قَضَى الْبَصِيرُ
u'قَضَى بَعْضٌ':Subject, #13: 13	قَضَى بَعْضَ
u'قَضَى بَيْنٌ':Predicate, #2: 2	قَضَى بَعْضُ
u'قَضَى تَأْسِيسٌ':Subject, #3: 3	قَضَى بَيْنَ
u'قَضَى تَشَهُّدٌ':Predicate, #1: 1	قَضَى تَأْسِيسُ
u'قَضَى ثَالِثٌ':Predicate, #1: 1	قَضَى التَّشَهُّدَ
u'قَضَى ثَلاثُ':Predicate, #1: 1	قَضَى الثَّالِثَةَ
u'قَضَى ثَلاثُ':Predicate, #1: 1	قَضَى الثَّلَاثَ
u'قَضَى ثَلاثَةٌ':Predicate, #3: 3	قَضَى ثَلَاثَ
u'قَضَى ثَمانِي':Predicate, #2: 2	قَضَى ثَلَاثَةَ
u'قَضَى ثَمَنٌ':Predicate, #1: 1	قَضَى ثَمَانِيَ
u'قَضَى جَازٌ':Predicate, #3: 3	قَضَى الثَّمَنَ
u'قَضَى جَمِيع':Predicate, #1: 1	قَضَى جَازَ
u'قَضَى جَهْر':Predicate, #2: 2	قَضَى الْجَمِيعَ
u'قَضَى جَهْر':Predicate, #1: 1	قَضَى الْجَهْرِيَّةَ
u'قَضَى جَهْرَة':Predicate, #1: 1	قَضَى جَهْرِيَّةً
u'قَضَى جَهْرَة':Predicate, #1: 1	قَضَى الْجَهْرِيَّةَ
u'قَضَى جَهْرِيّ':Predicate, #1: 1	قَضَى جَهْرِيَّةً
u'قَضَى جَهْرِيّ':Predicate, #1: 1	قَضَى الْجَهْرِيَّةَ
u'قَضَى حاجَةٌ':Predicate, #1: 1	قَضَى جَهْرِيَّةً
u'قَضَى حاجَةٌ':Predicate, #1: 1	قَضَى الْحَاجَةَ
u'قَضَى حاكِمٌ':Subject, #5: 5	قَضَى حَاجَةَ
u'قَضَى حَجٌّ':Predicate, #4: 4	قَضَى الْحَاكِمُ
u'قَضَى حَقٌّ':Predicate, #3: 3	قَضَى الْحَجَّ
u'قَضَى حُكَّامٌ':Subject, #3: 3	قَضَى حَقَّ
u'قَضَى خاصّ':Subject, #2: 2	قَضَى حُكَّامُ
u'قَضَى خُلَفَاءُ':Subject, #1: 1	قَضَى الْخَاصُّ
u'قَضَى خَلِيفَةٌ':Subject, #1: 1	قَضَى الْخُلَفَاءُ
u'قَضَى خَمْسَةٌ':Predicate, #1: 1	قَضَى خَلِيفَتُهُ
u'قَضَى دُعَاءٌ':Predicate, #1: 1	قَضَى خَمْسَةَ
u'قَضَى دَيْنٌ':Predicate, #1: 1	قَضَى الدُّعَاءَ
u'قَضَى دَيْنٌ':Predicate, #35: 35	قَضَى الدَّيْنَ
u'قَضَى دُيونٌ':Predicate, #43: 43	قَضَى دَيْنَ
u'قَضَى دُيونٌ':Predicate, #1: 1	قَضَى دُيُونَ
u'قَضَى رَاهِنٌ':Subject, #2: 2	قَضَى الدُّيُونَ
u'قَضَى رَبُّ':Predicate, #19: 19	قَضَى الرَّاهِنُ
u'قَضَى رَبُّ':Subject, #1: 1	قَضَى رَبَّ
u'قَضَى رَسُولٌ':Subject, #1: 1	قَضَى رَبُّ
u'قَضَى رُكوعٌ':Predicate, #76: 76	قَضَى رَسُولُ
u'قَضَى رَمَضانُ':Predicate, #1: 1	قَضَى الرُّكُوعَ
u'قَضَى زائِدٌ':Predicate, #1: 1	قَضَى رَمَضَانَ
u'قَضَى زَمَنٌ':Predicate, #1: 1	قَضَى الزَّائِدَ
u'قَضَى زَيْدٌ':Subject, #1: 1	قَضَى زَمَنَ
u'قَضَى سَبْعٌ':Predicate, #11: 11	قَضَى زَيْدٌ
u'قَضَى سُجُودٌ':Predicate, #1: 1	قَضَى سَبْعَ
u'قَضَى سِرِّيٌّ':Predicate, #1: 1	قَضَى السُّجُودَ
u'قَضَى سَطِيح':Subject, #1: 1	قَضَى سِرِّيَّةً
u'قَضَى سَعْدٌ':Subject, #1: 1	قَضَى سَطِيحٌ
u'قَضَى سَهْلٌ':Predicate, #1: 1	قَضَى سَعْدُ
u'قَضَى سَيِّدٌ':Subject, #1: 1	قَضَى سَهْلاً
u'قَضَى شَارِعٌ':Subject, #1: 1	قَضَى السَّيِّدُ
u'قَضَى شَهْرٌ':Predicate, #1: 1	قَضَى الشَّارِعُ
u'قَضَى صَلاَةٌ':Predicate, #1: 1	قَضَى الشَّهْرَ
u'قَضَى صَلاَةٌ':Predicate, #17: 17	قَضَى الصَّلاَةَ
u'قَضَى صَلاَةٌ':Predicate, #1: 1	قَضَى صَلاَةَ
u'قَضَى صَلاَةٌ':Predicate, #4: 4	قَضَى الصَّلاةَ
u'قَضَى صَلاَةٌ':Predicate, #7: 7	قَضَى الصَّلَاةَ
u'قَضَى ضَامِنٌ':Subject, #9: 9	قَضَى صَلَاةَ
u'قَضَى طَالِبٌ':Predicate, #7: 7	قَضَى الضَّامِنُ
u'قَضَى طواف':Subject, #2: 2	قَضَى الطَّالِبَ
u'قَضَى طَوَافٌ':Subject, #1: 1	قَضَى طَوَافُهُ
u'قَضَى طُولٌ':Predicate, #1: 1	قَضَى طَوَافُهُ
u'قَضَى ظاهِرٌ':Subject, #1: 1	قَضَى طُولَ
u'قَضَى ظُهْرٌ':Predicate, #1: 1	قَضَى ظَاهِرُ
u'قَضَى عَدَدٌ':Predicate, #4: 4	قَضَى الظُّهْرَ
u'قَضَى عَدْلٌ':Subject, #4: 4	قَضَى عَدَدَ
u'قَضَى عرف':Subject, #1: 1	قَضَى الْعَدْلُ
u'قَضَى عُرْفٌ':Subject, #1: 1	قَضَى الْعُرْفُ
u'قَضَى عَقْلٌ':Subject, #1: 1	قَضَى الْعُرْفُ
u'قَضَى عَلِيٌّ':Subject, #3: 3	قَضَى الْعَقْلُ
u'قَضَى عُمَرٌ':Subject, #6: 6	قَضَى عَلِيٌّ
u'قَضَى عمرة':Predicate, #26: 26	قَضَى عُمَرُ
u'قَضَى عُمْرَةٌ':Predicate, #1: 1	قَضَى عُمْرَةَ
u'قَضَى عمرة':Predicate, #1: 1	قَضَى عُمْرَةَ
u'قَضَى عُمْرَةٌ':Predicate, #3: 3	قَضَى الْعُمْرَةَ
u'قَضَى غرماء':Subject, #3: 3	قَضَى الْعُمْرَةَ
u'قَضَى فَاتِحٌ':Predicate, #1: 1	قَضَى الْغُرَمَاءُ
u'قَضَى فَاتِحَةٌ':Predicate, #1: 1	قَضَى الْفَاتِحَةَ
u'قَضَى فَاسِدٌ':Predicate, #1: 1	قَضَى الْفَاتِحَةَ
u'قَضَى فَجْرٌ':Predicate, #1: 1	قَضَى الْفَاسِدَةَ
u'قَضَى فَرَائِضُ':Predicate, #5: 5	قَضَى الْفَجْرَ
u'قَضَى فَرْضٌ':Predicate, #1: 1	قَضَى فَرَائِضَ
u'قَضَى فُضُولِيٌّ':Subject, #2: 2	قَضَى الْفَرْضَ
u'قَضَى فُضُولِيٌّ':Subject, #1: 1	قَضَى الْفُضُولِيُّ
u'قَضَى فُلاَنٌ':Subject, #1: 1	قَضَى فُضُولِيٌّ
u'قَضَى قَالٌ':Predicate, #2: 2	قَضَى فُلَانٌ
u'قَضَى قَضَاءٌ':Predicate, #3: 3	قَضَى قَالَ
u'قَضَى قول':Predicate, #1: 1	قَضَى الْقَضَاءَ
u'قَضَى قَوْلٌ':Predicate, #1: 1	قَضَى الْقَوْلَ
u'قَضَى كَثِيرٌ':Predicate, #1: 1	قَضَى الْقَوْلَ
u'قَضَى كَفِيلٌ':Subject, #1: 1	قَضَى الْكَثِيرَ
u'قَضَى مَالٌ':Predicate, #1: 1	قَضَى الْكَفِيلُ
u'قَضَى مَتْرُوكٌ':Predicate, #5: 5	قَضَى الْمَالَ
u'قَضَى مَتْرُوكٌ':Predicate, #1: 1	قَضَى الْمَتْرُوكَةَ
u'قَضَى مُحْتَالٌ':Subject, #1: 1	قَضَى مَتْرُوكَةً
u'قَضَى مُحَمَّدٌ':Subject, #1: 1	قَضَى الْمُحْتَالُ
u'قَضَى مُحِيل':Subject, #1: 1	قَضَى مُحَمَّدٌ
u'قَضَى مُرْتَهِنٌ':Predicate, #1: 1	قَضَى الْمُحِيلُ
u'قَضَى مُرْتَهِنٌ':Subject, #1: 1	قَضَى الْمُرْتَهِنَ
u'قَضَى مَطْلُوبٌ':Predicate, #1: 1	قَضَى الْمُرْتَهِنُ
u'قَضَى مَطْلُوبٌ':Subject, #1: 1	قَضَى الْمَطْلُوبَ
u'قَضَى مُعِير':Subject, #3: 3	قَضَى الْمَطْلُوبُ
u'قَضَى مُقَلِّدٌ':Subject, #2: 2	قَضَى الْمُعِيرُ
u'قَضَى مُقَيَّدٌ':Subject, #1: 1	قَضَى الْمُقَلِّدُ
u'قَضَى مَنَاسِكُ':Predicate, #1: 1	قَضَى مُقَيَّدٌ
u'قَضَى مَهْرٌ':Predicate, #3: 3	قَضَى الْمَنَاسِكَ
u'قَضَى مَهْرٌ':Predicate, #1: 1	قَضَى الْمَهْرَ
u'قَضَى مُوَكِّلٌ':Subject, #1: 1	قَضَى مَهْرَ
u'قَضَى نَاسٌ':Subject, #2: 2	قَضَى الْمُوَكِّلُ
u'قَضَى نَاسٌ':Subject, #1: 1	قَضَى النّاسُ
u'قَضَى نَائِبٌ':Predicate, #1: 1	قَضَى النَّاسُ
u'قَضَى نَائِبٌ':Subject, #1: 1	قَضَى نَائِبَةَ
u'قَضَى نَائِبَةٌ':Predicate, #2: 2	قَضَى نَائِبُهُ
u'قَضَى نَبِيٌّ':Subject, #1: 1	قَضَى نَائِبَةَ
u'قَضَى نَبِيٌّ':Subject, #12: 12	قَضَى النَّبِيُّ
u'قَضَى نُسُكٌ':Predicate, #1: 1	قَضَى نَبِيُّ
u'قَضَى نِصْفٌ':Predicate, #1: 1	قَضَى النُّسُكَ
u'قَضَى نِصْفٌ':Predicate, #2: 2	قَضَى النِّصْفَ
u'قَضَى نَصِيبٌ':Predicate, #2: 2	قَضَى نِصْفَ
u'قَضَى وَاجِبٌ':Predicate, #1: 1	قَضَى نَصِيبَ
u'قَضَى واحد':Subject, #2: 2	قَضَى الْوَاجِبَ
u'قَضَى وَاحِدٌ':Subject, #1: 1	قَضَى وَاحِدٌ
u'قَضَى وَارِثٌ':Subject, #1: 1	قَضَى وَاحِدٌ
u'قَضَى وَاطِئٌ':Subject, #4: 4	قَضَى الْوَارِثُ
u'قَضَى وَصِيٌّ':Subject, #1: 1	قَضَى الْوَاطِئُ
u'قَضَى وَكِيلٌ':Subject, #2: 2	قَضَى الْوَصِيُّ
u'قَضَى ولد':Subject, #4: 4	قَضَى الْوَكِيلُ
u'قَضَى وَلَدٌ':Subject, #1: 1	قَضَى الْوَلَدُ
u'قَضَى وَلِيٌّ':Subject, #1: 1	قَضَى الْوَلَدُ
u'قَضَى يَوْمٌ':Predicate, #1: 1	قَضَى وَلِيُّهُ
u'قِطَارٌ إِبِلٌ':Added, #1: 1	قَضَى يَوْمَ
u'قِطَارٌ واحد':Added, #2: 2	قِطَارِ إبِلٍ
u'قِطَارٌ وَاحِدٌ':Added, #1: 1	قِطَارٍ وَاحِدٍ
u'قِطَافٌ أَوَّلُ':Added, #1: 1	قِطَارٍ وَاحِدٍ
u'قَطَّ ذَنَبٌ':Predicate, #1: 1	قِطَافُ أَوَّلِهِ
u'قطر بَوْلٌ':Added, #1: 1	قَطَّ ذَنَبَ
u'قطر بَوْلٌ':Added, #1: 1	قَطْرُ بَوْلِهِ
u'قَطْرٌ بَوْلٌ':Added, #1: 1	قَطْرِ بَوْلِهِ
u'قَطْرٌ بَوْلٌ':Added, #1: 1	قَطْرُ بَوْلِهِ
u'قَطْرَةٌ بَوْلٌ':Added, #1: 1	قَطْرِ بَوْلِهِ
u'قَطْرَةٌ خَمْرٌ':Added, #1: 1	قَطْرَةُ بَوْلٍ
u'قَطْرَةٌ خَمْرٌ':Added, #1: 1	قَطْرَةَ خَمْرٍ
u'قَطْرَةٌ دَمٌ':Added, #2: 2	قَطْرَةُ خَمْرٍ
u'قَطْرَةٌ دَمٌ':Added, #1: 1	قَطْرَةَ دَمٍ
u'قَطْرَةٌ دَمٌ':Added, #1: 1	قَطْرَةِ دَمٍ
u'قَطْرَةٌ لَبَنٌ':Added, #3: 3	قَطْرَةُ دَمٍ
u'قَطْرَةٌ مَاءٌ':Added, #1: 1	قَطْرَةَ لَبَنٍ
u'قَطْرَةٌ مَاءٌ':Added, #1: 1	قَطْرَةُ مَاءٍ
u'قَطْرَةٌ مَطَرٌ':Added, #1: 1	قَطْرَةِ مَاءٍ
u'قَطْرَةٌ نَجَاسَةٌ':Added, #1: 1	قَطْرَةُ مَطَرٍ
u'قَطَرَ دَمٌ':Subject, #1: 1	قَطْرَةُ نَجَاسَةٍ
u'قطر دَمٌ':Added, #6: 6	قَطَرَ الدَّمُ
u'قَطْرٌ دَمٌ':Added, #1: 1	قَطْرَ الدَّمِ
u'قَطَرَ سَقْفٌ':Subject, #1: 1	قَطْرَ الدَّمِ
u'قَطَّرَ صَائِمٌ':Subject, #1: 1	قَطَرَ سَقْفُ
u'قَطَرَ فَارِسٌ':Predicate, #1: 1	قَطَّرَ الصَّائِمُ
u'قَطَّرَ مَاءٌ':Predicate, #1: 1	قَطَرَ الْفَارِسَ
u'قَطَرَ مَاءٌ':Subject, #2: 2	قَطَّرَ الْمَاءَ
u'قطر مَاءٌ':Added, #1: 1	قَطَرَ الْمَاءُ
u'قَطْرٌ مَاءٌ':Added, #10: 10	قَطْرِ الْمَاءِ
u'قطر مَاءٌ':Added, #10: 10	قَطْرِ الْمَاءِ
u'قَطْرٌ مَاءٌ':Added, #1: 1	قَطْرُ الْمَاءِ
u'قَطَعَ أَبٌ':Subject, #1: 1	قَطْرُ الْمَاءِ
u'قَطَعَ اِبْنٌ':Subject, #1: 1	قَطَعَ الْأَبُ
u'قَطَعَ إِبْهَامٌ':Predicate, #19: 19	قَطَعَ ابْنُ
u'قَطَعَ إِبْهَامٌ':Predicate, #1: 1	قَطَعَ الْإِبْهَامَ
u'قَطْعٌ إِبْهَامٌ':Added, #2: 2	قَطَعَ إبْهَامَ
u'قَطَعَ أَبْيَض':Predicate, #1: 1	قَطْعِ إبْهَامِ
u'قَطَعَ اِجْتِهَادٌ':Predicate, #1: 1	أَقْطَعَ أَبْيَضَ
u'قَطَعَ أَجْفَانٌ':Predicate, #2: 2	قَطَعَ اجْتِهَادَ
u'قَطْعٌ أَجْفَانٌ':Added, #1: 1	قَطَعَ الْأَجْفَانَ
u'قَطَعَ أَجْنَبِيٌّ':Subject, #1: 1	قَطْعِ الْأَجْفَانِ
u'قَطَعَ أَجْنَبِيٌّ':Subject, #1: 1	قَطَعَ الْأَجْنَبِيُّ
u'قَطَعَ اِحْتِمَالٌ':Predicate, #4: 4	قَطَعَ أَجْنَبِيٌّ
u'قَطَعَ أحَدٌ':Predicate, #1: 1	قَطَعَ احْتِمَالَ
u'قَطَعَ أحَدٌ':Subject, #1: 1	قَطَعَ أَحَدَ
u'قَطْعٌ أحَدٌ':Added, #3: 3	قَطَعَ أَحَدُ
u'قَطْعٌ أَحْكَامٌ':Added, #1: 1	قَطْعُ أَحَدِ
u'قَطْعٌ أُخُوَّةٌ':Added, #1: 1	قَطْعِ أَحْكَامٍ
u'قَطَعَ آدَمِيٌّ':Subject, #1: 1	قَطْعُ الْأُخُوَّاتِ
u'قَطَعَ أَرْبَعُ':Predicate, #1: 1	قَطَعَ الْآدَمِيُّ
u'قَطَعَ أَرْبَعُ':Predicate, #1: 1	أَقْطَعَ أَرْبَعَ
u'قَطْعٌ أَرْبَعُ':Added, #1: 1	قَطَعَ أَرْبَعَ
u'قَطْعٌ إِرْثٌ':Added, #1: 1	قَطْعِ الْأَرْبَعِ
u'قَطْعٌ إِرْثٌ':Added, #1: 1	قَطْعُ الْإِرْثِ
u'قَطَعَ إِرْسَالٌ':Predicate, #1: 1	قَطْعِ الْإِرْثِ
u'قَطْعٌ أرْضٌ':Added, #1: 1	قَطَعَ الْإِرْسَالَ
u'قَطْعٌ أَسَابِيعُ':Added, #1: 1	قَطْعَ الْأَرْضِ
u'قَطَعَ أسْبَابٌ':Predicate, #1: 1	قَطْعُ الْأَسَابِيعِ
u'قَطَعَ أَسْبَابٌ':Predicate, #1: 1	قَطَعَ أَسْبَابَ
u'قَطْعٌ اِسْتِمْرارٌ':Added, #1: 1	قَطَعَ أَسْبَابَ
u'قَطَعَ أَسْفَلُ':Predicate, #1: 1	قَطْعُ اسْتِمْرَارِهِ
u'قَطْعٌ إِسْلامٌ':Added, #1: 1	قَطَعَ أَسْفَلَ
u'قَطْعٌ أَسْواقٌ':Added, #4: 4	قَطْعُ الْإِسْلَامِ
u'قَطَعَ أَشْجَارٌ':Predicate, #1: 1	قَطْعِ الْأَسْوَاقِ
u'قَطَعَ أَشْجَارٌ':Predicate, #1: 1	قَطَعَ أَشْجَارَ
u'قَطْعٌ أَشْجَارٌ':Added, #1: 1	قَطَعَ الْأَشْجَارَ
u'قَطْعٌ أَشَلّ':Added, #1: 1	قَطْعَ الْأَشْجَارِ
u'قَطَعَ أَصابِعُ':Predicate, #2: 2	قَطْعِ الْأَشَلِّ
u'قَطَعَ أَصابِعُ':Predicate, #2: 2	قَطَعَ الْأَصَابِعَ
u'قَطْعٌ أَصابِعُ':Added, #5: 5	قَطَعَ أَصَابِعَ
u'قَطْعٌ أَصابِعُ':Added, #1: 1	قَطْعُ أَصَابِعِ
u'قَطْعٌ أَصابِعُ':Added, #1: 1	قَطْعِ أَصَابِعِ
u'قَطْعٌ أَصابِعُ':Added, #1: 1	قَطْعُ الْأَصَابِعِ
u'قَطْعٌ أَصابِعُ':Added, #2: 2	قَطْعَ الْأَصَابِعِ
u'قَطَعَ أُصْبُعٌ':Predicate, #2: 2	قَطْعِ الْأَصَابِعِ
u'قَطَعَ إِصْبَعٌ':Predicate, #18: 18	قَطَعَ أُصْبُعَ
u'قَطَعَ إِصْبَعٌ':Predicate, #1: 1	قَطَعَ الْإِصْبَعَ
u'قَطَعَ أُصْبُعٌ':Predicate, #3: 3	قَطَعَ إصْبَعَ
u'قَطْعٌ أُصْبُعٌ':Added, #6: 6	قَطَعَ الْأُصْبُعَ
u'قَطْعٌ إِصْبَعٌ':Added, #1: 1	قَطْعِ أُصْبُعِ
u'قَطْعٌ أُصْبُعٌ':Added, #1: 1	قَطْعِ إصْبَعٍ
u'قَطْعٌ إِصْبَعٌ':Added, #1: 1	قَطْعُ أُصْبُعَيْنِ
u'قَطْعٌ أُصْبُعٌ':Added, #1: 1	قَطْعُ الْإِصْبَعِ
u'قَطْعٌ أُصْبُعٌ':Added, #2: 2	قَطْعَ أُصْبُعٍ
u'قَطْعٌ إِصْبَعٌ':Added, #2: 2	قَطْعِ الْأُصْبُعِ
u'قَطْعٌ أُصْبُعٌ':Added, #2: 2	قَطْعِ الْإِصْبَعِ
u'قَطَعَ أَصْحَابٌ':Subject, #4: 4	قَطْعِ أُصْبُعٍ
u'قَطْعٌ أَصْحَابٌ':Added, #5: 5	قَطَعَ الْأَصْحَابُ
u'قَطْعٌ أَصْحَابٌ':Added, #1: 1	قَطْعَ الْأَصْحَابِ
u'قَطْعٌ أصل':Added, #1: 1	قَطْعِ الْأَصْحَابِ
u'قَطْعٌ أًصْلٌ':Added, #1: 1	قَطْعِ الْأَصْلِ
u'قَطَعَ أَطْرافٌ':Predicate, #1: 1	قَطْعِ الْأَصْلِ
u'قَطَعَ أَطْرَافٌ':Predicate, #1: 1	قَطَعَ أَطْرَافَ
u'قَطَعَ أَطْرافٌ':Predicate, #1: 1	قَطَعَ أَطْرَافَ
u'قَطَعَ أَطْرَافٌ':Predicate, #2: 2	قَطَعَ الْأَطْرَافَ
u'قَطْعٌ أَطْرافٌ':Added, #2: 2	قَطَعَ الْأَطْرَافَ
u'قَطْعٌ أَطْرَافٌ':Added, #1: 1	قَطْعُ الْأَطْرَافِ
u'قَطْعٌ أَطْرافٌ':Added, #1: 1	قَطْعُ الْأَطْرَافِ
u'قَطْعٌ أَطْرَافٌ':Added, #2: 2	قَطْعِ الْأَطْرَافِ
u'قَطَعَ أَظافِرُ':Predicate, #2: 2	قَطْعِ الْأَطْرَافِ
u'قَطْعٌ أَغْصَانٌ':Added, #1: 1	قَطَعَ أَظَافِرَ
u'قَطْعٌ أَغْصَانٌ':Added, #1: 1	قَطْعَ الْأَغْصَانِ
u'قَطْعٌ أفيُونٌ':Added, #1: 1	قَطْعُ الْأَغْصَانِ
u'قَطَعَ أَكْثَرُ':Predicate, #1: 1	قَطْعُ الْأَفْيُونِ
u'قَطَعَ أَكْثَرُ':Predicate, #3: 3	قَطَعَ أَكْثَرَ
u'قَطَعَ أَكْثَرُ':Subject, #3: 3	قَطَعَ الْأَكْثَرَ
u'قَطْعٌ أَكْثَرُ':Added, #2: 2	قَطَعَ أَكْثَرُ
u'قَطْعٌ أَكْثَرُ':Added, #1: 1	قَطْعِ أَكْثَرِ
u'قَطْعٌ أَكْثَرُ':Added, #1: 1	قَطْعَ الْأَكْثَرِ
u'قَطَعَ أكل':Predicate, #2: 2	قَطْعِ الْأَكْثَرِ
u'قَطَعَ أَكْلٌ':Predicate, #1: 1	قَطَعَ الْأَكْلَ
u'قَطْعٌ آلةٌ':Added, #1: 1	قَطَعَ الْأَكْلَ
u'قَطْعٌ إلْحَاقٌ':Added, #1: 1	قَطْعَ آلَةِ
u'قَطْعٌ ألف':Added, #1: 1	قَطْعَ الْإِلْحَاقِ
u'قَطْعٌ أَلْوَانٌ':Added, #1: 1	قَطْعُ أَلِفِ
u'قَطَعَ ألْيَةٌ':Predicate, #1: 1	قَطْعِ الْأَلْوَانِ
u'قَطَعَ إمَامٌ':Subject, #1: 1	قَطَعَ أَلْيَةَ
u'قَطَعَ إمَامٌ':Subject, #1: 1	قَطَعَ إمَامُ
u'قَطْعٌ إِمْساكٌ':Added, #8: 8	قَطَعَ الْإِمَامُ
u'قَطْعٌ إِناءٌ':Added, #1: 1	قَطْعِ الْإِمْسَاكِ
u'قَطْعٌ أُنْثَى':Added, #2: 2	قَطْعِ الْإِنَاءِ
u'قَطَعَ إِنْسانٌ':Subject, #1: 1	قَطْعِ الْأُنْثَيَيْنِ
u'قَطَعَ أنصار':Predicate, #8: 8	قَطَعَ إنْسَانٌ
u'قَطَعَ أَنْصارٌ':Predicate, #2: 2	أَقْطَعَ الأَنْصَارَ
u'قَطَعَ أَنْصَارٌ':Predicate, #2: 2	أَقْطَعَ الأَنْصَارَ
u'قَطَعَ أَنْفٌ':Predicate, #2: 2	أَقْطَعَ الأَنْصَارَ
u'قَطَعَ أَنْفٌ':Predicate, #1: 1	قَطَعَ الْأَنْفَ
u'قَطَعَ أَنْفٌ':Subject, #2: 2	قَطَعَ أَنْفَ
u'قَطْعٌ أَنْفٌ':Added, #1: 1	قَطَعَ أَنْفُهُ
u'قَطْعٌ أَنْفٌ':Added, #1: 1	قَطْعُ الْأَنْفِ
u'قَطْعٌ أَنْفٌ':Added, #1: 1	قَطْعِ الْأَنْفِ
u'قَطَعَ أُنْمُلَةٌ':Predicate, #1: 1	قَطْعِ أَنْفِ
u'قَطْعٌ أُنْمُلَةٌ':Added, #1: 1	قَطَعَ أُنْمُلَةَ
u'قَطْعٌ أُنْمُلَةٌ':Added, #1: 1	قَطْعَ الْأُنْمُلَةِ
u'قَطْعٌ أُنْمُلَةٌ':Added, #1: 1	قَطْعُ الْأُنْمُلَةِ
u'قَطْعٌ أُنْمُلَةٌ':Added, #1: 1	قَطْعِ الْأُنْمُلَةِ
u'قَطْعٌ أُنْمُلَةٌ':Added, #1: 1	قَطْعُ أُنْمُلَةِ
u'قَطْعٌ أَنْهُرٌ':Added, #1: 1	قَطْعِ أُنْمُلَةِ
u'قَطَعَ أهْلٌ':Subject, #1: 1	قَطْعِ الْأَنْهُرِ
u'قَطْعٌ أهْلٌ':Added, #2: 2	قَطَعَ أَهْلُ
u'قَطْعٌ أَوْتَارٌ':Added, #1: 1	قَطْعَ أَهْلِ
u'قَطَعَ أوداج':Predicate, #1: 1	قَطْعُ الْأَوْتَارِ
u'قَطْعٌ أوداج':Added, #6: 6	قَطَعَ الْأَوْدَاجَ
u'قَطْعٌ أوداج':Added, #7: 7	قَطْعِ الْأَوْدَاجِ
u'قَطَعَ أَوْدِيَةٌ':Predicate, #8: 8	قَطْعُ الْأَوْدَاجِ
u'قَطَعَ أَوَّلُ':Predicate, #1: 1	قَطَعَ الأَوْدِيَةَ
u'قَطَعَ أَوَّلُ':Subject, #2: 2	قَطَعَ الْأَوَّلَ
u'قَطْعٌ أَوَّلُ':Added, #1: 1	قَطَعَ الْأَوَّلُ
u'قَطَعَ أَيْدِي':Predicate, #2: 2	قَطْعِ الْأَوَّلِ
u'قَطْعٌ إيمَانٌ':Added, #1: 1	قَطَعَ الْأَيْدِيَ
u'قَطْعٌ بَابٌ':Added, #1: 1	قَطْعَ الْإِيمَانِ
u'قَطْعٌ بادِي':Added, #1: 1	قَطْعُ بَابِ
u'قَطْعٌ بَادِيَةٌ':Added, #1: 1	قَطْعِ الْبَادِيَةِ
u'قَطْعٌ باسُورٌ':Added, #1: 1	قَطْعِ الْبَادِيَةِ
u'قَطَعَ باقِي':Predicate, #1: 1	قَطْعَ الْبَاسُورِ
u'قَطَعَ باقِي':Predicate, #1: 1	قَطَعَ بَاقِيَ
u'قَطَعَ بَائِعٌ':Subject, #2: 2	قَطَعَ الْبَاقِيَ
u'قَطْعٌ بَائِعٌ':Added, #17: 17	قَطَعَ الْبَائِعُ
u'قَطَعَ بَحْرٌ':Predicate, #1: 1	قَطْعِ الْبَائِعِ
u'قَطْعٌ بَحْرٌ':Added, #1: 1	أَقْطَعَ الْبَحْرَ
u'قَطَعَ بساط':Predicate, #1: 1	قَطْعِ الْبَحْرِ
u'قَطَعَ بِساطٌ':Predicate, #1: 1	قَطَعَ الْبِسَاطَ
u'قَطْعٌ بُسْرٌ':Added, #1: 1	قَطَعَ الْبِسَاطَ
u'قَطَعَ بِطِّيخٌ':Predicate, #1: 1	قَطْعِ الْبُسْرِ
u'قَطَعَ بَعْضٌ':Predicate, #1: 1	قَطَعَ الْبِطِّيخَ
u'قَطَعَ بَعْضٌ':Predicate, #13: 13	قَطَعَ بَعْضَ
u'قَطَعَ بَعْضٌ':Subject, #2: 2	قَطَعَ الْبَعْضَ
u'قَطْعٌ بَعْضٌ':Added, #4: 4	قَطَعَ بَعْضُ
u'قَطْعٌ بَعْضٌ':Added, #1: 1	قَطْعَ بَعْضٍ
u'قَطْعٌ بَعْضٌ':Added, #2: 2	قَطْعُ الْبَعْضِ
u'قَطْعٌ بَعْضٌ':Added, #2: 2	قَطْعُ بَعْضِ
u'قَطْعٌ بَعْضٌ':Added, #2: 2	قَطْعِ بَعْضِهِ
u'قَطْعٌ بوَاسِيرُ':Added, #9: 9	قَطْعِ بَعْضِ
u'قَطْعٌ بَوَاسِيرُ':Added, #1: 1	قَطْعُ الْبَوَاسِيرِ
u'قَطْعٌ بَيْضَةٌ':Added, #1: 1	قَطْعُ الْبَوَاسِيرِ
u'قَطَعَ بَيْنٌ':Predicate, #2: 2	قَطْعِ الْبَيْضَةِ
u'قَطْعٌ تَأْبِيدٌ':Added, #1: 1	قَطَعَ بَيْنَ
u'قَطَعَ تَأْثِيرٌ':Predicate, #1: 1	قَطْعَ التَّأْبِيدِ
u'قَطَعَ تَتَابُعٌ':Predicate, #1: 1	قَطَعَ تَأْثِيرَ
u'قَطْعٌ تَتَابُعٌ':Added, #1: 1	قَطَعَ التَّتَابُعَ
u'قَطْعٌ تَتَابُعٌ':Added, #1: 1	قَطْع التَّتَابُعِ
u'قَطْعٌ تَرْجِيحٌ':Added, #4: 4	قَطْعِ التَّتَابُعِ
u'قَطْعٌ تَرْكٌ':Added, #1: 1	قَطْعُ التَّرْجِيحِ
u'قَطَعَ تَصَرُّفٌ':Predicate, #1: 1	قَطْعَ تَرْكٍ
u'قَطْعٌ تَفْسِيرٌ':Added, #1: 1	قَطَعَ تَصَرُّفَ
u'قَطَعَ تَكْبيرٌ':Predicate, #1: 1	قَطْعِ تَفْسِيرِ
u'قَطَعَ تَلْبيَةٌ':Predicate, #2: 2	قَطَعَ التَّكْبِيرَ
u'قَطْعٌ تَلْبيَةٌ':Added, #20: 20	قَطَعَ التَّلْبِيَةَ
u'قَطْعٌ تَلْبيَةٌ':Added, #4: 4	قَطْعَ التَّلْبِيَةِ
u'قَطْعٌ تَلْبيَةٌ':Added, #4: 4	قَطْعُ التَّلْبِيَةِ
u'قَطْعٌ تمام':Added, #9: 9	قَطْعِ التَّلْبِيَةِ
u'قَطْعٌ تَمامٌ':Added, #1: 1	قَطْعِ تَمَامِ
u'قَطَعَ تَنَازُعٌ':Predicate, #1: 1	قَطْعِ تَمَامِ
u'قَطْعٌ تَنَازُعٌ':Added, #1: 1	قَطَعَ التَّنَازُعَ
u'قَطَعَ ثَانِي':Predicate, #1: 1	قَطْعُ التَّنَازُعِ
u'قَطَعَ ثَانِي':Predicate, #1: 1	قَطَعَ الثَّانِيَ
u'قَطَعَ ثَانِيَةٌ':Predicate, #1: 1	قَطَعَ الثَّانِيَةَ
u'قَطَعَ ثَلاثُ':Predicate, #1: 1	قَطَعَ الثَّانِيَةَ
u'قَطَعَ ثَلاثُ':Predicate, #1: 1	قَطَعَ الثَّلَاثَ
u'قَطَعَ ثَلاثَةٌ':Predicate, #3: 3	قَطَعَ ثَلَاثَ
u'قَطْعٌ ثَلاثَةٌ':Added, #1: 1	قَطَعَ ثَلاَثَةَ
u'قَطْعٌ ثَلاثَةٌ':Added, #1: 1	قَطْعِ الثَّلَاثَةِ
u'قَطْعٌ ثِمارٌ':Added, #1: 1	قَطْعِ ثَلَاثَةٍ
u'قَطَعَ ثَمَرٌ':Predicate, #1: 1	قَطْعِ الثِّمَارِ
u'قَطْعٌ ثَمَرٌ':Added, #2: 2	قَطَعَ الثَّمَرَ
u'قَطْعٌ ثَمَرٌ':Added, #1: 1	قَطْعَ الثَّمَرِ
u'قَطْعٌ ثَمَرٌ':Added, #1: 1	قَطْعَ ثَمَرِهِ
u'قَطْعٌ ثَمَرٌ':Added, #2: 2	قَطْعُ الثَّمَرِ
u'قَطَعَ ثَمَرَةٌ':Predicate, #2: 2	قَطْعِ الثَّمَرِ
u'قَطْعٌ ثَمَرَةٌ':Added, #2: 2	قَطَعَ الثَّمَرَةَ
u'قَطْعٌ ثَمَرَةٌ':Added, #1: 1	قَطْعَ الثَّمَرَةِ
u'قَطْعٌ ثَمَرَةٌ':Added, #1: 1	قَطْعَ ثَمَرَةِ
u'قَطْعٌ ثَمَرَةٌ':Added, #1: 1	قَطْعَ ثَمَرَتِهِ
u'قَطْعٌ ثَمَرَةٌ':Added, #2: 2	قَطْعُ الثَّمَرَةِ
u'قَطْعٌ ثَمَنٌ':Added, #5: 5	قَطْعِ الثَّمَرَةِ
u'قَطْعٌ ثَمَنٌ':Added, #1: 1	قَطْعِ ثَمَنٍ
u'قَطَّعَ ثَوْبٌ':Predicate, #2: 2	قَطْعِ ثَمَنِهِ
u'قَطَعَ ثَوْبٌ':Predicate, #1: 1	قَطَّعَ الثَّوْبَ
u'قَطْعٌ ثَوْبٌ':Added, #7: 7	قَطَعَ الثَّوْبَ
u'قَطْعٌ ثَوْبٌ':Added, #1: 1	قَطْعِ الثَّوْبِ
u'قَطْعٌ ثَوْبٌ':Added, #1: 1	قَطْعِ ثَوْبٍ
u'قَطْعٌ ثَوْبٌ':Added, #2: 2	قَطْعَ الثَّوْبِ
u'قَطَّعَ ثِيابٌ':Predicate, #4: 4	قَطْعُ الثَّوْبِ
u'قَطْعٌ جَاحِدٌ':Added, #1: 1	قَطَّعَ الثِّيَابَ
u'قَطْعٌ جَارِحٌ':Added, #1: 1	قَطْعِ جَاحِدِ
u'قَطْعٌ جَارِحَةٌ':Added, #2: 2	قَطْعِ جَارِحَةٍ
u'قَطْعٌ جِرْمٌ':Added, #2: 2	قَطْعِ جَارِحَةٍ
u'قَطْعٌ جُزْءٌ':Added, #1: 1	قَطْعِ جِرْمٍ
u'قَطْعٌ جِزْيَةٌ':Added, #1: 1	قَطْعَ جُزْءٍ
u'قَطْعٌ جَفْنٌ':Added, #2: 2	قَطْعَ الْجِزْيَةِ
u'قَطَعَ جُفُونٌ':Predicate, #1: 1	قَطْعِ الْجَفْنِ
u'قَطْعٌ جُفُونٌ':Added, #4: 4	قَطَعَ الْجُفُونَ
u'قَطَعَ جلد':Predicate, #2: 2	قَطْعِ الْجُفُونِ
u'قَطَعَ جِلْدٌ':Predicate, #1: 1	قَطَعَ الْجِلْدَ
u'قَطْعٌ جلد':Added, #1: 1	قَطَعَ الْجِلْدَ
u'قَطْعٌ جِلْدٌ':Added, #1: 1	قَطْعَ جِلْدِهِ
u'قَطْعٌ جلد':Added, #1: 1	قَطْعَ جِلْدِهِ
u'قَطْعٌ جِلْدٌ':Added, #2: 2	قَطْعَ الْجِلْدِ
u'قَطْعٌ جلد':Added, #2: 2	قَطْعَ الْجِلْدِ
u'قَطْعٌ جِلْدٌ':Added, #3: 3	قَطْعِ الْجِلْدِ
u'قَطَعَ جِلْدَةٌ':Predicate, #3: 3	قَطْعِ الْجِلْدِ
u'قَطْعٌ جِلْدَةٌ':Added, #2: 2	قَطَعَ الْجِلْدَةَ
u'قَطْعٌ جِلْدَةٌ':Added, #1: 1	قَطْعِ جِلْدَةٍ
u'قَطْعٌ جِلْدَةٌ':Added, #2: 2	قَطْعِ الْجِلْدَةِ
u'قَطَعَ جَمَاعَةٌ':Subject, #4: 4	قَطْعُ الْجِلْدَةِ
u'قَطْعٌ جَمَاعَةٌ':Added, #5: 5	قَطَعَ جَمَاعَةٌ
u'قَطْعٌ جَمَاعَةٌ':Added, #1: 1	قَطْعَ الْجَمَاعَةِ
u'قَطَعَ جَمَالٌ':Subject, #1: 1	قَطْعِ جَمَاعَةٍ
u'قَطَعَ جَمَاهِيرُ':Subject, #3: 3	قَطَعَ جَمَالُ
u'قَطْعٌ جمع':Added, #1: 1	قَطَعَ جَمَاهِيرُ
u'قَطْعٌ جمع':Added, #2: 2	قَطْعُ الْجَمْعِ
u'قَطْعٌ جَمْعٌ':Added, #2: 2	قَطْعِ الْجَمْعِ
u'قَطْعٌ جَمْعٌ':Added, #2: 2	قَطْعُ الْجَمْعِ
u'قَطَعَ جمعة':Predicate, #2: 2	قَطْعِ الْجَمْعِ
u'قَطَعَ جُمُعَةٌ':Predicate, #1: 1	قَطَعَ الْجُمُعَةَ
u'قَطَعَ جُمْهُورٌ':Subject, #1: 1	قَطَعَ الْجُمُعَةَ
u'قَطْعٌ جُمْهُورٌ':Added, #10: 10	قَطَعَ الْجُمْهُورُ
u'قَطْعٌ جُمْهُورٌ':Added, #1: 1	قَطْعِ الْجُمْهُورِ
u'قَطَعَ جَمِيع':Predicate, #1: 1	قَطْعِ جُمْهُورِ
u'قَطَعَ جَمِيع':Subject, #1: 1	قَطَعَ الْجَمِيعَ
u'قَطْعٌ جَمِيع':Added, #1: 1	قَطَعَ الْجَمِيعُ
u'قَطَعَ حَبْلٌ':Predicate, #1: 1	قَطْعُ الْجَمِيعِ
u'قَطْعٌ حَبيبٌ':Added, #2: 2	قَطَعَ الْحَبْلَ
u'قَطْعٌ حَجٌّ':Added, #1: 1	قَطْعُ الْحَبِيبِ
u'قَطَعَ حُرٌّ':Subject, #1: 1	قَطْعَ الْحَجِّ
u'قَطْعٌ حَرْفٌ':Added, #3: 3	قَطَعَ حُرٌّ
u'قَطْعٌ حَرَمٌ':Added, #1: 1	قَطْعِ حَرْفِهِ
u'قَطَعَ حَشَفَةٌ':Predicate, #1: 1	قَطْعَ الْحَرَمِ
u'قَطَعَ حَشَفَةٌ':Predicate, #1: 1	قَطَعَ حَشَفَةَ
u'قَطْعٌ حَشَفَةٌ':Added, #7: 7	قَطَعَ الْحَشَفَةَ
u'قَطْعٌ حَشَفَةٌ':Added, #1: 1	قَطْعَ الْحَشَفَةِ
u'قَطْعٌ حَشَفَةٌ':Added, #2: 2	قَطْعُ الْحَشَفَةِ
u'قَطَعَ حَشِيشٌ':Predicate, #4: 4	قَطْعِ الْحَشَفَةِ
u'قَطَعَ حَشِيشٌ':Predicate, #1: 1	قَطَعَ الْحَشِيشَ
u'قَطْعٌ حَشِيشٌ':Added, #7: 7	قَطَعَ حَشِيشَ
u'قَطْعٌ حَشِيشٌ':Added, #1: 1	قَطْعِ الْحَشِيشِ
u'قَطْعٌ حَشِيشٌ':Added, #1: 1	قَطْعُ حَشِيشٍ
u'قَطْعٌ حَطَبٌ':Added, #2: 2	قَطْعُ الْحَشِيشِ
u'قَطَعَ حَقٌّ':Predicate, #2: 2	قَطْعُ الْحَطَبِ
u'قَطْعٌ حَقٌّ':Added, #3: 3	قَطَعَ حَقَّ
u'قَطْعٌ حَقٌّ':Added, #1: 1	قَطْعُ حَقِّ
u'قَطْعٌ حَقٌّ':Added, #1: 1	قَطْعِ حَقِّ
u'قَطَعَ حُقوقٌ':Predicate, #1: 1	قَطْعَ حَقِّهِ
u'قَطَعَ حُقُوقٌ':Predicate, #2: 2	قَطَعَ حُقُوقَ
u'قَطَعَ حُكْمٌ':Predicate, #2: 2	قَطَعَ حُقُوقَ
u'قَطْعٌ حُكْمٌ':Added, #1: 1	قَطَعَ الْحُكْمَ
u'قَطْعٌ حُكْمٌ':Added, #1: 1	قَطْعَ الْحُكْمِ
u'قَطَعَ حَلالٌ':Subject, #1: 1	قَطْعُ حُكْمٍ
u'قَطَعَ حَلْقٌ':Predicate, #1: 1	قَطَعَ حَلَالٌ
u'قَطْعٌ حَلْقٌ':Added, #1: 1	قَطَعَ حَلْقَ
u'قَطَعَ حُلْقُومٌ':Predicate, #1: 1	قَطْعُ الْحَلْقِ
u'قَطَعَ حُلْقُومٌ':Predicate, #1: 1	قَطَعَ حُلْقُومَ
u'قَطْعٌ حُلْقُومٌ':Added, #4: 4	قَطَعَ الْحُلْقُومَ
u'قَطْعٌ حُلْقُومٌ':Added, #1: 1	قَطْعِ حُلْقُومِهِ
u'قَطْعٌ حُلْقُومٌ':Added, #7: 7	قَطْعِ الْحُلْقُومِ
u'قَطْعٌ حُلِيٌّ':Added, #8: 8	قَطْعُ الْحُلْقُومِ
u'قَطْعٌ حَمَّامٌ':Added, #1: 1	قَطْعُ الْحُلِيِّ
u'قَطَعَ حَوافِرُ':Predicate, #2: 2	قَطْعُ حَمَّامٍ
u'قَطْعٌ حَيْضٌ':Added, #1: 1	قَطَعَ حَوَافِرَ
u'قَطْعٌ حَيْضٌ':Added, #1: 1	قَطْعُ الْحَيْضِ
u'قَطْعٌ خُبْزٌ':Added, #1: 1	قَطْعِ الْحَيْضِ
u'قَطْعٌ خُبْزٌ':Added, #1: 1	قَطْعُ الْخُبْزِ
u'قَطْعٌ خرق':Added, #1: 1	قَطْعِ الْخُبْزِ
u'قَطْعٌ خِرَقٌ':Added, #1: 1	قَطْعِ خِرَقٍ
u'قَطْعٌ خَشَبٌ':Added, #1: 1	قَطْعِ خِرَقٍ
u'قَطْعٌ خُشُوعٌ':Added, #3: 3	قَطْعَ خَشَبٍ
u'قَطْعٌ خُصُومَةٌ':Added, #2: 2	قَطْعُ الْخُشُوعِ
u'قَطْعٌ خُصُومَةٌ':Added, #1: 1	قَطْعَ الْخُصُومَةِ
u'قَطْعٌ خُصُومَةٌ':Added, #2: 2	قَطْعِ الْخُصُومَةِ
u'قَطْعٌ خصى':Added, #6: 6	قَطْعُ الْخُصُومَةِ
u'قَطْعٌ خصى':Added, #1: 1	قَطْعَ الْخُصْيَتَيْنِ
u'قَطَعَ خطبة':Predicate, #1: 1	قَطْعُ الْخَصِيَتَيْنِ
u'قَطَعَ خُطْبَةٌ':Predicate, #2: 2	قَطَعَ الْخُطْبَةَ
u'قَطْعٌ خُفٌّ':Added, #2: 2	قَطَعَ الْخُطْبَةَ
u'قَطْعٌ خُفٌّ':Added, #1: 1	قَطْعُ الْخُفِّ
u'قَطْعٌ خُفٌّ':Added, #2: 2	قَطْعِ الْخُفِّ
u'قَطْعٌ خَمْسَةٌ':Added, #3: 3	قَطْعِ الْخُفَّيْنِ
u'قَطْعٌ خِنْصَرٌ':Added, #1: 1	قَطْعِ خَمْسَةِ
u'قَطْعٌ خيار':Added, #1: 1	قَطْعِ خِنْصَرٍ
u'قَطْعٌ خيار':Added, #2: 2	قَطْعُ الْخِيَارِ
u'قَطْعٌ خِيَارٌ':Added, #2: 2	قَطْعِ الْخِيَارِ
u'قَطْعٌ خِيَارٌ':Added, #2: 2	قَطْعُ الْخِيَارِ
u'قَطْعٌ خَيْطٌ':Added, #2: 2	قَطْعِ الْخِيَارِ
u'قَطَعَ دَرَاهِمُ':Predicate, #1: 1	قَطْعُ الْخَيْطِ
u'قَطْعٌ دَرَاهِمُ':Added, #1: 1	قَطَعَ الدَّرَاهِمَ
u'قَطْعٌ دِرْهَمٌ':Added, #1: 1	قَطْعِ الدَّرَاهِمِ
u'قَطْعٌ دِرْهَم':Added, #1: 1	قَطْعُ دِرْهَمٍ
u'قَطْعٌ دَنانيرُ':Added, #1: 1	قَطْعُ دِرْهَمٍ
u'قَطَعَ دُورٌ':Predicate, #2: 2	قَطْعُ الدَّنَانِيرِ
u'قَطَعَ ذِراعٌ':Predicate, #2: 2	أَقْطَعَ الدُّورَ
u'قَطَعَ ذِراعٌ':Predicate, #1: 1	قَطَعَ ذِرَاعَ
u'قَطْعٌ ذِراعٌ':Added, #2: 2	قَطَعَ الذِّرَاعَ
u'قَطْعٌ ذِراعٌ':Added, #1: 1	قَطْعُ الذِّرَاعِ
u'قَطَعَ ذكر':Predicate, #1: 1	قَطْعِ الذِّرَاعِ
u'قَطَعَ ذَكَرٌ':Predicate, #10: 10	قَطَعَ الذَّكَرَ
u'قَطَعَ ذكر':Predicate, #10: 10	قَطَعَ الذَّكَرَ
u'قَطَعَ ذَكَرٌ':Predicate, #2: 2	قَطَعَ ذَكَرَ
u'قَطْعٌ ذكر':Added, #2: 2	قَطَعَ ذَكَرَ
u'قَطْعٌ ذَكَرٌ':Added, #1: 1	قَطْعَ الذَّكَرِ
u'قَطْعٌ ذَكَرٌ':Added, #1: 1	قَطْعَ الذَّكَرِ
u'قَطْعٌ ذكر':Added, #1: 1	قَطْعِ ذَكَرٍ
u'قَطْعٌ ذَكَرٌ':Added, #3: 3	قَطْعُ الذَّكَرِ
u'قَطْعٌ ذكر':Added, #3: 3	قَطْعُ الذَّكَرِ
u'قَطْعٌ ذَكَرٌ':Added, #7: 7	قَطْعِ الذَّكَرِ
u'قَطَعَ ذِمِّيٌّ':Subject, #7: 7	قَطْعِ الذَّكَرِ
u'قَطَعَ ذَنَبٌ':Predicate, #4: 4	قَطَعَ ذِمِّيٌّ
u'قَطْعٌ ذَهَبٌ':Added, #7: 7	قَطَعَ ذَنَبَ
u'قَطَعَ ذِئْبٌ':Subject, #1: 1	قَطْعُ الذَّهَبِ
u'قَطَعَ رابع':Predicate, #3: 3	قَطَعَ الذِّئْبُ
u'قَطَعَ رَابِعٌ':Predicate, #1: 1	قَطَعَ الرَّابِعَةَ
u'قَطَعَ رَأْسٌ':Predicate, #1: 1	قَطَعَ الرَّابِعَةَ
u'قَطَعَ رَأْسٌ':Predicate, #2: 2	قَطَعَ رَأْسَ
u'قَطْعٌ رَأْسٌ':Added, #4: 4	قَطَعَ الرَّأْسَ
u'قَطْعٌ رَأْسٌ':Added, #1: 1	قَطْعُ الرَّأْسِ
u'قَطْعٌ رَأْسٌ':Added, #1: 1	قَطْعِ رَأْسٍ
u'قَطْعٌ رَأْسٌ':Added, #1: 1	قَطْعِ رَأْسِ
u'قَطْعٌ رَأْسٌ':Added, #2: 2	قَطْعُ رَأْسِهِ
u'قَطْعٌ رَائِحٌ':Added, #3: 3	قَطْعِ الرَّأْسِ
u'قَطْعٌ رَائِحٌ':Added, #1: 1	قَطْعِ الرَّائِحَةِ
u'قَطْعٌ رَائِحٌ':Added, #1: 1	قَطْعَ رَائِحَةٍ
u'قَطْعٌ رَائِحٌ':Added, #1: 1	قَطْعِ رَائِحَةٍ
u'قَطْعٌ رَائِحٌ':Added, #2: 2	قَطْعُ الرَّائِحَةِ
u'قَطْعٌ رَائِحَةٌ':Added, #2: 2	قَطْعِ رَائِحَتِهِ
u'قَطْعٌ رَائِحَةٌ':Added, #1: 1	قَطْعِ الرَّائِحَةِ
u'قَطْعٌ رَائِحَةٌ':Added, #1: 1	قَطْعَ رَائِحَةٍ
u'قَطْعٌ رَائِحَةٌ':Added, #1: 1	قَطْعِ رَائِحَةٍ
u'قَطْعٌ رَائِحَةٌ':Added, #2: 2	قَطْعُ الرَّائِحَةِ
u'قَطْعٌ رَبْطٌ':Added, #2: 2	قَطْعِ رَائِحَتِهِ
u'قَطَعَ رُبُعٌ':Predicate, #1: 1	قَطْعُ الرَّبْطِ
u'قَطْعٌ رجعة':Added, #2: 2	قَطَعَ رُبُعَ
u'قَطْعٌ رجعة':Added, #1: 1	قَطْعَ الرَّجْعَةِ
u'قَطْعٌ رَجْعَةٌ':Added, #1: 1	قَطْعِ الرَّجْعَةِ
u'قَطْعٌ رَجْعَةٌ':Added, #1: 1	قَطْعَ الرَّجْعَةِ
u'قَطْعٌ رجعة':Added, #1: 1	قَطْعِ الرَّجْعَةِ
u'قَطْعٌ رَجْعَةٌ':Added, #5: 5	قَطْعُ الرَّجْعَةِ
u'قَطَعَ رِجْلٌ':Predicate, #5: 5	قَطْعُ الرَّجْعَةِ
u'قَطَعَ رَجُلٌ':Predicate, #1: 1	قَطَعَ رِجْلَ
u'قَطَعَ رِجْلٌ':Predicate, #2: 2	قَطَعَ رَجُلاً
u'قَطَعَ رَجُلٌ':Subject, #3: 3	قَطَعَ الرِّجْلَ
u'قَطَعَ رَجُلٌ':Subject, #23: 23	قَطَعَ رَجُلٌ
u'قَطْعٌ رَجُلٌ':Added, #9: 9	قَطَعَ الرَّجُلُ
u'قَطْعٌ رِجْلٌ':Added, #1: 1	قَطْعِ الرَّجُلِ
u'قَطْعٌ رِجْلٌ':Added, #1: 1	قَطْعِ الرِّجْلِ
u'قَطْعٌ رِجْلٌ':Added, #1: 1	قَطْعَ رِجْلِهِ
u'قَطْعٌ رِجْلٌ':Added, #2: 2	قَطْعَ الرِّجْلِ
u'قَطْعٌ رِجْلٌ':Added, #2: 2	قَطْعُ رِجْلِهِ
u'قَطْعٌ رُجُوعٌ':Added, #6: 6	قَطْعِ رِجْلِهِ
u'قَطْعٌ رحم':Added, #1: 1	قَطْعُ الرُّجُوعِ
u'قَطْعٌ رَحِمٌ':Added, #1: 1	قَطْعُ الرَّحِمِ
u'قَطْعٌ رَحِمٌ':Added, #1: 1	قَطْعُ الرَّحِمِ
u'قَطْعٌ رحم':Added, #1: 1	قَطْعَ رَحِمٍ
u'قَطْعٌ رَحِمٌ':Added, #2: 2	قَطْعَ الرَّحِمِ
u'قَطْعٌ رحم':Added, #2: 2	قَطْعَ الرَّحِمِ
u'قَطْعٌ رَحِمٌ':Added, #3: 3	قَطْعِ الرَّحِمِ
u'قَطَعَ رَسُولٌ':Subject, #3: 3	قَطْعِ الرَّحِمِ
u'قَطْعٌ رَضيعٌ':Added, #7: 7	قَطَعَ رَسُولُ
u'قَطَعَ رعاف':Predicate, #1: 1	قَطْعَ الرَّضِيعِ
u'قَطَعَ رُعافٌ':Predicate, #1: 1	قَطَعَ الرُّعَافَ
u'قَطْعٌ رَغْبَةٌ':Added, #1: 1	قَطَعَ الرُّعَافَ
u'قَطْعٌ رُكوعٌ':Added, #1: 1	قَطْعِ الرَّغْبَةِ
u'قَطْعٌ زائِدٌ':Added, #3: 3	قَطْعِ الرُّكُوعِ
u'قَطْعٌ زائِدٌ':Added, #1: 1	قَطْعِ زَائِدَةٍ
u'قَطْعٌ زُروعٌ':Added, #2: 2	قَطْعِ الزَّائِدِ
u'قَطْعٌ زَوْجِيٌّ':Added, #1: 1	قَطْعُ الزُّرُوعِ
u'قَطْعٌ زَيْتونَةٌ':Added, #1: 1	قَطْعِ الزَّوْجِيَّةِ
u'قَطَعَ سَارِقٌ':Predicate, #1: 1	قَطْعِ الزَّيْتُونَةِ
u'قَطَعَ سَارِقٌ':Predicate, #1: 1	قَطَعَ السَّارِقَ
u'قَطْعٌ سَارِقٌ':Added, #2: 2	قَطَعَ سَارِقَ
u'قَطْعٌ سَارِقٌ':Added, #1: 1	قَطْع السَّارِقِ
u'قَطْعٌ سَارِقٌ':Added, #1: 1	قَطْعَ السَّارِقِ
u'قَطْعٌ سَارِقٌ':Added, #1: 1	قَطْعَ سَارِقِ
u'قَطْعٌ سَارِقٌ':Added, #6: 6	قَطْعُ السَّارِقِ
u'قَطَعَ سَاعِدٌ':Predicate, #6: 6	قَطْعِ السَّارِقِ
u'قَطْعٌ سَبَبٌ':Added, #1: 1	قَطَعَ سَاعِدَ
u'قَطْعٌ سَبِيلٌ':Added, #1: 1	قَطْعَ السَّبَبِ
u'قَطْعٌ سَبِيلٌ':Added, #2: 2	قَطْعِ سَبِيلٍ
u'قَطَعَ سِدْرٌ':Predicate, #3: 3	قَطْعَ السَّبِيلِ
u'قَطْعٌ سِدْرٌ':Added, #4: 4	قَطَعَ السِّدْرَ
u'قَطْعٌ سِدْرٌ':Added, #1: 1	قَطْعِ سِدْرٍ
u'قَطْعٌ سُرَّةٌ':Added, #6: 6	قَطْعِ السِّدْرِ
u'قَطْعٌ سَرقَةٌ':Added, #1: 1	قَطْعُ السُّرَّةِ
u'قَطْعٌ سَرِقَةٌ':Added, #14: 14	قَطْعِ السَّرِقَةِ
u'قَطْعٌ سَرقَةٌ':Added, #14: 14	قَطْعِ السَّرِقَةِ
u'قَطْعٌ سَرِقَةٌ':Added, #1: 1	قَطْعُ سَرِقَةِ
u'قَطْعٌ سَرقَةٌ':Added, #1: 1	قَطْعُ سَرِقَةِ
u'قَطْعٌ سَرِقَةٌ':Added, #2: 2	قَطْعُ السَّرِقَةِ
u'قَطْعٌ سَرقَةٌ':Added, #2: 2	قَطْعُ السَّرِقَةِ
u'قَطْعٌ سَرِقَةٌ':Added, #4: 4	قَطْعِ سَرِقَةٍ
u'قَطْعٌ سَعَفٌ':Added, #4: 4	قَطْعِ سَرِقَةٍ
u'قَطْعٌ سَعَف':Added, #1: 1	قَطْعَ السَّعَفِ
u'قَطْعٌ سَفَرٌ':Added, #1: 1	قَطْعَ السَّعَفِ
u'قَطْعٌ سَفَرٌ':Added, #2: 2	قَطْعُ السَّفَرِ
u'قَطْعٌ سَلْطَنَةٌ':Added, #6: 6	قَطْعَ السَّفَرِ
u'قَطْعٌ سِلْعَةٌ':Added, #1: 1	قَطْعُ سَلْطَنَةٍ
u'قَطْعٌ سِلْعَةٌ':Added, #1: 1	قَطْعُ السِّلْعَةِ
u'قَطْعٌ سِلْعَةٌ':Added, #2: 2	قَطْعِ سِلْعَتِهِ
u'قَطْعٌ سِلْعَةٌ':Added, #4: 4	قَطْعِ سِلْعَةٍ
u'قَطَعَ سَلِيمٌ':Subject, #5: 5	قَطْعِ السِّلْعَةِ
u'قَطَعَ سَلِيمٌ':Subject, #1: 1	قَطَعَ سَلِيمُ
u'قَطْعٌ سمر':Added, #4: 4	قَطَعَ السَّلِيمُ
u'قَطْعٌ سَمَرٌ':Added, #1: 1	قَطْعِ السَّمَرِ
u'قَطْعٌ سمر':Added, #1: 1	قَطْعِ السَّمَرِ
u'قَطْعٌ سَمَرٌ':Added, #2: 2	قَطْعَ السَّمَرِ
u'قَطْعٌ سمر':Added, #2: 2	قَطْعَ السَّمَرِ
u'قَطْعٌ سَمَرٌ':Added, #4: 4	قَطْعُ السَّمَرِ
u'قَطْعٌ سِنٌّ':Added, #4: 4	قَطْعُ السَّمَرِ
u'قَطَعَ سُنَّةٌ':Predicate, #1: 1	قَطْعُ السِّنِّ
u'قَطَعَ سَهْمٌ':Subject, #1: 1	قَطَعَ سُنَّةَ
u'قَطْعٌ سَيْرٌ':Added, #1: 1	قَطَعَ السَّهْمُ
u'قَطَعَ سَيْفٌ':Subject, #1: 1	قَطْعِ السَّيْرِ
u'قَطَعَ شَارِبٌ':Predicate, #1: 1	قَطَعَ السَّيْفُ
u'قَطَعَ شَارِحٌ':Subject, #1: 1	قَطَعَ الشَّارِبَ
u'قَطْعٌ شَارِعٌ':Added, #3: 3	قَطَعَ الشَّارِحُ
u'قَطَعَ شافِعِيّ':Subject, #1: 1	قَطْعُ الشَّارِعِ
u'قَطْعٌ شَائِعٌ':Added, #3: 3	قَطَعَ الشَّافِعِيُّ
u'قَطَعَ شَجَرٌ':Predicate, #1: 1	قَطْعِ الشَّائِعِ
u'قَطْعٌ شَجَرٌ':Added, #1: 1	قَطَعَ شَجَرَ
u'قَطْعٌ شَجَرٌ':Added, #1: 1	قَطْعٍ شَجَرٍ
u'قَطْعٌ شَجَرٌ':Added, #1: 1	قَطْعَ شَجَرِ
u'قَطْعٌ شَجَرٌ':Added, #2: 2	قَطْعُ شَجَرِ
u'قَطْعٌ شَجَرٌ':Added, #2: 2	قَطْعُ شَجَرِهِ
u'قَطْعٌ شَجَرٌ':Added, #3: 3	قَطْعَ الشَّجَرِ
u'قَطْعٌ شَجَرٌ':Added, #3: 3	قَطْعِ شَجَرِ
u'قَطْعٌ شَجَرٌ':Added, #4: 4	قَطْعُ الشَّجَرِ
u'قَطَعَ شَجَرَةٌ':Predicate, #5: 5	قَطْعِ الشَّجَرِ
u'قَطَعَ شَجَرَةٌ':Predicate, #1: 1	قَطَعَ الشَّجَرَةَ
u'قَطْعٌ شَجَرَةٌ':Added, #1: 1	قَطَعَ شَجَرَةَ
u'قَطْعٌ شَجَرَةٌ':Added, #1: 1	قَطْعَ الشَّجَرَةِ
u'قَطْعٌ شَجَرَةٌ':Added, #1: 1	قَطْعِ الشَّجَرَةِ
u'قَطْعٌ شَجَرَةٌ':Added, #1: 1	قَطْعُ شَجَرَةٍ
u'قَطَعَ شحمة':Predicate, #1: 1	قَطْعِ شَجَرَةِ
u'قَطَعَ شَحْمَةٌ':Predicate, #1: 1	قَطَعَ شَحْمَةَ
u'قَطْعٌ شَخْصٌ':Added, #1: 1	قَطَعَ شَحْمَةَ
u'قَطْعٌ شراك':Added, #1: 1	قَطْعِ شَخْصٍ
u'قَطْعٌ شِرَاكٌ':Added, #1: 1	قَطْعِ الشِّرَاكِ
u'قَطَعَ شَرْعٌ':Subject, #1: 1	قَطْعِ الشِّرَاكِ
u'قَطْعٌ شركة':Added, #1: 1	قَطَعَ الشَّرْعُ
u'قَطْعٌ شَرِكَةٌ':Added, #1: 1	قَطْعِ شَرِكَةِ
u'قَطْعٌ شركة':Added, #1: 1	قَطْعِ شَرِكَةِ
u'قَطْعٌ شَرِكَةٌ':Added, #23: 23	قَطْعِ الشَّرِكَةِ
u'قَطْعٌ شركة':Added, #23: 23	قَطْعِ الشَّرِكَةِ
u'قَطْعٌ شَرِكَةٌ':Added, #3: 3	قَطْعَ الشَّرِكَةِ
u'قَطَعَ شَرِيفٌ':Subject, #3: 3	قَطْعَ الشَّرِكَةِ
u'قَطْعٌ شَعْرٌ':Added, #1: 1	قَطَعَ الشَّرِيفُ
u'قَطْعٌ شَفْرَةٌ':Added, #1: 1	قَطْعِ الشَّعْرِ
u'قَطْعٌ شَهْوَةٌ':Added, #1: 1	قَطْعَ الشَّفْرَةِ
u'قَطْعٌ شَوْكٌ':Added, #1: 1	قَطْعِ شَهْوَةِ
u'قَطْعٌ شَوْكٌ':Added, #1: 1	قَطْعُ الشَّوْكِ
u'قَطْعٌ شَوْكِ':Added, #1: 1	قَطْعِ الشَّوْكِ
u'قَطْعٌ شَوْكِ':Added, #1: 1	قَطْعُ الشَّوْكِ
u'قَطْعٌ شَيْءٌ':Added, #1: 1	قَطْعِ الشَّوْكِ
u'قَطْعٌ شَيْءٌ':Added, #1: 1	قَطْعِ شَيْءٍ
u'قَطَعَ شَيْخٌ':Subject, #2: 2	قَطْعُ شَيْءٍ
u'قَطْعٌ شَيْخٌ':Added, #9: 9	قَطَعَ الشَّيْخُ
u'قَطَعَ شِيرازِيّ':Subject, #1: 1	قَطْعِ الشَّيْخِ
u'قَطَعَ صَاحِبٌ':Subject, #1: 1	قَطَعَ الشِّيرَازِيُّ
u'قَطْعٌ صَاحِبٌ':Added, #4: 4	قَطَعَ صَاحِبُ
u'قَطْعٌ صَاحِبٌ':Added, #1: 1	قَطْعُ صَاحِبِ
u'قَطَعَ صَحِيحٌ':Predicate, #2: 2	قَطْعِ صَاحِبِ
u'قَطْعٌ صَرْم':Added, #1: 1	قَطَعَ صَحِيحَ
u'قَطْعٌ صَفٌّ':Added, #2: 2	قَطْعُ الصَّرْمِ
u'قَطْعٌ صَفٌّ':Added, #1: 1	قَطْعَ الصَّفِّ
u'قَطَعَ صَلاَةٌ':Predicate, #1: 1	قَطْعُ الصَّفِّ
u'قَطْعٌ صَلاَةٌ':Added, #9: 9	قَطَعَ الصَّلَاةَ
u'قَطْعٌ صَلاَةٌ':Added, #1: 1	قَطْعِ صَلَاةِ
u'قَطْعٌ صَلاَةٌ':Added, #1: 1	قَطْعُ صَلَاتِهِ
u'قَطْعٌ صَلاَةٌ':Added, #1: 1	قَطْعِ صَلَاتِهِ
u'قَطْعٌ صَلاَةٌ':Added, #2: 2	قَطْعَ صَلَاتِهِ
u'قَطْعٌ صَلاَةٌ':Added, #8: 8	قَطْعَ الصَّلَاةِ
u'قَطْعٌ صَلاَةٌ':Added, #8: 8	قَطْعُ الصَّلَاةِ
u'قَطْعٌ صُوفٌ':Added, #9: 9	قَطْعِ الصَّلَاةِ
u'قَطْعٌ صَوْمٌ':Added, #1: 1	قَطْعُ الصُّوفِ
u'قَطَعَ صَيْدٌ':Predicate, #1: 1	قَطْعَ الصَّوْمِ
u'قَطَعَ صَيْرَفِيٌّ':Subject, #1: 1	قَطَعَ الصَّيْدَ
u'قَطْعٌ ضَرَرٌ':Added, #1: 1	قَطَعَ الصَّيْرَفِيُّ
u'قَطَعَ ضَفِيرٌ':Predicate, #1: 1	قَطْعَ الضَّرَرِ
u'قَطَعَ ضَفِيرَةٌ':Predicate, #1: 1	قَطَعَ ضَفِيرَةَ
u'قَطَعَ طرف':Predicate, #1: 1	قَطَعَ ضَفِيرَةَ
u'قَطَعَ طَرَفٌ':Predicate, #11: 11	قَطَعَ طَرَفَ
u'قَطْعٌ طرف':Added, #11: 11	قَطَعَ طَرَفَ
u'قَطْعٌ طرف':Added, #1: 1	قَطْعَ طَرَفِ
u'قَطْعٌ طرف':Added, #1: 1	قَطْعُ طَرَفِ
u'قَطْعٌ طَرَفٌ':Added, #1: 1	قَطْعِ طَرْفِ
u'قَطْعٌ طَرَفٌ':Added, #1: 1	قَطْعَ طَرَفِ
u'قَطْعٌ طَرَفٌ':Added, #1: 1	قَطْعُ طَرَفِ
u'قَطْعٌ طَرْفٌ':Added, #1: 1	قَطْعِ طَرَفٍ
u'قَطْعٌ طَرْفٌ':Added, #1: 1	قَطْعَ طَرْفٍ
u'قَطْعٌ طرف':Added, #1: 1	قَطْعِ طَرْفِ
u'قَطْعٌ طَرَفٌ':Added, #2: 2	قَطْعُ طَرَفِهِ
u'قَطْعٌ طرف':Added, #2: 2	قَطْعُ طَرَفِهِ
u'قَطْعٌ طَرَفٌ':Added, #5: 5	قَطْعِ طَرَفِ
u'قَطْعٌ طرف':Added, #5: 5	قَطْعِ طَرَفِ
u'قَطْعٌ طَرَفٌ':Added, #6: 6	قَطْعِ الطَّرَفِ
u'قَطَعَ طَرِيقٌ':Predicate, #6: 6	قَطْعِ الطَّرَفِ
u'قَطْعٌ طَرِيقٌ':Added, #12: 12	قَطَعَ الطَّرِيقَ
u'قَطْعٌ طَرِيقٌ':Added, #47: 47	قَطْعِ الطَّرِيقِ
u'قَطْعٌ طَرِيقٌ':Added, #4: 4	قَطْعِ طَرِيقٍ
u'قَطْعٌ طَرِيقٌ':Added, #9: 9	قَطْعَ الطَّرِيقِ
u'قَطَعَ طَفْر':Predicate, #9: 9	قَطْعُ الطَّرِيقِ
u'قَطْعٌ طلب':Added, #1: 1	قَطَعَ الطَّفْرَ
u'قَطْعٌ طَلَبٌ':Added, #1: 1	قَطْعِ الطّلَبِ
u'قَطْعٌ طِلَبٌ':Added, #1: 1	قَطْعِ الطّلَبِ
u'قَطَعَ طَلْحٌ':Predicate, #1: 1	قَطْعِ الطّلَبِ
u'قَطَعَ طلحة':Predicate, #1: 1	أَقْطَعَ طَلْحَةَ
u'قَطْعٌ طَمَعٌ':Added, #1: 1	أَقْطَعَ طَلْحَةَ
u'قَطْعٌ طَمَعٌ':Added, #1: 1	قَطْعَ طَمَعٍ
u'قَطْعٌ طَهَارَةٌ':Added, #2: 2	قَطْعَ طَمَعِ
u'قَطْعٌ طواف':Added, #1: 1	قَطْعَ الطَّهَارَةِ
u'قَطْعٌ طواف':Added, #2: 2	قَطْعَ الطَّوَافِ
u'قَطْعٌ طَوَافٌ':Added, #2: 2	قَطْعُ الطَّوَافِ
u'قَطْعٌ طَوَافٌ':Added, #2: 2	قَطْعَ الطَّوَافِ
u'قَطَعَ ظاهِرٌ':Subject, #2: 2	قَطْعُ الطَّوَافِ
u'قَطْعٌ ظُفْرٌ':Added, #1: 1	قَطَعَ ظَاهِرُهُ
u'قَطْعٌ ظُهْرٌ':Added, #1: 1	قَطْعُ الظُّفْرِ
u'قَطَعَ عَامٌّ':Subject, #1: 1	قَطْعِ ظُهْرِ
u'قَطَعَ عَامِلٌ':Subject, #1: 1	قَطَعَ الْعَامَّةُ
u'قَطَعَ عِبَادٌ':Predicate, #1: 1	قَطَعَ الْعَامِلُ
u'قَطَعَ عَبْدٌ':Subject, #1: 1	قَطَعَ الْعِبَادَ
u'قَطَعَ عَبْدٌ':Subject, #5: 5	قَطَعَ عَبْدٌ
u'قَطَعَ عَذْب':Predicate, #6: 6	قَطَعَ الْعَبْدُ
u'قَطَعَ عُذْرٌ':Predicate, #1: 1	قَطَعَ عَذْبَةَ
u'قَطَعَ عَرَقٌ':Predicate, #1: 1	قَطَعَ الْعُذْرَ
u'قَطَعَ عُرُوقٌ':Predicate, #1: 1	قَطَعَ الْعَرَقَ
u'قَطْعٌ عُرُوقٌ':Added, #5: 5	قَطَعَ الْعُرُوقَ
u'قَطْعٌ عُرُوقٌ':Added, #1: 1	قَطْعِ الْعرُوُقِ
u'قَطْعٌ عُرُوقٌ':Added, #1: 1	قَطْعُ عُرُوقِ
u'قَطْعٌ عُرُوقٌ':Added, #4: 4	قَطْعِ الْعُرُوقِ
u'قَطَعَ عِشَاءٌ':Predicate, #8: 8	قَطْعُ الْعُرُوقِ
u'قَطْعٌ عِشَاءٌ':Added, #1: 1	قَطَعَ الْعِشَاءَ
u'قَطَعَ عِصْمَةٌ':Predicate, #1: 1	قَطْعِ الْعِشَاءِ
u'قَطْعٌ عِصْمَةٌ':Added, #1: 1	قَطَعَ الْعِصْمَةَ
u'قَطْعٌ عِصْمَةٌ':Added, #1: 1	قَطْعِ الْعِصْمَةِ
u'قَطْعٌ عِصْمَةٌ':Added, #1: 1	قَطْعِ عِصْمَةِ
u'قَطْعٌ عِصْمَةٌ':Added, #2: 2	قَطْعُ الْعِصْمَةِ
u'قَطْعٌ عَضُدٌ':Added, #2: 2	قَطْعُ عِصْمَةِ
u'قَطْعٌ عَضُدٌ':Added, #1: 1	قَطْعِ الْعَضُدِ
u'قَطَعَ عُضْوٌ':Predicate, #2: 2	قَطْعُ عَضُدِهِ
u'قَطْعٌ عُضْوٌ':Added, #1: 1	قَطَعَ عُضْوَ
u'قَطْعٌ عُضْوٌ':Added, #1: 1	قَطْعِ عُضْوِ
u'قَطْعٌ عُضْوٌ':Added, #2: 2	قَطْعَ الْعُضْوِ
u'قَطْعٌ عُضْوٌ':Added, #2: 2	قَطْعِ الْعُضْوِ
u'قَطْعٌ عُضْوٌ':Added, #2: 2	قَطْعَ عُضْوٍ
u'قَطْعٌ عُضْوٌ':Added, #2: 2	قَطْعِ عُضْوِهِ
u'قَطْعٌ عُضْوٌ':Added, #3: 3	قَطْعُ الْعُضْوِ
u'قَطْعٌ عُضْوٌ':Added, #4: 4	قَطْعُ عُضْوٍ
u'قَطَعَ عَقِيقٌ':Predicate, #7: 7	قَطْعِ عُضْوٍ
u'قَطْعٌ عِمَارَةٌ':Added, #1: 1	أَقْطَعَ الْعَقِيقَ
u'قَطَعَ عُمَرٌ':Subject, #1: 1	قَطْعِ الْعِمَارَاتِ
u'قَطَعَ عَمَلٌ':Predicate, #1: 1	قَطَعَ عُمَرُ
u'قَطْعٌ عِنَبٌ':Added, #1: 1	قَطَعَ الْعَمَلَ
u'قَطَعَ عند':Predicate, #2: 2	قَطْعُ الْعِنَبِ
u'قَطَعَ عنق':Predicate, #4: 4	قَطَعَ عِنْدَ
u'قَطَعَ عُنُقٌ':Predicate, #1: 1	قَطَعَ عُنُقَ
u'قَطْعٌ عَيْنٌ':Added, #1: 1	قَطَعَ عُنُقَ
u'قَطْعٌ عَيْن':Added, #1: 1	قَطْعُ عَيْنٍ
u'قَطَعَ غَاصِبٌ':Subject, #1: 1	قَطْعُ عَيْنٍ
u'قَطْعٌ غُدَّةٌ':Added, #2: 2	قَطَعَ الْغَاصِبُ
u'قَطَعَ غُصْنٌ':Predicate, #1: 1	قَطْعِ غُدَّةٍ
u'قَطْعٌ غُصْنٌ':Added, #1: 1	قَطَعَ الْغُصْنَ
u'قَطْعٌ غُصْنٌ':Added, #1: 1	قَطْعِ الْغُصْنِ
u'قَطَعَ غُضْرُوفٌ':Predicate, #1: 1	قَطْعُ غُصْنِ
u'قَطَعَ غير':Subject, #1: 1	قَطَعَ غُضْرُوفَ
u'قَطَعَ غَيْرٌ':Subject, #1: 1	قَطَعَ غَيْرُهُ
u'قَطَعَ غير':Subject, #1: 1	قَطَعَ غَيْرُهُ
u'قَطَعَ غَيْرٌ':Subject, #4: 4	قَطَعَ غَيْرُ
u'قَطْعٌ غير':Added, #4: 4	قَطَعَ غَيْرُ
u'قَطْعٌ غَيْرٌ':Added, #1: 1	قَطْعُ غَيْرِ
u'قَطْعٌ غير':Added, #1: 1	قَطْعُ غَيْرِ
u'قَطْعٌ غَيْرٌ':Added, #1: 1	قَطْعِ غَيْرِهِ
u'قَطْعٌ فَاتِحٌ':Added, #1: 1	قَطْعِ غَيْرِهِ
u'قَطْعٌ فَاتِحَةٌ':Added, #1: 1	قَطْعَ الْفَاتِحَةِ
u'قَطْعٌ فَاسِدٌ':Added, #1: 1	قَطْعَ الْفَاتِحَةِ
u'قَطَعَ فَذٌّ':Subject, #1: 1	قَطْعُ الْفَاسِدِ
u'قَطَعَ فَرْجٌ':Predicate, #2: 2	قَطَعَ فَذٌّ
u'قَطْعٌ فَرْضٌ':Added, #2: 2	قَطَعَ فَرْجَ
u'قَطَعَ فلان':Predicate, #1: 1	قَطْعِ الْفَرْضِ
u'قَطَعَ فلان':Predicate, #1: 1	أَقْطَعَ بِلالَ
u'قَطَعَ فلان':Predicate, #1: 1	أَقْطَعَ بِلَالَ
u'قَطَعَ فلان':Predicate, #4: 4	أَقْطَعَ بِلاَلَ
u'قَطَعَ فلان':Subject, #8: 8	أَقْطَعَ الزُّبَيْرَ
u'قَطَعَ فُلاَنٌ':Subject, #3: 3	قَطَعَ الشَّافِعِيُّ
u'قَطْعٌ فِلْذَةٌ':Added, #3: 3	قَطَعَ فُلَانٌ
u'قَطْعٌ فِلْقَةٌ':Added, #2: 2	قَطْعَ فِلْذَةٍ
u'قَطَعَ فَوْرٌ':Predicate, #1: 1	قَطْعُ فِلْقَةٍ
u'قَطَعَ قَاطِعٌ':Subject, #1: 1	قَطَعَ الْفَوْرَ
u'قَطَعَ قَاطِعٌ':Subject, #1: 1	قَطَعَ قَاطِعُ
u'قَطْعٌ قَائِلٌ':Added, #5: 5	قَطَعَ الْقَاطِعُ
u'قَطْعٌ قُدْوَةٌ':Added, #1: 1	قَطْعِ قَائِلِهِ
u'قَطْعٌ قُدْوَةٌ':Added, #1: 1	قَطْعُ الْقُدْوَةِ
u'قَطَعَ قِرَاءةٌ':Predicate, #2: 2	قَطْعَ الْقُدْوَةِ
u'قَطَعَ قِرَاءةٌ':Predicate, #1: 1	أَقْطَعَ الْقِرَاءَةَ
u'قَطْعٌ قِرَاءةٌ':Added, #1: 1	قَطَعَ الْقِرَاءَةَ
u'قَطْعٌ قِرَاءةٌ':Added, #2: 2	قَطْعُ الْقِرَاءَةِ
u'قَطْعٌ قِرَاءةٌ':Added, #3: 3	قَطْعَ الْقِرَاءَةِ
u'قَطْعٌ قَرْنٌ':Added, #3: 3	قَطْعِ الْقِرَاءَةِ
u'قَطْعٌ قَرْنٌ':Added, #1: 1	قَطْعُ قَرْنِ
u'قَطَعَ قُرُونٌ':Predicate, #3: 3	قَطْعَ قَرْنِ
u'قَطَعَ قَصَبَةٌ':Predicate, #1: 1	قَطَعَ قُرُونَ
u'قَطَعَ قَمِيصٌ':Predicate, #1: 1	قَطَعَ الْقَصَبَةَ
u'قَطَعَ قوائم':Predicate, #1: 1	قَطَعَ الْقَمِيصَ
u'قَطَعَ قَوَائِمُ':Predicate, #5: 5	قَطَعَ قَوَائِمَ
u'قَطْعٌ قوائم':Added, #5: 5	قَطَعَ قَوَائِمَ
u'قَطْعٌ قَوَائِمُ':Added, #2: 2	قَطْعِ الْقَوَائِمِ
u'قَطْعٌ قوائم':Added, #2: 2	قَطْعِ الْقَوَائِمِ
u'قَطْعٌ قَوَائِمُ':Added, #2: 2	قَطْعَ قَوَائِمِ
u'قَطَعَ قول':Subject, #2: 2	قَطْعَ قَوَائِمِ
u'قَطَعَ قَوْلٌ':Subject, #1: 1	قَطَعَ قَوْلُهُ
u'قَطَعَ كَامِلٌ':Subject, #1: 1	قَطَعَ قَوْلُهُ
u'قَطَعَ كَفٌّ':Predicate, #2: 2	قَطَعَ كَامِلُ
u'قَطَعَ كَفٌّ':Predicate, #10: 10	قَطَعَ الْكَفَّ
u'قَطْعٌ كَفٌّ':Added, #3: 3	قَطَعَ كَفَّ
u'قَطْعٌ كَفٌّ':Added, #1: 1	قَطْعَ الْكَفِّ
u'قَطْعٌ كَلاَمٌ':Added, #5: 5	قَطْعِ الْكَفِّ
u'قَطَعَ كَلْبٌ':Subject, #1: 1	قَطْعَ الْكَلَامِ
u'قَطْعٌ لَحْمٌ':Added, #1: 1	قَطَعَ الْكَلْبُ
u'قَطْعٌ لَحْمٌ':Added, #1: 1	قَطْعُ اللَّحْمِ
u'قَطْعٌ لَحْمٌ':Added, #1: 1	قَطْعِ اللَّحْمِ
u'قَطْعٌ لَحْمٌ':Added, #1: 1	قَطْعُ لَحْمٍ
u'قَطَعَ لِسَانٌ':Predicate, #1: 1	قَطْعِ لَحْمِهِ
u'قَطَعَ لِسَانٌ':Predicate, #2: 2	قَطَعَ اللِّسَانَ
u'قَطْعٌ لِسَانٌ':Added, #6: 6	قَطَعَ لِسَانَ
u'قَطْعٌ لِسَانٌ':Added, #1: 1	قَطْعِ لِسَانٍ
u'قَطْعٌ لِسَانٌ':Added, #1: 1	قَطْعِ لِسَانِ
u'قَطْعٌ لِسَانٌ':Added, #2: 2	قَطْعِ اللِّسَانِ
u'قَطْعٌ لُصُوصٌ':Added, #2: 2	قَطْعَ لِسَانِهِ
u'قَطْعٌ لَيْنٌ':Added, #1: 1	قَطْعِ اللُّصُوصِ
u'قَطْعٌ لِينَةٌ':Added, #1: 1	قَطْعُ اللّينَةِ
u'قَطْعٌ مَاءٌ':Added, #1: 1	قَطْعُ اللّينَةِ
u'قَطْعٌ مَادَّةٌ':Added, #1: 1	قَطْعِ الْمَاءِ
u'قَطْعٌ مَادَّةٌ':Added, #1: 1	قَطْعِ مَادَّةِ
u'قَطَعَ مَارِنٌ':Predicate, #3: 3	قَطْعَ مَادَّةِ
u'قَطْعٌ مَارِنٌ':Added, #6: 6	قَطَعَ الْمَارِنَ
u'قَطَعَ مَالٌ':Predicate, #1: 1	قَطْعَ الْمَارِنِ
u'قَطْعٌ مَالٌ':Added, #1: 1	قَطَعَ مَالَ
u'قَطَعَ مُتْعَةٌ':Predicate, #1: 1	قَطْعِ مَالِهِ
u'قَطَعَ مُتَعَمِّدٌ':Subject, #1: 1	قَطَعَ مُتْعَةَ
u'قَطَعَ مثل':Predicate, #1: 1	قَطَعَ الْمُتَعَمِّدُ
u'قَطَعَ مِثْلٌ':Predicate, #1: 1	قَطَعَ مِثْلَ
u'قَطْعٌ مثل':Added, #1: 1	قَطَعَ مِثْلَ
u'قَطْعٌ مِثْلٌ':Added, #1: 1	قَطْعُ مِثْلِ
u'قَطَعَ مَجْدٌ':Subject, #1: 1	قَطْعُ مِثْلِ
u'قَطْعٌ مَجْلِسٌ':Added, #1: 1	قَطَعَ الْمَجْدُ
u'قَطْعٌ مَجْمُوعٌ':Added, #1: 1	قَطْعُ الْمَجْلِسِ
u'قَطْعٌ مَحَلٌّ':Added, #1: 1	قَطْعِ الْمَجْمُوعِ
u'قَطَعَ مُدَرِّسٌ':Subject, #1: 1	قَطْعُ مَحَلِّ
u'قَطْعٌ مذاكير':Added, #1: 1	قَطَعَ الْمُدَرِّسُ
u'قَطَعَ مرٌّ':Predicate, #1: 1	قَطْعِ الْمَذَاكِيرِ
u'قَطْعٌ مَرْفِقٌ':Added, #1: 1	قَطَعَ مَرَّةً
u'قَطْعٌ مَرْفِق':Added, #1: 1	قَطْعُ الْمَرْفِقِ
u'قَطْعٌ مَرْفِقٌ':Added, #1: 1	قَطْعُ الْمَرْفِقِ
u'قَطْعٌ مَرْفِق':Added, #2: 2	قَطْعِ الْمَرْفِقِ
u'قَطَعَ مَرِيءٌ':Predicate, #2: 2	قَطْعِ الْمَرْفِقِ
u'قَطْعٌ مَرِيءٌ':Added, #1: 1	قَطَعَ الْمَرِيءَ
u'قَطْعٌ مَرِيءٌ':Added, #1: 1	قَطْعُ الْمَرِيءِ
u'قَطَعَ مَسَافَةٌ':Predicate, #4: 4	قَطْعِ الْمَرِيءِ
u'قَطَعَ مَسَافَةٌ':Predicate, #1: 1	قَطَعَ مَسَافَةَ
u'قَطْعٌ مَسَافَةٌ':Added, #5: 5	قَطَعَ الْمَسَافَةَ
u'قَطْعٌ مَسَافَةٌ':Added, #14: 14	قَطْعِ الْمَسَافَةِ
u'قَطْعٌ مَسَافَةٌ':Added, #1: 1	قَطْعِ الْمَسَافَاتِ
u'قَطْعٌ مَسَافَةٌ':Added, #1: 1	قَطْعُ مَسَافَاتٍ
u'قَطْعٌ مَسَافَةٌ':Added, #1: 1	قَطْعُ مَسَافَةِ
u'قَطْعٌ مَسَافَةٌ':Added, #1: 1	قَطْعِ مَسَافَةٍ
u'قَطْعٌ مَسَافَةٌ':Added, #1: 1	قَطْعِ مَسَافَةِ
u'قَطْعٌ مَسَافَةٌ':Added, #20: 20	قَطْعُ الْمَسَافَةِ
u'قَطْعٌ مَسَافَةٌ':Added, #3: 3	قَطْعُ مَسَافَةٍ
u'قَطَعَ مَسَائِلُ':Predicate, #6: 6	قَطْعَ الْمَسَافَةِ
u'قَطَعَ مُسْتَحِقٌّ':Subject, #1: 1	قَطَعَ الْمَسَائِلَ
u'قَطَعَ مُسْلِمٌ':Subject, #1: 1	قَطَعَ مُسْتَحِقُّ
u'قَطْعٌ مَسِيرَةٌ':Added, #3: 3	قَطَعَ مُسْلِمٌ
u'قَطَعَ مُشْكِلٌ':Subject, #1: 1	قَطْعِ مَسِيرَةِ
u'قَطَعَ مَصّ':Predicate, #1: 1	قَطَعَ الْمُشْكِلُ
u'قَطْعٌ مَصَالِحُ':Added, #2: 2	قَطَعَ الْمَصَّةَ
u'قَطَعَ مُصَنِّفٌ':Subject, #1: 1	قَطْعَ مَصَالِحِ
u'قَطْعٌ مُصَنِّفٌ':Added, #16: 16	قَطَعَ الْمُصَنِّفُ
u'قَطْعٌ مَصِيرٌ':Added, #2: 2	قَطْعُ الْمُصَنِّفِ
u'قَطْعٌ مُضِرٌّ':Added, #1: 1	قَطْعِ مَصِيرٍ
u'قَطَعَ مُضَرَّسٌ':Subject, #2: 2	قَطْعُ الْمُضِرِّ
u'قَطَعَ مُعَادٌ':Predicate, #1: 1	قَطَعَ الْمُضَرَّسُ
u'قَطَعَ مُعْتَدِلٌ':Subject, #1: 1	قَطَعَ الْمُعَادَةَ
u'قَطَعَ مُعْتَدِلٌ':Subject, #1: 1	قَطَعَ الْمُعْتَدِلُ
u'قَطَعَ مُعْظَمٌ':Subject, #3: 3	قَطَعَ مُعْتَدِلٌ
u'قَطْعٌ مَعْلُومٌ':Added, #1: 1	قَطَعَ مُعْظَمُ
u'قَطْعٌ مَعْلُومٌ':Added, #1: 1	قَطْعُ مَعْلُومِ
u'قَطْعٌ مُعِير':Added, #2: 2	قَطْعِ الْمَعْلُومِ
u'قَطَعَ مَفْصِلٌ':Predicate, #1: 1	قَطْعِ الْمُعِيرِ
u'قَطْعٌ مَفْصِلٌ':Added, #13: 13	قَطَعَ الْمَفْصِلَ
u'قَطَعَ مَقْطُوعٌ':Subject, #1: 1	قَطْعِ الْمَفْصِلِ
u'قَطَعَ مَقْطُوعَةٌ':Subject, #2: 2	قَطَعَ الْمَقْطُوعَةُ
u'قَطَعَ مَكَانٌ':Predicate, #2: 2	قَطَعَ الْمَقْطُوعَةُ
u'قَطَعَ مِلْكٌ':Predicate, #1: 1	قَطَعَ مَكَانَ
u'قَطْعٌ مِلْكٌ':Added, #1: 1	قَطَعَ الْمِلْكَ
u'قَطْعٌ مِلْكٌ':Added, #1: 1	قَطْعَ مِلْكِ
u'قَطْعٌ مِلْكٌ':Added, #1: 1	قَطْعَ مِلْكِهِ
u'قَطْعٌ مِلْكٌ':Added, #1: 1	قَطْعِ مِلْكِهِ
u'قَطْعٌ مَمْلُوكٌ':Added, #2: 2	قَطْعَ الْمِلْكِ
u'قَطْعٌ مُمَيِّزٌ':Added, #1: 1	قَطْعِ الْمَمْلُوكِ
u'قَطْعٌ مُنَازَعٌ':Added, #1: 1	قَطْعُ مُمَيِّزٍ
u'قَطْعٌ مُنَازَعٌ':Added, #12: 12	قَطْعُ الْمُنَازَعَةِ
u'قَطْعٌ مُنَازَعٌ':Added, #1: 1	قَطْعِ الْمُنَازَعَاتِ
u'قَطْعٌ مُنَازَعَةٌ':Added, #7: 7	قَطْعِ الْمُنَازَعَةِ
u'قَطْعٌ مُنَازَعَةٌ':Added, #12: 12	قَطْعُ الْمُنَازَعَةِ
u'قَطْعٌ مُنَازَعَةٌ':Added, #1: 1	قَطْعِ الْمُنَازَعَاتِ
u'قَطْعٌ مِنَّةٌ':Added, #7: 7	قَطْعِ الْمُنَازَعَةِ
u'قَطْعٌ مِنَّةٌ':Added, #1: 1	قَطْعُ مِنَّتِهِ
u'قَطْعٌ مِنْشَارٌ':Added, #3: 3	قَطْعَ الْمِنَّةِ
u'قَطَعَ مَنْفَعَةٌ':Predicate, #1: 1	قَطْعَ الْمِنْشَارِ
u'قَطْعٌ مَنْفَعَةٌ':Added, #1: 1	قَطَعَ مَنْفَعَةَ
u'قَطَعَ مَنْقُولٌ':Subject, #4: 4	قَطْعِ الْمَنْفَعَةِ
u'قَطْعٌ مَوَادُّ':Added, #1: 1	قَطَعَ الْمَنْقُولُ
u'قَطْعٌ مُوالاة':Added, #2: 2	قَطْعُ مَوَادِّ
u'قَطْعٌ مُؤَجِّرٌ':Added, #2: 2	قَطْعِ الْمُوَالَاةِ
u'قَطْعٌ مَوَدَّةٌ':Added, #1: 1	قَطْعِ الْمُؤَجِّرِ
u'قَطَعَ مَوْضِعٌ':Predicate, #1: 1	قَطْعُ الْمَوَدَّاتِ
u'قَطْعٌ مَوْضِعٌ':Added, #2: 2	قَطَعَ مَوْضِعَ
u'قَطْعٌ مِير':Added, #1: 1	قَطْعِ مَوْضِعِ
u'قَطَعَ مِيرَاثٌ':Predicate, #2: 2	قَطْعَ الْمِيرَةِ
u'قَطْعٌ مِيرَة':Added, #1: 1	قَطَعَ مِيرَاثَ
u'قَطَعَ نَاسٌ':Predicate, #2: 2	قَطْعَ الْمِيرَةِ
u'قَطَعَ نَاظِمٌ':Subject, #3: 3	أَقْطَعَ النَّاسَ
u'قَطَعَ نَاظِمٌ':Subject, #1: 1	قَطَعَ النَّاظِمُ
u'قَطَعَ نَاقِصٌ':Subject, #1: 1	قَطَعَ نَاظِمُ
u'قَطْعٌ نَبّاش':Added, #1: 1	قَطَعَ نَاقِصُ
u'قَطَعَ نَبِيٌّ':Subject, #4: 4	قَطْعِ النَّبَّاشِ
u'قَطَعَ نُخَاعٌ':Predicate, #3: 3	قَطَعَ النَّبِيُّ
u'قَطَعَ نَخْلٌ':Predicate, #1: 1	قَطَعَ النُّخَاعَ
u'قَطْعٌ نَخْلٌ':Added, #5: 5	قَطَعَ نَخْلَ
u'قَطْعٌ نَخْلٌ':Added, #1: 1	قَطْعِ النّخْلِ
u'قَطْعٌ نزاع':Added, #1: 1	قَطْعِ النَّخْلِ
u'قَطْعٌ نِزَاعٌ':Added, #1: 1	قَطْعِ النِّزَاعِ
u'قَطْعٌ نزاع':Added, #1: 1	قَطْعِ النِّزَاعِ
u'قَطْعٌ نِزَاعٌ':Added, #3: 3	قَطْعُ النِّزَاعِ
u'قَطَعَ نَسَبٌ':Predicate, #3: 3	قَطْعُ النِّزَاعِ
u'قَطْعٌ نَسَبٌ':Added, #3: 3	قَطَعَ نَسَبَ
u'قَطْعٌ نَسَبٌ':Added, #1: 1	قَطْعُ النَّسَبِ
u'قَطْعٌ نَسَبٌ':Added, #1: 1	قَطْعُ نَسَبٍ
u'قَطْعٌ نَسَبٌ':Added, #1: 1	قَطْعِ نَسَبٍ
u'قَطْعٌ نَسَبٌ':Added, #2: 2	قَطْعُ نَسَبِ
u'قَطْعٌ نَسَبٌ':Added, #2: 2	قَطْعِ نَسَبِ
u'قَطْعٌ نَسَبٌ':Added, #7: 7	قَطْعَ النَّسَبِ
u'قَطَعَ نِسْبَةٌ':Predicate, #8: 8	قَطْعِ النَّسَبِ
u'قَطْعٌ نِسْبَةٌ':Added, #1: 1	قَطَعَ النِّسْبَةَ
u'قَطْعٌ نِسْبَةٌ':Added, #1: 1	قَطْعَ نِسْبَةِ
u'قَطْعٌ نَسْلٌ':Added, #1: 1	قَطْعُ نِسْبَةِ
u'قَطْعٌ نَسْلٌ':Added, #1: 1	قَطْعِ نَسْلٍ
u'قَطْعٌ نَسْلٌ':Added, #2: 2	قَطْعُ النَّسْلِ
u'قَطَعَ نِصْفٌ':Predicate, #4: 4	قَطْعِ النَّسْلِ
u'قَطَعَ نِصْفٌ':Predicate, #12: 12	قَطَعَ نِصْفَ
u'قَطْعٌ نِصْفٌ':Added, #5: 5	قَطَعَ النِّصْفَ
u'قَطْعٌ نِصْفٌ':Added, #1: 1	قَطْعُ النِّصْفِ
u'قَطَعَ نَظَرٌ':Subject, #1: 1	قَطْعِ النِّصْفِ
u'قَطْعٌ نَظَرٌ':Added, #1: 1	قَطَعَ نَظَرُهُ
u'قَطْعٌ نَظَرٌ':Added, #1: 1	قَطْعَ النَّظَرِ
u'قَطْعٌ نَظَرٌ':Added, #1: 1	قَطْعُ النَّظَرِ
u'قَطْعٌ نَظَرٌ':Added, #1: 1	قَطْعِ نَظَرِهِ
u'قَطْعٌ نَظْمٌ':Added, #64: 64	قَطْعِ النَّظَرِ
u'قَطْعٌ نَظِيرٌ':Added, #1: 1	قَطْعَ نَظْمِ
u'قَطْعٌ نَعْتٌ':Added, #1: 1	قَطْعُ النَّظِيرِ
u'قَطْعٌ نعمة':Added, #1: 1	قَطْعُ النَّعْتِ
u'قَطْعٌ نِعْمَةٌ':Added, #1: 1	قَطْعَ النِّعْمَةِ
u'قَطَعَ نفاس':Subject, #1: 1	قَطْعَ النِّعْمَةِ
u'قَطَعَ نِفَاسٌ':Subject, #1: 1	قَطَعَ النِّفَاسُ
u'قَطْعٌ نَفْسٌ':Added, #1: 1	قَطَعَ النِّفَاسُ
u'قَطْعٌ نَفْلٌ':Added, #2: 2	قَطْعُ نَفْسِ
u'قَطْعٌ نقرة':Added, #1: 1	قَطْعِ النَّفْلِ
u'قَطْعٌ نُقَرَةٌ':Added, #1: 1	قَطْعِ النُّقَرَةِ
u'قَطْعٌ نكاح':Added, #1: 1	قَطْعِ النُّقَرَةِ
u'قَطْعٌ نِكَاحٌ':Added, #1: 1	قَطْعِ نِكَاحِ
u'قَطْعٌ نكاح':Added, #1: 1	قَطْعِ نِكَاحِ
u'قَطْعٌ نِكَاحٌ':Added, #2: 2	قَطْعُ النِّكَاحِ
u'قَطْعٌ نكاح':Added, #2: 2	قَطْعُ النِّكَاحِ
u'قَطْعٌ نِكَاحٌ':Added, #8: 8	قَطْعِ النِّكَاحِ
u'قَطْعٌ نَمَاءٌ':Added, #8: 8	قَطْعِ النِّكَاحِ
u'قَطَعَ نِيَّةٌ':Predicate, #1: 1	قَطْعِ النَّمَاءِ
u'قَطَعَ نِيَّةٌ':Predicate, #3: 3	قَطَعَ النِّيَّةَ
u'قَطْعٌ نِيَّةٌ':Added, #3: 3	قَطَعَ نِيَّةَ
u'قَطْعٌ همزة':Added, #3: 3	قَطْعِ النِّيَّةِ
u'قَطْعٌ هَمْزَةٌ':Added, #1: 1	قَطْعِ هَمْزَتِهِ
u'قَطْعٌ وَاجِبٌ':Added, #1: 1	قَطْعِ هَمْزَتِهِ
u'قَطَعَ واحد':Subject, #1: 1	قَطْعُ الْوَاجِبِ
u'قَطَعَ وَاحِدٌ':Subject, #6: 6	قَطَعَ وَاحِدٌ
u'قَطْعٌ واحد':Added, #6: 6	قَطَعَ وَاحِدٌ
u'قَطْعٌ واحد':Added, #1: 1	قَطْعُ وَاحِدٍ
u'قَطْعٌ وَاحِدٌ':Added, #1: 1	قَطْعِ وَاحِدٍ
u'قَطْعٌ وَاحِدٌ':Added, #1: 1	قَطْعُ وَاحِدٍ
u'قَطَعَ وَادِي':Predicate, #1: 1	قَطْعِ وَاحِدٍ
u'قَطْعٌ وَاقِعٌ':Added, #1: 1	قَطَعَ الْوَادِيَ
u'قَطَعَ وَاهِبٌ':Subject, #1: 1	قَطْعِ الْوَاقِعِ
u'قَطْعٌ وَتَرٌ':Added, #2: 2	قَطَعَ الْوَاهِبُ
u'قَطْعٌ وَتَرٌ':Added, #1: 1	قَطْعُ وَتَرٍ
u'قَطْعٌ وَدَجٌ':Added, #1: 1	قَطْعِ وَتَرٍ
u'قَطْعٌ وَدَجٌ':Added, #1: 1	قَطْعُ الْوَدَجَيْنِ
u'قَطَعَ وَدِيعٌ':Subject, #3: 3	قَطْعِ الْوَدَجَيْنِ
u'قَطَعَ ورق':Predicate, #1: 1	قَطَعَ الْوَدِيعُ
u'قَطَعَ وَرَقٌ':Predicate, #1: 1	قَطَعَ الْوَرَقَ
u'قَطْعٌ وَسَاوِسُ':Added, #1: 1	قَطَعَ الْوَرَقَ
u'قَطْعٌ وَصَائِلُ':Added, #1: 1	قَطْعِ الْوَسَاوِسِ
u'قَطَعَ وصلة':Predicate, #1: 1	قَطْعِ الْوَصَائِلِ
u'قَطَعَ وُصْلَةٌ':Predicate, #1: 1	قَطَعَ وُصْلَةَ
u'قَطْعٌ وصلة':Added, #1: 1	قَطَعَ وُصْلَةَ
u'قَطْعٌ وصلة':Added, #1: 1	قَطْعِ الْوَصْلَةِ
u'قَطْعٌ وُصْلَةٌ':Added, #1: 1	قَطْعِ الْوُصْلَةِ
u'قَطْعٌ وصلة':Added, #1: 1	قَطْعِ الْوُصْلَةِ
u'قَطْعٌ وصلة':Added, #1: 1	قَطْعِ وَصْلَةِ
u'قَطْعٌ وُضُوءٌ':Added, #4: 4	قَطْعُ الْوَصْلَةِ
u'قَطَعَ وَكِيلٌ':Subject, #2: 2	قَطْعَ الْوُضُوءِ
u'قَطَعَ وَلاَيَةٌ':Predicate, #1: 1	قَطَعَ الْوَكِيلُ
u'قَطَعَ وِلاَيَةٌ':Predicate, #1: 1	قَطَعَ الْوَلاَيَةَ
u'قَطَعَ وِلاَيَةٌ':Predicate, #1: 1	قَطَعَ الْوِلَايَةَ
u'قَطْعٌ وِلاَيَةٌ':Added, #1: 1	قَطَعَ وِلَايَةَ
u'قَطْعٌ ولد':Added, #2: 2	قَطْعِ الْوِلَايَةِ
u'قَطْعٌ ولد':Added, #1: 1	قَطْعَ الْوَلَدِ
u'قَطْعٌ ولد':Added, #1: 1	قَطْعُ الْوَلَدِ
u'قَطْعٌ وَلَدٌ':Added, #1: 1	قَطْعِ الْوَلَدِ
u'قَطْعٌ وَلَدٌ':Added, #1: 1	قَطْعَ الْوَلَدِ
u'قَطْعٌ وَلَدٌ':Added, #1: 1	قَطْعُ الْوَلَدِ
u'قَطَعَ وَلِيٌّ':Subject, #1: 1	قَطْعِ الْوَلَدِ
u'قَطَعَ يَابِسٌ':Predicate, #3: 3	قَطَعَ الْوَلِيُّ
u'قَطَعَ يَدٌ':Predicate, #1: 1	قَطَعَ الْيَابِسَ
u'قَطَعَ يَدٌ':Predicate, #152: 152	قَطَعَ يَدَ
u'قَطَعَ يَدٌ':Subject, #18: 18	قَطَعَ الْيَدَ
u'قَطْعٌ يَدٌ':Added, #1: 1	قَطَعَ يَدَاهُ
u'قَطْعٌ يَدٌ':Added, #14: 14	قَطْعُ يَدِهِ
u'قَطْعٌ يَدٌ':Added, #16: 16	قَطْعُ الْيَدِ
u'قَطْعٌ يَدٌ':Added, #1: 1	قَطْع يَدٍ
u'قَطْعٌ يَدٌ':Added, #1: 1	قَطْعُ يَدٍ
u'قَطْعٌ يَدٌ':Added, #1: 1	قَطْعُ يَدِ
u'قَطْعٌ يَدٌ':Added, #1: 1	قَطْعِ يَدَيْنِ
u'قَطْعٌ يَدٌ':Added, #21: 21	قَطْعِ يَدِهِ
u'قَطْعٌ يَدٌ':Added, #28: 28	قَطْعِ الْيَدِ
u'قَطْعٌ يَدٌ':Added, #3: 3	قَطْعُ الْيَدَيْنِ
u'قَطْعٌ يَدٌ':Added, #3: 3	قَطْعَ يَدٍ
u'قَطْعٌ يَدٌ':Added, #5: 5	قَطْعَ الْيَدِ
u'قَطْعٌ يَدٌ':Added, #6: 6	قَطْعَ يَدِ
u'قَطْعٌ يَدٌ':Added, #6: 6	قَطْعِ يَدٍ
u'قَطْعٌ يَدٌ':Added, #7: 7	قَطْعِ الْيَدَيْنِ
u'قَطْعٌ يَدٌ':Added, #7: 7	قَطْعِ يَدِ
u'قَطَعَ يسار':Predicate, #7: 7	قَطْعَ يَدِهِ
u'قَطَعَ يَسَارٌ':Predicate, #4: 4	قَطَعَ يَسَارَ
u'قَطْعٌ يسار':Added, #4: 4	قَطَعَ يَسَارَ
u'قَطْعٌ يسار':Added, #1: 1	قَطْعَ الْيَسَارِ
u'قَطْعٌ يَسَارٌ':Added, #1: 1	قَطْعُ الْيَسَارِ
u'قَطْعٌ يَسَارٌ':Added, #1: 1	قَطْعَ الْيَسَارِ
u'قَطْعٌ يسار':Added, #1: 1	قَطْعُ الْيَسَارِ
u'قَطْعٌ يَسَارٌ':Added, #2: 2	قَطْعِ الْيَسَارِ
u'قَطَعَ يَمِينٌ':Predicate, #2: 2	قَطْعِ الْيَسَارِ
u'قَطَعَ يَمِينٌ':Predicate, #10: 10	قَطَعَ يَمِينَ
u'قَطْعٌ يَمِينٌ':Added, #2: 2	قَطَعَ الْيَمِينَ
u'قَطْعٌ يَمِينٌ':Added, #1: 1	قَطْعُ الْيَمِينِ
u'قَطْعٌ يَمِينٌ':Added, #1: 1	قَطْعِ يَمِينِهِ
u'قَطْعٌ يَمِينٌ':Added, #2: 2	قَطْعِ يَمِينِ
u'قَطْعٌ يَمِينٌ':Added, #5: 5	قَطْعِ الْيَمِينِ
u'قَطَفَ لَبِيبٌ':Subject, #6: 6	قَطْعُ يَمِينِهِ
u'قَعَدَ أَخِيرٌ':Predicate, #1: 1	قَطَفَ اللَّبِيبُ
u'قَعَدَ أَخِيرٌ':Predicate, #1: 1	قَعَدَ الْأَخِيرَ
u'قَعَدَ إمَامٌ':Subject, #2: 2	قَعَدَ الْأَخِيرَةَ
u'قَعَدَ إمَامٌ':Subject, #14: 14	قَعَدَ الْإِمَامُ
u'قَعَدَ إمَامٌ':Subject, #2: 2	قَعَدَ الإِمَامُ
u'قَعَدَ آمِنٌ':Subject, #2: 2	قَعَدَ إمَامُهُ
u'قَعَدَ إِنْسانٌ':Subject, #1: 1	قَعَدَ آمِنٌ
u'قَعَدَ بَيْنٌ':Predicate, #1: 1	قَعَدَ إنْسَانٌ
u'قعدة اِسْتِرَاحَةٌ':Added, #5: 5	قَعَدَ بَيْنَ
u'قَعْدَةٌ اِسْتِرَاحَةٌ':Added, #2: 2	قَعْدَةُ اسْتِرَاحَةٍ
u'قعدة تَشَهُّدٌ':Added, #2: 2	قَعْدَةُ اسْتِرَاحَةٍ
u'قَعْدَةٌ تَشَهُّدٌ':Added, #1: 1	قَعْدَةَ التَّشَهُّدِ
u'قعدة خَتْمٌ':Added, #1: 1	قَعْدَةَ التَّشَهُّدِ
u'قَعْدَةٌ خَتْمٌ':Added, #2: 2	قَعْدَةَ الْخَتْمِ
u'قعدة خَتْمٌ':Added, #2: 2	قَعْدَةَ الْخَتْمِ
u'قَعْدَةٌ خَتْمٌ':Added, #2: 2	قَعْدَةَ خَتْمٍ
u'قعدة خَتْمٌ':Added, #2: 2	قَعْدَةَ خَتْمٍ
u'قَعْدَةٌ خَتْمٌ':Added, #5: 5	قَعْدَةُ الْخَتْمِ
u'قعدة سُجُودٌ':Added, #5: 5	قَعْدَةُ الْخَتْمِ
u'قَعْدَةٌ سُجُودٌ':Added, #1: 1	قَعْدَةُ سُجُودِ
u'قعدة سَهْوٌ':Added, #1: 1	قَعْدَةُ سُجُودِ
u'قَعْدَةٌ سَهْوٌ':Added, #6: 6	قَعْدَةِ السَّهْوِ
u'قعدة صَلاَةٌ':Added, #6: 6	قَعْدَةِ السَّهْوِ
u'قَعْدَةٌ صَلاَةٌ':Added, #2: 2	قَعْدَةِ الصَّلَاةِ
u'قعدة عجز':Added, #2: 2	قَعْدَةِ الصَّلَاةِ
u'قعدة عَجْزٌ':Added, #1: 1	قَعْدَةَ الْعَجْزِ
u'قَعْدَةٌ عجز':Added, #1: 1	قَعْدَةَ الْعَجْزِ
u'قَعْدَةٌ عَجْزٌ':Added, #1: 1	قَعْدَةَ الْعَجْزِ
u'قعدة مَغْضُوبٌ':Added, #1: 1	قَعْدَةَ الْعَجْزِ
u'قَعْدَةٌ مَغْضُوبٌ':Added, #2: 2	قَعْدَةَ الْمَغْضُوبِ
u'قعدة واحد':Added, #2: 2	قَعْدَةَ الْمَغْضُوبِ
u'قعدة وَاحِدٌ':Added, #1: 1	قَعْدَةٍ وَاحِدَةٍ
u'قَعْدَةٌ واحد':Added, #1: 1	قَعْدَةٍ وَاحِدَةٍ
u'قَعْدَةٌ وَاحِدٌ':Added, #1: 1	قَعْدَةٍ وَاحِدَةٍ
u'قَعَدَ ثَابِتٌ':Subject, #1: 1	قَعْدَةٍ وَاحِدَةٍ
u'قَعَدَ جَازٌ':Predicate, #1: 1	قَعَدَ ثَابِتُ
u'قَعَدَ حاكِمٌ':Subject, #1: 1	قَعَدَ جَازَ
u'قَعَدَ حَفَظَةٌ':Subject, #1: 1	قَعَدَ الْحَاكِمُ
u'قَعَدَ خَلْفٌ':Predicate, #1: 1	قَعَدَ الْحَفَظَةُ
u'قَعَدَ دَاخِلٌ':Subject, #1: 1	قَعَدَ خَلْفَ
u'قَعَدَ ذُبابٌ':Subject, #1: 1	قَعَدَ الدَّاخِلُ
u'قَعَدَ رَجُلٌ':Subject, #1: 1	قَعَدَ الذُّبَابُ
u'قَعَدَ رَسُولٌ':Subject, #1: 1	قَعَدَ الرَّجُلُ
u'قَعَدَ شَيْطَانٌ':Subject, #1: 1	قَعَدَ رَسُولُ
u'قَعَدَ عَامِلٌ':Subject, #1: 1	قَعَدَ الشَّيْطَانُ
u'قَعَدَ عند':Predicate, #1: 1	قَعَدَ الْعَامِلُ
u'قَعَدَ فَلًا':Predicate, #1: 1	قَعَدَ عِنْدَ
u'قَعَدَ قَالٌ':Predicate, #7: 7	قَعَدَ فَلاَ
u'قَعَدَ قَدْرٌ':Predicate, #1: 1	قَعَدَ قَالَ
u'قَعَدَ قعدة':Predicate, #33: 33	قَعَدَ قَدْرَ
u'قَعَدَ قَعْدَةٌ':Predicate, #1: 1	قَعَدَ قَعْدَةَ
u'قَعَدَ مِقْدَارٌ':Predicate, #1: 1	قَعَدَ قَعْدَةَ
u'قَعَدَ وَتَرٌ':Predicate, #1: 1	قَعَدَ مِقْدَارَ
u'قَعَدَ وسط':Predicate, #1: 1	قَعَدَ وَتَرَكَ
u'قَعْرٌ أرْضٌ':Added, #2: 2	قَعَدَ وَسْطَ
u'قَعْرٌ بَحْرٌ':Added, #1: 1	قَعْرِ الْأَرْضِ
u'قَعْرٌ بَحْرٌ':Added, #3: 3	قَعْرَ الْبَحْرِ
u'قَعْرٌ بدن':Added, #9: 9	قَعْرِ الْبَحْرِ
u'قَعْرٌ بَدَنٌ':Added, #1: 1	قَعْرِ الْبَدَنِ
u'قَعْرٌ بِئْرٌ':Added, #1: 1	قَعْرِ الْبَدَنِ
u'قَعْرٌ بَيْتٌ':Added, #4: 4	قَعْرِ الْبِئْرِ
u'قَعْرٌ بَيْتٌ':Added, #1: 1	قَعْرِ بَيْتِهِ
u'قَعْرٌ رحم':Added, #3: 3	قَعْرِ بَيْتٍ
u'قَعْرٌ رَحِمٌ':Added, #3: 3	قَعْرِ الرَّحِمِ
u'قَعْرٌ عَدْنٌ':Added, #3: 3	قَعْرِ الرَّحِمِ
u'قَعْرٌ مَاءٌ':Added, #1: 1	قَعْرِ عَدْنٍ
u'قَعْرٌ مُظْلِمٌ':Added, #1: 1	قَعْرِ الْمَاءِ
u'قَعْرٌ مَعِدَةٌ':Added, #1: 1	قَعْرِ مُظْلِمَةٍ
u'قَفَا ثَوْرٌ':Predicate, #3: 3	قَعْرِ الْمَعِدَةِ
u'قَفَلَ أهْلٌ':Subject, #5: 5	قَفَا ثَوْرَ
u'قَفَلَ رَسُولٌ':Subject, #1: 1	قَفَلَ أَهْلُ
u'قَفَلَ قَالٌ':Predicate, #4: 4	قَفَلَ رَسُولُ
u'قَفَلَ نَاسٌ':Subject, #1: 1	قَفَلَ قَالَ
u'قَفَلَ نَاسٌ':Subject, #1: 1	قَفَلَ النّاسُ
u'قَلَّ أَجْرٌ':Subject, #1: 1	قَفَلَ النَّاسُ
u'قَلَّ أَجْوَدُ':Subject, #2: 2	قَلَّ الْأَجْرُ
u'قَلَّ إِدْرَاكٌ':Subject, #1: 1	قَلَّ الْأَجْوَدُ
u'قَلَّ آدَمِيٌّ':Subject, #1: 1	قَلَّ الْإِدْرَاكُ
u'قَلَّ اِسْتِعْمالٌ':Subject, #1: 1	قَلَّ آدَمِيٌّ
u'قَلَّ اِسْتِعْمالٌ':Subject, #1: 1	قَلَّ اسْتِعْمَالُ
u'قَلَّ أصل':Subject, #1: 1	قَلَّ اسْتِعْمَالُهُ
u'قَلَّ أًصْلٌ':Subject, #1: 1	قَلَّ أَصْلُهُ
u'قَلَّ أكل':Subject, #1: 1	قَلَّ أَصْلُهُ
u'قَلَّ أَكْلٌ':Subject, #1: 1	قَلَّ الْأَكْلُ
u'قلب اِبْنٌ':Added, #1: 1	قَلَّ الْأَكْلُ
u'قَلْبٌ اِبْنٌ':Added, #1: 1	قَلْبَ ابْنِ
u'قَلْب اِبْنٌ':Added, #1: 1	قَلْبَ ابْنِ
u'قلب اِبْنٌ':Added, #1: 1	قَلْبَ ابْنِ
u'قلب اِبْنٌ':Added, #2: 2	قَلْبُ ابْنِ
u'قَلْبٌ اِبْنٌ':Added, #2: 2	قَلْبِ ابْنِ
u'قَلْبٌ اِبْنٌ':Added, #2: 2	قَلْبُ ابْنِ
u'قَلْب اِبْنٌ':Added, #2: 2	قَلْبِ ابْنِ
u'قَلْب اِبْنٌ':Added, #2: 2	قَلْبُ ابْنِ
u'قلب أُصولٌ':Added, #2: 2	قَلْبِ ابْنِ
u'قَلْبٌ أُصولٌ':Added, #1: 1	قَلْبَ الْأُصُولِ
u'قَلْب أُصولٌ':Added, #1: 1	قَلْبَ الْأُصُولِ
u'قلب أعْيانٌ':Added, #1: 1	قَلْبَ الْأُصُولِ
u'قلب أعْيانٌ':Added, #1: 1	قَلْبُ الْأَعْيَانِ
u'قلب أَعْيَانٌ':Added, #1: 1	قَلْبِ الْأَعْيَانِ
u'قلب أَعْيَانٌ':Added, #1: 1	قَلْبُ الْأَعْيَانِ
u'قَلْبٌ أعْيانٌ':Added, #1: 1	قَلْبِ الْأَعْيَانِ
u'قَلْبٌ أعْيانٌ':Added, #1: 1	قَلْبُ الْأَعْيَانِ
u'قَلْب أعْيانٌ':Added, #1: 1	قَلْبِ الْأَعْيَانِ
u'قَلْب أعْيانٌ':Added, #1: 1	قَلْبُ الْأَعْيَانِ
u'قَلْبٌ أَعْيَانٌ':Added, #1: 1	قَلْبِ الْأَعْيَانِ
u'قَلْبٌ أَعْيَانٌ':Added, #1: 1	قَلْبُ الْأَعْيَانِ
u'قَلْب أَعْيَانٌ':Added, #1: 1	قَلْبِ الْأَعْيَانِ
u'قَلْب أَعْيَانٌ':Added, #1: 1	قَلْبُ الْأَعْيَانِ
u'قلب أعْيانٌ':Added, #1: 1	قَلْبِ الْأَعْيَانِ
u'قلب أَعْيَانٌ':Added, #2: 2	قَلْبَ الْأَعْيَانِ
u'قَلْبٌ أعْيانٌ':Added, #2: 2	قَلْبَ الْأَعْيَانِ
u'قَلْب أعْيانٌ':Added, #2: 2	قَلْبَ الْأَعْيَانِ
u'قَلْبٌ أَعْيَانٌ':Added, #2: 2	قَلْبَ الْأَعْيَانِ
u'قَلْب أَعْيَانٌ':Added, #2: 2	قَلْبَ الْأَعْيَانِ
u'قلب الْمَرْءُ':Added, #2: 2	قَلْبَ الْأَعْيَانِ
u'قَلْبٌ الْمَرْءُ':Added, #1: 1	قَلْبُ الْمَرْءِ
u'قَلْب الْمَرْءُ':Added, #1: 1	قَلْبُ الْمَرْءِ
u'قلب الْمَرْأَةُ':Added, #1: 1	قَلْبُ الْمَرْءِ
u'قلب الْمَرْأَةُ':Added, #1: 1	قَلْبُ الْمَرْأَةِ
u'قَلْبٌ الْمَرْأَةُ':Added, #1: 1	قَلْبِ الْمَرْأَةِ
u'قَلْبٌ الْمَرْأَةُ':Added, #1: 1	قَلْبُ الْمَرْأَةِ
u'قَلْب الْمَرْأَةُ':Added, #1: 1	قَلْبِ الْمَرْأَةِ
u'قَلْب الْمَرْأَةُ':Added, #1: 1	قَلْبُ الْمَرْأَةِ
u'قلب أُمٌّ':Added, #1: 1	قَلْبِ الْمَرْأَةِ
u'قَلْبٌ أُمٌّ':Added, #1: 1	قَلْبِ أُمِّهِ
u'قَلْب أُمٌّ':Added, #1: 1	قَلْبِ أُمِّهِ
u'قَلَبَ إمَامٌ':Subject, #1: 1	قَلْبِ أُمِّهِ
u'قلب إمَامٌ':Added, #1: 1	قَلَبَ الْإِمَامُ
u'قَلْبٌ إمَامٌ':Added, #1: 1	قَلْبِ إمَامِهِ
u'قَلْب إمَامٌ':Added, #1: 1	قَلْبِ إمَامِهِ
u'قلب إِنْسانٌ':Added, #1: 1	قَلْبِ إمَامِهِ
u'قَلْبٌ إِنْسانٌ':Added, #2: 2	قَلْبِ الْإِنْسَانِ
u'قَلْب إِنْسانٌ':Added, #2: 2	قَلْبِ الْإِنْسَانِ
u'قَلَّبَ أَوْرَاقٌ':Predicate, #2: 2	قَلْبِ الْإِنْسَانِ
u'قَلَبَ أَوَّلُ':Predicate, #2: 2	قَلَّبَ الْأَوْرَاقَ
u'قلب بَائِعٌ':Added, #1: 1	قَلَبَ الْأَوَّلَ
u'قَلْبٌ بَائِعٌ':Added, #1: 1	قَلْبُ الْبَائِعِ
u'قَلْب بَائِعٌ':Added, #1: 1	قَلْبُ الْبَائِعِ
u'قلب بَخِيلٌ':Added, #1: 1	قَلْبُ الْبَائِعِ
u'قَلْبٌ بَخِيلٌ':Added, #1: 1	قَلْبَ الْبَخِيلِ
u'قَلْب بَخِيلٌ':Added, #1: 1	قَلْبَ الْبَخِيلِ
u'قلب بَشَرٌ':Added, #1: 1	قَلْبَ الْبَخِيلِ
u'قَلْبٌ بَشَرٌ':Added, #9: 9	قَلْبِ بَشَرٍ
u'قَلْب بَشَرٌ':Added, #9: 9	قَلْبِ بَشَرٍ
u'قلب تَسْوِيَةٌ':Added, #9: 9	قَلْبِ بَشَرٍ
u'قَلْبٌ تَسْوِيَةٌ':Added, #2: 2	قَلْبُ التَّسْوِيَةِ
u'قَلْب تَسْوِيَةٌ':Added, #2: 2	قَلْبُ التَّسْوِيَةِ
u'قلب تَشْبِيه':Added, #2: 2	قَلْبُ التَّسْوِيَةِ
u'قَلْبٌ تَشْبِيه':Added, #1: 1	قَلْبُ التَّشْبِيهِ
u'قَلْب تَشْبِيه':Added, #1: 1	قَلْبُ التَّشْبِيهِ
u'قلب ثَالِثٌ':Added, #1: 1	قَلْبُ التَّشْبِيهِ
u'قَلْبٌ ثَالِثٌ':Added, #1: 1	قَلْبُ الثَّالِثِ
u'قَلْب ثَالِثٌ':Added, #1: 1	قَلْبُ الثَّالِثِ
u'قلب جَبَانٌ':Added, #1: 1	قَلْبُ الثَّالِثِ
u'قَلْبٌ جَبَانٌ':Added, #1: 1	قَلْبَ الْجَبَانِ
u'قَلْب جَبَانٌ':Added, #1: 1	قَلْبَ الْجَبَانِ
u'قلب حاطِبٌ':Added, #1: 1	قَلْبَ الْجَبَانِ
u'قَلْبٌ حاطِبٌ':Added, #1: 1	قَلْبَ حَاطِبٍ
u'قَلْب حاطِبٌ':Added, #1: 1	قَلْبَ حَاطِبٍ
u'قلب حاكِمٌ':Added, #1: 1	قَلْبَ حَاطِبٍ
u'قَلْبٌ حاكِمٌ':Added, #1: 1	قَلْبِ الْحَاكِمِ
u'قَلْب حاكِمٌ':Added, #1: 1	قَلْبِ الْحَاكِمِ
u'قلب حالٌ':Added, #1: 1	قَلْبِ الْحَاكِمِ
u'قَلْبٌ حالٌ':Added, #1: 1	قَلْبُ الْحَالِ
u'قَلْب حالٌ':Added, #1: 1	قَلْبُ الْحَالِ
u'قَلَبَ حَجٌّ':Predicate, #1: 1	قَلْبُ الْحَالِ
u'قلب حَجٌّ':Added, #1: 1	قَلَبَ الْحَجَّ
u'قَلْبٌ حَجٌّ':Added, #1: 1	قَلْبَ الْحَجِّ
u'قَلْب حَجٌّ':Added, #1: 1	قَلْبَ الْحَجِّ
u'قلب حَدَثٌ':Added, #1: 1	قَلْبَ الْحَجِّ
u'قَلْبٌ حَدَثٌ':Added, #1: 1	قَلْبُ الْحَدَثِ
u'قَلْب حَدَثٌ':Added, #1: 1	قَلْبُ الْحَدَثِ
u'قلب حَزِينٌ':Added, #1: 1	قَلْبُ الْحَدَثِ
u'قَلْبٌ حَزِينٌ':Added, #1: 1	قَلْبَ الْحَزِينِ
u'قَلْب حَزِينٌ':Added, #1: 1	قَلْبَ الْحَزِينِ
u'قلب حَقٌّ':Added, #1: 1	قَلْبَ الْحَزِينِ
u'قَلْبٌ حَقٌّ':Added, #1: 1	قَلْبُ الْحَقِّ
u'قَلْب حَقٌّ':Added, #1: 1	قَلْبُ الْحَقِّ
u'قلب حُكْمٌ':Added, #1: 1	قَلْبُ الْحَقِّ
u'قَلْبٌ حُكْمٌ':Added, #1: 1	قَلْبُ الْحُكْمِ
u'قَلْب حُكْمٌ':Added, #1: 1	قَلْبُ الْحُكْمِ
u'قلب حَيٌّ':Added, #1: 1	قَلْبُ الْحُكْمِ
u'قَلْبٌ حَيٌّ':Added, #1: 1	قَلْبِ الْحَيِّ
u'قَلْب حَيٌّ':Added, #1: 1	قَلْبِ الْحَيِّ
u'قَلْبٌ حَيٌّ':Added, #1: 1	قَلْبِ الْحَيِّ
u'قَلْب حَيٌّ':Added, #1: 1	قَلْبٍ حَيٍّ
u'قلب خَصْمٌ':Added, #1: 1	قَلْبٍ حَيٍّ
u'قَلْبٌ خَصْمٌ':Added, #2: 2	قَلْبُ خَصْمِهِ
u'قَلْب خَصْمٌ':Added, #2: 2	قَلْبُ خَصْمِهِ
u'قلب دَاعِي':Added, #2: 2	قَلْبُ خَصْمِهِ
u'قَلْبٌ دَاعِي':Added, #2: 2	قَلْبَ دَاعِيهِ
u'قَلْب دَاعِي':Added, #2: 2	قَلْبَ دَاعِيهِ
u'قلب دَقيقٌ':Added, #2: 2	قَلْبَ دَاعِيهِ
u'قَلْبٌ دَقيقٌ':Added, #1: 1	قَلْبِ الدَّقِيقِ
u'قَلْب دَقيقٌ':Added, #1: 1	قَلْبِ الدَّقِيقِ
u'قلب دَلالَةٌ':Added, #1: 1	قَلْبِ الدَّقِيقِ
u'قَلْبٌ دَلالَةٌ':Added, #1: 1	قَلْبَ دَلَالَةِ
u'قَلْب دَلالَةٌ':Added, #1: 1	قَلْبَ دَلَالَةِ
u'قلب ذَهَبٌ':Added, #1: 1	قَلْبَ دَلَالَةِ
u'قَلْبٌ ذَهَبٌ':Added, #1: 1	قَلْبَ ذَهَبٍ
u'قَلْب ذَهَبٌ':Added, #1: 1	قَلْبَ ذَهَبٍ
u'قلب رَجُلٌ':Added, #1: 1	قَلْبَ ذَهَبٍ
u'قَلْبٌ رَجُلٌ':Added, #1: 1	قَلْبُ الرَّجُلِ
u'قَلْب رَجُلٌ':Added, #1: 1	قَلْبُ الرَّجُلِ
u'قلب رَجُلٌ':Added, #1: 1	قَلْبُ الرَّجُلِ
u'قَلْبٌ رَجُلٌ':Added, #2: 2	قَلْبَ الرَّجُلِ
u'قَلْب رَجُلٌ':Added, #2: 2	قَلْبَ الرَّجُلِ
u'قلب رَجُلٌ':Added, #2: 2	قَلْبَ الرَّجُلِ
u'قَلْبٌ رَجُلٌ':Added, #8: 8	قَلْبِ رَجُلٍ
u'قَلْب رَجُلٌ':Added, #8: 8	قَلْبِ رَجُلٍ
u'قَلَبَ رِدَاءٌ':Predicate, #8: 8	قَلْبِ رَجُلٍ
u'قلب رِدَاءٌ':Added, #2: 2	قَلَبَ الرِّدَاءَ
u'قَلْبٌ رِدَاءٌ':Added, #5: 5	قَلْبُ رِدَاءٍ
u'قَلْب رِدَاءٌ':Added, #5: 5	قَلْبُ رِدَاءٍ
u'قلب رَسُولٌ':Added, #5: 5	قَلْبُ رِدَاءٍ
u'قَلْبٌ رَسُولٌ':Added, #1: 1	قَلْبِ الرَّسُولِ
u'قَلْب رَسُولٌ':Added, #1: 1	قَلْبِ الرَّسُولِ
u'قَلَبَ زِقٌّ':Predicate, #1: 1	قَلْبِ الرَّسُولِ
u'قلب زَيْدٌ':Added, #1: 1	قَلَبَ الزِّقَّ
u'قَلْبٌ زَيْدٌ':Added, #1: 1	قَلْبِ زَيْدٍ
u'قَلْب زَيْدٌ':Added, #1: 1	قَلْبِ زَيْدٍ
u'قلب سَامِعٌ':Added, #1: 1	قَلْبِ زَيْدٍ
u'قَلْبٌ سَامِعٌ':Added, #2: 2	قَلْبِ السَّامِعِ
u'قَلْب سَامِعٌ':Added, #2: 2	قَلْبِ السَّامِعِ
u'قلب شَاةٌ':Added, #2: 2	قَلْبِ السَّامِعِ
u'قَلْبٌ شَاةٌ':Added, #1: 1	قَلْبِ الشَّاةِ
u'قَلْب شَاةٌ':Added, #1: 1	قَلْبِ الشَّاةِ
u'قلب شَجَرٌ':Added, #1: 1	قَلْبِ الشَّاةِ
u'قَلْبٌ شَجَرٌ':Added, #1: 1	قَلْبِ الشَّجَرِ
u'قَلْب شَجَرٌ':Added, #1: 1	قَلْبِ الشَّجَرِ
u'قلب شَرِيعَةٌ':Added, #1: 1	قَلْبِ الشَّجَرِ
u'قَلْبٌ شَرِيعَةٌ':Added, #2: 2	قَلْبُ الشَّرِيعَةِ
u'قَلْب شَرِيعَةٌ':Added, #2: 2	قَلْبُ الشَّرِيعَةِ
u'قلب شَيْءٌ':Added, #2: 2	قَلْبُ الشَّرِيعَةِ
u'قَلْبٌ شَيْءٌ':Added, #1: 1	قَلْبُ الشَّيْءِ
u'قَلْب شَيْءٌ':Added, #1: 1	قَلْبُ الشَّيْءِ
u'قلب شَيْخٌ':Added, #1: 1	قَلْبُ الشَّيْءِ
u'قَلْبٌ شَيْخٌ':Added, #2: 2	قَلْبَ الشَّيْخِ
u'قَلْب شَيْخٌ':Added, #2: 2	قَلْبَ الشَّيْخِ
u'قلب شَيْخٌ':Added, #2: 2	قَلْبَ الشَّيْخِ
u'قَلْبٌ شَيْخٌ':Added, #4: 4	قَلْبُ الشَّيْخِ
u'قَلْب شَيْخٌ':Added, #4: 4	قَلْبُ الشَّيْخِ
u'قلب صَاحِبٌ':Added, #4: 4	قَلْبُ الشَّيْخِ
u'قَلْبٌ صَاحِبٌ':Added, #1: 1	قَلْبِ صَاحِبِ
u'قَلْب صَاحِبٌ':Added, #1: 1	قَلْبِ صَاحِبِ
u'قلب صَاحِبٌ':Added, #1: 1	قَلْبِ صَاحِبِ
u'قَلْبٌ صَاحِبٌ':Added, #2: 2	قَلْبِ صَاحِبِهِ
u'قَلْب صَاحِبٌ':Added, #2: 2	قَلْبِ صَاحِبِهِ
u'قلب صَغِيرٌ':Added, #2: 2	قَلْبِ صَاحِبِهِ
u'قَلْبٌ صَغِيرٌ':Added, #1: 1	قَلْبَ الصَّغِيرِ
u'قَلْب صَغِيرٌ':Added, #1: 1	قَلْبَ الصَّغِيرِ
u'قَلَبَ صَلاَةٌ':Predicate, #1: 1	قَلْبَ الصَّغِيرِ
u'قَلَبَ صَوْمٌ':Predicate, #1: 1	قَلَبَ الصَّلَاةَ
u'قلب عَاقِلٌ':Added, #2: 2	قَلَبَ صَوْمَ
u'قَلْبٌ عَاقِلٌ':Added, #1: 1	قَلْبِ عَاقِلٍ
u'قَلْب عَاقِلٌ':Added, #1: 1	قَلْبِ عَاقِلٍ
u'قلب عَاقِلٌ':Added, #1: 1	قَلْبِ عَاقِلٍ
u'قَلْبٌ عَاقِلٌ':Added, #2: 2	قَلْبِ الْعَاقِلِ
u'قَلْب عَاقِلٌ':Added, #2: 2	قَلْبِ الْعَاقِلِ
u'قلب عَبْدٌ':Added, #2: 2	قَلْبِ الْعَاقِلِ
u'قَلْبٌ عَبْدٌ':Added, #1: 1	قَلْبَ عَبْدِهِ
u'قَلْب عَبْدٌ':Added, #1: 1	قَلْبَ عَبْدِهِ
u'قلب عَبْدٌ':Added, #1: 1	قَلْبَ عَبْدِهِ
u'قَلْبٌ عَبْدٌ':Added, #7: 7	قَلْبِ عَبْدٍ
u'قَلْب عَبْدٌ':Added, #7: 7	قَلْبِ عَبْدٍ
u'قَلْبٌ غَافِلٌ':Added, #7: 7	قَلْبِ عَبْدٍ
u'قَلْب غَافِلٌ':Added, #4: 4	قَلْبٍ غَافِلٍ
u'قلب غير':Added, #4: 4	قَلْبٍ غَافِلٍ
u'قلب غَيْرٌ':Added, #1: 1	قَلْبَ غَيْرِهِ
u'قَلْبٌ غير':Added, #1: 1	قَلْبَ غَيْرِهِ
u'قَلْب غير':Added, #1: 1	قَلْبَ غَيْرِهِ
u'قَلْبٌ غَيْرٌ':Added, #1: 1	قَلْبَ غَيْرِهِ
u'قَلْب غَيْرٌ':Added, #1: 1	قَلْبَ غَيْرِهِ
u'قلب غير':Added, #1: 1	قَلْبَ غَيْرِهِ
u'قلب غَيْرٌ':Added, #2: 2	قَلْبِ غَيْرِهِ
u'قَلْبٌ غير':Added, #2: 2	قَلْبِ غَيْرِهِ
u'قَلْب غير':Added, #2: 2	قَلْبِ غَيْرِهِ
u'قَلْبٌ غَيْرٌ':Added, #2: 2	قَلْبِ غَيْرِهِ
u'قَلْب غَيْرٌ':Added, #2: 2	قَلْبِ غَيْرِهِ
u'قَلْبٌ فَارِغٌ':Added, #2: 2	قَلْبِ غَيْرِهِ
u'قَلْب فَارِغٌ':Added, #1: 1	قَلْبٍ فَارِغٍ
u'قلب فِضَّةٌ':Added, #1: 1	قَلْبٍ فَارِغٍ
u'قَلْبٌ فِضَّةٌ':Added, #27: 27	قَلْبَ فِضَّةٍ
u'قَلْب فِضَّةٌ':Added, #27: 27	قَلْبَ فِضَّةٍ
u'قلب فِضَّةٌ':Added, #27: 27	قَلْبَ فِضَّةٍ
u'قَلْبٌ فِضَّةٌ':Added, #3: 3	قَلْبُ فِضَّةٍ
u'قَلْب فِضَّةٌ':Added, #3: 3	قَلْبُ فِضَّةٍ
u'قَلَبَ فِعْلٌ':Predicate, #3: 3	قَلْبُ فِضَّةٍ
u'قلب فَقِيرٌ':Added, #2: 2	قَلَبَ الْفِعْلَ
u'قَلْبٌ فَقِيرٌ':Added, #1: 1	قَلْبُ الْفَقِيرِ
u'قَلْب فَقِيرٌ':Added, #1: 1	قَلْبُ الْفَقِيرِ
u'قلب قَارِئٌ':Added, #1: 1	قَلْبُ الْفَقِيرِ
u'قَلْبٌ قَارِئٌ':Added, #1: 1	قَلْبَ الْقَارِئِ
u'قَلْب قَارِئٌ':Added, #1: 1	قَلْبَ الْقَارِئِ
u'قلب قَاعِدٌ':Added, #1: 1	قَلْبَ الْقَارِئِ
u'قَلْبٌ قَاعِدٌ':Added, #1: 1	قَلْبَ الْقَاعِدَةِ
u'قَلْب قَاعِدٌ':Added, #1: 1	قَلْبَ الْقَاعِدَةِ
u'قلب قَالِبٌ':Added, #1: 1	قَلْبَ الْقَاعِدَةِ
u'قَلْبٌ قَالِبٌ':Added, #1: 1	قَلْبَ الْقَالِبِ
u'قَلْب قَالِبٌ':Added, #1: 1	قَلْبَ الْقَالِبِ
u'قلب قلب':Added, #1: 1	قَلْبَ الْقَالِبِ
u'قلب قلب':Added, #1: 1	قَلْبَ الْقَلْبِ
u'قَلْبٌ قلب':Added, #1: 1	قَلْبُ الْقَلْبِ
u'قَلْبٌ قلب':Added, #1: 1	قَلْبَ الْقَلْبِ
u'قَلْب قلب':Added, #1: 1	قَلْبُ الْقَلْبِ
u'قَلْب قلب':Added, #1: 1	قَلْبَ الْقَلْبِ
u'قلب قَلْبٌ':Added, #1: 1	قَلْبُ الْقَلْبِ
u'قلب قَلْبٌ':Added, #1: 1	قَلْبَ الْقَلْبِ
u'قلب قَلْب':Added, #1: 1	قَلْبُ الْقَلْبِ
u'قلب قَلْب':Added, #1: 1	قَلْبَ الْقَلْبِ
u'قَلْبٌ قَلْبٌ':Added, #1: 1	قَلْبُ الْقَلْبِ
u'قَلْبٌ قَلْبٌ':Added, #1: 1	قَلْبَ الْقَلْبِ
u'قَلْبٌ قَلْب':Added, #1: 1	قَلْبُ الْقَلْبِ
u'قَلْبٌ قَلْب':Added, #1: 1	قَلْبَ الْقَلْبِ
u'قَلْب قَلْبٌ':Added, #1: 1	قَلْبُ الْقَلْبِ
u'قَلْب قَلْبٌ':Added, #1: 1	قَلْبَ الْقَلْبِ
u'قَلْب قَلْب':Added, #1: 1	قَلْبُ الْقَلْبِ
u'قَلْب قَلْب':Added, #1: 1	قَلْبَ الْقَلْبِ
u'قلب قلب':Added, #1: 1	قَلْبُ الْقَلْبِ
u'قَلْبٌ قلب':Added, #1: 1	قَلْبِ قَلْبِهِ
u'قَلْب قلب':Added, #1: 1	قَلْبِ قَلْبِهِ
u'قلب قَلْبٌ':Added, #1: 1	قَلْبِ قَلْبِهِ
u'قلب قَلْب':Added, #1: 1	قَلْبِ قَلْبِهِ
u'قَلْبٌ قَلْبٌ':Added, #1: 1	قَلْبِ قَلْبِهِ
u'قَلْبٌ قَلْب':Added, #1: 1	قَلْبِ قَلْبِهِ
u'قَلْب قَلْبٌ':Added, #1: 1	قَلْبِ قَلْبِهِ
u'قَلْب قَلْب':Added, #1: 1	قَلْبِ قَلْبِهِ
u'قلب كَافِرٌ':Added, #1: 1	قَلْبِ قَلْبِهِ
u'قَلْبٌ كَافِرٌ':Added, #1: 1	قَلْبُ الْكَافِرِ
u'قَلْب كَافِرٌ':Added, #1: 1	قَلْبُ الْكَافِرِ
u'قلب كَبِيرٌ':Added, #1: 1	قَلْبُ الْكَافِرِ
u'قَلْبٌ كَبِيرٌ':Added, #1: 1	قَلْبُ الْكَبِيرِ
u'قَلْب كَبِيرٌ':Added, #1: 1	قَلْبُ الْكَبِيرِ
u'قلب لُغَةٌ':Added, #1: 1	قَلْبُ الْكَبِيرِ
u'قَلْبٌ لُغَةٌ':Added, #1: 1	قَلْبِ اللُّغَةِ
u'قَلْب لُغَةٌ':Added, #1: 1	قَلْبِ اللُّغَةِ
u'قلب مَالِكٌ':Added, #1: 1	قَلْبِ اللُّغَةِ
u'قَلْبٌ مَالِكٌ':Added, #1: 1	قَلْبِ مَالِكِهِ
u'قَلْب مَالِكٌ':Added, #1: 1	قَلْبِ مَالِكِهِ
u'قلب مُتَعَارَفٌ':Added, #1: 1	قَلْبِ مَالِكِهِ
u'قَلْبٌ مُتَعَارَفٌ':Added, #1: 1	قَلْبُ الْمُتَعَارَفِ
u'قَلْب مُتَعَارَفٌ':Added, #1: 1	قَلْبُ الْمُتَعَارَفِ
u'قلب مُتَكَبِّرٌ':Added, #1: 1	قَلْبُ الْمُتَعَارَفِ
u'قَلْبٌ مُتَكَبِّرٌ':Added, #1: 1	قَلْبِ مُتَكَبِّرٍ
u'قَلْب مُتَكَبِّرٌ':Added, #1: 1	قَلْبِ مُتَكَبِّرٍ
u'قلب مُتَيَقِّظٌ':Added, #1: 1	قَلْبِ مُتَكَبِّرٍ
u'قَلْبٌ مُتَيَقِّظٌ':Added, #1: 1	قَلْبِ مُتَيَقِّظٍ
u'قَلْب مُتَيَقِّظٌ':Added, #1: 1	قَلْبِ مُتَيَقِّظٍ
u'قلب مَجْنُونٌ':Added, #1: 1	قَلْبِ مُتَيَقِّظٍ
u'قَلْبٌ مَجْنُونٌ':Added, #1: 1	قَلْبِ مَجْنُونٍ
u'قَلْب مَجْنُونٌ':Added, #1: 1	قَلْبِ مَجْنُونٍ
u'قلب مَجْنِيٌّ':Added, #1: 1	قَلْبِ مَجْنُونٍ
u'قَلْبٌ مَجْنِيٌّ':Added, #1: 1	قَلْبِ الْمَجْنِيِّ
u'قَلْب مَجْنِيٌّ':Added, #1: 1	قَلْبِ الْمَجْنِيِّ
u'قلب مُحَمَّدٌ':Added, #1: 1	قَلْبِ الْمَجْنِيِّ
u'قَلْبٌ مُحَمَّدٌ':Added, #1: 1	قَلْبِ مُحَمّدٍ
u'قَلْب مُحَمَّدٌ':Added, #1: 1	قَلْبِ مُحَمّدٍ
u'قلب مُرْتَهِنٌ':Added, #1: 1	قَلْبِ مُحَمّدٍ
u'قَلْبٌ مُرْتَهِنٌ':Added, #1: 1	قَلْبِ الْمُرْتَهِنِ
u'قَلْب مُرْتَهِنٌ':Added, #1: 1	قَلْبِ الْمُرْتَهِنِ
u'قلب مُسْلِمٌ':Added, #1: 1	قَلْبِ الْمُرْتَهِنِ
u'قَلْبٌ مُسْلِمٌ':Added, #1: 1	قَلْبُ مُسْلِمٍ
u'قَلْب مُسْلِمٌ':Added, #1: 1	قَلْبُ مُسْلِمٍ
u'قلب مُسْلِمٌ':Added, #1: 1	قَلْبُ مُسْلِمٍ
u'قَلْبٌ مُسْلِمٌ':Added, #2: 2	قَلْبِ مُسْلِمٍ
u'قَلْب مُسْلِمٌ':Added, #2: 2	قَلْبِ مُسْلِمٍ
u'قَلَبَ مَشْرُوعٌ':Predicate, #2: 2	قَلْبِ مُسْلِمٍ
u'قلب مَشْرُوعٌ':Added, #2: 2	قَلَبَ الْمَشْرُوعَ
u'قَلْبٌ مَشْرُوعٌ':Added, #6: 6	قَلْبُ الْمَشْرُوعِ
u'قَلْب مَشْرُوعٌ':Added, #6: 6	قَلْبُ الْمَشْرُوعِ
u'قلب مُصَابٌ':Added, #6: 6	قَلْبُ الْمَشْرُوعِ
u'قَلْبٌ مُصَابٌ':Added, #1: 1	قَلْبِ الْمُصَابِ
u'قَلْب مُصَابٌ':Added, #1: 1	قَلْبِ الْمُصَابِ
u'قلب مُقَلِّدٌ':Added, #1: 1	قَلْبِ الْمُصَابِ
u'قَلْبٌ مُقَلِّدٌ':Added, #1: 1	قَلْبِ الْمُقَلِّدِ
u'قَلْب مُقَلِّدٌ':Added, #1: 1	قَلْبِ الْمُقَلِّدِ
u'قلب مُنَافِقٌ':Added, #1: 1	قَلْبِ الْمُقَلِّدِ
u'قَلْبٌ مُنَافِقٌ':Added, #3: 3	قَلْبَ مُنَافِقٍ
u'قَلْب مُنَافِقٌ':Added, #3: 3	قَلْبَ مُنَافِقٍ
u'قلب مَوْضِعٌ':Added, #3: 3	قَلْبَ مُنَافِقٍ
u'قَلْبٌ مَوْضِعٌ':Added, #1: 1	قَلْبُ الْمَوْضِعِ
u'قَلْب مَوْضِعٌ':Added, #1: 1	قَلْبُ الْمَوْضِعِ
u'قلب مَوْضُوعٌ':Added, #1: 1	قَلْبُ الْمَوْضِعِ
u'قَلْبٌ مَوْضُوعٌ':Added, #10: 10	قَلْبِ الْمَوْضُوعِ
u'قَلْب مَوْضُوعٌ':Added, #10: 10	قَلْبِ الْمَوْضُوعِ
u'قلب مَوْضُوعٌ':Added, #10: 10	قَلْبِ الْمَوْضُوعِ
u'قلب مَوْضُوعٌ':Added, #1: 1	قَلْبَ الْمَوْضُوعِ
u'قَلْبٌ مَوْضُوعٌ':Added, #1: 1	قَلْبُ الْمَوْضُوعِ
u'قَلْبٌ مَوْضُوعٌ':Added, #1: 1	قَلْبَ الْمَوْضُوعِ
u'قَلْب مَوْضُوعٌ':Added, #1: 1	قَلْبُ الْمَوْضُوعِ
u'قَلْب مَوْضُوعٌ':Added, #1: 1	قَلْبَ الْمَوْضُوعِ
u'قَلْبٌ مُوقِنٌ':Added, #1: 1	قَلْبُ الْمَوْضُوعِ
u'قَلْب مُوقِنٌ':Added, #1: 1	قَلْبٍ مُوقِنٍ
u'قلب مُؤْمِنٌ':Added, #1: 1	قَلْبٍ مُوقِنٍ
u'قَلْبٌ مُؤْمِنٌ':Added, #1: 1	قَلْبَ الْمُؤْمِنِ
u'قَلْب مُؤْمِنٌ':Added, #1: 1	قَلْبَ الْمُؤْمِنِ
u'قلب مُؤْمِنٌ':Added, #1: 1	قَلْبَ الْمُؤْمِنِ
u'قَلْبٌ مُؤْمِنٌ':Added, #1: 1	قَلْبِ مُؤْمِنٍ
u'قَلْب مُؤْمِنٌ':Added, #1: 1	قَلْبِ مُؤْمِنٍ
u'قلب مُؤْمِنٌ':Added, #1: 1	قَلْبِ مُؤْمِنٍ
u'قَلْبٌ مُؤْمِنٌ':Added, #3: 3	قَلْبِ الْمُؤْمِنِ
u'قَلْب مُؤْمِنٌ':Added, #3: 3	قَلْبِ الْمُؤْمِنِ
u'قلب مُؤْمِنٌ':Added, #3: 3	قَلْبِ الْمُؤْمِنِ
u'قَلْبٌ مُؤْمِنٌ':Added, #8: 8	قَلْبُ الْمُؤْمِنِ
u'قَلْب مُؤْمِنٌ':Added, #8: 8	قَلْبُ الْمُؤْمِنِ
u'قلب نَاسٌ':Added, #8: 8	قَلْبُ الْمُؤْمِنِ
u'قَلْبٌ نَاسٌ':Added, #1: 1	قَلْبُ النَّاسِ
u'قَلْب نَاسٌ':Added, #1: 1	قَلْبُ النَّاسِ
u'قلب نَاظِرٌ':Added, #1: 1	قَلْبُ النَّاسِ
u'قَلْبٌ نَاظِرٌ':Added, #1: 1	قَلْبِ النَّاظِرِ
u'قَلْب نَاظِرٌ':Added, #1: 1	قَلْبِ النَّاظِرِ
u'قلب نَائِمٌ':Added, #1: 1	قَلْبِ النَّاظِرِ
u'قَلْبٌ نَائِمٌ':Added, #2: 2	قَلْبِ النَّائِمِ
u'قَلْب نَائِمٌ':Added, #2: 2	قَلْبِ النَّائِمِ
u'قلب نَبِيٌّ':Added, #2: 2	قَلْبِ النَّائِمِ
u'قلب نَبِيٌّ':Added, #1: 1	قَلْبَ النَّبِيِّ
u'قَلْبٌ نَبِيٌّ':Added, #1: 1	قَلْبِ النَّبِيِّ
u'قَلْبٌ نَبِيٌّ':Added, #1: 1	قَلْبَ النَّبِيِّ
u'قَلْب نَبِيٌّ':Added, #1: 1	قَلْبِ النَّبِيِّ
u'قَلْب نَبِيٌّ':Added, #1: 1	قَلْبَ النَّبِيِّ
u'قلب نَخْلٌ':Added, #1: 1	قَلْبِ النَّبِيِّ
u'قَلْبٌ نَخْلٌ':Added, #1: 1	قَلْبِ النَّخْلِ
u'قَلْب نَخْلٌ':Added, #1: 1	قَلْبِ النَّخْلِ
u'قلب نَفْسٌ':Added, #1: 1	قَلْبِ النَّخْلِ
u'قَلْبٌ نَفْسٌ':Added, #1: 1	قَلْبِ نَفْسِهِ
u'قَلْب نَفْسٌ':Added, #1: 1	قَلْبِ نَفْسِهِ
u'قَلَبَ نِيَّةٌ':Predicate, #1: 1	قَلْبِ نَفْسِهِ
u'قلب نِيَّةٌ':Added, #2: 2	قَلَبَ نِيَّةَ
u'قَلْبٌ نِيَّةٌ':Added, #1: 1	قَلْبِ النِّيَّةِ
u'قَلْب نِيَّةٌ':Added, #1: 1	قَلْبِ النِّيَّةِ
u'قَلَبَ همزة':Predicate, #1: 1	قَلْبِ النِّيَّةِ
u'قَلَبَ هَمْزَةٌ':Predicate, #1: 1	قَلَبَ الْهَمْزَةَ
u'قلب همزة':Added, #1: 1	قَلَبَ الْهَمْزَةَ
u'قَلْبٌ همزة':Added, #1: 1	قَلْبُ الْهَمْزَةِ
u'قَلْب همزة':Added, #1: 1	قَلْبُ الْهَمْزَةِ
u'قلب هَمْزَةٌ':Added, #1: 1	قَلْبُ الْهَمْزَةِ
u'قَلْبٌ هَمْزَةٌ':Added, #1: 1	قَلْبُ الْهَمْزَةِ
u'قَلْب هَمْزَةٌ':Added, #1: 1	قَلْبُ الْهَمْزَةِ
u'قلب ورق':Added, #1: 1	قَلْبُ الْهَمْزَةِ
u'قَلْبٌ ورق':Added, #1: 1	قَلْبِ وَرَقِهِ
u'قَلْب ورق':Added, #1: 1	قَلْبِ وَرَقِهِ
u'قلب وَرَقٌ':Added, #1: 1	قَلْبِ وَرَقِهِ
u'قَلْبٌ وَرَقٌ':Added, #1: 1	قَلْبِ وَرَقِهِ
u'قَلْب وَرَقٌ':Added, #1: 1	قَلْبِ وَرَقِهِ
u'قلب وَضْعٌ':Added, #1: 1	قَلْبِ وَرَقِهِ
u'قَلْبٌ وَضْعٌ':Added, #1: 1	قَلْبُ الْوَضْعِ
u'قَلْب وَضْعٌ':Added, #1: 1	قَلْبُ الْوَضْعِ
u'قلب يَقْظَان':Added, #1: 1	قَلْبُ الْوَضْعِ
u'قَلْبٌ يَقْظَان':Added, #1: 1	قَلْبِ الْيَقْظَانِ
u'قَلْب يَقْظَان':Added, #1: 1	قَلْبِ الْيَقْظَانِ
u'قِلَّةٌ إِبِلٌ':Added, #1: 1	قَلْبِ الْيَقْظَانِ
u'قِلَّةٌ إِتْقَانٌ':Added, #3: 3	قِلَّةِ الْإِبِلِ
u'قِلَّةٌ اِحْتِرَامٌ':Added, #1: 1	قِلَّةِ إِتْقَانِهِ
u'قِلَّةٌ إِخْوَانٌ':Added, #1: 1	قِلَّةُ احْتِرَامٍ
u'قِلَّةٌ أدَب':Added, #1: 1	قِلَّةَ إخْوَانِهِ
u'قِلَّةٌ أدَب':Added, #1: 1	قِلَّةِ أَدَبٍ
u'قِلَّةٌ اِسْتِعْمالٌ':Added, #2: 2	قِلَّةَ أَدَبٍ
u'قِلَّةٌ اِطِّلاعٌ':Added, #1: 1	قِلَّةُ اسْتِعْمَالِ
u'قِلَّةٌ اِكْتِرَاثٌ':Added, #1: 1	قِلَّةِ اطِّلَاعٍ
u'قِلَّةٌ أكل':Added, #3: 3	قِلَّةِ اكْتِرَاثِ
u'قِلَّةٌ أَكْلٌ':Added, #1: 1	قِلَّةِ أَكْلِ
u'قِلَّةٌ أكل':Added, #1: 1	قِلَّةِ أَكْلِ
u'قِلَّةٌ أكل':Added, #1: 1	قِلَّةُ أَكْلِهِ
u'قِلَّةٌ أَكْلٌ':Added, #1: 1	قِلَّةِ أَكْلِهِ
u'قِلَّةٌ أَكْلٌ':Added, #1: 1	قِلَّةُ أَكْلِهِ
u'قِلَّةٌ أكل':Added, #1: 1	قِلَّةِ أَكْلِهِ
u'قِلَّةٌ أَكْلٌ':Added, #2: 2	قِلَّةَ الْأَكْلِ
u'قِلَّةٌ اِنْتِفاعٌ':Added, #2: 2	قِلَّةَ الْأَكْلِ
u'قِلَّةٌ إِنْصافٌ':Added, #1: 1	قِلَّةِ انْتِفَاعِ
u'قِلَّةٌ أَنَفَةٌ':Added, #2: 2	قِلَّةِ الْإِنْصَافِ
u'قِلَّةٌ اِهْتِمَامٌ':Added, #1: 1	قِلَّةُ الْأَنَفَةِ
u'قِلَّةٌ أهْلٌ':Added, #3: 3	قِلَّةِ اهْتِمَامِهِ
u'قِلَّةٌ تَحَفُّظٌ':Added, #1: 1	قِلَّةِ أَهْلِهِ
u'قِلَّةٌ تَحَفُّظٌ':Added, #1: 1	قِلَّةُ التَّحَفُّظِ
u'قِلَّةٌ تَغْيِيرٌ':Added, #1: 1	قِلَّةِ تَحَفُّظٍ
u'قِلَّةٌ تَفاوُت':Added, #1: 1	قِلَّةُ التَّغْيِيرِ
u'قِلَّةٌ تَقاطُرٌ':Added, #1: 1	قِلَّةِ التَّفَاوُتِ
u'قِلَّةٌ تَمْييزٌ':Added, #1: 1	قِلَّةِ التَّقَاطُرِ
u'قِلَّةٌ جماع':Added, #2: 2	قِلَّةُ تَمْيِيزِهِ
u'قِلَّةٌ جِمَاعٌ':Added, #1: 1	قِلَّةِ الْجِمَاعِ
u'قِلَّةٌ جَمَاعَةٌ':Added, #1: 1	قِلَّةِ الْجِمَاعِ
u'قِلَّةٌ جمع':Added, #3: 3	قِلَّةِ الْجَمَاعَةِ
u'قِلَّةٌ جَمْعٌ':Added, #3: 3	قِلَّةِ الْجَمْعِ
u'قِلَّةٌ جِنَايَةٌ':Added, #3: 3	قِلَّةِ الْجَمْعِ
u'قِلَّةٌ حَديثٌ':Added, #1: 1	قِلَّةِ الْجِنَايَةِ
u'قِلَّةٌ حَرَكَةٌ':Added, #1: 1	قِلَّةِ حَدِيثِهِ
u'قِلَّةٌ حَصْرٌ':Added, #1: 1	قِلَّةَ الْحَرَكَةِ
u'قِلَّةٌ حَظٌّ':Added, #1: 1	قِلَّةُ الْحَصْرِ
u'قِلَّةٌ حَظٌّ':Added, #1: 1	قِلَّةَ حَظِّ
u'قِلَّةٌ حَنَانٌ':Added, #1: 1	قِلَّةِ حَظِّهِ
u'قِلَّةٌ حَيَاءٌ':Added, #1: 1	قِلَّةُ الْحَنَانِ
u'قِلَّةٌ حَيَاءٌ':Added, #1: 1	قِلَّةُ الْحَيَاءِ
u'قِلَّةٌ حَيَاءٌ':Added, #1: 1	قِلَّةِ حَيَاءٍ
u'قِلَّةٌ حَيَاءٌ':Added, #1: 1	قِلَّةِ حَيَاءِ
u'قِلَّةٌ دُخَانٌ':Added, #2: 2	قِلَّةِ الْحَيَاءِ
u'قِلَّةٌ دَيْنٌ':Added, #1: 1	قِلَّةُ الدُّخَانِ
u'قِلَّةٌ دِينٌ':Added, #1: 1	قِلَّةُ الدَّيْنِ
u'قِلَّةٌ دِينٌ':Added, #1: 1	قِلَّةِ دِينٍ
u'قِلَّةٌ ذِهْنٌ':Added, #1: 1	قِلَّةِ دِينِ
u'قِلَّةٌ رُطوبَةٌ':Added, #1: 1	قِلَّةِ ذِهْنِهِ
u'قِلَّةٌ رَغْبَةٌ':Added, #1: 1	قِلَّةِ الرُّطُوبَةِ
u'قِلَّةٌ رَغْبَةٌ':Added, #1: 1	قِلَّةِ الرَّغْبَةِ
u'قِلَّةٌ رَغْبَةٌ':Added, #1: 1	قِلَّةُ رَغْبَةٍ
u'قِلَّةٌ ريعٌ':Added, #1: 1	قِلَّةِ رَغْبَةِ
u'قِلَّةٌ زادٌ':Added, #2: 2	قِلَّةِ الرِّيعِ
u'قِلَّةٌ زَمَنٌ':Added, #1: 1	قِلَّةِ الزَّادِ
u'قِلَّةٌ سُؤَالٌ':Added, #2: 2	قِلَّةِ الزَّمَنِ
u'قِلَّةٌ شِبَعٌ':Added, #1: 1	قِلَّةُ السُّؤَالِ
u'قِلَّةٌ شَرَائِعُ':Added, #1: 1	قِلَّةُ الشِّبَعِ
u'قِلَّةٌ شكر':Added, #1: 1	قِلَّةَ الشَّرَائِعِ
u'قِلَّةٌ شُكْرٌ':Added, #1: 1	قِلَّةِ الشُّكْرِ
u'قِلَّةٌ شَهْوَةٌ':Added, #1: 1	قِلَّةِ الشُّكْرِ
u'قِلَّةٌ صبر':Added, #1: 1	قِلَّةِ شَهْوَةٍ
u'قِلَّةٌ صَبْرٌ':Added, #3: 3	قِلَّةُ الصَّبْرِ
u'قِلَّةٌ ضَبْطٌ':Added, #3: 3	قِلَّةُ الصَّبْرِ
u'قِلَّةٌ ضَوْءٌ':Added, #1: 1	قِلَّةِ ضَبْطِهِ
u'قِلَّةٌ طَمَعٌ':Added, #1: 1	قِلَّةَ ضَوْءٍ
u'قِلَّةٌ عَدَدٌ':Added, #2: 2	قِلَّةُ الطَّمَعِ
u'قِلَّةٌ عَرْضٌ':Added, #2: 2	قِلَّةِ الْعَدَدِ
u'قِلَّةٌ عَظْمٌ':Added, #1: 1	قِلَّةِ عَرْضِ
u'قِلَّةٌ عَقْلٌ':Added, #1: 1	قِلَّةِ الْعَظْمِ
u'قِلَّةٌ عَقْلٌ':Added, #1: 1	قِلَّةُ الْعَقْلِ
u'قِلَّةٌ عَقْلٌ':Added, #1: 1	قِلَّةِ الْعَقْلِ
u'قِلَّةٌ عَلَفٌ':Added, #1: 1	قِلَّةُ عَقْلِهِ
u'قِلَّةٌ عَلَفٌ':Added, #1: 1	قِلَّةِ الْعَلَفِ
u'قِلَّةٌ علم':Added, #1: 1	قِلَّةِ عَلَفٍ
u'قِلَّةٌ علم':Added, #2: 2	قِلَّةُ الْعِلْمِ
u'قِلَّةٌ عِلْمٌ':Added, #2: 2	قِلَّةِ الْعِلْمِ
u'قِلَّةٌ عِلْمٌ':Added, #2: 2	قِلَّةُ الْعِلْمِ
u'قِلَّةٌ علم':Added, #2: 2	قِلَّةِ الْعِلْمِ
u'قِلَّةٌ عِلْمٌ':Added, #2: 2	قِلَّةِ عِلْمِهِ
u'قِلَّةٌ عَمَلٌ':Added, #2: 2	قِلَّةِ عِلْمِهِ
u'قِلَّةٌ غفلة':Added, #2: 2	قِلَّةِ الْعَمَلِ
u'قِلَّةٌ غَفْلَةٌ':Added, #1: 1	قِلَّةِ الْغَفْلَةِ
u'قِلَّةٌ غَيْرَةٌ':Added, #1: 1	قِلَّةِ الْغَفْلَةِ
u'قِلَّةٌ فِضَّةٌ':Added, #1: 1	قِلَّةُ الْغَيْرَةِ
u'قِلَّةٌ فَضِيلٌ':Added, #1: 1	قِلَّةُ فِضَّةِ
u'قِلَّةٌ فَضِيلَةٌ':Added, #1: 1	قِلَّةِ الْفَضِيلَةِ
u'قِلَّةٌ فِقْهٌ':Added, #1: 1	قِلَّةِ الْفَضِيلَةِ
u'قِلَّةٌ فِقْهٌ':Added, #1: 1	قِلَّةِ فِقْهِهِ
u'قِلَّةٌ فَهْمٌ':Added, #2: 2	قِلَّةِ الْفِقْهِ
u'قِلَّةٌ قِرَاءةٌ':Added, #1: 1	قِلَّةُ فَهْمِهِ
u'قِلَّةٌ كَلاَمٌ':Added, #4: 4	قِلَّةِ الْقِرَاءَةِ
u'قِلَّةٌ كَمِّيٌّ':Added, #7: 7	قِلَّةُ الْكَلَامِ
u'قِلَّةٌ لُبٌّ':Added, #2: 2	قِلَّةِ كَمِّيَّةٍ
u'قِلَّةٌ لَحْمٌ':Added, #1: 1	قِلَّةُ لُبِّهِ
u'قِلَّةٌ لَفْظٌ':Added, #1: 1	قِلَّةِ اللَّحْمِ
u'قِلَّةٌ مَاءٌ':Added, #1: 1	قِلَّةَ اللَّفْظِ
u'قِلَّةٌ مَاءٌ':Added, #1: 1	قِلَّةُ الْمَاءِ
u'قِلَّةٌ مَالٌ':Added, #1: 1	قِلَّةِ مَاءِ
u'قِلَّةٌ مَالٌ':Added, #1: 1	قِلَّةِ مَالِ
u'قِلَّةٌ مَالٌ':Added, #4: 4	قِلَّةَ الْمَالِ
u'قِلَّةٌ مُبَالاَةٌ':Added, #5: 5	قِلَّةِ الْمَالِ
u'قِلَّةٌ مُبَالاَةٌ':Added, #1: 1	قِلَّةُ الْمُبَالَاةِ
u'قِلَّةٌ مُبَالاَةٌ':Added, #1: 1	قِلَّةَ مُبَالَاةٍ
u'قِلَّةٌ مُبَالاَةٌ':Added, #1: 1	قِلَّةُ مُبَالَاةٍ
u'قِلَّةٌ مُبَالاَةٌ':Added, #2: 2	قِلَّةِ مُبَالَاتِهِ
u'قِلَّةٌ مُحَافَظَةٌ':Added, #3: 3	قِلَّةِ الْمُبَالَاةِ
u'قِلَّةٌ مُرَاقَبٌ':Added, #1: 1	قِلَّةِ مُحَافَظَتِهِ
u'قِلَّةٌ مُرَاقَبَةٌ':Added, #1: 1	قِلَّةِ مُرَاقَبَةٍ
u'قِلَّةٌ مَصَاحِفُ':Added, #1: 1	قِلَّةِ مُرَاقَبَةٍ
u'قِلَّةٌ مَطَرٌ':Added, #1: 1	قِلَّةِ الْمَصَاحِفِ
u'قِلَّةٌ مَعْرِفَةٌ':Added, #1: 1	قِلَّةِ الْمَطَرِ
u'قِلَّةٌ مَعْرِفَةٌ':Added, #1: 1	قِلَّةُ مَعْرِفَةٍ
u'قِلَّةٌ مَعْرِفَة':Added, #1: 1	قِلَّةِ مَعْرِفَةٍ
u'قِلَّةٌ مَعْرِفَة':Added, #1: 1	قِلَّةُ مَعْرِفَةٍ
u'قِلَّةٌ مَهْرٌ':Added, #1: 1	قِلَّةِ مَعْرِفَةٍ
u'قِلَّةٌ مِيَاهٌ':Added, #1: 1	قِلَّةِ الْمَهْرِ
u'قِلَّةٌ نَصِيبٌ':Added, #1: 1	قِلَّةِ الْمِيَاهِ
u'قِلَّةٌ نَصِيبٌ':Added, #1: 1	قِلَّةِ نَصِيبِ
u'قِلَّةٌ نَظَرٌ':Added, #1: 1	قِلَّةِ نَصِيبِهِ
u'قِلَّةٌ نقل':Added, #1: 1	قِلَّةُ النَّظَرِ
u'قِلَّةٌ نَقْلٌ':Added, #1: 1	قِلَّةِ النَّقْلِ
u'قِلَّةٌ نَمَاءٌ':Added, #1: 1	قِلَّةِ النَّقْلِ
u'قِلَّةٌ هِدَايَةٌ':Added, #1: 1	قِلَّةِ النَّمَاءِ
u'قِلَّةٌ هِدَايَةٌ':Added, #1: 1	قِلَّةِ هِدَايَةِ
u'قِلَّةٌ وسائط':Added, #2: 2	قِلَّةُ هِدَايَتِهِ
u'قِلَّةٌ وسائط':Added, #1: 1	قِلَّةُ الْوَسَائِطِ
u'قِلَّةٌ وَطْءٌ':Added, #1: 1	قِلَّةِ الْوَسَائِطِ
u'قِلَّةٌ وُقُوعٌ':Added, #1: 1	قِلَّةَ الْوَطْءِ
u'قِلَّةٌ وُقُوعٌ':Added, #1: 1	قِلَّةُ الْوُقُوعِ
u'قِلَّةٌ وُقُوعٌ':Added, #1: 1	قِلَّةُ وُقُوعِهِ
u'قِلَّةٌ يَدٌ':Added, #1: 1	قِلَّةِ وُقُوعِهِ
u'قَلَّ تَأْثِيرٌ':Subject, #1: 1	قِلَّةِ يَدٍ
u'قَلَّ تَجْوِيزٌ':Subject, #1: 1	قَلَّ تَأْثِيرُهُ
u'قَلَّ تَفَكُّرٌ':Subject, #1: 1	قَلَّ تَجْوِيزُهُ
u'قَلَّ ثَمَنٌ':Subject, #1: 1	قَلَّ تَفَكُّرُهُ
u'قَلَّ جَازٌ':Predicate, #2: 2	قَلَّ ثَمَنُهُ
u'قَلَّ جمع':Subject, #2: 2	قَلَّ جَازَ
u'قَلَّ جَمْعٌ':Subject, #1: 1	قَلَّ الْجَمْعُ
u'قَلَّ جمع':Subject, #1: 1	قَلَّ الْجَمْعُ
u'قَلَّ جَمْعٌ':Subject, #1: 1	قَلَّ جَمْعُهُ
u'قَلَّ جهل':Subject, #1: 1	قَلَّ جَمْعُهُ
u'قَلَّ جَهْلٌ':Subject, #2: 2	قَلَّ جَهْلُهُ
u'قَلَّ حَجيجٌ':Subject, #2: 2	قَلَّ جَهْلُهُ
u'قَلَّ حَرامٌ':Subject, #1: 1	قَلَّ الْحَجِيجُ
u'قَلَّ حُزْنٌ':Subject, #4: 4	قَلَّ الْحَرَامُ
u'قَلَّ خَارِجٌ':Subject, #1: 1	قَلَّ حُزْنُهُ
u'قَلَّ خطر':Subject, #1: 1	قَلَّ الْخَارِجُ
u'قَلَّ خَطَرٌ':Subject, #2: 2	قَلَّ خَطَرُهُ
u'قَلَّ خَيْرٌ':Subject, #2: 2	قَلَّ خَطَرُهُ
u'قَلَّ خَيْرٌ':Subject, #1: 1	قَلَّ خَيْرُهُ
u'قَلَّدَ أعْلَمُ':Predicate, #2: 2	قَلَّ خَيْرٌ
u'قَلَّدَ إمَامٌ':Predicate, #1: 1	قَلَّدَ الْأَعْلَمَ
u'قَلَّدَ إمَامٌ':Subject, #1: 1	قَلَّدَ إمَامَ
u'قَلَّدَ إمَامَةٌ':Predicate, #3: 3	قَلَّدَ الْإِمَامُ
u'قَلَّدَ أهْلٌ':Subject, #1: 1	قَلَّدَ الْإِمَامَةَ
u'قَلَّدَ بدنة':Predicate, #1: 1	قَلَّدَ أَهْلُ
u'قَلَّدَ بدنة':Predicate, #1: 1	قَلَّدَ بَدَنَةَ
u'قَلَّدَ بَعْضٌ':Predicate, #2: 2	قَلَّدَ الْبَدَنَةَ
u'قَلَّدَ ثِقَةٌ':Subject, #1: 1	قَلَّدَ بَعْضَ
u'قَلَّدَ خَلِيفَةٌ':Subject, #1: 1	قَلَّدَ ثِقَةٌ
u'قَلَّدَ دَمٌ':Predicate, #2: 2	قَلَّدَ الْخَلِيفَةُ
u'قَلَّدَ رَسُولٌ':Subject, #2: 2	قَلَّدَ دَمَ
u'قَلَّدَ سُلْطَانٌ':Subject, #3: 3	قَلَّدَ رَسُولُ
u'قَلَّدَ شَاةٌ':Predicate, #8: 8	قَلَّدَ السُّلْطَانُ
u'قَلَّدَ شافِعِيّ':Predicate, #1: 1	قَلَّدَ الشَّاةَ
u'قَلَّدَ شَخْصٌ':Subject, #3: 3	قَلَّدَ الشَّافِعِيَّ
u'قَلَّدَ فلان':Predicate, #1: 1	قَلَّدَ شَخْصٌ
u'قَلَّدَ قَائِلٌ':Predicate, #3: 3	قَلَّدَ الشَّافِعِيَّ
u'قَلَّدَ قَائِلٌ':Predicate, #1: 1	قَلَّدَ الْقَائِلِينَ
u'قَلَّدَ قَائِلٌ':Subject, #2: 2	قَلَّدَ الْقَائِلَ
u'قَلَّدَ قَضَاءٌ':Predicate, #1: 1	قَلَّدَ الْقَائِلُ
u'قَلَّدَ قَضَاءٌ':Predicate, #2: 2	قَلَّدَ قَضَاءَ
u'قَلَّ دِماغٌ':Subject, #4: 4	قَلَّدَ الْقَضَاءَ
u'قَلَّدَ مُجْتَهِد':Predicate, #2: 2	قَلَّ دِمَاغُهُ
u'قَلَّدَ مُخَالِفٌ':Predicate, #1: 1	قَلَّدَ الْمُجْتَهِدَ
u'قَلَّدَ هَدَايَا':Subject, #1: 1	قَلَّدَ الْمُخَالِفَ
u'قَلَّدَ هَدْيٌ':Predicate, #1: 1	قَلَّدَ هَدَايَاهُ
u'قَلَّ دونٌ':Predicate, #4: 4	قَلَّدَ الْهَدْيَ
u'قَلَّ دَيْنٌ':Subject, #1: 1	قَلَّ دُونَ
u'قَلَّ ذَهَبٌ':Subject, #5: 5	قَلَّ الدَّيْنُ
u'قَلَّ رَأْسٌ':Subject, #1: 1	قَلَّ الذَّهَبُ
u'قَلَّ رَخْصٌ':Subject, #1: 1	قَلَّ رَأْسُ
u'قَلَّ ريعٌ':Subject, #1: 1	قَلَّ رَخْصٌ
u'قَلَّ زادٌ':Predicate, #1: 1	قَلَّ رِيعُ
u'قَلَّ زائِدٌ':Subject, #1: 1	قَلَّ زَادَ
u'قَلَّ زَمَنٌ':Subject, #1: 1	قَلَّ الزَّائِدُ
u'قَلَّ زَمَنٌ':Subject, #4: 4	قَلَّ زَمَنُ
u'قَلَّ سَبَبٌ':Subject, #4: 4	قَلَّ زَمَنُهُ
u'قَلَّ سفهاء':Subject, #1: 1	قَلَّ سَبَبٌ
u'قَلَّ سُكُونٌ':Subject, #1: 1	قَلَّ سُفَهَاءُ
u'قَلَّ سَلَمٌ':Subject, #1: 1	قَلَّ سُكُونُهُ
u'قَلَّ سُنَّةٌ':Subject, #1: 1	قَلَّ السَّلَمُ
u'قَلَّ سَواءٌ':Subject, #1: 1	قَلَّ سُنَّةٌ
u'قَلَّ شَبَهٌ':Subject, #1: 1	قَلَّ سَوَاءٌ
u'قَلَّ شَعْرٌ':Subject, #1: 1	قَلَّ الشَّبَهُ
u'قَلَّ شكر':Subject, #1: 1	قَلَّ شَعْرُ
u'قَلَّ شُكْرٌ':Subject, #1: 1	قَلَّ شُكْرُهُ
u'قَلَّ شُهُودٌ':Subject, #1: 1	قَلَّ شُكْرُهُ
u'قَلَّ شَيْءٌ':Subject, #1: 1	قَلَّ الشُّهُودُ
u'قَلَّ صبر':Subject, #1: 1	قَلَّ شَيْءٌ
u'قَلَّ صَبْرٌ':Subject, #2: 2	قَلَّ صَبْرُهُ
u'قَلَّ صدق':Subject, #2: 2	قَلَّ صَبْرُهُ
u'قَلَّ صِدْقٌ':Subject, #1: 1	قَلَّ صِدْقُهُ
u'قَلَّ صَدِيقٌ':Subject, #1: 1	قَلَّ صِدْقُهُ
u'قَلَّ ضَرَرٌ':Subject, #3: 3	قَلَّ صَدِيقُهُ
u'قَلَّ طعام':Subject, #1: 1	قَلَّ الضَّرَرُ
u'قَلَّ طَعَامٌ':Subject, #1: 1	قَلَّ الطَّعَامُ
u'قَلَّ طعام':Subject, #1: 1	قَلَّ الطَّعَامُ
u'قَلَّ طَعَامٌ':Subject, #1: 1	قَلَّ طَعَامُهُ
u'قَلَعَ أعْوَر':Subject, #1: 1	قَلَّ طَعَامُهُ
u'قَلَعَ إِنْسانٌ':Subject, #3: 3	قَلَعَ الْأَعْوَرُ
u'قَلَعَ بَائِعٌ':Subject, #1: 1	قَلَعَ إنْسَانٌ
u'قَلَعَ بِنَاءٌ':Predicate, #3: 3	قَلَعَ الْبَائِعُ
u'قَلَّ عتاب':Subject, #1: 1	قَلَعَ الْبِنَاءَ
u'قَلَّ عِتَابٌ':Subject, #1: 1	قَلَّ عِتَابُهُ
u'قَلَعَ جِذْعٌ':Predicate, #1: 1	قَلَّ عِتَابُهُ
u'قَلَعَ حَجَّام':Subject, #4: 4	قَلَعَ الْجِذْعَ
u'قَلَعَ حَدَق':Predicate, #1: 1	قَلَعَ الْحَجَّامُ
u'قَلَعَ حَدَقَة':Predicate, #1: 1	قَلَعَ حَدَقَةَ
u'قَلَّ عَدَدٌ':Subject, #1: 1	قَلَعَ حَدَقَةَ
u'قَلَّ عَدَدٌ':Subject, #1: 1	قَلَّ عَدَدُ
u'قَلَعَ رَبُّ':Subject, #2: 2	قَلَّ الْعَدَدُ
u'قَلَعَ رَجُلٌ':Subject, #1: 1	قَلَعَ رَبُّ
u'قَلَعَ رَجُلٌ':Subject, #3: 3	قَلَعَ رَجُلٌ
u'قَلَعَ رَطْبَةٌ':Predicate, #4: 4	قَلَعَ الرَّجُلُ
u'قَلَعَ زَرْعٌ':Predicate, #2: 2	قَلَعَ الرَّطْبَةَ
u'قَلَعَ سِنٌّ':Predicate, #3: 3	قَلَعَ الزَّرْعَ
u'قَلَعَ سِنٌّ':Predicate, #26: 26	قَلَعَ سِنَّ
u'قَلَعَ سَيْل':Subject, #3: 3	قَلَعَ السِّنَّ
u'قَلَعَ شَوْكٌ':Predicate, #1: 1	قَلَعَ السَّيْلُ
u'قَلَعَ شَوْكِ':Predicate, #1: 1	قَلَعَ شَوْكَ
u'قَلَعَ صَاحِبٌ':Subject, #1: 1	قَلَعَ شَوْكَ
u'قَلَعَ ظاهِرٌ':Predicate, #1: 1	قَلَعَ صَاحِبُ
u'قَلَعَ ظُفْرٌ':Predicate, #1: 1	قَلَعَ الظَّاهِرَ
u'قَلَعَ عَلَقٌ':Predicate, #1: 1	قَلَعَ ظُفْرَ
u'قَلَعَ عَلَق':Predicate, #1: 1	قَلَعَ الْعَلَقَ
u'قَلَعَ غِرَاسٌ':Predicate, #1: 1	قَلَعَ الْعَلَقَ
u'قَلَعَ غَرْسٌ':Predicate, #1: 1	قَلَعَ الْغِرَاسَ
u'قَلَعَ غير':Predicate, #1: 1	قَلَعَ الْغَرْسَ
u'قَلَعَ غَيْرٌ':Predicate, #1: 1	قَلَعَ غَيْرَ
u'قَلَّ عَقْلٌ':Subject, #1: 1	قَلَعَ غَيْرَ
u'قَلَعَ لِسَانٌ':Predicate, #4: 4	قَلَّ عَقْلُهُ
u'قَلَعَ لِسَانٌ':Subject, #1: 1	قَلَعَ لِسَانَ
u'قَلَّ عَلَفٌ':Subject, #1: 1	قَلَعَ لِسَانُ
u'قَلَعَ مَالِكٌ':Subject, #1: 1	قَلَّ الْعَلَفُ
u'قَلَعَ مُسْتَحِقٌّ':Subject, #1: 1	قَلَعَ الْمَالِكُ
u'قَلَعَ مُعَادٌ':Predicate, #1: 1	قَلَعَ الْمُسْتَحِقُّ
u'قَلَّ عَمَلٌ':Subject, #1: 1	قَلَعَ الْمُعَادَةَ
u'قَلَّ عَمَلٌ':Subject, #1: 1	قَلَّ الْعَمَلُ
u'قَلَّ عَيْبٌ':Subject, #1: 1	قَلَّ عَمَلُهُ
u'قَلَّ عَيْبٌ':Subject, #1: 1	قَلَّ الْعَيْبُ
u'قَلَّ غِذَاءٌ':Subject, #1: 1	قَلَّ عَيْبٌ
u'قَلَّ غَرَرٌ':Subject, #1: 1	قَلَّ غِذَاءُ
u'قَلَّ غُرْمٌ':Subject, #2: 2	قَلَّ الْغَرَرُ
u'قَلَّ غضب':Subject, #1: 1	قَلَّ الْغُرْمُ
u'قَلَّ غَضَبٌ':Subject, #1: 1	قَلَّ الْغَضَبُ
u'قَلَّ فرح':Subject, #1: 1	قَلَّ الْغَضَبُ
u'قَلَّ فَرَحٌ':Subject, #1: 1	قَلَّ فَرَحُهُ
u'قَلَّ فرق':Subject, #1: 1	قَلَّ فَرَحُهُ
u'قَلَّ فَرْقٌ':Subject, #1: 1	قَلَّ الْفَرْقُ
u'قَلَّ فَصٌّ':Subject, #1: 1	قَلَّ الْفَرْقُ
u'قَلَّ قَالٌ':Predicate, #2: 2	قَلَّ فَصُّهُ
u'قَلَّ قَدْرٌ':Subject, #2: 2	قَلَّ قَالَ
u'قَلَقٌ نَفْسٌ':Added, #1: 1	قَلَّ قَدْرُهُ
u'قَلَّ قَوْمٌ':Subject, #1: 1	قَلَقُ النَّفْسِ
u'قَلَّ كَلاَمٌ':Subject, #1: 1	قَلَّ الْقَوْمُ
u'قَلَّ كَيْدٌ':Subject, #1: 1	قَلَّ كَلَامُهُ
u'قَلَّ لبن':Subject, #1: 1	قَلَّ كَيْدُهُ
u'قَلَّ لَبَنٌ':Subject, #1: 1	قَلَّ اللَّبَنُ
u'قَلَّ لَيْلٌ':Subject, #1: 1	قَلَّ اللَّبَنُ
u'قَلَّ مَاءٌ':Subject, #1: 1	قَلَّ لَيْلَةٌ
u'قَلَّ مَاءٌ':Subject, #3: 3	قَلَّ مَاءُ
u'قَلَّمَ أَكْثَرُ':Predicate, #4: 4	قَلَّ الْمَاءُ
u'قَلَّ مَالٌ':Subject, #2: 2	قَلَّمَ أَكْثَرَ
u'قَلَّ مَالٌ':Subject, #11: 11	قَلَّ الْمَالُ
u'قَلَّ مَالٌ':Subject, #2: 2	قَلَّ مَالُهُ
u'قَلَّ مثل':Predicate, #3: 3	قَلَّ مَالُ
u'قَلَّ مِثْلٌ':Predicate, #1: 1	قَلَّ مِثْلَ
u'قَلَّ مثل':Subject, #1: 1	قَلَّ مِثْلَ
u'قَلَّ مِثْلٌ':Subject, #1: 1	قَلَّ مِثْلُ
u'قَلَّمَ ثَلاثَةٌ':Predicate, #1: 1	قَلَّ مِثْلُ
u'قَلَّمَ حَلالٌ':Subject, #2: 2	قَلَّمَ ثَلَاثَةَ
u'قَلَّمَ خَمْسَةٌ':Predicate, #1: 1	قَلَّمَ الْحَلَالُ
u'قَلَّ مَشْرَبٌ':Subject, #5: 5	قَلَّمَ خَمْسَةَ
u'قَلَّ مَطْعَمٌ':Subject, #1: 1	قَلَّ مَشْرَبُهُ
u'قَلَّمَ ظُفْرٌ':Predicate, #1: 1	قَلَّ مَطْعَمُهُ
u'قَلَّ مَقْبُوضٌ':Subject, #1: 1	قَلَّمَ ظُفْرَ
u'قَلَّ مُكْثٌ':Subject, #1: 1	قَلَّ الْمَقْبُوضُ
u'قَلَّمَ مُحْرِمٌ':Subject, #1: 1	قَلَّ مُكْثُهُ
u'قَلَّ مَوْصُوفٌ':Subject, #1: 1	قَلَّمَ الْمُحْرِمُ
u'قَلَّ نَاسٌ':Subject, #1: 1	قَلَّ الْمَوْصُوفُ
u'قَلَّ نَجْمٌ':Subject, #2: 2	قَلَّ النَّاسُ
u'قَلَّ نَصِيبٌ':Subject, #1: 1	قَلَّ نَجْمُهُ
u'قَلَّ نَصِيبٌ':Subject, #1: 1	قَلَّ نَصِيبُهُ
u'قَلَّ نُقْصَانٌ':Subject, #2: 2	قَلَّ نَصِيبُ
u'قَلَّ نُورٌ':Subject, #4: 4	قَلَّ النُّقْصَانُ
u'قَلَّ هَمٌّ':Subject, #1: 1	قَلَّ النُّورُ
u'قَلَّ وَاجِبٌ':Subject, #1: 1	قَلَّ هَمُّهُ
u'قُلُوبٌ أحَدٌ':Added, #1: 1	قَلَّ الْوَاجِبُ
u'قُلُوبٌ أعاجم':Added, #1: 1	قُلُوبُ أَحَدِ
u'قُلُوبٌ أعاجم':Added, #1: 1	قُلُوبُ الأَعَاجِمِ
u'قُلُوبٌ أَقْوَامٌ':Added, #1: 1	قُلُوبُ الْأَعَاجِمِ
u'قُلُوبٌ أُمَّةٌ':Added, #4: 4	قُلُوبَ أَقْوَامٍ
u'قُلُوبٌ أنبياء':Added, #1: 1	قُلُوبَ أُمَّتِهِ
u'قُلُوبٌ أهْلٌ':Added, #1: 1	قُلُوبُ الْأَنْبِيَاءِ
u'قُلُوبٌ أهْلٌ':Added, #1: 1	قُلُوبُ أَهْلِ
u'قُلُوبٌ أَوْلاَدٌ':Added, #5: 5	قُلُوبِ أَهْلِ
u'قُلُوبٌ بَعْضٌ':Added, #4: 4	قُلُوبِ أَوْلَادِ
u'قُلُوبٌ جُهَّالٌ':Added, #1: 1	قُلُوبَ بَعْضِ
u'قُلُوبٌ خلق':Added, #1: 1	قُلُوبُ الْجُهَّالِ
u'قُلُوبٌ خَلْقٌ':Added, #1: 1	قُلُوبَ الْخَلْقِ
u'قُلُوبٌ خلق':Added, #1: 1	قُلُوبَ الْخَلْقِ
u'قُلُوبٌ خَلْقٌ':Added, #2: 2	قُلُوبُ الْخَلْقِ
u'قُلُوبٌ ذِئابٌ':Added, #2: 2	قُلُوبُ الْخَلْقِ
u'قُلُوبٌ رِجَالٌ':Added, #1: 1	قُلُوبُ الذِّئَابِ
u'قُلُوبٌ رِجَالٌ':Added, #1: 1	قُلُوبِ الرّجَالِ
u'قُلُوبٌ رِجَالٌ':Added, #3: 3	قُلُوبَ الرِّجَالِ
u'قُلُوبٌ رِجَالٌ':Added, #4: 4	قُلُوبِ الرِّجَالِ
u'قُلُوبٌ شركاء':Added, #6: 6	قُلُوبَ رِجَالٍ
u'قُلُوبٌ شَيَاطِينُ':Added, #1: 1	قُلُوبِ الشُّرَكَاءِ
u'قُلُوبٌ صِبْيَانٌ':Added, #1: 1	قُلُوبُ الشَّيَاطِينِ
u'قُلُوبٌ صَحَابَةٌ':Added, #1: 1	قُلُوبِ الصِّبْيَانِ
u'قُلُوبٌ عَامٌّ':Added, #1: 1	قُلُوبِ الصَّحَابَةِ
u'قُلُوبٌ عِبَادٌ':Added, #1: 1	قُلُوبِ الْعَامَّةِ
u'قُلُوبٌ عِبَادٌ':Added, #1: 1	قُلُوبَ الْعِبَادِ
u'قُلُوبٌ عَرَبٌ':Added, #6: 6	قُلُوبِ عِبَادِهِ
u'قُلُوبٌ عَرَبٌ':Added, #1: 1	قُلُوبَ الْعَرَبِ
u'قُلُوبٌ عُقَلاَءُ':Added, #1: 1	قُلُوبِ الْعَرَبِ
u'قُلُوبٌ عَوَامُّ':Added, #1: 1	قُلُوبُ الْعُقَلَاءِ
u'قُلُوبٌ فَرِيقٌ':Added, #2: 2	قُلُوبِ الْعَوَامِّ
u'قُلُوبٌ فَرِيقٌ':Added, #1: 1	قُلُوبَ فَرِيقٍ
u'قُلُوبٌ فقراء':Added, #5: 5	قُلُوبُ فَرِيقٍ
u'قُلُوبٌ فقراء':Added, #1: 1	قُلُوبُ الْفُقَرَاءِ
u'قُلُوبٌ قَوْمٌ':Added, #3: 3	قُلُوبِ الْفُقَرَاءِ
u'قُلُوبٌ كُفَّارٌ':Added, #3: 3	قُلُوبَ قَوْمٍ
u'قُلُوبٌ كُفَّارٌ':Added, #1: 1	قُلُوبَ الْكُفَّارِ
u'قُلُوبٌ مُتَوَكِّلٌ':Added, #3: 3	قُلُوبِ الْكُفَّارِ
u'قُلُوبٌ نَاسٌ':Added, #1: 1	قُلُوبِ الْمُتَوَكِّلَةِ
u'قُلُوبٌ نَاسٌ':Added, #1: 1	قُلُوبُ النَّاسِ
u'قُلُوبٌ نَاسٌ':Added, #1: 1	قُلُوبِ النّاسِ
u'قُلُوبٌ نَاسٌ':Added, #2: 2	قُلُوبَ النَّاسِ
u'قَلَّ وُجُودٌ':Subject, #9: 9	قُلُوبِ النَّاسِ
u'قَلَّ وَزْنٌ':Subject, #1: 1	قَلَّ وُجُودُهُ
u'قَلَّ وَصْفٌ':Subject, #1: 1	قَلَّ وَزْنُهُ
u'قَلَّ وُفُورٌ':Subject, #2: 2	قَلَّ وَصْفُهُ
u'قَلَّ وُقُوعٌ':Subject, #1: 1	قَلَّ وُفُورُ
u'قَلَّ وَلَهٌ':Subject, #1: 1	قَلَّ وُقُوعُ
u'قَلَى حِنْطَةٌ':Predicate, #1: 1	قَلَّ وَلَهُ
u'قَلَّ يَوْمٌ':Subject, #1: 1	قَلَى الْحِنْطَةَ
u'قَمَطَ رَجُلٌ':Subject, #6: 6	قَلَّ يَوْمٌ
u'قَمَطَ وَرَمٌ':Subject, #1: 1	قَمَطَ رَجُلٌ
u'قَمْعٌ أَهْوَاءٌ':Added, #1: 1	قَمَطَ وَرَمَاهُ
u'قَمْعٌ رَطْبَةٌ':Added, #1: 1	قَمْعِ أَهْوَاءِ
u'قَنَا اِسْمٌ':Subject, #1: 1	قَمْع الرَّطْبَةِ
u'قَنَاعَةٌ زُهْدٌ':Added, #1: 1	قَنَا اسْمُ
u'قَنَتَ إمَامٌ':Subject, #1: 1	قَنَاعَةِ زُهْدِهِ
u'قَنَتَ جَازٌ':Predicate, #6: 6	قَنَتَ الْإِمَامُ
u'قَنَتَ رَسُولٌ':Subject, #1: 1	قَنَتَ جَازَ
u'قَنَتَ عَلِيٌّ':Subject, #25: 25	قَنَتَ رَسُولُ
u'قَنَتَ عُمَرٌ':Subject, #2: 2	قَنَتَ عَلِيٌّ
u'قَنَتَ عند':Predicate, #2: 2	قَنَتَ عُمَرُ
u'قَنْطَرَةٌ إِسْلامٌ':Added, #1: 1	قَنَتَ عِنْدَ
u'قَنْطَرَةٌ جِسْرٌ':Added, #1: 1	قَنْطَرَةُ الْإِسْلَامِ
u'قَنْطَرَةٌ ضَيِّقٌ':Added, #1: 1	قَنْطَرَةِ جِسْرٍ
u'قَنْطَرَةٌ عَاهِرٌ':Added, #1: 1	قَنْطَرَةٍ ضَيِّقَةٍ
u'قَنَعَ حاكِمٌ':Subject, #1: 1	قَنْطَرَةِ عَاهِرَةٍ
u'قَنَّعَ رَسُولٌ':Subject, #2: 2	قَنَعَ الْحَاكِمُ
u'قَهْرٌ أحَدٌ':Added, #1: 1	قَنَّعَ رَسُولُ
u'قَهْرٌ أَسْرٌ':Added, #1: 1	قَهْرُ أَحَدٍ
u'قَهْرٌ أَعْدَاءٌ':Added, #1: 1	قَهْرِ الْأَسْرِ
u'قَهَرَ أَقْوَامٌ':Predicate, #1: 1	قَهْرِ الْأَعْدَاءِ
u'قَهْرٌ إمَامٌ':Added, #1: 1	قَهَرَ الْأَقْوَامَ
u'قَهْرٌ أَميرٌ':Added, #1: 1	قَهْرُ الْإِمَامِ
u'قَهَرَ حُرٌّ':Subject, #2: 2	قَهْرِ الْأَمِيرِ
u'قَهْرٌ خَصْمٌ':Added, #1: 1	قَهَرَ حُرٌّ
u'قَهْرٌ زَوْجٌ':Added, #1: 1	قَهْرِ الْخَصْمِ
u'قَهْرٌ سَيِّدٌ':Added, #1: 1	قَهْرِ الزَّوْجِ
u'قَهْرٌ غير':Added, #1: 1	قَهْرِ السَّيِّدِ
u'قَهْرٌ غَيْرٌ':Added, #7: 7	قَهْرَ غَيْرِهِ
u'قَهْرٌ مَاءٌ':Added, #7: 7	قَهْرَ غَيْرِهِ
u'قَهْرٌ مَاءٌ':Added, #1: 1	قَهْرُ الْمَاءِ
u'قَهَرَ مَدْيُونٌ':Subject, #6: 6	قَهْرَ الْمَاءِ
u'قَهْرٌ مُرْتَدٌّ':Added, #2: 2	قَهَرَ مَدْيُونٌ
u'قَهَرَ مُسْلِمٌ':Predicate, #1: 1	قَهْرِ الْمُرْتَدِّ
u'قَهَرَ مُسْلِمٌ':Subject, #1: 1	قَهَرَ مُسْلِمِينَ
u'قَهْرٌ مُسْلِمٌ':Added, #1: 1	قَهَرَ مُسْلِمٌ
u'قَهَرَ نَاسٌ':Predicate, #1: 1	قَهْرِ الْمُسْلِمِ
u'قَهْرٌ نِصْفٌ':Added, #1: 1	قَهَرَ النَّاسَ
u'قَهْرٌ نَفْسٌ':Added, #1: 1	قَهْرُ نِصْفِ
u'قَهْقَهَ إمَامٌ':Subject, #3: 3	قَهْرِ النَّفْسِ
u'قَهْقَهَ بَعْضٌ':Subject, #4: 4	قَهْقَهَ الْإِمَامُ
u'قَهْقَهَ قَوْمٌ':Subject, #1: 1	قَهْقَهَ بَعْضُ
u'قَهْقَهَ مُرَاهِقٌ':Subject, #3: 3	قَهْقَهَ الْقَوْمُ
u'قِوَامٌ أبدانٌ':Added, #1: 1	قَهْقَهَ الْمُرَاهِقُ
u'قِوَامٌ أَجْسَامٌ':Added, #1: 1	قِوَامُ الْأَبْدَانِ
u'قِوَامٌ آدَمِيٌّ':Added, #1: 1	قِوَامُ الْأَجْسَامِ
u'قِوَامٌ أرْضٌ':Added, #1: 1	قِوَامُ الْآدَمِيِّ
u'قِوَامٌ أَشْيَاءٌ':Added, #1: 1	قِوَامَ الْأَرْضِ
u'قِوَامٌ أَغْصَانٌ':Added, #1: 1	قِوَامَ الْأَشْيَاءِ
u'قِوَامٌ بدن':Added, #1: 1	قِوَامَ الْأَغْصَانِ
u'قِوَامٌ بَدَنٌ':Added, #1: 1	قِوَامَ الْبَدَنِ
u'قِوَامٌ بَطْشٌ':Added, #1: 1	قِوَامَ الْبَدَنِ
u'قِوَامٌ حَقٌّ':Added, #1: 1	قِوَامَ الْبَطْشِ
u'قِوَامٌ حَيَاةٌ':Added, #1: 1	قِوَامِ الْحَقِّ
u'قِوَامٌ خلق':Added, #2: 2	قِوَامُ الْحَيَاةِ
u'قِوَامٌ خَلْقٌ':Added, #1: 1	قِوَامَ الْخَلْقِ
u'قِوَامٌ دِينٌ':Added, #1: 1	قِوَامَ الْخَلْقِ
u'قِوَامٌ دِينٌ':Added, #20: 20	قِوَامُ الدِّينِ
u'قِوَامٌ روحٌ':Added, #4: 4	قِوَامِ الدِّينِ
u'قِوَامٌ صِحَّةٌ':Added, #1: 1	قِوَامُ الرُّوحِ
u'قِوَامٌ صَيْدٌ':Added, #1: 1	قِوَامُ الصِّحَّةِ
u'قِوَامٌ عَقْدٌ':Added, #1: 1	قِوَامَ الصَّيْدِ
u'قِوَامٌ عَيْشٌ':Added, #2: 2	قِوَامُ الْعَقْدِ
u'قِوَامٌ عَيْشٌ':Added, #1: 1	قِوَامُ الْعَيْشِ
u'قِوَامٌ مَاءٌ':Added, #1: 1	قِوَامِ الْعَيْشِ
u'قِوَامٌ مَعَاشٌ':Added, #1: 1	قِوَامِ الْمَاءِ
u'قِوَامٌ مُعْتَادٌ':Added, #1: 1	قِوَامُ الْمَعَاشِ
u'قِوَامٌ نَفْسٌ':Added, #2: 2	قِوَامُ مُعْتَادِ
u'قِوَامٌ نَفْسٌ':Added, #1: 1	قِوَامُ النَّفْسِ
u'قِوَامٌ نَفْسٌ':Added, #1: 1	قِوَامِ النَّفْسِ
u'قُوَّةٌ إبْصَارٌ':Added, #1: 1	قِوَامُ نَفْسِهِ
u'قُوَّة إبْصَارٌ':Added, #1: 1	قُوَّةِ الْإِبْصَارِ
u'قُوَّةٌ اِتِّصَالٌ':Added, #1: 1	قُوَّةِ الْإِبْصَارِ
u'قُوَّة اِتِّصَالٌ':Added, #2: 2	قُوَّةُ اتِّصَالِ
u'قُوَّةٌ إِثْبَاتٌ':Added, #2: 2	قُوَّةُ اتِّصَالِ
u'قُوَّة إِثْبَاتٌ':Added, #1: 1	قُوَّةِ الْإِثْبَاتِ
u'قُوَّةٌ أثَرٌ':Added, #1: 1	قُوَّةِ الْإِثْبَاتِ
u'قُوَّة أثَرٌ':Added, #1: 1	قُوَّةِ أَثَرِهِ
u'قُوَّةٌ أثَرٌ':Added, #1: 1	قُوَّةِ أَثَرِهِ
u'قُوَّةٌ أثَرٌ':Added, #3: 3	قُوَّةُ الْأَثَرِ
u'قُوَّة أثَرٌ':Added, #3: 3	قُوَّةِ الْأَثَرِ
u'قُوَّة أثَرٌ':Added, #3: 3	قُوَّةُ الْأَثَرِ
u'قُوَّةٌ اِجْتِهَادٌ':Added, #3: 3	قُوَّةِ الْأَثَرِ
u'قُوَّة اِجْتِهَادٌ':Added, #1: 1	قُوَّةُ اجْتِهَادِ
u'قُوَّةٌ إِحالَةٌ':Added, #1: 1	قُوَّةُ اجْتِهَادِ
u'قُوَّة إِحالَةٌ':Added, #1: 1	قُوَّةَ الْإِحَالَةِ
u'قُوَّةٌ اِحْترَازٌ':Added, #1: 1	قُوَّةَ الْإِحَالَةِ
u'قُوَّة اِحْترَازٌ':Added, #1: 1	قُوَّةِ احْتِرَازِهِ
u'قُوَّةٌ أخْذٌ':Added, #1: 1	قُوَّةِ احْتِرَازِهِ
u'قُوَّة أخْذٌ':Added, #1: 1	قُوَّةُ أَخْذِ
u'قُوَّةٌ إِخْوَةٌ':Added, #1: 1	قُوَّةُ أَخْذِ
u'قُوَّة إِخْوَةٌ':Added, #1: 1	قُوَّةُ الْإِخْوَةِ
u'قُوَّةٌ إِرْثٌ':Added, #1: 1	قُوَّةُ الْإِخْوَةِ
u'قُوَّة إِرْثٌ':Added, #1: 1	قُوَّةَ إرْثِهِ
u'قُوَّةٌ إِرْثٌ':Added, #1: 1	قُوَّةَ إرْثِهِ
u'قُوَّة إِرْثٌ':Added, #1: 1	قُوَّةِ الْإِرْثِ
u'قُوَّةٌ أرْضٌ':Added, #1: 1	قُوَّةِ الْإِرْثِ
u'قُوَّة أرْضٌ':Added, #1: 1	قُوَّةَ الْأَرْضِ
u'قُوَّةٌ أسْبَابٌ':Added, #1: 1	قُوَّةَ الْأَرْضِ
u'قُوَّة أسْبَابٌ':Added, #1: 1	قُوَّةِ الْأَسْبَابِ
u'قُوَّةٌ أَسْبَابٌ':Added, #1: 1	قُوَّةِ الْأَسْبَابِ
u'قُوَّة أَسْبَابٌ':Added, #1: 1	قُوَّةِ الْأَسْبَابِ
u'قُوَّةٌ إِسْكارٌ':Added, #1: 1	قُوَّةِ الْأَسْبَابِ
u'قُوَّة إِسْكارٌ':Added, #1: 1	قُوَّةُ الْإِسْكَارِ
u'قُوَّةٌ إِسْلامٌ':Added, #1: 1	قُوَّةُ الْإِسْكَارِ
u'قُوَّة إِسْلامٌ':Added, #1: 1	قُوَّةِ الْإِسْلَامِ
u'قُوَّةٌ أصل':Added, #1: 1	قُوَّةِ الْإِسْلَامِ
u'قُوَّة أصل':Added, #1: 1	قُوَّةَ الْأَصْلِ
u'قُوَّةٌ أًصْلٌ':Added, #1: 1	قُوَّةَ الْأَصْلِ
u'قُوَّة أًصْلٌ':Added, #1: 1	قُوَّةَ الْأَصْلِ
u'قُوَّةٌ اِعْتِبارٌ':Added, #1: 1	قُوَّةَ الْأَصْلِ
u'قُوَّة اِعْتِبارٌ':Added, #1: 1	قُوَّةُ اعْتِبَارِهِ
u'قُوَّةٌ أَعْضَاءٌ':Added, #1: 1	قُوَّةُ اعْتِبَارِهِ
u'قُوَّة أَعْضَاءٌ':Added, #1: 1	قُوَّةَ أَعْضَاءِ
u'قُوَّةٌ إمَارَةٌ':Added, #1: 1	قُوَّةَ أَعْضَاءِ
u'قُوَّة إمَارَةٌ':Added, #1: 1	قُوَّةِ الْإِمَارَةِ
u'قُوَّةٌ أَمْرٌ':Added, #1: 1	قُوَّةِ الْإِمَارَةِ
u'قُوَّة أَمْرٌ':Added, #1: 1	قُوَّةِ الْأَمْرِ
u'قُوَّةٌ إِمْساكٌ':Added, #1: 1	قُوَّةِ الْأَمْرِ
u'قُوَّة إِمْساكٌ':Added, #1: 1	قُوَّةِ إمْسَاكِهِ
u'قُوَّةٌ إِنْباتٌ':Added, #1: 1	قُوَّةِ إمْسَاكِهِ
u'قُوَّة إِنْباتٌ':Added, #1: 1	قُوَّةَ الْإِنْبَاتِ
u'قُوَّةٌ إِنْباتٌ':Added, #1: 1	قُوَّةَ الْإِنْبَاتِ
u'قُوَّةٌ إِنْباتٌ':Added, #2: 2	قُوَّةُ الْإِنْبَاتِ
u'قُوَّة إِنْباتٌ':Added, #2: 2	قُوَّةِ الْإِنْبَاتِ
u'قُوَّة إِنْباتٌ':Added, #2: 2	قُوَّةُ الْإِنْبَاتِ
u'قُوَّةٌ أَوَّلُ':Added, #2: 2	قُوَّةِ الْإِنْبَاتِ
u'قُوَّة أَوَّلُ':Added, #2: 2	قُوَّةِ الْأَوَّلِ
u'قُوَّةٌ إِيجَابٌ':Added, #2: 2	قُوَّةِ الْأَوَّلِ
u'قُوَّة إِيجَابٌ':Added, #1: 1	قُوَّةِ الْإِيجَابِ
u'قُوَّةٌ أَيْمَانٌ':Added, #1: 1	قُوَّةِ الْإِيجَابِ
u'قُوَّة أَيْمَانٌ':Added, #1: 1	قُوَّةِ أَيْمَانٍ
u'قُوَّةٌ إيمَانٌ':Added, #1: 1	قُوَّةِ أَيْمَانٍ
u'قُوَّة إيمَانٌ':Added, #2: 2	قُوَّةُ إيمَانِهِ
u'قُوَّةٌ بَأسٌ':Added, #2: 2	قُوَّةُ إيمَانِهِ
u'قُوَّة بَأسٌ':Added, #1: 1	قُوَّةَ بَأْسٍ
u'قُوَّةٌ بَاعِثٌ':Added, #1: 1	قُوَّةَ بَأْسٍ
u'قُوَّة بَاعِثٌ':Added, #1: 1	قُوَّةِ الْبَاعِثِ
u'قُوَّةٌ بدن':Added, #1: 1	قُوَّةِ الْبَاعِثِ
u'قُوَّة بدن':Added, #1: 1	قُوَّةُ الْبَدَنِ
u'قُوَّةٌ بَدَنٌ':Added, #1: 1	قُوَّةُ الْبَدَنِ
u'قُوَّة بَدَنٌ':Added, #1: 1	قُوَّةُ الْبَدَنِ
u'قُوَّةٌ بدن':Added, #1: 1	قُوَّةُ الْبَدَنِ
u'قُوَّة بدن':Added, #1: 1	قُوَّةُ بَدَنِهِ
u'قُوَّةٌ بَدَنٌ':Added, #1: 1	قُوَّةُ بَدَنِهِ
u'قُوَّة بَدَنٌ':Added, #1: 1	قُوَّةُ بَدَنِهِ
u'قُوَّةٌ بدن':Added, #1: 1	قُوَّةُ بَدَنِهِ
u'قُوَّة بدن':Added, #3: 3	قُوَّةِ الْبَدَنِ
u'قُوَّةٌ بَدَنٌ':Added, #3: 3	قُوَّةِ الْبَدَنِ
u'قُوَّة بَدَنٌ':Added, #3: 3	قُوَّةِ الْبَدَنِ
u'قُوَّةٌ بَشَرٌ':Added, #3: 3	قُوَّةِ الْبَدَنِ
u'قُوَّة بَشَرٌ':Added, #1: 1	قُوَّةِ الْبَشَرِ
u'قُوَّةٌ بَشَرٌ':Added, #1: 1	قُوَّةِ الْبَشَرِ
u'قُوَّة بَشَرٌ':Added, #1: 1	قُوَّةِ بَشَرٍ
u'قُوَّةٌ بَصيرٌ':Added, #1: 1	قُوَّةِ بَشَرٍ
u'قُوَّة بَصيرٌ':Added, #1: 1	قُوَّةِ الْبَصِيرَةِ
u'قُوَّةٌ بَصيرَةٌ':Added, #1: 1	قُوَّةِ الْبَصِيرَةِ
u'قُوَّة بَصيرَةٌ':Added, #1: 1	قُوَّةِ الْبَصِيرَةِ
u'قُوَّةٌ بَطْشٌ':Added, #1: 1	قُوَّةِ الْبَصِيرَةِ
u'قُوَّة بَطْشٌ':Added, #1: 1	قُوَّةِ الْبَطْشِ
u'قُوَّةٌ بَطْشٌ':Added, #1: 1	قُوَّةِ الْبَطْشِ
u'قُوَّة بَطْشٌ':Added, #4: 4	قُوَّةَ الْبَطْشِ
u'قُوَّةٌ بَعْضٌ':Added, #4: 4	قُوَّةَ الْبَطْشِ
u'قُوَّة بَعْضٌ':Added, #1: 1	قُوَّةِ الْبَعْضِ
u'قُوَّةٌ تَسْلِيمٌ':Added, #1: 1	قُوَّةِ الْبَعْضِ
u'قُوَّة تَسْلِيمٌ':Added, #1: 1	قُوَّةُ التَّسْلِيمِ
u'قُوَّةٌ تَصْحِيحٌ':Added, #1: 1	قُوَّةُ التَّسْلِيمِ
u'قُوَّة تَصْحِيحٌ':Added, #1: 1	قُوَّةُ تَصْحِيحِ
u'قُوَّةٌ تَطْهِيرٌ':Added, #1: 1	قُوَّةُ تَصْحِيحِ
u'قُوَّة تَطْهِيرٌ':Added, #1: 1	قُوَّةُ التَّطْهِيرِ
u'قُوَّةٌ تَعَلُّقٌ':Added, #1: 1	قُوَّةُ التَّطْهِيرِ
u'قُوَّة تَعَلُّقٌ':Added, #1: 1	قُوَّةَ تَعَلُّقِهِ
u'قُوَّةٌ تَعْمِيمٌ':Added, #1: 1	قُوَّةَ تَعَلُّقِهِ
u'قُوَّة تَعْمِيمٌ':Added, #1: 1	قُوَّةِ التَّعْمِيمِ
u'قُوَّةٌ تُهْمَةٌ':Added, #1: 1	قُوَّةِ التَّعْمِيمِ
u'قُوَّة تُهْمَةٌ':Added, #1: 1	قُوَّةُ التُّهْمَةِ
u'قُوَّةٌ تُهْمَةٌ':Added, #1: 1	قُوَّةُ التُّهْمَةِ
u'قُوَّة تُهْمَةٌ':Added, #3: 3	قُوَّةِ التُّهْمَةِ
u'قُوَّةٌ ثبات':Added, #3: 3	قُوَّةِ التُّهْمَةِ
u'قُوَّة ثبات':Added, #1: 1	قُوَّةُ ثَبَاتِ
u'قُوَّةٌ ثبَاتٌ':Added, #1: 1	قُوَّةُ ثَبَاتِ
u'قُوَّة ثبَاتٌ':Added, #1: 1	قُوَّةُ ثَبَاتِ
u'قُوَّةٌ ثُبُوتٌ':Added, #1: 1	قُوَّةُ ثَبَاتِ
u'قُوَّة ثُبُوتٌ':Added, #1: 1	قُوَّةِ الثُّبُوتِ
u'قُوَّةٌ ثُبُوتٌ':Added, #1: 1	قُوَّةِ الثُّبُوتِ
u'قُوَّة ثُبُوتٌ':Added, #2: 2	قُوَّةَ الثُّبُوتِ
u'قُوَّةٌ ثَوْبٌ':Added, #2: 2	قُوَّةَ الثُّبُوتِ
u'قُوَّة ثَوْبٌ':Added, #2: 2	قُوَّةَ الثَّوْبِ
u'قُوَّةٌ جَانِبٌ':Added, #2: 2	قُوَّةَ الثَّوْبِ
u'قُوَّة جَانِبٌ':Added, #1: 1	قُوَّةُ جَانِبٍ
u'قُوَّةٌ جَانِبٌ':Added, #1: 1	قُوَّةُ جَانِبٍ
u'قُوَّة جَانِبٌ':Added, #1: 1	قُوَّةُ جَانِبِهِ
u'قُوَّةٌ جَراءَة':Added, #1: 1	قُوَّةُ جَانِبِهِ
u'قُوَّة جَراءَة':Added, #1: 1	قُوَّةُ جَرَاءَةٍ
u'قُوَّةٌ جُزْءٌ':Added, #1: 1	قُوَّةُ جَرَاءَةٍ
u'قُوَّة جُزْءٌ':Added, #1: 1	قُوَّةَ الْجُزْءِ
u'قُوَّةٌ جُزْئِيٌّ':Added, #1: 1	قُوَّةَ الْجُزْءِ
u'قُوَّة جُزْئِيٌّ':Added, #2: 2	قُوَّةِ الْجُزْئِيَّةِ
u'قُوَّةٌ جُزْئِيَّةٌ':Added, #2: 2	قُوَّةِ الْجُزْئِيَّةِ
u'قُوَّة جُزْئِيَّةٌ':Added, #2: 2	قُوَّةِ الْجُزْئِيَّةِ
u'قُوَّةٌ جماع':Added, #2: 2	قُوَّةِ الْجُزْئِيَّةِ
u'قُوَّة جماع':Added, #2: 2	قُوَّةِ الْجِمَاعِ
u'قُوَّةٌ جِمَاعٌ':Added, #2: 2	قُوَّةِ الْجِمَاعِ
u'قُوَّة جِمَاعٌ':Added, #2: 2	قُوَّةِ الْجِمَاعِ
u'قُوَّةٌ جماع':Added, #2: 2	قُوَّةِ الْجِمَاعِ
u'قُوَّة جماع':Added, #3: 3	قُوَّةُ الْجِمَاعِ
u'قُوَّةٌ جِمَاعٌ':Added, #3: 3	قُوَّةُ الْجِمَاعِ
u'قُوَّة جِمَاعٌ':Added, #3: 3	قُوَّةُ الْجِمَاعِ
u'قُوَّةٌ جمع':Added, #3: 3	قُوَّةُ الْجِمَاعِ
u'قُوَّة جمع':Added, #1: 1	قُوَّةِ الْجَمْعِ
u'قُوَّةٌ جَمْعٌ':Added, #1: 1	قُوَّةِ الْجَمْعِ
u'قُوَّة جَمْعٌ':Added, #1: 1	قُوَّةِ الْجَمْعِ
u'قُوَّةٌ جُمَلٌ':Added, #1: 1	قُوَّةِ الْجَمْعِ
u'قُوَّة جُمَلٌ':Added, #1: 1	قُوَّةِ جُمَلٍ
u'قُوَّةٌ جِنٌّ':Added, #1: 1	قُوَّةِ جُمَلٍ
u'قُوَّة جِنٌّ':Added, #1: 1	قُوَّةِ الْجِنِّ
u'قُوَّةٌ حَدٌّ':Added, #1: 1	قُوَّةِ الْجِنِّ
u'قُوَّة حَدٌّ':Added, #1: 1	قُوَّةِ حَدَّيْنِ
u'قُوَّةٌ حَديثٌ':Added, #1: 1	قُوَّةِ حَدَّيْنِ
u'قُوَّة حَديثٌ':Added, #1: 1	قُوَّةِ الْحَدِيثِ
u'قُوَّةٌ حَديثٌ':Added, #1: 1	قُوَّةِ الْحَدِيثِ
u'قُوَّة حَديثٌ':Added, #1: 1	قُوَّةَ حَدِيثِ
u'قُوَّةٌ حُرْمَةٌ':Added, #1: 1	قُوَّةَ حَدِيثِ
u'قُوَّةٌ حُرْمَةٌ':Added, #1: 1	قُوَّةَ الْحُرْمَةِ
u'قُوَّة حُرْمَةٌ':Added, #1: 1	قُوَّةِ الْحُرْمَةِ
u'قُوَّة حُرْمَةٌ':Added, #1: 1	قُوَّةَ الْحُرْمَةِ
u'قُوَّةٌ حِفْظٌ':Added, #1: 1	قُوَّةِ الْحُرْمَةِ
u'قُوَّة حِفْظٌ':Added, #1: 1	قُوَّةُ حِفْظِهِ
u'قُوَّةٌ حُكْم':Added, #1: 1	قُوَّةُ حِفْظِهِ
u'قُوَّة حُكْم':Added, #1: 1	قُوَّةٍ حُكْمِيَّةٍ
u'قُوَّةٌ حُكْمِيّ':Added, #1: 1	قُوَّةٍ حُكْمِيَّةٍ
u'قُوَّة حُكْمِيّ':Added, #1: 1	قُوَّةٍ حُكْمِيَّةٍ
u'قُوَّةٌ حَيَوَانٌ':Added, #1: 1	قُوَّةٍ حُكْمِيَّةٍ
u'قُوَّة حَيَوَانٌ':Added, #1: 1	قُوَّةِ الْحَيَوَانِ
u'قُوَّةٌ خَاطِرٌ':Added, #1: 1	قُوَّةِ الْحَيَوَانِ
u'قُوَّة خَاطِرٌ':Added, #1: 1	قُوَّةِ خَاطِرِهِ
u'قُوَّةٌ خَبَّازٌ':Added, #1: 1	قُوَّةِ خَاطِرِهِ
u'قُوَّة خَبَّازٌ':Added, #1: 1	قُوَّةِ الْخَبَّازِ
u'قُوَّةٌ خَبَرٌ':Added, #1: 1	قُوَّةِ الْخَبَّازِ
u'قُوَّةٌ خَبَر':Added, #1: 1	قُوَّةِ الْخَبَرِ
u'قُوَّة خَبَرٌ':Added, #1: 1	قُوَّةِ الْخَبَرِ
u'قُوَّة خَبَر':Added, #1: 1	قُوَّةِ الْخَبَرِ
u'قُوَّةٌ خَبَرٌ':Added, #1: 1	قُوَّةِ الْخَبَرِ
u'قُوَّةٌ خَبَر':Added, #1: 1	قُوَّةِ خَبَرَيْنِ
u'قُوَّة خَبَرٌ':Added, #1: 1	قُوَّةِ خَبَرَيْنِ
u'قُوَّة خَبَر':Added, #1: 1	قُوَّةِ خَبَرَيْنِ
u'قُوَّةٌ خَتْمٌ':Added, #1: 1	قُوَّةِ خَبَرَيْنِ
u'قُوَّة خَتْمٌ':Added, #1: 1	قُوَّةِ الْخَتْمِ
u'قُوَّةٌ خَطَأٌ':Added, #1: 1	قُوَّةِ الْخَتْمِ
u'قُوَّة خَطَأٌ':Added, #1: 1	قُوَّةِ الْخَطَأِ
u'قُوَّةٌ خِلاَفٌ':Added, #1: 1	قُوَّةِ الْخَطَأِ
u'قُوَّة خِلاَفٌ':Added, #1: 1	قُوَّةَ الْخِلَافِ
u'قُوَّةٌ خِلاَفٌ':Added, #1: 1	قُوَّةَ الْخِلَافِ
u'قُوَّة خِلاَفٌ':Added, #7: 7	قُوَّةِ الْخِلَافِ
u'قُوَّةٌ خَوْفٌ':Added, #7: 7	قُوَّةِ الْخِلَافِ
u'قُوَّة خَوْفٌ':Added, #1: 1	قُوَّةُ خَوْفِ
u'قُوَّةٌ دَابَّةٌ':Added, #1: 1	قُوَّةُ خَوْفِ
u'قُوَّة دَابَّةٌ':Added, #1: 1	قُوَّةِ الدَّابَّةِ
u'قُوَّةٌ دَاخِلٌ':Added, #1: 1	قُوَّةِ الدَّابَّةِ
u'قُوَّة دَاخِلٌ':Added, #2: 2	قُوَّةِ الدَّاخِلِ
u'قُوَّةٌ دَافِعٌ':Added, #2: 2	قُوَّةِ الدَّاخِلِ
u'قُوَّة دَافِعٌ':Added, #1: 1	قُوَّةُ الدَّافِعِ
u'قُوَّةٌ دفع':Added, #1: 1	قُوَّةُ الدَّافِعِ
u'قُوَّة دفع':Added, #1: 1	قُوَّةِ دَفْعِهِ
u'قُوَّةٌ دَفْعٌ':Added, #1: 1	قُوَّةِ دَفْعِهِ
u'قُوَّة دَفْعٌ':Added, #1: 1	قُوَّةِ دَفْعِهِ
u'قُوَّةٌ دفع':Added, #1: 1	قُوَّةِ دَفْعِهِ
u'قُوَّة دفع':Added, #3: 3	قُوَّةُ الدَّفْعِ
u'قُوَّةٌ دَفْعٌ':Added, #3: 3	قُوَّةُ الدَّفْعِ
u'قُوَّة دَفْعٌ':Added, #3: 3	قُوَّةُ الدَّفْعِ
u'قُوَّةٌ دَلالَةٌ':Added, #3: 3	قُوَّةُ الدَّفْعِ
u'قُوَّة دَلالَةٌ':Added, #1: 1	قُوَّةَ الدَّلَالَةِ
u'قُوَّةٌ دَلالَةٌ':Added, #1: 1	قُوَّةَ الدَّلَالَةِ
u'قُوَّة دَلالَةٌ':Added, #1: 1	قُوَّةَ دَلَالَتِهِ
u'قُوَّةٌ دَلالَةٌ':Added, #1: 1	قُوَّةَ دَلَالَتِهِ
u'قُوَّة دَلالَةٌ':Added, #2: 2	قُوَّةَ دَلَالَةٍ
u'قُوَّةٌ دَلالَةٌ':Added, #2: 2	قُوَّةَ دَلَالَةٍ
u'قُوَّة دَلالَةٌ':Added, #5: 5	قُوَّةِ الدَّلَالَةِ
u'قُوَّةٌ دَليلٌ':Added, #5: 5	قُوَّةِ الدَّلَالَةِ
u'قُوَّة دَليلٌ':Added, #1: 1	قُوَّةِ دَلِيلِ
u'قُوَّةٌ دَليلٌ':Added, #1: 1	قُوَّةِ دَلِيلِ
u'قُوَّةٌ دَليلٌ':Added, #2: 2	قُوَّةُ الدَّلِيلِ
u'قُوَّة دَليلٌ':Added, #2: 2	قُوَّةِ الدَّلِيلِ
u'قُوَّة دَليلٌ':Added, #2: 2	قُوَّةُ الدَّلِيلِ
u'قُوَّةٌ دَمٌ':Added, #2: 2	قُوَّةِ الدَّلِيلِ
u'قُوَّة دَمٌ':Added, #1: 1	قُوَّةِ دَمِ
u'قُوَّةٌ دَيْنٌ':Added, #1: 1	قُوَّةِ دَمِ
u'قُوَّة دَيْنٌ':Added, #2: 2	قُوَّةِ الدَّيْنِ
u'قُوَّةٌ ذَكاءٌ':Added, #2: 2	قُوَّةِ الدَّيْنِ
u'قُوَّة ذَكاءٌ':Added, #2: 2	قُوَّةِ الذَّكَاءِ
u'قُوَّةٌ ذِهْنٌ':Added, #2: 2	قُوَّةِ الذَّكَاءِ
u'قُوَّة ذِهْنٌ':Added, #1: 1	قُوَّةِ الذِّهْنِ
u'قُوَّةٌ رَأْيٌ':Added, #1: 1	قُوَّةِ الذِّهْنِ
u'قُوَّة رَأْيٌ':Added, #1: 1	قُوَّةَ الرَّأْيِ
u'قُوَّةٌ رَجُلٌ':Added, #1: 1	قُوَّةَ الرَّأْيِ
u'قُوَّة رَجُلٌ':Added, #1: 1	قُوَّةِ الرَّجُلِ
u'قُوَّةٌ رَجُلٌ':Added, #1: 1	قُوَّةِ الرَّجُلِ
u'قُوَّة رَجُلٌ':Added, #1: 1	قُوَّةُ الرَّجُلَيْنِ
u'قُوَّةٌ رَجُلٌ':Added, #1: 1	قُوَّةُ الرَّجُلَيْنِ
u'قُوَّة رَجُلٌ':Added, #2: 2	قُوَّةِ الرَّجُلَيْنِ
u'قُوَّةٌ رضاع':Added, #2: 2	قُوَّةِ الرَّجُلَيْنِ
u'قُوَّة رضاع':Added, #1: 1	قُوَّةُ رَضَاعِهِ
u'قُوَّةٌ رَعْيٌ':Added, #1: 1	قُوَّةُ رَضَاعِهِ
u'قُوَّة رَعْيٌ':Added, #1: 1	قُوَّةَ الرَّعْيِ
u'قُوَّةٌ رَغْبَةٌ':Added, #1: 1	قُوَّةَ الرَّعْيِ
u'قُوَّة رَغْبَةٌ':Added, #1: 1	قُوَّةِ الرَّغْبَةِ
u'قُوَّةٌ رَفْعٌ':Added, #1: 1	قُوَّةِ الرَّغْبَةِ
u'قُوَّة رَفْعٌ':Added, #1: 1	قُوَّةُ رَفْعِ
u'قُوَّةٌ رَمْيٌ':Added, #1: 1	قُوَّةُ رَفْعِ
u'قُوَّة رَمْيٌ':Added, #1: 1	قُوَّةِ الرَّمْيِ
u'قُوَّةٌ رِوايَةٌ':Added, #1: 1	قُوَّةِ الرَّمْيِ
u'قُوَّة رِوايَةٌ':Added, #1: 1	قُوَّةِ رِوَايَةِ
u'قُوَّةٌ سَبَبٌ':Added, #1: 1	قُوَّةِ رِوَايَةِ
u'قُوَّةٌ سَبَبٌ':Added, #1: 1	قُوَّةَ سَبَبِهِ
u'قُوَّة سَبَبٌ':Added, #1: 1	قُوَّةِ سَبَبِهِ
u'قُوَّة سَبَبٌ':Added, #1: 1	قُوَّةَ سَبَبِهِ
u'قُوَّةٌ سَبَبٌ':Added, #1: 1	قُوَّةِ سَبَبِهِ
u'قُوَّة سَبَبٌ':Added, #2: 2	قُوَّةُ السَّبَبِ
u'قُوَّةٌ سَبْقٌ':Added, #2: 2	قُوَّةُ السَّبَبِ
u'قُوَّة سَبْقٌ':Added, #1: 1	قُوَّةُ السَّبْقِ
u'قُوَّةٌ سَبْقٌ':Added, #1: 1	قُوَّةُ السَّبْقِ
u'قُوَّة سَبْقٌ':Added, #2: 2	قُوَّةَ السَّبْقِ
u'قُوَّةٌ سَرَيَانٌ':Added, #2: 2	قُوَّةَ السَّبْقِ
u'قُوَّة سَرَيَانٌ':Added, #1: 1	قُوَّةُ سَرَيَانٍ
u'قُوَّةٌ سُلْطَانٌ':Added, #1: 1	قُوَّةُ سَرَيَانٍ
u'قُوَّة سُلْطَانٌ':Added, #1: 1	قُوَّةِ السُّلْطَانِ
u'قُوَّةٌ سُلْطَانٌ':Added, #1: 1	قُوَّةِ السُّلْطَانِ
u'قُوَّة سُلْطَانٌ':Added, #1: 1	قُوَّةِ سُلْطَانٍ
u'قُوَّةٌ سُلْطَانٌ':Added, #1: 1	قُوَّةِ سُلْطَانٍ
u'قُوَّة سُلْطَانٌ':Added, #1: 1	قُوَّةَ سُلْطَانِهِ
u'قُوَّةٌ سَلْطَنَةٌ':Added, #1: 1	قُوَّةَ سُلْطَانِهِ
u'قُوَّة سَلْطَنَةٌ':Added, #1: 1	قُوَّةُ السَّلْطَنَةِ
u'قُوَّةٌ سُنَّةٌ':Added, #1: 1	قُوَّةُ السَّلْطَنَةِ
u'قُوَّة سُنَّةٌ':Added, #1: 1	قُوَّةِ السُّنَّةِ
u'قُوَّةٌ سَنَدٌ':Added, #1: 1	قُوَّةِ السُّنَّةِ
u'قُوَّة سَنَدٌ':Added, #1: 1	قُوَّةِ السَّنَدِ
u'قُوَّةٌ سَيْرٌ':Added, #1: 1	قُوَّةِ السَّنَدِ
u'قُوَّة سَيْرٌ':Added, #1: 1	قُوَّةِ السَّيْرِ
u'قُوَّةٌ سَيَلانٌ':Added, #1: 1	قُوَّةِ السَّيْرِ
u'قُوَّة سَيَلانٌ':Added, #4: 4	قُوَّةُ السَّيَلَانِ
u'قُوَّةٌ شَابٌّ':Added, #4: 4	قُوَّةُ السَّيَلَانِ
u'قُوَّة شَابٌّ':Added, #1: 1	قُوَّةِ الشَّابِّ
u'قُوَّةٌ شَبَهٌ':Added, #1: 1	قُوَّةِ الشَّابِّ
u'قُوَّة شَبَهٌ':Added, #1: 1	قُوَّةُ الشَّبَهِ
u'قُوَّةٌ شَبَهٌ':Added, #1: 1	قُوَّةُ الشَّبَهِ
u'قُوَّة شَبَهٌ':Added, #2: 2	قُوَّةَ شَبَهِهِ
u'قُوَّةٌ شُبْهَةٌ':Added, #2: 2	قُوَّةَ شَبَهِهِ
u'قُوَّة شُبْهَةٌ':Added, #1: 1	قُوَّةِ الشُّبْهَةِ
u'قُوَّةٌ شُبْهَةٌ':Added, #1: 1	قُوَّةِ الشُّبْهَةِ
u'قُوَّةٌ شُبْهَةٌ':Added, #2: 2	قُوَّةَ الشُّبْهَةِ
u'قُوَّة شُبْهَةٌ':Added, #2: 2	قُوَّةُ الشُّبْهَةِ
u'قُوَّة شُبْهَةٌ':Added, #2: 2	قُوَّةَ الشُّبْهَةِ
u'قُوَّةٌ شَرْعِيٌّ':Added, #2: 2	قُوَّةُ الشُّبْهَةِ
u'قُوَّة شَرْعِيٌّ':Added, #2: 2	قُوَّةٍ شَرْعِيَّةٍ
u'قُوَّةٌ شَهَوَاتٌ':Added, #2: 2	قُوَّةٍ شَرْعِيَّةٍ
u'قُوَّة شَهَوَاتٌ':Added, #1: 1	قُوَّةِ الشَّهَوَاتِ
u'قُوَّةٌ شَهْوَةٌ':Added, #1: 1	قُوَّةِ الشَّهَوَاتِ
u'قُوَّة شَهْوَةٌ':Added, #1: 1	قُوَّةَ الشَّهْوَةِ
u'قُوَّةٌ شَوْكَةٌ':Added, #1: 1	قُوَّةَ الشَّهْوَةِ
u'قُوَّة شَوْكَةٌ':Added, #1: 1	قُوَّةُ الشَّوْكَةِ
u'قُوَّةٌ صِبْغٌ':Added, #1: 1	قُوَّةُ الشَّوْكَةِ
u'قُوَّة صِبْغٌ':Added, #1: 1	قُوَّةُ الصِّبْغِ
u'قُوَّةٌ صَحِيحٌ':Added, #1: 1	قُوَّةُ الصِّبْغِ
u'قُوَّة صَحِيحٌ':Added, #1: 1	قُوَّةُ الصَّحِيحِ
u'قُوَّةٌ طَاعِمٌ':Added, #1: 1	قُوَّةُ الصَّحِيحِ
u'قُوَّة طَاعِمٌ':Added, #2: 2	قُوَّةَ الطَّاعِمِ
u'قُوَّةٌ طِبَاعٌ':Added, #2: 2	قُوَّةَ الطَّاعِمِ
u'قُوَّة طِبَاعٌ':Added, #2: 2	قُوَّةِ الطِّبَاعِ
u'قُوَّةٌ طَبْعٌ':Added, #2: 2	قُوَّةِ الطِّبَاعِ
u'قُوَّة طَبْعٌ':Added, #1: 1	قُوَّةِ الطَّبْعِ
u'قُوَّةٌ طَبِيعَةٌ':Added, #1: 1	قُوَّةِ الطَّبْعِ
u'قُوَّة طَبِيعَةٌ':Added, #1: 1	قُوَّةُ الطَّبِيعَةِ
u'قُوَّةٌ طعام':Added, #1: 1	قُوَّةُ الطَّبِيعَةِ
u'قُوَّة طعام':Added, #1: 1	قُوَّةِ الطَّعَامِ
u'قُوَّةٌ طَعَامٌ':Added, #1: 1	قُوَّةِ الطَّعَامِ
u'قُوَّة طَعَامٌ':Added, #1: 1	قُوَّةِ الطَّعَامِ
u'قُوَّةٌ طَيَرَانٌ':Added, #1: 1	قُوَّةِ الطَّعَامِ
u'قُوَّة طَيَرَانٌ':Added, #1: 1	قُوَّةَ الطَّيَرَانِ
u'قُوَّةٌ طِينٌ':Added, #1: 1	قُوَّةَ الطَّيَرَانِ
u'قُوَّة طِينٌ':Added, #1: 1	قُوَّةُ الطِّينِ
u'قُوَّةٌ ظالِمٌ':Added, #1: 1	قُوَّةُ الطِّينِ
u'قُوَّة ظالِمٌ':Added, #1: 1	قُوَّةِ الظَّالِمِ
u'قُوَّةٌ ظَنٌّ':Added, #1: 1	قُوَّةِ الظَّالِمِ
u'قُوَّة ظَنٌّ':Added, #2: 2	قُوَّةَ الظَّنِّ
u'قُوَّةٌ ظَنٌّ':Added, #2: 2	قُوَّةَ الظَّنِّ
u'قُوَّة ظَنٌّ':Added, #3: 3	قُوَّةِ الظَّنِّ
u'قُوَّةٌ ظُهورٌ':Added, #3: 3	قُوَّةِ الظَّنِّ
u'قُوَّة ظُهورٌ':Added, #1: 1	قُوَّةِ الظُّهُورِ
u'قُوَّةٌ عتق':Added, #1: 1	قُوَّةِ الظُّهُورِ
u'قُوَّة عتق':Added, #1: 1	قُوَّةُ الْعِتْقِ
u'قُوَّةٌ عِتْقٌ':Added, #1: 1	قُوَّةُ الْعِتْقِ
u'قُوَّة عِتْقٌ':Added, #1: 1	قُوَّةُ الْعِتْقِ
u'قُوَّةٌ عَدَاوَةٌ':Added, #1: 1	قُوَّةُ الْعِتْقِ
u'قُوَّة عَدَاوَةٌ':Added, #1: 1	قُوَّةِ الْعَدَاوَةِ
u'قُوَّةٌ عَقْلٌ':Added, #1: 1	قُوَّةِ الْعَدَاوَةِ
u'قُوَّة عَقْلٌ':Added, #1: 1	قُوَّةِ الْعَقْلِ
u'قُوَّةٌ عَقْلٌ':Added, #1: 1	قُوَّةِ الْعَقْلِ
u'قُوَّة عَقْلٌ':Added, #1: 1	قُوَّةُ عَقْلِهِ
u'قُوَّةٌ عِلَّةٌ':Added, #1: 1	قُوَّةُ عَقْلِهِ
u'قُوَّة عِلَّةٌ':Added, #1: 1	قُوَّةَ الْعِلَّةِ
u'قُوَّةٌ غِذَاءٌ':Added, #1: 1	قُوَّةَ الْعِلَّةِ
u'قُوَّة غِذَاءٌ':Added, #1: 1	قُوَّةِ الْغِذَاءِ
u'قُوَّةٌ غضب':Added, #1: 1	قُوَّةِ الْغِذَاءِ
u'قُوَّة غضب':Added, #2: 2	قُوَّةَ الْغَضَبِ
u'قُوَّةٌ غَضَبٌ':Added, #2: 2	قُوَّةَ الْغَضَبِ
u'قُوَّة غَضَبٌ':Added, #2: 2	قُوَّةَ الْغَضَبِ
u'قُوَّةٌ غَيْرَةٌ':Added, #2: 2	قُوَّةَ الْغَضَبِ
u'قُوَّة غَيْرَةٌ':Added, #1: 1	قُوَّةُ غَيْرَةِ
u'قُوَّةٌ فَرَائِضُ':Added, #1: 1	قُوَّةُ غَيْرَةِ
u'قُوَّة فَرَائِضُ':Added, #1: 1	قُوَّةِ الْفَرَائِضِ
u'قُوَّةٌ فَرْضٌ':Added, #1: 1	قُوَّةِ الْفَرَائِضِ
u'قُوَّة فَرْضٌ':Added, #2: 2	قُوَّةِ الْفَرْضِ
u'قُوَّةٌ قَابِضٌ':Added, #2: 2	قُوَّةِ الْفَرْضِ
u'قُوَّة قَابِضٌ':Added, #1: 1	قُوَّةٍ قَابِضَةٍ
u'قُوَّةٌ قَامَةٌ':Added, #1: 1	قُوَّةٍ قَابِضَةٍ
u'قُوَّة قَامَةٌ':Added, #1: 1	قُوَّةِ قَامَةٍ
u'قُوَّةٌ قتال':Added, #1: 1	قُوَّةِ قَامَةٍ
u'قُوَّة قتال':Added, #2: 2	قُوَّةُ الْقِتَالِ
u'قُوَّةٌ قِتَالٌ':Added, #2: 2	قُوَّةُ الْقِتَالِ
u'قُوَّة قِتَالٌ':Added, #2: 2	قُوَّةُ الْقِتَالِ
u'قُوَّةٌ قَرَابَةٌ':Added, #2: 2	قُوَّةُ الْقِتَالِ
u'قُوَّةٌ قَرَابَةٌ':Added, #1: 1	قُوَّةُ الْقَرَابَةِ
u'قُوَّة قَرَابَةٌ':Added, #1: 1	قُوَّةِ الْقَرَابَةِ
u'قُوَّة قَرَابَةٌ':Added, #1: 1	قُوَّةُ الْقَرَابَةِ
u'قُوَّةٌ قرائن':Added, #1: 1	قُوَّةِ الْقَرَابَةِ
u'قُوَّة قرائن':Added, #1: 1	قُوَّةِ الْقَرَائِنِ
u'قُوَّةٌ قَرِينٌ':Added, #1: 1	قُوَّةِ الْقَرَائِنِ
u'قُوَّةٌ قَرِينٌ':Added, #1: 1	قُوَّةُ الْقَرِينَةِ
u'قُوَّة قَرِينٌ':Added, #1: 1	قُوَّةِ الْقَرِينَةِ
u'قُوَّة قَرِينٌ':Added, #1: 1	قُوَّةُ الْقَرِينَةِ
u'قُوَّةٌ قَصْدٌ':Added, #1: 1	قُوَّةِ الْقَرِينَةِ
u'قُوَّة قَصْدٌ':Added, #1: 1	قُوَّةُ الْقَصْدِ
u'قُوَّةٌ قلب':Added, #1: 1	قُوَّةُ الْقَصْدِ
u'قُوَّة قلب':Added, #1: 1	قُوَّةِ الْقَلْبِ
u'قُوَّةٌ قَلْبٌ':Added, #1: 1	قُوَّةِ الْقَلْبِ
u'قُوَّةٌ قَلْب':Added, #1: 1	قُوَّةِ الْقَلْبِ
u'قُوَّة قَلْبٌ':Added, #1: 1	قُوَّةِ الْقَلْبِ
u'قُوَّة قَلْب':Added, #1: 1	قُوَّةِ الْقَلْبِ
u'قُوَّةٌ قول':Added, #1: 1	قُوَّةِ الْقَلْبِ
u'قُوَّة قول':Added, #1: 1	قُوَّةِ الْقَوْلِ
u'قُوَّةٌ قَوْلٌ':Added, #1: 1	قُوَّةِ الْقَوْلِ
u'قُوَّة قَوْلٌ':Added, #1: 1	قُوَّةِ الْقَوْلِ
u'قُوَّةٌ قول':Added, #1: 1	قُوَّةِ الْقَوْلِ
u'قُوَّة قول':Added, #3: 3	قُوَّةِ قَوْلِهِ
u'قُوَّةٌ قَوْلٌ':Added, #3: 3	قُوَّةِ قَوْلِهِ
u'قُوَّة قَوْلٌ':Added, #3: 3	قُوَّةِ قَوْلِهِ
u'قُوَّةٌ كفر':Added, #3: 3	قُوَّةِ قَوْلِهِ
u'قُوَّة كفر':Added, #1: 1	قُوَّةِ الْكُفْرِ
u'قُوَّةٌ كُفْرٌ':Added, #1: 1	قُوَّةِ الْكُفْرِ
u'قُوَّة كُفْرٌ':Added, #1: 1	قُوَّةِ الْكُفْرِ
u'قُوَّةٌ كَلاَمٌ':Added, #1: 1	قُوَّةِ الْكُفْرِ
u'قُوَّة كَلاَمٌ':Added, #1: 1	قُوَّةَ كَلَامٍ
u'قُوَّةٌ كَلاَمٌ':Added, #1: 1	قُوَّةَ كَلَامٍ
u'قُوَّةٌ كَلاَمٌ':Added, #2: 2	قُوَّةُ الْكَلَامِ
u'قُوَّة كَلاَمٌ':Added, #2: 2	قُوَّةِ الْكَلَامِ
u'قُوَّة كَلاَمٌ':Added, #2: 2	قُوَّةُ الْكَلَامِ
u'قُوَّةٌ كَلاَمٌ':Added, #2: 2	قُوَّةِ الْكَلَامِ
u'قُوَّة كَلاَمٌ':Added, #2: 2	قُوَّةَ كَلَامِ
u'قُوَّةٌ كَلاَمٌ':Added, #2: 2	قُوَّةَ كَلَامِ
u'قُوَّةٌ كَلاَمٌ':Added, #3: 3	قُوَّةُ كَلَامِ
u'قُوَّة كَلاَمٌ':Added, #3: 3	قُوَّةِ كَلَامِ
u'قُوَّة كَلاَمٌ':Added, #3: 3	قُوَّةُ كَلَامِ
u'قُوَّةٌ لَفْظٌ':Added, #3: 3	قُوَّةِ كَلَامِ
u'قُوَّة لَفْظٌ':Added, #1: 1	قُوَّةَ اللَّفْظِ
u'قُوَّةٌ لَفْظٌ':Added, #1: 1	قُوَّةَ اللَّفْظِ
u'قُوَّة لَفْظٌ':Added, #4: 4	قُوَّةِ اللَّفْظِ
u'قُوَّةٌ مَالِكٌ':Added, #4: 4	قُوَّةِ اللَّفْظِ
u'قُوَّة مَالِكٌ':Added, #1: 1	قُوَّةِ الْمَالِكِ
u'قُوَّةٌ مَالِكٌ':Added, #1: 1	قُوَّةِ الْمَالِكِ
u'قُوَّة مَالِكٌ':Added, #1: 1	قُوَّةِ مَالِكِ
u'قُوَّةٌ مالِك':Added, #1: 1	قُوَّةِ مَالِكِ
u'قُوَّة مالِك':Added, #5: 5	قُوَّةِ الْمَالِكِيَّةِ
u'قُوَّةٌ مالِكِيّ':Added, #5: 5	قُوَّةِ الْمَالِكِيَّةِ
u'قُوَّة مالِكِيّ':Added, #5: 5	قُوَّةِ الْمَالِكِيَّةِ
u'قُوَّةٌ مُتَأَخِّرٌ':Added, #5: 5	قُوَّةِ الْمَالِكِيَّةِ
u'قُوَّة مُتَأَخِّرٌ':Added, #2: 2	قُوَّةُ الْمُتَأَخِّرِ
u'قُوَّةٌ مُتَعَدِّدٌ':Added, #2: 2	قُوَّةُ الْمُتَأَخِّرِ
u'قُوَّة مُتَعَدِّدٌ':Added, #1: 1	قُوَّةِ الْمُتَعَدِّدِ
u'قُوَّةٌ مَتْنٌ':Added, #1: 1	قُوَّةِ الْمُتَعَدِّدِ
u'قُوَّة مَتْنٌ':Added, #1: 1	قُوَّةِ الْمَتْنِ
u'قُوَّةٌ مُتَوَاتِرٌ':Added, #1: 1	قُوَّةِ الْمَتْنِ
u'قُوَّة مُتَوَاتِرٌ':Added, #1: 1	قُوَّةِ الْمُتَوَاتِرِ
u'قُوَّةٌ مَحَبَّةٌ':Added, #1: 1	قُوَّةِ الْمُتَوَاتِرِ
u'قُوَّة مَحَبَّةٌ':Added, #1: 1	قُوَّةُ مَحَبَّةِ
u'قُوَّةٌ مَحْرَم':Added, #1: 1	قُوَّةُ مَحَبَّةِ
u'قُوَّة مَحْرَم':Added, #1: 1	قُوَّةُ الْمَحْرَمِيَّةِ
u'قُوَّةٌ مَحْرَمَة':Added, #1: 1	قُوَّةُ الْمَحْرَمِيَّةِ
u'قُوَّة مَحْرَمَة':Added, #1: 1	قُوَّةُ الْمَحْرَمِيَّةِ
u'قُوَّةٌ مُدْرَكٌ':Added, #1: 1	قُوَّةُ الْمَحْرَمِيَّةِ
u'قُوَّة مُدْرَكٌ':Added, #1: 1	قُوَّةِ الْمُدْرَكِ
u'قُوَّةٌ مَدْلُولٌ':Added, #1: 1	قُوَّةِ الْمُدْرَكِ
u'قُوَّة مَدْلُولٌ':Added, #1: 1	قُوَّةُ مَدْلُولِهِ
u'قُوَّةٌ مراسيل':Added, #1: 1	قُوَّةُ مَدْلُولِهِ
u'قُوَّة مراسيل':Added, #1: 1	قُوَّةِ مَرَاسِيلِ
u'قُوَّةٌ مَرَاسِيلُ':Added, #1: 1	قُوَّةِ مَرَاسِيلِ
u'قُوَّة مَرَاسِيلُ':Added, #1: 1	قُوَّةِ مَرَاسِيلِ
u'قُوَّةٌ مُسَبِّبٌ':Added, #1: 1	قُوَّةِ مَرَاسِيلِ
u'قُوَّة مُسَبِّبٌ':Added, #1: 1	قُوَّةَ الْمُسَبِّبِ
u'قُوَّةٌ مَشْيٌ':Added, #1: 1	قُوَّةَ الْمُسَبِّبِ
u'قُوَّةٌ مَشْيٌ':Added, #1: 1	قُوَّةُ الْمَشْيِ
u'قُوَّة مَشْيٌ':Added, #1: 1	قُوَّةِ الْمَشْيِ
u'قُوَّة مَشْيٌ':Added, #1: 1	قُوَّةُ الْمَشْيِ
u'قُوَّةٌ مَصْلَحَةٌ':Added, #1: 1	قُوَّةِ الْمَشْيِ
u'قُوَّة مَصْلَحَةٌ':Added, #1: 1	قُوَّةِ الْمَصْلَحَةِ
u'قُوَّةٌ مَعْرِفَةٌ':Added, #1: 1	قُوَّةِ الْمَصْلَحَةِ
u'قُوَّةٌ مَعْرِفَة':Added, #1: 1	قُوَّةَ مَعْرِفَةِ
u'قُوَّة مَعْرِفَةٌ':Added, #1: 1	قُوَّةَ مَعْرِفَةِ
u'قُوَّة مَعْرِفَة':Added, #1: 1	قُوَّةَ مَعْرِفَةِ
u'قُوَّةٌ مَعْرِفَةٌ':Added, #1: 1	قُوَّةَ مَعْرِفَةِ
u'قُوَّةٌ مَعْرِفَة':Added, #2: 2	قُوَّةِ الْمَعْرِفَةِ
u'قُوَّة مَعْرِفَةٌ':Added, #2: 2	قُوَّةِ الْمَعْرِفَةِ
u'قُوَّة مَعْرِفَة':Added, #2: 2	قُوَّةِ الْمَعْرِفَةِ
u'قُوَّةٌ مُكْتَسِبٌ':Added, #2: 2	قُوَّةِ الْمَعْرِفَةِ
u'قُوَّة مُكْتَسِبٌ':Added, #1: 1	قُوَّةٍ مُكْتَسِبٍ
u'قُوَّةٌ مَلْفُوظٌ':Added, #1: 1	قُوَّةٍ مُكْتَسِبٍ
u'قُوَّة مَلْفُوظٌ':Added, #2: 2	قُوَّةِ الْمَلْفُوظِ
u'قُوَّةٌ مِلْكٌ':Added, #2: 2	قُوَّةِ الْمَلْفُوظِ
u'قُوَّة مِلْكٌ':Added, #1: 1	قُوَّةَ الْمِلْكِ
u'قُوَّةٌ مُلْكٌ':Added, #1: 1	قُوَّةَ الْمِلْكِ
u'قُوَّة مُلْكٌ':Added, #1: 1	قُوَّةَ مُلْكِهِ
u'قُوَّةٌ مِلْكِيَّةٌ':Added, #1: 1	قُوَّةَ مُلْكِهِ
u'قُوَّة مِلْكِيَّةٌ':Added, #1: 1	قُوَّةِ الْمِلْكِيَّةِ
u'قُوَّةٌ مُمَانَعَةٌ':Added, #1: 1	قُوَّةِ الْمِلْكِيَّةِ
u'قُوَّة مُمَانَعَةٌ':Added, #1: 1	قُوَّةِ الْمُمَانَعَةِ
u'قُوَّةٌ مُمَيِّزٌ':Added, #1: 1	قُوَّةِ الْمُمَانَعَةِ
u'قُوَّة مُمَيِّزٌ':Added, #1: 1	قُوَّةٍ مُمَيِّزَةٍ
u'قُوَّةٌ مُنَاسَبَةٌ':Added, #1: 1	قُوَّةٍ مُمَيِّزَةٍ
u'قُوَّة مُنَاسَبَةٌ':Added, #1: 1	قُوَّةِ الْمُنَاسَبَةِ
u'قُوَّةٌ مُنَاظَرَةٌ':Added, #1: 1	قُوَّةِ الْمُنَاسَبَةِ
u'قُوَّة مُنَاظَرَةٌ':Added, #1: 1	قُوَّةِ الْمُنَاظَرَةِ
u'قُوَّةٌ مَنْطُوقٌ':Added, #1: 1	قُوَّةِ الْمُنَاظَرَةِ
u'قُوَّة مَنْطُوقٌ':Added, #1: 1	قُوَّةِ الْمَنْطُوقِ
u'قُوَّةٌ مُنْفَصِلٌ':Added, #1: 1	قُوَّةِ الْمَنْطُوقِ
u'قُوَّة مُنْفَصِلٌ':Added, #1: 1	قُوَّةِ الْمُنْفَصِلِ
u'قُوَّةٌ مِنَنٌ':Added, #1: 1	قُوَّةِ الْمُنْفَصِلِ
u'قُوَّة مِنَنٌ':Added, #1: 1	قُوَّةُ الْمِنَنِ
u'قُوَّةٌ مُهْمَلٌ':Added, #1: 1	قُوَّةُ الْمِنَنِ
u'قُوَّة مُهْمَلٌ':Added, #1: 1	قُوَّةُ الْمُهْمَلِ
u'قُوَّةٌ نَظَرٌ':Added, #1: 1	قُوَّةُ الْمُهْمَلِ
u'قُوَّة نَظَرٌ':Added, #1: 1	قُوَّةِ النَّظَرِ
u'قُوَّةٌ نَظَرٌ':Added, #1: 1	قُوَّةِ النَّظَرِ
u'قُوَّة نَظَرٌ':Added, #1: 1	قُوَّةِ نَظَرِ
u'قُوَّةٌ نَفْسٌ':Added, #1: 1	قُوَّةِ نَظَرِ
u'قُوَّة نَفْسٌ':Added, #1: 1	قُوَّةِ نَفْسِهِ
u'قُوَّةٌ نَفْسٌ':Added, #1: 1	قُوَّةِ نَفْسِهِ
u'قُوَّة نَفْسٌ':Added, #2: 2	قُوَّةِ النَّفْسِ
u'قُوَّةٌ نَفْيٌ':Added, #2: 2	قُوَّةِ النَّفْسِ
u'قُوَّة نَفْيٌ':Added, #1: 1	قُوَّةِ نَفْيِ
u'قُوَّةٌ هضم':Added, #1: 1	قُوَّةِ نَفْيِ
u'قُوَّة هضم':Added, #1: 1	قُوَّةَ الْهَضْمِ
u'قُوَّةٌ هَضْمٌ':Added, #1: 1	قُوَّةَ الْهَضْمِ
u'قُوَّة هَضْمٌ':Added, #1: 1	قُوَّةَ الْهَضْمِ
u'قُوَّةٌ وَاجِبٌ':Added, #1: 1	قُوَّةَ الْهَضْمِ
u'قُوَّة وَاجِبٌ':Added, #7: 7	قُوَّةِ الْوَاجِبِ
u'قُوَّةٌ وَجْهٌ':Added, #7: 7	قُوَّةِ الْوَاجِبِ
u'قُوَّة وَجْهٌ':Added, #1: 1	قُوَّةِ وَجْهِهِ
u'قُوَّةٌ وَحْشَةٌ':Added, #1: 1	قُوَّةِ وَجْهِهِ
u'قُوَّة وَحْشَةٌ':Added, #1: 1	قُوَّةَ الْوَحْشَةِ
u'قُوَّةٌ وَسَائِلُ':Added, #1: 1	قُوَّةَ الْوَحْشَةِ
u'قُوَّة وَسَائِلُ':Added, #1: 1	قُوَّةُ وَسَائِلِهِ
u'قُوَّةٌ وَصْفٌ':Added, #1: 1	قُوَّةُ وَسَائِلِهِ
u'قُوَّةٌ وَصْفٌ':Added, #1: 1	قُوَّةَ الْوَصْفِ
u'قُوَّة وَصْفٌ':Added, #1: 1	قُوَّةِ الْوَصْفِ
u'قُوَّة وَصْفٌ':Added, #1: 1	قُوَّةَ الْوَصْفِ
u'قُوَّةٌ وَقْتٌ':Added, #1: 1	قُوَّةِ الْوَصْفِ
u'قُوَّة وَقْتٌ':Added, #1: 1	قُوَّةِ الْوَقْتِ
u'قُوَّةٌ وِلاَيَةٌ':Added, #1: 1	قُوَّةِ الْوَقْتِ
u'قُوَّةٌ وِلاَيَةٌ':Added, #1: 1	قُوَّةُ وِلَايَةِ
u'قُوَّة وِلاَيَةٌ':Added, #1: 1	قُوَّةِ وِلَايَةِ
u'قُوَّة وِلاَيَةٌ':Added, #1: 1	قُوَّةُ وِلَايَةِ
u'قُوَّةٌ وَهْمٌ':Added, #1: 1	قُوَّةِ وِلَايَةِ
u'قُوَّة وَهْمٌ':Added, #1: 1	قُوَّةُ الْوَهْمِ
u'قُوَّةٌ يَدٌ':Added, #1: 1	قُوَّةُ الْوَهْمِ
u'قُوَّة يَدٌ':Added, #1: 1	قُوَّةِ الْيَدِ
u'قول أَبٌ':Added, #1: 1	قُوَّةِ الْيَدِ
u'قَوْلٌ أَبٌ':Added, #19: 19	قَوْلُ الْأَبِ
u'قول أَبٌ':Added, #19: 19	قَوْلُ الْأَبِ
u'قَوْلٌ أَبٌ':Added, #3: 3	قَوْلِ الْأَبِ
u'قول أَبٌ':Added, #3: 3	قَوْلِ الْأَبِ
u'قَوْلٌ أَبٌ':Added, #4: 4	قَوْلَ الْأَبِ
u'قول إبَاحَةٌ':Added, #4: 4	قَوْلَ الْأَبِ
u'قَوْلٌ إبَاحَةٌ':Added, #1: 1	قَوْلَ الْإِبَاحَةِ
u'قول إِبْطَالٌ':Added, #1: 1	قَوْلَ الْإِبَاحَةِ
u'قَوْلٌ إِبْطَالٌ':Added, #1: 1	قَوْلِ الْإِبْطَالِ
u'قول اِبْنٌ':Added, #1: 1	قَوْلِ الْإِبْطَالِ
u'قَوْلٌ اِبْنٌ':Added, #142: 142	قَوْلَ ابْنِ
u'قول اِبْنٌ':Added, #142: 142	قَوْلَ ابْنِ
u'قَوْلٌ اِبْنٌ':Added, #2: 2	قَوْلِ ابْنِهِ
u'قول اِبْنٌ':Added, #2: 2	قَوْلِ ابْنِهِ
u'قَوْلٌ اِبْنٌ':Added, #3: 3	قَوْل ابْنِ
u'قول اِبْنٌ':Added, #3: 3	قَوْل ابْنِ
u'قَوْلٌ اِبْنٌ':Added, #503: 503	قَوْلِ ابْنِ
u'قول اِبْنٌ':Added, #503: 503	قَوْلِ ابْنِ
u'قَوْلٌ اِبْنٌ':Added, #766: 766	قَوْلُ ابْنِ
u'قول إِجْبَارٌ':Added, #766: 766	قَوْلُ ابْنِ
u'قَوْلٌ إِجْبَارٌ':Added, #1: 1	قَوْلِ الْإِجْبَارِ
u'قول إِجْمَالٌ':Added, #1: 1	قَوْلِ الْإِجْبَارِ
u'قول إِجْمَالٌ':Added, #1: 1	قَوْلَ الْإِجْمَالِ
u'قَوْلٌ إِجْمَالٌ':Added, #1: 1	قَوْلِ الْإِجْمَالِ
u'قَوْلٌ إِجْمَالٌ':Added, #1: 1	قَوْلَ الْإِجْمَالِ
u'قول أَجِيرٌ':Added, #1: 1	قَوْلِ الْإِجْمَالِ
u'قَوْلٌ أَجِيرٌ':Added, #6: 6	قَوْلُ الْأَجِيرِ
u'قول أحَدٌ':Added, #6: 6	قَوْلُ الْأَجِيرِ
u'قَوْلٌ أحَدٌ':Added, #10: 10	قَوْلِ أَحَدٍ
u'قول أحَدٌ':Added, #10: 10	قَوْلِ أَحَدٍ
u'قول أحَدٌ':Added, #1: 1	قَوْلَ أَحَدِ
u'قَوْلٌ أحَدٌ':Added, #1: 1	قَوْلِ أَحَدِ
u'قَوْلٌ أحَدٌ':Added, #1: 1	قَوْلَ أَحَدِ
u'قول إِحْيَاءٌ':Added, #1: 1	قَوْلِ أَحَدِ
u'قَوْلٌ إِحْيَاءٌ':Added, #1: 1	قَوْلُ الْإِحْيَاءِ
u'قول أَخٌ':Added, #1: 1	قَوْلُ الْإِحْيَاءِ
u'قَوْلٌ أَخٌ':Added, #1: 1	قَوْلَ أَخٍ
u'قول أَخٌ':Added, #1: 1	قَوْلَ أَخٍ
u'قَوْلٌ أَخٌ':Added, #3: 3	قَوْلُ الْأَخِ
u'قول إِخْوَةٌ':Added, #3: 3	قَوْلُ الْأَخِ
u'قَوْلٌ إِخْوَةٌ':Added, #1: 1	قَوْلَ إخْوَةِ
u'قول أَخِيرٌ':Added, #1: 1	قَوْلَ إخْوَةِ
u'قَوْلٌ أَخِيرٌ':Added, #1: 1	قَوْلِ الْأَخِيرِ
u'قول أَخِيرٌ':Added, #1: 1	قَوْلِ الْأَخِيرِ
u'قَوْلٌ أَخِيرٌ':Added, #1: 1	قَوْلِ الْأَخِيرَيْنِ
u'قول أَدَاءٌ':Added, #1: 1	قَوْلِ الْأَخِيرَيْنِ
u'قَوْلٌ أَدَاءٌ':Added, #1: 1	قَوْلِ أَدَاءِ
u'قول إِرْشَادٌ':Added, #1: 1	قَوْلِ أَدَاءِ
u'قَوْلٌ إِرْشَادٌ':Added, #4: 4	قَوْلُ الْإِرْشَادِ
u'قول إِرْشَادٌ':Added, #4: 4	قَوْلُ الْإِرْشَادِ
u'قَوْلٌ إِرْشَادٌ':Added, #7: 7	قَوْلِ الْإِرْشَادِ
u'قول أُسْتَاذٌ':Added, #7: 7	قَوْلِ الْإِرْشَادِ
u'قَوْلٌ أُسْتَاذٌ':Added, #1: 1	قَوْلِ أُسْتَاذِهِ
u'قول أُسْتَاذٌ':Added, #1: 1	قَوْلِ أُسْتَاذِهِ
u'قَوْلٌ أُسْتَاذٌ':Added, #1: 1	قَوْلَ الْأُسْتَاذِ
u'قول أُسْتَاذٌ':Added, #1: 1	قَوْلَ الْأُسْتَاذِ
u'قَوْلٌ أُسْتَاذٌ':Added, #2: 2	قَوْلِ الْأُسْتَاذَيْنِ
u'قول أُسْتَاذٌ':Added, #2: 2	قَوْلِ الْأُسْتَاذَيْنِ
u'قَوْلٌ أُسْتَاذٌ':Added, #7: 7	قَوْلُ الْأُسْتَاذِ
u'قول أَسَدٌ':Added, #7: 7	قَوْلُ الْأُسْتَاذِ
u'قَوْلٌ أَسَدٌ':Added, #1: 1	قَوْلُ أَسَدٍ
u'قول إِسْعافٌ':Added, #1: 1	قَوْلُ أَسَدٍ
u'قَوْلٌ إِسْعافٌ':Added, #1: 1	قَوْلُ الْإِسْعَافِ
u'قول إِسْقاطٌ':Added, #1: 1	قَوْلُ الْإِسْعَافِ
u'قَوْلٌ إِسْقاطٌ':Added, #3: 3	قَوْلِ الْإِسْقَاطِ
u'قول إِسْكافٌ':Added, #3: 3	قَوْلِ الْإِسْقَاطِ
u'قَوْلٌ إِسْكافٌ':Added, #1: 1	قَوْلِ الْإِسْكَافِ
u'قول إِسْكافٌ':Added, #1: 1	قَوْلِ الْإِسْكَافِ
u'قَوْلٌ إِسْكافٌ':Added, #2: 2	قَوْلَ الْإِسْكَافِ
u'قول إِسْلامٌ':Added, #2: 2	قَوْلَ الْإِسْكَافِ
u'قَوْلٌ إِسْلامٌ':Added, #1: 1	قَوْلِ الْإِسْلَامِ
u'قول أسْوَد':Added, #1: 1	قَوْلِ الْإِسْلَامِ
u'قَوْلٌ أسْوَد':Added, #2: 2	قَوْلُ الأَسْوَدِ
u'قول أسْوَد':Added, #2: 2	قَوْلُ الأَسْوَدِ
u'قَوْلٌ أسْوَد':Added, #4: 4	قَوْلِ الأَسْوَدِ
u'قول أَسيرٌ':Added, #4: 4	قَوْلِ الأَسْوَدِ
u'قَوْلٌ أَسيرٌ':Added, #5: 5	قَوْلُ الْأَسِيرِ
u'قول إشاعَةٌ':Added, #5: 5	قَوْلُ الْأَسِيرِ
u'قَوْلٌ إشاعَةٌ':Added, #1: 1	قَوْلُ الْإِشَاعَةِ
u'قول اِشْتِراطٌ':Added, #1: 1	قَوْلُ الْإِشَاعَةِ
u'قَوْلٌ اِشْتِراطٌ':Added, #1: 1	قَوْلِ اشْتِرَاطِ
u'قول أَشْعَث':Added, #1: 1	قَوْلِ اشْتِرَاطِ
u'قَوْلٌ أَشْعَث':Added, #1: 1	قَوْلِ الأَشْعَثِ
u'قول أَصْحَابٌ':Added, #1: 1	قَوْلِ الأَشْعَثِ
u'قَوْلٌ أَصْحَابٌ':Added, #10: 10	قَوْلِ أَصْحَابِ
u'قول أَصْحَابٌ':Added, #10: 10	قَوْلِ أَصْحَابِ
u'قَوْلٌ أَصْحَابٌ':Added, #16: 16	قَوْلُ أَصْحَابِ
u'قول أَصْحَابٌ':Added, #16: 16	قَوْلُ أَصْحَابِ
u'قَوْلٌ أَصْحَابٌ':Added, #27: 27	قَوْلُ الْأَصْحَابِ
u'قول أَصْحَابٌ':Added, #27: 27	قَوْلُ الْأَصْحَابِ
u'قَوْلٌ أَصْحَابٌ':Added, #2: 2	قَوْلِ أَصْحَابِهِ
u'قول أَصْحَابٌ':Added, #2: 2	قَوْلِ أَصْحَابِهِ
u'قَوْلٌ أَصْحَابٌ':Added, #45: 45	قَوْلِ الْأَصْحَابِ
u'قول أَصْحَابٌ':Added, #45: 45	قَوْلِ الْأَصْحَابِ
u'قَوْلٌ أَصْحَابٌ':Added, #5: 5	قَوْلَ الْأَصْحَابِ
u'قول أصل':Added, #5: 5	قَوْلَ الْأَصْحَابِ
u'قول أًصْلٌ':Added, #1: 1	قَوْلِ أَصْلِ
u'قَوْلٌ أصل':Added, #1: 1	قَوْلِ أَصْلِ
u'قَوْلٌ أًصْلٌ':Added, #1: 1	قَوْلِ أَصْلِ
u'قول أصل':Added, #1: 1	قَوْلِ أَصْلِ
u'قول أًصْلٌ':Added, #25: 25	قَوْلُ الْأَصْلِ
u'قَوْلٌ أصل':Added, #25: 25	قَوْلُ الْأَصْلِ
u'قَوْلٌ أًصْلٌ':Added, #25: 25	قَوْلُ الْأَصْلِ
u'قول أصل':Added, #25: 25	قَوْلُ الْأَصْلِ
u'قول أًصْلٌ':Added, #43: 43	قَوْلِ الْأَصْلِ
u'قَوْلٌ أصل':Added, #43: 43	قَوْلِ الْأَصْلِ
u'قَوْلٌ أًصْلٌ':Added, #43: 43	قَوْلِ الْأَصْلِ
u'قول أصل':Added, #43: 43	قَوْلِ الْأَصْلِ
u'قول أًصْلٌ':Added, #4: 4	قَوْلَ أَصْلِهِ
u'قَوْلٌ أصل':Added, #4: 4	قَوْلَ أَصْلِهِ
u'قَوْلٌ أًصْلٌ':Added, #4: 4	قَوْلَ أَصْلِهِ
u'قول أصل':Added, #4: 4	قَوْلَ أَصْلِهِ
u'قول أًصْلٌ':Added, #5: 5	قَوْلُ أَصْلِ
u'قَوْلٌ أصل':Added, #5: 5	قَوْلُ أَصْلِ
u'قَوْلٌ أًصْلٌ':Added, #5: 5	قَوْلُ أَصْلِ
u'قول أصل':Added, #5: 5	قَوْلُ أَصْلِ
u'قول أًصْلٌ':Added, #65: 65	قَوْلُ أَصْلِهِ
u'قَوْلٌ أصل':Added, #65: 65	قَوْلُ أَصْلِهِ
u'قَوْلٌ أًصْلٌ':Added, #65: 65	قَوْلُ أَصْلِهِ
u'قول أصل':Added, #65: 65	قَوْلُ أَصْلِهِ
u'قول أًصْلٌ':Added, #81: 81	قَوْلِ أَصْلِهِ
u'قَوْلٌ أصل':Added, #81: 81	قَوْلِ أَصْلِهِ
u'قَوْلٌ أًصْلٌ':Added, #81: 81	قَوْلِ أَصْلِهِ
u'قول أصل':Added, #81: 81	قَوْلِ أَصْلِهِ
u'قول أًصْلٌ':Added, #9: 9	قَوْلَ الْأَصْلِ
u'قَوْلٌ أصل':Added, #9: 9	قَوْلَ الْأَصْلِ
u'قَوْلٌ أًصْلٌ':Added, #9: 9	قَوْلَ الْأَصْلِ
u'قول أَصَمّ':Added, #9: 9	قَوْلَ الْأَصْلِ
u'قَوْلٌ أَصَمّ':Added, #4: 4	قَوْلُ الْأَصَمِّ
u'قول أَصيلٌ':Added, #4: 4	قَوْلُ الْأَصَمِّ
u'قَوْلٌ أَصيلٌ':Added, #1: 1	قَوْلُ الْأَصِيلِ
u'قول أعْرَابِيٌّ':Added, #1: 1	قَوْلُ الْأَصِيلِ
u'قول أعْرَابِيٌّ':Added, #1: 1	قَوْلُ الأَعْرَابِيِّ
u'قَوْلٌ أعْرَابِيٌّ':Added, #1: 1	قَوْلُ الْأَعْرَابِيِّ
u'قَوْلٌ أعْرَابِيٌّ':Added, #1: 1	قَوْلُ الأَعْرَابِيِّ
u'قول أعْرَابِيٌّ':Added, #1: 1	قَوْلُ الْأَعْرَابِيِّ
u'قَوْلٌ أعْرَابِيٌّ':Added, #3: 3	قَوْلِ الْأَعْرَابِيِّ
u'قول أعْلَمُ':Added, #3: 3	قَوْلِ الْأَعْرَابِيِّ
u'قَوْلٌ أعْلَمُ':Added, #2: 2	قَوْلِ الْأَعْلَمِ
u'قول أعْمَش':Added, #2: 2	قَوْلِ الْأَعْلَمِ
u'قول أعْمَش':Added, #1: 1	قَوْلَ الْأَعْمَشِ
u'قول أعْمَش':Added, #1: 1	قَوْلُ الْأَعْمَشِ
u'قَوْلٌ أعْمَش':Added, #1: 1	قَوْلِ الْأَعْمَشِ
u'قَوْلٌ أعْمَش':Added, #1: 1	قَوْلَ الْأَعْمَشِ
u'قَوْلٌ أعْمَش':Added, #1: 1	قَوْلُ الْأَعْمَشِ
u'قول أعْمَش':Added, #1: 1	قَوْلِ الْأَعْمَشِ
u'قَوْلٌ أعْمَش':Added, #2: 2	قَوْلِ الأَعْمَشِ
u'قول أقَلُّ':Added, #2: 2	قَوْلِ الأَعْمَشِ
u'قول أقَلُّ':Added, #1: 1	قَوْلُ الْأَقَلِّ
u'قَوْلٌ أقَلُّ':Added, #1: 1	قَوْلِ الْأَقَلِّ
u'قَوْلٌ أقَلُّ':Added, #1: 1	قَوْلُ الْأَقَلِّ
u'قول أَكْثَرُ':Added, #1: 1	قَوْلِ الْأَقَلِّ
u'قَوْلٌ أَكْثَرُ':Added, #18: 18	قَوْلِ أَكْثَرِ
u'قول أَكْثَرُ':Added, #18: 18	قَوْلِ أَكْثَرِ
u'قَوْلٌ أَكْثَرُ':Added, #1: 1	قَوْل أَكْثَرِ
u'قول أَكْثَرُ':Added, #1: 1	قَوْل أَكْثَرِ
u'قَوْلٌ أَكْثَرُ':Added, #26: 26	قَوْلِ الْأَكْثَرِ
u'قول أَكْثَرُ':Added, #26: 26	قَوْلِ الْأَكْثَرِ
u'قَوْلٌ أَكْثَرُ':Added, #2: 2	قَوْلَ الْأَكْثَرِ
u'قول أَكْثَرُ':Added, #2: 2	قَوْلَ الْأَكْثَرِ
u'قَوْلٌ أَكْثَرُ':Added, #32: 32	قَوْلُ الْأَكْثَرِ
u'قول أَكْثَرُ':Added, #32: 32	قَوْلُ الْأَكْثَرِ
u'قَوْلٌ أَكْثَرُ':Added, #3: 3	قَوْلُ الأَكْثَرِ
u'قول أَكْثَرُ':Added, #3: 3	قَوْلُ الأَكْثَرِ
u'قَوْلٌ أَكْثَرُ':Added, #6: 6	قَوْلَ أَكْثَرِ
u'قول أَكْثَرُ':Added, #6: 6	قَوْلَ أَكْثَرِ
u'قَوْلٌ أَكْثَرُ':Added, #99: 99	قَوْلُ أَكْثَرِ
u'قول إكْرَاهٌ':Added, #99: 99	قَوْلُ أَكْثَرِ
u'قَوْلٌ إكْرَاهٌ':Added, #1: 1	قَوْلِ الْإِكْرَاهِ
u'قول أَكْمَلُ':Added, #1: 1	قَوْلِ الْإِكْرَاهِ
u'قَوْلٌ أَكْمَلُ':Added, #1: 1	قَوْلُ الْأَكْمَلِ
u'قول أَلْثَغ':Added, #1: 1	قَوْلُ الْأَكْمَلِ
u'قَوْلٌ أَلْثَغ':Added, #1: 1	قَوْلِ الْأَلْثَغِ
u'قول اللهُ':Added, #1: 1	قَوْلِ الْأَلْثَغِ
u'قَوْلٌ اللهُ':Added, #1: 1	قَوْلِ اللهِ
u'قول الْمَرْءُ':Added, #1: 1	قَوْلِ اللهِ
u'قَوْلٌ الْمَرْءُ':Added, #1: 1	قَوْلَ الْمَرْءِ
u'قول الْمَرْأَةُ':Added, #1: 1	قَوْلَ الْمَرْءِ
u'قَوْلٌ الْمَرْأَةُ':Added, #13: 13	قَوْلَ الْمَرْأَةِ
u'قول الْمَرْأَةُ':Added, #13: 13	قَوْلَ الْمَرْأَةِ
u'قَوْلٌ الْمَرْأَةُ':Added, #26: 26	قَوْلُ الْمَرْأَةِ
u'قول الْمَرْأَةُ':Added, #26: 26	قَوْلُ الْمَرْأَةِ
u'قَوْلٌ الْمَرْأَةُ':Added, #4: 4	قَوْلِ الْمَرْأَةِ
u'قول أُمٌّ':Added, #4: 4	قَوْلِ الْمَرْأَةِ
u'قَوْلٌ أُمٌّ':Added, #1: 1	قَوْلَ الْأُمِّ
u'قول أُمٌّ':Added, #1: 1	قَوْلَ الْأُمِّ
u'قَوْلٌ أُمٌّ':Added, #1: 1	قَوْلَ أُمِّ
u'قول أُمٌّ':Added, #1: 1	قَوْلَ أُمِّ
u'قَوْلٌ أُمٌّ':Added, #2: 2	قَوْلِ الْأُمِّ
u'قول أُمٌّ':Added, #2: 2	قَوْلِ الْأُمِّ
u'قول أُمٌّ':Added, #2: 2	قَوْلُ أُمِّ
u'قَوْلٌ أُمٌّ':Added, #2: 2	قَوْلِ أُمِّ
u'قَوْلٌ أُمٌّ':Added, #2: 2	قَوْلُ أُمِّ
u'قول أُمٌّ':Added, #2: 2	قَوْلِ أُمِّ
u'قَوْلٌ أُمٌّ':Added, #3: 3	قَوْلُ الْأُمِّ
u'قول إمَاتَةٌ':Added, #3: 3	قَوْلُ الْأُمِّ
u'قَوْلٌ إمَاتَةٌ':Added, #1: 1	قَوْلِ إِمَاتَةِ
u'قول إمَامٌ':Added, #1: 1	قَوْلِ إِمَاتَةِ
u'قَوْلٌ إمَامٌ':Added, #140: 140	قَوْلُ الْإِمَامِ
u'قول إمَامٌ':Added, #140: 140	قَوْلُ الْإِمَامِ
u'قَوْلٌ إمَامٌ':Added, #15: 15	قَوْلُ إمَامِ
u'قول إمَامٌ':Added, #15: 15	قَوْلُ إمَامِ
u'قَوْلٌ إمَامٌ':Added, #192: 192	قَوْلِ الْإِمَامِ
u'قول إمَامٌ':Added, #192: 192	قَوْلِ الْإِمَامِ
u'قَوْلٌ إمَامٌ':Added, #1: 1	قَوْل الْإِمَامِ
u'قول إمَامٌ':Added, #1: 1	قَوْل الْإِمَامِ
u'قَوْلٌ إمَامٌ':Added, #1: 1	قَوْلِ الْإِمَامَيْنِ
u'قول إمَامٌ':Added, #1: 1	قَوْلِ الْإِمَامَيْنِ
u'قَوْلٌ إمَامٌ':Added, #1: 1	قَوْلَ إمَامِهِ
u'قول إمَامٌ':Added, #1: 1	قَوْلَ إمَامِهِ
u'قَوْلٌ إمَامٌ':Added, #2: 2	قَوْلَ إمَامِ
u'قول إمَامٌ':Added, #2: 2	قَوْلَ إمَامِ
u'قول إمَامٌ':Added, #2: 2	قَوْلُ إمَامِهِ
u'قَوْلٌ إمَامٌ':Added, #2: 2	قَوْلِ إمَامِهِ
u'قَوْلٌ إمَامٌ':Added, #2: 2	قَوْلُ إمَامِهِ
u'قول إمَامٌ':Added, #2: 2	قَوْلِ إمَامِهِ
u'قَوْلٌ إمَامٌ':Added, #32: 32	قَوْلَ الْإِمَامِ
u'قول إمَامٌ':Added, #32: 32	قَوْلَ الْإِمَامِ
u'قَوْلٌ إمَامٌ':Added, #5: 5	قَوْلِ إمَامِ
u'قول أُمَّةٌ':Added, #5: 5	قَوْلِ إمَامِ
u'قَوْلٌ أُمَّةٌ':Added, #1: 1	قَوْلُ الْأُمَّةِ
u'قول أُمَّةٌ':Added, #1: 1	قَوْلُ الْأُمَّةِ
u'قَوْلٌ أُمَّةٌ':Added, #1: 1	قَوْلِ أُمَّتِهِ
u'قول أُمَّةٌ':Added, #1: 1	قَوْلِ أُمَّتِهِ
u'قَوْلٌ أُمَّةٌ':Added, #2: 2	قَوْلَ الْأُمَّةِ
u'قول أمَةٌ':Added, #2: 2	قَوْلَ الْأُمَّةِ
u'قَوْلٌ أمَةٌ':Added, #4: 4	قَوْلُ الْأَمَةِ
u'قول أمَةٌ':Added, #4: 4	قَوْلُ الْأَمَةِ
u'قَوْلٌ أمَةٌ':Added, #5: 5	قَوْلِ الْأَمَةِ
u'قول آمِرٌ':Added, #5: 5	قَوْلِ الْأَمَةِ
u'قَوْلٌ آمِرٌ':Added, #15: 15	قَوْلُ الْآمِرِ
u'قول آمِرٌ':Added, #15: 15	قَوْلُ الْآمِرِ
u'قول آمِرٌ':Added, #1: 1	قَوْلَ الْآمِرِ
u'قَوْلٌ آمِرٌ':Added, #1: 1	قَوْلِ الْآمِرِ
u'قَوْلٌ آمِرٌ':Added, #1: 1	قَوْلَ الْآمِرِ
u'قول اِمْرَأَةٌ':Added, #1: 1	قَوْلِ الْآمِرِ
u'قَوْلٌ اِمْرَأَةٌ':Added, #1: 1	قَوْلَ امْرَأَةِ
u'قول اِمْرَأَةٌ':Added, #1: 1	قَوْلَ امْرَأَةِ
u'قَوْلٌ اِمْرَأَةٌ':Added, #7: 7	قَوْلُ امْرَأَةٍ
u'قول أمناء':Added, #7: 7	قَوْلُ امْرَأَةٍ
u'قول أمناء':Added, #1: 1	قَوْلَ الْأُمَنَاءِ
u'قَوْلٌ أمناء':Added, #1: 1	قَوْلِ الْأُمَنَاءِ
u'قَوْلٌ أمناء':Added, #1: 1	قَوْلَ الْأُمَنَاءِ
u'قول أَميرٌ':Added, #1: 1	قَوْلِ الْأُمَنَاءِ
u'قَوْلٌ أَميرٌ':Added, #1: 1	قَوْلِ أَمِيرِ
u'قول أَمينٌ':Added, #1: 1	قَوْلِ أَمِيرِ
u'قَوْلٌ أَمينٌ':Added, #13: 13	قَوْلُ الْأَمِينِ
u'قول أَمينٌ':Added, #13: 13	قَوْلُ الْأَمِينِ
u'قَوْلٌ أَمينٌ':Added, #1: 1	قَوْلُ أَمِينِ
u'قول أنبياء':Added, #1: 1	قَوْلُ أَمِينِ
u'قول أنبياء':Added, #1: 1	قَوْلُ الْأَنْبِيَاءِ
u'قَوْلٌ أنبياء':Added, #1: 1	قَوْلِ الْأَنْبِيَاءِ
u'قَوْلٌ أنبياء':Added, #1: 1	قَوْلُ الْأَنْبِيَاءِ
u'قول إِنْسانٌ':Added, #1: 1	قَوْلِ الْأَنْبِيَاءِ
u'قول إِنْسانٌ':Added, #1: 1	قَوْلُ الإِنْسَانِ
u'قول إِنْسانٌ':Added, #1: 1	قَوْلَ الْإِنْسَانِ
u'قَوْلٌ إِنْسانٌ':Added, #1: 1	قَوْلِ الْإِنْسَانِ
u'قَوْلٌ إِنْسانٌ':Added, #1: 1	قَوْلُ الإِنْسَانِ
u'قَوْلٌ إِنْسانٌ':Added, #1: 1	قَوْلَ الْإِنْسَانِ
u'قول إِنْسانٌ':Added, #1: 1	قَوْلِ الْإِنْسَانِ
u'قَوْلٌ إِنْسانٌ':Added, #1: 1	قَوْلِ إنْسَانٍ
u'قول إِنْسانٌ':Added, #1: 1	قَوْلِ إنْسَانٍ
u'قَوْلٌ إِنْسانٌ':Added, #2: 2	قَوْلُ إنْسَانٍ
u'قول إِنْسانٌ':Added, #2: 2	قَوْلُ إنْسَانٍ
u'قَوْلٌ إِنْسانٌ':Added, #5: 5	قَوْلُ الْإِنْسَانِ
u'قول أنصار':Added, #5: 5	قَوْلُ الْإِنْسَانِ
u'قول أنصار':Added, #1: 1	قَوْلُ الْأَنْصَارِ
u'قول أَنْصارٌ':Added, #1: 1	قَوْلِ الْأَنْصَارِ
u'قول أَنْصارٌ':Added, #1: 1	قَوْلُ الْأَنْصَارِ
u'قول أَنْصَارٌ':Added, #1: 1	قَوْلِ الْأَنْصَارِ
u'قول أَنْصَارٌ':Added, #1: 1	قَوْلُ الْأَنْصَارِ
u'قَوْلٌ أنصار':Added, #1: 1	قَوْلِ الْأَنْصَارِ
u'قَوْلٌ أنصار':Added, #1: 1	قَوْلُ الْأَنْصَارِ
u'قَوْلٌ أَنْصارٌ':Added, #1: 1	قَوْلِ الْأَنْصَارِ
u'قَوْلٌ أَنْصارٌ':Added, #1: 1	قَوْلُ الْأَنْصَارِ
u'قَوْلٌ أَنْصَارٌ':Added, #1: 1	قَوْلِ الْأَنْصَارِ
u'قَوْلٌ أَنْصَارٌ':Added, #1: 1	قَوْلُ الْأَنْصَارِ
u'قول أَنْوَارٌ':Added, #1: 1	قَوْلِ الْأَنْصَارِ
u'قَوْلٌ أَنْوَارٌ':Added, #3: 3	قَوْلِ الْأَنْوَارِ
u'قول أَنْوَارٌ':Added, #3: 3	قَوْلِ الْأَنْوَارِ
u'قَوْلٌ أَنْوَارٌ':Added, #8: 8	قَوْلُ الْأَنْوَارِ
u'قول أهْلٌ':Added, #8: 8	قَوْلُ الْأَنْوَارِ
u'قَوْلٌ أهْلٌ':Added, #32: 32	قَوْلُ أَهْلِ
u'قول أهْلٌ':Added, #32: 32	قَوْلُ أَهْلِ
u'قَوْلٌ أهْلٌ':Added, #46: 46	قَوْلِ أَهْلِ
u'قول أهْلٌ':Added, #46: 46	قَوْلِ أَهْلِ
u'قَوْلٌ أهْلٌ':Added, #6: 6	قَوْلَ أَهْلِ
u'قول أَوَّلُ':Added, #6: 6	قَوْلَ أَهْلِ
u'قَوْلٌ أَوَّلُ':Added, #2: 2	قَوْلَ الْأَوَّلِ
u'قول أَوَّلُ':Added, #2: 2	قَوْلَ الْأَوَّلِ
u'قَوْلٌ أَوَّلُ':Added, #4: 4	قَوْلِ الْأَوَّلِ
u'قول أَوَّلُ':Added, #4: 4	قَوْلِ الْأَوَّلِ
u'قَوْلٌ أَوَّلُ':Added, #5: 5	قَوْلُ الْأَوَّلِ
u'قول أَوْلاَدٌ':Added, #5: 5	قَوْلُ الْأَوَّلِ
u'قَوْلٌ أَوْلاَدٌ':Added, #1: 1	قَوْلَ أَوْلَادِ
u'قول أئِمَّةٌ':Added, #1: 1	قَوْلَ أَوْلَادِ
u'قَوْلٌ أئِمَّةٌ':Added, #13: 13	قَوْلِ الْأَئِمَّةِ
u'قول أئِمَّةٌ':Added, #13: 13	قَوْلِ الْأَئِمَّةِ
u'قَوْلٌ أئِمَّةٌ':Added, #1: 1	قَوْلَ الْأَئِمَّةِ
u'قول أئِمَّةٌ':Added, #1: 1	قَوْلَ الْأَئِمَّةِ
u'قَوْلٌ أئِمَّةٌ':Added, #25: 25	قَوْلُ الْأَئِمَّةِ
u'قول أئِمَّةٌ':Added, #25: 25	قَوْلُ الْأَئِمَّةِ
u'قَوْلٌ أئِمَّةٌ':Added, #2: 2	قَوْلَ أَئِمَّةِ
u'قول أئِمَّةٌ':Added, #2: 2	قَوْلَ أَئِمَّةِ
u'قَوْلٌ أئِمَّةٌ':Added, #3: 3	قَوْلُ أَئِمَّةِ
u'قول أئِمَّةٌ':Added, #3: 3	قَوْلُ أَئِمَّةِ
u'قَوْلٌ أئِمَّةٌ':Added, #4: 4	قَوْلِ أَئِمَّةِ
u'قول إيمَانٌ':Added, #4: 4	قَوْلِ أَئِمَّةِ
u'قَوْلٌ إيمَانٌ':Added, #1: 1	قَوْلِ الْإِيمَانِ
u'قول إيمَانٌ':Added, #1: 1	قَوْلِ الْإِيمَانِ
u'قَوْلٌ إيمَانٌ':Added, #9: 9	قَوْلُ الْإِيمَانِ
u'قول بَاعِثٌ':Added, #9: 9	قَوْلُ الْإِيمَانِ
u'قَوْلٌ بَاعِثٌ':Added, #1: 1	قَوْلَ بَاعِثِ
u'قول بَاعِثٌ':Added, #1: 1	قَوْلَ بَاعِثِ
u'قَوْلٌ بَاعِثٌ':Added, #2: 2	قَوْلُ الْبَاعِثِ
u'قول بالِغٌ':Added, #2: 2	قَوْلُ الْبَاعِثِ
u'قول بالِغٌ':Added, #1: 1	قَوْلَ الْبَالِغِ
u'قَوْلٌ بالِغٌ':Added, #1: 1	قَوْلِ الْبَالِغِ
u'قَوْلٌ بالِغٌ':Added, #1: 1	قَوْلَ الْبَالِغِ
u'قول بَائِعٌ':Added, #1: 1	قَوْلِ الْبَالِغِ
u'قَوْلٌ بَائِعٌ':Added, #119: 119	قَوْلُ الْبَائِعِ
u'قول بَائِعٌ':Added, #119: 119	قَوْلُ الْبَائِعِ
u'قَوْلٌ بَائِعٌ':Added, #17: 17	قَوْلِ الْبَائِعِ
u'قول بَائِعٌ':Added, #17: 17	قَوْلِ الْبَائِعِ
u'قَوْلٌ بَائِعٌ':Added, #20: 20	قَوْلَ الْبَائِعِ
u'قول بَائِعٌ':Added, #20: 20	قَوْلَ الْبَائِعِ
u'قول بَائِعٌ':Added, #2: 2	قَوْلُ بَائِعٍ
u'قَوْلٌ بَائِعٌ':Added, #2: 2	قَوْلُ بَائِعِ
u'قَوْلٌ بَائِعٌ':Added, #2: 2	قَوْلُ بَائِعٍ
u'قول بَتِّيّ':Added, #2: 2	قَوْلُ بَائِعِ
u'قَوْلٌ بَتِّيّ':Added, #1: 1	قَوْلِ الْبَتِّيِّ
u'قول بُحْتُرِيّ':Added, #1: 1	قَوْلِ الْبَتِّيِّ
u'قَوْلٌ بُحْتُرِيّ':Added, #1: 1	قَوْلَ الْبُحْتُرِيِّ
u'قول بَحْرٌ':Added, #1: 1	قَوْلَ الْبُحْتُرِيِّ
u'قَوْلٌ بَحْرٌ':Added, #5: 5	قَوْلِ الْبَحْرِ
u'قول بُخَارِيٌّ':Added, #5: 5	قَوْلِ الْبَحْرِ
u'قول بُخَارِيٌّ':Added, #1: 1	قَوْلُ الْبُخَارِيِّ
u'قَوْلٌ بُخَارِيٌّ':Added, #1: 1	قَوْلِ الْبُخَارِيِّ
u'قَوْلٌ بُخَارِيٌّ':Added, #1: 1	قَوْلُ الْبُخَارِيِّ
u'قول بدائع':Added, #1: 1	قَوْلِ الْبُخَارِيِّ
u'قَوْلٌ بدائع':Added, #2: 2	قَوْلُ الْبَدَائِعِ
u'قول بدائع':Added, #2: 2	قَوْلُ الْبَدَائِعِ
u'قَوْلٌ بدائع':Added, #3: 3	قَوْلِ الْبَدَائِعِ
u'قول بدائع':Added, #3: 3	قَوْلِ الْبَدَائِعِ
u'قَوْلٌ بدائع':Added, #6: 6	قَوْلَ الْبَدَائِعِ
u'قول براءٌ':Added, #6: 6	قَوْلَ الْبَدَائِعِ
u'قول براءٌ':Added, #1: 1	قَوْلَ الْبَرَاءِ
u'قول بَراءٌ':Added, #1: 1	قَوْلِ الْبَرَاءِ
u'قول بَراءٌ':Added, #1: 1	قَوْلَ الْبَرَاءِ
u'قَوْلٌ براءٌ':Added, #1: 1	قَوْلِ الْبَرَاءِ
u'قَوْلٌ براءٌ':Added, #1: 1	قَوْلَ الْبَرَاءِ
u'قَوْلٌ بَراءٌ':Added, #1: 1	قَوْلِ الْبَرَاءِ
u'قَوْلٌ بَراءٌ':Added, #1: 1	قَوْلَ الْبَرَاءِ
u'قول براءٌ':Added, #1: 1	قَوْلِ الْبَرَاءِ
u'قول بَراءٌ':Added, #3: 3	قَوْلُ الْبَرَاءِ
u'قَوْلٌ براءٌ':Added, #3: 3	قَوْلُ الْبَرَاءِ
u'قَوْلٌ بَراءٌ':Added, #3: 3	قَوْلُ الْبَرَاءِ
u'قول بُرْهانٌ':Added, #3: 3	قَوْلُ الْبَرَاءِ
u'قول بُرْهَانٌ':Added, #1: 1	قَوْلَ الْبُرْهَانِ
u'قَوْلٌ بُرْهانٌ':Added, #1: 1	قَوْلَ الْبُرْهَانِ
u'قَوْلٌ بُرْهَانٌ':Added, #1: 1	قَوْلَ الْبُرْهَانِ
u'قول بَرِيَّةٌ':Added, #1: 1	قَوْلَ الْبُرْهَانِ
u'قَوْلٌ بَرِيَّةٌ':Added, #2: 2	قَوْلِ الْبَرِيَّةِ
u'قول بَزَّارٌ':Added, #2: 2	قَوْلِ الْبَرِيَّةِ
u'قَوْلٌ بَزَّارٌ':Added, #1: 1	قَوْلُ الْبَزَّارِ
u'قول بَزّاز':Added, #1: 1	قَوْلُ الْبَزَّارِ
u'قول بَزّاز':Added, #2: 2	قَوْلَ الْبَزَّازِيَّةِ
u'قَوْلٌ بَزّاز':Added, #2: 2	قَوْلِ الْبَزَّازِيَّةِ
u'قَوْلٌ بَزّاز':Added, #2: 2	قَوْلَ الْبَزَّازِيَّةِ
u'قول بَزّازَة':Added, #2: 2	قَوْلِ الْبَزَّازِيَّةِ
u'قول بَزّازَة':Added, #2: 2	قَوْلَ الْبَزَّازِيَّةِ
u'قَوْلٌ بَزّازَة':Added, #2: 2	قَوْلِ الْبَزَّازِيَّةِ
u'قَوْلٌ بَزّازَة':Added, #2: 2	قَوْلَ الْبَزَّازِيَّةِ
u'قول بَشَرٌ':Added, #2: 2	قَوْلِ الْبَزَّازِيَّةِ
u'قول بِشْرٌ':Added, #1: 1	قَوْلِ بَشَرٍ
u'قول بِشْرٌ':Added, #1: 1	قَوْلَ بِشْرٍ
u'قَوْلٌ بَشَرٌ':Added, #1: 1	قَوْلِ بِشْرِ
u'قَوْلٌ بِشْرٌ':Added, #1: 1	قَوْلِ بَشَرٍ
u'قَوْلٌ بِشْرٌ':Added, #1: 1	قَوْلَ بِشْرٍ
u'قول بَشَرٌ':Added, #1: 1	قَوْلِ بِشْرِ
u'قَوْلٌ بَشَرٌ':Added, #2: 2	قَوْلُ الْبَشَرِ
u'قول بِشْرٌ':Added, #2: 2	قَوْلُ الْبَشَرِ
u'قول بِشْرٌ':Added, #2: 2	قَوْلَ بِشْرِ
u'قَوْلٌ بِشْرٌ':Added, #2: 2	قَوْلِ بِشْرٍ
u'قَوْلٌ بِشْرٌ':Added, #2: 2	قَوْلَ بِشْرِ
u'قول بِشْرٌ':Added, #2: 2	قَوْلِ بِشْرٍ
u'قَوْلٌ بِشْرٌ':Added, #5: 5	قَوْلُ بِشْرٍ
u'قول بَعْضٌ':Added, #5: 5	قَوْلُ بِشْرٍ
u'قَوْلٌ بَعْضٌ':Added, #16: 16	قَوْلِ الْبَعْضِ
u'قول بَعْضٌ':Added, #16: 16	قَوْلِ الْبَعْضِ
u'قَوْلٌ بَعْضٌ':Added, #1: 1	قَوْلِ بَعْضٍ
u'قول بَعْضٌ':Added, #1: 1	قَوْلِ بَعْضٍ
u'قَوْلٌ بَعْضٌ':Added, #21: 21	قَوْلُ الْبَعْضِ
u'قول بَعْضٌ':Added, #21: 21	قَوْلُ الْبَعْضِ
u'قَوْلٌ بَعْضٌ':Added, #22: 22	قَوْلَ بَعْضِ
u'قول بَعْضٌ':Added, #22: 22	قَوْلَ بَعْضِ
u'قَوْلٌ بَعْضٌ':Added, #3: 3	قَوْلَ الْبَعْضِ
u'قول بَعْضٌ':Added, #3: 3	قَوْلَ الْبَعْضِ
u'قَوْلٌ بَعْضٌ':Added, #78: 78	قَوْلِ بَعْضِ
u'قول بَعْضٌ':Added, #78: 78	قَوْلِ بَعْضِ
u'قَوْلٌ بَعْضٌ':Added, #90: 90	قَوْلُ بَعْضِ
u'قول بِنْتٌ':Added, #90: 90	قَوْلُ بَعْضِ
u'قَوْلٌ بِنْتٌ':Added, #1: 1	قَوْلَ بِنْتِ
u'قول بَيَانٌ':Added, #1: 1	قَوْلَ بِنْتِ
u'قول بَيَانٌ':Added, #1: 1	قَوْلُ الْبَيَانِ
u'قَوْلٌ بَيَانٌ':Added, #1: 1	قَوْلِ الْبَيَانِ
u'قَوْلٌ بَيَانٌ':Added, #1: 1	قَوْلُ الْبَيَانِ
u'قول بَيْضاوِيّ':Added, #1: 1	قَوْلِ الْبَيَانِ
u'قول بَيْضاوِيّ':Added, #1: 1	قَوْلَ الْبَيْضَاوِيِّ
u'قَوْلٌ بَيْضاوِيّ':Added, #1: 1	قَوْلِ الْبَيْضَاوِيِّ
u'قَوْلٌ بَيْضاوِيّ':Added, #1: 1	قَوْلَ الْبَيْضَاوِيِّ
u'قول بَيْضاوِيّ':Added, #1: 1	قَوْلِ الْبَيْضَاوِيِّ
u'قَوْلٌ بَيْضاوِيّ':Added, #2: 2	قَوْلُ الْبَيْضَاوِيِّ
u'قول بَيْعٌ':Added, #2: 2	قَوْلُ الْبَيْضَاوِيِّ
u'قَوْلٌ بَيْعٌ':Added, #3: 3	قَوْلِ الْبَيْعِ
u'قول بَيِّن':Added, #3: 3	قَوْلِ الْبَيْعِ
u'قَوْلٌ بَيِّن':Added, #1: 1	قَوْلَ الْبَيِّنَتَيْنِ
u'قول بَيِّنَةٌ':Added, #1: 1	قَوْلَ الْبَيِّنَتَيْنِ
u'قَوْلٌ بَيِّنَةٌ':Added, #2: 2	قَوْلُ الْبَيِّنَةِ
u'قول تَابِعٌ':Added, #2: 2	قَوْلُ الْبَيِّنَةِ
u'قول تَابِعٌ':Added, #1: 1	قَوْلَ التّابِعِ
u'قَوْلٌ تَابِعٌ':Added, #1: 1	قَوْلَ التَّابِعِ
u'قَوْلٌ تَابِعٌ':Added, #1: 1	قَوْلَ التّابِعِ
u'قول تَابِعِيٌّ':Added, #1: 1	قَوْلَ التَّابِعِ
u'قَوْلٌ تَابِعِيٌّ':Added, #3: 3	قَوْلُ التَّابِعِيِّ
u'قول تَابِعِيٌّ':Added, #3: 3	قَوْلُ التَّابِعِيِّ
u'قَوْلٌ تَابِعِيٌّ':Added, #4: 4	قَوْلَ التَّابِعِيِّ
u'قول تَابِعِيٌّ':Added, #4: 4	قَوْلَ التَّابِعِيِّ
u'قَوْلٌ تَابِعِيٌّ':Added, #7: 7	قَوْلِ التَّابِعِيِّ
u'قول تَاجٌ':Added, #7: 7	قَوْلِ التَّابِعِيِّ
u'قَوْلٌ تَاجٌ':Added, #1: 1	قَوْلِ تَاجِ
u'قول تَاجٌ':Added, #1: 1	قَوْلِ تَاجِ
u'قول تَاجٌ':Added, #2: 2	قَوْلُ التَّاجِ
u'قَوْلٌ تَاجٌ':Added, #2: 2	قَوْلِ التَّاجِ
u'قَوْلٌ تَاجٌ':Added, #2: 2	قَوْلُ التَّاجِ
u'قول تَبْيِين':Added, #2: 2	قَوْلِ التَّاجِ
u'قَوْلٌ تَبْيِين':Added, #1: 1	قَوْلَ التَّبْيِينِ
u'قول تَبْيِين':Added, #1: 1	قَوْلَ التَّبْيِينِ
u'قَوْلٌ تَبْيِين':Added, #2: 2	قَوْلِ التَّبْيِينِ
u'قول تَتِمَّةٌ':Added, #2: 2	قَوْلِ التَّبْيِينِ
u'قَوْلٌ تَتِمَّةٌ':Added, #2: 2	قَوْلُ التَّتِمَّةِ
u'قول تَجْرِيدٌ':Added, #2: 2	قَوْلُ التَّتِمَّةِ
u'قَوْلٌ تَجْرِيدٌ':Added, #1: 1	قَوْلُ التَّجْرِيدِ
u'قول تَجْنِيس':Added, #1: 1	قَوْلُ التَّجْرِيدِ
u'قول تَجْنِيس':Added, #1: 1	قَوْلَ التَّجْنِيسِ
u'قَوْلٌ تَجْنِيس':Added, #1: 1	قَوْلِ التَّجْنِيسِ
u'قَوْلٌ تَجْنِيس':Added, #1: 1	قَوْلَ التَّجْنِيسِ
u'قول تَحْقِيقٌ':Added, #1: 1	قَوْلِ التَّجْنِيسِ
u'قَوْلٌ تَحْقِيقٌ':Added, #1: 1	قَوْلُ التَّحْقِيقِ
u'قول تَحْقِيقٌ':Added, #1: 1	قَوْلُ التَّحْقِيقِ
u'قَوْلٌ تَحْقِيقٌ':Added, #3: 3	قَوْلَ التَّحْقِيقِ
u'قول تَحْلِيلٌ':Added, #3: 3	قَوْلَ التَّحْقِيقِ
u'قَوْلٌ تَحْلِيلٌ':Added, #1: 1	قَوْلُ التَّحْلِيلِ
u'قول تَخْصِيصٌ':Added, #1: 1	قَوْلُ التَّحْلِيلِ
u'قَوْلٌ تَخْصِيصٌ':Added, #1: 1	قَوْلِ تَخْصِيصِ
u'قول تَخْيِيرٌ':Added, #1: 1	قَوْلِ تَخْصِيصِ
u'قَوْلٌ تَخْيِيرٌ':Added, #1: 1	قَوْلِ التَّخْيِيرِ
u'قول تَدْرِيبٌ':Added, #1: 1	قَوْلِ التَّخْيِيرِ
u'قَوْلٌ تَدْرِيبٌ':Added, #1: 1	قَوْلُ التَّدْرِيبِ
u'قول تَرَادُفٌ':Added, #1: 1	قَوْلُ التَّدْرِيبِ
u'قَوْلٌ تَرَادُفٌ':Added, #1: 1	قَوْلِ التَّرَادُفِ
u'قول تَرْتِيبٌ':Added, #1: 1	قَوْلِ التَّرَادُفِ
u'قَوْلٌ تَرْتِيبٌ':Added, #1: 1	قَوْلِ التَّرْتِيبِ
u'قول تَرْكٌ':Added, #1: 1	قَوْلِ التَّرْتِيبِ
u'قَوْلٌ تَرْكٌ':Added, #1: 1	قَوْلِ تَرْكِ
u'قول تَصْوِيبٌ':Added, #1: 1	قَوْلِ تَرْكِ
u'قَوْلٌ تَصْوِيبٌ':Added, #1: 1	قَوْلِ التَّصْوِيبِ
u'قول تَضْيِيقٌ':Added, #1: 1	قَوْلِ التَّصْوِيبِ
u'قَوْلٌ تَضْيِيقٌ':Added, #1: 1	قَوْلِ التَّضْيِيقِ
u'قول تَعْجِيل':Added, #1: 1	قَوْلِ التَّضْيِيقِ
u'قَوْلٌ تَعْجِيل':Added, #1: 1	قَوْلِ التَّعْجِيلِ
u'قول تَعَقُّبٌ':Added, #1: 1	قَوْلِ التَّعْجِيلِ
u'قَوْلٌ تَعَقُّبٌ':Added, #1: 1	قَوْلِ التَّعَقُّبَاتِ
u'قول تَعْلِيقٌ':Added, #1: 1	قَوْلِ التَّعَقُّبَاتِ
u'قَوْلٌ تَعْلِيقٌ':Added, #1: 1	قَوْلَ التَّعْلِيقِ
u'قول تَعْلِيقٌ':Added, #1: 1	قَوْلَ التَّعْلِيقِ
u'قَوْلٌ تَعْلِيقٌ':Added, #2: 2	قَوْلِ التَّعْلِيقِ
u'قول تَلْقِين':Added, #2: 2	قَوْلِ التَّعْلِيقِ
u'قول تَلْقِين':Added, #1: 1	قَوْلُ التَّلْقِينِ
u'قَوْلٌ تَلْقِين':Added, #1: 1	قَوْلِ التَّلْقِينِ
u'قَوْلٌ تَلْقِين':Added, #1: 1	قَوْلُ التَّلْقِينِ
u'قول تِلْميذٌ':Added, #1: 1	قَوْلِ التَّلْقِينِ
u'قَوْلٌ تِلْميذٌ':Added, #1: 1	قَوْلُ تِلْمِيذِهِ
u'قول تَمْلِيك':Added, #1: 1	قَوْلُ تِلْمِيذِهِ
u'قَوْلٌ تَمْلِيك':Added, #2: 2	قَوْلِ التَّمْلِيكِ
u'قول تَمِيمِيّ':Added, #2: 2	قَوْلِ التَّمْلِيكِ
u'قَوْلٌ تَمِيمِيّ':Added, #4: 4	قَوْلِ التَّمِيمِيِّ
u'قول تَنْبِيه':Added, #4: 4	قَوْلِ التَّمِيمِيِّ
u'قول تَنْبِيه':Added, #1: 1	قَوْلُ التَّنْبِيهِ
u'قَوْلٌ تَنْبِيه':Added, #1: 1	قَوْلِ التَّنْبِيهِ
u'قَوْلٌ تَنْبِيه':Added, #1: 1	قَوْلُ التَّنْبِيهِ
u'قول تَنْبِيه':Added, #1: 1	قَوْلِ التَّنْبِيهِ
u'قَوْلٌ تَنْبِيه':Added, #2: 2	قَوْلَ التَّنْبِيهِ
u'قول تَهْذِيبٌ':Added, #2: 2	قَوْلَ التَّنْبِيهِ
u'قَوْلٌ تَهْذِيبٌ':Added, #1: 1	قَوْلُ التَّهْذِيبِ
u'قول تَوَسُّط':Added, #1: 1	قَوْلُ التَّهْذِيبِ
u'قَوْلٌ تَوَسُّط':Added, #1: 1	قَوْلُ التَّوَسُّطِ
u'قول تَوْشِيحٌ':Added, #1: 1	قَوْلُ التَّوَسُّطِ
u'قَوْلٌ تَوْشِيحٌ':Added, #1: 1	قَوْلُ التَّوْشِيحِ
u'قول ثَابِتٌ':Added, #1: 1	قَوْلُ التَّوْشِيحِ
u'قَوْلٌ ثَابِتٌ':Added, #2: 2	قَوْلُ ثَابِتٍ
u'قَوْلٌ ثَالِثٌ':Added, #2: 2	قَوْلُ ثَابِتٍ
u'قول ثَالِثٌ':Added, #11: 11	قَوْلٍ ثَالِثٍ
u'قَوْلٌ ثَالِثٌ':Added, #1: 1	قَوْلِ الثَّالِثِ
u'قول ثَالِثٌ':Added, #1: 1	قَوْلِ الثَّالِثِ
u'قَوْلٌ ثَالِثٌ':Added, #2: 2	قَوْلُ الثَّالِثِ
u'قول ثَعْلَبٌ':Added, #2: 2	قَوْلُ الثَّالِثِ
u'قول ثَعْلَبٌ':Added, #1: 1	قَوْلَ ثَعْلَبٍ
u'قَوْلٌ ثَعْلَبٌ':Added, #1: 1	قَوْلُ ثَعْلَبٍ
u'قَوْلٌ ثَعْلَبٌ':Added, #1: 1	قَوْلَ ثَعْلَبٍ
u'قول ثِقَة':Added, #1: 1	قَوْلُ ثَعْلَبٍ
u'قول ثِقَة':Added, #1: 1	قَوْلَ الثِّقَاتِ
u'قَوْلٌ ثِقَة':Added, #1: 1	قَوْلِ الثِّقَاتِ
u'قَوْلٌ ثِقَة':Added, #1: 1	قَوْلَ الثِّقَاتِ
u'قول ثِقَةٌ':Added, #1: 1	قَوْلِ الثِّقَاتِ
u'قَوْلٌ ثِقَةٌ':Added, #1: 1	قَوْلِ الثِّقَةِ
u'قول ثِقَةٌ':Added, #1: 1	قَوْلِ الثِّقَةِ
u'قَوْلٌ ثِقَةٌ':Added, #2: 2	قَوْلُ الثِّقَةِ
u'قول ثَلاثَةٌ':Added, #2: 2	قَوْلُ الثِّقَةِ
u'قول ثَلاثَةٌ':Added, #1: 1	قَوْلَ ثَلَاثَةٍ
u'قَوْلٌ ثَلاثَةٌ':Added, #1: 1	قَوْلِ ثَلَاثَةٍ
u'قَوْلٌ ثَلاثَةٌ':Added, #1: 1	قَوْلَ ثَلَاثَةٍ
u'قول ثَلاثَةٌ':Added, #1: 1	قَوْلِ ثَلَاثَةٍ
u'قَوْلٌ ثَلاثَةٌ':Added, #3: 3	قَوْلُ الثَّلَاثَةِ
u'قول ثَلاثَةٌ':Added, #3: 3	قَوْلُ الثَّلَاثَةِ
u'قَوْلٌ ثَلاثَةٌ':Added, #3: 3	قَوْلُ ثَلَاثَةٍ
u'قول ثَوْرِيٌّ':Added, #3: 3	قَوْلُ ثَلَاثَةٍ
u'قول ثَوْرِيٌّ':Added, #1: 1	قَوْلَ الثَّوْرِيِّ
u'قَوْلٌ ثَوْرِيٌّ':Added, #1: 1	قَوْلِ الثَّوْرِيِّ
u'قَوْلٌ ثَوْرِيٌّ':Added, #1: 1	قَوْلَ الثَّوْرِيِّ
u'قول ثَوْرِيٌّ':Added, #1: 1	قَوْلِ الثَّوْرِيِّ
u'قَوْلٌ ثَوْرِيٌّ':Added, #2: 2	قَوْلُ الثَّوْرِيِّ
u'قول جَابِرٌ':Added, #2: 2	قَوْلُ الثَّوْرِيِّ
u'قول جَابِرٌ':Added, #1: 1	قَوْلَ جَابِرٍ
u'قَوْلٌ جَابِرٌ':Added, #1: 1	قَوْلُ جَابِرِ
u'قَوْلٌ جَابِرٌ':Added, #1: 1	قَوْلَ جَابِرٍ
u'قول جَابِرٌ':Added, #1: 1	قَوْلُ جَابِرِ
u'قَوْلٌ جَابِرٌ':Added, #4: 4	قَوْلِ جَابِرِ
u'قول جَابِرٌ':Added, #4: 4	قَوْلِ جَابِرِ
u'قَوْلٌ جَابِرٌ':Added, #5: 5	قَوْلِ جَابِرٍ
u'قول جَابِرٌ':Added, #5: 5	قَوْلِ جَابِرٍ
u'قَوْلٌ جَابِرٌ':Added, #6: 6	قَوْلُ جَابِرٍ
u'قول جَاحِدٌ':Added, #6: 6	قَوْلُ جَابِرٍ
u'قَوْلٌ جَاحِدٌ':Added, #1: 1	قَوْلُ الْجَاحِدِ
u'قول جَارِي':Added, #1: 1	قَوْلُ الْجَاحِدِ
u'قَوْلٌ جَارِي':Added, #1: 1	قَوْلَ الْجَارِيَةِ
u'قول جَارِيَةٌ':Added, #1: 1	قَوْلَ الْجَارِيَةِ
u'قَوْلٌ جَارِيَةٌ':Added, #1: 1	قَوْلَ الْجَارِيَةِ
u'قول جَاهِلٌ':Added, #1: 1	قَوْلَ الْجَارِيَةِ
u'قَوْلٌ جَاهِلٌ':Added, #1: 1	قَوْلِ الْجَاهِلِ
u'قول جَاهِلٌ':Added, #1: 1	قَوْلِ الْجَاهِلِ
u'قَوْلٌ جَاهِلٌ':Added, #1: 1	قَوْلُ جَاهِلٍ
u'قول جَائِزٌ':Added, #1: 1	قَوْلُ جَاهِلٍ
u'قَوْلٌ جَائِزٌ':Added, #1: 1	قَوْلَ الْجَائِزِ
u'قول جَرِيرٌ':Added, #1: 1	قَوْلَ الْجَائِزِ
u'قول جَرِيرٌ':Added, #1: 1	قَوْلَ جَرِيرٍ
u'قول جَرِيرٌ':Added, #1: 1	قَوْلَ جَرِيرِ
u'قَوْلٌ جَرِيرٌ':Added, #1: 1	قَوْلُ جَرِيرٍ
u'قَوْلٌ جَرِيرٌ':Added, #1: 1	قَوْلَ جَرِيرٍ
u'قَوْلٌ جَرِيرٌ':Added, #1: 1	قَوْلَ جَرِيرِ
u'قول جَصَّاصٌ':Added, #1: 1	قَوْلُ جَرِيرٍ
u'قَوْلٌ جَصَّاصٌ':Added, #1: 1	قَوْلُ الْجَصَّاصِ
u'قول جَصَّاصٌ':Added, #1: 1	قَوْلُ الْجَصَّاصِ
u'قَوْلٌ جَصَّاصٌ':Added, #3: 3	قَوْلِ الْجَصَّاصِ
u'قول جَلّاب':Added, #3: 3	قَوْلِ الْجَصَّاصِ
u'قَوْلٌ جَلّاب':Added, #1: 1	قَوْلُ الْجَلَّابِ
u'قول جَلاَلٌ':Added, #1: 1	قَوْلُ الْجَلَّابِ
u'قول جَلاَلٌ':Added, #3: 3	قَوْلُ الْجَلَالِ
u'قَوْلٌ جَلاَلٌ':Added, #3: 3	قَوْلِ الْجَلَالِ
u'قَوْلٌ جَلاَلٌ':Added, #3: 3	قَوْلُ الْجَلَالِ
u'قول جَمَاعَةٌ':Added, #3: 3	قَوْلِ الْجَلَالِ
u'قَوْلٌ جَمَاعَةٌ':Added, #19: 19	قَوْلُ جَمَاعَةٍ
u'قول جَمَاعَةٌ':Added, #19: 19	قَوْلُ جَمَاعَةٍ
u'قَوْلٌ جَمَاعَةٌ':Added, #1: 1	قَوْلِ الْجَمَاعَةِ
u'قول جَمَاعَةٌ':Added, #1: 1	قَوْلِ الْجَمَاعَةِ
u'قَوْلٌ جَمَاعَةٌ':Added, #1: 1	قَوْلُ جَمَاعَةِ
u'قول جَمَاعَةٌ':Added, #1: 1	قَوْلُ جَمَاعَةِ
u'قَوْلٌ جَمَاعَةٌ':Added, #2: 2	قَوْلِ جَمَاعَةٍ
u'قول جَمَاعَةٌ':Added, #2: 2	قَوْلِ جَمَاعَةٍ
u'قَوْلٌ جَمَاعَةٌ':Added, #5: 5	قَوْلُ الْجَمَاعَةِ
u'قول جَمَّالٌ':Added, #5: 5	قَوْلُ الْجَمَاعَةِ
u'قَوْلٌ جَمَّالٌ':Added, #2: 2	قَوْلُ الْجَمَّالِ
u'قول جَمَاهِيرُ':Added, #2: 2	قَوْلُ الْجَمَّالِ
u'قَوْلٌ جَمَاهِيرُ':Added, #1: 1	قَوْلُ الْجَمَاهِيرِ
u'قول جَمَاهِيرُ':Added, #1: 1	قَوْلُ الْجَمَاهِيرِ
u'قَوْلٌ جَمَاهِيرُ':Added, #3: 3	قَوْلُ جَمَاهِيرِ
u'قول جمع':Added, #3: 3	قَوْلُ جَمَاهِيرِ
u'قَوْلٌ جمع':Added, #2: 2	قَوْلِ الْجَمْعِ
u'قول جَمْعٌ':Added, #2: 2	قَوْلِ الْجَمْعِ
u'قَوْلٌ جَمْعٌ':Added, #2: 2	قَوْلِ الْجَمْعِ
u'قول جَمْعٌ':Added, #2: 2	قَوْلِ الْجَمْعِ
u'قول جَمْعٌ':Added, #3: 3	قَوْلَ جَمْعٍ
u'قَوْلٌ جَمْعٌ':Added, #3: 3	قَوْلِ جَمْعٍ
u'قَوْلٌ جَمْعٌ':Added, #3: 3	قَوْلَ جَمْعٍ
u'قول جَمْعٌ':Added, #3: 3	قَوْلِ جَمْعٍ
u'قَوْلٌ جَمْعٌ':Added, #4: 4	قَوْلُ جَمْعٍ
u'قول جُمْهُورٌ':Added, #4: 4	قَوْلُ جَمْعٍ
u'قَوْلٌ جُمْهُورٌ':Added, #11: 11	قَوْلِ جُمْهُورِ
u'قول جُمْهُورٌ':Added, #11: 11	قَوْلِ جُمْهُورِ
u'قَوْلٌ جُمْهُورٌ':Added, #19: 19	قَوْلِ الْجُمْهُورِ
u'قول جُمْهُورٌ':Added, #19: 19	قَوْلِ الْجُمْهُورِ
u'قَوْلٌ جُمْهُورٌ':Added, #3: 3	قَوْلَ جُمْهُورِ
u'قول جُمْهُورٌ':Added, #3: 3	قَوْلَ جُمْهُورِ
u'قَوْلٌ جُمْهُورٌ':Added, #49: 49	قَوْلُ جُمْهُورِ
u'قول جُمْهُورٌ':Added, #49: 49	قَوْلُ جُمْهُورِ
u'قَوْلٌ جُمْهُورٌ':Added, #4: 4	قَوْلَ الْجُمْهُورِ
u'قول جُمْهُورٌ':Added, #4: 4	قَوْلَ الْجُمْهُورِ
u'قَوْلٌ جُمْهُورٌ':Added, #73: 73	قَوْلُ الْجُمْهُورِ
u'قول جَمِيع':Added, #73: 73	قَوْلُ الْجُمْهُورِ
u'قول جَمِيع':Added, #1: 1	قَوْلَ الْجَمِيعِ
u'قول جَمِيع':Added, #1: 1	قَوْلُ الْجَمِيعِ
u'قَوْلٌ جَمِيع':Added, #1: 1	قَوْلِ الْجَمِيعِ
u'قَوْلٌ جَمِيع':Added, #1: 1	قَوْلَ الْجَمِيعِ
u'قَوْلٌ جَمِيع':Added, #1: 1	قَوْلُ الْجَمِيعِ
u'قول جِنٌّ':Added, #1: 1	قَوْلِ الْجَمِيعِ
u'قَوْلٌ جِنٌّ':Added, #4: 4	قَوْلُ الْجِنِّ
u'قول جَوَاهِرُ':Added, #4: 4	قَوْلُ الْجِنِّ
u'قَوْلٌ جَوَاهِرُ':Added, #1: 1	قَوْلَ الْجَوَاهِرِ
u'قول جَوَاهِرُ':Added, #1: 1	قَوْلَ الْجَوَاهِرِ
u'قَوْلٌ جَوَاهِرُ':Added, #3: 3	قَوْلِ الْجَوَاهِرِ
u'قول جَوَاهِرُ':Added, #3: 3	قَوْلِ الْجَوَاهِرِ
u'قَوْلٌ جَوَاهِرُ':Added, #4: 4	قَوْلُ الْجَوَاهِرِ
u'قول جَوْهَرٌ':Added, #4: 4	قَوْلُ الْجَوَاهِرِ
u'قول جَوْهَرٌ':Added, #1: 1	قَوْلَ الْجَوْهَرَةِ
u'قَوْلٌ جَوْهَرٌ':Added, #1: 1	قَوْلُ الْجَوْهَرَةِ
u'قَوْلٌ جَوْهَرٌ':Added, #1: 1	قَوْلَ الْجَوْهَرَةِ
u'قول جَوْهَرِيٌّ':Added, #1: 1	قَوْلُ الْجَوْهَرَةِ
u'قول جَوْهَرِيٌّ':Added, #1: 1	قَوْلُ الْجَوْهَرِيِّ
u'قَوْلٌ جَوْهَرِيٌّ':Added, #1: 1	قَوْلِ الْجَوْهَرِيِّ
u'قَوْلٌ جَوْهَرِيٌّ':Added, #1: 1	قَوْلُ الْجَوْهَرِيِّ
u'قول حارِثٌ':Added, #1: 1	قَوْلِ الْجَوْهَرِيِّ
u'قَوْلٌ حارِثٌ':Added, #2: 2	قَوْلَ الْحَارِثِ
u'قول حافِرٌ':Added, #2: 2	قَوْلَ الْحَارِثِ
u'قَوْلٌ حافِرٌ':Added, #1: 1	قَوْلَ الْحَافِرِ
u'قول حافِرٌ':Added, #1: 1	قَوْلَ الْحَافِرِ
u'قَوْلٌ حافِرٌ':Added, #2: 2	قَوْلُ الْحَافِرِ
u'قول حافِظٌ':Added, #2: 2	قَوْلُ الْحَافِرِ
u'قَوْلٌ حافِظٌ':Added, #1: 1	قَوْلُ حَافِظِ
u'قول حافِظٌ':Added, #1: 1	قَوْلُ حَافِظِ
u'قَوْلٌ حافِظٌ':Added, #2: 2	قَوْلُ الْحَافِظِ
u'قول حاكِمٌ':Added, #2: 2	قَوْلُ الْحَافِظِ
u'قَوْلٌ حاكِمٌ':Added, #3: 3	قَوْلَ الْحَاكِمِ
u'قول حاكِمٌ':Added, #3: 3	قَوْلَ الْحَاكِمِ
u'قَوْلٌ حاكِمٌ':Added, #7: 7	قَوْلُ الْحَاكِمِ
u'قول حاكِمٌ':Added, #7: 7	قَوْلُ الْحَاكِمِ
u'قَوْلٌ حاكِمٌ':Added, #8: 8	قَوْلِ الْحَاكِمِ
u'قول حائِكٌ':Added, #8: 8	قَوْلِ الْحَاكِمِ
u'قَوْلٌ حائِكٌ':Added, #2: 2	قَوْلُ الْحَائِكِ
u'قول حذَّاءٌ':Added, #2: 2	قَوْلُ الْحَائِكِ
u'قَوْلٌ حذَّاءٌ':Added, #1: 1	قَوْلُ الْحَذَّاءِ
u'قول حُذَّاقٌ':Added, #1: 1	قَوْلُ الْحَذَّاءِ
u'قَوْلٌ حُذَّاقٌ':Added, #2: 2	قَوْلُ الْحُذَّاقِ
u'قول حُرٌّ':Added, #2: 2	قَوْلُ الْحُذَّاقِ
u'قَوْلٌ حُرٌّ':Added, #1: 1	قَوْلُ الْحُرَّةِ
u'قول حُرٌّ':Added, #1: 1	قَوْلُ الْحُرَّةِ
u'قَوْلٌ حُرٌّ':Added, #2: 2	قَوْلَ الْحُرِّ
u'قول حَرامٌ':Added, #2: 2	قَوْلَ الْحُرِّ
u'قَوْلٌ حَرامٌ':Added, #1: 1	قَوْلَ الْحَرَامِ
u'قول حَرْبٌ':Added, #1: 1	قَوْلَ الْحَرَامِ
u'قَوْلٌ حَرْبٌ':Added, #2: 2	قَوْلَ حَرْبٍ
u'قول حَسَنٌ':Added, #2: 2	قَوْلَ حَرْبٍ
u'قَوْلٌ حَسَنٌ':Added, #1: 1	قَوْلِ حَسَنِ
u'قول حَسَنٌ':Added, #1: 1	قَوْلِ حَسَنِ
u'قَوْلٌ حَسَنٌ':Added, #31: 31	قَوْلِ الْحَسَنِ
u'قول حَسَنٌ':Added, #31: 31	قَوْلِ الْحَسَنِ
u'قَوْلٌ حَسَنٌ':Added, #46: 46	قَوْلُ الْحَسَنِ
u'قول حَسَنٌ':Added, #46: 46	قَوْلُ الْحَسَنِ
u'قَوْلٌ حَسَنٌ':Added, #6: 6	قَوْلَ الْحَسَنِ
u'قول حَصْرٌ':Added, #6: 6	قَوْلَ الْحَسَنِ
u'قول حَصْرٌ':Added, #1: 1	قَوْلَ الْحَصْرِ
u'قَوْلٌ حَصْرٌ':Added, #1: 1	قَوْلِ الْحَصْرِ
u'قَوْلٌ حَصْرٌ':Added, #1: 1	قَوْلَ الْحَصْرِ
u'قول حِطَّة':Added, #1: 1	قَوْلِ الْحَصْرِ
u'قَوْلٌ حِطَّة':Added, #3: 3	قَوْلِ حِطَّةٍ
u'قول حَظْر':Added, #3: 3	قَوْلِ حِطَّةٍ
u'قَوْلٌ حَظْر':Added, #1: 1	قَوْلِ الْحَظْرِ
u'قول حَقٌّ':Added, #1: 1	قَوْلِ الْحَظْرِ
u'قَوْلٌ حَقٌّ':Added, #1: 1	قَوْلَ الْحَقِّ
u'قول حَقِيقٌ':Added, #1: 1	قَوْلَ الْحَقِّ
u'قَوْلٌ حَقِيقٌ':Added, #1: 1	قَوْلِ الْحَقِيقَةِ
u'قول حَقِيقَةٌ':Added, #1: 1	قَوْلِ الْحَقِيقَةِ
u'قَوْلٌ حَقِيقَةٌ':Added, #1: 1	قَوْلِ الْحَقِيقَةِ
u'قول حُكَّامٌ':Added, #1: 1	قَوْلِ الْحَقِيقَةِ
u'قَوْلٌ حُكَّامٌ':Added, #1: 1	قَوْلُ حُكَّامِ
u'قول حَكَمٌ':Added, #1: 1	قَوْلُ حُكَّامِ
u'قَوْلٌ حَكَمٌ':Added, #5: 5	قَوْلِ الْحَكَمِ
u'قول حكماء':Added, #5: 5	قَوْلِ الْحَكَمِ
u'قَوْلٌ حكماء':Added, #1: 1	قَوْلُ الْحُكَمَاءِ
u'قول حكماء':Added, #1: 1	قَوْلُ الْحُكَمَاءِ
u'قَوْلٌ حكماء':Added, #3: 3	قَوْلِ الْحُكَمَاءِ
u'قول حَلْوانِيٌّ':Added, #3: 3	قَوْلِ الْحُكَمَاءِ
u'قَوْلٌ حَلْوانِيٌّ':Added, #1: 1	قَوْلِ الْحَلْوَانِيِّ
u'قول حَلْوانِيٌّ':Added, #1: 1	قَوْلِ الْحَلْوَانِيِّ
u'قَوْلٌ حَلْوانِيٌّ':Added, #2: 2	قَوْلَ الْحَلْوَانِيِّ
u'قول حَلْوانِيٌّ':Added, #2: 2	قَوْلَ الْحَلْوَانِيِّ
u'قَوْلٌ حَلْوانِيٌّ':Added, #4: 4	قَوْلُ الْحَلْوَانِيِّ
u'قول حِلْيَةٌ':Added, #4: 4	قَوْلُ الْحَلْوَانِيِّ
u'قَوْلٌ حِلْيَةٌ':Added, #1: 1	قَوْلُ الْحِلْيَةِ
u'قول حَمَّالٌ':Added, #1: 1	قَوْلُ الْحِلْيَةِ
u'قَوْلٌ حَمَّالٌ':Added, #1: 1	قَوْلَ الْحَمَّالِ
u'قول حَمَّالٌ':Added, #1: 1	قَوْلَ الْحَمَّالِ
u'قَوْلٌ حَمَّالٌ':Added, #3: 3	قَوْلُ الْحَمَّالِ
u'قول حَمِيل':Added, #3: 3	قَوْلُ الْحَمَّالِ
u'قَوْلٌ حَمِيل':Added, #1: 1	قَوْلَ الْحَمِيلِ
u'قول حَنَفِيَّةٌ':Added, #1: 1	قَوْلَ الْحَمِيلِ
u'قَوْلٌ حَنَفِيَّةٌ':Added, #16: 16	قَوْلِ الْحَنَفِيَّةِ
u'قول حَنَفِيَّةٌ':Added, #16: 16	قَوْلِ الْحَنَفِيَّةِ
u'قَوْلٌ حَنَفِيَّةٌ':Added, #23: 23	قَوْلُ الْحَنَفِيَّةِ
u'قول حَنَفِيَّةٌ':Added, #23: 23	قَوْلُ الْحَنَفِيَّةِ
u'قَوْلٌ حَنَفِيَّةٌ':Added, #4: 4	قَوْلَ الْحَنَفِيَّةِ
u'قول خَادِمٌ':Added, #4: 4	قَوْلَ الْحَنَفِيَّةِ
u'قَوْلٌ خَادِمٌ':Added, #1: 1	قَوْلُ الْخَادِمِ
u'قول خَادِمٌ':Added, #1: 1	قَوْلُ الْخَادِمِ
u'قَوْلٌ خَادِمٌ':Added, #2: 2	قَوْلَ الْخَادِمِ
u'قول خَاصَّةٌ':Added, #2: 2	قَوْلَ الْخَادِمِ
u'قَوْلٌ خَاصَّةٌ':Added, #1: 1	قَوْلُ الْخَاصَّةِ
u'قول خَاطِبٌ':Added, #1: 1	قَوْلُ الْخَاصَّةِ
u'قَوْلٌ خَاطِبٌ':Added, #2: 2	قَوْلِ الْخَاطِبِ
u'قول خَالِدٌ':Added, #2: 2	قَوْلِ الْخَاطِبِ
u'قَوْلٌ خَالِدٌ':Added, #1: 1	قَوْلِ خَالِدٍ
u'قول خان':Added, #1: 1	قَوْلِ خَالِدٍ
u'قَوْلٌ خان':Added, #1: 1	قَوْلَ الْخَانِيَّةِ
u'قول خان':Added, #1: 1	قَوْلَ الْخَانِيَّةِ
u'قَوْلٌ خان':Added, #3: 3	قَوْلِ الْخَانِيَّةِ
u'قول خان':Added, #3: 3	قَوْلِ الْخَانِيَّةِ
u'قَوْلٌ خان':Added, #4: 4	قَوْلُ الْخَانِيَّةِ
u'قول خانَة':Added, #4: 4	قَوْلُ الْخَانِيَّةِ
u'قَوْلٌ خانَة':Added, #1: 1	قَوْلَ الْخَانِيَّةِ
u'قول خانَة':Added, #1: 1	قَوْلَ الْخَانِيَّةِ
u'قَوْلٌ خانَة':Added, #3: 3	قَوْلِ الْخَانِيَّةِ
u'قول خانَة':Added, #3: 3	قَوْلِ الْخَانِيَّةِ
u'قَوْلٌ خانَة':Added, #4: 4	قَوْلُ الْخَانِيَّةِ
u'قول خِزَانَةٌ':Added, #4: 4	قَوْلُ الْخَانِيَّةِ
u'قَوْلٌ خِزَانَةٌ':Added, #1: 1	قَوْلُ خِزَانَةِ
u'قول خَسِيسٌ':Added, #1: 1	قَوْلُ خِزَانَةِ
u'قَوْلٌ خَسِيسٌ':Added, #1: 1	قَوْلُ الْخَسِيسِ
u'قول خَصْمٌ':Added, #1: 1	قَوْلُ الْخَسِيسِ
u'قول خَصْمٌ':Added, #1: 1	قَوْلَ خَصْمِهِ
u'قَوْلٌ خَصْمٌ':Added, #1: 1	قَوْلِ خَصْمِهِ
u'قَوْلٌ خَصْمٌ':Added, #1: 1	قَوْلَ خَصْمِهِ
u'قول خَصْمٌ':Added, #1: 1	قَوْلِ خَصْمِهِ
u'قَوْلٌ خَصْمٌ':Added, #3: 3	قَوْلُ الْخَصْمِ
u'قول خَصْمٌ':Added, #3: 3	قَوْلُ الْخَصْمِ
u'قَوْلٌ خَصْمٌ':Added, #4: 4	قَوْلُ خَصْمِهِ
u'قول خَصْمٌ':Added, #4: 4	قَوْلُ خَصْمِهِ
u'قَوْلٌ خَصْمٌ':Added, #5: 5	قَوْلَ الْخَصْمِ
u'قول خَصْمٌ':Added, #5: 5	قَوْلَ الْخَصْمِ
u'قَوْلٌ خَصْمٌ':Added, #7: 7	قَوْلِ الْخَصْمِ
u'قول خضر':Added, #7: 7	قَوْلِ الْخَصْمِ
u'قَوْلٌ خضر':Added, #1: 1	قَوْلِ الْخَضِرِ
u'قول خَضِرٌ':Added, #1: 1	قَوْلِ الْخَضِرِ
u'قَوْلٌ خَضِرٌ':Added, #1: 1	قَوْلِ الْخَضِرِ
u'قول خطباء':Added, #1: 1	قَوْلِ الْخَضِرِ
u'قَوْلٌ خطباء':Added, #1: 1	قَوْلُ الْخُطَبَاءِ
u'قول خَطِيبٌ':Added, #1: 1	قَوْلُ الْخُطَبَاءِ
u'قَوْلٌ خَطِيبٌ':Added, #1: 1	قَوْلَ الْخَطِيبِ
u'قول خُلاصَة':Added, #1: 1	قَوْلَ الْخَطِيبِ
u'قول خُلاصَة':Added, #1: 1	قَوْلُ الْخُلَاصَةِ
u'قَوْلٌ خُلاصَة':Added, #1: 1	قَوْلِ الْخُلَاصَةِ
u'قَوْلٌ خُلاصَة':Added, #1: 1	قَوْلُ الْخُلَاصَةِ
u'قول خُلاصَة':Added, #1: 1	قَوْلِ الْخُلَاصَةِ
u'قَوْلٌ خُلاصَة':Added, #2: 2	قَوْلَ الْخُلَاصَةِ
u'قول خِلاَفِيٌّ':Added, #2: 2	قَوْلَ الْخُلَاصَةِ
u'قَوْلٌ خِلاَفِيٌّ':Added, #1: 1	قَوْلَ الْخِلَافِيِّ
u'قول خُلَفَاءُ':Added, #1: 1	قَوْلَ الْخِلَافِيِّ
u'قول خُلَفَاءُ':Added, #1: 1	قَوْلَ الْخُلَفَاءِ
u'قَوْلٌ خُلَفَاءُ':Added, #1: 1	قَوْلُ الْخُلَفَاءِ
u'قَوْلٌ خُلَفَاءُ':Added, #1: 1	قَوْلَ الْخُلَفَاءِ
u'قول خُلَفَاءُ':Added, #1: 1	قَوْلُ الْخُلَفَاءِ
u'قَوْلٌ خُلَفَاءُ':Added, #2: 2	قَوْلِ الْخُلَفَاءِ
u'قول خَلِيلٌ':Added, #2: 2	قَوْلِ الْخُلَفَاءِ
u'قَوْلٌ خَلِيلٌ':Added, #1: 1	قَوْلُ الْخَلِيلِ
u'قول خَلِيلٌ':Added, #1: 1	قَوْلُ الْخَلِيلِ
u'قَوْلٌ خَلِيلٌ':Added, #3: 3	قَوْلِ الْخَلِيلِ
u'قول خَمْسَةٌ':Added, #3: 3	قَوْلِ الْخَلِيلِ
u'قَوْلٌ خَمْسَةٌ':Added, #2: 2	قَوْلُ خَمْسَةٍ
u'قول خوارج':Added, #2: 2	قَوْلُ خَمْسَةٍ
u'قَوْلٌ خوارج':Added, #1: 1	قَوْلُ الْخَوَارِجِ
u'قول خَوَارِجُ':Added, #1: 1	قَوْلُ الْخَوَارِجِ
u'قَوْلٌ خَوَارِجُ':Added, #1: 1	قَوْلُ الْخَوَارِجِ
u'قول خوارج':Added, #1: 1	قَوْلُ الْخَوَارِجِ
u'قَوْلٌ خوارج':Added, #2: 2	قَوْلِ الْخَوَارِجِ
u'قول خَوَارِجُ':Added, #2: 2	قَوْلِ الْخَوَارِجِ
u'قَوْلٌ خَوَارِجُ':Added, #2: 2	قَوْلِ الْخَوَارِجِ
u'قول خَيَّاطٌ':Added, #2: 2	قَوْلِ الْخَوَارِجِ
u'قَوْلٌ خَيَّاطٌ':Added, #1: 1	قَوْلَ الْخَيَّاطِ
u'قول خَيَّاطٌ':Added, #1: 1	قَوْلَ الْخَيَّاطِ
u'قَوْلٌ خَيَّاطٌ':Added, #3: 3	قَوْلُ الْخَيَّاطِ
u'قول خَيْرٌ':Added, #3: 3	قَوْلُ الْخَيَّاطِ
u'قَوْلٌ خَيْرٌ':Added, #1: 1	قَوْلِ الْخَيْرِ
u'قول خَيْرٌ':Added, #1: 1	قَوْلِ الْخَيْرِ
u'قَوْلٌ خَيْرٌ':Added, #1: 1	قَوْلِ خَيْرِ
u'قول دَاخِلٌ':Added, #1: 1	قَوْلِ خَيْرِ
u'قَوْلٌ دَاخِلٌ':Added, #1: 1	قَوْلِ الدَّاخِلِ
u'قول دَافِعٌ':Added, #1: 1	قَوْلِ الدَّاخِلِ
u'قَوْلٌ دَافِعٌ':Added, #10: 10	قَوْلُ الدَّافِعِ
u'قول دَافِعٌ':Added, #10: 10	قَوْلُ الدَّافِعِ
u'قَوْلٌ دَافِعٌ':Added, #1: 1	قَوْلِ الدَّافِعِ
u'قول دَائِنٌ':Added, #1: 1	قَوْلِ الدَّافِعِ
u'قَوْلٌ دَائِنٌ':Added, #1: 1	قَوْلَ الدَّائِنِ
u'قول دُرَرٌ':Added, #1: 1	قَوْلَ الدَّائِنِ
u'قَوْلٌ دُرَرٌ':Added, #2: 2	قَوْلَ الدُّرَرِ
u'قول دُرَرٌ':Added, #2: 2	قَوْلَ الدُّرَرِ
u'قَوْلٌ دُرَرٌ':Added, #4: 4	قَوْلِ الدُّرَرِ
u'قول ذَخيرَةٌ':Added, #4: 4	قَوْلِ الدُّرَرِ
u'قَوْلٌ ذَخيرَةٌ':Added, #2: 2	قَوْلَ الذَّخِيرَةِ
u'قول ذَخيرَةٌ':Added, #2: 2	قَوْلَ الذَّخِيرَةِ
u'قَوْلٌ ذَخيرَةٌ':Added, #3: 3	قَوْلُ الذَّخِيرَةِ
u'قول ذِمِّيٌّ':Added, #3: 3	قَوْلُ الذَّخِيرَةِ
u'قول ذِمِّيٌّ':Added, #1: 1	قَوْلَ الذِّمِّيِّ
u'قَوْلٌ ذِمِّيٌّ':Added, #1: 1	قَوْلُ الذِّمِّيِّ
u'قَوْلٌ ذِمِّيٌّ':Added, #1: 1	قَوْلَ الذِّمِّيِّ
u'قول رَاجِزٌ':Added, #1: 1	قَوْلُ الذِّمِّيِّ
u'قَوْلٌ رَاجِزٌ':Added, #1: 1	قَوْلَ الرَّاجِزِ
u'قول رَاجِزٌ':Added, #1: 1	قَوْلَ الرَّاجِزِ
u'قَوْلٌ رَاجِزٌ':Added, #2: 2	قَوْلِ الرّاجِزِ
u'قول رَاجِزٌ':Added, #2: 2	قَوْلِ الرّاجِزِ
u'قَوْلٌ رَاجِزٌ':Added, #3: 3	قَوْلُ الرّاجِزِ
u'قول راغِب':Added, #3: 3	قَوْلُ الرّاجِزِ
u'قَوْلٌ راغِب':Added, #1: 1	قَوْلُ الرَّاغِبِ
u'قول رَافِضٌ':Added, #1: 1	قَوْلُ الرَّاغِبِ
u'قول رَافِضٌ':Added, #1: 1	قَوْلُ الرَّافِضَةِ
u'قَوْلٌ رَافِضٌ':Added, #1: 1	قَوْلِ الرَّافِضَةِ
u'قَوْلٌ رَافِضٌ':Added, #1: 1	قَوْلُ الرَّافِضَةِ
u'قول رَافِضَةٌ':Added, #1: 1	قَوْلِ الرَّافِضَةِ
u'قول رَافِضَةٌ':Added, #1: 1	قَوْلُ الرَّافِضَةِ
u'قَوْلٌ رَافِضَةٌ':Added, #1: 1	قَوْلِ الرَّافِضَةِ
u'قَوْلٌ رَافِضَةٌ':Added, #1: 1	قَوْلُ الرَّافِضَةِ
u'قول رَاكِبٌ':Added, #1: 1	قَوْلِ الرَّافِضَةِ
u'قَوْلٌ رَاكِبٌ':Added, #7: 7	قَوْلُ الرَّاكِبِ
u'قول رَاهِبٌ':Added, #7: 7	قَوْلُ الرَّاكِبِ
u'قَوْلٌ رَاهِبٌ':Added, #1: 1	قَوْلُ الرّاهِبِ
u'قول رَاهِبٌ':Added, #1: 1	قَوْلُ الرّاهِبِ
u'قَوْلٌ رَاهِبٌ':Added, #3: 3	قَوْلِ الرّاهِبِ
u'قول رَاهِنٌ':Added, #3: 3	قَوْلِ الرّاهِبِ
u'قول رَاهِنٌ':Added, #1: 1	قَوْلَ الرَّاهِنِ
u'قَوْلٌ رَاهِنٌ':Added, #1: 1	قَوْلِ الرَّاهِنِ
u'قَوْلٌ رَاهِنٌ':Added, #1: 1	قَوْلَ الرَّاهِنِ
u'قول رَاهِنٌ':Added, #1: 1	قَوْلِ الرَّاهِنِ
u'قَوْلٌ رَاهِنٌ':Added, #42: 42	قَوْلُ الرَّاهِنِ
u'قول رَبُّ':Added, #42: 42	قَوْلُ الرَّاهِنِ
u'قَوْلٌ رَبُّ':Added, #10: 10	قَوْلَ رَبِّ
u'قول رَبُّ':Added, #10: 10	قَوْلَ رَبِّ
u'قَوْلٌ رَبُّ':Added, #3: 3	قَوْلِ رَبِّهِ
u'قول رَبُّ':Added, #3: 3	قَوْلِ رَبِّهِ
u'قَوْلٌ رَبُّ':Added, #6: 6	قَوْلُ رَبِّهِ
u'قول رَبُّ':Added, #6: 6	قَوْلُ رَبِّهِ
u'قَوْلٌ رَبُّ':Added, #93: 93	قَوْلُ رَبِّ
u'قول رَبِيعٌ':Added, #93: 93	قَوْلُ رَبِّ
u'قول رَبِيعٌ':Added, #1: 1	قَوْلَ الرَّبِيعِ
u'قَوْلٌ رَبِيعٌ':Added, #1: 1	قَوْلُ الرّبِيعِ
u'قَوْلٌ رَبِيعٌ':Added, #1: 1	قَوْلَ الرَّبِيعِ
u'قول رَجُلٌ':Added, #1: 1	قَوْلُ الرّبِيعِ
u'قَوْلٌ رَجُلٌ':Added, #15: 15	قَوْلِ الرَّجُلِ
u'قول رَجُلٌ':Added, #15: 15	قَوْلِ الرَّجُلِ
u'قَوْلٌ رَجُلٌ':Added, #1: 1	قَوْلِ الرّجُلِ
u'قول رَجُلٌ':Added, #1: 1	قَوْلِ الرّجُلِ
u'قول رَجُلٌ':Added, #1: 1	قَوْلَ رَجُلٍ
u'قَوْلٌ رَجُلٌ':Added, #1: 1	قَوْلُ رَجُلٍ
u'قَوْلٌ رَجُلٌ':Added, #1: 1	قَوْلَ رَجُلٍ
u'قول رَجُلٌ':Added, #1: 1	قَوْلُ رَجُلٍ
u'قول رَجُلٌ':Added, #1: 1	قَوْلَ رَجُلَيْنِ
u'قول رَجُلٌ':Added, #1: 1	قَوْلُ رَجُلَيْنِ
u'قَوْلٌ رَجُلٌ':Added, #1: 1	قَوْلِ رَجُلَيْنِ
u'قَوْلٌ رَجُلٌ':Added, #1: 1	قَوْلَ رَجُلَيْنِ
u'قَوْلٌ رَجُلٌ':Added, #1: 1	قَوْلُ رَجُلَيْنِ
u'قول رَجُلٌ':Added, #1: 1	قَوْلِ رَجُلَيْنِ
u'قَوْلٌ رَجُلٌ':Added, #23: 23	قَوْلُ الرَّجُلِ
u'قول رَجُلٌ':Added, #23: 23	قَوْلُ الرَّجُلِ
u'قَوْلٌ رَجُلٌ':Added, #2: 2	قَوْلَ الرّجُلِ
u'قول رَجُلٌ':Added, #2: 2	قَوْلَ الرّجُلِ
u'قَوْلٌ رَجُلٌ':Added, #2: 2	قَوْلِ رَجُلٍ
u'قول رَجُلٌ':Added, #2: 2	قَوْلِ رَجُلٍ
u'قَوْلٌ رَجُلٌ':Added, #5: 5	قَوْلَ الرَّجُلِ
u'قول رُجُوعٌ':Added, #5: 5	قَوْلَ الرَّجُلِ
u'قَوْلٌ رُجُوعٌ':Added, #1: 1	قَوْلِ الرُّجُوعِ
u'قول رَسُولٌ':Added, #1: 1	قَوْلِ الرُّجُوعِ
u'قَوْلٌ رَسُولٌ':Added, #18: 18	قَوْلُ رَسُولِ
u'قول رَسُولٌ':Added, #18: 18	قَوْلُ رَسُولِ
u'قول رَسُولٌ':Added, #21: 21	قَوْلَ رَسُولِ
u'قَوْلٌ رَسُولٌ':Added, #21: 21	قَوْلِ رَسُولِ
u'قَوْلٌ رَسُولٌ':Added, #21: 21	قَوْلَ رَسُولِ
u'قول رَسُولٌ':Added, #21: 21	قَوْلِ رَسُولِ
u'قَوْلٌ رَسُولٌ':Added, #2: 2	قَوْلُ رَسُولِهِ
u'قول رَسُولٌ':Added, #2: 2	قَوْلُ رَسُولِهِ
u'قَوْلٌ رَسُولٌ':Added, #3: 3	قَوْلُ الرَّسُولِ
u'قول رَسُولٌ':Added, #3: 3	قَوْلُ الرَّسُولِ
u'قَوْلٌ رَسُولٌ':Added, #5: 5	قَوْلَ الرَّسُولِ
u'قول رَسُولٌ':Added, #5: 5	قَوْلَ الرَّسُولِ
u'قَوْلٌ رَسُولٌ':Added, #8: 8	قَوْلِ الرَّسُولِ
u'قول رَضِيٌّ':Added, #8: 8	قَوْلِ الرَّسُولِ
u'قَوْلٌ رَضِيٌّ':Added, #1: 1	قَوْلُ الرَّضِيِّ
u'قول رُكْنٌ':Added, #1: 1	قَوْلُ الرَّضِيِّ
u'قول رُكْن':Added, #1: 1	قَوْلِ رُكْنِ
u'قَوْلٌ رُكْنٌ':Added, #1: 1	قَوْلِ رُكْنِ
u'قَوْلٌ رُكْن':Added, #1: 1	قَوْلِ رُكْنِ
u'قول رَمْلِيٌّ':Added, #1: 1	قَوْلِ رُكْنِ
u'قَوْلٌ رَمْلِيٌّ':Added, #1: 1	قَوْلُ الرَّمْلِيِّ
u'قول روافض':Added, #1: 1	قَوْلُ الرَّمْلِيِّ
u'قَوْلٌ روافض':Added, #1: 1	قَوْلَ الرَّوَافِضِ
u'قول رَوَافِضُ':Added, #1: 1	قَوْلَ الرَّوَافِضِ
u'قَوْلٌ رَوَافِضُ':Added, #1: 1	قَوْلَ الرَّوَافِضِ
u'قول روافض':Added, #1: 1	قَوْلَ الرَّوَافِضِ
u'قَوْلٌ روافض':Added, #4: 4	قَوْلِ الرَّوَافِضِ
u'قول رَوَافِضُ':Added, #4: 4	قَوْلِ الرَّوَافِضِ
u'قَوْلٌ رَوَافِضُ':Added, #4: 4	قَوْلِ الرَّوَافِضِ
u'قول رَوْضٌ':Added, #4: 4	قَوْلِ الرَّوَافِضِ
u'قَوْلٌ رَوْضٌ':Added, #5: 5	قَوْلِ الرَّوْضِ
u'قول رَوْضَةٌ':Added, #5: 5	قَوْلِ الرَّوْضِ
u'قَوْلٌ رَوْضَةٌ':Added, #13: 13	قَوْلَ الرَّوْضَةِ
u'قول رَوْضَةٌ':Added, #13: 13	قَوْلَ الرَّوْضَةِ
u'قَوْلٌ رَوْضَةٌ':Added, #2: 2	قَوْل الرَّوْضَةِ
u'قول رَوْضَةٌ':Added, #2: 2	قَوْل الرَّوْضَةِ
u'قول رَوْضَةٌ':Added, #38: 38	قَوْلُ الرَّوْضَةِ
u'قَوْلٌ رَوْضَةٌ':Added, #38: 38	قَوْلِ الرَّوْضَةِ
u'قَوْلٌ رَوْضَةٌ':Added, #38: 38	قَوْلُ الرَّوْضَةِ
u'قول زاجِرٌ':Added, #38: 38	قَوْلِ الرَّوْضَةِ
u'قَوْلٌ زاجِرٌ':Added, #1: 1	قَوْلَ زاجرٍ
u'قول زَارِعٌ':Added, #1: 1	قَوْلَ زاجرٍ
u'قَوْلٌ زَارِعٌ':Added, #2: 2	قَوْلُ الزَّارِعِ
u'قول زَجَّاجٌ':Added, #2: 2	قَوْلُ الزَّارِعِ
u'قَوْلٌ زَجَّاجٌ':Added, #1: 1	قَوْلَ الزَّجَّاجِ
u'قول زَجَّاجٌ':Added, #1: 1	قَوْلَ الزَّجَّاجِ
u'قول زَجَّاجٌ':Added, #2: 2	قَوْلُ الزَّجَّاجِ
u'قَوْلٌ زَجَّاجٌ':Added, #2: 2	قَوْلِ الزَّجَّاجِ
u'قَوْلٌ زَجَّاجٌ':Added, #2: 2	قَوْلُ الزَّجَّاجِ
u'قول زُفَرٌ':Added, #2: 2	قَوْلِ الزَّجَّاجِ
u'قَوْلٌ زُفَرٌ':Added, #1: 1	قَوْلُ زُفَرٍ
u'قول زَوالٌ':Added, #1: 1	قَوْلُ زُفَرٍ
u'قَوْلٌ زَوالٌ':Added, #1: 1	قَوْلِ زَوَالِ
u'قول زَوْجٌ':Added, #1: 1	قَوْلِ زَوَالِ
u'قَوْلٌ زَوْجٌ':Added, #10: 10	قَوْلِ الزَّوْجِ
u'قول زَوْجٌ':Added, #10: 10	قَوْلِ الزَّوْجِ
u'قَوْلٌ زَوْجٌ':Added, #152: 152	قَوْلُ الزَّوْجِ
u'قول زَوْجٌ':Added, #152: 152	قَوْلُ الزَّوْجِ
u'قَوْلٌ زَوْجٌ':Added, #19: 19	قَوْلَ الزَّوْجِ
u'قول زَوْجٌ':Added, #19: 19	قَوْلَ الزَّوْجِ
u'قَوْلٌ زَوْجٌ':Added, #1: 1	قَوْل الزَّوْجِ
u'قول زَوْجٌ':Added, #1: 1	قَوْل الزَّوْجِ
u'قول زَوْجٌ':Added, #1: 1	قَوْلَ الزَّوْجَيْنِ
u'قَوْلٌ زَوْجٌ':Added, #1: 1	قَوْلِ الزَّوْجَيْنِ
u'قَوْلٌ زَوْجٌ':Added, #1: 1	قَوْلَ الزَّوْجَيْنِ
u'قول زَوْجَةٌ':Added, #1: 1	قَوْلِ الزَّوْجَيْنِ
u'قَوْلٌ زَوْجَةٌ':Added, #11: 11	قَوْلُ الزَّوْجَةِ
u'قول زَوْجَةٌ':Added, #11: 11	قَوْلُ الزَّوْجَةِ
u'قَوْلٌ زَوْجَةٌ':Added, #1: 1	قَوْلَ الزَّوْجَةِ
u'قول زُورٌ':Added, #1: 1	قَوْلَ الزَّوْجَةِ
u'قَوْلٌ زُورٌ':Added, #16: 16	قَوْلَ الزُّورِ
u'قول زُورٌ':Added, #16: 16	قَوْلَ الزُّورِ
u'قَوْلٌ زُورٌ':Added, #3: 3	قَوْلِ الزُّورِ
u'قول زُورٌ':Added, #3: 3	قَوْلِ الزُّورِ
u'قَوْلٌ زُورٌ':Added, #5: 5	قَوْلُ الزُّورِ
u'قول زَيْدٌ':Added, #5: 5	قَوْلُ الزُّورِ
u'قَوْلٌ زَيْدٌ':Added, #11: 11	قَوْلُ زَيْدِ
u'قول زَيْدٌ':Added, #11: 11	قَوْلُ زَيْدِ
u'قَوْلٌ زَيْدٌ':Added, #13: 13	قَوْلِ زَيْدٍ
u'قول زَيْدٌ':Added, #13: 13	قَوْلِ زَيْدٍ
u'قَوْلٌ زَيْدٌ':Added, #1: 1	قَوْلَ زَيْدِ
u'قول زَيْدٌ':Added, #1: 1	قَوْلَ زَيْدِ
u'قول زَيْدٌ':Added, #5: 5	قَوْلُ زَيْدٍ
u'قَوْلٌ زَيْدٌ':Added, #5: 5	قَوْلِ زَيْدِ
u'قَوْلٌ زَيْدٌ':Added, #5: 5	قَوْلُ زَيْدٍ
u'قول زَيْدٌ':Added, #5: 5	قَوْلِ زَيْدِ
u'قَوْلٌ زَيْدٌ':Added, #8: 8	قَوْلَ زَيْدٍ
u'قول سَابِقٌ':Added, #8: 8	قَوْلَ زَيْدٍ
u'قَوْلٌ سَابِقٌ':Added, #1: 1	قَوْلُ السَّابِقِ
u'قول سَاكِنٌ':Added, #1: 1	قَوْلُ السَّابِقِ
u'قَوْلٌ سَاكِنٌ':Added, #1: 1	قَوْلِ السَّاكِنِ
u'قول سَاكِنٌ':Added, #1: 1	قَوْلِ السَّاكِنِ
u'قَوْلٌ سَاكِنٌ':Added, #7: 7	قَوْلُ السَّاكِنِ
u'قول سَائِبٌ':Added, #7: 7	قَوْلُ السَّاكِنِ
u'قَوْلٌ سَائِبٌ':Added, #1: 1	قَوْلِ السَّائِبِ
u'قول سَائِرٌ':Added, #1: 1	قَوْلِ السَّائِبِ
u'قَوْلٌ سَائِرٌ':Added, #4: 4	قَوْلُ سَائِرِ
u'قول سَائِقٌ':Added, #4: 4	قَوْلُ سَائِرِ
u'قَوْلٌ سَائِقٌ':Added, #1: 1	قَوْلَ السَّائِقِ
u'قول سائِل':Added, #1: 1	قَوْلَ السَّائِقِ
u'قول سَائِلٌ':Added, #1: 1	قَوْلُ السّائِلِ
u'قَوْلٌ سائِل':Added, #1: 1	قَوْلُ السّائِلِ
u'قَوْلٌ سَائِلٌ':Added, #1: 1	قَوْلُ السّائِلِ
u'قول سائِل':Added, #1: 1	قَوْلُ السّائِلِ
u'قول سَائِلٌ':Added, #1: 1	قَوْلِ سَائِلِهِ
u'قَوْلٌ سائِل':Added, #1: 1	قَوْلِ سَائِلِهِ
u'قَوْلٌ سَائِلٌ':Added, #1: 1	قَوْلِ سَائِلِهِ
u'قول سائِل':Added, #1: 1	قَوْلِ سَائِلِهِ
u'قول سَائِلٌ':Added, #24: 24	قَوْلُ السَّائِلِ
u'قَوْلٌ سائِل':Added, #24: 24	قَوْلُ السَّائِلِ
u'قَوْلٌ سَائِلٌ':Added, #24: 24	قَوْلُ السَّائِلِ
u'قول سائِل':Added, #24: 24	قَوْلُ السَّائِلِ
u'قول سَائِلٌ':Added, #41: 41	قَوْلِ السَّائِلِ
u'قَوْلٌ سائِل':Added, #41: 41	قَوْلِ السَّائِلِ
u'قَوْلٌ سَائِلٌ':Added, #41: 41	قَوْلِ السَّائِلِ
u'قول سائِل':Added, #41: 41	قَوْلِ السَّائِلِ
u'قول سَائِلٌ':Added, #5: 5	قَوْلَ السَّائِلِ
u'قَوْلٌ سائِل':Added, #5: 5	قَوْلَ السَّائِلِ
u'قَوْلٌ سَائِلٌ':Added, #5: 5	قَوْلَ السَّائِلِ
u'قول سِتٌّ':Added, #5: 5	قَوْلَ السَّائِلِ
u'قَوْلٌ سِتٌّ':Added, #1: 1	قَوْلَ سِتَّةٍ
u'قول سَحْبٌ':Added, #1: 1	قَوْلَ سِتَّةٍ
u'قَوْلٌ سَحْبٌ':Added, #1: 1	قَوْلِ السَّحْبِ
u'قول سَدَادٌ':Added, #1: 1	قَوْلِ السَّحْبِ
u'قول سُدَادٌ':Added, #1: 1	قَوْلَ السّدَادِ
u'قول سِدَادٌ':Added, #1: 1	قَوْلَ السّدَادِ
u'قَوْلٌ سَدَادٌ':Added, #1: 1	قَوْلَ السّدَادِ
u'قَوْلٌ سُدَادٌ':Added, #1: 1	قَوْلَ السّدَادِ
u'قَوْلٌ سِدَادٌ':Added, #1: 1	قَوْلَ السّدَادِ
u'قول سِرَاجٌ':Added, #1: 1	قَوْلَ السّدَادِ
u'قول سِرَاجٌ':Added, #1: 1	قَوْلُ السِّرَاجِ
u'قَوْلٌ سِرَاجٌ':Added, #1: 1	قَوْلِ السِّرَاجِ
u'قَوْلٌ سِرَاجٌ':Added, #1: 1	قَوْلُ السِّرَاجِ
u'قول سِرَاجٌ':Added, #1: 1	قَوْلِ السِّرَاجِ
u'قَوْلٌ سِرَاجٌ':Added, #2: 2	قَوْلَ السِّرَاجِ
u'قول سُرُوجِيّ':Added, #2: 2	قَوْلَ السِّرَاجِ
u'قَوْلٌ سُرُوجِيّ':Added, #1: 1	قَوْلِ السُّرُوجِيِّ
u'قول سَعْدٌ':Added, #1: 1	قَوْلِ السُّرُوجِيِّ
u'قَوْلٌ سَعْدٌ':Added, #1: 1	قَوْلَ السَّعْدِ
u'قول سَعْدٌ':Added, #1: 1	قَوْلَ السَّعْدِ
u'قول سَعْدٌ':Added, #1: 1	قَوْلَ سَعْدِ
u'قَوْلٌ سَعْدٌ':Added, #1: 1	قَوْلُ سَعْدٍ
u'قَوْلٌ سَعْدٌ':Added, #1: 1	قَوْلَ سَعْدِ
u'قول سَعْدٌ':Added, #1: 1	قَوْلُ سَعْدٍ
u'قَوْلٌ سَعْدٌ':Added, #4: 4	قَوْلَ سَعْدٍ
u'قول سَعِيدٌ':Added, #4: 4	قَوْلَ سَعْدٍ
u'قَوْلٌ سَعِيدٌ':Added, #10: 10	قَوْلُ سَعِيدِ
u'قول سَعِيدٌ':Added, #10: 10	قَوْلُ سَعِيدِ
u'قَوْلٌ سَعِيدٌ':Added, #3: 3	قَوْلَ سَعِيدِ
u'قول سَعِيدٌ':Added, #3: 3	قَوْلَ سَعِيدِ
u'قَوْلٌ سَعِيدٌ':Added, #7: 7	قَوْلِ سَعِيدِ
u'قول سَفَاهَةٌ':Added, #7: 7	قَوْلِ سَعِيدِ
u'قَوْلٌ سَفَاهَةٌ':Added, #1: 1	قَوْلِ السّفَاهَةِ
u'قول سُلْطَانٌ':Added, #1: 1	قَوْلِ السّفَاهَةِ
u'قول سُلْطَانٌ':Added, #1: 1	قَوْلَ السُّلْطَانِ
u'قَوْلٌ سُلْطَانٌ':Added, #1: 1	قَوْلِ السُّلْطَانِ
u'قَوْلٌ سُلْطَانٌ':Added, #1: 1	قَوْلَ السُّلْطَانِ
u'قول سَلَفٌ':Added, #1: 1	قَوْلِ السُّلْطَانِ
u'قَوْلٌ سَلَفٌ':Added, #3: 3	قَوْلَ السَّلَفِ
u'قول سَلَفٌ':Added, #3: 3	قَوْلَ السَّلَفِ
u'قَوْلٌ سَلَفٌ':Added, #7: 7	قَوْلُ السَّلَفِ
u'قول سُلَيْمانِيّ':Added, #7: 7	قَوْلُ السَّلَفِ
u'قَوْلٌ سُلَيْمانِيّ':Added, #1: 1	قَوْلِ السُّلَيْمَانِيَّةِ
u'قول سِماكٌ':Added, #1: 1	قَوْلِ السُّلَيْمَانِيَّةِ
u'قَوْلٌ سِماكٌ':Added, #1: 1	قَوْلَ سِمَاكِ
u'قول سُنَّةٌ':Added, #1: 1	قَوْلَ سِمَاكِ
u'قَوْلٌ سُنَّةٌ':Added, #1: 1	قَوْلِ السُّنَّةِ
u'قول سُهَيْلٌ':Added, #1: 1	قَوْلِ السُّنَّةِ
u'قَوْلٌ سُهَيْلٌ':Added, #1: 1	قَوْلُ سُهَيْلِ
u'قول سُهَيْلٌ':Added, #1: 1	قَوْلُ سُهَيْلِ
u'قَوْلٌ سُهَيْلٌ':Added, #2: 2	قَوْلِ سُهَيْلٍ
u'قول سُوءٌ':Added, #2: 2	قَوْلِ سُهَيْلٍ
u'قَوْلٌ سُوءٌ':Added, #2: 2	قَوْلُ سُوءٍ
u'قول سَيِّدٌ':Added, #2: 2	قَوْلُ سُوءٍ
u'قَوْلٌ سَيِّدٌ':Added, #14: 14	قَوْلُ السَّيِّدِ
u'قول سَيِّدٌ':Added, #14: 14	قَوْلُ السَّيِّدِ
u'قَوْلٌ سَيِّدٌ':Added, #1: 1	قَوْلُ سَيِّدِ
u'قول سَيِّدٌ':Added, #1: 1	قَوْلُ سَيِّدِ
u'قَوْلٌ سَيِّدٌ':Added, #2: 2	قَوْلَ السَّيِّدِ
u'قول سَيِّدٌ':Added, #2: 2	قَوْلَ السَّيِّدِ
u'قَوْلٌ سَيِّدٌ':Added, #5: 5	قَوْلِ السَّيِّدِ
u'قَوْلٌ شَاذَّ':Added, #5: 5	قَوْلِ السَّيِّدِ
u'قَوْلٌ شَاذّ':Added, #1: 1	قَوْلٍ شَاذٍّ
u'قول شاذِلِيّ':Added, #1: 1	قَوْلٍ شَاذٍّ
u'قَوْلٌ شاذِلِيّ':Added, #1: 1	قَوْلِ الشَّاذِلِيِّ
u'قول شَارِحٌ':Added, #1: 1	قَوْلِ الشَّاذِلِيِّ
u'قَوْلٌ شَارِحٌ':Added, #17: 17	قَوْلُ الشَّارِحِ
u'قول شَارِحٌ':Added, #17: 17	قَوْلُ الشَّارِحِ
u'قول شَارِحٌ':Added, #1: 1	قَوْلَ شَارِحِ
u'قول شَارِحٌ':Added, #1: 1	قَوْلُ شَارِحِ
u'قَوْلٌ شَارِحٌ':Added, #1: 1	قَوْلِ شَارِحِ
u'قَوْلٌ شَارِحٌ':Added, #1: 1	قَوْلَ شَارِحِ
u'قَوْلٌ شَارِحٌ':Added, #1: 1	قَوْلُ شَارِحِ
u'قول شَارِحٌ':Added, #1: 1	قَوْلِ شَارِحِ
u'قَوْلٌ شَارِحٌ':Added, #6: 6	قَوْلَ الشَّارِحِ
u'قول شَارِحٌ':Added, #6: 6	قَوْلَ الشَّارِحِ
u'قَوْلٌ شَارِحٌ':Added, #7: 7	قَوْلِ الشَّارِحِ
u'قول شَارِعٌ':Added, #7: 7	قَوْلِ الشَّارِحِ
u'قَوْلٌ شَارِعٌ':Added, #1: 1	قَوْلُ الشَّارِعِ
u'قول شَارِعٌ':Added, #1: 1	قَوْلُ الشَّارِعِ
u'قَوْلٌ شَارِعٌ':Added, #2: 2	قَوْلَ الشَّارِعِ
u'قول شَارِعٌ':Added, #2: 2	قَوْلَ الشَّارِعِ
u'قَوْلٌ شَارِعٌ':Added, #4: 4	قَوْلِ الشَّارِعِ
u'قول شَاعِر':Added, #4: 4	قَوْلِ الشَّارِعِ
u'قَوْلٌ شَاعِر':Added, #11: 11	قَوْلَ الشَّاعِرِ
u'قول شَاعِر':Added, #11: 11	قَوْلَ الشَّاعِرِ
u'قَوْلٌ شَاعِر':Added, #15: 15	قَوْلِ الشَّاعِرِ
u'قول شَاعِر':Added, #15: 15	قَوْلِ الشَّاعِرِ
u'قَوْلٌ شَاعِر':Added, #16: 16	قَوْلُ الشَّاعِرِ
u'قول شَاعِر':Added, #16: 16	قَوْلُ الشَّاعِرِ
u'قَوْلٌ شَاعِر':Added, #1: 1	قَوْلَ الشّاعِرِ
u'قول شَاعِر':Added, #1: 1	قَوْلَ الشّاعِرِ
u'قَوْلٌ شَاعِر':Added, #5: 5	قَوْلِ الشّاعِرِ
u'قول شَاعِر':Added, #5: 5	قَوْلِ الشّاعِرِ
u'قَوْلٌ شَاعِر':Added, #6: 6	قَوْلُ الشّاعِرِ
u'قول شافِع':Added, #6: 6	قَوْلُ الشّاعِرِ
u'قَوْلٌ شافِع':Added, #2: 2	قَوْلَ الشَّافِعِيَّةِ
u'قول شافِع':Added, #2: 2	قَوْلَ الشَّافِعِيَّةِ
u'قَوْلٌ شافِع':Added, #7: 7	قَوْلُ الشَّافِعِيَّةِ
u'قول شافِع':Added, #7: 7	قَوْلُ الشَّافِعِيَّةِ
u'قَوْلٌ شافِع':Added, #8: 8	قَوْلِ الشَّافِعِيَّةِ
u'قول شافِعِيّ':Added, #8: 8	قَوْلِ الشَّافِعِيَّةِ
u'قَوْلٌ شافِعِيّ':Added, #175: 175	قَوْلِ الشَّافِعِيِّ
u'قول شافِعِيّ':Added, #175: 175	قَوْلِ الشَّافِعِيِّ
u'قَوْلٌ شافِعِيّ':Added, #219: 219	قَوْلُ الشَّافِعِيِّ
u'قول شافِعِيّ':Added, #219: 219	قَوْلُ الشَّافِعِيِّ
u'قَوْلٌ شافِعِيّ':Added, #23: 23	قَوْلَ الشَّافِعِيِّ
u'قول شافِعِيّ':Added, #23: 23	قَوْلَ الشَّافِعِيِّ
u'قَوْلٌ شافِعِيّ':Added, #2: 2	قَوْلَ الشَّافِعِيَّةِ
u'قول شافِعِيّ':Added, #2: 2	قَوْلَ الشَّافِعِيَّةِ
u'قَوْلٌ شافِعِيّ':Added, #7: 7	قَوْلُ الشَّافِعِيَّةِ
u'قول شافِعِيّ':Added, #7: 7	قَوْلُ الشَّافِعِيَّةِ
u'قَوْلٌ شافِعِيّ':Added, #8: 8	قَوْلِ الشَّافِعِيَّةِ
u'قول شَامِلٌ':Added, #8: 8	قَوْلِ الشَّافِعِيَّةِ
u'قول شَامِلٌ':Added, #1: 1	قَوْلَ الشَّامِلِ
u'قَوْلٌ شَامِلٌ':Added, #1: 1	قَوْلُ الشَّامِلِ
u'قَوْلٌ شَامِلٌ':Added, #1: 1	قَوْلَ الشَّامِلِ
u'قول شَاهِدٌ':Added, #1: 1	قَوْلُ الشَّامِلِ
u'قَوْلٌ شَاهِدٌ':Added, #11: 11	قَوْلُ الشَّاهِدِ
u'قول شَاهِدٌ':Added, #11: 11	قَوْلُ الشَّاهِدِ
u'قول شَاهِدٌ':Added, #1: 1	قَوْلَ الشَّاهِدَيْنِ
u'قول شَاهِدٌ':Added, #1: 1	قَوْلُ الشَّاهِدَيْنِ
u'قَوْلٌ شَاهِدٌ':Added, #1: 1	قَوْلِ الشَّاهِدَيْنِ
u'قَوْلٌ شَاهِدٌ':Added, #1: 1	قَوْلَ الشَّاهِدَيْنِ
u'قَوْلٌ شَاهِدٌ':Added, #1: 1	قَوْلُ الشَّاهِدَيْنِ
u'قول شَاهِدٌ':Added, #1: 1	قَوْلِ الشَّاهِدَيْنِ
u'قَوْلٌ شَاهِدٌ':Added, #1: 1	قَوْلِ شَاهِدَيْنِ
u'قول شَاهِدٌ':Added, #1: 1	قَوْلِ شَاهِدَيْنِ
u'قَوْلٌ شَاهِدٌ':Added, #3: 3	قَوْلِ الشَّاهِدِ
u'قول شَاهِدٌ':Added, #3: 3	قَوْلِ الشَّاهِدِ
u'قَوْلٌ شَاهِدٌ':Added, #5: 5	قَوْلَ الشَّاهِدِ
u'قول شَجَرَةٌ':Added, #5: 5	قَوْلَ الشَّاهِدِ
u'قَوْلٌ شَجَرَةٌ':Added, #1: 1	قَوْلِ الشَّجَرَةِ
u'قول شَخْصٌ':Added, #1: 1	قَوْلِ الشَّجَرَةِ
u'قَوْلٌ شَخْصٌ':Added, #1: 1	قَوْلِ الشَّخْصِ
u'قول شَخْصٌ':Added, #1: 1	قَوْلِ الشَّخْصِ
u'قَوْلٌ شَخْصٌ':Added, #3: 3	قَوْلُ الشَّخْصِ
u'قول شُرَّاحٌ':Added, #3: 3	قَوْلُ الشَّخْصِ
u'قَوْلٌ شُرَّاحٌ':Added, #1: 1	قَوْلُ الشُّرَّاحِ
u'قول شُرَّاحٌ':Added, #1: 1	قَوْلُ الشُّرَّاحِ
u'قَوْلٌ شُرَّاحٌ':Added, #1: 1	قَوْلُ شُرَّاحِ
u'قول شَرْحٌ':Added, #1: 1	قَوْلُ شُرَّاحِ
u'قَوْلٌ شَرْحٌ':Added, #1: 1	قَوْلِ شَرْحِهِ
u'قول شَرْحٌ':Added, #1: 1	قَوْلِ شَرْحِهِ
u'قَوْلٌ شَرْحٌ':Added, #2: 2	قَوْلُ الشَّرْحِ
u'قول شَرْحٌ':Added, #2: 2	قَوْلُ الشَّرْحِ
u'قَوْلٌ شَرْحٌ':Added, #2: 2	قَوْلِ شَرْحِ
u'قول شَرْحٌ':Added, #2: 2	قَوْلِ شَرْحِ
u'قَوْلٌ شَرْحٌ':Added, #3: 3	قَوْلَ شَرْحِ
u'قول شِرْذِمَةٌ':Added, #3: 3	قَوْلَ شَرْحِ
u'قَوْلٌ شِرْذِمَةٌ':Added, #1: 1	قَوْلِ الشِّرْذِمَةِ
u'قول شِرْذِمَةٌ':Added, #1: 1	قَوْلِ الشِّرْذِمَةِ
u'قَوْلٌ شِرْذِمَةٌ':Added, #1: 1	قَوْلُ شِرْذِمَةٍ
u'قول شركاء':Added, #1: 1	قَوْلُ شِرْذِمَةٍ
u'قَوْلٌ شركاء':Added, #1: 1	قَوْلُ الشُّرَكَاءِ
u'قول شركة':Added, #1: 1	قَوْلُ الشُّرَكَاءِ
u'قول شركة':Added, #1: 1	قَوْل الشَّرِكَةِ
u'قَوْلٌ شركة':Added, #1: 1	قَوْلَ الشَّرِكَةِ
u'قَوْلٌ شركة':Added, #1: 1	قَوْل الشَّرِكَةِ
u'قول شَرِكَةٌ':Added, #1: 1	قَوْلَ الشَّرِكَةِ
u'قول شَرِكَةٌ':Added, #1: 1	قَوْل الشَّرِكَةِ
u'قَوْلٌ شَرِكَةٌ':Added, #1: 1	قَوْلَ الشَّرِكَةِ
u'قَوْلٌ شَرِكَةٌ':Added, #1: 1	قَوْل الشَّرِكَةِ
u'قول شركة':Added, #1: 1	قَوْلَ الشَّرِكَةِ
u'قَوْلٌ شركة':Added, #4: 4	قَوْلِ الشَّرِكَةِ
u'قول شَرِكَةٌ':Added, #4: 4	قَوْلِ الشَّرِكَةِ
u'قَوْلٌ شَرِكَةٌ':Added, #4: 4	قَوْلِ الشَّرِكَةِ
u'قول شَرِيفٌ':Added, #4: 4	قَوْلِ الشَّرِكَةِ
u'قَوْلٌ شَرِيفٌ':Added, #1: 1	قَوْلِ الشَّرِيفِ
u'قول شَرِيفٌ':Added, #1: 1	قَوْلِ الشَّرِيفِ
u'قَوْلٌ شَرِيفٌ':Added, #4: 4	قَوْلُ الشَّرِيفِ
u'قول شَرِيكٌ':Added, #4: 4	قَوْلُ الشَّرِيفِ
u'قَوْلٌ شَرِيكٌ':Added, #5: 5	قَوْلُ الشَّرِيكِ
u'قول شَعْبِيٌّ':Added, #5: 5	قَوْلُ الشَّرِيكِ
u'قول شَعْبِيٌّ':Added, #4: 4	قَوْلَ الشَّعْبِيِّ
u'قَوْلٌ شَعْبِيٌّ':Added, #4: 4	قَوْلِ الشَّعْبِيِّ
u'قَوْلٌ شَعْبِيٌّ':Added, #4: 4	قَوْلَ الشَّعْبِيِّ
u'قول شَعْبِيٌّ':Added, #4: 4	قَوْلِ الشَّعْبِيِّ
u'قَوْلٌ شَعْبِيٌّ':Added, #7: 7	قَوْلُ الشَّعْبِيِّ
u'قول شِعْرٌ':Added, #7: 7	قَوْلُ الشَّعْبِيِّ
u'قَوْلٌ شِعْرٌ':Added, #1: 1	قَوْلِ الشِّعْرِ
u'قول شُعرَاءُ':Added, #1: 1	قَوْلِ الشِّعْرِ
u'قول شُعَرَاءُ':Added, #1: 1	قَوْلَ الشُّعَرَاءِ
u'قَوْلٌ شُعرَاءُ':Added, #1: 1	قَوْلَ الشُّعَرَاءِ
u'قَوْلٌ شُعَرَاءُ':Added, #1: 1	قَوْلَ الشُّعَرَاءِ
u'قول شِفَاءٌ':Added, #1: 1	قَوْلَ الشُّعَرَاءِ
u'قَوْلٌ شِفَاءٌ':Added, #1: 1	قَوْلَ الشِّفَاءِ
u'قول شَفِيعٌ':Added, #1: 1	قَوْلَ الشِّفَاءِ
u'قَوْلٌ شَفِيعٌ':Added, #13: 13	قَوْلُ الشَّفِيعِ
u'قول شَفِيعٌ':Added, #13: 13	قَوْلُ الشَّفِيعِ
u'قَوْلٌ شَفِيعٌ':Added, #1: 1	قَوْلِ الشَّفِيعِ
u'قول شَفِيعٌ':Added, #1: 1	قَوْلِ الشَّفِيعِ
u'قَوْلٌ شَفِيعٌ':Added, #5: 5	قَوْلَ الشَّفِيعِ
u'قول شمس':Added, #5: 5	قَوْلَ الشَّفِيعِ
u'قول شمس':Added, #3: 3	قَوْلَ شَمْسِ
u'قَوْلٌ شمس':Added, #3: 3	قَوْلُ شَمْسِ
u'قَوْلٌ شمس':Added, #3: 3	قَوْلَ شَمْسِ
u'قول شَمْسٌ':Added, #3: 3	قَوْلُ شَمْسِ
u'قول شَمْسٌ':Added, #3: 3	قَوْلَ شَمْسِ
u'قَوْلٌ شَمْسٌ':Added, #3: 3	قَوْلُ شَمْسِ
u'قَوْلٌ شَمْسٌ':Added, #3: 3	قَوْلَ شَمْسِ
u'قول شمس':Added, #3: 3	قَوْلُ شَمْسِ
u'قَوْلٌ شمس':Added, #6: 6	قَوْلِ شَمْسِ
u'قول شَمْسٌ':Added, #6: 6	قَوْلِ شَمْسِ
u'قَوْلٌ شَمْسٌ':Added, #6: 6	قَوْلِ شَمْسِ
u'قول شَهْرٌ':Added, #6: 6	قَوْلِ شَمْسِ
u'قَوْلٌ شَهْرٌ':Added, #1: 1	قَوْلُ شَهْرِ
u'قول شُهُودٌ':Added, #1: 1	قَوْلُ شَهْرِ
u'قَوْلٌ شُهُودٌ':Added, #1: 1	قَوْلُ شُهُودِهِ
u'قول شُهُودٌ':Added, #1: 1	قَوْلُ شُهُودِهِ
u'قول شُهُودٌ':Added, #3: 3	قَوْلُ الشُّهُودِ
u'قَوْلٌ شُهُودٌ':Added, #3: 3	قَوْلِ الشُّهُودِ
u'قَوْلٌ شُهُودٌ':Added, #3: 3	قَوْلُ الشُّهُودِ
u'قول شَهِيدٌ':Added, #3: 3	قَوْلِ الشُّهُودِ
u'قَوْلٌ شَهِيدٌ':Added, #1: 1	قَوْلِ الشَّهِيدِ
u'قول شَيْخٌ':Added, #1: 1	قَوْلِ الشَّهِيدِ
u'قول شَيْخٌ':Added, #1: 1	قَوْل الشَّيْخِ
u'قَوْلٌ شَيْخٌ':Added, #1: 1	قَوْلَ الشّيْخِ
u'قَوْلٌ شَيْخٌ':Added, #1: 1	قَوْل الشَّيْخِ
u'قول شَيْخٌ':Added, #1: 1	قَوْلَ الشّيْخِ
u'قَوْلٌ شَيْخٌ':Added, #1: 1	قَوْل شَيْخِ
u'قول شَيْخٌ':Added, #1: 1	قَوْل شَيْخِ
u'قول شَيْخٌ':Added, #1: 1	قَوْل شَيْخِهِ
u'قَوْلٌ شَيْخٌ':Added, #1: 1	قَوْلُ شَيْخِهِ
u'قَوْلٌ شَيْخٌ':Added, #1: 1	قَوْل شَيْخِهِ
u'قول شَيْخٌ':Added, #1: 1	قَوْلُ شَيْخِهِ
u'قَوْلٌ شَيْخٌ':Added, #25: 25	قَوْلِ الشَّيْخِ
u'قول شَيْخٌ':Added, #25: 25	قَوْلِ الشَّيْخِ
u'قَوْلٌ شَيْخٌ':Added, #25: 25	قَوْلِ الشَّيْخَيْنِ
u'قول شَيْخٌ':Added, #25: 25	قَوْلِ الشَّيْخَيْنِ
u'قَوْلٌ شَيْخٌ':Added, #28: 28	قَوْلُ الشَّيْخِ
u'قول شَيْخٌ':Added, #28: 28	قَوْلُ الشَّيْخِ
u'قَوْلٌ شَيْخٌ':Added, #28: 28	قَوْلُ الشَّيْخَيْنِ
u'قول شَيْخٌ':Added, #28: 28	قَوْلُ الشَّيْخَيْنِ
u'قَوْلٌ شَيْخٌ':Added, #3: 3	قَوْل الشَّيْخَيْنِ
u'قول شَيْخٌ':Added, #3: 3	قَوْل الشَّيْخَيْنِ
u'قَوْلٌ شَيْخٌ':Added, #4: 4	قَوْلِ شَيْخِ
u'قول شَيْخٌ':Added, #4: 4	قَوْلِ شَيْخِ
u'قَوْلٌ شَيْخٌ':Added, #5: 5	قَوْلَ الشَّيْخِ
u'قول شَيْخٌ':Added, #5: 5	قَوْلَ الشَّيْخِ
u'قَوْلٌ شَيْخٌ':Added, #5: 5	قَوْلُ شَيْخِ
u'قول شَيْخٌ':Added, #5: 5	قَوْلُ شَيْخِ
u'قَوْلٌ شَيْخٌ':Added, #6: 6	قَوْلَ الشَّيْخَيْنِ
u'قول شَيْخٌ':Added, #6: 6	قَوْلَ الشَّيْخَيْنِ
u'قَوْلٌ شَيْخٌ':Added, #7: 7	قَوْلِ شَيْخِهِ
u'قول شَيْطَانٌ':Added, #7: 7	قَوْلِ شَيْخِهِ
u'قَوْلٌ شَيْطَانٌ':Added, #1: 1	قَوْلَ الشَّيْطَانِ
u'قول شُيُوخٌ':Added, #1: 1	قَوْلَ الشَّيْطَانِ
u'قَوْلٌ شُيُوخٌ':Added, #1: 1	قَوْلَ الشُّيُوخِ
u'قول شُيُوخٌ':Added, #1: 1	قَوْلَ الشُّيُوخِ
u'قَوْلٌ شُيُوخٌ':Added, #1: 1	قَوْلِ شُيُوخِ
u'قول صَابِئٌ':Added, #1: 1	قَوْلِ شُيُوخِ
u'قَوْلٌ صَابِئٌ':Added, #1: 1	قَوْلَ الصَّابِئِ
u'قول صَاحِبٌ':Added, #1: 1	قَوْلَ الصَّابِئِ
u'قَوْلٌ صَاحِبٌ':Added, #28: 28	قَوْلَ صَاحِبِ
u'قول صَاحِبٌ':Added, #28: 28	قَوْلَ صَاحِبِ
u'قَوْلٌ صَاحِبٌ':Added, #2: 2	قَوْلِ صَاحِبٍ
u'قول صَاحِبٌ':Added, #2: 2	قَوْلِ صَاحِبٍ
u'قَوْلٌ صَاحِبٌ':Added, #3: 3	قَوْلُ صَاحِبِهِ
u'قول صَاحِبٌ':Added, #3: 3	قَوْلُ صَاحِبِهِ
u'قَوْلٌ صَاحِبٌ':Added, #42: 42	قَوْلِ صَاحِبِ
u'قول صَاحِبٌ':Added, #42: 42	قَوْلِ صَاحِبِ
u'قَوْلٌ صَاحِبٌ':Added, #4: 4	قَوْلِ صَاحِبِهِ
u'قول صَاحِبٌ':Added, #4: 4	قَوْلِ صَاحِبِهِ
u'قَوْلٌ صَاحِبٌ':Added, #6: 6	قَوْلِ الصَّاحِبَيْنِ
u'قول صَاحِبٌ':Added, #6: 6	قَوْلِ الصَّاحِبَيْنِ
u'قَوْلٌ صَاحِبٌ':Added, #81: 81	قَوْلُ صَاحِبِ
u'قول صَالِحٌ':Added, #81: 81	قَوْلُ صَاحِبِ
u'قول صَالِح':Added, #1: 1	قَوْلُ صَالِحٍ
u'قَوْلٌ صَالِحٌ':Added, #1: 1	قَوْلُ صَالِحٍ
u'قَوْلٌ صَالِح':Added, #1: 1	قَوْلُ صَالِحٍ
u'قول صَانِعٌ':Added, #1: 1	قَوْلُ صَالِحٍ
u'قول صَانِعٌ':Added, #1: 1	قَوْلَ الصَّانِعِ
u'قَوْلٌ صَانِعٌ':Added, #1: 1	قَوْلِ الصَّانِعِ
u'قَوْلٌ صَانِعٌ':Added, #1: 1	قَوْلَ الصَّانِعِ
u'قول صَانِعٌ':Added, #1: 1	قَوْلِ الصَّانِعِ
u'قَوْلٌ صَانِعٌ':Added, #2: 2	قَوْلُ الصَّانِعِ
u'قول صَانِعٌ':Added, #2: 2	قَوْلُ الصَّانِعِ
u'قَوْلٌ صَانِعٌ':Added, #2: 2	قَوْلُ صَانِعِهِ
u'قول صَبِيٌّ':Added, #2: 2	قَوْلُ صَانِعِهِ
u'قَوْلٌ صَبِيٌّ':Added, #10: 10	قَوْلُ الصَّبِيِّ
u'قول صَبِيٌّ':Added, #10: 10	قَوْلُ الصَّبِيِّ
u'قَوْلٌ صَبِيٌّ':Added, #1: 1	قَوْلِ الصَّبِيِّ
u'قول صَبِيٌّ':Added, #1: 1	قَوْلِ الصَّبِيِّ
u'قَوْلٌ صَبِيٌّ':Added, #2: 2	قَوْلَ الصَّبِيِّ
u'قول صَحَابَةٌ':Added, #2: 2	قَوْلَ الصَّبِيِّ
u'قَوْلٌ صَحَابَةٌ':Added, #2: 2	قَوْلَ الصَّحَابَةِ
u'قول صَحَابَةٌ':Added, #2: 2	قَوْلَ الصَّحَابَةِ
u'قَوْلٌ صَحَابَةٌ':Added, #5: 5	قَوْلُ الصَّحَابَةِ
u'قول صَحَابَةٌ':Added, #5: 5	قَوْلُ الصَّحَابَةِ
u'قَوْلٌ صَحَابَةٌ':Added, #7: 7	قَوْلِ الصَّحَابَةِ
u'قول صَحَابِيٌّ':Added, #7: 7	قَوْلِ الصَّحَابَةِ
u'قَوْلٌ صَحَابِيٌّ':Added, #11: 11	قَوْلُ صَحَابِيٍّ
u'قول صَحَابِيٌّ':Added, #11: 11	قَوْلُ صَحَابِيٍّ
u'قَوْلٌ صَحَابِيٌّ':Added, #1: 1	قَوْلُ صَحَابِيَّيْنِ
u'قول صَحَابِيٌّ':Added, #1: 1	قَوْلُ صَحَابِيَّيْنِ
u'قَوْلٌ صَحَابِيٌّ':Added, #25: 25	قَوْلَ الصَّحَابِيِّ
u'قول صَحَابِيٌّ':Added, #25: 25	قَوْلَ الصَّحَابِيِّ
u'قول صَحَابِيٌّ':Added, #26: 26	قَوْلُ الصَّحَابِيِّ
u'قَوْلٌ صَحَابِيٌّ':Added, #26: 26	قَوْلِ الصَّحَابِيِّ
u'قَوْلٌ صَحَابِيٌّ':Added, #26: 26	قَوْلُ الصَّحَابِيِّ
u'قول صَحَابِيٌّ':Added, #26: 26	قَوْلِ الصَّحَابِيِّ
u'قَوْلٌ صَحَابِيٌّ':Added, #2: 2	قَوْلَ صَحَابِيٍّ
u'قول صَحَابِيٌّ':Added, #2: 2	قَوْلَ صَحَابِيٍّ
u'قَوْلٌ صَحَابِيٌّ':Added, #3: 3	قَوْلِ صَحَابِيٍّ
u'قول صِحَّةٌ':Added, #3: 3	قَوْلِ صَحَابِيٍّ
u'قَوْلٌ صِحَّةٌ':Added, #1: 1	قَوْلِ الصِّحَّةِ
u'قول صَدْرٌ':Added, #1: 1	قَوْلِ الصِّحَّةِ
u'قَوْلٌ صَدْرٌ':Added, #2: 2	قَوْلِ صَدْرِ
u'قول صَدْرٌ':Added, #2: 2	قَوْلِ صَدْرِ
u'قَوْلٌ صَدْرٌ':Added, #6: 6	قَوْلُ صَدْرِ
u'قول صدق':Added, #6: 6	قَوْلُ صَدْرِ
u'قَوْلٌ صدق':Added, #1: 1	قَوْلَ الصِّدْقِ
u'قول صِدْقٌ':Added, #1: 1	قَوْلَ الصِّدْقِ
u'قَوْلٌ صِدْقٌ':Added, #1: 1	قَوْلَ الصِّدْقِ
u'قول صِدِّيقٌ':Added, #1: 1	قَوْلَ الصِّدْقِ
u'قَوْلٌ صِدِّيقٌ':Added, #2: 2	قَوْلُ الصِّدِّيقِ
u'قول صِرْفٌ':Added, #2: 2	قَوْلُ الصِّدِّيقِ
u'قَوْلٌ صِرْفٌ':Added, #1: 1	قَوْلُ الصِّرْفَةِ
u'قول صَغِيرٌ':Added, #1: 1	قَوْلُ الصِّرْفَةِ
u'قَوْلٌ صَغِيرٌ':Added, #1: 1	قَوْلُ الصَّغِيرِ
u'قول صَلاَحٌ':Added, #1: 1	قَوْلُ الصَّغِيرِ
u'قَوْلٌ صَلاَحٌ':Added, #1: 1	قَوْلُ الصَّلَاحِ
u'قول صُوفِيٌّ':Added, #1: 1	قَوْلُ الصَّلَاحِ
u'قول صُوفِيٌّ':Added, #1: 1	قَوْلَ الصُّوفِيَّةِ
u'قول صُوفِيٌّ':Added, #1: 1	قَوْلُ الصُّوفِيَّةِ
u'قَوْلٌ صُوفِيٌّ':Added, #1: 1	قَوْلِ الصُّوفِيَّةِ
u'قَوْلٌ صُوفِيٌّ':Added, #1: 1	قَوْلَ الصُّوفِيَّةِ
u'قَوْلٌ صُوفِيٌّ':Added, #1: 1	قَوْلُ الصُّوفِيَّةِ
u'قول صُوفِيَّةٌ':Added, #1: 1	قَوْلِ الصُّوفِيَّةِ
u'قول صُوفِيَّةٌ':Added, #1: 1	قَوْلَ الصُّوفِيَّةِ
u'قول صُوفِيَّةٌ':Added, #1: 1	قَوْلُ الصُّوفِيَّةِ
u'قَوْلٌ صُوفِيَّةٌ':Added, #1: 1	قَوْلِ الصُّوفِيَّةِ
u'قَوْلٌ صُوفِيَّةٌ':Added, #1: 1	قَوْلَ الصُّوفِيَّةِ
u'قَوْلٌ صُوفِيَّةٌ':Added, #1: 1	قَوْلُ الصُّوفِيَّةِ
u'قول صَيْدَلانِيّ':Added, #1: 1	قَوْلِ الصُّوفِيَّةِ
u'قَوْلٌ صَيْدَلانِيّ':Added, #1: 1	قَوْلِ الصَّيْدَلَانِيِّ
u'قول صَيْرَفِيٌّ':Added, #1: 1	قَوْلِ الصَّيْدَلَانِيِّ
u'قول صَيْرَفِيٌّ':Added, #5: 5	قَوْلَ الصَّيْرَفِيِّ
u'قَوْلٌ صَيْرَفِيٌّ':Added, #5: 5	قَوْلِ الصَّيْرَفِيِّ
u'قَوْلٌ صَيْرَفِيٌّ':Added, #5: 5	قَوْلَ الصَّيْرَفِيِّ
u'قول ضَارِبٌ':Added, #5: 5	قَوْلِ الصَّيْرَفِيِّ
u'قول ضَارِبٌ':Added, #3: 3	قَوْلَ الضَّارِبِ
u'قَوْلٌ ضَارِبٌ':Added, #3: 3	قَوْلُ الضَّارِبِ
u'قَوْلٌ ضَارِبٌ':Added, #3: 3	قَوْلَ الضَّارِبِ
u'قول ضَامِنٌ':Added, #3: 3	قَوْلُ الضَّارِبِ
u'قَوْلٌ ضَامِنٌ':Added, #7: 7	قَوْلُ الضَّامِنِ
u'قول ضرار':Added, #7: 7	قَوْلُ الضَّامِنِ
u'قَوْلٌ ضرار':Added, #1: 1	قَوْلَ ضِرَارِ
u'قول ضَمَانٌ':Added, #1: 1	قَوْلَ ضِرَارِ
u'قَوْلٌ ضَمَانٌ':Added, #1: 1	قَوْلِ ضَمَانِ
u'قول ضَمَانٌ':Added, #1: 1	قَوْلِ ضَمَانِ
u'قَوْلٌ ضَمَانٌ':Added, #2: 2	قَوْلُ ضَمَانِ
u'قول ضَمَانٌ':Added, #2: 2	قَوْلُ ضَمَانِ
u'قَوْلٌ ضَمَانٌ':Added, #5: 5	قَوْلِ الضَّمَانِ
u'قول ضَيْفٌ':Added, #5: 5	قَوْلِ الضَّمَانِ
u'قَوْلٌ ضَيْفٌ':Added, #1: 1	قَوْلِ الضَّيْفِ
u'قول طَاعَةٌ':Added, #1: 1	قَوْلِ الضَّيْفِ
u'قَوْلٌ طَاعَةٌ':Added, #1: 1	قَوْلُ طَاعَةٍ
u'قول طَالِبٌ':Added, #1: 1	قَوْلُ طَاعَةٍ
u'قَوْلٌ طَالِبٌ':Added, #11: 11	قَوْلُ الطَّالِبِ
u'قول طَالِبٌ':Added, #11: 11	قَوْلُ الطَّالِبِ
u'قَوْلٌ طَالِبٌ':Added, #1: 1	قَوْلَ طَالِبِ
u'قول طَالِبٌ':Added, #1: 1	قَوْلَ طَالِبِ
u'قَوْلٌ طَالِبٌ':Added, #2: 2	قَوْلِ الطَّالِبِ
u'قول طَالِبٌ':Added, #2: 2	قَوْلِ الطَّالِبِ
u'قَوْلٌ طَالِبٌ':Added, #3: 3	قَوْلَ الطَّالِبِ
u'قول طَائِفٌ':Added, #3: 3	قَوْلَ الطَّالِبِ
u'قَوْلٌ طَائِفٌ':Added, #12: 12	قَوْلُ طَائِفَةٍ
u'قول طَائِفٌ':Added, #12: 12	قَوْلُ طَائِفَةٍ
u'قول طَائِفٌ':Added, #1: 1	قَوْلُ الطَّائِفَةِ
u'قَوْلٌ طَائِفٌ':Added, #1: 1	قَوْلِ الطَّائِفَةِ
u'قَوْلٌ طَائِفٌ':Added, #1: 1	قَوْلُ الطَّائِفَةِ
u'قول طَائِفٌ':Added, #1: 1	قَوْلِ الطَّائِفَةِ
u'قَوْلٌ طَائِفٌ':Added, #1: 1	قَوْلَ طَائِفَةٍ
u'قول طَائِفٌ':Added, #1: 1	قَوْلَ طَائِفَةٍ
u'قَوْلٌ طَائِفٌ':Added, #2: 2	قَوْلَ الطَّائِفَةِ
u'قول طَائِفٌ':Added, #2: 2	قَوْلَ الطَّائِفَةِ
u'قَوْلٌ طَائِفٌ':Added, #7: 7	قَوْلِ طَائِفَةٍ
u'قول طَبَرِيّ':Added, #7: 7	قَوْلِ طَائِفَةٍ
u'قَوْلٌ طَبَرِيّ':Added, #1: 1	قَوْلِ الطَّبَرِيِّ
u'قول طَبَرِيّ':Added, #1: 1	قَوْلِ الطَّبَرِيِّ
u'قَوْلٌ طَبَرِيّ':Added, #3: 3	قَوْلُ الطَّبَرِيِّ
u'قول طَبِيبٌ':Added, #3: 3	قَوْلُ الطَّبَرِيِّ
u'قول طَبِيبٌ':Added, #1: 1	قَوْلَ الطَّبِيبِ
u'قَوْلٌ طَبِيبٌ':Added, #1: 1	قَوْلُ الطَّبِيبِ
u'قَوْلٌ طَبِيبٌ':Added, #1: 1	قَوْلَ الطَّبِيبِ
u'قول طَبِيبٌ':Added, #1: 1	قَوْلُ الطَّبِيبِ
u'قَوْلٌ طَبِيبٌ':Added, #2: 2	قَوْلِ الطَّبِيبِ
u'قول طَبِيبٌ':Added, #2: 2	قَوْلِ الطَّبِيبِ
u'قول طَبِيبٌ':Added, #2: 2	قَوْلُ طَبِيبٍ
u'قَوْلٌ طَبِيبٌ':Added, #2: 2	قَوْلِ طَبِيبٍ
u'قَوْلٌ طَبِيبٌ':Added, #2: 2	قَوْلُ طَبِيبٍ
u'قول طِمٌّ':Added, #2: 2	قَوْلِ طَبِيبٍ
u'قَوْلٌ طِمٌّ':Added, #1: 1	قَوْلُ الطِّمِّ
u'قول ظاهِر':Added, #1: 1	قَوْلُ الطِّمِّ
u'قول ظاهِر':Added, #1: 1	قَوْلَ الظَّاهِرِيَّةِ
u'قَوْلٌ ظاهِر':Added, #1: 1	قَوْلُ الظَّاهِرِيَّةِ
u'قَوْلٌ ظاهِر':Added, #1: 1	قَوْلَ الظَّاهِرِيَّةِ
u'قول ظاهِرَة':Added, #1: 1	قَوْلُ الظَّاهِرِيَّةِ
u'قول ظاهِرَة':Added, #1: 1	قَوْلَ الظَّاهِرِيَّةِ
u'قَوْلٌ ظاهِرَة':Added, #1: 1	قَوْلُ الظَّاهِرِيَّةِ
u'قَوْلٌ ظاهِرَة':Added, #1: 1	قَوْلَ الظَّاهِرِيَّةِ
u'قول ظاهِرِيّ':Added, #1: 1	قَوْلُ الظَّاهِرِيَّةِ
u'قول ظاهِرِيّ':Added, #1: 1	قَوْلَ الظَّاهِرِيَّةِ
u'قَوْلٌ ظاهِرِيّ':Added, #1: 1	قَوْلُ الظَّاهِرِيَّةِ
u'قَوْلٌ ظاهِرِيّ':Added, #1: 1	قَوْلَ الظَّاهِرِيَّةِ
u'قول ظَهِير':Added, #1: 1	قَوْلُ الظَّاهِرِيَّةِ
u'قول ظَهِير':Added, #1: 1	قَوْلَ الظَّهِيرِيَّةِ
u'قول ظَهِير':Added, #1: 1	قَوْلُ الظَّهِيرِيَّةِ
u'قَوْلٌ ظَهِير':Added, #1: 1	قَوْلِ الظَّهِيرِيَّةِ
u'قَوْلٌ ظَهِير':Added, #1: 1	قَوْلَ الظَّهِيرِيَّةِ
u'قَوْلٌ ظَهِير':Added, #1: 1	قَوْلُ الظَّهِيرِيَّةِ
u'قول ظَهِيرَة':Added, #1: 1	قَوْلِ الظَّهِيرِيَّةِ
u'قول ظَهِيرَة':Added, #1: 1	قَوْلَ الظَّهِيرِيَّةِ
u'قول ظَهِيرَة':Added, #1: 1	قَوْلُ الظَّهِيرِيَّةِ
u'قَوْلٌ ظَهِيرَة':Added, #1: 1	قَوْلِ الظَّهِيرِيَّةِ
u'قَوْلٌ ظَهِيرَة':Added, #1: 1	قَوْلَ الظَّهِيرِيَّةِ
u'قَوْلٌ ظَهِيرَة':Added, #1: 1	قَوْلُ الظَّهِيرِيَّةِ
u'قول عارِيَّةٌ':Added, #1: 1	قَوْلِ الظَّهِيرِيَّةِ
u'قَوْلٌ عارِيَّةٌ':Added, #1: 1	قَوْلَ الْعَارِيَّةِ
u'قول عارِيَّةٌ':Added, #1: 1	قَوْلَ الْعَارِيَّةِ
u'قَوْلٌ عارِيَّةٌ':Added, #2: 2	قَوْلِ الْعَارِيَّةِ
u'قول عَاقِدٌ':Added, #2: 2	قَوْلِ الْعَارِيَّةِ
u'قَوْلٌ عَاقِدٌ':Added, #1: 1	قَوْلِ الْعَاقِدِ
u'قول عَاقِدٌ':Added, #1: 1	قَوْلِ الْعَاقِدِ
u'قَوْلٌ عَاقِدٌ':Added, #1: 1	قَوْلُ الْعَاقِدَيْنِ
u'قول عَاقِلٌ':Added, #1: 1	قَوْلُ الْعَاقِدَيْنِ
u'قَوْلٌ عَاقِلٌ':Added, #2: 2	قَوْلُ الْعَاقِلَةِ
u'قول عَالِمٌ':Added, #2: 2	قَوْلُ الْعَاقِلَةِ
u'قَوْلٌ عَالِمٌ':Added, #2: 2	قَوْلَ الْعَالِمِ
u'قول عَالِمٌ':Added, #2: 2	قَوْلَ الْعَالِمِ
u'قَوْلٌ عَالِمٌ':Added, #3: 3	قَوْلُ الْعَالِمِ
u'قول عَالِمٌ':Added, #3: 3	قَوْلُ الْعَالِمِ
u'قَوْلٌ عَالِمٌ':Added, #4: 4	قَوْلِ الْعَالِمِ
u'قول عَامٌّ':Added, #4: 4	قَوْلِ الْعَالِمِ
u'قَوْلٌ عَامٌّ':Added, #1: 1	قَوْلَ الْعَامِّ
u'قول عَامٌّ':Added, #1: 1	قَوْلَ الْعَامِّ
u'قَوْلٌ عَامٌّ':Added, #1: 1	قَوْلَ الْعَامَّةِ
u'قَوْلٌ عَامٌّ':Added, #1: 1	قَوْلَ الْعَامَّةِ
u'قول عَامٌّ':Added, #1: 1	قَوْلٍ عَامٍّ
u'قَوْلٌ عَامٌّ':Added, #22: 22	قَوْلِ عَامَّةِ
u'قول عَامٌّ':Added, #22: 22	قَوْلِ عَامَّةِ
u'قَوْلٌ عَامٌّ':Added, #25: 25	قَوْلُ الْعَامَّةِ
u'قول عَامٌّ':Added, #25: 25	قَوْلُ الْعَامَّةِ
u'قَوْلٌ عَامٌّ':Added, #26: 26	قَوْلِ الْعَامَّةِ
u'قول عَامٌّ':Added, #26: 26	قَوْلِ الْعَامَّةِ
u'قَوْلٌ عَامٌّ':Added, #3: 3	قَوْلَ عَامَّةِ
u'قول عَامٌّ':Added, #3: 3	قَوْلَ عَامَّةِ
u'قَوْلٌ عَامٌّ':Added, #54: 54	قَوْلُ عَامَّةِ
u'قول عَامِرٌ':Added, #54: 54	قَوْلُ عَامَّةِ
u'قول عَامِرٌ':Added, #1: 1	قَوْلُ عَامِرٍ
u'قَوْلٌ عَامِرٌ':Added, #1: 1	قَوْلُ عَامِرِ
u'قَوْلٌ عَامِرٌ':Added, #1: 1	قَوْلُ عَامِرٍ
u'قول عَامِرٌ':Added, #1: 1	قَوْلُ عَامِرِ
u'قَوْلٌ عَامِرٌ':Added, #2: 2	قَوْلَ عَامِرٍ
u'قول عَامِلٌ':Added, #2: 2	قَوْلَ عَامِرٍ
u'قَوْلٌ عَامِلٌ':Added, #14: 14	قَوْلُ الْعَامِلِ
u'قول عَامِلٌ':Added, #14: 14	قَوْلُ الْعَامِلِ
u'قول عَامِلٌ':Added, #1: 1	قَوْلَ عَامِلِ
u'قَوْلٌ عَامِلٌ':Added, #1: 1	قَوْلُ عَامِلِ
u'قَوْلٌ عَامِلٌ':Added, #1: 1	قَوْلَ عَامِلِ
u'قول عَامِلٌ':Added, #1: 1	قَوْلُ عَامِلِ
u'قَوْلٌ عَامِلٌ':Added, #4: 4	قَوْلَ الْعَامِلِ
u'قول عَامِّيٌّ':Added, #4: 4	قَوْلَ الْعَامِلِ
u'قَوْلٌ عَامِّيٌّ':Added, #1: 1	قَوْلَ الْعَامِّيِّ
u'قول عَامِّيٌّ':Added, #1: 1	قَوْلَ الْعَامِّيِّ
u'قول عَامِّيٌّ':Added, #2: 2	قَوْلُ الْعَامِّيِّ
u'قَوْلٌ عَامِّيٌّ':Added, #2: 2	قَوْلِ الْعَامِّيِّ
u'قَوْلٌ عَامِّيٌّ':Added, #2: 2	قَوْلُ الْعَامِّيِّ
u'قول عَائِدٌ':Added, #2: 2	قَوْلِ الْعَامِّيِّ
u'قَوْلٌ عَائِدٌ':Added, #1: 1	قَوْلِ الْعَائِدِ
u'قول عُبَابٌ':Added, #1: 1	قَوْلِ الْعَائِدِ
u'قَوْلٌ عُبَابٌ':Added, #1: 1	قَوْلُ الْعُبَابِ
u'قول عُبَابٌ':Added, #1: 1	قَوْلُ الْعُبَابِ
u'قَوْلٌ عُبَابٌ':Added, #4: 4	قَوْلِ الْعُبَابِ
u'قول عَبَّاسٌ':Added, #4: 4	قَوْلِ الْعُبَابِ
u'قَوْلٌ عَبَّاسٌ':Added, #1: 1	قَوْلُ الْعَبَّاسِ
u'قول عَبَّاسٌ':Added, #1: 1	قَوْلُ الْعَبَّاسِ
u'قول عَبَّاسٌ':Added, #1: 1	قَوْلَ عَبّاسٍ
u'قَوْلٌ عَبَّاسٌ':Added, #1: 1	قَوْلِ عَبّاسِ
u'قَوْلٌ عَبَّاسٌ':Added, #1: 1	قَوْلَ عَبّاسٍ
u'قول عَبْدٌ':Added, #1: 1	قَوْلِ عَبّاسِ
u'قَوْلٌ عَبْدٌ':Added, #10: 10	قَوْلَ عَبْدِ
u'قول عَبْدٌ':Added, #10: 10	قَوْلَ عَبْدِ
u'قَوْلٌ عَبْدٌ':Added, #18: 18	قَوْلُ عَبْدِ
u'قول عَبْدٌ':Added, #18: 18	قَوْلُ عَبْدِ
u'قول عَبْدٌ':Added, #1: 1	قَوْلُ عَبْدٍ
u'قَوْلٌ عَبْدٌ':Added, #1: 1	قَوْلِ عَبْدٍ
u'قَوْلٌ عَبْدٌ':Added, #1: 1	قَوْلُ عَبْدٍ
u'قول عَبْدٌ':Added, #1: 1	قَوْلِ عَبْدٍ
u'قَوْلٌ عَبْدٌ':Added, #2: 2	قَوْلِ الْعَبْدِ
u'قول عَبْدٌ':Added, #2: 2	قَوْلِ الْعَبْدِ
u'قَوْلٌ عَبْدٌ':Added, #31: 31	قَوْلِ عَبْدِ
u'قول عَبْدٌ':Added, #31: 31	قَوْلِ عَبْدِ
u'قَوْلٌ عَبْدٌ':Added, #36: 36	قَوْلُ الْعَبْدِ
u'قول عَبْدٌ':Added, #36: 36	قَوْلُ الْعَبْدِ
u'قَوْلٌ عَبْدٌ':Added, #5: 5	قَوْلَ الْعَبْدِ
u'قول عَبَدَةٌ':Added, #5: 5	قَوْلَ الْعَبْدِ
u'قَوْلٌ عَبَدَةٌ':Added, #1: 1	قَوْلُ عَبَدَةِ
u'قول عَجَّاجٌ':Added, #1: 1	قَوْلُ عَبَدَةِ
u'قَوْلٌ عَجَّاجٌ':Added, #1: 1	قَوْلِ الْعَجّاجِ
u'قول عَجَّاجٌ':Added, #1: 1	قَوْلِ الْعَجّاجِ
u'قَوْلٌ عَجَّاجٌ':Added, #2: 2	قَوْلَ الْعَجّاجِ
u'قول عَدْلٌ':Added, #2: 2	قَوْلَ الْعَجّاجِ
u'قَوْلٌ عَدْلٌ':Added, #10: 10	قَوْلُ عَدْلٍ
u'قول عَدْلٌ':Added, #10: 10	قَوْلُ عَدْلٍ
u'قَوْلٌ عَدْلٌ':Added, #1: 1	قَوْلِ عَدْلٍ
u'قول عَدْلٌ':Added, #1: 1	قَوْلِ عَدْلٍ
u'قَوْلٌ عَدْلٌ':Added, #2: 2	قَوْلَ الْعَدْلِ
u'قول عَدْلٌ':Added, #2: 2	قَوْلَ الْعَدْلِ
u'قَوْلٌ عَدْلٌ':Added, #3: 3	قَوْلِ عَدْلَيْنِ
u'قول عَدْلٌ':Added, #3: 3	قَوْلِ عَدْلَيْنِ
u'قَوْلٌ عَدْلٌ':Added, #4: 4	قَوْلُ عَدْلَيْنِ
u'قول عَدْلٌ':Added, #4: 4	قَوْلُ عَدْلَيْنِ
u'قَوْلٌ عَدْلٌ':Added, #6: 6	قَوْلُ الْعَدْلِ
u'قول عَدَمٌ':Added, #6: 6	قَوْلُ الْعَدْلِ
u'قَوْلٌ عَدَمٌ':Added, #1: 1	قَوْلُ عَدَمِ
u'قول عَرَبٌ':Added, #1: 1	قَوْلُ عَدَمِ
u'قَوْلٌ عَرَبٌ':Added, #3: 3	قَوْلُ الْعَرَبِ
u'قول عَرَبٌ':Added, #3: 3	قَوْلُ الْعَرَبِ
u'قَوْلٌ عَرَبٌ':Added, #8: 8	قَوْلِ الْعَرَبِ
u'قول عَرَبِيٌّ':Added, #8: 8	قَوْلِ الْعَرَبِ
u'قَوْلٌ عَرَبِيٌّ':Added, #1: 1	قَوْلَ الْعَرَبِيِّ
u'قول عَزْمٌ':Added, #1: 1	قَوْلَ الْعَرَبِيِّ
u'قَوْلٌ عَزْمٌ':Added, #1: 1	قَوْلُ عَزْمٍ
u'قول عَزِيزٌ':Added, #1: 1	قَوْلُ عَزْمٍ
u'قَوْلٌ عَزِيزٌ':Added, #2: 2	قَوْلُ الْعَزِيزِ
u'قول عِصَامٌ':Added, #2: 2	قَوْلُ الْعَزِيزِ
u'قَوْلٌ عِصَامٌ':Added, #1: 1	قَوْلُ عِصَامٍ
u'قول عَصْرِيٌّ':Added, #1: 1	قَوْلُ عِصَامٍ
u'قَوْلٌ عَصْرِيٌّ':Added, #1: 1	قَوْلُ عَصْرِيٍّ
u'قول عَضُدٌ':Added, #1: 1	قَوْلُ عَصْرِيٍّ
u'قول عَضُدٌ':Added, #1: 1	قَوْلَ الْعَضُدِ
u'قَوْلٌ عَضُدٌ':Added, #1: 1	قَوْلِ الْعَضُدِ
u'قَوْلٌ عَضُدٌ':Added, #1: 1	قَوْلَ الْعَضُدِ
u'قول عَضُدٌ':Added, #1: 1	قَوْلِ الْعَضُدِ
u'قول عَضُدٌ':Added, #1: 1	قَوْلُ عَضُدِ
u'قَوْلٌ عَضُدٌ':Added, #1: 1	قَوْلِ عَضُدِ
u'قَوْلٌ عَضُدٌ':Added, #1: 1	قَوْلُ عَضُدِ
u'قول عَطَاءٌ':Added, #1: 1	قَوْلِ عَضُدِ
u'قَوْلٌ عَطَاءٌ':Added, #14: 14	قَوْلُ عَطَاءٍ
u'قول عَطَاءٌ':Added, #14: 14	قَوْلُ عَطَاءٍ
u'قَوْلٌ عَطَاءٌ':Added, #1: 1	قَوْلَ عَطَاءٍ
u'قول عَطَاءٌ':Added, #1: 1	قَوْلَ عَطَاءٍ
u'قَوْلٌ عَطَاءٌ':Added, #5: 5	قَوْلِ عَطَاءٍ
u'قول عَطَاءٌ':Added, #5: 5	قَوْلِ عَطَاءٍ
u'قَوْلٌ عَطَاءٌ':Added, #7: 7	قَوْلُ عَطَاءِ
u'قول عَقْدٌ':Added, #7: 7	قَوْلُ عَطَاءِ
u'قول عَقْدٌ':Added, #1: 1	قَوْلَ الْعَقْدِ
u'قَوْلٌ عَقْدٌ':Added, #1: 1	قَوْلُ الْعَقْدِ
u'قَوْلٌ عَقْدٌ':Added, #1: 1	قَوْلَ الْعَقْدِ
u'قول عَكْسٌ':Added, #1: 1	قَوْلُ الْعَقْدِ
u'قَوْلٌ عَكْسٌ':Added, #1: 1	قَوْلُ عَكْسِهِ
u'قول علماء':Added, #1: 1	قَوْلُ عَكْسِهِ
u'قَوْلٌ علماء':Added, #10: 10	قَوْلِ الْعُلَمَاءِ
u'قول عُلَمَاءُ':Added, #10: 10	قَوْلِ الْعُلَمَاءِ
u'قَوْلٌ عُلَمَاءُ':Added, #10: 10	قَوْلِ الْعُلَمَاءِ
u'قول علماء':Added, #10: 10	قَوْلِ الْعُلَمَاءِ
u'قَوْلٌ علماء':Added, #2: 2	قَوْلَ الْعُلَمَاءِ
u'قول عُلَمَاءُ':Added, #2: 2	قَوْلَ الْعُلَمَاءِ
u'قَوْلٌ عُلَمَاءُ':Added, #2: 2	قَوْلَ الْعُلَمَاءِ
u'قول علماء':Added, #2: 2	قَوْلَ الْعُلَمَاءِ
u'قَوْلٌ علماء':Added, #2: 2	قَوْلُ عُلَمَاءِ
u'قول عُلَمَاءُ':Added, #2: 2	قَوْلُ عُلَمَاءِ
u'قَوْلٌ عُلَمَاءُ':Added, #2: 2	قَوْلُ عُلَمَاءِ
u'قول علماء':Added, #2: 2	قَوْلُ عُلَمَاءِ
u'قَوْلٌ علماء':Added, #4: 4	قَوْلُ الْعُلَمَاءِ
u'قول عُلَمَاءُ':Added, #4: 4	قَوْلُ الْعُلَمَاءِ
u'قَوْلٌ عُلَمَاءُ':Added, #4: 4	قَوْلُ الْعُلَمَاءِ
u'قول عَلِيٌّ':Added, #4: 4	قَوْلُ الْعُلَمَاءِ
u'قَوْلٌ عَلِيٌّ':Added, #29: 29	قَوْلِ عَلِيٍّ
u'قول عَلِيٌّ':Added, #29: 29	قَوْلِ عَلِيٍّ
u'قَوْلٌ عَلِيٌّ':Added, #2: 2	قَوْلِ عَلِيِّ
u'قول عَلِيٌّ':Added, #2: 2	قَوْلِ عَلِيِّ
u'قَوْلٌ عَلِيٌّ':Added, #3: 3	قَوْلُ عَلِيِّ
u'قول عَلِيٌّ':Added, #3: 3	قَوْلُ عَلِيِّ
u'قَوْلٌ عَلِيٌّ':Added, #4: 4	قَوْلَ عَلِيٍّ
u'قول عَلِيٌّ':Added, #4: 4	قَوْلَ عَلِيٍّ
u'قَوْلٌ عَلِيٌّ':Added, #51: 51	قَوْلُ عَلِيٍّ
u'قول عَمَّةٌ':Added, #51: 51	قَوْلُ عَلِيٍّ
u'قَوْلٌ عَمَّةٌ':Added, #1: 1	قَوْلَ عَمّتِهِ
u'قول عُمْرَانِيٌّ':Added, #1: 1	قَوْلَ عَمّتِهِ
u'قَوْلٌ عُمْرَانِيٌّ':Added, #1: 1	قَوْلُ الْعُمْرَانِيِّ
u'قول عِنَايَةٌ':Added, #1: 1	قَوْلُ الْعُمْرَانِيِّ
u'قَوْلٌ عِنَايَةٌ':Added, #1: 1	قَوْلَ الْعِنَايَةِ
u'قول غَاصِبٌ':Added, #1: 1	قَوْلَ الْعِنَايَةِ
u'قَوْلٌ غَاصِبٌ':Added, #1: 1	قَوْلُ غَاصِبِهِ
u'قول غَاصِبٌ':Added, #1: 1	قَوْلُ غَاصِبِهِ
u'قَوْلٌ غَاصِبٌ':Added, #25: 25	قَوْلُ الْغَاصِبِ
u'قول غَاصِبٌ':Added, #25: 25	قَوْلُ الْغَاصِبِ
u'قَوْلٌ غَاصِبٌ':Added, #4: 4	قَوْلَ الْغَاصِبِ
u'قول غَالِبٌ':Added, #4: 4	قَوْلَ الْغَاصِبِ
u'قَوْلٌ غَالِبٌ':Added, #1: 1	قَوْلُ غَالِبِ
u'قول غَائِبٌ':Added, #1: 1	قَوْلُ غَالِبِ
u'قَوْلٌ غَائِبٌ':Added, #1: 1	قَوْلُ الْغَائِبِ
u'قول غُرَابٌ':Added, #1: 1	قَوْلُ الْغَائِبِ
u'قَوْلٌ غُرَابٌ':Added, #1: 1	قَوْلِ الْغُرَابِ
u'قول غرماء':Added, #1: 1	قَوْلِ الْغُرَابِ
u'قَوْلٌ غرماء':Added, #1: 1	قَوْلَ الْغُرَمَاءِ
u'قول غرماء':Added, #1: 1	قَوْلَ الْغُرَمَاءِ
u'قَوْلٌ غرماء':Added, #2: 2	قَوْلُ الْغُرَمَاءِ
u'قول غَرِيمٌ':Added, #2: 2	قَوْلُ الْغُرَمَاءِ
u'قول غَرِيمٌ':Added, #1: 1	قَوْلَ غَرِيمِهِ
u'قَوْلٌ غَرِيمٌ':Added, #1: 1	قَوْلُ غَرِيمِهِ
u'قَوْلٌ غَرِيمٌ':Added, #1: 1	قَوْلَ غَرِيمِهِ
u'قول غُلاَمٌ':Added, #1: 1	قَوْلُ غَرِيمِهِ
u'قول غُلاَمٌ':Added, #1: 1	قَوْلِ الْغُلَامِ
u'قَوْلٌ غُلاَمٌ':Added, #1: 1	قَوْلِ الْغُلاَمِ
u'قَوْلٌ غُلاَمٌ':Added, #1: 1	قَوْلِ الْغُلَامِ
u'قول غُلاَمٌ':Added, #1: 1	قَوْلِ الْغُلاَمِ
u'قَوْلٌ غُلاَمٌ':Added, #4: 4	قَوْلُ الْغُلَامِ
u'قول غير':Added, #4: 4	قَوْلُ الْغُلَامِ
u'قول غَيْرٌ':Added, #12: 12	قَوْلِ غَيْرِ
u'قَوْلٌ غير':Added, #12: 12	قَوْلِ غَيْرِ
u'قَوْلٌ غَيْرٌ':Added, #12: 12	قَوْلِ غَيْرِ
u'قول غير':Added, #12: 12	قَوْلِ غَيْرِ
u'قول غَيْرٌ':Added, #26: 26	قَوْلُ غَيْرِ
u'قَوْلٌ غير':Added, #26: 26	قَوْلُ غَيْرِ
u'قَوْلٌ غَيْرٌ':Added, #26: 26	قَوْلُ غَيْرِ
u'قول غير':Added, #26: 26	قَوْلُ غَيْرِ
u'قول غَيْرٌ':Added, #2: 2	قَوْلَ غَيْرِ
u'قَوْلٌ غير':Added, #2: 2	قَوْلَ غَيْرِ
u'قَوْلٌ غَيْرٌ':Added, #2: 2	قَوْلَ غَيْرِ
u'قول غير':Added, #2: 2	قَوْلَ غَيْرِ
u'قول غَيْرٌ':Added, #37: 37	قَوْلِ غَيْرِهِ
u'قَوْلٌ غير':Added, #37: 37	قَوْلِ غَيْرِهِ
u'قَوْلٌ غَيْرٌ':Added, #37: 37	قَوْلِ غَيْرِهِ
u'قول غير':Added, #37: 37	قَوْلِ غَيْرِهِ
u'قول غَيْرٌ':Added, #4: 4	قَوْلَ الْغَيْرِ
u'قَوْلٌ غير':Added, #4: 4	قَوْلَ الْغَيْرِ
u'قَوْلٌ غَيْرٌ':Added, #4: 4	قَوْلَ الْغَيْرِ
u'قول غير':Added, #4: 4	قَوْلَ الْغَيْرِ
u'قول غَيْرٌ':Added, #6: 6	قَوْلُ الْغَيْرِ
u'قَوْلٌ غير':Added, #6: 6	قَوْلُ الْغَيْرِ
u'قَوْلٌ غَيْرٌ':Added, #6: 6	قَوْلُ الْغَيْرِ
u'قول غير':Added, #6: 6	قَوْلُ الْغَيْرِ
u'قول غَيْرٌ':Added, #6: 6	قَوْلَ غَيْرِهِ
u'قَوْلٌ غير':Added, #6: 6	قَوْلَ غَيْرِهِ
u'قَوْلٌ غَيْرٌ':Added, #6: 6	قَوْلَ غَيْرِهِ
u'قول غير':Added, #6: 6	قَوْلَ غَيْرِهِ
u'قول غَيْرٌ':Added, #8: 8	قَوْلُ غَيْرِهِ
u'قَوْلٌ غير':Added, #8: 8	قَوْلُ غَيْرِهِ
u'قَوْلٌ غَيْرٌ':Added, #8: 8	قَوْلُ غَيْرِهِ
u'قول غير':Added, #8: 8	قَوْلُ غَيْرِهِ
u'قول غَيْرٌ':Added, #9: 9	قَوْلِ الْغَيْرِ
u'قَوْلٌ غير':Added, #9: 9	قَوْلِ الْغَيْرِ
u'قَوْلٌ غَيْرٌ':Added, #9: 9	قَوْلِ الْغَيْرِ
u'قول فَارِسِيٌّ':Added, #9: 9	قَوْلِ الْغَيْرِ
u'قَوْلٌ فَارِسِيٌّ':Added, #1: 1	قَوْلُ الْفَارِسِيِّ
u'قول فَارِقٌ':Added, #1: 1	قَوْلُ الْفَارِسِيِّ
u'قَوْلٌ فَارِقٌ':Added, #1: 1	قَوْلُ الْفَارِقِ
u'قول فَارُوقٌ':Added, #1: 1	قَوْلُ الْفَارِقِ
u'قَوْلٌ فَارُوقٌ':Added, #1: 1	قَوْلُ الْفَارُوقِ
u'قول فَاسِقٌ':Added, #1: 1	قَوْلُ الْفَارُوقِ
u'قَوْلٌ فَاسِقٌ':Added, #1: 1	قَوْلِ فَاسِقٍ
u'قول فَاسِقٌ':Added, #1: 1	قَوْلِ فَاسِقٍ
u'قَوْلٌ فَاسِقٌ':Added, #5: 5	قَوْلُ الْفَاسِقِ
u'قول فَاسِقٌ':Added, #5: 5	قَوْلُ الْفَاسِقِ
u'قول فَاسِقٌ':Added, #6: 6	قَوْلَ الْفَاسِقِ
u'قَوْلٌ فَاسِقٌ':Added, #6: 6	قَوْلِ الْفَاسِقِ
u'قَوْلٌ فَاسِقٌ':Added, #6: 6	قَوْلَ الْفَاسِقِ
u'قول فَاكِهَانِيٌّ':Added, #6: 6	قَوْلِ الْفَاسِقِ
u'قول فَاكِهَانِيٌّ':Added, #2: 2	قَوْلُ الْفَاكِهَانِيِّ
u'قَوْلٌ فَاكِهَانِيٌّ':Added, #2: 2	قَوْلِ الْفَاكِهَانِيِّ
u'قَوْلٌ فَاكِهَانِيٌّ':Added, #2: 2	قَوْلُ الْفَاكِهَانِيِّ
u'قول فَتْحٌ':Added, #2: 2	قَوْلِ الْفَاكِهَانِيِّ
u'قَوْلٌ فَتْحٌ':Added, #1: 1	قَوْلَ الْفَتْحِ
u'قول فَتْحٌ':Added, #1: 1	قَوْلَ الْفَتْحِ
u'قَوْلٌ فَتْحٌ':Added, #6: 6	قَوْلُ الْفَتْحِ
u'قول فَتْحٌ':Added, #6: 6	قَوْلُ الْفَتْحِ
u'قَوْلٌ فَتْحٌ':Added, #7: 7	قَوْلِ الْفَتْحِ
u'قول فُجَّارٌ':Added, #7: 7	قَوْلِ الْفَتْحِ
u'قَوْلٌ فُجَّارٌ':Added, #1: 1	قَوْلَ الْفُجَّارِ
u'قول فخر':Added, #1: 1	قَوْلَ الْفُجَّارِ
u'قَوْلٌ فخر':Added, #12: 12	قَوْلُ فَخْرِ
u'قول فَخْرٌ':Added, #12: 12	قَوْلُ فَخْرِ
u'قَوْلٌ فَخْرٌ':Added, #12: 12	قَوْلُ فَخْرِ
u'قول فخر':Added, #12: 12	قَوْلُ فَخْرِ
u'قَوْلٌ فخر':Added, #1: 1	قَوْلُ الْفَخْرِ
u'قول فَخْرٌ':Added, #1: 1	قَوْلُ الْفَخْرِ
u'قَوْلٌ فَخْرٌ':Added, #1: 1	قَوْلُ الْفَخْرِ
u'قول فخر':Added, #1: 1	قَوْلُ الْفَخْرِ
u'قَوْلٌ فخر':Added, #2: 2	قَوْلِ الْفَخْرِ
u'قول فَخْرٌ':Added, #2: 2	قَوْلِ الْفَخْرِ
u'قَوْلٌ فَخْرٌ':Added, #2: 2	قَوْلِ الْفَخْرِ
u'قول فخر':Added, #2: 2	قَوْلِ الْفَخْرِ
u'قَوْلٌ فخر':Added, #2: 2	قَوْلَ فَخْرِ
u'قول فَخْرٌ':Added, #2: 2	قَوْلَ فَخْرِ
u'قَوْلٌ فَخْرٌ':Added, #2: 2	قَوْلَ فَخْرِ
u'قول فخر':Added, #2: 2	قَوْلَ فَخْرِ
u'قَوْلٌ فخر':Added, #9: 9	قَوْلِ فَخْرِ
u'قول فَخْرٌ':Added, #9: 9	قَوْلِ فَخْرِ
u'قَوْلٌ فَخْرٌ':Added, #9: 9	قَوْلِ فَخْرِ
u'قول فَرَّاءٌ':Added, #9: 9	قَوْلِ فَخْرِ
u'قول فَرَّاءٌ':Added, #1: 1	قَوْلِ الْفَرّاءِ
u'قَوْلٌ فَرَّاءٌ':Added, #1: 1	قَوْلِ الْفَرَّاءِ
u'قَوْلٌ فَرَّاءٌ':Added, #1: 1	قَوْلِ الْفَرّاءِ
u'قول فراض':Added, #1: 1	قَوْلِ الْفَرَّاءِ
u'قَوْلٌ فراض':Added, #1: 1	قَوْلِ الْفِرَاضِ
u'قول فِرَاضٌ':Added, #1: 1	قَوْلِ الْفِرَاضِ
u'قَوْلٌ فِرَاضٌ':Added, #1: 1	قَوْلِ الْفِرَاضِ
u'قول فَرَزْدَقٌ':Added, #1: 1	قَوْلِ الْفِرَاضِ
u'قَوْلٌ فَرَزْدَقٌ':Added, #3: 3	قَوْلُ الْفَرَزْدَقِ
u'قول فَرْضٌ':Added, #3: 3	قَوْلُ الْفَرَزْدَقِ
u'قَوْلٌ فَرْضٌ':Added, #1: 1	قَوْلِ الْفَرْضِ
u'قول فَرْعٌ':Added, #1: 1	قَوْلِ الْفَرْضِ
u'قَوْلٌ فَرْعٌ':Added, #1: 1	قَوْلُ الْفَرْعِ
u'قول فرق':Added, #1: 1	قَوْلُ الْفَرْعِ
u'قَوْلٌ فرق':Added, #1: 1	قَوْلِ الْفَرْقِ
u'قول فَرْقٌ':Added, #1: 1	قَوْلِ الْفَرْقِ
u'قَوْلٌ فَرْقٌ':Added, #1: 1	قَوْلِ الْفَرْقِ
u'قول فُرُوعٌ':Added, #1: 1	قَوْلِ الْفَرْقِ
u'قَوْلٌ فُرُوعٌ':Added, #1: 1	قَوْلُ الْفُرُوعِ
u'قول فُرُوعٌ':Added, #1: 1	قَوْلُ الْفُرُوعِ
u'قَوْلٌ فُرُوعٌ':Added, #2: 2	قَوْلِ الْفُرُوعِ
u'قول فَرِيقٌ':Added, #2: 2	قَوْلِ الْفُرُوعِ
u'قَوْلٌ فَرِيقٌ':Added, #1: 1	قَوْلِ الْفَرِيقَيْنِ
u'قول فَرِيقٌ':Added, #1: 1	قَوْلِ الْفَرِيقَيْنِ
u'قَوْلٌ فَرِيقٌ':Added, #1: 1	قَوْلُ فَرِيقٍ
u'قول فَسْخٌ':Added, #1: 1	قَوْلُ فَرِيقٍ
u'قَوْلٌ فَسْخٌ':Added, #3: 3	قَوْلِ الْفَسْخِ
u'قول فسقة':Added, #3: 3	قَوْلِ الْفَسْخِ
u'قَوْلٌ فسقة':Added, #1: 1	قَوْلُ الْفَسَقَةِ
u'قول فُضُولِيٌّ':Added, #1: 1	قَوْلُ الْفَسَقَةِ
u'قَوْلٌ فُضُولِيٌّ':Added, #1: 1	قَوْلِ الْفُضُولِيِّ
u'قول فقهاء':Added, #1: 1	قَوْلِ الْفُضُولِيِّ
u'قَوْلٌ فقهاء':Added, #22: 22	قَوْلِ الْفُقَهَاءِ
u'قول فقهاء':Added, #22: 22	قَوْلِ الْفُقَهَاءِ
u'قَوْلٌ فقهاء':Added, #32: 32	قَوْلُ الْفُقَهَاءِ
u'قول فقهاء':Added, #32: 32	قَوْلُ الْفُقَهَاءِ
u'قَوْلٌ فقهاء':Added, #5: 5	قَوْلُ فُقَهَاءِ
u'قول فقهاء':Added, #5: 5	قَوْلُ فُقَهَاءِ
u'قَوْلٌ فقهاء':Added, #6: 6	قَوْلَ الْفُقَهَاءِ
u'قول فَقِيرٌ':Added, #6: 6	قَوْلَ الْفُقَهَاءِ
u'قَوْلٌ فَقِيرٌ':Added, #2: 2	قَوْلُ الْفَقِيرِ
u'قول فَقِيهٌ':Added, #2: 2	قَوْلُ الْفَقِيرِ
u'قَوْلٌ فَقِيهٌ':Added, #14: 14	قَوْلِ الْفَقِيهِ
u'قول فَقِيهٌ':Added, #14: 14	قَوْلِ الْفَقِيهِ
u'قَوْلٌ فَقِيهٌ':Added, #7: 7	قَوْلَ الْفَقِيهِ
u'قول فَقِيهٌ':Added, #7: 7	قَوْلَ الْفَقِيهِ
u'قَوْلٌ فَقِيهٌ':Added, #9: 9	قَوْلُ الْفَقِيهِ
u'قول فلان':Added, #9: 9	قَوْلُ الْفَقِيهِ
u'قَوْلٌ فلان':Added, #175: 175	قَوْلِ الشَّافِعِيِّ
u'قول فلان':Added, #175: 175	قَوْلِ الشَّافِعِيِّ
u'قَوْلٌ فلان':Added, #1: 1	قَوْلَ الْبُحْتُرِيِّ
u'قول فلان':Added, #1: 1	قَوْلَ الْبُحْتُرِيِّ
u'قَوْلٌ فلان':Added, #1: 1	قَوْلَ التِّرْمِذِيِّ
u'قول فلان':Added, #1: 1	قَوْلَ التِّرْمِذِيِّ
u'قَوْلٌ فلان':Added, #1: 1	قَوْلُ الْحَارِثِيِّ
u'قول فلان':Added, #1: 1	قَوْلُ الْحَارِثِيِّ
u'قَوْلٌ فلان':Added, #1: 1	قَوْلِ الْحَازِمِيِّ
u'قول فلان':Added, #1: 1	قَوْلِ الْحَازِمِيِّ
u'قَوْلٌ فلان':Added, #1: 1	قَوْلَ الْخَانِيَّةِ
u'قول فلان':Added, #1: 1	قَوْلَ الْخَانِيَّةِ
u'قَوْلٌ فلان':Added, #1: 1	قَوْلُ الرَّاغِبِ
u'قول فلان':Added, #1: 1	قَوْلُ الرَّاغِبِ
u'قَوْلٌ فلان':Added, #1: 1	قَوْل الزّبَيْرِ
u'قول فلان':Added, #1: 1	قَوْل الزّبَيْرِ
u'قَوْلٌ فلان':Added, #1: 1	قَوْلِ الزَّمَخْشَرِيِّ
u'قول فلان':Added, #1: 1	قَوْلِ الزَّمَخْشَرِيِّ
u'قَوْلٌ فلان':Added, #1: 1	قَوْلَ الزَّيْدِيَّةِ
u'قول فلان':Added, #1: 1	قَوْلَ الزَّيْدِيَّةِ
u'قَوْلٌ فلان':Added, #1: 1	قَوْلِ السُّلَيْمَانِيَّةِ
u'قول فلان':Added, #1: 1	قَوْلِ السُّلَيْمَانِيَّةِ
u'قَوْلٌ فلان':Added, #1: 1	قَوْلِ الشَّاذِلِيِّ
u'قول فلان':Added, #1: 1	قَوْلِ الشَّاذِلِيِّ
u'قَوْلٌ فلان':Added, #1: 1	قَوْلِ الطَّبَرِيِّ
u'قول فلان':Added, #1: 1	قَوْلِ الطَّبَرِيِّ
u'قول فلان':Added, #1: 1	قَوْلَ الظَّاهِرِيَّةِ
u'قَوْلٌ فلان':Added, #1: 1	قَوْلُ الظَّاهِرِيَّةِ
u'قَوْلٌ فلان':Added, #1: 1	قَوْلَ الظَّاهِرِيَّةِ
u'قول فلان':Added, #1: 1	قَوْلُ الظَّاهِرِيَّةِ
u'قَوْلٌ فلان':Added, #1: 1	قَوْلُ الْقَصَّابِ
u'قول فلان':Added, #1: 1	قَوْلُ الْقَصَّابِ
u'قَوْلٌ فلان':Added, #1: 1	قَوْلَ الْمِقْدَادِ
u'قول فلان':Added, #1: 1	قَوْلَ الْمِقْدَادِ
u'قول فلان':Added, #1: 1	قَوْلَ بِلَالٍ
u'قَوْلٌ فلان':Added, #1: 1	قَوْلِ بِلَالٍ
u'قَوْلٌ فلان':Added, #1: 1	قَوْلَ بِلَالٍ
u'قول فلان':Added, #1: 1	قَوْلِ بِلَالٍ
u'قَوْلٌ فلان':Added, #1: 1	قَوْلِ جُبَيْرِ
u'قول فلان':Added, #1: 1	قَوْلِ جُبَيْرِ
u'قَوْلٌ فلان':Added, #1: 1	قَوْلُ جَعْفَرِ
u'قول فلان':Added, #1: 1	قَوْلُ جَعْفَرِ
u'قَوْلٌ فلان':Added, #1: 1	قَوْلِ زُهَيْرٍ
u'قول فلان':Added, #1: 1	قَوْلِ زُهَيْرٍ
u'قَوْلٌ فلان':Added, #219: 219	قَوْلُ الشَّافِعِيِّ
u'قول فلان':Added, #219: 219	قَوْلُ الشَّافِعِيِّ
u'قَوْلٌ فلان':Added, #23: 23	قَوْلَ الشَّافِعِيِّ
u'قول فلان':Added, #23: 23	قَوْلَ الشَّافِعِيِّ
u'قول فلان':Added, #2: 2	قَوْلَ الْبَزَّازِيَّةِ
u'قَوْلٌ فلان':Added, #2: 2	قَوْلِ الْبَزَّازِيَّةِ
u'قَوْلٌ فلان':Added, #2: 2	قَوْلَ الْبَزَّازِيَّةِ
u'قول فلان':Added, #2: 2	قَوْلِ الْبَزَّازِيَّةِ
u'قَوْلٌ فلان':Added, #2: 2	قَوْلُ التِّرْمِذِيِّ
u'قول فلان':Added, #2: 2	قَوْلُ التِّرْمِذِيِّ
u'قَوْلٌ فلان':Added, #2: 2	قَوْلُ الدَّمِيرِيِّ
u'قول فلان':Added, #2: 2	قَوْلُ الدَّمِيرِيِّ
u'قَوْلٌ فلان':Added, #2: 2	قَوْلِ الرَّازِيِّ
u'قول فلان':Added, #2: 2	قَوْلِ الرَّازِيِّ
u'قَوْلٌ فلان':Added, #2: 2	قَوْلُ الزّبَيْرِ
u'قول فلان':Added, #2: 2	قَوْلُ الزّبَيْرِ
u'قَوْلٌ فلان':Added, #2: 2	قَوْلَ الشَّافِعِيَّةِ
u'قول فلان':Added, #2: 2	قَوْلَ الشَّافِعِيَّةِ
u'قَوْلٌ فلان':Added, #2: 2	قَوْلُ الْقُرْطُبِيِّ
u'قول فلان':Added, #2: 2	قَوْلُ الْقُرْطُبِيِّ
u'قَوْلٌ فلان':Added, #2: 2	قَوْلِ الْمُتَصَدِّقِ
u'قول فلان':Added, #2: 2	قَوْلِ الْمُتَصَدِّقِ
u'قَوْلٌ فلان':Added, #2: 2	قَوْلِ الْوَاصِفِ
u'قول فلان':Added, #2: 2	قَوْلِ الْوَاصِفِ
u'قَوْلٌ فلان':Added, #2: 2	قَوْلُ زُهَيْرٍ
u'قول فلان':Added, #2: 2	قَوْلُ زُهَيْرٍ
u'قَوْلٌ فلان':Added, #2: 2	قَوْلِ مَكْحُولٍ
u'قول فلان':Added, #2: 2	قَوْلِ مَكْحُولٍ
u'قَوْلٌ فلان':Added, #3: 3	قَوْلِ الْخَانِيَّةِ
u'قول فلان':Added, #3: 3	قَوْلِ الْخَانِيَّةِ
u'قَوْلٌ فلان':Added, #3: 3	قَوْلُ الطَّبَرِيِّ
u'قول فلان':Added, #3: 3	قَوْلُ الطَّبَرِيِّ
u'قَوْلٌ فلان':Added, #4: 4	قَوْلِ التَّمِيمِيِّ
u'قول فلان':Added, #4: 4	قَوْلِ التَّمِيمِيِّ
u'قَوْلٌ فلان':Added, #4: 4	قَوْلُ الْخَانِيَّةِ
u'قول فلان':Added, #4: 4	قَوْلُ الْخَانِيَّةِ
u'قَوْلٌ فلان':Added, #4: 4	قَوْلِ الدَّمِيرِيِّ
u'قول فلان':Added, #4: 4	قَوْلِ الدَّمِيرِيِّ
u'قَوْلٌ فلان':Added, #4: 4	قَوْلِ الزّبَيْرِ
u'قول فلان':Added, #4: 4	قَوْلِ الزّبَيْرِ
u'قَوْلٌ فلان':Added, #4: 4	قَوْلُ الْمُتَصَدِّقِ
u'قول فلان':Added, #4: 4	قَوْلُ الْمُتَصَدِّقِ
u'قَوْلٌ فلان':Added, #4: 4	قَوْلُ بِلَالٍ
u'قول فُلاَنٌ':Added, #4: 4	قَوْلُ بِلَالٍ
u'قول فُلاَنٌ':Added, #4: 4	قَوْلُ فُلَانٍ
u'قَوْلٌ فُلاَنٌ':Added, #4: 4	قَوْلِ فُلَانٍ
u'قَوْلٌ فُلاَنٌ':Added, #4: 4	قَوْلُ فُلَانٍ
u'قول فلان':Added, #4: 4	قَوْلِ فُلَانٍ
u'قَوْلٌ فلان':Added, #7: 7	قَوْلُ الشَّافِعِيَّةِ
u'قول فلان':Added, #7: 7	قَوْلُ الشَّافِعِيَّةِ
u'قَوْلٌ فلان':Added, #8: 8	قَوْلِ الشَّافِعِيَّةِ
u'قول قَابِضٌ':Added, #8: 8	قَوْلِ الشَّافِعِيَّةِ
u'قَوْلٌ قَابِضٌ':Added, #26: 26	قَوْلُ الْقَابِضِ
u'قول قَابِضٌ':Added, #26: 26	قَوْلُ الْقَابِضِ
u'قَوْلٌ قَابِضٌ':Added, #2: 2	قَوْلِ الْقَابِضِ
u'قول قَابِضٌ':Added, #2: 2	قَوْلِ الْقَابِضِ
u'قَوْلٌ قَابِضٌ':Added, #3: 3	قَوْلَ الْقَابِضِ
u'قول قَابِلٌ':Added, #3: 3	قَوْلَ الْقَابِضِ
u'قَوْلٌ قَابِلٌ':Added, #2: 2	قَوْلَ الْقَابِلَةِ
u'قول قَاتِلٌ':Added, #2: 2	قَوْلَ الْقَابِلَةِ
u'قَوْلٌ قَاتِلٌ':Added, #5: 5	قَوْلُ الْقَاتِلِ
u'قول قَاذِفٌ':Added, #5: 5	قَوْلُ الْقَاتِلِ
u'قَوْلٌ قَاذِفٌ':Added, #1: 1	قَوْلَ الْقَاذِفِ
u'قول قَاذِفٌ':Added, #1: 1	قَوْلَ الْقَاذِفِ
u'قَوْلٌ قَاذِفٌ':Added, #9: 9	قَوْلُ الْقَاذِفِ
u'قول قَارِئٌ':Added, #9: 9	قَوْلُ الْقَاذِفِ
u'قَوْلٌ قَارِئٌ':Added, #1: 1	قَوْلِ قَارِئِ
u'قول قَاسِمٌ':Added, #1: 1	قَوْلِ قَارِئِ
u'قَوْلٌ قَاسِمٌ':Added, #2: 2	قَوْلِ الْقَاسِمِ
u'قول قَاسِمٌ':Added, #2: 2	قَوْلِ الْقَاسِمِ
u'قَوْلٌ قَاسِمٌ':Added, #3: 3	قَوْلُ الْقَاسِمِ
u'قول قَاطِعٌ':Added, #3: 3	قَوْلُ الْقَاسِمِ
u'قَوْلٌ قَاطِعٌ':Added, #2: 2	قَوْلُ الْقَاطِعِ
u'قول قاف':Added, #2: 2	قَوْلُ الْقَاطِعِ
u'قَوْلٌ قاف':Added, #3: 3	قَوْلِ الْقَافَةِ
u'قول قَائِلٌ':Added, #3: 3	قَوْلِ الْقَافَةِ
u'قَوْلٌ قَائِلٌ':Added, #1: 1	قَوْلِ قَائِلَةٍ
u'قول قَائِلٌ':Added, #1: 1	قَوْلِ قَائِلَةٍ
u'قول قَائِلٌ':Added, #1: 1	قَوْلَ قَائِلِهِ
u'قَوْلٌ قَائِلٌ':Added, #1: 1	قَوْلِ قَائِلِهِ
u'قَوْلٌ قَائِلٌ':Added, #1: 1	قَوْلَ قَائِلِهِ
u'قول قَائِلٌ':Added, #1: 1	قَوْلِ قَائِلِهِ
u'قَوْلٌ قَائِلٌ':Added, #20: 20	قَوْلَ الْقَائِلِ
u'قول قَائِلٌ':Added, #20: 20	قَوْلَ الْقَائِلِ
u'قَوْلٌ قَائِلٌ':Added, #2: 2	قَوْلَ قَائِلٍ
u'قول قَائِلٌ':Added, #2: 2	قَوْلَ قَائِلٍ
u'قَوْلٌ قَائِلٌ':Added, #32: 32	قَوْلُ الْقَائِلِ
u'قول قَائِلٌ':Added, #32: 32	قَوْلُ الْقَائِلِ
u'قَوْلٌ قَائِلٌ':Added, #38: 38	قَوْلِ الْقَائِلِ
u'قول قَائِلَةٌ':Added, #38: 38	قَوْلِ الْقَائِلِ
u'قَوْلٌ قَائِلَةٌ':Added, #1: 1	قَوْلِ قَائِلَةٍ
u'قول قَتِيلٌ':Added, #1: 1	قَوْلِ قَائِلَةٍ
u'قَوْلٌ قَتِيلٌ':Added, #1: 1	قَوْلُ الْقَتِيلِ
u'قول قَدَرُ':Added, #1: 1	قَوْلُ الْقَتِيلِ
u'قول قَدَرُ':Added, #1: 1	قَوْلَ الْقَدَرِيَّةِ
u'قول قَدَر':Added, #1: 1	قَوْلُ الْقَدَرِيَّةِ
u'قول قَدَر':Added, #1: 1	قَوْلَ الْقَدَرِيَّةِ
u'قَوْلٌ قَدَرُ':Added, #1: 1	قَوْلُ الْقَدَرِيَّةِ
u'قَوْلٌ قَدَرُ':Added, #1: 1	قَوْلَ الْقَدَرِيَّةِ
u'قَوْلٌ قَدَر':Added, #1: 1	قَوْلُ الْقَدَرِيَّةِ
u'قَوْلٌ قَدَر':Added, #1: 1	قَوْلَ الْقَدَرِيَّةِ
u'قول قَدَرِيّ':Added, #1: 1	قَوْلُ الْقَدَرِيَّةِ
u'قول قَدَرِيّ':Added, #1: 1	قَوْلَ الْقَدَرِيَّةِ
u'قَوْلٌ قَدَرِيّ':Added, #1: 1	قَوْلُ الْقَدَرِيَّةِ
u'قَوْلٌ قَدَرِيّ':Added, #1: 1	قَوْلَ الْقَدَرِيَّةِ
u'قول قدماء':Added, #1: 1	قَوْلُ الْقَدَرِيَّةِ
u'قَوْلٌ قدماء':Added, #1: 1	قَوْلُ قُدَمَاءِ
u'قول قُرْطُبِيّ':Added, #1: 1	قَوْلُ قُدَمَاءِ
u'قَوْلٌ قُرْطُبِيّ':Added, #2: 2	قَوْلُ الْقُرْطُبِيِّ
u'قول قَرِيبٌ':Added, #2: 2	قَوْلُ الْقُرْطُبِيِّ
u'قَوْلٌ قَرِيبٌ':Added, #2: 2	قَوْلِ قَرِيبِ
u'قول قُرَيْشٌ':Added, #2: 2	قَوْلِ قَرِيبِ
u'قَوْلٌ قُرَيْشٌ':Added, #1: 1	قَوْلِ قُرَيْشٍ
u'قول قُرَيْشٌ':Added, #1: 1	قَوْلِ قُرَيْشٍ
u'قَوْلٌ قُرَيْشٌ':Added, #2: 2	قَوْلَ قُرَيْشٍ
u'قول قَصّاب':Added, #2: 2	قَوْلَ قُرَيْشٍ
u'قَوْلٌ قَصّاب':Added, #1: 1	قَوْلُ الْقَصَّابِ
u'قول قضاة':Added, #1: 1	قَوْلُ الْقَصَّابِ
u'قَوْلٌ قضاة':Added, #1: 1	قَوْلَ الْقُضَاةِ
u'قول قضاة':Added, #1: 1	قَوْلَ الْقُضَاةِ
u'قَوْلٌ قضاة':Added, #3: 3	قَوْلِ الْقُضَاةِ
u'قول قُطْبٌ':Added, #3: 3	قَوْلِ الْقُضَاةِ
u'قَوْلٌ قُطْبٌ':Added, #1: 1	قَوْلُ الْقُطْبِ
u'قول قَفَّالٌ':Added, #1: 1	قَوْلُ الْقُطْبِ
u'قَوْلٌ قَفَّالٌ':Added, #14: 14	قَوْلُ الْقَفَّالِ
u'قول قَفَّالٌ':Added, #14: 14	قَوْلُ الْقَفَّالِ
u'قَوْلٌ قَفَّالٌ':Added, #1: 1	قَوْلَ الْقَفَّالِ
u'قول قَفَّالٌ':Added, #1: 1	قَوْلَ الْقَفَّالِ
u'قَوْلٌ قَفَّالٌ':Added, #3: 3	قَوْل الْقَفَّالِ
u'قول قَفَّالٌ':Added, #3: 3	قَوْل الْقَفَّالِ
u'قَوْلٌ قَفَّالٌ':Added, #6: 6	قَوْلِ الْقَفَّالِ
u'قول قول':Added, #6: 6	قَوْلِ الْقَفَّالِ
u'قَوْلٌ قول':Added, #1: 1	قَوْلُ قَوْلِ
u'قول قَوْلٌ':Added, #1: 1	قَوْلُ قَوْلِ
u'قَوْلٌ قَوْلٌ':Added, #1: 1	قَوْلُ قَوْلِ
u'قول قَوْمٌ':Added, #1: 1	قَوْلُ قَوْلِ
u'قَوْلٌ قَوْمٌ':Added, #1: 1	قَوْلَ الْقَوْمِ
u'قول قَوْمٌ':Added, #1: 1	قَوْلَ الْقَوْمِ
u'قول قَوْمٌ':Added, #2: 2	قَوْلُ قَوْمٍ
u'قَوْلٌ قَوْمٌ':Added, #2: 2	قَوْلِ قَوْمِ
u'قَوْلٌ قَوْمٌ':Added, #2: 2	قَوْلُ قَوْمٍ
u'قول قَيِّمٌ':Added, #2: 2	قَوْلِ قَوْمِ
u'قَوْلٌ قَيِّمٌ':Added, #1: 1	قَوْلِ الْقَيِّمِ
u'قول قَيِّمٌ':Added, #1: 1	قَوْلِ الْقَيِّمِ
u'قَوْلٌ قَيِّمٌ':Added, #2: 2	قَوْلُ الْقَيِّمِ
u'قول كَاتِبٌ':Added, #2: 2	قَوْلُ الْقَيِّمِ
u'قَوْلٌ كَاتِبٌ':Added, #1: 1	قَوْلُ الْكَاتِبِ
u'قول كَاتِبٌ':Added, #1: 1	قَوْلُ الْكَاتِبِ
u'قَوْلٌ كَاتِبٌ':Added, #1: 1	قَوْلُ كَاتِبِ
u'قول كَاتِبٌ':Added, #1: 1	قَوْلُ كَاتِبِ
u'قَوْلٌ كَاتِبٌ':Added, #1: 1	قَوْلُ كَاتِبِهِ
u'قول كَاذِبٌ':Added, #1: 1	قَوْلُ كَاتِبِهِ
u'قَوْلٌ كَاذِبٌ':Added, #1: 1	قَوْلُ كَاذِبٍ
u'قول كَاشِحٌ':Added, #1: 1	قَوْلُ كَاذِبٍ
u'قَوْلٌ كَاشِحٌ':Added, #1: 1	قَوْلَ كَاشِحٍ
u'قول كَافٌّ':Added, #1: 1	قَوْلَ كَاشِحٍ
u'قَوْلٌ كَافٌّ':Added, #4: 4	قَوْلُ الْكَافَّةِ
u'قول كَافٌّ':Added, #4: 4	قَوْلُ الْكَافَّةِ
u'قَوْلٌ كَافٌّ':Added, #4: 4	قَوْلُ كَافَّةِ
u'قول كَافَّةٌ':Added, #4: 4	قَوْلُ كَافَّةِ
u'قَوْلٌ كَافَّةٌ':Added, #4: 4	قَوْلُ الْكَافَّةِ
u'قول كَافَّةٌ':Added, #4: 4	قَوْلُ الْكَافَّةِ
u'قَوْلٌ كَافَّةٌ':Added, #4: 4	قَوْلُ كَافَّةِ
u'قول كَافِرٌ':Added, #4: 4	قَوْلُ كَافَّةِ
u'قَوْلٌ كَافِرٌ':Added, #1: 1	قَوْلَ الْكَافِرِ
u'قول كَافِرٌ':Added, #1: 1	قَوْلَ الْكَافِرِ
u'قَوْلٌ كَافِرٌ':Added, #2: 2	قَوْلُ كَافِرَةٍ
u'قول كَافِرٌ':Added, #2: 2	قَوْلُ كَافِرَةٍ
u'قَوْلٌ كَافِرٌ':Added, #3: 3	قَوْلِ الْكَافِرِ
u'قول كَافِرٌ':Added, #3: 3	قَوْلِ الْكَافِرِ
u'قَوْلٌ كَافِرٌ':Added, #6: 6	قَوْلُ الْكَافِرِ
u'قول كَبِيرٌ':Added, #6: 6	قَوْلُ الْكَافِرِ
u'قَوْلٌ كَبِيرٌ':Added, #1: 1	قَوْلُ الْكَبِيرَةِ
u'قول كَثِيرٌ':Added, #1: 1	قَوْلُ الْكَبِيرَةِ
u'قَوْلٌ كَثِيرٌ':Added, #1: 1	قَوْلُ الْكَثِيرِ
u'قول كَرِيٌّ':Added, #1: 1	قَوْلُ الْكَثِيرِ
u'قَوْلٌ كَرِيٌّ':Added, #2: 2	قَوْلُ الْكَرِيِّ
u'قول كَعْبٌ':Added, #2: 2	قَوْلُ الْكَرِيِّ
u'قول كَعْبٌ':Added, #1: 1	قَوْل كَعْبٍ
u'قول كَعْبٌ':Added, #1: 1	قَوْلَ كَعْبٍ
u'قول كَعْبٌ':Added, #1: 1	قَوْلُ كَعْبِ
u'قَوْلٌ كَعْبٌ':Added, #1: 1	قَوْلِ كَعْبِ
u'قَوْلٌ كَعْبٌ':Added, #1: 1	قَوْل كَعْبٍ
u'قَوْلٌ كَعْبٌ':Added, #1: 1	قَوْلَ كَعْبٍ
u'قَوْلٌ كَعْبٌ':Added, #1: 1	قَوْلُ كَعْبِ
u'قول كَعْبٌ':Added, #1: 1	قَوْلِ كَعْبِ
u'قَوْلٌ كَعْبٌ':Added, #3: 3	قَوْلِ كَعْبٍ
u'قول كُفَّارٌ':Added, #3: 3	قَوْلِ كَعْبٍ
u'قول كُفَّارٌ':Added, #1: 1	قَوْلُ الْكُفَّارِ
u'قَوْلٌ كُفَّارٌ':Added, #1: 1	قَوْلِ الْكُفَّارِ
u'قَوْلٌ كُفَّارٌ':Added, #1: 1	قَوْلُ الْكُفَّارِ
u'قول كِفَايَةٌ':Added, #1: 1	قَوْلِ الْكُفَّارِ
u'قَوْلٌ كِفَايَةٌ':Added, #3: 3	قَوْلُ الْكِفَايَةِ
u'قول كَفَرَةٌ':Added, #3: 3	قَوْلُ الْكِفَايَةِ
u'قول كَفَرَةٌ':Added, #1: 1	قَوْلُ الْكَفَرَةِ
u'قَوْلٌ كَفَرَةٌ':Added, #1: 1	قَوْلِ الْكَفَرَةِ
u'قَوْلٌ كَفَرَةٌ':Added, #1: 1	قَوْلُ الْكَفَرَةِ
u'قول كَفِيلٌ':Added, #1: 1	قَوْلِ الْكَفَرَةِ
u'قَوْلٌ كَفِيلٌ':Added, #10: 10	قَوْلُ الْكَفِيلِ
u'قول كَفِيلٌ':Added, #10: 10	قَوْلُ الْكَفِيلِ
u'قَوْلٌ كَفِيلٌ':Added, #1: 1	قَوْلِ الْكَفِيلِ
u'قول كَفِيلٌ':Added, #1: 1	قَوْلِ الْكَفِيلِ
u'قَوْلٌ كَفِيلٌ':Added, #5: 5	قَوْلَ الْكَفِيلِ
u'قول كَمَالٌ':Added, #5: 5	قَوْلَ الْكَفِيلِ
u'قَوْلٌ كَمَالٌ':Added, #1: 1	قَوْلِ الْكَمَالِ
u'قول كَمَالٌ':Added, #1: 1	قَوْلِ الْكَمَالِ
u'قَوْلٌ كَمَالٌ':Added, #2: 2	قَوْلُ الْكَمَالِ
u'قول كُمَيْتٌ':Added, #2: 2	قَوْلُ الْكَمَالِ
u'قَوْلٌ كُمَيْتٌ':Added, #1: 1	قَوْلَ الْكُمَيْتِ
u'قول كُمَيْتٌ':Added, #1: 1	قَوْلَ الْكُمَيْتِ
u'قَوْلٌ كُمَيْتٌ':Added, #2: 2	قَوْلُ الْكُمَيْتِ
u'قول كَنْزٌ':Added, #2: 2	قَوْلُ الْكُمَيْتِ
u'قَوْلٌ كَنْزٌ':Added, #2: 2	قَوْلُ الْكَنْزِ
u'قول كَهَنَةٌ':Added, #2: 2	قَوْلُ الْكَنْزِ
u'قَوْلٌ كَهَنَةٌ':Added, #1: 1	قَوْلُ الْكَهَنَةِ
u'قول كَهَنَةٌ':Added, #1: 1	قَوْلُ الْكَهَنَةِ
u'قَوْلٌ كَهَنَةٌ':Added, #2: 2	قَوْلَ الْكَهَنَةِ
u'قول لُبَابٌ':Added, #2: 2	قَوْلَ الْكَهَنَةِ
u'قَوْلٌ لُبَابٌ':Added, #1: 1	قَوْلِ اللُّبَابِ
u'قول لَقِيطٌ':Added, #1: 1	قَوْلِ اللُّبَابِ
u'قَوْلٌ لَقِيطٌ':Added, #2: 2	قَوْلُ اللَّقِيطِ
u'قول لَيْثٌ':Added, #2: 2	قَوْلُ اللَّقِيطِ
u'قول لَيْثٌ':Added, #1: 1	قَوْلُ اللّيْثِ
u'قَوْلٌ لَيْثٌ':Added, #1: 1	قَوْلِ اللَّيْثِ
u'قَوْلٌ لَيْثٌ':Added, #1: 1	قَوْلُ اللّيْثِ
u'قول لَيْثٌ':Added, #1: 1	قَوْلِ اللَّيْثِ
u'قَوْلٌ لَيْثٌ':Added, #2: 2	قَوْلُ اللَّيْثِ
u'قول مَاعِزٌ':Added, #2: 2	قَوْلُ اللَّيْثِ
u'قَوْلٌ مَاعِزٌ':Added, #1: 1	قَوْلِ مَاعِزٍ
u'قول مَالِكٌ':Added, #1: 1	قَوْلِ مَاعِزٍ
u'قَوْلٌ مَالِكٌ':Added, #1: 1	قَوْلِ الْمَالِكِ
u'قول مَالِكٌ':Added, #1: 1	قَوْلِ الْمَالِكِ
u'قَوْلٌ مَالِكٌ':Added, #1: 1	قَوْلِ مَالِكِ
u'قول مَالِكٌ':Added, #1: 1	قَوْلِ مَالِكِ
u'قَوْلٌ مَالِكٌ':Added, #265: 265	قَوْلِ مَالِكٍ
u'قول مَالِكٌ':Added, #265: 265	قَوْلِ مَالِكٍ
u'قَوْلٌ مَالِكٌ':Added, #282: 282	قَوْلُ مَالِكٍ
u'قول مَالِكٌ':Added, #282: 282	قَوْلُ مَالِكٍ
u'قَوْلٌ مَالِكٌ':Added, #2: 2	قَوْلَ الْمَالِكِ
u'قول مَالِكٌ':Added, #2: 2	قَوْلَ الْمَالِكِ
u'قَوْلٌ مَالِكٌ':Added, #33: 33	قَوْلُ الْمَالِكِ
u'قول مَالِكٌ':Added, #33: 33	قَوْلُ الْمَالِكِ
u'قَوْلٌ مَالِكٌ':Added, #35: 35	قَوْلَ مَالِكٍ
u'قول مَالِكٌ':Added, #35: 35	قَوْلَ مَالِكٍ
u'قَوْلٌ مَالِكٌ':Added, #4: 4	قَوْلُ مَالِكِ
u'قول مَأْمُورٌ':Added, #4: 4	قَوْلُ مَالِكِ
u'قَوْلٌ مَأْمُورٌ':Added, #11: 11	قَوْلُ الْمَأْمُورِ
u'قول مَأْمُورٌ':Added, #11: 11	قَوْلُ الْمَأْمُورِ
u'قَوْلٌ مَأْمُورٌ':Added, #1: 1	قَوْلُ مَأْمُورِهِ
u'قول مَأْمُورٌ':Added, #1: 1	قَوْلُ مَأْمُورِهِ
u'قول مَأْمُورٌ':Added, #2: 2	قَوْلَ الْمَأْمُورِ
u'قَوْلٌ مَأْمُورٌ':Added, #2: 2	قَوْلِ الْمَأْمُورِ
u'قَوْلٌ مَأْمُورٌ':Added, #2: 2	قَوْلَ الْمَأْمُورِ
u'قول مَانِعٌ':Added, #2: 2	قَوْلِ الْمَأْمُورِ
u'قَوْلٌ مَانِعٌ':Added, #1: 1	قَوْلِ الْمَانِعِ
u'قول مَانِعٌ':Added, #1: 1	قَوْلِ الْمَانِعِ
u'قَوْلٌ مَانِعٌ':Added, #2: 2	قَوْلَ الْمَانِعِ
u'قول مُبْتاع':Added, #2: 2	قَوْلَ الْمَانِعِ
u'قَوْلٌ مُبْتاع':Added, #1: 1	قَوْلَ الْمُبْتَاعِ
u'قول مُبْتاع':Added, #1: 1	قَوْلَ الْمُبْتَاعِ
u'قَوْلٌ مُبْتاع':Added, #6: 6	قَوْلُ الْمُبْتَاعِ
u'قول مبرَّد':Added, #6: 6	قَوْلُ الْمُبْتَاعِ
u'قَوْلٌ مبرَّد':Added, #1: 1	قَوْلُ الْمُبَرّدِ
u'قول مُبَرَّدٌ':Added, #1: 1	قَوْلُ الْمُبَرّدِ
u'قول مُبَرِّدٌ':Added, #1: 1	قَوْلُ الْمُبَرّدِ
u'قَوْلٌ مُبَرَّدٌ':Added, #1: 1	قَوْلُ الْمُبَرّدِ
u'قَوْلٌ مُبَرِّدٌ':Added, #1: 1	قَوْلُ الْمُبَرّدِ
u'قول مُبَرِّدٌ':Added, #1: 1	قَوْلُ الْمُبَرّدِ
u'قَوْلٌ مُبَرِّدٌ':Added, #4: 4	قَوْلُ الْمُبَرِّدِ
u'قول مُبْرِقٌ':Added, #4: 4	قَوْلُ الْمُبَرِّدِ
u'قَوْلٌ مُبْرِقٌ':Added, #1: 1	قَوْلُ الْمُبْرِقِ
u'قول مَبْسُوطٌ':Added, #1: 1	قَوْلُ الْمُبْرِقِ
u'قَوْلٌ مَبْسُوطٌ':Added, #1: 1	قَوْلُ الْمَبْسُوطَيْنِ
u'قول مَبْسُوطٌ':Added, #1: 1	قَوْلُ الْمَبْسُوطَيْنِ
u'قَوْلٌ مَبْسُوطٌ':Added, #3: 3	قَوْلِ الْمَبْسُوطِ
u'قول مَبْعُوثٌ':Added, #3: 3	قَوْلِ الْمَبْسُوطِ
u'قَوْلٌ مَبْعُوثٌ':Added, #2: 2	قَوْلُ الْمَبْعُوثِ
u'قول مُبِيحٌ':Added, #2: 2	قَوْلُ الْمَبْعُوثِ
u'قَوْلٌ مُبِيحٌ':Added, #1: 1	قَوْلَ الْمُبِيحِ
u'قول مُتَصَدِّق':Added, #1: 1	قَوْلَ الْمُبِيحِ
u'قَوْلٌ مُتَصَدِّق':Added, #2: 2	قَوْلِ الْمُتَصَدِّقِ
u'قول مُتَصَدِّق':Added, #2: 2	قَوْلِ الْمُتَصَدِّقِ
u'قَوْلٌ مُتَصَدِّق':Added, #4: 4	قَوْلُ الْمُتَصَدِّقِ
u'قول مُتَعَاقِدٌ':Added, #4: 4	قَوْلُ الْمُتَصَدِّقِ
u'قول مُتَعَاقِدٌ':Added, #1: 1	قَوْلَ الْمُتَعَاقِدَيْنِ
u'قَوْلٌ مُتَعَاقِدٌ':Added, #1: 1	قَوْلِ الْمُتَعَاقِدَيْنِ
u'قَوْلٌ مُتَعَاقِدٌ':Added, #1: 1	قَوْلَ الْمُتَعَاقِدَيْنِ
u'قَوْلٌ مُتَعَلِّقٌ':Added, #1: 1	قَوْلِ الْمُتَعَاقِدَيْنِ
u'قول مُتَكَلِّمٌ':Added, #1: 1	قَوْلٍ مُتَعَلِّقٍ
u'قَوْلٌ مُتَكَلِّمٌ':Added, #1: 1	قَوْلِ الْمُتَكَلِّمِ
u'قول مُتَلَمِّسٌ':Added, #1: 1	قَوْلِ الْمُتَكَلِّمِ
u'قَوْلٌ مُتَلَمِّسٌ':Added, #1: 1	قَوْلُ الْمُتَلَمِّسِ
u'قول مُتَمَسِّك':Added, #1: 1	قَوْلُ الْمُتَلَمِّسِ
u'قول مُتَمَسِّك':Added, #1: 1	قَوْلَ الْمُتَمَسِّكِ
u'قَوْلٌ مُتَمَسِّك':Added, #1: 1	قَوْلُ الْمُتَمَسِّكِ
u'قَوْلٌ مُتَمَسِّك':Added, #1: 1	قَوْلَ الْمُتَمَسِّكِ
u'قول مَتْنٌ':Added, #1: 1	قَوْلُ الْمُتَمَسِّكِ
u'قَوْلٌ مَتْنٌ':Added, #3: 3	قَوْلَ الْمَتْنِ
u'قول مَتْنٌ':Added, #3: 3	قَوْلَ الْمَتْنِ
u'قَوْلٌ مَتْنٌ':Added, #69: 69	قَوْلِ الْمَتْنِ
u'قول مَتْنٌ':Added, #69: 69	قَوْلِ الْمَتْنِ
u'قَوْلٌ مَتْنٌ':Added, #7: 7	قَوْلُ الْمَتْنِ
u'قول مثل':Added, #7: 7	قَوْلُ الْمَتْنِ
u'قَوْلٌ مثل':Added, #1: 1	قَوْلِ مِثْلِهِ
u'قول مِثْلٌ':Added, #1: 1	قَوْلِ مِثْلِهِ
u'قَوْلٌ مِثْلٌ':Added, #1: 1	قَوْلِ مِثْلِهِ
u'قول مَجَازٌ':Added, #1: 1	قَوْلِ مِثْلِهِ
u'قَوْلٌ مَجَازٌ':Added, #1: 1	قَوْلِ الْمَجَازِ
u'قول مُجَاهِدٌ':Added, #1: 1	قَوْلِ الْمَجَازِ
u'قَوْلٌ مُجَاهِدٌ':Added, #25: 25	قَوْلُ مُجَاهِدٍ
u'قول مُجَاهِدٌ':Added, #25: 25	قَوْلُ مُجَاهِدٍ
u'قَوْلٌ مُجَاهِدٌ':Added, #3: 3	قَوْلَ مُجَاهِدٍ
u'قول مُجَاهِدٌ':Added, #3: 3	قَوْلَ مُجَاهِدٍ
u'قَوْلٌ مُجَاهِدٌ':Added, #7: 7	قَوْلِ مُجَاهِدٍ
u'قول مُجْتَهِد':Added, #7: 7	قَوْلِ مُجَاهِدٍ
u'قول مُجْتَهِد':Added, #1: 1	قَوْلُ مُجْتَهِدَيْنِ
u'قَوْلٌ مُجْتَهِد':Added, #1: 1	قَوْلِ مُجْتَهِدَيْنِ
u'قَوْلٌ مُجْتَهِد':Added, #1: 1	قَوْلُ مُجْتَهِدَيْنِ
u'قول مُجْتَهِد':Added, #1: 1	قَوْلِ مُجْتَهِدَيْنِ
u'قَوْلٌ مُجْتَهِد':Added, #2: 2	قَوْلِ الْمُجْتَهِدِ
u'قول مُجْتَهِد':Added, #2: 2	قَوْلِ الْمُجْتَهِدِ
u'قَوْلٌ مُجْتَهِد':Added, #2: 2	قَوْلِ مُجْتَهِدٍ
u'قول مُجْتَهِد':Added, #2: 2	قَوْلِ مُجْتَهِدٍ
u'قَوْلٌ مُجْتَهِد':Added, #3: 3	قَوْلَ الْمُجْتَهِدِ
u'قول مُجْتَهِد':Added, #3: 3	قَوْلَ الْمُجْتَهِدِ
u'قَوْلٌ مُجْتَهِد':Added, #4: 4	قَوْلُ الْمُجْتَهِدِ
u'قول مُجْتَهِد':Added, #4: 4	قَوْلُ الْمُجْتَهِدِ
u'قَوْلٌ مُجْتَهِد':Added, #6: 6	قَوْلَ مُجْتَهِدٍ
u'قول مَجْدٌ':Added, #6: 6	قَوْلَ مُجْتَهِدٍ
u'قَوْلٌ مَجْدٌ':Added, #3: 3	قَوْلُ الْمَجْدِ
u'قول مَجْدٌ':Added, #3: 3	قَوْلُ الْمَجْدِ
u'قَوْلٌ مَجْدٌ':Added, #4: 4	قَوْلِ الْمَجْدِ
u'قول مَجْرُوحٌ':Added, #4: 4	قَوْلِ الْمَجْدِ
u'قَوْلٌ مَجْرُوحٌ':Added, #1: 1	قَوْلُ الْمَجْرُوحِ
u'قول مَجْمَعٌ':Added, #1: 1	قَوْلُ الْمَجْرُوحِ
u'قَوْلٌ مَجْمَعٌ':Added, #2: 2	قَوْلُ الْمَجْمَعِ
u'قول مَجْمُوعٌ':Added, #2: 2	قَوْلُ الْمَجْمَعِ
u'قَوْلٌ مَجْمُوعٌ':Added, #11: 11	قَوْلِ الْمَجْمُوعِ
u'قول مَجْمُوعٌ':Added, #11: 11	قَوْلِ الْمَجْمُوعِ
u'قَوْلٌ مَجْمُوعٌ':Added, #1: 1	قَوْل الْمَجْمُوعِ
u'قول مَجْمُوعٌ':Added, #1: 1	قَوْل الْمَجْمُوعِ
u'قَوْلٌ مَجْمُوعٌ':Added, #21: 21	قَوْلُ الْمَجْمُوعِ
u'قول مَجْمُوعٌ':Added, #21: 21	قَوْلُ الْمَجْمُوعِ
u'قَوْلٌ مَجْمُوعٌ':Added, #5: 5	قَوْلَ الْمَجْمُوعِ
u'قول مَجْنُونٌ':Added, #5: 5	قَوْلَ الْمَجْمُوعِ
u'قَوْلٌ مَجْنُونٌ':Added, #1: 1	قَوْلَ الْمَجْنُونِ
u'قول مَجْنِيٌّ':Added, #1: 1	قَوْلَ الْمَجْنُونِ
u'قَوْلٌ مَجْنِيٌّ':Added, #1: 1	قَوْلُ مَجْنِيٍّ
u'قول مَجْنِيٌّ':Added, #1: 1	قَوْلُ مَجْنِيٍّ
u'قَوْلٌ مَجْنِيٌّ':Added, #2: 2	قَوْلُ الْمَجْنِيِّ
u'قول مَجُوسِيٌّ':Added, #2: 2	قَوْلُ الْمَجْنِيِّ
u'قَوْلٌ مَجُوسِيٌّ':Added, #1: 1	قَوْلُ الْمَجُوسِيِّ
u'قول مُجِيزٌ':Added, #1: 1	قَوْلُ الْمَجُوسِيِّ
u'قَوْلٌ مُجِيزٌ':Added, #1: 1	قَوْلِ مُجِيزِ
u'قول مُحْتَالٌ':Added, #1: 1	قَوْلِ مُجِيزِ
u'قَوْلٌ مُحْتَالٌ':Added, #5: 5	قَوْلُ الْمُحْتَالِ
u'قول مَحْجُورٌ':Added, #5: 5	قَوْلُ الْمُحْتَالِ
u'قَوْلٌ مَحْجُورٌ':Added, #1: 1	قَوْلَ الْمَحْجُورِ
u'قول مَحْجُورٌ':Added, #1: 1	قَوْلَ الْمَحْجُورِ
u'قَوْلٌ مَحْجُورٌ':Added, #3: 3	قَوْلُ الْمَحْجُورِ
u'قول مُحَدِّثٌ':Added, #3: 3	قَوْلُ الْمَحْجُورِ
u'قَوْلٌ مُحَدِّثٌ':Added, #2: 2	قَوْلَ الْمُحَدِّثِ
u'قول مُحَرِّرٌ':Added, #2: 2	قَوْلَ الْمُحَدِّثِ
u'قَوْلٌ مُحَرِّرٌ':Added, #1: 1	قَوْلِ الْمُحَرِّرِ
u'قول مُحَرَّرٌ':Added, #1: 1	قَوْلِ الْمُحَرِّرِ
u'قول مُحَرَّرٌ':Added, #3: 3	قَوْلُ الْمُحَرَّرِ
u'قَوْلٌ مُحَرَّرٌ':Added, #3: 3	قَوْلِ الْمُحَرَّرِ
u'قَوْلٌ مُحَرَّرٌ':Added, #3: 3	قَوْلُ الْمُحَرَّرِ
u'قَوْلٌ مُحَرَّمٌ':Added, #3: 3	قَوْلِ الْمُحَرَّرِ
u'قول مَحْصُولٌ':Added, #1: 1	قَوْلٍ مُحَرَّمٍ
u'قَوْلٌ مَحْصُولٌ':Added, #2: 2	قَوْلِ الْمَحْصُولِ
u'قول مُحَقِّقٌ':Added, #2: 2	قَوْلِ الْمَحْصُولِ
u'قَوْلٌ مُحَقِّقٌ':Added, #1: 1	قَوْلِ الْمُحَقِّقِ
u'قول مُحَقِّقٌ':Added, #1: 1	قَوْلِ الْمُحَقِّقِ
u'قول مُحَقِّقٌ':Added, #3: 3	قَوْلَ الْمُحَقِّقِ
u'قَوْلٌ مُحَقِّقٌ':Added, #3: 3	قَوْلُ الْمُحَقِّقِ
u'قَوْلٌ مُحَقِّقٌ':Added, #3: 3	قَوْلَ الْمُحَقِّقِ
u'قول مُحَمَّدٌ':Added, #3: 3	قَوْلُ الْمُحَقِّقِ
u'قَوْلٌ مُحَمَّدٌ':Added, #101: 101	قَوْلَ مُحَمَّدٍ
u'قول مُحَمَّدٌ':Added, #101: 101	قَوْلَ مُحَمَّدٍ
u'قَوْلٌ مُحَمَّدٌ':Added, #19: 19	قَوْلِ مُحَمَّدِ
u'قول مُحَمَّدٌ':Added, #19: 19	قَوْلِ مُحَمَّدِ
u'قول مُحَمَّدٌ':Added, #1: 1	قَوْل مُحَمَّدٍ
u'قول مُحَمَّدٌ':Added, #1: 1	قَوْلَ مُحَمَّدِ
u'قَوْلٌ مُحَمَّدٌ':Added, #1: 1	قَوْلُ مُحَمّدِ
u'قَوْلٌ مُحَمَّدٌ':Added, #1: 1	قَوْل مُحَمَّدٍ
u'قَوْلٌ مُحَمَّدٌ':Added, #1: 1	قَوْلَ مُحَمَّدِ
u'قول مُحَمَّدٌ':Added, #1: 1	قَوْلُ مُحَمّدِ
u'قَوْلٌ مُحَمَّدٌ':Added, #21: 21	قَوْلُ مُحَمَّدِ
u'قول مُحَمَّدٌ':Added, #21: 21	قَوْلُ مُحَمَّدِ
u'قَوْلٌ مُحَمَّدٌ':Added, #392: 392	قَوْلُ مُحَمَّدٍ
u'قول مُحَمَّدٌ':Added, #392: 392	قَوْلُ مُحَمَّدٍ
u'قَوْلٌ مُحَمَّدٌ':Added, #618: 618	قَوْلِ مُحَمَّدٍ
u'قول مُحِيطٌ':Added, #618: 618	قَوْلِ مُحَمَّدٍ
u'قَوْلٌ مُحِيطٌ':Added, #2: 2	قَوْلُ الْمُحِيطِ
u'قول مُحِيطٌ':Added, #2: 2	قَوْلُ الْمُحِيطِ
u'قَوْلٌ مُحِيطٌ':Added, #3: 3	قَوْلِ الْمُحِيطِ
u'قول مُحِيل':Added, #3: 3	قَوْلِ الْمُحِيطِ
u'قَوْلٌ مُحِيل':Added, #10: 10	قَوْلُ الْمُحِيلِ
u'قول مُحِيل':Added, #10: 10	قَوْلُ الْمُحِيلِ
u'قَوْلٌ مُحِيل':Added, #1: 1	قَوْلَ الْمُحِيلِ
u'قول مُخَالِفٌ':Added, #1: 1	قَوْلَ الْمُحِيلِ
u'قول مُخَالِفٌ':Added, #4: 4	قَوْلَ الْمُخَالِفِ
u'قَوْلٌ مُخَالِفٌ':Added, #4: 4	قَوْلُ الْمُخَالِفِ
u'قَوْلٌ مُخَالِفٌ':Added, #4: 4	قَوْلَ الْمُخَالِفِ
u'قول مُخَالِفٌ':Added, #4: 4	قَوْلُ الْمُخَالِفِ
u'قَوْلٌ مُخَالِفٌ':Added, #9: 9	قَوْلِ الْمُخَالِفِ
u'قول مُخْبِرٌ':Added, #9: 9	قَوْلِ الْمُخَالِفِ
u'قَوْلٌ مُخْبِرٌ':Added, #1: 1	قَوْلَ الْمُخْبِرِ
u'قول مُخْبِرٌ':Added, #1: 1	قَوْلَ الْمُخْبِرِ
u'قَوْلٌ مُخْبِرٌ':Added, #2: 2	قَوْلِ الْمُخْبِرِ
u'قول مُخْتَصّ':Added, #2: 2	قَوْلِ الْمُخْبِرِ
u'قَوْلٌ مُخْتَصّ':Added, #1: 1	قَوْلِ مُخْتَصٍّ
u'قول مُخْتَلِفٌ':Added, #1: 1	قَوْلِ مُخْتَصٍّ
u'قَوْلٌ مُخْتَلِفٌ':Added, #1: 1	قَوْلُ مُخْتَلِفٍ
u'قول مُخْرِجٌ':Added, #1: 1	قَوْلُ مُخْتَلِفٍ
u'قَوْلٌ مُخْرِجٌ':Added, #1: 1	قَوْلَ الْمُخْرِجِ
u'قَوْلٌ مُخْرِجٌ':Added, #1: 1	قَوْلَ الْمُخْرِجِ
u'قول مُخْرِجٌ':Added, #1: 1	قَوْلٍ مُخْرِجٍ
u'قَوْلٌ مُخْرِجٌ':Added, #2: 2	قَوْلُ الْمُخْرِجِ
u'قول مُدَبَّرٌ':Added, #2: 2	قَوْلُ الْمُخْرِجِ
u'قَوْلٌ مُدَبَّرٌ':Added, #1: 1	قَوْلِ الْمُدَبَّرِ
u'قول مُدَرِّسٌ':Added, #1: 1	قَوْلِ الْمُدَبَّرِ
u'قَوْلٌ مُدَرِّسٌ':Added, #2: 2	قَوْلُ الْمُدَرِّسِ
u'قول مُدَّعِي':Added, #2: 2	قَوْلُ الْمُدَرِّسِ
u'قَوْلٌ مُدَّعِي':Added, #1: 1	قَوْلِ مُدَّعِيهِ
u'قول مُدَّعِي':Added, #1: 1	قَوْلِ مُدَّعِيهِ
u'قَوْلٌ مُدَّعِي':Added, #2: 2	قَوْلُ مُدَّعِيَةِ
u'قول مُدَّعِي':Added, #2: 2	قَوْلُ مُدَّعِيَةِ
u'قَوْلٌ مُدَّعِي':Added, #3: 3	قَوْلُ مُدَّعِيهِ
u'قول مَدْفُوعٌ':Added, #3: 3	قَوْلُ مُدَّعِيهِ
u'قول مَدْفُوعٌ':Added, #2: 2	قَوْلَ الْمَدْفُوعِ
u'قَوْلٌ مَدْفُوعٌ':Added, #2: 2	قَوْلُ الْمَدْفُوعِ
u'قَوْلٌ مَدْفُوعٌ':Added, #2: 2	قَوْلَ الْمَدْفُوعِ
u'قول مُدَوَّنٌ':Added, #2: 2	قَوْلُ الْمَدْفُوعِ
u'قَوْلٌ مُدَوَّنٌ':Added, #12: 12	قَوْلَ الْمُدَوَّنَةِ
u'قول مُدَوَّنٌ':Added, #12: 12	قَوْلَ الْمُدَوَّنَةِ
u'قَوْلٌ مُدَوَّنٌ':Added, #21: 21	قَوْلِ الْمُدَوَّنَةِ
u'قول مُدَوَّنٌ':Added, #21: 21	قَوْلِ الْمُدَوَّنَةِ
u'قَوْلٌ مُدَوَّنٌ':Added, #38: 38	قَوْلُ الْمُدَوَّنَةِ
u'قول مُدَوَّنَةٌ':Added, #38: 38	قَوْلُ الْمُدَوَّنَةِ
u'قَوْلٌ مُدَوَّنَةٌ':Added, #12: 12	قَوْلَ الْمُدَوَّنَةِ
u'قول مُدَوَّنَةٌ':Added, #12: 12	قَوْلَ الْمُدَوَّنَةِ
u'قَوْلٌ مُدَوَّنَةٌ':Added, #21: 21	قَوْلِ الْمُدَوَّنَةِ
u'قول مُدَوَّنَةٌ':Added, #21: 21	قَوْلِ الْمُدَوَّنَةِ
u'قَوْلٌ مُدَوَّنَةٌ':Added, #38: 38	قَوْلُ الْمُدَوَّنَةِ
u'قول مَدِينٌ':Added, #38: 38	قَوْلُ الْمُدَوَّنَةِ
u'قَوْلٌ مَدِينٌ':Added, #1: 1	قَوْلُ الْمَدِينِ
u'قول مَدْيُونٌ':Added, #1: 1	قَوْلُ الْمَدِينِ
u'قَوْلٌ مَدْيُونٌ':Added, #1: 1	قَوْلِ الْمَدْيُونِ
u'قول مَدْيُونٌ':Added, #1: 1	قَوْلِ الْمَدْيُونِ
u'قَوْلٌ مَدْيُونٌ':Added, #4: 4	قَوْلَ الْمَدْيُونِ
u'قول مَدْيُونٌ':Added, #4: 4	قَوْلَ الْمَدْيُونِ
u'قَوْلٌ مَدْيُونٌ':Added, #5: 5	قَوْلُ الْمَدْيُونِ
u'قول مُرْتَهِنٌ':Added, #5: 5	قَوْلُ الْمَدْيُونِ
u'قَوْلٌ مُرْتَهِنٌ':Added, #1: 1	قَوْلِ الْمُرْتَهِنِ
u'قول مُرْتَهِنٌ':Added, #1: 1	قَوْلِ الْمُرْتَهِنِ
u'قَوْلٌ مُرْتَهِنٌ':Added, #30: 30	قَوْلُ الْمُرْتَهِنِ
u'قول مُرْتَهِنٌ':Added, #30: 30	قَوْلُ الْمُرْتَهِنِ
u'قَوْلٌ مُرْتَهِنٌ':Added, #5: 5	قَوْلَ الْمُرْتَهِنِ
u'قول مَرْجُوعٌ':Added, #5: 5	قَوْلَ الْمُرْتَهِنِ
u'قَوْلٌ مَرْجُوعٌ':Added, #2: 2	قَوْلُ الْمَرْجُوعِ
u'قول مُرْجِئَةٌ':Added, #2: 2	قَوْلُ الْمَرْجُوعِ
u'قول مُرْجِئَةٌ':Added, #1: 1	قَوْلَ الْمُرْجِئَةِ
u'قَوْلٌ مُرْجِئَةٌ':Added, #1: 1	قَوْلُ الْمُرْجِئَةِ
u'قَوْلٌ مُرْجِئَةٌ':Added, #1: 1	قَوْلَ الْمُرْجِئَةِ
u'قول مَرْدُودٌ':Added, #1: 1	قَوْلُ الْمُرْجِئَةِ
u'قَوْلٌ مَرْدُودٌ':Added, #1: 1	قَوْلَ الْمَرْدُودِ
u'قول مُرْسِلٌ':Added, #1: 1	قَوْلَ الْمَرْدُودِ
u'قَوْلٌ مُرْسِلٌ':Added, #1: 1	قَوْلُ الْمُرْسِلِ
u'قول مُرْضِعٌ':Added, #1: 1	قَوْلُ الْمُرْسِلِ
u'قَوْلٌ مُرْضِعٌ':Added, #1: 1	قَوْلُ الْمُرْضِعَةِ
u'قول مَرِيضٌ':Added, #1: 1	قَوْلُ الْمُرْضِعَةِ
u'قَوْلٌ مَرِيضٌ':Added, #1: 1	قَوْلُ الْمَرِيضِ
u'قول مُزَارِعٌ':Added, #1: 1	قَوْلُ الْمَرِيضِ
u'قَوْلٌ مُزَارِعٌ':Added, #2: 2	قَوْلَ الْمُزَارِعِ
u'قول مُزَارِعٌ':Added, #2: 2	قَوْلَ الْمُزَارِعِ
u'قَوْلٌ مُزَارِعٌ':Added, #3: 3	قَوْلُ الْمُزَارِعِ
u'قول مُسَافِرٌ':Added, #3: 3	قَوْلُ الْمُزَارِعِ
u'قَوْلٌ مُسَافِرٌ':Added, #1: 1	قَوْلُ الْمُسَافِرِ
u'قول مُسْتَأْجِرٌ':Added, #1: 1	قَوْلُ الْمُسَافِرِ
u'قَوْلٌ مُسْتَأْجِرٌ':Added, #1: 1	قَوْلِ الْمُسْتَأْجِرِ
u'قول مُسْتَأْجِرٌ':Added, #1: 1	قَوْلِ الْمُسْتَأْجِرِ
u'قَوْلٌ مُسْتَأْجِرٌ':Added, #40: 40	قَوْلُ الْمُسْتَأْجِرِ
u'قول مُسْتَأْجِرٌ':Added, #40: 40	قَوْلُ الْمُسْتَأْجِرِ
u'قَوْلٌ مُسْتَأْجِرٌ':Added, #9: 9	قَوْلَ الْمُسْتَأْجِرِ
u'قول مُسْتَعْمِلٌ':Added, #9: 9	قَوْلَ الْمُسْتَأْجِرِ
u'قَوْلٌ مُسْتَعْمِلٌ':Added, #1: 1	قَوْلَ الْمُسْتَعْمِلِ
u'قول مُسْتَعِيرٌ':Added, #1: 1	قَوْلَ الْمُسْتَعْمِلِ
u'قَوْلٌ مُسْتَعِيرٌ':Added, #1: 1	قَوْلِ الْمُسْتَعِيرِ
u'قول مُسْتَعِيرٌ':Added, #1: 1	قَوْلِ الْمُسْتَعِيرِ
u'قَوْلٌ مُسْتَعِيرٌ':Added, #3: 3	قَوْلُ الْمُسْتَعِيرِ
u'قول مُسْتَوْدَعٌ':Added, #3: 3	قَوْلُ الْمُسْتَعِيرِ
u'قَوْلٌ مُسْتَوْدَعٌ':Added, #1: 1	قَوْلُ الْمُسْتَوْدَعِ
u'قول مَسْتُورٌ':Added, #1: 1	قَوْلُ الْمُسْتَوْدَعِ
u'قَوْلٌ مَسْتُورٌ':Added, #1: 1	قَوْلَ مَسْتُورِ
u'قول مَسْتُورٌ':Added, #1: 1	قَوْلَ مَسْتُورِ
u'قَوْلٌ مَسْتُورٌ':Added, #4: 4	قَوْلُ الْمَسْتُورِ
u'قول مَسْرُوقٌ':Added, #4: 4	قَوْلُ الْمَسْتُورِ
u'قَوْلٌ مَسْرُوقٌ':Added, #1: 1	قَوْلُ مَسْرُوقٍ
u'قول مَسْرُوقٌ':Added, #1: 1	قَوْلُ مَسْرُوقٍ
u'قَوْلٌ مَسْرُوقٌ':Added, #4: 4	قَوْلِ مَسْرُوقٍ
u'قول مُسَلَّمٌ':Added, #4: 4	قَوْلِ مَسْرُوقٍ
u'قَوْلٌ مُسَلَّمٌ':Added, #1: 1	قَوْلِ الْمُسَلَّمِ
u'قول مُسَلَّمٌ':Added, #1: 1	قَوْلِ الْمُسَلَّمِ
u'قَوْلٌ مُسَلَّمٌ':Added, #4: 4	قَوْلُ الْمُسَلَّمِ
u'قول مُسْلِمٌ':Added, #4: 4	قَوْلُ الْمُسَلَّمِ
u'قَوْلٌ مُسْلِمٌ':Added, #9: 9	قَوْلُ الْمُسْلِمِ
u'قول مَشَايِخُ':Added, #9: 9	قَوْلُ الْمُسْلِمِ
u'قَوْلٌ مَشَايِخُ':Added, #2: 2	قَوْلُ الْمَشَايِخِ
u'قول مَشَايِخُ':Added, #2: 2	قَوْلُ الْمَشَايِخِ
u'قول مَشَايِخُ':Added, #4: 4	قَوْلُ مَشَايِخِ
u'قَوْلٌ مَشَايِخُ':Added, #4: 4	قَوْلِ مَشَايِخِ
u'قَوْلٌ مَشَايِخُ':Added, #4: 4	قَوْلُ مَشَايِخِ
u'قول مَشَايِخُ':Added, #4: 4	قَوْلِ مَشَايِخِ
u'قَوْلٌ مَشَايِخُ':Added, #6: 6	قَوْلِ الْمَشَايِخِ
u'قول مُشْرِك':Added, #6: 6	قَوْلِ الْمَشَايِخِ
u'قَوْلٌ مُشْرِك':Added, #1: 1	قَوْلُ الْمُشْرِكِ
u'قول مَشْهُودٌ':Added, #1: 1	قَوْلُ الْمُشْرِكِ
u'قَوْلٌ مَشْهُودٌ':Added, #2: 2	قَوْلَ الْمَشْهُودِ
u'قول مَشْهُودٌ':Added, #2: 2	قَوْلَ الْمَشْهُودِ
u'قَوْلٌ مَشْهُودٌ':Added, #3: 3	قَوْلِ الْمَشْهُودِ
u'قَوْلٌ مَشْهُورٌ':Added, #3: 3	قَوْلِ الْمَشْهُودِ
u'قول مُشِيرٌ':Added, #1: 1	قَوْلٍ مَشْهُورٍ
u'قَوْلٌ مُشِيرٌ':Added, #1: 1	قَوْلَ الْمُشِيرِ
u'قول مُصَالِحٌ':Added, #1: 1	قَوْلَ الْمُشِيرِ
u'قَوْلٌ مُصَالِحٌ':Added, #2: 2	قَوْلُ الْمُصَالِحِ
u'قول مُصَنِّفٌ':Added, #2: 2	قَوْلُ الْمُصَالِحِ
u'قَوْلٌ مُصَنِّفٌ':Added, #254: 254	قَوْلِ الْمُصَنِّفِ
u'قول مُصَنِّفٌ':Added, #254: 254	قَوْلِ الْمُصَنِّفِ
u'قَوْلٌ مُصَنِّفٌ':Added, #272: 272	قَوْلُ الْمُصَنِّفِ
u'قول مُصَنِّفٌ':Added, #272: 272	قَوْلُ الْمُصَنِّفِ
u'قَوْلٌ مُصَنِّفٌ':Added, #30: 30	قَوْلَ الْمُصَنِّفِ
u'قول مُصَوِّبٌ':Added, #30: 30	قَوْلَ الْمُصَنِّفِ
u'قَوْلٌ مُصَوِّبٌ':Added, #2: 2	قَوْلِ الْمُصَوِّبَةِ
u'قول مُضَارِبٌ':Added, #2: 2	قَوْلِ الْمُصَوِّبَةِ
u'قَوْلٌ مُضَارِبٌ':Added, #14: 14	قَوْلُ الْمُضَارِبِ
u'قول مُضَارِبٌ':Added, #14: 14	قَوْلُ الْمُضَارِبِ
u'قَوْلٌ مُضَارِبٌ':Added, #1: 1	قَوْلَ الْمُضَارِبِ
u'قول مُضَارِبٌ':Added, #1: 1	قَوْلَ الْمُضَارِبِ
u'قَوْلٌ مُضَارِبٌ':Added, #1: 1	قَوْلُ مُضَارِبٍ
u'قول مُضَارَبَةٌ':Added, #1: 1	قَوْلُ مُضَارِبٍ
u'قَوْلٌ مُضَارَبَةٌ':Added, #1: 1	قَوْلَ مُضَارَبَةٍ
u'قول مَضْرُوبٌ':Added, #1: 1	قَوْلَ مُضَارَبَةٍ
u'قَوْلٌ مَضْرُوبٌ':Added, #2: 2	قَوْلُ الْمَضْرُوبِ
u'قول مَضْمُونٌ':Added, #2: 2	قَوْلُ الْمَضْرُوبِ
u'قَوْلٌ مَضْمُونٌ':Added, #1: 1	قَوْلُ الْمَضْمُونِ
u'قول مُضِيفٌ':Added, #1: 1	قَوْلُ الْمَضْمُونِ
u'قَوْلٌ مُضِيفٌ':Added, #1: 1	قَوْلَ الْمُضِيفِ
u'قول مَطْلَبٌ':Added, #1: 1	قَوْلَ الْمُضِيفِ
u'قَوْلٌ مَطْلَبٌ':Added, #1: 1	قَوْلِ الْمَطْلَبِ
u'قول مُطْلِقٌ':Added, #1: 1	قَوْلِ الْمَطْلَبِ
u'قَوْلٌ مُطْلِقٌ':Added, #1: 1	قَوْلُ الْمُطْلِقِ
u'قول مَطْلُوبٌ':Added, #1: 1	قَوْلُ الْمُطْلِقِ
u'قَوْلٌ مَطْلُوبٌ':Added, #2: 2	قَوْلَ الْمَطْلُوبِ
u'قول مَطْلُوبٌ':Added, #2: 2	قَوْلَ الْمَطْلُوبِ
u'قَوْلٌ مَطْلُوبٌ':Added, #7: 7	قَوْلُ الْمَطْلُوبِ
u'قول معاصر':Added, #7: 7	قَوْلُ الْمَطْلُوبِ
u'قَوْلٌ معاصر':Added, #1: 1	قَوْلُ الْمُعَاصِرِ
u'قول مُعَاصِرٌ':Added, #1: 1	قَوْلُ الْمُعَاصِرِ
u'قَوْلٌ مُعَاصِرٌ':Added, #1: 1	قَوْلُ الْمُعَاصِرِ
u'قول مُعَايِنٌ':Added, #1: 1	قَوْلُ الْمُعَاصِرِ
u'قَوْلٌ مُعَايِنٌ':Added, #1: 1	قَوْلِ الْمُعَايِنِ
u'قول مَعْبَدٌ':Added, #1: 1	قَوْلِ الْمُعَايِنِ
u'قَوْلٌ مَعْبَدٌ':Added, #1: 1	قَوْلَ مَعْبَدٍ
u'قول مَعْبَدٌ':Added, #1: 1	قَوْلَ مَعْبَدٍ
u'قَوْلٌ مَعْبَدٌ':Added, #2: 2	قَوْلُ مَعْبَدٍ
u'قول مُعْتَدٌّ':Added, #2: 2	قَوْلُ مَعْبَدٍ
u'قَوْلٌ مُعْتَدٌّ':Added, #1: 1	قَوْلِ الْمُعْتَدَّةِ
u'قول مُعْتَرِضٌ':Added, #1: 1	قَوْلِ الْمُعْتَدَّةِ
u'قَوْلٌ مُعْتَرِضٌ':Added, #1: 1	قَوْلُ الْمُعْتَرِضِ
u'قول مُعْتَرِضٌ':Added, #1: 1	قَوْلُ الْمُعْتَرِضِ
u'قَوْلٌ مُعْتَرِضٌ':Added, #2: 2	قَوْلِ الْمُعْتَرِضِ
u'قول مُعْتَزِلٌ':Added, #2: 2	قَوْلِ الْمُعْتَرِضِ
u'قَوْلٌ مُعْتَزِلٌ':Added, #11: 11	قَوْلُ الْمُعْتَزِلَةِ
u'قول مُعْتَزِلٌ':Added, #11: 11	قَوْلُ الْمُعْتَزِلَةِ
u'قَوْلٌ مُعْتَزِلٌ':Added, #1: 1	قَوْلَ الْمُعْتَزِلَةِ
u'قول مُعْتَزِلٌ':Added, #1: 1	قَوْلَ الْمُعْتَزِلَةِ
u'قَوْلٌ مُعْتَزِلٌ':Added, #2: 2	قَوْلُ مُعْتَزِلَةِ
u'قول مُعْتَزِلٌ':Added, #2: 2	قَوْلُ مُعْتَزِلَةِ
u'قَوْلٌ مُعْتَزِلٌ':Added, #9: 9	قَوْلِ الْمُعْتَزِلَةِ
u'قول مُعْتَزِلَةٌ':Added, #9: 9	قَوْلِ الْمُعْتَزِلَةِ
u'قَوْلٌ مُعْتَزِلَةٌ':Added, #11: 11	قَوْلُ الْمُعْتَزِلَةِ
u'قول مُعْتَزِلَةٌ':Added, #11: 11	قَوْلُ الْمُعْتَزِلَةِ
u'قَوْلٌ مُعْتَزِلَةٌ':Added, #1: 1	قَوْلَ الْمُعْتَزِلَةِ
u'قول مُعْتَزِلَةٌ':Added, #1: 1	قَوْلَ الْمُعْتَزِلَةِ
u'قَوْلٌ مُعْتَزِلَةٌ':Added, #2: 2	قَوْلُ مُعْتَزِلَةِ
u'قول مُعْتَزِلَةٌ':Added, #2: 2	قَوْلُ مُعْتَزِلَةِ
u'قَوْلٌ مُعْتَزِلَةٌ':Added, #9: 9	قَوْلِ الْمُعْتَزِلَةِ
u'قول مِعْرَاجٌ':Added, #9: 9	قَوْلِ الْمُعْتَزِلَةِ
u'قول مِعْرَاجٌ':Added, #1: 1	قَوْلُ الْمِعْرَاجِ
u'قَوْلٌ مِعْرَاجٌ':Added, #1: 1	قَوْلِ الْمِعْرَاجِ
u'قَوْلٌ مِعْرَاجٌ':Added, #1: 1	قَوْلُ الْمِعْرَاجِ
u'قول مِعْرَاجٌ':Added, #1: 1	قَوْلِ الْمِعْرَاجِ
u'قَوْلٌ مِعْرَاجٌ':Added, #1: 1	قَوْلُ مِعْرَاجِ
u'قول مَعْرُوفٌ':Added, #1: 1	قَوْلُ مِعْرَاجِ
u'قَوْلٌ مَعْرُوفٌ':Added, #1: 1	قَوْلُ الْمَعْرُوفَةِ
u'قول مَعْرُوفٌ':Added, #1: 1	قَوْلُ الْمَعْرُوفَةِ
u'قَوْلٌ مَعْرُوفٌ':Added, #1: 1	قَوْلُ مَعْرُوفٍ
u'قول مَعْزُولٌ':Added, #1: 1	قَوْلُ مَعْرُوفٍ
u'قَوْلٌ مَعْزُولٌ':Added, #1: 1	قَوْلِ الْمَعْزُولِ
u'قول مَعْزُولٌ':Added, #1: 1	قَوْلِ الْمَعْزُولِ
u'قول مَعْزُولٌ':Added, #5: 5	قَوْلَ الْمَعْزُولِ
u'قَوْلٌ مَعْزُولٌ':Added, #5: 5	قَوْلُ الْمَعْزُولِ
u'قَوْلٌ مَعْزُولٌ':Added, #5: 5	قَوْلَ الْمَعْزُولِ
u'قول مَعْصُومٌ':Added, #5: 5	قَوْلُ الْمَعْزُولِ
u'قَوْلٌ مَعْصُومٌ':Added, #1: 1	قَوْلِ الْمَعْصُومِ
u'قول مُعَطَّلٌ':Added, #1: 1	قَوْلِ الْمَعْصُومِ
u'قَوْلٌ مُعَطَّلٌ':Added, #1: 1	قَوْلُ الْمُعَطّلِ
u'قول مُعْظَمٌ':Added, #1: 1	قَوْلُ الْمُعَطّلِ
u'قَوْلٌ مُعْظَمٌ':Added, #1: 1	قَوْلُ الْمُعْظَمِ
u'قول مُعْظَمٌ':Added, #1: 1	قَوْلُ الْمُعْظَمِ
u'قَوْلٌ مُعْظَمٌ':Added, #1: 1	قَوْلِ مُعْظَمِ
u'قول مُعْظَمٌ':Added, #1: 1	قَوْلِ مُعْظَمِ
u'قَوْلٌ مُعْظَمٌ':Added, #3: 3	قَوْلُ مُعْظَمِ
u'قول مُعَلِّلٌ':Added, #3: 3	قَوْلُ مُعْظَمِ
u'قَوْلٌ مُعَلِّلٌ':Added, #2: 2	قَوْلُ الْمُعَلِّلِ
u'قول مُعِير':Added, #2: 2	قَوْلُ الْمُعَلِّلِ
u'قول مُعِير':Added, #1: 1	قَوْلَ الْمُعِيرِ
u'قَوْلٌ مُعِير':Added, #1: 1	قَوْلُ الْمُعِيرِ
u'قَوْلٌ مُعِير':Added, #1: 1	قَوْلَ الْمُعِيرِ
u'قول مُعِير':Added, #1: 1	قَوْلُ الْمُعِيرِ
u'قَوْلٌ مُعِير':Added, #1: 1	قَوْلُ مُعِيرٍ
u'قول مَغْصُوب':Added, #1: 1	قَوْلُ مُعِيرٍ
u'قَوْلٌ مَغْصُوب':Added, #1: 1	قَوْلَ الْمَغْصُوبِ
u'قول مَغْصُوب':Added, #1: 1	قَوْلَ الْمَغْصُوبِ
u'قَوْلٌ مَغْصُوب':Added, #7: 7	قَوْلُ الْمَغْصُوبِ
u'قول مُفْجِعٌ':Added, #7: 7	قَوْلُ الْمَغْصُوبِ
u'قَوْلٌ مُفْجِعٌ':Added, #1: 1	قَوْلُ الْمُفْجِعِ
u'قول مَفْدِيٌّ':Added, #1: 1	قَوْلُ الْمُفْجِعِ
u'قَوْلٌ مَفْدِيٌّ':Added, #1: 1	قَوْلَ الْمَفْدِيِّ
u'قول مُفَسِّرٌ':Added, #1: 1	قَوْلَ الْمَفْدِيِّ
u'قَوْلٌ مُفَسِّرٌ':Added, #1: 1	قَوْلِ الْمُفَسِّرِ
u'قول مُفْلِسٌ':Added, #1: 1	قَوْلِ الْمُفَسِّرِ
u'قَوْلٌ مُفْلِسٌ':Added, #1: 1	قَوْلُ الْمُفْلِسِ
u'قول مُقَاتِلٌ':Added, #1: 1	قَوْلُ الْمُفْلِسِ
u'قول مُقَاتِلٌ':Added, #1: 1	قَوْلُ مُقَاتِلِ
u'قَوْلٌ مُقَاتِلٌ':Added, #1: 1	قَوْلِ مُقَاتِلٍ
u'قَوْلٌ مُقَاتِلٌ':Added, #1: 1	قَوْلُ مُقَاتِلِ
u'قول مُقَاتِلٌ':Added, #1: 1	قَوْلِ مُقَاتِلٍ
u'قَوْلٌ مُقَاتِلٌ':Added, #3: 3	قَوْلُ مُقَاتِلٍ
u'قول مَقْتُولٌ':Added, #3: 3	قَوْلُ مُقَاتِلٍ
u'قَوْلٌ مَقْتُولٌ':Added, #1: 1	قَوْلَ الْمَقْتُولِ
u'قول مَقْتُولٌ':Added, #1: 1	قَوْلَ الْمَقْتُولِ
u'قَوْلٌ مَقْتُولٌ':Added, #4: 4	قَوْلِ الْمَقْتُولِ
u'قول مَقْدِسِيٌّ':Added, #4: 4	قَوْلِ الْمَقْتُولِ
u'قَوْلٌ مَقْدِسِيٌّ':Added, #2: 2	قَوْلُ الْمَقْدِسِيِّ
u'قَوْلٌ مُقَدَّمٌ':Added, #2: 2	قَوْلُ الْمَقْدِسِيِّ
u'قول مَقْذُوفٌ':Added, #1: 1	قَوْلٍ مُقَدَّمٍ
u'قَوْلٌ مَقْذُوفٌ':Added, #1: 1	قَوْلُ الْمَقْذُوفِ
u'قول مَقْضِيّ':Added, #1: 1	قَوْلُ الْمَقْذُوفِ
u'قَوْلٌ مَقْضِيّ':Added, #2: 2	قَوْلُ الْمَقْضِيِّ
u'قول مُقَلِّدٌ':Added, #2: 2	قَوْلُ الْمَقْضِيِّ
u'قَوْلٌ مُقَلِّدٌ':Added, #1: 1	قَوْلِ الْمُقَلِّدِ
u'قول مُقَلَّدٌ':Added, #1: 1	قَوْلِ الْمُقَلِّدِ
u'قَوْلٌ مُقَلَّدٌ':Added, #1: 1	قَوْلِ مُقَلَّدِهِ
u'قول مَكْحُول':Added, #1: 1	قَوْلِ مُقَلَّدِهِ
u'قَوْلٌ مَكْحُول':Added, #2: 2	قَوْلِ مَكْحُولٍ
u'قول مُكْرَهٌ':Added, #2: 2	قَوْلِ مَكْحُولٍ
u'قَوْلٌ مُكْرَهٌ':Added, #1: 1	قَوْلِ الْمُكْرَهِ
u'قول مُكَلَّفٌ':Added, #1: 1	قَوْلِ الْمُكْرَهِ
u'قَوْلٌ مُكَلَّفٌ':Added, #1: 1	قَوْلُ الْمُكَلَّفِ
u'قول مَلأٌ':Added, #1: 1	قَوْلُ الْمُكَلَّفِ
u'قَوْلٌ مَلأٌ':Added, #1: 1	قَوْلَ الْمَلَأِ
u'قول مَلاَحِدَةٌ':Added, #1: 1	قَوْلَ الْمَلَأِ
u'قَوْلٌ مَلاَحِدَةٌ':Added, #1: 1	قَوْلُ الْمَلَاحِدَةِ
u'قول مَلاَئِكَةٌ':Added, #1: 1	قَوْلُ الْمَلَاحِدَةِ
u'قَوْلٌ مَلاَئِكَةٌ':Added, #1: 1	قَوْلُ الْمَلَائِكَةِ
u'قول مَلاَئِكَةٌ':Added, #1: 1	قَوْلُ الْمَلَائِكَةِ
u'قول مَلاَئِكَةٌ':Added, #2: 2	قَوْلِ الْمَلَائِكَةِ
u'قَوْلٌ مَلاَئِكَةٌ':Added, #2: 2	قَوْلَ الْمَلاَئِكَةِ
u'قَوْلٌ مَلاَئِكَةٌ':Added, #2: 2	قَوْلِ الْمَلَائِكَةِ
u'قول مَلاَئِكَةٌ':Added, #2: 2	قَوْلَ الْمَلاَئِكَةِ
u'قَوْلٌ مَلاَئِكَةٌ':Added, #3: 3	قَوْلَ الْمَلَائِكَةِ
u'قول مُلْتَقِط':Added, #3: 3	قَوْلَ الْمَلَائِكَةِ
u'قَوْلٌ مُلْتَقِط':Added, #2: 2	قَوْلُ الْمُلْتَقِطِ
u'قول مُلْحِدٌ':Added, #2: 2	قَوْلُ الْمُلْتَقِطِ
u'قَوْلٌ مُلْحِدٌ':Added, #1: 1	قَوْلُ الْمُلْحِدَةِ
u'قول مُلْزِمٌ':Added, #1: 1	قَوْلُ الْمُلْحِدَةِ
u'قَوْلٌ مُلْزِمٌ':Added, #1: 1	قَوْلُ مُلْزِمٍ
u'قول مَلَكٌ':Added, #1: 1	قَوْلُ مُلْزِمٍ
u'قول مَلِكٌ':Added, #1: 1	قَوْلِ الْمَلَكِ
u'قَوْلٌ مَلَكٌ':Added, #1: 1	قَوْلِ الْمَلِكِ
u'قَوْلٌ مَلِكٌ':Added, #1: 1	قَوْلِ الْمَلَكِ
u'قول مُمَيِّزٌ':Added, #1: 1	قَوْلِ الْمَلِكِ
u'قَوْلٌ مُمَيِّزٌ':Added, #1: 1	قَوْلَ الْمُمَيِّزِ
u'قول مُمَيِّزٌ':Added, #1: 1	قَوْلَ الْمُمَيِّزِ
u'قَوْلٌ مُمَيِّزٌ':Added, #1: 1	قَوْلِ مُمَيِّزٍ
u'قول مُمَيِّزٌ':Added, #1: 1	قَوْلِ مُمَيِّزٍ
u'قَوْلٌ مُمَيِّزٌ':Added, #2: 2	قَوْلُ الْمُمَيِّزِ
u'قول مَنَارٌ':Added, #2: 2	قَوْلُ الْمُمَيِّزِ
u'قَوْلٌ مَنَارٌ':Added, #1: 1	قَوْلِ الْمَنَارِ
u'قول مَنَاطِقَةٌ':Added, #1: 1	قَوْلِ الْمَنَارِ
u'قَوْلٌ مَنَاطِقَةٌ':Added, #1: 1	قَوْلَ الْمَنَاطِقَةِ
u'قول مُنَاظِرٌ':Added, #1: 1	قَوْلَ الْمَنَاطِقَةِ
u'قَوْلٌ مُنَاظِرٌ':Added, #1: 1	قَوْلِ الْمُنَاظِرِ
u'قول مُنَجِّمٌ':Added, #1: 1	قَوْلِ الْمُنَاظِرِ
u'قَوْلٌ مُنَجِّمٌ':Added, #1: 1	قَوْلُ الْمُنَجِّمِ
u'قول مُنْقَرِضٌ':Added, #1: 1	قَوْلُ الْمُنَجِّمِ
u'قَوْلٌ مُنْقَرِضٌ':Added, #1: 1	قَوْلِ الْمُنْقَرِضَةِ
u'قول مَنْقُوض':Added, #1: 1	قَوْلِ الْمُنْقَرِضَةِ
u'قَوْلٌ مَنْقُوض':Added, #1: 1	قَوْلِ الْمَنْقُوضَةِ
u'قول مُنْكَرٌ':Added, #1: 1	قَوْلِ الْمَنْقُوضَةِ
u'قول مُنْكَرٌ':Added, #1: 1	قَوْلُ الْمُنْكَرِ
u'قَوْلٌ مُنْكَرٌ':Added, #1: 1	قَوْلِ الْمُنْكَرِ
u'قَوْلٌ مُنْكَرٌ':Added, #1: 1	قَوْلُ الْمُنْكَرِ
u'قول مُنْكِرٌ':Added, #1: 1	قَوْلِ الْمُنْكَرِ
u'قول مُنْكِرٌ':Added, #1: 1	قَوْلَ مُنْكِرِ
u'قَوْلٌ مُنْكِرٌ':Added, #1: 1	قَوْلُ مُنْكِرِ
u'قَوْلٌ مُنْكِرٌ':Added, #1: 1	قَوْلَ مُنْكِرِ
u'قول مُنْكِرٌ':Added, #1: 1	قَوْلُ مُنْكِرِ
u'قَوْلٌ مُنْكِرٌ':Added, #1: 1	قَوْلُ مُنْكِرَةٍ
u'قول مُنْكَرٌ':Added, #1: 1	قَوْلُ مُنْكِرَةٍ
u'قول مُنْكِرٌ':Added, #1: 1	قَوْلُ مُنْكَرِهِ
u'قَوْلٌ مُنْكَرٌ':Added, #1: 1	قَوْلِ مُنْكِرِهِ
u'قَوْلٌ مُنْكِرٌ':Added, #1: 1	قَوْلُ مُنْكَرِهِ
u'قول مُنْكِرٌ':Added, #1: 1	قَوْلِ مُنْكِرِهِ
u'قَوْلٌ مُنْكِرٌ':Added, #3: 3	قَوْلُ مُنْكِرِهِ
u'قول مُنْكِرٌ':Added, #3: 3	قَوْلُ مُنْكِرِهِ
u'قَوْلٌ مُنْكِرٌ':Added, #53: 53	قَوْلُ الْمُنْكِرِ
u'قول مُنْكِرٌ':Added, #53: 53	قَوْلُ الْمُنْكِرِ
u'قَوْلٌ مُنْكِرٌ':Added, #8: 8	قَوْلَ الْمُنْكِرِ
u'قول مِنْهَاجٌ':Added, #8: 8	قَوْلَ الْمُنْكِرِ
u'قَوْلٌ مِنْهَاجٌ':Added, #11: 11	قَوْلُ الْمِنْهَاجِ
u'قول مِنْهَاجٌ':Added, #11: 11	قَوْلُ الْمِنْهَاجِ
u'قَوْلٌ مِنْهَاجٌ':Added, #20: 20	قَوْلِ الْمِنْهَاجِ
u'قول مِنْهَاجٌ':Added, #20: 20	قَوْلِ الْمِنْهَاجِ
u'قَوْلٌ مِنْهَاجٌ':Added, #5: 5	قَوْلَ الْمِنْهَاجِ
u'قول مُهَذَّبٌ':Added, #5: 5	قَوْلَ الْمِنْهَاجِ
u'قَوْلٌ مُهَذَّبٌ':Added, #1: 1	قَوْلِ الْمُهَذَّبِ
u'قول مُهَذَّبٌ':Added, #1: 1	قَوْلِ الْمُهَذَّبِ
u'قَوْلٌ مُهَذَّبٌ':Added, #3: 3	قَوْلُ الْمُهَذَّبِ
u'قول مُهَلْهَلٌ':Added, #3: 3	قَوْلُ الْمُهَذَّبِ
u'قَوْلٌ مُهَلْهَلٌ':Added, #1: 1	قَوْلَ مُهَلْهَلٍ
u'قول مُهَلْهَلٌ':Added, #1: 1	قَوْلَ مُهَلْهَلٍ
u'قَوْلٌ مُهَلْهَلٌ':Added, #2: 2	قَوْلُ مُهَلْهَلٍ
u'قول مُهِمٌّ':Added, #2: 2	قَوْلُ مُهَلْهَلٍ
u'قَوْلٌ مُهِمٌّ':Added, #4: 4	قَوْلِ الْمُهِمَّاتِ
u'قول مُهِمَّةٌ':Added, #4: 4	قَوْلِ الْمُهِمَّاتِ
u'قَوْلٌ مُهِمَّةٌ':Added, #4: 4	قَوْلِ الْمُهِمَّاتِ
u'قول مُؤْتَمَنٌ':Added, #4: 4	قَوْلِ الْمُهِمَّاتِ
u'قَوْلٌ مُؤْتَمَنٌ':Added, #1: 1	قَوْلُ الْمُؤْتَمَنِ
u'قول مُوَثَّقٌ':Added, #1: 1	قَوْلُ الْمُؤْتَمَنِ
u'قول مُوَثِّقٌ':Added, #1: 1	قَوْلَ الْمُوَثَّقِ
u'قَوْلٌ مُوَثَّقٌ':Added, #1: 1	قَوْلُ الْمُوَثِّقِ
u'قَوْلٌ مُوَثِّقٌ':Added, #1: 1	قَوْلَ الْمُوَثَّقِ
u'قول مُوَثَّقٌ':Added, #1: 1	قَوْلُ الْمُوَثِّقِ
u'قَوْلٌ مُوَثَّقٌ':Added, #6: 6	قَوْلُ الْمُوَثَّقِ
u'قول مُوجِبٌ':Added, #6: 6	قَوْلُ الْمُوَثَّقِ
u'قول مُوجِبٌ':Added, #1: 1	قَوْلُ الْمُوجِبِ
u'قَوْلٌ مُوجِبٌ':Added, #1: 1	قَوْلِ الْمُوجِبِ
u'قَوْلٌ مُوجِبٌ':Added, #1: 1	قَوْلُ الْمُوجِبِ
u'قول مُؤَجِّرٌ':Added, #1: 1	قَوْلِ الْمُوجِبِ
u'قَوْلٌ مُؤَجِّرٌ':Added, #1: 1	قَوْلِ الْمُؤَجِّرِ
u'قول مُؤَجِّرٌ':Added, #1: 1	قَوْلِ الْمُؤَجِّرِ
u'قَوْلٌ مُؤَجِّرٌ':Added, #4: 4	قَوْلُ الْمُؤَجِّرِ
u'قول مُودَعٌ':Added, #4: 4	قَوْلُ الْمُؤَجِّرِ
u'قول مُودَعٌ':Added, #1: 1	قَوْلَ الْمُودَعِ
u'قَوْلٌ مُودَعٌ':Added, #1: 1	قَوْلِ الْمُودَعِ
u'قَوْلٌ مُودَعٌ':Added, #1: 1	قَوْلَ الْمُودَعِ
u'قول مُودِعٌ':Added, #1: 1	قَوْلِ الْمُودَعِ
u'قَوْلٌ مُودِعٌ':Added, #4: 4	قَوْلُ الْمُودِعِ
u'قول مُودَعٌ':Added, #4: 4	قَوْلُ الْمُودِعِ
u'قَوْلٌ مُودَعٌ':Added, #8: 8	قَوْلُ الْمُودَعِ
u'قول مُؤَذِّنٌ':Added, #8: 8	قَوْلُ الْمُودَعِ
u'قول مُؤَذِّنٌ':Added, #1: 1	قَوْلَ الْمُؤَذِّنِ
u'قَوْلٌ مُؤَذِّنٌ':Added, #1: 1	قَوْلُ الْمُؤَذِّنِ
u'قَوْلٌ مُؤَذِّنٌ':Added, #1: 1	قَوْلَ الْمُؤَذِّنِ
u'قول مُؤَذِّنٌ':Added, #1: 1	قَوْلُ الْمُؤَذِّنِ
u'قَوْلٌ مُؤَذِّنٌ':Added, #4: 4	قَوْلِ الْمُؤَذِّنِ
u'قول مُوَرِّقٌ':Added, #4: 4	قَوْلِ الْمُؤَذِّنِ
u'قَوْلٌ مُوَرِّقٌ':Added, #1: 1	قَوْلُ الْمُوَرِّقِ
u'قول مُوَكِّلٌ':Added, #1: 1	قَوْلُ الْمُوَرِّقِ
u'قَوْلٌ مُوَكِّلٌ':Added, #14: 14	قَوْلُ الْمُوَكِّلِ
u'قول مُوَكِّلٌ':Added, #14: 14	قَوْلُ الْمُوَكِّلِ
u'قول مُوَكِّلٌ':Added, #1: 1	قَوْلُ مُوَكِّلِهِ
u'قَوْلٌ مُوَكِّلٌ':Added, #1: 1	قَوْلِ مُوَكِّلِهِ
u'قَوْلٌ مُوَكِّلٌ':Added, #1: 1	قَوْلُ مُوَكِّلِهِ
u'قول مُوَكِّلٌ':Added, #1: 1	قَوْلِ مُوَكِّلِهِ
u'قَوْلٌ مُوَكِّلٌ':Added, #3: 3	قَوْلِ الْمُوَكِّلِ
u'قول مُؤَلِّفٌ':Added, #3: 3	قَوْلِ الْمُوَكِّلِ
u'قَوْلٌ مُؤَلِّفٌ':Added, #12: 12	قَوْلُ الْمُؤَلِّفِ
u'قول مُؤَلِّفٌ':Added, #12: 12	قَوْلُ الْمُؤَلِّفِ
u'قَوْلٌ مُؤَلِّفٌ':Added, #18: 18	قَوْلِ الْمُؤَلِّفِ
u'قول مُؤَلِّفٌ':Added, #18: 18	قَوْلِ الْمُؤَلِّفِ
u'قَوْلٌ مُؤَلِّفٌ':Added, #19: 19	قَوْلَ الْمُؤَلِّفِ
u'قول مُؤَلَّفٌ':Added, #19: 19	قَوْلَ الْمُؤَلِّفِ
u'قول مُؤَلَّفٌ':Added, #1: 1	قَوْلَ الْمُؤَلَّفِ
u'قَوْلٌ مُؤَلَّفٌ':Added, #1: 1	قَوْلِ الْمُؤَلَّفِ
u'قَوْلٌ مُؤَلَّفٌ':Added, #1: 1	قَوْلَ الْمُؤَلَّفِ
u'قول مَوْهُوبٌ':Added, #1: 1	قَوْلِ الْمُؤَلَّفِ
u'قَوْلٌ مَوْهُوبٌ':Added, #1: 1	قَوْلَ الْمَوْهُوبَةِ
u'قول مَوْهُوبٌ':Added, #1: 1	قَوْلَ الْمَوْهُوبَةِ
u'قَوْلٌ مَوْهُوبٌ':Added, #2: 2	قَوْلَ الْمَوْهُوبِ
u'قول مَوْهُوبٌ':Added, #2: 2	قَوْلَ الْمَوْهُوبِ
u'قَوْلٌ مَوْهُوبٌ':Added, #3: 3	قَوْلُ الْمَوْهُوبِ
u'قول نَابِغٌ':Added, #3: 3	قَوْلُ الْمَوْهُوبِ
u'قول نَابِغٌ':Added, #2: 2	قَوْلُ النّابِغَةِ
u'قول نَابِغٌ':Added, #2: 2	قَوْلُ النَّابِغَةِ
u'قَوْلٌ نَابِغٌ':Added, #2: 2	قَوْلِ النّابِغَةِ
u'قَوْلٌ نَابِغٌ':Added, #2: 2	قَوْلُ النّابِغَةِ
u'قَوْلٌ نَابِغٌ':Added, #2: 2	قَوْلُ النَّابِغَةِ
u'قول ناذِر':Added, #2: 2	قَوْلِ النّابِغَةِ
u'قَوْلٌ ناذِر':Added, #1: 1	قَوْلِ النَّاذِرِ
u'قول نَاسٌ':Added, #1: 1	قَوْلِ النَّاذِرِ
u'قَوْلٌ نَاسٌ':Added, #13: 13	قَوْلِ النَّاسِ
u'قول نَاسٌ':Added, #13: 13	قَوْلِ النَّاسِ
u'قَوْلٌ نَاسٌ':Added, #1: 1	قَوْلِ النّاسِ
u'قول نَاسٌ':Added, #1: 1	قَوْلِ النّاسِ
u'قَوْلٌ نَاسٌ':Added, #5: 5	قَوْلَ النَّاسِ
u'قول نَاسٌ':Added, #5: 5	قَوْلَ النَّاسِ
u'قَوْلٌ نَاسٌ':Added, #6: 6	قَوْلُ النَّاسِ
u'قول نَاظِرٌ':Added, #6: 6	قَوْلُ النَّاسِ
u'قول نَاظِرٌ':Added, #1: 1	قَوْلُ النَّاظِرِ
u'قَوْلٌ نَاظِرٌ':Added, #1: 1	قَوْلِ النَّاظِرِ
u'قَوْلٌ نَاظِرٌ':Added, #1: 1	قَوْلُ النَّاظِرِ
u'قول نَافِعٌ':Added, #1: 1	قَوْلِ النَّاظِرِ
u'قَوْلٌ نَافِعٌ':Added, #1: 1	قَوْلَ نَافِعٍ
u'قول نَافِعٌ':Added, #1: 1	قَوْلَ نَافِعٍ
u'قَوْلٌ نَافِعٌ':Added, #4: 4	قَوْلِ نَافِعٍ
u'قول نَافِي':Added, #4: 4	قَوْلِ نَافِعٍ
u'قَوْلٌ نَافِي':Added, #1: 1	قَوْلُ النَّافِيَةِ
u'قول نَافِي':Added, #1: 1	قَوْلُ النَّافِيَةِ
u'قَوْلٌ نَافِي':Added, #1: 1	قَوْلُ نَافِيهِ
u'قول نَبِيٌّ':Added, #1: 1	قَوْلُ نَافِيهِ
u'قَوْلٌ نَبِيٌّ':Added, #19: 19	قَوْلَ النَّبِيِّ
u'قول نَبِيٌّ':Added, #19: 19	قَوْلَ النَّبِيِّ
u'قَوْلٌ نَبِيٌّ':Added, #1: 1	قَوْلِ نَبِيِّهِ
u'قول نَبِيٌّ':Added, #1: 1	قَوْلِ نَبِيِّهِ
u'قَوْلٌ نَبِيٌّ':Added, #47: 47	قَوْلِ النَّبِيِّ
u'قول نَبِيٌّ':Added, #47: 47	قَوْلِ النَّبِيِّ
u'قَوْلٌ نَبِيٌّ':Added, #55: 55	قَوْلُ النَّبِيِّ
u'قول نُحَاةٌ':Added, #55: 55	قَوْلُ النَّبِيِّ
u'قول نُحَاةٌ':Added, #2: 2	قَوْلَ النُّحَاةِ
u'قَوْلٌ نُحَاةٌ':Added, #2: 2	قَوْلِ النُّحَاةِ
u'قَوْلٌ نُحَاةٌ':Added, #2: 2	قَوْلَ النُّحَاةِ
u'قول نُحَاةٌ':Added, #2: 2	قَوْلِ النُّحَاةِ
u'قَوْلٌ نُحَاةٌ':Added, #5: 5	قَوْلُ النُّحَاةِ
u'قول نَحْوٌ':Added, #5: 5	قَوْلُ النُّحَاةِ
u'قَوْلٌ نَحْوٌ':Added, #1: 1	قَوْلَ نَحْوِ
u'قول نَخَّاسٌ':Added, #1: 1	قَوْلَ نَحْوِ
u'قَوْلٌ نَخَّاسٌ':Added, #1: 1	قَوْلُ النَّخَّاسِ
u'قول نَدَّافٌ':Added, #1: 1	قَوْلُ النَّخَّاسِ
u'قَوْلٌ نَدَّافٌ':Added, #1: 1	قَوْلُ النَّدَّافِ
u'قول نَدْبٌ':Added, #1: 1	قَوْلُ النَّدَّافِ
u'قَوْلٌ نَدْبٌ':Added, #1: 1	قَوْلِ النَّدْبِ
u'قول نِساءٌ':Added, #1: 1	قَوْلِ النَّدْبِ
u'قَوْلٌ نِساءٌ':Added, #1: 1	قَوْلَ النِّسَاءِ
u'قول نِساءٌ':Added, #1: 1	قَوْلَ النِّسَاءِ
u'قَوْلٌ نِساءٌ':Added, #4: 4	قَوْلُ النِّسَاءِ
u'قول نِساءٌ':Added, #4: 4	قَوْلُ النِّسَاءِ
u'قَوْلٌ نِساءٌ':Added, #6: 6	قَوْلِ النِّسَاءِ
u'قول نَصْرٌ':Added, #6: 6	قَوْلِ النِّسَاءِ
u'قَوْلٌ نَصْرٌ':Added, #1: 1	قَوْلُ نَصْرٍ
u'قول نَصْرَانِيٌّ':Added, #1: 1	قَوْلُ نَصْرٍ
u'قَوْلٌ نَصْرَانِيٌّ':Added, #1: 1	قَوْلُ النّصْرَانِيّةِ
u'قول نَصْرَانِيٌّ':Added, #1: 1	قَوْلُ النّصْرَانِيّةِ
u'قَوْلٌ نَصْرَانِيٌّ':Added, #2: 2	قَوْلُ النَّصْرَانِيِّ
u'قول نَصْرَانِيَّةٌ':Added, #2: 2	قَوْلُ النَّصْرَانِيِّ
u'قَوْلٌ نَصْرَانِيَّةٌ':Added, #1: 1	قَوْلُ النّصْرَانِيّةِ
u'قول نَصِيبٌ':Added, #1: 1	قَوْلُ النّصْرَانِيّةِ
u'قَوْلٌ نَصِيبٌ':Added, #1: 1	قَوْلَ النَّصِيبِ
u'قول نُعْمَانُ':Added, #1: 1	قَوْلَ النَّصِيبِ
u'قَوْلٌ نُعْمَانُ':Added, #1: 1	قَوْلَ النُّعْمَانِ
u'قول نفاة':Added, #1: 1	قَوْلَ النُّعْمَانِ
u'قَوْلٌ نفاة':Added, #1: 1	قَوْلِ نُفَاةِ
u'قول نَفْسٌ':Added, #1: 1	قَوْلِ نُفَاةِ
u'قَوْلٌ نَفْسٌ':Added, #1: 1	قَوْلُ النَّفْسِ
u'قول نَفْسٌ':Added, #1: 1	قَوْلُ النَّفْسِ
u'قَوْلٌ نَفْسٌ':Added, #1: 1	قَوْلَ نَفْسِهِ
u'قول نَفْسٌ':Added, #1: 1	قَوْلَ نَفْسِهِ
u'قَوْلٌ نَفْسٌ':Added, #2: 2	قَوْلِ نَفْسِهِ
u'قول نَفْيٌ':Added, #2: 2	قَوْلِ نَفْسِهِ
u'قَوْلٌ نَفْيٌ':Added, #1: 1	قَوْلَ النَّفْيِ
u'قول نَفْيٌ':Added, #1: 1	قَوْلَ النَّفْيِ
u'قَوْلٌ نَفْيٌ':Added, #1: 1	قَوْلِ نَفْيِهِ
u'قول نَقَّاشٌ':Added, #1: 1	قَوْلِ نَفْيِهِ
u'قَوْلٌ نَقَّاشٌ':Added, #1: 1	قَوْلِ النَّقَّاشِ
u'قول نِهَايَةٌ':Added, #1: 1	قَوْلِ النَّقَّاشِ
u'قَوْلٌ نِهَايَةٌ':Added, #1: 1	قَوْلُ النِّهَايَةِ
u'قول نِهَايَةٌ':Added, #1: 1	قَوْلُ النِّهَايَةِ
u'قَوْلٌ نِهَايَةٌ':Added, #2: 2	قَوْلَ النِّهَايَةِ
u'قول نَهْرٌ':Added, #2: 2	قَوْلَ النِّهَايَةِ
u'قول نَهْرٌ':Added, #2: 2	قَوْلَ النَّهْرِ
u'قَوْلٌ نَهْرٌ':Added, #2: 2	قَوْلِ النَّهْرِ
u'قَوْلٌ نَهْرٌ':Added, #2: 2	قَوْلَ النَّهْرِ
u'قول نَهْرٌ':Added, #2: 2	قَوْلِ النَّهْرِ
u'قَوْلٌ نَهْرٌ':Added, #5: 5	قَوْلُ النَّهْرِ
u'قول نَوَوِيٌّ':Added, #5: 5	قَوْلُ النَّهْرِ
u'قَوْلٌ نَوَوِيٌّ':Added, #11: 11	قَوْلِ النَّوَوِيِّ
u'قول نَوَوِيٌّ':Added, #11: 11	قَوْلِ النَّوَوِيِّ
u'قَوْلٌ نَوَوِيٌّ':Added, #26: 26	قَوْلُ النَّوَوِيِّ
u'قول نَوَوِيٌّ':Added, #26: 26	قَوْلُ النَّوَوِيِّ
u'قَوْلٌ نَوَوِيٌّ':Added, #6: 6	قَوْلَ النَّوَوِيِّ
u'قول نِيَّةٌ':Added, #6: 6	قَوْلَ النَّوَوِيِّ
u'قَوْلٌ نِيَّةٌ':Added, #1: 1	قَوْلِ النِّيَّةِ
u'قول هِدَايَةٌ':Added, #1: 1	قَوْلِ النِّيَّةِ
u'قَوْلٌ هِدَايَةٌ':Added, #16: 16	قَوْلِ الْهِدَايَةِ
u'قول هِدَايَةٌ':Added, #16: 16	قَوْلِ الْهِدَايَةِ
u'قَوْلٌ هِدَايَةٌ':Added, #4: 4	قَوْلَ الْهِدَايَةِ
u'قول هِدَايَةٌ':Added, #4: 4	قَوْلَ الْهِدَايَةِ
u'قَوْلٌ هِدَايَةٌ':Added, #7: 7	قَوْلُ الْهِدَايَةِ
u'قول هَرَوِيّ':Added, #7: 7	قَوْلُ الْهِدَايَةِ
u'قول هَرَوِيّ':Added, #1: 1	قَوْلُ الْهَرَوِيِّ
u'قَوْلٌ هَرَوِيّ':Added, #1: 1	قَوْلِ الْهَرَوِيِّ
u'قَوْلٌ هَرَوِيّ':Added, #1: 1	قَوْلُ الْهَرَوِيِّ
u'قول هشام':Added, #1: 1	قَوْلِ الْهَرَوِيِّ
u'قول هشام':Added, #1: 1	قَوْلَ هِشَامٍ
u'قَوْلٌ هشام':Added, #1: 1	قَوْلُ هِشَامٍ
u'قَوْلٌ هشام':Added, #1: 1	قَوْلَ هِشَامٍ
u'قول هِشَامٌ':Added, #1: 1	قَوْلُ هِشَامٍ
u'قول هِشَامٌ':Added, #1: 1	قَوْلَ هِشَامٍ
u'قَوْلٌ هِشَامٌ':Added, #1: 1	قَوْلُ هِشَامٍ
u'قَوْلٌ هِشَامٌ':Added, #1: 1	قَوْلَ هِشَامٍ
u'قول هلاك':Added, #1: 1	قَوْلُ هِشَامٍ
u'قَوْلٌ هلاك':Added, #2: 2	قَوْلَ الْهَلَاكِ
u'قول هَلاَكٌ':Added, #2: 2	قَوْلَ الْهَلَاكِ
u'قَوْلٌ هَلاَكٌ':Added, #2: 2	قَوْلَ الْهَلَاكِ
u'قول هِلاَلٌ':Added, #2: 2	قَوْلَ الْهَلَاكِ
u'قَوْلٌ هِلاَلٌ':Added, #11: 11	قَوْلُ هِلَالٍ
u'قول هِلاَلٌ':Added, #11: 11	قَوْلُ هِلَالٍ
u'قَوْلٌ هِلاَلٌ':Added, #7: 7	قَوْلِ هِلَالٍ
u'قول هِنْدٌ':Added, #7: 7	قَوْلِ هِلَالٍ
u'قول هِنْدٌ':Added, #1: 1	قَوْلَ هِنْدِ
u'قَوْلٌ هِنْدٌ':Added, #1: 1	قَوْلُ هِنْدٍ
u'قَوْلٌ هِنْدٌ':Added, #1: 1	قَوْلَ هِنْدِ
u'قول وَاجِبٌ':Added, #1: 1	قَوْلُ هِنْدٍ
u'قَوْلٌ وَاجِبٌ':Added, #1: 1	قَوْلِ الْوَاجِبِ
u'قول واحد':Added, #1: 1	قَوْلِ الْوَاجِبِ
u'قَوْلٌ واحد':Added, #10: 10	قَوْلُ وَاحِدٍ
u'قول وَاحِدٌ':Added, #10: 10	قَوْلُ وَاحِدٍ
u'قَوْلٌ وَاحِدٌ':Added, #10: 10	قَوْلُ وَاحِدٍ
u'قول واحد':Added, #10: 10	قَوْلُ وَاحِدٍ
u'قَوْلٌ واحد':Added, #15: 15	قَوْلُ الْوَاحِدِ
u'قول وَاحِدٌ':Added, #15: 15	قَوْلُ الْوَاحِدِ
u'قَوْلٌ وَاحِدٌ':Added, #15: 15	قَوْلُ الْوَاحِدِ
u'قَوْلٌ واحد':Added, #15: 15	قَوْلُ الْوَاحِدِ
u'قَوْلٌ وَاحِدٌ':Added, #19: 19	قَوْلٍ وَاحِدٍ
u'قول واحد':Added, #19: 19	قَوْلٍ وَاحِدٍ
u'قَوْلٌ واحد':Added, #1: 1	قَوْلُ الْوَاحِدَةِ
u'قول وَاحِدٌ':Added, #1: 1	قَوْلُ الْوَاحِدَةِ
u'قَوْلٌ وَاحِدٌ':Added, #1: 1	قَوْلُ الْوَاحِدَةِ
u'قول واحد':Added, #1: 1	قَوْلُ الْوَاحِدَةِ
u'قَوْلٌ واحد':Added, #1: 1	قَوْلُ وَاحِدَةٍ
u'قول وَاحِدٌ':Added, #1: 1	قَوْلُ وَاحِدَةٍ
u'قَوْلٌ وَاحِدٌ':Added, #1: 1	قَوْلُ وَاحِدَةٍ
u'قول واحد':Added, #1: 1	قَوْلُ وَاحِدَةٍ
u'قَوْلٌ واحد':Added, #4: 4	قَوْلَ وَاحِدٍ
u'قول وَاحِدٌ':Added, #4: 4	قَوْلَ وَاحِدٍ
u'قَوْلٌ وَاحِدٌ':Added, #4: 4	قَوْلَ وَاحِدٍ
u'قول واحد':Added, #4: 4	قَوْلَ وَاحِدٍ
u'قَوْلٌ واحد':Added, #5: 5	قَوْلَ الْوَاحِدِ
u'قول وَاحِدٌ':Added, #5: 5	قَوْلَ الْوَاحِدِ
u'قَوْلٌ وَاحِدٌ':Added, #5: 5	قَوْلَ الْوَاحِدِ
u'قول واحد':Added, #5: 5	قَوْلَ الْوَاحِدِ
u'قَوْلٌ واحد':Added, #6: 6	قَوْلِ الْوَاحِدِ
u'قول وَاحِدٌ':Added, #6: 6	قَوْلِ الْوَاحِدِ
u'قَوْلٌ وَاحِدٌ':Added, #6: 6	قَوْلِ الْوَاحِدِ
u'قول واحد':Added, #6: 6	قَوْلِ الْوَاحِدِ
u'قَوْلٌ واحد':Added, #7: 7	قَوْلِ وَاحِدٍ
u'قول وَاحِدٌ':Added, #7: 7	قَوْلِ وَاحِدٍ
u'قَوْلٌ وَاحِدٌ':Added, #7: 7	قَوْلِ وَاحِدٍ
u'قول وَارِثٌ':Added, #7: 7	قَوْلِ وَاحِدٍ
u'قَوْلٌ وَارِثٌ':Added, #17: 17	قَوْلُ الْوَارِثِ
u'قول وَارِثٌ':Added, #17: 17	قَوْلُ الْوَارِثِ
u'قَوْلٌ وَارِثٌ':Added, #1: 1	قَوْلِ الْوَارِثِ
u'قول وَارِثٌ':Added, #1: 1	قَوْلِ الْوَارِثِ
u'قَوْلٌ وَارِثٌ':Added, #1: 1	قَوْلُ وَارِثِهِ
u'قول وَارِثٌ':Added, #1: 1	قَوْلُ وَارِثِهِ
u'قَوْلٌ وَارِثٌ':Added, #2: 2	قَوْلِ وَارِثٍ
u'قول واصِف':Added, #2: 2	قَوْلِ وَارِثٍ
u'قَوْلٌ واصِف':Added, #2: 2	قَوْلِ الْوَاصِفِ
u'قول وَاضِعٌ':Added, #2: 2	قَوْلِ الْوَاصِفِ
u'قَوْلٌ وَاضِعٌ':Added, #1: 1	قَوْلِ الْوَاضِعِ
u'قول وَاضِعٌ':Added, #1: 1	قَوْلِ الْوَاضِعِ
u'قَوْلٌ وَاضِعٌ':Added, #1: 1	قَوْلُ وَاضِعِهِ
u'قول وَاضِعٌ':Added, #1: 1	قَوْلُ وَاضِعِهِ
u'قَوْلٌ وَاضِعٌ':Added, #2: 2	قَوْلُ الْوَاضِعِ
u'قول وَاقِعٌ':Added, #2: 2	قَوْلُ الْوَاضِعِ
u'قَوْلٌ وَاقِعٌ':Added, #1: 1	قَوْلَ الْوَاقِعِ
u'قول وَاقِفٌ':Added, #1: 1	قَوْلَ الْوَاقِعِ
u'قَوْلٌ وَاقِفٌ':Added, #14: 14	قَوْلِ الْوَاقِفِ
u'قول واقِف':Added, #14: 14	قَوْلِ الْوَاقِفِ
u'قَوْلٌ واقِف':Added, #1: 1	قَوْلُ الْوَاقِفِيَّةِ
u'قول وَاقِفٌ':Added, #1: 1	قَوْلُ الْوَاقِفِيَّةِ
u'قَوْلٌ وَاقِفٌ':Added, #2: 2	قَوْل الْوَاقِفِ
u'قول وَاقِفٌ':Added, #2: 2	قَوْل الْوَاقِفِ
u'قول وَاقِفٌ':Added, #2: 2	قَوْلَ الْوَاقِفَةِ
u'قَوْلٌ وَاقِفٌ':Added, #2: 2	قَوْلِ الْوَاقِفَةِ
u'قَوْلٌ وَاقِفٌ':Added, #2: 2	قَوْلَ الْوَاقِفَةِ
u'قول وَاقِفٌ':Added, #2: 2	قَوْلِ الْوَاقِفَةِ
u'قَوْلٌ وَاقِفٌ':Added, #6: 6	قَوْلُ الْوَاقِفِ
u'قول وَاقِفٌ':Added, #6: 6	قَوْلُ الْوَاقِفِ
u'قَوْلٌ وَاقِفٌ':Added, #8: 8	قَوْلَ الْوَاقِفِ
u'قول وَالِدٌ':Added, #8: 8	قَوْلَ الْوَاقِفِ
u'قَوْلٌ وَالِدٌ':Added, #1: 1	قَوْلِ وَالِدِهِ
u'قول وَاهِبٌ':Added, #1: 1	قَوْلِ وَالِدِهِ
u'قَوْلٌ وَاهِبٌ':Added, #1: 1	قَوْلَ الْوَاهِبِ
u'قول وَاهِبٌ':Added, #1: 1	قَوْلَ الْوَاهِبِ
u'قَوْلٌ وَاهِبٌ':Added, #8: 8	قَوْلُ الْوَاهِبِ
u'قول وَجْهٌ':Added, #8: 8	قَوْلُ الْوَاهِبِ
u'قَوْلٌ وَجْهٌ':Added, #1: 1	قَوْلِ الْوَجْهِ
u'قول وُجُوبٌ':Added, #1: 1	قَوْلِ الْوَجْهِ
u'قول وُجُوبٌ':Added, #1: 1	قَوْلَ الْوُجُوبِ
u'قَوْلٌ وُجُوبٌ':Added, #1: 1	قَوْلِ الْوُجُوبِ
u'قَوْلٌ وُجُوبٌ':Added, #1: 1	قَوْلَ الْوُجُوبِ
u'قول وَجِيزٌ':Added, #1: 1	قَوْلِ الْوُجُوبِ
u'قَوْلٌ وَجِيزٌ':Added, #1: 1	قَوْلِ الْوَجِيزِ
u'قول وَرَثَةٌ':Added, #1: 1	قَوْلِ الْوَجِيزِ
u'قَوْلٌ وَرَثَةٌ':Added, #13: 13	قَوْلُ الْوَرَثَةِ
u'قول وَرَثَةٌ':Added, #13: 13	قَوْلُ الْوَرَثَةِ
u'قَوْلٌ وَرَثَةٌ':Added, #1: 1	قَوْلِ الْوَرَثَةِ
u'قول وَرَثَةٌ':Added, #1: 1	قَوْلِ الْوَرَثَةِ
u'قَوْلٌ وَرَثَةٌ':Added, #1: 1	قَوْلِ وَرَثَةِ
u'قول وَرَثَةٌ':Added, #1: 1	قَوْلِ وَرَثَةِ
u'قَوْلٌ وَرَثَةٌ':Added, #2: 2	قَوْلَ وَرَثَةِ
u'قول وَرَثَةٌ':Added, #2: 2	قَوْلَ وَرَثَةِ
u'قَوْلٌ وَرَثَةٌ':Added, #3: 3	قَوْلُ وَرَثَتِهِ
u'قول وَرَثَةٌ':Added, #3: 3	قَوْلُ وَرَثَتِهِ
u'قَوْلٌ وَرَثَةٌ':Added, #5: 5	قَوْلَ الْوَرَثَةِ
u'قول وَرَثَةٌ':Added, #5: 5	قَوْلَ الْوَرَثَةِ
u'قَوْلٌ وَرَثَةٌ':Added, #8: 8	قَوْلُ وَرَثَةِ
u'قول وَسِيطٌ':Added, #8: 8	قَوْلُ وَرَثَةِ
u'قَوْلٌ وَسِيطٌ':Added, #1: 1	قَوْلَ الْوَسِيطِ
u'قول وَسِيطٌ':Added, #1: 1	قَوْلَ الْوَسِيطِ
u'قَوْلٌ وَسِيطٌ':Added, #2: 2	قَوْلُ الْوَسِيطِ
u'قول وَصِيٌّ':Added, #2: 2	قَوْلُ الْوَسِيطِ
u'قَوْلٌ وَصِيٌّ':Added, #1: 1	قَوْلِ الْوَصِيِّ
u'قول وَصِيٌّ':Added, #1: 1	قَوْلِ الْوَصِيِّ
u'قَوْلٌ وَصِيٌّ':Added, #22: 22	قَوْلُ الْوَصِيِّ
u'قول وَصِيٌّ':Added, #22: 22	قَوْلُ الْوَصِيِّ
u'قَوْلٌ وَصِيٌّ':Added, #4: 4	قَوْلَ الْوَصِيِّ
u'قول وِقَايَةٌ':Added, #4: 4	قَوْلَ الْوَصِيِّ
u'قول وِقَايَةٌ':Added, #1: 1	قَوْلَ الْوِقَايَةِ
u'قَوْلٌ وِقَايَةٌ':Added, #1: 1	قَوْلِ الْوِقَايَةِ
u'قَوْلٌ وِقَايَةٌ':Added, #1: 1	قَوْلَ الْوِقَايَةِ
u'قول وَقْفٌ':Added, #1: 1	قَوْلِ الْوِقَايَةِ
u'قول وَقْفٌ':Added, #1: 1	قَوْلَ الْوَقْفِ
u'قَوْلٌ وَقْفٌ':Added, #1: 1	قَوْلُ الْوَقْفِ
u'قَوْلٌ وَقْفٌ':Added, #1: 1	قَوْلَ الْوَقْفِ
u'قول وَقْفٌ':Added, #1: 1	قَوْلُ الْوَقْفِ
u'قول وَقْفٌ':Added, #1: 1	قَوْلُ وَقْفِ
u'قَوْلٌ وَقْفٌ':Added, #1: 1	قَوْلِ وَقْفِ
u'قَوْلٌ وَقْفٌ':Added, #1: 1	قَوْلُ وَقْفِ
u'قول وَقْفٌ':Added, #1: 1	قَوْلِ وَقْفِ
u'قَوْلٌ وَقْفٌ':Added, #4: 4	قَوْلِ الْوَقْفِ
u'قول وَكِيلٌ':Added, #4: 4	قَوْلِ الْوَقْفِ
u'قَوْلٌ وَكِيلٌ':Added, #1: 1	قَوْلَ وَكِيلِ
u'قول وَكِيلٌ':Added, #1: 1	قَوْلَ وَكِيلِ
u'قَوْلٌ وَكِيلٌ':Added, #29: 29	قَوْلُ الْوَكِيلِ
u'قول وَكِيلٌ':Added, #29: 29	قَوْلُ الْوَكِيلِ
u'قَوْلٌ وَكِيلٌ':Added, #2: 2	قَوْلُ وَكِيلِ
u'قول وَكِيلٌ':Added, #2: 2	قَوْلُ وَكِيلِ
u'قَوْلٌ وَكِيلٌ':Added, #5: 5	قَوْلَ الْوَكِيلِ
u'قول وَكِيلٌ':Added, #5: 5	قَوْلَ الْوَكِيلِ
u'قَوْلٌ وَكِيلٌ':Added, #6: 6	قَوْلِ الْوَكِيلِ
u'قول ولد':Added, #6: 6	قَوْلِ الْوَكِيلِ
u'قَوْلٌ ولد':Added, #1: 1	قَوْلِ الْوَلَدِ
u'قول وَلَدٌ':Added, #1: 1	قَوْلِ الْوَلَدِ
u'قَوْلٌ وَلَدٌ':Added, #1: 1	قَوْلِ الْوَلَدِ
u'قول ولد':Added, #1: 1	قَوْلِ الْوَلَدِ
u'قَوْلٌ ولد':Added, #1: 1	قَوْلِ وَلَدِهِ
u'قول وَلَدٌ':Added, #1: 1	قَوْلِ وَلَدِهِ
u'قَوْلٌ وَلَدٌ':Added, #1: 1	قَوْلِ وَلَدِهِ
u'قول ولد':Added, #1: 1	قَوْلِ وَلَدِهِ
u'قَوْلٌ ولد':Added, #5: 5	قَوْلُ الْوَلَدِ
u'قول وَلَدٌ':Added, #5: 5	قَوْلُ الْوَلَدِ
u'قَوْلٌ وَلَدٌ':Added, #5: 5	قَوْلُ الْوَلَدِ
u'قول وَلِيٌّ':Added, #5: 5	قَوْلُ الْوَلَدِ
u'قَوْلٌ وَلِيٌّ':Added, #17: 17	قَوْلُ الْوَلِيِّ
u'قول وَلِيٌّ':Added, #17: 17	قَوْلُ الْوَلِيِّ
u'قول وَلِيٌّ':Added, #1: 1	قَوْلَ الْوَلِيِّ
u'قَوْلٌ وَلِيٌّ':Added, #1: 1	قَوْلِ الْوَلِيِّ
u'قَوْلٌ وَلِيٌّ':Added, #1: 1	قَوْلَ الْوَلِيِّ
u'قول وَلِيٌّ':Added, #1: 1	قَوْلِ الْوَلِيِّ
u'قَوْلٌ وَلِيٌّ':Added, #1: 1	قَوْلِ وَلِيِّهِ
u'قول وَلِيٌّ':Added, #1: 1	قَوْلِ وَلِيِّهِ
u'قَوْلٌ وَلِيٌّ':Added, #2: 2	قَوْلُ وَلِيِّ
u'قول يَتِيمٌ':Added, #2: 2	قَوْلُ وَلِيِّ
u'قَوْلٌ يَتِيمٌ':Added, #1: 1	قَوْلُ الْيَتِيمِ
u'قول يهود':Added, #1: 1	قَوْلُ الْيَتِيمِ
u'قول يَهُودٌ':Added, #1: 1	قَوْلِ الْيَهُودِ
u'قَوْلٌ يهود':Added, #1: 1	قَوْلِ الْيَهُودِ
u'قَوْلٌ يَهُودٌ':Added, #1: 1	قَوْلِ الْيَهُودِ
u'قول يَهُودِيٌّ':Added, #1: 1	قَوْلِ الْيَهُودِ
u'قول يَهُودِيٌّ':Added, #1: 1	قَوْلَ الْيَهُودِيِّ
u'قَوْلٌ يَهُودِيٌّ':Added, #1: 1	قَوْلُ الْيَهُودِيِّ
u'قَوْلٌ يَهُودِيٌّ':Added, #1: 1	قَوْلَ الْيَهُودِيِّ
u'قَوْمٌ أَبٌ':Added, #1: 1	قَوْلُ الْيَهُودِيِّ
u'قَوْمٌ أَبٌ':Added, #14: 14	قَوْمِ الْأَبِ
u'قَوْمٌ اِبْنٌ':Added, #1: 1	قَوْمَ الْأَبِ
u'قَوَّمَ آخِرُ':Predicate, #1: 1	قَوْمِ ابْنِ
u'قَوْمٌ أُمٌّ':Added, #1: 1	قَوَّمَ آخِرَ
u'قَوْمٌ أُمٌّ':Added, #2: 2	قَوْمَ الْأُمِّ
u'قَوْمٌ أُمٌّ':Added, #5: 5	قَوْمُ الْأُمِّ
u'قَوْمٌ أُمٌّ':Added, #6: 6	قَوْمُ أُمِّهِ
u'قَوْمٌ أُمٌّ':Added, #7: 7	قَوْمِ أُمِّهِ
u'قَوَّمَ بدنة':Predicate, #8: 8	قَوْمِ الْأُمِّ
u'قَوَّمَ بِضاعَةٌ':Predicate, #2: 2	قَوَّمَ الْبَدَنَةَ
u'قَوْمَةٌ رُكوعٌ':Added, #1: 1	قَوَّمَ الْبِضَاعَةَ
u'قَوَّمَ جَزَاءٌ':Predicate, #4: 4	قَوْمَةِ الرُّكُوعِ
u'قَوَّمَ جلد':Predicate, #3: 3	قَوَّمَ الْجَزَاءَ
u'قَوَّمَ جِلْدٌ':Predicate, #1: 1	قَوَّمَ الْجِلْدَ
u'قَوَّمَ حِجازِيّ':Predicate, #1: 1	قَوَّمَ الْجِلْدَ
u'قَوْمٌ حَسَدٌ':Added, #1: 1	قَوَّمَ الْحِجَازِيَّةَ
u'قَوَّمَ دِيَةٌ':Predicate, #2: 2	قَوْمَ حَسَدٍ
u'قَوْمٌ رَجُلٌ':Added, #1: 1	قَوَّمَ الدِّيَةَ
u'قَوْمٌ رَسُولٌ':Added, #1: 1	قَوْمُ الرّجُلِ
u'قَوْمٌ سَفَرٌ':Added, #1: 1	قَوْمُ رَسُولِ
u'قَوْمٌ سُفْلٌ':Added, #2: 2	قَوْمُ سَفَرٍ
u'قَوْمٌ سُوءٌ':Added, #1: 1	قَوْمٍ سُفْلٍ
u'قَوْمٌ صَاحِبٌ':Added, #3: 3	قَوْمُ سُوءٍ
u'قَوْمٌ صَالِحٌ':Added, #1: 1	قَوْمِ صَاحِبِ
u'قَوْمٌ صَالِح':Added, #1: 1	قَوْمَ صَالِحٍ
u'قَوْمٌ صَالِحٌ':Added, #1: 1	قَوْمَ صَالِحٍ
u'قَوْمٌ صَالِح':Added, #3: 3	قَوْمُ صَالِحٍ
u'قَوَّمَ صَيْدٌ':Predicate, #3: 3	قَوْمُ صَالِحٍ
u'قَوْمٌ ضِمَادٌ':Added, #1: 1	قَوَّمَ الصَّيْدَ
u'قَوْمٌ عَادٌ':Added, #1: 1	قَوْمُ ضِمَادٍ
u'قَوْمٌ عَبْدٌ':Added, #1: 1	قَوْمُ عَادٍ
u'قَوْمٌ عَدُوٌّ':Added, #3: 3	قَوْمُ عَبْدِ
u'قَوْمٌ عُدُولٌ':Added, #18: 18	قَوْمٍ عَدُوٍّ
u'قَوْمٌ عُرَاةٌ':Added, #2: 2	قَوْمٍ عُدُولٍ
u'قَوْمٌ عَرَبٌ':Added, #1: 1	قَوْمٍ عُرَاةٍ
u'قَوْمٌ عُكُوفٌ':Added, #1: 1	قَوْمُ عَرَبٍ
u'قَوَّمَ عند':Predicate, #1: 1	قَوْمٍ عُكُوفٍ
u'قَوَّمَ غُرَّةٌ':Predicate, #1: 1	قَوَّمَ عِنْدَ
u'قَوَّمَ فلان':Predicate, #4: 4	قَوَّمَ الْغُرَّةَ
u'قَوْمٌ فلان':Added, #1: 1	قَوَّمَ الْحِجَازِيَّةَ
u'قَوْمٌ فلان':Added, #1: 1	قَوْمَ شُعَيْبٍ
u'قَوْمٌ فلان':Added, #1: 1	قَوْمُ شُعَيْبٍ
u'قَوَّمَ قِيمَةٌ':Subject, #2: 2	قَوْمِ شُعَيْبٍ
u'قَوْمٌ كُفَّارٌ':Added, #1: 1	قَوَّمَ قِيمَتُهُ
u'قَوْمٌ مَالِكٌ':Added, #7: 7	قَوْمٍ كُفَّارٍ
u'قَوَّمَ مثل':Predicate, #1: 1	قَوْمِ مَالِكِ
u'قَوَّمَ مِثْلٌ':Predicate, #1: 1	قَوَّمَ الْمِثْلَ
u'قَوَّمَ مِثْلِيٌّ':Predicate, #1: 1	قَوَّمَ الْمِثْلَ
u'قَوْمٌ مَرْهُونٌ':Added, #1: 1	قَوَّمَ الْمِثْلِيَّ
u'قَوَّمَ مَقْتُولٌ':Predicate, #1: 1	قَوْمِ الْمَرْهُونِ
u'قَوْمٌ مُلُوكٌ':Added, #1: 1	قَوَّمَ الْمَقْتُولَ
u'قَوَّمَ مَوْرُوثٌ':Predicate, #1: 1	قَوْمٍ مُلُوكٍ
u'قَوْمٌ هِلاَلٌ':Added, #1: 1	قَوَّمَ الْمَوْرُوثَ
u'قَوْمٌ هُودٌ':Added, #1: 1	قَوْمِ هِلَالٍ
u'قَوَّمَ يَدٌ':Predicate, #2: 2	قَوْمَ هُودٍ
u'قَوِيَ آثَارٌ':Predicate, #1: 1	قَوَّمَ الْيَدَ
u'قَوِيَ أثَرٌ':Subject, #1: 1	قَوِيَ الْآثَارَ
u'قَوِيَ أثَرٌ':Subject, #1: 1	قَوِيَ أَثَرُ
u'قَوِيَ اِجْتِهَادٌ':Subject, #7: 7	قَوِيَ أَثَرُهُ
u'قَوِيَ أَجْزَاءٌ':Predicate, #1: 1	قَوِيَ اجْتِهَادٌ
u'قَوِيَ إِسْلامٌ':Subject, #1: 1	أَقْوَى أَجْزَاءَ
u'قَوِيَ إِشْكالٌ':Subject, #2: 2	قَوِيَ الْإِسْلَامُ
u'قَوِيَ إِعْتاقٌ':Subject, #2: 2	قَوِيَ الْإِشْكَالُ
u'قَوَّى اِعْتِراضٌ':Predicate, #1: 1	قَوِيَ الْإِعْتَاقُ
u'قَوِيَ أَمْرٌ':Subject, #1: 1	قَوَّى اعْتِرَاضَ
u'قَوِيَ أَمْرٌ':Subject, #1: 1	قَوِيَ الْأَمْرُ
u'قَوِيَ إيمَانٌ':Subject, #1: 1	قَوِيَ أَمْرُهُ
u'قَوِيَ بِشْرٌ':Subject, #1: 1	قَوِيَ إيمَانُهُ
u'قَوِيَ بُعْدٌ':Subject, #1: 1	قَوِيَ بِشْرٌ
u'قَوِيَ تجَانُسٌ':Subject, #1: 1	قَوِيَ بُعْدُهُ
u'قَوِيَ تَحْرِيمٌ':Subject, #1: 1	قَوِيَ التَّجَانُسُ
u'قَوِيَ تَمْييزٌ':Subject, #1: 1	قَوِيَ التَّحْرِيمُ
u'قَوِيَ جَانِبٌ':Subject, #2: 2	قَوِيَ تَمْيِيزُهُ
u'قَوِيَ جَانِبٌ':Subject, #1: 1	قَوِيَ جَانِبُهُ
u'قَوِيَ جَوَازٌ':Subject, #3: 3	قَوِيَ جَانِبُ
u'قَوِيَ جَيْشٌ':Subject, #2: 2	قَوِيَ الْجَوَازُ
u'قَوِيَ حالٌ':Subject, #1: 1	قَوِيَ جَيْشُهُ
u'قَوِيَ حَبٌّ':Subject, #2: 2	قَوِيَ حَالُهُ
u'قَوِيَ حَديثٌ':Subject, #1: 1	قَوِيَ حَبُّهُ
u'قَوِيَ حِسٌّ':Subject, #1: 1	قَوِيَ الْحَدِيثُ
u'قَوِيَ حِفْظٌ':Subject, #1: 1	قَوِيَ الْحِسُّ
u'قَوِيَ حُكْمٌ':Subject, #1: 1	قَوِيَ الْحِفْظُ
u'قَوِيَ خَفِيٌّ':Subject, #1: 1	قَوِيَ الْحُكْمُ
u'قَوِيَ خَوْفٌ':Subject, #1: 1	قَوِيَ الْخَفِيُّ
u'قَوِيَ دَليلٌ':Subject, #2: 2	قَوِيَ الْخَوْفُ
u'قَوِيَ دَليلٌ':Subject, #1: 1	قَوِيَ دَلِيلُ
u'قَوِيَ دِينٌ':Subject, #3: 3	قَوِيَ دَلِيلُهُ
u'قَوِيَ سَبَبٌ':Subject, #1: 1	قَوِيَ دِينُهُ
u'قَوِيَ ظاهِرٌ':Subject, #3: 3	قَوِيَ سَبَبُ
u'قَوَّى ظَنٌّ':Subject, #2: 2	قَوِيَ الظَّاهِرُ
u'قَوِيَ ظَنٌّ':Subject, #1: 1	قَوَّى الظَّنُّ
u'قَوِيَ عند':Predicate, #4: 4	قَوِيَ الظَّنُّ
u'قَوَّى عين':Predicate, #2: 2	أَقْوَى عِنْدَ
u'قَوَّى عَيْنٌ':Predicate, #1: 1	قَوَّى الْعَيْنَ
u'قَوَّى عَيْن':Predicate, #1: 1	قَوَّى الْعَيْنَ
u'قَوِيَ فَسْخٌ':Subject, #1: 1	قَوَّى الْعَيْنَ
u'قَوِيَ فطار':Predicate, #1: 1	قَوِيَ فَسْخُ
u'قَوِيَ فَهْمٌ':Subject, #1: 1	قَوِيَ فَطَارَ
u'قَوِيَ قَالٌ':Predicate, #1: 1	قَوِيَ فَهْمُ
u'قَوِيَ قول':Subject, #5: 5	أَقْوَى قَالَ
u'قَوِيَ قَوْلٌ':Subject, #1: 1	قَوِيَ قَوْلُ
u'قَوِيَ مَرَضٌ':Subject, #1: 1	قَوِيَ قَوْلُ
u'قَوِيَ وَجَبٌ':Predicate, #1: 1	قَوِيَ مَرَضُهُ
u'قَوِيَ وَجْهٌ':Subject, #1: 1	أَقْوَى وَجَبَ
u'قَوِيَ وَسْوَاسٌ':Subject, #1: 1	قَوِيَ وَجْهُهُ
u'قَوِيَ وُقُوعٌ':Subject, #1: 1	قَوِيَ الْوَسْوَاسُ
u'قَوِيَ يَقِينٌ':Subject, #1: 1	قَوِيَ وُقُوعُ
u'قَيْءٌ بالِغٌ':Added, #1: 1	قَوِيَ يَقِينُهُ
u'قَيْءٌ كَلْبٌ':Added, #2: 2	قَيْءٍ بَالِغٍ
u'قِيَادَةٌ نَفْسٌ':Added, #1: 1	قَيْءُ الْكَلْبِ
u'قِيَادٌ فَرَسٌ':Added, #2: 2	قِيَادَةِ نَفْسِهِ
u'قِيَادٌ فَرَسٌ':Added, #1: 1	قِيَادُ الْفَرَسِ
u'قِيَادٌ قِيَاسٌ':Added, #1: 1	قِيَادَ فَرَسِهِ
u'قِيَادٌ نَفْسٌ':Added, #1: 1	قِيَادَ قِيَاسِهِ
u'قِيَادٌ نَفْسٌ':Added, #1: 1	قِيَادُ النَّفْسِ
u'قِيَادٌ نَفْسٌ':Added, #1: 1	قِيَادُ نَفْسِهِ
u'قِيَاسٌ اِبْتِداءٌ':Added, #2: 2	قِيَادِ نَفْسِهِ
u'قِيَاسٌ إبدالٌ':Added, #1: 1	قِيَاسُ ابْتِدَاءِ
u'قِيَاسٌ اِبْنٌ':Added, #1: 1	قِيَاسِ إبْدَالِ
u'قِيَاسٌ اِبْنٌ':Added, #1: 1	قِيَاسَ ابْنِ
u'قِيَاسٌ اِبْنٌ':Added, #1: 1	قِيَاسِ ابْنِ
u'قِيَاسٌ أثَرٌ':Added, #2: 2	قِيَاسُ ابْنِ
u'قِيَاسٌ إجَارَةٌ':Added, #1: 1	قِيَاسُ الْأَثَرِ
u'قِيَاسٌ أحَدٌ':Added, #1: 1	قِيَاسِ الْإِجَارَاتِ
u'قِيَاسٌ أحَدٌ':Added, #1: 1	قِيَاسُ أَحَدٍ
u'قِيَاسٌ إِحْرَامٌ':Added, #1: 1	قِيَاسُ أَحَدِ
u'قِيَاسٌ اِسْتِحْسَانٌ':Added, #1: 1	قِيَاسُ الْإِحْرَامِ
u'قِيَاسٌ اِسْتِواءٌ':Added, #1: 1	قِيَاسُ اسْتِحْسَانٍ
u'قِيَاسٌ إِسْلامٌ':Added, #1: 1	قِيَاسُ اسْتِوَاءِ
u'قِيَاسٌ اِسْمٌ':Added, #1: 1	قِيَاسُ إسْلَامِ
u'قِيَاسٌ أَسيرٌ':Added, #1: 1	قِيَاسَ اسْمِ
u'قِيَاسٌ أشباه':Added, #1: 1	قِيَاسَ الْأَسِيرِ
u'قِيَاسٌ أشْبَاهٌ':Added, #1: 1	قِيَاسِ الْأَشْبَاهِ
u'قِيَاسٌ أَشْبَاهٌ':Added, #1: 1	قِيَاسِ الْأَشْبَاهِ
u'قِيَاسٌ أصل':Added, #1: 1	قِيَاسِ الْأَشْبَاهِ
u'قِيَاسٌ أًصْلٌ':Added, #1: 1	قِيَاسِ أَصْلِ
u'قِيَاسٌ أصل':Added, #1: 1	قِيَاسِ أَصْلِ
u'قِيَاسٌ أصل':Added, #1: 1	قِيَاسَ الْأَصْلِ
u'قِيَاسٌ أصل':Added, #1: 1	قِيَاسُ الْأَصْلِ
u'قِيَاسٌ أًصْلٌ':Added, #1: 1	قِيَاسِ الْأَصْلِ
u'قِيَاسٌ أًصْلٌ':Added, #1: 1	قِيَاسَ الْأَصْلِ
u'قِيَاسٌ أًصْلٌ':Added, #1: 1	قِيَاسُ الْأَصْلِ
u'قِيَاسٌ أصل':Added, #1: 1	قِيَاسِ الْأَصْلِ
u'قِيَاسٌ أًصْلٌ':Added, #2: 2	قِيَاسُ أَصْلِ
u'قِيَاسٌ أَصْوَاتٌ':Added, #2: 2	قِيَاسُ أَصْلِ
u'قِيَاسٌ أُصولٌ':Added, #1: 1	قِيَاسُ الْأَصْوَاتِ
u'قِيَاسٌ أُصولٌ':Added, #1: 1	قِيَاسُ أُصُولِ
u'قِيَاسٌ أُصولٌ':Added, #3: 3	قِيَاسَ الْأُصُولِ
u'قِيَاسٌ أُصولٌ':Added, #3: 3	قِيَاسُ الْأُصُولِ
u'قِيَاسٌ إِعادَةٌ':Added, #6: 6	قِيَاسِ الْأُصُولِ
u'قِيَاسٌ إِعادَةٌ':Added, #1: 1	قِيَاسَ الْإِعَادَةِ
u'قِيَاسٌ اِعْتِبارٌ':Added, #2: 2	قِيَاسُ الْإِعَادَةِ
u'قِيَاسٌ اِعْتِمادٌ':Added, #1: 1	قِيَاسُ اعْتِبَارِ
u'قِيَاسٌ أَعْمَالٌ':Added, #1: 1	قِيَاسُ اعْتِمَادِ
u'قِيَاسٌ أَعْوَاضٌ':Added, #1: 1	قِيَاسَ أَعْمَالِ
u'قِيَاسٌ اِقْتِداءٌ':Added, #1: 1	قِيَاسِ الْأَعْوَاضِ
u'قِيَاسٌ إقْرَارٌ':Added, #1: 1	قِيَاسَ اقْتِدَاءِ
u'قِيَاسٌ الْمَرْأَةُ':Added, #2: 2	قِيَاسُ الْإِقْرَارِ
u'قِيَاسٌ إمَامَةٌ':Added, #1: 1	قِيَاسِ الْمَرْأَةِ
u'قِيَاسٌ أَمْرٌ':Added, #1: 1	قِيَاسُ الْإِمَامَةِ
u'قِيَاسٌ اِنْتِقالٌ':Added, #1: 1	قِيَاسُ الْأَمْرِ
u'قِيَاسٌ أَوَّلُ':Added, #1: 1	قِيَاسُ انْتِقَالِ
u'قِيَاسٌ أَوَّلُ':Added, #1: 1	قِيَاسَ الْأَوَّلِ
u'قِيَاسٌ إِيجَابٌ':Added, #2: 2	قِيَاسِ الْأَوَّلِ
u'قِيَاسٌ بَابٌ':Added, #1: 1	قِيَاسِ الْإِيجَابِ
u'قِيَاسٌ بَحْرٌ':Added, #2: 2	قِيَاسُ بَابِ
u'قِيَاسٌ بِرٌّ':Added, #1: 1	قِيَاسُ الْبَحْرِ
u'قِيَاسٌ بُرْهانٌ':Added, #1: 1	قِيَاسِ الْبِرِّ
u'قِيَاسٌ بُرْهَانٌ':Added, #1: 1	قِيَاسُ الْبُرْهَانِ
u'قِيَاسٌ بَعْضٌ':Added, #1: 1	قِيَاسُ الْبُرْهَانِ
u'قِيَاسٌ بَيْعٌ':Added, #1: 1	قِيَاسِ بَعْضِ
u'قِيَاسٌ بَيِّنَةٌ':Added, #2: 2	قِيَاسُ الْبَيْعِ
u'قِيَاسٌ تَحْقِيقٌ':Added, #1: 1	قِيَاسِ الْبَيِّنَاتِ
u'قِيَاسٌ تَحْقِيقٌ':Added, #1: 1	قِيَاسُ التَّحْقِيقِ
u'قِيَاسٌ تَحْقِيقٌ':Added, #1: 1	قِيَاسُ تَحْقِيقٍ
u'قِيَاسٌ تَخْصِيصٌ':Added, #4: 4	قِيَاسِ التَّحْقِيقِ
u'قِيَاسٌ تَرْتِيبٌ':Added, #1: 1	قِيَاسُ التَّخْصِيصِ
u'قِيَاسٌ تَرْتِيبٌ':Added, #1: 1	قِيَاسِ التَّرْتِيبِ
u'قِيَاسٌ تَسْمِيَة':Added, #1: 1	قِيَاسُ تَرْتِيبِ
u'قِيَاسٌ تَسْوِيَةٌ':Added, #1: 1	قِيَاسِ تَسْمِيَةِ
u'قِيَاسٌ تَسْوِيَةٌ':Added, #1: 1	قِيَاسَ التَّسْوِيَةِ
u'قِيَاسٌ تَشْبِيهٌ':Added, #2: 2	قِيَاسُ التَّسْوِيَةِ
u'قِيَاسٌ تَشْبِيهٌ':Added, #1: 1	قِيَاسَ تَشْبِيهٍ
u'قِيَاسٌ تَشَهُّدٌ':Added, #2: 2	قِيَاسَ تَشْبِيهِهِ
u'قِيَاسٌ تَصرِيفٌ':Added, #1: 1	قِيَاسُ التَّشَهُّدِ
u'قِيَاسٌ تَصَوُّرٌ':Added, #1: 1	قِيَاسِ التّصْرِيفِ
u'قِيَاسٌ تَعْلِيلٌ':Added, #1: 1	قِيَاسِ تَصَوُّرِ
u'قِيَاسٌ تَفْرِيطٌ':Added, #1: 1	قِيَاسِ تَعْلِيلِ
u'قِيَاسٌ تَقْديمٌ':Added, #1: 1	قِيَاسَ التَّفْرِيطِ
u'قِيَاسٌ تَقْريبٌ':Added, #1: 1	قِيَاسِ التَّقْدِيمِ
u'قِيَاسٌ تَقْريبٌ':Added, #1: 1	قِيَاسُ التَّقْرِيبِ
u'قِيَاسٌ تَقْريبٌ':Added, #2: 2	قِيَاسِ التَّقْرِيبِ
u'قِيَاسٌ تَكْبيرٌ':Added, #4: 4	قِيَاسَ التَّقْرِيبِ
u'قِيَاسٌ تَلْقِين':Added, #1: 1	قِيَاسَ التَّكْبِيرِ
u'قِيَاسٌ تَمْثيلٌ':Added, #1: 1	قِيَاسُ التَّلْقِينِ
u'قِيَاسٌ تَمْلِيكٌ':Added, #1: 1	قِيَاسِ التَّمْثِيلِ
u'قِيَاسٌ تَيَمُّمٌ':Added, #1: 1	قِيَاسُ تَمْلِيكِ
u'قِيَاسٌ ثَوْبٌ':Added, #1: 1	قِيَاسُ التَّيَمُّمِ
u'قِيَاسٌ ثَوْبٌ':Added, #1: 1	قِيَاسُ الثَّوْبِ
u'قِيَاسٌ جُزْءٌ':Added, #1: 1	قِيَاسُ ثَوْبٍ
u'قِيَاسٌ جَلِيٌّ':Added, #1: 1	قِيَاسِ الْجُزْءِ
u'قِيَاسٌ جماع':Added, #3: 3	قِيَاسٍ جَلِيٍّ
u'قِيَاسٌ جِمَاعٌ':Added, #1: 1	قِيَاسُ الْجِمَاعِ
u'قِيَاسٌ جمع':Added, #1: 1	قِيَاسُ الْجِمَاعِ
u'قِيَاسٌ جمع':Added, #1: 1	قِيَاسُ الْجَمْعِ
u'قِيَاسٌ جَمْعٌ':Added, #1: 1	قِيَاسِ الْجَمْعِ
u'قِيَاسٌ جَمْعٌ':Added, #1: 1	قِيَاسُ الْجَمْعِ
u'قِيَاسٌ جمعة':Added, #1: 1	قِيَاسِ الْجَمْعِ
u'قِيَاسٌ جُمُعَةٌ':Added, #1: 1	قِيَاسِ الْجُمُعَةِ
u'قِيَاسٌ جُمْلَةٌ':Added, #1: 1	قِيَاسِ الْجُمُعَةِ
u'قِيَاسٌ حَجْرٌ':Added, #2: 2	قِيَاسَ الْجُمْلَةِ
u'قِيَاسٌ حَدٌّ':Added, #1: 1	قِيَاسُ الْحَجْرِ
u'قِيَاسٌ حَدَثٌ':Added, #1: 1	قِيَاسُ حَدِّ
u'قِيَاسٌ حَرَكَةٌ':Added, #1: 1	قِيَاسَ الْحَدَثِ
u'قِيَاسٌ حُرْمَةٌ':Added, #1: 1	قِيَاسِ الْحَرَكَةِ
u'قِيَاسٌ حَسَنٌ':Added, #1: 1	قِيَاسُ حُرْمَةِ
u'قِيَاسٌ حُصُول':Added, #1: 1	قِيَاسِ الْحَسَنِ
u'قِيَاسٌ حَضَرٌ':Added, #1: 1	قِيَاسِ حُصُولِ
u'قِيَاسٌ حَلْقٌ':Added, #1: 1	قِيَاسِ الْحَضَرِ
u'قِيَاسٌ حُلِيٌّ':Added, #1: 1	قِيَاسِ الْحَلْقِ
u'قِيَاسٌ حَمْلٌ':Added, #1: 1	قِيَاسِ حُلِيِّ
u'قِيَاسٌ خَالٌ':Added, #1: 1	قِيَاسُ الْحَمْلِ
u'قِيَاسٌ خراج':Added, #1: 1	قِيَاسِ الْخَالَاتِ
u'قِيَاسٌ خَرَاجٌ':Added, #1: 1	قِيَاسُ خَرَاجِ
u'قِيَاسٌ خُرُوجٌ':Added, #1: 1	قِيَاسُ خَرَاجِ
u'قِيَاسٌ خَصْمٌ':Added, #1: 1	قِيَاسَ خُرُوجِ
u'قِيَاسٌ خَصْمٌ':Added, #1: 1	قِيَاسُ خَصْمِهِ
u'قِيَاسٌ خَمْرٌ':Added, #3: 3	قِيَاسِ الْخَصْمِ
u'قِيَاسٌ خيار':Added, #1: 1	قِيَاسَ الْخَمْرِ
u'قِيَاسٌ خِيَارٌ':Added, #1: 1	قِيَاسِ خِيَارِ
u'قِيَاسٌ دَجاج':Added, #1: 1	قِيَاسِ خِيَارِ
u'قِيَاسٌ دَرَاهِمُ':Added, #1: 1	قِيَاسِ الدَّجَاجَةِ
u'قِيَاسٌ دُعَاءٌ':Added, #1: 1	قِيَاسُ الدَّرَاهِمِ
u'قِيَاسٌ دَلالَةٌ':Added, #1: 1	قِيَاسِ الدُّعَاءِ
u'قِيَاسٌ دَلالَةٌ':Added, #1: 1	قِيَاسِ دَلَالَةٍ
u'قِيَاسٌ دَلالَةٌ':Added, #6: 6	قِيَاسَ الدَّلَالَةِ
u'قِيَاسٌ دَلالَةٌ':Added, #7: 7	قِيَاسُ الدَّلَالَةِ
u'قِيَاسٌ دَمٌ':Added, #7: 7	قِيَاسِ الدَّلَالَةِ
u'قِيَاسٌ دونٌ':Added, #1: 1	قِيَاسُ الدَّمِ
u'قِيَاسٌ ذِراعٌ':Added, #1: 1	قِيَاسَ الدُّونِ
u'قِيَاسٌ ذُرَةٌ':Added, #1: 1	قِيَاسَ الذِّرَاعِ
u'قِيَاسٌ رِبَوِيّ':Added, #2: 2	قِيَاسِ الذُّرَةِ
u'قِيَاسٌ رَدٌّ':Added, #1: 1	قِيَاسِ رِبَوِيَّةِ
u'قِيَاسٌ رَمْيٌ':Added, #1: 1	قِيَاسُ الرَّدِّ
u'قِيَاسٌ رَهْنٌ':Added, #1: 1	قِيَاسَ الرَّمْيِ
u'قِيَاسٌ رِوايَةٌ':Added, #1: 1	قِيَاسِ الرَّهْنِ
u'قِيَاسٌ رِوايَةٌ':Added, #1: 1	قِيَاسَ الرِّوَايَةِ
u'قِيَاسٌ رِوايَةٌ':Added, #1: 1	قِيَاسُ رِوَايَةِ
u'قِيَاسٌ رِوايَةٌ':Added, #3: 3	قِيَاسِ رِوَايَةِ
u'قِيَاسٌ زَكاةٌ':Added, #4: 4	قِيَاسُ الرِّوَايَةِ
u'قِيَاسٌ زَكاةٌ':Added, #1: 1	قِيَاسُ الزَّكَاةِ
u'قِيَاسٌ زَمانٌ':Added, #1: 1	قِيَاسَ زَكَاةِ
u'قِيَاسٌ زَمَنٌ':Added, #1: 1	قِيَاسِ الزَّمَانِ
u'قِيَاسٌ سَائِرٌ':Added, #1: 1	قِيَاسُ زَمَنِ
u'قِيَاسٌ سَائِرٌ':Added, #2: 2	قِيَاسَ سَائِرِ
u'قِيَاسٌ سَائِرٌ':Added, #3: 3	قِيَاسُ سَائِرِ
u'قِيَاسٌ سترة':Added, #4: 4	قِيَاسِ سَائِرِ
u'قِيَاسٌ سُتْرَةٌ':Added, #1: 1	قِيَاسُ السُّتْرَةِ
u'قِيَاسٌ سجدة':Added, #1: 1	قِيَاسُ السُّتْرَةِ
u'قِيَاسٌ سَجْدَةٌ':Added, #1: 1	قِيَاسَ السَّجْدَةِ
u'قِيَاسٌ سجدة':Added, #1: 1	قِيَاسَ السَّجْدَةِ
u'قِيَاسٌ سَجْدَةٌ':Added, #1: 1	قِيَاسُ سَجْدَةِ
u'قِيَاسٌ سُجُودٌ':Added, #1: 1	قِيَاسُ سَجْدَةِ
u'قِيَاسٌ سَفَرٌ':Added, #2: 2	قِيَاسُ سُجُودِ
u'قِيَاسٌ سَلَمٌ':Added, #1: 1	قِيَاسُ السَّفَرِ
u'قِيَاسٌ سَلَمٌ':Added, #1: 1	قِيَاسُ السَّلَمِ
u'قِيَاسٌ سَنَةٌ':Added, #3: 3	قِيَاسِ السَّلَمِ
u'قِيَاسٌ سُنَّةٌ':Added, #1: 1	قِيَاسُ السَّنَةِ
u'قِيَاسٌ سَوائِمُ':Added, #2: 2	قِيَاسُ السُّنَّةِ
u'قِيَاسٌ سَوَائِمُ':Added, #1: 1	قِيَاسُ السَّوَائِمِ
u'قِيَاسٌ شافِعِيّ':Added, #1: 1	قِيَاسُ السَّوَائِمِ
u'قِيَاسٌ شَبَهٌ':Added, #5: 5	قِيَاسِ الشَّافِعِيِّ
u'قِيَاسٌ شَبَهٌ':Added, #12: 12	قِيَاسُ الشَّبَهِ
u'قِيَاسٌ شَبَهٌ':Added, #13: 13	قِيَاسِ الشَّبَهِ
u'قِيَاسٌ شَبَهٌ':Added, #1: 1	قِيَاسَ شَبَهٍ
u'قِيَاسٌ شُبْهَةٌ':Added, #4: 4	قِيَاسَ الشَّبَهِ
u'قِيَاسٌ شَحْمٌ':Added, #1: 1	قِيَاسِ الشُّبْهَةِ
u'قِيَاسٌ شَرْعِيٌّ':Added, #1: 1	قِيَاسَ الشَّحْمِ
u'قِيَاسٌ شفعة':Added, #1: 1	قِيَاسُ الشَّرْعِيَّاتِ
u'قِيَاسٌ شُفْعَةٌ':Added, #1: 1	قِيَاسُ الشُّفْعَةِ
u'قِيَاسٌ شَيْءٌ':Added, #1: 1	قِيَاسُ الشُّفْعَةِ
u'قِيَاسٌ صَحَابَةٌ':Added, #2: 2	قِيَاسُ الشَّيْءِ
u'قِيَاسٌ صَفٌّ':Added, #1: 1	قِيَاسِ الصَّحَابَةِ
u'قِيَاسٌ صَلاَةٌ':Added, #1: 1	قِيَاسُ الصَّفِّ
u'قِيَاسٌ صَلاَةٌ':Added, #1: 1	قِيَاسَ الصَّلَاةِ
u'قِيَاسٌ صَلاَةٌ':Added, #1: 1	قِيَاسَ صَلَاةِ
u'قِيَاسٌ صَلاَةٌ':Added, #2: 2	قِيَاسُ الصَّلَاةِ
u'قِيَاسٌ صُورَةٌ':Added, #5: 5	قِيَاسِ الصَّلَاةِ
u'قِيَاسٌ صَوْمٌ':Added, #1: 1	قِيَاسُ الصُّورَةِ
u'قِيَاسٌ صَوْمٌ':Added, #1: 1	قِيَاسَ الصَّوْمِ
u'قِيَاسٌ صَوْمٌ':Added, #1: 1	قِيَاسُ صَوْمِ
u'قِيَاسٌ صَوْمٌ':Added, #1: 1	قِيَاسِ صَوْمِ
u'قِيَاسٌ صَوْمٌ':Added, #2: 2	قِيَاسُ الصَّوْمِ
u'قِيَاسٌ صَيْدٌ':Added, #8: 8	قِيَاسِ الصَّوْمِ
u'قِيَاسٌ ضحك':Added, #1: 1	قِيَاسِ صَيْدِ
u'قِيَاسٌ ضَحِكٌ':Added, #1: 1	قِيَاسُ ضَحِكهِ
u'قِيَاسٌ طَرْدٌ':Added, #1: 1	قِيَاسُ ضَحِكهِ
u'قِيَاسٌ طَرِيقٌ':Added, #1: 1	قِيَاسُ الطَّرْدِ
u'قِيَاسٌ طَرِيقَةٌ':Added, #3: 3	قِيَاسِ الطَّرِيقِ
u'قِيَاسٌ طَلاَقٌ':Added, #1: 1	قِيَاسِ طَرِيقَةِ
u'قِيَاسٌ طَلاَقٌ':Added, #1: 1	قِيَاسَ الطَّلَاقِ
u'قِيَاسٌ طَلاَقٌ':Added, #1: 1	قِيَاسِ الطَّلَاقِ
u'قِيَاسٌ طلب':Added, #3: 3	قِيَاسُ الطَّلَاقِ
u'قِيَاسٌ طَلَبٌ':Added, #1: 1	قِيَاسَ طَلَبِ
u'قِيَاسٌ ظاهِرٌ':Added, #1: 1	قِيَاسَ طَلَبِ
u'قِيَاسٌ ظاهِرٌ':Added, #1: 1	قِيَاسَ ظَاهِرِ
u'قِيَاسٌ ظاهِرٌ':Added, #2: 2	قِيَاسُ ظَاهِرِ
u'قِيَاسٌ عَامِدٌ':Added, #4: 4	قِيَاسِ ظَاهِرِ
u'قِيَاسٌ عَبْدٌ':Added, #1: 1	قِيَاسِ الْعَامِدِ
u'قِيَاسٌ عَبْدٌ':Added, #1: 1	قِيَاسُ الْعَبْدِ
u'قِيَاسٌ عَدَدٌ':Added, #1: 1	قِيَاسِ الْعَبْدِ
u'قِيَاسٌ عَدَمٌ':Added, #1: 1	قِيَاسُ الْعَدَدِ
u'قِيَاسٌ عَدَمٌ':Added, #1: 1	قِيَاسُ عَدَمِ
u'قِيَاسٌ عَدَمٌ':Added, #2: 2	قِيَاسِ عَدَمِ
u'قِيَاسٌ عَرَبِيٌّ':Added, #3: 3	قِيَاسَ عَدَمِ
u'قِيَاسٌ عَرَبِيٌّ':Added, #1: 1	قِيَاسُ الْعَرَبِيَّةِ
u'قِيَاسٌ عُضْوٌ':Added, #1: 1	قِيَاسِ الْعَرَبِيَّةِ
u'قِيَاسٌ عُقُودٌ':Added, #1: 1	قِيَاسُ الْعُضْوِ
u'قِيَاسٌ عَكْسٌ':Added, #1: 1	قِيَاسُ الْعُقُودِ
u'قِيَاسٌ عَكْسٌ':Added, #1: 1	قِيَاسَ الْعَكْسِ
u'قِيَاسٌ عَكْسٌ':Added, #1: 1	قِيَاسُ عَكْسٍ
u'قِيَاسٌ عَكْسٌ':Added, #2: 2	قِيَاسِ الْعَكْسِ
u'قِيَاسٌ عِلَّةٌ':Added, #3: 3	قِيَاسُ الْعَكْسِ
u'قِيَاسٌ عِلَّةٌ':Added, #14: 14	قِيَاسِ الْعِلَّةِ
u'قِيَاسٌ عِلَّةٌ':Added, #1: 1	قِيَاسِ عِلَّةِ
u'قِيَاسٌ عِلَّةٌ':Added, #2: 2	قِيَاسَ الْعِلَّةِ
u'قِيَاسٌ عِلَّةٌ':Added, #3: 3	قِيَاسُ عِلَّةِ
u'قِيَاسٌ عِلَلٌ':Added, #9: 9	قِيَاسُ الْعِلَّةِ
u'قِيَاسٌ عِلَلٌ':Added, #1: 1	قِيَاسِ الْعِلَلِ
u'قِيَاسٌ عِلِّيٌّ':Added, #1: 1	قِيَاسُ عِلَلٍ
u'قِيَاسٌ عِلِّيٌّ':Added, #1: 1	قِيَاسَ عِلِّيَّةِ
u'قِيَاسٌ عَمَلٌ':Added, #1: 1	قِيَاسُ عِلِّيَّةِ
u'قِيَاسٌ غَائِبٌ':Added, #1: 1	قِيَاسِ عَمَلِ
u'قِيَاسٌ غَائِبٌ':Added, #1: 1	قِيَاسِ الْغَائِبِ
u'قِيَاسٌ غبار':Added, #1: 1	قِيَاسٍ غَائِبٍ
u'قِيَاسٌ غُبَارٌ':Added, #1: 1	قِيَاسُ الْغُبَارِ
u'قِيَاسٌ غَرَامَةٌ':Added, #1: 1	قِيَاسُ الْغُبَارِ
u'قِيَاسٌ غَلَبَةٌ':Added, #1: 1	قِيَاسِ الْغَرَامَاتِ
u'قِيَاسٌ غير':Added, #1: 1	قِيَاسَ غَلَبَةِ
u'قِيَاسٌ غَيْرٌ':Added, #1: 1	قِيَاسُ غَيْرِ
u'قِيَاسٌ فَرَائِضُ':Added, #1: 1	قِيَاسُ غَيْرِ
u'قِيَاسٌ فَرْضٌ':Added, #1: 1	قِيَاسِ الْفَرَائِضِ
u'قِيَاسٌ فَرْعٌ':Added, #1: 1	قِيَاسَ الْفَرْضِ
u'قِيَاسٌ فَصْلٌ':Added, #2: 2	قِيَاسُ الْفَرْعِ
u'قِيَاسٌ فِقْهٌ':Added, #1: 1	قِيَاسِ فَصْلِ
u'قِيَاسٌ فلان':Added, #2: 2	قِيَاسِ الْفِقْهِ
u'قِيَاسٌ قَاعِدٌ':Added, #5: 5	قِيَاسِ الشَّافِعِيِّ
u'قِيَاسٌ قَاعِدٌ':Added, #1: 1	قِيَاسِ الْقَاعِدَةِ
u'قِيَاسٌ قُبْلَةٌ':Added, #3: 3	قِيَاسُ الْقَاعِدَةِ
u'قِيَاسٌ قَرْضٌ':Added, #1: 1	قِيَاسِ الْقُبْلَةِ
u'قِيَاسٌ قَسام':Added, #1: 1	قِيَاسُ الْقَرْضِ
u'قِيَاسٌ قَسامَة':Added, #1: 1	قِيَاسُ الْقَسَامَةِ
u'قِيَاسٌ قَضَاءٌ':Added, #1: 1	قِيَاسُ الْقَسَامَةِ
u'قِيَاسٌ قَوَاعِدُ':Added, #1: 1	قِيَاسُ قَضَاءِ
u'قِيَاسٌ قَوَاعِدُ':Added, #1: 1	قِيَاسِ الْقَوَاعِدِ
u'قِيَاسٌ قول':Added, #1: 1	قِيَاسِ قَوَاعِدِ
u'قِيَاسٌ قَوْلٌ':Added, #107: 107	قِيَاسُ قَوْلِ
u'قِيَاسٌ قول':Added, #107: 107	قِيَاسُ قَوْلِ
u'قِيَاسٌ قَوْلٌ':Added, #15: 15	قِيَاسُ قَوْلِهِ
u'قِيَاسٌ قول':Added, #15: 15	قِيَاسُ قَوْلِهِ
u'قِيَاسٌ قَوْلٌ':Added, #1: 1	قِيَاسَ الْقَوْلِ
u'قِيَاسٌ قول':Added, #1: 1	قِيَاسَ الْقَوْلِ
u'قِيَاسٌ قَوْلٌ':Added, #247: 247	قِيَاسِ قَوْلِ
u'قِيَاسٌ قَوْلٌ':Added, #247: 247	قِيَاسِ قَوْلِ
u'قِيَاسٌ قول':Added, #2: 2	قِيَاسِ قَوْلٍ
u'قِيَاسٌ قَوْلٌ':Added, #31: 31	قِيَاسِ قَوْلِهِ
u'قِيَاسٌ قول':Added, #31: 31	قِيَاسِ قَوْلِهِ
u'قِيَاسٌ قَوْلٌ':Added, #4: 4	قِيَاسُ الْقَوْلِ
u'قِيَاسٌ قول':Added, #4: 4	قِيَاسُ الْقَوْلِ
u'قِيَاسٌ قَوْلٌ':Added, #5: 5	قِيَاسَ قَوْلِ
u'قِيَاسٌ قِيَمٌ':Added, #5: 5	قِيَاسَ قَوْلِ
u'قِيَاسٌ كِتَابَةٌ':Added, #1: 1	قِيَاسِ قِيَمِ
u'قِيَاسٌ كَرَاهَةٌ':Added, #1: 1	قِيَاسَ الْكِتَابَةِ
u'قِيَاسٌ كَرَاهَةٌ':Added, #1: 1	قِيَاسُ كَرَاهَةِ
u'قِيَاسٌ كَفَّارٌ':Added, #2: 2	قِيَاسِ كَرَاهَةِ
u'قِيَاسٌ كَفَّارٌ':Added, #1: 1	قِيَاسَ الْكَفَّارَةِ
u'قِيَاسٌ كَفَّارَةٌ':Added, #1: 1	قِيَاسِ كَفَّارَةِ
u'قِيَاسٌ كَفَّارَةٌ':Added, #1: 1	قِيَاسَ الْكَفَّارَةِ
u'قِيَاسٌ كَفَالَةٌ':Added, #1: 1	قِيَاسِ كَفَّارَةِ
u'قِيَاسٌ كَلاَمٌ':Added, #1: 1	قِيَاسُ الْكَفَالَةِ
u'قِيَاسٌ كَلْبٌ':Added, #1: 1	قِيَاسُ كَلَامِهِ
u'قِيَاسٌ كُلِّيٌّ':Added, #1: 1	قِيَاسِ الْكَلْبِ
u'قِيَاسٌ لقطة':Added, #2: 2	قِيَاسٍ كُلِّيٍّ
u'قِيَاسٌ مالِك':Added, #1: 1	قِيَاسِ اللُّقَطَةِ
u'قِيَاسٌ مَالِكٌ':Added, #1: 1	قِيَاسِ الْمَالِكِيَّةِ
u'قِيَاسٌ مالِكِيّ':Added, #2: 2	قِيَاسِ مَالِكٍ
u'قِيَاسٌ مَبِيعٌ':Added, #1: 1	قِيَاسِ الْمَالِكِيَّةِ
u'قِيَاسٌ مَبِيعٌ':Added, #1: 1	قِيَاسُ الْمَبِيعِ
u'قِيَاسٌ مُتَأَخِّرٌ':Added, #1: 1	قِيَاسِ الْمَبِيعِ
u'قِيَاسٌ مَحْضَرٌ':Added, #1: 1	قِيَاسُ الْمُتَأَخِّرِ
u'قِيَاسٌ مُحَمَّدٌ':Added, #1: 1	قِيَاسُ مَحْضَرٍ
u'قِيَاسٌ مُخْتَلَفٌ':Added, #5: 5	قِيَاسِ مُحَمَّدٍ
u'قِيَاسٌ مُخْطِئٌ':Added, #1: 1	قِيَاسُ الْمُخْتَلَفِ
u'قِيَاسٌ مُدَّةٌ':Added, #1: 1	قِيَاسَ الْمُخْطِئِ
u'قِيَاسٌ مَدْلُولٌ':Added, #1: 1	قِيَاسِ الْمُدَّةِ
u'قِيَاسٌ مَذْهَبٌ':Added, #1: 1	قِيَاسُ مَدْلُولٍ
u'قِيَاسٌ مَذْهَبٌ':Added, #16: 16	قِيَاسَ الْمَذْهَبِ
u'قِيَاسٌ مَذْهَبٌ':Added, #260: 260	قِيَاسُ الْمَذْهَبِ
u'قِيَاسٌ مَذْهَبٌ':Added, #28: 28	قِيَاسِ الْمَذْهَبِ
u'قِيَاسٌ مَذْهَبٌ':Added, #2: 2	قِيَاسِ مَذْهَبِ
u'قِيَاسٌ مَذْهَبٌ':Added, #4: 4	قِيَاسُ مَذْهَبِهِ
u'قِيَاسٌ مَذْهَبٌ':Added, #6: 6	قِيَاسِ مَذْهَبِهِ
u'قِيَاسٌ مُرْتَدٌّ':Added, #7: 7	قِيَاسُ مَذْهَبِ
u'قِيَاسٌ مُرَكَّبٌ':Added, #1: 1	قِيَاسِ الْمُرْتَدَّةِ
u'قِيَاسٌ مَسَاجِدُ':Added, #3: 3	قِيَاسٍ مُرَكَّبٍ
u'قِيَاسٌ مَسْأَلَةٌ':Added, #1: 1	قِيَاسُ الْمَسَاجِدِ
u'قِيَاسٌ مَسْأَلَةٌ':Added, #17: 17	قِيَاسِ مَسْأَلَةِ
u'قِيَاسٌ مَسْأَلَةٌ':Added, #2: 2	قِيَاسُ الْمَسْأَلَةِ
u'قِيَاسٌ مَسْأَلَةٌ':Added, #2: 2	قِيَاسَ مَسْأَلَةِ
u'قِيَاسٌ مَسْأَلَةٌ':Added, #2: 2	قِيَاسِ مَسْأَلَةٍ
u'قِيَاسٌ مَسْأَلَةٌ':Added, #6: 6	قِيَاسُ مَسْأَلَةِ
u'قِيَاسٌ مُسَاوَاةٌ':Added, #9: 9	قِيَاسِ الْمَسْأَلَةِ
u'قِيَاسٌ مُسَاوَاةٌ':Added, #1: 1	قِيَاسَ الْمُسَاوَاةِ
u'قِيَاسٌ مُسَاوَاةٌ':Added, #1: 1	قِيَاسُ الْمُسَاوَاةِ
u'قِيَاسٌ مَسَائِلُ':Added, #1: 1	قِيَاسِ الْمُسَاوَاةِ
u'قِيَاسٌ مَسْبُوق':Added, #1: 1	قِيَاسُ الْمَسَائِلِ
u'قِيَاسٌ مَسْكُوتٌ':Added, #1: 1	قِيَاسُ الْمَسْبُوقِ
u'قِيَاسٌ مَشَايِخُ':Added, #1: 1	قِيَاسُ الْمَسْكُوتِ
u'قِيَاسٌ مُصَنِّفٌ':Added, #1: 1	قِيَاسِ مَشَايِخِ
u'قِيَاسٌ مُصَنِّفٌ':Added, #1: 1	قِيَاسَ الْمُصَنِّفِ
u'قِيَاسٌ مَضْمُونٌ':Added, #1: 1	قِيَاسُ الْمُصَنِّفِ
u'قِيَاسٌ مُعْتَادٌ':Added, #1: 1	قِيَاسِ الْمَضْمُونَاتِ
u'قِيَاسٌ مُعْتَمَدٌ':Added, #1: 1	قِيَاسُ الْمُعْتَادَةِ
u'قِيَاسٌ مَعْرِفَةٌ':Added, #2: 2	قِيَاسُ الْمُعْتَمَدِ
u'قِيَاسٌ مَعْرِفَة':Added, #1: 1	قِيَاسُ مَعْرِفَةِ
u'قِيَاسٌ مُعَصْفَر':Added, #1: 1	قِيَاسُ مَعْرِفَةِ
u'قِيَاسٌ مَعْلُومٌ':Added, #1: 1	قِيَاسَ الْمُعَصْفَرِ
u'قِيَاسٌ مَفْعُولٌ':Added, #1: 1	قِيَاسُ الْمَعْلُومِ
u'قِيَاسٌ مِلْءٌ':Added, #1: 1	قِيَاسَ الْمَفْعُولِ
u'قِيَاسٌ مَمْسُوح':Added, #1: 1	قِيَاسَ مِلْءِ
u'قِيَاسٌ مُنَاسَبَةٌ':Added, #2: 2	قِيَاسُ الْمَمْسُوحِ
u'قِيَاسٌ مَنْصُوصٌ':Added, #1: 1	قِيَاسِ الْمُنَاسَبَاتِ
u'قِيَاسٌ مَنْصُوصٌ':Added, #2: 2	قِيَاسِ الْمَنْصُوصِ
u'قِيَاسٌ مَنْعٌ':Added, #8: 8	قِيَاسُ الْمَنْصُوصِ
u'قِيَاسٌ مَنْعٌ':Added, #1: 1	قِيَاسُ مَنْعِ
u'قِيَاسٌ مَنْقُولٌ':Added, #2: 2	قِيَاسَ الْمَنْعِ
u'قِيَاسٌ مَنِيٌّ':Added, #2: 2	قِيَاسُ الْمَنْقُولِ
u'قِيَاسٌ مُودَعٌ':Added, #1: 1	قِيَاسُ الْمَنِيِّ
u'قِيَاسٌ مَوْزُونٌ':Added, #1: 1	قِيَاسَ الْمُودَعِ
u'قِيَاسٌ مَوْعُودٌ':Added, #1: 1	قِيَاسُ الْمَوْزُونَاتِ
u'قِيَاسٌ مِيرَاثٌ':Added, #1: 1	قِيَاسَ الْمَوْعُودِ
u'قِيَاسٌ مِيرَاثٌ':Added, #1: 1	قِيَاسَ مِيرَاثِ
u'قِيَاسٌ نَاظِرٌ':Added, #2: 2	قِيَاسِ الْمِيرَاثِ
u'قِيَاسٌ نَافِلَةٌ':Added, #1: 1	قِيَاسَ النَّاظِرِ
u'قِيَاسٌ نَبْش':Added, #1: 1	قِيَاسُ النَّافِلَةِ
u'قِيَاسٌ نَبْش':Added, #1: 1	قِيَاسُ النَّبْشِ
u'قِيَاسٌ نَحْوٌ':Added, #1: 1	قِيَاسِ النَّبْشِ
u'قِيَاسٌ نذر':Added, #1: 1	قِيَاسِ النّحْوِ
u'قِيَاسٌ نذر':Added, #1: 1	قِيَاسَ النَّذْرِ
u'قِيَاسٌ نَذْرٌ':Added, #1: 1	قِيَاسُ النَّذْرِ
u'قِيَاسٌ نَذْرٌ':Added, #1: 1	قِيَاسَ النَّذْرِ
u'قِيَاسٌ نذر':Added, #1: 1	قِيَاسُ النَّذْرِ
u'قِيَاسٌ نَذْرٌ':Added, #1: 1	قِيَاسُ نَذْرِ
u'قِيَاسٌ نَسَبٌ':Added, #1: 1	قِيَاسُ نَذْرِ
u'قِيَاسٌ نَسَبٌ':Added, #1: 1	قِيَاسِ النَّسَبِ
u'قِيَاسٌ نِسَبٌ':Added, #2: 2	قِيَاسِ النّسَبِ
u'قِيَاسٌ نسمة':Added, #2: 2	قِيَاسِ النّسَبِ
u'قِيَاسٌ نَسَمَةٌ':Added, #1: 1	قِيَاسِ النَّسَمَةِ
u'قِيَاسٌ نَصٌّ':Added, #1: 1	قِيَاسِ النَّسَمَةِ
u'قِيَاسٌ نَصٌّ':Added, #1: 1	قِيَاسِ النَّصِّ
u'قِيَاسٌ نَصٌّ':Added, #1: 1	قِيَاسَ نَصٍّ
u'قِيَاسٌ نَصٌّ':Added, #1: 1	قِيَاسُ نَصٍّ
u'قِيَاسٌ نَصٌّ':Added, #1: 1	قِيَاسِ نَصٍّ
u'قِيَاسٌ نَصٌّ':Added, #1: 1	قِيَاسُ نَصِّهِ
u'قِيَاسٌ نصب':Added, #2: 2	قِيَاسُ نَصِّ
u'قِيَاسٌ نَصْبٌ':Added, #1: 1	قِيَاسُ نَصْبِ
u'قِيَاسٌ نَصْرَانِيٌّ':Added, #1: 1	قِيَاسُ نَصْبِ
u'قِيَاسٌ نُصُوصٌ':Added, #1: 1	قِيَاسِ النَّصْرَانِيِّ
u'قِيَاسٌ نظائر':Added, #2: 2	قِيَاسُ نُصُوصِهِ
u'قِيَاسٌ نظائر':Added, #1: 1	قِيَاسُ النَّظَائِرِ
u'قِيَاسٌ نَظِيرٌ':Added, #4: 4	قِيَاسُ نَظَائِرِهِ
u'قِيَاسٌ نَظِيرٌ':Added, #1: 1	قِيَاسِ النَّظِيرِ
u'قِيَاسٌ نَعْلٌ':Added, #1: 1	قِيَاسُ نَظِيرِهِ
u'قِيَاسٌ نَعْلٌ':Added, #1: 1	قِيَاسُ النَّعْلِ
u'قِيَاسٌ نفاة':Added, #1: 1	قِيَاسِ النَّعْلِ
u'قِيَاسٌ نَفَقَةٌ':Added, #1: 1	قِيَاسُ نُفَاةِ
u'قِيَاسٌ نَفْيٌ':Added, #2: 2	قِيَاسِ نَفَقَةِ
u'قِيَاسٌ نَفْيٌ':Added, #1: 1	قِيَاسِ النَّفْيِ
u'قِيَاسٌ نكاح':Added, #1: 1	قِيَاسَ نَفْيِ
u'قِيَاسٌ نِكَاحٌ':Added, #1: 1	قِيَاسَ النِّكَاحِ
u'قِيَاسٌ نَهْرٌ':Added, #1: 1	قِيَاسَ النِّكَاحِ
u'قِيَاسٌ نَهْيٌ':Added, #1: 1	قِيَاسِ النَّهْرِ
u'قِيَاسٌ نَوَوِيٌّ':Added, #1: 1	قِيَاسُ نَهْيٍ
u'قِيَاسٌ نِيَابَةٌ':Added, #1: 1	قِيَاسُ النَّوَوِيِّ
u'قِيَاسٌ هِبَةٌ':Added, #1: 1	قِيَاسِ النِّيَابَةِ
u'قِيَاسٌ هِبَةٌ':Added, #1: 1	قِيَاس هِبَةِ
u'قِيَاسٌ هَدْيٌ':Added, #1: 1	قِيَاسِ هِبَةِ
u'قِيَاسٌ هَدْيٌ':Added, #1: 1	قِيَاسِ هَدْيِ
u'قِيَاسٌ وَاجِبٌ':Added, #2: 2	قِيَاسُ الْهَدْيِ
u'قِيَاسٌ واحد':Added, #1: 1	قِيَاسَ وَاجِبٍ
u'قِيَاسٌ وَاحِدٌ':Added, #1: 1	قِيَاسُ الْوَاحِدَةِ
u'قِيَاسٌ واحد':Added, #1: 1	قِيَاسُ الْوَاحِدَةِ
u'قِيَاسٌ وَاحِدٌ':Added, #1: 1	قِيَاسٍ وَاحِدٍ
u'قِيَاسٌ وَاضِحٌ':Added, #1: 1	قِيَاسٍ وَاحِدٍ
u'قِيَاسٌ وَجْهٌ':Added, #1: 1	قِيَاسِ الْوَاضِحِ
u'قِيَاسٌ وَجْهٌ':Added, #1: 1	قِيَاسُ الْوَجْهِ
u'قِيَاسٌ وَجْهٌ':Added, #1: 1	قِيَاسِ الْوَجْهَيْنِ
u'قِيَاسٌ وُجُوبٌ':Added, #1: 1	قِيَاسِ وَجْهِ
u'قِيَاسٌ وُجُوبٌ':Added, #1: 1	قِيَاسُ وُجُوبِ
u'قِيَاسٌ وَرْدٌ':Added, #1: 1	قِيَاسِ وُجُوبِ
u'قِيَاسٌ وَسَائِلُ':Added, #2: 2	قِيَاسُ الْوَرْدِ
u'قِيَاسٌ وَصِيٌّ':Added, #1: 1	قِيَاسِ الْوَسَائِلِ
u'قِيَاسٌ وُضُوءٌ':Added, #1: 1	قِيَاسِ الْوَصِيِّ
u'قِيَاسٌ وُضُوءٌ':Added, #2: 2	قِيَاسُ الْوُضُوءِ
u'قِيَاسٌ وَلاَءٌ':Added, #2: 2	قِيَاسِ الْوُضُوءِ
u'قِيَاسٌ وِلاَيَةٌ':Added, #1: 1	قِيَاسُ وَلَاءِ
u'قِيَاسٌ ولد':Added, #1: 1	قِيَاسَ وِلَايَةِ
u'قِيَاسٌ وَلَدٌ':Added, #1: 1	قِيَاسُ الْوَلَدِ
u'قيام أَبٌ':Added, #1: 1	قِيَاسُ الْوَلَدِ
u'قِيَامٌ أَبٌ':Added, #1: 1	قِيَامُ الْأَبِ
u'قيام أَبٌ':Added, #1: 1	قِيَامُ الْأَبِ
u'قِيَامٌ أَبٌ':Added, #4: 4	قِيَامِ الْأَبِ
u'قيام اِبْنٌ':Added, #4: 4	قِيَامِ الْأَبِ
u'قيام اِبْنٌ':Added, #1: 1	قِيَامَ ابْنِ
u'قِيَامٌ اِبْنٌ':Added, #1: 1	قِيَامِ ابْنِ
u'قِيَامٌ اِبْنٌ':Added, #1: 1	قِيَامَ ابْنِ
u'قيام أثَرٌ':Added, #1: 1	قِيَامِ ابْنِ
u'قِيَامٌ أثَرٌ':Added, #1: 1	قِيَامِ أَثَرِ
u'قيام أثَرٌ':Added, #1: 1	قِيَامِ أَثَرِ
u'قِيَامٌ أثَرٌ':Added, #1: 1	قِيَامُ الْأَثَرِ
u'قيام أثَرٌ':Added, #1: 1	قِيَامُ الْأَثَرِ
u'قِيَامٌ أثَرٌ':Added, #2: 2	قِيَامَ الْأَثَرِ
u'قيام إِجْمَاعٌ':Added, #2: 2	قِيَامَ الْأَثَرِ
u'قِيَامٌ إِجْمَاعٌ':Added, #1: 1	قِيَامُ الْإِجْمَاعِ
u'قيام إِجْمَاعٌ':Added, #1: 1	قِيَامُ الْإِجْمَاعِ
u'قِيَامٌ إِجْمَاعٌ':Added, #2: 2	قِيَامِ الْإِجْمَاعِ
u'قيام أحَدٌ':Added, #2: 2	قِيَامِ الْإِجْمَاعِ
u'قِيَامٌ أحَدٌ':Added, #1: 1	قِيَامِ أَحَدِ
u'قيام إِحْرَامٌ':Added, #1: 1	قِيَامِ أَحَدِ
u'قِيَامٌ إِحْرَامٌ':Added, #1: 1	قِيَامُ الْإِحْرَامِ
u'قيام آخِرُ':Added, #1: 1	قِيَامُ الْإِحْرَامِ
u'قِيَامٌ آخِرُ':Added, #1: 1	قِيَامِ آخِرِ
u'قيام أَرْبَعَةٌ':Added, #1: 1	قِيَامِ آخِرِ
u'قِيَامٌ أَرْبَعَةٌ':Added, #1: 1	قِيَامُ أَرْبَعَةِ
u'قيام أَرْبَعَةٌ':Added, #1: 1	قِيَامُ أَرْبَعَةِ
u'قيام أَرْبَعَةٌ':Added, #1: 1	قِيَامَ الْأَرْبَعَةِ
u'قِيَامٌ أَرْبَعَةٌ':Added, #1: 1	قِيَامِ الْأَرْبَعَةِ
u'قِيَامٌ أَرْبَعَةٌ':Added, #1: 1	قِيَامَ الْأَرْبَعَةِ
u'قيام أَرْبَعَةٌ':Added, #1: 1	قِيَامِ الْأَرْبَعَةِ
u'قِيَامٌ أَرْبَعَةٌ':Added, #2: 2	قِيَامُ أَرْبَعَةٍ
u'قيام أصل':Added, #2: 2	قِيَامُ أَرْبَعَةٍ
u'قيام أًصْلٌ':Added, #1: 1	قِيَامُ أَصْلِ
u'قِيَامٌ أصل':Added, #1: 1	قِيَامُ أَصْلِ
u'قِيَامٌ أًصْلٌ':Added, #1: 1	قِيَامُ أَصْلِ
u'قيام أصل':Added, #1: 1	قِيَامُ أَصْلِ
u'قيام أًصْلٌ':Added, #2: 2	قِيَامِ أَصْلِ
u'قِيَامٌ أصل':Added, #2: 2	قِيَامِ أَصْلِ
u'قِيَامٌ أًصْلٌ':Added, #2: 2	قِيَامِ أَصْلِ
u'قيام إضافَةٌ':Added, #2: 2	قِيَامِ أَصْلِ
u'قِيَامٌ إضافَةٌ':Added, #1: 1	قِيَامِ الْإِضَافَاتِ
u'قيام إضافَةٌ':Added, #1: 1	قِيَامِ الْإِضَافَاتِ
u'قِيَامٌ إضافَةٌ':Added, #1: 1	قِيَامِ الْإِضَافَةِ
u'قيام أَعْذَارٌ':Added, #1: 1	قِيَامِ الْإِضَافَةِ
u'قِيَامٌ أَعْذَارٌ':Added, #1: 1	قِيَامِ الْأَعْذَارِ
u'قيام إقْرَارٌ':Added, #1: 1	قِيَامِ الْأَعْذَارِ
u'قِيَامٌ إقْرَارٌ':Added, #1: 1	قِيَامُ الْإِقْرَارِ
u'قيام أقْرَبُ':Added, #1: 1	قِيَامُ الْإِقْرَارِ
u'قِيَامٌ أقْرَبُ':Added, #1: 1	قِيَامُ الْأَقْرَبِ
u'قيام آلةٌ':Added, #1: 1	قِيَامُ الْأَقْرَبِ
u'قِيَامٌ آلةٌ':Added, #2: 2	قِيَامِ الْآلَةِ
u'قيام ألف':Added, #2: 2	قِيَامِ الْآلَةِ
u'قيام ألْفٌ':Added, #1: 1	قِيَامُ الْأَلْفِ
u'قيام أَلْفٌ':Added, #1: 1	قِيَامُ الْأَلْفِ
u'قِيَامٌ ألف':Added, #1: 1	قِيَامُ الْأَلْفِ
u'قِيَامٌ ألْفٌ':Added, #1: 1	قِيَامُ الْأَلْفِ
u'قِيَامٌ أَلْفٌ':Added, #1: 1	قِيَامُ الْأَلْفِ
u'قيام إمَامٌ':Added, #1: 1	قِيَامُ الْأَلْفِ
u'قِيَامٌ إمَامٌ':Added, #1: 1	قِيَامَ الإِمَامِ
u'قيام إمَامٌ':Added, #1: 1	قِيَامَ الإِمَامِ
u'قِيَامٌ إمَامٌ':Added, #1: 1	قِيَامَ إمَامِهِ
u'قيام إمَامٌ':Added, #1: 1	قِيَامَ إمَامِهِ
u'قِيَامٌ إمَامٌ':Added, #2: 2	قِيَامَ الْإِمَامِ
u'قيام إمَامٌ':Added, #2: 2	قِيَامَ الْإِمَامِ
u'قِيَامٌ إمَامٌ':Added, #2: 2	قِيَامِ إمَامِهِ
u'قيام إمَامٌ':Added, #2: 2	قِيَامِ إمَامِهِ
u'قِيَامٌ إمَامٌ':Added, #5: 5	قِيَامُ الْإِمَامِ
u'قيام إمَامٌ':Added, #5: 5	قِيَامُ الْإِمَامِ
u'قِيَامٌ إمَامٌ':Added, #9: 9	قِيَامِ الْإِمَامِ
u'قيام أمَانَةٌ':Added, #9: 9	قِيَامِ الْإِمَامِ
u'قِيَامٌ أمَانَةٌ':Added, #1: 1	قِيَامُ الْأَمَانَةِ
u'قيام أَمْرٌ':Added, #1: 1	قِيَامُ الْأَمَانَةِ
u'قِيَامٌ أَمْرٌ':Added, #1: 1	قِيَامَ أَمْرِ
u'قيام أَمْرٌ':Added, #1: 1	قِيَامَ أَمْرِ
u'قِيَامٌ أَمْرٌ':Added, #2: 2	قِيَامِ الْأَمْرِ
u'قيام أَمْرٌ':Added, #2: 2	قِيَامِ الْأَمْرِ
u'قِيَامٌ أَمْرٌ':Added, #3: 3	قِيَامَ الْأَمْرِ
u'قيام أَنْبِذَةٌ':Added, #3: 3	قِيَامَ الْأَمْرِ
u'قِيَامٌ أَنْبِذَةٌ':Added, #1: 1	قِيَامِ الْأَنْبِذَةِ
u'قيام إِنْكارٌ':Added, #1: 1	قِيَامِ الْأَنْبِذَةِ
u'قِيَامٌ إِنْكارٌ':Added, #2: 2	قِيَامُ الْإِنْكَارِ
u'قيام أهْلٌ':Added, #2: 2	قِيَامُ الْإِنْكَارِ
u'قِيَامٌ أهْلٌ':Added, #1: 1	قِيَامِ أَهْلِ
u'قيام أَهْلِيٌّ':Added, #1: 1	قِيَامِ أَهْلِ
u'قيام أَهْلِيٌّ':Added, #1: 1	قِيَامَ أَهْلِيَّةِ
u'قِيَامٌ أَهْلِيٌّ':Added, #1: 1	قِيَامُ أَهْلِيَّةِ
u'قِيَامٌ أَهْلِيٌّ':Added, #1: 1	قِيَامَ أَهْلِيَّةِ
u'قيام أَهْلِيٌّ':Added, #1: 1	قِيَامُ أَهْلِيَّةِ
u'قيام أَهْلِيٌّ':Added, #1: 1	قِيَامَ أَهْلِيَّتِهِ
u'قيام أَهْلِيٌّ':Added, #1: 1	قِيَامُ أَهْلِيَّتِهِ
u'قِيَامٌ أَهْلِيٌّ':Added, #1: 1	قِيَامِ أَهْلِيَّتِهِ
u'قِيَامٌ أَهْلِيٌّ':Added, #1: 1	قِيَامَ أَهْلِيَّتِهِ
u'قِيَامٌ أَهْلِيٌّ':Added, #1: 1	قِيَامُ أَهْلِيَّتِهِ
u'قيام أَهْلِيٌّ':Added, #1: 1	قِيَامِ أَهْلِيَّتِهِ
u'قيام أَهْلِيٌّ':Added, #2: 2	قِيَامَ الْأَهْلِيَّةِ
u'قِيَامٌ أَهْلِيٌّ':Added, #2: 2	قِيَامُ الْأَهْلِيَّةِ
u'قِيَامٌ أَهْلِيٌّ':Added, #2: 2	قِيَامَ الْأَهْلِيَّةِ
u'قيام أَهْلِيٌّ':Added, #2: 2	قِيَامُ الْأَهْلِيَّةِ
u'قِيَامٌ أَهْلِيٌّ':Added, #2: 2	قِيَامِ أَهْلِيَّةِ
u'قيام أَهْلِيٌّ':Added, #2: 2	قِيَامِ أَهْلِيَّةِ
u'قِيَامٌ أَهْلِيٌّ':Added, #5: 5	قِيَامِ الْأَهْلِيَّةِ
u'قيام أهْلِيَّةٌ':Added, #5: 5	قِيَامِ الْأَهْلِيَّةِ
u'قيام أهْلِيَّةٌ':Added, #1: 1	قِيَامَ أَهْلِيَّةِ
u'قِيَامٌ أهْلِيَّةٌ':Added, #1: 1	قِيَامُ أَهْلِيَّةِ
u'قِيَامٌ أهْلِيَّةٌ':Added, #1: 1	قِيَامَ أَهْلِيَّةِ
u'قيام أهْلِيَّةٌ':Added, #1: 1	قِيَامُ أَهْلِيَّةِ
u'قيام أهْلِيَّةٌ':Added, #1: 1	قِيَامَ أَهْلِيَّتِهِ
u'قيام أهْلِيَّةٌ':Added, #1: 1	قِيَامُ أَهْلِيَّتِهِ
u'قِيَامٌ أهْلِيَّةٌ':Added, #1: 1	قِيَامِ أَهْلِيَّتِهِ
u'قِيَامٌ أهْلِيَّةٌ':Added, #1: 1	قِيَامَ أَهْلِيَّتِهِ
u'قِيَامٌ أهْلِيَّةٌ':Added, #1: 1	قِيَامُ أَهْلِيَّتِهِ
u'قيام أهْلِيَّةٌ':Added, #1: 1	قِيَامِ أَهْلِيَّتِهِ
u'قيام أهْلِيَّةٌ':Added, #2: 2	قِيَامَ الْأَهْلِيَّةِ
u'قِيَامٌ أهْلِيَّةٌ':Added, #2: 2	قِيَامُ الْأَهْلِيَّةِ
u'قِيَامٌ أهْلِيَّةٌ':Added, #2: 2	قِيَامَ الْأَهْلِيَّةِ
u'قيام أهْلِيَّةٌ':Added, #2: 2	قِيَامُ الْأَهْلِيَّةِ
u'قِيَامٌ أهْلِيَّةٌ':Added, #2: 2	قِيَامِ أَهْلِيَّةِ
u'قيام أهْلِيَّةٌ':Added, #2: 2	قِيَامِ أَهْلِيَّةِ
u'قِيَامٌ أهْلِيَّةٌ':Added, #5: 5	قِيَامِ الْأَهْلِيَّةِ
u'قيام أوائل':Added, #5: 5	قِيَامِ الْأَهْلِيَّةِ
u'قِيَامٌ أوائل':Added, #1: 1	قِيَامُ الْأَوَائِلِ
u'قيام أَوْرَاقٌ':Added, #1: 1	قِيَامُ الْأَوَائِلِ
u'قِيَامٌ أَوْرَاقٌ':Added, #1: 1	قِيَامِ الْأَوْرَاقِ
u'قيام أَوَّلُ':Added, #1: 1	قِيَامِ الْأَوْرَاقِ
u'قِيَامٌ أَوَّلُ':Added, #3: 3	قِيَامَ الْأَوَّلِ
u'قيام أَوْلاَدٌ':Added, #3: 3	قِيَامَ الْأَوَّلِ
u'قِيَامٌ أَوْلاَدٌ':Added, #1: 1	قِيَامِ أَوْلَادِ
u'قيام أيتام':Added, #1: 1	قِيَامِ أَوْلَادِ
u'قِيَامٌ أيتام':Added, #1: 1	قِيَامِ الْأَيْتَامِ
u'قيام بَائِعٌ':Added, #1: 1	قِيَامِ الْأَيْتَامِ
u'قِيَامٌ بَائِعٌ':Added, #1: 1	قِيَامِ الْبَائِعِ
u'قيام بَائِعٌ':Added, #1: 1	قِيَامِ الْبَائِعِ
u'قِيَامٌ بَائِعٌ':Added, #2: 2	قِيَامُ الْبَائِعِ
u'قيام بَدَلٌ':Added, #2: 2	قِيَامُ الْبَائِعِ
u'قِيَامٌ بَدَلٌ':Added, #1: 1	قِيَامَ الْبَدَلِ
u'قيام بَدَنٌ':Added, #1: 1	قِيَامَ الْبَدَلِ
u'قِيَامٌ بَدَنٌ':Added, #1: 1	قِيَامُ بَدَنٍ
u'قيام بَذْرٌ':Added, #1: 1	قِيَامُ بَدَنٍ
u'قِيَامٌ بَذْرٌ':Added, #1: 1	قِيَامِ الْبَذْرِ
u'قيام بِرٌّ':Added, #1: 1	قِيَامِ الْبَذْرِ
u'قِيَامٌ بِرٌّ':Added, #1: 1	قِيَامِ الْبِرِّ
u'قيام بَعْضٌ':Added, #1: 1	قِيَامِ الْبِرِّ
u'قِيَامٌ بَعْضٌ':Added, #1: 1	قِيَامُ بَعْضِ
u'قيام بَعيرٌ':Added, #1: 1	قِيَامُ بَعْضِ
u'قِيَامٌ بَعيرٌ':Added, #1: 1	قِيَامِ الْبَعِيرِ
u'قيام بَغْلٌ':Added, #1: 1	قِيَامِ الْبَعِيرِ
u'قِيَامٌ بَغْلٌ':Added, #1: 1	قِيَامِ بَغْلَتِهِ
u'قيام بِنَاءٌ':Added, #1: 1	قِيَامِ بَغْلَتِهِ
u'قِيَامٌ بِنَاءٌ':Added, #1: 1	قِيَامِ الْبِنَاءِ
u'قيام بِنْتٌ':Added, #1: 1	قِيَامِ الْبِنَاءِ
u'قِيَامٌ بِنْتٌ':Added, #2: 2	قِيَامُ الْبِنْتِ
u'قيام بِنْيَةٌ':Added, #2: 2	قِيَامُ الْبِنْتِ
u'قِيَامٌ بِنْيَةٌ':Added, #1: 1	قِيَامَ الْبِنْيَةِ
u'قيام بِنْيَةٌ':Added, #1: 1	قِيَامَ الْبِنْيَةِ
u'قِيَامٌ بِنْيَةٌ':Added, #1: 1	قِيَامُ بِنْيَةِ
u'قيام بَيْعٌ':Added, #1: 1	قِيَامُ بِنْيَةِ
u'قِيَامٌ بَيْعٌ':Added, #1: 1	قِيَامَ الْبَيْعِ
u'قيام بَيِّن':Added, #1: 1	قِيَامَ الْبَيْعِ
u'قِيَامٌ بَيِّن':Added, #2: 2	قِيَامِ الْبَيِّنَتَيْنِ
u'قيام بَيِّنَةٌ':Added, #2: 2	قِيَامِ الْبَيِّنَتَيْنِ
u'قِيَامٌ بَيِّنَةٌ':Added, #1: 1	قِيَامَ الْبَيِّنَةِ
u'قيام بَيِّنَةٌ':Added, #1: 1	قِيَامَ الْبَيِّنَةِ
u'قِيَامٌ بَيِّنَةٌ':Added, #1: 1	قِيَامُ بَيِّنَةٍ
u'قيام بَيِّنَةٌ':Added, #1: 1	قِيَامُ بَيِّنَةٍ
u'قِيَامٌ بَيِّنَةٌ':Added, #20: 20	قِيَامِ الْبَيِّنَةِ
u'قيام بَيِّنَةٌ':Added, #20: 20	قِيَامِ الْبَيِّنَةِ
u'قِيَامٌ بَيِّنَةٌ':Added, #3: 3	قِيَامُ الْبَيِّنَةِ
u'قيام بَيِّنَةٌ':Added, #3: 3	قِيَامُ الْبَيِّنَةِ
u'قِيَامٌ بَيِّنَةٌ':Added, #4: 4	قِيَامِ بَيِّنَةٍ
u'قيام تَرِكَةٌ':Added, #4: 4	قِيَامِ بَيِّنَةٍ
u'قِيَامٌ تَرِكَةٌ':Added, #1: 1	قِيَامِ التَّرِكَةِ
u'قيام تَصْدِيقٌ':Added, #1: 1	قِيَامِ التَّرِكَةِ
u'قِيَامٌ تَصْدِيقٌ':Added, #1: 1	قِيَامِ التَّصْدِيقِ
u'قيام تَعَلُّقٌ':Added, #1: 1	قِيَامِ التَّصْدِيقِ
u'قِيَامٌ تَعَلُّقٌ':Added, #1: 1	قِيَامَ التَّعَلُّقِ
u'قيام ثَالِثٌ':Added, #1: 1	قِيَامَ التَّعَلُّقِ
u'قِيَامٌ ثَالِثٌ':Added, #1: 1	قِيَامِ ثَالِثَتِهِ
u'قيام ثَالِثٌ':Added, #1: 1	قِيَامِ ثَالِثَتِهِ
u'قِيَامٌ ثَالِثٌ':Added, #4: 4	قِيَامِ الثَّالِثَةِ
u'قيام ثَانِي':Added, #4: 4	قِيَامِ الثَّالِثَةِ
u'قِيَامٌ ثَانِي':Added, #1: 1	قِيَامِ ثَانِيَةِ
u'قيام ثَانِي':Added, #1: 1	قِيَامِ ثَانِيَةِ
u'قِيَامٌ ثَانِي':Added, #5: 5	قِيَامِ الثَّانِيَةِ
u'قيام ثَانِيَةٌ':Added, #5: 5	قِيَامِ الثَّانِيَةِ
u'قِيَامٌ ثَانِيَةٌ':Added, #1: 1	قِيَامِ ثَانِيَةِ
u'قيام ثَانِيَةٌ':Added, #1: 1	قِيَامِ ثَانِيَةِ
u'قِيَامٌ ثَانِيَةٌ':Added, #5: 5	قِيَامِ الثَّانِيَةِ
u'قيام ثَمَنٌ':Added, #5: 5	قِيَامِ الثَّانِيَةِ
u'قِيَامٌ ثَمَنٌ':Added, #5: 5	قِيَامُ الثَّمَنِ
u'قيام جَارِي':Added, #5: 5	قِيَامُ الثَّمَنِ
u'قِيَامٌ جَارِي':Added, #2: 2	قِيَامِ الْجَارِيَةِ
u'قيام جَارِيَةٌ':Added, #2: 2	قِيَامِ الْجَارِيَةِ
u'قِيَامٌ جَارِيَةٌ':Added, #2: 2	قِيَامِ الْجَارِيَةِ
u'قيام جُحُود':Added, #2: 2	قِيَامِ الْجَارِيَةِ
u'قِيَامٌ جُحُود':Added, #1: 1	قِيَامُ الْجُحُودِ
u'قيام جُزْءٌ':Added, #1: 1	قِيَامُ الْجُحُودِ
u'قِيَامٌ جُزْءٌ':Added, #1: 1	قِيَامِ جُزْءٍ
u'قيام جمعة':Added, #1: 1	قِيَامِ جُزْءٍ
u'قِيَامٌ جمعة':Added, #1: 1	قِيَامِ الْجُمُعَةِ
u'قيام جُمُعَةٌ':Added, #1: 1	قِيَامِ الْجُمُعَةِ
u'قِيَامٌ جُمُعَةٌ':Added, #1: 1	قِيَامِ الْجُمُعَةِ
u'قيام جَهالَة':Added, #1: 1	قِيَامِ الْجُمُعَةِ
u'قِيَامٌ جَهالَة':Added, #1: 1	قِيَامِ الْجَهَالَةِ
u'قيام جهل':Added, #1: 1	قِيَامِ الْجَهَالَةِ
u'قِيَامٌ جهل':Added, #1: 1	قِيَامُ الْجَهْلِ
u'قيام جَهْلٌ':Added, #1: 1	قِيَامُ الْجَهْلِ
u'قِيَامٌ جَهْلٌ':Added, #1: 1	قِيَامُ الْجَهْلِ
u'قيام جوف':Added, #1: 1	قِيَامُ الْجَهْلِ
u'قِيَامٌ جوف':Added, #1: 1	قِيَامِ جَوْفِ
u'قيام جَوْفٌ':Added, #1: 1	قِيَامِ جَوْفِ
u'قِيَامٌ جَوْفٌ':Added, #1: 1	قِيَامِ جَوْفِ
u'قيام حاجَةٌ':Added, #1: 1	قِيَامِ جَوْفِ
u'قيام حاجَةٌ':Added, #1: 1	قِيَامَ حَاجَةِ
u'قِيَامٌ حاجَةٌ':Added, #1: 1	قِيَامِ حَاجَةِ
u'قِيَامٌ حاجَةٌ':Added, #1: 1	قِيَامَ حَاجَةِ
u'قيام حاجَةٌ':Added, #1: 1	قِيَامِ حَاجَةِ
u'قِيَامٌ حاجَةٌ':Added, #1: 1	قِيَامِ حَاجَتِهِ
u'قيام حادِثٌ':Added, #1: 1	قِيَامِ حَاجَتِهِ
u'قِيَامٌ حادِثٌ':Added, #1: 1	قِيَامُ الْحَادِثِ
u'قيام حاضِرٌ':Added, #1: 1	قِيَامُ الْحَادِثِ
u'قِيَامٌ حاضِرٌ':Added, #1: 1	قِيَامَ الْحَاضِرِ
u'قيام حُجَّةٌ':Added, #1: 1	قِيَامَ الْحَاضِرِ
u'قيام حُجَّةٌ':Added, #1: 1	قِيَامَ الْحُجَّةِ
u'قِيَامٌ حُجَّةٌ':Added, #1: 1	قِيَامِ الْحُجَّةِ
u'قِيَامٌ حُجَّةٌ':Added, #1: 1	قِيَامَ الْحُجَّةِ
u'قيام حُجَّةٌ':Added, #1: 1	قِيَامِ الْحُجَّةِ
u'قِيَامٌ حُجَّةٌ':Added, #1: 1	قِيَامِ حُجَّةٍ
u'قيام حُجَّةٌ':Added, #1: 1	قِيَامِ حُجَّةٍ
u'قِيَامٌ حُجَّةٌ':Added, #2: 2	قِيَامِ حُجَّةِ
u'قيام حُجَّةٌ':Added, #2: 2	قِيَامِ حُجَّةِ
u'قِيَامٌ حُجَّةٌ':Added, #4: 4	قِيَامُ الْحُجَّةِ
u'قيام حَجْرٌ':Added, #4: 4	قِيَامُ الْحُجَّةِ
u'قِيَامٌ حَجْرٌ':Added, #1: 1	قِيَامِ الْحَجْرِ
u'قيام حَدٌّ':Added, #1: 1	قِيَامِ الْحَجْرِ
u'قِيَامٌ حَدٌّ':Added, #1: 1	قِيَامِ الْحَدِّ
u'قيام حَدَثٌ':Added, #1: 1	قِيَامِ الْحَدِّ
u'قِيَامٌ حَدَثٌ':Added, #4: 4	قِيَامِ الْحَدَثِ
u'قيام حَرامٌ':Added, #4: 4	قِيَامِ الْحَدَثِ
u'قِيَامٌ حَرامٌ':Added, #1: 1	قِيَامَ الْحَرَامِ
u'قيام حَرْبٌ':Added, #1: 1	قِيَامَ الْحَرَامِ
u'قِيَامٌ حَرْبٌ':Added, #5: 5	قِيَامِ الْحَرْبِ
u'قيام حَرْفٌ':Added, #5: 5	قِيَامِ الْحَرْبِ
u'قِيَامٌ حَرْفٌ':Added, #1: 1	قِيَامِ حَرْفٍ
u'قيام حُرْمَةٌ':Added, #1: 1	قِيَامِ حَرْفٍ
u'قِيَامٌ حُرْمَةٌ':Added, #2: 2	قِيَامِ الْحُرْمَةِ
u'قيام حَظٌّ':Added, #2: 2	قِيَامِ الْحُرْمَةِ
u'قِيَامٌ حَظٌّ':Added, #1: 1	قِيَامِ حَظٍّ
u'قيام حَقٌّ':Added, #1: 1	قِيَامِ حَظٍّ
u'قيام حَقٌّ':Added, #1: 1	قِيَامُ الْحَقِّ
u'قِيَامٌ حَقٌّ':Added, #1: 1	قِيَامِ الْحَقِّ
u'قِيَامٌ حَقٌّ':Added, #1: 1	قِيَامُ الْحَقِّ
u'قيام حَقٌّ':Added, #1: 1	قِيَامِ الْحَقِّ
u'قيام حَقٌّ':Added, #1: 1	قِيَامِ حَقٍّ
u'قِيَامٌ حَقٌّ':Added, #1: 1	قِيَامِ حَقِّ
u'قِيَامٌ حَقٌّ':Added, #1: 1	قِيَامِ حَقٍّ
u'قيام حَقٌّ':Added, #1: 1	قِيَامِ حَقِّ
u'قِيَامٌ حَقٌّ':Added, #2: 2	قِيَامُ حَقِّ
u'قيام حَقٌّ':Added, #2: 2	قِيَامُ حَقِّ
u'قِيَامٌ حَقٌّ':Added, #3: 3	قِيَامَ حَقِّ
u'قيام حَمْلٌ':Added, #3: 3	قِيَامَ حَقِّ
u'قيام حَمْلٌ':Added, #1: 1	قِيَامَ الْحَمْلِ
u'قيام حَمْلٌ':Added, #1: 1	قِيَامُ الْحَمْلِ
u'قِيَامٌ حَمْلٌ':Added, #1: 1	قِيَامِ الْحَمْلِ
u'قِيَامٌ حَمْلٌ':Added, #1: 1	قِيَامَ الْحَمْلِ
u'قِيَامٌ حَمْلٌ':Added, #1: 1	قِيَامُ الْحَمْلِ
u'قيام حَيَاةٌ':Added, #1: 1	قِيَامِ الْحَمْلِ
u'قِيَامٌ حَيَاةٌ':Added, #1: 1	قِيَامِ الْحَيَاةِ
u'قيام حَيْثِيَّةٌ':Added, #1: 1	قِيَامِ الْحَيَاةِ
u'قِيَامٌ حَيْثِيَّةٌ':Added, #2: 2	قِيَامِ الْحَيْثِيَّةِ
u'قيام حَيْضٌ':Added, #2: 2	قِيَامِ الْحَيْثِيَّةِ
u'قِيَامٌ حَيْضٌ':Added, #5: 5	قِيَامِ الْحَيْضِ
u'قيام خَتْمٌ':Added, #5: 5	قِيَامِ الْحَيْضِ
u'قِيَامٌ خَتْمٌ':Added, #2: 2	قِيَامِ الْخَتْمِ
u'قيام خُصُومَةٌ':Added, #2: 2	قِيَامِ الْخَتْمِ
u'قِيَامٌ خُصُومَةٌ':Added, #3: 3	قِيَامُ الْخُصُومَةِ
u'قيام خطبة':Added, #3: 3	قِيَامُ الْخُصُومَةِ
u'قِيَامٌ خطبة':Added, #1: 1	قِيَامِ الْخُطْبَةِ
u'قيام خُطْبَةٌ':Added, #1: 1	قِيَامِ الْخُطْبَةِ
u'قِيَامٌ خُطْبَةٌ':Added, #1: 1	قِيَامِ الْخُطْبَةِ
u'قيام خَطِيبٌ':Added, #1: 1	قِيَامِ الْخُطْبَةِ
u'قِيَامٌ خَطِيبٌ':Added, #1: 1	قِيَامِ الْخَطِيبِ
u'قيام خلق':Added, #1: 1	قِيَامِ الْخَطِيبِ
u'قِيَامٌ خلق':Added, #1: 1	قِيَامِ الْخَلْقِ
u'قيام خَلْقٌ':Added, #1: 1	قِيَامِ الْخَلْقِ
u'قِيَامٌ خَلْقٌ':Added, #1: 1	قِيَامِ الْخَلْقِ
u'قيام خَمْسَةٌ':Added, #1: 1	قِيَامِ الْخَلْقِ
u'قِيَامٌ خَمْسَةٌ':Added, #1: 1	قِيَامِ خَمْسَةِ
u'قيام خوارج':Added, #1: 1	قِيَامِ خَمْسَةِ
u'قِيَامٌ خوارج':Added, #1: 1	قِيَامَ الْخَوَارِجِ
u'قيام خَوَارِجُ':Added, #1: 1	قِيَامَ الْخَوَارِجِ
u'قِيَامٌ خَوَارِجُ':Added, #1: 1	قِيَامَ الْخَوَارِجِ
u'قيام دَارٌ':Added, #1: 1	قِيَامَ الْخَوَارِجِ
u'قِيَامٌ دَارٌ':Added, #1: 1	قِيَامِ الدَّارِ
u'قيام دَلالَةٌ':Added, #1: 1	قِيَامِ الدَّارِ
u'قيام دَلالَةٌ':Added, #1: 1	قِيَامُ دَلَالَةٍ
u'قِيَامٌ دَلالَةٌ':Added, #1: 1	قِيَامِ دَلَالَةِ
u'قِيَامٌ دَلالَةٌ':Added, #1: 1	قِيَامُ دَلَالَةٍ
u'قيام دَلالَةٌ':Added, #1: 1	قِيَامِ دَلَالَةِ
u'قِيَامٌ دَلالَةٌ':Added, #2: 2	قِيَامَ الدَّلَالَةِ
u'قيام دَليلٌ':Added, #2: 2	قِيَامَ الدَّلَالَةِ
u'قِيَامٌ دَليلٌ':Added, #14: 14	قِيَامِ الدَّلِيلِ
u'قيام دَليلٌ':Added, #14: 14	قِيَامِ الدَّلِيلِ
u'قِيَامٌ دَليلٌ':Added, #2: 2	قِيَامُ دَلِيلِ
u'قيام دَليلٌ':Added, #2: 2	قِيَامُ دَلِيلِ
u'قِيَامٌ دَليلٌ':Added, #5: 5	قِيَامَ الدَّلِيلِ
u'قيام دَليلٌ':Added, #5: 5	قِيَامَ الدَّلِيلِ
u'قِيَامٌ دَليلٌ':Added, #5: 5	قِيَامِ دَلِيلِ
u'قيام دَليلٌ':Added, #5: 5	قِيَامِ دَلِيلِ
u'قِيَامٌ دَليلٌ':Added, #6: 6	قِيَامُ الدَّلِيلِ
u'قيام دَمٌ':Added, #6: 6	قِيَامُ الدَّلِيلِ
u'قِيَامٌ دَمٌ':Added, #2: 2	قِيَامِ الدَّمِ
u'قيام دَهْرٌ':Added, #2: 2	قِيَامِ الدَّمِ
u'قِيَامٌ دَهْرٌ':Added, #1: 1	قِيَامَ الدَّهْرِ
u'قيام دَيْنٌ':Added, #1: 1	قِيَامَ الدَّهْرِ
u'قِيَامٌ دَيْنٌ':Added, #12: 12	قِيَامَ الدَّيْنِ
u'قيام دَيْنٌ':Added, #12: 12	قِيَامَ الدَّيْنِ
u'قِيَامٌ دَيْنٌ':Added, #1: 1	قِيَامُ الدَّيْنِ
u'قيام دَيْنٌ':Added, #1: 1	قِيَامُ الدَّيْنِ
u'قِيَامٌ دَيْنٌ':Added, #2: 2	قِيَامِ الدَّيْنِ
u'قيام ذكر':Added, #2: 2	قِيَامِ الدَّيْنِ
u'قِيَامٌ ذكر':Added, #1: 1	قِيَامِ الذَّكَرِ
u'قيام ذَكَرٌ':Added, #1: 1	قِيَامِ الذَّكَرِ
u'قِيَامٌ ذَكَرٌ':Added, #1: 1	قِيَامِ الذَّكَرِ
u'قيام ذِمَّةٌ':Added, #1: 1	قِيَامِ الذَّكَرِ
u'قِيَامٌ ذِمَّةٌ':Added, #1: 1	قِيَامَ الذِّمَّةِ
u'قيام ذِمَّةٌ':Added, #1: 1	قِيَامَ الذِّمَّةِ
u'قِيَامٌ ذِمَّةٌ':Added, #2: 2	قِيَامِ الذِّمَّةِ
u'قيام رَائِحٌ':Added, #2: 2	قِيَامِ الذِّمَّةِ
u'قِيَامٌ رَائِحٌ':Added, #1: 1	قِيَامُ الرَّائِحَةِ
u'قيام رَائِحٌ':Added, #1: 1	قِيَامُ الرَّائِحَةِ
u'قِيَامٌ رَائِحٌ':Added, #3: 3	قِيَامَ الرَّائِحَةِ
u'قيام رَائِحٌ':Added, #3: 3	قِيَامَ الرَّائِحَةِ
u'قِيَامٌ رَائِحٌ':Added, #5: 5	قِيَامِ الرَّائِحَةِ
u'قيام رَائِحَةٌ':Added, #5: 5	قِيَامِ الرَّائِحَةِ
u'قِيَامٌ رَائِحَةٌ':Added, #1: 1	قِيَامُ الرَّائِحَةِ
u'قيام رَائِحَةٌ':Added, #1: 1	قِيَامُ الرَّائِحَةِ
u'قِيَامٌ رَائِحَةٌ':Added, #3: 3	قِيَامَ الرَّائِحَةِ
u'قيام رَائِحَةٌ':Added, #3: 3	قِيَامَ الرَّائِحَةِ
u'قِيَامٌ رَائِحَةٌ':Added, #5: 5	قِيَامِ الرَّائِحَةِ
u'قيام رَجُلٌ':Added, #5: 5	قِيَامِ الرَّائِحَةِ
u'قِيَامٌ رَجُلٌ':Added, #1: 1	قِيَامُ الرَّجُلِ
u'قيام رَجُلٌ':Added, #1: 1	قِيَامُ الرَّجُلِ
u'قِيَامٌ رَجُلٌ':Added, #2: 2	قِيَامِ الرَّجُلِ
u'قيام رُخْصَةٌ':Added, #2: 2	قِيَامِ الرَّجُلِ
u'قِيَامٌ رُخْصَةٌ':Added, #1: 1	قِيَامِ الرُّخْصَةِ
u'قيام رَسُولٌ':Added, #1: 1	قِيَامِ الرُّخْصَةِ
u'قِيَامٌ رَسُولٌ':Added, #1: 1	قِيَامُ الرّسُولِ
u'قيام رَسُولٌ':Added, #1: 1	قِيَامُ الرّسُولِ
u'قِيَامٌ رَسُولٌ':Added, #5: 5	قِيَامِ رَسُولِ
u'قيام رَسُولٌ':Added, #5: 5	قِيَامِ رَسُولِ
u'قِيَامٌ رَسُولٌ':Added, #7: 7	قِيَامَ رَسُولِ
u'قيام رُشْدٌ':Added, #7: 7	قِيَامَ رَسُولِ
u'قِيَامٌ رُشْدٌ':Added, #1: 1	قِيَامَ الرُّشْدِ
u'قيام رَفْعٌ':Added, #1: 1	قِيَامَ الرُّشْدِ
u'قِيَامٌ رَفْعٌ':Added, #1: 1	قِيَامُ الرَّفْعِ
u'قيام رِقٌّ':Added, #1: 1	قِيَامُ الرَّفْعِ
u'قيام رِقٌّ':Added, #1: 1	قِيَامَ الرِّقِّ
u'قِيَامٌ رِقٌّ':Added, #1: 1	قِيَامِ الرِّقِّ
u'قِيَامٌ رِقٌّ':Added, #1: 1	قِيَامَ الرِّقِّ
u'قيام رِقٌّ':Added, #1: 1	قِيَامِ الرِّقِّ
u'قِيَامٌ رِقٌّ':Added, #6: 6	قِيَامُ الرِّقِّ
u'قيام ركعة':Added, #6: 6	قِيَامُ الرِّقِّ
u'قِيَامٌ ركعة':Added, #1: 1	قِيَامِ الرَّكْعَةِ
u'قيام رَكْعَةٌ':Added, #1: 1	قِيَامِ الرَّكْعَةِ
u'قِيَامٌ رَكْعَةٌ':Added, #1: 1	قِيَامِ الرَّكْعَةِ
u'قيام رُكوعٌ':Added, #1: 1	قِيَامِ الرَّكْعَةِ
u'قِيَامٌ رُكوعٌ':Added, #1: 1	قِيَامِ الرُّكُوعِ
u'قيام رَهْنٌ':Added, #1: 1	قِيَامِ الرُّكُوعِ
u'قِيَامٌ رَهْنٌ':Added, #5: 5	قِيَامِ الرَّهْنِ
u'قيام زَوْجٌ':Added, #5: 5	قِيَامِ الرَّهْنِ
u'قيام زَوْجٌ':Added, #1: 1	قِيَامُ الزَّوْجِ
u'قِيَامٌ زَوْجٌ':Added, #1: 1	قِيَامِ الزَّوْجِ
u'قِيَامٌ زَوْجٌ':Added, #1: 1	قِيَامُ الزَّوْجِ
u'قيام زَوْجَةٌ':Added, #1: 1	قِيَامِ الزَّوْجِ
u'قِيَامٌ زَوْجَةٌ':Added, #1: 1	قِيَامِ الزَّوْجَةِ
u'قيام زَوْجِيٌّ':Added, #1: 1	قِيَامِ الزَّوْجَةِ
u'قِيَامٌ زَوْجِيٌّ':Added, #11: 11	قِيَامِ الزَّوْجِيَّةِ
u'قيام زَوْجِيٌّ':Added, #11: 11	قِيَامِ الزَّوْجِيَّةِ
u'قِيَامٌ زَوْجِيٌّ':Added, #3: 3	قِيَامَ الزَّوْجِيَّةِ
u'قيام زَيْدٌ':Added, #3: 3	قِيَامَ الزَّوْجِيَّةِ
u'قِيَامٌ زَيْدٌ':Added, #1: 1	قِيَامُ زَيْدٍ
u'قيام زَيْدٌ':Added, #1: 1	قِيَامُ زَيْدٍ
u'قِيَامٌ زَيْدٌ':Added, #3: 3	قِيَامَ زَيْدٍ
u'قيام زَيْدٌ':Added, #3: 3	قِيَامَ زَيْدٍ
u'قِيَامٌ زَيْدٌ':Added, #5: 5	قِيَامِ زَيْدٍ
u'قيام سَارِي':Added, #5: 5	قِيَامِ زَيْدٍ
u'قِيَامٌ سَارِي':Added, #1: 1	قِيَامَ السَّارِيَةِ
u'قيام سَاعَةٌ':Added, #1: 1	قِيَامَ السَّارِيَةِ
u'قيام سَاعَةٌ':Added, #1: 1	قِيَامُ السّاعَةِ
u'قيام سَاعَةٌ':Added, #1: 1	قِيَامُ السَّاعَةِ
u'قِيَامٌ سَاعَةٌ':Added, #1: 1	قِيَامِ السّاعَةِ
u'قِيَامٌ سَاعَةٌ':Added, #1: 1	قِيَامُ السّاعَةِ
u'قِيَامٌ سَاعَةٌ':Added, #1: 1	قِيَامُ السَّاعَةِ
u'قيام سَاعَةٌ':Added, #1: 1	قِيَامِ السّاعَةِ
u'قِيَامٌ سَاعَةٌ':Added, #22: 22	قِيَامِ السَّاعَةِ
u'قيام سَاعَةٌ':Added, #22: 22	قِيَامِ السَّاعَةِ
u'قِيَامٌ سَاعَةٌ':Added, #2: 2	قِيَامَ السَّاعَةِ
u'قيام سَبَّابٌ':Added, #2: 2	قِيَامَ السَّاعَةِ
u'قِيَامٌ سَبَّابٌ':Added, #1: 1	قِيَامِ السَّبَّابَةِ
u'قيام سَبَّابَةٌ':Added, #1: 1	قِيَامِ السَّبَّابَةِ
u'قِيَامٌ سَبَّابَةٌ':Added, #1: 1	قِيَامِ السَّبَّابَةِ
u'قيام سَبَبٌ':Added, #1: 1	قِيَامِ السَّبَّابَةِ
u'قِيَامٌ سَبَبٌ':Added, #12: 12	قِيَامِ السَّبَبِ
u'قيام سَبَبٌ':Added, #12: 12	قِيَامِ السَّبَبِ
u'قِيَامٌ سَبَبٌ':Added, #1: 1	قِيَامُ سَبَبِ
u'قيام سَبَبٌ':Added, #1: 1	قِيَامُ سَبَبِ
u'قِيَامٌ سَبَبٌ':Added, #2: 2	قِيَامُ السَّبَبِ
u'قيام سَبَبٌ':Added, #2: 2	قِيَامُ السَّبَبِ
u'قِيَامٌ سَبَبٌ':Added, #3: 3	قِيَامِ سَبَبِهِ
u'قيام سَفَرٌ':Added, #3: 3	قِيَامِ سَبَبِهِ
u'قِيَامٌ سَفَرٌ':Added, #1: 1	قِيَامُ السَّفَرِ
u'قيام سَلْطَنَةٌ':Added, #1: 1	قِيَامُ السَّفَرِ
u'قِيَامٌ سَلْطَنَةٌ':Added, #1: 1	قِيَامِ السَّلْطَنَةِ
u'قيام سِلْعَةٌ':Added, #1: 1	قِيَامِ السَّلْطَنَةِ
u'قِيَامٌ سِلْعَةٌ':Added, #15: 15	قِيَامِ السِّلْعَةِ
u'قيام سِلْعَةٌ':Added, #15: 15	قِيَامِ السِّلْعَةِ
u'قِيَامٌ سِلْعَةٌ':Added, #1: 1	قِيَامَ السِّلْعَةِ
u'قيام سِلْعَةٌ':Added, #1: 1	قِيَامَ السِّلْعَةِ
u'قِيَامٌ سِلْعَةٌ':Added, #2: 2	قِيَامُ السِّلْعَةِ
u'قيام سَلَمٌ':Added, #2: 2	قِيَامُ السِّلْعَةِ
u'قِيَامٌ سَلَمٌ':Added, #1: 1	قِيَامِ السَّلَمِ
u'قيام سَنَةٌ':Added, #1: 1	قِيَامِ السَّلَمِ
u'قِيَامٌ سَنَةٌ':Added, #1: 1	قِيَامِ سَنَةٍ
u'قيام سَوادٌ':Added, #1: 1	قِيَامِ سَنَةٍ
u'قِيَامٌ سَوادٌ':Added, #1: 1	قِيَامِ السَّوَادِ
u'قيام سُورَةٌ':Added, #1: 1	قِيَامِ السَّوَادِ
u'قِيَامٌ سُورَةٌ':Added, #1: 1	قِيَامَ السُّورَةِ
u'قيام سُورَةٌ':Added, #1: 1	قِيَامَ السُّورَةِ
u'قِيَامٌ سُورَةٌ':Added, #2: 2	قِيَامِ السُّورَةِ
u'قيام سَيِّدٌ':Added, #2: 2	قِيَامِ السُّورَةِ
u'قِيَامٌ سَيِّدٌ':Added, #1: 1	قِيَامِ السَّيِّدِ
u'قيام سَيْفٌ':Added, #1: 1	قِيَامِ السَّيِّدِ
u'قيام سَيْفٌ':Added, #1: 1	قِيَامَ السَّيْفِ
u'قِيَامٌ سَيْفٌ':Added, #1: 1	قِيَامُ السَّيْفِ
u'قِيَامٌ سَيْفٌ':Added, #1: 1	قِيَامَ السَّيْفِ
u'قيام شَاهِدٌ':Added, #1: 1	قِيَامُ السَّيْفِ
u'قِيَامٌ شَاهِدٌ':Added, #1: 1	قِيَامِ شَاهِدٍ
u'قيام شُبْهَةٌ':Added, #1: 1	قِيَامِ شَاهِدٍ
u'قِيَامٌ شُبْهَةٌ':Added, #3: 3	قِيَامُ الشُّبْهَةِ
u'قيام شُبْهَةٌ':Added, #3: 3	قِيَامُ الشُّبْهَةِ
u'قِيَامٌ شُبْهَةٌ':Added, #4: 4	قِيَامِ الشُّبْهَةِ
u'قيام شَخْصٌ':Added, #4: 4	قِيَامِ الشُّبْهَةِ
u'قِيَامٌ شَخْصٌ':Added, #1: 1	قِيَامَ الشَّخْصِ
u'قيام شَخْصٌ':Added, #1: 1	قِيَامَ الشَّخْصِ
u'قِيَامٌ شَخْصٌ':Added, #1: 1	قِيَامُ شَخْصٍ
u'قيام شَرْطٌ':Added, #1: 1	قِيَامُ شَخْصٍ
u'قِيَامٌ شَرْطٌ':Added, #1: 1	قِيَامُ الشَّرْطِ
u'قيام شَرْطٌ':Added, #1: 1	قِيَامُ الشَّرْطِ
u'قِيَامٌ شَرْطٌ':Added, #2: 2	قِيَامِ الشَّرْطِ
u'قيام شركة':Added, #2: 2	قِيَامِ الشَّرْطِ
u'قِيَامٌ شركة':Added, #1: 1	قِيَامَ الشَّرِكَةِ
u'قيام شَرِكَةٌ':Added, #1: 1	قِيَامَ الشَّرِكَةِ
u'قِيَامٌ شَرِكَةٌ':Added, #1: 1	قِيَامَ الشَّرِكَةِ
u'قيام شَرِيكٌ':Added, #1: 1	قِيَامَ الشَّرِكَةِ
u'قِيَامٌ شَرِيكٌ':Added, #1: 1	قِيَامِ الشَّرِيكِ
u'قيام شَعَائِرُ':Added, #1: 1	قِيَامِ الشَّرِيكِ
u'قِيَامٌ شَعَائِرُ':Added, #1: 1	قِيَامِ الشَّعَائِرِ
u'قيام شُغْلٌ':Added, #1: 1	قِيَامِ الشَّعَائِرِ
u'قيام شُغْل':Added, #1: 1	قِيَامِ شُغْلِ
u'قِيَامٌ شُغْلٌ':Added, #1: 1	قِيَامِ شُغْلِ
u'قِيَامٌ شُغْل':Added, #1: 1	قِيَامِ شُغْلِ
u'قيام شَفِيعٌ':Added, #1: 1	قِيَامِ شُغْلِ
u'قِيَامٌ شَفِيعٌ':Added, #4: 4	قِيَامِ الشَّفِيعِ
u'قيام شَكٌّ':Added, #4: 4	قِيَامِ الشَّفِيعِ
u'قِيَامٌ شَكٌّ':Added, #1: 1	قِيَامُ الشَّكِّ
u'قيام شَكٌّ':Added, #1: 1	قِيَامُ الشَّكِّ
u'قِيَامٌ شَكٌّ':Added, #2: 2	قِيَامِ الشَّكِّ
u'قيام شَهَادَةٌ':Added, #2: 2	قِيَامِ الشَّكِّ
u'قِيَامٌ شَهَادَةٌ':Added, #1: 1	قِيَامِ الشَّهَادَةِ
u'قيام شَهْرٌ':Added, #1: 1	قِيَامِ الشَّهَادَةِ
u'قِيَامٌ شَهْرٌ':Added, #1: 1	قِيَامَ شَهْرِ
u'قيام شَهْرٌ':Added, #1: 1	قِيَامَ شَهْرِ
u'قِيَامٌ شَهْرٌ':Added, #8: 8	قِيَامِ شَهْرِ
u'قيام شَيْءٌ':Added, #8: 8	قِيَامِ شَهْرِ
u'قِيَامٌ شَيْءٌ':Added, #1: 1	قِيَامِ شَيْءٍ
u'قيام شَيْءٌ':Added, #1: 1	قِيَامِ شَيْءٍ
u'قِيَامٌ شَيْءٌ':Added, #2: 2	قِيَامُ الشَّيْءِ
u'قيام صَاحِبٌ':Added, #2: 2	قِيَامُ الشَّيْءِ
u'قِيَامٌ صَاحِبٌ':Added, #2: 2	قِيَامِ صَاحِبِ
u'قيام صِفَةٌ':Added, #2: 2	قِيَامِ صَاحِبِ
u'قيام صِفَةٌ':Added, #1: 1	قِيَامَ الصِّفَةِ
u'قيام صِفَةٌ':Added, #1: 1	قِيَامُ الصِّفَةِ
u'قِيَامٌ صِفَةٌ':Added, #1: 1	قِيَامِ الصِّفَةِ
u'قِيَامٌ صِفَةٌ':Added, #1: 1	قِيَامَ الصِّفَةِ
u'قِيَامٌ صِفَةٌ':Added, #1: 1	قِيَامُ الصِّفَةِ
u'قيام صِفَةٌ':Added, #1: 1	قِيَامِ الصِّفَةِ
u'قِيَامٌ صِفَةٌ':Added, #1: 1	قِيَامِ صِفَةِ
u'قيام صَلاَةٌ':Added, #1: 1	قِيَامِ صِفَةِ
u'قِيَامٌ صَلاَةٌ':Added, #1: 1	قِيَامُ صَلاَةِ
u'قيام صَلاَةٌ':Added, #1: 1	قِيَامُ صَلاَةِ
u'قِيَامٌ صَلاَةٌ':Added, #2: 2	قِيَامَ الصَّلَاةِ
u'قيام صَلاَةٌ':Added, #2: 2	قِيَامَ الصَّلَاةِ
u'قِيَامٌ صَلاَةٌ':Added, #3: 3	قِيَامِ الصَّلَاةِ
u'قيام صُنَّاعٌ':Added, #3: 3	قِيَامِ الصَّلَاةِ
u'قِيَامٌ صُنَّاعٌ':Added, #1: 1	قِيَامُ الصُّنَّاعِ
u'قيام ضَرْبٌ':Added, #1: 1	قِيَامُ الصُّنَّاعِ
u'قِيَامٌ ضَرْبٌ':Added, #1: 1	قِيَامِ الضَّرْبِ
u'قيام طَاقَةٌ':Added, #1: 1	قِيَامِ الضَّرْبِ
u'قِيَامٌ طَاقَةٌ':Added, #1: 1	قِيَامِ الطَّاقَةِ
u'قيام طَالِبٌ':Added, #1: 1	قِيَامِ الطَّاقَةِ
u'قِيَامٌ طَالِبٌ':Added, #1: 1	قِيَامُ الطَّالِبِ
u'قيام طَائِفٌ':Added, #1: 1	قِيَامُ الطَّالِبِ
u'قِيَامٌ طَائِفٌ':Added, #1: 1	قِيَامُ طَائِفَةٍ
u'قيام طَلاَقٌ':Added, #1: 1	قِيَامُ طَائِفَةٍ
u'قِيَامٌ طَلاَقٌ':Added, #1: 1	قِيَامِ طَلَاقِ
u'قيام طلب':Added, #1: 1	قِيَامِ طَلَاقِ
u'قِيَامٌ طلب':Added, #1: 1	قِيَامِ طَلَبِ
u'قيام طَلَبٌ':Added, #1: 1	قِيَامِ طَلَبِ
u'قيام طَلَبٌ':Added, #1: 1	قِيَامُ طَلَبٍ
u'قِيَامٌ طَلَبٌ':Added, #1: 1	قِيَامِ طَلَبِ
u'قِيَامٌ طَلَبٌ':Added, #1: 1	قِيَامُ طَلَبٍ
u'قيام طلب':Added, #1: 1	قِيَامِ طَلَبِ
u'قِيَامٌ طلب':Added, #3: 3	قِيَامُ الطَّلَبِ
u'قيام طَلَبٌ':Added, #3: 3	قِيَامُ الطَّلَبِ
u'قِيَامٌ طَلَبٌ':Added, #3: 3	قِيَامُ الطَّلَبِ
u'قيام طَهَارَةٌ':Added, #3: 3	قِيَامُ الطَّلَبِ
u'قِيَامٌ طَهَارَةٌ':Added, #1: 1	قِيَامُ الطَّهَارَةِ
u'قيام ظَنٌّ':Added, #1: 1	قِيَامُ الطَّهَارَةِ
u'قِيَامٌ ظَنٌّ':Added, #1: 1	قِيَامِ الظَّنِّ
u'قيام ظَهيرٌ':Added, #1: 1	قِيَامِ الظَّنِّ
u'قِيَامٌ ظَهيرٌ':Added, #3: 3	قِيَامِ الظَّهِيرَةِ
u'قيام ظَهيرَةٌ':Added, #3: 3	قِيَامِ الظَّهِيرَةِ
u'قِيَامٌ ظَهيرَةٌ':Added, #3: 3	قِيَامِ الظَّهِيرَةِ
u'قيام عَاقِدٌ':Added, #3: 3	قِيَامِ الظَّهِيرَةِ
u'قِيَامٌ عَاقِدٌ':Added, #1: 1	قِيَامُ الْعَاقِدَيْنِ
u'قيام عجز':Added, #1: 1	قِيَامُ الْعَاقِدَيْنِ
u'قِيَامٌ عجز':Added, #1: 1	قِيَامِ الْعَجْزِ
u'قيام عَجْزٌ':Added, #1: 1	قِيَامِ الْعَجْزِ
u'قِيَامٌ عَجْزٌ':Added, #1: 1	قِيَامِ الْعَجْزِ
u'قيام عَدَالَةٌ':Added, #1: 1	قِيَامِ الْعَجْزِ
u'قِيَامٌ عَدَالَةٌ':Added, #1: 1	قِيَامِ الْعَدَالَةِ
u'قيام عِدَّةٌ':Added, #1: 1	قِيَامِ الْعَدَالَةِ
u'قِيَامٌ عِدَّةٌ':Added, #12: 12	قِيَامِ الْعِدَّةِ
u'قيام عِدَّةٌ':Added, #12: 12	قِيَامِ الْعِدَّةِ
u'قِيَامٌ عِدَّةٌ':Added, #2: 2	قِيَامُ الْعِدَّةِ
u'قيام عُذْرٌ':Added, #2: 2	قِيَامُ الْعِدَّةِ
u'قِيَامٌ عُذْرٌ':Added, #1: 1	قِيَامَ الْعُذْرِ
u'قيام عُذْرٌ':Added, #1: 1	قِيَامَ الْعُذْرِ
u'قِيَامٌ عُذْرٌ':Added, #1: 1	قِيَامِ عُذْرٍ
u'قيام عُذْرٌ':Added, #1: 1	قِيَامِ عُذْرٍ
u'قِيَامٌ عُذْرٌ':Added, #5: 5	قِيَامِ الْعُذْرِ
u'قيام عَرَضٌ':Added, #5: 5	قِيَامِ الْعُذْرِ
u'قيام عَرْضٌ':Added, #1: 1	قِيَامَ الْعَرَضِ
u'قيام عَرْضٌ':Added, #1: 1	قِيَامَ الْعَرْضِ
u'قِيَامٌ عَرَضٌ':Added, #1: 1	قِيَامُ الْعَرْضِ
u'قِيَامٌ عَرْضٌ':Added, #1: 1	قِيَامَ الْعَرَضِ
u'قِيَامٌ عَرْضٌ':Added, #1: 1	قِيَامَ الْعَرْضِ
u'قيام عَرَضٌ':Added, #1: 1	قِيَامُ الْعَرْضِ
u'قِيَامٌ عَرَضٌ':Added, #2: 2	قِيَامُ الْعَرَضِ
u'قيام عَرَضٌ':Added, #2: 2	قِيَامُ الْعَرَضِ
u'قيام عَرْضٌ':Added, #3: 3	قِيَامِ الْعَرَضِ
u'قِيَامٌ عَرَضٌ':Added, #3: 3	قِيَامِ الْعَرْضِ
u'قِيَامٌ عَرْضٌ':Added, #3: 3	قِيَامِ الْعَرَضِ
u'قيام عرف':Added, #3: 3	قِيَامِ الْعَرْضِ
u'قِيَامٌ عرف':Added, #1: 1	قِيَامِ الْعُرْفِ
u'قيام عُرْفٌ':Added, #1: 1	قِيَامِ الْعُرْفِ
u'قِيَامٌ عُرْفٌ':Added, #1: 1	قِيَامِ الْعُرْفِ
u'قيام عَقْدٌ':Added, #1: 1	قِيَامِ الْعُرْفِ
u'قِيَامٌ عَقْدٌ':Added, #1: 1	قِيَامِ عَقْدِ
u'قيام عَقْدٌ':Added, #1: 1	قِيَامِ عَقْدِ
u'قيام عَقْدٌ':Added, #2: 2	قِيَامَ الْعَقْدِ
u'قِيَامٌ عَقْدٌ':Added, #2: 2	قِيَامُ الْعَقْدِ
u'قِيَامٌ عَقْدٌ':Added, #2: 2	قِيَامَ الْعَقْدِ
u'قيام عَقْدٌ':Added, #2: 2	قِيَامُ الْعَقْدِ
u'قِيَامٌ عَقْدٌ':Added, #6: 6	قِيَامِ الْعَقْدِ
u'قيام عَقْلٌ':Added, #6: 6	قِيَامِ الْعَقْدِ
u'قِيَامٌ عَقْلٌ':Added, #2: 2	قِيَامِ الْعَقْلِ
u'قيام عَقْلٌ':Added, #2: 2	قِيَامِ الْعَقْلِ
u'قِيَامٌ عَقْلٌ':Added, #2: 2	قِيَامِ عَقْلِهِ
u'قيام عِلَّةٌ':Added, #2: 2	قِيَامِ عَقْلِهِ
u'قِيَامٌ عِلَّةٌ':Added, #2: 2	قِيَامِ الْعِلَّةِ
u'قيام عِمَارَةٌ':Added, #2: 2	قِيَامِ الْعِلَّةِ
u'قِيَامٌ عِمَارَةٌ':Added, #1: 1	قِيَامَ الْعِمَارَةِ
u'قيام عَيْبٌ':Added, #1: 1	قِيَامَ الْعِمَارَةِ
u'قِيَامٌ عَيْبٌ':Added, #10: 10	قِيَامِ الْعَيْبِ
u'قيام عَيْبٌ':Added, #10: 10	قِيَامِ الْعَيْبِ
u'قِيَامٌ عَيْبٌ':Added, #1: 1	قِيَامُ الْعَيْبِ
u'قيام عَيْبٌ':Added, #1: 1	قِيَامُ الْعَيْبِ
u'قِيَامٌ عَيْبٌ':Added, #6: 6	قِيَامَ الْعَيْبِ
u'قيام عين':Added, #6: 6	قِيَامَ الْعَيْبِ
u'قيام عَيْنٌ':Added, #10: 10	قِيَامِ الْعَيْنِ
u'قيام عَيْن':Added, #10: 10	قِيَامِ الْعَيْنِ
u'قِيَامٌ عين':Added, #10: 10	قِيَامِ الْعَيْنِ
u'قِيَامٌ عَيْنٌ':Added, #10: 10	قِيَامِ الْعَيْنِ
u'قِيَامٌ عَيْن':Added, #10: 10	قِيَامِ الْعَيْنِ
u'قيام عين':Added, #10: 10	قِيَامِ الْعَيْنِ
u'قيام عَيْنٌ':Added, #1: 1	قِيَامُ الْعَيْنِ
u'قيام عَيْن':Added, #1: 1	قِيَامُ الْعَيْنِ
u'قِيَامٌ عين':Added, #1: 1	قِيَامُ الْعَيْنِ
u'قِيَامٌ عَيْنٌ':Added, #1: 1	قِيَامُ الْعَيْنِ
u'قِيَامٌ عَيْن':Added, #1: 1	قِيَامُ الْعَيْنِ
u'قيام عين':Added, #1: 1	قِيَامُ الْعَيْنِ
u'قيام عَيْنٌ':Added, #1: 1	قِيَامِ عَيْنِ
u'قيام عَيْن':Added, #1: 1	قِيَامِ عَيْنِ
u'قِيَامٌ عين':Added, #1: 1	قِيَامِ عَيْنِ
u'قِيَامٌ عَيْنٌ':Added, #1: 1	قِيَامِ عَيْنِ
u'قِيَامٌ عَيْن':Added, #1: 1	قِيَامِ عَيْنِ
u'قيام عين':Added, #1: 1	قِيَامِ عَيْنِ
u'قيام عَيْنٌ':Added, #2: 2	قِيَامِ عَيْنِهِ
u'قيام عَيْن':Added, #2: 2	قِيَامِ عَيْنِهِ
u'قِيَامٌ عين':Added, #2: 2	قِيَامِ عَيْنِهِ
u'قِيَامٌ عَيْنٌ':Added, #2: 2	قِيَامِ عَيْنِهِ
u'قِيَامٌ عَيْن':Added, #2: 2	قِيَامِ عَيْنِهِ
u'قيام غَرَرٌ':Added, #2: 2	قِيَامِ عَيْنِهِ
u'قِيَامٌ غَرَرٌ':Added, #1: 1	قِيَامِ الْغَرَرِ
u'قيام غرماء':Added, #1: 1	قِيَامِ الْغَرَرِ
u'قِيَامٌ غرماء':Added, #1: 1	قِيَامَ الْغُرَمَاءِ
u'قيام غرماء':Added, #1: 1	قِيَامَ الْغُرَمَاءِ
u'قِيَامٌ غرماء':Added, #5: 5	قِيَامِ الْغُرَمَاءِ
u'قيام غير':Added, #5: 5	قِيَامِ الْغُرَمَاءِ
u'قيام غَيْرٌ':Added, #1: 1	قِيَامِ غَيْرِ
u'قِيَامٌ غير':Added, #1: 1	قِيَامِ غَيْرِ
u'قِيَامٌ غَيْرٌ':Added, #1: 1	قِيَامِ غَيْرِ
u'قيام غير':Added, #1: 1	قِيَامِ غَيْرِ
u'قيام غَيْرٌ':Added, #2: 2	قِيَامُ غَيْرِهِ
u'قِيَامٌ غير':Added, #2: 2	قِيَامُ غَيْرِهِ
u'قِيَامٌ غَيْرٌ':Added, #2: 2	قِيَامُ غَيْرِهِ
u'قيام غير':Added, #2: 2	قِيَامُ غَيْرِهِ
u'قيام غَيْرٌ':Added, #3: 3	قِيَامِ غَيْرِهِ
u'قِيَامٌ غير':Added, #3: 3	قِيَامِ غَيْرِهِ
u'قِيَامٌ غَيْرٌ':Added, #3: 3	قِيَامِ غَيْرِهِ
u'قيام فَارِقٌ':Added, #3: 3	قِيَامِ غَيْرِهِ
u'قِيَامٌ فَارِقٌ':Added, #1: 1	قِيَامِ الْفَارِقِ
u'قيام فتنة':Added, #1: 1	قِيَامِ الْفَارِقِ
u'قِيَامٌ فتنة':Added, #1: 1	قِيَامُ الْفِتْنَةِ
u'قيام فِتْنَةٌ':Added, #1: 1	قِيَامُ الْفِتْنَةِ
u'قِيَامٌ فِتْنَةٌ':Added, #1: 1	قِيَامُ الْفِتْنَةِ
u'قيام فِرَاشٌ':Added, #1: 1	قِيَامُ الْفِتْنَةِ
u'قيام فِرَاشٌ':Added, #2: 2	قِيَامُ الْفِرَاشِ
u'قِيَامٌ فِرَاشٌ':Added, #2: 2	قِيَامِ الْفِرَاشِ
u'قِيَامٌ فِرَاشٌ':Added, #2: 2	قِيَامُ الْفِرَاشِ
u'قيام فَرْضٌ':Added, #2: 2	قِيَامِ الْفِرَاشِ
u'قِيَامٌ فَرْضٌ':Added, #1: 1	قِيَامِ الْفَرْضِ
u'قيام فَرْضٌ':Added, #1: 1	قِيَامِ الْفَرْضِ
u'قِيَامٌ فَرْضٌ':Added, #1: 1	قِيَامَ فَرْضٍ
u'قيام فَرْعٌ':Added, #1: 1	قِيَامَ فَرْضٍ
u'قِيَامٌ فَرْعٌ':Added, #1: 1	قِيَامُ الْفَرْعِ
u'قيام فُرُوعٌ':Added, #1: 1	قِيَامُ الْفَرْعِ
u'قِيَامٌ فُرُوعٌ':Added, #2: 2	قِيَامِ الْفُرُوعِ
u'قيام فَرِيضَةٌ':Added, #2: 2	قِيَامِ الْفُرُوعِ
u'قِيَامٌ فَرِيضَةٌ':Added, #1: 1	قِيَامِ الْفَرِيضَةِ
u'قيام فَضْلٌ':Added, #1: 1	قِيَامِ الْفَرِيضَةِ
u'قِيَامٌ فَضْلٌ':Added, #2: 2	قِيَامِ الْفَضْلِ
u'قيام فلان':Added, #2: 2	قِيَامِ الْفَضْلِ
u'قِيَامٌ فلان':Added, #1: 1	قِيَامُ بِلَالٍ
u'قيام قَاطِعٌ':Added, #1: 1	قِيَامُ بِلَالٍ
u'قِيَامٌ قَاطِعٌ':Added, #1: 1	قِيَامِ الْقَاطِعِ
u'قيام قدرة':Added, #1: 1	قِيَامِ الْقَاطِعِ
u'قِيَامٌ قدرة':Added, #1: 1	قِيَامِ قُدْرَتِهِ
u'قيام قُدْرَةٌ':Added, #1: 1	قِيَامِ قُدْرَتِهِ
u'قِيَامٌ قُدْرَةٌ':Added, #1: 1	قِيَامِ قُدْرَتِهِ
u'قيام قَرِينٌ':Added, #1: 1	قِيَامِ قُدْرَتِهِ
u'قِيَامٌ قَرِينٌ':Added, #1: 1	قِيَامَ الْقَرِينَةِ
u'قيام قَرِينٌ':Added, #1: 1	قِيَامَ الْقَرِينَةِ
u'قِيَامٌ قَرِينٌ':Added, #1: 1	قِيَامِ قَرِينَةِ
u'قيام قُنُوتٌ':Added, #1: 1	قِيَامِ قَرِينَةِ
u'قِيَامٌ قُنُوتٌ':Added, #1: 1	قِيَامِ الْقُنُوتِ
u'قيام قول':Added, #1: 1	قِيَامِ الْقُنُوتِ
u'قِيَامٌ قول':Added, #1: 1	قِيَامِ قَوْلِ
u'قيام قَوْلٌ':Added, #1: 1	قِيَامِ قَوْلِ
u'قِيَامٌ قَوْلٌ':Added, #1: 1	قِيَامِ قَوْلِ
u'قيام قَوْمٌ':Added, #1: 1	قِيَامِ قَوْلِ
u'قِيَامٌ قَوْمٌ':Added, #1: 1	قِيَامِ الْقَوْمِ
u'قيام قيام':Added, #1: 1	قِيَامِ الْقَوْمِ
u'قيام قِيَامٌ':Added, #1: 1	قِيَامَ قِيَامِهِ
u'قِيَامٌ قيام':Added, #1: 1	قِيَامَ قِيَامِهِ
u'قِيَامٌ قِيَامٌ':Added, #1: 1	قِيَامَ قِيَامِهِ
u'قيام قِيَامَةٌ':Added, #1: 1	قِيَامَ قِيَامِهِ
u'قِيَامٌ قِيَامَةٌ':Added, #1: 1	قِيَامِ الْقِيَامَةِ
u'قيام قَيْدٌ':Added, #1: 1	قِيَامِ الْقِيَامَةِ
u'قِيَامٌ قَيْدٌ':Added, #1: 1	قِيَامُ الْقَيْدِ
u'قيام كَافٌّ':Added, #1: 1	قِيَامُ الْقَيْدِ
u'قِيَامٌ كَافٌّ':Added, #1: 1	قِيَامِ كَافَّةِ
u'قيام كَافَّةٌ':Added, #1: 1	قِيَامِ كَافَّةِ
u'قِيَامٌ كَافَّةٌ':Added, #1: 1	قِيَامِ كَافَّةِ
u'قيام كِتَابَةٌ':Added, #1: 1	قِيَامِ كَافَّةِ
u'قِيَامٌ كِتَابَةٌ':Added, #10: 10	قِيَامِ الْكِتَابَةِ
u'قيام كَلاَمٌ':Added, #10: 10	قِيَامِ الْكِتَابَةِ
u'قِيَامٌ كَلاَمٌ':Added, #1: 1	قِيَامِ الْكَلَامِ
u'قيام لبس':Added, #1: 1	قِيَامِ الْكَلَامِ
u'قِيَامٌ لبس':Added, #1: 1	قِيَامِ لُبْسِ
u'قيام لُبْسٌ':Added, #1: 1	قِيَامِ لُبْسِ
u'قِيَامٌ لُبْسٌ':Added, #1: 1	قِيَامِ لُبْسِ
u'قيام لَفْظٌ':Added, #1: 1	قِيَامِ لُبْسِ
u'قِيَامٌ لَفْظٌ':Added, #1: 1	قِيَامُ اللَّفْظِ
u'قيام لَفْظٌ':Added, #1: 1	قِيَامُ اللَّفْظِ
u'قيام لَفْظٌ':Added, #1: 1	قِيَامَ لَفْظٍ
u'قِيَامٌ لَفْظٌ':Added, #1: 1	قِيَامِ لَفْظٍ
u'قِيَامٌ لَفْظٌ':Added, #1: 1	قِيَامَ لَفْظٍ
u'قيام لَوَثٌ':Added, #1: 1	قِيَامِ لَفْظٍ
u'قِيَامٌ لَوَثٌ':Added, #1: 1	قِيَامِ اللَّوَثِ
u'قيام لَوْنٌ':Added, #1: 1	قِيَامِ اللَّوَثِ
u'قِيَامٌ لَوْنٌ':Added, #2: 2	قِيَامِ اللَّوْنِ
u'قيام لَيْلٌ':Added, #2: 2	قِيَامِ اللَّوْنِ
u'قِيَامٌ لَيْلٌ':Added, #1: 1	قِيَامَ لَيْلَةٍ
u'قيام لَيْلٌ':Added, #1: 1	قِيَامَ لَيْلَةٍ
u'قِيَامٌ لَيْلٌ':Added, #20: 20	قِيَامُ اللَّيْلِ
u'قيام لَيْلٌ':Added, #20: 20	قِيَامُ اللَّيْلِ
u'قِيَامٌ لَيْلٌ':Added, #26: 26	قِيَامَ اللَّيْلِ
u'قيام لَيْلٌ':Added, #26: 26	قِيَامَ اللَّيْلِ
u'قيام لَيْلٌ':Added, #2: 2	قِيَامَ لَيْلَةِ
u'قيام لَيْلٌ':Added, #2: 2	قِيَامُ لَيْلَةٍ
u'قِيَامٌ لَيْلٌ':Added, #2: 2	قِيَامِ لَيْلَةِ
u'قِيَامٌ لَيْلٌ':Added, #2: 2	قِيَامَ لَيْلَةِ
u'قِيَامٌ لَيْلٌ':Added, #2: 2	قِيَامُ لَيْلَةٍ
u'قيام لَيْلٌ':Added, #2: 2	قِيَامِ لَيْلَةِ
u'قِيَامٌ لَيْلٌ':Added, #49: 49	قِيَامِ اللَّيْلِ
u'قيام لَيْلٌ':Added, #49: 49	قِيَامِ اللَّيْلِ
u'قِيَامٌ لَيْلٌ':Added, #8: 8	قِيَامِ لَيْلَةٍ
u'قيام مَالٌ':Added, #8: 8	قِيَامِ لَيْلَةٍ
u'قِيَامٌ مَالٌ':Added, #2: 2	قِيَامَ مَالٍ
u'قيام مَالِيٌّ':Added, #2: 2	قِيَامَ مَالٍ
u'قِيَامٌ مَالِيٌّ':Added, #1: 1	قِيَامُ الْمَالِيَّةِ
u'قيام مَانِعٌ':Added, #1: 1	قِيَامُ الْمَالِيَّةِ
u'قيام مَانِعٌ':Added, #1: 1	قِيَامَ الْمَانِعِ
u'قِيَامٌ مَانِعٌ':Added, #1: 1	قِيَامُ الْمَانِعِ
u'قِيَامٌ مَانِعٌ':Added, #1: 1	قِيَامَ الْمَانِعِ
u'قيام مَانِعٌ':Added, #1: 1	قِيَامُ الْمَانِعِ
u'قيام مَانِعٌ':Added, #1: 1	قِيَامُ مَانِعٍ
u'قِيَامٌ مَانِعٌ':Added, #1: 1	قِيَامُ مَانِعِ
u'قِيَامٌ مَانِعٌ':Added, #1: 1	قِيَامُ مَانِعٍ
u'قيام مَانِعٌ':Added, #1: 1	قِيَامُ مَانِعِ
u'قِيَامٌ مَانِعٌ':Added, #5: 5	قِيَامِ الْمَانِعِ
u'قيام مُبِيحٌ':Added, #5: 5	قِيَامِ الْمَانِعِ
u'قِيَامٌ مُبِيحٌ':Added, #3: 3	قِيَامِ الْمُبِيحِ
u'قيام مَبِيعٌ':Added, #3: 3	قِيَامِ الْمُبِيحِ
u'قِيَامٌ مَبِيعٌ':Added, #10: 10	قِيَامِ الْمَبِيعِ
u'قيام مَبِيعٌ':Added, #10: 10	قِيَامِ الْمَبِيعِ
u'قِيَامٌ مَبِيعٌ':Added, #1: 1	قِيَامَ الْمَبِيعِ
u'قيام مَبِيعٌ':Added, #1: 1	قِيَامَ الْمَبِيعِ
u'قِيَامٌ مَبِيعٌ':Added, #5: 5	قِيَامُ الْمَبِيعِ
u'قيام مُحْتَسِبٌ':Added, #5: 5	قِيَامُ الْمَبِيعِ
u'قِيَامٌ مُحْتَسِبٌ':Added, #1: 1	قِيَامَ الْمُحْتَسِبِ
u'قيام مُحَرَّمٌ':Added, #1: 1	قِيَامَ الْمُحْتَسِبِ
u'قِيَامٌ مُحَرَّمٌ':Added, #3: 3	قِيَامِ الْمُحَرَّمِ
u'قيام مَحَلٌّ':Added, #3: 3	قِيَامِ الْمُحَرَّمِ
u'قيام مَحَلٌّ':Added, #2: 2	قِيَامَ الْمَحَلِّ
u'قيام مَحَلٌّ':Added, #2: 2	قِيَامُ الْمَحَلِّ
u'قِيَامٌ مَحَلٌّ':Added, #2: 2	قِيَامِ الْمَحَلِّ
u'قِيَامٌ مَحَلٌّ':Added, #2: 2	قِيَامَ الْمَحَلِّ
u'قِيَامٌ مَحَلٌّ':Added, #2: 2	قِيَامُ الْمَحَلِّ
u'قيام مراد':Added, #2: 2	قِيَامِ الْمَحَلِّ
u'قِيَامٌ مراد':Added, #1: 1	قِيَامِ مُرَادِهِ
u'قيام مُرَادٌ':Added, #1: 1	قِيَامِ مُرَادِهِ
u'قِيَامٌ مُرَادٌ':Added, #1: 1	قِيَامِ مُرَادِهِ
u'قيام مُرْتَهِنٌ':Added, #1: 1	قِيَامِ مُرَادِهِ
u'قِيَامٌ مُرْتَهِنٌ':Added, #2: 2	قِيَامَ الْمُرْتَهِنِ
u'قيام مَرْهُونٌ':Added, #2: 2	قِيَامَ الْمُرْتَهِنِ
u'قِيَامٌ مَرْهُونٌ':Added, #1: 1	قِيَامَ الْمَرْهُونِ
u'قيام مُسْتَحِقٌّ':Added, #1: 1	قِيَامَ الْمَرْهُونِ
u'قِيَامٌ مُسْتَحِقٌّ':Added, #1: 1	قِيَامِ الْمُسْتَحِقِّ
u'قيام مُسْتَنَدٌ':Added, #1: 1	قِيَامِ الْمُسْتَحِقِّ
u'قِيَامٌ مُسْتَنَدٌ':Added, #1: 1	قِيَامِ الْمُسْتَنَدِ
u'قيام مسكة':Added, #1: 1	قِيَامِ الْمُسْتَنَدِ
u'قِيَامٌ مسكة':Added, #1: 1	قِيَامِ الْمُسْكَةِ
u'قيام مُسْكَةٌ':Added, #1: 1	قِيَامِ الْمُسْكَةِ
u'قِيَامٌ مُسْكَةٌ':Added, #1: 1	قِيَامِ الْمُسْكَةِ
u'قيام مُسْلِمٌ':Added, #1: 1	قِيَامِ الْمُسْكَةِ
u'قِيَامٌ مُسْلِمٌ':Added, #1: 1	قِيَامِ الْمُسْلِمِ
u'قيام مُضَارَبَةٌ':Added, #1: 1	قِيَامِ الْمُسْلِمِ
u'قِيَامٌ مُضَارَبَةٌ':Added, #1: 1	قِيَامِ الْمُضَارَبَةِ
u'قيام مَطَرٌ':Added, #1: 1	قِيَامِ الْمُضَارَبَةِ
u'قِيَامٌ مَطَرٌ':Added, #1: 1	قِيَامِ الْمَطَرِ
u'قيام مُعَارَضَةٌ':Added, #1: 1	قِيَامِ الْمَطَرِ
u'قِيَامٌ مُعَارَضَةٌ':Added, #1: 1	قِيَامِ الْمُعَارَضَةِ
u'قيام مَعْقُودٌ':Added, #1: 1	قِيَامِ الْمُعَارَضَةِ
u'قِيَامٌ مَعْقُودٌ':Added, #2: 2	قِيَامَ الْمَعْقُودِ
u'قيام مَعْقُودٌ':Added, #2: 2	قِيَامَ الْمَعْقُودِ
u'قِيَامٌ مَعْقُودٌ':Added, #5: 5	قِيَامُ الْمَعْقُودِ
u'قيام مَعِيشَةٌ':Added, #5: 5	قِيَامُ الْمَعْقُودِ
u'قِيَامٌ مَعِيشَةٌ':Added, #1: 1	قِيَامِ الْمَعِيشَةِ
u'قيام مَغْصُوب':Added, #1: 1	قِيَامِ الْمَعِيشَةِ
u'قيام مَغْصُوب':Added, #1: 1	قِيَامَ الْمَغْصُوبِ
u'قِيَامٌ مَغْصُوب':Added, #1: 1	قِيَامِ الْمَغْصُوبِ
u'قِيَامٌ مَغْصُوب':Added, #1: 1	قِيَامَ الْمَغْصُوبِ
u'قيام مُقَابَلٌ':Added, #1: 1	قِيَامِ الْمَغْصُوبِ
u'قِيَامٌ مُقَابَلٌ':Added, #1: 1	قِيَامِ الْمُقَابَلَةِ
u'قيام مُقَابَلَةٌ':Added, #1: 1	قِيَامِ الْمُقَابَلَةِ
u'قِيَامٌ مُقَابَلَةٌ':Added, #1: 1	قِيَامِ الْمُقَابَلَةِ
u'قيام مُقْتَضىً':Added, #1: 1	قِيَامِ الْمُقَابَلَةِ
u'قِيَامٌ مُقْتَضىً':Added, #2: 2	قِيَامِ مُقْتَضِيهِ
u'قيام مِلَّةٌ':Added, #2: 2	قِيَامِ مُقْتَضِيهِ
u'قِيَامٌ مِلَّةٌ':Added, #2: 2	قِيَامُ الْمِلَّةِ
u'قيام مِلْكٌ':Added, #2: 2	قِيَامُ الْمِلَّةِ
u'قِيَامٌ مِلْكٌ':Added, #15: 15	قِيَامُ الْمِلْكِ
u'قيام مِلْكٌ':Added, #15: 15	قِيَامُ الْمِلْكِ
u'قِيَامٌ مِلْكٌ':Added, #1: 1	قِيَامُ مِلْكِهِ
u'قيام مِلْكٌ':Added, #1: 1	قِيَامُ مِلْكِهِ
u'قِيَامٌ مِلْكٌ':Added, #22: 22	قِيَامِ الْمِلْكِ
u'قيام مِلْكٌ':Added, #22: 22	قِيَامِ الْمِلْكِ
u'قِيَامٌ مِلْكٌ':Added, #2: 2	قِيَامَ مِلْكِهِ
u'قيام مِلْكٌ':Added, #2: 2	قِيَامَ مِلْكِهِ
u'قِيَامٌ مِلْكٌ':Added, #3: 3	قِيَامُ مِلْكِ
u'قيام مِلْكٌ':Added, #3: 3	قِيَامُ مِلْكِ
u'قِيَامٌ مِلْكٌ':Added, #4: 4	قِيَامَ الْمِلْكِ
u'قيام مِلْكٌ':Added, #4: 4	قِيَامَ الْمِلْكِ
u'قِيَامٌ مِلْكٌ':Added, #4: 4	قِيَامِ مِلْكِهِ
u'قيام مِلْكٌ':Added, #4: 4	قِيَامِ مِلْكِهِ
u'قِيَامٌ مِلْكٌ':Added, #8: 8	قِيَامِ مِلْكِ
u'قيام ملكة':Added, #8: 8	قِيَامِ مِلْكِ
u'قِيَامٌ ملكة':Added, #1: 1	قِيَامِ مَلَكَةِ
u'قيام مَلَكَةٌ':Added, #1: 1	قِيَامِ مَلَكَةِ
u'قِيَامٌ مَلَكَةٌ':Added, #1: 1	قِيَامِ مَلَكَةِ
u'قيام مَنْعٌ':Added, #1: 1	قِيَامِ مَلَكَةِ
u'قِيَامٌ مَنْعٌ':Added, #1: 1	قِيَامِ الْمَنْعِ
u'قيام مَوَانِعُ':Added, #1: 1	قِيَامِ الْمَنْعِ
u'قِيَامٌ مَوَانِعُ':Added, #1: 1	قِيَامِ مَوَانِعِ
u'قيام نَاسٌ':Added, #1: 1	قِيَامِ مَوَانِعِ
u'قيام نَاسٌ':Added, #1: 1	قِيَام النَّاسِ
u'قِيَامٌ نَاسٌ':Added, #1: 1	قِيَامِ النَّاسِ
u'قِيَامٌ نَاسٌ':Added, #1: 1	قِيَام النَّاسِ
u'قيام نَاسٌ':Added, #1: 1	قِيَامِ النَّاسِ
u'قيام نَاسٌ':Added, #2: 2	قِيَامَ النَّاسِ
u'قِيَامٌ نَاسٌ':Added, #2: 2	قِيَامُ النَّاسِ
u'قِيَامٌ نَاسٌ':Added, #2: 2	قِيَامَ النَّاسِ
u'قيام نَبِيٌّ':Added, #2: 2	قِيَامُ النَّاسِ
u'قِيَامٌ نَبِيٌّ':Added, #2: 2	قِيَامِ النَّبِيِّ
u'قيام نَجَاسَةٌ':Added, #2: 2	قِيَامِ النَّبِيِّ
u'قِيَامٌ نَجَاسَةٌ':Added, #1: 1	قِيَامِ النَّجَاسَةِ
u'قيام نِساءٌ':Added, #1: 1	قِيَامِ النَّجَاسَةِ
u'قِيَامٌ نِساءٌ':Added, #1: 1	قِيَامِ النِّسَاءِ
u'قيام نَصٌّ':Added, #1: 1	قِيَامِ النِّسَاءِ
u'قيام نَصٌّ':Added, #1: 1	قِيَامَ النَّصِّ
u'قِيَامٌ نَصٌّ':Added, #1: 1	قِيَامُ النَّصِّ
u'قِيَامٌ نَصٌّ':Added, #1: 1	قِيَامَ النَّصِّ
u'قيام نَصٌّ':Added, #1: 1	قِيَامُ النَّصِّ
u'قِيَامٌ نَصٌّ':Added, #2: 2	قِيَامِ النَّصِّ
u'قيام نظام':Added, #2: 2	قِيَامِ النَّصِّ
u'قِيَامٌ نظام':Added, #1: 1	قِيَامُ نِظَامِ
u'قيام نِظَامٌ':Added, #1: 1	قِيَامُ نِظَامِ
u'قِيَامٌ نِظَامٌ':Added, #1: 1	قِيَامُ نِظَامِ
u'قيام نَفْسٌ':Added, #1: 1	قِيَامُ نِظَامِ
u'قِيَامٌ نَفْسٌ':Added, #1: 1	قِيَامَ نَفْسِهِ
u'قيام نكاح':Added, #1: 1	قِيَامَ نَفْسِهِ
u'قِيَامٌ نكاح':Added, #1: 1	قِيَامُ النِّكَاحِ
u'قيام نِكَاحٌ':Added, #1: 1	قِيَامُ النِّكَاحِ
u'قِيَامٌ نِكَاحٌ':Added, #1: 1	قِيَامُ النِّكَاحِ
u'قيام نكاح':Added, #1: 1	قِيَامُ النِّكَاحِ
u'قيام نكاح':Added, #1: 1	قِيَامُ نِكَاحِ
u'قِيَامٌ نكاح':Added, #1: 1	قِيَامِ نِكَاحِ
u'قِيَامٌ نكاح':Added, #1: 1	قِيَامُ نِكَاحِ
u'قيام نِكَاحٌ':Added, #1: 1	قِيَامِ نِكَاحِ
u'قيام نِكَاحٌ':Added, #1: 1	قِيَامُ نِكَاحِ
u'قِيَامٌ نِكَاحٌ':Added, #1: 1	قِيَامِ نِكَاحِ
u'قِيَامٌ نِكَاحٌ':Added, #1: 1	قِيَامُ نِكَاحِ
u'قيام نكاح':Added, #1: 1	قِيَامِ نِكَاحِ
u'قِيَامٌ نكاح':Added, #65: 65	قِيَامِ النِّكَاحِ
u'قيام نِكَاحٌ':Added, #65: 65	قِيَامِ النِّكَاحِ
u'قِيَامٌ نِكَاحٌ':Added, #65: 65	قِيَامِ النِّكَاحِ
u'قيام نكاح':Added, #65: 65	قِيَامِ النِّكَاحِ
u'قِيَامٌ نكاح':Added, #7: 7	قِيَامَ النِّكَاحِ
u'قيام نِكَاحٌ':Added, #7: 7	قِيَامَ النِّكَاحِ
u'قِيَامٌ نِكَاحٌ':Added, #7: 7	قِيَامَ النِّكَاحِ
u'قيام نَوْعٌ':Added, #7: 7	قِيَامَ النِّكَاحِ
u'قِيَامٌ نَوْعٌ':Added, #1: 1	قِيَامِ نَوْعِ
u'قيام وَاجِبٌ':Added, #1: 1	قِيَامِ نَوْعِ
u'قِيَامٌ وَاجِبٌ':Added, #1: 1	قِيَامِ وَاجِبٍ
u'قِيَامٌ واحد':Added, #1: 1	قِيَامِ وَاجِبٍ
u'قِيَامٌ وَاحِدٌ':Added, #2: 2	قِيَامٍ وَاحِدٍ
u'قيام وَارِثٌ':Added, #2: 2	قِيَامٍ وَاحِدٍ
u'قِيَامٌ وَارِثٌ':Added, #2: 2	قِيَامِ وَارِثٍ
u'قيام وُجُوبٌ':Added, #2: 2	قِيَامِ وَارِثٍ
u'قِيَامٌ وُجُوبٌ':Added, #1: 1	قِيَامِ الْوُجُوبِ
u'قيام وُجُوبٌ':Added, #1: 1	قِيَامِ الْوُجُوبِ
u'قِيَامٌ وُجُوبٌ':Added, #1: 1	قِيَامِ وُجُوبِهِ
u'قيام وَصْفٌ':Added, #1: 1	قِيَامِ وُجُوبِهِ
u'قيام وَصْفٌ':Added, #1: 1	قِيَامُ الْوَصْفِ
u'قِيَامٌ وَصْفٌ':Added, #1: 1	قِيَامِ الْوَصْفِ
u'قِيَامٌ وَصْفٌ':Added, #1: 1	قِيَامُ الْوَصْفِ
u'قيام وَصْفٌ':Added, #1: 1	قِيَامِ الْوَصْفِ
u'قِيَامٌ وَصْفٌ':Added, #1: 1	قِيَامِ وَصْفِ
u'قيام وَصْفٌ':Added, #1: 1	قِيَامِ وَصْفِ
u'قِيَامٌ وَصْفٌ':Added, #1: 1	قِيَامَ وَصْفَيْنِ
u'قيام وَصْفٌ':Added, #1: 1	قِيَامَ وَصْفَيْنِ
u'قِيَامٌ وَصْفٌ':Added, #2: 2	قِيَامَ الْوَصْفِ
u'قيام وصلة':Added, #2: 2	قِيَامَ الْوَصْفِ
u'قِيَامٌ وصلة':Added, #1: 1	قِيَامِ الْوَصْلَةِ
u'قيام وَصِيٌّ':Added, #1: 1	قِيَامِ الْوَصْلَةِ
u'قِيَامٌ وَصِيٌّ':Added, #1: 1	قِيَامِ الْوَصِيَّةِ
u'قيام وَصِيَّةٌ':Added, #1: 1	قِيَامِ الْوَصِيَّةِ
u'قِيَامٌ وَصِيَّةٌ':Added, #1: 1	قِيَامِ الْوَصِيَّةِ
u'قيام وُضُوءٌ':Added, #1: 1	قِيَامِ الْوَصِيَّةِ
u'قيام وُضُوءٌ':Added, #1: 1	قِيَامَ الْوُضُوءِ
u'قيام وُضُوءٌ':Added, #1: 1	قِيَامُ الْوُضُوءِ
u'قِيَامٌ وُضُوءٌ':Added, #1: 1	قِيَامِ الْوُضُوءِ
u'قِيَامٌ وُضُوءٌ':Added, #1: 1	قِيَامَ الْوُضُوءِ
u'قِيَامٌ وُضُوءٌ':Added, #1: 1	قِيَامُ الْوُضُوءِ
u'قيام وَطْءٌ':Added, #1: 1	قِيَامِ الْوُضُوءِ
u'قِيَامٌ وَطْءٌ':Added, #1: 1	قِيَامِ الْوَطْءِ
u'قيام وَقْتٌ':Added, #1: 1	قِيَامِ الْوَطْءِ
u'قِيَامٌ وَقْتٌ':Added, #1: 1	قِيَامَ الْوَقْتِ
u'قيام وَقْتٌ':Added, #1: 1	قِيَامَ الْوَقْتِ
u'قِيَامٌ وَقْتٌ':Added, #3: 3	قِيَامِ الْوَقْتِ
u'قيام وَكِيلٌ':Added, #3: 3	قِيَامِ الْوَقْتِ
u'قِيَامٌ وَكِيلٌ':Added, #1: 1	قِيَامُ الْوَكِيلِ
u'قيام وِلاَيَةٌ':Added, #1: 1	قِيَامُ الْوَكِيلِ
u'قِيَامٌ وِلاَيَةٌ':Added, #1: 1	قِيَامَ وِلَايَتِهِ
u'قيام وِلاَيَةٌ':Added, #1: 1	قِيَامَ وِلَايَتِهِ
u'قِيَامٌ وِلاَيَةٌ':Added, #2: 2	قِيَامَ وِلَايَةِ
u'قيام وِلاَيَةٌ':Added, #2: 2	قِيَامَ وِلَايَةِ
u'قِيَامٌ وِلاَيَةٌ':Added, #3: 3	قِيَامِ وِلَايَةِ
u'قيام وِلاَيَةٌ':Added, #3: 3	قِيَامِ وِلَايَةِ
u'قِيَامٌ وِلاَيَةٌ':Added, #3: 3	قِيَامِ وِلَايَتِهِ
u'قيام ولد':Added, #3: 3	قِيَامِ وِلَايَتِهِ
u'قِيَامٌ ولد':Added, #1: 1	قِيَامَ الْوَلَدِ
u'قيام وَلَدٌ':Added, #1: 1	قِيَامَ الْوَلَدِ
u'قِيَامٌ وَلَدٌ':Added, #1: 1	قِيَامَ الْوَلَدِ
u'قيام ولد':Added, #1: 1	قِيَامَ الْوَلَدِ
u'قِيَامٌ ولد':Added, #3: 3	قِيَامِ وَلَدِ
u'قيام وَلَدٌ':Added, #3: 3	قِيَامِ وَلَدِ
u'قِيَامٌ وَلَدٌ':Added, #3: 3	قِيَامِ وَلَدِ
u'قيام ولد':Added, #3: 3	قِيَامِ وَلَدِ
u'قِيَامٌ ولد':Added, #7: 7	قِيَامِ الْوَلَدِ
u'قيام وَلَدٌ':Added, #7: 7	قِيَامِ الْوَلَدِ
u'قِيَامٌ وَلَدٌ':Added, #7: 7	قِيَامِ الْوَلَدِ
u'قيام وَلِيٌّ':Added, #7: 7	قِيَامِ الْوَلَدِ
u'قيام وَلِيٌّ':Added, #1: 1	قِيَامَ الْوَلِيِّ
u'قِيَامٌ وَلِيٌّ':Added, #1: 1	قِيَامِ الْوَلِيِّ
u'قِيَامٌ وَلِيٌّ':Added, #1: 1	قِيَامَ الْوَلِيِّ
u'قيام يَدٌ':Added, #1: 1	قِيَامِ الْوَلِيِّ
u'قِيَامٌ يَدٌ':Added, #1: 1	قِيَامَ الْيَدِ
u'قيام يَدٌ':Added, #1: 1	قِيَامَ الْيَدِ
u'قِيَامٌ يَدٌ':Added, #1: 1	قِيَامِ الْيَدَيْنِ
u'قيام يَدٌ':Added, #1: 1	قِيَامِ الْيَدَيْنِ
u'قِيَامٌ يَدٌ':Added, #1: 1	قِيَامَ يَدِ
u'قيام يَدٌ':Added, #1: 1	قِيَامَ يَدِ
u'قِيَامٌ يَدٌ':Added, #1: 1	قِيَامَ يَدِهِ
u'قيام يَدٌ':Added, #1: 1	قِيَامَ يَدِهِ
u'قِيَامٌ يَدٌ':Added, #2: 2	قِيَامِ يَدِ
u'قيام يَدٌ':Added, #2: 2	قِيَامِ يَدِ
u'قِيَامٌ يَدٌ':Added, #3: 3	قِيَامِ يَدِهِ
u'قَيَّدَ اِبْنٌ':Subject, #3: 3	قِيَامِ يَدِهِ
u'قَيَّدَ إتْمَامٌ':Predicate, #7: 7	قَيَّدَ ابْنُ
u'قَيَّدَ إِحْرَامٌ':Predicate, #1: 1	قَيَّدَ إتْمَامَ
u'قَيَّدَ أَحْكَامٌ':Predicate, #1: 1	قَيَّدَ الْإِحْرَامَ
u'قَيَّدَ إِرْسَالٌ':Predicate, #1: 1	قَيَّدَ الْأَحْكَامَ
u'قَيَّدَ إِرْشَادٌ':Predicate, #1: 1	قَيَّدَ الْإِرْسَالَ
u'قَيَّدَ إِسْقاطٌ':Predicate, #1: 1	قَيَّدَ الْإِرْشَادَ
u'قَيَّدَ أَشْرِبَةٌ':Predicate, #1: 1	قَيَّدَ إسْقَاطَ
u'قَيَّدَ أَصْحَابٌ':Subject, #1: 1	قَيَّدَ الْأَشْرِبَةَ
u'قَيَّدَ إِعادَةٌ':Predicate, #2: 2	قَيَّدَ الْأَصْحَابُ
u'قَيَّدَ إمَامٌ':Subject, #1: 1	قَيَّدَ الْإِعَادَةَ
u'قَيَّدَ آمِرٌ':Subject, #2: 2	قَيَّدَ الْإِمَامُ
u'قَيَّدَ إِمْساكٌ':Predicate, #1: 1	قَيَّدَ الْآمِرُ
u'قَيَّدَ إِمْهالٌ':Predicate, #1: 1	قَيَّدَ الْإِمْسَاكَ
u'قَيَّدَ أهْلٌ':Subject, #1: 1	قَيَّدَ الْإِمْهَالَ
u'قَيَّدَ بَعْضٌ':Subject, #1: 1	قَيَّدَ أَهْلُ
u'قَيَّدَ بَيْعٌ':Predicate, #3: 3	قَيَّدَ بَعْضُ
u'قَيَّدَ تَحْرِيمٌ':Predicate, #1: 1	قَيَّدَ بَيْعَ
u'قَيَّدَ تَخْيِيرٌ':Predicate, #1: 1	قَيَّدَ تَحْرِيمَ
u'قَيَّدَ تَرْجِيحٌ':Predicate, #1: 1	قَيَّدَ التَّخْيِيرَ
u'قَيَّدَ تَصْدِيقٌ':Predicate, #1: 1	قَيَّدَ تَرْجِيحَ
u'قَيَّدَ تَفْوِيضٌ':Predicate, #1: 1	قَيَّدَ التَّصْدِيقَ
u'قَيَّدَ تَقَدُّمٌ':Predicate, #1: 1	قَيَّدَ التَّفْوِيضَ
u'قَيَّدَ تَوْلِيَةٌ':Predicate, #1: 1	قَيَّدَ التَّقَدُّمَ
u'قَيَّدَ ثَالِثٌ':Predicate, #1: 1	قَيَّدَ التَّوْلِيَةَ
u'قَيَّدَ ثَانِي':Predicate, #4: 4	قَيَّدَ الثَّالِثَةَ
u'قَيَّدَ ثَانِيَةٌ':Predicate, #2: 2	قَيَّدَ الثَّانِيَةَ
u'قَيَّدَ ثُبُوتٌ':Predicate, #2: 2	قَيَّدَ الثَّانِيَةَ
u'قَيَّدَ جَمِيع':Predicate, #1: 1	قَيَّدَ ثُبُوتَ
u'قَيَّدَ جَوَابٌ':Predicate, #1: 1	قَيَّدَ الْجَمِيعَ
u'قَيَّدَ جَوَازٌ':Predicate, #2: 2	قَيَّدَ الْجَوَابَ
u'قَيَّدَ جَوَازٌ':Predicate, #1: 1	قَيَّدَ الْجَوَازَ
u'قَيَّدَ حَجٌّ':Predicate, #2: 2	قَيَّدَ جَوَازَ
u'قَيَّدَ حُضورٌ':Predicate, #2: 2	قَيَّدَ الْحَجَّ
u'قَيَّدَ حُضُورٌ':Predicate, #1: 1	قَيَّدَ الْحُضُورَ
u'قَيَّدَ حَمْلٌ':Predicate, #1: 1	قَيَّدَ الْحُضُورَ
u'قَيَّدَ حَوَالَةٌ':Predicate, #1: 1	قَيَّدَ حَمْلَ
u'قَيَّدَ خامس':Predicate, #2: 2	قَيَّدَ الْحَوَالَةَ
u'قَيَّدَ خَامِسٌ':Predicate, #1: 1	قَيَّدَ خَامِسَةَ
u'قَيَّدَ خامس':Predicate, #1: 1	قَيَّدَ خَامِسَةَ
u'قَيَّدَ خَامِسٌ':Predicate, #9: 9	قَيَّدَ الْخَامِسَةَ
u'قَيَّدَ خُرُوجٌ':Predicate, #9: 9	قَيَّدَ الْخَامِسَةَ
u'قَيَّدَ خِلاَفٌ':Predicate, #1: 1	قَيَّدَ الْخُرُوجَ
u'قَيَّدَ دَلالَةٌ':Predicate, #3: 3	قَيَّدَ الْخِلَافَ
u'قَيَّدَ ذكر':Predicate, #1: 1	قَيَّدَ دَلَالَةَ
u'قَيَّدَ ذَكَرٌ':Predicate, #1: 1	قَيَّدَ الذَّكَرَ
u'قَيَّدَ رَجُلٌ':Subject, #1: 1	قَيَّدَ الذَّكَرَ
u'قَيَّدَ رَقَبَةٌ':Predicate, #1: 1	قَيَّدَ رَجُلٌ
u'قَيَّدَ ركعة':Predicate, #3: 3	قَيَّدَ الرَّقَبَةَ
u'قَيَّدَ رَكْعَةٌ':Predicate, #10: 10	قَيَّدَ الرَّكْعَةَ
u'قَيَّدَ رِوايَةٌ':Predicate, #10: 10	قَيَّدَ الرَّكْعَةَ
u'قَيَّدَ سَاقِطٌ':Subject, #1: 1	قَيَّدَ رِوَايَةَ
u'قَيَّدَ سُقُوطٌ':Predicate, #1: 1	قَيَّدَ سَاقِطَةٌ
u'قَيَّدَ سلام':Predicate, #1: 1	قَيَّدَ السُّقُوطَ
u'قَيَّدَ سَلاَمٌ':Predicate, #1: 1	قَيَّدَ السَّلَامَ
u'قَيَّدَ شَارِحٌ':Subject, #1: 1	قَيَّدَ السَّلَامَ
u'قَيَّدَ شَهَادَةٌ':Predicate, #1: 1	قَيَّدَ الشَّارِحُ
u'قَيَّدَ شَهْرٌ':Predicate, #1: 1	قَيَّدَ الشَّهَادَةَ
u'قَيَّدَ شَيْخٌ':Subject, #1: 1	قَيَّدَ الشَّهْرَ
u'قَيَّدَ صَدْرٌ':Subject, #1: 1	قَيَّدَ الشَّيْخُ
u'قَيَّدَ ضَرَرٌ':Predicate, #1: 1	قَيَّدَ صَدْرُ
u'قَيَّدَ طَبَرِيّ':Subject, #1: 1	قَيَّدَ الضَّرَرَ
u'قَيَّدَ طَلاَقٌ':Predicate, #1: 1	قَيَّدَ الطَّبَرِيُّ
u'قَيَّدَ ظهار':Predicate, #1: 1	قَيَّدَ الطَّلَاقَ
u'قَيَّدَ عَدَمٌ':Predicate, #1: 1	قَيَّدَ الظِّهَارَ
u'قَيَّدَ فَتْكٌ':Predicate, #2: 2	قَيَّدَ عَدَمَ
u'قَيَّدَ فَسْخٌ':Predicate, #1: 1	قَيَّدَ الْفَتْكَ
u'قَيَّدَ فلان':Subject, #1: 1	قَيَّدَ الْفَسْخَ
u'قَيَّدَ قُبْلَةٌ':Predicate, #1: 1	قَيَّدَ الطَّبَرِيُّ
u'قَيَّدَ قُرْبٌ':Predicate, #1: 1	قَيَّدَ الْقُبْلَةَ
u'قَيَّدَ قسمة':Predicate, #1: 1	قَيَّدَ الْقُرْبَ
u'قَيَّدَ قِسْمَةٌ':Predicate, #1: 1	قَيَّدَ الْقِسْمَةَ
u'قَيَّدَ قول':Predicate, #1: 1	قَيَّدَ الْقِسْمَةَ
u'قَيَّدَ قَوْلٌ':Predicate, #2: 2	قَيَّدَ قَوْلَ
u'قَيَّدَ كَرَاهَةٌ':Predicate, #2: 2	قَيَّدَ قَوْلَ
u'قَيَّدَ كَفَالَةٌ':Predicate, #1: 1	قَيَّدَ الْكَرَاهَةَ
u'قَيَّدَ كَوْنٌ':Predicate, #1: 1	قَيَّدَ الْكَفَالَةَ
u'قَيَّدَ كَوْنٌ':Subject, #1: 1	قَيَّدَ كَوْنَ
u'قَيَّدَ مثل':Predicate, #1: 1	قَيَّدَ كَوْنُهُ
u'قَيَّدَ مِثْلٌ':Predicate, #1: 1	قَيَّدَ الْمِثْلَ
u'قَيَّدَ مَحَلٌّ':Predicate, #1: 1	قَيَّدَ الْمِثْلَ
u'قَيَّدَ مُحَمَّدٌ':Subject, #1: 1	قَيَّدَ مَحَلَّ
u'قَيَّدَ مُخَالَفَةٌ':Predicate, #1: 1	قَيَّدَ مُحَمَّدٌ
u'قَيَّدَ مَذْهَبٌ':Predicate, #1: 1	قَيَّدَ الْمُخَالَفَةَ
u'قَيَّدَ مَسْأَلَةٌ':Predicate, #1: 1	قَيَّدَ الْمَذْهَبَ
u'قَيَّدَ مَسْبُوق':Subject, #9: 9	قَيَّدَ الْمَسْأَلَةَ
u'قَيَّدَ مُصَنِّفٌ':Subject, #3: 3	قَيَّدَ الْمَسْبُوقُ
u'قَيَّدَ مَعَانِي':Predicate, #12: 12	قَيَّدَ الْمُصَنِّفُ
u'قَيَّدَ مَنْعٌ':Predicate, #1: 1	قَيَّدَ الْمَعَانِيَ
u'قَيَّدَ مَنْفَعَةٌ':Predicate, #1: 1	قَيَّدَ الْمَنْعَ
u'قَيَّدَ مَنْقُولٌ':Predicate, #2: 2	قَيَّدَ الْمَنْفَعَةَ
u'قَيَّدَ مُؤَلِّفٌ':Subject, #1: 1	قَيَّدَ الْمَنْقُولَ
u'قَيَّدَ هِبَةٌ':Predicate, #1: 1	قَيَّدَ الْمُؤَلِّفُ
u'قَيَّدَ وَاقِفٌ':Subject, #1: 1	قَيَّدَ الْهِبَةَ
u'قَيَّدَ وَاهِبٌ':Predicate, #2: 2	قَيَّدَ الْوَاقِفُ
u'قَيَّدَ وُجُوبٌ':Predicate, #1: 1	قَيَّدَ الْوَاهِبَ
u'قَيَّدَ وَصِيٌّ':Predicate, #3: 3	قَيَّدَ الْوُجُوبَ
u'قَيَّدَ وَصِيَّةٌ':Predicate, #3: 3	قَيَّدَ الْوَصِيَّةَ
u'قَيَّدَ وَكِيلٌ':Predicate, #3: 3	قَيَّدَ الْوَصِيَّةَ
u'قَيَّدَ ولد':Predicate, #1: 1	قَيَّدَ الْوَكِيلَ
u'قَيَّدَ وَلَدٌ':Predicate, #1: 1	قَيَّدَ وَلَدَ
u'قَيَّمَ حاكِمٌ':Predicate, #1: 1	قَيَّدَ وَلَدَ
u'قَيْنٌ سُوءٌ':Added, #1: 1	قَيَّمَ الْحَاكِمَ
u'كَابَدَ نَارٌ':Predicate, #1: 1	قَيْنِ السّوءِ
u'كَابَرَ مَعْقُولٌ':Predicate, #1: 1	كَابَدَ النَّارَ
u'كَاتَبَ أَبٌ':Predicate, #1: 1	كَابَرَ الْمَعْقُولَ
u'كَاتَبَ أَبٌ':Subject, #2: 2	كَاتَبَ الْأَبَ
u'كَاتَبَ اِبْنٌ':Predicate, #1: 1	كَاتَبَ الْأَبُ
u'كَاتَبَ اِبْنٌ':Subject, #1: 1	كَاتَبَ ابْنَ
u'كَاتَبَ أحَدٌ':Subject, #1: 1	كَاتَبَ ابْنُ
u'كَاتَبَ أَرْبَعَةٌ':Predicate, #3: 3	كَاتَبَ أَحَدُ
u'كَاتَبَ أُمٌّ':Predicate, #1: 1	كَاتَبَ أَرْبَعَةَ
u'كَاتَبَ أُمٌّ':Predicate, #13: 13	كَاتَبَ أُمَّ
u'كَاتَبَ أمَةٌ':Predicate, #7: 7	كَاتَبَ الْأُمَّ
u'كَاتَبَ بَعْضٌ':Predicate, #4: 4	كَاتَبَ الْأَمَةَ
u'كَاتَبَ ثَلاثَةٌ':Subject, #4: 4	كَاتَبَ بَعْضَ
u'كَاتَبَ جَارِي':Predicate, #2: 2	كَاتَبَ ثَلَاثَةٌ
u'كَاتَبَ جَمَاعَةٌ':Subject, #4: 4	كَاتَبَ جَارِيَةً
u'كَاتَبَ حاضِرٌ':Predicate, #1: 1	كَاتَبَ جَمَاعَةٌ
u'كَاتَبَ حُرٌّ':Predicate, #3: 3	كَاتَبَ الْحَاضِرَ
u'كَاتَبَ حُرٌّ':Subject, #1: 1	كَاتَبَ حُرَّةً
u'كَاتَبَ ذِمِّيٌّ':Subject, #5: 5	كَاتَبَ الْحُرُّ
u'كَاتَبَ ذِمِّيٌّ':Subject, #2: 2	كَاتَبَ الذِّمِّيُّ
u'كَاتَبَ رَجُلٌ':Subject, #3: 3	كَاتَبَ ذِمِّيٌّ
u'كَاتَبَ رَجُلٌ':Subject, #19: 19	كَاتَبَ الرَّجُلُ
u'كَاتَبَ رَسُولٌ':Subject, #2: 2	كَاتَبَ رَجُلٌ
u'كَاتَبَ سُهَيْلٌ':Predicate, #2: 2	كَاتَبَ رَسُولُ
u'كَاتَبَ سَيِّدٌ':Subject, #1: 1	كَاتَبَ سُهَيْلَ
u'كَاتَبَ صَحِيحٌ':Subject, #2: 2	كَاتَبَ السَّيِّدُ
u'كَاتَبَ عَبْدٌ':Predicate, #1: 1	كَاتَبَ الصَّحِيحُ
u'كَاتَبَ عَبْدٌ':Predicate, #2: 2	كَاتَبَ الْعَبْدَ
u'كَاتَبَ عَبْدٌ':Subject, #4: 4	كَاتَبَ عَبْدَ
u'كَاتَبَ عَبْدٌ':Subject, #1: 1	كَاتَبَ عَبْدُ
u'كَاتَبَ عَبْدٌ':Subject, #1: 1	كَاتَبَ عَبْدُهُ
u'كَاتَبَ عَدُوٌّ':Predicate, #4: 4	كَاتَبَ الْعَبْدُ
u'كَاتَبَ فلان':Predicate, #1: 1	كَاتَبَ الْعَدُوَّ
u'كَاتَبَ فُلاَنٌ':Subject, #1: 1	كَاتَبَ مُعَاوِيَةَ
u'كَاتَبَ كَافِرٌ':Subject, #10: 10	كَاتَبَ فُلَانٌ
u'كَاتَبَ مُدَبَّرٌ':Predicate, #2: 2	كَاتَبَ كَافِرٌ
u'كَاتَبَ مُدَبَّرٌ':Subject, #4: 4	كَاتَبَ الْمُدَبَّرَ
u'كَاتَبَ مُرْتَدٌّ':Subject, #1: 1	كَاتَبَ الْمُدَبَّرُ
u'كَاتَبَ مَرِيضٌ':Subject, #1: 1	كَاتَبَ الْمُرْتَدُّ
u'كَاتَبَ مُسْلِمٌ':Subject, #3: 3	كَاتَبَ الْمَرِيضُ
u'كَاتَبَ مُسْلِمٌ':Subject, #11: 11	كَاتَبَ الْمُسْلِمُ
u'كَاتَبَ مُشْرِك':Predicate, #2: 2	كَاتَبَ مُسْلِمٌ
u'كَاتَبَ مُضَارِبٌ':Subject, #1: 1	كَاتَبَ الْمُشْرِكِينَ
u'كَاتَبَ مُعاوِيَة':Predicate, #1: 1	كَاتَبَ الْمُضَارِبُ
u'كَاتَبَ مُمَيِّزٌ':Subject, #1: 1	كَاتَبَ مُعَاوِيَةَ
u'كَاتَبَ نَصْرَانِيٌّ':Subject, #1: 1	كَاتَبَ الْمُمَيِّزُ
u'كَاتَبَ نِصْفٌ':Predicate, #6: 6	كَاتَبَ النَّصْرَانِيُّ
u'كَاتَبَ نِصْفٌ':Predicate, #15: 15	كَاتَبَ نِصْفَ
u'كَاتَبَ واحد':Subject, #2: 2	كَاتَبَ النِّصْفَ
u'كَاتَبَ وَاحِدٌ':Subject, #1: 1	كَاتَبَ وَاحِدٌ
u'كَاتَبَ وَارِثٌ':Subject, #1: 1	كَاتَبَ وَاحِدٌ
u'كَاتَبَ وَتَرٌ':Predicate, #1: 1	كَاتَبَ الْوَارِثُ
u'كَاتَبَ وَرَثَةٌ':Subject, #1: 1	كَاتَبَ وَتَرَكَ
u'كَاتَبَ وَصِيٌّ':Subject, #1: 1	كَاتَبَ وَرَثَتُهُ
u'كَاتَبَ وَكِيلٌ':Predicate, #1: 1	كَاتَبَ الْوَصِيُّ
u'كَاتَبَ ولد':Predicate, #1: 1	كَاتَبَ الْوَكِيلَ
u'كَاتَبَ وَلَدٌ':Predicate, #2: 2	كَاتَبَ الْوَلَدَ
u'كَاتَبَ ولد':Subject, #2: 2	كَاتَبَ الْوَلَدَ
u'كَاتَبَ وَلَدٌ':Subject, #1: 1	كَاتَبَ الْوَلَدُ
u'كَادَ أَعْدَاءٌ':Subject, #1: 1	كَاتَبَ الْوَلَدُ
u'كَادَ أهْلٌ':Subject, #1: 1	كَادَ أَعْدَاءُ
u'كَادَ حسد':Subject, #1: 1	كَادَ أَهْلُ
u'كَادَ حَسَدٌ':Subject, #1: 1	كَادَ الْحَسَدُ
u'كَادَ حَلِيم':Subject, #1: 1	كَادَ الْحَسَدُ
u'كَادَ رَجُلٌ':Subject, #1: 1	كَادَ الْحَلِيمُ
u'كَادَ ظِلٌّ':Subject, #3: 3	كَادَ الرَّجُلُ
u'كَادَ فقر':Subject, #1: 1	كَادَ الظِّلُّ
u'كَادَ فَقْرٌ':Subject, #3: 3	كَادَ الْفَقْرُ
u'كَادَ نَاسٌ':Subject, #3: 3	كَادَ الْفَقْرُ
u'كَارَ عِمَامَةٌ':Predicate, #2: 2	كَادَ النَّاسُ
u'كَافَأَ عَمَلٌ':Subject, #1: 1	كَارَ الْعِمَامَةَ
u'كَالَ بَائِعٌ':Subject, #1: 1	كَافَأَ عَمَلُهُ
u'كَالَ زَنْدٌ':Predicate, #1: 1	كَالَ الْبَائِعُ
u'كَالَ زِيادَةٌ':Predicate, #2: 2	كَالَ الزّنْدَ
u'كَالَ مُسْتَأْجِرٌ':Subject, #1: 1	كَالَ الزِّيَادَةَ
u'كَانَ آب':Predicate, #2: 2	كَالَ الْمُسْتَأْجِرُ
u'كَانَ أَبٌ':Subject, #1: 1	كَانَ آبَ
u'كَانَ أَبٌ':Subject, #1: 1	كَانَ أَبٌ
u'كَانَ آباءٌ':Subject, #214: 214	كَانَ الْأَبُ
u'كَانَ اِبْتِداءٌ':Predicate, #1: 1	كَانَ آبَاءُ
u'كَانَ اِبْتِداءٌ':Subject, #4: 4	كَانَ ابْتِدَاءَ
u'كَانَ اِبْتِلاَعٌ':Subject, #24: 24	كَانَ ابْتِدَاءُ
u'كَانَ اِبْتِيَاعٌ':Subject, #1: 1	كَانَ ابْتِلَاعُ
u'كَانَ إِبْرَازٌ':Subject, #1: 1	كَانَ ابْتِيَاعُهُ
u'كَانَ إِبْرِيقٌ':Subject, #1: 1	كَانَ إبْرَازُ
u'كَانَ إِبْطَالٌ':Subject, #1: 1	كَانَ إبْرِيقُ
u'كَانَ إِبْطَالٌ':Subject, #1: 1	كَانَ إبْطَالُ
u'كَانَ أَبْعَدُ':Predicate, #1: 1	كَانَ الْإِبْطَالُ
u'كَانَ أَبْعَدُ':Subject, #23: 23	كَانَ أَبْعَدَ
u'كَانَ إِبِلٌ':Subject, #3: 3	كَانَ الْأَبْعَدُ
u'كَانَ إبْلِيسُ':Subject, #1: 1	كَانَ الْإِبِلُ
u'كَانَ اِبْنٌ':Predicate, #1: 1	كَانَ إبْلِيسُ
u'كَانَ اِبْنٌ':Subject, #52: 52	كَانَ ابْنَ
u'كَانَ اِبْنٌ':Subject, #255: 255	كَانَ ابْنُ
u'كَانَ اِبْنٌ':Subject, #7: 7	كَانَ ابْنٌ
u'كَانَ إِبْهَامٌ':Subject, #7: 7	كَانَ ابْنُهُ
u'كَانَ أَبْيَض':Predicate, #1: 1	كَانَ الْإِبْهَامُ
u'كَانَ أَبْيَض':Subject, #16: 16	كَانَ أَبْيَضَ
u'كَانَ أَبْيَض':Subject, #1: 1	كَانَ أَبْيَضُ
u'كَانَ اِتِّبَاعٌ':Subject, #1: 1	كَانَ الْأَبْيَضُ
u'كَانَ اِتِّبَاعٌ':Subject, #1: 1	كَانَ اتِّبَاعُ
u'كَانَ اِتِّصَالٌ':Predicate, #1: 1	كَانَ اتِّبَاعُهُ
u'كَانَ اِتِّصَالٌ':Subject, #1: 1	كَانَ اتِّصَالَ
u'كَانَ اِتِّصَالٌ':Subject, #1: 1	كَانَ اتِّصَالُ
u'كَانَ اِتِّفَاقٌ':Subject, #2: 2	كَانَ اتِّصَالُهُ
u'كَانَ إِتْلاَفٌ':Subject, #1: 1	كَانَ اتِّفَاقُ
u'كَانَ إِتْلاَفٌ':Subject, #1: 1	كَانَ إتْلَافُ
u'كَانَ إِتْلاَفٌ':Subject, #1: 1	كَانَ إتْلَافُهُ
u'كَانَ إتْمَامٌ':Subject, #3: 3	كَانَ الْإِتْلَافُ
u'كَانَ إتْمَامٌ':Subject, #1: 1	كَانَ إتْمَامُ
u'كَانَ أَتُونٌ':Subject, #3: 3	كَانَ الْإِتْمَامُ
u'كَانَ إِتْيانٌ':Subject, #1: 1	كَانَ الْأَتُونُ
u'كَانَ إِتْيانٌ':Subject, #1: 1	كَانَ إتْيَانُ
u'كَانَ إِتْيانٌ':Subject, #1: 1	كَانَ إِتْيَانُ
u'كَانَ إِثْبَاتٌ':Subject, #1: 1	كَانَ إتْيَانُهُ
u'كَانَ إِثْبَاتٌ':Subject, #2: 2	كَانَ إثْبَاتُهُ
u'كَانَ إِثْبَاتٌ':Subject, #3: 3	كَانَ إثْبَاتُ
u'كَانَ إِثْخَانٌ':Subject, #3: 3	كَانَ الْإِثْبَاتُ
u'كَانَ أثَرٌ':Subject, #1: 1	كَانَ الْإِثْخَانُ
u'كَانَ أثَرٌ':Subject, #1: 1	كَانَ الْأَثَرُ
u'كَانَ أثَرٌ':Subject, #2: 2	كَانَ أَثَرُهُ
u'كَانَ أثقل':Predicate, #5: 5	كَانَ أَثَرُ
u'كَانَ إِثْمٌ':Subject, #5: 5	كَانَ أَثْقَلَ
u'كَانَ إِثْمٌ':Subject, #1: 1	كَانَ إثْمٌ
u'كَانَ إِثْمٌ':Subject, #1: 1	كَانَ إثْمُهُ
u'كَانَ إِثْمٌ':Subject, #1: 1	كَانَ إِثْمُهُ
u'كَانَ إِثْمٌ':Subject, #2: 2	كَانَ إثْمُ
u'كَانَ إجَارَةٌ':Subject, #7: 7	كَانَ الْإِثْمُ
u'كَانَ إِجْبَارٌ':Subject, #1: 1	كَانَ الْإِجَارَةُ
u'كَانَ اِجْتِمَاعٌ':Subject, #1: 1	كَانَ الْإِجْبَارُ
u'كَانَ اِجْتِهَادٌ':Subject, #2: 2	كَانَ اجْتِمَاعُ
u'كَانَ اِجْتِهَادٌ':Subject, #1: 1	كَانَ اجْتِهَادُ
u'كَانَ أَجْرٌ':Predicate, #1: 1	كَانَ اجْتِهَادُهُ
u'كَانَ أَجْرٌ':Subject, #2: 2	كَانَ أَجْرَ
u'كَانَ أَجْرٌ':Subject, #14: 14	كَانَ أَجْرُ
u'كَانَ أَجْرٌ':Subject, #1: 1	كَانَ أَجْرَاهُ
u'كَانَ آجُرٌّ':Subject, #1: 1	كَانَ أَجْرُهُ
u'كَانَ أَجْرٌ':Subject, #1: 1	كَانَ الْآجُرُّ
u'كَانَ أَجْرَب':Predicate, #42: 42	كَانَ الْأَجْرُ
u'كَانَ أُجْرَةٌ':Predicate, #1: 1	كَانَ أَجْرَبَ
u'كَانَ أُجْرَةٌ':Subject, #1: 1	كَانَ أُجْرَةَ
u'كَانَ إِجْزَاءٌ':Subject, #2: 2	كَانَ أُجْرَةُ
u'كَانَ أَجَلٌ':Subject, #1: 1	كَانَ الْإِجْزَاءُ
u'كَانَ أَجَلٌ':Subject, #1: 1	كَانَ أَجَلُهُ
u'كَانَ أَجَلٌ':Subject, #1: 1	كَانَ الأَجَلُ
u'كَانَ أَجَلٌ':Subject, #24: 24	كَانَ الْأَجَلُ
u'كَانَ إِجْمَاعٌ':Subject, #4: 4	كَانَ أَجَلُ
u'كَانَ إِجْمَاعٌ':Subject, #11: 11	كَانَ الْإِجْمَاعُ
u'كَانَ إِجْمَاعٌ':Subject, #1: 1	كَانَ إجْمَاعٌ
u'كَانَ أَجَمَةٌ':Subject, #2: 2	كَانَ إجْمَاعُ
u'كَانَ أجْمَع':Predicate, #1: 1	كَانَ أَجَمَةٌ
u'كَانَ أَجْنَبِيٌّ':Subject, #2: 2	كَانَ أَجْمَعَ
u'كَانَ أَجْنَبِيٌّ':Subject, #4: 4	كَانَ أَجْنَبِيٌّ
u'كَانَ أَجْوَدُ':Predicate, #8: 8	كَانَ الْأَجْنَبِيُّ
u'كَانَ أَجْوَدُ':Subject, #12: 12	كَانَ أَجْوَدَ
u'كَانَ أَجِيرٌ':Predicate, #1: 1	كَانَ الْأَجْوَدُ
u'كَانَ أَجِيرٌ':Subject, #3: 3	كَانَ أَجِيرَ
u'كَانَ أَجِيرٌ':Subject, #1: 1	كَانَ أَجِيرُ
u'كَانَ آحَادٌ':Subject, #20: 20	كَانَ الْأَجِيرُ
u'كَانَ إِحْبَالٌ':Subject, #1: 1	كَانَ آحَادُ
u'كَانَ اِحْتَفَر':Predicate, #1: 1	كَانَ الْإِحْبَالُ
u'كَانَ اِحْتِمَالٌ':Subject, #1: 1	كَانَ احْتَفَرَ
u'كَانَ اِحْتِيَاجٌ':Subject, #2: 2	كَانَ احْتِمَالُ
u'كَانَ أحَدٌ':Predicate, #1: 1	كَانَ احْتِيَاجُهُ
u'كَانَ أحَدٌ':Subject, #6: 6	كَانَ أَحَدَ
u'كَانَ أحَدٌ':Subject, #144: 144	كَانَ أَحَدُ
u'كَانَ إِحْدَاثٌ':Predicate, #14: 14	كَانَ أَحَدٌ
u'كَانَ إِحْدَاثٌ':Subject, #1: 1	كَانَ إحْدَاثَ
u'كَانَ إِحْدَاثٌ':Subject, #1: 1	كَانَ إحْدَاثُ
u'كَانَ أَحْدَب':Predicate, #1: 1	كَانَ الْإِحْدَاثُ
u'كَانَ إِحْرَامٌ':Predicate, #1: 1	كَانَ أَحْدَبَ
u'كَانَ إِحْرَامٌ':Subject, #2: 2	كَانَ إحْرَامَ
u'كَانَ إِحْرَامٌ':Subject, #10: 10	كَانَ إحْرَامُهُ
u'كَانَ إِحْرَامٌ':Subject, #3: 3	كَانَ الْإِحْرَامُ
u'كَانَ أَحْسَنُ':Predicate, #5: 5	كَانَ إحْرَامُ
u'كَانَ أَحْسَنُ':Subject, #30: 30	كَانَ أَحْسَنَ
u'كَانَ أَحْسَنُ':Subject, #2: 2	كَانَ أَحْسَنُ
u'كَانَ أَحْسَنُ':Subject, #2: 2	كَانَ أَحْسَنُهُ
u'كَانَ إحْضَارٌ':Subject, #7: 7	كَانَ الْأَحْسَنُ
u'كَانَ أَحَقُّ':Predicate, #1: 1	كَانَ إحْضَارُهُ
u'كَانَ أَحَقُّ':Subject, #61: 61	كَانَ أَحَقَّ
u'كَانَ أحكم':Predicate, #1: 1	كَانَ أَحَقُّ
u'كَانَ إِحْلاَفٌ':Subject, #1: 1	كَانَ أَحْكَمَ
u'كَانَ أحْمَر':Predicate, #1: 1	كَانَ إحْلَافُ
u'كَانَ أحْمَق':Predicate, #4: 4	كَانَ أَحْمَرَ
u'كَانَ أَحْنَف':Subject, #1: 1	كَانَ أَحْمَقَ
u'كَانَ أحْوَل':Subject, #1: 1	كَانَ الْأَحْنَفُ
u'كَانَ إِحْيَاءٌ':Subject, #1: 1	كَانَ الْأَحْوَلُ
u'كَانَ أَخٌ':Predicate, #3: 3	كَانَ الْإِحْيَاءُ
u'كَانَ أَخٌ':Subject, #1: 1	كَانَ أَخَ
u'كَانَ أَخٌ':Subject, #11: 11	كَانَ الْأَخُ
u'كَانَ أخْبَارٌ':Subject, #3: 3	كَانَ أَخٌ
u'كَانَ أَخْبَارٌ':Subject, #1: 1	كَانَ أَخْبَارُ
u'كَانَ إِخْبَارٌ':Subject, #1: 1	كَانَ أَخْبَارُ
u'كَانَ إِخْبَارٌ':Subject, #1: 1	كَانَ إخْبَارُ
u'كَانَ أخْبَارٌ':Subject, #1: 1	كَانَ إخْبَارُهُ
u'كَانَ أَخْبَارٌ':Subject, #1: 1	كَانَ الْأَخْبَارُ
u'كَانَ أَخْبَثٌ':Predicate, #1: 1	كَانَ الْأَخْبَارُ
u'كَانَ اِخْتِصَاصٌ':Subject, #1: 1	كَانَ أَخْبَثَ
u'كَانَ اِخْتِلاطٌ':Subject, #1: 1	كَانَ اخْتِصَاصُ
u'كَانَ اِخْتِلاَفٌ':Subject, #1: 1	كَانَ اخْتِلَاطُهُ
u'كَانَ اِخْتِلاَفٌ':Subject, #1: 1	كَانَ الاِخْتِلاَفُ
u'كَانَ اِخْتِيَارٌ':Subject, #5: 5	كَانَ اخْتِلَافُ
u'كَانَ اِخْتِيَارٌ':Subject, #1: 1	كَانَ الاِخْتِيَارُ
u'كَانَ اِخْتِيَارٌ':Subject, #2: 2	كَانَ اخْتِيَارُ
u'كَانَ أخْذٌ':Subject, #2: 2	كَانَ اخْتِيَارُهُ
u'كَانَ أخْذٌ':Subject, #15: 15	كَانَ الْأَخْذُ
u'كَانَ آخِرُ':Predicate, #5: 5	كَانَ أَخْذُ
u'كَانَ آخِرُ':Subject, #20: 20	كَانَ آخِرَ
u'كَانَ آخِرُ':Subject, #1: 1	كَانَ الْآخِرُ
u'كَانَ إِخْرَاجٌ':Subject, #34: 34	كَانَ آخِرُ
u'كَانَ إِخْرَاجٌ':Subject, #2: 2	كَانَ إخْرَاجُ
u'كَانَ إِخْرَاجٌ':Subject, #5: 5	كَانَ إخْرَاجُهُ
u'كَانَ أخرَس':Predicate, #7: 7	كَانَ الْإِخْرَاجُ
u'كَانَ أخرَس':Subject, #10: 10	كَانَ أَخْرَسَ
u'كَانَ أخرَس':Subject, #1: 1	كَانَ أَخْرَسُ
u'كَانَ أَخَصُّ':Predicate, #6: 6	كَانَ الْأَخْرَسُ
u'كَانَ أَخَصُّ':Subject, #7: 7	كَانَ أَخَصَّ
u'كَانَ أَخْضَر':Predicate, #1: 1	كَانَ الْأَخَصُّ
u'كَانَ أخفُّ':Predicate, #1: 1	كَانَ أَخْضَرَ
u'كَانَ إِخْلاَفٌ':Subject, #9: 9	كَانَ أَخَفَّ
u'كَانَ إِخْلالٌ':Subject, #1: 1	كَانَ الْإِخْلَافُ
u'كَانَ إِخْوَةٌ':Subject, #1: 1	كَانَ الْإِخْلَالُ
u'كَانَ أَخِيرٌ':Predicate, #2: 2	كَانَ الْإِخْوَةُ
u'كَانَ أَدَاءٌ':Subject, #1: 1	كَانَ الْأَخِيرَ
u'كَانَ أَدَاءٌ':Subject, #6: 6	كَانَ الْأَدَاءُ
u'كَانَ إِدَامٌ':Predicate, #7: 7	كَانَ أَدَاءُ
u'كَانَ اِدِّخارٌ':Subject, #1: 1	كَانَ إدَامَ
u'كَانَ إِدْرَاكٌ':Subject, #1: 1	كَانَ ادِّخَارُ
u'كَانَ إِدْرَاكٌ':Subject, #1: 1	كَانَ إدْرَاكُ
u'كَانَ آدَمِيٌّ':Subject, #3: 3	كَانَ الْإِدْرَاكُ
u'كَانَ إِدْناءٌ':Subject, #1: 1	كَانَ الْآدَمِيُّ
u'كَانَ أَذَانٌ':Subject, #1: 1	كَانَ الْإِدْنَاءُ
u'كَانَ أَذَانٌ':Subject, #11: 11	كَانَ الْأَذَانُ
u'كَانَ آذَانٌ':Subject, #2: 2	كَانَ أَذَانُهُ
u'كَانَ أَذَانٌ':Subject, #2: 2	كَانَ الْآذَانُ
u'كَانَ أَذَانٌ':Subject, #5: 5	كَانَ أَذَانُ
u'كَانَ إِذْنٌ':Predicate, #6: 6	كَانَ الأَذَانُ
u'كَانَ إِذْنٌ':Subject, #1: 1	كَانَ الْإِذْنَ
u'كَانَ إِذْنٌ':Subject, #14: 14	كَانَ الْإِذْنُ
u'كَانَ إِذْنٌ':Subject, #1: 1	كَانَ إذْنٌ
u'كَانَ إِذْنٌ':Subject, #1: 1	كَانَ إذْنُ
u'كَانَ إِذْنٌ':Subject, #1: 1	كَانَ الإِذْنُ
u'كَانَ إِرَادَةٌ':Subject, #3: 3	كَانَ إذْنُهُ
u'كَانَ أرْبَابٌ':Subject, #1: 1	كَانَ إرَادَةُ
u'كَانَ أرْبَابٌ':Subject, #1: 1	كَانَ الْأَرْبَابُ
u'كَانَ أَرْبَعُ':Predicate, #7: 7	كَانَ أَرْبَابُ
u'كَانَ أَرْبَعَةٌ':Predicate, #6: 6	كَانَ أَرْبَعَ
u'كَانَ أَرْبَعَةٌ':Subject, #7: 7	كَانَ أَرْبَعَةَ
u'كَانَ اِرْتِحَالٌ':Subject, #1: 1	كَانَ الْأَرْبَعَةُ
u'كَانَ اِرْتِدَادٌ':Subject, #2: 2	كَانَ ارْتِحَالُهُ
u'كَانَ اِرْتِدَادٌ':Subject, #1: 1	كَانَ ارْتِدَادُ
u'كَانَ اِرْتِفَاعٌ':Subject, #1: 1	كَانَ ارْتِدَادُهُ
u'كَانَ اِرْتِكَابٌ':Subject, #1: 1	كَانَ ارْتِفَاعُهُ
u'كَانَ إِرْثٌ':Subject, #1: 1	كَانَ ارْتِكَابُهُ
u'كَانَ إِرْثٌ':Subject, #2: 2	كَانَ إرْثُ
u'كَانَ أَرْجَحُ':Predicate, #2: 2	كَانَ الْإِرْثُ
u'كَانَ أَرْدَأَ':Predicate, #2: 2	كَانَ أَرْجَحَ
u'كَانَ أَرُزٌّ':Subject, #2: 2	كَانَ أَرْدَأَ
u'كَانَ إِرْسَالٌ':Subject, #2: 2	كَانَ الْأَرُزُّ
u'كَانَ أرْضٌ':Predicate, #1: 1	كَانَ الْإِرْسَالُ
u'كَانَ أرْضٌ':Subject, #1: 1	كَانَ أَرْضَ
u'كَانَ أرْضٌ':Subject, #4: 4	كَانَ أَرْضٌ
u'كَانَ إِرْضاعٌ':Subject, #5: 5	كَانَ الْأَرْضُ
u'كَانَ إِرْضاعٌ':Subject, #1: 1	كَانَ إرْضَاعُ
u'كَانَ إِرْكَابٌ':Subject, #2: 2	كَانَ الْإِرْضَاعُ
u'كَانَ أَرْمَد':Predicate, #1: 1	كَانَ الْإِرْكَابُ
u'كَانَ إِزَارٌ':Predicate, #1: 1	كَانَ أَرْمَدَ
u'كَانَ إِزَارٌ':Subject, #1: 1	كَانَ الْإِزَارَ
u'كَانَ إِزَارٌ':Subject, #1: 1	كَانَ إزَارُهُ
u'كَانَ إِزَارٌ':Subject, #1: 1	كَانَ الإِزَارُ
u'كَانَ إِزَالَةٌ':Subject, #3: 3	كَانَ الْإِزَارُ
u'كَانَ أزُرٌ':Predicate, #3: 3	كَانَ إزَالَةُ
u'كَانَ أَزْهَر':Predicate, #1: 1	كَانَ الْأُزُرَ
u'كَانَ أَزْواجٌ':Subject, #2: 2	كَانَ أَزْهَرَ
u'كَانَ أَزْيَدُ':Predicate, #2: 2	كَانَ أَزْوَاجُ
u'كَانَ أُسٌّ':Subject, #9: 9	كَانَ أَزْيَدَ
u'كَانَ أُسٌّ':Subject, #1: 1	كَانَ الْأُسُّ
u'كَانَ أسَاسٌ':Subject, #2: 2	كَانَ أُسُّ
u'كَانَ أَسَاسٌ':Subject, #1: 1	كَانَ أَسَاسُ
u'كَانَ أسْبَابٌ':Subject, #1: 1	كَانَ أَسَاسُ
u'كَانَ أَسْبَابٌ':Subject, #1: 1	كَانَ أَسْبَابُهُ
u'كَانَ إِسْبَاغٌ':Subject, #1: 1	كَانَ أَسْبَابُهُ
u'كَانَ أَسْبَقُ':Predicate, #1: 1	كَانَ الْإِسْبَاغُ
u'كَانَ أَسْبَقُ':Subject, #5: 5	كَانَ أَسْبَقَ
u'كَانَ أُسْتَاذٌ':Subject, #1: 1	كَانَ الْأَسْبَقُ
u'كَانَ اِسْتِثْنَاءٌ':Predicate, #1: 1	كَانَ الْأُسْتَاذُ
u'كَانَ اِسْتِثْنَاءٌ':Subject, #2: 2	كَانَ اسْتِثْنَاءَ
u'كَانَ اِسْتِحْقَاقٌ':Subject, #2: 2	كَانَ اسْتِثْنَاءُ
u'كَانَ اِسْتِحْقَاقٌ':Subject, #4: 4	كَانَ اسْتِحْقَاقُهُ
u'كَانَ اِسْتِخْدامٌ':Subject, #5: 5	كَانَ اسْتِحْقَاقُ
u'كَانَ اِسْتِخْدامٌ':Subject, #1: 1	كَانَ اسْتِخْدَامُهُ
u'كَانَ اِسْتِخْرَاجٌ':Subject, #2: 2	كَانَ اسْتِخْدَامُ
u'كَانَ اِسْتِدَامَةٌ':Subject, #1: 1	كَانَ اسْتِخْرَاجُهُ
u'كَانَ اِسْتِدْرَاكٌ':Subject, #1: 1	كَانَ اسْتِدَامَةُ
u'كَانَ اِسْتِصْحابٌ':Subject, #1: 1	كَانَ اسْتِدْرَاكُهُ
u'كَانَ اِسْتِعْمالٌ':Subject, #1: 1	كَانَ اسْتِصْحَابُ
u'كَانَ اِسْتِعْمالٌ':Subject, #3: 3	كَانَ اسْتِعْمَالُ
u'كَانَ اِسْتِغْفارٌ':Subject, #5: 5	كَانَ اسْتِعْمَالُهُ
u'كَانَ اِسْتِغْلاَلٌ':Subject, #1: 1	كَانَ اسْتِغْفَارُ
u'كَانَ اِسْتِقْرارٌ':Subject, #1: 1	كَانَ اسْتِغْلَالُ
u'كَانَ اِسْتَقْرَض':Predicate, #2: 2	كَانَ اسْتِقْرَارُهُ
u'كَانَ اِسْتِمْساك':Subject, #1: 1	كَانَ اسْتَقْرَضَ
u'كَانَ اِسْتِناد':Subject, #1: 1	كَانَ اسْتِمْسَاكُ
u'كَانَ اِسْتِناد':Subject, #2: 2	كَانَ اسْتِنَادُ
u'كَانَ اِسْتِواءٌ':Subject, #2: 2	كَانَ اسْتِنَادُهُ
u'كَانَ اِسْتِئْنَافٌ':Subject, #1: 1	كَانَ اسْتِوَاءُ
u'كَانَ اِسْتيفاءٌ':Subject, #1: 1	كَانَ اسْتِئْنَافُ
u'كَانَ اِسْتيلاءٌ':Subject, #1: 1	كَانَ اسْتِيفَاءُ
u'كَانَ اِسْتيلاءٌ':Subject, #1: 1	كَانَ اسْتِيلَاءٌ
u'كَانَ إِسْراءٌ':Subject, #1: 1	كَانَ اسْتِيلَاءُ
u'كَانَ إِسْرافٌ':Subject, #5: 5	كَانَ الْإِسْرَاءُ
u'كَانَ أَسْرَعُ':Predicate, #1: 1	كَانَ الْإِسْرَافُ
u'كَانَ أَسْرَعُ':Subject, #5: 5	كَانَ أَسْرَعَ
u'كَانَ أَسْفَلُ':Predicate, #2: 2	كَانَ أَسْرَعُ
u'كَانَ أَسْفَلُ':Predicate, #1: 1	كَانَ الْأَسْفَلَ
u'كَانَ أَسْفَلُ':Subject, #7: 7	كَانَ أَسْفَلَ
u'كَانَ أَسْفَلُ':Subject, #1: 1	كَانَ أَسْفَلُ
u'كَانَ أَسْفَلُ':Subject, #1: 1	كَانَ أَسْفَلُهُ
u'كَانَ إِسْقاطٌ':Subject, #3: 3	كَانَ الْأَسْفَلُ
u'كَانَ إِسْلامٌ':Subject, #1: 1	كَانَ إسْقَاطُ
u'كَانَ إِسْلامٌ':Subject, #14: 14	كَانَ الْإِسْلَامُ
u'كَانَ إِسْلامٌ':Subject, #1: 1	كَانَ إِسْلامُ
u'كَانَ إِسْلامٌ':Subject, #1: 1	كَانَ إِسْلاَمُهُ
u'كَانَ إِسْلامٌ':Subject, #2: 2	كَانَ إِسْلامُهُ
u'كَانَ إِسْلامٌ':Subject, #4: 4	كَانَ إِسْلاَمُ
u'كَانَ إِسْلامٌ':Subject, #5: 5	كَانَ إسْلَامُ
u'كَانَ إِسْلامٌ':Subject, #6: 6	كَانَ الإِسْلاَمُ
u'كَانَ اِسْمٌ':Predicate, #7: 7	كَانَ إسْلَامُهُ
u'كَانَ اِسْمٌ':Subject, #7: 7	كَانَ اسْمَ
u'كَانَ اِسْمٌ':Subject, #19: 19	كَانَ اسْمُ
u'كَانَ إِسْنادٌ':Subject, #24: 24	كَانَ اسْمُهُ
u'كَانَ إِسْنادٌ':Subject, #1: 1	كَانَ الإِسْنَادُ
u'كَانَ إِسْنادٌ':Subject, #1: 1	كَانَ الْإِسْنَادُ
u'كَانَ إِسْنادٌ':Subject, #2: 2	كَانَ إسْنَادُهُ
u'كَانَ أُسْوَةٌ':Predicate, #3: 3	كَانَ إِسْنَادُهُ
u'كَانَ أُسْوَةٌ':Subject, #4: 4	كَانَ أُسْوَةَ
u'كَانَ أسْوَد':Predicate, #1: 1	كَانَ أُسْوَةُ
u'كَانَ أسْوَد':Subject, #8: 8	كَانَ أَسْوَدَ
u'كَانَ أَسيرٌ':Subject, #3: 3	كَانَ الْأَسْوَدُ
u'كَانَ إِشْباعٌ':Subject, #6: 6	كَانَ الْأَسِيرُ
u'كَانَ أشْبَهُ':Predicate, #1: 1	كَانَ الْإِشْبَاعُ
u'كَانَ اِشْتِدادٌ':Subject, #5: 5	كَانَ أَشْبَهَ
u'كَانَ اِشْتِراطٌ':Subject, #1: 1	كَانَ اشْتِدَادُهُ
u'كَانَ اِشْتِراطٌ':Subject, #2: 2	كَانَ اشْتِرَاطُهُ
u'كَانَ اِشْتِراكٌ':Subject, #5: 5	كَانَ اشْتِرَاطُ
u'كَانَ اِشْتِغالٌ':Subject, #1: 1	كَانَ اشْتِرَاكُهُ
u'كَانَ اِشْتِغالٌ':Subject, #1: 1	كَانَ اشْتِغَالُ
u'كَانَ أَشْجَعُ':Predicate, #1: 1	كَانَ الاِشْتِغَالُ
u'كَانَ أَشْجَعُ':Subject, #2: 2	كَانَ أَشْجَعَ
u'كَانَ أَشَدُّ':Predicate, #1: 1	كَانَ الْأَشْجَعُ
u'كَانَ إِشْراكٌ':Subject, #18: 18	كَانَ أَشَدَّ
u'كَانَ أشرف':Predicate, #2: 2	كَانَ الْإِشْرَاكُ
u'كَانَ أَشْرَفُ':Predicate, #1: 1	كَانَ أَشْرَفَ
u'كَانَ أَشْعَث':Predicate, #1: 1	كَانَ أَشْرَفَ
u'كَانَ إِشْفاقٌ':Subject, #1: 1	كَانَ أَشْعَثَ
u'كَانَ إِشْكالٌ':Subject, #1: 1	كَانَ الْإِشْفَاقُ
u'كَانَ أَشَلّ':Predicate, #2: 2	كَانَ الْإِشْكَالُ
u'كَانَ أشْهَرُ':Subject, #2: 2	كَانَ أَشَلَّ
u'كَانَ أَشْهُرٌ':Subject, #2: 2	كَانَ الْأَشْهَرُ
u'كَانَ أَصابِعُ':Subject, #2: 2	كَانَ الْأَشْهُرُ
u'كَانَ أُصْبُعٌ':Subject, #1: 1	كَانَ الْأَصَابِعُ
u'كَانَ أَصْحَابٌ':Subject, #1: 1	كَانَ أُصْبُعٌ
u'كَانَ أَصْحَابٌ':Subject, #4: 4	كَانَ أَصْحَابُهُ
u'كَانَ أَصْحَابٌ':Subject, #4: 4	كَانَ الْأَصْحَابُ
u'كَانَ إِصْرارٌ':Subject, #70: 70	كَانَ أَصْحَابُ
u'كَانَ إِصْرارٌ':Subject, #1: 1	كَانَ إصْرَارُهُ
u'كَانَ اِصْطاد':Predicate, #1: 1	كَانَ الْإِصْرَارُ
u'كَانَ اِصْطِلاحٌ':Subject, #1: 1	كَانَ اصْطَادَ
u'كَانَ اِصْطِناع':Subject, #1: 1	كَانَ اصْطِلَاحُ
u'كَانَ اِصْطِيادٌ':Subject, #1: 1	كَانَ اصْطِنَاعُ
u'كَانَ أصْغَرٌ':Predicate, #1: 1	كَانَ اصْطِيَادُ
u'كَانَ أَصْغَرُ':Predicate, #14: 14	كَانَ أَصْغَرَ
u'كَانَ أصْغَرٌ':Subject, #14: 14	كَانَ أَصْغَرَ
u'كَانَ أَصْغَرُ':Subject, #3: 3	كَانَ الْأَصْغَرُ
u'كَانَ أَصْفَر':Predicate, #3: 3	كَانَ الْأَصْغَرُ
u'كَانَ أصل':Predicate, #9: 9	كَانَ أَصْفَرَ
u'كَانَ أًصْلٌ':Predicate, #2: 2	كَانَ أَصْلَ
u'كَانَ أًصْلٌ':Subject, #2: 2	كَانَ أَصْلَ
u'كَانَ أصل':Subject, #2: 2	كَانَ أَصْلٌ
u'كَانَ أًصْلٌ':Subject, #47: 47	كَانَ أَصْلُهُ
u'كَانَ أصل':Subject, #47: 47	كَانَ أَصْلُهُ
u'كَانَ أًصْلٌ':Subject, #49: 49	كَانَ أَصْلُ
u'كَانَ أصل':Subject, #49: 49	كَانَ أَصْلُ
u'كَانَ أًصْلٌ':Subject, #87: 87	كَانَ الْأَصْلُ
u'كَانَ أَصْلَحُ':Predicate, #87: 87	كَانَ الْأَصْلُ
u'كَانَ أَصْلَحُ':Subject, #11: 11	كَانَ أَصْلَحَ
u'كَانَ أَصْلَع':Predicate, #8: 8	كَانَ الْأَصْلَحُ
u'كَانَ أَصْلِيٌّ':Subject, #2: 2	كَانَ أَصْلَعَ
u'كَانَ أَصَمّ':Predicate, #1: 1	كَانَ الْأَصْلِيُّ
u'كَانَ أَصَمّ':Subject, #10: 10	كَانَ أَصَمَّ
u'كَانَ أُصولٌ':Subject, #1: 1	كَانَ الْأَصَمُّ
u'كَانَ أَصيلٌ':Subject, #1: 1	كَانَ أُصُولُ
u'كَانَ إضافَةٌ':Predicate, #7: 7	كَانَ الْأَصِيلُ
u'كَانَ إضافَةٌ':Subject, #1: 1	كَانَ إضَافَةَ
u'كَانَ أَضْعَافٌ':Predicate, #2: 2	كَانَ إضَافَةُ
u'كَانَ إِضْلالٌ':Subject, #1: 1	كَانَ أَضْعَافَ
u'كَانَ إضْمارٌ':Subject, #1: 1	كَانَ الْإِضْلَالُ
u'كَانَ اِطِّراح':Subject, #3: 3	كَانَ الْإِضْمَارُ
u'كَانَ إِطْعامٌ':Subject, #1: 1	كَانَ اطِّرَاحُهُ
u'كَانَ إِطْعامٌ':Subject, #1: 1	كَانَ إطْعَامُهُ
u'كَانَ اِطِّلاعٌ':Subject, #1: 1	كَانَ الْإِطْعَامُ
u'كَانَ إِطْلاقٌ':Subject, #1: 1	كَانَ اطِّلَاعُ
u'كَانَ إِطْلاقٌ':Subject, #11: 11	كَانَ الْإِطْلَاقُ
u'كَانَ إِطْلاقٌ':Subject, #4: 4	كَانَ إطْلَاقُهُ
u'كَانَ أَطْوَلُ':Predicate, #7: 7	كَانَ إطْلَاقُ
u'كَانَ أَطْيَبُ':Predicate, #3: 3	كَانَ أَطْوَلَ
u'كَانَ إِظْهارٌ':Subject, #2: 2	كَانَ أَطْيَبَ
u'كَانَ إِظْهارٌ':Subject, #1: 1	كَانَ إظْهَارُهُ
u'كَانَ أظهر':Predicate, #1: 1	كَانَ الْإِظْهَارُ
u'كَانَ أظهر':Subject, #5: 5	كَانَ أَظْهَرَ
u'كَانَ أظهر':Subject, #1: 1	كَانَ الْأَظْهَرُ
u'كَانَ إِعْتاقٌ':Subject, #2: 2	كَانَ أَظْهَرُ
u'كَانَ إِعْتاقٌ':Subject, #2: 2	كَانَ إعْتَاقُ
u'كَانَ إِعْتاقٌ':Subject, #3: 3	كَانَ إعْتَاقُهُ
u'كَانَ اِعْتِبارٌ':Subject, #7: 7	كَانَ الْإِعْتَاقُ
u'كَانَ اِعْتِبارٌ':Subject, #2: 2	كَانَ اعْتِبَارُهُ
u'كَانَ اِعْتِراضٌ':Subject, #9: 9	كَانَ اعْتِبَارُ
u'كَانَ اِعْتِرافٌ':Subject, #1: 1	كَانَ اعْتِرَاضُهُ
u'كَانَ اِعْتِرافٌ':Subject, #1: 1	كَانَ اعْتِرَافٌ
u'كَانَ اِعْتِقادٌ':Subject, #4: 4	كَانَ اعْتِرَافُهُ
u'كَانَ اِعْتِقادٌ':Subject, #1: 1	كَانَ اعْتِقَادُ
u'كَانَ اِعْتِكافٌ':Predicate, #2: 2	كَانَ اعْتِقَادُهُ
u'كَانَ اِعْتِكافٌ':Subject, #4: 4	كَانَ اعْتِكَافَ
u'كَانَ اِعْتِمادٌ':Subject, #4: 4	كَانَ اعْتِكَافُهُ
u'كَانَ اِعْتِيادٌ':Subject, #1: 1	كَانَ الاِعْتِمَادُ
u'كَانَ أَعْدَاءٌ':Subject, #1: 1	كَانَ اعْتِيَادُ
u'كَانَ إِعْرابٌ':Subject, #1: 1	كَانَ أَعْدَاءُ
u'كَانَ إِعْرابٌ':Subject, #1: 1	كَانَ إعْرَابُ
u'كَانَ أعْرَابِيٌّ':Subject, #1: 1	كَانَ إعْرَابُهُ
u'كَانَ أعْرَج':Predicate, #1: 1	كَانَ الْأَعْرَابِيُّ
u'كَانَ أعْرَفُ':Predicate, #1: 1	كَانَ أَعْرَجَ
u'كَانَ أعْرَف':Predicate, #6: 6	كَانَ أَعْرَفَ
u'كَانَ أعَزُّ':Predicate, #6: 6	كَانَ أَعْرَفَ
u'كَانَ أعَزُّ':Subject, #1: 1	كَانَ أَعَزَّكَ
u'كَانَ إعْزَازٌ':Predicate, #1: 1	كَانَ الْأَعَزُّ
u'كَانَ أعْزَب':Predicate, #1: 1	كَانَ إعْزَازَ
u'كَانَ أعسر':Predicate, #1: 1	كَانَ أَعْزَبَ
u'كَانَ أعْسَر':Predicate, #2: 2	كَانَ أَعْسَرَ
u'كَانَ إعْطَاءٌ':Subject, #2: 2	كَانَ أَعْسَرَ
u'كَانَ إعْطَاءٌ':Subject, #3: 3	كَانَ إعْطَاءُ
u'كَانَ أعْظَمُ':Predicate, #3: 3	كَانَ الْإِعْطَاءُ
u'كَانَ إعْلاَمٌ':Subject, #13: 13	كَانَ أَعْظَمَ
u'كَانَ إعْلاَنٌ':Subject, #1: 1	كَانَ الْإِعْلَامُ
u'كَانَ أعْلَمُ':Predicate, #1: 1	كَانَ الْإِعْلَانُ
u'كَانَ أعْلَمُ':Subject, #19: 19	كَانَ أَعْلَمَ
u'كَانَ أعْلَمُ':Subject, #2: 2	كَانَ الْأَعْلَمُ
u'كَانَ أَعَمُّ':Predicate, #4: 4	كَانَ أَعْلَمُ
u'كَانَ أَعْمَالٌ':Subject, #34: 34	كَانَ أَعَمَّ
u'كَانَ أَعْمَامٌ':Subject, #1: 1	كَانَ أَعْمَالُ
u'كَانَ أعْمَش':Predicate, #1: 1	كَانَ أَعْمَامُهُ
u'كَانَ أعْمَش':Subject, #1: 1	كَانَ أَعْمَشَ
u'كَانَ أعْمَش':Subject, #1: 1	كَانَ الأَعْمَشُ
u'كَانَ أَعْوَانٌ':Subject, #1: 1	كَانَ الْأَعْمَشُ
u'كَانَ أعْوَر':Predicate, #1: 1	كَانَ الْأَعْوَانُ
u'كَانَ أغْلَبُ':Subject, #1: 1	كَانَ أَعْوَرَ
u'كَانَ أغْلَبُ':Subject, #13: 13	كَانَ الْأَغْلَبُ
u'كَانَ أغْلَبُ':Subject, #2: 2	كَانَ أَغْلَبُ
u'كَانَ أَغْنِيَاء':Subject, #4: 4	كَانَ الأَغْلَبُ
u'كَانَ إفَادَةٌ':Subject, #1: 1	كَانَ الْأَغْنِيَاءُ
u'كَانَ اِفْتِتَاحٌ':Subject, #1: 1	كَانَ إفَادَتُهُ
u'كَانَ اِفْتِضاض':Subject, #2: 2	كَانَ افْتِتَاحُهُ
u'كَانَ إِفْرَادٌ':Subject, #1: 1	كَانَ افْتِضَاضُهُ
u'كَانَ إِفْرَادٌ':Subject, #1: 1	كَانَ الْإِفْرَادُ
u'كَانَ إفْسَادٌ':Subject, #2: 2	كَانَ إفْرَادُ
u'كَانَ أفْضَلُ':Predicate, #4: 4	كَانَ الْإِفْسَادُ
u'كَانَ أفْضَلُ':Subject, #60: 60	كَانَ أَفْضَلَ
u'كَانَ أفْضَلُ':Subject, #1: 1	كَانَ الأَفْضَلُ
u'كَانَ أفْضَلُ':Subject, #23: 23	كَانَ الْأَفْضَلُ
u'كَانَ إِفْطارٌ':Subject, #3: 3	كَانَ أَفْضَلُ
u'كَانَ إقامَةٌ':Predicate, #3: 3	كَانَ الْإِفْطَارُ
u'كَانَ إقامَةٌ':Subject, #1: 1	كَانَ إقَامَةَ
u'كَانَ إقامَةٌ':Subject, #1: 1	كَانَ إقَامَةُ
u'كَانَ أقْبَحُ':Predicate, #1: 1	كَانَ الْإِقَامَةُ
u'كَانَ اِقْتِياتٌ':Subject, #1: 1	كَانَ أَقْبَحَ
u'كَانَ إقْدَامٌ':Subject, #1: 1	كَانَ اقْتِيَاتُهُ
u'كَانَ أقْدَرُ':Predicate, #2: 2	كَانَ إقْدَامُهُ
u'كَانَ أقْدَمُ':Predicate, #2: 2	كَانَ أَقْدَرَ
u'كَانَ أقْرأُ':Predicate, #3: 3	كَانَ أَقْدَمَ
u'كَانَ أقْرأُ':Subject, #3: 3	كَانَ أَقْرَأَ
u'كَانَ إقْرَارٌ':Subject, #1: 1	كَانَ الْأَقْرَأُ
u'كَانَ إقْرَارٌ':Subject, #22: 22	كَانَ إقْرَارُهُ
u'كَانَ إقْرَارٌ':Subject, #2: 2	كَانَ إقْرَارٌ
u'كَانَ إقْرَارٌ':Subject, #56: 56	كَانَ الْإِقْرَارُ
u'كَانَ أقْرَبُ':Predicate, #8: 8	كَانَ إقْرَارُ
u'كَانَ أقْرَبُ':Subject, #58: 58	كَانَ أَقْرَبَ
u'كَانَ أقْرَبُ':Subject, #19: 19	كَانَ الْأَقْرَبُ
u'كَانَ أقْرَع':Predicate, #1: 1	كَانَ أَقْرَبُ
u'كَانَ أقْرَع':Subject, #1: 1	كَانَ أَقْرَعَ
u'كَانَ أقْصَرُ':Predicate, #1: 1	كَانَ الْأَقْرَعُ
u'كَانَ إقْطَاعٌ':Subject, #1: 1	كَانَ أَقْصَرَ
u'كَانَ أقَلُّ':Predicate, #1: 1	كَانَ إقْطَاعُ
u'كَانَ أقَلُّ':Predicate, #229: 229	كَانَ أَقَلَّ
u'كَانَ أقَلُّ':Subject, #3: 3	كَانَ الْأَقَلَّ
u'كَانَ أقَلُّ':Subject, #14: 14	كَانَ الْأَقَلُّ
u'كَانَ أقَلُّ':Subject, #2: 2	كَانَ أَقَلُّهُ
u'كَانَ أَقْوَامٌ':Subject, #3: 3	كَانَ أَقَلُّ
u'كَانَ أكابر':Subject, #1: 1	كَانَ أَقْوَامٌ
u'كَانَ أكابر':Subject, #1: 1	كَانَ الْأَكَابِرُ
u'كَانَ أكَّارٌ':Subject, #2: 2	كَانَ أَكَابِرُ
u'كَانَ أكْبَرُ':Predicate, #4: 4	كَانَ الْأَكَّارُ
u'كَانَ أكْبَرُ':Subject, #15: 15	كَانَ أَكْبَرَ
u'كَانَ أكْبَرُ':Subject, #1: 1	كَانَ الْأَكْبَرُ
u'كَانَ إكْثَارٌ':Subject, #54: 54	كَانَ أَكْبَرُ
u'كَانَ أَكْثَرُ':Predicate, #5: 5	كَانَ الْإِكْثَارُ
u'كَانَ أَكْثَرُ':Predicate, #1: 1	كَانَ الْأَكْثَرَ
u'كَانَ أَكْثَرُ':Subject, #205: 205	كَانَ أَكْثَرَ
u'كَانَ أَكْثَرُ':Subject, #21: 21	كَانَ الْأَكْثَرُ
u'كَانَ أَكْثَرُ':Subject, #43: 43	كَانَ أَكْثَرُ
u'كَانَ إكْرَامٌ':Subject, #8: 8	كَانَ أَكْثَرُهُ
u'كَانَ إكْرَاهٌ':Subject, #2: 2	كَانَ الْإِكْرَامُ
u'كَانَ إكْرَاهٌ':Subject, #1: 1	كَانَ إكْرَاهُهُ
u'كَانَ أكْرَمُ':Predicate, #24: 24	كَانَ الْإِكْرَاهُ
u'كَانَ أكل':Predicate, #4: 4	كَانَ أَكْرَمَ
u'كَانَ أكل':Subject, #5: 5	كَانَ أَكَلَ
u'كَانَ أَكْلٌ':Subject, #2: 2	كَانَ أَكْلُهُ
u'كَانَ أكل':Subject, #2: 2	كَانَ أَكْلُهُ
u'كَانَ أَكْلٌ':Subject, #6: 6	كَانَ الْأَكْلُ
u'كَانَ أَكْمَلُ':Predicate, #6: 6	كَانَ الْأَكْلُ
u'كَانَ أَكْمَلُ':Subject, #5: 5	كَانَ أَكْمَلَ
u'كَانَ أَكْمَلُ':Subject, #1: 1	كَانَ أَكْمَلُ
u'كَانَ اِلْتِزَامٌ':Subject, #1: 1	كَانَ الْأَكْمَلُ
u'كَانَ اِلْتِقَاطٌ':Subject, #5: 5	كَانَ الْتِزَامُ
u'كَانَ أَلْثَغ':Predicate, #1: 1	كَانَ الْتِقَاطُهُ
u'كَانَ إلْحَاقٌ':Subject, #3: 3	كَانَ أَلْثَغَ
u'كَانَ إلْحَاقٌ':Subject, #1: 1	كَانَ الْإِلْحَاقُ
u'كَانَ إِلْزَامٌ':Predicate, #1: 1	كَانَ إلْحَاقُ
u'كَانَ إِلْزَامٌ':Subject, #1: 1	كَانَ إلْزَامَ
u'كَانَ ألف':Predicate, #1: 1	كَانَ الْإِلْزَامُ
u'كَانَ ألْفٌ':Predicate, #14: 14	كَانَ أَلْفَ
u'كَانَ أَلْفٌ':Predicate, #14: 14	كَانَ أَلْفَ
u'كَانَ ألف':Predicate, #14: 14	كَانَ أَلْفَ
u'كَانَ ألف':Subject, #1: 1	كَانَ أَلِفَ
u'كَانَ ألْفٌ':Subject, #22: 22	كَانَ الْأَلْفُ
u'كَانَ أَلْفٌ':Subject, #22: 22	كَانَ الْأَلْفُ
u'كَانَ ألف':Subject, #22: 22	كَانَ الْأَلْفُ
u'كَانَ ألف':Subject, #2: 2	كَانَ الْأَلِفُ
u'كَانَ ألْفٌ':Subject, #2: 2	كَانَ أَلْفُ
u'كَانَ أَلْفٌ':Subject, #2: 2	كَانَ أَلْفُ
u'كَانَ إِلْقَاءٌ':Subject, #2: 2	كَانَ أَلْفُ
u'كَانَ ألَمٌ':Subject, #2: 2	كَانَ الْإِلْقَاءُ
u'كَانَ الْمَرْءُ':Subject, #1: 1	كَانَ الْأَلَمُ
u'كَانَ ألُوفٌ':Subject, #1: 1	كَانَ الْمَرْءُ
u'كَانَ أُمٌّ':Predicate, #1: 1	كَانَ أَلُوفٌ
u'كَانَ أُمٌّ':Subject, #1: 1	كَانَ أُمَّ
u'كَانَ أُمٌّ':Subject, #1: 1	كَانَ الْأُمُّ
u'كَانَ أُمٌّ':Subject, #2: 2	كَانَ أُمٌّ
u'كَانَ إمَامٌ':Predicate, #2: 2	كَانَ أُمُّهُ
u'كَانَ إمَامٌ':Predicate, #3: 3	كَانَ إمَامَ
u'كَانَ إمَامٌ':Subject, #7: 7	كَانَ الْإِمَامَ
u'كَانَ إمَامٌ':Subject, #1: 1	كَانَ إمَامٌ
u'كَانَ إمَامٌ':Subject, #234: 234	كَانَ الْإِمَامُ
u'كَانَ إمَامٌ':Subject, #6: 6	كَانَ إمَامُ
u'كَانَ أمَانٌ':Subject, #7: 7	كَانَ إمَامُهُ
u'كَانَ أمَانٌ':Subject, #1: 1	كَانَ أَمَانُهُ
u'كَانَ اِمْتِدَادٌ':Subject, #4: 4	كَانَ الْأَمَانُ
u'كَانَ اِمْتِناعٌ':Subject, #1: 1	كَانَ امْتِدَادُ
u'كَانَ اِمْتِناعٌ':Subject, #4: 4	كَانَ امْتِنَاعُ
u'كَانَ أَمَدٌ':Subject, #4: 4	كَانَ امْتِنَاعُهُ
u'كَانَ آمِرٌ':Predicate, #2: 2	كَانَ أَمَدُ
u'كَانَ أَمْرٌ':Subject, #1: 1	كَانَ الْآمِرَ
u'كَانَ أَمْرٌ':Subject, #13: 13	كَانَ أَمْرُ
u'كَانَ أَمْرٌ':Subject, #152: 152	كَانَ الْأَمْرُ
u'كَانَ أَمْرٌ':Subject, #15: 15	كَانَ أَمْرُهُ
u'كَانَ أَمْرٌ':Subject, #2: 2	كَانَ الأَمْرُ
u'كَانَ آمِرٌ':Subject, #3: 3	كَانَ أَمْرٌ
u'كَانَ أمراء':Subject, #72: 72	كَانَ الْآمِرُ
u'كَانَ أَمْرَد':Predicate, #2: 2	كَانَ الْأُمَرَاءُ
u'كَانَ أَمْرَد':Subject, #5: 5	كَانَ أَمْرَدَ
u'كَانَ إِمْساكٌ':Predicate, #3: 3	كَانَ الْأَمْرَدُ
u'كَانَ إِمْساكٌ':Subject, #1: 1	كَانَ إمْسَاكَ
u'كَانَ إِمْضاءٌ':Subject, #3: 3	كَانَ الْإِمْسَاكُ
u'كَانَ إِمْضاءٌ':Subject, #1: 1	كَانَ الْإِمْضَاءُ
u'كَانَ إِمْكانٌ':Subject, #1: 1	كَانَ إمْضَاءُ
u'كَانَ أَمْلَس':Predicate, #3: 3	كَانَ الْإِمْكَانُ
u'كَانَ أَمِنٌ':Predicate, #1: 1	كَانَ أَمْلَسَ
u'كَانَ أَمْنٌ':Subject, #1: 1	كَانَ أَمِنَ
u'كَانَ أَمْنٌ':Subject, #1: 1	كَانَ أَمْنُ
u'كَانَ أمناء':Subject, #2: 2	كَانَ الْأَمْنُ
u'كَانَ أموات':Subject, #1: 1	كَانَ أُمَنَاءُ
u'كَانَ أُمِّيٌّ':Subject, #1: 1	كَانَ الْأَمْوَاتُ
u'كَانَ أَميرٌ':Predicate, #1: 1	كَانَ الْأُمِّيُّ
u'كَانَ أَميرٌ':Subject, #1: 1	كَانَ الْأَمِيرَ
u'كَانَ أَميرٌ':Subject, #13: 13	كَانَ الْأَمِيرُ
u'كَانَ إِناءٌ':Predicate, #8: 8	كَانَ أَمِيرُ
u'كَانَ إِناءٌ':Subject, #1: 1	كَانَ إنَاءَ
u'كَانَ إِناءٌ':Subject, #18: 18	كَانَ الْإِنَاءُ
u'كَانَ أُناسٌ':Subject, #1: 1	كَانَ إنَاءُ
u'كَانَ أنبياء':Subject, #2: 2	كَانَ أُنَاسٌ
u'كَانَ اِنْتِساخٌ':Subject, #3: 3	كَانَ الْأَنْبِيَاءُ
u'كَانَ اِنْتِفاء':Subject, #1: 1	كَانَ انْتِسَاخُ
u'كَانَ اِنْتِفاعٌ':Subject, #3: 3	كَانَ انْتِفَاءُ
u'كَانَ اِنْتِقالٌ':Subject, #2: 2	كَانَ انْتِفَاعُ
u'كَانَ اِنْتِقالٌ':Subject, #1: 1	كَانَ انْتِقَالُ
u'كَانَ اِنْتِهاءٌ':Subject, #2: 2	كَانَ انْتِقَالُهُ
u'كَانَ اِنْحِرافٌ':Subject, #3: 3	كَانَ انْتِهَاءُ
u'كَانَ اِنْحِطاطٌ':Subject, #2: 2	كَانَ انْحِرَافُهُ
u'كَانَ إِنْسانٌ':Subject, #1: 1	كَانَ انْحِطَاطُ
u'كَانَ إِنْسانٌ':Subject, #1: 1	كَانَ إنْسَانٌ
u'كَانَ أَنْسَبُ':Predicate, #8: 8	كَانَ الْإِنْسَانُ
u'كَانَ أَنْسَبُ':Subject, #23: 23	كَانَ أَنْسَبَ
u'كَانَ إِنْشادٌ':Subject, #13: 13	كَانَ الْأَنْسَبُ
u'كَانَ أنصار':Subject, #1: 1	كَانَ الْإِنْشَادُ
u'كَانَ أنصار':Subject, #1: 1	كَانَ الأَنْصَارُ
u'كَانَ أَنْصارٌ':Subject, #1: 1	كَانَ الْأَنْصَارُ
u'كَانَ أَنْصارٌ':Subject, #1: 1	كَانَ الأَنْصَارُ
u'كَانَ أَنْصَارٌ':Subject, #1: 1	كَانَ الْأَنْصَارُ
u'كَانَ أَنْصَارٌ':Subject, #1: 1	كَانَ الأَنْصَارُ
u'كَانَ أَنْصِبَاءُ':Subject, #1: 1	كَانَ الْأَنْصَارُ
u'كَانَ اِنْصِبابٌ':Subject, #1: 1	كَانَ أَنْصِبَاءُ
u'كَانَ اِنْصَبَغ':Predicate, #1: 1	كَانَ انْصِبَابُ
u'كَانَ اِنْصِرافٌ':Subject, #1: 1	كَانَ انْصَبَغَ
u'كَانَ اِنْعِدَامٌ':Subject, #2: 2	كَانَ انْصِرَافُهُ
u'كَانَ اِنْعِقَادٌ':Subject, #1: 1	كَانَ انْعِدَامُهُ
u'كَانَ اِنْعِقَادٌ':Subject, #1: 1	كَانَ انْعِقَادُهُ
u'كَانَ اِنْغِماس':Subject, #4: 4	كَانَ انْعِقَادُ
u'كَانَ أَنْفٌ':Predicate, #1: 1	كَانَ انْغِمَاسُهُ
u'كَانَ أَنْفٌ':Subject, #1: 1	كَانَ الْأَنْفَ
u'كَانَ إِنْفاقٌ':Subject, #2: 2	كَانَ أَنْفُ
u'كَانَ إِنْفاقٌ':Subject, #1: 1	كَانَ إنْفَاقُهُ
u'كَانَ اِنْفِصالٌ':Subject, #7: 7	كَانَ الْإِنْفَاقُ
u'كَانَ أَنْفَعُ':Predicate, #1: 1	كَانَ انْفِصَالُهُ
u'كَانَ اِنْقِرَاضٌ':Subject, #9: 9	كَانَ أَنْفَعَ
u'كَانَ اِنْقِضاءٌ':Subject, #2: 2	كَانَ انْقِرَاضُ
u'كَانَ اِنْقِطاعٌ':Subject, #1: 1	كَانَ انْقِضَاءُ
u'كَانَ إِنْكارٌ':Subject, #4: 4	كَانَ انْقِطَاعُهُ
u'كَانَ إِنْكارٌ':Subject, #1: 1	كَانَ إنْكَارُ
u'كَانَ أهْلٌ':Predicate, #2: 2	كَانَ الْإِنْكَارُ
u'كَانَ أهْلٌ':Subject, #4: 4	كَانَ أَهْلَ
u'كَانَ أهْلٌ':Subject, #15: 15	كَانَ أَهْلُهُ
u'كَانَ أهْلٌ':Subject, #1: 1	كَانَ أَهْلٌ
u'كَانَ إهْلاَلٌ':Subject, #78: 78	كَانَ أَهْلُ
u'كَانَ إهْمَالٌ':Subject, #1: 1	كَانَ إهْلَالُهُ
u'كَانَ أهْوَنُ':Predicate, #1: 1	كَانَ إِهْمَالُ
u'كَانَ أوَانٌ':Predicate, #5: 5	كَانَ أَهْوَنَ
u'كَانَ أوَانٌ':Subject, #2: 2	كَانَ أَوَانَ
u'كَانَ أوائل':Subject, #1: 1	كَانَ أَوَانُ
u'كَانَ أوْجَهُ':Predicate, #2: 2	كَانَ أَوَائِلُ
u'كَانَ أوْجَهُ':Predicate, #1: 1	كَانَ الْأَوْجَهَ
u'كَانَ أَوْجُهٌ':Subject, #3: 3	كَانَ أَوْجَهَ
u'كَانَ أوْجَهُ':Subject, #1: 1	كَانَ الْأَوْجُهُ
u'كَانَ أوْسَطُ':Subject, #2: 2	كَانَ الْأَوْجَهُ
u'كَانَ أوْضَحُ':Predicate, #2: 2	كَانَ الْأَوْسَطُ
u'كَانَ أوْضَحُ':Subject, #12: 12	كَانَ أَوْضَحَ
u'كَانَ أَوْفَرُ':Predicate, #1: 1	كَانَ أَوْضَحُ
u'كَانَ أَوْكَس':Predicate, #1: 1	كَانَ أَوْفَرَ
u'كَانَ أَوَّلُ':Predicate, #1: 1	كَانَ أَوْكَسَ
u'كَانَ أَوَّلُ':Predicate, #21: 21	كَانَ أَوّلَ
u'كَانَ أَوَّلُ':Predicate, #29: 29	كَانَ أَوَّلَ
u'كَانَ أَوَّلُ':Subject, #66: 66	كَانَ الْأَوَّلَ
u'كَانَ أَوَّلُ':Subject, #341: 341	كَانَ الْأَوَّلُ
u'كَانَ أَوَّلُ':Subject, #51: 51	كَانَ أَوَّلُ
u'كَانَ أَوْلاَدٌ':Subject, #7: 7	كَانَ أَوَّلُهُ
u'كَانَ أَوْلاَدٌ':Subject, #5: 5	كَانَ أَوْلَادُهُ
u'كَانَ أَوْلاَدٌ':Subject, #6: 6	كَانَ أَوْلَادُ
u'كَانَ أَوْلِيَاءُ':Subject, #8: 8	كَانَ الْأَوْلَادُ
u'كَانَ أَوْلِيَاءُ':Subject, #4: 4	كَانَ أَوْلِيَاءُ
u'كَانَ أئِمَّةٌ':Subject, #6: 6	كَانَ الْأَوْلِيَاءُ
u'كَانَ أيَّامٌ':Predicate, #2: 2	كَانَ أَئِمَّةُ
u'كَانَ أَيَّامٌ':Predicate, #1: 1	كَانَ أَيَّامَ
u'كَانَ أيَّامٌ':Subject, #1: 1	كَانَ أَيَّامَ
u'كَانَ أَيَّامٌ':Subject, #3: 3	كَانَ أَيَّامُ
u'كَانَ آيَةٌ':Subject, #3: 3	كَانَ أَيَّامُ
u'كَانَ أيتام':Subject, #1: 1	كَانَ آيَةُ
u'كَانَ إِيجَابٌ':Subject, #1: 1	كَانَ الْأَيْتَامُ
u'كَانَ إِيجَابٌ':Subject, #13: 13	كَانَ الْإِيجَابُ
u'كَانَ إِيجَارٌ':Subject, #1: 1	كَانَ إيجَابُ
u'كَانَ إيجَازٌ':Subject, #1: 1	كَانَ الْإِيجَارُ
u'كَانَ إِيدَاعٌ':Subject, #3: 3	كَانَ الْإِيجَازُ
u'كَانَ إِيدَاعٌ':Subject, #1: 1	كَانَ إيدَاعُ
u'كَانَ إيرَادٌ':Subject, #2: 2	كَانَ الْإِيدَاعُ
u'كَانَ أَيْسَرُ':Predicate, #1: 1	كَانَ الْإِيرَادُ
u'كَانَ أَيْسَرُ':Subject, #1: 1	كَانَ أَيْسَرَ
u'كَانَ أَيْسَرُ':Subject, #1: 1	كَانَ الْأَيْسَرُ
u'كَانَ إِيطَاءٌ':Subject, #1: 1	كَانَ أَيْسَرُهُ
u'كَانَ إيقَاعٌ':Predicate, #1: 1	كَانَ الْإِيطَاءُ
u'كَانَ إيقَاعٌ':Subject, #1: 1	كَانَ إيقَاعَ
u'كَانَ إيقَاعٌ':Subject, #2: 2	كَانَ الْإِيقَاعُ
u'كَانَ إيمَانٌ':Subject, #2: 2	كَانَ إيقَاعُ
u'كَانَ إيمَانٌ':Subject, #2: 2	كَانَ إيمَانُ
u'كَانَ إيمَانٌ':Subject, #3: 3	كَانَ إيمَانُهُ
u'كَانَ أَيْمَنُ':Subject, #5: 5	كَانَ الْإِيمَانُ
u'كَانَ أَيْمَن':Subject, #1: 1	كَانَ الْأَيْمَنُ
u'كَانَ إِيهَامٌ':Subject, #1: 1	كَانَ الْأَيْمَنُ
u'كَانَ بَابٌ':Subject, #1: 1	كَانَ الْإِيهَامُ
u'كَانَ بَابٌ':Subject, #13: 13	كَانَ الْبَابُ
u'كَانَ بَابٌ':Subject, #14: 14	كَانَ بَابُ
u'كَانَ باذِلٌ':Subject, #2: 2	كَانَ بَابُهُ
u'كَانَ بَارِحٌ':Predicate, #1: 1	كَانَ الْبَاذِلُ
u'كَانَ بَارِحٌ':Subject, #1: 1	كَانَ الْبَارِحَةَ
u'كَانَ بَارِزٌ':Subject, #1: 1	كَانَ الْبَارِحَةُ
u'كَانَ بَأسٌ':Subject, #1: 1	كَانَ الْبَارِزُ
u'كَانَ بَأسٌ':Subject, #2: 2	كَانَ الْبَأْسُ
u'كَانَ بَاطِلٌ':Predicate, #2: 2	كَانَ بَأْسٌ
u'كَانَ بَاطن':Subject, #1: 1	كَانَ بَاطِلاً
u'كَانَ باطِنٌ':Subject, #1: 1	كَانَ بَاطِنُ
u'كَانَ بَاعٌ':Predicate, #1: 1	كَانَ بَاطِنُ
u'كَانَ بَاعٌ':Subject, #25: 25	كَانَ بَاعَ
u'كَانَ بَاعِثٌ':Subject, #1: 1	كَانَ بَاعَاهُ
u'كَانَ بَاعِثٌ':Subject, #1: 1	كَانَ بَاعِثُهُ
u'كَانَ بَاعِثٌ':Subject, #2: 2	كَانَ بَاعِثُ
u'كَانَ بالِغٌ':Subject, #5: 5	كَانَ الْبَاعِثُ
u'كَانَ بَانٌ':Predicate, #3: 3	كَانَ الْبَالِغُ
u'كَانَ بَائِعٌ':Predicate, #3: 3	كَانَ بَانَ
u'كَانَ بَائِعٌ':Subject, #1: 1	كَانَ الْبَائِعَ
u'كَانَ بَائِعٌ':Subject, #196: 196	كَانَ الْبَائِعُ
u'كَانَ بَائِعٌ':Subject, #3: 3	كَانَ بَائِعُ
u'كَانَ بَائِنٌ':Subject, #4: 4	كَانَ بَائِعُهُ
u'كَانَ بَتَّةٌ':Subject, #1: 1	كَانَ الْبَائِنُ
u'كَانَ بَحْثٌ':Subject, #1: 1	كَانَ الْبَتَّةُ
u'كَانَ بَحْثٌ':Subject, #3: 3	كَانَ بَحْثُ
u'كَانَ بَحْرٌ':Subject, #6: 6	كَانَ الْبَحْثُ
u'كَانَ بُخارٌ':Subject, #2: 2	كَانَ الْبَحْرُ
u'كَانَ بُخَارِيٌّ':Subject, #1: 1	كَانَ الْبُخَارُ
u'كَانَ بَخَر':Subject, #1: 1	كَانَ الْبُخَارِيُّ
u'كَانَ بُخْلٌ':Subject, #2: 2	كَانَ الْبَخَرُ
u'كَانَ بُدّ':Subject, #1: 1	كَانَ الْبُخْلُ
u'كَانَ بَدْءٌ':Subject, #2: 2	كَانَ بُدٌّ
u'كَانَ بَدْءٌ':Subject, #1: 1	كَانَ الْبَدْءُ
u'كَانَ بَدْرٌ':Subject, #9: 9	كَانَ بَدْءُ
u'كَانَ بَدَلٌ':Predicate, #2: 2	كَانَ بَدْرٌ
u'كَانَ بَدَلٌ':Subject, #21: 21	كَانَ بَدَلَ
u'كَانَ بَدَلٌ':Subject, #23: 23	كَانَ بَدَلُ
u'كَانَ بَدَلٌ':Subject, #2: 2	كَانَ بَدَلُهُ
u'كَانَ بدن':Subject, #34: 34	كَانَ الْبَدَلُ
u'كَانَ بَدَنٌ':Subject, #1: 1	كَانَ بَدَنُهُ
u'كَانَ بدن':Subject, #1: 1	كَانَ بَدَنُهُ
u'كَانَ بَدَنٌ':Subject, #3: 3	كَانَ الْبَدَنُ
u'كَانَ بَدْوٌ':Subject, #3: 3	كَانَ الْبَدَنُ
u'كَانَ بَدَوِيٌّ':Subject, #1: 1	كَانَ بَدْوُ
u'كَانَ بَذْرٌ':Subject, #3: 3	كَانَ الْبَدَوِيُّ
u'كَانَ بَذْلٌ':Subject, #215: 215	كَانَ الْبَذْرُ
u'كَانَ بَذْلٌ':Subject, #1: 1	كَانَ بَذْلُهُ
u'كَانَ بَرٌّ':Subject, #2: 2	كَانَ الْبَذْلُ
u'كَانَ بُرٌّ':Subject, #2: 2	كَانَ الْبَرُّ
u'كَانَ بِرٌّ':Subject, #3: 3	كَانَ الْبُرُّ
u'كَانَ بُرْء':Subject, #3: 3	كَانَ الْبِرُّ
u'كَانَ براءٌ':Subject, #1: 1	كَانَ الْبُرْءُ
u'كَانَ بَراءٌ':Subject, #14: 14	كَانَ الْبَرَاءُ
u'كَانَ بُرْجٌ':Subject, #14: 14	كَانَ الْبَرَاءُ
u'كَانَ بَرْدٌ':Subject, #1: 1	كَانَ الْبُرْجُ
u'كَانَ بِرْذَوْنٌ':Subject, #1: 1	كَانَ الْبَرْدُ
u'كَانَ برص':Subject, #1: 1	كَانَ الْبِرْذَوْنُ
u'كَانَ بَرَصٌ':Subject, #1: 1	كَانَ الْبَرَصُ
u'كَانَ بُزاق':Predicate, #1: 1	كَانَ الْبَرَصُ
u'كَانَ بُزاق':Subject, #2: 2	كَانَ بُزَاقَ
u'كَانَ بساط':Subject, #1: 1	كَانَ الْبُزَاقُ
u'كَانَ بِساطٌ':Subject, #3: 3	كَانَ الْبِسَاطُ
u'كَانَ بُسْتانٌ':Subject, #3: 3	كَانَ الْبِسَاطُ
u'كَانَ بُسْرٌ':Subject, #7: 7	كَانَ الْبُسْتَانُ
u'كَانَ بسط':Predicate, #1: 1	كَانَ الْبُسْرُ
u'كَانَ بسط':Predicate, #1: 1	كَانَ بَسَطَ
u'كَانَ بِشْرٌ':Subject, #1: 1	كَانَ بُسِطَ
u'كَانَ بِشْرٌ':Subject, #1: 1	كَانَ بِشْرٌ
u'كَانَ بَشيرٌ':Subject, #1: 1	كَانَ بِشْرُ
u'كَانَ بُصاقٌ':Subject, #2: 2	كَانَ بَشِيرُ
u'كَانَ بَصَرٌ':Subject, #1: 1	كَانَ الْبُصَاقُ
u'كَانَ بصرة':Predicate, #1: 1	كَانَ بَصَرُهُ
u'كَانَ بَصيرٌ':Subject, #1: 1	كَانَ الْبَصْرَةَ
u'كَانَ بَطْشٌ':Subject, #1: 1	كَانَ الْبَصِيرُ
u'كَانَ بَطْنٌ':Subject, #1: 1	كَانَ الْبَطْشُ
u'كَانَ بَطْنٌ':Subject, #1: 1	كَانَ بَطْنُ
u'كَانَ بَطْنٌ':Subject, #1: 1	كَانَ بَطْنُهُ
u'كَانَ بَطِيءٌ':Predicate, #2: 2	كَانَ الْبَطْنُ
u'كَانَ بِطِّيخٌ':Subject, #5: 5	كَانَ بَطِيءَ
u'كَانَ بَعْثٌ':Subject, #1: 1	كَانَ الْبِطِّيخُ
u'كَانَ بُعْدٌ':Subject, #1: 1	كَانَ بَعْثُ
u'كَانَ بُعْدٌ':Subject, #1: 1	كَانَ بُعْدُهُ
u'كَانَ بَعْضٌ':Predicate, #3: 3	كَانَ الْبُعْدُ
u'كَانَ بَعْضٌ':Subject, #7: 7	كَانَ بَعْضَ
u'كَانَ بَعْضٌ':Subject, #126: 126	كَانَ بَعْضُ
u'كَانَ بَعْضٌ':Subject, #1: 1	كَانَ بَعْضٌ
u'كَانَ بَعْضٌ':Subject, #26: 26	كَانَ الْبَعْضُ
u'كَانَ بَعْلٌ':Predicate, #37: 37	كَانَ بَعْضُهُ
u'كَانَ بَعيدٌ':Predicate, #4: 4	كَانَ بَعْلاً
u'كَانَ بَعيدٌ':Subject, #5: 5	كَانَ بَعِيدَ
u'كَانَ بَعيرٌ':Subject, #1: 1	كَانَ الْبَعِيدُ
u'كَانَ بَقاءٌ':Subject, #2: 2	كَانَ الْبَعِيرُ
u'كَانَ بَقاءٌ':Subject, #1: 1	كَانَ الْبَقَاءُ
u'كَانَ بَقّار':Subject, #4: 4	كَانَ بَقَاءُ
u'كَانَ بَقَرٌ':Subject, #1: 1	كَانَ الْبَقَّارُ
u'كَانَ بَقَرٌ':Subject, #1: 1	كَانَ الْبَقَرُ
u'كَانَ بَقِيَّةٌ':Predicate, #2: 2	كَانَ بَقَرُ
u'كَانَ بَقِيَّةٌ':Subject, #1: 1	كَانَ بَقِيَّةَ
u'كَانَ بُكاءٌ':Subject, #3: 3	كَانَ بَقِيَّةُ
u'كَانَ بِكْرٌ':Predicate, #4: 4	كَانَ الْبُكَاءُ
u'كَانَ بَلَدٌ':Subject, #1: 1	كَانَ بِكْرَ
u'كَانَ بَلَدٌ':Subject, #1: 1	كَانَ بَلَدٌ
u'كَانَ بَلَدٌ':Subject, #21: 21	كَانَ الْبَلَدُ
u'كَانَ بُلُوغٌ':Subject, #5: 5	كَانَ بَلَدُهُ
u'كَانَ بُلُوغٌ':Subject, #1: 1	كَانَ الْبُلُوغُ
u'كَانَ بِنَاءٌ':Subject, #2: 2	كَانَ بُلُوغُهُ
u'كَانَ بِنَاءٌ':Subject, #1: 1	كَانَ بِنَاءٌ
u'كَانَ بِنَاءٌ':Subject, #1: 1	كَانَ بِنَاءُ
u'كَانَ بِنْتٌ':Predicate, #41: 41	كَانَ الْبِنَاءُ
u'كَانَ بِنْتٌ':Subject, #1: 1	كَانَ بِنْتَ
u'كَانَ بُنْيانٌ':Subject, #1: 1	كَانَ بِنْتُ
u'كَانَ بَوْلٌ':Predicate, #1: 1	كَانَ بُنْيَانُهُ
u'كَانَ بَوْلٌ':Subject, #1: 1	كَانَ بَوْلَ
u'كَانَ بِئْرٌ':Subject, #7: 7	كَانَ الْبَوْلُ
u'كَانَ بَيَاضٌ':Subject, #8: 8	كَانَ الْبِئْرُ
u'كَانَ بَيَاضٌ':Subject, #13: 13	كَانَ الْبَيَاضُ
u'كَانَ بَيَّاعٌ':Subject, #2: 2	كَانَ بَيَاضُهُ
u'كَانَ بَيَانٌ':Predicate, #1: 1	كَانَ بَيَّاعُ
u'كَانَ بَيَانٌ':Subject, #2: 2	كَانَ بَيَانَ
u'كَانَ بَيَانٌ':Subject, #3: 3	كَانَ بَيَانُ
u'كَانَ بَيَانٌ':Subject, #3: 3	كَانَ بَيَانُهُ
u'كَانَ بَيْتٌ':Subject, #7: 7	كَانَ الْبَيَانُ
u'كَانَ بَيْتٌ':Subject, #11: 11	كَانَ بَيْتُ
u'كَانَ بَيْتٌ':Subject, #1: 1	كَانَ بَيْتٌ
u'كَانَ بَيْتٌ':Subject, #35: 35	كَانَ الْبَيْتُ
u'كَانَ بيض':Predicate, #6: 6	كَانَ بَيْتُهُ
u'كَانَ بيض':Subject, #1: 1	كَانَ بَيْضَ
u'كَانَ بَيْعٌ':Predicate, #5: 5	كَانَ الْبَيْضُ
u'كَانَ بِيَعٌ':Predicate, #11: 11	كَانَ بَيْعَ
u'كَانَ بَيْعٌ':Subject, #5: 5	كَانَ بِيعَ
u'كَانَ بَيْعٌ':Subject, #146: 146	كَانَ الْبَيْعُ
u'كَانَ بَيْعٌ':Subject, #17: 17	كَانَ بَيْعُ
u'كَانَ بَيْنٌ':Predicate, #9: 9	كَانَ بَيْعُهُ
u'كَانَ بَيْنٌ':Predicate, #317: 317	كَانَ بَيْنَ
u'كَانَ بَيِّنَةٌ':Subject, #4: 4	كَانَ بَيْنَكَ
u'كَانَ تَابِعٌ':Subject, #1: 1	كَانَ بَيِّنَةٌ
u'كَانَ تَأْبِيدٌ':Subject, #2: 2	كَانَ التَّابِعُ
u'كَانَ تَأْثِيرٌ':Subject, #4: 4	كَانَ التَّأْبِيدُ
u'كَانَ تَأْثِيرٌ':Subject, #1: 1	كَانَ تَأْثِيرُ
u'كَانَ تَأْثِيرٌ':Subject, #2: 2	كَانَ تَأْثِيرُهُ
u'كَانَ تَاجٌ':Subject, #4: 4	كَانَ التَّأْثِيرُ
u'كَانَ تَاجِرٌ':Subject, #1: 1	كَانَ تَاجُ
u'كَانَ تَأْجِيلٌ':Subject, #2: 2	كَانَ التَّاجِرُ
u'كَانَ تَأْخِيرٌ':Subject, #11: 11	كَانَ التَّأْجِيلُ
u'كَانَ تَأْخِيرٌ':Subject, #11: 11	كَانَ التَّأْخِيرُ
u'كَانَ تَأْدِيبٌ':Subject, #7: 7	كَانَ تَأْخِيرُ
u'كَانَ تَأْدِيبٌ':Subject, #1: 1	كَانَ التَّأْدِيبُ
u'كَانَ تارِك':Subject, #1: 1	كَانَ تَأْدِيبُهُ
u'كَانَ تَارِيخٌ':Subject, #1: 1	كَانَ تَارِكُ
u'كَانَ تَارِيخٌ':Subject, #19: 19	كَانَ تَارِيخُ
u'كَانَ تَاسِعٌ':Subject, #3: 3	كَانَ التَّارِيخُ
u'كَانَ تَأْسِيسٌ':Subject, #1: 1	كَانَ التَّاسِعُ
u'كَانَ تَأْكِيدٌ':Subject, #1: 1	كَانَ التَّأْسِيسُ
u'كَانَ تالِف':Subject, #1: 1	كَانَ التَّأْكِيدُ
u'كَانَ تَامٌّ':Predicate, #2: 2	كَانَ التَّالِفُ
u'كَانَ تَامٌّ':Predicate, #1: 1	كَانَ تَامَّ
u'كَانَ تَأْمِينٌ':Subject, #1: 1	كَانَ تَامّةً
u'كَانَ تَبَادُلٌ':Subject, #1: 1	كَانَ تَأْمِينُهُ
u'كَانَ تَبْدِيلٌ':Predicate, #1: 1	كَانَ التَّبَادُلُ
u'كَانَ تِبْر':Subject, #1: 1	كَانَ تَبْدِيلَ
u'كَانَ تَبَرُّعٌ':Subject, #3: 3	كَانَ التِّبْرُ
u'كَانَ تَبَرُّمٌ':Subject, #2: 2	كَانَ التَّبَرُّعُ
u'كَانَ تَبَسُّطٌ':Subject, #1: 1	كَانَ التَّبَرُّمُ
u'كَانَ تَبَع':Subject, #1: 1	كَانَ تَبَسُّطُ
u'كَانَ تَبَع':Subject, #1: 1	كَانَ التَّبَعُ
u'كَانَ تَبَعِيّ':Subject, #1: 1	كَانَ تَبَعِيَّةُ
u'كَانَ تَبَعِيَّة':Subject, #1: 1	كَانَ تَبَعِيَّةُ
u'كَانَ تِبْن':Subject, #1: 1	كَانَ تَبَعِيَّةُ
u'كَانَ تَبْوِيبٌ':Subject, #4: 4	كَانَ التِّبْنُ
u'كَانَ تَتَابُعٌ':Subject, #1: 1	كَانَ التَّبْوِيبُ
u'كَانَ تَثَاؤُبٌ':Subject, #1: 1	كَانَ التَّتَابُعُ
u'كَانَ تجَانُسٌ':Subject, #1: 1	كَانَ التَّثَاؤُبُ
u'كَانَ تَجَاوُزٌ':Subject, #1: 1	كَانَ التَّجَانُسُ
u'كَانَ تَجْفِيفٌ':Subject, #1: 1	كَانَ التَّجَاوُزُ
u'كَانَ تَجَوُّزٌ':Subject, #1: 1	كَانَ تَجْفِيفُهُ
u'كَانَ تَجْوِيزٌ':Subject, #2: 2	كَانَ التَّجَوُّزُ
u'كَانَ تَحْدِيدٌ':Subject, #1: 1	كَانَ التَّجْوِيزُ
u'كَانَ تَحْرِيك':Subject, #1: 1	كَانَ التَّحْدِيدُ
u'كَانَ تَحْرِيمٌ':Subject, #1: 1	كَانَ التَّحْرِيكُ
u'كَانَ تَحْرِيمٌ':Subject, #2: 2	كَانَ تَحْرِيمُ
u'كَانَ تَحْصِيلٌ':Subject, #6: 6	كَانَ التَّحْرِيمُ
u'كَانَ تَحْصِيلٌ':Subject, #1: 1	كَانَ تَحْصِيلُ
u'كَانَ تَحَقُّقٌ':Subject, #1: 1	كَانَ تَحْصِيلُهُ
u'كَانَ تَحْقِيقٌ':Subject, #1: 1	كَانَ تَحَقُّقُ
u'كَانَ تَحْقِيقٌ':Subject, #1: 1	كَانَ تَحْقِيقُ
u'كَانَ تَحْكِيمٌ':Subject, #2: 2	كَانَ التَّحْقِيقُ
u'كَانَ تَحَلُّقٌ':Subject, #2: 2	كَانَ التَّحْكِيمُ
u'كَانَ تَحَلُّلٌ':Subject, #1: 1	كَانَ تَحَلُّقٌ
u'كَانَ تَحَلُّلٌ':Subject, #2: 2	كَانَ التَّحَلُّلُ
u'كَانَ تَحْلِيف':Subject, #2: 2	كَانَ تَحَلُّلُهُ
u'كَانَ تَحْلِيلٌ':Subject, #2: 2	كَانَ التَّحْلِيفُ
u'كَانَ تَحَمُّلٌ':Subject, #1: 1	كَانَ التَّحْلِيلُ
u'كَانَ تَحَمُّلٌ':Subject, #1: 1	كَانَ التَّحَمُّلُ
u'كَانَ تَحْمِيلٌ':Subject, #1: 1	كَانَ تَحَمُّلُهُ
u'كَانَ تَحَوُّلٌ':Subject, #1: 1	كَانَ التَّحْمِيلُ
u'كَانَ تَحْوِيلٌ':Subject, #1: 1	كَانَ تَحَوُّلُهُ
u'كَانَ تَحْوِيلٌ':Subject, #1: 1	كَانَ تَحْوِيلُ
u'كَانَ تَخارُج':Subject, #2: 2	كَانَ التَّحْوِيلُ
u'كَانَ تَخَاطُبٌ':Subject, #1: 1	كَانَ التَّخَارُجُ
u'كَانَ تَخْصِيصٌ':Subject, #2: 2	كَانَ التَّخَاطُبُ
u'كَانَ تَخْصِيصٌ':Subject, #1: 1	كَانَ تَخْصِيصُ
u'كَانَ تَخْصِيصٌ':Subject, #1: 1	كَانَ تَخْصِيصُهُ
u'كَانَ تَخَلُّفٌ':Predicate, #6: 6	كَانَ التَّخْصِيصُ
u'كَانَ تَخَلُّفٌ':Subject, #2: 2	كَانَ تَخَلّفَ
u'كَانَ تَخَلُّقٌ':Subject, #1: 1	كَانَ تَخَلُّفُهُ
u'كَانَ تَخَلُّلٌ':Subject, #1: 1	كَانَ تَخَلُّقُ
u'كَانَ تَخْلِيصٌ':Subject, #1: 1	كَانَ التَّخَلُّلُ
u'كَانَ تَخْيِيرٌ':Subject, #1: 1	كَانَ التَّخْلِيصُ
u'كَانَ تَدَارُكٌ':Predicate, #3: 3	كَانَ التَّخْيِيرُ
u'كَانَ تَدَارُكٌ':Subject, #1: 1	كَانَ التَّدَارُكَ
u'كَانَ تَدْبِيرٌ':Subject, #1: 1	كَانَ التَّدَارُكُ
u'كَانَ تَذَكُّرٌ':Subject, #6: 6	كَانَ التَّدْبِيرُ
u'كَانَ تَذَكُّرٌ':Subject, #3: 3	كَانَ التَّذَكُّرُ
u'كَانَ تَذْكِرَةٌ':Subject, #3: 3	كَانَ تَذَكُّرُهُ
u'كَانَ تَذْكيرٌ':Subject, #1: 1	كَانَ التَّذْكِرَةُ
u'كَانَ تُرَابٌ':Predicate, #1: 1	كَانَ التَّذْكِيرُ
u'كَانَ تُرَابٌ':Subject, #1: 1	كَانَ تُرَابَ
u'كَانَ تُرَابٌ':Subject, #17: 17	كَانَ التُّرَابُ
u'كَانَ تَرَاجُعٌ':Subject, #1: 1	كَانَ تُرَابُ
u'كَانَ تَرَافُعٌ':Subject, #1: 1	كَانَ تَرَاجُعُ
u'كَانَ تَرْتِيبٌ':Subject, #1: 1	كَانَ التَّرَافُعُ
u'كَانَ تَرْتِيبٌ':Subject, #18: 18	كَانَ التَّرْتِيبُ
u'كَانَ تَرْجِيحٌ':Subject, #1: 1	كَانَ تَرْتِيبٌ
u'كَانَ تَرْجِيعٌ':Subject, #10: 10	كَانَ التَّرْجِيحُ
u'كَانَ تَرَدُّدٌ':Subject, #1: 1	كَانَ تَرْجِيعُهُ
u'كَانَ تَرَدُّدٌ':Subject, #1: 1	كَانَ التَّرَدُّدُ
u'كَانَ تَرْدِيدٌ':Subject, #1: 1	كَانَ تَرَدُّدُهُ
u'كَانَ تَرْكٌ':Subject, #2: 2	كَانَ التَّرْدِيدُ
u'كَانَ تَرْكٌ':Subject, #13: 13	كَانَ التَّرْكُ
u'كَانَ تَرْكٌ':Subject, #15: 15	كَانَ تَرْكُ
u'كَانَ تَرَكُّبٌ':Subject, #21: 21	كَانَ تَرْكُهُ
u'كَانَ تَرْكِيبٌ':Predicate, #1: 1	كَانَ التَّرَكُّبُ
u'كَانَ تَرْكِيبٌ':Subject, #1: 1	كَانَ تَرْكِيبَ
u'كَانَ تَزَوُّجٌ':Subject, #1: 1	كَانَ تَرْكِيبُهُ
u'كَانَ تَزَوُّجٌ':Subject, #12: 12	كَانَ التَّزَوُّجُ
u'كَانَ تَزْوِيجٌ':Subject, #3: 3	كَانَ تَزَوُّجُهُ
u'كَانَ تَزْوِيجٌ':Subject, #1: 1	كَانَ تَزْوِيجُ
u'كَانَ تَزْوِيجٌ':Subject, #1: 1	كَانَ تَزْوِيجُهُ
u'كَانَ تَسْبِيحٌ':Predicate, #6: 6	كَانَ التَّزْوِيجُ
u'كَانَ تَسْبِيعٌ':Subject, #1: 1	كَانَ تَسْبِيحَ
u'كَانَ تِسْعَةٌ':Predicate, #1: 1	كَانَ التَّسْبِيعُ
u'كَانَ تَسْعِيرٌ':Subject, #2: 2	كَانَ تِسْعَةَ
u'كَانَ تَسْلِيطٌ':Subject, #1: 1	كَانَ التَّسْعِيرُ
u'كَانَ تَسْلِيمٌ':Subject, #4: 4	كَانَ التَّسْلِيطُ
u'كَانَ تَسْلِيمٌ':Subject, #10: 10	كَانَ التَّسْلِيمُ
u'كَانَ تَسْلِيمٌ':Subject, #1: 1	كَانَ تَسْلِيمُ
u'كَانَ تَسْمِيَة':Predicate, #4: 4	كَانَ تَسْلِيمُهُ
u'كَانَ تَشَابُهٌ':Subject, #1: 1	كَانَ تَسْمِيَةَ
u'كَانَ تَشَاجُرٌ':Subject, #1: 1	كَانَ التَّشَابُهُ
u'كَانَ تَشْبِيه':Subject, #1: 1	كَانَ التَّشَاجُرُ
u'كَانَ تَشْرِيعٌ':Subject, #2: 2	كَانَ التَّشْبِيهُ
u'كَانَ تَشَهُّدٌ':Predicate, #1: 1	كَانَ التَّشْرِيعُ
u'كَانَ تَشَهُّدٌ':Subject, #2: 2	كَانَ التَّشَهُّدَ
u'كَانَ تَشَهُّدٌ':Subject, #1: 1	كَانَ التَّشَهُّدُ
u'كَانَ تَصَادُقٌ':Subject, #1: 1	كَانَ تَشَهُّدُ
u'كَانَ تَصَبُّرٌ':Subject, #1: 1	كَانَ التَّصَادُقُ
u'كَانَ تَصْحِيحٌ':Subject, #1: 1	كَانَ التَّصَبُّرُ
u'كَانَ تَصَدُّقٌ':Subject, #2: 2	كَانَ تَصْحِيحُهُ
u'كَانَ تَصَدُّقٌ':Subject, #1: 1	كَانَ تَصَدُّقُ
u'كَانَ تَصْدِيقٌ':Subject, #2: 2	كَانَ التَّصَدُّقُ
u'كَانَ تَصْدِيقٌ':Subject, #1: 1	كَانَ التَّصْدِيقُ
u'كَانَ تَصَرُّفٌ':Subject, #1: 1	كَانَ تَصْدِيقُ
u'كَانَ تَصَرُّفٌ':Subject, #11: 11	كَانَ تَصَرُّفُهُ
u'كَانَ تَصَرُّفٌ':Subject, #3: 3	كَانَ تَصَرُّفُ
u'كَانَ تَصرِيفٌ':Subject, #4: 4	كَانَ التَّصَرُّفُ
u'كَانَ تَصَوُّرٌ':Subject, #1: 1	كَانَ تَصْرِيفُ
u'كَانَ تَصْوِيبٌ':Predicate, #3: 3	كَانَ تَصَوُّرُ
u'كَانَ تَصْوِيرٌ':Subject, #1: 1	كَانَ تَصْوِيبَ
u'كَانَ تَضْعِيفٌ':Subject, #3: 3	كَانَ التَّصْوِيرُ
u'كَانَ تَضْعِيفٌ':Subject, #1: 1	كَانَ تَضْعِيفُ
u'كَانَ تَطْبِيقٌ':Subject, #2: 2	كَانَ التَّضْعِيفُ
u'كَانَ تَطْلِيقٌ':Subject, #1: 1	كَانَ التَّطْبِيقُ
u'كَانَ تَطْلِيقٌ':Subject, #1: 1	كَانَ تَطْلِيقُ
u'كَانَ تَطْهِيرٌ':Subject, #3: 3	كَانَ التَّطْلِيقُ
u'كَانَ تَطْهِيرٌ':Subject, #1: 1	كَانَ التَّطْهِيرُ
u'كَانَ تَطَوُّعٌ':Subject, #2: 2	كَانَ تَطْهِيرُ
u'كَانَ تَطَوُّعٌ':Subject, #1: 1	كَانَ التَّطَوُّعُ
u'كَانَ تَطَوُّعٌ':Subject, #1: 1	كَانَ تَطَوُّعُ
u'كَانَ تَعَارُضٌ':Subject, #1: 1	كَانَ تَطَوُّعُهُ
u'كَانَ تَعَارُفٌ':Subject, #3: 3	كَانَ التَّعَارُضُ
u'كَانَ تَعَاقُبٌ':Subject, #1: 1	كَانَ التَّعَارُفُ
u'كَانَ تَعَامُلٌ':Subject, #1: 1	كَانَ التَّعَاقُبُ
u'كَانَ تَعَامُلٌ':Subject, #1: 1	كَانَ تَعَامُلُ
u'كَانَ تَعَبُّدٌ':Subject, #7: 7	كَانَ التَّعَامُلُ
u'كَانَ تَعْبِيرٌ':Subject, #1: 1	كَانَ التَّعَبُّدُ
u'كَانَ تَعْبِيرٌ':Subject, #1: 1	كَانَ التَّعْبِيرُ
u'كَانَ تَعْبِيرٌ':Subject, #1: 1	كَانَ تَعْبِيرُهُ
u'كَانَ تَعْجِيل':Subject, #3: 3	كَانَ تَعْبِيرُ
u'كَانَ تَعْجِيل':Subject, #2: 2	كَانَ تَعْجِيلُ
u'كَانَ تَعَدُّدٌ':Subject, #7: 7	كَانَ التَّعْجِيلُ
u'كَانَ تَعْدِيلٌ':Subject, #1: 1	كَانَ تَعَدُّدُ
u'كَانَ تَعَذُّرٌ':Subject, #1: 1	كَانَ التَّعْدِيلُ
u'كَانَ تَعَرُّضٌ':Subject, #2: 2	كَانَ التَّعَذُّرُ
u'كَانَ تَعْرِيضٌ':Subject, #1: 1	كَانَ تَعَرُّضُهُ
u'كَانَ تَعْرِيفٌ':Subject, #1: 1	كَانَ التَّعْرِيضُ
u'كَانَ تَعْرِيفٌ':Subject, #10: 10	كَانَ التَّعْرِيفُ
u'كَانَ تَعْرِيفٌ':Subject, #1: 1	كَانَ تَعْرِيفُ
u'كَانَ تَعْزِير':Subject, #2: 2	كَانَ تَعْرِيفُهُ
u'كَانَ تَعْزِير':Subject, #1: 1	كَانَ تَعْزِيرُ
u'كَانَ تَعَلُّقٌ':Subject, #6: 6	كَانَ التَّعْزِيرُ
u'كَانَ تَعَلُّقٌ':Subject, #1: 1	كَانَ التَّعَلُّقُ
u'كَانَ تَعْلِيقٌ':Subject, #3: 3	كَانَ تَعَلُّقُ
u'كَانَ تَعْلِيقٌ':Subject, #1: 1	كَانَ تَعْلِيقُ
u'كَانَ تَعْلِيقٌ':Subject, #1: 1	كَانَ تَعْلِيقُهُ
u'كَانَ تَعْلِيلٌ':Subject, #56: 56	كَانَ التَّعْلِيقُ
u'كَانَ تَعْلِيمٌ':Predicate, #7: 7	كَانَ التَّعْلِيلُ
u'كَانَ تَعْلِيمٌ':Subject, #1: 1	كَانَ تَعْلِيمَ
u'كَانَ تَعْلِيمٌ':Subject, #1: 1	كَانَ التَّعْلِيمُ
u'كَانَ تَعْمِيمٌ':Subject, #1: 1	كَانَ تَعْلِيمُ
u'كَانَ تَعْوِيلٌ':Subject, #2: 2	كَانَ التَّعْمِيمُ
u'كَانَ تَعْيِينٌ':Subject, #1: 1	كَانَ التَّعْوِيلُ
u'كَانَ تَعْيِينٌ':Subject, #2: 2	كَانَ تَعْيِينُ
u'كَانَ تَعْيِينٌ':Subject, #2: 2	كَانَ تَعْيِينُهُ
u'كَانَ تَغْرِيبٌ':Subject, #3: 3	كَانَ التَّعْيِينُ
u'كَانَ تَغَيُّرٌ':Predicate, #2: 2	كَانَ التَّغْرِيبُ
u'كَانَ تَغَيُّرٌ':Subject, #1: 1	كَانَ تَغَيّرَ
u'كَانَ تَغَيُّرٌ':Subject, #2: 2	كَانَ تَغَيُّرُهُ
u'كَانَ تَغْيِيرٌ':Subject, #4: 4	كَانَ التَّغَيُّرُ
u'كَانَ تَغْيِيرٌ':Subject, #1: 1	كَانَ تَغْيِيرُ
u'كَانَ تُفَّاحٌ':Subject, #5: 5	كَانَ التَّغْيِيرُ
u'كَانَ تَفَاخُرٌ':Subject, #1: 1	كَانَ التُّفَّاحُ
u'كَانَ تَفَاضُلٌ':Subject, #1: 1	كَانَ التَّفَاخُرُ
u'كَانَ تَفَاوُتٌ':Subject, #2: 2	كَانَ التَّفَاضُلُ
u'كَانَ تَفاوُت':Subject, #1: 1	كَانَ تَفَاوُتٌ
u'كَانَ تَفْرِيع':Subject, #6: 6	كَانَ التَّفَاوُتُ
u'كَانَ تَفْرِيع':Subject, #1: 1	كَانَ التَّفْرِيعُ
u'كَانَ تَفْرِيقٌ':Subject, #1: 1	كَانَ تَفْرِيعُهُ
u'كَانَ تَفْسِيرٌ':Subject, #7: 7	كَانَ التَّفْرِيقُ
u'كَانَ تَفْسِيرٌ':Subject, #1: 1	كَانَ التَّفْسِيرُ
u'كَانَ تَفْصِيلٌ':Subject, #2: 2	كَانَ تَفْسِيرُهُ
u'كَانَ تَفْضِيلٌ':Subject, #3: 3	كَانَ التَّفْصِيلُ
u'كَانَ تَفَكُّرٌ':Subject, #1: 1	كَانَ التَّفْضِيلُ
u'كَانَ تَفَكُّرٌ':Subject, #2: 2	كَانَ التَّفَكُّرُ
u'كَانَ تَفْوِيت':Subject, #2: 2	كَانَ تَفَكُّرُهُ
u'كَانَ تَفْوِيضٌ':Predicate, #1: 1	كَانَ تَفْوِيتُ
u'كَانَ تَفْوِيضٌ':Subject, #3: 3	كَانَ تَفْوِيضَ
u'كَانَ تَفْوِيضٌ':Subject, #12: 12	كَانَ التَّفْوِيضُ
u'كَانَ تَقاطُرٌ':Subject, #1: 1	كَانَ تَفْوِيضُ
u'كَانَ تَقَدُّمٌ':Subject, #1: 1	كَانَ التَّقَاطُرُ
u'كَانَ تَقَدُّمٌ':Subject, #1: 1	كَانَ تَقَدُّمُ
u'كَانَ تَقْديرٌ':Subject, #3: 3	كَانَ التَّقَدُّمُ
u'كَانَ تَقْديرٌ':Subject, #2: 2	كَانَ تَقْدِيرُ
u'كَانَ تَقْديرٌ':Subject, #3: 3	كَانَ تَقْدِيرُهُ
u'كَانَ تَقْديمٌ':Predicate, #4: 4	كَانَ التَّقْدِيرُ
u'كَانَ تَقْديمٌ':Subject, #1: 1	كَانَ تَقْدِيمَ
u'كَانَ تَقْديمٌ':Subject, #1: 1	كَانَ التَّقْدِيمُ
u'كَانَ تَقْديمٌ':Subject, #2: 2	كَانَ تَقْدِيمُ
u'كَانَ تَقْريرٌ':Subject, #4: 4	كَانَ تَقْدِيمُهُ
u'كَانَ تَقْسِيمٌ':Subject, #1: 1	كَانَ تَقْرِيرُهُ
u'كَانَ تَقْسِيمٌ':Subject, #1: 1	كَانَ التَّقْسِيمُ
u'كَانَ تَقْصيرٌ':Subject, #1: 1	كَانَ تَقْسِيمُهُ
u'كَانَ تَقْصيرٌ':Subject, #1: 1	كَانَ تَقْصِيرُ
u'كَانَ تَقْصيرٌ':Subject, #3: 3	كَانَ التَّقْصِيرُ
u'كَانَ تَقَطُّعٌ':Subject, #3: 3	كَانَ تَقْصِيرُهُ
u'كَانَ تَقْليدٌ':Subject, #1: 1	كَانَ التَّقَطُّعُ
u'كَانَ تَقْليد':Subject, #2: 2	كَانَ تَقْلِيدُ
u'كَانَ تَقْليدٌ':Subject, #2: 2	كَانَ تَقْلِيدُ
u'كَانَ تَقْليد':Subject, #3: 3	كَانَ تَقْلِيدُهُ
u'كَانَ تَقْليدٌ':Subject, #3: 3	كَانَ تَقْلِيدُهُ
u'كَانَ تَقْليد':Subject, #8: 8	كَانَ التَّقْلِيدُ
u'كَانَ تَقْويمٌ':Subject, #8: 8	كَانَ التَّقْلِيدُ
u'كَانَ تَقْويمٌ':Subject, #1: 1	كَانَ التَّقْوِيمُ
u'كَانَ تَقِيٌّ':Subject, #1: 1	كَانَ تَقْوِيمُهُ
u'كَانَ تَقْيِيد':Subject, #1: 1	كَانَ التَّقِيُّ
u'كَانَ تَكافُؤٌ':Subject, #9: 9	كَانَ التَّقْيِيدُ
u'كَانَ تَكْبيرٌ':Subject, #1: 1	كَانَ التَّكَافُؤُ
u'كَانَ تَكْذيبٌ':Subject, #2: 2	كَانَ التَّكْبِيرُ
u'كَانَ تَكَرُّرٌ':Subject, #1: 1	كَانَ التَّكْذِيبُ
u'كَانَ تَكْفيرٌ':Subject, #1: 1	كَانَ تَكَرُّرُ
u'كَانَ تَكَلُّفٌ':Subject, #4: 4	كَانَ التَّكْفِيرُ
u'كَانَ تَكَلُّفٌ':Subject, #1: 1	كَانَ التَّكَلُّفُ
u'كَانَ تَكَلُّمٌ':Predicate, #1: 1	كَانَ تَكَلُّفُهُ
u'كَانَ تَكَلُّمٌ':Subject, #1: 1	كَانَ تَكَلّمَ
u'كَانَ تَكْليفٌ':Subject, #1: 1	كَانَ تَكَلُّمُهُ
u'كَانَ تَكْنِيَة':Subject, #8: 8	كَانَ التَّكْلِيفُ
u'كَانَ تَلازُم':Subject, #1: 1	كَانَ تَكْنِيَتُهُ
u'كَانَ تَلاصُقٌ':Subject, #2: 2	كَانَ التَّلَازُمُ
u'كَانَ تَلْبيدٌ':Subject, #1: 1	كَانَ التَّلَاصُقُ
u'كَانَ تَلَذُّذٌ':Subject, #1: 1	كَانَ التَّلْبِيدُ
u'كَانَ تَلَفٌ':Subject, #2: 2	كَانَ التَّلَذُّذُ
u'كَانَ تَلَف':Subject, #13: 13	كَانَ تَلَفُهُ
u'كَانَ تَلَفٌ':Subject, #17: 17	كَانَ التَّلَفُ
u'كَانَ تَلَفُّظٌ':Subject, #1: 1	كَانَ تَلَفُ
u'كَانَ تِلْميذٌ':Subject, #2: 2	كَانَ التَّلَفُّظُ
u'كَانَ تَماثيلُ':Predicate, #1: 1	كَانَ التِّلْمِيذُ
u'كَانَ تَماثيلُ':Subject, #1: 1	كَانَ تَمَاثِيلَ
u'كَانَ تمام':Subject, #1: 1	كَانَ تَمَاثِيلُ
u'كَانَ تَمامٌ':Subject, #4: 4	كَانَ تَمَامُ
u'كَانَ تَمَتُّعٌ':Subject, #4: 4	كَانَ تَمَامُ
u'كَانَ تِمْثالٌ':Subject, #2: 2	كَانَ التَّمَتُّعُ
u'كَانَ تَمثُّلٌ':Predicate, #2: 2	كَانَ التِّمْثَالُ
u'كَانَ تَمْر':Subject, #1: 1	كَانَ تَمَثّلَ
u'كَانَ تَمْريضٌ':Subject, #4: 4	كَانَ التَّمْرُ
u'كَانَ تَمَكُّنٌ':Subject, #1: 1	كَانَ تَمْرِيضُ
u'كَانَ تَمْكِينٌ':Subject, #2: 2	كَانَ التَّمَكُّنُ
u'كَانَ تَمَلُّكٌ':Subject, #1: 1	كَانَ تَمْكِينُ
u'كَانَ تَمَلُّك':Subject, #1: 1	كَانَ تَمَلُّكُ
u'كَانَ تَمْلِيكٌ':Subject, #2: 2	كَانَ التَّمَلُّكُ
u'كَانَ تَمْلِيك':Subject, #1: 1	كَانَ تَمْلِيكُ
u'كَانَ تَمْييزٌ':Subject, #3: 3	كَانَ التَّمْلِيكُ
u'كَانَ تَنَازُعٌ':Subject, #1: 1	كَانَ التَّمْيِيزُ
u'كَانَ تَنَاسُبٌ':Subject, #5: 5	كَانَ التَّنَازُعُ
u'كَانَ تَنَاقُضٌ':Subject, #1: 1	كَانَ التَّنَاسُبُ
u'كَانَ تَنَاوُلٌ':Subject, #1: 1	كَانَ التَّنَاقُضُ
u'كَانَ تَنْبِيه':Subject, #2: 2	كَانَ تَنَاوُلُهُ
u'كَانَ تَنجُّسٌ':Subject, #1: 1	كَانَ التَّنْبِيهُ
u'كَانَ تَنْجِيسٌ':Subject, #1: 1	كَانَ التَّنَجُّسُ
u'كَانَ تَنَحْنُحٌ':Subject, #1: 1	كَانَ التَّنْجِيسُ
u'كَانَ تَنَزُّه':Subject, #2: 2	كَانَ التَّنَحْنُحُ
u'كَانَ تَنَفُّلٌ':Subject, #2: 2	كَانَ التَّنَزُّهُ
u'كَانَ تَنْفِيذٌ':Subject, #1: 1	كَانَ التَّنَفُّلُ
u'كَانَ تَنْفِيلٌ':Subject, #1: 1	كَانَ تَنْفِيذُهُ
u'كَانَ تَوَارُثٌ':Subject, #4: 4	كَانَ التَّنْفِيلُ
u'كَانَ تَوَارِيخُ':Subject, #1: 1	كَانَ التَّوَارُثُ
u'كَانَ تَوَاضُعٌ':Subject, #1: 1	كَانَ تَوَارِيخُ
u'كَانَ تَوَاطُؤٌ':Subject, #1: 1	كَانَ التَّوَاضُعُ
u'كَانَ تَوَالُدٌ':Subject, #1: 1	كَانَ التَّوَاطُؤُ
u'كَانَ تَوْبَةٌ':Predicate, #2: 2	كَانَ تَوَالُدُهُ
u'كَانَ تَوَجُّهٌ':Subject, #1: 1	كَانَ تَوْبَةَ
u'كَانَ تَوَجُّهٌ':Subject, #1: 1	كَانَ التَّوَجُّهُ
u'كَانَ تَوْجِيهٌ':Subject, #1: 1	كَانَ تَوَجُّهُهُ
u'كَانَ تَوْحِيدٌ':Subject, #1: 1	كَانَ تَوْجِيهُ
u'كَانَ تَوْسِيعٌ':Subject, #1: 1	كَانَ تَوْحِيدُ
u'كَانَ تَوْفِيقٌ':Subject, #1: 1	كَانَ التَّوْسِيعُ
u'كَانَ تَوَقُّفٌ':Subject, #2: 2	كَانَ التَّوْفِيقُ
u'كَانَ تَوَقُّفٌ':Subject, #1: 1	كَانَ تَوَقُّفُ
u'كَانَ تَوَقُّفٌ':Subject, #1: 1	كَانَ تَوَقُّفُهُ
u'كَانَ تَوْقِيَةٌ':Subject, #2: 2	كَانَ التَّوَقُّفُ
u'كَانَ تَوْقِيتٌ':Subject, #1: 1	كَانَ تَوْقِيتُهُ
u'كَانَ تَوْقِيت':Subject, #1: 1	كَانَ تَوْقِيتُهُ
u'كَانَ تَوْقِيعٌ':Subject, #4: 4	كَانَ التَّوْقِيتُ
u'كَانَ تَوْقِيفٌ':Subject, #5: 5	كَانَ التَّوْقِيعُ
u'كَانَ تَوْكِيلٌ':Subject, #1: 1	كَانَ التَّوْقِيفُ
u'كَانَ تَوَهُّمٌ':Subject, #31: 31	كَانَ التَّوْكِيلُ
u'كَانَ تَيامُنٌ':Subject, #1: 1	كَانَ تَوَهُّمُ
u'كَانَ تَيسٌ':Subject, #1: 1	كَانَ التَّيَامُنُ
u'كَانَ تَيَمُّمٌ':Subject, #1: 1	كَانَ التَّيْسُ
u'كَانَ تَيَمُّمٌ':Subject, #1: 1	كَانَ تَيَمُّمُهُ
u'كَانَ ثَابِتٌ':Predicate, #3: 3	كَانَ التَّيَمُّمُ
u'كَانَ ثَابِتٌ':Subject, #7: 7	كَانَ ثَابِتَ
u'كَانَ ثَابِتٌ':Subject, #14: 14	كَانَ الثَّابِتُ
u'كَانَ ثَالِثٌ':Predicate, #1: 1	كَانَ ثَابِتُ
u'كَانَ ثَالِثٌ':Predicate, #1: 1	كَانَ الثَّالِثَةَ
u'كَانَ ثَالِثٌ':Subject, #3: 3	كَانَ الثَّالِثَ
u'كَانَ ثَالِثٌ':Subject, #15: 15	كَانَ الثَّالِثُ
u'كَانَ ثَالِثٌ':Subject, #1: 1	كَانَ الثّالِثُ
u'كَانَ ثَالِثٌ':Subject, #1: 1	كَانَ الثَّالِثَةُ
u'كَانَ ثَانِي':Predicate, #2: 2	كَانَ ثَالِثٌ
u'كَانَ ثَانِي':Predicate, #1: 1	كَانَ ثَانِيَ
u'كَانَ ثُبُوتٌ':Subject, #60: 60	كَانَ الثَّانِيَ
u'كَانَ ثُبُوتٌ':Subject, #1: 1	كَانَ الثُّبُوتُ
u'كَانَ ثُبُوتٌ':Subject, #7: 7	كَانَ ثُبُوتُهُ
u'كَانَ ثَدْيٌ':Subject, #8: 8	كَانَ ثُبُوتُ
u'كَانَ ثَغْرٌ':Subject, #1: 1	كَانَ الثَّدْيُ
u'كَانَ ثُفْلٌ':Subject, #2: 2	كَانَ الثَّغْرُ
u'كَانَ ثُقْبٌ':Subject, #1: 1	كَانَ الثُّفْلُ
u'كَانَ ثَقْبٌ':Subject, #1: 1	كَانَ الثُّقْبُ
u'كَانَ ثِقَةٌ':Subject, #2: 2	كَانَ الثَّقْبُ
u'كَانَ ثَقِيلٌ':Subject, #2: 2	كَانَ ثِقَةٌ
u'كَانَ ثَلاثُ':Predicate, #1: 1	كَانَ ثَقِيلُ
u'كَانَ ثَلاثُ':Subject, #1: 1	كَانَ ثَلاَثَ
u'كَانَ ثَلاثَةٌ':Predicate, #2: 2	كَانَ الثَّلَاثُ
u'كَانَ ثَلاثَةٌ':Subject, #13: 13	كَانَ ثَلَاثَةَ
u'كَانَ ثَلاثَةٌ':Subject, #1: 1	كَانَ ثَلاثَةٌ
u'كَانَ ثَلاثَةٌ':Subject, #1: 1	كَانَ ثَلاثَةُ
u'كَانَ ثَلاثَةٌ':Subject, #1: 1	كَانَ ثَلاَثَةٌ
u'كَانَ ثَلاثَةٌ':Subject, #4: 4	كَانَ الثَّلَاثَةُ
u'كَانَ ثَلاثَةٌ':Subject, #4: 4	كَانَ ثَلَاثَةٌ
u'كَانَ ثَلاثُون':Predicate, #4: 4	كَانَ ثَلَاثَةُ
u'كَانَ ثَلاثُون':Predicate, #1: 1	كَانَ ثَلَاثُونَ
u'كَانَ ثُلاثِيٌّ':Subject, #1: 1	كَانَ ثَلاَثُونَ
u'كَانَ ثَلْجٌ':Subject, #1: 1	كَانَ ثُلَاثِيُّهُ
u'كَانَ ثِمارٌ':Subject, #1: 1	كَانَ الثَّلْجُ
u'كَانَ ثَمَرٌ':Subject, #2: 2	كَانَ الثِّمَارُ
u'كَانَ ثَمَرٌ':Subject, #11: 11	كَانَ الثَّمَرُ
u'كَانَ ثَمَرٌ':Subject, #1: 1	كَانَ ثَمَرٌ
u'كَانَ ثَمَنٌ':Predicate, #1: 1	كَانَ ثَمَرُ
u'كَانَ ثَمَنٌ':Subject, #14: 14	كَانَ ثَمَنَ
u'كَانَ ثَمَنٌ':Subject, #11: 11	كَانَ ثَمَنُهُ
u'كَانَ ثَمَنٌ':Subject, #264: 264	كَانَ الثَّمَنُ
u'كَانَ ثَوابٌ':Subject, #35: 35	كَانَ ثَمَنُ
u'كَانَ ثَوابٌ':Subject, #1: 1	كَانَ ثَوَابُ
u'كَانَ ثَوابٌ':Subject, #1: 1	كَانَ ثَوَابُهُ
u'كَانَ ثَوْبٌ':Predicate, #3: 3	كَانَ الثَّوَابُ
u'كَانَ ثَوْبٌ':Subject, #7: 7	كَانَ ثَوْبَ
u'كَانَ ثَوْبٌ':Subject, #1: 1	كَانَ ثَوْبَاهُ
u'كَانَ ثَوْبٌ':Subject, #2: 2	كَانَ ثَوْبُ
u'كَانَ ثَوْبٌ':Subject, #2: 2	كَانَ ثَوْبُهُ
u'كَانَ ثَوْبٌ':Subject, #57: 57	كَانَ الثَّوْبُ
u'كَانَ ثَوْرٌ':Subject, #5: 5	كَانَ ثَوْبٌ
u'كَانَ ثَوْرِيٌّ':Subject, #2: 2	كَانَ الثَّوْرُ
u'كَانَ ثِيابٌ':Subject, #1: 1	كَانَ الثَّوْرِيُّ
u'كَانَ ثِيابٌ':Subject, #1: 1	كَانَ ثِيَابٌ
u'كَانَ جَابِرٌ':Subject, #1: 1	كَانَ ثِيَابُهُ
u'كَانَ جَابِرٌ':Subject, #1: 1	كَانَ جَابِرٌ
u'كَانَ جَارٌ':Predicate, #1: 1	كَانَ جَابِرُ
u'كَانَ جَارٌ':Subject, #1: 1	كَانَ جَارَ
u'كَانَ جَارٌ':Subject, #2: 2	كَانَ الْجَارُ
u'كَانَ جَارِحٌ':Subject, #4: 4	كَانَ جَارُهُ
u'كَانَ جَارِحٌ':Subject, #10: 10	كَانَ الْجَارِحُ
u'كَانَ جَارِحٌ':Subject, #1: 1	كَانَ جَارِحُ
u'كَانَ جَارِي':Predicate, #1: 1	كَانَ جَارِحُهُ
u'كَانَ جَارِي':Subject, #16: 16	كَانَ جَارِيَةً
u'كَانَ جَارِي':Subject, #1: 1	كَانَ الْجَارِيَةُ
u'كَانَ جَارِيَةٌ':Subject, #2: 2	كَانَ جَارِيَةٌ
u'كَانَ جَارِيَةٌ':Subject, #1: 1	كَانَ الْجَارِيَةُ
u'كَانَ جَازٌ':Predicate, #2: 2	كَانَ جَارِيَةٌ
u'كَانَ جَاسُوسٌ':Subject, #2: 2	كَانَ جَازَ
u'كَانَ جالِب':Subject, #1: 1	كَانَ الْجَاسُوسُ
u'كَانَ جَالِسٌ':Subject, #1: 1	كَانَ الْجَالِبُ
u'كَانَ جَامِعٌ':Subject, #1: 1	كَانَ الْجَالِسُ
u'كَانَ جَانِبٌ':Subject, #4: 4	كَانَ الْجَامِعُ
u'كَانَ جَانِبٌ':Subject, #1: 1	كَانَ جَانِبُ
u'كَانَ جَاهٌ':Subject, #3: 3	كَانَ الْجَانِبُ
u'كَانَ جَاهِلٌ':Predicate, #1: 1	كَانَ جَاهُهُ
u'كَانَ جَاهِلٌ':Subject, #1: 1	كَانَ جَاهِلاً
u'كَانَ جَبْرٌ':Subject, #1: 1	كَانَ الْجَاهِلُ
u'كَانَ جَبَلٌ':Subject, #1: 1	كَانَ جَبْرُهُ
u'كَانَ جَبَلٌ':Subject, #1: 1	كَانَ الْجَبَلُ
u'كَانَ جَبْهَةٌ':Predicate, #1: 1	كَانَ جَبَلُ
u'كَانَ جُحُود':Subject, #2: 2	كَانَ الْجَبْهَةَ
u'كَانَ جِدار':Subject, #1: 1	كَانَ الْجُحُودُ
u'كَانَ جِدار':Subject, #1: 1	كَانَ جِدَارُهُ
u'كَانَ جَدْب':Subject, #3: 3	كَانَ الْجِدَارُ
u'كَانَ جَدِيرٌ':Subject, #1: 1	كَانَ الْجَدْبُ
u'كَانَ جُذَاذٌ':Subject, #1: 1	كَانَ الْجَدِيرُ
u'كَانَ جُذَاذٌ':Subject, #1: 1	كَانَ جُذَاذُ
u'كَانَ جَذَعٌ':Subject, #1: 1	كَانَ جُذَاذُهُ
u'كَانَ جِذْعٌ':Subject, #1: 1	كَانَ الْجَذَعُ
u'كَانَ جُذُوعٌ':Subject, #1: 1	كَانَ جِذْعٌ
u'كَانَ جُذُوعٌ':Subject, #1: 1	كَانَ الْجُذُوعُ
u'كَانَ جَرٌّ':Subject, #2: 2	كَانَ جُذُوعُ
u'كَانَ جراح':Subject, #1: 1	كَانَ الْجَرُّ
u'كَانَ جِرَاحٌ':Subject, #1: 1	كَانَ الْجِرَاحُ
u'كَانَ جَرَادٌ':Subject, #1: 1	كَانَ الْجِرَاحُ
u'كَانَ جُرْحٌ':Subject, #1: 1	كَانَ الْجَرَادُ
u'كَانَ جُرْحٌ':Subject, #1: 1	كَانَ جُرْحٌ
u'كَانَ جُرْحٌ':Subject, #25: 25	كَانَ الْجُرْحُ
u'كَانَ جِرْمٌ':Subject, #2: 2	كَانَ جُرْحُهُ
u'كَانَ جُرْمٌ':Subject, #1: 1	كَانَ جِرْمُهُ
u'كَانَ جَرْيٌ':Subject, #2: 2	كَانَ الْجُرْمُ
u'كَانَ جَرَيان':Subject, #1: 1	كَانَ جَرْيُ
u'كَانَ جَرِيحٌ':Subject, #1: 1	كَانَ الْجَرَيَانُ
u'كَانَ جَرِيدٌ':Predicate, #1: 1	كَانَ الْجَرِيحُ
u'كَانَ جَرِيرٌ':Subject, #1: 1	كَانَ جَرِيدَةً
u'كَانَ جُزْءٌ':Subject, #1: 1	كَانَ جَرِيرُ
u'كَانَ جُزْءٌ':Subject, #1: 1	كَانَ جُزْءٌ
u'كَانَ جُزْءٌ':Subject, #1: 1	كَانَ جُزْءُ
u'كَانَ جَزَاءٌ':Predicate, #9: 9	كَانَ الْجُزْءُ
u'كَانَ جَزَاءٌ':Subject, #1: 1	كَانَ جَزَاءَ
u'كَانَ جَزَاءٌ':Subject, #19: 19	كَانَ الْجَزَاءُ
u'كَانَ جَزْم':Subject, #3: 3	كَانَ جَزَاءُ
u'كَانَ جِزْيَةٌ':Subject, #1: 1	كَانَ الْجَزْمُ
u'كَانَ جِسْمٌ':Subject, #1: 1	كَانَ الْجِزْيَةُ
u'كَانَ جُعَلٌ':Subject, #1: 1	كَانَ الْجِسْمُ
u'كَانَ جلد':Predicate, #1: 1	كَانَ الْجُعَلُ
u'كَانَ جِلْدٌ':Predicate, #2: 2	كَانَ جِلْدَ
u'كَانَ جَلْدٌ':Subject, #2: 2	كَانَ جِلْدَ
u'كَانَ جلد':Subject, #1: 1	كَانَ جَلْدٌ
u'كَانَ جَلْدٌ':Subject, #3: 3	كَانَ الْجَلْدُ
u'كَانَ جلد':Subject, #3: 3	كَانَ الْجَلْدُ
u'كَانَ جِلْدٌ':Subject, #4: 4	كَانَ جِلْدُ
u'كَانَ جلد':Subject, #4: 4	كَانَ جِلْدُ
u'كَانَ جِلْدٌ':Subject, #8: 8	كَانَ الْجِلْدُ
u'كَانَ جُلُوسٌ':Subject, #8: 8	كَانَ الْجِلْدُ
u'كَانَ جُلُوسٌ':Subject, #1: 1	كَانَ الْجُلُوسُ
u'كَانَ جَلِيٌّ':Predicate, #6: 6	كَانَ جُلُوسُهُ
u'كَانَ جَلِيلٌ':Predicate, #1: 1	كَانَ جَلِيَّةً
u'كَانَ جماع':Subject, #8: 8	كَانَ جَلِيلَ
u'كَانَ جِمَاعٌ':Subject, #8: 8	كَانَ الْجِمَاعُ
u'كَانَ جَمَاعَةٌ':Subject, #8: 8	كَانَ الْجِمَاعُ
u'كَانَ جَمَّالٌ':Subject, #2: 2	كَانَ جَمَاعَةٌ
u'كَانَ جَمَالٌ':Subject, #1: 1	كَانَ الْجَمَّالُ
u'كَانَ جَمْدٌ':Subject, #2: 2	كَانَ الْجَمَالُ
u'كَانَ جمع':Predicate, #1: 1	كَانَ الْجَمْدُ
u'كَانَ جمع':Predicate, #1: 1	كَانَ جَمَعَ
u'كَانَ جَمْعٌ':Predicate, #6: 6	كَانَ جَمْعَ
u'كَانَ جَمْعٌ':Subject, #6: 6	كَانَ جَمْعَ
u'كَانَ جمع':Subject, #1: 1	كَانَ جَمْعٌ
u'كَانَ جَمْعٌ':Subject, #1: 1	كَانَ جَمْعُهُ
u'كَانَ جمع':Subject, #1: 1	كَانَ جَمْعُهُ
u'كَانَ جَمْعٌ':Subject, #21: 21	كَانَ الْجَمْعُ
u'كَانَ جمع':Subject, #21: 21	كَانَ الْجَمْعُ
u'كَانَ جَمْعٌ':Subject, #2: 2	كَانَ جَمْعُ
u'كَانَ جمعة':Subject, #2: 2	كَانَ جَمْعُ
u'كَانَ جُمُعَةٌ':Subject, #1: 1	كَانَ الْجُمُعَةُ
u'كَانَ جُمْلَةٌ':Subject, #1: 1	كَانَ الْجُمُعَةُ
u'كَانَ جُمْهُورٌ':Subject, #1: 1	كَانَ جُمْلَةٌ
u'كَانَ جُمْهُورٌ':Subject, #2: 2	كَانَ الْجُمْهُورُ
u'كَانَ جَمِيع':Predicate, #2: 2	كَانَ جُمْهُورُ
u'كَانَ جَمِيع':Subject, #1: 1	كَانَ الْجَمِيعَ
u'كَانَ جِنٌّ':Subject, #12: 12	كَانَ الْجَمِيعُ
u'كَانَ جُنَاةٌ':Subject, #2: 2	كَانَ الْجِنُّ
u'كَانَ جناح':Subject, #1: 1	كَانَ الْجُنَاةُ
u'كَانَ جناح':Subject, #1: 1	كَانَ الْجَنَاحُ
u'كَانَ جَنَاحٌ':Subject, #1: 1	كَانَ الْجُنَاحُ
u'كَانَ جُنَاحٌ':Subject, #1: 1	كَانَ الْجَنَاحُ
u'كَانَ جِنَايَةٌ':Subject, #1: 1	كَانَ الْجُنَاحُ
u'كَانَ جُنْحٌ':Subject, #1: 1	كَانَ جِنَايَةُ
u'كَانَ جِنْسٌ':Subject, #1: 1	كَانَ جُنْحُ
u'كَانَ جِنْسٌ':Subject, #19: 19	كَانَ الْجِنْسُ
u'كَانَ جِنْسٌ':Subject, #2: 2	كَانَ جِنْسٌ
u'كَانَ جِنْسٌ':Subject, #2: 2	كَانَ جِنْسُهُ
u'كَانَ جُنُونٌ':Subject, #3: 3	كَانَ جِنْسُ
u'كَانَ جُنُونٌ':Subject, #9: 9	كَانَ الْجُنُونُ
u'كَانَ جَنِينٌ':Subject, #9: 9	كَانَ جُنُونُهُ
u'كَانَ جهاد':Subject, #18: 18	كَانَ الْجَنِينُ
u'كَانَ جِهَادٌ':Subject, #1: 1	كَانَ جِهَادُ
u'كَانَ جهاد':Subject, #1: 1	كَانَ جِهَادُ
u'كَانَ جِهَادٌ':Subject, #7: 7	كَانَ الْجِهَادُ
u'كَانَ جهاز':Subject, #7: 7	كَانَ الْجِهَادُ
u'كَانَ جِهَازٌ':Subject, #1: 1	كَانَ الْجِهَازُ
u'كَانَ جُهَّالٌ':Subject, #1: 1	كَانَ الْجِهَازُ
u'كَانَ جَهْدٌ':Subject, #1: 1	كَانَ الْجُهَّالُ
u'كَانَ جهر':Subject, #1: 1	كَانَ الْجَهْدُ
u'كَانَ جَهْرٌ':Subject, #1: 1	كَانَ الْجَهْرُ
u'كَانَ جَهْلٌ':Subject, #1: 1	كَانَ الْجَهْرُ
u'كَانَ جهل':Subject, #1: 1	كَانَ جَهْلٌ
u'كَانَ جَهْلٌ':Subject, #3: 3	كَانَ الْجَهْلُ
u'كَانَ جَوَابٌ':Subject, #3: 3	كَانَ الْجَهْلُ
u'كَانَ جَوَابٌ':Subject, #3: 3	كَانَ جَوَابُ
u'كَانَ جَوَابٌ':Subject, #54: 54	كَانَ الْجَوَابُ
u'كَانَ جواد':Subject, #7: 7	كَانَ جَوَابُهُ
u'كَانَ جَوَادٌ':Subject, #2: 2	كَانَ الْجَوَادُ
u'كَانَ جَوَازٌ':Subject, #2: 2	كَانَ الْجَوَادُ
u'كَانَ جَوَازٌ':Subject, #5: 5	كَانَ الْجَوَازُ
u'كَانَ جُوَالِقٌ':Subject, #5: 5	كَانَ جَوَازُ
u'كَانَ جود':Subject, #1: 1	كَانَ الْجُوَالِقُ
u'كَانَ جُودٌ':Subject, #1: 1	كَانَ الْجُودُ
u'كَانَ جَوْرٌ':Subject, #1: 1	كَانَ الْجُودُ
u'كَانَ جَوْرَبٌ':Subject, #1: 1	كَانَ جَوْرُهُ
u'كَانَ جَوْزٌ':Subject, #1: 1	كَانَ الْجَوْرَبُ
u'كَانَ جَوْهَرٌ':Subject, #1: 1	كَانَ جَوْزُهُ
u'كَانَ جياد':Subject, #1: 1	كَانَ الْجَوْهَرُ
u'كَانَ جِيَادٌ':Subject, #1: 1	كَانَ الْجِيَادُ
u'كَانَ جَيْبٌ':Subject, #1: 1	كَانَ الْجِيَادُ
u'كَانَ جَيْبٌ':Subject, #1: 1	كَانَ الْجَيْبُ
u'كَانَ جِيرَانٌ':Subject, #2: 2	كَانَ جَيْبُهُ
u'كَانَ جِيرَانٌ':Subject, #1: 1	كَانَ الْجِيرَانُ
u'كَانَ جَيْشٌ':Subject, #1: 1	كَانَ جِيرَانُ
u'كَانَ حاجٌّ':Subject, #3: 3	كَانَ الْجَيْشُ
u'كَانَ حاجِزٌ':Subject, #3: 3	كَانَ الْحَاجُّ
u'كَانَ حادِثٌ':Subject, #1: 1	كَانَ الْحَاجِزُ
u'كَانَ حارِثٌ':Subject, #2: 2	كَانَ الْحَادِثُ
u'كَانَ حارِسٌ':Predicate, #3: 3	كَانَ حَارِثَةُ
u'كَانَ حارِسٌ':Subject, #1: 1	كَانَ حَارِسَ
u'كَانَ حاسِدٌ':Subject, #3: 3	كَانَ الْحَارِسُ
u'كَانَ حاصِلٌ':Subject, #1: 1	كَانَ الْحَاسِدُ
u'كَانَ حاصِلٌ':Subject, #2: 2	كَانَ حَاصِلُ
u'كَانَ حاصِلٌ':Subject, #3: 3	كَانَ الْحَاصِلُ
u'كَانَ حاضِرٌ':Predicate, #4: 4	كَانَ حَاصِلُهُ
u'كَانَ حاضِرٌ':Subject, #2: 2	كَانَ حَاضِرَ
u'كَانَ حاضِنٌ':Predicate, #22: 22	كَانَ الْحَاضِرُ
u'كَانَ حاضِنٌ':Subject, #2: 2	كَانَ حَاضِنَ
u'كَانَ حافِرٌ':Subject, #1: 1	كَانَ الْحَاضِنُ
u'كَانَ حافِظٌ':Subject, #6: 6	كَانَ الْحَافِرُ
u'كَانَ حاكِمٌ':Subject, #4: 4	كَانَ الْحَافِظُ
u'كَانَ حاكِمٌ':Subject, #1: 1	كَانَ حَاكِمٌ
u'كَانَ حالٌ':Predicate, #41: 41	كَانَ الْحَاكِمُ
u'كَانَ حالٌ':Subject, #23: 23	كَانَ حَالَ
u'كَانَ حالٌ':Subject, #10: 10	كَانَ حَالُ
u'كَانَ حالٌ':Subject, #16: 16	كَانَ الْحَالُ
u'كَانَ حالَةٌ':Predicate, #5: 5	كَانَ حَالُهُ
u'كَانَ حالَةٌ':Subject, #4: 4	كَانَ حَالَةَ
u'كَانَ حالِق':Subject, #1: 1	كَانَ حَالَتُهُ
u'كَانَ حامِلٌ':Predicate, #4: 4	كَانَ الْحَالِقُ
u'كَانَ حامِلٌ':Subject, #1: 1	كَانَ حَامِلَ
u'كَانَ حانوتٌ':Subject, #6: 6	كَانَ الْحَامِلُ
u'كَانَ حائِزٌ':Subject, #2: 2	كَانَ الْحَانُوتُ
u'كَانَ حائِطٌ':Subject, #2: 2	كَانَ الْحَائِزُ
u'كَانَ حائِكٌ':Subject, #46: 46	كَانَ الْحَائِطُ
u'كَانَ حائِلٌ':Subject, #2: 2	كَانَ الْحَائِكُ
u'كَانَ حائِلٌ':Subject, #12: 12	كَانَ الْحَائِلُ
u'كَانَ حَبٌّ':Subject, #1: 1	كَانَ حَائِلُهُ
u'كَانَ حُبٌّ':Subject, #3: 3	كَانَ الْحَبُّ
u'كَانَ حَبْسٌ':Subject, #4: 4	كَانَ حُبُّ
u'كَانَ حَبْسٌ':Subject, #14: 14	كَانَ الْحَبْسُ
u'كَانَ حَبَشَة':Subject, #1: 1	كَانَ حَبْسُهُ
u'كَانَ حَبْلٌ':Subject, #1: 1	كَانَ الْحَبَشَةُ
u'كَانَ حَبيبٌ':Predicate, #5: 5	كَانَ الْحَبْلُ
u'كَانَ حَتْفٌ':Subject, #1: 1	كَانَ الْحَبِيبَ
u'كَانَ حَجٌّ':Predicate, #1: 1	كَانَ حَتْفُهُ
u'كَانَ حَجٌّ':Subject, #4: 4	كَانَ حَجَّ
u'كَانَ حَجٌّ':Subject, #19: 19	كَانَ الْحَجُّ
u'كَانَ حَجٌّ':Subject, #1: 1	كَانَ حَجٌّ
u'كَانَ حَجٌّ':Subject, #1: 1	كَانَ حَجُّ
u'كَانَ حَجَّام':Predicate, #4: 4	كَانَ حَجُّهُ
u'كَانَ حُجَّةٌ':Subject, #1: 1	كَانَ حَجّامَ
u'كَانَ حَجَرٌ':Subject, #1: 1	كَانَ الْحُجَّةُ
u'كَانَ حَجْرٌ':Subject, #13: 13	كَانَ الْحَجَرُ
u'كَانَ حَجْرٌ':Subject, #1: 1	كَانَ حَجْرُ
u'كَانَ حَدٌّ':Predicate, #9: 9	كَانَ الْحَجْرُ
u'كَانَ حَدٌّ':Predicate, #1: 1	كَانَ الْحَدَّ
u'كَانَ حَدٌّ':Subject, #1: 1	كَانَ حَدَّ
u'كَانَ حَدٌّ':Subject, #26: 26	كَانَ الْحَدُّ
u'كَانَ حَدٌّ':Subject, #4: 4	كَانَ حَدُّ
u'كَانَ حداد':Subject, #7: 7	كَانَ حَدُّهُ
u'كَانَ حِدادٌ':Subject, #1: 1	كَانَ الْحِدَادُ
u'كَانَ حَدَّادٌ':Subject, #1: 1	كَانَ الْحِدَادُ
u'كَانَ حَدَثٌ':Predicate, #2: 2	كَانَ الْحَدَّادُ
u'كَانَ حَدَثٌ':Subject, #8: 8	كَانَ حَدَثَ
u'كَانَ حَدَثٌ':Subject, #11: 11	كَانَ حَدَثُهُ
u'كَانَ حُدوثٌ':Subject, #12: 12	كَانَ الْحَدَثُ
u'كَانَ حَديثٌ':Predicate, #5: 5	كَانَ حُدُوثُ
u'كَانَ حَديثٌ':Subject, #3: 3	كَانَ حَدِيثَ
u'كَانَ حَديثٌ':Subject, #11: 11	كَانَ حَدِيثُ
u'كَانَ حَديثٌ':Subject, #15: 15	كَانَ الْحَدِيثُ
u'كَانَ حَديثٌ':Subject, #1: 1	كَانَ حَدِيثٌ
u'كَانَ حَديدٌ':Subject, #3: 3	كَانَ حَدِيثُهُ
u'كَانَ حَذَرٌ':Subject, #1: 1	كَانَ الْحَدِيدُ
u'كَانَ حَذْف':Subject, #1: 1	كَانَ الْحَذَرُ
u'كَانَ حُرٌّ':Predicate, #4: 4	كَانَ الْحَذْفُ
u'كَانَ حُرٌّ':Predicate, #11: 11	كَانَ حُرَّ
u'كَانَ حُرٌّ':Subject, #1: 1	كَانَ حُرَّةً
u'كَانَ حَرٌّ':Subject, #1: 1	كَانَ حُرٌّ
u'كَانَ حُرٌّ':Subject, #4: 4	كَانَ الْحَرُّ
u'كَانَ حَرامٌ':Predicate, #9: 9	كَانَ الْحُرُّ
u'كَانَ حَرامٌ':Subject, #2: 2	كَانَ حَرَامَ
u'كَانَ حَرْبٌ':Subject, #3: 3	كَانَ الْحَرَامُ
u'كَانَ حَرْبٌ':Subject, #1: 1	كَانَ الْحَرْبُ
u'كَانَ حَرْبٌ':Subject, #1: 1	كَانَ حَرْبٌ
u'كَانَ حَرْثٌ':Subject, #1: 1	كَانَ حَرْبُ
u'كَانَ حَرَجٌ':Subject, #1: 1	كَانَ الْحَرْثُ
u'كَانَ حِرْزٌ':Predicate, #4: 4	كَانَ الْحَرَجُ
u'كَانَ حِرْزٌ':Subject, #2: 2	كَانَ حِرْزَ
u'كَانَ حِرْزٌ':Subject, #1: 1	كَانَ الْحِرْزُ
u'كَانَ حَرَض':Subject, #2: 2	كَانَ حِرْزُ
u'كَانَ حَرْفٌ':Predicate, #1: 1	كَانَ الْحَرَضُ
u'كَانَ حَرْفٌ':Subject, #2: 2	كَانَ حَرْفَ
u'كَانَ حَرْفٌ':Subject, #1: 1	كَانَ الْحَرْفُ
u'كَانَ حَرَقٌ':Subject, #5: 5	كَانَ حَرْفُ
u'كَانَ حَرَمٌ':Subject, #1: 1	كَانَ حَرَقُ
u'كَانَ حُرْمَةٌ':Subject, #1: 1	كَانَ حَرَمُ
u'كَانَ حُرْمَةٌ':Subject, #1: 1	كَانَ الْحُرْمَةُ
u'كَانَ حَرِيرٌ':Subject, #2: 2	كَانَ حُرْمَةُ
u'كَانَ حَرِيمٌ':Predicate, #1: 1	كَانَ الْحَرِيرُ
u'كَانَ حَرِيمٌ':Subject, #1: 1	كَانَ حَرِيمَ
u'كَانَ حَرِيمٌ':Subject, #1: 1	كَانَ حَرِيمُهُ
u'كَانَ حُزْنٌ':Subject, #3: 3	كَانَ الْحَرِيمُ
u'كَانَ حِسٌّ':Predicate, #1: 1	كَانَ الْحُزْنُ
u'كَانَ حِسٌّ':Subject, #5: 5	كَانَ حِسَّ
u'كَانَ حساب':Predicate, #1: 1	كَانَ الْحِسُّ
u'كَانَ حِسَابٌ':Predicate, #1: 1	كَانَ حِسَابَ
u'كَانَ حساب':Subject, #1: 1	كَانَ حِسَابَ
u'كَانَ حِسَابٌ':Subject, #1: 1	كَانَ الْحِسَابُ
u'كَانَ حسد':Subject, #1: 1	كَانَ الْحِسَابُ
u'كَانَ حَسَدٌ':Subject, #2: 2	كَانَ الْحَسَدُ
u'كَانَ حَسَنٌ':Predicate, #2: 2	كَانَ الْحَسَدُ
u'كَانَ حَسَنٌ':Subject, #7: 7	كَانَ حَسَنَ
u'كَانَ حَسَنٌ':Subject, #18: 18	كَانَ الْحَسَنُ
u'كَانَ حُسْنٌ':Subject, #1: 1	كَانَ حَسَنُ
u'كَانَ حُسْنٌ':Subject, #1: 1	كَانَ حُسْنُ
u'كَانَ حِسِّيٌّ':Subject, #2: 2	كَانَ حُسْنُهُ
u'كَانَ حَشْوٌ':Subject, #1: 1	كَانَ الْحِسِّيُّ
u'كَانَ حَشِيشٌ':Subject, #1: 1	كَانَ حَشْوُهُ
u'كَانَ حِصَّةٌ':Subject, #1: 1	كَانَ الْحَشِيشُ
u'كَانَ حِصَّةٌ':Subject, #2: 2	كَانَ حِصَّتُهُ
u'كَانَ حَصْرٌ':Subject, #3: 3	كَانَ حِصَّةُ
u'كَانَ حَصْرٌ':Subject, #2: 2	كَانَ الْحَصْرُ
u'كَانَ حَصَلٌ':Predicate, #2: 2	كَانَ حَصْرُهُ
u'كَانَ حِصْنٌ':Subject, #9: 9	كَانَ حَصَلَ
u'كَانَ حِصْنٌ':Subject, #3: 3	كَانَ الْحِصْنُ
u'كَانَ حُصُول':Subject, #4: 4	كَانَ حِصْنٌ
u'كَانَ حُصُول':Subject, #2: 2	كَانَ حُصُولُهُ
u'كَانَ حَصِيرٌ':Subject, #6: 6	كَانَ حُصُولُ
u'كَانَ حَضَرٌ':Predicate, #2: 2	كَانَ الْحَصِيرُ
u'كَانَ حُضورٌ':Subject, #2: 2	كَانَ حَضَرَ
u'كَانَ حُضُورٌ':Subject, #1: 1	كَانَ الْحُضُورُ
u'كَانَ حُضورٌ':Subject, #1: 1	كَانَ الْحُضُورُ
u'كَانَ حُضُورٌ':Subject, #2: 2	كَانَ حُضُورُ
u'كَانَ حَطّ':Subject, #2: 2	كَانَ حُضُورُ
u'كَانَ حَطَّابٌ':Subject, #3: 3	كَانَ الْحَطُّ
u'كَانَ حَطَبٌ':Subject, #1: 1	كَانَ الْحَطَّابُ
u'كَانَ حَطِيم':Subject, #2: 2	كَانَ الْحَطَبُ
u'كَانَ حَظٌّ':Subject, #3: 3	كَانَ الْحَطِيمُ
u'كَانَ حَظٌّ':Subject, #3: 3	كَانَ حَظُّهُ
u'كَانَ حَظْر':Subject, #8: 8	كَانَ الْحَظُّ
u'كَانَ حَفْرٌ':Subject, #6: 6	كَانَ الْحَظْرُ
u'كَانَ حِفْظٌ':Subject, #9: 9	كَانَ الْحَفْرُ
u'كَانَ حَفِيدٌ':Subject, #3: 3	كَانَ الْحِفْظُ
u'كَانَ حَقٌّ':Predicate, #1: 1	كَانَ حَفِيدُهُ
u'كَانَ حَقٌّ':Subject, #7: 7	كَانَ حَقَّ
u'كَانَ حَقٌّ':Subject, #17: 17	كَانَ حَقُّهُ
u'كَانَ حَقٌّ':Subject, #1: 1	كَانَ حَقٌّ
u'كَانَ حَقٌّ':Subject, #30: 30	كَانَ حَقُّ
u'كَانَ حُقوقٌ':Subject, #47: 47	كَانَ الْحَقُّ
u'كَانَ حُقُوقٌ':Subject, #1: 1	كَانَ حُقُوقُ
u'كَانَ حَقِيقٌ':Predicate, #1: 1	كَانَ حُقُوقُ
u'كَانَ حَقِيقٌ':Subject, #2: 2	كَانَ حَقِيقَةَ
u'كَانَ حَقِيقٌ':Subject, #1: 1	كَانَ الْحَقِيقَةُ
u'كَانَ حَقِيقٌ':Subject, #1: 1	كَانَ حَقِيقَتُهُ
u'كَانَ حَقِيقَةٌ':Predicate, #2: 2	كَانَ حَقِيقَةُ
u'كَانَ حَقِيقَةٌ':Subject, #2: 2	كَانَ حَقِيقَةَ
u'كَانَ حَقِيقَةٌ':Subject, #1: 1	كَانَ الْحَقِيقَةُ
u'كَانَ حَقِيقَةٌ':Subject, #1: 1	كَانَ حَقِيقَتُهُ
u'كَانَ حَقِيقِيٌّ':Subject, #2: 2	كَانَ حَقِيقَةُ
u'كَانَ حُكَّامٌ':Subject, #1: 1	كَانَ الْحَقِيقِيُّ
u'كَانَ حُكْمٌ':Predicate, #1: 1	كَانَ الْحُكَّامُ
u'كَانَ حَكَمٌ':Predicate, #2: 2	كَانَ حُكْمَ
u'كَانَ حُكْمٌ':Subject, #7: 7	كَانَ حَكَمَ
u'كَانَ حَكَمٌ':Subject, #194: 194	كَانَ الْحُكْمُ
u'كَانَ حُكْمٌ':Subject, #3: 3	كَانَ الْحَكَمُ
u'كَانَ حُكْمٌ':Subject, #40: 40	كَانَ حُكْمُ
u'كَانَ حكمة':Subject, #51: 51	كَانَ حُكْمُهُ
u'كَانَ حِكْمَةٌ':Subject, #1: 1	كَانَ الْحِكْمَةُ
u'كَانَ حَكِيمٌ':Subject, #1: 1	كَانَ الْحِكْمَةُ
u'كَانَ حَكِيمٌ':Subject, #1: 1	كَانَ الْحَكِيمُ
u'كَانَ حَلٌّ':Predicate, #2: 2	كَانَ حَكِيمُ
u'كَانَ حَلٌّ':Subject, #4: 4	كَانَ حَلَّ
u'كَانَ حَلٌّ':Subject, #1: 1	كَانَ حَلُّ
u'كَانَ حِلٌّ':Subject, #2: 2	كَانَ الْحَلُّ
u'كَانَ حِلٌّ':Subject, #3: 3	كَانَ حِلُّ
u'كَانَ حَلالٌ':Predicate, #4: 4	كَانَ الْحِلُّ
u'كَانَ حَلالٌ':Predicate, #1: 1	كَانَ حَلَالَ
u'كَانَ حَلالٌ':Subject, #5: 5	كَانَ حَلاَلاً
u'كَانَ حَلَقٌ':Predicate, #4: 4	كَانَ الْحَلَالُ
u'كَانَ حَلْقٌ':Subject, #2: 2	كَانَ حَلَقَ
u'كَانَ حَلْقٌ':Subject, #1: 1	كَانَ حَلْقُ
u'كَانَ حِلْمٌ':Subject, #7: 7	كَانَ الْحَلْقُ
u'كَانَ حُلُولٌ':Subject, #2: 2	كَانَ الْحِلْمُ
u'كَانَ حُلِيٌّ':Subject, #1: 1	كَانَ الْحُلُولُ
u'كَانَ حَلِيبٌ':Subject, #6: 6	كَانَ الْحُلِيُّ
u'كَانَ حِلْيَةٌ':Subject, #2: 2	كَانَ الْحَلِيبُ
u'كَانَ حِمَارٌ':Subject, #2: 2	كَانَ حِلْيَةُ
u'كَانَ حَمَّالٌ':Subject, #4: 4	كَانَ الْحِمَارُ
u'كَانَ حَمَّامٌ':Subject, #2: 2	كَانَ الْحَمَّالُ
u'كَانَ حَمْدٌ':Subject, #2: 2	كَانَ حَمَّامٌ
u'كَانَ حَمْز':Subject, #3: 3	كَانَ الْحَمْدُ
u'كَانَ حَمَلٌ':Predicate, #3: 3	كَانَ حَمْزَةُ
u'كَانَ حَمْلٌ':Subject, #2: 2	كَانَ حَمَلَ
u'كَانَ حَمْلٌ':Subject, #10: 10	كَانَ حَمْلُهُ
u'كَانَ حَمْلٌ':Subject, #1: 1	كَانَ حَمْلٌ
u'كَانَ حَمْلٌ':Subject, #1: 1	كَانَ حَمْلُ
u'كَانَ حِنَّاءٌ':Subject, #39: 39	كَانَ الْحَمْلُ
u'كَانَ حِنْثٌ':Subject, #2: 2	كَانَ الْحِنَّاءُ
u'كَانَ حِنْثٌ':Subject, #1: 1	كَانَ حِنْثُهُ
u'كَانَ حنق':Predicate, #5: 5	كَانَ الْحِنْثُ
u'كَانَ حَنَقٌ':Predicate, #1: 1	كَانَ حَنَقَ
u'كَانَ حَوائِجُ':Subject, #1: 1	كَانَ حَنَقَ
u'كَانَ حُوتٌ':Subject, #1: 1	كَانَ حَوَائِجُ
u'كَانَ حَوْزٌ':Subject, #1: 1	كَانَ الْحُوتُ
u'كَانَ حَوْضٌ':Subject, #1: 1	كَانَ الْحَوْزُ
u'كَانَ حَوْضٌ':Subject, #10: 10	كَانَ الْحَوْضُ
u'كَانَ حول':Predicate, #1: 1	كَانَ حَوْضٌ
u'كَانَ حَوْلٌ':Predicate, #7: 7	كَانَ حَوْلَ
u'كَانَ حول':Subject, #7: 7	كَانَ حَوْلَ
u'كَانَ حول':Subject, #1: 1	كَانَ الْحَوَلُ
u'كَانَ حَوَلٌ':Subject, #1: 1	كَانَ الْحَوْلُ
u'كَانَ حَوْلٌ':Subject, #1: 1	كَانَ الْحَوَلُ
u'كَانَ حول':Subject, #1: 1	كَانَ الْحَوْلُ
u'كَانَ حول':Subject, #1: 1	كَانَ حَوْلٌ
u'كَانَ حَوْلٌ':Subject, #1: 1	كَانَ حَوْلُ
u'كَانَ حَوْلٌ':Subject, #1: 1	كَانَ حَوْلٌ
u'كَانَ حَوْلاَء':Predicate, #1: 1	كَانَ حَوْلُ
u'كَانَ حَيٌّ':Subject, #1: 1	كَانَ حَوْلَاءَ
u'كَانَ حَيٌّ':Subject, #1: 1	كَانَ حَيٌّ
u'كَانَ حَيَاءٌ':Subject, #5: 5	كَانَ الْحَيُّ
u'كَانَ حَيَاةٌ':Predicate, #2: 2	كَانَ الْحَيَاءُ
u'كَانَ حِيازَة':Predicate, #1: 1	كَانَ حَيَاةَ
u'كَانَ حَيِّزٌ':Subject, #1: 1	كَانَ حِيَازَةَ
u'كَانَ حَيْضٌ':Subject, #1: 1	كَانَ حَيِّزُ
u'كَانَ حِيلَةٌ':Subject, #4: 4	كَانَ الْحَيْضُ
u'كَانَ حَيَوَانٌ':Subject, #2: 2	كَانَ حِيلَةٌ
u'كَانَ خَادِمٌ':Predicate, #15: 15	كَانَ الْحَيَوَانُ
u'كَانَ خَادِمٌ':Subject, #1: 1	كَانَ خَادِمَ
u'كَانَ خَارِجٌ':Predicate, #9: 9	كَانَ الْخَادِمُ
u'كَانَ خَارِجٌ':Subject, #44: 44	كَانَ خَارِجَ
u'كَانَ خَارِجٌ':Subject, #1: 1	كَانَ خَارِجٌ
u'كَانَ خَارِجٌ':Subject, #1: 1	كَانَ خَارِجُ
u'كَانَ خَارِجٌ':Subject, #1: 1	كَانَ خَارِجُهُ
u'كَانَ خاصّ':Subject, #51: 51	كَانَ الْخَارِجُ
u'كَانَ خَاطِبٌ':Subject, #5: 5	كَانَ الْخَاصُّ
u'كَانَ خَاطِئٌ':Subject, #5: 5	كَانَ الْخَاطِبُ
u'كَانَ خَالٌ':Subject, #1: 1	كَانَ الْخَاطِئُ
u'كَانَ خَالِدٌ':Subject, #1: 1	كَانَ خَالٌ
u'كَانَ خَالِصٌ':Subject, #3: 3	كَانَ خَالِدُ
u'كَانَ خَالِقٌ':Subject, #1: 1	كَانَ الْخَالِصُ
u'كَانَ خامس':Predicate, #1: 1	كَانَ الْخَالِقُ
u'كَانَ خَامِسٌ':Predicate, #1: 1	كَانَ الْخَامِسَ
u'كَانَ خامس':Subject, #1: 1	كَانَ الْخَامِسَ
u'كَانَ خَامِسٌ':Subject, #1: 1	كَانَ الْخَامِسُ
u'كَانَ خِبَاءٌ':Subject, #1: 1	كَانَ الْخَامِسُ
u'كَانَ خَبَّازٌ':Subject, #2: 2	كَانَ الْخِبَاءُ
u'كَانَ خُبْثٌ':Subject, #2: 2	كَانَ الْخَبَّازُ
u'كَانَ خَبَرٌ':Predicate, #1: 1	كَانَ الْخُبْثُ
u'كَانَ خَبَر':Predicate, #2: 2	كَانَ خَبَرَ
u'كَانَ خَبَرٌ':Subject, #2: 2	كَانَ خَبَرَ
u'كَانَ خَبَر':Subject, #1: 1	كَانَ خَبَرٌ
u'كَانَ خَبَرٌ':Subject, #1: 1	كَانَ خَبَرٌ
u'كَانَ خَبَر':Subject, #1: 1	كَانَ خَبَرُهُ
u'كَانَ خَبَرٌ':Subject, #1: 1	كَانَ خَبَرُهُ
u'كَانَ خَبَر':Subject, #25: 25	كَانَ الْخَبَرُ
u'كَانَ خَبَرٌ':Subject, #25: 25	كَانَ الْخَبَرُ
u'كَانَ خَبَر':Subject, #3: 3	كَانَ خَبَرُ
u'كَانَ خُبْزٌ':Predicate, #3: 3	كَانَ خَبَرُ
u'كَانَ خُبْزٌ':Subject, #1: 1	كَانَ خُبْزَ
u'كَانَ خُبْزٌ':Subject, #3: 3	كَانَ خُبْزُ
u'كَانَ خَبِيث':Subject, #9: 9	كَانَ الْخُبْزُ
u'كَانَ ختان':Subject, #1: 1	كَانَ الْخَبِيثُ
u'كَانَ خِتَانٌ':Subject, #1: 1	كَانَ الْخِتَانُ
u'كَانَ خَتْمٌ':Subject, #1: 1	كَانَ الْخِتَانُ
u'كَانَ خَتْمٌ':Subject, #1: 1	كَانَ الْخَتْمُ
u'كَانَ خَتَنٌ':Subject, #5: 5	كَانَ خَتْمُ
u'كَانَ خدم':Subject, #1: 1	كَانَ الْخَتَنُ
u'كَانَ خَدَمٌ':Subject, #1: 1	كَانَ الْخَدَمُ
u'كَانَ خدمة':Subject, #1: 1	كَانَ الْخَدَمُ
u'كَانَ خِدْمَةٌ':Subject, #2: 2	كَانَ الْخِدْمَةُ
u'كَانَ خَرَابٌ':Subject, #2: 2	كَانَ الْخِدْمَةُ
u'كَانَ خراج':Predicate, #1: 1	كَانَ خَرَابُ
u'كَانَ خُرَاجٌ':Predicate, #1: 1	كَانَ خُرَاجَ
u'كَانَ خراج':Predicate, #1: 1	كَانَ خُرَاجَ
u'كَانَ خَرَاجٌ':Predicate, #9: 9	كَانَ خَرَاجَ
u'كَانَ خراج':Subject, #9: 9	كَانَ خَرَاجَ
u'كَانَ خَرَاجٌ':Subject, #14: 14	كَانَ الْخَرَاجُ
u'كَانَ خراج':Subject, #14: 14	كَانَ الْخَرَاجُ
u'كَانَ خَرَاجٌ':Subject, #9: 9	كَانَ خَرَاجُ
u'كَانَ خرس':Subject, #9: 9	كَانَ خَرَاجُ
u'كَانَ خرق':Subject, #1: 1	كَانَ خَرَسُهُ
u'كَانَ خَرْقٌ':Subject, #1: 1	كَانَ خَرْقُهُ
u'كَانَ خرق':Subject, #1: 1	كَانَ خَرْقُهُ
u'كَانَ خَرْقٌ':Subject, #23: 23	كَانَ الْخَرْقُ
u'كَانَ خُرُوجٌ':Subject, #23: 23	كَانَ الْخَرْقُ
u'كَانَ خُرُوجٌ':Subject, #14: 14	كَانَ الْخُرُوجُ
u'كَانَ خُرُوجٌ':Subject, #20: 20	كَانَ خُرُوجُهُ
u'كَانَ خَزَفٌ':Subject, #3: 3	كَانَ خُرُوجُ
u'كَانَ خَشْيَةٌ':Predicate, #1: 1	كَانَ الْخَزَفُ
u'كَانَ خِصاء':Subject, #1: 1	كَانَ خَشْيَةَ
u'كَانَ خِصْبٌ':Predicate, #2: 2	كَانَ الْخِصَاءُ
u'كَانَ خِصْبٌ':Subject, #1: 1	كَانَ خِصْبَ
u'كَانَ خَصْمٌ':Subject, #1: 1	كَانَ الْخِصْبُ
u'كَانَ خَصْمٌ':Subject, #31: 31	كَانَ الْخَصْمُ
u'كَانَ خَطٌّ':Subject, #3: 3	كَانَ خَصْمُهُ
u'كَانَ خَطٌّ':Subject, #1: 1	كَانَ خَطُّهُ
u'كَانَ خَطٌّ':Subject, #2: 2	كَانَ خَطٌّ
u'كَانَ خَطٌّ':Subject, #2: 2	كَانَ خَطُّ
u'كَانَ خَطَأٌ':Subject, #9: 9	كَانَ الْخَطُّ
u'كَانَ خَطَأٌ':Subject, #2: 2	كَانَ خَطَأٌ
u'كَانَ خِطَابٌ':Subject, #5: 5	كَانَ الْخَطَأُ
u'كَانَ خِطَابٌ':Subject, #10: 10	كَانَ الْخِطَابُ
u'كَانَ خِطَابٌ':Subject, #1: 1	كَانَ خِطَابُ
u'كَانَ خطر':Subject, #1: 1	كَانَ خِطَابُهُ
u'كَانَ خَطَرٌ':Subject, #5: 5	كَانَ الْخَطَرُ
u'كَانَ خَطِيبٌ':Subject, #5: 5	كَانَ الْخَطَرُ
u'كَانَ خَطِيَّةٌ':Subject, #5: 5	كَانَ الْخَطِيبُ
u'كَانَ خُفٌّ':Predicate, #1: 1	كَانَ خَطِيَّةُ
u'كَانَ خُفٌّ':Subject, #1: 1	كَانَ الْخُفَّ
u'كَانَ خُفٌّ':Subject, #14: 14	كَانَ الْخُفُّ
u'كَانَ خفاف':Subject, #1: 1	كَانَ خُفَّاهُ
u'كَانَ خَفِيٌّ':Subject, #1: 1	كَانَ خُفَافُ
u'كَانَ خَفِيفٌ':Predicate, #1: 1	كَانَ الْخَفِيُّ
u'كَانَ خَلاَءٌ':Subject, #2: 2	كَانَ خَفِيفَ
u'كَانَ خِلاَفٌ':Predicate, #2: 2	كَانَ الْخَلَاءُ
u'كَانَ خِلاَفٌ':Subject, #36: 36	كَانَ خِلَافَ
u'كَانَ خِلاَفٌ':Subject, #23: 23	كَانَ الْخِلَافُ
u'كَانَ خِلاَفٌ':Subject, #3: 3	كَانَ خِلَافُ
u'كَانَ خلط':Predicate, #4: 4	كَانَ خِلَافُهُ
u'كَانَ خلط':Subject, #2: 2	كَانَ خَلَطَ
u'كَانَ خلط':Subject, #1: 1	كَانَ الْخَلْطُ
u'كَانَ خُلْعٌ':Subject, #2: 2	كَانَ خَلْطُ
u'كَانَ خُلْعٌ':Subject, #11: 11	كَانَ الْخُلْعُ
u'كَانَ خَلْفٌ':Predicate, #1: 1	كَانَ خُلْعُ
u'كَانَ خَلَفٌ':Subject, #12: 12	كَانَ خَلْفَ
u'كَانَ خُلَفَاءُ':Subject, #1: 1	كَانَ الْخَلَفُ
u'كَانَ خلق':Predicate, #1: 1	كَانَ الْخُلَفَاءُ
u'كَانَ خلق':Subject, #1: 1	كَانَ خُلِقَ
u'كَانَ خَلْقٌ':Subject, #1: 1	كَانَ خَلْقُ
u'كَانَ خلق':Subject, #1: 1	كَانَ خَلْقُ
u'كَانَ خَلْقٌ':Subject, #2: 2	كَانَ الْخَلْقُ
u'كَانَ خُلُقٌ':Subject, #2: 2	كَانَ الْخَلْقُ
u'كَانَ خُلُق':Subject, #2: 2	كَانَ خُلُقٌ
u'كَانَ خلق':Subject, #2: 2	كَانَ خُلُقٌ
u'كَانَ خَلْقٌ':Subject, #2: 2	كَانَ خَلْقُهُ
u'كَانَ خلق':Subject, #2: 2	كَانَ خَلْقُهُ
u'كَانَ خُلُقٌ':Subject, #3: 3	كَانَ خُلُقُهُ
u'كَانَ خُلُق':Subject, #3: 3	كَانَ خُلُقُهُ
u'كَانَ خَلِيطٌ':Predicate, #3: 3	كَانَ خُلُقُهُ
u'كَانَ خَلِيطٌ':Subject, #2: 2	كَانَ خَلِيطَ
u'كَانَ خَلِيطٌ':Subject, #1: 1	كَانَ الْخَلِيطُ
u'كَانَ خَلِيفَةٌ':Predicate, #1: 1	كَانَ خَلِيطُهُ
u'كَانَ خَلِيفَةٌ':Predicate, #1: 1	كَانَ الْخَلِيفَةَ
u'كَانَ خَلِيفَةٌ':Subject, #3: 3	كَانَ خَلِيفَةَ
u'كَانَ خَلِيلٌ':Subject, #12: 12	كَانَ الْخَلِيفَةُ
u'كَانَ خِمَارٌ':Subject, #2: 2	كَانَ الْخَلِيلُ
u'كَانَ خَمْرٌ':Subject, #2: 2	كَانَ الْخِمَارُ
u'كَانَ خَمْسٌ':Predicate, #14: 14	كَانَ الْخَمْرُ
u'كَانَ خُمُسٌ':Subject, #2: 2	كَانَ خَمْسَ
u'كَانَ خُمْسٌ':Subject, #1: 1	كَانَ الْخُمُسُ
u'كَانَ خَمْسَةٌ':Predicate, #1: 1	كَانَ خُمْسُ
u'كَانَ خَمْسَةٌ':Subject, #9: 9	كَانَ خَمْسَةَ
u'كَانَ خَمْسَةٌ':Subject, #2: 2	كَانَ خَمْسَةٌ
u'كَانَ خَنْدَقٌ':Subject, #3: 3	كَانَ خَمْسَةُ
u'كَانَ خِنْزِيرٌ':Subject, #1: 1	كَانَ الْخَنْدَقُ
u'كَانَ خِنْصَرٌ':Subject, #4: 4	كَانَ الْخِنْزِيرُ
u'كَانَ خَنْقٌ':Subject, #2: 2	كَانَ الْخِنْصَرُ
u'كَانَ خَوْفٌ':Predicate, #1: 1	كَانَ خَنْقُهُ
u'كَانَ خَوْفٌ':Subject, #1: 1	كَانَ خَوْفَ
u'كَانَ خَوْفٌ':Subject, #16: 16	كَانَ الْخَوْفُ
u'كَانَ خَوْفٌ':Subject, #1: 1	كَانَ خَوْفُ
u'كَانَ خَوْفٌ':Subject, #2: 2	كَانَ خَوْفُهُ
u'كَانَ خيار':Predicate, #3: 3	كَانَ خَوْفٌ
u'كَانَ خِيَارٌ':Predicate, #4: 4	كَانَ خِيَارَ
u'كَانَ خيار':Subject, #4: 4	كَانَ خِيَارَ
u'كَانَ خِيَارٌ':Subject, #1: 1	كَانَ خِيَارُهُ
u'كَانَ خيار':Subject, #1: 1	كَانَ خِيَارُهُ
u'كَانَ خِيَارٌ':Subject, #267: 267	كَانَ الْخِيَارُ
u'كَانَ خيار':Subject, #267: 267	كَانَ الْخِيَارُ
u'كَانَ خِيَارٌ':Subject, #4: 4	كَانَ خِيَارُ
u'كَانَ خَيَّاطٌ':Subject, #4: 4	كَانَ خِيَارُ
u'كَانَ خَيْرٌ':Predicate, #8: 8	كَانَ الْخَيَّاطُ
u'كَانَ خَيْرٌ':Subject, #2: 2	كَانَ خَيْرَ
u'كَانَ خَيْرٌ':Subject, #1: 1	كَانَ خَيْرُهُ
u'كَانَ خَيْرٌ':Subject, #2: 2	كَانَ الْخَيْرُ
u'كَانَ خِيرَةٌ':Subject, #2: 2	كَانَ خَيْرُ
u'كَانَ دَاءٌ':Predicate, #1: 1	كَانَ الْخِيَرَةُ
u'كَانَ دَاءٌ':Subject, #1: 1	كَانَ دَاءَ
u'كَانَ دَأْبٌ':Subject, #1: 1	كَانَ دَاءُ
u'كَانَ دَأْبٌ':Subject, #1: 1	كَانَ دَأْبهُ
u'كَانَ دَابَّةٌ':Subject, #2: 2	كَانَ دَأْبُهُ
u'كَانَ دَاخِلٌ':Predicate, #1: 1	كَانَ دَابَّةٌ
u'كَانَ دَاخِلٌ':Subject, #30: 30	كَانَ دَاخِلَ
u'كَانَ دَاخِلٌ':Subject, #11: 11	كَانَ الدَّاخِلُ
u'كَانَ دَارٌ':Subject, #1: 1	كَانَ دَاخِلُ
u'كَانَ دَارٌ':Subject, #2: 2	كَانَ دَارٌ
u'كَانَ دَاعِي':Predicate, #7: 7	كَانَ الدَّارُ
u'كَانَ دَاعِي':Predicate, #2: 2	كَانَ دَاعِيَةَ
u'كَانَ دَافِعٌ':Subject, #4: 4	كَانَ دَاعِيَةً
u'كَانَ دَافِعٌ':Subject, #12: 12	كَانَ الدَّافِعُ
u'كَانَ دَافِعٌ':Subject, #1: 1	كَانَ دَافِعُ
u'كَانَ دَائِنٌ':Subject, #2: 2	كَانَ دَافِعُهُ
u'كَانَ دِبَاغٌ':Subject, #3: 3	كَانَ الدَّائِنُ
u'كَانَ دِبْسٌ':Subject, #2: 2	كَانَ الدِّبَاغُ
u'كَانَ دُخَانٌ':Subject, #1: 1	كَانَ الدِّبْسُ
u'كَانَ دُخَانٌ':Subject, #1: 1	كَانَ الدُّخَانُ
u'كَانَ دُخَانٌ':Subject, #1: 1	كَانَ دُخَانُ
u'كَانَ دَخَلٌ':Predicate, #1: 1	كَانَ دُخَانُهُ
u'كَانَ دَخْلٌ':Subject, #112: 112	كَانَ دَخَلَ
u'كَانَ دُخُولٌ':Subject, #2: 2	كَانَ دَخْلُهُ
u'كَانَ دُخُولٌ':Subject, #10: 10	كَانَ دُخُولُهُ
u'كَانَ دُخُولٌ':Subject, #12: 12	كَانَ الدُّخُولُ
u'كَانَ دُخُولٌ':Subject, #1: 1	كَانَ دُخُولٌ
u'كَانَ دَرَاهِمُ':Predicate, #4: 4	كَانَ دُخُولُ
u'كَانَ دَرْبٌ':Subject, #9: 9	كَانَ دَرَاهِمَ
u'كَانَ دَرْبٌ':Subject, #1: 1	كَانَ الدَّرْبُ
u'كَانَ دَرَجٌ':Subject, #1: 1	كَانَ دَرْبٌ
u'كَانَ دَرَجَ':Subject, #1: 1	كَانَ دَرَجٌ
u'كَانَ دِرْهَمٌ':Subject, #1: 1	كَانَ دَرَجٌ
u'كَانَ دِرْهَم':Subject, #5: 5	كَانَ الدِّرْهَمُ
u'كَانَ دُعَاءٌ':Subject, #5: 5	كَانَ الدِّرْهَمُ
u'كَانَ دفع':Predicate, #6: 6	كَانَ الدُّعَاءُ
u'كَانَ دفع':Subject, #41: 41	كَانَ دَفَعَ
u'كَانَ دَفْعٌ':Subject, #23: 23	كَانَ الدَّفْعُ
u'كَانَ دفع':Subject, #23: 23	كَانَ الدَّفْعُ
u'كَانَ دَفْعٌ':Subject, #2: 2	كَانَ دَفْعُ
u'كَانَ دفع':Subject, #2: 2	كَانَ دَفْعُ
u'كَانَ دَفْعٌ':Subject, #2: 2	كَانَ دَفْعُهُ
u'كَانَ دفن':Predicate, #2: 2	كَانَ دَفْعُهُ
u'كَانَ دفن':Subject, #1: 1	كَانَ دُفِنَ
u'كَانَ دَفْنٌ':Subject, #1: 1	كَانَ الدَّفْنُ
u'كَانَ دفن':Subject, #1: 1	كَانَ الدَّفْنُ
u'كَانَ دَفْنٌ':Subject, #2: 2	كَانَ دَفْنُهُ
u'كَانَ دَقيقٌ':Subject, #2: 2	كَانَ دَفْنُهُ
u'كَانَ دُكَّانٌ':Subject, #1: 1	كَانَ الدَّقِيقُ
u'كَانَ دَلالَةٌ':Subject, #2: 2	كَانَ الدُّكَّانُ
u'كَانَ دَلالَةٌ':Subject, #1: 1	كَانَ دَلَالَةُ
u'كَانَ دلك':Subject, #2: 2	كَانَ دَلَالَتُهُ
u'كَانَ دَلْكٌ':Subject, #2: 2	كَانَ الدَّلْكُ
u'كَانَ دَلْوٌ':Subject, #2: 2	كَانَ الدَّلْكُ
u'كَانَ دَلْوٌ':Subject, #1: 1	كَانَ دَلْوُهُ
u'كَانَ دَليلٌ':Predicate, #2: 2	كَانَ الدَّلْوُ
u'كَانَ دَليلٌ':Subject, #6: 6	كَانَ دَلِيلَ
u'كَانَ دَليلٌ':Subject, #11: 11	كَانَ دَلِيلُ
u'كَانَ دَليلٌ':Subject, #21: 21	كَانَ الدَّلِيلُ
u'كَانَ دَمٌ':Predicate, #5: 5	كَانَ دَلِيلُهُ
u'كَانَ دَمٌ':Subject, #6: 6	كَانَ دَمَ
u'كَانَ دَمٌ':Subject, #1: 1	كَانَ دَمٌ
u'كَانَ دَمٌ':Subject, #42: 42	كَانَ الدَّمُ
u'كَانَ دَمٌ':Subject, #6: 6	كَانَ دَمُ
u'كَانَ دَنانيرُ':Predicate, #8: 8	كَانَ دَمُهُ
u'كَانَ دَهْرٌ':Subject, #1: 1	كَانَ دَنَانِيرَ
u'كَانَ دِهْليزٌ':Subject, #1: 1	كَانَ الدَّهْرُ
u'كَانَ دُهْنٌ':Subject, #3: 3	كَانَ الدِّهْلِيزُ
u'كَانَ دَواءٌ':Subject, #8: 8	كَانَ الدُّهْنُ
u'كَانَ دَواءٌ':Subject, #1: 1	كَانَ الدَّوَاءُ
u'كَانَ دَوامٌ':Subject, #1: 1	كَانَ دَوَاءٌ
u'كَانَ دَوامٌ':Subject, #1: 1	كَانَ دَوَامُ
u'كَانَ دُودٌ':Subject, #2: 2	كَانَ الدَّوَامُ
u'كَانَ دُودٌ':Subject, #1: 1	كَانَ الدُّودُ
u'كَانَ دَوْرٌ':Subject, #1: 1	كَانَ دُودُ
u'كَانَ دَوْرٌ':Subject, #1: 1	كَانَ الدَّوْرُ
u'كَانَ دَوْرٌ':Subject, #1: 1	كَانَ دَوْرُ
u'كَانَ دَوْس':Subject, #2: 2	كَانَ دَوْرُهُ
u'كَانَ دونٌ':Predicate, #1: 1	كَانَ الدَّوْسُ
u'كَانَ دونٌ':Predicate, #104: 104	كَانَ دُونَ
u'كَانَ دونٌ':Predicate, #1: 1	كَانَ دُونَكَ
u'كَانَ دونٌ':Subject, #1: 1	كَانَ دُونَهُنَّ
u'كَانَ ديباجٌ':Subject, #1: 1	كَانَ دُونُهُ
u'كَانَ دِيَةٌ':Predicate, #1: 1	كَانَ الدِّيبَاجُ
u'كَانَ دِيَةٌ':Subject, #1: 1	كَانَ دِيَةَ
u'كَانَ دِيَةٌ':Subject, #1: 1	كَانَ دِيَتُهُ
u'كَانَ دَيْنٌ':Predicate, #2: 2	كَانَ دِيَةُ
u'كَانَ دِينٌ':Subject, #3: 3	كَانَ دَيْنَ
u'كَانَ دِينٌ':Subject, #1: 1	كَانَ دِينٌ
u'كَانَ دِينٌ':Subject, #1: 1	كَانَ دِينُ
u'كَانَ دَيْنٌ':Subject, #1: 1	كَانَ دِينُهُ
u'كَانَ دَيْنٌ':Subject, #20: 20	كَانَ دَيْنُ
u'كَانَ دَيْنٌ':Subject, #323: 323	كَانَ الدَّيْنُ
u'كَانَ دِينٌ':Subject, #36: 36	كَانَ دَيْنُهُ
u'كَانَ دَيْنٌ':Subject, #8: 8	كَانَ الدِّينُ
u'كَانَ دِينارٌ':Subject, #8: 8	كَانَ دَيْنٌ
u'كَانَ دِيوانٌ':Subject, #7: 7	كَانَ الدِّينَارُ
u'كَانَ ذاتِيٌّ':Subject, #1: 1	كَانَ الدِّيوَانُ
u'كَانَ ذاهِب':Subject, #1: 1	كَانَ الذَّاتِيُّ
u'كَانَ ذُبابٌ':Subject, #23: 23	كَانَ الذَّاهِبُ
u'كَانَ ذَبيحٌ':Predicate, #1: 1	كَانَ الذُّبَابُ
u'كَانَ ذَبيحَةٌ':Predicate, #2: 2	كَانَ ذَبِيحَةَ
u'كَانَ ذِراعٌ':Subject, #2: 2	كَانَ ذَبِيحَةَ
u'كَانَ ذِراعٌ':Subject, #1: 1	كَانَ ذِرَاعٌ
u'كَانَ ذَرْعٌ':Subject, #4: 4	كَانَ الذِّرَاعُ
u'كَانَ ذَكاةٌ':Subject, #1: 1	كَانَ ذَرْعٌ
u'كَانَ ذكر':Predicate, #1: 1	كَانَ ذَكَاتُهُ
u'كَانَ ذَكَرٌ':Predicate, #12: 12	كَانَ ذَكَرَ
u'كَانَ ذكر':Predicate, #12: 12	كَانَ ذَكَرَ
u'كَانَ ذكر':Predicate, #1: 1	كَانَ ذُكِرَ
u'كَانَ ذِكْرٌ':Predicate, #1: 1	كَانَ ذِكْرَ
u'كَانَ ذكر':Subject, #1: 1	كَانَ ذِكْرَ
u'كَانَ ذِكْرٌ':Subject, #11: 11	كَانَ ذِكْرُ
u'كَانَ ذَكَرٌ':Subject, #11: 11	كَانَ ذِكْرُ
u'كَانَ ذكر':Subject, #1: 1	كَانَ ذَكَرٌ
u'كَانَ ذِكْرٌ':Subject, #6: 6	كَانَ الذِّكْرُ
u'كَانَ ذكر':Subject, #6: 6	كَانَ الذِّكْرُ
u'كَانَ ذَكَرٌ':Subject, #7: 7	كَانَ الذَّكَرُ
u'كَانَ ذكر':Subject, #7: 7	كَانَ الذَّكَرُ
u'كَانَ ذكر':Subject, #9: 9	كَانَ ذَكَرُهُ
u'كَانَ ذَكَرٌ':Subject, #9: 9	كَانَ ذِكْرُهُ
u'كَانَ ذِكْرٌ':Subject, #9: 9	كَانَ ذَكَرُهُ
u'كَانَ ذُلٌّ':Subject, #9: 9	كَانَ ذِكْرُهُ
u'كَانَ ذِمِّيٌّ':Subject, #1: 1	كَانَ ذُلُّ
u'كَانَ ذَنْبٌ':Subject, #7: 7	كَانَ الذِّمِّيُّ
u'كَانَ ذَنْبٌ':Subject, #2: 2	كَانَ ذَنْبُ
u'كَانَ ذَنْبٌ':Subject, #3: 3	كَانَ ذَنْبُهُ
u'كَانَ ذَهَابٌ':Subject, #7: 7	كَانَ الذَّنْبُ
u'كَانَ ذَهَابٌ':Subject, #2: 2	كَانَ الذَّهَابُ
u'كَانَ ذَهَبٌ':Predicate, #2: 2	كَانَ ذَهَابُهُ
u'كَانَ ذَهَبٌ':Subject, #3: 3	كَانَ ذَهَبَ
u'كَانَ ذَهَبٌ':Subject, #11: 11	كَانَ الذَّهَبُ
u'كَانَ ذِهْنٌ':Subject, #1: 1	كَانَ ذَهَبٌ
u'كَانَ ذِئْبٌ':Subject, #1: 1	كَانَ ذِهْنُ
u'كَانَ ذَيْلٌ':Subject, #1: 1	كَانَ الذِّئْبُ
u'كَانَ رابع':Predicate, #1: 1	كَانَ ذَيْلُهُ
u'كَانَ رَابِعٌ':Predicate, #1: 1	كَانَ الرَّابِعَ
u'كَانَ رابع':Subject, #1: 1	كَانَ الرَّابِعَ
u'كَانَ رَابِعٌ':Subject, #1: 1	كَانَ الرّابِعُ
u'كَانَ رابع':Subject, #1: 1	كَانَ الرّابِعُ
u'كَانَ رَابِعٌ':Subject, #8: 8	كَانَ الرَّابِعُ
u'كَانَ رَاتِبٌ':Subject, #8: 8	كَانَ الرَّابِعُ
u'كَانَ رَاتِب':Subject, #1: 1	كَانَ الرَّاتِبُ
u'كَانَ رَاجِحٌ':Predicate, #1: 1	كَانَ الرَّاتِبُ
u'كَانَ رَاجِحٌ':Subject, #1: 1	كَانَ رَاجِحَ
u'كَانَ رَاجِعٌ':Subject, #6: 6	كَانَ الرَّاجِحُ
u'كَانَ رَاجِلٌ':Subject, #2: 2	كَانَ الرَّاجِعُ
u'كَانَ رَأْسٌ':Predicate, #1: 1	كَانَ الرَّاجِلُ
u'كَانَ رَأْسٌ':Subject, #1: 1	كَانَ رَأْسَ
u'كَانَ رَأْسٌ':Subject, #106: 106	كَانَ رَأْسُ
u'كَانَ رَأْسٌ':Subject, #3: 3	كَانَ الرَّأْسُ
u'كَانَ رَاعِفٌ':Subject, #8: 8	كَانَ رَأْسُهُ
u'كَانَ رَافِعٌ':Subject, #1: 1	كَانَ الرَّاعِفُ
u'كَانَ رَافِعٌ':Subject, #1: 1	كَانَ الرَّافِعُ
u'كَانَ رَاكِبٌ':Predicate, #1: 1	كَانَ رَافِعُ
u'كَانَ رَاكِبٌ':Subject, #1: 1	كَانَ رَاكِبَ
u'كَانَ رَاكِبٌ':Subject, #2: 2	كَانَ رَاكِبٌ
u'كَانَ رَاكِدٌ':Subject, #9: 9	كَانَ الرَّاكِبُ
u'كَانَ رَاكِعٌ':Subject, #1: 1	كَانَ الرَّاكِدُ
u'كَانَ رَاهِنٌ':Predicate, #1: 1	كَانَ الرَّاكِعُ
u'كَانَ رَاهِنٌ':Subject, #1: 1	كَانَ الرَّاهِنَ
u'كَانَ رَاهِنٌ':Subject, #2: 2	كَانَ رَاهِنُ
u'كَانَ رَأْيٌ':Subject, #64: 64	كَانَ الرَّاهِنُ
u'كَانَ رَأْيٌ':Subject, #3: 3	كَانَ الرَّأْيُ
u'كَانَ رَأْيٌ':Subject, #7: 7	كَانَ رَأْيُ
u'كَانَ رَائِحٌ':Subject, #8: 8	كَانَ رَأْيُهُ
u'كَانَ رَائِحَةٌ':Subject, #2: 2	كَانَ رَائِحَتُهُ
u'كَانَ رَبُّ':Predicate, #2: 2	كَانَ رَائِحَتُهُ
u'كَانَ رَبُّ':Predicate, #1: 1	كَانَ رَبّكَ
u'كَانَ رَبُّ':Subject, #4: 4	كَانَ رَبَّ
u'كَانَ رَبُّ':Subject, #2: 2	كَانَ رَبُّهُ
u'كَانَ رباط':Subject, #82: 82	كَانَ رَبُّ
u'كَانَ رِبَاطٌ':Subject, #8: 8	كَانَ الرِّبَاطُ
u'كَانَ رِبْحٌ':Predicate, #8: 8	كَانَ الرِّبَاطُ
u'كَانَ رِبْحٌ':Subject, #2: 2	كَانَ رِبْحَ
u'كَانَ رِبْحٌ':Subject, #1: 1	كَانَ رِبْحُهُ
u'كَانَ رِبْحٌ':Subject, #2: 2	كَانَ رِبْحُ
u'كَانَ رَبْطٌ':Subject, #33: 33	كَانَ الرِّبْحُ
u'كَانَ رُبُعٌ':Predicate, #2: 2	كَانَ الرَّبْطُ
u'كَانَ رُبْعٌ':Predicate, #2: 2	كَانَ الرُّبُعَ
u'كَانَ رُبْعٌ':Subject, #5: 5	كَانَ رُبْعَ
u'كَانَ رُبُعٌ':Subject, #1: 1	كَانَ الرُّبْعُ
u'كَانَ رُبُعٌ':Subject, #2: 2	كَانَ رُبُعُ
u'كَانَ رُبْعٌ':Subject, #3: 3	كَانَ الرُّبُعُ
u'كَانَ رَبِيعٌ':Subject, #3: 3	كَانَ رُبْعُ
u'كَانَ رَبِيعَةٌ':Subject, #1: 1	كَانَ رَبِيعٌ
u'كَانَ رَجاء':Subject, #3: 3	كَانَ رَبِيعَةُ
u'كَانَ رَجَاءٌ':Subject, #1: 1	كَانَ رَجَاءُ
u'كَانَ رَجاء':Subject, #1: 1	كَانَ رَجَاءُ
u'كَانَ رَجَاءٌ':Subject, #2: 2	كَانَ الرَّجَاءُ
u'كَانَ رِجَالٌ':Subject, #2: 2	كَانَ الرَّجَاءُ
u'كَانَ رِجَالٌ':Subject, #11: 11	كَانَ رِجَالٌ
u'كَانَ رُجْحانٌ':Subject, #4: 4	كَانَ الرِّجَالُ
u'كَانَ رُجْحانٌ':Subject, #1: 1	كَانَ رُجْحَانُهُ
u'كَانَ رَجْعِيٌّ':Subject, #4: 4	كَانَ الرُّجْحَانُ
u'كَانَ رَجِلٌ':Predicate, #1: 1	كَانَ الرَّجْعِيُّ
u'كَانَ رَجُلٌ':Predicate, #1: 1	كَانَ رَجِلَ
u'كَانَ رَجُلٌ':Predicate, #2: 2	كَانَ رَجُلَ
u'كَانَ رِجْلٌ':Subject, #8: 8	كَانَ رَجُلاً
u'كَانَ رِجْلٌ':Subject, #1: 1	كَانَ رِجْلَاهُ
u'كَانَ رَجُلٌ':Subject, #1: 1	كَانَ رِجْلُهُ
u'كَانَ رَجُلٌ':Subject, #200: 200	كَانَ الرَّجُلُ
u'كَانَ رَجُلٌ':Subject, #4: 4	كَانَ الرّجُلُ
u'كَانَ رَجْمٌ':Subject, #82: 82	كَانَ رَجُلٌ
u'كَانَ رُجُوعٌ':Subject, #3: 3	كَانَ الرَّجْمُ
u'كَانَ رُجُوعٌ':Subject, #10: 10	كَانَ رُجُوعُهُ
u'كَانَ رُجُوعٌ':Subject, #21: 21	كَانَ الرُّجُوعُ
u'كَانَ رِحَالٌ':Predicate, #2: 2	كَانَ رُجُوعُ
u'كَانَ رحم':Subject, #1: 1	كَانَ رِحَالاً
u'كَانَ رَحِمٌ':Subject, #1: 1	كَانَ الرَّحِمُ
u'كَانَ رَخَاءٌ':Subject, #1: 1	كَانَ الرَّحِمُ
u'كَانَ رَدٌّ':Predicate, #1: 1	كَانَ رَخَاءٌ
u'كَانَ رَدٌّ':Subject, #4: 4	كَانَ رَدَّ
u'كَانَ رَدٌّ':Subject, #2: 2	كَانَ رَدٌّ
u'كَانَ رَدٌّ':Subject, #2: 2	كَانَ رَدُّهُ
u'كَانَ رَدٌّ':Subject, #67: 67	كَانَ الرَّدُّ
u'كَانَ رِدَاءٌ':Subject, #7: 7	كَانَ رَدُّ
u'كَانَ رِدْفٌ':Predicate, #3: 3	كَانَ الرِّدَاءُ
u'كَانَ رَدِيءٌ':Predicate, #3: 3	كَانَ رِدْفَ
u'كَانَ رَدِيفٌ':Predicate, #3: 3	كَانَ رَدِيءَ
u'كَانَ رَدِيفٌ':Subject, #6: 6	كَانَ رَدِيفَ
u'كَانَ رِزْقٌ':Subject, #4: 4	كَانَ الرَّدِيفُ
u'كَانَ رِزْقٌ':Subject, #1: 1	كَانَ الرِّزْقُ
u'كَانَ رِزْقٌ':Subject, #1: 1	كَانَ رِزْقُ
u'كَانَ رَسْمٌ':Subject, #1: 1	كَانَ رِزْقُهُ
u'كَانَ رَسُولٌ':Predicate, #1: 1	كَانَ الرَّسْمُ
u'كَانَ رَسُولٌ':Predicate, #1: 1	كَانَ الرَّسُولَ
u'كَانَ رَسُولٌ':Subject, #5: 5	كَانَ رَسُولَ
u'كَانَ رَسُولٌ':Subject, #1283: 1283	كَانَ رَسُولُ
u'كَانَ رَشيدٌ':Predicate, #16: 16	كَانَ الرَّسُولُ
u'كَانَ رَشيدٌ':Subject, #3: 3	كَانَ رَشِيدَ
u'كَانَ رِضاً':Subject, #1: 1	كَانَ الرَّشِيدُ
u'كَانَ رضاع':Subject, #2: 2	كَانَ رِضَاهُ
u'كَانَ رَضْخ':Subject, #8: 8	كَانَ الرَّضَاعُ
u'كَانَ رضع':Predicate, #2: 2	كَانَ الرَّضْخُ
u'كَانَ رَضَعٌ':Predicate, #1: 1	كَانَ رَضَعَ
u'كَانَ رَضيعٌ':Subject, #1: 1	كَانَ رَضَعَ
u'كَانَ رُطَبٌ':Subject, #3: 3	كَانَ الرَّضِيعُ
u'كَانَ رَطْبٌ':Subject, #1: 1	كَانَ رُطَبُ
u'كَانَ رُطَبٌ':Subject, #2: 2	كَانَ الرَّطْبُ
u'كَانَ رِطْلٌ':Subject, #5: 5	كَانَ الرُّطَبُ
u'كَانَ رعاف':Subject, #1: 1	كَانَ الرِّطْلُ
u'كَانَ رُعافٌ':Subject, #6: 6	كَانَ الرُّعَافُ
u'كَانَ رَعْيٌ':Subject, #6: 6	كَانَ الرُّعَافُ
u'كَانَ رَغيفٌ':Subject, #1: 1	كَانَ الرَّعْيُ
u'كَانَ رَفْعٌ':Subject, #1: 1	كَانَ الرَّغِيفُ
u'كَانَ رَفْعٌ':Subject, #1: 1	كَانَ رَفْعُهُ
u'كَانَ رَفْعٌ':Subject, #2: 2	كَانَ رَفْعُ
u'كَانَ رِفْقٌ':Subject, #3: 3	كَانَ الرَّفْعُ
u'كَانَ رَفيعٌ':Predicate, #2: 2	كَانَ الرِّفْقُ
u'كَانَ رَفيقٌ':Predicate, #1: 1	كَانَ رَفِيعَ
u'كَانَ رَفيقٌ':Subject, #1: 1	كَانَ رَفِيقَ
u'كَانَ رِقٌّ':Subject, #1: 1	كَانَ الرَّفِيقُ
u'كَانَ رِقٌّ':Subject, #1: 1	كَانَ رِقُّ
u'كَانَ رِقٌّ':Subject, #1: 1	كَانَ رِقُّهُ
u'كَانَ رَقَبَةٌ':Subject, #5: 5	كَانَ الرِّقُّ
u'كَانَ رَقْمٌ':Subject, #2: 2	كَانَ رَقَبَةُ
u'كَانَ رَقْم':Subject, #1: 1	كَانَ الرَّقْمُ
u'كَانَ رَقيقٌ':Subject, #1: 1	كَانَ الرَّقْمُ
u'كَانَ رَقيق':Subject, #7: 7	كَانَ الرَّقِيقُ
u'كَانَ ركب':Predicate, #7: 7	كَانَ الرَّقِيقُ
u'كَانَ ركب':Subject, #2: 2	كَانَ رَكِبَ
u'كَانَ رَكْبٌ':Subject, #1: 1	كَانَ الرَّكْبُ
u'كَانَ رُكْنٌ':Subject, #1: 1	كَانَ الرَّكْبُ
u'كَانَ رُكْن':Subject, #2: 2	كَانَ الرُّكْنُ
u'كَانَ رُكْنٌ':Subject, #2: 2	كَانَ الرُّكْنُ
u'كَانَ رُكْن':Subject, #2: 2	كَانَ رُكْنُهُ
u'كَانَ رُكوبٌ':Subject, #2: 2	كَانَ رُكْنُهُ
u'كَانَ رُكوعٌ':Subject, #10: 10	كَانَ الرُّكُوبُ
u'كَانَ رُكونٌ':Subject, #6: 6	كَانَ الرُّكُوعُ
u'كَانَ رَمَضانُ':Predicate, #1: 1	كَانَ الرُّكُونُ
u'كَانَ رَمَضانُ':Subject, #2: 2	كَانَ رَمَضَانَ
u'كَانَ رَمَلٌ':Predicate, #13: 13	كَانَ رَمَضَانُ
u'كَانَ رَمَلٌ':Subject, #2: 2	كَانَ رَمَلَ
u'كَانَ رَمْيٌ':Subject, #1: 1	كَانَ الرَّمَلُ
u'كَانَ رَمْيٌ':Subject, #11: 11	كَانَ الرَّمْيُ
u'كَانَ رَهْطٌ':Subject, #3: 3	كَانَ رَمْيُ
u'كَانَ رَهْنٌ':Predicate, #2: 2	كَانَ رَهْطٌ
u'كَانَ رَهْنٌ':Subject, #2: 2	كَانَ رَهْنَ
u'كَانَ رَهْنٌ':Subject, #107: 107	كَانَ الرَّهْنُ
u'كَانَ رِوايَةٌ':Subject, #1: 1	كَانَ رَهْنُهُ
u'كَانَ رِوايَةٌ':Subject, #1: 1	كَانَ رِوَايَةٌ
u'كَانَ رِوايَةٌ':Subject, #1: 1	كَانَ رِوَايَةُ
u'كَانَ رُؤَسَاءُ':Subject, #1: 1	كَانَ رِوَايَتُهُ
u'كَانَ رُومٌ':Subject, #1: 1	كَانَ الرُّؤَسَاءُ
u'كَانَ رُؤْيَةٌ':Subject, #1: 1	كَانَ الرُّومُ
u'كَانَ رُؤْيَةٌ':Subject, #1: 1	كَانَ الرُّؤْيَةُ
u'كَانَ رَئِيسٌ':Predicate, #1: 1	كَانَ رُؤْيَةُ
u'كَانَ رَيْبٌ':Subject, #1: 1	كَانَ رَئِيسَ
u'كَانَ ريحٌ':Subject, #1: 1	كَانَ رَيْبُ
u'كَانَ ريحٌ':Subject, #1: 1	كَانَ رِيحٌ
u'كَانَ ريعٌ':Subject, #3: 3	كَانَ الرِّيحُ
u'كَانَ رَيْعٌ':Subject, #1: 1	كَانَ الرَّيْعُ
u'كَانَ ريعٌ':Subject, #1: 1	كَانَ الرَّيْعُ
u'كَانَ رِيقٌ':Subject, #4: 4	كَانَ الرِّيعُ
u'كَانَ زادٌ':Predicate, #1: 1	كَانَ الرِّيقُ
u'كَانَ زَارِعٌ':Subject, #6: 6	كَانَ زَادَ
u'كَانَ زاي':Subject, #1: 1	كَانَ الزَّارِعُ
u'كَانَ زائِدٌ':Subject, #1: 1	كَانَ الزَّايُ
u'كَانَ زائِرٌ':Subject, #12: 12	كَانَ الزَّائِدُ
u'كَانَ زائِفٌ':Subject, #1: 1	كَانَ الزَّائِرُ
u'كَانَ زائِلٌ':Predicate, #1: 1	كَانَ الزَّائِفُ
u'كَانَ زُبْدٌ':Subject, #2: 2	كَانَ زَائِلَ
u'كَانَ زِبْلٌ':Subject, #2: 2	كَانَ الزُّبْدُ
u'كَانَ زَجَّاجٌ':Subject, #1: 1	كَانَ الزِّبْلُ
u'كَانَ زِرٌّ':Subject, #1: 1	كَانَ الزَّجَّاجُ
u'كَانَ زَرْعٌ':Subject, #1: 1	كَانَ زِرُّ
u'كَانَ زَرْعٌ':Subject, #1: 1	كَانَ زَرْعٌ
u'كَانَ زَرْعٌ':Subject, #1: 1	كَانَ زَرْعُهُ
u'كَانَ زَرْعٌ':Subject, #2: 2	كَانَ زَرْعُ
u'كَانَ زَعْفَرانٌ':Subject, #56: 56	كَانَ الزَّرْعُ
u'كَانَ زَعْمٌ':Subject, #1: 1	كَانَ الزَّعْفَرَانُ
u'كَانَ زُفَرٌ':Subject, #1: 1	كَانَ زَعْمُهُ
u'كَانَ زِقٌّ':Subject, #1: 1	كَانَ زُفَرُ
u'كَانَ زَكاةٌ':Predicate, #3: 3	كَانَ الزِّقُّ
u'كَانَ زَكاةٌ':Subject, #2: 2	كَانَ زَكَاةَ
u'كَانَ زِمامٌ':Subject, #2: 2	كَانَ زَكَاةُ
u'كَانَ زَمانٌ':Predicate, #2: 2	كَانَ زِمَامُ
u'كَانَ زَمانٌ':Subject, #2: 2	كَانَ زَمَانَ
u'كَانَ زَمانٌ':Subject, #4: 4	كَانَ الزَّمَانُ
u'كَانَ زَمَنٌ':Predicate, #8: 8	كَانَ زَمَانُ
u'كَانَ زَمَنٌ':Subject, #11: 11	كَانَ زَمَنَ
u'كَانَ زِنَة':Subject, #17: 17	كَانَ زَمَنُ
u'كَانَ زُهْدٌ':Subject, #1: 1	كَانَ زِنَةُ
u'كَانَ زَواجٌ':Subject, #1: 1	كَانَ زُهْدُهُ
u'كَانَ زَوالٌ':Predicate, #1: 1	كَانَ زَوَاجُهُ
u'كَانَ زَوالٌ':Subject, #1: 1	كَانَ زَوَالَ
u'كَانَ زَوالٌ':Subject, #1: 1	كَانَ الزَّوَالُ
u'كَانَ زَوالٌ':Subject, #1: 1	كَانَ زَوَالُهُ
u'كَانَ زَوْجٌ':Predicate, #6: 6	كَانَ زَوَالُ
u'كَانَ زَوْجٌ':Predicate, #1: 1	كَانَ الزَّوْجَ
u'كَانَ زَوْجٌ':Subject, #2: 2	كَانَ زَوْجَ
u'كَانَ زَوْجٌ':Subject, #1: 1	كَانَ الزّوْجُ
u'كَانَ زَوْجٌ':Subject, #20: 20	كَانَ زَوْجُ
u'كَانَ زَوْجٌ':Subject, #2: 2	كَانَ زَوْجٌ
u'كَانَ زِيٌّ':Predicate, #375: 375	كَانَ الزَّوْجُ
u'كَانَ زِيادَةٌ':Predicate, #2: 2	كَانَ زِيَّ
u'كَانَ زِيادَةٌ':Subject, #2: 2	كَانَ زِيَادَةَ
u'كَانَ زِيادَةٌ':Subject, #1: 1	كَانَ الزِّيَادَةُ
u'كَانَ زَيْتٌ':Subject, #1: 1	كَانَ زِيَادَةُ
u'كَانَ زَيْتٌ':Subject, #1: 1	كَانَ زَيْتُ
u'كَانَ زَيْتٌ':Subject, #2: 2	كَانَ زَيْتُهُ
u'كَانَ زَيْتونٌ':Subject, #3: 3	كَانَ الزَّيْتُ
u'كَانَ زَيْدٌ':Subject, #1: 1	كَانَ الزَّيْتُونُ
u'كَانَ زَيْدٌ':Subject, #31: 31	كَانَ زَيْدٌ
u'كَانَ زُيوفٌ':Subject, #8: 8	كَانَ زَيْدُ
u'كَانَ زُيُوفٌ':Subject, #2: 2	كَانَ الزُّيُوفُ
u'كَانَ سَابِقٌ':Subject, #2: 2	كَانَ الزُّيُوفُ
u'كَانَ سَابِقٌ':Subject, #1: 1	كَانَ سَابِقَةُ
u'كَانَ سَاتِرٌ':Subject, #6: 6	كَانَ السَّابِقُ
u'كَانَ سَاتِرٌ':Subject, #1: 1	كَانَ سَاتِرٌ
u'كَانَ سَاحِرٌ':Subject, #2: 2	كَانَ السَّاتِرُ
u'كَانَ سَادِنٌ':Predicate, #2: 2	كَانَ السَّاحِرُ
u'كَانَ سَارِقٌ':Subject, #1: 1	كَانَ سَادِنَ
u'كَانَ سَاعَةٌ':Predicate, #19: 19	كَانَ السَّارِقُ
u'كَانَ سَاقٌ':Predicate, #1: 1	كَانَ سَاعَةَ
u'كَانَ سَاقٌ':Subject, #7: 7	كَانَ سَاقَ
u'كَانَ سَاقٌ':Subject, #1: 1	كَانَ سَاقُهُ
u'كَانَ سَاقِطٌ':Subject, #2: 2	كَانَ سَاقَاهُ
u'كَانَ سَاكِتٌ':Subject, #7: 7	كَانَ السَّاقِطُ
u'كَانَ سَاكِنٌ':Subject, #2: 2	كَانَ السَّاكِتُ
u'كَانَ سَاكِنٌ':Subject, #2: 2	كَانَ سَاكِنُ
u'كَانَ سَالِمٌ':Predicate, #5: 5	كَانَ السَّاكِنُ
u'كَانَ سَالِمٌ':Subject, #1: 1	كَانَ سَالِمَ
u'كَانَ سَالِمٌ':Subject, #1: 1	كَانَ السَّالِمُ
u'كَانَ سَالِمٌ':Subject, #3: 3	كَانَ سَالِمُ
u'كَانَ سَامِعٌ':Subject, #6: 6	كَانَ سَالِمٌ
u'كَانَ سَائِرٌ':Subject, #8: 8	كَانَ السَّامِعُ
u'كَانَ سَائِقٌ':Subject, #2: 2	كَانَ سَائِرُ
u'كَانَ سَائِقٌ':Subject, #1: 1	كَانَ سَائِقٌ
u'كَانَ سائِل':Subject, #2: 2	كَانَ السَّائِقُ
u'كَانَ سَائِلٌ':Subject, #7: 7	كَانَ السَّائِلُ
u'كَانَ سَبٌّ':Subject, #7: 7	كَانَ السَّائِلُ
u'كَانَ سَبٌّ':Subject, #1: 1	كَانَ سَبُّهُ
u'كَانَ سَبَبٌ':Predicate, #3: 3	كَانَ السَّبُّ
u'كَانَ سَبَبٌ':Subject, #8: 8	كَانَ سَبَبَ
u'كَانَ سَبَبٌ':Subject, #22: 22	كَانَ سَبَبُهُ
u'كَانَ سَبَبٌ':Subject, #2: 2	كَانَ سَبَبٌ
u'كَانَ سَبَبٌ':Subject, #34: 34	كَانَ سَبَبُ
u'كَانَ سَبْتٌ':Subject, #59: 59	كَانَ السَّبَبُ
u'كَانَ سَبْرٌ':Subject, #1: 1	كَانَ السّبْتُ
u'كَانَ سَبْعٌ':Predicate, #2: 2	كَانَ السَّبْرُ
u'كَانَ سُبْعٌ':Subject, #1: 1	كَانَ سَبْعَ
u'كَانَ سَبُعٌ':Subject, #1: 1	كَانَ سُبْعُ
u'كَانَ سَبْعَةٌ':Predicate, #3: 3	كَانَ السَّبُعُ
u'كَانَ سَبَقٌ':Predicate, #4: 4	كَانَ سَبْعَةَ
u'كَانَ سَبْقٌ':Subject, #5: 5	كَانَ سَبَقَ
u'كَانَ سَبِيلٌ':Subject, #2: 2	كَانَ سَبْقُ
u'كَانَ سَبِيلٌ':Subject, #1: 1	كَانَ السَّبِيلُ
u'كَانَ سَبِيلٌ':Subject, #1: 1	كَانَ سَبِيلُ
u'كَانَ سِتٌّ':Predicate, #3: 3	كَانَ سَبِيلُهُ
u'كَانَ سِتٌّ':Predicate, #1: 1	كَانَ السِّتَّ
u'كَانَ سِتٌّ':Predicate, #1: 1	كَانَ سِتَّ
u'كَانَ سِتٌّ':Predicate, #1: 1	كَانَ سِتَّةً
u'كَانَ سِتْرٌ':Subject, #1: 1	كَانَ سِتَّةَ
u'كَانَ سِتْرٌ':Subject, #1: 1	كَانَ سِتْرٌ
u'كَانَ سَتْرٌ':Subject, #1: 1	كَانَ سِتْرُ
u'كَانَ سِتْرٌ':Subject, #3: 3	كَانَ السَّتْرُ
u'كَانَ سِجَالٌ':Subject, #3: 3	كَانَ السِّتْرُ
u'كَانَ سَجْنٌ':Subject, #1: 1	كَانَ سِجَالُ
u'كَانَ سِجْنٌ':Subject, #1: 1	كَانَ السَّجْنُ
u'كَانَ سُجُودٌ':Subject, #1: 1	كَانَ السِّجْنُ
u'كَانَ سُجُودٌ':Subject, #10: 10	كَانَ السُّجُودُ
u'كَانَ سُجُودٌ':Subject, #3: 3	كَانَ سُجُودُ
u'كَانَ سِحْرٌ':Subject, #3: 3	كَانَ سُجُودُهُ
u'كَانَ سَحَرٌ':Subject, #2: 2	كَانَ السِّحْرُ
u'كَانَ سَخَاءٌ':Subject, #3: 3	كَانَ السَّحَرُ
u'كَانَ سَدٌّ':Predicate, #1: 1	كَانَ السَّخَاءُ
u'كَانَ سَدٌّ':Subject, #1: 1	كَانَ سَدَّ
u'كَانَ سَدٌّ':Subject, #1: 1	كَانَ سَدُّ
u'كَانَ سُدْسٌ':Subject, #1: 1	كَانَ سَدُّهُ
u'كَانَ سِرٌّ':Subject, #1: 1	كَانَ السُّدْسُ
u'كَانَ سَرَاةٌ':Subject, #1: 1	كَانَ السِّرُّ
u'كَانَ سِرَاجٌ':Subject, #1: 1	كَانَ السّرَاةُ
u'كَانَ سَرَاوِيلُ':Subject, #1: 1	كَانَ سِرَاجُ
u'كَانَ سَرْجٌ':Subject, #1: 1	كَانَ السَّرَاوِيلُ
u'كَانَ سَرْجٌ':Subject, #1: 1	كَانَ سَرْجٌ
u'كَانَ سِرْدَابٌ':Subject, #4: 4	كَانَ السَّرْجُ
u'كَانَ سِرْقِين':Subject, #3: 3	كَانَ السِّرْدَابُ
u'كَانَ سَرِيرٌ':Subject, #2: 2	كَانَ السِّرْقِينُ
u'كَانَ سَرِيعٌ':Predicate, #2: 2	كَانَ السَّرِيرُ
u'كَانَ سَطْحٌ':Subject, #4: 4	كَانَ سَرِيعَ
u'كَانَ سَطْحٌ':Subject, #1: 1	كَانَ سَطْحُهُ
u'كَانَ سَعْدٌ':Subject, #2: 2	كَانَ السَّطْحُ
u'كَانَ سَعْدٌ':Subject, #1: 1	كَانَ سَعْدُ
u'كَانَ سعر':Subject, #6: 6	كَانَ سَعْدٌ
u'كَانَ سِعْرٌ':Subject, #10: 10	كَانَ السِّعْرُ
u'كَانَ سعر':Subject, #10: 10	كَانَ السِّعْرُ
u'كَانَ سِعْرٌ':Subject, #1: 1	كَانَ سِعْرُ
u'كَانَ سعر':Subject, #1: 1	كَانَ سِعْرُ
u'كَانَ سِعْرٌ':Subject, #1: 1	كَانَ سِعْرُهُ
u'كَانَ سَعِيدٌ':Predicate, #1: 1	كَانَ سِعْرُهُ
u'كَانَ سَعِيدٌ':Subject, #2: 2	كَانَ سَعِيدَ
u'كَانَ سَفَرٌ':Predicate, #11: 11	كَانَ سَعِيدُ
u'كَانَ سَفَرٌ':Subject, #3: 3	كَانَ سَفَرَ
u'كَانَ سَفَرٌ':Subject, #20: 20	كَانَ سَفَرُهُ
u'كَانَ سُفْلٌ':Subject, #23: 23	كَانَ السَّفَرُ
u'كَانَ سُفْلٌ':Subject, #6: 6	كَانَ سُفْلٌ
u'كَانَ سَفِيرٌ':Predicate, #8: 8	كَانَ السُّفْلُ
u'كَانَ سَفِيهٌ':Subject, #1: 1	كَانَ السَّفِيرَ
u'كَانَ سِقَاءٌ':Subject, #2: 2	كَانَ السَّفِيهُ
u'كَانَ سقط':Predicate, #1: 1	كَانَ السِّقَاءُ
u'كَانَ سقط':Predicate, #1: 1	كَانَ سُقِطَ
u'كَانَ سَقَطٌ':Predicate, #7: 7	كَانَ سَقَطَ
u'كَانَ سقط':Subject, #7: 7	كَانَ سَقَطَ
u'كَانَ سِقْطٌ':Subject, #8: 8	كَانَ السِّقْطُ
u'كَانَ سَقْفٌ':Subject, #8: 8	كَانَ السِّقْطُ
u'كَانَ سُقُوطٌ':Subject, #4: 4	كَانَ السَّقْفُ
u'كَانَ سُقُوطٌ':Subject, #2: 2	كَانَ سُقُوطُ
u'كَانَ سُقُوطٌ':Subject, #3: 3	كَانَ سُقُوطُهُ
u'كَانَ سَقْيٌ':Subject, #4: 4	كَانَ السُّقُوطُ
u'كَانَ سُكَّانٌ':Subject, #4: 4	كَانَ السَّقْيُ
u'كَانَ سكر':Subject, #1: 1	كَانَ السُّكَّانُ
u'كَانَ سُكْرٌ':Subject, #1: 1	كَانَ السُّكْرُ
u'كَانَ سكر':Subject, #1: 1	كَانَ السُّكْرُ
u'كَانَ سُكْرٌ':Subject, #3: 3	كَانَ سُكْرُهُ
u'كَانَ سَكْرَان':Predicate, #3: 3	كَانَ سُكْرُهُ
u'كَانَ سَكْرَان':Subject, #4: 4	كَانَ سَكْرَانَ
u'كَانَ سَكَنٌ':Predicate, #1: 1	كَانَ السَّكْرَانُ
u'كَانَ سُكُوتٌ':Subject, #1: 1	كَانَ سَكَنَ
u'كَانَ سُكُوتٌ':Subject, #5: 5	كَانَ سُكُوتُهُ
u'كَانَ سِكِّينٌ':Subject, #7: 7	كَانَ السُّكُوتُ
u'كَانَ سِكِّينٌ':Subject, #1: 1	كَانَ السِّكِّينُ
u'كَانَ سِلاَحٌ':Subject, #1: 1	كَانَ سِكِّينٌ
u'كَانَ سلام':Subject, #1: 1	كَانَ السِّلَاحُ
u'كَانَ سَلاَمٌ':Subject, #2: 2	كَانَ السَّلاَمُ
u'كَانَ سلام':Subject, #2: 2	كَانَ السَّلاَمُ
u'كَانَ سَلاَمٌ':Subject, #2: 2	كَانَ سَلَامُ
u'كَانَ سلام':Subject, #2: 2	كَانَ سَلَامُ
u'كَانَ سَلاَمٌ':Subject, #3: 3	كَانَ سَلَامُهُ
u'كَانَ سلام':Subject, #3: 3	كَانَ سَلَامُهُ
u'كَانَ سَلاَمٌ':Subject, #7: 7	كَانَ السَّلَامُ
u'كَانَ سَلَبٌ':Subject, #7: 7	كَانَ السَّلَامُ
u'كَانَ سَلْبٌ':Subject, #1: 1	كَانَ السّلَبُ
u'كَانَ سَلَبٌ':Subject, #1: 1	كَانَ سَلْبُ
u'كَانَ سَلَبٌ':Subject, #1: 1	كَانَ سَلَبُهُ
u'كَانَ سَلَسٌ':Subject, #6: 6	كَانَ السَّلَبُ
u'كَانَ سُلْطَانٌ':Subject, #1: 1	كَانَ السَّلَسُ
u'كَانَ سَلَفٌ':Predicate, #21: 21	كَانَ السُّلْطَانُ
u'كَانَ سَلَفٌ':Subject, #2: 2	كَانَ سَلَفَ
u'كَانَ سِلْكٌ':Subject, #23: 23	كَانَ السَّلَفُ
u'كَانَ سَلَمٌ':Subject, #1: 1	كَانَ السِّلْكُ
u'كَانَ سُلَّمٌ':Subject, #17: 17	كَانَ السَّلَمُ
u'كَانَ سلمة':Subject, #1: 1	كَانَ السُّلَّمُ
u'كَانَ سُلُوكٌ':Subject, #4: 4	كَانَ سَلَمَةُ
u'كَانَ سُلُوك':Subject, #1: 1	كَانَ سُلُوكُهُ
u'كَانَ سَلِيمٌ':Subject, #1: 1	كَانَ سُلُوكُهُ
u'كَانَ سَمٌّ':Subject, #2: 2	كَانَ السَّلِيمُ
u'كَانَ سَمَاءٌ':Subject, #2: 2	كَانَ سَمَّاهُ
u'كَانَ سِمَاطٌ':Predicate, #2: 2	كَانَ السَّمَاءُ
u'كَانَ سَمَاعٌ':Subject, #1: 1	كَانَ سِمَاطَ
u'كَانَ سَمَاعٌ':Subject, #2: 2	كَانَ السَّمَاعُ
u'كَانَ سِمْسَارٌ':Subject, #3: 3	كَانَ سَمَاعُهُ
u'كَانَ سَمْعٌ':Subject, #1: 1	كَانَ السِّمْسَارُ
u'كَانَ سَمَكٌ':Predicate, #2: 2	كَانَ السَّمْعُ
u'كَانَ سَمَكٌ':Subject, #1: 1	كَانَ سَمَكَةً
u'كَانَ سَمْنٌ':Subject, #3: 3	كَانَ السَّمَكُ
u'كَانَ سَمِينٌ':Predicate, #5: 5	كَانَ السَّمْنُ
u'كَانَ سِنٌّ':Predicate, #1: 1	كَانَ سَمِينَ
u'كَانَ سِنٌّ':Subject, #3: 3	كَانَ سِنَّ
u'كَانَ سِنٌّ':Subject, #14: 14	كَانَ سِنُّ
u'كَانَ سِنٌّ':Subject, #5: 5	كَانَ السِّنُّ
u'كَانَ سُنَّةٌ':Predicate, #5: 5	كَانَ سِنُّهُ
u'كَانَ سَنَةٌ':Predicate, #1: 1	كَانَ سُنَّةَ
u'كَانَ سَنَدٌ':Subject, #7: 7	كَانَ سَنَةَ
u'كَانَ سهام':Subject, #2: 2	كَانَ سَنَدُهُ
u'كَانَ سِهَامٌ':Subject, #1: 1	كَانَ سِهَامُ
u'كَانَ سَهْلٌ':Predicate, #1: 1	كَانَ سِهَامُ
u'كَانَ سَهْلٌ':Subject, #1: 1	كَانَ سَهْلاً
u'كَانَ سَهْلٌ':Subject, #1: 1	كَانَ سَهْلُ
u'كَانَ سَهْمٌ':Subject, #2: 2	كَانَ سَهْلٌ
u'كَانَ سَهْمٌ':Subject, #1: 1	كَانَ سَهْمٌ
u'كَانَ سَهْمٌ':Subject, #2: 2	كَانَ سَهْمَاهُ
u'كَانَ سَهْمٌ':Subject, #4: 4	كَانَ سَهْمُ
u'كَانَ سَهْمٌ':Subject, #5: 5	كَانَ سَهْمُهُ
u'كَانَ سَهْوٌ':Subject, #6: 6	كَانَ السَّهْمُ
u'كَانَ سَهْوٌ':Subject, #1: 1	كَانَ سَهْوُ
u'كَانَ سَهْوٌ':Subject, #1: 1	كَانَ سَهْوُهُ
u'كَانَ سُوءٌ':Subject, #4: 4	كَانَ السَّهْوُ
u'كَانَ سَواءٌ':Subject, #3: 3	كَانَ سُوءُ
u'كَانَ سَوادٌ':Subject, #8: 8	كَانَ سَوَاءٌ
u'كَانَ سَوادٌ':Subject, #1: 1	كَانَ سَوَادُ
u'كَانَ سَوادٌ':Subject, #1: 1	كَانَ سَوَادُهُ
u'كَانَ سِواكٌ':Subject, #4: 4	كَانَ السَّوَادُ
u'كَانَ سُؤَالٌ':Predicate, #4: 4	كَانَ السِّوَاكُ
u'كَانَ سُؤَالٌ':Subject, #1: 1	كَانَ سُؤَالَ
u'كَانَ سُؤَالٌ':Subject, #1: 1	كَانَ سُؤَالُهُ
u'كَانَ سود':Subject, #7: 7	كَانَ السُّؤَالُ
u'كَانَ سُودٌ':Subject, #1: 1	كَانَ السُّودُ
u'كَانَ سُؤْرٌ':Predicate, #1: 1	كَانَ السُّودُ
u'كَانَ سُؤْرٌ':Subject, #1: 1	كَانَ سُؤْرَ
u'كَانَ سُؤْرٌ':Subject, #1: 1	كَانَ سُؤْرُ
u'كَانَ سَوْطٌ':Subject, #2: 2	كَانَ سُؤْرُهُ
u'كَانَ سُوقٌ':Subject, #1: 1	كَانَ السَّوْطُ
u'كَانَ سَوِيق':Subject, #1: 1	كَانَ السُّوقُ
u'كَانَ سِياقٌ':Subject, #1: 1	كَانَ السَّوِيقُ
u'كَانَ سِياقٌ':Subject, #1: 1	كَانَ السِّيَاقُ
u'كَانَ سَيِّدٌ':Predicate, #1: 1	كَانَ سِيَاقُهُ
u'كَانَ سَيِّدٌ':Subject, #1: 1	كَانَ سَيِّدَ
u'كَانَ سَيِّدٌ':Subject, #2: 2	كَانَ سَيِّدُ
u'كَانَ سَيِّدٌ':Subject, #37: 37	كَانَ السَّيِّدُ
u'كَانَ سَيْرٌ':Subject, #7: 7	كَانَ سَيِّدُهُ
u'كَانَ سيرَةٌ':Subject, #1: 1	كَانَ سَيْرُهُ
u'كَانَ سَيْفٌ':Subject, #1: 1	كَانَ سِيرَتُهُ
u'كَانَ سَيْفٌ':Subject, #2: 2	كَانَ سَيْفُ
u'كَانَ سَيْل':Subject, #7: 7	كَانَ السَّيْفُ
u'كَانَ سَيَلانٌ':Subject, #1: 1	كَانَ السَّيْلُ
u'كَانَ سَيَلانٌ':Subject, #1: 1	كَانَ السَّيَلَانُ
u'كَانَ سَيِّئٌ':Predicate, #1: 1	كَانَ سَيَلَانُهُ
u'كَانَ سَيِّئٌ':Subject, #2: 2	كَانَ سَيِّئَ
u'كَانَ شَاةٌ':Subject, #5: 5	كَانَ سَيِّئُهُ
u'كَانَ شَاخِصٌ':Subject, #1: 1	كَانَ شَاةٌ
u'كَانَ شَارِبٌ':Subject, #1: 1	كَانَ الشَّاخِصُ
u'كَانَ شَارِبٌ':Subject, #1: 1	كَانَ الشَّارِبُ
u'كَانَ شَارِعٌ':Subject, #3: 3	كَانَ شَارِبُ
u'كَانَ شَاعِر':Predicate, #2: 2	كَانَ الشَّارِعُ
u'كَانَ شَاعِر':Subject, #1: 1	كَانَ شَاعِرَ
u'كَانَ شَاغِلٌ':Subject, #2: 2	كَانَ الشَّاعِرُ
u'كَانَ شافِعِيّ':Subject, #1: 1	كَانَ الشَّاغِلُ
u'كَانَ شَأْنٌ':Predicate, #11: 11	كَانَ الشَّافِعِيُّ
u'كَانَ شَأْنٌ':Subject, #2: 2	كَانَ شَأْنَ
u'كَانَ شَأْنٌ':Subject, #1: 1	كَانَ الشّأْنُ
u'كَانَ شَأْنٌ':Subject, #2: 2	كَانَ شَأْنُهُ
u'كَانَ شَأْنٌ':Subject, #3: 3	كَانَ الشَّأْنُ
u'كَانَ شَاهِدٌ':Predicate, #5: 5	كَانَ شَأْنُ
u'كَانَ شَاهِدٌ':Subject, #1: 1	كَانَ شَاهِدَ
u'كَانَ شَاهِدٌ':Subject, #2: 2	كَانَ شَاهِدٌ
u'كَانَ شَاهِدٌ':Subject, #2: 2	كَانَ شَاهِدُ
u'كَانَ شَبابٌ':Subject, #38: 38	كَانَ الشَّاهِدُ
u'كَانَ شَبابٌ':Subject, #1: 1	كَانَ شَبَابٌ
u'كَانَ شَبَابٌ':Subject, #1: 1	كَانَ شَبَابُ
u'كَانَ شَبَابٌ':Subject, #1: 1	كَانَ شَبَابٌ
u'كَانَ شِبَعٌ':Subject, #1: 1	كَانَ شَبَابُ
u'كَانَ شَبْعَان':Predicate, #1: 1	كَانَ شِبَعُهُ
u'كَانَ شَبَهٌ':Predicate, #2: 2	كَانَ شَبْعَانَ
u'كَانَ شِبْهٌ':Predicate, #2: 2	كَانَ شَبَهَ
u'كَانَ شَبَهٌ':Subject, #4: 4	كَانَ شِبْهَ
u'كَانَ شَبَهٌ':Subject, #1: 1	كَانَ شَبَهُهُ
u'كَانَ شُبْهَةٌ':Subject, #3: 3	كَانَ الشَّبَهُ
u'كَانَ شَبِيهٌ':Predicate, #1: 1	كَانَ شُبْهَةُ
u'كَانَ شَبِيهٌ':Subject, #1: 1	كَانَ شَبِيهَ
u'كَانَ شِتَاءٌ':Subject, #1: 1	كَانَ الشَّبِيهُ
u'كَانَ شَتْوِيُّ':Subject, #4: 4	كَانَ الشِّتَاءُ
u'كَانَ شَجَرٌ':Subject, #1: 1	كَانَ الشَّتْوِيُّ
u'كَانَ شَجَرٌ':Subject, #1: 1	كَانَ شَجَرٌ
u'كَانَ شَحْمٌ':Predicate, #6: 6	كَانَ الشَّجَرُ
u'كَانَ شَحْمٌ':Subject, #1: 1	كَانَ شَحْمَ
u'كَانَ شَخْصٌ':Subject, #1: 1	كَانَ الشَّحْمُ
u'كَانَ شَخْصٌ':Subject, #3: 3	كَانَ الشَّخْصُ
u'كَانَ شَدٌّ':Predicate, #5: 5	كَانَ شَخْصٌ
u'كَانَ شَدٌّ':Subject, #1: 1	كَانَ شَدَّ
u'كَانَ شَدٌّ':Subject, #1: 1	كَانَ شَدُّ
u'كَانَ شِدَّةٌ':Subject, #2: 2	كَانَ الشَّدُّ
u'كَانَ شِدَّةٌ':Subject, #1: 1	كَانَ الشِّدَّةُ
u'كَانَ شَدِيدٌ':Predicate, #1: 1	كَانَ شِدَّةُ
u'كَانَ شَدِيدٌ':Subject, #7: 7	كَانَ شَدِيدَ
u'كَانَ شَرٌّ':Predicate, #1: 1	كَانَ شَدِيدُ
u'كَانَ شَرٌّ':Subject, #1: 1	كَانَ شَرَّ
u'كَانَ شِرَاءٌ':Subject, #5: 5	كَانَ شَرُّهُ
u'كَانَ شِرَاءٌ':Subject, #31: 31	كَانَ الشِّرَاءُ
u'كَانَ شَرَابٌ':Subject, #6: 6	كَانَ شِرَاءُ
u'كَانَ شرب':Predicate, #1: 1	كَانَ الشَّرَابُ
u'كَانَ شرب':Predicate, #1: 1	كَانَ شَرِبَ
u'كَانَ شُرْبٌ':Predicate, #1: 1	كَانَ شُرْبَ
u'كَانَ شرب':Subject, #1: 1	كَانَ شُرْبَ
u'كَانَ شرب':Subject, #1: 1	كَانَ شُرْبُ
u'كَانَ شُرْبٌ':Subject, #1: 1	كَانَ شِرْبُ
u'كَانَ شِرْبٌ':Subject, #1: 1	كَانَ شُرْبُ
u'كَانَ شرب':Subject, #1: 1	كَانَ شِرْبُ
u'كَانَ شرب':Subject, #2: 2	كَانَ الشُّرْبُ
u'كَانَ شُرْبٌ':Subject, #2: 2	كَانَ الشِّرْبُ
u'كَانَ شِرْبٌ':Subject, #2: 2	كَانَ الشُّرْبُ
u'كَانَ شرب':Subject, #2: 2	كَانَ الشِّرْبُ
u'كَانَ شُرْبٌ':Subject, #2: 2	كَانَ شُرْبُهُ
u'كَانَ شَرْطٌ':Predicate, #2: 2	كَانَ شُرْبُهُ
u'كَانَ شَرَطٌ':Predicate, #1: 1	كَانَ شَرْطَ
u'كَانَ شَرْطٌ':Subject, #21: 21	كَانَ شَرَطَ
u'كَانَ شَرْطٌ':Subject, #20: 20	كَانَ شَرْطُ
u'كَانَ شَرْطٌ':Subject, #3: 3	كَانَ شَرْطُهُ
u'كَانَ شَرْعٌ':Predicate, #90: 90	كَانَ الشَّرْطُ
u'كَانَ شَرَعٌ':Predicate, #1: 1	كَانَ الشَّرْعَ
u'كَانَ شَرْعٌ':Subject, #3: 3	كَانَ شَرَعَ
u'كَانَ شِرْعٌ':Subject, #1: 1	كَانَ الشّرْعُ
u'كَانَ شَرْعٌ':Subject, #1: 1	كَانَ الشّرْعُ
u'كَانَ شَرْعٌ':Subject, #1: 1	كَانَ شَرْعُهُ
u'كَانَ شَرْعِيٌّ':Subject, #4: 4	كَانَ شَرْعُ
u'كَانَ شرف':Subject, #2: 2	كَانَ شَرْعِيَّةُ
u'كَانَ شَرَفٌ':Subject, #1: 1	كَانَ شَرَفُ
u'كَانَ شركاء':Subject, #1: 1	كَانَ شَرَفُ
u'كَانَ شُرُوعٌ':Subject, #9: 9	كَانَ الشُّرَكَاءُ
u'كَانَ شُرُوعٌ':Subject, #1: 1	كَانَ الشُّرُوعُ
u'كَانَ شَرِيعَةٌ':Predicate, #8: 8	كَانَ شُرُوعُهُ
u'كَانَ شَرِيكٌ':Predicate, #1: 1	كَانَ شَرِيعَةَ
u'كَانَ شَرِيكٌ':Subject, #7: 7	كَانَ شَرِيكَ
u'كَانَ شَرِيكٌ':Subject, #33: 33	كَانَ الشَّرِيكُ
u'كَانَ شَرِيكٌ':Subject, #9: 9	كَانَ شَرِيكُ
u'كَانَ شَطٌّ':Subject, #9: 9	كَانَ شَرِيكُهُ
u'كَانَ شَطْرٌ':Predicate, #1: 1	كَانَ الشَّطُّ
u'كَانَ شَطْرٌ':Subject, #1: 1	كَانَ شَطْرَ
u'كَانَ شَطْرٌ':Subject, #1: 1	كَانَ الشَّطْرُ
u'كَانَ شِطْرَنْجٌ':Subject, #4: 4	كَانَ شَطْرُ
u'كَانَ شعار':Predicate, #1: 1	كَانَ الشِّطْرَنْجُ
u'كَانَ شِعَارٌ':Predicate, #2: 2	كَانَ شِعَارَ
u'كَانَ شعار':Subject, #2: 2	كَانَ شِعَارَ
u'كَانَ شِعَارٌ':Subject, #1: 1	كَانَ شِعَارُ
u'كَانَ شُعْبَةٌ':Subject, #1: 1	كَانَ شِعَارُ
u'كَانَ شَعْبِيٌّ':Subject, #9: 9	كَانَ شُعْبَةُ
u'كَانَ شَعْرٌ':Predicate, #2: 2	كَانَ الشَّعْبِيُّ
u'كَانَ شَعْرٌ':Predicate, #1: 1	كَانَ شَعْرَ
u'كَانَ شَعْرٌ':Subject, #1: 1	كَانَ شَعْرَةً
u'كَانَ شِعْرٌ':Subject, #12: 12	كَانَ الشَّعْرُ
u'كَانَ شَعَرٌ':Subject, #1: 1	كَانَ الشِّعْرُ
u'كَانَ شَعْرٌ':Subject, #1: 1	كَانَ شَعَرُ
u'كَانَ شَعْرٌ':Subject, #3: 3	كَانَ شَعْرُهُ
u'كَانَ شُعرَاءُ':Subject, #7: 7	كَانَ شَعْرُ
u'كَانَ شُعَرَاءُ':Subject, #1: 1	كَانَ شُعَرَاءُ
u'كَانَ شَعِيرٌ':Subject, #1: 1	كَانَ شُعَرَاءُ
u'كَانَ شُغْلٌ':Subject, #5: 5	كَانَ الشَّعِيرُ
u'كَانَ شُغْل':Subject, #2: 2	كَانَ الشُّغْلُ
u'كَانَ شِفَاءٌ':Subject, #2: 2	كَانَ الشُّغْلُ
u'كَانَ شفعاء':Subject, #1: 1	كَانَ شِفَاءُ
u'كَانَ شَفِيعٌ':Subject, #1: 1	كَانَ الشُّفَعَاءُ
u'كَانَ شَقٌّ':Subject, #47: 47	كَانَ الشَّفِيعُ
u'كَانَ شقاق':Subject, #7: 7	كَانَ الشَّقُّ
u'كَانَ شِقَاقٌ':Subject, #1: 1	كَانَ شِقَاقٌ
u'كَانَ شَكٌّ':Predicate, #1: 1	كَانَ شِقَاقٌ
u'كَانَ شَكٌّ':Subject, #4: 4	كَانَ شَكَّ
u'كَانَ شَكٌّ':Subject, #21: 21	كَانَ الشَّكُّ
u'كَانَ شكر':Subject, #7: 7	كَانَ شَكُّهُ
u'كَانَ شُكْرٌ':Subject, #2: 2	كَانَ الشُّكْرُ
u'كَانَ شَمَّاسٌ':Subject, #2: 2	كَانَ الشُّكْرُ
u'كَانَ شمس':Subject, #1: 1	كَانَ شَمّاسٌ
u'كَانَ شَمْسٌ':Subject, #4: 4	كَانَ شَمْسُ
u'كَانَ شَمِط':Predicate, #4: 4	كَانَ شَمْسُ
u'كَانَ شَمْعٌ':Subject, #1: 1	كَانَ شَمِطَ
u'كَانَ شُمُول':Subject, #1: 1	كَانَ الشَّمْعُ
u'كَانَ شَنِيعٌ':Predicate, #1: 1	كَانَ الشُّمُولُ
u'كَانَ شَهَادَةٌ':Subject, #1: 1	كَانَ شَنِيعَ
u'كَانَ شَهْرٌ':Predicate, #1: 1	كَانَ شَهَادَتُهُ
u'كَانَ شَهْرٌ':Subject, #1: 1	كَانَ شَهْرَ
u'كَانَ شَهْرٌ':Subject, #10: 10	كَانَ الشَّهْرُ
u'كَانَ شَهْرٌ':Subject, #1: 1	كَانَ الشّهْرُ
u'كَانَ شُهُودٌ':Subject, #5: 5	كَانَ شَهْرُ
u'كَانَ شُهُودٌ':Subject, #29: 29	كَانَ شُهُودُ
u'كَانَ شُهُودٌ':Subject, #45: 45	كَانَ الشُّهُودُ
u'كَانَ شَهِيدٌ':Subject, #4: 4	كَانَ شُهُودُهُ
u'كَانَ شَوَّالٌ':Subject, #1: 1	كَانَ الشَّهِيدُ
u'كَانَ شَوْكَةٌ':Subject, #3: 3	كَانَ شَوَّالٌ
u'كَانَ شُؤْمٌ':Subject, #1: 1	كَانَ الشَّوْكَةُ
u'كَانَ شَيْءٌ':Predicate, #4: 4	كَانَ الشُّؤْمُ
u'كَانَ شَيْءٌ':Subject, #1: 1	كَانَ الشَّيْءَ
u'كَانَ شَيْءٌ':Subject, #19: 19	كَانَ الشَّيْءُ
u'كَانَ شَيْءٌ':Subject, #1: 1	كَانَ الشّيْءُ
u'كَانَ شيب':Subject, #47: 47	كَانَ شَيْءٌ
u'كَانَ شَيْبٌ':Subject, #1: 1	كَانَ شَيْبُهُ
u'كَانَ شَيْخٌ':Predicate, #1: 1	كَانَ شَيْبُهُ
u'كَانَ شَيْخٌ':Subject, #2: 2	كَانَ شَيْخَ
u'كَانَ شَيْخٌ':Subject, #18: 18	كَانَ الشَّيْخُ
u'كَانَ شَيْخٌ':Subject, #1: 1	كَانَ شَيْخٌ
u'كَانَ شَيْطَانٌ':Subject, #2: 2	كَانَ شَيْخُ
u'كَانَ شَيْطَانٌ':Subject, #1: 1	كَانَ الشّيْطَانُ
u'كَانَ شَيْنٌ':Subject, #6: 6	كَانَ الشَّيْطَانُ
u'كَانَ شُيُوخٌ':Subject, #1: 1	كَانَ الشَّيْنُ
u'كَانَ شُيُوخٌ':Subject, #1: 1	كَانَ الشُّيُوخُ
u'كَانَ صابِغ':Subject, #1: 1	كَانَ شُيُوخُ
u'كَانَ صَاحِبٌ':Predicate, #2: 2	كَانَ الصَّابِغُ
u'كَانَ صَاحِبٌ':Subject, #44: 44	كَانَ صَاحِبَ
u'كَانَ صَاحِبٌ':Subject, #129: 129	كَانَ صَاحِبُ
u'كَانَ صَادٌّ':Subject, #26: 26	كَانَ صَاحِبُهُ
u'كَانَ صَادِرٌ':Subject, #1: 1	كَانَ الصَّادُّ
u'كَانَ صَادِقٌ':Predicate, #4: 4	كَانَ الصَّادِرُ
u'كَانَ صَادِقٌ':Subject, #4: 4	كَانَ صَادِقَ
u'كَانَ صَاعٌ':Subject, #2: 2	كَانَ الصَّادِقُ
u'كَانَ صَاعٌ':Subject, #2: 2	كَانَ الصَّاعُ
u'كَانَ صَالِحٌ':Predicate, #4: 4	كَانَ صَاعُ
u'كَانَ صَالِح':Predicate, #1: 1	كَانَ صَالِحَ
u'كَانَ صَالِحٌ':Subject, #1: 1	كَانَ صَالِحَ
u'كَانَ صَالِح':Subject, #1: 1	كَانَ الصَّالِحُ
u'كَانَ صَالِحٌ':Subject, #1: 1	كَانَ الصَّالِحُ
u'كَانَ صَالِح':Subject, #1: 1	كَانَ صَالِحٌ
u'كَانَ صَالِحٌ':Subject, #1: 1	كَانَ صَالِحٌ
u'كَانَ صَالِح':Subject, #2: 2	كَانَ صَالِحُ
u'كَانَ صَانِعٌ':Subject, #2: 2	كَانَ صَالِحُ
u'كَانَ صَائِدٌ':Subject, #12: 12	كَانَ الصَّانِعُ
u'كَانَ صَبٌّ':Subject, #1: 1	كَانَ الصَّائِدُ
u'كَانَ صَبَّاغٌ':Subject, #2: 2	كَانَ صَبُّ
u'كَانَ صِبَاغٌ':Subject, #1: 1	كَانَ الصَّبَّاغُ
u'كَانَ صبر':Predicate, #1: 1	كَانَ الصِّبَاغُ
u'كَانَ صبر':Subject, #1: 1	كَانَ صَبَرَ
u'كَانَ صَبْرٌ':Subject, #3: 3	كَانَ الصَّبْرُ
u'كَانَ صِبْغٌ':Subject, #3: 3	كَانَ الصَّبْرُ
u'كَانَ صَبْغٌ':Subject, #1: 1	كَانَ الصِّبْغُ
u'كَانَ صَبْغٌ':Subject, #1: 1	كَانَ صَبْغُهُ
u'كَانَ صَبِيٌّ':Predicate, #9: 9	كَانَ الصَّبْغُ
u'كَانَ صَبِيٌّ':Subject, #2: 2	كَانَ صَبِيَّةً
u'كَانَ صَبِيٌّ':Subject, #6: 6	كَانَ صَبِيٌّ
u'كَانَ صِبْيَانٌ':Subject, #88: 88	كَانَ الصَّبِيُّ
u'كَانَ صِبْيَانٌ':Subject, #1: 1	كَانَ الصِّبْيَانُ
u'كَانَ صَبِيحٌ':Subject, #1: 1	كَانَ صِبْيَانُهُ
u'كَانَ صَحَابَةٌ':Subject, #2: 2	كَانَ صَبِيحَةُ
u'كَانَ صَحَابِيٌّ':Subject, #4: 4	كَانَ الصَّحَابَةُ
u'كَانَ صحاح':Subject, #2: 2	كَانَ الصَّحَابِيُّ
u'كَانَ صِحَّةٌ':Predicate, #1: 1	كَانَ صِحَاحُهُ
u'كَانَ صِحَّةٌ':Subject, #1: 1	كَانَ الصِّحَّةَ
u'كَانَ صَحْرَاءُ':Predicate, #3: 3	كَانَ صِحَّةُ
u'كَانَ صَحْنٌ':Subject, #1: 1	كَانَ صَحْرَاءَ
u'كَانَ صَحْنٌ':Subject, #1: 1	كَانَ الصَّحْنُ
u'كَانَ صَحْوٌ':Subject, #1: 1	كَانَ صَحْنُ
u'كَانَ صَحْوٌ':Subject, #1: 1	كَانَ الصَّحْوُ
u'كَانَ صَحِيحٌ':Predicate, #1: 1	كَانَ صَحْوٌ
u'كَانَ صَحِيحٌ':Subject, #7: 7	كَانَ صَحِيحَ
u'كَانَ صداق':Subject, #19: 19	كَانَ الصَّحِيحُ
u'كَانَ صَدَاقٌ':Subject, #29: 29	كَانَ الصَّدَاقُ
u'كَانَ صداق':Subject, #29: 29	كَانَ الصَّدَاقُ
u'كَانَ صَدَاقٌ':Subject, #3: 3	كَانَ صَدَاقُهُ
u'كَانَ صداق':Subject, #3: 3	كَانَ صَدَاقُهُ
u'كَانَ صَدَاقٌ':Subject, #4: 4	كَانَ صَدَاقُ
u'كَانَ صَدْرٌ':Subject, #4: 4	كَانَ صَدَاقُ
u'كَانَ صَدْرٌ':Subject, #1: 1	كَانَ الصَّدْرُ
u'كَانَ صدق':Predicate, #1: 1	كَانَ صَدْرُ
u'كَانَ صدق':Subject, #2: 2	كَانَ صَدَقَ
u'كَانَ صِدْقٌ':Subject, #2: 2	كَانَ الصِّدْقُ
u'كَانَ صَدُقَةٌ':Subject, #2: 2	كَانَ الصِّدْقُ
u'كَانَ صدقة':Subject, #1: 1	كَانَ الصَّدُقَاتُ
u'كَانَ صَدَقَةٌ':Subject, #1: 1	كَانَ صَدَقَةُ
u'كَانَ صَدِيقٌ':Subject, #1: 1	كَانَ صَدَقَةُ
u'كَانَ صِدِّيقٌ':Subject, #1: 1	كَانَ الصَّدِيقُ
u'كَانَ صَدِيقٌ':Subject, #1: 1	كَانَ الصّدّيقُ
u'كَانَ صِدِّيقٌ':Subject, #1: 1	كَانَ صَدِيقُهُ
u'كَانَ صَرْفٌ':Subject, #2: 2	كَانَ الصِّدِّيقُ
u'كَانَ صَرْف':Subject, #2: 2	كَانَ صَرْفُ
u'كَانَ صَرْفٌ':Subject, #2: 2	كَانَ صَرْفُ
u'كَانَ صَرْف':Subject, #3: 3	كَانَ صَرْفُهُ
u'كَانَ صَرْفٌ':Subject, #3: 3	كَانَ صَرْفُهُ
u'كَانَ صَرْف':Subject, #5: 5	كَانَ الصَّرْفُ
u'كَانَ صَرِيحٌ':Predicate, #5: 5	كَانَ الصَّرْفُ
u'كَانَ صَرِيحٌ':Subject, #1: 1	كَانَ صَرِيحَ
u'كَانَ صَعْبٌ':Subject, #2: 2	كَانَ الصَّرِيحُ
u'كَانَ صغار':Subject, #1: 1	كَانَ الصَّعْبُ
u'كَانَ صِغَرٌ':Subject, #1: 1	كَانَ الصِّغَارُ
u'كَانَ صَغِيرٌ':Predicate, #3: 3	كَانَ الصِّغَرُ
u'كَانَ صَغِيرٌ':Predicate, #1: 1	كَانَ صَغِيرَ
u'كَانَ صَغِيرٌ':Subject, #2: 2	كَانَ صَغِيرَةً
u'كَانَ صَفٌّ':Predicate, #43: 43	كَانَ الصَّغِيرُ
u'كَانَ صَفٌّ':Subject, #1: 1	كَانَ الصَّفَّ
u'كَانَ صَفٌّ':Subject, #1: 1	كَانَ الصَّفُّ
u'كَانَ صِفَةٌ':Subject, #4: 4	كَانَ صَفٌّ
u'كَانَ صِفَةٌ':Subject, #1: 1	كَانَ الصِّفَةُ
u'كَانَ صفح':Subject, #1: 1	كَانَ صِفَتُهُ
u'كَانَ صَفْحٌ':Subject, #1: 1	كَانَ الصَّفْحُ
u'كَانَ صفر':Subject, #1: 1	كَانَ الصَّفْحُ
u'كَانَ صَفَرٌ':Subject, #1: 1	كَانَ صَفَرٌ
u'كَانَ صفر':Subject, #1: 1	كَانَ صَفَرٌ
u'كَانَ صُفْرٌ':Subject, #2: 2	كَانَ الصُّفْرُ
u'كَانَ صَفْوٌ':Subject, #2: 2	كَانَ الصُّفْرُ
u'كَانَ صَفْوَان':Subject, #1: 1	كَانَ صَفْوُ
u'كَانَ صَقْرٌ':Subject, #3: 3	كَانَ صَفْوَانُ
u'كَانَ صَكٌّ':Subject, #1: 1	كَانَ الصَّقْرُ
u'كَانَ صَكٌّ':Subject, #1: 1	كَانَ صَكُّ
u'كَانَ صَلاَةٌ':Predicate, #5: 5	كَانَ الصَّكُّ
u'كَانَ صَلاَةٌ':Subject, #1: 1	كَانَ صَلاَةَ
u'كَانَ صَلاَةٌ':Subject, #1: 1	كَانَ صَلَاةٌ
u'كَانَ صَلاَةٌ':Subject, #2: 2	كَانَ الصَّلَاةُ
u'كَانَ صَلاَةٌ':Subject, #2: 2	كَانَ صَلَاتُهُ
u'كَانَ صَلاَةٌ':Subject, #3: 3	كَانَ صَلَاةُ
u'كَانَ صَلاَحٌ':Subject, #4: 4	كَانَ صَلاَةُ
u'كَانَ صَلاَحٌ':Subject, #1: 1	كَانَ الصَّلَاحُ
u'كَانَ صَلاَحٌ':Subject, #2: 2	كَانَ صَلَاحُ
u'كَانَ صلْبٌ':Predicate, #2: 2	كَانَ صَلَاحُهُ
u'كَانَ صلح':Predicate, #1: 1	كَانَ صُلْبَ
u'كَانَ صلح':Predicate, #1: 1	كَانَ صَلَحَ
u'كَانَ صلح':Predicate, #1: 1	كَانَ صَلُحَ
u'كَانَ صُلْحٌ':Predicate, #1: 1	كَانَ صُلْحَ
u'كَانَ صلح':Subject, #1: 1	كَانَ صُلْحَ
u'كَانَ صُلْحٌ':Subject, #2: 2	كَانَ صُلْحُ
u'كَانَ صلح':Subject, #2: 2	كَانَ صُلْحُ
u'كَانَ صُلْحٌ':Subject, #95: 95	كَانَ الصُّلْحُ
u'كَانَ صَلِيبٌ':Subject, #95: 95	كَانَ الصُّلْحُ
u'كَانَ صمت':Subject, #3: 3	كَانَ الصَّلِيبُ
u'كَانَ صَمْتٌ':Subject, #1: 1	كَانَ صَمْتُهُ
u'كَانَ صَمَمٌ':Subject, #1: 1	كَانَ صَمْتُهُ
u'كَانَ صِنَاعَةٌ':Subject, #1: 1	كَانَ الصَّمَمُ
u'كَانَ صُنْدُوقٌ':Subject, #2: 2	كَانَ صِنَاعَتُهُ
u'كَانَ صُنْدُوقٌ':Subject, #1: 1	كَانَ صُنْدُوقُ
u'كَانَ صنع':Predicate, #3: 3	كَانَ الصُّنْدُوقُ
u'كَانَ صِنْفٌ':Subject, #2: 2	كَانَ صَنَعَ
u'كَانَ صَوَابٌ':Subject, #2: 2	كَانَ الصِّنْفُ
u'كَانَ صَوَابٌ':Subject, #10: 10	كَانَ الصَّوَابُ
u'كَانَ صَوَابٌ':Subject, #1: 1	كَانَ صَوَابُ
u'كَانَ صَوْتٌ':Subject, #3: 3	كَانَ صَوَابُهُ
u'كَانَ صُوفٌ':Subject, #2: 2	كَانَ صَوْتُ
u'كَانَ صَوْل':Subject, #1: 1	كَانَ صُوفُ
u'كَانَ صَوْمٌ':Predicate, #1: 1	كَانَ الصَّوْلُ
u'كَانَ صَوْمٌ':Subject, #1: 1	كَانَ صَوْمَ
u'كَانَ صَوْمٌ':Subject, #24: 24	كَانَ الصَّوْمُ
u'كَانَ صَوْمٌ':Subject, #3: 3	كَانَ صَوْمُ
u'كَانَ صِيَامٌ':Subject, #8: 8	كَانَ صَوْمُهُ
u'كَانَ صِيَامٌ':Subject, #1: 1	كَانَ الصِّيَامُ
u'كَانَ صِيَامٌ':Subject, #1: 1	كَانَ صِيَامُ
u'كَانَ صِيَانَةٌ':Subject, #1: 1	كَانَ صِيَامُهُ
u'كَانَ صَيْدٌ':Predicate, #1: 1	كَانَ صِيَانَةُ
u'كَانَ صَيْدٌ':Subject, #3: 3	كَانَ صَيْدَ
u'كَانَ صَيْدٌ':Subject, #1: 1	كَانَ صَيْدُ
u'كَانَ صِيعَانٌ':Subject, #32: 32	كَانَ الصَّيْدُ
u'كَانَ صِيغَةٌ':Predicate, #1: 1	كَانَ الصِّيعَانُ
u'كَانَ صَيْفٌ':Subject, #1: 1	كَانَ صِيغَةَ
u'كَانَ ضَارِبٌ':Subject, #3: 3	كَانَ الصَّيْفُ
u'كَانَ ضَامِنٌ':Subject, #6: 6	كَانَ الضَّارِبُ
u'كَانَ ضَبْطٌ':Subject, #7: 7	كَانَ الضَّامِنُ
u'كَانَ ضحك':Predicate, #1: 1	كَانَ الضّبْطُ
u'كَانَ ضَحِكٌ':Predicate, #3: 3	كَانَ ضَحِكَ
u'كَانَ ضَحِكٌ':Subject, #3: 3	كَانَ ضَحِكَ
u'كَانَ ضحك':Subject, #1: 1	كَانَ ضَحِكٌ
u'كَانَ ضَحِكٌ':Subject, #1: 1	كَانَ ضَحِكُهُ
u'كَانَ ضَخْمٌ':Predicate, #1: 1	كَانَ ضَحِكُهُ
u'كَانَ ضَرٌّ':Predicate, #1: 1	كَانَ ضَخْمَ
u'كَانَ ضَرَبٌ':Predicate, #1: 1	كَانَ ضَرَّكَ
u'كَانَ ضَرْبٌ':Subject, #4: 4	كَانَ ضَرَبَ
u'كَانَ ضَرْبٌ':Subject, #5: 5	كَانَ ضَرْبُ
u'كَانَ ضَرَرٌ':Subject, #6: 6	كَانَ الضَّرْبُ
u'كَانَ ضَرَرٌ':Subject, #12: 12	كَانَ الضَّرَرُ
u'كَانَ ضَرَرٌ':Subject, #1: 1	كَانَ ضَرَرٌ
u'كَانَ ضَرَرٌ':Subject, #2: 2	كَانَ ضَرَرُهُ
u'كَانَ ضَرُورَةٌ':Predicate, #5: 5	كَانَ ضَرَرُ
u'كَانَ ضَرُورَةٌ':Subject, #3: 3	كَانَ ضَرُورَةَ
u'كَانَ ضَرُورِيٌّ':Subject, #1: 1	كَانَ ضَرُورَةٌ
u'كَانَ ضَرِيرٌ':Predicate, #1: 1	كَانَ ضَرُورِيُّ
u'كَانَ ضَرِيرٌ':Subject, #1: 1	كَانَ ضَرِيرَ
u'كَانَ ضِعْفٌ':Predicate, #1: 1	كَانَ ضَرِيرُ
u'كَانَ ضِعْفٌ':Subject, #2: 2	كَانَ ضِعْفَ
u'كَانَ ضَعِيفٌ':Predicate, #1: 1	كَانَ ضِعْفُ
u'كَانَ ضلال':Subject, #4: 4	كَانَ ضَعِيفَ
u'كَانَ ضَلاَلٌ':Subject, #1: 1	كَانَ الضَّلَالُ
u'كَانَ ضلال':Subject, #1: 1	كَانَ الضَّلَالُ
u'كَانَ ضَلاَلٌ':Subject, #2: 2	كَانَ ضَلَالُهُ
u'كَانَ ضَمٌّ':Subject, #2: 2	كَانَ ضَلَالُهُ
u'كَانَ ضَمَانٌ':Predicate, #2: 2	كَانَ الضَّمُّ
u'كَانَ ضَمَانٌ':Subject, #6: 6	كَانَ ضَمَانَ
u'كَانَ ضَمَانٌ':Subject, #10: 10	كَانَ ضَمَانُ
u'كَانَ ضَمَانٌ':Subject, #55: 55	كَانَ الضَّمَانُ
u'كَانَ ضَمِنٌ':Predicate, #9: 9	كَانَ ضَمَانُهُ
u'كَانَ ضَمِيرٌ':Subject, #8: 8	كَانَ ضَمِنَ
u'كَانَ ضَمِيرٌ':Subject, #2: 2	كَانَ ضَمِيرُ
u'كَانَ ضِيَاءٌ':Subject, #7: 7	كَانَ الضَّمِيرُ
u'كَانَ ضَيْفٌ':Subject, #1: 1	كَانَ الضّيَاءُ
u'كَانَ ضَيِّقٌ':Predicate, #2: 2	كَانَ الضَّيْفُ
u'كَانَ ضِيقٌ':Subject, #3: 3	كَانَ ضَيِّقَ
u'كَانَ طَارِئٌ':Subject, #1: 1	كَانَ الضِّيقُ
u'كَانَ طَافٌ':Predicate, #2: 2	كَانَ الطَّارِئُ
u'كَانَ طَالِبٌ':Predicate, #23: 23	كَانَ طَافَ
u'كَانَ طَالِبٌ':Subject, #1: 1	كَانَ طَالِبَ
u'كَانَ طَاهِرٌ':Subject, #31: 31	كَانَ الطَّالِبُ
u'كَانَ طَائِرٌ':Subject, #5: 5	كَانَ الطَّاهِرُ
u'كَانَ طَائِفٌ':Predicate, #5: 5	كَانَ الطَّائِرُ
u'كَانَ طَائِفٌ':Subject, #1: 1	كَانَ طَائِفَةً
u'كَانَ طَائِفٌ':Subject, #1: 1	كَانَ الطّائِفُ
u'كَانَ طَائِفٌ':Subject, #1: 1	كَانَ الطَّائِفُ
u'كَانَ طِبٌّ':Subject, #2: 2	كَانَ طَائِفَةٌ
u'كَانَ طِبٌّ':Subject, #1: 1	كَانَ الطِّبُّ
u'كَانَ طَبْخٌ':Subject, #1: 1	كَانَ طِبُّهُ
u'كَانَ طَبْخٌ':Subject, #1: 1	كَانَ الطَّبْخُ
u'كَانَ طَبْعٌ':Subject, #1: 1	كَانَ طَبْخُ
u'كَانَ طَبْلٌ':Predicate, #1: 1	كَانَ طَبْعُهُ
u'كَانَ طَبِيبٌ':Subject, #3: 3	كَانَ طَبْلَ
u'كَانَ طَحِينٌ':Subject, #3: 3	كَانَ الطَّبِيبُ
u'كَانَ طرب':Subject, #4: 4	كَانَ الطَّحِينُ
u'كَانَ طَرَبٌ':Subject, #1: 1	كَانَ الطَّرَبُ
u'كَانَ طَرْحٌ':Subject, #1: 1	كَانَ الطَّرَبُ
u'كَانَ طَرْدٌ':Subject, #3: 3	كَانَ الطَّرْحُ
u'كَانَ طرف':Subject, #1: 1	كَانَ الطَّرْدُ
u'كَانَ طَرَفٌ':Subject, #1: 1	كَانَ الطَّرَفُ
u'كَانَ طرف':Subject, #1: 1	كَانَ الطَّرَفُ
u'كَانَ طَرَفٌ':Subject, #2: 2	كَانَ طَرَفُهُ
u'كَانَ طرف':Subject, #2: 2	كَانَ طَرَفُهُ
u'كَانَ طَرَفٌ':Subject, #4: 4	كَانَ طَرَفُ
u'كَانَ طَرِيقٌ':Subject, #4: 4	كَانَ طَرَفُ
u'كَانَ طَرِيقٌ':Subject, #14: 14	كَانَ طَرِيقُ
u'كَانَ طَرِيقٌ':Subject, #14: 14	كَانَ طَرِيقُهُ
u'كَانَ طَرِيقٌ':Subject, #1: 1	كَانَ طَرِيقٌ
u'كَانَ طعام':Predicate, #44: 44	كَانَ الطَّرِيقُ
u'كَانَ طَعَامٌ':Predicate, #3: 3	كَانَ طَعَامَ
u'كَانَ طعام':Subject, #3: 3	كَانَ طَعَامَ
u'كَانَ طَعَامٌ':Subject, #1: 1	كَانَ طَعَامُ
u'كَانَ طعام':Subject, #1: 1	كَانَ طَعَامُ
u'كَانَ طَعَامٌ':Subject, #3: 3	كَانَ طَعَامُهُ
u'كَانَ طعام':Subject, #3: 3	كَانَ طَعَامُهُ
u'كَانَ طَعَامٌ':Subject, #56: 56	كَانَ الطَّعَامُ
u'كَانَ طَعْمٌ':Subject, #56: 56	كَانَ الطَّعَامُ
u'كَانَ طَعْنٌ':Subject, #3: 3	كَانَ الطَّعْمُ
u'كَانَ طَعْنٌ':Subject, #1: 1	كَانَ طَعْنُ
u'كَانَ طِفْلٌ':Subject, #1: 1	كَانَ طَعْنُهُ
u'كَانَ طَلاَقٌ':Subject, #3: 3	كَانَ الطِّفْلُ
u'كَانَ طَلاَقٌ':Subject, #192: 192	كَانَ الطَّلَاقُ
u'كَانَ طَلاَقٌ':Subject, #2: 2	كَانَ الطَّلاَقُ
u'كَانَ طَلاَقٌ':Subject, #2: 2	كَانَ طَلَاقُهُ
u'كَانَ طلب':Predicate, #4: 4	كَانَ طَلَاقُ
u'كَانَ طَلَبٌ':Predicate, #4: 4	كَانَ طَلَبَ
u'كَانَ طلب':Subject, #4: 4	كَانَ طَلَبَ
u'كَانَ طَلَبٌ':Subject, #4: 4	كَانَ طَلَبُ
u'كَانَ طلب':Subject, #4: 4	كَانَ طَلَبُ
u'كَانَ طَلَبٌ':Subject, #5: 5	كَانَ طَلَبُهُ
u'كَانَ طلب':Subject, #5: 5	كَانَ طَلَبُهُ
u'كَانَ طَلَبٌ':Subject, #6: 6	كَانَ الطَّلَبُ
u'كَانَ طَلْحٌ':Subject, #6: 6	كَانَ الطَّلَبُ
u'كَانَ طلحة':Subject, #2: 2	كَانَ طَلْحَةُ
u'كَانَ طَلْعٌ':Subject, #2: 2	كَانَ طَلْحَةُ
u'كَانَ طُلُوعٌ':Subject, #1: 1	كَانَ الطَّلْعُ
u'كَانَ طهر':Subject, #1: 1	كَانَ الطُّلُوعُ
u'كَانَ طُهْرٌ':Subject, #17: 17	كَانَ الطُّهْرُ
u'كَانَ طَهُورٌ':Subject, #17: 17	كَانَ الطُّهْرُ
u'كَانَ طواف':Predicate, #2: 2	كَانَ الطَّهُورُ
u'كَانَ طَوَافٌ':Predicate, #2: 2	كَانَ طَوَافَ
u'كَانَ طواف':Subject, #2: 2	كَانَ طَوَافَ
u'كَانَ طَوَافٌ':Subject, #10: 10	كَانَ الطَّوَافُ
u'كَانَ طواف':Subject, #10: 10	كَانَ الطَّوَافُ
u'كَانَ طَوَافٌ':Subject, #2: 2	كَانَ طَوَافُهُ
u'كَانَ طواف':Subject, #2: 2	كَانَ طَوَافُهُ
u'كَانَ طَوَافٌ':Subject, #5: 5	كَانَ طَوَافُ
u'كَانَ طَوْعٌ':Subject, #5: 5	كَانَ طَوَافُ
u'كَانَ طُولٌ':Subject, #1: 1	كَانَ الطَّوْعُ
u'كَانَ طُولٌ':Subject, #2: 2	كَانَ طُولُ
u'كَانَ طَوِيلٌ':Predicate, #4: 4	كَانَ طُولُهُ
u'كَانَ طَيِّبٌ':Predicate, #4: 4	كَانَ طَوِيلَ
u'كَانَ طِيبٌ':Subject, #3: 3	كَانَ طَيِّبَ
u'كَانَ طَيِّبٌ':Subject, #17: 17	كَانَ الطِّيبُ
u'كَانَ طَيِّبٌ':Subject, #1: 1	كَانَ الطَّيِّبُ
u'كَانَ طَيْرٌ':Subject, #1: 1	كَانَ طَيِّبُهُ
u'كَانَ طَيْرٌ':Subject, #1: 1	كَانَ طَيْرٌ
u'كَانَ طِينٌ':Subject, #5: 5	كَانَ الطَّيْرُ
u'كَانَ طِينٌ':Subject, #1: 1	كَانَ طِينٌ
u'كَانَ ظالِمٌ':Subject, #6: 6	كَانَ الطِّينُ
u'كَانَ ظاهِرٌ':Predicate, #1: 1	كَانَ الظَّالِمُ
u'كَانَ ظاهِرٌ':Subject, #4: 4	كَانَ ظَاهِرَ
u'كَانَ ظاهِرٌ':Subject, #17: 17	كَانَ ظَاهِرُهُ
u'كَانَ ظاهِرٌ':Subject, #1: 1	كَانَ ظَاهِرٌ
u'كَانَ ظاهِرٌ':Subject, #41: 41	كَانَ الظَّاهِرُ
u'كَانَ ظَرْفٌ':Predicate, #44: 44	كَانَ ظَاهِرُ
u'كَانَ ظَرْفٌ':Subject, #1: 1	كَانَ ظَرْفَ
u'كَانَ ظَرْفٌ':Subject, #1: 1	كَانَ الظّرْفُ
u'كَانَ ظَرْفٌ':Subject, #1: 1	كَانَ ظَرْفُ
u'كَانَ ظَفَرٌ':Subject, #3: 3	كَانَ الظَّرْفُ
u'كَانَ ظُفْرٌ':Subject, #1: 1	كَانَ الظّفَرُ
u'كَانَ ظِلٌّ':Subject, #2: 2	كَانَ ظُفْرُهُ
u'كَانَ ظِلٌّ':Subject, #13: 13	كَانَ ظِلُّ
u'كَانَ ظِلٌّ':Subject, #1: 1	كَانَ ظِلٌّ
u'كَانَ ظِلٌّ':Subject, #2: 2	كَانَ الظِّلُّ
u'كَانَ ظِلٌّ':Subject, #3: 3	كَانَ ظِلّهُ
u'كَانَ ظُلْمٌ':Subject, #5: 5	كَانَ ظِلُّهُ
u'كَانَ ظُلْمٌ':Subject, #1: 1	كَانَ الظّلْمُ
u'كَانَ ظُلْمٌ':Subject, #1: 1	كَانَ الظُّلْمُ
u'كَانَ ظَنٌّ':Predicate, #1: 1	كَانَ ظُلْمُهُ
u'كَانَ ظَنٌّ':Subject, #2: 2	كَانَ ظَنَّ
u'كَانَ ظَنٌّ':Subject, #2: 2	كَانَ ظَنُّ
u'كَانَ ظَنٌّ':Subject, #3: 3	كَانَ ظَنُّهُ
u'كَانَ ظهار':Subject, #7: 7	كَانَ الظَّنُّ
u'كَانَ ظُهْرٌ':Subject, #4: 4	كَانَ الظِّهَارُ
u'كَانَ ظَهْرٌ':Subject, #1: 1	كَانَ الظُّهْرُ
u'كَانَ ظَهْرٌ':Subject, #3: 3	كَانَ ظَهْرُ
u'كَانَ ظُهورٌ':Subject, #4: 4	كَانَ ظَهْرُهُ
u'كَانَ ظُهورٌ':Subject, #2: 2	كَانَ ظُهُورُهُ
u'كَانَ عَادٌ':Predicate, #4: 4	كَانَ ظُهُورُ
u'كَانَ عَادَةٌ':Predicate, #3: 3	كَانَ عَادَ
u'كَانَ عَادَةٌ':Subject, #4: 4	كَانَ عَادَةَ
u'كَانَ عَادَةٌ':Subject, #1: 1	كَانَ عَادَةُ
u'كَانَ عادِم':Subject, #9: 9	كَانَ عَادَتُهُ
u'كَانَ عَارٌ':Subject, #1: 1	كَانَ الْعَادِمُ
u'كَانَ عارِيَّةٌ':Predicate, #1: 1	كَانَ الْعَارُ
u'كَانَ عَاصِمٌ':Subject, #1: 1	كَانَ عَارِيَّةَ
u'كَانَ عَاقِبٌ':Subject, #2: 2	كَانَ عَاصِمٌ
u'كَانَ عَاقِبَةٌ':Subject, #3: 3	كَانَ عَاقِبَةُ
u'كَانَ عَاقِدٌ':Subject, #3: 3	كَانَ عَاقِبَةُ
u'كَانَ عَاقِرٌ':Subject, #30: 30	كَانَ الْعَاقِدُ
u'كَانَ عَاقِلٌ':Predicate, #2: 2	كَانَ عَاقِرُ
u'كَانَ عَاقِلٌ':Subject, #1: 1	كَانَ عَاقِلاً
u'كَانَ عَاقِلٌ':Subject, #1: 1	كَانَ الْعَاقِلُ
u'كَانَ عَالَمٌ':Subject, #1: 1	كَانَ عَاقِلَةُ
u'كَانَ عَالِمٌ':Subject, #2: 2	كَانَ الْعَالَمُ
u'كَانَ عَامٌّ':Predicate, #4: 4	كَانَ الْعَالِمُ
u'كَانَ عَامٌّ':Predicate, #1: 1	كَانَ الْعَامَّ
u'كَانَ عَامٌ':Predicate, #2: 2	كَانَ عَامَّةَ
u'كَانَ عَامٌ':Subject, #4: 4	كَانَ عَامَ
u'كَانَ عَامٌّ':Subject, #10: 10	كَانَ الْعَامُ
u'كَانَ عَامٌ':Subject, #13: 13	كَانَ الْعَامُّ
u'كَانَ عَامٌّ':Subject, #4: 4	كَانَ عَامٌ
u'كَانَ عَامٌ':Subject, #4: 4	كَانَ عَامَّةُ
u'كَانَ عَامِرٌ':Subject, #7: 7	كَانَ عَامُ
u'كَانَ عَامِلٌ':Predicate, #2: 2	كَانَ عَامِرٌ
u'كَانَ عَامِلٌ':Predicate, #2: 2	كَانَ عَامِلَ
u'كَانَ عَامِلٌ':Subject, #5: 5	كَانَ عَامِلاً
u'كَانَ عَامِّيٌّ':Subject, #50: 50	كَانَ الْعَامِلُ
u'كَانَ عَائِدٌ':Subject, #2: 2	كَانَ الْعَامِّيُّ
u'كَانَ عَائِلٌ':Predicate, #1: 1	كَانَ الْعَائِدُ
u'كَانَ عِبَادٌ':Subject, #1: 1	كَانَ عَائِلاً
u'كَانَ عِبَارَةٌ':Subject, #2: 2	كَانَ الْعِبَادُ
u'كَانَ عَبَّاسٌ':Subject, #2: 2	كَانَ عِبَارَةٌ
u'كَانَ عَبَّاسٌ':Subject, #1: 1	كَانَ الْعَبّاسُ
u'كَانَ عَبَّاسٌ':Subject, #1: 1	كَانَ عَبَّاسٌ
u'كَانَ عَبَثٌ':Subject, #6: 6	كَانَ الْعَبَّاسُ
u'كَانَ عَبْدٌ':Predicate, #1: 1	كَانَ الْعَبَثُ
u'كَانَ عَبْدٌ':Subject, #12: 12	كَانَ عَبْدَ
u'كَانَ عَبْدٌ':Subject, #35: 35	كَانَ عَبْدٌ
u'كَانَ عَبْدٌ':Subject, #3: 3	كَانَ عَبْدُهُ
u'كَانَ عَبْدٌ':Subject, #481: 481	كَانَ الْعَبْدُ
u'كَانَ عبرة':Subject, #72: 72	كَانَ عَبْدُ
u'كَانَ عِبْرَةٌ':Subject, #1: 1	كَانَ الْعِبْرَةُ
u'كَانَ عُبُورٌ':Subject, #1: 1	كَانَ الْعِبْرَةُ
u'كَانَ عَبِيدٌ':Subject, #1: 1	كَانَ الْعُبُورُ
u'كَانَ عَبِيدٌ':Subject, #1: 1	كَانَ عَبِيدُ
u'كَانَ عَبِيدٌ':Subject, #1: 1	كَانَ عَبِيدُهُ
u'كَانَ عتاق':Subject, #4: 4	كَانَ الْعَبِيدُ
u'كَانَ عتبة':Subject, #1: 1	كَانَ الْعَتَاقُ
u'كَانَ عتق':Predicate, #3: 3	كَانَ عُتْبَةُ
u'كَانَ عتق':Subject, #4: 4	كَانَ عَتَقَ
u'كَانَ عِتْقٌ':Subject, #10: 10	كَانَ عِتْقُهُ
u'كَانَ عتق':Subject, #10: 10	كَانَ عِتْقُهُ
u'كَانَ عِتْقٌ':Subject, #37: 37	كَانَ الْعِتْقُ
u'كَانَ عِتْقٌ':Subject, #37: 37	كَانَ الْعِتْقُ
u'كَانَ عتق':Subject, #4: 4	كَانَ عِتْقٌ
u'كَانَ عِتْقٌ':Subject, #5: 5	كَانَ عِتْقُ
u'كَانَ عَتِيقٌ':Subject, #5: 5	كَانَ عِتْقُ
u'كَانَ عُجْبٌ':Subject, #1: 1	كَانَ الْعَتِيقُ
u'كَانَ عجز':Predicate, #1: 1	كَانَ الْعُجْبُ
u'كَانَ عجز':Subject, #3: 3	كَانَ عَجَزَ
u'كَانَ عَجْزٌ':Subject, #1: 1	كَانَ عَجْزُ
u'كَانَ عَجْزٌ':Subject, #1: 1	كَانَ عَجْزٌ
u'كَانَ عجز':Subject, #1: 1	كَانَ عَجْزُ
u'كَانَ عَجْزٌ':Subject, #4: 4	كَانَ عَجْزُهُ
u'كَانَ عجز':Subject, #4: 4	كَانَ عَجْزُهُ
u'كَانَ عَجْزٌ':Subject, #7: 7	كَانَ الْعَجْزُ
u'كَانَ عَجَمِيٌّ':Subject, #7: 7	كَانَ الْعَجْزُ
u'كَانَ عَدٌّ':Subject, #1: 1	كَانَ الْعَجَمِيُّ
u'كَانَ عَدَّاءٌ':Subject, #1: 1	كَانَ عَدُّ
u'كَانَ عَدَاوَةٌ':Subject, #1: 1	كَانَ الْعَدَّاءُ
u'كَانَ عَدَدٌ':Subject, #1: 1	كَانَ عَدَاوَةٌ
u'كَانَ عَدَدٌ':Subject, #1: 1	كَانَ عَدَدٌ
u'كَانَ عَدَدٌ':Subject, #2: 2	كَانَ عَدَدُهُ
u'كَانَ عَدَدٌ':Subject, #8: 8	كَانَ الْعَدَدُ
u'كَانَ عِدْلٌ':Predicate, #9: 9	كَانَ عَدَدُ
u'كَانَ عَدْلٌ':Predicate, #1: 1	كَانَ عِدْلَ
u'كَانَ عَدْلٌ':Predicate, #2: 2	كَانَ عَدْلاً
u'كَانَ عَدْلٌ':Subject, #3: 3	كَانَ عَدْلَ
u'كَانَ عَدَمٌ':Predicate, #26: 26	كَانَ الْعَدْلُ
u'كَانَ عَدَمٌ':Subject, #1: 1	كَانَ عَدَمَ
u'كَانَ عَدَمٌ':Subject, #40: 40	كَانَ عَدَمُ
u'كَانَ عَدُوٌّ':Subject, #4: 4	كَانَ عَدَمُهُ
u'كَانَ عَدِيمٌ':Predicate, #22: 22	كَانَ الْعَدُوُّ
u'كَانَ عَذَابٌ':Subject, #2: 2	كَانَ عَدِيمَ
u'كَانَ عُذْرٌ':Subject, #1: 1	كَانَ الْعَذَابُ
u'كَانَ عُذْرٌ':Subject, #1: 1	كَانَ عُذْرُهُ
u'كَانَ عُذْرٌ':Subject, #6: 6	كَانَ عُذْرٌ
u'كَانَ عَرَبِيٌّ':Predicate, #9: 9	كَانَ الْعُذْرُ
u'كَانَ عَرَبِيٌّ':Subject, #1: 1	كَانَ عَرَبِيَّ
u'كَانَ عَرْشٌ':Subject, #3: 3	كَانَ الْعَرَبِيُّ
u'كَانَ عَرْضٌ':Subject, #1: 1	كَانَ عَرْشُهُ
u'كَانَ عَرْضٌ':Subject, #1: 1	كَانَ عَرْضُ
u'كَانَ عَرْضٌ':Subject, #2: 2	كَانَ عَرْضُهُ
u'كَانَ عَرَضٌ':Subject, #5: 5	كَانَ الْعَرْضُ
u'كَانَ عرف':Predicate, #6: 6	كَانَ الْعَرَضُ
u'كَانَ عرف':Predicate, #1: 1	كَانَ عُرِفَ
u'كَانَ عُرْفٌ':Predicate, #1: 1	كَانَ عُرْفَ
u'كَانَ عرف':Subject, #1: 1	كَانَ عُرْفَ
u'كَانَ عُرْفٌ':Subject, #33: 33	كَانَ الْعُرْفُ
u'كَانَ عرف':Subject, #33: 33	كَانَ الْعُرْفُ
u'كَانَ عُرْفٌ':Subject, #3: 3	كَانَ عُرْفٌ
u'كَانَ عرف':Subject, #3: 3	كَانَ عُرْفٌ
u'كَانَ عُرْفٌ':Subject, #6: 6	كَانَ عُرْفُ
u'كَانَ عَرَقٌ':Subject, #6: 6	كَانَ عُرْفُ
u'كَانَ عُرْقُوبٌ':Subject, #2: 2	كَانَ الْعَرَقُ
u'كَانَ عُرْقُوبٌ':Subject, #1: 1	كَانَ عُرْقُوبٌ
u'كَانَ عُرْوَةٌ':Predicate, #1: 1	كَانَ عُرْقُوبُ
u'كَانَ عُرْوَةٌ':Subject, #1: 1	كَانَ عُرْوَةَ
u'كَانَ عَرُوسٌ':Subject, #8: 8	كَانَ عُرْوَةُ
u'كَانَ عُرُوقٌ':Subject, #2: 2	كَانَ الْعَرُوسُ
u'كَانَ عزل':Subject, #1: 1	كَانَ عُرُوقُهُ
u'كَانَ عَزْمٌ':Subject, #2: 2	كَانَ الْعَزْلُ
u'كَانَ عَزِيمَةٌ':Predicate, #1: 1	كَانَ الْعَزْمُ
u'كَانَ عسر':Subject, #1: 1	كَانَ الْعَزِيمَةَ
u'كَانَ عُسْرٌ':Subject, #1: 1	كَانَ الْعُسْرُ
u'كَانَ عَسْكَرٌ':Subject, #1: 1	كَانَ الْعُسْرُ
u'كَانَ عَسْكَرٌ':Subject, #1: 1	كَانَ عَسْكَرٌ
u'كَانَ عَسَلٌ':Subject, #4: 4	كَانَ الْعَسْكَرُ
u'كَانَ عَشْرٌ':Predicate, #1: 1	كَانَ الْعَسَلُ
u'كَانَ عَشْرٌ':Predicate, #1: 1	كَانَ عَشْرَةً
u'كَانَ عَشْرٌ':Subject, #1: 1	كَانَ عَشْرَةَ
u'كَانَ عَشْرٌ':Subject, #1: 1	كَانَ عَشْرٌ
u'كَانَ عُشْرٌ':Subject, #2: 2	كَانَ الْعَشْرُ
u'كَانَ عِشْرُون':Predicate, #9: 9	كَانَ الْعُشْرُ
u'كَانَ عِشْقٌ':Subject, #1: 1	كَانَ عِشْرُونَ
u'كَانَ عَشِيَّةٌ':Subject, #1: 1	كَانَ الْعِشْقُ
u'كَانَ عَصَبٌ':Predicate, #1: 1	كَانَ عَشِيَّةُ
u'كَانَ عصبة':Subject, #1: 1	كَانَ عَصَبَ
u'كَانَ عَصَبَةٌ':Subject, #1: 1	كَانَ الْعَصَبَةُ
u'كَانَ عصبة':Subject, #1: 1	كَانَ الْعَصَبَةُ
u'كَانَ عَصَبَةٌ':Subject, #1: 1	كَانَ عَصَبَةُ
u'كَانَ عصبة':Subject, #1: 1	كَانَ عَصَبَةُ
u'كَانَ عَصَبَةٌ':Subject, #1: 1	كَانَ عَصَبَتُهُ
u'كَانَ عَصْرٌ':Subject, #1: 1	كَانَ عَصَبَتُهُ
u'كَانَ عُصْفُر':Subject, #2: 2	كَانَ عَصْرُ
u'كَانَ عَصِيرٌ':Subject, #2: 2	كَانَ الْعُصْفُرُ
u'كَانَ عَضّ':Subject, #1: 1	كَانَ الْعَصِيرُ
u'كَانَ عُضْوٌ':Subject, #1: 1	كَانَ الْعَضُّ
u'كَانَ عَطَاءٌ':Subject, #2: 2	كَانَ الْعُضْوُ
u'كَانَ عَطَاءٌ':Subject, #3: 3	كَانَ الْعَطَاءُ
u'كَانَ عَطَاءٌ':Subject, #4: 4	كَانَ عَطَاءُ
u'كَانَ عَطَشٌ':Subject, #5: 5	كَانَ عَطَاءٌ
u'كَانَ عطف':Subject, #1: 1	كَانَ الْعَطَشُ
u'كَانَ عِطْفٌ':Subject, #1: 1	كَانَ الْعِطْفُ
u'كَانَ عطف':Subject, #1: 1	كَانَ الْعِطْفُ
u'كَانَ عَطْفٌ':Subject, #5: 5	كَانَ الْعَطْفُ
u'كَانَ عَطِيَّةٌ':Predicate, #5: 5	كَانَ الْعَطْفُ
u'كَانَ عَظْمٌ':Predicate, #1: 1	كَانَ عَطِيَّةَ
u'كَانَ عَظْمٌ':Subject, #1: 1	كَانَ عَظْمَ
u'كَانَ عَظْمٌ':Subject, #1: 1	كَانَ عَظْمُ
u'كَانَ عَظِيمٌ':Predicate, #2: 2	كَانَ الْعَظْمُ
u'كَانَ عَظِيم':Predicate, #3: 3	كَانَ عَظِيمَ
u'كَانَ عَفَافٌ':Subject, #3: 3	كَانَ عَظِيمَ
u'كَانَ عَفْوٌ':Subject, #1: 1	كَانَ الْعَفَافُ
u'كَانَ عَفْوٌ':Subject, #4: 4	كَانَ عَفْوُهُ
u'كَانَ عَقَارٌ':Subject, #8: 8	كَانَ الْعَفْوُ
u'كَانَ عَقِبٌ':Predicate, #24: 24	كَانَ الْعَقَارُ
u'كَانَ عَقْدٌ':Predicate, #3: 3	كَانَ عَقِبَ
u'كَانَ عَقْدٌ':Subject, #4: 4	كَانَ عَقْدَ
u'كَانَ عَقْدٌ':Subject, #109: 109	كَانَ الْعَقْدُ
u'كَانَ عَقْدٌ':Subject, #25: 25	كَانَ عَقْدُ
u'كَانَ عقر':Subject, #5: 5	كَانَ عَقْدُهُ
u'كَانَ عقر':Subject, #1: 1	كَانَ الْعَقْرُ
u'كَانَ عُقْرٌ':Subject, #3: 3	كَانَ الْعُقْرُ
u'كَانَ عَقْلٌ':Subject, #3: 3	كَانَ الْعُقْرُ
u'كَانَ عَقْلٌ':Subject, #11: 11	كَانَ الْعَقْلُ
u'كَانَ عَقْلٌ':Subject, #4: 4	كَانَ عَقْلُهُ
u'كَانَ عَقْلِيٌّ':Subject, #5: 5	كَانَ عَقْلُ
u'كَانَ عُقُوقٌ':Subject, #1: 1	كَانَ الْعَقْلِيُّ
u'كَانَ عَقِيبٌ':Predicate, #1: 1	كَانَ عُقُوقُهُ
u'كَانَ عَكْسٌ':Subject, #3: 3	كَانَ عَقِيبَ
u'كَانَ عِلَّةٌ':Predicate, #2: 2	كَانَ الْعَكْسُ
u'كَانَ عِلَّةٌ':Subject, #1: 1	كَانَ عِلَّةَ
u'كَانَ عِلَّةٌ':Subject, #1: 1	كَانَ الْعِلَّةُ
u'كَانَ عِلَّةٌ':Subject, #1: 1	كَانَ عِلَّتُهُ
u'كَانَ عَلَفٌ':Subject, #3: 3	كَانَ عِلَّةُ
u'كَانَ عِلْكٌ':Subject, #2: 2	كَانَ الْعَلَفُ
u'كَانَ علم':Predicate, #1: 1	كَانَ الْعِلْكُ
u'كَانَ علم':Predicate, #19: 19	كَانَ عَلِمَ
u'كَانَ عَلَمٌ':Predicate, #1: 1	كَانَ عَلَمَ
u'كَانَ علم':Subject, #1: 1	كَانَ عَلَمَ
u'كَانَ عِلْمٌ':Subject, #16: 16	كَانَ الْعِلْمُ
u'كَانَ علم':Subject, #16: 16	كَانَ الْعِلْمُ
u'كَانَ عَلَمٌ':Subject, #1: 1	كَانَ الْعَلَمُ
u'كَانَ علم':Subject, #1: 1	كَانَ الْعَلَمُ
u'كَانَ عَلَمٌ':Subject, #1: 1	كَانَ عَلَمُ
u'كَانَ علم':Subject, #1: 1	كَانَ عَلَمُ
u'كَانَ عِلْمٌ':Subject, #4: 4	كَانَ عِلْمُهُ
u'كَانَ علم':Subject, #4: 4	كَانَ عِلْمُهُ
u'كَانَ عِلْمٌ':Subject, #7: 7	كَانَ عِلْمُ
u'كَانَ علماء':Subject, #7: 7	كَانَ عِلْمُ
u'كَانَ عُلَمَاءُ':Subject, #4: 4	كَانَ الْعُلَمَاءُ
u'كَانَ عِلْمِيٌّ':Subject, #4: 4	كَانَ الْعُلَمَاءُ
u'كَانَ عُلُوٌّ':Subject, #1: 1	كَانَ الْعِلْمِيَّةُ
u'كَانَ عُلْوٌ':Subject, #1: 1	كَانَ عُلُوُّهُ
u'كَانَ عُلُوٌّ':Subject, #2: 2	كَانَ الْعُلْوُ
u'كَانَ عُلُوٌّ':Subject, #2: 2	كَانَ عُلُوٌّ
u'كَانَ عُلْوٌ':Subject, #2: 2	كَانَ عُلُوُّ
u'كَانَ عُلُوٌّ':Subject, #2: 2	كَانَ عُلْوٌ
u'كَانَ عُلُوقٌ':Subject, #5: 5	كَانَ الْعُلُوُّ
u'كَانَ عُلُوقٌ':Subject, #1: 1	كَانَ عُلُوقُ
u'كَانَ عَلِيٌّ':Subject, #6: 6	كَانَ الْعُلُوقُ
u'كَانَ عَلِيٌّ':Subject, #4: 4	كَانَ عَلِيُّ
u'كَانَ عَمٌّ':Predicate, #8: 8	كَانَ عَلِيٌّ
u'كَانَ عَمٌّ':Predicate, #1: 1	كَانَ عَمَّ
u'كَانَ عَمٌّ':Subject, #1: 1	كَانَ عَمَّهُنَّ
u'كَانَ عَمٌّ':Subject, #1: 1	كَانَ عَمّهُ
u'كَانَ عَمٌّ':Subject, #2: 2	كَانَ عَمٌّ
u'كَانَ عِمَادٌ':Subject, #7: 7	كَانَ الْعَمُّ
u'كَانَ عُمَارَةٌ':Subject, #2: 2	كَانَ عِمَادُ
u'كَانَ عُمَّالٌ':Subject, #1: 1	كَانَ عُمَارَةُ
u'كَانَ عَمْدٌ':Subject, #3: 3	كَانَ الْعُمَّالُ
u'كَانَ عُمْدَةٌ':Subject, #1: 1	كَانَ الْعَمْدُ
u'كَانَ عُمَرٌ':Predicate, #2: 2	كَانَ عُمْدَةُ
u'كَانَ عُمَرٌ':Subject, #2: 2	كَانَ عُمَرَ
u'كَانَ عُمُرٌ':Subject, #107: 107	كَانَ عُمَرُ
u'كَانَ عُمْرَانٌ':Subject, #2: 2	كَانَ عُمُرُهُ
u'كَانَ عُمْقٌ':Predicate, #1: 1	كَانَ الْعُمْرَانُ
u'كَانَ عُمْقٌ':Subject, #1: 1	كَانَ عُمْقَ
u'كَانَ عَمَلٌ':Predicate, #1: 1	كَانَ عُمْقُ
u'كَانَ عَمَلٌ':Subject, #1: 1	كَانَ عَمَلَ
u'كَانَ عَمَلٌ':Subject, #12: 12	كَانَ عَمَلُهُ
u'كَانَ عَمَلٌ':Subject, #44: 44	كَانَ الْعَمَلُ
u'كَانَ عُمُومٌ':Subject, #7: 7	كَانَ عَمَلُ
u'كَانَ عُمُومٌ':Subject, #2: 2	كَانَ الْعُمُومُ
u'كَانَ عُمُومٌ':Subject, #3: 3	كَانَ عُمُومُ
u'كَانَ عمي':Predicate, #4: 4	كَانَ عُمُومُهُ
u'كَانَ عِنَبٌ':Subject, #2: 2	كَانَ عَمِيَ
u'كَانَ عند':Predicate, #9: 9	كَانَ الْعِنَبُ
u'كَانَ عند':Predicate, #234: 234	كَانَ عِنْدَ
u'كَانَ عُنْوَانٌ':Subject, #9: 9	كَانَ عِنْدَكَ
u'كَانَ عَهِدٌ':Predicate, #2: 2	كَانَ الْعُنْوَانُ
u'كَانَ عَهْدٌ':Subject, #6: 6	كَانَ عَهِدَ
u'كَانَ عَهْدٌ':Subject, #14: 14	كَانَ الْعَهْدُ
u'كَانَ عَهْدٌ':Subject, #2: 2	كَانَ عَهْدُ
u'كَانَ عُودٌ':Subject, #3: 3	كَانَ عَهْدُهُ
u'كَانَ عَوْدٌ':Subject, #1: 1	كَانَ الْعُودُ
u'كَانَ عَوْدٌ':Subject, #2: 2	كَانَ الْعَوْدُ
u'كَانَ عِوَضٌ':Subject, #2: 2	كَانَ عَوْدُهُ
u'كَانَ عِيَارٌ':Subject, #33: 33	كَانَ الْعِوَضُ
u'كَانَ عِيَالٌ':Subject, #1: 1	كَانَ عِيَارُهُ
u'كَانَ عِيَانٌ':Subject, #1: 1	كَانَ عِيَالُهُ
u'كَانَ عَيْبٌ':Subject, #1: 1	كَانَ الْعِيَانُ
u'كَانَ عَيْبٌ':Subject, #67: 67	كَانَ الْعَيْبُ
u'كَانَ عِيدٌ':Subject, #6: 6	كَانَ عَيْبُ
u'كَانَ عَيْشٌ':Subject, #1: 1	كَانَ عِيدُ
u'كَانَ عَيْشٌ':Subject, #1: 1	كَانَ عَيْشُ
u'كَانَ عين':Predicate, #1: 1	كَانَ عَيْشُهُ
u'كَانَ عَيْنٌ':Predicate, #1: 1	كَانَ عَيْنَ
u'كَانَ عَيْن':Predicate, #1: 1	كَانَ عَيْنَ
u'كَانَ عين':Subject, #1: 1	كَانَ عَيْنَ
u'كَانَ عَيْنٌ':Subject, #16: 16	كَانَ الْعَيْنُ
u'كَانَ عَيْن':Subject, #16: 16	كَانَ الْعَيْنُ
u'كَانَ عين':Subject, #16: 16	كَانَ الْعَيْنُ
u'كَانَ عَيْنٌ':Subject, #4: 4	كَانَ عَيْنُهُ
u'كَانَ عَيْن':Subject, #4: 4	كَانَ عَيْنُهُ
u'كَانَ عين':Subject, #4: 4	كَانَ عَيْنُهُ
u'كَانَ عَيْنٌ':Subject, #6: 6	كَانَ عَيْنُ
u'كَانَ عَيْن':Subject, #6: 6	كَانَ عَيْنُ
u'كَانَ غاسِل':Subject, #6: 6	كَانَ عَيْنُ
u'كَانَ غَاصِبٌ':Predicate, #3: 3	كَانَ الْغَاسِلُ
u'كَانَ غَاصِبٌ':Subject, #1: 1	كَانَ الْغَاصِبَ
u'كَانَ غَاصِبٌ':Subject, #1: 1	كَانَ غَاصِبُ
u'كَانَ غَالِبٌ':Predicate, #70: 70	كَانَ الْغَاصِبُ
u'كَانَ غَالِبٌ':Predicate, #2: 2	كَانَ الْغَالِبَ
u'كَانَ غَالِبٌ':Subject, #4: 4	كَانَ غَالِبَ
u'كَانَ غَالِبٌ':Subject, #26: 26	كَانَ غَالِبُ
u'كَانَ غَالِبٌ':Subject, #5: 5	كَانَ غَالِبُهُ
u'كَانَ غانِم':Subject, #85: 85	كَانَ الْغَالِبُ
u'كَانَ غَائِبٌ':Subject, #2: 2	كَانَ غَانِمُ
u'كَانَ غَايَةٌ':Predicate, #18: 18	كَانَ الْغَائِبُ
u'كَانَ غَايَةٌ':Subject, #1: 1	كَانَ غَايَةَ
u'كَانَ غَايَةٌ':Subject, #1: 1	كَانَ غَايَةٌ
u'كَانَ غَايَةٌ':Subject, #1: 1	كَانَ غَايَةُ
u'كَانَ غبار':Subject, #1: 1	كَانَ غَايَتُهُ
u'كَانَ غُبَارٌ':Subject, #1: 1	كَانَ الْغُبَارُ
u'كَانَ غَبَنٌ':Subject, #1: 1	كَانَ الْغُبَارُ
u'كَانَ غَبْنٌ':Subject, #1: 1	كَانَ الْغَبَنُ
u'كَانَ غَبْنٌ':Subject, #1: 1	كَانَ غَبْنُهُ
u'كَانَ غُثَاءٌ':Predicate, #5: 5	كَانَ الْغَبْنُ
u'كَانَ غَدٌ':Subject, #1: 1	كَانَ غُثَاءَةً
u'كَانَ غَدٌ':Subject, #21: 21	كَانَ الْغَدُ
u'كَانَ غداة':Predicate, #7: 7	كَانَ غَدٌ
u'كَانَ غَدَاةٌ':Predicate, #1: 1	كَانَ غَدَاةَ
u'كَانَ غَدِيرٌ':Subject, #1: 1	كَانَ غَدَاةَ
u'كَانَ غَدِيرٌ':Subject, #1: 1	كَانَ غَدِيرٌ
u'كَانَ غِذَاءٌ':Predicate, #2: 2	كَانَ الْغَدِيرُ
u'كَانَ غِذَاءٌ':Subject, #1: 1	كَانَ غِذَاءَ
u'كَانَ غُرَابٌ':Subject, #1: 1	كَانَ الْغِذَاءُ
u'كَانَ غِرَاسٌ':Subject, #1: 1	كَانَ الْغُرَابُ
u'كَانَ غَرَرٌ':Subject, #3: 3	كَانَ الْغِرَاسُ
u'كَانَ غَرَرٌ':Subject, #1: 1	كَانَ غَرَرُ
u'كَانَ غَرْزٌ':Subject, #3: 3	كَانَ الْغَرَرُ
u'كَانَ غَرْسٌ':Subject, #1: 1	كَانَ الْغَرْزُ
u'كَانَ غَرَضٌ':Subject, #4: 4	كَانَ الْغَرْسُ
u'كَانَ غَرَضٌ':Subject, #16: 16	كَانَ غَرَضُهُ
u'كَانَ غَرَضٌ':Subject, #20: 20	كَانَ الْغَرَضُ
u'كَانَ غَرِقٌ':Predicate, #3: 3	كَانَ غَرَضُ
u'كَانَ غُرْمٌ':Subject, #1: 1	كَانَ غَرِقَ
u'كَانَ غرماء':Subject, #1: 1	كَانَ الْغُرْمُ
u'كَانَ غرماء':Subject, #1: 1	كَانَ غُرَمَاءُ
u'كَانَ غُرُورٌ':Subject, #4: 4	كَانَ الْغُرَمَاءُ
u'كَانَ غَرِيمٌ':Subject, #3: 3	كَانَ الْغُرُورُ
u'كَانَ غَزَالٌ':Subject, #28: 28	كَانَ الْغَرِيمُ
u'كَانَ غَزْلٌ':Subject, #1: 1	كَانَ الْغَزَالُ
u'كَانَ غَزْلٌ':Subject, #13: 13	كَانَ الْغَزْلُ
u'كَانَ غَسْلٌ':Subject, #3: 3	كَانَ غَزْلُ
u'كَانَ غُسْلٌ':Subject, #1: 1	كَانَ غَسْلُ
u'كَانَ غُسْلٌ':Subject, #1: 1	كَانَ غُسْلُ
u'كَانَ غَسْلٌ':Subject, #2: 2	كَانَ غُسْلُهُ
u'كَانَ غُسْلٌ':Subject, #3: 3	كَانَ الْغَسْلُ
u'كَانَ غِشٌّ':Subject, #6: 6	كَانَ الْغُسْلُ
u'كَانَ غَصْبٌ':Subject, #5: 5	كَانَ الْغِشُّ
u'كَانَ غُصْنٌ':Subject, #8: 8	كَانَ الْغَصْبُ
u'كَانَ غُصْنٌ':Subject, #1: 1	كَانَ غُصْنٌ
u'كَانَ غضب':Subject, #3: 3	كَانَ الْغُصْنُ
u'كَانَ غَضَبٌ':Subject, #1: 1	كَانَ الْغَضَبُ
u'كَانَ غضب':Subject, #1: 1	كَانَ الْغَضَبُ
u'كَانَ غَضَبٌ':Subject, #1: 1	كَانَ غَضَبُ
u'كَانَ غضب':Subject, #1: 1	كَانَ غَضَبُ
u'كَانَ غَضَبٌ':Subject, #1: 1	كَانَ غَضَبُهُ
u'كَانَ غُلاَمٌ':Subject, #1: 1	كَانَ غَضَبُهُ
u'كَانَ غُلاَمٌ':Subject, #14: 14	كَانَ الْغُلَامُ
u'كَانَ غُلاَمٌ':Subject, #1: 1	كَانَ غُلامٌ
u'كَانَ غلب':Predicate, #2: 2	كَانَ غُلَامٌ
u'كَانَ غَلَبَةٌ':Subject, #1: 1	كَانَ غَلَبَ
u'كَانَ غَلَبَةٌ':Subject, #2: 2	كَانَ الْغَلَبَةُ
u'كَانَ غَلَطٌ':Subject, #2: 2	كَانَ غَلَبَةُ
u'كَانَ غُلُول':Predicate, #2: 2	كَانَ الْغَلَطُ
u'كَانَ غِمْدٌ':Subject, #1: 1	كَانَ غُلُولاً
u'كَانَ غناء':Subject, #2: 2	كَانَ الْغِمْدُ
u'كَانَ غِنَاءٌ':Subject, #5: 5	كَانَ الْغِنَاءُ
u'كَانَ غَنَمٌ':Subject, #5: 5	كَانَ الْغِنَاءُ
u'كَانَ غَنَمٌ':Subject, #1: 1	كَانَ الْغَنَمُ
u'كَانَ غُنْمٌ':Subject, #1: 1	كَانَ غَنَمُ
u'كَانَ غَنِيٌّ':Subject, #1: 1	كَانَ غُنْمُهُ
u'كَانَ غَوْثٌ':Subject, #1: 1	كَانَ الْغَنِيُّ
u'كَانَ غَيْثٌ':Subject, #1: 1	كَانَ الْغَوْثُ
u'كَانَ غير':Predicate, #1: 1	كَانَ الْغَيْثُ
u'كَانَ غَيْرٌ':Predicate, #497: 497	كَانَ غَيْرَ
u'كَانَ غير':Subject, #497: 497	كَانَ غَيْرَ
u'كَانَ غَيْرٌ':Subject, #34: 34	كَانَ غَيْرُ
u'كَانَ غير':Subject, #34: 34	كَانَ غَيْرُ
u'كَانَ غَيْرٌ':Subject, #35: 35	كَانَ غَيْرُهُ
u'كَانَ غير':Subject, #35: 35	كَانَ غَيْرُهُ
u'كَانَ غَيْرٌ':Subject, #7: 7	كَانَ الْغَيْرُ
u'كَانَ غَيْمٌ':Subject, #7: 7	كَانَ الْغَيْرُ
u'كَانَ فاء':Subject, #3: 3	كَانَ غَيْمٌ
u'كَانَ فَاتِحٌ':Subject, #1: 1	كَانَ الْفَاءُ
u'كَانَ فَاحِشٌ':Predicate, #1: 1	كَانَ الْفَاتِحُ
u'كَانَ فَارِسٌ':Predicate, #15: 15	كَانَ فَاحِشَةً
u'كَانَ فَاسِدٌ':Subject, #1: 1	كَانَ فَارِسَ
u'كَانَ فَاسِقٌ':Subject, #3: 3	كَانَ الْفَاسِدُ
u'كَانَ فَاضِلٌ':Predicate, #5: 5	كَانَ الْفَاسِقُ
u'كَانَ فَاضِلٌ':Subject, #1: 1	كَانَ الْفَاضِلَ
u'كَانَ فَاضِلٌ':Subject, #1: 1	كَانَ فَاضِلٌ
u'كَانَ فَاضِلٌ':Subject, #1: 1	كَانَ فَاضِلُ
u'كَانَ فَاعِلٌ':Subject, #8: 8	كَانَ الْفَاضِلُ
u'كَانَ فَاعِلٌ':Subject, #15: 15	كَانَ الْفَاعِلُ
u'كَانَ فَاعِلٌ':Subject, #1: 1	كَانَ فَاعِلُ
u'كَانَ فَاقِدٌ':Subject, #1: 1	كَانَ فَاعِلُهُ
u'كَانَ فَاكِهٌ':Predicate, #1: 1	كَانَ فَاقِدُ
u'كَانَ فَائِدَةٌ':Subject, #3: 3	كَانَ فَاكِهَةً
u'كَانَ فَتْحٌ':Subject, #1: 1	كَانَ فَائِدَةُ
u'كَانَ فَتْحٌ':Subject, #3: 3	كَانَ فَتْحُ
u'كَانَ فَجْرٌ':Subject, #8: 8	كَانَ الْفَتْحُ
u'كَانَ فُجْلٌ':Subject, #1: 1	كَانَ الْفَجْرُ
u'كَانَ فُحْشٌ':Subject, #1: 1	كَانَ الْفُجْلُ
u'كَانَ فَحْلٌ':Predicate, #2: 2	كَانَ الْفُحْشُ
u'كَانَ فَحْلٌ':Subject, #1: 1	كَانَ فَحْلَ
u'كَانَ فخر':Subject, #3: 3	كَانَ الْفَحْلُ
u'كَانَ فَخْرٌ':Subject, #1: 1	كَانَ فَخْرُ
u'كَانَ فِدَاءٌ':Subject, #1: 1	كَانَ فَخْرُ
u'كَانَ فِدَاءٌ':Subject, #12: 12	كَانَ الْفِدَاءُ
u'كَانَ فَرٌّ':Predicate, #1: 1	كَانَ فِدَاءُ
u'كَانَ فرار':Subject, #1: 1	كَانَ فَرَّ
u'كَانَ فِرَارٌ':Subject, #1: 1	كَانَ الْفِرَارُ
u'كَانَ فَرَاسِخُ':Predicate, #1: 1	كَانَ الْفِرَارُ
u'كَانَ فِرَاشٌ':Subject, #1: 1	كَانَ فَرَاسِخَ
u'كَانَ فِرَاشٌ':Subject, #1: 1	كَانَ فِرَاشُهُ
u'كَانَ فِرَاشٌ':Subject, #3: 3	كَانَ فِرَاشُ
u'كَانَ فراغ':Subject, #4: 4	كَانَ الْفِرَاشُ
u'كَانَ فَرَاغٌ':Subject, #2: 2	كَانَ فَرَاغُ
u'كَانَ فِرَاقٌ':Subject, #2: 2	كَانَ فَرَاغُ
u'كَانَ فِرَاقٌ':Subject, #1: 1	كَانَ الْفِرَاقُ
u'كَانَ فَرْجٌ':Predicate, #1: 1	كَانَ فِرَاقُ
u'كَانَ فَرْجٌ':Subject, #2: 2	كَانَ فَرْجَ
u'كَانَ فَرْجٌ':Subject, #1: 1	كَانَ فَرْجُ
u'كَانَ فرح':Subject, #3: 3	كَانَ الْفَرْجُ
u'كَانَ فَرَحٌ':Subject, #1: 1	كَانَ فَرَحُهُ
u'كَانَ فَرْخٌ':Subject, #1: 1	كَانَ فَرَحُهُ
u'كَانَ فرد':Subject, #1: 1	كَانَ الْفَرْخُ
u'كَانَ فَرْدٌ':Subject, #1: 1	كَانَ الْفَرْدُ
u'كَانَ فَرَسٌ':Subject, #1: 1	كَانَ الْفَرْدُ
u'كَانَ فَرَسٌ':Subject, #2: 2	كَانَ فَرَسُهُ
u'كَانَ فَرَسٌ':Subject, #3: 3	كَانَ فَرَسُ
u'كَانَ فَرْضٌ':Predicate, #5: 5	كَانَ الْفَرَسُ
u'كَانَ فَرْضٌ':Subject, #12: 12	كَانَ فَرْضَ
u'كَانَ فَرْضٌ':Subject, #10: 10	كَانَ فَرْضُهُ
u'كَانَ فَرْضٌ':Subject, #23: 23	كَانَ الْفَرْضُ
u'كَانَ فَرْعٌ':Subject, #7: 7	كَانَ فَرْضُ
u'كَانَ فِرْعَوْنُ':Predicate, #8: 8	كَانَ الْفَرْعُ
u'كَانَ فِرْعَوْنُ':Subject, #1: 1	كَانَ فِرْعَوْنَ
u'كَانَ فرق':Subject, #1: 1	كَانَ فِرْعَوْنُ
u'كَانَ فَرْقٌ':Subject, #10: 10	كَانَ الْفَرْقُ
u'كَانَ فرق':Subject, #10: 10	كَانَ الْفَرْقُ
u'كَانَ فَرْقٌ':Subject, #1: 1	كَانَ فَرْقُ
u'كَانَ فَرْوٌ':Subject, #1: 1	كَانَ فَرْقُ
u'كَانَ فُرُوعٌ':Subject, #1: 1	كَانَ الْفَرْوُ
u'كَانَ فَرِيقٌ':Subject, #1: 1	كَانَ الْفُرُوعُ
u'كَانَ فَرِيقٌ':Subject, #2: 2	كَانَ فَرِيقٌ
u'كَانَ فَزَعٌ':Subject, #3: 3	كَانَ الْفَرِيقُ
u'كَانَ فساد':Subject, #3: 3	كَانَ فَزَعٌ
u'كَانَ فَسَادٌ':Subject, #17: 17	كَانَ الْفَسَادُ
u'كَانَ فساد':Subject, #17: 17	كَانَ الْفَسَادُ
u'كَانَ فَسَادٌ':Subject, #4: 4	كَانَ فَسَادُ
u'كَانَ فَسْخٌ':Subject, #4: 4	كَانَ فَسَادُ
u'كَانَ فَسْخٌ':Subject, #17: 17	كَانَ الْفَسْخُ
u'كَانَ فُسْطَاطٌ':Subject, #3: 3	كَانَ فَسْخُ
u'كَانَ فِسْقٌ':Subject, #1: 1	كَانَ الْفُسْطَاطُ
u'كَانَ فِسْقٌ':Subject, #15: 15	كَانَ فِسْقُهُ
u'كَانَ فِسْقٌ':Subject, #1: 1	كَانَ الْفِسْقُ
u'كَانَ فَصٌّ':Subject, #2: 2	كَانَ فِسْقُ
u'كَانَ فَصٌّ':Subject, #2: 2	كَانَ الْفَصُّ
u'كَانَ فَصْلٌ':Subject, #2: 2	كَانَ فَصُّهُ
u'كَانَ فَصْلٌ':Subject, #1: 1	كَانَ فَصْلُهُ
u'كَانَ فَصْلٌ':Subject, #3: 3	كَانَ فَصْلُ
u'كَانَ فَضَاءٌ':Subject, #9: 9	كَانَ الْفَصْلُ
u'كَانَ فِضَّةٌ':Subject, #1: 1	كَانَ الْفَضَاءُ
u'كَانَ فَضْلٌ':Subject, #1: 1	كَانَ الْفِضَّةُ
u'كَانَ فَضْلٌ':Subject, #12: 12	كَانَ الْفَضْلُ
u'كَانَ فَضْلٌ':Subject, #2: 2	كَانَ فَضْلٌ
u'كَانَ فُضُولِيٌّ':Subject, #2: 2	كَانَ فَضْلُ
u'كَانَ فِطَامٌ':Subject, #2: 2	كَانَ الْفُضُولِيُّ
u'كَانَ فِطْرٌ':Subject, #1: 1	كَانَ الْفِطَامُ
u'كَانَ فِطْرٌ':Subject, #3: 3	كَانَ فِطْرُهُ
u'كَانَ فِعْلٌ':Predicate, #5: 5	كَانَ الْفِطْرُ
u'كَانَ فِعْلٌ':Predicate, #1: 1	كَانَ الْفِعْلَ
u'كَانَ فِعْلٌ':Subject, #5: 5	كَانَ فِعْلَ
u'كَانَ فِعْلٌ':Subject, #17: 17	كَانَ فِعْلُ
u'كَانَ فِعْلٌ':Subject, #1: 1	كَانَ فِعْلٌ
u'كَانَ فِعْلٌ':Subject, #22: 22	كَانَ فِعْلُهُ
u'كَانَ فَقْدٌ':Subject, #41: 41	كَانَ الْفِعْلُ
u'كَانَ فقر':Subject, #1: 1	كَانَ الْفَقْدُ
u'كَانَ فَقْرٌ':Subject, #1: 1	كَانَ الْفَقْرُ
u'كَانَ فقر':Subject, #1: 1	كَانَ الْفَقْرُ
u'كَانَ فَقْرٌ':Subject, #1: 1	كَانَ فَقْرُهُ
u'كَانَ فقراء':Subject, #1: 1	كَانَ فَقْرُهُ
u'كَانَ فقراء':Subject, #2: 2	كَانَ الْفُقَرَاءُ
u'كَانَ فِقْهٌ':Subject, #5: 5	كَانَ فُقَرَاءُ
u'كَانَ فقهاء':Subject, #4: 4	كَانَ الْفِقْهُ
u'كَانَ فَقِيرٌ':Subject, #2: 2	كَانَ الْفُقَهَاءُ
u'كَانَ فَقِيهٌ':Subject, #5: 5	كَانَ الْفَقِيرُ
u'كَانَ فَكٌّ':Subject, #17: 17	كَانَ الْفَقِيهُ
u'كَانَ فِكَاكٌ':Subject, #1: 1	كَانَ فَكُّ
u'كَانَ فَلاَسِفَةٌ':Subject, #1: 1	كَانَ فِكَاكُهُ
u'كَانَ فلان':Predicate, #1: 1	كَانَ فَلَاسِفَةُ
u'كَانَ فلان':Predicate, #1: 1	كَانَ عُثْمَانَ
u'كَانَ فلان':Predicate, #1: 1	كَانَ قَتَادَةَ
u'كَانَ فلان':Subject, #1: 1	كَانَ مَكَّةَ
u'كَانَ فلان':Subject, #11: 11	كَانَ الشَّافِعِيُّ
u'كَانَ فلان':Subject, #17: 17	كَانَ عُثْمَانُ
u'كَانَ فلان':Subject, #19: 19	كَانَ سُفْيَانُ
u'كَانَ فلان':Subject, #1: 1	كَانَ الدَّانِقُ
u'كَانَ فلان':Subject, #1: 1	كَانَ الزّبَيْرُ
u'كَانَ فلان':Subject, #1: 1	كَانَ الْمَكِّيُّ
u'كَانَ فلان':Subject, #1: 1	كَانَ بُرَيْدَةُ
u'كَانَ فلان':Subject, #1: 1	كَانَ جُبَيْرُ
u'كَانَ فلان':Subject, #1: 1	كَانَ حَاتِمٌ
u'كَانَ فلان':Subject, #1: 1	كَانَ دَانِيَالُ
u'كَانَ فلان':Subject, #1: 1	كَانَ زِيَادٌ
u'كَانَ فلان':Subject, #1: 1	كَانَ شُعَيْبٌ
u'كَانَ فلان':Subject, #1: 1	كَانَ هَارُونُ
u'كَانَ فلان':Subject, #2: 2	كَانَ الزُّبَيْرُ
u'كَانَ فلان':Subject, #2: 2	كَانَ الْمُتَصَدِّقُ
u'كَانَ فلان':Subject, #2: 2	كَانَ تَمِيمٌ
u'كَانَ فلان':Subject, #2: 2	كَانَ جَعْفَرٌ
u'كَانَ فلان':Subject, #2: 2	كَانَ جَعْفَرُ
u'كَانَ فلان':Subject, #2: 2	كَانَ حُذَيْفَةُ
u'كَانَ فُلاَنٌ':Subject, #2: 2	كَانَ غَانِمُ
u'كَانَ فلان':Subject, #2: 2	كَانَ فُلاَنٌ
u'كَانَ فلان':Subject, #2: 2	كَانَ لُقْمَانُ
u'كَانَ فلان':Subject, #2: 2	كَانَ مَكْحُولٌ
u'كَانَ فلان':Subject, #3: 3	كَانَ حَمْزَةُ
u'كَانَ فلان':Subject, #3: 3	كَانَ قَتَادَةُ
u'كَانَ فلان':Subject, #4: 4	كَانَ مُعَاوِيَةُ
u'كَانَ فلان':Subject, #5: 5	كَانَ بِلاَلٌ
u'كَانَ فُلاَنٌ':Subject, #6: 6	كَانَ بِلَالٌ
u'كَانَ فَلْسٌ':Subject, #74: 74	كَانَ فُلَانٌ
u'كَانَ فَمٌ':Subject, #1: 1	كَانَ الْفَلْسُ
u'كَانَ فِنَاءٌ':Subject, #3: 3	كَانَ فَمُهُ
u'كَانَ فِنَاءٌ':Subject, #10: 10	كَانَ الْفِنَاءُ
u'كَانَ فَهِمٌ':Predicate, #1: 1	كَانَ فِنَاءٌ
u'كَانَ فَهْمٌ':Subject, #1: 1	كَانَ فَهِمَ
u'كَانَ فَوَاتٌ':Subject, #1: 1	كَانَ الْفَهْمُ
u'كَانَ فَوَاتٌ':Subject, #1: 1	كَانَ فَوَاتُهُ
u'كَانَ فَوَاتٌ':Subject, #2: 2	كَانَ فَوَاتُ
u'كَانَ فُؤَادٌ':Subject, #4: 4	كَانَ الْفَوَاتُ
u'كَانَ فَوْرٌ':Subject, #1: 1	كَانَ الْفُؤَادُ
u'كَانَ فَوْقَانِيٌّ':Subject, #2: 2	كَانَ الْفَوْرُ
u'كَانَ فَيْءٌ':Subject, #2: 2	كَانَ الْفَوْقَانِيُّ
u'كَانَ قَابِضٌ':Subject, #3: 3	كَانَ الْفَيْءُ
u'كَانَ قَابِلٌ':Subject, #11: 11	كَانَ الْقَابِضُ
u'كَانَ قَابِلٌ':Subject, #1: 1	كَانَ قَابِلٌ
u'كَانَ قَاتِلٌ':Predicate, #2: 2	كَانَ الْقَابِلُ
u'كَانَ قَاتِلٌ':Subject, #1: 1	كَانَ قَاتِلَ
u'كَانَ قَاتِلٌ':Subject, #1: 1	كَانَ قَاتِلُ
u'كَانَ قادِح':Subject, #75: 75	كَانَ الْقَاتِلُ
u'كَانَ قَادِرٌ':Subject, #3: 3	كَانَ قَادِحٌ
u'كَانَ قَادِمٌ':Subject, #1: 1	كَانَ الْقَادِرُ
u'كَانَ قَاذِفٌ':Predicate, #2: 2	كَانَ الْقَادِمُ
u'كَانَ قَاذِفٌ':Subject, #1: 1	كَانَ قَاذِفَ
u'كَانَ قَاذِفٌ':Subject, #17: 17	كَانَ الْقَاذِفُ
u'كَانَ قَارِئٌ':Subject, #2: 2	كَانَ قَاذِفٌ
u'كَانَ قَاسِمٌ':Subject, #13: 13	كَانَ الْقَارِئُ
u'كَانَ قَاصٌّ':Subject, #5: 5	كَانَ الْقَاسِمُ
u'كَانَ قَاصِدٌ':Subject, #1: 1	كَانَ الْقَاصُّ
u'كَانَ قَاصِرٌ':Predicate, #1: 1	كَانَ قَاصِدُهُ
u'كَانَ قَاطِعٌ':Predicate, #1: 1	كَانَ قَاصِرَ
u'كَانَ قَاطِعٌ':Subject, #1: 1	كَانَ قَاطِعَ
u'كَانَ قَاطِعٌ':Subject, #1: 1	كَانَ قَاطِعُ
u'كَانَ قَاعِدٌ':Predicate, #8: 8	كَانَ الْقَاطِعُ
u'كَانَ قَاعِدٌ':Predicate, #1: 1	كَانَ قَاعِداً
u'كَانَ قَاعِدٌ':Subject, #1: 1	كَانَ قَاعِدَةً
u'كَانَ قَالٌ':Predicate, #3: 3	كَانَ الْقَاعِدُ
u'كَانَ قَانِتٌ':Subject, #142: 142	كَانَ قَالَ
u'كَانَ قَائِدٌ':Subject, #1: 1	كَانَ الْقَانِتُ
u'كَانَ قَائِدٌ':Subject, #1: 1	كَانَ قَائِدُهُ
u'كَانَ قَائِلٌ':Subject, #2: 2	كَانَ الْقَائِدُ
u'كَانَ قَائِلٌ':Subject, #18: 18	كَانَ الْقَائِلُ
u'كَانَ قَائِلٌ':Subject, #2: 2	كَانَ قَائِلُ
u'كَانَ قَائِمٌ':Predicate, #5: 5	كَانَ قَائِلُهُ
u'كَانَ قَائِمٌ':Predicate, #1: 1	كَانَ الْقَائِمَ
u'كَانَ قَائِمٌ':Subject, #2: 2	كَانَ قَائِمَ
u'كَانَ قَبَاءٌ':Predicate, #1: 1	كَانَ الْقَائِمُ
u'كَانَ قَبَاءٌ':Subject, #1: 1	كَانَ قَبَاءَ
u'كَانَ قَبْرٌ':Predicate, #1: 1	كَانَ قَبَاءٌ
u'كَانَ قَبْرٌ':Subject, #1: 1	كَانَ قَبْرَ
u'كَانَ قَبْرٌ':Subject, #1: 1	كَانَ قَبْرُ
u'كَانَ قَبْضٌ':Subject, #8: 8	كَانَ الْقَبْرُ
u'كَانَ قَبْضٌ':Subject, #18: 18	كَانَ الْقَبْضُ
u'كَانَ قَبْضٌ':Subject, #4: 4	كَانَ قَبْضُهُ
u'كَانَ قبضة':Predicate, #9: 9	كَانَ قَبْضُ
u'كَانَ قَبْضَةٌ':Predicate, #1: 1	كَانَ قَبْضَةَ
u'كَانَ قِبْلَةٌ':Subject, #1: 1	كَانَ قَبْضَةَ
u'كَانَ قُبُورٌ':Subject, #1: 1	كَانَ قِبْلَتُهُ
u'كَانَ قَبُولٌ':Subject, #1: 1	كَانَ قُبُورُ
u'كَانَ قَبُولٌ':Subject, #5: 5	كَانَ قَبُولُ
u'كَانَ قَبُولٌ':Subject, #6: 6	كَانَ قَبُولُهُ
u'كَانَ قَبِيعَةٌ':Subject, #7: 7	كَانَ الْقَبُولُ
u'كَانَ قَتاد':Predicate, #1: 1	كَانَ قَبِيعَةُ
u'كَانَ قَتاد':Subject, #1: 1	كَانَ قَتَادَةَ
u'كَانَ قتال':Subject, #3: 3	كَانَ قَتَادَةُ
u'كَانَ قِتَالٌ':Subject, #2: 2	كَانَ قِتَالٌ
u'كَانَ قتال':Subject, #2: 2	كَانَ قِتَالٌ
u'كَانَ قِتَالٌ':Subject, #7: 7	كَانَ الْقِتَالُ
u'كَانَ قتل':Predicate, #7: 7	كَانَ الْقِتَالُ
u'كَانَ قتل':Predicate, #17: 17	كَانَ قَتَلَ
u'كَانَ قَتْلٌ':Subject, #1: 1	كَانَ قُتِلَ
u'كَانَ قتل':Subject, #1: 1	كَانَ قَتْلٌ
u'كَانَ قَتْلٌ':Subject, #67: 67	كَانَ الْقَتْلُ
u'كَانَ قتل':Subject, #67: 67	كَانَ الْقَتْلُ
u'كَانَ قَتْلٌ':Subject, #7: 7	كَانَ قَتْلُ
u'كَانَ قتل':Subject, #7: 7	كَانَ قَتْلُ
u'كَانَ قَتْلٌ':Subject, #7: 7	كَانَ قَتْلُهُ
u'كَانَ قَتِيلٌ':Predicate, #7: 7	كَانَ قَتْلُهُ
u'كَانَ قَتِيلٌ':Subject, #1: 1	كَانَ قَتِيلَ
u'كَانَ قَحْطٌ':Subject, #6: 6	كَانَ الْقَتِيلُ
u'كَانَ قَدٌّ':Predicate, #1: 1	كَانَ قَحْطٌ
u'كَانَ قُدَّامٌ':Predicate, #1: 1	كَانَ قَدَّ
u'كَانَ قَدَحٌ':Subject, #1: 1	كَانَ قُدَّامَ
u'كَانَ قَدْرٌ':Predicate, #1: 1	كَانَ الْقَدَحُ
u'كَانَ قَدَرٌ':Predicate, #1: 1	كَانَ الْقَدْرَ
u'كَانَ قَدْرٌ':Predicate, #2: 2	كَانَ قَدَرَ
u'كَانَ قَدْرٌ':Subject, #46: 46	كَانَ قَدْرَ
u'كَانَ قَدْرٌ':Subject, #1: 1	كَانَ قَدْرٌ
u'كَانَ قَدْرٌ':Subject, #1: 1	كَانَ قَدْرُهُ
u'كَانَ قَدْرٌ':Subject, #22: 22	كَانَ قَدْرُ
u'كَانَ قدم':Predicate, #2: 2	كَانَ الْقَدْرُ
u'كَانَ قَدَمٌ':Predicate, #1: 1	كَانَ قَدَمَ
u'كَانَ قدم':Predicate, #1: 1	كَانَ قَدَمَ
u'كَانَ قَدَمٌ':Subject, #2: 2	كَانَ قَدِمَ
u'كَانَ قدماء':Subject, #1: 1	كَانَ قَدَمَاهُ
u'كَانَ قدمة':Subject, #1: 1	كَانَ الْقُدَمَاءُ
u'كَانَ قُدْوَةٌ':Predicate, #1: 1	كَانَ قَدْمَةُ
u'كَانَ قُدْوَةٌ':Predicate, #1: 1	كَانَ الْقُدْوَةَ
u'كَانَ قُدُومٌ':Subject, #1: 1	كَانَ قُدْوَةَ
u'كَانَ قُدُومٌ':Subject, #1: 1	كَانَ الْقُدُومُ
u'كَانَ قُدُومٌ':Subject, #2: 2	كَانَ قُدُومُهُ
u'كَانَ قذف':Predicate, #4: 4	كَانَ قُدُومُ
u'كَانَ قَذَفٌ':Predicate, #1: 1	كَانَ قَذَفَ
u'كَانَ قذف':Subject, #1: 1	كَانَ قَذَفَ
u'كَانَ قَذْفٌ':Subject, #23: 23	كَانَ الْقَذْفُ
u'كَانَ قذف':Subject, #23: 23	كَانَ الْقَذْفُ
u'كَانَ قَذْفٌ':Subject, #2: 2	كَانَ قَذْفُهُ
u'كَانَ قُرْء':Subject, #2: 2	كَانَ قَذْفُهُ
u'كَانَ قِرَاءةٌ':Subject, #1: 1	كَانَ الْقُرْءُ
u'كَانَ قرار':Subject, #1: 1	كَانَ قِرَاءَةُ
u'كَانَ قَرَارٌ':Subject, #4: 4	كَانَ الْقَرَارُ
u'كَانَ قرار':Subject, #4: 4	كَانَ الْقَرَارُ
u'كَانَ قَرَارٌ':Subject, #4: 4	كَانَ قَرَارُ
u'كَانَ قراض':Subject, #4: 4	كَانَ قَرَارُ
u'كَانَ قِرام':Subject, #5: 5	كَانَ الْقِرَاضُ
u'كَانَ قُرْآنٌ':Predicate, #1: 1	كَانَ قِرَامٌ
u'كَانَ قُرْآنٌ':Subject, #2: 2	كَانَ الْقُرْآنَ
u'كَانَ قِرَانٌ':Subject, #11: 11	كَانَ الْقُرْآنُ
u'كَانَ قُرْبٌ':Predicate, #1: 1	كَانَ الْقِرَانُ
u'كَانَ قُرْبٌ':Subject, #4: 4	كَانَ قُرْبَ
u'كَانَ قُرَّةٌ':Subject, #1: 1	كَانَ قُرْبُ
u'كَانَ قُرْصٌ':Subject, #1: 1	كَانَ قُرَّةُ
u'كَانَ قَرْضٌ':Subject, #1: 1	كَانَ الْقُرْصُ
u'كَانَ قَرْضٌ':Subject, #1: 1	كَانَ قَرْضُ
u'كَانَ قِرْطَاسٌ':Subject, #9: 9	كَانَ الْقَرْضُ
u'كَانَ قِرْنٌ':Predicate, #1: 1	كَانَ الْقِرْطَاسُ
u'كَانَ قَرِيبٌ':Predicate, #1: 1	كَانَ قِرْنَ
u'كَانَ قَرِيبٌ':Subject, #11: 11	كَانَ قَرِيبَ
u'كَانَ قَرِيبٌ':Subject, #12: 12	كَانَ الْقَرِيبُ
u'كَانَ قَسَمٌ':Predicate, #2: 2	كَانَ قَرِيبُهُ
u'كَانَ قَسَمٌ':Subject, #1: 1	كَانَ قَسَمَ
u'كَانَ قَسْمٌ':Subject, #1: 1	كَانَ الْقَسَمُ
u'كَانَ قَسْمٌ':Subject, #1: 1	كَانَ قَسْمُ
u'كَانَ قَسْمٌ':Subject, #1: 1	كَانَ قَسْمُهُ
u'كَانَ قسمة':Subject, #3: 3	كَانَ الْقَسْمُ
u'كَانَ قِسْمَةٌ':Subject, #1: 1	كَانَ الْقِسْمَةُ
u'كَانَ قسمة':Subject, #1: 1	كَانَ الْقِسْمَةُ
u'كَانَ قِسْمَةٌ':Subject, #1: 1	كَانَ قِسْمَةُ
u'كَانَ قصاص':Subject, #1: 1	كَانَ قِسْمَةُ
u'كَانَ قِصَاصٌ':Subject, #38: 38	كَانَ الْقِصَاصُ
u'كَانَ قِصَّةٌ':Subject, #38: 38	كَانَ الْقِصَاصُ
u'كَانَ قَصْدٌ':Subject, #1: 1	كَانَ قِصّةُ
u'كَانَ قَصْدٌ':Subject, #10: 10	كَانَ قَصْدُ
u'كَانَ قَصْدٌ':Subject, #19: 19	كَانَ الْقَصْدُ
u'كَانَ قَصْرٌ':Subject, #28: 28	كَانَ قَصْدُهُ
u'كَانَ قَصَصٌ':Subject, #2: 2	كَانَ الْقَصْرُ
u'كَانَ قُصُورٌ':Subject, #1: 1	كَانَ الْقَصَصُ
u'كَانَ قَصِيرٌ':Subject, #6: 6	كَانَ الْقُصُورُ
u'كَانَ قَضَاءٌ':Predicate, #1: 1	كَانَ الْقَصِيرُ
u'كَانَ قَضَاءٌ':Subject, #2: 2	كَانَ قَضَاءَ
u'كَانَ قَضَاءٌ':Subject, #3: 3	كَانَ قَضَاءُ
u'كَانَ قضاة':Subject, #43: 43	كَانَ الْقَضَاءُ
u'كَانَ قَضِيَّةٌ':Predicate, #2: 2	كَانَ الْقُضَاةُ
u'كَانَ قَضِيَّةٌ':Subject, #1: 1	كَانَ قَضِيَّةَ
u'كَانَ قِطَارٌ':Subject, #2: 2	كَانَ قَضِيَّتُهُ
u'كَانَ قطبة':Subject, #3: 3	كَانَ الْقِطَارُ
u'كَانَ قَطْعٌ':Subject, #1: 1	كَانَ قُطْبَةُ
u'كَانَ قَطْعٌ':Subject, #2: 2	كَانَ قَطْعُهُ
u'كَانَ قَطْعٌ':Subject, #57: 57	كَانَ الْقَطْعُ
u'كَانَ قُطْنٌ':Subject, #7: 7	كَانَ قَطْعُ
u'كَانَ قُعُودٌ':Subject, #2: 2	كَانَ الْقُطْنُ
u'كَانَ قُعُودٌ':Subject, #2: 2	كَانَ قُعُودُهُ
u'كَانَ قَفَّالٌ':Subject, #5: 5	كَانَ الْقُعُودُ
u'كَانَ قَفَصٌ':Subject, #2: 2	كَانَ الْقَفَّالُ
u'كَانَ قَفِيز':Subject, #5: 5	كَانَ الْقَفَصُ
u'كَانَ قلب':Subject, #1: 1	كَانَ الْقَفِيزُ
u'كَانَ قلب':Subject, #1: 1	كَانَ الْقُلْبُ
u'كَانَ قَلْبٌ':Subject, #2: 2	كَانَ الْقَلْبُ
u'كَانَ قَلْب':Subject, #2: 2	كَانَ الْقَلْبُ
u'كَانَ قلب':Subject, #2: 2	كَانَ الْقَلْبُ
u'كَانَ قَلْبٌ':Subject, #3: 3	كَانَ قَلْبُ
u'كَانَ قَلْب':Subject, #3: 3	كَانَ قَلْبُ
u'كَانَ قلب':Subject, #3: 3	كَانَ قَلْبُ
u'كَانَ قَلْبٌ':Subject, #8: 8	كَانَ قَلْبُهُ
u'كَانَ قَلْب':Subject, #8: 8	كَانَ قَلْبُهُ
u'كَانَ قَلَمٌ':Subject, #8: 8	كَانَ قَلْبُهُ
u'كَانَ قَلِيلٌ':Predicate, #1: 1	كَانَ الْقَلَمُ
u'كَانَ قَلِيلٌ':Subject, #13: 13	كَانَ قَلِيلَ
u'كَانَ قَلِيلٌ':Subject, #1: 1	كَانَ قَلِيلُهُ
u'كَانَ قَلِيلٌ':Subject, #2: 2	كَانَ قَلِيلُ
u'كَانَ قَمْحٌ':Subject, #4: 4	كَانَ الْقَلِيلُ
u'كَانَ قمر':Subject, #1: 1	كَانَ الْقَمْحُ
u'كَانَ قَمَرٌ':Subject, #7: 7	كَانَ الْقَمَرُ
u'كَانَ قِمْطٌ':Subject, #7: 7	كَانَ الْقَمَرُ
u'كَانَ قَمِيصٌ':Subject, #1: 1	كَانَ الْقِمْطُ
u'كَانَ قَمِيصٌ':Subject, #3: 3	كَانَ الْقَمِيصُ
u'كَانَ قُنُوتٌ':Subject, #6: 6	كَانَ قَمِيصُهُ
u'كَانَ قَوَاعِدُ':Subject, #2: 2	كَانَ الْقُنُوتُ
u'كَانَ قَوَامٌ':Predicate, #1: 1	كَانَ الْقَوَاعِدُ
u'كَانَ قوائم':Subject, #1: 1	كَانَ قَوَامَ
u'كَانَ قَوَائِمُ':Subject, #1: 1	كَانَ قَوَائِمُهُ
u'كَانَ قُوتٌ':Predicate, #1: 1	كَانَ قَوَائِمُهُ
u'كَانَ قُوتٌ':Subject, #2: 2	كَانَ قُوتَ
u'كَانَ قُوتٌ':Subject, #1: 1	كَانَ الْقُوتُ
u'كَانَ قُوتٌ':Subject, #2: 2	كَانَ قُوتُ
u'كَانَ قَوَد':Subject, #2: 2	كَانَ قُوتُهُ
u'كَانَ قول':Predicate, #2: 2	كَانَ الْقَوَدُ
u'كَانَ قَوْلٌ':Predicate, #1: 1	كَانَ الْقَوْلَ
u'كَانَ قول':Predicate, #1: 1	كَانَ الْقَوْلَ
u'كَانَ قَوْلٌ':Predicate, #7: 7	كَانَ قَوْلَ
u'كَانَ قول':Subject, #7: 7	كَانَ قَوْلَ
u'كَانَ قَوْلٌ':Subject, #23: 23	كَانَ قَوْلُ
u'كَانَ قول':Subject, #23: 23	كَانَ قَوْلُ
u'كَانَ قَوْلٌ':Subject, #378: 378	كَانَ الْقَوْلُ
u'كَانَ قول':Subject, #378: 378	كَانَ الْقَوْلُ
u'كَانَ قَوْلٌ':Subject, #62: 62	كَانَ قَوْلُهُ
u'كَانَ قَوْمٌ':Subject, #62: 62	كَانَ قَوْلُهُ
u'كَانَ قَوْمٌ':Subject, #13: 13	كَانَ قَوْمٌ
u'كَانَ قَوْمٌ':Subject, #1: 1	كَانَ قَوْمُ
u'كَانَ قَوْمٌ':Subject, #20: 20	كَانَ الْقَوْمُ
u'كَانَ قَوِيٌّ':Predicate, #3: 3	كَانَ قَوْمُهُ
u'كَانَ قَوِيٌّ':Subject, #1: 1	كَانَ قَوِيَّ
u'كَانَ قَيْءٌ':Subject, #1: 1	كَانَ الْقَوِيُّ
u'كَانَ قِيَاسٌ':Predicate, #1: 1	كَانَ الْقَيْءُ
u'كَانَ قِيَاسٌ':Predicate, #1: 1	كَانَ الْقِيَاسَ
u'كَانَ قِيَاسٌ':Subject, #2: 2	كَانَ قِيَاسَ
u'كَانَ قِيَاسٌ':Subject, #1: 1	كَانَ قِيَاسٌ
u'كَانَ قِيَاسٌ':Subject, #2: 2	كَانَ قِيَاسُهُ
u'كَانَ قِيَاسٌ':Subject, #3: 3	كَانَ قِيَاسُ
u'كَانَ قيام':Subject, #56: 56	كَانَ الْقِيَاسُ
u'كَانَ قِيَامٌ':Subject, #10: 10	كَانَ قِيَامُهُ
u'كَانَ قيام':Subject, #10: 10	كَانَ قِيَامُهُ
u'كَانَ قِيَامٌ':Subject, #2: 2	كَانَ الْقِيَامُ
u'كَانَ قيام':Subject, #2: 2	كَانَ الْقِيَامُ
u'كَانَ قِيَامٌ':Subject, #2: 2	كَانَ قِيَامُ
u'كَانَ قَيْدٌ':Subject, #2: 2	كَانَ قِيَامُ
u'كَانَ قَيْدٌ':Subject, #1: 1	كَانَ الْقَيْدُ
u'كَانَ قَيِّمٌ':Predicate, #1: 1	كَانَ قَيْدُهُ
u'كَانَ قَيِّمٌ':Subject, #1: 1	كَانَ الْقَيِّمَ
u'كَانَ قِيمَةٌ':Predicate, #4: 4	كَانَ الْقَيِّمُ
u'كَانَ قِيمَةٌ':Predicate, #1: 1	كَانَ قِيمَةَ
u'كَانَ قِيمَةٌ':Subject, #2: 2	كَانَ الْقِيمَةَ
u'كَانَ قِيمَةٌ':Subject, #18: 18	كَانَ قِيمَتُهُ
u'كَانَ قِيمَةٌ':Subject, #2: 2	كَانَ الْقِيمَةُ
u'كَانَ كَاتِبٌ':Predicate, #54: 54	كَانَ قِيمَةُ
u'كَانَ كَاتِبٌ':Subject, #2: 2	كَانَ كَاتِبَ
u'كَانَ كَاتِبٌ':Subject, #1: 1	كَانَ كَاتِبُ
u'كَانَ كَافِرٌ':Subject, #6: 6	كَانَ الْكَاتِبُ
u'كَانَ كَامِلٌ':Predicate, #7: 7	كَانَ الْكَافِرُ
u'كَانَ كَامِلٌ':Subject, #2: 2	كَانَ كَامِلَ
u'كَانَ كَائِنٌ':Subject, #1: 1	كَانَ كَامِلٌ
u'كَانَ كبار':Subject, #1: 1	كَانَ الْكَائِنُ
u'كَانَ كبار':Subject, #1: 1	كَانَ كِبَارُ
u'كَانَ كبر':Predicate, #9: 9	كَانَ الْكِبَارُ
u'كَانَ كبر':Predicate, #2: 2	كَانَ كَبُرَ
u'كَانَ كَبِيرٌ':Predicate, #2: 2	كَانَ كَبِرَ
u'كَانَ كَبِيرٌ':Subject, #1: 1	كَانَ كَبِيرَ
u'كَانَ كَبِيرٌ':Subject, #1: 1	كَانَ كَبِيرُ
u'كَانَ كِتَابٌ':Predicate, #5: 5	كَانَ الْكَبِيرُ
u'كَانَ كِتَابٌ':Subject, #1: 1	كَانَ كِتَابَ
u'كَانَ كِتَابٌ':Subject, #16: 16	كَانَ الْكِتَابُ
u'كَانَ كِتَابٌ':Subject, #1: 1	كَانَ كِتَابُهُ
u'كَانَ كَتَّانٌ':Subject, #2: 2	كَانَ كِتَابٌ
u'كَانَ كُتُبٌ':Subject, #1: 1	كَانَ الْكَتَّانُ
u'كَانَ كِتْمَانٌ':Subject, #1: 1	كَانَ كُتُبٌ
u'كَانَ كَثٌّ':Predicate, #1: 1	كَانَ الْكِتْمَانُ
u'كَانَ كَثِيرٌ':Predicate, #1: 1	كَانَ كَثَّ
u'كَانَ كَثِيرٌ':Subject, #15: 15	كَانَ كَثِيرَ
u'كَانَ كَثِيفٌ':Predicate, #1: 1	كَانَ الْكَثِيرُ
u'كَانَ كَثِيفٌ':Subject, #1: 1	كَانَ كَثِيفَ
u'كَانَ كحل':Subject, #1: 1	كَانَ الْكَثِيفُ
u'كَانَ كُحْلٌ':Subject, #1: 1	كَانَ الْكُحْلُ
u'كَانَ كذب':Subject, #1: 1	كَانَ الْكُحْلُ
u'كَانَ كَذِبٌ':Subject, #5: 5	كَانَ الْكَذِبُ
u'كَانَ كِرَاءٌ':Subject, #5: 5	كَانَ الْكَذِبُ
u'كَانَ كِرَاءٌ':Subject, #11: 11	كَانَ الْكِرَاءُ
u'كَانَ كَرْمٌ':Subject, #5: 5	كَانَ كِرَاءُ
u'كَانَ كَرِهٌ':Predicate, #5: 5	كَانَ الْكَرْمُ
u'كَانَ كَرِيمٌ':Predicate, #1: 1	كَانَ كَرِهَ
u'كَانَ كَرِيمٌ':Subject, #1: 1	كَانَ كَرِيمَ
u'كَانَ كَسْبٌ':Predicate, #1: 1	كَانَ الْكَرِيمُ
u'كَانَ كَسْبٌ':Subject, #1: 1	كَانَ كَسْبَ
u'كَانَ كَسْبٌ':Subject, #13: 13	كَانَ كَسْبُهُ
u'كَانَ كَسْبٌ':Subject, #1: 1	كَانَ كَسْبٌ
u'كَانَ كَسْبٌ':Subject, #3: 3	كَانَ الْكَسْبُ
u'كَانَ كَسْرٌ':Subject, #3: 3	كَانَ كَسْبُ
u'كَانَ كَسْرٌ':Subject, #11: 11	كَانَ الْكَسْرُ
u'كَانَ كُسُوفٌ':Subject, #1: 1	كَانَ كَسْرُ
u'كَانَ كَشْفٌ':Subject, #1: 1	كَانَ الْكُسُوفُ
u'كَانَ كَشْفٌ':Subject, #1: 1	كَانَ الْكَشْفُ
u'كَانَ كَشْفٌ':Subject, #1: 1	كَانَ كَشْفُهُ
u'كَانَ كَعْبٌ':Subject, #2: 2	كَانَ كَشْفُ
u'كَانَ كُفَّارٌ':Subject, #3: 3	كَانَ الْكَعْبُ
u'كَانَ كَفَّارَةٌ':Subject, #4: 4	كَانَ الْكُفَّارُ
u'كَانَ كفاف':Predicate, #2: 2	كَانَ كَفَّارَةٌ
u'كَانَ كَفَافٌ':Predicate, #2: 2	كَانَ كَفَافَ
u'كَانَ كَفَالَةٌ':Subject, #2: 2	كَانَ كَفَافَ
u'كَانَ كفر':Predicate, #1: 1	كَانَ الْكَفَالَةُ
u'كَانَ كفر':Subject, #1: 1	كَانَ كَفَرَ
u'كَانَ كُفْرٌ':Subject, #1: 1	كَانَ كُفْرُ
u'كَانَ كُفْرٌ':Subject, #1: 1	كَانَ كُفْرٌ
u'كَانَ كفر':Subject, #1: 1	كَانَ كُفْرُ
u'كَانَ كُفْرٌ':Subject, #3: 3	كَانَ كُفْرُهُ
u'كَانَ كفر':Subject, #3: 3	كَانَ كُفْرُهُ
u'كَانَ كُفْرٌ':Subject, #5: 5	كَانَ الْكُفْرُ
u'كَانَ كِفْلٌ':Subject, #5: 5	كَانَ الْكُفْرُ
u'كَانَ كَفَنٌ':Subject, #3: 3	كَانَ الْكِفْلُ
u'كَانَ كَفَنٌ':Subject, #12: 12	كَانَ الْكَفَنُ
u'كَانَ كَفِيلٌ':Subject, #4: 4	كَانَ كَفَنُهُ
u'كَانَ كَلاَمٌ':Predicate, #51: 51	كَانَ الْكَفِيلُ
u'كَانَ كَلاَمٌ':Subject, #2: 2	كَانَ كَلَامَ
u'كَانَ كَلاَمٌ':Subject, #16: 16	كَانَ كَلَامُ
u'كَانَ كَلاَمٌ':Subject, #1: 1	كَانَ الْكَلاَمُ
u'كَانَ كَلاَمٌ':Subject, #1: 1	كَانَ كَلاَمُهُ
u'كَانَ كَلاَمٌ':Subject, #21: 21	كَانَ كَلَامُهُ
u'كَانَ كَلْبٌ':Predicate, #37: 37	كَانَ الْكَلَامُ
u'كَانَ كَلْبٌ':Subject, #1: 1	كَانَ كَلْبَ
u'كَانَ كُمٌّ':Subject, #6: 6	كَانَ الْكَلْبُ
u'كَانَ كُمٌّ':Subject, #1: 1	كَانَ كُمُّ
u'كَانَ كَمَالٌ':Predicate, #1: 1	كَانَ كُمُّهُ
u'كَانَ كَمَالٌ':Subject, #1: 1	كَانَ كَمَالَ
u'كَانَ كَمَالٌ':Subject, #1: 1	كَانَ الْكَمَالُ
u'كَانَ كِنَايَةٌ':Predicate, #1: 1	كَانَ كَمَالُ
u'كَانَ كَنِيفٌ':Subject, #1: 1	كَانَ كِنَايَةَ
u'كَانَ كَوْرٌ':Subject, #1: 1	كَانَ الْكَنِيفُ
u'كَانَ كُوزٌ':Subject, #1: 1	كَانَ الْكَوْرُ
u'كَانَ كَوْنٌ':Subject, #3: 3	كَانَ الْكُوزُ
u'كَانَ كَوْنٌ':Subject, #2: 2	كَانَ كَوْنُ
u'كَانَ كِيسٌ':Subject, #5: 5	كَانَ كَوْنُهُ
u'كَانَ كَيْفِيَّةٌ':Subject, #1: 1	كَانَ الْكِيسُ
u'كَانَ كَيْلٌ':Subject, #1: 1	كَانَ كَيْفِيَّةُ
u'كَانَ كَيْلٌ':Subject, #1: 1	كَانَ الْكَيْلُ
u'كَانَ كَيْلٌ':Subject, #1: 1	كَانَ كَيْلُ
u'كَانَ لاَحِقٌ':Subject, #1: 1	كَانَ كَيْلُهُ
u'كَانَ لاَحِقٌ':Subject, #1: 1	كَانَ لَاحِقٌ
u'كَانَ لاَزِمٌ':Subject, #5: 5	كَانَ اللَّاحِقُ
u'كَانَ لاَزِمٌ':Subject, #1: 1	كَانَ لَازِمُهُ
u'كَانَ لاَمٌ':Subject, #6: 6	كَانَ اللَّازِمُ
u'كَانَ لاَمٌ':Subject, #1: 1	كَانَ اللَّامُ
u'كَانَ لاَمِسٌ':Subject, #1: 1	كَانَ لَامُ
u'كَانَ لاَئِقٌ':Subject, #2: 2	كَانَ اللَّامِسُ
u'كَانَ لُبٌّ':Subject, #2: 2	كَانَ اللَّائِقُ
u'كَانَ لِبَاسٌ':Predicate, #1: 1	كَانَ اللُّبُّ
u'كَانَ لِبَاسٌ':Subject, #1: 1	كَانَ لِبَاسَ
u'كَانَ لَبَدٌ':Subject, #1: 1	كَانَ لِبَاسُ
u'كَانَ لبس':Subject, #1: 1	كَانَ اللَّبَدُ
u'كَانَ لُبْسٌ':Subject, #1: 1	كَانَ لُبْسُهُ
u'كَانَ لبس':Subject, #1: 1	كَانَ لُبْسُهُ
u'كَانَ لُبْسٌ':Subject, #3: 3	كَانَ اللُّبْسُ
u'كَانَ لبس':Subject, #3: 3	كَانَ اللُّبْسُ
u'كَانَ لُبْسٌ':Subject, #4: 4	كَانَ لُبْسُ
u'كَانَ لبن':Subject, #4: 4	كَانَ لُبْسُ
u'كَانَ لَبَنٌ':Subject, #1: 1	كَانَ لَبَنُ
u'كَانَ لبن':Subject, #1: 1	كَانَ لَبَنُ
u'كَانَ لَبَنٌ':Subject, #27: 27	كَانَ اللَّبَنُ
u'كَانَ لبن':Subject, #27: 27	كَانَ اللَّبَنُ
u'كَانَ لَبِنٌ':Subject, #2: 2	كَانَ اللَّبِنُ
u'كَانَ لَبِيبٌ':Subject, #2: 2	كَانَ اللَّبِنُ
u'كَانَ لَحْدٌ':Subject, #1: 1	كَانَ اللَّبِيبُ
u'كَانَ لَحْمٌ':Predicate, #1: 1	كَانَ اللَّحْدُ
u'كَانَ لَحْمٌ':Subject, #1: 1	كَانَ لَحْمَ
u'كَانَ لَحْمٌ':Subject, #2: 2	كَانَ لَحْمُ
u'كَانَ لحمة':Subject, #9: 9	كَانَ اللَّحْمُ
u'كَانَ لُحْمَةٌ':Subject, #4: 4	كَانَ لُحْمَتُهُ
u'كَانَ لَحْنٌ':Subject, #4: 4	كَانَ لُحْمَتُهُ
u'كَانَ لدد':Subject, #1: 1	كَانَ لَحْنُهُ
u'كَانَ لَدَدٌ':Subject, #1: 1	كَانَ اللَّدَدُ
u'كَانَ لُزُومٌ':Predicate, #1: 1	كَانَ اللَّدَدُ
u'كَانَ لُزُومٌ':Subject, #1: 1	كَانَ لُزُومَ
u'كَانَ لُزُومٌ':Subject, #2: 2	كَانَ اللُّزُومُ
u'كَانَ لِسَانٌ':Subject, #4: 4	كَانَ لُزُومُ
u'كَانَ لِسَانِيُّ':Predicate, #1: 1	كَانَ لِسَانُهُ
u'كَانَ لِصٌّ':Subject, #1: 1	كَانَ اللِّسَانِيَّ
u'كَانَ لعاب':Subject, #1: 1	كَانَ اللِّصُّ
u'كَانَ لُعَابٌ':Subject, #1: 1	كَانَ لُعَابُهُ
u'كَانَ لعان':Subject, #1: 1	كَانَ لُعَابُهُ
u'كَانَ لعب':Subject, #6: 6	كَانَ اللِّعَانُ
u'كَانَ لَعِبٌ':Subject, #1: 1	كَانَ لَعِبُهُ
u'كَانَ لعب':Subject, #1: 1	كَانَ لَعِبُهُ
u'كَانَ لَعِبٌ':Subject, #3: 3	كَانَ اللَّعِبُ
u'كَانَ لَعْن':Subject, #3: 3	كَانَ اللَّعِبُ
u'كَانَ لَغْوٌ':Subject, #1: 1	كَانَ اللَّعْنُ
u'كَانَ لَفْظٌ':Predicate, #2: 2	كَانَ اللَّغْوُ
u'كَانَ لَفْظٌ':Subject, #2: 2	كَانَ لَفْظَ
u'كَانَ لَفْظٌ':Subject, #10: 10	كَانَ لَفْظُهُ
u'كَانَ لَفْظٌ':Subject, #23: 23	كَانَ لَفْظُ
u'كَانَ لِقَاءٌ':Subject, #42: 42	كَانَ اللَّفْظُ
u'كَانَ لَقِيطٌ':Subject, #1: 1	كَانَ اللِّقَاءُ
u'كَانَ لَمْسٌ':Subject, #8: 8	كَانَ اللَّقِيطُ
u'كَانَ لَهْوٌ':Subject, #5: 5	كَانَ اللَّمْسُ
u'كَانَ لِوَاءٌ':Predicate, #1: 1	كَانَ اللّهْوُ
u'كَانَ لِوَاءٌ':Subject, #1: 1	كَانَ اللِّوَاءَ
u'كَانَ لَوْحٌ':Subject, #1: 1	كَانَ لِوَاءُهُ
u'كَانَ لَوْحٌ':Subject, #1: 1	كَانَ اللّوْحُ
u'كَانَ لُؤْلُؤٌ':Subject, #1: 1	كَانَ لَوْحٌ
u'كَانَ لَوْمٌ':Subject, #1: 1	كَانَ اللُّؤْلُؤُ
u'كَانَ لَوْنٌ':Subject, #1: 1	كَانَ اللَّوْمُ
u'كَانَ لَوْنٌ':Subject, #2: 2	كَانَ اللَّوْنُ
u'كَانَ لَوْنٌ':Subject, #2: 2	كَانَ لَوْنُهُ
u'كَانَ لَيْثٌ':Subject, #3: 3	كَانَ لَوْنُ
u'كَانَ لَيْثٌ':Subject, #1: 1	كَانَ اللَّيْثُ
u'كَانَ لَيْلٌ':Predicate, #1: 1	كَانَ لَيْثٌ
u'كَانَ لَيْلٌ':Predicate, #1: 1	كَانَ لَيْلاً
u'كَانَ لَيْلٌ':Predicate, #1: 1	كَانَ لَيْلَةً
u'كَانَ لَيْلٌ':Subject, #4: 4	كَانَ لَيْلَةَ
u'كَانَ لَيْلٌ':Subject, #12: 12	كَانَ اللَّيْلُ
u'كَانَ لَيْلٌ':Subject, #1: 1	كَانَ لَيْلاُ
u'كَانَ لَيِّنٌ':Predicate, #5: 5	كَانَ لَيْلَةُ
u'كَانَ مَاءٌ':Predicate, #2: 2	كَانَ لَيِّنَ
u'كَانَ مَاءٌ':Subject, #3: 3	كَانَ مَاءَ
u'كَانَ مَاءٌ':Subject, #1: 1	كَانَ مَاءٌ
u'كَانَ مَاءٌ':Subject, #218: 218	كَانَ الْمَاءُ
u'كَانَ مَارٌّ':Subject, #7: 7	كَانَ مَاءُ
u'كَانَ مَاسٌّ':Subject, #5: 5	كَانَ الْمَارُّ
u'كَانَ مَاسِحٌ':Subject, #4: 4	كَانَ الْمَاسُّ
u'كَانَ مَاشِي':Predicate, #1: 1	كَانَ الْمَاسِحُ
u'كَانَ مَاضِي':Subject, #3: 3	كَانَ مَاشِيَةً
u'كَانَ مَاعِزٌ':Subject, #1: 1	كَانَ مَاضِيَةٌ
u'كَانَ مَأْكُولٌ':Predicate, #2: 2	كَانَ مَاعِزُ
u'كَانَ مَأْكُولٌ':Subject, #4: 4	كَانَ مَأْكُولَ
u'كَانَ مَالٌ':Predicate, #3: 3	كَانَ الْمَأْكُولُ
u'كَانَ مَالٌ':Subject, #9: 9	كَانَ مَالَ
u'كَانَ مَآلٌ':Subject, #276: 276	كَانَ الْمَالُ
u'كَانَ مَآلٌ':Subject, #2: 2	كَانَ مَآلُهُ
u'كَانَ مَالٌ':Subject, #3: 3	كَانَ الْمَآلُ
u'كَانَ مَالٌ':Subject, #3: 3	كَانَ مَالٌ
u'كَانَ مَالٌ':Subject, #44: 44	كَانَ مَالُ
u'كَانَ مَالِكٌ':Predicate, #70: 70	كَانَ مَالُهُ
u'كَانَ مَالِكٌ':Predicate, #1: 1	كَانَ الْمَالِكَ
u'كَانَ مَالِكٌ':Subject, #1: 1	كَانَ مَالِكَ
u'كَانَ مَالِكٌ':Subject, #14: 14	كَانَ مَالِكُ
u'كَانَ مَالِكٌ':Subject, #24: 24	كَانَ مَالِكٌ
u'كَانَ مَالِكٌ':Subject, #5: 5	كَانَ مَالِكُهُ
u'كَانَ مَأْلُوفٌ':Subject, #66: 66	كَانَ الْمَالِكُ
u'كَانَ مَأْمُورٌ':Subject, #1: 1	كَانَ مَأْلُوفٌ
u'كَانَ مَأْمُونٌ':Subject, #41: 41	كَانَ الْمَأْمُورُ
u'كَانَ مَانِعٌ':Subject, #1: 1	كَانَ الْمَأْمُونُ
u'كَانَ مَانِعٌ':Subject, #18: 18	كَانَ الْمَانِعُ
u'كَانَ مَائِيُّ':Predicate, #1: 1	كَانَ مَانِعٌ
u'كَانَ مُبَاحٌ':Predicate, #2: 2	كَانَ مَائِيَّ
u'كَانَ مُبَاحٌ':Subject, #6: 6	كَانَ مُبَاحَ
u'كَانَ مُبَادَلَةٌ':Predicate, #7: 7	كَانَ الْمُبَاحُ
u'كَانَ مُبَاشِرٌ':Predicate, #11: 11	كَانَ مُبَادَلَةَ
u'كَانَ مُبَاشِرٌ':Subject, #1: 1	كَانَ مُبَاشِرَ
u'كَانَ مُبْتاع':Subject, #1: 1	كَانَ الْمُبَاشِرُ
u'كَانَ مُبْتَدَأٌ':Subject, #9: 9	كَانَ الْمُبْتَاعُ
u'كَانَ مُبْتَدِعٌ':Subject, #6: 6	كَانَ الْمُبْتَدَأُ
u'كَانَ مُبْتَدِئٌ':Subject, #3: 3	كَانَ الْمُبْتَدِعُ
u'كَانَ مَبْدَأٌ':Subject, #5: 5	كَانَ الْمُبْتَدِئُ
u'كَانَ مَبْذُول':Subject, #4: 4	كَانَ مَبْدَأُ
u'كَانَ مَبْعُوثٌ':Subject, #1: 1	كَانَ الْمَبْذُولُ
u'كَانَ مُبَلِّغٌ':Subject, #1: 1	كَانَ الْمَبْعُوثُ
u'كَانَ مَبْلَغٌ':Subject, #1: 1	كَانَ الْمُبَلِّغُ
u'كَانَ مَبْلَغٌ':Subject, #1: 1	كَانَ مَبْلَغُ
u'كَانَ مَبْلُول':Subject, #2: 2	كَانَ الْمَبْلَغُ
u'كَانَ مَبْنِيٌّ':Subject, #1: 1	كَانَ الْمَبْلُولُ
u'كَانَ مُبِيحٌ':Subject, #2: 2	كَانَ الْمَبْنِيُّ
u'كَانَ مَبِيعٌ':Subject, #1: 1	كَانَ الْمُبِيحُ
u'كَانَ مُبَيَّنٌ':Subject, #191: 191	كَانَ الْمَبِيعُ
u'كَانَ مُتَأَخِّرٌ':Subject, #5: 5	كَانَ الْمُبَيَّنُ
u'كَانَ مَتَاعٌ':Predicate, #2: 2	كَانَ الْمُتَأَخِّرُ
u'كَانَ مَتَاعٌ':Subject, #1: 1	كَانَ مَتَاعَ
u'كَانَ مَتَاعٌ':Subject, #19: 19	كَانَ الْمَتَاعُ
u'كَانَ مُتَأَهِّلٌ':Subject, #1: 1	كَانَ مَتَاعُهُ
u'كَانَ مُتَبَرِّعٌ':Subject, #1: 1	كَانَ مُتَأَهِّلُهُ
u'كَانَ متبوع':Subject, #3: 3	كَانَ الْمُتَبَرِّعُ
u'كَانَ مُتَتَابِعٌ':Subject, #2: 2	كَانَ الْمَتْبُوعُ
u'كَانَ مُتَجَاوِزٌ':Subject, #1: 1	كَانَ مُتَتَابِعٌ
u'كَانَ مُتَّجِهٌ':Subject, #1: 1	كَانَ الْمُتَجَاوِزُ
u'كَانَ مُتَخَلِّف':Subject, #1: 1	كَانَ الْمُتَّجِهُ
u'كَانَ مُتَدانِي':Predicate, #1: 1	كَانَ الْمُتَخَلِّفُ
u'كَانَ مَتْرُوكٌ':Subject, #1: 1	كَانَ مُتَدَانِيَ
u'كَانَ مُتَزَوِّجٌ':Subject, #19: 19	كَانَ الْمَتْرُوكُ
u'كَانَ مُتَصَدِّق':Subject, #3: 3	كَانَ الْمُتَزَوِّجُ
u'كَانَ مُتَصَرِّفٌ':Subject, #2: 2	كَانَ الْمُتَصَدِّقُ
u'كَانَ مُتَّصِلٌ':Predicate, #3: 3	كَانَ الْمُتَصَرِّفُ
u'كَانَ مُتَعَارَفٌ':Subject, #3: 3	كَانَ مُتَّصِلَ
u'كَانَ مُتَعَذِّرٌ':Predicate, #2: 2	كَانَ الْمُتَعَارَفُ
u'كَانَ مُتَعَلِّقٌ':Subject, #2: 2	كَانَ مُتَعَذِّرَ
u'كَانَ مُتَعَلِّقٌ':Subject, #1: 1	كَانَ الْمُتَعَلِّقُ
u'كَانَ مُتَعَلِّقٌ':Subject, #1: 1	كَانَ مُتَعَلِّقُ
u'كَانَ مُتَعَلِّمٌ':Subject, #1: 1	كَانَ مُتَعَلِّقُهُ
u'كَانَ مُتَغَيِّرٌ':Predicate, #2: 2	كَانَ الْمُتَعَلِّمُ
u'كَانَ مُتَفاوِت':Predicate, #1: 1	كَانَ مُتَغَيِّرَ
u'كَانَ مُتَّفَقٌ':Subject, #1: 1	كَانَ مُتَفَاوِتَ
u'كَانَ مُتَقَدِّمٌ':Predicate, #1: 1	كَانَ الْمُتَّفَقُ
u'كَانَ مُتَقَدِّمٌ':Subject, #1: 1	كَانَ الْمُتَقَدِّمَ
u'كَانَ مُتَكَلِّمٌ':Subject, #5: 5	كَانَ الْمُتَقَدِّمُ
u'كَانَ مُتْلِفٌ':Subject, #6: 6	كَانَ الْمُتَكَلِّمُ
u'كَانَ مُتْلِفٌ':Subject, #1: 1	كَانَ مُتْلِفُهُ
u'كَانَ مُتَمَتِّعٌ':Subject, #9: 9	كَانَ الْمُتْلِفُ
u'كَانَ مُتَمِّمٌ':Subject, #1: 1	كَانَ الْمُتَمَتِّعُ
u'كَانَ مُتَنازَع':Subject, #2: 2	كَانَ الْمُتَمِّمُ
u'كَانَ مُتَّهَمٌ':Subject, #2: 2	كَانَ الْمُتَنَازَعُ
u'كَانَ مُتَوَجِّه':Subject, #1: 1	كَانَ الْمُتَّهَمُ
u'كَانَ مُتَوَسِّطٌ':Subject, #1: 1	كَانَ مُتَوَجِّهٌ
u'كَانَ مُتَوَكِّلٌ':Subject, #2: 2	كَانَ الْمُتَوَسِّطُ
u'كَانَ مِثْقَالٌ':Predicate, #1: 1	كَانَ الْمُتَوَكِّلُ
u'كَانَ مثل':Predicate, #1: 1	كَانَ مِثْقَالَ
u'كَانَ مِثْلٌ':Predicate, #1: 1	كَانَ مِثْلَكَ
u'كَانَ مثل':Predicate, #1: 1	كَانَ مِثْلَكَ
u'كَانَ مِثْلٌ':Predicate, #79: 79	كَانَ مِثْلَ
u'كَانَ مثل':Subject, #79: 79	كَانَ مِثْلَ
u'كَانَ مِثْلٌ':Subject, #17: 17	كَانَ مِثْلُ
u'كَانَ مثل':Subject, #17: 17	كَانَ مِثْلُ
u'كَانَ مَثَلٌ':Subject, #1: 1	كَانَ مَثَلُ
u'كَانَ مثل':Subject, #1: 1	كَانَ مَثَلُ
u'كَانَ مَثَلٌ':Subject, #1: 1	كَانَ مَثَلُهُ
u'كَانَ مثل':Subject, #1: 1	كَانَ مَثَلُهُ
u'كَانَ مِثْلٌ':Subject, #34: 34	كَانَ مِثْلُهُ
u'كَانَ مثل':Subject, #34: 34	كَانَ مِثْلُهُ
u'كَانَ مِثْلٌ':Subject, #3: 3	كَانَ الْمِثْلُ
u'كَانَ مُثَمَّنٌ':Subject, #3: 3	كَانَ الْمِثْلُ
u'كَانَ مَجَازٌ':Subject, #1: 1	كَانَ الْمُثَمَّنُ
u'كَانَ مَجَازٌ':Subject, #1: 1	كَانَ مَجَازُهُ
u'كَانَ مَجَامِعُ':Subject, #2: 2	كَانَ الْمَجَازُ
u'كَانَ مُجَاهِدٌ':Subject, #1: 1	كَانَ الْمَجَامِعُ
u'كَانَ مُجَاهِدٌ':Subject, #1: 1	كَانَ الْمُجَاهِدُ
u'كَانَ مَجْبُورٌ':Subject, #2: 2	كَانَ مُجَاهِدٌ
u'كَانَ مُجْتَهِد':Predicate, #2: 2	كَانَ الْمَجْبُورُ
u'كَانَ مُجْتَهِد':Predicate, #1: 1	كَانَ الْمُجْتَهِدَ
u'كَانَ مُجْتَهِد':Subject, #1: 1	كَانَ مُجْتَهِدَ
u'كَانَ مَجْدٌ':Subject, #3: 3	كَانَ الْمُجْتَهِدُ
u'كَانَ مَجْدٌ':Subject, #1: 1	كَانَ الْمَجْدُ
u'كَانَ مُجَرَّدٌ':Predicate, #2: 2	كَانَ مَجْدٌ
u'كَانَ مُجَرَّدٌ':Subject, #2: 2	كَانَ مُجَرَّدَ
u'كَانَ مَجْرُوحٌ':Subject, #5: 5	كَانَ مُجَرَّدُ
u'كَانَ مَجْرُورٌ':Subject, #3: 3	كَانَ الْمَجْرُوحُ
u'كَانَ مَجْلِسٌ':Predicate, #1: 1	كَانَ الْمَجْرُورُ
u'كَانَ مَجْلِسٌ':Subject, #2: 2	كَانَ مَجْلِسَ
u'كَانَ مُجْمَعٌ':Subject, #7: 7	كَانَ الْمَجْلِسُ
u'كَانَ مَجْمُوعٌ':Subject, #2: 2	كَانَ الْمُجْمَعُ
u'كَانَ مَجْمُوعٌ':Subject, #1: 1	كَانَ مَجْمُوعُ
u'كَانَ مَجْمُوعٌ':Subject, #1: 1	كَانَ مَجْمُوعُهُ
u'كَانَ مَجْنُونٌ':Subject, #2: 2	كَانَ الْمَجْمُوعُ
u'كَانَ مَجْنِيٌّ':Subject, #6: 6	كَانَ الْمَجْنُونُ
u'كَانَ مَجْهُولٌ':Predicate, #11: 11	كَانَ الْمَجْنِيُّ
u'كَانَ مَجُوسٌ':Subject, #13: 13	كَانَ مَجْهُولَ
u'كَانَ مَجِيءٌ':Subject, #1: 1	كَانَ الْمَجُوسُ
u'كَانَ مَجِيءٌ':Subject, #1: 1	كَانَ الْمَجِيءُ
u'كَانَ مُجِيزٌ':Subject, #1: 1	كَانَ مَجِيءُ
u'كَانَ مُجِيزٌ':Subject, #1: 1	كَانَ مُجِيزُ
u'كَانَ مُحَابَاةٌ':Subject, #8: 8	كَانَ الْمُجِيزُ
u'كَانَ مُحَارِبٌ':Subject, #1: 1	كَانَ الْمُحَابَاةُ
u'كَانَ مُحِبٌّ':Subject, #3: 3	كَانَ الْمُحَارِبُ
u'كَانَ مَحْبُوسٌ':Subject, #1: 1	كَانَ الْمُحِبُّ
u'كَانَ مُحْتَاجٌ':Subject, #3: 3	كَانَ الْمَحْبُوسُ
u'كَانَ مُحْتَالٌ':Subject, #6: 6	كَانَ الْمُحْتَاجُ
u'كَانَ مُحْتَسِبٌ':Subject, #11: 11	كَانَ الْمُحْتَالُ
u'كَانَ مُحْتَمَلٌ':Predicate, #1: 1	كَانَ الْمُحْتَسِبُ
u'كَانَ مُحْتَمَلٌ':Subject, #1: 1	كَانَ الْمُحْتَمَلَ
u'كَانَ مُحْتَمَلٌ':Subject, #1: 1	كَانَ الْمُحْتَمَلُ
u'كَانَ مَحْجُورٌ':Subject, #1: 1	كَانَ مُحْتَمَلُ
u'كَانَ مُحَدِّثٌ':Subject, #7: 7	كَانَ الْمَحْجُورُ
u'كَانَ مُحَدِّثٌ':Subject, #1: 1	كَانَ الْمُحَدّثُ
u'كَانَ مُحْدِثٌ':Subject, #2: 2	كَانَ الْمُحَدِّثُ
u'كَانَ مَحْدُودٌ':Subject, #3: 3	كَانَ الْمُحْدِثُ
u'كَانَ مَحْذُوفٌ':Subject, #3: 3	كَانَ الْمَحْدُودُ
u'كَانَ مِحْرَابٌ':Subject, #3: 3	كَانَ الْمَحْذُوفُ
u'كَانَ مُحَرَّمٌ':Predicate, #3: 3	كَانَ الْمِحْرَابُ
u'كَانَ مَحْرَمٌ':Subject, #1: 1	كَانَ مُحَرَّمَ
u'كَانَ مُحَرَّمٌ':Subject, #3: 3	كَانَ الْمَحْرَمُ
u'كَانَ مُحْرِمٌ':Subject, #5: 5	كَانَ الْمُحَرَّمُ
u'كَانَ مُحْسِنٌ':Subject, #8: 8	كَانَ الْمُحْرِمُ
u'كَانَ مُحَصَّبٌ':Subject, #1: 1	كَانَ الْمُحْسِنُ
u'كَانَ مَحْضٌ':Predicate, #1: 1	كَانَ الْمُحَصَّبُ
u'كَانَ مَحْظُورٌ':Predicate, #1: 1	كَانَ مَحْضَ
u'كَانَ مَحْفُورٌ':Subject, #2: 2	كَانَ مَحْظُورَ
u'كَانَ مُحَقَّقٌ':Predicate, #1: 1	كَانَ الْمَحْفُورُ
u'كَانَ مُحَقَّقٌ':Subject, #1: 1	كَانَ مُحَقَّقَ
u'كَانَ مُحْكَمٌ':Subject, #1: 1	كَانَ مُحَقَّقُ
u'كَانَ مُحَكِّمٌ':Subject, #1: 1	كَانَ الْمُحْكَمُ
u'كَانَ مُحَكَّمٌ':Subject, #3: 3	كَانَ الْمُحَكِّمُ
u'كَانَ مَحْكُومٌ':Subject, #9: 9	كَانَ الْمُحَكَّمُ
u'كَانَ مَحَلٌّ':Predicate, #5: 5	كَانَ الْمَحْكُومُ
u'كَانَ مَحَلٌّ':Subject, #1: 1	كَانَ مَحَلَّ
u'كَانَ مَحَلٌّ':Subject, #16: 16	كَانَ مَحَلُّ
u'كَانَ مَحَلٌّ':Subject, #18: 18	كَانَ الْمَحَلُّ
u'كَانَ مُحَمَّدٌ':Subject, #6: 6	كَانَ مَحَلُّهُ
u'كَانَ مُحَمَّدٌ':Subject, #12: 12	كَانَ مُحَمَّدُ
u'كَانَ مُحَمَّدٌ':Subject, #17: 17	كَانَ مُحَمَّدٌ
u'كَانَ مَحْمُولٌ':Subject, #5: 5	كَانَ مُحَمّدٌ
u'كَانَ مُحِيل':Subject, #6: 6	كَانَ الْمَحْمُولُ
u'كَانَ مُخاصِم':Subject, #5: 5	كَانَ الْمُحِيلُ
u'كَانَ مُخَاطِبٌ':Subject, #1: 1	كَانَ الْمُخَاصِمُ
u'كَانَ مُخَاطَبٌ':Subject, #2: 2	كَانَ الْمُخَاطِبُ
u'كَانَ مُخَاطَبٌ':Subject, #2: 2	كَانَ مُخَاطَبَةُ
u'كَانَ مُخَاطَبَةٌ':Subject, #7: 7	كَانَ الْمُخَاطَبُ
u'كَانَ مُخَالِفٌ':Predicate, #2: 2	كَانَ مُخَاطَبَةُ
u'كَانَ مُخَالِفٌ':Subject, #1: 1	كَانَ مُخَالِفَ
u'كَانَ مُخَالَفَةٌ':Subject, #3: 3	كَانَ الْمُخَالِفُ
u'كَانَ مُخَالَفَةٌ':Subject, #1: 1	كَانَ مُخَالَفَةٌ
u'كَانَ مُخْبِرٌ':Subject, #1: 1	كَانَ مُخَالَفَةُ
u'كَانَ مُخْتَارٌ':Predicate, #60: 60	كَانَ الْمُخْبِرُ
u'كَانَ مُخْتَارٌ':Subject, #1: 1	كَانَ مُخْتَارَ
u'كَانَ مُخْتَارٌ':Subject, #11: 11	كَانَ الْمُخْتَارُ
u'كَانَ مُخْتَلِطٌ':Predicate, #2: 2	كَانَ مُخْتَارُ
u'كَانَ مُخْتَلِفٌ':Predicate, #2: 2	كَانَ مُخْتَلِطَ
u'كَانَ مُخْتَلَفٌ':Subject, #1: 1	كَانَ مُخْتَلِفَ
u'كَانَ مُخْتَلِفٌ':Subject, #1: 1	كَانَ الْمُخْتَلَفُ
u'كَانَ مُخَرَّبٌ':Predicate, #1: 1	كَانَ الْمُخْتَلِفُ
u'كَانَ مَخْرَجٌ':Subject, #1: 1	كَانَ مُخَرَّبَ
u'كَانَ مُخْرِجٌ':Subject, #1: 1	كَانَ مَخْرَجُ
u'كَانَ مَخْرَجٌ':Subject, #1: 1	كَانَ مُخْرِجُ
u'كَانَ مَخْرَجٌ':Subject, #1: 1	كَانَ مَخْرَجُهُ
u'كَانَ مُخْرِجٌ':Subject, #2: 2	كَانَ الْمَخْرَجُ
u'كَانَ مُخَصَّصٌ':Subject, #2: 2	كَانَ الْمُخْرِجُ
u'كَانَ مَخْصُوصٌ':Subject, #7: 7	كَانَ الْمُخَصَّصُ
u'كَانَ مُخَضْرَمٌ':Subject, #5: 5	كَانَ الْمَخْصُوصُ
u'كَانَ مُخْطِئٌ':Subject, #1: 1	كَانَ الْمُخَضْرَمُ
u'كَانَ مُخَلَّفٌ':Subject, #1: 1	كَانَ الْمُخْطِئُ
u'كَانَ مَخْلُوطٌ':Predicate, #1: 1	كَانَ الْمُخَلَّفُ
u'كَانَ مَخْلُوطٌ':Subject, #1: 1	كَانَ مَخْلُوطَ
u'كَانَ مَخِيضٌ':Subject, #3: 3	كَانَ الْمَخْلُوطُ
u'كَانَ مَدٌّ':Subject, #2: 2	كَانَ الْمَخِيضُ
u'كَانَ مَدَارٌ':Subject, #2: 2	كَانَ الْمَدُّ
u'كَانَ مَدَارٌ':Subject, #2: 2	كَانَ الْمَدَارُ
u'كَانَ مَدَارٌ':Subject, #2: 2	كَانَ مَدَارُ
u'كَانَ مُدَبَّرٌ':Subject, #2: 2	كَانَ مَدَارُهُ
u'كَانَ مُدَبِّرٌ':Subject, #17: 17	كَانَ الْمُدَبَّرُ
u'كَانَ مَدْبُوغٌ':Subject, #7: 7	كَانَ الْمُدَبِّرُ
u'كَانَ مُدَّةٌ':Subject, #1: 1	كَانَ الْمَدْبُوغُ
u'كَانَ مَدْحٌ':Subject, #1: 1	كَانَ مُدَّةُ
u'كَانَ مَدْخُولٌ':Subject, #1: 1	كَانَ مَدْحُهُ
u'كَانَ مُدْرَكٌ':Subject, #1: 1	كَانَ مَدْخُولُ
u'كَانَ مُدْرِكٌ':Subject, #1: 1	كَانَ الْمُدْرَكُ
u'كَانَ مَدْعُوٌّ':Subject, #1: 1	كَانَ الْمُدْرِكُ
u'كَانَ مَدْفُوعٌ':Subject, #4: 4	كَانَ الْمَدْعُوُّ
u'كَانَ مَدْفُونٌ':Subject, #13: 13	كَانَ الْمَدْفُوعُ
u'كَانَ مَدْلُولٌ':Predicate, #1: 1	كَانَ الْمَدْفُونُ
u'كَانَ مَدْلُولٌ':Subject, #1: 1	كَانَ مَدْلُولَ
u'كَانَ مَدْلُولٌ':Subject, #10: 10	كَانَ الْمَدْلُولُ
u'كَانَ مَدْلُولٌ':Subject, #1: 1	كَانَ مَدْلُولُ
u'كَانَ مُدِيرٌ':Subject, #5: 5	كَانَ مَدْلُولُهُ
u'كَانَ مَدِينٌ':Subject, #1: 1	كَانَ الْمُدِيرُ
u'كَانَ مَدْيُونٌ':Predicate, #4: 4	كَانَ الْمَدِينُ
u'كَانَ مَدْيُونٌ':Subject, #1: 1	كَانَ مَدْيُونَ
u'كَانَ مَدْيُونٌ':Subject, #2: 2	كَانَ مَدْيُونُهُ
u'كَانَ مَذْكُورٌ':Subject, #34: 34	كَانَ الْمَدْيُونُ
u'كَانَ مَذْهَبٌ':Predicate, #7: 7	كَانَ الْمَذْكُورُ
u'كَانَ مَذْهَبٌ':Predicate, #3: 3	كَانَ الْمَذْهَبَ
u'كَانَ مَذْهَبٌ':Subject, #3: 3	كَانَ مَذْهَبَ
u'كَانَ مَذْهَبٌ':Subject, #12: 12	كَانَ الْمَذْهَبُ
u'كَانَ مَذْهَبٌ':Subject, #12: 12	كَانَ مَذْهَبُ
u'كَانَ مرٌّ':Predicate, #16: 16	كَانَ مَذْهَبُهُ
u'كَانَ مَرٌّ':Predicate, #1: 1	كَانَ مَرَّ
u'كَانَ مرٌّ':Predicate, #1: 1	كَانَ مَرَّ
u'كَانَ مرٌّ':Subject, #6: 6	كَانَ مَرَّةً
u'كَانَ مراد':Subject, #2: 2	كَانَ مَرَّاتُ
u'كَانَ مُرَادٌ':Subject, #13: 13	كَانَ مُرَادُ
u'كَانَ مراد':Subject, #13: 13	كَانَ مُرَادُ
u'كَانَ مُرَادٌ':Subject, #229: 229	كَانَ الْمُرَادُ
u'كَانَ مراد':Subject, #229: 229	كَانَ الْمُرَادُ
u'كَانَ مُرَادٌ':Subject, #58: 58	كَانَ مُرَادُهُ
u'كَانَ مَرَّةٌ':Subject, #58: 58	كَانَ مُرَادُهُ
u'كَانَ مُرَتَّبٌ':Subject, #2: 2	كَانَ مَرَّاتُ
u'كَانَ مَرْتَبَةٌ':Subject, #1: 1	كَانَ الْمُرَتَّبُ
u'كَانَ مُرْتَدٌّ':Subject, #1: 1	كَانَ مَرْتَبَتُهُ
u'كَانَ مُرْتَهِنٌ':Predicate, #13: 13	كَانَ الْمُرْتَدُّ
u'كَانَ مُرْتَهِنٌ':Subject, #1: 1	كَانَ الْمُرْتَهِنَ
u'كَانَ مُرَجَّحٌ':Subject, #32: 32	كَانَ الْمُرْتَهِنُ
u'كَانَ مُرَجِّحٌ':Subject, #1: 1	كَانَ الْمُرَجَّحُ
u'كَانَ مَرْجِعٌ':Subject, #1: 1	كَانَ مُرَجِّحُ
u'كَانَ مَرْجِعٌ':Subject, #1: 1	كَانَ الْمَرْجِعُ
u'كَانَ مَرْجُوّ':Predicate, #1: 1	كَانَ مَرْجِعُ
u'كَانَ مَرْدُودٌ':Predicate, #6: 6	كَانَ مَرْجُوَّ
u'كَانَ مَرْدُودٌ':Subject, #1: 1	كَانَ مَرْدُودَ
u'كَانَ مُرْسَلٌ':Predicate, #8: 8	كَانَ الْمَرْدُودُ
u'كَانَ مُرْسَلٌ':Subject, #9: 9	كَانَ مُرْسَلاً
u'كَانَ مُرْسِلٌ':Subject, #1: 1	كَانَ مُرْسَلُهُ
u'كَانَ مُرْسَلٌ':Subject, #1: 1	كَانَ مُرْسِلُهُ
u'كَانَ مُرْسِلٌ':Subject, #2: 2	كَانَ الْمُرْسَلُ
u'كَانَ مَرَضٌ':Predicate, #7: 7	كَانَ الْمُرْسِلُ
u'كَانَ مَرَضٌ':Subject, #2: 2	كَانَ مَرَضَ
u'كَانَ مَرَضٌ':Subject, #15: 15	كَانَ الْمَرَضُ
u'كَانَ مَرَضٌ':Subject, #1: 1	كَانَ مَرَضُ
u'كَانَ مَرْفَأٌ':Predicate, #3: 3	كَانَ مَرَضُهُ
u'كَانَ مِرْفَقٌ':Subject, #1: 1	كَانَ مَرْفَأَ
u'كَانَ مُرَكَّبٌ':Subject, #1: 1	كَانَ الْمِرْفَقُ
u'كَانَ مَرْهُونٌ':Subject, #3: 3	كَانَ الْمُرَكَّبُ
u'كَانَ مُرُورٌ':Subject, #6: 6	كَانَ الْمَرْهُونُ
u'كَانَ مُرِيدٌ':Subject, #3: 3	كَانَ الْمُرُورُ
u'كَانَ مُرِيدٌ':Subject, #1: 1	كَانَ مُرِيدٌ
u'كَانَ مُرِيدٌ':Subject, #1: 1	كَانَ مُرِيدُ
u'كَانَ مَرِيضٌ':Subject, #2: 2	كَانَ الْمُرِيدُ
u'كَانَ مِزَاجٌ':Subject, #16: 16	كَانَ الْمَرِيضُ
u'كَانَ مُزَاحٌ':Subject, #4: 4	كَانَ مِزَاجُ
u'كَانَ مُزَاحِمٌ':Subject, #2: 2	كَانَ الْمُزَاحُ
u'كَانَ مُزَاحِمٌ':Subject, #1: 1	كَانَ مُزَاحِمُهُ
u'كَانَ مُزَارِعٌ':Subject, #2: 2	كَانَ الْمُزَاحِمُ
u'كَانَ مزال':Subject, #8: 8	كَانَ الْمُزَارِعُ
u'كَانَ مَزْرُوعٌ':Subject, #2: 2	كَانَ الْمُزَالُ
u'كَانَ مَزَلَّةٌ':Predicate, #1: 1	كَانَ الْمَزْرُوعُ
u'كَانَ مُزَوِّرٌ':Subject, #1: 1	كَانَ مَزَلَّةَ
u'كَانَ مَسٌّ':Subject, #1: 1	كَانَ الْمُزَوِّرُ
u'كَانَ مَسٌّ':Subject, #1: 1	كَانَ مَسُّ
u'كَانَ مَسَاءٌ':Subject, #3: 3	كَانَ الْمَسُّ
u'كَانَ مَسَاءٌ':Subject, #1: 1	كَانَ الْمَسَاءُ
u'كَانَ مَسَاجِدُ':Subject, #2: 2	كَانَ مَسَاءُ
u'كَانَ مُسَافِرٌ':Subject, #1: 1	كَانَ مَسَاجِدُ
u'كَانَ مَسَائِلُ':Subject, #8: 8	كَانَ الْمُسَافِرُ
u'كَانَ مَسْبُوق':Subject, #1: 1	كَانَ مَسَائِلُ
u'كَانَ مُسْتَأْجِرٌ':Predicate, #3: 3	كَانَ الْمَسْبُوقُ
u'كَانَ مُسْتَأْجِرٌ':Predicate, #1: 1	كَانَ مُسْتَأْجِرَ
u'كَانَ مُسْتَأْجِرٌ':Subject, #3: 3	كَانَ الْمُسْتَأْجِرَ
u'كَانَ مُسْتَبِدٌّ':Subject, #42: 42	كَانَ الْمُسْتَأْجِرُ
u'كَانَ مُسْتَبْضِع':Subject, #1: 1	كَانَ الْمُسْتَبِدُّ
u'كَانَ مُسْتَبِيح':Subject, #1: 1	كَانَ الْمُسْتَبْضِعُ
u'كَانَ مُسْتَحَبٌّ':Subject, #1: 1	كَانَ الْمُسْتَبِيحُ
u'كَانَ مُسْتَحَقٌّ':Predicate, #3: 3	كَانَ الْمُسْتَحَبُّ
u'كَانَ مُسْتَحِقٌّ':Predicate, #1: 1	كَانَ مُسْتَحَقَّ
u'كَانَ مُسْتَحِقٌّ':Subject, #1: 1	كَانَ مُسْتَحِقَّ
u'كَانَ مُسْتَحَقٌّ':Subject, #11: 11	كَانَ الْمُسْتَحِقُّ
u'كَانَ مُسْتَحَقٌّ':Subject, #19: 19	كَانَ الْمُسْتَحَقُّ
u'كَانَ مُسْتَحَقٌّ':Subject, #1: 1	كَانَ مُسْتَحَقٌّ
u'كَانَ مُسْتَحِقٌّ':Subject, #1: 1	كَانَ مُسْتَحَقُّهُ
u'كَانَ مُسْتَخْرَجٌ':Subject, #1: 1	كَانَ مُسْتَحِقُّهُ
u'كَانَ مُسْتَعَارٌ':Subject, #2: 2	كَانَ الْمُسْتَخْرَجُ
u'كَانَ مُسْتَعَانٌ':Subject, #4: 4	كَانَ الْمُسْتَعَارُ
u'كَانَ مُسْتَعْمَلٌ':Subject, #1: 1	كَانَ الْمُسْتَعَانُ
u'كَانَ مُسْتَعْمِلٌ':Subject, #1: 1	كَانَ الْمُسْتَعْمَلُ
u'كَانَ مُسْتَعِيرٌ':Subject, #3: 3	كَانَ الْمُسْتَعْمِلُ
u'كَانَ مُسْتَعِيرٌ':Subject, #1: 1	كَانَ مُسْتَعِيرُ
u'كَانَ مُسْتَعِين':Subject, #9: 9	كَانَ الْمُسْتَعِيرُ
u'كَانَ مُسْتَغَلٌّ':Subject, #1: 1	كَانَ الْمُسْتَعِينُ
u'كَانَ مُسْتَفاد':Subject, #1: 1	كَانَ الْمُسْتَغَلُّ
u'كَانَ مُسْتَقْبِلٌ':Predicate, #6: 6	كَانَ الْمُسْتَفَادُ
u'كَانَ مُسْتَمِعٌ':Subject, #3: 3	كَانَ مُسْتَقْبِلَ
u'كَانَ مُسْتَنِدٌ':Predicate, #1: 1	كَانَ الْمُسْتَمِعُ
u'كَانَ مُسْتَنَدٌ':Subject, #1: 1	كَانَ مُسْتَنِدَ
u'كَانَ مُسْتَنِدٌ':Subject, #1: 1	كَانَ الْمُسْتَنَدُ
u'كَانَ مُسْتَنِدٌ':Subject, #1: 1	كَانَ مُسْتَنِدُ
u'كَانَ مُسْتَنَدٌ':Subject, #1: 1	كَانَ مُسْتَنِدُهُ
u'كَانَ مُسْتَنَدٌ':Subject, #2: 2	كَانَ مُسْتَنَدُهُ
u'كَانَ مُسْتَنِيب':Subject, #6: 6	كَانَ مُسْتَنَدُ
u'كَانَ مُسْتَهْلَكٌ':Subject, #3: 3	كَانَ الْمُسْتَنِيبُ
u'كَانَ مُسْتَهْلِكٌ':Subject, #1: 1	كَانَ الْمُسْتَهْلَكُ
u'كَانَ مُسْتَوْدَعٌ':Subject, #2: 2	كَانَ الْمُسْتَهْلِكُ
u'كَانَ مَسْتُورٌ':Predicate, #3: 3	كَانَ الْمُسْتَوْدَعُ
u'كَانَ مَسْجِدٌ':Predicate, #1: 1	كَانَ مَسْتُورَ
u'كَانَ مَسْجِدٌ':Predicate, #1: 1	كَانَ الْمَسْجِدَ
u'كَانَ مَسْجِدٌ':Subject, #1: 1	كَانَ مَسْجِدَ
u'كَانَ مَسْجِدٌ':Subject, #1: 1	كَانَ مَسْجِدُ
u'كَانَ مَسْجِدٌ':Subject, #38: 38	كَانَ الْمَسْجِدُ
u'كَانَ مَسْحٌ':Subject, #3: 3	كَانَ مَسْجِدٌ
u'كَانَ مَسْرُوقٌ':Subject, #7: 7	كَانَ الْمَسْحُ
u'كَانَ مِسْكٌ':Subject, #14: 14	كَانَ الْمَسْرُوقُ
u'كَانَ مَسْكَنٌ':Predicate, #1: 1	كَانَ الْمِسْكُ
u'كَانَ مَسْكَنٌ':Subject, #1: 1	كَانَ الْمَسْكَنَ
u'كَانَ مَسْكَنٌ':Subject, #2: 2	كَانَ مَسْكَنُ
u'كَانَ مَسْكَنٌ':Subject, #3: 3	كَانَ مَسْكَنُهُ
u'كَانَ مَسْكُوتٌ':Subject, #9: 9	كَانَ الْمَسْكَنُ
u'كَانَ مِسْكِينٌ':Subject, #4: 4	كَانَ الْمَسْكُوتُ
u'كَانَ مُسَلَّمٌ':Predicate, #1: 1	كَانَ الْمِسْكِينُ
u'كَانَ مُسَلَّمٌ':Subject, #1: 1	كَانَ الْمُسَلَّمَ
u'كَانَ مُسْلِمٌ':Subject, #11: 11	كَانَ الْمُسَلَّمُ
u'كَانَ مُسْلِمٌ':Subject, #22: 22	كَانَ الْمُسْلِمُ
u'كَانَ مَسْلُوكٌ':Subject, #6: 6	كَانَ مُسْلِمٌ
u'كَانَ مُسَوِّغٌ':Subject, #2: 2	كَانَ الْمَسْلُوكُ
u'كَانَ مَسِيحٌ':Subject, #1: 1	كَانَ الْمُسَوِّغُ
u'كَانَ مَسِيرَةٌ':Predicate, #3: 3	كَانَ الْمَسِيحُ
u'كَانَ مَسِيرَةٌ':Subject, #1: 1	كَانَ مَسِيرَةَ
u'كَانَ مَسِيلٌ':Subject, #1: 1	كَانَ مَسِيرَةُ
u'كَانَ مَسِيلٌ':Subject, #1: 1	كَانَ الْمَسِيلُ
u'كَانَ مُشار':Subject, #3: 3	كَانَ مَسِيلُ
u'كَانَ مُشَارِكٌ':Subject, #13: 13	كَانَ الْمُشَارُ
u'كَانَ مُشَارَكَةٌ':Subject, #1: 1	كَانَ الْمُشَارِكُ
u'كَانَ مُشَاوَرَةٌ':Subject, #1: 1	كَانَ الْمُشَارَكَةُ
u'كَانَ مُشَبَّهٌ':Subject, #1: 1	كَانَ مُشَاوَرَتُهُ
u'كَانَ مُشْتَرَكٌ':Predicate, #7: 7	كَانَ الْمُشَبَّهُ
u'كَانَ مُشْتَرَكٌ':Subject, #1: 1	كَانَ مُشْتَرَكَ
u'كَانَ مُشْتَغِل':Predicate, #10: 10	كَانَ الْمُشْتَرَكُ
u'كَانَ مُشْتَقٌّ':Subject, #1: 1	كَانَ مُشْتَغِلاً
u'كَانَ مُشْرِفٌ':Subject, #2: 2	كَانَ الْمُشْتَقُّ
u'كَانَ مُشْرِك':Predicate, #1: 1	كَانَ مُشْرِفٌ
u'كَانَ مَشْرُوطٌ':Subject, #1: 1	كَانَ مُشْرِكِينَ
u'كَانَ مَشْفُوع':Subject, #20: 20	كَانَ الْمَشْرُوطُ
u'كَانَ مَشْقُوقٌ':Predicate, #1: 1	كَانَ الْمَشْفُوعُ
u'كَانَ مَشْقُوقٌ':Subject, #1: 1	كَانَ مَشْقُوقَ
u'كَانَ مُشْكِلٌ':Predicate, #1: 1	كَانَ الْمَشْقُوقُ
u'كَانَ مُشْكِلٌ':Subject, #2: 2	كَانَ مُشْكِلَ
u'كَانَ مُشْكِلٌ':Subject, #3: 3	كَانَ الْمُشْكِلُ
u'كَانَ مَشْكُوكٌ':Subject, #3: 3	كَانَ مُشْكِلُ
u'كَانَ مَشْهُودٌ':Subject, #5: 5	كَانَ الْمَشْكُوكُ
u'كَانَ مَشْهُورٌ':Predicate, #54: 54	كَانَ الْمَشْهُودُ
u'كَانَ مَشْهُورٌ':Subject, #1: 1	كَانَ مَشْهُورَ
u'كَانَ مَشْهُورٌ':Subject, #1: 1	كَانَ مَشْهُورُ
u'كَانَ مَشْيٌ':Subject, #6: 6	كَانَ الْمَشْهُورُ
u'كَانَ مَشْيٌ':Subject, #2: 2	كَانَ الْمَشْيُ
u'كَانَ مَصّ':Predicate, #3: 3	كَانَ مَشْيُهُ
u'كَانَ مُصَابٌ':Subject, #2: 2	كَانَ مَصَّةً
u'كَانَ مُصَابٌ':Subject, #1: 1	كَانَ مُصَابُ
u'كَانَ مُصَاحِبٌ':Subject, #3: 3	كَانَ الْمُصَابُ
u'كَانَ مُصَالِحٌ':Subject, #2: 2	كَانَ الْمُصَاحِبُ
u'كَانَ مَصْبُوبٌ':Subject, #6: 6	كَانَ الْمُصَالِحُ
u'كَانَ مُصْحَفٌ':Subject, #3: 3	كَانَ الْمَصْبُوبُ
u'كَانَ مُصْحَفٌ':Subject, #1: 1	كَانَ مُصْحَفٌ
u'كَانَ مَصْدَرٌ':Subject, #4: 4	كَانَ الْمُصْحَفُ
u'كَانَ مُصَدِّقٌ':Predicate, #2: 2	كَانَ الْمَصْدَرُ
u'كَانَ مُصَدِّقٌ':Subject, #1: 1	كَانَ مُصَدِّقَ
u'كَانَ مِصْرٌ':Subject, #3: 3	كَانَ الْمُصَدِّقُ
u'كَانَ مِصْرَاعٌ':Subject, #4: 4	كَانَ الْمِصْرُ
u'كَانَ مَصْرِفٌ':Subject, #1: 1	كَانَ الْمِصْرَاعُ
u'كَانَ مَصْرُوفٌ':Subject, #1: 1	كَانَ مَصْرِفُهُ
u'كَانَ مَصْرُوف':Subject, #1: 1	كَانَ الْمَصْرُوفُ
u'كَانَ مَصْرُوفٌ':Subject, #1: 1	كَانَ الْمَصْرُوفُ
u'كَانَ مَصْرُوف':Subject, #1: 1	كَانَ مَصْرُوفُ
u'كَانَ مَصْلَحَةٌ':Subject, #1: 1	كَانَ مَصْرُوفُ
u'كَانَ مُصَنِّفٌ':Subject, #1: 1	كَانَ مَصْلَحَةُ
u'كَانَ مَصْنُوعٌ':Subject, #5: 5	كَانَ الْمُصَنِّفُ
u'كَانَ مُصِيبٌ':Subject, #1: 1	كَانَ الْمَصْنُوعُ
u'كَانَ مُصِيبٌ':Subject, #1: 1	كَانَ مُصِيبُهُ
u'كَانَ مَصِيرٌ':Subject, #2: 2	كَانَ الْمُصِيبُ
u'كَانَ مَصِيرٌ':Subject, #1: 1	كَانَ مَصِيرُ
u'كَانَ مُضَارِبٌ':Subject, #4: 4	كَانَ الْمَصِيرُ
u'كَانَ مُضَافٌ':Subject, #51: 51	كَانَ الْمُضَارِبُ
u'كَانَ مَضْرُوبٌ':Subject, #10: 10	كَانَ الْمُضَافُ
u'كَانَ مُضْطَرٌّ':Subject, #1: 1	كَانَ الْمَضْرُوبُ
u'كَانَ مُضْطَرِبٌ':Predicate, #3: 3	كَانَ الْمُضْطَرُّ
u'كَانَ مَضْغٌ':Subject, #1: 1	كَانَ مُضْطَرِبَ
u'كَانَ مَضْمُومٌ':Subject, #1: 1	كَانَ الْمَضْغُ
u'كَانَ مَضْمُونٌ':Predicate, #1: 1	كَانَ الْمَضْمُومَةُ
u'كَانَ مَضْمُونٌ':Subject, #2: 2	كَانَ مَضْمُونَ
u'كَانَ مَضْمُونٌ':Subject, #3: 3	كَانَ مَضْمُونُ
u'كَانَ مُضِيٌّ':Subject, #9: 9	كَانَ الْمَضْمُونُ
u'كَانَ مَطَرٌ':Subject, #1: 1	كَانَ الْمُضِيُّ
u'كَانَ مَطَرٌ':Subject, #1: 1	كَانَ مَطَرٌ
u'كَانَ مَطْعَمٌ':Subject, #8: 8	كَانَ الْمَطَرُ
u'كَانَ مُطْعِمٌ':Subject, #1: 1	كَانَ مَطْعَمُهُ
u'كَانَ مُطْلَقٌ':Predicate, #2: 2	كَانَ مُطْعِمُ
u'كَانَ مُطْلَقٌ':Predicate, #1: 1	كَانَ الْمُطْلَقَ
u'كَانَ مُطْلِقٌ':Subject, #1: 1	كَانَ مُطْلَقَ
u'كَانَ مُطْلَقٌ':Subject, #1: 1	كَانَ الْمُطْلِقُ
u'كَانَ مُطْلَقٌ':Subject, #2: 2	كَانَ مُطْلَقُ
u'كَانَ مَطْلُوبٌ':Subject, #3: 3	كَانَ الْمُطْلَقُ
u'كَانَ مَطْلُوبٌ':Subject, #34: 34	كَانَ الْمَطْلُوبُ
u'كَانَ مَظْرُوفٌ':Subject, #3: 3	كَانَ مَطْلُوبُ
u'كَانَ مَظْلُومٌ':Subject, #2: 2	كَانَ الْمَظْرُوفُ
u'كَانَ مُعَادٌ':Subject, #2: 2	كَانَ الْمَظْلُومُ
u'كَانَ مُعارِضٌ':Subject, #1: 1	كَانَ الْمُعَادُ
u'كَانَ مُعَارَضَةٌ':Subject, #1: 1	كَانَ الْمُعَارِضُ
u'كَانَ مُعَامِلٌ':Subject, #1: 1	كَانَ الْمُعَارَضَةُ
u'كَانَ مُعاوِيَة':Subject, #1: 1	كَانَ مُعَامِلُهُ
u'كَانَ مَعْبَدٌ':Subject, #4: 4	كَانَ مُعَاوِيَةُ
u'كَانَ مُعْتَادٌ':Subject, #1: 1	كَانَ مَعْبَدٌ
u'كَانَ مُعْتَبَرٌ':Subject, #2: 2	كَانَ الْمُعْتَادُ
u'كَانَ مُعْتَبَرٌ':Subject, #1: 1	كَانَ مُعْتَبَرٌ
u'كَانَ مُعْتَدٌّ':Predicate, #22: 22	كَانَ الْمُعْتَبَرُ
u'كَانَ مُعْتَدٌّ':Subject, #1: 1	كَانَ مُعْتَدَّةً
u'كَانَ مُعْتَدِلٌ':Predicate, #3: 3	كَانَ الْمُعْتَدُّ
u'كَانَ مُعْتَرِضٌ':Subject, #1: 1	كَانَ مُعْتَدِلَ
u'كَانَ مُعْتَقٌ':Predicate, #3: 3	كَانَ الْمُعْتَرِضُ
u'كَانَ مُعْتَقٌ':Predicate, #1: 1	كَانَ الْمُعْتَقَ
u'كَانَ مُعْتَقٌ':Subject, #1: 1	كَانَ مُعْتَقَ
u'كَانَ مُعْتَقٌ':Subject, #18: 18	كَانَ الْمُعْتَقُ
u'كَانَ مُعْتَقَدٌ':Subject, #3: 3	كَانَ مُعْتَقُ
u'كَانَ مُعْتَكَف':Subject, #2: 2	كَانَ مُعْتَقَدُهُ
u'كَانَ مُعْتَمَدٌ':Subject, #2: 2	كَانَ مُعْتَكَفُهُ
u'كَانَ مُعْتَمَدٌ':Subject, #12: 12	كَانَ الْمُعْتَمَدُ
u'كَانَ مَعْتُوهٌ':Subject, #1: 1	كَانَ مُعْتَمَدُ
u'كَانَ مُعْجِزٌ':Predicate, #1: 1	كَانَ الْمَعْتُوهُ
u'كَانَ مُعَجِّلٌ':Subject, #2: 2	كَانَ مُعْجِزَةً
u'كَانَ مُعَجَّلٌ':Subject, #1: 1	كَانَ الْمُعَجِّلُ
u'كَانَ مَعْدِنٌ':Predicate, #6: 6	كَانَ الْمُعَجَّلُ
u'كَانَ مَعْدِنٌ':Subject, #2: 2	كَانَ مَعْدِنَ
u'كَانَ مَعْدُودٌ':Subject, #3: 3	كَانَ الْمَعْدِنُ
u'كَانَ مَعْدُومٌ':Predicate, #3: 3	كَانَ الْمَعْدُودُ
u'كَانَ مَعْدُومٌ':Subject, #1: 1	كَانَ مَعْدُومَ
u'كَانَ مَعْرُوفٌ':Predicate, #1: 1	كَانَ الْمَعْدُومُ
u'كَانَ مَعْرُوفٌ':Subject, #7: 7	كَانَ مَعْرُوفَ
u'كَانَ مَعْرُوفٌ':Subject, #1: 1	كَانَ مَعْرُوفٌ
u'كَانَ مَعْرُوفٌ':Subject, #1: 1	كَانَ مَعْرُوفُ
u'كَانَ مَعْشَرٌ':Subject, #3: 3	كَانَ الْمَعْرُوفُ
u'كَانَ مَعْطُوبٌ':Subject, #1: 1	كَانَ مَعْشَرٌ
u'كَانَ مَعْطُوف':Subject, #1: 1	كَانَ الْمَعْطُوبُ
u'كَانَ مُعْظَمٌ':Subject, #3: 3	كَانَ الْمَعْطُوفُ
u'كَانَ مَعْقِلٌ':Subject, #4: 4	كَانَ مُعْظَمُ
u'كَانَ مَعْقِلٌ':Subject, #1: 1	كَانَ مَعْقِلٌ
u'كَانَ مَعْقُودٌ':Subject, #1: 1	كَانَ مَعْقِلُ
u'كَانَ مَعْقُولٌ':Predicate, #59: 59	كَانَ الْمَعْقُودُ
u'كَانَ مُعَلَّقٌ':Subject, #1: 1	كَانَ مَعْقُولَ
u'كَانَ مُعَلِّقٌ':Subject, #19: 19	كَانَ الْمُعَلَّقُ
u'كَانَ مُعَلِّمٌ':Predicate, #2: 2	كَانَ الْمُعَلِّقُ
u'كَانَ مَعْلَمٌ':Subject, #1: 1	كَانَ الْمُعَلِّمَ
u'كَانَ مُعَلِّمٌ':Subject, #1: 1	كَانَ الْمَعْلَمُ
u'كَانَ مُعْلَنٌ':Predicate, #3: 3	كَانَ الْمُعَلِّمُ
u'كَانَ مَعْلُولٌ':Predicate, #1: 1	كَانَ مُعْلَنَ
u'كَانَ مَعْلُولٌ':Subject, #2: 2	كَانَ مَعْلُولَ
u'كَانَ مَعْلُومٌ':Predicate, #1: 1	كَانَ الْمَعْلُولُ
u'كَانَ مَعْلُوم':Subject, #13: 13	كَانَ مَعْلُومَ
u'كَانَ مَعْلُومٌ':Subject, #2: 2	كَانَ مَعْلُومِيَّةُ
u'كَانَ مَعْلُومَة':Subject, #4: 4	كَانَ الْمَعْلُومُ
u'كَانَ مَعْهُودٌ':Subject, #2: 2	كَانَ مَعْلُومِيَّةُ
u'كَانَ مُعَوَّضٌ':Subject, #1: 1	كَانَ الْمَعْهُودُ
u'كَانَ مِعْيَارٌ':Predicate, #1: 1	كَانَ الْمُعَوَّضُ
u'كَانَ مَعِيبٌ':Subject, #1: 1	كَانَ مِعْيَارَ
u'كَانَ مُعِير':Subject, #4: 4	كَانَ الْمَعِيبُ
u'كَانَ مُعَيَّنٌ':Subject, #2: 2	كَانَ الْمُعِيرُ
u'كَانَ مُعِينٌ':Subject, #1: 1	كَانَ مُعَيَّنُ
u'كَانَ مُعَيَّنٌ':Subject, #3: 3	كَانَ الْمُعِينُ
u'كَانَ مَغْبُونٌ':Subject, #3: 3	كَانَ الْمُعَيَّنُ
u'كَانَ مَغْرِبٌ':Subject, #2: 2	كَانَ الْمَغْبُونُ
u'كَانَ مَغْرُورٌ':Subject, #1: 1	كَانَ الْمَغْرِبُ
u'كَانَ مَغْشُوشٌ':Subject, #3: 3	كَانَ الْمَغْرُورُ
u'كَانَ مَغْصُوب':Predicate, #1: 1	كَانَ الْمَغْشُوشُ
u'كَانَ مَغْصُوب':Subject, #1: 1	كَانَ الْمَغْصُوبَ
u'كَانَ مُغَلَّب':Subject, #39: 39	كَانَ الْمَغْصُوبُ
u'كَانَ مَغْلُوبٌ':Subject, #3: 3	كَانَ الْمُغَلَّبُ
u'كَانَ مَغْنَمٌ':Subject, #1: 1	كَانَ الْمَغْلُوبُ
u'كَانَ مُغَيَّبٌ':Subject, #2: 2	كَانَ الْمَغْنَمُ
u'كَانَ مَغِيبٌ':Subject, #1: 1	كَانَ الْمُغَيَّبُ
u'كَانَ مَغِيبٌ':Subject, #1: 1	كَانَ مَغِيبُهُ
u'كَانَ مُغَيِّرٌ':Subject, #2: 2	كَانَ الْمَغِيبُ
u'كَانَ مُفَادٌ':Subject, #1: 1	كَانَ الْمُغَيِّرُ
u'كَانَ مُفَارِقٌ':Subject, #1: 1	كَانَ الْمُفَادُ
u'كَانَ مِفْتَاحٌ':Subject, #1: 1	كَانَ الْمُفَارِقُ
u'كَانَ مُفْتَقِرٌ':Subject, #1: 1	كَانَ الْمِفْتَاحُ
u'كَانَ مَفْتُوحٌ':Subject, #1: 1	كَانَ الْمُفْتَقِرُ
u'كَانَ مُفْرَدٌ':Subject, #1: 1	كَانَ الْمَفْتُوحُ
u'كَانَ مُفْرَدٌ':Subject, #1: 1	كَانَ الْمُفْرَدُ
u'كَانَ مُفَرِّقٌ':Subject, #1: 1	كَانَ الْمُفْرَدَاتُ
u'كَانَ مَفْرُوضٌ':Subject, #1: 1	كَانَ الْمُفَرِّقُ
u'كَانَ مُفْسِدٌ':Subject, #3: 3	كَانَ الْمَفْرُوضُ
u'كَانَ مَفْصُولٌ':Subject, #5: 5	كَانَ الْمُفْسِدُ
u'كَانَ مَفْعُولٌ':Subject, #1: 1	كَانَ الْمَفْصُولُ
u'كَانَ مَفْعُولٌ':Subject, #1: 1	كَانَ مَفْعُولُ
u'كَانَ مَفْعُولٌ':Subject, #1: 1	كَانَ مَفْعُولُهُ
u'كَانَ مَفْقُودٌ':Predicate, #9: 9	كَانَ الْمَفْعُولُ
u'كَانَ مَفْقُودٌ':Subject, #1: 1	كَانَ مَفْقُودَ
u'كَانَ مُفْلِسٌ':Subject, #4: 4	كَانَ الْمَفْقُودُ
u'كَانَ مَفْهُومٌ':Predicate, #2: 2	كَانَ الْمُفْلِسُ
u'كَانَ مَفْهُومٌ':Subject, #4: 4	كَانَ مَفْهُومَ
u'كَانَ مَفْهُومٌ':Subject, #2: 2	كَانَ الْمَفْهُومُ
u'كَانَ مَفْهُومٌ':Subject, #2: 2	كَانَ مَفْهُومُهُ
u'كَانَ مُفَوَّضٌ':Subject, #3: 3	كَانَ مَفْهُومُ
u'كَانَ مُفِيدٌ':Subject, #2: 2	كَانَ الْمُفَوَّضُ
u'كَانَ مُقَابِلٌ':Subject, #1: 1	كَانَ مُفِيدُهُ
u'كَانَ مُقَابِلٌ':Subject, #1: 1	كَانَ الْمُقَابِلُ
u'كَانَ مَقَامٌ':Predicate, #5: 5	كَانَ مُقَابِلُهُ
u'كَانَ مُقَامٌ':Subject, #1: 1	كَانَ مَقَامَ
u'كَانَ مَقَامٌ':Subject, #1: 1	كَانَ مُقَامُهُ
u'كَانَ مَقَامٌ':Subject, #2: 2	كَانَ الْمَقَامُ
u'كَانَ مُقَبِّلٌ':Subject, #2: 2	كَانَ مَقَامُهُ
u'كَانَ مَقْبُورٌ':Subject, #4: 4	كَانَ الْمُقَبِّلُ
u'كَانَ مَقْبُوضٌ':Subject, #1: 1	كَانَ الْمَقْبُورُ
u'كَانَ مُقْتَرِضٌ':Subject, #13: 13	كَانَ الْمَقْبُوضُ
u'كَانَ مَقْتُولٌ':Subject, #1: 1	كَانَ الْمُقْتَرِضُ
u'كَانَ مِقْدَارٌ':Predicate, #38: 38	كَانَ الْمَقْتُولُ
u'كَانَ مِقْدَارٌ':Subject, #9: 9	كَانَ مِقْدَارَ
u'كَانَ مِقْدَارٌ':Subject, #17: 17	كَانَ مِقْدَارُهُ
u'كَانَ مِقْدَارٌ':Subject, #2: 2	كَانَ مِقْدَارٌ
u'كَانَ مُقَدَّرٌ':Subject, #6: 6	كَانَ مِقْدَارُ
u'كَانَ مُقَدِّمٌ':Predicate, #1: 1	كَانَ الْمُقَدَّرُ
u'كَانَ مُقَدَّمٌ':Subject, #1: 1	كَانَ مُقَدِّمَةً
u'كَانَ مُقَدَّمٌ':Subject, #1: 1	كَانَ الْمُقَدَّمُ
u'كَانَ مُقَدِّمٌ':Subject, #1: 1	كَانَ مُقَدَّمُ
u'كَانَ مُقَدِّمَةٌ':Subject, #1: 1	كَانَ مُقَدِّمَاتُهُ
u'كَانَ مَقْدُورٌ':Predicate, #1: 1	كَانَ مُقَدِّمَاتُهُ
u'كَانَ مَقْدُورٌ':Subject, #1: 1	كَانَ مَقْدُورَ
u'كَانَ مَقْذُوفٌ':Subject, #1: 1	كَانَ الْمَقْدُورُ
u'كَانَ مَقَرٌّ':Subject, #15: 15	كَانَ الْمَقْذُوفُ
u'كَانَ مُقَرَّرٌ':Subject, #3: 3	كَانَ الْمَقَرُّ
u'كَانَ مُقَرِّرٌ':Subject, #1: 1	كَانَ الْمُقَرَّرُ
u'كَانَ مُقْرِضٌ':Subject, #1: 1	كَانَ الْمُقَرِّرُ
u'كَانَ مَقْسُومٌ':Subject, #1: 1	كَانَ الْمُقْرِضُ
u'كَانَ مَقْصِدٌ':Subject, #5: 5	كَانَ الْمَقْسُومُ
u'كَانَ مَقْصِدٌ':Subject, #2: 2	كَانَ مَقْصِدُهُ
u'كَانَ مَقْصُودٌ':Predicate, #4: 4	كَانَ الْمَقْصِدُ
u'كَانَ مَقْصُودٌ':Predicate, #2: 2	كَانَ الْمَقْصُودَ
u'كَانَ مَقْصُودٌ':Subject, #2: 2	كَانَ مَقْصُودَ
u'كَانَ مَقْصُودٌ':Subject, #2: 2	كَانَ مَقْصُودُ
u'كَانَ مَقْصُودٌ':Subject, #46: 46	كَانَ الْمَقْصُودُ
u'كَانَ مَقْضِيّ':Subject, #8: 8	كَانَ مَقْصُودُهُ
u'كَانَ مَقْطَعٌ':Subject, #13: 13	كَانَ الْمَقْضِيُّ
u'كَانَ مَقْطُوعٌ':Predicate, #2: 2	كَانَ الْمَقْطَعُ
u'كَانَ مَقْطُوعٌ':Predicate, #13: 13	كَانَ مَقْطُوعَ
u'كَانَ مَقْطُوعٌ':Subject, #1: 1	كَانَ مَقْطُوعَةَ
u'كَانَ مَقْطُوعٌ':Subject, #10: 10	كَانَ الْمَقْطُوعُ
u'كَانَ مَقْطُوعَةٌ':Predicate, #1: 1	كَانَ الْمَقْطُوعَةُ
u'كَانَ مَقْطُوعَةٌ':Subject, #1: 1	كَانَ مَقْطُوعَةَ
u'كَانَ مُقْعَدٌ':Subject, #1: 1	كَانَ الْمَقْطُوعَةُ
u'كَانَ مُقَلِّدٌ':Subject, #1: 1	كَانَ مُقْعَدٌ
u'كَانَ مُقَلَّدٌ':Subject, #1: 1	كَانَ الْمُقَلِّدُ
u'كَانَ مَقْهُور':Subject, #2: 2	كَانَ الْمُقَلَّدُ
u'كَانَ مِقْوَدٌ':Subject, #1: 1	كَانَ الْمَقْهُورُ
u'كَانَ مَقُولٌ':Subject, #1: 1	كَانَ الْمِقْوَدُ
u'كَانَ مُقَيَّدٌ':Predicate, #2: 2	كَانَ الْمَقُولُ
u'كَانَ مُقَيَّدٌ':Subject, #1: 1	كَانَ الْمُقَيَّدَ
u'كَانَ مُقِيمٌ':Subject, #4: 4	كَانَ الْمُقَيَّدُ
u'كَانَ مَكَاتِبُ':Subject, #6: 6	كَانَ الْمُقِيمُ
u'كَانَ مُكَاتَبَةٌ':Subject, #1: 1	كَانَ الْمَكَاتِبُ
u'كَانَ مَكَانٌ':Predicate, #4: 4	كَانَ مُكَاتَبَةُ
u'كَانَ مَكَانٌ':Subject, #110: 110	كَانَ مَكَانَ
u'كَانَ مَكَانٌ':Subject, #13: 13	كَانَ الْمَكَانُ
u'كَانَ مَكَانٌ':Subject, #18: 18	كَانَ مَكَانُ
u'كَانَ مُكْتَسِبٌ':Subject, #3: 3	كَانَ مَكَانُهُ
u'كَانَ مُكْتَنِزٌ':Subject, #2: 2	كَانَ الْمُكْتَسِبُ
u'كَانَ مَكْتُوبٌ':Subject, #1: 1	كَانَ الْمُكْتَنِزُ
u'كَانَ مُكْثٌ':Subject, #13: 13	كَانَ الْمَكْتُوبُ
u'كَانَ مَكْحُول':Subject, #2: 2	كَانَ الْمُكْثُ
u'كَانَ مُكْرِهٌ':Predicate, #2: 2	كَانَ مَكْحُولٌ
u'كَانَ مُكْرِهٌ':Subject, #1: 1	كَانَ الْمُكْرِهَ
u'كَانَ مُكْرَهٌ':Subject, #10: 10	كَانَ الْمُكْرِهُ
u'كَانَ مَكْرُوهٌ':Subject, #19: 19	كَانَ الْمُكْرَهُ
u'كَانَ مَكْرُوهٌ':Subject, #1: 1	كَانَ الْمَكْرُوهُ
u'كَانَ مَكْسُورٌ':Predicate, #2: 2	كَانَ مَكْرُوهُ
u'كَانَ مَكْشُوفٌ':Predicate, #1: 1	كَانَ مَكْسُورَ
u'كَانَ مَكْشُوفٌ':Subject, #4: 4	كَانَ مَكْشُوفَ
u'كَانَ مَكْفُوفٌ':Predicate, #1: 1	كَانَ الْمَكْشُوفُ
u'كَانَ مَكْفُولٌ':Subject, #1: 1	كَانَ مَكْفُوفَ
u'كَانَ مُكَلَّفٌ':Subject, #17: 17	كَانَ الْمَكْفُولُ
u'كَانَ مَكِّيّ':Subject, #3: 3	كَانَ الْمُكَلَّفُ
u'كَانَ مِكْيَالٌ':Subject, #1: 1	كَانَ الْمَكِّيُّ
u'كَانَ مَكِيلٌ':Predicate, #2: 2	كَانَ الْمِكْيَالُ
u'كَانَ مَكِيلٌ':Subject, #1: 1	كَانَ مَكِيلاً
u'كَانَ مِلْءٌ':Predicate, #7: 7	كَانَ الْمَكِيلُ
u'كَانَ مِلْءٌ':Subject, #13: 13	كَانَ مِلْءَ
u'كَانَ مَلْبَنٌ':Subject, #1: 1	كَانَ مِلْءُ
u'كَانَ مُلْتَقِط':Subject, #1: 1	كَانَ مَلْبَنُ
u'كَانَ ملح':Subject, #18: 18	كَانَ الْمُلْتَقِطُ
u'كَانَ مِلْحٌ':Subject, #2: 2	كَانَ الْمِلْحُ
u'كَانَ مَلْحَظٌ':Subject, #2: 2	كَانَ الْمِلْحُ
u'كَانَ مُلْحَقٌ':Subject, #1: 1	كَانَ مَلْحَظُ
u'كَانَ مَلْزُوم':Subject, #2: 2	كَانَ الْمُلْحَقُ
u'كَانَ مَلْزُوم':Subject, #1: 1	كَانَ الْمَلْزُومُ
u'كَانَ مَلْفُوظٌ':Subject, #1: 1	كَانَ مَلْزُومُهُ
u'كَانَ مُلَقَّب':Subject, #2: 2	كَانَ الْمَلْفُوظُ
u'كَانَ مِلْكٌ':Predicate, #1: 1	كَانَ الْمُلَقَّبُ
u'كَانَ مَلِكٌ':Predicate, #14: 14	كَانَ مِلْكَ
u'كَانَ مَلَكٌ':Predicate, #1: 1	كَانَ الْمَلِكَ
u'كَانَ مَلَكٌ':Subject, #2: 2	كَانَ مَلَكَ
u'كَانَ مُلْكٌ':Subject, #1: 1	كَانَ الْمَلَكُ
u'كَانَ مَلَكٌ':Subject, #1: 1	كَانَ الْمُلْكُ
u'كَانَ مِلْكٌ':Subject, #1: 1	كَانَ مَلَكُ
u'كَانَ مِلْكٌ':Subject, #1: 1	كَانَ مِلْكٌ
u'كَانَ مَلَكٌ':Subject, #26: 26	كَانَ مِلْكُهُ
u'كَانَ مِلْكٌ':Subject, #2: 2	كَانَ مَلَكٌ
u'كَانَ مَلِكٌ':Subject, #40: 40	كَانَ الْمِلْكُ
u'كَانَ مَلِكٌ':Subject, #4: 4	كَانَ مَلِكٌ
u'كَانَ مِلْكٌ':Subject, #6: 6	كَانَ الْمَلِكُ
u'كَانَ مَلْمُوسٌ':Subject, #7: 7	كَانَ مِلْكُ
u'كَانَ مُلُوكٌ':Subject, #2: 2	كَانَ الْمَلْمُوسُ
u'كَانَ مَمَاتٌ':Subject, #2: 2	كَانَ مُلُوكُ
u'كَانَ مُمْتَنِعٌ':Predicate, #1: 1	كَانَ الْمَمَاتُ
u'كَانَ مَمَرٌّ':Subject, #2: 2	كَانَ مُمْتَنِعَ
u'كَانَ مَمَرٌّ':Subject, #1: 1	كَانَ مَمَرُّ
u'كَانَ مَمْرُور':Subject, #1: 1	كَانَ مَمَرُّهُ
u'كَانَ مَمْسُوح':Predicate, #1: 1	كَانَ الْمَمْرُورُ
u'كَانَ مَمْسُوح':Subject, #1: 1	كَانَ مَمْسُوحَ
u'كَانَ مُمْكِنٌ':Predicate, #3: 3	كَانَ الْمَمْسُوحُ
u'كَانَ مُمْكِن':Predicate, #2: 2	كَانَ مُمْكِنَ
u'كَانَ مُمَلَّحٌ':Subject, #2: 2	كَانَ مُمْكِنَ
u'كَانَ مَمْلَحَةٌ':Subject, #1: 1	كَانَ الْمُمَلَّحُ
u'كَانَ مَمْلُوكٌ':Predicate, #1: 1	كَانَ مَمْلَحَةٌ
u'كَانَ مَمْلُوكٌ':Subject, #1: 1	كَانَ مَمْلُوكَ
u'كَانَ مَمْنُوعٌ':Predicate, #13: 13	كَانَ الْمَمْلُوكُ
u'كَانَ مَمْنُوعٌ':Subject, #1: 1	كَانَ مَمْنُوعَ
u'كَانَ مُمَيِّزٌ':Subject, #2: 2	كَانَ الْمَمْنُوعُ
u'كَانَ مَنٌّ':Subject, #1: 1	كَانَ الْمُمَيِّزُ
u'كَانَ مُنَادِي':Predicate, #2: 2	كَانَ الْمَنُّ
u'كَانَ مَنَارٌ':Subject, #1: 1	كَانَ الْمُنَادِيَ
u'كَانَ مُنَاسِبٌ':Subject, #1: 1	كَانَ الْمَنَارُ
u'كَانَ مَنَاطٌ':Subject, #8: 8	كَانَ الْمُنَاسِبُ
u'كَانَ مَنَاطٌ':Subject, #1: 1	كَانَ الْمَنَاطُ
u'كَانَ مُنافاة':Subject, #1: 1	كَانَ مَنَاطُ
u'كَانَ مَنَافِعُ':Predicate, #1: 1	كَانَ مُنَافَاةٌ
u'كَانَ مَنَافِعُ':Predicate, #1: 1	كَانَ الْمَنَافِعَ
u'كَانَ مِنْبَرٌ':Subject, #1: 1	كَانَ مَنَافِعَ
u'كَانَ مِنْبَرٌ':Subject, #1: 1	كَانَ مِنْبَرُ
u'كَانَ مَنْبَعٌ':Subject, #2: 2	كَانَ مِنْبَرُهُ
u'كَانَ مُنْتَظِر':Subject, #4: 4	كَانَ مَنْبَعُهُ
u'كَانَ مُنْتَفِشٌ':Predicate, #1: 1	كَانَ الْمُنْتَظِرُ
u'كَانَ مُنَجِّس':Subject, #1: 1	كَانَ مُنْتَفِشَ
u'كَانَ مُنْحَرِفٌ':Subject, #1: 1	كَانَ الْمُنَجِّسُ
u'كَانَ مَنْذُور':Subject, #1: 1	كَانَ الْمُنْحَرِفُ
u'كَانَ مَنْزِلٌ':Predicate, #3: 3	كَانَ الْمَنْذُورُ
u'كَانَ مَنْزِلٌ':Predicate, #1: 1	كَانَ مَنْزِلَ
u'كَانَ مَنْزِلٌ':Subject, #1: 1	كَانَ مَنْزِلاً
u'كَانَ مَنْزِلٌ':Subject, #12: 12	كَانَ مَنْزِلُهُ
u'كَانَ مَنْزِلٌ':Subject, #4: 4	كَانَ مَنْزِلُ
u'كَانَ مَنْزُول':Subject, #8: 8	كَانَ الْمَنْزِلُ
u'كَانَ مَنْسُوبٌ':Subject, #2: 2	كَانَ الْمَنْزُولُ
u'كَانَ مَنْسِيٌّ':Subject, #1: 1	كَانَ الْمَنْسُوبُ
u'كَانَ مَنْشَأٌ':Predicate, #1: 1	كَانَ الْمَنْسِيُّ
u'كَانَ مَنْصُوبٌ':Predicate, #2: 2	كَانَ مَنْشَأَ
u'كَانَ مَنْصُورٌ':Subject, #6: 6	كَانَ مَنْصُوبَ
u'كَانَ مَنْطِقٌ':Subject, #1: 1	كَانَ الْمَنْصُورُ
u'كَانَ مَنْطِقٌ':Subject, #1: 1	كَانَ الْمَنْطِقُ
u'كَانَ مَنْطِقِيٌّ':Subject, #1: 1	كَانَ مَنْطِقُهُ
u'كَانَ مَنْطُوقٌ':Subject, #1: 1	كَانَ الْمَنْطِقِيُّ
u'كَانَ مَنْطُوقٌ':Subject, #1: 1	كَانَ مَنْطُوقُهُ
u'كَانَ مَنْظُورٌ':Subject, #3: 3	كَانَ الْمَنْطُوقُ
u'كَانَ مَنْعٌ':Subject, #2: 2	كَانَ الْمَنْظُورُ
u'كَانَ مَنْعٌ':Subject, #17: 17	كَانَ الْمَنْعُ
u'كَانَ مُنْفَرِدٌ':Subject, #4: 4	كَانَ مَنْعُ
u'كَانَ مُنْفَصِلٌ':Subject, #3: 3	كَانَ الْمُنْفَرِدُ
u'كَانَ مَنْفَعَةٌ':Predicate, #2: 2	كَانَ الْمُنْفَصِلُ
u'كَانَ مَنْفَعَةٌ':Subject, #1: 1	كَانَ الْمَنْفَعَةَ
u'كَانَ مُنْفَق':Subject, #3: 3	كَانَ مَنْفَعَةُ
u'كَانَ مَنْفِيٌّ':Predicate, #1: 1	كَانَ الْمُنْفَقُ
u'كَانَ مَنْفِيٌّ':Subject, #1: 1	كَانَ مَنْفِيَّ
u'كَانَ مُنْقَسِم':Subject, #5: 5	كَانَ الْمَنْفِيُّ
u'كَانَ مَنْقُوص':Subject, #1: 1	كَانَ الْمُنْقَسِمُ
u'كَانَ مَنْقُولٌ':Subject, #1: 1	كَانَ الْمَنْقُوصُ
u'كَانَ مَنْكِبٌ':Subject, #5: 5	كَانَ الْمَنْقُولُ
u'كَانَ مُنْكِرٌ':Subject, #1: 1	كَانَ الْمَنْكِبُ
u'كَانَ مُنْكَرٌ':Subject, #1: 1	كَانَ مُنْكِرُ
u'كَانَ مُنْكِرٌ':Subject, #2: 2	كَانَ مُنْكَرٌ
u'كَانَ مُنْكَسِر':Subject, #6: 6	كَانَ الْمُنْكِرُ
u'كَانَ مَنْكُوح':Predicate, #1: 1	كَانَ الْمُنْكَسِرُ
u'كَانَ مَنْهِيٌّ':Subject, #1: 1	كَانَ مَنْكُوحَةَ
u'كَانَ مَنِيٌّ':Subject, #2: 2	كَانَ الْمَنْهِيُّ
u'كَانَ مُهَاجِرٌ':Subject, #1: 1	كَانَ الْمَنِيُّ
u'كَانَ مَهْجُوٌّ':Subject, #2: 2	كَانَ الْمُهَاجِرُ
u'كَانَ مَهْرٌ':Predicate, #1: 1	كَانَ الْمَهْجُوُّ
u'كَانَ مَهْرٌ':Subject, #2: 2	كَانَ مَهْرَ
u'كَانَ مَهْرٌ':Subject, #64: 64	كَانَ الْمَهْرُ
u'كَانَ مَوَاتٌ':Subject, #85: 85	كَانَ مَهْرُ
u'كَانَ مَوَاطِنُ':Subject, #4: 4	كَانَ الْمَوَاتُ
u'كَانَ مُوَافِقٌ':Subject, #1: 1	كَانَ الْمَوَاطِنُ
u'كَانَ مُوالاة':Subject, #1: 1	كَانَ الْمُوَافِقُ
u'كَانَ مَوْتٌ':Predicate, #1: 1	كَانَ الْمُوَالَاةُ
u'كَانَ مَوْتٌ':Subject, #1: 1	كَانَ مَوْتَ
u'كَانَ مَوْتٌ':Subject, #11: 11	كَانَ مَوْتُهُ
u'كَانَ مَوْتٌ':Subject, #21: 21	كَانَ الْمَوْتُ
u'كَانَ مُؤَثِّرٌ':Subject, #8: 8	كَانَ مَوْتُ
u'كَانَ مُوجِبٌ':Subject, #1: 1	كَانَ الْمُؤَثِّرُ
u'كَانَ مُوجِبٌ':Subject, #11: 11	كَانَ الْمُوجِبُ
u'كَانَ مُوجَبٌ':Subject, #12: 12	كَانَ مُوجِبُ
u'كَانَ مُوجَبٌ':Subject, #1: 1	كَانَ الْمُوجَبُ
u'كَانَ مُوجَبٌ':Subject, #1: 1	كَانَ مُوجَبُهُ
u'كَانَ مُوجِبٌ':Subject, #2: 2	كَانَ مُوجَبُ
u'كَانَ مُؤَجِّرٌ':Subject, #7: 7	كَانَ مُوجِبُهُ
u'كَانَ مُؤَجَّلٌ':Subject, #8: 8	كَانَ الْمُؤَجِّرُ
u'كَانَ مَوْجُودٌ':Subject, #2: 2	كَانَ الْمُؤَجَّلُ
u'كَانَ مُؤَخَّرٌ':Subject, #6: 6	كَانَ الْمَوْجُودُ
u'كَانَ مُودَعٌ':Subject, #1: 1	كَانَ الْمُؤَخَّرُ
u'كَانَ مُودِعٌ':Subject, #16: 16	كَانَ الْمُودَعُ
u'كَانَ مُؤَذِّنٌ':Predicate, #9: 9	كَانَ الْمُودِعُ
u'كَانَ مُؤَذِّنٌ':Subject, #2: 2	كَانَ مُؤَذِّنَ
u'كَانَ مُؤَذِّنٌ':Subject, #16: 16	كَانَ الْمُؤَذِّنُ
u'كَانَ مُوَرِّث':Subject, #1: 1	كَانَ مُؤَذِّنُ
u'كَانَ مَوْرِدٌ':Subject, #1: 1	كَانَ الْمُوَرِّثُ
u'كَانَ مَوْرُوثٌ':Subject, #1: 1	كَانَ مَوْرِدُ
u'كَانَ مَوْزُونٌ':Subject, #1: 1	كَانَ الْمَوْرُوثُ
u'كَانَ مُوسِرٌ':Subject, #1: 1	كَانَ الْمَوْزُونُ
u'كَانَ مُوسِّعٌ':Subject, #2: 2	كَانَ الْمُوسِرُ
u'كَانَ مَوْصُوفٌ':Subject, #1: 1	كَانَ الْمُوَسِّعُ
u'كَانَ مَوْصُولٌ':Predicate, #1: 1	كَانَ الْمَوْصُوفُ
u'كَانَ مَوْضِعٌ':Predicate, #1: 1	كَانَ مَوْصُولاً
u'كَانَ مَوْضِعٌ':Subject, #7: 7	كَانَ مَوْضِعَ
u'كَانَ مَوْضِعٌ':Subject, #31: 31	كَانَ مَوْضِعُ
u'كَانَ مَوْضِعٌ':Subject, #35: 35	كَانَ الْمَوْضِعُ
u'كَانَ مَوْضِعٌ':Subject, #3: 3	كَانَ مَوْضِعٌ
u'كَانَ مَوْضُوعٌ':Subject, #4: 4	كَانَ مَوْضِعُهُ
u'كَانَ مَوْضُوعٌ':Subject, #4: 4	كَانَ الْمَوْضُوعُ
u'كَانَ مُوَقِّعٌ':Subject, #4: 4	كَانَ مَوْضُوعُ
u'كَانَ مَوْقُوفٌ':Subject, #1: 1	كَانَ الْمُوَقِّعُ
u'كَانَ مُوَكِّلٌ':Subject, #27: 27	كَانَ الْمَوْقُوفُ
u'كَانَ مُوَكَّلٌ':Subject, #2: 2	كَانَ مُوَكِّلُهُ
u'كَانَ مُوَكِّلٌ':Subject, #4: 4	كَانَ الْمُوَكَّلُ
u'كَانَ مَوْلِدٌ':Subject, #68: 68	كَانَ الْمُوَكِّلُ
u'كَانَ مَوْلِدٌ':Subject, #1: 1	كَانَ مَوْلِدُ
u'كَانَ مُؤَلِّفٌ':Subject, #3: 3	كَانَ مَوْلِدُهُ
u'كَانَ مَوْلُودٌ':Subject, #1: 1	كَانَ الْمُؤَلِّفُ
u'كَانَ مُؤَمَّلٌ':Subject, #3: 3	كَانَ الْمَوْلُودُ
u'كَانَ مُؤْمِنٌ':Subject, #1: 1	كَانَ مُؤَمَّلٌ
u'كَانَ مُؤَنَّثٌ':Subject, #1: 1	كَانَ الْمُؤْمِنَاتُ
u'كَانَ مَوْهُوبٌ':Subject, #1: 1	كَانَ الْمُؤَنَّثُ
u'كَانَ مِيرَاثٌ':Subject, #42: 42	كَانَ الْمَوْهُوبُ
u'كَانَ مِيرَاثٌ':Subject, #11: 11	كَانَ مِيرَاثُهُ
u'كَانَ مِيرَاثٌ':Subject, #1: 1	كَانَ مِيرَاثٌ
u'كَانَ مِيرَاثٌ':Subject, #26: 26	كَانَ الْمِيرَاثُ
u'كَانَ مِيزَابٌ':Subject, #5: 5	كَانَ مِيرَاثُ
u'كَانَ مِيقَاتٌ':Subject, #6: 6	كَانَ الْمِيزَابُ
u'كَانَ مِيقَاتٌ':Subject, #2: 2	كَانَ مِيقَاتُ
u'كَانَ ميل':Subject, #3: 3	كَانَ مِيقَاتُهُ
u'كَانَ مَيْلٌ':Subject, #1: 1	كَانَ مَيْلُ
u'كَانَ مَيَلاَنٌ':Subject, #1: 1	كَانَ مَيْلُ
u'كَانَ نَابِتٌ':Subject, #2: 2	كَانَ الْمَيَلَانُ
u'كَانَ نَاخِسٌ':Subject, #2: 2	كَانَ النَّابِتُ
u'كَانَ ناذِر':Subject, #1: 1	كَانَ النَّاخِسُ
u'كَانَ نَاسٌ':Subject, #8: 8	كَانَ النَّاذِرُ
u'كَانَ نَاسٌ':Subject, #5: 5	كَانَ النّاسُ
u'كَانَ نَاسٌ':Subject, #7: 7	كَانَ نَاسٌ
u'كَانَ نَاسِخٌ':Subject, #89: 89	كَانَ النَّاسُ
u'كَانَ نَاسِخ':Subject, #2: 2	كَانَ النَّاسِخُ
u'كَانَ نَاصِبٌ':Subject, #2: 2	كَانَ النَّاسِخُ
u'كَانَ نَاظِرٌ':Predicate, #1: 1	كَانَ النَّاصِبُ
u'كَانَ نَاظِرٌ':Subject, #2: 2	كَانَ نَاظِرَ
u'كَانَ نَاظِرٌ':Subject, #12: 12	كَانَ النَّاظِرُ
u'كَانَ نَاقِصٌ':Predicate, #1: 1	كَانَ نَاظِرُهُ
u'كَانَ نَاقِصٌ':Predicate, #1: 1	كَانَ نَاقِصَةً
u'كَانَ نَاقِصٌ':Subject, #3: 3	كَانَ نَاقِصَ
u'كَانَ نَاقِلٌ':Subject, #6: 6	كَانَ النَّاقِصُ
u'كَانَ نَائِبٌ':Predicate, #10: 10	كَانَ النَّاقِلُ
u'كَانَ نَائِبٌ':Subject, #3: 3	كَانَ نَائِبَ
u'كَانَ نَائِمٌ':Subject, #4: 4	كَانَ النَّائِبُ
u'كَانَ نَبْذٌ':Subject, #4: 4	كَانَ النَّائِمُ
u'كَانَ نَبِيٌّ':Predicate, #2: 2	كَانَ النَّبْذُ
u'كَانَ نَبِيٌّ':Subject, #2: 2	كَانَ النَّبِيَّ
u'كَانَ نَبِيٌّ':Subject, #2: 2	كَانَ نَبِيُّ
u'كَانَ نَبِيذٌ':Subject, #307: 307	كَانَ النَّبِيُّ
u'كَانَ نَبِيذٌ':Subject, #1: 1	كَانَ نَبِيذُ
u'كَانَ نِتَاجٌ':Subject, #4: 4	كَانَ النَّبِيذُ
u'كَانَ نِتَاجٌ':Subject, #1: 1	كَانَ النِّتَاجُ
u'كَانَ نَتِيجَةٌ':Predicate, #4: 4	كَانَ نِتَاجُ
u'كَانَ نِجَاءٌ':Subject, #1: 1	كَانَ نَتِيجَةَ
u'كَانَ نَجَاسَةٌ':Subject, #1: 1	كَانَ النّجَاءُ
u'كَانَ نَجَسٌ':Predicate, #1: 1	كَانَ نَجَاسَةٌ
u'كَانَ نَجِسٌ':Predicate, #1: 1	كَانَ نَجَسَ
u'كَانَ نَجِسٌ':Subject, #1: 1	كَانَ نَجِسَ
u'كَانَ نَجَسٌ':Subject, #3: 3	كَانَ النَّجِسُ
u'كَانَ نَجْمٌ':Subject, #6: 6	كَانَ النَّجَسُ
u'كَانَ نَجْمٌ':Subject, #1: 1	كَانَ النَّجْمُ
u'كَانَ نُجُومٌ':Predicate, #1: 1	كَانَ نَجْمُ
u'كَانَ نَحْلٌ':Subject, #1: 1	كَانَ النُّجُومَ
u'كَانَ نَحْوٌ':Predicate, #2: 2	كَانَ النَّحْلُ
u'كَانَ نَحْوٌ':Subject, #13: 13	كَانَ نَحْوَ
u'كَانَ نَحْوٌ':Subject, #1: 1	كَانَ نَحْوُ
u'كَانَ نَخْس':Subject, #1: 1	كَانَ نَحْوُهُ
u'كَانَ نَخْلٌ':Predicate, #2: 2	كَانَ النَّخْسُ
u'كَانَ نَخْلٌ':Subject, #1: 1	كَانَ نَخْلاً
u'كَانَ نَخْلٌ':Subject, #3: 3	كَانَ نَخْلٌ
u'كَانَ نَخِيلٌ':Subject, #6: 6	كَانَ النَّخْلُ
u'كَانَ نَخِيلٌ':Subject, #1: 1	كَانَ النّخِيلُ
u'كَانَ نِدَاءٌ':Subject, #2: 2	كَانَ النَّخِيلُ
u'كَانَ نَدْبٌ':Subject, #10: 10	كَانَ النِّدَاءُ
u'كَانَ نَدْبٌ':Subject, #1: 1	كَانَ نَدْبُ
u'كَانَ نذر':Predicate, #2: 2	كَانَ النَّدْبُ
u'كَانَ نذر':Predicate, #6: 6	كَانَ نَذَرَ
u'كَانَ نَذْرٌ':Predicate, #6: 6	كَانَ نَذْرَ
u'كَانَ نذر':Subject, #6: 6	كَانَ نَذْرَ
u'كَانَ نَذْرٌ':Subject, #19: 19	كَانَ النَّذْرُ
u'كَانَ نذر':Subject, #19: 19	كَانَ النَّذْرُ
u'كَانَ نَذْرٌ':Subject, #1: 1	كَانَ نَذْرُ
u'كَانَ نزاع':Subject, #1: 1	كَانَ نَذْرُ
u'كَانَ نِزَاعٌ':Subject, #2: 2	كَانَ النِّزَاعُ
u'كَانَ نَزَحَ':Subject, #2: 2	كَانَ النِّزَاعُ
u'كَانَ نَزَح':Subject, #1: 1	كَانَ النَّزَحُ
u'كَانَ نَزْعٌ':Subject, #1: 1	كَانَ النَّزَحُ
u'كَانَ نَزَلٌ':Predicate, #2: 2	كَانَ النَّزْعُ
u'كَانَ نُزُولٌ':Subject, #2: 2	كَانَ نَزَلَ
u'كَانَ نِساءٌ':Subject, #3: 3	كَانَ نُزُولُ
u'كَانَ نِساءٌ':Subject, #13: 13	كَانَ النِّسَاءُ
u'كَانَ نَسَبٌ':Subject, #2: 2	كَانَ نِسَاءُ
u'كَانَ نِسَبٌ':Subject, #1: 1	كَانَ النّسَبُ
u'كَانَ نَسَبٌ':Subject, #1: 1	كَانَ النّسَبُ
u'كَانَ نَسَبٌ':Subject, #1: 1	كَانَ نَسَبُ
u'كَانَ نَسَبٌ':Subject, #6: 6	كَانَ نَسَبُهُ
u'كَانَ نِسْبَةٌ':Subject, #9: 9	كَانَ النَّسَبُ
u'كَانَ نِسْبَةٌ':Subject, #1: 1	كَانَ النِّسْبَةُ
u'كَانَ نسخة':Subject, #1: 1	كَانَ نِسْبَتُهُ
u'كَانَ نُسْخَةٌ':Subject, #1: 1	كَانَ نُسْخَةُ
u'كَانَ نُسُكٌ':Predicate, #1: 1	كَانَ نُسْخَةُ
u'كَانَ نُسُكٌ':Subject, #1: 1	كَانَ نُسُكَ
u'كَانَ نُسُكٌ':Subject, #1: 1	كَانَ نُسُكُهُ
u'كَانَ نَسْلٌ':Subject, #2: 2	كَانَ النُّسُكُ
u'كَانَ نسمة':Subject, #2: 2	كَانَ النَّسْلُ
u'كَانَ نَسَمَةٌ':Subject, #1: 1	كَانَ النَّسَمَةُ
u'كَانَ نسي':Predicate, #1: 1	كَانَ النَّسَمَةُ
u'كَانَ نِسْيَانٌ':Subject, #5: 5	كَانَ نَسِيَ
u'كَانَ نِسْيَانٌ':Subject, #2: 2	كَانَ النِّسْيَانُ
u'كَانَ نَشَأٌ':Predicate, #2: 2	كَانَ نِسْيَانُهُ
u'كَانَ نشاط':Subject, #1: 1	كَانَ نَشَأَ
u'كَانَ نَشَاطٌ':Subject, #1: 1	كَانَ النَّشَاطُ
u'كَانَ نُشُورٌ':Subject, #1: 1	كَانَ النَّشَاطُ
u'كَانَ نُشُوزٌ':Subject, #1: 1	كَانَ النُّشُورُ
u'كَانَ نَصٌّ':Subject, #20: 20	كَانَ النُّشُوزُ
u'كَانَ نَصٌّ':Subject, #11: 11	كَانَ النَّصُّ
u'كَانَ نَصٌّ':Subject, #1: 1	كَانَ نَصُّ
u'كَانَ نصاب':Predicate, #2: 2	كَانَ نَصُّهُ
u'كَانَ نِصَابٌ':Predicate, #2: 2	كَانَ نِصَابَ
u'كَانَ نصاب':Subject, #2: 2	كَانَ نِصَابَ
u'كَانَ نِصَابٌ':Subject, #2: 2	كَانَ نِصَابُ
u'كَانَ نصاب':Subject, #2: 2	كَانَ نِصَابُ
u'كَانَ نِصَابٌ':Subject, #31: 31	كَانَ النِّصَابُ
u'كَانَ نصب':Subject, #31: 31	كَانَ النِّصَابُ
u'كَانَ نصب':Subject, #1: 1	كَانَ النَّصْبُ
u'كَانَ نَصْبٌ':Subject, #1: 1	كَانَ النُّصُبُ
u'كَانَ نُصُبٌ':Subject, #1: 1	كَانَ النَّصْبُ
u'كَانَ نَصْرَانِيٌّ':Subject, #1: 1	كَانَ النُّصُبُ
u'كَانَ نِصْفٌ':Predicate, #3: 3	كَانَ النَّصْرَانِيُّ
u'كَانَ نِصْفٌ':Predicate, #10: 10	كَانَ نِصْفَ
u'كَانَ نِصْفٌ':Subject, #6: 6	كَانَ النِّصْفَ
u'كَانَ نِصْفٌ':Subject, #25: 25	كَانَ النِّصْفُ
u'كَانَ نِصْفٌ':Subject, #38: 38	كَانَ نِصْفُ
u'كَانَ نَصْلٌ':Subject, #7: 7	كَانَ نِصْفُهُ
u'كَانَ نَصِيبٌ':Predicate, #1: 1	كَانَ نَصْلُ
u'كَانَ نَصِيبٌ':Subject, #3: 3	كَانَ نَصِيبَ
u'كَانَ نَصِيبٌ':Subject, #25: 25	كَانَ نَصِيبُ
u'كَانَ نَصِيبٌ':Subject, #37: 37	كَانَ نَصِيبُهُ
u'كَانَ نِضْوٌ':Predicate, #4: 4	كَانَ النَّصِيبُ
u'كَانَ نُطْقٌ':Subject, #2: 2	كَانَ نِضْوَ
u'كَانَ نُظَّارٌ':Subject, #1: 1	كَانَ النُّطْقُ
u'كَانَ نظام':Subject, #1: 1	كَانَ النُّظَّارُ
u'كَانَ نِظَامٌ':Subject, #1: 1	كَانَ نِظَامُ
u'كَانَ نَظَرٌ':Subject, #1: 1	كَانَ نِظَامُ
u'كَانَ نَظَرٌ':Subject, #1: 1	كَانَ نَظَرٌ
u'كَانَ نَظَرٌ':Subject, #32: 32	كَانَ النَّظَرُ
u'كَانَ نَظَرٌ':Subject, #3: 3	كَانَ نَظَرُ
u'كَانَ نَظْمٌ':Subject, #6: 6	كَانَ نَظَرُهُ
u'كَانَ نَظِيرٌ':Predicate, #1: 1	كَانَ نَظْمُهُ
u'كَانَ نَظِيرٌ':Subject, #3: 3	كَانَ نَظِيرَ
u'كَانَ نَعْتٌ':Subject, #3: 3	كَانَ نَظِيرُ
u'كَانَ نَعْلٌ':Subject, #1: 1	كَانَ النَّعْتُ
u'كَانَ نَعَمٌ':Subject, #1: 1	كَانَ نَعْلُ
u'كَانَ نفاس':Subject, #1: 1	كَانَ نَعَمُهُ
u'كَانَ نِفَاسٌ':Subject, #1: 1	كَانَ النِّفَاسُ
u'كَانَ نِفَاقٌ':Subject, #1: 1	كَانَ النِّفَاسُ
u'كَانَ نَفَذٌ':Predicate, #1: 1	كَانَ نِفَاقُ
u'كَانَ نَفَرٌ':Subject, #2: 2	كَانَ نَفَذَ
u'كَانَ نَفْسٌ':Predicate, #2: 2	كَانَ نَفَرٌ
u'كَانَ نَفْسٌ':Subject, #2: 2	كَانَ نَفْسَ
u'كَانَ نَفْسَانِيٌّ':Predicate, #11: 11	كَانَ نَفْسُ
u'كَانَ نَفْعٌ':Subject, #1: 1	كَانَ النَّفْسَانِيَّ
u'كَانَ نَفْعٌ':Subject, #3: 3	كَانَ النَّفْعُ
u'كَانَ نَفْعٌ':Subject, #3: 3	كَانَ نَفْعُ
u'كَانَ نَفَقَةٌ':Subject, #3: 3	كَانَ نَفْعُهُ
u'كَانَ نَفَقَةٌ':Subject, #1: 1	كَانَ النَّفَقَةُ
u'كَانَ نَفْلٌ':Subject, #1: 1	كَانَ نَفَقَةُ
u'كَانَ نَفَلٌ':Subject, #1: 1	كَانَ نَفْلُهُ
u'كَانَ نُفُوذٌ':Subject, #5: 5	كَانَ النَّفَلُ
u'كَانَ نَفْيٌ':Predicate, #2: 2	كَانَ نُفُوذُ
u'كَانَ نَفْيٌ':Subject, #1: 1	كَانَ نَفْيَ
u'كَانَ نَفْيٌ':Subject, #12: 12	كَانَ النَّفْيُ
u'كَانَ نَفْيٌ':Subject, #5: 5	كَانَ نَفْيُ
u'كَانَ نَفِيرٌ':Subject, #5: 5	كَانَ نَفْيُهُ
u'كَانَ نَقْبٌ':Subject, #5: 5	كَانَ النَّفِيرُ
u'كَانَ نَقْدٌ':Predicate, #5: 5	كَانَ النَّقْبُ
u'كَانَ نَقْد':Predicate, #1: 1	كَانَ نَقْدَ
u'كَانَ نَقْدٌ':Subject, #1: 1	كَانَ نَقْدَ
u'كَانَ نَقْد':Subject, #11: 11	كَانَ نَقْدُ
u'كَانَ نَقْدٌ':Subject, #11: 11	كَانَ نَقْدُ
u'كَانَ نَقْد':Subject, #12: 12	كَانَ النَّقْدُ
u'كَانَ نَقْدٌ':Subject, #12: 12	كَانَ النَّقْدُ
u'كَانَ نَقْد':Subject, #2: 2	كَانَ نَقْدٌ
u'كَانَ نَقْشٌ':Predicate, #2: 2	كَانَ نَقْدٌ
u'كَانَ نَقْشٌ':Subject, #1: 1	كَانَ نَقْشَ
u'كَانَ نَقْشٌ':Subject, #1: 1	كَانَ نَقْشُهُ
u'كَانَ نَقْشٌ':Subject, #2: 2	كَانَ النَّقْشُ
u'كَانَ نَقْصٌ':Subject, #5: 5	كَانَ نَقْشُ
u'كَانَ نَقْصٌ':Subject, #20: 20	كَانَ النَّقْصُ
u'كَانَ نَقْصٌ':Subject, #2: 2	كَانَ نَقْصُهُ
u'كَانَ نَقْصٌ':Subject, #3: 3	كَانَ نَقْصٌ
u'كَانَ نُقْصَانٌ':Predicate, #6: 6	كَانَ نَقْصُ
u'كَانَ نُقْصَانٌ':Subject, #1: 1	كَانَ نُقْصَانَ
u'كَانَ نُقْصَانٌ':Subject, #2: 2	كَانَ نُقْصَانُهُ
u'كَانَ نُقْصَانٌ':Subject, #65: 65	كَانَ النُّقْصَانُ
u'كَانَ نَقْضٌ':Subject, #8: 8	كَانَ نُقْصَانُ
u'كَانَ نَقْضٌ':Subject, #1: 1	كَانَ نَقْضُهُ
u'كَانَ نَقْضٌ':Subject, #2: 2	كَانَ نَقْضُ
u'كَانَ نُقَطٌ':Subject, #6: 6	كَانَ النَّقْضُ
u'كَانَ نَقْعٌ':Subject, #1: 1	كَانَ النُّقَطُ
u'كَانَ نقل':Predicate, #1: 1	كَانَ نَقْعُ
u'كَانَ نقل':Predicate, #1: 1	كَانَ نَقَلَ
u'كَانَ نَقَلٌ':Predicate, #1: 1	كَانَ نُقِلَ
u'كَانَ نقل':Subject, #1: 1	كَانَ نَقَلَ
u'كَانَ نَقْلٌ':Subject, #2: 2	كَانَ نَقْلُهُ
u'كَانَ نقل':Subject, #2: 2	كَانَ نَقْلُهُ
u'كَانَ نَقْلٌ':Subject, #3: 3	كَانَ النَّقْلُ
u'كَانَ نقل':Subject, #3: 3	كَانَ النَّقْلُ
u'كَانَ نَقْلٌ':Subject, #5: 5	كَانَ نَقْلُ
u'كَانَ نَقِيضٌ':Predicate, #5: 5	كَانَ نَقْلُ
u'كَانَ نَقِيضٌ':Subject, #1: 1	كَانَ نَقِيضَ
u'كَانَ نَقِيضٌ':Subject, #1: 1	كَانَ نَقِيضُ
u'كَانَ نكاح':Predicate, #1: 1	كَانَ نَقِيضُهُ
u'كَانَ نِكَاحٌ':Predicate, #1: 1	كَانَ نِكَاحَ
u'كَانَ نكاح':Subject, #1: 1	كَانَ نِكَاحَ
u'كَانَ نِكَاحٌ':Subject, #12: 12	كَانَ نِكَاحُ
u'كَانَ نكاح':Subject, #12: 12	كَانَ نِكَاحُ
u'كَانَ نِكَاحٌ':Subject, #1: 1	كَانَ نِكَاحٌ
u'كَانَ نكاح':Subject, #1: 1	كَانَ نِكَاحٌ
u'كَانَ نِكَاحٌ':Subject, #97: 97	كَانَ النِّكَاحُ
u'كَانَ نكار':Subject, #97: 97	كَانَ النِّكَاحُ
u'كَانَ نُكُولٌ':Subject, #1: 1	كَانَ النِّكَارُ
u'كَانَ نُكُولٌ':Subject, #1: 1	كَانَ نُكُولُهُ
u'كَانَ نَمَاءٌ':Predicate, #4: 4	كَانَ النُّكُولُ
u'كَانَ نَمَاءٌ':Subject, #2: 2	كَانَ نَمَاءَ
u'كَانَ نهار':Subject, #2: 2	كَانَ النَّمَاءُ
u'كَانَ نَهَارٌ':Subject, #4: 4	كَانَ النَّهَارُ
u'كَانَ نَهْرٌ':Subject, #4: 4	كَانَ النَّهَارُ
u'كَانَ نَهْرٌ':Subject, #13: 13	كَانَ نَهْرٌ
u'كَانَ نَهْيٌ':Subject, #37: 37	كَانَ النَّهْرُ
u'كَانَ نَوْبَةٌ':Predicate, #25: 25	كَانَ النَّهْيُ
u'كَانَ نَوْبَةٌ':Subject, #1: 1	كَانَ نَوْبَةَ
u'كَانَ نُورٌ':Subject, #2: 2	كَانَ نَوْبَةُ
u'كَانَ نَوْعٌ':Predicate, #1: 1	كَانَ نُورُهُ
u'كَانَ نَوْعٌ':Subject, #2: 2	كَانَ نَوْعَ
u'كَانَ نَوْمٌ':Subject, #1: 1	كَانَ نَوْعٌ
u'كَانَ نِيَّةٌ':Subject, #6: 6	كَانَ النَّوْمُ
u'كَانَ هَالِكٌ':Subject, #4: 4	كَانَ نِيَّتُهُ
u'كَانَ هُبُوطٌ':Subject, #8: 8	كَانَ الْهَالِكُ
u'كَانَ هَجْوٌ':Predicate, #1: 1	كَانَ هُبُوطُهُ
u'كَانَ هُجُومٌ':Subject, #1: 1	كَانَ هَجْوَ
u'كَانَ هَدْمٌ':Subject, #1: 1	كَانَ الْهُجُومُ
u'كَانَ هَدْمٌ':Subject, #1: 1	كَانَ الْهَدْمُ
u'كَانَ هُدْهُدٌ':Subject, #1: 1	كَانَ هَدْمُ
u'كَانَ هَدِيٌّ':Predicate, #1: 1	كَانَ الْهُدْهُدُ
u'كَانَ هَدْيٌ':Predicate, #1: 1	كَانَ هَدِيَّةً
u'كَانَ هَدْيٌ':Subject, #2: 2	كَانَ هَدْيَ
u'كَانَ هَدْيٌ':Subject, #1: 1	كَانَ الْهَدْيُ
u'كَانَ هِرٌّ':Subject, #1: 1	كَانَ هَدْيُهُ
u'كَانَ هَرَب':Subject, #1: 1	كَانَ الْهِرُّ
u'كَانَ هزال':Subject, #1: 1	كَانَ الْهَرَبُ
u'كَانَ هُزَالٌ':Subject, #1: 1	كَانَ هُزَالٌ
u'كَانَ هَزْلٌ':Subject, #1: 1	كَانَ هُزَالٌ
u'كَانَ هلاك':Subject, #3: 3	كَانَ الْهَزْلُ
u'كَانَ هَلاَكٌ':Subject, #26: 26	كَانَ الْهَلَاكُ
u'كَانَ هلاك':Subject, #26: 26	كَانَ الْهَلَاكُ
u'كَانَ هَلاَكٌ':Subject, #2: 2	كَانَ هَلَاكُهُ
u'كَانَ هلاك':Subject, #2: 2	كَانَ هَلَاكُهُ
u'كَانَ هَلاَكٌ':Subject, #5: 5	كَانَ هَلَاكُ
u'كَانَ هَلَكٌ':Predicate, #5: 5	كَانَ هَلَاكُ
u'كَانَ هَمٌّ':Subject, #9: 9	كَانَ هَلَكَ
u'كَانَ وَاجِبٌ':Predicate, #1: 1	كَانَ الْهَمُّ
u'كَانَ وَاجِبٌ':Subject, #5: 5	كَانَ وَاجِبَ
u'كَانَ وَاجِبٌ':Subject, #118: 118	كَانَ الْوَاجِبُ
u'كَانَ وَاجِبٌ':Subject, #1: 1	كَانَ وَاجِبٌ
u'كَانَ وَاجِدٌ':Subject, #2: 2	كَانَ وَاجِبُ
u'كَانَ وَاجِدٌ':Subject, #15: 15	كَانَ الْوَاجِدُ
u'كَانَ واحد':Predicate, #1: 1	كَانَ وَاجِدُهُ
u'كَانَ وَاحِدٌ':Predicate, #9: 9	كَانَ وَاحِدَةً
u'كَانَ واحد':Subject, #9: 9	كَانَ وَاحِدَةً
u'كَانَ وَاحِدٌ':Subject, #14: 14	كَانَ وَاحِدٌ
u'كَانَ واحد':Subject, #14: 14	كَانَ وَاحِدٌ
u'كَانَ وَاحِدٌ':Subject, #5: 5	كَانَ الْوَاحِدُ
u'كَانَ وَارِثٌ':Predicate, #5: 5	كَانَ الْوَاحِدُ
u'كَانَ وَارِثٌ':Subject, #3: 3	كَانَ وَارِثَ
u'كَانَ وَارِثٌ':Subject, #2: 2	كَانَ وَارِثٌ
u'كَانَ وَارِثٌ':Subject, #3: 3	كَانَ وَارِثُ
u'كَانَ وَارِثٌ':Subject, #68: 68	كَانَ الْوَارِثُ
u'كَانَ وَاسِطٌ':Predicate, #6: 6	كَانَ وَارِثُهُ
u'كَانَ وَاسِطٌ':Subject, #1: 1	كَانَ الْوَاسِطَةَ
u'كَانَ وَاصِلٌ':Subject, #1: 1	كَانَ وَاسِطَتُهُ
u'كَانَ وَاصِلٌ':Subject, #1: 1	كَانَ وَاصِلُ
u'كَانَ وَاضِعٌ':Subject, #2: 2	كَانَ الْوَاصِلُ
u'كَانَ وَاضِعٌ':Subject, #1: 1	كَانَ وَاضِعَاهُ
u'كَانَ وَاضِعٌ':Subject, #2: 2	كَانَ وَاضِعُ
u'كَانَ وَاطِئٌ':Subject, #2: 2	كَانَ وَاضِعُهُ
u'كَانَ وَاطِئٌ':Subject, #15: 15	كَانَ الْوَاطِئُ
u'كَانَ وَاعِظٌ':Subject, #1: 1	كَانَ وَاطِئُ
u'كَانَ وَاعِي':Predicate, #1: 1	كَانَ الْوَاعِظُ
u'كَانَ وَافِدٌ':Subject, #1: 1	كَانَ وَاعِيَةً
u'كَانَ وَافِرٌ':Predicate, #1: 1	كَانَ الْوَافِدُ
u'كَانَ وَاقِعٌ':Subject, #1: 1	كَانَ وَافِرَ
u'كَانَ وَاقِفٌ':Subject, #19: 19	كَانَ الْوَاقِعُ
u'كَانَ وَاقِفٌ':Subject, #1: 1	كَانَ وَاقِفُ
u'كَانَ وَاقِفٌ':Subject, #2: 2	كَانَ وَاقِفُهُ
u'كَانَ وَالِدٌ':Subject, #63: 63	كَانَ الْوَاقِفُ
u'كَانَ وَالِدٌ':Subject, #15: 15	كَانَ الْوَالِدُ
u'كَانَ وَالِدٌ':Subject, #2: 2	كَانَ وَالِدُ
u'كَانَ وَاهِبٌ':Subject, #2: 2	كَانَ وَالِدُهُ
u'كَانَ وَبَاءٌ':Subject, #13: 13	كَانَ الْوَاهِبُ
u'كَانَ وَتَرٌ':Predicate, #1: 1	كَانَ الْوَبَاءُ
u'كَانَ وَجَبٌ':Predicate, #1: 1	كَانَ وَتَرَكَ
u'كَانَ وَجَعٌ':Predicate, #8: 8	كَانَ وَجَبَ
u'كَانَ وَجَعٌ':Subject, #1: 1	كَانَ وَجَعَ
u'كَانَ وَجَعٌ':Subject, #1: 1	كَانَ وَجَعُ
u'كَانَ وَجْهٌ':Predicate, #1: 1	كَانَ وَجَعُهُ
u'كَانَ وَجْهٌ':Subject, #3: 3	كَانَ وَجْهَ
u'كَانَ وَجْهٌ':Subject, #26: 26	كَانَ وَجْهُهُ
u'كَانَ وَجْهٌ':Subject, #4: 4	كَانَ الْوَجْهُ
u'كَانَ وُجُوبٌ':Subject, #9: 9	كَانَ وَجْهُ
u'كَانَ وُجُوبٌ':Subject, #10: 10	كَانَ وُجُوبُهُ
u'كَانَ وُجُوبٌ':Subject, #12: 12	كَانَ الْوُجُوبُ
u'كَانَ وُجُودٌ':Subject, #14: 14	كَانَ وُجُوبُ
u'كَانَ وُجُودٌ':Subject, #10: 10	كَانَ وُجُودُهُ
u'كَانَ وَحْشِيٌّ':Predicate, #4: 4	كَانَ وُجُودُ
u'كَانَ وَحْيٌ':Subject, #1: 1	كَانَ وَحْشِيَّ
u'كَانَ وداع':Subject, #1: 1	كَانَ الْوَحْيُ
u'كَانَ وَدَاعٌ':Subject, #1: 1	كَانَ الْوَدَاعُ
u'كَانَ وَدَكٌ':Subject, #1: 1	كَانَ الْوَدَاعُ
u'كَانَ وَدِيعَةٌ':Subject, #1: 1	كَانَ الْوَدَكُ
u'كَانَ وَراء':Predicate, #1: 1	كَانَ وَدِيعَةٌ
u'كَانَ وُرَّاثٌ':Subject, #6: 6	كَانَ وَرَاءَ
u'كَانَ وَرَثَةٌ':Predicate, #2: 2	كَانَ الْوُرَّاثُ
u'كَانَ وَرَثَةٌ':Subject, #1: 1	كَانَ الْوَرَثَةَ
u'كَانَ وَرَثَةٌ':Subject, #10: 10	كَانَ الْوَرَثَةُ
u'كَانَ وَرَثَةٌ':Subject, #1: 1	كَانَ وَرَثَةُ
u'كَانَ وَرَعٌ':Subject, #9: 9	كَانَ وَرَثَتُهُ
u'كَانَ ورق':Subject, #2: 2	كَانَ الْوَرَعُ
u'كَانَ وَرَقٌ':Subject, #1: 1	كَانَ الْوَرَقُ
u'كَانَ وَرَقَةٌ':Subject, #1: 1	كَانَ الْوَرَقُ
u'كَانَ وُرُودٌ':Subject, #1: 1	كَانَ وَرَقَةُ
u'كَانَ وَزْنٌ':Predicate, #1: 1	كَانَ وُرُودُهُ
u'كَانَ وَزْنٌ':Subject, #2: 2	كَانَ وَزْنَ
u'كَانَ وَزْنٌ':Subject, #11: 11	كَانَ وَزْنُ
u'كَانَ وَزْنٌ':Subject, #6: 6	كَانَ الْوَزْنُ
u'كَانَ وَزِيرٌ':Subject, #8: 8	كَانَ وَزْنُهُ
u'كَانَ وَسَخٌ':Subject, #1: 1	كَانَ الْوَزِيرُ
u'كَانَ وسط':Predicate, #1: 1	كَانَ وَسَخُهُ
u'كَانَ وَسَطٌ':Predicate, #2: 2	كَانَ وَسَطَ
u'كَانَ وسط':Subject, #2: 2	كَانَ وَسَطَ
u'كَانَ وَسَطٌ':Subject, #1: 1	كَانَ وَسَطُ
u'كَانَ وَسْمٌ':Subject, #1: 1	كَانَ وَسَطُ
u'كَانَ وَصْفٌ':Subject, #1: 1	كَانَ الْوَسْمُ
u'كَانَ وَصْفٌ':Subject, #10: 10	كَانَ الْوَصْفُ
u'كَانَ وَصْفٌ':Subject, #1: 1	كَانَ وَصْفٌ
u'كَانَ وصل':Predicate, #2: 2	كَانَ وَصْفُ
u'كَانَ وُصُولٌ':Subject, #6: 6	كَانَ وَصَلَ
u'كَانَ وُصُولٌ':Subject, #1: 1	كَانَ الْوُصُولُ
u'كَانَ وَصِيٌّ':Predicate, #1: 1	كَانَ وُصُولُ
u'كَانَ وَصِيٌّ':Predicate, #13: 13	كَانَ وَصِيَّةً
u'كَانَ وَصِيٌّ':Subject, #1: 1	كَانَ وَصِيَّ
u'كَانَ وَصِيٌّ':Subject, #1: 1	كَانَ وَصِيَّةُ
u'كَانَ وَصِيٌّ':Subject, #1: 1	كَانَ وَصِيَّتُهُ
u'كَانَ وَصِيٌّ':Subject, #2: 2	كَانَ وَصِيَّةٌ
u'كَانَ وَصِيٌّ':Subject, #30: 30	كَانَ الْوَصِيُّ
u'كَانَ وَصِيٌّ':Subject, #4: 4	كَانَ وَصِيُّهُ
u'كَانَ وَصِيَّةٌ':Subject, #5: 5	كَانَ وَصِيُّ
u'كَانَ وَصِيَّةٌ':Subject, #1: 1	كَانَ وَصِيَّةُ
u'كَانَ وَصِيَّةٌ':Subject, #1: 1	كَانَ وَصِيَّتُهُ
u'كَانَ وَصِيفٌ':Subject, #2: 2	كَانَ وَصِيَّةٌ
u'كَانَ وَضْعٌ':Subject, #1: 1	كَانَ الْوَصِيفُ
u'كَانَ وَضْعٌ':Subject, #14: 14	كَانَ الْوَضْعُ
u'كَانَ وَضْعٌ':Subject, #3: 3	كَانَ وَضْعُهُ
u'كَانَ وُضُوءٌ':Subject, #6: 6	كَانَ وَضْعُ
u'كَانَ وُضُوءٌ':Subject, #1: 1	كَانَ وُضُوءٌ
u'كَانَ وُضُوءٌ':Subject, #3: 3	كَانَ وُضُوءُ
u'كَانَ وُضُوءٌ':Subject, #3: 3	كَانَ وُضُوءُهُ
u'كَانَ وَطْءٌ':Subject, #8: 8	كَانَ الْوُضُوءُ
u'كَانَ وَطْءٌ':Subject, #21: 21	كَانَ الْوَطْءُ
u'كَانَ وَطَنٌ':Predicate, #2: 2	كَانَ وَطْءُ
u'كَانَ وَطَنٌ':Subject, #3: 3	كَانَ وَطَنَ
u'كَانَ وَطَنٌ':Subject, #1: 1	كَانَ الْوَطَنُ
u'كَانَ وَظِيفٌ':Predicate, #1: 1	كَانَ وَطَنُهُ
u'كَانَ وَظِيفٌ':Subject, #1: 1	كَانَ وَظِيفَةَ
u'كَانَ وَظِيفٌ':Subject, #1: 1	كَانَ وَظِيفَةُ
u'كَانَ وَظِيفَةٌ':Predicate, #1: 1	كَانَ وَظِيفَتُهُ
u'كَانَ وَظِيفَةٌ':Subject, #1: 1	كَانَ وَظِيفَةَ
u'كَانَ وَظِيفَةٌ':Subject, #1: 1	كَانَ وَظِيفَةُ
u'كَانَ وِعَاءٌ':Subject, #1: 1	كَانَ وَظِيفَتُهُ
u'كَانَ وَعْدٌ':Subject, #2: 2	كَانَ الْوِعَاءُ
u'كَانَ وَعْدٌ':Subject, #2: 2	كَانَ وَعْدُهُ
u'كَانَ وَعِيدٌ':Subject, #7: 7	كَانَ وَعْدُ
u'كَانَ وَفَاءٌ':Subject, #2: 2	كَانَ الْوَعِيدُ
u'كَانَ وَفَاءٌ':Subject, #1: 1	كَانَ وَفَاءٌ
u'كَانَ وُفُورٌ':Subject, #3: 3	كَانَ الْوَفَاءُ
u'كَانَ وَقْتٌ':Predicate, #1: 1	كَانَ وُفُورُ
u'كَانَ وَقْتٌ':Subject, #34: 34	كَانَ وَقْتَ
u'كَانَ وَقْتٌ':Subject, #2: 2	كَانَ وَقْتٌ
u'كَانَ وَقْتٌ':Subject, #35: 35	كَانَ وَقْتُ
u'كَانَ وَقْتٌ':Subject, #44: 44	كَانَ الْوَقْتُ
u'كَانَ وقع':Predicate, #6: 6	كَانَ وَقْتُهُ
u'كَانَ وقع':Subject, #16: 16	كَانَ وَقَعَ
u'كَانَ وَقْعٌ':Subject, #2: 2	كَانَ الْوَقْعُ
u'كَانَ وَقْفٌ':Predicate, #2: 2	كَانَ الْوَقْعُ
u'كَانَ وَقْفٌ':Subject, #2: 2	كَانَ وَقْفَ
u'كَانَ وَقْفٌ':Subject, #1: 1	كَانَ وَقْفٌ
u'كَانَ وَقْفٌ':Subject, #2: 2	كَانَ وَقْفُهُ
u'كَانَ وُقُوعٌ':Predicate, #89: 89	كَانَ الْوَقْفُ
u'كَانَ وُقُوعٌ':Subject, #1: 1	كَانَ وُقُوعَ
u'كَانَ وُقُوعٌ':Subject, #19: 19	كَانَ الْوُقُوعُ
u'كَانَ وُقُوعٌ':Subject, #2: 2	كَانَ وُقُوعُهُ
u'كَانَ وُقُوفٌ':Subject, #3: 3	كَانَ وُقُوعُ
u'كَانَ وُقُوفٌ':Subject, #1: 1	كَانَ وُقُوفُ
u'كَانَ وُقُوفٌ':Subject, #4: 4	كَانَ الْوُقُوفُ
u'كَانَ وَكْرٌ':Subject, #4: 4	كَانَ وُقُوفُهُ
u'كَانَ وكلاء':Subject, #1: 1	كَانَ الْوَكْرُ
u'كَانَ وَكِيلٌ':Predicate, #1: 1	كَانَ الْوُكَلَاءُ
u'كَانَ وَكِيلٌ':Subject, #9: 9	كَانَ وَكِيلَ
u'كَانَ وَكِيلٌ':Subject, #3: 3	كَانَ وَكِيلُهُ
u'كَانَ وَكِيلٌ':Subject, #5: 5	كَانَ وَكِيلُ
u'كَانَ وَلاَءٌ':Subject, #95: 95	كَانَ الْوَكِيلُ
u'كَانَ وَلاَءٌ':Subject, #10: 10	كَانَ وَلَاءُ
u'كَانَ وُلاَةٌ':Subject, #32: 32	كَانَ الْوَلَاءُ
u'كَانَ وُلاَةٌ':Subject, #1: 1	كَانَ الْوُلَاةُ
u'كَانَ وِلاَيَةٌ':Subject, #1: 1	كَانَ وُلَاةُ
u'كَانَ وِلاَيَةٌ':Subject, #2: 2	كَانَ الْوِلَايَةُ
u'كَانَ ولد':Predicate, #2: 2	كَانَ وِلَايَةُ
u'كَانَ وَلَدٌ':Predicate, #10: 10	كَانَ وَلَدَ
u'كَانَ ولد':Predicate, #10: 10	كَانَ وَلَدَ
u'كَانَ وَلَدٌ':Predicate, #2: 2	كَانَ الْوَلَدَ
u'كَانَ ولد':Predicate, #2: 2	كَانَ الْوَلَدَ
u'كَانَ ولد':Subject, #2: 2	كَانَ وُلِدَ
u'كَانَ وَلَدٌ':Subject, #15: 15	كَانَ وَلَدُهُ
u'كَانَ ولد':Subject, #15: 15	كَانَ وَلَدُهُ
u'كَانَ وَلَدٌ':Subject, #197: 197	كَانَ الْوَلَدُ
u'كَانَ ولد':Subject, #197: 197	كَانَ الْوَلَدُ
u'كَانَ وَلَدٌ':Subject, #19: 19	كَانَ وَلَدُ
u'كَانَ وَلَدٌ':Subject, #19: 19	كَانَ وَلَدُ
u'كَانَ ولدان':Subject, #5: 5	كَانَ وَلَدٌ
u'كَانَ وَلَهٌ':Subject, #1: 1	كَانَ الْوِلْدَانُ
u'كَانَ وُلُوغ':Subject, #1: 1	كَانَ وَلَهُ
u'كَانَ وَلِيٌّ':Predicate, #2: 2	كَانَ الْوُلُوغُ
u'كَانَ وَلِيٌّ':Subject, #4: 4	كَانَ وَلِيَّ
u'كَانَ وَلِيٌّ':Subject, #14: 14	كَانَ وَلِيُّ
u'كَانَ وَلِيٌّ':Subject, #1: 1	كَانَ وَلِيٌّ
u'كَانَ وَلِيٌّ':Subject, #35: 35	كَانَ الْوَلِيُّ
u'كَانَ وَلِيدٌ':Subject, #3: 3	كَانَ وَلِيُّهُ
u'كَانَ يَابِسٌ':Subject, #2: 2	كَانَ الْوَلِيدُ
u'كَانَ يَافُوخٌ':Subject, #5: 5	كَانَ الْيَابِسُ
u'كَانَ يَبِسٌ':Predicate, #1: 1	كَانَ يَافُوخٌ
u'كَانَ يَتِيمٌ':Subject, #1: 1	كَانَ يَبِسَ
u'كَانَ يَدٌ':Predicate, #8: 8	كَانَ الْيَتِيمُ
u'كَانَ يَدٌ':Subject, #1: 1	كَانَ الْيَدَ
u'كَانَ يَدٌ':Subject, #1: 1	كَانَ يَدُ
u'كَانَ يسار':Subject, #3: 3	كَانَ يَدُهُ
u'كَانَ يَسَارٌ':Subject, #1: 1	كَانَ الْيَسَارُ
u'كَانَ يَسِيرٌ':Subject, #1: 1	كَانَ الْيَسَارُ
u'كَانَ يَسِيرٌ':Subject, #2: 2	كَانَ الْيَسِيرُ
u'كَانَ يَعْقُوبٌ':Subject, #7: 7	كَانَ يَسِيرُ
u'كَانَ يَقْظَان':Predicate, #1: 1	كَانَ يَعْقُوبُ
u'كَانَ يَقِينٌ':Subject, #3: 3	كَانَ يَقْظَانَ
u'كَانَ يَمَامٌ':Subject, #1: 1	كَانَ الْيَقِينُ
u'كَانَ يَمِينٌ':Subject, #1: 1	كَانَ الْيَمَامَةُ
u'كَانَ يَمِينٌ':Subject, #18: 18	كَانَ الْيَمِينُ
u'كَانَ يَمِينٌ':Subject, #2: 2	كَانَ يَمِينُ
u'كَانَ يَهُودِيٌّ':Subject, #4: 4	كَانَ يَمِينُهُ
u'كَانَ يَوْمٌ':Predicate, #1: 1	كَانَ الْيَهُودِيُّ
u'كَانَ يَوْمٌ':Predicate, #79: 79	كَانَ يَوْمَ
u'كَانَ يَوْمٌ':Subject, #7: 7	كَانَ الْيَوْمَ
u'كَانَ يَوْمٌ':Subject, #185: 185	كَانَ يَوْمُ
u'كَانَ يَوْمٌ':Subject, #19: 19	كَانَ الْيَوْمُ
u'كَانَ يَوْمٌ':Subject, #1: 1	كَانَ يَوْمُهُ
u'كَبَحَ دَابَّةٌ':Predicate, #7: 7	كَانَ يَوْمٌ
u'كَبْحٌ دَابَّةٌ':Added, #5: 5	كَبَحَ الدَّابَّةَ
u'كَبَدٌ سَمَاءٌ':Added, #1: 1	كَبْحُ الدَّابَّةِ
u'كَبَّرَ أَرْبَعُ':Predicate, #1: 1	كَبَدِ السَّمَاءِ
u'كبر أَطْرافٌ':Added, #2: 2	كَبَّرَ أَرْبَعَ
u'كبر أَطْرَافٌ':Added, #1: 1	كِبَرِ الْأَطْرَافِ
u'كِبَرٌ أَطْرافٌ':Added, #1: 1	كِبَرِ الْأَطْرَافِ
u'كِبَرٌ أَطْرَافٌ':Added, #1: 1	كِبَرِ الْأَطْرَافِ
u'كَبَّرَ إمَامٌ':Subject, #1: 1	كِبَرِ الْأَطْرَافِ
u'كَبَّرَ إمَامٌ':Subject, #3: 3	كَبَّرَ إمَامُهُ
u'كَبَّرَ إمَامٌ':Subject, #4: 4	كَبَّرَ الإِمَامُ
u'كبر بَلَدٌ':Added, #53: 53	كَبَّرَ الْإِمَامُ
u'كبر بَلَدٌ':Added, #1: 1	كُبْرِ الْبَلَدِ
u'كُبْرٌ بَلَدٌ':Added, #1: 1	كِبَرِ الْبَلَدِ
u'كِبَرٌ بَلَدٌ':Added, #1: 1	كُبْرِ الْبَلَدِ
u'كَبَّرَ تَكْبِير':Predicate, #1: 1	كِبَرِ الْبَلَدِ
u'كَبَّرَ تَكْبِير':Predicate, #2: 2	كَبَّرَ التَّكْبِيرَةَ
u'كَبَّرَ تَكْبِير':Predicate, #2: 2	كَبَّرَ تَكْبِيرَةً
u'كَبَّرَ ثَالِثٌ':Subject, #2: 2	كَبَّرَ تَكْبِيرَةَ
u'كَبَّرَ ثَانِي':Predicate, #1: 1	كَبَّرَ الثَّالِثُ
u'كَبَّرَ ثَانِيَةٌ':Predicate, #6: 6	كَبَّرَ الثَّانِيَةَ
u'كَبَّرَ ثَلاثُ':Predicate, #6: 6	كَبَّرَ الثَّانِيَةَ
u'كَبُرَ جِسْمٌ':Subject, #1: 1	كَبَّرَ ثَلاَثَ
u'كَبَّرَ حاضِرٌ':Subject, #1: 1	كَبُرَ جِسْمُهُ
u'كَبَّرَ حالٌ':Predicate, #2: 2	كَبَّرَ الْحَاضِرُ
u'كبر حَجْمٌ':Added, #1: 1	كَبَّرَ حَالَ
u'كِبَرٌ حَجْمٌ':Added, #1: 1	كِبَرِ حَجْمِ
u'كَبَّرَ حَديثٌ':Predicate, #1: 1	كِبَرِ حَجْمِ
u'كبر حَمْلٌ':Added, #2: 2	كَبَّرَ الْحَدِيثَ
u'كِبَرٌ حَمْلٌ':Added, #1: 1	كِبَرِ الْحَمْلِ
u'كبر حَيَوَانٌ':Added, #1: 1	كِبَرِ الْحَمْلِ
u'كبر حَيَوَانٌ':Added, #1: 1	كُبْرِ الْحَيَوَانِ
u'كُبْرٌ حَيَوَانٌ':Added, #1: 1	كِبَرِ الْحَيَوَانِ
u'كِبَرٌ حَيَوَانٌ':Added, #1: 1	كُبْرِ الْحَيَوَانِ
u'كَبِرَ خُزَاعَةٌ':Predicate, #1: 1	كِبَرِ الْحَيَوَانِ
u'كَبَّرَ خَلِيفَةٌ':Subject, #1: 1	أَكْبَرَ خُزَاعَةَ
u'كبر دَابَّةٌ':Added, #1: 1	كَبَّرَ الْخَلِيفَةُ
u'كِبَرٌ دَابَّةٌ':Added, #1: 1	كِبَرِ الدَّابَّةِ
u'كبر دَلْوٌ':Added, #1: 1	كِبَرِ الدَّابَّةِ
u'كِبَرٌ دَلْوٌ':Added, #2: 2	كِبَرِ الدَّلْوِ
u'كبر ذكر':Added, #2: 2	كِبَرِ الدَّلْوِ
u'كِبَرٌ ذكر':Added, #1: 1	كِبَرِ الذَّكَرِ
u'كبر ذَكَرٌ':Added, #1: 1	كِبَرِ الذَّكَرِ
u'كِبَرٌ ذَكَرٌ':Added, #1: 1	كِبَرِ الذَّكَرِ
u'كَبَّرَ رابع':Predicate, #1: 1	كِبَرِ الذَّكَرِ
u'كَبَّرَ رَابِعٌ':Predicate, #4: 4	كَبَّرَ الرَّابِعَةَ
u'كَبِرَ رَجُلٌ':Subject, #4: 4	كَبَّرَ الرَّابِعَةَ
u'كَبَّرَ رَجُلٌ':Subject, #1: 1	كَبِرَ الرَّجُلُ
u'كَبِرَ رَسُولٌ':Subject, #1: 1	كَبَّرَ الرَّجُلُ
u'كَبَّرَ رَسُولٌ':Subject, #1: 1	كَبِرَ رَسُولُ
u'كَبُرَ زَيْدٌ':Subject, #2: 2	كَبَّرَ رَسُولُ
u'كَبِرَ زَيْدٌ':Subject, #1: 1	كَبُرَ زَيْدٌ
u'كبر سِنٌّ':Added, #1: 1	كَبِرَ زَيْدٌ
u'كِبَرٌ سِنٌّ':Added, #1: 1	كِبَرِ سِنِّ
u'كبر سِنٌّ':Added, #1: 1	كِبَرِ سِنِّ
u'كِبَرٌ سِنٌّ':Added, #2: 2	كِبَرَ السِّنِّ
u'كبر سِنٌّ':Added, #2: 2	كِبَرَ السِّنِّ
u'كبر سِنٌّ':Added, #2: 2	كِبَرُ سِنٍّ
u'كِبَرٌ سِنٌّ':Added, #2: 2	كِبَرِ سِنٍّ
u'كِبَرٌ سِنٌّ':Added, #2: 2	كِبَرُ سِنٍّ
u'كبر سِنٌّ':Added, #2: 2	كِبَرِ سِنٍّ
u'كبر سِنٌّ':Added, #4: 4	كِبَرُ السِّنِّ
u'كِبَرٌ سِنٌّ':Added, #4: 4	كِبَرِ السِّنِّ
u'كِبَرٌ سِنٌّ':Added, #4: 4	كِبَرُ السِّنِّ
u'كَبِرَ شَعْرٌ':Subject, #4: 4	كِبَرِ السِّنِّ
u'كَبِرَ صَبِيٌّ':Subject, #1: 1	كَبِرَ شَعْرُهُ
u'كبر صغار':Added, #5: 5	كَبِرَ الصَّبِيُّ
u'كِبَرٌ صغار':Added, #1: 1	كِبَرِ الصِّغَارِ
u'كَبُرَ صَغِيرٌ':Subject, #1: 1	كِبَرِ الصِّغَارِ
u'كَبِرَ صَغِيرٌ':Subject, #1: 1	كَبُرَ الصَّغِيرُ
u'كبر ضَبَّةٌ':Added, #1: 1	كَبِرَ صَغِيرٌ
u'كِبَرٌ ضَبَّةٌ':Added, #1: 1	كِبَرِ الضَّبَّةِ
u'كبر ضَبَّةٌ':Added, #1: 1	كِبَرِ الضَّبَّةِ
u'كِبَرٌ ضَبَّةٌ':Added, #1: 1	كِبَرِ ضَبَّتِهِ
u'كبر طِحَالٌ':Added, #1: 1	كِبَرِ ضَبَّتِهِ
u'كِبَرٌ طِحَالٌ':Added, #1: 1	كِبَرَ الطِّحَالِ
u'كَبُرَ عَبْدٌ':Subject, #1: 1	كِبَرَ الطِّحَالِ
u'كَبِرَ عَبْدٌ':Subject, #1: 1	كَبُرَ الْعَبْدُ
u'كَبِرَ عَبْدٌ':Subject, #1: 1	كَبِرَ الْعَبْدُ
u'كبر عَظْمٌ':Added, #1: 1	كَبِرَ عَبْدُ
u'كِبَرٌ عَظْمٌ':Added, #2: 2	كِبَرِ الْعَظْمِ
u'كَبَّرَ عَقِبٌ':Predicate, #2: 2	كِبَرِ الْعَظْمِ
u'كَبَّرَ عُمَرٌ':Subject, #1: 1	كَبَّرَ عَقِبَ
u'كَبُرَ عند':Predicate, #1: 1	كَبَّرَ عُمَرُ
u'كَبَّرَ عند':Predicate, #1: 1	كَبُرَ عِنْدَ
u'كَبَرَ غُلاَمٌ':Subject, #5: 5	كَبَّرَ عِنْدَ
u'كَبُرَ غُلاَمٌ':Subject, #1: 1	كَبَرَ الْغُلَامُ
u'كَبِرَ فلان':Subject, #1: 1	كَبُرَ الْغُلَامُ
u'كَبُرَ قَالٌ':Predicate, #1: 1	كَبِرَ عَقِيلٌ
u'كَبِرَ قَالٌ':Predicate, #1: 1	كَبُرَ قَالَ
u'كَبَّرَ قَالٌ':Predicate, #2: 2	كَبِرَ قَالَ
u'كبر قوافل':Added, #3: 3	كَبَّرَ قَالَ
u'كِبَرٌ قوافل':Added, #1: 1	كِبَرِ الْقَوَافِلِ
u'كبر قَوَافِلُ':Added, #1: 1	كِبَرِ الْقَوَافِلِ
u'كِبَرٌ قَوَافِلُ':Added, #1: 1	كِبَرِ الْقَوَافِلِ
u'كبر كَبِيرٌ':Added, #1: 1	كِبَرِ الْقَوَافِلِ
u'كِبَرٌ كَبِيرٌ':Added, #2: 2	كِبَرُ الْكَبِيرِ
u'كَبَّرَ مرٌّ':Predicate, #2: 2	كِبَرُ الْكَبِيرِ
u'كَبَّرَ مَسْبُوق':Subject, #1: 1	كَبَّرَ مَرَّةً
u'كَبُرَ مَسْجِدٌ':Subject, #1: 1	كَبَّرَ الْمَسْبُوقُ
u'كبر مِصْرٌ':Added, #2: 2	كَبُرَ الْمَسْجِدُ
u'كِبَرٌ مِصْرٌ':Added, #1: 1	كِبَرِ الْمِصْرِ
u'كَبَّرَ مُكَبِّرٌ':Subject, #1: 1	كِبَرِ الْمِصْرِ
u'كبر مَنْزِلَةٌ':Added, #1: 1	كَبَّرَ مُكَبِّرٌ
u'كِبَرٌ مَنْزِلَةٌ':Added, #2: 2	كِبَرَ الْمَنْزِلَةِ
u'كَبِرَ نَفَقَةٌ':Subject, #2: 2	كِبَرَ الْمَنْزِلَةِ
u'كَبَّرَ واحد':Predicate, #1: 1	كَبِرَ نَفَقَةُ
u'كَبَّرَ وَاحِدٌ':Predicate, #1: 1	كَبَّرَ وَاحِدَةً
u'كبر وَرَثَةٌ':Added, #1: 1	كَبَّرَ وَاحِدَةً
u'كِبَرٌ وَرَثَةٌ':Added, #2: 2	كِبَرِ الْوَرَثَةِ
u'كَبِرَ ولد':Subject, #2: 2	كِبَرِ الْوَرَثَةِ
u'كَبِرَ وَلَدٌ':Subject, #3: 3	كَبِرَ الْوَلَدُ
u'كبر يَدٌ':Added, #3: 3	كَبِرَ الْوَلَدُ
u'كِبَرٌ يَدٌ':Added, #1: 1	كِبَرِ يَدَيْنِ
u'كَبَّرَ يَوْمٌ':Predicate, #1: 1	كِبَرِ يَدَيْنِ
u'كَبَسَ أرْضٌ':Predicate, #1: 1	كَبَّرَ يَوْمَ
u'كَبَسَ بِئْرٌ':Predicate, #1: 1	كَبَسَ الْأَرْضَ
u'كَبَسَ رَجُلٌ':Subject, #1: 1	كَبَسَ الْبِئْرَ
u'كِتَابٌ أَبٌ':Added, #2: 2	كَبَسَ الرَّجُلُ
u'كِتَابٌ اِبْتِيَاعٌ':Added, #1: 1	كِتَابَ الْأَبِ
u'كِتَابٌ إبدالٌ':Added, #1: 1	كِتَابَ ابْتِيَاعِهِ
u'كِتَابٌ إِبْطَالٌ':Added, #1: 1	كِتَابِ الْإِبْدَالِ
u'كِتَابٌ إِبْطَالٌ':Added, #1: 1	كِتَابَ إبْطَالِ
u'كِتَابٌ إِبِلٌ':Added, #4: 4	كِتَابِ إبْطَالِ
u'كِتَابٌ اِبْنٌ':Added, #1: 1	كِتَابِ الْإِبِلِ
u'كِتَابٌ إتْحَافٌ':Added, #128: 128	كِتَابِ ابْنِ
u'كِتَابٌ آثَارٌ':Added, #2: 2	كِتَابُ الْإِتْحَافِ
u'كِتَابٌ آثَارٌ':Added, #1: 1	كِتَاب الْآثَارِ
u'كِتَابٌ إِثْبَاتٌ':Added, #7: 7	كِتَابِ الْآثَارِ
u'كِتَابٌ إجَارَةٌ':Added, #5: 5	كِتَابِ إثْبَاتِ
u'كِتَابٌ إجَارَةٌ':Added, #13: 13	كِتَابِ الْإِجَارَةِ
u'كِتَابٌ إجَارَةٌ':Added, #1: 1	كِتَابَ الْإِجَارَةِ
u'كِتَابٌ إجَارَةٌ':Added, #20: 20	كِتَابِ الْإِجَارَاتِ
u'كِتَابٌ إجَارَةٌ':Added, #2: 2	كِتَابِ الإِجَارَةِ
u'كِتَابٌ إجَارَةٌ':Added, #3: 3	كِتَابُ الْإِجَارَاتِ
u'كِتَابٌ إجَازَةٌ':Added, #9: 9	كِتَابُ الْإِجَارَةِ
u'كِتَابٌ آجَالٌ':Added, #1: 1	كِتَابِ الْإِجَازَةِ
u'كِتَابٌ إِجْمَاعٌ':Added, #1: 1	كِتَابِ الْآجَالِ
u'كِتَابٌ إِجْمَاعٌ':Added, #1: 1	كِتَاب الْإِجْمَاعِ
u'كِتَابٌ إِجْمَاعٌ':Added, #1: 1	كِتَابُ الْإِجْمَاعِ
u'كِتَابٌ أَجْوِبَةٌ':Added, #4: 4	كِتَابِ الْإِجْمَاعِ
u'كِتَابٌ أحَدٌ':Added, #1: 1	كِتَابِ الْأَجْوِبَةِ
u'كِتَابٌ إِحْرَامٌ':Added, #1: 1	كِتَابِ أَحَدٍ
u'كِتَابٌ أَحْكَامٌ':Added, #1: 1	كِتَابِ الْإِحْرَامِ
u'كِتَابٌ إحْكَامٌ':Added, #18: 18	كِتَابِ أَحْكَامِ
u'كِتَابٌ أَحْكَامٌ':Added, #1: 1	كِتَابِ إحْكَامِ
u'كِتَابٌ إحْكَامٌ':Added, #6: 6	كِتَابِ الْأَحْكَامِ
u'كِتَابٌ إِحْيَاءٌ':Added, #7: 7	كِتَابِ الْإِحْكَامِ
u'كِتَابٌ إِحْيَاءٌ':Added, #2: 2	كِتَابِ إحْيَاءِ
u'كِتَابٌ إِحْيَاءٌ':Added, #2: 2	كِتَابِ إِحْيَاءِ
u'كِتَابٌ إِخْبَارٌ':Added, #8: 8	كِتَابُ إحْيَاءِ
u'كِتَابٌ أخْبَارٌ':Added, #1: 1	كِتَابِ الْإِخْبَارِ
u'كِتَابٌ أَخْبَارٌ':Added, #2: 2	كِتَابِ أَخْبَارِ
u'كِتَابٌ اِخْتِلاَفٌ':Added, #2: 2	كِتَابِ أَخْبَارِ
u'كِتَابٌ اِخْتِلاَفٌ':Added, #10: 10	كِتَابِ اخْتِلَافِ
u'كِتَابٌ إِخْلاَصٌ':Added, #6: 6	كِتَابِ اخْتِلاَفِ
u'كِتَابٌ أخْلاقٌ':Added, #2: 2	كِتَابِ الْإِخْلَاصِ
u'كِتَابٌ أَخْلاَقٌ':Added, #2: 2	كِتَابِ أَخْلَاقِ
u'كِتَابٌ آدابٌ':Added, #2: 2	كِتَابِ أَخْلَاقِ
u'كِتَابٌ آدابٌ':Added, #1: 1	كِتَابُ آدَابِ
u'كِتَابٌ أدَب':Added, #3: 3	كِتَابِ آدَابِ
u'كِتَابٌ أدَب':Added, #1: 1	كِتَابِ الأَدَبِ
u'كِتَابٌ أدَب':Added, #37: 37	كِتَابِ أَدَبِ
u'كِتَابٌ أدَب':Added, #3: 3	كِتَابُ أَدَبِ
u'كِتَابٌ أدْعِيَةٌ':Added, #3: 3	كِتَابِ الْأَدَبِ
u'كِتَابٌ آدَمِيٌّ':Added, #1: 1	كِتَابِ الْأَدْعِيَةِ
u'كِتَابٌ أَدْوِيَةٌ':Added, #7: 7	كِتَابِ الْآدَمِيِّ
u'كِتَابٌ أَذَانٌ':Added, #1: 1	كِتَابِ الْأَدْوِيَةِ
u'كِتَابٌ إِرَادَةٌ':Added, #8: 8	كِتَابِ الْأَذَانِ
u'كِتَابٌ إِرْخَاءٌ':Added, #1: 1	كِتَابِ الْإِرَادَةِ
u'كِتَابٌ إِرْشَادٌ':Added, #1: 1	كِتَابِ إرْخَاءِ
u'كِتَابٌ أسَاسٌ':Added, #2: 2	كِتَابِ الْإِرْشَادِ
u'كِتَابٌ أَسَاسٌ':Added, #1: 1	كِتَابِ أَسَاسِ
u'كِتَابٌ أسْبَابٌ':Added, #1: 1	كِتَابِ أَسَاسِ
u'كِتَابٌ أَسْبَابٌ':Added, #8: 8	كِتَابِ أَسْبَابِ
u'كِتَابٌ أُسْتَاذٌ':Added, #8: 8	كِتَابِ أَسْبَابِ
u'كِتَابٌ اِسْتِسْقَاءٌ':Added, #2: 2	كِتَابِ الْأُسْتَاذِ
u'كِتَابٌ أسْرَارٌ':Added, #2: 2	كِتَابِ الاِسْتِسْقَاءِ
u'كِتَابٌ أَسْرَارٌ':Added, #1: 1	كِتَابِ الْأَسْرَارِ
u'كِتَابٌ أَسْماءٌ':Added, #1: 1	كِتَابِ الْأَسْرَارِ
u'كِتَابٌ أشباه':Added, #1: 1	كِتَابِ الأَسْمَاءِ
u'كِتَابٌ أشْبَاهٌ':Added, #3: 3	كِتَابِ الْأَشْبَاهِ
u'كِتَابٌ أَشْبَاهٌ':Added, #3: 3	كِتَابِ الْأَشْبَاهِ
u'كِتَابٌ اِشْتِقاقٌ':Added, #3: 3	كِتَابِ الْأَشْبَاهِ
u'كِتَابٌ أَشْرِبَةٌ':Added, #1: 1	كِتَابِ اشْتِقَاقِ
u'كِتَابٌ أَشْرِبَةٌ':Added, #2: 2	كِتَابِ الأَشْرِبَةِ
u'كِتَابٌ أَشْرِبَةٌ':Added, #5: 5	كِتَابُ الْأَشْرِبَةِ
u'كِتَابٌ أصل':Added, #6: 6	كِتَابِ الْأَشْرِبَةِ
u'كِتَابٌ أًصْلٌ':Added, #2: 2	كِتَابِ الْأَصْلِ
u'كِتَابٌ إِصْلاحٌ':Added, #2: 2	كِتَابِ الْأَصْلِ
u'كِتَابٌ أُصولٌ':Added, #1: 1	كِتَابِ إصْلَاحِ
u'كِتَابٌ أُصولٌ':Added, #1: 1	كِتَابُ أُصُولِ
u'كِتَابٌ أُصولٌ':Added, #1: 1	كِتَاب الْأُصُولِ
u'كِتَابٌ أُصولٌ':Added, #1: 1	كِتَابِ الْأُصُولِ
u'كِتَابٌ أَطْعِمَةٌ':Added, #3: 3	كِتَابِ أُصُولِ
u'كِتَابٌ أَطْعِمَةٌ':Added, #7: 7	كِتَابُ الْأَطْعِمَةِ
u'كِتَابٌ إِعْتاقٌ':Added, #7: 7	كِتَابِ الْأَطْعِمَةِ
u'كِتَابٌ إِعْجازٌ':Added, #4: 4	كِتَابِ الْإِعْتَاقِ
u'كِتَابٌ أعداد':Added, #2: 2	كِتَابِ الْإِعْجَازِ
u'كِتَابٌ أَعْدَادٌ':Added, #1: 1	كِتَابِ الْأَعْدَادِ
u'كِتَابٌ إِعْرابٌ':Added, #1: 1	كِتَابِ الْأَعْدَادِ
u'كِتَابٌ إعْلاَمٌ':Added, #2: 2	كِتَابِ الْإِعْرَابِ
u'كِتَابٌ أَعْلاَمٌ':Added, #1: 1	كِتَابِ الْإِعْلَامِ
u'كِتَابٌ أَعْمَالٌ':Added, #5: 5	كِتَابِ الْأَعْلَامِ
u'كِتَابٌ إفَادَةٌ':Added, #1: 1	كِتَابِ الْأَعْمَالِ
u'كِتَابٌ إِفْرَادٌ':Added, #1: 1	كِتَابِ الْإِفَادَةِ
u'كِتَابٌ إفْسَادٌ':Added, #1: 1	كِتَابِ الْإِفْرَادِ
u'كِتَابٌ أَفْعَالٌ':Added, #1: 1	كِتَابِ إفْسَادِ
u'كِتَابٌ أَفْعَالٌ':Added, #1: 1	كِتَابِ أَفْعَالِ
u'كِتَابٌ اِقْتِناصٌ':Added, #1: 1	كِتَابِ الْأَفْعَالِ
u'كِتَابٌ إقْرَارٌ':Added, #2: 2	كِتَابِ اقْتِنَاصِ
u'كِتَابٌ إقْرَارٌ':Added, #14: 14	كِتَابُ الْإِقْرَارِ
u'كِتَابٌ إقْرَارٌ':Added, #1: 1	كِتَابِ الإِقْرَارِ
u'كِتَابٌ إقْرَارٌ':Added, #2: 2	كِتَابَ الْإِقْرَارِ
u'كِتَابٌ أَقْضِيَةٌ':Added, #58: 58	كِتَابِ الْإِقْرَارِ
u'كِتَابٌ أَقْضِيَةٌ':Added, #1: 1	كِتَابُ الْأَقْضِيَةِ
u'كِتَابٌ آكَامٌ':Added, #39: 39	كِتَابِ الْأَقْضِيَةِ
u'كِتَابٌ إكْرَاهٌ':Added, #2: 2	كِتَابِ آكَامِ
u'كِتَابٌ إكْرَاهٌ':Added, #13: 13	كِتَابِ الْإِكْرَاهِ
u'كِتَابٌ إلْجَامٌ':Added, #4: 4	كِتَابُ الْإِكْرَاهِ
u'كِتَابٌ الرِّياض':Added, #1: 1	كِتَابُ إلْجَامِ
u'كِتَابٌ أَلْفَاظٌ':Added, #1: 1	كِتَابِ الرِّيَاضِ
u'كِتَابٌ أَلْفَاظٌ':Added, #1: 1	كِتَابَ الْأَلْفَاظِ
u'كِتَابٌ أَلْفَاظٌ':Added, #1: 1	كِتَابِ أَلْفَاظِ
u'كِتَابٌ اللهُ':Added, #2: 2	كِتَابِ الْأَلْفَاظِ
u'كِتَابٌ اللهُ':Added, #4: 4	كِتَابِ اللهِ
u'كِتَابٌ إِلْمَامٌ':Added, #7: 7	كِتَابَ اللهِ
u'كِتَابٌ إلْهَامٌ':Added, #1: 1	كِتَابِ الْإِلْمَامِ
u'كِتَابٌ أُمٌّ':Added, #1: 1	كِتَابِ الْإِلْهَامِ
u'كِتَابٌ إمَارَةٌ':Added, #4: 4	كِتَابِ الْأُمِّ
u'كِتَابٌ إمَامٌ':Added, #1: 1	كِتَابِ الْإِمَارَةِ
u'كِتَابٌ إمَامَةٌ':Added, #2: 2	كِتَابِ الْإِمَامِ
u'كِتَابٌ إمَامَةٌ':Added, #1: 1	كِتَابُ الإِمَامَةِ
u'كِتَابٌ إمَامَةٌ':Added, #1: 1	كِتَابُ الْإِمَامَةِ
u'كِتَابٌ إمَامَةٌ':Added, #2: 2	كِتَابِ الإِمَامَةِ
u'كِتَابٌ أمَانٌ':Added, #2: 2	كِتَابِ الْإِمَامَةِ
u'كِتَابٌ إمْتَاعٌ':Added, #2: 2	كِتَابِ الْأَمَانِ
u'كِتَابٌ أمثال':Added, #1: 1	كِتَابِ الْإِمْتَاعِ
u'كِتَابٌ أَمْثَالٌ':Added, #3: 3	كِتَابِ الْأَمْثَالِ
u'كِتَابٌ أَمَدٌ':Added, #3: 3	كِتَابِ الْأَمْثَالِ
u'كِتَابٌ أَمْرٌ':Added, #20: 20	كِتَابِ الْأَمَدِ
u'كِتَابٌ إِمْلاءٌ':Added, #4: 4	كِتَابِ الْأَمْرِ
u'كِتَابٌ أُمَّهَاتٌ':Added, #1: 1	كِتَابِ الْإِمْلَاءِ
u'كِتَابٌ أُمَّهَاتٌ':Added, #2: 2	كِتَابِ أُمَّهَاتِ
u'كِتَابٌ أَمْوَالٌ':Added, #3: 3	كِتَابُ أُمَّهَاتِ
u'كِتَابٌ أَميرٌ':Added, #20: 20	كِتَابِ الْأَمْوَالِ
u'كِتَابٌ أنبياء':Added, #1: 1	كِتَابِ أَمِيرِ
u'كِتَابٌ اِنْتِقالٌ':Added, #2: 2	كِتَابِ الْأَنْبِيَاءِ
u'كِتَابٌ إِنْذارٌ':Added, #1: 1	كِتَابِ انْتِقَالِ
u'كِتَابٌ إِنْذارٌ':Added, #1: 1	كِتَابَ الْإِنْذَارِ
u'كِتَابٌ أَنْسَابٌ':Added, #1: 1	كِتَابِ الْإِنْذَارِ
u'كِتَابٌ أَنْسَابٌ':Added, #1: 1	كِتَابِ أَنْسَابِ
u'كِتَابٌ إِنْصافٌ':Added, #2: 2	كِتَابِ الْأَنْسَابِ
u'كِتَابٌ أَنْوَارٌ':Added, #9: 9	كِتَابِ الْإِنْصَافِ
u'كِتَابٌ أهْلٌ':Added, #4: 4	كِتَابِ أَنْوَارِ
u'كِتَابٌ أوائل':Added, #1: 1	كِتَابِ أَهْلِ
u'كِتَابٌ أوْسَطُ':Added, #1: 1	كِتَابِ الْأَوَائِلِ
u'كِتَابٌ أَوْلاَدٌ':Added, #1: 1	كِتَابِ الْأَوْسَطِ
u'كِتَابٌ أَوْهَامٌ':Added, #1: 1	كِتَابِ أَوْلَادِ
u'كِتَابٌ إِيجَارٌ':Added, #1: 1	كِتَابِ أَوْهَامِ
u'كِتَابٌ إيجَازٌ':Added, #1: 1	كِتَابُ الْإِيجَارِ
u'كِتَابٌ إيصَالٌ':Added, #2: 2	كِتَابِ الْإِيجَازِ
u'كِتَابٌ أَيْمَانٌ':Added, #2: 2	كِتَابِ الْإِيصَالِ
u'كِتَابٌ إيمَانٌ':Added, #15: 15	كِتَابُ الْأَيْمَانِ
u'كِتَابٌ أَيْمَانٌ':Added, #17: 17	كِتَابِ الْإِيمَانِ
u'كِتَابٌ أَيْمَانٌ':Added, #1: 1	كِتَابُ الأَيْمَانِ
u'كِتَابٌ إيمَانٌ':Added, #1: 1	كِتَابِ الأَيْمَانِ
u'كِتَابٌ أَيْمَانٌ':Added, #1: 1	كِتَابِ الإِيمَانِ
u'كِتَابٌ بَاعِثٌ':Added, #93: 93	كِتَابِ الْأَيْمَانِ
u'كِتَابٌ بَحْرٌ':Added, #1: 1	كِتَابِ الْبَاعِثِ
u'كِتَابٌ بُخَارِيٌّ':Added, #2: 2	كِتَابِ الْبَحْرِ
u'كِتَابٌ بُخَارِيٌّ':Added, #1: 1	كِتَابُ الْبُخَارِيِّ
u'كِتَابٌ بَدْءٌ':Added, #4: 4	كِتَابِ الْبُخَارِيِّ
u'كِتَابٌ بَدْءٌ':Added, #1: 1	كِتَابِ الْبَدْءِ
u'كِتَابٌ بَدِيعٌ':Added, #2: 2	كِتَابِ بَدْءِ
u'كِتَابٌ بَذْلٌ':Added, #1: 1	كِتَابِ الْبَدِيعِ
u'كِتَابٌ بِرٌّ':Added, #1: 1	كِتَابِ بَذْلِ
u'كِتَابٌ بَراءةٌ':Added, #1: 1	كِتَابِ بِرِّ
u'كِتَابٌ بَراءةٌ':Added, #1: 1	كِتَابَ الْبَرَاءَةِ
u'كِتَابٌ بُرْهانٌ':Added, #1: 1	كِتَابَ بَرَاءَةٍ
u'كِتَابٌ بُرْهَانٌ':Added, #1: 1	كِتَابَ الْبُرْهَانِ
u'كِتَابٌ بُرْهانٌ':Added, #1: 1	كِتَابَ الْبُرْهَانِ
u'كِتَابٌ بُرْهَانٌ':Added, #4: 4	كِتَابِ الْبُرْهَانِ
u'كِتَابٌ بُسْتانٌ':Added, #4: 4	كِتَابِ الْبُرْهَانِ
u'كِتَابٌ بَضائِعُ':Added, #3: 3	كِتَابِ الْبُسْتَانِ
u'كِتَابٌ بَعْضٌ':Added, #9: 9	كِتَابِ الْبَضَائِعِ
u'كِتَابٌ بُغاةٌ':Added, #1: 1	كِتَابِ بَعْضِ
u'كِتَابٌ بَهْجَةٌ':Added, #1: 1	كِتَابِ الْبُغَاةِ
u'كِتَابٌ بَيَانٌ':Added, #12: 12	كِتَابِ بَهْجَةِ
u'كِتَابٌ بَيَانٌ':Added, #1: 1	كِتَابَ الْبَيَانِ
u'كِتَابٌ بَيَانٌ':Added, #3: 3	كِتَابِ بَيَانِ
u'كِتَابٌ بَيْعٌ':Added, #6: 6	كِتَابِ الْبَيَانِ
u'كِتَابٌ بَيْعٌ':Added, #5: 5	كِتَابُ الْبَيْعِ
u'كِتَابٌ بيوع':Added, #78: 78	كِتَابِ الْبَيْعِ
u'كِتَابٌ بيوع':Added, #11: 11	كِتَابُ الْبُيُوعِ
u'كِتَابٌ بيوع':Added, #2: 2	كِتَابَ الْبُيُوعِ
u'كِتَابَةٌ أَبٌ':Added, #66: 66	كِتَابِ الْبُيُوعِ
u'كِتَابَةٌ أَبٌ':Added, #1: 1	كِتَابَةُ الْأَبِ
u'كِتَابَةٌ إجَارَةٌ':Added, #2: 2	كِتَابَةِ الْأَبِ
u'كِتَابَةٌ أَجْزَاءٌ':Added, #2: 2	كِتَابَةَ إجَارَةِ
u'كِتَابَةٌ أحَدٌ':Added, #1: 1	كِتَابَةَ الْأَجْزَاءِ
u'كِتَابَةٌ أحَدٌ':Added, #1: 1	كِتَابَةُ أَحَدِ
u'كِتَابَةٌ أخرَس':Added, #3: 3	كِتَابَةِ أَحَدِ
u'كِتَابَةٌ أخرَس':Added, #1: 1	كِتَابَةُ الْأَخْرَسِ
u'كِتَابَةٌ أرْضٌ':Added, #2: 2	كِتَابَةَ الْأَخْرَسِ
u'كِتَابَةٌ اِسْتِئْجَارٌ':Added, #1: 1	كِتَابَةِ أَرْضِهِ
u'كِتَابَةٌ اِسْمٌ':Added, #1: 1	كِتَابَةَ اسْتِئْجَارِ
u'كِتَابَةٌ اِسْمٌ':Added, #1: 1	كِتَابَةَ اسْمِ
u'كِتَابَةٌ اِسْمٌ':Added, #1: 1	كِتَابَةِ اسْمِ
u'كِتَابَةٌ أصل':Added, #5: 5	كِتَابَةُ اسْمِ
u'كِتَابَةٌ أًصْلٌ':Added, #1: 1	كِتَابَةِ أَصْلِ
u'كِتَابَةٌ إقْرَارٌ':Added, #1: 1	كِتَابَةِ أَصْلِ
u'كِتَابَةٌ أَلْفَاظٌ':Added, #1: 1	كِتَابَةَ إقْرَارِهِ
u'كِتَابَةٌ أُمٌّ':Added, #1: 1	كِتَابَةِ أَلْفَاظِ
u'كِتَابَةٌ أُمٌّ':Added, #1: 1	كِتَابَةِ أُمِّ
u'كِتَابَةٌ أُمٌّ':Added, #3: 3	كِتَابَةِ أُمِّهِ
u'كِتَابَةٌ أمَةٌ':Added, #4: 4	كِتَابَةِ الْأُمِّ
u'كِتَابَةٌ أمَةٌ':Added, #1: 1	كِتَابَةَ الْأَمَةِ
u'كِتَابَةٌ أهْلٌ':Added, #1: 1	كِتَابَةُ أَمَةٍ
u'كِتَابَةٌ أَوَّلُ':Added, #1: 1	كِتَابَةِ أَهْلِ
u'كِتَابَةٌ أَوَّلُ':Added, #1: 1	كِتَابَةِ الْأَوَّلِ
u'كِتَابَةٌ أَوَّلُ':Added, #2: 2	كِتَابَةَ الْأَوَّلِ
u'كِتَابَةٌ بَعْضٌ':Added, #3: 3	كِتَابَةُ الْأَوَّلِ
u'كِتَابَةٌ بَعْضٌ':Added, #1: 1	كِتَابَةَ بَعْضِ
u'كِتَابَةٌ بَعْضٌ':Added, #2: 2	كِتَابَةِ بَعْضٍ
u'كِتَابَةٌ بَعْضٌ':Added, #2: 2	كِتَابَةُ بَعْضِهِ
u'كِتَابَةٌ بَيْعٌ':Added, #3: 3	كِتَابَةِ بَعْضِ
u'كِتَابَةٌ تَارِيخٌ':Added, #1: 1	كِتَابَةَ بَيْعِ
u'كِتَابَةٌ تَوْرَاةٌ':Added, #1: 1	كِتَابَةِ التَّارِيخِ
u'كِتَابَةٌ ثَلاثُ':Added, #1: 1	كِتَابَةَ تَوْرَاةٍ
u'كِتَابَةٌ ثَمَنٌ':Added, #1: 1	كِتَابَةِ ثَلَاثِ
u'كِتَابَةٌ جَرَيان':Added, #1: 1	كِتَابَةُ ثَمَنِهِ
u'كِتَابَةٌ جَمَاعَةٌ':Added, #1: 1	كِتَابَةِ جَرَيَانِ
u'كِتَابَةٌ جَوَابٌ':Added, #2: 2	كِتَابَةُ الْجَمَاعَةِ
u'كِتَابَةٌ جَوَابٌ':Added, #1: 1	كِتَابَةُ الْجَوَابِ
u'كِتَابَةٌ حاجَةٌ':Added, #1: 1	كِتَابَةِ الْجَوَابِ
u'كِتَابَةٌ حاضِرٌ':Added, #1: 1	كِتَابَةِ الْحَاجَةِ
u'كِتَابَةٌ حُدودٌ':Added, #2: 2	كِتَابَةِ الْحَاضِرِ
u'كِتَابَةٌ حُدودٌ':Added, #1: 1	كِتَابَةِ الْحُدُودِ
u'كِتَابَةٌ حَديثٌ':Added, #1: 1	كِتَابَةِ حُدُودِ
u'كِتَابَةٌ حَديثٌ':Added, #1: 1	كِتَابَةَ الْحَدِيثِ
u'كِتَابَةٌ حَسَنٌ':Added, #2: 2	كِتَابَةِ الْحَدِيثِ
u'كِتَابَةٌ حَسَنَةٌ':Added, #1: 1	كِتَابَةُ حَسَنَاتٍ
u'كِتَابَةٌ حِصَّةٌ':Added, #1: 1	كِتَابَةُ حَسَنَاتٍ
u'كِتَابَةٌ حُكْمٌ':Added, #1: 1	كِتَابَةُ حِصَّتِهِ
u'كِتَابَةٌ حَوائِجُ':Added, #2: 2	كِتَابَةِ الْحُكْمِ
u'كِتَابَةٌ خان':Added, #1: 1	كِتَابَةَ الْحَوَائِجِ
u'كِتَابَةٌ خانَة':Added, #1: 1	كِتَابَةِ الْخَانِيَّةِ
u'كِتَابَةٌ خراج':Added, #1: 1	كِتَابَةِ الْخَانِيَّةِ
u'كِتَابَةٌ خراج':Added, #1: 1	كِتَابَةَ الْخَرَاجِ
u'كِتَابَةٌ خَرَاجٌ':Added, #1: 1	كِتَابَةِ الْخَرَاجِ
u'كِتَابَةٌ خَرَاجٌ':Added, #1: 1	كِتَابَةَ الْخَرَاجِ
u'كِتَابَةٌ خَطٌّ':Added, #1: 1	كِتَابَةِ الْخَرَاجِ
u'كِتَابَةٌ دَاخِلٌ':Added, #1: 1	كِتَابَةِ خَطِّهِ
u'كِتَابَةٌ دَيْنٌ':Added, #1: 1	كِتَابَةَ الدَّاخِلِ
u'كِتَابَةٌ ذكر':Added, #1: 1	كِتَابَةِ الدَّيْنِ
u'كِتَابَةٌ ذكر':Added, #1: 1	كِتَابَةَ ذِكْرِ
u'كِتَابَةٌ ذِكْرٌ':Added, #1: 1	كِتَابَةُ ذِكْرِ
u'كِتَابَةٌ ذِكْرٌ':Added, #1: 1	كِتَابَةَ ذِكْرِ
u'كِتَابَةٌ رِجَالٌ':Added, #1: 1	كِتَابَةُ ذِكْرِ
u'كِتَابَةٌ رِقاعٌ':Added, #1: 1	كِتَابَةُ الرِّجَالِ
u'كِتَابَةٌ سِجِلٌّ':Added, #4: 4	كِتَابَةُ الرِّقَاعِ
u'كِتَابَةٌ سِجِلٌّ':Added, #1: 1	كِتَابَةُ السِّجِلِّ
u'كِتَابَةٌ سُلْطَانٌ':Added, #1: 1	كِتَابَةِ السِّجِلَّاتِ
u'كِتَابَةٌ سُورَةٌ':Added, #1: 1	كِتَابَةِ السُّلْطَانِ
u'كِتَابَةٌ سَيِّدٌ':Added, #1: 1	كِتَابَةُ سُورَةِ
u'كِتَابَةٌ شَهَادَةٌ':Added, #1: 1	كِتَابَةَ السَّيِّدِ
u'كِتَابَةٌ شَهَادَةٌ':Added, #1: 1	كِتَابَةَ الشَّهَادَةِ
u'كِتَابَةٌ شُهُودٌ':Added, #1: 1	كِتَابَةِ شَهَادَةِ
u'كِتَابَةٌ شَيْءٌ':Added, #2: 2	كِتَابَةِ الشُّهُودِ
u'كِتَابَةٌ شَيْءٌ':Added, #1: 1	كِتَابَةَ شَيْءٍ
u'كِتَابَةٌ شَيْءٌ':Added, #1: 1	كِتَابَةِ شَيْءٍ
u'كِتَابَةٌ شَيْخٌ':Added, #2: 2	كِتَابَةُ شَيْءٍ
u'كِتَابَةٌ صَاحِبٌ':Added, #1: 1	كِتَابَةُ الشَّيْخِ
u'كِتَابَةٌ صَبِيٌّ':Added, #1: 1	كِتَابَةِ صَاحِبِهِ
u'كِتَابَةٌ صداق':Added, #1: 1	كِتَابَةَ الصَّبِيِّ
u'كِتَابَةٌ صداق':Added, #1: 1	كِتَابَةُ الصَّدَاقِ
u'كِتَابَةٌ صَدَاقٌ':Added, #1: 1	كِتَابَةِ الصَّدَاقِ
u'كِتَابَةٌ صَدَاقٌ':Added, #1: 1	كِتَابَةُ الصَّدَاقِ
u'كِتَابَةٌ صداق':Added, #1: 1	كِتَابَةِ الصَّدَاقِ
u'كِتَابَةٌ صَدَاقٌ':Added, #1: 1	كِتَابَةُ صَدَاقِ
u'كِتَابَةٌ صَغِيرٌ':Added, #1: 1	كِتَابَةُ صَدَاقِ
u'كِتَابَةٌ صَغِيرٌ':Added, #1: 1	كِتَابَةَ الصَّغِيرِ
u'كِتَابَةٌ صِفَةٌ':Added, #1: 1	كِتَابَةُ صَغِيرٍ
u'كِتَابَةٌ صَكٌّ':Added, #1: 1	كِتَابَةِ الصِّفَةِ
u'كِتَابَةٌ صَكٌّ':Added, #1: 1	كِتَابَةُ الصَّكِّ
u'كِتَابَةٌ صُكُوكٌ':Added, #2: 2	كِتَابَةِ الصَّكِّ
u'كِتَابَةٌ صُكُوكٌ':Added, #1: 1	كِتَابَةُ الصُّكُوكِ
u'كِتَابَةٌ صُلْحٌ':Added, #1: 1	كِتَابَةِ الصُّكُوكِ
u'كِتَابَةٌ صلح':Added, #1: 1	كِتَابَةَ صُلْحٍ
u'كِتَابَةٌ صُلْحٌ':Added, #2: 2	كِتَابَةَ الصُّلْحِ
u'كِتَابَةٌ طُرُقٌ':Added, #2: 2	كِتَابَةَ الصُّلْحِ
u'كِتَابَةٌ طَلاَقٌ':Added, #1: 1	كِتَابَةِ طُرُقِ
u'كِتَابَةٌ عِبَارَةٌ':Added, #2: 2	كِتَابَةَ الطَّلَاقِ
u'كِتَابَةٌ عَبْدٌ':Added, #1: 1	كِتَابَةِ عِبَارَاتِ
u'كِتَابَةٌ عَبْدٌ':Added, #1: 1	كِتَابَةِ عَبْدٍ
u'كِتَابَةٌ عَبْدٌ':Added, #1: 1	كِتَابَةِ عَبْدَيْنِ
u'كِتَابَةٌ عَبْدٌ':Added, #2: 2	كِتَابَةُ عَبْدٍ
u'كِتَابَةٌ عَبْدٌ':Added, #2: 2	كِتَابَةَ عَبْدِهِ
u'كِتَابَةٌ عَبْدٌ':Added, #3: 3	كِتَابَةِ عَبْدِهِ
u'كِتَابَةٌ عَبْدٌ':Added, #4: 4	كِتَابَةُ الْعَبْدِ
u'كِتَابَةٌ عَبِيدٌ':Added, #8: 8	كِتَابَةِ الْعَبْدِ
u'كِتَابَةٌ عَلاَمَةٌ':Added, #1: 1	كِتَابَةُ الْعَبِيدِ
u'كِتَابَةٌ علم':Added, #1: 1	كِتَابَةُ الْعَلَامَةِ
u'كِتَابَةٌ عِلْمٌ':Added, #1: 1	كِتَابَةُ الْعِلْمِ
u'كِتَابَةٌ علم':Added, #1: 1	كِتَابَةُ الْعِلْمِ
u'كِتَابَةٌ عِلْمٌ':Added, #2: 2	كِتَابَةَ الْعِلْمِ
u'كِتَابَةٌ علم':Added, #2: 2	كِتَابَةَ الْعِلْمِ
u'كِتَابَةٌ عِلْمٌ':Added, #4: 4	كِتَابَةِ الْعِلْمِ
u'كِتَابَةٌ عَهْدٌ':Added, #4: 4	كِتَابَةِ الْعِلْمِ
u'كِتَابَةٌ غَلَطٌ':Added, #1: 1	كِتَابَةِ الْعَهْدِ
u'كِتَابَةٌ غير':Added, #1: 1	كِتَابَةُ الْغَلَطِ
u'كِتَابَةٌ غَيْرٌ':Added, #1: 1	كِتَابَةِ الْغَيْرِ
u'كِتَابَةٌ غير':Added, #1: 1	كِتَابَةِ الْغَيْرِ
u'كِتَابَةٌ غَيْرٌ':Added, #1: 1	كِتَابَةُ غَيْرِهِ
u'كِتَابَةٌ فَاسِدٌ':Added, #1: 1	كِتَابَةُ غَيْرِهِ
u'كِتَابَةٌ فَسْخٌ':Added, #1: 1	كِتَابَةٍ فَاسِدَةٍ
u'كِتَابَةٌ فلان':Added, #1: 1	كِتَابَةَ فَسْخِ
u'كِتَابَةٌ قَبْضٌ':Added, #1: 1	كِتَابَةِ الْخَانِيَّةِ
u'كِتَابَةٌ قُرْآنٌ':Added, #2: 2	كِتَابَةِ قَبْضِ
u'كِتَابَةٌ قُرْآنٌ':Added, #1: 1	كِتَابَةُ قُرْآنٍ
u'كِتَابَةٌ قُرْآنٌ':Added, #3: 3	كِتَابَةِ الْقُرْآنِ
u'كِتَابَةٌ قُرْآنٌ':Added, #4: 4	كِتَابَةَ الْقُرْآنِ
u'كِتَابَةٌ قَطَائِعُ':Added, #8: 8	كِتَابَةُ الْقُرْآنِ
u'كِتَابَةٌ قِنٌّ':Added, #1: 1	كِتَابَةِ الْقَطَائِعِ
u'كِتَابَةٌ قَيِّمٌ':Added, #1: 1	كِتَابَةِ الْقِنِّ
u'كِتَابَةٌ قِيمَةٌ':Added, #1: 1	كِتَابَةُ الْقَيِّمِ
u'كِتَابَةٌ كَافِرٌ':Added, #1: 1	كِتَابَةِ قِيمَةِ
u'كِتَابَةٌ كَافِرٌ':Added, #1: 1	كِتَابَةُ الْكَافِرِ
u'كِتَابَةٌ كِتَابٌ':Added, #1: 1	كِتَابَةِ الْكَافِرِ
u'كِتَابَةٌ كِتَابٌ':Added, #1: 1	كِتَابَةَ الْكِتَابِ
u'كِتَابَةٌ كِتَابٌ':Added, #1: 1	كِتَابَةِ الْكِتَابِ
u'كِتَابَةٌ كِتَابٌ':Added, #1: 1	كِتَابَةَ كِتَابٍ
u'كِتَابَةٌ كِتَابٌ':Added, #1: 1	كِتَابَةُ كِتَابِ
u'كِتَابَةٌ كِتَابٌ':Added, #1: 1	كِتَابَةِ كِتَابٍ
u'كِتَابَةٌ كُرَّاسٌ':Added, #2: 2	كِتَابَةُ كِتَابٍ
u'كِتَابَةٌ كَلاَمٌ':Added, #1: 1	كِتَابَةِ كُرَّاسٍ
u'كِتَابَةٌ لَفْظَةٌ':Added, #1: 1	كِتَابَةِ كَلَامِ
u'كِتَابَةٌ مَبِيعٌ':Added, #2: 2	كِتَابَةِ لَفْظَةِ
u'كِتَابَةٌ مثل':Added, #1: 1	كِتَابَةُ الْمَبِيعِ
u'كِتَابَةٌ مِثْلٌ':Added, #1: 1	كِتَابَةُ مِثْلِهِ
u'كِتَابَةٌ مَحْضَرٌ':Added, #1: 1	كِتَابَةُ مِثْلِهِ
u'كِتَابَةٌ مَحْضَرٌ':Added, #1: 1	كِتَابَةَ مَحْضَرٍ
u'كِتَابَةٌ مُحَمَّدٌ':Added, #4: 4	كِتَابَةِ الْمَحْضَرِ
u'كِتَابَةٌ مُدَبَّرٌ':Added, #1: 1	كِتَابَةُ مُحَمَّدٍ
u'كِتَابَةٌ مُدَبَّرٌ':Added, #1: 1	كِتَابَةُ الْمُدَبَّرِ
u'كِتَابَةٌ مُدَبَّرٌ':Added, #1: 1	كِتَابَةِ الْمُدَبَّرِ
u'كِتَابَةٌ مُدَبَّرٌ':Added, #1: 1	كِتَابَةُ مُدَبَّرٍ
u'كِتَابَةٌ مُرْتَدٌّ':Added, #2: 2	كِتَابَةَ الْمُدَبَّرِ
u'كِتَابَةٌ مُرْتَدٌّ':Added, #1: 1	كِتَابَةُ الْمُرْتَدِّ
u'كِتَابَةٌ مَرْهُونٌ':Added, #3: 3	كِتَابَةِ الْمُرْتَدِّ
u'كِتَابَةٌ مَرْهُونٌ':Added, #1: 1	كِتَابَةُ الْمَرْهُونِ
u'كِتَابَةٌ مُسْلِمٌ':Added, #1: 1	كِتَابَةُ مَرْهُونٍ
u'كِتَابَةٌ مَشْهُودٌ':Added, #1: 1	كِتَابَةُ الْمُسْلِمَيْنِ
u'كِتَابَةٌ مَصَاحِفُ':Added, #1: 1	كِتَابَةُ الْمَشْهُودِ
u'كِتَابَةٌ مُصْحَفٌ':Added, #1: 1	كِتَابَةِ الْمَصَاحِفِ
u'كِتَابَةٌ مُصْحَفٌ':Added, #1: 1	كِتَابَةَ الْمُصْحَفِ
u'كِتَابَةٌ مُصَنِّفٌ':Added, #3: 3	كِتَابَةِ الْمُصْحَفِ
u'كِتَابَةٌ مُضَارَبَةٌ':Added, #1: 1	كِتَابَةِ الْمُصَنِّفِ
u'كِتَابَةٌ مُعَامَلَةٌ':Added, #1: 1	كِتَابَةَ الْمُضَارَبَةِ
u'كِتَابَةٌ مُعْتَقٌ':Added, #1: 1	كِتَابَةُ الْمُعَامَلَاتِ
u'كِتَابَةٌ مَعْصِيَةٌ':Added, #1: 1	كِتَابَةَ مُعْتَقِ
u'كِتَابَةٌ مَغْصُوب':Added, #1: 1	كِتَابَةِ الْمَعْصِيَةِ
u'كِتَابَةٌ مَفْهُومٌ':Added, #1: 1	كِتَابَةُ الْمَغْصُوبِ
u'كِتَابَةٌ مُمَيِّزٌ':Added, #1: 1	كِتَابَةٍ مَفْهُومَةٍ
u'كِتَابَةٌ مناشير':Added, #1: 1	كِتَابَةِ الْمُمَيِّزِ
u'كِتَابَةٌ مَنَاشِيرُ':Added, #1: 1	كِتَابَةُ الْمَنَاشِيرِ
u'كِتَابَةٌ مَنْشُورٌ':Added, #1: 1	كِتَابَةُ الْمَنَاشِيرِ
u'كِتَابَةٌ مَهْرٌ':Added, #1: 1	كِتَابَةَ الْمَنْشُورِ
u'كِتَابَةٌ مَهْرٌ':Added, #1: 1	كِتَابَةَ الْمَهْرِ
u'كِتَابَةٌ مَهْرٌ':Added, #1: 1	كِتَابَةُ الْمَهْرِ
u'كِتَابَةٌ نَاطِقٌ':Added, #3: 3	كِتَابَةِ الْمَهْرِ
u'كِتَابَةٌ نَاطِقٌ':Added, #1: 1	كِتَابَةُ نَاطِقٍ
u'كِتَابَةٌ نَحْوٌ':Added, #2: 2	كِتَابَةَ النَّاطِقِ
u'كِتَابَةٌ نَحْوٌ':Added, #1: 1	كِتَابَةَ نَحْوِ
u'كِتَابَةٌ نَحْوٌ':Added, #1: 1	كِتَابَةُ نَحْوِ
u'كِتَابَةٌ نسخة':Added, #1: 1	كِتَابَةِ نَحْوِ
u'كِتَابَةٌ نُسْخَةٌ':Added, #1: 1	كِتَابَةِ النُّسْخَةِ
u'كِتَابَةٌ نسخة':Added, #1: 1	كِتَابَةِ النُّسْخَةِ
u'كِتَابَةٌ نُسْخَةٌ':Added, #1: 1	كِتَابَةِ نُسْخَةٍ
u'كِتَابَةٌ نِصْفٌ':Added, #1: 1	كِتَابَةِ نُسْخَةٍ
u'كِتَابَةٌ نَصِيبٌ':Added, #1: 1	كِتَابَةَ النِّصْفِ
u'كِتَابَةٌ نَهْرٌ':Added, #3: 3	كِتَابَةِ نَصِيبِهِ
u'كِتَابَةٌ واحد':Added, #1: 1	كِتَابَةُ النَّهْرِ
u'كِتَابَةٌ وَاحِدٌ':Added, #1: 1	كِتَابَةِ الْوَاحِدِ
u'كِتَابَةٌ واحد':Added, #1: 1	كِتَابَةِ الْوَاحِدِ
u'كِتَابَةٌ وَاحِدٌ':Added, #4: 4	كِتَابَةٍ وَاحِدَةٍ
u'كِتَابَةٌ وَارِثٌ':Added, #4: 4	كِتَابَةٍ وَاحِدَةٍ
u'كِتَابَةٌ وَثِيقٌ':Added, #1: 1	كِتَابَةِ الْوَارِثِ
u'كِتَابَةٌ وَصِيٌّ':Added, #1: 1	كِتَابَةُ الْوَثِيقَةِ
u'كِتَابَةٌ وَصِيٌّ':Added, #1: 1	كِتَابَةَ الْوَصِيِّ
u'كِتَابَةٌ وَصِيَّةٌ':Added, #1: 1	كِتَابَةَ الْوَصِيَّةِ
u'كِتَابَةٌ وَقْفٌ':Added, #1: 1	كِتَابَةَ الْوَصِيَّةِ
u'كِتَابَةٌ ولد':Added, #1: 1	كِتَابَةِ الْوَقْفِ
u'كِتَابَةٌ وَلَدٌ':Added, #2: 2	كِتَابَةِ الْوَلَدِ
u'كِتَابَةٌ وَلِيٌّ':Added, #2: 2	كِتَابَةِ الْوَلَدِ
u'كِتَابَةٌ يهود':Added, #1: 1	كِتَابَةِ الْوَلِيِّ
u'كِتَابَةٌ يَهُودٌ':Added, #1: 1	كِتَابَةَ الْيَهُودِ
u'كِتَابٌ تَارِيخٌ':Added, #1: 1	كِتَابَةَ الْيَهُودِ
u'كِتَابٌ تَارِيخٌ':Added, #1: 1	كِتَابِ التَّارِيخِ
u'كِتَابٌ تَبْصِرَة':Added, #1: 1	كِتَابِ تَارِيخِ
u'كِتَابٌ تِجَارَةٌ':Added, #2: 2	كِتَابِ التَّبْصِرَةِ
u'كِتَابٌ تَجْرِيدٌ':Added, #1: 1	كِتَابِ التِّجَارَةِ
u'كِتَابٌ تَجْنِيدٌ':Added, #1: 1	كِتَابِ التَّجْرِيدِ
u'كِتَابٌ تَجْنِيس':Added, #1: 1	كِتَابِ تَجْنِيدِ
u'كِتَابٌ تَحْرِيرٌ':Added, #1: 1	كِتَابِ التَّجْنِيسِ
u'كِتَابٌ تَحْرِيرٌ':Added, #2: 2	كِتَابِ التَّحْرِيرِ
u'كِتَابٌ تَحْرِيمٌ':Added, #2: 2	كِتَابِ تَحْرِيرِ
u'كِتَابٌ تَحْصِيلٌ':Added, #3: 3	كِتَابِ تَحْرِيمِ
u'كِتَابٌ تَحْقِيقٌ':Added, #8: 8	كِتَابِ التَّحْصِيلِ
u'كِتَابٌ تَحْلِيلٌ':Added, #2: 2	كِتَابِ التَّحْقِيقِ
u'كِتَابٌ تَخْرِيجٌ':Added, #1: 1	كِتَابِ التَّحْلِيلِ
u'كِتَابٌ تَخْرِيجٌ':Added, #1: 1	كِتَابِ تَخْرِيجِ
u'كِتَابٌ تَخْلِيصٌ':Added, #5: 5	كِتَابِ التَّخْرِيجِ
u'كِتَابٌ تَخْلِيصٌ':Added, #1: 1	كِتَابِ التَّخْلِيصِ
u'كِتَابٌ تَخْيِيرٌ':Added, #2: 2	كِتَابِ تَخْلِيصِ
u'كِتَابٌ تَدْبِيرٌ':Added, #6: 6	كِتَابِ التَّخْيِيرِ
u'كِتَابٌ تَدْبِيرٌ':Added, #2: 2	كِتَابِ التَّدْبِيرِ
u'كِتَابٌ تَدْلِيس':Added, #4: 4	كِتَابُ التَّدْبِيرِ
u'كِتَابٌ تَذْكِرَةٌ':Added, #2: 2	كِتَابِ التَّدْلِيسِ
u'كِتَابٌ تَذْكِرَةٌ':Added, #1: 1	كِتَابِ التَّذْكِرَةِ
u'كِتَابٌ تَرَاوِيحُ':Added, #1: 1	كِتَابِ تَذْكِرَةِ
u'كِتَابٌ تَرْتِيبٌ':Added, #1: 1	كِتَابُ التَّرَاوِيحِ
u'كِتَابٌ تَرْتِيبٌ':Added, #4: 4	كِتَابِ تَرْتِيبِ
u'كِتَابٌ تَرْجِيحٌ':Added, #6: 6	كِتَابِ التَّرْتِيبِ
u'كِتَابٌ تَرْغِيبٌ':Added, #1: 1	كِتَابِ التَّرْجِيحِ
u'كِتَابٌ تَرْهِيبٌ':Added, #2: 2	كِتَابِ التَّرْغِيبِ
u'كِتَابٌ تَزْوِيجٌ':Added, #1: 1	كِتَابِ التَّرْهِيبِ
u'كِتَابٌ تَسْدِيدٌ':Added, #1: 1	كِتَابِ تَزْوِيجِ
u'كِتَابٌ تَسْمِيَة':Added, #1: 1	كِتَابِ التَّسْدِيدِ
u'كِتَابٌ تَشَهُّدٌ':Added, #2: 2	كِتَابِ التَّسْمِيَةِ
u'كِتَابٌ تَضْمِينٌ':Added, #1: 1	كِتَابِ التَّشَهُّدِ
u'كِتَابٌ تَعْدِيلٌ':Added, #1: 1	كِتَابِ تَضْمِينِ
u'كِتَابٌ تَعْرِيفٌ':Added, #1: 1	كِتَابُ التَّعْدِيلِ
u'كِتَابٌ تَعْظِيمٌ':Added, #6: 6	كِتَابِ التّعْرِيفِ
u'كِتَابٌ تَعْلِيقٌ':Added, #2: 2	كِتَابِ تَعْظِيمِ
u'كِتَابٌ تَفَرُّدٌ':Added, #2: 2	كِتَابِ التَّعْلِيقِ
u'كِتَابٌ تَفْرِقَة':Added, #1: 1	كِتَابِ التَّفَرُّدِ
u'كِتَابٌ تَفْسِيرٌ':Added, #4: 4	كِتَابِ التَّفْرِقَةِ
u'كِتَابٌ تَفْصِيلٌ':Added, #5: 5	كِتَابِ التَّفْسِيرِ
u'كِتَابٌ تَفْلِيسٌ':Added, #1: 1	كِتَابَ التَّفْصِيلِ
u'كِتَابٌ تَفْلِيسٌ':Added, #1: 1	كِتَاب التَّفْلِيسِ
u'كِتَابٌ تَفْلِيسٌ':Added, #3: 3	كِتَابُ التَّفْلِيسِ
u'كِتَابٌ تَقْديمٌ':Added, #9: 9	كِتَابِ التَّفْلِيسِ
u'كِتَابٌ تَقْريبٌ':Added, #1: 1	كِتَابِ تَقْدِيمِ
u'كِتَابٌ تَقْريبٌ':Added, #18: 18	كِتَابِ التَّقْرِيبِ
u'كِتَابٌ تَلْخيصٌ':Added, #1: 1	كِتَابِ التّقْرِيبِ
u'كِتَابٌ تَلْخيصٌ':Added, #1: 1	كِتَابَ التَّلْخِيصِ
u'كِتَابٌ تَلْخيصٌ':Added, #2: 2	كِتَابِ تَلْخِيصِ
u'كِتَابٌ تَلْويحٌ':Added, #4: 4	كِتَابِ التَّلْخِيصِ
u'كِتَابٌ تمام':Added, #1: 1	كِتَابِ التَّلْوِيحِ
u'كِتَابٌ تَمامٌ':Added, #1: 1	كِتَابِ التَّمَامِ
u'كِتَابٌ تَمْحيصٌ':Added, #1: 1	كِتَابِ التَّمَامِ
u'كِتَابٌ تَمْهِيدٌ':Added, #2: 2	كِتَابِ التَّمْحِيصِ
u'كِتَابٌ تَمْييزٌ':Added, #1: 1	كِتَابِ التّمْهِيدِ
u'كِتَابٌ تَنْوِيرٌ':Added, #1: 1	كِتَابِ التَّمْيِيزِ
u'كِتَابٌ تَوَاضُعٌ':Added, #1: 1	كِتَابِ التَّنْوِيرِ
u'كِتَابٌ تَوْبَةٌ':Added, #1: 1	كِتَابِ التَّوَاضُعِ
u'كِتَابٌ تَوْسِعَة':Added, #2: 2	كِتَابِ التَّوْبَةِ
u'كِتَابٌ تَوَكُّلٌ':Added, #1: 1	كِتَابِ التَّوْسِعَةِ
u'كِتَابٌ تونِسِيّ':Added, #1: 1	كِتَابِ التَّوَكُّلِ
u'كِتَابٌ تِيجَانٌ':Added, #1: 1	كِتَابِ التُّونِسِيِّ
u'كِتَابٌ تَيْسيرٌ':Added, #2: 2	كِتَابِ التّيجَانِ
u'كِتَابٌ تَيَمُّمٌ':Added, #1: 1	كِتَابِ التَّيْسِيرِ
u'كِتَابٌ تَيَمُّمٌ':Added, #3: 3	كِتَابُ التَّيَمُّمِ
u'كِتَابٌ ثِقَة':Added, #4: 4	كِتَابِ التَّيَمُّمِ
u'كِتَابٌ ثَوابٌ':Added, #1: 1	كِتَابِ الثِّقَاتِ
u'كِتَابٌ جَامِعٌ':Added, #1: 1	كِتَابِ ثَوَابِ
u'كِتَابٌ جَامِعٌ':Added, #1: 1	كِتَابُ جَامِعِ
u'كِتَابٌ جَامِعٌ':Added, #1: 1	كِتَابِ جَامِعِ
u'كِتَابٌ جَدَلٌ':Added, #9: 9	كِتَابِ الْجَامِعِ
u'كِتَابٌ جراح':Added, #1: 1	كِتَابِ الْجَدَلِ
u'كِتَابٌ جِرَاحٌ':Added, #3: 3	كِتَابُ الْجِرَاحِ
u'كِتَابٌ جراح':Added, #3: 3	كِتَابُ الْجِرَاحِ
u'كِتَابٌ جِرَاحٌ':Added, #7: 7	كِتَابِ الْجِرَاحِ
u'كِتَابٌ جِزْيَةٌ':Added, #7: 7	كِتَابِ الْجِرَاحِ
u'كِتَابٌ جِزْيَةٌ':Added, #1: 1	كِتَابَ الْجِزْيَةِ
u'كِتَابٌ جِزْيَةٌ':Added, #2: 2	كِتَابُ الْجِزْيَةِ
u'كِتَابٌ جِعال':Added, #7: 7	كِتَابِ الْجِزْيَةِ
u'كِتَابٌ جَلِيسٌ':Added, #1: 1	كِتَابُ الْجِعَالَةِ
u'كِتَابٌ جَمَاعَةٌ':Added, #2: 2	كِتَابِ الْجَلِيسِ
u'كِتَابٌ جَمَالٌ':Added, #1: 1	كِتَابِ الْجَمَاعَاتِ
u'كِتَابٌ جمع':Added, #1: 1	كِتَابِ جَمَالِ
u'كِتَابٌ جمع':Added, #1: 1	كِتَابَ الْجَمْعِ
u'كِتَابٌ جَمْعٌ':Added, #1: 1	كِتَابِ الْجَمْعِ
u'كِتَابٌ جَمْعٌ':Added, #1: 1	كِتَابَ الْجَمْعِ
u'كِتَابٌ جمعة':Added, #1: 1	كِتَابِ الْجَمْعِ
u'كِتَابٌ جُمُعَةٌ':Added, #16: 16	كِتَابِ الْجُمُعَةِ
u'كِتَابٌ جمعة':Added, #16: 16	كِتَابِ الْجُمُعَةِ
u'كِتَابٌ جمعة':Added, #1: 1	كِتَابِ الْجُمْعَةِ
u'كِتَابٌ جُمُعَةٌ':Added, #3: 3	كِتَابُ الْجُمُعَةِ
u'كِتَابٌ جُمَلٌ':Added, #3: 3	كِتَابُ الْجُمُعَةِ
u'كِتَابٌ جَنَائِزُ':Added, #1: 1	كِتَابِ الْجُمَلِ
u'كِتَابٌ جَنَائِزُ':Added, #23: 23	كِتَابِ الْجَنَائِزِ
u'كِتَابٌ جِنَايَةٌ':Added, #9: 9	كِتَابُ الْجَنَائِزِ
u'كِتَابٌ جِنَايَةٌ':Added, #11: 11	كِتَابُ الْجِنَايَاتِ
u'كِتَابٌ جهاد':Added, #32: 32	كِتَابِ الْجِنَايَاتِ
u'كِتَابٌ جِهَادٌ':Added, #33: 33	كِتَابِ الْجِهَادِ
u'كِتَابٌ جهاد':Added, #33: 33	كِتَابِ الْجِهَادِ
u'كِتَابٌ جِهَادٌ':Added, #5: 5	كِتَابُ الْجِهَادِ
u'كِتَابٌ جهر':Added, #5: 5	كِتَابُ الْجِهَادِ
u'كِتَابٌ جَهْرٌ':Added, #1: 1	كِتَابِ الْجَهْرِ
u'كِتَابٌ حاطِبٌ':Added, #1: 1	كِتَابِ الْجَهْرِ
u'كِتَابٌ حاطِبٌ':Added, #1: 1	كِتَابَ حَاطِبٍ
u'كِتَابٌ حاطِبٌ':Added, #1: 1	كِتَابَ حَاطِبِ
u'كِتَابٌ حافِلٌ':Added, #1: 1	كِتَابُ حَاطِبٍ
u'كِتَابٌ حاكِمٌ':Added, #1: 1	كِتَابٍ حَافِلٍ
u'كِتَابٌ حاكِمٌ':Added, #1: 1	كِتَابُ حَاكِمِ
u'كِتَابٌ حاكِمٌ':Added, #3: 3	كِتَابُ الْحَاكِمِ
u'كِتَابٌ حَبْسٌ':Added, #3: 3	كِتَابِ الْحَاكِمِ
u'كِتَابٌ حَجٌّ':Added, #1: 1	كِتَابِ الْحَبْسِ
u'كِتَابٌ حَجٌّ':Added, #10: 10	كِتَابُ الْحَجِّ
u'كِتَابٌ حُجَّةٌ':Added, #81: 81	كِتَابِ الْحَجِّ
u'كِتَابٌ حُجَجٌ':Added, #4: 4	كِتَابِ الْحُجَّةِ
u'كِتَابٌ حَجَرٌ':Added, #1: 1	كِتَابِ الْحُجَجِ
u'كِتَابٌ حَجْرٌ':Added, #1: 1	كِتَابُ الْحَجَرِ
u'كِتَابٌ حَجْرٌ':Added, #24: 24	كِتَابِ الْحَجْرِ
u'كِتَابٌ حَجْرٌ':Added, #2: 2	كِتَاب الْحَجْرِ
u'كِتَابٌ حَدٌّ':Added, #7: 7	كِتَابُ الْحَجْرِ
u'كِتَابٌ حَدٌّ':Added, #1: 1	كِتَابِ حَدِّ
u'كِتَابٌ حُدودٌ':Added, #6: 6	كِتَابُ حَدِّ
u'كِتَابٌ حُدودٌ':Added, #11: 11	كِتَابُ الْحُدُودِ
u'كِتَابٌ حُدودٌ':Added, #1: 1	كِتَاب ِالْحُدُودِ
u'كِتَابٌ حُدودٌ':Added, #2: 2	كِتَابَ الْحُدُودِ
u'كِتَابٌ حَديثٌ':Added, #65: 65	كِتَابِ الْحُدُودِ
u'كِتَابٌ حساب':Added, #1: 1	كِتَابِ حَدِيثٍ
u'كِتَابٌ حِسَابٌ':Added, #1: 1	كِتَابُ حِسَابٍ
u'كِتَابٌ حَسَنٌ':Added, #1: 1	كِتَابُ حِسَابٍ
u'كِتَابٌ حَسَنٌ':Added, #1: 1	كِتَابَ حَسَنَاتِهِ
u'كِتَابٌ حَسَنَةٌ':Added, #2: 2	كِتَابِ الْحَسَنِ
u'كِتَابٌ حَظْر':Added, #1: 1	كِتَابَ حَسَنَاتِهِ
u'كِتَابٌ حَظْر':Added, #1: 1	كِتَابُ الْحَظْرِ
u'كِتَابٌ حَقٌّ':Added, #4: 4	كِتَابِ الْحَظْرِ
u'كِتَابٌ حَكَمٌ':Added, #1: 1	كِتَابَ حَقٍّ
u'كِتَابٌ حُكْمٌ':Added, #1: 1	كِتَابُ الْحَكَمِ
u'كِتَابٌ حُكْمٌ':Added, #1: 1	كِتَابِ الْحُكْمِ
u'كِتَابٌ حُكْمٌ':Added, #1: 1	كِتَاب حُكْمِ
u'كِتَابٌ حُكْمٌ':Added, #1: 1	كِتَابِ حُكْمِ
u'كِتَابٌ حَلالٌ':Added, #2: 2	كِتَابِ حُكْمٍ
u'كِتَابٌ حَمَّادٌ':Added, #1: 1	كِتَابِ الْحَلَالِ
u'كِتَابٌ حَمَّادٌ':Added, #1: 1	كِتَابُ حَمَّادِ
u'كِتَابٌ حَمَّامٌ':Added, #1: 1	كِتَابِ حَمَّادِ
u'كِتَابٌ حَوَالَةٌ':Added, #1: 1	كِتَابِ الْحَمَّامِ
u'كِتَابٌ حَوَالَةٌ':Added, #10: 10	كِتَابُ الْحَوَالَةِ
u'كِتَابٌ حَيْضٌ':Added, #10: 10	كِتَابِ الْحَوَالَةِ
u'كِتَابٌ حَيْضٌ':Added, #27: 27	كِتَابِ الْحَيْضِ
u'كِتَابٌ حيطانٌ':Added, #3: 3	كِتَابُ الْحَيْضِ
u'كِتَابٌ حِيَلٌ':Added, #12: 12	كِتَابِ الْحِيطَانِ
u'كِتَابٌ حِيَلٌ':Added, #15: 15	كِتَابِ الْحِيَلِ
u'كِتَابٌ حَيَوَانٌ':Added, #1: 1	كِتَابُ الْحِيَلِ
u'كِتَابٌ ختان':Added, #5: 5	كِتَابِ الْحَيَوَانِ
u'كِتَابٌ خِتَانٌ':Added, #1: 1	كِتَابُ الْخِتَانِ
u'كِتَابٌ خراج':Added, #1: 1	كِتَابُ الْخِتَانِ
u'كِتَابٌ خَرَاجٌ':Added, #21: 21	كِتَابِ الْخَرَاجِ
u'كِتَابٌ خِصَالٌ':Added, #21: 21	كِتَابِ الْخَرَاجِ
u'كِتَابٌ خِصَالٌ':Added, #1: 1	كِتَاب الْخِصَالِ
u'كِتَابٌ خُلاصَة':Added, #5: 5	كِتَابِ الْخِصَالِ
u'كِتَابٌ خِلاَفٌ':Added, #1: 1	كِتَابِ خُلَاصَةِ
u'كِتَابٌ خِلاَفٌ':Added, #2: 2	كِتَابِ الْخِلاَفِ
u'كِتَابٌ خُلْعٌ':Added, #8: 8	كِتَابِ الْخِلَافِ
u'كِتَابٌ خُلْعٌ':Added, #6: 6	كِتَابُ الْخُلْعِ
u'كِتَابٌ خَلِيفَةٌ':Added, #6: 6	كِتَابِ الْخُلْعِ
u'كِتَابٌ خَلِيلٌ':Added, #1: 1	كِتَابُ الْخَلِيفَةِ
u'كِتَابٌ خَمْسٌ':Added, #1: 1	كِتَابِ الْخَلِيلِ
u'كِتَابٌ خَوَاتِمُ':Added, #1: 1	كِتَابِ الْخَمْسِ
u'كِتَابٌ خَوَاتِيمُ':Added, #4: 4	كِتَابِ الْخَوَاتِمِ
u'كِتَابٌ خيار':Added, #2: 2	كِتَابِ الْخَوَاتِيمِ
u'كِتَابٌ خِيَارٌ':Added, #2: 2	كِتَابِ الْخِيَارِ
u'كِتَابٌ خَيْلٌ':Added, #2: 2	كِتَابِ الْخِيَارِ
u'كِتَابٌ دَاءٌ':Added, #2: 2	كِتَابِ الْخَيْلِ
u'كِتَابٌ دَارٌ':Added, #1: 1	كِتَابِ الدَّاءِ
u'كِتَابٌ دَامِغٌ':Added, #1: 1	كِتَابِ الدَّارِ
u'كِتَابٌ دُرٌّ':Added, #1: 1	كِتَابُ الدَّامِغِ
u'كِتَابٌ دَرْء':Added, #1: 1	كِتَابِ الدُّرِّ
u'كِتَابٌ دُرَرٌ':Added, #1: 1	كِتَابِ دَرْءِ
u'كِتَابٌ دِرَرٌ':Added, #1: 1	كِتَابِ الدّرَرِ
u'كِتَابٌ دُرَرٌ':Added, #1: 1	كِتَابِ الدّرَرِ
u'كِتَابٌ دُعَاءٌ':Added, #3: 3	كِتَابِ الدُّرَرِ
u'كِتَابٌ دَعَوَاتٌ':Added, #3: 3	كِتَابِ الدُّعَاءِ
u'كِتَابٌ دَلائِلُ':Added, #6: 6	كِتَابِ الدَّعَوَاتِ
u'كِتَابٌ دَلائِلُ':Added, #13: 13	كِتَابِ الدَّلَائِلِ
u'كِتَابٌ دَلائِلُ':Added, #1: 1	كِتَابِ الدّلَائِلِ
u'كِتَابٌ دَلائِلُ':Added, #1: 1	كِتَابِ دَلَائِلِ
u'كِتَابٌ دُورٌ':Added, #1: 1	كِتَابِ دَلاَئِلِ
u'كِتَابٌ دَوْرٌ':Added, #1: 1	كِتَابِ الدُّورِ
u'كِتَابٌ ديباجٌ':Added, #1: 1	كِتَابِ الدَّوْرِ
u'كِتَابٌ دِيَةٌ':Added, #1: 1	كِتَابِ الدِّيبَاجِ
u'كِتَابٌ دِيَةٌ':Added, #13: 13	كِتَابُ الدِّيَاتِ
u'كِتَابٌ دَيْنٌ':Added, #34: 34	كِتَابِ الدِّيَاتِ
u'كِتَابٌ دَيْنٌ':Added, #1: 1	كِتَابَ الدَّيْنِ
u'كِتَابٌ دِيوانٌ':Added, #1: 1	كِتَابِ دَيْنِهِ
u'كِتَابٌ ذَبائِحُ':Added, #1: 1	كِتَابِ الدِّيوَانِ
u'كِتَابٌ ذَبائِحُ':Added, #4: 4	كِتَابُ الذَّبَائِحِ
u'كِتَابٌ ذَريعٌ':Added, #4: 4	كِتَابِ الذَّبَائِحِ
u'كِتَابٌ ذَريعَةٌ':Added, #1: 1	كِتَابِ الذَّرِيعَةِ
u'كِتَابٌ ذكر':Added, #1: 1	كِتَابِ الذَّرِيعَةِ
u'كِتَابٌ ذِكْرٌ':Added, #1: 1	كِتَابِ الذِّكْرِ
u'كِتَابٌ ذَمٌّ':Added, #1: 1	كِتَابِ الذِّكْرِ
u'كِتَابٌ ذَيْلٌ':Added, #6: 6	كِتَابِ ذَمِّ
u'كِتَابٌ رجعة':Added, #1: 1	كِتَابُ الذَّيْلِ
u'كِتَابٌ رَجْعَةٌ':Added, #3: 3	كِتَابِ الرَّجْعَةِ
u'كِتَابٌ رجعة':Added, #3: 3	كِتَابِ الرَّجْعَةِ
u'كِتَابٌ رَجْعَةٌ':Added, #5: 5	كِتَابُ الرَّجْعَةِ
u'كِتَابٌ رَجُلٌ':Added, #5: 5	كِتَابُ الرَّجْعَةِ
u'كِتَابٌ رَجُلٌ':Added, #1: 1	كِتَابِ الرَّجُلِ
u'كِتَابٌ رَجُلٌ':Added, #1: 1	كِتَابُ رَجُلٍ
u'كِتَابٌ رُجُوعٌ':Added, #2: 2	كِتَابِ رَجُلٍ
u'كِتَابٌ رُجُوعٌ':Added, #10: 10	كِتَابِ الرُّجُوعِ
u'كِتَابٌ رحمة':Added, #4: 4	كِتَابُ الرُّجُوعِ
u'كِتَابٌ رَحْمَةٌ':Added, #1: 1	كِتَابِ الرَّحْمَةِ
u'كِتَابٌ رَدٌّ':Added, #1: 1	كِتَابِ الرَّحْمَةِ
u'كِتَابٌ رَدَّةٌ':Added, #3: 3	كِتَابِ الرَّدِّ
u'كِتَابٌ رِدَّةٌ':Added, #1: 1	كِتَابِ الرّدّةِ
u'كِتَابٌ رِدَّةٌ':Added, #1: 1	كِتَابِ الرّدّةِ
u'كِتَابٌ رِدَّةٌ':Added, #5: 5	كِتَابُ الرِّدَّةِ
u'كِتَابٌ رَزينٌ':Added, #5: 5	كِتَابِ الرِّدَّةِ
u'كِتَابٌ رِسَالَةٌ':Added, #1: 1	كِتَابِ رَزِينِ
u'كِتَابٌ رِسَالَةٌ':Added, #12: 12	كِتَابِ الرِّسَالَةِ
u'كِتَابٌ رِسَالَةٌ':Added, #1: 1	كِتَابُ الرِّسَالَةِ
u'كِتَابٌ رِسَالَةٌ':Added, #1: 1	كِتَابَ رِسَالَةٍ
u'كِتَابٌ رَسُولٌ':Added, #3: 3	كِتَابَ الرِّسَالَةِ
u'كِتَابٌ رَسُولٌ':Added, #10: 10	كِتَابَ رَسُولِ
u'كِتَابٌ رَسُولٌ':Added, #12: 12	كِتَابِ رَسُولِ
u'كِتَابٌ رَسُولٌ':Added, #14: 14	كِتَابُ رَسُولِ
u'كِتَابٌ رَسُولٌ':Added, #1: 1	كِتَابَ الرّسُولِ
u'كِتَابٌ رَشيدٌ':Added, #4: 4	كِتَابُ الرّسُولِ
u'كِتَابٌ رضاع':Added, #1: 1	كِتَابِ الرَّشِيدِ
u'كِتَابٌ رضاع':Added, #11: 11	كِتَابُ الرَّضَاعِ
u'كِتَابٌ رقاق':Added, #9: 9	كِتَابِ الرَّضَاعِ
u'كِتَابٌ رُقاقٌ':Added, #1: 1	كِتَابِ الرّقَاقِ
u'كِتَابٌ رَمْيٌ':Added, #1: 1	كِتَابِ الرّقَاقِ
u'كِتَابٌ رَهْنٌ':Added, #1: 1	كِتَابِ الرَّمْيِ
u'كِتَابٌ رَهْنٌ':Added, #1: 1	كِتَابُ رَهْنِ
u'كِتَابٌ رَهْنٌ':Added, #54: 54	كِتَابِ الرَّهْنِ
u'كِتَابٌ رُهونٌ':Added, #7: 7	كِتَابُ الرَّهْنِ
u'كِتَابٌ رُوَاةٌ':Added, #1: 1	كِتَابِ الرُّهُونِ
u'كِتَابٌ رُوَاةٌ':Added, #1: 1	كِتَابِ رُوَاةِ
u'كِتَابٌ رواحل':Added, #2: 2	كِتَابِ الرُّوَاةِ
u'كِتَابٌ رَوَاحِلُ':Added, #1: 1	كِتَابِ الرَّوَاحِلِ
u'كِتَابٌ روحٌ':Added, #1: 1	كِتَابِ الرَّوَاحِلِ
u'كِتَابٌ رَوْضَةٌ':Added, #1: 1	كِتَابِ الرُّوحِ
u'كِتَابٌ رِياضٌ':Added, #1: 1	كِتَابِ رَوْضَةِ
u'كِتَابٌ زادٌ':Added, #1: 1	كِتَابِ الرِّيَاضِ
u'كِتَابٌ زاهِرٌ':Added, #1: 1	كِتَابِ زَادِ
u'كِتَابٌ زَكاةٌ':Added, #1: 1	كِتَابِ الزَّاهِرِ
u'كِتَابٌ زَكاةٌ':Added, #117: 117	كِتَابِ الزَّكَاةِ
u'كِتَابٌ زَكاةٌ':Added, #12: 12	كِتَابُ الزَّكَاةِ
u'كِتَابٌ زُكاةٌ':Added, #1: 1	كِتَابِ الزّكَاةِ
u'كِتَابٌ زَلازِلٌ':Added, #1: 1	كِتَابِ الزّكَاةِ
u'كِتَابٌ زَنْدَقَةٌ':Added, #1: 1	كِتَابِ الزَّلَازِلِ
u'كِتَابٌ زواجر':Added, #1: 1	كِتَابُ زَنْدَقَةٍ
u'كِتَابٌ زِيادَةٌ':Added, #1: 1	كِتَابِ الزَّوَاجِرِ
u'كِتَابٌ زِيادَةٌ':Added, #1: 1	كِتَابِ الزِّيَادَاتِ
u'كِتَابٌ زَيْدٌ':Added, #2: 2	كِتَابَ الزِّيَادَاتِ
u'كِتَابٌ سَابِقٌ':Added, #1: 1	كِتَابُ زَيْدٍ
u'كِتَابٌ سَائِرٌ':Added, #1: 1	كِتَابِ السّابِقِ
u'كِتَابٌ سَبَقٌ':Added, #1: 1	كِتَابِ سَائِرِ
u'كِتَابٌ سَبْقٌ':Added, #2: 2	كِتَابُ السَّبَقِ
u'كِتَابٌ سِدَادٌ':Added, #2: 2	كِتَابِ السَّبْقِ
u'كِتَابٌ سِرٌّ':Added, #2: 2	كِتَابِ السِّدَادِ
u'كِتَابٌ سِرٌّ':Added, #1: 1	كِتَابُ السِّرِّ
u'كِتَابٌ سَرقَةٌ':Added, #5: 5	كِتَابِ السِّرِّ
u'كِتَابٌ سَرِقَةٌ':Added, #5: 5	كِتَابِ السَّرِقَةِ
u'كِتَابٌ سَرقَةٌ':Added, #5: 5	كِتَابِ السَّرِقَةِ
u'كِتَابٌ سَرِقَةٌ':Added, #7: 7	كِتَابُ السَّرِقَةِ
u'كِتَابٌ سُرْيانِيّ':Added, #7: 7	كِتَابُ السَّرِقَةِ
u'كِتَابٌ سَعْدٌ':Added, #2: 2	كِتَابَ السُّرْيَانِيَّةِ
u'كِتَابٌ سَعِيدٌ':Added, #2: 2	كِتَابِ سَعْدٍ
u'كِتَابٌ سلام':Added, #1: 1	كِتَابِ سَعِيدِ
u'كِتَابٌ سَلاَمٌ':Added, #1: 1	كِتَابِ السَّلَامِ
u'كِتَابٌ سُلْطَانٌ':Added, #1: 1	كِتَابِ السَّلَامِ
u'كِتَابٌ سُلْطَانٌ':Added, #1: 1	كِتَابُ السُّلْطَانِ
u'كِتَابٌ سَلَمٌ':Added, #4: 4	كِتَابِ السُّلْطَانِ
u'كِتَابٌ سَلَمٌ':Added, #11: 11	كِتَابِ السَّلَمِ
u'كِتَابٌ سَمَاوِيٌّ':Added, #3: 3	كِتَابُ السَّلَمِ
u'كِتَابٌ سُنَّةٌ':Added, #1: 1	كِتَابٍ سَمَاوِيٍّ
u'كِتَابٌ سنن':Added, #8: 8	كِتَابِ السُّنَّةِ
u'كِتَابٌ سنن':Added, #1: 1	كِتَابَ السُّنَنِ
u'كِتَابٌ سَنَنٌ':Added, #1: 1	كِتَابِ السّنَنِ
u'كِتَابٌ سنن':Added, #1: 1	كِتَابِ السّنَنِ
u'كِتَابٌ سنن':Added, #2: 2	كِتَابِ سُنَنِ
u'كِتَابٌ سَوادٌ':Added, #67: 67	كِتَابِ السُّنَنِ
u'كِتَابٌ سِواكٌ':Added, #1: 1	كِتَابِ السَّوَادِ
u'كِتَابٌ سِياسَةٌ':Added, #5: 5	كِتَابِ السِّوَاكِ
u'كِتَابٌ سِيَرٌ':Added, #1: 1	كِتَابِ السِّيَاسَةِ
u'كِتَابٌ سِيَرٌ':Added, #1: 1	كِتَابِ السِّيرِ
u'كِتَابٌ سِيَرٌ':Added, #1: 1	كِتَابَ السِّيَرِ
u'كِتَابٌ سِيَرٌ':Added, #1: 1	كِتَابِ السّيَرِ
u'كِتَابٌ سِيَرٌ':Added, #1: 1	كِتَابِ سِيَرِهِ
u'كِتَابٌ سَيْرٌ':Added, #29: 29	كِتَابِ السِّيَرِ
u'كِتَابٌ سِيَرٌ':Added, #2: 2	كِتَابِ السَّيْرِ
u'كِتَابٌ سيرَةٌ':Added, #9: 9	كِتَابُ السِّيَرِ
u'كِتَابٌ سيرَةٌ':Added, #1: 1	كِتَابِ السّيرَةِ
u'كِتَابٌ سيرَةٌ':Added, #1: 1	كِتَابَ سِيرَةِ
u'كِتَابٌ شافِعِيّ':Added, #1: 1	كِتَابُ سِيرَةِ
u'كِتَابٌ شَامِلٌ':Added, #1: 1	كِتَابِ الشَّافِعِيِّ
u'كِتَابٌ شُبْهَةٌ':Added, #2: 2	كِتَابِ الشّامِلِ
u'كِتَابٌ شِرَاءٌ':Added, #1: 1	كِتَابَ الشُّبْهَةِ
u'كِتَابٌ شِرَاءٌ':Added, #1: 1	كِتَابُ الشِّرَاءِ
u'كِتَابٌ شِرَاءٌ':Added, #1: 1	كِتَابَ شِرَاءٍ
u'كِتَابٌ شِرَاءٌ':Added, #1: 1	كِتَابَ شِرَاءِ
u'كِتَابٌ شِرَاءٌ':Added, #1: 1	كِتَابُ شِرَاءٍ
u'كِتَابٌ شِرَاءٌ':Added, #1: 1	كِتَابِ شِرَاءٍ
u'كِتَابٌ شِرَاءٌ':Added, #3: 3	كِتَابِ الشِّرَاءِ
u'كِتَابٌ شَرَائِطُ':Added, #6: 6	كِتَابَ الشِّرَاءِ
u'كِتَابٌ شرب':Added, #2: 2	كِتَابِ شَرَائِطِ
u'كِتَابٌ شِرْبٌ':Added, #1: 1	كِتَابُ الشِّرْبِ
u'كِتَابٌ شرب':Added, #1: 1	كِتَابُ الشِّرْبِ
u'كِتَابٌ شِرْبٌ':Added, #6: 6	كِتَابِ الشِّرْبِ
u'كِتَابٌ شرب':Added, #6: 6	كِتَابِ الشِّرْبِ
u'كِتَابٌ شُرْبٌ':Added, #9: 9	كِتَابِ الشُّرْبِ
u'كِتَابٌ شَرْحٌ':Added, #9: 9	كِتَابِ الشُّرْبِ
u'كِتَابٌ شرف':Added, #12: 12	كِتَابِ شَرْحِ
u'كِتَابٌ شَرَفٌ':Added, #4: 4	كِتَابِ شَرَفِ
u'كِتَابٌ شركة':Added, #4: 4	كِتَابِ شَرَفِ
u'كِتَابٌ شَرِكَةٌ':Added, #19: 19	كِتَابِ الشَّرِكَةِ
u'كِتَابٌ شركة':Added, #19: 19	كِتَابِ الشَّرِكَةِ
u'كِتَابٌ شَرِكَةٌ':Added, #1: 1	كِتَابَ الشَّرِكَةِ
u'كِتَابٌ شركة':Added, #1: 1	كِتَابَ الشَّرِكَةِ
u'كِتَابٌ شِرْكَةٌ':Added, #3: 3	كِتَابُ الشِّرْكَةِ
u'كِتَابٌ شركة':Added, #3: 3	كِتَابُ الشِّرْكَةِ
u'كِتَابٌ شَرِكَةٌ':Added, #8: 8	كِتَابُ الشَّرِكَةِ
u'كِتَابٌ شُرُوطٌ':Added, #8: 8	كِتَابُ الشَّرِكَةِ
u'كِتَابٌ شَرِيعَةٌ':Added, #10: 10	كِتَابِ الشُّرُوطِ
u'كِتَابٌ شُعَبٌ':Added, #1: 1	كِتَابِ الشَّرِيعَةِ
u'كِتَابٌ شِفَاءٌ':Added, #1: 1	كِتَابِ شُعَبِ
u'كِتَابٌ شَفَاعَةٌ':Added, #1: 1	كِتَابِ الشِّفَاءِ
u'كِتَابٌ شفعة':Added, #2: 2	كِتَابَ شَفَاعَةٍ
u'كِتَابٌ شُفْعَةٌ':Added, #22: 22	كِتَابِ الشُّفْعَةِ
u'كِتَابٌ شفعة':Added, #22: 22	كِتَابِ الشُّفْعَةِ
u'كِتَابٌ شُفْعَةٌ':Added, #9: 9	كِتَابُ الشُّفْعَةِ
u'كِتَابٌ شَفِيعٌ':Added, #9: 9	كِتَابُ الشُّفْعَةِ
u'كِتَابٌ شكر':Added, #1: 1	كِتَابِ الشَّفِيعِ
u'كِتَابٌ شُكْرٌ':Added, #1: 1	كِتَابِ الشُّكْرِ
u'كِتَابٌ شَمَائِلُ':Added, #1: 1	كِتَابِ الشُّكْرِ
u'كِتَابٌ شمس':Added, #1: 1	كِتَابِ الشَّمَائِلِ
u'كِتَابٌ شَمْسٌ':Added, #1: 1	كِتَابِ شَمْسِ
u'كِتَابٌ شَهَادَةٌ':Added, #1: 1	كِتَابِ شَمْسِ
u'كِتَابٌ شَهَادَةٌ':Added, #16: 16	كِتَابُ الشَّهَادَاتِ
u'كِتَابٌ شَهَادَةٌ':Added, #1: 1	كِتَابَ الشَّهَادَاتِ
u'كِتَابٌ شَهَادَةٌ':Added, #4: 4	كِتَابِ الشَّهَادَةِ
u'كِتَابٌ شَيْخٌ':Added, #54: 54	كِتَابِ الشَّهَادَاتِ
u'كِتَابٌ شَيْخٌ':Added, #15: 15	كِتَابِ الشّيْخِ
u'كِتَابٌ شَيْخٌ':Added, #1: 1	كِتَابُ الشَّيْخِ
u'كِتَابٌ صَاحِبٌ':Added, #2: 2	كِتَابِ الشَّيْخِ
u'كِتَابٌ صَحَابَةٌ':Added, #1: 1	كِتَابُ صَاحِبِ
u'كِتَابٌ صَحَابَةٌ':Added, #1: 1	كِتَابِ الصَّحَابَةِ
u'كِتَابٌ صَحِيحٌ':Added, #3: 3	كِتَابِ الصّحَابَةِ
u'كِتَابٌ صَحِيحٌ':Added, #1: 1	كِتَابُ الصَّحِيحِ
u'كِتَابٌ صداق':Added, #2: 2	كِتَابِ الصَّحِيحِ
u'كِتَابٌ صَدَاقٌ':Added, #41: 41	كِتَابِ الصَّدَاقِ
u'كِتَابٌ صداق':Added, #41: 41	كِتَابِ الصَّدَاقِ
u'كِتَابٌ صَدَاقٌ':Added, #6: 6	كِتَابُ الصَّدَاقِ
u'كِتَابٌ صَدَقَةٌ':Added, #6: 6	كِتَابُ الصَّدَاقِ
u'كِتَابٌ صَدَقَةٌ':Added, #1: 1	كِتَابُ الصَّدَقَاتِ
u'كِتَابٌ صدقة':Added, #2: 2	كِتَابَ الصَّدَقَاتِ
u'كِتَابٌ صَدَقَةٌ':Added, #3: 3	كِتَابِ الصَّدَقَةِ
u'كِتَابٌ صدقة':Added, #3: 3	كِتَابِ الصَّدَقَةِ
u'كِتَابٌ صَدَقَةٌ':Added, #6: 6	كِتَابَ الصَّدَقَةِ
u'كِتَابٌ صَرْفٌ':Added, #6: 6	كِتَابَ الصَّدَقَةِ
u'كِتَابٌ صَرْف':Added, #25: 25	كِتَابِ الصَّرْفِ
u'كِتَابٌ صَرْفٌ':Added, #25: 25	كِتَابِ الصَّرْفِ
u'كِتَابٌ صَرْف':Added, #3: 3	كِتَابُ الصَّرْفِ
u'كِتَابٌ صَرِيحٌ':Added, #3: 3	كِتَابُ الصَّرْفِ
u'كِتَابٌ صَغِيرٌ':Added, #1: 1	كِتَابِ الصَّرِيحِ
u'كِتَابٌ صِفَةٌ':Added, #1: 1	كِتَابٍ صَغِيرٍ
u'كِتَابٌ صَفْوَةٌ':Added, #2: 2	كِتَابِ صِفَةِ
u'كِتَابٌ صَفْوَةٌ':Added, #1: 1	كِتَابِ الصَّفْوَةِ
u'كِتَابٌ صَكٌّ':Added, #1: 1	كِتَابِ صَفْوَةِ
u'كِتَابٌ صَلاَةٌ':Added, #1: 1	كِتَابُ صَكٍّ
u'كِتَابٌ صَلاَةٌ':Added, #152: 152	كِتَابِ الصَّلَاةِ
u'كِتَابٌ صَلاَةٌ':Added, #15: 15	كِتَابُ الصَّلَاةِ
u'كِتَابٌ صَلاَةٌ':Added, #18: 18	كِتَابُ صَلَاةِ
u'كِتَابٌ صَلاَةٌ':Added, #1: 1	كِتَابِ الصَّلاةِ
u'كِتَابٌ صَلاَةٌ':Added, #1: 1	كِتَابُ صَلاَةِ
u'كِتَابٌ صَلاَةٌ':Added, #2: 2	كِتَابَ الصَّلَاةِ
u'كِتَابٌ صَلاَةٌ':Added, #2: 2	كِتَابِ الصّلَاةِ
u'كِتَابٌ صَلاَةٌ':Added, #31: 31	كِتَابِ الصَّلاَةِ
u'كِتَابٌ صَلاَةٌ':Added, #3: 3	كِتَابِ صَلَاةِ
u'كِتَابٌ صلح':Added, #3: 3	كِتَابِ صَلاَةِ
u'كِتَابٌ صُلْحٌ':Added, #3: 3	كِتَابَ الصُّلْحِ
u'كِتَابٌ صلح':Added, #3: 3	كِتَابَ الصُّلْحِ
u'كِتَابٌ صُلْحٌ':Added, #48: 48	كِتَابِ الصُّلْحِ
u'كِتَابٌ صلح':Added, #48: 48	كِتَابِ الصُّلْحِ
u'كِتَابٌ صُلْحٌ':Added, #8: 8	كِتَابُ الصُّلْحِ
u'كِتَابٌ صَوْمٌ':Added, #8: 8	كِتَابُ الصُّلْحِ
u'كِتَابٌ صَوْمٌ':Added, #1: 1	كِتَابَ الصَّوْمِ
u'كِتَابٌ صَوْمٌ':Added, #32: 32	كِتَابِ الصَّوْمِ
u'كِتَابٌ صِيال':Added, #6: 6	كِتَابُ الصَّوْمِ
u'كِتَابٌ صِيال':Added, #1: 1	كِتَابُ الصِّيَالِ
u'كِتَابٌ صِيَامٌ':Added, #1: 1	كِتَابِ الصِّيَالِ
u'كِتَابٌ صِيَامٌ':Added, #30: 30	كِتَابِ الصِّيَامِ
u'كِتَابٌ صَيْدٌ':Added, #7: 7	كِتَابُ الصِّيَامِ
u'كِتَابٌ صَيْدٌ':Added, #10: 10	كِتَابُ الصَّيْدِ
u'كِتَابٌ ضعفاء':Added, #26: 26	كِتَابِ الصَّيْدِ
u'كِتَابٌ ضَمَانٌ':Added, #1: 1	كِتَابِ الضّعَفَاءِ
u'كِتَابٌ ضَمَانٌ':Added, #3: 3	كِتَابُ ضَمَانِ
u'كِتَابٌ ضَمَانٌ':Added, #4: 4	كِتَابُ الضَّمَانِ
u'كِتَابٌ طِبٌّ':Added, #4: 4	كِتَابِ الضَّمَانِ
u'كِتَابٌ طِبٌّ':Added, #10: 10	كِتَابِ الطِّبِّ
u'كِتَابٌ طِبٌّ':Added, #1: 1	كِتَاب الطِّبِّ
u'كِتَابٌ طِبٌّ':Added, #1: 1	كِتَابُ الطِّبِّ
u'كِتَابٌ طَبَقَةٌ':Added, #1: 1	كِتَابَ طِبٍّ
u'كِتَابٌ طُرُقٌ':Added, #1: 1	كِتَابِ طَبَقَاتِ
u'كِتَابٌ طُرُقَاتٌ':Added, #1: 1	كِتَابِ الطُّرُقِ
u'كِتَابٌ طَرِيقٌ':Added, #1: 1	كِتَابِ الطُّرُقَاتِ
u'كِتَابٌ طَلاَقٌ':Added, #1: 1	كِتَابِ الطَّرِيقِ
u'كِتَابٌ طَلاَقٌ':Added, #121: 121	كِتَابِ الطَّلَاقِ
u'كِتَابٌ طَلاَقٌ':Added, #13: 13	كِتَابُ الطَّلَاقِ
u'كِتَابٌ طَلاَقٌ':Added, #1: 1	كِتَابَ الطَّلَاقِ
u'كِتَابٌ طَلاَقٌ':Added, #1: 1	كِتَابِ الطّلَاقِ
u'كِتَابٌ طَلاَقٌ':Added, #3: 3	كِتَابِ طَلَاقِ
u'كِتَابٌ طَهَارَةٌ':Added, #4: 4	كِتَابِ الطَّلاَقِ
u'كِتَابٌ طِهَارَةٌ':Added, #16: 16	كِتَابُ الطَّهَارَةِ
u'كِتَابٌ طَهَارَةٌ':Added, #1: 1	كِتَابُ الطِّهَارَاتِ
u'كِتَابٌ طِهَارَةٌ':Added, #1: 1	كِتَابِ الطّهَارَةِ
u'كِتَابٌ طَهَارَةٌ':Added, #1: 1	كِتَابِ الطّهَارَةِ
u'كِتَابٌ طَهُورٌ':Added, #65: 65	كِتَابِ الطَّهَارَةِ
u'كِتَابٌ طَهُورٌ':Added, #1: 1	كِتَاب الطَّهُورِ
u'كِتَابٌ طَوَاعِينُ':Added, #8: 8	كِتَابِ الطَّهُورِ
u'كِتَابٌ ظهار':Added, #2: 2	كِتَابِ الطَّوَاعِينِ
u'كِتَابٌ ظهار':Added, #22: 22	كِتَابِ الظِّهَارِ
u'كِتَابٌ عارِيَّةٌ':Added, #5: 5	كِتَابُ الظِّهَارِ
u'كِتَابٌ عارِيَّةٌ':Added, #10: 10	كِتَابُ الْعَارِيَّةِ
u'كِتَابٌ عَاقِلٌ':Added, #7: 7	كِتَابِ الْعَارِيَّةِ
u'كِتَابٌ عَالِمٌ':Added, #2: 2	كِتَابِ الْعَاقِلَةِ
u'كِتَابٌ عَبْدٌ':Added, #1: 1	كِتَابَ عَالِمٍ
u'كِتَابٌ عَبْدٌ':Added, #3: 3	كِتَابُ عَبْدِ
u'كِتَابٌ عتاق':Added, #3: 3	كِتَابِ عَبْدِ
u'كِتَابٌ عتاق':Added, #25: 25	كِتَابِ الْعَتَاقِ
u'كِتَابٌ عتق':Added, #3: 3	كِتَابُ الْعَتَاقِ
u'كِتَابٌ عِتْقٌ':Added, #11: 11	كِتَابُ الْعِتْقِ
u'كِتَابٌ عتق':Added, #11: 11	كِتَابُ الْعِتْقِ
u'كِتَابٌ عِتْقٌ':Added, #48: 48	كِتَابِ الْعِتْقِ
u'كِتَابٌ عُدَّةٌ':Added, #48: 48	كِتَابِ الْعِتْقِ
u'كِتَابٌ عِدَّةٌ':Added, #1: 1	كِتَابِ عُدَّةِ
u'كِتَابٌ عُدَّةٌ':Added, #2: 2	كِتَابُ الْعِدَّةِ
u'كِتَابٌ عِدَّةٌ':Added, #3: 3	كِتَابِ الْعُدَّةِ
u'كِتَابٌ عَدَدٌ':Added, #6: 6	كِتَابِ الْعِدَّةِ
u'كِتَابٌ عِدَدٌ':Added, #1: 1	كِتَابِ الْعَدَدِ
u'كِتَابٌ عِدَدٌ':Added, #5: 5	كِتَابِ الْعِدَدِ
u'كِتَابٌ عَرَبٌ':Added, #6: 6	كِتَابُ الْعِدَدِ
u'كِتَابٌ عزل':Added, #1: 1	كِتَابَ الْعَرَبِ
u'كِتَابٌ عزلة':Added, #1: 1	كِتَابَ الْعَزْلِ
u'كِتَابٌ عُزْلَةٌ':Added, #4: 4	كِتَابِ الْعُزْلَةِ
u'كِتَابٌ عُشْرٌ':Added, #4: 4	كِتَابِ الْعُزْلَةِ
u'كِتَابٌ عُشْرٌ':Added, #15: 15	كِتَابِ الْعُشْرِ
u'كِتَابٌ عِشْرَةٌ':Added, #1: 1	كِتَابُ الْعُشْرِ
u'كِتَابٌ عَقْدٌ':Added, #2: 2	كِتَابُ عِشْرَةِ
u'كِتَابٌ عَقْدٌ':Added, #1: 1	كِتَابِ عَقْدٍ
u'كِتَابٌ عَقْلٌ':Added, #6: 6	كِتَابُ عَقْدِ
u'كِتَابٌ عُقُوبَةٌ':Added, #1: 1	كِتَابِ الْعَقْلِ
u'كِتَابٌ عَقِيقَةٌ':Added, #1: 1	كِتَابِ الْعُقُوبَاتِ
u'كِتَابٌ عِلَلٌ':Added, #1: 1	كِتَابُ الْعَقِيقَةِ
u'كِتَابٌ عِلَلٌ':Added, #21: 21	كِتَابِ الْعِلَلِ
u'كِتَابٌ علم':Added, #2: 2	كِتَابِ عِلَلِ
u'كِتَابٌ عِلْمٌ':Added, #1: 1	كِتَابَ عِلْمٍ
u'كِتَابٌ علم':Added, #1: 1	كِتَابَ عِلْمٍ
u'كِتَابٌ عِلْمٌ':Added, #7: 7	كِتَابِ الْعِلْمِ
u'كِتَابٌ عَلِيٌّ':Added, #7: 7	كِتَابِ الْعِلْمِ
u'كِتَابٌ عِمَادٌ':Added, #3: 3	كِتَابُ عَلِيٍّ
u'كِتَابٌ عُمُومٌ':Added, #1: 1	كِتَابِ الْعِمَادِ
u'كِتَابٌ عَهْدٌ':Added, #1: 1	كِتَابِ الْعُمُومِ
u'كِتَابٌ عُهْدَةٌ':Added, #1: 1	كِتَابَ الْعَهْدِ
u'كِتَابٌ عَوَاصِمُ':Added, #1: 1	كِتَابَ الْعُهْدَةِ
u'كِتَابٌ عوامل':Added, #1: 1	كِتَابِ الْعَوَاصِمِ
u'كِتَابٌ عَوَامِلُ':Added, #1: 1	كِتَابِ الْعَوَامِلِ
u'كِتَابٌ عِيَارٌ':Added, #1: 1	كِتَابِ الْعَوَامِلِ
u'كِتَابٌ عِيدٌ':Added, #2: 2	كِتَابِ عِيَارِ
u'كِتَابٌ عين':Added, #2: 2	كِتَابِ الْعِيدَيْنِ
u'كِتَابٌ عَيْنٌ':Added, #15: 15	كِتَابِ الْعَيْنِ
u'كِتَابٌ عَيْن':Added, #15: 15	كِتَابِ الْعَيْنِ
u'كِتَابٌ عُيُوبٌ':Added, #15: 15	كِتَابِ الْعَيْنِ
u'كِتَابٌ عُيُونٌ':Added, #5: 5	كِتَابِ الْعُيُوبِ
u'كِتَابٌ غَايَةٌ':Added, #1: 1	كِتَابِ عُيُونِ
u'كِتَابٌ غُرَرٌ':Added, #1: 1	كِتَابِ الْغَايَةِ
u'كِتَابٌ غَرَرٌ':Added, #1: 1	كِتَابِ غُرَرِ
u'كِتَابٌ غَرِيبٌ':Added, #3: 3	كِتَابِ الْغَرَرِ
u'كِتَابٌ غَرِيبٌ':Added, #1: 1	كِتَابِ الْغَرِيبِ
u'كِتَابٌ غَصْبٌ':Added, #1: 1	كِتَابِ الْغَرِيبَيْنِ
u'كِتَابٌ غَصْبٌ':Added, #11: 11	كِتَابُ الْغَصْبِ
u'كِتَابٌ غَوَامِضُ':Added, #39: 39	كِتَابِ الْغَصْبِ
u'كِتَابٌ غير':Added, #2: 2	كِتَابِ الْغَوَامِضِ
u'كِتَابٌ غَيْرٌ':Added, #1: 1	كِتَابِ الْغَيْرِ
u'كِتَابٌ غير':Added, #1: 1	كِتَابِ الْغَيْرِ
u'كِتَابٌ غَيْرٌ':Added, #3: 3	كِتَابِ غَيْرِهِ
u'كِتَابٌ فَاتِحٌ':Added, #3: 3	كِتَابِ غَيْرِهِ
u'كِتَابٌ فَاتِحَةٌ':Added, #1: 1	كِتَابِ فَاتِحَةِ
u'كِتَابٌ فُتُوحٌ':Added, #1: 1	كِتَابِ فَاتِحَةِ
u'كِتَابٌ فَرَّاءٌ':Added, #2: 2	كِتَابِ الْفُتُوحِ
u'كِتَابٌ فَرَائِضُ':Added, #1: 1	كِتَابِ الْفَرَّاءِ
u'كِتَابٌ فَرَائِضُ':Added, #12: 12	كِتَابُ الْفَرَائِضِ
u'كِتَابٌ فَرَائِضُ':Added, #24: 24	كِتَابِ الْفَرَائِضِ
u'كِتَابٌ فِرْدَوْسٌ':Added, #2: 2	كِتَابَ الْفَرَائِضِ
u'كِتَابٌ فُرْقَانٌ':Added, #1: 1	كِتَابِ الْفِرْدَوْسِ
u'كِتَابٌ فُرُوعٌ':Added, #1: 1	كِتَابِ الْفُرْقَانِ
u'كِتَابٌ فُرُوقٌ':Added, #1: 1	كِتَابُ الْفُرُوعِ
u'كِتَابٌ فَرِيضَةٌ':Added, #2: 2	كِتَابِ الْفُرُوقِ
u'كِتَابٌ فساد':Added, #1: 1	كِتَابِ فَرِيضَةِ
u'كِتَابٌ فَسَادٌ':Added, #2: 2	كِتَابِ فَسَادِ
u'كِتَابٌ فَصْلٌ':Added, #2: 2	كِتَابِ فَسَادِ
u'كِتَابٌ فُصُولٌ':Added, #1: 1	كِتَابَ فَصْلِ
u'كِتَابٌ فَضَائِلُ':Added, #3: 3	كِتَابِ الْفُصُولِ
u'كِتَابٌ فَضَائِلُ':Added, #2: 2	كِتَابِ الْفَضَائِلِ
u'كِتَابٌ فَضْلٌ':Added, #5: 5	كِتَابِ فَضَائِلِ
u'كِتَابٌ فِقْهٌ':Added, #2: 2	كِتَابِ فَضْلِ
u'كِتَابٌ فِقْهٌ':Added, #1: 1	كِتَابُ الْفِقْهِ
u'كِتَابٌ فَقِيهٌ':Added, #7: 7	كِتَابِ فِقْهِ
u'كِتَابٌ فُكَاهَةٌ':Added, #3: 3	كِتَابِ الْفَقِيهِ
u'كِتَابٌ فُلاَنٌ':Added, #1: 1	كِتَابِ الْفُكَاهَةِ
u'كِتَابٌ فُلاَنٌ':Added, #13: 13	كِتَابَ فُلَانٍ
u'كِتَابٌ فلان':Added, #16: 16	كِتَابُ فُلَانٍ
u'كِتَابٌ فلان':Added, #1: 1	كِتَابِ الشَّافِعِيِّ
u'كِتَابٌ فلان':Added, #1: 1	كِتَابَ قَيْسٍ
u'كِتَابٌ فلان':Added, #2: 2	كِتَابِ التِّرْمِذِيِّ
u'كِتَابٌ فُلاَنٌ':Added, #2: 2	كِتَابَ السُّرْيَانِيَّةِ
u'كِتَابٌ فلان':Added, #2: 2	كِتَابُ فُلَانِ
u'كِتَابٌ فُلاَنٌ':Added, #3: 3	كِتَابِ الزّبَيْرِ
u'كِتَابٌ فَهْمٌ':Added, #4: 4	كِتَابِ فُلَانٍ
u'كِتَابٌ فَوَائِدُ':Added, #5: 5	كِتَابِ فَهْمِ
u'كِتَابٌ فَوَائِدُ':Added, #1: 1	كِتَابِ الْفَوَائِدِ
u'كِتَابٌ فَيْءٌ':Added, #2: 2	كِتَابِ فَوَائِدِ
u'كِتَابٌ فَيْصَلٌ':Added, #2: 2	كِتَابِ الْفَيْءِ
u'كِتَابٌ قَاطِعٌ':Added, #1: 1	كِتَابِ الْفَيْصَلِ
u'كِتَابٌ قَانُونٌ':Added, #2: 2	كِتَابُ قَاطِعِ
u'كِتَابٌ قُبُورٌ':Added, #2: 2	كِتَابِ قَانُونِ
u'كِتَابٌ قتال':Added, #2: 2	كِتَابِ الْقُبُورِ
u'كِتَابٌ قِتَالٌ':Added, #1: 1	كِتَابِ قِتَالِ
u'كِتَابٌ قَدَرٌ':Added, #1: 1	كِتَابِ قِتَالِ
u'كِتَابٌ قَدِيمٌ':Added, #1: 1	كِتَابِ الْقَدَرِ
u'كِتَابٌ قذف':Added, #11: 11	كِتَابِ الْقَدِيمِ
u'كِتَابٌ قذف':Added, #2: 2	كِتَابُ الْقَذْفِ
u'كِتَابٌ قَذْفٌ':Added, #2: 2	كِتَابِ الْقَذْفِ
u'كِتَابٌ قَذْفٌ':Added, #2: 2	كِتَابُ الْقَذْفِ
u'كِتَابٌ قِرَاءةٌ':Added, #2: 2	كِتَابِ الْقَذْفِ
u'كِتَابٌ قِرَاءةٌ':Added, #1: 1	كِتَابَ الْقِرَاءَاتِ
u'كِتَابٌ قراض':Added, #1: 1	كِتَابِ الْقِرَاءَةِ
u'كِتَابٌ قراض':Added, #4: 4	كِتَابُ الْقِرَاضِ
u'كِتَابٌ قُرْآنٌ':Added, #5: 5	كِتَابِ الْقِرَاضِ
u'كِتَابٌ قُرَّةٌ':Added, #1: 1	كِتَابِ الْقُرْآنِ
u'كِتَابٌ قُرْعَةٌ':Added, #1: 1	كِتَابُ قُرَّةِ
u'كِتَابٌ قَزْوِينِيّ':Added, #2: 2	كِتَابِ الْقُرْعَةِ
u'كِتَابٌ قَسام':Added, #1: 1	كِتَابِ الْقَزْوِينِيِّ
u'كِتَابٌ قَسام':Added, #1: 1	كِتَابُ الْقَسَامَةِ
u'كِتَابٌ قَسامَة':Added, #3: 3	كِتَابِ الْقَسَامَةِ
u'كِتَابٌ قَسامَة':Added, #1: 1	كِتَابُ الْقَسَامَةِ
u'كِتَابٌ قَسْمٌ':Added, #3: 3	كِتَابِ الْقَسَامَةِ
u'كِتَابٌ قَسْمٌ':Added, #13: 13	كِتَابِ الْقَسْمِ
u'كِتَابٌ قَسْمٌ':Added, #2: 2	كِتَابُ الْقَسْمِ
u'كِتَابٌ قَسْمٌ':Added, #5: 5	كِتَابُ قَسْمِ
u'كِتَابٌ قسمة':Added, #5: 5	كِتَابِ قَسْمِ
u'كِتَابٌ قِسْمَةٌ':Added, #1: 1	كِتَابُ قِسْمَةٍ
u'كِتَابٌ قسمة':Added, #1: 1	كِتَابُ قِسْمَةٍ
u'كِتَابٌ قِسْمَةٌ':Added, #2: 2	كِتَابَ الْقِسْمَةِ
u'كِتَابٌ قسمة':Added, #2: 2	كِتَابَ الْقِسْمَةِ
u'كِتَابٌ قِسْمَةٌ':Added, #35: 35	كِتَابِ الْقِسْمَةِ
u'كِتَابٌ قسمة':Added, #35: 35	كِتَابِ الْقِسْمَةِ
u'كِتَابٌ قِسْمَةٌ':Added, #8: 8	كِتَابُ الْقِسْمَةِ
u'كِتَابٌ قصاص':Added, #8: 8	كِتَابُ الْقِسْمَةِ
u'كِتَابٌ قِصَاصٌ':Added, #1: 1	كِتَابُ الْقِصَاصِ
u'كِتَابٌ قَضَاءٌ':Added, #1: 1	كِتَابُ الْقِصَاصِ
u'كِتَابٌ قَضَاءٌ':Added, #1: 1	كِتَابَ الْقَضَاءِ
u'كِتَابٌ قَضَاءٌ':Added, #81: 81	كِتَابِ الْقَضَاءِ
u'كِتَابٌ قضاة':Added, #8: 8	كِتَابُ الْقَضَاءِ
u'كِتَابٌ قَطْعٌ':Added, #3: 3	كِتَابِ الْقُضَاةِ
u'كِتَابٌ قطعان':Added, #2: 2	كِتَابِ الْقَطْعِ
u'كِتَابٌ قَفَّالٌ':Added, #1: 1	كِتَابِ الْقُطْعَانِ
u'كِتَابٌ قُنُوتٌ':Added, #4: 4	كِتَابِ الْقَفَّالِ
u'كِتَابٌ قُوتٌ':Added, #1: 1	كِتَابِ الْقُنُوتِ
u'كِتَابٌ قَوْلٌ':Added, #1: 1	كِتَابِ قُوتِ
u'كِتَابٌ قِيَاسٌ':Added, #1: 1	كِتَابِ الْقَوْلَيْنِ
u'كِتَابٌ قِيَاسٌ':Added, #1: 1	كِتَابُ الْقِيَاسِ
u'كِتَابٌ قَيْس':Added, #9: 9	كِتَابِ الْقِيَاسِ
u'كِتَابٌ كَاتِبٌ':Added, #1: 1	كِتَابَ قَيْسٍ
u'كِتَابٌ كَامِلٌ':Added, #1: 1	كِتَابُ كَاتِبٍ
u'كِتَابٌ كُتَّابٌ':Added, #2: 2	كِتَابِ الْكَامِلِ
u'كِتَابٌ كِتَابٌ':Added, #1: 1	كِتَابِ الْكُتّابِ
u'كِتَابٌ كِتَابَةٌ':Added, #1: 1	كِتَابِ الْكِتَابِ
u'كِتَابٌ كِتَابَةٌ':Added, #2: 2	كِتَابِ الْكِتَابَةِ
u'كِتَابٌ كِرَاءٌ':Added, #3: 3	كِتَابُ الْكِتَابَةِ
u'كِتَابٌ كُرَاعٌ':Added, #1: 1	كِتَابِ كِرَاءِ
u'كِتَابٌ كَرَاهَةٌ':Added, #1: 1	كِتَابِ كُرَاعٍ
u'كِتَابٌ كَرَاهِيَةٌ':Added, #2: 2	كِتَابِ الْكَرَاهَةِ
u'كِتَابٌ كَرَاهِيَةٌ':Added, #1: 1	كِتَابَ الْكَرَاهِيَةِ
u'كِتَابٌ كَرَاهِيَةٌ':Added, #4: 4	كِتَابُ الْكَرَاهِيَةِ
u'كِتَابٌ كَسْبٌ':Added, #9: 9	كِتَابِ الْكَرَاهِيَةِ
u'كِتَابٌ كَشْفٌ':Added, #4: 4	كِتَابِ الْكَسْبِ
u'كِتَابٌ كَفَّارٌ':Added, #1: 1	كِتَابِ كَشْفِ
u'كِتَابٌ كَفَّارٌ':Added, #1: 1	كِتَابُ الْكَفَّارَةِ
u'كِتَابٌ كَفَّارٌ':Added, #1: 1	كِتَابُ كَفَّارَةِ
u'كِتَابٌ كَفَّارٌ':Added, #2: 2	كِتَابُ الْكَفَّارَاتِ
u'كِتَابٌ كَفَّارَةٌ':Added, #9: 9	كِتَابِ الْكَفَّارَاتِ
u'كِتَابٌ كَفَّارَةٌ':Added, #1: 1	كِتَابُ الْكَفَّارَةِ
u'كِتَابٌ كَفَّارَةٌ':Added, #1: 1	كِتَابُ كَفَّارَةِ
u'كِتَابٌ كَفَّارَةٌ':Added, #2: 2	كِتَابُ الْكَفَّارَاتِ
u'كِتَابٌ كَفَالَةٌ':Added, #9: 9	كِتَابِ الْكَفَّارَاتِ
u'كِتَابٌ كَفَالَةٌ':Added, #1: 1	كِتَابَ الْكَفَالَةِ
u'كِتَابٌ كَفَالَةٌ':Added, #22: 22	كِتَابِ الْكَفَالَةِ
u'كِتَابٌ كِفَايَةٌ':Added, #6: 6	كِتَابُ الْكَفَالَةِ
u'كِتَابٌ لاَمِعٌ':Added, #2: 2	كِتَابِ الْكِفَايَةِ
u'كِتَابٌ لِبَاسٌ':Added, #1: 1	كِتَابِ اللَّامِعِ
u'كِتَابٌ لطائف':Added, #4: 4	كِتَابِ اللِّبَاسِ
u'كِتَابٌ لطائف':Added, #1: 1	كِتَابِ اللَّطَائِفِ
u'كِتَابٌ لعان':Added, #1: 1	كِتَابِ لَطَائِفِ
u'كِتَابٌ لعان':Added, #1: 1	كِتَاب اللِّعَانِ
u'كِتَابٌ لعان':Added, #4: 4	كِتَابُ اللِّعَانِ
u'كِتَابٌ لُغَةٌ':Added, #7: 7	كِتَابِ اللِّعَانِ
u'كِتَابٌ لقطة':Added, #1: 1	كِتَابِ لُغَةٍ
u'كِتَابٌ لقطة':Added, #10: 10	كِتَابُ اللُّقَطَةِ
u'كِتَابٌ لُقْطَةٌ':Added, #1: 1	كِتَابِ اللُّقْطَةِ
u'كِتَابٌ لقطة':Added, #1: 1	كِتَابِ اللُّقْطَةِ
u'كِتَابٌ لَقِيطٌ':Added, #4: 4	كِتَابِ اللُّقَطَةِ
u'كِتَابٌ لَقِيطٌ':Added, #10: 10	كِتَابُ اللَّقِيطِ
u'كِتَابٌ لمع':Added, #7: 7	كِتَابِ اللَّقِيطِ
u'كِتَابٌ لَوَاحِقُ':Added, #1: 1	كِتَابَ اللُّمَعِ
u'كِتَابٌ مَالِكٌ':Added, #1: 1	كِتَابِ اللَّوَاحِقِ
u'كِتَابٌ مُبَايَعَةٌ':Added, #1: 1	كِتَابِ مَالِكٍ
u'كِتَابٌ مُبَايَعَةٌ':Added, #1: 1	كِتَابَ مُبَايَعَةٍ
u'كِتَابٌ مُبْتَدِئٌ':Added, #1: 1	كِتَابُ مُبَايَعَةٍ
u'كِتَابٌ مَبْسُوطٌ':Added, #1: 1	كِتَابِ الْمُبْتَدِئِ
u'كِتَابٌ مُبِينٌ':Added, #1: 1	كِتَابِ الْمَبْسُوطِ
u'كِتَابٌ مُتَحَيِّرٌ':Added, #7: 7	كِتَابٍ مُبِينٍ
u'كِتَابٌ مَجَازٌ':Added, #1: 1	كِتَابِ الْمُتَحَيِّرَةِ
u'كِتَابٌ مُجَانَبَةٌ':Added, #5: 5	كِتَابِ الْمَجَازِ
u'كِتَابٌ مُجَرَّدٌ':Added, #1: 1	كِتَابِ الْمُجَانَبَةِ
u'كِتَابٌ مَجُوسٌ':Added, #3: 3	كِتَابِ الْمُجَرَّدِ
u'كِتَابٌ مَحَاضِرُ':Added, #1: 1	كِتَابِ الْمَجُوسِ
u'كِتَابٌ مَحَاضِرُ':Added, #1: 1	كِتَابُ الْمَحَاضِرِ
u'كِتَابٌ مَحْصُولٌ':Added, #1: 1	كِتَابِ الْمَحَاضِرِ
u'كِتَابٌ مُحَكَّمٌ':Added, #1: 1	كِتَابِ الْمَحْصُولِ
u'كِتَابٌ مُحْكَمٌ':Added, #1: 1	كِتَابُ الْمُحَكَّمِ
u'كِتَابٌ مُحَمَّدٌ':Added, #1: 1	كِتَابِ الْمُحْكَمِ
u'كِتَابٌ مُحَمَّدٌ':Added, #113: 113	كِتَابِ مُحَمَّدٍ
u'كِتَابٌ مُحَمَّدٌ':Added, #1: 1	كِتَابَ مُحَمَّدِ
u'كِتَابٌ مُحَمَّدٌ':Added, #1: 1	كِتَابُ مُحَمَّدٍ
u'كِتَابٌ مِحْنَةٌ':Added, #6: 6	كِتَابِ مُحَمَّدِ
u'كِتَابٌ مُحِيطٌ':Added, #1: 1	كِتَابِ الْمِحْنَةِ
u'كِتَابٌ مُخَالِفٌ':Added, #2: 2	كِتَابِ الْمُحِيطِ
u'كِتَابٌ مُخْتَصَرٌ':Added, #1: 1	كِتَابٍ مُخَالِفٍ
u'كِتَابٌ مَخْتُومٌ':Added, #3: 3	كِتَابِ مُخْتَصَرِ
u'كِتَابٌ مَدَارِكُ':Added, #1: 1	كِتَابٍ مَخْتُومٍ
u'كِتَابٌ مُدَبَّرٌ':Added, #1: 1	كِتَابِ الْمَدَارِكِ
u'كِتَابٌ مَدْخَلٌ':Added, #1: 1	كِتَابِ الْمُدَبَّرِ
u'كِتَابٌ مُذَاكَرَةٌ':Added, #8: 8	كِتَابِ الْمَدْخَلِ
u'كِتَابٌ مَذْهَبٌ':Added, #1: 1	كِتَابِ الْمُذَاكَرَةِ
u'كِتَابٌ مَذْهَبٌ':Added, #1: 1	كِتَابِ الْمَذْهَبِ
u'كِتَابٌ مراسيل':Added, #1: 1	كِتَابِ مَذْهَبِ
u'كِتَابٌ مَرَاسِيلُ':Added, #2: 2	كِتَابِ الْمَرَاسِيلِ
u'كِتَابٌ مُرْتَدٌّ':Added, #2: 2	كِتَابِ الْمَرَاسِيلِ
u'كِتَابٌ مَرْسُومٌ':Added, #1: 1	كِتَابِ الْمُرْتَدِّ
u'كِتَابٌ مُرْشِدٌ':Added, #1: 1	كِتَابٍ مَرْسُومٍ
u'كِتَابٌ مُسَابَقَةٌ':Added, #1: 1	كِتَابِ الْمُرْشِدِ
u'كِتَابٌ مُساقاة':Added, #2: 2	كِتَابُ الْمُسَابَقَةِ
u'كِتَابٌ مُساقاة':Added, #1: 1	كِتَابَ الْمُسَاقَاةِ
u'كِتَابٌ مُساقاة':Added, #1: 1	كِتَابِ الْمُسَاقَاةِ
u'كِتَابٌ مَسَائِلُ':Added, #9: 9	كِتَابُ الْمُسَاقَاةِ
u'كِتَابٌ مَسَائِلُ':Added, #1: 1	كِتَاب الْمَسَائِلِ
u'كِتَابٌ مُسْتَدْرِك':Added, #4: 4	كِتَابِ الْمَسَائِلِ
u'كِتَابٌ مُسْتَعَارٌ':Added, #1: 1	كِتَابِ الْمُسْتَدْرِكِ
u'كِتَابٌ مُسْتَقِلٌّ':Added, #1: 1	كِتَابٍ مُسْتَعَارٍ
u'كِتَابٌ مَسْتُورٌ':Added, #1: 1	كِتَابٍ مُسْتَقِلٍّ
u'كِتَابٌ مِسْعَرٌ':Added, #1: 1	كِتَابُ الْمَسْتُورَةِ
u'كِتَابٌ مُسْلِمٌ':Added, #1: 1	كِتَابَ مِسْعَرٍ
u'كِتَابٌ مُسْلِمٌ':Added, #19: 19	كِتَابِ مُسْلِمٍ
u'كِتَابٌ مُشْتَرَكٌ':Added, #1: 1	كِتَابِ مُسْلِمِ
u'كِتَابٌ مُشْكِلٌ':Added, #1: 1	كِتَابِ مُشْتَرَكٍ
u'كِتَابٌ مُشْكِلٌ':Added, #1: 1	كِتَابُ الْمُشْكِلَيْنِ
u'كِتَابٌ مُشْكِلٌ':Added, #1: 1	كِتَابِ مُشْكِلِ
u'كِتَابٌ مَشْهُورٌ':Added, #22: 22	كِتَابِ الْمُشْكِلَيْنِ
u'كِتَابٌ مَصَاحِفُ':Added, #2: 2	كِتَابٍ مَشْهُورٍ
u'كِتَابٌ مُصَحَّحٌ':Added, #1: 1	كِتَابِ الْمَصَاحِفِ
u'كِتَابٌ مُصَنِّفٌ':Added, #1: 1	كِتَابٍ مُصَحَّحٍ
u'كِتَابٌ مُصَنِّفٌ':Added, #1: 1	كِتَابَ الْمُصَنِّفِ
u'كِتَابٌ مُضَارَبَةٌ':Added, #1: 1	كِتَابِ الْمُصَنِّفِ
u'كِتَابٌ مُضَارَبَةٌ':Added, #16: 16	كِتَابِ الْمُضَارَبَةِ
u'كِتَابٌ مَطَرٌ':Added, #4: 4	كِتَابُ الْمُضَارَبَةِ
u'كِتَابٌ مَعَارِجُ':Added, #1: 1	كِتَابِ الْمَطَرِ
u'كِتَابٌ مَعَارِفُ':Added, #1: 1	كِتَابِ الْمَعَارِجِ
u'كِتَابٌ مَعَارِفُ':Added, #1: 1	كِتَابِ الْمَعَارِفِ
u'كِتَابٌ مَعَارِيضُ':Added, #2: 2	كِتَابِ مَعَارِفِ
u'كِتَابٌ مَعَاقِلُ':Added, #1: 1	كِتَابِ الْمَعَارِيضِ
u'كِتَابٌ مَعَاقِلُ':Added, #2: 2	كِتَابِ الْمَعَاقِلِ
u'كِتَابٌ مُعَامَلَةٌ':Added, #4: 4	كِتَابُ الْمَعَاقِلِ
u'كِتَابٌ مُعْتَمَدٌ':Added, #1: 1	كِتَاب الْمُعَامَلَةِ
u'كِتَابٌ مُعْتَمَدٌ':Added, #1: 1	كِتَابُ الْمُعْتَمَدِ
u'كِتَابٌ مُعْتَمَدٌ':Added, #2: 2	كِتَابٍ مُعْتَمَدٍ
u'كِتَابٌ مُعْجَمٌ':Added, #3: 3	كِتَابِ الْمُعْتَمَدِ
u'كِتَابٌ مُعْجَمٌ':Added, #5: 5	كِتَابِ الْمُعْجَمِ
u'كِتَابٌ مَعْرِفَةٌ':Added, #5: 5	كِتَابِ مُعْجَمِ
u'كِتَابٌ مَعْرِفَة':Added, #1: 1	كِتَابَ مَعْرِفَةِ
u'كِتَابٌ مَعْرِفَةٌ':Added, #1: 1	كِتَابَ مَعْرِفَةِ
u'كِتَابٌ مَعْرِفَة':Added, #3: 3	كِتَابِ الْمَعْرِفَةِ
u'كِتَابٌ مَعْرِفَةٌ':Added, #3: 3	كِتَابِ الْمَعْرِفَةِ
u'كِتَابٌ مَعْرِفَة':Added, #3: 3	كِتَابِ مَعْرِفَةِ
u'كِتَابٌ مَعْرُوفٌ':Added, #3: 3	كِتَابِ مَعْرِفَةِ
u'كِتَابٌ مُعَلَّمٌ':Added, #2: 2	كِتَابٍ مَعْرُوفٍ
u'كِتَابٌ مُعَلِّمٌ':Added, #1: 1	كِتَابِ الْمُعَلّمِ
u'كِتَابٌ مِعْيَارٌ':Added, #1: 1	كِتَابِ الْمُعَلّمِ
u'كِتَابٌ مُغارَسَة':Added, #2: 2	كِتَابِ مِعْيَارِ
u'كِتَابٌ مُغارَسَة':Added, #1: 1	كِتَابَ الْمُغَارَسَةِ
u'كِتَابٌ مُغارَسَة':Added, #1: 1	كِتَابُ الْمُغَارَسَةِ
u'كِتَابٌ مُفْصِحٌ':Added, #2: 2	كِتَابِ الْمُغَارَسَةِ
u'كِتَابٌ مَفْقُودٌ':Added, #1: 1	كِتَابٍ مُفْصِحٍ
u'كِتَابٌ مَفْقُودٌ':Added, #4: 4	كِتَابِ الْمَفْقُودِ
u'كِتَابٌ مَقَالٌ':Added, #6: 6	كِتَابُ الْمَفْقُودِ
u'كِتَابٌ مَقَالٌ':Added, #1: 1	كِتَابِ الْمَقَالَاتِ
u'كِتَابٌ مَقَالَةٌ':Added, #2: 2	كِتَابِ مَقَالَاتِ
u'كِتَابٌ مَقَالَةٌ':Added, #1: 1	كِتَابِ الْمَقَالَاتِ
u'كِتَابٌ مُقَدَّمٌ':Added, #2: 2	كِتَابِ مَقَالَاتِ
u'كِتَابٌ مُقَدِّمٌ':Added, #1: 1	كِتَابِ الْمُقَدّمَاتِ
u'كِتَابٌ مُقَدِّمَةٌ':Added, #1: 1	كِتَابِ الْمُقَدّمَاتِ
u'كِتَابٌ مُقْسِطٌ':Added, #1: 1	كِتَابِ الْمُقَدّمَاتِ
u'كِتَابٌ مَقْصِدٌ':Added, #3: 3	كِتَابِ الْمُقْسِطِ
u'كِتَابٌ مُقْنِعٌ':Added, #1: 1	كِتَابِ مَقْصِدِ
u'كِتَابٌ مُقْنِعٌ':Added, #1: 1	كِتَابَ الْمُقْنِعِ
u'كِتَابٌ مَكْنُونٌ':Added, #3: 3	كِتَابِ الْمُقْنِعِ
u'كِتَابٌ مَنَاسِكُ':Added, #3: 3	كِتَابٍ مَكْنُونٍ
u'كِتَابٌ مَنَاسِكُ':Added, #14: 14	كِتَابِ الْمَنَاسِكِ
u'كِتَابٌ مَنَاقِبُ':Added, #6: 6	كِتَابُ الْمَنَاسِكِ
u'كِتَابٌ مُنْتَخَبٌ':Added, #1: 1	كِتَابِ الْمَنَاقِبِ
u'كِتَابٌ مَنْثُورٌ':Added, #1: 1	كِتَابِ الْمُنْتَخَبِ
u'كِتَابٌ مِنْهَاجٌ':Added, #1: 1	كِتَابِ الْمَنْثُورِ
u'كِتَابٌ مُنْيَةٌ':Added, #1: 1	كِتَابِ مِنْهَاجِ
u'كِتَابٌ مُنِيرٌ':Added, #1: 1	كِتَابِ مُنْيَةِ
u'كِتَابٌ مُهَادَنَةٌ':Added, #1: 1	كِتَابٍ مُنِيرٍ
u'كِتَابٌ مُهَذَّبٌ':Added, #1: 1	كِتَابُ الْمُهَادَنَةِ
u'كِتَابٌ مُوَافِقٌ':Added, #1: 1	كِتَابِ الْمُهَذَّبِ
u'كِتَابٌ مُوَافَقَةٌ':Added, #3: 3	كِتَابِ الْمُوَافِقَاتِ
u'كِتَابٌ مَوَاقِيتُ':Added, #15: 15	كِتَابِ الْمُوَافَقَاتِ
u'كِتَابٌ مَوْتٌ':Added, #1: 1	كِتَابُ الْمَوَاقِيتِ
u'كِتَابٌ مُؤْتَلِفٌ':Added, #1: 1	كِتَابِ الْمَوْتِ
u'كِتَابٌ مَوْثُوقٌ':Added, #1: 1	كِتَابِ الْمُؤْتَلِفِ
u'كِتَابٌ مُوجِبٌ':Added, #4: 4	كِتَابٍ مَوْثُوقٍ
u'كِتَابٌ مُوَكِّلٌ':Added, #1: 1	كِتَابُ مُوجِبَاتِ
u'كِتَابٌ مَوْلِدٌ':Added, #1: 1	كِتَابُ الْمُوَكِّلِ
u'كِتَابٌ مِيزَابٌ':Added, #1: 1	كِتَابِ الْمَوْلِدِ
u'كِتَابٌ نَاسٌ':Added, #1: 1	كِتَابِ الْمِيزَابِ
u'كِتَابٌ نَاسِخٌ':Added, #1: 1	كِتَابَ النَّاسِ
u'كِتَابٌ نَاسِخ':Added, #2: 2	كِتَابِ النّاسِخِ
u'كِتَابٌ نَاسِخٌ':Added, #2: 2	كِتَابِ النّاسِخِ
u'كِتَابٌ نَاسِخ':Added, #3: 3	كِتَابِ النَّاسِخِ
u'كِتَابٌ نبات':Added, #3: 3	كِتَابِ النَّاسِخِ
u'كِتَابٌ نَبَاتٌ':Added, #4: 4	كِتَابِ النّبَاتِ
u'كِتَابٌ نُبُوَّةٌ':Added, #4: 4	كِتَابِ النّبَاتِ
u'كِتَابٌ نَبِيٌّ':Added, #1: 1	كِتَابِ النُّبُوَّاتِ
u'كِتَابٌ نَبِيٌّ':Added, #10: 10	كِتَابِ النَّبِيِّ
u'كِتَابٌ نَبِيٌّ':Added, #2: 2	كِتَابَ النَّبِيِّ
u'كِتَابٌ نَتَائِجُ':Added, #4: 4	كِتَابُ النَّبِيِّ
u'كِتَابٌ نذر':Added, #1: 1	كِتَابِ نَتَائِجِ
u'كِتَابٌ نَذْرٌ':Added, #2: 2	كِتَابُ النَّذْرِ
u'كِتَابٌ نذر':Added, #2: 2	كِتَابُ النَّذْرِ
u'كِتَابٌ نَذْرٌ':Added, #3: 3	كِتَابِ النَّذْرِ
u'كِتَابٌ نُذُورٌ':Added, #3: 3	كِتَابِ النَّذْرِ
u'كِتَابٌ نُذُورٌ':Added, #1: 1	كِتَابَ النُّذُورِ
u'كِتَابٌ نُذُورٌ':Added, #1: 1	كِتَابُ النُّذُورِ
u'كِتَابٌ نُذُورٌ':Added, #1: 1	كِتَابِ النّذُورِ
u'كِتَابٌ نِساءٌ':Added, #3: 3	كِتَابِ النُّذُورِ
u'كِتَابٌ نِساءٌ':Added, #1: 1	كِتَابِ النِّسَاءِ
u'كِتَابٌ نَسَبٌ':Added, #3: 3	كِتَابِ النّسَاءِ
u'كِتَابٌ نَصِيحٌ':Added, #3: 3	كِتَابِ النَّسَبِ
u'كِتَابٌ نَصِيحَةٌ':Added, #2: 2	كِتَابِ النَّصِيحَةِ
u'كِتَابٌ نَظْمٌ':Added, #2: 2	كِتَابِ النَّصِيحَةِ
u'كِتَابٌ نَفَقَةٌ':Added, #1: 1	كِتَابِ نَظْمِ
u'كِتَابٌ نَفَقَةٌ':Added, #1: 1	كِتَابُ النَّفَقَةِ
u'كِتَابٌ نَفَقَةٌ':Added, #1: 1	كِتَابِ النَّفَقَةِ
u'كِتَابٌ نَفَقَةٌ':Added, #25: 25	كِتَابِ النَّفَقَاتِ
u'كِتَابٌ نَفْيٌ':Added, #8: 8	كِتَابُ النَّفَقَاتِ
u'كِتَابٌ نَقْدٌ':Added, #1: 1	كِتَابِ نَفْيِ
u'كِتَابٌ نَقْد':Added, #1: 1	كِتَابِ نَقْدِ
u'كِتَابٌ نَقْضٌ':Added, #1: 1	كِتَابِ نَقْدِ
u'كِتَابٌ نقل':Added, #1: 1	كِتَابِ نَقْضِ
u'كِتَابٌ نَقْلٌ':Added, #1: 1	كِتَابَ نَقْلِ
u'كِتَابٌ نكاح':Added, #1: 1	كِتَابَ نَقْلِ
u'كِتَابٌ نِكَاحٌ':Added, #116: 116	كِتَابِ النِّكَاحِ
u'كِتَابٌ نكاح':Added, #116: 116	كِتَابِ النِّكَاحِ
u'كِتَابٌ نِكَاحٌ':Added, #16: 16	كِتَابُ النِّكَاحِ
u'كِتَابٌ نكاح':Added, #16: 16	كِتَابُ النِّكَاحِ
u'كِتَابٌ نكاح':Added, #1: 1	كِتَاب النِّكَاحِ
u'كِتَابٌ نِكَاحٌ':Added, #1: 1	كِتَابِ النّكَاحِ
u'كِتَابٌ نِكَاحٌ':Added, #1: 1	كِتَاب النِّكَاحِ
u'كِتَابٌ نُكَتٌ':Added, #1: 1	كِتَابِ النّكَاحِ
u'كِتَابٌ نُكَتٌ':Added, #1: 1	كِتَابِ نُكَتِ
u'كِتَابٌ نِهَايَةٌ':Added, #5: 5	كِتَابِ النُّكَتِ
u'كِتَابٌ نَوَادِرُ':Added, #2: 2	كِتَابِ النِّهَايَةِ
u'كِتَابٌ نَوَادِرُ':Added, #1: 1	كِتَابُ نَوَادِرِ
u'كِتَابٌ نُورٌ':Added, #1: 1	كِتَابِ نَوَادِرِ
u'كِتَابٌ نُورٌ':Added, #1: 1	كِتَابِ النُّورِ
u'كِتَابٌ هِبَاتٌ':Added, #3: 3	كِتَابِ نُورِ
u'كِتَابٌ هِبَةٌ':Added, #5: 5	كِتَابِ الْهِبَاتِ
u'كِتَابٌ هِبَةٌ':Added, #1: 1	كِتَابَ الْهِبَةِ
u'كِتَابٌ هِبَةٌ':Added, #36: 36	كِتَابِ الْهِبَةِ
u'كِتَابٌ هِدَايَةٌ':Added, #9: 9	كِتَابُ الْهِبَةِ
u'كِتَابٌ هُدْنَةٌ':Added, #2: 2	كِتَابَ الْهِدَايَةِ
u'كِتَابٌ هَدْيٌ':Added, #1: 1	كِتَابِ الْهُدْنَةِ
u'كِتَابٌ هشام':Added, #19: 19	كِتَابِ الْهَدْيِ
u'كِتَابٌ هِشَامٌ':Added, #1: 1	كِتَابَ هِشَامٍ
u'كِتَابٌ هِلاَلٌ':Added, #1: 1	كِتَابَ هِشَامٍ
u'كِتَابٌ واحد':Added, #1: 1	كِتَابِ هِلَالٍ
u'كِتَابٌ وَاحِدٌ':Added, #2: 2	كِتَابٍ وَاحِدٍ
u'كِتَابٌ وَاقِعٌ':Added, #2: 2	كِتَابٍ وَاحِدٍ
u'كِتَابٌ وَاقِفٌ':Added, #1: 1	كِتَابِ الْوَاقِعَاتِ
u'كِتَابٌ وَجْهٌ':Added, #1: 1	كِتَابِ الْوَاقِفِ
u'كِتَابٌ وَجِيزٌ':Added, #2: 2	كِتَابِ الْوَجْهَيْنِ
u'كِتَابٌ ودائع':Added, #1: 1	كِتَابِ الْوَجِيزِ
u'كِتَابٌ وَدَائِعُ':Added, #5: 5	كِتَابِ الْوَدَائِعِ
u'كِتَابٌ وَدِيعٌ':Added, #5: 5	كِتَابِ الْوَدَائِعِ
u'كِتَابٌ وَدِيعٌ':Added, #14: 14	كِتَابِ الْوَدِيعَةِ
u'كِتَابٌ وَدِيعَةٌ':Added, #9: 9	كِتَابُ الْوَدِيعَةِ
u'كِتَابٌ وَدِيعَةٌ':Added, #14: 14	كِتَابِ الْوَدِيعَةِ
u'كِتَابٌ وَرَعٌ':Added, #9: 9	كِتَابُ الْوَدِيعَةِ
u'كِتَابٌ وَسَائِلُ':Added, #4: 4	كِتَابِ الْوَرَعِ
u'كِتَابٌ وِصَايَةٌ':Added, #2: 2	كِتَابِ وَسَائِلِ
u'كِتَابٌ وَصْفٌ':Added, #1: 1	كِتَابِ الْوِصَايَةِ
u'كِتَابٌ وَصِيٌّ':Added, #1: 1	كِتَابِ الْوَصْفِ
u'كِتَابٌ وَصِيٌّ':Added, #12: 12	كِتَابِ الْوَصِيَّةِ
u'كِتَابٌ وَصِيٌّ':Added, #1: 1	كِتَابُ الْوَصِيَّةِ
u'كِتَابٌ وَصِيٌّ':Added, #1: 1	كِتَابُ وَصِيَّةٍ
u'كِتَابٌ وَصِيٌّ':Added, #1: 1	كِتَابِ وَصِيَّةِ
u'كِتَابٌ وَصِيٌّ':Added, #1: 1	كِتَابُ وَصِيَّتِهِ
u'كِتَابٌ وَصِيٌّ':Added, #2: 2	كِتَابَ الْوَصِيَّةِ
u'كِتَابٌ وَصِيَّةٌ':Added, #3: 3	كِتَابِ وَصِيَّتِهِ
u'كِتَابٌ وَصِيَّةٌ':Added, #12: 12	كِتَابِ الْوَصِيَّةِ
u'كِتَابٌ وَصِيَّةٌ':Added, #1: 1	كِتَابُ الْوَصِيَّةِ
u'كِتَابٌ وَصِيَّةٌ':Added, #1: 1	كِتَابُ وَصِيَّةٍ
u'كِتَابٌ وَصِيَّةٌ':Added, #1: 1	كِتَابِ وَصِيَّةِ
u'كِتَابٌ وَصِيَّةٌ':Added, #1: 1	كِتَابُ وَصِيَّتِهِ
u'كِتَابٌ وَصِيَّةٌ':Added, #2: 2	كِتَابَ الْوَصِيَّةِ
u'كِتَابٌ وُضُوءٌ':Added, #3: 3	كِتَابِ وَصِيَّتِهِ
u'كِتَابٌ وَعْظٌ':Added, #1: 1	كِتَابِ الْوُضُوءِ
u'كِتَابٌ وَعْظٌ':Added, #1: 1	كِتَابِ الْوَعْظِ
u'كِتَابٌ وَقَارٌ':Added, #1: 1	كِتَابَ وَعْظٍ
u'كِتَابٌ وَقْفٌ':Added, #1: 1	كِتَابِ الْوَقَارِ
u'كِتَابٌ وَقْفٌ':Added, #13: 13	كِتَابُ الْوَقْفِ
u'كِتَابٌ وَقْفٌ':Added, #1: 1	كِتَابَ وَقْفِ
u'كِتَابٌ وَقْفٌ':Added, #1: 1	كِتَابُ وَقْفٍ
u'كِتَابٌ وَقْفٌ':Added, #2: 2	كِتَابَ الْوَقْفِ
u'كِتَابٌ وَقْفٌ':Added, #4: 4	كِتَابِ وَقْفٍ
u'كِتَابٌ وَقْفٌ':Added, #77: 77	كِتَابِ الْوَقْفِ
u'كِتَابٌ وُقُوفٌ':Added, #9: 9	كِتَابِ وَقْفِهِ
u'كِتَابٌ وِكَالَةٌ':Added, #1: 1	كِتَابِ الْوُقُوفِ
u'كِتَابٌ وَلاَءٌ':Added, #1: 1	كِتَابِ الْوِكَالَةِ
u'كِتَابٌ وَلاَءٌ':Added, #16: 16	كِتَابِ الْوَلَاءِ
u'كِتَابٌ وَلاَءٌ':Added, #1: 1	كِتَابِ الْوَلاَءِ
u'كِتَابٌ وَلاَءٌ':Added, #3: 3	كِتَابَ الْوَلَاءِ
u'كِتَابٌ وَلِيٌّ':Added, #5: 5	كِتَابُ الْوَلَاءِ
u'كِتَابٌ وَلِيدٌ':Added, #1: 1	كِتَابَ الْوَلِيِّ
u'كِتَابٌ وَلِيمَةٌ':Added, #1: 1	كِتَابِ الْوَلِيدِ
u'كِتَابٌ وَلِيمَةٌ':Added, #2: 2	كِتَابُ الْوَلِيمَةِ
u'كِتَابٌ وَهْمٌ':Added, #2: 2	كِتَابِ الْوَلِيمَةِ
u'كِتَابٌ يَاقُوتٌ':Added, #2: 2	كِتَابِ الْوَهْمِ
u'كِتَابٌ يَتِيمٌ':Added, #1: 1	كِتَابِ الْيَاقُوتِ
u'كِتَابٌ يهود':Added, #1: 1	كِتَابِ الْيَتِيمَةِ
u'كِتَابٌ يَهُودٌ':Added, #1: 1	كِتَابَ الْيَهُودِ
u'كُتُبٌ إِبِلٌ':Added, #1: 1	كِتَابَ الْيَهُودِ
u'كَتَبَ اِبْنٌ':Subject, #1: 1	كُتُبِ الْإِبِلِ
u'كُتُبٌ اِبْنٌ':Added, #6: 6	كَتَبَ ابْنُ
u'كُتُبٌ اِبْنٌ':Added, #1: 1	كُتُبُ ابْنِ
u'كُتُبٌ اِبْنٌ':Added, #2: 2	كُتُبَ ابْنِ
u'كَتَبَ إجَازَةٌ':Predicate, #3: 3	كُتُبِ ابْنِ
u'كُتُبٌ أَحادِيثُ':Added, #1: 1	كَتَبَ الْإِجَازَةَ
u'كَتَبَ أحَدٌ':Predicate, #2: 2	كُتُبِ الْأَحَادِيثِ
u'كَتَبَ إحْسَانٌ':Predicate, #1: 1	كَتَبَ أَحَدَ
u'كَتَبَ إحْسَانٌ':Predicate, #6: 6	كَتَبَ الإِحْسَانَ
u'كُتُبٌ أَحْكَامٌ':Added, #8: 8	كَتَبَ الْإِحْسَانَ
u'كُتُبٌ أخْبَارٌ':Added, #1: 1	كُتُبِ الْأَحْكَامِ
u'كُتُبٌ أَخْبَارٌ':Added, #1: 1	كُتُبِ الْأَخْبَارِ
u'كُتُبٌ أدَب':Added, #1: 1	كُتُبِ الْأَخْبَارِ
u'كَتَبَ آدَمُ':Predicate, #3: 3	كُتُبِ الْأَدَبِ
u'كَتَبَ اِسْمٌ':Predicate, #1: 1	كَتَبَ آدَمَ
u'كَتَبَ أَسْماءٌ':Predicate, #5: 5	كَتَبَ اسْمَ
u'كُتُبٌ أَشْرِبَةٌ':Added, #2: 2	كَتَبَ الْأَسْمَاءَ
u'كُتُبٌ أَصْحَابٌ':Added, #1: 1	كُتُبِ الْأَشْرِبَةِ
u'كُتُبٌ أَصْحَابٌ':Added, #15: 15	كُتُبِ الْأَصْحَابِ
u'كُتُبٌ أَصْحَابٌ':Added, #1: 1	كُتُبِ أَصْحَابِهِ
u'كُتُبٌ أَصْحَابٌ':Added, #2: 2	كُتُبِ أَصْحَابِ
u'كُتُبٌ أَصْحَابٌ':Added, #2: 2	كُتُبَ الْأَصْحَابِ
u'كُتُبٌ أُصولٌ':Added, #2: 2	كُتُبُ الْأَصْحَابِ
u'كُتُبٌ أُصولٌ':Added, #1: 1	كُتُبَ الْأُصُولِ
u'كُتُبٌ أُصولٌ':Added, #5: 5	كُتُبِ أُصُولِ
u'كُتُبٌ أكابر':Added, #81: 81	كُتُبِ الْأُصُولِ
u'كُتُبٌ أُمٌّ':Added, #1: 1	كُتُبِ الْأَكَابِرِ
u'كُتُبٌ إمَامٌ':Added, #2: 2	كُتُبِ الْأُمِّ
u'كُتُبٌ أهْلٌ':Added, #1: 1	كُتُبِ الْإِمَامِ
u'كُتُبٌ أَوْقَافٌ':Added, #3: 3	كُتُبِ أَهْلِ
u'كُتُبٌ أَوْقَافٌ':Added, #16: 16	كُتُبِ الْأَوْقَافِ
u'كُتُبٌ أَوْقَافٌ':Added, #1: 1	كُتُبُ الْأَوْقَافِ
u'كَتَبَ أَوَّلُ':Predicate, #2: 2	كُتُبَ الْأَوْقَافِ
u'كُتُبٌ آيٌ':Added, #1: 1	كَتَبَ الْأَوَّلَ
u'كُتُبٌ أئِمَّةٌ':Added, #1: 1	كُتُبِ الْآيِ
u'كَتَبَ آيَةٌ':Predicate, #3: 3	كُتُبِ الْأَئِمَّةِ
u'كَتَبَ إيمَانٌ':Predicate, #1: 1	كَتَبَ الآيَةَ
u'كُتُبٌ أَيْمَانٌ':Added, #1: 1	كَتَبَ الْإِيمَانَ
u'كَتَبَ بَاعٌ':Predicate, #1: 1	كُتُبِ الْأَيْمَانِ
u'كُتُبٌ بِدَعٌ':Added, #1: 1	كَتَبَ بَاعَ
u'كَتَبَ بَعْضٌ':Subject, #2: 2	كُتُبُ بِدَعٍ
u'كُتُبٌ بَعْضٌ':Added, #2: 2	كَتَبَ بَعْضُ
u'كَتَبَ بَغْلٌ':Predicate, #2: 2	كُتُبِ بَعْضِ
u'كَتَبَ بَيْنٌ':Predicate, #1: 1	كَتَبَ الْبَغْلَةَ
u'كُتُبٌ تَارِيخٌ':Added, #3: 3	كَتَبَ بَيْنَ
u'كُتُبٌ تَفَاسِيرُ':Added, #2: 2	كُتُبِ التّارِيخِ
u'كَتَبَ تَفْسِيرٌ':Predicate, #2: 2	كُتُبِ التّفَاسِيرِ
u'كُتُبٌ تَفْسِيرٌ':Added, #1: 1	كَتَبَ تَفْسِيرَ
u'كُتُبٌ تَفْسِيرٌ':Added, #1: 1	كُتُبَ التَّفْسِيرِ
u'كُتُبٌ تَفْسِيرٌ':Added, #1: 1	كُتُبِ التّفْسِيرِ
u'كُتُبٌ تَفْسِيرٌ':Added, #1: 1	كُتُبُ تَفْسِيرٍ
u'كُتُبٌ تَفْسِيرٌ':Added, #2: 2	كُتُبُ التَّفْسِيرِ
u'كُتُبٌ تَوَارِيخُ':Added, #9: 9	كُتُبِ التَّفْسِيرِ
u'كُتُبٌ تَوَارِيخُ':Added, #1: 1	كُتُبَ التَّوَارِيخِ
u'كَتَبَ تَوْرَاةٌ':Predicate, #2: 2	كُتُبِ التَّوَارِيخِ
u'كُتُبٌ تَوْرَاةٌ':Added, #1: 1	كَتَبَ التَّوْرَاةَ
u'كَتَبَ جَوَابٌ':Predicate, #2: 2	كُتُبِ التَّوْرَاةِ
u'كُتُبٌ حاجٌّ':Added, #3: 3	كَتَبَ الْجَوَابَ
u'كُتُبٌ حارِثٌ':Added, #1: 1	كُتُبِ الْحَاجِّ
u'كَتَبَ حاطِبٌ':Subject, #1: 1	كُتُبِ الْحَارِثِ
u'كَتَبَ حاكِمٌ':Subject, #2: 2	كَتَبَ حَاطِبُ
u'كَتَبَ حالَةٌ':Predicate, #2: 2	كَتَبَ الْحَاكِمُ
u'كُتُبٌ حُجَّاجٌ':Added, #1: 1	كَتَبَ حَالَةَ
u'كَتَبَ حَديثٌ':Predicate, #1: 1	كُتُبِ الْحُجَّاجِ
u'كُتُبٌ حَديثٌ':Added, #2: 2	كَتَبَ الْحَدِيثَ
u'كُتُبٌ حَديثٌ':Added, #1: 1	كُتُبِ الْحَدِيْثِ
u'كُتُبٌ حَديثٌ':Added, #1: 1	كُتُبَ حَدِيثٍ
u'كُتُبٌ حَديثٌ':Added, #3: 3	كُتُبُ الْحَدِيثِ
u'كُتُبٌ حَديثٌ':Added, #4: 4	كُتُبَ الْحَدِيثِ
u'كَتَبَ حَسَنٌ':Subject, #76: 76	كُتُبِ الْحَدِيثِ
u'كَتَبَ حَضَرٌ':Predicate, #1: 1	كَتَبَ الْحَسَنُ
u'كَتَبَ حَكَمٌ':Subject, #1: 1	كَتَبَ حَضَرَ
u'كَتَبَ حِلْيَةٌ':Predicate, #1: 1	كَتَبَ الْحَكَمُ
u'كُتُبٌ حَنَفِيَّةٌ':Added, #1: 1	كَتَبَ الْحِلْيَةَ
u'كُتُبٌ حَنَفِيَّةٌ':Added, #17: 17	كُتُبِ الْحَنَفِيَّةِ
u'كَتَبَ حَوائِجُ':Predicate, #1: 1	كُتُبَ الْحَنَفِيَّةِ
u'كَتَبَ خَالِدٌ':Subject, #1: 1	كَتَبَ الْحَوَائِجَ
u'كَتَبَ خَطٌّ':Predicate, #2: 2	كَتَبَ خَالِدُ
u'كُتُبٌ خِلاَفٌ':Added, #2: 2	كَتَبَ الْخَطَّ
u'كَتَبَ خَلِيفَةٌ':Subject, #57: 57	كُتُبِ الْخِلَافِ
u'كَتَبَ ذكر':Predicate, #2: 2	كَتَبَ الْخَلِيفَةُ
u'كَتَبَ ذِكْرٌ':Predicate, #2: 2	كَتَبَ ذِكْرَ
u'كُتُبٌ ذكر':Added, #2: 2	كَتَبَ ذِكْرَ
u'كُتُبٌ ذِكْرٌ':Added, #1: 1	كُتُبِ الذِّكْرِ
u'كُتُبٌ ذكر':Added, #1: 1	كُتُبِ الذِّكْرِ
u'كُتُبٌ ذِكْرٌ':Added, #1: 1	كُتُبِ ذِكْرِ
u'كَتَبَ رابع':Subject, #1: 1	كُتُبِ ذِكْرِ
u'كَتَبَ رَابِعٌ':Subject, #1: 1	كَتَبَ الرَّابِعَةُ
u'كَتَبَ رَاجِعٌ':Subject, #1: 1	كَتَبَ الرَّابِعَةُ
u'كُتُبٌ رَأْيٌ':Added, #1: 1	كَتَبَ رَاجِعٌ
u'كَتَبَ رَبُّ':Subject, #2: 2	كُتُبَ الرَّأْيِ
u'كَتَبَ رَبِيعٌ':Subject, #1: 1	كَتَبَ رَبُّ
u'كُتُبٌ رِجَالٌ':Added, #1: 1	كَتَبَ الرَّبِيعُ
u'كَتَبَ رَجُلٌ':Subject, #1: 1	كُتُبِ الرِّجَالِ
u'كَتَبَ رَجُلٌ':Subject, #3: 3	كَتَبَ الرَّجُلُ
u'كَتَبَ رَسُولٌ':Subject, #6: 6	كَتَبَ رَجُلٌ
u'كُتُبٌ رَسُولٌ':Added, #22: 22	كَتَبَ رَسُولُ
u'كَتَبَ رَشيدٌ':Subject, #1: 1	كُتُبُ رَسُولِ
u'كَتَبَ رِقٌّ':Predicate, #1: 1	كَتَبَ الرَّشِيدُ
u'كَتَبَ رِقاعٌ':Predicate, #1: 1	كَتَبَ الرِّقَّ
u'كَتَبَ رَمْلِيٌّ':Subject, #1: 1	كَتَبَ الرِّقَاعَ
u'كُتُبٌ زَنْدَقَةٌ':Added, #2: 2	كَتَبَ الرَّمْلِيُّ
u'كُتُبٌ زَنْدَقَةٌ':Added, #1: 1	كُتُبَ الزَّنْدَقَةِ
u'كُتُبٌ زَنْدَقَةٌ':Added, #1: 1	كُتُبِ الزَّنْدَقَةِ
u'كَتَبَ زَيْدٌ':Subject, #1: 1	كُتُبِ زَنْدَقَةٍ
u'كَتَبَ زَيْدٌ':Subject, #1: 1	كَتَبَ زَيْدٌ
u'كَتَبَ سَائِرٌ':Predicate, #2: 2	كَتَبَ زَيْدُ
u'كُتُبٌ سَائِرٌ':Added, #1: 1	كَتَبَ سَائِرَ
u'كُتُبٌ سَبْعَةٌ':Added, #1: 1	كُتُبِ سَائِرِ
u'كُتُبٌ سِحْرٌ':Added, #1: 1	كُتُبٍ سَبْعَةٍ
u'كُتُبٌ سَعْدٌ':Added, #1: 1	كُتُبِ السِّحْرِ
u'كُتُبٌ سَعْدٌ':Added, #1: 1	كُتُبِ سَعْدٍ
u'كُتُبٌ سَعِيدٌ':Added, #3: 3	كُتُبِ سَعْدِ
u'كَتَبَ سُلْطَانٌ':Subject, #2: 2	كُتُبِ سَعِيدِ
u'كُتُبٌ سَلَفٌ':Added, #1: 1	كَتَبَ السُّلْطَانُ
u'كُتُبٌ سَلَفٌ':Added, #1: 1	كُتُبَ السَّلَفِ
u'كُتُبٌ سَمَاعٌ':Added, #1: 1	كُتُبِ السَّلَفِ
u'كُتُبٌ سُنَّةٌ':Added, #1: 1	كُتُبِ السَّمَاعِ
u'كُتُبٌ سنن':Added, #1: 1	كُتُبِ السُّنَّةِ
u'كُتُبٌ شافِع':Added, #3: 3	كُتُبِ السُّنَنِ
u'كَتَبَ شافِعِيّ':Subject, #30: 30	كُتُبِ الشَّافِعِيَّةِ
u'كُتُبٌ شافِعِيّ':Added, #1: 1	كَتَبَ الشَّافِعِيُّ
u'كُتُبٌ شافِعِيّ':Added, #1: 1	كُتُبُ الشَّافِعِيِّ
u'كُتُبٌ شافِعِيّ':Added, #2: 2	كُتُبِ الشَّافِعِيِّ
u'كُتُبٌ شَرْحٌ':Added, #30: 30	كُتُبِ الشَّافِعِيَّةِ
u'كُتُبٌ شَرْعٌ':Added, #1: 1	كُتُبِ شَرْحِ
u'كُتُبٌ شَرِيعَةٌ':Added, #1: 1	كُتُبِ الشَّرْعِ
u'كُتُبٌ شَرِيعَةٌ':Added, #1: 1	كُتُبَ الشَّرِيعَةِ
u'كَتَبَ شَطْرٌ':Predicate, #5: 5	كُتُبِ الشَّرِيعَةِ
u'كُتُبٌ شِعْرٌ':Added, #1: 1	كَتَبَ شَطْرَ
u'كَتَبَ شَهَادَةٌ':Predicate, #1: 1	كُتُبِ الشِّعْرِ
u'كَتَبَ شَيْخٌ':Subject, #7: 7	كَتَبَ الشَّهَادَةَ
u'كُتُبٌ شَيْخٌ':Added, #2: 2	كَتَبَ الشَّيْخُ
u'كُتُبٌ شِيعَةٌ':Added, #4: 4	كُتُبِ الشَّيْخَيْنِ
u'كَتَبَ صَاحِبٌ':Subject, #1: 1	كُتُبِ الشِّيعَةِ
u'كُتُبٌ صَحَابَةٌ':Added, #1: 1	كَتَبَ صَاحِبُهُ
u'كَتَبَ صَحِيحٌ':Subject, #1: 1	كُتُبِ الصَّحَابَةِ
u'كُتُبٌ صَحِيحٌ':Added, #2: 2	كَتَبَ الصَّحِيحُ
u'كَتَبَ صدقة':Predicate, #1: 1	كُتُبِ الصَّحِيحِ
u'كَتَبَ صَدَقَةٌ':Predicate, #1: 1	كَتَبَ الصَّدَقَةَ
u'كُتُبٌ صَدَقَةٌ':Added, #1: 1	كَتَبَ الصَّدَقَةَ
u'كُتُبٌ صَدَقَةٌ':Added, #1: 1	كُتُبَ الصَّدَقَاتِ
u'كَتَبَ صَرِيحٌ':Predicate, #2: 2	كُتُبُ الصَّدَقَاتِ
u'كَتَبَ صَرِيحٌ':Predicate, #1: 1	كَتَبَ الصَّرِيحَ
u'كَتَبَ صَكٌّ':Predicate, #3: 3	كَتَبَ صَرِيحَ
u'كَتَبَ صَكٌّ':Predicate, #2: 2	كَتَبَ صَكَّ
u'كَتَبَ صلح':Predicate, #4: 4	كَتَبَ الصَّكَّ
u'كَتَبَ صُلْحٌ':Predicate, #1: 1	كَتَبَ الصُّلْحَ
u'كَتَبَ صَوَابٌ':Predicate, #1: 1	كَتَبَ الصُّلْحَ
u'كُتُبٌ طِبٌّ':Added, #1: 1	كَتَبَ صَوَابَ
u'كُتُبٌ طِبٌّ':Added, #1: 1	كُتُبُ الطِّبِّ
u'كُتُبٌ طَرِيقٌ':Added, #7: 7	كُتُبِ الطِّبِّ
u'كَتَبَ طَلاَقٌ':Predicate, #1: 1	كُتُبِ الطَّرِيقَيْنِ
u'كَتَبَ طَلاَقٌ':Predicate, #3: 3	كَتَبَ طَلَاقَ
u'كُتُبٌ طَلاَقٌ':Added, #6: 6	كَتَبَ الطَّلَاقَ
u'كُتُبٌ ظاهِر':Added, #2: 2	كُتُبِ الطَّلَاقِ
u'كُتُبٌ ظاهِرٌ':Added, #1: 1	كُتُبِ الظَّاهِرِيَّةِ
u'كُتُبٌ ظاهِرَة':Added, #9: 9	كُتُبِ ظَاهِرِ
u'كُتُبٌ ظاهِرِيّ':Added, #1: 1	كُتُبِ الظَّاهِرِيَّةِ
u'كُتُبٌ عَامٌّ':Added, #1: 1	كُتُبِ الظَّاهِرِيَّةِ
u'كَتَبَ عَامِلٌ':Subject, #1: 1	كُتُبِ الْعَامَّةِ
u'كَتَبَ عَبْدٌ':Subject, #1: 1	كَتَبَ عَامِلٌ
u'كُتُبٌ عَبْدٌ':Added, #3: 3	كَتَبَ عَبْدُ
u'كُتُبٌ عَرَبِيٌّ':Added, #1: 1	كُتُبِ عَبْدِ
u'كُتُبٌ عَقَائِدُ':Added, #3: 3	كُتُبِ الْعَرَبِيَّةِ
u'كَتَبَ عَقِيبٌ':Predicate, #1: 1	كُتُبِ الْعَقَائِدِ
u'كُتُبٌ علم':Added, #1: 1	كَتَبَ عَقِيبَ
u'كُتُبٌ عِلْمٌ':Added, #12: 12	كُتُبُ الْعِلْمِ
u'كُتُبٌ علم':Added, #12: 12	كُتُبُ الْعِلْمِ
u'كُتُبٌ عِلْمٌ':Added, #1: 1	كُتُبَ عِلْمِ
u'كُتُبٌ علم':Added, #1: 1	كُتُبَ عِلْمِ
u'كُتُبٌ عِلْمٌ':Added, #20: 20	كُتُبِ الْعِلْمِ
u'كُتُبٌ علم':Added, #20: 20	كُتُبِ الْعِلْمِ
u'كُتُبٌ عِلْمٌ':Added, #2: 2	كُتُبَ الْعِلْمِ
u'كُتُبٌ علم':Added, #2: 2	كُتُبَ الْعِلْمِ
u'كُتُبٌ عِلْمٌ':Added, #2: 2	كُتُبَ عِلْمٍ
u'كُتُبٌ علماء':Added, #2: 2	كُتُبَ عِلْمٍ
u'كُتُبٌ عُلَمَاءُ':Added, #1: 1	كُتُبِ الْعُلَمَاءِ
u'كُتُبٌ علماء':Added, #1: 1	كُتُبِ الْعُلَمَاءِ
u'كُتُبٌ عُلَمَاءُ':Added, #2: 2	كُتُبُ الْعُلَمَاءِ
u'كُتُبٌ علماء':Added, #2: 2	كُتُبُ الْعُلَمَاءِ
u'كُتُبٌ عُلَمَاءُ':Added, #3: 3	كُتُبَ الْعُلَمَاءِ
u'كُتُبٌ عُلُومٌ':Added, #3: 3	كُتُبَ الْعُلَمَاءِ
u'كُتُبٌ عُلُومٌ':Added, #1: 1	كُتُبِ عُلُومٍ
u'كُتُبٌ عُلُومٌ':Added, #1: 1	كُتُبِ عُلُومِ
u'كَتَبَ عَلِيٌّ':Subject, #2: 2	كُتُبِ الْعُلُومِ
u'كَتَبَ عُمَارَةٌ':Subject, #1: 1	كَتَبَ عَلِيٌّ
u'كَتَبَ عُمَرٌ':Predicate, #1: 1	كَتَبَ عُمَارَةُ
u'كَتَبَ عُمَرٌ':Subject, #3: 3	كَتَبَ عُمَرَ
u'كَتَبَ عند':Predicate, #60: 60	كَتَبَ عُمَرُ
u'كَتَبَ عَهْدٌ':Predicate, #1: 1	كَتَبَ عِنْدَ
u'كَتَبَ غَبْنٌ':Predicate, #1: 1	كَتَبَ الْعَهْدَ
u'كُتُبٌ غَرِيبٌ':Added, #1: 1	كَتَبَ الْغَبْنَ
u'كَتَبَ غير':Predicate, #1: 1	كُتُبِ الْغَرِيبِ
u'كَتَبَ غَيْرٌ':Predicate, #1: 1	كَتَبَ غَيْرَ
u'كُتُبٌ غير':Added, #1: 1	كَتَبَ غَيْرَ
u'كُتُبٌ غَيْرٌ':Added, #1: 1	كُتُبِ الْغَيْرِ
u'كُتُبٌ فِرَاسَةٌ':Added, #1: 1	كُتُبِ الْغَيْرِ
u'كَتَبَ فَرَائِضُ':Predicate, #1: 1	كُتُبَ الْفِرَاسَةِ
u'كُتُبٌ فُرُوعٌ':Added, #1: 1	كَتَبَ الْفَرَائِضَ
u'كُتُبٌ فُرُوعٌ':Added, #14: 14	كُتُبِ الْفُرُوعِ
u'كُتُبٌ فُرُوعٌ':Added, #1: 1	كُتُبَ الْفُرُوعِ
u'كُتُبٌ فقراء':Added, #3: 3	كُتُبُ الْفُرُوعِ
u'كُتُبٌ فِقْهٌ':Added, #1: 1	كُتُبِ الْفُقَرَاءِ
u'كُتُبٌ فِقْهٌ':Added, #1: 1	كُتُبَ الْفِقْهِ
u'كُتُبٌ فِقْهٌ':Added, #1: 1	كُتُبَ فِقْهٍ
u'كُتُبٌ فِقْهٌ':Added, #2: 2	كُتُبُ فِقْهٍ
u'كُتُبٌ فِقْهٌ':Added, #4: 4	كُتُبُ الْفِقْهِ
u'كُتُبٌ فقهاء':Added, #75: 75	كُتُبِ الْفِقْهِ
u'كُتُبٌ فَقِيهٌ':Added, #8: 8	كُتُبِ الْفُقَهَاءِ
u'كُتُبٌ فَقِيهٌ':Added, #1: 1	كُتُبَ الْفَقِيهِ
u'كَتَبَ فلان':Subject, #1: 1	كُتُبُ الْفَقِيهِ
u'كَتَبَ فلان':Subject, #1: 1	كَتَبَ الشَّافِعِيُّ
u'كَتَبَ فلان':Subject, #1: 1	كَتَبَ حُذَيْفَةُ
u'كَتَبَ فلان':Subject, #1: 1	كَتَبَ زِيَادُ
u'كَتَبَ فلان':Subject, #1: 1	كَتَبَ سُفْيَانُ
u'كَتَبَ فُلاَنٌ':Subject, #1: 1	كَتَبَ عُثْمَانُ
u'كَتَبَ فلان':Subject, #1: 1	كَتَبَ فُلَانٌ
u'كُتُبٌ فلان':Added, #3: 3	كَتَبَ مُعَاوِيَةُ
u'كُتُبٌ فلان':Added, #1: 1	كُتُبِ التِّرْمِذِيِّ
u'كُتُبٌ فلان':Added, #1: 1	كُتُبُ الشَّافِعِيِّ
u'كُتُبٌ فلان':Added, #1: 1	كُتُبِ الظَّاهِرِيَّةِ
u'كُتُبٌ فلان':Added, #2: 2	كُتُبِ الشَّافِعِيِّ
u'كُتُبٌ فَلْسَفَةٌ':Added, #30: 30	كُتُبِ الشَّافِعِيَّةِ
u'كُتُبٌ فَنٌّ':Added, #1: 1	كُتُبِ الْفَلْسَفَةِ
u'كَتَبَ قِبَلٌ':Predicate, #1: 1	كُتُبِ الْفَنِّ
u'كَتَبَ قَدْرٌ':Predicate, #1: 1	كَتَبَ قِبَلَ
u'كُتُبٌ قدماء':Added, #2: 2	كَتَبَ قَدْرَ
u'كُتُبٌ قِرَاءةٌ':Added, #1: 1	كُتُبِ الْقُدَمَاءِ
u'كَتَبَ قُرْآنٌ':Predicate, #1: 1	كُتُبِ الْقِرَاءَةِ
u'كُتُبٌ قضاة':Added, #3: 3	كَتَبَ الْقُرْآنَ
u'كَتَبَ قَلَمٌ':Subject, #2: 2	كُتُبِ الْقُضَاةِ
u'كَتَبَ قَوْمٌ':Subject, #1: 1	كَتَبَ الْقَلَمُ
u'كُتُبٌ قَوْمٌ':Added, #1: 1	كَتَبَ قَوْمٌ
u'كُتُبٌ قَوْمٌ':Added, #1: 1	كُتُبِ قَوْمٍ
u'كَتَبَ كَاتِبٌ':Subject, #2: 2	كُتُبِ الْقَوْمِ
u'كَتَبَ كَاتِبٌ':Subject, #4: 4	كَتَبَ الْكَاتِبُ
u'كَتَبَ كِتَابٌ':Predicate, #4: 4	كَتَبَ كَاتِبٌ
u'كَتَبَ كِتَابٌ':Predicate, #7: 7	كَتَبَ الْكِتَابَ
u'كُتُبٌ كَلاَمٌ':Added, #9: 9	كَتَبَ كِتَابَ
u'كُتُبٌ كَلاَمٌ':Added, #1: 1	كُتُبِ كَلَامِ
u'كُتُبٌ كَلاَمٌ':Added, #3: 3	كُتُبَ الْكَلَامِ
u'كُتُبٌ كَلاَمٌ':Added, #4: 4	كُتُبُ الْكَلَامِ
u'كُتُبٌ لُغَةٌ':Added, #5: 5	كُتُبِ الْكَلَامِ
u'كَتَبَ مَالٌ':Subject, #23: 23	كُتُبِ اللُّغَةِ
u'كَتَبَ مالِك':Subject, #1: 1	كَتَبَ مَالٌ
u'كُتُبٌ مالِك':Added, #1: 1	كَتَبَ الْمَالِكِيَّةُ
u'كُتُبٌ مالِك':Added, #1: 1	كُتُبَ الْمَالِكِيَّةِ
u'كُتُبٌ مالِك':Added, #1: 1	كُتُبُ الْمَالِكِيَّةِ
u'كَتَبَ مالِكِيّ':Subject, #4: 4	كُتُبِ الْمَالِكِيَّةِ
u'كُتُبٌ مالِكِيّ':Added, #1: 1	كَتَبَ الْمَالِكِيَّةُ
u'كُتُبٌ مالِكِيّ':Added, #1: 1	كُتُبَ الْمَالِكِيَّةِ
u'كُتُبٌ مالِكِيّ':Added, #1: 1	كُتُبُ الْمَالِكِيَّةِ
u'كُتُبٌ مُبَايَعَةٌ':Added, #4: 4	كُتُبِ الْمَالِكِيَّةِ
u'كُتُبٌ مُبْتَدِعٌ':Added, #2: 2	كُتُبِ الْمُبَايَعَاتِ
u'كُتُبٌ مَجَالِسُ':Added, #3: 3	كُتُبِ الْمُبْتَدِعَةِ
u'كَتَبَ مَجْلِسٌ':Predicate, #1: 1	كُتُبِ الْمَجَالِسِ
u'كَتَبَ مَحْضَرٌ':Predicate, #1: 1	كَتَبَ الْمَجْلِسَ
u'كَتَبَ مُحَمَّدٌ':Subject, #1: 1	كَتَبَ الْمَحْضَرَ
u'كَتَبَ مُحَمَّدٌ':Subject, #1: 1	كَتَبَ مُحَمَّدٌ
u'كُتُبٌ مُحَمَّدٌ':Added, #1: 1	كَتَبَ مُحَمَّدُ
u'كُتُبٌ مُحَمَّدٌ':Added, #1: 1	كُتُبَ مُحَمَّدٍ
u'كُتُبٌ مُحَمَّدٌ':Added, #2: 2	كُتُبِ مُحَمَّدٍ
u'كُتُبٌ مُخْتَصَرٌ':Added, #3: 3	كُتُبِ مُحَمَّدِ
u'كُتُبٌ مُدَوَّنٌ':Added, #1: 1	كُتُبُ مُخْتَصَرَةٍ
u'كُتُبٌ مُدَوَّنَةٌ':Added, #1: 1	كُتُبِ الْمُدَوَّنَةِ
u'كُتُبٌ مَذَاهِبُ':Added, #1: 1	كُتُبِ الْمُدَوَّنَةِ
u'كُتُبٌ مَذْهَبٌ':Added, #1: 1	كُتُبِ الْمَذَاهِبِ
u'كُتُبٌ مَذْهَبٌ':Added, #1: 1	كُتُب الْمَذْهَبِ
u'كُتُبٌ مَذْهَبٌ':Added, #2: 2	كُتُبَ الْمَذْهَبِ
u'كَتَبَ مرٌّ':Predicate, #34: 34	كُتُبِ الْمَذْهَبِ
u'كُتُبٌ مَسَائِلُ':Added, #1: 1	كَتَبَ مَرَّةً
u'كُتُبٌ مَسَائِلُ':Added, #23: 23	كُتُبِ الْمَسَائِلِ
u'كَتَبَ مَصَاحِفُ':Predicate, #2: 2	كُتُبُ الْمَسَائِلِ
u'كُتُبٌ مُصَنِّفٌ':Added, #1: 1	كَتَبَ الْمَصَاحِفَ
u'كَتَبَ مُعاوِيَة':Subject, #2: 2	كُتُبِ الْمُصَنِّفِ
u'كُتُبٌ مُعْتَزِلٌ':Added, #3: 3	كَتَبَ مُعَاوِيَةُ
u'كُتُبٌ مُعْتَزِلٌ':Added, #1: 1	كُتُبَ الْمُعْتَزِلَةِ
u'كُتُبٌ مُعْتَزِلَةٌ':Added, #1: 1	كُتُبِ الْمُعْتَزِلَةِ
u'كُتُبٌ مُعْتَزِلَةٌ':Added, #1: 1	كُتُبَ الْمُعْتَزِلَةِ
u'كَتَبَ مَقْسُومٌ':Predicate, #1: 1	كُتُبِ الْمُعْتَزِلَةِ
u'كَتَبَ مَقْسُومٌ':Subject, #1: 1	كَتَبَ الْمَقْسُومَ
u'كَتَبَ مَكْتُوبٌ':Subject, #1: 1	كَتَبَ الْمَقْسُومُ
u'كُتُبٌ مَلاَئِكَةٌ':Added, #3: 3	كَتَبَ الْمَكْتُوبُ
u'كُتُبٌ مَنَاسِكُ':Added, #1: 1	كُتُبُ الْمَلَائِكَةِ
u'كُتُبٌ مَنْطِقٌ':Added, #1: 1	كُتُبِ الْمَنَاسِكِ
u'كَتَبَ مُهَاجِرٌ':Predicate, #1: 1	كُتُبِ الْمَنْطِقِ
u'كُتُبٌ نَاسٌ':Added, #1: 1	كَتَبَ الْمُهَاجِرِينَ
u'كَتَبَ نَبِيٌّ':Subject, #2: 2	كُتُبِ النَّاسِ
u'كَتَبَ نَجْدَةٌ':Subject, #6: 6	كَتَبَ النَّبِيُّ
u'كُتُبٌ نُحَاةٌ':Added, #7: 7	كَتَبَ نَجْدَةُ
u'كُتُبٌ نَحْوٌ':Added, #1: 1	كُتُبِ النُّحَاةِ
u'كُتُبٌ نَحْوٌ':Added, #1: 1	كُتُبَ النَّحْوِ
u'كُتُبٌ نقلة':Added, #1: 1	كُتُبِ النَّحْوِ
u'كُتُبٌ نَقَلَةٌ':Added, #1: 1	كُتُبِ النَّقَلَةِ
u'كُتُبٌ نَوَادِرُ':Added, #1: 1	كُتُبِ النَّقَلَةِ
u'كُتُبٌ نَوَوِيٌّ':Added, #2: 2	كُتُبِ النَّوَادِرِ
u'كَتَبَ وَحْيٌ':Predicate, #1: 1	كُتُبِ النَّوَوِيِّ
u'كَتَبَ وَصِيٌّ':Predicate, #1: 1	كَتَبَ الْوَحْيَ
u'كُتُبٌ وَعْظٌ':Added, #3: 3	كَتَبَ وَصِيَّةً
u'كُتُبٌ وَعْظٌ':Added, #1: 1	كُتُبِ الْوَعْظِ
u'كَتَبَ وَقْفٌ':Predicate, #1: 1	كُتُبِ وَعْظٍ
u'كَتَبَ وَكِيلٌ':Subject, #1: 1	كَتَبَ الْوَقْفَ
u'كَتَبَ وَلِيدٌ':Subject, #1: 1	كَتَبَ الْوَكِيلُ
u'كُتُبٌ يمن':Added, #1: 1	كَتَبَ الْوَلِيدُ
u'كُتُبٌ يَمَنُ':Added, #1: 1	كُتُبِ الْيَمَنِ
u'كَتَبَ يهود':Subject, #1: 1	كُتُبِ الْيَمَنِ
u'كَتَبَ يَهُودٌ':Subject, #1: 1	كَتَبَ الْيَهُودُ
u'كُتُبٌ يهود':Added, #1: 1	كَتَبَ الْيَهُودُ
u'كُتُبٌ يَهُودٌ':Added, #1: 1	كُتُبِ الْيَهُودِ
u'كُتُبٌ يَوْمٌ':Added, #1: 1	كُتُبِ الْيَهُودِ
u'كتم أسْرَارٌ':Added, #1: 1	كُتُبَ الْيَوْمِ
u'كتم أَسْرَارٌ':Added, #1: 1	كَتْمِ الْأَسْرَارِ
u'كَتْمٌ أسْرَارٌ':Added, #1: 1	كَتْمِ الْأَسْرَارِ
u'كَتْمٌ أَسْرَارٌ':Added, #1: 1	كَتْمِ الْأَسْرَارِ
u'كِتْمَانٌ أسْرَارٌ':Added, #1: 1	كَتْمِ الْأَسْرَارِ
u'كِتْمَانٌ أَسْرَارٌ':Added, #1: 1	كِتْمَانَ الْأَسْرَارِ
u'كِتْمَانٌ إقْرَارٌ':Added, #1: 1	كِتْمَانَ الْأَسْرَارِ
u'كِتْمَانٌ بَعْثٌ':Added, #1: 1	كِتْمَانِ الْإِقْرَارِ
u'كِتْمَانٌ سِرٌّ':Added, #1: 1	كِتْمَانِ بَعْثِهِ
u'كِتْمَانٌ سِرٌّ':Added, #1: 1	كِتْمَانُ السِّرِّ
u'كِتْمَانٌ شَهَادَةٌ':Added, #1: 1	كِتْمَانِ السِّرِّ
u'كِتْمَانٌ شَهَادَةٌ':Added, #1: 1	كِتْمَانُ الشَّهَادَةِ
u'كِتْمَانٌ طَلاَقٌ':Added, #1: 1	كِتْمَانِ الشَّهَادَةِ
u'كِتْمَانٌ علم':Added, #1: 1	كِتْمَانِ الطَّلَاقِ
u'كِتْمَانٌ عِلْمٌ':Added, #1: 1	كِتْمَانَ الْعِلْمِ
u'كِتْمَانٌ علم':Added, #1: 1	كِتْمَانَ الْعِلْمِ
u'كِتْمَانٌ عِلْمٌ':Added, #3: 3	كِتْمَانِ الْعِلْمِ
u'كِتْمَانٌ عَيْبٌ':Added, #3: 3	كِتْمَانِ الْعِلْمِ
u'كِتْمَانٌ عَيْبٌ':Added, #1: 1	كِتْمَانُ الْعَيْبِ
u'كِتْمَانٌ عَيْبٌ':Added, #1: 1	كِتْمَانِ الْعَيْبِ
u'كِتْمَانٌ عُيُوبٌ':Added, #2: 2	كِتْمَانُ عَيْبِ
u'كَتَمَ رَجُلٌ':Subject, #4: 4	كِتْمَانُ الْعُيُوبِ
u'كَتَمَ رَهْنٌ':Predicate, #1: 1	كَتَمَ الرَّجُلُ
u'كتم شَرِيكٌ':Added, #1: 1	كَتَمَ الرَّهْنَ
u'كَتْمٌ شَرِيكٌ':Added, #2: 2	كَتْمِ شَرِيكِهِ
u'كتم شَهَادَةٌ':Added, #2: 2	كَتْمِ شَرِيكِهِ
u'كَتْمٌ شَهَادَةٌ':Added, #1: 1	كَتْمُ الشَّهَادَةِ
u'كتم شَهَادَةٌ':Added, #1: 1	كَتْمُ الشَّهَادَةِ
u'كَتْمٌ شَهَادَةٌ':Added, #1: 1	كَتْمُ شَهَادَةِ
u'كَتَمَ صَدِيقٌ':Subject, #1: 1	كَتْمُ شَهَادَةِ
u'كَتَمَ عَالَمٌ':Subject, #1: 1	كَتَمَ الصَّدِيقُ
u'كتم عَزْمٌ':Added, #1: 1	كَتَمَ الْعَالَمُ
u'كَتْمٌ عَزْمٌ':Added, #1: 1	كَتْمِ الْعَزْمِ
u'كَتَمَ علم':Predicate, #1: 1	كَتْمِ الْعَزْمِ
u'كَتَمَ عِلْمٌ':Predicate, #1: 1	كَتَمَ الْعِلْمَ
u'كتم علم':Added, #1: 1	كَتَمَ الْعِلْمَ
u'كَتْمٌ علم':Added, #1: 1	كَتْمُ الْعِلْمِ
u'كتم عِلْمٌ':Added, #1: 1	كَتْمُ الْعِلْمِ
u'كَتْمٌ عِلْمٌ':Added, #1: 1	كَتْمُ الْعِلْمِ
u'كتم عَمَلٌ':Added, #1: 1	كَتْمُ الْعِلْمِ
u'كَتْمٌ عَمَلٌ':Added, #1: 1	كَتْمِ الْعَمَلِ
u'كَتَمَ عَيْبٌ':Predicate, #1: 1	كَتْمِ الْعَمَلِ
u'كتم عَيْبٌ':Added, #1: 1	كَتَمَ الْعَيْبَ
u'كَتْمٌ عَيْبٌ':Added, #1: 1	كَتْمُ الْعَيْبِ
u'كتم عَيْبٌ':Added, #1: 1	كَتْمُ الْعَيْبِ
u'كَتْمٌ عَيْبٌ':Added, #1: 1	كَتْمُ عَيْبٍ
u'كَتَمَ قُرْآنٌ':Predicate, #1: 1	كَتْمُ عَيْبٍ
u'كَتَمَ وَرَثَةٌ':Subject, #1: 1	كَتَمَ الْقُرْآنَ
u'كَثَافَةٌ لَحْمٌ':Added, #1: 1	كَتَمَ الْوَرَثَةُ
u'كَثُرَ أَجَلٌ':Subject, #2: 2	كَثَافَةِ لَحْمٍ
u'كَثُرَ اِحْتِيَاجٌ':Subject, #1: 1	كَثُرَ الْأَجَلُ
u'كَثُرَ اِخْتِلاَفٌ':Subject, #1: 1	كَثُرَ احْتِيَاجُهُ
u'كَثُرَ أخْذٌ':Subject, #2: 2	كَثُرَ اخْتِلَافُ
u'كَثُرَ إِخْوَةٌ':Subject, #1: 1	كَثُرَ أَخْذُهُ
u'كَثُرَ اِسْتِدْلاَلٌ':Subject, #1: 1	كَثُرَ الإِخْوَةُ
u'كَثُرَ اِسْتِرْسَالٌ':Subject, #1: 1	كَثُرَ اسْتِدْلَالُ
u'كَثُرَ اِسْتِعْمالٌ':Subject, #1: 1	كَثُرَ اسْتِرْسَالُ
u'كَثُرَ اِسْتِعْمالٌ':Subject, #1: 1	كَثُرَ اسْتِعْمَالُ
u'كَثُرَ اِشْتِراكٌ':Subject, #4: 4	كَثُرَ اسْتِعْمَالُهُ
u'كَثُرَ اِشْتِغالٌ':Subject, #1: 1	كَثُرَ اشْتِرَاكُ
u'كَثُرَ اِشْتِغالٌ':Subject, #1: 1	كَثُرَ اشْتِغَالُ
u'كَثُرَ اِعْتِبارٌ':Subject, #1: 1	كَثُرَ اشْتِغَالُهُ
u'كَثُرَ إِعْجازٌ':Subject, #1: 1	كَثُرَ اعْتِبَارُهُ
u'كَثُرَ أكل':Subject, #1: 1	كَثُرَ إعْجَازُهُ
u'كَثُرَ أَكْلٌ':Subject, #1: 1	كَثُرَ أَكْلُهُ
u'كَثُرَ إِلْمَامٌ':Subject, #1: 1	كَثُرَ أَكْلُهُ
u'كَثُرَ اِنْحِرافٌ':Subject, #1: 1	كَثُرَ إلْمَامُهُ
u'كَثُرَ أهْلٌ':Subject, #1: 1	كَثُرَ انْحِرَافُهُ
u'كَثُرَ أَوْقَاتٌ':Subject, #2: 2	كَثُرَ أَهْلُ
u'كَثُرَ أَوْلاَدٌ':Subject, #1: 1	كَثُرَ أَوْقَاتُ
u'كَثُرَ أَوْلِيَاءُ':Subject, #1: 1	كَثُرَ أَوْلَادُ
u'كَثُرَ إيرَادٌ':Subject, #1: 1	كَثُرَ أَوْلِيَاءُ
u'كَثُرَ بَاطِلٌ':Subject, #1: 1	كَثُرَ إيرَادُهُ
u'كَثُرَ بَحْثٌ':Subject, #1: 1	كَثُرَ الْبَاطِلُ
u'كَثُرَ بُصاقٌ':Subject, #1: 1	كَثُرَ بَحْثُ
u'كَثُرَ بَطَلٌ':Predicate, #1: 1	كَثُرَ بُصَاقُهُ
u'كَثُرَ بَيَاضٌ':Subject, #1: 1	كَثُرَ بَطَلَ
u'كَثْرَةٌ أبْخِرَةٌ':Added, #1: 1	كَثُرَ الْبَيَاضُ
u'كَثْرَةٌ إِبِلٌ':Added, #1: 1	كَثْرَةِ الْأَبْخِرَةِ
u'كَثْرَةٌ إِتْيانٌ':Added, #1: 1	كَثْرَةِ الْإِبِلِ
u'كَثْرَةٌ إِثْمٌ':Added, #1: 1	كَثْرَةِ الْإِتْيَانِ
u'كَثْرَةٌ أجَانِبُ':Added, #1: 1	كَثْرَةِ الْإِثْمِ
u'كَثْرَةٌ أَجْرٌ':Added, #2: 2	كَثْرَةِ الْأَجَانِبِ
u'كَثْرَةٌ أَجْزَاءٌ':Added, #3: 3	كَثْرَةِ الْأَجْرِ
u'كَثْرَةٌ أَجْزَاءٌ':Added, #1: 1	كَثْرَةِ الْأَجْزَاءِ
u'كَثْرَةٌ أجْنِحَةٌ':Added, #2: 2	كَثْرَةُ الْأَجْزَاءِ
u'كَثْرَةٌ أَحادِيثُ':Added, #1: 1	كَثْرَةِ الْأَجْنِحَةِ
u'كَثْرَةٌ إِحالَةٌ':Added, #1: 1	كَثْرَةُ الْأَحَادِيثِ
u'كَثْرَةٌ إِحالَةٌ':Added, #1: 1	كَثْرَةُ الْإِحَالَةِ
u'كَثْرَةٌ اِخْتِلاَفٌ':Added, #1: 1	كَثْرَةِ الْإِحَالَةِ
u'كَثْرَةٌ إِخْوَانٌ':Added, #1: 1	كَثْرَةِ اخْتِلَافِ
u'كَثْرَةٌ إِخْوَانٌ':Added, #1: 1	كَثْرَةُ إخْوَانِهِ
u'كَثْرَةٌ إِخْوَةٌ':Added, #1: 1	كَثْرَةِ الْإِخْوَانِ
u'كَثْرَةٌ إِدْرَاكٌ':Added, #1: 1	كَثْرَةِ الْإِخْوَةِ
u'كَثْرَةٌ إِدْرَاكٌ':Added, #1: 1	كَثْرَة الْإِدْرَاكَاتِ
u'كَثْرَةٌ إِرَادَةٌ':Added, #1: 1	كَثْرَةُ الْإِدْرَاكَاتِ
u'كَثْرَةٌ إِرَادَةٌ':Added, #1: 1	كَثْرَةُ إرَادَةِ
u'كَثْرَةٌ أسْبَابٌ':Added, #1: 1	كَثْرَةِ إرَادَةِ
u'كَثْرَةٌ أَسْبَابٌ':Added, #1: 1	كَثْرَةُ أَسْبَابِهِ
u'كَثْرَةٌ اِسْتِعْمالٌ':Added, #1: 1	كَثْرَةُ أَسْبَابِهِ
u'كَثْرَةٌ اِسْتِغْفارٌ':Added, #1: 1	كَثْرَةِ اسْتِعْمَالِهِ
u'كَثْرَةٌ اِسْتِفْرَاغٌ':Added, #1: 1	كَثْرَةِ الاِسْتِغْفَارِ
u'كَثْرَةٌ أسْفَارٌ':Added, #1: 1	كَثْرَةِ اسْتِفْرَاغِ
u'كَثْرَةٌ إِسْلامٌ':Added, #1: 1	كَثْرَةِ أَسْفَارِهِ
u'كَثْرَةٌ أسْئِلَةٌ':Added, #1: 1	كَثْرَةِ إسْلَامِ
u'كَثْرَةٌ أشباه':Added, #1: 1	كَثْرَةِ الْأَسْئِلَةِ
u'كَثْرَةٌ أشْبَاهٌ':Added, #1: 1	كَثْرَةِ الْأَشْبَاهِ
u'كَثْرَةٌ أَشْبَاهٌ':Added, #1: 1	كَثْرَةِ الْأَشْبَاهِ
u'كَثْرَةٌ أشباه':Added, #1: 1	كَثْرَةِ الْأَشْبَاهِ
u'كَثْرَةٌ أشْبَاهٌ':Added, #2: 2	كَثْرَةَ الْأَشْبَاهِ
u'كَثْرَةٌ أَشْبَاهٌ':Added, #2: 2	كَثْرَةَ الْأَشْبَاهِ
u'كَثْرَةٌ اِشْتِغالٌ':Added, #2: 2	كَثْرَةَ الْأَشْبَاهِ
u'كَثْرَةٌ اِشْتِغالٌ':Added, #1: 1	كَثْرَةُ اشْتِغَالِ
u'كَثْرَةٌ اِشْتِغالٌ':Added, #1: 1	كَثْرَةِ اشْتِغَالِ
u'كَثْرَةٌ أَشْغالٌ':Added, #1: 1	كَثْرَةُ اشْتِغَالِهِ
u'كَثْرَةٌ أَشْغالٌ':Added, #1: 1	كَثْرَةِ أَشْغَالٍ
u'كَثْرَةٌ إصابَةٌ':Added, #2: 2	كَثْرَةِ الْأَشْغَالِ
u'كَثْرَةٌ إصابَةٌ':Added, #1: 1	كَثْرَةِ إصَابَةِ
u'كَثْرَةٌ أصدقاء':Added, #1: 1	كَثْرَةِ الْإِصَابَةِ
u'كَثْرَةٌ أصفياء':Added, #1: 1	كَثْرَةُ أَصْدِقَاءِ
u'كَثْرَةٌ أُصولٌ':Added, #1: 1	كَثْرَةِ الْأَصْفِيَاءِ
u'كَثْرَةٌ أُصولٌ':Added, #3: 3	كَثْرَةَ الْأُصُولِ
u'كَثْرَةٌ أُصولٌ':Added, #3: 3	كَثْرَةِ الْأُصُولِ
u'كَثْرَةٌ إضْمارٌ':Added, #4: 4	كَثْرَةُ الْأُصُولِ
u'كَثْرَةٌ إِطْلاعٌ':Added, #1: 1	كَثْرَةُ الْإِضْمَارِ
u'كَثْرَةٌ إِطْلاقٌ':Added, #1: 1	كَثْرَةِ إطْلَاعِهِ
u'كَثْرَةٌ إعْلاَمٌ':Added, #1: 1	كَثْرَةُ إطْلَاقِ
u'كَثْرَةٌ أَفْعَالٌ':Added, #2: 2	كَثْرَةِ إعْلَامِ
u'كَثْرَةٌ أَفْعَالٌ':Added, #1: 1	كَثْرَةُ أَفْعَالِ
u'كَثْرَةٌ إقامَةٌ':Added, #2: 2	كَثْرَةِ الْأَفْعَالِ
u'كَثْرَةٌ أَقْوَالٌ':Added, #1: 1	كَثْرَةُ إقَامَتِهِ
u'كَثْرَةٌ أكل':Added, #1: 1	كَثْرَةِ الْأَقْوَالِ
u'كَثْرَةٌ أَكْلٌ':Added, #1: 1	كَثْرَةُ الْأَكْلِ
u'كَثْرَةٌ أكل':Added, #1: 1	كَثْرَةُ الْأَكْلِ
u'كَثْرَةٌ أكل':Added, #2: 2	كَثْرَةَ الْأَكْلِ
u'كَثْرَةٌ أَكْلٌ':Added, #2: 2	كَثْرَةِ الْأَكْلِ
u'كَثْرَةٌ أَكْلٌ':Added, #2: 2	كَثْرَةَ الْأَكْلِ
u'كَثْرَةٌ إلْحَاحٌ':Added, #2: 2	كَثْرَةِ الْأَكْلِ
u'كَثْرَةٌ ألَمٌ':Added, #2: 2	كَثْرَةُ الْإِلْحَاحِ
u'كَثْرَةٌ أمثال':Added, #1: 1	كَثْرَةِ الْأَلَمِ
u'كَثْرَةٌ أَمْثَالٌ':Added, #1: 1	كَثْرَةِ الْأَمْثَالِ
u'كَثْرَةٌ أَمْطَارٌ':Added, #1: 1	كَثْرَةِ الْأَمْثَالِ
u'كَثْرَةٌ أَمْوَالٌ':Added, #1: 1	كَثْرَةِ الْأَمْطَارِ
u'كَثْرَةٌ إِنْزالٌ':Added, #1: 1	كَثْرَةِ أَمْوَالٍ
u'كَثْرَةٌ اِنْهِزَامٌ':Added, #1: 1	كَثْرَةِ إنْزَالِ
u'كَثْرَةٌ أَنْوَارٌ':Added, #1: 1	كَثْرَةَ انْهِزَامِ
u'كَثْرَةٌ أهْلٌ':Added, #1: 1	كَثْرَةِ الْأَنْوَارِ
u'كَثْرَةٌ أَوْصَافٌ':Added, #1: 1	كَثْرَةِ أَهْلِ
u'كَثْرَةٌ أَيْمَانٌ':Added, #1: 1	كَثْرَةِ الْأَوْصَافِ
u'كَثْرَةٌ بَحْثٌ':Added, #1: 1	كَثْرَةَ الْأَيْمَانِ
u'كَثْرَةٌ بَرَكَةٌ':Added, #1: 1	كَثْرَةِ بَحْثِهِ
u'كَثْرَةٌ بُكاءٌ':Added, #1: 1	كَثْرَةِ الْبَرَكَةِ
u'كَثْرَةٌ بُكاءٌ':Added, #1: 1	كَثْرَةَ الْبُكَاءِ
u'كَثْرَةٌ بِنَاءٌ':Added, #1: 1	كَثْرَةُ الْبُكَاءِ
u'كَثْرَةٌ بَوْلٌ':Added, #1: 1	كَثْرَةِ الْبِنَاءِ
u'كَثْرَةٌ بيض':Added, #1: 1	كَثْرَةِ الْبَوْلِ
u'كَثْرَةٌ تَبْلِيغٌ':Added, #1: 1	كَثْرَةِ الْبَيْضِ
u'كَثْرَةٌ تَتَبُّعٌ':Added, #1: 1	كَثْرَةَ التَّبْلِيغِ
u'كَثْرَةٌ تَجَارِبُ':Added, #1: 1	كَثْرَةِ التَّتَبُّعِ
u'كَثْرَةٌ تَجَوُّزٌ':Added, #1: 1	كَثْرَةِ التَّجَارِبِ
u'كَثْرَةٌ تَخْصِيصٌ':Added, #1: 1	كَثْرَةِ التَّجَوُّزِ
u'كَثْرَةٌ تَخْصِيصٌ':Added, #1: 1	كَثْرَةَ التَّخْصِيصِ
u'كَثْرَةٌ تَخْصِيصٌ':Added, #1: 1	كَثْرَةُ تَخْصِيصِ
u'كَثْرَةٌ تَرَدُّدٌ':Added, #1: 1	كَثْرَةِ تَخْصِيصِهِ
u'كَثْرَةٌ تَعَارُضٌ':Added, #1: 1	كَثْرَةَ التَّرَدُّدِ
u'كَثْرَةٌ تَعَارُضٌ':Added, #1: 1	كَثْرَةَ التَّعَارُضِ
u'كَثْرَةٌ تَعَاهُدٌ':Added, #1: 1	كَثْرَةِ التَّعَارُضِ
u'كَثْرَةٌ تَغَفُّلٌ':Added, #1: 1	كَثْرَةُ التَّعَاهُدِ
u'كَثْرَةٌ تَغَيُّرٌ':Added, #1: 1	كَثْرَةِ التَّغَفُّلِ
u'كَثْرَةٌ تَفْتِيشٌ':Added, #1: 1	كَثْرَةُ تَغَيُّرِهِ
u'كَثْرَةٌ تَفَرُّدٌ':Added, #1: 1	كَثْرَةِ التَّفْتِيشِ
u'كَثْرَةٌ تَفْرِيطٌ':Added, #1: 1	كَثْرَةُ تَفَرُّدِ
u'كَثْرَةٌ تَفْرِيع':Added, #1: 1	كَثْرَةِ تَفْرِيطِهِ
u'كَثْرَةٌ تَقْديرٌ':Added, #1: 1	كَثْرَةُ تَفْرِيعِ
u'كَثْرَةٌ تَكَرُّرٌ':Added, #1: 1	كَثْرَةُ التَّقْدِيرِ
u'كَثْرَةٌ تِلاوَةٌ':Added, #1: 1	كَثْرَةِ تَكَرُّرِهِ
u'كَثْرَةٌ تِلاوَةٌ':Added, #1: 1	كَثْرَةِ تِلَاوَتِهِ
u'كَثْرَةٌ تَلْويثٌ':Added, #2: 2	كَثْرَةُ تِلَاوَتِهِ
u'كَثْرَةٌ تَنْوِيرٌ':Added, #1: 1	كَثْرَةِ التَّلْوِيثِ
u'كَثْرَةٌ ثَمَنٌ':Added, #2: 2	كَثْرَةَ التَّنْوِيرِ
u'كَثْرَةٌ ثَمَنٌ':Added, #1: 1	كَثْرَةُ الثَّمَنِ
u'كَثْرَةٌ ثَوابٌ':Added, #1: 1	كَثْرَةُ ثَمَنٍ
u'كَثْرَةٌ ثَوابٌ':Added, #1: 1	كَثْرَةَ ثَوَابِ
u'كَثْرَةٌ ثَوابٌ':Added, #1: 1	كَثْرَةِ ثَوَابِ
u'كَثْرَةٌ ثَوابٌ':Added, #1: 1	كَثْرَةِ ثَوَابِهِ
u'كَثْرَةٌ ثَوابٌ':Added, #4: 4	كَثْرَةُ الثَّوَابِ
u'كَثْرَةٌ ثِيابٌ':Added, #6: 6	كَثْرَةِ الثَّوَابِ
u'كَثْرَةٌ جُزْئِيٌّ':Added, #2: 2	كَثْرَةِ الثِّيَابِ
u'كَثْرَةٌ جُزْئِيَّةٌ':Added, #1: 1	كَثْرَةُ الْجُزْئِيَّاتِ
u'كَثْرَةٌ جِزْيَةٌ':Added, #1: 1	كَثْرَةُ الْجُزْئِيَّاتِ
u'كَثْرَةٌ جماع':Added, #2: 2	كَثْرَةَ الْجِزْيَةِ
u'كَثْرَةٌ جِمَاعٌ':Added, #1: 1	كَثْرَةُ الْجِمَاعِ
u'كَثْرَةٌ جَمَاعَةٌ':Added, #1: 1	كَثْرَةُ الْجِمَاعِ
u'كَثْرَةٌ جَمَاعَةٌ':Added, #1: 1	كَثْرَةُ الْجَمَاعَةِ
u'كَثْرَةٌ جمع':Added, #2: 2	كَثْرَةِ الْجَمَاعَةِ
u'كَثْرَةٌ جمع':Added, #1: 1	كَثْرَةَ الْجَمْعِ
u'كَثْرَةٌ جَمْعٌ':Added, #1: 1	كَثْرَةُ الْجَمْعِ
u'كَثْرَةٌ جَمْعٌ':Added, #1: 1	كَثْرَةَ الْجَمْعِ
u'كَثْرَةٌ جمع':Added, #1: 1	كَثْرَةُ الْجَمْعِ
u'كَثْرَةٌ جَمْعٌ':Added, #8: 8	كَثْرَةِ الْجَمْعِ
u'كَثْرَةٌ جُهَّالٌ':Added, #8: 8	كَثْرَةِ الْجَمْعِ
u'كَثْرَةٌ جِهَةٌ':Added, #1: 1	كَثْرَةِ الْجُهَّالِ
u'كَثْرَةٌ جِهَةٌ':Added, #1: 1	كَثْرَةِ الْجِهَاتِ
u'كَثْرَةٌ جهل':Added, #1: 1	كَثْرَةُ جِهَاتِ
u'كَثْرَةٌ جَهْلٌ':Added, #1: 1	كَثْرَةُ الْجَهْلِ
u'كَثْرَةٌ جهل':Added, #1: 1	كَثْرَةُ الْجَهْلِ
u'كَثْرَةٌ جَهْلٌ':Added, #2: 2	كَثْرَةِ الْجَهْلِ
u'كَثْرَةٌ حاجَةٌ':Added, #2: 2	كَثْرَةِ الْجَهْلِ
u'كَثْرَةٌ حَديثٌ':Added, #1: 1	كَثْرَةِ الْحَاجَةِ
u'كَثْرَةٌ حَديثٌ':Added, #1: 1	كَثْرَةُ الْحَدِيثِ
u'كَثْرَةٌ حَذْف':Added, #1: 1	كَثْرَةُ حَدِيثِ
u'كَثْرَةٌ حَرامٌ':Added, #1: 1	كَثْرَةُ الْحَذْفِ
u'كَثْرَةٌ حَرَكَةٌ':Added, #4: 4	كَثْرَةِ الْحَرَامِ
u'كَثْرَةٌ حَرَكَةٌ':Added, #1: 1	كَثْرَةُ حَرَكَةٍ
u'كَثْرَةٌ حَرَكَةٌ':Added, #2: 2	كَثْرَةِ الْحَرَكَةِ
u'كَثْرَةٌ حُروفٌ':Added, #3: 3	كَثْرَةُ الْحَرَكَةِ
u'كَثْرَةٌ حَرِيرٌ':Added, #1: 1	كَثْرَةُ حُرُوفِ
u'كَثْرَةٌ حِفْظٌ':Added, #1: 1	كَثْرَةِ الْحَرِيرِ
u'كَثْرَةٌ حَقٌّ':Added, #1: 1	كَثْرَةُ حِفْظِهِ
u'كَثْرَةٌ حَمْلٌ':Added, #1: 1	كَثْرَةِ حَقٍّ
u'كَثْرَةٌ خَبِيث':Added, #1: 1	كَثْرَةِ الْحَمْلِ
u'كَثْرَةٌ خُرُوجٌ':Added, #2: 2	كَثْرَةُ الْخَبِيثِ
u'كَثْرَةٌ خُرُوجٌ':Added, #1: 1	كَثْرَةَ الْخُرُوجِ
u'كَثْرَةٌ خُصُومَةٌ':Added, #1: 1	كَثْرَةِ الْخُرُوجِ
u'كَثْرَةٌ خِلاَفٌ':Added, #2: 2	كَثْرَةَ الْخُصُومَاتِ
u'كَثْرَةٌ خلائق':Added, #1: 1	كَثْرَةِ الْخِلَافِ
u'كَثْرَةٌ خَلائِقُ':Added, #1: 1	كَثْرَةِ الْخَلائِقِ
u'كَثْرَةٌ خَوْفٌ':Added, #1: 1	كَثْرَةِ الْخَلائِقِ
u'كَثْرَةٌ خَوْفٌ':Added, #1: 1	كَثْرَةَ الْخَوْفِ
u'كَثْرَةٌ خَيْرٌ':Added, #2: 2	كَثْرَةِ خَوْفِ
u'كَثْرَةٌ دُخُولٌ':Added, #2: 2	كَثْرَةُ الْخَيْرِ
u'كَثْرَةٌ دُعَاءٌ':Added, #1: 1	كَثْرَةَ الدُّخُولِ
u'كَثْرَةٌ دَلائِلُ':Added, #1: 1	كَثْرَةُ الدُّعَاءِ
u'كَثْرَةٌ دَمٌ':Added, #1: 1	كَثْرَةِ الدَّلَائِلِ
u'كَثْرَةٌ ذكر':Added, #2: 2	كَثْرَةِ الدَّمِ
u'كَثْرَةٌ ذِكْرٌ':Added, #1: 1	كَثْرَةِ ذِكْرِهِ
u'كَثْرَةٌ رَفْضٌ':Added, #1: 1	كَثْرَةِ ذِكْرِهِ
u'كَثْرَةٌ رُكوعٌ':Added, #1: 1	كَثْرَةُ الرَّفْضِ
u'كَثْرَةٌ رُكوعٌ':Added, #1: 1	كَثْرَةِ الرُّكُوعِ
u'كَثْرَةٌ رُكوعٌ':Added, #2: 2	كَثْرَةَ الرُّكُوعِ
u'كَثْرَةٌ رَمادٌ':Added, #2: 2	كَثْرَةُ الرُّكُوعِ
u'كَثْرَةٌ رُوَاةٌ':Added, #1: 1	كَثْرَةِ الرَّمَادِ
u'كَثْرَةٌ رُوَاةٌ':Added, #1: 1	كَثْرَةُ الرُّوَاةِ
u'كَثْرَةٌ رِوايَةٌ':Added, #2: 2	كَثْرَةِ الرُّوَاةِ
u'كَثْرَةٌ ريعٌ':Added, #1: 1	كَثْرَةُ رِوَايَةِ
u'كَثْرَةٌ زِحامٌ':Added, #1: 1	كَثْرَةُ الرِّيعِ
u'كَثْرَةٌ زِحامٌ':Added, #1: 1	كَثْرَةُ الزِّحَامِ
u'كَثْرَةٌ زِحامٌ':Added, #1: 1	كَثْرَةُ زِحَامٍ
u'كَثْرَةٌ زَرْعٌ':Added, #2: 2	كَثْرَةِ الزِّحَامِ
u'كَثْرَةٌ زواجر':Added, #1: 1	كَثْرَةِ زَرْعِهِ
u'كَثْرَةٌ زِيادَةٌ':Added, #1: 1	كَثْرَةِ الزَّوَاجِرِ
u'كَثْرَةٌ زِيارَةٌ':Added, #1: 1	كَثْرَةِ زِيَادَةِ
u'كَثْرَةٌ زِيارَةٌ':Added, #1: 1	كَثْرَةَ زِيَارَةِ
u'كَثْرَةٌ سَبَبٌ':Added, #1: 1	كَثْرَةِ زِيَارَةِ
u'كَثْرَةٌ سُجُودٌ':Added, #1: 1	كَثْرَةِ سَبَبِهِ
u'كَثْرَةٌ سُجُودٌ':Added, #1: 1	كَثْرَةُ السُّجُودِ
u'كَثْرَةٌ سُكَّانٌ':Added, #4: 4	كَثْرَةِ السُّجُودِ
u'كَثْرَةٌ سَمَاعٌ':Added, #1: 1	كَثْرَةَ السُّكَّانِ
u'كَثْرَةٌ سُؤَالٌ':Added, #1: 1	كَثْرَةِ سَمَاعِهِ
u'كَثْرَةٌ سُؤَالٌ':Added, #3: 3	كَثْرَةُ السُّؤَالِ
u'كَثْرَةٌ شرب':Added, #3: 3	كَثْرَةِ السُّؤَالِ
u'كَثْرَةٌ شُرْبٌ':Added, #1: 1	كَثْرَةُ شُرْبِهِ
u'كَثْرَةٌ شركاء':Added, #1: 1	كَثْرَةُ شُرْبِهِ
u'كَثْرَةٌ شَعْرٌ':Added, #1: 1	كَثْرَةِ الشُّرَكَاءِ
u'كَثْرَةٌ شُغْلٌ':Added, #1: 1	كَثْرَةَ الشَّعْرِ
u'كَثْرَةٌ شُغْل':Added, #2: 2	كَثْرَةِ شُغْلٍ
u'كَثْرَةٌ شَهَادَةٌ':Added, #2: 2	كَثْرَةِ شُغْلٍ
u'كَثْرَةٌ شوَاهِدُ':Added, #1: 1	كَثْرَةَ شَهَادَةِ
u'كَثْرَةٌ شَوَاهِدُ':Added, #1: 1	كَثْرَةِ شَوَاهِدِهِ
u'كَثْرَةٌ شَوْكٌ':Added, #1: 1	كَثْرَةِ شَوَاهِدِهِ
u'كَثْرَةٌ شَوْكِ':Added, #1: 1	كَثْرَةِ الشَّوْكِ
u'كَثْرَةٌ شَيْءٌ':Added, #1: 1	كَثْرَةِ الشَّوْكِ
u'كَثْرَةٌ شِيَاهٌ':Added, #1: 1	كَثْرَةِ الشَّيْءِ
u'كَثْرَةٌ صحبة':Added, #1: 1	كَثْرَةُ الشِّيَاهِ
u'كَثْرَةٌ صحبة':Added, #1: 1	كَثْرَةُ الصُّحْبَةِ
u'كَثْرَةٌ صُحْبَةٌ':Added, #1: 1	كَثْرَةِ الصُّحْبَةِ
u'كَثْرَةٌ صُحْبَةٌ':Added, #1: 1	كَثْرَةُ الصُّحْبَةِ
u'كَثْرَةٌ صداق':Added, #1: 1	كَثْرَةِ الصُّحْبَةِ
u'كَثْرَةٌ صَدَاقٌ':Added, #2: 2	كَثْرَةِ الصَّدَاقِ
u'كَثْرَةٌ صدقة':Added, #2: 2	كَثْرَةِ الصَّدَاقِ
u'كَثْرَةٌ صَدَقَةٌ':Added, #1: 1	كَثْرَةِ الصَّدَقَةِ
u'كَثْرَةٌ صَلاَةٌ':Added, #1: 1	كَثْرَةِ الصَّدَقَةِ
u'كَثْرَةٌ صَلاَةٌ':Added, #1: 1	كَثْرَةُ الصَّلَاةِ
u'كَثْرَةٌ صَوْمٌ':Added, #1: 1	كَثْرَةِ الصَّلاَةِ
u'كَثْرَةٌ ضحك':Added, #2: 2	كَثْرَةِ الصَّوْمِ
u'كَثْرَةٌ ضَحِكٌ':Added, #4: 4	كَثْرَةَ الضَّحِكِ
u'كَثْرَةٌ ضَرْبٌ':Added, #4: 4	كَثْرَةَ الضَّحِكِ
u'كَثْرَةٌ ضَرْبٌ':Added, #1: 1	كَثْرَةُ الضَّرْبِ
u'كَثْرَةٌ طَاعَةٌ':Added, #1: 1	كَثْرَةِ الضَّرْبِ
u'كَثْرَةٌ طُرُقٌ':Added, #1: 1	كَثْرَةِ الطَّاعَةِ
u'كَثْرَةٌ طِلاَءٌ':Added, #1: 1	كَثْرَةِ الطُّرُقِ
u'كَثْرَةٌ طِيبٌ':Added, #1: 1	كَثْرَةَ طِلَاءِ
u'كَثْرَةٌ عَائِلٌ':Added, #1: 1	كَثْرَةُ الطِّيبِ
u'كَثْرَةٌ عِبَادَةٌ':Added, #1: 1	كَثْرَةِ عَائِلَةٍ
u'كَثْرَةٌ عِبَادَةٌ':Added, #1: 1	كَثْرَةُ عِبَادَةِ
u'كَثْرَةٌ عتاب':Added, #2: 2	كَثْرَةِ الْعِبَادَةِ
u'كَثْرَةٌ عِتَابٌ':Added, #1: 1	كَثْرَةَ الْعِتَابِ
u'كَثْرَةٌ عَدَدٌ':Added, #1: 1	كَثْرَةَ الْعِتَابِ
u'كَثْرَةٌ عَدَدٌ':Added, #1: 1	كَثْرَةَ الْعَدَدِ
u'كَثْرَةٌ عَدَدٌ':Added, #1: 1	كَثْرَةِ عَدَدٍ
u'كَثْرَةٌ عَدَدٌ':Added, #3: 3	كَثْرَةُ الْعَدَدِ
u'كَثْرَةٌ عَدُوٌّ':Added, #6: 6	كَثْرَةِ الْعَدَدِ
u'كَثْرَةٌ عَرَضٌ':Added, #2: 2	كَثْرَةُ الْعَدُوِّ
u'كَثْرَةٌ عَرَقٌ':Added, #2: 2	كَثْرَةِ الْعَرَضِ
u'كَثْرَةٌ عُرُوضٌ':Added, #1: 1	كَثْرَةِ الْعَرَقِ
u'كَثْرَةٌ علم':Added, #1: 1	كَثْرَةِ عُرُوضِ
u'كَثْرَةٌ عِلْمٌ':Added, #1: 1	كَثْرَةَ الْعِلْمِ
u'كَثْرَةٌ عَمَلٌ':Added, #1: 1	كَثْرَةَ الْعِلْمِ
u'كَثْرَةٌ عَمَلٌ':Added, #1: 1	كَثْرَةَ الْعَمَلِ
u'كَثْرَةٌ عَمَلٌ':Added, #1: 1	كَثْرَةِ الْعَمَلِ
u'كَثْرَةٌ عَمَلٌ':Added, #1: 1	كَثْرَةُ عَمَلٍ
u'كَثْرَةٌ عِيَالٌ':Added, #3: 3	كَثْرَةِ عَمَلٍ
u'كَثْرَةٌ عِيَالٌ':Added, #1: 1	كَثْرَةَ الْعِيَالِ
u'كَثْرَةٌ عِيَالٌ':Added, #1: 1	كَثْرَةَ عِيَالِهِ
u'كَثْرَةٌ عِيَالٌ':Added, #2: 2	كَثْرَةُ الْعِيَالِ
u'كَثْرَةٌ غبار':Added, #3: 3	كَثْرَةِ الْعِيَالِ
u'كَثْرَةٌ غُبَارٌ':Added, #1: 1	كَثْرَةِ الْغُبَارِ
u'كَثْرَةٌ غَرَرٌ':Added, #1: 1	كَثْرَةِ الْغُبَارِ
u'كَثْرَةٌ غضب':Added, #3: 3	كَثْرَةِ الْغَرَرِ
u'كَثْرَةٌ غَضَبٌ':Added, #1: 1	كَثْرَةَ الْغَضَبِ
u'كَثْرَةٌ غفلة':Added, #1: 1	كَثْرَةَ الْغَضَبِ
u'كَثْرَةٌ غَفْلَةٌ':Added, #1: 1	كَثْرَةُ الْغَفْلَةِ
u'كَثْرَةٌ فَاعِلٌ':Added, #1: 1	كَثْرَةُ الْغَفْلَةِ
u'كَثْرَةٌ فَائِدَةٌ':Added, #1: 1	كَثْرَةَ الْفَاعِلِ
u'كَثْرَةٌ فَائِدَةٌ':Added, #1: 1	كَثْرَةَ الْفَائِدَةِ
u'كَثْرَةٌ فُرُوعٌ':Added, #2: 2	كَثْرَةِ الْفَائِدَةِ
u'كَثْرَةٌ فُرُوعٌ':Added, #1: 1	كَثْرَةَ الْفُرُوعِ
u'كَثْرَةٌ فَضَائِلُ':Added, #1: 1	كَثْرَةِ الْفُرُوعِ
u'كَثْرَةٌ فِعْلٌ':Added, #1: 1	كَثْرَةُ فَضَائِلِهِ
u'كَثْرَةٌ قَدْرٌ':Added, #2: 2	كَثْرَةُ الْفِعْلِ
u'كَثْرَةٌ قِرَاءةٌ':Added, #1: 1	كَثْرَةِ الْقَدْرِ
u'كَثْرَةٌ قِرَاءةٌ':Added, #1: 1	كَثْرَةُ الْقِرَاءَةِ
u'كَثْرَةٌ قِرَاءةٌ':Added, #1: 1	كَثْرَةُ قِرَاءَةِ
u'كَثْرَةٌ قَصْدٌ':Added, #1: 1	كَثْرَةِ قِرَاءَتِهِ
u'كَثْرَةٌ قَوْمٌ':Added, #1: 1	كَثْرَةُ الْقَصْدِ
u'كَثْرَةٌ قَوْمٌ':Added, #1: 1	كَثْرَةُ قَوْمِهِ
u'كَثْرَةٌ قِيمَةٌ':Added, #3: 3	كَثْرَةِ الْقَوْمِ
u'كَثْرَةٌ قِيمَةٌ':Added, #1: 1	كَثْرَةِ قِيمَةِ
u'كَثْرَةٌ كِتَابَةٌ':Added, #1: 1	كَثْرَةَ قِيمَتِهِ
u'كَثْرَةٌ كَذِبٌ':Added, #1: 1	كَثْرَةِ الْكِتَابَةِ
u'كَثْرَةٌ كُفَّارٌ':Added, #1: 1	كَثْرَةُ كَذِبٍ
u'كَثْرَةٌ كَلاَمٌ':Added, #1: 1	كَثْرَةِ الْكُفَّارِ
u'كَثْرَةٌ كَلاَمٌ':Added, #3: 3	كَثْرَةَ الْكَلَامِ
u'كَثْرَةٌ كَلاَمٌ':Added, #5: 5	كَثْرَةِ الْكَلَامِ
u'كَثْرَةٌ كَمَالٌ':Added, #8: 8	كَثْرَةُ الْكَلَامِ
u'كَثْرَةٌ لبن':Added, #2: 2	كَثْرَةِ كَمَالِ
u'كَثْرَةٌ لَبَنٌ':Added, #1: 1	كَثْرَةُ اللَّبَنِ
u'كَثْرَةٌ لبن':Added, #1: 1	كَثْرَةُ اللَّبَنِ
u'كَثْرَةٌ لَبَنٌ':Added, #4: 4	كَثْرَةَ اللَّبَنِ
u'كَثْرَةٌ لَحْمٌ':Added, #4: 4	كَثْرَةَ اللَّبَنِ
u'كَثْرَةٌ لَحْمٌ':Added, #1: 1	كَثْرَةَ اللَّحْمِ
u'كَثْرَةٌ لَحْنٌ':Added, #1: 1	كَثْرَةُ اللَّحْمِ
u'كَثْرَةٌ مَاءٌ':Added, #1: 1	كَثْرَةُ اللَّحْنِ
u'كَثْرَةٌ مَاءٌ':Added, #3: 3	كَثْرَةَ الْمَاءِ
u'كَثْرَةٌ مَاءٌ':Added, #6: 6	كَثْرَةُ الْمَاءِ
u'كَثْرَةٌ مَالٌ':Added, #7: 7	كَثْرَةِ الْمَاءِ
u'كَثْرَةٌ مَالٌ':Added, #1: 1	كَثْرَةُ مَالٍ
u'كَثْرَةٌ مَالٌ':Added, #1: 1	كَثْرَةُ مَالِ
u'كَثْرَةٌ مَالٌ':Added, #2: 2	كَثْرَةِ مَالِهِ
u'كَثْرَةٌ مَالٌ':Added, #4: 4	كَثْرَةَ الْمَالِ
u'كَثْرَةٌ مَالٌ':Added, #5: 5	كَثْرَةُ الْمَالِ
u'كَثْرَةٌ مُتَعَدِّدٌ':Added, #6: 6	كَثْرَةِ الْمَالِ
u'كَثْرَةٌ مُتَوَقَّعٌ':Added, #1: 1	كَثْرَةِ الْمُتَعَدِّدِ
u'كَثْرَةٌ مَجِيءٌ':Added, #1: 1	كَثْرَةِ الْمُتَوَقَّعِ
u'كَثْرَةٌ مُحَصَّل':Added, #1: 1	كَثْرَةِ الْمَجِيءِ
u'كَثْرَةٌ مُخَاصَمَةٌ':Added, #1: 1	كَثْرَةِ الْمُحَصَّلِ
u'كَثْرَةٌ مُخَاصَمَةٌ':Added, #2: 2	كَثْرَةَ الْمُخَاصَمَةِ
u'كَثْرَةٌ مُخَالَطَةٌ':Added, #2: 2	كَثْرَةِ الْمُخَاصَمَةِ
u'كَثْرَةٌ مُخَالَفَةٌ':Added, #1: 1	كَثْرَةَ الْمُخَالَطَةِ
u'كَثْرَةٌ مَخْصُوصٌ':Added, #1: 1	كَثْرَةِ الْمُخَالَفَةِ
u'كَثْرَةٌ مَدِيحٌ':Added, #1: 1	كَثْرَةٍ مَخْصُوصَةٍ
u'كَثْرَةٌ مرٌّ':Added, #1: 1	كَثْرَةُ مَدِيحِ
u'كَثْرَةٌ مَرَّةٌ':Added, #1: 1	كَثْرَةِ الْمَرَّاتِ
u'كَثْرَةٌ مِزَاحٌ':Added, #1: 1	كَثْرَةِ الْمَرَّاتِ
u'كَثْرَةٌ مَسْأَلَةٌ':Added, #1: 1	كَثْرَةُ الْمِزَاحِ
u'كَثْرَةٌ مَشَقَّةٌ':Added, #1: 1	كَثْرَةُ الْمَسْأَلَةِ
u'كَثْرَةٌ مَشْيٌ':Added, #1: 1	كَثْرَةَ الْمَشَقَّةِ
u'كَثْرَةٌ مُضَاعَفٌ':Added, #1: 1	كَثْرَةِ الْمَشْيِ
u'كَثْرَةٌ مُضَاعَفٌ':Added, #1: 1	كَثْرَةَ الْمُضَاعَفَةِ
u'كَثْرَةٌ مُضَاعَفَةٌ':Added, #1: 1	كَثْرَةُ مُضَاعَفَةِ
u'كَثْرَةٌ مُضَاعَفَةٌ':Added, #1: 1	كَثْرَةَ الْمُضَاعَفَةِ
u'كَثْرَةٌ مُطَالَعَةٌ':Added, #1: 1	كَثْرَةُ مُضَاعَفَةِ
u'كَثْرَةٌ مَطَرٌ':Added, #1: 1	كَثْرَةِ مُطَالَعَتِهِ
u'كَثْرَةٌ مَطَرٌ':Added, #1: 1	كَثْرَةَ الْمَطَرِ
u'كَثْرَةٌ مُعَارَضَةٌ':Added, #1: 1	كَثْرَةِ الْمَطَرِ
u'كَثْرَةٌ مَعْلُومٌ':Added, #1: 1	كَثْرَةِ الْمُعَارَضَةِ
u'كَثْرَةٌ مَفْعُولٌ':Added, #1: 1	كَثْرَةِ الْمَعْلُومَاتِ
u'كَثْرَةٌ مَفْعُولٌ':Added, #1: 1	كَثْرَةُ الْمَفْعُولِ
u'كَثْرَةٌ مُقَابِلٌ':Added, #2: 2	كَثْرَةَ الْمَفْعُولِ
u'كَثْرَةٌ مَقَالٌ':Added, #1: 1	كَثْرَةِ مُقَابِلِهِ
u'كَثْرَةٌ مَقَالٌ':Added, #1: 1	كَثْرَةِ الْمَقَالِ
u'كَثْرَةٌ مَقَالَةٌ':Added, #2: 2	كَثْرَةُ الْمَقَالَاتِ
u'كَثْرَةٌ مُقَدِّمٌ':Added, #2: 2	كَثْرَةُ الْمَقَالَاتِ
u'كَثْرَةٌ مُقَدِّمٌ':Added, #1: 1	كَثْرَةُ الْمُقَدِّمَاتِ
u'كَثْرَةٌ مُقَدِّمَةٌ':Added, #2: 2	كَثْرَةِ الْمُقَدِّمَاتِ
u'كَثْرَةٌ مُقَدِّمَةٌ':Added, #1: 1	كَثْرَةُ الْمُقَدِّمَاتِ
u'كَثْرَةٌ مَقْرُوءٌ':Added, #2: 2	كَثْرَةِ الْمُقَدِّمَاتِ
u'كَثْرَةٌ ملح':Added, #1: 1	كَثْرَةِ الْمَقْرُوءِ
u'كَثْرَةٌ مِلْحٌ':Added, #1: 1	كَثْرَةُ الْمِلْحِ
u'كَثْرَةٌ مُلْكٌ':Added, #1: 1	كَثْرَةُ الْمِلْحِ
u'كَثْرَةٌ مُمَارَسٌ':Added, #1: 1	كَثْرَةُ الْمُلْكِ
u'كَثْرَةٌ مُمَارَسَةٌ':Added, #1: 1	كَثْرَةِ الْمُمَارَسَةِ
u'كَثْرَةٌ مُنَاظَرَةٌ':Added, #1: 1	كَثْرَةِ الْمُمَارَسَةِ
u'كَثْرَةٌ مَنَافِعُ':Added, #1: 1	كَثْرَةَ الْمُنَاظَرَةِ
u'كَثْرَةٌ مَهْرٌ':Added, #1: 1	كَثْرَةِ الْمَنَافِعِ
u'كَثْرَةٌ مُهُورٌ':Added, #1: 1	كَثْرَةَ الْمَهْرِ
u'كَثْرَةٌ مَوَاعِيدُ':Added, #1: 1	كَثْرَةِ مُهُورِ
u'كَثْرَةٌ مُوَافَقَةٌ':Added, #1: 1	كَثْرَةُ الْمَوَاعِيدِ
u'كَثْرَةٌ مَوْتٌ':Added, #1: 1	كَثْرَةِ الْمُوَافَقَةِ
u'كَثْرَةٌ مَوْتٌ':Added, #1: 1	كَثْرَةُ الْمَوْتِ
u'كَثْرَةٌ مُؤَنٌ':Added, #1: 1	كَثْرَةِ الْمَوْتِ
u'كَثْرَةٌ مِيرَاثٌ':Added, #1: 1	كَثْرَةُ الْمُؤَنِ
u'كَثْرَةٌ نَاسٌ':Added, #3: 3	كَثْرَةَ الْمِيرَاثِ
u'كَثْرَةٌ نَاسٌ':Added, #1: 1	كَثْرَةُ النّاسِ
u'كَثْرَةٌ نزاع':Added, #1: 1	كَثْرَةِ النَّاسِ
u'كَثْرَةٌ نِزَاعٌ':Added, #1: 1	كَثْرَةَ النِّزَاعِ
u'كَثْرَةٌ نِساءٌ':Added, #1: 1	كَثْرَةَ النِّزَاعِ
u'كَثْرَةٌ نِساءٌ':Added, #1: 1	كَثْرَةُ النِّسَاءِ
u'كَثْرَةٌ نَسْلٌ':Added, #1: 1	كَثْرَةِ النِّسَاءِ
u'كَثْرَةٌ نظائر':Added, #1: 1	كَثْرَةِ النَّسْلِ
u'كَثْرَةٌ نقل':Added, #2: 2	كَثْرَةُ النَّظَائِرِ
u'كَثْرَةٌ نَقْلٌ':Added, #1: 1	كَثْرَةِ النَّقْلِ
u'كَثْرَةٌ نقل':Added, #1: 1	كَثْرَةِ النَّقْلِ
u'كَثْرَةٌ نَقْلٌ':Added, #1: 1	كَثْرَةِ نَقْلِهِ
u'كَثْرَةٌ نَوْمٌ':Added, #1: 1	كَثْرَةِ نَقْلِهِ
u'كَثْرَةٌ هَذَيَانٌ':Added, #1: 1	كَثْرَةِ نَوْمِهِ
u'كَثْرَةٌ وُجُوبٌ':Added, #1: 1	كَثْرَةُ الْهَذَيَانِ
u'كَثْرَةٌ وُجُودٌ':Added, #2: 2	كَثْرَةِ الْوُجُوبِ
u'كَثْرَةٌ وُجُودٌ':Added, #1: 1	كَثْرَةُ الْوُجُودِ
u'كَثْرَةٌ وُرُودٌ':Added, #1: 1	كَثْرَةُ وُجُودِ
u'كَثْرَةٌ وَسَاوِسُ':Added, #1: 1	كَثْرَةُ وُرُودِهِ
u'كَثْرَةٌ وُقُوعٌ':Added, #1: 1	كَثْرَةِ وَسَاوِسِهِ
u'كَثْرَةٌ وُقُوعٌ':Added, #1: 1	كَثْرَةُ الْوُقُوعِ
u'كَثْرَةٌ وُقُوعٌ':Added, #1: 1	كَثْرَةِ وُقُوعِ
u'كَثْرَةٌ وُقُوعٌ':Added, #1: 1	كَثْرَةَ وُقُوعِهِ
u'كَثْرَةٌ وَلاَئِمُ':Added, #2: 2	كَثْرَةِ وُقُوعِهِ
u'كَثْرَةٌ يُبْسٌ':Added, #1: 1	كَثْرَةُ الْوَلَائِمِ
u'كَثُرَ تَجَوُّزٌ':Subject, #1: 1	كَثْرَةُ يُبْسِ
u'كَثُرَ تَحَلُّلٌ':Subject, #1: 1	كَثُرَ التَّجَوُّزُ
u'كَثُرَ تُرَابٌ':Subject, #1: 1	كَثُرَ التَّحَلُّلُ
u'كَثُرَ تَرَدُّدٌ':Subject, #1: 1	كَثُرَ التُّرَابُ
u'كَثُرَ تَشْنِيعٌ':Subject, #1: 1	كَثُرَ تَرَدُّدٌ
u'كَثُرَ تَشَوُّفٌ':Subject, #1: 1	كَثُرَ التَّشْنِيعُ
u'كَثُرَ تَصَرُّفٌ':Subject, #1: 1	كَثُرَ تَشَوُّفُ
u'كَثُرَ تَطَلُّعٌ':Subject, #1: 1	كَثُرَ تَصَرُّفُهُ
u'كَثُرَ تَطْلِيقٌ':Subject, #1: 1	كَثُرَ تَطَلُّعُهُ
u'كَثُرَ تَعَدُّدٌ':Subject, #1: 1	كَثُرَ تَطْلِيقُهُ
u'كَثُرَ تُفَّاحٌ':Subject, #1: 1	كَثُرَ التَّعَدُّدُ
u'كَثُرَ تَفْصِيلٌ':Subject, #2: 2	كَثُرَ التُّفَّاحُ
u'كَثُرَ تَفَكُّرٌ':Subject, #1: 1	كَثُرَ تَفْصِيلُهُ
u'كَثُرَ تَوَلُّدٌ':Subject, #1: 1	كَثُرَ تَفَكُّرُهُ
u'كَثُرَ ثَمَرٌ':Subject, #1: 1	كَثُرَ تَوَلُّدُ
u'كَثُرَ ثَمَنٌ':Subject, #1: 1	كَثُرَ الثَّمَرُ
u'كَثُرَ ثَوابٌ':Subject, #1: 1	كَثُرَ ثَمَنُهُ
u'كَثُرَ جَائِزٌ':Subject, #1: 1	كَثُرَ ثَوَابُهُ
u'كَثَّرَ جَرَّاحٌ':Subject, #1: 1	كَثُرَ جَائِزٌ
u'كَثُرَ جمع':Subject, #1: 1	كَثَّرَ الْجَرَّاحُ
u'كَثُرَ جَمْعٌ':Subject, #2: 2	كَثُرَ جَمْعُهُ
u'كَثُرَ جُنَاةٌ':Subject, #2: 2	كَثُرَ جَمْعُهُ
u'كَثُرَ جناح':Subject, #1: 1	كَثُرَ الْجُنَاةُ
u'كَثُرَ جَنَاحٌ':Subject, #1: 1	كَثُرَ الْجَنَاحُ
u'كَثُرَ جُهَّالٌ':Subject, #1: 1	كَثُرَ الْجَنَاحُ
u'كَثُرَ حَديثٌ':Subject, #1: 1	كَثُرَ الْجُهَّالُ
u'كَثُرَ حُسَّادٌ':Subject, #1: 1	كَثُرَ الْحَدِيثُ
u'كَثُرَ حُضورٌ':Subject, #1: 1	كَثُرَ حُسَّادُهُ
u'كَثُرَ حُضُورٌ':Subject, #1: 1	كَثُرَ حُضُورُهُ
u'كَثُرَ حقد':Subject, #1: 1	كَثُرَ حُضُورُهُ
u'كَثُرَ حِقد':Subject, #1: 1	كَثُرَ حِقْدُهُ
u'كَثُرَ حِقْدٌ':Subject, #1: 1	كَثُرَ حِقْدُهُ
u'كَثُرَ حِلٌّ':Subject, #1: 1	كَثُرَ حِقْدُهُ
u'كَثُرَ حَلالٌ':Subject, #1: 1	كَثُرَ الْحِلُّ
u'كَثُرَ خُبْثٌ':Subject, #1: 1	كَثُرَ الْحَلَالُ
u'كَثُرَ خَمْسَةٌ':Subject, #1: 1	كَثُرَ الْخُبْثُ
u'كَثُرَ خَوْضٌ':Subject, #1: 1	كَثُرَ خَمْسَةُ
u'كَثُرَ دفع':Subject, #1: 1	كَثُرَ الْخَوْضُ
u'كَثُرَ دَفْعٌ':Subject, #2: 2	كَثُرَ دَفْعُ
u'كَثُرَ دَمٌ':Subject, #2: 2	كَثُرَ دَفْعُ
u'كَثُرَ دَمٌ':Subject, #1: 1	كَثُرَ الدَّمُ
u'كَثُرَ دَوْرٌ':Subject, #1: 1	كَثُرَ دَمُهُ
u'كَثُرَ دونٌ':Predicate, #1: 1	كَثُرَ دَوْرُ
u'كَثُرَ دَيْنٌ':Subject, #1: 1	كَثُرَ دُونَ
u'كَثُرَ ذَرْقٌ':Subject, #1: 1	كَثُرَ دَيْنُهُ
u'كَثُرَ رَدٌّ':Subject, #1: 1	كَثُرَ ذَرْقُ
u'كَثُرَ رَفْضٌ':Subject, #1: 1	كَثُرَ الرَّدُّ
u'كَثُرَ رُكوبٌ':Subject, #1: 1	كَثُرَ الرَّفْضُ
u'كَثُرَ رُكوعٌ':Subject, #1: 1	كَثُرَ رُكُوبُهُ
u'كَثُرَ ريعٌ':Subject, #2: 2	كَثُرَ رُكُوعُهُ
u'كَثُرَ زَعْمٌ':Subject, #1: 1	كَثُرَ الرِّيعُ
u'كَثُرَ زَمَنٌ':Subject, #1: 1	كَثُرَ الزَّعْمُ
u'كَثُرَ زَيْتٌ':Subject, #2: 2	كَثُرَ زَمَنُ
u'كَثُرَ سقط':Subject, #1: 1	كَثُرَ زَيْتُهُ
u'كَثُرَ سُلُوكٌ':Subject, #1: 1	كَثُرَ سَقْطُهُ
u'كَثُرَ سُلُوك':Subject, #1: 1	كَثُرَ سُلُوكُ
u'كَثَّرَ سَوادٌ':Predicate, #1: 1	كَثُرَ سُلُوكُ
u'كَثُرَ سُؤَالٌ':Subject, #4: 4	كَثَّرَ سَوَادَ
u'كَثُرَ شرب':Subject, #7: 7	كَثُرَ السُّؤَالُ
u'كَثُرَ شُرْبٌ':Subject, #3: 3	كَثُرَ شُرْبُهُ
u'كَثُرَ شَطَطٌ':Subject, #3: 3	كَثُرَ شُرْبُهُ
u'كَثُرَ شَعْرٌ':Subject, #1: 1	كَثُرَ شَطَطُهُ
u'كَثُرَ شَعَرٌ':Subject, #1: 1	كَثُرَ شَعْرُ
u'كَثُرَ شَغَبٌ':Subject, #1: 1	كَثُرَ شَعَرُهُ
u'كَثُرَ شَقٌّ':Subject, #1: 1	كَثُرَ الشَّغَبُ
u'كَثُرَ شَكٌّ':Subject, #1: 1	كَثُرَ شَقُّهُ
u'كَثُرَ شُهُودٌ':Subject, #1: 1	كَثُرَ شَكُّهُ
u'كَثُرَ شَيْءٌ':Subject, #2: 2	كَثُرَ الشُّهُودُ
u'كَثُرَ صَدِيقٌ':Subject, #1: 1	كَثُرَ شَيْءٌ
u'كَثُرَ صَوَابٌ':Subject, #1: 1	كَثُرَ صَدِيقُهُ
u'كَثُرَ ضحك':Subject, #1: 1	كَثُرَ صَوَابُهُ
u'كَثُرَ ضَحِكٌ':Subject, #2: 2	كَثُرَ ضَحِكُهُ
u'كَثُرَ ضَرَرٌ':Subject, #2: 2	كَثُرَ ضَحِكُهُ
u'كَثُرَ طُرُوقٌ':Subject, #1: 1	كَثُرَ ضَرَرُهُ
u'كَثُرَ عَبَثٌ':Subject, #1: 1	كَثُرَ طُرُوقُهُ
u'كَثُرَ عَدَدٌ':Subject, #1: 1	كَثُرَ الْعَبَثُ
u'كَثُرَ عَدَدٌ':Subject, #3: 3	كَثُرَ الْعَدَدُ
u'كَثُرَ عَدُوٌّ':Subject, #7: 7	كَثُرَ عَدَدُ
u'كَثُرَ عَدُوٌّ':Subject, #1: 1	كَثُرَ الْعَدُوُّ
u'كَثُرَ عَسْكَرٌ':Subject, #1: 1	كَثُرَ عَدُوُّهُ
u'كَثُرَ عَصْرٌ':Subject, #1: 1	كَثُرَ الْعَسْكَرُ
u'كَثُرَ عَمَلٌ':Subject, #1: 1	كَثُرَ عَصْرُهُ
u'كَثُرَ عند':Predicate, #1: 1	كَثُرَ الْعَمَلُ
u'كَثُرَ عِيَالٌ':Subject, #2: 2	كَثُرَ عِنْدَ
u'كَثُرَ غبار':Subject, #1: 1	كَثُرَ عِيَالُهُ
u'كَثُرَ غُبَارٌ':Subject, #1: 1	كَثُرَ الْغُبَارُ
u'كَثُرَ غَبْنٌ':Subject, #1: 1	كَثُرَ الْغُبَارُ
u'كَثُرَ غَرَرٌ':Subject, #2: 2	كَثُرَ الْغَبْنُ
u'كَثُرَ غرماء':Subject, #1: 1	كَثُرَ الْغَرَرُ
u'كَثُرَ غفر':Predicate, #1: 1	كَثُرَ الْغُرَمَاءُ
u'كَثُرَ غَفَرٌ':Predicate, #1: 1	كَثُرَ غَفَرَ
u'كَثُرَ غَلَطٌ':Subject, #1: 1	كَثُرَ غَفَرَ
u'كَثُرَ غيم':Subject, #1: 1	كَثُرَ غَلَطُهُ
u'كَثُرَ غَيْمٌ':Subject, #1: 1	كَثُرَ الْغَيْمُ
u'كَثُرَ فِسْقٌ':Subject, #1: 1	كَثُرَ الْغَيْمُ
u'كَثُرَ فَضْلٌ':Subject, #1: 1	كَثُرَ الْفِسْقُ
u'كَثُرَ فَضْلٌ':Subject, #1: 1	كَثُرَ فَضْلُ
u'كَثُرَ فلان':Subject, #1: 1	كَثُرَ فَضْلُهُ
u'كَثُرَ قَالٌ':Predicate, #1: 1	كَثُرَ اللُّوطِيَّةُ
u'كَثُرَ قتل':Subject, #1: 1	كَثُرَ قَالَ
u'كَثُرَ قَتْلٌ':Subject, #3: 3	كَثُرَ الْقَتْلُ
u'كَثُرَ قذف':Subject, #3: 3	كَثُرَ الْقَتْلُ
u'كَثُرَ قَذْفٌ':Subject, #1: 1	كَثُرَ الْقَذْفُ
u'كَثُرَ قَصْدٌ':Subject, #1: 1	كَثُرَ الْقَذْفُ
u'كَثُرَ قول':Subject, #1: 1	كَثُرَ قَصْدُهُ
u'كَثُرَ قَوْلٌ':Subject, #1: 1	كَثُرَ قَوْلُهُ
u'كَثُرَ قول':Subject, #1: 1	كَثُرَ قَوْلُهُ
u'كَثُرَ قَوْلٌ':Subject, #2: 2	كَثُرَ الْقَوْلُ
u'كَثُرَ قَوْمٌ':Subject, #2: 2	كَثُرَ الْقَوْلُ
u'كَثُرَ كَلاَمٌ':Subject, #1: 1	كَثُرَ الْقَوْمُ
u'كَثُرَ كَلاَمٌ':Subject, #2: 2	كَثُرَ كَلَامُ
u'كَثُرَ كَوْنٌ':Subject, #2: 2	كَثُرَ كَلَامُهُ
u'كَثُرَ لَحْمٌ':Subject, #1: 1	كَثُرَ كَوْنُ
u'كَثُرَ لَغْوٌ':Subject, #2: 2	كَثُرَ لَحْمُهُ
u'كَثُرَ لُوطِيّ':Subject, #1: 1	كَثُرَ لَغْوٌ
u'كَثُرَ مَاءٌ':Subject, #1: 1	كَثُرَ اللُّوطِيَّةُ
u'كَثُرَ مَالٌ':Subject, #3: 3	كَثُرَ الْمَاءُ
u'كَثُرَ مَالٌ':Subject, #1: 1	كَثُرَ مَالُ
u'كَثُرَ مَالٌ':Subject, #5: 5	كَثُرَ مَالُهُ
u'كَثُرَ مَائِعٌ':Subject, #8: 8	كَثُرَ الْمَالُ
u'كَثُرَ مُحَرَّمٌ':Subject, #1: 1	كَثُرَ الْمَائِعُ
u'كَثُرَ مِزَاحٌ':Subject, #1: 1	كَثُرَ الْمُحَرَّمَاتُ
u'كَثُرَ مُزَاحِمٌ':Subject, #1: 1	كَثُرَ مِزَاحُهُ
u'كَثُرَ مَطْعَمٌ':Subject, #1: 1	كَثُرَ الْمُزَاحِمُ
u'كَثُرَ مُلاَزَمَةٌ':Subject, #1: 1	كَثُرَ مَطْعَمُهُ
u'كَثُرَ مَوْتٌ':Subject, #1: 1	كَثُرَ مُلَازَمَةُ
u'كَثُرَ نَاسٌ':Subject, #1: 1	كَثُرَ الْمَوْتُ
u'كَثُرَ نَزَوَانٌ':Subject, #20: 20	كَثُرَ النَّاسُ
u'كَثُرَ نَسْلٌ':Subject, #2: 2	كَثُرَ نَزَوَانُهُ
u'كَثُرَ نَصِيبٌ':Subject, #1: 1	كَثُرَ نَسْلُهُ
u'كَثُرَ نَفَلٌ':Subject, #1: 1	كَثُرَ النَّصِيبُ
u'كَثُرَ نَقْصٌ':Subject, #1: 1	كَثُرَ النَّفَلُ
u'كَثُرَ نُهُوضٌ':Subject, #1: 1	كَثُرَ النَّقْصُ
u'كَثُرَ نَوْمٌ':Subject, #2: 2	كَثُرَ نُهُوضُهُ
u'كَثُرَ هَزْلٌ':Subject, #1: 1	كَثُرَ نَوْمُهُ
u'كَثُرَ هَمٌّ':Subject, #1: 1	كَثُرَ هَزْلُهُ
u'كَثُرَ وُجُودٌ':Subject, #1: 1	كَثُرَ هَمُّهُ
u'كَثُرَ وَزْنٌ':Subject, #2: 2	كَثُرَ وُجُودُهُ
u'كَثُرَ وَسَخٌ':Subject, #1: 1	كَثُرَ وَزْنُهُ
u'كَثُرَ وَسَخٌ':Subject, #1: 1	كَثُرَ الْوَسَخُ
u'كَثُرَ وَصْفٌ':Subject, #1: 1	كَثُرَ وَسَخُهُ
u'كَثُرَ وَصْفٌ':Subject, #1: 1	كَثُرَ الْوَصْفُ
u'كَثُرَ وُقُوعٌ':Subject, #1: 1	كَثُرَ وَصْفُهُ
u'كَثُرَ وُقُوعٌ':Subject, #2: 2	كَثُرَ وُقُوعُ
u'كَدْحٌ طلب':Added, #2: 2	كَثُرَ وُقُوعُهُ
u'كَدْحٌ طَلَبٌ':Added, #1: 1	كَدْحِ الطَّلَبِ
u'كَذَبَ اِبْنٌ':Subject, #1: 1	كَدْحِ الطَّلَبِ
u'كذب اِبْنٌ':Added, #2: 2	كَذَبَ ابْنُ
u'كَذِبٌ اِبْنٌ':Added, #1: 1	كَذِبُ ابْنٍ
u'كذب آحَادٌ':Added, #1: 1	كَذِبُ ابْنٍ
u'كَذِبٌ آحَادٌ':Added, #2: 2	كَذِبُ الْآحَادِ
u'كَذَّبَ أحَدٌ':Predicate, #2: 2	كَذِبُ الْآحَادِ
u'كذب أحَدٌ':Added, #5: 5	كَذَّبَ أَحَدَ
u'كَذِبٌ أحَدٌ':Added, #2: 2	كَذِبَ أَحَدِ
u'كَذَّبَ أَصْحَابٌ':Subject, #2: 2	كَذِبَ أَحَدِ
u'كَذَّبَ أصل':Subject, #1: 1	كَذَّبَ أَصْحَابُ
u'كَذَّبَ أًصْلٌ':Subject, #1: 1	كَذَّبَ الْأَصْلُ
u'كَذَبَ أُصولٌ':Subject, #1: 1	كَذَّبَ الْأَصْلُ
u'كذب أُصولٌ':Added, #1: 1	كَذَبَ الْأُصُولُ
u'كَذِبٌ أُصولٌ':Added, #1: 1	كَذِبُ الْأُصُولِ
u'كَذَبَ أَعْدَاءٌ':Subject, #1: 1	كَذِبُ الْأُصُولِ
u'كَذَّبَ إقْرَارٌ':Predicate, #1: 1	كَذَبَ أَعْدَاءُ
u'كَذَّبَ أَكْثَرُ':Predicate, #1: 1	كَذَّبَ الْإِقْرَارَ
u'كَذَّبَ المُشْتَرِي':Predicate, #1: 1	كَذَّبَ أَكْثَرَ
u'كَذَّبَ آمِرٌ':Subject, #1: 1	كَذَّبَ الْمُشْتَرِيَ
u'كَذَبَ أَميرٌ':Subject, #1: 1	كَذَّبَ الْآمِرُ
u'كذب إِنْسانٌ':Added, #1: 1	كَذَبَ أَمِيرُ
u'كَذِبٌ إِنْسانٌ':Added, #1: 1	كَذِبُ الْإِنْسَانِ
u'كذب أهْلٌ':Added, #1: 1	كَذِبُ الْإِنْسَانِ
u'كَذِبٌ أهْلٌ':Added, #1: 1	كَذِبَ أَهْلِ
u'كَذَّبَ أَوَّلُ':Predicate, #1: 1	كَذِبَ أَهْلِ
u'كَذَّبَ أَوَّلُ':Subject, #2: 2	كَذَّبَ الْأَوَّلَ
u'كَذَّبَ بَائِعٌ':Subject, #1: 1	كَذَّبَ الْأَوَّلُ
u'كذب بَائِعٌ':Added, #1: 1	كَذَّبَ الْبَائِعُ
u'كَذِبٌ بَائِعٌ':Added, #3: 3	كَذِبُ الْبَائِعِ
u'كَذَبَ بَطَلٌ':Predicate, #3: 3	كَذِبُ الْبَائِعِ
u'كَذَّبَ بَعْضٌ':Subject, #1: 1	كَذَبَ بَطَلَ
u'كَذَبَ بَيْنٌ':Predicate, #1: 1	كَذَّبَ بَعْضٌ
u'كذب بَيِّنَةٌ':Added, #1: 1	كَذَبَ بَيْنَ
u'كَذِبٌ بَيِّنَةٌ':Added, #1: 1	كَذِبُ الْبَيِّنَةِ
u'كذب بَيِّنَةٌ':Added, #1: 1	كَذِبُ الْبَيِّنَةِ
u'كَذِبٌ بَيِّنَةٌ':Added, #2: 2	كَذِبَ الْبَيِّنَةِ
u'كَذَّبَ ثَانِي':Predicate, #2: 2	كَذِبَ الْبَيِّنَةِ
u'كذب جواد':Added, #1: 1	كَذَّبَ الثَّانِيَ
u'كَذِبٌ جواد':Added, #1: 1	كَذِبِ الْجَوَادِ
u'كذب جَوَادٌ':Added, #1: 1	كَذِبِ الْجَوَادِ
u'كَذِبٌ جَوَادٌ':Added, #1: 1	كَذِبِ الْجَوَادِ
u'كَذَبَ حَدٌّ':Subject, #1: 1	كَذِبِ الْجَوَادِ
u'كَذَبَ حَديثٌ':Subject, #1: 1	كَذَبَ الْحَدُّ
u'كذب خَبَرٌ':Added, #1: 1	كَذَبَ الْحَدِيثُ
u'كذب خَبَر':Added, #1: 1	كَذِبُ الْخَبَرِ
u'كَذِبٌ خَبَرٌ':Added, #1: 1	كَذِبُ الْخَبَرِ
u'كَذِبٌ خَبَر':Added, #1: 1	كَذِبُ الْخَبَرِ
u'كذب خَصْمٌ':Added, #1: 1	كَذِبُ الْخَبَرِ
u'كَذِبٌ خَصْمٌ':Added, #1: 1	كَذِبِ خَصْمِهِ
u'كَذَّبَ رَسُولٌ':Subject, #1: 1	كَذِبِ خَصْمِهِ
u'كَذَبَ رَسُولٌ':Subject, #1: 1	كَذَّبَ الرَّسُولُ
u'كَذَبَ زَيْدٌ':Subject, #1: 1	كَذَبَ رَسُولُ
u'كَذَبَ سَعْدٌ':Subject, #2: 2	كَذَبَ زَيْدٌ
u'كَذَّبَ شَارِعٌ':Predicate, #2: 2	كَذَبَ سَعْدٌ
u'كذب شَاهِدٌ':Added, #2: 2	كَذَّبَ الشَّارِعَ
u'كَذِبٌ شَاهِدٌ':Added, #1: 1	كَذِبَ الشَّاهِدِ
u'كذب شَاهِدٌ':Added, #1: 1	كَذِبَ الشَّاهِدِ
u'كَذِبٌ شَاهِدٌ':Added, #1: 1	كَذِبُ الشَّاهِدَيْنِ
u'كَذَّبَ شُهُودٌ':Predicate, #1: 1	كَذِبُ الشَّاهِدَيْنِ
u'كَذَبَ شُهُودٌ':Subject, #1: 1	كَذَّبَ الشُّهُودَ
u'كذب شُهُودٌ':Added, #4: 4	كَذَبَ شُهُودُ
u'كَذِبٌ شُهُودٌ':Added, #1: 1	كَذِبَ الشُّهُودِ
u'كذب شُهُودٌ':Added, #1: 1	كَذِبَ الشُّهُودِ
u'كَذِبٌ شُهُودٌ':Added, #2: 2	كَذِبُ الشُّهُودِ
u'كذب شُهُودٌ':Added, #2: 2	كَذِبُ الشُّهُودِ
u'كَذِبٌ شُهُودٌ':Added, #3: 3	كَذِبِ الشُّهُودِ
u'كَذَّبَ صَاحِبٌ':Predicate, #3: 3	كَذِبِ الشُّهُودِ
u'كَذَبَ عَبْدٌ':Subject, #1: 1	كَذَّبَ صَاحِبَ
u'كذب عَبْدٌ':Added, #4: 4	كَذَبَ الْعَبْدُ
u'كَذِبٌ عَبْدٌ':Added, #2: 2	كَذِبَ الْعَبْدِ
u'كَذَبَ عَدُوٌّ':Subject, #2: 2	كَذِبَ الْعَبْدِ
u'كَذَبَ عَلِيٌّ':Predicate, #2: 2	كَذَبَ عَدُوُّ
u'كَذِبٌ عَمْدٌ':Added, #1: 1	كَذَبَ عَلِيَّ
u'كَذَّبَ غرماء':Subject, #1: 1	كَذِبٍ عَمْدٍ
u'كذب غير':Added, #1: 1	كَذَّبَ الْغُرَمَاءُ
u'كذب غَيْرٌ':Added, #1: 1	كَذِبُ غَيْرِهِ
u'كَذِبٌ غير':Added, #1: 1	كَذِبُ غَيْرِهِ
u'كَذِبٌ غَيْرٌ':Added, #1: 1	كَذِبُ غَيْرِهِ
u'كَذِبٌ فَاحِشٌ':Added, #1: 1	كَذِبُ غَيْرِهِ
u'كذب فَرْعٌ':Added, #1: 1	كَذِبٍ فَاحِشٍ
u'كَذِبٌ فَرْعٌ':Added, #1: 1	كَذِبُ الْفَرْعِ
u'كذب فَرِيقٌ':Added, #1: 1	كَذِبُ الْفَرْعِ
u'كَذِبٌ فَرِيقٌ':Added, #3: 3	كَذِبُ الْفَرِيقَيْنِ
u'كَذَبَ فُلاَنٌ':Subject, #3: 3	كَذِبُ الْفَرِيقَيْنِ
u'كَذَبَ فُؤَادٌ':Subject, #1: 1	كَذَبَ فُلَانٌ
u'كَذَّبَ قَاتِلٌ':Subject, #2: 2	كَذَبَ الْفُؤَادُ
u'كذب قَاذِفٌ':Added, #1: 1	كَذَّبَ الْقَاتِلُ
u'كَذِبٌ قَاذِفٌ':Added, #3: 3	كَذِبِ الْقَاذِفِ
u'كَذَّبَ قَاضِي':Predicate, #3: 3	كَذِبِ الْقَاذِفِ
u'كَذَبَ قَالٌ':Predicate, #1: 1	كَذَّبَ الْقَاضِيَ
u'كَذَبَ كَعْبٌ':Subject, #2: 2	كَذَبَ قَالَ
u'كَذَّبَ مُجْمِعٌ':Predicate, #1: 1	كَذَبَ كَعْبٌ
u'كذب مَجْمُوعٌ':Added, #1: 1	كَذَّبَ الْمُجْمِعِينَ
u'كَذِبٌ مَجْمُوعٌ':Added, #1: 1	كَذِبَ مَجْمُوعِ
u'كذب مَجْنِيٌّ':Added, #1: 1	كَذِبَ مَجْمُوعِ
u'كَذِبٌ مَجْنِيٌّ':Added, #1: 1	كَذِبِ الْمَجْنِيِّ
u'كَذِبٌ مُحَرَّمٌ':Added, #1: 1	كَذِبِ الْمَجْنِيِّ
u'كَذَبَ مُخْبِرٌ':Subject, #1: 1	كَذِبٍ مُحَرَّمٍ
u'كَذَّبَ مُشْتَرِي':Predicate, #1: 1	كَذَبَ الْمُخْبِرُ
u'كَذَّبَ مُفْلِسٌ':Subject, #1: 1	كَذَّبَ الْمُشْتَرِيَ
u'كذب مُقَدِّمٌ':Added, #1: 1	كَذَّبَ الْمُفْلِسُ
u'كَذِبٌ مُقَدِّمٌ':Added, #1: 1	كَذِبَ الْمُقَدِّمَتَيْنِ
u'كذب مُنْكِرٌ':Added, #1: 1	كَذِبَ الْمُقَدِّمَتَيْنِ
u'كَذِبٌ مُنْكِرٌ':Added, #1: 1	كَذِبُ الْمُنْكِرِ
u'كَذَّبَ مُؤَذِّنٌ':Predicate, #1: 1	كَذِبُ الْمُنْكِرِ
u'كَذَّبَ نَصٌّ':Predicate, #1: 1	كَذَّبَ الْمُؤَذِّنَ
u'كَذَّبَ نَصْرَانِيٌّ':Subject, #1: 1	كَذَّبَ النَّصَّ
u'كذب نَفْسٌ':Added, #1: 1	كَذَّبَ نَصْرَانِيٌّ
u'كَذِبٌ نَفْسٌ':Added, #2: 2	كَذِبَ نَفْسِهِ
u'كَذَبَ نَقِيضٌ':Subject, #2: 2	كَذِبَ نَفْسِهِ
u'كذب نَقِيضٌ':Added, #1: 1	كَذَبَ نَقِيضُ
u'كَذِبٌ نَقِيضٌ':Added, #1: 1	كَذِبَ نَقِيضِ
u'كَذَبَ نَوْف':Subject, #1: 1	كَذِبَ نَقِيضِ
u'كَذَّبَ واحد':Predicate, #1: 1	كَذَبَ نَوْفٌ
u'كَذَّبَ وَاحِدٌ':Predicate, #2: 2	كَذَّبَ وَاحِدَةً
u'كَذَّبَ وَكِيلٌ':Subject, #2: 2	كَذَّبَ وَاحِدَةً
u'كذب وَكِيلٌ':Added, #1: 1	كَذَّبَ الْوَكِيلُ
u'كَذِبٌ وَكِيلٌ':Added, #1: 1	كَذِبِ الْوَكِيلِ
u'كَذَّبَ وَلِيٌّ':Subject, #1: 1	كَذِبِ الْوَكِيلِ
u'كَرَامَةٌ أخْلاقٌ':Added, #1: 1	كَذَّبَ الْوَلِيُّ
u'كَرَامَةٌ أَخْلاَقٌ':Added, #1: 1	كَرَامَةَ أَخْلَاقٍ
u'كَرَامَةٌ أَوْلِيَاءُ':Added, #1: 1	كَرَامَةَ أَخْلَاقٍ
u'كَرَامَةٌ رَسُولٌ':Added, #2: 2	كَرَامَةُ الْأَوْلِيَاءِ
u'كَرَامَةٌ صَاحِبٌ':Added, #1: 1	كَرَامَةُ رَسُولِهِ
u'كَرَامَةٌ صَاحِبٌ':Added, #1: 1	كَرَامَةَ صَاحِبِ
u'كَرَامَةٌ طَيٌّ':Added, #1: 1	كَرَامَةُ صَاحِبِهِ
u'كَرَامَةٌ طَيْرٌ':Added, #1: 1	كَرَامَةِ الطَّيِّ
u'كَرَامَةٌ ولد':Added, #1: 1	كَرَامَةِ الطَّيْرِ
u'كَرَامَةٌ وَلَدٌ':Added, #1: 1	كَرَامَةِ الْوَلَدِ
u'كَرَاهَةٌ إبدالٌ':Added, #1: 1	كَرَامَةِ الْوَلَدِ
u'كَرَاهَةٌ اِتِّخَاذٌ':Added, #2: 2	كَرَاهَةِ الْإِبْدَالِ
u'كَرَاهَةٌ اِجْتِمَاعٌ':Added, #1: 1	كَرَاهَةِ اتِّخَاذِ
u'كَرَاهَةٌ آجُرٌّ':Added, #1: 1	كَرَاهَةَ اجْتِمَاعِ
u'كَرَاهَةٌ أخْذٌ':Added, #1: 1	كَرَاهَةَ الْآجُرِّ
u'كَرَاهَةٌ إِخْرَاجٌ':Added, #2: 2	كَرَاهَةِ الْأَخْذِ
u'كَرَاهَةٌ أَخِيرٌ':Added, #2: 2	كَرَاهَةِ إخْرَاجِهِ
u'كَرَاهَةٌ إِدْمَانٌ':Added, #2: 2	كَرَاهَةُ الْأَخِيرِ
u'كَرَاهَةٌ أَذَانٌ':Added, #1: 1	كَرَاهَةُ إدْمَانِ
u'كَرَاهَةٌ أَذَانٌ':Added, #1: 1	كَرَاهَةَ أَذَانِ
u'كَرَاهَةٌ أَذَانٌ':Added, #1: 1	كَرَاهَةُ الْأَذَانِ
u'كَرَاهَةٌ إِزَالَةٌ':Added, #2: 2	كَرَاهَةِ أَذَانِ
u'كَرَاهَةٌ اِسْتِعْمالٌ':Added, #1: 1	كَرَاهَةِ إزَالَةِ
u'كَرَاهَةٌ اِسْتِعْمالٌ':Added, #1: 1	كَرَاهَةِ اسْتِعْمَالِهِ
u'كَرَاهَةٌ إِسْنادٌ':Added, #2: 2	كَرَاهَةَ اسْتِعْمَالِهِ
u'كَرَاهَةٌ اِشْتِمالٌ':Added, #1: 1	كَرَاهَةِ إسْنَادِ
u'كَرَاهَةٌ أَصْحَابٌ':Added, #1: 1	كَرَاهَةُ اشْتِمَالِ
u'كَرَاهَةٌ أَضْدادٌ':Added, #1: 1	كَرَاهَةِ أَصْحَابِهِ
u'كَرَاهَةٌ أَضْدَادٌ':Added, #1: 1	كَرَاهَةَ أَضْدَادِ
u'كَرَاهَةٌ إِطالَةٌ':Added, #1: 1	كَرَاهَةَ أَضْدَادِ
u'كَرَاهَةٌ إِطالَةٌ':Added, #1: 1	كَرَاهَةِ إطَالَةِ
u'كَرَاهَةٌ إِعانَةٌ':Added, #3: 3	كَرَاهَةُ إطَالَةِ
u'كَرَاهَةٌ إعْطَاءٌ':Added, #1: 1	كَرَاهَةُ إعَانَةِ
u'كَرَاهَةٌ أَعْمَالٌ':Added, #1: 1	كَرَاهَةُ الْإِعْطَاءِ
u'كَرَاهَةٌ إِفْرَادٌ':Added, #1: 1	كَرَاهَةِ أَعْمَالِ
u'كَرَاهَةٌ إِفْرَادٌ':Added, #2: 2	كَرَاهَةُ إفْرَادِهِ
u'كَرَاهَةٌ إِفْرَادٌ':Added, #3: 3	كَرَاهَةُ إفْرَادِ
u'كَرَاهَةٌ إقامَةٌ':Added, #4: 4	كَرَاهَةِ إفْرَادِ
u'كَرَاهَةٌ إقامَةٌ':Added, #1: 1	كَرَاهَةَ إقَامَةِ
u'كَرَاهَةٌ إقامَةٌ':Added, #1: 1	كَرَاهَةُ إقَامَةِ
u'كَرَاهَةٌ اِقْتِناءٌ':Added, #1: 1	كَرَاهَةِ إقَامَةِ
u'كَرَاهَةٌ إكْثَارٌ':Added, #1: 1	كَرَاهَةُ اقْتِنَاءِ
u'كَرَاهَةٌ أَكْثَرُ':Added, #1: 1	كَرَاهَةُ الْإِكْثَارِ
u'كَرَاهَةٌ أكل':Added, #1: 1	كَرَاهَةِ الْأَكْثَرِ
u'كَرَاهَةٌ أَكْلٌ':Added, #1: 1	كَرَاهَةَ أَكْلِهِ
u'كَرَاهَةٌ أكل':Added, #1: 1	كَرَاهَةَ أَكْلِهِ
u'كَرَاهَةٌ أَكْلٌ':Added, #2: 2	كَرَاهَةَ أَكْلِ
u'كَرَاهَةٌ أكل':Added, #2: 2	كَرَاهَةَ أَكْلِ
u'كَرَاهَةٌ أَكْلٌ':Added, #2: 2	كَرَاهَةِ الْأَكْلِ
u'كَرَاهَةٌ أكل':Added, #2: 2	كَرَاهَةِ الْأَكْلِ
u'كَرَاهَةٌ أَكْلٌ':Added, #3: 3	كَرَاهَةِ أَكْلِ
u'كَرَاهَةٌ إمَالَةٌ':Added, #3: 3	كَرَاهَةِ أَكْلِ
u'كَرَاهَةٌ إمَامٌ':Added, #1: 1	كَرَاهَةَ الْإِمَالَةِ
u'كَرَاهَةٌ إمَامٌ':Added, #1: 1	كَرَاهَةُ الْإِمَامِ
u'كَرَاهَةٌ إمَامَةٌ':Added, #1: 1	كَرَاهَةِ الْإِمَامِ
u'كَرَاهَةٌ إمَامَةٌ':Added, #2: 2	كَرَاهَةَ إمَامَةِ
u'كَرَاهَةٌ إمَامَةٌ':Added, #2: 2	كَرَاهَةِ إمَامَتِهِ
u'كَرَاهَةٌ إِمْساكٌ':Added, #3: 3	كَرَاهَةِ إمَامَةِ
u'كَرَاهَةٌ إِنْشاءٌ':Added, #1: 1	كَرَاهَةِ إمْسَاكِ
u'كَرَاهَةٌ أنِينٌ':Added, #1: 1	كَرَاهَةَ الْإِنْشَاءِ
u'كَرَاهَةٌ أهْلٌ':Added, #1: 1	كَرَاهَةِ الْأَنِينِ
u'كَرَاهَةٌ أَوَّلُ':Added, #1: 1	كَرَاهَةِ أَهْلِ
u'كَرَاهَةٌ إِيثَارٌ':Added, #1: 1	كَرَاهَةِ أَوَّلِ
u'كَرَاهَةٌ إِيثَارٌ':Added, #1: 1	كَرَاهَةِ الْإِيثَارِ
u'كَرَاهَةٌ إِيثَارٌ':Added, #1: 1	كَرَاهَةُ إيثَارِ
u'كَرَاهَةٌ إيقَاعٌ':Added, #1: 1	كَرَاهَةِ إيثَارِهِ
u'كَرَاهَةٌ إيقَاعٌ':Added, #1: 1	كَرَاهَةَ الْإِيقَاعِ
u'كَرَاهَةٌ إيقَاعٌ':Added, #1: 1	كَرَاهَةِ الْإِيقَاعِ
u'كَرَاهَةٌ بِدْعَةٌ':Added, #2: 2	كَرَاهَةُ إيقَاعِ
u'كَرَاهَةٌ بَسْمَلَةٌ':Added, #1: 1	كَرَاهَةَ بِدْعَتِهِ
u'كَرَاهَةٌ بُصاقٌ':Added, #1: 1	كَرَاهَةِ الْبَسْمَلَةِ
u'كَرَاهَةٌ بَعْضٌ':Added, #1: 1	كَرَاهَةِ الْبُصَاقِ
u'كَرَاهَةٌ بِنَاءٌ':Added, #1: 1	كَرَاهَةِ بَعْضِ
u'كَرَاهَةٌ بَوْلٌ':Added, #1: 1	كَرَاهَةَ الْبِنَاءِ
u'كَرَاهَةٌ بَوْلٌ':Added, #2: 2	كَرَاهَةَ الْبَوْلِ
u'كَرَاهَةٌ بَيْعٌ':Added, #3: 3	كَرَاهَةِ الْبَوْلِ
u'كَرَاهَةٌ بَيْعٌ':Added, #1: 1	كَرَاهَةَ الْبَيْعِ
u'كَرَاهَةٌ بَيْعٌ':Added, #1: 1	كَرَاهَةُ الْبَيْعِ
u'كَرَاهَةٌ بَيْعٌ':Added, #1: 1	كَرَاهَةُ بَيْعِهِ
u'كَرَاهَةٌ بَيْعٌ':Added, #2: 2	كَرَاهَةَ بَيْعِ
u'كَرَاهَةٌ بَيْعٌ':Added, #2: 2	كَرَاهَةُ بَيْعِ
u'كَرَاهَةٌ تَأْخِيرٌ':Added, #3: 3	كَرَاهَةِ بَيْعِ
u'كَرَاهَةٌ تِجَارَةٌ':Added, #1: 1	كَرَاهَةَ التَّأْخِيرِ
u'كَرَاهَةٌ تَجَرُّدٌ':Added, #4: 4	كَرَاهَةِ التِّجَارَةِ
u'كَرَاهَةٌ تَحْرِيمٌ':Added, #1: 1	كَرَاهَةُ تَجَرُّدِ
u'كَرَاهَةٌ تَحْرِيمٌ':Added, #17: 17	كَرَاهَةَ التَّحْرِيمِ
u'كَرَاهَةٌ تَحْرِيمٌ':Added, #19: 19	كَرَاهَةُ التَّحْرِيمِ
u'كَرَاهَةٌ تَحْرِيمٌ':Added, #1: 1	كَرَاهَةِ تَحْرِيمٍ
u'كَرَاهَةٌ تَحْرِيمٌ':Added, #21: 21	كَرَاهَةِ التَّحْرِيمِ
u'كَرَاهَةٌ تَحْرِيمٌ':Added, #29: 29	كَرَاهَةَ تَحْرِيمٍ
u'كَرَاهَةٌ تَحْلِيَةٌ':Added, #31: 31	كَرَاهَةُ تَحْرِيمٍ
u'كَرَاهَةٌ تَخْرِيقٌ':Added, #1: 1	كَرَاهَةُ تَحْلِيَةِ
u'كَرَاهَةٌ تَخَلُّفٌ':Added, #1: 1	كَرَاهَةُ تَخْرِيقِ
u'كَرَاهَةٌ تَخْمِين':Added, #1: 1	كَرَاهَةِ التَّخَلُّفِ
u'كَرَاهَةٌ تَرْكٌ':Added, #1: 1	كَرَاهَةُ التَّخْمِينِ
u'كَرَاهَةٌ تَرْكٌ':Added, #1: 1	كَرَاهَةِ التَّرْكِ
u'كَرَاهَةٌ تَرْكٌ':Added, #1: 1	كَرَاهَةَ تَرْكِ
u'كَرَاهَةٌ تَرْكٌ':Added, #1: 1	كَرَاهَةُ تَرْكِهِ
u'كَرَاهَةٌ تَرْكٌ':Added, #3: 3	كَرَاهَةُ تَرْكِ
u'كَرَاهَةٌ تَسْوِيدٌ':Added, #7: 7	كَرَاهَةِ تَرْكِ
u'كَرَاهَةٌ تَشَبُّهٌ':Added, #2: 2	كَرَاهَةَ تَسْوِيدِ
u'كَرَاهَةٌ تَشَدُّقٌ':Added, #1: 1	كَرَاهَةِ تَشَبُّهِ
u'كَرَاهَةٌ تَشْمِيرٌ':Added, #1: 1	كَرَاهَةُ التَّشَدُّقِ
u'كَرَاهَةٌ تَضْحِيَةٌ':Added, #1: 1	كَرَاهَةِ تَشْمِيرِ
u'كَرَاهَةٌ تَطَهُّرٌ':Added, #1: 1	كَرَاهَةِ التَّضْحِيَةِ
u'كَرَاهَةٌ تَطَوُّعٌ':Added, #1: 1	كَرَاهَةِ التَّطَهُّرِ
u'كَرَاهَةٌ تَطْوِيلٌ':Added, #1: 1	كَرَاهَةُ التَّطَوُّعِ
u'كَرَاهَةٌ تَطْيِيبٌ':Added, #1: 1	كَرَاهَةِ تَطْوِيلِهِ
u'كَرَاهَةٌ تَعْلِيقٌ':Added, #1: 1	كَرَاهَةُ تَطْيِيبِ
u'كَرَاهَةٌ تَعْلِيمٌ':Added, #1: 1	كَرَاهَةِ تَعْلِيقِ
u'كَرَاهَةٌ تَعَمُّدٌ':Added, #1: 1	كَرَاهَةِ التَّعْلِيمِ
u'كَرَاهَةٌ تَعَوُّدٌ':Added, #1: 1	كَرَاهَةِ تَعَمُّدِ
u'كَرَاهَةٌ تَعْيِينٌ':Added, #1: 1	كَرَاهَةَ تَعَوُّدِ
u'كَرَاهَةٌ تَغْطِيَةٌ':Added, #1: 1	كَرَاهَةِ تَعْيِينِ
u'كَرَاهَةٌ تَفْرِيقٌ':Added, #1: 1	كَرَاهَةَ تَغْطِيَةِ
u'كَرَاهَةٌ تُفْل':Added, #1: 1	كَرَاهَةِ التَّفْرِيقِ
u'كَرَاهَةٌ تَقَدُّمٌ':Added, #2: 2	كَرَاهَةِ التُّفْلِ
u'كَرَاهَةٌ تَقْديمٌ':Added, #1: 1	كَرَاهَةِ التَّقَدُّمِ
u'كَرَاهَةٌ تَقْديمٌ':Added, #1: 1	كَرَاهَةِ تَقْدِيمِ
u'كَرَاهَةٌ تَكْرارٌ':Added, #2: 2	كَرَاهَةَ تَقْدِيمِ
u'كَرَاهَةٌ تَكْرارٌ':Added, #1: 1	كَرَاهَةُ التَّكْرَارِ
u'كَرَاهَةٌ تَكْرارٌ':Added, #1: 1	كَرَاهَةَ تَكْرَارِ
u'كَرَاهَةٌ تَلْحِين':Added, #1: 1	كَرَاهَةِ تَكْرَارِ
u'كَرَاهَةٌ تَلْطيخٌ':Added, #1: 1	كَرَاهَةِ التَّلْحِينِ
u'كَرَاهَةٌ تَنْبِيه':Added, #1: 1	كَرَاهَةَ تَلْطِيخِ
u'كَرَاهَةٌ تَنْزِيه':Added, #3: 3	كَرَاهَةِ التَّنْبِيهِ
u'كَرَاهَةٌ تَنْزِيهٌ':Added, #14: 14	كَرَاهَةِ التَّنْزِيهِ
u'كَرَاهَةٌ تَنْزِيهٌ':Added, #31: 31	كَرَاهَةَ تَنْزِيهٍ
u'كَرَاهَةٌ تَنْزِيه':Added, #31: 31	كَرَاهَةُ تَنْزِيهٍ
u'كَرَاهَةٌ تَنْزِيه':Added, #3: 3	كَرَاهَةُ التَّنْزِيهِ
u'كَرَاهَةٌ تَنْشِيفٌ':Added, #7: 7	كَرَاهَةَ التَّنْزِيهِ
u'كَرَاهَةٌ تَنَفُّلٌ':Added, #2: 2	كَرَاهَةِ تَنْشِيفِ
u'كَرَاهَةٌ تَنَفُّلٌ':Added, #2: 2	كَرَاهَةُ التَّنَفُّلِ
u'كَرَاهَةٌ تَوسُّدٌ':Added, #2: 2	كَرَاهَةِ التَّنَفُّلِ
u'كَرَاهَةٌ تَوَضُّؤٌ':Added, #1: 1	كَرَاهَةِ تَوَسُّدِهِ
u'كَرَاهَةٌ ثَانِي':Added, #1: 1	كَرَاهَةَ التَّوَضُّؤِ
u'كَرَاهَةٌ ثَانِيَةٌ':Added, #2: 2	كَرَاهَةِ الثَّانِيَةِ
u'كَرَاهَةٌ ثَوْبٌ':Added, #2: 2	كَرَاهَةِ الثَّانِيَةِ
u'كَرَاهَةٌ جَمَاعَةٌ':Added, #1: 1	كَرَاهَةِ ثَوْبِ
u'كَرَاهَةٌ جَمَاعَةٌ':Added, #1: 1	كَرَاهَةِ الْجَمَاعَةِ
u'كَرَاهَةٌ جمع':Added, #1: 1	كَرَاهَةِ جَمَاعَةِ
u'كَرَاهَةٌ جَمْعٌ':Added, #1: 1	كَرَاهَةِ الْجَمْعِ
u'كَرَاهَةٌ جهر':Added, #1: 1	كَرَاهَةِ الْجَمْعِ
u'كَرَاهَةٌ جَهْرٌ':Added, #2: 2	كَرَاهَةِ جَهْرِهِ
u'كَرَاهَةٌ حائِلٌ':Added, #2: 2	كَرَاهَةِ جَهْرِهِ
u'كَرَاهَةٌ حَبٌّ':Added, #2: 2	كَرَاهَةِ حَائِلٍ
u'كَرَاهَةٌ حَجٌّ':Added, #1: 1	كَرَاهَةِ الْحَبِّ
u'كَرَاهَةٌ حِجَامَةٌ':Added, #1: 1	كَرَاهَةَ الْحَجِّ
u'كَرَاهَةٌ حَديثٌ':Added, #1: 1	كَرَاهَةَ الْحِجَامَةِ
u'كَرَاهَةٌ حُضورٌ':Added, #2: 2	كَرَاهَةَ الْحَدِيثِ
u'كَرَاهَةٌ حُضُورٌ':Added, #1: 1	كَرَاهَةِ الْحُضُورِ
u'كَرَاهَةٌ حُضورٌ':Added, #1: 1	كَرَاهَةِ الْحُضُورِ
u'كَرَاهَةٌ حُضُورٌ':Added, #1: 1	كَرَاهَةِ حُضُورِ
u'كَرَاهَةٌ حُضورٌ':Added, #1: 1	كَرَاهَةِ حُضُورِ
u'كَرَاهَةٌ حُضُورٌ':Added, #1: 1	كَرَاهَةِ حُضُورِهِ
u'كَرَاهَةٌ حَلْقٌ':Added, #1: 1	كَرَاهَةِ حُضُورِهِ
u'كَرَاهَةٌ حَلْقٌ':Added, #1: 1	كَرَاهَةِ الْحَلْقِ
u'كَرَاهَةٌ حَلْقٌ':Added, #1: 1	كَرَاهَةُ حَلْقِ
u'كَرَاهَةٌ حَمْلٌ':Added, #2: 2	كَرَاهَةِ حَلْقِ
u'كَرَاهَةٌ حَمْلٌ':Added, #1: 1	كَرَاهَةِ الْحَمْلِ
u'كَرَاهَةٌ خبائث':Added, #1: 1	كَرَاهَةِ حَمْلِهِ
u'كَرَاهَةٌ خَبَائِثُ':Added, #1: 1	كَرَاهَةَ الْخَبَائِثِ
u'كَرَاهَةٌ خُرُوجٌ':Added, #1: 1	كَرَاهَةَ الْخَبَائِثِ
u'كَرَاهَةٌ خُرُوجٌ':Added, #1: 1	كَرَاهَةُ الْخُرُوجِ
u'كَرَاهَةٌ خُرُوجٌ':Added, #1: 1	كَرَاهَةِ الْخُرُوجِ
u'كَرَاهَةٌ خُرُوجٌ':Added, #1: 1	كَرَاهَةِ خُرُوجِ
u'كَرَاهَةٌ خِضَابٌ':Added, #1: 1	كَرَاهَةَ خُرُوجِهِ
u'كَرَاهَةٌ خِلاَفٌ':Added, #1: 1	كَرَاهَةِ الْخِضَابِ
u'كَرَاهَةٌ خُلْعٌ':Added, #1: 1	كَرَاهَةُ خِلَافِهِ
u'كَرَاهَةٌ خَلُوق':Added, #1: 1	كَرَاهَةِ الْخُلْعِ
u'كَرَاهَةٌ خُمُول':Added, #1: 1	كَرَاهَةِ الْخَلُوقِ
u'كَرَاهَةٌ دُخُولٌ':Added, #1: 1	كَرَاهَةِ الْخُمُولِ
u'كَرَاهَةٌ دُخُولٌ':Added, #1: 1	كَرَاهَةُ الدُّخُولِ
u'كَرَاهَةٌ دُخُولٌ':Added, #1: 1	كَرَاهَةِ دُخُولِ
u'كَرَاهَةٌ دُخُولٌ':Added, #1: 1	كَرَاهَةِ دُخُولِهِ
u'كَرَاهَةٌ دُخُولٌ':Added, #2: 2	كَرَاهَةِ الدُّخُولِ
u'كَرَاهَةٌ دُعَاءٌ':Added, #2: 2	كَرَاهَةُ دُخُولِهِ
u'كَرَاهَةٌ دُعَاءٌ':Added, #1: 1	كَرَاهَةُ الدُّعَاءِ
u'كَرَاهَةٌ دفع':Added, #5: 5	كَرَاهَةِ الدُّعَاءِ
u'كَرَاهَةٌ دَفْعٌ':Added, #1: 1	كَرَاهَةِ دَفْعِ
u'كَرَاهَةٌ ذِمِّيٌّ':Added, #1: 1	كَرَاهَةِ دَفْعِ
u'كَرَاهَةٌ ذَوْقٌ':Added, #1: 1	كَرَاهَةِ الذِّمِّيَّةِ
u'كَرَاهَةٌ ذَوْقٌ':Added, #1: 1	كَرَاهَةَ الذَّوْقِ
u'كَرَاهَةٌ رَأْسٌ':Added, #2: 2	كَرَاهَةِ الذَّوْقِ
u'كَرَاهَةٌ رَجْمٌ':Added, #1: 1	كَرَاهَةُ رَأْسِ
u'كَرَاهَةٌ رُجُوعٌ':Added, #1: 1	كَرَاهَةِ رَجْمِهِ
u'كَرَاهَةٌ رَدٌّ':Added, #1: 1	كَرَاهَةُ رُجُوعِهِ
u'كَرَاهَةٌ رَشٌّ':Added, #2: 2	كَرَاهَةِ الرَّدِّ
u'كَرَاهَةٌ رَفْعٌ':Added, #1: 1	كَرَاهَةُ رَشِّهِ
u'كَرَاهَةٌ رُكوبٌ':Added, #1: 1	كَرَاهَةِ رَفْعِ
u'كَرَاهَةٌ زَلْزَلَةٌ':Added, #1: 1	كَرَاهَةِ الرُّكُوبِ
u'كَرَاهَةٌ زِيادَةٌ':Added, #1: 1	كَرَاهَةِ زَلْزَلَةِ
u'كَرَاهَةٌ زِيادَةٌ':Added, #2: 2	كَرَاهَةَ الزِّيَادَةِ
u'كَرَاهَةٌ زِيادَةٌ':Added, #2: 2	كَرَاهَةُ الزِّيَادَةِ
u'كَرَاهَةٌ سَبٌّ':Added, #3: 3	كَرَاهَةِ الزِّيَادَةِ
u'كَرَاهَةٌ سترة':Added, #2: 2	كَرَاهَةِ سَبِّ
u'كَرَاهَةٌ سُتْرَةٌ':Added, #1: 1	كَرَاهَةَ السُّتْرَةِ
u'كَرَاهَةٌ سُرْعَةٌ':Added, #1: 1	كَرَاهَةَ السُّتْرَةِ
u'كَرَاهَةٌ سَفَرٌ':Added, #1: 1	كَرَاهَةُ السُّرْعَةِ
u'كَرَاهَةٌ سُكُونٌ':Added, #1: 1	كَرَاهَةِ سَفَرِ
u'كَرَاهَةٌ سلام':Added, #1: 1	كَرَاهَةُ السُّكُونِ
u'كَرَاهَةٌ سَلاَمٌ':Added, #1: 1	كَرَاهَةِ السَّلَامِ
u'كَرَاهَةٌ سلام':Added, #1: 1	كَرَاهَةِ السَّلَامِ
u'كَرَاهَةٌ سَلاَمٌ':Added, #2: 2	كَرَاهَةُ السَّلَامِ
u'كَرَاهَةٌ سَلَفٌ':Added, #2: 2	كَرَاهَةُ السَّلَامِ
u'كَرَاهَةٌ سِواكٌ':Added, #1: 1	كَرَاهَةُ السَّلَفِ
u'كَرَاهَةٌ سِواكٌ':Added, #1: 1	كَرَاهَةَ السِّوَاكِ
u'كَرَاهَةٌ سُؤَالٌ':Added, #3: 3	كَرَاهَةِ السِّوَاكِ
u'كَرَاهَةٌ سُؤَالٌ':Added, #1: 1	كَرَاهَةُ السُّؤَالِ
u'كَرَاهَةٌ سُؤْرٌ':Added, #3: 3	كَرَاهَةِ السُّؤَالِ
u'كَرَاهَةٌ سُؤْرٌ':Added, #1: 1	كَرَاهَةِ السُّؤْرِ
u'كَرَاهَةٌ سُؤْرٌ':Added, #1: 1	كَرَاهَةُ سُؤْرِ
u'كَرَاهَةٌ سُؤْرٌ':Added, #1: 1	كَرَاهَةِ سُؤْرِهِ
u'كَرَاهَةٌ سُؤْرٌ':Added, #2: 2	كَرَاهَةُ سُؤْرِهِ
u'كَرَاهَةٌ سِياحَةٌ':Added, #3: 3	كَرَاهَةِ سُؤْرِ
u'كَرَاهَةٌ شَدٌّ':Added, #1: 1	كَرَاهَةِ السِّيَاحَةِ
u'كَرَاهَةٌ شِرَاءٌ':Added, #1: 1	كَرَاهَةُ شَدِّ
u'كَرَاهَةٌ شرب':Added, #2: 2	كَرَاهَةَ الشِّرَاءِ
u'كَرَاهَةٌ شرب':Added, #1: 1	كَرَاهَةَ شُرْبِهِ
u'كَرَاهَةٌ شُرْبٌ':Added, #1: 1	كَرَاهَةِ شُرْبِهِ
u'كَرَاهَةٌ شُرْبٌ':Added, #1: 1	كَرَاهَةَ شُرْبِهِ
u'كَرَاهَةٌ شرب':Added, #1: 1	كَرَاهَةِ شُرْبِهِ
u'كَرَاهَةٌ شُرْبٌ':Added, #3: 3	كَرَاهَةِ الشُّرْبِ
u'كَرَاهَةٌ شَمٌّ':Added, #3: 3	كَرَاهَةِ الشُّرْبِ
u'كَرَاهَةٌ شَهَادَةٌ':Added, #1: 1	كَرَاهَةِ شَمِّهِ
u'كَرَاهَةٌ صَبْغٌ':Added, #2: 2	كَرَاهَةِ شَهَادَتِهِ
u'كَرَاهَةٌ صَلاَةٌ':Added, #1: 1	كَرَاهَةُ الصَّبْغِ
u'كَرَاهَةٌ صَلاَةٌ':Added, #14: 14	كَرَاهَةِ الصَّلَاةِ
u'كَرَاهَةٌ صَلاَةٌ':Added, #1: 1	كَرَاهَةُ الصَّلَاةِ
u'كَرَاهَةٌ صَلاَةٌ':Added, #2: 2	كَرَاهَةَ الصَّلَاةِ
u'كَرَاهَةٌ صَوْمٌ':Added, #3: 3	كَرَاهَةِ صَلَاةِ
u'كَرَاهَةٌ صَوْمٌ':Added, #1: 1	كَرَاهَةُ صَوْمِ
u'كَرَاهَةٌ صَوْمٌ':Added, #1: 1	كَرَاهَةِ صَوْمِهِ
u'كَرَاهَةٌ صَوْمٌ':Added, #2: 2	كَرَاهَةَ صَوْمِ
u'كَرَاهَةٌ صَوْمٌ':Added, #2: 2	كَرَاهَةُ صَوْمِهِ
u'كَرَاهَةٌ صِيَامٌ':Added, #3: 3	كَرَاهَةِ صَوْمِ
u'كَرَاهَةٌ ضِدٌّ':Added, #1: 1	كَرَاهَةِ صِيَامِ
u'كَرَاهَةٌ ضِدٌّ':Added, #1: 1	كَرَاهَةَ الضِّدِّ
u'كَرَاهَةٌ ضِدٌّ':Added, #1: 1	كَرَاهَةِ ضِدِّهِ
u'كَرَاهَةٌ ضَمٌّ':Added, #2: 2	كَرَاهَةَ ضِدِّهِ
u'كَرَاهَةٌ طَلاَقٌ':Added, #2: 2	كَرَاهَةِ الضَّمِّ
u'كَرَاهَةٌ طَهَارَةٌ':Added, #1: 1	كَرَاهَةِ الطَّلَاقِ
u'كَرَاهَةٌ طَيْلَسَانٌ':Added, #1: 1	كَرَاهَةُ الطَّهَارَةِ
u'كَرَاهَةٌ عَاجٌ':Added, #2: 2	كَرَاهَةِ الطَّيْلَسَانِ
u'كَرَاهَةٌ عَبَثٌ':Added, #1: 1	كَرَاهَةُ الْعَاجِ
u'كَرَاهَةٌ عجلة':Added, #1: 1	كَرَاهَةَ الْعَبَثِ
u'كَرَاهَةٌ عَجَلَةٌ':Added, #2: 2	كَرَاهَةُ الْعَجَلَةِ
u'كَرَاهَةٌ عَدٌّ':Added, #2: 2	كَرَاهَةُ الْعَجَلَةِ
u'كَرَاهَةٌ عَدٌّ':Added, #1: 1	كَرَاهَةَ الْعَدِّ
u'كَرَاهَةٌ عَدَمٌ':Added, #4: 4	كَرَاهَةِ عَدِّ
u'كَرَاهَةٌ عزل':Added, #1: 1	كَرَاهَةَ عَدَمِ
u'كَرَاهَةٌ عمرة':Added, #1: 1	كَرَاهَةِ الْعَزْلِ
u'كَرَاهَةٌ عُمْرَةٌ':Added, #1: 1	كَرَاهَةَ الْعُمْرَةِ
u'كَرَاهَةٌ عمرة':Added, #1: 1	كَرَاهَةَ الْعُمْرَةِ
u'كَرَاهَةٌ عُمْرَةٌ':Added, #2: 2	كَرَاهَةِ الْعُمْرَةِ
u'كَرَاهَةٌ عَمَلٌ':Added, #2: 2	كَرَاهَةِ الْعُمْرَةِ
u'كَرَاهَةٌ غُسْلٌ':Added, #1: 1	كَرَاهَةِ الْعَمَلِ
u'كَرَاهَةٌ غَسْلٌ':Added, #1: 1	كَرَاهَةِ الْغُسْلِ
u'كَرَاهَةٌ غَمْس':Added, #1: 1	كَرَاهَةِ غَسْلِهِ
u'كَرَاهَةٌ غير':Added, #1: 1	كَرَاهَةُ الْغَمْسِ
u'كَرَاهَةٌ غَيْرٌ':Added, #1: 1	كَرَاهَةِ غَيْرِهِ
u'كَرَاهَةٌ فَرْقَعَةٌ':Added, #1: 1	كَرَاهَةِ غَيْرِهِ
u'كَرَاهَةٌ فِطْرٌ':Added, #1: 1	كَرَاهَةُ الْفَرْقَعَةِ
u'كَرَاهَةٌ فِعْلٌ':Added, #1: 1	كَرَاهَةَ الْفِطْرِ
u'كَرَاهَةٌ فِعْلٌ':Added, #1: 1	كَرَاهَةِ الْفِعْلِ
u'كَرَاهَةٌ فِعْلٌ':Added, #1: 1	كَرَاهَةِ فِعْلِ
u'كَرَاهَةٌ قَبُولٌ':Added, #1: 1	كَرَاهَةَ فِعْلِهِ
u'كَرَاهَةٌ قَبُولٌ':Added, #1: 1	كَرَاهَةِ الْقَبُولِ
u'كَرَاهَةٌ قتال':Added, #1: 1	كَرَاهَةُ قَبُولِ
u'كَرَاهَةٌ قِتَالٌ':Added, #1: 1	كَرَاهَةِ قِتَالِ
u'كَرَاهَةٌ قتل':Added, #1: 1	كَرَاهَةِ قِتَالِ
u'كَرَاهَةٌ قَتْلٌ':Added, #1: 1	كَرَاهَةَ قَتْلِ
u'كَرَاهَةٌ قتل':Added, #1: 1	كَرَاهَةَ قَتْلِ
u'كَرَاهَةٌ قَتْلٌ':Added, #2: 2	كَرَاهَةِ قَتْلِ
u'كَرَاهَةٌ قِرَاءةٌ':Added, #2: 2	كَرَاهَةِ قَتْلِ
u'كَرَاهَةٌ قِرَاءةٌ':Added, #2: 2	كَرَاهَةَ الْقِرَاءَةِ
u'كَرَاهَةٌ قِرَاءةٌ':Added, #2: 2	كَرَاهَةُ الْقِرَاءَةِ
u'كَرَاهَةٌ قِرَاءةٌ':Added, #4: 4	كَرَاهَةُ قِرَاءَةِ
u'كَرَاهَةٌ قِرَانٌ':Added, #5: 5	كَرَاهَةِ الْقِرَاءَةِ
u'كَرَاهَةٌ قَرْضٌ':Added, #1: 1	كَرَاهَةِ الْقِرَانِ
u'كَرَاهَةٌ قَضَاءٌ':Added, #1: 1	كَرَاهَةِ الْقَرْضِ
u'كَرَاهَةٌ قَطْعٌ':Added, #1: 1	كَرَاهَةِ الْقَضَاءِ
u'كَرَاهَةٌ قَطْعٌ':Added, #1: 1	كَرَاهَةِ الْقَطْعِ
u'كَرَاهَةٌ قُعُودٌ':Added, #1: 1	كَرَاهَةِ قَطْعِ
u'كَرَاهَةٌ قلب':Added, #2: 2	كَرَاهَةِ الْقُعُودِ
u'كَرَاهَةٌ قَلْبٌ':Added, #2: 2	كَرَاهَةُ الْقَلْبِ
u'كَرَاهَةٌ قَلْب':Added, #2: 2	كَرَاهَةُ الْقَلْبِ
u'كَرَاهَةٌ قيام':Added, #2: 2	كَرَاهَةُ الْقَلْبِ
u'كَرَاهَةٌ قِيَامٌ':Added, #1: 1	كَرَاهَةَ الْقِيَامِ
u'كَرَاهَةٌ قيام':Added, #1: 1	كَرَاهَةَ الْقِيَامِ
u'كَرَاهَةٌ قِيَامٌ':Added, #1: 1	كَرَاهَةُ قِيَامِ
u'كَرَاهَةٌ قيام':Added, #1: 1	كَرَاهَةُ قِيَامِ
u'كَرَاهَةٌ قِيَامٌ':Added, #1: 1	كَرَاهَةُ قِيَامِهِ
u'كَرَاهَةٌ كِتَابَةٌ':Added, #1: 1	كَرَاهَةُ قِيَامِهِ
u'كَرَاهَةٌ كِتَابَةٌ':Added, #1: 1	كَرَاهَةَ الْكِتَابَةِ
u'كَرَاهَةٌ كَثْرَةٌ':Added, #1: 1	كَرَاهَةِ الْكِتَابَةِ
u'كَرَاهَةٌ كَلاَمٌ':Added, #1: 1	كَرَاهَةِ كَثْرَةِ
u'كَرَاهَةٌ كَلاَمٌ':Added, #1: 1	كَرَاهَةَ الْكَلَامِ
u'كَرَاهَةٌ كَلاَمٌ':Added, #1: 1	كَرَاهَةُ الْكَلَامِ
u'كَرَاهَةٌ كَوْنٌ':Added, #4: 4	كَرَاهَةِ الْكَلَامِ
u'كَرَاهَةٌ كَيٌّ':Added, #1: 1	كَرَاهَةَ كَوْنِ
u'كَرَاهَةٌ لبس':Added, #2: 2	كَرَاهَةَ الْكَيِّ
u'كَرَاهَةٌ لبس':Added, #1: 1	كَرَاهَةَ لُبْسِ
u'كَرَاهَةٌ لبس':Added, #1: 1	كَرَاهَةُ لُبْسِ
u'كَرَاهَةٌ لُبْسٌ':Added, #1: 1	كَرَاهَةِ لِبْسِ
u'كَرَاهَةٌ لُبْسٌ':Added, #1: 1	كَرَاهَةَ لُبْسِ
u'كَرَاهَةٌ لِبْسٌ':Added, #1: 1	كَرَاهَةُ لُبْسِ
u'كَرَاهَةٌ لبس':Added, #1: 1	كَرَاهَةِ لِبْسِ
u'كَرَاهَةٌ لُبْسٌ':Added, #5: 5	كَرَاهَةِ لُبْسِ
u'كَرَاهَةٌ لَحْمٌ':Added, #5: 5	كَرَاهَةِ لُبْسِ
u'كَرَاهَةٌ لَحْمٌ':Added, #1: 1	كَرَاهَةِ لَحْمِ
u'كَرَاهَةٌ لعب':Added, #3: 3	كَرَاهَةَ لَحْمِهِ
u'كَرَاهَةٌ لَعِبٌ':Added, #1: 1	كَرَاهَةِ اللَّعِبِ
u'كَرَاهَةٌ لعب':Added, #1: 1	كَرَاهَةِ اللَّعِبِ
u'كَرَاهَةٌ لَعِبٌ':Added, #1: 1	كَرَاهَةِ لَعِبِ
u'كَرَاهَةٌ لَعِبٌ':Added, #1: 1	كَرَاهَةِ لَعِبِ
u'كَرَاهَةٌ لِقَاءٌ':Added, #2: 2	كَرَاهَةِ لَعِبٍ
u'كَرَاهَةٌ مَاءٌ':Added, #2: 2	كَرَاهَةُ لِقَاءِ
u'كَرَاهَةٌ مَالِكٌ':Added, #1: 1	كَرَاهَةُ الْمَاءِ
u'كَرَاهَةٌ مَالِكٌ':Added, #1: 1	كَرَاهَةِ مَالِكٍ
u'كَرَاهَةٌ مُجَالَسَةٌ':Added, #2: 2	كَرَاهَةُ مَالِكٍ
u'كَرَاهَةٌ مُجَالَسَةٌ':Added, #1: 1	كَرَاهَةِ مُجَالَسَةِ
u'كَرَاهَةٌ مُجَاوَرَةٌ':Added, #2: 2	كَرَاهَةُ مُجَالَسَةِ
u'كَرَاهَةٌ مِحْرَابٌ':Added, #2: 2	كَرَاهَةِ الْمُجَاوَرَةِ
u'كَرَاهَةٌ مُحَمَّدٌ':Added, #1: 1	كَرَاهَةُ الْمِحْرَابِ
u'كَرَاهَةٌ مُخَالَطَةٌ':Added, #1: 1	كَرَاهَةِ مُحَمَّدٍ
u'كَرَاهَةٌ مَدٌّ':Added, #1: 1	كَرَاهَةِ مُخَالَطَةِ
u'كَرَاهَةٌ مَدَاخِلُ':Added, #1: 1	كَرَاهَةُ مَدِّ
u'كَرَاهَةٌ مُدَاوَمَةٌ':Added, #1: 1	كَرَاهَةِ مَدَاخِلِ
u'كَرَاهَةٌ مَدْحٌ':Added, #1: 1	كَرَاهَةِ الْمُدَاوَمَةِ
u'كَرَاهَةٌ مُرُورٌ':Added, #2: 2	كَرَاهَةِ الْمَدْحِ
u'كَرَاهَةٌ مَسٌّ':Added, #1: 1	كَرَاهَةَ الْمُرُورِ
u'كَرَاهَةٌ مُسَاوَاةٌ':Added, #1: 1	كَرَاهَةُ مَسِّ
u'كَرَاهَةٌ مُسَخَّنٌ':Added, #1: 1	كَرَاهَةُ الْمُسَاوَاةِ
u'كَرَاهَةٌ مُسَخَّنٌ':Added, #2: 2	كَرَاهَةِ الْمُسَخَّنِ
u'كَرَاهَةٌ مُشَمَّسٌ':Added, #2: 2	كَرَاهَةِ مُسَخَّنٍ
u'كَرَاهَةٌ مَشْيٌ':Added, #1: 1	كَرَاهَةِ الْمُشَمَّسِ
u'كَرَاهَةٌ مُعَاشَرَةٌ':Added, #1: 1	كَرَاهَةُ الْمَشْيِ
u'كَرَاهَةٌ مَعْصِيَةٌ':Added, #1: 1	كَرَاهَةُ مُعَاشَرَةِ
u'كَرَاهَةٌ مَعِيبٌ':Added, #1: 1	كَرَاهَةُ الْمَعْصِيَةِ
u'كَرَاهَةٌ مُفَارَقَةٌ':Added, #1: 1	كَرَاهَةِ الْمَعِيبِ
u'كَرَاهَةٌ مُكْثٌ':Added, #1: 1	كَرَاهَةُ مُفَارَقَةِ
u'كَرَاهَةٌ مَنْهِيٌّ':Added, #1: 1	كَرَاهَةِ الْمُكْثِ
u'كَرَاهَةٌ مُوَاظَبَةٌ':Added, #1: 1	كَرَاهَةُ الْمَنْهِيِّ
u'كَرَاهَةٌ مَوْتٌ':Added, #1: 1	كَرَاهَةِ الْمُوَاظَبَةِ
u'كَرَاهَةٌ مَوْتٌ':Added, #1: 1	كَرَاهَةَ الْمَوْتِ
u'كَرَاهَةٌ مَوْتٌ':Added, #1: 1	كَرَاهَةُ الْمَوْتِ
u'كَرَاهَةٌ مَوْتٌ':Added, #1: 1	كَرَاهَةِ الْمَوْتِ
u'كَرَاهَةٌ نَافِلَةٌ':Added, #2: 2	كَرَاهَةِ مَوْتِ
u'كَرَاهَةٌ نَبِيٌّ':Added, #1: 1	كَرَاهَةِ النَّافِلَةِ
u'كَرَاهَةٌ نَبِيٌّ':Added, #1: 1	كَرَاهَةُ النَّبِيِّ
u'كَرَاهَةٌ نَثْرٌ':Added, #1: 1	كَرَاهَةِ النَّبِيِّ
u'كَرَاهَةٌ نَحْوٌ':Added, #1: 1	كَرَاهَةِ النَّثْرِ
u'كَرَاهَةٌ نِدَاءٌ':Added, #1: 1	كَرَاهَةَ نَحْوِ
u'كَرَاهَةٌ نِدَاءٌ':Added, #1: 1	كَرَاهَةِ النِّدَاءِ
u'كَرَاهَةٌ نذر':Added, #1: 1	كَرَاهَةُ نِدَاءِ
u'كَرَاهَةٌ نذر':Added, #1: 1	كَرَاهَةُ النَّذْرِ
u'كَرَاهَةٌ نَذْرٌ':Added, #1: 1	كَرَاهَةِ النَّذْرِ
u'كَرَاهَةٌ نَذْرٌ':Added, #1: 1	كَرَاهَةُ النَّذْرِ
u'كَرَاهَةٌ نَظَرٌ':Added, #1: 1	كَرَاهَةِ النَّذْرِ
u'كَرَاهَةٌ نَظَرٌ':Added, #1: 1	كَرَاهَةَ النَّظَرِ
u'كَرَاهَةٌ نَظَرٌ':Added, #1: 1	كَرَاهَةِ النَّظَرِ
u'كَرَاهَةٌ نَظَرٌ':Added, #1: 1	كَرَاهَةِ نَظَرِهِ
u'كَرَاهَةٌ نَفْثٌ':Added, #2: 2	كَرَاهَةُ النَّظَرِ
u'كَرَاهَةٌ نَفْخ':Added, #3: 3	كَرَاهَةِ النَّفْثِ
u'كَرَاهَةٌ نَفْسٌ':Added, #1: 1	كَرَاهَةُ النَّفْخِ
u'كَرَاهَةٌ نقل':Added, #1: 1	كَرَاهَةُ النَّفْسِ
u'كَرَاهَةٌ نَقْلٌ':Added, #1: 1	كَرَاهَةُ النَّقْلِ
u'كَرَاهَةٌ نكاح':Added, #1: 1	كَرَاهَةُ النَّقْلِ
u'كَرَاهَةٌ نكاح':Added, #2: 2	كَرَاهَةُ نِكَاحِ
u'كَرَاهَةٌ نِكَاحٌ':Added, #2: 2	كَرَاهَةِ نِكَاحِ
u'كَرَاهَةٌ نِكَاحٌ':Added, #2: 2	كَرَاهَةُ نِكَاحِ
u'كَرَاهَةٌ نَوَافِلُ':Added, #2: 2	كَرَاهَةِ نِكَاحِ
u'كَرَاهَةٌ نَوْمٌ':Added, #1: 1	كَرَاهَةِ النَّوَافِلِ
u'كَرَاهَةٌ نَوْمٌ':Added, #1: 1	كَرَاهَةُ النَّوْمِ
u'كَرَاهَةٌ نَوْمٌ':Added, #1: 1	كَرَاهَةِ النَّوْمِ
u'كَرَاهَةٌ هِبَةٌ':Added, #2: 2	كَرَاهَةَ النَّوْمِ
u'كَرَاهَةٌ هَدِيٌّ':Added, #1: 1	كَرَاهَةِ هِبَةِ
u'كَرَاهَةٌ هَدِيَّةٌ':Added, #1: 1	كَرَاهَةِ الْهَدِيَّةِ
u'كَرَاهَةٌ واحد':Added, #1: 1	كَرَاهَةِ الْهَدِيَّةِ
u'كَرَاهَةٌ وَاحِدٌ':Added, #1: 1	كَرَاهَةِ الْوَاحِدَةِ
u'كَرَاهَةٌ وصل':Added, #1: 1	كَرَاهَةِ الْوَاحِدَةِ
u'كَرَاهَةٌ وَصْلٌ':Added, #1: 1	كَرَاهَةِ وَصْلِ
u'كَرَاهَةٌ وَضْعٌ':Added, #1: 1	كَرَاهَةِ وَصْلِ
u'كَرَاهَةٌ وُضُوءٌ':Added, #1: 1	كَرَاهَةَ الْوَضْعِ
u'كَرَاهَةٌ وَطْءٌ':Added, #5: 5	كَرَاهَةِ الْوُضُوءِ
u'كَرَاهَةٌ وَطْءٌ':Added, #1: 1	كَرَاهَةُ الْوَطْءِ
u'كَرَاهَةٌ يَوْمٌ':Added, #1: 1	كَرَاهَةِ الْوَطْءِ
u'كَرَاهِيَةٌ اِبْتِيَاعٌ':Added, #1: 1	كَرَاهَةِ يَوْمِ
u'كَرَاهِيَةٌ اِجْتِمَاعٌ':Added, #1: 1	كَرَاهِيَةِ ابْتِيَاعِ
u'كَرَاهِيَةٌ أخْذٌ':Added, #2: 2	كَرَاهِيَةَ اجْتِمَاعِ
u'كَرَاهِيَةٌ أخْذٌ':Added, #1: 1	كَرَاهِيَةِ أَخْذِ
u'كَرَاهِيَةٌ إِخْرَاجٌ':Added, #1: 1	كَرَاهِيَةِ الْأَخْذِ
u'كَرَاهِيَةٌ اِسْتِعانَةٌ':Added, #1: 1	كَرَاهِيَةِ إخْرَاجِ
u'كَرَاهِيَةٌ إِسْرافٌ':Added, #1: 1	كَرَاهِيَةِ الاِسْتِعَانَةِ
u'كَرَاهِيَةٌ اِشْتِغالٌ':Added, #1: 1	كَرَاهِيَةِ الْإِسْرَافِ
u'كَرَاهِيَةٌ إضافَةٌ':Added, #1: 1	كَرَاهِيَةِ الاِشْتِغَالِ
u'كَرَاهِيَةٌ اِقْتِباسٌ':Added, #1: 1	كَرَاهِيَةَ إضَافَةِ
u'كَرَاهِيَةٌ إكْثَارٌ':Added, #1: 1	كَرَاهِيَةِ اقْتِبَاسِ
u'كَرَاهِيَةٌ إكْثَارٌ':Added, #1: 1	كَرَاهِيَةِ الإِكْثَارِ
u'كَرَاهِيَةٌ أَكْثَرُ':Added, #1: 1	كَرَاهِيَةُ الْإِكْثَارِ
u'كَرَاهِيَةٌ اِلْتِفَاتٌ':Added, #1: 1	كَرَاهِيَةَ الْأَكْثَرِ
u'كَرَاهِيَةٌ إمَارَةٌ':Added, #1: 1	كَرَاهِيَةِ الاِلْتِفَاتِ
u'كَرَاهِيَةٌ إمَامَةٌ':Added, #1: 1	كَرَاهِيَةِ الإِمَارَةِ
u'كَرَاهِيَةٌ إمَامَةٌ':Added, #1: 1	كَرَاهِيَةِ الإِمَامَةِ
u'كَرَاهِيَةٌ إِمْساكٌ':Added, #1: 1	كَرَاهِيَةِ إِمَامَةِ
u'كَرَاهِيَةٌ إِنْشادٌ':Added, #1: 1	كَرَاهِيَةِ إِمْسَاكِ
u'كَرَاهِيَةٌ بُخْلٌ':Added, #1: 1	كَرَاهِيَةِ إِنْشَادِ
u'كَرَاهِيَةٌ بُرْقُعٌ':Added, #1: 1	كَرَاهِيَةِ الْبُخْلِ
u'كَرَاهِيَةٌ بَوْلٌ':Added, #1: 1	كَرَاهِيَةُ الْبُرْقُعِ
u'كَرَاهِيَةٌ بَيْعٌ':Added, #1: 1	كَرَاهِيَةِ الْبَوْلِ
u'كَرَاهِيَةٌ بَيْعٌ':Added, #1: 1	كَرَاهِيَةَ الْبَيْعِ
u'كَرَاهِيَةٌ تَأَخُّرٌ':Added, #3: 3	كَرَاهِيَةِ بَيْعِ
u'كَرَاهِيَةٌ تَأْخِيرٌ':Added, #1: 1	كَرَاهِيَةِ التَّأَخُّرِ
u'كَرَاهِيَةٌ تَأْخِيرٌ':Added, #1: 1	كَرَاهِيَةِ التَّأْخِيرِ
u'كَرَاهِيَةٌ تَأْخِيرٌ':Added, #1: 1	كَرَاهِيَةِ تَأَْخِيرِ
u'كَرَاهِيَةٌ تَبايَع':Added, #2: 2	كَرَاهِيَةِ تَأْخِيرِ
u'كَرَاهِيَةٌ تَثَاؤُبٌ':Added, #1: 1	كَرَاهِيَةِ التَّبَايعِ
u'كَرَاهِيَةٌ تَجْفِيفٌ':Added, #1: 1	كَرَاهِيَةِ التَّثَاؤُبِ
u'كَرَاهِيَةٌ تَجْمِيعٌ':Added, #1: 1	كَرَاهِيَةَ تَجْفِيفِ
u'كَرَاهِيَةٌ تَحْرِيمٌ':Added, #1: 1	كَرَاهِيَةِ التَّجْمِيعِ
u'كَرَاهِيَةٌ تَدَافُعٌ':Added, #1: 1	كَرَاهِيَةَ التَّحْرِيمِ
u'كَرَاهِيَةٌ تَرْكٌ':Added, #1: 1	كَرَاهِيَةِ التَّدَافُعِ
u'كَرَاهِيَةٌ تَرْكٌ':Added, #1: 1	كَرَاهِيَةِ التَّرْكِ
u'كَرَاهِيَةٌ تَسَارُعٌ':Added, #1: 1	كَرَاهِيَةِ تَرْكِ
u'كَرَاهِيَةٌ تَسْمِيَة':Added, #1: 1	كَرَاهِيَةِ التَّسَارُعِ
u'كَرَاهِيَةٌ تَسْمِيَة':Added, #1: 1	كَرَاهِيَةَ تَسْمِيَةِ
u'كَرَاهِيَةٌ تَضْعِيفٌ':Added, #1: 1	كَرَاهِيَةُ تَسْمِيَةِ
u'كَرَاهِيَةٌ تَطَوُّعٌ':Added, #1: 1	كَرَاهِيَةَ التّضْعِيفِ
u'كَرَاهِيَةٌ تَطْوِيلٌ':Added, #1: 1	كَرَاهِيَةِ التَّطَوُّعِ
u'كَرَاهِيَةٌ تَعْلِيقٌ':Added, #1: 1	كَرَاهِيَةَ التَّطْوِيلِ
u'كَرَاهِيَةٌ تَفْقِيعٌ':Added, #1: 1	كَرَاهِيَةِ تَعْلِيقِ
u'كَرَاهِيَةٌ تَقْديمٌ':Added, #1: 1	كَرَاهِيَةِ تَفْقِيعِ
u'كَرَاهِيَةٌ تَمادِي':Added, #1: 1	كَرَاهِيَةِ تَقْدِيمِ
u'كَرَاهِيَةٌ تَمَتُّعٌ':Added, #1: 1	كَرَاهِيَةِ تَمَادِيهِ
u'كَرَاهِيَةٌ تَنْزِيه':Added, #1: 1	كَرَاهِيَةِ التَّمَتُّعِ
u'كَرَاهِيَةٌ تَنْزِيهٌ':Added, #1: 1	كَرَاهِيَةُ التَّنْزِيهِ
u'كَرَاهِيَةٌ تَنْزِيه':Added, #1: 1	كَرَاهِيَةَ تَنْزِيهٍ
u'كَرَاهِيَةٌ تَنْزِيه':Added, #2: 2	كَرَاهِيَةَ التَّنْزِيهِ
u'كَرَاهِيَةٌ تَنَفُّسٌ':Added, #4: 4	كَرَاهِيَةِ التَّنْزِيهِ
u'كَرَاهِيَةٌ جَارٌ':Added, #1: 1	كَرَاهِيَةِ التَّنَفُّسِ
u'كَرَاهِيَةٌ جَامِعٌ':Added, #1: 1	كَرَاهِيَةِ الْجَارِ
u'كَرَاهِيَةٌ جُلُوسٌ':Added, #1: 1	كَرَاهِيَةَ الْجَامِعِ
u'كَرَاهِيَةٌ جُلُوسٌ':Added, #1: 1	كَرَاهِيَةُ الْجُلُوسِ
u'كَرَاهِيَةٌ حَبْسٌ':Added, #1: 1	كَرَاهِيَةِ الْجُلُوسِ
u'كَرَاهِيَةٌ حَسَنٌ':Added, #1: 1	كَرَاهِيَةُ حَبْسِ
u'كَرَاهِيَةٌ حَلْقٌ':Added, #1: 1	كَرَاهِيَةُ الْحَسَنِ
u'كَرَاهِيَةٌ حمر':Added, #1: 1	كَرَاهِيَةَ حَلْقِهِ
u'كَرَاهِيَةٌ حُمُرٌ':Added, #1: 1	كَرَاهِيَةِ الْحُمُرِ
u'كَرَاهِيَةٌ حَمْلٌ':Added, #1: 1	كَرَاهِيَةِ الْحُمُرِ
u'كَرَاهِيَةٌ خُرُوجٌ':Added, #1: 1	كَرَاهِيَةِ حَمْلِ
u'كَرَاهِيَةٌ خُرُوجٌ':Added, #1: 1	كَرَاهِيَةَ الْخُرُوجِ
u'كَرَاهِيَةٌ خِصاء':Added, #1: 1	كَرَاهِيَةِ خُرُوجِ
u'كَرَاهِيَةٌ دُخُولٌ':Added, #1: 1	كَرَاهِيَةِ خِصَاءِ
u'كَرَاهِيَةٌ دَوامٌ':Added, #2: 2	كَرَاهِيَةِ الدُّخُولِ
u'كَرَاهِيَةٌ دَوامٌ':Added, #1: 1	كَرَاهِيَةِ دَوَامِ
u'كَرَاهِيَةٌ ذَمٌّ':Added, #1: 1	كَرَاهِيَةِ دَوَامِهِ
u'كَرَاهِيَةٌ رَسُولٌ':Added, #1: 1	كَرَاهِيَةِ ذَمِّ
u'كَرَاهِيَةٌ رَفْعٌ':Added, #1: 1	كَرَاهِيَةُ الرّسُولِ
u'كَرَاهِيَةٌ رُكوبٌ':Added, #3: 3	كَرَاهِيَةِ رَفْعِ
u'كَرَاهِيَةٌ زِفافٌ':Added, #1: 1	كَرَاهِيَةِ الرُّكُوبِ
u'كَرَاهِيَةٌ زِيادَةٌ':Added, #1: 1	كَرَاهِيَةِ الزِّفَافِ
u'كَرَاهِيَةٌ سِباعٌ':Added, #1: 1	كَرَاهِيَةِ الزِّيَادَةِ
u'كَرَاهِيَةٌ سَفَرٌ':Added, #1: 1	كَرَاهِيَةِ السِّبَاعِ
u'كَرَاهِيَةٌ سمر':Added, #1: 1	كَرَاهِيَةِ السَّفَرِ
u'كَرَاهِيَةٌ سَمَرٌ':Added, #1: 1	كَرَاهِيَةُ السَّمَرِ
u'كَرَاهِيَةٌ سِواكٌ':Added, #1: 1	كَرَاهِيَةُ السَّمَرِ
u'كَرَاهِيَةٌ سُؤَالٌ':Added, #1: 1	كَرَاهِيَةَ السّوَاكِ
u'كَرَاهِيَةٌ سَيْرٌ':Added, #1: 1	كَرَاهِيَةِ السُّؤَالِ
u'كَرَاهِيَةٌ شِدَّةٌ':Added, #1: 1	كَرَاهِيَةِ السَّيْرِ
u'كَرَاهِيَةٌ صَفٌّ':Added, #1: 1	كَرَاهِيَةُ شِدَّةِ
u'كَرَاهِيَةٌ صَلاَةٌ':Added, #1: 1	كَرَاهِيَةِ الصَّفِّ
u'كَرَاهِيَةٌ صَلاَةٌ':Added, #1: 1	كَرَاهِيَةِ الصَّلَاةِ
u'كَرَاهِيَةٌ طَلاَقٌ':Added, #3: 3	كَرَاهِيَةِ الصَّلاَةِ
u'كَرَاهِيَةٌ طَلاَقٌ':Added, #1: 1	كَرَاهِيَةُ الطَّلَاقِ
u'كَرَاهِيَةٌ طَلاَقٌ':Added, #1: 1	كَرَاهِيَةِ الطَّلاَقِ
u'كَرَاهِيَةٌ طلب':Added, #2: 2	كَرَاهِيَةِ الطَّلَاقِ
u'كَرَاهِيَةٌ طَلَبٌ':Added, #1: 1	كَرَاهِيَةِ طَلَبِ
u'كَرَاهِيَةٌ ظَهِير':Added, #1: 1	كَرَاهِيَةِ طَلَبِ
u'كَرَاهِيَةٌ ظَهِيرَة':Added, #1: 1	كَرَاهِيَةِ الظَّهِيرِيَّةِ
u'كَرَاهِيَةٌ عِرَافَةٌ':Added, #1: 1	كَرَاهِيَةِ الظَّهِيرِيَّةِ
u'كَرَاهِيَةٌ علماء':Added, #1: 1	كَرَاهِيَةِ الْعِرَافَةِ
u'كَرَاهِيَةٌ عُلَمَاءُ':Added, #1: 1	كَرَاهِيَةُ الْعُلَمَاءِ
u'كَرَاهِيَةٌ عَمَلٌ':Added, #1: 1	كَرَاهِيَةُ الْعُلَمَاءِ
u'كَرَاهِيَةٌ عِيَادَةٌ':Added, #1: 1	كَرَاهِيَةِ الْعَمَلِ
u'كَرَاهِيَةٌ قُبْلَةٌ':Added, #1: 1	كَرَاهِيَةُ الْعِيَادَةِ
u'كَرَاهِيَةٌ قتل':Added, #1: 1	كَرَاهِيَةِ الْقُبْلَةِ
u'كَرَاهِيَةٌ قَتْلٌ':Added, #2: 2	كَرَاهِيَةِ قَتْلِ
u'كَرَاهِيَةٌ قِرَانٌ':Added, #2: 2	كَرَاهِيَةِ قَتْلِ
u'كَرَاهِيَةٌ قَضَاءٌ':Added, #1: 1	كَرَاهِيَةِ الْقِرَانِ
u'كَرَاهِيَةٌ قَطْعٌ':Added, #1: 1	كَرَاهِيَةِ الْقَضَاءِ
u'كَرَاهِيَةٌ قول':Added, #1: 1	كَرَاهِيَةِ قَطْعِ
u'كَرَاهِيَةٌ قَوْلٌ':Added, #2: 2	كَرَاهِيَةِ قَوْلِ
u'كَرَاهِيَةٌ قول':Added, #2: 2	كَرَاهِيَةِ قَوْلِ
u'كَرَاهِيَةٌ قَوْلٌ':Added, #3: 3	كَرَاهِيَةُ قَوْلِهِ
u'كَرَاهِيَةٌ كَثْرَةٌ':Added, #3: 3	كَرَاهِيَةُ قَوْلِهِ
u'كَرَاهِيَةٌ كَلاَمٌ':Added, #1: 1	كَرَاهِيَةِ كَثْرَةِ
u'كَرَاهِيَةٌ لبس':Added, #1: 1	كَرَاهِيَةِ الْكَلاَمِ
u'كَرَاهِيَةٌ لُبْسٌ':Added, #1: 1	كَرَاهِيَةِ لُبْسِ
u'كَرَاهِيَةٌ لعب':Added, #1: 1	كَرَاهِيَةِ لُبْسِ
u'كَرَاهِيَةٌ لَعِبٌ':Added, #2: 2	كَرَاهِيَةُ اللَّعِبِ
u'كَرَاهِيَةٌ لعب':Added, #2: 2	كَرَاهِيَةُ اللَّعِبِ
u'كَرَاهِيَةٌ لَعِبٌ':Added, #3: 3	كَرَاهِيَةِ اللَّعِبِ
u'كَرَاهِيَةٌ مَالِكٌ':Added, #3: 3	كَرَاهِيَةِ اللَّعِبِ
u'كَرَاهِيَةٌ مَالِكٌ':Added, #1: 1	كَرَاهِيَةَ مَالِكٍ
u'كَرَاهِيَةٌ مُبَايَعَةٌ':Added, #1: 1	كَرَاهِيَةِ مَالِكٍ
u'كَرَاهِيَةٌ مَرِيضٌ':Added, #1: 1	كَرَاهِيَةِ مُبَايَعَةِ
u'كَرَاهِيَةٌ مَرِيضٌ':Added, #1: 1	كَرَاهِيَةِ الْمَرِيضِ
u'كَرَاهِيَةٌ مَسٌّ':Added, #3: 3	كَرَاهِيَةُ الْمَرِيضِ
u'كَرَاهِيَةٌ مَسْأَلَةٌ':Added, #1: 1	كَرَاهِيَةِ مَسِّ
u'كَرَاهِيَةٌ مَسْحٌ':Added, #1: 1	كَرَاهِيَةِ الْمَسْأَلَةِ
u'كَرَاهِيَةٌ مَنْعٌ':Added, #1: 1	كَرَاهِيَةِ مَسْحِ
u'كَرَاهِيَةٌ نذر':Added, #1: 1	كَرَاهِيَةِ مَنْعِ
u'كَرَاهِيَةٌ نَذْرٌ':Added, #1: 1	كَرَاهِيَةِ النَّذْرِ
u'كَرَاهِيَةٌ نَظَرٌ':Added, #1: 1	كَرَاهِيَةِ النَّذْرِ
u'كَرَاهِيَةٌ نَظَرٌ':Added, #1: 1	كَرَاهِيَةُ النَّظَرِ
u'كَرَاهِيَةٌ نَفْسٌ':Added, #1: 1	كَرَاهِيَةِ النَّظَرِ
u'كَرَاهِيَةٌ نَفَلٌ':Added, #2: 2	كَرَاهِيَةِ النَّفْسِ
u'كَرَاهِيَةٌ نكاح':Added, #1: 1	كَرَاهِيَةِ النَّفَلِ
u'كَرَاهِيَةٌ نِكَاحٌ':Added, #1: 1	كَرَاهِيَةِ نِكَاحِ
u'كَرَاهِيَةٌ نَوْمٌ':Added, #1: 1	كَرَاهِيَةِ نِكَاحِ
u'كَرَاهِيَةٌ نَوْمٌ':Added, #1: 1	كَرَاهِيَةِ النَّوْمِ
u'كَرَاهِيَةٌ هِدَايَةٌ':Added, #1: 1	كَرَاهِيَةِ نَوْمِ
u'كَرَاهِيَةٌ وَاقِعٌ':Added, #1: 1	كَرَاهِيَةِ الْهِدَايَةِ
u'كَرَاهِيَةٌ وَجْهٌ':Added, #2: 2	كَرَاهِيَةِ الْوَاقِعَاتِ
u'كَرَاهِيَةٌ وُقُوفٌ':Added, #1: 1	كَرَاهِيَةَ وَجْهِهِ
u'كَرَاهِيَةٌ وِلاَيَةٌ':Added, #1: 1	كَرَاهِيَةِ الْوُقُوفِ
u'كَرَاهِيَةٌ يَمِينٌ':Added, #1: 1	كَرَاهِيَةِ الْوِلاَيَةِ
u'كَرَبَ أرْضٌ':Predicate, #1: 1	كَرَاهِيَةِ الْيَمِينِ
u'كَرْبٌ أرْضٌ':Added, #11: 11	كَرَبَ الْأَرْضَ
u'كَرْبٌ طَالِبٌ':Added, #1: 1	كَرْبِ الْأَرْضِ
u'كَرَبَ عَامِلٌ':Subject, #1: 1	كَرْبِ الطَّالِبِ
u'كَرْبٌ عَظِيم':Added, #1: 1	كَرَبَ الْعَامِلُ
u'كَرَبَ مثل':Predicate, #1: 1	كَرْبٍ عَظِيمٍ
u'كَرَبَ مِثْلٌ':Predicate, #1: 1	كَرَبَ مِثْلَ
u'كَرَبَ مُزَارِعٌ':Subject, #1: 1	كَرَبَ مِثْلَ
u'كَرْبٌ مَوْتٌ':Added, #2: 2	كَرَبَ الْمُزَارِعُ
u'كَرَّةٌ عَدُوٌّ':Added, #1: 1	كَرْبِ الْمَوْتِ
u'كَرَّرَ أدَاةٌ':Predicate, #2: 2	كَرَّةَ الْعَدُوِّ
u'كَرَّرَ إِطْعامٌ':Predicate, #2: 2	كَرَّرَ أَدَاةَ
u'كَرَّرَ إقْرَارٌ':Predicate, #1: 1	كَرَّرَ الْإِطْعَامَ
u'كَرَّرَ أُمٌّ':Predicate, #1: 1	كَرَّرَ الْإِقْرَارَ
u'كَرَّرَ إيمَانٌ':Predicate, #1: 1	كَرَّرَ أُمَّ
u'كَرَّرَ أَيْمَانٌ':Predicate, #1: 1	كَرَّرَ الْإِيمَانَ
u'كَرَّرَ تَخْيِيرٌ':Predicate, #2: 2	كَرَّرَ الْأَيْمَانَ
u'كَرَّرَ تَرَحُّمٌ':Predicate, #1: 1	كَرَّرَ التَّخْيِيرَ
u'كَرَّرَ تَشَهُّدٌ':Predicate, #1: 1	كَرَّرَ التَّرَحُّمَ
u'كَرَّرَ تَعْلِيقٌ':Predicate, #4: 4	كَرَّرَ التَّشَهُّدَ
u'كَرَّرَ تَعْلِيقٌ':Predicate, #1: 1	كَرَّرَ التَّعْلِيقَ
u'كَرَّرَ تَكْبيرٌ':Predicate, #2: 2	كَرَّرَ تَعْلِيقَ
u'كَرَّرَ تِلاوَةٌ':Predicate, #1: 1	كَرَّرَ التَّكْبِيرَ
u'كَرَّرَ ثَلاثُ':Predicate, #3: 3	كَرَّرَ تِلَاوَةَ
u'كَرَّرَ حَرْفٌ':Predicate, #1: 1	كَرَّرَ الثَّلَاثَ
u'كَرَّرَ خيار':Predicate, #3: 3	كَرَّرَ حَرْفَ
u'كَرَّرَ خِيَارٌ':Predicate, #1: 1	كَرَّرَ الْخِيَارَ
u'كَرَّرَ سَقْيٌ':Predicate, #1: 1	كَرَّرَ الْخِيَارَ
u'كَرَّرَ سُؤَالٌ':Predicate, #1: 1	كَرَّرَ السَّقْيَ
u'كَرَّرَ سُورَةٌ':Predicate, #1: 1	كَرَّرَ السُّؤَالَ
u'كَرَّرَ شِرَاءٌ':Predicate, #2: 2	كَرَّرَ السُّورَةَ
u'كَرَّرَ شرب':Predicate, #1: 1	كَرَّرَ الشِّرَاءَ
u'كَرَّرَ شُرْبٌ':Predicate, #2: 2	كَرَّرَ شُرْبَ
u'كَرَّرَ شَرْطٌ':Predicate, #2: 2	كَرَّرَ شُرْبَ
u'كَرَّرَ طَلاَقٌ':Predicate, #1: 1	كَرَّرَ الشَّرْطَ
u'كَرَّرَ ظهار':Predicate, #3: 3	كَرَّرَ الطَّلَاقَ
u'كَرَّرَ عَامِلٌ':Predicate, #3: 3	كَرَّرَ الظِّهَارَ
u'كَرَّرَ عَرْضٌ':Predicate, #1: 1	كَرَّرَ الْعَامِلَ
u'كَرَّرَ عمرة':Predicate, #2: 2	كَرَّرَ الْعَرْضَ
u'كَرَّرَ عُمْرَةٌ':Predicate, #1: 1	كَرَّرَ الْعُمْرَةَ
u'كَرَّرَ فَاتِحٌ':Predicate, #1: 1	كَرَّرَ الْعُمْرَةَ
u'كَرَّرَ فَاتِحَةٌ':Predicate, #3: 3	كَرَّرَ الْفَاتِحَةَ
u'كَرَّرَ فِطْرٌ':Predicate, #3: 3	كَرَّرَ الْفَاتِحَةَ
u'كَرَّرَ فِعْلٌ':Predicate, #1: 1	كَرَّرَ الْفِطْرَ
u'كَرَّرَ قذف':Predicate, #1: 1	كَرَّرَ فِعْلَ
u'كَرَّرَ قَذْفٌ':Predicate, #3: 3	كَرَّرَ الْقَذْفَ
u'كَرَّرَ قَسَمٌ':Predicate, #3: 3	كَرَّرَ الْقَذْفَ
u'كَرَّرَ كَلِمَةٌ':Predicate, #1: 1	كَرَّرَ الْقَسَمَ
u'كَرَّرَ لَفْظٌ':Predicate, #1: 1	كَرَّرَ الْكَلِمَةَ
u'كَرَّرَ لَفْظٌ':Predicate, #13: 13	كَرَّرَ لَفْظَ
u'كَرَّرَ مُتَعَلِّمٌ':Subject, #5: 5	كَرَّرَ اللَّفْظَ
u'كَرَّرَ مُتَمَتِّعٌ':Subject, #1: 1	كَرَّرَ الْمُتَعَلِّمُ
u'كَرَّرَ مرٌّ':Predicate, #1: 1	كَرَّرَ الْمُتَمَتِّعُ
u'كَرَّرَ مَسَائِلُ':Predicate, #1: 1	كَرَّرَ مَرَّةً
u'كَرَّرَ مَسْحٌ':Predicate, #3: 3	كَرَّرَ مَسَائِلَ
u'كَرَّرَ مُصَنِّفٌ':Subject, #1: 1	كَرَّرَ الْمَسْحَ
u'كَرَّرَ نَظَرٌ':Predicate, #3: 3	كَرَّرَ الْمُصَنِّفُ
u'كَرَّرَ نَفْيٌ':Predicate, #14: 14	كَرَّرَ النَّظَرَ
u'كَرَّرَ وَطْءٌ':Predicate, #1: 1	كَرَّرَ النَّفْيَ
u'كَرَّرَ يَمِينٌ':Predicate, #2: 2	كَرَّرَ الْوَطْءَ
u'كَرَّرَ يَمِينٌ':Predicate, #1: 1	كَرَّرَ يَمِينَ
u'كَرَّرَ يَوْمٌ':Predicate, #3: 3	كَرَّرَ الْيَمِينَ
u'كَرَمٌ الْمَرْءُ':Added, #1: 1	كَرَّرَ الْيَوْمَ
u'كَرَمٌ حَيَاةٌ':Added, #3: 3	كَرَمُ الْمَرْءِ
u'كَرَّ مُصَنِّفٌ':Subject, #2: 2	كَرَمُ الْحَيَاةِ
u'كَرَمٌ طَبْعٌ':Added, #1: 1	كَرَّ الْمُصَنِّفُ
u'كَرَمٌ طَبِيعَةٌ':Added, #1: 1	كَرَمُ الطَّبْعِ
u'كَرَمٌ فَتَّاحٌ':Added, #2: 2	كَرَمِ الطَّبِيعَةِ
u'كَرَمٌ نَفْسٌ':Added, #1: 1	كَرَمِ الْفَتَّاحِ
u'كَرَمٌ نَفْسٌ':Added, #1: 1	كَرَمِ نَفْسِهِ
u'كَرِهَ اِبْنٌ':Subject, #2: 2	كَرَمِ النَّفْسِ
u'كَرِهَ إجَازَةٌ':Predicate, #3: 3	كَرِهَ ابْنُ
u'كَرِهَ أَجْرٌ':Predicate, #2: 2	كَرِهَ الْإِجَازَةَ
u'كَرِهَ أحَدٌ':Subject, #1: 1	كَرِهَ أَجْرَ
u'كَرِهَ أخْذٌ':Predicate, #1: 1	كَرِهَ أَحَدُ
u'كَرِهَ أخْذٌ':Predicate, #1: 1	كَرِهَ أَخْذَ
u'كَرِهَ إِخْرَاجٌ':Predicate, #1: 1	كَرِهَ الْأَخْذَ
u'كَرِهَ اِسْتِقْبالٌ':Predicate, #1: 1	كَرِهَ إخْرَاجَ
u'كَرِهَ اِسْتِكْثارٌ':Predicate, #1: 1	كَرِهَ اسْتِقْبَالَ
u'كَرِهَ اِسْمٌ':Predicate, #1: 1	كَرِهَ الاِسْتِكْثَارَ
u'كَرِهَ إِشْعارٌ':Predicate, #2: 2	كَرِهَ الاِسْمَ
u'كَرِهَ أَشْهَب':Subject, #2: 2	كَرِهَ إشْعَارَ
u'كَرِهَ إِطْلاقٌ':Predicate, #1: 1	كَرِهَ أَشْهَبُ
u'كَرِهَ أَطْمَاعٌ':Predicate, #1: 1	كَرِهَ إطْلَاقَ
u'كَرِهَ اِعْتِكافٌ':Predicate, #1: 1	كَرِهَ الْأَطْمَاعَ
u'كَرِهَ إعْلاَمٌ':Subject, #1: 1	كَرِهَ اعْتِكافَ
u'كَرِهَ إِفْرَاطٌ':Predicate, #1: 1	كَرِهَ إعْلَامُهُ
u'كَرِهَ إقالَةٌ':Predicate, #2: 2	كَرِهَ الْإِفْرَاطَ
u'كَرِهَ أَكْثَرُ':Subject, #1: 1	كَرِهَ الْإِقَالَةَ
u'كَرِهَ أكل':Predicate, #1: 1	كَرِهَ أَكْثَرُ
u'كَرِهَ أَكْلٌ':Predicate, #4: 4	كَرِهَ أَكْلَ
u'كَرِهَ إلْبَاسٌ':Predicate, #4: 4	كَرِهَ أَكْلَ
u'كَرِهَ الْمَرْأَةُ':Predicate, #1: 1	كَرِهَ إلْبَاسَ
u'كَرِهَ الْمَرْأَةُ':Predicate, #1: 1	كَرِهَ الْمَرْأَةَ
u'كَرِهَ إمَامٌ':Subject, #3: 3	أَكْرَهَ الْمَرْأَةَ
u'كَرِهَ اِنْتِفاعٌ':Predicate, #21: 21	كَرِهَ الْإِمَامُ
u'كَرِهَ أهْلٌ':Subject, #1: 1	كَرِهَ الاِنْتِفَاعَ
u'كَرِهَ أَوَّلُ':Predicate, #2: 2	كَرِهَ أَهْلُ
u'كَرِهَ أَيْمَانٌ':Predicate, #1: 1	كَرِهَ الْأَوَّلَ
u'كَرِهَ بَطَائِنُ':Predicate, #1: 1	كَرِهَ الأَيْمَانَ
u'كَرِهَ بَعْضٌ':Subject, #1: 1	كَرِهَ بَطَائِنَ
u'كَرِهَ بَيْعٌ':Predicate, #6: 6	كَرِهَ بَعْضُ
u'كَرِهَ بَيْعٌ':Predicate, #1: 1	كَرِهَ الْبَيْعَ
u'كَرِهَ تَحَلُّقٌ':Predicate, #8: 8	كَرِهَ بَيْعَ
u'كَرِهَ تَدَاوِي':Predicate, #1: 1	كَرِهَ التَّحَلُّقَ
u'كَرِهَ تَرْكٌ':Predicate, #1: 1	كَرِهَ التَّدَاوِيَ
u'كَرِهَ تَزَايُدٌ':Predicate, #1: 1	كَرِهَ تَرْكَ
u'كَرِهَ تَسْوِيدٌ':Predicate, #1: 1	كَرِهَ التَّزَايُدَ
u'كَرِهَ تَعْلِيمٌ':Predicate, #2: 2	كَرِهَ تَسْوِيدَ
u'كَرِهَ تَقْديمٌ':Predicate, #1: 1	كَرِهَ تَعْلِيمَ
u'كَرِهَ تَمْرَةٌ':Predicate, #1: 1	كَرِهَ تَقْدِيمَ
u'كَرِهَ تَنُّورٌ':Predicate, #1: 1	كَرِهَ التَّمْرَةَ
u'كَرِهَ تَوَاضُعٌ':Predicate, #1: 1	كَرِهَ التَّنُّورَ
u'كَرِهَ جَمَاعَةٌ':Subject, #1: 1	كَرِهَ التَّوَاضُعَ
u'كَرِهَ جمع':Predicate, #2: 2	كَرِهَ جَمَاعَةٌ
u'كَرِهَ جَمْعٌ':Predicate, #2: 2	كَرِهَ الْجَمْعَ
u'كَرِهَ جُمْهُورٌ':Subject, #2: 2	كَرِهَ الْجَمْعَ
u'كَرِهَ جهر':Predicate, #1: 1	كَرِهَ جُمْهُورُ
u'كَرِهَ جَهْرٌ':Predicate, #1: 1	كَرِهَ الْجَهْرَ
u'كَرِهَ جِوَارٌ':Predicate, #1: 1	كَرِهَ الْجَهْرَ
u'كَرِهَ حَسَنٌ':Subject, #1: 1	كَرِهَ الْجِوَارَ
u'كَرِهَ حَمَّامٌ':Predicate, #1: 1	كَرِهَ الْحَسَنُ
u'كَرِهَ خَصْمٌ':Subject, #1: 1	كَرِهَ الْحَمَّامَ
u'كَرِهَ خَلُوق':Predicate, #1: 1	كَرِهَ خَصْمُهُ
u'كَرِهَ دُخَانٌ':Predicate, #1: 1	كَرِهَ الْخَلُوقَ
u'كَرِهَ دُعَاءٌ':Predicate, #1: 1	كَرِهَ دُخَانَ
u'كَرِهَ ذَبيحٌ':Predicate, #1: 1	كَرِهَ دُعَاءَ
u'كَرِهَ ذَبيحَةٌ':Predicate, #1: 1	كَرِهَ ذَبِيحَةَ
u'كَرِهَ ذَهَبٌ':Predicate, #1: 1	كَرِهَ ذَبِيحَةَ
u'كَرِهَ رَاهِنٌ':Subject, #1: 1	كَرِهَ الذَّهَبَ
u'كَرِهَ رَبُّ':Subject, #2: 2	كَرِهَ الرَّاهِنُ
u'كَرِهَ رَسُولٌ':Subject, #1: 1	كَرِهَ رَبُّ
u'كَرِهَ رَشٌّ':Predicate, #6: 6	كَرِهَ رَسُولُ
u'كَرِهَ رَمْيٌ':Predicate, #1: 1	كَرِهَ الرَّشَّ
u'كَرِهَ رُؤْيَةٌ':Predicate, #1: 1	كَرِهَ الرَّمْيَ
u'كَرِهَ زَوْجٌ':Subject, #2: 2	كَرِهَ رُؤْيَةَ
u'كَرِهَ زَوْجٌ':Subject, #1: 1	كَرِهَ زَوْجُ
u'كَرِهَ زَوْجَةٌ':Predicate, #5: 5	كَرِهَ الزَّوْجُ
u'كَرِهَ زَيْدٌ':Subject, #1: 1	أَكْرَهَ الزَّوْجَةَ
u'كَرِهَ زِينَةٌ':Predicate, #1: 1	كَرِهَ زَيْدٌ
u'كُرْهٌ سَرَاوِيلُ':Added, #1: 1	كَرِهَ الزِّينَةَ
u'كَرِهَ سُرْعَةٌ':Predicate, #1: 1	كُرْهِ السَّرَاوِيلِ
u'كَرِهَ سِقَاءٌ':Predicate, #1: 1	كَرِهَ السُّرْعَةَ
u'كَرِهَ سَلَفٌ':Predicate, #2: 2	كَرِهَ السِّقَاءَ
u'كَرِهَ سَلَفٌ':Subject, #1: 1	كَرِهَ السَّلَفَ
u'كَرِهَ سَلَمٌ':Predicate, #4: 4	كَرِهَ السَّلَفُ
u'كَرِهَ سِواكٌ':Predicate, #1: 1	كَرِهَ السَّلَمَ
u'كَرِهَ سَيِّدٌ':Subject, #1: 1	كَرِهَ السِّوَاكَ
u'كَرِهَ شافِعِيّ':Subject, #4: 4	كَرِهَ سَيِّدُهُ
u'كَرِهَ شِدَّةٌ':Predicate, #4: 4	كَرِهَ الشَّافِعِيُّ
u'كَرِهَ شِرَاءٌ':Predicate, #1: 1	كَرِهَ شِدَّةَ
u'كَرِهَ شرب':Predicate, #2: 2	كَرِهَ شِرَاءَ
u'كَرِهَ شُرْبٌ':Predicate, #1: 1	كَرِهَ الشُّرْبَ
u'كَرِهَ شَرْطٌ':Predicate, #1: 1	كَرِهَ الشُّرْبَ
u'كَرِهَ شَرْعٌ':Subject, #1: 1	كَرِهَ الشَّرْطَ
u'كَرِهَ شَهَادَةٌ':Predicate, #1: 1	كَرِهَ الشَّرْعُ
u'كَرِهَ شَيْءٌ':Predicate, #1: 1	كَرِهَ شَهَادَةَ
u'كَرِهَ شَيْخٌ':Subject, #1: 1	كَرِهَ الشَّيْءَ
u'كَرِهَ صَاحِبٌ':Predicate, #1: 1	كَرِهَ الشَّيْخُ
u'كَرِهَ صَاحِبٌ':Subject, #1: 1	أَكْرَهَ صَاحِبَ
u'كَرِهَ صَاحِبٌ':Subject, #1: 1	كَرِهَ صَاحِبُ
u'كَرِهَ صَلاَةٌ':Predicate, #1: 1	كَرِهَ صَاحِبُهُ
u'كَرِهَ صَلاَةٌ':Predicate, #1: 1	كَرِهَ الصَّلَاةَ
u'كَرِهَ صَلاَةٌ':Predicate, #1: 1	كَرِهَ صَلَاةَ
u'كُرْهٌ صَلاَةٌ':Added, #2: 2	كَرِهَ الصَّلاَةَ
u'كُرْهٌ صَلاَةٌ':Added, #1: 1	كُرْهُ الصَّلَاةِ
u'كَرِهَ صَوْمٌ':Predicate, #1: 1	كُرْهِ الصَّلَاةِ
u'كَرِهَ طَوَائِفُ':Subject, #2: 2	كَرِهَ صَوْمَ
u'كَرِهَ ظُلْمٌ':Predicate, #1: 1	كَرِهَ طَوَائِفُ
u'كَرِهَ عَاقِلٌ':Predicate, #1: 1	كَرِهَ الظّلْمَ
u'كَرِهَ عَبْدٌ':Subject, #1: 1	أَكْرَهَ عَاقِلَةً
u'كَرِهَ عُذْرَةٌ':Predicate, #1: 1	كَرِهَ عَبْدُ
u'كَرِهَ عزل':Predicate, #1: 1	كَرِهَ الْعُذْرَةَ
u'كَرِهَ عَشْرٌ':Predicate, #1: 1	كَرِهَ الْعَزْلَ
u'كُرْهٌ عِلاَجٌ':Added, #2: 2	كَرِهَ عَشْرَ
u'كَرِهَ علماء':Subject, #1: 1	كُرْهِ الْعِلَاجِ
u'كَرِهَ عُلَمَاءُ':Subject, #1: 1	كَرِهَ عُلَمَاءُ
u'كَرِهَ علماء':Subject, #1: 1	كَرِهَ عُلَمَاءُ
u'كَرِهَ عُلَمَاءُ':Subject, #2: 2	كَرِهَ الْعُلَمَاءُ
u'كَرِهَ عُمَرٌ':Subject, #2: 2	كَرِهَ الْعُلَمَاءُ
u'كَرِهَ عمي':Predicate, #2: 2	كَرِهَ عُمَرُ
u'كَرِهَ غَلَّةٌ':Predicate, #1: 1	كَرِهَ عَمِيَ
u'كَرِهَ فَضْلٌ':Predicate, #1: 1	كَرِهَ غَلَّةَ
u'كَرِهَ فلان':Subject, #1: 1	كَرِهَ فَضْلَ
u'كَرِهَ فلان':Subject, #2: 2	كَرِهَ مُعَاوِيَةُ
u'كَرِهَ قَابِضٌ':Predicate, #4: 4	كَرِهَ الشَّافِعِيُّ
u'كَرِهَ قتال':Predicate, #1: 1	أَكْرَهَ الْقَابِضَ
u'كَرِهَ قِتَالٌ':Predicate, #1: 1	كَرِهَ قِتَالَ
u'كَرِهَ قتل':Predicate, #1: 1	كَرِهَ قِتَالَ
u'كَرِهَ قَتْلٌ':Predicate, #1: 1	كَرِهَ قَتْلَ
u'كَرِهَ قِرَاءةٌ':Predicate, #1: 1	كَرِهَ قَتْلَ
u'كُرْهٌ قِرَاءةٌ':Added, #3: 3	كَرِهَ قِرَاءَةَ
u'كَرِهَ قِرَانٌ':Predicate, #1: 1	كُرْهِ قِرَاءَةِ
u'كُرْهٌ قِرْدٌ':Added, #1: 1	كَرِهَ الْقِرَانَ
u'كَرِهَ قَسْمٌ':Predicate, #1: 1	كُرْهِ الْقِرْدِ
u'كَرِهَ قَوْمٌ':Subject, #1: 1	كَرِهَ قَسْمَ
u'كَرِهَ كَافِرٌ':Subject, #2: 2	كَرِهَ قَوْمٌ
u'كَرِهَ كِتَابَةٌ':Predicate, #2: 2	كَرِهَ الْكَافِرُ
u'كَرِهَ كَثْرَةٌ':Predicate, #1: 1	كَرِهَ كِتَابَةَ
u'كَرِهَ لبس':Predicate, #2: 2	كَرِهَ كَثْرَةَ
u'كَرِهَ لُبْسٌ':Predicate, #1: 1	كَرِهَ لُبْسَ
u'كَرِهَ لبن':Predicate, #1: 1	كَرِهَ لُبْسَ
u'كَرِهَ لَبَنٌ':Predicate, #1: 1	كَرِهَ لَبَنَ
u'كَرِهَ لَحْمٌ':Predicate, #1: 1	كَرِهَ لَبَنَ
u'كَرِهَ لدد':Predicate, #1: 1	كَرِهَ لَحْمَ
u'كَرِهَ لَدَدٌ':Predicate, #1: 1	كَرِهَ اللَّدَدَ
u'كَرِهَ لِقَاءٌ':Predicate, #1: 1	كَرِهَ اللَّدَدَ
u'كَرِهَ مَاءٌ':Predicate, #5: 5	كَرِهَ لِقَاءَ
u'كَرِهَ مَالِكٌ':Subject, #1: 1	كَرِهَ الْمَاءَ
u'كَرِهَ مُبَاشَرَةٌ':Predicate, #80: 80	كَرِهَ مَالِكٌ
u'كَرِهَ مُثْمِر':Predicate, #5: 5	كَرِهَ الْمُبَاشَرَةَ
u'كَرِهَ مُجَازَفَةٌ':Predicate, #1: 1	كَرِهَ الْمُثْمِرَ
u'كَرِهَ مَحْلَبٌ':Predicate, #1: 1	كَرِهَ الْمُجَازَفَةَ
u'كَرِهَ مُحَمَّدٌ':Subject, #1: 1	كَرِهَ الْمَحْلَبَ
u'كَرِهَ مُخَالِفٌ':Subject, #1: 1	كَرِهَ مُحَمَّدٌ
u'كَرِهَ مُخَالَفَةٌ':Predicate, #1: 1	كَرِهَ الْمُخَالِفُ
u'كَرِهَ مُخَالَفَةٌ':Predicate, #1: 1	كَرِهَ الْمُخَالَفَةَ
u'كَرِهَ مُرُورٌ':Predicate, #1: 1	كَرِهَ مُخَالَفَةَ
u'كَرِهَ مَسَائِلُ':Predicate, #1: 1	كَرِهَ الْمُرُورَ
u'كَرِهَ مَسْحٌ':Predicate, #5: 5	كَرِهَ الْمَسَائِلَ
u'كَرِهَ مَشْيٌ':Predicate, #1: 1	كَرِهَ الْمَسْحَ
u'كَرِهَ مَضْغٌ':Predicate, #3: 3	كَرِهَ الْمَشْيَ
u'كَرِهَ مُعَامَلَةٌ':Predicate, #1: 1	كَرِهَ مَضْغَ
u'كَرِهَ مُعاوِيَة':Subject, #2: 2	كَرِهَ مُعَامَلَةَ
u'كَرِهَ مُعَصْفَر':Predicate, #2: 2	كَرِهَ مُعَاوِيَةُ
u'كُرْهٌ مُعَلَّقٌ':Added, #3: 3	كَرِهَ الْمُعَصْفَرَ
u'كَرِهَ مَكْرُوهٌ':Predicate, #1: 1	كُرْهِ الْمُعَلَّقِ
u'كَرِهَ مِنْطَقَةٌ':Predicate, #1: 1	كَرِهَ الْمَكْرُوهَ
u'كَرِهَ نَاسٌ':Subject, #1: 1	كَرِهَ الْمِنْطَقَةَ
u'كَرِهَ نَبِيٌّ':Subject, #3: 3	كَرِهَ النَّاسُ
u'كَرِهَ نشرة':Predicate, #4: 4	كَرِهَ النَّبِيُّ
u'كَرِهَ نَشْرَةٌ':Predicate, #1: 1	كَرِهَ النّشْرَةَ
u'كَرِهَ نُشْرَةٌ':Predicate, #1: 1	كَرِهَ النّشْرَةَ
u'كَرِهَ نقل':Predicate, #1: 1	كَرِهَ النّشْرَةَ
u'كَرِهَ نَقْلٌ':Predicate, #1: 1	كَرِهَ نَقْلَ
u'كَرِهَ نكاح':Predicate, #1: 1	كَرِهَ نَقْلَ
u'كَرِهَ نِكَاحٌ':Predicate, #1: 1	كَرِهَ نِكَاحَ
u'كَرِهَ نَوْمٌ':Predicate, #1: 1	كَرِهَ نِكَاحَ
u'كَرِهَ وَضْعٌ':Predicate, #1: 1	كَرِهَ النَّوْمَ
u'كَرِهَ وُضُوءٌ':Predicate, #1: 1	كَرِهَ وَضْعَ
u'كَرِهَ وَطْءٌ':Predicate, #3: 3	كَرِهَ الْوُضُوءَ
u'كَرِهَ وَلِيٌّ':Subject, #1: 1	كَرِهَ الْوَطْءَ
u'كَرَى أَسْفَلُ':Predicate, #2: 2	كَرِهَ الْوَلِيُّ
u'كَرِيَ رِباعٌ':Predicate, #1: 1	كَرَى أَسْفَلَ
u'كَرِيَ رِبَاعٌ':Predicate, #1: 1	أَكْرَى الرِّبَاعَ
u'كَرِيَ مَطْمُورٌ':Predicate, #1: 1	أَكْرَى الرِّبَاعَ
u'كَرِيَ نِصْفٌ':Predicate, #2: 2	أَكْرَى مَطْمُورَةً
u'كَسَا أُمٌّ':Predicate, #1: 1	أَكْرَى نِصْفَ
u'كَسَا أَميرٌ':Subject, #2: 2	كَسَا أُمَّ
u'كَسَا بَحْرٌ':Subject, #3: 3	كَسَا الْأَمِيرُ
u'كَسَا بَيْتٌ':Predicate, #1: 1	كَسَا الْبَحْرُ
u'كَسَا ثَوْبٌ':Predicate, #6: 6	كَسَا الْبَيْتَ
u'كَسَا حُلَّةٌ':Predicate, #1: 1	كَسَا الثَّوْبَ
u'كَسَادٌ دَرَاهِمُ':Added, #1: 1	كَسَا الْحُلّةَ
u'كَسَادٌ سُوقٌ':Added, #2: 2	كَسَادِ الدَّرَاهِمِ
u'كَسَادٌ فُلُوسٌ':Added, #1: 1	كَسَادِ السُّوقِ
u'كَسَا رَجُلٌ':Subject, #1: 1	كَسَادِ الْفُلُوسِ
u'كَسَا صغار':Predicate, #1: 1	كَسَا الرَّجُلُ
u'كَسَا عَشْرٌ':Predicate, #1: 1	كَسَا صِغَارَ
u'كَسَا كعبة':Predicate, #1: 1	كَسَا عَشْرَةَ
u'كَسَا كَعْبَةٌ':Predicate, #4: 4	كَسَا الْكَعْبَةَ
u'كَسَا مُفَاوِضٌ':Subject, #4: 4	كَسَا الْكَعْبَةَ
u'كَسَا نَاسٌ':Predicate, #1: 1	كَسَا الْمُفَاوِضُ
u'كَسْبٌ أَبٌ':Added, #1: 1	كَسَا النَّاسَ
u'كَسْبٌ إِذْنٌ':Added, #1: 1	كَسْبُ الْأَبِ
u'كَسْبٌ إِذْنٌ':Added, #2: 2	كَسْبِ الْإِذْنِ
u'كَسْبٌ إِسْلامٌ':Added, #3: 3	كَسْبُ الْإِذْنِ
u'كَسْبٌ إِسْلامٌ':Added, #17: 17	كَسْبِ الْإِسْلَامِ
u'كَسْبٌ إِسْلامٌ':Added, #1: 1	كَسْبُ إسْلَامٍ
u'كَسْبٌ إِسْلامٌ':Added, #2: 2	كَسْبِ إسْلَامِهِ
u'كَسْبٌ إِسْلامٌ':Added, #4: 4	كَسْبَ إسْلَامِهِ
u'كَسْبٌ إِسْلامٌ':Added, #7: 7	كَسْبَ الْإِسْلَامِ
u'كَسْبٌ إِلْزَامٌ':Added, #9: 9	كَسْبُ الْإِسْلَامِ
u'كَسْبٌ الْمَرْأَةُ':Added, #1: 1	كَسْبَ الْإِلْزَامِ
u'كَسْبٌ أُمٌّ':Added, #1: 1	كَسْبِ الْمَرْأَةِ
u'كَسْبٌ إمَاءٌ':Added, #1: 1	كَسْبَ الْأُمِّ
u'كَسْبٌ أمَةٌ':Added, #3: 3	كَسْبِ الإِمَاءِ
u'كَسْبٌ أمَةٌ':Added, #3: 3	كَسْبُ أَمَتِهِ
u'كَسْبٌ تُجَّارٌ':Added, #5: 5	كَسْبِ الأَمَةِ
u'كَسْبٌ تِجَارَةٌ':Added, #1: 1	كَسْبُ التُّجَّارِ
u'كَسْبٌ تِجَارَةٌ':Added, #1: 1	كَسْبُ تِجَارَةٍ
u'كَسْبٌ تَصَدُّقٌ':Added, #3: 3	كَسْبِ التِّجَارَةِ
u'كَسْبٌ جَديدٌ':Added, #1: 1	كَسْبِ التَّصَدُّقِ
u'كَسْبٌ حَجَّام':Added, #1: 1	كَسْبٍ جَدِيدٍ
u'كَسْبٌ حَجَّام':Added, #16: 16	كَسْبِ الْحَجَّامِ
u'كَسْبٌ حَجَّام':Added, #1: 1	كَسْبَ الْحَجَّامِ
u'كَسْبٌ حُرٌّ':Added, #8: 8	كَسْبُ الْحَجَّامِ
u'كَسْبٌ حُرٌّ':Added, #1: 1	كَسْبُ الْحُرِّ
u'كَسْبٌ حُرٌّ':Added, #1: 1	كَسْبِ الْحُرِّ
u'كَسْبٌ حُرٌّ':Added, #1: 1	كَسْبَ حُرٍّ
u'كَسْبٌ حَرامٌ':Added, #2: 2	كَسْبُ حُرٍّ
u'كَسْبٌ حَلالٌ':Added, #1: 1	كَسْبٍ حَرَامٍ
u'كَسْبٌ حَلالٌ':Added, #1: 1	كَسْبِ الْحَلاَلِ
u'كَسْبٌ حَلالٌ':Added, #2: 2	كَسْبُ الْحَلَالِ
u'كَسْبٌ حَمَّامِيٌّ':Added, #2: 2	كَسْبٍ حَلَالٍ
u'كَسْبٌ حَمَّامِيٌّ':Added, #1: 1	كَسْبِ الْحَمَّامِيِّ
u'كَسْبٌ خَصِيٌّ':Added, #2: 2	كَسْبُ الْحَمَّامِيِّ
u'كَسْبٌ خَيْرٌ':Added, #2: 2	كَسْبُ الْخَصِيِّ
u'كَسْبٌ رَجُلٌ':Added, #1: 1	كَسْبِ الْخَيْرِ
u'كَسْبٌ رَجُلٌ':Added, #1: 1	كَسْبُ الرَّجُلِ
u'كَسْبٌ رِدَّةٌ':Added, #2: 2	كَسْبِ الرَّجُلِ
u'كَسْبٌ رِدَّةٌ':Added, #10: 10	كَسْبُ الرِّدَّةِ
u'كَسْبٌ رِدَّةٌ':Added, #16: 16	كَسْبِ الرِّدَّةِ
u'كَسْبٌ رِدَّةٌ':Added, #1: 1	كَسْبِ رِدَّتِهِ
u'كَسْبٌ رِدَّةٌ':Added, #2: 2	كَسْبُ رِدَّتِهِ
u'كَسْبٌ رِدَّةٌ':Added, #3: 3	كَسْبَ رِدَّتِهِ
u'كَسْبٌ رَقيقٌ':Added, #4: 4	كَسْبَ الرِّدَّةِ
u'كَسْبٌ رَقيق':Added, #1: 1	كَسْبُ رَقِيقٍ
u'كَسْبٌ رَهْنٌ':Added, #1: 1	كَسْبُ رَقِيقٍ
u'كَسَبَ رَهينٌ':Subject, #1: 1	كَسْبِ الرَّهْنِ
u'كَسَبَ زَيْدٌ':Subject, #2: 2	كَسَبَ رَهِينٌ
u'كَسْبٌ سَائِرٌ':Added, #1: 1	كَسَبَ زَيْدٌ
u'كَسْبٌ صَانِعٌ':Added, #1: 1	كَسْبُ سَائِرِ
u'كَسْبٌ صنعة':Added, #1: 1	كَسْبُ الصَّانِعِ
u'كَسْبٌ صَنْعَةٌ':Added, #1: 1	كَسْبُ صَنْعَتِهِ
u'كَسْبٌ ضَمِيرٌ':Added, #1: 1	كَسْبُ صَنْعَتِهِ
u'كَسْبٌ طَيِّبٌ':Added, #1: 1	كَسْبُ الضَّمِيرِ
u'كَسْبٌ عَامِلٌ':Added, #7: 7	كَسْبٍ طَيِّبٍ
u'كَسْبٌ عَبْدٌ':Added, #1: 1	كَسْبُ الْعَامِلِ
u'كَسْبٌ عَبْدٌ':Added, #10: 10	كَسْبُ الْعَبْدِ
u'كَسْبٌ عَبْدٌ':Added, #18: 18	كَسْبَ الْعَبْدِ
u'كَسْبٌ عَبْدٌ':Added, #1: 1	كَسْبُ عَبْدِ
u'كَسْبٌ عَبْدٌ':Added, #21: 21	كَسْبُ عَبْدِهِ
u'كَسْبٌ عَبْدٌ':Added, #26: 26	كَسْبِ الْعَبْدِ
u'كَسْبٌ عَبْدٌ':Added, #3: 3	كَسْبَ عَبْدِهِ
u'كَسْبٌ عَبْدٌ':Added, #5: 5	كَسْبُ عَبْدٍ
u'كَسْبٌ عتق':Added, #5: 5	كَسْبِ عَبْدِهِ
u'كَسْبٌ عِتْقٌ':Added, #1: 1	كَسْبِ الْعِتْقِ
u'كَسْبٌ فُلاَنٌ':Added, #1: 1	كَسْبِ الْعِتْقِ
u'كَسْبٌ فُلاَنٌ':Added, #1: 1	كَسْبُ فُلَانٍ
u'كَسْبٌ قلب':Added, #7: 7	كَسْبِ فُلَانٍ
u'كَسْبٌ قلب':Added, #1: 1	كَسْبُ الْقَلْبِ
u'كَسْبٌ قَلْبٌ':Added, #1: 1	كَسْبِ الْقَلْبِ
u'كَسْبٌ قَلْبٌ':Added, #1: 1	كَسْبُ الْقَلْبِ
u'كَسْبٌ قَلْب':Added, #1: 1	كَسْبِ الْقَلْبِ
u'كَسْبٌ قَلْب':Added, #1: 1	كَسْبُ الْقَلْبِ
u'كَسْبٌ قُوتٌ':Added, #1: 1	كَسْبِ الْقَلْبِ
u'كَسْبٌ قُوتٌ':Added, #1: 1	كَسْبِ الْقُوتِ
u'كَسْبٌ كَسْبٌ':Added, #1: 1	كَسْبِ قُوتِهِ
u'كَسْبٌ كَسْبٌ':Added, #1: 1	كَسْبُ كَسْبِ
u'كَسْبٌ كَسْبٌ':Added, #1: 1	كَسْبِ كَسْبِهِ
u'كَسْبٌ مَاءٌ':Added, #5: 5	كَسْبُ كَسْبِهِ
u'كَسْبٌ مَاشِطٌ':Added, #1: 1	كَسْبَ الْمَاءِ
u'كَسْبٌ مَاشِطٌ':Added, #1: 1	كَسْبِ الْمَاشِطَةِ
u'كَسْبٌ مَالٌ':Added, #2: 2	كَسْبُ الْمَاشِطَةِ
u'كَسْبٌ مَالٌ':Added, #1: 1	كَسْبِ الْمَالِ
u'كَسْبٌ مُبَاحٌ':Added, #2: 2	كَسْبُ الْمَالِ
u'كَسْبٌ مُبَاحٌ':Added, #1: 1	كَسْبٍ مُبَاحٍ
u'كَسَبَ مَبِيعٌ':Subject, #1: 1	كَسْبُ مُبَاحِ
u'كَسْبٌ مَبِيعٌ':Added, #1: 1	كَسَبَ الْمَبِيعُ
u'كَسْبٌ مَبِيعٌ':Added, #1: 1	كَسْبَ الْمَبِيعِ
u'كَسْبٌ مَبِيعٌ':Added, #1: 1	كَسْبِ الْمَبِيعِ
u'كَسْبٌ مثل':Added, #2: 2	كَسْبُ الْمَبِيعِ
u'كَسْبٌ مِثْلٌ':Added, #1: 1	كَسْبُ مِثْلِ
u'كَسْبٌ مَجْهُولٌ':Added, #1: 1	كَسْبُ مِثْلِ
u'كَسْبٌ مُدَبَّرٌ':Added, #1: 1	كَسْبِ مَجْهُولِ
u'كَسْبٌ مُرْتَدٌّ':Added, #1: 1	كَسْبِ الْمُدَبَّرِ
u'كَسَبَ مَعَالِي':Predicate, #1: 1	كَسْبُ مُرْتَدٍّ
u'كَسْبٌ مُعْتَقٌ':Added, #1: 1	كَسَبَ الْمَعَالِيَ
u'كَسْبٌ مَعُونَةٌ':Added, #1: 1	كَسْبِ الْمُعْتَقِ
u'كَسْبٌ مُغَنِّي':Added, #1: 1	كَسْبَ الْمَعُونَةِ
u'كَسْبٌ مُغَنِّي':Added, #1: 1	كَسْبُ الْمُغَنِّيَةِ
u'كَسَبَ مَمْلُوكٌ':Subject, #1: 1	كَسْبِ الْمُغَنِّيَةِ
u'كَسْبٌ مَمْلُوكٌ':Added, #1: 1	كَسَبَ الْمَمْلُوكُ
u'كَسْبٌ مَمْلُوكٌ':Added, #1: 1	كَسْبَ الْمَمْلُوكِ
u'كَسْبٌ مَمْلُوكٌ':Added, #1: 1	كَسْبُ الْمَمْلُوكِ
u'كَسْبٌ مَهْرٌ':Added, #1: 1	كَسْبُ مَمْلُوكِهِ
u'كَسْبٌ نَادِرٌ':Added, #1: 1	كَسْبِ مَهْرِ
u'كَسْبٌ نِصْفٌ':Added, #2: 2	كَسْبٍ نَادِرٍ
u'كَسْبٌ نَصِيبٌ':Added, #1: 1	كَسْبَ النِّصْفِ
u'كَسْبٌ نَصِيبٌ':Added, #1: 1	كَسْبُ نَصِيبِ
u'كَسْبٌ نَفَقَةٌ':Added, #1: 1	كَسْبَ نَصِيبِهِ
u'كَسْبٌ نَفَقَةٌ':Added, #1: 1	كَسْبِ النَّفَقَةِ
u'كَسْبٌ واحد':Added, #1: 1	كَسْبَ نَفَقَةِ
u'كَسْبٌ وَاحِدٌ':Added, #2: 2	كَسْبٍ وَاحِدٍ
u'كَسْبٌ وَاسِعٌ':Added, #2: 2	كَسْبٍ وَاحِدٍ
u'كَسَبَ ولد':Subject, #1: 1	كَسْبٍ وَاسِعٍ
u'كَسَبَ وَلَدٌ':Subject, #1: 1	كَسَبَ الْوَلَدُ
u'كَسْبٌ ولد':Added, #1: 1	كَسَبَ الْوَلَدُ
u'كَسْبٌ وَلَدٌ':Added, #5: 5	كَسْبِ الْوَلَدِ
u'كَسْبٌ ولد':Added, #5: 5	كَسْبِ الْوَلَدِ
u'كَسْبٌ ولد':Added, #6: 6	كَسْبَ الْوَلَدِ
u'كَسْبٌ وَلَدٌ':Added, #6: 6	كَسْبُ الْوَلَدِ
u'كَسْبٌ وَلَدٌ':Added, #6: 6	كَسْبَ الْوَلَدِ
u'كَسْبٌ وَنِيَّةٌ':Added, #6: 6	كَسْبُ الْوَلَدِ
u'كَسْبٌ يَدٌ':Added, #1: 1	كَسْبٍ وَنِيَّةٍ
u'كَسْبٌ يَدٌ':Added, #1: 1	كَسْبِ الْيَدِ
u'كَسْبٌ يَدٌ':Added, #1: 1	كَسْبُ يَدِهِ
u'كَسَدَ بَطَلٌ':Predicate, #3: 3	كَسْبِ يَدِهِ
u'كَسَدَ سُوقٌ':Subject, #1: 1	كَسَدَ بَطَلَ
u'كَسَدَ شَيْءٌ':Subject, #1: 1	كَسَدَ السُّوقُ
u'كَسَرَ إِبْرِيقٌ':Predicate, #1: 1	كَسَدَ الشَّيْءُ
u'كَسَرَ أَحْناءٌ':Predicate, #1: 1	كَسَرَ إبْرِيقَ
u'كَسَرَ أحْنَاءٌ':Predicate, #1: 1	كَسَرَ أَحْنَاءَ
u'كَسْرٌ أَشْيَاءٌ':Added, #1: 1	كَسَرَ أَحْنَاءَ
u'كَسْرٌ أَصْنَامٌ':Added, #1: 1	كَسْرِ الْأَشْيَاءِ
u'كَسْرٌ أَصْنَامٌ':Added, #1: 1	كَسْرَ الْأَصْنَامِ
u'كَسَرَ أَغْصَانٌ':Predicate, #2: 2	كَسْرُ الْأَصْنَامِ
u'كَسْرٌ أَغْصَانٌ':Added, #1: 1	كَسَرَ الْأَغْصَانَ
u'كَسْرٌ آلةٌ':Added, #1: 1	كَسْرَ أَغْصَانِ
u'كَسْرٌ آلِهَةٌ':Added, #1: 1	كَسْرُ آلَةِ
u'كَسَرَ إِناءٌ':Predicate, #1: 1	كَسْرِ الْآلِهَةِ
u'كَسَرَ إِناءٌ':Predicate, #1: 1	كَسَرَ الْإِنَاءَ
u'كَسَرَ أَنْفٌ':Predicate, #3: 3	كَسَرَ إنَاءَ
u'كَسْرٌ آنِيَةٌ':Added, #1: 1	كَسَرَ أَنْفَ
u'كَسْرٌ آنِيَةٌ':Added, #1: 1	كَسْرِ آنِيَةِ
u'كَسَرَ أوانِي':Predicate, #2: 2	كَسْرُ آنِيَةِ
u'كَسْرٌ أَوَّلُ':Added, #1: 1	كَسَرَ أَوَانِيَ
u'كَسْرٌ باء':Added, #1: 1	كَسْرِ أَوَّلِهِ
u'كَسْرٌ باء':Added, #1: 1	كَسْرَ الْبَاءِ
u'كَسَرَ بَابٌ':Predicate, #1: 1	كَسْرُ الْبَاءِ
u'كَسْرٌ بَابٌ':Added, #1: 1	كَسَرَ الْبَابَ
u'كَسَرَ بَعْضٌ':Predicate, #1: 1	كَسْرُ الْبَابِ
u'كَسَرَ بَعْضٌ':Predicate, #1: 1	كَسَرَ الْبَعْضَ
u'كَسَرَ بيض':Predicate, #6: 6	كَسَرَ بَعْضَ
u'كَسْرٌ بيض':Added, #9: 9	كَسَرَ بَيْضَ
u'كَسْرٌ بيض':Added, #1: 1	كَسْرِ الْبَيْضِ
u'كَسْرٌ بيض':Added, #1: 1	كَسْرُ بَيْضِهِ
u'كَسَرَ بَيْضَةٌ':Predicate, #1: 1	كَسْرِ بَيْضِهِ
u'كَسْرٌ بَيْضَةٌ':Added, #2: 2	كَسَرَ بَيْضَةَ
u'كسرة بَيْضَةٌ':Added, #1: 1	كَسْرَ الْبَيْضَةِ
u'كَسْرَةٌ بَيْضَةٌ':Added, #1: 1	كَسْرَةِ الْبَيْضَةِ
u'كسرة ذال':Added, #1: 1	كَسْرَةِ الْبَيْضَةِ
u'كَسْرَةٌ ذال':Added, #1: 1	كَسْرَةُ الذَّالِ
u'كسرة عين':Added, #1: 1	كَسْرَةُ الذَّالِ
u'كسرة عَيْنٌ':Added, #1: 1	كَسْرَةُ الْعَيْنِ
u'كسرة عَيْن':Added, #1: 1	كَسْرَةُ الْعَيْنِ
u'كَسْرَةٌ عين':Added, #1: 1	كَسْرَةُ الْعَيْنِ
u'كَسْرَةٌ عَيْنٌ':Added, #1: 1	كَسْرَةُ الْعَيْنِ
u'كَسْرَةٌ عَيْن':Added, #1: 1	كَسْرَةُ الْعَيْنِ
u'كسرة هاء':Added, #1: 1	كَسْرَةُ الْعَيْنِ
u'كَسْرَةٌ هاء':Added, #1: 1	كَسْرَةُ الْهَاءِ
u'كَسَرَ تاء':Predicate, #1: 1	كَسْرَةُ الْهَاءِ
u'كَسْرٌ تاء':Added, #5: 5	كَسَرَ التَّاءَ
u'كَسْرٌ تَرْقُوَةٌ':Added, #1: 1	كَسْرِ التَّاءِ
u'كَسْرٌ ثَوْرٌ':Added, #1: 1	كَسْرِ التَّرْقُوَةِ
u'كَسَرَ جَرَّةٌ':Predicate, #1: 1	كَسْرِ الثَّوْرِ
u'كَسَرَ جَفْنٌ':Predicate, #1: 1	كَسَرَ جَرَّةَ
u'كَسْرٌ جناح':Added, #1: 1	كَسَرَ جَفْنَ
u'كَسْرٌ جَنَاحٌ':Added, #1: 1	كَسْرَ جَنَاحٍ
u'كَسْرٌ جَوْزٌ':Added, #1: 1	كَسْرَ جَنَاحٍ
u'كَسْرٌ حاء':Added, #1: 1	كَسْرِ الْجَوْزِ
u'كَسْرٌ حاء':Added, #1: 1	كَسْرَ الْحَاءِ
u'كَسْرٌ حِدَّةٌ':Added, #2: 2	كَسْرِ الْحَاءِ
u'كَسْرٌ حَطَبٌ':Added, #1: 1	كَسْرِ حِدَّةِ
u'كَسْرٌ حَطَبٌ':Added, #1: 1	كَسْرُ الْحَطَبِ
u'كَسْرٌ حَطَبٌ':Added, #1: 1	كَسْرِ حَطَبٍ
u'كَسَرَ حَلْقَةٌ':Predicate, #3: 3	كَسْرِ الْحَطَبِ
u'كَسَرَ حُلِيٌّ':Predicate, #1: 1	كَسَرَ حَلْقَةَ
u'كَسْرٌ حُلِيٌّ':Added, #1: 1	كَسَرَ الْحُلِيَّ
u'كَسْرٌ حُلِيٌّ':Added, #1: 1	كَسْرُ الْحُلِيِّ
u'كَسْرٌ خاء':Added, #1: 1	كَسْرُ حُلِيِّ
u'كَسْرٌ خَاطِرٌ':Added, #1: 1	كَسْرِ الْخَاءِ
u'كَسْرٌ خَاطِرٌ':Added, #1: 1	كَسْرِ الْخَاطِرِ
u'كَسَرَ خَتْمٌ':Predicate, #1: 1	كَسْرِ خَاطِرِ
u'كَسْرٌ خَتْمٌ':Added, #2: 2	كَسَرَ خَتْمَ
u'كَسْرٌ دَالٌ':Added, #1: 1	كَسْرِ الْخَتْمِ
u'كَسَرَ دَرَاهِمُ':Predicate, #2: 2	كَسْرُ الدَّالِ
u'كَسْرٌ دَرَاهِمُ':Added, #1: 1	كَسَرَ دَرَاهِمَ
u'كَسْرٌ دَرَاهِمُ':Added, #1: 1	كَسْرِ الدَّرَاهِمِ
u'كَسْرٌ دِرْهَمٌ':Added, #2: 2	كَسْرُ الدَّرَاهِمِ
u'كَسْرٌ دِرْهَم':Added, #1: 1	كَسْرُ الدِّرْهَمِ
u'كَسْرٌ دُفٌّ':Added, #1: 1	كَسْرُ الدِّرْهَمِ
u'كَسْرٌ ذِراعٌ':Added, #1: 1	كَسْرِ الدُّفِّ
u'كَسْرٌ ذِراعٌ':Added, #1: 1	كَسْرِ الذِّرَاعِ
u'كَسْرٌ ذَهَبٌ':Added, #1: 1	كَسْرُ ذِرَاعِ
u'كَسْرٌ راء':Added, #1: 1	كَسْرُ الذّهَبِ
u'كَسْرٌ راء':Added, #1: 1	كَسْرُ الرَّاءِ
u'كَسْرٌ راء':Added, #1: 1	كَسْرِ الرَّاءِ
u'كَسَرَ رَجُلٌ':Subject, #2: 2	كَسْرِ الرّاءِ
u'كَسْرٌ رُطَبٌ':Added, #1: 1	كَسَرَ رَجُلٌ
u'كَسَرَ رَغيفٌ':Predicate, #1: 1	كَسْرُ الرّطَبِ
u'كَسْرٌ زاي':Added, #1: 1	كَسَرَ رَغِيفَ
u'كَسَرَ سَاقٌ':Predicate, #1: 1	كَسْرِ الزَّايِ
u'كَسْرٌ سَاقٌ':Added, #1: 1	كَسَرَ سَاقَ
u'كَسْرٌ سَفِينَةٌ':Added, #1: 1	كَسْرِ السَّاقِ
u'كَسْرٌ سِكَّةٌ':Added, #1: 1	كَسْرِ السَّفِينَةِ
u'كَسْرٌ سِكَّةٌ':Added, #1: 1	كَسْرِ السِّكَّةِ
u'كَسَرَ سِنٌّ':Predicate, #3: 3	كَسْرِ سِكَّةِ
u'كَسَرَ سَيْفٌ':Predicate, #3: 3	كَسَرَ سِنَّ
u'كَسَرَ سَيْفٌ':Predicate, #1: 1	كَسَرَ السَّيْفَ
u'كَسْرٌ سِين':Added, #1: 1	كَسَرَ سَيْفَ
u'كَسَرَ شافِعِيّ':Subject, #1: 1	كَسْرُ السِّينِ
u'كَسْرٌ شَهْوَةٌ':Added, #1: 1	كَسَرَ الشَّافِعِيُّ
u'كَسْرٌ شَوْكَةٌ':Added, #3: 3	كَسْرُ الشَّهْوَةِ
u'كَسْرٌ شَوْكَةٌ':Added, #1: 1	كَسْرُ شَوْكَةِ
u'كَسَرَ صَاحِبٌ':Subject, #3: 3	كَسْرِ شَوْكَةِ
u'كَسْرٌ صَدَفٌ':Added, #1: 1	كَسَرَ صَاحِبُ
u'كَسْرٌ صِفَةٌ':Added, #1: 1	كَسْرُ الصَّدَفِ
u'كَسْرٌ صِفَةٌ':Added, #1: 1	كَسْرَ صِفَةِ
u'كَسْرٌ صلْبٌ':Added, #1: 1	كَسْرَ صِفَتِهِ
u'كَسْرٌ صلْبٌ':Added, #1: 1	كَسْرَ الصُّلْبِ
u'كَسْرٌ صلْبٌ':Added, #1: 1	كَسْرُ الصُّلْبِ
u'كَسَرَ صُورَةٌ':Predicate, #4: 4	كَسْرِ الصُّلْبِ
u'كَسْرٌ ضِفَّةٌ':Added, #1: 1	كَسَرَ الصُّورَةَ
u'كَسْرٌ ضِفَّةٌ':Added, #1: 1	كَسْرَ ضِفَّةِ
u'كَسْرٌ ضلع':Added, #1: 1	كَسْرِ ضِفَّتِهِ
u'كَسْرٌ ضِلْعٌ':Added, #1: 1	كَسْرُ الضِّلْعِ
u'كَسْرٌ ضِلْعٌ':Added, #1: 1	كَسْرُ الضِّلْعِ
u'كَسَرَ طَائِرٌ':Subject, #1: 1	كَسْرِ ضِلْعٍ
u'كَسْرٌ عظام':Added, #1: 1	كَسَرَ الطَّائِرُ
u'كَسْرٌ عظام':Added, #1: 1	كَسْرُ الْعِظَامِ
u'كَسْرٌ عِظَامٌ':Added, #1: 1	كَسْرِ الْعِظَامِ
u'كَسْرٌ عِظَامٌ':Added, #1: 1	كَسْرُ الْعِظَامِ
u'كَسْرٌ عظام':Added, #1: 1	كَسْرِ الْعِظَامِ
u'كَسْرٌ عِظَامٌ':Added, #2: 2	كَسْرُ عِظَامِ
u'كَسَرَ عَظْمٌ':Predicate, #2: 2	كَسْرُ عِظَامِ
u'كَسْرٌ عَظْمٌ':Added, #2: 2	كَسَرَ عَظْمَ
u'كَسْرٌ عَظْمٌ':Added, #1: 1	كَسْرَ عَظْمِ
u'كَسْرٌ عَظْمٌ':Added, #1: 1	كَسْرُ عَظْمٍ
u'كَسْرٌ عَظْمٌ':Added, #1: 1	كَسْرِ عَظْمِهِ
u'كَسْرٌ عَظْمٌ':Added, #2: 2	كَسْرَ الْعَظْمِ
u'كَسْرٌ عَظْمٌ':Added, #4: 4	كَسْرُ الْعَظْمِ
u'كَسْرٌ عَظْمٌ':Added, #5: 5	كَسْرِ الْعَظْمِ
u'كَسَرَ عُمَرٌ':Subject, #8: 8	كَسْرُ عَظْمِ
u'كَسْرٌ عنق':Added, #1: 1	كَسَرَ عُمَرُ
u'كَسْرٌ عُنُقٌ':Added, #1: 1	كَسْرُ الْعُنُقِ
u'كَسْرٌ عين':Added, #1: 1	كَسْرُ الْعُنُقِ
u'كَسْرٌ عَيْنٌ':Added, #1: 1	كَسْرِ الْعَيْنِ
u'كَسْرٌ عَيْن':Added, #1: 1	كَسْرِ الْعَيْنِ
u'كَسَرَ فَخْذٌ':Predicate, #1: 1	كَسْرِ الْعَيْنِ
u'كَسْرٌ فَخْذٌ':Added, #1: 1	كَسَرَ فَخْذَ
u'كَسَرَ فلان':Subject, #1: 1	كَسْرِ فَخْذٍ
u'كَسَرَ قَافٌ':Predicate, #1: 1	كَسَرَ الشَّافِعِيُّ
u'كَسْرٌ قَافٌ':Added, #2: 2	كَسَرَ الْقَافَ
u'كَسْرٌ قَرْنٌ':Added, #1: 1	كَسْرِ الْقَافِ
u'كَسْرٌ قسمة':Added, #1: 1	كَسْرُ الْقَرْنِ
u'كَسْرٌ قِسْمَةٌ':Added, #1: 1	كَسْرِ قِسْمَتِهِ
u'كَسَرَ قلب':Predicate, #1: 1	كَسْرِ قِسْمَتِهِ
u'كَسَرَ قَلْبٌ':Predicate, #1: 1	كَسَرَ قَلْبَ
u'كَسَرَ قَلْب':Predicate, #1: 1	كَسَرَ قَلْبَ
u'كَسْرٌ قلب':Added, #1: 1	كَسَرَ قَلْبَ
u'كَسْرٌ قَلْبٌ':Added, #2: 2	كَسْرَ قَلْبِ
u'كَسْرٌ قَلْب':Added, #2: 2	كَسْرَ قَلْبِ
u'كَسْرٌ قلب':Added, #2: 2	كَسْرَ قَلْبِ
u'كَسْرٌ قَلْبٌ':Added, #3: 3	كَسْرِ قَلْبِ
u'كَسْرٌ قَلْب':Added, #3: 3	كَسْرِ قَلْبِ
u'كَسْرٌ قُلُوبٌ':Added, #3: 3	كَسْرِ قَلْبِ
u'كَسْرٌ قُلُوبٌ':Added, #2: 2	كَسْرُ قُلُوبِ
u'كَسْرٌ قَوْسٌ':Added, #2: 2	كَسْرِ قُلُوبِ
u'كَسْرٌ قَوْسٌ':Added, #1: 1	كَسْرُ قَوْسٍ
u'كَسَرَ لاَمٌ':Predicate, #1: 1	كَسْرِ قَوْسٍ
u'كَسْرٌ لاَمٌ':Added, #2: 2	كَسَرَ اللَّامَ
u'كَسْرٌ لاَمٌ':Added, #1: 1	كَسْرَ اللَّامِ
u'كَسْرٌ لَوْزَةٌ':Added, #2: 2	كَسْرِ اللَّامِ
u'كَسَرَ مُحْرِمٌ':Subject, #1: 1	كَسْرَ لَوْزَةٍ
u'كَسَرَ مُحْرِمٌ':Subject, #2: 2	كَسَرَ الْمُحْرِمُ
u'كَسْرٌ مَعَازِفُ':Added, #2: 2	كَسَرَ مُحْرِمٌ
u'كَسْرٌ مُعْتَادٌ':Added, #3: 3	كَسْرِ الْمَعَازِفِ
u'كَسَرَ مِيمٌ':Predicate, #1: 1	كَسْرِ الْمُعْتَادِ
u'كَسْرٌ مِيمٌ':Added, #1: 1	كَسَرَ الْمِيمَ
u'كَسْرٌ مِيمٌ':Added, #1: 1	كَسْرَ الْمِيمِ
u'كَسْرٌ مِيمٌ':Added, #1: 1	كَسْرُ الْمِيمِ
u'كَسْرٌ نَحْوٌ':Added, #1: 1	كَسْرِ الْمِيمِ
u'كَسَرَ نِصْفٌ':Predicate, #1: 1	كَسْرَ نَحْوِ
u'كَسْرٌ نَفْسٌ':Added, #3: 3	كَسَرَ نِصْفَ
u'كَسْرٌ نَفْسٌ':Added, #1: 1	كَسْرِ نَفْسٍ
u'كَسْرٌ هاء':Added, #2: 2	كَسْرِ النَّفْسِ
u'كَسْرٌ هاء':Added, #1: 1	كَسْرُ الْهَاءِ
u'كَسَرَ همزة':Predicate, #1: 1	كَسْرِ الْهَاءِ
u'كَسَرَ هَمْزَةٌ':Predicate, #1: 1	كَسَرَ الْهَمْزَةَ
u'كَسْرٌ همزة':Added, #1: 1	كَسَرَ الْهَمْزَةَ
u'كَسْرٌ هَمْزَةٌ':Added, #1: 1	كَسْرُ هَمْزَةِ
u'كَسْرٌ همزة':Added, #1: 1	كَسْرُ هَمْزَةِ
u'كَسْرٌ همزة':Added, #2: 2	كَسْرُ الْهَمْزَةِ
u'كَسْرٌ هَمْزَةٌ':Added, #2: 2	كَسْرِ الْهَمْزَةِ
u'كَسْرٌ هَمْزَةٌ':Added, #2: 2	كَسْرُ الْهَمْزَةِ
u'كَسْرٌ يَابِسٌ':Added, #2: 2	كَسْرِ الْهَمْزَةِ
u'كَسَرَ يَدٌ':Predicate, #1: 1	كَسْرُ الْيَابِسِ
u'كَسْرٌ يَدٌ':Added, #2: 2	كَسَرَ يَدَ
u'كَسْرٌ يَمِينٌ':Added, #1: 1	كَسْرِ الْيَدِ
u'كَسَفَ شمس':Subject, #1: 1	كَسْرُ الْيَمِينِ
u'كَسَفَ شَمْسٌ':Subject, #1: 1	كَسَفَ الشَّمْسُ
u'كَسَفَ واحد':Subject, #1: 1	كَسَفَ الشَّمْسُ
u'كَسَفَ وَاحِدٌ':Subject, #2: 2	كَسَفَ وَاحِدٌ
u'كُسُوفٌ بالٌ':Added, #2: 2	كَسَفَ وَاحِدٌ
u'كُسُوفٌ بَالٌ':Added, #1: 1	كُسُوفَ الْبَالِ
u'كُسُوفٌ شمس':Added, #1: 1	كُسُوفَ الْبَالِ
u'كُسُوفٌ شَمْسٌ':Added, #2: 2	كُسُوفَ الشَّمْسِ
u'كُسُوفٌ شمس':Added, #2: 2	كُسُوفَ الشَّمْسِ
u'كُسُوفٌ شَمْسٌ':Added, #44: 44	كُسُوفِ الشَّمْسِ
u'كُسُوفٌ شمس':Added, #44: 44	كُسُوفِ الشَّمْسِ
u'كُسُوفٌ شَمْسٌ':Added, #4: 4	كُسُوفُ الشَّمْسِ
u'كُسُوفٌ قمر':Added, #4: 4	كُسُوفُ الشَّمْسِ
u'كُسُوفٌ قمر':Added, #1: 1	كُسُوفَ الْقَمَرِ
u'كُسُوفٌ قَمَرٌ':Added, #1: 1	كُسُوفُ الْقَمَرِ
u'كُسُوفٌ قَمَرٌ':Added, #1: 1	كُسُوفَ الْقَمَرِ
u'كُسُوفٌ قَمَرٌ':Added, #1: 1	كُسُوفُ الْقَمَرِ
u'كُسُوفٌ قمر':Added, #1: 1	كُسُوفِ الْقَمَرَيْنِ
u'كُسُوفٌ قَمَرٌ':Added, #4: 4	كُسُوفِ الْقَمَرِ
u'كُسُوفٌ نَيِّرٌ':Added, #4: 4	كُسُوفِ الْقَمَرِ
u'كُسُوفٌ هِدَايَةٌ':Added, #2: 2	كُسُوفِ النَّيِّرَيْنِ
u'كَشَحَ قَوْمٌ':Subject, #1: 1	كُسُوفِ الْهِدَايَةِ
u'كَشَطَ جِلْدَةٌ':Predicate, #2: 2	كَشَحَ الْقَوْمُ
u'كَشَطَ لَفْظَةٌ':Predicate, #1: 1	كَشَطَ جِلْدَةَ
u'كَشَفَ إِثْرَاءٌ':Subject, #1: 1	كَشَطَ لَفْظَةَ
u'كَشْفٌ آدَمِيٌّ':Added, #1: 1	كَشَفَ الْإِثْرَاءُ
u'كَشْفٌ أَسْتَارٌ':Added, #1: 1	كَشْفِ الْآدَمِيِّ
u'كَشْفٌ أسْرَارٌ':Added, #2: 2	كَشْفُ الْأَسْتَارِ
u'كَشْفٌ أَسْرَارٌ':Added, #1: 1	كَشْفِ أَسْرَارِ
u'كَشْفٌ أسْرَارٌ':Added, #1: 1	كَشْفِ أَسْرَارِ
u'كَشْفٌ أَسْرَارٌ':Added, #26: 26	كَشْفِ الْأَسْرَارِ
u'كَشْفٌ أُمُورٌ':Added, #26: 26	كَشْفِ الْأَسْرَارِ
u'كَشْفٌ بَاطن':Added, #1: 1	كَشْفِ الْأُمُورِ
u'كَشْفٌ باطِنٌ':Added, #2: 2	كَشْفُ بَاطِنِ
u'كَشْفٌ بدن':Added, #2: 2	كَشْفُ بَاطِنِ
u'كَشْفٌ بَدَنٌ':Added, #1: 1	كَشْفِ الْبَدَنِ
u'كَشْفٌ بَعْضٌ':Added, #1: 1	كَشْفِ الْبَدَنِ
u'كَشْفٌ بَلاءٌ':Added, #1: 1	كَشْفَ الْبَعْضِ
u'كَشْفٌ بَيْتٌ':Added, #1: 1	كَشْفَ الْبَلَاءِ
u'كَشَفَ ثَوْبٌ':Predicate, #1: 1	كَشْفُ الْبَيْتِ
u'كَشْفٌ جَبْهَةٌ':Added, #1: 1	كَشَفَ الثّوْبَ
u'كَشْفٌ جَبْهَةٌ':Added, #1: 1	كَشْفُ الْجَبْهَةِ
u'كَشْفٌ جَمِيع':Added, #1: 1	كَشْفِ الْجَبْهَةِ
u'كَشْفٌ حالٌ':Added, #1: 1	كَشْفِ الْجَمِيعِ
u'كَشْفٌ حَقٌّ':Added, #5: 5	كَشْفِ الْحَالِ
u'كَشْفٌ حقائق':Added, #1: 1	كَشْفِ الْحَقِّ
u'كَشْفٌ حَقَائِقُ':Added, #1: 1	كَشْفِ الْحَقَائِقِ
u'كَشَفَ خَلِيفَةٌ':Subject, #1: 1	كَشْفِ الْحَقَائِقِ
u'كَشَفَ خِمَارٌ':Predicate, #1: 1	كَشَفَ الْخَلِيفَةُ
u'كَشَفَ خُمُرٌ':Predicate, #2: 2	كَشَفَ خِمَارَ
u'كَشْفٌ ذِراعٌ':Added, #1: 1	كَشَفَ خُمُرَ
u'كَشْفٌ ذَيْلٌ':Added, #1: 1	كَشْفَ الذِّرَاعَيْنِ
u'كَشْفٌ رَأْسٌ':Added, #1: 1	كَشْفُ ذَيْلِ
u'كَشْفٌ رَأْسٌ':Added, #1: 1	كَشْفَ الرَّأْسِ
u'كَشْفٌ رَأْسٌ':Added, #1: 1	كَشْفُ الرَّأْسِ
u'كَشْفٌ رَأْسٌ':Added, #1: 1	كَشْفِ رَأْسِهِ
u'كَشْفٌ رَأْسٌ':Added, #3: 3	كَشْفِ الرَّأْسِ
u'كَشْفٌ رُبْعٌ':Added, #3: 3	كَشْفُ رَأْسِهِ
u'كَشَفَ رَجُلٌ':Subject, #2: 2	كَشْفُ رُبْعِ
u'كَشَفَ رِدَاءٌ':Predicate, #1: 1	كَشَفَ رَجُلٌ
u'كَشَفَ رَسُولٌ':Subject, #1: 1	كَشَفَ الرِّدَاءَ
u'كَشْفٌ ركبة':Added, #3: 3	كَشَفَ رَسُولُ
u'كَشْفٌ رُكْبَةٌ':Added, #1: 1	كَشْفِ الرُّكْبَةِ
u'كَشْفٌ ريحٌ':Added, #1: 1	كَشْفِ الرُّكْبَةِ
u'كَشَفَ زِقٌّ':Predicate, #1: 1	كَشْفِ الرِّيحِ
u'كَشْفٌ سَبَبٌ':Added, #2: 2	كَشَفَ الزِّقَّ
u'كَشَفَ سِتْرٌ':Predicate, #1: 1	كَشْفِ السَّبَبِ
u'كَشْفٌ سِتْرٌ':Added, #3: 3	كَشَفَ سِتْرَ
u'كَشْفٌ سِرٌّ':Added, #1: 1	كَشْفِ سِتْرِ
u'كَشْفٌ سَوادٌ':Added, #1: 1	كَشْفِ السِّرِّ
u'كَشْفٌ شَيْءٌ':Added, #1: 1	كَشْفِ السَّوَادِ
u'كَشْفٌ عَاقِبٌ':Added, #1: 1	كَشْفُ شَيْءٍ
u'كَشْفٌ عَاقِبَةٌ':Added, #1: 1	كَشْفِ الْعَاقِبَةِ
u'كَشْفٌ عِبَارَةٌ':Added, #1: 1	كَشْفِ الْعَاقِبَةِ
u'كَشَفَ عَبْدٌ':Predicate, #1: 1	كَشْفِ عِبَارَةِ
u'كَشَفَ عَظْمٌ':Predicate, #1: 1	كَشَفَ الْعَبْدَ
u'كَشْفٌ عُلُومٌ':Added, #1: 1	كَشَفَ عَظْمَ
u'كَشَفَ عُمَرٌ':Subject, #1: 1	كَشْفِ عُلُومِ
u'كَشَفَ عَوْرَةٌ':Predicate, #1: 1	كَشَفَ عُمَرُ
u'كَشَفَ عَوْرَةٌ':Predicate, #3: 3	كَشَفَ الْعَوْرَةَ
u'كَشْفٌ عَوْرَةٌ':Added, #3: 3	كَشَفَ عَوْرَةَ
u'كَشْفٌ عَوْرَةٌ':Added, #12: 12	كَشْفَ الْعَوْرَةِ
u'كَشْفٌ عَوْرَةٌ':Added, #19: 19	كَشْفُ الْعَوْرَةِ
u'كَشْفٌ عَوْرَةٌ':Added, #1: 1	كَشْفَ عَوْرَتِهِ
u'كَشْفٌ عَوْرَةٌ':Added, #25: 25	كَشْفِ الْعَوْرَةِ
u'كَشْفٌ عَوْرَةٌ':Added, #2: 2	كَشْفَ الْعَوْرَاتِ
u'كَشْفٌ عَوْرَةٌ':Added, #2: 2	كَشْفِ الْعَوْرَاتِ
u'كَشْفٌ عَوْرَةٌ':Added, #3: 3	كَشْفِ عَوْرَةٍ
u'كَشْفٌ عَوْرَةٌ':Added, #3: 3	كَشْفُ عَوْرَتِهِ
u'كَشَفَ غِطَاءٌ':Predicate, #3: 3	كَشْفِ عَوْرَتِهِ
u'كَشْفٌ غِطَاءٌ':Added, #2: 2	كَشَفَ الْغِطَاءَ
u'كَشْفٌ غِطَاءٌ':Added, #1: 1	كَشْفِ الْغِطَاءِ
u'كَشْفٌ غُمَّةٌ':Added, #2: 2	كَشْفُ الْغِطَاءِ
u'كَشْفٌ غَوَامِضُ':Added, #1: 1	كَشْفُ الْغُمَّةِ
u'كَشَفَ غيب':Subject, #8: 8	كَشْفِ الْغَوَامِضِ
u'كَشَفَ غَيْبٌ':Subject, #1: 1	كَشَفَ الْغَيْبُ
u'كَشْفٌ قدم':Added, #1: 1	كَشَفَ الْغَيْبُ
u'كَشْفٌ قَدَمٌ':Added, #1: 1	كَشْفِ الْقَدَمِ
u'كَشَفَ قَمِيصٌ':Predicate, #1: 1	كَشْفِ الْقَدَمِ
u'كَشَفَ قناع':Predicate, #1: 1	كَشَفَ الْقَمِيصَ
u'كَشَفَ قِنَاعٌ':Predicate, #2: 2	كَشَفَ قِنَاعَ
u'كَشْفٌ قناع':Added, #2: 2	كَشَفَ قِنَاعَ
u'كَشْفٌ قِنَاعٌ':Added, #1: 1	كَشْفِ الْقِنَاعِ
u'كَشْفٌ قناع':Added, #1: 1	كَشْفِ الْقِنَاعِ
u'كَشْفٌ قِنَاعٌ':Added, #1: 1	كَشْفُ قِنَاعِ
u'كَشْفٌ قول':Added, #1: 1	كَشْفُ قِنَاعِ
u'كَشْفٌ قَوْلٌ':Added, #1: 1	كَشْفَ الْقَوْلِ
u'كَشْفٌ كَثِيرٌ':Added, #1: 1	كَشْفَ الْقَوْلِ
u'كَشْفٌ كُرْبَةٌ':Added, #1: 1	كَشْفُ الْكَثِيرِ
u'كَشْفٌ كَفٌّ':Added, #1: 1	كَشْفِ كُرْبَةٍ
u'كَشْفٌ مراد':Added, #1: 1	كَشْفُ الْكَفَّيْنِ
u'كَشْفٌ مُرَادٌ':Added, #1: 1	كَشْفِ مُرَادِهِ
u'كَشْفٌ مُشْكِلٌ':Added, #1: 1	كَشْفِ مُرَادِهِ
u'كَشْفٌ مُعْضِلٌ':Added, #17: 17	كَشْفِ الْمُشْكِلِ
u'كَشْفٌ مُعْضِلَةٌ':Added, #1: 1	كَشْفِ الْمُعْضِلَاتِ
u'كَشْفٌ مَنَارٌ':Added, #1: 1	كَشْفِ الْمُعْضِلَاتِ
u'كَشْفٌ مَنْقُولٌ':Added, #2: 2	كَشْفِ الْمَنَارِ
u'كَشْفٌ مَنْكِبٌ':Added, #1: 1	كَشْفُ الْمَنْقُولِ
u'كَشَفَ نَبِيٌّ':Subject, #1: 1	كَشْفِ الْمَنْكِبَيْنِ
u'كَشْفٌ نُقُولٌ':Added, #1: 1	كَشَفَ النَّبِيُّ
u'كَشْفٌ وَجْهٌ':Added, #1: 1	كَشْفُ النُّقُولِ
u'كَشْفٌ وَجْهٌ':Added, #3: 3	كَشْفِ الْوَجْهِ
u'كَشْفٌ يَسِيرٌ':Added, #5: 5	كَشْفُ الْوَجْهِ
u'كَشْفٌ يَسِيرٌ':Added, #1: 1	كَشْفِ الْيَسِيرِ
u'كَعَبَ ثَدْيٌ':Subject, #1: 1	كَشْفٍ يَسِيرٍ
u'كفاء نعمة':Added, #1: 1	كَعَبَ ثَدْيُ
u'كِفَاءٌ نعمة':Added, #2: 2	كِفَاءُ نِعْمَةِ
u'كفاء نِعْمَةٌ':Added, #2: 2	كِفَاءُ نِعْمَةِ
u'كِفَاءٌ نِعْمَةٌ':Added, #2: 2	كِفَاءُ نِعْمَةِ
u'كَفَالَةٌ أَبٌ':Added, #2: 2	كِفَاءُ نِعْمَةِ
u'كَفَالَةٌ أحَدٌ':Added, #2: 2	كَفَالَةِ الْأَبِ
u'كَفَالَةٌ أحَدٌ':Added, #1: 1	كَفَالَةَ أَحَدِ
u'كَفَالَةٌ أخرَس':Added, #1: 1	كَفَالَةُ أَحَدٍ
u'كَفَالَةٌ اِشْتِراكٌ':Added, #1: 1	كَفَالَةُ الْأَخْرَسِ
u'كَفَالَةٌ أصل':Added, #1: 1	كَفَالَةَ اشْتِرَاكٍ
u'كَفَالَةٌ أًصْلٌ':Added, #5: 5	كَفَالَةِ الْأَصْلِ
u'كَفَالَةٌ أَطْفَالٌ':Added, #5: 5	كَفَالَةِ الْأَصْلِ
u'كَفَالَةٌ إِنْسانٌ':Added, #1: 1	كَفَالَةِ الْأَطْفَالِ
u'كَفَالَةٌ اِنْفِرادٌ':Added, #1: 1	كَفَالَةُ إنْسَانٍ
u'كَفَالَةٌ بدن':Added, #2: 2	كَفَالَةَ انْفِرَادٍ
u'كَفَالَةٌ بَدَنٌ':Added, #2: 2	كَفَالَةِ الْبَدَنِ
u'كَفَالَةٌ جَارِي':Added, #2: 2	كَفَالَةِ الْبَدَنِ
u'كَفَالَةٌ جَارِيَةٌ':Added, #1: 1	كَفَالَةِ الْجَارِيَةِ
u'كَفَالَةٌ حُرٌّ':Added, #1: 1	كَفَالَةِ الْجَارِيَةِ
u'كَفَالَةٌ حُرٌّ':Added, #1: 1	كَفَالَةُ الْحُرِّ
u'كَفَالَةٌ خان':Added, #1: 1	كَفَالَةُ الْحُرَّةِ
u'كَفَالَةٌ خانَة':Added, #4: 4	كَفَالَةِ الْخَانِيَّةِ
u'كَفَالَةٌ دَرَكٌ':Added, #4: 4	كَفَالَةِ الْخَانِيَّةِ
u'كَفَالَةٌ رَجُلٌ':Added, #1: 1	كَفَالَةُ الدَّرَكِ
u'كَفَالَةٌ رَجُلٌ':Added, #1: 1	كَفَالَةُ الرَّجُلَيْنِ
u'كَفَالَةٌ رَجُلٌ':Added, #1: 1	كَفَالَةِ رَجُلٍ
u'كَفَالَةٌ رَجُلٌ':Added, #2: 2	كَفَالَةَ رَجُلٍ
u'كَفَالَةٌ زَيْدٌ':Added, #7: 7	كَفَالَةِ الرَّجُلَيْنِ
u'كَفَالَةٌ سَابِقٌ':Added, #1: 1	كَفَالَةُ زَيْدٍ
u'كَفَالَةٌ سَيِّدٌ':Added, #1: 1	كَفَالَةٍ سَابِقَةٍ
u'كَفَالَةٌ شَرِيكٌ':Added, #1: 1	كَفَالَةَ السَّيِّدِ
u'كَفَالَةٌ صَبِيٌّ':Added, #1: 1	كَفَالَةُ الشَّرِيكِ
u'كَفَالَةٌ صَبِيٌّ':Added, #1: 1	كَفَالَةِ الصَّبِيِّ
u'كَفَالَةٌ عَبْدٌ':Added, #2: 2	كَفَالَةُ الصَّبِيِّ
u'كَفَالَةٌ عَبْدٌ':Added, #1: 1	كَفَالَةَ الْعَبْدِ
u'كَفَالَةٌ عَبْدٌ':Added, #4: 4	كَفَالَةِ الْعَبْدِ
u'كَفَالَةٌ عِصَامٌ':Added, #5: 5	كَفَالَةُ الْعَبْدِ
u'كَفَالَةٌ عَمٌّ':Added, #1: 1	كَفَالَةِ عِصَامٍ
u'كَفَالَةٌ عين':Added, #1: 1	كَفَالَةِ عَمّهِ
u'كَفَالَةٌ عَيْنٌ':Added, #1: 1	كَفَالَةِ الْعَيْنِ
u'كَفَالَةٌ عَيْن':Added, #1: 1	كَفَالَةِ الْعَيْنِ
u'كَفَالَةٌ غَائِبٌ':Added, #1: 1	كَفَالَةِ الْعَيْنِ
u'كَفَالَةٌ غُلاَمٌ':Added, #1: 1	كَفَالَةِ الْغَائِبِ
u'كَفَالَةٌ فُلاَنٌ':Added, #1: 1	كَفَالَةِ الْغُلَامِ
u'كَفَالَةٌ فلان':Added, #10: 10	كَفَالَةِ فُلَانٍ
u'كَفَالَةٌ كَفِيلٌ':Added, #4: 4	كَفَالَةِ الْخَانِيَّةِ
u'كَفَالَةٌ مَالٌ':Added, #2: 2	كَفَالَةِ الْكَفِيلِ
u'كَفَالَةٌ مَبْسُوطٌ':Added, #1: 1	كَفَالَةِ الْمَالِ
u'كَفَالَةٌ مَجْنُونٌ':Added, #2: 2	كَفَالَةِ الْمَبْسُوطِ
u'كَفَالَةٌ مَدْيُونٌ':Added, #1: 1	كَفَالَةُ مَجْنُونٍ
u'كَفَالَةٌ مَرِيضٌ':Added, #1: 1	كَفَالَةُ الْمَدْيُونِ
u'كَفَالَةٌ مُسْلِمٌ':Added, #2: 2	كَفَالَةُ الْمَرِيضِ
u'كَفَالَةٌ نَاظِرٌ':Added, #1: 1	كَفَالَةَ مُسْلِمٍ
u'كَفَالَةٌ نَفْسٌ':Added, #1: 1	كَفَالَةُ النَّاظِرِ
u'كَفَالَةٌ نَفْسٌ':Added, #1: 1	كَفَالَةِ نَفْسٍ
u'كَفَالَةٌ نَفْسٌ':Added, #2: 2	كَفَالَةِ نَفْسِ
u'كَفَالَةٌ واحد':Added, #5: 5	كَفَالَةِ النَّفْسِ
u'كَفَالَةٌ وَاحِدٌ':Added, #1: 1	كَفَالَةِ الْوَاحِدِ
u'كَفَالَةٌ وَاقِعٌ':Added, #1: 1	كَفَالَةِ الْوَاحِدِ
u'كَفَالَةٌ وَاقِعَةٌ':Added, #1: 1	كَفَالَةٍ وَاقِعَةٍ
u'كَفَالَةٌ وَجْهٌ':Added, #1: 1	كَفَالَةٍ وَاقِعَةٍ
u'كَفَالَةٌ وَصِيٌّ':Added, #1: 1	كَفَالَةَ الْوَجْهِ
u'كَفَالَةٌ وَصِيٌّ':Added, #1: 1	كَفَالَةُ الْوَصِيِّ
u'كَفَالَةٌ وَكِيلٌ':Added, #1: 1	كَفَالَةِ الْوَصِيِّ
u'كَفَالَةٌ ولد':Added, #4: 4	كَفَالَةُ الْوَكِيلِ
u'كَفَالَةٌ وَلَدٌ':Added, #1: 1	كَفَالَةُ الْوَلَدِ
u'كَفَالَةٌ يَتِيمٌ':Added, #1: 1	كَفَالَةُ الْوَلَدِ
u'كِفَايَةٌ اِبْنٌ':Added, #1: 1	كَفَالَةِ الْيَتِيمِ
u'كِفَايَةٌ أرْبَابٌ':Added, #1: 1	كِفَايَةِ ابْنِ
u'كِفَايَةٌ أَمْرٌ':Added, #1: 1	كِفَايَةِ أَرْبَابِهِ
u'كِفَايَةٌ إِمْكانٌ':Added, #1: 1	كِفَايَةُ أَمْرِ
u'كِفَايَةٌ أهْلٌ':Added, #2: 2	كِفَايَةُ الْإِمْكَانِ
u'كِفَايَةٌ أَوْلاَدٌ':Added, #1: 1	كِفَايَةَ أَهْلِهِ
u'كِفَايَةٌ أيَّامٌ':Added, #1: 1	كِفَايَةِ أَوْلَادِهِ
u'كِفَايَةٌ أَيَّامٌ':Added, #2: 2	كِفَايَةَ أَيَّامٍ
u'كِفَايَةٌ بُسْتانٌ':Added, #2: 2	كِفَايَةَ أَيَّامٍ
u'كِفَايَةٌ بَقِيَّةٌ':Added, #1: 1	كِفَايَةِ الْبُسْتَانِ
u'كِفَايَةٌ حَمْدٌ':Added, #1: 1	كِفَايَةُ بَقِيَّةِ
u'كِفَايَةٌ خَادِمٌ':Added, #1: 1	كِفَايَةِ الْحَمْدِ
u'كِفَايَةٌ دَابَّةٌ':Added, #1: 1	كِفَايَةَ الْخَادِمِ
u'كِفَايَةٌ رَقيقٌ':Added, #1: 1	كِفَايَةُ دَابَّتِهِ
u'كِفَايَةٌ رَقيق':Added, #1: 1	كِفَايَةُ الرَّقِيقِ
u'كِفَايَةٌ سَنَةٌ':Added, #1: 1	كِفَايَةُ الرَّقِيقِ
u'كِفَايَةٌ سَنَةٌ':Added, #2: 2	كِفَايَةُ سَنَةٍ
u'كِفَايَةٌ سَنَةٌ':Added, #3: 3	كِفَايَةَ سَنَةٍ
u'كِفَايَةٌ سَنَةٌ':Added, #5: 5	كِفَايَةِ السَّنَةِ
u'كِفَايَةٌ شَعْبِيٌّ':Added, #7: 7	كِفَايَةِ سَنَةٍ
u'كِفَايَةٌ صَغِيرٌ':Added, #1: 1	كِفَايَةِ الشَّعْبِيِّ
u'كِفَايَةٌ طَالِبٌ':Added, #1: 1	كِفَايَةِ الصَّغِيرِ
u'كِفَايَةٌ طِفْلٌ':Added, #1: 1	كِفَايَةِ الطَّالِبِ
u'كِفَايَةٌ طَهَارَةٌ':Added, #1: 1	كِفَايَةُ الطِّفْلِ
u'كِفَايَةٌ عُمُرٌ':Added, #1: 1	كِفَايَةِ طَهَارَتِهِ
u'كِفَايَةٌ عِيَالٌ':Added, #1: 1	كِفَايَةَ الْعُمُرِ
u'كِفَايَةٌ عِيَالٌ':Added, #2: 2	كِفَايَةُ عِيَالِهِ
u'كِفَايَةٌ فحول':Added, #2: 2	كِفَايَةِ عِيَالِهِ
u'كِفَايَةٌ فُحُولٌ':Added, #1: 1	كِفَايَةِ الْفُحُولِ
u'كِفَايَةٌ فَقِيرٌ':Added, #1: 1	كِفَايَةِ الْفُحُولِ
u'كِفَايَةٌ قَرِيبٌ':Added, #1: 1	كِفَايَةُ الْفَقِيرِ
u'كِفَايَةٌ كِفَايَةٌ':Added, #1: 1	كِفَايَةِ قَرِيبِهِ
u'كِفَايَةٌ مُتَحَفِّظٌ':Added, #1: 1	كِفَايَةِ الْكِفَايَةِ
u'كِفَايَةٌ مثل':Added, #2: 2	كِفَايَةِ الْمُتَحَفِّظِ
u'كِفَايَةٌ مِثْلٌ':Added, #1: 1	كِفَايَةِ مِثْلِهِ
u'كِفَايَةٌ مُحْتَاجٌ':Added, #1: 1	كِفَايَةِ مِثْلِهِ
u'كِفَايَةٌ مِسْكِينٌ':Added, #1: 1	كِفَايَةِ الْمُحْتَاجِ
u'كِفَايَةٌ مَصْلَحَةٌ':Added, #1: 1	كِفَايَةِ الْمِسْكِينِ
u'كِفَايَةٌ مُمَوِّنٌ':Added, #1: 1	كِفَايَةُ الْمَصْلَحَةِ
u'كِفَايَةٌ مُوسِرٌ':Added, #1: 1	كِفَايَةِ مُمَوِّنِهِ
u'كِفَايَةٌ نَفْسٌ':Added, #2: 2	كِفَايَةِ الْمُوسِرَاتِ
u'كِفَايَةٌ نَفْسٌ':Added, #1: 1	كِفَايَةُ نَفْسِهِ
u'كِفَايَةٌ نَفَقَةٌ':Added, #1: 1	كِفَايَةِ نَفْسِهِ
u'كِفَايَةٌ هِدَايَةٌ':Added, #2: 2	كِفَايَةِ نَفَقَةٍ
u'كِفَايَةٌ ولد':Added, #1: 1	كِفَايَةِ الْهِدَايَةِ
u'كِفَايَةٌ ولد':Added, #1: 1	كِفَايَةَ الْوَلَدِ
u'كِفَايَةٌ وَلَدٌ':Added, #1: 1	كِفَايَةِ الْوَلَدِ
u'كِفَايَةٌ وَلَدٌ':Added, #1: 1	كِفَايَةَ الْوَلَدِ
u'كِفَايَةٌ يَوْمٌ':Added, #1: 1	كِفَايَةِ الْوَلَدِ
u'كِفَايَةٌ يَوْمٌ':Added, #1: 1	كِفَايَةِ الْيَوْمِ
u'كِفَايَةٌ يَوْمٌ':Added, #1: 1	كِفَايَةَ يَوْمِهِ
u'كَفَّ بَصَرٌ':Subject, #2: 2	كِفَايَةَ يَوْمٍ
u'كفر أَبٌ':Added, #1: 1	كَفَّ بَصَرُهُ
u'كُفْرٌ أَبٌ':Added, #1: 1	كُفْرِ الْأَبِ
u'كَفَرَ إبْلِيسُ':Subject, #1: 1	كُفْرِ الْأَبِ
u'كَفَّرَ أَرْبَعَةٌ':Predicate, #1: 1	كَفَرَ إبْلِيسُ
u'كفر أصل':Added, #1: 1	كَفَّرَ الْأَرْبَعَةَ
u'كفر أًصْلٌ':Added, #1: 1	كُفْرُ الْأَصْلِ
u'كُفْرٌ أصل':Added, #1: 1	كُفْرُ الْأَصْلِ
u'كُفْرٌ أًصْلٌ':Added, #1: 1	كُفْرُ الْأَصْلِ
u'كفر أَطْفَالٌ':Added, #1: 1	كُفْرُ الْأَصْلِ
u'كُفْرٌ أَطْفَالٌ':Added, #1: 1	كُفْرَ أَطْفَالِ
u'كَفَّرَ آمِرٌ':Subject, #1: 1	كُفْرَ أَطْفَالِ
u'كُفْرَانٌ عَشِيرٌ':Added, #1: 1	كَفَّرَ الْآمِرُ
u'كفر إِنْكارٌ':Added, #1: 1	كُفْرَانِ الْعَشِيرِ
u'كُفْرٌ إِنْكارٌ':Added, #1: 1	كُفْرُ إنْكَارٍ
u'كُفْرَانٌ نِعَمٌ':Added, #1: 1	كُفْرُ إنْكَارٍ
u'كُفْرَانٌ نِعَمٌ':Added, #1: 1	كُفْرَانُ النِّعَمِ
u'كُفْرَانٌ نعمة':Added, #2: 2	كُفْرَانِ النِّعَمِ
u'كُفْرَانٌ نِعْمَةٌ':Added, #1: 1	كُفْرَانَ نِعْمَةِ
u'كُفْرَانٌ نعمة':Added, #1: 1	كُفْرَانَ نِعْمَةِ
u'كُفْرَانٌ نِعْمَةٌ':Added, #2: 2	كُفْرَانُ النِّعْمَةِ
u'كُفْرَانٌ نعمة':Added, #2: 2	كُفْرَانُ النِّعْمَةِ
u'كُفْرَانٌ نعمة':Added, #3: 3	كُفْرَانُ نِعْمَةِ
u'كُفْرَانٌ نِعْمَةٌ':Added, #3: 3	كُفْرَانِ نِعْمَةِ
u'كُفْرَانٌ نِعْمَةٌ':Added, #3: 3	كُفْرَانُ نِعْمَةِ
u'كُفْرَانٌ نعمة':Added, #3: 3	كُفْرَانِ نِعْمَةِ
u'كُفْرَانٌ نِعْمَةٌ':Added, #4: 4	كُفْرَانَ النِّعْمَةِ
u'كُفْرَانٌ نعمة':Added, #4: 4	كُفْرَانَ النِّعْمَةِ
u'كُفْرَانٌ نِعْمَةٌ':Added, #6: 6	كُفْرَانِ النِّعْمَةِ
u'كَفَّرَ أهْلٌ':Predicate, #6: 6	كُفْرَانِ النِّعْمَةِ
u'كَفَرَ أهْلٌ':Subject, #3: 3	كَفَّرَ أَهْلَ
u'كفر تارِك':Added, #1: 1	كَفَرَ أَهْلُ
u'كُفْرٌ تارِك':Added, #1: 1	كُفْرِ تَارِكِ
u'كَفَرَ جَاحِدٌ':Subject, #1: 1	كُفْرِ تَارِكِ
u'كفر جَاحِدٌ':Added, #1: 1	كَفَرَ جَاحِدُهُ
u'كُفْرٌ جَاحِدٌ':Added, #1: 1	كُفْرَ جَاحِدِ
u'كَفَّ رَجُلٌ':Subject, #1: 1	كُفْرَ جَاحِدِ
u'كَفَّرَ جَهْم':Predicate, #2: 2	كَفَّ الرَّجُلُ
u'كفر حَقِيقَةٌ':Added, #2: 2	كَفَّرَ الْجَهْمِيَّةَ
u'كُفْرٌ حَقِيقَةٌ':Added, #1: 1	كُفْرَ حَقِيقَةٍ
u'كَفَّرَ حَنَفِيَّةٌ':Subject, #1: 1	كُفْرَ حَقِيقَةٍ
u'كفر خوارج':Added, #1: 1	كَفَّرَ الْحَنَفِيَّةُ
u'كفر خوارج':Added, #2: 2	كُفْرَ الْخَوَارِجِ
u'كُفْرٌ خوارج':Added, #2: 2	كُفْرِ الْخَوَارِجِ
u'كُفْرٌ خوارج':Added, #2: 2	كُفْرَ الْخَوَارِجِ
u'كفر خَوَارِجُ':Added, #2: 2	كُفْرِ الْخَوَارِجِ
u'كفر خَوَارِجُ':Added, #2: 2	كُفْرَ الْخَوَارِجِ
u'كُفْرٌ خَوَارِجُ':Added, #2: 2	كُفْرِ الْخَوَارِجِ
u'كُفْرٌ خَوَارِجُ':Added, #2: 2	كُفْرَ الْخَوَارِجِ
u'كَفَرَ دَخَلٌ':Predicate, #2: 2	كُفْرِ الْخَوَارِجِ
u'كفر ذِمِّيٌّ':Added, #1: 1	كَفَرَ دَخَلَ
u'كفر ذِمِّيٌّ':Added, #1: 1	كُفْرَ الذِّمِّيِّ
u'كُفْرٌ ذِمِّيٌّ':Added, #1: 1	كُفْرُ الذِّمِّيِّ
u'كُفْرٌ ذِمِّيٌّ':Added, #1: 1	كُفْرَ الذِّمِّيِّ
u'كَفَّرَ رَجُلٌ':Subject, #1: 1	كُفْرُ الذِّمِّيِّ
u'كَفَّرَ رَجُلٌ':Subject, #1: 1	كَفَّرَ الرَّجُلُ
u'كفر رَقيقٌ':Added, #1: 1	كَفَّرَ رَجُلٌ
u'كفر رَقيق':Added, #1: 1	كُفْرُ رَقِيقٍ
u'كُفْرٌ رَقيقٌ':Added, #1: 1	كُفْرُ رَقِيقٍ
u'كُفْرٌ رَقيق':Added, #1: 1	كُفْرُ رَقِيقٍ
u'كفر زَوْجَةٌ':Added, #1: 1	كُفْرُ رَقِيقٍ
u'كُفْرٌ زَوْجَةٌ':Added, #2: 2	كُفْرِ الزَّوْجَةِ
u'كَفَّرَ سقط':Predicate, #2: 2	كُفْرِ الزَّوْجَةِ
u'كَفَّرَ سَقَطٌ':Predicate, #1: 1	كَفَّرَ سَقَطَ
u'كفر شُهُودٌ':Added, #1: 1	كَفَّرَ سَقَطَ
u'كُفْرٌ شُهُودٌ':Added, #3: 3	كُفْرُ الشُّهُودِ
u'كفر صَاحِبٌ':Added, #3: 3	كُفْرُ الشُّهُودِ
u'كُفْرٌ صَاحِبٌ':Added, #1: 1	كُفْرِ صَاحِبِ
u'كَفَّرَ صَحَابَةٌ':Predicate, #1: 1	كُفْرِ صَاحِبِ
u'كُفْرٌ صَرِيحٌ':Added, #2: 2	كَفَّرَ الصَّحَابَةَ
u'كُفْرٌ ظاهِرٌ':Added, #1: 1	كُفْرٍ صَرِيحٍ
u'كَفَّرَ عَاجِزٌ':Subject, #1: 1	كُفْرٍ ظَاهِرٍ
u'كَفَّرَ عَاشُورَاءُ':Subject, #1: 1	كَفَّرَ الْعَاجِزُ
u'كفر عَدُوٌّ':Added, #1: 1	كَفَّرَ عَاشُورَاءُ
u'كُفْرٌ عَدُوٌّ':Added, #1: 1	كُفْرِ الْعَدُوِّ
u'كفر عناد':Added, #1: 1	كُفْرِ الْعَدُوِّ
u'كُفْرٌ عناد':Added, #1: 1	كُفْرُ عِنَادٍ
u'كفر عِنَادٌ':Added, #1: 1	كُفْرُ عِنَادٍ
u'كُفْرٌ عِنَادٌ':Added, #1: 1	كُفْرُ عِنَادٍ
u'كَفَّرَ عند':Predicate, #1: 1	كُفْرُ عِنَادٍ
u'كَفَرَ عند':Predicate, #1: 1	كَفَّرَ عِنْدَ
u'كفر غُلاَمٌ':Added, #4: 4	كَفَرَ عِنْدَ
u'كُفْرٌ غُلاَمٌ':Added, #1: 1	كُفْرَ الْغُلَامِ
u'كَفَّرَ غير':Subject, #1: 1	كُفْرَ الْغُلَامِ
u'كَفَّرَ غَيْرٌ':Subject, #1: 1	كَفَّرَ الْغَيْرُ
u'كَفَّرَ غير':Subject, #1: 1	كَفَّرَ الْغَيْرُ
u'كَفَّرَ غَيْرٌ':Subject, #1: 1	كَفَّرَ غَيْرُهُ
u'كفر غير':Added, #1: 1	كَفَّرَ غَيْرُهُ
u'كفر غَيْرٌ':Added, #1: 1	كُفْرِ غَيْرِهِ
u'كُفْرٌ غير':Added, #1: 1	كُفْرِ غَيْرِهِ
u'كُفْرٌ غَيْرٌ':Added, #1: 1	كُفْرِ غَيْرِهِ
u'كفر فِرْقَةٌ':Added, #1: 1	كُفْرِ غَيْرِهِ
u'كُفْرٌ فِرْقَةٌ':Added, #1: 1	كُفْرِ الْفِرْقَةِ
u'كَفَّرَ قَالٌ':Predicate, #1: 1	كُفْرِ الْفِرْقَةِ
u'كَفَرَ قَالٌ':Predicate, #1: 1	كَفَّرَ قَالَ
u'كفر قَائِلٌ':Added, #5: 5	كَفَرَ قَالَ
u'كُفْرٌ قَائِلٌ':Added, #1: 1	كُفْرَ الْقَائِلِ
u'كَفَرَ قتل':Predicate, #1: 1	كُفْرَ الْقَائِلِ
u'كفر قَرِيبٌ':Added, #1: 1	كَفَرَ قُتِلَ
u'كُفْرٌ قَرِيبٌ':Added, #1: 1	كُفْرِ الْقَرِيبِ
u'كَفَرَ قول':Subject, #1: 1	كُفْرِ الْقَرِيبِ
u'كَفَرَ قَوْلٌ':Subject, #1: 1	كَفَرَ قَوْلُهُ
u'كفر كَافِرٌ':Added, #1: 1	كَفَرَ قَوْلُهُ
u'كُفْرٌ كَافِرٌ':Added, #1: 1	كُفْرَ الْكَافِرِ
u'كفر كَافِرٌ':Added, #1: 1	كُفْرَ الْكَافِرِ
u'كُفْرٌ كَافِرٌ':Added, #3: 3	كُفْرِ الْكَافِرِ
u'كفر كَافِرٌ':Added, #3: 3	كُفْرِ الْكَافِرِ
u'كُفْرٌ كَافِرٌ':Added, #4: 4	كُفْرُ الْكَافِرِ
u'كَفَرَ كفر':Predicate, #4: 4	كُفْرُ الْكَافِرِ
u'كَفَرَ كَفُورٌ':Subject, #3: 3	كَفَرَ كَفَرَ
u'كفر مَالِكٌ':Added, #2: 2	كَفَرَ الْكَفُورُ
u'كُفْرٌ مَالِكٌ':Added, #2: 2	كُفْرِ الْمَالِكِ
u'كَفَرَ مَأْمُورٌ':Subject, #2: 2	كُفْرِ الْمَالِكِ
u'كفر مُتَعَلِّمٌ':Added, #1: 1	كَفَرَ الْمَأْمُورُ
u'كُفْرٌ مُتَعَلِّمٌ':Added, #1: 1	كُفْرِ مُتَعَلِّمِهِ
u'كَفَّرَ مُتَمَتِّعٌ':Subject, #1: 1	كُفْرِ مُتَعَلِّمِهِ
u'كفر مُحَارِبٌ':Added, #2: 2	كَفَّرَ الْمُتَمَتِّعُ
u'كُفْرٌ مُحَارِبٌ':Added, #3: 3	كُفْرُ الْمُحَارِبِ
u'كُفْرٌ مَحْضٌ':Added, #3: 3	كُفْرُ الْمُحَارِبِ
u'كَفَرَ مُخَالِفٌ':Subject, #1: 1	كُفْرٍ مَحْضٍ
u'كَفَّرَ مُرْتَدٌّ':Subject, #1: 1	كَفَرَ الْمُخَالِفُ
u'كفر مُرْتَدٌّ':Added, #2: 2	كَفَّرَ مُرْتَدٌّ
u'كُفْرٌ مُرْتَدٌّ':Added, #1: 1	كُفْرَ الْمُرْتَدِّ
u'كفر مُسْلِمٌ':Added, #1: 1	كُفْرَ الْمُرْتَدِّ
u'كُفْرٌ مُسْلِمٌ':Added, #1: 1	كُفْرُ الْمُسْلِمِ
u'كفر مَعْرُوفٌ':Added, #1: 1	كُفْرُ الْمُسْلِمِ
u'كُفْرٌ مَعْرُوفٌ':Added, #1: 1	كُفْرُ الْمَعْرُوفِ
u'كفر مِلَّةٌ':Added, #1: 1	كُفْرُ الْمَعْرُوفِ
u'كُفْرٌ مِلَّةٌ':Added, #1: 1	كُفْرَ الْمِلَّةِ
u'كفر مُنْكِرٌ':Added, #1: 1	كُفْرَ الْمِلَّةِ
u'كُفْرٌ مُنْكِرٌ':Added, #1: 1	كُفْرَ مُنْكِرِ
u'كَفَّرَ مُوَكِّلٌ':Subject, #1: 1	كُفْرَ مُنْكِرِ
u'كَفَرَ نُجُومٌ':Predicate, #1: 1	كَفَّرَ الْمُوَكِّلُ
u'كفر نِعَمٌ':Added, #1: 1	كَفَرَ النُّجُومَ
u'كُفْرٌ نِعَمٌ':Added, #1: 1	كُفْرُ النِّعَمِ
u'كفر نِعَمٌ':Added, #1: 1	كُفْرُ النِّعَمِ
u'كُفْرٌ نِعَمٌ':Added, #1: 1	كُفْرِ نِعَمِ
u'كَفَرَ نعمة':Predicate, #1: 1	كُفْرِ نِعَمِ
u'كَفَرَ نِعْمَةٌ':Predicate, #1: 1	كَفَرَ نِعْمَةَ
u'كَفَرَ نعمة':Predicate, #1: 1	كَفَرَ نِعْمَةَ
u'كَفَرَ نِعْمَةٌ':Predicate, #4: 4	كَفَرَ النِّعْمَةَ
u'كفر نعمة':Added, #4: 4	كَفَرَ النِّعْمَةَ
u'كفر نعمة':Added, #1: 1	كُفْرَ النِّعْمَةِ
u'كُفْرٌ نعمة':Added, #1: 1	كُفْرِ النِّعْمَةِ
u'كُفْرٌ نعمة':Added, #1: 1	كُفْرَ النِّعْمَةِ
u'كفر نِعْمَةٌ':Added, #1: 1	كُفْرِ النِّعْمَةِ
u'كفر نِعْمَةٌ':Added, #1: 1	كُفْرَ النِّعْمَةِ
u'كُفْرٌ نِعْمَةٌ':Added, #1: 1	كُفْرِ النِّعْمَةِ
u'كُفْرٌ نِعْمَةٌ':Added, #1: 1	كُفْرَ النِّعْمَةِ
u'كفر نعمة':Added, #1: 1	كُفْرِ النِّعْمَةِ
u'كفر نعمة':Added, #1: 1	كُفْرُ نِعْمَةٍ
u'كُفْرٌ نعمة':Added, #1: 1	كُفْرُ نِعْمَةِ
u'كُفْرٌ نعمة':Added, #1: 1	كُفْرُ نِعْمَةٍ
u'كفر نِعْمَةٌ':Added, #1: 1	كُفْرُ نِعْمَةِ
u'كفر نِعْمَةٌ':Added, #1: 1	كُفْرُ نِعْمَةٍ
u'كُفْرٌ نِعْمَةٌ':Added, #1: 1	كُفْرُ نِعْمَةِ
u'كُفْرٌ نِعْمَةٌ':Added, #1: 1	كُفْرُ نِعْمَةٍ
u'كفر نعمة':Added, #1: 1	كُفْرُ نِعْمَةِ
u'كُفْرٌ نعمة':Added, #3: 3	كُفْرُ النِّعْمَةِ
u'كفر نِعْمَةٌ':Added, #3: 3	كُفْرُ النِّعْمَةِ
u'كُفْرٌ نِعْمَةٌ':Added, #3: 3	كُفْرُ النِّعْمَةِ
u'كفر نَفْسٌ':Added, #3: 3	كُفْرُ النِّعْمَةِ
u'كُفْرٌ نَفْسٌ':Added, #2: 2	كُفْرَ نَفْسِهِ
u'كَفَّرَ وَاطِئٌ':Subject, #2: 2	كُفْرَ نَفْسِهِ
u'كفر ولد':Added, #1: 1	كَفَّرَ الْوَاطِئُ
u'كُفْرٌ ولد':Added, #1: 1	كُفْرُ وَلَدِ
u'كفر وَلَدٌ':Added, #1: 1	كُفْرُ وَلَدِ
u'كُفْرٌ وَلَدٌ':Added, #1: 1	كُفْرُ وَلَدِ
u'كفر يهود':Added, #1: 1	كُفْرُ وَلَدِ
u'كفر يهود':Added, #1: 1	كُفْرُ الْيَهُودِ
u'كفر يَهُودٌ':Added, #1: 1	كُفْرِ الْيَهُودِ
u'كفر يَهُودٌ':Added, #1: 1	كُفْرُ الْيَهُودِ
u'كُفْرٌ يهود':Added, #1: 1	كُفْرِ الْيَهُودِ
u'كُفْرٌ يهود':Added, #1: 1	كُفْرُ الْيَهُودِ
u'كُفْرٌ يَهُودٌ':Added, #1: 1	كُفْرِ الْيَهُودِ
u'كُفْرٌ يَهُودٌ':Added, #1: 1	كُفْرُ الْيَهُودِ
u'كَفَّرَ يَوْمٌ':Predicate, #1: 1	كُفْرِ الْيَهُودِ
u'كَفَّ زَوْجٌ':Subject, #1: 1	كَفَّرَ الْيَوْمَ
u'كَفَّ قَائِلٌ':Subject, #1: 1	كَفَّ الزَّوْجُ
u'كَفَّ كَفٌّ':Predicate, #1: 1	كَفَّ قَائِلُهُ
u'كَفَلَ أَبٌ':Subject, #1: 1	كَفَّ كَفَّ
u'كَفَلَ أحَدٌ':Subject, #1: 1	كَفَلَ الْأَبُ
u'كَفَلَ إِنْسانٌ':Subject, #1: 1	كَفَلَ أَحَدُ
u'كَفَلَ ثَانِي':Predicate, #3: 3	كَفَلَ إنْسَانٌ
u'كَفَلَ ثَلاثَةٌ':Subject, #1: 1	كَفَلَ الثَّانِيَ
u'كَفَلَ جَمَاعَةٌ':Subject, #2: 2	كَفَلَ ثَلَاثَةٌ
u'كَفَلَ حُرٌّ':Subject, #1: 1	كَفَلَ جَمَاعَةٌ
u'كَفَلَ رَجُلٌ':Subject, #1: 1	كَفَلَ الْحُرُّ
u'كَفَلَ رَجُلٌ':Subject, #20: 20	كَفَلَ رَجُلٌ
u'كَفَلَ سَيِّدٌ':Subject, #3: 3	كَفَلَ الرَّجُلُ
u'كَفَلَ صَبِيٌّ':Subject, #2: 2	كَفَلَ سَيِّدُهُ
u'كَفَلَ عَبْدٌ':Subject, #1: 1	كَفَلَ الصَّبِيُّ
u'كَفَلَ عَبْدٌ':Subject, #2: 2	كَفَلَ عَبْدٌ
u'كَفَلَ فُلاَنٌ':Subject, #3: 3	كَفَلَ الْعَبْدُ
u'كَفَلَ قَادِرٌ':Subject, #2: 2	كَفَلَ فُلَانٌ
u'كَفَّلَ مُتَّهَمٌ':Predicate, #1: 1	كَفَلَ قَادِرٌ
u'كَفَلَ مَرِيضٌ':Subject, #1: 1	كَفَّلَ الْمُتَّهَمِينَ
u'كَفَلَ مُسْلِمٌ':Subject, #1: 1	كَفَلَ الْمَرِيضُ
u'كَفَلَ واحد':Subject, #3: 3	كَفَلَ مُسْلِمٌ
u'كَفَلَ وَاحِدٌ':Subject, #2: 2	كَفَلَ وَاحِدٌ
u'كَفَلَ وَكِيلٌ':Predicate, #2: 2	كَفَلَ وَاحِدٌ
u'كَفَلَ وَكِيلٌ':Subject, #1: 1	كَفَلَ الْوَكِيلَ
u'كَفَّنَ أَجْنَبِيٌّ':Subject, #1: 1	كَفَلَ الْوَكِيلُ
u'كَفَّ نَارٌ':Predicate, #1: 1	كَفَّنَ أَجْنَبِيٌّ
u'كَفَّنَ رَسُولٌ':Subject, #1: 1	كَفَّ النَّارَ
u'كَفَّنَ شَهِيدٌ':Predicate, #1: 1	كَفَّنَ رَسُولُ
u'كَفَّنَ فَاطِمٌ':Predicate, #1: 1	كَفَّنَ الشَّهِيدَ
u'كَفْنٌ مثل':Added, #1: 1	كَفَّنَ فَاطِمَةَ
u'كَفْنٌ مِثْلٌ':Added, #1: 1	كَفْنَ مِثْلِهِ
u'كَفَّنَ نَبِيٌّ':Subject, #1: 1	كَفْنَ مِثْلِهِ
u'كَفَّنَ وَصِيٌّ':Subject, #1: 1	كَفَّنَ النَّبِيُّ
u'كَفَّ هَمٌّ':Subject, #1: 1	كَفَّنَ الْوَصِيُّ
u'كَفَى أخْذٌ':Subject, #1: 1	كَفَّ الْهَمُّ
u'كَفَى إِذْنٌ':Subject, #2: 2	كَفَى أَخْذُهُ
u'كَفَى إِذْنٌ':Subject, #1: 1	كَفَى إذْنٌ
u'كَفَى إِذْنٌ':Subject, #1: 1	كَفَى إذْنُ
u'كَفَى اِسْتِيطانٌ':Subject, #1: 1	كَفَى إذْنُهُ
u'كَفَى إِسْلامٌ':Subject, #1: 1	كَفَى اسْتِيطَانُ
u'كَفَى إشارَة':Subject, #1: 1	كَفَى الْإِسْلَامُ
u'كَفَى إِطْلاقٌ':Subject, #1: 1	كَفَى الْإِشَارَةُ
u'كَفَى إِفْرَازٌ':Subject, #4: 4	كَفَى الْإِطْلَاقُ
u'كَفَى الْمَرْءُ':Subject, #1: 1	كَفَى إفْرَازُ
u'كَفَى أُمَّهَاتٌ':Predicate, #2: 2	كَفَى الْمَرْءُ
u'كَفَى إيصَالٌ':Subject, #1: 1	كَفَى أُمّهَاتَ
u'كَفَى بَيَانٌ':Subject, #1: 1	كَفَى إيصَالُ
u'كَفَى تَأْجِيلٌ':Subject, #1: 1	كَفَى بَيَانُ
u'كَفَى تَأْمِينٌ':Subject, #1: 1	كَفَى تَأْجِيلُهُ
u'كَفَى تَخْفِيفٌ':Subject, #1: 1	كَفَى تَأْمِينُ
u'كَفَى تَصَوُّرٌ':Subject, #1: 1	كَفَى التَّخْفِيفُ
u'كَفَى تَعَدُّدٌ':Subject, #1: 1	كَفَى تَصَوُّرُ
u'كَفَى ثَوْبٌ':Subject, #1: 1	كَفَى التَّعَدُّدُ
u'كَفَى حَدٌّ':Subject, #1: 1	كَفَى الثَّوْبُ
u'كَفَى ذكر':Subject, #2: 2	كَفَى حَدٌّ
u'كَفَى ذِكْرٌ':Subject, #1: 1	كَفَى ذِكْرُ
u'كَفَى ذكر':Subject, #1: 1	كَفَى ذِكْرُ
u'كَفَى ذِكْرٌ':Subject, #3: 3	كَفَى ذِكْرُهُ
u'كَفَى رَفْعٌ':Subject, #3: 3	كَفَى ذِكْرُهُ
u'كَفَى سَاعِي':Predicate, #1: 1	كَفَى الرَّفْعُ
u'كَفَى شُرُوعٌ':Subject, #1: 1	كَفَى السَّاعِيَ
u'كَفَى شيب':Subject, #1: 1	كَفَى الشُّرُوعُ
u'كَفَى شَيْبٌ':Subject, #1: 1	كَفَى الشَّيْبُ
u'كَفَى صَبٌّ':Subject, #1: 1	كَفَى الشَّيْبُ
u'كَفَى صَحِيحٌ':Predicate, #1: 1	كَفَى صَبُّ
u'كَفَى صَلاَةٌ':Subject, #1: 1	كَفَى الصَّحِيحَ
u'كَفَى ظَنٌّ':Subject, #1: 1	كَفَى الصَّلَاةُ
u'كَفَى غُسْلٌ':Subject, #1: 1	كَفَى الظَّنُّ
u'كَفَى غُسْلٌ':Subject, #1: 1	كَفَى الْغُسْلُ
u'كَفَى غير':Subject, #1: 1	كَفَى غُسْلُ
u'كَفَى غَيْرٌ':Subject, #1: 1	كَفَى غَيْرُ
u'كَفَى فِعْلٌ':Subject, #1: 1	كَفَى غَيْرُ
u'كَفَى فِعْلٌ':Subject, #1: 1	كَفَى الْفِعْلُ
u'كَفَى قَبُولٌ':Subject, #1: 1	كَفَى فِعْلٌ
u'كَفَى قتل':Subject, #1: 1	كَفَى قَبُولُهُ
u'كَفَى قَتْلٌ':Subject, #1: 1	كَفَى الْقَتْلُ
u'كَفَى مَاءٌ':Subject, #1: 1	كَفَى الْقَتْلُ
u'كَفَى مُتَأَخِّرٌ':Predicate, #2: 2	كَفَى الْمَاءُ
u'كَفَى مُجَرَّدٌ':Subject, #1: 1	كَفَى الْمُتَأَخِّرَ
u'كَفَى مُحْدِثٌ':Predicate, #1: 1	كَفَى مُجَرَّدُ
u'كَفَى مَسْحٌ':Subject, #1: 1	كَفَى الْمُحْدِثَ
u'كَفَى مُسِيءٌ':Predicate, #1: 1	كَفَى مَسْحُ
u'كَفَى مُوَافَقَةٌ':Subject, #1: 1	كَفَى الْمُسِيءَ
u'كَفَى مَوْجُودٌ':Subject, #1: 1	كَفَى مُوَافَقَةُ
u'كَفَى نَجْمٌ':Subject, #1: 1	كَفَى الْمَوْجُودُ
u'كَفَى نَسْلٌ':Subject, #1: 1	كَفَى نَجْمٌ
u'كَفَى نِيَّةٌ':Subject, #2: 2	كَفَى نَسْلُهُ
u'كَفَى واحد':Subject, #1: 1	كَفَى نِيَّةُ
u'كَفَى وَاحِدٌ':Subject, #1: 1	كَفَى الْوَاحِدُ
u'كَفَى واحد':Subject, #1: 1	كَفَى الْوَاحِدُ
u'كَفَى وَاحِدٌ':Subject, #2: 2	كَفَى وَاحِدٌ
u'كَلَّبَ رَجُلٌ':Subject, #2: 2	كَفَى وَاحِدٌ
u'كَلَحَ مَشَافِرُ':Subject, #1: 1	كَلَّبَ الرَّجُلُ
u'كَلَّفَ المُشْتَرِي':Predicate, #1: 1	كَلَحَ الْمَشَافِرُ
u'كَلَّفَ خلق':Predicate, #2: 2	كَلَّفَ الْمُشْتَرِيَ
u'كَلَّفَ خَلْقٌ':Predicate, #1: 1	كَلَّفَ الْخَلْقَ
u'كَلَّفَ رِجَالٌ':Predicate, #1: 1	كَلَّفَ الْخَلْقَ
u'كَلَّفَ سَيِّدٌ':Subject, #1: 1	كَلَّفَ الرِّجَالَ
u'كَلَّفَ كُفَّارٌ':Predicate, #1: 1	كَلَّفَ السَّيِّدُ
u'كَلَّفَ مُجْتَهِد':Predicate, #1: 1	كَلَّفَ الْكُفَّارَ
u'كَلَّفَ مُشْتَرِي':Predicate, #1: 1	كَلَّفَ الْمُجْتَهِدِينَ
u'كَلَّفَ مَعْدُومٌ':Predicate, #2: 2	كَلَّفَ الْمُشْتَرِيَ
u'كَلَّفَ مُعَلِّلٌ':Predicate, #1: 1	كَلَّفَ الْمَعْدُومَ
u'كَلَّفَ نِساءٌ':Predicate, #1: 1	كَلَّفَ الْمُعَلِّلَ
u'كَلَّ لِسَانٌ':Subject, #1: 1	كَلَّفَ النِّسَاءَ
u'كَلَّمَ اِبْنٌ':Predicate, #1: 1	كَلَّ لِسَانُهُ
u'كَلَّمَ أحَدٌ':Predicate, #2: 2	كَلَّمَ ابْنَ
u'كَلَّمَ أخرَس':Predicate, #2: 2	كَلَّمَ أَحَدَ
u'كَلَّمَ أَرْبَعُ':Predicate, #1: 1	كَلَّمَ الْأَخْرَسَ
u'كَلَّمَ أَصْحَابٌ':Predicate, #1: 1	كَلَّمَ الْأَرْبَعَ
u'كَلَّمَ أَطْفَالٌ':Predicate, #1: 1	كَلَّمَ أَصْحَابَ
u'كَلَّمَ المُشْتَرِي':Predicate, #1: 1	كَلَّمَ الْأَطْفَالَ
u'كَلَّمَ أَوَّلُ':Predicate, #1: 1	كَلَّمَ الْمُشْتَرِيَ
u'كَلَّمَ بَائِعٌ':Subject, #4: 4	كَلَّمَ الْأَوَّلَ
u'كَلَّمَ رِجَالٌ':Predicate, #1: 1	كَلَّمَ الْبَائِعُ
u'كَلَّمَ رَسُولٌ':Subject, #1: 1	كَلَّمَ رِجَالَ
u'كَلَّمَ طَلْحٌ':Subject, #1: 1	كَلَّمَ رَسُولُ
u'كَلَّمَ طلحة':Subject, #1: 1	كَلَّمَ طَلْحَةُ
u'كَلَّمَ عَائِدٌ':Subject, #1: 1	كَلَّمَ طَلْحَةُ
u'كَلَّمَ عَبْدٌ':Predicate, #1: 1	كَلَّمَ عَائِدٌ
u'كَلَّمَ عتق':Predicate, #2: 2	كَلَّمَ الْعَبْدَ
u'كَلَّمَ عُمَرٌ':Predicate, #2: 2	كَلَّمَ عَتَقَ
u'كَلَّمَ غُلاَمٌ':Predicate, #1: 1	كَلَّمَ عُمَرَ
u'كَلَّمَ غُلاَمٌ':Predicate, #1: 1	كَلَّمَ الْغُلَامَ
u'كَلَّمَ غُلاَمٌ':Subject, #1: 1	كَلَّمَ غُلَامَ
u'كَلَّمَ فلان':Subject, #3: 3	كَلَّمَ غُلَامُ
u'كَلَّمَ قَتَلَةٌ':Predicate, #1: 1	كَلَّمَ عُثْمَانُ
u'كَلَّمَ مَذْكُورٌ':Predicate, #1: 1	كَلَّمَ قَتَلَةَ
u'كَلَّمَ مُشْتَرِي':Predicate, #1: 1	كَلَّمَ الْمَذْكُورَ
u'كَلَّمَ نَبِيٌّ':Predicate, #1: 1	كَلَّمَ الْمُشْتَرِيَ
u'كَلِيَ عَيْنٌ':Subject, #1: 1	كَلَّمَ النَّبِيَّ
u'كَلِيَ عَيْن':Subject, #1: 1	كَلِيَ عَيْنٌ
u'كَمَالٌ اِبْنٌ':Added, #1: 1	كَلِيَ عَيْنٌ
u'كَمَالٌ أَجْرٌ':Added, #4: 4	كَمَالِ ابْنِ
u'كَمَالٌ أَجْرٌ':Added, #1: 1	كَمَالُ أَجْرِ
u'كَمَالٌ أَجْرٌ':Added, #1: 1	كَمَالِ أَجْرِهِ
u'كَمَالٌ أَجْرٌ':Added, #1: 1	كَمَالَ الْأَجْرِ
u'كَمَالٌ أُجْرَةٌ':Added, #2: 2	كَمَالُ الْأَجْرِ
u'كَمَالٌ إِحْيَاءٌ':Added, #2: 2	كَمَالُ الْأُجْرَةِ
u'كَمَالٌ اِخْتِلاَفٌ':Added, #1: 1	كَمَالِ الْإِحْيَاءِ
u'كَمَالٌ أَدَاءٌ':Added, #1: 1	كَمَالِ اخْتِلَافِ
u'كَمَالٌ آدابٌ':Added, #1: 1	كَمَالِ الْأَدَاءِ
u'كَمَالٌ آدَمِيٌّ':Added, #1: 1	كَمَالِ الْآدَابِ
u'كَمَالٌ أَذَانٌ':Added, #2: 2	كَمَالِ الْآدَمِيِّ
u'كَمَالٌ إِسْبَاغٌ':Added, #3: 3	كَمَالِ الْأَذَانِ
u'كَمَالٌ اِسْتِعْدَادٌ':Added, #1: 1	كَمَالِ الْإِسْبَاغِ
u'كَمَالٌ إِسْلامٌ':Added, #1: 1	كَمَالِ اسْتِعْدَادِهِ
u'كَمَالٌ أَطْرافٌ':Added, #1: 1	كَمَالَ الْإِسْلَامِ
u'كَمَالٌ أَطْرَافٌ':Added, #1: 1	كَمَالِ أَطْرَافِهِ
u'كَمَالٌ اِطِّلاعٌ':Added, #1: 1	كَمَالِ أَطْرَافِهِ
u'كَمَالٌ أَفْرَادٌ':Added, #1: 1	كَمَالِ اطِّلَاعِهِ
u'كَمَالٌ آلةٌ':Added, #1: 1	كَمَالِ الْأَفْرَادِ
u'كَمَالٌ ألف':Added, #1: 1	كَمَالِ آلَةِ
u'كَمَالٌ ألف':Added, #1: 1	كَمَالُ الْأَلْفِ
u'كَمَالٌ ألْفٌ':Added, #1: 1	كَمَالِ الْأُلْفِ
u'كَمَالٌ ألْفٌ':Added, #1: 1	كَمَالُ الْأَلْفِ
u'كَمَالٌ أَلْفٌ':Added, #1: 1	كَمَالِ الْأُلْفِ
u'كَمَالٌ ألف':Added, #1: 1	كَمَالُ الْأَلْفِ
u'كَمَالٌ ألْفٌ':Added, #2: 2	كَمَالِ الْأَلْفِ
u'كَمَالٌ أَلْفٌ':Added, #2: 2	كَمَالِ الْأَلْفِ
u'كَمَالٌ أَهْلِيٌّ':Added, #2: 2	كَمَالِ الْأَلْفِ
u'كَمَالٌ أَهْلِيٌّ':Added, #1: 1	كَمَالَ الْأَهْلِيَّةِ
u'كَمَالٌ أهْلِيَّةٌ':Added, #2: 2	كَمَالُ الْأَهْلِيَّةِ
u'كَمَالٌ أهْلِيَّةٌ':Added, #1: 1	كَمَالَ الْأَهْلِيَّةِ
u'كَمَالٌ أَوْصَافٌ':Added, #2: 2	كَمَالُ الْأَهْلِيَّةِ
u'كَمَالٌ أَوَّلُ':Added, #1: 1	كَمَالَ الْأَوْصَافِ
u'كَمَالٌ إيمَانٌ':Added, #1: 1	كَمَالِ الْأَوَّلِ
u'كَمَالٌ بالِغٌ':Added, #2: 2	كَمَالِ الْإِيمَانِ
u'كَمَالٌ بَدَلٌ':Added, #1: 1	كَمَالِ الْبَالِغِ
u'كَمَالٌ بذلة':Added, #2: 2	كَمَالُ بَدَلِ
u'كَمَالٌ بِذْلَةٌ':Added, #1: 1	كَمَالِ الْبِذْلَةِ
u'كَمَالٌ بَلاغَةٌ':Added, #1: 1	كَمَالِ الْبِذْلَةِ
u'كَمَالٌ بُلُوغٌ':Added, #2: 2	كَمَالِ الْبَلَاغَةِ
u'كَمَالٌ بِنَاءٌ':Added, #1: 1	كَمَالِ الْبُلُوغِ
u'كَمَالٌ بَيْتٌ':Added, #2: 2	كَمَالِ الْبِنَاءِ
u'كَمَالٌ بَيِّنَةٌ':Added, #3: 3	كَمَالِ بَيْتِ
u'كَمَالٌ تَاسِعٌ':Added, #1: 1	كَمَالِ الْبَيِّنَةِ
u'كَمَالٌ تَحَفُّظٌ':Added, #1: 1	كَمَالِ التَّاسِعَةِ
u'كَمَالٌ تَحَمُّلٌ':Added, #1: 1	كَمَالِ التَّحَفُّظِ
u'كَمَالٌ تَدَبُّرٌ':Added, #1: 1	كَمَالَ تَحَمُّلِهِ
u'كَمَالٌ تَرْوِيحَةٌ':Added, #1: 1	كَمَالُ التَّدَبُّرِ
u'كَمَالٌ تَرْوِيحَة':Added, #2: 2	كَمَالِ التَّرْوِيحَةِ
u'كَمَالٌ تَسْبِيحٌ':Added, #2: 2	كَمَالِ التَّرْوِيحَةِ
u'كَمَالٌ تَصَرُّفٌ':Added, #1: 1	كَمَالِ التَّسْبِيحِ
u'كَمَالٌ تَصَرُّفٌ':Added, #1: 1	كَمَالَ التَّصَرُّفِ
u'كَمَالٌ تَعْدَادٌ':Added, #1: 1	كَمَالِ التَّصَرُّفِ
u'كَمَالٌ تَفْوِيضٌ':Added, #1: 1	كَمَالَ التَّعْدَادِ
u'كَمَالٌ تَقَرُّبٌ':Added, #1: 1	كَمَالَ التَّفْوِيضِ
u'كَمَالٌ تَمَتُّعٌ':Added, #1: 1	كَمَالِ تَقَرُّبِهِ
u'كَمَالٌ تَمَيُّزٌ':Added, #1: 1	كَمَالِ التَّمَتُّعِ
u'كَمَالٌ تَمْييزٌ':Added, #1: 1	كَمَالِ تَمَيُّزِهِ
u'كَمَالٌ تَنْظِيفٌ':Added, #1: 1	كَمَالُ التَّمْيِيزِ
u'كَمَالٌ تَيَمُّمٌ':Added, #2: 2	كَمَالُ التَّنْظِيفِ
u'كَمَالٌ ثَالِثٌ':Added, #1: 1	كَمَالِ التَّيَمُّمِ
u'كَمَالٌ جلد':Added, #2: 2	كَمَالِ الثَّالِثِ
u'كَمَالٌ جَلْدٌ':Added, #1: 1	كَمَالِ جَلْدِهِ
u'كَمَالٌ جَمَالٌ':Added, #1: 1	كَمَالِ جَلْدِهِ
u'كَمَالٌ جَمَالٌ':Added, #1: 1	كَمَالِ الْجَمَالِ
u'كَمَالٌ جمع':Added, #1: 1	كَمَالُ جَمَالٍ
u'كَمَالٌ جَمْعٌ':Added, #1: 1	كَمَالُ الْجَمْعِ
u'كَمَالٌ جمع':Added, #1: 1	كَمَالُ الْجَمْعِ
u'كَمَالٌ جَمْعٌ':Added, #7: 7	كَمَالِ الْجَمْعِ
u'كَمَالٌ جَنَابَةٌ':Added, #7: 7	كَمَالِ الْجَمْعِ
u'كَمَالٌ جِنَايَةٌ':Added, #1: 1	كَمَالِ الْجَنَابَةِ
u'كَمَالٌ جِنَايَةٌ':Added, #1: 1	كَمَالُ الْجِنَايَةِ
u'كَمَالٌ جِنَايَةٌ':Added, #1: 1	كَمَالَ جِنَايَتِهِ
u'كَمَالٌ جِنَايَةٌ':Added, #6: 6	كَمَالَ الْجِنَايَةِ
u'كَمَالٌ جِنْسِيٌّ':Added, #6: 6	كَمَالِ الْجِنَايَةِ
u'كَمَالٌ حادِثٌ':Added, #1: 1	كَمَالِ الْجِنْسِيَّةِ
u'كَمَالٌ حالٌ':Added, #1: 1	كَمَالَ حَادِثٍ
u'كَمَالٌ حالٌ':Added, #1: 1	كَمَالَ الْحَالِ
u'كَمَالٌ حالٌ':Added, #1: 1	كَمَالُ الْحَالِ
u'كَمَالٌ حُجَّةٌ':Added, #3: 3	كَمَالِ الْحَالِ
u'كَمَالٌ حِجَّةٌ':Added, #1: 1	كَمَالِ الْحُجَّةِ
u'كَمَالٌ حُجَّةٌ':Added, #1: 1	كَمَالُ الْحِجَّةِ
u'كَمَالٌ حَدٌّ':Added, #5: 5	كَمَالُ الْحُجَّةِ
u'كَمَالٌ حَدٌّ':Added, #1: 1	كَمَالِ الْحَدِّ
u'كَمَالٌ حَدٌّ':Added, #2: 2	كَمَالَ الْحَدِّ
u'كَمَالٌ حَرَكَةٌ':Added, #2: 2	كَمَالُ الْحَدِّ
u'كَمَالٌ حُرِّيَّةٌ':Added, #1: 1	كَمَالِ الْحَرَكَةِ
u'كَمَالٌ حُرِّيَّةٌ':Added, #1: 1	كَمَالَ الْحُرِّيَّةِ
u'كَمَالٌ حُرِّيَّةٌ':Added, #2: 2	كَمَالِ الْحُرِّيَّةِ
u'كَمَالٌ حَقٌّ':Added, #5: 5	كَمَالِ حُرِّيَّتِهِ
u'كَمَالٌ حَقٌّ':Added, #1: 1	كَمَالِ الْحَقِّ
u'كَمَالٌ حَقٌّ':Added, #1: 1	كَمَالَ حَقِّهِ
u'كَمَالٌ حَقٌّ':Added, #1: 1	كَمَالِ حَقِّهِ
u'كَمَالٌ حول':Added, #2: 2	كَمَالُ حَقِّهِ
u'كَمَالٌ حَوْلٌ':Added, #55: 55	كَمَالِ الْحَوْلِ
u'كَمَالٌ حَيَاةٌ':Added, #55: 55	كَمَالِ الْحَوْلِ
u'كَمَالٌ حَيْضٌ':Added, #1: 1	كَمَالِ حَيَاتِهِ
u'كَمَالٌ خراج':Added, #1: 1	كَمَالَ الْحَيْضِ
u'كَمَالٌ خَرَاجٌ':Added, #1: 1	كَمَالِ الْخَرَاجِ
u'كَمَالٌ خُرُوجٌ':Added, #1: 1	كَمَالِ الْخَرَاجِ
u'كَمَالٌ خُرُوجٌ':Added, #1: 1	كَمَالُ الْخُرُوجِ
u'كَمَالٌ خلقة':Added, #1: 1	كَمَالُ خُرُوجِهِ
u'كَمَالٌ خِلْقَةٌ':Added, #1: 1	كَمَالِ الْخِلْقَةِ
u'كَمَالٌ خلقة':Added, #1: 1	كَمَالِ الْخِلْقَةِ
u'كَمَالٌ خِلْقَةٌ':Added, #1: 1	كَمَالِ خِلْقَتِهِ
u'كَمَالٌ خَمْسٌ':Added, #1: 1	كَمَالِ خِلْقَتِهِ
u'كَمَالٌ دِيَةٌ':Added, #1: 1	كَمَالَ خَمْسِ
u'كَمَالٌ دِيَةٌ':Added, #2: 2	كَمَالِ الدِّيَةِ
u'كَمَالٌ دِيَةٌ':Added, #4: 4	كَمَالُ دِيَتِهِ
u'كَمَالٌ دِيَةٌ':Added, #6: 6	كَمَالَ الدِّيَةِ
u'كَمَالٌ دِينٌ':Added, #77: 77	كَمَالُ الدِّيَةِ
u'كَمَالٌ دَيْنٌ':Added, #1: 1	كَمَالِ دِينِهِ
u'كَمَالٌ دِينٌ':Added, #1: 1	كَمَالَ دَيْنِهِ
u'كَمَالٌ دِينٌ':Added, #22: 22	كَمَالُ الدِّينِ
u'كَمَالٌ رَأْسٌ':Added, #8: 8	كَمَالِ الدِّينِ
u'كَمَالٌ راغِب':Added, #1: 1	كَمَالِ رَأْسِ
u'كَمَالٌ رَأْيٌ':Added, #1: 1	كَمَالُ الرَّاغِبِ
u'كَمَالٌ رَأْيٌ':Added, #1: 1	كَمَالِ رَأْيِهِ
u'كَمَالٌ رُبُعٌ':Added, #2: 2	كَمَالِ الرَّأْيِ
u'كَمَالٌ رُبُعٌ':Added, #1: 1	كَمَالُ الرُّبُعِ
u'كَمَالٌ رُبُوبِيٌّ':Added, #1: 1	كَمَالُ رُبُعِ
u'كَمَالٌ رُخْصَةٌ':Added, #1: 1	كَمَالِ الرُّبُوبِيَّةِ
u'كَمَالٌ رَدٌّ':Added, #1: 1	كَمَالُ رُخْصَةٍ
u'كَمَالٌ رِقٌّ':Added, #1: 1	كَمَالِ الرَّدِّ
u'كَمَالٌ رِقٌّ':Added, #1: 1	كَمَالِ الرِّقِّ
u'كَمَالٌ رِقٌّ':Added, #2: 2	كَمَالُ الرِّقِّ
u'كَمَالٌ رُكوعٌ':Added, #6: 6	كَمَالَ الرِّقِّ
u'كَمَالٌ زادٌ':Added, #1: 1	كَمَالِ الرُّكُوعِ
u'كَمَالٌ زِينَةٌ':Added, #1: 1	كَمَالِ الزَّادِ
u'كَمَالٌ سَبَبٌ':Added, #2: 2	كَمَالَ الزِّينَةِ
u'كَمَالٌ سَبَبٌ':Added, #1: 1	كَمَالِ سَبَبِ
u'كَمَالٌ سَبَبٌ':Added, #3: 3	كَمَالِ السَّبَبِ
u'كَمَالٌ سَبْعَةٌ':Added, #3: 3	كَمَالِ سَبَبِهِ
u'كَمَالٌ سَتْرٌ':Added, #2: 2	كَمَالُ السَّبْعَةِ
u'كَمَالٌ سَلاَمَةٌ':Added, #1: 1	كَمَالُ السَّتْرِ
u'كَمَالٌ سَنَةٌ':Added, #1: 1	كَمَالُ السَّلَامَةِ
u'كَمَالٌ سُنَّةٌ':Added, #1: 1	كَمَالُ السَّنَةِ
u'كَمَالٌ سُنَّةٌ':Added, #3: 3	كَمَالِ السُّنَّةِ
u'كَمَالٌ سُنَّةٌ':Added, #4: 4	كَمَالَ السُّنَّةِ
u'كَمَالٌ سُورَةٌ':Added, #5: 5	كَمَالُ السُّنَّةِ
u'كَمَالٌ شَرْطٌ':Added, #1: 1	كَمَالِ السُّورَةِ
u'كَمَالٌ شَرْطٌ':Added, #1: 1	كَمَالَ الشَّرْطِ
u'كَمَالٌ شَرْطٌ':Added, #1: 1	كَمَالِ شَرْطِهِ
u'كَمَالٌ شَرْطٌ':Added, #3: 3	كَمَالُ الشَّرْطِ
u'كَمَالٌ شُرُوطٌ':Added, #4: 4	كَمَالِ الشَّرْطِ
u'كَمَالٌ شُرُوطٌ':Added, #1: 1	كَمَالُ الشُّرُوطِ
u'كَمَالٌ شَرِيعَةٌ':Added, #1: 1	كَمَالِ الشُّرُوطِ
u'كَمَالٌ شَرِيعَةٌ':Added, #1: 1	كَمَالُ الشَّرِيعَةِ
u'كَمَالٌ شَرِيكٌ':Added, #1: 1	كَمَالِ الشَّرِيعَةِ
u'كَمَالٌ شَفَقَةٌ':Added, #1: 1	كَمَالِ الشَّرِيكِ
u'كَمَالٌ شَوْطٌ':Added, #1: 1	كَمَالِ شَفَقَتِهِ
u'كَمَالٌ شَوْطٌ':Added, #1: 1	كَمَالُ الشَّوْطِ
u'كَمَالٌ صَاحِبٌ':Added, #1: 1	كَمَالِ الشَّوْطِ
u'كَمَالٌ صَبِيٌّ':Added, #1: 1	كَمَالِ صَاحِبِهِ
u'كَمَالٌ صدقة':Added, #1: 1	كَمَالِ الصَّبِيِّ
u'كَمَالٌ صَدَقَةٌ':Added, #1: 1	كَمَالُ الصَّدَقَةِ
u'كَمَالٌ صدقة':Added, #1: 1	كَمَالُ الصَّدَقَةِ
u'كَمَالٌ صَدَقَةٌ':Added, #2: 2	كَمَالِ الصَّدَقَةِ
u'كَمَالٌ صِفَةٌ':Added, #2: 2	كَمَالِ الصَّدَقَةِ
u'كَمَالٌ صِفَةٌ':Added, #1: 1	كَمَالَ الصِّفَةِ
u'كَمَالٌ صِفَةٌ':Added, #1: 1	كَمَالِ الصِّفَةِ
u'كَمَالٌ صَلاَةٌ':Added, #2: 2	كَمَالِ الصِّفَاتِ
u'كَمَالٌ صَلاَةٌ':Added, #1: 1	كَمَالِ الصَّلَاةِ
u'كَمَالٌ صَلاَةٌ':Added, #1: 1	كَمَالَ صَلَاةٍ
u'كَمَالٌ صَلاَحٌ':Added, #2: 2	كَمَالَ صَلَاتِهِ
u'كَمَالٌ صَنْج':Added, #1: 1	كَمَالِ صَلَاحِهِ
u'كَمَالٌ صُورَةٌ':Added, #1: 1	كَمَالِ الصَّنْجَةِ
u'كَمَالٌ صَوْمٌ':Added, #1: 1	كَمَالِ الصّورَةِ
u'كَمَالٌ صَوْمٌ':Added, #1: 1	كَمَالَ الصَّوْمِ
u'كَمَالٌ ضَالٌّ':Added, #1: 1	كَمَالُ الصَّوْمِ
u'كَمَالٌ ضَائِعٌ':Added, #2: 2	كَمَالٍ ضَالٍّ
u'كَمَالٌ ضَبْطٌ':Added, #5: 5	كَمَالٍ ضَائِعٍ
u'كَمَالٌ ضمار':Added, #1: 1	كَمَالِ ضَبْطِهِ
u'كَمَالٌ ضَمَانٌ':Added, #1: 1	كَمَالِ الضِّمَارِ
u'كَمَالٌ ضَمَانٌ':Added, #1: 1	كَمَالَ الضَّمَانِ
u'كَمَالٌ ضَمَانٌ':Added, #1: 1	كَمَالُ الضَّمَانِ
u'كَمَالٌ طِفْلٌ':Added, #1: 1	كَمَالُ ضَمَانِهِ
u'كَمَالٌ طَهَارَةٌ':Added, #2: 2	كَمَالِ الطِّفْلِ
u'كَمَالٌ طَهَارَةٌ':Added, #2: 2	كَمَالِ طَهَارَتِهِ
u'كَمَالٌ طَهَارَةٌ':Added, #3: 3	كَمَالِ الطَّهَارَةِ
u'كَمَالٌ طُهْرٌ':Added, #5: 5	كَمَالُ الطَّهَارَةِ
u'كَمَالٌ طواف':Added, #1: 1	كَمَالِ طُهْرٍ
u'كَمَالٌ طَوَافٌ':Added, #1: 1	كَمَالِ الطَّوَافِ
u'كَمَالٌ طُولٌ':Added, #1: 1	كَمَالِ الطَّوَافِ
u'كَمَالٌ طِيبٌ':Added, #2: 2	كَمَالِ الطُّولِ
u'كَمَالٌ عَبْدٌ':Added, #1: 1	كَمَالِ طِيبِهِ
u'كَمَالٌ عتق':Added, #3: 3	كَمَالِ الْعَبْدِ
u'كَمَالٌ عِتْقٌ':Added, #1: 1	كَمَالِ الْعِتْقِ
u'كَمَالٌ عَدَاوَةٌ':Added, #1: 1	كَمَالِ الْعِتْقِ
u'كَمَالٌ عِدَّةٌ':Added, #1: 1	كَمَالِ الْعَدَاوَةِ
u'كَمَالٌ عِدَّةٌ':Added, #1: 1	كَمَالُ الْعِدَّةِ
u'كَمَالٌ عَدَدٌ':Added, #2: 2	كَمَالِ الْعِدَّةِ
u'كَمَالٌ عَدَدٌ':Added, #1: 1	كَمَالَ الْعَدَدِ
u'كَمَالٌ عَدَدٌ':Added, #1: 1	كَمَالُ الْعَدَدِ
u'كَمَالٌ عَدَدٌ':Added, #1: 1	كَمَالِ عَدَدِ
u'كَمَالٌ عَدَمٌ':Added, #2: 2	كَمَالِ الْعَدَدِ
u'كَمَالٌ عَرْضٌ':Added, #1: 1	كَمَالِ عَدَمِ
u'كَمَالٌ عَقْدٌ':Added, #7: 7	كَمَالِ الْعَرْضِ
u'كَمَالٌ عَقْدٌ':Added, #1: 1	كَمَالُ الْعَقْدِ
u'كَمَالٌ عقر':Added, #2: 2	كَمَالِ الْعَقْدِ
u'كَمَالٌ عُقْرٌ':Added, #1: 1	كَمَالِ الْعُقْرِ
u'كَمَالٌ عقر':Added, #1: 1	كَمَالِ الْعُقْرِ
u'كَمَالٌ عُقْرٌ':Added, #2: 2	كَمَالُ الْعُقْرِ
u'كَمَالٌ عَقْلٌ':Added, #2: 2	كَمَالُ الْعُقْرِ
u'كَمَالٌ عَقْلٌ':Added, #1: 1	كَمَالَ الْعَقْلِ
u'كَمَالٌ عَقْلٌ':Added, #3: 3	كَمَالُ الْعَقْلِ
u'كَمَالٌ عَقْلٌ':Added, #3: 3	كَمَالِ عَقْلِهِ
u'كَمَالٌ عُقُوبَةٌ':Added, #7: 7	كَمَالِ الْعَقْلِ
u'كَمَالٌ عُقُوبَةٌ':Added, #1: 1	كَمَالَ الْعُقُوبَةِ
u'كَمَالٌ عِلَّةٌ':Added, #1: 1	كَمَالُ الْعُقُوبَةِ
u'كَمَالٌ علم':Added, #2: 2	كَمَالِ الْعِلَّةِ
u'كَمَالٌ عِلْمٌ':Added, #1: 1	كَمَالِ الْعِلْمِ
u'كَمَالٌ عِمَارَةٌ':Added, #1: 1	كَمَالِ الْعِلْمِ
u'كَمَالٌ عَمَلٌ':Added, #1: 1	كَمَالِ الْعِمَارَةِ
u'كَمَالٌ غَائِبٌ':Added, #1: 1	كَمَالَ عَمَلٍ
u'كَمَالٌ غُرْمٌ':Added, #1: 1	كَمَالِ غَائِبٍ
u'كَمَالٌ غُسْلٌ':Added, #1: 1	كَمَالُ الْغُرْمِ
u'كَمَالٌ غَسْلٌ':Added, #1: 1	كَمَالِ الْغُسْلِ
u'كَمَالٌ غُسْلٌ':Added, #1: 1	كَمَالِ غَسْلِ
u'كَمَالٌ غَنِيمَةٌ':Added, #2: 2	كَمَالِ غُسْلِ
u'كَمَالٌ غير':Added, #2: 2	كَمَالِ الْغَنِيمَةِ
u'كَمَالٌ غَيْرٌ':Added, #1: 1	كَمَالِ الْغَيْرِ
u'كَمَالٌ غير':Added, #1: 1	كَمَالِ الْغَيْرِ
u'كَمَالٌ غَيْرٌ':Added, #1: 1	كَمَالِ غَيْرِهِ
u'كَمَالٌ فِعْلٌ':Added, #1: 1	كَمَالِ غَيْرِهِ
u'كَمَالٌ فِعْلٌ':Added, #1: 1	كَمَالُ الْفِعْلِ
u'كَمَالٌ فِعْلٌ':Added, #1: 1	كَمَالُ فِعْلِ
u'كَمَالٌ فِقْهٌ':Added, #2: 2	كَمَالَ الْفِعْلِ
u'كَمَالٌ فلان':Added, #1: 1	كَمَالِ فِقْهِهِ
u'كَمَالٌ فَهْمٌ':Added, #1: 1	كَمَالُ الرَّاغِبِ
u'كَمَالٌ قَبْضٌ':Added, #1: 1	كَمَالُ الْفَهْمِ
u'كَمَالٌ قَبْضٌ':Added, #1: 1	كَمَالُ الْقَبْضِ
u'كَمَالٌ قدرة':Added, #1: 1	كَمَالِ الْقَبْضِ
u'كَمَالٌ قُدْرَةٌ':Added, #2: 2	كَمَالَ الْقُدْرَةِ
u'كَمَالٌ قدرة':Added, #2: 2	كَمَالَ الْقُدْرَةِ
u'كَمَالٌ قُدْرَةٌ':Added, #3: 3	كَمَالِ قُدْرَتِهِ
u'كَمَالٌ قُوَّةٌ':Added, #3: 3	كَمَالِ قُدْرَتِهِ
u'كَمَالٌ قُوَّة':Added, #1: 1	كَمَالِ الْقُوَّةِ
u'كَمَالٌ قُوَّةٌ':Added, #1: 1	كَمَالِ الْقُوَّةِ
u'كَمَالٌ قُوَّة':Added, #2: 2	كَمَالِ قُوَّةِ
u'كَمَالٌ قِيمَةٌ':Added, #2: 2	كَمَالِ قُوَّةِ
u'كَمَالٌ قِيمَةٌ':Added, #1: 1	كَمَالِ الْقِيمَةِ
u'كَمَالٌ قِيمَةٌ':Added, #1: 1	كَمَالَ قِيمَةِ
u'كَمَالٌ قِيمَةٌ':Added, #2: 2	كَمَالَ الْقِيمَةِ
u'كَمَالٌ قِيمَةٌ':Added, #2: 2	كَمَالُ قِيمَتِهِ
u'كَمَالٌ كِتَابَةٌ':Added, #6: 6	كَمَالُ الْقِيمَةِ
u'كَمَالٌ كَفَّارٌ':Added, #4: 4	كَمَالِ الْكِتَابَةِ
u'كَمَالٌ كَفَّارَةٌ':Added, #1: 1	كَمَالَ الْكَفَّارَةِ
u'كَمَالٌ كَلاَمٌ':Added, #1: 1	كَمَالَ الْكَفَّارَةِ
u'كَمَالٌ لَذَّةٌ':Added, #1: 1	كَمَالَ الْكَلَامِ
u'كَمَالٌ مَالٌ':Added, #1: 1	كَمَالِ اللَّذَّةِ
u'كَمَالٌ مالِك':Added, #1: 1	كَمَالُ مَالِهِ
u'كَمَالٌ مالِكِيّ':Added, #1: 1	كَمَالِ الْمَالِكِيَّةِ
u'كَمَالٌ مَأْمُورٌ':Added, #1: 1	كَمَالِ الْمَالِكِيَّةِ
u'كَمَالٌ مُتَابَعٌ':Added, #1: 1	كَمَالُ الْمَأْمُورِ
u'كَمَالٌ مُتَابَعٌ':Added, #1: 1	كَمَالَ الْمُتَابَعَةِ
u'كَمَالٌ مُتَابَعَةٌ':Added, #1: 1	كَمَالُ الْمُتَابَعَةِ
u'كَمَالٌ مُتَابَعَةٌ':Added, #1: 1	كَمَالَ الْمُتَابَعَةِ
u'كَمَالٌ مَجْهُولٌ':Added, #1: 1	كَمَالُ الْمُتَابَعَةِ
u'كَمَالٌ مَحْجُورٌ':Added, #1: 1	كَمَالٍ مَجْهُولٍ
u'كَمَالٌ مَحَلٌّ':Added, #1: 1	كَمَالِ الْمَحْجُورِ
u'كَمَالٌ مُدَّةٌ':Added, #1: 1	كَمَالِ الْمَحَلِّ
u'كَمَالٌ مُدَّةٌ':Added, #3: 3	كَمَالِ مُدَّةِ
u'كَمَالٌ مُرْتَدٌّ':Added, #5: 5	كَمَالَ مُدَّةِ
u'كَمَالٌ مُرُوءةٌ':Added, #2: 2	كَمَالِ الْمُرْتَدِّ
u'كَمَالٌ مَرِيضٌ':Added, #2: 2	كَمَالِ الْمُرُوءَةِ
u'كَمَالٌ مُشْتَرَكٌ':Added, #1: 1	كَمَالِ الْمَرِيضِ
u'كَمَالٌ مُضَارَبَةٌ':Added, #1: 1	كَمَالَ الْمُشْتَرَكِ
u'كَمَالٌ مَعْرِفَةٌ':Added, #6: 6	كَمَالِ الْمُضَارَبَةِ
u'كَمَالٌ مَعْرِفَة':Added, #1: 1	كَمَالِ مَعْرِفَةٍ
u'كَمَالٌ مَعْزُولٌ':Added, #1: 1	كَمَالِ مَعْرِفَةٍ
u'كَمَالٌ مَغْصُوب':Added, #1: 1	كَمَالٍ مَعْزُولٍ
u'كَمَالٌ مَفْقُودٌ':Added, #1: 1	كَمَالِ الْمَغْصُوبِ
u'كَمَالٌ مَفْقُودٌ':Added, #1: 1	كَمَالَ مَفْقُودٍ
u'كَمَالٌ مُفْلِسٌ':Added, #1: 1	كَمَالِ مَفْقُودٍ
u'كَمَالٌ مَقْصُودٌ':Added, #1: 1	كَمَالِ الْمُفْلِسِ
u'كَمَالٌ مِلَّةٌ':Added, #1: 1	كَمَالِ الْمَقْصُودِ
u'كَمَالٌ مِلَّةٌ':Added, #1: 1	كَمَالَ الْمِلَّةِ
u'كَمَالٌ مِلْكٌ':Added, #1: 1	كَمَالِ الْمِلَّةِ
u'كَمَالٌ مِلْكٌ':Added, #1: 1	كَمَالُ الْمِلْكِ
u'كَمَالٌ مِلْكٌ':Added, #1: 1	كَمَالِ مِلْكِهِ
u'كَمَالٌ مِلْكٌ':Added, #3: 3	كَمَالِ الْمِلْكِ
u'كَمَالٌ مِلْكٌ':Added, #4: 4	كَمَالِ مِلْكِ
u'كَمَالٌ مَنْفَعَةٌ':Added, #6: 6	كَمَالَ الْمِلْكِ
u'كَمَالٌ مَهْرٌ':Added, #1: 1	كَمَالِ الْمَنْفَعَةِ
u'كَمَالٌ مَهْرٌ':Added, #14: 14	كَمَالَ الْمَهْرِ
u'كَمَالٌ مَهْرٌ':Added, #1: 1	كَمَالِ مَهْرِ
u'كَمَالٌ مَهْرٌ':Added, #24: 24	كَمَالُ الْمَهْرِ
u'كَمَالٌ مَهْرٌ':Added, #6: 6	كَمَالُ مَهْرِ
u'كَمَالٌ مُوجِبٌ':Added, #8: 8	كَمَالِ الْمَهْرِ
u'كَمَالٌ مُؤَذِّنٌ':Added, #2: 2	كَمَالُ الْمُوجِبِ
u'كَمَالٌ نِسْبَةٌ':Added, #1: 1	كَمَالِ الْمُؤَذِّنِ
u'كَمَالٌ نصاب':Added, #1: 1	كَمَالِ النِّسْبَةِ
u'كَمَالٌ نِصَابٌ':Added, #16: 16	كَمَالُ النِّصَابِ
u'كَمَالٌ نصاب':Added, #16: 16	كَمَالُ النِّصَابِ
u'كَمَالٌ نِصَابٌ':Added, #36: 36	كَمَالِ النِّصَابِ
u'كَمَالٌ نصاب':Added, #36: 36	كَمَالِ النِّصَابِ
u'كَمَالٌ نِصَابٌ':Added, #9: 9	كَمَالَ النِّصَابِ
u'كَمَالٌ نَظَرٌ':Added, #9: 9	كَمَالَ النِّصَابِ
u'كَمَالٌ نَظَرٌ':Added, #1: 1	كَمَالُ النَّظَرِ
u'كَمَالٌ نعمة':Added, #1: 1	كَمَالِ النَّظَرِ
u'كَمَالٌ نِعْمَةٌ':Added, #1: 1	كَمَالِ النِّعْمَةِ
u'كَمَالٌ نعمة':Added, #1: 1	كَمَالِ النِّعْمَةِ
u'كَمَالٌ نِعْمَةٌ':Added, #1: 1	كَمَالِ نِعْمَتِهِ
u'كَمَالٌ نَفْسٌ':Added, #1: 1	كَمَالِ نِعْمَتِهِ
u'كَمَالٌ نَفَقَةٌ':Added, #1: 1	كَمَالُ النَّفْسِ
u'كَمَالٌ نَقْصٌ':Added, #1: 1	كَمَالُ النَّفَقَةِ
u'كَمَالٌ نَمَاءٌ':Added, #1: 1	كَمَالُ النَّقْصِ
u'كَمَالٌ نَوْمٌ':Added, #1: 1	كَمَالِ النَّمَاءِ
u'كَمَالٌ هَتْكٌ':Added, #1: 1	كَمَالُ نَوْمِهِ
u'كَمَالٌ هُدْنَةٌ':Added, #1: 1	كَمَالَ هَتْكِ
u'كَمَالٌ وَاجِبٌ':Added, #1: 1	كَمَالِ الْهُدْنَةِ
u'كَمَالٌ واحد':Added, #1: 1	كَمَالَ الْوَاجِبِ
u'كَمَالٌ وَاحِدٌ':Added, #2: 2	كَمَالِ الْوَاحِدِ
u'كَمَالٌ واحد':Added, #2: 2	كَمَالِ الْوَاحِدِ
u'كَمَالٌ وَاحِدٌ':Added, #4: 4	كَمَالٍ وَاحِدٍ
u'كَمَالٌ وَجْهٌ':Added, #4: 4	كَمَالٍ وَاحِدٍ
u'كَمَالٌ وُجُودٌ':Added, #1: 1	كَمَالِ الْوَجْهِ
u'كَمَالٌ وُجُودٌ':Added, #1: 1	كَمَالَ الْوُجُودِ
u'كَمَالٌ وُجُودٌ':Added, #1: 1	كَمَالِ الْوُجُودِ
u'كَمَالٌ وَحْيٌ':Added, #1: 1	كَمَالُ وُجُودِ
u'كَمَالٌ وَطْءٌ':Added, #1: 1	كَمَالِ الْوَحْيِ
u'كَمَالٌ وَظِيفٌ':Added, #1: 1	كَمَالَ الْوَطْءِ
u'كَمَالٌ وَظِيفَةٌ':Added, #1: 1	كَمَالَ الْوَظِيفَةِ
u'كَمَالٌ وَفَاءٌ':Added, #1: 1	كَمَالَ الْوَظِيفَةِ
u'كَمَالٌ وَقْتٌ':Added, #1: 1	كَمَالِ وَفَاءِ
u'كَمَالٌ وَقْتٌ':Added, #1: 1	كَمَالُ وَقْتٍ
u'كَمَالٌ وِلاَيَةٌ':Added, #3: 3	كَمَالِ الْوَقْتِ
u'كَمَالٌ وِلاَيَةٌ':Added, #1: 1	كَمَالَ الْوِلَايَةِ
u'كَمَالٌ وِلاَيَةٌ':Added, #1: 1	كَمَالِ وِلَايَةِ
u'كَمَالٌ وِلاَيَةٌ':Added, #1: 1	كَمَالِ وِلَايَتِهِ
u'كَمَالٌ ولد':Added, #2: 2	كَمَالِ الْوِلَايَةِ
u'كَمَالٌ وَلَدٌ':Added, #1: 1	كَمَالَ الْوَلَدِ
u'كَمَالٌ يَتِيمٌ':Added, #1: 1	كَمَالَ الْوَلَدِ
u'كَمَالٌ يَوْمٌ':Added, #3: 3	كَمَالِ الْيَتِيمِ
u'كَمَالٌ يَوْمٌ':Added, #1: 1	كَمَالِ الْيَوْمِ
u'كَمَدٌ مُظْلِمٌ':Added, #1: 1	كَمَالَ يَوْمٍ
u'كَمُلَ إِحْيَاءٌ':Subject, #1: 1	كَمَدٍ مُظْلِمٍ
u'كَمَّلَ إِرْثٌ':Predicate, #1: 1	كَمُلَ الْإِحْيَاءُ
u'كَمَّلَ أَرْكانٌ':Predicate, #1: 1	كَمَّلَ الْإِرْثَ
u'كَمَّلَ أَرْكَانٌ':Predicate, #1: 1	كَمَّلَ الْأَرْكَانَ
u'كَمُلَ اِمْتِزَاجٌ':Subject, #1: 1	كَمَّلَ الْأَرْكَانَ
u'كَمُلَ أَمَدٌ':Subject, #1: 1	كَمُلَ امْتِزَاجُهُ
u'كَمَّلَ أُمَّهَاتٌ':Subject, #1: 1	كَمُلَ أَمَدُ
u'كَمُلَ إيمَانٌ':Subject, #1: 1	كَمَّلَ أُمَّهَاتُهُ
u'كَمَّلَ باقِي':Predicate, #1: 1	كَمُلَ إيمَانُهُ
u'كَمُلَ تَدَاوُلٌ':Subject, #1: 1	كَمَّلَ الْبَاقِيَ
u'كَمَّلَ حَدٌّ':Predicate, #1: 1	كَمُلَ التَّدَاوُلُ
u'كَمُلَ حَدٌّ':Subject, #2: 2	كَمَّلَ حَدَّ
u'كَمَّلَ حَقٌّ':Predicate, #1: 1	كَمُلَ حَدُّهُ
u'كَمُلَ حَقٌّ':Subject, #1: 1	كَمَّلَ حَقَّ
u'كَمَّلَ حُمُولَةٌ':Predicate, #1: 1	كَمُلَ الْحَقُّ
u'كَمُلَ حَيَاءٌ':Subject, #1: 1	كَمَّلَ الْحُمُولَةَ
u'كَمَّلَ دِيَةٌ':Predicate, #1: 1	كَمُلَ حَيَاءُ
u'كَمُلَ دِينٌ':Subject, #1: 1	كَمَّلَ الدِّيَةَ
u'كَمُلَ دِينٌ':Subject, #1: 1	كَمُلَ دِينُهُ
u'كَمَّلَ سَبْعٌ':Predicate, #2: 2	كَمُلَ الدِّينُ
u'كَمَّلَ سقط':Subject, #1: 1	كَمَّلَ سَبْعَ
u'كَمَّلَ سِقْطٌ':Subject, #1: 1	كَمَّلَ السِّقْطُ
u'كَمُلَ سَقْيٌ':Subject, #1: 1	كَمَّلَ السِّقْطُ
u'كَمُلَ شَرَائِطُ':Subject, #1: 1	كَمُلَ سَقْيُ
u'كَمُلَ شَرْطٌ':Subject, #1: 1	كَمُلَ شَرَائِطُ
u'كَمُلَ صَبِيٌّ':Subject, #1: 1	كَمُلَ الشَّرْطُ
u'كَمَّلَ صداق':Predicate, #1: 1	كَمُلَ الصَّبِيُّ
u'كَمَّلَ صَدَاقٌ':Predicate, #1: 1	كَمَّلَ الصَّدَاقَ
u'كَمُلَ صداق':Subject, #1: 1	كَمَّلَ الصَّدَاقَ
u'كَمُلَ صَدَاقٌ':Subject, #1: 1	كَمُلَ الصَّدَاقُ
u'كَمَّلَ صَلاَةٌ':Predicate, #1: 1	كَمُلَ الصَّدَاقُ
u'كَمُلَ عَامٌ':Subject, #1: 1	كَمَّلَ الصَّلَاةَ
u'كَمُلَ عتق':Subject, #1: 1	كَمُلَ الْعَامُ
u'كَمُلَ عِتْقٌ':Subject, #1: 1	كَمُلَ الْعِتْقُ
u'كَمُلَ عَقْلٌ':Subject, #1: 1	كَمُلَ الْعِتْقُ
u'كَمُلَ غَرَضٌ':Subject, #3: 3	كَمُلَ عَقْلُهُ
u'كَمُلَ قَالٌ':Predicate, #1: 1	كَمُلَ الْغَرَضُ
u'كَمُلَ قول':Subject, #1: 1	كَمُلَ قَالَ
u'كَمُلَ قَوْلٌ':Subject, #1: 1	كَمُلَ قَوْلُهُ
u'كَمُلَ قِيمَةٌ':Subject, #1: 1	كَمُلَ قَوْلُهُ
u'كَمَّلَ مُحْرِمٌ':Subject, #1: 1	كَمُلَ قِيمَتُهُ
u'كَمُلَ مُقَدَّرٌ':Subject, #1: 1	كَمَّلَ الْمُحْرِمُ
u'كَمُلَ مُقَرَّرٌ':Subject, #1: 1	كَمُلَ الْمُقَدَّرُ
u'كَمُلَ مِلْكٌ':Subject, #1: 1	كَمُلَ الْمُقَرَّرُ
u'كَمُلَ نبات':Subject, #1: 1	كَمُلَ مِلْكُ
u'كَمُلَ نَبَاتٌ':Subject, #1: 1	كَمُلَ نَبَاتُهُ
u'كَمَّلَ نصاب':Predicate, #1: 1	كَمُلَ نَبَاتُهُ
u'كَمَّلَ نِصَابٌ':Predicate, #3: 3	كَمَّلَ النِّصَابَ
u'كَمُلَ نصاب':Subject, #3: 3	كَمَّلَ النِّصَابَ
u'كَمُلَ نِصَابٌ':Subject, #11: 11	كَمُلَ النِّصَابُ
u'كَمُلَ نصاب':Subject, #11: 11	كَمُلَ النِّصَابُ
u'كَمُلَ نِصَابٌ':Subject, #1: 1	كَمُلَ نِصَابُهُ
u'كَمُلَ نِصْفٌ':Subject, #1: 1	كَمُلَ نِصَابُهُ
u'كَمُلَ وُجُودٌ':Subject, #1: 1	كَمُلَ نِصْفُ
u'كَمَّلَ وُضُوءٌ':Predicate, #1: 1	كَمُلَ وُجُودُهُ
u'كَمُلَ ولد':Subject, #1: 1	كَمَّلَ الْوُضُوءَ
u'كَمُلَ وَلَدٌ':Subject, #1: 1	كَمُلَ الْوَلَدُ
u'كَمَنَ جَوَاهِرُ':Predicate, #1: 1	كَمُلَ الْوَلَدُ
u'كَمَنَ كَلْبٌ':Subject, #1: 1	كَمَنَ جَوَاهِرَ
u'كِنَايَةٌ بَيْعٌ':Added, #1: 1	كَمَنَ الْكَلْبُ
u'كِنَايَةٌ بَيْعٌ':Added, #1: 1	كِنَايَةِ الْبَيْعِ
u'كِنَايَةٌ تَمْلِيكٌ':Added, #1: 1	كِنَايَةَ بَيْعٍ
u'كِنَايَةٌ طَلاَقٌ':Added, #1: 1	كِنَايَةُ تَمْلِيكٍ
u'كِنَايَةٌ طَلاَقٌ':Added, #1: 1	كِنَايَةُ الطَّلَاقِ
u'كِنَايَةٌ طَلاَقٌ':Added, #2: 2	كِنَايَةَ طَلَاقٍ
u'كِنَايَةٌ طَلاَقٌ':Added, #2: 2	كِنَايَةُ طَلَاقٍ
u'كِنَايَةٌ ظاهِرٌ':Added, #3: 3	كِنَايَةِ الطَّلَاقِ
u'كِنَايَةٌ ظاهِرَة':Added, #1: 1	كِنَايَةٍ ظَاهِرَةٍ
u'كِنَايَةٌ ظهار':Added, #1: 1	كِنَايَةٍ ظَاهِرَةٍ
u'كِنَايَةٌ قول':Added, #1: 1	كِنَايَةَ ظِهَارٍ
u'كِنَايَةٌ قَوْلٌ':Added, #1: 1	كِنَايَةَ قَوْلِهِ
u'كِنَايَةٌ مُفْتَقِرٌ':Added, #1: 1	كِنَايَةَ قَوْلِهِ
u'كِنَايَةٌ هِبَةٌ':Added, #1: 1	كِنَايَةٍ مُفْتَقِرَةٍ
u'كِنَايَةٌ هِبَةٌ':Added, #1: 1	كِنَايَةِ هِبَةٍ
u'كِنَايَةٌ وَجْهٌ':Added, #2: 2	كِنَايَةُ هِبَةٍ
u'كِنَايَةٌ وَصِيٌّ':Added, #1: 1	كِنَايَةُ وَجْهٍ
u'كِنَايَةٌ وَصِيٌّ':Added, #1: 1	كِنَايَةَ وَصِيَّةٍ
u'كِنَايَةٌ وَصِيَّةٌ':Added, #1: 1	كِنَايَةُ وَصِيَّةٍ
u'كِنَايَةٌ وَصِيَّةٌ':Added, #1: 1	كِنَايَةَ وَصِيَّةٍ
u'كَنْزٌ اِبْنٌ':Added, #1: 1	كِنَايَةُ وَصِيَّةٍ
u'كَنْزٌ جَنَّةٌ':Added, #1: 1	كَنْزِ ابْنِ
u'كَنْزٌ دقائق':Added, #3: 3	كَنْزِ الْجَنَّةِ
u'كَنْزٌ دَقائِقُ':Added, #1: 1	كَنْزَ الدَّقَائِقِ
u'كَنْزٌ دقائق':Added, #1: 1	كَنْزَ الدَّقَائِقِ
u'كَنْزٌ دَقائِقُ':Added, #6: 6	كَنْزِ الدَّقَائِقِ
u'كَنْزٌ ذَهَبٌ':Added, #6: 6	كَنْزِ الدَّقَائِقِ
u'كَنْزٌ كعبة':Added, #1: 1	كَنْزِ الذَّهَبِ
u'كَنْزٌ كَعْبَةٌ':Added, #1: 1	كَنْزِ الْكَعْبَةِ
u'كَنْزٌ كعبة':Added, #1: 1	كَنْزِ الْكَعْبَةِ
u'كَنْزٌ كَعْبَةٌ':Added, #5: 5	كَنْزَ الْكَعْبَةِ
u'كَنَزَ مَالٌ':Predicate, #5: 5	كَنْزَ الْكَعْبَةِ
u'كَنَزَ مَالٌ':Predicate, #1: 1	كَنَزَ الْمَالَ
u'كَنْزٌ مَدْفُونٌ':Added, #1: 1	كَنَزَ مَالَ
u'كَنَسَ طَرِيقٌ':Predicate, #1: 1	كَنْزٍ مَدْفُونٍ
u'كَنَسَ ظَبْيٌ':Subject, #2: 2	كَنَسَ الطَّرِيقَ
u'كَنَسَ مُسْتَأْجِرٌ':Subject, #1: 1	كَنَسَ الظَّبْيُ
u'كَنْفٌ ذُنُوبٌ':Added, #1: 1	كَنَسَ الْمُسْتَأْجِرُ
u'كُنُوزٌ أَرْزَاقٌ':Added, #1: 1	كَنْفِ الذُّنُوبِ
u'كُنُوزٌ أرْضٌ':Added, #1: 1	كُنُوزُ الْأَرْزَاقِ
u'كُنُوزٌ جَنَّةٌ':Added, #1: 1	كُنُوزِ الْأَرْضِ
u'كُنُوزٌ علم':Added, #5: 5	كُنُوزِ الْجَنَّةِ
u'كُنُوزٌ عِلْمٌ':Added, #1: 1	كُنُوزِ الْعِلْمِ
u'كَنَّى إمَامٌ':Subject, #1: 1	كُنُوزِ الْعِلْمِ
u'كُنْيَةٌ تَخْصِيصٌ':Added, #1: 1	كَنَّى الْإِمَامُ
u'كُنْيَةٌ مُسْلِمٌ':Added, #1: 1	كُنْيَةَ التَّخْصِيصِ
u'كُنْيَةٌ نَبِيٌّ':Added, #1: 1	كُنْيَةَ مُسْلِمٍ
u'كَنَّى رَسُولٌ':Subject, #1: 1	كُنْيَةِ النَّبِيِّ
u'كَنَّى غير':Subject, #1: 1	كَنَّى رَسُولُ
u'كَنَّى غَيْرٌ':Subject, #1: 1	كَنَّى غَيْرُ
u'كَنَّى كِنَايَةٌ':Predicate, #1: 1	كَنَّى غَيْرُ
u'كَنَّى مُحَمَّدٌ':Predicate, #1: 1	كَنَّى الْكِنَايَةَ
u'كَنَّى نَبِيٌّ':Subject, #1: 1	كَنَّى مُحَمَّدَ
u'كَوْرٌ بَعيرٌ':Added, #2: 2	كَنَّى النَّبِيُّ
u'كَوْرٌ حَدَّادٌ':Added, #1: 1	كَوْرِ الْبَعِيرِ
u'كَوْرٌ عِمَامَةٌ':Added, #2: 2	كَوْرُ الْحَدَّادِ
u'كَوْرٌ عِمَامَةٌ':Added, #1: 1	كَوْرَ الْعِمَامَةِ
u'كَوْرٌ عِمَامَةٌ':Added, #9: 9	كَوْرِ الْعِمَامَةِ
u'كَوْنٌ أَبٌ':Added, #9: 9	كَوْرِ عِمَامَتِهِ
u'كَوْنٌ أَبٌ':Added, #1: 1	كَوْنِ الْأَبِ
u'كَوْنٌ إبَاحَةٌ':Added, #3: 3	كَوْنُ الْأَبِ
u'كَوْنٌ اِبْتِداءٌ':Added, #1: 1	كَوْنِ الْإِبَاحَةِ
u'كَوْنٌ إِبِلٌ':Added, #1: 1	كَوْنَ ابْتِدَاءِ
u'كَوْنٌ اِبْنَة':Added, #1: 1	كَوْنِ الْإِبِلِ
u'كَوْنٌ اِتِّصَالٌ':Added, #1: 1	كَوْنِ ابْنَةِ
u'كَوْنٌ إِتْلاَفٌ':Added, #1: 1	كَوْنِ اتِّصَالِهِ
u'كَوْنٌ إِتْلاَفٌ':Added, #1: 1	كَوْنُ إتْلَافِهِ
u'كَوْنٌ إِتْلاَفٌ':Added, #1: 1	كَوْنَ الْإِتْلَافِ
u'كَوْنٌ إِثْمٌ':Added, #1: 1	كَوْنُ الْإِتْلَافِ
u'كَوْنٌ أَثْوابٌ':Added, #1: 1	كَوْنُ الْإِثْمِ
u'كَوْنٌ اِجْتِمَاعٌ':Added, #1: 1	كَوْنُ الْأَثْوَابِ
u'كَوْنٌ آجُرٌّ':Added, #1: 1	كَوْنُ اجْتِمَاعِ
u'كَوْنٌ أُجْرَةٌ':Added, #1: 1	كَوْنِ الْآجُرِّ
u'كَوْنٌ أُجْرَةٌ':Added, #1: 1	كَوْنِ الْأُجْرَةِ
u'كَوْنٌ أَجْزَاءٌ':Added, #4: 4	كَوْنُ الْأُجْرَةِ
u'كَوْنٌ أَجْزَاءٌ':Added, #1: 1	كَوْنُ أَجْزَاءِ
u'كَوْنٌ إِجْمَاعٌ':Added, #2: 2	كَوْنُ الْأَجْزَاءِ
u'كَوْنٌ إِجْمَاعٌ':Added, #1: 1	كَوْنَ الْإِجْمَاعِ
u'كَوْنٌ إِجْمَاعٌ':Added, #7: 7	كَوْنُ الْإِجْمَاعِ
u'كَوْنٌ أَجْنَبِيٌّ':Added, #8: 8	كَوْنِ الْإِجْمَاعِ
u'كَوْنٌ أَجِيرٌ':Added, #2: 2	كَوْنِ الْأَجْنَبِيِّ
u'كَوْنٌ أَجِيرٌ':Added, #1: 1	كَوْنُ الْأَجِيرِ
u'كَوْنٌ إحَاطَةٌ':Added, #2: 2	كَوْنَ الْأَجِيرِ
u'كَوْنٌ أَحْباسٌ':Added, #1: 1	كَوْنِ إحَاطَتِهِ
u'كَوْنٌ اِحْتِمَالٌ':Added, #1: 1	كَوْنِ الْأَحْبَاسِ
u'كَوْنٌ أحَدٌ':Added, #1: 1	كَوْنِ احْتِمَالِهِ
u'كَوْنٌ أحَدٌ':Added, #1: 1	كَوْنَ أَحَدِ
u'كَوْنٌ أحَدٌ':Added, #2: 2	كَوْنِ أَحَدِ
u'كَوْنٌ إِحْرَامٌ':Added, #3: 3	كَوْنُ أَحَدِ
u'كَوْنٌ أَحْكَامٌ':Added, #1: 1	كَوْنِ إحْرَامِهِ
u'كَوْنٌ أَحْكَامٌ':Added, #1: 1	كَوْنُ الْأَحْكَامِ
u'كَوْنٌ أَحْوالٌ':Added, #1: 1	كَوْنِ الْأَحْكَامِ
u'كَوْنٌ أحْوَالٌ':Added, #1: 1	كَوْنِ أَحْوَالِ
u'كَوْنٌ إِحْيَاءٌ':Added, #1: 1	كَوْنِ أَحْوَالِ
u'كَوْنٌ إِخْبَارٌ':Added, #1: 1	كَوْنُ الْإِحْيَاءِ
u'كَوْنٌ اِخْتِلاطٌ':Added, #1: 1	كَوْنُ الْإِخْبَارِ
u'كَوْنٌ اِخْتِلاَفٌ':Added, #2: 2	كَوْنُ اخْتِلَاطِ
u'كَوْنٌ اِخْتِلاَفٌ':Added, #1: 1	كَوْنَ اخْتِلَافِ
u'كَوْنٌ أخْذٌ':Added, #1: 1	كَوْنِ اخْتِلَافِ
u'كَوْنٌ إِخْرَاجٌ':Added, #1: 1	كَوْنِ الْأَخْذِ
u'كَوْنٌ إِخْرَاجٌ':Added, #1: 1	كَوْنَ الْإِخْرَاجِ
u'كَوْنٌ أخرَس':Added, #1: 1	كَوْنُ الْإِخْرَاجِ
u'كَوْنٌ أَدَاءٌ':Added, #1: 1	كَوْنِ الْأَخْرَسِ
u'كَوْنٌ أَدَاءٌ':Added, #1: 1	كَوْنَ الْأَدَاءِ
u'كَوْنٌ أَذَانٌ':Added, #2: 2	كَوْنُ الْأَدَاءِ
u'كَوْنٌ أَذَانٌ':Added, #1: 1	كَوْنِ أَذَانِهِ
u'كَوْنٌ إِرَادَةٌ':Added, #1: 1	كَوْنُ الْأَذَانِ
u'كَوْنٌ أَرْبَعُ':Added, #1: 1	كَوْنِ الْإِرَادَةِ
u'كَوْنٌ أَرْبَعُ':Added, #1: 1	كَوْنَ الْأَرْبَعِ
u'كَوْنٌ إِرْثٌ':Added, #1: 1	كَوْنِ الْأَرْبَعِ
u'كَوْنٌ إِرْسَالٌ':Added, #1: 1	كَوْنِ إرْثِهِ
u'كَوْنٌ أرْضٌ':Added, #1: 1	كَوْنِ الْإِرْسَالِ
u'كَوْنٌ أرْضٌ':Added, #1: 1	كَوْنُ أَرْضِهِ
u'كَوْنٌ أرْضٌ':Added, #1: 1	كَوْنِ أَرْضِهِ
u'كَوْنٌ أرْضٌ':Added, #1: 1	كَوْنَ الْأَرْضِ
u'كَوْنٌ أرْضٌ':Added, #1: 1	كَوْنِ الْأَرْضِ
u'كَوْنٌ أَرْطالٌ':Added, #3: 3	كَوْنُ الْأَرْضِ
u'كَوْنٌ اِسْتِثْنَاءٌ':Added, #1: 1	كَوْنِ الْأَرْطَالِ
u'كَوْنٌ اِسْتِعْمالٌ':Added, #1: 1	كَوْنَ اسْتِثْنَاءِ
u'كَوْنٌ اِسْتِعْمالٌ':Added, #1: 1	كَوْنِ اسْتِعْمَالِ
u'كَوْنٌ اِسْتِغْرَاقٌ':Added, #1: 1	كَوْنِ اسْتِعْمَالِهِ
u'كَوْنٌ اِسْتِغْرَاقٌ':Added, #1: 1	كَوْنَ اسْتِغْرَاقِ
u'كَوْنٌ اِسْتِغْرَاقٌ':Added, #1: 1	كَوْنُ اسْتِغْرَاقِ
u'كَوْنٌ إِسْراءٌ':Added, #1: 1	كَوْنِ اسْتِغْرَاقِ
u'كَوْنٌ إِسْفارٌ':Added, #1: 1	كَوْنَ الْإِسْرَاءِ
u'كَوْنٌ إِسْكارٌ':Added, #1: 1	كَوْنِ الْإِسْفَارِ
u'كَوْنٌ إِسْلامٌ':Added, #1: 1	كَوْنُ الْإِسْكَارِ
u'كَوْنٌ إِسْلامٌ':Added, #1: 1	كَوْنَ إسْلَامِهِ
u'كَوْنٌ إِسْلامٌ':Added, #1: 1	كَوْنُ الْإِسْلَامِ
u'كَوْنٌ اِسْمٌ':Added, #1: 1	كَوْنِ الْإِسْلَامِ
u'كَوْنٌ اِسْمٌ':Added, #1: 1	كَوْنَ اسْمِهِ
u'كَوْنٌ أَسْماءٌ':Added, #1: 1	كَوْنُ اسْمِهِ
u'كَوْنٌ إِسْنادٌ':Added, #1: 1	كَوْنُ الْأَسْمَاءِ
u'كَوْنٌ إِسْنادٌ':Added, #1: 1	كَوْنُ الْإِسْنَادِ
u'كَوْنٌ أسْوَد':Added, #5: 5	كَوْنِ الْإِسْنَادِ
u'كَوْنٌ أَصالَةٌ':Added, #1: 1	كَوْنِ الْأَسْوَدِ
u'كَوْنٌ أَصْحَابٌ':Added, #2: 2	كَوْنِ الْأَصَالَةِ
u'كَوْنٌ أصل':Added, #1: 1	كَوْنُ الْأَصْحَابِ
u'كَوْنٌ أًصْلٌ':Added, #11: 11	كَوْنِ الْأَصْلِ
u'كَوْنٌ أصل':Added, #11: 11	كَوْنِ الْأَصْلِ
u'كَوْنٌ أصل':Added, #1: 1	كَوْنَ أَصْلِ
u'كَوْنٌ أًصْلٌ':Added, #1: 1	كَوْنِ أَصْلِ
u'كَوْنٌ أًصْلٌ':Added, #1: 1	كَوْنَ أَصْلِ
u'كَوْنٌ أصل':Added, #1: 1	كَوْنِ أَصْلِ
u'كَوْنٌ أًصْلٌ':Added, #1: 1	كَوْنِ أَصْلِهِ
u'كَوْنٌ أصل':Added, #1: 1	كَوْنِ أَصْلِهِ
u'كَوْنٌ أًصْلٌ':Added, #4: 4	كَوْنَ الْأَصْلِ
u'كَوْنٌ أصل':Added, #4: 4	كَوْنَ الْأَصْلِ
u'كَوْنٌ أًصْلٌ':Added, #9: 9	كَوْنُ الْأَصْلِ
u'كَوْنٌ إضافَةٌ':Added, #9: 9	كَوْنُ الْأَصْلِ
u'كَوْنٌ إضافَةٌ':Added, #1: 1	كَوْنِ إضَافَةِ
u'كَوْنٌ إِطْعامٌ':Added, #1: 1	كَوْنِ الْإِضَافَةِ
u'كَوْنٌ إِطْلاقٌ':Added, #1: 1	كَوْنِ الْإِطْعَامِ
u'كَوْنٌ إِطْلاقٌ':Added, #1: 1	كَوْنَ إطْلَاقِ
u'كَوْنٌ إِطْلاقٌ':Added, #1: 1	كَوْنَ إطْلَاقِهِ
u'كَوْنٌ إِطْلاقٌ':Added, #1: 1	كَوْنُ إطْلَاقِهِ
u'كَوْنٌ إِطْلاقٌ':Added, #1: 1	كَوْنُ الْإِطْلَاقِ
u'كَوْنٌ إِطْلاقٌ':Added, #2: 2	كَوْنُ إطْلَاقِ
u'كَوْنٌ أظهر':Added, #4: 4	كَوْنِ الْإِطْلَاقِ
u'كَوْنٌ إِعادَةٌ':Added, #1: 1	كَوْنُ أَظْهَرِ
u'كَوْنٌ إِعارَةٌ':Added, #1: 1	كَوْنِ الْإِعَادَةِ
u'كَوْنٌ إِعارَةٌ':Added, #1: 1	كَوْنُ الْإِعَارَةِ
u'كَوْنٌ إِعْتاقٌ':Added, #1: 1	كَوْنِ الْإِعَارَةِ
u'كَوْنٌ اِعْتِراضٌ':Added, #1: 1	كَوْنَ الْإِعْتَاقِ
u'كَوْنٌ اِعْتِكافٌ':Added, #1: 1	كَوْنِ اعْتِرَاضِهِ
u'كَوْنٌ إعْطَاءٌ':Added, #1: 1	كَوْنُ اعْتِكَافِهِ
u'كَوْنٌ إِعْلاءٌ':Added, #1: 1	كَوْنُ الْإِعْطَاءِ
u'كَوْنٌ أَعَمُّ':Added, #1: 1	كَوْنُ إعْلَاءِ
u'كَوْنٌ أَعَمُّ':Added, #1: 1	كَوْنَ الْأَعَمِّ
u'كَوْنٌ أَعْمَالٌ':Added, #1: 1	كَوْنُ الْأَعَمِّ
u'كَوْنٌ إِفَاضَةٌ':Added, #1: 1	كَوْنِ الْأَعْمَالِ
u'كَوْنٌ إِفْرَادٌ':Added, #1: 1	كَوْنِ إفَاضَةِ
u'كَوْنٌ إِفْرَادٌ':Added, #1: 1	كَوْنُ إِفْرَادِ
u'كَوْنٌ أفْضَلُ':Added, #1: 1	كَوْنِ الْإِفْرَادِ
u'كَوْنٌ أفْضَلُ':Added, #2: 2	كَوْنَ الْأَفْضَلِ
u'كَوْنٌ إقالَةٌ':Added, #4: 4	كَوْنِ الْأَفْضَلِ
u'كَوْنٌ إقالَةٌ':Added, #1: 1	كَوْنَ الْإِقَالَةِ
u'كَوْنٌ إقْرَارٌ':Added, #1: 1	كَوْنِ الْإِقَالَةِ
u'كَوْنٌ إقْرَارٌ':Added, #1: 1	كَوْنُ الْإِقْرَارِ
u'كَوْنٌ أقَلُّ':Added, #2: 2	كَوْنِ الْإِقْرَارِ
u'كَوْنٌ أقَلُّ':Added, #1: 1	كَوْنَ أَقَلِّ
u'كَوْنٌ أقَلُّ':Added, #1: 1	كَوْنُ أَقَلِّ
u'كَوْنٌ أقَلُّ':Added, #1: 1	كَوْنِ أَقَلِّهِ
u'كَوْنٌ أقَلُّ':Added, #2: 2	كَوْنُ الْأَقَلِّ
u'كَوْنٌ أقَلُّ':Added, #2: 2	كَوْنِ الْأَقَلِّ
u'كَوْنٌ أَقْوَالٌ':Added, #3: 3	كَوْنِ أَقَلِّ
u'كَوْنٌ أَكْثَرُ':Added, #1: 1	كَوْنُ الْأَقْوَالِ
u'كَوْنٌ أَكْثَرُ':Added, #1: 1	كَوْنِ أَكْثَرِهِ
u'كَوْنٌ أَكْثَرُ':Added, #3: 3	كَوْنُ أَكْثَرِ
u'كَوْنٌ إكْرَاهٌ':Added, #3: 3	كَوْنِ أَكْثَرِ
u'كَوْنٌ أكل':Added, #1: 1	كَوْنِ الْإِكْرَاهِ
u'كَوْنٌ أَكْلٌ':Added, #1: 1	كَوْنُ أَكْلِهِ
u'كَوْنٌ أكل':Added, #1: 1	كَوْنُ أَكْلِهِ
u'كَوْنٌ أَكْلٌ':Added, #1: 1	كَوْنُ الْأَكْلِ
u'كَوْنٌ آلةٌ':Added, #1: 1	كَوْنُ الْأَكْلِ
u'كَوْنٌ إلْحَاحٌ':Added, #1: 1	كَوْنِ آلَةِ
u'كَوْنٌ إِلْزَامٌ':Added, #1: 1	كَوْنَ الْإِلْحَاحِ
u'كَوْنٌ ألف':Added, #1: 1	كَوْنَ الْإِلْزَامِ
u'كَوْنٌ ألف':Added, #1: 1	كَوْنَ الْأَلْفِ
u'كَوْنٌ ألْفٌ':Added, #1: 1	كَوْنِ الْأَلِفِ
u'كَوْنٌ أَلْفٌ':Added, #1: 1	كَوْنَ الْأَلْفِ
u'كَوْنٌ ألف':Added, #1: 1	كَوْنَ الْأَلْفِ
u'كَوْنٌ ألْفٌ':Added, #2: 2	كَوْنُ الْأَلْفِ
u'كَوْنٌ أَلْفٌ':Added, #2: 2	كَوْنُ الْأَلْفِ
u'كَوْنٌ أَلْفَاظٌ':Added, #2: 2	كَوْنُ الْأَلْفِ
u'كَوْنٌ الْمَرْأَةُ':Added, #1: 1	كَوْنِ الْأَلْفَاظِ
u'كَوْنٌ الْمَرْأَةُ':Added, #3: 3	كَوْنَ الْمَرْأَةِ
u'كَوْنٌ الْمَرْأَةُ':Added, #4: 4	كَوْنُ الْمَرْأَةِ
u'كَوْنٌ أَمَاكِنُ':Added, #4: 4	كَوْنِ الْمَرْأَةِ
u'كَوْنٌ إمَامٌ':Added, #1: 1	كَوْنِ الْأَمَاكِنِ
u'كَوْنٌ إمَامٌ':Added, #3: 3	كَوْنَ الْإِمَامِ
u'كَوْنٌ إمَامٌ':Added, #6: 6	كَوْنِ الْإِمَامِ
u'كَوْنٌ إمَامَةٌ':Added, #7: 7	كَوْنُ الْإِمَامِ
u'كَوْنٌ أمَةٌ':Added, #1: 1	كَوْنُ الْإِمَامَةِ
u'كَوْنٌ أمَةٌ':Added, #1: 1	كَوْنَ الْأَمَةِ
u'كَوْنٌ أمَةٌ':Added, #1: 1	كَوْنِ الْأَمَةِ
u'كَوْنٌ أَمَدٌ':Added, #2: 2	كَوْنُ الْأَمَةِ
u'كَوْنٌ آمِرٌ':Added, #1: 1	كَوْنُ أَمَدِهِ
u'كَوْنٌ أَمْرٌ':Added, #1: 1	كَوْنِ الْآمِرِ
u'كَوْنٌ أَمْرٌ':Added, #1: 1	كَوْنِ أَمْرِ
u'كَوْنٌ أَمْرٌ':Added, #4: 4	كَوْنُ الْأَمْرِ
u'كَوْنٌ أَمْرٌ':Added, #5: 5	كَوْنَ الْأَمْرِ
u'كَوْنٌ اِمْرَأَةٌ':Added, #9: 9	كَوْنِ الْأَمْرِ
u'كَوْنٌ إِمْساكٌ':Added, #1: 1	كَوْنِ امْرَأَتِهِ
u'كَوْنٌ إِمْكانٌ':Added, #1: 1	كَوْنُ الْإِمْسَاكِ
u'كَوْنٌ إِمْكانٌ':Added, #1: 1	كَوْنَ إمْكَانِ
u'كَوْنٌ أَمْلاكٌ':Added, #2: 2	كَوْنَ الْإِمْكَانِ
u'كَوْنٌ أَمْلاَكٌ':Added, #1: 1	كَوْنُ الْأَمْلَاكِ
u'كَوْنٌ أَمْوَالٌ':Added, #1: 1	كَوْنُ الْأَمْلَاكِ
u'كَوْنٌ إِناءٌ':Added, #1: 1	كَوْنِ الْأَمْوَالِ
u'كَوْنٌ إِناءٌ':Added, #1: 1	كَوْنُ الْإِنَاءِ
u'كَوْنٌ إِنْسانٌ':Added, #1: 1	كَوْنِ إنَاءِ
u'كَوْنٌ إِنْسانٌ':Added, #1: 1	كَوْنَ الْإِنْسَانِ
u'كَوْنٌ إِنْسانٌ':Added, #1: 1	كَوْنُ الْإِنْسَانِ
u'كَوْنٌ إِنْشادٌ':Added, #1: 1	كَوْنِ الْإِنْسَانِ
u'كَوْنٌ اِنْعِقَادٌ':Added, #1: 1	كَوْنِ الْإِنْشَادِ
u'كَوْنٌ أَنْفُسٌ':Added, #2: 2	كَوْنَ انْعِقَادِ
u'كَوْنٌ اِنْفِساخٌ':Added, #1: 1	كَوْنِ الْأَنْفُسِ
u'كَوْنٌ إِنْكارٌ':Added, #1: 1	كَوْنُ انْفِسَاخِ
u'كَوْنٌ أهْلٌ':Added, #1: 1	كَوْنِ إنْكَارِ
u'كَوْنٌ أهْلٌ':Added, #1: 1	كَوْنُ أَهْلِ
u'كَوْنٌ أهْلٌ':Added, #1: 1	كَوْنُ أَهْلِهِ
u'كَوْنٌ أوْجَهُ':Added, #2: 2	كَوْنِ أَهْلِ
u'كَوْنٌ أَوْجُهٌ':Added, #1: 1	كَوْنَ الْأَوْجَهِ
u'كَوْنٌ أوْسَطُ':Added, #1: 1	كَوْنِ الْأَوْجُهِ
u'كَوْنٌ أَوْقَاتٌ':Added, #1: 1	كَوْنُ الْأَوْسَطِ
u'كَوْنٌ أَوَّلُ':Added, #1: 1	كَوْنَ الْأَوْقَاتِ
u'كَوْنٌ أَوَّلُ':Added, #1: 1	كَوْنَ أَوَّلِ
u'كَوْنٌ أَوَّلُ':Added, #4: 4	كَوْنُ الْأَوَّلِ
u'كَوْنٌ أَوْلاَدٌ':Added, #5: 5	كَوْنِ الْأَوَّلِ
u'كَوْنٌ آيَةٌ':Added, #1: 1	كَوْنَ الْأَوْلَادِ
u'كَوْنٌ إيمَانٌ':Added, #3: 3	كَوْنِ الْآيَةِ
u'كَوْنٌ أَيْمَانٌ':Added, #1: 1	كَوْنَ الْإِيمَانِ
u'كَوْنٌ باء':Added, #3: 3	كَوْنِ الْأَيْمَانِ
u'كَوْنٌ باقَةٌ':Added, #1: 1	كَوْنُ الْبَاءِ
u'كَوْنٌ باقِي':Added, #1: 1	كَوْنِ بَاقِيهِ
u'كَوْنٌ بَائِعٌ':Added, #1: 1	كَوْنِ بَاقِيهِ
u'كَوْنٌ بَائِعٌ':Added, #1: 1	كَوْنُ الْبَائِعِ
u'كَوْنٌ بَائِنٌ':Added, #2: 2	كَوْنِ الْبَائِعِ
u'كَوْنٌ بَائِنٌ':Added, #1: 1	كَوْنُ الْبَائِنِ
u'كَوْنٌ بَحْرٌ':Added, #1: 1	كَوْنَ بَائِنٍ
u'كَوْنٌ بِدَايَةٌ':Added, #1: 1	كَوْنِ الْبَحْرِ
u'كَوْنٌ بِدْعَةٌ':Added, #1: 1	كَوْنُ الْبِدَايَةِ
u'كَوْنٌ بِدْعَةٌ':Added, #1: 1	كَوْنُ الْبِدْعَةِ
u'كَوْنٌ بَدَلٌ':Added, #2: 2	كَوْنِ الْبِدْعَةِ
u'كَوْنٌ بَدَلٌ':Added, #1: 1	كَوْنُ الْبَدَلِ
u'كَوْنٌ بَدَلٌ':Added, #1: 1	كَوْنِ الْبَدَلِ
u'كَوْنٌ بَذْرٌ':Added, #1: 1	كَوْنِ بَدَلِهِ
u'كَوْنٌ بَراءةٌ':Added, #3: 3	كَوْنُ الْبَذْرِ
u'كَوْنٌ بَرِّيٌّ':Added, #2: 2	كَوْنِ الْبَرَاءَةِ
u'كَوْنٌ بَرِّيَّةٌ':Added, #1: 1	كَوْنَ الْبَرِّيَّةِ
u'كَوْنٌ بُسْتانٌ':Added, #1: 1	كَوْنَ الْبَرِّيَّةِ
u'كَوْنٌ بَعْثٌ':Added, #1: 1	كَوْنِ الْبُسْتَانِ
u'كَوْنٌ بَعْضٌ':Added, #1: 1	كَوْنِ الْبَعْثِ
u'كَوْنٌ بَعْضٌ':Added, #1: 1	كَوْنُ الْبَعْضِ
u'كَوْنٌ بَعْضٌ':Added, #2: 2	كَوْنِ الْبَعْضِ
u'كَوْنٌ بَعْضٌ':Added, #2: 2	كَوْنُ بَعْضِ
u'كَوْنٌ بَعْضٌ':Added, #2: 2	كَوْنِ بَعْضِ
u'كَوْنٌ بَعْضٌ':Added, #3: 3	كَوْنَ بَعْضِ
u'كَوْنٌ بَقاءٌ':Added, #3: 3	كَوْنُ بَعْضِهِ
u'كَوْنٌ بَقاءٌ':Added, #1: 1	كَوْنَ الْبَقَاءِ
u'كَوْنٌ بُقْعَةٌ':Added, #1: 1	كَوْنُ بَقَاءِ
u'كَوْنٌ بِكْرٌ':Added, #1: 1	كَوْنَ الْبُقْعَةِ
u'كَوْنٌ بِنَاءٌ':Added, #1: 1	كَوْنُ الْبِكْرِ
u'كَوْنٌ بِنْتٌ':Added, #1: 1	كَوْنِ الْبِنَاءِ
u'كَوْنٌ بَيَاضٌ':Added, #1: 1	كَوْنُ بِنْتِ
u'كَوْنٌ بَيَانٌ':Added, #1: 1	كَوْنُ الْبَيَاضِ
u'كَوْنٌ بَيْتٌ':Added, #2: 2	كَوْنِ الْبَيَانِ
u'كَوْنٌ بَيْتٌ':Added, #1: 1	كَوْنُ الْبَيْتِ
u'كَوْنٌ بَيْتٌ':Added, #1: 1	كَوْنِ الْبَيْتِ
u'كَوْنٌ بَيْعٌ':Added, #1: 1	كَوْنِ بَيْتِ
u'كَوْنٌ بَيْعٌ':Added, #1: 1	كَوْنَ بَيْعِهِ
u'كَوْنٌ بَيْعٌ':Added, #1: 1	كَوْنِ بَيْعِهِ
u'كَوْنٌ بَيْعَةٌ':Added, #4: 4	كَوْنَ الْبَيْعِ
u'كَوْنٌ تَابِعٌ':Added, #1: 1	كَوْنِ الْبَيْعَةِ
u'كَوْنٌ تَأْثِيرٌ':Added, #1: 1	كَوْنِ التَّابِعِ
u'كَوْنٌ تَأْخِيرٌ':Added, #1: 1	كَوْنِ تَأْثِيرِ
u'كَوْنٌ تَأْخِيرٌ':Added, #1: 1	كَوْنُ التَّأْخِيرِ
u'كَوْنٌ تارِك':Added, #1: 1	كَوْنَ تَأْخِيرِ
u'كَوْنٌ تَأْمِينٌ':Added, #1: 1	كَوْنِ التَّارِكِ
u'كَوْنٌ تَثْنِيَةٌ':Added, #1: 1	كَوْنِ تَأْمِينِهِ
u'كَوْنٌ تَجْرِيح':Added, #1: 1	كَوْنِ التَّثْنِيَةِ
u'كَوْنٌ تَجَوُّزٌ':Added, #1: 1	كَوْنُ التَّجْرِيحِ
u'كَوْنٌ تَجْوِيزٌ':Added, #1: 1	كَوْنِ التَّجَوُّزِ
u'كَوْنٌ تَحْجِيرٌ':Added, #1: 1	كَوْنُ التَّجْوِيزِ
u'كَوْنٌ تَحْرِيمٌ':Added, #1: 1	كَوْنِ التَّحْجِيرِ
u'كَوْنٌ تَحْرِيمٌ':Added, #1: 1	كَوْنَ التَّحْرِيمِ
u'كَوْنٌ تَحْرِيم':Added, #1: 1	كَوْنُ التَّحْرِيمِ
u'كَوْنٌ تَخْصِيصٌ':Added, #1: 1	كَوْنِ التَّحْرِيمَةِ
u'كَوْنٌ تَخْصِيصٌ':Added, #1: 1	كَوْنِ التَّخْصِيصِ
u'كَوْنٌ تَخْيِيرٌ':Added, #1: 1	كَوْنُ تَخْصِيصِ
u'كَوْنٌ تَدْبِيرٌ':Added, #1: 1	كَوْنِ التَّخْيِيرِ
u'كَوْنٌ تَدْلِيس':Added, #1: 1	كَوْنِ تَدْبِيرِهِ
u'كَوْنٌ تُرْبَةٌ':Added, #1: 1	كَوْنَ تَدْلِيسِ
u'كَوْنٌ تَرْتِيبٌ':Added, #1: 1	كَوْنُ تُرْبَةِ
u'كَوْنٌ تَرَفُّقٌ':Added, #2: 2	كَوْنِ التَّرْتِيبِ
u'كَوْنٌ تَرْكٌ':Added, #1: 1	كَوْنُ التَّرَفُّقِ
u'كَوْنٌ تَرْكٌ':Added, #1: 1	كَوْنُ تَرْكِهِ
u'كَوْنٌ تَرْكٌ':Added, #2: 2	كَوْنُ التَّرْكِ
u'كَوْنٌ تَرِكَةٌ':Added, #3: 3	كَوْنِ تَرْكِ
u'كَوْنٌ تَرْكِيبٌ':Added, #1: 1	كَوْنِ التَّرِكَةِ
u'كَوْنٌ تَزْكِيَةٌ':Added, #1: 1	كَوْنَ التَّرْكِيبِ
u'كَوْنٌ تَسْبِيحٌ':Added, #1: 1	كَوْنَ التَّزْكِيَةِ
u'كَوْنٌ تَسْلِيمٌ':Added, #1: 1	كَوْنِ التَّسْبِيحِ
u'كَوْنٌ تَسْلِيم':Added, #1: 1	كَوْنَ التَّسْلِيمِ
u'كَوْنٌ تَشْبِيهٌ':Added, #1: 1	كَوْنُ التَّسْلِيمَةِ
u'كَوْنٌ تَصْدِيقٌ':Added, #1: 1	كَوْنِ تَشْبِيهِ
u'كَوْنٌ تَصَرُّفٌ':Added, #1: 1	كَوْنِ التَّصْدِيقِ
u'كَوْنٌ تَصَرُّفٌ':Added, #1: 1	كَوْنُ تَصَرُّفِ
u'كَوْنٌ تَصَوُّرٌ':Added, #3: 3	كَوْنِ تَصَرُّفِ
u'كَوْنٌ تَطْلِيقٌ':Added, #1: 1	كَوْنِ تَصَوُّرَاتِ
u'كَوْنٌ تَعَامُلٌ':Added, #1: 1	كَوْنِ التَّطْلِيقِ
u'كَوْنٌ تَعَبُّدٌ':Added, #1: 1	كَوْنِ التَّعَامُلِ
u'كَوْنٌ تَعْبِيرٌ':Added, #1: 1	كَوْنُ التَّعَبُّدِ
u'كَوْنٌ تَعْبِيرٌ':Added, #1: 1	كَوْنُ التَّعْبِيرِ
u'كَوْنٌ تَعْدِيلٌ':Added, #1: 1	كَوْنَ تَعْبِيرِ
u'كَوْنٌ تَعْرِيضٌ':Added, #1: 1	كَوْنُ التَّعْدِيلِ
u'كَوْنٌ تَعْرِيفٌ':Added, #1: 1	كَوْنِ التَّعْرِيضِ
u'كَوْنٌ تَعْرِيفٌ':Added, #1: 1	كَوْنُ التَّعْرِيفِ
u'كَوْنٌ تَعَلُّقٌ':Added, #1: 1	كَوْنِ التَّعْرِيفِ
u'كَوْنٌ تَعَلُّقٌ':Added, #1: 1	كَوْنِ التَّعَلُّقِ
u'كَوْنٌ تَعْلِيقٌ':Added, #1: 1	كَوْنُ تَعَلُّقِ
u'كَوْنٌ تَعْلِيقٌ':Added, #1: 1	كَوْنَ التَّعْلِيقِ
u'كَوْنٌ تَعْلِيلٌ':Added, #4: 4	كَوْنِ التَّعْلِيقِ
u'كَوْنٌ تَعْيِينٌ':Added, #1: 1	كَوْنُ التَّعْلِيلِ
u'كَوْنٌ تَعْيِينٌ':Added, #1: 1	كَوْنُ التَّعْيِينِ
u'كَوْنٌ تَغْرِيبٌ':Added, #2: 2	كَوْنِ التَّعْيِينِ
u'كَوْنٌ تَغَيُّرٌ':Added, #1: 1	كَوْنُ التَّغْرِيبِ
u'كَوْنٌ تَغْيِيرٌ':Added, #1: 1	كَوْنِ التَّغَيُّرِ
u'كَوْنٌ تَغْيِيرٌ':Added, #1: 1	كَوْنِ تَغْيِيرِ
u'كَوْنٌ تَفاوُت':Added, #2: 2	كَوْنِ التَّغْيِيرِ
u'كَوْنٌ تَقادُم':Added, #1: 1	كَوْنِ التَّفَاوُتِ
u'كَوْنٌ تَقَدُّمٌ':Added, #1: 1	كَوْنَ التَّقَادُمِ
u'كَوْنٌ تَقْديريٌّ':Added, #2: 2	كَوْنِ تَقَدُّمِهِ
u'كَوْنٌ تَقْريرٌ':Added, #1: 1	كَوْنُ التَّقْدِيرِيِّ
u'كَوْنٌ تَقْيِيد':Added, #2: 2	كَوْنَ التَّقْرِيرِ
u'كَوْنٌ تَقْيِيد':Added, #2: 2	كَوْنَ التَّقْيِيدِ
u'كَوْنٌ تَكْبيرٌ':Added, #2: 2	كَوْنِ التَّقْيِيدِ
u'كَوْنٌ تَكْرارٌ':Added, #1: 1	كَوْنُ تَكْبِيرِ
u'كَوْنٌ تَكْليفٌ':Added, #2: 2	كَوْنُ التَّكْرَارِ
u'كَوْنٌ تِلاوَةٌ':Added, #1: 1	كَوْنَ التَّكْلِيفِ
u'كَوْنٌ تَلَوُّمٌ':Added, #1: 1	كَوْنِ التِّلَاوَةِ
u'كَوْنٌ تَمْثيلٌ':Added, #1: 1	كَوْنِ التَّلَوُّمِ
u'كَوْنٌ تَمْر':Added, #1: 1	كَوْنِ تَمْثِيلِ
u'كَوْنٌ تَمْلِيك':Added, #2: 2	كَوْنُ التَّمْرِ
u'كَوْنٌ تَنَاصُرٌ':Added, #1: 1	كَوْنُ التَّمْلِيكِ
u'كَوْنٌ تَنَاقُضٌ':Added, #1: 1	كَوْنِ التَّنَاصُرِ
u'كَوْنٌ تَنَحْنُحٌ':Added, #1: 1	كَوْنِ التَّنَاقُضِ
u'كَوْنٌ تَوْأَمٌ':Added, #1: 1	كَوْنُ التَّنَحْنُحِ
u'كَوْنٌ تَوَقُّفٌ':Added, #1: 1	كَوْنِ التَّوْأَمِ
u'كَوْنٌ تَوَقُّفٌ':Added, #1: 1	كَوْنُ تَوَقُّفِ
u'كَوْنٌ تَوْقِيفٌ':Added, #1: 1	كَوْنِ تَوَقُّفِهِ
u'كَوْنٌ تَوَكُّلٌ':Added, #2: 2	كَوْنَ التَّوْقِيفِ
u'كَوْنٌ تَوْكِيدٌ':Added, #1: 1	كَوْنِ التَّوَكُّلِ
u'كَوْنٌ تَيامُنٌ':Added, #1: 1	كَوْنَ التَّوْكِيدِ
u'كَوْنٌ تَيَمُّمٌ':Added, #1: 1	كَوْنِ التَّيَامُنِ
u'كَوْنٌ ثَابِتٌ':Added, #1: 1	كَوْنِ التَّيَمُّمِ
u'كَوْنٌ ثَابِتٌ':Added, #1: 1	كَوْنَ الثَّابِتِ
u'كَوْنٌ ثَابِتٌ':Added, #1: 1	كَوْنُ الثَّابِتِ
u'كَوْنٌ ثَالِثٌ':Added, #2: 2	كَوْنِ الثَّابِتِ
u'كَوْنٌ ثَالِثٌ':Added, #1: 1	كَوْنَ الثَّالِثِ
u'كَوْنٌ ثَانِي':Added, #1: 1	كَوْنُ الثَّالِثَةِ
u'كَوْنٌ ثَانِيَةٌ':Added, #3: 3	كَوْنُ الثَّانِيَةِ
u'كَوْنٌ ثُبُوتٌ':Added, #3: 3	كَوْنُ الثَّانِيَةِ
u'كَوْنٌ ثَدْيٌ':Added, #1: 1	كَوْنَ ثُبُوتِهِ
u'كَوْنٌ ثَلاثُ':Added, #1: 1	كَوْنِ الثَّدْيِ
u'كَوْنٌ ثَمَرٌ':Added, #1: 1	كَوْنِ الثَّلَاثِ
u'كَوْنٌ ثَمَرَةٌ':Added, #1: 1	كَوْنِ الثَّمَرِ
u'كَوْنٌ ثَمَرَةٌ':Added, #1: 1	كَوْنُ الثَّمَرَةِ
u'كَوْنٌ ثَمَنٌ':Added, #1: 1	كَوْنِ الثَّمَرَةِ
u'كَوْنٌ ثَمَنٌ':Added, #3: 3	كَوْنَ الثَّمَنِ
u'كَوْنٌ ثَمَنٌ':Added, #5: 5	كَوْنُ الثَّمَنِ
u'كَوْنٌ ثَناءٌ':Added, #6: 6	كَوْنِ الثَّمَنِ
u'كَوْنٌ ثَناءٌ':Added, #1: 1	كَوْنُ الثَّنَاءِ
u'كَوْنٌ ثَوابٌ':Added, #1: 1	كَوْنِ الثَّنَاءِ
u'كَوْنٌ ثَوابٌ':Added, #1: 1	كَوْنُ الثَّوَابِ
u'كَوْنٌ ثَوْبٌ':Added, #1: 1	كَوْنِ الثَّوَابِ
u'كَوْنٌ ثَوْبٌ':Added, #1: 1	كَوْنِ الثَّوْبِ
u'كَوْنٌ ثِيابٌ':Added, #3: 3	كَوْنُ الثَّوْبِ
u'كَوْنٌ جَابِرٌ':Added, #1: 1	كَوْنِ الثِّيَابِ
u'كَوْنٌ جَارِحٌ':Added, #1: 1	كَوْنِ الْجَابِرِ
u'كَوْنٌ جَارِي':Added, #3: 3	كَوْنُ الْجَارِحِ
u'كَوْنٌ جَارِي':Added, #1: 1	كَوْنَ الْجَارِيَةِ
u'كَوْنٌ جَارِي':Added, #1: 1	كَوْنُ الْجَارِيَةِ
u'كَوْنٌ جَارِيَةٌ':Added, #1: 1	كَوْنِ الْجَارِيَةِ
u'كَوْنٌ جَارِيَةٌ':Added, #1: 1	كَوْنَ الْجَارِيَةِ
u'كَوْنٌ جَارِيَةٌ':Added, #1: 1	كَوْنُ الْجَارِيَةِ
u'كَوْنٌ جَامِعٌ':Added, #1: 1	كَوْنِ الْجَارِيَةِ
u'كَوْنٌ جَبَلٌ':Added, #2: 2	كَوْنِ الْجَامِعِ
u'كَوْنٌ جَبَلٌ':Added, #1: 1	كَوْنُ الْجَبَلِ
u'كَوْنٌ جَبَلٌ':Added, #2: 2	كَوْنَ الْجَبَلِ
u'كَوْنٌ جَحْد':Added, #3: 3	كَوْنِ الْجَبَلِ
u'كَوْنٌ جُحُود':Added, #2: 2	كَوْنِ الْجَحْدِ
u'كَوْنٌ جِدار':Added, #1: 1	كَوْنِ الْجُحُودِ
u'كَوْنٌ جَرَادٌ':Added, #1: 1	كَوْنَ الْجِدَارِ
u'كَوْنٌ جُرْحٌ':Added, #1: 1	كَوْنِ الْجَرَادِ
u'كَوْنٌ جُرْحٌ':Added, #1: 1	كَوْنُ الْجُرْحِ
u'كَوْنٌ جُرْمٌ':Added, #1: 1	كَوْنِ جُرْحِهِ
u'كَوْنٌ جَرْي':Added, #1: 1	كَوْنَ الْجُرْمِ
u'كَوْنٌ جُزْءٌ':Added, #1: 1	كَوْنُ الْجَرْيَةِ
u'كَوْنٌ جُزْءٌ':Added, #1: 1	كَوْنِ الْجُزْءِ
u'كَوْنٌ جَزَاءٌ':Added, #2: 2	كَوْنُ الْجُزْءِ
u'كَوْنٌ جَزَاءٌ':Added, #1: 1	كَوْنِ جَزَاءِ
u'كَوْنٌ جلد':Added, #5: 5	كَوْنِ الْجَزَاءِ
u'كَوْنٌ جِلْدٌ':Added, #1: 1	كَوْنُ الْجِلْدِ
u'كَوْنٌ جلد':Added, #1: 1	كَوْنُ الْجِلْدِ
u'كَوْنٌ جِلْدٌ':Added, #1: 1	كَوْنُ جِلْدِ
u'كَوْنٌ جماع':Added, #1: 1	كَوْنُ جِلْدِ
u'كَوْنٌ جِمَاعٌ':Added, #1: 1	كَوْنَ الْجِمَاعِ
u'كَوْنٌ جَمَاعَةٌ':Added, #1: 1	كَوْنَ الْجِمَاعِ
u'كَوْنٌ جمع':Added, #2: 2	كَوْنِ الْجَمَاعَةِ
u'كَوْنٌ جَمْعٌ':Added, #1: 1	كَوْنِ الْجَمْعِ
u'كَوْنٌ جمع':Added, #1: 1	كَوْنِ الْجَمْعِ
u'كَوْنٌ جَمْعٌ':Added, #1: 1	كَوْنِ جَمْعِ
u'كَوْنٌ جمع':Added, #1: 1	كَوْنِ جَمْعِ
u'كَوْنٌ جَمْعٌ':Added, #3: 3	كَوْنُ الْجَمْعِ
u'كَوْنٌ جمعة':Added, #3: 3	كَوْنُ الْجَمْعِ
u'كَوْنٌ جُمُعَةٌ':Added, #1: 1	كَوْنِ الْجُمُعَةِ
u'كَوْنٌ جُمْلَةٌ':Added, #1: 1	كَوْنِ الْجُمُعَةِ
u'كَوْنٌ جَمِيع':Added, #1: 1	كَوْنَ الْجُمْلَةِ
u'كَوْنٌ جَمِيع':Added, #1: 1	كَوْنِ الْجَمِيعِ
u'كَوْنٌ جِنَايَةٌ':Added, #2: 2	كَوْنُ الْجَمِيعِ
u'كَوْنٌ جِنْسٌ':Added, #1: 1	كَوْنِ الْجِنَايَةِ
u'كَوْنٌ جِنْسِيٌّ':Added, #1: 1	كَوْنَ الْجِنْسِ
u'كَوْنٌ جهاد':Added, #1: 1	كَوْنِ الْجِنْسِيَّةِ
u'كَوْنٌ جِهَادٌ':Added, #1: 1	كَوْنِ الْجِهَادِ
u'كَوْنٌ جَهالَة':Added, #1: 1	كَوْنِ الْجِهَادِ
u'كَوْنٌ جَهالَة':Added, #1: 1	كَوْنُ الْجَهَالَةِ
u'كَوْنٌ جهل':Added, #1: 1	كَوْنِ الْجَهَالَةِ
u'كَوْنٌ جَهْلٌ':Added, #1: 1	كَوْنُ الْجَهْلِ
u'كَوْنٌ جَوَابٌ':Added, #1: 1	كَوْنُ الْجَهْلِ
u'كَوْنٌ جِوَارٌ':Added, #3: 3	كَوْنُ الْجَوَابِ
u'كَوْنٌ جَوَازٌ':Added, #1: 1	كَوْنُ الْجِوَارِ
u'كَوْنٌ جَوَازٌ':Added, #1: 1	كَوْنَ الْجَوَازِ
u'كَوْنٌ حاجٌّ':Added, #1: 1	كَوْنِ جَوَازِهِ
u'كَوْنٌ حاجَةٌ':Added, #1: 1	كَوْنِ الْحَاجِّ
u'كَوْنٌ حاجِزٌ':Added, #1: 1	كَوْنُ الْحَاجَةِ
u'كَوْنٌ حادِثٌ':Added, #1: 1	كَوْنِ الْحَاجِزِ
u'كَوْنٌ حادِثٌ':Added, #1: 1	كَوْنَ الْحَادِثِ
u'كَوْنٌ حادِثٌ':Added, #1: 1	كَوْنُ الْحَادِثِ
u'كَوْنٌ حاصِلٌ':Added, #1: 1	كَوْنِ الْحَادِثِ
u'كَوْنٌ حاضِرٌ':Added, #1: 1	كَوْنَ الْحَاصِلِ
u'كَوْنٌ حاكِمٌ':Added, #1: 1	كَوْنِ الْحَاضِرِ
u'كَوْنٌ حاكِمٌ':Added, #1: 1	كَوْنُ الْحَاكِمِ
u'كَوْنٌ حاكِمٌ':Added, #2: 2	كَوْنَ الْحَاكِمِ
u'كَوْنٌ حالٌ':Added, #3: 3	كَوْنِ الْحَاكِمِ
u'كَوْنٌ حامِلٌ':Added, #1: 1	كَوْنِ الْحَالِ
u'كَوْنٌ حَبيبٌ':Added, #1: 1	كَوْنُ حَامِلِهِ
u'كَوْنٌ حَجٌّ':Added, #1: 1	كَوْنِ حَبِيبِ
u'كَوْنٌ حَجٌّ':Added, #1: 1	كَوْنَ الْحَجِّ
u'كَوْنٌ حَجَرٌ':Added, #1: 1	كَوْنُ الْحَجِّ
u'كَوْنٌ حَجْرٌ':Added, #1: 1	كَوْنُ الْحَجَرِ
u'كَوْنٌ حَجْرٌ':Added, #1: 1	كَوْنِ الْحَجْرِ
u'كَوْنٌ حَدٌّ':Added, #1: 1	كَوْنِ حَجْرِهِ
u'كَوْنٌ حَدٌّ':Added, #1: 1	كَوْنِ حَدِّ
u'كَوْنٌ حَدٌّ':Added, #2: 2	كَوْنَ الْحَدِّ
u'كَوْنٌ حَدَثٌ':Added, #4: 4	كَوْنِ الْحَدِّ
u'كَوْنٌ حَديثٌ':Added, #1: 1	كَوْنِ الْحَدَثِ
u'كَوْنٌ حَذْف':Added, #1: 1	كَوْنَ حَدِيثِ
u'كَوْنٌ حُرٌّ':Added, #1: 1	كَوْنَ الْحَذْفِ
u'كَوْنٌ حَرامٌ':Added, #1: 1	كَوْنِ الْحُرِّ
u'كَوْنٌ حَرامٌ':Added, #1: 1	كَوْنَ الْحَرَامِ
u'كَوْنٌ حِرْزٌ':Added, #1: 1	كَوْنِ الْحَرَامِ
u'كَوْنٌ حُرْمَةٌ':Added, #1: 1	كَوْنِ الْحِرْزِ
u'كَوْنٌ حُرْمَةٌ':Added, #1: 1	كَوْنَ الْحُرْمَةِ
u'كَوْنٌ حُرْمَةٌ':Added, #1: 1	كَوْنُ الْحُرْمَةِ
u'كَوْنٌ حَرِيمٌ':Added, #1: 1	كَوْنِ حُرْمَتِهِ
u'كَوْنٌ حساب':Added, #1: 1	كَوْنَ حَرِيمِ
u'كَوْنٌ حِسَابٌ':Added, #1: 1	كَوْنِ حِسَابِهِ
u'كَوْنٌ حُسْنٌ':Added, #1: 1	كَوْنِ حِسَابِهِ
u'كَوْنٌ حَسَنٌ':Added, #1: 1	كَوْنِ الْحُسْنِ
u'كَوْنٌ حَسَنٌ':Added, #1: 1	كَوْنُ الْحَسَنَةِ
u'كَوْنٌ حَسَنَةٌ':Added, #1: 1	كَوْنُ حَسَنَاتِ
u'كَوْنٌ حَسَنَةٌ':Added, #1: 1	كَوْنُ الْحَسَنَةِ
u'كَوْنٌ حَشَفَةٌ':Added, #1: 1	كَوْنُ حَسَنَاتِ
u'كَوْنٌ حَصْرٌ':Added, #1: 1	كَوْنُ الْحَشَفَةِ
u'كَوْنٌ حَضَانَةٌ':Added, #1: 1	كَوْنِ الْحَصْرِ
u'كَوْنٌ حَطِيم':Added, #1: 1	كَوْنِ الْحَضَانَةِ
u'كَوْنٌ حَقٌّ':Added, #1: 1	كَوْنَ الْحَطِيمِ
u'كَوْنٌ حَقٌّ':Added, #2: 2	كَوْنَ الْحَقِّ
u'كَوْنٌ حَقٌّ':Added, #3: 3	كَوْنِ الْحَقِّ
u'كَوْنٌ حَقِيقٌ':Added, #4: 4	كَوْنُ الْحَقِّ
u'كَوْنٌ حَقِيقٌ':Added, #1: 1	كَوْنِ الْحَقِيقَةِ
u'كَوْنٌ حَقِيقَةٌ':Added, #1: 1	كَوْنِ حَقِيقَةِ
u'كَوْنٌ حَقِيقَةٌ':Added, #1: 1	كَوْنِ الْحَقِيقَةِ
u'كَوْنٌ حَقِيقَةٌ':Added, #1: 1	كَوْنَ حَقِيقَةٍ
u'كَوْنٌ حَقِيقِيٌّ':Added, #1: 1	كَوْنِ حَقِيقَةِ
u'كَوْنٌ حُكْمٌ':Added, #3: 3	كَوْنُ الْحَقِيقِيِّ
u'كَوْنٌ حُكْمٌ':Added, #13: 13	كَوْنُ الْحُكْمِ
u'كَوْنٌ حُكْمٌ':Added, #1: 1	كَوْنُ حُكْمِ
u'كَوْنٌ حُكْمٌ':Added, #1: 1	كَوْنَ حُكْمِهِ
u'كَوْنٌ حُكْمٌ':Added, #1: 1	كَوْنُ حُكْمِهِ
u'كَوْنٌ حُكْمٌ':Added, #2: 2	كَوْنَ حُكْمِ
u'كَوْنٌ حُكْمٌ':Added, #2: 2	كَوْنِ حُكْمِ
u'كَوْنٌ حُكْمٌ':Added, #2: 2	كَوْنِ حُكْمِهِ
u'كَوْنٌ حُكْمٌ':Added, #4: 4	كَوْنِ الْحُكْمِ
u'كَوْنٌ حِلٌّ':Added, #5: 5	كَوْنَ الْحُكْمِ
u'كَوْنٌ حِلٌّ':Added, #1: 1	كَوْنُ الْحِلِّ
u'كَوْنٌ حَلْقٌ':Added, #2: 2	كَوْنِ الْحِلِّ
u'كَوْنٌ حَلْقٌ':Added, #1: 1	كَوْنَ الْحَلْقِ
u'كَوْنٌ حَمْلٌ':Added, #1: 1	كَوْنِ حَلْقِ
u'كَوْنٌ حَمْلٌ':Added, #4: 4	كَوْنُ الْحَمْلِ
u'كَوْنٌ حِنْثٌ':Added, #9: 9	كَوْنِ الْحَمْلِ
u'كَوْنٌ حِنْطَةٌ':Added, #2: 2	كَوْنِ الْحِنْثِ
u'كَوْنٌ حَيَاةٌ':Added, #1: 1	كَوْنِ الْحِنْطَةِ
u'كَوْنٌ خَادِمٌ':Added, #1: 1	كَوْنُ الْحَيَاةِ
u'كَوْنٌ خَارِجٌ':Added, #2: 2	كَوْنِ الْخَادِمِ
u'كَوْنٌ خَارِجٌ':Added, #2: 2	كَوْنُ الْخَارِجِ
u'كَوْنٌ خاصّ':Added, #2: 2	كَوْنِ الْخَارِجِ
u'كَوْنٌ خاصّ':Added, #1: 1	كَوْنَ الْخَاصِّ
u'كَوْنٌ خَالِقٌ':Added, #1: 1	كَوْنِ الْخَاصِّ
u'كَوْنٌ خَائِنٌ':Added, #1: 1	كَوْنِ الْخَالِقِ
u'كَوْنٌ خَبَرٌ':Added, #2: 2	كَوْنِ الْخَائِنِ
u'كَوْنٌ خَبَر':Added, #2: 2	كَوْنُ الْخَبَرِ
u'كَوْنٌ خَبَرٌ':Added, #2: 2	كَوْنُ الْخَبَرِ
u'كَوْنٌ خَبَرٌ':Added, #2: 2	كَوْنُ خَبَرِ
u'كَوْنٌ خَبَر':Added, #2: 2	كَوْنِ خَبَرِ
u'كَوْنٌ خَبَر':Added, #2: 2	كَوْنُ خَبَرِ
u'كَوْنٌ خَبَرٌ':Added, #2: 2	كَوْنِ خَبَرِ
u'كَوْنٌ خَبَر':Added, #3: 3	كَوْنِ الْخَبَرِ
u'كَوْنٌ خدمة':Added, #3: 3	كَوْنِ الْخَبَرِ
u'كَوْنٌ خِدْمَةٌ':Added, #1: 1	كَوْنِ الْخِدْمَةِ
u'كَوْنٌ خرق':Added, #1: 1	كَوْنِ الْخِدْمَةِ
u'كَوْنٌ خَرْقٌ':Added, #1: 1	كَوْنُ الْخَرْقِ
u'كَوْنٌ خُرُوجٌ':Added, #1: 1	كَوْنُ الْخَرْقِ
u'كَوْنٌ خُرُوجٌ':Added, #1: 1	كَوْنُ الْخُرُوجِ
u'كَوْنٌ خُرُوجٌ':Added, #1: 1	كَوْنِ الْخُرُوجِ
u'كَوْنٌ خَصْمٌ':Added, #1: 1	كَوْنُ خُرُوجِهِ
u'كَوْنٌ خُصُوصِيٌّ':Added, #5: 5	كَوْنِ الْخَصْمِ
u'كَوْنٌ خَطٌّ':Added, #1: 1	كَوْنِ خُصُوصِيَّةِ
u'كَوْنٌ خَطَأٌ':Added, #1: 1	كَوْنِ الْخَطِّ
u'كَوْنٌ خطبة':Added, #2: 2	كَوْنُ الْخَطَأِ
u'كَوْنٌ خطبة':Added, #2: 2	كَوْنُ الْخُطْبَةِ
u'كَوْنٌ خُطْبَةٌ':Added, #2: 2	كَوْنِ الْخُطْبَةِ
u'كَوْنٌ خُطْبَةٌ':Added, #2: 2	كَوْنُ الْخُطْبَةِ
u'كَوْنٌ خطر':Added, #2: 2	كَوْنِ الْخُطْبَةِ
u'كَوْنٌ خَطَرٌ':Added, #1: 1	كَوْنُ الْخَطَرِ
u'كَوْنٌ خَلاَءٌ':Added, #1: 1	كَوْنُ الْخَطَرِ
u'كَوْنٌ خِلاَفٌ':Added, #1: 1	كَوْنَ الْخَلَاءِ
u'كَوْنٌ خِلاَفٌ':Added, #2: 2	كَوْنَ الْخِلَافِ
u'كَوْنٌ خِلاَفٌ':Added, #2: 2	كَوْنُ الْخِلَافِ
u'كَوْنٌ خُلْعٌ':Added, #2: 2	كَوْنِ الْخِلَافِ
u'كَوْنٌ خَلَفٌ':Added, #1: 1	كَوْنُ الْخُلْعِ
u'كَوْنٌ خَلْوَةٌ':Added, #1: 1	كَوْنِ الْخَلَفِ
u'كَوْنٌ خُلُوفٌ':Added, #1: 1	كَوْنُ الْخَلْوَةِ
u'كَوْنٌ خَمْرٌ':Added, #1: 1	كَوْنِ الْخُلُوفِ
u'كَوْنٌ خَمْرٌ':Added, #1: 1	كَوْنُ الْخَمْرِ
u'كَوْنٌ خِنْزِيرٌ':Added, #1: 1	كَوْنِ الْخَمْرِ
u'كَوْنٌ خيار':Added, #1: 1	كَوْنُ الْخِنْزِيرِ
u'كَوْنٌ خِيَارٌ':Added, #2: 2	كَوْنَ الْخِيَارِ
u'كَوْنٌ خِيرَةٌ':Added, #2: 2	كَوْنَ الْخِيَارِ
u'كَوْنٌ دَابَّةٌ':Added, #1: 1	كَوْنِ الْخِيرَةِ
u'كَوْنٌ دَابَّةٌ':Added, #1: 1	كَوْنَ الدَّابَّةِ
u'كَوْنٌ دَاخِلٌ':Added, #2: 2	كَوْنِ الدَّابَّةِ
u'كَوْنٌ دَارٌ':Added, #1: 1	كَوْنِ الدَّاخِلِ
u'كَوْنٌ دَارٌ':Added, #1: 1	كَوْنُ الدَّارِ
u'كَوْنٌ دَارٌ':Added, #2: 2	كَوْنِ الدَّارِ
u'كَوْنٌ دَافِعٌ':Added, #7: 7	كَوْنَ الدَّارِ
u'كَوْنٌ دِبَاغٌ':Added, #2: 2	كَوْنُ الدَّافِعِ
u'كَوْنٌ دُخُولٌ':Added, #1: 1	كَوْنِ الدِّبَاغِ
u'كَوْنٌ دَرَاهِمُ':Added, #1: 1	كَوْنِ الدُّخُولِ
u'كَوْنٌ دَرَاهِمُ':Added, #1: 1	كَوْنَ الدَّرَاهِمِ
u'كَوْنٌ دِرْهَمٌ':Added, #2: 2	كَوْنُ الدَّرَاهِمِ
u'كَوْنٌ دِرْهَم':Added, #1: 1	كَوْنَ الدِّرْهَمِ
u'كَوْنٌ دَعْوَةٌ':Added, #1: 1	كَوْنَ الدِّرْهَمِ
u'كَوْنٌ دَعْوَةٌ':Added, #1: 1	كَوْنُ الدَّعْوَةِ
u'كَوْنٌ دفع':Added, #1: 1	كَوْنِ الدَّعْوَةِ
u'كَوْنٌ دَفْعٌ':Added, #1: 1	كَوْنِ الدَّفْعِ
u'كَوْنٌ دفع':Added, #1: 1	كَوْنِ الدَّفْعِ
u'كَوْنٌ دَفْعٌ':Added, #2: 2	كَوْنُ الدَّفْعِ
u'كَوْنٌ دَفِينٌ':Added, #2: 2	كَوْنُ الدَّفْعِ
u'كَوْنٌ دَفِين':Added, #1: 1	كَوْنِ دَفِينِ
u'كَوْنٌ دَلالَةٌ':Added, #1: 1	كَوْنِ دَفِينِ
u'كَوْنٌ دَلالَةٌ':Added, #1: 1	كَوْنُ الدَّلَالَةِ
u'كَوْنٌ دُلوكٌ':Added, #1: 1	كَوْنِ دَلَالَتِهِ
u'كَوْنٌ دَليلٌ':Added, #1: 1	كَوْنِ الدُّلُوكِ
u'كَوْنٌ دَليلٌ':Added, #1: 1	كَوْنَ دَلِيلِ
u'كَوْنٌ دَليلٌ':Added, #2: 2	كَوْنِ دَلِيلِهِ
u'كَوْنٌ دَليلٌ':Added, #3: 3	كَوْنَ الدَّلِيلِ
u'كَوْنٌ دَليلٌ':Added, #3: 3	كَوْنُ الدَّلِيلِ
u'كَوْنٌ دَليلٌ':Added, #3: 3	كَوْنِ دَلِيلِ
u'كَوْنٌ دَمٌ':Added, #5: 5	كَوْنِ الدَّلِيلِ
u'كَوْنٌ دَمٌ':Added, #1: 1	كَوْنَ الدَّمِ
u'كَوْنٌ دَمٌ':Added, #1: 1	كَوْنُ الدَّمَيْنِ
u'كَوْنٌ دَوامٌ':Added, #5: 5	كَوْنِ الدَّمِ
u'كَوْنٌ دُودَةٌ':Added, #1: 1	كَوْنِ دَوَامِ
u'كَوْنٌ دَوَرانٌ':Added, #1: 1	كَوْنِ الدُّودَةِ
u'كَوْنٌ دَوَرانٌ':Added, #1: 1	كَوْنَ الدَّوَرَانِ
u'كَوْنٌ دِيَةٌ':Added, #1: 1	كَوْنِ الدَّوَرَانِ
u'كَوْنٌ دَيْنٌ':Added, #1: 1	كَوْنُ الدِّيَةِ
u'كَوْنٌ دَيْنٌ':Added, #2: 2	كَوْنَ الدَّيْنِ
u'كَوْنٌ دَيْنٌ':Added, #3: 3	كَوْنِ الدَّيْنِ
u'كَوْنٌ ذاتِيٌّ':Added, #4: 4	كَوْنُ الدَّيْنِ
u'كَوْنٌ ذَرْعٌ':Added, #1: 1	كَوْنُ الذَّاتِيِّ
u'كَوْنٌ ذَكاةٌ':Added, #1: 1	كَوْنِ الذَّرْعِ
u'كَوْنٌ ذكر':Added, #1: 1	كَوْنِ ذَكَاتِهِ
u'كَوْنٌ ذكر':Added, #1: 1	كَوْنَ الذَّكَرِ
u'كَوْنٌ ذكر':Added, #1: 1	كَوْنُ الذَّكَرِ
u'كَوْنٌ ذَكَرٌ':Added, #1: 1	كَوْنِ الذَّكَرِ
u'كَوْنٌ ذَكَرٌ':Added, #1: 1	كَوْنَ الذَّكَرِ
u'كَوْنٌ ذَكَرٌ':Added, #1: 1	كَوْنُ الذَّكَرِ
u'كَوْنٌ ذَكَرٌ':Added, #1: 1	كَوْنِ الذَّكَرِ
u'كَوْنٌ ذكر':Added, #1: 1	كَوْنِ الذَّكَرَيْنِ
u'كَوْنٌ ذِكْرٌ':Added, #1: 1	كَوْنَ ذِكْرِ
u'كَوْنٌ ذُكورٌ':Added, #1: 1	كَوْنَ ذِكْرِ
u'كَوْنٌ ذَمٌّ':Added, #1: 1	كَوْنِ الذُّكُورِ
u'كَوْنٌ ذَمٌّ':Added, #1: 1	كَوْنِ الذَّمِّ
u'كَوْنٌ ذِمِّيٌّ':Added, #3: 3	كَوْنُ الذَّمِّ
u'كَوْنٌ ذِمِّيٌّ':Added, #1: 1	كَوْنَ الذِّمِّيِّ
u'كَوْنٌ ذَهَابٌ':Added, #2: 2	كَوْنِ الذِّمِّيِّ
u'كَوْنٌ ذَهَابٌ':Added, #1: 1	كَوْنُ الذَّهَابِ
u'كَوْنٌ ذِهْنٌ':Added, #1: 1	كَوْنِ الذَّهَابِ
u'كَوْنٌ رابع':Added, #1: 1	كَوْنَ الذِّهْنِ
u'كَوْنٌ رَابِعٌ':Added, #1: 1	كَوْنَ الرَّابِعِ
u'كَوْنٌ رَأْسٌ':Added, #1: 1	كَوْنَ الرَّابِعِ
u'كَوْنٌ رَأْسٌ':Added, #1: 1	كَوْنِ رَأْسِهِ
u'كَوْنٌ رَأْسٌ':Added, #2: 2	كَوْنُ الرَّأْسِ
u'كَوْنٌ رَأْسٌ':Added, #2: 2	كَوْنِ رَأْسِ
u'كَوْنٌ رَاهِنٌ':Added, #4: 4	كَوْنُ رَأْسِ
u'كَوْنٌ رَاهِنٌ':Added, #1: 1	كَوْنِ الرَّاهِنِ
u'كَوْنٌ رَاوِي':Added, #4: 4	كَوْنُ الرَّاهِنِ
u'كَوْنٌ رَاوِي':Added, #1: 1	كَوْنُ رَاوِيهِ
u'كَوْنٌ رَأْيٌ':Added, #1: 1	كَوْنِ رَاوِيهِ
u'كَوْنٌ رَبُّ':Added, #1: 1	كَوْنُ رَأْيِهِ
u'كَوْنٌ رَبُّ':Added, #1: 1	كَوْنِ رَبِّ
u'كَوْنٌ رِبْحٌ':Added, #1: 1	كَوْنِ رَبِّهِ
u'كَوْنٌ رِبْحٌ':Added, #1: 1	كَوْنَ الرِّبْحِ
u'كَوْنٌ رِجَالٌ':Added, #1: 1	كَوْنِ الرِّبْحِ
u'كَوْنٌ رجعة':Added, #1: 1	كَوْنِ رِجَالِهِ
u'كَوْنٌ رَجْعَةٌ':Added, #1: 1	كَوْنِ الرَّجْعَةِ
u'كَوْنٌ رَجُلٌ':Added, #1: 1	كَوْنِ الرَّجْعَةِ
u'كَوْنٌ رَجُلٌ':Added, #1: 1	كَوْنَ الرَّجُلِ
u'كَوْنٌ رَجُلٌ':Added, #1: 1	كَوْنُ رَجُلٍ
u'كَوْنٌ رَجُلٌ':Added, #2: 2	كَوْنِ الرَّجُلِ
u'كَوْنٌ رُجُوعٌ':Added, #3: 3	كَوْنُ الرَّجُلِ
u'كَوْنٌ رُجُولِيٌّ':Added, #2: 2	كَوْنُ الرُّجُوعِ
u'كَوْنٌ رِزْقٌ':Added, #1: 1	كَوْنِ الرُّجُولِيَّةِ
u'كَوْنٌ رَسُولٌ':Added, #1: 1	كَوْنُ رِزْقِ
u'كَوْنٌ رضاع':Added, #1: 1	كَوْنَ الرَّسُولِ
u'كَوْنٌ رفقة':Added, #1: 1	كَوْنِ الرَّضَاعِ
u'كَوْنٌ رُفْقَةٌ':Added, #1: 1	كَوْنِ الرُّفْقَةِ
u'كَوْنٌ رَقَبَةٌ':Added, #1: 1	كَوْنِ الرُّفْقَةِ
u'كَوْنٌ رَقَبَةٌ':Added, #1: 1	كَوْنُ الرَّقَبَةِ
u'كَوْنٌ رَقَبَةٌ':Added, #1: 1	كَوْنِ رَقَبَةِ
u'كَوْنٌ رَقْمٌ':Added, #2: 2	كَوْنِ الرَّقَبَةِ
u'كَوْنٌ رَقْم':Added, #1: 1	كَوْنُ الرَّقْمِ
u'كَوْنٌ رَقيقٌ':Added, #1: 1	كَوْنُ الرَّقْمِ
u'كَوْنٌ رَقيق':Added, #1: 1	كَوْنُ الرَّقِيقِ
u'كَوْنٌ رَقيقٌ':Added, #1: 1	كَوْنُ الرَّقِيقِ
u'كَوْنٌ ركبة':Added, #1: 1	كَوْنُ الرَّقِيقَةِ
u'كَوْنٌ رُكْبَةٌ':Added, #1: 1	كَوْنِ الرُّكْبَةِ
u'كَوْنٌ رُكْنٌ':Added, #1: 1	كَوْنِ الرُّكْبَةِ
u'كَوْنٌ رُكْن':Added, #1: 1	كَوْنَ الرُّكْنِ
u'كَوْنٌ رُكْن':Added, #1: 1	كَوْنَ الرُّكْنِ
u'كَوْنٌ رُكْنِيّ':Added, #1: 1	كَوْنُ الرُّكْنِيَّةِ
u'كَوْنٌ رُكوبٌ':Added, #1: 1	كَوْنُ الرُّكْنِيَّةِ
u'كَوْنٌ رُكوعٌ':Added, #1: 1	كَوْنِ الرُّكُوبِ
u'كَوْنٌ رَمادٌ':Added, #1: 1	كَوْنِ الرُّكُوعِ
u'كَوْنٌ رُمْحٌ':Added, #1: 1	كَوْنَ الرَّمَادِ
u'كَوْنٌ رَمْيٌ':Added, #1: 1	كَوْنَ الرُّمْحِ
u'كَوْنٌ رَمْيٌ':Added, #1: 1	كَوْنِ الرَّمْيِ
u'كَوْنٌ رَهْنٌ':Added, #2: 2	كَوْنُ الرَّمْيِ
u'كَوْنٌ رَهْنٌ':Added, #1: 1	كَوْنَ الرَّهْنِ
u'كَوْنٌ رَهْنٌ':Added, #1: 1	كَوْنُ رَهْنِ
u'كَوْنٌ رِوايَةٌ':Added, #3: 3	كَوْنُ الرَّهْنِ
u'كَوْنٌ رِوايَةٌ':Added, #1: 1	كَوْنَ رِوَايَةِ
u'كَوْنٌ زائِدٌ':Added, #1: 1	كَوْنُ رِوَايَةِ
u'كَوْنٌ زَرْعٌ':Added, #1: 1	كَوْنِ الزَّائِدِ
u'كَوْنٌ زَرْعٌ':Added, #1: 1	كَوْنُ الزَّرْعِ
u'كَوْنٌ زَكاةٌ':Added, #1: 1	كَوْنِ الزَّرْعِ
u'كَوْنٌ زَكاةٌ':Added, #1: 1	كَوْنِ الزَّكَاةِ
u'كَوْنٌ زَمانٌ':Added, #2: 2	كَوْنُ الزَّكَاةِ
u'كَوْنٌ زَمانٌ':Added, #1: 1	كَوْنُ زَمَانِ
u'كَوْنٌ زَوالٌ':Added, #1: 1	كَوْنِ زَمَانِ
u'كَوْنٌ زَوْجٌ':Added, #1: 1	كَوْنِ الزَّوَالِ
u'كَوْنٌ زَوْجٌ':Added, #1: 1	كَوْنُ الزَّوْجَيْنِ
u'كَوْنٌ زَوْجٌ':Added, #2: 2	كَوْنَ الزَّوْجِ
u'كَوْنٌ زَوْجٌ':Added, #2: 2	كَوْنُ الزَّوْجِ
u'كَوْنٌ زَوْجَةٌ':Added, #3: 3	كَوْنِ الزَّوْجِ
u'كَوْنٌ زَوْجَةٌ':Added, #1: 1	كَوْنُ الزَّوْجَةِ
u'كَوْنٌ زَوْجَةٌ':Added, #1: 1	كَوْنِ زَوْجَةِ
u'كَوْنٌ زَوْجِيٌّ':Added, #2: 2	كَوْنِ الزَّوْجَةِ
u'كَوْنٌ زِيادَةٌ':Added, #1: 1	كَوْنِ الزَّوْجِيَّةِ
u'كَوْنٌ زَيْدٌ':Added, #1: 1	كَوْنِ الزِّيَادَةِ
u'كَوْنٌ زَيْدٌ':Added, #1: 1	كَوْنِ زَيْدٍ
u'كَوْنٌ سَارِقٌ':Added, #3: 3	كَوْنَ زَيْدٍ
u'كَوْنٌ سَارِقٌ':Added, #1: 1	كَوْنُ السَّارِقِ
u'كَوْنٌ سَاقِي':Added, #1: 1	كَوْنِ السَّارِقِ
u'كَوْنٌ سَاقِيَةٌ':Added, #1: 1	كَوْنَ السَّاقِيَةِ
u'كَوْنٌ سائِل':Added, #1: 1	كَوْنَ السَّاقِيَةِ
u'كَوْنٌ سَائِلٌ':Added, #1: 1	كَوْنُ السَّائِلِ
u'كَوْنٌ سَبَبٌ':Added, #1: 1	كَوْنُ السَّائِلِ
u'كَوْنٌ سَبَبٌ':Added, #1: 1	كَوْنَ السَّبَبِ
u'كَوْنٌ سَبَبٌ':Added, #1: 1	كَوْنُ السَّبَبِ
u'كَوْنٌ سَبَبٌ':Added, #1: 1	كَوْنُ سَبَبِ
u'كَوْنٌ سَبَبٌ':Added, #1: 1	كَوْنِ سَبَبِهِ
u'كَوْنٌ سَبَبٌ':Added, #2: 2	كَوْنِ السَّبَبِ
u'كَوْنٌ سَبَقٌ':Added, #2: 2	كَوْنِ سَبَبِ
u'كَوْنٌ سَبْقٌ':Added, #1: 1	كَوْنِ السَّبَقِ
u'كَوْنٌ سِتْرٌ':Added, #1: 1	كَوْنِ السَّبْقِ
u'كَوْنٌ سُجُودٌ':Added, #1: 1	كَوْنِ السِّتْرِ
u'كَوْنٌ سُخُونَةٌ':Added, #1: 1	كَوْنِ سُجُودِ
u'كَوْنٌ سِدْرٌ':Added, #1: 1	كَوْنُ سُخُونَتِهِ
u'كَوْنٌ سَرقَةٌ':Added, #1: 1	كَوْنُ السِّدْرِ
u'كَوْنٌ سَرِقَةٌ':Added, #1: 1	كَوْنُ السَّرِقَةِ
u'كَوْنٌ سِعَايَةٌ':Added, #1: 1	كَوْنُ السَّرِقَةِ
u'كَوْنٌ سَفَرٌ':Added, #2: 2	كَوْنِ السِّعَايَةِ
u'كَوْنٌ سَفَرٌ':Added, #1: 1	كَوْنُ السَّفَرِ
u'كَوْنٌ سُقُوطٌ':Added, #1: 1	كَوْنِ سَفَرِ
u'كَوْنٌ سُقُوطٌ':Added, #1: 1	كَوْنُ السُّقُوطِ
u'كَوْنٌ سَكْرَان':Added, #1: 1	كَوْنِ سُقُوطِ
u'كَوْنٌ سُكُوتٌ':Added, #1: 1	كَوْنِ السَّكْرَانِ
u'كَوْنٌ سُكُوتٌ':Added, #1: 1	كَوْنَ السُّكُوتِ
u'كَوْنٌ سُكُوتٌ':Added, #1: 1	كَوْنُ السُّكُوتِ
u'كَوْنٌ سُكُوتٌ':Added, #2: 2	كَوْنِ سُكُوتِهِ
u'كَوْنٌ سَلاَمَةٌ':Added, #5: 5	كَوْنِ السُّكُوتِ
u'كَوْنٌ سِلْعَةٌ':Added, #1: 1	كَوْنُ سَلَامَةِ
u'كَوْنٌ سَلَمٌ':Added, #1: 1	كَوْنِ السِّلْعَةِ
u'كَوْنٌ سموات':Added, #2: 2	كَوْنِ السَّلَمِ
u'كَوْنٌ سَنَةٌ':Added, #1: 1	كَوْنِ السَّمَوَاتِ
u'كَوْنٌ سُنَّةٌ':Added, #1: 1	كَوْنِ السَّنَةِ
u'كَوْنٌ سُنَّةٌ':Added, #1: 1	كَوْنَ السُّنَّةِ
u'كَوْنٌ سَنَدٌ':Added, #1: 1	كَوْنُ السُّنَّةِ
u'كَوْنٌ سِواكٌ':Added, #2: 2	كَوْنِ السَّنَدِ
u'كَوْنٌ سُؤَالٌ':Added, #2: 2	كَوْنِ السِّوَاكِ
u'كَوْنٌ سُؤَالٌ':Added, #1: 1	كَوْنَ السُّؤَالِ
u'كَوْنٌ سُؤْرٌ':Added, #1: 1	كَوْنِ السُّؤَالِ
u'كَوْنٌ سَيِّدٌ':Added, #1: 1	كَوْنِ سُؤْرِ
u'كَوْنٌ سَيِّدٌ':Added, #1: 1	كَوْنِ السَّيِّدِ
u'كَوْنٌ شَاخِصٌ':Added, #1: 1	كَوْنِ سَيِّدِهِ
u'كَوْنٌ شَارِبٌ':Added, #1: 1	كَوْنِ الشَّاخِصِ
u'كَوْنٌ شَارِعٌ':Added, #1: 1	كَوْنِ الشَّارِبِ
u'كَوْنٌ شَارِعٌ':Added, #1: 1	كَوْنِ الشَّارِعِ
u'كَوْنٌ شافِعِيّ':Added, #2: 2	كَوْنُ الشَّارِعِ
u'كَوْنٌ شافِعِيّ':Added, #1: 1	كَوْنُ الشَّافِعِيِّ
u'كَوْنٌ شَاقٌّ':Added, #1: 1	كَوْنِ الشَّافِعِيِّ
u'كَوْنٌ شَاهِدٌ':Added, #1: 1	كَوْنَ الشَّاقِّ
u'كَوْنٌ شَاهِدٌ':Added, #1: 1	كَوْنِ الشَّاهِدِ
u'كَوْنٌ شَاهِدٌ':Added, #1: 1	كَوْنُ الشَّاهِدَيْنِ
u'كَوْنٌ شَاهِدٌ':Added, #1: 1	كَوْنِ الشَّاهِدَيْنِ
u'كَوْنٌ شُبْهَةٌ':Added, #2: 2	كَوْنَ الشَّاهِدِ
u'كَوْنٌ شَجَرٌ':Added, #1: 1	كَوْنَ شُبْهَةِ
u'كَوْنٌ شَخْصٌ':Added, #1: 1	كَوْنِ الشَّجَرِ
u'كَوْنٌ شِدَّةٌ':Added, #2: 2	كَوْنُ الشَّخْصِ
u'كَوْنٌ شِرَاءٌ':Added, #1: 1	كَوْنِ الشِّدَّةِ
u'كَوْنٌ شِرَاءٌ':Added, #2: 2	كَوْنُ الشِّرَاءِ
u'كَوْنٌ شَرَابٌ':Added, #2: 2	كَوْنِ الشِّرَاءِ
u'كَوْنٌ شُرَاةٌ':Added, #1: 1	كَوْنِ الشَّرَابِ
u'كَوْنٌ شرب':Added, #1: 1	كَوْنُ الشُّرَاةِ
u'كَوْنٌ شُرْبٌ':Added, #1: 1	كَوْنِ الشُّرْبِ
u'كَوْنٌ شَرْطٌ':Added, #1: 1	كَوْنِ الشُّرْبِ
u'كَوْنٌ شَرْطٌ':Added, #2: 2	كَوْنُ الشَّرْطِ
u'كَوْنٌ شَرْطٌ':Added, #2: 2	كَوْنِ شَرْطِ
u'كَوْنٌ شَرْطٌ':Added, #3: 3	كَوْنَ الشَّرْطِ
u'كَوْنٌ شَرْعٌ':Added, #7: 7	كَوْنِ الشَّرْطِ
u'كَوْنٌ شَرْعٌ':Added, #1: 1	كَوْنَ الشَّرْعِ
u'كَوْنٌ شَرْعٌ':Added, #1: 1	كَوْنِ الشَّرْعِ
u'كَوْنٌ شرف':Added, #1: 1	كَوْنَ شَرْعِ
u'كَوْنٌ شَرَفٌ':Added, #1: 1	كَوْنُ شَرَفِ
u'كَوْنٌ شركة':Added, #1: 1	كَوْنُ شَرَفِ
u'كَوْنٌ شَرِكَةٌ':Added, #1: 1	كَوْنِ الشَّرِكَةِ
u'كَوْنٌ شركة':Added, #1: 1	كَوْنِ الشَّرِكَةِ
u'كَوْنٌ شَرِكَةٌ':Added, #1: 1	كَوْنِ شَرِكَةِ
u'كَوْنٌ شُرُوعٌ':Added, #1: 1	كَوْنِ شَرِكَةِ
u'كَوْنٌ شُرُوعٌ':Added, #1: 1	كَوْنُ الشُّرُوعِ
u'كَوْنٌ شَرِيكٌ':Added, #1: 1	كَوْنِ الشُّرُوعِ
u'كَوْنٌ شِطْرَنْجٌ':Added, #1: 1	كَوْنُ الشَّرِيكِ
u'كَوْنٌ شَفِيعٌ':Added, #1: 1	كَوْنُ الشِّطْرَنْجِ
u'كَوْنٌ شَكٌّ':Added, #1: 1	كَوْنِ الشَّفِيعِ
u'كَوْنٌ شَهَادَةٌ':Added, #2: 2	كَوْنِ الشَّكِّ
u'كَوْنٌ شَهَادَةٌ':Added, #1: 1	كَوْنِ الشَّهَادَةِ
u'كَوْنٌ شَهَادَةٌ':Added, #1: 1	كَوْنُ شَهَادَةِ
u'كَوْنٌ شَهَادَةٌ':Added, #1: 1	كَوْنِ شَهَادَةِ
u'كَوْنٌ شَهْرٌ':Added, #2: 2	كَوْنُ الشَّهَادَةِ
u'كَوْنٌ شَيْءٌ':Added, #1: 1	كَوْنُ الشَّهْرِ
u'كَوْنٌ شَيْءٌ':Added, #17: 17	كَوْنُ الشَّيْءِ
u'كَوْنٌ شَيْءٌ':Added, #1: 1	كَوْنِ شَيْءٍ
u'كَوْنٌ شَيْءٌ':Added, #20: 20	كَوْنِ الشَّيْءِ
u'كَوْنٌ شَيْخٌ':Added, #7: 7	كَوْنَ الشَّيْءِ
u'كَوْنٌ شَيْخٌ':Added, #1: 1	كَوْنُ الشَّيْخِ
u'كَوْنٌ صَاحِبٌ':Added, #1: 1	كَوْنِ الشَّيْخِ
u'كَوْنٌ صَاحِبٌ':Added, #1: 1	كَوْنَ صَاحِبِ
u'كَوْنٌ صَاعٌ':Added, #2: 2	كَوْنِ صَاحِبِ
u'كَوْنٌ صَبٌّ':Added, #1: 1	كَوْنَ الصَّاعِ
u'كَوْنٌ صباح':Added, #1: 1	كَوْنُ الصَّبِّ
u'كَوْنٌ صَبَاحٌ':Added, #1: 1	كَوْنِ الصَّبَاحِ
u'كَوْنٌ صَبْغٌ':Added, #1: 1	كَوْنِ الصَّبَاحِ
u'كَوْنٌ صَبِيٌّ':Added, #1: 1	كَوْنُ الصَّبْغِ
u'كَوْنٌ صَبِيٌّ':Added, #1: 1	كَوْنَ الصَّبِيِّ
u'كَوْنٌ صَحَابِيٌّ':Added, #2: 2	كَوْنِ الصَّبِيِّ
u'كَوْنٌ صَحَابِيٌّ':Added, #1: 1	كَوْنُ الصَّحَابِيِّ
u'كَوْنٌ صِحَّةٌ':Added, #2: 2	كَوْنَ الصَّحَابِيِّ
u'كَوْنٌ صَحْرَاءُ':Added, #1: 1	كَوْنُ الصِّحَّةِ
u'كَوْنٌ صَحِيحٌ':Added, #1: 1	كَوْنِ الصَّحْرَاءِ
u'كَوْنٌ صداق':Added, #1: 1	كَوْنُ الصَّحِيحِ
u'كَوْنٌ صداق':Added, #1: 1	كَوْنَ الصَّدَاقِ
u'كَوْنٌ صَدَاقٌ':Added, #1: 1	كَوْنِ الصَّدَاقِ
u'كَوْنٌ صَدَاقٌ':Added, #1: 1	كَوْنَ الصَّدَاقِ
u'كَوْنٌ صَدَاقَةٌ':Added, #1: 1	كَوْنِ الصَّدَاقِ
u'كَوْنٌ صَدْرٌ':Added, #1: 1	كَوْنُ الصَّدَاقَةِ
u'كَوْنٌ صدقة':Added, #1: 1	كَوْنِ صَدْرِ
u'كَوْنٌ صَدَقَةٌ':Added, #1: 1	كَوْنِ الصَّدَقَةِ
u'كَوْنٌ صَرْفٌ':Added, #1: 1	كَوْنِ الصَّدَقَةِ
u'كَوْنٌ صَرْف':Added, #1: 1	كَوْنِ الصَّرْفِ
u'كَوْنٌ صغار':Added, #1: 1	كَوْنِ الصَّرْفِ
u'كَوْنٌ صغائر':Added, #1: 1	كَوْنَ الصِّغَارِ
u'كَوْنٌ صَغَائِرُ':Added, #1: 1	كَوْنَ الصَّغَائِرِ
u'كَوْنٌ صَفٌّ':Added, #1: 1	كَوْنَ الصَّغَائِرِ
u'كَوْنٌ صِفَةٌ':Added, #1: 1	كَوْنِ الصَّفِّ
u'كَوْنٌ صِفَةٌ':Added, #2: 2	كَوْنُ الصِّفَةِ
u'كَوْنٌ صَلاَةٌ':Added, #6: 6	كَوْنِ الصِّفَةِ
u'كَوْنٌ صَلاَةٌ':Added, #1: 1	كَوْنُ صَلَاةِ
u'كَوْنٌ صَلاَةٌ':Added, #2: 2	كَوْنَ الصَّلَاةِ
u'كَوْنٌ صَلاَةٌ':Added, #2: 2	كَوْنِ صَلَاةِ
u'كَوْنٌ صَلاَةٌ':Added, #3: 3	كَوْنِ الصَّلَاةِ
u'كَوْنٌ صلح':Added, #5: 5	كَوْنُ الصَّلَاةِ
u'كَوْنٌ صُلْحٌ':Added, #1: 1	كَوْنِ الصُّلْحِ
u'كَوْنٌ صَلَوَاتٌ':Added, #1: 1	كَوْنِ الصُّلْحِ
u'كَوْنٌ صُورَةٌ':Added, #1: 1	كَوْنِ الصَّلَوَاتِ
u'كَوْنٌ صَوْمٌ':Added, #1: 1	كَوْنِ صُورَةِ
u'كَوْنٌ صَوْمٌ':Added, #1: 1	كَوْنُ صَوْمِ
u'كَوْنٌ صَوْمٌ':Added, #1: 1	كَوْنِ صَوْمِ
u'كَوْنٌ صَوْمٌ':Added, #2: 2	كَوْنَ الصَّوْمِ
u'كَوْنٌ صِيَاحٌ':Added, #4: 4	كَوْنِ الصَّوْمِ
u'كَوْنٌ صَيْدٌ':Added, #1: 1	كَوْنِ الصِّيَاحِ
u'كَوْنٌ صِيغَةٌ':Added, #1: 1	كَوْنِ الصَّيْدِ
u'كَوْنٌ صِيغَةٌ':Added, #1: 1	كَوْنُ الصِّيغَةِ
u'كَوْنٌ ضِدٌّ':Added, #3: 3	كَوْنِ الصِّيغَةِ
u'كَوْنٌ ضِدٌّ':Added, #1: 1	كَوْنُ الضِّدِّ
u'كَوْنٌ ضَرْبٌ':Added, #1: 1	كَوْنَ ضِدِّهِ
u'كَوْنٌ ضِعْفٌ':Added, #1: 1	كَوْنُ الضَّرْبِ
u'كَوْنٌ ضَعِيفٌ':Added, #1: 1	كَوْنِ ضِعْفِهِ
u'كَوْنٌ ضَمَانٌ':Added, #2: 2	كَوْنِ الضَّعِيفِ
u'كَوْنٌ ضَمِيرٌ':Added, #1: 1	كَوْنِ الضَّمَانِ
u'كَوْنٌ ضَمِيرٌ':Added, #1: 1	كَوْنَ الضَّمِيرِ
u'كَوْنٌ طَاعُونٌ':Added, #1: 1	كَوْنِ الضَّمِيرِ
u'كَوْنٌ طَالِبٌ':Added, #1: 1	كَوْنِ الطَّاعُونِ
u'كَوْنٌ طَالِقٌ':Added, #1: 1	كَوْنُ الطَّالِبِ
u'كَوْنٌ طحن':Added, #1: 1	كَوْنُ طَالِقٍ
u'كَوْنٌ طَرْدٌ':Added, #1: 1	كَوْنِ الطَّحْنِ
u'كَوْنٌ طَرِيقٌ':Added, #1: 1	كَوْنِ الطَّرْدِ
u'كَوْنٌ طَرِيقٌ':Added, #1: 1	كَوْنَ الطَّرِيقِ
u'كَوْنٌ طعام':Added, #1: 1	كَوْنِ الطَّرِيقِ
u'كَوْنٌ طَعَامٌ':Added, #2: 2	كَوْنُ الطَّعَامِ
u'كَوْنٌ طعام':Added, #2: 2	كَوْنُ الطَّعَامِ
u'كَوْنٌ طَعَامٌ':Added, #3: 3	كَوْنِ الطَّعَامِ
u'كَوْنٌ طَعْنٌ':Added, #3: 3	كَوْنِ الطَّعَامِ
u'كَوْنٌ طَلاَقٌ':Added, #1: 1	كَوْنِ الطَّعْنِ
u'كَوْنٌ طَلاَقٌ':Added, #1: 1	كَوْنِ الطَّلَاقِ
u'كَوْنٌ طَلاَقٌ':Added, #3: 3	كَوْنَ الطَّلَاقِ
u'كَوْنٌ طلب':Added, #3: 3	كَوْنُ الطَّلَاقِ
u'كَوْنٌ طَلَبٌ':Added, #1: 1	كَوْنِ الطَّلَبِ
u'كَوْنٌ طَهَارَةٌ':Added, #1: 1	كَوْنِ الطَّلَبِ
u'كَوْنٌ طواف':Added, #1: 1	كَوْنَ الطَّهَارَةِ
u'كَوْنٌ طَوَافٌ':Added, #1: 1	كَوْنِ الطَّوَافِ
u'كَوْنٌ طَوْفٌ':Added, #1: 1	كَوْنِ الطَّوَافِ
u'كَوْنٌ ظاهِرٌ':Added, #1: 1	كَوْنِ الطَّوْفِ
u'كَوْنٌ ظِلٌّ':Added, #1: 1	كَوْنُ الظَّاهِرِ
u'كَوْنٌ ظُلَّةٌ':Added, #1: 1	كَوْنِ ظِلِّ
u'كَوْنٌ ظَنٌّ':Added, #1: 1	كَوْنُ ظُلَّةِ
u'كَوْنٌ ظهار':Added, #1: 1	كَوْنِ الظَّنِّ
u'كَوْنٌ ظَهْرٌ':Added, #1: 1	كَوْنُ الظِّهَارِ
u'كَوْنٌ عَادِيٌّ':Added, #1: 1	كَوْنِ الظَّهْرِ
u'كَوْنٌ عَاقِدٌ':Added, #1: 1	كَوْنَ الْعَادِيِّ
u'كَوْنٌ عَاقِدٌ':Added, #1: 1	كَوْنِ الْعَاقِدِ
u'كَوْنٌ عَاقِدٌ':Added, #1: 1	كَوْنِ عَاقِدِ
u'كَوْنٌ عَاقِلٌ':Added, #3: 3	كَوْنُ الْعَاقِدِ
u'كَوْنٌ عَالَمٌ':Added, #1: 1	كَوْنِ الْعَاقِلَةِ
u'كَوْنٌ عَامٌّ':Added, #1: 1	كَوْنَ الْعَالَمِ
u'كَوْنٌ عَامٌّ':Added, #2: 2	كَوْنُ الْعَامِّ
u'كَوْنٌ عَامِلٌ':Added, #2: 2	كَوْنِ الْعَامِّ
u'كَوْنٌ عَامِلٌ':Added, #3: 3	كَوْنُ الْعَامِلِ
u'كَوْنٌ عِبَادَةٌ':Added, #5: 5	كَوْنِ الْعَامِلِ
u'كَوْنٌ عِبَادَةٌ':Added, #1: 1	كَوْنِ الْعِبَادَةِ
u'كَوْنٌ عَبْدٌ':Added, #2: 2	كَوْنَ الْعِبَادَةِ
u'كَوْنٌ عَبْدٌ':Added, #1: 1	كَوْنِ الْعَبْدَيْنِ
u'كَوْنٌ عَبْدٌ':Added, #1: 1	كَوْنَ عَبْدِ
u'كَوْنٌ عَبْدٌ':Added, #1: 1	كَوْنِ عَبْدِهِ
u'كَوْنٌ عَبْدٌ':Added, #2: 2	كَوْنُ الْعَبْدِ
u'كَوْنٌ عَبْدٌ':Added, #2: 2	كَوْنُ عَبْدِ
u'كَوْنٌ عَبْدٌ':Added, #4: 4	كَوْنَ الْعَبْدِ
u'كَوْنٌ عتق':Added, #6: 6	كَوْنِ الْعَبْدِ
u'كَوْنٌ عِتْقٌ':Added, #1: 1	كَوْنُ الْعِتْقِ
u'كَوْنٌ عتق':Added, #1: 1	كَوْنُ الْعِتْقِ
u'كَوْنٌ عِتْقٌ':Added, #2: 2	كَوْنِ الْعِتْقِ
u'كَوْنٌ عجز':Added, #2: 2	كَوْنِ الْعِتْقِ
u'كَوْنٌ عَجْزٌ':Added, #1: 1	كَوْنُ الْعَجْزِ
u'كَوْنٌ عِدَّةٌ':Added, #1: 1	كَوْنُ الْعَجْزِ
u'كَوْنٌ عَدَدٌ':Added, #1: 1	كَوْنُ عِدَّةِ
u'كَوْنٌ عَدَدٌ':Added, #1: 1	كَوْنِ الْعَدَدِ
u'كَوْنٌ عَدَمٌ':Added, #1: 1	كَوْنِ عَدَدٍ
u'كَوْنٌ عَدَمٌ':Added, #1: 1	كَوْنَ عَدَمِ
u'كَوْنٌ عَدَمٌ':Added, #2: 2	كَوْنِ الْعَدَمِ
u'كَوْنٌ عَدَمٌ':Added, #3: 3	كَوْنُ عَدَمِ
u'كَوْنٌ عَدُوٌّ':Added, #4: 4	كَوْنِ عَدَمِ
u'كَوْنٌ عَرَضٌ':Added, #1: 1	كَوْنُ الْعَدُوِّ
u'كَوْنٌ عَرَضٌ':Added, #1: 1	كَوْنُ الْعَرَضِ
u'كَوْنٌ عَرْضٌ':Added, #1: 1	كَوْنِ الْعَرَضِ
u'كَوْنٌ عرف':Added, #1: 1	كَوْنَ الْعَرْضِ
u'كَوْنٌ عرف':Added, #1: 1	كَوْنُ الْعُرْفِ
u'كَوْنٌ عُرْفٌ':Added, #1: 1	كَوْنِ الْعُرْفِ
u'كَوْنٌ عُرْفٌ':Added, #1: 1	كَوْنُ الْعُرْفِ
u'كَوْنٌ عَرَقٌ':Added, #1: 1	كَوْنِ الْعُرْفِ
u'كَوْنٌ عزل':Added, #1: 1	كَوْنَ عَرَقِ
u'كَوْنٌ عَزْمٌ':Added, #1: 1	كَوْنَ الْعَزْلِ
u'كَوْنٌ عَسْكَرٌ':Added, #1: 1	كَوْنَ الْعَزْمِ
u'كَوْنٌ عَشَاءٌ':Added, #1: 1	كَوْنُ الْعَسْكَرِ
u'كَوْنٌ عِشْقٌ':Added, #1: 1	كَوْنِ الْعَشَاءِ
u'كَوْنٌ عُضْوٌ':Added, #2: 2	كَوْنُ الْعِشْقِ
u'كَوْنٌ عطف':Added, #1: 1	كَوْنُ الْعُضْوِ
u'كَوْنٌ عطف':Added, #2: 2	كَوْنُ الْعَطْفِ
u'كَوْنٌ عَطْفٌ':Added, #2: 2	كَوْنِ الْعَطْفِ
u'كَوْنٌ عَطْفٌ':Added, #2: 2	كَوْنُ الْعَطْفِ
u'كَوْنٌ عَقَارٌ':Added, #2: 2	كَوْنِ الْعَطْفِ
u'كَوْنٌ عَقَارٌ':Added, #1: 1	كَوْنُ الْعَقَارِ
u'كَوْنٌ عَقْدٌ':Added, #1: 1	كَوْنُ عَقَارِهِ
u'كَوْنٌ عَقْدٌ':Added, #1: 1	كَوْنُ الْعَقْدِ
u'كَوْنٌ عَقْلٌ':Added, #7: 7	كَوْنِ الْعَقْدِ
u'كَوْنٌ عَقْلٌ':Added, #1: 1	كَوْنُ الْعَقْلِ
u'كَوْنٌ عُقُوبَةٌ':Added, #1: 1	كَوْنِ الْعَقْلِ
u'كَوْنٌ عُقُوقٌ':Added, #1: 1	كَوْنِ الْعُقُوبَةِ
u'كَوْنٌ عَلاَقَةٌ':Added, #1: 1	كَوْنِ الْعُقُوقِ
u'كَوْنٌ عَلاَقَةٌ':Added, #1: 1	كَوْنُ الْعَلَاقَةِ
u'كَوْنٌ عَلاَمَةٌ':Added, #1: 1	كَوْنِ الْعَلَاقَةِ
u'كَوْنٌ عِلَّةٌ':Added, #1: 1	كَوْنَ الْعَلَامَةِ
u'كَوْنٌ عِلَّةٌ':Added, #10: 10	كَوْنِ الْعِلَّةِ
u'كَوْنٌ عِلَّةٌ':Added, #1: 1	كَوْنَ عِلَّةِ
u'كَوْنٌ عِلَّةٌ':Added, #1: 1	كَوْنُ عِلَّةِ
u'كَوْنٌ عِلَّةٌ':Added, #2: 2	كَوْنِ عِلَّةِ
u'كَوْنٌ عِلَّةٌ':Added, #3: 3	كَوْنَ الْعِلَّةِ
u'كَوْنٌ علم':Added, #4: 4	كَوْنُ الْعِلَّةِ
u'كَوْنٌ علم':Added, #1: 1	كَوْنَ الْعِلْمِ
u'كَوْنٌ عِلْمٌ':Added, #1: 1	كَوْنُ الْعِلْمِ
u'كَوْنٌ عِلْمٌ':Added, #1: 1	كَوْنَ الْعِلْمِ
u'كَوْنٌ علم':Added, #1: 1	كَوْنُ الْعِلْمِ
u'كَوْنٌ عِلْمٌ':Added, #1: 1	كَوْنِ عِلْمِ
u'كَوْنٌ علم':Added, #1: 1	كَوْنِ عِلْمِ
u'كَوْنٌ عِلْمٌ':Added, #2: 2	كَوْنِ الْعِلْمِ
u'كَوْنٌ عُلْوٌ':Added, #2: 2	كَوْنِ الْعِلْمِ
u'كَوْنٌ عُلُوقٌ':Added, #1: 1	كَوْنِ الْعُلْوِ
u'كَوْنٌ عُلُوقٌ':Added, #1: 1	كَوْنِ الْعُلُوقِ
u'كَوْنٌ عِلِّيٌّ':Added, #3: 3	كَوْنُ الْعُلُوقِ
u'كَوْنٌ عَمْدٌ':Added, #2: 2	كَوْنُ الْعِلِّيَّةِ
u'كَوْنٌ عمرة':Added, #1: 1	كَوْنِ عَمْدِهِ
u'كَوْنٌ عُمْرَةٌ':Added, #2: 2	كَوْنُ الْعُمْرَةِ
u'كَوْنٌ عَمَلٌ':Added, #2: 2	كَوْنُ الْعُمْرَةِ
u'كَوْنٌ عَمَلٌ':Added, #1: 1	كَوْنَ الْعَمَلِ
u'كَوْنٌ عَمَلٌ':Added, #1: 1	كَوْنُ الْعَمَلِ
u'كَوْنٌ عُمُومٌ':Added, #2: 2	كَوْنِ الْعَمَلِ
u'كَوْنٌ عُمُومٌ':Added, #1: 1	كَوْنِ الْعُمُومِ
u'كَوْنٌ عُمُومٌ':Added, #1: 1	كَوْنُ عُمُومِ
u'كَوْنٌ عُمُومٌ':Added, #1: 1	كَوْنِ عُمُومِ
u'كَوْنٌ عُودٌ':Added, #2: 2	كَوْنُ عُمُومِهِ
u'كَوْنٌ عِوَضٌ':Added, #1: 1	كَوْنُ الْعُودِ
u'كَوْنٌ عِوَضٌ':Added, #2: 2	كَوْنِ الْعِوَضِ
u'كَوْنٌ عَيْبٌ':Added, #7: 7	كَوْنُ الْعِوَضِ
u'كَوْنٌ عَيْبٌ':Added, #1: 1	كَوْنَ الْعَيْبِ
u'كَوْنٌ عين':Added, #1: 1	كَوْنِ الْعَيْبِ
u'كَوْنٌ عَيْنٌ':Added, #1: 1	كَوْنَ الْعَيْنِ
u'كَوْنٌ عَيْن':Added, #1: 1	كَوْنَ الْعَيْنِ
u'كَوْنٌ عين':Added, #1: 1	كَوْنَ الْعَيْنِ
u'كَوْنٌ عَيْنٌ':Added, #2: 2	كَوْنِ الْعَيْنِ
u'كَوْنٌ عَيْن':Added, #2: 2	كَوْنِ الْعَيْنِ
u'كَوْنٌ عين':Added, #2: 2	كَوْنِ الْعَيْنِ
u'كَوْنٌ عَيْنٌ':Added, #4: 4	كَوْنُ الْعَيْنِ
u'كَوْنٌ عَيْن':Added, #4: 4	كَوْنُ الْعَيْنِ
u'كَوْنٌ غاسِل':Added, #4: 4	كَوْنُ الْعَيْنِ
u'كَوْنٌ غاسِل':Added, #1: 1	كَوْنِ غَاسِلِ
u'كَوْنٌ غَاصِبٌ':Added, #3: 3	كَوْنُ الْغَاسِلِ
u'كَوْنٌ غَالِبٌ':Added, #1: 1	كَوْنُ الْغَاصِبِ
u'كَوْنٌ غَائِبٌ':Added, #1: 1	كَوْنِ غَالِبٍ
u'كَوْنٌ غَايَةٌ':Added, #1: 1	كَوْنَ الْغَائِبِ
u'كَوْنٌ غَدٌ':Added, #1: 1	كَوْنَ الْغَايَةِ
u'كَوْنٌ غَدٌ':Added, #1: 1	كَوْنِ الْغَدِ
u'كَوْنٌ غُرَابٌ':Added, #2: 2	كَوْنُ غَدٍ
u'كَوْنٌ غِرَاسٌ':Added, #1: 1	كَوْنِ الْغُرَابِ
u'كَوْنٌ غَسْلٌ':Added, #1: 1	كَوْنَ الْغِرَاسِ
u'كَوْنٌ غَسْلٌ':Added, #1: 1	كَوْنِ الْغَسْلِ
u'كَوْنٌ غُسْلٌ':Added, #1: 1	كَوْن غَسْلِ
u'كَوْنٌ غَصْبٌ':Added, #2: 2	كَوْنُ الْغُسْلِ
u'كَوْنٌ غَصْبٌ':Added, #1: 1	كَوْنُ الْغَصْبِ
u'كَوْنٌ غُلاَمٌ':Added, #3: 3	كَوْنِ الْغَصْبِ
u'كَوْنٌ غَلَبَةٌ':Added, #2: 2	كَوْنُ الْغُلَامِ
u'كَوْنٌ غناء':Added, #2: 2	كَوْنُ الْغَلَبَةِ
u'كَوْنٌ غِنَاءٌ':Added, #1: 1	كَوْنُ الْغِنَاءِ
u'كَوْنٌ غَنَائِمُ':Added, #1: 1	كَوْنُ الْغِنَاءِ
u'كَوْنٌ غِيبَةٌ':Added, #1: 1	كَوْنُ الْغَنَائِمِ
u'كَوْنٌ غير':Added, #1: 1	كَوْنِ الْغِيبَةِ
u'كَوْنٌ غير':Added, #1: 1	كَوْنَ الْغَيْرِ
u'كَوْنٌ غَيْرٌ':Added, #1: 1	كَوْنِ الْغَيْرِ
u'كَوْنٌ غَيْرٌ':Added, #1: 1	كَوْنَ الْغَيْرِ
u'كَوْنٌ غير':Added, #1: 1	كَوْنِ الْغَيْرِ
u'كَوْنٌ غير':Added, #1: 1	كَوْنُ غَيْرِ
u'كَوْنٌ غَيْرٌ':Added, #1: 1	كَوْنِ غَيْرِ
u'كَوْنٌ غَيْرٌ':Added, #1: 1	كَوْنُ غَيْرِ
u'كَوْنٌ غير':Added, #1: 1	كَوْنِ غَيْرِ
u'كَوْنٌ غير':Added, #1: 1	كَوْنَ غَيْرِهِ
u'كَوْنٌ غَيْرٌ':Added, #1: 1	كَوْنِ غَيْرِهِ
u'كَوْنٌ غَيْرٌ':Added, #1: 1	كَوْنَ غَيْرِهِ
u'كَوْنٌ فاء':Added, #1: 1	كَوْنِ غَيْرِهِ
u'كَوْنٌ فَاتِحٌ':Added, #1: 1	كَوْنِ الْفَاءِ
u'كَوْنٌ فَاتِحَةٌ':Added, #1: 1	كَوْنِ الْفَاتِحَةِ
u'كَوْنٌ فَاسِقٌ':Added, #1: 1	كَوْنِ الْفَاتِحَةِ
u'كَوْنٌ فَاعِلٌ':Added, #1: 1	كَوْنِ الْفَاسِقِ
u'كَوْنٌ فَاعِلٌ':Added, #1: 1	كَوْنُ الْفَاعِلِ
u'كَوْنٌ فَاعِلٌ':Added, #1: 1	كَوْنُ فَاعِلِهِ
u'كَوْنٌ فَاعِلٌ':Added, #2: 2	كَوْنِ فَاعِلِهِ
u'كَوْنٌ فَائِدَةٌ':Added, #3: 3	كَوْنَ الْفَاعِلِ
u'كَوْنٌ فَتْحٌ':Added, #1: 1	كَوْنِ الْفَائِدَةِ
u'كَوْنٌ فخر':Added, #1: 1	كَوْنِ الْفَتْحِ
u'كَوْنٌ فَخْرٌ':Added, #1: 1	كَوْنَ فَخْرِ
u'كَوْنٌ فِدَاءٌ':Added, #1: 1	كَوْنَ فَخْرِ
u'كَوْنٌ فَرْجٌ':Added, #1: 1	كَوْنَ الْفِدَاءِ
u'كَوْنٌ فَرْجٌ':Added, #1: 1	كَوْنُ الْفَرْجِ
u'كَوْنٌ فَرْعٌ':Added, #1: 1	كَوْنِ فَرْجِهِ
u'كَوْنٌ فَرْعٌ':Added, #1: 1	كَوْنَ الْفَرْعِ
u'كَوْنٌ فَرْعٌ':Added, #1: 1	كَوْنِ الْفَرْعِ
u'كَوْنٌ فَرْعٌ':Added, #1: 1	كَوْنُ فَرْعِ
u'كَوْنٌ فُرْقَةٌ':Added, #2: 2	كَوْنُ الْفَرْعِ
u'كَوْنٌ فُرْقَةٌ':Added, #1: 1	كَوْنُ الْفُرْقَةِ
u'كَوْنٌ فِرْقَةٌ':Added, #1: 1	كَوْنِ الْفُرْقَةِ
u'كَوْنٌ فساد':Added, #1: 1	كَوْنُ الْفِرْقَةِ
u'كَوْنٌ فَسَادٌ':Added, #1: 1	كَوْنِ الْفَسَادِ
u'كَوْنٌ فساد':Added, #1: 1	كَوْنِ الْفَسَادِ
u'كَوْنٌ فَسَادٌ':Added, #2: 2	كَوْنُ الْفَسَادِ
u'كَوْنٌ فَسْخٌ':Added, #2: 2	كَوْنُ الْفَسَادِ
u'كَوْنٌ فَسْخٌ':Added, #1: 1	كَوْنِ فَسْخِهِ
u'كَوْنٌ فَضْلٌ':Added, #2: 2	كَوْنَ الْفَسْخِ
u'كَوْنٌ فُضُولِيٌّ':Added, #1: 1	كَوْنُ الْفَضْلِ
u'كَوْنٌ فِطْرٌ':Added, #1: 1	كَوْنِ الْفُضُولِيِّ
u'كَوْنٌ فِطْرٌ':Added, #1: 1	كَوْنُ الْفِطْرِ
u'كَوْنٌ فِعْلٌ':Added, #1: 1	كَوْنِ الْفِطْرِ
u'كَوْنٌ فِعْلٌ':Added, #16: 16	كَوْنِ الْفِعْلِ
u'كَوْنٌ فِعْلٌ':Added, #1: 1	كَوْنُ الْفِعْلَيْنِ
u'كَوْنٌ فِعْلٌ':Added, #1: 1	كَوْنَ فِعْلِهِ
u'كَوْنٌ فِعْلٌ':Added, #2: 2	كَوْنَ الْفِعْلِ
u'كَوْنٌ فِعْلٌ':Added, #2: 2	كَوْنُ فِعْلِ
u'كَوْنٌ فِعْلٌ':Added, #2: 2	كَوْنِ فِعْلِ
u'كَوْنٌ فِعْلٌ':Added, #2: 2	كَوْنُ فِعْلِهِ
u'كَوْنٌ فِعْلٌ':Added, #3: 3	كَوْنِ فِعْلِهِ
u'كَوْنٌ فِقْهٌ':Added, #9: 9	كَوْنُ الْفِعْلِ
u'كَوْنٌ فِقْهٌ':Added, #2: 2	كَوْنُ الْفِقْهِ
u'كَوْنٌ فلان':Added, #4: 4	كَوْنِ الْفِقْهِ
u'كَوْنٌ فلان':Added, #1: 1	كَوْنُ الرُّكْنِيَّةِ
u'كَوْنٌ فلان':Added, #1: 1	كَوْنُ الزُّبَيْرِ
u'كَوْنٌ فلان':Added, #1: 1	كَوْنُ الشَّافِعِيِّ
u'كَوْنٌ فلان':Added, #1: 1	كَوْنِ الشَّافِعِيِّ
u'كَوْنٌ فلان':Added, #1: 1	كَوْنِ الْمَمْدُوحِيَّةِ
u'كَوْنٌ قَاتِلٌ':Added, #1: 1	كَوْنُ الْهَاشِمِيِّ
u'كَوْنٌ قَاتِلٌ':Added, #1: 1	كَوْنُ الْقَاتِلِ
u'كَوْنٌ قَاتِلٌ':Added, #1: 1	كَوْنِ الْقَاتِلِ
u'كَوْنٌ قَاذِفٌ':Added, #1: 1	كَوْنُ قَاتِلِهِ
u'كَوْنٌ قَافِلٌ':Added, #1: 1	كَوْنَ الْقَاذِفِ
u'كَوْنٌ قَافِلَةٌ':Added, #1: 1	كَوْنِ الْقَافِلَةِ
u'كَوْنٌ قَائِمٌ':Added, #1: 1	كَوْنِ الْقَافِلَةِ
u'كَوْنٌ قَبْرٌ':Added, #1: 1	كَوْنِ الْقَائِمِ
u'كَوْنٌ قَبْضٌ':Added, #1: 1	كَوْنِ الْقَبْرِ
u'كَوْنٌ قُبْلَةٌ':Added, #1: 1	كَوْنُ الْقَبْضِ
u'كَوْنٌ قَبُولٌ':Added, #1: 1	كَوْنِ الْقُبْلَةِ
u'كَوْنٌ قَبُولٌ':Added, #1: 1	كَوْنَ قَبُولِ
u'كَوْنٌ قَبُولٌ':Added, #1: 1	كَوْنِ قَبُولِ
u'كَوْنٌ قتل':Added, #3: 3	كَوْنِ الْقَبُولِ
u'كَوْنٌ قَتْلٌ':Added, #1: 1	كَوْنَ الْقَتْلِ
u'كَوْنٌ قتل':Added, #1: 1	كَوْنَ الْقَتْلِ
u'كَوْنٌ قَتْلٌ':Added, #1: 1	كَوْنُ قَتْلِ
u'كَوْنٌ قتل':Added, #1: 1	كَوْنُ قَتْلِ
u'كَوْنٌ قتل':Added, #2: 2	كَوْنُ الْقَتْلِ
u'كَوْنٌ قَتْلٌ':Added, #2: 2	كَوْنِ الْقَتْلِ
u'كَوْنٌ قَتْلٌ':Added, #2: 2	كَوْنُ الْقَتْلِ
u'كَوْنٌ قَدْرٌ':Added, #2: 2	كَوْنِ الْقَتْلِ
u'كَوْنٌ قَدْرٌ':Added, #1: 1	كَوْنُ الْقَدْرِ
u'كَوْنٌ قدرة':Added, #1: 1	كَوْنَ قَدْرِ
u'كَوْنٌ قُدْرَةٌ':Added, #1: 1	كَوْنُ الْقُدْرَةِ
u'كَوْنٌ قِرَاءةٌ':Added, #1: 1	كَوْنُ الْقُدْرَةِ
u'كَوْنٌ قِرَاءةٌ':Added, #1: 1	كَوْنِ الْقِرَاءَةِ
u'كَوْنٌ قِرْبَةٌ':Added, #2: 2	كَوْنَ الْقِرَاءَةِ
u'كَوْنٌ قَرِيبٌ':Added, #1: 1	كَوْنِ الْقِرْبَةِ
u'كَوْنٌ قَرِيبٌ':Added, #1: 1	كَوْنُ الْقَرِيبِ
u'كَوْنٌ قَسام':Added, #1: 1	كَوْنُ قَرِيبِ
u'كَوْنٌ قَسامَة':Added, #1: 1	كَوْنُ الْقَسَامَةِ
u'كَوْنٌ قِسْمٌ':Added, #1: 1	كَوْنُ الْقَسَامَةِ
u'كَوْنٌ قصاص':Added, #1: 1	كَوْنُ الْقِسْمِ
u'كَوْنٌ قِصَاصٌ':Added, #1: 1	كَوْنَ الْقِصَاصِ
u'كَوْنٌ قصاص':Added, #1: 1	كَوْنَ الْقِصَاصِ
u'كَوْنٌ قِصَاصٌ':Added, #3: 3	كَوْنِ الْقِصَاصِ
u'كَوْنٌ قَصْدٌ':Added, #3: 3	كَوْنِ الْقِصَاصِ
u'كَوْنٌ قَصْدٌ':Added, #1: 1	كَوْنَ الْقَصْدِ
u'كَوْنٌ قَضَاءٌ':Added, #1: 1	كَوْنُ الْقَصْدِ
u'كَوْنٌ قَضَاءٌ':Added, #1: 1	كَوْنَ الْقَضَاءِ
u'كَوْنٌ قِطَارٌ':Added, #1: 1	كَوْنِ الْقَضَاءِ
u'كَوْنٌ قُطْبٌ':Added, #1: 1	كَوْنُ الْقِطَارِ
u'كَوْنٌ قَطْرَانٌ':Added, #1: 1	كَوْنِ الْقُطْبِ
u'كَوْنٌ قَطْعٌ':Added, #1: 1	كَوْنِ الْقَطْرَانِ
u'كَوْنٌ قطعة':Added, #3: 3	كَوْنِ الْقَطْعِ
u'كَوْنٌ قِطْعَةٌ':Added, #1: 1	كَوْنَ قِطْعَةِ
u'كَوْنٌ قُعُودٌ':Added, #1: 1	كَوْنَ قِطْعَةِ
u'كَوْنٌ قُلَّةٌ':Added, #1: 1	كَوْنِ الْقُعُودِ
u'كَوْنٌ قمر':Added, #1: 1	كَوْنِ الْقُلَّةِ
u'كَوْنٌ قَمَرٌ':Added, #1: 1	كَوْنِ الْقَمَرِ
u'كَوْنٌ قول':Added, #1: 1	كَوْنِ الْقَمَرِ
u'كَوْنٌ قول':Added, #1: 1	كَوْنَ الْقَوْلِ
u'كَوْنٌ قَوْلٌ':Added, #1: 1	كَوْنِ الْقَوْلِ
u'كَوْنٌ قَوْلٌ':Added, #1: 1	كَوْنَ الْقَوْلِ
u'كَوْنٌ قول':Added, #1: 1	كَوْنِ الْقَوْلِ
u'كَوْنٌ قَوْلٌ':Added, #1: 1	كَوْنَ قَوْلِ
u'كَوْنٌ قول':Added, #1: 1	كَوْنَ قَوْلِ
u'كَوْنٌ قَوْلٌ':Added, #2: 2	كَوْنِ قَوْلِهِ
u'كَوْنٌ قول':Added, #2: 2	كَوْنِ قَوْلِهِ
u'كَوْنٌ قَوْلٌ':Added, #3: 3	كَوْنُ الْقَوْلِ
u'كَوْنٌ قول':Added, #3: 3	كَوْنُ الْقَوْلِ
u'كَوْنٌ قَوْلٌ':Added, #3: 3	كَوْنُ قَوْلِ
u'كَوْنٌ قول':Added, #3: 3	كَوْنُ قَوْلِ
u'كَوْنٌ قَوْلٌ':Added, #4: 4	كَوْنِ قَوْلِ
u'كَوْنٌ قِيَاسٌ':Added, #4: 4	كَوْنِ قَوْلِ
u'كَوْنٌ قِيَاسٌ':Added, #4: 4	كَوْنَ الْقِيَاسِ
u'كَوْنٌ قِيَاسٌ':Added, #4: 4	كَوْنُ الْقِيَاسِ
u'كَوْنٌ قيام':Added, #4: 4	كَوْنِ الْقِيَاسِ
u'كَوْنٌ قيام':Added, #1: 1	كَوْنَ الْقِيَامِ
u'كَوْنٌ قِيَامٌ':Added, #1: 1	كَوْنِ الْقِيَامِ
u'كَوْنٌ قِيَامٌ':Added, #1: 1	كَوْنَ الْقِيَامِ
u'كَوْنٌ قيام':Added, #1: 1	كَوْنِ الْقِيَامِ
u'كَوْنٌ قِيَامٌ':Added, #2: 2	كَوْنِ قِيَامِ
u'كَوْنٌ قَيْدٌ':Added, #2: 2	كَوْنِ قِيَامِ
u'كَوْنٌ قَيْدٌ':Added, #1: 1	كَوْنَ الْقَيْدِ
u'كَوْنٌ قِيمَةٌ':Added, #1: 1	كَوْنِ الْقَيْدِ
u'كَوْنٌ قِيمَةٌ':Added, #1: 1	كَوْنُ قِيمَةِ
u'كَوْنٌ قِيمَةٌ':Added, #1: 1	كَوْنُ قِيمَتِهِ
u'كَوْنٌ كَاتِبٌ':Added, #2: 2	كَوْنِ قِيمَةِ
u'كَوْنٌ كَاذِبٌ':Added, #1: 1	كَوْنُ الْكَاتِبِ
u'كَوْنٌ كَاذِبٌ':Added, #1: 1	كَوْنُ الْكَاذِبِ
u'كَوْنٌ كَافِرٌ':Added, #3: 3	كَوْنُ الْكَاذِبَةِ
u'كَوْنٌ كَائِنٌ':Added, #1: 1	كَوْنَ الْكَافِرِ
u'كَوْنٌ كِتاب':Added, #1: 1	كَوْنِ الْكَائِنِ
u'كَوْنٌ كِتَابٌ':Added, #1: 1	كَوْنِ الْكِتَابِيَّةِ
u'كَوْنٌ كِتَابَةٌ':Added, #2: 2	كَوْنِ الْكِتَابِ
u'كَوْنٌ كِتَابَةٌ':Added, #1: 1	كَوْنُ الْكِتَابَةِ
u'كَوْنٌ كِتابَة':Added, #1: 1	كَوْنِ الْكِتَابَةِ
u'كَوْنٌ كِتابِيّ':Added, #1: 1	كَوْنِ الْكِتَابِيَّةِ
u'كَوْنٌ كذب':Added, #1: 1	كَوْنِ الْكِتَابِيَّةِ
u'كَوْنٌ كَذِبٌ':Added, #1: 1	كَوْنِ الْكَذِبِ
u'كَوْنٌ كِرَاءٌ':Added, #1: 1	كَوْنِ الْكَذِبِ
u'كَوْنٌ كَرَاهَةٌ':Added, #1: 1	كَوْنِ كِرَاءِ
u'كَوْنٌ كَرَاهَةٌ':Added, #1: 1	كَوْنَ الْكَرَاهَةِ
u'كَوْنٌ كَرَاهَةٌ':Added, #1: 1	كَوْنِ الْكَرَاهَةِ
u'كَوْنٌ كَسْبٌ':Added, #1: 1	كَوْنَ كَرَاهَةِ
u'كَوْنٌ كَسْبٌ':Added, #1: 1	كَوْنُ الْكَسْبِ
u'كَوْنٌ كَفٌّ':Added, #1: 1	كَوْنَ كَسْبِ
u'كَوْنٌ كُفَّارٌ':Added, #1: 1	كَوْنِ الْكَفِّ
u'كَوْنٌ كَفَّارٌ':Added, #1: 1	كَوْنُ الْكُفَّارِ
u'كَوْنٌ كَفَّارَةٌ':Added, #2: 2	كَوْنُ الْكَفَّارَةِ
u'كَوْنٌ كَفَالَةٌ':Added, #2: 2	كَوْنُ الْكَفَّارَةِ
u'كَوْنٌ كفر':Added, #2: 2	كَوْنِ الْكَفَالَةِ
u'كَوْنٌ كُفْرٌ':Added, #1: 1	كَوْنُ كُفْرِ
u'كَوْنٌ كَفِيلٌ':Added, #1: 1	كَوْنُ كُفْرِ
u'كَوْنٌ كَلاَمٌ':Added, #1: 1	كَوْنِ الْكَفِيلِ
u'كَوْنٌ كَلاَمٌ':Added, #1: 1	كَوْنَ كَلَامِ
u'كَوْنٌ كَلاَمٌ':Added, #1: 1	كَوْنِ كَلَامِهِ
u'كَوْنٌ كَلاَمٌ':Added, #2: 2	كَوْنُ الْكَلَامِ
u'كَوْنٌ كَلام':Added, #2: 2	كَوْنِ الْكَلَامِ
u'كَوْنٌ كَلْبٌ':Added, #3: 3	كَوْنِ الْكَلَامَيْنِ
u'كَوْنٌ لاَزِمٌ':Added, #2: 2	كَوْنِ الْكَلْبِ
u'كَوْنٌ لاَزِمٌ':Added, #2: 2	كَوْنِ اللَّازِمِ
u'كَوْنٌ لاَزِمٌ':Added, #2: 2	كَوْنِ لَازِمِ
u'كَوْنٌ لاَمٌ':Added, #3: 3	كَوْنُ اللَّازِمِ
u'كَوْنٌ لاَمِسٌ':Added, #1: 1	كَوْنِ اللَّامِ
u'كَوْنٌ لاَمِسَةٌ':Added, #1: 1	كَوْنُ اللَّامِسَةِ
u'كَوْنٌ لَبَدٌ':Added, #1: 1	كَوْنُ اللَّامِسَةِ
u'كَوْنٌ لبس':Added, #1: 1	كَوْنِ اللَّبَدِ
u'كَوْنٌ لبس':Added, #1: 1	كَوْنُ اللُّبْسِ
u'كَوْنٌ لُبْسٌ':Added, #1: 1	كَوْنِ اللُّبْسِ
u'كَوْنٌ لُبْسٌ':Added, #1: 1	كَوْنُ اللُّبْسِ
u'كَوْنٌ لبس':Added, #1: 1	كَوْنِ اللُّبْسِ
u'كَوْنٌ لُبْسٌ':Added, #1: 1	كَوْنَ لُبْسِ
u'كَوْنٌ لبن':Added, #1: 1	كَوْنَ لُبْسِ
u'كَوْنٌ لَبَنٌ':Added, #2: 2	كَوْنُ اللَّبَنِ
u'كَوْنٌ لبن':Added, #2: 2	كَوْنُ اللَّبَنِ
u'كَوْنٌ لَبَنٌ':Added, #4: 4	كَوْنِ اللَّبَنِ
u'كَوْنٌ لعاب':Added, #4: 4	كَوْنِ اللَّبَنِ
u'كَوْنٌ لُعَابٌ':Added, #1: 1	كَوْنِ اللُّعَابِ
u'كَوْنٌ لُغَةٌ':Added, #1: 1	كَوْنِ اللُّعَابِ
u'كَوْنٌ لَفْظٌ':Added, #1: 1	كَوْنِ اللُّغَاتِ
u'كَوْنٌ لَفْظٌ':Added, #11: 11	كَوْنُ اللَّفْظِ
u'كَوْنٌ لَفْظٌ':Added, #17: 17	كَوْنِ اللَّفْظِ
u'كَوْنٌ لَفْظٌ':Added, #1: 1	كَوْنِ لَفْظِ
u'كَوْنٌ لَفْظٌ':Added, #1: 1	كَوْنُ لَفْظِهِ
u'كَوْنٌ لَفْظٌ':Added, #2: 2	كَوْنَ لَفْظِ
u'كَوْنٌ لقطة':Added, #3: 3	كَوْنَ اللَّفْظِ
u'كَوْنٌ لَمْسٌ':Added, #1: 1	كَوْنُ اللُّقَطَةِ
u'كَوْنٌ لَيْلٌ':Added, #1: 1	كَوْنَ اللَّمْسِ
u'كَوْنٌ مَاءٌ':Added, #1: 1	كَوْنُ اللَّيْلِ
u'كَوْنٌ مَاءٌ':Added, #1: 1	كَوْنِ مَاءِ
u'كَوْنٌ مَاءٌ':Added, #3: 3	كَوْنَ الْمَاءِ
u'كَوْنٌ مَاءٌ':Added, #3: 3	كَوْنُ الْمَاءِ
u'كَوْنٌ مَاسِحٌ':Added, #6: 6	كَوْنِ الْمَاءِ
u'كَوْنٌ مَالٌ':Added, #1: 1	كَوْنُ الْمَاسِحِ
u'كَوْنٌ مَالٌ':Added, #16: 16	كَوْنُ الْمَالِ
u'كَوْنٌ مَالٌ':Added, #1: 1	كَوْنُ مَالِ
u'كَوْنٌ مَالٌ':Added, #1: 1	كَوْنِ مَالِهِ
u'كَوْنٌ مَالٌ':Added, #2: 2	كَوْنُ مَالِهِ
u'كَوْنٌ مَالٌ':Added, #4: 4	كَوْنِ الْمَالِ
u'كَوْنٌ مَالِكٌ':Added, #5: 5	كَوْنَ الْمَالِ
u'كَوْنٌ مالِكِيّ':Added, #3: 3	كَوْنِ الْمَالِكِ
u'كَوْنٌ مَالِيٌّ':Added, #1: 1	كَوْنِ الْمَالِكِيِّ
u'كَوْنٌ مَأْمُورٌ':Added, #1: 1	كَوْنَ مَالِيَّةِ
u'كَوْنٌ مَأْمُورٌ':Added, #2: 2	كَوْنَ الْمَأْمُورِ
u'كَوْنٌ مُبَاحٌ':Added, #2: 2	كَوْنِ الْمَأْمُورِ
u'كَوْنٌ مَبَادِئُ':Added, #1: 1	كَوْنِ الْمُبَاحِ
u'كَوْنٌ مُبْتَدِئٌ':Added, #1: 1	كَوْنُ الْمَبَادِئِ
u'كَوْنٌ مَبْدَأٌ':Added, #1: 1	كَوْنِ الْمُبْتَدِئِ
u'كَوْنٌ مَبْعُوثٌ':Added, #1: 1	كَوْنِ الْمَبْدَأِ
u'كَوْنٌ مُبَلِّغٌ':Added, #1: 1	كَوْنُ الْمَبْعُوثِ
u'كَوْنٌ مُبَلِّغٌ':Added, #1: 1	كَوْنَ الْمُبَلِّغِ
u'كَوْنٌ مَبِيعٌ':Added, #1: 1	كَوْنُ الْمُبَلِّغِ
u'كَوْنٌ مَبِيعٌ':Added, #4: 4	كَوْنُ الْمَبِيعِ
u'كَوْنٌ مَبِيعٌ':Added, #5: 5	كَوْنَ الْمَبِيعِ
u'كَوْنٌ مُتَّجَهٌ':Added, #7: 7	كَوْنِ الْمَبِيعِ
u'كَوْنٌ مُتَحَرِّكٌ':Added, #1: 1	كَوْنُ الْمُتَّجَهِ
u'كَوْنٌ مَتْرُوكٌ':Added, #1: 1	كَوْنِ الْمُتَحَرِّكِ
u'كَوْنٌ مُتَزَوِّجٌ':Added, #1: 1	كَوْنِ الْمَتْرُوكِ
u'كَوْنٌ مُتَصَرِّفٌ':Added, #1: 1	كَوْنِ الْمُتَزَوِّجِ
u'كَوْنٌ مُتَّصِلٌ':Added, #1: 1	كَوْنِ الْمُتَصَرِّفِ
u'كَوْنٌ مُتَعَلِّقٌ':Added, #1: 1	كَوْنُ الْمُتَّصِلِ
u'كَوْنٌ مُتَعَلِّقٌ':Added, #1: 1	كَوْنُ الْمُتَعَلِّقِ
u'كَوْنٌ مُتَلَبِّسٌ':Added, #1: 1	كَوْنَ مُتَعَلِّقِ
u'كَوْنٌ مُتَوَاتِرٌ':Added, #1: 1	كَوْنُ الْمُتَلَبِّسِ
u'كَوْنٌ مُتَوَاتِرٌ':Added, #1: 1	كَوْنُ الْمُتَوَاتِرِ
u'كَوْنٌ مُتَوَقِّف':Added, #1: 1	كَوْنِ الْمُتَوَاتِرِ
u'كَوْنٌ مُتَوَلِّدٌ':Added, #1: 1	كَوْنِ الْمُتَوَقِّفِ
u'كَوْنٌ مثل':Added, #1: 1	كَوْنِ الْمُتَوَلِّدِ
u'كَوْنٌ مِثْلٌ':Added, #1: 1	كَوْنِ مِثْلِ
u'كَوْنٌ مَجَازٌ':Added, #1: 1	كَوْنِ مِثْلِ
u'كَوْنٌ مَجَازٌ':Added, #1: 1	كَوْنِ الْمَجَازِ
u'كَوْنٌ مَجَازِيٌّ':Added, #3: 3	كَوْنُ الْمَجَازِ
u'كَوْنٌ مُجْتَهِد':Added, #1: 1	كَوْنُ الْمَجَازِيِّ
u'كَوْنٌ مُجَرَّدٌ':Added, #1: 1	كَوْنُ الْمُجْتَهِدِ
u'كَوْنٌ مُجَرَّدٌ':Added, #1: 1	كَوْنُ مُجَرَّدِ
u'كَوْنٌ مَجْمُوعٌ':Added, #3: 3	كَوْنِ مُجَرَّدِ
u'كَوْنٌ مَجْمُوعٌ':Added, #1: 1	كَوْنِ الْمَجْمُوعِ
u'كَوْنٌ مَجْمُوعٌ':Added, #2: 2	كَوْنَ الْمَجْمُوعِ
u'كَوْنٌ مَجْنُونٌ':Added, #2: 2	كَوْنُ الْمَجْمُوعِ
u'كَوْنٌ مُحْتَالٌ':Added, #1: 1	كَوْنُ الْمَجْنُونَةِ
u'كَوْنٌ مُحَدِّثٌ':Added, #1: 1	كَوْنِ الْمُحْتَالِ
u'كَوْنٌ مُحْدَثٌ':Added, #1: 1	كَوْنِ الْمُحَدِّثِ
u'كَوْنٌ مَحْدُودٌ':Added, #1: 1	كَوْنِ الْمُحْدَثَةِ
u'كَوْنٌ مَحْرَمٌ':Added, #1: 1	كَوْنُ الْمَحْدُودِ
u'كَوْنٌ مَحْرَمٌ':Added, #1: 1	كَوْنَ الْمَحْرَمِ
u'كَوْنٌ مَحْرَمٌ':Added, #1: 1	كَوْنُ الْمَحْرَمِ
u'كَوْنٌ مُحَرَّمٌ':Added, #1: 1	كَوْنِ الْمَحْرَمِ
u'كَوْنٌ مَحَلٌّ':Added, #1: 1	كَوْنُ الْمُحَرَّمِ
u'كَوْنٌ مَحَلٌّ':Added, #1: 1	كَوْنَ الْمَحَلِّ
u'كَوْنٌ مَحَلٌّ':Added, #1: 1	كَوْنَ مَحَلِّ
u'كَوْنٌ مَحَلٌّ':Added, #2: 2	كَوْنِ مَحَلِّ
u'كَوْنٌ مَحَلٌّ':Added, #4: 4	كَوْنِ الْمَحَلِّ
u'كَوْنٌ مَحْمَلٌ':Added, #6: 6	كَوْنُ الْمَحَلِّ
u'كَوْنٌ مَحْمُودٌ':Added, #1: 1	كَوْنُ مَحْمَلِهِ
u'كَوْنٌ مُخَاطَبٌ':Added, #1: 1	كَوْنِ مَحْمُودِ
u'كَوْنٌ مُخَالَفَةٌ':Added, #2: 2	كَوْنِ الْمُخَاطَبِ
u'كَوْنٌ مُخْبِرٌ':Added, #1: 1	كَوْنِ الْمُخَالَفَةِ
u'كَوْنٌ مُخْبِرٌ':Added, #1: 1	كَوْنَ الْمُخْبِرِ
u'كَوْنٌ مُخْتَارٌ':Added, #1: 1	كَوْنِ الْمُخْبِرِ
u'كَوْنٌ مَدَارٌ':Added, #1: 1	كَوْنُ الْمُخْتَارِ
u'كَوْنٌ مَدَارٌ':Added, #1: 1	كَوْنَ الْمَدَارِ
u'كَوْنٌ مَدَارٌ':Added, #2: 2	كَوْنُ الْمَدَارِ
u'كَوْنٌ مُدَّةٌ':Added, #2: 2	كَوْنِ الْمَدَارِ
u'كَوْنٌ مُدَّةٌ':Added, #1: 1	كَوْنَ الْمُدَّةِ
u'كَوْنٌ مُدَّةٌ':Added, #1: 1	كَوْنِ الْمُدَّةِ
u'كَوْنٌ مُدَّةٌ':Added, #1: 1	كَوْنُ مُدَّةِ
u'كَوْنٌ مُدَّةٌ':Added, #1: 1	كَوْنِ مُدَّةِ
u'كَوْنٌ مَدْخُولٌ':Added, #2: 2	كَوْنُ الْمُدَّةِ
u'كَوْنٌ مَدْعُوٌّ':Added, #3: 3	كَوْنِ مَدْخُولِ
u'كَوْنٌ مَدْفُوعٌ':Added, #2: 2	كَوْنُ الْمَدْعُوِّ
u'كَوْنٌ مَدْلُولٌ':Added, #1: 1	كَوْنِ الْمَدْفُوعِ
u'كَوْنٌ مَذْكُورٌ':Added, #1: 1	كَوْنُ الْمَدْلُولِ
u'كَوْنٌ مَذْكُورٌ':Added, #1: 1	كَوْنَ الْمَذْكُورِ
u'كَوْنٌ مَذْهَبٌ':Added, #1: 1	كَوْنُ الْمَذْكُورِ
u'كَوْنٌ مَذْهَبٌ':Added, #1: 1	كَوْنَ مَذْهَبِ
u'كَوْنٌ مَذْهَبٌ':Added, #1: 1	كَوْنُ مَذْهَبِ
u'كَوْنٌ مراد':Added, #2: 2	كَوْنِ مَذْهَبِ
u'كَوْنٌ مُرَادٌ':Added, #11: 11	كَوْنَ الْمُرَادِ
u'كَوْنٌ مراد':Added, #11: 11	كَوْنَ الْمُرَادِ
u'كَوْنٌ مُرَادٌ':Added, #14: 14	كَوْنُ الْمُرَادِ
u'كَوْنٌ مراد':Added, #14: 14	كَوْنُ الْمُرَادِ
u'كَوْنٌ مُرَادٌ':Added, #16: 16	كَوْنِ الْمُرَادِ
u'كَوْنٌ مراد':Added, #16: 16	كَوْنِ الْمُرَادِ
u'كَوْنٌ مراد':Added, #1: 1	كَوْنَ مُرَادِ
u'كَوْنٌ مراد':Added, #1: 1	كَوْنُ مُرَادِ
u'كَوْنٌ مُرَادٌ':Added, #1: 1	كَوْنِ مُرَادِ
u'كَوْنٌ مُرَادٌ':Added, #1: 1	كَوْنَ مُرَادِ
u'كَوْنٌ مُرَادٌ':Added, #1: 1	كَوْنُ مُرَادِ
u'كَوْنٌ مراد':Added, #1: 1	كَوْنِ مُرَادِ
u'كَوْنٌ مُرَادٌ':Added, #2: 2	كَوْنُ مُرَادِهِ
u'كَوْنٌ مُرَاعَاةٌ':Added, #2: 2	كَوْنُ مُرَادِهِ
u'كَوْنٌ مُرَاهِقٌ':Added, #1: 1	كَوْنِ مُرَاعَاةِ
u'كَوْنٌ مَرْتَبَةٌ':Added, #1: 1	كَوْنِ الْمُرَاهِقِ
u'كَوْنٌ مُرْتَدٌّ':Added, #1: 1	كَوْنَ الْمَرْتَبَةِ
u'كَوْنٌ مُرَجِّحٌ':Added, #2: 2	كَوْنَ الْمُرْتَدِّ
u'كَوْنٌ مَرْدُودٌ':Added, #1: 1	كَوْنُ الْمُرَجِّحِ
u'كَوْنٌ مَرَضٌ':Added, #1: 1	كَوْنَ الْمَرْدُودِ
u'كَوْنٌ مَرْهُونٌ':Added, #2: 2	كَوْنِ الْمَرَضِ
u'كَوْنٌ مَرْهُونٌ':Added, #1: 1	كَوْنَ الْمَرْهُونِ
u'كَوْنٌ مَرْهُونٌ':Added, #2: 2	كَوْنُ الْمَرْهُونِ
u'كَوْنٌ مِزْمَارٌ':Added, #2: 2	كَوْنِ الْمَرْهُونِ
u'كَوْنٌ مُسَافِرٌ':Added, #1: 1	كَوْنُ الْمِزْمَارِ
u'كَوْنٌ مَسْأَلَةٌ':Added, #1: 1	كَوْنِ الْمُسَافِرِ
u'كَوْنٌ مَسْأَلَةٌ':Added, #1: 1	كَوْنَ الْمَسْأَلَةِ
u'كَوْنٌ مَسْأَلَةٌ':Added, #2: 2	كَوْنُ الْمَسْأَلَةِ
u'كَوْنٌ مَسَائِلُ':Added, #2: 2	كَوْنِ الْمَسْأَلَةِ
u'كَوْنٌ مَسْبُوق':Added, #1: 1	كَوْنِ الْمَسَائِلِ
u'كَوْنٌ مُسْتَأْجِرٌ':Added, #1: 1	كَوْنِ الْمَسْبُوقِ
u'كَوْنٌ مُسْتَحِقٌّ':Added, #3: 3	كَوْنِ الْمُسْتَأْجِرِ
u'كَوْنٌ مُسْتَحِقٌّ':Added, #1: 1	كَوْنُ الْمُسْتَحِقِّ
u'كَوْنٌ مُسْتَحِقٌّ':Added, #2: 2	كَوْنِ الْمُسْتَحِقِّ
u'كَوْنٌ مُسْتَعَارٌ':Added, #2: 2	كَوْنُ مُسْتَحِقِّهِ
u'كَوْنٌ مُسْتَعْمَلٌ':Added, #1: 1	كَوْنُ الْمُسْتَعَارِ
u'كَوْنٌ مُسْتَفاد':Added, #3: 3	كَوْنِ الْمُسْتَعْمَلِ
u'كَوْنٌ مُسْتَمِعٌ':Added, #2: 2	كَوْنِ الْمُسْتَفَادِ
u'كَوْنٌ مُسْتَنَدٌ':Added, #1: 1	كَوْنُ الْمُسْتَمِعِ
u'كَوْنٌ مَسْجِدٌ':Added, #1: 1	كَوْنِ مُسْتَنَدِهِ
u'كَوْنٌ مَسْجِدٌ':Added, #1: 1	كَوْنُ الْمَسْجِدِ
u'كَوْنٌ مَسْحٌ':Added, #1: 1	كَوْنِ الْمَسْجِدِ
u'كَوْنٌ مَسْحٌ':Added, #1: 1	كَوْنَ الْمَسْحِ
u'كَوْنٌ مَسْرُوقٌ':Added, #2: 2	كَوْنِ الْمَسْحِ
u'كَوْنٌ مَسْرُوقٌ':Added, #1: 1	كَوْنَ الْمَسْرُوقِ
u'كَوْنٌ مَسْكَنٌ':Added, #2: 2	كَوْنِ الْمَسْرُوقِ
u'كَوْنٌ مَسْكُوتٌ':Added, #1: 1	كَوْنِ الْمَسْكَنِ
u'كَوْنٌ مُسْلِمٌ':Added, #2: 2	كَوْنَ الْمَسْكُوتِ
u'كَوْنٌ مُسْلِمٌ':Added, #1: 1	كَوْنَ الْمُسْلِمِ
u'كَوْنٌ مُسْلِمٌ':Added, #1: 1	كَوْنُ الْمُسْلِمَةِ
u'كَوْنٌ مُسَلَّمٌ':Added, #2: 2	كَوْنُ الْمُسْلِمِ
u'كَوْنٌ مُسْلِمٌ':Added, #3: 3	كَوْنُ الْمُسَلَّمِ
u'كَوْنٌ مُسْنَدٌ':Added, #3: 3	كَوْنِ الْمُسْلِمِ
u'كَوْنٌ مُشَبَّهٌ':Added, #1: 1	كَوْنِ الْمُسْنَدِ
u'كَوْنٌ مُشْتَقٌّ':Added, #1: 1	كَوْنُ الْمُشَبَّهِ
u'كَوْنٌ مُشْتَقٌّ':Added, #1: 1	كَوْنَ الْمُشْتَقِّ
u'كَوْنٌ مُشْرِك':Added, #1: 1	كَوْنِ الْمُشْتَقِّ
u'كَوْنٌ مَشْرُوطٌ':Added, #1: 1	كَوْنُ الْمُشْرِكِ
u'كَوْنٌ مَشْهُودٌ':Added, #1: 1	كَوْنُ الْمَشْرُوطِ
u'كَوْنٌ مَشْهُودٌ':Added, #2: 2	كَوْنُ الْمَشْهُودِ
u'كَوْنٌ مَشْهُورٌ':Added, #3: 3	كَوْنِ الْمَشْهُودِ
u'كَوْنٌ مَشْيٌ':Added, #1: 1	كَوْنُ الْمَشْهُورِ
u'كَوْنٌ مَصَالِحُ':Added, #1: 1	كَوْنِ الْمَشْيِ
u'كَوْنٌ مَصْرِفٌ':Added, #1: 1	كَوْنِ الْمَصَالِحِ
u'كَوْنٌ مَصْلَحَةٌ':Added, #1: 1	كَوْنَ الْمَصْرِفِ
u'كَوْنٌ مَصْلَحَةٌ':Added, #1: 1	كَوْنَ الْمَصْلَحَةِ
u'كَوْنٌ مَصْلَحَةٌ':Added, #1: 1	كَوْنِ الْمَصْلَحَةِ
u'كَوْنٌ مُصَنِّفٌ':Added, #1: 1	كَوْنَ مَصْلَحَتِهِ
u'كَوْنٌ مُصَنِّفٌ':Added, #1: 1	كَوْنِ الْمُصَنِّفِ
u'كَوْنٌ مُصِيبٌ':Added, #2: 2	كَوْنُ الْمُصَنِّفِ
u'كَوْنٌ مُصِيبٌ':Added, #1: 1	كَوْنِ مُصِيبَتِهِ
u'كَوْنٌ مُصِيبَةٌ':Added, #2: 2	كَوْنِ الْمُصِيبِ
u'كَوْنٌ مُضَافٌ':Added, #1: 1	كَوْنِ مُصِيبَتِهِ
u'كَوْنٌ مُضَافٌ':Added, #1: 1	كَوْنَ الْمُضَافِ
u'كَوْنٌ مُضْطَرٌّ':Added, #1: 1	كَوْنِ الْمُضَافِ
u'كَوْنٌ مَضْمُومٌ':Added, #1: 1	كَوْنِ الْمُضْطَرِّ
u'كَوْنٌ مُطَابَقَةٌ':Added, #1: 1	كَوْنِ الْمَضْمُومِ
u'كَوْنٌ مَطْعُونٌ':Added, #1: 1	كَوْنِ الْمُطَابَقَةِ
u'كَوْنٌ مُطْلَقٌ':Added, #1: 1	كَوْنِ الْمَطْعُونِ
u'كَوْنٌ مُطَلَّقٌ':Added, #1: 1	كَوْنِ الْمُطْلَقِ
u'كَوْنٌ مُطْلَقٌ':Added, #1: 1	كَوْنِ الْمُطَلَّقَةِ
u'كَوْنٌ مَطْلُوبٌ':Added, #2: 2	كَوْنَ الْمُطْلَقِ
u'كَوْنٌ مُطِيعٌ':Added, #1: 1	كَوْنِ الْمَطْلُوبِ
u'كَوْنٌ مُعارِضٌ':Added, #1: 1	كَوْنُ الْمُطِيعِ
u'كَوْنٌ مُعَامَلَةٌ':Added, #1: 1	كَوْنَ الْمُعَارِضِ
u'كَوْنٌ مُعْتَبَرٌ':Added, #1: 1	كَوْنَ الْمُعَامَلَاتِ
u'كَوْنٌ مُعْتَبَرٌ':Added, #1: 1	كَوْنِ الْمُعْتَبَرِ
u'كَوْنٌ مُعْتَقٌ':Added, #2: 2	كَوْنُ الْمُعْتَبَرِ
u'كَوْنٌ مُعْتَقٌ':Added, #1: 1	كَوْنُ الْمُعْتَقِ
u'كَوْنٌ مُعْجِزٌ':Added, #1: 1	كَوْنَ الْمُعْتَقَةِ
u'كَوْنٌ مُعْجِزٌ':Added, #1: 1	كَوْنِ الْمُعْجِزِ
u'كَوْنٌ مُعْجِزَةٌ':Added, #1: 1	كَوْنِ الْمُعْجِزَةِ
u'كَوْنٌ مَعْدِنٌ':Added, #1: 1	كَوْنِ الْمُعْجِزَةِ
u'كَوْنٌ مَعْدُومٌ':Added, #1: 1	كَوْنِ الْمَعْدِنِ
u'كَوْنٌ مَعْصِيَةٌ':Added, #1: 1	كَوْنُ الْمَعْدُومِ
u'كَوْنٌ مَعْطُوف':Added, #1: 1	كَوْنَ الْمَعْصِيَةِ
u'كَوْنٌ مَعْطُوف':Added, #1: 1	كَوْنُ الْمَعْطُوفِ
u'كَوْنٌ مَعْقُودٌ':Added, #1: 1	كَوْنِ الْمَعْطُوفِ
u'كَوْنٌ مَعْقُودٌ':Added, #1: 1	كَوْنَ الْمَعْقُودِ
u'كَوْنٌ مَعْقُودٌ':Added, #1: 1	كَوْنُ الْمَعْقُودِ
u'كَوْنٌ مُعَلَّقٌ':Added, #2: 2	كَوْنِ الْمَعْقُودِ
u'كَوْنٌ مُعَلَّقٌ':Added, #1: 1	كَوْنَ الْمُعَلَّقِ
u'كَوْنٌ مَعْلُوم':Added, #2: 2	كَوْنِ الْمُعَلَّقِ
u'كَوْنٌ مَعْلُومَة':Added, #1: 1	كَوْنِ مَعْلُومِيَّةِ
u'كَوْنٌ مَعْنَوِيٌّ':Added, #1: 1	كَوْنِ مَعْلُومِيَّةِ
u'كَوْنٌ مُعِير':Added, #1: 1	كَوْنَ الْمَعْنَوِيِّ
u'كَوْنٌ مَغْرِبٌ':Added, #3: 3	كَوْنُ الْمُعِيرِ
u'كَوْنٌ مَغْصُوب':Added, #2: 2	كَوْنِ الْمَغْرِبِ
u'كَوْنٌ مُغَلَّب':Added, #1: 1	كَوْنِ الْمَغْصُوبِ
u'كَوْنٌ مُغَيِّرٌ':Added, #1: 1	كَوْنِ الْمُغَلَّبِ
u'كَوْنٌ مَفَازَة':Added, #1: 1	كَوْنِ الْمُغَيِّرِ
u'كَوْنٌ مِفْتَاحٌ':Added, #1: 1	كَوْنُ الْمَفَازَةِ
u'كَوْنٌ مُفْرَدٌ':Added, #1: 1	كَوْنَ الْمِفْتَاحِ
u'كَوْنٌ مُفْرَدٌ':Added, #1: 1	كَوْنِ الْمُفْرَدِ
u'كَوْنٌ مَفْرُوضٌ':Added, #2: 2	كَوْنُ الْمُفْرَدِ
u'كَوْنٌ مَفْرُوضٌ':Added, #1: 1	كَوْنَ الْمَفْرُوضِ
u'كَوْنٌ مَفْعُولٌ':Added, #1: 1	كَوْنُ الْمَفْرُوضِ
u'كَوْنٌ مُفْلِسٌ':Added, #3: 3	كَوْنُ الْمَفْعُولِ
u'كَوْنٌ مَفْهُومٌ':Added, #1: 1	كَوْنَ الْمُفْلِسِ
u'كَوْنٌ مَفْهُومٌ':Added, #1: 1	كَوْنُ الْمَفْهُومِ
u'كَوْنٌ مُقَابَلٌ':Added, #1: 1	كَوْنِ الْمَفْهُومِ
u'كَوْنٌ مُقَابَلَةٌ':Added, #1: 1	كَوْنَ مُقَابَلَةِ
u'كَوْنٌ مَقَامٌ':Added, #1: 1	كَوْنَ مُقَابَلَةِ
u'كَوْنٌ مَقْبُوضٌ':Added, #1: 1	كَوْنُ الْمَقَامِ
u'كَوْنٌ مَقْبُوضٌ':Added, #1: 1	كَوْنَ الْمَقْبُوضِ
u'كَوْنٌ مَقْبُوضٌ':Added, #1: 1	كَوْنُ الْمَقْبُوضِ
u'كَوْنٌ مَقْتُولٌ':Added, #3: 3	كَوْنِ الْمَقْبُوضِ
u'كَوْنٌ مُقَدَّرٌ':Added, #3: 3	كَوْنُ الْمَقْتُولِ
u'كَوْنٌ مُقَدِّمٌ':Added, #1: 1	كَوْنِ الْمُقَدَّرِ
u'كَوْنٌ مُقَدِّمٌ':Added, #1: 1	كَوْنِ الْمُقَدِّمَةِ
u'كَوْنٌ مُقَدِّمَةٌ':Added, #1: 1	كَوْنُ مُقَدِّمَةِ
u'كَوْنٌ مُقَدِّمَةٌ':Added, #1: 1	كَوْنِ الْمُقَدِّمَةِ
u'كَوْنٌ مَقْدُورٌ':Added, #1: 1	كَوْنُ مُقَدِّمَةِ
u'كَوْنٌ مَقْذُوفٌ':Added, #1: 1	كَوْنُ الْمَقْدُورِ
u'كَوْنٌ مُقْرِضٌ':Added, #1: 1	كَوْنَ الْمَقْذُوفِ
u'كَوْنٌ مَقْرُوءٌ':Added, #2: 2	كَوْنُ الْمُقْرِضِ
u'كَوْنٌ مَقْرُوءٌ':Added, #1: 1	كَوْنَ الْمَقْرُوءِ
u'كَوْنٌ مَقْصُودٌ':Added, #1: 1	كَوْنِ الْمَقْرُوءِ
u'كَوْنٌ مَقْصُودٌ':Added, #1: 1	كَوْنَ الْمَقْصُودِ
u'كَوْنٌ مُقَلِّدٌ':Added, #4: 4	كَوْنِ الْمَقْصُودِ
u'كَوْنٌ مُقَيَّدٌ':Added, #1: 1	كَوْنَ الْمُقَلِّدِ
u'كَوْنٌ مُقَيَّدٌ':Added, #1: 1	كَوْنُ الْمُقَيَّدِ
u'كَوْنٌ مَكَانٌ':Added, #1: 1	كَوْنِ الْمُقَيَّدِ
u'كَوْنٌ مَكَانٌ':Added, #1: 1	كَوْنِ الْمَكَانِ
u'كَوْنٌ مَكْتُوبٌ':Added, #1: 1	كَوْنِ الْمَكَانَيْنِ
u'كَوْنٌ مَكْرٌ':Added, #1: 1	كَوْنِ الْمَكْتُوبِ
u'كَوْنٌ مُكْرَهٌ':Added, #1: 1	كَوْنُ الْمَكْرِ
u'كَوْنٌ مَكْرُوهٌ':Added, #1: 1	كَوْنِ الْمُكْرَهِ
u'كَوْنٌ مَكْفُولٌ':Added, #1: 1	كَوْنِ الْمَكْرُوهِ
u'كَوْنٌ مَكْفُولٌ':Added, #1: 1	كَوْنِ الْمَكْفُولِ
u'كَوْنٌ مُكَلَّفٌ':Added, #2: 2	كَوْنُ الْمَكْفُولِ
u'كَوْنٌ مُكَلَّفٌ':Added, #2: 2	كَوْنَ الْمُكَلَّفِ
u'كَوْنٌ مُكَمِّلٌ':Added, #2: 2	كَوْنُ الْمُكَلَّفِ
u'كَوْنٌ مُلاَحَظَةٌ':Added, #1: 1	كَوْنِ مُكَمِّلِ
u'كَوْنٌ مَلاَئِكَةٌ':Added, #1: 1	كَوْنُ الْمُلَاحَظَةِ
u'كَوْنٌ مُلْتَقِط':Added, #1: 1	كَوْنِ الْمَلَائِكَةِ
u'كَوْنٌ مَلْحَظٌ':Added, #1: 1	كَوْنِ الْمُلْتَقِطِ
u'كَوْنٌ مَلْزُوم':Added, #1: 1	كَوْنُ مَلْحَظِ
u'كَوْنٌ مَلَكٌ':Added, #1: 1	كَوْنِ الْمَلْزُومِ
u'كَوْنٌ مِلْكٌ':Added, #1: 1	كَوْنِ الْمَلَكِ
u'كَوْنٌ مِلْكٌ':Added, #1: 1	كَوْنَ الْمِلْكِ
u'كَوْنٌ مِلْكٌ':Added, #1: 1	كَوْنُ الْمِلْكِ
u'كَوْنٌ مِلْكٌ':Added, #1: 1	كَوْنِ الْمِلْكِ
u'كَوْنٌ مِلْكٌ':Added, #1: 1	كَوْنُ مِلْكِهِ
u'كَوْنٌ مُمْتَنِعٌ':Added, #2: 2	كَوْنِ مِلْكِ
u'كَوْنٌ مَمْدُوح':Added, #1: 1	كَوْنِ الْمُمْتَنِعِ
u'كَوْنٌ مَمْنُوعٌ':Added, #1: 1	كَوْنِ الْمَمْدُوحِيَّةِ
u'كَوْنٌ مُنَاسِبٌ':Added, #1: 1	كَوْنِ الْمَمْنُوعِ
u'كَوْنٌ مُنَاسَبَةٌ':Added, #1: 1	كَوْنُ الْمُنَاسِبِ
u'كَوْنٌ مَنَاطٌ':Added, #1: 1	كَوْنُ الْمُنَاسَبَةِ
u'كَوْنٌ مَنَاطٌ':Added, #1: 1	كَوْنُ الْمَنَاطِ
u'كَوْنٌ مَنَافِعُ':Added, #1: 1	كَوْنُ مَنَاطِ
u'كَوْنٌ مَنَافِعُ':Added, #1: 1	كَوْنِ الْمَنَافِعِ
u'كَوْنٌ مَنْدُوبٌ':Added, #5: 5	كَوْنِ مَنَافِعِهِ
u'كَوْنٌ مُنْذِرٌ':Added, #2: 2	كَوْنِ الْمَنْدُوبِ
u'كَوْنٌ مَنْذُور':Added, #1: 1	كَوْنَ الْمُنْذِرِ
u'كَوْنٌ مَنْسُوخٌ':Added, #2: 2	كَوْنُ الْمَنْذُورِ
u'كَوْنٌ مَنْسِيٌّ':Added, #1: 1	كَوْنَ الْمَنْسُوخِ
u'كَوْنٌ مَنْصِبٌ':Added, #1: 1	كَوْنِ الْمَنْسِيَّتَيْنِ
u'كَوْنٌ مَنْصُوصٌ':Added, #1: 1	كَوْنَ الْمَنْصِبِ
u'كَوْنٌ مَنْعٌ':Added, #1: 1	كَوْنِ الْمَنْصُوصِ
u'كَوْنٌ مَنْعٌ':Added, #1: 1	كَوْنَ الْمَنْعِ
u'كَوْنٌ مَنْعٌ':Added, #1: 1	كَوْنِ الْمَنْعِ
u'كَوْنٌ مُنْفَرِدٌ':Added, #1: 1	كَوْنَ مَنْعِ
u'كَوْنٌ مَنْفَعَةٌ':Added, #1: 1	كَوْنِ الْمُنْفَرِدِ
u'كَوْنٌ مَنْفَعَةٌ':Added, #1: 1	كَوْنِ الْمَنْفَعَةِ
u'كَوْنٌ مَنْفَعَةٌ':Added, #2: 2	كَوْنَ الْمَنْفَعَةِ
u'كَوْنٌ مَنْفَعَةٌ':Added, #2: 2	كَوْنِ مَنْفَعَةِ
u'كَوْنٌ مَنْهِيٌّ':Added, #4: 4	كَوْنُ الْمَنْفَعَةِ
u'كَوْنٌ مَنِيٌّ':Added, #1: 1	كَوْنُ الْمَنْهِيِّ
u'كَوْنٌ مَهْرٌ':Added, #1: 1	كَوْنَ الْمَنِيِّ
u'كَوْنٌ مَهْرٌ':Added, #1: 1	كَوْنَ الْمَهْرِ
u'كَوْنٌ مَوَانِعُ':Added, #3: 3	كَوْنُ الْمَهْرِ
u'كَوْنٌ مَوْتٌ':Added, #1: 1	كَوْنُ الْمَوَانِعِ
u'كَوْنٌ مَوْتٌ':Added, #1: 1	كَوْنَ الْمَوْتِ
u'كَوْنٌ مَوْتٌ':Added, #2: 2	كَوْنُ الْمَوْتِ
u'كَوْنٌ مُوجَبٌ':Added, #2: 2	كَوْنِ الْمَوْتِ
u'كَوْنٌ مُوجَبٌ':Added, #1: 1	كَوْنِ الْمُوجَبِ
u'كَوْنٌ مُوجِبٌ':Added, #1: 1	كَوْنَ الْمُوجَبَةِ
u'كَوْنٌ مَوْجُودٌ':Added, #3: 3	كَوْنِ الْمُوجِبِ
u'كَوْنٌ مَوْجُودٌ':Added, #1: 1	كَوْنَ الْمَوْجُودِ
u'كَوْنٌ مُودِعٌ':Added, #1: 1	كَوْنِ الْمَوْجُودِ
u'كَوْنٌ مُؤَذِّنٌ':Added, #1: 1	كَوْنَ الْمُودِعِ
u'كَوْنٌ مَوْصُوفٌ':Added, #5: 5	كَوْنُ الْمُؤَذِّنِ
u'كَوْنٌ مَوْضِعٌ':Added, #3: 3	كَوْنِ الْمَوْصُوفِ
u'كَوْنٌ مَوْضِعٌ':Added, #1: 1	كَوْنِ الْمَوْضِعِ
u'كَوْنٌ مَوْضِعٌ':Added, #1: 1	كَوْنَ مَوْضِعِ
u'كَوْنٌ مَوْضُوعٌ':Added, #1: 1	كَوْنِ مَوْضِعِ
u'كَوْنٌ مَوْقُوفٌ':Added, #1: 1	كَوْنَ الْمَوْضُوعِ
u'كَوْنٌ مُؤَلَّفٌ':Added, #2: 2	كَوْنُ الْمَوْقُوفِ
u'كَوْنٌ مَوْلُودٌ':Added, #2: 2	كَوْنَ الْمُؤَلَّفِ
u'كَوْنٌ مَوْهُوبٌ':Added, #2: 2	كَوْنِ الْمَوْلُودِ
u'كَوْنٌ ناذِر':Added, #1: 1	كَوْنُ الْمَوْهُوبِ
u'كَوْنٌ نَاسٌ':Added, #1: 1	كَوْنُ النَّاذِرِ
u'كَوْنٌ نَاسٌ':Added, #1: 1	كَوْنَ النَّاسِ
u'كَوْنٌ نَاظِرٌ':Added, #1: 1	كَوْنِ النَّاسِ
u'كَوْنٌ نَافِلَةٌ':Added, #1: 1	كَوْنُ النَّاظِرِ
u'كَوْنٌ نَائِبٌ':Added, #1: 1	كَوْنُ النَّافِلَةِ
u'كَوْنٌ نَبِيٌّ':Added, #2: 2	كَوْنِ النَّائِبِ
u'كَوْنٌ نجاة':Added, #2: 2	كَوْنُ النَّبِيِّ
u'كَوْنٌ نَجَاةٌ':Added, #1: 1	كَوْنِ النَّجَاةِ
u'كَوْنٌ نَجَاسَةٌ':Added, #1: 1	كَوْنِ النَّجَاةِ
u'كَوْنٌ نَجَاسَةٌ':Added, #1: 1	كَوْنَ النَّجَاسَاتِ
u'كَوْنٌ نَجَاسَةٌ':Added, #1: 1	كَوْنَ النَّجَاسَةِ
u'كَوْنٌ نَجَاسَةٌ':Added, #1: 1	كَوْنِ نَجَاسَةِ
u'كَوْنٌ نِدَاءٌ':Added, #2: 2	كَوْنِ النَّجَاسَةِ
u'كَوْنٌ نذر':Added, #1: 1	كَوْنِ النِّدَاءِ
u'كَوْنٌ نَذْرٌ':Added, #1: 1	كَوْنِ النَّذْرِ
u'كَوْنٌ نُزُولٌ':Added, #1: 1	كَوْنِ النَّذْرِ
u'كَوْنٌ نِساءٌ':Added, #2: 2	كَوْنُ نُزُولِهِ
u'كَوْنٌ نَسَبٌ':Added, #1: 1	كَوْنِ النِّسَاءِ
u'كَوْنٌ نِسْبَةٌ':Added, #1: 1	كَوْنِ النَّسَبِ
u'كَوْنٌ نِسْبَةٌ':Added, #1: 1	كَوْنُ النِّسْبَةِ
u'كَوْنٌ نِسْيَانٌ':Added, #1: 1	كَوْنِ النِّسْبَةِ
u'كَوْنٌ نِسْيَانٌ':Added, #1: 1	كَوْنِ النِّسْيَانِ
u'كَوْنٌ نِسْيَانٌ':Added, #1: 1	كَوْنِ نِسْيَانِ
u'كَوْنٌ نَصٌّ':Added, #1: 1	كَوْنِ نِسْيَانِهِ
u'كَوْنٌ نَصٌّ':Added, #1: 1	كَوْنُ النَّصِّ
u'كَوْنٌ نصاب':Added, #2: 2	كَوْنِ النَّصِّ
u'كَوْنٌ نِصَابٌ':Added, #1: 1	كَوْنُ النِّصَابِ
u'كَوْنٌ نصب':Added, #1: 1	كَوْنُ النِّصَابِ
u'كَوْنٌ نَصْبٌ':Added, #1: 1	كَوْنِ النَّصْبِ
u'كَوْنٌ نَصْرَانِيٌّ':Added, #1: 1	كَوْنِ النَّصْبِ
u'كَوْنٌ نِصْفٌ':Added, #1: 1	كَوْنِ النَّصْرَانِيِّ
u'كَوْنٌ نَصِيبٌ':Added, #4: 4	كَوْنِ النِّصْفِ
u'كَوْنٌ نَظَرٌ':Added, #1: 1	كَوْنُ نَصِيبِهِ
u'كَوْنٌ نَظَرٌ':Added, #1: 1	كَوْنَ النَّظَرِ
u'كَوْنٌ نَعْلٌ':Added, #3: 3	كَوْنِ النَّظَرِ
u'كَوْنٌ نعمة':Added, #1: 1	كَوْنُ النَّعْلِ
u'كَوْنٌ نِعْمَةٌ':Added, #1: 1	كَوْنُ النِّعْمَةِ
u'كَوْنٌ نفاس':Added, #1: 1	كَوْنُ النِّعْمَةِ
u'كَوْنٌ نِفَاسٌ':Added, #1: 1	كَوْنُ النِّفَاسِ
u'كَوْنٌ نَفْسٌ':Added, #1: 1	كَوْنُ النِّفَاسِ
u'كَوْنٌ نَفْسٌ':Added, #1: 1	كَوْنِ النَّفْسِ
u'كَوْنٌ نَفْسٌ':Added, #1: 1	كَوْنَ نَفْسِ
u'كَوْنٌ نَفْلٌ':Added, #1: 1	كَوْنُ نَفْسِ
u'كَوْنٌ نَفْلٌ':Added, #1: 1	كَوْنُ النَّفْلِ
u'كَوْنٌ نُفُوسٌ':Added, #1: 1	كَوْنِ النَّفْلِ
u'كَوْنٌ نَفْيٌ':Added, #1: 1	كَوْنِ النُّفُوسِ
u'كَوْنٌ نَفْيٌ':Added, #1: 1	كَوْنَ النَّفْيِ
u'كَوْنٌ نَفْيٌ':Added, #1: 1	كَوْنُ النَّفْيِ
u'كَوْنٌ نَفْيٌ':Added, #1: 1	كَوْنُ نَفْيِ
u'كَوْنٌ نَقْدٌ':Added, #4: 4	كَوْنِ النَّفْيِ
u'كَوْنٌ نَقْد':Added, #1: 1	كَوْنِ النَّقْدِ
u'كَوْنٌ نَقْدٌ':Added, #1: 1	كَوْنِ النَّقْدِ
u'كَوْنٌ نَقْد':Added, #1: 1	كَوْنَ النَّقْدَيْنِ
u'كَوْنٌ نَقْصٌ':Added, #1: 1	كَوْنَ النَّقْدَيْنِ
u'كَوْنٌ نَقِيضٌ':Added, #1: 1	كَوْنِ النَّقْصِ
u'كَوْنٌ نَقِيضٌ':Added, #1: 1	كَوْنَ النَّقِيضِ
u'كَوْنٌ نكاح':Added, #2: 2	كَوْنِ نَقِيضِ
u'كَوْنٌ نكاح':Added, #1: 1	كَوْنَ النِّكَاحِ
u'كَوْنٌ نِكَاحٌ':Added, #1: 1	كَوْنُ النِّكَاحِ
u'كَوْنٌ نِكَاحٌ':Added, #1: 1	كَوْنَ النِّكَاحِ
u'كَوْنٌ نكاح':Added, #1: 1	كَوْنُ النِّكَاحِ
u'كَوْنٌ نكاح':Added, #1: 1	كَوْنُ نِكَاحِ
u'كَوْنٌ نِكَاحٌ':Added, #1: 1	كَوْنِ نِكَاحِ
u'كَوْنٌ نِكَاحٌ':Added, #1: 1	كَوْنُ نِكَاحِ
u'كَوْنٌ نَكِرٌ':Added, #1: 1	كَوْنِ نِكَاحِ
u'كَوْنٌ نكرة':Added, #2: 2	كَوْنِ النَّكِرَةِ
u'كَوْنٌ نَكِرَةٌ':Added, #2: 2	كَوْنِ النَّكِرَةِ
u'كَوْنٌ نَهْرٌ':Added, #2: 2	كَوْنِ النَّكِرَةِ
u'كَوْنٌ نَهْيٌ':Added, #1: 1	كَوْنِ النَّهْرِ
u'كَوْنٌ نَهْيٌ':Added, #1: 1	كَوْنَ النَّهْيِ
u'كَوْنٌ نَهْيٌ':Added, #5: 5	كَوْنِ النَّهْيِ
u'كَوْنٌ نَوْعٌ':Added, #6: 6	كَوْنُ النَّهْيِ
u'كَوْنٌ نَوْعِيٌّ':Added, #1: 1	كَوْنِ النَّوْعِ
u'كَوْنٌ نَوْمٌ':Added, #1: 1	كَوْنِ النَّوْعِيَّةِ
u'كَوْنٌ نِيَّةٌ':Added, #1: 1	كَوْنِ النَّوْمِ
u'كَوْنٌ نِيَّةٌ':Added, #1: 1	كَوْنِ نِيَّةِ
u'كَوْنٌ هاشِمِيّ':Added, #2: 2	كَوْنِ النِّيَّةِ
u'كَوْنٌ هجر':Added, #1: 1	كَوْنُ الْهَاشِمِيِّ
u'كَوْنٌ هَجْرٌ':Added, #1: 1	كَوْنِ هَجْرِ
u'كَوْنٌ هلاك':Added, #1: 1	كَوْنِ هَجْرِ
u'كَوْنٌ هَلاَكٌ':Added, #1: 1	كَوْنَ الْهَلَاكِ
u'كَوْنٌ هلاك':Added, #1: 1	كَوْنَ الْهَلَاكِ
u'كَوْنٌ هَلاَكٌ':Added, #2: 2	كَوْنِ الْهَلَاكِ
u'كَوْنٌ وَاجِبٌ':Added, #2: 2	كَوْنِ الْهَلَاكِ
u'كَوْنٌ وَاجِدٌ':Added, #3: 3	كَوْنِ الْوَاجِبِ
u'كَوْنٌ وَاجِدٌ':Added, #1: 1	كَوْنُ الْوَاجِدِ
u'كَوْنٌ واحد':Added, #1: 1	كَوْنِ الْوَاجِدِ
u'كَوْنٌ وَاحِدٌ':Added, #1: 1	كَوْنِ وَاحِدَةٍ
u'كَوْنٌ واحد':Added, #1: 1	كَوْنِ وَاحِدَةٍ
u'كَوْنٌ وَاحِدٌ':Added, #2: 2	كَوْنِ الْوَاحِدِ
u'كَوْنٌ واحد':Added, #2: 2	كَوْنِ الْوَاحِدِ
u'كَوْنٌ وَاحِدٌ':Added, #3: 3	كَوْنُ الْوَاحِدِ
u'كَوْنٌ وَاضِعٌ':Added, #3: 3	كَوْنُ الْوَاحِدِ
u'كَوْنٌ وَاقِعٌ':Added, #1: 1	كَوْنُ الْوَاضِعِ
u'كَوْنٌ وَاقِعٌ':Added, #1: 1	كَوْنُ الْوَاقِعِ
u'كَوْنٌ وَاقِعٌ':Added, #1: 1	كَوْنِ الْوَاقِعَةِ
u'كَوْنٌ وَاقِعٌ':Added, #2: 2	كَوْنَ الْوَاقِعِ
u'كَوْنٌ وَاقِعَةٌ':Added, #3: 3	كَوْنِ الْوَاقِعِ
u'كَوْنٌ وَاقِفٌ':Added, #1: 1	كَوْنِ الْوَاقِعَةِ
u'كَوْنٌ وَالِدٌ':Added, #1: 1	كَوْنُ الْوَاقِفِ
u'كَوْنٌ وَثِيقٌ':Added, #1: 1	كَوْنُ الْوَالِدِ
u'كَوْنٌ وَجْهٌ':Added, #1: 1	كَوْنِ وَثِيقَةِ
u'كَوْنٌ وُجُوبٌ':Added, #1: 1	كَوْنِ وَجْهِ
u'كَوْنٌ وُجُوبٌ':Added, #1: 1	كَوْنَ وُجُوبِ
u'كَوْنٌ وُجُوبٌ':Added, #1: 1	كَوْنُ وُجُوبِ
u'كَوْنٌ وُجُوبٌ':Added, #1: 1	كَوْنِ وُجُوبِ
u'كَوْنٌ وُجُوبٌ':Added, #1: 1	كَوْنُ وُجُوبِهِ
u'كَوْنٌ وُجُوبٌ':Added, #2: 2	كَوْنَ الْوُجُوبِ
u'كَوْنٌ وُجُودٌ':Added, #2: 2	كَوْنُ الْوُجُوبِ
u'كَوْنٌ وَرَثَةٌ':Added, #1: 1	كَوْنِ وُجُودِهِ
u'كَوْنٌ وُرُودٌ':Added, #1: 1	كَوْنُ الْوَرَثَةِ
u'كَوْنٌ وَصْفٌ':Added, #1: 1	كَوْن الْوُرُودِ
u'كَوْنٌ وَصْفٌ':Added, #10: 10	كَوْنَ الْوَصْفِ
u'كَوْنٌ وَصْفٌ':Added, #10: 10	كَوْنُ الْوَصْفِ
u'كَوْنٌ وَصْفٌ':Added, #1: 1	كَوْنَ وَصْفِهِ
u'كَوْنٌ وَصْفٌ':Added, #1: 1	كَوْنِ وَصْفِهِ
u'كَوْنٌ وَصْفٌ':Added, #21: 21	كَوْنِ الْوَصْفِ
u'كَوْنٌ وَصِيٌّ':Added, #2: 2	كَوْنِ وَصْفِ
u'كَوْنٌ وَصِيٌّ':Added, #1: 1	كَوْنِ الْوَصِيِّ
u'كَوْنٌ وَصِيَّةٌ':Added, #1: 1	كَوْنَ الْوَصِيَّةِ
u'كَوْنٌ وَضْعٌ':Added, #1: 1	كَوْنَ الْوَصِيَّةِ
u'كَوْنٌ وَضْعٌ':Added, #1: 1	كَوْنَ الْوَضْعِ
u'كَوْنٌ وُضُوءٌ':Added, #1: 1	كَوْنَ وَضْعِ
u'كَوْنٌ وُضُوءٌ':Added, #1: 1	كَوْنَ الْوُضُوءِ
u'كَوْنٌ وُضُوءٌ':Added, #1: 1	كَوْنُ الْوُضُوءِ
u'كَوْنٌ وَطْءٌ':Added, #3: 3	كَوْنِ الْوُضُوءِ
u'كَوْنٌ وَطْءٌ':Added, #1: 1	كَوْنُ الْوَطْءِ
u'كَوْنٌ وَعْدٌ':Added, #5: 5	كَوْنِ الْوَطْءِ
u'كَوْنٌ وَعِيدٌ':Added, #1: 1	كَوْنِ الْوَعْدِ
u'كَوْنٌ وَقْتٌ':Added, #1: 1	كَوْنَ وَعِيدِهِ
u'كَوْنٌ وَقْتٌ':Added, #1: 1	كَوْنُ وَقْتِهِ
u'كَوْنٌ وَقْتٌ':Added, #2: 2	كَوْنُ الْوَقْتِ
u'كَوْنٌ وَقْتٌ':Added, #2: 2	كَوْنِ الْوَقْتِ
u'كَوْنٌ وَقْفٌ':Added, #3: 3	كَوْنَ الْوَقْتِ
u'كَوْنٌ وقفة':Added, #1: 1	كَوْنُ الْوَقْفِ
u'كَوْنٌ وَقْفَةٌ':Added, #1: 1	كَوْنِ الْوَقْفَةِ
u'كَوْنٌ وُقُوعٌ':Added, #1: 1	كَوْنِ الْوَقْفَةِ
u'كَوْنٌ وُقُوفٌ':Added, #1: 1	كَوْنِ الْوُقُوعِ
u'كَوْنٌ وُقُوفٌ':Added, #1: 1	كَوْنُ الْوُقُوفِ
u'كَوْنٌ وَكِيلٌ':Added, #1: 1	كَوْنِ الْوُقُوفِ
u'كَوْنٌ وَكِيلٌ':Added, #2: 2	كَوْنُ الْوَكِيلِ
u'كَوْنٌ وِلاَدَةٌ':Added, #2: 2	كَوْنِ الْوَكِيلِ
u'كَوْنٌ وِلاَيَةٌ':Added, #1: 1	كَوْنِ الْوِلَادَةِ
u'كَوْنٌ ولد':Added, #1: 1	كَوْنِ وِلَايَتِهِ
u'كَوْنٌ ولد':Added, #11: 11	كَوْنُ الْوَلَدِ
u'كَوْنٌ وَلَدٌ':Added, #11: 11	كَوْنِ الْوَلَدِ
u'كَوْنٌ وَلَدٌ':Added, #11: 11	كَوْنُ الْوَلَدِ
u'كَوْنٌ ولد':Added, #11: 11	كَوْنِ الْوَلَدِ
u'كَوْنٌ وَلَدٌ':Added, #1: 1	كَوْنُ وَلَدِ
u'كَوْنٌ ولد':Added, #1: 1	كَوْنُ وَلَدِ
u'كَوْنٌ وَلَدٌ':Added, #4: 4	كَوْنَ الْوَلَدِ
u'كَوْنٌ ولد':Added, #4: 4	كَوْنَ الْوَلَدِ
u'كَوْنٌ وَلَدٌ':Added, #4: 4	كَوْنِ وَلَدِ
u'كَوْنٌ وَلِيٌّ':Added, #4: 4	كَوْنِ وَلَدِ
u'كَوْنٌ وَلِيدٌ':Added, #1: 1	كَوْنَ الْوَلِيِّ
u'كَوْنٌ وَهَّابٌ':Added, #1: 1	كَوْنُ الْوَلِيدِ
u'كَوْنٌ يَتِيمٌ':Added, #1: 1	كَوْنُ الْوَهَّابِ
u'كَوْنٌ يَدٌ':Added, #1: 1	كَوْنُ الْيَتِيمِ
u'كَوْنٌ يَدٌ':Added, #1: 1	كَوْنُ الْيَدِ
u'كَوْنٌ يَدٌ':Added, #1: 1	كَوْنِ يَدِ
u'كَوْنٌ يَدٌ':Added, #1: 1	كَوْنُ يَدِهِ
u'كَوْنٌ يَمِينٌ':Added, #3: 3	كَوْنِ الْيَدِ
u'كَوْنٌ يَمِينٌ':Added, #1: 1	كَوْنَ الْيَمِينِ
u'كَوْنٌ يَمِينٌ':Added, #1: 1	كَوْنِ الْيَمِينِ
u'كَوْنٌ يَمِينٌ':Added, #1: 1	كَوْنُ يَمِينِهِ
u'كَوْنٌ يهود':Added, #4: 4	كَوْنُ الْيَمِينِ
u'كَوْنٌ يَهُودٌ':Added, #1: 1	كَوْنِ الْيَهُودِ
u'كَوْنٌ يَهُودِيٌّ':Added, #1: 1	كَوْنِ الْيَهُودِ
u'كَوْنٌ يَوْمٌ':Added, #1: 1	كَوْنِ الْيَهُودِيِّ
u'كَوْنٌ يَوْمٌ':Added, #1: 1	كَوْنُ الْيَوْمِ
u'كَوْنٌ يَوْمٌ':Added, #1: 1	كَوْنُ يَوْمِ
u'كَوْنٌ يَوْمٌ':Added, #1: 1	كَوْنِ يَوْمِ
u'كَوْنٌ يَوْمٌ':Added, #1: 1	كَوْنَ يَوْمَيْنِ
u'كَوَى سَعْدٌ':Predicate, #2: 2	كَوْنِ الْيَوْمِ
u'كَيَّةٌ نَارٌ':Added, #2: 2	كَوَى سَعْدَ
u'كَيْدٌ حَسْو':Added, #1: 1	كَيَّةِ نَارٍ
u'كَيْدٌ شَيْطَانٌ':Added, #1: 1	كَيْدِ الْحَسْوِ
u'كَيْدٌ طَائِفٌ':Added, #1: 1	كَيْدِ الشَّيْطَانِ
u'كَيْدٌ كَائِدٌ':Added, #1: 1	كَيْدِ الطَّائِفَتَيْنِ
u'كَيْدٌ نَاسٌ':Added, #1: 1	كَيْدَ كَائِدٍ
u'كَيْلٌ أَجْنَبِيٌّ':Added, #2: 2	كَيْدِ النَّاسِ
u'كَيْلٌ بَائِعٌ':Added, #1: 1	كَيْلِ الْأَجْنَبِيِّ
u'كَيْلٌ بَائِعٌ':Added, #1: 1	كَيْلَ الْبَائِعِ
u'كَيْلٌ بَائِعٌ':Added, #1: 1	كَيْلُ الْبَائِعِ
u'كَيْلٌ بُرٌّ':Added, #4: 4	كَيْلِ الْبَائِعِ
u'كَيْلَةٌ حِنْطَةٌ':Added, #1: 1	كَيْلَ بُرٍّ
u'كَيْلٌ حَبٌّ':Added, #1: 1	كَيْلَةِ حِنْطَةٍ
u'كَيْلٌ حِنْطَةٌ':Added, #1: 1	كَيْلُ حَبِّهِ
u'كَيْلٌ رَجُلٌ':Added, #2: 2	كَيْلِ الْحِنْطَةِ
u'كَيْلٌ رِطْلٌ':Added, #1: 1	كَيْلُ الرَّجُلِ
u'كَيْلٌ زَكاةٌ':Added, #1: 1	كَيْلُ الرِّطْلِ
u'كَيْلٌ سَمْنٌ':Added, #2: 2	كَيْلِ الزَّكَاةِ
u'كَيْلٌ صبرة':Added, #1: 1	كَيْلِ سَمْنِهِ
u'كَيْلٌ صُبْرَةٌ':Added, #2: 2	كَيْلِ الصُّبْرَةِ
u'كَيْلٌ صدقة':Added, #2: 2	كَيْلِ الصُّبْرَةِ
u'كَيْلٌ صَدَقَةٌ':Added, #1: 1	كَيْلَ صَدَقَةِ
u'كَيْلٌ طعام':Added, #1: 1	كَيْلَ صَدَقَةِ
u'كَيْلٌ طَعَامٌ':Added, #2: 2	كَيْلَ الطَّعَامِ
u'كَيْلٌ طعام':Added, #2: 2	كَيْلَ الطَّعَامِ
u'كَيْلٌ طَعَامٌ':Added, #5: 5	كَيْلِ الطَّعَامِ
u'كَيْلٌ مَبِيعٌ':Added, #5: 5	كَيْلِ الطَّعَامِ
u'كَيْلٌ مَخْصُوصٌ':Added, #1: 1	كَيْلِ الْمَبِيعِ
u'كَيْلٌ مُدٌّ':Added, #1: 1	كَيْلٍ مَخْصُوصٍ
u'كَيْلٌ مَدِينٌ':Added, #1: 1	كَيْلِ مُدٍّ
u'كَيْلٌ مَدِينَةٌ':Added, #2: 2	كَيْلُ مَدِينَةِ
u'كَيْلٌ مَعْلُومٌ':Added, #2: 2	كَيْلُ مَدِينَةِ
u'كَيْلٌ مُؤَجَّلٌ':Added, #29: 29	كَيْلٍ مَعْلُومٍ
u'كَيْلٌ مَوْزُونٌ':Added, #2: 2	كَيْلٍ مُؤَجَّلٍ
u'كَيْلٌ واحد':Added, #1: 1	كَيْلِ الْمَوْزُونِ
u'كَيْلٌ وَاحِدٌ':Added, #1: 1	كَيْلٍ وَاحِدٍ
u'لَابَسَ أرْبَابٌ':Predicate, #1: 1	كَيْلٍ وَاحِدٍ
u'لَابَسَ فِتَنٌ':Predicate, #1: 1	لَابَسَ أَرْبَابَ
u'لَابَسَ نَجَاسَةٌ':Predicate, #1: 1	لَابَسَ الْفِتَنَ
u'لَاحَ بَدْرٌ':Subject, #1: 1	لَابَسَ النَّجَاسَةَ
u'لَاحَ بَعْضٌ':Subject, #1: 1	لَاحَ بَدْرُ
u'لَاحَظَ أكل':Predicate, #1: 1	لَاحَ بَعْضُ
u'لَاحَظَ أَكْلٌ':Predicate, #1: 1	لَاحَظَ الْأَكْلَ
u'لَاحَظَ أَوَّلُ':Predicate, #1: 1	لَاحَظَ الْأَكْلَ
u'لَاحَظَ تَقْريرٌ':Predicate, #1: 1	لَاحَظَ الْأَوَّلَ
u'لَاحَظَ غَايَةٌ':Predicate, #1: 1	لَاحَظَ تَقْرِيرَ
u'لَاحَظَ مَأْكُولٌ':Predicate, #2: 2	لَاحَظَ الْغَايَةَ
u'لَاحَظَ مُمْكِنٌ':Predicate, #1: 1	لَاحَظَ الْمَأْكُولَ
u'لَاحَظَ مُمْكِن':Predicate, #1: 1	لَاحَظَ الْمُمْكِنَ
u'لَاحَ عَدَمٌ':Subject, #1: 1	لَاحَظَ الْمُمْكِنَ
u'لَاحَ فَضْلٌ':Subject, #1: 1	لَاحَ عَدَمُ
u'لَاحَ كَتَّانٌ':Subject, #1: 1	لَاحَ فَضْلُ
u'لَاحَ نَجْمٌ':Subject, #1: 1	لَاحَ كَتّانُ
u'لَاحَى رِجَالٌ':Predicate, #1: 1	لَاحَ نَجْمُ
u'لَازَمَ أحَدٌ':Predicate, #2: 2	لَاحَى الرِّجَالَ
u'لَازَمَ أَصيلٌ':Predicate, #1: 1	لَازَمَ أَحَدَ
u'لَازَمَ أَكْثَرُ':Predicate, #1: 1	لَازَمَ الْأَصِيلَ
u'لَازَمَ بَيات':Predicate, #1: 1	لَازَمَ أَكْثَرَ
u'لَازَمَ ثَغْرٌ':Predicate, #1: 1	لَازَمَ الْبَيَاتَ
u'لَازَمَ عَدَالَةٌ':Predicate, #1: 1	لَازَمَ ثَغْرَ
u'لَازَمَ كَفِيلٌ':Subject, #1: 1	لَازَمَ الْعَدَالَةَ
u'لَازَمَ كَنِيسَةٌ':Predicate, #1: 1	لَازَمَ الْكَفِيلُ
u'لَازَمَ نَبِيٌّ':Subject, #1: 1	لَازَمَ الْكَنِيسَةَ
u'لَازَمَ نِيَّةٌ':Predicate, #1: 1	لَازَمَ النَّبِيُّ
u'لَاصَقَ بِنَاءٌ':Subject, #1: 1	لَازَمَ نِيَّةَ
u'لَاصَقَ شَيْءٌ':Predicate, #1: 1	لَاصَقَ الْبِنَاءُ
u'لَاعَنَ بَيْنٌ':Predicate, #1: 1	لَاصَقَ الشَّيْءَ
u'لَاعَنَ رَجُلٌ':Subject, #8: 8	لَاعَنَ بَيْنَ
u'لَاعَنَ رَسُولٌ':Subject, #3: 3	لَاعَنَ الرَّجُلُ
u'لَاعَنَ زَوْجٌ':Subject, #1: 1	لَاعَنَ رَسُولُ
u'لَاعَنَ زَوْجٌ':Subject, #1: 1	لَاعَنَ الزَّوْجُ
u'لَاعَنَ زَوْجَةٌ':Predicate, #1: 1	لَاعَنَ زَوْجٌ
u'لَاعَنَ عُمَرٌ':Predicate, #1: 1	لَاعَنَ الزَّوْجَةَ
u'لَاعَنَ قَوْمٌ':Subject, #1: 1	لَاعَنَ عُمَرَ
u'لَاعَنَ وَجَبٌ':Predicate, #1: 1	لَاعَنَ قَوْمٌ
u'لَاعَنَ وَلَدٌ':Subject, #5: 5	لَاعَنَ وَجَبَ
u'لَاقَى أسِنَّةٌ':Predicate, #1: 1	لَاعَنَ وَلَدٌ
u'لَاقَى بدن':Predicate, #1: 1	لَاقَى الْأَسِنّةَ
u'لَاقَى بَدَنٌ':Predicate, #1: 1	لَاقَى الْبَدَنَ
u'لَاقَى بدن':Predicate, #1: 1	لَاقَى الْبَدَنَ
u'لَاقَى بَدَنٌ':Predicate, #1: 1	لَاقَى بَدَنَ
u'لَاقَى ثَوْبٌ':Subject, #1: 1	لَاقَى بَدَنَ
u'لَاقَى حُرْمَةٌ':Predicate, #1: 1	لَاقَى ثَوْبُهُ
u'لَاقَى حُرِّيَّةٌ':Predicate, #1: 1	لَاقَى حُرْمَةَ
u'لَاقَى حَفْرٌ':Predicate, #1: 1	لَاقَى حُرِّيَّةَ
u'لَاقَى حَقٌّ':Predicate, #1: 1	لَاقَى حَفْرَ
u'لَاقَى حِمَامٌ':Predicate, #2: 2	لَاقَى حَقَّ
u'لَاقَى خَالِصٌ':Predicate, #1: 1	لَاقَى حِمَامَ
u'لَاقَى درجة':Predicate, #1: 1	لَاقَى خَالِصَ
u'لَاقَى دَرَجَةٌ':Predicate, #1: 1	لَاقَى دَرَجَةَ
u'لَاقَى رَجُلٌ':Predicate, #1: 1	لَاقَى دَرَجَةَ
u'لَاقَى عَدُوٌّ':Predicate, #1: 1	لَاقَى الرَّجُلَ
u'لَاقَى عين':Predicate, #1: 1	لَاقَى الْعَدُوَّ
u'لَاقَى عَيْنٌ':Predicate, #1: 1	لَاقَى عَيْنَ
u'لَاقَى عَيْن':Predicate, #1: 1	لَاقَى عَيْنَ
u'لَاقَى فِعْلٌ':Subject, #1: 1	لَاقَى عَيْنَ
u'لَاقَى فُلُوسٌ':Predicate, #2: 2	لَاقَى فِعْلُهُ
u'لَاقَى كِتَابَةٌ':Predicate, #1: 1	لَاقَى الْفُلُوسَ
u'لَاقَى مَاءٌ':Predicate, #1: 1	لَاقَى الْكِتَابَةَ
u'لَاقَى مَاءٌ':Subject, #1: 1	لَاقَى الْمَاءَ
u'لَاقَى مَالٌ':Subject, #1: 1	لَاقَى الْمَاءُ
u'لَاقَى مُجِيرٌ':Subject, #1: 1	لَاقَى مَالُهُ
u'لَاقَى مِلْكٌ':Predicate, #1: 1	لَاقَى مُجِيرُ
u'لَاقَى نَجَاسَةٌ':Predicate, #4: 4	لَاقَى مِلْكَ
u'لَاقَى نَجِسٌ':Predicate, #4: 4	لَاقَى النَّجَاسَةَ
u'لَاقَى يسار':Subject, #1: 1	لَاقَى النَّجِسَ
u'لَاقَى يَسَارٌ':Subject, #2: 2	لَاقَى يَسَارُ
u'لَامَ اِبْنٌ':Subject, #2: 2	لَاقَى يَسَارُ
u'لَامَ صَدِيقٌ':Predicate, #1: 1	لَامَ ابْنُ
u'لَامَ لاَئِمٌ':Subject, #1: 1	لَامَ الصَّدِيقَ
u'لَانَ حطاب':Subject, #2: 2	لَامَ لَائِمُ
u'لَانَ صِيَاغَةٌ':Predicate, #1: 1	أَلَانَ حِطَابُ
u'لَبِثَ بِضْعٌ':Predicate, #1: 1	لَانَ الصِّيَاغَةَ
u'لَبِثَ عَشْرٌ':Predicate, #1: 1	لَبِثَ بِضْعَ
u'لَبِثَ نَبِيٌّ':Subject, #1: 1	لَبِثَ عَشْرَ
u'لَبَّدَ جَازٌ':Predicate, #1: 1	لَبِثَ النَّبِيُّ
u'لَبَّدَ رَسُولٌ':Subject, #1: 1	لَبَّدَ جَازَ
u'لَبَّدَ شَعْرٌ':Predicate, #1: 1	لَبَّدَ رَسُولُ
u'لَبَّ رَجُلٌ':Subject, #2: 2	لَبَّدَ شَعْرَ
u'لبس أَحْسَنُ':Added, #1: 1	أَلَبَّ الرَّجُلُ
u'لُبْسٌ أَحْسَنُ':Added, #1: 1	لُبْسُ أَحْسَنِ
u'لبس أحْمَر':Added, #1: 1	لُبْسُ أَحْسَنِ
u'لُبْسٌ أحْمَر':Added, #1: 1	لُبْسُ الْأَحْمَرِ
u'لبس أحْمَر':Added, #1: 1	لُبْسُ الْأَحْمَرِ
u'لُبْسٌ أحْمَر':Added, #3: 3	لُبْسِ الْأَحْمَرِ
u'لَبِسَ إِزَارٌ':Predicate, #3: 3	لُبْسِ الْأَحْمَرِ
u'لبس إِزَارٌ':Added, #2: 2	لَبِسَ الْإِزَارَ
u'لبس إِزَارٌ':Added, #1: 1	لُبْسَ الْإِزَارِ
u'لُبْسٌ إِزَارٌ':Added, #1: 1	لُبْسُ الْإِزَارِ
u'لُبْسٌ إِزَارٌ':Added, #1: 1	لُبْسَ الْإِزَارِ
u'لبس إِزَارٌ':Added, #1: 1	لُبْسُ الْإِزَارِ
u'لُبْسٌ إِزَارٌ':Added, #3: 3	لُبْسِ الْإِزَارِ
u'لَبِسَ أَسْفَلُ':Predicate, #3: 3	لُبْسِ الْإِزَارِ
u'لبس أَقْبِيَةٌ':Added, #1: 1	لَبِسَ الْأَسْفَلَ
u'لُبْسٌ أَقْبِيَةٌ':Added, #1: 1	لُبْسِ الْأَقْبِيَةِ
u'لَبِسَ أَكْثَرُ':Predicate, #1: 1	لُبْسِ الْأَقْبِيَةِ
u'لبس أَكْثَرُ':Added, #2: 2	لَبِسَ أَكْثَرَ
u'لُبْسٌ أَكْثَرُ':Added, #1: 1	لُبْسِ أَكْثَرِ
u'لبس آلةٌ':Added, #1: 1	لُبْسِ أَكْثَرِ
u'لُبْسٌ آلةٌ':Added, #1: 1	لُبْسَ آلَةِ
u'لبس الْمَرْأَةُ':Added, #1: 1	لُبْسَ آلَةِ
u'لبس الْمَرْأَةُ':Added, #1: 1	لُبْسَ الْمَرْأَةِ
u'لُبْسٌ الْمَرْأَةُ':Added, #1: 1	لُبْسُ الْمَرْأَةِ
u'لُبْسٌ الْمَرْأَةُ':Added, #1: 1	لُبْسَ الْمَرْأَةِ
u'لبس الْمَرْأَةُ':Added, #1: 1	لُبْسُ الْمَرْأَةِ
u'لُبْسٌ الْمَرْأَةُ':Added, #2: 2	لُبْسِ الْمَرْأَةِ
u'لبس أهْلٌ':Added, #2: 2	لُبْسِ الْمَرْأَةِ
u'لُبْسٌ أهْلٌ':Added, #1: 1	لُبْسُ أَهْلِ
u'لبس أوْسَطُ':Added, #1: 1	لُبْسُ أَهْلِ
u'لُبْسٌ أوْسَطُ':Added, #1: 1	لُبْسُ أَوْسَطِ
u'لبس بَارِي':Added, #1: 1	لُبْسُ أَوْسَطِ
u'لُبْسٌ بَارِي':Added, #1: 1	لُبْسُ بَارِيَةٍ
u'لبس بَعْضٌ':Added, #1: 1	لُبْسُ بَارِيَةٍ
u'لبس بَعْضٌ':Added, #1: 1	لُبْسُ بَعْضِ
u'لُبْسٌ بَعْضٌ':Added, #1: 1	لُبْسِ بَعْضِ
u'لُبْسٌ بَعْضٌ':Added, #1: 1	لُبْسُ بَعْضِ
u'لبس بَيَاضٌ':Added, #1: 1	لُبْسِ بَعْضِ
u'لُبْسٌ بَيَاضٌ':Added, #1: 1	لُبْسُ الْبَيَاضِ
u'لُبْسَةٌ الْمَرْأَةُ':Added, #1: 1	لُبْسُ الْبَيَاضِ
u'لُبْسَةٌ أنبياء':Added, #1: 1	لُبْسَةَ الْمَرْأَةِ
u'لُبْسَةٌ أهْلٌ':Added, #1: 1	لُبْسَةِ الأَنْبِيَاءِ
u'لُبْسَةٌ صَحَابَةٌ':Added, #2: 2	لُبْسَةُ أَهْلِ
u'لُبْسَةٌ يهود':Added, #1: 1	لُبْسَةُ الصَّحَابَةِ
u'لُبْسَةٌ يهود':Added, #1: 1	لُبْسَةَ الْيَهُودِ
u'لُبْسَةٌ يَهُودٌ':Added, #1: 1	لُبْسَةُ الْيَهُودِ
u'لُبْسَةٌ يَهُودٌ':Added, #1: 1	لُبْسَةَ الْيَهُودِ
u'لبس تَعْمِيمٌ':Added, #1: 1	لُبْسَةُ الْيَهُودِ
u'لُبْسٌ تَعْمِيمٌ':Added, #1: 1	لُبْسِ التَّعْمِيمِ
u'لبس تِكَّةٌ':Added, #1: 1	لُبْسِ التَّعْمِيمِ
u'لُبْسٌ تِكَّةٌ':Added, #1: 1	لُبْسُ التِّكَّةِ
u'لَبِسَ ثَانِي':Predicate, #1: 1	لُبْسُ التِّكَّةِ
u'لَبِسَ ثَانِيَةٌ':Predicate, #1: 1	لَبِسَ الثَّانِيَةَ
u'لبس ثَلاثَةٌ':Added, #1: 1	لَبِسَ الثَّانِيَةَ
u'لُبْسٌ ثَلاثَةٌ':Added, #1: 1	لُبْسُ الثَّلَاثَةِ
u'لَبِسَ ثَوْبٌ':Predicate, #1: 1	لُبْسُ الثَّلَاثَةِ
u'لَبِسَ ثَوْبٌ':Predicate, #12: 12	لَبِسَ ثَوْبَ
u'لَبِسَ ثَوْبٌ':Predicate, #16: 16	لَبِسَ الثَّوْبَ
u'لبس ثَوْبٌ':Added, #1: 1	أَلْبَسَ الثَّوْبَ
u'لُبْسٌ ثَوْبٌ':Added, #11: 11	لُبْسِ الثَّوْبِ
u'لبس ثَوْبٌ':Added, #11: 11	لُبْسِ الثَّوْبِ
u'لُبْسٌ ثَوْبٌ':Added, #1: 1	لُبْسَ الثَّوْبِ
u'لبس ثَوْبٌ':Added, #1: 1	لُبْسَ الثَّوْبِ
u'لُبْسٌ ثَوْبٌ':Added, #1: 1	لُبْسِ الثَّوْبَيْنِ
u'لبس ثَوْبٌ':Added, #1: 1	لُبْسِ الثَّوْبَيْنِ
u'لبس ثَوْبٌ':Added, #1: 1	لُبْسَ ثَوْبٍ
u'لُبْسٌ ثَوْبٌ':Added, #1: 1	لُبْسَ ثَوْبِ
u'لُبْسٌ ثَوْبٌ':Added, #1: 1	لُبْسَ ثَوْبٍ
u'لبس ثَوْبٌ':Added, #1: 1	لُبْسَ ثَوْبِ
u'لُبْسٌ ثَوْبٌ':Added, #1: 1	لُبْسَ ثَوْبِهِ
u'لبس ثَوْبٌ':Added, #1: 1	لُبْسَ ثَوْبِهِ
u'لُبْسٌ ثَوْبٌ':Added, #5: 5	لُبْسُ ثَوْبٍ
u'لبس ثَوْبٌ':Added, #5: 5	لُبْسُ ثَوْبٍ
u'لُبْسٌ ثَوْبٌ':Added, #9: 9	لُبْسُ الثَّوْبِ
u'لبس ثَوْبٌ':Added, #9: 9	لُبْسُ الثَّوْبِ
u'لُبْسٌ ثَوْبٌ':Added, #9: 9	لُبْسِ ثَوْبٍ
u'لَبِسَ ثِيابٌ':Predicate, #9: 9	لُبْسِ ثَوْبٍ
u'لَبِسَ ثِيابٌ':Predicate, #1: 1	لَبِسَ ثِيَابَ
u'لبس ثِيابٌ':Added, #2: 2	لَبِسَ الثِّيَابَ
u'لُبْسٌ ثِيابٌ':Added, #1: 1	لُبْسِ الثّيَابِ
u'لبس ثِيابٌ':Added, #1: 1	لُبْسِ الثّيَابِ
u'لُبْسٌ ثِيابٌ':Added, #1: 1	لُبْسُ ثِيَابٍ
u'لبس ثِيابٌ':Added, #1: 1	لُبْسُ ثِيَابٍ
u'لُبْسٌ ثِيابٌ':Added, #3: 3	لُبْسُ ثِيَابِ
u'لبس ثِيابٌ':Added, #3: 3	لُبْسُ ثِيَابِ
u'لبس ثِيابٌ':Added, #9: 9	لُبْسُ الثِّيَابِ
u'لُبْسٌ ثِيابٌ':Added, #9: 9	لُبْسِ الثِّيَابِ
u'لُبْسٌ ثِيابٌ':Added, #9: 9	لُبْسُ الثِّيَابِ
u'لبس جَديدٌ':Added, #9: 9	لُبْسِ الثِّيَابِ
u'لبس جَدِيدٌ':Added, #1: 1	لُبْسِ الْجَدِيدِ
u'لُبْسٌ جَديدٌ':Added, #1: 1	لُبْسِ الْجَدِيدِ
u'لُبْسٌ جَدِيدٌ':Added, #1: 1	لُبْسِ الْجَدِيدِ
u'لُبْسٌ جَديدٌ':Added, #1: 1	لُبْسِ الْجَدِيدِ
u'لبس جلد':Added, #1: 1	لُبْسٍ جَدِيدٍ
u'لُبْسٌ جلد':Added, #1: 1	لُبْسُ جِلْدِ
u'لبس جِلْدٌ':Added, #1: 1	لُبْسُ جِلْدِ
u'لُبْسٌ جِلْدٌ':Added, #1: 1	لُبْسُ جِلْدِ
u'لبس جلد':Added, #1: 1	لُبْسُ جِلْدِ
u'لُبْسٌ جلد':Added, #5: 5	لُبْسِ جِلْدِ
u'لبس جِلْدٌ':Added, #5: 5	لُبْسِ جِلْدِ
u'لُبْسٌ جِلْدٌ':Added, #5: 5	لُبْسِ جِلْدِ
u'لبس جُلُودٌ':Added, #5: 5	لُبْسِ جِلْدِ
u'لُبْسٌ جُلُودٌ':Added, #1: 1	لُبْسِ الْجُلُودِ
u'لبس جُلُودٌ':Added, #1: 1	لُبْسِ الْجُلُودِ
u'لُبْسٌ جُلُودٌ':Added, #2: 2	لُبْسِ جُلُودِ
u'لبس حَرامٌ':Added, #2: 2	لُبْسِ جُلُودِ
u'لُبْسٌ حَرامٌ':Added, #1: 1	لُبْسِ الْحَرَامِ
u'لَبِسَ حَرِيرٌ':Predicate, #1: 1	لُبْسِ الْحَرَامِ
u'لبس حَرِيرٌ':Added, #15: 15	لَبِسَ الْحَرِيرَ
u'لُبْسٌ حَرِيرٌ':Added, #10: 10	لُبْسَ الْحَرِيرِ
u'لبس حَرِيرٌ':Added, #10: 10	لُبْسَ الْحَرِيرِ
u'لبس حَرِيرٌ':Added, #1: 1	لُبْسُ حَرِيرٍ
u'لُبْسٌ حَرِيرٌ':Added, #1: 1	لُبْسِ حَرِيرٍ
u'لُبْسٌ حَرِيرٌ':Added, #1: 1	لُبْسُ حَرِيرٍ
u'لبس حَرِيرٌ':Added, #1: 1	لُبْسِ حَرِيرٍ
u'لُبْسٌ حَرِيرٌ':Added, #25: 25	لُبْسُ الْحَرِيرِ
u'لبس حَرِيرٌ':Added, #25: 25	لُبْسُ الْحَرِيرِ
u'لُبْسٌ حَرِيرٌ':Added, #50: 50	لُبْسِ الْحَرِيرِ
u'لبس حَشْوٌ':Added, #50: 50	لُبْسِ الْحَرِيرِ
u'لُبْسٌ حَشْوٌ':Added, #1: 1	لُبْسِ الْحَشْوِ
u'لبس حَلْقَةٌ':Added, #1: 1	لُبْسِ الْحَشْوِ
u'لُبْسٌ حَلْقَةٌ':Added, #2: 2	لُبْسِ الْحَلْقَةِ
u'لبس حُلِيٌّ':Added, #2: 2	لُبْسِ الْحَلْقَةِ
u'لبس حُلِيٌّ':Added, #1: 1	لُبْسُ حُلِيٍّ
u'لُبْسٌ حُلِيٌّ':Added, #1: 1	لُبْسُ حُلِيِّ
u'لُبْسٌ حُلِيٌّ':Added, #1: 1	لُبْسُ حُلِيٍّ
u'لبس حُلِيٌّ':Added, #1: 1	لُبْسُ حُلِيِّ
u'لُبْسٌ حُلِيٌّ':Added, #2: 2	لُبْسِ الْحُلِيِّ
u'لبس حُلِيٌّ':Added, #2: 2	لُبْسِ الْحُلِيِّ
u'لُبْسٌ حُلِيٌّ':Added, #5: 5	لُبْسُ الْحُلِيِّ
u'لبس حُمْرَةٌ':Added, #5: 5	لُبْسُ الْحُلِيِّ
u'لُبْسٌ حُمْرَةٌ':Added, #1: 1	لُبْسِ الْحُمْرَةِ
u'لبس حَيٌّ':Added, #1: 1	لُبْسِ الْحُمْرَةِ
u'لُبْسٌ حَيٌّ':Added, #2: 2	لُبْسِ الْحَيِّ
u'لبس خرقة':Added, #2: 2	لُبْسِ الْحَيِّ
u'لُبْسٌ خرقة':Added, #2: 2	لُبْسُ الْخِرْقَةِ
u'لبس خِرْقَةٌ':Added, #2: 2	لُبْسُ الْخِرْقَةِ
u'لُبْسٌ خِرْقَةٌ':Added, #2: 2	لُبْسُ الْخِرْقَةِ
u'لبس خرقة':Added, #2: 2	لُبْسُ الْخِرْقَةِ
u'لُبْسٌ خرقة':Added, #3: 3	لُبْسِ الْخِرْقَةِ
u'لبس خِرْقَةٌ':Added, #3: 3	لُبْسِ الْخِرْقَةِ
u'لُبْسٌ خِرْقَةٌ':Added, #3: 3	لُبْسِ الْخِرْقَةِ
u'لبس خَزٌّ':Added, #3: 3	لُبْسِ الْخِرْقَةِ
u'لبس خَزٌّ':Added, #3: 3	لُبْسُ الْخَزِّ
u'لُبْسٌ خَزٌّ':Added, #3: 3	لُبْسِ الْخَزِّ
u'لُبْسٌ خَزٌّ':Added, #3: 3	لُبْسُ الْخَزِّ
u'لبس خشن':Added, #3: 3	لُبْسِ الْخَزِّ
u'لُبْسٌ خشن':Added, #2: 2	لُبْسُ الْخَشِنِ
u'لبس خَشِنٌ':Added, #2: 2	لُبْسُ الْخَشِنِ
u'لُبْسٌ خَشِنٌ':Added, #2: 2	لُبْسُ الْخَشِنِ
u'لَبِسَ خُفٌّ':Predicate, #2: 2	لُبْسُ الْخَشِنِ
u'لَبِسَ خُفٌّ':Predicate, #1: 1	لَبِسَ خُفَّ
u'لبس خُفٌّ':Added, #29: 29	لَبِسَ الْخُفَّ
u'لُبْسٌ خُفٌّ':Added, #19: 19	لُبْسِ الْخُفِّ
u'لبس خُفٌّ':Added, #19: 19	لُبْسِ الْخُفِّ
u'لُبْسٌ خُفٌّ':Added, #1: 1	لُبْسِ خُفٍّ
u'لبس خُفٌّ':Added, #1: 1	لُبْسِ خُفٍّ
u'لُبْسٌ خُفٌّ':Added, #2: 2	لُبْسَ الْخُفِّ
u'لبس خُفٌّ':Added, #2: 2	لُبْسَ الْخُفِّ
u'لُبْسٌ خُفٌّ':Added, #4: 4	لُبْسُ الْخُفَّيْنِ
u'لبس خُفٌّ':Added, #4: 4	لُبْسُ الْخُفَّيْنِ
u'لُبْسٌ خُفٌّ':Added, #5: 5	لُبْسُ الْخُفِّ
u'لبس خُفٌّ':Added, #5: 5	لُبْسُ الْخُفِّ
u'لُبْسٌ خُفٌّ':Added, #8: 8	لُبْسِ الْخُفَّيْنِ
u'لبس خَلْخَالٌ':Added, #8: 8	لُبْسِ الْخُفَّيْنِ
u'لُبْسٌ خَلْخَالٌ':Added, #1: 1	لُبْسُ الْخَلْخَالِ
u'لبس خِمَارٌ':Added, #1: 1	لُبْسُ الْخَلْخَالِ
u'لُبْسٌ خِمَارٌ':Added, #1: 1	لُبْسِ خِمَارٍ
u'لَبِسَ دَرَاهِمُ':Predicate, #1: 1	لُبْسِ خِمَارٍ
u'لبس دَمالِجُ':Added, #1: 1	لَبِسَ الدَّرَاهِمَ
u'لُبْسٌ دَمالِجُ':Added, #1: 1	لُبْسِ الدَّمَالِجِ
u'لبس ديباجٌ':Added, #1: 1	لُبْسِ الدَّمَالِجِ
u'لُبْسٌ ديباجٌ':Added, #1: 1	لُبْسِ الدِّيبَاجِ
u'لبس ديباجٌ':Added, #1: 1	لُبْسِ الدِّيبَاجِ
u'لُبْسٌ ديباجٌ':Added, #2: 2	لُبْسُ دِيبَاجٍ
u'لبس دِينٌ':Added, #2: 2	لُبْسُ دِيبَاجٍ
u'لَبْسٌ دِينٌ':Added, #1: 1	لَبْسُ الدِّينِ
u'لبس ذكر':Added, #1: 1	لَبْسُ الدِّينِ
u'لُبْسٌ ذكر':Added, #1: 1	لُبْسُ الذَّكَرِ
u'لبس ذَكَرٌ':Added, #1: 1	لُبْسُ الذَّكَرِ
u'لُبْسٌ ذَكَرٌ':Added, #1: 1	لُبْسُ الذَّكَرِ
u'لَبِسَ ذِمِّيٌّ':Subject, #1: 1	لُبْسُ الذَّكَرِ
u'لَبِسَ ذَهَبٌ':Predicate, #1: 1	لَبِسَ الذِّمِّيُّ
u'لبس ذَهَبٌ':Added, #1: 1	لَبِسَ الذَّهَبَ
u'لُبْسٌ ذَهَبٌ':Added, #11: 11	لُبْسِ الذَّهَبِ
u'لبس ذَهَبٌ':Added, #11: 11	لُبْسِ الذَّهَبِ
u'لُبْسٌ ذَهَبٌ':Added, #2: 2	لُبْسُ الذَّهَبِ
u'لبس رَجُلٌ':Added, #2: 2	لُبْسُ الذَّهَبِ
u'لُبْسٌ رَجُلٌ':Added, #1: 1	لُبْسِ الرَّجُلِ
u'لبس رَجُلٌ':Added, #1: 1	لُبْسِ الرَّجُلِ
u'لُبْسٌ رَجُلٌ':Added, #4: 4	لُبْسَ الرَّجُلِ
u'لبس رِدَاءٌ':Added, #4: 4	لُبْسَ الرَّجُلِ
u'لُبْسٌ رِدَاءٌ':Added, #2: 2	لُبْسِ الرِّدَاءِ
u'لبس رَفيعٌ':Added, #2: 2	لُبْسِ الرِّدَاءِ
u'لُبْسٌ رَفيعٌ':Added, #1: 1	لُبْسَ الرَّفِيعِ
u'لبس رَفيعٌ':Added, #1: 1	لُبْسَ الرَّفِيعِ
u'لبس رَفيعٌ':Added, #1: 1	لُبْسَ رَفِيعِ
u'لُبْسٌ رَفيعٌ':Added, #1: 1	لُبْسِ رَفِيعِ
u'لُبْسٌ رَفيعٌ':Added, #1: 1	لُبْسَ رَفِيعِ
u'لبس رَقيقٌ':Added, #1: 1	لُبْسِ رَفِيعِ
u'لبس رَقيق':Added, #1: 1	لُبْسُ الرَّقِيقِ
u'لُبْسٌ رَقيقٌ':Added, #1: 1	لُبْسُ الرَّقِيقِ
u'لُبْسٌ رَقيق':Added, #1: 1	لُبْسُ الرَّقِيقِ
u'لبس زَرْدَة':Added, #1: 1	لُبْسُ الرَّقِيقِ
u'لُبْسٌ زَرْدَة':Added, #1: 1	لُبْسُ الزَّرْدَةِ
u'لبس زَوْجٌ':Added, #1: 1	لُبْسُ الزَّرْدَةِ
u'لُبْسٌ زَوْجٌ':Added, #1: 1	لُبْسُ زَوْجِ
u'لَبِسَ زِيٌّ':Predicate, #1: 1	لُبْسُ زَوْجِ
u'لبس زِيٌّ':Added, #1: 1	لَبِسَ زِيَّ
u'لُبْسٌ زِيٌّ':Added, #1: 1	لُبْسَ زِيِّ
u'لبس زِيٌّ':Added, #1: 1	لُبْسَ زِيِّ
u'لُبْسٌ زِيٌّ':Added, #2: 2	لُبْسِ زِيِّ
u'لبس زِينَةٌ':Added, #2: 2	لُبْسِ زِيِّ
u'لُبْسٌ زِينَةٌ':Added, #1: 1	لُبْسِ الزِّينَةِ
u'لبس زِينَةٌ':Added, #1: 1	لُبْسِ الزِّينَةِ
u'لُبْسٌ زِينَةٌ':Added, #1: 1	لُبْسُ زِينَةٍ
u'لبس سَائِرٌ':Added, #1: 1	لُبْسُ زِينَةٍ
u'لُبْسٌ سَائِرٌ':Added, #1: 1	لُبْسَ سَائِرِ
u'لَبِسَ سَرَاوِيلُ':Predicate, #1: 1	لُبْسَ سَائِرِ
u'لَبِسَ سَرَاوِيلُ':Predicate, #1: 1	لَبِسَ السَّرَاوِيلَ
u'لبس سَرَاوِيلُ':Added, #5: 5	لَبِسَ سَرَاوِيلَ
u'لُبْسٌ سَرَاوِيلُ':Added, #1: 1	لُبْسِ السَّرَاوِيلِ
u'لبس سَرَاوِيلُ':Added, #1: 1	لُبْسِ السَّرَاوِيلِ
u'لُبْسٌ سَرَاوِيلُ':Added, #3: 3	لُبْسَ السَّرَاوِيلِ
u'لبس سَرَاوِيلُ':Added, #3: 3	لُبْسَ السَّرَاوِيلِ
u'لُبْسٌ سَرَاوِيلُ':Added, #4: 4	لُبْسُ السَّرَاوِيلِ
u'لبس سِرْوَالٌ':Added, #4: 4	لُبْسُ السَّرَاوِيلِ
u'لُبْسٌ سِرْوَالٌ':Added, #1: 1	لُبْسُ السِّرْوَالِ
u'لَبَّسَ سعر':Predicate, #1: 1	لُبْسُ السِّرْوَالِ
u'لَبَّسَ سِعْرٌ':Predicate, #2: 2	لَبَّسَ السِّعْرَ
u'لَبِسَ سِلاَحٌ':Predicate, #2: 2	لَبَّسَ السِّعْرَ
u'لبس سِلاَحٌ':Added, #1: 1	لَبِسَ السِّلاَحَ
u'لُبْسٌ سِلاَحٌ':Added, #1: 1	لُبْسِ السِّلَاحِ
u'لبس سَلَفٌ':Added, #1: 1	لُبْسِ السِّلَاحِ
u'لُبْسٌ سَلَفٌ':Added, #1: 1	لُبْسِ السَّلَفِ
u'لبس سَوادٌ':Added, #1: 1	لُبْسِ السَّلَفِ
u'لُبْسٌ سَوادٌ':Added, #1: 1	لُبْسَ السَّوَادِ
u'لبس سَوادٌ':Added, #1: 1	لُبْسَ السَّوَادِ
u'لُبْسٌ سَوادٌ':Added, #4: 4	لُبْسُ السَّوَادِ
u'لبس سَوادٌ':Added, #4: 4	لُبْسُ السَّوَادِ
u'لُبْسٌ سَوادٌ':Added, #5: 5	لُبْسِ السَّوَادِ
u'لَبِسَ شعار':Predicate, #5: 5	لُبْسِ السَّوَادِ
u'لَبِسَ شِعَارٌ':Predicate, #1: 1	لَبِسَ شِعَارَ
u'لبس شعار':Added, #1: 1	لَبِسَ شِعَارَ
u'لُبْسٌ شعار':Added, #1: 1	لُبْسُ شِعَارِ
u'لبس شِعَارٌ':Added, #1: 1	لُبْسُ شِعَارِ
u'لُبْسٌ شِعَارٌ':Added, #1: 1	لُبْسُ شِعَارِ
u'لبس شعار':Added, #1: 1	لُبْسُ شِعَارِ
u'لُبْسٌ شعار':Added, #3: 3	لُبْسِ شِعَارِ
u'لبس شِعَارٌ':Added, #3: 3	لُبْسِ شِعَارِ
u'لُبْسٌ شِعَارٌ':Added, #3: 3	لُبْسِ شِعَارِ
u'لبس شُفُوفٌ':Added, #3: 3	لُبْسِ شِعَارِ
u'لُبْسٌ شُفُوفٌ':Added, #1: 1	لُبْسِ الشُّفُوفِ
u'لبس شهرة':Added, #1: 1	لُبْسِ الشُّفُوفِ
u'لُبْسٌ شهرة':Added, #1: 1	لُبْسِ الشُّهْرَةِ
u'لبس شُهْرَةٌ':Added, #1: 1	لُبْسِ الشُّهْرَةِ
u'لُبْسٌ شُهْرَةٌ':Added, #1: 1	لُبْسِ الشُّهْرَةِ
u'لبس شَيْءٌ':Added, #1: 1	لُبْسِ الشُّهْرَةِ
u'لبس شَيْءٌ':Added, #1: 1	لُبْسَ شَيْءٍ
u'لُبْسٌ شَيْءٌ':Added, #1: 1	لُبْسُ شَيْءٍ
u'لُبْسٌ شَيْءٌ':Added, #1: 1	لُبْسَ شَيْءٍ
u'لبس صِبْيَانٌ':Added, #1: 1	لُبْسُ شَيْءٍ
u'لُبْسٌ صِبْيَانٌ':Added, #1: 1	لُبْسِ الصِّبْيَانِ
u'لبس صغار':Added, #1: 1	لُبْسِ الصِّبْيَانِ
u'لُبْسٌ صغار':Added, #1: 1	لُبْسِ الصِّغَارِ
u'لبس صُوفٌ':Added, #1: 1	لُبْسِ الصِّغَارِ
u'لُبْسٌ صُوفٌ':Added, #2: 2	لُبْسُ الصُّوفِ
u'لبس طَاهِرٌ':Added, #2: 2	لُبْسُ الصُّوفِ
u'لُبْسٌ طَاهِرٌ':Added, #1: 1	لُبْسِ الطَّاهِرِ
u'لبس طَيَالِسَةٌ':Added, #1: 1	لُبْسِ الطَّاهِرِ
u'لُبْسٌ طَيَالِسَةٌ':Added, #1: 1	لُبْسِ الطَّيَالِسَةِ
u'لَبِسَ طَيْلَسَانٌ':Predicate, #1: 1	لُبْسِ الطَّيَالِسَةِ
u'لبس طَيْلَسَانٌ':Added, #2: 2	لَبِسَ الطَّيْلَسَانَ
u'لُبْسٌ طَيْلَسَانٌ':Added, #1: 1	لُبْسُ الطَّيْلَسَانِ
u'لبس طَيْلَسَانٌ':Added, #1: 1	لُبْسُ الطَّيْلَسَانِ
u'لبس طَيْلَسَانٌ':Added, #2: 2	لُبْسَ الطَّيْلَسَانِ
u'لُبْسٌ طَيْلَسَانٌ':Added, #2: 2	لُبْسِ الطَّيْلَسَانِ
u'لُبْسٌ طَيْلَسَانٌ':Added, #2: 2	لُبْسَ الطَّيْلَسَانِ
u'لَبِسَ ظُلَّةٌ':Predicate, #2: 2	لُبْسِ الطَّيْلَسَانِ
u'لبس عَالِمٌ':Added, #1: 1	لَبِسَ الظُّلَّةَ
u'لُبْسٌ عَالِمٌ':Added, #1: 1	لُبْسِ الْعَالِمِ
u'لَبِسَ عباء':Predicate, #1: 1	لُبْسِ الْعَالِمِ
u'لبس عَبَاءةٌ':Added, #1: 1	لَبِسَ الْعَبَاءَ
u'لُبْسٌ عَبَاءةٌ':Added, #1: 1	لُبْسُ الْعَبَاءَةِ
u'لَبِسَ عَبَّاسٌ':Subject, #1: 1	لُبْسُ الْعَبَاءَةِ
u'لَبِسَ عَبْدٌ':Subject, #1: 1	لَبِسَ الْعَبّاسُ
u'لَبِسَ عِزٌّ':Subject, #1: 1	لَبِسَ عَبْدُهُ
u'لَبِسَ عُقَدٌ':Predicate, #1: 1	لَبِسَ الْعِزُّ
u'لَبِسَ عِقْدٌ':Predicate, #1: 1	لَبِسَ عُقَدَ
u'لبس عَلاَمَةٌ':Added, #4: 4	لَبِسَ عِقْدَ
u'لُبْسٌ عَلاَمَةٌ':Added, #1: 1	لُبْسُ عَلَامَةٍ
u'لَبِسَ عِمَامَةٌ':Predicate, #1: 1	لُبْسُ عَلَامَةٍ
u'لبس عِمَامَةٌ':Added, #1: 1	لَبِسَ الْعِمَامَةَ
u'لبس عِمَامَةٌ':Added, #1: 1	لُبْسُ الْعِمَامَةِ
u'لُبْسٌ عِمَامَةٌ':Added, #1: 1	لُبْسِ الْعِمَامَةِ
u'لُبْسٌ عِمَامَةٌ':Added, #1: 1	لُبْسُ الْعِمَامَةِ
u'لبس عِمَامَةٌ':Added, #1: 1	لُبْسِ الْعِمَامَةِ
u'لُبْسٌ عِمَامَةٌ':Added, #1: 1	لُبْسُ عِمَامَةٍ
u'لبس عَمَائِمُ':Added, #1: 1	لُبْسُ عِمَامَةٍ
u'لُبْسٌ عَمَائِمُ':Added, #1: 1	لُبْسِ الْعَمَائِمِ
u'لَبِسَ عين':Predicate, #1: 1	لُبْسِ الْعَمَائِمِ
u'لَبِسَ عَيْنٌ':Predicate, #1: 1	لَبِسَ عَيْنَ
u'لَبِسَ عَيْن':Predicate, #1: 1	لَبِسَ عَيْنَ
u'لبس عين':Added, #1: 1	لَبِسَ عَيْنَ
u'لبس عَيْنٌ':Added, #1: 1	لُبْسُ الْعَيْنِ
u'لبس عَيْن':Added, #1: 1	لُبْسُ الْعَيْنِ
u'لُبْسٌ عين':Added, #1: 1	لُبْسُ الْعَيْنِ
u'لُبْسٌ عَيْنٌ':Added, #1: 1	لُبْسُ الْعَيْنِ
u'لُبْسٌ عَيْن':Added, #1: 1	لُبْسُ الْعَيْنِ
u'لبس غَزْلٌ':Added, #1: 1	لُبْسُ الْعَيْنِ
u'لبس غَزْلٌ':Added, #1: 1	لُبْسَ الْغَزْلِ
u'لُبْسٌ غَزْلٌ':Added, #1: 1	لُبْسُ الْغَزْلِ
u'لُبْسٌ غَزْلٌ':Added, #1: 1	لُبْسَ الْغَزْلِ
u'لبس غِيَارٌ':Added, #1: 1	لُبْسُ الْغَزْلِ
u'لبس غِيَارٌ':Added, #1: 1	لُبْسَ الْغِيَارِ
u'لُبْسٌ غِيَارٌ':Added, #1: 1	لُبْسِ الْغِيَارِ
u'لُبْسٌ غِيَارٌ':Added, #1: 1	لُبْسَ الْغِيَارِ
u'لبس غِيَارٌ':Added, #1: 1	لُبْسِ الْغِيَارِ
u'لُبْسٌ غِيَارٌ':Added, #1: 1	لُبْسِ غِيَارٍ
u'لَبِسَ غير':Predicate, #1: 1	لُبْسِ غِيَارٍ
u'لَبِسَ غَيْرٌ':Predicate, #2: 2	لَبِسَ غَيْرَ
u'لبس غير':Added, #2: 2	لَبِسَ غَيْرَ
u'لبس غَيْرٌ':Added, #1: 1	لُبْسِ غَيْرِ
u'لُبْسٌ غير':Added, #1: 1	لُبْسِ غَيْرِ
u'لُبْسٌ غَيْرٌ':Added, #1: 1	لُبْسِ غَيْرِ
u'لبس غير':Added, #1: 1	لُبْسِ غَيْرِ
u'لبس غَيْرٌ':Added, #2: 2	لُبْسُ غَيْرِ
u'لُبْسٌ غير':Added, #2: 2	لُبْسُ غَيْرِ
u'لُبْسٌ غَيْرٌ':Added, #2: 2	لُبْسُ غَيْرِ
u'لبس فِرَاءٌ':Added, #2: 2	لُبْسُ غَيْرِ
u'لُبْسٌ فِرَاءٌ':Added, #1: 1	لُبْسُ الْفِرَاءِ
u'لَبِسَ فرد':Predicate, #1: 1	لُبْسُ الْفِرَاءِ
u'لَبِسَ فَرْدٌ':Predicate, #1: 1	لَبِسَ الْفَرْدَ
u'لبس فِضَّةٌ':Added, #1: 1	لَبِسَ الْفَرْدَ
u'لُبْسٌ فِضَّةٌ':Added, #3: 3	لُبْسِ الْفِضَّةِ
u'لبس فِضَّةٌ':Added, #3: 3	لُبْسِ الْفِضَّةِ
u'لُبْسٌ فِضَّةٌ':Added, #4: 4	لُبْسُ الْفِضَّةِ
u'لبس فلان':Added, #4: 4	لُبْسُ الْفِضَّةِ
u'لُبْسٌ فلان':Added, #1: 1	لُبْسِ الْوَاصِفِ
u'لَبِسَ قَبَاءٌ':Predicate, #1: 1	لُبْسِ الْوَاصِفِ
u'لبس قَبَاءٌ':Added, #1: 1	لَبِسَ الْقَبَاءَ
u'لبس قَبَاءٌ':Added, #2: 2	لُبْسَ الْقَبَاءِ
u'لُبْسٌ قَبَاءٌ':Added, #2: 2	لُبْسُ الْقَبَاءِ
u'لُبْسٌ قَبَاءٌ':Added, #2: 2	لُبْسَ الْقَبَاءِ
u'لبس قَبَاءٌ':Added, #2: 2	لُبْسُ الْقَبَاءِ
u'لُبْسٌ قَبَاءٌ':Added, #3: 3	لُبْسِ الْقَبَاءِ
u'لبس قُفَّازٌ':Added, #3: 3	لُبْسِ الْقَبَاءِ
u'لُبْسٌ قُفَّازٌ':Added, #1: 1	لُبْسَ الْقُفَّازَيْنِ
u'لبس قُفَّازٌ':Added, #1: 1	لُبْسَ الْقُفَّازَيْنِ
u'لُبْسٌ قُفَّازٌ':Added, #2: 2	لُبْسِ الْقُفَّازَيْنِ
u'لبس قُفَّازٌ':Added, #2: 2	لُبْسِ الْقُفَّازَيْنِ
u'لُبْسٌ قُفَّازٌ':Added, #2: 2	لُبْسُ قُفَّازٍ
u'لبس قُفَّازٌ':Added, #2: 2	لُبْسُ قُفَّازٍ
u'لُبْسٌ قُفَّازٌ':Added, #4: 4	لُبْسُ الْقُفَّازَيْنِ
u'لبس قَلَنْسُوَةٌ':Added, #4: 4	لُبْسُ الْقُفَّازَيْنِ
u'لبس قَلَنْسُوَةٌ':Added, #1: 1	لُبْسُ الْقَلَنْسُوَةِ
u'لُبْسٌ قَلَنْسُوَةٌ':Added, #1: 1	لُبْسِ الْقَلَنْسُوَةِ
u'لُبْسٌ قَلَنْسُوَةٌ':Added, #1: 1	لُبْسُ الْقَلَنْسُوَةِ
u'لبس قَلَنْسُوَةٌ':Added, #1: 1	لُبْسِ الْقَلَنْسُوَةِ
u'لُبْسٌ قَلَنْسُوَةٌ':Added, #1: 1	لُبْسِ قَلَنْسُوَةٍ
u'لَبِسَ قَمِيصٌ':Predicate, #1: 1	لُبْسِ قَلَنْسُوَةٍ
u'لَبِسَ قَمِيصٌ':Predicate, #1: 1	لَبِسَ قَمِيصَ
u'لبس قَمِيصٌ':Added, #3: 3	لَبِسَ الْقَمِيصَ
u'لبس قَمِيصٌ':Added, #5: 5	لُبْسُ الْقَمِيصِ
u'لُبْسٌ قَمِيصٌ':Added, #5: 5	لُبْسِ الْقَمِيصِ
u'لُبْسٌ قَمِيصٌ':Added, #5: 5	لُبْسُ الْقَمِيصِ
u'لبس قَمِيصٌ':Added, #5: 5	لُبْسِ الْقَمِيصِ
u'لُبْسٌ قَمِيصٌ':Added, #5: 5	لُبْسِ قَمِيصٍ
u'لَبِسَ كَتَّانٌ':Predicate, #5: 5	لُبْسِ قَمِيصٍ
u'لبس كَتَّانٌ':Added, #2: 2	لَبِسَ الْكَتَّانَ
u'لبس كَتَّانٌ':Added, #2: 2	لُبْسُ الْكَتَّانِ
u'لُبْسٌ كَتَّانٌ':Added, #2: 2	لُبْسِ الْكَتَّانِ
u'لُبْسٌ كَتَّانٌ':Added, #2: 2	لُبْسُ الْكَتَّانِ
u'لبس كُحْلِيٌّ':Added, #2: 2	لُبْسِ الْكَتَّانِ
u'لُبْسٌ كُحْلِيٌّ':Added, #1: 1	لُبْسُ الْكُحْلِيِّ
u'لَبِسَ كِسَاءٌ':Predicate, #1: 1	لُبْسُ الْكُحْلِيِّ
u'لَبِسَ لِبَاسٌ':Predicate, #1: 1	لَبِسَ كِسَاءَ
u'لَبِسَ لبس':Predicate, #2: 2	لَبِسَ اللِّبَاسَ
u'لَبِسَ لِبْسٌ':Predicate, #1: 1	لَبِسَ لِبْسَ
u'لبس لُؤْلُؤٌ':Added, #1: 1	لَبِسَ لِبْسَ
u'لُبْسٌ لُؤْلُؤٌ':Added, #1: 1	لُبْسُ اللُّؤْلُؤِ
u'لبس لُؤْلُؤٌ':Added, #1: 1	لُبْسُ اللُّؤْلُؤِ
u'لُبْسٌ لُؤْلُؤٌ':Added, #4: 4	لُبْسَ اللُّؤْلُؤِ
u'لَبِسَ لَيْلٌ':Predicate, #4: 4	لُبْسَ اللُّؤْلُؤِ
u'لبس مُبَطَّنٌ':Added, #1: 1	لَبِسَ لَيْلَةً
u'لُبْسٌ مُبَطَّنٌ':Added, #1: 1	لُبْسُ الْمُبَطَّنِ
u'لبس مثل':Added, #1: 1	لُبْسُ الْمُبَطَّنِ
u'لُبْسٌ مثل':Added, #1: 1	لُبْسِ مِثْلِهِ
u'لبس مِثْلٌ':Added, #1: 1	لُبْسِ مِثْلِهِ
u'لُبْسٌ مِثْلٌ':Added, #1: 1	لُبْسِ مِثْلِهِ
u'لَبِسَ مُحْرِمٌ':Subject, #1: 1	لُبْسِ مِثْلِهِ
u'لَبِسَ مُحْرِمٌ':Subject, #3: 3	لَبِسَ مُحْرِمٌ
u'لبس مُحْرِمٌ':Added, #6: 6	لَبِسَ الْمُحْرِمُ
u'لبس مُحْرِمٌ':Added, #2: 2	لُبْسُ الْمُحْرِمِ
u'لُبْسٌ مُحْرِمٌ':Added, #2: 2	لُبْسِ الْمُحْرِمِ
u'لُبْسٌ مُحْرِمٌ':Added, #2: 2	لُبْسُ الْمُحْرِمِ
u'لبس مُحَنَّكٌ':Added, #2: 2	لُبْسِ الْمُحْرِمِ
u'لُبْسٌ مُحَنَّكٌ':Added, #1: 1	لُبْسَ الْمُحَنَّكَةِ
u'لُبْسٌ مُخْتَصّ':Added, #1: 1	لُبْسَ الْمُحَنَّكَةِ
u'لبس مِخْيَطٌ':Added, #1: 1	لُبْسٍ مُخْتَصٍّ
u'لُبْسٌ مِخْيَطٌ':Added, #1: 1	لُبْسُ الْمِخْيَطِ
u'لبس مِخْيَطٌ':Added, #1: 1	لُبْسُ الْمِخْيَطِ
u'لُبْسٌ مِخْيَطٌ':Added, #2: 2	لُبْسِ الْمِخْيَطِ
u'لبس مُرْتَهِنٌ':Added, #2: 2	لُبْسِ الْمِخْيَطِ
u'لُبْسٌ مُرْتَهِنٌ':Added, #1: 1	لُبْسَ الْمُرْتَهِنِ
u'لبس مُرَقَّعٌ':Added, #1: 1	لُبْسَ الْمُرْتَهِنِ
u'لُبْسٌ مُرَقَّعٌ':Added, #1: 1	لُبْسِ الْمُرَقَّعِ
u'لبس مُرَقَّعٌ':Added, #1: 1	لُبْسِ الْمُرَقَّعِ
u'لُبْسٌ مُرَقَّعٌ':Added, #1: 1	لُبْسِ مُرَقَّعَةٍ
u'لبس مَصْبُوغ':Added, #1: 1	لُبْسِ مُرَقَّعَةٍ
u'لُبْسٌ مَصْبُوغ':Added, #1: 1	لُبْسَ الْمَصْبُوغِ
u'لبس مَصْبُوغ':Added, #1: 1	لُبْسَ الْمَصْبُوغِ
u'لُبْسٌ مَصْبُوغ':Added, #1: 1	لُبْسُ مَصْبُوغٍ
u'لبس مَصْبُوغ':Added, #1: 1	لُبْسُ مَصْبُوغٍ
u'لبس مَصْبُوغ':Added, #2: 2	لُبْسُ الْمَصْبُوغِ
u'لُبْسٌ مَصْبُوغ':Added, #2: 2	لُبْسِ الْمَصْبُوغِ
u'لُبْسٌ مَصْبُوغ':Added, #2: 2	لُبْسُ الْمَصْبُوغِ
u'لبس مُضَرَّجٌ':Added, #2: 2	لُبْسِ الْمَصْبُوغِ
u'لُبْسٌ مُضَرَّجٌ':Added, #1: 1	لُبْسَ الْمُضَرَّجِ
u'لبس مُعَصْفَر':Added, #1: 1	لُبْسَ الْمُضَرَّجِ
u'لُبْسٌ مُعَصْفَر':Added, #1: 1	لُبْسَ الْمُعَصْفَرِ
u'لبس مُعَصْفَر':Added, #1: 1	لُبْسَ الْمُعَصْفَرِ
u'لُبْسٌ مُعَصْفَر':Added, #3: 3	لُبْسِ الْمُعَصْفَرِ
u'لبس مُعَصْفَر':Added, #3: 3	لُبْسِ الْمُعَصْفَرِ
u'لُبْسٌ مُعَصْفَر':Added, #4: 4	لُبْسُ الْمُعَصْفَرِ
u'لبس مَغْصُوب':Added, #4: 4	لُبْسُ الْمُعَصْفَرِ
u'لُبْسٌ مَغْصُوب':Added, #1: 1	لُبْسِ الْمَغْصُوبِ
u'لبس مَقْطُوعٌ':Added, #1: 1	لُبْسِ الْمَغْصُوبِ
u'لُبْسٌ مَقْطُوعٌ':Added, #1: 1	لُبْسُ الْمَقْطُوعِ
u'لبس مُكَعَّبٌ':Added, #1: 1	لُبْسُ الْمَقْطُوعِ
u'لُبْسٌ مُكَعَّبٌ':Added, #1: 1	لُبْسُ مُكَعَّبٍ
u'لبس مُمَسَّكٌ':Added, #1: 1	لُبْسُ مُكَعَّبٍ
u'لُبْسٌ مُمَسَّكٌ':Added, #1: 1	لُبْسِ الْمُمَسَّكِ
u'لبس مَنْسُوجٌ':Added, #1: 1	لُبْسِ الْمُمَسَّكِ
u'لُبْسٌ مَنْسُوجٌ':Added, #1: 1	لُبْسُ الْمَنْسُوجِ
u'لبس مِنْطَقَةٌ':Added, #1: 1	لُبْسُ الْمَنْسُوجِ
u'لُبْسٌ مِنْطَقَةٌ':Added, #2: 2	لُبْسَ الْمِنْطَقَةِ
u'لَبِسَ نَاسٌ':Subject, #2: 2	لُبْسَ الْمِنْطَقَةِ
u'لبس نَاسٌ':Added, #1: 1	لَبِسَ النَّاسُ
u'لُبْسٌ نَاسٌ':Added, #1: 1	لُبْسِ النَّاسِ
u'لبس نَاعِمٌ':Added, #1: 1	لُبْسِ النَّاسِ
u'لُبْسٌ نَاعِمٌ':Added, #1: 1	لُبْسُ النَّاعِمِ
u'لَبِسَ نَجَسٌ':Predicate, #1: 1	لُبْسُ النَّاعِمِ
u'لبس نَحْوٌ':Added, #1: 1	لَبِسَ نَجَسَ
u'لُبْسٌ نَحْوٌ':Added, #1: 1	لُبْسُ نَحْوِ
u'لبس نِساءٌ':Added, #1: 1	لُبْسُ نَحْوِ
u'لبس نِساءٌ':Added, #1: 1	لُبْسَ النِّسَاءِ
u'لُبْسٌ نِساءٌ':Added, #1: 1	لُبْسُ النِّسَاءِ
u'لُبْسٌ نِساءٌ':Added, #1: 1	لُبْسَ النِّسَاءِ
u'لَبِسَ نِصْفٌ':Predicate, #1: 1	لُبْسُ النِّسَاءِ
u'لبس نَعْلٌ':Added, #1: 1	لَبِسَ نِصْفَ
u'لبس نَعْلٌ':Added, #1: 1	لُبْسُ النَّعْلِ
u'لُبْسٌ نَعْلٌ':Added, #1: 1	لُبْسِ النَّعْلِ
u'لُبْسٌ نَعْلٌ':Added, #1: 1	لُبْسُ النَّعْلِ
u'لبس نَعْلٌ':Added, #1: 1	لُبْسِ النَّعْلِ
u'لبس نَعْلٌ':Added, #1: 1	لُبْسُ النَّعْلَيْنِ
u'لُبْسٌ نَعْلٌ':Added, #1: 1	لُبْسِ النَّعْلَيْنِ
u'لُبْسٌ نَعْلٌ':Added, #1: 1	لُبْسُ النَّعْلَيْنِ
u'لُبْسٌ واحد':Added, #1: 1	لُبْسِ النَّعْلَيْنِ
u'لُبْسٌ وَاحِدٌ':Added, #1: 1	لُبْسٍ وَاحِدٍ
u'لبس واصِف':Added, #1: 1	لُبْسٍ وَاحِدٍ
u'لُبْسٌ واصِف':Added, #1: 1	لُبْسِ الْوَاصِفِ
u'لَبِسَ وَهَلٌ':Predicate, #1: 1	لُبْسِ الْوَاصِفِ
u'لَبَّى اِسْمٌ':Subject, #1: 1	لَبِسَ وَهَلَكَ
u'لَبَّى تَلْبيَةٌ':Predicate, #1: 1	لَبَّى اسْمٌ
u'لَبَّى حاجٌّ':Subject, #1: 1	لَبَّى تَلْبِيَةَ
u'لَبَّى رَسُولٌ':Subject, #2: 2	لَبَّى الْحَاجُّ
u'لَبَّى سقط':Predicate, #4: 4	لَبَّى رَسُولُ
u'لَبَّى سَقَطٌ':Predicate, #1: 1	لَبَّى سَقَطَ
u'لَبَّى عَشِيَّةٌ':Predicate, #1: 1	لَبَّى سَقَطَ
u'لَبَّى عند':Predicate, #1: 1	لَبَّى عَشِيَّةَ
u'لَبَّى قَالٌ':Predicate, #2: 2	لَبَّى عِنْدَ
u'لَبَّى مَلاَئِكَةٌ':Subject, #1: 1	لَبَّى قَالَ
u'لَتَّ بَعْضٌ':Predicate, #1: 1	لَبَّى الْمَلَائِكَةُ
u'لَتَّ رَجُلٌ':Subject, #1: 1	لَتَّ بَعْضَ
u'لَتَّ سَوِيق':Predicate, #1: 1	لَتَّ الرَّجُلُ
u'لَجَأَ أعْيانٌ':Subject, #7: 7	لَتَّ السَّوِيقَ
u'لَجَأَ أَعْيَانٌ':Subject, #1: 1	لَجَأَ الْأَعْيَانُ
u'لَجَأَ حاكِمٌ':Predicate, #1: 1	لَجَأَ الْأَعْيَانُ
u'لَجَأَ سَبُعٌ':Predicate, #2: 2	أَلْجَأَ الْحَاكِمَ
u'لَجَأَ سَمَكٌ':Predicate, #1: 1	أَلْجَأَ السَّبُعَ
u'لَجَأَ قَاضِي':Predicate, #1: 1	أَلْجَأَ سَمَكَةً
u'لَجَأَ قَوْمٌ':Subject, #2: 2	أَلْجَأَ الْقَاضِيَ
u'لَجَأَ مُبَرِّدٌ':Predicate, #1: 1	لَجَأَ قَوْمٌ
u'لَجَأَ وَكِيلٌ':Predicate, #1: 1	أَلْجَأَ الْمُبَرِّدَ
u'لِحَاءٌ شَجَرٌ':Added, #1: 1	أَلْجَأَ الْوَكِيلَ
u'لِحَاءٌ شَجَرٌ':Added, #1: 1	لِحَاءِ الشَّجَرِ
u'لِحَاءٌ شَجَرَةٌ':Added, #2: 2	لِحَاءَ شَجَرٍ
u'لحاق ضَرَرٌ':Added, #4: 4	لِحَاءَ شَجَرَةٍ
u'لِحَاقٌ ضَرَرٌ':Added, #1: 1	لِحَاقِ الضَّرَرِ
u'لحاق نَسَبٌ':Added, #1: 1	لِحَاقِ الضَّرَرِ
u'لِحَاقٌ نَسَبٌ':Added, #1: 1	لِحَاقِ النَّسَبِ
u'لَحَّ خَصْمٌ':Subject, #1: 1	لِحَاقِ النَّسَبِ
u'لَحْدٌ قَبْرٌ':Added, #5: 5	أَلَحَّ الْخَصْمُ
u'لَحْدٌ واحد':Added, #1: 1	لَحْدِ الْقَبْرِ
u'لَحْدٌ وَاحِدٌ':Added, #1: 1	لَحْدٍ وَاحِدٍ
u'لَحِسَ ثَوْبٌ':Predicate, #1: 1	لَحْدٍ وَاحِدٍ
u'لَحَظَ أسْبَابٌ':Predicate, #1: 1	لَحِسَ الثَّوْبَ
u'لَحَظَ أَسْبَابٌ':Predicate, #1: 1	لَحَظَ الْأَسْبَابَ
u'لَحْظٌ الْمَرْأَةُ':Added, #1: 1	لَحَظَ الْأَسْبَابَ
u'لَحَظَ بَيْعٌ':Predicate, #1: 1	لَحْظَ الْمَرْأَةِ
u'لَحَظَ زَمانٌ':Subject, #1: 1	لَحَظَ الْبَيْعَ
u'لَحَظَ عَبْدٌ':Subject, #1: 1	لَحَظَ الزّمَانُ
u'لَحَظَ لَفْظٌ':Predicate, #1: 1	لَحَظَ الْعَبْدُ
u'لَحَظَ مَالِكٌ':Subject, #1: 1	لَحَظَ اللَّفْظَ
u'لَحَفَ حَديثٌ':Predicate, #1: 1	لَحَظَ مَالِكٌ
u'لَحِقَ اِبْنٌ':Predicate, #1: 1	أَلْحَفَ الْحَدِيثَ
u'لَحِقَ أَجَلٌ':Predicate, #1: 1	أَلْحَقَ ابْنَ
u'لَحِقَ أحَدٌ':Subject, #1: 1	أَلْحَقَ الْأَجَلَ
u'لَحِقَ أخْبَارٌ':Predicate, #1: 1	لَحِقَ أَحَدٌ
u'لَحِقَ أَخْبَارٌ':Predicate, #1: 1	لَحِقَ الْأَخْبَارَ
u'لَحِقَ إِخْرَاجٌ':Predicate, #1: 1	لَحِقَ الْأَخْبَارَ
u'لَحِقَ أَطْرافٌ':Predicate, #1: 1	أَلْحَقَ إخْرَاجَ
u'لَحِقَ أَطْرَافٌ':Predicate, #1: 1	أَلْحَقَ الْأَطْرَافَ
u'لَحِقَ المُشْتَرِي':Predicate, #1: 1	أَلْحَقَ الْأَطْرَافَ
u'لَحِقَ إمَامٌ':Predicate, #1: 1	لَحِقَ الْمُشْتَرِيَ
u'لَحِقَ أمَانٌ':Predicate, #2: 2	لَحِقَ الْإِمَامَ
u'لَحِقَ أَوَّلُ':Predicate, #1: 1	أَلْحَقَ أَمَانَ
u'لَحِقَ أَوَّلُ':Predicate, #1: 1	لَحِقَ الْأَوَّلَ
u'لَحِقَ أَوْلاَدٌ':Predicate, #2: 2	أَلْحَقَ الْأَوَّلَ
u'لَحِقَ بَطَلٌ':Predicate, #2: 2	أَلْحَقَ أَوْلَادَ
u'لَحِقَ بَعيرٌ':Predicate, #2: 2	لَحِقَ بَطَلَ
u'لَحِقَ تَابِعٌ':Predicate, #1: 1	لَحِقَ الْبَعِيرَ
u'لَحِقَ ثَانِي':Predicate, #1: 1	أَلْحَقَ التَّابِعِينَ
u'لَحِقَ ثَانِي':Predicate, #1: 1	لَحِقَ الثَّانِيَ
u'لَحِقَ جَبْرٌ':Predicate, #2: 2	أَلْحَقَ الثَّانِيَ
u'لَحِقَ جَزَاءٌ':Predicate, #1: 1	أَلْحَقَ الْجَبْرَ
u'لَحِقَ جَمِيع':Predicate, #1: 1	أَلْحَقَ الْجَزَاءَ
u'لَحِقَ جَيْشٌ':Predicate, #1: 1	لَحِقَ الْجَمِيعَ
u'لَحِقَ خُصُومَةٌ':Predicate, #1: 1	لَحِقَ الْجَيْشَ
u'لَحِقَ خَمْسٌ':Predicate, #1: 1	أَلْحَقَ الْخُصُومَةَ
u'لَحِقَ دونٌ':Predicate, #1: 1	أَلْحَقَ الْخَمْسَ
u'لَحِقَ دَيْنٌ':Predicate, #1: 1	لَحِقَ دُونَ
u'لَحِقَ دَيْنٌ':Subject, #1: 1	أَلْحَقَ الدَّيْنَ
u'لَحِقَ دَيْنٌ':Subject, #1: 1	لَحِقَ دَيْنٌ
u'لَحِقَ ذَمٌّ':Subject, #2: 2	لَحِقَ الدَّيْنُ
u'لَحِقَ ذِمِّيٌّ':Subject, #1: 1	لَحِقَ الذَّمُّ
u'لَحِقَ رَبُّ':Predicate, #1: 1	لَحِقَ الذِّمِّيُّ
u'لَحِقَ رَبُّ':Subject, #1: 1	لَحِقَ رَبَّ
u'لَحِقَ رَسُولٌ':Predicate, #1: 1	لَحِقَ رَبُّ
u'لَحِقَ رَضيعٌ':Subject, #1: 1	لَحِقَ رَسُولَ
u'لَحِقَ ركعة':Predicate, #1: 1	لَحِقَ الرَّضِيعُ
u'لَحِقَ رَكْعَةٌ':Predicate, #1: 1	لَحِقَ الرَّكْعَةَ
u'لَحِقَ زَوْجٌ':Predicate, #1: 1	لَحِقَ الرَّكْعَةَ
u'لَحِقَ زَوْجٌ':Subject, #4: 4	لَحِقَ الزَّوْجَ
u'لَحِقَ زَوْجَةٌ':Predicate, #1: 1	لَحِقَ الزَّوْجُ
u'لَحِقَ زِيادَةٌ':Predicate, #1: 1	لَحِقَ الزَّوْجَةَ
u'لَحِقَ سَيِّدٌ':Predicate, #1: 1	أَلْحَقَ زِيَادَةَ
u'لَحِقَ سَيِّدٌ':Subject, #2: 2	لَحِقَ السَّيِّدَ
u'لَحِقَ شَرْطٌ':Predicate, #1: 1	لَحِقَ سَيِّدُ
u'لَحِقَ شَيْنٌ':Predicate, #1: 1	أَلْحَقَ الشَّرْطَ
u'لَحِقَ صَاحِبٌ':Predicate, #7: 7	أَلْحَقَ الشَّيْنَ
u'لَحِقَ صَرِيحٌ':Subject, #1: 1	لَحِقَ صَاحِبَ
u'لَحِقَ صِفَةٌ':Predicate, #1: 1	لَحِقَ الصَّرِيحُ
u'لَحِقَ ضَرْبٌ':Predicate, #1: 1	أَلْحَقَ صِفَةَ
u'لَحِقَ ظَنٌّ':Predicate, #1: 1	أَلْحَقَ ضَرْبَ
u'لَحِقَ ظَهْرٌ':Subject, #1: 1	أَلْحَقَ الظَّنَّ
u'لَحِقَ عَارِضٌ':Predicate, #1: 1	لَحِقَ ظَهْرُهُ
u'لَحِقَ عَاقِلٌ':Predicate, #1: 1	أَلْحَقَ الْعَارِضَ
u'لَحِقَ عَامِدٌ':Predicate, #1: 1	لَحِقَ الْعَاقِلَةَ
u'لَحِقَ عَبْدٌ':Predicate, #1: 1	أَلْحَقَ الْعَامِدَ
u'لَحِقَ عَبْدٌ':Predicate, #1: 1	أَلْحَقَ الْعَبْدَ
u'لَحِقَ عَدْلٌ':Predicate, #8: 8	لَحِقَ الْعَبْدَ
u'لَحِقَ عُمَرٌ':Predicate, #3: 3	لَحِقَ الْعَدْلَ
u'لَحِقَ عين':Predicate, #1: 1	لَحِقَ عُمَرَ
u'لَحِقَ عَيْنٌ':Predicate, #1: 1	لَحِقَ الْعَيْنَ
u'لَحِقَ عَيْن':Predicate, #1: 1	لَحِقَ الْعَيْنَ
u'لَحِقَ غانِم':Predicate, #1: 1	لَحِقَ الْعَيْنَ
u'لَحِقَ فلان':Predicate, #1: 1	لَحِقَ الْغَانِمِينَ
u'لَحِقَ فِيلٌ':Predicate, #1: 1	لَحِقَ الْغَانِمِينَ
u'لَحِقَ قَرْضٌ':Predicate, #1: 1	أَلْحَقَ الْفِيلَ
u'لَحِقَ كَسْبٌ':Predicate, #1: 1	أَلْحَقَ الْقَرْضَ
u'لَحِقَ لِصٌّ':Subject, #1: 1	أَلْحَقَ الْكَسْبَ
u'لَحِقَ مُدَبَّرٌ':Subject, #1: 1	لَحِقَ لِصٌّ
u'لَحِقَ مدد':Subject, #1: 1	لَحِقَ الْمُدَبَّرُ
u'لَحِقَ مَدَدٌ':Subject, #2: 2	لَحِقَ مَدَدٌ
u'لَحِقَ مُرْتَدٌّ':Subject, #2: 2	لَحِقَ مَدَدٌ
u'لَحِقَ مُرْتَدٌّ':Subject, #13: 13	لَحِقَ الْمُرْتَدُّ
u'لَحِقَ مَسَائِلُ':Predicate, #1: 1	لَحِقَ مُرْتَدٌّ
u'لَحِقَ مُشْتَرِي':Predicate, #1: 1	أَلْحَقَ مَسَائِلَ
u'لَحِقَ مَقْطُوعٌ':Subject, #1: 1	لَحِقَ الْمُشْتَرِيَ
u'لَحِقَ مَكْفُولٌ':Subject, #1: 1	لَحِقَ الْمَقْطُوعُ
u'لَحِقَ مُلْحَقٌ':Predicate, #1: 1	لَحِقَ الْمَكْفُولُ
u'لَحِقَ مُلْحَقٌ':Predicate, #1: 1	أَلْحَقَ الْمُلْحَقَ
u'لَحِقَ مُلْحَقٌ':Subject, #1: 1	لَحِقَ الْمُلْحَقَ
u'لَحِقَ مُنْحَصِرٌ':Predicate, #1: 1	لَحِقَ الْمُلْحَقُ
u'لَحِقَ مُنْكِرٌ':Predicate, #1: 1	لَحِقَ الْمُنْحَصِرَ
u'لَحِقَ مُوسِرٌ':Subject, #1: 1	لَحِقَ الْمُنْكِرَ
u'لَحِقَ مُوَكَّلٌ':Subject, #1: 1	لَحِقَ الْمُوسِرُ
u'لَحِقَ مُوَكِّلٌ':Subject, #1: 1	لَحِقَ الْمُوَكَّلُ
u'لَحِقَ نَاسٌ':Predicate, #1: 1	لَحِقَ الْمُوَكِّلُ
u'لَحِقَ نَسَبٌ':Subject, #1: 1	لَحِقَ النَّاسَ
u'لَحِقَ نَوْعٌ':Predicate, #2: 2	لَحِقَ النَّسَبُ
u'لَحِقَ هِبَةٌ':Predicate, #1: 1	أَلْحَقَ نَوْعَ
u'لَحِقَ واحد':Predicate, #1: 1	أَلْحَقَ الْهِبَةَ
u'لَحِقَ وَاحِدٌ':Predicate, #3: 3	أَلْحَقَ الْوَاحِدَ
u'لَحِقَ وَرَثَةٌ':Predicate, #3: 3	أَلْحَقَ الْوَاحِدَ
u'لَحِقَ وَعِيدٌ':Predicate, #2: 2	لَحِقَ الْوَرَثَةَ
u'لَحِقَ وَكِيلٌ':Subject, #1: 1	أَلْحَقَ الْوَعِيدَ
u'لَحِقَ ولد':Subject, #1: 1	لَحِقَ الْوَكِيلُ
u'لَحِقَ وَلَدٌ':Subject, #3: 3	لَحِقَ الْوَلَدُ
u'لَحْمٌ إِبِلٌ':Added, #3: 3	لَحِقَ الْوَلَدُ
u'لَحْمٌ إِبِلٌ':Added, #1: 1	لَحْمَ الْإِبِلِ
u'لَحْمٌ إِبِلٌ':Added, #2: 2	لَحْمَ إبِلٍ
u'لَحْمٌ إِبِلٌ':Added, #2: 2	لَحْمُ الْإِبِلِ
u'لَحْمٌ اِبْنٌ':Added, #5: 5	لَحْمِ الْإِبِلِ
u'لَحْمٌ اِبْنٌ':Added, #1: 1	لَحْمَ ابْنِ
u'لَحْمٌ أَجِنَّةٌ':Added, #1: 1	لَحْمِ ابْنِ
u'لَحْمٌ أَخٌ':Added, #1: 1	لَحْمُ الْأَجِنَّةِ
u'لَحْمٌ آدَمِيٌّ':Added, #1: 1	لَحْمِ الْأَخِ
u'لَحْمٌ آدَمِيٌّ':Added, #1: 1	لَحْمَ آدَمِيٍّ
u'لَحْمٌ آدَمِيٌّ':Added, #1: 1	لَحْمِ آدَمِيٍّ
u'لَحْمٌ آدَمِيٌّ':Added, #1: 1	لَحْمَ الْآدَمِيِّ
u'لَحْمٌ أَرْنَبٌ':Added, #6: 6	لَحْمِ الْآدَمِيِّ
u'لَحْمٌ أسْنَانٌ':Added, #1: 1	لَحْمُ الْأَرْنَبِ
u'لَحْمٌ إِنْسانٌ':Added, #2: 2	لَحْمَ الْأَسْنَانِ
u'لَحْمٌ إِنْسانٌ':Added, #1: 1	لَحْمَ الْإِنْسَانِ
u'لَحْمٌ إِنْسانٌ':Added, #1: 1	لَحْمِ الْإِنْسَانِ
u'لَحْمٌ أَنْعامٌ':Added, #3: 3	لَحْمَ إنْسَانٍ
u'لَحْمٌ أَنْعَامٌ':Added, #1: 1	لَحْمِ الْأَنْعَامِ
u'لَحْمٌ أَنْعامٌ':Added, #1: 1	لَحْمِ الْأَنْعَامِ
u'لَحْمٌ أَنْعَامٌ':Added, #1: 1	لَحْمُ أَنْعَامٍ
u'لَحْمٌ أَنْعامٌ':Added, #1: 1	لَحْمُ أَنْعَامٍ
u'لَحْمٌ أَنْعَامٌ':Added, #2: 2	لَحْمُ الْأَنْعَامِ
u'لَحْمٌ أُنْمُلَةٌ':Added, #2: 2	لَحْمُ الْأَنْعَامِ
u'لَحْمٌ إوَزٌّ':Added, #1: 1	لَحْمِ أُنْمُلَةٍ
u'لَحْمٌ بَعيرٌ':Added, #1: 1	لَحْمُ الْإِوَزِّ
u'لَحْمٌ بَغْلٌ':Added, #1: 1	لَحْمَ بَعِيرٍ
u'لَحْمٌ بَقَرٌ':Added, #1: 1	لَحْمُ الْبَغْلِ
u'لَحْمٌ بَقَرٌ':Added, #10: 10	لَحْمَ بَقَرٍ
u'لَحْمٌ بَقَرٌ':Added, #1: 1	لَحْمِ الْبَقَرَةِ
u'لَحْمٌ بَقَرٌ':Added, #2: 2	لَحْمُ الْبَقَرِ
u'لَحْمٌ بَقَرٌ':Added, #2: 2	لَحْمِ الْبَقَرِ
u'لَحْمٌ بَقَرٌ':Added, #2: 2	لَحْمَ بَقَرَةٍ
u'لَحْمٌ بَقَرٌ':Added, #3: 3	لَحْمِ بَقَرِ
u'لَحْمٌ بيض':Added, #8: 8	لَحْمَ الْبَقَرِ
u'لَحْمٌ ثَدْيٌ':Added, #1: 1	لَحْمِ الْبِيضِ
u'لَحْمٌ ثَعْلَبٌ':Added, #1: 1	لَحْمُ الثَّدْيَيْنِ
u'لَحْمٌ ثَوْرٌ':Added, #1: 1	لَحْمِ الثَّعْلَبِ
u'لَحْمٌ جَامُوسٌ':Added, #2: 2	لَحْمَ ثَوْرٍ
u'لَحْمٌ جَامُوسٌ':Added, #1: 1	لَحْمِ الْجَامُوسِ
u'لَحْمٌ جَامُوسٌ':Added, #2: 2	لَحْمَ الْجَامُوسِ
u'لَحْمٌ جَدْيٌ':Added, #3: 3	لَحْمَ جَامُوسٍ
u'لَحْمٌ جَدْيٌ':Added, #1: 1	لَحْمُ الْجَدْيِ
u'لَحْمٌ جَزَاءٌ':Added, #1: 1	لَحْمَ جَدْيٍ
u'لَحْمٌ جَزُورٌ':Added, #1: 1	لَحْمَ جَزَاءِ
u'لَحْمٌ جَزُورٌ':Added, #2: 2	لَحْمَ الْجَزُورِ
u'لَحْمٌ جَزُورٌ':Added, #2: 2	لَحْمُ الْجَزُورِ
u'لَحْمٌ جَزُورٌ':Added, #2: 2	لَحْمَ جَزُورٍ
u'لَحْمٌ جلاد':Added, #6: 6	لَحْمِ الْجَزُورِ
u'لَحْمٌ جَمَلٌ':Added, #1: 1	لَحْمَ الْجِلَادِ
u'لَحْمٌ جَمَلٌ':Added, #1: 1	لَحْمَ الْجَمَلِ
u'لَحْمٌ جَمَلٌ':Added, #1: 1	لَحْمَ جَمَلٍ
u'لَحْمٌ جِنْسٌ':Added, #2: 2	لَحْمُ جَمَلٍ
u'لَحْمٌ حَجَلٌ':Added, #1: 1	لَحْمُ جِنْسِ
u'لَحْمٌ حَجَلٌ':Added, #1: 1	لَحْمُ الْحَجَلِ
u'لَحْمٌ حَرامٌ':Added, #1: 1	لَحْمِ الْحَجَلِ
u'لَحْمٌ حِمَارٌ':Added, #2: 2	لَحْمٍ حَرَامٍ
u'لَحْمٌ حِمَارٌ':Added, #1: 1	لَحْمِ الْحِمَارِ
u'لَحْمٌ حِمَارٌ':Added, #2: 2	لَحْمَ حِمَارٍ
u'لَحْمٌ حِمَارٌ':Added, #2: 2	لَحْمِ حِمَارٍ
u'لَحْمٌ حِمَارٌ':Added, #2: 2	لَحْمِ حِمَارِ
u'لَحْمٌ حَمَامٌ':Added, #3: 3	لَحْمَ حِمَارِ
u'لَحْمٌ حمر':Added, #1: 1	لَحْمُ الْحَمَامِ
u'لَحْمٌ حُمُرٌ':Added, #1: 1	لَحْمِ الْحُمُرِ
u'لَحْمٌ حمر':Added, #1: 1	لَحْمِ الْحُمُرِ
u'لَحْمٌ حُمُرٌ':Added, #2: 2	لَحْمَ الْحُمُرِ
u'لَحْمٌ حمر':Added, #2: 2	لَحْمَ الْحُمُرِ
u'لَحْمٌ حُمُرٌ':Added, #2: 2	لَحْمَ حُمُرِ
u'لَحْمٌ حُوتٌ':Added, #2: 2	لَحْمَ حُمُرِ
u'لَحْمٌ حُوتٌ':Added, #1: 1	لَحْمَ الْحُوتِ
u'لَحْمٌ حُوتٌ':Added, #1: 1	لَحْمُ الْحُوتِ
u'لَحْمٌ حَيٌّ':Added, #1: 1	لَحْمِ الْحُوتِ
u'لَحْمٌ حَيَوَانٌ':Added, #2: 2	لَحْمٍ حَيٍّ
u'لَحْمٌ خَبِيث':Added, #1: 1	لَحْمِ الْحَيَوَانِ
u'لَحْمٌ خَدٌّ':Added, #1: 1	لَحْمُ الْخَبِيثِ
u'لَحْمٌ خَدٌّ':Added, #1: 1	لَحْمِ الْخَدِّ
u'لَحْمٌ خِنْزِيرٌ':Added, #1: 1	لَحْمِ الْخَدَّيْنِ
u'لَحْمٌ خِنْزِيرٌ':Added, #10: 10	لَحْمِ خِنْزِيرٍ
u'لَحْمٌ خِنْزِيرٌ':Added, #18: 18	لَحْمَ خِنْزِيرٍ
u'لَحْمٌ خِنْزِيرٌ':Added, #21: 21	لَحْمِ الْخِنْزِيرِ
u'لَحْمٌ خِنْزِيرٌ':Added, #4: 4	لَحْمُ خِنْزِيرٍ
u'لَحْمٌ خِنْزِيرٌ':Added, #7: 7	لَحْمُ الْخِنْزِيرِ
u'لَحْمٌ خَوْخَةٌ':Added, #8: 8	لَحْمَ الْخِنْزِيرِ
u'لَحْمٌ خَيْلٌ':Added, #1: 1	لَحْمُ الْخَوْخَةِ
u'لَحْمٌ خَيْلٌ':Added, #2: 2	لَحْمُ الْخَيْلِ
u'لَحْمٌ دَجَاجٌ':Added, #2: 2	لَحْمِ الْخَيْلِ
u'لَحْمٌ دَجاج':Added, #1: 1	لَحْمِ الدَّجَاجِ
u'لَحْمٌ دَجاج':Added, #1: 1	لَحْمَ الدَّجَاجَةِ
u'لَحْمٌ دَجَاجٌ':Added, #2: 2	لَحْمَ دَجَاجَةٍ
u'لَحْمٌ دَجَاجٌ':Added, #3: 3	لَحْمُ دَجَاجٍ
u'لَحْمٌ دُرَّاجٌ':Added, #4: 4	لَحْمَ دَجَاجٍ
u'لَحْمٌ دِيكٌ':Added, #1: 1	لَحْمُ الدُّرَّاجِ
u'لَحْمٌ دِيكٌ':Added, #2: 2	لَحْمَ الدِّيكِ
u'لَحْمٌ ذِراعٌ':Added, #2: 2	لَحْمَ دِيكٍ
u'لَحْمٌ ذِراعٌ':Added, #1: 1	لَحْمُ الذِّرَاعِ
u'لَحْمٌ ذكر':Added, #1: 1	لَحْمُ ذِرَاعِ
u'لَحْمٌ ذَكَرٌ':Added, #1: 1	لَحْمِ الذَّكَرِ
u'لَحْمٌ ذكر':Added, #1: 1	لَحْمِ الذَّكَرِ
u'لَحْمٌ ذَكَرٌ':Added, #2: 2	لَحْمَ الذَّكَرِ
u'لَحْمٌ رَأْسٌ':Added, #2: 2	لَحْمَ الذَّكَرِ
u'لَحْمٌ رَأْسٌ':Added, #1: 1	لَحْمَ رَأْسِ
u'لَحْمٌ رَأْسٌ':Added, #2: 2	لَحْمَ الرَّأْسِ
u'لَحْمٌ رَأْسٌ':Added, #2: 2	لَحْمُ الرَّأْسِ
u'لَحْمٌ رَأْسٌ':Added, #2: 2	لَحْمِ رَأْسٍ
u'لَحْمٌ رَاعِي':Added, #3: 3	لَحْمِ الرَّأْسِ
u'لَحْمٌ رَاعِي':Added, #1: 1	لَحْمُ رَاعِيَةٍ
u'لَحْمٌ رَجُلٌ':Added, #2: 2	لَحْمَ رَاعِيَةٍ
u'لَحْمٌ رَضيعٌ':Added, #1: 1	لَحْمَ رَجُلٍ
u'لَحْمٌ سِباعٌ':Added, #1: 1	لَحْمِ رَضِيعِهِ
u'لَحْمٌ سِباعٌ':Added, #1: 1	لَحْمِ سِبَاعِ
u'لَحْمٌ سَبُعٌ':Added, #2: 2	لَحْمِ السِّبَاعِ
u'لَحْمٌ سَرَطَانٌ':Added, #1: 1	لَحْمِ السَّبُعِ
u'لَحْمٌ سَمَكٌ':Added, #1: 1	لَحْمَ السَّرَطَانِ
u'لَحْمٌ سَمَكٌ':Added, #2: 2	لَحْمِ السَّمَكِ
u'لَحْمٌ شَاةٌ':Added, #6: 6	لَحْمَ السَّمَكِ
u'لَحْمٌ شَاةٌ':Added, #1: 1	لَحْمُ الشَّاةِ
u'لَحْمٌ شَاةٌ':Added, #1: 1	لَحْمَ شَاةِ
u'لَحْمٌ شَاةٌ':Added, #2: 2	لَحْمِ شَاتِهِ
u'لَحْمٌ شَاةٌ':Added, #5: 5	لَحْمِ شَاةٍ
u'لَحْمٌ شَاةٌ':Added, #6: 6	لَحْمِ الشَّاةِ
u'لَحْمٌ شَاةٌ':Added, #7: 7	لَحْمَ الشَّاةِ
u'لَحْمٌ شَيْطَانٌ':Added, #8: 8	لَحْمَ شَاةٍ
u'لَحْمٌ صَدَفٌ':Added, #1: 1	لَحْمِ الشَّيْطَانِ
u'لَحْمٌ صَيْدٌ':Added, #1: 1	لَحْمِ الصَّدَفِ
u'لَحْمٌ صَيْدٌ':Added, #3: 3	لَحْمُ الصَّيْدِ
u'لَحْمٌ صَيْدٌ':Added, #3: 3	لَحْمُ صَيْدٍ
u'لَحْمٌ صَيْدٌ':Added, #4: 4	لَحْمُ صَيْدِ
u'لَحْمٌ صَيْدٌ':Added, #5: 5	لَحْمِ صَيْدٍ
u'لَحْمٌ صَيْدٌ':Added, #7: 7	لَحْمِ الصَّيْدِ
u'لَحْمٌ صَيْدٌ':Added, #8: 8	لَحْمَ الصَّيْدِ
u'لَحْمٌ ضَأْنٌ':Added, #8: 8	لَحْمَ صَيْدٍ
u'لَحْمٌ ضَأْنٌ':Added, #1: 1	لَحْمَ ضَأْنٍ
u'لَحْمٌ ضَأْنٌ':Added, #1: 1	لَحْمُ ضَأْنٍ
u'لَحْمٌ ضَأْنٌ':Added, #2: 2	لَحْمَ الضَّأْنِ
u'لَحْمٌ ضَبٌّ':Added, #2: 2	لَحْمِ الضَّأْنِ
u'لَحْمٌ ضَبٌّ':Added, #1: 1	لَحْمَ الضَّبِّ
u'لَحْمٌ ضَبٌّ':Added, #1: 1	لَحْمِ الضَّبِّ
u'لَحْمٌ ضَبٌّ':Added, #1: 1	لَحْمِ ضَبٍّ
u'لَحْمٌ ضَبٌّ':Added, #2: 2	لَحْمُ الضَّبِّ
u'لَحْمٌ ضِبَاعٌ':Added, #3: 3	لَحْمُ ضَبٍّ
u'لَحْمٌ ضَحِيَّةٌ':Added, #2: 2	لَحْمُ الضِّبَاعِ
u'لَحْمٌ طَاهِرٌ':Added, #1: 1	لَحْمِ الضَّحِيَّةِ
u'لَحْمٌ طَرِيٌّ':Added, #3: 3	لَحْمٍ طَاهِرٍ
u'لَحْمٌ طَيْرٌ':Added, #1: 1	لَحْمٍ طَرِيٍّ
u'لَحْمٌ طَيْرٌ':Added, #1: 1	لَحْمِ طَيْرٍ
u'لَحْمٌ طَيْرٌ':Added, #2: 2	لَحْمَ الطَّيْرِ
u'لَحْمٌ طَيْرٌ':Added, #2: 2	لَحْمِ الطَّيْرِ
u'لَحْمٌ طَيْرٌ':Added, #2: 2	لَحْمَ طَيْرٍ
u'لَحْمٌ طُيُورٌ':Added, #3: 3	لَحْمُ الطَّيْرِ
u'لَحْمٌ طُيُورٌ':Added, #1: 1	لَحْمُ الطُّيُورِ
u'لَحْمٌ طُيُورٌ':Added, #2: 2	لَحْمَ الطُّيُورِ
u'لَحْمٌ ظَبْيٌ':Added, #5: 5	لَحْمِ الطُّيُورِ
u'لَحْمٌ ظَهْرٌ':Added, #1: 1	لَحْمُ ظَبْيٍ
u'لَحْمٌ ظَهْرٌ':Added, #1: 1	لَحْمِ الظَّهْرِ
u'لَحْمٌ عَدُوٌّ':Added, #3: 3	لَحْمُ الظَّهْرِ
u'لَحْمٌ عِرَابٌ':Added, #1: 1	لَحْمَ عَدُوِّهِ
u'لَحْمٌ عَنْزٌ':Added, #2: 2	لَحْمِ الْعِرَابِ
u'لَحْمٌ غَزَالٌ':Added, #2: 2	لَحْمَ عَنْزٍ
u'لَحْمٌ غَنَمٌ':Added, #1: 1	لَحْمُ الْغَزَالِ
u'لَحْمٌ غَنَمٌ':Added, #1: 1	لَحْمُ الْغَنَمِ
u'لَحْمٌ غَنَمٌ':Added, #1: 1	لَحْمِ الْغَنَمِ
u'لَحْمٌ غَنَمٌ':Added, #1: 1	لَحْمَ غَنَمٍ
u'لَحْمٌ غير':Added, #2: 2	لَحْمِ غَنَمٍ
u'لَحْمٌ غَيْرٌ':Added, #2: 2	لَحْمَ غَيْرِهِ
u'لَحْمٌ فَحْلٌ':Added, #2: 2	لَحْمَ غَيْرِهِ
u'لَحْمٌ فَرَسٌ':Added, #2: 2	لَحْمِ الْفَحْلِ
u'لَحْمٌ فَرَسٌ':Added, #2: 2	لَحْمُ الْفَرَسِ
u'لَحْمٌ فَرَسٌ':Added, #2: 2	لَحْمِ الْفَرَسِ
u'لَحْمٌ فَصِيلٌ':Added, #2: 2	لَحْمَ فَرَسٍ
u'لَحْمٌ فَمٌ':Added, #1: 1	لَحْمَ الْفَصِيلِ
u'لَحْمٌ قِدْرٌ':Added, #1: 1	لَحْمَ الْفَمِ
u'لَحْمٌ قُرْبَةٌ':Added, #1: 1	لَحْمِ قِدْرِهِ
u'لَحْمٌ قِرْدٌ':Added, #1: 1	لَحْمِ قُرْبَتِهِ
u'لَحْمٌ قَنَابِرُ':Added, #1: 1	لَحْمُ الْقِرْدِ
u'لَحْمٌ كبار':Added, #1: 1	لَحْمُ الْقَنَابِرِ
u'لَحْمٌ كِبَاشٌ':Added, #3: 3	لَحْمِ الْكِبَارِ
u'لَحْمٌ كَبْشٌ':Added, #1: 1	لَحْمُ الْكِبَاشِ
u'لَحْمٌ كُرْكِيٌّ':Added, #2: 2	لَحْمِ الْكَبْشِ
u'لَحْمٌ كَلْبٌ':Added, #1: 1	لَحْمُ الْكُرْكِيِّ
u'لَحْمٌ مَاعِزٌ':Added, #6: 6	لَحْمَ كَلْبٍ
u'لَحْمٌ مَأْكُولٌ':Added, #1: 1	لَحْمُ الْمَاعِزِ
u'لَحْمٌ مَأْكُولٌ':Added, #1: 1	لَحْمَ الْمَأْكُولَةِ
u'لَحْمٌ مَأْكُولٌ':Added, #1: 1	لَحْمِ مَأْكُولٍ
u'لَحْمٌ مُبَاحٌ':Added, #3: 3	لَحْمٍ مَأْكُولٍ
u'لَحْمٌ مُتَوَلِّدٌ':Added, #1: 1	لَحْمِ الْمُبَاحِ
u'لَحْمٌ مَجْهُولٌ':Added, #1: 1	لَحْمُ الْمُتَوَلِّدِ
u'لَحْمٌ مَخْصُوصٌ':Added, #1: 1	لَحْمِ مَجْهُولِ
u'لَحْمٌ مَشْوِيٌّ':Added, #1: 1	لَحْمٍ مَخْصُوصٍ
u'لَحْمٌ مَطْبُوخٌ':Added, #1: 1	لَحْمِ مَشْوِيٍّ
u'لَحْمٌ معز':Added, #1: 1	لَحْمٍ مَطْبُوخٍ
u'لَحْمٌ مَعْزٌ':Added, #1: 1	لَحْمَ الْمَعْزِ
u'لَحْمٌ معز':Added, #1: 1	لَحْمَ الْمَعْزِ
u'لَحْمٌ مَعْزٌ':Added, #1: 1	لَحْمُ مَعْزٍ
u'لَحْمٌ معز':Added, #1: 1	لَحْمُ مَعْزٍ
u'لَحْمٌ مَعْزٌ':Added, #2: 2	لَحْمِ الْمَعْزِ
u'لَحْمٌ مَعْلُوفٌ':Added, #2: 2	لَحْمِ الْمَعْزِ
u'لَحْمٌ مُغَلَّظ':Added, #1: 1	لَحْمِ مَعْلُوفَةٍ
u'لَحْمٌ مَغِيبٌ':Added, #1: 1	لَحْمِ الْمُغَلَّظِ
u'لَحْمٌ مَغِيبٌ':Added, #1: 1	لَحْمُ مَغِيبٍ
u'لَحْمٌ مَكْرُوهٌ':Added, #5: 5	لَحْمِ مَغِيبٍ
u'لَحْمٌ مَيْتٌ':Added, #1: 1	لَحْمِ الْمَكْرُوهِ
u'لَحْمٌ مَيْتٌ':Added, #2: 2	لَحْمَ الْمَيْتَةِ
u'لَحْمٌ مَيْتَةٌ':Added, #5: 5	لَحْمِ الْمَيْتَةِ
u'لَحْمٌ مَيْتَةٌ':Added, #1: 1	لَحْمَ مَيْتَةٍ
u'لَحْمٌ مَيْتَةٌ':Added, #2: 2	لَحْمَ الْمَيْتَةِ
u'لَحْمٌ مَيْتَةٌ':Added, #5: 5	لَحْمِ الْمَيْتَةِ
u'لَحْمٌ نَاسٌ':Added, #6: 6	لَحْمُ مَيْتَةٍ
u'لَحْمٌ نَاسٌ':Added, #1: 1	لَحْمَ النَّاسِ
u'لَحْمٌ نَاقَةٌ':Added, #1: 1	لَحْمِ النَّاسِ
u'لَحْمٌ نَاقَة':Added, #1: 1	لَحْمَ نَاقَةٍ
u'لَحْمٌ نَجَاسَةٌ':Added, #1: 1	لَحْمَ نَاقَةٍ
u'لَحْمٌ نُسُكٌ':Added, #1: 1	لَحْمُ النَّجَاسَةِ
u'لَحْمٌ نَعَمٌ':Added, #1: 1	لَحْمِ نُسُكِهِ
u'لَحْمٌ هَدْيٌ':Added, #1: 1	لَحْمُ النَّعَمِ
u'لَحْمٌ هَدْيٌ':Added, #1: 1	لَحْمِ الْهَدْيِ
u'لَحْمٌ وَجْهٌ':Added, #2: 2	لَحْمِ هَدْيِهِ
u'لَحْمٌ وَجْهٌ':Added, #1: 1	لَحْمِ الْوَجْهِ
u'لَحْمٌ وَحْشٌ':Added, #2: 2	لَحْمُ وَجْهِهِ
u'لَحْمٌ وَحْشِيٌّ':Added, #1: 1	لَحْمَ الْوَحْشِ
u'لَحَنَ إمَامٌ':Subject, #1: 1	لَحْمِ الْوَحْشِيِّ
u'لَحْنٌ بِشْرٌ':Added, #1: 1	لَحَنَ إمَامُهُ
u'لَحْنٌ حَديثٌ':Added, #1: 1	لَحْنِ بِشْرٍ
u'لَحْنٌ خِطَابٌ':Added, #1: 1	لَحْنِ الْحَدِيثِ
u'لَحْنٌ عَامٌّ':Added, #3: 3	لَحْنَ الْخِطَابِ
u'لَحْنٌ قول':Added, #1: 1	لَحْنِ الْعَامَّةِ
u'لَحْنٌ قَوْلٌ':Added, #2: 2	لَحْنُ الْقَوْلِ
u'لَحْنٌ قول':Added, #2: 2	لَحْنُ الْقَوْلِ
u'لَحْنٌ قَوْلٌ':Added, #3: 3	لَحْنِ الْقَوْلِ
u'لَحْنٌ مَنْطِقٌ':Added, #3: 3	لَحْنِ الْقَوْلِ
u'لُحُودٌ أنصار':Added, #1: 1	لَحْنِ مَنْطِقِهِ
u'لُحُودٌ أَنْصارٌ':Added, #1: 1	لُحُودَ الْأَنْصَارِ
u'لُحُودٌ أَنْصَارٌ':Added, #1: 1	لُحُودَ الْأَنْصَارِ
u'لُحُومٌ إِبِلٌ':Added, #1: 1	لُحُودَ الْأَنْصَارِ
u'لُحُومٌ إِبِلٌ':Added, #10: 10	لُحُومِ الإِبِلِ
u'لُحُومٌ إِبِلٌ':Added, #10: 10	لُحُومِ الْإِبِلِ
u'لُحُومٌ إِبِلٌ':Added, #1: 1	لُحُومَ الإِبِلِ
u'لُحُومٌ إِبِلٌ':Added, #1: 1	لُحُومُ الْإِبِلِ
u'لُحُومٌ أُتُنٌ':Added, #3: 3	لُحُومَ الْإِبِلِ
u'لُحُومٌ أُتُن':Added, #1: 1	لُحُومُ الْأُتُنِ
u'لُحُومٌ أنبياء':Added, #1: 1	لُحُومُ الْأُتُنِ
u'لُحُومٌ أَنْعامٌ':Added, #3: 3	لُحُومَ الْأَنْبِيَاءِ
u'لُحُومٌ أَنْعَامٌ':Added, #1: 1	لُحُومُ الْأَنْعَامِ
u'لُحُومٌ أَنْعامٌ':Added, #1: 1	لُحُومُ الْأَنْعَامِ
u'لُحُومٌ أَنْعَامٌ':Added, #2: 2	لُحُومِ الْأَنْعَامِ
u'لُحُومٌ جِنْسٌ':Added, #2: 2	لُحُومِ الْأَنْعَامِ
u'لُحُومٌ حمر':Added, #2: 2	لُحُومِ الْجِنْسِ
u'لُحُومٌ حُمُرٌ':Added, #14: 14	لُحُومَ الْحُمُرِ
u'لُحُومٌ حمر':Added, #14: 14	لُحُومَ الْحُمُرِ
u'لُحُومٌ حمر':Added, #1: 1	لُحُومَ الْحُمِرِ
u'لُحُومٌ حمر':Added, #1: 1	لُحُومِ الْحُمْرِ
u'لُحُومٌ حُمُرٌ':Added, #1: 1	لُحُومُ حُمُرِ
u'لُحُومٌ حمر':Added, #1: 1	لُحُومُ حُمُرِ
u'لُحُومٌ حُمُرٌ':Added, #2: 2	لُحُومُ الْحُمُرِ
u'لُحُومٌ حمر':Added, #2: 2	لُحُومُ الْحُمُرِ
u'لُحُومٌ حُمُرٌ':Added, #63: 63	لُحُومِ الْحُمُرِ
u'لُحُومٌ حَيٌّ':Added, #63: 63	لُحُومِ الْحُمُرِ
u'لُحُومٌ حَيَّاتٌ':Added, #2: 2	لُحُومَ الْحَيَّاتِ
u'لُحُومٌ حَيَّةٌ':Added, #2: 2	لُحُومَ الْحَيَّاتِ
u'لُحُومٌ خَنَازِيرُ':Added, #2: 2	لُحُومَ الْحَيَّاتِ
u'لُحُومٌ خَيْلٌ':Added, #1: 1	لُحُومَ الْخَنَازِيرِ
u'لُحُومٌ خَيْلٌ':Added, #17: 17	لُحُومِ الْخَيْلِ
u'لُحُومٌ خَيْلٌ':Added, #2: 2	لُحُومُ الْخَيْلِ
u'لُحُومٌ سِباعٌ':Added, #5: 5	لُحُومَ الْخَيْلِ
u'لُحُومٌ سِباعٌ':Added, #1: 1	لُحُومُ السِّبَاعِ
u'لُحُومٌ طَيْرٌ':Added, #4: 4	لُحُومِ السِّبَاعِ
u'لُحُومٌ طُيُورٌ':Added, #2: 2	لُحُومِ الطَّيْرِ
u'لُحُومٌ طُيُورٌ':Added, #1: 1	لُحُومِ الطُّيُورِ
u'لُحُومٌ علماء':Added, #1: 1	لُحُومِ طُيُورٍ
u'لُحُومٌ عُلَمَاءُ':Added, #1: 1	لُحُومَ الْعُلَمَاءِ
u'لُحُومٌ غَنَمٌ':Added, #1: 1	لُحُومَ الْعُلَمَاءِ
u'لُحُومٌ غوافل':Added, #10: 10	لُحُومِ الْغَنَمِ
u'لُحُومٌ كلاب':Added, #7: 7	لُحُومِ الْغَوَافِلِ
u'لُحُومٌ كلاب':Added, #1: 1	لُحُومُ الْكِلَابِ
u'لُحُومٌ كِلاَبٌ':Added, #1: 1	لُحُومُ الْكِلاَبِ
u'لُحُومٌ كِلاَبٌ':Added, #1: 1	لُحُومُ الْكِلَابِ
u'لُحُومٌ نَاسٌ':Added, #1: 1	لُحُومُ الْكِلاَبِ
u'لُحُومٌ نَاسٌ':Added, #1: 1	لُحُومِ النّاسِ
u'لُحُومٌ نَاسٌ':Added, #2: 2	لُحُومِ النَّاسِ
u'لَحْيٌ بَعيرٌ':Added, #8: 8	لُحُومَ النَّاسِ
u'لَحْيٌ بَعيرٌ':Added, #1: 1	لَحْيَ الْبَعِيرِ
u'لَخَّصَ جَوَابٌ':Predicate, #1: 1	لَحْيَ بَعِيرٍ
u'لَخَّصَ شَرْحٌ':Predicate, #1: 1	لَخَّصَ جَوَابَ
u'لَخَّصَ كَلاَمٌ':Predicate, #1: 1	لَخَّصَ شَرْحَ
u'لَخَّصَ نَوَوِيٌّ':Subject, #1: 1	لَخَّصَ كَلَامَ
u'لَدَّ أحَدٌ':Subject, #1: 1	لَخَّصَ النَّوَوِيُّ
u'لَدَّ رَجُلٌ':Subject, #1: 1	لَدَّ أَحَدُ
u'لَدْغَةٌ عَقْرَبٌ':Added, #1: 1	لَدَّ الرَّجُلُ
u'لَدْغٌ حَيٌّ':Added, #1: 1	لَدْغَةِ الْعَقْرَبِ
u'لَدْغٌ حَيَّاتٌ':Added, #1: 1	لَدْغِ الْحَيَّاتِ
u'لَدْغٌ حَيَّةٌ':Added, #1: 1	لَدْغِ الْحَيَّاتِ
u'لَدْغٌ ذُبابٌ':Added, #1: 1	لَدْغِ الْحَيَّاتِ
u'لَدَغَ رَجُلٌ':Predicate, #1: 1	لَدْغِ الذُّبَابِ
u'لَدْغٌ عَقْرَبٌ':Added, #1: 1	لَدَغَ رَجُلاً
u'لَدْغٌ مَثَانَةٌ':Added, #1: 1	لَدْغِ عَقْرَبٍ
u'لَذَّةٌ آخِرَةٌ':Added, #1: 1	لَدْغِ الْمَثَانَةِ
u'لَذَّةٌ إِنْزالٌ':Added, #1: 1	لَذَّةِ الْآخِرَةِ
u'لَذَّةٌ باقِي':Added, #2: 2	لَذَّةَ الْإِنْزَالِ
u'لَذَّةٌ باقِيَةٌ':Added, #1: 1	لَذَّةٍ بَاقِيَةٍ
u'لَذَّةٌ بدن':Added, #1: 1	لَذَّةٍ بَاقِيَةٍ
u'لَذَّةٌ بَدَنٌ':Added, #1: 1	لَذَّةِ الْبَدَنِ
u'لَذَّةٌ جماع':Added, #1: 1	لَذَّةِ الْبَدَنِ
u'لَذَّةٌ جِمَاعٌ':Added, #1: 1	لَذَّةُ الْجِمَاعِ
u'لَذَّةٌ جماع':Added, #1: 1	لَذَّةُ الْجِمَاعِ
u'لَذَّةٌ جِمَاعٌ':Added, #2: 2	لَذَّةَ الْجِمَاعِ
u'لَذَّةٌ جماع':Added, #2: 2	لَذَّةَ الْجِمَاعِ
u'لَذَّةٌ جِمَاعٌ':Added, #2: 2	لَذَّةَ جِمَاعِهِ
u'لَذَّةٌ جماع':Added, #2: 2	لَذَّةَ جِمَاعِهِ
u'لَذَّةٌ جِمَاعٌ':Added, #3: 3	لَذَّةِ الْجِمَاعِ
u'لَذَّةٌ حَرارَةٌ':Added, #3: 3	لَذَّةِ الْجِمَاعِ
u'لَذَّةٌ حِسِّيٌّ':Added, #1: 1	لَذَّةَ حَرَارَةِ
u'لَذَّةٌ حِلْمٌ':Added, #1: 1	لَذَّةٍ حِسِّيَّةٍ
u'لَذَّةٌ سَاعَةٌ':Added, #1: 1	لَذَّةَ الْحِلْمِ
u'لَذَّةٌ سَاعَةٌ':Added, #1: 1	لَذَّةُ سَاعَةٍ
u'لَذَّةٌ سكر':Added, #2: 2	لَذَّةَ سَاعَةٍ
u'لَذَّةٌ سُكْرٌ':Added, #1: 1	لَذَّةِ السُّكْرِ
u'لَذَّةٌ صَغِيرٌ':Added, #1: 1	لَذَّةِ السُّكْرِ
u'لَذَّةٌ طَاعَةٌ':Added, #1: 1	لَذَّةٍ صَغِيرَةٍ
u'لَذَّةٌ طعام':Added, #1: 1	لَذَّةُ الطَّاعَةِ
u'لَذَّةٌ طعام':Added, #1: 1	لَذَّةَ الطَّعَامِ
u'لَذَّةٌ طَعَامٌ':Added, #1: 1	لَذَّةِ الطَّعَامِ
u'لَذَّةٌ طَعَامٌ':Added, #1: 1	لَذَّةَ الطَّعَامِ
u'لَذَّةٌ عَاجِلٌ':Added, #1: 1	لَذَّةِ الطَّعَامِ
u'لَذَّةٌ عَاقِبٌ':Added, #1: 1	لَذَّةٍ عَاجِلَةٍ
u'لَذَّةٌ عَاقِبَةٌ':Added, #1: 1	لَذَّةِ عَاقِبَةِ
u'لَذَّةٌ عِبَادَةٌ':Added, #1: 1	لَذَّةِ عَاقِبَةِ
u'لَذَّةٌ عَفْوٌ':Added, #1: 1	لَذَّةَ الْعِبَادَةِ
u'لَذَّةٌ عَيْشٌ':Added, #1: 1	لَذَّةُ الْعَفْوِ
u'لَذَّةٌ فَانِي':Added, #1: 1	لَذَّةَ الْعَيْشِ
u'لَذَّةٌ قلب':Added, #1: 1	لَذَّةٍ فَانِيَةٍ
u'لَذَّةٌ قلب':Added, #1: 1	لَذَّةَ الْقَلْبِ
u'لَذَّةٌ قَلْبٌ':Added, #1: 1	لَذَّةُ الْقَلْبِ
u'لَذَّةٌ قَلْبٌ':Added, #1: 1	لَذَّةَ الْقَلْبِ
u'لَذَّةٌ قَلْب':Added, #1: 1	لَذَّةُ الْقَلْبِ
u'لَذَّةٌ قَلْب':Added, #1: 1	لَذَّةَ الْقَلْبِ
u'لَذَّةٌ كَسْبٌ':Added, #1: 1	لَذَّةُ الْقَلْبِ
u'لَذَّةٌ لَغْوٌ':Added, #1: 1	لَذَّةِ الْكَسْبِ
u'لَذَّةٌ لَمْسٌ':Added, #1: 1	لَذَّةُ لَغْوٍ
u'لَذَّةٌ مَأْكَلٌ':Added, #2: 2	لَذَّةِ اللَّمْسِ
u'لَذَّةٌ مُتَقَدِّمٌ':Added, #1: 1	لَذَّةُ الْمَأْكَلِ
u'لَذَّةٌ مَحْمَدَةٌ':Added, #1: 1	لَذَّةٍ مُتَقَدِّمَةٍ
u'لَذَّةٌ مَطْعَمٌ':Added, #1: 1	لَذَّةِ الْمَحْمَدَةِ
u'لَذَّةٌ مَطْعَمٌ':Added, #1: 1	لَذَّةِ الْمَطْعَمِ
u'لَذَّةٌ مُقَارِنٌ':Added, #1: 1	لَذَّةَ مَطْعَمٍ
u'لَذَّةٌ نَظَرٌ':Added, #1: 1	لَذَّةٍ مُقَارِنَةٍ
u'لَذَّةٌ نَظَرٌ':Added, #1: 1	لَذَّةَ النَّظَرِ
u'لَذَّةٌ نَفْسَانِيٌّ':Added, #1: 1	لَذَّةُ النَّظَرِ
u'لَذَّةٌ نَوْمٌ':Added, #1: 1	لَذَّةٍ نَفْسَانِيَّةٍ
u'لَذَّةٌ وَطْءٌ':Added, #1: 1	لَذَّةَ النَّوْمِ
u'لَذَّةٌ يَسِيرٌ':Added, #1: 1	لَذَّةَ الْوَطْءِ
u'لَذَّةٌ يَسِيرٌ':Added, #1: 1	لَذَّةِ يَسِيرَةِ
u'لَذَّ طَعْمٌ':Subject, #2: 2	لَذَّةٍ يَسِيرَةٍ
u'لَذْعٌ أَخْلاَطٌ':Added, #1: 1	لَذَّ طَعْمُهُ
u'لَزِقَ حَنَكٌ':Subject, #1: 1	لَذْعَ الْأَخْلَاطِ
u'لَزِمَ أَبٌ':Predicate, #1: 1	لَزِقَ حَنَكُهُ
u'لَزِمَ إِبَانَةٌ':Subject, #1: 1	لَزِمَ الْأَبَ
u'لَزِمَ إبدالٌ':Subject, #1: 1	لَزِمَ الْإِبَانَةُ
u'لَزِمَ إِبْطَالٌ':Subject, #1: 1	لَزِمَ الْإِبْدَالُ
u'لَزِمَ اِتِّحَادٌ':Subject, #6: 6	لَزِمَ إبْطَالُ
u'لَزِمَ إتْمَامٌ':Subject, #1: 1	لَزِمَ اتِّحَادُ
u'لَزِمَ إِتْيانٌ':Subject, #3: 3	لَزِمَ إتْمَامُهُ
u'لَزِمَ إِثْبَاتٌ':Subject, #1: 1	لَزِمَ إتْيَانُهُ
u'لَزِمَ إِثْمٌ':Subject, #2: 2	لَزِمَ إثْبَاتُ
u'لَزِمَ اِجْتِمَاعٌ':Subject, #1: 1	لَزِمَ الْإِثْمُ
u'لَزِمَ أَجْرٌ':Subject, #4: 4	لَزِمَ اجْتِمَاعُ
u'لَزِمَ أَجْرٌ':Subject, #1: 1	لَزِمَ أَجْرُ
u'لَزِمَ إِجْرَاءٌ':Subject, #1: 1	لَزِمَ الْأَجْرُ
u'لَزِمَ أَجِيرٌ':Predicate, #1: 1	لَزِمَ إجْرَاءُ
u'لَزِمَ إِحالَةٌ':Subject, #3: 3	لَزِمَ الْأَجِيرَ
u'لَزِمَ أحَدٌ':Predicate, #1: 1	لَزِمَ إحَالَةُ
u'لَزِمَ أحَدٌ':Subject, #1: 1	لَزِمَ أَحَدَ
u'لَزِمَ اِخْتِلاَفٌ':Subject, #2: 2	لَزِمَ أَحَدُ
u'لَزِمَ أخْذٌ':Subject, #4: 4	لَزِمَ اخْتِلَافُ
u'لَزِمَ إِخْرَاجٌ':Subject, #1: 1	لَزِمَ الْأَخْذُ
u'لَزِمَ إِخْلالٌ':Subject, #2: 2	لَزِمَ إخْرَاجُ
u'لَزِمَ إِرَاقَةٌ':Subject, #1: 1	لَزِمَ الْإِخْلَالُ
u'لَزِمَ أرْضٌ':Predicate, #1: 1	لَزِمَ إرَاقَةُ
u'لَزِمَ إِزَالَةٌ':Subject, #1: 1	لَزِمَ أَرْضَ
u'لَزِمَ اِسْتِثْنَاءٌ':Subject, #1: 1	لَزِمَ إزَالَتُهُ
u'لَزِمَ اِسْتِعْمالٌ':Subject, #1: 1	لَزِمَ اسْتِثْنَاءُ
u'لَزِمَ اِسْتِغْرَاقٌ':Subject, #1: 1	لَزِمَ اسْتِعْمَالُهُ
u'لَزِمَ اِسْتِغْفارٌ':Predicate, #1: 1	لَزِمَ اسْتِغْرَاقُ
u'لَزِمَ إِسْراجٌ':Subject, #1: 1	لَزِمَ الاِسْتِغْفَارَ
u'لَزِمَ اِشْتِراكٌ':Subject, #1: 1	لَزِمَ إسْرَاجُهُ
u'لَزِمَ إِظْهارٌ':Subject, #1: 1	لَزِمَ اشْتِرَاكُ
u'لَزِمَ إِعادَةٌ':Subject, #2: 2	لَزِمَ إظْهَارُ
u'لَزِمَ إِعادَةٌ':Subject, #1: 1	لَزِمَ إعَادَتُهُ
u'لَزِمَ اِعْتِبارٌ':Subject, #5: 5	لَزِمَ إعَادَةُ
u'لَزِمَ إعْلاَمٌ':Subject, #2: 2	لَزِمَ اعْتِبَارُهُ
u'لَزِمَ إِفْحَامٌ':Subject, #1: 1	لَزِمَ إعْلَامُ
u'لَزِمَ إقامَةٌ':Subject, #1: 1	لَزِمَ إفْحَامُ
u'لَزِمَ إقْرَارٌ':Subject, #1: 1	لَزِمَ إقَامَةُ
u'لَزِمَ أقَلُّ':Subject, #1: 1	لَزِمَ الْإِقْرَارُ
u'لَزِمَ إكْرَامٌ':Subject, #1: 1	لَزِمَ أَقَلُّ
u'لَزِمَ إِلْزَامٌ':Subject, #1: 1	لَزِمَ إكْرَامُهُ
u'لَزِمَ إلْغَاءٌ':Subject, #1: 1	لَزِمَ إلْزَامُ
u'لَزِمَ ألْفٌ':Subject, #4: 4	لَزِمَ إلْغَاءُ
u'لَزِمَ أَلْفٌ':Subject, #1: 1	لَزِمَ أَلْفٌ
u'لَزِمَ ألف':Subject, #1: 1	لَزِمَ أَلْفٌ
u'لَزِمَ ألْفٌ':Subject, #3: 3	لَزِمَ الْأَلْفُ
u'لَزِمَ أَلْفٌ':Subject, #3: 3	لَزِمَ الْأَلْفُ
u'لَزِمَ المُشْتَرِي':Predicate, #3: 3	لَزِمَ الْأَلْفُ
u'لَزِمَ إمَامٌ':Predicate, #12: 12	لَزِمَ الْمُشْتَرِيَ
u'لَزِمَ إمَامٌ':Subject, #4: 4	لَزِمَ الْإِمَامَ
u'لَزِمَ أمَانٌ':Subject, #1: 1	لَزِمَ الْإِمَامُ
u'لَزِمَ اِمْتِناعٌ':Subject, #1: 1	لَزِمَ أَمَانُهُ
u'لَزِمَ آمِرٌ':Predicate, #4: 4	لَزِمَ امْتِنَاعُ
u'لَزِمَ آمِرٌ':Subject, #25: 25	لَزِمَ الْآمِرَ
u'لَزِمَ أَمْرٌ':Subject, #1: 1	لَزِمَ الْآمِرُ
u'لَزِمَ إِمْهالٌ':Subject, #1: 1	لَزِمَ الْأَمْرُ
u'لَزِمَ اِنْتِفاء':Subject, #1: 1	لَزِمَ إمْهَالُهُ
u'لَزِمَ إِنْسانٌ':Predicate, #5: 5	لَزِمَ انْتِفَاءُ
u'لَزِمَ اِنْصِرافٌ':Subject, #2: 2	لَزِمَ الْإِنْسَانَ
u'لَزِمَ أَنْفٌ':Subject, #1: 1	لَزِمَ انْصِرَافُ
u'لَزِمَ اِنْفِكاكٌ':Subject, #1: 1	لَزِمَ أَنْفُهُ
u'لَزِمَ إِنْكارٌ':Subject, #1: 1	لَزِمَ انْفِكَاكُ
u'لَزِمَ إهْدَارٌ':Subject, #1: 1	لَزِمَ الْإِنْكَارُ
u'لَزِمَ أهْلٌ':Subject, #1: 1	لَزِمَ إهْدَارُ
u'لَزِمَ إهْمَالٌ':Subject, #2: 2	لَزِمَ أَهْلُ
u'لَزِمَ أَوَّلُ':Predicate, #2: 2	لَزِمَ إهْمَالُ
u'لَزِمَ أَوَّلُ':Subject, #7: 7	لَزِمَ الْأَوَّلَ
u'لَزِمَ إِيجَابٌ':Subject, #2: 2	لَزِمَ الْأَوَّلُ
u'لَزِمَ باقِي':Predicate, #2: 2	لَزِمَ إيجَابُ
u'لَزِمَ بَائِعٌ':Predicate, #1: 1	أَلْزَمَ الْبَاقِيَ
u'لَزِمَ بَائِعٌ':Subject, #8: 8	لَزِمَ الْبَائِعَ
u'لَزِمَ بَحْثٌ':Subject, #2: 2	لَزِمَ الْبَائِعُ
u'لَزِمَ بُخَارِيٌّ':Predicate, #2: 2	لَزِمَ الْبَحْثُ
u'لَزِمَ بَقاءٌ':Subject, #1: 1	أَلْزَمَ الْبُخَارِيَّ
u'لَزِمَ بَيَانٌ':Subject, #2: 2	لَزِمَ بَقَاءُ
u'لَزِمَ بَيْعٌ':Predicate, #1: 1	لَزِمَ الْبَيَانُ
u'لَزِمَ بَيْعٌ':Subject, #1: 1	لَزِمَ الْبَيْعَ
u'لَزِمَ بَيْعٌ':Subject, #1: 1	لَزِمَ بَيْعُ
u'لَزِمَ تَابِعٌ':Predicate, #22: 22	لَزِمَ الْبَيْعُ
u'لَزِمَ تَأْخِيرٌ':Subject, #1: 1	لَزِمَ التَّابِعَ
u'لَزِمَ تَأْكِيدٌ':Subject, #7: 7	لَزِمَ تَأْخِيرُ
u'لَزِمَ تَتَابُعٌ':Predicate, #1: 1	لَزِمَ التَّأْكِيدُ
u'لَزِمَ تَتَابُعٌ':Subject, #1: 1	لَزِمَ التَّتَابُعَ
u'لَزِمَ تَحْرِيمٌ':Subject, #2: 2	لَزِمَ التَّتَابُعُ
u'لَزِمَ تَحَكُّمٌ':Subject, #3: 3	لَزِمَ تَحْرِيمُ
u'لَزِمَ تَخْصِيصٌ':Subject, #2: 2	لَزِمَ التَّحَكُّمُ
u'لَزِمَ تَخْصِيصٌ':Subject, #2: 2	لَزِمَ التَّخْصِيصُ
u'لَزِمَ تَخَلُّفٌ':Subject, #2: 2	لَزِمَ تَخْصِيصُ
u'لَزِمَ تَخَلُّفٌ':Subject, #1: 1	لَزِمَ التَّخَلُّفُ
u'لَزِمَ تَخْيِيرٌ':Subject, #1: 1	لَزِمَ تَخَلُّفُ
u'لَزِمَ تَدَافُعٌ':Subject, #1: 1	لَزِمَ التَّخْيِيرُ
u'لَزِمَ تَذَكُّرٌ':Subject, #1: 1	لَزِمَ التَّدَافُعُ
u'لَزِمَ تَرْجِيحٌ':Subject, #1: 1	لَزِمَ التَّذَكُّرُ
u'لَزِمَ تَرْجِيحٌ':Subject, #1: 1	لَزِمَ التَّرْجِيحُ
u'لَزِمَ تَرْكٌ':Subject, #4: 4	لَزِمَ تَرْجِيحُ
u'لَزِمَ تَرْكٌ':Subject, #1: 1	لَزِمَ تَرْكُهُ
u'لَزِمَ تَرِكَةٌ':Predicate, #4: 4	لَزِمَ تَرْكُ
u'لَزِمَ تَرْكِيبٌ':Predicate, #1: 1	لَزِمَ تَرِكَةَ
u'لَزِمَ تَرْكِيبٌ':Subject, #1: 1	لَزِمَ التَّرْكِيبَ
u'لَزِمَ تَسَلْسُلٌ':Subject, #1: 1	لَزِمَ التَّرْكِيبُ
u'لَزِمَ تَسْلِيمٌ':Subject, #2: 2	لَزِمَ التَّسَلْسُلُ
u'لَزِمَ تَسْلِيمٌ':Subject, #1: 1	لَزِمَ التَّسْلِيمُ
u'لَزِمَ تَسْمِيَة':Subject, #1: 1	لَزِمَ تَسْلِيمُهُ
u'لَزِمَ تَصْحِيحٌ':Subject, #1: 1	لَزِمَ تَسْمِيَةُ
u'لَزِمَ تَصْدِيقٌ':Subject, #1: 1	لَزِمَ تَصْحِيحُ
u'لَزِمَ تَصَوُّرٌ':Subject, #1: 1	لَزِمَ تَصْدِيقُهُ
u'لَزِمَ تَطْوِيلٌ':Subject, #1: 1	لَزِمَ تَصَوُّرُ
u'لَزِمَ تَعَارُضٌ':Predicate, #1: 1	لَزِمَ تَطْوِيلُ
u'لَزِمَ تَعَارُضٌ':Subject, #1: 1	لَزِمَ التَّعَارُضَ
u'لَزِمَ تَعَارُضٌ':Subject, #1: 1	لَزِمَ التَّعَارُضُ
u'لَزِمَ تَعَبُّدٌ':Subject, #1: 1	لَزِمَ تَعَارُضُ
u'لَزِمَ تَعَدُّدٌ':Subject, #2: 2	لَزِمَ التَّعَبُّدُ
u'لَزِمَ تَعَذُّرٌ':Subject, #1: 1	لَزِمَ تَعَدُّدُ
u'لَزِمَ تَعْذِيب':Subject, #1: 1	لَزِمَ تَعَذُّرُ
u'لَزِمَ تَعْرِيفٌ':Subject, #1: 1	لَزِمَ التَّعْذِيبُ
u'لَزِمَ تَعْطِيلٌ':Subject, #2: 2	لَزِمَ تَعْرِيفُ
u'لَزِمَ تَعَقُّلٌ':Subject, #1: 1	لَزِمَ تَعْطِيلُ
u'لَزِمَ تَعَقُّلٌ':Subject, #1: 1	لَزِمَ تَعَقُّلُ
u'لَزِمَ تَعْلِيقٌ':Subject, #1: 1	لَزِمَ تَعَقُّلُهُ
u'لَزِمَ تَعْمِيمٌ':Subject, #1: 1	لَزِمَ التَّعْلِيقُ
u'لَزِمَ تَغْسِيلٌ':Subject, #1: 1	لَزِمَ تَعْمِيمُهُ
u'لَزِمَ تَغْيِيرٌ':Subject, #1: 1	لَزِمَ تَغْسِيلُهُ
u'لَزِمَ تَفَرُّقٌ':Subject, #1: 1	لَزِمَ تَغْيِيرُ
u'لَزِمَ تَفْرِيقٌ':Subject, #1: 1	لَزِمَ تَفَرُّقُ
u'لَزِمَ تَقْديرٌ':Subject, #1: 1	لَزِمَ التَّفْرِيقُ
u'لَزِمَ تَقْديمٌ':Subject, #3: 3	لَزِمَ تَقْدِيرُ
u'لَزِمَ تَقْريرٌ':Subject, #4: 4	لَزِمَ تَقْدِيمُ
u'لَزِمَ تَقْيِيد':Subject, #1: 1	لَزِمَ التَّقْرِيرُ
u'لَزِمَ تَقْيِيد':Subject, #1: 1	لَزِمَ التَّقْيِيدُ
u'لَزِمَ تَكْرارٌ':Subject, #1: 1	لَزِمَ تَقْيِيدُهُ
u'لَزِمَ تَكْفيرٌ':Subject, #4: 4	لَزِمَ التَّكْرَارُ
u'لَزِمَ تَكْفيرٌ':Subject, #1: 1	لَزِمَ التَّكْفِيرُ
u'لَزِمَ تَكْليفٌ':Subject, #1: 1	لَزِمَ تَكْفِيرُ
u'لَزِمَ تَكْليفٌ':Subject, #1: 1	لَزِمَ تَكْلِيفُ
u'لَزِمَ تَلْفيقٌ':Subject, #1: 1	لَزِمَ تَكْلِيفُهُ
u'لَزِمَ تَمَكُّنٌ':Subject, #1: 1	لَزِمَ التَّلْفِيقُ
u'لَزِمَ تَمْلِيكٌ':Subject, #1: 1	لَزِمَ التَّمَكُّنُ
u'لَزِمَ تَنَاقُضٌ':Subject, #1: 1	لَزِمَ تَمْلِيكُ
u'لَزِمَ تَوَارُدٌ':Subject, #4: 4	لَزِمَ التَّنَاقُضُ
u'لَزِمَ تَوْرِيث':Subject, #2: 2	لَزِمَ تَوَارُدُ
u'لَزِمَ تَوْضِيحٌ':Subject, #1: 1	لَزِمَ تَوْرِيثُ
u'لَزِمَ تَوَعُّدٌ':Subject, #1: 1	لَزِمَ تَوْضِيحُ
u'لَزِمَ تَوَقُّفٌ':Subject, #1: 1	لَزِمَ التَّوَعُّدُ
u'لَزِمَ تَوْكِيلٌ':Subject, #1: 1	لَزِمَ تَوَقُّفُ
u'لَزِمَ ثَانِي':Predicate, #1: 1	لَزِمَ تَوْكِيلُهُ
u'لَزِمَ ثُبُوتٌ':Subject, #5: 5	لَزِمَ الثَّانِيَ
u'لَزِمَ ثَمَنٌ':Subject, #4: 4	لَزِمَ ثُبُوتُ
u'لَزِمَ جَانِي':Predicate, #2: 2	لَزِمَ الثَّمَنُ
u'لَزِمَ جَزَاءٌ':Subject, #1: 1	لَزِمَ الْجَانِيَ
u'لَزِمَ جمع':Predicate, #3: 3	لَزِمَ الْجَزَاءُ
u'لَزِمَ جَمْعٌ':Predicate, #1: 1	لَزِمَ الْجَمْعَ
u'لَزِمَ جمع':Subject, #1: 1	لَزِمَ الْجَمْعَ
u'لَزِمَ جَمْعٌ':Subject, #5: 5	لَزِمَ الْجَمْعُ
u'لَزِمَ جهل':Subject, #5: 5	لَزِمَ الْجَمْعُ
u'لَزِمَ جَهْلٌ':Subject, #1: 1	لَزِمَ الْجَهْلُ
u'لَزِمَ جهل':Subject, #1: 1	لَزِمَ الْجَهْلُ
u'لَزِمَ جَهْلٌ':Subject, #1: 1	لَزِمَ جَهْلُ
u'لَزِمَ جَوَابٌ':Subject, #1: 1	لَزِمَ جَهْلُ
u'لَزِمَ جَوَازٌ':Subject, #1: 1	لَزِمَ الْجَوَابُ
u'لَزِمَ جَوَازٌ':Subject, #1: 1	لَزِمَ جَوَازُ
u'لَزِمَ حاسِبٌ':Predicate, #1: 1	لَزِمَ جَوَازُهُ
u'لَزِمَ حاكِمٌ':Predicate, #1: 1	لَزِمَ الْحَاسِبَ
u'لَزِمَ حَبْسٌ':Subject, #5: 5	لَزِمَ الْحَاكِمَ
u'لَزِمَ حَجٌّ':Subject, #1: 1	لَزِمَ حَبْسُ
u'لَزِمَ حَجْرٌ':Subject, #1: 1	لَزِمَ الْحَجُّ
u'لَزِمَ حَرَجٌ':Subject, #3: 3	لَزِمَ الْحَجْرُ
u'لَزِمَ حُرِّيَّةٌ':Subject, #5: 5	لَزِمَ الْحَرَجُ
u'لَزِمَ حُصُول':Subject, #1: 1	لَزِمَ حُرِّيَّةُ
u'لَزِمَ حِفْظٌ':Subject, #2: 2	لَزِمَ حُصُولُ
u'لَزِمَ حُكْمٌ':Subject, #1: 1	لَزِمَ حِفْظُ
u'لَزِمَ حُكْمٌ':Subject, #1: 1	لَزِمَ حُكْمُ
u'لَزِمَ حُكْمٌ':Subject, #2: 2	لَزِمَ حُكْمُهُ
u'لَزِمَ حَمْلٌ':Subject, #6: 6	لَزِمَ الْحُكْمُ
u'لَزِمَ حَيٌّ':Predicate, #1: 1	لَزِمَ الْحَمْلُ
u'لَزِمَ خُرُوجٌ':Subject, #1: 1	لَزِمَ الْحَيَّ
u'لَزِمَ خَطَأٌ':Subject, #2: 2	لَزِمَ الْخُرُوجُ
u'لَزِمَ خِلاَفٌ':Subject, #1: 1	لَزِمَ خَطَأُ
u'لَزِمَ خلق':Predicate, #1: 1	لَزِمَ خِلَافُ
u'لَزِمَ خَلْقٌ':Predicate, #1: 1	لَزِمَ الْخَلْقَ
u'لَزِمَ خلق':Predicate, #1: 1	لَزِمَ الْخَلْقَ
u'لَزِمَ خَلْقٌ':Predicate, #2: 2	أَلْزَمَ الْخَلْقَ
u'لَزِمَ دُخُولٌ':Subject, #2: 2	أَلْزَمَ الْخَلْقَ
u'لَزِمَ دُخُولٌ':Subject, #1: 1	لَزِمَ الدُّخُولُ
u'لَزِمَ دفع':Subject, #2: 2	لَزِمَ دُخُولُ
u'لَزِمَ دَفْعٌ':Subject, #1: 1	لَزِمَ الدَّفْعُ
u'لَزِمَ دفع':Subject, #1: 1	لَزِمَ الدَّفْعُ
u'لَزِمَ دَفْعٌ':Subject, #1: 1	لَزِمَ دَفْعُهُ
u'لَزِمَ دَمٌ':Subject, #1: 1	لَزِمَ دَفْعُهُ
u'لَزِمَ دَوامٌ':Subject, #2: 2	لَزِمَ الدَّمُ
u'لَزِمَ دَوْرٌ':Subject, #1: 1	لَزِمَ دَوَامُ
u'لَزِمَ دُورٌ':Subject, #10: 10	لَزِمَ الدَّوْرُ
u'لَزِمَ دِينٌ':Predicate, #1: 1	لَزِمَ الدُّورُ
u'لَزِمَ دَيْنٌ':Subject, #1: 1	لَزِمَ دِينَ
u'لَزِمَ دِينارٌ':Subject, #3: 3	لَزِمَ الدَّيْنُ
u'لَزِمَ ذاكِرٌ':Predicate, #1: 1	لَزِمَ الدِّينَارُ
u'لَزِمَ ذكر':Subject, #1: 1	لَزِمَ الذَّاكِرَ
u'لَزِمَ ذِكْرٌ':Subject, #1: 1	لَزِمَ ذِكْرُهُ
u'لَزِمَ ذِمَّةٌ':Predicate, #1: 1	لَزِمَ ذِكْرُهُ
u'لَزِمَ ذِمَّةٌ':Predicate, #1: 1	أَلْزَمَ ذِمَّةَ
u'لَزِمَ ذِمَّةٌ':Predicate, #2: 2	لَزِمَ الذِّمَّةَ
u'لَزِمَ رَاكِبٌ':Predicate, #2: 2	لَزِمَ ذِمَّةَ
u'لَزِمَ رَامِي':Predicate, #2: 2	لَزِمَ الرَّاكِبَ
u'لَزِمَ رَبُّ':Predicate, #1: 1	لَزِمَ الرَّامِيَ
u'لَزِمَ رَبُّ':Subject, #1: 1	لَزِمَ رَبَّ
u'لَزِمَ رِبْحٌ':Subject, #1: 1	لَزِمَ رَبُّ
u'لَزِمَ رَجُلٌ':Predicate, #1: 1	لَزِمَ الرِّبْحُ
u'لَزِمَ رُجُوعٌ':Subject, #2: 2	لَزِمَ الرَّجُلَ
u'لَزِمَ رَدٌّ':Subject, #1: 1	لَزِمَ رُجُوعُهُ
u'لَزِمَ رَدٌّ':Subject, #1: 1	لَزِمَ الرَّدُّ
u'لَزِمَ رَدٌّ':Subject, #1: 1	لَزِمَ رَدُّ
u'لَزِمَ رُقادٌ':Predicate, #1: 1	لَزِمَ رَدُّهُ
u'لَزِمَ رَقيقٌ':Predicate, #1: 1	لَزِمَ الرُّقَادَ
u'لَزِمَ رَقيق':Predicate, #2: 2	لَزِمَ الرَّقِيقَ
u'لَزِمَ رَهْنٌ':Subject, #2: 2	لَزِمَ الرَّقِيقَ
u'لَزِمَ زَوْجٌ':Predicate, #2: 2	لَزِمَ الرَّهْنُ
u'لَزِمَ زِيادَةٌ':Subject, #5: 5	لَزِمَ الزَّوْجَ
u'لَزِمَ زِيادَةٌ':Subject, #2: 2	لَزِمَ الزِّيَادَةُ
u'لَزِمَ سَامِعٌ':Predicate, #2: 2	لَزِمَ زِيَادَةُ
u'لَزِمَ سَبْقٌ':Subject, #1: 1	لَزِمَ السَّامِعَ
u'لَزِمَ سَكْرَان':Predicate, #1: 1	لَزِمَ سَبْقُ
u'لَزِمَ سُلْطَانٌ':Predicate, #1: 1	أَلْزَمَ السَّكْرَانَ
u'لَزِمَ سِلْعَةٌ':Predicate, #4: 4	لَزِمَ السُّلْطَانَ
u'لَزِمَ سَمَاعٌ':Subject, #1: 1	لَزِمَ السِّلْعَةَ
u'لَزِمَ سَيِّدٌ':Predicate, #1: 1	لَزِمَ سَمَاعُ
u'لَزِمَ سَيِّدٌ':Subject, #9: 9	لَزِمَ السَّيِّدَ
u'لَزِمَ شَاهِدٌ':Predicate, #1: 1	لَزِمَ السَّيِّدُ
u'لَزِمَ شَرْطٌ':Subject, #1: 1	لَزِمَ شَاهِدَ
u'لَزِمَ شَرْعِيٌّ':Subject, #1: 1	لَزِمَ شَرْطُهُ
u'لَزِمَ شَرِيكٌ':Predicate, #1: 1	لَزِمَ الشَّرْعِيُّ
u'لَزِمَ شَفِيعٌ':Predicate, #1: 1	لَزِمَ الشَّرِيكَ
u'لَزِمَ شُمُول':Subject, #3: 3	لَزِمَ الشَّفِيعَ
u'لَزِمَ شَهْرٌ':Subject, #3: 3	لَزِمَ شُمُولُ
u'لَزِمَ شُهُودٌ':Predicate, #3: 3	لَزِمَ شَهْرٌ
u'لَزِمَ شَيْءٌ':Subject, #1: 1	لَزِمَ الشُّهُودَ
u'لَزِمَ صَاحِبٌ':Predicate, #1: 1	لَزِمَ شَيْءٌ
u'لَزِمَ صَاحِبٌ':Subject, #1: 1	لَزِمَ صَاحِبَ
u'لَزِمَ صَبِيٌّ':Predicate, #2: 2	لَزِمَ صَاحِبُ
u'لَزِمَ صَبِيٌّ':Predicate, #1: 1	أَلْزَمَ الصَّبِيَّ
u'لَزِمَ صِحَّةٌ':Subject, #2: 2	لَزِمَ الصَّبِيَّ
u'لَزِمَ صَحِيحٌ':Predicate, #5: 5	لَزِمَ صِحَّةُ
u'لَزِمَ صَوَابٌ':Subject, #1: 1	لَزِمَ الصَّحِيحَ
u'لَزِمَ صَوْمٌ':Subject, #1: 1	لَزِمَ صَوَابُ
u'لَزِمَ ضَامِنٌ':Predicate, #2: 2	لَزِمَ الصَّوْمُ
u'لَزِمَ ضَمٌّ':Subject, #1: 1	لَزِمَ الضَّامِنَ
u'لَزِمَ ضَمٌّ':Subject, #1: 1	لَزِمَ ضَمُّهُ
u'لَزِمَ ضَمَانٌ':Subject, #2: 2	لَزِمَ ضَمُّ
u'لَزِمَ طَائِفٌ':Predicate, #2: 2	لَزِمَ الضَّمَانُ
u'لَزِمَ طَلاَقٌ':Subject, #1: 1	لَزِمَ الطَّائِفَةَ
u'لَزِمَ طلب':Subject, #5: 5	لَزِمَ الطَّلَاقُ
u'لَزِمَ طَلَبٌ':Subject, #1: 1	لَزِمَ طَلَبُ
u'لَزِمَ ظهار':Subject, #1: 1	لَزِمَ طَلَبُ
u'لَزِمَ عَامِلٌ':Predicate, #1: 1	لَزِمَ ظِهَارُهُ
u'لَزِمَ عِبَادٌ':Predicate, #5: 5	لَزِمَ الْعَامِلَ
u'لَزِمَ عَبَثٌ':Subject, #2: 2	لَزِمَ الْعِبَادَ
u'لَزِمَ عَبْدٌ':Predicate, #1: 1	لَزِمَ الْعَبَثُ
u'لَزِمَ عتق':Subject, #6: 6	لَزِمَ الْعَبْدَ
u'لَزِمَ عِتْقٌ':Subject, #1: 1	لَزِمَ الْعِتْقُ
u'لَزِمَ عَدَمٌ':Subject, #1: 1	لَزِمَ الْعِتْقُ
u'لَزِمَ عسر':Subject, #6: 6	لَزِمَ عَدَمُ
u'لَزِمَ عُسْرٌ':Subject, #1: 1	لَزِمَ الْعُسْرُ
u'لَزِمَ عَقْدٌ':Predicate, #1: 1	لَزِمَ الْعُسْرُ
u'لَزِمَ عَقْدٌ':Subject, #2: 2	أَلْزَمَ الْعَقْدَ
u'لَزِمَ علم':Subject, #15: 15	لَزِمَ الْعَقْدُ
u'لَزِمَ عِلْمٌ':Subject, #1: 1	لَزِمَ الْعِلْمُ
u'لَزِمَ عَمَلٌ':Subject, #1: 1	لَزِمَ الْعِلْمُ
u'لَزِمَ عُمُومٌ':Subject, #5: 5	لَزِمَ الْعَمَلُ
u'لَزِمَ عند':Predicate, #3: 3	لَزِمَ عُمُومُ
u'لَزِمَ عَوْل':Subject, #1: 1	لَزِمَ عِنْدَ
u'لَزِمَ عِيدَانٌ':Subject, #1: 1	لَزِمَ الْعَوْلُ
u'لَزِمَ غَاصِبٌ':Predicate, #1: 1	لَزِمَ الْعِيدَانُ
u'لَزِمَ غُرْمٌ':Subject, #3: 3	لَزِمَ الْغَاصِبَ
u'لَزِمَ غَرِيمٌ':Predicate, #2: 2	لَزِمَ الْغُرْمُ
u'لَزِمَ غَسْلٌ':Subject, #1: 1	لَزِمَ الْغَرِيمَ
u'لَزِمَ فَرْدٌ':Subject, #1: 1	لَزِمَ غَسْلُهُ
u'لَزِمَ فَرْعٌ':Subject, #1: 1	لَزِمَ فَرْدٌ
u'لَزِمَ فساد':Subject, #1: 1	لَزِمَ فَرْعُهُ
u'لَزِمَ فَسَادٌ':Subject, #1: 1	لَزِمَ فَسَادُ
u'لَزِمَ فِعْلٌ':Subject, #1: 1	لَزِمَ فَسَادُ
u'لَزِمَ فِعْلٌ':Subject, #2: 2	لَزِمَ فِعْلُ
u'لَزِمَ فَوَاتٌ':Subject, #3: 3	لَزِمَ فِعْلُهُ
u'لَزِمَ قَادِرٌ':Predicate, #1: 1	لَزِمَ فَوَاتُ
u'لَزِمَ قَادِرٌ':Subject, #3: 3	لَزِمَ الْقَادِرَ
u'لَزِمَ قَالِعٌ':Predicate, #1: 1	لَزِمَ الْقَادِرُ
u'لَزِمَ قَائِلٌ':Predicate, #1: 1	لَزِمَ الْقَالِعَ
u'لَزِمَ قَائِلٌ':Predicate, #1: 1	أَلْزَمَ الْقَائِلِينَ
u'لَزِمَ قَائِلٌ':Subject, #1: 1	لَزِمَ الْقَائِلَ
u'لَزِمَ قَبْضٌ':Subject, #1: 1	لَزِمَ قَائِلٌ
u'لَزِمَ قَبْضٌ':Subject, #1: 1	لَزِمَ الْقَبْضُ
u'لَزِمَ قَبُولٌ':Subject, #2: 2	لَزِمَ قَبْضُهُ
u'لَزِمَ قَدْحٌ':Subject, #12: 12	لَزِمَ قَبُولُهُ
u'لَزِمَ قَدْرٌ':Predicate, #2: 2	لَزِمَ الْقَدْحُ
u'لَزِمَ قدم':Subject, #1: 1	لَزِمَ الْقَدْرَ
u'لَزِمَ قِدَمٌ':Subject, #2: 2	لَزِمَ قِدَمُ
u'لَزِمَ قِرَاءةٌ':Subject, #2: 2	لَزِمَ قِدَمُ
u'لَزِمَ قسمة':Subject, #1: 1	لَزِمَ قِرَاءَةُ
u'لَزِمَ قِسْمَةٌ':Subject, #1: 1	لَزِمَ قِسْمَةُ
u'لَزِمَ قَصْرٌ':Subject, #1: 1	لَزِمَ قِسْمَةُ
u'لَزِمَ قَضَاءٌ':Subject, #1: 1	لَزِمَ الْقَصْرُ
u'لَزِمَ قلب':Predicate, #1: 1	لَزِمَ الْقَضَاءُ
u'لَزِمَ قَلْبٌ':Predicate, #1: 1	لَزِمَ قَلْبَ
u'لَزِمَ قَلْب':Predicate, #1: 1	لَزِمَ قَلْبَ
u'لَزِمَ قَنَاعَةٌ':Predicate, #1: 1	لَزِمَ قَلْبَ
u'لَزِمَ قَوَد':Subject, #1: 1	لَزِمَ الْقَنَاعَةَ
u'لَزِمَ قول':Subject, #2: 2	لَزِمَ الْقَوَدُ
u'لَزِمَ قَوْلٌ':Subject, #1: 1	لَزِمَ الْقَوْلُ
u'لَزِمَ قول':Subject, #1: 1	لَزِمَ الْقَوْلُ
u'لَزِمَ قَوْلٌ':Subject, #2: 2	لَزِمَ قَوْلُهُ
u'لَزِمَ قِيَاسٌ':Subject, #2: 2	لَزِمَ قَوْلُهُ
u'لَزِمَ قيام':Subject, #1: 1	لَزِمَ قِيَاسُ
u'لَزِمَ قِيَامٌ':Subject, #1: 1	لَزِمَ الْقِيَامُ
u'لَزِمَ قيام':Subject, #1: 1	لَزِمَ الْقِيَامُ
u'لَزِمَ قِيَامٌ':Subject, #1: 1	لَزِمَ قِيَامُ
u'لَزِمَ قيام':Subject, #1: 1	لَزِمَ قِيَامُ
u'لَزِمَ قِيَامٌ':Subject, #1: 1	لَزِمَ قِيَامُهُ
u'لَزِمَ قِيمَةٌ':Subject, #1: 1	لَزِمَ قِيَامُهُ
u'لَزِمَ كَافٌّ':Predicate, #1: 1	لَزِمَ قِيمَةُ
u'لَزِمَ كَافَّةٌ':Predicate, #1: 1	لَزِمَ كَافَّةَ
u'لَزِمَ كَافِرٌ':Predicate, #1: 1	لَزِمَ كَافَّةَ
u'لَزِمَ كَافِرٌ':Subject, #2: 2	لَزِمَ الْكَافِرَ
u'لَزِمَ كَثْرَةٌ':Subject, #1: 1	لَزِمَ الْكَافِرُ
u'لَزِمَ كذب':Subject, #1: 1	لَزِمَ كَثْرَةُ
u'لَزِمَ كَذِبٌ':Subject, #1: 1	لَزِمَ كَذِبُهُ
u'لَزِمَ كِرَاءٌ':Subject, #1: 1	لَزِمَ كَذِبُهُ
u'لَزِمَ كَفَّارٌ':Predicate, #2: 2	لَزِمَ الْكِرَاءُ
u'لَزِمَ كَفَّارٌ':Subject, #1: 1	أَلْزَمَ الْكَفَّارَةَ
u'لَزِمَ كَفَّارَةٌ':Predicate, #1: 1	لَزِمَ الْكَفَّارَةُ
u'لَزِمَ كَفَّارَةٌ':Subject, #1: 1	أَلْزَمَ الْكَفَّارَةَ
u'لَزِمَ كفر':Subject, #1: 1	لَزِمَ الْكَفَّارَةُ
u'لَزِمَ كُفْرٌ':Subject, #2: 2	لَزِمَ الْكُفْرُ
u'لَزِمَ كَفِيلٌ':Predicate, #2: 2	لَزِمَ الْكُفْرُ
u'لَزِمَ كَنِيسَةٌ':Predicate, #18: 18	لَزِمَ الْكَفِيلَ
u'لَزِمَ كَوْنٌ':Subject, #1: 1	لَزِمَ الْكَنِيسَةَ
u'لَزِمَ كَوْنٌ':Subject, #10: 10	لَزِمَ كَوْنُ
u'لَزِمَ لاَزِمٌ':Subject, #10: 10	لَزِمَ كَوْنُهُ
u'لَزِمَ لُزُومٌ':Subject, #1: 1	لَزِمَ اللَّازِمُ
u'لَزِمَ لَفْظٌ':Subject, #1: 1	لَزِمَ لُزُومُ
u'لَزِمَ مَالٌ':Subject, #1: 1	لَزِمَ لَفْظٌ
u'لَزِمَ مَالِكٌ':Predicate, #6: 6	لَزِمَ الْمَالُ
u'لَزِمَ مَالِكٌ':Predicate, #1: 1	لَزِمَ مَالِكَ
u'لَزِمَ مَأْمُورٌ':Predicate, #2: 2	لَزِمَ الْمَالِكَ
u'لَزِمَ مُبَادَلَةٌ':Subject, #3: 3	لَزِمَ الْمَأْمُورَ
u'لَزِمَ مُبَاشِرٌ':Predicate, #1: 1	لَزِمَ مُبَادَلَةُ
u'لَزِمَ مُبْتاع':Predicate, #1: 1	لَزِمَ الْمُبَاشِرَ
u'لَزِمَ مَبِيتٌ':Subject, #1: 1	لَزِمَ الْمُبْتَاعَ
u'لَزِمَ مثل':Subject, #1: 1	لَزِمَ مَبِيتُ
u'لَزِمَ مِثْلٌ':Subject, #1: 1	لَزِمَ الْمِثْلُ
u'لَزِمَ مثل':Subject, #1: 1	لَزِمَ الْمِثْلُ
u'لَزِمَ مِثْلٌ':Subject, #4: 4	لَزِمَ مِثْلُهُ
u'لَزِمَ مَجَازٌ':Subject, #4: 4	لَزِمَ مِثْلُهُ
u'لَزِمَ مَحْذُور':Subject, #1: 1	لَزِمَ الْمَجَازُ
u'لَزِمَ مُحْرِمٌ':Predicate, #1: 1	لَزِمَ الْمَحْذُورُ
u'لَزِمَ مُخَالَفَةٌ':Subject, #1: 1	لَزِمَ الْمُحْرِمَ
u'لَزِمَ مَدْيُونٌ':Predicate, #1: 1	لَزِمَ مُخَالَفَةُ
u'لَزِمَ مُرْتَدٌّ':Predicate, #1: 1	لَزِمَ الْمَدْيُونَ
u'لَزِمَ مَرِيضٌ':Predicate, #1: 1	لَزِمَ الْمُرْتَدَّ
u'لَزِمَ مُسْتَأْجِرٌ':Predicate, #2: 2	لَزِمَ الْمَرِيضَ
u'لَزِمَ مُسْتَدْعِي':Predicate, #5: 5	لَزِمَ الْمُسْتَأْجِرَ
u'لَزِمَ مُسْتَعِيرٌ':Predicate, #1: 1	لَزِمَ الْمُسْتَدْعِيَ
u'لَزِمَ مُسْلِمٌ':Predicate, #1: 1	لَزِمَ الْمُسْتَعِيرَ
u'لَزِمَ مُسَلَّمٌ':Predicate, #1: 1	أَلْزَمَ الْمُسْلِمَ
u'لَزِمَ مُشْتَرِي':Predicate, #1: 1	لَزِمَ الْمُسَلَّمَ
u'لَزِمَ مُصَوِّبٌ':Predicate, #12: 12	لَزِمَ الْمُشْتَرِيَ
u'لَزِمَ مَصِيرٌ':Subject, #1: 1	لَزِمَ الْمُصَوِّبَةَ
u'لَزِمَ مُضَارِبٌ':Predicate, #1: 1	لَزِمَ الْمَصِيرُ
u'لَزِمَ مُطَلَّقٌ':Predicate, #4: 4	لَزِمَ الْمُضَارِبَ
u'لَزِمَ مَطْلُوبٌ':Predicate, #3: 3	لَزِمَ الْمُطَلَّقَةَ
u'لَزِمَ مُقَابَلٌ':Subject, #2: 2	لَزِمَ الْمَطْلُوبَ
u'لَزِمَ مُقَابَلَةٌ':Subject, #1: 1	لَزِمَ مُقَابَلَةُ
u'لَزِمَ مُقْرِضٌ':Predicate, #1: 1	لَزِمَ مُقَابَلَةُ
u'لَزِمَ مَقْصُودٌ':Subject, #1: 1	لَزِمَ الْمُقْرِضَ
u'لَزِمَ مُكْتَرِي':Predicate, #1: 1	لَزِمَ الْمَقْصُودُ
u'لَزِمَ مَكْفُولٌ':Predicate, #2: 2	لَزِمَ الْمُكْتَرِيَ
u'لَزِمَ مُكَلَّفٌ':Predicate, #1: 1	لَزِمَ الْمَكْفُولَ
u'لَزِمَ مُكَلَّفٌ':Predicate, #1: 1	لَزِمَ الْمُكَلَّفَ
u'لَزِمَ مُمَاطِلٌ':Predicate, #1: 1	لَزِمَ الْمُكَلَّفَةَ
u'لَزِمَ مَنْعٌ':Subject, #1: 1	لَزِمَ الْمُمَاطِلَ
u'لَزِمَ مَهْرٌ':Predicate, #1: 1	لَزِمَ مَنْعُهُ
u'لَزِمَ مَهْرٌ':Subject, #1: 1	أَلْزَمَ الْمَهْرَ
u'لَزِمَ مَهْرٌ':Subject, #1: 1	لَزِمَ مَهْرُ
u'لَزِمَ مَوَالِي':Predicate, #5: 5	لَزِمَ الْمَهْرُ
u'لَزِمَ مُؤَجِّرٌ':Predicate, #1: 1	لَزِمَ مَوَالِيَ
u'لَزِمَ مُوَقِّعٌ':Subject, #1: 1	لَزِمَ الْمُؤَجِّرَ
u'لَزِمَ مُوَكِّلٌ':Predicate, #1: 1	لَزِمَ الْمُوَقِّعُ
u'لَزِمَ مُوَكِّلٌ':Subject, #21: 21	لَزِمَ الْمُوَكِّلَ
u'لَزِمَ ناذِر':Predicate, #1: 1	لَزِمَ الْمُوَكِّلُ
u'لَزِمَ نَاسٌ':Predicate, #2: 2	لَزِمَ النَّاذِرَ
u'لَزِمَ نَاسٌ':Predicate, #1: 1	أَلْزَمَ النَّاسَ
u'لَزِمَ نَاظِرٌ':Predicate, #3: 3	لَزِمَ النَّاسَ
u'لَزِمَ نَبِيٌّ':Predicate, #1: 1	لَزِمَ النَّاظِرَ
u'لَزِمَ نَحْوٌ':Subject, #1: 1	لَزِمَ النَّبِيَّ
u'لَزِمَ نذر':Predicate, #1: 1	لَزِمَ نَحْوُ
u'لَزِمَ نَذْرٌ':Predicate, #1: 1	أَلْزَمَ نَذْرَ
u'لَزِمَ نذر':Subject, #1: 1	أَلْزَمَ نَذْرَ
u'لَزِمَ نَذْرٌ':Subject, #1: 1	لَزِمَ النَّذْرُ
u'لَزِمَ نَسَبٌ':Subject, #1: 1	لَزِمَ النَّذْرُ
u'لَزِمَ نِصْفٌ':Subject, #1: 1	لَزِمَ النَّسَبُ
u'لَزِمَ نَفَقَةٌ':Subject, #1: 1	لَزِمَ نِصْفُهُ
u'لَزِمَ نَفْيٌ':Subject, #1: 1	لَزِمَ نَفَقَةُ
u'لَزِمَ نَقْصٌ':Subject, #2: 2	لَزِمَ نَفْيُ
u'لَزِمَ نَقْضٌ':Subject, #1: 1	لَزِمَ النَّقْصُ
u'لَزِمَ نكاح':Subject, #2: 2	لَزِمَ نَقْضُ
u'لَزِمَ نِكَاحٌ':Subject, #1: 1	لَزِمَ النِّكَاحُ
u'لَزِمَ وَارِثٌ':Predicate, #1: 1	لَزِمَ النِّكَاحُ
u'لَزِمَ وَارِثٌ':Subject, #1: 1	لَزِمَ الْوَارِثَ
u'لَزِمَ وَاطِئٌ':Predicate, #1: 1	لَزِمَ وَارِثُهُ
u'لَزِمَ وَالِدٌ':Predicate, #1: 1	لَزِمَ الْوَاطِئَ
u'لَزِمَ وُجُوبٌ':Subject, #1: 1	لَزِمَ الْوَالِدَ
u'لَزِمَ وُجُوبٌ':Subject, #2: 2	لَزِمَ الْوُجُوبُ
u'لَزِمَ وُجُودٌ':Subject, #3: 3	لَزِمَ وُجُوبُ
u'لَزِمَ وَرَثَةٌ':Predicate, #1: 1	لَزِمَ وُجُودُ
u'لَزِمَ وسط':Subject, #4: 4	لَزِمَ الْوَرَثَةَ
u'لَزِمَ وَسَطٌ':Subject, #1: 1	لَزِمَ الْوَسَطُ
u'لَزِمَ وَصْفٌ':Subject, #1: 1	لَزِمَ الْوَسَطُ
u'لَزِمَ وَصِيٌّ':Predicate, #2: 2	لَزِمَ وَصْفُهُ
u'لَزِمَ وَصِيٌّ':Subject, #2: 2	لَزِمَ الْوَصِيَّ
u'لَزِمَ وَفَاءٌ':Subject, #1: 1	لَزِمَ الْوَصِيُّ
u'لَزِمَ وَقْفٌ':Subject, #3: 3	لَزِمَ الْوَفَاءُ
u'لَزِمَ وُقُوعٌ':Predicate, #4: 4	لَزِمَ الْوَقْفُ
u'لَزِمَ وُقُوعٌ':Subject, #1: 1	لَزِمَ وُقُوعَ
u'لَزِمَ وُقُوعٌ':Subject, #2: 2	لَزِمَ وُقُوعُهُ
u'لَزِمَ وَكِيلٌ':Predicate, #7: 7	لَزِمَ وُقُوعُ
u'لَزِمَ وَكِيلٌ':Predicate, #2: 2	أَلْزَمَ الْوَكِيلَ
u'لَزِمَ وَكِيلٌ':Subject, #35: 35	لَزِمَ الْوَكِيلَ
u'لَزِمَ وَلاَءٌ':Subject, #2: 2	لَزِمَ الْوَكِيلُ
u'لَزِمَ ولد':Predicate, #1: 1	لَزِمَ الْوَلَاءُ
u'لَزِمَ وَلَدٌ':Predicate, #2: 2	لَزِمَ الْوَلَدَ
u'لَزِمَ ولد':Subject, #2: 2	لَزِمَ الْوَلَدَ
u'لَزِمَ وَلَدٌ':Subject, #1: 1	لَزِمَ الْوَلَدُ
u'لَزِمَ وَلِيٌّ':Predicate, #1: 1	لَزِمَ الْوَلَدُ
u'لَزِمَ يَقِينٌ':Predicate, #1: 1	لَزِمَ الْوَلِيَّ
u'لُزُومٌ اِبْتِداءٌ':Added, #3: 3	أَلْزَمَ الْيَقِينَ
u'لُزُومٌ إِبْطَالٌ':Added, #1: 1	لُزُومِ ابْتِدَاءِ
u'لُزُومٌ إِبْهَامٌ':Added, #1: 1	لُزُومَ إبْطَالِ
u'لُزُومٌ اِتِّحَادٌ':Added, #1: 1	لُزُومِ إبْهَامِ
u'لُزُومٌ إِتْلاَفٌ':Added, #1: 1	لُزُومِ اتِّحَادِ
u'لُزُومٌ إتْمَامٌ':Added, #1: 1	لُزُومُ إتْلَافِ
u'لُزُومٌ إتْمَامٌ':Added, #1: 1	لُزُومُ الْإِتْمَامِ
u'لُزُومٌ إتْمَامٌ':Added, #2: 2	لُزُومُ إتْمَامِهِ
u'لُزُومٌ إِتْيانٌ':Added, #2: 2	لُزُومِ الْإِتْمَامِ
u'لُزُومٌ إِتْيانٌ':Added, #1: 1	لُزُومَ الْإِتْيَانِ
u'لُزُومٌ إِتْيانٌ':Added, #1: 1	لُزُومُ الْإِتْيَانِ
u'لُزُومٌ إِثْمٌ':Added, #3: 3	لُزُومِ الْإِتْيَانِ
u'لُزُومٌ إِجَابَةٌ':Added, #1: 1	لُزُومُ الْإِثْمِ
u'لُزُومٌ إجَارَةٌ':Added, #2: 2	لُزُومُ الْإِجَابَةِ
u'لُزُومٌ اِجْتِمَاعٌ':Added, #1: 1	لُزُومُ الْإِجَارَةِ
u'لُزُومٌ اجْتِنَابٌ':Added, #1: 1	لُزُومُ اجْتِمَاعِ
u'لُزُومٌ أَجْرٌ':Added, #1: 1	لُزُومِ اجْتِنَابِ
u'لُزُومٌ أَجْرٌ':Added, #1: 1	لُزُومُ الْأَجْرِ
u'لُزُومٌ أُجْرَةٌ':Added, #2: 2	لُزُومَ الْأَجْرِ
u'لُزُومٌ أُجْرَةٌ':Added, #1: 1	لُزُومُ أُجْرَةِ
u'لُزُومٌ أَجَلٌ':Added, #1: 1	لُزُومِ أُجْرَتِهِ
u'لُزُومٌ إِحالَةٌ':Added, #1: 1	لُزُومَ الْأَجَلِ
u'لُزُومٌ أحَدٌ':Added, #1: 1	لُزُومِ إحَالَةِ
u'لُزُومٌ إِحْرَامٌ':Added, #1: 1	لُزُومِ أَحَدِ
u'لُزُومٌ إِحْرَامٌ':Added, #2: 2	لُزُومُ الْإِحْرَامِ
u'لُزُومٌ إِحْرَامٌ':Added, #2: 2	لُزُومِ الْإِحْرَامِ
u'لُزُومٌ أَحْكَامٌ':Added, #2: 2	لُزُومِ الْإِحْرَامَيْنِ
u'لُزُومٌ اِخْتِلاَفٌ':Added, #1: 1	لُزُومِ الْأَحْكَامِ
u'لُزُومٌ اِخْتِيَارٌ':Added, #1: 1	لُزُومِ اخْتِلَافِهِ
u'لُزُومٌ أخْذٌ':Added, #1: 1	لُزُومِ اخْتِيَارِ
u'لُزُومٌ أخْذٌ':Added, #1: 1	لُزُومِ أَخْذِ
u'لُزُومٌ إِخْرَاجٌ':Added, #1: 1	لُزُومِ الْأَخْذِ
u'لُزُومٌ إِخْرَاجٌ':Added, #1: 1	لُزُومُ إخْرَاجِ
u'لُزُومٌ إِخْرَاجٌ':Added, #1: 1	لُزُومِ إخْرَاجِهِ
u'لُزُومٌ أَدَاءٌ':Added, #1: 1	لُزُومِ الْإِخْرَاجِ
u'لُزُومٌ أدَب':Added, #8: 8	لُزُومِ الْأَدَاءِ
u'لُزُومٌ أَرْبَعُ':Added, #1: 1	لُزُومُ الْأَدَبِ
u'لُزُومٌ اِرْتِفَاعٌ':Added, #1: 1	لُزُومِ الْأَرْبَعِ
u'لُزُومٌ إِرْسَالٌ':Added, #1: 1	لُزُومُ ارْتِفَاعِ
u'لُزُومٌ إِرْسَالٌ':Added, #1: 1	لُزُومِ إرْسَالِهِ
u'لُزُومٌ إِسَاءةٌ':Added, #1: 1	لُزُومِ الْإِرْسَالِ
u'لُزُومٌ اِسْتِثْنَاءٌ':Added, #1: 1	لُزُومَ الْإِسَاءَةِ
u'لُزُومٌ اِسْتِحْقَاقٌ':Added, #1: 1	لُزُومُ اسْتِثْنَاءِ
u'لُزُومٌ اِسْتِكْمالٌ':Added, #1: 1	لُزُومِ اسْتِحْقَاقِ
u'لُزُومٌ اِسْتِئْجَارٌ':Added, #1: 1	لُزُومَ اسْتِكْمَالِهِ
u'لُزُومٌ إصابَةٌ':Added, #1: 1	لُزُومُ اسْتِئْجَارِ
u'لُزُومٌ إضْمارٌ':Added, #1: 1	لُزُومِ إصَابَةِ
u'لُزُومٌ إِطْلاقٌ':Added, #1: 1	لُزُومِ إضْمَارِ
u'لُزُومٌ إِعادَةٌ':Added, #1: 1	لُزُومُ إطْلَاقِ
u'لُزُومٌ إِعادَةٌ':Added, #4: 4	لُزُومُ الْإِعَادَةِ
u'لُزُومٌ إِعادَةٌ':Added, #6: 6	لُزُومِ الْإِعَادَةِ
u'لُزُومٌ اِعْتِبارٌ':Added, #7: 7	لُزُومِ إعَادَةِ
u'لُزُومٌ إعْلاَمٌ':Added, #1: 1	لُزُومِ اعْتِبَارِ
u'لُزُومٌ إعْلاَمٌ':Added, #1: 1	لُزُومِ الْإِعْلَامِ
u'لُزُومٌ أَعْمَالٌ':Added, #2: 2	لُزُومِ إعْلَامِ
u'لُزُومٌ أقَلُّ':Added, #1: 1	لُزُومَ الْأَعْمَالِ
u'لُزُومٌ ألْفٌ':Added, #1: 1	لُزُومُ الْأَقَلِّ
u'لُزُومٌ ألف':Added, #1: 1	لُزُومُ أَلْفَيْنِ
u'لُزُومٌ ألْفٌ':Added, #2: 2	لُزُومُ الْأَلْفِ
u'لُزُومٌ أَلْفٌ':Added, #2: 2	لُزُومُ الْأَلْفِ
u'لُزُومٌ ألف':Added, #2: 2	لُزُومُ الْأَلْفِ
u'لُزُومٌ ألْفٌ':Added, #3: 3	لُزُومِ الْأَلْفِ
u'لُزُومٌ أَلْفٌ':Added, #3: 3	لُزُومِ الْأَلْفِ
u'لُزُومٌ الْمَرْأَةُ':Added, #3: 3	لُزُومِ الْأَلْفِ
u'لُزُومٌ اِمْتِثَالٌ':Added, #1: 1	لُزُومِ الْمَرْأَةِ
u'لُزُومٌ اِمْتِناعٌ':Added, #1: 1	لُزُومِ امْتِثَالِهِ
u'لُزُومٌ أَمْرٌ':Added, #1: 1	لُزُومَ امْتِنَاعِ
u'لُزُومٌ إِمْكانٌ':Added, #1: 1	لُزُومُ أَمْرٍ
u'لُزُومٌ اِنْتِظارٌ':Added, #1: 1	لُزُومِ إمْكَانِ
u'لُزُومٌ اِنْتِظارٌ':Added, #1: 1	لُزُومُ انْتِظَارِ
u'لُزُومٌ اِنْتِفاء':Added, #1: 1	لُزُومِ انْتِظَارِهِ
u'لُزُومٌ اِنْتِفاء':Added, #1: 1	لُزُومَ انْتِفَاءِ
u'لُزُومٌ اِنْتِفاء':Added, #2: 2	لُزُومُ انْتِفَاءِ
u'لُزُومٌ اِنْدِراجٌ':Added, #2: 2	لُزُومِ انْتِفَاءِ
u'لُزُومٌ إِنْقَاذٌ':Added, #1: 1	لُزُومِ انْدِرَاجِ
u'لُزُومٌ أَوْلَوِيٌّ':Added, #1: 1	لُزُومِ الْإِنْقَاذِ
u'لُزُومٌ أيَّامٌ':Added, #1: 1	لُزُومِ أَوْلَوِيَّةِ
u'لُزُومٌ أَيَّامٌ':Added, #1: 1	لُزُومِ الْأَيَّامِ
u'لُزُومٌ إيقَاعٌ':Added, #1: 1	لُزُومِ الْأَيَّامِ
u'لُزُومٌ بَائِعٌ':Added, #1: 1	لُزُومِ إيقَاعِ
u'لُزُومٌ بَحْثٌ':Added, #1: 1	لُزُومُ الْبَائِعِ
u'لُزُومٌ بَدَلٌ':Added, #1: 1	لُزُومُ الْبَحْثِ
u'لُزُومٌ بدنة':Added, #1: 1	لُزُومِ الْبَدَلِ
u'لُزُومٌ بدنة':Added, #1: 1	لُزُومِ الْبَدَنَةِ
u'لُزُومٌ بِرٌّ':Added, #1: 1	لُزُومُ بَدَنَةٍ
u'لُزُومٌ بَعيدٌ':Added, #1: 1	لُزُومُ بِرِّ
u'لُزُومٌ بَعيرٌ':Added, #1: 1	لُزُومِ الْبَعِيدِ
u'لُزُومٌ بُقْعَةٌ':Added, #1: 1	لُزُومُ الْبَعِيرِ
u'لُزُومٌ بِنَاءٌ':Added, #1: 1	لُزُومَ بُقْعَةٍ
u'لُزُومٌ بَيَانٌ':Added, #1: 1	لُزُومِ بِنَاءِ
u'لُزُومٌ بَيْتٌ':Added, #2: 2	لُزُومِ الْبَيَانِ
u'لُزُومٌ بَيْتٌ':Added, #2: 2	لُزُومَ الْبَيْتِ
u'لُزُومٌ بَيْعٌ':Added, #2: 2	لُزُومِ الْبَيْتِ
u'لُزُومٌ بَيْعٌ':Added, #11: 11	لُزُومِ الْبَيْعِ
u'لُزُومٌ بَيِّنَةٌ':Added, #4: 4	لُزُومَ الْبَيْعِ
u'لُزُومٌ تَأْجِيلٌ':Added, #1: 1	لُزُومِ الْبَيِّنَةِ
u'لُزُومٌ تَأْخِيرٌ':Added, #2: 2	لُزُومِ تَأْجِيلِ
u'لُزُومٌ تَتَابُعٌ':Added, #1: 1	لُزُومِ تَأْخِيرِ
u'لُزُومٌ تَتَابُعٌ':Added, #1: 1	لُزُومُ التَّتَابُعِ
u'لُزُومٌ تَتَابُعٌ':Added, #1: 1	لُزُومِ التَّتَابُعِ
u'لُزُومٌ تَتِمَّةٌ':Added, #1: 1	لُزُومِ تَتَابُعِ
u'لُزُومٌ تَجْدِيدٌ':Added, #2: 2	لُزُومُ التَّتِمَّةِ
u'لُزُومٌ تَجَرُّدٌ':Added, #1: 1	لُزُومُ التَّجْدِيدِ
u'لُزُومٌ تَحْصِيلٌ':Added, #1: 1	لُزُومُ التَّجَرُّدِ
u'لُزُومٌ تَحَكُّمٌ':Added, #1: 1	لُزُومُ تَحْصِيلِ
u'لُزُومٌ تَحَكُّمٌ':Added, #1: 1	لُزُومِ التَّحَكُّمِ
u'لُزُومٌ تَحَلُّلٌ':Added, #3: 3	لُزُومُ التَّحَكُّمِ
u'لُزُومٌ تَدْبِيرٌ':Added, #1: 1	لُزُومِ تَحَلُّلِهِ
u'لُزُومٌ تَدْبِيرٌ':Added, #1: 1	لُزُومُ التَّدْبِيرِ
u'لُزُومٌ تَزْوِيجٌ':Added, #2: 2	لُزُومِ التَّدْبِيرِ
u'لُزُومٌ تِسْعَةٌ':Added, #1: 1	لُزُومُ تَزْوِيجِ
u'لُزُومٌ تَسَلْسُلٌ':Added, #2: 2	لُزُومُ تِسْعَةٍ
u'لُزُومٌ تَسْلِيمٌ':Added, #1: 1	لُزُومُ التَّسَلْسُلِ
u'لُزُومٌ تَسْلِيمٌ':Added, #1: 1	لُزُومِ التَّسْلِيمِ
u'لُزُومٌ تَصَدُّقٌ':Added, #2: 2	لُزُومِ تَسْلِيمِهِ
u'لُزُومٌ تَصَدُّقٌ':Added, #1: 1	لُزُومَ التَّصَدُّقِ
u'لُزُومٌ تَصَدُّقٌ':Added, #1: 1	لُزُومُ التَّصَدُّقِ
u'لُزُومٌ تَصَوُّرٌ':Added, #4: 4	لُزُومِ التَّصَدُّقِ
u'لُزُومٌ تَعْجِيل':Added, #1: 1	لُزُومِ تَصَوُّرِ
u'لُزُومٌ تَعَدُّدٌ':Added, #1: 1	لُزُومِ تَعْجِيلِ
u'لُزُومٌ تَعْزِير':Added, #1: 1	لُزُومُ التَّعَدُّدِ
u'لُزُومٌ تَعَقُّلٌ':Added, #2: 2	لُزُومِ التَّعْزِيرِ
u'لُزُومٌ تَعَقُّلٌ':Added, #1: 1	لُزُومَ تَعَقُّلِ
u'لُزُومٌ تَعَقُّلٌ':Added, #1: 1	لُزُومُ تَعَقُّلِ
u'لُزُومٌ تَعَلُّمٌ':Added, #1: 1	لُزُومِ تَعَقُّلِهِ
u'لُزُومٌ تَعْيِينٌ':Added, #1: 1	لُزُومُ التَّعَلُّمِ
u'لُزُومٌ تَفاوُت':Added, #3: 3	لُزُومِ التَّعْيِينِ
u'لُزُومٌ تَفْرِيغٌ':Added, #1: 1	لُزُومِ التَّفَاوُتِ
u'لُزُومٌ تَفْصِيلٌ':Added, #1: 1	لُزُومُ تَفْرِيغِ
u'لُزُومٌ تَفْوِيت':Added, #1: 1	لُزُومُ التَّفْصِيلِ
u'لُزُومٌ تَقابُض':Added, #1: 1	لُزُومُ تَفْوِيتِ
u'لُزُومٌ تَقَدُّمٌ':Added, #1: 1	لُزُومُ التَّقَابُضِ
u'لُزُومٌ تَقَدُّمٌ':Added, #1: 1	لُزُومَ تَقَدُّمِ
u'لُزُومٌ تَقْديرٌ':Added, #1: 1	لُزُومِ تَقَدُّمِ
u'لُزُومٌ تَقْديرٌ':Added, #1: 1	لُزُومِ التَّقْدِيرِ
u'لُزُومٌ تَقْريرٌ':Added, #1: 1	لُزُومُ تَقْدِيرِ
u'لُزُومٌ تَقْيِيد':Added, #1: 1	لُزُومِ تَقْرِيرِ
u'لُزُومٌ تَكْرارٌ':Added, #1: 1	لُزُومِ التَّقْيِيدِ
u'لُزُومٌ تَكْرارٌ':Added, #1: 1	لُزُومِ التَّكْرَارِ
u'لُزُومٌ تَكْفيرٌ':Added, #1: 1	لُزُومُ تَكْرَارِ
u'لُزُومٌ تَكْفيرٌ':Added, #1: 1	لُزُومِ تَكْفِيرِهِ
u'لُزُومٌ تَكْميلٌ':Added, #2: 2	لُزُومِ التَّكْفِيرِ
u'لُزُومٌ تَلْبيسٌ':Added, #1: 1	لُزُومِ التَّكْمِيلِ
u'لُزُومٌ تمام':Added, #1: 1	لُزُومُ التَّلْبِيسِ
u'لُزُومٌ تَمامٌ':Added, #1: 1	لُزُومِ تَمَامِ
u'لُزُومٌ تَمَذْهُبٌ':Added, #1: 1	لُزُومِ تَمَامِ
u'لُزُومٌ تَنَاقُضٌ':Added, #4: 4	لُزُومُ التَّمَذْهُبِ
u'لُزُومٌ تَنَاقُضٌ':Added, #1: 1	لُزُومَ التَّنَاقُضِ
u'لُزُومٌ تَنَاقُضٌ':Added, #1: 1	لُزُومُ التَّنَاقُضِ
u'لُزُومٌ تَنَاوُلٌ':Added, #1: 1	لُزُومُ تَنَاقُضِ
u'لُزُومٌ تَنَاوُلٌ':Added, #1: 1	لُزُومُ تَنَاوُلِ
u'لُزُومٌ تَنْجِيزٌ':Added, #1: 1	لُزُومَ تَنَاوُلِهِ
u'لُزُومٌ تَنْفِيذٌ':Added, #1: 1	لُزُومِ التَّنْجِيزِ
u'لُزُومٌ تَنْفِيذٌ':Added, #2: 2	لُزُومِ التَّنْفِيذِ
u'لُزُومٌ تَوَاتُرٌ':Added, #2: 2	لُزُومِ تَنْفِيذِ
u'لُزُومٌ تَوَاتُرٌ':Added, #1: 1	لُزُومَ التَّوَاتُرِ
u'لُزُومٌ تَوَاتُرٌ':Added, #1: 1	لُزُومُ التَّوَاتُرِ
u'لُزُومٌ تَوَارُدٌ':Added, #1: 1	لُزُومَ تَوَاتُرِ
u'لُزُومٌ تَوَقُّفٌ':Added, #1: 1	لُزُومِ تَوَارُدِ
u'لُزُومٌ تَوَقُّفٌ':Added, #1: 1	لُزُومَ التَّوَقُّفِ
u'لُزُومٌ تَوْكِيلٌ':Added, #1: 1	لُزُومِ التَّوَقُّفِ
u'لُزُومٌ ثَالِثٌ':Added, #1: 1	لُزُومَ التَّوْكِيلِ
u'لُزُومٌ ثَغْرٌ':Added, #1: 1	لُزُومِ الثَّالِثِ
u'لُزُومٌ ثَلاثُ':Added, #1: 1	لُزُومُ الثَّغْرِ
u'لُزُومٌ ثَلاثُ':Added, #1: 1	لُزُومَ الثَّلَاثِ
u'لُزُومٌ ثَلاثَةٌ':Added, #6: 6	لُزُومِ الثَّلَاثِ
u'لُزُومٌ ثَمَنٌ':Added, #2: 2	لُزُومِ الثَّلَاثَةِ
u'لُزُومٌ جَبْرٌ':Added, #2: 2	لُزُومِ الثَّمَنِ
u'لُزُومٌ جَزَاءٌ':Added, #1: 1	لُزُومِ الْجَبْرِ
u'لُزُومٌ جَزَاءٌ':Added, #1: 1	لُزُومِ الْجَزَاءَيْنِ
u'لُزُومٌ جَزَاءٌ':Added, #2: 2	لُزُومِ الْجَزَاءِ
u'لُزُومٌ جِزْيَةٌ':Added, #3: 3	لُزُومَ الْجَزَاءِ
u'لُزُومٌ جَمَاعَةٌ':Added, #1: 1	لُزُومُ الْجِزْيَةِ
u'لُزُومٌ جَمَاعَةٌ':Added, #1: 1	لُزُومَ الْجَمَاعَةِ
u'لُزُومٌ جمع':Added, #1: 1	لُزُومِ الْجَمَاعَةِ
u'لُزُومٌ جمع':Added, #1: 1	لُزُومَ الْجَمْعِ
u'لُزُومٌ جَمْعٌ':Added, #1: 1	لُزُومِ الْجَمْعِ
u'لُزُومٌ جَمْعٌ':Added, #1: 1	لُزُومَ الْجَمْعِ
u'لُزُومٌ جمعة':Added, #1: 1	لُزُومِ الْجَمْعِ
u'لُزُومٌ جُمُعَةٌ':Added, #1: 1	لُزُومِ الْجُمُعَةِ
u'لُزُومٌ جَمِيع':Added, #1: 1	لُزُومِ الْجُمُعَةِ
u'لُزُومٌ جَوَازٌ':Added, #1: 1	لُزُومِ الْجَمِيعِ
u'لُزُومٌ جَوَازٌ':Added, #1: 1	لُزُومَ جَوَازِ
u'لُزُومٌ حَبْسٌ':Added, #1: 1	لُزُومِ جَوَازِ
u'لُزُومٌ حَجٌّ':Added, #1: 1	لُزُومَ الْحَبْسِ
u'لُزُومٌ حَجٌّ':Added, #1: 1	لُزُومِ حَجٍّ
u'لُزُومٌ حَجٌّ':Added, #2: 2	لُزُومَ الْحَجِّ
u'لُزُومٌ حُجَّةٌ':Added, #2: 2	لُزُومِ الْحَجِّ
u'لُزُومٌ حُجَّةٌ':Added, #1: 1	لُزُومَ الْحُجَّةِ
u'لُزُومٌ حَدٌّ':Added, #2: 2	لُزُومِ الْحُجَّةِ
u'لُزُومٌ حَدٌّ':Added, #2: 2	لُزُومَ الْحَدِّ
u'لُزُومٌ حَدٌّ':Added, #2: 2	لُزُومُ الْحَدِّ
u'لُزُومٌ حَرَجٌ':Added, #4: 4	لُزُومِ الْحَدِّ
u'لُزُومٌ حَرَجٌ':Added, #1: 1	لُزُومُ الْحَرَجِ
u'لُزُومٌ حُضورٌ':Added, #1: 1	لُزُومِ الْحَرَجِ
u'لُزُومٌ حُضُورٌ':Added, #1: 1	لُزُومِ حُضُورِ
u'لُزُومٌ حَقٌّ':Added, #1: 1	لُزُومِ حُضُورِ
u'لُزُومٌ حَقٌّ':Added, #1: 1	لُزُومَ الْحَقِّ
u'لُزُومٌ حَقٌّ':Added, #1: 1	لُزُومِ الْحَقِّ
u'لُزُومٌ حَقٌّ':Added, #1: 1	لُزُومَ حَقِّ
u'لُزُومٌ حُكْمٌ':Added, #1: 1	لُزُومُ حَقٍّ
u'لُزُومٌ حُكْمٌ':Added, #1: 1	لُزُومِ حُكْمٍ
u'لُزُومٌ حُكْمٌ':Added, #1: 1	لُزُومُ حُكْمِهِ
u'لُزُومٌ حُكْمٌ':Added, #3: 3	لُزُومُ الْحُكْمِ
u'لُزُومٌ حُكْمٌ':Added, #5: 5	لُزُومَ الْحُكْمِ
u'لُزُومٌ حُكُومَةٌ':Added, #9: 9	لُزُومِ الْحُكْمِ
u'لُزُومٌ حَلٌّ':Added, #1: 1	لُزُومُ الْحُكُومَةِ
u'لُزُومٌ حِلٌّ':Added, #1: 1	لُزُومِ حَلِّ
u'لُزُومٌ خُصُومَةٌ':Added, #1: 1	لُزُومِ حِلِّ
u'لُزُومٌ خَمْسَةٌ':Added, #1: 1	لُزُومَ الْخُصُومَةِ
u'لُزُومٌ خَمْسَةٌ':Added, #1: 1	لُزُومِ الْخَمْسَةِ
u'لُزُومٌ دَابَّةٌ':Added, #2: 2	لُزُومُ خَمْسَةِ
u'لُزُومٌ دِرْهَمٌ':Added, #1: 1	لُزُومَ الدَّابَّةِ
u'لُزُومٌ دِرْهَم':Added, #1: 1	لُزُومُ الدِّرْهَمَيْنِ
u'لُزُومٌ دِرْهَمٌ':Added, #1: 1	لُزُومُ الدِّرْهَمَيْنِ
u'لُزُومٌ دِرْهَمٌ':Added, #1: 1	لُزُومَ دِرْهَمٍ
u'لُزُومٌ دِرْهَم':Added, #1: 1	لُزُومِ دِرْهَمٍ
u'لُزُومٌ دِرْهَم':Added, #1: 1	لُزُومَ دِرْهَمٍ
u'لُزُومٌ دَعْوَةٌ':Added, #1: 1	لُزُومِ دِرْهَمٍ
u'لُزُومٌ دفع':Added, #1: 1	لُزُومِ دَعْوَتِهِ
u'لُزُومٌ دَفْعٌ':Added, #1: 1	لُزُومَ الدَّفْعِ
u'لُزُومٌ دفع':Added, #1: 1	لُزُومَ الدَّفْعِ
u'لُزُومٌ دَفْعٌ':Added, #1: 1	لُزُومَ دَفْعِ
u'لُزُومٌ دفع':Added, #1: 1	لُزُومَ دَفْعِ
u'لُزُومٌ دَفْعٌ':Added, #3: 3	لُزُومِ الدَّفْعِ
u'لُزُومٌ دَلالَةٌ':Added, #3: 3	لُزُومِ الدَّفْعِ
u'لُزُومٌ دَمٌ':Added, #1: 1	لُزُومُ الدَّلَالَةِ
u'لُزُومٌ دَمٌ':Added, #1: 1	لُزُومَ الدَّمَيْنِ
u'لُزُومٌ دَمٌ':Added, #1: 1	لُزُومِ الدَّمَيْنِ
u'لُزُومٌ دَمٌ':Added, #1: 1	لُزُومَ دَمٍ
u'لُزُومٌ دَمٌ':Added, #1: 1	لُزُومَ دَمِ
u'لُزُومٌ دَمٌ':Added, #1: 1	لُزُومُ دَمٍ
u'لُزُومٌ دَمٌ':Added, #1: 1	لُزُومِ دَمٍ
u'لُزُومٌ دَمٌ':Added, #1: 1	لُزُومِ دَمِ
u'لُزُومٌ دَمٌ':Added, #1: 1	لُزُومِ دَمَيْنِ
u'لُزُومٌ دَمٌ':Added, #21: 21	لُزُومِ الدَّمِ
u'لُزُومٌ دَمٌ':Added, #2: 2	لُزُومُ دَمَيْنِ
u'لُزُومٌ دَمٌ':Added, #5: 5	لُزُومَ الدَّمِ
u'لُزُومٌ دَوْرٌ':Added, #9: 9	لُزُومُ الدَّمِ
u'لُزُومٌ دَوْرٌ':Added, #1: 1	لُزُومَ الدَّوْرِ
u'لُزُومٌ دِيَةٌ':Added, #4: 4	لُزُومِ الدَّوْرِ
u'لُزُومٌ دِيَةٌ':Added, #2: 2	لُزُومَ الدِّيَةِ
u'لُزُومٌ دِيَةٌ':Added, #2: 2	لُزُومِ الدِّيَةِ
u'لُزُومٌ دَيْنٌ':Added, #4: 4	لُزُومُ الدِّيَةِ
u'لُزُومٌ دَيْنٌ':Added, #2: 2	لُزُومُ الدَّيْنِ
u'لُزُومٌ ذكر':Added, #2: 2	لُزُومِ الدَّيْنِ
u'لُزُومٌ ذِكْرٌ':Added, #1: 1	لُزُومِ ذِكْرِ
u'لُزُومٌ رَبُّ':Added, #1: 1	لُزُومِ ذِكْرِ
u'لُزُومٌ رِبْحٌ':Added, #3: 3	لُزُومِ رَبِّ
u'لُزُومٌ رُجُوعٌ':Added, #1: 1	لُزُومِ رِبْحِ
u'لُزُومٌ رَدٌّ':Added, #1: 1	لُزُومِ الرُّجُوعِ
u'لُزُومٌ رَدٌّ':Added, #1: 1	لُزُومَ الرَّدِّ
u'لُزُومٌ رَدٌّ':Added, #1: 1	لُزُومِ الرَّدِّ
u'لُزُومٌ رَدٌّ':Added, #1: 1	لُزُومِ رَدِّ
u'لُزُومٌ رَدٌّ':Added, #1: 1	لُزُومِ رَدِّهِ
u'لُزُومٌ رضاع':Added, #2: 2	لُزُومُ رَدِّ
u'لُزُومٌ رَفْضٌ':Added, #1: 1	لُزُومُ الرَّضَاعِ
u'لُزُومٌ رَمْيٌ':Added, #2: 2	لُزُومِ الرَّفْضِ
u'لُزُومٌ رَهْنٌ':Added, #1: 1	لُزُومِ الرَّمْيِ
u'لُزُومٌ رَهْنٌ':Added, #1: 1	لُزُومَ الرَّهْنِ
u'لُزُومٌ رَهْنٌ':Added, #2: 2	لُزُومُ الرَّهْنِ
u'لُزُومٌ زائِدٌ':Added, #8: 8	لُزُومِ الرَّهْنِ
u'لُزُومٌ زائِدٌ':Added, #1: 1	لُزُومَ الزَّائِدِ
u'لُزُومٌ زَكاةٌ':Added, #1: 1	لُزُومِ الزَّائِدِ
u'لُزُومٌ زَكاةٌ':Added, #1: 1	لُزُومُ الزَّكَاةِ
u'لُزُومٌ زِيادَةٌ':Added, #1: 1	لُزُومِ الزَّكَاةِ
u'لُزُومٌ زِيادَةٌ':Added, #1: 1	لُزُومِ زِيَادَةِ
u'لُزُومٌ زِيادَةٌ':Added, #2: 2	لُزُومِ الزِّيَادَةِ
u'لُزُومٌ سَائِبٌ':Added, #4: 4	لُزُومُ الزِّيَادَةِ
u'لُزُومٌ سَائِرٌ':Added, #1: 1	لُزُومُ السَّائِبَةِ
u'لُزُومٌ سَبْعٌ':Added, #1: 1	لُزُومِ سَائِرِ
u'لُزُومٌ سَبْعَةٌ':Added, #1: 1	لُزُومِ السَّبْعِ
u'لُزُومٌ سِتٌّ':Added, #1: 1	لُزُومُ سَبْعَةٍ
u'لُزُومٌ سَتْرٌ':Added, #1: 1	لُزُومِ السِّتَّةِ
u'لُزُومٌ سُجُودٌ':Added, #1: 1	لُزُومُ سَتْرِ
u'لُزُومٌ سَدٌّ':Added, #1: 1	لُزُومِ السُّجُودِ
u'لُزُومٌ سَفَرٌ':Added, #1: 1	لُزُومَ سَدِّ
u'لُزُومٌ سَيِّدٌ':Added, #1: 1	لُزُومِ السَّفَرِ
u'لُزُومٌ شَاةٌ':Added, #1: 1	لُزُومَ السَّيِّدِ
u'لُزُومٌ شَاةٌ':Added, #1: 1	لُزُومُ الشَّاةِ
u'لُزُومٌ شَدٌّ':Added, #1: 1	لُزُومُ شَاةٍ
u'لُزُومٌ شِرَاءٌ':Added, #1: 1	لُزُومَ الشَّدِّ
u'لُزُومٌ شِرَاءٌ':Added, #1: 1	لُزُومِ الشِّرَاءِ
u'لُزُومٌ شَرْطٌ':Added, #1: 1	لُزُومِ شِرَاءِ
u'لُزُومٌ شُعُورٌ':Added, #1: 1	لُزُومَ شَرْطٍ
u'لُزُومٌ شَفْعٌ':Added, #1: 1	لُزُومِ الشُّعُورِ
u'لُزُومٌ شَهَادَةٌ':Added, #2: 2	لُزُومِ الشَّفْعِ
u'لُزُومٌ شَهْرٌ':Added, #1: 1	لُزُومَ الشَّهَادَةِ
u'لُزُومٌ شَيْءٌ':Added, #1: 1	لُزُومُ الشَّهْرِ
u'لُزُومٌ شَيْءٌ':Added, #2: 2	لُزُومُ الشَّيْءِ
u'لُزُومٌ شَيْءٌ':Added, #2: 2	لُزُومُ شَيْءٍ
u'لُزُومٌ صَاحِبٌ':Added, #3: 3	لُزُومِ شَيْءٍ
u'لُزُومٌ صِحَّةٌ':Added, #1: 1	لُزُومُ صَاحِبِهِ
u'لُزُومٌ صِحَّةٌ':Added, #1: 1	لُزُومَ صِحَّةِ
u'لُزُومٌ صداق':Added, #1: 1	لُزُومِ صِحَّةِ
u'لُزُومٌ صَدَاقٌ':Added, #1: 1	لُزُومِ الصَّدَاقِ
u'لُزُومٌ صداق':Added, #1: 1	لُزُومِ الصَّدَاقِ
u'لُزُومٌ صداق':Added, #1: 1	لُزُومَ صَدَاقِ
u'لُزُومٌ صداق':Added, #1: 1	لُزُومِ صَدَاقٍ
u'لُزُومٌ صَدَاقٌ':Added, #1: 1	لُزُومِ صَدَاقِ
u'لُزُومٌ صَدَاقٌ':Added, #1: 1	لُزُومَ صَدَاقِ
u'لُزُومٌ صَدَاقٌ':Added, #1: 1	لُزُومِ صَدَاقٍ
u'لُزُومٌ صدق':Added, #1: 1	لُزُومِ صَدَاقِ
u'لُزُومٌ صِدْقٌ':Added, #1: 1	لُزُومُ صِدْقِ
u'لُزُومٌ صدقة':Added, #1: 1	لُزُومُ صِدْقِ
u'لُزُومٌ صَدَقَةٌ':Added, #1: 1	لُزُومَ الصَّدَقَةِ
u'لُزُومٌ صدقة':Added, #1: 1	لُزُومَ الصَّدَقَةِ
u'لُزُومٌ صَدَقَةٌ':Added, #3: 3	لُزُومِ الصَّدَقَةِ
u'لُزُومٌ صَلاَةٌ':Added, #3: 3	لُزُومِ الصَّدَقَةِ
u'لُزُومٌ صَلاَةٌ':Added, #1: 1	لُزُومِ الصَّلَاةِ
u'لُزُومٌ صنعة':Added, #1: 1	لُزُومَ صَلَاةٍ
u'لُزُومٌ صَنْعَةٌ':Added, #2: 2	لُزُومِ الصَّنْعَةِ
u'لُزُومٌ صَوَامِعُ':Added, #2: 2	لُزُومِ الصَّنْعَةِ
u'لُزُومٌ صَوْمٌ':Added, #1: 1	لُزُومُ الصَّوَامِعِ
u'لُزُومٌ صَوْمٌ':Added, #2: 2	لُزُومُ الصَّوْمِ
u'لُزُومٌ صَوْنٌ':Added, #2: 2	لُزُومِ الصَّوْمِ
u'لُزُومٌ صِيَامٌ':Added, #1: 1	لُزُومُ صَوْنِ
u'لُزُومٌ صَيْرُورَة':Added, #1: 1	لُزُومِ الصِّيَامِ
u'لُزُومٌ صَيْرُورَة':Added, #1: 1	لُزُومُ صَيْرُورَةِ
u'لُزُومٌ ضَرَرٌ':Added, #1: 1	لُزُومِ صَيْرُورَةِ
u'لُزُومٌ ضَرَرٌ':Added, #1: 1	لُزُومِ الضَّرَرِ
u'لُزُومٌ ضَمَانٌ':Added, #1: 1	لُزُومُ ضَرَرٍ
u'لُزُومٌ ضَمَانٌ':Added, #1: 1	لُزُومِ الضَّمَانِ
u'لُزُومٌ ضَمَانٌ':Added, #1: 1	لُزُومِ ضَمَانِ
u'لُزُومٌ ضَمَانٌ':Added, #1: 1	لُزُومِ ضَمَانِهِ
u'لُزُومٌ طَاعَةٌ':Added, #3: 3	لُزُومُ الضَّمَانِ
u'لُزُومٌ طَاعَةٌ':Added, #1: 1	لُزُومِ الطَّاعَةِ
u'لُزُومٌ طَرِيقٌ':Added, #1: 1	لُزُومِ طَاعَةٍ
u'لُزُومٌ طَرِيقَةٌ':Added, #1: 1	لُزُومَ الطَّرِيقِ
u'لُزُومٌ طَلاَقٌ':Added, #1: 1	لُزُومُ طَرِيقَةٍ
u'لُزُومٌ طَلاَقٌ':Added, #1: 1	لُزُومُ الطَّلَاقِ
u'لُزُومٌ طَلاَقٌ':Added, #2: 2	لُزُومَ الطَّلَاقِ
u'لُزُومٌ طَلاَقٌ':Added, #2: 2	لُزُومِ الطَّلَاقِ
u'لُزُومٌ طلب':Added, #2: 2	لُزُومُ طَلَاقِ
u'لُزُومٌ طَلَبٌ':Added, #1: 1	لُزُومُ الطَّلَبِ
u'لُزُومٌ طلب':Added, #1: 1	لُزُومُ الطَّلَبِ
u'لُزُومٌ طَلَبٌ':Added, #1: 1	لُزُومِ طَلَبِ
u'لُزُومٌ طلب':Added, #1: 1	لُزُومِ طَلَبِ
u'لُزُومٌ طَلَبٌ':Added, #2: 2	لُزُومِ الطَّلَبِ
u'لُزُومٌ طِينٌ':Added, #2: 2	لُزُومِ الطَّلَبِ
u'لُزُومٌ ظَرْفٌ':Added, #2: 2	لُزُومِ طِينٍ
u'لُزُومٌ عارِيَّةٌ':Added, #1: 1	لُزُومِ ظَرْفِهِ
u'لُزُومٌ عارِيَّةٌ':Added, #1: 1	لُزُومُ الْعَارِيَّةِ
u'لُزُومٌ عِبَادَةٌ':Added, #1: 1	لُزُومِ الْعَارِيَّةِ
u'لُزُومٌ عَبَثٌ':Added, #2: 2	لُزُومِ الْعِبَادَةِ
u'لُزُومٌ عتق':Added, #1: 1	لُزُومِ الْعَبَثِ
u'لُزُومٌ عتق':Added, #1: 1	لُزُومُ الْعِتْقِ
u'لُزُومٌ عِتْقٌ':Added, #1: 1	لُزُومِ الْعِتْقِ
u'لُزُومٌ عِتْقٌ':Added, #1: 1	لُزُومُ الْعِتْقِ
u'لُزُومٌ عتق':Added, #1: 1	لُزُومِ الْعِتْقِ
u'لُزُومٌ عِتْقٌ':Added, #1: 1	لُزُومُ عِتْقِ
u'لُزُومٌ عِدَّةٌ':Added, #1: 1	لُزُومُ عِتْقِ
u'لُزُومٌ عِدَّةٌ':Added, #1: 1	لُزُومِ الْعِدَّةِ
u'لُزُومٌ عَدَدٌ':Added, #2: 2	لُزُومُ الْعِدَّةِ
u'لُزُومٌ عَدَمٌ':Added, #1: 1	لُزُومِ عَدَدِ
u'لُزُومٌ عَدَمٌ':Added, #1: 1	لُزُومَ عَدَمِ
u'لُزُومٌ عَدَمٌ':Added, #2: 2	لُزُومِ عَدَمِ
u'لُزُومٌ عُرُوضٌ':Added, #3: 3	لُزُومُ عَدَمِ
u'لُزُومٌ عِصْيَانٌ':Added, #1: 1	لُزُومِ عُرُوضِ
u'لُزُومٌ عَقْدٌ':Added, #1: 1	لُزُومِ عِصْيَانٍ
u'لُزُومٌ عَقْدٌ':Added, #20: 20	لُزُومَ الْعَقْدِ
u'لُزُومٌ عَقْدٌ':Added, #24: 24	لُزُومِ الْعَقْدِ
u'لُزُومٌ عَقْدٌ':Added, #2: 2	لُزُومِ عَقْدِ
u'لُزُومٌ عُقُوبَةٌ':Added, #8: 8	لُزُومُ الْعَقْدِ
u'لُزُومٌ عُقُودٌ':Added, #1: 1	لُزُومُ الْعُقُوبَةِ
u'لُزُومٌ عَكْسٌ':Added, #1: 1	لُزُومِ الْعُقُودِ
u'لُزُومٌ علم':Added, #1: 1	لُزُومُ الْعَكْسِ
u'لُزُومٌ عِلْمٌ':Added, #1: 1	لُزُومِ الْعِلْمِ
u'لُزُومٌ عَمَلٌ':Added, #1: 1	لُزُومِ الْعِلْمِ
u'لُزُومٌ عَمَلٌ':Added, #1: 1	لُزُومُ الْعَمَلِ
u'لُزُومٌ عَمَلٌ':Added, #3: 3	لُزُومَ الْعَمَلِ
u'لُزُومٌ عُهْدَةٌ':Added, #4: 4	لُزُومِ الْعَمَلِ
u'لُزُومٌ عُهْدَةٌ':Added, #1: 1	لُزُومُ الْعُهْدَةِ
u'لُزُومٌ عَوْدٌ':Added, #5: 5	لُزُومِ الْعُهْدَةِ
u'لُزُومٌ عَوْدٌ':Added, #1: 1	لُزُومِ الْعَوْدِ
u'لُزُومٌ عَوْدٌ':Added, #1: 1	لُزُومَ عَوْدِهِ
u'لُزُومٌ عِوَضٌ':Added, #2: 2	لُزُومُ الْعَوْدِ
u'لُزُومٌ غَرَامَةٌ':Added, #2: 2	لُزُومِ الْعِوَضِ
u'لُزُومٌ غُرَّةٌ':Added, #1: 1	لُزُومِ الْغَرَامَةِ
u'لُزُومٌ غَسْلٌ':Added, #1: 1	لُزُومِ الْغُرَّةِ
u'لُزُومٌ غَسْلٌ':Added, #1: 1	لُزُومُ غَسْلِ
u'لُزُومٌ غَسْلٌ':Added, #1: 1	لُزُومِ غَسْلِ
u'لُزُومٌ غُسْلٌ':Added, #1: 1	لُزُومِ غَسْلِهِ
u'لُزُومٌ غير':Added, #3: 3	لُزُومِ الْغُسْلِ
u'لُزُومٌ غير':Added, #1: 1	لُزُومَ غَيْرِ
u'لُزُومٌ غَيْرٌ':Added, #1: 1	لُزُومِ غَيْرِ
u'لُزُومٌ غَيْرٌ':Added, #1: 1	لُزُومَ غَيْرِ
u'لُزُومٌ فِدَاءٌ':Added, #1: 1	لُزُومِ غَيْرِ
u'لُزُومٌ فِدْيَةٌ':Added, #1: 1	لُزُومِ الْفِدَاءِ
u'لُزُومٌ فِدْيَةٌ':Added, #1: 1	لُزُومُ الْفِدْيَةِ
u'لُزُومٌ فَرْضٌ':Added, #6: 6	لُزُومِ الْفِدْيَةِ
u'لُزُومٌ فَرْضٌ':Added, #1: 1	لُزُومَ الْفَرْضِ
u'لُزُومٌ فَرْعِيٌّ':Added, #1: 1	لُزُومُ فَرْضِ
u'لُزُومٌ فَرْعِيٌّ':Added, #1: 1	لُزُومِ فَرْعِيَّةِ
u'لُزُومٌ فساد':Added, #1: 1	لُزُومِ فَرْعِيَّتِهِ
u'لُزُومٌ فَسَادٌ':Added, #1: 1	لُزُومُ الْفَسَادِ
u'لُزُومٌ فساد':Added, #1: 1	لُزُومُ الْفَسَادِ
u'لُزُومٌ فساد':Added, #1: 1	لُزُومَ فَسَادِ
u'لُزُومٌ فساد':Added, #1: 1	لُزُومِ فَسَادٍ
u'لُزُومٌ فَسَادٌ':Added, #1: 1	لُزُومِ فَسَادِ
u'لُزُومٌ فَسَادٌ':Added, #1: 1	لُزُومَ فَسَادِ
u'لُزُومٌ فَسَادٌ':Added, #1: 1	لُزُومِ فَسَادٍ
u'لُزُومٌ فَسْخٌ':Added, #1: 1	لُزُومِ فَسَادِ
u'لُزُومٌ فَصَاحَةٌ':Added, #1: 1	لُزُومِ فَسْخِ
u'لُزُومٌ فَهْمٌ':Added, #1: 1	لُزُومَ الْفَصَاحَةِ
u'لُزُومٌ فَوْر':Added, #1: 1	لُزُومَ فَهْمِ
u'لُزُومٌ فَوْر':Added, #1: 1	لُزُومِ الْفَوْرِيَّةِ
u'لُزُومٌ فَوْرَة':Added, #1: 1	لُزُومِ فَوْرِيَّةِ
u'لُزُومٌ فَوْرَة':Added, #1: 1	لُزُومِ الْفَوْرِيَّةِ
u'لُزُومٌ فَوْرِيّ':Added, #1: 1	لُزُومِ فَوْرِيَّةِ
u'لُزُومٌ فَوْرِيّ':Added, #1: 1	لُزُومِ الْفَوْرِيَّةِ
u'لُزُومٌ قَبُولٌ':Added, #1: 1	لُزُومِ فَوْرِيَّةِ
u'لُزُومٌ قَبُولٌ':Added, #1: 1	لُزُومُ الْقَبُولِ
u'لُزُومٌ قَبُولٌ':Added, #1: 1	لُزُومِ قَبُولِ
u'لُزُومٌ قَبُولٌ':Added, #3: 3	لُزُومُ قَبُولِ
u'لُزُومٌ قدم':Added, #4: 4	لُزُومِ الْقَبُولِ
u'لُزُومٌ قِدَمٌ':Added, #1: 1	لُزُومُ قِدَمِ
u'لُزُومٌ قِرَاءةٌ':Added, #1: 1	لُزُومُ قِدَمِ
u'لُزُومٌ قِسْطٌ':Added, #1: 1	لُزُومُ قِرَاءَةِ
u'لُزُومٌ قَضَاءٌ':Added, #1: 1	لُزُومِ الْقِسْطِ
u'لُزُومٌ قَضَاءٌ':Added, #12: 12	لُزُومِ الْقَضَاءِ
u'لُزُومٌ قَضَاءٌ':Added, #1: 1	لُزُومَ الْقَضَاءِ
u'لُزُومٌ قَضَاءٌ':Added, #1: 1	لُزُومِ قَضَاءٍ
u'لُزُومٌ قَضَاءٌ':Added, #4: 4	لُزُومُ قَضَاءِ
u'لُزُومٌ قَضَاءٌ':Added, #5: 5	لُزُومِ قَضَاءِ
u'لُزُومٌ قَطْعٌ':Added, #6: 6	لُزُومُ الْقَضَاءِ
u'لُزُومٌ قَطْعٌ':Added, #1: 1	لُزُومَ الْقَطْعِ
u'لُزُومٌ قَطْعٌ':Added, #1: 1	لُزُومِ الْقَطْعِ
u'لُزُومٌ قَلاَئِدُ':Added, #1: 1	لُزُومُ قَطْعِهِ
u'لُزُومٌ قَوَد':Added, #1: 1	لُزُومَ الْقَلَائِدِ
u'لُزُومٌ قَوَد':Added, #1: 1	لُزُومَ الْقَوَدِ
u'لُزُومٌ قِيَاسٌ':Added, #1: 1	لُزُومِ الْقَوَدِ
u'لُزُومٌ قِيمَةٌ':Added, #2: 2	لُزُومَ الْقِيَاسِ
u'لُزُومٌ قِيمَةٌ':Added, #1: 1	لُزُومُ الْقِيمَةِ
u'لُزُومٌ قِيمَةٌ':Added, #1: 1	لُزُومَ قِيمَةِ
u'لُزُومٌ قِيمَةٌ':Added, #1: 1	لُزُومِ قِيمَةِ
u'لُزُومٌ قِيمَةٌ':Added, #2: 2	لُزُومَ الْقِيمَةِ
u'لُزُومٌ قِيمَةٌ':Added, #2: 2	لُزُومِ قِيمَتِهِ
u'لُزُومٌ قِيمَةٌ':Added, #3: 3	لُزُومُ قِيمَةِ
u'لُزُومٌ كِتَابَةٌ':Added, #4: 4	لُزُومِ الْقِيمَةِ
u'لُزُومٌ كذب':Added, #3: 3	لُزُومِ الْكِتَابَةِ
u'لُزُومٌ كذب':Added, #1: 1	لُزُومَ الْكَذِبِ
u'لُزُومٌ كَذِبٌ':Added, #1: 1	لُزُومِ الْكَذِبِ
u'لُزُومٌ كَذِبٌ':Added, #1: 1	لُزُومَ الْكَذِبِ
u'لُزُومٌ كذب':Added, #1: 1	لُزُومِ الْكَذِبِ
u'لُزُومٌ كَذِبٌ':Added, #3: 3	لُزُومُ الْكَذِبِ
u'لُزُومٌ كِرَاءٌ':Added, #3: 3	لُزُومُ الْكَذِبِ
u'لُزُومٌ كِرَاءٌ':Added, #1: 1	لُزُومُ الْكِرَاءِ
u'لُزُومٌ كَسْرٌ':Added, #1: 1	لُزُومِ كِرَاءِ
u'لُزُومٌ كَفَّارٌ':Added, #1: 1	لُزُومِ الْكَسْرِ
u'لُزُومٌ كَفَّارٌ':Added, #10: 10	لُزُومُ الْكَفَّارَةِ
u'لُزُومٌ كَفَّارٌ':Added, #12: 12	لُزُومِ الْكَفَّارَةِ
u'لُزُومٌ كَفَّارٌ':Added, #1: 1	لُزُومُ كَفَّارَةِ
u'لُزُومٌ كَفَّارٌ':Added, #3: 3	لُزُومِ كَفَّارَةِ
u'لُزُومٌ كَفَّارَةٌ':Added, #4: 4	لُزُومَ الْكَفَّارَةِ
u'لُزُومٌ كَفَّارَةٌ':Added, #10: 10	لُزُومُ الْكَفَّارَةِ
u'لُزُومٌ كَفَّارَةٌ':Added, #12: 12	لُزُومِ الْكَفَّارَةِ
u'لُزُومٌ كَفَّارَةٌ':Added, #1: 1	لُزُومُ كَفَّارَةِ
u'لُزُومٌ كَفَّارَةٌ':Added, #3: 3	لُزُومِ كَفَّارَةِ
u'لُزُومٌ كَفَالَةٌ':Added, #4: 4	لُزُومَ الْكَفَّارَةِ
u'لُزُومٌ كفر':Added, #1: 1	لُزُومَ الْكَفَالَةِ
u'لُزُومٌ كُفْرٌ':Added, #1: 1	لُزُومِ الْكُفْرِ
u'لُزُومٌ كفر':Added, #1: 1	لُزُومِ الْكُفْرِ
u'لُزُومٌ كُفْرٌ':Added, #2: 2	لُزُومُ الْكُفْرِ
u'لُزُومٌ كُلِّيٌّ':Added, #2: 2	لُزُومُ الْكُفْرِ
u'لُزُومٌ كُلِّيَّةٌ':Added, #1: 1	لُزُومِ الْكُلِّيَّةِ
u'لُزُومٌ كَمَالٌ':Added, #1: 1	لُزُومِ الْكُلِّيَّةِ
u'لُزُومٌ كَوْنٌ':Added, #1: 1	لُزُومِ كَمَالِ
u'لُزُومٌ كَوْنٌ':Added, #1: 1	لُزُومِ كَوْنِهِ
u'لُزُومٌ كَوْنٌ':Added, #2: 2	لُزُومِ كَوْنِ
u'لُزُومٌ لاَزِمٌ':Added, #3: 3	لُزُومُ كَوْنِ
u'لُزُومٌ لاَزِمٌ':Added, #1: 1	لُزُومَ اللَّازِمِ
u'لُزُومٌ لَفْظِيٌّ':Added, #1: 1	لُزُومُ اللَّازِمِ
u'لُزُومٌ مَالٌ':Added, #1: 1	لُزُومُ اللَّفْظِيِّ
u'لُزُومٌ مَالٌ':Added, #13: 13	لُزُومِ الْمَالِ
u'لُزُومٌ مَالٌ':Added, #1: 1	لُزُومَ الْمَالِ
u'لُزُومٌ مَبِيتٌ':Added, #1: 1	لُزُومِ مَالٍ
u'لُزُومٌ مَبِيعٌ':Added, #1: 1	لُزُومِ الْمَبِيتِ
u'لُزُومٌ مُتَابَعٌ':Added, #1: 1	لُزُومُ الْمَبِيعِ
u'لُزُومٌ مُتَابَعَةٌ':Added, #1: 1	لُزُومِ مُتَابَعَةِ
u'لُزُومٌ مُتَنَاقِضٌ':Added, #1: 1	لُزُومِ مُتَابَعَةِ
u'لُزُومٌ مثل':Added, #1: 1	لُزُومَ الْمُتَنَاقِضَيْنِ
u'لُزُومٌ مِثْلٌ':Added, #2: 2	لُزُومُ مِثْلِهِ
u'لُزُومٌ مَجَازِيٌّ':Added, #2: 2	لُزُومُ مِثْلِهِ
u'لُزُومٌ مَحْذُور':Added, #1: 1	لُزُومِ الْمَجَازِيِّ
u'لُزُومٌ مُرُورٌ':Added, #1: 1	لُزُومِ الْمَحْذُورِ
u'لُزُومٌ مُسَاوَاةٌ':Added, #1: 1	لُزُومِ الْمُرُورِ
u'لُزُومٌ مُسْتَبْعَدٌ':Added, #1: 1	لُزُومِ مُسَاوَاةِ
u'لُزُومٌ مُسْتَنِدٌ':Added, #1: 1	لُزُومِ الْمُسْتَبْعَدِ
u'لُزُومٌ مَسْجِدٌ':Added, #1: 1	لُزُومِ الْمُسْتَنِدِ
u'لُزُومٌ مَسْجِدٌ':Added, #1: 1	لُزُومُ الْمَسْجِدِ
u'لُزُومٌ مَسْحٌ':Added, #3: 3	لُزُومُ مَسْجِدٍ
u'لُزُومٌ مَسْكَنٌ':Added, #1: 1	لُزُومَ مَسْحِ
u'لُزُومٌ مُسْلِمٌ':Added, #1: 1	لُزُومُ مَسْكَنِ
u'لُزُومٌ مَشْيٌ':Added, #1: 1	لُزُومِ مُسْلِمٍ
u'لُزُومٌ مَشْيٌ':Added, #1: 1	لُزُومَ الْمَشْيِ
u'لُزُومٌ مُضَارَبَةٌ':Added, #1: 1	لُزُومِ الْمَشْيِ
u'لُزُومٌ مُطَالَبٌ':Added, #1: 1	لُزُومَ الْمُضَارَبَةِ
u'لُزُومٌ مُطَالَبَةٌ':Added, #1: 1	لُزُومَ الْمُطَالَبَةِ
u'لُزُومٌ مُطْلَقٌ':Added, #1: 1	لُزُومَ الْمُطَالَبَةِ
u'لُزُومٌ مَطْلُوبٌ':Added, #1: 1	لُزُومِ الْمُطْلَقِ
u'لُزُومٌ مَعْلُولٌ':Added, #2: 2	لُزُومِ الْمَطْلُوبِ
u'لُزُومٌ مَفْسَدَةٌ':Added, #1: 1	لُزُومُ الْمَعْلُولِ
u'لُزُومٌ مُقَدَّمٌ':Added, #1: 1	لُزُومَ الْمَفْسَدَةِ
u'لُزُومٌ مَلْزُوم':Added, #1: 1	لُزُومِ الْمُقَدَّمِ
u'لُزُومٌ مِلْكٌ':Added, #1: 1	لُزُومِ الْمَلْزُومِ
u'لُزُومٌ مُمْتَنِعٌ':Added, #1: 1	لُزُومَ الْمِلْكِ
u'لُزُومٌ مَنْزِلٌ':Added, #1: 1	لُزُومِ الْمُمْتَنِعِ
u'لُزُومٌ مَنْعٌ':Added, #1: 1	لُزُومُ الْمَنْزِلِ
u'لُزُومٌ مَهْرٌ':Added, #1: 1	لُزُومُ الْمَنْعِ
u'لُزُومٌ مَهْرٌ':Added, #1: 1	لُزُومُ الْمَهْرِ
u'لُزُومٌ مَهْرٌ':Added, #2: 2	لُزُومِ مَهْرِ
u'لُزُومٌ مُوَافَقَةٌ':Added, #7: 7	لُزُومِ الْمَهْرِ
u'لُزُومٌ مُوجَبٌ':Added, #1: 1	لُزُومِ مُوَافَقَةِ
u'لُزُومٌ مَوْضِعٌ':Added, #1: 1	لُزُومَ الْمُوجَبِ
u'لُزُومٌ مُؤَنٌ':Added, #1: 1	لُزُومُ مَوْضِعٍ
u'لُزُومٌ نَتِيجَةٌ':Added, #1: 1	لُزُومِ الْمُؤَنِ
u'لُزُومٌ نذر':Added, #1: 1	لُزُومِ النَّتِيجَةِ
u'لُزُومٌ نذر':Added, #1: 1	لُزُومَ النَّذْرِ
u'لُزُومٌ نذر':Added, #1: 1	لُزُومُ النَّذْرِ
u'لُزُومٌ نَذْرٌ':Added, #1: 1	لُزُومِ النَّذْرِ
u'لُزُومٌ نَذْرٌ':Added, #1: 1	لُزُومَ النَّذْرِ
u'لُزُومٌ نَذْرٌ':Added, #1: 1	لُزُومُ النَّذْرِ
u'لُزُومٌ نِصْفٌ':Added, #1: 1	لُزُومِ النَّذْرِ
u'لُزُومٌ نِصْفٌ':Added, #1: 1	لُزُومِ النِّصْفِ
u'لُزُومٌ نِصْفٌ':Added, #1: 1	لُزُومِ نِصْفِ
u'لُزُومٌ نَظَرٌ':Added, #2: 2	لُزُومُ نِصْفِ
u'لُزُومٌ نَفَقَةٌ':Added, #1: 1	لُزُومِ النَّظَرِ
u'لُزُومٌ نَفَقَةٌ':Added, #1: 1	لُزُومُ نَفَقَتِهِ
u'لُزُومٌ نَفَقَةٌ':Added, #2: 2	لُزُومِ النَّفَقَةِ
u'لُزُومٌ نَفْلٌ':Added, #2: 2	لُزُومِ نَفَقَةِ
u'لُزُومٌ نَفْيٌ':Added, #1: 1	لُزُومُ النَّفْلِ
u'لُزُومٌ نَفْيٌ':Added, #1: 1	لُزُومِ نَفْيِ
u'لُزُومٌ نَفْيٌ':Added, #1: 1	لُزُومِ نَفْيِهِ
u'لُزُومٌ نَقْدٌ':Added, #2: 2	لُزُومَ نَفْيِ
u'لُزُومٌ نَقْد':Added, #2: 2	لُزُومُ النَّقْدِ
u'لُزُومٌ نُقْصَانٌ':Added, #2: 2	لُزُومُ النَّقْدِ
u'لُزُومٌ نَقْضٌ':Added, #1: 1	لُزُومُ النُّقْصَانِ
u'لُزُومٌ نكاح':Added, #1: 1	لُزُومُ النَّقْضِ
u'لُزُومٌ نكاح':Added, #1: 1	لُزُومَ النِّكَاحِ
u'لُزُومٌ نِكَاحٌ':Added, #1: 1	لُزُومُ النِّكَاحِ
u'لُزُومٌ نِكَاحٌ':Added, #1: 1	لُزُومَ النِّكَاحِ
u'لُزُومٌ نَوَافِلُ':Added, #1: 1	لُزُومُ النِّكَاحِ
u'لُزُومٌ نِيَّةٌ':Added, #1: 1	لُزُومِ النَّوَافِلِ
u'لُزُومٌ هِبَةٌ':Added, #1: 1	لُزُومِ نِيَّةِ
u'لُزُومٌ هِبَةٌ':Added, #1: 1	لُزُومَ الْهِبَةِ
u'لُزُومٌ هَدْمٌ':Added, #1: 1	لُزُومِ الْهِبَةِ
u'لُزُومٌ هَدْيٌ':Added, #3: 3	لُزُومِ هَدْمِ
u'لُزُومٌ هِرٌّ':Added, #1: 1	لُزُومُ الْهَدْيِ
u'لُزُومٌ هَرَب':Added, #1: 1	لُزُومِ الْهِرَّةِ
u'لُزُومٌ وَاجِبٌ':Added, #1: 1	لُزُومِ الْهَرَبِ
u'لُزُومٌ واحد':Added, #1: 1	لُزُومُ وَاجِبِ
u'لُزُومٌ وَاحِدٌ':Added, #1: 1	لُزُومِ وَاحِدَةٍ
u'لُزُومٌ وُجُودٌ':Added, #1: 1	لُزُومِ وَاحِدَةٍ
u'لُزُومٌ وُجُودٌ':Added, #1: 1	لُزُومِ وُجُودِ
u'لُزُومٌ وَصِيٌّ':Added, #1: 1	لُزُومِ وُجُودِهِ
u'لُزُومٌ وَصِيَّةٌ':Added, #1: 1	لُزُومِ الْوَصِيَّةِ
u'لُزُومٌ وَفَاءٌ':Added, #1: 1	لُزُومِ الْوَصِيَّةِ
u'لُزُومٌ وَفَاءٌ':Added, #2: 2	لُزُومُ الْوَفَاءِ
u'لُزُومٌ وَقْفٌ':Added, #5: 5	لُزُومِ الْوَفَاءِ
u'لُزُومٌ وَقْفٌ':Added, #3: 3	لُزُومَ الْوَقْفِ
u'لُزُومٌ وَلاَءٌ':Added, #3: 3	لُزُومِ الْوَقْفِ
u'لُزُومٌ ولد':Added, #1: 1	لُزُومِ الْوَلَاءِ
u'لُزُومٌ ولد':Added, #1: 1	لُزُومُ الْوَلَدِ
u'لُزُومٌ وَلَدٌ':Added, #1: 1	لُزُومِ الْوَلَدِ
u'لُزُومٌ وَلَدٌ':Added, #1: 1	لُزُومُ الْوَلَدِ
u'لُزُومٌ يَوْمٌ':Added, #1: 1	لُزُومِ الْوَلَدِ
u'لَسْعٌ رُتَيْلاَءُ':Added, #1: 1	لُزُومَ يَوْمٍ
u'لَسْعٌ زُنْبورٌ':Added, #1: 1	لَسْعِ الرُّتَيْلَاءِ
u'لَسْعٌ زُنْبورٌ':Added, #1: 1	لَسْعَ الزُّنْبُورِ
u'لَسْعٌ عَقْرَبٌ':Added, #1: 1	لَسْعِ الزُّنْبُورِ
u'لَسْعٌ عَقْرَبٌ':Added, #1: 1	لَسْعُ الْعَقْرَبِ
u'لَسْعٌ هَوَامٌّ':Added, #1: 1	لَسْعِ الْعَقْرَبِ
u'لسن مُتَسَبِّبٌ':Added, #1: 1	لَسْعِ الْهَوَامِّ
u'لَسْنٌ مُتَسَبِّبٌ':Added, #1: 1	لَسْنَ مُتَسَبِّبَاتٍ
u'لَصِقَ خُبْزٌ':Subject, #1: 1	لَسْنَ مُتَسَبِّبَاتٍ
u'لَطَافَةٌ حامِضٌ':Added, #1: 1	لَصِقَ الْخُبْزُ
u'لَطَّخَ بَاطن':Predicate, #1: 1	لَطَافَةِ الْحَامِضِ
u'لَطَّخَ باطِنٌ':Predicate, #2: 2	لَطَّخَ بَاطِنَ
u'لطخ حِنَّاءٌ':Added, #2: 2	لَطَّخَ بَاطِنَ
u'لَطْخٌ حِنَّاءٌ':Added, #1: 1	لَطْخِ حِنّاءٍ
u'لطخ رَأْسٌ':Added, #1: 1	لَطْخِ حِنّاءٍ
u'لَطْخٌ رَأْسٌ':Added, #3: 3	لَطْخُ رَأْسِ
u'لطخ نَفْسٌ':Added, #3: 3	لَطْخُ رَأْسِ
u'لَطْخٌ نَفْسٌ':Added, #1: 1	لَطْخِ نَفْسِهِ
u'لَطُفَ اِعْتِبارٌ':Subject, #1: 1	لَطْخِ نَفْسِهِ
u'لَطُفَ قَوَامٌ':Subject, #1: 1	لَطُفَ اعْتِبَارُ
u'لَطْمَةٌ ولد':Added, #1: 1	لَطُفَ قَوَامُهُ
u'لَطْمَةٌ وَلَدٌ':Added, #1: 1	لَطْمَةَ وَلَدِ
u'لَطَمَ جَارِي':Predicate, #1: 1	لَطْمَةَ وَلَدِ
u'لَطَمَ خُدُودٌ':Predicate, #1: 1	لَطَمَ جَارِيَةً
u'لَطَمَ رَجُلٌ':Subject, #2: 2	لَطَمَ الْخُدُودَ
u'لَطَمَ لَطِيم':Subject, #2: 2	لَطَمَ رَجُلٌ
u'لَطَمَ مُسْلِمٌ':Subject, #1: 1	لَطَمَ لَطِيمٌ
u'لعب اِبْنٌ':Added, #2: 2	لَطَمَ الْمُسْلِمُ
u'لَعِبٌ اِبْنٌ':Added, #1: 1	لَعِبِ ابْنِ
u'لعب بناتٌ':Added, #1: 1	لَعِبِ ابْنِ
u'لعب بناتٌ':Added, #2: 2	لَعِبَ الْبَنَاتِ
u'لَعِبٌ بناتٌ':Added, #2: 2	لَعِبِ الْبَنَاتِ
u'لَعِبٌ بناتٌ':Added, #2: 2	لَعِبَ الْبَنَاتِ
u'لعب حَبَشَة':Added, #2: 2	لَعِبِ الْبَنَاتِ
u'لَعِبٌ حَبَشَة':Added, #1: 1	لَعِبِ الْحَبَشَةِ
u'لَعِبَ رَجُلٌ':Subject, #1: 1	لَعِبِ الْحَبَشَةِ
u'لعب رَجُلٌ':Added, #1: 1	لَعِبَ رَجُلٌ
u'لَعِبٌ رَجُلٌ':Added, #1: 1	لَعِبُ الرَّجُلِ
u'لَعِبَ سَعِيدٌ':Subject, #1: 1	لَعِبُ الرَّجُلِ
u'لَعِبَ شِطْرَنْجٌ':Predicate, #1: 1	لَعِبَ سَعِيدُ
u'لعب شِطْرَنْجٌ':Added, #1: 1	لَعِبَ الشِّطْرَنْجَ
u'لَعِبٌ شِطْرَنْجٌ':Added, #4: 4	لَعِبِ الشِّطْرَنْجِ
u'لعب صِبْيَانٌ':Added, #4: 4	لَعِبِ الشِّطْرَنْجِ
u'لعب صِبْيَانٌ':Added, #1: 1	لَعِبَ الصِّبْيَانِ
u'لَعِبٌ صِبْيَانٌ':Added, #1: 1	لَعِبِ الصِّبْيَانِ
u'لَعِبٌ صِبْيَانٌ':Added, #1: 1	لَعِبَ الصِّبْيَانِ
u'لَعِبَ صُدُودٌ':Subject, #1: 1	لَعِبِ الصِّبْيَانِ
u'لَعِبٌ مُبَاحٌ':Added, #1: 1	لَعِبَ الصُّدُودُ
u'لعب مُعْتَقِدٌ':Added, #1: 1	لَعِبٍ مُبَاحٍ
u'لَعِبٌ مُعْتَقِدٌ':Added, #1: 1	لَعِبُ مُعْتَقِدِ
u'لَعِبَ نَاسٌ':Subject, #1: 1	لَعِبُ مُعْتَقِدِ
u'لعب يهود':Added, #1: 1	لَعِبَ النَّاسُ
u'لعب يَهُودٌ':Added, #1: 1	لَعِبُ الْيَهُودِ
u'لَعِبٌ يهود':Added, #1: 1	لَعِبُ الْيَهُودِ
u'لَعِبٌ يَهُودٌ':Added, #1: 1	لَعِبُ الْيَهُودِ
u'لَعِقَ عَسَلٌ':Predicate, #1: 1	لَعِبُ الْيَهُودِ
u'لَعِقَ قَصْعَةٌ':Predicate, #1: 1	لَعِقَ الْعَسَلَ
u'لَعَنَ آخِرُ':Subject, #1: 1	لَعِقَ الْقَصْعَةَ
u'لَعَنَ إلَهٌ':Subject, #1: 1	لَعَنَ آخِرُ
u'لَعَنَ بَعْضٌ':Subject, #1: 1	لَعَنَ الْإِلَهُ
u'لعنة أَقْوَامٌ':Added, #1: 1	لَعَنَ بَعْضٌ
u'لَعْنَةٌ أَقْوَامٌ':Added, #1: 1	لَعْنَةُ أَقْوَامٍ
u'لعنة اللهُ':Added, #1: 1	لَعْنَةُ أَقْوَامٍ
u'لَعْنَةٌ اللهُ':Added, #5: 5	لَعْنَةُ اللهِ
u'لعنة رَجُلٌ':Added, #5: 5	لَعْنَةُ اللهِ
u'لَعْنَةٌ رَجُلٌ':Added, #1: 1	لَعْنَةِ الرَّجُلِ
u'لعنة فَاسِقٌ':Added, #1: 1	لَعْنَةِ الرَّجُلِ
u'لعنة فَاسِقٌ':Added, #1: 1	لَعْنَةَ الْفَاسِقِ
u'لَعْنَةٌ فَاسِقٌ':Added, #1: 1	لَعْنَةِ الْفَاسِقِ
u'لَعْنَةٌ فَاسِقٌ':Added, #1: 1	لَعْنَةَ الْفَاسِقِ
u'لعنة فَاعِلٌ':Added, #1: 1	لَعْنَةِ الْفَاسِقِ
u'لَعْنَةٌ فَاعِلٌ':Added, #1: 1	لَعْنَةِ فَاعِلِهِ
u'لعنة كَافِرٌ':Added, #1: 1	لَعْنَةِ فَاعِلِهِ
u'لعنة كَافِرٌ':Added, #1: 1	لَعْنَةَ الْكَافِرِ
u'لَعْنَةٌ كَافِرٌ':Added, #1: 1	لَعْنَةُ الْكَافِرِ
u'لَعْنَةٌ كَافِرٌ':Added, #1: 1	لَعْنَةَ الْكَافِرِ
u'لعنة كَفَرَةٌ':Added, #1: 1	لَعْنَةُ الْكَافِرِ
u'لَعْنَةٌ كَفَرَةٌ':Added, #1: 1	لَعْنَةُ الْكَفَرَةِ
u'لعنة مُبْتَدِعٌ':Added, #1: 1	لَعْنَةُ الْكَفَرَةِ
u'لَعْنَةٌ مُبْتَدِعٌ':Added, #1: 1	لَعْنَةَ الْمُبْتَدِعِ
u'لعنة مُعِينٌ':Added, #1: 1	لَعْنَةَ الْمُبْتَدِعِ
u'لَعْنَةٌ مُعِينٌ':Added, #1: 1	لَعْنَةِ الْمُعِينِ
u'لعنة مُعَيَّنٌ':Added, #1: 1	لَعْنَةِ الْمُعِينِ
u'لَعْنَةٌ مُعَيَّنٌ':Added, #1: 1	لَعْنَةُ مُعَيَّنٍ
u'لعنة مُعَيَّنٌ':Added, #1: 1	لَعْنَةُ مُعَيَّنٍ
u'لَعْنَةٌ مُعَيَّنٌ':Added, #3: 3	لَعْنَةِ الْمُعَيَّنِ
u'لعنة نَوْعٌ':Added, #3: 3	لَعْنَةِ الْمُعَيَّنِ
u'لَعْنَةٌ نَوْعٌ':Added, #1: 1	لَعْنَةَ نَوْعٍ
u'لَعَنَ ثَالِثٌ':Predicate, #1: 1	لَعْنَةَ نَوْعٍ
u'لَعَنَ حَكَمٌ':Predicate, #1: 1	لَعَنَ الثَّالِثَ
u'لَعَنَ خامس':Predicate, #1: 1	لَعَنَ الْحَكَمَ
u'لَعَنَ خَامِسٌ':Predicate, #1: 1	لَعَنَ الْخَامِسَةَ
u'لَعَنَ خَمْرٌ':Predicate, #1: 1	لَعَنَ الْخَامِسَةَ
u'لَعَنَ رَاشِي':Predicate, #6: 6	لَعَنَ الْخَمْرَ
u'لَعَنَ رَسُولٌ':Subject, #1: 1	لَعَنَ الرَّاشِيَ
u'لَعَنَ ريحٌ':Predicate, #61: 61	لَعَنَ رَسُولُ
u'لَعَنَ سَلَفٌ':Predicate, #2: 2	لَعَنَ الرِّيحَ
u'لَعَنَ شَيْطَانٌ':Predicate, #1: 1	لَعَنَ السَّلَفَ
u'لَعَنَ عَرَبٌ':Predicate, #1: 1	لَعَنَ الشَّيْطَانَ
u'لَعَنَ قَدَرُ':Predicate, #2: 2	لَعَنَ الْعَرَبَ
u'لَعَنَ قَدَر':Predicate, #1: 1	لَعَنَ الْقَدَرِيَّةَ
u'لَعَنَ قَدَرِيّ':Predicate, #1: 1	لَعَنَ الْقَدَرِيَّةَ
u'لَعَنَ مُحَلِّل':Predicate, #1: 1	لَعَنَ الْقَدَرِيَّةَ
u'لَعَنَ مُخَنَّث':Predicate, #1: 1	لَعَنَ الْمُحَلِّلَ
u'لَعَنَ مُصْحَفٌ':Predicate, #2: 2	لَعَنَ الْمُخَنَّثِينَ
u'لَعَنَ مُصَوِّرٌ':Predicate, #1: 1	لَعَنَ الْمُصْحَفَ
u'لَعَنَ مُصَوِّرٌ':Predicate, #1: 1	لَعَنَ الْمُصَوِّرَ
u'لَعَنَ نَائِحٌ':Predicate, #1: 1	لَعَنَ الْمُصَوِّرِينَ
u'لَعَنَ نَبِيٌّ':Subject, #1: 1	لَعَنَ النَّائِحَةَ
u'لَعَنَ يَوْمٌ':Predicate, #3: 3	لَعَنَ النَّبِيُّ
u'لَغَا آخِرُ':Subject, #1: 1	لَعَنَ يَوْمَ
u'لَغَا أَخِيرٌ':Subject, #2: 2	لَغَا آخِرُ
u'لَغَا إقْرَارٌ':Subject, #1: 1	لَغَا الْأَخِيرُ
u'لَغَا إقْرَارٌ':Subject, #1: 1	لَغَا إقْرَارُ
u'لَغَا إقْرَارٌ':Subject, #2: 2	لَغَا إقْرَارُهُ
u'لَغَا إمَامٌ':Subject, #2: 2	لَغَا الْإِقْرَارُ
u'لَغَا أَمْرٌ':Subject, #1: 1	لَغَا الْإِمَامُ
u'لَغَا تَحَمُّلٌ':Subject, #1: 1	لَغَا الْأَمْرُ
u'لَغَا تَعْرِيفٌ':Subject, #1: 1	لَغَا التَّحَمُّلُ
u'لَغَا خُلْعٌ':Subject, #1: 1	لَغَا التَّعْرِيفُ
u'لَغَا ذكر':Subject, #1: 1	لَغَا الْخُلْعُ
u'لَغَا ذِكْرٌ':Subject, #3: 3	لَغَا ذِكْرُ
u'لَغَا رُجُوعٌ':Subject, #3: 3	لَغَا ذِكْرُ
u'لَغَا زائِدٌ':Subject, #1: 1	لَغَا الرُّجُوعُ
u'لَغَا سَبْرٌ':Predicate, #2: 2	لَغَا الزَّائِدُ
u'لَغَا شَرْطٌ':Subject, #1: 1	لَغَا السَّبْرَ
u'لَغَا صَرِيحٌ':Subject, #4: 4	لَغَا الشَّرْطُ
u'لَغَا قول':Subject, #1: 1	لَغَا صَرِيحُ
u'لَغَا قَوْلٌ':Subject, #2: 2	لَغَا قَوْلُ
u'لَغَا قول':Subject, #2: 2	لَغَا قَوْلُ
u'لَغَا قَوْلٌ':Subject, #5: 5	لَغَا قَوْلُهُ
u'لَغَا كَلاَمٌ':Subject, #5: 5	لَغَا قَوْلُهُ
u'لَغَا كَلاَمٌ':Subject, #1: 1	لَغَا الْكَلَامُ
u'لَغَا لَفْظٌ':Subject, #1: 1	لَغَا كَلَامُهُ
u'لَغَا نذر':Subject, #1: 1	لَغَا اللَّفْظُ
u'لَغَا نَذْرٌ':Subject, #1: 1	لَغَا نَذْرُهُ
u'لَغَا نِيَّةٌ':Predicate, #1: 1	لَغَا نَذْرُهُ
u'لَغَا وَصْفٌ':Subject, #1: 1	لَغَا نِيَّةَ
u'لَغَا وَصْفٌ':Subject, #1: 1	لَغَا الْوَصْفُ
u'لَغَا وَصْفٌ':Subject, #1: 1	لَغَا وَصْفُ
u'لَغَا وَقْفٌ':Subject, #2: 2	لَغَا وَصْفُهُ
u'لَغْوٌ إشارَة':Added, #1: 1	لَغَا وَقْفُهُ
u'لَغْوٌ إقْرَارٌ':Added, #1: 1	لَغْوِ الْإِشَارَةِ
u'لَغْوٌ جِهَةٌ':Added, #1: 1	لَغْوِ إقْرَارِ
u'لَغْوٌ دُخُولٌ':Added, #2: 2	لَغْوِ الْجِهَةِ
u'لَغْوٌ رُؤْيَةٌ':Added, #1: 1	لَغْوُ دُخُولِ
u'لَغْوٌ سُعَالٌ':Added, #1: 1	لَغْوُ رُؤْيَةِ
u'لَغْوٌ طَلاَقٌ':Added, #1: 1	لَغْوُ السُّعَالِ
u'لَغْوٌ عَقْدٌ':Added, #1: 1	لَغْوُ الطَّلَاقِ
u'لَغْوٌ علم':Added, #1: 1	لَغْوُ عَقْدِهِ
u'لَغْوٌ عِلْمٌ':Added, #1: 1	لَغْوِ عِلْمِهِ
u'لَغْوٌ غبار':Added, #1: 1	لَغْوِ عِلْمِهِ
u'لَغْوٌ غُبَارٌ':Added, #1: 1	لَغْوِ غُبَارِ
u'لَغْوٌ قَبْضٌ':Added, #1: 1	لَغْوِ غُبَارِ
u'لَغْوٌ كَافِرٌ':Added, #1: 1	لَغْوِ الْقَبْضِ
u'لَغْوٌ كُفَّارٌ':Added, #1: 1	لَغْوِ الْكَافِرِ
u'لَغْوٌ لبن':Added, #1: 1	لَغْوِ الْكُفَّارِ
u'لَغْوٌ لَبَنٌ':Added, #1: 1	لَغْوُ لَبَنِ
u'لَغْوٌ نَفَقَةٌ':Added, #1: 1	لَغْوُ لَبَنِ
u'لَغْوٌ نكاح':Added, #1: 1	لَغْوَ نَفَقَةِ
u'لَغْوٌ نِكَاحٌ':Added, #1: 1	لَغْوُ النِّكَاحِ
u'لَغْوٌ وِلاَيَةٌ':Added, #1: 1	لَغْوُ النِّكَاحِ
u'لَغْوٌ يَمِينٌ':Added, #1: 1	لَغْوِ الْوِلَايَةِ
u'لَغْوٌ يَمِينٌ':Added, #10: 10	لَغْوِ الْيَمِينِ
u'لَغْوٌ يَمِينٌ':Added, #18: 18	لَغْوُ الْيَمِينِ
u'لَغْوٌ يَمِينٌ':Added, #2: 2	لَغْوُ يَمِينٍ
u'لَغِيَ إشارَة':Predicate, #5: 5	لَغْوَ الْيَمِينِ
u'لَغِيَ تَعَلُّقٌ':Predicate, #1: 1	أَلْغَى الْإِشَارَةَ
u'لَغِيَ ذكر':Predicate, #1: 1	أَلْغَى تَعَلُّقَ
u'لَغِيَ ذِكْرٌ':Predicate, #1: 1	أَلْغَى ذِكْرَ
u'لَغِيَ صَاحِبٌ':Predicate, #1: 1	أَلْغَى ذِكْرَ
u'لَغِيَ كَسْرٌ':Predicate, #1: 1	أَلْغَى صَاحِبَ
u'لَغِيَ لَفْظٌ':Predicate, #1: 1	أَلْغَى الْكَسْرَ
u'لَغِيَ نَظَرٌ':Predicate, #1: 1	أَلْغَى لَفْظَ
u'لَغِيَ وَصْفٌ':Predicate, #1: 1	أَلْغَى النَّظَرَ
u'لَفَّ أَجْنَبِيٌّ':Subject, #2: 2	أَلْغَى وَصْفَ
u'لفتة نَاظِرٌ':Added, #1: 1	لَفَّ الْأَجْنَبِيُّ
u'لَفْتَةٌ نَاظِرٌ':Added, #1: 1	لَفْتَةِ نَاظِرٍ
u'لَفَّ ثَوْبٌ':Predicate, #1: 1	لَفْتَةِ نَاظِرٍ
u'لَفْحٌ حُروبٌ':Added, #3: 3	لَفَّ الثَّوْبَ
u'لَفَظَ إِسْلامٌ':Predicate, #2: 2	لَفْحِ الْحُرُوبِ
u'لَفَظَ بَحْرٌ':Subject, #1: 1	لَفَظَ الإِسْلاَمَ
u'لَفْظَةٌ أَبٌ':Added, #5: 5	لَفَظَ الْبَحْرُ
u'لَفْظَةٌ أبَدٌ':Added, #1: 1	لَفْظَةِ الْأَبِ
u'لَفْظَةٌ اِبْنٌ':Added, #1: 1	لَفْظَةِ الْأَبَدِ
u'لَفْظَةٌ اِبْنٌ':Added, #1: 1	لَفْظَةَ ابْنٍ
u'لَفْظَةٌ إجَارَةٌ':Added, #1: 1	لَفْظَةِ ابْنِهِ
u'لَفْظَةٌ إجَارَةٌ':Added, #1: 1	لَفْظَةَ الْإِجَارَةِ
u'لَفْظَةٌ أحَدٌ':Added, #1: 1	لَفْظَةُ الْإِجَارَةِ
u'لَفْظَةٌ إِطْعامٌ':Added, #1: 1	لَفْظَةَ أَحَدٍ
u'لَفْظَةٌ إِعادَةٌ':Added, #1: 1	لَفْظَةَ الْإِطْعَامِ
u'لَفْظَةٌ إِعارَةٌ':Added, #1: 1	لَفْظَةِ الْإِعَادَةِ
u'لَفْظَةٌ إِعارَةٌ':Added, #1: 1	لَفْظَةُ الْإِعَارَةِ
u'لَفْظَةٌ إقامَةٌ':Added, #2: 2	لَفْظَةَ الْإِعَارَةِ
u'لَفْظَةٌ ألْفٌ':Added, #2: 2	لَفْظَةِ الْإِقَامَةِ
u'لَفْظَةٌ أَلْفٌ':Added, #1: 1	لَفْظَةُ أَلْفٍ
u'لَفْظَةٌ إلَهٌ':Added, #1: 1	لَفْظَةُ أَلْفٍ
u'لَفْظَةٌ أُمٌّ':Added, #1: 1	لَفْظَةَ إلَهٍ
u'لَفْظَةٌ أُمٌّ':Added, #1: 1	لَفْظَةَ أُمِّ
u'لَفْظَةٌ أَمْرٌ':Added, #2: 2	لَفْظَةُ أُمٍّ
u'لَفْظَةٌ أَمْرٌ':Added, #1: 1	لَفْظَةَ الْأَمْرِ
u'لَفْظَةٌ أَمْرٌ':Added, #1: 1	لَفْظَةُ الْأَمْرِ
u'لَفْظَةٌ إِمْساكٌ':Added, #1: 1	لَفْظَةِ الْأَمْرِ
u'لَفْظَةٌ أَمْنٌ':Added, #1: 1	لَفْظَةَ الْإِمْسَاكِ
u'لَفْظَةٌ بدنة':Added, #1: 1	لَفْظَةَ الْأَمْنِ
u'لَفْظَةٌ بَعْضٌ':Added, #2: 2	لَفْظَةِ الْبَدَنَةِ
u'لَفْظَةٌ بَعْضٌ':Added, #1: 1	لَفْظَةُ بَعْضٍ
u'لَفْظَةٌ بَنْدَر':Added, #1: 1	لَفْظَةَ بَعْضِهِ
u'لَفْظَةٌ تَحْرِيمٌ':Added, #2: 2	لَفْظَةُ الْبَنْدَرِ
u'لَفْظَةٌ تَسْلِيمٌ':Added, #1: 1	لَفْظَةَ التَّحْرِيمِ
u'لَفْظَةٌ تَكْبيرٌ':Added, #1: 1	لَفْظَةَ التَّسْلِيمِ
u'لَفْظَةٌ تَلَفٌ':Added, #1: 1	لَفْظَةِ التَّكْبِيرِ
u'لَفْظَةٌ تَنَزُّه':Added, #1: 1	لَفْظَةَ تَلَفٍ
u'لَفْظَةٌ جُحُود':Added, #1: 1	لَفْظَةِ التَّنَزُّهِ
u'لَفْظَةٌ جَزُورٌ':Added, #1: 1	لَفْظَةِ الْجُحُودِ
u'لَفْظَةٌ حَبْسٌ':Added, #1: 1	لَفْظَةِ الْجَزُورِ
u'لَفْظَةٌ حُكْمٌ':Added, #1: 1	لَفْظَةُ الْحَبْسِ
u'لَفْظَةٌ حُكْمٌ':Added, #1: 1	لَفْظَةَ الْحُكْمِ
u'لَفْظَةٌ حَيْضَةٌ':Added, #1: 1	لَفْظَةُ الْحُكْمِ
u'لَفْظَةٌ خُلْعٌ':Added, #1: 1	لَفْظَةُ الْحَيْضَةِ
u'لَفْظَةٌ ذِمِّيٌّ':Added, #1: 1	لَفْظَةِ الْخُلْعِ
u'لَفْظَةٌ رَجُلٌ':Added, #1: 1	لَفْظَةَ ذِمِّيٍّ
u'لَفْظَةٌ رَهْنٌ':Added, #1: 1	لَفْظَةَ رَجُلٍ
u'لَفْظَةٌ زَوْجٌ':Added, #1: 1	لَفْظَةُ الرَّهْنِ
u'لَفْظَةٌ سلام':Added, #1: 1	لَفْظَةَ الزَّوْجِ
u'لَفْظَةٌ سَلاَمٌ':Added, #1: 1	لَفْظَةَ السَّلَامِ
u'لَفْظَةٌ سلام':Added, #1: 1	لَفْظَةَ السَّلَامِ
u'لَفْظَةٌ سَلاَمٌ':Added, #2: 2	لَفْظَةِ السَّلَامِ
u'لَفْظَةٌ شِبْرٌ':Added, #2: 2	لَفْظَةِ السَّلَامِ
u'لَفْظَةٌ شَطْرٌ':Added, #1: 1	لَفْظَةَ الشِّبْرِ
u'لَفْظَةٌ شَهَادَةٌ':Added, #1: 1	لَفْظَةُ شَطْرٍ
u'لَفْظَةٌ شَهَادَةٌ':Added, #10: 10	لَفْظَةُ الشَّهَادَةِ
u'لَفْظَةٌ شَهَادَةٌ':Added, #13: 13	لَفْظَةِ الشَّهَادَةِ
u'لَفْظَةٌ شَيْءٌ':Added, #9: 9	لَفْظَةَ الشَّهَادَةِ
u'لَفْظَةٌ صدقة':Added, #2: 2	لَفْظَةَ شَيْءٍ
u'لَفْظَةٌ صدقة':Added, #1: 1	لَفْظَةَ الصَّدَقَةِ
u'لَفْظَةٌ صَدَقَةٌ':Added, #1: 1	لَفْظَةُ الصَّدَقَةِ
u'لَفْظَةٌ صَدَقَةٌ':Added, #1: 1	لَفْظَةَ الصَّدَقَةِ
u'لَفْظَةٌ طَاهِرٌ':Added, #1: 1	لَفْظَةُ الصَّدَقَةِ
u'لَفْظَةٌ طَلاَقٌ':Added, #1: 1	لَفْظَةَ الطَّاهِرِ
u'لَفْظَةٌ طَلاَقٌ':Added, #1: 1	لَفْظَةُ الطَّلَاقِ
u'لَفْظَةٌ ظهار':Added, #2: 2	لَفْظَةَ الطَّلَاقِ
u'لَفْظَةٌ عتق':Added, #1: 1	لَفْظَةَ الظِّهَارِ
u'لَفْظَةٌ عِتْقٌ':Added, #1: 1	لَفْظَةِ الْعِتْقِ
u'لَفْظَةٌ عتق':Added, #1: 1	لَفْظَةِ الْعِتْقِ
u'لَفْظَةٌ عِتْقٌ':Added, #2: 2	لَفْظَةُ الْعِتْقِ
u'لَفْظَةٌ عَدَمٌ':Added, #2: 2	لَفْظَةُ الْعِتْقِ
u'لَفْظَةٌ عَدَمٌ':Added, #1: 1	لَفْظَةَ عَدَمِ
u'لَفْظَةٌ عِلْقٌ':Added, #3: 3	لَفْظَةِ عَدَمِ
u'لَفْظَةٌ علم':Added, #1: 1	لَفْظَةُ عِلْقٍ
u'لَفْظَةٌ عِلْمٌ':Added, #1: 1	لَفْظَةَ عِلْمٍ
u'لَفْظَةٌ عَلِيٌّ':Added, #1: 1	لَفْظَةَ عِلْمٍ
u'لَفْظَةٌ غَدٌ':Added, #1: 1	لَفْظَةَ عَلِيِّ
u'لَفْظَةٌ غَنَمٌ':Added, #1: 1	لَفْظَةَ غَدٍ
u'لَفْظَةٌ غير':Added, #1: 1	لَفْظَةَ الْغَنَمِ
u'لَفْظَةٌ غَيْرٌ':Added, #1: 1	لَفْظَةُ غَيْرِ
u'لَفْظَةٌ فلان':Added, #1: 1	لَفْظَةُ غَيْرِ
u'لَفْظَةٌ قَبُولٌ':Added, #2: 2	لَفْظَةُ الْبَنْدَرِ
u'لَفْظَةٌ قَرِيبٌ':Added, #1: 1	لَفْظَةَ قَبُولِ
u'لَفْظَةٌ قَضَاءٌ':Added, #1: 1	لَفْظَةَ الْقَرِيبِ
u'لَفْظَةٌ كَرَاهَةٌ':Added, #1: 1	لَفْظَةِ الْقَضَاءِ
u'لَفْظَةٌ لَحْمٌ':Added, #1: 1	لَفْظَةَ الْكَرَاهَةِ
u'لَفْظَةٌ لعنة':Added, #1: 1	لَفْظَةِ لَحْمٍ
u'لَفْظَةٌ لَعْنَةٌ':Added, #2: 2	لَفْظَةَ اللَّعْنَةِ
u'لَفْظَةٌ مثل':Added, #2: 2	لَفْظَةَ اللَّعْنَةِ
u'لَفْظَةٌ مِثْلٌ':Added, #1: 1	لَفْظَةَ مِثْلِ
u'لَفْظَةٌ مُخْتَارٌ':Added, #1: 1	لَفْظَةَ مِثْلِ
u'لَفْظَةٌ مَشِيئَةٌ':Added, #1: 1	لَفْظَةِ الْمُخْتَارِ
u'لَفْظَةٌ مُضَارَبَةٌ':Added, #1: 1	لَفْظَةُ الْمَشِيئَةِ
u'لَفْظَةٌ مَقْهُور':Added, #1: 1	لَفْظَةِ الْمُضَارَبَةِ
u'لَفْظَةٌ نَحْوٌ':Added, #1: 1	لَفْظَةَ الْمَقْهُورِ
u'لَفْظَةٌ نذر':Added, #1: 1	لَفْظَةِ نَحْوِ
u'لَفْظَةٌ نَذْرٌ':Added, #1: 1	لَفْظَةِ النَّذْرِ
u'لَفْظَةٌ نِصْفٌ':Added, #1: 1	لَفْظَةِ النَّذْرِ
u'لَفْظَةٌ نكاح':Added, #2: 2	لَفْظَةِ نِصْفِ
u'لَفْظَةٌ نِكَاحٌ':Added, #2: 2	لَفْظَةِ النِّكَاحِ
u'لَفْظَةٌ هِبَةٌ':Added, #2: 2	لَفْظَةِ النِّكَاحِ
u'لَفْظَةٌ هِبَةٌ':Added, #1: 1	لَفْظَةُ الْهِبَةِ
u'لَفْظَةٌ هَدْيٌ':Added, #1: 1	لَفْظَةِ الْهِبَةِ
u'لَفْظَةٌ واحد':Added, #2: 2	لَفْظَةِ الْهَدْيِ
u'لَفْظَةٌ وَاحِدٌ':Added, #2: 2	لَفْظَةٍ وَاحِدَةٍ
u'لَفْظَةٌ وُجُوبٌ':Added, #2: 2	لَفْظَةٍ وَاحِدَةٍ
u'لَفْظَةٌ وَقْفٌ':Added, #1: 1	لَفْظَةَ الْوُجُوبِ
u'لَفْظَةٌ يَوْمٌ':Added, #2: 2	لَفْظَةَ الْوَقْفِ
u'لَفَظَ ثَدْيٌ':Predicate, #1: 1	لَفْظَةُ يَوْمٍ
u'لَفَظَ عَجَمِيٌّ':Subject, #1: 1	لَفَظَ الثَّدْيَ
u'لَفَّ عِمَامَةٌ':Predicate, #1: 1	لَفَظَ عَجَمِيٌّ
u'لَفَّقَ قول':Predicate, #1: 1	لَفَّ الْعِمَامَةَ
u'لَفَّقَ قَوْلٌ':Predicate, #3: 3	لَفَّقَ قَوْلَ
u'لَفَّ كِرْباس':Predicate, #3: 3	لَفَّقَ قَوْلَ
u'لَفَّ لِفَافَةٌ':Predicate, #1: 1	لَفَّ الْكِرْبَاسَ
u'لِقَاءٌ أَحِبَّةٌ':Added, #1: 1	لَفَّ اللِّفَافَةَ
u'لِقَاءٌ أحَدٌ':Added, #1: 1	لِقَاءُ الْأَحِبَّةِ
u'لِقَاءٌ إِخْوَانٌ':Added, #1: 1	لِقَاءُ أَحَدٍ
u'لِقَاءٌ أكابر':Added, #1: 1	لِقَاءُ الْإِخْوَانِ
u'لِقَاءٌ اللهُ':Added, #1: 1	لِقَاءَ الْأَكَابِرِ
u'لِقَاءٌ أهْلٌ':Added, #4: 4	لِقَاءَ اللهِ
u'لِقَاءٌ جَمَاعَةٌ':Added, #1: 1	لِقَاءَ أَهْلِ
u'لِقَاءٌ حَجَرٌ':Added, #1: 1	لِقَاءُ جَمَاعَةٍ
u'لِقَاءٌ خضر':Added, #1: 1	لِقَاءِ الْحَجَرِ
u'لِقَاءٌ خِضْرٌ':Added, #1: 1	لِقَاءِ الْخِضْرِ
u'لِقَاءٌ رَبُّ':Added, #1: 1	لِقَاءِ الْخِضْرِ
u'لِقَاءٌ رَبُّ':Added, #4: 4	لِقَاءَ رَبِّهِ
u'لِقَاءٌ رفقة':Added, #4: 4	لِقَاءِ رَبِّهِ
u'لِقَاءٌ رُفْقَةٌ':Added, #1: 1	لِقَاءِ الرُّفْقَةِ
u'لِقَاءٌ رُومٌ':Added, #1: 1	لِقَاءِ الرُّفْقَةِ
u'لِقَاءٌ زَيْدٌ':Added, #1: 1	لِقَاءُ الرّومِ
u'لِقَاءٌ عَدُوٌّ':Added, #1: 1	لِقَاءَ زَيْدٍ
u'لِقَاءٌ عَدُوٌّ':Added, #13: 13	لِقَاءَ الْعَدُوِّ
u'لِقَاءٌ غير':Added, #5: 5	لِقَاءِ الْعَدُوِّ
u'لِقَاءٌ غَيْرٌ':Added, #1: 1	لِقَاءِ غَيْرِهِ
u'لِقَاءٌ قَوْمٌ':Added, #1: 1	لِقَاءِ غَيْرِهِ
u'لِقَاءٌ مُتَحابّ':Added, #1: 1	لِقَاءِ الْقَوْمِ
u'لِقَاءٌ مُحَدِّثٌ':Added, #1: 1	لِقَاءَ مُتَحَابّيْنِ
u'لِقَاءٌ مَطْلُوبٌ':Added, #1: 1	لِقَاءِ مُحَدِّثٍ
u'لِقَاءٌ مُلُوكٌ':Added, #1: 1	لِقَاءِ الْمَطْلُوبِ
u'لِقَاءٌ مُؤْمِنٌ':Added, #1: 1	لِقَاءِ الْمُلُوكِ
u'لِقَاءٌ نَاسٌ':Added, #1: 1	لِقَاءَ الْمُؤْمِنِ
u'لِقَاءٌ نَاسٌ':Added, #2: 2	لِقَاءُ النَّاسِ
u'لِقَاءٌ نَبِيٌّ':Added, #2: 2	لِقَاءِ النَّاسِ
u'لِقَاءٌ واحد':Added, #1: 1	لِقَاءَ النَّبِيِّ
u'لِقَاءٌ وَاحِدٌ':Added, #1: 1	لِقَاءُ وَاحِدٍ
u'لِقَاءٌ وَجْهٌ':Added, #1: 1	لِقَاءُ وَاحِدٍ
u'لَقَّبَ أَوْقَاتٌ':Predicate, #1: 1	لِقَاءَ وَجْهِهِ
u'لَقَّبَ بَابٌ':Predicate, #1: 1	لَقَّبَ الْأَوْقَاتَ
u'لَقَّبَ مَسْأَلَةٌ':Predicate, #1: 1	لَقَّبَ الْبَابَ
u'لَقَطَ أَصابِعُ':Predicate, #2: 2	لَقَّبَ الْمَسْأَلَةَ
u'لَقْطٌ أَصابِعُ':Added, #1: 1	لَقَطَ أَصَابِعَ
u'لَقْطٌ أَصابِعُ':Added, #1: 1	لَقْطُ الْأَصَابِعِ
u'لَقَطَ ثَلاثُ':Predicate, #1: 1	لَقْطِ الْأَصَابِعِ
u'لَقْطٌ خَمْسٌ':Added, #1: 1	لَقَطَ الثَّلَاثَ
u'لَقْطٌ زَيْتونٌ':Added, #1: 1	لَقْطُ خَمْسٍ
u'لَقْطٌ زَيْتونٌ':Added, #1: 1	لَقْطُ الزَّيْتُونِ
u'لَقْطٌ طِفْلٌ':Added, #1: 1	لَقْطِ الزَّيْتُونِ
u'لَقَّنَ رَجُلٌ':Subject, #2: 2	لَقْطُ طِفْلٍ
u'لَقَّنَ مَدْيُونٌ':Subject, #1: 1	لَقَّنَ الرَّجُلُ
u'لَقِيَ اِبْنٌ':Predicate, #1: 1	لَقَّنَ الْمَدْيُونُ
u'لَقِيَ أَجْنَبِيٌّ':Predicate, #5: 5	لَقِيَ ابْنَ
u'لَقِيَ أَحِبَّةٌ':Predicate, #1: 1	لَقِيَ أَجْنَبِيَّةً
u'لَقِيَ أحَدٌ':Predicate, #2: 2	أَلْقَى الْأَحِبّةَ
u'لَقِيَ أحَدٌ':Predicate, #2: 2	أَلْقَى أَحَدَ
u'لَقِيَ أَذَانٌ':Predicate, #2: 2	لَقِيَ أَحَدَ
u'لَقِيَ أَشْهَب':Predicate, #1: 1	أَلْقَى الْأَذَانَ
u'لَقِيَ أصْغَرٌ':Predicate, #1: 1	لَقِيَ أَشْهَبَ
u'لَقِيَ أَصْغَرُ':Predicate, #3: 3	لَقِيَ الْأَصْغَرَ
u'لَقِيَ أَصيلٌ':Predicate, #3: 3	لَقِيَ الْأَصْغَرَ
u'لَقِيَ أقْرَع':Predicate, #1: 1	لَقِيَ الْأَصِيلَ
u'لَقِيَ أكْبَرُ':Predicate, #2: 2	لَقِيَ الْأَقْرَعَ
u'لَقِيَ الْمَرْءُ':Predicate, #3: 3	لَقِيَ الْأَكْبَرَ
u'لَقِيَ المُشْتَرِي':Predicate, #1: 1	لَقِيَ الْمَرْءَ
u'لَقِيَ أَلْوَاحٌ':Predicate, #2: 2	لَقِيَ الْمُشْتَرِيَ
u'لَقِيَ إمَامٌ':Subject, #1: 1	أَلْقَى الْأَلْوَاحَ
u'لَقِيَ آمِرٌ':Predicate, #1: 1	لَقِيَ الْإِمَامُ
u'لَقِيَ آمِرٌ':Predicate, #1: 1	أَلْقَى الْآمِرَ
u'لَقِيَ أوْسَطُ':Predicate, #3: 3	لَقِيَ الْآمِرَ
u'لَقِيَ بَائِعٌ':Predicate, #2: 2	لَقِيَ الْأَوْسَطَ
u'لَقِيَ بَائِعٌ':Subject, #5: 5	لَقِيَ الْبَائِعَ
u'لَقِيَ بَذْرٌ':Predicate, #1: 1	لَقِيَ الْبَائِعُ
u'لَقِيَ بَيْتٌ':Predicate, #4: 4	أَلْقَى الْبَذْرَ
u'لَقِيَ تُرَابٌ':Predicate, #4: 4	لَقِيَ الْبَيْتَ
u'لَقِيَ ثَالِثٌ':Subject, #1: 1	أَلْقَى التُّرَابَ
u'لَقِيَ جِلْبَابٌ':Predicate, #2: 2	لَقِيَ الثَّالِثُ
u'لَقِيَ جَمَاعَةٌ':Subject, #5: 5	أَلْقَى جِلْبَابَ
u'لَقِيَ جُوَالِقٌ':Predicate, #1: 1	لَقِيَ جَمَاعَةٌ
u'لَقِيَ حَبٌّ':Predicate, #1: 1	أَلْقَى جُوَالِقَ
u'لَقِيَ حَشِيشٌ':Predicate, #1: 1	أَلْقَى حَبَّ
u'لَقِيَ حَكِيمٌ':Predicate, #2: 2	أَلْقَى الْحَشِيشَ
u'لَقِيَ خامس':Subject, #1: 1	لَقِيَ حَكِيمَ
u'لَقِيَ خَامِسٌ':Subject, #1: 1	لَقِيَ الْخَامِسُ
u'لَقِيَ خَلْقٌ':Subject, #1: 1	لَقِيَ الْخَامِسُ
u'لَقِيَ دَابَّةٌ':Predicate, #1: 1	لَقِيَ خَلْقٌ
u'لَقِيَ رابع':Subject, #1: 1	أَلْقَى دَابَّةَ
u'لَقِيَ رَابِعٌ':Subject, #1: 1	لَقِيَ الرَّابِعُ
u'لَقِيَ رَبُّ':Subject, #1: 1	لَقِيَ الرَّابِعُ
u'لَقَّى رَبُّ':Subject, #1: 1	لَقِيَ رَبُّ
u'لَقِيَ رَجُلٌ':Predicate, #1: 1	لَقَّى رَبُّ
u'لَقِيَ رَجُلٌ':Subject, #1: 1	لَقِيَ الرَّجُلَ
u'لَقِيَ رَجُلٌ':Subject, #1: 1	لَقِيَ رَجُلٌ
u'لَقِيَ رَسُولٌ':Predicate, #2: 2	لَقِيَ الرَّجُلُ
u'لَقِيَ رَسُولٌ':Predicate, #1: 1	أَلْقَى رَسُولَ
u'لَقِيَ رَسُولٌ':Subject, #4: 4	لَقِيَ رَسُولَ
u'لَقِيَ رَوْث':Predicate, #12: 12	لَقِيَ رَسُولُ
u'لَقِيَ زَيْدٌ':Predicate, #2: 2	أَلْقَى الرَّوْثَةَ
u'لَقِيَ سِلاَحٌ':Predicate, #2: 2	لَقِيَ زَيْدَ
u'لَقِيَ سِلاَحٌ':Predicate, #1: 1	أَلْقَى السِّلَاحَ
u'لَقِيَ سَمْعٌ':Predicate, #3: 3	أَلْقَى السِّلاَحَ
u'لَقِيَ سَمَكٌ':Predicate, #2: 2	أَلْقَى السَّمْعَ
u'لَقِيَ سِنٌّ':Predicate, #1: 1	أَلْقَى سَمَكَةً
u'لَقِيَ شبكة':Predicate, #1: 1	أَلْقَى السِّنَّ
u'لَقِيَ شَبَكَةٌ':Predicate, #1: 1	أَلْقَى الشَّبَكَةَ
u'لَقِيَ شَيْطان':Predicate, #1: 1	أَلْقَى الشَّبَكَةَ
u'لَقِيَ شَيْطان':Predicate, #1: 1	لَقِيَ شَيْطَانَةً
u'لَقِيَ صَحَابِيٌّ':Predicate, #2: 2	لَقِيَ شَيْطَانَةَ
u'لَقِيَ صَدِيقٌ':Predicate, #2: 2	لَقِيَ الصَّحَابِيَّ
u'لَقِيَ طَائِفٌ':Predicate, #2: 2	أَلْقَى الصَّدِيقَ
u'لَقِيَ طَرِيقٌ':Predicate, #1: 1	لَقِيَ طَائِفَةً
u'لَقِيَ عَبَّاسٌ':Predicate, #1: 1	لَقِيَ الطّرِيقَ
u'لَقِيَ عَبَّاسٌ':Predicate, #1: 1	لَقِيَ الْعَبّاسَ
u'لَقِيَ عَبْدٌ':Subject, #1: 1	لَقِيَ الْعَبَّاسَ
u'لَقِيَ عَدُوٌّ':Predicate, #1: 1	لَقِيَ عَبْدُ
u'لَقِيَ عُمَرٌ':Predicate, #3: 3	لَقِيَ الْعَدُوَّ
u'لَقِيَ عُمَرٌ':Subject, #2: 2	لَقِيَ عُمَرَ
u'لَقِيَ عند':Predicate, #1: 1	لَقِيَ عُمَرُ
u'لَقِيَ فلان':Predicate, #1: 1	لَقِيَ عِنْدَ
u'لَقِيَ فلان':Predicate, #1: 1	لَقِيَ عُثْمَانَ
u'لَقِيَ فلان':Predicate, #1: 1	لَقِيَ عَوْفَ
u'لَقِيَ فلان':Subject, #2: 2	لَقِيَ حُذَيْفَةَ
u'لَقِيَ قُمَامَةٌ':Predicate, #1: 1	لَقِيَ مُعَاوِيَةُ
u'لَقِيَ كَافِرٌ':Predicate, #2: 2	أَلْقَى الْقُمَامَةَ
u'لَقِيَ كَفِيلٌ':Predicate, #1: 1	لَقِيَ الْكَافِرَ
u'لَقِيَ مَاءٌ':Predicate, #2: 2	لَقِيَ الْكَفِيلَ
u'لَقِيَ مَالٌ':Predicate, #1: 1	أَلْقَى الْمَاءَ
u'لَقِيَ مَأْمُورٌ':Predicate, #1: 1	أَلْقَى مَالَ
u'لَقِيَ مَتَاعٌ':Predicate, #1: 1	لَقِيَ الْمَأْمُورَ
u'لَقِيَ مُسْلِمٌ':Subject, #1: 1	أَلْقَى الْمَتَاعَ
u'لَقِيَ مُشْتَرِي':Predicate, #1: 1	لَقِيَ مُسْلِمٌ
u'لَقِيَ مُشْرِك':Predicate, #2: 2	لَقِيَ الْمُشْتَرِيَ
u'لَقِيَ مُصَنِّفٌ':Predicate, #3: 3	لَقِيَ الْمُشْرِكِينَ
u'لَقِيَ مُعاوِيَة':Subject, #1: 1	لَقِيَ الْمُصَنِّفَ
u'لَقِيَ مِنْطَقَةٌ':Predicate, #1: 1	لَقِيَ مُعَاوِيَةُ
u'لَقِيَ نَاسٌ':Subject, #1: 1	أَلْقَى الْمِنْطَقَةَ
u'لَقِيَ نَبِيٌّ':Predicate, #1: 1	لَقِيَ نَاسٌ
u'لَقِيَ نَبِيٌّ':Subject, #7: 7	لَقِيَ النَّبِيَّ
u'لَقِيَ نَجَاسَةٌ':Predicate, #4: 4	لَقِيَ النَّبِيُّ
u'لَقِيَ نَجَسٌ':Predicate, #1: 1	أَلْقَى النَّجَاسَةَ
u'لَقِيَ هِنْدٌ':Predicate, #1: 1	أَلْقَى النَّجَسَ
u'لَقِيَ وَفْدٌ':Predicate, #1: 1	لَقِيَ هِنْدَ
u'لَقِيَ يَوْمٌ':Predicate, #2: 2	لَقِيَ الْوَفْدَ
u'لَمَحَ بَرْقٌ':Predicate, #1: 1	لَقِيَ يَوْمَ
u'لَمْحٌ بَرْقٌ':Added, #1: 1	لَمَحَ الْبَرْقَ
u'لَمْحٌ صِفَةٌ':Added, #1: 1	لَمْحُ الْبَرْقِ
u'لَمْحٌ نُورٌ':Added, #1: 1	لَمْحُ الصِّفَةِ
u'لَمْسٌ أَجْنَبِيٌّ':Added, #1: 1	لَمْحَ نُورٍ
u'لَمْسٌ أَجْنَبِيٌّ':Added, #1: 1	لَمْسُ الْأَجْنَبِيَّةِ
u'لَمَسَ الْمَرْأَةُ':Predicate, #1: 1	لَمْسِ الْأَجْنَبِيَّةِ
u'لَمْسٌ الْمَرْأَةُ':Added, #1: 1	لَمَسَ الْمَرْأَةَ
u'لَمْسٌ الْمَرْأَةُ':Added, #1: 1	لَمْسُ الْمَرْأَةِ
u'لَمَسَ اِمْرَأَةٌ':Predicate, #1: 1	لَمْسِ الْمَرْأَةِ
u'لَمْسٌ اِمْرَأَةٌ':Added, #1: 1	لَمَسَ امْرَأَةَ
u'لَمْسٌ آنِيَةٌ':Added, #1: 1	لَمْسَ امْرَأَةٍ
u'لَمْسٌ ثِيابٌ':Added, #1: 1	لَمْسِ الْآنِيَةِ
u'لَمَسَ حَجَرٌ':Predicate, #1: 1	لَمْسِ الثِّيَابِ
u'لَمْسٌ خَطَأٌ':Added, #1: 1	لَمَسَ الْحَجَرَ
u'لَمْسٌ ذكر':Added, #1: 1	لَمْسِ الْخَطَأِ
u'لَمْسٌ ذَكَرٌ':Added, #1: 1	لَمْسِ الذَّكَرِ
u'لَمَسَ رَجُلٌ':Subject, #1: 1	لَمْسِ الذَّكَرِ
u'لَمَسَ رَجُلٌ':Subject, #2: 2	لَمَسَ الرَّجُلُ
u'لَمْسٌ رَجُلٌ':Added, #3: 3	لَمَسَ رَجُلٌ
u'لَمَسَ سَائِرٌ':Predicate, #1: 1	لَمْسُ الرَّجُلِ
u'لَمْسٌ سِنٌّ':Added, #1: 1	لَمَسَ سَائِرَ
u'لَمْسٌ شَعْرٌ':Added, #1: 1	لَمْسُ سِنٍّ
u'لَمْسٌ شَعْرٌ':Added, #1: 1	لَمْسَ الشَّعْرِ
u'لَمْسٌ شَيْءٌ':Added, #1: 1	لَمْسُ الشَّعْرِ
u'لَمَسَ شَيْخٌ':Subject, #1: 1	لَمْسَ شَيْءٍ
u'لَمْسٌ صغائر':Added, #1: 1	لَمَسَ شَيْخٌ
u'لَمْسٌ صَغَائِرُ':Added, #1: 1	لَمْسِ الصَّغَائِرِ
u'لَمَسَ صَغِيرٌ':Predicate, #1: 1	لَمْسِ الصَّغَائِرِ
u'لَمْسٌ صَغِيرٌ':Added, #1: 1	لَمَسَ صَغِيرَةً
u'لَمْسٌ طِفْلٌ':Added, #1: 1	لَمْسَ الصَّغِيرَةِ
u'لَمْسٌ عُضْوٌ':Added, #1: 1	لَمْسُ الطِّفْلَةِ
u'لَمْسٌ فَرْجٌ':Added, #1: 1	لَمْسُ الْعُضْوِ
u'لَمْسٌ قَبْرٌ':Added, #1: 1	لَمْسِ الْفَرْجِ
u'لَمَسَ قُبُلٌ':Predicate, #2: 2	لَمْسُ الْقَبْرِ
u'لَمْسٌ قُبُلٌ':Added, #1: 1	لَمَسَ قُبُلَ
u'لَمْسٌ مَحَارِمُ':Added, #1: 1	لَمْسِ قُبُلِ
u'لَمَسَ مُصْحَفٌ':Predicate, #2: 2	لَمْسِ الْمَحَارِمِ
u'لَمَسَ وبال':Predicate, #1: 1	لَمَسَ الْمُصْحَفَ
u'لَمَسَ وَبَالٌ':Predicate, #1: 1	لَمَسَ وَبَالَ
u'لَمْسٌ وَجْهٌ':Added, #1: 1	لَمَسَ وَبَالَ
u'لَمَعَانٌ شمس':Added, #1: 1	لَمْسُ وَجْهِ
u'لَمَعَانٌ شَمْسٌ':Added, #1: 1	لَمَعَانَ الشّمْسِ
u'لَهَا أَبٌ':Subject, #1: 1	لَمَعَانَ الشّمْسِ
u'لَهَا أَبٌ':Subject, #17: 17	لَهَا أَبٌ
u'لَهَا آباءٌ':Subject, #1: 1	لَهَا الْأَبُ
u'لَهَا آبارٌ':Subject, #4: 4	لَهَا آبَاءٌ
u'لَهَا اِبْتِداءٌ':Subject, #1: 1	لَهَا آبَارٌ
u'لَهَا اِبْتِداءٌ':Subject, #2: 2	لَهَا ابْتِدَاءٌ
u'لَهَا إبدالٌ':Subject, #2: 2	لَهَا ابْتِدَاءُ
u'لَهَا إِبْطَالٌ':Subject, #1: 1	لَهَا إبْدَالُهُ
u'لَهَا أَبْعَدُ':Subject, #1: 1	لَهَا إبْطَالُهُ
u'لَهَا اِبْنٌ':Subject, #1: 1	لَهَا أَبْعَدُ
u'لَهَا اِبْنٌ':Subject, #19: 19	لَهَا ابْنٌ
u'لَهَا اِبْنَة':Subject, #7: 7	لَهَا ابْنُ
u'لَهَا أبْنيَةٌ':Subject, #1: 1	لَهَا ابْنَةٌ
u'لَهَا أَبْوَابٌ':Subject, #1: 1	لَهَا أَبْنِيَةٌ
u'لَهَا اِتِّبَاعٌ':Subject, #7: 7	لَهَا أَبْوَابُ
u'لَهَا اِتِّبَاعٌ':Subject, #1: 1	لَهَا اتِّبَاعُهُ
u'لَهَا اِتِّخَاذٌ':Subject, #2: 2	لَهَا اتِّبَاعُ
u'لَهَا اِتِّصَالٌ':Subject, #1: 1	لَهَا اتِّخَاذُهُ
u'لَهَا إتْمَامٌ':Subject, #3: 3	لَهَا اتِّصَالٌ
u'لَهَا إِتْيانٌ':Subject, #1: 1	لَهَا إتْمَامُ
u'لَهَا أثَرٌ':Subject, #1: 1	لَهَا الْإِتْيَانُ
u'لَهَا إجَازَةٌ':Subject, #39: 39	لَهَا أَثَرٌ
u'لَهَا أَجْرٌ':Subject, #1: 1	لَهَا الْإِجَازَةُ
u'لَهَا أَجْرٌ':Subject, #3: 3	لَهَا الْأَجْرُ
u'لَهَا أَجْرٌ':Subject, #4: 4	لَهَا أَجْرُ
u'لَهَا أُجْرَةٌ':Subject, #6: 6	لَهَا أَجْرٌ
u'لَهَا أُجْرَةٌ':Subject, #1: 1	لَهَا أُجْرَتُهُ
u'لَهَا أُجْرَةٌ':Subject, #32: 32	لَهَا أُجْرَةٌ
u'لَهَا أَجْزَاءٌ':Subject, #3: 3	لَهَا أُجْرَةُ
u'لَهَا أَجَلٌ':Predicate, #1: 1	لَهَا أَجْزَاءٌ
u'لَهَا أَجَلٌ':Subject, #1: 1	لَهَا الْأَجَلَ
u'لَهَا أَجَلٌ':Subject, #1: 1	لَهَا الْأَجَلُ
u'لَهَا أَجْنَبِيٌّ':Subject, #3: 3	لَهَا أَجَلٌ
u'لَهَا أجْنِحَةٌ':Subject, #2: 2	لَهَا أَجْنَبِيٌّ
u'لَهَا أَحادِيثُ':Subject, #4: 4	لَهَا أَجْنِحَةٌ
u'لَهَا اِحْتِسابٌ':Predicate, #1: 1	لَهَا أَحَادِيثُ
u'لَهَا أحَدٌ':Subject, #1: 1	لَهَا احْتِسَابَ
u'لَهَا أحَدٌ':Subject, #1: 1	لَهَا أَحَدُ
u'لَهَا إِحْرَامٌ':Subject, #6: 6	لَهَا أَحَدٌ
u'لَهَا إِحْرَامٌ':Subject, #1: 1	لَهَا إحْرَامٌ
u'لَهَا أَحْسَنُ':Subject, #1: 1	لَهَا الْإِحْرَامُ
u'لَهَا أَحْكَامٌ':Predicate, #1: 1	لَهَا أَحْسَنُ
u'لَهَا أَحْكَامٌ':Subject, #1: 1	لَهَا أَحْكَامَ
u'لَهَا أَحْكَامٌ':Subject, #1: 1	لَهَا أَحْكَامُهُ
u'لَهَا أَحْكَامٌ':Subject, #2: 2	لَهَا أَحْكَامٌ
u'لَهَا أَحْوالٌ':Subject, #3: 3	لَهَا أَحْكَامُ
u'لَهَا أحْوَالٌ':Subject, #1: 1	لَهَا أَحْوَالٌ
u'لَهَا أَخٌ':Subject, #1: 1	لَهَا أَحْوَالٌ
u'لَهَا أُخْتٌ':Subject, #5: 5	لَهَا أَخٌ
u'لَهَا اِخْتِصَاصٌ':Subject, #5: 5	لَهَا أُخْتٌ
u'لَهَا اِخْتِيَارٌ':Subject, #2: 2	لَهَا اخْتِصَاصٌ
u'لَهَا أخْذٌ':Subject, #3: 3	لَهَا اخْتِيَارُ
u'لَهَا أخْذٌ':Subject, #2: 2	لَهَا أَخْذُهُ
u'لَهَا أخْذٌ':Subject, #3: 3	لَهَا الْأَخْذُ
u'لَهَا آخِرَةٌ':Subject, #8: 8	لَهَا أَخْذُ
u'لَهَا إِخْلاَصٌ':Predicate, #1: 1	لَهَا آخِرَةٌ
u'لَهَا أَدَاءٌ':Subject, #1: 1	لَهَا الْإِخْلَاصَ
u'لَهَا أَدْوارٌ':Subject, #4: 4	لَهَا أَدَاءُ
u'لَهَا أَذَانٌ':Subject, #1: 1	لَهَا أَدْوَارٌ
u'لَهَا أَذَانٌ':Subject, #1: 1	لَهَا أَذَانُ
u'لَهَا إِذْنٌ':Predicate, #2: 2	لَهَا أَذَانٌ
u'لَهَا إِذْنٌ':Subject, #1: 1	لَهَا إذْنَ
u'لَهَا إِذْنٌ':Subject, #4: 4	لَهَا إذْنٌ
u'لَهَا أذْنَابٌ':Subject, #5: 5	لَهَا إذْنُ
u'لَهَا أَذْنَابٌ':Subject, #1: 1	لَهَا أَذْنَابٌ
u'لَهَا أرْبَابٌ':Subject, #1: 1	لَهَا أَذْنَابٌ
u'لَهَا أَرْبَعُ':Subject, #1: 1	لَهَا أَرْبَابٌ
u'لَهَا أَرْبَعَةٌ':Predicate, #8: 8	لَهَا أَرْبَعُ
u'لَهَا أَرْبَعَةٌ':Subject, #18: 18	لَهَا أَرْبَعَةَ
u'لَهَا أَرْبَعَةٌ':Subject, #12: 12	لَهَا أَرْبَعَةُ
u'لَهَا اِرْتِبَاطٌ':Subject, #1: 1	لَهَا أَرْبَعَةٌ
u'لَهَا اِرْتِكَابٌ':Subject, #1: 1	لَهَا ارْتِبَاطٌ
u'لَهَا إِرْثٌ':Subject, #1: 1	لَهَا ارْتِكَابُ
u'لَهَا أُرْجُوحَةٌ':Subject, #1: 1	لَهَا الْإِرْثُ
u'لَهَا إِرْسَالٌ':Subject, #1: 1	لَهَا أُرْجُوحَةٌ
u'لَهَا أرْضٌ':Subject, #1: 1	لَهَا إرْسَالُ
u'لَهَا أرْضٌ':Subject, #1: 1	لَهَا أَرْضٌ
u'لَهَا أَرْكانٌ':Subject, #2: 2	لَهَا أَرْضُ
u'لَهَا أَرْكانٌ':Subject, #1: 1	لَهَا أَرْكَانٌ
u'لَهَا أَرْكَانٌ':Subject, #1: 1	لَهَا أَرْكَانُ
u'لَهَا أَرْكَانٌ':Subject, #1: 1	لَهَا أَرْكَانٌ
u'لَهَا إِزَارٌ':Predicate, #1: 1	لَهَا أَرْكَانُ
u'لَهَا إِزَارٌ':Subject, #1: 1	لَهَا الْإِزَارَ
u'لَهَا أسْبَابٌ':Subject, #3: 3	لَهَا إزَارٌ
u'لَهَا أَسْبَابٌ':Subject, #2: 2	لَهَا أَسْبَابٌ
u'لَهَا اِسْتِحْقَاقٌ':Predicate, #2: 2	لَهَا أَسْبَابٌ
u'لَهَا اِسْتِحْقَاقٌ':Subject, #1: 1	لَهَا اسْتِحْقَاقَ
u'لَهَا اِسْتِعْمالٌ':Subject, #1: 1	لَهَا اسْتِحْقَاقُ
u'لَهَا اِسْتِعْمالٌ':Subject, #1: 1	لَهَا اسْتِعْمَالٌ
u'لَهَا اِسْتِلْحاق':Subject, #1: 1	لَهَا اسْتِعْمَالُهُ
u'لَهَا اِسْمٌ':Subject, #1: 1	لَهَا اسْتِلْحَاقٌ
u'لَهَا اِسْمٌ':Subject, #1: 1	لَهَا اسْمُهُ
u'لَهَا أَسْماءٌ':Subject, #3: 3	لَهَا اسْمٌ
u'لَهَا أَسْماءٌ':Subject, #1: 1	لَهَا أَسْمَاءٌ
u'لَهَا إِسْنادٌ':Subject, #2: 2	لَهَا أَسْمَاءُ
u'لَهَا أُسْوَةٌ':Subject, #2: 2	لَهَا إسْنَادٌ
u'لَهَا أسْوَد':Subject, #1: 1	لَهَا أُسْوَةٌ
u'لَهَا إشارَة':Subject, #1: 1	لَهَا أَسْوَدُ
u'لَهَا أَشَدُّ':Predicate, #4: 4	لَهَا إشَارَةٌ
u'لَهَا أَشْيَاءٌ':Predicate, #1: 1	لَهَا أَشَدَّ
u'لَهَا أُصْبُعٌ':Subject, #1: 1	لَهَا أَشْيَاءَ
u'لَهَا أَصْحَابٌ':Subject, #1: 1	لَهَا أُصْبُعٌ
u'لَهَا أًصْلٌ':Predicate, #1: 1	لَهَا أَصْحَابُ
u'لَهَا أًصْلٌ':Subject, #1: 1	لَهَا أَصْلاً
u'لَهَا أُصولٌ':Subject, #20: 20	لَهَا أَصْلٌ
u'لَهَا إضافَةٌ':Subject, #2: 2	لَهَا أُصُولٌ
u'لَهَا اِضْطِرابٌ':Subject, #1: 1	لَهَا الْإِضَافَةُ
u'لَهَا إِطاعَةٌ':Subject, #1: 1	لَهَا اضْطِرَابُ
u'لَهَا اِطِّلاعٌ':Subject, #2: 2	لَهَا إطَاعَتُهُ
u'لَهَا إِطْلاقٌ':Predicate, #1: 1	لَهَا اطِّلَاعٌ
u'لَهَا إِطْلاقٌ':Subject, #1: 1	لَهَا إطْلَاقَ
u'لَهَا أَطْوَاقٌ':Subject, #2: 2	لَهَا إطْلَاقُ
u'لَهَا اِعْتِمادٌ':Subject, #1: 1	لَهَا أَطْوَاقٌ
u'لَهَا أَعْضَاءٌ':Subject, #2: 2	لَهَا اعْتِمَادُهُ
u'لَهَا أَعْلاَمٌ':Subject, #1: 1	لَهَا الْأَعْضَاءُ
u'لَهَا أَعْلاَمٌ':Subject, #3: 3	لَهَا أَعْلَامٌ
u'لَهَا أَعْوَادٌ':Subject, #3: 3	لَهَا أَعْلاَمٌ
u'لَهَا أَغْصَانٌ':Subject, #1: 1	لَهَا أَعْوَادٌ
u'لَهَا أَغْنِيَاء':Subject, #1: 1	لَهَا أَغْصَانٌ
u'لَهَا إفْسَادٌ':Predicate, #2: 2	لَهَا الْأَغْنِيَاءُ
u'لَهَا إِفْطارٌ':Subject, #2: 2	لَهَا الْإِفْسَادَ
u'لَهَا أَفْهَامٌ':Subject, #2: 2	لَهَا الْإِفْطَارُ
u'لَهَا أَفْئِدَةٌ':Subject, #1: 1	لَهَا أَفْهَامٌ
u'لَهَا أقارب':Subject, #1: 1	لَهَا أَفْئِدَةُ
u'لَهَا إقامَةٌ':Subject, #4: 4	لَهَا أَقَارِبُ
u'لَهَا إقامَةٌ':Subject, #1: 1	لَهَا إقَامَتُهُ
u'لَهَا إقامَةٌ':Subject, #1: 1	لَهَا الْإِقَامَةُ
u'لَهَا إقْدَامٌ':Subject, #2: 2	لَهَا إقَامَةُ
u'لَهَا أقْرَبُ':Subject, #1: 1	لَهَا الْإِقْدَامُ
u'لَهَا أقَلُّ':Predicate, #1: 1	لَهَا أَقْرَبُ
u'لَهَا أقَلُّ':Predicate, #5: 5	لَهَا أَقَلَّ
u'لَهَا أقَلُّ':Subject, #5: 5	لَهَا الْأَقَلَّ
u'لَهَا أقَلُّ':Subject, #1: 1	لَهَا أَقَلُّ
u'لَهَا أَكْثَرُ':Predicate, #8: 8	لَهَا الْأَقَلُّ
u'لَهَا أَكْثَرُ':Predicate, #20: 20	لَهَا أَكْثَرَ
u'لَهَا أَكْثَرُ':Subject, #3: 3	لَهَا الْأَكْثَرَ
u'لَهَا أكل':Subject, #7: 7	لَهَا أَكْثَرُ
u'لَهَا أَكْلٌ':Subject, #1: 1	لَهَا أَكْلُ
u'لَهَا أكل':Subject, #1: 1	لَهَا أَكْلُ
u'لَهَا أَكْلٌ':Subject, #3: 3	لَهَا أَكْلُهُ
u'لَهَا آلةٌ':Subject, #3: 3	لَهَا أَكْلُهُ
u'لَهَا آلةٌ':Subject, #1: 1	لَهَا الْآلَةُ
u'لَهَا آلةٌ':Subject, #2: 2	لَهَا آلَةُ
u'لَهَا ألف':Predicate, #3: 3	لَهَا آلَةٌ
u'لَهَا ألْفٌ':Predicate, #1: 1	لَهَا الْأَلْفَ
u'لَهَا أَلْفٌ':Predicate, #1: 1	لَهَا الْأَلْفَ
u'لَهَا ألف':Predicate, #1: 1	لَهَا الْأَلْفَ
u'لَهَا ألْفٌ':Predicate, #1: 1	لَهَا أَلْفَ
u'لَهَا أَلْفٌ':Predicate, #1: 1	لَهَا أَلْفَ
u'لَهَا ألْفٌ':Subject, #1: 1	لَهَا أَلْفَ
u'لَهَا أَلْفٌ':Subject, #1: 1	لَهَا أَلْفٌ
u'لَهَا ألف':Subject, #1: 1	لَهَا أَلْفٌ
u'لَهَا ألْفٌ':Subject, #2: 2	لَهَا أَلْفُ
u'لَهَا أَلْفٌ':Subject, #2: 2	لَهَا أَلْفُ
u'لَهَا ألف':Subject, #2: 2	لَهَا أَلْفُ
u'لَهَا ألْفٌ':Subject, #7: 7	لَهَا الْأَلْفُ
u'لَهَا أَلْفٌ':Subject, #7: 7	لَهَا الْأَلْفُ
u'لَهَا أَلْفَاظٌ':Subject, #7: 7	لَهَا الْأَلْفُ
u'لَهَا ألْيَةٌ':Subject, #1: 1	لَهَا أَلْفَاظٌ
u'لَهَا أُمٌّ':Subject, #2: 2	لَهَا أَلْيَةٌ
u'لَهَا أُمٌّ':Subject, #30: 30	لَهَا أُمُّ
u'لَهَا إمَامٌ':Subject, #5: 5	لَهَا أُمٌّ
u'لَهَا إمَامٌ':Subject, #2: 2	لَهَا إمَامٌ
u'لَهَا إمَامَةٌ':Subject, #8: 8	لَهَا الْإِمَامُ
u'لَهَا أمَانٌ':Subject, #1: 1	لَهَا الْإِمَامَةُ
u'لَهَا أمَةٌ':Predicate, #1: 1	لَهَا أَمَانٌ
u'لَهَا أمَةٌ':Subject, #1: 1	لَهَا أَمَةَ
u'لَهَا أمَةٌ':Subject, #1: 1	لَهَا الْأَمَةُ
u'لَهَا أَمْتِعَةٌ':Subject, #1: 1	لَهَا أَمَةٌ
u'لَهَا أمثال':Subject, #2: 2	لَهَا أَمْتِعَةٌ
u'لَهَا أَمْثَالٌ':Subject, #1: 1	لَهَا الْأَمْثَالُ
u'لَهَا أَمْثَالٌ':Subject, #1: 1	لَهَا الْأَمْثَالُ
u'لَهَا أَمْرٌ':Predicate, #2: 2	لَهَا أَمْثَالٌ
u'لَهَا أَمْرٌ':Predicate, #1: 1	لَهَا الْأَمْرَ
u'لَهَا أَمْرٌ':Subject, #2: 2	لَهَا أَمْرَ
u'لَهَا أَمْرٌ':Subject, #2: 2	لَهَا الْأَمْرُ
u'لَهَا أَمْرٌ':Subject, #3: 3	لَهَا أَمْرٌ
u'لَهَا اِمْرَأَةٌ':Subject, #3: 3	لَهَا أَمْرُ
u'لَهَا إِمْساكٌ':Subject, #5: 5	لَهَا امْرَأَةٌ
u'لَهَا أُمَّهَاتٌ':Subject, #2: 2	لَهَا إمْسَاكُ
u'لَهَا إِناءٌ':Predicate, #1: 1	لَهَا أُمَّهَاتٌ
u'لَهَا إِناءٌ':Subject, #5: 5	لَهَا الْإِنَاءَ
u'لَهَا إِنْباءٌ':Subject, #1: 1	لَهَا الْإِنَاءُ
u'لَهَا اِنْتِظارٌ':Subject, #1: 1	لَهَا إنْبَاءٌ
u'لَهَا إِنْذارٌ':Subject, #1: 1	لَهَا انْتِظَارُ
u'لَهَا إِنْسانٌ':Subject, #1: 1	لَهَا الْإِنْذَارُ
u'لَهَا اِنْصِبابٌ':Subject, #1: 1	لَهَا الإِنْسَانُ
u'لَهَا إِنْفاقٌ':Subject, #2: 2	لَهَا انْصِبَابُ
u'لَهَا أَنْفُسٌ':Predicate, #1: 1	لَهَا الْإِنْفَاقُ
u'لَهَا أَنْفَعُ':Predicate, #1: 1	لَهَا أَنْفُسَ
u'لَهَا اِنْقِضاءٌ':Subject, #1: 1	لَهَا الْأَنْفَعَ
u'لَهَا إِنْكارٌ':Subject, #1: 1	لَهَا انْقِضَاءٌ
u'لَهَا أُنْمُلَةٌ':Subject, #1: 1	لَهَا إِنْكَارٌ
u'لَهَا أَنْيَابٌ':Subject, #3: 3	لَهَا أُنْمُلَةٌ
u'لَهَا أهْلٌ':Predicate, #3: 3	لَهَا أَنْيَابٌ
u'لَهَا أهْلٌ':Subject, #2: 2	لَهَا أَهْلَ
u'لَهَا أهْلٌ':Subject, #3: 3	لَهَا أَهْلٌ
u'لَهَا أَهْلِيٌّ':Subject, #7: 7	لَهَا أَهْلُ
u'لَهَا أهْلِيَّةٌ':Subject, #1: 1	لَهَا الْأَهْلِيَّةُ
u'لَهَا أوَابِدُ':Predicate, #1: 1	لَهَا الْأَهْلِيَّةُ
u'لَهَا أوَابِدُ':Subject, #1: 1	لَهَا أَوَابِدَ
u'لَهَا أوْسَطُ':Predicate, #1: 1	لَهَا أَوَابِدُ
u'لَهَا أَوْكَس':Subject, #1: 1	لَهَا أَوْسَطَ
u'لَهَا أَوَّلُ':Subject, #2: 2	لَهَا الْأَوْكَسُ
u'لَهَا أَوْلاَدٌ':Predicate, #1: 1	لَهَا الْأَوَّلُ
u'لَهَا أَوْلاَدٌ':Subject, #2: 2	لَهَا الْأَوْلَادَ
u'لَهَا أَوْلاَدٌ':Subject, #2: 2	لَهَا الْأَوْلَادُ
u'لَهَا أَوْلِيَاءُ':Subject, #2: 2	لَهَا أَوْلَادٌ
u'لَهَا أيَّامٌ':Subject, #3: 3	لَهَا أَوْلِيَاءُ
u'لَهَا أَيَّامٌ':Subject, #1: 1	لَهَا الْأَيَّامُ
u'لَهَا أيَّامٌ':Subject, #1: 1	لَهَا الْأَيَّامُ
u'لَهَا أَيَّامٌ':Subject, #1: 1	لَهَا أَيَّامُ
u'لَهَا أيَّامٌ':Subject, #1: 1	لَهَا أَيَّامُ
u'لَهَا أَيَّامٌ':Subject, #2: 2	لَهَا أَيَّامٌ
u'لَهَا إيقَاعٌ':Subject, #2: 2	لَهَا أَيَّامٌ
u'لَهَا إيقَاعٌ':Subject, #2: 2	لَهَا الْإِيقَاعُ
u'لَهَا أَيْنٌ':Predicate, #2: 2	لَهَا إيقَاعُ
u'لَهَا بَابٌ':Predicate, #1: 1	لَهَا أَيْنَ
u'لَهَا بَابٌ':Subject, #1: 1	لَهَا الْبَابَ
u'لَهَا بَابٌ':Subject, #1: 1	لَهَا بَابُ
u'لَهَا باقِي':Predicate, #8: 8	لَهَا بَابٌ
u'لَهَا بالٌ':Predicate, #3: 3	لَهَا الْبَاقِيَ
u'لَهَا بَالٌ':Predicate, #2: 2	لَهَا بَالاً
u'لَهَا بالٌ':Subject, #2: 2	لَهَا بَالاً
u'لَهَا بَالٌ':Subject, #2: 2	لَهَا بَالٌ
u'لَهَا بَائِعٌ':Subject, #2: 2	لَهَا بَالٌ
u'لَهَا بُدّ':Subject, #1: 1	لَهَا الْبَائِعُ
u'لَهَا بَدَلٌ':Predicate, #4: 4	لَهَا بُدٌّ
u'لَهَا بَدَلٌ':Subject, #1: 1	لَهَا الْبَدَلَ
u'لَهَا بَدَلٌ':Subject, #1: 1	لَهَا الْبَدَلُ
u'لَهَا بَدَلٌ':Subject, #1: 1	لَهَا بَدَلُ
u'لَهَا بَدَلٌ':Subject, #1: 1	لَهَا بَدَلُهُ
u'لَهَا بدنة':Subject, #9: 9	لَهَا بَدَلٌ
u'لَهَا بِرٌّ':Subject, #1: 1	لَهَا بَدَنَةٌ
u'لَهَا بُرْء':Subject, #1: 1	لَهَا بِرٌّ
u'لَهَا بُراقٌ':Subject, #1: 1	لَهَا الْبُرْءُ
u'لَهَا بَرَكَةٌ':Subject, #1: 1	لَهَا الْبُرَاقُ
u'لَهَا بُرْهانٌ':Subject, #2: 2	لَهَا بَرَكَةُ
u'لَهَا بُرْهَانٌ':Subject, #1: 1	لَهَا بُرْهَانٌ
u'لَهَا بَريمٌ':Subject, #1: 1	لَهَا بُرْهَانٌ
u'لَهَا بَريمٌ':Subject, #1: 1	لَهَا بَرِيمٌ
u'لَهَا بِصارَة':Subject, #1: 1	لَهَا بَرِيمُ
u'لَهَا بَطَلٌ':Predicate, #1: 1	لَهَا بِصَارَةٌ
u'لَهَا بَعْضٌ':Predicate, #2: 2	لَهَا بَطَلَ
u'لَهَا بَعْضٌ':Subject, #2: 2	لَهَا بَعْضَ
u'لَهَا بَعْضٌ':Subject, #2: 2	لَهَا الْبَعْضُ
u'لَهَا بَعْلٌ':Subject, #5: 5	لَهَا بَعْضُ
u'لَهَا بَعيرٌ':Subject, #2: 2	لَهَا بَعْلٌ
u'لَهَا بَغْلٌ':Subject, #1: 1	لَهَا بَعِيرٌ
u'لَهَا بَقاءٌ':Subject, #2: 2	لَهَا بَغْلَةٌ
u'لَهَا بُكاءٌ':Subject, #2: 2	لَهَا الْبَقَاءُ
u'لَهَا بَكَرٌ':Subject, #1: 1	لَهَا الْبُكَاءُ
u'لَهَا بَكْرَةٌ':Subject, #1: 1	لَهَا بَكَرٌ
u'لَهَا بَليدٌ':Subject, #1: 1	لَهَا بَكْرَةٌ
u'لَهَا بِنَاءٌ':Subject, #1: 1	لَهَا بَلِيدَةُ
u'لَهَا بِنْتٌ':Subject, #3: 3	لَهَا الْبِنَاءُ
u'لَهَا بِنْتٌ':Subject, #1: 1	لَهَا الْبِنْتُ
u'لَهَا بِنْتٌ':Subject, #1: 1	لَهَا بِنْتُ
u'لَهَا بِنْيَةٌ':Subject, #3: 3	لَهَا بِنْتٌ
u'لَهَا بَوَاطِنُ':Predicate, #1: 1	لَهَا بِنْيَةٌ
u'لَهَا بِئْرٌ':Subject, #1: 1	لَهَا بَوَاطِنَ
u'لَهَا بَيَانٌ':Subject, #1: 1	لَهَا بِئْرُ
u'لَهَا بَيْتٌ':Subject, #1: 1	لَهَا بَيَانُهُ
u'لَهَا بَيْتٌ':Subject, #1: 1	لَهَا بَيْتٌ
u'لَهَا بَيْضاء':Subject, #2: 2	لَهَا بَيْتُ
u'لَهَا بَيْعٌ':Subject, #1: 1	لَهَا الْبَيْضَاءُ
u'لَهَا بَيْعٌ':Subject, #2: 2	لَهَا الْبَيْعُ
u'لَهَا بَيْنٌ':Predicate, #2: 2	لَهَا بَيْعُهُ
u'لَهَا بَيِّنَةٌ':Subject, #5: 5	لَهَا بَيْنَ
u'لَهَا بَيِّنَةٌ':Subject, #15: 15	لَهَا بَيِّنَةٌ
u'لَهَا تَابِعٌ':Subject, #1: 1	لَهَا الْبَيِّنَةُ
u'لَهَا تَأْثِيرٌ':Subject, #2: 2	لَهَا تَابِعٌ
u'لَهَا تَأْخِيرٌ':Predicate, #6: 6	لَهَا تَأْثِيرٌ
u'لَهَا تَأْخِيرٌ':Subject, #1: 1	لَهَا التَّأْخِيرَ
u'لَهَا تَأْخِيرٌ':Subject, #1: 1	لَهَا تَأْخِيرُ
u'لَهَا تَأْخِيرٌ':Subject, #2: 2	لَهَا التَّأْخِيرُ
u'لَهَا تبعة':Subject, #2: 2	لَهَا تَأْخِيرُهُ
u'لَهَا تَبِعَةٌ':Subject, #1: 1	لَهَا تَبِعَةٌ
u'لَهَا تَجَمُّلٌ':Subject, #1: 1	لَهَا تَبِعَةٌ
u'لَهَا تَحْرِيمٌ':Subject, #1: 1	لَهَا التَّجَمُّلُ
u'لَهَا تَحْكِيمٌ':Subject, #3: 3	لَهَا تَحْرِيمٌ
u'لَهَا تَحَلُّلٌ':Subject, #1: 1	لَهَا التَّحْكِيمُ
u'لَهَا تَحَلُّلٌ':Subject, #1: 1	لَهَا تَحَلُّلٌ
u'لَهَا تَحَوُّلٌ':Subject, #3: 3	لَهَا التَّحَلُّلُ
u'لَهَا تَحِيَّةٌ':Subject, #3: 3	لَهَا التَّحَوُّلُ
u'لَهَا تَخْصِيصٌ':Subject, #1: 1	لَهَا تَحِيَّةٌ
u'لَهَا تَخَطِّي':Predicate, #1: 1	لَهَا التَّخْصِيصُ
u'لَهَا تَرْتِيبٌ':Subject, #1: 1	لَهَا التَّخَطِّيَ
u'لَهَا تَرَدُّدٌ':Subject, #1: 1	لَهَا التَّرْتِيبُ
u'لَهَا تَرْطِيبٌ':Subject, #1: 1	لَهَا تَرَدُّدٌ
u'لَهَا تَرْغِيبٌ':Subject, #1: 1	لَهَا التَّرْطِيبُ
u'لَهَا تَرْكٌ':Subject, #1: 1	لَهَا التَّرْغِيبُ
u'لَهَا تَرْكٌ':Subject, #2: 2	لَهَا تَرْكُ
u'لَهَا تَرِكَةٌ':Subject, #2: 2	لَهَا تَرْكُهُ
u'لَهَا تَزَوُّجٌ':Subject, #1: 1	لَهَا تَرِكَةٌ
u'لَهَا تَزَوُّجٌ':Subject, #17: 17	لَهَا التَّزَوُّجُ
u'لَهَا تَزْوِيجٌ':Predicate, #1: 1	لَهَا تَزَوُّجُهُ
u'لَهَا تَزْوِيجٌ':Subject, #1: 1	لَهَا تَزْوِيجَ
u'لَهَا تَزَيُّنٌ':Subject, #4: 4	لَهَا تَزْوِيجُ
u'لَهَا تِسْعَةٌ':Predicate, #1: 1	لَهَا التَّزَيُّنُ
u'لَهَا تِسْعَةٌ':Subject, #1: 1	لَهَا تِسْعَةَ
u'لَهَا تِسْعَةٌ':Subject, #2: 2	لَهَا تِسْعَةُ
u'لَهَا تِسْعَةٌ':Subject, #3: 3	لَهَا تِسْعَةٌ
u'لَهَا تَشَبُّهٌ':Subject, #5: 5	لَهَا التِّسْعَةُ
u'لَهَا تَشْبِيهٌ':Subject, #1: 1	لَهَا تَشَبُّهٌ
u'لَهَا تَصَرُّفٌ':Predicate, #1: 1	لَهَا تَشْبِيهُ
u'لَهَا تَصَرُّفٌ':Subject, #1: 1	لَهَا التَّصَرُّفَ
u'لَهَا تَطْلِيقٌ':Subject, #8: 8	لَهَا التَّصَرُّفُ
u'لَهَا تَطْهِيرٌ':Subject, #3: 3	لَهَا التَّطْلِيقُ
u'لَهَا تَطْوِيلٌ':Subject, #1: 1	لَهَا تَطْهِيرُ
u'لَهَا تَعْبِيرٌ':Subject, #1: 1	لَهَا التَّطْوِيلُ
u'لَهَا تَعْظِيمٌ':Subject, #1: 1	لَهَا التَّعْبِيرُ
u'لَهَا تَعْظِيمٌ':Subject, #1: 1	لَهَا التَّعْظِيمُ
u'لَهَا تَعَلُّقٌ':Subject, #1: 1	لَهَا تَعْظِيمٌ
u'لَهَا تَعَلُّقٌ':Subject, #2: 2	لَهَا التَّعَلُّقُ
u'لَهَا تَعْلِيقٌ':Subject, #9: 9	لَهَا تَعَلُّقٌ
u'لَهَا تَعْلِيمٌ':Subject, #1: 1	لَهَا تَعْلِيقٌ
u'لَهَا تَعْيِينٌ':Subject, #2: 2	لَهَا تَعْلِيمُ
u'لَهَا تَغْسِيلٌ':Predicate, #1: 1	لَهَا تَعْيِينُ
u'لَهَا تَفْرِيقٌ':Subject, #1: 1	لَهَا تَغْسِيلَ
u'لَهَا تَقَدُّمٌ':Subject, #2: 2	لَهَا التَّفْرِيقُ
u'لَهَا تَقَدُّمٌ':Subject, #1: 1	لَهَا تَقَدُّمٌ
u'لَهَا تَقْديرٌ':Subject, #3: 3	لَهَا تَقَدُّمُ
u'لَهَا تَكْبيرٌ':Subject, #1: 1	لَهَا تَقْدِيرٌ
u'لَهَا تَكْبيرٌ':Subject, #1: 1	لَهَا تَكْبِيرٌ
u'لَهَا تَكْرارٌ':Subject, #2: 2	لَهَا التَّكْبِيرُ
u'لَهَا تَكَشُّفٌ':Subject, #1: 1	لَهَا التَّكْرَارُ
u'لَهَا تَكْليفٌ':Subject, #1: 1	لَهَا التَّكَشُّفُ
u'لَهَا تَلَفُّظٌ':Subject, #2: 2	لَهَا تَكْلِيفُهُ
u'لَهَا تَمٌّ':Predicate, #1: 1	لَهَا التَّلَفُّظُ
u'لَهَا تمام':Subject, #1: 1	لَهَا تَمَّ
u'لَهَا تَمامٌ':Subject, #2: 2	لَهَا تَمَامُ
u'لَهَا تَمْكِينٌ':Subject, #2: 2	لَهَا تَمَامُ
u'لَهَا تَمْييزٌ':Subject, #6: 6	لَهَا تَمْكِينُهُ
u'لَهَا تَنَاوُلٌ':Predicate, #10: 10	لَهَا تَمْيِيزٌ
u'لَهَا تَنجُّسٌ':Subject, #1: 1	لَهَا تَنَاوُلَ
u'لَهَا تَنْزِيلٌ':Subject, #1: 1	لَهَا التَّنَجُّسُ
u'لَهَا تَنْفِيذٌ':Subject, #1: 1	لَهَا التّنْزِيلُ
u'لَهَا تَهَيُّؤٌ':Subject, #1: 1	لَهَا تَنْفِيذٌ
u'لَهَا تَوابِعُ':Subject, #1: 1	لَهَا التَّهَيُّؤُ
u'لَهَا تَوَابِعُ':Subject, #2: 2	لَهَا تَوَابِعُ
u'لَهَا تَوْسِيعٌ':Subject, #2: 2	لَهَا تَوَابِعُ
u'لَهَا تَوْكِيلٌ':Predicate, #1: 1	لَهَا تَوْسِيعُ
u'لَهَا تَوْكِيلٌ':Subject, #1: 1	لَهَا التَّوْكِيلَ
u'لَهَا تَيَمُّمٌ':Subject, #2: 2	لَهَا التَّوْكِيلُ
u'لَهَا ثَابِتٌ':Subject, #2: 2	لَهَا التَّيَمُّمُ
u'لَهَا ثابتة':Subject, #1: 1	لَهَا ثَابِتَةٌ
u'لَهَا ثالِب':Subject, #1: 1	لَهَا ثَابِتَةٌ
u'لَهَا ثَالِثٌ':Predicate, #1: 1	لَهَا الثَّالِبُ
u'لَهَا ثَامِنٌ':Subject, #1: 1	لَهَا الثَّالِثَةَ
u'لَهَا ثَانِي':Predicate, #1: 1	لَهَا ثَامِنٌ
u'لَهَا ثَانِيَةٌ':Predicate, #1: 1	لَهَا الثَّانِيَةَ
u'لَهَا ثبات':Subject, #1: 1	لَهَا الثَّانِيَةَ
u'لَهَا ثبَاتٌ':Subject, #1: 1	لَهَا ثَبَاتٌ
u'لَهَا ثُبُوتٌ':Subject, #1: 1	لَهَا ثَبَاتٌ
u'لَهَا ثَدْيٌ':Subject, #1: 1	لَهَا ثُبُوتُهُ
u'لَهَا ثُغَاءٌ':Subject, #2: 2	لَهَا ثَدْيٌ
u'لَهَا ثِقَةٌ':Subject, #7: 7	لَهَا ثُغَاءٌ
u'لَهَا ثَلاثُ':Predicate, #1: 1	لَهَا ثِقَةٌ
u'لَهَا ثَلاثُ':Subject, #4: 4	لَهَا ثَلَاثَ
u'لَهَا ثَلاثُ':Subject, #1: 1	لَهَا الثَّلَاثُ
u'لَهَا ثَلاثُ':Subject, #1: 1	لَهَا ثَلاَثُ
u'لَهَا ثَلاثَةٌ':Predicate, #9: 9	لَهَا ثَلَاثُ
u'لَهَا ثَلاثَةٌ':Subject, #7: 7	لَهَا ثَلَاثَةَ
u'لَهَا ثَلاثَةٌ':Subject, #1: 1	لَهَا الثَّلَاثَةُ
u'لَهَا ثَلاثَةٌ':Subject, #28: 28	لَهَا ثَلَاثَةُ
u'لَهَا ثَمانِيَةٌ':Subject, #2: 2	لَهَا ثَلَاثَةٌ
u'لَهَا ثَمانِين':Predicate, #1: 1	لَهَا ثَمَانِيَةٌ
u'لَهَا ثَمَرٌ':Subject, #1: 1	لَهَا ثَمَانِينَ
u'لَهَا ثَمَرَةٌ':Subject, #4: 4	لَهَا ثَمَرٌ
u'لَهَا ثَمَنٌ':Subject, #5: 5	لَهَا ثَمَرَةٌ
u'لَهَا ثَمَنٌ':Subject, #1: 1	لَهَا الثَّمَنُ
u'لَهَا ثُمْنٌ':Subject, #1: 1	لَهَا ثَمَنٌ
u'لَهَا ثَوابٌ':Predicate, #1: 1	لَهَا ثُمْنُ
u'لَهَا ثَوابٌ':Subject, #1: 1	لَهَا ثَوَابَ
u'لَهَا ثَوْبٌ':Subject, #2: 2	لَهَا ثَوَابُ
u'لَهَا ثِيابٌ':Subject, #1: 1	لَهَا ثَوْبٌ
u'لَهَا جَارٌ':Subject, #1: 1	لَهَا ثِيَابُ
u'لَهَا جَارِي':Subject, #3: 3	لَهَا جَارٌ
u'لَهَا جَارِيَةٌ':Subject, #1: 1	لَهَا الْجَارِيَةُ
u'لَهَا جَازٌ':Predicate, #1: 1	لَهَا الْجَارِيَةُ
u'لَهَا جَائِزٌ':Subject, #14: 14	لَهَا جَازَ
u'لَهَا جُبّةٌ':Subject, #2: 2	لَهَا جَائِزٌ
u'لَهَا جراح':Subject, #2: 2	لَهَا الْجُبَّةُ
u'لَهَا جِرَاحٌ':Subject, #1: 1	لَهَا جِرَاحٌ
u'لَهَا جِرْمٌ':Subject, #1: 1	لَهَا جِرَاحٌ
u'لَهَا جُرْمٌ':Subject, #5: 5	لَهَا جِرْمٌ
u'لَهَا جَزَاءٌ':Subject, #7: 7	لَهَا جُرْمٌ
u'لَهَا جِسْمٌ':Subject, #2: 2	لَهَا جَزَاءٌ
u'لَهَا جفاف':Subject, #1: 1	لَهَا جِسْمٌ
u'لَهَا جَفَافٌ':Subject, #1: 1	لَهَا جَفَافٌ
u'لَهَا جِلْبَابٌ':Subject, #1: 1	لَهَا جَفَافٌ
u'لَهَا جلد':Subject, #2: 2	لَهَا جِلْبَابٌ
u'لَهَا جِلْدٌ':Subject, #1: 1	لَهَا الْجِلْدُ
u'لَهَا جُلُوسٌ':Subject, #1: 1	لَهَا الْجِلْدُ
u'لَهَا جَمَاعَةٌ':Subject, #1: 1	لَهَا الْجُلُوسُ
u'لَهَا جَمَاعَةٌ':Subject, #3: 3	لَهَا جَمَاعَةٌ
u'لَهَا جمع':Subject, #8: 8	لَهَا الْجَمَاعَةُ
u'لَهَا جَمْعٌ':Subject, #2: 2	لَهَا الْجَمْعُ
u'لَهَا جناح':Subject, #2: 2	لَهَا الْجَمْعُ
u'لَهَا جَنَاحٌ':Subject, #1: 1	لَهَا جَنَاحُ
u'لَهَا جِنْسٌ':Subject, #1: 1	لَهَا جَنَاحُ
u'لَهَا جُنُونٌ':Subject, #1: 1	لَهَا جِنْسٌ
u'لَهَا جهاز':Subject, #1: 1	لَهَا جُنُونٌ
u'لَهَا جِهَازٌ':Subject, #1: 1	لَهَا جِهَازٌ
u'لَهَا جِهَةٌ':Subject, #1: 1	لَهَا جِهَازٌ
u'لَهَا جِهَةٌ':Subject, #1: 1	لَهَا جِهَةٌ
u'لَهَا جَوَابٌ':Subject, #1: 1	لَهَا جِهَةُ
u'لَهَا جَيْبٌ':Subject, #4: 4	لَهَا جَوَابٌ
u'لَهَا جِيرَانٌ':Subject, #1: 1	لَهَا جَيْبٌ
u'لَهَا حاجَةٌ':Subject, #1: 1	لَهَا جِيرَانٌ
u'لَهَا حاجِزٌ':Subject, #1: 1	لَهَا حَاجَةٌ
u'لَهَا حارِثٌ':Subject, #1: 1	لَهَا حَاجِزٌ
u'لَهَا حارِسٌ':Subject, #1: 1	لَهَا الْحَارِثُ
u'لَهَا حاصِلٌ':Subject, #3: 3	لَهَا حَارِسٌ
u'لَهَا حاضِرٌ':Subject, #2: 2	لَهَا حَاصِلٌ
u'لَهَا حافِرٌ':Subject, #2: 2	لَهَا حَاضِرٌ
u'لَهَا حافِظٌ':Subject, #1: 1	لَهَا الْحَافِرُ
u'لَهَا حاكِمٌ':Subject, #2: 2	لَهَا حَافِظٌ
u'لَهَا حالٌ':Predicate, #3: 3	لَهَا الْحَاكِمُ
u'لَهَا حالٌ':Subject, #2: 2	لَهَا حَالَ
u'لَهَا حالٌ':Subject, #1: 1	لَهَا حَالُ
u'لَهَا حالَةٌ':Predicate, #2: 2	لَهَا حَالٌ
u'لَهَا حالَةٌ':Subject, #4: 4	لَهَا حَالَةَ
u'لَهَا حالَةٌ':Subject, #1: 1	لَهَا حَالَةٌ
u'لَهَا حَبٌّ':Subject, #1: 1	لَهَا حَالَةُ
u'لَهَا حَبْسٌ':Predicate, #1: 1	لَهَا الْحَبُّ
u'لَهَا حَبْسٌ':Predicate, #1: 1	لَهَا الْحَبْسَ
u'لَهَا حَبْسٌ':Subject, #1: 1	لَهَا حَبْسَ
u'لَهَا حَبيبٌ':Subject, #5: 5	لَهَا حَبْسُ
u'لَهَا حَجٌّ':Predicate, #1: 1	لَهَا حَبِيبَةُ
u'لَهَا حَجٌّ':Subject, #1: 1	لَهَا حَجَّكَ
u'لَهَا حُجَّةٌ':Subject, #1: 1	لَهَا الْحَجُّ
u'لَهَا حَجْرٌ':Subject, #1: 1	لَهَا حُجَّةٌ
u'لَهَا حَجْرٌ':Subject, #1: 1	لَهَا الْحَجْرُ
u'لَهَا حَجَلٌ':Predicate, #1: 1	لَهَا حَجْرٌ
u'لَهَا حَدٌّ':Predicate, #1: 1	لَهَا حَجَلَةً
u'لَهَا حَدٌّ':Subject, #1: 1	لَهَا حَدَّ
u'لَهَا حدب':Subject, #9: 9	لَهَا حَدٌّ
u'لَهَا حَدَبٌ':Subject, #2: 2	لَهَا حَدَبٌ
u'لَهَا حِدَّةٌ':Subject, #2: 2	لَهَا حَدَبٌ
u'لَهَا حُدودٌ':Subject, #1: 1	لَهَا حِدَّةٌ
u'لَهَا حُدودٌ':Subject, #1: 1	لَهَا الْحُدُودُ
u'لَهَا حَديثٌ':Predicate, #1: 1	لَهَا حُدُودٌ
u'لَهَا حَديثٌ':Subject, #2: 2	لَهَا الْحَدِيثَ
u'لَهَا حُرٌّ':Subject, #2: 2	لَهَا الْحَدِيثُ
u'لَهَا حَرامٌ':Subject, #2: 2	لَهَا حُرٌّ
u'لَهَا حِرْزٌ':Subject, #1: 1	لَهَا حَرَامٌ
u'لَهَا حَرَمٌ':Subject, #1: 1	لَهَا حِرْزٌ
u'لَهَا حُرْمَةٌ':Subject, #1: 1	لَهَا حَرَمٌ
u'لَهَا حُرْمَةٌ':Subject, #2: 2	لَهَا حُرْمَةٌ
u'لَهَا حُرِّيَّةٌ':Subject, #2: 2	لَهَا حُرْمَةُ
u'لَهَا حَرِيمٌ':Subject, #2: 2	لَهَا الْحُرِّيَّةُ
u'لَهَا حَسَكٌ':Subject, #11: 11	لَهَا حَرِيمٌ
u'لَهَا حِصَّةٌ':Subject, #1: 1	لَهَا حَسَكٌ
u'لَهَا حِصَّةٌ':Subject, #12: 12	لَهَا حِصَّةٌ
u'لَهَا حِصَّةٌ':Subject, #1: 1	لَهَا الْحِصَّةُ
u'لَهَا حَضَانَةٌ':Predicate, #1: 1	لَهَا حِصَّةُ
u'لَهَا حَضَانَةٌ':Subject, #2: 2	لَهَا الْحَضَانَةَ
u'لَهَا حَضَانَةٌ':Subject, #3: 3	لَهَا حَضَانَةُ
u'لَهَا حُضورٌ':Subject, #6: 6	لَهَا الْحَضَانَةُ
u'لَهَا حُضُورٌ':Subject, #1: 1	لَهَا الْحُضُورُ
u'لَهَا حُضورٌ':Subject, #1: 1	لَهَا الْحُضُورُ
u'لَهَا حُضُورٌ':Subject, #1: 1	لَهَا حُضُورٌ
u'لَهَا حُضورٌ':Subject, #1: 1	لَهَا حُضُورٌ
u'لَهَا حُضُورٌ':Subject, #1: 1	لَهَا حُضُورُهُ
u'لَهَا حَظٌّ':Subject, #1: 1	لَهَا حُضُورُهُ
u'لَهَا حَفٌّ':Subject, #4: 4	لَهَا حَظٌّ
u'لَهَا حَفِيرَةٌ':Subject, #1: 1	لَهَا حَفُّهُ
u'لَهَا حَقٌّ':Predicate, #1: 1	لَهَا حَفِيرَةٌ
u'لَهَا حَقٌّ':Subject, #6: 6	لَهَا حَقَّ
u'لَهَا حَقٌّ':Subject, #1: 1	لَهَا الْحَقُّ
u'لَهَا حَقٌّ':Subject, #28: 28	لَهَا حَقٌّ
u'لَهَا حُقوقٌ':Subject, #52: 52	لَهَا حَقُّ
u'لَهَا حُقُوقٌ':Subject, #1: 1	لَهَا حُقُوقُ
u'لَهَا حُقوقٌ':Subject, #1: 1	لَهَا حُقُوقُ
u'لَهَا حُقُوقٌ':Subject, #2: 2	لَهَا حُقُوقٌ
u'لَهَا حَقِيقٌ':Subject, #2: 2	لَهَا حُقُوقٌ
u'لَهَا حَقِيقَةٌ':Subject, #2: 2	لَهَا حَقِيقَةُ
u'لَهَا حَقِيقَةٌ':Subject, #2: 2	لَهَا حَقِيقَةُ
u'لَهَا حُكْمٌ':Predicate, #3: 3	لَهَا حَقِيقَةٌ
u'لَهَا حُكْمٌ':Subject, #4: 4	لَهَا حُكْمَ
u'لَهَا حُكْمٌ':Subject, #13: 13	لَهَا حُكْمٌ
u'لَهَا حُكْمٌ':Subject, #1: 1	لَهَا الْحُكْمُ
u'لَهَا حُكْمٌ':Subject, #3: 3	لَهَا حُكْمُهُ
u'لَهَا حكمة':Subject, #61: 61	لَهَا حُكْمُ
u'لَهَا حِكْمَةٌ':Subject, #1: 1	لَهَا حِكْمَةٌ
u'لَهَا حُكُومَةٌ':Subject, #1: 1	لَهَا حِكْمَةٌ
u'لَهَا حِلٌّ':Subject, #1: 1	لَهَا حُكُومَةٌ
u'لَهَا حُلَّةٌ':Subject, #1: 1	لَهَا الْحِلُّ
u'لَهَا حَلْقٌ':Subject, #1: 1	لَهَا حُلّةٌ
u'لَهَا حَلَقٌ':Subject, #1: 1	لَهَا الْحَلْقُ
u'لَهَا حَلْقٌ':Subject, #1: 1	لَهَا حَلَقٌ
u'لَهَا حَلَمَةٌ':Subject, #1: 1	لَهَا حَلْقُ
u'لَهَا حُلِيٌّ':Predicate, #1: 1	لَهَا حَلَمَةٌ
u'لَهَا حُلِيٌّ':Subject, #1: 1	لَهَا الْحُلِيَّ
u'لَهَا حَمَّامٌ':Subject, #1: 1	لَهَا حُلِيٌّ
u'لَهَا حَمَّامٌ':Subject, #2: 2	لَهَا الْحَمَّامُ
u'لَهَا حَمْحَم':Subject, #6: 6	لَهَا الْحَمَّامَاتُ
u'لَهَا حَمْحَمَة':Subject, #4: 4	لَهَا حَمْحَمَةٌ
u'لَهَا حَمْلٌ':Predicate, #4: 4	لَهَا حَمْحَمَةٌ
u'لَهَا حَمْلٌ':Subject, #1: 1	لَهَا الْحَمْلَ
u'لَهَا حَمْلٌ':Subject, #1: 1	لَهَا الْحَمْلُ
u'لَهَا حَمْلٌ':Subject, #1: 1	لَهَا حَمْلُ
u'لَهَا حِمْلٌ':Subject, #8: 8	لَهَا حَمْلٌ
u'لَهَا حِنْطَةٌ':Subject, #8: 8	لَهَا حِمْلٌ
u'لَهَا حول':Predicate, #1: 1	لَهَا حِنْطَةٌ
u'لَهَا حَوْلٌ':Predicate, #1: 1	لَهَا الْحَوْلَ
u'لَهَا حول':Subject, #1: 1	لَهَا الْحَوْلَ
u'لَهَا حَوْلٌ':Subject, #3: 3	لَهَا حَوْلٌ
u'لَهَا حَوْمَةٌ':Subject, #3: 3	لَهَا حَوْلٌ
u'لَهَا حَيْضٌ':Subject, #1: 1	لَهَا حَوْمَةٌ
u'لَهَا خَادِمٌ':Subject, #11: 11	لَهَا حَيْضٌ
u'لَهَا خَادِمٌ':Subject, #1: 1	لَهَا الْخَادِمُ
u'لَهَا خَارِجٌ':Predicate, #9: 9	لَهَا خَادِمٌ
u'لَهَا خَارِجٌ':Subject, #1: 1	لَهَا خَارِجَ
u'لَهَا خَاصِّيَّةٌ':Subject, #9: 9	لَهَا خَارِجٌ
u'لَهَا خَاضِعٌ':Predicate, #1: 1	لَهَا خَاصِّيَّةُ
u'لَهَا خَالٌ':Subject, #4: 4	لَهَا خَاضِعِينَ
u'لَهَا خَالٌ':Subject, #1: 1	لَهَا خَالٌ
u'لَهَا خام':Subject, #1: 1	لَهَا خَالَةٌ
u'لَهَا خِبْرَةٌ':Subject, #1: 1	لَهَا خَامَةٌ
u'لَهَا خَدَمٌ':Subject, #1: 1	لَهَا خِبْرَةٌ
u'لَهَا خدمة':Subject, #1: 1	لَهَا خَدَمٌ
u'لَهَا خِدْمَةٌ':Subject, #1: 1	لَهَا الْخِدْمَةُ
u'لَهَا خدمة':Subject, #1: 1	لَهَا الْخِدْمَةُ
u'لَهَا خِدْمَةٌ':Subject, #1: 1	لَهَا خِدْمَةٌ
u'لَهَا خَدِيج':Predicate, #1: 1	لَهَا خِدْمَةٌ
u'لَهَا خرق':Subject, #1: 1	لَهَا خَدِيجَةَ
u'لَهَا خَرْقٌ':Subject, #3: 3	لَهَا خَرْقٌ
u'لَهَا خُرُوجٌ':Predicate, #3: 3	لَهَا خَرْقٌ
u'لَهَا خُرُوجٌ':Subject, #6: 6	لَهَا الْخُرُوجَ
u'لَهَا خَصْمٌ':Subject, #36: 36	لَهَا الْخُرُوجُ
u'لَهَا خُصُومَةٌ':Subject, #1: 1	لَهَا خَصْمٌ
u'لَهَا خُصُومَةٌ':Subject, #1: 1	لَهَا الْخُصُومَةُ
u'لَهَا خِضَابٌ':Subject, #1: 1	لَهَا خُصُومَةٌ
u'لَهَا خضب':Subject, #2: 2	لَهَا الْخِضَابُ
u'لَهَا خَضْبٌ':Subject, #1: 1	لَهَا الْخَضْبُ
u'لَهَا خَضْرَاء':Subject, #1: 1	لَهَا الْخَضْبُ
u'لَهَا خَطٌّ':Predicate, #1: 1	لَهَا الْخَضْرَاءُ
u'لَهَا خَطْبٌ':Subject, #1: 1	لَهَا خَطَّ
u'لَهَا خَطَرٌ':Subject, #2: 2	لَهَا خَطْبٌ
u'لَهَا خَطْمٌ':Subject, #2: 2	لَهَا خَطَرٌ
u'لَهَا خلاص':Subject, #1: 1	لَهَا خَطْمٌ
u'لَهَا خَلاَصٌ':Subject, #1: 1	لَهَا الْخَلَاصُ
u'لَهَا خِلاَفٌ':Predicate, #1: 1	لَهَا الْخَلَاصُ
u'لَهَا خَلْفٌ':Subject, #1: 1	لَهَا خِلَافَ
u'لَهَا خَلَفٌ':Subject, #1: 1	لَهَا خَلْفٌ
u'لَهَا خِمَارٌ':Predicate, #2: 2	لَهَا خَلَفٌ
u'لَهَا خِمَارٌ':Subject, #1: 1	لَهَا الْخِمَارَ
u'لَهَا خِمَارٌ':Subject, #1: 1	لَهَا الْخِمَارُ
u'لَهَا خَمْرٌ':Predicate, #1: 1	لَهَا خِمَارُ
u'لَهَا خَمْرٌ':Subject, #1: 1	لَهَا الْخَمْرَ
u'لَهَا خَمْسٌ':Subject, #1: 1	لَهَا الْخَمْرُ
u'لَهَا خَمْسٌ':Subject, #1: 1	لَهَا خَمْسٌ
u'لَهَا خَمْسَةٌ':Predicate, #3: 3	لَهَا خَمْسُ
u'لَهَا خَمْسَةٌ':Subject, #3: 3	لَهَا خَمْسَةَ
u'لَهَا خَمْسَةٌ':Subject, #10: 10	لَهَا خَمْسَةٌ
u'لَهَا خَمْلٌ':Subject, #5: 5	لَهَا خَمْسَةُ
u'لَهَا خُوَارٌ':Subject, #1: 1	لَهَا خَمْلٌ
u'لَهَا خيار':Predicate, #4: 4	لَهَا خُوَارٌ
u'لَهَا خِيَارٌ':Predicate, #34: 34	لَهَا الْخِيَارَ
u'لَهَا خيار':Predicate, #34: 34	لَهَا الْخِيَارَ
u'لَهَا خِيَارٌ':Predicate, #7: 7	لَهَا خِيَارَ
u'لَهَا خيار':Subject, #7: 7	لَهَا خِيَارَ
u'لَهَا خِيَارٌ':Subject, #107: 107	لَهَا الْخِيَارُ
u'لَهَا خيار':Subject, #107: 107	لَهَا الْخِيَارُ
u'لَهَا خِيَارٌ':Subject, #10: 10	لَهَا خِيَارُ
u'لَهَا خيار':Subject, #10: 10	لَهَا خِيَارُ
u'لَهَا خِيَارٌ':Subject, #8: 8	لَهَا خِيَارٌ
u'لَهَا خِيرَةٌ':Predicate, #8: 8	لَهَا خِيَارٌ
u'لَهَا دَاخِلٌ':Subject, #1: 1	لَهَا الْخِيرَةَ
u'لَهَا دَارٌ':Predicate, #6: 6	لَهَا دَاخِلٌ
u'لَهَا دَارٌ':Subject, #2: 2	لَهَا الدَّارَ
u'لَهَا دَارٌ':Subject, #1: 1	لَهَا الدَّارُ
u'لَهَا دَالَّةٌ':Subject, #2: 2	لَهَا دَارٌ
u'لَهَا دَائِمٌ':Subject, #1: 1	لَهَا دَالَّةٌ
u'لَهَا دَخَلٌ':Predicate, #1: 1	لَهَا دَائِمٌ
u'لَهَا دَخْلٌ':Subject, #1: 1	لَهَا دَخَلَ
u'لَهَا دُخُولٌ':Subject, #4: 4	لَهَا دَخْلٌ
u'لَهَا دُخُولٌ':Subject, #1: 1	لَهَا الدُّخُولُ
u'لَهَا دُخُولٌ':Subject, #1: 1	لَهَا دُخُولُ
u'لَهَا دَرَاهِمُ':Predicate, #1: 1	لَهَا دُخُولُهُ
u'لَهَا دَرَاهِمُ':Subject, #3: 3	لَهَا دَرَاهِمَ
u'لَهَا دَرْبٌ':Subject, #1: 1	لَهَا دَرَاهِمُ
u'لَهَا دَرْبٌ':Subject, #1: 1	لَهَا الدَّرْبُ
u'لَهَا دَرَجَةٌ':Subject, #1: 1	لَهَا دَرْبٌ
u'لَهَا دَرَكٌ':Predicate, #1: 1	لَهَا دَرَجَاتٌ
u'لَهَا دُسْتُورٌ':Subject, #1: 1	لَهَا الدَّرَكَ
u'لَهَا دفع':Subject, #1: 1	لَهَا دُسْتُورٌ
u'لَهَا دَفْعٌ':Subject, #1: 1	لَهَا دَفْعُهُ
u'لَهَا دفع':Subject, #1: 1	لَهَا دَفْعُهُ
u'لَهَا دَفْعٌ':Subject, #3: 3	لَهَا دَفْعُ
u'لَهَا دَلالَةٌ':Subject, #3: 3	لَهَا دَفْعُ
u'لَهَا دَلْوٌ':Subject, #1: 1	لَهَا دَلَالَةٌ
u'لَهَا دَمٌ':Subject, #6: 6	لَهَا دَلْوٌ
u'لَهَا دَنٌّ':Subject, #8: 8	لَهَا دَمٌ
u'لَهَا دَناءةٌ':Subject, #1: 1	لَهَا الدَّنُّ
u'لَهَا دَواءٌ':Subject, #1: 1	لَهَا دَنَاءَةٌ
u'لَهَا دَوامٌ':Subject, #1: 1	لَهَا الدَّوَاءُ
u'لَهَا دُورٌ':Subject, #2: 2	لَهَا دَوَامٌ
u'لَهَا دَوْرٌ':Subject, #1: 1	لَهَا دُورٌ
u'لَهَا دونٌ':Predicate, #1: 1	لَهَا دَوْرٌ
u'لَهَا دونٌ':Predicate, #20: 20	لَهَا دُونَ
u'لَهَا دِيَةٌ':Subject, #2: 2	لَهَا دُونَهُنَّ
u'لَهَا دَيْنٌ':Subject, #1: 1	لَهَا دِيَاتٌ
u'لَهَا دِينٌ':Subject, #1: 1	لَهَا دَيْنٌ
u'لَهَا ذَبيحَةٌ':Subject, #2: 2	لَهَا دِينٌ
u'لَهَا ذَكاةٌ':Subject, #1: 1	لَهَا ذَبِيحَةٌ
u'لَهَا ذِكْرٌ':Subject, #1: 1	لَهَا ذَكَاةٌ
u'لَهَا ذكر':Subject, #13: 13	لَهَا ذِكْرٌ
u'لَهَا ذِكْرٌ':Subject, #1: 1	لَهَا ذِكْرُ
u'لَهَا ذِمَّةٌ':Subject, #1: 1	لَهَا ذِكْرُ
u'لَهَا ذِمَّةٌ':Subject, #1: 1	لَهَا ذِمَّةُ
u'لَهَا ذَنَبٌ':Subject, #2: 2	لَهَا ذِمَّةٌ
u'لَهَا ذُنُوبٌ':Subject, #2: 2	لَهَا ذَنَبٌ
u'لَهَا ذَهَبٌ':Predicate, #1: 1	لَهَا ذُنُوبٌ
u'لَهَا ذُؤابَةٌ':Subject, #1: 1	لَهَا الذَّهَبَ
u'لَهَا راتِب':Subject, #2: 2	لَهَا ذُؤَابَةٌ
u'لَهَا رَأْسٌ':Predicate, #1: 1	لَهَا رَاتِبَةٌ
u'لَهَا رَأْسٌ':Subject, #1: 1	لَهَا رَأْسَ
u'لَهَا رَأْيٌ':Subject, #5: 5	لَهَا رَأْسٌ
u'لَهَا رَبُّ':Subject, #8: 8	لَهَا رَأْيٌ
u'لَهَا رَبَضٌ':Subject, #1: 1	لَهَا الرَّبُّ
u'لَهَا رُبُعٌ':Predicate, #1: 1	لَهَا رَبَضٌ
u'لَهَا رُبْعٌ':Predicate, #2: 2	لَهَا رُبُعَ
u'لَهَا رُبْعٌ':Subject, #2: 2	لَهَا رُبْعَ
u'لَهَا رُبُعٌ':Subject, #1: 1	لَهَا الرُّبْعُ
u'لَهَا رُبْعٌ':Subject, #4: 4	لَهَا رُبُعُ
u'لَهَا رُبُعٌ':Subject, #4: 4	لَهَا رُبْعُ
u'لَهَا رَبْوَةٌ':Subject, #5: 5	لَهَا الرُّبُعُ
u'لَهَا رجعة':Subject, #1: 1	لَهَا رَبْوَةٌ
u'لَهَا رَجْعَةٌ':Subject, #1: 1	لَهَا رَجْعَةٌ
u'لَهَا رَجُلٌ':Subject, #1: 1	لَهَا رَجْعَةٌ
u'لَهَا رَجُلٌ':Subject, #11: 11	لَهَا رَجُلٌ
u'لَهَا رُجُوعٌ':Predicate, #2: 2	لَهَا الرَّجُلُ
u'لَهَا رُجُوعٌ':Subject, #2: 2	لَهَا الرُّجُوعَ
u'لَهَا رَحِمٌ':Subject, #13: 13	لَهَا الرُّجُوعُ
u'لَهَا رُخْصَةٌ':Predicate, #1: 1	لَهَا رَحِمٌ
u'لَهَا رَدٌّ':Predicate, #2: 2	لَهَا الرُّخْصَةَ
u'لَهَا رَدٌّ':Subject, #1: 1	لَهَا رَدَّ
u'لَهَا رَدٌّ':Subject, #1: 1	لَهَا الرَّدُّ
u'لَهَا رَدٌّ':Subject, #1: 1	لَهَا رَدٌّ
u'لَهَا رَسْمٌ':Predicate, #2: 2	لَهَا رَدُّ
u'لَهَا رَسْمٌ':Subject, #2: 2	لَهَا رَسْمَ
u'لَهَا رَسْمٌ':Subject, #16: 16	لَهَا رَسْمُ
u'لَهَا رَسُولٌ':Predicate, #1: 1	لَهَا رَسْمٌ
u'لَهَا رَسُولٌ':Subject, #2: 2	لَهَا رَسُولَ
u'لَهَا رُسُومٌ':Subject, #81: 81	لَهَا رَسُولُ
u'لَهَا رَشاشٌ':Subject, #2: 2	لَهَا رُسُومٌ
u'لَهَا رِعايَةٌ':Subject, #1: 1	لَهَا رَشَاشٌ
u'لَهَا رَغْبَةٌ':Subject, #1: 1	لَهَا رِعَايَتُهُ
u'لَهَا رَفْعٌ':Subject, #2: 2	لَهَا رَغْبَةٌ
u'لَهَا رَفْعٌ':Subject, #1: 1	لَهَا الرَّفْعُ
u'لَهَا رَفيعٌ':Subject, #3: 3	لَهَا رَفْعُ
u'لَهَا رُكْنٌ':Subject, #1: 1	لَهَا رَفِيعٌ
u'لَهَا رُكْن':Subject, #1: 1	لَهَا رُكْنٌ
u'لَهَا رُكوعٌ':Subject, #1: 1	لَهَا رُكْنٌ
u'لَهَا رُكوعٌ':Subject, #1: 1	لَهَا الرُّكُوعُ
u'لَهَا رواجع':Subject, #4: 4	لَهَا رُكُوعٌ
u'لَهَا رَوْشَن':Subject, #1: 1	لَهَا الرَّوَاجِعُ
u'لَهَا ريحٌ':Subject, #1: 1	لَهَا رَوْشَنٌ
u'لَهَا رَيْحانٌ':Subject, #2: 2	لَهَا رِيحٌ
u'لَهَا ريعٌ':Subject, #1: 1	لَهَا رَيْحَانَةُ
u'لَهَا زادٌ':Predicate, #1: 1	لَهَا رِيعٌ
u'لَهَا زاغٌ':Subject, #2: 2	لَهَا زَادَ
u'لَهَا زَكاةٌ':Predicate, #1: 1	لَهَا الزَّاغُ
u'لَهَا زُمَّلٌ':Subject, #1: 1	لَهَا الزَّكَاةَ
u'لَهَا زَوْجٌ':Predicate, #1: 1	لَهَا زُمّلٌ
u'لَهَا زَوْجٌ':Subject, #2: 2	لَهَا الزَّوْجَ
u'لَهَا زَوْجٌ':Subject, #102: 102	لَهَا زَوْجٌ
u'لَهَا زِيادَةٌ':Predicate, #34: 34	لَهَا الزَّوْجُ
u'لَهَا زِيادَةٌ':Predicate, #1: 1	لَهَا الزِّيَادَةَ
u'لَهَا زِيادَةٌ':Subject, #1: 1	لَهَا زِيَادَةَ
u'لَهَا زِيادَةٌ':Subject, #2: 2	لَهَا الزِّيَادَةُ
u'لَهَا زِيارَةٌ':Subject, #2: 2	لَهَا زِيَادَةُ
u'لَهَا زِيارَةٌ':Subject, #1: 1	لَهَا زِيَارَةُ
u'لَهَا زَيْدٌ':Subject, #1: 1	لَهَا زِيَارَتُهُ
u'لَهَا زَيْنَبٌ':Subject, #1: 1	لَهَا زَيْدٌ
u'لَهَا زِينَةٌ':Subject, #4: 4	لَهَا زَيْنَبُ
u'لَهَا ساباط':Subject, #1: 1	لَهَا الزِّينَةُ
u'لَهَا سَاعِي':Predicate, #1: 1	لَهَا سَابَاطٌ
u'لَهَا سَاقٌ':Subject, #2: 2	لَهَا السَّاعِيَ
u'لَهَا سَاقِي':Predicate, #1: 1	لَهَا سَاقٌ
u'لَهَا سانِيَةٌ':Subject, #2: 2	لَهَا سَاقِيَةً
u'لَهَا سَائِرٌ':Subject, #1: 1	لَهَا سَانِيَةٌ
u'لَهَا سَائِقٌ':Subject, #5: 5	لَهَا سَائِرُ
u'لَهَا سَائِلٌ':Predicate, #7: 7	لَهَا سَائِقٌ
u'لَهَا سَائِلٌ':Predicate, #1: 1	لَهَا سَائِلَةً
u'لَهَا سائِل':Subject, #1: 1	لَهَا سَائِلَةَ
u'لَهَا سَائِلٌ':Subject, #3: 3	لَهَا سَائِلٌ
u'لَهَا سَائِلٌ':Subject, #3: 3	لَهَا سَائِلٌ
u'لَهَا سَبَبٌ':Subject, #3: 3	لَهَا سَائِلَةٌ
u'لَهَا سبحة':Subject, #25: 25	لَهَا سَبَبٌ
u'لَهَا سَبْعٌ':Predicate, #2: 2	لَهَا سَبْحَةُ
u'لَهَا سَبْعٌ':Subject, #4: 4	لَهَا سَبْعَ
u'لَهَا سَبْعَةٌ':Subject, #5: 5	لَهَا سَبْعُ
u'لَهَا سَبْعَةٌ':Subject, #2: 2	لَهَا سَبْعَةٌ
u'لَهَا سَبِيلٌ':Predicate, #4: 4	لَهَا سَبْعَةُ
u'لَهَا سِتٌّ':Subject, #1: 1	لَهَا سَبِيلَ
u'لَهَا سِتٌّ':Subject, #1: 1	لَهَا سِتُّ
u'لَهَا سِتٌّ':Subject, #4: 4	لَهَا سِتَّةُ
u'لَهَا سَتْرٌ':Subject, #8: 8	لَهَا سِتَّةٌ
u'لَهَا سَتْرٌ':Subject, #1: 1	لَهَا السَّتْرُ
u'لَهَا سجدة':Subject, #1: 1	لَهَا سَتْرُهُ
u'لَهَا سَجْدَةٌ':Subject, #1: 1	لَهَا سَجْدَةٌ
u'لَهَا سَدٌّ':Subject, #1: 1	لَهَا سَجْدَةٌ
u'لَهَا سَدَنَةٌ':Subject, #1: 1	لَهَا سَدُّهُ
u'لَهَا سِرٌّ':Subject, #2: 2	لَهَا سَدَنَةٌ
u'لَهَا سَعْدَانٌ':Predicate, #1: 1	لَهَا سِرٌّ
u'لَهَا سَفَرٌ':Predicate, #1: 1	لَهَا السَّعْدَانَ
u'لَهَا سَفَرٌ':Subject, #1: 1	لَهَا السَّفَرَ
u'لَهَا سقط':Predicate, #3: 3	لَهَا السَّفَرُ
u'لَهَا سَقَطٌ':Predicate, #1: 1	لَهَا سَقَطَ
u'لَهَا سَقْفٌ':Subject, #1: 1	لَهَا سَقَطَ
u'لَهَا سُكَّانٌ':Subject, #2: 2	لَهَا سَقْفٌ
u'لَهَا سِكَكٌ':Subject, #1: 1	لَهَا سُكَّانٌ
u'لَهَا سلام':Subject, #1: 1	لَهَا سِكَكٌ
u'لَهَا سَلاَمٌ':Subject, #1: 1	لَهَا سَلَامٌ
u'لَهَا سُلْطَانٌ':Subject, #1: 1	لَهَا سَلَامٌ
u'لَهَا سلمة':Subject, #2: 2	لَهَا السُّلْطَانُ
u'لَهَا سِنٌّ':Subject, #1: 1	لَهَا سَلَمَةُ
u'لَهَا سَنَامٌ':Subject, #2: 2	لَهَا سِنٌّ
u'لَهَا سُنَّةٌ':Subject, #1: 1	لَهَا سَنَامٌ
u'لَهَا سَنَةٌ':Subject, #13: 13	لَهَا سُنَّةٌ
u'لَهَا سَنَةٌ':Subject, #16: 16	لَهَا سَنَةٌ
u'لَهَا سُنَّةٌ':Subject, #1: 1	لَهَا السَّنَةُ
u'لَهَا سنن':Subject, #1: 1	لَهَا سُنَّةُ
u'لَهَا سهام':Subject, #1: 1	لَهَا سُنَنٌ
u'لَهَا سِهَامٌ':Subject, #1: 1	لَهَا سِهَامٌ
u'لَهَا سَهْمٌ':Subject, #1: 1	لَهَا سِهَامٌ
u'لَهَا سَهْمٌ':Subject, #2: 2	لَهَا سَهْمٌ
u'لَهَا سَواءٌ':Subject, #2: 2	لَهَا سَهْمُ
u'لَهَا سورٌ':Subject, #13: 13	لَهَا سَوَاءٌ
u'لَهَا سورٌ':Subject, #1: 1	لَهَا سُوَرٌ
u'لَهَا سُوقٌ':Subject, #5: 5	لَهَا سُورٌ
u'لَهَا سَيِّدٌ':Subject, #5: 5	لَهَا سُوقٌ
u'لَهَا شَابٌّ':Subject, #1: 1	لَهَا السَّيِّدُ
u'لَهَا شَاةٌ':Subject, #1: 1	لَهَا شَابٌّ
u'لَهَا شَاهِدٌ':Subject, #1: 1	لَهَا شَاةٌ
u'لَهَا شَاهِدٌ':Subject, #1: 1	لَهَا شَاهِدٌ
u'لَهَا شَاهِدَةٌ':Subject, #1: 1	لَهَا شَاهِدَةٌ
u'لَهَا شَبَهٌ':Subject, #1: 1	لَهَا شَاهِدَةٌ
u'لَهَا شُبَهٌ':Subject, #1: 1	لَهَا الشّبَهُ
u'لَهَا شَبَهٌ':Subject, #1: 1	لَهَا الشّبَهُ
u'لَهَا شُبْهَةٌ':Subject, #1: 1	لَهَا شَبَهٌ
u'لَهَا شجَاعٌ':Subject, #1: 1	لَهَا شُبْهَةُ
u'لَهَا شِرَاءٌ':Subject, #1: 1	لَهَا شُجَاعٌ
u'لَهَا شراك':Subject, #1: 1	لَهَا الشِّرَاءُ
u'لَهَا شِرَاكٌ':Subject, #1: 1	لَهَا شِرَاكٌ
u'لَهَا شَرَائِطُ':Subject, #1: 1	لَهَا شِرَاكٌ
u'لَهَا شِرْبٌ':Subject, #2: 2	لَهَا شَرَائِطُ
u'لَهَا شُرْبٌ':Subject, #17: 17	لَهَا شِرْبٌ
u'لَهَا شَرْطٌ':Subject, #3: 3	لَهَا شُرْبٌ
u'لَهَا شرف':Predicate, #3: 3	لَهَا شَرْطٌ
u'لَهَا شَرَفٌ':Predicate, #2: 2	لَهَا شَرَفَ
u'لَهَا شرف':Subject, #2: 2	لَهَا شَرَفَ
u'لَهَا شَرَفٌ':Subject, #3: 3	لَهَا شَرَفٌ
u'لَهَا شركة':Subject, #3: 3	لَهَا شَرَفٌ
u'لَهَا شَرِكَةٌ':Subject, #3: 3	لَهَا شَرِكَةُ
u'لَهَا شُرُوطٌ':Subject, #3: 3	لَهَا شَرِكَةُ
u'لَهَا شُرُوطٌ':Subject, #3: 3	لَهَا شُرُوطٌ
u'لَهَا شَطْرٌ':Subject, #6: 6	لَهَا شُرُوطُ
u'لَهَا شُعاعٌ':Subject, #1: 1	لَهَا الشَّطْرُ
u'لَهَا شُعَاعٌ':Subject, #1: 1	لَهَا شُعَاعٌ
u'لَهَا شَعْرٌ':Subject, #1: 1	لَهَا شُعَاعٌ
u'لَهَا شُعُورٌ':Subject, #1: 1	لَهَا شَعْرٌ
u'لَهَا شفعة':Subject, #1: 1	لَهَا شُعُورٌ
u'لَهَا شُفْعَةٌ':Subject, #1: 1	لَهَا الشُّفْعَةُ
u'لَهَا شِقٌّ':Subject, #1: 1	لَهَا الشُّفْعَةُ
u'لَهَا شَكْلٌ':Subject, #2: 2	لَهَا شِقٌّ
u'لَهَا شمس':Subject, #1: 1	لَهَا شَكْلُ
u'لَهَا شَمْسٌ':Subject, #1: 1	لَهَا الشَّمْسُ
u'لَهَا شَهَادَةٌ':Predicate, #1: 1	لَهَا الشَّمْسُ
u'لَهَا شَهَادَةٌ':Subject, #1: 1	لَهَا شَهَادَةَ
u'لَهَا شَهْرٌ':Subject, #1: 1	لَهَا شَهَادَةُ
u'لَهَا شَهْرٌ':Subject, #1: 1	لَهَا الشَّهْرُ
u'لَهَا شَهْوَةٌ':Subject, #1: 1	لَهَا شَهْرٌ
u'لَهَا شُهُودٌ':Subject, #4: 4	لَهَا شَهْوَةٌ
u'لَهَا شوَاهِدُ':Subject, #2: 2	لَهَا شُهُودٌ
u'لَهَا شَوَاهِدُ':Subject, #3: 3	لَهَا شَوَاهِدُ
u'لَهَا شَيْءٌ':Subject, #3: 3	لَهَا شَوَاهِدُ
u'لَهَا شِيَاهٌ':Subject, #34: 34	لَهَا شَيْءٌ
u'لَهَا شَيْخٌ':Subject, #1: 1	لَهَا شِيَاهُ
u'لَهَا صَاحِبٌ':Subject, #1: 1	لَهَا الشَّيْخُ
u'لَهَا صَاحِبٌ':Subject, #1: 1	لَهَا صَاحِبَةٌ
u'لَهَا صَافِي':Subject, #2: 2	لَهَا صَاحِبُ
u'لَهَا صَانِعٌ':Subject, #1: 1	لَهَا صَافِيَةُ
u'لَهَا صبر':Subject, #1: 1	لَهَا صَانِعٌ
u'لَهَا صَبْرٌ':Subject, #1: 1	لَهَا الصَّبْرُ
u'لَهَا صحبة':Subject, #1: 1	لَهَا الصَّبْرُ
u'لَهَا صُحْبَةٌ':Subject, #1: 1	لَهَا صُحْبَةٌ
u'لَهَا صِحَّةٌ':Subject, #1: 1	لَهَا صُحْبَةٌ
u'لَهَا صداق':Predicate, #1: 1	لَهَا صِحَّةُ
u'لَهَا صَدَاقٌ':Predicate, #11: 11	لَهَا الصَّدَاقَ
u'لَهَا صداق':Predicate, #11: 11	لَهَا الصَّدَاقَ
u'لَهَا صَدَاقٌ':Predicate, #4: 4	لَهَا صَدَاقَ
u'لَهَا صداق':Subject, #4: 4	لَهَا صَدَاقَ
u'لَهَا صَدَاقٌ':Subject, #11: 11	لَهَا صَدَاقُ
u'لَهَا صداق':Subject, #11: 11	لَهَا صَدَاقُ
u'لَهَا صَدَاقٌ':Subject, #12: 12	لَهَا الصَّدَاقُ
u'لَهَا صداق':Subject, #12: 12	لَهَا الصَّدَاقُ
u'لَهَا صَدَاقٌ':Subject, #9: 9	لَهَا صَدَاقٌ
u'لَهَا صَدْرٌ':Subject, #9: 9	لَهَا صَدَاقٌ
u'لَهَا صَدْرٌ':Subject, #1: 1	لَهَا صَدْرٌ
u'لَهَا صدقة':Subject, #1: 1	لَهَا صَدْرُ
u'لَهَا صَدَقَةٌ':Subject, #15: 15	لَهَا صَدَقَةٌ
u'لَهَا صدقة':Subject, #15: 15	لَهَا صَدَقَةٌ
u'لَهَا صَدَقَةٌ':Subject, #2: 2	لَهَا صَدَقَةُ
u'لَهَا صَرْفٌ':Subject, #2: 2	لَهَا صَدَقَةُ
u'لَهَا صَرْف':Subject, #1: 1	لَهَا صَرْفٌ
u'لَهَا صَرِيفٌ':Subject, #1: 1	لَهَا صَرْفٌ
u'لَهَا صَغِيرٌ':Predicate, #1: 1	لَهَا صَرِيفُ
u'لَهَا صِفَةٌ':Subject, #1: 1	لَهَا صَغِيرَةً
u'لَهَا صَفِيٌّ':Subject, #2: 2	لَهَا صِفَةُ
u'لَهَا صَلاَةٌ':Predicate, #4: 4	لَهَا صَفِيَّةُ
u'لَهَا صَلاَةٌ':Subject, #1: 1	لَهَا صَلَاةَ
u'لَهَا صَلاَةٌ':Subject, #10: 10	لَهَا الصَّلَاةُ
u'لَهَا صَلاَةٌ':Subject, #1: 1	لَهَا صَلَاةُ
u'لَهَا صَلاَحٌ':Subject, #3: 3	لَهَا الصَّلاَةُ
u'لَهَا صَلاَحِيَّةٌ':Subject, #1: 1	لَهَا صَلَاحٌ
u'لَهَا صُلْب':Predicate, #1: 1	لَهَا صَلَاحِيَّةُ
u'لَهَا صُلْبِيّ':Predicate, #1: 1	لَهَا صُلْبِيَّةً
u'لَهَا صَلْصَلَةٌ':Subject, #1: 1	لَهَا صُلْبِيَّةً
u'لَهَا صَنْدَلٌ':Subject, #1: 1	لَهَا صَلْصَلَةٌ
u'لَهَا صَوْبٌ':Predicate, #1: 1	لَهَا صَنْدَلَةٌ
u'لَهَا صَوْتٌ':Subject, #1: 1	لَهَا صَوْبَ
u'لَهَا صُورٌ':Subject, #4: 4	لَهَا صَوْتٌ
u'لَهَا صُوَرٌ':Subject, #1: 1	لَهَا صُوَرٌ
u'لَهَا صَوْمٌ':Subject, #1: 1	لَهَا صُوَرٌ
u'لَهَا صَوْمٌ':Subject, #1: 1	لَهَا الصَّوْمُ
u'لَهَا صِيَاحٌ':Subject, #2: 2	لَهَا صَوْمُ
u'لَهَا صِيَانَةٌ':Subject, #2: 2	لَهَا صِيَاحٌ
u'لَهَا صِيَغٌ':Subject, #1: 1	لَهَا صِيَانَةُ
u'لَهَا صِيغَةٌ':Predicate, #1: 1	لَهَا صِيَغٌ
u'لَهَا ضَابِطٌ':Subject, #1: 1	لَهَا صِيغَةَ
u'لَهَا ضِرَامٌ':Subject, #1: 1	لَهَا ضَابِطٌ
u'لَهَا ضَرَائِرُ':Subject, #1: 1	لَهَا ضِرَامُ
u'لَهَا ضَرَّةٌ':Subject, #1: 1	لَهَا ضَرَائِرُ
u'لَهَا ضَرَرٌ':Subject, #1: 1	لَهَا ضَرَّةٌ
u'لَهَا ضَرُورِيٌّ':Subject, #2: 2	لَهَا الضَّرَرُ
u'لَهَا ضِعْفٌ':Subject, #1: 1	لَهَا ضَرُورِيٌّ
u'لَهَا ضَمِنٌ':Predicate, #1: 1	لَهَا ضِعْفُ
u'لَهَا طَالِبٌ':Subject, #2: 2	لَهَا ضَمِنَ
u'لَهَا طَاهِرٌ':Predicate, #3: 3	لَهَا طَالِبٌ
u'لَهَا طَائِفٌ':Predicate, #1: 1	لَهَا طَاهِرَةً
u'لَهَا طِبَاعٌ':Subject, #1: 1	لَهَا طَائِفَةً
u'لَهَا طرائف':Predicate, #1: 1	لَهَا الطِّبَاعُ
u'لَهَا طَرَائِفُ':Predicate, #1: 1	لَهَا طَرَائِفَ
u'لَهَا طَرَفٌ':Subject, #1: 1	لَهَا طَرَائِفَ
u'لَهَا طُرُقٌ':Subject, #2: 2	لَهَا طَرَفٌ
u'لَهَا طَرِيقٌ':Subject, #1: 1	لَهَا طُرُقٌ
u'لَهَا طعام':Subject, #9: 9	لَهَا طَرِيقٌ
u'لَهَا طَعَامٌ':Subject, #1: 1	لَهَا طَعَامُ
u'لَهَا طَعْمٌ':Subject, #1: 1	لَهَا طَعَامُ
u'لَهَا طَلاَقٌ':Predicate, #1: 1	لَهَا طَعْمٌ
u'لَهَا طَلاَقٌ':Predicate, #1: 1	لَهَا الطَّلَاقَ
u'لَهَا طَلاَقٌ':Subject, #3: 3	لَهَا طَلَاقَ
u'لَهَا طَلاَقٌ':Subject, #1: 1	لَهَا الطَّلَاقُ
u'لَهَا طَلاَقٌ':Subject, #1: 1	لَهَا طَلَاقٌ
u'لَهَا طَلَبٌ':Subject, #2: 2	لَهَا طَلَاقُ
u'لَهَا طلب':Subject, #2: 2	لَهَا طَلَبٌ
u'لَهَا طَلَبٌ':Subject, #3: 3	لَهَا طَلَبُهُ
u'لَهَا طلب':Subject, #3: 3	لَهَا طَلَبُهُ
u'لَهَا طَلَبٌ':Subject, #5: 5	لَهَا طَلَبُ
u'لَهَا طَلْعٌ':Subject, #5: 5	لَهَا طَلَبُ
u'لَهَا طَهَارَةٌ':Subject, #5: 5	لَهَا طَلْعٌ
u'لَهَا طَهَارَةٌ':Subject, #1: 1	لَهَا طَهَارَةٌ
u'لَهَا طُهْرٌ':Subject, #4: 4	لَهَا الطَّهَارَةُ
u'لَهَا طهر':Subject, #1: 1	لَهَا طُهْرٌ
u'لَهَا طُهْرٌ':Subject, #3: 3	لَهَا الطُّهْرُ
u'لَهَا طواف':Subject, #3: 3	لَهَا الطُّهْرُ
u'لَهَا طَوَافٌ':Subject, #1: 1	لَهَا طَوَافٌ
u'لَهَا طواف':Subject, #1: 1	لَهَا طَوَافٌ
u'لَهَا طَوَافٌ':Subject, #2: 2	لَهَا الطَّوَافُ
u'لَهَا طواف':Subject, #2: 2	لَهَا الطَّوَافُ
u'لَهَا طَوَافٌ':Subject, #3: 3	لَهَا طَوَافُ
u'لَهَا طَيْرٌ':Subject, #3: 3	لَهَا طَوَافُ
u'لَهَا طِينٌ':Subject, #1: 1	لَهَا طَيْرٌ
u'لَهَا ظَرِبٌ':Subject, #1: 1	لَهَا طِينٌ
u'لَهَا ظُفْرٌ':Subject, #1: 1	لَهَا الظَّرِبُ
u'لَهَا ظِلٌّ':Subject, #1: 1	لَهَا ظُفْرٌ
u'لَهَا عَابِدٌ':Subject, #3: 3	لَهَا ظِلٌّ
u'لَهَا عَادَةٌ':Subject, #1: 1	لَهَا الْعَابِدُ
u'لَهَا عَادَةٌ':Subject, #1: 1	لَهَا عَادَةُ
u'لَهَا عَادَةٌ':Subject, #26: 26	لَهَا عَادَةٌ
u'لَهَا عارِيَّةٌ':Subject, #3: 3	لَهَا عَادَاتٌ
u'لَهَا عَاقِبٌ':Subject, #1: 1	لَهَا عَارِيَّةٌ
u'لَهَا عَاقِبَةٌ':Subject, #1: 1	لَهَا الْعَاقِبَةُ
u'لَهَا عَاقِلٌ':Subject, #1: 1	لَهَا الْعَاقِبَةُ
u'لَهَا عَاكِفٌ':Predicate, #1: 1	لَهَا عَاقِلَةٌ
u'لَهَا عَائِشٌ':Subject, #1: 1	لَهَا عَاكِفِينَ
u'لَهَا عِبَارَةٌ':Subject, #10: 10	لَهَا عَائِشَةُ
u'لَهَا عَبْدٌ':Predicate, #1: 1	لَهَا عِبَارَةٌ
u'لَهَا عَبْدٌ':Predicate, #1: 1	لَهَا الْعَبْدَ
u'لَهَا عَبْدٌ':Subject, #2: 2	لَهَا عَبْدَ
u'لَهَا عَبْدٌ':Subject, #1: 1	لَهَا عَبْدُهُ
u'لَهَا عَبْدٌ':Subject, #4: 4	لَهَا عَبْدُ
u'لَهَا عبرة':Subject, #5: 5	لَهَا الْعَبْدُ
u'لَهَا عِبْرَةٌ':Subject, #1: 1	لَهَا عِبْرَةٌ
u'لَهَا عُبُورٌ':Subject, #1: 1	لَهَا عِبْرَةٌ
u'لَهَا عُبُورٌ':Subject, #1: 1	لَهَا عُبُورُ
u'لَهَا عتق':Predicate, #2: 2	لَهَا الْعُبُورُ
u'لَهَا عِتْقٌ':Predicate, #1: 1	لَهَا الْعِتْقَ
u'لَهَا عتق':Predicate, #1: 1	لَهَا الْعِتْقَ
u'لَهَا عتق':Subject, #2: 2	لَهَا عَتَقَ
u'لَهَا عِتْقٌ':Subject, #1: 1	لَهَا عِتْقُهُ
u'لَهَا عتق':Subject, #1: 1	لَهَا عِتْقُهُ
u'لَهَا عِتْقٌ':Subject, #2: 2	لَهَا الْعِتْقُ
u'لَهَا عِتْقٌ':Subject, #2: 2	لَهَا الْعِتْقُ
u'لَهَا عِدَّةٌ':Subject, #3: 3	لَهَا عِتْقٌ
u'لَهَا عَدَدٌ':Subject, #1: 1	لَهَا عِدَّةُ
u'لَهَا عَدَدٌ':Subject, #1: 1	لَهَا الْعَدَدُ
u'لَهَا عَدَمٌ':Subject, #1: 1	لَهَا عَدَدٌ
u'لَهَا عَذَابٌ':Subject, #3: 3	لَهَا عَدَمُ
u'لَهَا عُذْرٌ':Subject, #7: 7	لَهَا الْعَذَابُ
u'لَهَا عَذْرَاءُ':Subject, #5: 5	لَهَا عُذْرٌ
u'لَهَا عَرَبٌ':Subject, #1: 1	لَهَا الْعَذْرَاءُ
u'لَهَا عَرْضٌ':Subject, #1: 1	لَهَا الْعَرَبُ
u'لَهَا عرف':Subject, #1: 1	لَهَا الْعَرْضُ
u'لَهَا عُرْفٌ':Subject, #3: 3	لَهَا عُرْفٌ
u'لَهَا عرفة':Subject, #3: 3	لَهَا عُرْفٌ
u'لَهَا عَزَائِمُ':Subject, #1: 1	لَهَا عَرَفَةُ
u'لَهَا عَزْمٌ':Subject, #1: 1	لَهَا عَزَائِمُ
u'لَهَا عَشْرٌ':Subject, #1: 1	لَهَا الْعَزْمُ
u'لَهَا عِشْرُون':Predicate, #1: 1	لَهَا عَشْرُ
u'لَهَا عَشِيرَةٌ':Subject, #3: 3	لَهَا عِشْرُونَ
u'لَهَا عِصَامٌ':Subject, #1: 1	لَهَا عَشِيرَةٌ
u'لَهَا عَصَبَةٌ':Subject, #1: 1	لَهَا عِصَامٌ
u'لَهَا عصبة':Subject, #1: 1	لَهَا عَصَبَاتٌ
u'لَهَا عُصْبَةٌ':Subject, #1: 1	لَهَا عُصْبَةٌ
u'لَهَا عصبة':Subject, #1: 1	لَهَا عُصْبَةٌ
u'لَهَا عَصَبَةٌ':Subject, #6: 6	لَهَا عَصَبَةٌ
u'لَهَا عَصِيرٌ':Subject, #6: 6	لَهَا عَصَبَةٌ
u'لَهَا عَظْمٌ':Subject, #1: 1	لَهَا عَصِيرُ
u'لَهَا عَظِيم':Subject, #3: 3	لَهَا عَظْمٌ
u'لَهَا عقاب':Subject, #1: 1	لَهَا عَظِيمٌ
u'لَهَا عُقَابٌ':Subject, #1: 1	لَهَا الْعُقَابُ
u'لَهَا عَقِبٌ':Predicate, #1: 1	لَهَا الْعُقَابُ
u'لَهَا عقبة':Subject, #2: 2	لَهَا عَقِبَ
u'لَهَا عُقْبَةٌ':Subject, #1: 1	لَهَا عُقْبَةُ
u'لَهَا عَقْدٌ':Subject, #1: 1	لَهَا عُقْبَةُ
u'لَهَا عُقَدٌ':Subject, #1: 1	لَهَا عَقْدٌ
u'لَهَا عقر':Subject, #1: 1	لَهَا عُقَدٌ
u'لَهَا عُقْرٌ':Subject, #1: 1	لَهَا الْعُقْرُ
u'لَهَا عقر':Subject, #1: 1	لَهَا الْعُقْرُ
u'لَهَا عُقْرٌ':Subject, #1: 1	لَهَا عُقْرُ
u'لَهَا عَكْسٌ':Subject, #1: 1	لَهَا عُقْرُ
u'لَهَا عَلاَمَةٌ':Subject, #1: 1	لَهَا عَكْسٌ
u'لَهَا عِلَّةٌ':Subject, #1: 1	لَهَا عَلَامَاتٌ
u'لَهَا عَلَفٌ':Predicate, #1: 1	لَهَا الْعِلَّةُ
u'لَهَا عَلَقَةٌ':Subject, #1: 1	لَهَا الْعَلَفَ
u'لَهَا علم':Subject, #1: 1	لَهَا عَلَقَةٌ
u'لَهَا علم':Subject, #1: 1	لَهَا عَلَمٌ
u'لَهَا علم':Subject, #1: 1	لَهَا عَلَمُ
u'لَهَا عَلَمٌ':Subject, #1: 1	لَهَا عِلْمٌ
u'لَهَا عَلَمٌ':Subject, #1: 1	لَهَا عَلَمٌ
u'لَهَا عِلْمٌ':Subject, #1: 1	لَهَا عَلَمُ
u'لَهَا علماء':Subject, #1: 1	لَهَا عِلْمٌ
u'لَهَا عُلَمَاءُ':Subject, #1: 1	لَهَا عُلَمَاءُ
u'لَهَا عُلُوٌّ':Subject, #1: 1	لَهَا عُلَمَاءُ
u'لَهَا عُلْوٌ':Subject, #1: 1	لَهَا عُلُوٌّ
u'لَهَا عَمٌّ':Predicate, #1: 1	لَهَا عُلْوٌ
u'لَهَا عُمَانُ':Subject, #1: 1	لَهَا عَمَّ
u'لَهَا عَمْدٌ':Subject, #1: 1	لَهَا عُمَانُ
u'لَهَا عُمَرٌ':Subject, #1: 1	لَهَا عَمْدٌ
u'لَهَا عمرة':Subject, #3: 3	لَهَا عُمَرُ
u'لَهَا عمرة':Subject, #1: 1	لَهَا عَمْرَةُ
u'لَهَا عُمْرَةٌ':Subject, #1: 1	لَهَا عُمْرَةُ
u'لَهَا عَمَلٌ':Predicate, #1: 1	لَهَا عُمْرَةُ
u'لَهَا عَمَلٌ':Subject, #1: 1	لَهَا الْعَمَلَ
u'لَهَا عُمُومٌ':Subject, #1: 1	لَهَا عَمَلٌ
u'لَهَا عَنَاقٌ':Subject, #1: 1	لَهَا عُمُومٌ
u'لَهَا عَنْبَرٌ':Subject, #3: 3	لَهَا عَنَاقُ
u'لَهَا عند':Predicate, #2: 2	لَهَا الْعَنْبَرُ
u'لَهَا عند':Predicate, #1: 1	لَهَا عَنْدَ
u'لَهَا عَهْدٌ':Subject, #48: 48	لَهَا عِنْدَ
u'لَهَا عَوْدٌ':Subject, #1: 1	لَهَا عَهْدٌ
u'لَهَا عَوْدَةٌ':Subject, #2: 2	لَهَا الْعَوْدُ
u'لَهَا عِوَضٌ':Subject, #1: 1	لَهَا الْعَوْدَةُ
u'لَهَا عِوَضٌ':Subject, #2: 2	لَهَا عِوَضٌ
u'لَهَا عِيَالٌ':Predicate, #3: 3	لَهَا الْعِوَضُ
u'لَهَا عِيدٌ':Subject, #1: 1	لَهَا الْعِيَالَ
u'لَهَا عَيْنٌ':Subject, #1: 1	لَهَا عِيدٌ
u'لَهَا عَيْن':Subject, #3: 3	لَهَا عَيْنٌ
u'لَهَا عُيُونٌ':Subject, #3: 3	لَهَا عَيْنٌ
u'لَهَا غَايَةٌ':Subject, #1: 1	لَهَا الْعُيُونُ
u'لَهَا غَايَةٌ':Subject, #1: 1	لَهَا غَايَةٌ
u'لَهَا غَدٌ':Subject, #1: 1	لَهَا غَايَتُهُ
u'لَهَا غَرَّاءٌ':Subject, #1: 1	لَهَا الْغَدُ
u'لَهَا غَرَّاءٌ':Subject, #1: 1	لَهَا الْغَرّاءُ
u'لَهَا غُرَابٌ':Subject, #3: 3	لَهَا الْغَرَّاءُ
u'لَهَا غَرَضٌ':Subject, #1: 1	لَهَا غُرَابُ
u'لَهَا غَرَضٌ':Subject, #1: 1	لَهَا الْغَرَضُ
u'لَهَا غُرْلَة':Subject, #4: 4	لَهَا غَرَضٌ
u'لَهَا غُسْلٌ':Subject, #1: 1	لَهَا غُرْلَةٌ
u'لَهَا غَسْلٌ':Subject, #1: 1	لَهَا الْغُسْلُ
u'لَهَا غُسْلٌ':Subject, #1: 1	لَهَا غَسْلُهُ
u'لَهَا غُسْلٌ':Subject, #2: 2	لَهَا غُسْلُ
u'لَهَا غِشَاءٌ':Subject, #3: 3	لَهَا غُسْلُهُ
u'لَهَا غُلاَمٌ':Subject, #1: 1	لَهَا غِشَاءٌ
u'لَهَا غُلاَمٌ':Subject, #1: 1	لَهَا الْغُلامُ
u'لَهَا غُلاَمٌ':Subject, #1: 1	لَهَا الْغُلَامُ
u'لَهَا غَلَّةٌ':Subject, #2: 2	لَهَا غُلاَمٌ
u'لَهَا غَنَمٌ':Subject, #1: 1	لَهَا غَلَّةٌ
u'لَهَا غَوْرٌ':Subject, #1: 1	لَهَا غَنَمُ
u'لَهَا غير':Predicate, #1: 1	لَهَا غَوْرٌ
u'لَهَا غَيْرٌ':Predicate, #10: 10	لَهَا غَيْرَ
u'لَهَا غير':Subject, #10: 10	لَهَا غَيْرَ
u'لَهَا غَيْرٌ':Subject, #13: 13	لَهَا غَيْرُهُ
u'لَهَا غير':Subject, #13: 13	لَهَا غَيْرُهُ
u'لَهَا غِيَرٌ':Subject, #1: 1	لَهَا غِيَرُ
u'لَهَا غير':Subject, #1: 1	لَهَا غِيَرُ
u'لَهَا غَيْرٌ':Subject, #22: 22	لَهَا غَيْرُ
u'لَهَا فَأْرٌ':Subject, #22: 22	لَهَا غَيْرُ
u'لَهَا فَاكِهٌ':Subject, #1: 1	لَهَا فَأْرَةٌ
u'لَهَا فَاكِهَةٌ':Subject, #1: 1	لَهَا فَاكِهَةٌ
u'لَهَا فَائِدَةٌ':Subject, #1: 1	لَهَا فَاكِهَةٌ
u'لَهَا فَائِدَةٌ':Subject, #1: 1	لَهَا فَائِدَتُهُ
u'لَهَا فَتْحٌ':Subject, #4: 4	لَهَا فَائِدَةٌ
u'لَهَا فَحْلٌ':Subject, #1: 1	لَهَا الْفَتْحُ
u'لَهَا فَرَاشٌ':Subject, #2: 2	لَهَا فَحْلٌ
u'لَهَا فِرَاشٌ':Subject, #1: 1	لَهَا الْفَرَاشُ
u'لَهَا فِرَاشٌ':Subject, #1: 1	لَهَا الْفِرَاشُ
u'لَهَا فِرَاقٌ':Subject, #1: 1	لَهَا فِرَاشٌ
u'لَهَا فِرَاقٌ':Subject, #1: 1	لَهَا الْفِرَاقُ
u'لَهَا فَرْجٌ':Subject, #1: 1	لَهَا فِرَاقُهُ
u'لَهَا فَرْضٌ':Predicate, #3: 3	لَهَا فَرْجٌ
u'لَهَا فَرْضٌ':Predicate, #1: 1	لَهَا الْفَرْضَ
u'لَهَا فَرْضٌ':Subject, #2: 2	لَهَا فَرْضَ
u'لَهَا فَرْضٌ':Subject, #1: 1	لَهَا الْفَرْضُ
u'لَهَا فُرْقَةٌ':Predicate, #3: 3	لَهَا فَرْضٌ
u'لَهَا فُرْقَةٌ':Subject, #1: 1	لَهَا الْفُرْقَةَ
u'لَهَا فَرْوَةٌ':Subject, #1: 1	لَهَا الْفُرْقَةُ
u'لَهَا فُرُوعٌ':Subject, #1: 1	لَهَا الْفَرْوَةُ
u'لَهَا فَسْخٌ':Predicate, #1: 1	لَهَا الْفُرُوعُ
u'لَهَا فَسْخٌ':Subject, #17: 17	لَهَا الْفَسْخَ
u'لَهَا فَسْخٌ':Subject, #1: 1	لَهَا فَسْخُهُ
u'لَهَا فَسْخٌ':Subject, #2: 2	لَهَا فَسْخُ
u'لَهَا فَصَافِصُ':Subject, #46: 46	لَهَا الْفَسْخُ
u'لَهَا فَصْلٌ':Subject, #1: 1	لَهَا الْفَصَافِصُ
u'لَهَا فَضْلٌ':Subject, #1: 1	لَهَا فَصْلٌ
u'لَهَا فَضِيلَةٌ':Subject, #2: 2	لَهَا فَضْلٌ
u'لَهَا فِطْرٌ':Subject, #2: 2	لَهَا فَضِيلَةٌ
u'لَهَا فطرة':Subject, #9: 9	لَهَا الْفِطْرُ
u'لَهَا فِطْرَةٌ':Subject, #3: 3	لَهَا الْفِطْرَةُ
u'لَهَا فِعْلٌ':Predicate, #3: 3	لَهَا الْفِطْرَةُ
u'لَهَا فِعْلٌ':Subject, #1: 1	لَهَا الْفِعْلَ
u'لَهَا فِعْلٌ':Subject, #1: 1	لَهَا فِعْلُهُ
u'لَهَا فَلاَحٌ':Subject, #2: 2	لَهَا فِعْلُ
u'لَهَا فلان':Predicate, #1: 1	لَهَا فَلَاحٌ
u'لَهَا فلان':Subject, #1: 1	لَهَا خَدِيجَةَ
u'لَهَا فلان':Subject, #1: 1	لَهَا الْبَيْهَقِيُّ
u'لَهَا فلان':Subject, #1: 1	لَهَا الْقُدْسِيَّةُ
u'لَهَا فلان':Subject, #1: 1	لَهَا بِلاَلٌ
u'لَهَا فلان':Subject, #1: 1	لَهَا خُرَاسَانُ
u'لَهَا فُلاَنٌ':Subject, #1: 1	لَهَا رَاتِبَةٌ
u'لَهَا فلان':Subject, #1: 1	لَهَا فُلَانٌ
u'لَهَا فُلاَنٌ':Subject, #2: 2	لَهَا عُثْمَانُ
u'لَهَا فِنَاءٌ':Subject, #3: 3	لَهَا فُلَانَةُ
u'لَهَا قَابِلٌ':Subject, #1: 1	لَهَا فِنَاءٌ
u'لَهَا قَابِلٌ':Subject, #2: 2	لَهَا الْقَابِلَةُ
u'لَهَا قَاعِدٌ':Subject, #2: 2	لَهَا قَابِلَةٌ
u'لَهَا قاف':Predicate, #1: 1	لَهَا قَاعِدَةٌ
u'لَهَا قَالٌ':Predicate, #1: 1	لَهَا الْقَافَةَ
u'لَهَا قَائِدٌ':Subject, #42: 42	لَهَا قَالَ
u'لَهَا قَائِلٌ':Subject, #1: 1	لَهَا قَائِدٌ
u'لَهَا قُبْحٌ':Subject, #1: 1	لَهَا قَائِلٌ
u'لَهَا قَبْرٌ':Subject, #1: 1	لَهَا قُبْحٌ
u'لَهَا قَبْضٌ':Subject, #1: 1	لَهَا قَبْرٌ
u'لَهَا قَبُولٌ':Predicate, #1: 1	لَهَا قَبْضُ
u'لَهَا قَبُولٌ':Subject, #1: 1	لَهَا الْقَبُولَ
u'لَهَا قَتَب':Subject, #2: 2	لَهَا قَبُولٌ
u'لَهَا قتل':Predicate, #1: 1	لَهَا قَتَبٌ
u'لَهَا قتل':Subject, #1: 1	لَهَا قُتِلَ
u'لَهَا قَتْلٌ':Subject, #1: 1	لَهَا قَتْلُهُ
u'لَهَا قَدْرٌ':Predicate, #1: 1	لَهَا قَتْلُهُ
u'لَهَا قَدْرٌ':Subject, #2: 2	لَهَا قَدْرَ
u'لَهَا قَدْرٌ':Subject, #2: 2	لَهَا قَدْرُ
u'لَهَا قدرة':Subject, #5: 5	لَهَا قَدْرٌ
u'لَهَا قُدْرَةٌ':Subject, #1: 1	لَهَا قُدْرَةٌ
u'لَهَا قُدْسِيّ':Subject, #1: 1	لَهَا قُدْرَةٌ
u'لَهَا قُدْسِيَّة':Subject, #1: 1	لَهَا الْقُدْسِيَّةُ
u'لَهَا قُرْء':Subject, #1: 1	لَهَا الْقُدْسِيَّةُ
u'لَهَا قِرَاءةٌ':Subject, #1: 1	لَهَا قُرْءٌ
u'لَهَا قِرَاءةٌ':Subject, #1: 1	لَهَا الْقِرَاءَةُ
u'لَهَا قِرَاءةٌ':Subject, #2: 2	لَهَا قِرَاءَةٌ
u'لَهَا قَرَابَةٌ':Subject, #2: 2	لَهَا قِرَاءَةُ
u'لَهَا قَرَابَةٌ':Subject, #11: 11	لَهَا قَرَابَةٌ
u'لَهَا قرار':Subject, #1: 1	لَهَا قَرَابَةُ
u'لَهَا قَرَارٌ':Subject, #1: 1	لَهَا قَرَارٌ
u'لَهَا قرحاء':Subject, #1: 1	لَهَا قَرَارٌ
u'لَهَا قُرْعَةٌ':Subject, #1: 1	لَهَا الْقَرْحَاءُ
u'لَهَا قُرْعَةٌ':Subject, #3: 3	لَهَا الْقُرْعَةُ
u'لَهَا قَرْنٌ':Subject, #3: 3	لَهَا قُرْعَةُ
u'لَهَا قَرِيبٌ':Predicate, #3: 3	لَهَا قَرْنٌ
u'لَهَا قِسْطٌ':Subject, #1: 1	لَهَا الْقَرِيبَ
u'لَهَا قَسْمٌ':Predicate, #1: 1	لَهَا قِسْطٌ
u'لَهَا قَسْمٌ':Predicate, #1: 1	لَهَا الْقَسْمَ
u'لَهَا قَسْمٌ':Subject, #1: 1	لَهَا قَسْمَ
u'لَهَا قَسْمٌ':Subject, #2: 2	لَهَا الْقَسْمُ
u'لَهَا قَصْدٌ':Subject, #2: 2	لَهَا قَسْمُ
u'لَهَا قِصَرٌ':Subject, #1: 1	لَهَا قَصْدٌ
u'لَهَا قُصُورٌ':Predicate, #1: 1	لَهَا الْقِصَرُ
u'لَهَا قَضَاءٌ':Predicate, #2: 2	لَهَا قُصُورَ
u'لَهَا قَضَاءٌ':Predicate, #1: 1	لَهَا الْقَضَاءَ
u'لَهَا قَضَاءٌ':Subject, #1: 1	لَهَا قَضَاءَ
u'لَهَا قَضَاءٌ':Subject, #2: 2	لَهَا قَضَاءُ
u'لَهَا قَطْعٌ':Subject, #5: 5	لَهَا الْقَضَاءُ
u'لَهَا قُطْنٌ':Predicate, #1: 1	لَهَا قَطْعُ
u'لَهَا قلب':Subject, #1: 1	لَهَا الْقُطْنَ
u'لَهَا قَلْبٌ':Subject, #1: 1	لَهَا الْقَلْبُ
u'لَهَا قَلْب':Subject, #1: 1	لَهَا الْقَلْبُ
u'لَهَا قلب':Subject, #1: 1	لَهَا الْقَلْبُ
u'لَهَا قَلْبٌ':Subject, #1: 1	لَهَا قَلْبُهُ
u'لَهَا قَلْب':Subject, #1: 1	لَهَا قَلْبُهُ
u'لَهَا قُلُوبٌ':Subject, #1: 1	لَهَا قَلْبُهُ
u'لَهَا قَنَادِيلُ':Subject, #2: 2	لَهَا الْقُلُوبُ
u'لَهَا قَهْرٌ':Subject, #2: 2	لَهَا قَنَادِيلُ
u'لَهَا قُوَّةٌ':Subject, #1: 1	لَهَا قَهْرُهُ
u'لَهَا قُوَّة':Subject, #2: 2	لَهَا قُوَّةُ
u'لَهَا قُوَّةٌ':Subject, #2: 2	لَهَا قُوَّةُ
u'لَهَا قُوَّة':Subject, #3: 3	لَهَا قُوَّةٌ
u'لَهَا قَوْلٌ':Subject, #3: 3	لَهَا قُوَّةٌ
u'لَهَا قول':Subject, #1: 1	لَهَا قَوْلٌ
u'لَهَا قَوْلٌ':Subject, #4: 4	لَهَا قَوْلُهُ
u'لَهَا قَوْمٌ':Subject, #4: 4	لَهَا قَوْلُهُ
u'لَهَا قَوْمٌ':Subject, #1: 1	لَهَا الْقَوْمُ
u'لَهَا قيام':Subject, #2: 2	لَهَا قَوْمٌ
u'لَهَا قِيَامٌ':Subject, #2: 2	لَهَا الْقِيَامُ
u'لَهَا قِيمَةٌ':Predicate, #2: 2	لَهَا الْقِيَامُ
u'لَهَا قِيمَةٌ':Subject, #7: 7	لَهَا قِيمَةَ
u'لَهَا قِيمَةٌ':Subject, #10: 10	لَهَا قِيمَةُ
u'لَهَا قِيمَةٌ':Subject, #18: 18	لَهَا قِيمَةٌ
u'لَهَا قِيمَةٌ':Subject, #1: 1	لَهَا قِيمَتُهُ
u'لَهَا كَاسِبٌ':Subject, #7: 7	لَهَا الْقِيمَةُ
u'لَهَا كَافِرٌ':Subject, #1: 1	لَهَا كَاسِبٌ
u'لَهَا كَبِيرٌ':Subject, #1: 1	لَهَا الْكَافِرُ
u'لَهَا كِتَابٌ':Subject, #1: 1	لَهَا كَبِيرُ
u'لَهَا كِرَاءٌ':Subject, #1: 1	لَهَا الْكِتَابُ
u'لَهَا كِرْباس':Subject, #1: 1	لَهَا كِرَاءٌ
u'لَهَا كِسَاءٌ':Subject, #2: 2	لَهَا الْكِرْبَاسُ
u'لَهَا كَسْبٌ':Subject, #1: 1	لَهَا كِسَاءٌ
u'لَهَا كَسْبٌ':Subject, #1: 1	لَهَا الْكَسْبُ
u'لَهَا كَسْرٌ':Subject, #8: 8	لَهَا كَسْبٌ
u'لَهَا كَشْفٌ':Predicate, #1: 1	لَهَا كَسْرٌ
u'لَهَا كَشْفٌ':Subject, #1: 1	لَهَا كَشْفَ
u'لَهَا كَعْبٌ':Subject, #3: 3	لَهَا كَشْفُ
u'لَهَا كُفَّارٌ':Subject, #1: 1	لَهَا كَعْبٌ
u'لَهَا كَفَّارَةٌ':Subject, #5: 5	لَهَا الْكُفَّارُ
u'لَهَا كَفَرَةٌ':Subject, #1: 1	لَهَا كَفَّارَةٌ
u'لَهَا كُفُؤٌ':Subject, #1: 1	لَهَا كَفَرَةُ
u'لَهَا كَلاَمٌ':Subject, #1: 1	لَهَا كُفُؤٌ
u'لَهَا كَلاَمٌ':Subject, #1: 1	لَهَا كَلَامٌ
u'لَهَا كَلْبٌ':Subject, #1: 1	لَهَا كَلَامُ
u'لَهَا كَمَالٌ':Predicate, #1: 1	لَهَا كَلْبٌ
u'لَهَا كَمَالٌ':Subject, #2: 2	لَهَا كَمَالَ
u'لَهَا كِمَامٌ':Subject, #9: 9	لَهَا كَمَالُ
u'لَهَا كِنَايَةٌ':Subject, #1: 1	لَهَا كِمَامٌ
u'لَهَا كُنْيَةٌ':Subject, #1: 1	لَهَا كِنَايَةٌ
u'لَهَا كَوَاسِبُ':Subject, #1: 1	لَهَا كُنْيَةٌ
u'لَهَا كَوْنٌ':Subject, #3: 3	لَهَا الْكَوَاسِبُ
u'لَهَا ل':Subject, #1: 1	لَهَا كَوْنُ
u'لَهَا لاَزِمٌ':Subject, #1: 1	لَهَا لِيَّةٌ
u'لَهَا لاَقِط':Subject, #3: 3	لَهَا لَازِمٌ
u'لَهَا لِبَاسٌ':Subject, #1: 1	لَهَا لَاقِطَةٌ
u'لَهَا لبس':Subject, #1: 1	لَهَا لِبَاسُ
u'لَهَا لُبْسٌ':Subject, #1: 1	لَهَا اللُّبْسُ
u'لَهَا لبس':Subject, #1: 1	لَهَا اللُّبْسُ
u'لَهَا لُبْسٌ':Subject, #1: 1	لَهَا لُبْسُهُ
u'لَهَا لبس':Subject, #1: 1	لَهَا لُبْسُهُ
u'لَهَا لُبْسٌ':Subject, #4: 4	لَهَا لُبْسُ
u'لَهَا لَبَنٌ':Subject, #4: 4	لَهَا لُبْسُ
u'لَهَا لبن':Subject, #41: 41	لَهَا لَبَنٌ
u'لَهَا لَبَنٌ':Subject, #4: 4	لَهَا اللَّبَنُ
u'لَهَا لبنة':Subject, #4: 4	لَهَا اللَّبَنُ
u'لَهَا لبنة':Subject, #1: 1	لَهَا لَبِنَةٌ
u'لَهَا لَبِنَةٌ':Subject, #1: 1	لَهَا لِبْنَةٌ
u'لَهَا لبنة':Subject, #1: 1	لَهَا لَبِنَةٌ
u'لَهَا لَبِيبٌ':Subject, #2: 2	لَهَا لِبْنَةُ
u'لَهَا لَحْظ':Predicate, #1: 1	لَهَا اللَّبِيبُ
u'لَهَا لَحْمٌ':Subject, #1: 1	لَهَا لَحْظَةً
u'لَهَا لِحْيَةٌ':Subject, #1: 1	لَهَا لَحْمٌ
u'لَهَا لِسَانٌ':Predicate, #3: 3	لَهَا لِحْيَةٌ
u'لَهَا لعاب':Subject, #2: 2	لَهَا لِسَانَ
u'لَهَا لُعَابٌ':Subject, #3: 3	لَهَا لُعَابٌ
u'لَهَا لِفَافَةٌ':Subject, #3: 3	لَهَا لُعَابٌ
u'لَهَا لَوَثٌ':Subject, #1: 1	لَهَا اللِّفَافَةُ
u'لَهَا لَوْنٌ':Subject, #1: 1	لَهَا اللَّوَثُ
u'لَهَا لَيْلٌ':Predicate, #2: 2	لَهَا لَوْنٌ
u'لَهَا لَيْلٌ':Subject, #2: 2	لَهَا لَيْلَةً
u'لَهَا مَاءٌ':Predicate, #3: 3	لَهَا لَيْلَةٌ
u'لَهَا مَاءٌ':Subject, #1: 1	لَهَا الْمَاءَ
u'لَهَا مَاءٌ':Subject, #1: 1	لَهَا الْمَاءُ
u'لَهَا مَاءٌ':Subject, #1: 1	لَهَا مَاءُ
u'لَهَا مَالٌ':Predicate, #3: 3	لَهَا مَاءٌ
u'لَهَا مَالٌ':Subject, #2: 2	لَهَا الْمَالَ
u'لَهَا مَالٌ':Subject, #29: 29	لَهَا مَالٌ
u'لَهَا مَالِكٌ':Subject, #2: 2	لَهَا الْمَالُ
u'لَهَا مَالِكٌ':Subject, #11: 11	لَهَا مَالِكٌ
u'لَهَا مَأْمُورٌ':Subject, #1: 1	لَهَا الْمَالِكُ
u'لَهَا مَأْمُونٌ':Subject, #4: 4	لَهَا الْمَأْمُورُ
u'لَهَا مَانِعٌ':Subject, #1: 1	لَهَا الْمَأْمُونُ
u'لَهَا مُبَاحٌ':Subject, #1: 1	لَهَا مَانِعٌ
u'لَهَا مَبَاحِثُ':Subject, #2: 2	لَهَا مُبَاحٌ
u'لَهَا مُبَاشَرَةٌ':Subject, #1: 1	لَهَا مَبَاحِثُ
u'لَهَا مُبَاشَرَةٌ':Subject, #1: 1	لَهَا مُبَاشَرَتُهُ
u'لَهَا مُبْتَدَأٌ':Subject, #2: 2	لَهَا مُبَاشَرَةُ
u'لَهَا مُتَعارِض':Subject, #1: 1	لَهَا مُبْتَدَأٌ
u'لَهَا مُتْعَةٌ':Predicate, #1: 1	لَهَا مُتَعَارِضَةٌ
u'لَهَا مُتْعَةٌ':Subject, #5: 5	لَهَا الْمُتْعَةَ
u'لَهَا مُتْعَةٌ':Subject, #30: 30	لَهَا الْمُتْعَةُ
u'لَهَا مُتَعَلِّقٌ':Subject, #5: 5	لَهَا مُتْعَةٌ
u'لَهَا مُتَعَهِّدٌ':Subject, #1: 1	لَهَا مُتَعَلِّقٌ
u'لَهَا مُتَفَرِّقٌ':Predicate, #1: 1	لَهَا مُتَعَهِّدٌ
u'لَهَا مِثَالٌ':Subject, #1: 1	لَهَا مُتَفَرِّقَةً
u'لَهَا مثل':Predicate, #1: 1	لَهَا مِثَالٌ
u'لَهَا مِثْلٌ':Predicate, #8: 8	لَهَا مِثْلَ
u'لَهَا مثل':Subject, #8: 8	لَهَا مِثْلَ
u'لَهَا مِثْلٌ':Subject, #11: 11	لَهَا مِثْلُ
u'لَهَا مِثْلٌ':Subject, #11: 11	لَهَا مِثْلُ
u'لَهَا مَجَازٌ':Subject, #2: 2	لَهَا مِثْلٌ
u'لَهَا مُجْبِرٌ':Subject, #1: 1	لَهَا مَجَازٌ
u'لَهَا مَجْلِسٌ':Subject, #1: 1	لَهَا مُجْبِرٌ
u'لَهَا مُجِيزٌ':Subject, #1: 1	لَهَا الْمَجْلِسُ
u'لَهَا مَحَارِمُ':Subject, #2: 2	لَهَا مُجِيزٌ
u'لَهَا مُحِبٌّ':Subject, #1: 1	لَهَا مَحَارِمُ
u'لَهَا مُحَرَّرٌ':Subject, #1: 1	لَهَا مُحِبٌّ
u'لَهَا مَحْرَمٌ':Subject, #1: 1	لَهَا مُحَرَّرٌ
u'لَهَا مَحَلٌّ':Subject, #20: 20	لَهَا مَحْرَمٌ
u'لَهَا مُحَمَّدٌ':Subject, #3: 3	لَهَا مَحَلٌّ
u'لَهَا مُحَمَّدٌ':Subject, #1: 1	لَهَا مُحَمّدٌ
u'لَهَا مَحْمَلٌ':Subject, #1: 1	لَهَا مُحَمَّدٌ
u'لَهَا مَخَافَةٌ':Predicate, #2: 2	لَهَا مَحْمَلٌ
u'لَهَا مَخَافَة':Predicate, #1: 1	لَهَا مَخَافَةَ
u'لَهَا مُخَالِفٌ':Subject, #1: 1	لَهَا مَخَافَةَ
u'لَهَا مُخَالَفَةٌ':Subject, #1: 1	لَهَا مُخَالِفٌ
u'لَهَا مُخْتَلِفٌ':Subject, #1: 1	لَهَا مُخَالَفَةُ
u'لَهَا مَخْرَجٌ':Predicate, #1: 1	لَهَا مُخْتَلِفَةٌ
u'لَهَا مُخَصَّصٌ':Subject, #1: 1	لَهَا الْمَخْرَجَ
u'لَهَا مَخْصُوصٌ':Subject, #2: 2	لَهَا مُخَصَّصَاتٌ
u'لَهَا مِخْلَبٌ':Subject, #1: 1	لَهَا مَخْصُوصٌ
u'لَهَا مُدَّةٌ':Predicate, #1: 1	لَهَا مِخْلَبٌ
u'لَهَا مُدَّةٌ':Predicate, #1: 1	لَهَا الْمُدَّةَ
u'لَهَا مُدَّةٌ':Subject, #2: 2	لَهَا مُدَّةَ
u'لَهَا مَدْخَلٌ':Subject, #4: 4	لَهَا مُدَّةٌ
u'لَهَا مُذَاكَرَةٌ':Subject, #12: 12	لَهَا مَدْخَلٌ
u'لَهَا مرٌّ':Predicate, #1: 1	لَهَا الْمُذَاكَرَاتُ
u'لَهَا مَرَابِطُ':Subject, #13: 13	لَهَا مَرَّةً
u'لَهَا مِرْآةٌ':Subject, #1: 1	لَهَا مَرَابِطُ
u'لَهَا مِرْآةٌ':Subject, #1: 1	لَهَا الْمِرْآةُ
u'لَهَا مُرَاعَاةٌ':Predicate, #1: 1	لَهَا مِرْآةٌ
u'لَهَا مَرْدُودٌ':Subject, #1: 1	لَهَا مُرَاعَاةَ
u'لَهَا مَرَضٌ':Subject, #1: 1	لَهَا مَرْدُودٌ
u'لَهَا مِرْفَقٌ':Subject, #2: 2	لَهَا مَرَضٌ
u'لَهَا مَرَمَّة':Subject, #1: 1	لَهَا مِرْفَقٌ
u'لَهَا مَزِيَّةٌ':Subject, #1: 1	لَهَا مَرَمَّةٌ
u'لَهَا مَزِيدٌ':Subject, #1: 1	لَهَا مَزِيَّةٌ
u'لَهَا مَسٌّ':Subject, #3: 3	لَهَا مَزِيدُ
u'لَهَا مُسَاكَنَةٌ':Subject, #1: 1	لَهَا مَسُّ
u'لَهَا مُسَالَمَةٌ':Subject, #1: 1	لَهَا مُسَاكَنَتُهُ
u'لَهَا مَسْبُوق':Subject, #1: 1	لَهَا الْمُسَالَمَةُ
u'لَهَا مُسْتَحَبٌّ':Subject, #1: 1	لَهَا مَسْبُوقٌ
u'لَهَا مُسْتَحِقٌّ':Subject, #2: 2	لَهَا مُسْتَحَبَّةٌ
u'لَهَا مُسْتَحَقٌّ':Subject, #1: 1	لَهَا مُسْتَحِقٌّ
u'لَهَا مُسْتَنَدٌ':Subject, #3: 3	لَهَا مُسْتَحَقٌّ
u'لَهَا مَسْجِدٌ':Subject, #1: 1	لَهَا مُسْتَنَدٌ
u'لَهَا مَسْحٌ':Subject, #2: 2	لَهَا مَسْجِدٌ
u'لَهَا مَسْرُوقٌ':Subject, #1: 1	لَهَا الْمَسْحُ
u'لَهَا مَسْكَنٌ':Predicate, #1: 1	لَهَا مَسْرُوقٌ
u'لَهَا مَسْكَنٌ':Subject, #1: 1	لَهَا الْمَسْكَنَ
u'لَهَا مُسَمَّى':Subject, #2: 2	لَهَا مَسْكَنٌ
u'لَهَا مُسَوِّغٌ':Subject, #1: 1	لَهَا مُسَمَّيَاتٌ
u'لَهَا مَسِيرَةٌ':Predicate, #2: 2	لَهَا مُسَوِّغٌ
u'لَهَا مَسِيلٌ':Subject, #1: 1	لَهَا مَسِيرَةَ
u'لَهَا مَسِيلٌ':Subject, #1: 1	لَهَا مَسِيلُ
u'لَهَا مُشار':Subject, #2: 2	لَهَا مَسِيلٌ
u'لَهَا مَشِيئَةٌ':Predicate, #3: 3	لَهَا الْمُشَارُ
u'لَهَا مَشِيئَةٌ':Subject, #5: 5	لَهَا الْمَشِيئَةَ
u'لَهَا مَشِيئَةٌ':Subject, #4: 4	لَهَا مَشِيئَةٌ
u'لَهَا مَصَادِرُ':Subject, #8: 8	لَهَا الْمَشِيئَةُ
u'لَهَا مَصَالِحُ':Subject, #2: 2	لَهَا مَصَادِرُ
u'لَهَا مُضَافٌ':Predicate, #1: 1	لَهَا مَصَالِحُ
u'لَهَا مَضْمُونٌ':Subject, #1: 1	لَهَا مُضَافَةً
u'لَهَا مُضِيٌّ':Subject, #1: 1	لَهَا مَضْمُونٌ
u'لَهَا مُطَالَبٌ':Predicate, #2: 2	لَهَا الْمُضِيُّ
u'لَهَا مُطَالَبٌ':Predicate, #2: 2	لَهَا مُطَالَبَةَ
u'لَهَا مُطَالَبٌ':Subject, #4: 4	لَهَا الْمُطَالَبَةَ
u'لَهَا مُطَالَبٌ':Subject, #14: 14	لَهَا الْمُطَالَبَةُ
u'لَهَا مُطَالَبَةٌ':Predicate, #4: 4	لَهَا مُطَالَبَةُ
u'لَهَا مُطَالَبَةٌ':Predicate, #2: 2	لَهَا مُطَالَبَةَ
u'لَهَا مُطَالَبَةٌ':Subject, #4: 4	لَهَا الْمُطَالَبَةَ
u'لَهَا مُطَالَبَةٌ':Subject, #14: 14	لَهَا الْمُطَالَبَةُ
u'لَهَا مَطَالِعُ':Predicate, #4: 4	لَهَا مُطَالَبَةُ
u'لَهَا مَطْلَبٌ':Subject, #1: 1	لَهَا مَطَالِعَ
u'لَهَا مُطْلَقٌ':Subject, #1: 1	لَهَا مَطْلَبٌ
u'لَهَا مَطْلُوبٌ':Subject, #2: 2	لَهَا مُطْلَقُ
u'لَهَا مَظَاهِرُ':Subject, #1: 1	لَهَا مَطْلُوبٌ
u'لَهَا مُعارِضٌ':Subject, #1: 1	لَهَا مَظَاهِرُ
u'لَهَا مَعَانِي':Predicate, #1: 1	لَهَا مُعَارِضٌ
u'لَهَا مُعْتَبَرٌ':Subject, #1: 1	لَهَا مَعَانِيَ
u'لَهَا مُعَجَّلٌ':Predicate, #1: 1	لَهَا مُعْتَبَرٌ
u'لَهَا مُعَجَّلٌ':Predicate, #1: 1	لَهَا مُعَجَّلَ
u'لَهَا مَعْرِفَةٌ':Subject, #2: 2	لَهَا الْمُعَجَّلَ
u'لَهَا مَعْرِفَة':Subject, #1: 1	لَهَا الْمَعْرِفَةُ
u'لَهَا مَعْرِفَةٌ':Subject, #1: 1	لَهَا الْمَعْرِفَةُ
u'لَهَا مَعْرِفَة':Subject, #1: 1	لَهَا مَعْرِفَةٌ
u'لَهَا مُعَيَّنٌ':Subject, #1: 1	لَهَا مَعْرِفَةٌ
u'لَهَا مُغَايِرٌ':Subject, #1: 1	لَهَا مُعَيَّنٌ
u'لَهَا مِغْلَقٌ':Subject, #1: 1	لَهَا مُغَايِرَةٌ
u'لَهَا مُفَارَقَةٌ':Subject, #1: 1	لَهَا مِغْلَقٌ
u'لَهَا مَفَاصِلُ':Subject, #1: 1	لَهَا مُفَارَقَةُ
u'لَهَا مَفْعُولٌ':Subject, #1: 1	لَهَا مَفَاصِلُ
u'لَهَا مَفْهُومٌ':Subject, #1: 1	لَهَا مَفْعُولٌ
u'لَهَا مَقَادِيرُ':Predicate, #1: 1	لَهَا مَفْهُومٌ
u'لَهَا مُقَارَنٌ':Subject, #1: 1	لَهَا مَقَادِيرَ
u'لَهَا مُقَامٌ':Predicate, #1: 1	لَهَا مُقَارَنٌ
u'لَهَا مَقَامٌ':Predicate, #1: 1	لَهَا الْمُقَامَ
u'لَهَا مَقَامٌ':Subject, #2: 2	لَهَا مَقَامَ
u'لَهَا مَقْبَرَةٌ':Subject, #1: 1	لَهَا الْمَقَامُ
u'لَهَا مِقْدَارٌ':Predicate, #1: 1	لَهَا مَقْبَرَةٌ
u'لَهَا مِقْدَارٌ':Subject, #1: 1	لَهَا مِقْدَارَ
u'لَهَا مِقْدَارٌ':Subject, #1: 1	لَهَا مِقْدَارُ
u'لَهَا مُقَدَّرٌ':Subject, #2: 2	لَهَا مِقْدَارٌ
u'لَهَا مُقَدِّمٌ':Subject, #2: 2	لَهَا مُقَدَّرٌ
u'لَهَا مُقَدِّمَةٌ':Subject, #1: 1	لَهَا مُقَدِّمَةٌ
u'لَهَا مَقْسُومٌ':Subject, #1: 1	لَهَا مُقَدِّمَةٌ
u'لَهَا مُكَاتَبَةٌ':Predicate, #1: 1	لَهَا مَقْسُومُ
u'لَهَا مُكْحُلَةٌ':Subject, #1: 1	لَهَا الْمُكَاتَبَةَ
u'لَهَا مَكْرٌ':Subject, #1: 1	لَهَا مُكْحُلَةٌ
u'لَهَا مُكَمِّلٌ':Subject, #1: 1	لَهَا مَكْرٌ
u'لَهَا مَلاَحِظُ':Subject, #1: 1	لَهَا مُكَمِّلٌ
u'لَهَا مُلْتَزِمٌ':Predicate, #1: 1	لَهَا مَلَاحِظُ
u'لَهَا مِلْحَفَةٌ':Subject, #1: 1	لَهَا مُلْتَزِمِينَ
u'لَهَا مِلْكٌ':Predicate, #1: 1	لَهَا مِلْحَفَةٌ
u'لَهَا مَلِكٌ':Subject, #2: 2	لَهَا مِلْكَ
u'لَهَا مِلْكٌ':Subject, #1: 1	لَهَا الْمَلِكُ
u'لَهَا مَلَكٌ':Subject, #1: 1	لَهَا مِلْكُهُ
u'لَهَا مِلْكٌ':Subject, #2: 2	لَهَا الْمَلَكُ
u'لَهَا مِلْكٌ':Subject, #2: 2	لَهَا مِلْكٌ
u'لَهَا مَمَالِيكُ':Subject, #5: 5	لَهَا الْمِلْكُ
u'لَهَا مَمَرَّاتٍ':Subject, #3: 3	لَهَا مَمَالِيكُ
u'لَهَا مُمْكِنٌ':Subject, #1: 1	لَهَا مَمَرَّاتٌ
u'لَهَا مُمْكِن':Subject, #2: 2	لَهَا مُمْكِنٌ
u'لَهَا مَمْلُوكٌ':Subject, #2: 2	لَهَا مُمْكِنٌ
u'لَهَا مُنَاسَبَةٌ':Subject, #1: 1	لَهَا مَمْلُوكٌ
u'لَهَا مَنَافِعُ':Predicate, #2: 2	لَهَا مُنَاسَبَةٌ
u'لَهَا مَنْبَعٌ':Subject, #1: 1	لَهَا مَنَافِعَ
u'لَهَا مَنْزِلٌ':Subject, #1: 1	لَهَا مَنْبَعٌ
u'لَهَا مَنْزِلَةٌ':Predicate, #1: 1	لَهَا مَنْزِلٌ
u'لَهَا مَنْشُورٌ':Subject, #7: 7	لَهَا مَنْزِلَةَ
u'لَهَا مَنْعٌ':Predicate, #1: 1	لَهَا مَنْشُورٌ
u'لَهَا مَنْعٌ':Subject, #1: 1	لَهَا الْمَنْعَ
u'لَهَا مَنْعٌ':Subject, #2: 2	لَهَا مَنْعُهُ
u'لَهَا مَنْعٌ':Subject, #3: 3	لَهَا الْمَنْعُ
u'لَهَا مَنْعَةٌ':Subject, #6: 6	لَهَا مَنْعُ
u'لَهَا مَنَعَةٌ':Subject, #1: 1	لَهَا مَنْعَةٌ
u'لَهَا مِنْفَحَة':Subject, #2: 2	لَهَا مَنَعَةٌ
u'لَهَا مَنْفَذٌ':Subject, #1: 1	لَهَا الْمِنْفَحَةُ
u'لَهَا مُنْفَرِدٌ':Predicate, #1: 1	لَهَا مَنْفَذٌ
u'لَهَا مُنْفَصِلٌ':Subject, #1: 1	لَهَا مُنْفَرِدَةً
u'لَهَا مَنْفَعَةٌ':Subject, #1: 1	لَهَا مُنْفَصِلَةٌ
u'لَهَا مَنْكُوسٌ':Predicate, #4: 4	لَهَا مَنْفَعَةٌ
u'لَهَا مَهْدِيٌّ':Subject, #1: 1	لَهَا مَنْكُوسَةً
u'لَهَا مَهْرٌ':Predicate, #1: 1	لَهَا الْمَهْدِيُّ
u'لَهَا مَهْرٌ':Predicate, #18: 18	لَهَا الْمَهْرَ
u'لَهَا مَهْرٌ':Subject, #27: 27	لَهَا مَهْرَ
u'لَهَا مَهْرٌ':Subject, #26: 26	لَهَا مَهْرٌ
u'لَهَا مَهْرٌ':Subject, #32: 32	لَهَا الْمَهْرُ
u'لَهَا مُواعَدَة':Predicate, #95: 95	لَهَا مَهْرُ
u'لَهَا مُوَافِقٌ':Subject, #2: 2	لَهَا الْمُوَاعَدَةَ
u'لَهَا مَوْجُودٌ':Subject, #1: 1	لَهَا مُوَافِقَةٌ
u'لَهَا مَوْضِعٌ':Predicate, #2: 2	لَهَا مَوْجُودٌ
u'لَهَا مَوْضِعٌ':Subject, #1: 1	لَهَا مَوْضِعَ
u'لَهَا مَوْقِعٌ':Predicate, #3: 3	لَهَا مَوْضِعٌ
u'لَهَا مَوْقِعٌ':Subject, #1: 1	لَهَا الْمَوْقِعَ
u'لَهَا مَوْقِفٌ':Subject, #1: 1	لَهَا مَوْقِعٌ
u'لَهَا مُوَكِّلٌ':Subject, #1: 1	لَهَا مَوْقِفٌ
u'لَهَا مُؤَنَّثٌ':Subject, #1: 1	لَهَا الْمُوَكِّلُ
u'لَهَا مُؤْنِسٌ':Predicate, #1: 1	لَهَا مُؤَنَّثٌ
u'لَهَا مِيرَاثٌ':Predicate, #1: 1	لَهَا مُؤْنِسَةً
u'لَهَا مِيرَاثٌ':Subject, #4: 4	لَهَا الْمِيرَاثَ
u'لَهَا مِيرَاثٌ':Subject, #1: 1	لَهَا مِيرَاثُ
u'لَهَا مِيرَاثٌ':Subject, #27: 27	لَهَا الْمِيرَاثُ
u'لَهَا مَيْمُونٌ':Subject, #6: 6	لَهَا مِيرَاثٌ
u'لَهَا نَابٌ':Subject, #1: 1	لَهَا مَيْمُونَةُ
u'لَهَا نَارٌ':Subject, #1: 1	لَهَا نَابٌ
u'لَهَا نَازِلٌ':Subject, #1: 1	لَهَا النَّارُ
u'لَهَا نَازِلَةٌ':Subject, #4: 4	لَهَا نَازِلَةٌ
u'لَهَا نَاسٌ':Predicate, #4: 4	لَهَا نَازِلَةٌ
u'لَهَا نَاسٌ':Subject, #1: 1	لَهَا النَّاسَ
u'لَهَا نَاظِرٌ':Subject, #4: 4	لَهَا النَّاسُ
u'لَهَا نَاقِصٌ':Predicate, #2: 2	لَهَا نَاظِرٌ
u'لَهَا نَبْوَةٌ':Subject, #1: 1	لَهَا نَاقِصَةً
u'لَهَا نَبِيٌّ':Subject, #1: 1	لَهَا نَبْوَةٌ
u'لَهَا نَجَاسَةٌ':Subject, #25: 25	لَهَا النَّبِيُّ
u'لَهَا نَحْوٌ':Subject, #1: 1	لَهَا النَّجَاسَةُ
u'لَهَا نذر':Subject, #2: 2	لَهَا نَحْوُ
u'لَهَا نِساءٌ':Subject, #2: 2	لَهَا النّذُرُ
u'لَهَا نِسَبٌ':Subject, #22: 22	لَهَا النِّسَاءُ
u'لَهَا نَسَبٌ':Subject, #1: 1	لَهَا نِسَبٌ
u'لَهَا نِسْبَةٌ':Subject, #7: 7	لَهَا نَسَبٌ
u'لَهَا نِسْوَةٌ':Subject, #1: 1	لَهَا نِسْبَةٌ
u'لَهَا نَصٌّ':Predicate, #1: 1	لَهَا نِسْوَةٌ
u'لَهَا نَصٌّ':Subject, #2: 2	لَهَا نَصَّ
u'لَهَا نصرة':Subject, #1: 1	لَهَا النَّصُّ
u'لَهَا نِصْفٌ':Predicate, #1: 1	لَهَا نَصْرَةُ
u'لَهَا نِصْفٌ':Predicate, #24: 24	لَهَا نِصْفَ
u'لَهَا نِصْفٌ':Subject, #9: 9	لَهَا النِّصْفَ
u'لَهَا نِصْفٌ':Subject, #12: 12	لَهَا النِّصْفُ
u'لَهَا نِصْفٌ':Subject, #2: 2	لَهَا نِصْفٌ
u'لَهَا نِصْفٌ':Subject, #5: 5	لَهَا نِصْفُهُ
u'لَهَا نَصِيبٌ':Predicate, #98: 98	لَهَا نِصْفُ
u'لَهَا نَصِيبٌ':Subject, #1: 1	لَهَا نَصِيبَ
u'لَهَا نَصِيبٌ':Subject, #1: 1	لَهَا النَّصِيبُ
u'لَهَا نَصِيبٌ':Subject, #1: 1	لَهَا نَصِيبٌ
u'لَهَا نظائر':Predicate, #2: 2	لَهَا نَصِيبُ
u'لَهَا نظائر':Subject, #2: 2	لَهَا نَظَائِرَ
u'لَهَا نَظَرٌ':Subject, #4: 4	لَهَا نَظَائِرُ
u'لَهَا نَظَرٌ':Subject, #1: 1	لَهَا نَظَرٌ
u'لَهَا نَظَرٌ':Subject, #1: 1	لَهَا نَظَرُهُ
u'لَهَا نَظَرٌ':Subject, #2: 2	لَهَا نَظَرُ
u'لَهَا نَظِيرٌ':Subject, #5: 5	لَهَا النَّظَرُ
u'لَهَا نَعْتٌ':Subject, #2: 2	لَهَا نَظِيرُ
u'لَهَا نِعَمٌ':Subject, #1: 1	لَهَا نَعْتُ
u'لَهَا نفاس':Subject, #1: 1	لَهَا النِّعَمُ
u'لَهَا نِفَاسٌ':Subject, #1: 1	لَهَا نِفَاسٌ
u'لَهَا نَفْسٌ':Subject, #1: 1	لَهَا نِفَاسٌ
u'لَهَا نَفَسٌ':Subject, #1: 1	لَهَا النَّفْسُ
u'لَهَا نَفْسٌ':Subject, #1: 1	لَهَا نَفَسٌ
u'لَهَا نَفْعٌ':Subject, #3: 3	لَهَا نَفْسٌ
u'لَهَا نَفَقَةٌ':Predicate, #2: 2	لَهَا نَفْعٌ
u'لَهَا نَفَقَةٌ':Predicate, #20: 20	لَهَا نَفَقَةَ
u'لَهَا نَفَقَةٌ':Subject, #73: 73	لَهَا النَّفَقَةَ
u'لَهَا نَفَقَةٌ':Subject, #15: 15	لَهَا نَفَقَةُ
u'لَهَا نَفَقَةٌ':Subject, #18: 18	لَهَا نَفَقَةٌ
u'لَهَا نَفَلٌ':Subject, #85: 85	لَهَا النَّفَقَةُ
u'لَهَا نَقْصٌ':Subject, #1: 1	لَهَا نَفَلٌ
u'لَهَا نَقْضٌ':Predicate, #2: 2	لَهَا نَقْصٌ
u'لَهَا نقل':Predicate, #1: 1	لَهَا النَّقْضَ
u'لَهَا نَقْلٌ':Predicate, #1: 1	لَهَا نَقْلَ
u'لَهَا نقل':Subject, #1: 1	لَهَا نَقْلَ
u'لَهَا نَقْلٌ':Subject, #1: 1	لَهَا النَّقْلُ
u'لَهَا نقل':Subject, #1: 1	لَهَا النَّقْلُ
u'لَهَا نَقْلٌ':Subject, #1: 1	لَهَا نَقْلُ
u'لَهَا نقل':Subject, #1: 1	لَهَا نَقْلُ
u'لَهَا نَقْلٌ':Subject, #3: 3	لَهَا نَقْلُهُ
u'لَهَا نقلة':Subject, #3: 3	لَهَا نَقْلُهُ
u'لَهَا نِقْيٌ':Subject, #1: 1	لَهَا النَّقْلَةُ
u'لَهَا نَقِيبٌ':Subject, #1: 1	لَهَا نِقْيٌ
u'لَهَا نكاح':Predicate, #1: 1	لَهَا نَقِيبٌ
u'لَهَا نِكَاحٌ':Predicate, #1: 1	لَهَا نِكَاحَ
u'لَهَا نكاح':Subject, #1: 1	لَهَا نِكَاحَ
u'لَهَا نِكَاحٌ':Subject, #2: 2	لَهَا نِكَاحُ
u'لَهَا نكاح':Subject, #2: 2	لَهَا نِكَاحُ
u'لَهَا نِكَاحٌ':Subject, #3: 3	لَهَا نِكَاحٌ
u'لَهَا نكاح':Subject, #3: 3	لَهَا نِكَاحٌ
u'لَهَا نِكَاحٌ':Subject, #9: 9	لَهَا النِّكَاحُ
u'لَهَا نُكُولٌ':Subject, #9: 9	لَهَا النِّكَاحُ
u'لَهَا نَكِيرٌ':Subject, #1: 1	لَهَا النُّكُولُ
u'لَهَا نِهَايَةٌ':Subject, #1: 1	لَهَا نَكِيرُ
u'لَهَا نَهْيٌ':Subject, #2: 2	لَهَا نِهَايَةٌ
u'لَهَا نُورٌ':Subject, #1: 1	لَهَا نَهْيُهُ
u'لَهَا نَوْعٌ':Predicate, #3: 3	لَهَا نُورٌ
u'لَهَا نَوْعٌ':Subject, #2: 2	لَهَا نَوْعَ
u'لَهَا نَوْعٌ':Subject, #1: 1	لَهَا نَوْعٌ
u'لَهَا نِيَابَةٌ':Subject, #4: 4	لَهَا نَوْعُ
u'لَهَا نِيَّةٌ':Predicate, #1: 1	لَهَا نِيَابَةٌ
u'لَهَا نِيَّةٌ':Subject, #1: 1	لَهَا النِّيَّةَ
u'لَهَا نِيَّةٌ':Subject, #3: 3	لَهَا نِيَّةُ
u'لَهَا نِيَّةٌ':Subject, #7: 7	لَهَا نِيَّةٌ
u'لَهَا هَاشِمٌ':Subject, #9: 9	لَهَا النِّيَّةُ
u'لَهَا هِبَةٌ':Subject, #1: 1	لَهَا الْهَاشِمَةُ
u'لَهَا هجرة':Predicate, #1: 1	لَهَا هِبَةُ
u'لَهَا هِجْرَةٌ':Predicate, #1: 1	لَهَا الْهِجْرَةَ
u'لَهَا هِدَايَةٌ':Predicate, #1: 1	لَهَا الْهِجْرَةَ
u'لَهَا هَدِيٌّ':Predicate, #1: 1	لَهَا الْهِدَايَةَ
u'لَهَا هِرٌّ':Subject, #10: 10	لَهَا هَدِيَّةً
u'لَهَا هَفْوَةٌ':Subject, #1: 1	لَهَا الْهِرّةُ
u'لَهَا هِلاَلِيَّةٌ':Subject, #1: 1	لَهَا هَفْوَةٌ
u'لَهَا هَمٌّ':Subject, #2: 2	لَهَا الْهِلَالِيَّةُ
u'لَهَا هِنْدٌ':Subject, #1: 1	لَهَا هَمٌّ
u'لَهَا هَيْئَةٌ':Subject, #1: 1	لَهَا هِنْدٌ
u'لَهَا وَاثِقٌ':Subject, #1: 1	لَهَا هَيْئَةٌ
u'لَهَا وَاجِبٌ':Subject, #1: 1	لَهَا الْوَاثِقُ
u'لَهَا وَاجِبٌ':Subject, #1: 1	لَهَا وَاجِبٌ
u'لَهَا واحد':Predicate, #3: 3	لَهَا وَاجِبَةٌ
u'لَهَا وَاحِدٌ':Predicate, #1: 1	لَهَا وَاحِدَةً
u'لَهَا واحد':Subject, #1: 1	لَهَا وَاحِدَةً
u'لَهَا وَاحِدٌ':Subject, #1: 1	لَهَا وَاحِدَةٌ
u'لَهَا واحد':Subject, #1: 1	لَهَا وَاحِدَةٌ
u'لَهَا وَاحِدٌ':Subject, #2: 2	لَهَا وَاحِدٌ
u'لَهَا وَارِثٌ':Subject, #2: 2	لَهَا وَاحِدٌ
u'لَهَا وَارِثٌ':Subject, #2: 2	لَهَا الْوَارِثُ
u'لَهَا وَالِدٌ':Subject, #7: 7	لَهَا وَارِثٌ
u'لَهَا وَالِي':Predicate, #1: 1	لَهَا وَالِدَتُهُ
u'لَهَا وَتَرٌ':Predicate, #1: 1	لَهَا وَالِيَ
u'لَهَا وثاب':Subject, #2: 2	لَهَا وَتَرَكَ
u'لَهَا وِثَابٌ':Subject, #1: 1	لَهَا وِثَابُ
u'لَهَا وَجَبٌ':Predicate, #1: 1	لَهَا وِثَابُ
u'لَهَا وَجْهٌ':Subject, #2: 2	لَهَا وَجَبَ
u'لَهَا وُجُوبٌ':Predicate, #2: 2	لَهَا وَجْهٌ
u'لَهَا وُجُوبٌ':Subject, #1: 1	لَهَا وُجُوبَ
u'لَهَا وُجُودٌ':Subject, #2: 2	لَهَا الْوُجُوبُ
u'لَهَا وُجُوهٌ':Subject, #3: 3	لَهَا وُجُودٌ
u'لَهَا وَرَثَةٌ':Subject, #2: 2	لَهَا وُجُوهٌ
u'لَهَا وسط':Subject, #1: 1	لَهَا وَرَثَةٌ
u'لَهَا وَسَطٌ':Subject, #3: 3	لَهَا الْوَسَطُ
u'لَهَا وَصْفٌ':Subject, #3: 3	لَهَا الْوَسَطُ
u'لَهَا وصل':Subject, #1: 1	لَهَا وَصْفٌ
u'لَهَا وَصْلٌ':Subject, #1: 1	لَهَا وَصْلُ
u'لَهَا وَصِيٌّ':Subject, #1: 1	لَهَا وَصْلُ
u'لَهَا وَصِيٌّ':Subject, #1: 1	لَهَا وَصِيٌّ
u'لَهَا وَصِيَّةٌ':Subject, #2: 2	لَهَا الْوَصِيَّةُ
u'لَهَا وُضُوءٌ':Subject, #2: 2	لَهَا الْوَصِيَّةُ
u'لَهَا وَقْتٌ':Predicate, #8: 8	لَهَا الْوُضُوءُ
u'لَهَا وَقْتٌ':Subject, #6: 6	لَهَا وَقْتَ
u'لَهَا وَقْتٌ':Subject, #11: 11	لَهَا وَقْتٌ
u'لَهَا وقع':Predicate, #4: 4	لَهَا وَقْتُ
u'لَهَا وَقْعٌ':Subject, #2: 2	لَهَا وَقَعَ
u'لَهَا وقعة':Subject, #10: 10	لَهَا وَقْعٌ
u'لَهَا وَقْعَةٌ':Subject, #1: 1	لَهَا وَقْعَةٌ
u'لَهَا وُقُوفٌ':Subject, #1: 1	لَهَا وَقْعَةٌ
u'لَهَا وَكِيلٌ':Predicate, #1: 1	لَهَا الْوُقُوفُ
u'لَهَا وَكِيلٌ':Subject, #1: 1	لَهَا وَكِيلَ
u'لَهَا وَلاَءٌ':Subject, #17: 17	لَهَا الْوَكِيلُ
u'لَهَا وُلاَةٌ':Subject, #1: 1	لَهَا وَلاَءٌ
u'لَهَا وِلاَيَةٌ':Predicate, #2: 2	لَهَا وُلَاةٌ
u'لَهَا وِلاَيَةٌ':Predicate, #1: 1	لَهَا وِلَايَةَ
u'لَهَا وِلاَيَةٌ':Subject, #3: 3	لَهَا الْوِلَايَةَ
u'لَهَا وِلاَيَةٌ':Subject, #10: 10	لَهَا وِلَايَةُ
u'لَهَا وَلَدٌ':Subject, #1: 1	لَهَا الْوِلَايَةُ
u'لَهَا وَلَهٌ':Subject, #52: 52	لَهَا وَلَدٌ
u'لَهَا وَلِيٌّ':Subject, #7: 7	لَهَا وَلَهُ
u'لَهَا وَلِيٌّ':Subject, #1: 1	لَهَا وَلِيُّ
u'لَهَا وَلِيٌّ':Subject, #1: 1	لَهَا وَلِيُّهُ
u'لَهَا وَلِيٌّ':Subject, #47: 47	لَهَا وَلِيٌّ
u'لَهَا وهبة':Subject, #8: 8	لَهَا الْوَلِيُّ
u'لَهَا يَدٌ':Subject, #1: 1	لَهَا وَهِبَةُ
u'لَهَا يسار':Subject, #2: 2	لَهَا يَدٌ
u'لَهَا يَسَارٌ':Subject, #1: 1	لَهَا يَسَارٌ
u'لَهَا يَعْقُوبٌ':Subject, #1: 1	لَهَا يَسَارٌ
u'لَهَا يَقِينٌ':Subject, #1: 1	لَهَا يَعْقُوبُ
u'لَهَا يَقِينٌ':Subject, #3: 3	لَهَا يَقِينٌ
u'لَهَا يَوْمٌ':Predicate, #4: 4	لَهَا يَقِينُ
u'لَهَا يَوْمٌ':Subject, #14: 14	لَهَا يَوْمَ
u'لَهَا يَوْمٌ':Subject, #1: 1	لَهَا الْيَوْمُ
u'لَهَبٌ حَرِيقٌ':Added, #2: 2	لَهَا يَوْمٌ
u'لَهَبٌ نَارٌ':Added, #1: 1	لَهَبُ الْحَرِيقِ
u'لَهَبٌ نَارٌ':Added, #1: 1	لَهَبِ النَّارِ
u'لَهْوٌ اِبْنٌ':Added, #1: 1	لَهَبِ نَارِ
u'لَهْوٌ حَديثٌ':Added, #1: 1	لَهْوِ ابْنِ
u'لَهْوٌ عُرْسٌ':Added, #15: 15	لَهْوَ الْحَدِيثِ
u'لَهْوٌ مُحَرَّمٌ':Added, #1: 1	لَهْوِ عُرْسٍ
u'لَهْوٌ مُؤْمِنٌ':Added, #1: 1	لَهْوٍ مُحَرَّمٍ
u'لَهْوٌ مُؤْمِنٌ':Added, #1: 1	لَهْوِ الْمُؤْمِنِ
u'لَهِيَ أَشَدُّ':Subject, #2: 2	لَهْوُ الْمُؤْمِنِ
u'لَوَّحَ مُصَنِّفٌ':Subject, #1: 1	لَهِيَ أَشَدُّ
u'لَوْحٌ مَغْصُوب':Added, #1: 1	لَوَّحَ الْمُصَنِّفُ
u'لَوْحٌ مَوْضُوعٌ':Added, #1: 1	لَوْحٍ مَغْصُوبٍ
u'لَوْحٌ وَقْفٌ':Added, #1: 1	لَوْحٍ مَوْضُوعٍ
u'لُؤْمٌ بُخْلٌ':Added, #2: 2	لَوْحَ الْوَقْفِ
u'لَوْمٌ بَعْضٌ':Added, #1: 1	لُؤْمَ الْبُخْلِ
u'لَوْمَةٌ لاَئِمٌ':Added, #1: 1	لَوْمِ بَعْضِ
u'لَوْمَةٌ لاَئِمٌ':Added, #11: 11	لَوْمَةَ لَائِمٍ
u'لَوْمَةٌ لاَئِمٌ':Added, #4: 4	لَوْمَةُ لاَئِمٍ
u'لَوْمَةٌ لاَئِمٌ':Added, #6: 6	لَوْمَةَ لاَئِمٍ
u'لَوْمٌ تَائِبٌ':Added, #8: 8	لَوْمَةُ لَائِمٍ
u'لُؤْمٌ طَبْعٌ':Added, #2: 2	لَوْمُ التَّائِبِ
u'لُؤْمٌ طَبْعٌ':Added, #1: 1	لُؤْمُ الطَّبْعِ
u'لُؤْمٌ طَبْعٌ':Added, #1: 1	لُؤْمِ الطَّبْعِ
u'لَوْمٌ عَوَاذِلُ':Added, #1: 1	لُؤْمِ طَبْعٍ
u'لِينٌ بدن':Added, #1: 1	لَوْمَ الْعَوَاذِلِ
u'لِينٌ بَدَنٌ':Added, #2: 2	لِينَ الْبَدَنِ
u'لِينٌ جَانِبٌ':Added, #2: 2	لِينَ الْبَدَنِ
u'لِينٌ حَرِيرٌ':Added, #1: 1	لِينَ الْجَانِبِ
u'لِينٌ عَيْشٌ':Added, #1: 1	لِينَ الْحَرِيرِ
u'لِينٌ قدم':Added, #1: 1	لِينِ الْعَيْشِ
u'لِينٌ قَدَمٌ':Added, #1: 1	لِينَ الْقَدَمِ
u'لِينٌ قُلُوبٌ':Added, #1: 1	لِينَ الْقَدَمِ
u'لَيَّنَ قول':Predicate, #1: 1	لِينِ الْقُلُوبِ
u'لَيَّنَ قَوْلٌ':Predicate, #1: 1	لَيَّنَ الْقَوْلَ
u'لِينٌ كَلاَمٌ':Added, #1: 1	لَيَّنَ الْقَوْلَ
u'لِينٌ لَفْظٌ':Added, #1: 1	لِينِ الْكَلَامِ
u'لِينٌ مَكَانٌ':Added, #1: 1	لِينَ اللَّفْظِ
u'مَاءَ فلان':Predicate, #1: 1	لِينِ الْمَكَانِ
u'مَاتَ أَبٌ':Subject, #4: 4	مَاءَ دِجْلَةَ
u'مَاتَ أَبٌ':Subject, #101: 101	مَاتَ الْأَبُ
u'مَاتَ آباءٌ':Subject, #4: 4	مَاتَ أَبُ
u'مَاتَ اِبْنٌ':Predicate, #1: 1	مَاتَ الْآبَاءُ
u'مَاتَ اِبْنٌ':Subject, #1: 1	مَاتَ ابْنَ
u'مَاتَ اِبْنٌ':Subject, #30: 30	مَاتَ ابْنُ
u'مَاتَ اِبْنٌ':Subject, #6: 6	مَاتَ ابْنٌ
u'مَاتَ أَثْناءُ':Predicate, #7: 7	مَاتَ ابْنُهُ
u'مَاتَ أُجْرَةٌ':Subject, #6: 6	مَاتَ أَثْنَاءَ
u'مَاتَ أَجْنَبِيٌّ':Subject, #1: 1	مَاتَ أُجْرَةٌ
u'مَاتَ أَجِيرٌ':Subject, #2: 2	مَاتَ الْأَجْنَبِيُّ
u'مَاتَ أَجِيرٌ':Subject, #2: 2	مَاتَ الْأَجِيرُ
u'مَاتَ أحَدٌ':Subject, #4: 4	مَاتَ أَجِيرُ
u'مَاتَ أحَدٌ':Subject, #14: 14	مَاتَ أَحَدٌ
u'مَاتَ أَخٌ':Subject, #99: 99	مَاتَ أَحَدُ
u'مَاتَ أَخٌ':Subject, #1: 1	مَاتَ أَخٌ
u'مَاتَ أَخٌ':Subject, #1: 1	مَاتَ الأَخُ
u'مَاتَ آخِرُ':Subject, #7: 7	مَاتَ الْأَخُ
u'مَاتَ أَخِيرٌ':Subject, #1: 1	مَاتَ الآخِرُ
u'مَاتَ أَسْرَعُ':Predicate, #2: 2	مَاتَ الْأَخِيرُ
u'مَاتَ أَسْفَلُ':Subject, #1: 1	مَاتَ أَسْرَعَ
u'مَاتَ أَشْهَب':Subject, #4: 4	مَاتَ الْأَسْفَلُ
u'مَاتَ أصدقاء':Subject, #1: 1	مَاتَ أَشْهَبُ
u'مَاتَ أصْغَرٌ':Subject, #1: 1	مَاتَ أَصْدِقَاءُ
u'مَاتَ أَصْغَرُ':Subject, #1: 1	مَاتَ الْأَصْغَرُ
u'مَاتَ أصل':Subject, #1: 1	مَاتَ الْأَصْغَرُ
u'مَاتَ أًصْلٌ':Subject, #3: 3	مَاتَ الْأَصْلُ
u'مَاتَ أَصيلٌ':Subject, #3: 3	مَاتَ الْأَصْلُ
u'مَاتَ أقارب':Subject, #4: 4	مَاتَ الْأَصِيلُ
u'مَاتَ أَقْرَانٌ':Subject, #2: 2	مَاتَ أَقَارِبُهُ
u'مَاتَ أقْرَبُ':Subject, #1: 1	مَاتَ الْأَقْرَانُ
u'مَاتَ أقْرَع':Predicate, #3: 3	مَاتَ الْأَقْرَبُ
u'مَاتَ أَكْثَرُ':Subject, #3: 3	مَاتَ أَقْرَعَ
u'مَاتَ أكل':Predicate, #1: 1	مَاتَ الْأَكْثَرُ
u'مَاتَ ألف':Subject, #1: 1	مَاتَ أُكِلَ
u'مَاتَ ألْفٌ':Subject, #1: 1	مَاتَ أَلْفُ
u'مَاتَ أَلْفٌ':Subject, #1: 1	مَاتَ أَلْفُ
u'مَاتَ الْمَرْءُ':Subject, #1: 1	مَاتَ أَلْفُ
u'مَاتَ إمَامٌ':Subject, #1: 1	مَاتَ الْمَرْءُ
u'مَاتَ إمَامٌ':Subject, #1: 1	أَمَاتَ الْإِمَامُ
u'مَاتَ إمَامٌ':Subject, #1: 1	مَاتَ إمَامٌ
u'مَاتَ آمِرٌ':Subject, #8: 8	مَاتَ الْإِمَامُ
u'مَاتَ أَميرٌ':Subject, #5: 5	مَاتَ الْآمِرُ
u'مَاتَ إِنْسانٌ':Subject, #2: 2	مَاتَ أَمِيرُ
u'مَاتَ إِنْسانٌ':Subject, #1: 1	مَاتَ الإِنْسَانُ
u'مَاتَ إِنْسانٌ':Subject, #1: 1	مَاتَ الْإِنْسَانُ
u'مَاتَ إِنْسانٌ':Subject, #1: 1	مَاتَ إِنْسَانٌ
u'مَاتَ أهْلٌ':Subject, #6: 6	مَاتَ إنْسَانٌ
u'مَاتَ أَوَّلُ':Subject, #1: 1	مَاتَ أَهْلُ
u'مَاتَ أَوْلاَدٌ':Subject, #27: 27	مَاتَ الْأَوَّلُ
u'مَاتَ أَوْلاَدٌ':Subject, #2: 2	مَاتَ الْأَوْلَادُ
u'مَاتَ بادِئٌ':Subject, #3: 3	مَاتَ أَوْلَادُ
u'مَاتَ بَائِعٌ':Subject, #4: 4	مَاتَ الْبَادِئُ
u'مَاتَ بَائِعٌ':Subject, #1: 1	مَاتَ بَائِعٌ
u'مَاتَ بَرِّيٌّ':Subject, #24: 24	مَاتَ الْبَائِعُ
u'مَاتَ بِشْرٌ':Subject, #2: 2	مَاتَ بَرِّيٌّ
u'مَاتَ بِشْرٌ':Subject, #4: 4	مَاتَ بِشْرٌ
u'مَاتَ بَطَلٌ':Predicate, #5: 5	مَاتَ بِشْرُ
u'مَاتَ بَطْنٌ':Subject, #10: 10	مَاتَ بَطَلَ
u'مَاتَ بَعْضٌ':Subject, #3: 3	مَاتَ الْبَطْنُ
u'مَاتَ بَعْضٌ':Subject, #15: 15	مَاتَ بَعْضُ
u'مَاتَ بَعْضٌ':Subject, #1: 1	مَاتَ بَعْضٌ
u'مَاتَ بَغْلٌ':Subject, #3: 3	مَاتَ الْبَعْضُ
u'مَاتَ بَقَرٌ':Subject, #2: 2	مَاتَ بَغْلٌ
u'مَاتَ بَنَّاءٌ':Subject, #2: 2	مَاتَ بَقَرُ
u'مَاتَ بَيْنٌ':Predicate, #1: 1	مَاتَ الْبَنَّاءُ
u'مَاتَ ثَابِتٌ':Subject, #6: 6	مَاتَ بَيْنَ
u'مَاتَ ثَابِتٌ':Subject, #1: 1	مَاتَ ثَابِتُ
u'مَاتَ ثَالِثٌ':Subject, #3: 3	مَاتَ الثَّابِتُ
u'مَاتَ ثَالِثٌ':Subject, #1: 1	مَاتَ الثَّالِثُ
u'مَاتَ ثَلاثُ':Predicate, #1: 1	مَاتَ ثَالِثٌ
u'مَاتَ ثَلاثَةٌ':Subject, #1: 1	مَاتَ ثَلَاثَ
u'مَاتَ جَازٌ':Predicate, #1: 1	مَاتَ الثَّلَاثَةُ
u'مَاتَ جَبَلٌ':Subject, #6: 6	مَاتَ جَازَ
u'مَاتَ جَدْيٌ':Subject, #1: 1	مَاتَ جَبَلُ
u'مَاتَ جَرِيحٌ':Subject, #1: 1	مَاتَ جَدْيٌ
u'مَاتَ جَمَاعَةٌ':Subject, #3: 3	مَاتَ الْجَرِيحُ
u'مَاتَ جَمَلٌ':Subject, #3: 3	مَاتَ جَمَاعَةٌ
u'مَاتَ جُنْدِيٌّ':Subject, #1: 1	مَاتَ جَمَلُهُ
u'مَاتَ جَنِينٌ':Subject, #1: 1	مَاتَ الْجُنْدِيُّ
u'مَاتَ حاجٌّ':Subject, #2: 2	مَاتَ الْجَنِينُ
u'مَاتَ حاجِبٌ':Subject, #5: 5	مَاتَ الْحَاجُّ
u'مَاتَ حاضِرٌ':Subject, #1: 1	مَاتَ الْحَاجِبُ
u'مَاتَ حاضِنٌ':Subject, #4: 4	مَاتَ الْحَاضِرُ
u'مَاتَ حالٌ':Predicate, #1: 1	مَاتَ الْحَاضِنُ
u'مَاتَ حَتْفٌ':Predicate, #3: 3	مَاتَ حَالَ
u'مَاتَ حُرٌّ':Subject, #29: 29	مَاتَ حَتْفَ
u'مَاتَ حُرٌّ':Subject, #1: 1	مَاتَ حُرٌّ
u'مَاتَ حَسَنٌ':Subject, #3: 3	مَاتَ الْحُرُّ
u'مَاتَ حِصَّةٌ':Subject, #5: 5	مَاتَ الْحَسَنُ
u'مَاتَ حَصَلٌ':Predicate, #1: 1	مَاتَ حِصَّتُهُ
u'مَاتَ حَكَمٌ':Subject, #1: 1	مَاتَ حَصَلَ
u'مَاتَ حَلٌّ':Predicate, #1: 1	مَاتَ الْحَكَمُ
u'مَاتَ حَلالٌ':Subject, #3: 3	مَاتَ حَلَّ
u'مَاتَ حَمَّالٌ':Subject, #1: 1	مَاتَ حَلَالٌ
u'مَاتَ حَمْلٌ':Subject, #1: 1	مَاتَ الْحَمَّالُ
u'مَاتَ حَيَوَانٌ':Subject, #2: 2	مَاتَ الْحَمْلُ
u'مَاتَ حَيَوَانٌ':Subject, #1: 1	مَاتَ حَيَوَانٌ
u'مَاتَ خَادِمٌ':Subject, #3: 3	مَاتَ الْحَيَوَانُ
u'مَاتَ خَارِجٌ':Predicate, #2: 2	مَاتَ الْخَادِمُ
u'مَاتَ خَارِجٌ':Subject, #1: 1	مَاتَ خَارِجَ
u'مَاتَ خَالِدٌ':Subject, #3: 3	مَاتَ الْخَارِجُ
u'مَاتَ خامس':Subject, #1: 1	مَاتَ خَالِدُ
u'مَاتَ خَامِسٌ':Subject, #2: 2	مَاتَ الْخَامِسُ
u'مَاتَ خَزَّانٌ':Subject, #2: 2	مَاتَ الْخَامِسُ
u'مَاتَ خَصْمٌ':Subject, #1: 1	مَاتَ خَزَّانُ
u'مَاتَ خَصِيٌّ':Subject, #3: 3	مَاتَ الْخَصْمُ
u'مَاتَ خَطَأٌ':Subject, #2: 2	مَاتَ الْخَصِيُّ
u'مَاتَ خَطِيبٌ':Subject, #1: 1	مَاتَ خَطَأٌ
u'مَاتَ خَطِيبٌ':Subject, #1: 1	مَاتَ الْخَطِيبُ
u'مَاتَ خَلْقٌ':Subject, #1: 1	مَاتَ خَطِيبُ
u'مَاتَ خَلِيفَةٌ':Subject, #1: 1	مَاتَ خَلْقٌ
u'مَاتَ دَاخِلٌ':Subject, #7: 7	مَاتَ الْخَلِيفَةُ
u'مَاتَ دَافِعٌ':Subject, #3: 3	مَاتَ الدَّاخِلُ
u'مَاتَ دَائِنٌ':Subject, #3: 3	مَاتَ الدَّافِعُ
u'مَاتَ دَخَلٌ':Predicate, #1: 1	مَاتَ الدَّائِنُ
u'مَاتَ دفن':Predicate, #5: 5	مَاتَ دَخَلَ
u'مَاتَ دَليلٌ':Subject, #2: 2	مَاتَ دُفِنَ
u'مَاتَ دُودٌ':Subject, #1: 1	مَاتَ دَلِيلُ
u'مَاتَ دونٌ':Predicate, #2: 2	مَاتَ دُودُ
u'مَاتَ دونٌ':Subject, #1: 1	مَاتَ دُونَ
u'مَاتَ دِيَةٌ':Subject, #1: 1	مَاتَ دُونُ
u'مَاتَ ذكر':Predicate, #1: 1	مَاتَ الدِّيَةُ
u'مَاتَ ذكر':Predicate, #1: 1	مَاتَ ذُكِرَ
u'مَاتَ ذَكَرٌ':Predicate, #2: 2	مَاتَ ذَكَرَ
u'مَاتَ ذكر':Subject, #2: 2	مَاتَ ذَكَرَ
u'مَاتَ ذَكَرٌ':Subject, #1: 1	مَاتَ الذَّكَرُ
u'مَاتَ ذِمِّيٌّ':Subject, #1: 1	مَاتَ الذَّكَرُ
u'مَاتَ ذِمِّيٌّ':Subject, #12: 12	مَاتَ ذِمِّيٌّ
u'مَاتَ ذَهَبٌ':Predicate, #3: 3	مَاتَ الذِّمِّيُّ
u'مَاتَ رابع':Subject, #2: 2	مَاتَ ذَهَبَ
u'مَاتَ رَابِعٌ':Subject, #1: 1	مَاتَ رَابِعٌ
u'مَاتَ رَاجِعٌ':Subject, #1: 1	مَاتَ رَابِعٌ
u'مَاتَ رَافِعٌ':Subject, #1: 1	مَاتَ رَاجِعٌ
u'مَاتَ رَاكِبٌ':Subject, #1: 1	مَاتَ رَافِعُ
u'مَاتَ رَاهِنٌ':Subject, #4: 4	مَاتَ الرَّاكِبُ
u'مَاتَ رَاهِنٌ':Subject, #1: 1	مَاتَ رَاهِنُهُ
u'مَاتَ رَبُّ':Subject, #33: 33	مَاتَ الرَّاهِنُ
u'مَاتَ رَبُّ':Subject, #38: 38	مَاتَ رَبُّ
u'مَاتَ رَجُلٌ':Subject, #5: 5	مَاتَ رَبُّهُ
u'مَاتَ رَجُلٌ':Subject, #52: 52	مَاتَ رَجُلٌ
u'مَاتَ رَسُولٌ':Subject, #78: 78	مَاتَ الرَّجُلُ
u'مَاتَ رَسُولٌ':Subject, #1: 1	أَمَاتَ رَسُولُ
u'مَاتَ رَسُولٌ':Subject, #1: 1	مَاتَ الرّسُولُ
u'مَاتَ رَسُولٌ':Subject, #1: 1	مَاتَ الرَّسُولُ
u'مَاتَ رَقيقٌ':Subject, #23: 23	مَاتَ رَسُولُ
u'مَاتَ رَقيق':Subject, #1: 1	مَاتَ الرَّقِيقُ
u'مَاتَ رَقيقٌ':Subject, #1: 1	مَاتَ الرَّقِيقُ
u'مَاتَ رَقيق':Subject, #1: 1	مَاتَ رَقِيقٌ
u'مَاتَ رَهْنٌ':Subject, #1: 1	مَاتَ رَقِيقٌ
u'مَاتَ رَئِيسٌ':Subject, #1: 1	مَاتَ الرَّهْنُ
u'مَاتَ زَمَنٌ':Predicate, #1: 1	مَاتَ رَئِيسٌ
u'مَاتَ زَوْجٌ':Subject, #2: 2	مَاتَ زَمَنَ
u'مَاتَ زَوْجٌ':Subject, #116: 116	مَاتَ الزَّوْجُ
u'مَاتَ زَوْجٌ':Subject, #15: 15	مَاتَ زَوْجُ
u'مَاتَ زَيْدٌ':Subject, #1: 1	مَاتَ زَوْجٌ
u'مَاتَ زَيْدٌ':Subject, #12: 12	مَاتَ زَيْدٌ
u'مَاتَ زَيْدٌ':Subject, #1: 1	أَمَاتَ زَيْدٌ
u'مَاتَ سَاقِطٌ':Subject, #1: 1	مَاتَ زَيْدُ
u'مَاتَ سَاكِتٌ':Subject, #2: 2	مَاتَ السَّاقِطُ
u'مَاتَ سَبْعَةٌ':Subject, #2: 2	مَاتَ السَّاكِتُ
u'مَاتَ سَعْدٌ':Subject, #1: 1	مَاتَ سَبْعَةٌ
u'مَاتَ سَعْدٌ':Subject, #2: 2	مَاتَ سَعْدٌ
u'مَاتَ سَعِيدٌ':Subject, #4: 4	مَاتَ سَعْدُ
u'مَاتَ سَفِيهٌ':Subject, #2: 2	مَاتَ سَعِيدُ
u'مَاتَ سقط':Predicate, #1: 1	مَاتَ السَّفِيهُ
u'مَاتَ سَقَطٌ':Predicate, #10: 10	مَاتَ سَقَطَ
u'مَاتَ سُلْطَانٌ':Subject, #10: 10	مَاتَ سَقَطَ
u'مَاتَ سَنَةٌ':Predicate, #1: 1	مَاتَ السُّلْطَانُ
u'مَاتَ سَهْلٌ':Subject, #7: 7	مَاتَ سَنَةَ
u'مَاتَ سَهْلٌ':Subject, #1: 1	مَاتَ سَهْلٌ
u'مَاتَ سَواءٌ':Subject, #1: 1	مَاتَ سَهْلُ
u'مَاتَ سَيِّدٌ':Subject, #1: 1	مَاتَ سَوَاءٌ
u'مَاتَ سَيِّدٌ':Subject, #46: 46	مَاتَ السَّيِّدُ
u'مَاتَ سَيِّدٌ':Subject, #5: 5	مَاتَ سَيِّدُ
u'مَاتَ شَارِبٌ':Subject, #6: 6	مَاتَ سَيِّدُهُ
u'مَاتَ شَاهِدٌ':Subject, #1: 1	مَاتَ شَارِبُ
u'مَاتَ شَاهِدٌ':Subject, #1: 1	مَاتَ الشَّاهِدُ
u'مَاتَ شَخْصٌ':Subject, #1: 1	مَاتَ شَاهِدُهُ
u'مَاتَ شَخْصٌ':Subject, #1: 1	مَاتَ الشَّخْصُ
u'مَاتَ شَرِيكٌ':Subject, #6: 6	مَاتَ شَخْصٌ
u'مَاتَ شَفِيعٌ':Subject, #2: 2	مَاتَ شَرِيكُ
u'مَاتَ شُهُودٌ':Subject, #16: 16	مَاتَ الشَّفِيعُ
u'مَاتَ شُهُودٌ':Subject, #1: 1	مَاتَ شُهُودُهُ
u'مَاتَ شَيْءٌ':Subject, #2: 2	مَاتَ الشُّهُودُ
u'مَاتَ شَيْخٌ':Subject, #1: 1	مَاتَ شَيْءٌ
u'مَاتَ صَاحِبٌ':Subject, #1: 1	مَاتَ الشَّيْخُ
u'مَاتَ صَاحِبٌ':Subject, #25: 25	مَاتَ صَاحِبُ
u'مَاتَ صَانِعٌ':Subject, #5: 5	مَاتَ صَاحِبُهُ
u'مَاتَ صَبِيٌّ':Subject, #2: 2	مَاتَ الصَّانِعُ
u'مَاتَ صَبِيٌّ':Subject, #1: 1	مَاتَ صَبِيٌّ
u'مَاتَ صَحِيحٌ':Subject, #26: 26	مَاتَ الصَّبِيُّ
u'مَاتَ صَغِيرٌ':Subject, #1: 1	مَاتَ الصَّحِيحُ
u'مَاتَ صَغِيرٌ':Subject, #1: 1	مَاتَ صَغِيرٌ
u'مَاتَ صنع':Predicate, #7: 7	مَاتَ الصَّغِيرُ
u'مَاتَ صَيْدٌ':Subject, #1: 1	مَاتَ صُنِعَ
u'مَاتَ صَيْدٌ':Subject, #1: 1	مَاتَ صَيْدٌ
u'مَاتَ صَيْرَفِيٌّ':Subject, #5: 5	مَاتَ الصَّيْدُ
u'مَاتَ ضَامِنٌ':Subject, #2: 2	مَاتَ الصَّيْرَفِيُّ
u'مَاتَ ضَمِنٌ':Predicate, #1: 1	مَاتَ الضَّامِنُ
u'مَاتَ طَالِبٌ':Subject, #3: 3	مَاتَ ضَمِنَ
u'مَاتَ طَالِبٌ':Subject, #15: 15	مَاتَ الطَّالِبُ
u'مَاتَ طَائِرٌ':Subject, #1: 1	مَاتَ طَالِبُ
u'مَاتَ طِفْلٌ':Subject, #1: 1	مَاتَ طَائِرٌ
u'مَاتَ طِفْلٌ':Subject, #1: 1	مَاتَ الطِّفْلُ
u'مَاتَ ظالِمٌ':Subject, #1: 1	مَاتَ طِفْلٌ
u'مَاتَ عَاشِرٌ':Predicate, #1: 1	مَاتَ الظَّالِمُ
u'مَاتَ ُعَاشِرٌ':Predicate, #1: 1	مَاتَ عَاشِرَ
u'مَاتَ عَاقِدٌ':Subject, #1: 1	مَاتَ عَاشِرَ
u'مَاتَ عَامٌ':Predicate, #2: 2	مَاتَ الْعَاقِدُ
u'مَاتَ عَامِلٌ':Subject, #3: 3	مَاتَ عَامَ
u'مَاتَ عَامِلٌ':Subject, #1: 1	مَاتَ عَامِلُ
u'مَاتَ عَبْدٌ':Subject, #25: 25	مَاتَ الْعَامِلُ
u'مَاتَ عَبْدٌ':Subject, #14: 14	مَاتَ عَبْدُ
u'مَاتَ عَبْدٌ':Subject, #173: 173	مَاتَ الْعَبْدُ
u'مَاتَ عتق':Predicate, #1: 1	مَاتَ عَبْدُهُ
u'مَاتَ عَتِيقٌ':Subject, #17: 17	مَاتَ عَتَقَ
u'مَاتَ عَتِيقٌ':Subject, #13: 13	مَاتَ الْعَتِيقُ
u'مَاتَ عَدْلٌ':Subject, #3: 3	مَاتَ عَتِيقُهُ
u'مَاتَ عَقِبٌ':Predicate, #8: 8	مَاتَ الْعَدْلُ
u'مَاتَ عَقِبٌ':Subject, #7: 7	مَاتَ عَقِبَ
u'مَاتَ عَقِيبٌ':Predicate, #1: 1	مَاتَ الْعَقِبُ
u'مَاتَ عَلْقَم':Subject, #2: 2	مَاتَ عَقِيبَ
u'مَاتَ عَلْقَمَة':Subject, #1: 1	مَاتَ عَلْقَمَةُ
u'مَاتَ عَلِيٌّ':Subject, #1: 1	مَاتَ عَلْقَمَةُ
u'مَاتَ عَلِيٌّ':Subject, #1: 1	مَاتَ عَلِيٌّ
u'مَاتَ عَمٌّ':Subject, #4: 4	مَاتَ عَلِيُّ
u'مَاتَ عُمَرٌ':Subject, #2: 2	مَاتَ الْعَمُّ
u'مَاتَ عند':Predicate, #9: 9	مَاتَ عُمَرُ
u'مَاتَ غَاصِبٌ':Subject, #21: 21	مَاتَ عِنْدَ
u'مَاتَ غَائِبٌ':Subject, #2: 2	مَاتَ الْغَاصِبُ
u'مَاتَ غَرِيبٌ':Subject, #8: 8	مَاتَ الْغَائِبُ
u'مَاتَ غَرِيمٌ':Subject, #1: 1	مَاتَ الْغَرِيبُ
u'مَاتَ غُلاَمٌ':Subject, #6: 6	مَاتَ الْغَرِيمُ
u'مَاتَ غُلاَمٌ':Subject, #1: 1	مَاتَ الْغُلاَمُ
u'مَاتَ غير':Predicate, #2: 2	مَاتَ الْغُلَامُ
u'مَاتَ غَيْرٌ':Predicate, #3: 3	مَاتَ غَيْرَ
u'مَاتَ غير':Subject, #3: 3	مَاتَ غَيْرَ
u'مَاتَ غَيْرٌ':Subject, #1: 1	مَاتَ غَيْرُ
u'مَاتَ فَارِسٌ':Subject, #1: 1	مَاتَ غَيْرُ
u'مَاتَ فَاعِلٌ':Subject, #2: 2	مَاتَ الْفَارِسُ
u'مَاتَ فَرَزْدَقٌ':Subject, #1: 1	مَاتَ الْفَاعِلُ
u'مَاتَ فَرَسٌ':Subject, #1: 1	مَاتَ الْفَرَزْدَقُ
u'مَاتَ فَرَسٌ':Subject, #4: 4	مَاتَ الْفَرَسُ
u'مَاتَ فُضُولِيٌّ':Subject, #5: 5	مَاتَ فَرَسُهُ
u'مَاتَ فَلًا':Predicate, #2: 2	مَاتَ الْفُضُولِيُّ
u'مَاتَ فُلاَنٌ':Subject, #2: 2	مَاتَ فَلاَ
u'مَاتَ فلان':Subject, #1: 1	أَمَاتَ فُلَانٌ
u'مَاتَ فلان':Subject, #1: 1	مَاتَ الْمُتَصَدِّقُ
u'مَاتَ فلان':Subject, #1: 1	مَاتَ جَعْفَرٌ
u'مَاتَ فلان':Subject, #1: 1	مَاتَ سُفْيَانُ
u'مَاتَ فلان':Subject, #1: 1	مَاتَ مَكِّيٌّ
u'مَاتَ فلان':Subject, #2: 2	مَاتَ مُعَاوِيَةُ
u'مَاتَ فُلاَنٌ':Subject, #3: 3	مَاتَ عُثْمَانُ
u'مَاتَ قَابِضٌ':Subject, #51: 51	مَاتَ فُلَانٌ
u'مَاتَ قَاتِلٌ':Subject, #2: 2	مَاتَ الْقَابِضُ
u'مَاتَ قَادِمٌ':Subject, #4: 4	مَاتَ الْقَاتِلُ
u'مَاتَ قَاسِمٌ':Subject, #1: 1	مَاتَ الْقَادِمُ
u'مَاتَ قَالٌ':Predicate, #1: 1	مَاتَ قَاسِمٌ
u'مَاتَ قَائِلٌ':Subject, #26: 26	مَاتَ قَالَ
u'مَاتَ قتل':Predicate, #1: 1	مَاتَ الْقَائِلُ
u'مَاتَ قراض':Subject, #3: 3	مَاتَ قُتِلَ
u'مَاتَ قَرِيبٌ':Subject, #1: 1	مَاتَ الْقِرَاضُ
u'مَاتَ قِطٌّ':Subject, #1: 1	مَاتَ قَرِيبُهُ
u'مَاتَ قِنٌّ':Subject, #1: 1	مَاتَ الْقِطُّ
u'مَاتَ قول':Subject, #2: 2	مَاتَ الْقِنُّ
u'مَاتَ قَوْلٌ':Subject, #1: 1	مَاتَ قَوْلُهُ
u'مَاتَ قَوْمٌ':Subject, #1: 1	مَاتَ قَوْلُهُ
u'مَاتَ قَيِّمٌ':Subject, #2: 2	مَاتَ قَوْمٌ
u'مَاتَ كَاتِبٌ':Subject, #4: 4	مَاتَ الْقَيِّمُ
u'مَاتَ كَافِرٌ':Subject, #1: 1	مَاتَ الْكَاتِبُ
u'مَاتَ كَافِرٌ':Subject, #6: 6	مَاتَ الْكَافِرُ
u'مَاتَ كَبِيرٌ':Subject, #7: 7	مَاتَ كَافِرٌ
u'مَاتَ كرام':Subject, #2: 2	مَاتَ الْكَبِيرُ
u'مَاتَ كَفِيلٌ':Subject, #1: 1	مَاتَ الْكِرَامُ
u'مَاتَ لاَحِقٌ':Subject, #17: 17	مَاتَ الْكَفِيلُ
u'مَاتَ لَقِيطٌ':Subject, #2: 2	مَاتَ اللَّاحِقُ
u'مَاتَ لَيْلٌ':Predicate, #2: 2	مَاتَ اللَّقِيطُ
u'مَاتَ لَيْلٌ':Predicate, #1: 1	مَاتَ اللَّيْلَةَ
u'مَاتَ مَالِكٌ':Subject, #1: 1	مَاتَ لَيْلَةَ
u'مَاتَ مالِكِيّ':Subject, #19: 19	مَاتَ الْمَالِكُ
u'مَاتَ مَأْمُورٌ':Subject, #1: 1	مَاتَ الْمَالِكِيُّ
u'مَاتَ مَبِيعٌ':Subject, #2: 2	مَاتَ الْمَأْمُورُ
u'مَاتَ مُتَزَوِّجٌ':Subject, #1: 1	مَاتَ الْمَبِيعُ
u'مَاتَ مُتَصَدِّق':Subject, #1: 1	مَاتَ الْمُتَزَوِّجُ
u'مَاتَ مُتَقَدِّمٌ':Subject, #1: 1	مَاتَ الْمُتَصَدِّقُ
u'مَاتَ مُتَمَتِّعٌ':Subject, #1: 1	مَاتَ الْمُتَقَدِّمُ
u'مَاتَ مُتَمَتِّعٌ':Subject, #1: 1	مَاتَ الْمُتَمَتِّعُ
u'مَاتَ مُتَوَاطِئٌ':Subject, #2: 2	مَاتَ مُتَمَتِّعٌ
u'مَاتَ مُجَاهِدٌ':Subject, #1: 1	مَاتَ الْمُتَوَاطِئُ
u'مَاتَ مُجْتَهِد':Subject, #1: 1	مَاتَ الْمُجَاهِدُ
u'مَاتَ مَجْرُوحٌ':Subject, #3: 3	مَاتَ الْمُجْتَهِدُ
u'مَاتَ مَجْنُونٌ':Subject, #12: 12	مَاتَ الْمَجْرُوحُ
u'مَاتَ مَجْنِيٌّ':Subject, #2: 2	مَاتَ الْمَجْنُونُ
u'مَاتَ مَجُوسِيٌّ':Subject, #5: 5	مَاتَ الْمَجْنِيُّ
u'مَاتَ مُحِبٌّ':Subject, #4: 4	مَاتَ الْمَجُوسِيُّ
u'مَاتَ مُحْتَالٌ':Subject, #1: 1	مَاتَ الْمُحِبُّ
u'مَاتَ مَحْدُودٌ':Subject, #15: 15	مَاتَ الْمُحْتَالُ
u'مَاتَ مَحْرَمٌ':Subject, #2: 2	مَاتَ الْمَحْدُودُ
u'مَاتَ مُحْرِمٌ':Subject, #2: 2	مَاتَ مَحْرَمُ
u'مَاتَ مُحَكَّمٌ':Subject, #3: 3	مَاتَ الْمُحْرِمُ
u'مَاتَ مُحِيل':Subject, #1: 1	مَاتَ الْمُحَكَّمُ
u'مَاتَ مُخْرِجٌ':Subject, #12: 12	مَاتَ الْمُحِيلُ
u'مَاتَ مُدَبَّرٌ':Subject, #1: 1	مَاتَ الْمُخْرِجُ
u'مَاتَ مُدَبِّرٌ':Subject, #15: 15	مَاتَ الْمُدَبَّرُ
u'مَاتَ مُدَرِّسٌ':Subject, #4: 4	مَاتَ الْمُدَبِّرُ
u'مَاتَ مُدْمِنٌ':Predicate, #3: 3	مَاتَ الْمُدَرِّسُ
u'مَاتَ مُدْمِنٌ':Subject, #2: 2	مَاتَ مُدْمِنَ
u'مَاتَ مَدِينٌ':Subject, #1: 1	مَاتَ مُدْمِنُ
u'مَاتَ مَدْيُونٌ':Subject, #2: 2	مَاتَ الْمَدِينُ
u'مَاتَ مَدْيُونٌ':Subject, #2: 2	مَاتَ الْمَدْيُونُ
u'مَاتَ مُرْتَدٌّ':Subject, #2: 2	مَاتَ مَدْيُونٌ
u'مَاتَ مُرْتَهِنٌ':Subject, #8: 8	مَاتَ الْمُرْتَدُّ
u'مَاتَ مُرْسَلٌ':Predicate, #4: 4	مَاتَ الْمُرْتَهِنُ
u'مَاتَ مَرِيضٌ':Subject, #1: 1	أَمَاتَ الْمُرْسَلِينَ
u'مَاتَ مُزَارِعٌ':Subject, #32: 32	مَاتَ الْمَرِيضُ
u'مَاتَ مُسْتَأْجِرٌ':Subject, #10: 10	مَاتَ الْمُزَارِعُ
u'مَاتَ مُسْتَحِقٌّ':Subject, #17: 17	مَاتَ الْمُسْتَأْجِرُ
u'مَاتَ مُسْتَحِقٌّ':Subject, #1: 1	مَاتَ مُسْتَحِقٌّ
u'مَاتَ مُسْتَعِيرٌ':Subject, #2: 2	مَاتَ الْمُسْتَحِقُّ
u'مَاتَ مُسْتَغْرِقٌ':Subject, #1: 1	مَاتَ الْمُسْتَعِيرُ
u'مَاتَ مُسْتَنِيب':Subject, #1: 1	مَاتَ مُسْتَغْرِقُ
u'مَاتَ مُسْتَوْدَعٌ':Subject, #2: 2	مَاتَ مُسْتَنِيبُهُ
u'مَاتَ مَسْرُوقٌ':Subject, #2: 2	مَاتَ الْمُسْتَوْدَعُ
u'مَاتَ مِسْكِينٌ':Subject, #1: 1	مَاتَ الْمَسْرُوقُ
u'مَاتَ مُسْلِمٌ':Subject, #2: 2	مَاتَ الْمِسْكِينُ
u'مَاتَ مُسْلِمٌ':Subject, #10: 10	مَاتَ الْمُسْلِمُ
u'مَاتَ مُشْرِك':Subject, #11: 11	مَاتَ مُسْلِمٌ
u'مَاتَ مَشْهُودٌ':Subject, #1: 1	مَاتَ مُشْرِكٌ
u'مَاتَ مُشِيرٌ':Subject, #6: 6	مَاتَ الْمَشْهُودُ
u'مَاتَ مَصْرُوفٌ':Subject, #1: 1	مَاتَ الْمُشِيرُ
u'مَاتَ مَصْرُوف':Subject, #1: 1	مَاتَ مَصْرُوفٌ
u'مَاتَ مُضَارِبٌ':Subject, #1: 1	مَاتَ مَصْرُوفٌ
u'مَاتَ مُضَارِبٌ':Subject, #10: 10	مَاتَ الْمُضَارِبُ
u'مَاتَ مَضْمُونٌ':Subject, #1: 1	مَاتَ مُضَارِبٌ
u'مَاتَ مَطْلُوبٌ':Subject, #3: 3	مَاتَ الْمَضْمُونُ
u'مَاتَ مُطِيعٌ':Subject, #7: 7	مَاتَ الْمَطْلُوبُ
u'مَاتَ مُعاوِيَة':Subject, #1: 1	مَاتَ الْمُطِيعُ
u'مَاتَ مُعْتَقٌ':Subject, #2: 2	مَاتَ مُعَاوِيَةُ
u'مَاتَ مُعْتَقٌ':Subject, #27: 27	مَاتَ الْمُعْتَقُ
u'مَاتَ مُعَجِّلٌ':Subject, #2: 2	مَاتَ مُعْتَقُ
u'مَاتَ مُعْسِرٌ':Subject, #1: 1	مَاتَ الْمُعَجِّلُ
u'مَاتَ مَعْقُودٌ':Subject, #1: 1	مَاتَ الْمُعْسِرُ
u'مَاتَ مُعَلِّمٌ':Subject, #1: 1	مَاتَ الْمَعْقُودُ
u'مَاتَ مُعَمِّرٌ':Subject, #1: 1	مَاتَ الْمُعَلِّمُ
u'مَاتَ مُعِير':Subject, #1: 1	مَاتَ الْمُعَمِّرُ
u'مَاتَ مُعَيَّنٌ':Subject, #5: 5	مَاتَ الْمُعِيرُ
u'مَاتَ مَغْصُوب':Subject, #1: 1	مَاتَ الْمُعَيَّنُ
u'مَاتَ مُفَاوِضٌ':Subject, #3: 3	مَاتَ الْمَغْصُوبُ
u'مَاتَ مُفْرَدٌ':Subject, #2: 2	مَاتَ الْمُفَاوِضُ
u'مَاتَ مَفْقُودٌ':Subject, #1: 1	مَاتَ الْمُفْرَدُ
u'مَاتَ مُفْلِسٌ':Subject, #4: 4	مَاتَ الْمَفْقُودُ
u'مَاتَ مَقْذُوفٌ':Subject, #2: 2	مَاتَ الْمُفْلِسُ
u'مَاتَ مَقْطُوعٌ':Subject, #6: 6	مَاتَ الْمَقْذُوفُ
u'مَاتَ مَقْطُوعٌ':Subject, #2: 2	مَاتَ الْمَقْطُوعُ
u'مَاتَ مَقْطُوعٌ':Subject, #2: 2	مَاتَ الْمَقْطُوعَةُ
u'مَاتَ مَقْطُوعَةٌ':Subject, #2: 2	مَاتَ مَقْطُوعُ
u'مَاتَ مَكَاتِبُ':Subject, #2: 2	مَاتَ الْمَقْطُوعَةُ
u'مَاتَ مَكْتُوبٌ':Subject, #1: 1	مَاتَ الْمَكَاتِبُ
u'مَاتَ مَكْفُولٌ':Subject, #6: 6	مَاتَ الْمَكْتُوبُ
u'مَاتَ مُكَلَّفٌ':Subject, #22: 22	مَاتَ الْمَكْفُولُ
u'مَاتَ مَكِّيّ':Subject, #1: 1	مَاتَ الْمُكَلَّفُ
u'مَاتَ مُلْتَقِط':Subject, #1: 1	مَاتَ مَكِّيٌّ
u'مَاتَ مَلِكٌ':Subject, #2: 2	مَاتَ الْمُلْتَقِطُ
u'مَاتَ مَمْسُوح':Subject, #1: 1	مَاتَ مَلِكٌ
u'مَاتَ مَمْلُوكٌ':Subject, #2: 2	مَاتَ مَمْسُوحٌ
u'مَاتَ مَنْذُور':Subject, #1: 1	مَاتَ الْمَمْلُوكُ
u'مَاتَ مُنْكِرٌ':Subject, #2: 2	مَاتَ الْمَنْذُورُ
u'مَاتَ مُنْكِرٌ':Subject, #10: 10	مَاتَ الْمُنْكِرُ
u'مَاتَ مُؤْتَمَنٌ':Subject, #1: 1	مَاتَ مُنْكِرُهُ
u'مَاتَ مُؤَجِّرٌ':Subject, #2: 2	مَاتَ الْمُؤْتَمَنُ
u'مَاتَ مُودِعٌ':Subject, #8: 8	مَاتَ الْمُؤَجِّرُ
u'مَاتَ مُودَعٌ':Subject, #2: 2	مَاتَ الْمُودِعُ
u'مَاتَ مُوَرِّث':Subject, #8: 8	مَاتَ الْمُودَعُ
u'مَاتَ مُوَرِّث':Subject, #8: 8	مَاتَ الْمُوَرِّثُ
u'مَاتَ مَوْرُوثٌ':Subject, #9: 9	مَاتَ مُوَرِّثُهُ
u'مَاتَ مُوسِرٌ':Subject, #2: 2	مَاتَ مَوْرُوثُهُ
u'مَاتَ مَوْقُوفٌ':Subject, #4: 4	مَاتَ الْمُوسِرُ
u'مَاتَ مُوَكِّلٌ':Subject, #4: 4	مَاتَ الْمَوْقُوفُ
u'مَاتَ مُوَكَّلٌ':Subject, #17: 17	مَاتَ الْمُوَكِّلُ
u'مَاتَ مُوَكِّلٌ':Subject, #1: 1	مَاتَ الْمُوَكَّلُ
u'مَاتَ مَوْلُودٌ':Subject, #2: 2	مَاتَ مُوَكِّلُهُ
u'مَاتَ مَوْلُودٌ':Subject, #1: 1	مَاتَ الْمَوْلُودُ
u'مَاتَ مَوْهُوبٌ':Subject, #1: 1	مَاتَ مَوْلُودٌ
u'مَاتَ ناذِر':Subject, #8: 8	مَاتَ الْمَوْهُوبُ
u'مَاتَ نَاسٌ':Subject, #2: 2	مَاتَ النَّاذِرُ
u'مَاتَ نَاسٌ':Subject, #1: 1	أَمَاتَ النَّاسُ
u'مَاتَ نَاسٌ':Subject, #1: 1	مَاتَ نَاسٌ
u'مَاتَ نَاظِرٌ':Subject, #4: 4	مَاتَ النَّاسُ
u'مَاتَ نَبِيٌّ':Subject, #2: 2	مَاتَ النَّاظِرُ
u'مَاتَ نَحْلٌ':Subject, #1: 1	مَاتَ النَّبِيُّ
u'مَاتَ نسي':Predicate, #1: 1	مَاتَ النَّحْلُ
u'مَاتَ نَصْرٌ':Subject, #1: 1	مَاتَ نُسِيَ
u'مَاتَ نَصْرَانِيٌّ':Subject, #1: 1	مَاتَ نَصْرٌ
u'مَاتَ نَصْرَانِيٌّ':Subject, #3: 3	مَاتَ النَّصْرَانِيُّ
u'مَاتَ هِنْدٌ':Subject, #6: 6	مَاتَ نَصْرَانِيٌّ
u'مَاتَ واحد':Subject, #1: 1	مَاتَ هِنْدٌ
u'مَاتَ وَاحِدٌ':Subject, #26: 26	مَاتَ وَاحِدٌ
u'مَاتَ وَارِثٌ':Subject, #26: 26	مَاتَ وَاحِدٌ
u'مَاتَ وَارِثٌ':Subject, #2: 2	مَاتَ الْوَارِثُ
u'مَاتَ وَاطِئٌ':Subject, #2: 2	مَاتَ وَارِثُهُ
u'مَاتَ وَاقِعٌ':Subject, #1: 1	مَاتَ الْوَاطِئُ
u'مَاتَ وَاقِفٌ':Subject, #1: 1	مَاتَ الْوَاقِعُ
u'مَاتَ وَالِدٌ':Subject, #23: 23	مَاتَ الْوَاقِفُ
u'مَاتَ وَالِدٌ':Subject, #1: 1	مَاتَ وَالِدُ
u'مَاتَ وَالِدٌ':Subject, #1: 1	مَاتَ وَالِدُهُ
u'مَاتَ وَاهِبٌ':Subject, #3: 3	مَاتَ الْوَالِدُ
u'مَاتَ وَتَرٌ':Predicate, #31: 31	مَاتَ الْوَاهِبُ
u'مَاتَ وَجَبٌ':Predicate, #191: 191	مَاتَ وَتَرَكَ
u'مَاتَ وَدِيعٌ':Subject, #5: 5	مَاتَ وَجَبَ
u'مَاتَ وَرَثَةٌ':Subject, #2: 2	مَاتَ الْوَدِيعُ
u'مَاتَ وَرَثَةٌ':Subject, #1: 1	مَاتَ وَرَثَةُ
u'مَاتَ وسط':Predicate, #1: 1	مَاتَ وَرَثَتُهُ
u'مَاتَ وَسَطٌ':Predicate, #2: 2	مَاتَ وَسَطَ
u'مَاتَ وَصِيٌّ':Subject, #2: 2	مَاتَ وَسَطَ
u'مَاتَ وَصِيٌّ':Subject, #2: 2	مَاتَ وَصِيٌّ
u'مَاتَ وَصِيٌّ':Subject, #2: 2	مَاتَ وَصِيُّ
u'مَاتَ وَقْتٌ':Predicate, #8: 8	مَاتَ الْوَصِيُّ
u'مَاتَ وقع':Predicate, #1: 1	مَاتَ وَقْتَ
u'مَاتَ وَكِيلٌ':Subject, #3: 3	مَاتَ وَقَعَ
u'مَاتَ ولد':Subject, #20: 20	مَاتَ الْوَكِيلُ
u'مَاتَ وَلَدٌ':Subject, #10: 10	مَاتَ وَلَدُهُ
u'مَاتَ وَلَدٌ':Subject, #10: 10	مَاتَ وَلَدُهُ
u'مَاتَ ولد':Subject, #3: 3	مَاتَ وَلَدٌ
u'مَاتَ وَلَدٌ':Subject, #7: 7	مَاتَ وَلَدُ
u'مَاتَ ولد':Subject, #7: 7	مَاتَ وَلَدُ
u'مَاتَ وَلَدٌ':Subject, #97: 97	مَاتَ الْوَلَدُ
u'مَاتَ وَلَهٌ':Subject, #97: 97	مَاتَ الْوَلَدُ
u'مَاتَ وَلِيٌّ':Subject, #60: 60	مَاتَ وَلَهُ
u'مَاتَ وَلِيٌّ':Subject, #1: 1	مَاتَ الْوَلِيُّ
u'مَاتَ يَتِيمٌ':Subject, #3: 3	مَاتَ وَلِيُّ
u'مَاتَ يَهُودِيٌّ':Subject, #3: 3	مَاتَ الْيَتِيمُ
u'مَاتَ يَهُودِيٌّ':Subject, #1: 1	مَاتَ الْيَهُودِيُّ
u'مَاتَ يَوْمٌ':Predicate, #2: 2	مَاتَ يَهُودِيٌّ
u'مَاتَ يَوْمٌ':Predicate, #17: 17	مَاتَ يَوْمَ
u'مَاجَ أهْلٌ':Subject, #3: 3	مَاتَ الْيَوْمَ
u'مَاجَ نَاسٌ':Subject, #1: 1	مَاجَ أَهْلُ
u'مَارَسَ فِقْهٌ':Predicate, #1: 1	مَاجَ النَّاسُ
u'مَارَسَ فُنُونٌ':Predicate, #1: 1	مَارَسَ الْفِقْهَ
u'مَارَسَ مَسَائِلُ':Predicate, #1: 1	مَارَسَ فُنُونَ
u'مَارَ شَيْءٌ':Subject, #1: 1	مَارَسَ مَسَائِلَ
u'مَازَجَ أَجْسَادٌ':Predicate, #1: 1	مَارَ الشَّيْءُ
u'مَالَ اِبْنٌ':Subject, #1: 1	مَازَجَ أَجْسَادَ
u'مَالٌ اِبْنٌ':Added, #4: 4	مَالَ ابْنُ
u'مَالَ اِجْتِهَادٌ':Subject, #4: 4	كَمَالِ ابْنِ
u'مَالٌ أَجْرٌ':Added, #1: 1	مَالَ اجْتِهَادُهُ
u'مَالٌ إِحْيَاءٌ':Added, #1: 1	كَمَالِ أَجْرِهِ
u'مَالٌ اِخْتِلاَفٌ':Added, #1: 1	كَمَالِ الْإِحْيَاءِ
u'مَالٌ أَدَاءٌ':Added, #1: 1	كَمَالِ اخْتِلَافِ
u'مَالٌ آدابٌ':Added, #1: 1	كَمَالِ الْأَدَاءِ
u'مَالٌ آدَمِيٌّ':Added, #1: 1	كَمَالِ الْآدَابِ
u'مَالٌ أَذَانٌ':Added, #2: 2	كَمَالِ الْآدَمِيِّ
u'مَالٌ إِسْبَاغٌ':Added, #3: 3	كَمَالِ الْأَذَانِ
u'مَالَ أُسْتَاذٌ':Subject, #1: 1	كَمَالِ الْإِسْبَاغِ
u'مَالٌ اِسْتِعْدَادٌ':Added, #1: 1	مَالَ الْأُسْتَاذُ
u'مَالٌ أَطْرافٌ':Added, #1: 1	كَمَالِ اسْتِعْدَادِهِ
u'مَالٌ أَطْرَافٌ':Added, #1: 1	كَمَالِ أَطْرَافِهِ
u'مَالٌ اِطِّلاعٌ':Added, #1: 1	كَمَالِ أَطْرَافِهِ
u'مَالٌ أَفْرَادٌ':Added, #1: 1	كَمَالِ اطِّلَاعِهِ
u'مَالَ أَكْثَرُ':Subject, #1: 1	كَمَالِ الْأَفْرَادِ
u'مَالٌ آلةٌ':Added, #9: 9	مَالَ أَكْثَرُ
u'مَالٌ ألف':Added, #1: 1	كَمَالِ آلَةِ
u'مَالٌ ألْفٌ':Added, #1: 1	كَمَالِ الْأُلْفِ
u'مَالٌ ألف':Added, #1: 1	كَمَالِ الْأُلْفِ
u'مَالٌ ألْفٌ':Added, #2: 2	كَمَالِ الْأَلْفِ
u'مَالٌ أَلْفٌ':Added, #2: 2	كَمَالِ الْأَلْفِ
u'مَالَ إمَامٌ':Subject, #2: 2	كَمَالِ الْأَلْفِ
u'مَالَ إمَامٌ':Subject, #1: 1	مَالَ إمَامُ
u'مَآلٌ أَمْرٌ':Added, #6: 6	مَالَ الْإِمَامُ
u'مَالٌ أَوَّلُ':Added, #2: 2	مَآلُ الْأَمْرِ
u'مَالٌ إيمَانٌ':Added, #1: 1	كَمَالِ الْأَوَّلِ
u'مَالٌ بالِغٌ':Added, #2: 2	كَمَالِ الْإِيمَانِ
u'مَالَ بَائِعٌ':Subject, #1: 1	كَمَالِ الْبَالِغِ
u'مَالٌ بذلة':Added, #1: 1	مَالَ الْبَائِعُ
u'مَالٌ بِذْلَةٌ':Added, #1: 1	كَمَالِ الْبِذْلَةِ
u'مَالَ بَعْضٌ':Subject, #1: 1	كَمَالِ الْبِذْلَةِ
u'مَالٌ بَلاغَةٌ':Added, #9: 9	مَالَ بَعْضُ
u'مَالٌ بُلُوغٌ':Added, #2: 2	كَمَالِ الْبَلَاغَةِ
u'مَالٌ بِنَاءٌ':Added, #1: 1	كَمَالِ الْبُلُوغِ
u'مَالٌ بَيْتٌ':Added, #2: 2	كَمَالِ الْبِنَاءِ
u'مَالٌ بَيِّنَةٌ':Added, #3: 3	كَمَالِ بَيْتِ
u'مَالٌ تَاسِعٌ':Added, #1: 1	كَمَالِ الْبَيِّنَةِ
u'مَالٌ تَحَفُّظٌ':Added, #1: 1	كَمَالِ التَّاسِعَةِ
u'مَالٌ تَرْوِيحَةٌ':Added, #1: 1	كَمَالِ التَّحَفُّظِ
u'مَالٌ تَرْوِيحَة':Added, #2: 2	كَمَالِ التَّرْوِيحَةِ
u'مَالٌ تَسْبِيحٌ':Added, #2: 2	كَمَالِ التَّرْوِيحَةِ
u'مَالٌ تَصَرُّفٌ':Added, #1: 1	كَمَالِ التَّسْبِيحِ
u'مَالٌ تَقَرُّبٌ':Added, #1: 1	كَمَالِ التَّصَرُّفِ
u'مَالٌ تَمَتُّعٌ':Added, #1: 1	كَمَالِ تَقَرُّبِهِ
u'مَالٌ تَمَيُّزٌ':Added, #1: 1	كَمَالِ التَّمَتُّعِ
u'مَالٌ تَيَمُّمٌ':Added, #1: 1	كَمَالِ تَمَيُّزِهِ
u'مَالٌ ثَالِثٌ':Added, #1: 1	كَمَالِ التَّيَمُّمِ
u'مَالَ جِدار':Subject, #2: 2	كَمَالِ الثَّالِثِ
u'مَالَ جِدار':Subject, #2: 2	مَالَ الْجِدَارُ
u'مَالٌ جلد':Added, #3: 3	مَالَ جِدَارُهُ
u'مَالٌ جَلْدٌ':Added, #1: 1	كَمَالِ جَلْدِهِ
u'مَالَ جَمَاعَةٌ':Subject, #1: 1	كَمَالِ جَلْدِهِ
u'مَالٌ جَمَالٌ':Added, #1: 1	مَالَ جَمَاعَةٌ
u'مَالٌ جمع':Added, #1: 1	كَمَالِ الْجَمَالِ
u'مَالٌ جَمْعٌ':Added, #7: 7	كَمَالِ الْجَمْعِ
u'مَالٌ جَنَابَةٌ':Added, #7: 7	كَمَالِ الْجَمْعِ
u'مَالٌ جِنَايَةٌ':Added, #1: 1	كَمَالِ الْجَنَابَةِ
u'مَالٌ جِنْسِيٌّ':Added, #6: 6	كَمَالِ الْجِنَايَةِ
u'مَالَ حاكِمٌ':Subject, #1: 1	كَمَالِ الْجِنْسِيَّةِ
u'مَالٌ حالٌ':Added, #5: 5	مَالَ الْحَاكِمُ
u'مَالَ حائِطٌ':Subject, #3: 3	كَمَالِ الْحَالِ
u'مَالَ حائِطٌ':Subject, #3: 3	مَالَ الْحَائِطُ
u'مَالَ حائِطٌ':Subject, #3: 3	مَالَ حَائِطٌ
u'مَالٌ حُجَّةٌ':Added, #8: 8	مَالَ حَائِطُهُ
u'مَالٌ حَدٌّ':Added, #1: 1	كَمَالِ الْحُجَّةِ
u'مَالٌ حَرَكَةٌ':Added, #1: 1	كَمَالِ الْحَدِّ
u'مَالٌ حُرِّيَّةٌ':Added, #1: 1	كَمَالِ الْحَرَكَةِ
u'مَالٌ حُرِّيَّةٌ':Added, #2: 2	كَمَالِ الْحُرِّيَّةِ
u'مَالٌ حَقٌّ':Added, #5: 5	كَمَالِ حُرِّيَّتِهِ
u'مَالٌ حَقٌّ':Added, #1: 1	كَمَالِ الْحَقِّ
u'مَالَ حَلْوانِيٌّ':Subject, #1: 1	كَمَالِ حَقِّهِ
u'مَالٌ حول':Added, #1: 1	مَالَ الْحَلْوَانِيُّ
u'مَالٌ حَوْلٌ':Added, #55: 55	كَمَالِ الْحَوْلِ
u'مَالٌ حَيَاةٌ':Added, #55: 55	كَمَالِ الْحَوْلِ
u'مَالٌ خراج':Added, #1: 1	كَمَالِ حَيَاتِهِ
u'مَالٌ خَرَاجٌ':Added, #1: 1	كَمَالِ الْخَرَاجِ
u'مَالٌ خلقة':Added, #1: 1	كَمَالِ الْخَرَاجِ
u'مَالٌ خِلْقَةٌ':Added, #1: 1	كَمَالِ الْخِلْقَةِ
u'مَالٌ خلقة':Added, #1: 1	كَمَالِ الْخِلْقَةِ
u'مَالٌ خِلْقَةٌ':Added, #1: 1	كَمَالِ خِلْقَتِهِ
u'مَالَ دَهْرٌ':Subject, #1: 1	كَمَالِ خِلْقَتِهِ
u'مَالٌ دِيَةٌ':Added, #1: 1	مَالَ دَهْرٌ
u'مَالٌ دِينٌ':Added, #2: 2	كَمَالِ الدِّيَةِ
u'مَالٌ دِينٌ':Added, #1: 1	كَمَالِ دِينِهِ
u'مَالٌ رَأْسٌ':Added, #8: 8	كَمَالِ الدِّينِ
u'مَالٌ رَأْيٌ':Added, #1: 1	كَمَالِ رَأْسِ
u'مَالٌ رَأْيٌ':Added, #1: 1	كَمَالِ رَأْيِهِ
u'مَالٌ رُبُوبِيٌّ':Added, #2: 2	كَمَالِ الرَّأْيِ
u'مَالٌ رَدٌّ':Added, #1: 1	كَمَالِ الرُّبُوبِيَّةِ
u'مَالَ رَسُولٌ':Subject, #1: 1	كَمَالِ الرَّدِّ
u'مَالٌ رِقٌّ':Added, #1: 1	مَالَ رَسُولُ
u'مَالٌ رُكوعٌ':Added, #1: 1	كَمَالِ الرِّقِّ
u'مَالٌ زادٌ':Added, #1: 1	كَمَالِ الرُّكُوعِ
u'مَالَ زُفَرٌ':Subject, #1: 1	كَمَالِ الزَّادِ
u'مَالَ زَمانٌ':Subject, #1: 1	مَالَ زُفَرُ
u'مَالٌ سَبَبٌ':Added, #1: 1	مَالَ الزَّمَانُ
u'مَالٌ سَبَبٌ':Added, #1: 1	كَمَالِ سَبَبِ
u'مَالٌ سَبَبٌ':Added, #3: 3	كَمَالِ السَّبَبِ
u'مَالٌ سُنَّةٌ':Added, #3: 3	كَمَالِ سَبَبِهِ
u'مَالٌ سُورَةٌ':Added, #3: 3	كَمَالِ السُّنَّةِ
u'مَالٌ شَرْطٌ':Added, #1: 1	كَمَالِ السُّورَةِ
u'مَالٌ شَرْطٌ':Added, #1: 1	كَمَالِ شَرْطِهِ
u'مَالٌ شُرُوطٌ':Added, #4: 4	كَمَالِ الشَّرْطِ
u'مَالٌ شَرِيعَةٌ':Added, #1: 1	كَمَالِ الشُّرُوطِ
u'مَالٌ شَرِيكٌ':Added, #1: 1	كَمَالِ الشَّرِيعَةِ
u'مَالٌ شَفَقَةٌ':Added, #1: 1	كَمَالِ الشَّرِيكِ
u'مَالَ شمس':Subject, #1: 1	كَمَالِ شَفَقَتِهِ
u'مَالَ شَمْسٌ':Subject, #30: 30	مَالَ شَمْسُ
u'مَالٌ شَوْطٌ':Added, #30: 30	مَالَ شَمْسُ
u'مَالَ شَيْخٌ':Subject, #1: 1	كَمَالِ الشَّوْطِ
u'مَالَ شَيْخٌ':Subject, #12: 12	مَالَ الشَّيْخُ
u'مَالَ صَاحِبٌ':Subject, #6: 6	مَالَ شَيْخُ
u'مَالٌ صَاحِبٌ':Added, #4: 4	مَالَ صَاحِبُ
u'مَالٌ صَبِيٌّ':Added, #1: 1	كَمَالِ صَاحِبِهِ
u'مَالَ صَدْرٌ':Subject, #1: 1	كَمَالِ الصَّبِيِّ
u'مَالٌ صدقة':Added, #3: 3	مَالَ الصَّدْرُ
u'مَالٌ صَدَقَةٌ':Added, #2: 2	كَمَالِ الصَّدَقَةِ
u'مَالٌ صِفَةٌ':Added, #2: 2	كَمَالِ الصَّدَقَةِ
u'مَالٌ صِفَةٌ':Added, #1: 1	كَمَالِ الصِّفَةِ
u'مَالٌ صَلاَةٌ':Added, #2: 2	كَمَالِ الصِّفَاتِ
u'مَالٌ صَلاَحٌ':Added, #1: 1	كَمَالِ الصَّلَاةِ
u'مَالٌ صَنْج':Added, #1: 1	كَمَالِ صَلَاحِهِ
u'مَالٌ صُورَةٌ':Added, #1: 1	كَمَالِ الصَّنْجَةِ
u'مَالٌ ضَالٌّ':Added, #1: 1	كَمَالِ الصّورَةِ
u'مَالٌ ضَائِعٌ':Added, #2: 2	كَمَالٍ ضَالٍّ
u'مَالٌ ضَبْطٌ':Added, #5: 5	كَمَالٍ ضَائِعٍ
u'مَالٌ ضمار':Added, #1: 1	كَمَالِ ضَبْطِهِ
u'مَالٌ طِفْلٌ':Added, #1: 1	كَمَالِ الضِّمَارِ
u'مَالٌ طَهَارَةٌ':Added, #2: 2	كَمَالِ الطِّفْلِ
u'مَالٌ طَهَارَةٌ':Added, #2: 2	كَمَالِ طَهَارَتِهِ
u'مَالٌ طُهْرٌ':Added, #3: 3	كَمَالِ الطَّهَارَةِ
u'مَالٌ طواف':Added, #1: 1	كَمَالِ طُهْرٍ
u'مَالٌ طَوَافٌ':Added, #1: 1	كَمَالِ الطَّوَافِ
u'مَالٌ طُولٌ':Added, #1: 1	كَمَالِ الطَّوَافِ
u'مَالٌ طِيبٌ':Added, #2: 2	كَمَالِ الطُّولِ
u'مَالَ عَامٌّ':Subject, #1: 1	كَمَالِ طِيبِهِ
u'مَالَ عَبْدٌ':Subject, #2: 2	مَالَ عَامَّةُ
u'مَالٌ عَبْدٌ':Added, #1: 1	مَالَ الْعَبْدُ
u'مَالٌ عتق':Added, #3: 3	كَمَالِ الْعَبْدِ
u'مَالٌ عِتْقٌ':Added, #1: 1	كَمَالِ الْعِتْقِ
u'مَالٌ عَدَاوَةٌ':Added, #1: 1	كَمَالِ الْعِتْقِ
u'مَالٌ عِدَّةٌ':Added, #1: 1	كَمَالِ الْعَدَاوَةِ
u'مَالٌ عَدَدٌ':Added, #2: 2	كَمَالِ الْعِدَّةِ
u'مَالٌ عَدَدٌ':Added, #1: 1	كَمَالِ عَدَدِ
u'مَالٌ عَدَمٌ':Added, #2: 2	كَمَالِ الْعَدَدِ
u'مَالٌ عَرْضٌ':Added, #1: 1	كَمَالِ عَدَمِ
u'مَالَ عِصَامٌ':Subject, #7: 7	كَمَالِ الْعَرْضِ
u'مَالٌ عَقْدٌ':Added, #1: 1	مَالَ عِصَامُ
u'مَالٌ عقر':Added, #2: 2	كَمَالِ الْعَقْدِ
u'مَالٌ عُقْرٌ':Added, #1: 1	كَمَالِ الْعُقْرِ
u'مَالٌ عَقْلٌ':Added, #1: 1	كَمَالِ الْعُقْرِ
u'مَالٌ عَقْلٌ':Added, #3: 3	كَمَالِ عَقْلِهِ
u'مَالٌ عِلَّةٌ':Added, #7: 7	كَمَالِ الْعَقْلِ
u'مَالٌ علم':Added, #2: 2	كَمَالِ الْعِلَّةِ
u'مَالٌ عِلْمٌ':Added, #1: 1	كَمَالِ الْعِلْمِ
u'مَالَ عُلُوٌّ':Subject, #1: 1	كَمَالِ الْعِلْمِ
u'مَالٌ عِمَارَةٌ':Added, #1: 1	مَالَ الْعُلُوُّ
u'مَالٌ غَائِبٌ':Added, #1: 1	كَمَالِ الْعِمَارَةِ
u'مَالٌ غُسْلٌ':Added, #1: 1	كَمَالِ غَائِبٍ
u'مَالٌ غَسْلٌ':Added, #1: 1	كَمَالِ الْغُسْلِ
u'مَالٌ غُسْلٌ':Added, #1: 1	كَمَالِ غَسْلِ
u'مَالَ غُصْنٌ':Subject, #2: 2	كَمَالِ غُسْلِ
u'مَالٌ غَنِيمَةٌ':Added, #1: 1	مَالَ غُصْنُ
u'مَالَ غير':Predicate, #2: 2	كَمَالِ الْغَنِيمَةِ
u'مَالَ غَيْرٌ':Predicate, #1: 1	مَالَ غَيْرَ
u'مَالَ غير':Subject, #1: 1	مَالَ غَيْرَ
u'مَالَ غَيْرٌ':Subject, #2: 2	مَالَ غَيْرُهُ
u'مَالٌ غير':Added, #2: 2	مَالَ غَيْرُهُ
u'مَالٌ غَيْرٌ':Added, #1: 1	كَمَالِ الْغَيْرِ
u'مَالٌ غير':Added, #1: 1	كَمَالِ الْغَيْرِ
u'مَالٌ غَيْرٌ':Added, #1: 1	كَمَالِ غَيْرِهِ
u'مَالَ فخر':Subject, #1: 1	كَمَالِ غَيْرِهِ
u'مَالَ فَخْرٌ':Subject, #2: 2	مَالَ فَخْرُ
u'مَالٌ فِقْهٌ':Added, #2: 2	مَالَ فَخْرُ
u'مَالَ فَقِيهٌ':Subject, #1: 1	كَمَالِ فِقْهِهِ
u'مَالَ فلان':Subject, #2: 2	مَالَ الْفَقِيهُ
u'مَالَ فَيْءٌ':Subject, #4: 4	مَالَ مَكْحُولٌ
u'مَالَ قَالٌ':Predicate, #1: 1	مَالَ فَيْءُ
u'مَالٌ قَبْضٌ':Added, #1: 1	مَالَ قَالَ
u'مَالٌ قدرة':Added, #1: 1	كَمَالِ الْقَبْضِ
u'مَالٌ قُدْرَةٌ':Added, #3: 3	كَمَالِ قُدْرَتِهِ
u'مَالَ قلب':Subject, #3: 3	كَمَالِ قُدْرَتِهِ
u'مَالَ قَلْبٌ':Subject, #2: 2	مَالَ قَلْبُهُ
u'مَالَ قَلْب':Subject, #2: 2	مَالَ قَلْبُهُ
u'مَالٌ قُوَّةٌ':Added, #2: 2	مَالَ قَلْبُهُ
u'مَالٌ قُوَّة':Added, #1: 1	كَمَالِ الْقُوَّةِ
u'مَالٌ قُوَّةٌ':Added, #1: 1	كَمَالِ الْقُوَّةِ
u'مَالٌ قُوَّة':Added, #2: 2	كَمَالِ قُوَّةِ
u'مَالٌ قِيمَةٌ':Added, #2: 2	كَمَالِ قُوَّةِ
u'مَالٌ كِتَابَةٌ':Added, #1: 1	كَمَالِ الْقِيمَةِ
u'مَالَ كُوزٌ':Subject, #4: 4	كَمَالِ الْكِتَابَةِ
u'مَالٌ لَذَّةٌ':Added, #1: 1	مَالَ الْكُوزُ
u'مَالَ مَالِكٌ':Subject, #1: 1	كَمَالِ اللَّذَّةِ
u'مَالٌ مالِك':Added, #2: 2	مَالَ مَالِكٌ
u'مَالٌ مالِكِيّ':Added, #1: 1	كَمَالِ الْمَالِكِيَّةِ
u'مَالٌ مَجْهُولٌ':Added, #1: 1	كَمَالِ الْمَالِكِيَّةِ
u'مَالٌ مَحْجُورٌ':Added, #1: 1	كَمَالٍ مَجْهُولٍ
u'مَالٌ مَحَلٌّ':Added, #1: 1	كَمَالِ الْمَحْجُورِ
u'مَالَ مُحَمَّدٌ':Subject, #1: 1	كَمَالِ الْمَحَلِّ
u'مَالٌ مُدَّةٌ':Added, #1: 1	مَالَ مُحَمَّدُ
u'مَالَ مرٌّ':Predicate, #3: 3	كَمَالِ مُدَّةِ
u'مَالٌ مُرْتَدٌّ':Added, #1: 1	مَالَ مَرَّةً
u'مَالٌ مُرُوءةٌ':Added, #2: 2	كَمَالِ الْمُرْتَدِّ
u'مَالٌ مَرِيضٌ':Added, #2: 2	كَمَالِ الْمُرُوءَةِ
u'مَآلٌ مَسْأَلَةٌ':Added, #1: 1	كَمَالِ الْمَرِيضِ
u'مَالَ مُسْلِمٌ':Predicate, #1: 1	مَآلِ الْمَسْأَلَةِ
u'مَالَ مُصَنِّفٌ':Subject, #3: 3	مَالَ الْمُسْلِمِينَ
u'مَالٌ مُضَارَبَةٌ':Added, #1: 1	مَالَ الْمُصَنِّفُ
u'مَالٌ مَعْرِفَةٌ':Added, #6: 6	كَمَالِ الْمُضَارَبَةِ
u'مَالٌ مَعْرِفَة':Added, #1: 1	كَمَالِ مَعْرِفَةٍ
u'مَالٌ مَعْزُولٌ':Added, #1: 1	كَمَالِ مَعْرِفَةٍ
u'مَالٌ مَغْصُوب':Added, #1: 1	كَمَالٍ مَعْزُولٍ
u'مَالٌ مَفْقُودٌ':Added, #1: 1	كَمَالِ الْمَغْصُوبِ
u'مَالٌ مُفْلِسٌ':Added, #1: 1	كَمَالِ مَفْقُودٍ
u'مَالٌ مَقْصُودٌ':Added, #1: 1	كَمَالِ الْمُفْلِسِ
u'مَالَ مَكْحُول':Subject, #1: 1	كَمَالِ الْمَقْصُودِ
u'مَالٌ مِلَّةٌ':Added, #4: 4	مَالَ مَكْحُولٌ
u'مَالٌ مِلْكٌ':Added, #1: 1	كَمَالِ الْمِلَّةِ
u'مَالٌ مِلْكٌ':Added, #1: 1	كَمَالِ مِلْكِهِ
u'مَالٌ مِلْكٌ':Added, #3: 3	كَمَالِ الْمِلْكِ
u'مَالٌ مَنْفَعَةٌ':Added, #4: 4	كَمَالِ مِلْكِ
u'مَالَ مَنْقُولٌ':Subject, #1: 1	كَمَالِ الْمَنْفَعَةِ
u'مَالٌ مَهْرٌ':Added, #1: 1	مَالَ مَنْقُولٌ
u'مَالٌ مَهْرٌ':Added, #1: 1	كَمَالِ مَهْرِ
u'مَالٌ مُؤَذِّنٌ':Added, #8: 8	كَمَالِ الْمَهْرِ
u'مَالَ ميل':Subject, #1: 1	كَمَالِ الْمُؤَذِّنِ
u'مَالَ مَيْلٌ':Subject, #1: 1	مَالَ مَيْلُهُ
u'مَالٌ نِسْبَةٌ':Added, #1: 1	مَالَ مَيْلُهُ
u'مَالٌ نصاب':Added, #1: 1	كَمَالِ النِّسْبَةِ
u'مَالٌ نِصَابٌ':Added, #36: 36	كَمَالِ النِّصَابِ
u'مَالَ نِصْفٌ':Subject, #36: 36	كَمَالِ النِّصَابِ
u'مَالٌ نَظَرٌ':Added, #1: 1	مَالَ نِصْفُهُ
u'مَالٌ نعمة':Added, #1: 1	كَمَالِ النَّظَرِ
u'مَالٌ نِعْمَةٌ':Added, #1: 1	كَمَالِ النِّعْمَةِ
u'مَالٌ نعمة':Added, #1: 1	كَمَالِ النِّعْمَةِ
u'مَالٌ نِعْمَةٌ':Added, #1: 1	كَمَالِ نِعْمَتِهِ
u'مَالٌ نَمَاءٌ':Added, #1: 1	كَمَالِ نِعْمَتِهِ
u'مَالَ نهار':Subject, #1: 1	كَمَالِ النَّمَاءِ
u'مَالَ نهار':Subject, #1: 1	مَالَ النّهَارُ
u'مَالَ نَهَارٌ':Subject, #1: 1	مَالَ النَّهَارُ
u'مَالَ نَهَارٌ':Subject, #1: 1	مَالَ النّهَارُ
u'مَالَ نَوَوِيٌّ':Subject, #1: 1	مَالَ النَّهَارُ
u'مَالٌ هُدْنَةٌ':Added, #1: 1	مَالَ النَّوَوِيُّ
u'مَالٌ واحد':Added, #1: 1	كَمَالِ الْهُدْنَةِ
u'مَالٌ وَاحِدٌ':Added, #2: 2	كَمَالِ الْوَاحِدِ
u'مَالٌ واحد':Added, #2: 2	كَمَالِ الْوَاحِدِ
u'مَالٌ وَاحِدٌ':Added, #4: 4	كَمَالٍ وَاحِدٍ
u'مَالَ وَجَارٌ':Predicate, #4: 4	كَمَالٍ وَاحِدٍ
u'مَالٌ وَجْهٌ':Added, #1: 1	مَالَ وَجَارَ
u'مَالٌ وُجُودٌ':Added, #1: 1	كَمَالِ الْوَجْهِ
u'مَالٌ وَحْيٌ':Added, #1: 1	كَمَالِ الْوُجُودِ
u'مَالٌ وَفَاءٌ':Added, #1: 1	كَمَالِ الْوَحْيِ
u'مَالٌ وَقْتٌ':Added, #1: 1	كَمَالِ وَفَاءِ
u'مَالٌ وِلاَيَةٌ':Added, #3: 3	كَمَالِ الْوَقْتِ
u'مَالٌ وِلاَيَةٌ':Added, #1: 1	كَمَالِ وِلَايَةِ
u'مَالٌ وِلاَيَةٌ':Added, #1: 1	كَمَالِ وِلَايَتِهِ
u'مَالٌ يَتِيمٌ':Added, #2: 2	كَمَالِ الْوِلَايَةِ
u'مَالٌ يَوْمٌ':Added, #3: 3	كَمَالِ الْيَتِيمِ
u'مُبَادَرَةٌ أُسْتَاذٌ':Added, #1: 1	كَمَالِ الْيَوْمِ
u'مُبَادَرَةٌ أصل':Added, #1: 1	مُبَادَرَةُ أُسْتَاذِهِ
u'مُبَادَرَةٌ أًصْلٌ':Added, #1: 1	مُبَادَرَةِ الْأَصْلِ
u'مُبَادَرَةٌ ذِهْنٌ':Added, #1: 1	مُبَادَرَةِ الْأَصْلِ
u'مُبَادَرَةٌ نَبِيٌّ':Added, #1: 1	مُبَادَرَةِ الذِّهْنِ
u'مُبَادَلَةٌ أَجَلٌ':Added, #1: 1	مُبَادَرَةُ النَّبِيِّ
u'مُبَادَلَةٌ جِنْسٌ':Added, #1: 1	مُبَادَلَةَ الْأَجَلِ
u'مُبَادَلَةٌ حِنْطَةٌ':Added, #1: 1	مُبَادَلَةُ الْجِنْسِ
u'مُبَادَلَةٌ دَارٌ':Added, #1: 1	مُبَادَلَةَ الْحِنْطَةِ
u'مُبَادَلَةٌ دِرْهَمٌ':Added, #2: 2	مُبَادَلَةُ دَارِ
u'مُبَادَلَةٌ دِرْهَم':Added, #1: 1	مُبَادَلَةِ الدِّرْهَمِ
u'مُبَادَلَةٌ دَيْنٌ':Added, #1: 1	مُبَادَلَةِ الدِّرْهَمِ
u'مُبَادَلَةٌ دِينارٌ':Added, #1: 1	مُبَادَلَةَ الدَّيْنِ
u'مُبَادَلَةٌ شرب':Added, #1: 1	مُبَادَلَةَ الدِّينَارِ
u'مُبَادَلَةٌ شِرْبٌ':Added, #2: 2	مُبَادَلَةَ الشِّرْبِ
u'مُبَادَلَةٌ شَيْءٌ':Added, #2: 2	مُبَادَلَةَ الشِّرْبِ
u'مُبَادَلَةٌ شَيْءٌ':Added, #1: 1	مُبَادَلَةُ الشَّيْءِ
u'مُبَادَلَةٌ شَيْءٌ':Added, #1: 1	مُبَادَلَةِ الشَّيْءِ
u'مُبَادَلَةٌ طعام':Added, #1: 1	مُبَادَلَةُ شَيْءٍ
u'مُبَادَلَةٌ طَعَامٌ':Added, #1: 1	مُبَادَلَةِ الطَّعَامِ
u'مُبَادَلَةٌ عَدَدٌ':Added, #1: 1	مُبَادَلَةِ الطَّعَامِ
u'مُبَادَلَةٌ عَقَارٌ':Added, #1: 1	مُبَادَلَةُ الْعَدَدِ
u'مُبَادَلَةٌ عَيْنٌ':Added, #1: 1	مُبَادَلَةِ عَقَارٍ
u'مُبَادَلَةٌ عَيْن':Added, #1: 1	مُبَادَلَةُ عَيْنٍ
u'مُبَادَلَةٌ قَلِيلٌ':Added, #1: 1	مُبَادَلَةُ عَيْنٍ
u'مُبَادَلَةٌ مَأْكُولٌ':Added, #3: 3	مُبَادَلَةُ الْقَلِيلِ
u'مُبَادَلَةٌ مَالٌ':Added, #1: 1	مُبَادَلَةُ الْمَأْكُولِ
u'مُبَادَلَةٌ مَالٌ':Added, #12: 12	مُبَادَلَةُ مَالٍ
u'مُبَادَلَةٌ مَالٌ':Added, #16: 16	مُبَادَلَةَ مَالٍ
u'مُبَادَلَةٌ مَالٌ':Added, #1: 1	مُبَادَلَةِ مَالٍ
u'مُبَادَلَةٌ مَالٌ':Added, #2: 2	مُبَادَلَةَ الْمَالِ
u'مُبَادَلَةٌ مَالٌ':Added, #40: 40	مُبَادَلَةُ الْمَالِ
u'مُبَادَلَةٌ مَنْفَعَةٌ':Added, #5: 5	مُبَادَلَةِ الْمَالِ
u'مُبَادَلَةٌ مَنْفَعَةٌ':Added, #1: 1	مُبَادَلَةَ الْمَنْفَعَةِ
u'مُبَادَلَةٌ مَوْجُودٌ':Added, #1: 1	مُبَادَلَةُ الْمَنْفَعَةِ
u'مُبَارَزَةٌ اِبْنٌ':Added, #2: 2	مُبَادَلَةِ مَوْجُودٍ
u'مُبَارَزَةٌ أَصْحَابٌ':Added, #1: 1	مُبَارَزَةِ ابْنِ
u'مُبَارَزَةٌ يَوْمٌ':Added, #1: 1	مُبَارَزَةِ أَصْحَابِهِ
u'مُبَارَكَةٌ زَيْتونَةٌ':Added, #1: 1	مُبَارَزَةِ يَوْمِ
u'مُبَارَكَةٌ نَاظِرٌ':Added, #3: 3	مُبَارَكَةٍ زَيْتُونَةٍ
u'مُبَارَكٌ زَيْتونَةٌ':Added, #1: 1	مُبَارَكَةِ النَّاظِرِ
u'مُبَارَكٌ نَاظِرٌ':Added, #3: 3	مُبَارَكَةٍ زَيْتُونَةٍ
u'مُبَاشَرَةٌ أَبٌ':Added, #1: 1	مُبَارَكَةِ النَّاظِرِ
u'مُبَاشَرَةٌ إِتْلاَفٌ':Added, #1: 1	مُبَاشَرَةِ الْأَبِ
u'مُبَاشَرَةٌ أحَدٌ':Added, #2: 2	مُبَاشَرَةِ الْإِتْلَافِ
u'مُبَاشَرَةٌ إِحْرَامٌ':Added, #1: 1	مُبَاشَرَةِ أَحَدِ
u'مُبَاشَرَةٌ أرْضٌ':Added, #1: 1	مُبَاشَرَةِ الْإِحْرَامِ
u'مُبَاشَرَةٌ أرْضٌ':Added, #1: 1	مُبَاشَرَةِ الْأَرْضِ
u'مُبَاشَرَةٌ أَزْواجٌ':Added, #2: 2	مُبَاشَرَةُ الْأَرْضِ
u'مُبَاشَرَةٌ أسْبَابٌ':Added, #1: 1	مُبَاشَرَةِ الْأَزْوَاجِ
u'مُبَاشَرَةٌ أَسْبَابٌ':Added, #1: 1	مُبَاشَرَةِ الْأَسْبَابِ
u'مُبَاشَرَةٌ إِعْتاقٌ':Added, #1: 1	مُبَاشَرَةِ الْأَسْبَابِ
u'مُبَاشَرَةٌ إعْطَاءٌ':Added, #1: 1	مُبَاشَرَةِ الْإِعْتَاقِ
u'مُبَاشَرَةٌ أَعْمَالٌ':Added, #1: 1	مُبَاشَرَةِ الْإِعْطَاءِ
u'مُبَاشَرَةٌ الْمَرْأَةُ':Added, #1: 1	مُبَاشَرَةِ أَعْمَالٍ
u'مُبَاشَرَةٌ أُمُورٌ':Added, #2: 2	مُبَاشَرَةِ الْمَرْأَةِ
u'مُبَاشَرَةٌ أَوْلِيَاءُ':Added, #1: 1	مُبَاشَرَةِ الْأُمُورِ
u'مُبَاشَرَةٌ بَيْعٌ':Added, #1: 1	مُبَاشَرَةَ الْأَوْلِيَاءِ
u'مُبَاشَرَةٌ بَيْعٌ':Added, #2: 2	مُبَاشَرَةُ الْبَيْعِ
u'مُبَاشَرَةٌ تَزْوِيجٌ':Added, #2: 2	مُبَاشَرَةِ الْبَيْعِ
u'مُبَاشَرَةٌ تَصَرُّفٌ':Added, #1: 1	مُبَاشَرَةَ التَّزْوِيجِ
u'مُبَاشَرَةٌ جَائِزٌ':Added, #2: 2	مُبَاشَرَةَ التَّصَرُّفِ
u'مُبَاشَرَةٌ جَبْهَةٌ':Added, #2: 2	مُبَاشَرَةِ الْجَائِزِ
u'مُبَاشَرَةٌ حاكِمٌ':Added, #1: 1	مُبَاشَرَةَ الْجَبْهَةِ
u'مُبَاشَرَةٌ حائِضٌ':Added, #1: 1	مُبَاشَرَةِ الْحَاكِمِ
u'مُبَاشَرَةٌ حَجٌّ':Added, #1: 1	مُبَاشَرَةِ الْحَائِضِ
u'مُبَاشَرَةٌ حَرامٌ':Added, #1: 1	مُبَاشَرَةُ الْحَجِّ
u'مُبَاشَرَةٌ حُكْمٌ':Added, #1: 1	مُبَاشَرَةِ الْحَرَامِ
u'مُبَاشَرَةٌ ذَكاةٌ':Added, #1: 1	مُبَاشَرَةُ الْحُكْمِ
u'مُبَاشَرَةٌ رَجُلٌ':Added, #1: 1	مُبَاشَرَةُ الذَّكَاةِ
u'مُبَاشَرَةٌ رَدٌّ':Added, #4: 4	مُبَاشَرَةِ الرَّجُلِ
u'مُبَاشَرَةٌ رُطوبَةٌ':Added, #1: 1	مُبَاشَرَةُ الرَّدِّ
u'مُبَاشَرَةٌ رفقة':Added, #1: 1	مُبَاشَرَةِ الرُّطُوبَةِ
u'مُبَاشَرَةٌ رُفْقَةٌ':Added, #1: 1	مُبَاشَرَةُ الرُّفْقَةِ
u'مُبَاشَرَةٌ زَوْجَةٌ':Added, #1: 1	مُبَاشَرَةُ الرُّفْقَةِ
u'مُبَاشَرَةٌ سَاتِرٌ':Added, #1: 1	مُبَاشَرَةِ الزَّوْجَةِ
u'مُبَاشَرَةٌ سَبَبٌ':Added, #1: 1	مُبَاشَرَةُ السَّاتِرِ
u'مُبَاشَرَةٌ سَبَبٌ':Added, #1: 1	مُبَاشَرَةَ السَّبَبِ
u'مُبَاشَرَةٌ سَبَبٌ':Added, #1: 1	مُبَاشَرَةِ سَبَبِهِ
u'مُبَاشَرَةٌ سَبَبٌ':Added, #2: 2	مُبَاشَرَةِ السَّبَبِ
u'مُبَاشَرَةٌ سَبَبٌ':Added, #4: 4	مُبَاشَرَةَ سَبَبِهِ
u'مُبَاشَرَةٌ سَبَبٌ':Added, #5: 5	مُبَاشَرَةِ سَبَبٍ
u'مُبَاشَرَةٌ سُؤَالٌ':Added, #5: 5	مُبَاشَرَةِ سَبَبِ
u'مُبَاشَرَةٌ سَيِّدٌ':Added, #1: 1	مُبَاشَرَةُ سُؤَالِ
u'مُبَاشَرَةٌ شِرَاءٌ':Added, #2: 2	مُبَاشَرَةَ السَّيِّدِ
u'مُبَاشَرَةٌ شَرْطٌ':Added, #3: 3	مُبَاشَرَةِ الشِّرَاءِ
u'مُبَاشَرَةٌ شَرْطٌ':Added, #1: 1	مُبَاشَرَةُ شَرْطٍ
u'مُبَاشَرَةٌ شَرْطٌ':Added, #1: 1	مُبَاشَرَةِ شَرْطِ
u'مُبَاشَرَةٌ شُرُوطٌ':Added, #5: 5	مُبَاشَرَةِ الشَّرْطِ
u'مُبَاشَرَةٌ شَيْءٌ':Added, #2: 2	مُبَاشَرَةِ شُرُوطِ
u'مُبَاشَرَةٌ صَبِيٌّ':Added, #1: 1	مُبَاشَرَةُ الشَّيْءِ
u'مُبَاشَرَةٌ صَفْقَةٌ':Added, #1: 1	مُبَاشَرَةُ الصَّبِيِّ
u'مُبَاشَرَةٌ طلب':Added, #1: 1	مُبَاشَرَةِ الصَّفْقَةِ
u'مُبَاشَرَةٌ طَلَبٌ':Added, #1: 1	مُبَاشَرَةِ الطَّلَبِ
u'مُبَاشَرَةٌ طِيبٌ':Added, #1: 1	مُبَاشَرَةِ الطَّلَبِ
u'مُبَاشَرَةٌ ظُلْمٌ':Added, #1: 1	مُبَاشَرَةَ الطِّيبِ
u'مُبَاشَرَةٌ عَاقِلٌ':Added, #1: 1	مُبَاشَرَةِ الظُّلْمِ
u'مُبَاشَرَةٌ عِبَادَةٌ':Added, #1: 1	مُبَاشَرَةِ الْعَاقِلِ
u'مُبَاشَرَةٌ عَقْدٌ':Added, #1: 1	مُبَاشَرَةِ الْعِبَادَةِ
u'مُبَاشَرَةٌ عَقْدٌ':Added, #1: 1	مُبَاشَرَةِ عَقْدٍ
u'مُبَاشَرَةٌ عَقْدٌ':Added, #1: 1	مُبَاشَرَةِ عَقْدِ
u'مُبَاشَرَةٌ عَقْدٌ':Added, #2: 2	مُبَاشَرَةَ الْعَقْدِ
u'مُبَاشَرَةٌ عَقْدٌ':Added, #2: 2	مُبَاشَرَةُ عَقْدِ
u'مُبَاشَرَةٌ عَقْدٌ':Added, #3: 3	مُبَاشَرَةُ الْعَقْدِ
u'مُبَاشَرَةٌ عَقْدٌ':Added, #7: 7	مُبَاشَرَةِ الْعَقْدِ
u'مُبَاشَرَةٌ عُقُودٌ':Added, #7: 7	مُبَاشَرَةَ عَقْدِ
u'مُبَاشَرَةٌ عُقُودٌ':Added, #1: 1	مُبَاشَرَةِ عُقُودِ
u'مُبَاشَرَةٌ عِلَّةٌ':Added, #2: 2	مُبَاشَرَةِ الْعُقُودِ
u'مُبَاشَرَةٌ عِلَّةٌ':Added, #1: 1	مُبَاشَرَةُ عِلَّةٍ
u'مُبَاشَرَةٌ عِلَّةٌ':Added, #1: 1	مُبَاشَرَةِ عِلَّتِهِ
u'مُبَاشَرَةٌ عَمَلٌ':Added, #2: 2	مُبَاشَرَةِ عِلَّةِ
u'مُبَاشَرَةٌ عَمَلٌ':Added, #1: 1	مُبَاشَرَةَ الْعَمَلِ
u'مُبَاشَرَةٌ عَمَلٌ':Added, #1: 1	مُبَاشَرَةِ عَمَلٍ
u'مُبَاشَرَةٌ عَوْرَةٌ':Added, #4: 4	مُبَاشَرَةِ الْعَمَلِ
u'مُبَاشَرَةٌ غير':Added, #1: 1	مُبَاشَرَةِ الْعَوْرَةِ
u'مُبَاشَرَةٌ غَيْرٌ':Added, #1: 1	مُبَاشَرَةَ الْغَيْرِ
u'مُبَاشَرَةٌ غير':Added, #1: 1	مُبَاشَرَةَ الْغَيْرِ
u'مُبَاشَرَةٌ غَيْرٌ':Added, #1: 1	مُبَاشَرَةِ غَيْرِ
u'مُبَاشَرَةٌ فُضُولِيٌّ':Added, #1: 1	مُبَاشَرَةِ غَيْرِ
u'مُبَاشَرَةٌ فِعْلٌ':Added, #2: 2	مُبَاشَرَةِ الْفُضُولِيِّ
u'مُبَاشَرَةٌ فِعْلٌ':Added, #1: 1	مُبَاشَرَةِ فِعْلِ
u'مُبَاشَرَةٌ فِعْلٌ':Added, #2: 2	مُبَاشَرَةَ الْفِعْلِ
u'مُبَاشَرَةٌ فِعْلٌ':Added, #3: 3	مُبَاشَرَةُ الْفِعْلِ
u'مُبَاشَرَةٌ قَبْضٌ':Added, #5: 5	مُبَاشَرَةِ الْفِعْلِ
u'مُبَاشَرَةٌ قَبْضٌ':Added, #1: 1	مُبَاشَرَةَ الْقَبْضِ
u'مُبَاشَرَةٌ قَبِيحٌ':Added, #1: 1	مُبَاشَرَةَ قَبْضِهِ
u'مُبَاشَرَةٌ قتل':Added, #1: 1	مُبَاشَرَةِ الْقَبِيحِ
u'مُبَاشَرَةٌ قَتْلٌ':Added, #1: 1	مُبَاشَرَةُ الْقَتْلِ
u'مُبَاشَرَةٌ قتل':Added, #1: 1	مُبَاشَرَةُ الْقَتْلِ
u'مُبَاشَرَةٌ قتل':Added, #1: 1	مُبَاشَرَةُ قَتْلِهِ
u'مُبَاشَرَةٌ قَتْلٌ':Added, #1: 1	مُبَاشَرَةِ قَتْلِهِ
u'مُبَاشَرَةٌ قَتْلٌ':Added, #1: 1	مُبَاشَرَةُ قَتْلِهِ
u'مُبَاشَرَةٌ قتل':Added, #1: 1	مُبَاشَرَةِ قَتْلِهِ
u'مُبَاشَرَةٌ قَتْلٌ':Added, #6: 6	مُبَاشَرَةِ الْقَتْلِ
u'مُبَاشَرَةٌ كَافِرٌ':Added, #6: 6	مُبَاشَرَةِ الْقَتْلِ
u'مُبَاشَرَةٌ كِتَابَةٌ':Added, #1: 1	مُبَاشَرَةِ الْكَافِرَةِ
u'مُبَاشَرَةٌ مَاءٌ':Added, #2: 2	مُبَاشَرَةَ الْكِتَابَةِ
u'مُبَاشَرَةٌ مَالِكٌ':Added, #1: 1	مُبَاشَرَةُ الْمَاءِ
u'مُبَاشَرَةٌ مُبَاحٌ':Added, #1: 1	مُبَاشَرَةِ الْمَالِكِ
u'مُبَاشَرَةٌ مُبَاحٌ':Added, #1: 1	مُبَاشَرَةٍ مُبَاحَةٍ
u'مُبَاشَرَةٌ مَحْسُوسٌ':Added, #1: 1	مُبَاشَرَةِ مُبَاحَةٍ
u'مُبَاشَرَةٌ مُسْتَقِلٌّ':Added, #1: 1	مُبَاشَرَةٍ مَحْسُوسَةٍ
u'مُبَاشَرَةٌ مَعْصِيَةٌ':Added, #1: 1	مُبَاشَرَةٍ مُسْتَقِلَّةٍ
u'مُبَاشَرَةٌ مُكْرَهٌ':Added, #2: 2	مُبَاشَرَةِ الْمَعْصِيَةِ
u'مُبَاشَرَةٌ مُكْرِهٌ':Added, #1: 1	مُبَاشَرَةِ الْمُكْرَهِ
u'مُبَاشَرَةٌ مَمْنُوعٌ':Added, #1: 1	مُبَاشَرَةِ الْمُكْرِهِ
u'مُبَاشَرَةٌ مَوْضِعٌ':Added, #1: 1	مُبَاشَرَةِ الْمَمْنُوعِ
u'مُبَاشَرَةٌ مُوَكِّلٌ':Added, #1: 1	مُبَاشَرَةُ الْمَوْضِعِ
u'مُبَاشَرَةٌ مُوَكِّلٌ':Added, #1: 1	مُبَاشَرَةُ الْمُوَكِّلِ
u'مُبَاشَرَةٌ نَاظِرٌ':Added, #1: 1	مُبَاشَرَةِ الْمُوَكِّلِ
u'مُبَاشَرَةٌ نَبِيٌّ':Added, #1: 1	مُبَاشَرَةِ النَّاظِرِ
u'مُبَاشَرَةٌ نَجَاسَةٌ':Added, #1: 1	مُبَاشَرَةُ النَّبِيِّ
u'مُبَاشَرَةٌ نَجَاسَةٌ':Added, #1: 1	مُبَاشَرَةِ النَّجَاسَةِ
u'مُبَاشَرَةٌ نِساءٌ':Added, #2: 2	مُبَاشَرَةُ النَّجَاسَةِ
u'مُبَاشَرَةٌ نكاح':Added, #1: 1	مُبَاشَرَةِ النِّسَاءِ
u'مُبَاشَرَةٌ نِكَاحٌ':Added, #1: 1	مُبَاشَرَةِ النِّكَاحِ
u'مُبَاشَرَةٌ هِبَةٌ':Added, #1: 1	مُبَاشَرَةِ النِّكَاحِ
u'مُبَاشَرَةٌ هَيْئَةٌ':Added, #2: 2	مُبَاشَرَةِ الْهِبَةِ
u'مُبَاشَرَةٌ وَظِيفٌ':Added, #1: 1	مُبَاشَرَةِ الْهَيْئَةِ
u'مُبَاشَرَةٌ وَظِيفَةٌ':Added, #1: 1	مُبَاشَرَةِ وَظِيفَتِهِ
u'مُبَاشَرَةٌ وَقْفٌ':Added, #1: 1	مُبَاشَرَةِ وَظِيفَتِهِ
u'مُبَاشَرَةٌ وَكِيلٌ':Added, #1: 1	مُبَاشَرَةِ الْوَقْفِ
u'مُبَاشَرَةٌ وَكِيلٌ':Added, #1: 1	مُبَاشَرَةَ الْوَكِيلِ
u'مُبَاشَرَةٌ وَكِيلٌ':Added, #1: 1	مُبَاشَرَةُ الْوَكِيلِ
u'مُبَاشَرَةٌ وَلاَءٌ':Added, #2: 2	مُبَاشَرَةِ الْوَكِيلِ
u'مُبَاشَرَةٌ وَلِيٌّ':Added, #1: 1	مُبَاشَرَةِ الْوَلَاءِ
u'مُبَاشَرَةٌ وَلِيٌّ':Added, #1: 1	مُبَاشَرَةِ وَلِيٍّ
u'مُبَاشَرَةٌ وَلِيٌّ':Added, #2: 2	مُبَاشَرَةُ الْوَلِيِّ
u'مُبَاشَرَةٌ يَمِينٌ':Added, #3: 3	مُبَاشَرَةِ الْوَلِيِّ
u'مُبَاهَاةٌ أهْلٌ':Added, #1: 1	مُبَاشَرَةَ الْيَمِينِ
u'مُبَاهَاةٌ رَسُولٌ':Added, #1: 1	مُبَاهَاةُ أَهْلِ
u'مُبَاهَاةٌ سَيِّدٌ':Added, #1: 1	مُبَاهَاةِ الرَّسُولِ
u'مُبَايَعَةٌ إمَامٌ':Added, #1: 1	مُبَاهَاةِ سَيِّدِ
u'مُبَايَعَةٌ سَيِّدٌ':Added, #2: 2	مُبَايَعَةِ الْإِمَامِ
u'مُبَايَعَةٌ غير':Added, #3: 3	مُبَايَعَةِ السَّيِّدِ
u'مُبَايَعَةٌ غَيْرٌ':Added, #1: 1	مُبَايَعَةُ غَيْرِ
u'مُبَايَعَةٌ كَافِرٌ':Added, #1: 1	مُبَايَعَةُ غَيْرِ
u'مُبَايَعَةٌ مَدِينٌ':Added, #1: 1	مُبَايَعَةَ الْكَافِرِ
u'مُبَايَعَةٌ مُرْتَهِنٌ':Added, #1: 1	مُبَايَعَةِ الْمَدِينِ
u'مُبَايَعَةٌ واحد':Added, #1: 1	مُبَايَعَةِ الْمُرْتَهِنِ
u'مُبَايَعَةٌ وَاحِدٌ':Added, #1: 1	مُبَايَعَةُ وَاحِدٍ
u'مَبَرَّةٌ إِقْراضٌ':Added, #1: 1	مُبَايَعَةُ وَاحِدٍ
u'مَبَرَّةٌ أهْلٌ':Added, #3: 3	مَبَرَّةِ الْإِقْرَاضِ
u'مَبَرَّةٌ ذِمِّيٌّ':Added, #1: 1	مَبَرَّةِ أَهْلِ
u'مَبِيتٌ ثَالِثٌ':Added, #1: 1	مَبَرَّةِ الذِّمِّيِّ
u'مَبِيتٌ زَوْجٌ':Added, #2: 2	مَبِيتُ الثَّالِثَةِ
u'مَبِيتٌ غرباء':Added, #1: 1	مَبِيتُ الزَّوْجِ
u'مَبِيتٌ لَيَالِي':Added, #2: 2	مَبِيتِ الْغُرَبَاءِ
u'مَبِيتٌ لَيْلٌ':Added, #2: 2	مَبِيتِ لَيَالِيِ
u'مَبِيتٌ لَيْلٌ':Added, #1: 1	مَبِيتُ اللَّيْلِ
u'مَبِيتٌ لَيْلٌ':Added, #1: 1	مَبِيتُ اللَّيْلَةِ
u'مَبِيتٌ لَيْلٌ':Added, #1: 1	مَبِيتِ اللَّيْلَةِ
u'مَبِيتٌ لَيْلٌ':Added, #1: 1	مَبِيتَ لَيْلَةٍ
u'مُتَابَعٌ إِجْمَاعٌ':Added, #1: 1	مَبِيتَ لَيْلَتَيْنِ
u'مُتَابَعٌ أَرْكانٌ':Added, #1: 1	مُتَابَعَةِ الْإِجْمَاعِ
u'مُتَابَعٌ أَرْكَانٌ':Added, #1: 1	مُتَابَعَةِ الْأَرْكَانِ
u'مُتَابَعٌ أَفْعَالٌ':Added, #1: 1	مُتَابَعَةِ الْأَرْكَانِ
u'مُتَابَعٌ أَكْثَرُ':Added, #1: 1	مُتَابَعَةِ الْأَفْعَالِ
u'مُتَابَعٌ إمَامٌ':Added, #1: 1	مُتَابَعَةُ الْأَكْثَرِ
u'مُتَابَعٌ إمَامٌ':Added, #12: 12	مُتَابَعَةُ الْإِمَامِ
u'مُتَابَعٌ إمَامٌ':Added, #18: 18	مُتَابَعَةَ الْإِمَامِ
u'مُتَابَعٌ إمَامٌ':Added, #18: 18	مُتَابَعَةِ الْإِمَامِ
u'مُتَابَعٌ إمَامٌ':Added, #2: 2	مُتَابَعَةُ إمَامِهِ
u'مُتَابَعٌ إمَامٌ':Added, #3: 3	مُتَابَعَةَ إمَامِهِ
u'مُتَابَعٌ أَمْرٌ':Added, #3: 3	مُتَابَعَةِ إمَامِهِ
u'مُتَابَعٌ أَميرٌ':Added, #1: 1	مُتَابَعَةِ الْأَمْرِ
u'مُتَابَعَةٌ إِجْمَاعٌ':Added, #1: 1	مُتَابَعَةَ أَمِيرِ
u'مُتَابَعَةٌ أَرْكانٌ':Added, #1: 1	مُتَابَعَةِ الْإِجْمَاعِ
u'مُتَابَعَةٌ أَرْكَانٌ':Added, #1: 1	مُتَابَعَةِ الْأَرْكَانِ
u'مُتَابَعَةٌ أَفْعَالٌ':Added, #1: 1	مُتَابَعَةِ الْأَرْكَانِ
u'مُتَابَعَةٌ أَكْثَرُ':Added, #1: 1	مُتَابَعَةِ الْأَفْعَالِ
u'مُتَابَعَةٌ إمَامٌ':Added, #1: 1	مُتَابَعَةُ الْأَكْثَرِ
u'مُتَابَعَةٌ إمَامٌ':Added, #12: 12	مُتَابَعَةُ الْإِمَامِ
u'مُتَابَعَةٌ إمَامٌ':Added, #18: 18	مُتَابَعَةَ الْإِمَامِ
u'مُتَابَعَةٌ إمَامٌ':Added, #18: 18	مُتَابَعَةِ الْإِمَامِ
u'مُتَابَعَةٌ إمَامٌ':Added, #2: 2	مُتَابَعَةُ إمَامِهِ
u'مُتَابَعَةٌ إمَامٌ':Added, #3: 3	مُتَابَعَةَ إمَامِهِ
u'مُتَابَعَةٌ أَمْرٌ':Added, #3: 3	مُتَابَعَةِ إمَامِهِ
u'مُتَابَعَةٌ أَميرٌ':Added, #1: 1	مُتَابَعَةِ الْأَمْرِ
u'مُتَابَعَةٌ حاجٌّ':Added, #1: 1	مُتَابَعَةَ أَمِيرِ
u'مُتَابَعَةٌ حَبيبٌ':Added, #1: 1	مُتَابَعَةُ الْحَاجِّ
u'مُتَابَعَةٌ حَبيبٌ':Added, #1: 1	مُتَابَعَةِ الْحَبِيبِ
u'مُتَابَعَةٌ حَبيبٌ':Added, #1: 1	مُتَابَعَةُ حَبِيبِ
u'مُتَابَعَةٌ حُكْم':Added, #1: 1	مُتَابَعَةُ حَبِيبِهِ
u'مُتَابَعَةٌ حُكْمِيّ':Added, #2: 2	مُتَابَعَةٍ حُكْمِيَّةٍ
u'مُتَابَعَةٌ رَسُولٌ':Added, #2: 2	مُتَابَعَةٍ حُكْمِيَّةٍ
u'مُتَابَعَةٌ سِتٌّ':Added, #1: 1	مُتَابَعَةِ الرَّسُولِ
u'مُتَابَعَةٌ سُنَّةٌ':Added, #1: 1	مُتَابَعَةُ السِّتِّ
u'مُتَابَعَةٌ سُنَّةٌ':Added, #1: 1	مُتَابَعَةُ السُّنَّةِ
u'مُتَابَعَةٌ سُنَّةٌ':Added, #1: 1	مُتَابَعَةُ سُنَّةِ
u'مُتَابَعَةٌ شَخْصٌ':Added, #3: 3	مُتَابَعَةِ السُّنَّةِ
u'مُتَابَعَةٌ ظَنٌّ':Added, #1: 1	مُتَابَعَةِ شَخْصٍ
u'مُتَابَعَةٌ ظَنٌّ':Added, #1: 1	مُتَابَعَةِ ظَنِّ
u'مُتَابَعَةٌ غَرِيمٌ':Added, #1: 1	مُتَابَعَةُ ظَنِّهِ
u'مُتَابَعَةٌ غَسْلٌ':Added, #1: 1	مُتَابَعَةَ الْغَرِيمِ
u'مُتَابَعَةٌ قول':Added, #1: 1	مُتَابَعَةَ غَسْلِ
u'مُتَابَعَةٌ قَوْلٌ':Added, #1: 1	مُتَابَعَةَ قَوْلِهِ
u'مُتَابَعَةٌ كَفِيلٌ':Added, #1: 1	مُتَابَعَةَ قَوْلِهِ
u'مُتَابَعَةٌ مَشْيٌ':Added, #1: 1	مُتَابَعَةَ الْكَفِيلِ
u'مُتَابَعَةٌ مَشْيٌ':Added, #2: 2	مُتَابَعَةَ الْمَشْيِ
u'مُتَابَعَةٌ مُصْحَفٌ':Added, #9: 9	مُتَابَعَةُ الْمَشْيِ
u'مُتَابَعَةٌ مُؤَذِّنٌ':Added, #2: 2	مُتَابَعَةِ الْمُصْحَفِ
u'مُتَابَعَةٌ مُؤَذِّنٌ':Added, #1: 1	مُتَابَعَةُ الْمُؤَذِّنِ
u'مُتَابَعَةٌ نَبِيٌّ':Added, #1: 1	مُتَابَعَةِ الْمُؤَذِّنِ
u'مُتَابَعَةٌ نَفْسٌ':Added, #2: 2	مُتَابَعَةَ النَّبِيِّ
u'مُتَابَعَةٌ نَوَوِيٌّ':Added, #1: 1	مُتَابَعَةَ النَّفْسِ
u'مُتَابَعَةٌ واحد':Added, #1: 1	مُتَابَعَةِ النَّوَوِيِّ
u'مُتَابَعَةٌ وَاحِدٌ':Added, #1: 1	مُتَابَعَةِ وَاحِدٍ
u'مُتَابَعَةٌ ولد':Added, #1: 1	مُتَابَعَةِ وَاحِدٍ
u'مُتَابَعَةٌ وَلَدٌ':Added, #1: 1	مُتَابَعَةِ الْوَلَدِ
u'مُتَابَعٌ حاجٌّ':Added, #1: 1	مُتَابَعَةِ الْوَلَدِ
u'مُتَابَعٌ حَبيبٌ':Added, #1: 1	مُتَابَعَةُ الْحَاجِّ
u'مُتَابَعٌ حَبيبٌ':Added, #1: 1	مُتَابَعَةِ الْحَبِيبِ
u'مُتَابَعٌ حَبيبٌ':Added, #1: 1	مُتَابَعَةُ حَبِيبِ
u'مُتَابَعٌ حُكْم':Added, #1: 1	مُتَابَعَةُ حَبِيبِهِ
u'مُتَابَعٌ حُكْمِيّ':Added, #2: 2	مُتَابَعَةٍ حُكْمِيَّةٍ
u'مُتَابَعٌ رَسُولٌ':Added, #2: 2	مُتَابَعَةٍ حُكْمِيَّةٍ
u'مُتَابَعٌ سِتٌّ':Added, #1: 1	مُتَابَعَةِ الرَّسُولِ
u'مُتَابَعٌ سُنَّةٌ':Added, #1: 1	مُتَابَعَةُ السِّتِّ
u'مُتَابَعٌ سُنَّةٌ':Added, #1: 1	مُتَابَعَةُ السُّنَّةِ
u'مُتَابَعٌ سُنَّةٌ':Added, #1: 1	مُتَابَعَةُ سُنَّةِ
u'مُتَابَعٌ شَخْصٌ':Added, #3: 3	مُتَابَعَةِ السُّنَّةِ
u'مُتَابَعٌ ظَنٌّ':Added, #1: 1	مُتَابَعَةِ شَخْصٍ
u'مُتَابَعٌ ظَنٌّ':Added, #1: 1	مُتَابَعَةِ ظَنِّ
u'مُتَابَعٌ غَرِيمٌ':Added, #1: 1	مُتَابَعَةُ ظَنِّهِ
u'مُتَابَعٌ غَسْلٌ':Added, #1: 1	مُتَابَعَةَ الْغَرِيمِ
u'مُتَابَعٌ قول':Added, #1: 1	مُتَابَعَةَ غَسْلِ
u'مُتَابَعٌ قَوْلٌ':Added, #1: 1	مُتَابَعَةَ قَوْلِهِ
u'مُتَابَعٌ كَفِيلٌ':Added, #1: 1	مُتَابَعَةَ قَوْلِهِ
u'مُتَابَعٌ مَشْيٌ':Added, #1: 1	مُتَابَعَةَ الْكَفِيلِ
u'مُتَابَعٌ مَشْيٌ':Added, #2: 2	مُتَابَعَةَ الْمَشْيِ
u'مُتَابَعٌ مُصْحَفٌ':Added, #9: 9	مُتَابَعَةُ الْمَشْيِ
u'مُتَابَعٌ مُؤَذِّنٌ':Added, #2: 2	مُتَابَعَةِ الْمُصْحَفِ
u'مُتَابَعٌ مُؤَذِّنٌ':Added, #1: 1	مُتَابَعَةُ الْمُؤَذِّنِ
u'مُتَابَعٌ نَبِيٌّ':Added, #1: 1	مُتَابَعَةِ الْمُؤَذِّنِ
u'مُتَابَعٌ نَفْسٌ':Added, #2: 2	مُتَابَعَةَ النَّبِيِّ
u'مُتَابَعٌ نَوَوِيٌّ':Added, #1: 1	مُتَابَعَةَ النَّفْسِ
u'مُتَابَعٌ واحد':Added, #1: 1	مُتَابَعَةِ النَّوَوِيِّ
u'مُتَابَعٌ وَاحِدٌ':Added, #1: 1	مُتَابَعَةِ وَاحِدٍ
u'مُتَابَعٌ ولد':Added, #1: 1	مُتَابَعَةِ وَاحِدٍ
u'مُتَابَعٌ وَلَدٌ':Added, #1: 1	مُتَابَعَةِ الْوَلَدِ
u'مَتَعَ نهار':Subject, #1: 1	مُتَابَعَةِ الْوَلَدِ
u'مَتَعَ نهار':Subject, #1: 1	مَتَعَ النّهَارُ
u'مَتَعَ نَهَارٌ':Subject, #1: 1	مَتَعَ النَّهَارُ
u'مَتَعَ نَهَارٌ':Subject, #1: 1	مَتَعَ النّهَارُ
u'مَتْنٌ أَنْوَارٌ':Added, #1: 1	مَتَعَ النَّهَارُ
u'مَتْنٌ بَسْمَلَةٌ':Added, #1: 1	مَتْنِ الْأَنْوَارِ
u'مَتْنٌ تَلْخيصٌ':Added, #1: 1	مَتْنِ الْبَسْمَلَةِ
u'مَتْنٌ تَنْوِيرٌ':Added, #1: 1	مَتْنِ التَّلْخِيصِ
u'مَتْنٌ ثَوْرٌ':Added, #15: 15	مَتْنِ التَّنْوِيرِ
u'مَتْنٌ حَديثٌ':Added, #1: 1	مَتْنِ ثَوْرٍ
u'مَتْنٌ حَديثٌ':Added, #10: 10	مَتْنِ الْحَدِيثِ
u'مَتْنٌ حَديثٌ':Added, #1: 1	مَتْنَ الْحَدِيثِ
u'مَتْنٌ حَديثٌ':Added, #1: 1	مَتْنُ الْحَدِيثِ
u'مَتْنٌ حَديثٌ':Added, #1: 1	مَتْنُ الْحَدِيثَيْنِ
u'مَتْنٌ دُرَرٌ':Added, #2: 2	مَتْنِ حَدِيثِ
u'مَتْنٌ دُرَرٌ':Added, #1: 1	مَتْنِ دُرَرِ
u'مَتْنٌ دَليلٌ':Added, #4: 4	مَتْنِ الدُّرَرِ
u'مَتْنٌ رَوْضٌ':Added, #1: 1	مَتْنِ الدَّلِيلِ
u'مَتْنٌ رَوْضٌ':Added, #1: 1	مَتْنَ الرَّوْضِ
u'مَتْنٌ ريحٌ':Added, #1: 1	مَتْنِ الرَّوْضِ
u'مَتْنٌ طَرِيقٌ':Added, #1: 1	مَتْنِ الرِّيحِ
u'مَتْنٌ عُبَابٌ':Added, #2: 2	مَتْنِ الطَّرِيقِ
u'مَتْنٌ عُبَابٌ':Added, #1: 1	مَتْنَ الْعُبَابِ
u'مَتْنٌ غُرَرٌ':Added, #2: 2	مَتْنِ الْعُبَابِ
u'مَتْنٌ كِتَابٌ':Added, #1: 1	مَتْنِ الْغُرَرِ
u'مَتْنٌ لُبَابٌ':Added, #3: 3	مَتْنِ الْكِتَابِ
u'مَتْنٌ مَاءٌ':Added, #4: 4	مَتْنِ اللُّبَابِ
u'مَتْنٌ مُجَرَّدٌ':Added, #2: 2	مَتْنِ الْمَاءِ
u'مَتْنٌ مَجْمَعٌ':Added, #1: 1	مَتْنٍ مُجَرَّدٍ
u'مَتْنٌ مُخْتَارٌ':Added, #1: 1	مَتْنِ الْمَجْمَعِ
u'مَتْنٌ مُقْنِعٌ':Added, #1: 1	مَتْنِ الْمُخْتَارِ
u'مَتْنٌ مَنَارٌ':Added, #1: 1	مَتْنِ الْمُقْنِعِ
u'مَتْنٌ مِنْهَاجٌ':Added, #1: 1	مَتْنِ الْمَنَارِ
u'مَتْنٌ مِنْهَاجٌ':Added, #1: 1	مَتْنَ الْمِنْهَاجِ
u'مَتْنٌ مِنْهَاجٌ':Added, #1: 1	مَتْنُ الْمِنْهَاجِ
u'مَتْنٌ مُنْيَةٌ':Added, #1: 1	مَتْنِ الْمِنْهَاجِ
u'مَتْنٌ مُنْيَةٌ':Added, #1: 1	مَتْنِ الْمُنْيَةِ
u'مَتْنٌ مَوَاهِبُ':Added, #1: 1	مَتْنِ مُنْيَةِ
u'مَتْنٌ مَوَاهِبُ':Added, #1: 1	مَتْنِ الْمَوَاهِبِ
u'مَتَنَ نَاسٌ':Predicate, #2: 2	مَتْنِ مَوَاهِبِ
u'مَتْنٌ نُقايَة':Added, #1: 1	مَتَنَ النّاسَ
u'مَتْنٌ هِدَايَةٌ':Added, #1: 1	مَتْنِ النُّقَايَةِ
u'مَتْنٌ وِقَايَةٌ':Added, #1: 1	مَتْنُ الْهِدَايَةِ
u'مُتُونٌ أَعْدَاءٌ':Added, #1: 1	مَتْنُ الْوِقَايَةِ
u'مُتُونٌ خَيْلٌ':Added, #1: 1	مُتُونِ الْأَعْدَاءِ
u'مُتُونٌ رِوايَةٌ':Added, #1: 1	مُتُونِ الْخَيْلِ
u'مُتُونٌ غَمَامٌ':Added, #1: 1	مُتُونِ الرِّوَايَةِ
u'مُتُونٌ مَذْهَبٌ':Added, #1: 1	مُتُونِ غَمَامِ
u'مَثَّلَ اِبْنٌ':Subject, #1: 1	مُتُونُ الْمَذْهَبِ
u'مَثَّلَ أَصْحَابٌ':Subject, #3: 3	مَثَّلَ ابْنُ
u'مَثَّلَ أصل':Subject, #1: 1	مَثَّلَ الْأَصْحَابُ
u'مَثَّلَ أًصْلٌ':Subject, #1: 1	مَثَّلَ الْأَصْلُ
u'مَثَّلَ إمَامٌ':Subject, #1: 1	مَثَّلَ الْأَصْلُ
u'مَثَلَ بَيْنٌ':Predicate, #2: 2	مَثَّلَ الْإِمَامُ
u'مَثَّلَ تَحْرِيمٌ':Predicate, #1: 1	مَثَلَ بَيْنَ
u'مَثَّلَ جَمَاعَةٌ':Subject, #1: 1	مَثَّلَ تَحْرِيمَ
u'مَثَّلَ دَلالَةٌ':Predicate, #1: 1	مَثَّلَ جَمَاعَةٌ
u'مَثَّلَ كَافِرٌ':Subject, #1: 1	مَثَّلَ الدَّلَالَةَ
u'مَثَّلَ كَلاَمٌ':Predicate, #1: 1	مَثَّلَ الْكَافِرُ
u'مَثَّلَ مَسْأَلَةٌ':Predicate, #1: 1	مَثَّلَ كَلَامَ
u'مَثَّلَ مُصَنِّفٌ':Subject, #3: 3	مَثَّلَ الْمَسْأَلَةَ
u'مُجَادَلَةٌ جُلّ':Added, #14: 14	مَثَّلَ الْمُصَنِّفُ
u'مُجَادَلَةٌ جُلَّة':Added, #1: 1	مُجَادَلَةُ جُلّةِ
u'مُجَادَلَةٌ زَوْجَةٌ':Added, #1: 1	مُجَادَلَةُ جُلّةِ
u'مُجَازَاةٌ إحْسَانٌ':Added, #1: 1	مُجَادَلَةُ زَوْجَةِ
u'مُجَازَاةٌ إحْسَانٌ':Added, #1: 1	مُجَازَاةَ الْإِحْسَانِ
u'مُجَازَاةٌ صَغِيرٌ':Added, #1: 1	مُجَازَاةُ الْإِحْسَانِ
u'مَجَازٌ إضْمارٌ':Added, #1: 1	مُجَازَاةِ الصَّغِيرَةِ
u'مَجَازٌ أَوَّلُ':Added, #1: 1	مَجَازُ الْإِضْمَارِ
u'مَجَازٌ تَرْكِيبٌ':Added, #1: 1	مَجَازَ الْأَوَّلِ
u'مَجَازٌ تَرْكِيبٌ':Added, #2: 2	مَجَازَ التَّرْكِيبِ
u'مَجَازٌ تَسْمِيَة':Added, #3: 3	مَجَازِ التَّرْكِيبِ
u'مَجَازٌ تَشْبِيه':Added, #1: 1	مَجَازِ تَسْمِيَةِ
u'مَجَازٌ تَشْبِيه':Added, #1: 1	مَجَازُ التَّشْبِيهِ
u'مَجَازٌ تَشْبِيهٌ':Added, #1: 1	مَجَازِ التّشْبِيهِ
u'مَجَازٌ تَشْبِيه':Added, #1: 1	مَجَازُ تَشْبِيهٍ
u'مَجَازٌ تَعْبِيرٌ':Added, #2: 2	مَجَازِ التَّشْبِيهِ
u'مَجَازٌ تَمْثيلٌ':Added, #3: 3	مَجَازِ التَّعْبِيرِ
u'مَجَازٌ جِنْسٌ':Added, #2: 2	مَجَازِ التَّمْثِيلِ
u'مَجَازٌ حَذْف':Added, #1: 1	مَجَازُ الْجِنْسِ
u'مَجَازٌ زِيادَةٌ':Added, #9: 9	مَجَازِ الْحَذْفِ
u'مَجَازٌ زِيادَةٌ':Added, #1: 1	مَجَازَ الزِّيَادَةِ
u'مَجَازٌ زِيادَةٌ':Added, #1: 1	مَجَازُ الزِّيَادَةِ
u'مَجَازٌ سَبَبِيَّةٌ':Added, #4: 4	مَجَازِ الزِّيَادَةِ
u'مَجَازٌ شافِع':Added, #1: 1	مَجَازُ السَّبَبِيَّةِ
u'مَجَازٌ شافِعِيّ':Added, #1: 1	مَجَازَ الشَّافِعِيَّةِ
u'مَجَازٌ شَرْعِيٌّ':Added, #1: 1	مَجَازَ الشَّافِعِيَّةِ
u'مَجَازٌ عَامٌّ':Added, #1: 1	مَجَازٍ شَرْعِيٍّ
u'مَجَازٌ عَلاَقَةٌ':Added, #1: 1	مَجَازٍ عَامٍّ
u'مَجَازٌ عَلاَقَةٌ':Added, #1: 1	مَجَازُ الْعَلَاقَةِ
u'مُجَازَفَةٌ اِبْنٌ':Added, #1: 1	مَجَازِ الْعَلَاقَةِ
u'مَجَازٌ فلان':Added, #1: 1	مُجَازَفَةِ ابْنِ
u'مَجَازٌ قُرْآنٌ':Added, #1: 1	مَجَازَ الشَّافِعِيَّةِ
u'مَجَازٌ قَرِينٌ':Added, #1: 1	مَجَازِ الْقُرْآنِ
u'مَجَازٌ كَلاَمٌ':Added, #1: 1	مَجَازُ الْقَرِينَةِ
u'مَجَازٌ لُغَةٌ':Added, #1: 1	مَجَازَ كَلَامِهِ
u'مَجَازٌ لَفْظٌ':Added, #1: 1	مَجَازِ اللُّغَةِ
u'مَجَازٌ لَفْظٌ':Added, #1: 1	مَجَازَ اللَّفْظِ
u'مَجَازٌ لَفْظٌ':Added, #1: 1	مَجَازُ لَفْظٍ
u'مَجَازٌ مَاءٌ':Added, #2: 2	مَجَازِ اللَّفْظِ
u'مَجَازٌ مَجَازٌ':Added, #1: 1	مَجَازُ الْمَاءِ
u'مَجَازٌ مَرَاتِبُ':Added, #1: 1	مَجَازُ الْمَجَازِ
u'مَجَازٌ مُسْتَعَارٌ':Added, #1: 1	مَجَازَ الْمَرَاتِبِ
u'مَجَازٌ مُقَابَلٌ':Added, #1: 1	مَجَازٍ مُسْتَعَارٍ
u'مَجَازٌ مُقَابَلَةٌ':Added, #1: 1	مَجَازِ الْمُقَابَلَةِ
u'مَجَازٌ نُقْصَانٌ':Added, #1: 1	مَجَازِ الْمُقَابَلَةِ
u'مَجَازٌ وَصْفٌ':Added, #2: 2	مَجَازِ النُّقْصَانِ
u'مُجَالَسَةٌ آخِرَةٌ':Added, #1: 1	مَجَازُ الْوَصْفِ
u'مُجَالَسَةٌ أخيار':Added, #1: 1	مُجَالَسَةَ الْآخِرَةِ
u'مُجَالَسَةٌ أَخْيَارٌ':Added, #1: 1	مُجَالَسَةُ الْأَخْيَارِ
u'مُجَالَسَةٌ أَعْدَاءٌ':Added, #1: 1	مُجَالَسَةُ الْأَخْيَارِ
u'مُجَالَسَةٌ أهْلٌ':Added, #1: 1	مُجَالَسَةَ الْأَعْدَاءِ
u'مُجَالَسَةٌ أهْلٌ':Added, #1: 1	مُجَالَسَةِ أَهْلِ
u'مُجَالَسَةٌ أهْلٌ':Added, #1: 1	مُجَالَسَةِ أَهْلِهِ
u'مُجَالَسَةٌ ثَقِيلٌ':Added, #2: 2	مُجَالَسَةَ أَهْلِ
u'مُجَالَسَةٌ حَسَنٌ':Added, #2: 2	مُجَالَسَةُ الثَّقِيلِ
u'مُجَالَسَةٌ حَكِيمٌ':Added, #1: 1	مُجَالَسَةِ الْحَسَنِ
u'مُجَالَسَةٌ رِجَالٌ':Added, #1: 1	مُجَالَسَةُ الْحَكِيمِ
u'مُجَالَسَةٌ سَفِيهٌ':Added, #1: 1	مُجَالَسَةُ الرِّجَالِ
u'مُجَالَسَةٌ عُقَلاَءُ':Added, #1: 1	مُجَالَسَةُ السَّفِيهِ
u'مُجَالَسَةٌ علماء':Added, #1: 1	مُجَالَسَةُ الْعُقَلَاءِ
u'مُجَالَسَةٌ عُلَمَاءُ':Added, #1: 1	مُجَالَسَةِ الْعُلَمَاءِ
u'مُجَالَسَةٌ علماء':Added, #1: 1	مُجَالَسَةِ الْعُلَمَاءِ
u'مُجَالَسَةٌ عُلَمَاءُ':Added, #2: 2	مُجَالَسَةَ الْعُلَمَاءِ
u'مُجَالَسَةٌ غُلاَمٌ':Added, #2: 2	مُجَالَسَةَ الْعُلَمَاءِ
u'مُجَالَسَةٌ قَدَرُ':Added, #2: 2	مُجَالَسَةِ الْغُلَامِ
u'مُجَالَسَةٌ قَدَر':Added, #1: 1	مُجَالَسَةِ الْقَدَرِيَّةِ
u'مُجَالَسَةٌ قَدَرِيّ':Added, #1: 1	مُجَالَسَةِ الْقَدَرِيَّةِ
u'مُجَامَعَةٌ بَهيمٌ':Added, #1: 1	مُجَالَسَةِ الْقَدَرِيَّةِ
u'مُجَامَعَةٌ بَهِيمَةٌ':Added, #1: 1	مُجَامَعَةِ الْبَهِيمَةِ
u'مُجَامَعَةٌ ثَوابٌ':Added, #1: 1	مُجَامَعَةِ الْبَهِيمَةِ
u'مُجَامَعَةٌ رُخْصَةٌ':Added, #1: 1	مُجَامَعَةُ الثَّوَابِ
u'مُجَامَعَةٌ صَوْمٌ':Added, #1: 1	مُجَامَعَةِ الرُّخْصَةِ
u'مُجَامَعَةٌ مثل':Added, #1: 1	مُجَامَعَةِ الصَّوْمِ
u'مُجَامَعَةٌ مِثْلٌ':Added, #1: 1	مُجَامَعَةَ مِثْلِهِ
u'مُجَامَعَةٌ نَفْيٌ':Added, #1: 1	مُجَامَعَةَ مِثْلِهِ
u'مُجَانَبَةٌ بِدَعٌ':Added, #1: 1	مُجَامَعَةِ النَّفْيِ
u'مُجَانَبَةٌ خلطاء':Added, #1: 1	مُجَانَبَةُ الْبِدَعِ
u'مُجَانَبَةٌ رِوايَةٌ':Added, #1: 1	مُجَانَبَةَ خُلَطَاءِ
u'مُجَانَبَةٌ زَلَلٌ':Added, #1: 1	مُجَانَبَةُ رِوَايَتِهِ
u'مُجَانَبَةٌ شَيْءٌ':Added, #1: 1	مُجَانَبَةَ الزَّلَلِ
u'مُجَانَبَةٌ غَرِيبٌ':Added, #1: 1	مُجَانَبَةُ الشَّيْءِ
u'مُجَانَبَةٌ قَرِينٌ':Added, #1: 1	مُجَانَبَةُ الْغَرِيبِ
u'مُجَانَبَةٌ كبر':Added, #1: 1	مُجَانَبَةُ قَرِينِهِ
u'مُجَانَبَةٌ كبر':Added, #1: 1	مُجَانَبَةُ الْكِبْرِ
u'مُجَانَبَةٌ كِبْرٌ':Added, #1: 1	مُجَانَبَةِ الْكِبْرِ
u'مُجَانَبَةٌ كِبْرٌ':Added, #1: 1	مُجَانَبَةُ الْكِبْرِ
u'مُجَانَبَةٌ كذب':Added, #1: 1	مُجَانَبَةِ الْكِبْرِ
u'مُجَانَبَةٌ كَذِبٌ':Added, #1: 1	مُجَانَبَةَ الْكَذِبِ
u'مُجَانَسَةٌ أَلْفَاظٌ':Added, #1: 1	مُجَانَبَةَ الْكَذِبِ
u'مُجَانَسَةٌ عِوَضٌ':Added, #1: 1	مُجَانَسَةِ الْأَلْفَاظِ
u'مُجَاهَدَةٌ بَذْلٌ':Added, #1: 1	مُجَانَسَةُ الْعِوَضَيْنِ
u'مُجَاهَدَةٌ شَيْطَانٌ':Added, #1: 1	مُجَاهَدَةِ بَذْلِ
u'مُجَاهَدَةٌ كُفَّارٌ':Added, #1: 1	مُجَاهَدَةُ الشَّيْطَانِ
u'مُجَاهَدَةٌ نَفْسٌ':Added, #1: 1	مُجَاهَدَةِ الْكُفَّارِ
u'مُجَاهَرَةٌ إمَامٌ':Added, #1: 1	مُجَاهَدَةِ نَفْسِهِ
u'مُجَاهَرَةٌ رَدْعٌ':Added, #1: 1	مُجَاهَرَةِ الْإِمَامِ
u'مُجَاوَرَةٌ إمَامٌ':Added, #1: 1	مُجَاهَرَةَ رَدْعٍ
u'مُجَاوَرَةٌ بَعْضٌ':Added, #1: 1	مُجَاوَرَةُ الْإِمَامِ
u'مُجَاوَرَةٌ دَمٌ':Added, #1: 1	مُجَاوَرَةِ بَعْضٍ
u'مُجَاوَرَةٌ زَيْدٌ':Added, #1: 1	مُجَاوَرَةِ الدَّمِ
u'مُجَاوَرَةٌ يَوْمٌ':Added, #1: 1	مُجَاوَرَةُ زَيْدٍ
u'مُجَاوَزَةٌ آخِرُ':Added, #1: 1	مُجَاوَرَةُ الْيَوْمِ
u'مُجَاوَزَةٌ أَرْبَعَةٌ':Added, #1: 1	مُجَاوَزَةُ آخِرِ
u'مُجَاوَزَةٌ أَشْيَاءٌ':Added, #1: 1	مُجَاوَزَةِ أَرْبَعَةِ
u'مُجَاوَزَةٌ أَكْثَرُ':Added, #2: 2	مُجَاوَزَةِ الْأَشْيَاءِ
u'مُجَاوَزَةٌ أَكْثَرُ':Added, #1: 1	مُجَاوَزَةِ أَكْثَرِهِ
u'مُجَاوَزَةٌ اِنْتِفاء':Added, #1: 1	مُجَاوَزَةِ الْأَكْثَرِ
u'مُجَاوَزَةٌ بَاطن':Added, #1: 1	مُجَاوَزَةِ انْتِفَاءِ
u'مُجَاوَزَةٌ باطِنٌ':Added, #1: 1	مُجَاوَزَةُ بَاطِنِ
u'مُجَاوَزَةٌ بَساتِينُ':Added, #1: 1	مُجَاوَزَةُ بَاطِنِ
u'مُجَاوَزَةٌ بِنَاءٌ':Added, #1: 1	مُجَاوَزَةُ الْبَسَاتِينِ
u'مُجَاوَزَةٌ بُيُوتٌ':Added, #1: 1	مُجَاوَزَةِ الْبِنَاءِ
u'مُجَاوَزَةٌ ثَلاثُ':Added, #2: 2	مُجَاوَزَةُ بُيُوتِ
u'مُجَاوَزَةٌ ثَلاثَةٌ':Added, #2: 2	مُجَاوَزَةِ الثَّلَاثِ
u'مُجَاوَزَةٌ جَمْرَةٌ':Added, #2: 2	مُجَاوَزَةِ ثَلَاثَةِ
u'مُجَاوَزَةٌ جَمْرَة':Added, #1: 1	مُجَاوَزَةُ جَمْرَةِ
u'مُجَاوَزَةٌ جَمِيع':Added, #1: 1	مُجَاوَزَةُ جَمْرَةِ
u'مُجَاوَزَةٌ جَمِيع':Added, #1: 1	مُجَاوَزَةُ الْجَمِيعِ
u'مُجَاوَزَةٌ حَدٌّ':Added, #1: 1	مُجَاوَزَةِ الْجَمِيعِ
u'مُجَاوَزَةٌ حَدٌّ':Added, #12: 12	مُجَاوَزَةُ الْحَدِّ
u'مُجَاوَزَةٌ حُدودٌ':Added, #1: 1	مُجَاوَزَةُ حَدٍّ
u'مُجَاوَزَةٌ ختان':Added, #1: 1	مُجَاوَزَةِ حُدُودِ
u'مُجَاوَزَةٌ خِتَانٌ':Added, #1: 1	مُجَاوَزَةُ الْخِتَانِ
u'مُجَاوَزَةٌ دَرْبٌ':Added, #1: 1	مُجَاوَزَةُ الْخِتَانِ
u'مُجَاوَزَةٌ دَرْبٌ':Added, #3: 3	مُجَاوَزَةُ الدَّرْبِ
u'مُجَاوَزَةٌ دَمٌ':Added, #3: 3	مُجَاوَزَةِ الدَّرْبِ
u'مُجَاوَزَةٌ رابِغ':Added, #1: 1	مُجَاوَزَةِ الدَّمِ
u'مُجَاوَزَةٌ سورٌ':Added, #1: 1	مُجَاوَزَةُ رَابِغٍ
u'مُجَاوَزَةٌ سورٌ':Added, #1: 1	مُجَاوَزَةُ السُّورِ
u'مُجَاوَزَةٌ سورٌ':Added, #1: 1	مُجَاوَزَةِ السُّورِ
u'مُجَاوَزَةٌ ظِلٌّ':Added, #1: 1	مُجَاوَزَةِ السُّورَيْنِ
u'مُجَاوَزَةٌ عَادَةٌ':Added, #1: 1	مُجَاوَزَةِ الظِّلِّ
u'مُجَاوَزَةٌ عَدَدٌ':Added, #1: 1	مُجَاوَزَةُ الْعَادَةِ
u'مُجَاوَزَةٌ عَدَدٌ':Added, #1: 1	مُجَاوَزَةَ عَدَدِهِ
u'مُجَاوَزَةٌ عَشْرٌ':Added, #1: 1	مُجَاوَزَةُ عَدَدِهِ
u'مُجَاوَزَةٌ عَشْرٌ':Added, #1: 1	مُجَاوَزَةِ عَشْرٍ
u'مُجَاوَزَةٌ عُمْرَانٌ':Added, #1: 1	مُجَاوَزَةِ عَشْرِ
u'مُجَاوَزَةٌ عُمْرَانٌ':Added, #1: 1	مُجَاوَزَةُ الْعُمْرَانِ
u'مُجَاوَزَةٌ فَرْسَخٌ':Added, #2: 2	مُجَاوَزَةُ عُمْرَانِ
u'مُجَاوَزَةٌ فِنَاءٌ':Added, #1: 1	مُجَاوَزَةِ الْفَرْسَخِ
u'مُجَاوَزَةٌ فِنَاءٌ':Added, #1: 1	مُجَاوَزَةَ الْفِنَاءِ
u'مُجَاوَزَةٌ قَرْيَةٌ':Added, #2: 2	مُجَاوَزَةُ الْفِنَاءِ
u'مُجَاوَزَةٌ مَحَلَّةٌ':Added, #1: 1	مُجَاوَزَةِ الْقَرْيَةِ
u'مُجَاوَزَةٌ مُدَّةٌ':Added, #1: 1	مُجَاوَزَةُ مَحَلَّةٍ
u'مُجَاوَزَةٌ مَزَارِعُ':Added, #1: 1	مُجَاوَزَةِ مُدَّتِهِ
u'مُجَاوَزَةٌ مَسَافَةٌ':Added, #1: 1	مُجَاوَزَةُ الْمَزَارِعِ
u'مُجَاوَزَةٌ مَسَافَةٌ':Added, #1: 1	مُجَاوَزَةَ الْمَسَافَةِ
u'مُجَاوَزَةٌ مِيقَاتٌ':Added, #1: 1	مُجَاوَزَةِ الْمَسَافَةِ
u'مُجَاوَزَةٌ مِيقَاتٌ':Added, #12: 12	مُجَاوَزَةِ الْمِيقَاتِ
u'مُجَاوَزَةٌ مِيقَاتٌ':Added, #1: 1	مُجَاوَزَةَ الْمِيقَاتِ
u'مُجَاوَزَةٌ مِيقَاتٌ':Added, #1: 1	مُجَاوَزَةُ مِيقَاتِهِ
u'مُجَاوَزَةٌ مِيقَاتٌ':Added, #2: 2	مُجَاوَزَةَ مِيقَاتٍ
u'مُجَاوَزَةٌ مِيقَاتٌ':Added, #2: 2	مُجَاوَزَةَ مِيقَاتَيْنِ
u'مُجَاوَزَةٌ وَقْتٌ':Added, #7: 7	مُجَاوَزَةُ الْمِيقَاتِ
u'مَجْدٌ أئِمَّةٌ':Added, #2: 2	مُجَاوَزَةِ الْوَقْتِ
u'مَجْدٌ أئِمَّةٌ':Added, #3: 3	مَجْدِ الْأَئِمَّةِ
u'مَجْدٌ بَيْتٌ':Added, #6: 6	مَجْدُ الْأَئِمَّةِ
u'مَجْدٌ حَيَاةٌ':Added, #1: 1	مَجْدِ بَيْتٍ
u'مَجْدٌ حَيَاةٌ':Added, #1: 1	مَجْدَ الْحَيَاةِ
u'مَجْدٌ دَيْنٌ':Added, #1: 1	مَجْدُ الْحَيَاةِ
u'مَجْدٌ دِينٌ':Added, #1: 1	مَجْدُ الدَّيْنِ
u'مَجْدٌ دِينٌ':Added, #2: 2	مَجْدَ الدِّينِ
u'مَجْدٌ دِينٌ':Added, #3: 3	مَجْدِ الدِّينِ
u'مَجَّ رَسُولٌ':Predicate, #65: 65	مَجْدُ الدِّينِ
u'مَجَّ رَسُولٌ':Subject, #1: 1	مَجَّ رَسُولَ
u'مَجَّ لبن':Predicate, #1: 1	مَجَّ رَسُولُ
u'مَجَّ لَبَنٌ':Predicate, #1: 1	مَجَّ اللَّبَنَ
u'مَجِيءٌ أُجْرَةٌ':Added, #1: 1	مَجَّ اللَّبَنَ
u'مَجِيءٌ أَجَلٌ':Added, #1: 1	مَجِيءِ أُجْرَةِ
u'مَجِيءٌ أَجَلٌ':Added, #1: 1	مَجِيءَ الْأَجَلِ
u'مَجِيءٌ اِسْمٌ':Added, #1: 1	مَجِيءِ الْأَجَلِ
u'مَجِيءٌ أَسْماءٌ':Added, #1: 1	مَجِيءَ اسْمِ
u'مَجِيءٌ الْمَرْأَةُ':Added, #1: 1	مَجِيءَ أَسْمَاءِ
u'مَجِيءٌ إمَامٌ':Added, #2: 2	مَجِيءِ الْمَرْأَةِ
u'مَجِيءٌ إمَامٌ':Added, #1: 1	مَجِيءَ الْإِمَامِ
u'مَجِيءٌ أوَانٌ':Added, #1: 1	مَجِيءِ إمَامِهِ
u'مَجِيءٌ أوَانٌ':Added, #1: 1	مَجِيءِ أَوَانِ
u'مَجِيءٌ أَوْجُهٌ':Added, #1: 1	مَجِيءِ أَوَانِهِ
u'مَجِيءٌ أَوَّلُ':Added, #1: 1	مَجِيءُ الْأَوْجُهِ
u'مَجِيءٌ باء':Added, #1: 1	مَجِيءِ أَوَّلِ
u'مَجِيءٌ بَأسٌ':Added, #2: 2	مَجِيءَ الْبَاءِ
u'مَجِيءٌ بَيَانٌ':Added, #1: 1	مَجِيءُ الْبَأْسِ
u'مَجِيءٌ تَفْصِيلٌ':Added, #1: 1	مَجِيءِ الْبَيَانِ
u'مَجِيءٌ ثَانِي':Added, #1: 1	مَجِيءِ التَّفْصِيلِ
u'مَجِيءٌ ثَانِيَةٌ':Added, #1: 1	مَجِيءَ الثَّانِيَةِ
u'مَجِيءٌ ثَلاثَةٌ':Added, #1: 1	مَجِيءَ الثَّانِيَةِ
u'مَجِيءٌ ثَمَرَةٌ':Added, #3: 3	مَجِيءِ ثَلَاثَةِ
u'مَجِيءٌ جُمْلَةٌ':Added, #1: 1	مَجِيءُ الثَّمَرَةِ
u'مَجِيءٌ حالٌ':Added, #1: 1	مَجِيءَ الْجُمْلَةِ
u'مَجِيءٌ خِلاَفٌ':Added, #2: 2	مَجِيءِ الْحَالِ
u'مَجِيءٌ خِلاَفٌ':Added, #1: 1	مَجِيءِ الْخِلَافِ
u'مَجِيءٌ خِلاَفٌ':Added, #1: 1	مَجِيءُ خِلَافٍ
u'مَجِيءٌ خِلاَفٌ':Added, #1: 1	مَجِيءُ خِلَافِ
u'مَجِيءٌ خِلاَفٌ':Added, #2: 2	مَجِيءُ الْخِلَافِ
u'مَجِيءٌ دَمٌ':Added, #2: 2	مَجِيءَ خِلَافٍ
u'مَجِيءٌ رابع':Added, #1: 1	مَجِيءَ الدَّمِ
u'مَجِيءٌ رَابِعٌ':Added, #1: 1	مَجِيءِ الرَّابِعِ
u'مَجِيءٌ رابع':Added, #1: 1	مَجِيءِ الرَّابِعِ
u'مَجِيءٌ رَابِعٌ':Added, #2: 2	مَجِيءَ رَابِعٍ
u'مَجِيءٌ رَأْسٌ':Added, #2: 2	مَجِيءَ رَابِعٍ
u'مَجِيءٌ رُسُلٌ':Added, #5: 5	مَجِيءِ رَأْسِ
u'مَجِيءٌ رَسُولٌ':Added, #1: 1	مَجِيءُ الرُّسُلِ
u'مَجِيءٌ زَمَنٌ':Added, #4: 4	مَجِيءُ الرَّسُولِ
u'مَجِيءٌ زَيْدٌ':Added, #2: 2	مَجِيءِ زَمَنِ
u'مَجِيءٌ شَاهِدٌ':Added, #2: 2	مَجِيءِ زَيْدٍ
u'مَجِيءٌ شَرْعٌ':Added, #1: 1	مَجِيءَ الشَّاهِدِ
u'مَجِيءٌ شَهَادَةٌ':Added, #2: 2	مَجِيءِ الشَّرْعِ
u'مَجِيءٌ شَهْرٌ':Added, #2: 2	مَجِيءَ الشَّهَادَةِ
u'مَجِيءٌ شَهْرٌ':Added, #1: 1	مَجِيءَ الشَّهْرِ
u'مَجِيءٌ شَهْرٌ':Added, #1: 1	مَجِيءِ شَهْرِ
u'مَجِيءٌ شُهُودٌ':Added, #4: 4	مَجِيءِ الشَّهْرِ
u'مَجِيءٌ صَاحِبٌ':Added, #2: 2	مَجِيءَ الشُّهُودِ
u'مَجِيءٌ عَصِيرٌ':Added, #1: 1	مَجِيءَ صَاحِبِهِ
u'مَجِيءٌ عَفْوٌ':Added, #1: 1	مَجِيءَ الْعَصِيرِ
u'مَجِيءٌ عِلَّةٌ':Added, #1: 1	مَجِيءَ الْعَفْوِ
u'مَجِيءٌ عَمْرٌ':Added, #1: 1	مَجِيءِ عِلَّتِهِ
u'مَجِيءٌ غَائِبٌ':Added, #1: 1	مَجِيءِ عَمْرٍ
u'مَجِيءٌ غَدٌ':Added, #1: 1	مَجِيءِ الْغَائِبِ
u'مَجِيءٌ غَدٌ':Added, #2: 2	مَجِيءَ الْغَدِ
u'مَجِيءٌ غَدٌ':Added, #32: 32	مَجِيءِ الْغَدِ
u'مَجِيءٌ غَلَّةٌ':Added, #3: 3	مَجِيءُ الْغَدِ
u'مَجِيءٌ غَيْثٌ':Added, #16: 16	مَجِيءِ الْغَلَّةِ
u'مَجِيءٌ فقراء':Added, #1: 1	مَجِيءِ الْغَيْثِ
u'مَجِيءٌ فِيلٌ':Added, #1: 1	مَجِيءُ الْفُقَرَاءِ
u'مَجِيءٌ قُبُورٌ':Added, #1: 1	مَجِيءِ الْفِيلِ
u'مَجِيءٌ قِرَاءةٌ':Added, #1: 1	مَجِيءَ قُبُورِ
u'مَجِيءٌ قول':Added, #1: 1	مَجِيءَ الْقِرَاءَاتِ
u'مَجِيءٌ قَوْلٌ':Added, #1: 1	مَجِيءَ قَوْلِهِ
u'مَجِيءٌ كِتَابٌ':Added, #1: 1	مَجِيءَ قَوْلِهِ
u'مَجِيءٌ مَاءٌ':Added, #1: 1	مَجِيءُ كِتَابِ
u'مَجِيءٌ مَاءٌ':Added, #1: 1	مَجِيءُ الْمَاءِ
u'مَجِيءٌ مَالٌ':Added, #3: 3	مَجِيءِ الْمَاءِ
u'مَجِيءٌ مثل':Added, #1: 1	مَجِيءِ مَالِهِ
u'مَجِيءٌ مِثْلٌ':Added, #1: 1	مَجِيءُ مِثْلِهِ
u'مَجِيءٌ مَجْمُوعٌ':Added, #1: 1	مَجِيءُ مِثْلِهِ
u'مَجِيءٌ مُسْتَحِقٌّ':Added, #1: 1	مَجِيءَ الْمَجْمُوعِ
u'مَجِيءٌ مَصْدَرٌ':Added, #1: 1	مَجِيءِ مُسْتَحِقِّهِ
u'مَجِيءٌ مَلَكٌ':Added, #1: 1	مَجِيءَ الْمَصْدَرِ
u'مَجِيءٌ مِلْكٌ':Added, #1: 1	مَجِيءُ الْمَلَكِ
u'مَجِيءٌ نَبِيٌّ':Added, #1: 1	مَجِيءِ مِلْكِهِ
u'مَجِيءٌ نَبِيٌّ':Added, #1: 1	مَجِيءُ النَّبِيِّ
u'مَجِيءٌ نعمة':Added, #2: 2	مَجِيءِ النَّبِيِّ
u'مَجِيءٌ نِعْمَةٌ':Added, #1: 1	مَجِيءَ النِّعْمَةِ
u'مَجِيءٌ نفر':Added, #1: 1	مَجِيءَ النِّعْمَةِ
u'مَجِيءٌ نَفَرٌ':Added, #1: 1	مَجِيءَ النّفَرِ
u'مَجِيءٌ نَفِيرٌ':Added, #1: 1	مَجِيءَ النّفَرِ
u'مَجِيءٌ واحد':Added, #2: 2	مَجِيءِ النَّفِيرِ
u'مَجِيءٌ وَاحِدٌ':Added, #1: 1	مَجِيءِ وَاحِدٍ
u'مَجِيءٌ وَارِثٌ':Added, #1: 1	مَجِيءِ وَاحِدٍ
u'مَجِيءٌ وَجْهٌ':Added, #1: 1	مَجِيءَ وَارِثٍ
u'مَجِيءٌ وَقْتٌ':Added, #1: 1	مَجِيءَ وَجْهٍ
u'مَجِيءٌ وَقْتٌ':Added, #1: 1	مَجِيءَ الْوَقْتِ
u'مَجِيءٌ وَقْتٌ':Added, #2: 2	مَجِيءِ وَقْتِهِ
u'مَجِيءٌ وَقْتٌ':Added, #6: 6	مَجِيءِ وَقْتِ
u'مَجِيءٌ يَوْمٌ':Added, #9: 9	مَجِيءِ الْوَقْتِ
u'مَجِيءٌ يَوْمٌ':Added, #1: 1	مَجِيءِ يَوْمِ
u'مَحَا اِسْمٌ':Predicate, #2: 2	مَجِيءِ يَوْمٍ
u'مُحَابَاةٌ بَائِعٌ':Added, #1: 1	مَحَا اسْمَ
u'مُحَابَاةٌ بَيْعٌ':Added, #2: 2	مُحَابَاةُ الْبَائِعِ
u'مُحَابَاةٌ زَوْجَةٌ':Added, #1: 1	مُحَابَاةِ بَيْعٍ
u'مُحَابَاةٌ صَحِيحٌ':Added, #1: 1	مُحَابَاة الزَّوْجَةِ
u'مُحَابَاةٌ عَبْدٌ':Added, #1: 1	مُحَابَاةِ الصَّحِيحِ
u'مُحَابَاةٌ علماء':Added, #1: 1	مُحَابَاةُ الْعَبْدِ
u'مُحَابَاةٌ عُلَمَاءُ':Added, #1: 1	مُحَابَاةِ الْعُلَمَاءِ
u'مُحَابَاةٌ نَفْسٌ':Added, #1: 1	مُحَابَاةِ الْعُلَمَاءِ
u'مُحَاجَّةٌ قَوْمٌ':Added, #1: 1	مُحَابَاةَ النَّفْسِ
u'مَحَا حَوائِجُ':Predicate, #1: 1	مُحَاجَّةِ قَوْمِهِ
u'مُحَادَثَةٌ إِخْوَانٌ':Added, #1: 1	مَحَا الْحَوَائِجَ
u'مُحَادَثَةٌ رَجُلٌ':Added, #2: 2	مُحَادَثَةُ الْإِخْوَانِ
u'مُحَادَثَةٌ شَابٌّ':Added, #1: 1	مُحَادَثَةِ الرَّجُلِ
u'مُحَاذَاةٌ إِبْهَامٌ':Added, #1: 1	مُحَادَثَةَ الشَّابَّةِ
u'مُحَاذَاةٌ أَعْضَاءٌ':Added, #1: 1	مُحَاذَاةِ الْإِبْهَامَيْنِ
u'مُحَاذَاةٌ الْمَرْأَةُ':Added, #2: 2	مُحَاذَاةِ أَعْضَاءِ
u'مُحَاذَاةٌ الْمَرْأَةُ':Added, #2: 2	مُحَاذَاةَ الْمَرْأَةِ
u'مُحَاذَاةٌ الْمَرْأَةُ':Added, #3: 3	مُحَاذَاةُ الْمَرْأَةِ
u'مُحَاذَاةٌ اِمْرَأَةٌ':Added, #3: 3	مُحَاذَاةِ الْمَرْأَةِ
u'مُحَاذَاةٌ أَمْرَد':Added, #1: 1	مُحَاذَاةِ امْرَأَةٍ
u'مُحَاذَاةٌ أَمْرَد':Added, #1: 1	مُحَاذَاةَ الْأَمْرَدِ
u'مُحَاذَاةٌ أَوَّلُ':Added, #1: 1	مُحَاذَاةُ الْأَمْرَدِ
u'مُحَاذَاةٌ بَيْتٌ':Added, #1: 1	مُحَاذَاةِ الْأَوَّلِ
u'مُحَاذَاةٌ حَجَرٌ':Added, #1: 1	مُحَاذَاةُ بَيْتِ
u'مُحَاذَاةٌ رَجُلٌ':Added, #2: 2	مُحَاذَاةِ الْحَجَرِ
u'مُحَاذَاةٌ رَجُلٌ':Added, #1: 1	مُحَاذَاةَ الرَّجُلِ
u'مُحَاذَاةٌ رُكْنٌ':Added, #1: 1	مُحَاذَاةُ الرَّجُلِ
u'مُحَاذَاةٌ رُكْن':Added, #1: 1	مُحَاذَاةُ الرُّكْنِ
u'مُحَاذَاةٌ رُكْنٌ':Added, #1: 1	مُحَاذَاةُ الرُّكْنِ
u'مُحَاذَاةٌ رُكْن':Added, #1: 1	مُحَاذَاةِ الرُّكْنَيْنِ
u'مُحَاذَاةٌ سَائِرٌ':Added, #1: 1	مُحَاذَاةِ الرُّكْنَيْنِ
u'مُحَاذَاةٌ صَفٌّ':Added, #1: 1	مُحَاذَاةِ سَائِرِ
u'مُحَاذَاةٌ عَجِيزَةٌ':Added, #1: 1	مُحَاذَاةِ الصَّفِّ
u'مُحَاذَاةٌ غير':Added, #1: 1	مُحَاذَاةِ الْعَجِيزَةِ
u'مُحَاذَاةٌ غَيْرٌ':Added, #1: 1	مُحَاذَاةِ غَيْرِ
u'مُحَاذَاةٌ غير':Added, #1: 1	مُحَاذَاةِ غَيْرِ
u'مُحَاذَاةٌ غَيْرٌ':Added, #2: 2	مُحَاذَاةَ غَيْرِ
u'مُحَاذَاةٌ قِبْلَةٌ':Added, #2: 2	مُحَاذَاةَ غَيْرِ
u'مُحَاذَاةٌ كعبة':Added, #1: 1	مُحَاذَاةَ الْقِبْلَةِ
u'مُحَاذَاةٌ كَعْبَةٌ':Added, #1: 1	مُحَاذَاةِ الْكَعْبَةِ
u'مُحَاذَاةٌ كَلْبٌ':Added, #1: 1	مُحَاذَاةِ الْكَعْبَةِ
u'مُحَاذَاةٌ مَنَاكِبُ':Added, #1: 1	مُحَاذَاةِ الْكَلْبِ
u'مُحَاذَاةٌ نَاسٌ':Added, #1: 1	مُحَاذَاةُ الْمَنَاكِبِ
u'مُحَاذَاةٌ هَوَاءٌ':Added, #1: 1	مُحَاذَاةِ النَّاسِ
u'مُحَاذَاةٌ يَمِينٌ':Added, #1: 1	مُحَاذَاةِ هَوَاءِ
u'مُحَاذَرَةٌ ضراب':Added, #1: 1	مُحَاذَاةِ الْيَمِينِ
u'مَحَا ذكر':Predicate, #1: 1	مُحَاذَرَةَ الضّرَابِ
u'مَحَا ذِكْرٌ':Predicate, #1: 1	مَحَا ذِكْرَ
u'مُحَارَبَةٌ أهْلٌ':Added, #1: 1	مَحَا ذِكْرَ
u'مُحَارَبَةٌ بَعْضٌ':Added, #1: 1	مُحَارَبَةِ أَهْلِ
u'مُحَارَبَةٌ رَسُولٌ':Added, #1: 1	مُحَارَبَةِ بَعْضِ
u'مُحَارَبَةٌ رُومٌ':Added, #1: 1	مُحَارَبَةُ رَسُولِ
u'مُحَاسَبَةٌ رَبُّ':Added, #1: 1	مُحَارَبَةِ الرّومِ
u'مُحَاسَبَةٌ عُمَّالٌ':Added, #1: 1	مُحَاسَبَةَ الرَّبِّ
u'مَحَا سَيْفٌ':Subject, #2: 2	مُحَاسَبَةُ الْعُمَّالِ
u'مُحَاصَرٌ أهْلٌ':Added, #1: 1	مَحَا السّيْفُ
u'مُحَاصَرَةٌ أهْلٌ':Added, #1: 1	مُحَاصَرَةِ أَهْلِ
u'مُحَاصَرَةٌ قلاع':Added, #1: 1	مُحَاصَرَةِ أَهْلِ
u'مُحَاصَرَةٌ قِلاَعٌ':Added, #1: 1	مُحَاصَرَةِ الْقِلَاعِ
u'مُحَاصَرٌ قلاع':Added, #1: 1	مُحَاصَرَةِ الْقِلَاعِ
u'مُحَاصَرٌ قِلاَعٌ':Added, #1: 1	مُحَاصَرَةِ الْقِلَاعِ
u'مَحَا طَلاَقٌ':Predicate, #1: 1	مُحَاصَرَةِ الْقِلَاعِ
u'مُحَافَظَةٌ أَرْبَعُ':Added, #2: 2	مَحَا الطَّلَاقَ
u'مُحَافَظَةٌ جَمَاعَةٌ':Added, #1: 1	مُحَافَظَةِ الْأَرْبَعِ
u'مُحَافَظَةٌ صَلَوَاتٌ':Added, #1: 1	مُحَافَظَةِ الْجَمَاعَةِ
u'مُحَاكَاةٌ نَاسٌ':Added, #1: 1	مُحَافَظَةِ الصَّلَوَاتِ
u'مَحَا كِتَابَةٌ':Predicate, #2: 2	مُحَاكَاةُ النَّاسِ
u'مَحَا مَعَارِفُ':Predicate, #1: 1	مَحَا كِتَابَةَ
u'مُحَاوَرَةٌ الْمَرْأَةُ':Added, #1: 1	مَحَا مَعَارِفَ
u'مُحَاوَرَةٌ خُلَفَاءُ':Added, #1: 1	مُحَاوَرَةَ الْمَرْأَةِ
u'مُحَاوَلَةٌ أَمْرٌ':Added, #1: 1	مُحَاوَرَةِ الْخُلَفَاءِ
u'مُحَاوَلَةٌ تَعْمِيمٌ':Added, #1: 1	مُحَاوَلَةِ أَمْرِهِ
u'مُحَاوَلَةٌ جمع':Added, #1: 1	مُحَاوَلَةِ التَّعْمِيمِ
u'مُحَاوَلَةٌ جَمْعٌ':Added, #1: 1	مُحَاوَلَةُ الْجَمْعِ
u'مُحَاوَلَةٌ جَمْعٌ':Added, #1: 1	مُحَاوَلَةُ الْجَمْعِ
u'مُحَاوَلَةٌ شَيْءٌ':Added, #1: 1	مُحَاوَلَةُ جَمْعٍ
u'مُحَاوَلَةٌ طلب':Added, #1: 1	مُحَاوَلَةِ شَيْءٍ
u'مُحَاوَلَةٌ طَلَبٌ':Added, #1: 1	مُحَاوَلَةُ طَلَبِ
u'مُحَاوَلَةٌ مَرَضٌ':Added, #1: 1	مُحَاوَلَةُ طَلَبِ
u'مُحَاوَلَةٌ مُعَارَضَةٌ':Added, #2: 2	مُحَاوَلَةُ الْمَرَضِ
u'مُحَاوَلَةٌ وُضُوءٌ':Added, #1: 1	مُحَاوَلَةُ مُعَارَضَةِ
u'مَحَبَّةٌ أَثْمانٌ':Added, #1: 1	مُحَاوَلَةِ الْوُضُوءِ
u'مَحَبَّةٌ إِسَاءةٌ':Added, #1: 1	مَحَبَّةَ الأَثْمَانِ
u'مَحَبَّةٌ أكل':Added, #1: 1	مَحَبَّةَ إسَاءَةِ
u'مَحَبَّةٌ أَكْلٌ':Added, #1: 1	مَحَبَّةُ الْأَكْلِ
u'مَحَبَّةٌ أُمٌّ':Added, #1: 1	مَحَبَّةُ الْأَكْلِ
u'مَحَبَّةٌ أَمْرٌ':Added, #1: 1	مَحَبَّةِ الْأُمِّ
u'مَحَبَّةٌ إِنْسانٌ':Added, #1: 1	مَحَبَّةِ الْأَمْرِ
u'مَحَبَّةٌ تُجَّارٌ':Added, #1: 1	مَحَبَّةُ الْإِنْسَانِ
u'مَحَبَّةٌ تَشْنِيعٌ':Added, #1: 1	مَحَبَّةَ التُّجَّارِ
u'مَحَبَّةٌ تَعْظِيمٌ':Added, #1: 1	مَحَبَّةَ التَّشْنِيعِ
u'مَحَبَّةٌ حِمَايَةٌ':Added, #1: 1	مَحَبَّةَ التَّعْظِيمِ
u'مَحَبَّةٌ دِينٌ':Added, #1: 1	مَحَبَّةُ حِمَايَةِ
u'مَحَبَّةٌ رَجُلٌ':Added, #1: 1	مَحَبَّةُ الدِّينِ
u'مَحَبَّةٌ رَسُولٌ':Added, #1: 1	مَحَبَّةِ الرَّجُلِ
u'مَحَبَّةٌ رُؤْيَةٌ':Added, #1: 1	مَحَبَّةِ الرَّسُولِ
u'مَحَبَّةٌ زَوالٌ':Added, #1: 1	مَحَبَّةُ رُؤْيَةِ
u'مَحَبَّةٌ شافِعِيّ':Added, #1: 1	مَحَبَّةُ زَوَالِ
u'مَحَبَّةٌ ظلمة':Added, #1: 1	مَحَبَّةِ الشَّافِعِيِّ
u'مَحَبَّةٌ عَذَابٌ':Added, #1: 1	مَحَبَّةُ الظَّلَمَةِ
u'مَحَبَّةٌ عَرَبٌ':Added, #1: 1	مَحَبَّةِ الْعَذَابِ
u'مَحَبَّةٌ فَاسِقٌ':Added, #1: 1	مَحَبَّةِ الْعَرَبِ
u'مَحَبَّةٌ فِسْقٌ':Added, #1: 1	مَحَبَّةِ الْفَاسِقِ
u'مَحَبَّةٌ فلان':Added, #1: 1	مَحَبَّةَ الْفِسْقِ
u'مَحَبَّةٌ قيام':Added, #1: 1	مَحَبَّةِ الشَّافِعِيِّ
u'مَحَبَّةٌ قِيَامٌ':Added, #2: 2	مَحَبَّةُ الْقِيَامِ
u'مَحَبَّةٌ مُبتدَعٌ':Added, #2: 2	مَحَبَّةُ الْقِيَامِ
u'مَحَبَّةٌ مَذْهَبٌ':Added, #1: 1	مَحَبَّةِ الْمُبْتَدَعِ
u'مَحَبَّةٌ مُعَامَلَةٌ':Added, #1: 1	مَحَبَّةِ الْمَذْهَبِ
u'مَحَبَّةٌ نَاسٌ':Added, #1: 1	مَحَبَّةَ الْمُعَامَلَةِ
u'مَحَبَّةٌ نَفْسٌ':Added, #1: 1	مَحَبَّةَ النَّاسِ
u'مَحَبَّةٌ نَفْسٌ':Added, #1: 1	مَحَبَّةُ النَّفْسِ
u'مَحَبَّةٌ نُفُوسٌ':Added, #1: 1	مَحَبَّةِ نَفْسِهِ
u'مَحْضٌ إِحْرَامٌ':Added, #1: 1	مَحَبَّةَ النُّفُوسِ
u'مَحْضٌ إِخْبَارٌ':Added, #1: 1	مَحْضِ الْإِحْرَامِ
u'مَحْضٌ إِخْوَةٌ':Added, #3: 3	مَحْضُ إخْبَارٍ
u'مَحْضٌ اِدِّعَاءٌ':Added, #2: 2	مَحْضُ إخْوَةٍ
u'مَحْضٌ إِرْسَالٌ':Added, #1: 1	مَحْضُ ادِّعَاءٍ
u'مَحْضٌ اِسْتِقْبالٌ':Added, #1: 1	مَحْضَ الْإِرْسَالِ
u'مَحْضٌ إِسْقاطٌ':Added, #3: 3	مَحْضُ اسْتِقْبَالٍ
u'مَحْضٌ إِسْقاطٌ':Added, #1: 1	مَحْضَ إسْقَاطٍ
u'مَحْضٌ إِشْكالٌ':Added, #1: 1	مَحْضُ إسْقَاطٍ
u'مَحْضٌ اِصْطِلاحٌ':Added, #1: 1	مَحْضِ الْإِشْكَالِ
u'مَحْضٌ اِفْتِداء':Added, #1: 1	مَحْضُ اصْطِلَاحٍ
u'مَحْضٌ آلةٌ':Added, #1: 1	مَحْضُ افْتِدَاءٍ
u'مَحْضٌ اِلْتِزَامٌ':Added, #1: 1	مَحْضُ آلَةٍ
u'مَحْضٌ أمَانَةٌ':Added, #2: 2	مَحْضُ الْتِزَامٍ
u'مَحْضٌ إِنْشاءٌ':Added, #2: 2	مَحْضَ أَمَانَةٍ
u'مَحْضٌ إيمَانٌ':Added, #1: 1	مَحْضُ إنْشَاءٍ
u'مَحْضٌ بَيْعٌ':Added, #2: 2	مَحْضُ الْإِيمَانِ
u'مَحْضٌ تَأْخِيرٌ':Added, #1: 1	مَحْضُ الْبَيْعِ
u'مَحْضٌ تَبَرُّعٌ':Added, #1: 1	مَحْضُ تَأْخِيرٍ
u'مَحْضٌ تَبَرُّعٌ':Added, #1: 1	مَحْضِ التَّبَرُّعِ
u'مَحْضٌ تَحَكُّمٌ':Added, #3: 3	مَحْضُ تَبَرُّعٍ
u'مَحْضٌ تَخْسِيرٌ':Added, #1: 1	مَحْضُ تَحَكُّمٍ
u'مَحْضٌ تَخْصِيصٌ':Added, #1: 1	مَحْضُ تَخْسِيرٍ
u'مَحْضٌ تَرْكٌ':Added, #1: 1	مَحْضُ تَخْصِيصِ
u'مَحْضٌ تَشَبُّهٌ':Added, #1: 1	مَحْضُ تَرْكٍ
u'مَحْضٌ تَعَبُّدٌ':Added, #2: 2	مَحْضُ تَشَبُّهٍ
u'مَحْضٌ تَعْرِيفٌ':Added, #5: 5	مَحْضُ تَعَبُّدٍ
u'مَحْضٌ تَعَصُّبٌ':Added, #1: 1	مَحْضُ التَّعْرِيفِ
u'مَحْضٌ تَعْلِيقٌ':Added, #1: 1	مَحْضُ تَعَصُّبٍ
u'مَحْضٌ تَعْلِيقٌ':Added, #2: 2	مَحْضَ تَعْلِيقٍ
u'مَحْضٌ تَعْلِيقٌ':Added, #3: 3	مَحْضِ التَّعْلِيقِ
u'مَحْضٌ تَعَنُّت':Added, #5: 5	مَحْضُ تَعْلِيقٍ
u'مَحْضٌ تَغَلُّبٌ':Added, #1: 1	مَحْضُ تَعَنُّتٍ
u'مَحْضٌ تَفْرِيطٌ':Added, #1: 1	مَحْضَ تَغَلُّبٍ
u'مَحْضٌ تَقْريرٌ':Added, #2: 2	مَحْضُ تَفْرِيطٍ
u'مَحْضٌ تَقْليدٌ':Added, #1: 1	مَحْضُ تَقْرِيرٍ
u'مَحْضٌ تَقْليدٌ':Added, #1: 1	مَحْضَ التَّقْلِيدِ
u'مَحْضٌ تَقْليد':Added, #1: 1	مَحْضُ التَّقْلِيدِ
u'مَحْضٌ تَقْليد':Added, #1: 1	مَحْضَ التَّقْلِيدِ
u'مَحْضٌ تَكْرارٌ':Added, #1: 1	مَحْضُ التَّقْلِيدِ
u'مَحْضٌ تَكْليفٌ':Added, #12: 12	مَحْضُ تَكْرَارٍ
u'مَحْضٌ تَمْلِيك':Added, #1: 1	مَحْضُ التَّكْلِيفِ
u'مَحْضٌ تَمْلِيكٌ':Added, #1: 1	مَحْضَ التَّمْلِيكِ
u'مَحْضٌ تَمْلِيكٌ':Added, #1: 1	مَحْضَ تَمْلِيكٍ
u'مَحْضٌ تَوْكِيلٌ':Added, #1: 1	مَحْضُ تَمْلِيكٍ
u'مَحْضٌ جَبْرٌ':Added, #1: 1	مَحْضُ تَوْكِيلٍ
u'مَحْضٌ جِعال':Added, #1: 1	مَحْضِ الْجَبْرِ
u'مَحْضٌ جِلْدٌ':Added, #1: 1	مَحْضُ جِعَالَةٍ
u'مَحْضٌ جهاد':Added, #1: 1	مَحْضُ جِلْدٍ
u'مَحْضٌ جِهَادٌ':Added, #1: 1	مَحْضَ الْجِهَادِ
u'مَحْضٌ حُدودٌ':Added, #1: 1	مَحْضَ الْجِهَادِ
u'مَحْضٌ حَقٌّ':Added, #2: 2	مَحْضِ حُدُودِ
u'مَحْضٌ حَقٌّ':Added, #1: 1	مَحْضُ حَقٍّ
u'مَحْضٌ حَقٌّ':Added, #20: 20	مَحْضُ حَقِّ
u'مَحْضٌ حَقٌّ':Added, #2: 2	مَحْضِ الْحَقِّ
u'مَحْضٌ حَقٌّ':Added, #3: 3	مَحْضِ حَقِّ
u'مَحْضٌ حُقوقٌ':Added, #4: 4	مَحْضُ حَقِّهِ
u'مَحْضٌ حُقُوقٌ':Added, #1: 1	مَحْضِ حُقُوقِ
u'مَحْضٌ خِلاَفٌ':Added, #1: 1	مَحْضِ حُقُوقِ
u'مَحْضٌ ذُكورٌ':Added, #1: 1	مَحْضُ الْخِلَافِ
u'مَحْضٌ ذَهَبٌ':Added, #1: 1	مَحْضِ الذُّكُورِ
u'مَحْضٌ رِبْحٌ':Added, #1: 1	مَحْضِ الذَّهَبِ
u'مَحْضٌ رِجَالٌ':Added, #1: 1	مَحْضُ رِبْحٍ
u'مَحْضٌ رحمة':Added, #1: 1	مَحْضُ الرِّجَالِ
u'مَحْضٌ رَحْمَةٌ':Added, #1: 1	مَحْضُ الرَّحْمَةِ
u'مَحْضٌ رِوايَةٌ':Added, #1: 1	مَحْضُ الرَّحْمَةِ
u'مَحْضٌ زِيادَةٌ':Added, #1: 1	مَحْضُ رِوَايَةٍ
u'مَحْضٌ زِيادَةٌ':Added, #1: 1	مَحْضَ زِيَادَةٍ
u'مَحْضٌ زِيادَةٌ':Added, #2: 2	مَحْضُ زِيَادَةٍ
u'مَحْضٌ زِينَةٌ':Added, #3: 3	مَحْضَ الزِّيَادَةِ
u'مَحْضٌ سُجُودٌ':Added, #1: 1	مَحْضُ زِينَةٍ
u'مَحْضٌ سَفِيرٌ':Added, #1: 1	مَحْضَ سُجُودِهِ
u'مَحْضٌ سُنَّةٌ':Added, #1: 1	مَحْضُ سَفِيرٍ
u'مَحْضٌ سُنَّةٌ':Added, #1: 1	مَحْضُ السُّنَّةِ
u'مَحْضٌ شَرْطٌ':Added, #1: 1	مَحْضِ السُّنَّةِ
u'مَحْضٌ شركة':Added, #3: 3	مَحْضُ الشَّرْطِ
u'مَحْضٌ شَرِكَةٌ':Added, #1: 1	مَحْضُ شَرِكَةٍ
u'مَحْضٌ شَكٌّ':Added, #1: 1	مَحْضُ شَرِكَةٍ
u'مَحْضٌ شَهَادَةٌ':Added, #1: 1	مَحْضُ الشَّكِّ
u'مَحْضٌ صِدْقٌ':Added, #2: 2	مَحْضُ شَهَادَةٍ
u'مَحْضٌ صِدْقٌ':Added, #1: 1	مَحْضَ صِدْقٍ
u'مَحْضٌ صنع':Added, #1: 1	مَحْضُ صِدْقٍ
u'مَحْضٌ صُنْعٌ':Added, #1: 1	مَحْضُ صُنْعِ
u'مَحْضٌ ضَرَرٌ':Added, #1: 1	مَحْضُ صُنْعِ
u'مَحْضٌ ضَرِيبَةٌ':Added, #1: 1	مَحْضُ ضَرَرٍ
u'مَحْضٌ ضَلاَلَةٌ':Added, #2: 2	مَحْضِ الضّرِيبَةِ
u'مَحْضٌ ظُلْمٌ':Added, #1: 1	مَحْضُ ضَلَالَةٍ
u'مَحْضٌ عِبَادَةٌ':Added, #1: 1	مَحْضُ ظُلْمٍ
u'مَحْضٌ عِبَادَةٌ':Added, #1: 1	مَحْضَ عِبَادَةٍ
u'مَحْضٌ عِبَادَةٌ':Added, #1: 1	مَحْضُ عِبَادَةٍ
u'مَحْضٌ عَدْلٌ':Added, #2: 2	مَحْضُ الْعِبَادَةِ
u'مَحْضٌ عَرَبٌ':Added, #1: 1	مَحْضُ عَدْلٍ
u'مَحْضٌ عصبة':Added, #1: 1	مَحْضُ الْعَرَبِ
u'مَحْضٌ عَصَبَةٌ':Added, #1: 1	مَحْضَ عَصَبَةٍ
u'مَحْضٌ عَفْوٌ':Added, #1: 1	مَحْضَ عَصَبَةٍ
u'مَحْضٌ عُقُوبَةٌ':Added, #3: 3	مَحْضُ الْعَفْوِ
u'مَحْضٌ عَمْدٌ':Added, #1: 1	مَحْضُ عُقُوبَةٍ
u'مَحْضٌ عَمْدٌ':Added, #1: 1	مَحْضُ الْعَمْدِ
u'مَحْضٌ عناد':Added, #1: 1	مَحْضُ عَمْدٍ
u'مَحْضٌ عِنَادٌ':Added, #1: 1	مَحْضُ الْعِنَادِ
u'مَحْضٌ عناد':Added, #1: 1	مَحْضُ الْعِنَادِ
u'مَحْضٌ عِنَادٌ':Added, #1: 1	مَحْضُ عِنَادٍ
u'مَحْضٌ غَرَرٌ':Added, #1: 1	مَحْضُ عِنَادٍ
u'مَحْضٌ غُرْمٌ':Added, #2: 2	مَحْضُ غَرَرٍ
u'مَحْضٌ غير':Added, #1: 1	مَحْضُ غُرْمٍ
u'مَحْضٌ غَيْرٌ':Added, #2: 2	مَحْضَ غَيْرِ
u'مَحْضٌ فُرُوعٌ':Added, #2: 2	مَحْضَ غَيْرِ
u'مَحْضٌ فَضْلٌ':Added, #1: 1	مَحْضِ الْفُرُوعِ
u'مَحْضٌ فَضْلٌ':Added, #1: 1	مَحْضُ فَضْلٍ
u'مَحْضٌ فَضْلٌ':Added, #1: 1	مَحْضِ فَضْلِ
u'مَحْضٌ فِقْهٌ':Added, #1: 1	مَحْضِ فَضْلِهِ
u'مَحْضٌ قَابِلِيَّةٌ':Added, #1: 1	مَحْضِ الْفِقْهِ
u'مَحْضٌ قَدَرٌ':Added, #1: 1	مَحْضُ قَابِلِيَّةِ
u'مَحْضٌ قُرْآنٌ':Added, #1: 1	مَحْضُ قَدَرٍ
u'مَحْضٌ قُرْآنٌ':Added, #1: 1	مَحْضِ الْقُرْآنِ
u'مَحْضٌ قُرْبَةٌ':Added, #1: 1	مَحْضِ قُرْآنٍ
u'مَحْضٌ قُرْبَةٌ':Added, #1: 1	مَحْضَ الْقُرْبَةِ
u'مَحْضٌ قَصْدٌ':Added, #1: 1	مَحْضُ الْقُرْبَةِ
u'مَحْضٌ قيام':Added, #1: 1	مَحْضُ قَصْدِهِ
u'مَحْضٌ قِيَامٌ':Added, #5: 5	مَحْضِ الْقِيَامِ
u'مَحْضٌ كَرَمٌ':Added, #5: 5	مَحْضِ الْقِيَامِ
u'مَحْضٌ كَرْمٌ':Added, #1: 1	مَحْضُ الْكَرَمِ
u'مَحْضٌ مَاءٌ':Added, #1: 1	مَحْضُ كَرْمٍ
u'مَحْضٌ مَالٌ':Added, #1: 1	مَحْضِ الْمَاءِ
u'مَحْضٌ مُتَابَعٌ':Added, #1: 1	مَحْضُ مَالٍ
u'مَحْضٌ مُتَابَعَةٌ':Added, #2: 2	مَحْضُ مُتَابَعَةٍ
u'مَحْضٌ مُخَالَفَةٌ':Added, #2: 2	مَحْضُ مُتَابَعَةٍ
u'مَحْضٌ مَشْهُودٌ':Added, #1: 1	مَحْضُ مُخَالَفَةٍ
u'مَحْضٌ مَصْلَحَةٌ':Added, #1: 1	مَحْضُ الْمَشْهُودِ
u'مَحْضٌ مَضَرَّةٌ':Added, #1: 1	مَحْضُ مَصْلَحَةٍ
u'مَحْضٌ مُعاطاة':Added, #1: 1	مَحْضُ مَضَرَّةٍ
u'مَحْضٌ مَعْصِيَةٌ':Added, #1: 1	مَحْضُ الْمُعَاطَاةِ
u'مَحْضٌ مُقَابَلٌ':Added, #1: 1	مَحْضُ مَعْصِيَةٍ
u'مَحْضٌ مُقَابَلَةٌ':Added, #1: 1	مَحْضُ الْمُقَابَلَةِ
u'مَحْضٌ مِلْكٌ':Added, #1: 1	مَحْضُ الْمُقَابَلَةِ
u'مَحْضٌ مَنْدُوبٌ':Added, #1: 1	مَحْض مِلْكِهِ
u'مَحْضٌ مَنْفَعَةٌ':Added, #1: 1	مَحْضِ الْمَنْدُوبَاتِ
u'مَحْضٌ مَنْفَعَةٌ':Added, #1: 1	مَحْضِ الْمَنْفَعَةِ
u'مَحْضٌ مُوَاسَاةٌ':Added, #2: 2	مَحْضُ مَنْفَعَةٍ
u'مَحْضٌ نِساءٌ':Added, #1: 1	مَحْضُ مُوَاسَاةٍ
u'مَحْضٌ نِساءٌ':Added, #1: 1	مَحْضُ النِّسَاءِ
u'مَحْضٌ نُسُكٌ':Added, #1: 1	مَحْضِ نِسَاءٍ
u'مَحْضٌ نَصٌّ':Added, #1: 1	مَحْضُ نُسُكٍ
u'مَحْضٌ نعمة':Added, #1: 1	مَحْضَ النَّصِّ
u'مَحْضٌ نِعْمَةٌ':Added, #1: 1	مَحْضُ نِعْمَةٍ
u'مَحْضٌ نَفْعٌ':Added, #1: 1	مَحْضُ نِعْمَةٍ
u'مَحْضٌ نَفْعٌ':Added, #1: 1	مَحْضَ النَّفْعِ
u'مَحْضٌ نِيَّةٌ':Added, #1: 1	مَحْضُ نَفْعٍ
u'مَحْضٌ وِلاَيَةٌ':Added, #1: 1	مَحْضِ النِّيَّةِ
u'مَحَقَ إِسْلامٌ':Predicate, #1: 1	مَحْضُ وِلَايَةٍ
u'مَحَلِّيٌّ الْمَرْأَةُ':Added, #1: 1	مَحَقَ الْإِسْلَامَ
u'مَحَلِّيٌّ الْمَرْأَةُ':Added, #1: 1	مَحَلِّيَّةُ الْمَرْأَةِ
u'مَحَلِّيٌّ بِرٌّ':Added, #1: 1	مَحَلِّيَّةِ الْمَرْأَةِ
u'مَحَلِّيٌّ بَيْعٌ':Added, #1: 1	مَحَلِّيَّةُ الْبِرِّ
u'مَحَلِّيٌّ بَيْعٌ':Added, #3: 3	مَحَلِّيَّةُ الْبَيْعِ
u'مَحَلِّيَّةٌ الْمَرْأَةُ':Added, #4: 4	مَحَلِّيَّةِ الْبَيْعِ
u'مَحَلِّيَّةٌ الْمَرْأَةُ':Added, #1: 1	مَحَلِّيَّةُ الْمَرْأَةِ
u'مَحَلِّيَّةٌ بِرٌّ':Added, #1: 1	مَحَلِّيَّةِ الْمَرْأَةِ
u'مَحَلِّيَّةٌ بَيْعٌ':Added, #1: 1	مَحَلِّيَّةُ الْبِرِّ
u'مَحَلِّيَّةٌ بَيْعٌ':Added, #3: 3	مَحَلِّيَّةُ الْبَيْعِ
u'مَحَلِّيَّةٌ تَمَلُّك':Added, #4: 4	مَحَلِّيَّةِ الْبَيْعِ
u'مَحَلِّيَّةٌ تَمْلِيك':Added, #1: 1	مَحَلِّيَّةِ التَّمَلُّكِ
u'مَحَلِّيَّةٌ جَوَازٌ':Added, #1: 1	مَحَلِّيَّةِ التَّمْلِيكِ
u'مَحَلِّيَّةٌ رَدٌّ':Added, #1: 1	مَحَلِّيَّةَ جَوَازِ
u'مَحَلِّيَّةٌ طَلاَقٌ':Added, #1: 1	مَحَلِّيَّةِ الرَّدِّ
u'مَحَلِّيَّةٌ ظهار':Added, #1: 1	مَحَلِّيَّةِ الطَّلَاقِ
u'مَحَلِّيَّةٌ عتق':Added, #1: 1	مَحَلِّيَّةَ الظِّهَارِ
u'مَحَلِّيَّةٌ عِتْقٌ':Added, #1: 1	مَحَلِّيَّةِ الْعِتْقِ
u'مَحَلِّيَّةٌ فِعْلٌ':Added, #1: 1	مَحَلِّيَّةِ الْعِتْقِ
u'مَحَلِّيَّةٌ مَحَارِمُ':Added, #1: 1	مَحَلِّيَّةِ الْفِعْلِ
u'مَحَلِّيَّةٌ مِلْكٌ':Added, #1: 1	مَحَلِّيَّةِ الْمَحَارِمِ
u'مَحَلِّيَّةٌ نكاح':Added, #1: 1	مَحَلِّيَّةِ الْمِلْكِ
u'مَحَلِّيَّةٌ نِكَاحٌ':Added, #1: 1	مَحَلِّيَّةِ نِكَاحِ
u'مَحَلِّيَّةٌ نكاح':Added, #1: 1	مَحَلِّيَّةِ نِكَاحِ
u'مَحَلِّيَّةٌ نِكَاحٌ':Added, #2: 2	مَحَلِّيَّةَ النِّكَاحِ
u'مَحَلِّيَّةٌ نكاح':Added, #2: 2	مَحَلِّيَّةَ النِّكَاحِ
u'مَحَلِّيَّةٌ نِكَاحٌ':Added, #5: 5	مَحَلِّيَّةِ النِّكَاحِ
u'مَحَلِّيَّةٌ وُقُوعٌ':Added, #5: 5	مَحَلِّيَّةِ النِّكَاحِ
u'مَحَلِّيٌّ تَمَلُّك':Added, #1: 1	مَحَلِّيَّةِ وُقُوعِ
u'مَحَلِّيٌّ تَمْلِيك':Added, #1: 1	مَحَلِّيَّةِ التَّمَلُّكِ
u'مَحَلِّيٌّ جَوَازٌ':Added, #1: 1	مَحَلِّيَّةِ التَّمْلِيكِ
u'مَحَلِّيٌّ رَدٌّ':Added, #1: 1	مَحَلِّيَّةَ جَوَازِ
u'مَحَلِّيٌّ طَلاَقٌ':Added, #1: 1	مَحَلِّيَّةِ الرَّدِّ
u'مَحَلِّيٌّ ظهار':Added, #1: 1	مَحَلِّيَّةِ الطَّلَاقِ
u'مَحَلِّيٌّ عتق':Added, #1: 1	مَحَلِّيَّةَ الظِّهَارِ
u'مَحَلِّيٌّ عِتْقٌ':Added, #1: 1	مَحَلِّيَّةِ الْعِتْقِ
u'مَحَلِّيٌّ فِعْلٌ':Added, #1: 1	مَحَلِّيَّةِ الْعِتْقِ
u'مَحَلِّيٌّ مَحَارِمُ':Added, #1: 1	مَحَلِّيَّةِ الْفِعْلِ
u'مَحَلِّيٌّ مِلْكٌ':Added, #1: 1	مَحَلِّيَّةِ الْمَحَارِمِ
u'مَحَلِّيٌّ نكاح':Added, #1: 1	مَحَلِّيَّةِ الْمِلْكِ
u'مَحَلِّيٌّ نِكَاحٌ':Added, #1: 1	مَحَلِّيَّةِ نِكَاحِ
u'مَحَلِّيٌّ نكاح':Added, #1: 1	مَحَلِّيَّةِ نِكَاحِ
u'مَحَلِّيٌّ نِكَاحٌ':Added, #2: 2	مَحَلِّيَّةَ النِّكَاحِ
u'مَحَلِّيٌّ نكاح':Added, #2: 2	مَحَلِّيَّةَ النِّكَاحِ
u'مَحَلِّيٌّ نِكَاحٌ':Added, #5: 5	مَحَلِّيَّةِ النِّكَاحِ
u'مَحَلِّيٌّ وُقُوعٌ':Added, #5: 5	مَحَلِّيَّةِ النِّكَاحِ
u'مَحْوٌ اِسْمٌ':Added, #1: 1	مَحَلِّيَّةِ وُقُوعِ
u'مَحْوٌ بَعْضٌ':Added, #3: 3	مَحْوِ اسْمِ
u'مَحْوٌ كُتُبٌ':Added, #1: 1	مَحْوِ بَعْضِ
u'مَحَى اِسْمٌ':Predicate, #2: 2	مَحْوِ كُتُبِ
u'مَحَى حَوائِجُ':Predicate, #1: 1	مَحَى اسْمَ
u'مَحَى خُطُوطٌ':Predicate, #1: 1	مَحَى الْحَوَائِجَ
u'مَحَى طَلاَقٌ':Predicate, #1: 1	مَحَى الْخُطُوطَ
u'مَحَى مُبْطِلٌ':Predicate, #2: 2	مَحَى الطَّلَاقَ
u'مَحَى وَجْهٌ':Predicate, #1: 1	مَحَى الْمُبْطِلَ
u'مُخَادَعَةٌ نَاسٌ':Added, #1: 1	مَحَى وَجْهَ
u'مُخَاصَمَةٌ بَائِعٌ':Added, #1: 1	مُخَادَعَةِ النَّاسِ
u'مُخَاصَمَةٌ زَوْجٌ':Added, #2: 2	مُخَاصَمَةُ بَائِعِهِ
u'مُخَاصَمَةٌ عَلِيٌّ':Added, #1: 1	مُخَاصَمَةِ الزَّوْجَيْنِ
u'مُخَاصَمَةٌ غَاصِبٌ':Added, #1: 1	مُخَاصَمَةِ عَلِيٍّ
u'مُخَاصَمَةٌ فلان':Added, #2: 2	مُخَاصَمَةُ الْغَاصِبِ
u'مُخَاصَمَةٌ قُرْطُبِيّ':Added, #1: 1	مُخَاصَمَةَ الْقُرْطُبِيِّ
u'مُخَاصَمَةٌ مَحْجُورٌ':Added, #1: 1	مُخَاصَمَةَ الْقُرْطُبِيِّ
u'مُخَاصَمَةٌ مُرْتَهِنٌ':Added, #1: 1	مُخَاصَمَةَ الْمَحْجُورِ
u'مُخَاصَمَةٌ مُلْتَقِط':Added, #1: 1	مُخَاصَمَةِ الْمُرْتَهِنِ
u'مُخَاصَمَةٌ مُوَكِّلٌ':Added, #1: 1	مُخَاصَمَةِ الْمُلْتَقِطِ
u'مُخَاصَمَةٌ وَلِيٌّ':Added, #1: 1	مُخَاصَمَةِ الْمُوَكِّلِ
u'مُخَاطَبٌ آدَمِيٌّ':Added, #2: 2	مُخَاصَمَةِ الْوَلِيِّ
u'مُخَاطَبٌ أئِمَّةٌ':Added, #1: 1	مُخَاطَبَةِ الْآدَمِيِّ
u'مُخَاطَبَةٌ آدَمِيٌّ':Added, #1: 1	مُخَاطَبَةِ الْأَئِمَّةِ
u'مُخَاطَبَةٌ أئِمَّةٌ':Added, #1: 1	مُخَاطَبَةِ الْآدَمِيِّ
u'مُخَاطَبَةٌ تَعْلِيمٌ':Added, #1: 1	مُخَاطَبَةِ الْأَئِمَّةِ
u'مُخَاطَبَةٌ حاضِرٌ':Added, #1: 1	مُخَاطَبَةُ تَعْلِيمٍ
u'مُخَاطَبَةٌ خلق':Added, #1: 1	مُخَاطَبَةِ الْحَاضِرِ
u'مُخَاطَبَةٌ خَلْقٌ':Added, #1: 1	مُخَاطَبَةِ الْخَلْقِ
u'مُخَاطَبَةٌ زَوْجَةٌ':Added, #1: 1	مُخَاطَبَةِ الْخَلْقِ
u'مُخَاطَبَةٌ شَارِعٌ':Added, #2: 2	مُخَاطَبَةِ زَوْجَتِهِ
u'مُخَاطَبَةٌ شَعْرٌ':Added, #1: 1	مُخَاطَبَةُ الشَّارِعِ
u'مُخَاطَبَةٌ ضَفِيرٌ':Added, #1: 1	مُخَاطَبَةَ الشَّعْرِ
u'مُخَاطَبَةٌ ضَفِيرَةٌ':Added, #1: 1	مُخَاطَبَةَ الضَّفِيرَةِ
u'مُخَاطَبَةٌ عَبْدٌ':Added, #1: 1	مُخَاطَبَةَ الضَّفِيرَةِ
u'مُخَاطَبَةٌ عناد':Added, #1: 1	مُخَاطَبَةِ الْعَبْدِ
u'مُخَاطَبَةٌ عِنَادٌ':Added, #1: 1	مُخَاطَبَةُ عِنَادٍ
u'مُخَاطَبَةٌ غير':Added, #1: 1	مُخَاطَبَةُ عِنَادٍ
u'مُخَاطَبَةٌ غَيْرٌ':Added, #1: 1	مُخَاطَبَةَ الْغَيْرِ
u'مُخَاطَبَةٌ قضاة':Added, #1: 1	مُخَاطَبَةَ الْغَيْرِ
u'مُخَاطَبَةٌ كَافِرٌ':Added, #1: 1	مُخَاطَبَةِ قُضَاةِ
u'مُخَاطَبَةٌ كُفَّارٌ':Added, #1: 1	مُخَاطَبَةِ الْكَافِرِ
u'مُخَاطَبَةٌ مثل':Added, #3: 3	مُخَاطَبَةِ الْكُفَّارِ
u'مُخَاطَبَةٌ مِثْلٌ':Added, #1: 1	مُخَاطَبَةُ مِثْلِ
u'مُخَاطَبَةٌ مُسْنَدٌ':Added, #1: 1	مُخَاطَبَةُ مِثْلِ
u'مُخَاطَبَةٌ نَاسٌ':Added, #1: 1	مُخَاطَبَةٍ مُسْنَدٍ
u'مُخَاطَبَةٌ واحد':Added, #1: 1	مُخَاطَبَةُ النَّاسِ
u'مُخَاطَبَةٌ وَاحِدٌ':Added, #1: 1	مُخَاطَبَةُ الْوَاحِدِ
u'مُخَاطَبٌ تَعْلِيمٌ':Added, #1: 1	مُخَاطَبَةُ الْوَاحِدِ
u'مُخَاطَبٌ حاضِرٌ':Added, #1: 1	مُخَاطَبَةُ تَعْلِيمٍ
u'مُخَاطَبٌ خلق':Added, #1: 1	مُخَاطَبَةِ الْحَاضِرِ
u'مُخَاطَبٌ خَلْقٌ':Added, #1: 1	مُخَاطَبَةِ الْخَلْقِ
u'مُخَاطَبٌ زَوْجَةٌ':Added, #1: 1	مُخَاطَبَةِ الْخَلْقِ
u'مُخَاطَبٌ شَارِعٌ':Added, #2: 2	مُخَاطَبَةِ زَوْجَتِهِ
u'مُخَاطَبٌ شَعْرٌ':Added, #1: 1	مُخَاطَبَةُ الشَّارِعِ
u'مُخَاطَبٌ ضَفِيرٌ':Added, #1: 1	مُخَاطَبَةَ الشَّعْرِ
u'مُخَاطَبٌ ضَفِيرَةٌ':Added, #1: 1	مُخَاطَبَةَ الضَّفِيرَةِ
u'مُخَاطَبٌ عَبْدٌ':Added, #1: 1	مُخَاطَبَةَ الضَّفِيرَةِ
u'مُخَاطَبٌ عناد':Added, #1: 1	مُخَاطَبَةِ الْعَبْدِ
u'مُخَاطَبٌ عِنَادٌ':Added, #1: 1	مُخَاطَبَةُ عِنَادٍ
u'مُخَاطَبٌ غير':Added, #1: 1	مُخَاطَبَةُ عِنَادٍ
u'مُخَاطَبٌ غَيْرٌ':Added, #1: 1	مُخَاطَبَةَ الْغَيْرِ
u'مُخَاطَبٌ قضاة':Added, #1: 1	مُخَاطَبَةَ الْغَيْرِ
u'مُخَاطَبٌ كَافِرٌ':Added, #1: 1	مُخَاطَبَةِ قُضَاةِ
u'مُخَاطَبٌ كُفَّارٌ':Added, #1: 1	مُخَاطَبَةِ الْكَافِرِ
u'مُخَاطَبٌ مثل':Added, #3: 3	مُخَاطَبَةِ الْكُفَّارِ
u'مُخَاطَبٌ مِثْلٌ':Added, #1: 1	مُخَاطَبَةُ مِثْلِ
u'مُخَاطَبٌ نَاسٌ':Added, #1: 1	مُخَاطَبَةُ مِثْلِ
u'مُخَاطَبٌ واحد':Added, #1: 1	مُخَاطَبَةُ النَّاسِ
u'مُخَاطَبٌ وَاحِدٌ':Added, #1: 1	مُخَاطَبَةُ الْوَاحِدِ
u'مُخَاطَرَةٌ تِجَارَةٌ':Added, #1: 1	مُخَاطَبَةُ الْوَاحِدِ
u'مَخَافَةٌ اِسْتِمْرارٌ':Added, #1: 1	مُخَاطَرَةُ التِّجَارَةِ
u'مَخَافَة اِسْتِمْرارٌ':Added, #1: 1	مَخَافَةِ اسْتِمْرَارِهِ
u'مَخَافَةٌ إصابَةٌ':Added, #1: 1	مَخَافَةِ اسْتِمْرَارِهِ
u'مَخَافَة إصابَةٌ':Added, #1: 1	مَخَافَةَ إصَابَةِ
u'مَخَافَةٌ إِطْنابٌ':Added, #1: 1	مَخَافَةَ إصَابَةِ
u'مَخَافَة إِطْنابٌ':Added, #1: 1	مَخَافَةَ الْإِطْنَابِ
u'مَخَافَةٌ أَعْيَارٌ':Added, #1: 1	مَخَافَةَ الْإِطْنَابِ
u'مَخَافَة أَعْيَارٌ':Added, #1: 1	مَخَافَةِ الْأَعْيَارِ
u'مَخَافَةٌ أَقْوَالٌ':Added, #1: 1	مَخَافَةِ الْأَعْيَارِ
u'مَخَافَة أَقْوَالٌ':Added, #1: 1	مَخَافَةَ أَقْوَالِ
u'مَخَافَةٌ اِنْدِراسٌ':Added, #1: 1	مَخَافَةَ أَقْوَالِ
u'مَخَافَة اِنْدِراسٌ':Added, #1: 1	مَخَافَةَ انْدِرَاسِهِ
u'مَخَافَةٌ إِنْفاقٌ':Added, #1: 1	مَخَافَةَ انْدِرَاسِهِ
u'مَخَافَة إِنْفاقٌ':Added, #1: 1	مَخَافَةَ الْإِنْفَاقِ
u'مَخَافَةٌ بُلْدانٌ':Added, #1: 1	مَخَافَةَ الْإِنْفَاقِ
u'مَخَافَة بُلْدانٌ':Added, #1: 1	مَخَافَةِ الْبُلْدَانِ
u'مَخَافَةٌ تَشْوِيشٌ':Added, #1: 1	مَخَافَةِ الْبُلْدَانِ
u'مَخَافَة تَشْوِيشٌ':Added, #1: 1	مَخَافَةَ التَّشْوِيشِ
u'مَخَافَةٌ تَطْوِيلٌ':Added, #1: 1	مَخَافَةَ التَّشْوِيشِ
u'مَخَافَة تَطْوِيلٌ':Added, #1: 1	مَخَافَةَ التَّطْوِيلِ
u'مَخَافَةٌ تَمَلُّك':Added, #1: 1	مَخَافَةَ التَّطْوِيلِ
u'مَخَافَة تَمَلُّك':Added, #1: 1	مَخَافَةَ التَّمَلُّكِ
u'مَخَافَةٌ تَوَهُّمٌ':Added, #1: 1	مَخَافَةَ التَّمَلُّكِ
u'مَخَافَة تَوَهُّمٌ':Added, #1: 1	مَخَافَةُ تَوَهُّمِ
u'مَخَافَةٌ ثَائِرٌ':Added, #1: 1	مَخَافَةُ تَوَهُّمِ
u'مَخَافَة ثَائِرٌ':Added, #2: 2	مَخَافَةَ ثَائِرٍ
u'مَخَافَةٌ جُحُود':Added, #2: 2	مَخَافَةَ ثَائِرٍ
u'مَخَافَة جُحُود':Added, #2: 2	مَخَافَةَ جُحُودِ
u'مَخَافَةٌ حَبْسٌ':Added, #2: 2	مَخَافَةَ جُحُودِ
u'مَخَافَة حَبْسٌ':Added, #1: 1	مَخَافَةَ الْحَبْسِ
u'مَخَافَةٌ خَلَلٌ':Added, #1: 1	مَخَافَةَ الْحَبْسِ
u'مَخَافَة خَلَلٌ':Added, #1: 1	مَخَافَةَ الْخَلَلِ
u'مَخَافَةٌ دَاءٌ':Added, #1: 1	مَخَافَةَ الْخَلَلِ
u'مَخَافَة دَاءٌ':Added, #1: 1	مَخَافَةَ الدَّاءِ
u'مَخَافَةٌ ذَريعٌ':Added, #1: 1	مَخَافَةَ الدَّاءِ
u'مَخَافَة ذَريعٌ':Added, #2: 2	مَخَافَةَ الذَّرِيعَةِ
u'مَخَافَةٌ ذَريعَةٌ':Added, #2: 2	مَخَافَةَ الذَّرِيعَةِ
u'مَخَافَة ذَريعَةٌ':Added, #2: 2	مَخَافَةَ الذَّرِيعَةِ
u'مَخَافَةٌ سَآمَةٌ':Added, #2: 2	مَخَافَةَ الذَّرِيعَةِ
u'مَخَافَةٌ سَآمَةٌ':Added, #1: 1	مَخَافَةَ السّآمَةِ
u'مَخَافَة سَآمَةٌ':Added, #1: 1	مَخَافَةَ السَّآمَةِ
u'مَخَافَة سَآمَةٌ':Added, #1: 1	مَخَافَةَ السّآمَةِ
u'مَخَافَةٌ سُبَّةٌ':Added, #1: 1	مَخَافَةَ السَّآمَةِ
u'مَخَافَة سُبَّةٌ':Added, #1: 1	مَخَافَةُ السّبّةِ
u'مَخَافَةٌ سَرَق':Added, #1: 1	مَخَافَةُ السّبّةِ
u'مَخَافَة سَرَق':Added, #1: 1	مَخَافَةَ السَّرَقِ
u'مَخَافَةٌ سُقُوطٌ':Added, #1: 1	مَخَافَةَ السَّرَقِ
u'مَخَافَة سُقُوطٌ':Added, #1: 1	مَخَافَةَ السُّقُوطِ
u'مَخَافَةٌ سكر':Added, #1: 1	مَخَافَةَ السُّقُوطِ
u'مَخَافَة سكر':Added, #1: 1	مَخَافَةُ السُّكْرِ
u'مَخَافَةٌ سُكْرٌ':Added, #1: 1	مَخَافَةُ السُّكْرِ
u'مَخَافَة سُكْرٌ':Added, #1: 1	مَخَافَةُ السُّكْرِ
u'مَخَافَةٌ سِلاَحٌ':Added, #1: 1	مَخَافَةُ السُّكْرِ
u'مَخَافَة سِلاَحٌ':Added, #3: 3	مَخَافَةَ السِّلاَحِ
u'مَخَافَةٌ شَرٌّ':Added, #3: 3	مَخَافَةَ السِّلاَحِ
u'مَخَافَة شَرٌّ':Added, #5: 5	مَخَافَةَ شَرِّهِ
u'مَخَافَةٌ شَنَآنٌ':Added, #5: 5	مَخَافَةَ شَرِّهِ
u'مَخَافَة شَنَآنٌ':Added, #1: 1	مَخَافَةَ الشّنَآنِ
u'مَخَافَةٌ شهرة':Added, #1: 1	مَخَافَةَ الشّنَآنِ
u'مَخَافَة شهرة':Added, #1: 1	مَخَافَةُ الشُّهْرَةِ
u'مَخَافَةٌ شُهْرَةٌ':Added, #1: 1	مَخَافَةُ الشُّهْرَةِ
u'مَخَافَة شُهْرَةٌ':Added, #1: 1	مَخَافَةُ الشُّهْرَةِ
u'مَخَافَةٌ صدقة':Added, #1: 1	مَخَافَةُ الشُّهْرَةِ
u'مَخَافَة صدقة':Added, #3: 3	مَخَافَةَ الصَّدَقَةِ
u'مَخَافَةٌ صَدَقَةٌ':Added, #3: 3	مَخَافَةَ الصَّدَقَةِ
u'مَخَافَة صَدَقَةٌ':Added, #3: 3	مَخَافَةَ الصَّدَقَةِ
u'مَخَافَةٌ ضَمَانٌ':Added, #3: 3	مَخَافَةَ الصَّدَقَةِ
u'مَخَافَة ضَمَانٌ':Added, #3: 3	مَخَافَةَ الضَّمَانِ
u'مَخَافَةٌ ضَيَاعٌ':Added, #3: 3	مَخَافَةَ الضَّمَانِ
u'مَخَافَة ضَيَاعٌ':Added, #1: 1	مَخَافَةَ الضَّيَاعِ
u'مَخَافَةٌ عَادَةٌ':Added, #1: 1	مَخَافَةَ الضَّيَاعِ
u'مَخَافَة عَادَةٌ':Added, #2: 2	مَخَافَةَ الْعَادَةِ
u'مَخَافَةٌ عَدُوٌّ':Added, #2: 2	مَخَافَةَ الْعَادَةِ
u'مَخَافَة عَدُوٌّ':Added, #3: 3	مَخَافَةَ الْعَدُوِّ
u'مَخَافَةٌ عَطَشٌ':Added, #3: 3	مَخَافَةَ الْعَدُوِّ
u'مَخَافَة عَطَشٌ':Added, #1: 1	مَخَافَةَ الْعَطَشِ
u'مَخَافَةٌ عُقُوبَةٌ':Added, #1: 1	مَخَافَةَ الْعَطَشِ
u'مَخَافَة عُقُوبَةٌ':Added, #1: 1	مَخَافَةَ الْعُقُوبَةِ
u'مَخَافَةٌ عَيْلَةٌ':Added, #1: 1	مَخَافَةَ الْعُقُوبَةِ
u'مَخَافَة عَيْلَةٌ':Added, #1: 1	مَخَافَةَ الْعَيْلَةِ
u'مَخَافَةٌ عين':Added, #1: 1	مَخَافَةَ الْعَيْلَةِ
u'مَخَافَة عين':Added, #2: 2	مَخَافَةَ الْعَيْنِ
u'مَخَافَةٌ عَيْنٌ':Added, #2: 2	مَخَافَةَ الْعَيْنِ
u'مَخَافَةٌ عَيْن':Added, #2: 2	مَخَافَةَ الْعَيْنِ
u'مَخَافَة عَيْنٌ':Added, #2: 2	مَخَافَةَ الْعَيْنِ
u'مَخَافَة عَيْن':Added, #2: 2	مَخَافَةَ الْعَيْنِ
u'مَخَافَةٌ غَرَامَةٌ':Added, #2: 2	مَخَافَةَ الْعَيْنِ
u'مَخَافَة غَرَامَةٌ':Added, #3: 3	مَخَافَةَ الْغَرَامَةِ
u'مَخَافَةٌ غضب':Added, #3: 3	مَخَافَةَ الْغَرَامَةِ
u'مَخَافَة غضب':Added, #1: 1	مَخَافَةَ غَضَبِهِ
u'مَخَافَةٌ غَضَبٌ':Added, #1: 1	مَخَافَةَ غَضَبِهِ
u'مَخَافَة غَضَبٌ':Added, #1: 1	مَخَافَةَ غَضَبِهِ
u'مَخَافَةٌ غفلة':Added, #1: 1	مَخَافَةَ غَضَبِهِ
u'مَخَافَة غفلة':Added, #1: 1	مَخَافَةَ الْغَفْلَةِ
u'مَخَافَةٌ غَفْلَةٌ':Added, #1: 1	مَخَافَةَ الْغَفْلَةِ
u'مَخَافَة غَفْلَةٌ':Added, #1: 1	مَخَافَةَ الْغَفْلَةِ
u'مَخَافَةٌ غَيْبَةٌ':Added, #1: 1	مَخَافَةَ الْغَفْلَةِ
u'مَخَافَة غَيْبَةٌ':Added, #1: 1	مَخَافَةَ الْغَيْبَةِ
u'مَخَافَةٌ فتنة':Added, #1: 1	مَخَافَةَ الْغَيْبَةِ
u'مَخَافَة فتنة':Added, #1: 1	مَخَافَةَ فِتْنَةِ
u'مَخَافَةٌ فِتْنَةٌ':Added, #1: 1	مَخَافَةَ فِتْنَةِ
u'مَخَافَة فِتْنَةٌ':Added, #1: 1	مَخَافَةَ فِتْنَةِ
u'مَخَافَةٌ فتنة':Added, #1: 1	مَخَافَةَ فِتْنَةِ
u'مَخَافَة فتنة':Added, #3: 3	مَخَافَةَ الْفِتْنَةِ
u'مَخَافَةٌ فِتْنَةٌ':Added, #3: 3	مَخَافَةَ الْفِتْنَةِ
u'مَخَافَة فِتْنَةٌ':Added, #3: 3	مَخَافَةَ الْفِتْنَةِ
u'مَخَافَةٌ فَجْرٌ':Added, #3: 3	مَخَافَةَ الْفِتْنَةِ
u'مَخَافَة فَجْرٌ':Added, #1: 1	مَخَافَةَ الْفَجْرِ
u'مَخَافَةٌ فقر':Added, #1: 1	مَخَافَةَ الْفَجْرِ
u'مَخَافَة فقر':Added, #1: 1	مَخَافَةَ الْفَقْرِ
u'مَخَافَةٌ فَقْرٌ':Added, #1: 1	مَخَافَةَ الْفَقْرِ
u'مَخَافَة فَقْرٌ':Added, #1: 1	مَخَافَةَ الْفَقْرِ
u'مَخَافَةٌ قتل':Added, #1: 1	مَخَافَةَ الْفَقْرِ
u'مَخَافَة قتل':Added, #1: 1	مَخَافَةَ الْقَتْلِ
u'مَخَافَةٌ قَتْلٌ':Added, #1: 1	مَخَافَةَ الْقَتْلِ
u'مَخَافَة قَتْلٌ':Added, #1: 1	مَخَافَةَ الْقَتْلِ
u'مَخَافَةٌ قَطِيعٌ':Added, #1: 1	مَخَافَةَ الْقَتْلِ
u'مَخَافَة قَطِيعٌ':Added, #2: 2	مَخَافَةَ الْقَطِيعَةِ
u'مَخَافَةٌ قَطِيعَةٌ':Added, #2: 2	مَخَافَةَ الْقَطِيعَةِ
u'مَخَافَة قَطِيعَةٌ':Added, #2: 2	مَخَافَةَ الْقَطِيعَةِ
u'مَخَافَةٌ قِيَامَةٌ':Added, #2: 2	مَخَافَةَ الْقَطِيعَةِ
u'مَخَافَة قِيَامَةٌ':Added, #4: 4	مَخَافَةَ الْقِيَامَةِ
u'مَخَافَةٌ كَرَاهِيَةٌ':Added, #4: 4	مَخَافَةَ الْقِيَامَةِ
u'مَخَافَة كَرَاهِيَةٌ':Added, #1: 1	مَخَافَةَ الْكَرَاهِيَةِ
u'مَخَافَةٌ كَوْنٌ':Added, #1: 1	مَخَافَةَ الْكَرَاهِيَةِ
u'مَخَافَة كَوْنٌ':Added, #1: 1	مَخَافَةَ كَوْنِهِ
u'مَخَافَةٌ لُزُومٌ':Added, #1: 1	مَخَافَةَ كَوْنِهِ
u'مَخَافَة لُزُومٌ':Added, #1: 1	مَخَافَةَ لُزُومِ
u'مَخَافَةٌ مَوْتٌ':Added, #1: 1	مَخَافَةَ لُزُومِ
u'مَخَافَة مَوْتٌ':Added, #1: 1	مَخَافَةَ الْمَوْتِ
u'مَخَافَةٌ نَارٌ':Added, #1: 1	مَخَافَةَ الْمَوْتِ
u'مَخَافَة نَارٌ':Added, #1: 1	مَخَافَةَ النَّارِ
u'مَخَافَةٌ نَاسٌ':Added, #1: 1	مَخَافَةَ النَّارِ
u'مَخَافَة نَاسٌ':Added, #3: 3	مَخَافَةُ النَّاسِ
u'مَخَافَةٌ نِسْيَانٌ':Added, #3: 3	مَخَافَةُ النَّاسِ
u'مَخَافَة نِسْيَانٌ':Added, #1: 1	مَخَافَةَ نِسْيَانِهِ
u'مَخَافَةٌ نُقْصَانٌ':Added, #1: 1	مَخَافَةَ نِسْيَانِهِ
u'مَخَافَة نُقْصَانٌ':Added, #1: 1	مَخَافَةَ النُّقْصَانِ
u'مَخَافَةٌ نَكَالٌ':Added, #1: 1	مَخَافَةَ النُّقْصَانِ
u'مَخَافَة نَكَالٌ':Added, #1: 1	مَخَافَةَ النَّكَالِ
u'مَخَافَةٌ نَوْمٌ':Added, #1: 1	مَخَافَةَ النَّكَالِ
u'مَخَافَة نَوْمٌ':Added, #1: 1	مَخَافَةَ النَّوْمِ
u'مَخَافَةٌ نَوْمٌ':Added, #1: 1	مَخَافَةَ النَّوْمِ
u'مَخَافَة نَوْمٌ':Added, #1: 1	مَخَافَةَ نَوْمِهِ
u'مَخَافَةٌ هلاك':Added, #1: 1	مَخَافَةَ نَوْمِهِ
u'مَخَافَة هلاك':Added, #1: 1	مَخَافَةَ الْهَلَاكِ
u'مَخَافَةٌ هَلاَكٌ':Added, #1: 1	مَخَافَةَ الْهَلَاكِ
u'مَخَافَة هَلاَكٌ':Added, #1: 1	مَخَافَةَ الْهَلَاكِ
u'مَخَافَةٌ وُقُوعٌ':Added, #1: 1	مَخَافَةَ الْهَلَاكِ
u'مَخَافَة وُقُوعٌ':Added, #1: 1	مَخَافَةَ الْوُقُوعِ
u'مُخَالَطَةٌ أَبْنَاءٌ':Added, #1: 1	مَخَافَةَ الْوُقُوعِ
u'مُخَالَطَةٌ أراذل':Added, #1: 1	مُخَالَطَةِ أَبْنَاءِ
u'مُخَالَطَةٌ أَرْواحٌ':Added, #1: 1	مُخَالَطَةِ الْأَرَاذِلِ
u'مُخَالَطَةٌ أَزْواجٌ':Added, #1: 1	مُخَالَطَةِ الْأَرْوَاحِ
u'مُخَالَطَةٌ أكفاء':Added, #1: 1	مُخَالَطَةَ الْأَزْوَاجِ
u'مُخَالَطَةٌ أيتام':Added, #1: 1	مُخَالَطَةِ الْأَكْفَاءِ
u'مُخَالَطَةٌ جِسْمٌ':Added, #1: 1	مُخَالَطَةِ الْأَيْتَامِ
u'مُخَالَطَةٌ جَمَاعَةٌ':Added, #1: 1	مُخَالَطَةِ الْجِسْمِ
u'مُخَالَطَةٌ جُمْهُورٌ':Added, #1: 1	مُخَالَطَةِ الْجَمَاعَةِ
u'مُخَالَطَةٌ خلق':Added, #1: 1	مُخَالَطَةِ الْجُمْهُورِ
u'مُخَالَطَةٌ خَلْقٌ':Added, #1: 1	مُخَالَطَةِ الْخَلْقِ
u'مُخَالَطَةٌ خَمْرٌ':Added, #1: 1	مُخَالَطَةِ الْخَلْقِ
u'مُخَالَطَةٌ رِجَالٌ':Added, #1: 1	مُخَالَطَةِ الْخَمْرِ
u'مُخَالَطَةٌ سُلْطَانٌ':Added, #3: 3	مُخَالَطَةِ الرِّجَالِ
u'مُخَالَطَةٌ شَيْءٌ':Added, #1: 1	مُخَالَطَةِ السُّلْطَانِ
u'مُخَالَطَةٌ شَيْطَانٌ':Added, #1: 1	مُخَالَطَةِ شَيْءٍ
u'مُخَالَطَةٌ صَائِمٌ':Added, #1: 1	مُخَالَطَةَ الشَّيْطَانِ
u'مُخَالَطَةٌ ظلمة':Added, #1: 1	مُخَالَطَةِ الصَّائِمِ
u'مُخَالَطَةٌ قَيْحٌ':Added, #1: 1	مُخَالَطَةِ الظَّلَمَةِ
u'مُخَالَطَةٌ كبائر':Added, #1: 1	مُخَالَطَةِ الْقَيْحِ
u'مُخَالَطَةٌ لعاب':Added, #2: 2	مُخَالَطَةِ الْكَبَائِرِ
u'مُخَالَطَةٌ لُعَابٌ':Added, #1: 1	مُخَالَطَةُ اللُّعَابِ
u'مُخَالَطَةٌ لعاب':Added, #1: 1	مُخَالَطَةُ اللُّعَابِ
u'مُخَالَطَةٌ لُعَابٌ':Added, #2: 2	مُخَالَطَةِ اللُّعَابِ
u'مُخَالَطَةٌ مَاءٌ':Added, #2: 2	مُخَالَطَةِ اللُّعَابِ
u'مُخَالَطَةٌ مُتَلَبِّسٌ':Added, #1: 1	مُخَالَطَةِ الْمَاءِ
u'مُخَالَطَةٌ مرد':Added, #1: 1	مُخَالَطَةِ الْمُتَلَبِّسِ
u'مُخَالَطَةٌ نَاسٌ':Added, #1: 1	مُخَالَطَةِ الْمُرْدِ
u'مُخَالَطَةٌ نَاسٌ':Added, #1: 1	مُخَالَطَةُ النَّاسِ
u'مُخَالَطَةٌ نَجَاسَةٌ':Added, #2: 2	مُخَالَطَةِ النَّاسِ
u'مُخَالَطَةٌ نَجَاسَةٌ':Added, #1: 1	مُخَالَطَةُ النَّجَاسَةِ
u'مُخَالَطَةٌ نَجَاسَةٌ':Added, #1: 1	مُخَالَطَةِ النَّجَاسَةِ
u'مُخَالَطَةٌ نَجَسٌ':Added, #1: 1	مُخَالَطَةُ نَجَاسَةٍ
u'مُخَالَطَةٌ نِساءٌ':Added, #1: 1	مُخَالَطَةِ النَّجَسِ
u'مُخَالَطَةٌ يَتِيمٌ':Added, #2: 2	مُخَالَطَةِ النِّسَاءِ
u'مُخَالَفَةٌ اِبْنٌ':Added, #1: 1	مُخَالَطَةِ الْيَتِيمِ
u'مُخَالَفَةٌ إِجْمَاعٌ':Added, #2: 2	مُخَالَفَةِ ابْنِ
u'مُخَالَفَةٌ إِجْمَاعٌ':Added, #1: 1	مُخَالَفَةِ إجْمَاعِ
u'مُخَالَفَةٌ إِجْمَاعٌ':Added, #2: 2	مُخَالَفَةَ الْإِجْمَاعِ
u'مُخَالَفَةٌ إِجْمَاعٌ':Added, #4: 4	مُخَالَفَةُ الْإِجْمَاعِ
u'مُخَالَفَةٌ إِذْنٌ':Added, #5: 5	مُخَالَفَةِ الْإِجْمَاعِ
u'مُخَالَفَةٌ إِذْنٌ':Added, #1: 1	مُخَالَفَةُ إذْنٍ
u'مُخَالَفَةٌ أصل':Added, #3: 3	مُخَالَفَةُ الْإِذْنِ
u'مُخَالَفَةٌ أًصْلٌ':Added, #1: 1	مُخَالَفَةُ أَصْلِ
u'مُخَالَفَةٌ أصل':Added, #1: 1	مُخَالَفَةُ أَصْلِ
u'مُخَالَفَةٌ أًصْلٌ':Added, #1: 1	مُخَالَفَةُ أَصْلِهِ
u'مُخَالَفَةٌ أصل':Added, #1: 1	مُخَالَفَةُ أَصْلِهِ
u'مُخَالَفَةٌ أصل':Added, #2: 2	مُخَالَفَةُ الْأَصْلِ
u'مُخَالَفَةٌ أًصْلٌ':Added, #2: 2	مُخَالَفَةِ الْأَصْلِ
u'مُخَالَفَةٌ أًصْلٌ':Added, #2: 2	مُخَالَفَةُ الْأَصْلِ
u'مُخَالَفَةٌ إِطْلاقٌ':Added, #2: 2	مُخَالَفَةِ الْأَصْلِ
u'مُخَالَفَةٌ إِطْلاقٌ':Added, #1: 1	مُخَالَفَةُ إطْلَاقِ
u'مُخَالَفَةٌ اِعْتِبارٌ':Added, #1: 1	مُخَالَفَةِ إطْلَاقِ
u'مُخَالَفَةٌ أقَلُّ':Added, #1: 1	مُخَالَفَةُ اعْتِبَارِهِ
u'مُخَالَفَةٌ الْمَرْأَةُ':Added, #1: 1	مُخَالَفَةِ الْأَقَلِّ
u'مُخَالَفَةٌ إمَامٌ':Added, #1: 1	مُخَالَفَةِ الْمَرْأَةِ
u'مُخَالَفَةٌ إمَامٌ':Added, #1: 1	مُخَالَفَةُ الْإِمَامِ
u'مُخَالَفَةٌ إمَامٌ':Added, #1: 1	مُخَالَفَةَ إمَامِهِ
u'مُخَالَفَةٌ إمَامٌ':Added, #1: 1	مُخَالَفَةِ إمَامِهِ
u'مُخَالَفَةٌ إمَامٌ':Added, #2: 2	مُخَالَفَةُ إمَامِهِ
u'مُخَالَفَةٌ إمَامٌ':Added, #3: 3	مُخَالَفَةَ الْإِمَامِ
u'مُخَالَفَةٌ أَمْرٌ':Added, #5: 5	مُخَالَفَةِ الْإِمَامِ
u'مُخَالَفَةٌ أَمْرٌ':Added, #1: 1	مُخَالَفَةُ أَمْرِ
u'مُخَالَفَةٌ أَمْرٌ':Added, #1: 1	مُخَالَفَةِ أَمْرِ
u'مُخَالَفَةٌ أَمْرٌ':Added, #1: 1	مُخَالَفَةَ أَمْرِهِ
u'مُخَالَفَةٌ أَمْرٌ':Added, #3: 3	مُخَالَفَةُ الْأَمْرِ
u'مُخَالَفَةٌ أَمْرٌ':Added, #3: 3	مُخَالَفَةِ الْأَمْرِ
u'مُخَالَفَةٌ أوامر':Added, #3: 3	مُخَالَفَةُ أَمْرِهِ
u'مُخَالَفَةٌ أَوامِرُ':Added, #1: 1	مُخَالَفَةِ الْأَوَامِرِ
u'مُخَالَفَةٌ أوامر':Added, #1: 1	مُخَالَفَةِ الْأَوَامِرِ
u'مُخَالَفَةٌ أَوامِرُ':Added, #1: 1	مُخَالَفَةُ أَوَامِرِ
u'مُخَالَفَةٌ أوامر':Added, #1: 1	مُخَالَفَةُ أَوَامِرِ
u'مُخَالَفَةٌ أَوامِرُ':Added, #1: 1	مُخَالَفَةِ أَوَامِرِهِ
u'مُخَالَفَةٌ أَوَّلُ':Added, #1: 1	مُخَالَفَةِ أَوَامِرِهِ
u'مُخَالَفَةٌ بَدَلٌ':Added, #2: 2	مُخَالَفَةِ الْأَوَّلِ
u'مُخَالَفَةٌ بَعْضٌ':Added, #1: 1	مُخَالَفَةِ الْبَدَلِ
u'مُخَالَفَةٌ بَعْضٌ':Added, #1: 1	مُخَالَفَةُ الْبَعْضِ
u'مُخَالَفَةٌ تَبَع':Added, #1: 1	مُخَالَفَةِ بَعْضِ
u'مُخَالَفَةٌ تَسْمِيَة':Added, #2: 2	مُخَالَفَةُ التَّبَعِ
u'مُخَالَفَةٌ تَكْليفٌ':Added, #1: 1	مُخَالَفَةِ التَّسْمِيَةِ
u'مُخَالَفَةٌ جَاهِلِيٌّ':Added, #1: 1	مُخَالَفَةُ التَّكْلِيفِ
u'مُخَالَفَةٌ جَاهِلِيَّةٌ':Added, #2: 2	مُخَالَفَةِ الْجَاهِلِيَّةِ
u'مُخَالَفَةٌ جَلاَلٌ':Added, #2: 2	مُخَالَفَةِ الْجَاهِلِيَّةِ
u'مُخَالَفَةٌ جَمَاعَةٌ':Added, #1: 1	مُخَالَفَةِ الْجَلَالِ
u'مُخَالَفَةٌ جُمْهُورٌ':Added, #4: 4	مُخَالَفَةَ الْجَمَاعَةِ
u'مُخَالَفَةٌ جِنْسٌ':Added, #1: 1	مُخَالَفَةِ الْجُمْهُورِ
u'مُخَالَفَةٌ جَوَابٌ':Added, #1: 1	مُخَالَفَةِ الْجِنْسِ
u'مُخَالَفَةٌ حَجٌّ':Added, #1: 1	مُخَالَفَةِ جَوَابِ
u'مُخَالَفَةٌ حَديثٌ':Added, #1: 1	مُخَالَفَةُ الْحَجِّ
u'مُخَالَفَةٌ حُكْمٌ':Added, #1: 1	مُخَالَفَةِ الْحَدِيثِ
u'مُخَالَفَةٌ حُكْمٌ':Added, #1: 1	مُخَالَفَةَ حُكْمِ
u'مُخَالَفَةٌ خَبَرٌ':Added, #1: 1	مُخَالَفَةَ حُكْمِهِ
u'مُخَالَفَةٌ خَبَر':Added, #1: 1	مُخَالَفَةِ الْخَبَرِ
u'مُخَالَفَةٌ خَطٌّ':Added, #1: 1	مُخَالَفَةِ الْخَبَرِ
u'مُخَالَفَةٌ دَليلٌ':Added, #1: 1	مُخَالَفَةُ خَطِّ
u'مُخَالَفَةٌ دِينٌ':Added, #3: 3	مُخَالَفَةِ الدَّلِيلِ
u'مُخَالَفَةٌ رَاجِعٌ':Added, #2: 2	مُخَالَفَةِ دِينِهِ
u'مُخَالَفَةٌ رَبُّ':Added, #1: 1	مُخَالَفَةُ الرَّاجِعِ
u'مُخَالَفَةٌ رَسُولٌ':Added, #1: 1	مُخَالَفَةِ الرَّبِّ
u'مُخَالَفَةٌ رَسُولٌ':Added, #1: 1	مُخَالَفَةِ الرَّسُولِ
u'مُخَالَفَةٌ رِوايَةٌ':Added, #1: 1	مُخَالَفَةَ رَسُولِ
u'مُخَالَفَةٌ رَوْضَةٌ':Added, #1: 1	مُخَالَفَةُ الرِّوَايَةِ
u'مُخَالَفَةٌ سَائِرٌ':Added, #2: 2	مُخَالَفَةِ الرَّوْضَةِ
u'مُخَالَفَةٌ سَلَفٌ':Added, #1: 1	مُخَالَفَةِ سَائِرِ
u'مُخَالَفَةٌ سَلَفٌ':Added, #1: 1	مُخَالَفَةُ السَّلَفِ
u'مُخَالَفَةٌ سُنَّةٌ':Added, #1: 1	مُخَالَفَةِ السَّلَفِ
u'مُخَالَفَةٌ سُنَّةٌ':Added, #10: 10	مُخَالَفَةِ السُّنَّةِ
u'مُخَالَفَةٌ سُنَّةٌ':Added, #1: 1	مُخَالَفَةُ السُّنَّةِ
u'مُخَالَفَةٌ سُنَّةٌ':Added, #1: 1	مُخَالَفَةِ سُنَّةِ
u'مُخَالَفَةٌ شافِعِيّ':Added, #2: 2	مُخَالَفَةَ السُّنَّةِ
u'مُخَالَفَةٌ شَرْطٌ':Added, #2: 2	مُخَالَفَةُ الشَّافِعِيِّ
u'مُخَالَفَةٌ شَرْطٌ':Added, #1: 1	مُخَالَفَةُ شَرْطِ
u'مُخَالَفَةٌ شَرْطٌ':Added, #1: 1	مُخَالَفَةُ شَرْطِهِ
u'مُخَالَفَةٌ شَرْعٌ':Added, #2: 2	مُخَالَفَةُ الشَّرْطِ
u'مُخَالَفَةٌ شَرْعٌ':Added, #1: 1	مُخَالَفَةُ الشَّرْعِ
u'مُخَالَفَةٌ شَرْعٌ':Added, #2: 2	مُخَالَفَةَ الشَّرْعِ
u'مُخَالَفَةٌ شِطْرَنْجٌ':Added, #3: 3	مُخَالَفَةِ الشَّرْعِ
u'مُخَالَفَةٌ صَاعٌ':Added, #1: 1	مُخَالَفَةِ الشِّطْرَنْجِ
u'مُخَالَفَةٌ صَرِيحٌ':Added, #1: 1	مُخَالَفَةِ صَاعِ
u'مُخَالَفَةٌ صِفَةٌ':Added, #1: 1	مُخَالَفَةَ صَرِيحِ
u'مُخَالَفَةٌ صَوَابٌ':Added, #1: 1	مُخَالَفَةِ صِفَتِهِ
u'مُخَالَفَةٌ صَوْمٌ':Added, #1: 1	مُخَالَفَةُ صَوَابِ
u'مُخَالَفَةٌ صَيْرَفِيٌّ':Added, #1: 1	مُخَالَفَةِ الصَّوْمِ
u'مُخَالَفَةٌ صِيغَةٌ':Added, #1: 1	مُخَالَفَةِ الصَّيْرَفِيِّ
u'مُخَالَفَةٌ ضَيْفٌ':Added, #1: 1	مُخَالَفَةَ صِيغَةِ
u'مُخَالَفَةٌ طَرِيقٌ':Added, #1: 1	مُخَالَفَةُ الضَّيْفِ
u'مُخَالَفَةٌ ظاهِرٌ':Added, #1: 1	مُخَالَفَةِ طَرِيقِ
u'مُخَالَفَةٌ ظاهِرٌ':Added, #1: 1	مُخَالَفَةَ ظَاهِرٍ
u'مُخَالَفَةٌ ظاهِرٌ':Added, #2: 2	مُخَالَفَةُ الظَّاهِرِ
u'مُخَالَفَةٌ عَادَةٌ':Added, #5: 5	مُخَالَفَةِ الظَّاهِرِ
u'مُخَالَفَةٌ عَامِّيٌّ':Added, #1: 1	مُخَالَفَةُ الْعَادَةِ
u'مُخَالَفَةٌ عِصَامٌ':Added, #1: 1	مُخَالَفَةَ الْعَامِّيِّ
u'مُخَالَفَةٌ علماء':Added, #1: 1	مُخَالَفَةِ عِصَامٍ
u'مُخَالَفَةٌ عُلَمَاءُ':Added, #1: 1	مُخَالَفَةِ الْعُلَمَاءِ
u'مُخَالَفَةٌ عَهْدٌ':Added, #1: 1	مُخَالَفَةِ الْعُلَمَاءِ
u'مُخَالَفَةٌ غَوْثٌ':Added, #1: 1	مُخَالَفَةِ الْعَهْدِ
u'مُخَالَفَةٌ غير':Added, #1: 1	مُخَالَفَةُ الْغَوْثِ
u'مُخَالَفَةٌ غَيْرٌ':Added, #1: 1	مُخَالَفَةُ غَيْرِ
u'مُخَالَفَةٌ غير':Added, #1: 1	مُخَالَفَةُ غَيْرِ
u'مُخَالَفَةٌ غَيْرٌ':Added, #2: 2	مُخَالَفَةِ غَيْرِهِ
u'مُخَالَفَةٌ فَقِيهٌ':Added, #2: 2	مُخَالَفَةِ غَيْرِهِ
u'مُخَالَفَةٌ فلان':Added, #2: 2	مُخَالَفَةِ الْفَقِيهِ
u'مُخَالَفَةٌ قَبُولٌ':Added, #2: 2	مُخَالَفَةُ الشَّافِعِيِّ
u'مُخَالَفَةٌ قِرَاءةٌ':Added, #1: 1	مُخَالَفَةِ قَبُولِ
u'مُخَالَفَةٌ قِسْمٌ':Added, #1: 1	مُخَالَفَةُ الْقِرَاءَاتِ
u'مُخَالَفَةٌ قَوَاعِدُ':Added, #1: 1	مُخَالَفَةِ الْقِسْمَيْنِ
u'مُخَالَفَةٌ قول':Added, #2: 2	مُخَالَفَةِ الْقَوَاعِدِ
u'مُخَالَفَةٌ قَوْلٌ':Added, #1: 1	مُخَالَفَةُ قَوْلِ
u'مُخَالَفَةٌ قول':Added, #1: 1	مُخَالَفَةُ قَوْلِ
u'مُخَالَفَةٌ قَوْلٌ':Added, #2: 2	مُخَالَفَةِ الْقَوْلِ
u'مُخَالَفَةٌ قَوْمٌ':Added, #2: 2	مُخَالَفَةِ الْقَوْلِ
u'مُخَالَفَةٌ قِيَاسٌ':Added, #1: 1	مُخَالَفَةَ قَوْمِهِ
u'مُخَالَفَةٌ قِيَاسٌ':Added, #1: 1	مُخَالَفَةَ الْقِيَاسِ
u'مُخَالَفَةٌ قِيَاسٌ':Added, #1: 1	مُخَالَفَةُ قِيَاسٍ
u'مُخَالَفَةٌ كِتَابٌ':Added, #3: 3	مُخَالَفَةِ الْقِيَاسِ
u'مُخَالَفَةٌ كِتَابٌ':Added, #1: 1	مُخَالَفَةَ الْكِتَابِ
u'مُخَالَفَةٌ كِتَابٌ':Added, #1: 1	مُخَالَفَةُ الْكِتَابِ
u'مُخَالَفَةٌ كَلاَمٌ':Added, #2: 2	مُخَالَفَةِ الْكِتَابِ
u'مُخَالَفَةٌ كَلاَمٌ':Added, #1: 1	مُخَالَفَةُ كَلَامِ
u'مُخَالَفَةٌ لَفْظٌ':Added, #3: 3	مُخَالَفَةِ كَلَامِ
u'مُخَالَفَةٌ لَفْظٌ':Added, #1: 1	مُخَالَفَةِ اللَّفْظِ
u'مُخَالَفَةٌ لقطة':Added, #1: 1	مُخَالَفَةِ لَفْظِ
u'مُخَالَفَةٌ مَأْمُورٌ':Added, #1: 1	مُخَالَفَةُ اللُّقَطَةِ
u'مُخَالَفَةٌ مَأْمُورٌ':Added, #1: 1	مُخَالَفَةِ الْمَأْمُورِ
u'مُخَالَفَةٌ مَأْمُورٌ':Added, #1: 1	مُخَالَفَةِ الْمَأْمُورَاتِ
u'مُخَالَفَةٌ متبوع':Added, #1: 1	مُخَالَفَةِ مَأْمُورٍ
u'مُخَالَفَةٌ متبوع':Added, #1: 1	مُخَالَفَةُ الْمَتْبُوعِ
u'مُخَالَفَةٌ مُتَعَلِّقٌ':Added, #1: 1	مُخَالَفَةِ مَتْبُوعِهِ
u'مُخَالَفَةٌ مَذْهَبٌ':Added, #1: 1	مُخَالَفَةِ مُتَعَلِّقِ
u'مُخَالَفَةٌ مراد':Added, #1: 1	مُخَالَفَةِ الْمَذْهَبِ
u'مُخَالَفَةٌ مُرَادٌ':Added, #1: 1	مُخَالَفَةُ الْمُرَادِ
u'مُخَالَفَةٌ مُسْتَحَبٌّ':Added, #1: 1	مُخَالَفَةُ الْمُرَادِ
u'مُخَالَفَةٌ مَسْكُوتٌ':Added, #1: 1	مُخَالَفَةِ الْمُسْتَحَبِّ
u'مُخَالَفَةٌ مَسْكُوتٌ':Added, #1: 1	مُخَالَفَةُ الْمَسْكُوتِ
u'مُخَالَفَةٌ مُسْلِمٌ':Added, #2: 2	مُخَالَفَةِ الْمَسْكُوتِ
u'مُخَالَفَةٌ مُصْحَفٌ':Added, #1: 1	مُخَالَفَةِ مُسْلِمٍ
u'مُخَالَفَةٌ مُضَارِبٌ':Added, #1: 1	مُخَالَفَةُ الْمُصْحَفِ
u'مُخَالَفَةٌ مَظْنُون':Added, #1: 1	مُخَالَفَةِ الْمُضَارِبِ
u'مُخَالَفَةٌ مُعْتَزِلٌ':Added, #1: 1	مُخَالَفَةِ الْمَظْنُونِ
u'مُخَالَفَةٌ مُعْتَزِلَةٌ':Added, #1: 1	مُخَالَفَةَ الْمُعْتَزِلَةِ
u'مُخَالَفَةٌ مَعْهُودٌ':Added, #1: 1	مُخَالَفَةَ الْمُعْتَزِلَةِ
u'مُخَالَفَةٌ مَقْطُوعٌ':Added, #1: 1	مُخَالَفَةِ الْمَعْهُودِ
u'مُخَالَفَةٌ مَلِكٌ':Added, #1: 1	مُخَالَفَةِ الْمَقْطُوعِ
u'مُخَالَفَةٌ مَنْذُور':Added, #1: 1	مُخَالَفَةِ الْمَلِكِ
u'مُخَالَفَةٌ مَنْقُولٌ':Added, #1: 1	مُخَالَفَةِ الْمَنْذُورِ
u'مُخَالَفَةٌ مَوْضِعٌ':Added, #1: 1	مُخَالَفَةُ مَنْقُولِ
u'مُخَالَفَةٌ نَاسٌ':Added, #1: 1	مُخَالَفَةِ الْمَوْضِعَيْنِ
u'مُخَالَفَةٌ نَائِبٌ':Added, #1: 1	مُخَالَفَةُ النَّاسِ
u'مُخَالَفَةٌ نَبِيٌّ':Added, #2: 2	مُخَالَفَةِ النَّائِبِ
u'مُخَالَفَةٌ نَصٌّ':Added, #1: 1	مُخَالَفَةِ النَّبِيِّ
u'مُخَالَفَةٌ نَصٌّ':Added, #2: 2	مُخَالَفَةُ نَصِّ
u'مُخَالَفَةٌ نَصٌّ':Added, #2: 2	مُخَالَفَةِ نَصِّ
u'مُخَالَفَةٌ نُصُوصٌ':Added, #4: 4	مُخَالَفَةِ النَّصِّ
u'مُخَالَفَةٌ نَفْسٌ':Added, #1: 1	مُخَالَفَةِ نُصُوصِ
u'مُخَالَفَةٌ نَفْسٌ':Added, #1: 1	مُخَالَفَةَ النَّفْسِ
u'مُخَالَفَةٌ نِهَايَةٌ':Added, #1: 1	مُخَالَفَةُ النَّفْسِ
u'مُخَالَفَةٌ نَهْيٌ':Added, #1: 1	مُخَالَفَةُ النِّهَايَةِ
u'مُخَالَفَةٌ نِيَّةٌ':Added, #1: 1	مُخَالَفَةَ نَهْيِ
u'مُخَالَفَةٌ وَاجِبٌ':Added, #2: 2	مُخَالَفَةِ النِّيَّةِ
u'مُخَالَفَةٌ وَالِدٌ':Added, #1: 1	مُخَالَفَةِ الْوَاجِبَاتِ
u'مُخَالَفَةٌ وَالِدٌ':Added, #1: 1	مُخَالَفَةِ الْوَالِدِ
u'مُخَالَفَةٌ وِفَاقٌ':Added, #1: 1	مُخَالَفَةِ وَالِدِهِ
u'مُخَالَفَةٌ وَكِيلٌ':Added, #1: 1	مُخَالَفَةِ الْوِفَاقِ
u'مُخَالَفَةٌ وُلاَةٌ':Added, #4: 4	مُخَالَفَةِ الْوَكِيلِ
u'مُخَالَفَةٌ يَمِينٌ':Added, #1: 1	مُخَالَفَةِ وُلَاةِ
u'مُخَالَفَةٌ يَمِينٌ':Added, #1: 1	مُخَالَفَةَ الْيَمِينِ
u'مُخَالَفَةٌ يهود':Added, #1: 1	مُخَالَفَةِ يَمِينِهِ
u'مُخَالَفَةٌ يهود':Added, #1: 1	مُخَالَفَةُ الْيَهُودِ
u'مُخَالَفَةٌ يَهُودٌ':Added, #1: 1	مُخَالَفَةِ الْيَهُودِ
u'مُخَالَفَةٌ يَهُودٌ':Added, #1: 1	مُخَالَفَةُ الْيَهُودِ
u'مُخَامَرَةٌ عَقْلٌ':Added, #1: 1	مُخَالَفَةِ الْيَهُودِ
u'مُخَامَرَةٌ عين':Added, #1: 1	مُخَامَرَةِ الْعَقْلِ
u'مُخَامَرَةٌ عَيْنٌ':Added, #1: 1	مُخَامَرَةِ عَيْنِ
u'مُخَامَرَةٌ عَيْن':Added, #1: 1	مُخَامَرَةِ عَيْنِ
u'مُخَامَرَةٌ نَجَاسَةٌ':Added, #1: 1	مُخَامَرَةِ عَيْنِ
u'مُخَامَرَةٌ نَجَاسَةٌ':Added, #1: 1	مُخَامَرَةُ النَّجَاسَةِ
u'مَخْرَجٌ إِخْبَارٌ':Added, #1: 1	مُخَامَرَةُ نَجَاسَةٍ
u'مَخْرَجٌ إفَادَةٌ':Added, #2: 2	مَخْرَجَ الْإِخْبَارِ
u'مَخْرَجٌ إفْتَاءٌ':Added, #1: 1	مَخْرَجِ إفَادَةِ
u'مَخْرَجٌ إفْسَادٌ':Added, #1: 1	مَخْرَجَ الْإِفْتَاءِ
u'مَخْرَجٌ إكْرَاهٌ':Added, #1: 1	مَخْرَجَ الْإِفْسَادِ
u'مَخْرَجٌ ألف':Added, #1: 1	مَخْرَجَ الْإِكْرَاهِ
u'مَخْرَجٌ أَمْرٌ':Added, #1: 1	مَخْرَجِ الْأَلِفِ
u'مَخْرَجٌ إِنْسانٌ':Added, #5: 5	مَخْرَجَ الْأَمْرِ
u'مَخْرَجٌ إِنْكارٌ':Added, #1: 1	مَخْرَجِ الْإِنْسَانِ
u'مَخْرَجٌ آيَةٌ':Added, #1: 1	مَخْرَجِ الْإِنْكَارِ
u'مَخْرَجٌ إِيجَابٌ':Added, #1: 1	مَخْرَجُ الْآيَةِ
u'مَخْرَجٌ أَيْمَانٌ':Added, #1: 1	مَخْرَجَ الْإِيجَابِ
u'مَخْرَجٌ بَوْلٌ':Added, #1: 1	مَخْرَجَ الأَيْمَانِ
u'مَخْرَجٌ بَوْلٌ':Added, #16: 16	مَخْرَجِ الْبَوْلِ
u'مَخْرَجٌ بَوْلٌ':Added, #4: 4	مَخْرَجَ الْبَوْلِ
u'مَخْرَجٌ بَوْلٌ':Added, #4: 4	مَخْرَجِ بَوْلٍ
u'مَخْرَجٌ بَيَانٌ':Added, #8: 8	مَخْرَجُ الْبَوْلِ
u'مَخْرَجٌ تَحْذِيرٌ':Added, #3: 3	مَخْرَجَ الْبَيَانِ
u'مَخْرَجٌ تَحْقِيقٌ':Added, #1: 1	مَخْرَجَ التَّحْذِيرِ
u'مَخْرَجٌ تَذْكيرٌ':Added, #1: 1	مَخْرَجَ التَّحْقِيقِ
u'مَخْرَجٌ تَشْرِيعٌ':Added, #1: 1	مَخْرَجُ التَّذْكِيرِ
u'مَخْرَجٌ تَشْرِيفٌ':Added, #2: 2	مَخْرَجَ التَّشْرِيعِ
u'مَخْرَجٌ تَعْرِيضٌ':Added, #1: 1	مَخْرَجَ التَّشْرِيفِ
u'مَخْرَجٌ تَعْلِيمٌ':Added, #1: 1	مَخْرَجَ التَّعْرِيضِ
u'مَخْرَجٌ تَعْمِيمٌ':Added, #1: 1	مَخْرَجَ التَّعْلِيمِ
u'مَخْرَجٌ تَفْرِيع':Added, #1: 1	مَخْرَجَ التَّعْمِيمِ
u'مَخْرَجٌ تَفْسِيرٌ':Added, #1: 1	مَخْرَجَ التَّفْرِيعِ
u'مَخْرَجٌ تَقْليدٌ':Added, #1: 1	مَخْرَجَ التَّفْسِيرِ
u'مَخْرَجٌ تَقْليد':Added, #1: 1	مَخْرَجُ التَّقْلِيدِ
u'مَخْرَجٌ تَقْويمٌ':Added, #1: 1	مَخْرَجُ التَّقْلِيدِ
u'مَخْرَجٌ تَكْثيرٌ':Added, #1: 1	مَخْرَجَ التَّقْوِيمِ
u'مَخْرَجٌ تَكْرارٌ':Added, #1: 1	مَخْرَجَ التَّكْثِيرِ
u'مَخْرَجٌ تَمْكِين':Added, #1: 1	مَخْرَجَ تَكْرَارِ
u'مَخْرَجٌ تَهْدِيدٌ':Added, #1: 1	مَخْرَجَ التَّمْكِينِ
u'مَخْرَجٌ تَوْبِيخٌ':Added, #1: 1	مَخْرَجَ التَّهْدِيدِ
u'مَخْرَجٌ جُمْلَةٌ':Added, #1: 1	مَخْرَجَ التَّوْبِيخِ
u'مَخْرَجٌ جَوَابٌ':Added, #1: 1	مَخْرَجَ الْجُمْلَةِ
u'مَخْرَجٌ جَوَابٌ':Added, #1: 1	مَخْرَجُ الْجَوَابِ
u'مَخْرَجٌ حاء':Added, #7: 7	مَخْرَجَ الْجَوَابِ
u'مَخْرَجٌ حاء':Added, #1: 1	مَخْرَجُ الْحَاءِ
u'مَخْرَجٌ حُجَّةٌ':Added, #3: 3	مَخْرَجِ الْحَاءِ
u'مَخْرَجٌ حَدَثٌ':Added, #1: 1	مَخْرَجَ الْحُجَّةِ
u'مَخْرَجٌ حَدَثٌ':Added, #1: 1	مَخْرَجُ الْحَدَثِ
u'مَخْرَجٌ حَديثٌ':Added, #1: 1	مَخْرَجِ الْحَدَثِ
u'مَخْرَجٌ حَديثٌ':Added, #1: 1	مَخْرَجُ الْحَدِيثِ
u'مَخْرَجٌ حَديثٌ':Added, #1: 1	مَخْرَجِ الْحَدِيثِ
u'مَخْرَجٌ حَديثٌ':Added, #1: 1	مَخْرَجُ الْحَدِيثَيْنِ
u'مَخْرَجٌ حَرْفٌ':Added, #3: 3	مَخْرَجِ حَدِيثِهِ
u'مَخْرَجٌ حِكَايَةٌ':Added, #2: 2	مَخْرَجِ حَرْفٍ
u'مَخْرَجٌ حُكْمٌ':Added, #2: 2	مَخْرَجَ الْحِكَايَةِ
u'مَخْرَجٌ حَيْضٌ':Added, #2: 2	مَخْرَجَ الْحُكْمِ
u'مَخْرَجٌ حَيْضٌ':Added, #1: 1	مَخْرَجُ الْحَيْضِ
u'مَخْرَجٌ خَبَرٌ':Added, #2: 2	مَخْرَجِ الْحَيْضِ
u'مَخْرَجٌ خَبَر':Added, #1: 1	مَخْرَجَ الْخَبَرِ
u'مَخْرَجٌ خَمْسَةٌ':Added, #1: 1	مَخْرَجَ الْخَبَرِ
u'مَخْرَجٌ دمع':Added, #1: 1	مَخْرَجِ خَمْسَةٍ
u'مَخْرَجٌ دَمْعٌ':Added, #1: 1	مَخْرَجُ الدَّمْعِ
u'مَخْرَجٌ ذَمٌّ':Added, #1: 1	مَخْرَجُ الدَّمْعِ
u'مَخْرَجٌ رُبُعٌ':Added, #3: 3	مَخْرَجَ الذَّمِّ
u'مَخْرَجٌ رُبُعٌ':Added, #1: 1	مَخْرَجَ الرُّبُعِ
u'مَخْرَجٌ رُبْعٌ':Added, #1: 1	مَخْرَجِ الرُّبُعِ
u'مَخْرَجٌ رِسَالَةٌ':Added, #2: 2	مَخْرَجِ الرُّبْعِ
u'مَخْرَجٌ زُورٌ':Added, #15: 15	مَخْرَجَ الرِّسَالَةِ
u'مَخْرَجٌ سَائِرٌ':Added, #1: 1	مَخْرَجَ الزُّورِ
u'مَخْرَجٌ سُبْعٌ':Added, #1: 1	مَخْرَجُ سَائِرِ
u'مَخْرَجٌ سهام':Added, #1: 1	مَخْرَجِ السُّبْعِ
u'مَخْرَجٌ سِهَامٌ':Added, #1: 1	مَخْرَجِ سِهَامِ
u'مَخْرَجٌ سُؤَالٌ':Added, #1: 1	مَخْرَجِ سِهَامِ
u'مَخْرَجٌ شَرْطٌ':Added, #1: 1	مَخْرَجَ السُّؤَالِ
u'مَخْرَجٌ شَرْعٌ':Added, #9: 9	مَخْرَجَ الشَّرْطِ
u'مَخْرَجٌ شركة':Added, #1: 1	مَخْرَجَ الشَّرْعِ
u'مَخْرَجٌ شَرِكَةٌ':Added, #1: 1	مَخْرَجَ الشَّرِكَةِ
u'مَخْرَجٌ شُرُوطٌ':Added, #1: 1	مَخْرَجَ الشَّرِكَةِ
u'مَخْرَجٌ شكر':Added, #1: 1	مَخْرَجَ الشُّرُوطِ
u'مَخْرَجٌ شُكْرٌ':Added, #1: 1	مَخْرَجَ الشُّكْرِ
u'مَخْرَجٌ شَهَادَةٌ':Added, #1: 1	مَخْرَجَ الشُّكْرِ
u'مَخْرَجٌ طاء':Added, #2: 2	مَخْرَجَ الشَّهَادَةِ
u'مَخْرَجٌ طَاعَةٌ':Added, #1: 1	مَخْرَجِ الطَّاءِ
u'مَخْرَجٌ عَادَةٌ':Added, #2: 2	مَخْرَجَ الطَّاعَاتِ
u'مَخْرَجٌ عِبَادَةٌ':Added, #6: 6	مَخْرَجَ الْعَادَةِ
u'مَخْرَجٌ غَالِبٌ':Added, #1: 1	مَخْرَجَ الْعِبَادَةِ
u'مَخْرَجٌ فاء':Added, #34: 34	مَخْرَجَ الْغَالِبِ
u'مَخْرَجٌ فَرْضٌ':Added, #1: 1	مَخْرَجِ الْفَاءِ
u'مَخْرَجٌ فَرْضٌ':Added, #15: 15	مَخْرَجِ فَرْضِ
u'مَخْرَجٌ فُرُوضٌ':Added, #1: 1	مَخْرَجُ الْفَرْضَيْنِ
u'مَخْرَجٌ قَيْءٌ':Added, #1: 1	مَخْرَجِ فُرُوضٍ
u'مَخْرَجٌ كَثِيرٌ':Added, #2: 2	مَخْرَجُ الْقَيْءِ
u'مَخْرَجٌ كَسْرٌ':Added, #1: 1	مَخْرَجَ الْكَثِيرِ
u'مَخْرَجٌ كَسْرٌ':Added, #1: 1	مَخْرَجَ الْكَسْرِ
u'مَخْرَجٌ كَسْرٌ':Added, #1: 1	مَخْرَجُ الْكَسْرِ
u'مَخْرَجٌ كَسْرٌ':Added, #1: 1	مَخْرَجِ الْكَسْرِ
u'مَخْرَجٌ كُسُورٌ':Added, #1: 1	مَخْرَجِ كَسْرٍ
u'مَخْرَجٌ كُسُورٌ':Added, #1: 1	مَخْرَجِ الْكُسُورِ
u'مَخْرَجٌ كَلاَمٌ':Added, #2: 2	مَخْرَجَ الْكُسُورِ
u'مَخْرَجٌ كَلاَمٌ':Added, #1: 1	مَخْرَجِ الْكَلَامِ
u'مَخْرَجٌ لاَمٌ':Added, #1: 1	مَخْرَجُ كَلَامِ
u'مَخْرَجٌ لبن':Added, #2: 2	مَخْرَجِ اللّامِ
u'مَخْرَجٌ لَبَنٌ':Added, #2: 2	مَخْرَجَ اللَّبَنِ
u'مَخْرَجٌ لجاج':Added, #2: 2	مَخْرَجَ اللَّبَنِ
u'مَخْرَجٌ مَاءٌ':Added, #1: 1	مَخْرَجَ اللَّجَاجِ
u'مَخْرَجٌ مَاءٌ':Added, #1: 1	مَخْرَجَ الْمَاءِ
u'مَخْرَجٌ مَالٌ':Added, #2: 2	مَخْرَجُ الْمَاءِ
u'مَخْرَجٌ مُحَاذَاةٌ':Added, #1: 1	مَخْرَجِ الْمَالِ
u'مَخْرَجٌ مَخْصُوصٌ':Added, #1: 1	مَخْرَجَ الْمُحَاذَاةِ
u'مَخْرَجٌ مَدْحٌ':Added, #1: 1	مَخْرَجٍ مَخْصُوصٍ
u'مَخْرَجٌ مُذَاكَرَةٌ':Added, #4: 4	مَخْرَجَ الْمَدْحِ
u'مَخْرَجٌ مَسْأَلَةٌ':Added, #1: 1	مَخْرَجَ الْمُذَاكَرَةِ
u'مَخْرَجٌ مَسْأَلَةٌ':Added, #1: 1	مَخْرَجَ مَسْأَلَةِ
u'مَخْرَجٌ مُعْجَمَةٌ':Added, #3: 3	مَخْرَجِ مَسْأَلَةِ
u'مَخْرَجٌ مُمَانَعَةٌ':Added, #1: 1	مَخْرَجِ الْمُعْجَمَةِ
u'مَخْرَجٌ مَنِيٌّ':Added, #1: 1	مَخْرَجَ الْمُمَانَعَةِ
u'مَخْرَجٌ مَنِيٌّ':Added, #1: 1	مَخْرَجِ الْمَنِيِّ
u'مَخْرَجٌ نذر':Added, #2: 2	مَخْرَجُ الْمَنِيِّ
u'مَخْرَجٌ نَذْرٌ':Added, #1: 1	مَخْرَجَ النَّذْرِ
u'مَخْرَجٌ نِصْفٌ':Added, #1: 1	مَخْرَجَ النَّذْرِ
u'مَخْرَجٌ نِصْفٌ':Added, #2: 2	مَخْرَجَ النِّصْفِ
u'مَخْرَجٌ نَهْيٌ':Added, #2: 2	مَخْرَجِ النِّصْفِ
u'مَخْرَجٌ نَوْحٌ':Added, #1: 1	مَخْرَجَ النَّهْيِ
u'مَخْرَجٌ هاء':Added, #2: 2	مَخْرَجَ النَّوْحِ
u'مَخْرَجٌ واحد':Added, #1: 1	مَخْرَجُ الْهَاءِ
u'مَخْرَجٌ وَاحِدٌ':Added, #3: 3	مَخْرَجٍ وَاحِدٍ
u'مَخْرَجٌ وَصِيٌّ':Added, #3: 3	مَخْرَجٍ وَاحِدٍ
u'مَخْرَجٌ وَصِيٌّ':Added, #1: 1	مَخْرَجِ الْوَصِيِّ
u'مَخْرَجٌ وَصِيٌّ':Added, #1: 1	مَخْرَجُ الْوَصِيَّتَيْنِ
u'مَخْرَجٌ وَصِيٌّ':Added, #1: 1	مَخْرَجِ الْوَصِيَّتَيْنِ
u'مَخْرَجٌ وَصِيٌّ':Added, #2: 2	مَخْرَجِ الْوَصِيَّةِ
u'مَخْرَجٌ وَصِيَّةٌ':Added, #7: 7	مَخْرَجَ الْوَصِيَّةِ
u'مَخْرَجٌ وَصِيَّةٌ':Added, #2: 2	مَخْرَجِ الْوَصِيَّةِ
u'مَخْرَجٌ وَضْعٌ':Added, #7: 7	مَخْرَجَ الْوَصِيَّةِ
u'مَخْرَجٌ وَعْدٌ':Added, #1: 1	مَخْرَجَ الْوَضْعِ
u'مَخْرَجٌ ولد':Added, #5: 5	مَخْرَجَ الْوَعْدِ
u'مَخْرَجٌ وَلَدٌ':Added, #1: 1	مَخْرَجِ الْوَلَدِ
u'مَخْرَجٌ يَمِينٌ':Added, #1: 1	مَخْرَجِ الْوَلَدِ
u'مَخْرَجٌ يَمِينٌ':Added, #2: 2	مَخْرَجَ الْيَمِينِ
u'مَخْضٌ زِقٌّ':Added, #3: 3	مَخْرَجِ يَمِينِهِ
u'مُدَاخَلَةٌ لبن':Added, #1: 1	مَخْضَ الزِّقِّ
u'مُدَاخَلَةٌ لَبِنٌ':Added, #1: 1	مُدَاخَلَةُ اللَّبِنِ
u'مُدَاخَلَةٌ لبن':Added, #1: 1	مُدَاخَلَةُ اللَّبِنِ
u'مُدَاخَلَةٌ لَبِنٌ':Added, #2: 2	مُدَاخَلَةُ لَبِنِ
u'مُدَاخَلَةٌ مَاءٌ':Added, #2: 2	مُدَاخَلَةُ لَبِنِ
u'مُدَاخَلَةٌ نَاسٌ':Added, #1: 1	مُدَاخَلَةُ الْمَاءِ
u'مُدَارَاةٌ شُؤُونٌ':Added, #1: 1	مُدَاخَلَةِ النَّاسِ
u'مُدَارَاةٌ نَاسٌ':Added, #1: 1	مُدَارَاةُ الشُّؤُونِ
u'مُدَارَسَةٌ قُرْآنٌ':Added, #5: 5	مُدَارَاةُ النَّاسِ
u'مُدَافَعَةٌ أحَدٌ':Added, #1: 1	مُدَارَسَةُ الْقُرْآنِ
u'مُدَافَعَةٌ أَخْبَثٌ':Added, #3: 3	مُدَافَعَةِ أَحَدِ
u'مُدَافَعَةٌ اِسْتِقْرارٌ':Added, #5: 5	مُدَافَعَةِ الْأَخْبَثَيْنِ
u'مُدَافَعَةٌ بَوْلٌ':Added, #1: 1	مُدَافَعَةَ اسْتِقْرَارِ
u'مُدَافَعَةٌ حَدَثٌ':Added, #1: 1	مُدَافَعَةِ الْبَوْلِ
u'مُدَافَعَةٌ حَدَثٌ':Added, #1: 1	مُدَافَعَةُ الْحَدَثِ
u'مُدَافَعَةٌ حُكْمٌ':Added, #2: 2	مُدَافَعَةِ الْحَدَثِ
u'مُدَافَعَةٌ ريحٌ':Added, #1: 1	مُدَافَعَةُ حُكْمِهِ
u'مُدَافَعَةٌ فِعْلٌ':Added, #1: 1	مُدَافَعَةَ الرِّيحِ
u'مُدَافَعَةٌ مُطَالِبٌ':Added, #1: 1	مُدَافَعَةِ الْفِعْلِ
u'مَدَّ ألف':Predicate, #1: 1	مُدَافَعَةِ الْمُطَالِبِ
u'مَدَّ الْمَرْأَةُ':Predicate, #6: 6	مَدَّ أَلِفَ
u'مَدَّ إمَامٌ':Subject, #1: 1	مَدَّ الْمَرْأَةَ
u'مَدَّ أهْلٌ':Subject, #3: 3	مَدَّ الْإِمَامُ
u'مُدَاوَاةٌ أَمْرَاضٌ':Added, #1: 1	أَمَدَّ أَهْلُ
u'مُدَاوَاةٌ جِرَاحَاتٌ':Added, #1: 1	مُدَاوَاةُ الْأَمْرَاضِ
u'مُدَاوَاةٌ جِرَاحَةٌ':Added, #1: 1	مُدَاوَاةَ الْجِرَاحَاتِ
u'مُدَاوَاةٌ جُرْحٌ':Added, #1: 1	مُدَاوَاةَ الْجِرَاحَاتِ
u'مُدَاوَاةٌ دُبُرٌ':Added, #1: 1	مُدَاوَاةَ الْجُرْحِ
u'مُدَاوَاةٌ قرح':Added, #1: 1	مُدَاوَاةِ الدُّبُرِ
u'مُدَاوَاةٌ مَاشِي':Added, #1: 1	مُدَاوَاةُ قُرْحِهِ
u'مُدَاوَاةٌ مَاشِيَةٌ':Added, #1: 1	مُدَاوَاةُ مَاشِيَةٍ
u'مُدَاوَاةٌ مَرِيضٌ':Added, #1: 1	مُدَاوَاةُ مَاشِيَةٍ
u'مُدَاوَمَةٌ أكل':Added, #1: 1	مُدَاوَاةَ الْمَرِيضِ
u'مُدَاوَمَةٌ أَكْلٌ':Added, #1: 1	مُدَاوَمَةُ أَكْلِ
u'مُدَاوَمَةٌ عَمَلٌ':Added, #1: 1	مُدَاوَمَةُ أَكْلِ
u'مُدَاوَمَةٌ قيام':Added, #1: 1	مُدَاوَمَةِ الْعَمَلِ
u'مُدَاوَمَةٌ قِيَامٌ':Added, #1: 1	مُدَاوَمَةُ قِيَامِ
u'مُدَاوَمَةٌ لَحْمٌ':Added, #1: 1	مُدَاوَمَةُ قِيَامِ
u'مُدَاوَمَةٌ مَشْيٌ':Added, #1: 1	مُدَاوَمَةُ اللَّحْمِ
u'مُدَاوَمَةٌ نَظَرٌ':Added, #1: 1	مُدَاوَمَةِ الْمَشْيِ
u'مُدَاوَمَةٌ نَظَرٌ':Added, #1: 1	مُدَاوَمَةَ النَّظَرِ
u'مُدَاوَمَةٌ نَوْعٌ':Added, #1: 1	مُدَاوَمَةِ النَّظَرِ
u'مَدَّ تَحْرِيمٌ':Predicate, #2: 2	مُدَاوَمَةَ النَّوْعِ
u'مَدْحٌ اِبْنٌ':Added, #1: 1	مَدَّ التَّحْرِيمَ
u'مَدْحٌ إِخْلاَصٌ':Added, #1: 1	مَدْحِ ابْنِ
u'مَدْحٌ أَمينٌ':Added, #1: 1	مَدْحِ الْإِخْلَاصِ
u'مَدْحٌ بَعْضٌ':Added, #1: 1	مَدْحَ الْأَمِينِ
u'مَدَحَ بَيَانٌ':Predicate, #1: 1	مَدْحَ بَعْضٍ
u'مَدَحَ حَديثٌ':Predicate, #1: 1	مَدَحَ الْبَيَانَ
u'مَدَحَ رَجُلٌ':Subject, #1: 1	مَدَحَ الْحَدِيثَ
u'مَدْحٌ رَجُلٌ':Added, #1: 1	مَدَحَ رَجُلٌ
u'مَدْحٌ رَجُلٌ':Added, #1: 1	مَدْحُ الرَّجُلِ
u'مَدْحٌ رَسُولٌ':Added, #1: 1	مَدْحِ رَجُلٍ
u'مَدْحٌ رَسُولٌ':Added, #1: 1	مَدْحِ الرّسُولِ
u'مَدَحَ سَاجِدٌ':Predicate, #2: 2	مَدْحِ رَسُولِ
u'مَدْحٌ سَخَاءٌ':Added, #1: 1	مَدَحَ السَّاجِدِينَ
u'مَدْحٌ شَرْعٌ':Added, #1: 1	مَدْحِ السَّخَاءِ
u'مَدْحٌ شِعْرٌ':Added, #1: 1	مَدْحَ الشَّرْعِ
u'مَدْحٌ صَبْوَةٌ':Added, #1: 1	مَدْحِ الشِّعْرِ
u'مَدَحَ صَحَابَةٌ':Predicate, #1: 1	مَدْحِ الصَّبْوَةِ
u'مَدْحٌ طعام':Added, #1: 1	مَدَحَ الصَّحَابَةَ
u'مَدْحٌ طَعَامٌ':Added, #1: 1	مَدْحُ طَعَامِهِ
u'مَدْحٌ ظلمة':Added, #1: 1	مَدْحُ طَعَامِهِ
u'مَدْحٌ ظلمة':Added, #1: 1	مَدْحَ الظَّلَمَةِ
u'مَدْحٌ عُمُومٌ':Added, #1: 1	مَدْحِ الظَّلَمَةِ
u'مَدَحَ فلان':Predicate, #1: 1	مَدْحِ عُمُومِ
u'مَدْحٌ فلان':Added, #1: 1	مَدَحَ الْمُوفِينَ
u'مَدَحَ قَالٌ':Predicate, #1: 1	مَدْحِ حَاتِمٍ
u'مَدْحٌ قَوْمٌ':Added, #1: 1	مَدَحَ قَالَ
u'مَدْحٌ قَوْمٌ':Added, #1: 1	مَدْحُ قَوْمٍ
u'مَدَّ حَمْز':Predicate, #1: 1	مَدْحِ قَوْمٍ
u'مَدْحٌ مُصِيبٌ':Added, #2: 2	مَدَّ حَمْزَةَ
u'مَدْحٌ مُصِيبٌ':Added, #1: 1	مَدْحِ الْمُصِيبِ
u'مَدْحٌ مُطْلَقٌ':Added, #5: 5	مَدْحُ الْمُصِيبِ
u'مَدْحٌ نَاسٌ':Added, #1: 1	مَدْحِ مُطْلَقِ
u'مَدْحٌ نَاسٌ':Added, #1: 1	مَدْحَ النَّاسِ
u'مَدْحٌ نَبِيٌّ':Added, #1: 1	مَدْحِ النَّاسِ
u'مَدْحٌ نَفْسٌ':Added, #1: 1	مَدْحِ النَّبِيِّ
u'مَدَّ رِجْلٌ':Predicate, #1: 1	مَدْحَ النَّفْسِ
u'مَدَّ ركعة':Predicate, #1: 1	مَدَّ الرِّجْلَ
u'مَدَّ رَكْعَةٌ':Predicate, #1: 1	مَدَّ الرَّكْعَةَ
u'مَدَّ عَبْدٌ':Subject, #1: 1	مَدَّ الرَّكْعَةَ
u'مَدَّ فلان':Predicate, #1: 1	مَدَّ عَبْدٌ
u'مَدَّ مَاءٌ':Predicate, #2: 2	مَدَّ حَمْزَةَ
u'مَدَّ مَجُوسِيٌّ':Subject, #2: 2	مَدَّ الْمَاءَ
u'مَدَّ مِقْوَدٌ':Predicate, #1: 1	مَدَّ الْمَجُوسِيُّ
u'مَدَّ همزة':Predicate, #2: 2	مَدَّ الْمِقْوَدَ
u'مَدَّ هَمْزَةٌ':Predicate, #1: 1	مَدَّ هَمْزَةَ
u'مَدَّ همزة':Predicate, #1: 1	مَدَّ هَمْزَةَ
u'مَدَّ هَمْزَةٌ':Predicate, #2: 2	مَدَّ الْهَمْزَةَ
u'مَدَّ وَقْت':Predicate, #2: 2	مَدَّ الْهَمْزَةَ
u'مَدَّ وَقْتِيّ':Predicate, #1: 1	مَدَّ الْوَقْتِيَّةَ
u'مُذَاكَرَةٌ حَديثٌ':Added, #1: 1	مَدَّ الْوَقْتِيَّةَ
u'مُذَاكَرَةٌ رِجَالٌ':Added, #1: 1	مُذَاكَرَةُ الْحَدِيثِ
u'مُذَاكَرَةٌ طَلاَقٌ':Added, #1: 1	مُذَاكَرَةُ الرِّجَالِ
u'مُذَاكَرَةٌ طَلاَقٌ':Added, #1: 1	مُذَاكَرَةُ الطَّلَاقِ
u'مُذَاكَرَةٌ طَلاَقٌ':Added, #3: 3	مُذَاكَرَةَ الطَّلَاقِ
u'مُذَاكَرَةٌ علم':Added, #56: 56	مُذَاكَرَةِ الطَّلَاقِ
u'مُذَاكَرَةٌ عِلْمٌ':Added, #2: 2	مُذَاكَرَةُ الْعِلْمِ
u'مُذَاكَرَةٌ علم':Added, #2: 2	مُذَاكَرَةُ الْعِلْمِ
u'مُذَاكَرَةٌ عِلْمٌ':Added, #4: 4	مُذَاكَرَةِ الْعِلْمِ
u'مَذَلَّةٌ عُبُودِيَّةٌ':Added, #4: 4	مُذَاكَرَةِ الْعِلْمِ
u'مَذَمَّةٌ حالٌ':Added, #1: 1	مَذَلَّةَ الْعُبُودِيَّةِ
u'مَذَمَّةٌ رضاع':Added, #1: 1	مَذَمَّةِ الْحَالَيْنِ
u'مَذَمَّةٌ سُنَّةٌ':Added, #3: 3	مَذَمَّةَ الرَّضَاعِ
u'مَذَمَّةٌ غِيبَةٌ':Added, #1: 1	مَذَمَّةَ سُنَّةٍ
u'مَذَمَّةٌ غير':Added, #2: 2	مَذَمَّةِ الْغِيبَةِ
u'مَذَمَّةٌ غَيْرٌ':Added, #1: 1	مَذَمَّةِ غَيْرِهِ
u'مَرَّ اِبْنٌ':Subject, #1: 1	مَذَمَّةِ غَيْرِهِ
u'مَرَّ إِبْهَامٌ':Predicate, #5: 5	مَرَّ ابْنُ
u'مَرَّ إِثْبَاتٌ':Subject, #1: 1	أَمَرَّ إبْهَامَ
u'مُرَاجَعَةٌ أحَدٌ':Added, #1: 1	مَرَّ إثْبَاتٌ
u'مُرَاجَعَةٌ أقارب':Added, #1: 1	مُرَاجَعَةِ أَحَدٍ
u'مُرَاجَعَةٌ الْمَرْأَةُ':Added, #1: 1	مُرَاجَعَةُ أَقَارِبِهِ
u'مُرَاجَعَةٌ إمَامٌ':Added, #1: 1	مُرَاجَعَةَ الْمَرْأَةِ
u'مُرَاجَعَةٌ إمَامٌ':Added, #1: 1	مُرَاجَعَةُ الْإِمَامِ
u'مُرَاجَعَةٌ أمَةٌ':Added, #2: 2	مُرَاجَعَةِ الْإِمَامِ
u'مُرَاجَعَةٌ بَائِعٌ':Added, #2: 2	مُرَاجَعَةُ الْأَمَةِ
u'مُرَاجَعَةٌ ثَالِثٌ':Added, #1: 1	مُرَاجَعَةُ الْبَائِعِ
u'مُرَاجَعَةٌ حارِثٌ':Added, #1: 1	مُرَاجَعَةِ ثَالِثِ
u'مُرَاجَعَةٌ حاكِمٌ':Added, #1: 1	مُرَاجَعَةَ الْحَارِثِ
u'مُرَاجَعَةٌ حاكِمٌ':Added, #1: 1	مُرَاجَعَةِ الْحَاكِمِ
u'مُرَاجَعَةٌ حاكِمٌ':Added, #2: 2	مُرَاجَعَةُ الْحَاكِمِ
u'مُرَاجَعَةٌ رَاهِنٌ':Added, #2: 2	مُرَاجَعَةِ حَاكِمٍ
u'مُرَاجَعَةٌ رَجُلٌ':Added, #1: 1	مُرَاجَعَةِ الرَّاهِنِ
u'مُرَاجَعَةٌ زَوْجٌ':Added, #1: 1	مُرَاجَعَةُ الرَّجُلِ
u'مُرَاجَعَةٌ زَوْجَةٌ':Added, #1: 1	مُرَاجَعَةِ الزَّوْجِ
u'مُرَاجَعَةٌ زَوْجَةٌ':Added, #1: 1	مُرَاجَعَةُ الزَّوْجَةِ
u'مُرَاجَعَةٌ سُلْطَانٌ':Added, #1: 1	مُرَاجَعَةُ زَوْجَتِهِ
u'مُرَاجَعَةٌ شَرْحٌ':Added, #2: 2	مُرَاجَعَةُ السُّلْطَانِ
u'مُرَاجَعَةٌ شَرِيكٌ':Added, #1: 1	مُرَاجَعَةِ شَرْحِ
u'مُرَاجَعَةٌ شَيْخٌ':Added, #1: 1	مُرَاجَعَةُ الشَّرِيكِ
u'مُرَاجَعَةٌ صَاحِبٌ':Added, #1: 1	مُرَاجَعَةِ شَيْخِهِ
u'مُرَاجَعَةٌ علماء':Added, #1: 1	مُرَاجَعَةِ صَاحِبِ
u'مُرَاجَعَةٌ عُلَمَاءُ':Added, #1: 1	مُرَاجَعَةِ الْعُلَمَاءِ
u'مُرَاجَعَةٌ علماء':Added, #1: 1	مُرَاجَعَةِ الْعُلَمَاءِ
u'مُرَاجَعَةٌ عُلَمَاءُ':Added, #1: 1	مُرَاجَعَةُ عُلَمَاءِ
u'مُرَاجَعَةٌ غَائِبٌ':Added, #1: 1	مُرَاجَعَةُ عُلَمَاءِ
u'مُرَاجَعَةٌ فُضُولِيٌّ':Added, #1: 1	مُرَاجَعَةِ الْغَائِبِ
u'مُرَاجَعَةٌ فِقْهٌ':Added, #2: 2	مُرَاجَعَةَ الْفُضُولِيِّ
u'مُرَاجَعَةٌ فلان':Added, #1: 1	مُرَاجَعَةِ الْفِقْهِ
u'مُرَاجَعَةٌ فلان':Added, #1: 1	مُرَاجَعَةُ الْمُتَصَدِّقِ
u'مُرَاجَعَةٌ كُتُبٌ':Added, #1: 1	مُرَاجَعَةِ الْمُتَصَدِّقِ
u'مُرَاجَعَةٌ كَلاَمٌ':Added, #1: 1	مُرَاجَعَةِ كُتُبِ
u'مُرَاجَعَةٌ كَلاَمٌ':Added, #1: 1	مُرَاجَعَةِ كَلَامِ
u'مُرَاجَعَةٌ مَالِكٌ':Added, #1: 1	مُرَاجَعَةِ كَلَامِهِ
u'مُرَاجَعَةٌ مُتَصَدِّق':Added, #1: 1	مُرَاجَعَةِ الْمَالِكِ
u'مُرَاجَعَةٌ مُتَصَدِّق':Added, #1: 1	مُرَاجَعَةُ الْمُتَصَدِّقِ
u'مُرَاجَعَةٌ مُطَوَّلٌ':Added, #1: 1	مُرَاجَعَةِ الْمُتَصَدِّقِ
u'مُرَاجَعَةٌ نسخة':Added, #1: 1	مُرَاجَعَةِ الْمُطَوَّلَاتِ
u'مُرَاجَعَةٌ نُسْخَةٌ':Added, #1: 1	مُرَاجَعَةِ نُسْخَةٍ
u'مُرَاجَعَةٌ نَفْسٌ':Added, #1: 1	مُرَاجَعَةِ نُسْخَةٍ
u'مُرَاجَعَةٌ وَارِثٌ':Added, #1: 1	مُرَاجَعَةِ نَفْسِهِ
u'مُرَاجَعَةٌ وَاقِفٌ':Added, #1: 1	مُرَاجَعَةِ الْوَارِثِ
u'مُرَاجَعَةٌ وَاقِفٌ':Added, #1: 1	مُرَاجَعَةَ الْوَاقِفِ
u'مُرَاجَعَةٌ وَلِيٌّ':Added, #2: 2	مُرَاجَعَةُ الْوَاقِفِ
u'مَرَّ أَجَلٌ':Subject, #1: 1	مُرَاجَعَةِ الْوَلِيِّ
u'مَرَّ إِجْمَاعٌ':Subject, #1: 1	مَرَّ الأَجَلُ
u'مَرَّ اِخْتِلاَفٌ':Subject, #1: 1	مَرَّ الْإِجْمَاعُ
u'مَرَّ آخِرُ':Predicate, #1: 1	مَرَّ اخْتِلَافُ
u'مَرَارَةٌ أَشْيَاءٌ':Added, #4: 4	مَرَّ آخِرَ
u'مَرَارَةٌ بَأْساءُ':Added, #2: 2	مَرَارَةَ الْأَشْيَاءِ
u'مَرَارَةٌ حَبْسٌ':Added, #1: 1	مَرَارَةَ الْبَأْسَاءِ
u'مَرَارَةٌ حَيَوَانٌ':Added, #1: 1	مَرَارَةِ الْحَبْسِ
u'مَرَارَةٌ سَاعَةٌ':Added, #1: 1	مَرَارَةَ حَيَوَانٍ
u'مَرَارَةٌ صبر':Added, #1: 1	مَرَارَةَ سَاعَةٍ
u'مَرَارَةٌ صَبْرٌ':Added, #2: 2	مَرَارَةَ الصَّبْرِ
u'مَرَارَةٌ غُصَصٌ':Added, #2: 2	مَرَارَةَ الصَّبْرِ
u'مَرَارَةٌ غَنَمٌ':Added, #1: 1	مَرَارَةَ غُصَصِهِ
u'مَرَارَةٌ مَبِيعٌ':Added, #1: 1	مَرَارَةِ الْغَنَمِ
u'مَرَّ إِزَالَةٌ':Subject, #1: 1	مَرَارَةِ الْمَبِيعِ
u'مَرَّ اِسْتِثْنَاءٌ':Subject, #1: 1	مَرَّ إزَالَةُ
u'مَرَّ اِسْتِدْلاَلٌ':Subject, #1: 1	مَرَّ اسْتِثْنَاءُ
u'مَرَّ اِسْتِلْزامٌ':Subject, #1: 1	مَرَّ اسْتِدْلَالُ
u'مُرَاسَلَةٌ حاكِمٌ':Added, #1: 1	مَرَّ اسْتِلْزَامُ
u'مُرَاسَلَةٌ حاكِمٌ':Added, #1: 1	مُرَاسَلَةِ الْحَاكِمِ
u'مَرَّ إشارَة':Subject, #1: 1	مُرَاسَلَةَ حَاكِمٍ
u'مراض أَعْمَالٌ':Added, #2: 2	مَرَّ إشَارَةٌ
u'مراض حَلْقٌ':Added, #1: 1	أَمْرَاضِ الْأَعْمَالِ
u'مراض خُلَفَاءُ':Added, #1: 1	أَمْرَاضِ الْحَلْقِ
u'مراض رَأْسٌ':Added, #1: 1	أَمْرَاضِ الْخُلَفَاءِ
u'مراض شَبابٌ':Added, #1: 1	أَمْرَاضِ الرَّأْسِ
u'مراض شَبَابٌ':Added, #1: 1	أَمْرَاضِ الشَّبَابِ
u'مراض عَصَبٌ':Added, #1: 1	أَمْرَاضِ الشَّبَابِ
u'مراض عين':Added, #1: 1	أَمْرَاضِ الْعَصَبِ
u'مراض عَيْنٌ':Added, #1: 1	أَمْرَاضِ الْعَيْنِ
u'مراض عَيْن':Added, #1: 1	أَمْرَاضِ الْعَيْنِ
u'مراض قلب':Added, #1: 1	أَمْرَاضِ الْعَيْنِ
u'مراض قَلْبٌ':Added, #1: 1	أَمْرَاضِ الْقَلْبِ
u'مراض قَلْب':Added, #1: 1	أَمْرَاضِ الْقَلْبِ
u'مراض قُلُوبٌ':Added, #1: 1	أَمْرَاضِ الْقَلْبِ
u'مُرَاعَاةٌ أَبْعَدُ':Added, #3: 3	أَمْرَاضِ الْقُلُوبِ
u'مُرَاعَاةٌ أحَدٌ':Added, #1: 1	مُرَاعَاةُ الْأَبْعَدِ
u'مُرَاعَاةٌ أَحْوالٌ':Added, #1: 1	مُرَاعَاةُ أَحَدِ
u'مُرَاعَاةٌ أحْوَالٌ':Added, #1: 1	مُرَاعَاةُ الْأَحْوَالِ
u'مُرَاعَاةٌ آخِرُ':Added, #1: 1	مُرَاعَاةُ الْأَحْوَالِ
u'مُرَاعَاةٌ أَخَصُّ':Added, #1: 1	مُرَاعَاةِ آخِرِ
u'مُرَاعَاةٌ إِشْرافٌ':Added, #1: 1	مُرَاعَاةِ الْأَخَصِّ
u'مُرَاعَاةٌ أَصْلَحُ':Added, #1: 1	مُرَاعَاةِ الْإِشْرَافِ
u'مُرَاعَاةٌ أَفْعَالٌ':Added, #1: 1	مُرَاعَاةُ الْأَصْلَحِ
u'مُرَاعَاةٌ أقْرَبُ':Added, #1: 1	مُرَاعَاةُ أَفْعَالِ
u'مُرَاعَاةٌ أَكْثَرُ':Added, #2: 2	مُرَاعَاةُ الْأَقْرَبِ
u'مُرَاعَاةٌ أَلْفَاظٌ':Added, #2: 2	مُرَاعَاةُ أَكْثَرِ
u'مُرَاعَاةٌ أَلْفَاظٌ':Added, #1: 1	مُرَاعَاةَ الْأَلْفَاظِ
u'مُرَاعَاةٌ ألَمٌ':Added, #4: 4	مُرَاعَاةِ الْأَلْفَاظِ
u'مُرَاعَاةٌ أمَانٌ':Added, #1: 1	مُرَاعَاةِ الْأَلَمِ
u'مُرَاعَاةٌ أَمْرٌ':Added, #1: 1	مُرَاعَاةُ الْأَمَانِ
u'مُرَاعَاةٌ أَوْقَاتٌ':Added, #1: 1	مُرَاعَاةَ أَمْرٍ
u'مُرَاعَاةٌ أَوَّلُ':Added, #1: 1	مُرَاعَاةِ الْأَوْقَاتِ
u'مُرَاعَاةٌ أَوَّلِيٌّ':Added, #1: 1	مُرَاعَاةُ أَوَّلِ
u'مُرَاعَاةٌ بَرٌّ':Added, #1: 1	مُرَاعَاةِ الْأَوَّلِيَّةِ
u'مُرَاعَاةٌ تَتَابُعٌ':Added, #1: 1	مُرَاعَاةِ الْبَرِّ
u'مُرَاعَاةٌ تَحَمُّلٌ':Added, #1: 1	مُرَاعَاةِ التَّتَابُعِ
u'مُرَاعَاةٌ تَخْفِيفٌ':Added, #1: 1	مُرَاعَاةَ تَحَمُّلِ
u'مُرَاعَاةٌ تَدْرِيجٌ':Added, #1: 1	مُرَاعَاةِ التَّخْفِيفِ
u'مُرَاعَاةٌ تَرْتِيبٌ':Added, #1: 1	مُرَاعَاةُ التَّدْرِيجِ
u'مُرَاعَاةٌ تَرْتِيبٌ':Added, #19: 19	مُرَاعَاةَ التَّرْتِيبِ
u'مُرَاعَاةٌ تَرْتِيبٌ':Added, #1: 1	مُرَاعَاةُ تَرْتِيبِ
u'مُرَاعَاةٌ تَرْتِيبٌ':Added, #2: 2	مُرَاعَاةَ تَرْتِيبِ
u'مُرَاعَاةٌ تَرْتِيبٌ':Added, #2: 2	مُرَاعَاةُ تَرْتِيبٍ
u'مُرَاعَاةٌ تَرْتِيبٌ':Added, #53: 53	مُرَاعَاةُ التَّرْتِيبِ
u'مُرَاعَاةٌ تَسْوِيَةٌ':Added, #7: 7	مُرَاعَاةِ التَّرْتِيبِ
u'مُرَاعَاةٌ تَعْيِينٌ':Added, #2: 2	مُرَاعَاةُ التَّسْوِيَةِ
u'مُرَاعَاةٌ تَفاوُت':Added, #1: 1	مُرَاعَاةِ تَعْيِينِ
u'مُرَاعَاةٌ تَقْليلٌ':Added, #1: 1	مُرَاعَاةِ التَّفَاوُتِ
u'مُرَاعَاةٌ تُهَمٌ':Added, #1: 1	مُرَاعَاةُ تَقْلِيلِ
u'مُرَاعَاةٌ ثُبُوتٌ':Added, #1: 1	مُرَاعَاةِ التُّهَمِ
u'مُرَاعَاةٌ ثَمَنٌ':Added, #1: 1	مُرَاعَاةِ ثُبُوتِ
u'مُرَاعَاةٌ جَانِبٌ':Added, #1: 1	مُرَاعَاةِ الثَّمَنِ
u'مُرَاعَاةٌ جَانِبٌ':Added, #1: 1	مُرَاعَاةَ الْجَانِبَيْنِ
u'مُرَاعَاةٌ جَانِبٌ':Added, #1: 1	مُرَاعَاةُ الْجَانِبَيْنِ
u'مُرَاعَاةٌ جَانِبٌ':Added, #1: 1	مُرَاعَاةِ جَانِبِ
u'مُرَاعَاةٌ جَانِبٌ':Added, #1: 1	مُرَاعَاةِ جَانِبِهِ
u'مُرَاعَاةٌ جَمَاعَةٌ':Added, #3: 3	مُرَاعَاةُ جَانِبِ
u'مُرَاعَاةٌ جِنْسٌ':Added, #1: 1	مُرَاعَاةُ الْجَمَاعَةِ
u'مُرَاعَاةٌ جِنْسِيٌّ':Added, #1: 1	مُرَاعَاةِ الْجِنْسِ
u'مُرَاعَاةٌ جِهَةٌ':Added, #1: 1	مُرَاعَاةِ الْجِنْسِيَّةِ
u'مُرَاعَاةٌ جَوْهَرٌ':Added, #1: 1	مُرَاعَاةَ جِهَةٍ
u'مُرَاعَاةٌ حالٌ':Added, #1: 1	مُرَاعَاةُ جَوْهَرِ
u'مُرَاعَاةٌ حالٌ':Added, #1: 1	مُرَاعَاةَ حَالِ
u'مُرَاعَاةٌ حُرْمَةٌ':Added, #1: 1	مُرَاعَاةُ حَالِ
u'مُرَاعَاةٌ حُرْمَةٌ':Added, #1: 1	مُرَاعَاةِ الْحُرْمَةِ
u'مُرَاعَاةٌ حَقٌّ':Added, #1: 1	مُرَاعَاةُ حُرْمَةِ
u'مُرَاعَاةٌ حَقٌّ':Added, #1: 1	مُرَاعَاةُ الْحَقِّ
u'مُرَاعَاةٌ حُقٌّ':Added, #1: 1	مُرَاعَاةُ الْحَقَّيْنِ
u'مُرَاعَاةٌ حَقٌّ':Added, #1: 1	مُرَاعَاةُ الْحُقَّيْنِ
u'مُرَاعَاةٌ حَقٌّ':Added, #1: 1	مُرَاعَاةَ حَقِّ
u'مُرَاعَاةٌ حَقٌّ':Added, #1: 1	مُرَاعَاةُ حَقِّ
u'مُرَاعَاةٌ حَقٌّ':Added, #2: 2	مُرَاعَاةِ الْحَقِّ
u'مُرَاعَاةٌ حَقٌّ':Added, #3: 3	مُرَاعَاةَ الْحَقَّيْنِ
u'مُرَاعَاةٌ حُكْمٌ':Added, #4: 4	مُرَاعَاةِ حَقِّ
u'مُرَاعَاةٌ خِلاَفٌ':Added, #1: 1	مُرَاعَاةُ حُكْمِ
u'مُرَاعَاةٌ خِلاَفٌ':Added, #1: 1	مُرَاعَاةَ خِلَافِ
u'مُرَاعَاةٌ خِلاَفٌ':Added, #1: 1	مُرَاعَاةِ خِلَافٍ
u'مُرَاعَاةٌ خِلاَفٌ':Added, #1: 1	مُرَاعَاةُ خِلَافِهِ
u'مُرَاعَاةٌ خِلاَفٌ':Added, #3: 3	مُرَاعَاةُ الْخِلَافِ
u'مُرَاعَاةٌ خِلاَفٌ':Added, #6: 6	مُرَاعَاةِ الْخِلَافِ
u'مُرَاعَاةٌ ذَرائِعُ':Added, #8: 8	مُرَاعَاةَ الْخِلَافِ
u'مُرَاعَاةٌ رَجُلٌ':Added, #1: 1	مُرَاعَاةِ الذَّرَائِعِ
u'مُرَاعَاةٌ رِجْلٌ':Added, #1: 1	مُرَاعَاةُ الرَّجُلِ
u'مُرَاعَاةٌ رَدٌّ':Added, #1: 1	مُرَاعَاةِ الرِّجْلِ
u'مُرَاعَاةٌ رَدٌّ':Added, #1: 1	مُرَاعَاةُ رَدِّ
u'مُرَاعَاةٌ سَتْرٌ':Added, #1: 1	مُرَاعَاةِ رَدِّ
u'مُرَاعَاةٌ سَفْحٌ':Added, #1: 1	مُرَاعَاةُ السَّتْرِ
u'مُرَاعَاةٌ سُنَّةٌ':Added, #1: 1	مُرَاعَاةِ السَّفْحِ
u'مُرَاعَاةٌ سُنَّةٌ':Added, #1: 1	مُرَاعَاةَ سُنَّةِ
u'مُرَاعَاةٌ سُنَّةٌ':Added, #3: 3	مُرَاعَاةِ السُّنَّةِ
u'مُرَاعَاةٌ سُنَّةٌ':Added, #4: 4	مُرَاعَاةُ السُّنَّةِ
u'مُرَاعَاةٌ سُنِّيٌّ':Added, #6: 6	مُرَاعَاةِ سُنَّةِ
u'مُرَاعَاةٌ شافِعِيّ':Added, #1: 1	مُرَاعَاةِ سُنِّيَّةِ
u'مُرَاعَاةٌ شَبَهٌ':Added, #1: 1	مُرَاعَاةُ الشَّافِعِيِّ
u'مُرَاعَاةٌ شَرْطٌ':Added, #1: 1	مُرَاعَاةِ الشَّبَهِ
u'مُرَاعَاةٌ شَرْطٌ':Added, #1: 1	مُرَاعَاةُ الشَّرْطِ
u'مُرَاعَاةٌ شَرْطٌ':Added, #1: 1	مُرَاعَاةِ الشَّرْطِ
u'مُرَاعَاةٌ شَرْطٌ':Added, #1: 1	مُرَاعَاةِ شَرْطِهِ
u'مُرَاعَاةٌ شَرْطٌ':Added, #3: 3	مُرَاعَاةُ شَرْطِهِ
u'مُرَاعَاةٌ شرف':Added, #4: 4	مُرَاعَاةُ شَرْطِ
u'مُرَاعَاةٌ شَرَفٌ':Added, #1: 1	مُرَاعَاةِ الشَّرَفِ
u'مُرَاعَاةٌ شُرُوطٌ':Added, #1: 1	مُرَاعَاةِ الشَّرَفِ
u'مُرَاعَاةٌ شُرُوطٌ':Added, #1: 1	مُرَاعَاةِ شُرُوطِ
u'مُرَاعَاةٌ صِفَةٌ':Added, #2: 2	مُرَاعَاةِ الشُّرُوطِ
u'مُرَاعَاةٌ صِفَةٌ':Added, #1: 1	مُرَاعَاةُ الصِّفَةِ
u'مُرَاعَاةٌ صِفَةٌ':Added, #1: 1	مُرَاعَاةَ صِفَةِ
u'مُرَاعَاةٌ صَلاَةٌ':Added, #1: 1	مُرَاعَاةِ صِفَةِ
u'مُرَاعَاةٌ صَلاَةٌ':Added, #1: 1	مُرَاعَاةَ الصَّلَاةِ
u'مُرَاعَاةٌ صُورٌ':Added, #1: 1	مُرَاعَاةُ الصَّلَاةِ
u'مُرَاعَاةٌ صُوَرٌ':Added, #1: 1	مُرَاعَاةِ الصُّوَرِ
u'مُرَاعَاةٌ صُورَةٌ':Added, #1: 1	مُرَاعَاةِ الصُّوَرِ
u'مُرَاعَاةٌ صُورَةٌ':Added, #1: 1	مُرَاعَاةَ الصُّورَةِ
u'مُرَاعَاةٌ صَوْمٌ':Added, #1: 1	مُرَاعَاةِ صُورَةِ
u'مُرَاعَاةٌ صِيغَةٌ':Added, #1: 1	مُرَاعَاةُ الصَّوْمِ
u'مُرَاعَاةٌ صِيغَةٌ':Added, #1: 1	مُرَاعَاةِ الصِّيغَةِ
u'مُرَاعَاةٌ طُلُوعٌ':Added, #1: 1	مُرَاعَاةُ صِيغَةِ
u'مُرَاعَاةٌ ظاهِرٌ':Added, #1: 1	مُرَاعَاةِ طُلُوعِ
u'مُرَاعَاةٌ عِبَادَةٌ':Added, #1: 1	مُرَاعَاةَ ظَاهِرِ
u'مُرَاعَاةٌ عَدَدٌ':Added, #1: 1	مُرَاعَاةُ الْعِبَادَاتِ
u'مُرَاعَاةٌ عَدَدٌ':Added, #1: 1	مُرَاعَاةَ الْعَدَدِ
u'مُرَاعَاةٌ عَدَدٌ':Added, #1: 1	مُرَاعَاةِ عَدَدٍ
u'مُرَاعَاةٌ عرف':Added, #2: 2	مُرَاعَاةِ الْعَدَدِ
u'مُرَاعَاةٌ عُرْفٌ':Added, #1: 1	مُرَاعَاةُ الْعُرْفِ
u'مُرَاعَاةٌ غِبْطَةٌ':Added, #1: 1	مُرَاعَاةُ الْعُرْفِ
u'مُرَاعَاةٌ غَرَضٌ':Added, #1: 1	مُرَاعَاةِ الْغِبْطَةِ
u'مُرَاعَاةٌ فَرْدٌ':Added, #1: 1	مُرَاعَاةُ غَرَضِ
u'مُرَاعَاةٌ فَرْدِيٌّ':Added, #1: 1	مُرَاعَاةُ فَرْدِيَّةِ
u'مُرَاعَاةٌ فَرْدِيَّةٌ':Added, #1: 1	مُرَاعَاةُ فَرْدِيَّةِ
u'مُرَاعَاةٌ فَرْضٌ':Added, #1: 1	مُرَاعَاةُ فَرْدِيَّةِ
u'مُرَاعَاةٌ فَضِيلٌ':Added, #2: 2	مُرَاعَاةُ فَرْضِ
u'مُرَاعَاةٌ فَضِيلَةٌ':Added, #1: 1	مُرَاعَاةُ فَضِيلَةِ
u'مُرَاعَاةٌ فِعْلٌ':Added, #1: 1	مُرَاعَاةُ فَضِيلَةِ
u'مُرَاعَاةٌ فلان':Added, #1: 1	مُرَاعَاةَ فِعْلِهِ
u'مُرَاعَاةٌ قَاعِدٌ':Added, #1: 1	مُرَاعَاةُ الشَّافِعِيِّ
u'مُرَاعَاةٌ قذف':Added, #1: 1	مُرَاعَاةَ الْقَاعِدَةِ
u'مُرَاعَاةٌ قَذْفٌ':Added, #1: 1	مُرَاعَاةَ قَذْفِهِ
u'مُرَاعَاةٌ قَصْدٌ':Added, #1: 1	مُرَاعَاةَ قَذْفِهِ
u'مُرَاعَاةٌ قَوَاعِدُ':Added, #1: 1	مُرَاعَاةِ قَصْدِهِ
u'مُرَاعَاةٌ قول':Added, #1: 1	مُرَاعَاةِ الْقَوَاعِدِ
u'مُرَاعَاةٌ قول':Added, #1: 1	مُرَاعَاةَ قَوْلِ
u'مُرَاعَاةٌ قَوْلٌ':Added, #1: 1	مُرَاعَاةُ قَوْلِ
u'مُرَاعَاةٌ قَوْلٌ':Added, #1: 1	مُرَاعَاةَ قَوْلِ
u'مُرَاعَاةٌ قَيْدٌ':Added, #1: 1	مُرَاعَاةُ قَوْلِ
u'مُرَاعَاةٌ قِيمَةٌ':Added, #1: 1	مُرَاعَاةِ قَيْدِ
u'مُرَاعَاةٌ كَافِرٌ':Added, #1: 1	مُرَاعَاةُ الْقِيمَةِ
u'مُرَاعَاةٌ كَثْرَةٌ':Added, #1: 1	مُرَاعَاةِ الْكَافِرِ
u'مُرَاعَاةٌ لِبَاسٌ':Added, #1: 1	مُرَاعَاةَ كَثْرَةِ
u'مُرَاعَاةٌ لَفْظٌ':Added, #1: 1	مُرَاعَاةِ لِبَاسِهِ
u'مُرَاعَاةٌ لَفْظٌ':Added, #1: 1	مُرَاعَاةَ اللَّفْظِ
u'مُرَاعَاةٌ لَفْظٌ':Added, #1: 1	مُرَاعَاةِ لَفْظِهِ
u'مُرَاعَاةٌ لَفْظٌ':Added, #2: 2	مُرَاعَاةُ اللَّفْظِ
u'مُرَاعَاةٌ لَفْظٌ':Added, #2: 2	مُرَاعَاةِ اللَّفْظِ
u'مُرَاعَاةٌ لَفْظٌ':Added, #2: 2	مُرَاعَاةَ لَفْظِ
u'مُرَاعَاةٌ مَآلٌ':Added, #2: 2	مُرَاعَاةِ لَفْظِ
u'مُرَاعَاةٌ مَالٌ':Added, #1: 1	مُرَاعَاةِ الْمَآلِ
u'مُرَاعَاةٌ مُسَاوَاةٌ':Added, #1: 1	مُرَاعَاةِ الْمَالِ
u'مُرَاعَاةٌ مَصَالِحُ':Added, #1: 1	مُرَاعَاةُ الْمُسَاوَاةِ
u'مُرَاعَاةٌ مَصَالِحُ':Added, #1: 1	مُرَاعَاةَ مَصَالِحِ
u'مُرَاعَاةٌ مَصَالِحُ':Added, #1: 1	مُرَاعَاةِ مَصَالِحِهِ
u'مُرَاعَاةٌ مَصْلَحَةٌ':Added, #2: 2	مُرَاعَاةُ الْمَصَالِحِ
u'مُرَاعَاةٌ مَصْلَحَةٌ':Added, #1: 1	مُرَاعَاةُ الْمَصْلَحَةِ
u'مُرَاعَاةٌ مَصْلَحَةٌ':Added, #1: 1	مُرَاعَاةِ مَصْلَحَةِ
u'مُرَاعَاةٌ مُضَافٌ':Added, #3: 3	مُرَاعَاةِ الْمَصْلَحَةِ
u'مُرَاعَاةٌ مَطِيَّةٌ':Added, #1: 1	مُرَاعَاةُ الْمُضَافِ
u'مُرَاعَاةٌ مَقَاصِدُ':Added, #1: 1	مُرَاعَاةَ الْمَطِيَّةِ
u'مُرَاعَاةٌ مِقْدَارٌ':Added, #1: 1	مُرَاعَاةِ الْمَقَاصِدِ
u'مُرَاعَاةٌ مِقْدَارٌ':Added, #1: 1	مُرَاعَاةُ الْمِقْدَارِ
u'مُرَاعَاةٌ مَقْصُودٌ':Added, #1: 1	مُرَاعَاةِ الْمِقْدَارِ
u'مُرَاعَاةٌ مَنْصُوصٌ':Added, #1: 1	مُرَاعَاةِ مَقْصُودِ
u'مُرَاعَاةٌ مَوْرِدٌ':Added, #1: 1	مُرَاعَاةِ الْمَنْصُوصِ
u'مُرَاعَاةٌ نَبِيٌّ':Added, #1: 1	مُرَاعَاةُ مَوْرِدِ
u'مُرَاعَاةٌ نَبِيٌّ':Added, #1: 1	مُرَاعَاةُ النَّبِيِّ
u'مُرَاعَاةٌ نصاب':Added, #1: 1	مُرَاعَاةِ النَّبِيِّ
u'مُرَاعَاةٌ نِصَابٌ':Added, #1: 1	مُرَاعَاةَ النِّصَابِ
u'مُرَاعَاةٌ نصفة':Added, #1: 1	مُرَاعَاةَ النِّصَابِ
u'مُرَاعَاةٌ نَظَرٌ':Added, #2: 2	مُرَاعَاةُ النَّصَفَةِ
u'مُرَاعَاةٌ نَظْمٌ':Added, #2: 2	مُرَاعَاةُ النَّظَرِ
u'مُرَاعَاةٌ نَفْسٌ':Added, #1: 1	مُرَاعَاةِ نَظْمِ
u'مُرَاعَاةٌ نَفْسٌ':Added, #1: 1	مُرَاعَاةَ النَّفْسِ
u'مُرَاعَاةٌ نَفْيٌ':Added, #2: 2	مُرَاعَاةِ نَفْسِهِ
u'مُرَاعَاةٌ نقل':Added, #1: 1	مُرَاعَاةِ النَّفْيِ
u'مُرَاعَاةٌ نَقْلٌ':Added, #1: 1	مُرَاعَاةِ النَّقْلِ
u'مُرَاعَاةٌ نِيَّةٌ':Added, #1: 1	مُرَاعَاةِ النَّقْلِ
u'مُرَاعَاةٌ وَقْتٌ':Added, #1: 1	مُرَاعَاةِ نِيَّتِهِ
u'مُرَاعَاةٌ وَقْتٌ':Added, #1: 1	مُرَاعَاةِ الْوَقْتِ
u'مُرَاعَاةٌ وَقْتٌ':Added, #1: 1	مُرَاعَاةِ وَقْتِ
u'مُرَاعَاةٌ وِلاَيَةٌ':Added, #2: 2	مُرَاعَاةَ الْوَقْتِ
u'مُرَاعَاةٌ يَوْمٌ':Added, #2: 2	مُرَاعَاةِ الْوِلَايَةِ
u'مَرَّ أعْرَابِيٌّ':Subject, #1: 1	مُرَاعَاةِ يَوْمِ
u'مُرَاقَبَةٌ عُيُونٌ':Added, #1: 1	مَرَّ أَعْرَابِيٌّ
u'مُرَاقَبَةٌ فَجْرٌ':Added, #1: 1	مُرَاقَبَةُ الْعُيُونِ
u'مُرَاقَبٌ عُيُونٌ':Added, #1: 1	مُرَاقَبَةِ الْفَجْرِ
u'مُرَاقَبٌ فَجْرٌ':Added, #1: 1	مُرَاقَبَةُ الْعُيُونِ
u'مَرَّ إلْحَاقٌ':Subject, #1: 1	مُرَاقَبَةِ الْفَجْرِ
u'مَرَّ إمَامٌ':Subject, #1: 1	مَرَّ إلْحَاقُهُ
u'مَرَّ اِمْتِناعٌ':Subject, #1: 1	مَرَّ الْإِمَامُ
u'مَرَّ اِنْتِفاء':Subject, #1: 1	مَرَّ امْتِنَاعُ
u'مَرَّ إِنْسانٌ':Subject, #1: 1	مَرَّ انْتِفَاءُ
u'مَرَّ أهْلٌ':Subject, #1: 1	مَرَّ إنْسَانٌ
u'مَرَّ أوائل':Predicate, #1: 1	مَرَّ أَهْلُ
u'مَرَّ أَوَّلُ':Predicate, #7: 7	مَرَّ أَوَائِلَ
u'مَرَّ أَوَّلُ':Subject, #50: 50	مَرَّ أَوَّلَ
u'مَرَّ أَوَّلُ':Subject, #1: 1	مَرَّ أَوَّلُ
u'مَرَّ بسط':Subject, #2: 2	مَرَّ الْأَوَّلُ
u'مَرَّ بَسْطٌ':Subject, #10: 10	مَرَّ بَسْطُهُ
u'مَرَّ بسط':Subject, #10: 10	مَرَّ بَسْطُهُ
u'مَرَّ بَسْطٌ':Subject, #3: 3	مَرَّ بَسْطُ
u'مَرَّ بُطْلان':Subject, #3: 3	مَرَّ بَسْطُ
u'مَرَّ بَعْضٌ':Subject, #1: 1	مَرَّ بُطْلَانُهُ
u'مَرَّ بَعْضٌ':Subject, #1: 1	مَرَّ بَعْضُ
u'مَرَّ بَيَانٌ':Subject, #1: 1	مَرَّ بَعْضُهُ
u'مَرَّ بَيَانٌ':Subject, #84: 84	مَرَّ بَيَانُهُ
u'مَرَّ بَيْنٌ':Predicate, #8: 8	مَرَّ بَيَانُ
u'مَرَّ تَاجِرٌ':Subject, #13: 13	مَرَّ بَيْنَ
u'مَرَّ تُجَّارٌ':Subject, #3: 3	مَرَّ التَّاجِرُ
u'مَرَّ تَحْقِيقٌ':Subject, #1: 1	مَرَّ تُجَّارُ
u'مَرَّ تَخْرِيجٌ':Subject, #2: 2	مَرَّ تَحْقِيقُهُ
u'مَرَّ تَصْحِيحٌ':Subject, #1: 1	مَرَّ تَخْرِيجٌ
u'مَرَّ تَصْحِيحٌ':Subject, #1: 1	مَرَّ تَصْحِيحٌ
u'مَرَّ تَصْدِيقٌ':Subject, #1: 1	مَرَّ تَصْحِيحُهُ
u'مَرَّ تَصْرِيحٌ':Subject, #1: 1	مَرَّ تَصْدِيقُ
u'مَرَّ تَصْوِيرٌ':Subject, #6: 6	مَرَّ التَّصْرِيحُ
u'مَرَّ تَعْرِيفٌ':Subject, #1: 1	مَرَّ تَصْوِيرُهُ
u'مَرَّ تَعْرِيفٌ':Subject, #1: 1	مَرَّ تَعْرِيفُ
u'مَرَّ تَعَسُّرٌ':Subject, #1: 1	مَرَّ تَعْرِيفُهُ
u'مَرَّ تَعْلِيقٌ':Subject, #1: 1	مَرَّ التَّعَسُّرُ
u'مَرَّ تَفْسِيرٌ':Subject, #1: 1	مَرَّ التَّعْلِيقُ
u'مَرَّ تَفْصِيلٌ':Subject, #1: 1	مَرَّ تَفْسِيرُهُ
u'مَرَّ تَقْديمٌ':Subject, #3: 3	مَرَّ تَفْصِيلُهُ
u'مَرَّ تَقْريرٌ':Subject, #2: 2	مَرَّ تَقْدِيمُ
u'مَرَّ تَقْيِيد':Subject, #7: 7	مَرَّ تَقْرِيرُهُ
u'مَرَّ تَقْيِيد':Subject, #1: 1	مَرَّ تَقْيِيدُ
u'مَرَّ تَنَبُّه':Subject, #1: 1	مَرَّ تَقْيِيدُهُ
u'مَرَّ تَنْبِيه':Subject, #1: 1	مَرَّ التَّنَبُّهُ
u'مَرَّ ثُبُوتٌ':Subject, #8: 8	مَرَّ التَّنْبِيهُ
u'مَرَّ جَازٌ':Predicate, #1: 1	مَرَّ ثُبُوتُ
u'مَرِجَ أَمْرٌ':Subject, #1: 1	مَرَّ جَازَ
u'مَرَجٌ بَحْرٌ':Added, #1: 1	مَرِجَ أَمْرُ
u'مَرَجٌ بَحْرَيْن':Added, #2: 2	مَرَجَ الْبَحْرَيْنِ
u'مَرَّ جَبْرٌ':Subject, #2: 2	مَرَجَ الْبَحْرَيْنِ
u'مَرَّ جِنْسٌ':Subject, #1: 1	مَرَّ جَبْرُ
u'مَرَّ جِنِّيٌّ':Subject, #4: 4	مَرَّ جِنْسُ
u'مَرَّ جَوَابٌ':Subject, #1: 1	مَرَّ الْجِنِّيُّ
u'مَرَّ جَوَابٌ':Subject, #1: 1	مَرَّ جَوَابُ
u'مَرَّ جَوَابٌ':Subject, #1: 1	مَرَّ جَوَابُهُ
u'مَرَّ جَوَازٌ':Subject, #5: 5	مَرَّ الْجَوَابُ
u'مَرَّ جَوَازٌ':Subject, #1: 1	مَرَّ الْجَوَازُ
u'مَرَّ حارِثٌ':Subject, #1: 1	مَرَّ جَوَازُ
u'مَرَّ حَدٌّ':Subject, #1: 1	مَرَّ حَارِثَةُ
u'مَرَّ حَديثٌ':Subject, #2: 2	مَرَّ حَدُّهُ
u'مَرَّ حُكْمٌ':Subject, #1: 1	مَرَّ الْحَدِيثُ
u'مَرَّ حُكْمٌ':Subject, #3: 3	مَرَّ حُكْمُ
u'مَرَّ حَمْلٌ':Predicate, #6: 6	مَرَّ حُكْمُهُ
u'مَرَّ حَمْلٌ':Subject, #1: 1	مَرَّ حَمْلَ
u'مَرَّ خَبَرٌ':Subject, #1: 1	مَرَّ حَمْلُهُ
u'مَرَّ خَبَر':Subject, #2: 2	مَرَّ خَبَرُ
u'مَرَّ خِلاَفٌ':Subject, #2: 2	مَرَّ خَبَرُ
u'مَرَّ دَاخِلٌ':Predicate, #1: 1	مَرَّ خِلَافُهُ
u'مَرَّ دونٌ':Predicate, #1: 1	مَرَّ دَاخِلَ
u'مَرَّ ذكر':Subject, #3: 3	مَرَّ دُونَ
u'مَرَّ ذِكْرٌ':Subject, #4: 4	مَرَّ ذِكْرُهُ
u'مَرَّ ذِمِّيٌّ':Subject, #4: 4	مَرَّ ذِكْرُهُ
u'مَرَّ ذِمِّيٌّ':Subject, #3: 3	مَرَّ ذِمِّيٌّ
u'مَرَّ رَجُلٌ':Subject, #4: 4	مَرَّ الذِّمِّيُّ
u'مَرَّ رَجُلٌ':Subject, #16: 16	مَرَّ رَجُلٌ
u'مَرَّ رَدٌّ':Subject, #2: 2	مَرَّ الرَّجُلُ
u'مَرَّ رَدٌّ':Subject, #1: 1	مَرَّ الرَّدُّ
u'مَرَّ رَدٌّ':Subject, #1: 1	مَرَّ رَدُّ
u'مَرَّ رَسُولٌ':Subject, #5: 5	مَرَّ رَدُّهُ
u'مَرَّ زائِدٌ':Subject, #53: 53	مَرَّ رَسُولُ
u'مَرَّ زِيادَةٌ':Subject, #1: 1	مَرَّ زَائِدٌ
u'مَرَّ سِكِّينٌ':Predicate, #1: 1	مَرَّ زِيَادَةُ
u'مَرَّ سَهْمٌ':Subject, #4: 4	أَمَرَّ السِّكِّينَ
u'مَرَّ سَواءٌ':Subject, #2: 2	مَرَّ السَّهْمُ
u'مَرَّ شَابٌّ':Subject, #3: 3	مَرَّ سَوَاءٌ
u'مَرَّ شافِعِيّ':Subject, #1: 1	مَرَّ شَابٌّ
u'مَرَّ شَامِيٌّ':Subject, #1: 1	مَرَّ الشَّافِعِيُّ
u'مَرَّ شَائِعٌ':Subject, #1: 1	مَرَّ الشَّامِيُّ
u'مَرَّ شَيْءٌ':Subject, #1: 1	مَرَّ شَائِعٌ
u'مَرَّ شَيْخٌ':Subject, #1: 1	مَرَّ شَيْءٌ
u'مَرَّ صَاحِبٌ':Predicate, #1: 1	مَرَّ شَيْخٌ
u'مَرَّ صَبِيٌّ':Subject, #1: 1	مَرَّ صَاحِبَ
u'مَرَّ صِحَّةٌ':Subject, #3: 3	مَرَّ صَبِيٌّ
u'مَرَّ صِحَّةٌ':Subject, #1: 1	مَرَّ صِحَّةُ
u'مَرَّ صَدْرٌ':Predicate, #1: 1	مَرَّ صِحَّتُهُ
u'مَرَّ صَرِيحٌ':Subject, #1: 1	مَرَّ صَدْرَ
u'مَرَّ صُورَةٌ':Predicate, #1: 1	مَرَّ صَرِيحٌ
u'مَرِضَ أَبٌ':Subject, #1: 1	مَرَّ صُورَةَ
u'مَرَضٌ أَبٌ':Added, #1: 1	مَرِضَ الْأَبُ
u'مَرِضَ اِبْنٌ':Subject, #2: 2	مَرَضِ الْأَبِ
u'مَرِضَ أَجِيرٌ':Subject, #4: 4	مَرِضَ ابْنُ
u'مَرِضَ أحَدٌ':Subject, #1: 1	مَرِضَ أَجِيرُ
u'مَرِضَ أحَدٌ':Subject, #2: 2	مَرِضَ أَحَدٌ
u'مَرَضٌ آدَمِيٌّ':Added, #4: 4	مَرِضَ أَحَدُ
u'مَرِضَ أَكْثَرُ':Predicate, #1: 1	مَرَضِ الْآدَمِيِّ
u'مَرَضٌ الْمَرْأَةُ':Added, #1: 1	مَرِضَ أَكْثَرَ
u'مَرِضَ إمَامٌ':Subject, #3: 3	مَرَضَ الْمَرْأَةِ
u'مَرِضَ آمِرٌ':Subject, #1: 1	مَرِضَ الْإِمَامُ
u'مَرِضَ أَميرٌ':Subject, #1: 1	مَرِضَ الْآمِرُ
u'مَرِضَ اِنْتِزاعٌ':Subject, #1: 1	مَرِضَ الْأَمِيرُ
u'مَرِضَ أيَّامٌ':Predicate, #1: 1	مَرِضَ انْتِزَاعُ
u'مَرِضَ أَيَّامٌ':Predicate, #1: 1	مَرِضَ الْأَيَّامَ
u'مَرَّ ضَبَّةٌ':Subject, #1: 1	مَرِضَ الْأَيَّامَ
u'مَرَّ ضَبْطٌ':Subject, #1: 1	مَرَّ الضَّبَّةُ
u'مَرِضَ بَعْضٌ':Subject, #1: 1	مَرَّ ضَبْطُهُ
u'مَرِضَ جَابِرٌ':Subject, #2: 2	مَرِضَ بَعْضُ
u'مَرِضَ جَمَّالٌ':Subject, #1: 1	مَرِضَ جَابِرٌ
u'مَرَضٌ حامِلٌ':Added, #1: 1	مَرِضَ الْجَمَّالُ
u'مَرِضَ حَبيبٌ':Subject, #1: 1	مَرَضِ الْحَامِلِ
u'مَرِضَ حَسَنٌ':Subject, #1: 1	مَرِضَ الْحَبِيبُ
u'مَرَضٌ خاصّ':Added, #1: 1	مَرِضَ الْحَسَنُ
u'مَرِضَ خَطِيبٌ':Subject, #1: 1	مَرَضٍ خَاصٍّ
u'مَرَضٌ دَابَّةٌ':Added, #1: 1	مَرِضَ الْخَطِيبُ
u'مَرَضٌ دَائِمٌ':Added, #1: 1	مَرَضِ دَابَّةٍ
u'مَرِضَ ذِمِّيٌّ':Subject, #1: 1	مَرَضٍ دَائِمٍ
u'مَرِضَ رَبُّ':Subject, #1: 1	مَرِضَ الذِّمِّيُّ
u'مَرِضَ رَجُلٌ':Subject, #1: 1	مَرِضَ رَبُّ
u'مَرِضَ رَجُلٌ':Subject, #2: 2	مَرِضَ رَجُلٌ
u'مَرَضٌ رَجُلٌ':Added, #5: 5	مَرِضَ الرَّجُلُ
u'مَرَضٌ رَجُلٌ':Added, #1: 1	مَرَضُ الرَّجُلِ
u'مَرِضَ رَسُولٌ':Subject, #1: 1	مَرَضِ الرَّجُلِ
u'مَرَضٌ رَسُولٌ':Added, #7: 7	مَرِضَ رَسُولُ
u'مَرَضٌ رَسُولٌ':Added, #1: 1	مَرَضُ رَسُولِ
u'مَرَضٌ رَقيقٌ':Added, #6: 6	مَرَضِ رَسُولِ
u'مَرَضٌ رَقيق':Added, #1: 1	مَرَضُ الرَّقِيقِ
u'مَرِضَ زَوْجٌ':Subject, #1: 1	مَرَضُ الرَّقِيقِ
u'مَرَضٌ زَوْجٌ':Added, #2: 2	مَرِضَ الزَّوْجُ
u'مَرَضٌ زَوْجٌ':Added, #1: 1	مَرَضُ الزَّوْجِ
u'مَرَضٌ زَوْجَةٌ':Added, #5: 5	مَرَضِ الزَّوْجِ
u'مَرِضَ زَيْدٌ':Subject, #1: 1	مَرَضِ الزَّوْجَةِ
u'مَرِضَ سَعْدٌ':Subject, #1: 1	مَرِضَ زَيْدٌ
u'مَرِضَ سقط':Predicate, #2: 2	مَرِضَ سَعْدٌ
u'مَرِضَ سَقَطٌ':Predicate, #1: 1	مَرِضَ سَقَطَ
u'مَرَضٌ سكتة':Added, #1: 1	مَرِضَ سَقَطَ
u'مَرَضٌ سَكْتَةٌ':Added, #1: 1	مَرَضُ السَّكْتَةِ
u'مَرَضٌ سُلٌّ':Added, #1: 1	مَرَضُ السَّكْتَةِ
u'مَرَضٌ سِياقٌ':Added, #1: 1	مَرَضُ السُّلِّ
u'مَرِضَ سَيِّدٌ':Subject, #1: 1	مَرَضِ السِّيَاقِ
u'مَرَضٌ سَيِّدٌ':Added, #1: 1	مَرِضَ السَّيِّدُ
u'مَرَضٌ سَيِّدٌ':Added, #1: 1	مَرَضِ السَّيِّدِ
u'مَرَضٌ شَاهِدٌ':Added, #1: 1	مَرَضِ سَيِّدِهِ
u'مَرَضٌ شَرِيكٌ':Added, #1: 1	مَرَضِ الشَّاهِدَيْنِ
u'مَرِضَ شُهُودٌ':Subject, #1: 1	مَرَضِ الشَّرِيكِ
u'مَرِضَ صَبِيٌّ':Subject, #1: 1	مَرِضَ شُهُودُ
u'مَرَضٌ صَحِيحٌ':Added, #1: 1	مَرِضَ الصَّبِيُّ
u'مَرَضٌ صَفْرَاء':Added, #1: 1	مَرَضِ الصَّحِيحِ
u'مَرِضَ عَامٌ':Predicate, #1: 1	مَرَضُ الصَّفْرَاءِ
u'مَرَضٌ عَامٌّ':Added, #1: 1	مَرِضَ عَامَ
u'مَرِضَ عَامِلٌ':Subject, #1: 1	مَرَضٍ عَامٍّ
u'مَرَضٌ عَامِلٌ':Added, #1: 1	مَرِضَ الْعَامِلُ
u'مَرِضَ عَبْدٌ':Subject, #2: 2	مَرَضُ الْعَامِلِ
u'مَرِضَ عَبْدٌ':Subject, #18: 18	مَرِضَ الْعَبْدُ
u'مَرَضٌ عَبْدٌ':Added, #3: 3	مَرِضَ عَبْدُ
u'مَرَضٌ عَبْدٌ':Added, #1: 1	مَرَضُ الْعَبْدِ
u'مَرِضَ عُمَرٌ':Subject, #2: 2	مَرَضَ الْعَبْدِ
u'مَرَضٌ عين':Added, #1: 1	مَرِضَ عُمَرُ
u'مَرَضٌ عَيْنٌ':Added, #1: 1	مَرَضِ الْعَيْنِ
u'مَرَضٌ عَيْن':Added, #1: 1	مَرَضِ الْعَيْنِ
u'مَرَضٌ فَرَسٌ':Added, #1: 1	مَرَضِ الْعَيْنِ
u'مَرِضَ قَالٌ':Predicate, #1: 1	مَرَضِ الْفَرَسِ
u'مَرِضَ قَرِيبٌ':Subject, #1: 1	مَرِضَ قَالَ
u'مَرَضٌ قُلُوبٌ':Added, #1: 1	مَرِضَ قَرِيبُهُ
u'مَرَّضَ قول':Predicate, #1: 1	مَرَضِ الْقُلُوبِ
u'مَرَّضَ قَوْلٌ':Predicate, #1: 1	مَرَّضَ الْقَوْلَ
u'مَرِضَ كَفِيلٌ':Subject, #1: 1	مَرَّضَ الْقَوْلَ
u'مَرِضَ مَأْمُورٌ':Subject, #2: 2	مَرِضَ الْكَفِيلُ
u'مَرَّ ضَمَانٌ':Predicate, #1: 1	مَرِضَ الْمَأْمُورُ
u'مَرَضٌ مَانِعٌ':Added, #2: 2	مَرَّ ضَمَانَ
u'مَرَضٌ مَبِيعٌ':Added, #1: 1	مَرَضٍ مَانِعٍ
u'مَرِضَ مَجْرُوحٌ':Subject, #1: 1	مَرَضَ الْمَبِيعِ
u'مَرِضَ مُحِيل':Subject, #1: 1	مَرِضَ الْمَجْرُوحُ
u'مَرَضٌ مُحِيل':Added, #2: 2	مَرِضَ الْمُحِيلُ
u'مَرَضٌ مَخْصُوصٌ':Added, #1: 1	مَرَضِ الْمُحِيلِ
u'مَرَضٌ مَخُوفٌ':Added, #1: 1	مَرَضٍ مَخْصُوصٍ
u'مَرِضَ مَدْيُونٌ':Subject, #6: 6	مَرَضٍ مَخُوفٍ
u'مَرِضَ مَرَضٌ':Predicate, #1: 1	مَرِضَ الْمَدْيُونُ
u'مَرِضَ مُسْتَأْجِرٌ':Subject, #7: 7	مَرِضَ مَرَضَ
u'مَرِضَ مُسْتَأْجِرٌ':Subject, #1: 1	مَرِضَ مُسْتَأْجِرُ
u'مَرَضٌ مُسْتَأْجِرٌ':Added, #2: 2	مَرِضَ الْمُسْتَأْجِرُ
u'مَرَضٌ مُسْلِمٌ':Added, #1: 1	مَرَضُ الْمُسْتَأْجِرِ
u'مَرَضٌ مَوْتٌ':Added, #1: 1	مَرَضَ الْمُسْلِمِ
u'مَرَضٌ مَوْتٌ':Added, #14: 14	مَرَضِ مَوْتِ
u'مَرَضٌ مَوْتٌ':Added, #163: 163	مَرَضِ مَوْتِهِ
u'مَرَضٌ مَوْتٌ':Added, #1: 1	مَرَضُ مَوْتٍ
u'مَرَضٌ مَوْتٌ':Added, #1: 1	مَرَضِ مَوْتٍ
u'مَرَضٌ مَوْتٌ':Added, #1: 1	مَرَضَ مَوْتِهِ
u'مَرَضٌ مَوْتٌ':Added, #57: 57	مَرَضَ الْمَوْتِ
u'مَرَضٌ مَوْتٌ':Added, #7: 7	مَرَضُ الْمَوْتِ
u'مَرِضَ مُؤَجِّرٌ':Subject, #97: 97	مَرَضِ الْمَوْتِ
u'مَرَضٌ مَوْرُوثٌ':Added, #2: 2	مَرِضَ الْمُؤَجِّرُ
u'مَرِضَ نَبِيٌّ':Subject, #1: 1	مَرَضِ مَوْرُوثِهِ
u'مَرِضَ نِصْفٌ':Predicate, #1: 1	مَرِضَ النَّبِيُّ
u'مَرِضَ وَاهِبٌ':Subject, #2: 2	مَرِضَ نِصْفَ
u'مَرَضٌ وَاهِبٌ':Added, #4: 4	مَرِضَ الْوَاهِبُ
u'مَرَضٌ وفاة':Added, #2: 2	مَرَضِ الْوَاهِبِ
u'مَرَضٌ وَفَاةٌ':Added, #1: 1	مَرَضِ الْوَفَاةِ
u'مَرَضٌ وفاة':Added, #1: 1	مَرَضِ الْوَفَاةِ
u'مَرَضٌ وَفَاةٌ':Added, #2: 2	مَرَضِ وَفَاتِهِ
u'مَرِضَ وَلَهٌ':Subject, #2: 2	مَرَضِ وَفَاتِهِ
u'مَرَضٌ يَوْمٌ':Added, #1: 1	مَرِضَ وَلَهُ
u'مَرَّ ظُعُنٌ':Subject, #1: 1	مَرَضِ الْيَوْمَيْنِ
u'مَرَّ عَامِرٌ':Subject, #1: 1	مَرَّ الظُّعُنُ
u'مَرَّ عَبْدٌ':Subject, #1: 1	مَرَّ عَامِرُ
u'مَرَّ عَبْدٌ':Subject, #1: 1	مَرَّ الْعَبْدُ
u'مَرَّ عَبْدٌ':Subject, #1: 1	مَرَّ عَبْدُ
u'مَرَّ عَدَمٌ':Subject, #3: 3	مَرَّ عَبْدٌ
u'مَرَّ عَقِبٌ':Predicate, #1: 1	مَرَّ عَدَمُ
u'مَرَّ علم':Predicate, #1: 1	مَرَّ عَقِبَ
u'مَرَّ عَلِيٌّ':Subject, #3: 3	مَرَّ عُلِمَ
u'مَرَّ عَلِيٌّ':Subject, #1: 1	مَرَّ عَلِيٌّ
u'مَرَّ عُمَرٌ':Subject, #1: 1	مَرَّ عَلِيُّ
u'مَرَّ عند':Predicate, #8: 8	مَرَّ عُمَرُ
u'مَرَّ غير':Predicate, #10: 10	مَرَّ عِنْدَ
u'مَرَّ غَيْرٌ':Predicate, #15: 15	مَرَّ غَيْرَ
u'مَرَّ غير':Subject, #15: 15	مَرَّ غَيْرَ
u'مَرَّ غَيْرٌ':Subject, #1: 1	مَرَّ غَيْرُ
u'مَرَّ فرق':Subject, #1: 1	مَرَّ غَيْرُ
u'مَرَّ فَرْقٌ':Subject, #6: 6	مَرَّ الْفَرْقُ
u'مَرَّ فِعْلٌ':Subject, #6: 6	مَرَّ الْفَرْقُ
u'مَرْفِقٌ أَمْلاكٌ':Added, #1: 1	مَرَّ فِعْلُهُ
u'مَرْفِق أَمْلاكٌ':Added, #1: 1	مَرْفِقُ الْأَمْلَاكِ
u'مَرْفِقٌ أَمْلاَكٌ':Added, #1: 1	مَرْفِقُ الْأَمْلَاكِ
u'مَرْفِق أَمْلاَكٌ':Added, #1: 1	مَرْفِقُ الْأَمْلَاكِ
u'مِرْفَقَةٌ حَرِيرٌ':Added, #1: 1	مَرْفِقُ الْأَمْلَاكِ
u'مِرْفَقَةٌ حَرِيرٌ':Added, #1: 1	مِرْفَقَةُ حَرِيرٍ
u'مِرْفَقٌ دَارٌ':Added, #2: 2	مِرْفَقَةِ حَرِيرٍ
u'مِرْفَقٌ دَارٌ':Added, #1: 1	مِرْفَقَ الدَّارِ
u'مَرْفِقٌ مَقْطُوعٌ':Added, #1: 1	مِرْفَقُ الدَّارِ
u'مَرْفِق مَقْطُوعٌ':Added, #1: 1	مَرْفِقَ مَقْطُوعِ
u'مِرْفَقٌ يَدٌ':Added, #1: 1	مَرْفِقَ مَقْطُوعِ
u'مَرَّ فلان':Subject, #2: 2	مِرْفَقِ يَدِهِ
u'مَرَّ فلان':Subject, #1: 1	مَرَّ الشَّافِعِيُّ
u'مَرَّ قَارِئٌ':Subject, #2: 2	مَرَّ عُثْمَانُ
u'مَرَّ قَالٌ':Predicate, #1: 1	مَرَّ الْقَارِئُ
u'مَرَّ قَبِيلٌ':Predicate, #49: 49	مَرَّ قَالَ
u'مَرَّ قُرْء':Subject, #1: 1	مَرَّ قَبِيلَ
u'مَرَقَ سَهْمٌ':Subject, #1: 1	مَرَّ الْقُرْءُ
u'مَرَّ قول':Subject, #1: 1	مَرَقَ السَّهْمُ
u'مَرَّ قَوْلٌ':Subject, #1: 1	مَرَّ قَوْلُ
u'مَرَّ قول':Subject, #1: 1	مَرَّ قَوْلُ
u'مَرَّ قَوْلٌ':Subject, #2: 2	مَرَّ قَوْلُهُ
u'مَرَّ قِيَاسٌ':Subject, #2: 2	مَرَّ قَوْلُهُ
u'مَرَّ قِيمَةٌ':Subject, #1: 1	مَرَّ الْقِيَاسُ
u'مَرَّ كَافِرٌ':Subject, #1: 1	مَرَّ قِيمَةُ
u'مَرْكَبٌ فَضْلٌ':Added, #1: 1	مَرَّ الْكَافِرُ
u'مَرَّ كَلاَمٌ':Subject, #1: 1	مَرْكَبُ فَضْلٍ
u'مَرَّ كَلاَمٌ':Subject, #12: 12	مَرَّ الْكَلَامُ
u'مَرَّ كَوْنٌ':Subject, #1: 1	مَرَّ كَلَامُ
u'مَرَّ لَحْظ':Predicate, #1: 1	مَرَّ كَوْنُهُ
u'مَرَّ مَاءٌ':Predicate, #1: 1	مَرَّ لَحْظَةً
u'مَرَّ مَارٌّ':Subject, #5: 5	أَمَرَّ الْمَاءَ
u'مَرَّ مَارٌّ':Subject, #2: 2	مَرَّ الْمَارُّ
u'مَرَّ مَالِكٌ':Subject, #3: 3	مَرَّ مَارٌّ
u'مَرَّ مَبْنِيٌّ':Subject, #1: 1	مَرَّ مَالِكٌ
u'مَرَّ مِثَالٌ':Subject, #2: 2	مَرَّ مَبْنِيٌّ
u'مَرَّ مثل':Subject, #1: 1	مَرَّ مِثَالُهُ
u'مَرَّ مِثْلٌ':Subject, #3: 3	مَرَّ مِثْلُهُ
u'مَرَّ مَحَلٌّ':Subject, #3: 3	مَرَّ مِثْلُهُ
u'مَرَّ مَحَلٌّ':Subject, #1: 1	مَرَّ مَحَلُّ
u'مَرَّ مُحَمَّدٌ':Subject, #3: 3	مَرَّ مَحَلُّهُ
u'مَرَّ مَحْمُولٌ':Subject, #1: 1	مَرَّ مُحَمَّدٌ
u'مَرَّ مُخَيَّرٌ':Subject, #1: 1	مَرَّ مَحْمُولٌ
u'مَرَّ مرٌّ':Predicate, #1: 1	مَرَّ مُخَيَّرَةٌ
u'مَرَّ مُسَافِرٌ':Subject, #2: 2	مَرَّ مَرَّةً
u'مَرَّ مُسَافِرٌ':Subject, #1: 1	مَرَّ الْمُسَافِرُ
u'مَرَّ مُسْلِمٌ':Subject, #1: 1	مَرَّ مُسَافِرٌ
u'مَرَّ مُسْلِمٌ':Subject, #2: 2	مَرَّ مُسْلِمٌ
u'مَرَّ مُشْتَقٌّ':Subject, #3: 3	مَرَّ الْمُسْلِمُ
u'مَرَّ مُضَارِبٌ':Subject, #1: 1	مَرَّ مُشْتَقَّةٌ
u'مَرَّ مُفِيدٌ':Subject, #5: 5	مَرَّ الْمُضَارِبُ
u'مَرَّ مَقْصُورٌ':Subject, #1: 1	مَرَّ الْمُفِيدُ
u'مَرَّ نَائِمٌ':Subject, #1: 1	مَرَّ مَقْصُورٌ
u'مَرَّ نَبِيٌّ':Subject, #1: 1	مَرَّ النَّائِمُ
u'مَرَّ نَحْوٌ':Subject, #20: 20	مَرَّ النَّبِيُّ
u'مَرَّ نَصٌّ':Predicate, #1: 1	مَرَّ نَحْوُهُ
u'مَرَّ نَصٌّ':Subject, #1: 1	مَرَّ نَصَّ
u'مَرَّ نَظِيرٌ':Subject, #1: 1	مَرَّ نَصُّهُ
u'مَرَّ نَظِيرٌ':Subject, #3: 3	مَرَّ نَظِيرُ
u'مَرَّ نقل':Subject, #54: 54	مَرَّ نَظِيرُهُ
u'مَرَّ نَقْلٌ':Subject, #1: 1	مَرَّ النَّقْلُ
u'مَرَّ نقل':Subject, #1: 1	مَرَّ النَّقْلُ
u'مَرَّ نَقْلٌ':Subject, #1: 1	مَرَّ نَقْلُ
u'مَرَّ نقل':Subject, #1: 1	مَرَّ نَقْلُ
u'مَرَّ نَقْلٌ':Subject, #3: 3	مَرَّ نَقْلُهُ
u'مَرَّ هُودٌ':Subject, #3: 3	مَرَّ نَقْلُهُ
u'مَرَّ وَاضِحٌ':Subject, #1: 1	مَرَّ هُودُ
u'مَرَّ وَتَرٌ':Predicate, #1: 1	مَرَّ وَاضِحٌ
u'مَرَّ وَجْهٌ':Predicate, #1: 1	مَرَّ وَتَرَكَ
u'مَرَّ وَجْهٌ':Subject, #3: 3	أَمَرَّ الْوَجْهَ
u'مَرَّ وَجْهٌ':Subject, #1: 1	مَرَّ وَجْهُ
u'مَرَّ وُجُوبٌ':Subject, #7: 7	مَرَّ الْوَجْهُ
u'مَرَّ وَراء':Predicate, #1: 1	مَرَّ وُجُوبُهُ
u'مُرُورٌ أَجَلٌ':Added, #2: 2	مَرَّ وَرَاءَ
u'مُرُورٌ أحَدٌ':Added, #1: 1	مُرُورِ الْأَجَلِ
u'مُرُورٌ أَزْمانٌ':Added, #1: 1	مُرُورُ أَحَدِ
u'مُرُورٌ أَزْمِنَةٌ':Added, #1: 1	مُرُورِ الْأَزْمَانِ
u'مُرُورٌ أَصابِعُ':Added, #3: 3	مُرُورِ الْأَزْمِنَةِ
u'مُرُورٌ الْمَرْأَةُ':Added, #1: 1	مُرُورَ الْأَصَابِعِ
u'مُرُورٌ الْمَرْأَةُ':Added, #1: 1	مُرُورِ الْمَرْأَةِ
u'مُرُورٌ الْمَرْأَةُ':Added, #2: 2	مُرُورُ الْمَرْأَةِ
u'مُرُورٌ إِنْسانٌ':Added, #3: 3	مُرُورَ الْمَرْأَةِ
u'مُرُورٌ إِنْسانٌ':Added, #1: 1	مُرُورَ إنْسَانٍ
u'مُرُورٌ أيَّامٌ':Added, #2: 2	مُرُورِ الْإِنْسَانِ
u'مُرُورٌ أَيَّامٌ':Added, #1: 1	مُرُورُ الْأَيَّامِ
u'مُرُورٌ أيَّامٌ':Added, #1: 1	مُرُورُ الْأَيَّامِ
u'مُرُورٌ أَيَّامٌ':Added, #3: 3	مُرُورِ الْأَيَّامِ
u'مُرُورٌ بَعيرٌ':Added, #3: 3	مُرُورِ الْأَيَّامِ
u'مُرُورٌ تُرَابٌ':Added, #1: 1	مُرُورُ الْبَعِيرِ
u'مُرُورٌ حاجٌّ':Added, #1: 1	مُرُورَ التُّرَابِ
u'مُرُورٌ حائِضٌ':Added, #1: 1	مُرُورُ الْحَاجِّ
u'مُرُورٌ حِمَارٌ':Added, #1: 1	مُرُورُ الْحَائِضِ
u'مُرُورٌ حِمَارٌ':Added, #1: 1	مُرُورُ الْحِمَارِ
u'مُرُورٌ حِمَارٌ':Added, #1: 1	مُرُورِ الْحِمَارِ
u'مُرُورٌ حول':Added, #2: 2	مُرُورَ الْحِمَارِ
u'مُرُورٌ حَوْلٌ':Added, #1: 1	مُرُورِ الْحَوْلِ
u'مُرُورٌ حول':Added, #1: 1	مُرُورِ الْحَوْلِ
u'مُرُورٌ حَوْلٌ':Added, #2: 2	مُرُورُ الْحَوْلِ
u'مُرُورٌ دَوَابُّ':Added, #2: 2	مُرُورُ الْحَوْلِ
u'مُرُورٌ رَاكِبٌ':Added, #1: 1	مُرُورَ الدَّوَابِّ
u'مُرُورٌ رَبُّ':Added, #1: 1	مُرُورُ الرَّاكِبِ
u'مُرُورٌ رَجُلٌ':Added, #1: 1	مُرُورِ رَبِّهِ
u'مُرُورٌ رُمْحٌ':Added, #1: 1	مُرُورِ رَجُلٍ
u'مُرُورٌ زَمانٌ':Added, #1: 1	مُرُورُ رُمْحٍ
u'مُرُورٌ زَمانٌ':Added, #1: 1	مُرُورُ الزَّمَانِ
u'مُرُورٌ سَهْمٌ':Added, #4: 4	مُرُورِ الزَّمَانِ
u'مُرُورٌ سَيْل':Added, #2: 2	مُرُورِ السَّهْمِ
u'مُرُورٌ شَيْءٌ':Added, #1: 1	مُرُورِ السَّيْلِ
u'مُرُورٌ شَيْءٌ':Added, #1: 1	مُرُورَ شَيْءٍ
u'مُرُورٌ شَيْطَانٌ':Added, #5: 5	مُرُورُ شَيْءٍ
u'مُرُورٌ شَيْطَانٌ':Added, #1: 1	مُرُورَ الشَّيْطَانِ
u'مُرُورٌ شَيْطَانٌ':Added, #2: 2	مُرُورُ الشَّيْطَانِ
u'مُرُورٌ صَاحِبٌ':Added, #2: 2	مُرُورِ الشَّيْطَانِ
u'مُرُورٌ صَغِيرٌ':Added, #1: 1	مُرُورِ صَاحِبِ
u'مُرُورٌ طرف':Added, #1: 1	مُرُورُ الصَّغِيرَةِ
u'مُرُورٌ طَرَفٌ':Added, #1: 1	مُرُورُ طَرَفِهِ
u'مُرُورٌ عَامٌ':Added, #1: 1	مُرُورُ طَرَفِهِ
u'مُرُورٌ عَبْدٌ':Added, #1: 1	مُرُورُ عَامٍ
u'مُرُورٌ غير':Added, #1: 1	مُرُورِ عَبْدِ
u'مُرُورٌ غَيْرٌ':Added, #1: 1	مُرُورَ غَيْرِ
u'مُرُورٌ فَرِيقٌ':Added, #1: 1	مُرُورَ غَيْرِ
u'مُرُورٌ كَلْبٌ':Added, #1: 1	مُرُورُ الْفَرِيقَيْنِ
u'مُرُورٌ مَارٌّ':Added, #1: 1	مُرُورِ الْكَلْبِ
u'مُرُورٌ نَاسٌ':Added, #2: 2	مُرُورُ الْمَارِّ
u'مُرُورٌ واحد':Added, #2: 2	مُرُورِ النَّاسِ
u'مُرُورٌ وَاحِدٌ':Added, #1: 1	مُرُورُ وَاحِدٍ
u'مُرُورٌ يَدٌ':Added, #1: 1	مُرُورُ وَاحِدٍ
u'مَرَّ وَقْتٌ':Subject, #1: 1	مُرُورَ الْيَدِ
u'مُرُوقٌ سَهْمٌ':Added, #1: 1	مَرَّ وَقْتُ
u'مَرَّ وقع':Predicate, #3: 3	مُرُوقَ السَّهْمِ
u'مَرَّ يهود':Subject, #1: 1	مَرَّ وَقَعَ
u'مَرَّ يَهُودٌ':Subject, #1: 1	مَرَّ الْيَهُودُ
u'مَرَّ يَهُودِيٌّ':Subject, #1: 1	مَرَّ الْيَهُودُ
u'مَرَّ يَوْمٌ':Subject, #1: 1	مَرَّ يَهُودِيٌّ
u'مِزَاحٌ الْمَرْءُ':Added, #15: 15	مَرَّ يَوْمُ
u'مُزَاحَمَةٌ أحَدٌ':Added, #1: 1	مِزَاحِ الْمَرْءِ
u'مُزَاحَمَةٌ بَائِعٌ':Added, #1: 1	مُزَاحَمَةِ أَحَدٍ
u'مُزَاحَمَةٌ تَبَع':Added, #1: 1	مُزَاحَمَةِ بَائِعِهِ
u'مُزَاحَمَةٌ تَعْمِيقٌ':Added, #1: 1	مُزَاحَمَةِ التَّبَعِ
u'مُزَاحَمَةٌ ثَابِتٌ':Added, #1: 1	مُزَاحَمَةَ تَعْمِيقِ
u'مُزَاحَمَةٌ خَارِجٌ':Added, #1: 1	مُزَاحَمَةُ الثَّابِتِ
u'مُزَاحَمَةٌ دَاخِلٌ':Added, #1: 1	مُزَاحَمَةِ الْخَارِجِ
u'مُزَاحَمَةٌ دَاخِلٌ':Added, #1: 1	مُزَاحَمَةُ الدَّاخِلِ
u'مُزَاحَمَةٌ دَاخِلَةٌ':Added, #1: 1	مُزَاحَمَةِ الدَّاخِلَةِ
u'مُزَاحَمَةٌ رِجَالٌ':Added, #1: 1	مُزَاحَمَةِ الدَّاخِلَةِ
u'مُزَاحَمَةٌ رَجُلٌ':Added, #1: 1	مُزَاحَمَةِ الرِّجَالِ
u'مُزَاحَمَةٌ سَائِرٌ':Added, #1: 1	مُزَاحَمَةُ الرَّجُلِ
u'مُزَاحَمَةٌ شَرِيكٌ':Added, #1: 1	مُزَاحَمَةُ سَائِرِ
u'مُزَاحَمَةٌ غَرِيمٌ':Added, #1: 1	مُزَاحَمَةِ الشَّرِيكِ
u'مُزَاحَمَةٌ غير':Added, #1: 1	مُزَاحَمَةُ الْغَرِيمِ
u'مُزَاحَمَةٌ غَيْرٌ':Added, #2: 2	مُزَاحَمَةِ غَيْرِهِ
u'مُزَاحَمَةٌ كَافِرٌ':Added, #2: 2	مُزَاحَمَةِ غَيْرِهِ
u'مُزَاحَمَةٌ كَامِلٌ':Added, #1: 1	مُزَاحَمَةُ الْكَافِرِ
u'مُزَاحَمَةٌ مَجَازٌ':Added, #1: 1	مُزَاحَمَةِ كَامِلَةِ
u'مُزَاحَمَةٌ وَصِيٌّ':Added, #1: 1	مُزَاحَمَةِ الْمَجَازِ
u'مُزَاحَمَةٌ وَصِيَّةٌ':Added, #2: 2	مُزَاحَمَةِ الْوَصِيَّةِ
u'مُزَاوَجَةٌ حمر':Added, #2: 2	مُزَاحَمَةِ الْوَصِيَّةِ
u'مُزَاوَجَةٌ حُمُرٌ':Added, #1: 1	مُزَاوَجَةِ الْحُمُرِ
u'مُزَاوَلَةٌ أَشْيَاءٌ':Added, #1: 1	مُزَاوَجَةِ الْحُمُرِ
u'مَزْجٌ خَمْرٌ':Added, #1: 1	مُزَاوَلَةِ الْأَشْيَاءِ
u'مَزْجٌ رَهْنٌ':Added, #1: 1	مَزْجِ الْخَمْرِ
u'مَزَجَ مَرَارَةٌ':Predicate, #1: 1	مَزْجُ الرَّهْنِ
u'مَزَحَ بَعْضٌ':Subject, #1: 1	مَزَجَ الْمَرَارَةَ
u'مَزَحَ شَعْبِيٌّ':Subject, #1: 1	مَزَحَ بَعْضُ
u'مَزَحَ صَدِيقٌ':Subject, #1: 1	مَزَحَ الشَّعْبِيُّ
u'مَزَحَ نَبِيٌّ':Subject, #1: 1	مَزَحَ الصَّدِيقُ
u'مَزَّقَ اِبْنٌ':Subject, #1: 1	مَزَحَ النَّبِيُّ
u'مَزِيدٌ اِحْتِرَامٌ':Added, #1: 1	مَزَّقَ ابْنُهُ
u'مَزِيدٌ اِحْتِيَاطٌ':Added, #1: 1	مَزِيدِ احْتِرَامِهِ
u'مَزِيدٌ اِخْتِصَاصٌ':Added, #1: 1	مَزِيدِ احْتِيَاطٍ
u'مَزِيدٌ إِسْلامٌ':Added, #2: 2	مَزِيدُ اخْتِصَاصٍ
u'مَزِيدٌ اِعْتِناءٌ':Added, #1: 1	مَزِيدُ الْإِسْلَامِ
u'مَزِيدٌ اِعْتِناءٌ':Added, #1: 1	مَزِيدَ اعْتِنَاءٍ
u'مَزِيدٌ اِعْتِناءٌ':Added, #1: 1	مَزِيدَ اعْتِنَاءِ
u'مَزِيدٌ ألَمٌ':Added, #1: 1	مَزِيدُ اعْتِنَاءٍ
u'مَزِيدٌ إِنْعامٌ':Added, #1: 1	مَزِيدَ أَلَمٍ
u'مَزِيدٌ إِنْعامٌ':Added, #1: 1	مَزِيدَ الْإِنْعَامِ
u'مَزِيدٌ بَحْثٌ':Added, #1: 1	مَزِيدِ إنْعَامِهِ
u'مَزِيدٌ بَحْثٌ':Added, #1: 1	مَزِيدِ الْبَحْثِ
u'مَزِيدٌ بَسْطٌ':Added, #2: 2	مَزِيدُ بَحْثٍ
u'مَزِيدٌ بَسْطٌ':Added, #1: 1	مَزِيدَ بَسْطٍ
u'مَزِيدٌ بَيَانٌ':Added, #1: 1	مَزِيدِ بَسْطٍ
u'مَزِيدٌ بَيَانٌ':Added, #13: 13	مَزِيدُ بَيَانٍ
u'مَزِيدٌ بَيَانٌ':Added, #1: 1	مَزِيدِ بَيَانٍ
u'مَزِيدٌ تَأْكِيدٌ':Added, #3: 3	مَزِيدَ بَيَانٍ
u'مَزِيدٌ تَأْكِيدٌ':Added, #1: 1	مَزِيدَ التَّأْكِيدِ
u'مَزِيدٌ تَأْكِيدٌ':Added, #1: 1	مَزِيدِ التَّأْكِيدِ
u'مَزِيدٌ تَأْكِيدٌ':Added, #1: 1	مَزِيدَ تَأْكِيدٍ
u'مَزِيدٌ تَأَمُّلٌ':Added, #1: 1	مَزِيدُ تَأْكِيدٍ
u'مَزِيدٌ تَتَبُّعٌ':Added, #2: 2	مَزِيدِ تَأَمُّلٍ
u'مَزِيدٌ تَثَبُّتٌ':Added, #1: 1	مَزِيدِ تَتَبُّعٍ
u'مَزِيدٌ تَحْقِيقٌ':Added, #1: 1	مَزِيدِ تَثَبُّتٍ
u'مَزِيدٌ تَحْقِيقٌ':Added, #1: 1	مَزِيدَ تَحْقِيقٍ
u'مَزِيدٌ تَسَلُّطٌ':Added, #1: 1	مَزِيدُ تَحْقِيقٍ
u'مَزِيدٌ تَشْرِيفٌ':Added, #1: 1	مَزِيدُ تَسَلُّطٍ
u'مَزِيدٌ تَعَصُّبٌ':Added, #1: 1	مَزِيدُ تَشْرِيفٍ
u'مَزِيدٌ تَعْظِيمٌ':Added, #2: 2	مَزِيدُ التَّعَصُّبِ
u'مَزِيدٌ تَعَلُّقٌ':Added, #1: 1	مَزِيدِ التَّعْظِيمِ
u'مَزِيدٌ تَفْتِيشٌ':Added, #1: 1	مَزِيدُ تَعَلُّقٍ
u'مَزِيدٌ تَفْضِيلٌ':Added, #1: 1	مَزِيدِ التَّفْتِيشِ
u'مَزِيدٌ تَقَدُّمٌ':Added, #1: 1	مَزِيدَ التَّفْضِيلِ
u'مَزِيدٌ تَقْريرٌ':Added, #1: 1	مَزِيدُ تَقَدُّمٍ
u'مَزِيدٌ تَكَلُّفٌ':Added, #1: 1	مَزِيدُ تَقْرِيرٍ
u'مَزِيدٌ تَنَظُّفٌ':Added, #1: 1	مَزِيدِ تَكَلُّفِ
u'مَزِيدٌ تَوَدُّدٌ':Added, #1: 1	مَزِيدَ التَّنَظُّفِ
u'مَزِيدٌ ثَوابٌ':Added, #1: 1	مَزِيدُ التَّوَدُّدِ
u'مَزِيدٌ ثَوابٌ':Added, #1: 1	مَزِيدُ الثَّوَابِ
u'مَزِيدٌ ثَوابٌ':Added, #1: 1	مَزِيدُ ثَوَابٍ
u'مَزِيدٌ جَهالَة':Added, #2: 2	مَزِيدِ الثَّوَابِ
u'مَزِيدٌ جَهْلٌ':Added, #1: 1	مَزِيدِ الْجَهَالَةِ
u'مَزِيدٌ جهل':Added, #1: 1	مَزِيدِ جَهْلٍ
u'مَزِيدٌ جهل':Added, #2: 2	مَزِيدَ جَهْلِهِ
u'مَزِيدٌ جَهْلٌ':Added, #2: 2	مَزِيدِ جَهْلِهِ
u'مَزِيدٌ جَهْلٌ':Added, #2: 2	مَزِيدَ جَهْلِهِ
u'مَزِيدٌ خَفَاءٌ':Added, #2: 2	مَزِيدِ جَهْلِهِ
u'مَزِيدٌ خَوْفٌ':Added, #1: 1	مَزِيدِ الْخَفَاءِ
u'مَزِيدٌ خَيْرٌ':Added, #1: 1	مَزِيدَ الْخَوْفِ
u'مَزِيدٌ دَقيقَةٌ':Added, #1: 1	مَزِيدَ خَيْرٍ
u'مَزِيدٌ ضَرُورَةٌ':Added, #1: 1	مَزِيدِ دَقِيقَةٍ
u'مَزِيدٌ طَلَبٌ':Added, #1: 1	مَزِيدِ ضَرُورَةٍ
u'مَزِيدٌ عَذَابٌ':Added, #1: 1	مَزِيدِ طَلَبٍ
u'مَزِيدٌ عقاب':Added, #1: 1	مَزِيدُ الْعَذَابِ
u'مَزِيدٌ عِقَابٌ':Added, #1: 1	مَزِيدِ الْعِقَابِ
u'مَزِيدٌ علم':Added, #1: 1	مَزِيدِ الْعِقَابِ
u'مَزِيدٌ عِلْمٌ':Added, #1: 1	مَزِيدُ الْعِلْمِ
u'مَزِيدٌ علم':Added, #1: 1	مَزِيدُ الْعِلْمِ
u'مَزِيدٌ عِلْمٌ':Added, #3: 3	مَزِيدَ عِلْمٍ
u'مَزِيدٌ غفلة':Added, #3: 3	مَزِيدَ عِلْمٍ
u'مَزِيدٌ غَفْلَةٌ':Added, #1: 1	مَزِيدِ غَفْلَةٍ
u'مَزِيدٌ فِقْهٌ':Added, #1: 1	مَزِيدِ غَفْلَةٍ
u'مَزِيدٌ قُرْبٌ':Added, #1: 1	مَزِيدِ الْفِقْهِ
u'مَزِيدٌ قُوَّةٌ':Added, #1: 1	مَزِيدِ الْقُرْبِ
u'مَزِيدٌ قُوَّة':Added, #1: 1	مَزِيدُ قُوَّةٍ
u'مَزِيدٌ كَرَمٌ':Added, #1: 1	مَزِيدُ قُوَّةٍ
u'مَزِيدٌ كَشْفٌ':Added, #1: 1	مَزِيدِ كَرَمِهِ
u'مَزِيدٌ كَلاَمٌ':Added, #1: 1	مَزِيدِ كَشْفٍ
u'مَزِيدٌ كَلاَمٌ':Added, #1: 1	مَزِيدُ الْكَلَامِ
u'مَزِيدٌ كَلاَمٌ':Added, #1: 1	مَزِيدِ كَلَامٍ
u'مَزِيدٌ كُلْفَةٌ':Added, #4: 4	مَزِيدُ كَلَامٍ
u'مَزِيدٌ مُزَاوَلَةٌ':Added, #1: 1	مَزِيدِ كُلْفَةٍ
u'مَزِيدٌ مَعْرِفَةٌ':Added, #1: 1	مَزِيدُ مُزَاوَلَةٍ
u'مَزِيدٌ مَعْرِفَة':Added, #1: 1	مَزِيدِ مَعْرِفَةٍ
u'مَزِيدٌ نِعَمٌ':Added, #1: 1	مَزِيدِ مَعْرِفَةٍ
u'مَزِيدٌ نَقْلٌ':Added, #1: 1	مَزِيدَ نِعَمِهِ
u'مَزِيدٌ وُضُوح':Added, #1: 1	مَزِيدُ نَقْلٍ
u'مَزِيدٌ وُضُوح':Added, #1: 1	مَزِيدُ وُضُوحٍ
u'مَزِيدٌ وُقُوفٌ':Added, #1: 1	مَزِيدِ وُضُوحٍ
u'مَزِيدٌ يَقَظَةٌ':Added, #1: 1	مَزِيدِ الْوُقُوفِ
u'مُسَابَقَةٌ إمَامٌ':Added, #1: 1	مَزِيدِ يَقَظَةِ
u'مُسَابَقَةٌ إمَامٌ':Added, #1: 1	مُسَابَقَةُ الْإِمَامِ
u'مُسَابَقَةٌ رَسُولٌ':Added, #1: 1	مُسَابَقَةِ الْإِمَامِ
u'مِسَاحَةٌ أرْضٌ':Added, #1: 1	مُسَابَقَةِ رَسُولِ
u'مِسَاحَةٌ أرْضٌ':Added, #1: 1	مِسَاحَةِ الأَرْضِ
u'مِسَاحَةٌ أرْضٌ':Added, #1: 1	مِسَاحَةِ الْأَرْضَيْنِ
u'مِسَاحَةٌ جلد':Added, #2: 2	مِسَاحَةِ الْأَرْضِ
u'مِسَاحَةٌ جِلْدٌ':Added, #1: 1	مِسَاحَةُ الْجِلْدِ
u'مِسَاحَةٌ خراج':Added, #1: 1	مِسَاحَةُ الْجِلْدِ
u'مِسَاحَةٌ خَرَاجٌ':Added, #1: 1	مِسَاحَةَ خَرَاجٍ
u'مِسَاحَةٌ سَوادٌ':Added, #1: 1	مِسَاحَةَ خَرَاجٍ
u'مِسَاحَةٌ شَجَّةٌ':Added, #1: 1	مِسَاحَةُ السَّوَادِ
u'مِسَاحَةٌ عِرَاقٌ':Added, #1: 1	مِسَاحَةِ الشَّجَّةِ
u'مِسَاحَةٌ مَزْرُوعٌ':Added, #2: 2	مِسَاحَةِ الْعِرَاقِ
u'مِسَاحَةٌ مَسْجِدٌ':Added, #1: 1	مِسَاحَةِ الْمَزْرُوعِ
u'مِسَاحَةٌ مَعْلُومٌ':Added, #1: 1	مِسَاحَةِ الْمَسْجِدِ
u'مِسَاحَةٌ وَجْهٌ':Added, #1: 1	مِسَاحَةٍ مَعْلُومَةٍ
u'مَسَّ أحَدٌ':Predicate, #1: 1	مِسَاحَةِ الْوَجْهِ
u'مَسَّ أحَدٌ':Subject, #1: 1	مَسَّ أَحَدَ
u'مَسَّ أحَدٌ':Subject, #1: 1	مَسَّ أَحَدٌ
u'مَسَّ أرْضٌ':Predicate, #1: 1	مَسَّ أَحَدُ
u'مَسَّ أرْضٌ':Predicate, #1: 1	مَسَّ الأَرْضَ
u'مُسَارَعَةٌ فساد':Added, #1: 1	مَسَّ الْأَرْضَ
u'مُسَارَعَةٌ فَسَادٌ':Added, #1: 1	مُسَارَعَةِ الْفَسَادِ
u'مَسَّ أَسْفَلُ':Predicate, #1: 1	مُسَارَعَةِ الْفَسَادِ
u'مُسَاعَدَةٌ أصل':Added, #1: 1	مَسَّ أَسْفَلَ
u'مُسَاعَدَةٌ أًصْلٌ':Added, #1: 1	مُسَاعَدَةِ أَصْلِ
u'مُسَاعَدَةٌ دَليلٌ':Added, #1: 1	مُسَاعَدَةِ أَصْلِ
u'مُسَاعَدَةٌ شَرِيكٌ':Added, #1: 1	مُسَاعَدَةِ الدَّلِيلِ
u'مُسَاعَدَةٌ قَدَرٌ':Added, #1: 1	مُسَاعَدَةِ شَرِيكِهِ
u'مُسَاعَدَةٌ قُرَيْشٌ':Added, #1: 1	مُسَاعَدَةَ الْقَدَرِ
u'مُسَاكَنَةٌ ذُلٌّ':Added, #1: 1	مُسَاعَدَةُ قُرَيْشٍ
u'مُسَاكَنَةٌ فُلاَنٌ':Added, #1: 1	مُسَاكَنَةَ الذُّلِّ
u'مُسَاكَنَةٌ فُلاَنٌ':Added, #1: 1	مُسَاكَنَةَ فُلَانٍ
u'مُسَاكَنَةٌ مُعْتَدٌّ':Added, #1: 1	مُسَاكَنَةِ فُلَانٍ
u'مَسَّ الْمَرْأَةُ':Predicate, #2: 2	مُسَاكَنَةُ الْمُعْتَدَّةِ
u'مَسَّ إِناءٌ':Predicate, #2: 2	مَسَّ الْمَرْأَةَ
u'مُسَاوَاةٌ أحَدٌ':Added, #1: 1	مَسَّ الْإِنَاءَ
u'مُسَاوَاةٌ أَخٌ':Added, #1: 1	مُسَاوَاةِ أَحَدٍ
u'مُسَاوَاةٌ إقامَةٌ':Added, #1: 1	مُسَاوَاةِ أَخٍ
u'مُسَاوَاةٌ إقْرَارٌ':Added, #1: 1	مُسَاوَاةِ إقَامَتِهِ
u'مُسَاوَاةٌ الْمَرْأَةُ':Added, #1: 1	مُسَاوَاةَ إقْرَارِهِ
u'مُسَاوَاةٌ إمَامٌ':Added, #1: 1	مُسَاوَاةِ الْمَرْأَةِ
u'مُسَاوَاةٌ أهْلٌ':Added, #2: 2	مُسَاوَاةِ الْإِمَامِ
u'مُسَاوَاةٌ بَعْضٌ':Added, #1: 1	مُسَاوَاةَ الْأَهْلِ
u'مُسَاوَاةٌ بَوْلٌ':Added, #1: 1	مُسَاوَاةُ بَعْضِ
u'مُسَاوَاةٌ بَيْضَةٌ':Added, #1: 1	مُسَاوَاةُ بَوْلِ
u'مُسَاوَاةٌ بَيْعٌ':Added, #1: 1	مُسَاوَاةَ بَيْضَةٍ
u'مُسَاوَاةٌ تَرْكٌ':Added, #1: 1	مُسَاوَاةِ الْبَيْعِ
u'مُسَاوَاةٌ تَصَرُّفٌ':Added, #1: 1	مُسَاوَاةَ تَرْكِهِ
u'مُسَاوَاةٌ تَصْوِيرٌ':Added, #1: 1	مُسَاوَاةِ تَصَرُّفِ
u'مُسَاوَاةٌ تَعْجِيل':Added, #1: 1	مُسَاوَاةِ التَّصْوِيرِ
u'مُسَاوَاةٌ ثَالِثٌ':Added, #1: 1	مُسَاوَاةُ التَّعْجِيلِ
u'مُسَاوَاةٌ جَارِحٌ':Added, #1: 1	مُسَاوَاةِ الثَّالِثِ
u'مُسَاوَاةٌ حُكْمٌ':Added, #1: 1	مُسَاوَاةِ الْجَارِحِ
u'مُسَاوَاةٌ حُكْمٌ':Added, #1: 1	مُسَاوَاةِ الْحُكْمَيْنِ
u'مُسَاوَاةٌ خَصْمٌ':Added, #1: 1	مُسَاوَاةَ حُكْمِ
u'مُسَاوَاةٌ دَمٌ':Added, #1: 1	مُسَاوَاةِ خَصْمِهِ
u'مُسَاوَاةٌ رَجُلٌ':Added, #1: 1	مُسَاوَاةَ الدَّمِ
u'مُسَاوَاةٌ رَدٌّ':Added, #1: 1	مُسَاوَاةِ الرَّجُلِ
u'مُسَاوَاةٌ رَهْنٌ':Added, #1: 1	مُسَاوَاةُ الرَّدِّ
u'مُسَاوَاةٌ زائِدٌ':Added, #1: 1	مُسَاوَاةَ الرَّهْنِ
u'مُسَاوَاةٌ زَمَنٌ':Added, #1: 1	مُسَاوَاةِ الزَّائِدِ
u'مُسَاوَاةٌ صدق':Added, #1: 1	مُسَاوَاةُ زَمَنِ
u'مُسَاوَاةٌ صِدْقٌ':Added, #1: 1	مُسَاوَاةِ الصِّدْقِ
u'مُسَاوَاةٌ صَلاَةٌ':Added, #1: 1	مُسَاوَاةِ الصِّدْقِ
u'مُسَاوَاةٌ صَوْمٌ':Added, #1: 1	مُسَاوَاةُ صَلَاتِهِ
u'مُسَاوَاةٌ عَبْدٌ':Added, #2: 2	مُسَاوَاةُ الصَّوْمِ
u'مُسَاوَاةٌ غير':Added, #1: 1	مُسَاوَاةِ الْعَبْدِ
u'مُسَاوَاةٌ غَيْرٌ':Added, #1: 1	مُسَاوَاةَ غَيْرِهِ
u'مُسَاوَاةٌ فَرْعٌ':Added, #1: 1	مُسَاوَاةَ غَيْرِهِ
u'مُسَاوَاةٌ فَرْعٌ':Added, #1: 1	مُسَاوَاةُ فَرْعٍ
u'مُسَاوَاةٌ فَرْعٌ':Added, #1: 1	مُسَاوَاةُ فَرْعِ
u'مُسَاوَاةٌ فَرْعٌ':Added, #1: 1	مُسَاوَاةِ فَرْعٍ
u'مُسَاوَاةٌ فِعْلٌ':Added, #2: 2	مُسَاوَاةَ الْفَرْعِ
u'مُسَاوَاةٌ قِيمَةٌ':Added, #1: 1	مُسَاوَاةِ الْفِعْلِ
u'مُسَاوَاةٌ كَلاَمٌ':Added, #1: 1	مُسَاوَاةِ الْقِيمَةِ
u'مُسَاوَاةٌ مَحَلٌّ':Added, #1: 1	مُسَاوَاةُ كَلَامِ
u'مُسَاوَاةٌ مَسْكُوتٌ':Added, #1: 1	مُسَاوَاةُ مَحَلٍّ
u'مُسَاوَاةٌ مَسْكُوتٌ':Added, #1: 1	مُسَاوَاةُ الْمَسْكُوتِ
u'مُسَاوَاةٌ مَنْطُوقٌ':Added, #3: 3	مُسَاوَاةِ الْمَسْكُوتِ
u'مُسَاوَمَةٌ جَابِرٌ':Added, #1: 1	مُسَاوَاةَ الْمَنْطُوقِ
u'مُسَايَرَةٌ أَلْفَاظٌ':Added, #1: 1	مُسَاوَمَةُ جَابِرٍ
u'مَسَّ ثَوْبٌ':Subject, #1: 1	مُسَايَرَةَ أَلْفَاظِ
u'مَسَّ جِدار':Predicate, #2: 2	مَسَّ ثَوْبُهُ
u'مَسَّ جلد':Predicate, #2: 2	مَسَّ الْجِدَارَ
u'مَسَّ جِلْدٌ':Predicate, #1: 1	مَسَّ الْجِلْدَ
u'مَسَّ جلد':Subject, #1: 1	مَسَّ الْجِلْدَ
u'مَسَّ جِلْدٌ':Subject, #1: 1	مَسَّ جِلْدُهُ
u'مَسَحَ أحَدٌ':Predicate, #1: 1	مَسَّ جِلْدُهُ
u'مَسَحَ أرْضٌ':Predicate, #1: 1	مَسَحَ أَحَدَ
u'مَسَحَ أَسْفَلُ':Predicate, #3: 3	مَسَحَ الْأَرْضَ
u'مَسْحٌ أَسْفَلُ':Added, #1: 1	مَسَحَ الْأَسْفَلَ
u'مَسْحٌ أَسْفَلُ':Added, #1: 1	مَسْحُ أَسْفَلِ
u'مَسْحٌ أَسْفَلُ':Added, #2: 2	مَسْحُ الْأَسْفَلِ
u'مَسْحٌ أَسْفَلُ':Added, #2: 2	مَسْحِ الْأَسْفَلِ
u'مَسْحٌ أَصابِعُ':Added, #3: 3	مَسْحِ أَسْفَلِهِ
u'مَسْحٌ أُصْبُعٌ':Added, #1: 1	مَسْحُ الْأَصَابِعِ
u'مَسْحٌ أَعْضَاءٌ':Added, #2: 2	مَسْحِ الْأُصْبُعِ
u'مَسْحٌ أَعْضَاءٌ':Added, #1: 1	مَسْحُ الْأَعْضَاءِ
u'مَسْحٌ أَعْضَاءٌ':Added, #1: 1	مَسْحِ الْأَعْضَاءِ
u'مَسْحٌ إقامَةٌ':Added, #2: 2	مَسْحُ أَعْضَاءِ
u'مَسَحَ أقَلُّ':Predicate, #2: 2	مَسْحَ الْإِقَامَةِ
u'مَسْحٌ أقَلُّ':Added, #3: 3	مَسَحَ أَقَلَّ
u'مَسَحَ أَكْثَرُ':Predicate, #1: 1	مَسْحِ أَقَلِّ
u'مَسْحٌ أَكْثَرُ':Added, #1: 1	مَسَحَ الْأَكْثَرَ
u'مَسْحٌ أَكْثَرُ':Added, #1: 1	مَسْحِ أَكْثَرِ
u'مَسْحٌ أَكْثَرُ':Added, #1: 1	مَسْحُ أَكْثَرِهِ
u'مَسَحَ إِنْسانٌ':Subject, #3: 3	مَسْحُ أَكْثَرِ
u'مَسَحَ بَاطن':Predicate, #1: 1	مَسَحَ الْإِنْسَانُ
u'مَسَحَ باطِنٌ':Predicate, #1: 1	مَسَحَ بَاطِنَ
u'مَسْحٌ بَاطن':Added, #1: 1	مَسَحَ بَاطِنَ
u'مَسْحٌ بَاطن':Added, #1: 1	مَسْحَ الْبَاطِنِ
u'مَسْحٌ باطِنٌ':Added, #1: 1	مَسْحُ الْبَاطِنِ
u'مَسْحٌ باطِنٌ':Added, #1: 1	مَسْحَ الْبَاطِنِ
u'مَسْحٌ بَاطن':Added, #1: 1	مَسْحُ الْبَاطِنِ
u'مَسْحٌ باطِنٌ':Added, #1: 1	مَسْحُ بَاطِنِهِ
u'مَسْحٌ بَاطن':Added, #1: 1	مَسْحُ بَاطِنِهِ
u'مَسْحٌ باطِنٌ':Added, #2: 2	مَسْحِ بَاطِنِ
u'مَسْحٌ بَاطن':Added, #2: 2	مَسْحِ بَاطِنِ
u'مَسْحٌ باطِنٌ':Added, #3: 3	مَسْحُ بَاطِنِ
u'مَسَحَ بَشَرَةٌ':Predicate, #3: 3	مَسْحُ بَاطِنِ
u'مَسَحَ بَشَرَةٌ':Predicate, #1: 1	مَسَحَ الْبَشَرَةَ
u'مَسْحٌ بَشَرَةٌ':Added, #2: 2	مَسَحَ بَشَرَةَ
u'مَسْحٌ بَشَرَةٌ':Added, #1: 1	مَسْحِ الْبَشَرَةِ
u'مَسْحٌ بَطْنٌ':Added, #2: 2	مَسْحُ الْبَشَرَةِ
u'مَسْحٌ بَطْنٌ':Added, #1: 1	مَسْحِ الْبَطْنِ
u'مَسَحَ بَعْضٌ':Predicate, #1: 1	مَسْحَ بَطْنِهِ
u'مَسْحٌ بَعْضٌ':Added, #1: 1	مَسَحَ بَعْضَ
u'مَسْحٌ بَعْضٌ':Added, #1: 1	مَسْحَ الْبَعْضِ
u'مَسْحٌ بَعْضٌ':Added, #1: 1	مَسْحُ الْبَعْضِ
u'مَسْحٌ بَعْضٌ':Added, #1: 1	مَسْحِ الْبَعْضِ
u'مَسْحٌ بَعْضٌ':Added, #1: 1	مَسْحُ بَعْضٍ
u'مَسْحٌ بَعْضٌ':Added, #1: 1	مَسْحَ بَعْضِهِ
u'مَسْحٌ بَعْضٌ':Added, #3: 3	مَسْحُ بَعْضِهِ
u'مَسْحٌ بَعْضٌ':Added, #5: 5	مَسْحِ بَعْضِ
u'مَسَحَ بَوْلٌ':Predicate, #8: 8	مَسْحُ بَعْضِ
u'مسحة أهْلٌ':Added, #1: 1	مَسَحَ الْبَوْلَ
u'مَسْحَةٌ أهْلٌ':Added, #1: 1	مَسْحَةُ أَهْلِ
u'مسحة جَمَالٌ':Added, #1: 1	مَسْحَةُ أَهْلِ
u'مَسْحَةٌ جَمَالٌ':Added, #1: 1	مَسْحَةُ جَمَالٍ
u'مسحة مُلْكٌ':Added, #1: 1	مَسْحَةُ جَمَالٍ
u'مَسْحَةٌ مُلْكٌ':Added, #1: 1	مَسْحَةُ مُلْكٍ
u'مَسْحٌ تُرَابٌ':Added, #1: 1	مَسْحَةُ مُلْكٍ
u'مَسَحَ تمام':Predicate, #2: 2	مَسْحُ التُّرَابِ
u'مَسَحَ تَمامٌ':Predicate, #1: 1	مَسَحَ تَمَامَ
u'مَسَحَ ثَلاثُ':Predicate, #1: 1	مَسَحَ تَمَامَ
u'مَسْحٌ ثَلاثُ':Added, #2: 2	مَسَحَ ثَلَاثَ
u'مَسَحَ ثَلاثَةٌ':Predicate, #1: 1	مَسْحَ ثَلَاثِ
u'مَسْحٌ ثَلاثَةٌ':Added, #3: 3	مَسَحَ ثَلَاثَةَ
u'مَسْحٌ جَبْهَةٌ':Added, #2: 2	مَسْحُ ثَلَاثَةِ
u'مَسْحٌ جَبْهَةٌ':Added, #1: 1	مَسْحَ جَبْهَتِهِ
u'مَسَحَ جَبِيرَة':Predicate, #2: 2	مَسْحَ الْجَبْهَةِ
u'مَسْحٌ جَبِيرَة':Added, #1: 1	مَسَحَ جَبِيرَةَ
u'مَسْحٌ جَبِيرَة':Added, #1: 1	مَسْحُ جَبِيرَةٍ
u'مَسْحٌ جَبِيرَة':Added, #6: 6	مَسْحُ الْجَبِيرَةِ
u'مَسْحٌ جَبِيرَة':Added, #7: 7	مَسْحِ الْجَبِيرَةِ
u'مَسَّ حَجَرٌ':Predicate, #8: 8	مَسْحَ الْجَبِيرَةِ
u'مَسَّ حَجَرٌ':Predicate, #2: 2	مَسَّ الْحَجَرَ
u'مَسْحٌ جِرَاحَةٌ':Added, #4: 4	أَمَسَّ الْحَجَرَ
u'مَسْحٌ جُرْحٌ':Added, #1: 1	مَسْحُ الْجِرَاحَةِ
u'مَسْحٌ جَرِيحٌ':Added, #1: 1	مَسْحُ الْجُرْحِ
u'مَسْحٌ جُزْءٌ':Added, #1: 1	مَسْحَ الْجَرِيحِ
u'مَسْحٌ جَمِيع':Added, #1: 1	مَسْحِ جُزْءٍ
u'مَسْحٌ جَمِيع':Added, #2: 2	مَسْحَ الْجَمِيعِ
u'مَسْحٌ جَوْرَبٌ':Added, #4: 4	مَسْحِ الْجَمِيعِ
u'مَسْحٌ جَوْرَبٌ':Added, #1: 1	مَسْحُ جَوْرَبٍ
u'مَسْحٌ حائِلٌ':Added, #2: 2	مَسْحُ الْجَوْرَبِ
u'مَسَحَ حِجامٌ':Subject, #2: 2	مَسْحِ الْحَائِلِ
u'مَسْحٌ حَجَرٌ':Added, #1: 1	مَسَحَ الْحِجَامُ
u'مَسْحٌ حُلْقُومٌ':Added, #2: 2	مَسْحُ الْحَجَرِ
u'مَسْحٌ خرقة':Added, #2: 2	مَسْحُ الْحُلْقُومِ
u'مَسْحٌ خِرْقَةٌ':Added, #1: 1	مَسْحُ الْخِرْقَةِ
u'مَسْحٌ خُفٌّ':Added, #1: 1	مَسْحُ الْخِرْقَةِ
u'مَسْحٌ خُفٌّ':Added, #14: 14	مَسْحِ الْخُفَّيْنِ
u'مَسْحٌ خُفٌّ':Added, #1: 1	مَسْحُ الْخُفَّيْنِ
u'مَسْحٌ خُفٌّ':Added, #33: 33	مَسْحِ الْخُفِّ
u'مَسْحٌ خُفٌّ':Added, #7: 7	مَسْحُ الْخُفِّ
u'مَسْحٌ دَاخِلٌ':Added, #8: 8	مَسْحَ الْخُفِّ
u'مَسْحٌ دَائِمٌ':Added, #2: 2	مَسْحُ دَاخِلِ
u'مَسْحٌ دَمٌ':Added, #1: 1	مَسْحُ دَائِمِ
u'مَسْحٌ ذِراعٌ':Added, #1: 1	مَسْحُ دَمِ
u'مَسْحٌ ذِراعٌ':Added, #2: 2	مَسْحُ الذِّرَاعَيْنِ
u'مَسَحَ رَأْسٌ':Predicate, #4: 4	مَسْحِ الذِّرَاعَيْنِ
u'مَسَحَ رَأْسٌ':Predicate, #1: 1	مَسَحَ رَأْسَ
u'مَسْحٌ رَأْسٌ':Added, #4: 4	مَسَحَ الرَّأْسَ
u'مَسْحٌ رَأْسٌ':Added, #107: 107	مَسْحِ الرَّأْسِ
u'مَسْحٌ رَأْسٌ':Added, #10: 10	مَسْحِ رَأْسِهِ
u'مَسْحٌ رَأْسٌ':Added, #13: 13	مَسْحَ رَأْسِهِ
u'مَسْحٌ رَأْسٌ':Added, #17: 17	مَسْحُ الرَّأْسِ
u'مَسْحٌ رَأْسٌ':Added, #1: 1	مَسْحِ رَأْسِ
u'مَسْحٌ رَأْسٌ':Added, #8: 8	مَسْحَ الرَّأْسِ
u'مَسَحَ رَجُلٌ':Subject, #9: 9	مَسْحُ رَأْسِهِ
u'مَسْحٌ رَجُلٌ':Added, #1: 1	مَسَحَ الرَّجُلُ
u'مَسَحَ رَسُولٌ':Subject, #1: 1	مَسْحُ الرَّجُلِ
u'مَسْحٌ رَسُولٌ':Added, #6: 6	مَسَحَ رَسُولُ
u'مَسْحٌ رَقَبَةٌ':Added, #1: 1	مَسْحَ رَسُولِ
u'مَسْحٌ رَقَبَةٌ':Added, #1: 1	مَسْحَ الرَّقَبَةِ
u'مَسْحٌ رَقَبَةٌ':Added, #1: 1	مَسْحِ الرَّقَبَةِ
u'مَسَحَ رُكْنٌ':Predicate, #4: 4	مَسْحُ الرَّقَبَةِ
u'مَسَحَ رُكْن':Predicate, #1: 1	مَسَحَ الرُّكْنَ
u'مَسْحٌ سَاتِرٌ':Added, #1: 1	مَسَحَ الرُّكْنَ
u'مَسَحَ سَاقٌ':Predicate, #2: 2	مَسْحِ السَّاتِرِ
u'مَسَحَ سِكِّينٌ':Predicate, #1: 1	مَسَحَ السَّاقَ
u'مَسْحٌ سِكِّينٌ':Added, #1: 1	مَسَحَ السِّكِّينَ
u'مَسَّحَ سَوادٌ':Predicate, #2: 2	مَسْحِ السِّكِّينِ
u'مَسْحٌ شَعْرٌ':Added, #1: 1	مَسَّحَ السَّوَادَ
u'مَسْحٌ شَعْرٌ':Added, #1: 1	مَسْحُ الشَّعْرِ
u'مَسْحٌ شَعْرٌ':Added, #1: 1	مَسْحَ شَعْرِ
u'مَسَحَ شمال':Predicate, #1: 1	مَسْحُ شَعْرِهِ
u'مَسَحَ شِمَالٌ':Predicate, #2: 2	مَسَحَ الشِّمَالَ
u'مَسْحٌ شَيْءٌ':Added, #2: 2	مَسَحَ الشِّمَالَ
u'مَسْحٌ صَحْفَةٌ':Added, #1: 1	مَسْحِ شَيْءٍ
u'مَسْحٌ صِمَاخٌ':Added, #2: 2	مَسْحُ الصَّحْفَةِ
u'مَسْحٌ صِمَاخٌ':Added, #1: 1	مَسْحَ الصِّمَاخِ
u'مَسْحٌ صِمَاخٌ':Added, #1: 1	مَسْحُ الصِّمَاخَيْنِ
u'مَسْحٌ صِمَاخٌ':Added, #1: 1	مَسْحِ الصِّمَاخَيْنِ
u'مَسَحَ ظاهِرٌ':Predicate, #2: 2	مَسْحَ الصِّمَاخَيْنِ
u'مَسْحٌ ظاهِرٌ':Added, #3: 3	مَسَحَ ظَاهِرَ
u'مَسْحٌ ظاهِرٌ':Added, #1: 1	مَسْحِ الظَّاهِرِ
u'مَسْحٌ ظاهِرٌ':Added, #1: 1	مَسْحُ ظَاهِرِ
u'مَسْحٌ ظاهِرٌ':Added, #1: 1	مَسْحِ ظَاهِرِ
u'مَسْحٌ ظاهِرٌ':Added, #1: 1	مَسْحُ ظَاهِرِهِ
u'مَسْحٌ ظَهْرٌ':Added, #1: 1	مَسْحِ ظَاهِرِهِ
u'مَسْحٌ ظَهْرٌ':Added, #1: 1	مَسْحُ ظَهْرِ
u'مَسَحَ ظُهورٌ':Predicate, #1: 1	مَسْحِ ظَهْرِهِ
u'مَسْحٌ عِذَارٌ':Added, #1: 1	مَسَحَ ظُهُورَ
u'مَسْحٌ عَرَقٌ':Added, #1: 1	مَسْحُ الْعِذَارِ
u'مَسْحٌ عِصَابَةٌ':Added, #2: 2	مَسْحِ الْعَرَقِ
u'مَسْحٌ عُضْوٌ':Added, #1: 1	مَسْحِ الْعِصَابَةِ
u'مَسْحٌ عُضْوٌ':Added, #1: 1	مَسْحِ عُضْوٍ
u'مَسَحَ عَلِيٌّ':Subject, #2: 2	مَسْحَ الْعُضْوِ
u'مَسْحٌ عَلِيلٌ':Added, #1: 1	مَسَحَ عَلِيٌّ
u'مَسْحٌ عِمَامَةٌ':Added, #1: 1	مَسْحُ الْعَلِيلِ
u'مَسْحٌ عِمَامَةٌ':Added, #1: 1	مَسْحَ الْعِمَامَةِ
u'مَسْحٌ عِمَامَةٌ':Added, #1: 1	مَسْحُ الْعِمَامَةِ
u'مَسْحٌ عنق':Added, #2: 2	مَسْحِ الْعِمَامَةِ
u'مَسْحٌ عُنُقٌ':Added, #1: 1	مَسْحَ الْعُنُقِ
u'مَسْحٌ عنق':Added, #1: 1	مَسْحَ الْعُنُقِ
u'مَسْحٌ عُنُقٌ':Added, #2: 2	مَسْحِ الْعُنُقِ
u'مَسْحٌ عنق':Added, #2: 2	مَسْحِ الْعُنُقِ
u'مَسْحٌ عُنُقٌ':Added, #2: 2	مَسْحِ عُنُقِهِ
u'مَسْحٌ عنق':Added, #2: 2	مَسْحِ عُنُقِهِ
u'مَسْحٌ عُنُقٌ':Added, #3: 3	مَسْحُ الْعُنُقِ
u'مَسْحٌ غُسْلٌ':Added, #3: 3	مَسْحُ الْعُنُقِ
u'مَسْحٌ غُسْلٌ':Added, #1: 1	مَسْحَ الْغُسْلِ
u'مَسَحَ غير':Predicate, #1: 1	مَسْحِ الْغُسْلِ
u'مَسَحَ غَيْرٌ':Predicate, #1: 1	مَسَحَ غَيْرَ
u'مَسْحٌ غير':Added, #1: 1	مَسَحَ غَيْرَ
u'مَسْحٌ غير':Added, #1: 1	مَسْحُ غَيْرِ
u'مَسْحٌ غَيْرٌ':Added, #1: 1	مَسْحِ غَيْرِ
u'مَسْحٌ غَيْرٌ':Added, #1: 1	مَسْحُ غَيْرِ
u'مَسْحٌ فَرْضٌ':Added, #1: 1	مَسْحِ غَيْرِ
u'مَسَحَ قَالٌ':Predicate, #1: 1	مَسْحِ الْفَرْضِ
u'مَسْحٌ قَدْرٌ':Added, #2: 2	مَسَحَ قَالَ
u'مَسْحٌ قدم':Added, #2: 2	مَسْحُ قَدْرِ
u'مَسْحٌ قَدَمٌ':Added, #2: 2	مَسْحَ الْقَدَمِ
u'مَسَحَ قَفَا':Subject, #2: 2	مَسْحَ الْقَدَمِ
u'مَسْحٌ قَلَنْسُوَةٌ':Added, #2: 2	مَسَحَ قَفَاهُ
u'مَسْحٌ كَفٌّ':Added, #1: 1	مَسْحُ الْقَلَنْسُوَةِ
u'مَسْحٌ لِحْيَةٌ':Added, #1: 1	مَسْحِ الْكَفِّ
u'مَسْحٌ لِحْيَةٌ':Added, #1: 1	مَسْحَ اللِّحْيَةِ
u'مَسْحٌ لمعة':Added, #3: 3	مَسْحُ اللِّحْيَةِ
u'مَسْحٌ مَحَاجِمُ':Added, #2: 2	مَسْحُ اللُّمْعَةِ
u'مَسْحٌ مُحْرِمٌ':Added, #1: 1	مَسْحُ الْمَحَاجِمِ
u'مَسْحٌ مَحَلٌّ':Added, #1: 1	مَسْحِ الْمُحْرِمِ
u'مَسَحَ مَدِينٌ':Predicate, #1: 1	مَسْحِ مَحَلِّهِ
u'مَسَحَ مَدِينَةٌ':Predicate, #1: 1	مَسَحَ الْمَدِينَةَ
u'مَسَحَ مرٌّ':Predicate, #1: 1	مَسَحَ الْمَدِينَةَ
u'مَسْحٌ مُسَافِرٌ':Added, #2: 2	مَسَحَ مَرَّةً
u'مَسْحٌ مُسَافِرٌ':Added, #14: 14	مَسْحَ مُسَافِرٍ
u'مَسْحٌ مُسَافِرٌ':Added, #1: 1	مَسْحَ الْمُسَافِرِ
u'مَسْحٌ مُسَافِرٌ':Added, #1: 1	مَسْحِ الْمُسَافِرِ
u'مَسْحٌ مُسَافِرٌ':Added, #1: 1	مَسْحُ مُسَافِرٍ
u'مَسَحَ مَسْجِدٌ':Predicate, #1: 1	مَسْحِ مُسَافِرٍ
u'مَسَحَ مِقْدَارٌ':Predicate, #1: 1	مَسَحَ الْمَسْجِدَ
u'مَسْحٌ مِقْدَارٌ':Added, #1: 1	مَسَحَ مِقْدَارَ
u'مَسَحَ مُقَدِّمٌ':Predicate, #1: 1	مَسْحِ مِقْدَارِ
u'مَسَحَ مُقِيمٌ':Subject, #2: 2	مَسَحَ مُقَدِّمَةً
u'مَسْحٌ مُقِيمٌ':Added, #2: 2	مَسَحَ مُقِيمٌ
u'مَسْحٌ مُقِيمٌ':Added, #13: 13	مَسْحَ مُقِيمٍ
u'مَسْحٌ مُقِيمٌ':Added, #1: 1	مَسْحَ الْمُقِيمِ
u'مَسْحٌ مُقِيمٌ':Added, #1: 1	مَسْحُ الْمُقِيمِ
u'مَسْحٌ مُقِيمٌ':Added, #2: 2	مَسْحِ الْمُقِيمِ
u'مَسْحٌ مُقِيمٌ':Added, #2: 2	مَسْحُ مُقِيمٍ
u'مَسَحَ مَوْضِعٌ':Predicate, #2: 2	مَسْحِ مُقِيمٍ
u'مَسْحٌ مَوْضِعٌ':Added, #3: 3	مَسَحَ مَوْضِعَ
u'مَسْحٌ مَوْضِعٌ':Added, #1: 1	مَسْحِ الْمَوْضِعِ
u'مَسْحٌ مَوْضِعٌ':Added, #1: 1	مَسْحِ مَوْضِعِ
u'مَسْحٌ نَاصِيَةٌ':Added, #3: 3	مَسْحُ مَوْضِعِ
u'مَسْحٌ نَاصِيَةٌ':Added, #1: 1	مَسْحَ النَّاصِيَةِ
u'مَسْحٌ نَاصِيَةٌ':Added, #1: 1	مَسْحُ النَّاصِيَةِ
u'مَسْحٌ نَبِيٌّ':Added, #1: 1	مَسْحِ النَّاصِيَةِ
u'مَسْحٌ نَفْسٌ':Added, #1: 1	مَسْحُ النَّبِيِّ
u'مَسْحٌ نُفَسَاءُ':Added, #1: 1	مَسْحِ نَفْسِ
u'مَسَحَ وَجْهٌ':Predicate, #1: 1	مَسْحِ النُّفَسَاءِ
u'مَسْحٌ وَجْهٌ':Added, #1: 1	مَسَحَ الْوَجْهَ
u'مَسْحٌ وَجْهٌ':Added, #1: 1	مَسْحَ وَجْهِهِ
u'مَسْحٌ وَجْهٌ':Added, #2: 2	مَسْحَ الْوَجْهِ
u'مَسْحٌ وَجْهٌ':Added, #3: 3	مَسْحِ وَجْهِهِ
u'مَسْحٌ وَجْهٌ':Added, #6: 6	مَسْحُ الْوَجْهِ
u'مَسْحٌ وسط':Added, #7: 7	مَسْحِ الْوَجْهِ
u'مَسْحٌ وَسَطٌ':Added, #1: 1	مَسْحُ وَسَطِ
u'مَسْحٌ وُضُوءٌ':Added, #1: 1	مَسْحُ وَسَطِ
u'مَسْحٌ وُضُوءٌ':Added, #1: 1	مَسْحَ الْوُضُوءِ
u'مَسَحَ يَدٌ':Predicate, #2: 2	مَسْحُ الْوُضُوءِ
u'مَسْحٌ يَدٌ':Added, #1: 1	مَسَحَ الْيَدَ
u'مَسْحٌ يَدٌ':Added, #1: 1	مَسْحُ الْيَدِ
u'مَسْحٌ يَدٌ':Added, #1: 1	مَسْحَ يَدِهِ
u'مَسْحٌ يَدٌ':Added, #3: 3	مَسْحُ الْيَدَيْنِ
u'مَسْحٌ يَدٌ':Added, #4: 4	مَسْحِ الْيَدِ
u'مَسْحٌ يَوْمٌ':Added, #4: 4	مَسْحِ الْيَدَيْنِ
u'مَسْخٌ بدن':Added, #1: 1	مَسْحَ يَوْمٍ
u'مَسْخٌ بَدَنٌ':Added, #1: 1	مَسْخُ الْبَدَنِ
u'مَسَّ ختان':Subject, #1: 1	مَسْخُ الْبَدَنِ
u'مَسَّ خِتَانٌ':Subject, #3: 3	مَسَّ الْخِتَانُ
u'مَسْخٌ جِنٌّ':Added, #3: 3	مَسَّ الْخِتَانُ
u'مَسْخٌ جِنٌّ':Added, #1: 1	مَسْخِ الْجِنِّ
u'مَسْخٌ حَلالٌ':Added, #4: 4	مَسْخُ الْجِنِّ
u'مَسْخٌ خلقة':Added, #1: 1	مَسْخِ حَلَالٍ
u'مَسْخٌ خِلْقَةٌ':Added, #1: 1	مَسْخِ الْخِلْقَةِ
u'مَسْخٌ قلب':Added, #1: 1	مَسْخِ الْخِلْقَةِ
u'مَسْخٌ قَلْبٌ':Added, #1: 1	مَسْخُ الْقَلْبِ
u'مَسْخٌ قَلْب':Added, #1: 1	مَسْخُ الْقَلْبِ
u'مَسَّ درجة':Predicate, #1: 1	مَسْخُ الْقَلْبِ
u'مَسَّ دَرَجَةٌ':Predicate, #1: 1	مَسَّ دَرَجَةَ
u'مَسَّ ذكر':Predicate, #1: 1	مَسَّ دَرَجَةَ
u'مَسَّ ذَكَرٌ':Predicate, #1: 1	مَسَّ ذَكَرَ
u'مَسَّ ذكر':Predicate, #1: 1	مَسَّ ذَكَرَ
u'مَسَّ ذَكَرٌ':Predicate, #2: 2	مَسَّ الذَّكَرَ
u'مَسَّ رَأْسٌ':Predicate, #2: 2	مَسَّ الذَّكَرَ
u'مَسَّ رَجُلٌ':Subject, #1: 1	مَسَّ رَأْسَ
u'مَسَّ رَجُلٌ':Subject, #3: 3	مَسَّ الرَّجُلُ
u'مَسَّ زَعْفَرانٌ':Predicate, #4: 4	مَسَّ رَجُلٌ
u'مَسَّ سَقَرُ':Predicate, #1: 1	مَسَّ الزَّعْفَرَانَ
u'مَسَّ سَمَاءٌ':Predicate, #5: 5	مَسَّ سَقَرَ
u'مَسَّ شَعَرٌ':Predicate, #5: 5	أَمَسَّ السَّمَاءَ
u'مَسَّ شَعْرٌ':Predicate, #1: 1	مَسَّ شَعَرَ
u'مَسَّ طِيبٌ':Predicate, #1: 1	مَسَّ شَعْرَ
u'مَسَّ فَدَّانٌ':Predicate, #1: 1	مَسَّ الطِّيبَ
u'مَسَّ فَرْجٌ':Predicate, #1: 1	مَسَّ الْفَدَّانَ
u'مَسَّ قُبُلٌ':Predicate, #3: 3	مَسَّ فَرْجَ
u'مَسْكٌ أَنْفٌ':Added, #1: 1	مَسَّ قُبُلَ
u'مسكة يَقِظٌ':Added, #1: 1	مَسْكُ أَنْفِهِ
u'مَسْكَةٌ يَقِظٌ':Added, #1: 1	مَسْكَةَ الْيَقِظَةِ
u'مسكة يَقَظَةٌ':Added, #1: 1	مَسْكَةَ الْيَقِظَةِ
u'مَسْكَةٌ يَقَظَةٌ':Added, #1: 1	مَسْكَةَ الْيَقَظَةِ
u'مَسْكٌ ثَوْرٌ':Added, #1: 1	مَسْكَةَ الْيَقَظَةِ
u'مَسْكٌ ثَوْرٌ':Added, #1: 1	مَسْكِ الثَّوْرِ
u'مَسْكٌ ذكر':Added, #1: 1	مَسْكِ ثَوْرٍ
u'مَسْكٌ ذَكَرٌ':Added, #1: 1	مَسْكِ ذَكَرِهِ
u'مَسْكٌ شَاةٌ':Added, #1: 1	مَسْكِ ذَكَرِهِ
u'مَسَّ كَفٌّ':Predicate, #2: 2	مَسْكَ شَاةٍ
u'مَسَّ كَلْبٌ':Subject, #3: 3	مَسَّ كَفَّ
u'مَسَكَ مَكَس':Predicate, #1: 1	مَسَّ الْكَلْبُ
u'مَسَّ مَخْرَجٌ':Predicate, #1: 1	مَسَكَ الْمَكَسَةَ
u'مَسَّ مُسْتَرْسِلٌ':Predicate, #1: 1	مَسَّ مَخْرَجَ
u'مَسَّ مُشْكِلٌ':Subject, #1: 1	مَسَّ الْمُسْتَرْسِلَ
u'مَسَّ مُغْتَسِلٌ':Subject, #1: 1	مَسَّ مُشْكِلٌ
u'مَسَّ واحد':Predicate, #1: 1	مَسَّ الْمُغْتَسِلُ
u'مَسَّ وَاحِدٌ':Predicate, #1: 1	أَمَسَّ وَاحِدَةً
u'مَسَّ وَرْسٌ':Predicate, #1: 1	أَمَسَّ وَاحِدَةً
u'مَسَّ وَرْسٌ':Subject, #1: 1	مَسَّ الْوَرْسَ
u'مَسِيرٌ أَرْبَعَةٌ':Added, #5: 5	مَسَّ الْوَرْسُ
u'مَسِيرٌ أَمْيَالٌ':Added, #1: 1	مَسِيرُ أَرْبَعَةِ
u'مَسِيرَةٌ أَرْبَعَةٌ':Added, #1: 1	مَسِيرِ أَمْيَالٍ
u'مَسِيرَةٌ أَرْبَعَةٌ':Added, #2: 2	مَسِيرَةِ أَرْبَعَةِ
u'مَسِيرَةٌ ألف':Added, #4: 4	مَسِيرَةُ أَرْبَعَةِ
u'مَسِيرَةٌ ألْفٌ':Added, #2: 2	مَسِيرَةَ أَلْفِ
u'مَسِيرَةٌ أَلْفٌ':Added, #2: 2	مَسِيرَةَ أَلْفِ
u'مَسِيرَةٌ ألف':Added, #2: 2	مَسِيرَةَ أَلْفِ
u'مَسِيرَةٌ ألْفٌ':Added, #5: 5	مَسِيرَةِ أَلْفِ
u'مَسِيرَةٌ أَلْفٌ':Added, #5: 5	مَسِيرَةِ أَلْفِ
u'مَسِيرَةٌ أيَّامٌ':Added, #5: 5	مَسِيرَةِ أَلْفِ
u'مَسِيرَةٌ أيَّامٌ':Added, #1: 1	مَسِيرَةَ أَيَّامٍ
u'مَسِيرَةٌ أَيَّامٌ':Added, #1: 1	مَسِيرَةِ أَيَّامٍ
u'مَسِيرَةٌ أَيَّامٌ':Added, #1: 1	مَسِيرَةَ أَيَّامٍ
u'مَسِيرَةٌ بَعْضٌ':Added, #1: 1	مَسِيرَةِ أَيَّامٍ
u'مَسِيرَةٌ ثَلاثُ':Added, #1: 1	مَسِيرَةِ بَعْضِ
u'مَسِيرَةٌ ثَلاثُ':Added, #1: 1	مَسِيرَةَ ثَلاثِ
u'مَسِيرَةٌ ثَلاثُ':Added, #1: 1	مَسِيرَةَ ثَلَاثِ
u'مَسِيرَةٌ ثَلاثَةٌ':Added, #1: 1	مَسِيرَةُ ثَلَاثِ
u'مَسِيرَةٌ ثَلاثَةٌ':Added, #16: 16	مَسِيرَةُ ثَلَاثَةِ
u'مَسِيرَةٌ ثَلاثَةٌ':Added, #1: 1	مَسِيرَةَ ثَلاثَةِ
u'مَسِيرَةٌ ثَلاثَةٌ':Added, #1: 1	مَسِيرَةَ ثَلاَثَةِ
u'مَسِيرَةٌ ثَلاثَةٌ':Added, #24: 24	مَسِيرَةِ ثَلَاثَةِ
u'مَسِيرَةٌ خَمْسٌ':Added, #29: 29	مَسِيرَةَ ثَلَاثَةِ
u'مَسِيرَةٌ خَمْسَةٌ':Added, #1: 1	مَسِيرَةُ خَمْسِ
u'مَسِيرَةٌ سَبْعٌ':Added, #2: 2	مَسِيرَةِ خَمْسَةِ
u'مَسِيرَةٌ سِتٌّ':Added, #1: 1	مَسِيرَةَ سَبْعِ
u'مَسِيرَةٌ سَفَرٌ':Added, #2: 2	مَسِيرَةَ سِتَّةِ
u'مَسِيرَةٌ سَفَرٌ':Added, #12: 12	مَسِيرَةِ السَّفَرِ
u'مَسِيرَةٌ سَفَرٌ':Added, #12: 12	مَسِيرَةَ سَفَرٍ
u'مَسِيرَةٌ سَفَرٌ':Added, #15: 15	مَسِيرَةِ سَفَرٍ
u'مَسِيرَةٌ سَفَرٌ':Added, #1: 1	مَسِيرَةُ سَفَرِ
u'مَسِيرَةٌ سَفَرٌ':Added, #2: 2	مَسِيرَةَ السَّفَرِ
u'مَسِيرَةٌ سَنَةٌ':Added, #8: 8	مَسِيرَةُ سَفَرٍ
u'مَسِيرَةٌ شَهْرٌ':Added, #1: 1	مَسِيرَةُ سَنَةٍ
u'مَسِيرَةٌ شَهْرٌ':Added, #14: 14	مَسِيرَةَ شَهْرٍ
u'مَسِيرَةٌ شَهْرٌ':Added, #1: 1	مَسِيرَةِ شَهْرَيْنِ
u'مَسِيرَةٌ شَهْرٌ':Added, #2: 2	مَسِيرَةَ شَهْرَيْنِ
u'مَسِيرَةٌ شَهْرٌ':Added, #4: 4	مَسِيرَةِ شَهْرٍ
u'مَسِيرَةٌ طلب':Added, #8: 8	مَسِيرَةُ شَهْرٍ
u'مَسِيرَةٌ طَلَبٌ':Added, #1: 1	مَسِيرَةِ الطَّلَبِ
u'مَسِيرَةٌ عَدُوٌّ':Added, #1: 1	مَسِيرَةِ الطَّلَبِ
u'مَسِيرَةٌ عَرْضٌ':Added, #1: 1	مَسِيرَةُ الْعَدُوِّ
u'مَسِيرَةٌ لَيْلٌ':Added, #2: 2	مَسِيرَةُ عَرْضِهِ
u'مَسِيرَةٌ لَيْلٌ':Added, #2: 2	مَسِيرَةِ لَيْلَةٍ
u'مَسِيرَةٌ ميل':Added, #4: 4	مَسِيرَةَ لَيْلَةٍ
u'مَسِيرَةٌ مَيْلٌ':Added, #1: 1	مَسِيرَةَ مَيْلٍ
u'مَسِيرَةٌ يَوْمٌ':Added, #1: 1	مَسِيرَةَ مَيْلٍ
u'مَسِيرَةٌ يَوْمٌ':Added, #10: 10	مَسِيرَةَ يَوْمٍ
u'مَسِيرَةٌ يَوْمٌ':Added, #1: 1	مَسِيرَةِ الْيَوْمِ
u'مَسِيرَةٌ يَوْمٌ':Added, #3: 3	مَسِيرَةُ يَوْمٍ
u'مَسِيرَةٌ يَوْمٌ':Added, #3: 3	مَسِيرَةَ يَوْمَيْنِ
u'مَسِيرَةٌ يَوْمٌ':Added, #5: 5	مَسِيرَةِ يَوْمٍ
u'مَسِيرٌ جَيْشٌ':Added, #5: 5	مَسِيرَةِ يَوْمَيْنِ
u'مَسِيرٌ خَالِدٌ':Added, #1: 1	مَسِيرِ الْجَيْشِ
u'مَسِيرٌ رَسُولٌ':Added, #2: 2	مَسِيرُ خَالِدِ
u'مَسِيرٌ شمس':Added, #1: 1	مَسِيرِ رَسُولِ
u'مَسِيرٌ شَمْسٌ':Added, #1: 1	مَسِيرَ الشَّمْسِ
u'مَسِيرٌ قُرَيْشٌ':Added, #1: 1	مَسِيرَ الشَّمْسِ
u'مَسِيرٌ قمر':Added, #1: 1	مَسِيرَ قُرَيْشٍ
u'مَسِيرٌ قَمَرٌ':Added, #1: 1	مَسِيرَ الْقَمَرِ
u'مَسِيلٌ بَوْلٌ':Added, #1: 1	مَسِيرَ الْقَمَرِ
u'مَسِيلٌ سَطْحٌ':Added, #1: 1	مَسِيلَ الْبَوْلِ
u'مَسِيلٌ صَغِيرٌ':Added, #1: 1	مَسِيلُ سَطْحِ
u'مَسِيلٌ طَرِيقٌ':Added, #1: 1	مَسِيلٍ صَغِيرٍ
u'مَسِيلٌ فَاضِلٌ':Added, #1: 1	مَسِيلِ الطَّرِيقِ
u'مَسِيلٌ مَاءٌ':Added, #1: 1	مَسِيلِ الْفَاضِلِ
u'مَسِيلٌ مَاءٌ':Added, #13: 13	مَسِيلُ مَاءٍ
u'مَسِيلٌ مَاءٌ':Added, #15: 15	مَسِيلُ الْمَاءِ
u'مَسِيلٌ مَاءٌ':Added, #1: 1	مَسِيل مَاءٍ
u'مَسِيلٌ مَاءٌ':Added, #25: 25	مَسِيلِ الْمَاءِ
u'مَسِيلٌ مَاءٌ':Added, #3: 3	مَسِيلَ مَاءِ
u'مَسِيلٌ مَاءٌ':Added, #4: 4	مَسِيلُ مَاءِ
u'مَسِيلٌ مَاءٌ':Added, #4: 4	مَسِيلِ مَاءٍ
u'مَسِيلٌ مَاءٌ':Added, #7: 7	مَسِيلَ الْمَاءِ
u'مَسِيلٌ مِرْحَاضٌ':Added, #8: 8	مَسِيلَ مَاءٍ
u'مَسِيلٌ مِرْحَاضٌ':Added, #1: 1	مَسِيلِ الْمِرْحَاضِ
u'مَسِيلٌ مَصَبٌّ':Added, #2: 2	مَسِيلَ الْمِرْحَاضِ
u'مَسِيلٌ مَصَبٌّ':Added, #1: 1	مَسِيلُ مَصَبِّ
u'مَسِيلٌ مِيَاهٌ':Added, #1: 1	مَسِيلِ مَصَبِّ
u'مُشَابَهَةٌ سِحْرٌ':Added, #1: 1	مَسِيلُ الْمِيَاهِ
u'مُشَابَهَةٌ طَلاَقٌ':Added, #1: 1	مُشَابَهَةِ السِّحْرِ
u'مُشَابَهَةٌ عُقُودٌ':Added, #2: 2	مُشَابَهَةُ الطَّلَاقِ
u'مُشَابَهَةٌ كُفَّارٌ':Added, #1: 1	مُشَابَهَةِ الْعُقُودِ
u'مُشَابَهَةٌ مَخْلُوقٌ':Added, #1: 1	مُشَابَهَةِ الْكُفَّارِ
u'مُشَابَهَةٌ مُعْتَادٌ':Added, #1: 1	مُشَابَهَةِ الْمَخْلُوقَاتِ
u'مُشَابَهَةٌ يَمِينٌ':Added, #1: 1	مُشَابَهَةِ الْمُعْتَادِ
u'مُشَاحَّةٌ تَكَلُّفٌ':Added, #1: 1	مُشَابَهَةُ الْيَمِينِ
u'مُشَاحَّةٌ مُتَسَاوِي':Added, #1: 1	مُشَاحَّةِ تَكَلُّفِ
u'مُشَاحَّةٌ نُفُوسٌ':Added, #1: 1	مُشَاحَّةِ الْمُتَسَاوِيَيْنِ
u'مُشَارَكَةٌ أَبٌ':Added, #1: 1	مُشَاحَّةَ النُّفُوسِ
u'مُشَارَكَةٌ أحَدٌ':Added, #1: 1	مُشَارَكَةِ أَبِ
u'مُشَارَكَةٌ إمَامٌ':Added, #1: 1	مُشَارَكَةِ أَحَدٍ
u'مُشَارَكَةٌ إمَامٌ':Added, #1: 1	مُشَارَكَةُ الْإِمَامِ
u'مُشَارَكَةٌ أمَةٌ':Added, #1: 1	مُشَارَكَةِ الْإِمَامِ
u'مُشَارَكَةٌ أُمَّةٌ':Added, #1: 1	مُشَارَكَةِ الْأَمَةِ
u'مُشَارَكَةٌ تَوْلِيَةٌ':Added, #1: 1	مُشَارَكَةُ الْأُمَّةِ
u'مُشَارَكَةٌ جَمَاعَةٌ':Added, #1: 1	مُشَارَكَةُ التَّوْلِيَةِ
u'مُشَارَكَةٌ حَقٌّ':Added, #2: 2	مُشَارَكَةِ الْجَمَاعَةِ
u'مُشَارَكَةٌ خَلْقٌ':Added, #1: 1	مُشَارَكَةُ حَقِّ
u'مُشَارَكَةٌ ذِمِّيٌّ':Added, #2: 2	مُشَارَكَةِ خَلْقٍ
u'مُشَارَكَةٌ رَبُّ':Added, #1: 1	مُشَارَكَةُ ذِمِّيٍّ
u'مُشَارَكَةٌ رَشيدٌ':Added, #1: 1	مُشَارَكَةُ رَبِّهِ
u'مُشَارَكَةٌ سَبَبٌ':Added, #1: 1	مُشَارَكَةِ الرَّشِيدِ
u'مُشَارَكَةٌ شَابٌّ':Added, #1: 1	مُشَارَكَةِ سَبَبٍ
u'مُشَارَكَةٌ شَيْطَانٌ':Added, #1: 1	مُشَارَكَةُ الشَّابَّةِ
u'مُشَارَكَةٌ صَاحِبٌ':Added, #1: 1	مُشَارَكَةِ الشَّيْطَانِ
u'مُشَارَكَةٌ صَاحِبٌ':Added, #1: 1	مُشَارَكَةِ صَاحِبِ
u'مُشَارَكَةٌ صَحِيحٌ':Added, #1: 1	مُشَارَكَةِ صَاحِبِهِ
u'مُشَارَكَةٌ عَامِلٌ':Added, #1: 1	مُشَارَكَةِ الصَّحِيحِ
u'مُشَارَكَةٌ عَبْدٌ':Added, #1: 1	مُشَارَكَةِ الْعَامِلِ
u'مُشَارَكَةٌ غرماء':Added, #1: 1	مُشَارَكَةُ الْعَبْدِ
u'مُشَارَكَةٌ غير':Added, #1: 1	مُشَارَكَةُ الْغُرَمَاءِ
u'مُشَارَكَةٌ غَيْرٌ':Added, #1: 1	مُشَارَكَةِ غَيْرِهِ
u'مُشَارَكَةٌ غير':Added, #1: 1	مُشَارَكَةِ غَيْرِهِ
u'مُشَارَكَةٌ غَيْرٌ':Added, #3: 3	مُشَارَكَةَ غَيْرِهِ
u'مُشَارَكَةٌ فِدْيَةٌ':Added, #3: 3	مُشَارَكَةَ غَيْرِهِ
u'مُشَارَكَةٌ فَرِيقٌ':Added, #1: 1	مُشَارَكَةِ الْفِدْيَةِ
u'مُشَارَكَةٌ قَابِضٌ':Added, #1: 1	مُشَارَكَةُ الْفَرِيقِ
u'مُشَارَكَةٌ قَوْمٌ':Added, #1: 1	مُشَارَكَةَ الْقَابِضِ
u'مُشَارَكَةٌ قَوْمٌ':Added, #1: 1	مُشَارَكَةِ الْقَوْمِ
u'مُشَارَكَةٌ مَالِكٌ':Added, #2: 2	مُشَارَكَةُ الْقَوْمِ
u'مُشَارَكَةٌ مَجُوسِيٌّ':Added, #1: 1	مُشَارَكَةَ الْمَالِكِ
u'مُشَارَكَةٌ مَعْطُوف':Added, #1: 1	مُشَارَكَةُ الْمَجُوسِيِّ
u'مُشَارَكَةٌ مُفْلِسٌ':Added, #1: 1	مُشَارَكَةُ الْمَعْطُوفِ
u'مُشَارَكَةٌ مُقَدِّمٌ':Added, #1: 1	مُشَارَكَةِ الْمُفْلِسِ
u'مُشَارَكَةٌ مُقَدِّمَةٌ':Added, #1: 1	مُشَارَكَةِ الْمُقَدِّمَاتِ
u'مُشَارَكَةٌ نَصْرَانِيٌّ':Added, #1: 1	مُشَارَكَةِ الْمُقَدِّمَاتِ
u'مُشَارَكَةٌ وَلِيٌّ':Added, #1: 1	مُشَارَكَةَ النَّصْرَانِيِّ
u'مُشَاطَرَةٌ أَوَّلُ':Added, #1: 1	مُشَارَكَةِ وَلِيِّ
u'مُشَاكَلَةٌ اِسْمٌ':Added, #1: 1	مُشَاطَرَةُ الْأَوَّلِ
u'مُشَاكَلَةٌ اِسْمٌ':Added, #1: 1	مُشَاكَلَةُ اسْمِ
u'مُشَاكَلَةٌ أَوَّلُ':Added, #1: 1	مُشَاكَلَةِ اسْمِهِ
u'مُشَاكَلَةٌ خِفٌّ':Added, #1: 1	مُشَاكَلَةِ الْأَوَّلِ
u'مُشَاكَلَةٌ خِفَّةٌ':Added, #1: 1	مُشَاكَلَةَ خِفّةِ
u'مُشَاكَلَةٌ فَرْضٌ':Added, #1: 1	مُشَاكَلَةَ خِفّةِ
u'مُشَاهَدٌ إِحْيَاءٌ':Added, #1: 1	مُشَاكَلَةُ الْفَرْضِ
u'مُشَاهَدٌ آلةٌ':Added, #1: 1	مُشَاهَدَةَ إحْيَاءِ
u'مُشَاهَدٌ إمَامٌ':Added, #1: 1	مُشَاهَدَةُ الْآلَةِ
u'مُشَاهَدٌ آيَةٌ':Added, #1: 1	مُشَاهَدَةَ الْإِمَامِ
u'مُشَاهَدٌ بَاطِلٌ':Added, #1: 1	مُشَاهَدَةِ الْآيَةِ
u'مُشَاهَدٌ بَيْتٌ':Added, #1: 1	مُشَاهَدَةَ الْبَاطِلِ
u'مُشَاهَدَةٌ إِحْيَاءٌ':Added, #2: 2	مُشَاهَدَةِ الْبَيْتِ
u'مُشَاهَدَةٌ آلةٌ':Added, #1: 1	مُشَاهَدَةَ إحْيَاءِ
u'مُشَاهَدَةٌ إمَامٌ':Added, #1: 1	مُشَاهَدَةُ الْآلَةِ
u'مُشَاهَدَةٌ آيَةٌ':Added, #1: 1	مُشَاهَدَةَ الْإِمَامِ
u'مُشَاهَدَةٌ بَاطِلٌ':Added, #1: 1	مُشَاهَدَةِ الْآيَةِ
u'مُشَاهَدَةٌ بَيْتٌ':Added, #1: 1	مُشَاهَدَةَ الْبَاطِلِ
u'مُشَاهَدَةٌ تَصَرُّفٌ':Added, #2: 2	مُشَاهَدَةِ الْبَيْتِ
u'مُشَاهَدَةٌ تَوْحِيدٌ':Added, #1: 1	مُشَاهَدَةُ التَّصَرُّفِ
u'مُشَاهَدَةٌ حَقٌّ':Added, #1: 1	مُشَاهَدَةِ تَوْحِيدٍ
u'مُشَاهَدَةٌ حَقٌّ':Added, #1: 1	مُشَاهَدَةَ الْحَقِّ
u'مُشَاهَدَةٌ سَبُعٌ':Added, #3: 3	مُشَاهَدَةِ الْحَقِّ
u'مُشَاهَدَةٌ شَاهِدٌ':Added, #2: 2	مُشَاهَدَةِ السَّبُعِ
u'مُشَاهَدَةٌ شَيْخٌ':Added, #1: 1	مُشَاهَدَةُ الشَّاهِدَيْنِ
u'مُشَاهَدَةٌ طَهَارَةٌ':Added, #1: 1	مُشَاهَدَةِ شَيْخٍ
u'مُشَاهَدَةٌ ظُلْمٌ':Added, #1: 1	مُشَاهَدَةِ طَهَارَتِهِ
u'مُشَاهَدَةٌ عِيَانٌ':Added, #1: 1	مُشَاهَدَةِ ظُلْمِهِ
u'مُشَاهَدَةٌ عين':Added, #1: 1	مُشَاهَدَةِ الْعِيَانِ
u'مُشَاهَدَةٌ عَيْنٌ':Added, #4: 4	مُشَاهَدَةُ الْعَيْنِ
u'مُشَاهَدَةٌ عَيْن':Added, #4: 4	مُشَاهَدَةُ الْعَيْنِ
u'مُشَاهَدَةٌ فِعْلٌ':Added, #4: 4	مُشَاهَدَةُ الْعَيْنِ
u'مُشَاهَدَةٌ قَائِلٌ':Added, #1: 1	مُشَاهَدَةِ فِعْلٍ
u'مُشَاهَدَةٌ كَفِيلٌ':Added, #1: 1	مُشَاهَدَةِ الْقَائِلِ
u'مُشَاهَدَةٌ مَبِيعٌ':Added, #1: 1	مُشَاهَدَةَ الْكَفِيلِ
u'مُشَاهَدَةٌ مُسْلِمٌ':Added, #1: 1	مُشَاهَدَةِ الْمَبِيعِ
u'مُشَاهَدَةٌ مَصْنُوعٌ':Added, #2: 2	مُشَاهَدَةُ مُسْلِمٍ
u'مُشَاهَدَةٌ مَكْتُوبٌ':Added, #1: 1	مُشَاهَدَةِ مَصْنُوعَاتِهِ
u'مُشَاهَدَةٌ مُنْكَرٌ':Added, #1: 1	مُشَاهَدَةِ الْمَكْتُوبِ
u'مُشَاهَدَةٌ نَجَاسَةٌ':Added, #1: 1	مُشَاهَدَةِ الْمُنْكَرِ
u'مُشَاهَدَةٌ وَقْتٌ':Added, #1: 1	مُشَاهَدَةِ النَّجَاسَاتِ
u'مُشَاهَدَةٌ وَقْتٌ':Added, #1: 1	مُشَاهَدَةَ الْوَقْتِ
u'مُشَاهَدٌ تَصَرُّفٌ':Added, #1: 1	مُشَاهَدَةُ الْوَقْتِ
u'مُشَاهَدٌ تَوْحِيدٌ':Added, #1: 1	مُشَاهَدَةُ التَّصَرُّفِ
u'مُشَاهَدٌ حَقٌّ':Added, #1: 1	مُشَاهَدَةِ تَوْحِيدٍ
u'مُشَاهَدٌ حَقٌّ':Added, #1: 1	مُشَاهَدَةَ الْحَقِّ
u'مُشَاهَدٌ سَبُعٌ':Added, #3: 3	مُشَاهَدَةِ الْحَقِّ
u'مُشَاهَدٌ شَاهِدٌ':Added, #2: 2	مُشَاهَدَةِ السَّبُعِ
u'مُشَاهَدٌ شَيْخٌ':Added, #1: 1	مُشَاهَدَةُ الشَّاهِدَيْنِ
u'مُشَاهَدٌ طَهَارَةٌ':Added, #1: 1	مُشَاهَدَةِ شَيْخٍ
u'مُشَاهَدٌ ظُلْمٌ':Added, #1: 1	مُشَاهَدَةِ طَهَارَتِهِ
u'مُشَاهَدٌ عِيَانٌ':Added, #1: 1	مُشَاهَدَةِ ظُلْمِهِ
u'مُشَاهَدٌ عين':Added, #1: 1	مُشَاهَدَةِ الْعِيَانِ
u'مُشَاهَدٌ عَيْنٌ':Added, #4: 4	مُشَاهَدَةُ الْعَيْنِ
u'مُشَاهَدٌ عَيْن':Added, #4: 4	مُشَاهَدَةُ الْعَيْنِ
u'مُشَاهَدٌ فِعْلٌ':Added, #4: 4	مُشَاهَدَةُ الْعَيْنِ
u'مُشَاهَدٌ قَائِلٌ':Added, #1: 1	مُشَاهَدَةِ فِعْلٍ
u'مُشَاهَدٌ كَفِيلٌ':Added, #1: 1	مُشَاهَدَةِ الْقَائِلِ
u'مُشَاهَدٌ مَبِيعٌ':Added, #1: 1	مُشَاهَدَةَ الْكَفِيلِ
u'مُشَاهَدٌ مُسْلِمٌ':Added, #1: 1	مُشَاهَدَةِ الْمَبِيعِ
u'مُشَاهَدٌ مَصْنُوعٌ':Added, #2: 2	مُشَاهَدَةُ مُسْلِمٍ
u'مُشَاهَدٌ مَكْتُوبٌ':Added, #1: 1	مُشَاهَدَةِ مَصْنُوعَاتِهِ
u'مُشَاهَدٌ مُنْكَرٌ':Added, #1: 1	مُشَاهَدَةِ الْمَكْتُوبِ
u'مُشَاهَدٌ نَجَاسَةٌ':Added, #1: 1	مُشَاهَدَةِ الْمُنْكَرِ
u'مُشَاهَدٌ وَقْتٌ':Added, #1: 1	مُشَاهَدَةِ النَّجَاسَاتِ
u'مُشَاهَدٌ وَقْتٌ':Added, #1: 1	مُشَاهَدَةَ الْوَقْتِ
u'مُشَاوَرَةٌ بَائِعٌ':Added, #1: 1	مُشَاهَدَةُ الْوَقْتِ
u'مُشَاوَرَةٌ بَائِعٌ':Added, #1: 1	مُشَاوَرَةُ الْبَائِعِ
u'مُشَاوَرَةٌ رَسُولٌ':Added, #1: 1	مُشَاوَرَةِ الْبَائِعِ
u'مُشَاوَرَةٌ فقهاء':Added, #1: 1	مُشَاوَرَةُ الرّسُولِ
u'مُشَاوَرَةٌ فقهاء':Added, #1: 1	مُشَاوَرَةَ الْفُقَهَاءِ
u'مُشَاوَرَةٌ قرناء':Added, #1: 1	مُشَاوَرَةُ الْفُقَهَاءِ
u'مُشَاوَرَةٌ نِساءٌ':Added, #1: 1	مُشَاوَرَةِ الْقُرَنَاءِ
u'مَشْرُوعِيَّةٌ إجَارَةٌ':Added, #1: 1	مُشَاوَرَةِ النّسَاءِ
u'مَشْرُوعِيَّةٌ إجَارَةٌ':Added, #1: 1	مَشْرُوعِيَّةَ الْإِجَارَةِ
u'مَشْرُوعِيَّةٌ إِجْبَارٌ':Added, #1: 1	مَشْرُوعِيَّةُ الْإِجَارَةِ
u'مَشْرُوعِيَّةٌ أَذَانٌ':Added, #1: 1	مَشْرُوعِيَّةُ الْإِجْبَارِ
u'مَشْرُوعِيَّةٌ اِسْتِعْمالٌ':Added, #1: 1	مَشْرُوعِيَّةِ الْأَذَانِ
u'مَشْرُوعِيَّةٌ أصل':Added, #1: 1	مَشْرُوعِيَّةَ اسْتِعْمَالِ
u'مَشْرُوعِيَّةٌ أًصْلٌ':Added, #1: 1	مَشْرُوعِيَّةِ أَصْلِهِ
u'مَشْرُوعِيَّةٌ تَخْيِيرٌ':Added, #1: 1	مَشْرُوعِيَّةِ أَصْلِهِ
u'مَشْرُوعِيَّةٌ تَسْمِيعٌ':Added, #1: 1	مَشْرُوعِيَّةُ التَّخْيِيرِ
u'مَشْرُوعِيَّةٌ تَسْوِيَةٌ':Added, #1: 1	مَشْرُوعِيَّةِ التَّسْمِيعِ
u'مَشْرُوعِيَّةٌ تَكْرارٌ':Added, #1: 1	مَشْرُوعِيَّةُ التَّسْوِيَةِ
u'مَشْرُوعِيَّةٌ تَيَمُّمٌ':Added, #1: 1	مَشْرُوعِيَّةِ تَكْرَارِهِ
u'مَشْرُوعِيَّةٌ تَيَمُّمٌ':Added, #1: 1	مَشْرُوعِيَّةَ التَّيَمُّمِ
u'مَشْرُوعِيَّةٌ تَيَمُّمٌ':Added, #1: 1	مَشْرُوعِيَّةُ التَّيَمُّمِ
u'مَشْرُوعِيَّةٌ جَمَاعَةٌ':Added, #2: 2	مَشْرُوعِيَّةِ التَّيَمُّمِ
u'مَشْرُوعِيَّةٌ جَوَازٌ':Added, #1: 1	مَشْرُوعِيَّةِ الْجَمَاعَةِ
u'مَشْرُوعِيَّةٌ حَبْسٌ':Added, #1: 1	مَشْرُوعِيَّةِ جَوَازِ
u'مَشْرُوعِيَّةٌ حَقٌّ':Added, #1: 1	مَشْرُوعِيَّةِ الْحَبْسِ
u'مَشْرُوعِيَّةٌ خطبة':Added, #1: 1	مَشْرُوعِيَّةِ حَقِّ
u'مَشْرُوعِيَّةٌ خُطْبَةٌ':Added, #1: 1	مَشْرُوعِيَّةِ الْخُطْبَةِ
u'مَشْرُوعِيَّةٌ خُلْعٌ':Added, #1: 1	مَشْرُوعِيَّةِ الْخُطْبَةِ
u'مَشْرُوعِيَّةٌ خيار':Added, #1: 1	مَشْرُوعِيَّةُ الْخُلْعِ
u'مَشْرُوعِيَّةٌ خِيَارٌ':Added, #1: 1	مَشْرُوعِيَّةِ الْخِيَارِ
u'مَشْرُوعِيَّةٌ دَواءٌ':Added, #1: 1	مَشْرُوعِيَّةِ الْخِيَارِ
u'مَشْرُوعِيَّةٌ رجعة':Added, #1: 1	مَشْرُوعِيَّةِ الدَّوَاءِ
u'مَشْرُوعِيَّةٌ رَجْعَةٌ':Added, #1: 1	مَشْرُوعِيَّةِ الرَّجْعَةِ
u'مَشْرُوعِيَّةٌ رُكوعٌ':Added, #1: 1	مَشْرُوعِيَّةِ الرَّجْعَةِ
u'مَشْرُوعِيَّةٌ رَمَلٌ':Added, #1: 1	مَشْرُوعِيَّةَ الرُّكُوعِ
u'مَشْرُوعِيَّةٌ سُجُودٌ':Added, #1: 1	مَشْرُوعِيَّةُ الرَّمَلِ
u'مَشْرُوعِيَّةٌ سُجُودٌ':Added, #1: 1	مَشْرُوعِيَّةُ السُّجُودِ
u'مَشْرُوعِيَّةٌ سُورَةٌ':Added, #1: 1	مَشْرُوعِيَّةَ سُجُودِ
u'مَشْرُوعِيَّةٌ صَلاَةٌ':Added, #1: 1	مَشْرُوعِيَّةِ السُّورَةِ
u'مَشْرُوعِيَّةٌ صَوْمٌ':Added, #1: 1	مَشْرُوعِيَّةِ الصَّلَاةِ
u'مَشْرُوعِيَّةٌ صِيَامٌ':Added, #1: 1	مَشْرُوعِيَّةِ الصَّوْمِ
u'مَشْرُوعِيَّةٌ طَلاَقٌ':Added, #1: 1	مَشْرُوعِيَّةِ صِيَامِ
u'مَشْرُوعِيَّةٌ عَقْدٌ':Added, #1: 1	مَشْرُوعِيَّةُ الطَّلَاقِ
u'مَشْرُوعِيَّةٌ غَسْلٌ':Added, #1: 1	مَشْرُوعِيَّةِ الْعَقْدِ
u'مَشْرُوعِيَّةٌ فِعْلٌ':Added, #1: 1	مَشْرُوعِيَّةُ الْغَسْلِ
u'مَشْرُوعِيَّةٌ قِرَاءةٌ':Added, #1: 1	مَشْرُوعِيَّةِ الْفِعْلِ
u'مَشْرُوعِيَّةٌ قَسام':Added, #1: 1	مَشْرُوعِيَّةِ الْقِرَاءَةِ
u'مَشْرُوعِيَّةٌ قَسامَة':Added, #1: 1	مَشْرُوعِيَّةَ الْقَسَامَةِ
u'مَشْرُوعِيَّةٌ قصاص':Added, #1: 1	مَشْرُوعِيَّةَ الْقَسَامَةِ
u'مَشْرُوعِيَّةٌ قِصَاصٌ':Added, #1: 1	مَشْرُوعِيَّةُ الْقِصَاصِ
u'مَشْرُوعِيَّةٌ قصاص':Added, #1: 1	مَشْرُوعِيَّةُ الْقِصَاصِ
u'مَشْرُوعِيَّةٌ قِصَاصٌ':Added, #2: 2	مَشْرُوعِيَّةِ الْقِصَاصِ
u'مَشْرُوعِيَّةٌ قِيَاسٌ':Added, #2: 2	مَشْرُوعِيَّةِ الْقِصَاصِ
u'مَشْرُوعِيَّةٌ كِتَابَةٌ':Added, #1: 1	مَشْرُوعِيَّةِ الْقِيَاسِ
u'مَشْرُوعِيَّةٌ كَفَّارٌ':Added, #1: 1	مَشْرُوعِيَّةُ الْكِتَابَةِ
u'مَشْرُوعِيَّةٌ كَفَّارَةٌ':Added, #1: 1	مَشْرُوعِيَّةُ الْكَفَّارَةِ
u'مَشْرُوعِيَّةٌ كَفَالَةٌ':Added, #1: 1	مَشْرُوعِيَّةُ الْكَفَّارَةِ
u'مَشْرُوعِيَّةٌ لعان':Added, #2: 2	مَشْرُوعِيَّةَ الْكَفَالَةِ
u'مَشْرُوعِيَّةٌ مُحَاسَبَةٌ':Added, #1: 1	مَشْرُوعِيَّةِ اللِّعَانِ
u'مَشْرُوعِيَّةٌ مَسْحٌ':Added, #1: 1	مَشْرُوعِيَّةَ الْمُحَاسَبَاتِ
u'مَشْرُوعِيَّةٌ نِيَّةٌ':Added, #1: 1	مَشْرُوعِيَّةِ الْمَسْحِ
u'مَشْرُوعِيَّةٌ وَصِيٌّ':Added, #1: 1	مَشْرُوعِيَّةِ النِّيَّةِ
u'مَشْرُوعِيَّةٌ وَصِيَّةٌ':Added, #1: 1	مَشْرُوعِيَّةُ الْوَصِيَّةِ
u'مَشَّطَ مُحْرِمٌ':Subject, #1: 1	مَشْرُوعِيَّةُ الْوَصِيَّةِ
u'مَشَقَّةٌ إبَاحَةٌ':Added, #1: 1	مَشَّطَ الْمُحْرِمُ
u'مَشَقَّةٌ اِسْتِعْمالٌ':Added, #1: 1	مَشَقَّةُ إبَاحَةِ
u'مَشَقَّةٌ أسْفَارٌ':Added, #1: 1	مَشَقَّةِ اسْتِعْمَالِ
u'مَشَقَّةٌ إِعادَةٌ':Added, #1: 1	مَشَقَّةَ الْأَسْفَارِ
u'مَشَقَّةٌ أَعْدَاءٌ':Added, #1: 1	مَشَقَّةُ إعَادَةِ
u'مَشَقَّةٌ أَعْذَارٌ':Added, #1: 1	مَشَقَّةِ الْأَعْدَاءِ
u'مَشَقَّةٌ أكل':Added, #1: 1	مَشَقَّةُ الْأَعْذَارِ
u'مَشَقَّةٌ أَكْلٌ':Added, #1: 1	مَشَقَّةِ الْأَكْلِ
u'مَشَقَّةٌ إِنْذارٌ':Added, #1: 1	مَشَقَّةِ الْأَكْلِ
u'مَشَقَّةٌ بَرْدٌ':Added, #1: 1	مَشَقَّةَ الْإِنْذَارِ
u'مَشَقَّةٌ بَرْدٌ':Added, #1: 1	مَشَقَّةُ الْبَرْدِ
u'مَشَقَّةٌ بَعْضٌ':Added, #1: 1	مَشَقَّةِ الْبَرْدِ
u'مَشَقَّةٌ تَخْلِيصٌ':Added, #1: 1	مَشَقَّةَ بَعْضِ
u'مَشَقَّةٌ تَرَافُعٌ':Added, #1: 1	مَشَقَّةُ تَخْلِيصِ
u'مَشَقَّةٌ تَكْليفٌ':Added, #1: 1	مَشَقَّةِ التَّرَافُعِ
u'مَشَقَّةٌ تَكْليفٌ':Added, #1: 1	مَشَقَّةُ التَّكْلِيفِ
u'مَشَقَّةٌ تَنْقِيةٌ':Added, #1: 1	مَشَقَّةِ التَّكْلِيفِ
u'مَشَقَّةٌ جمع':Added, #2: 2	مَشَقَّةِ تَنْقِيَتِهِ
u'مَشَقَّةٌ جَمْعٌ':Added, #1: 1	مَشَقَّةِ جَمْعِ
u'مَشَقَّةٌ حَجٌّ':Added, #1: 1	مَشَقَّةِ جَمْعِ
u'مَشَقَّةٌ حُضورٌ':Added, #1: 1	مَشَقَّةِ الْحَجِّ
u'مَشَقَّةٌ حُضُورٌ':Added, #1: 1	مَشَقَّةُ الْحُضُورِ
u'مَشَقَّةٌ ذَهَابٌ':Added, #1: 1	مَشَقَّةُ الْحُضُورِ
u'مَشَقَّةٌ زاجِرٌ':Added, #1: 1	مَشَقَّةُ الذَّهَابِ
u'مَشَقَّةٌ زائِدٌ':Added, #3: 3	مَشَقَّةَ الزَّاجِرِ
u'مَشَقَّةٌ سُجُودٌ':Added, #1: 1	مَشَقَّةٍ زَائِدَةٍ
u'مَشَقَّةٌ سَفَرٌ':Added, #1: 1	مَشَقَّةَ السُّجُودِ
u'مَشَقَّةٌ سَفَرٌ':Added, #3: 3	مَشَقَّةِ السَّفَرِ
u'مَشَقَّةٌ صبر':Added, #5: 5	مَشَقَّةُ السَّفَرِ
u'مَشَقَّةٌ صَبْرٌ':Added, #1: 1	مَشَقَّةُ الصَّبْرِ
u'مَشَقَّةٌ صُعُودٌ':Added, #1: 1	مَشَقَّةُ الصَّبْرِ
u'مَشَقَّةٌ صَلاَةٌ':Added, #1: 1	مَشَقَّةُ الصُّعُودِ
u'مَشَقَّةٌ صنعة':Added, #1: 1	مَشَقَّةُ الصَّلَاةِ
u'مَشَقَّةٌ صَنْعَةٌ':Added, #1: 1	مَشَقَّةُ الصَّنْعَةِ
u'مَشَقَّةٌ صَوْمٌ':Added, #1: 1	مَشَقَّةُ الصَّنْعَةِ
u'مَشَقَّةٌ صَوْمٌ':Added, #2: 2	مَشَقَّةِ الصَّوْمِ
u'مَشَقَّةٌ صِيَامٌ':Added, #5: 5	مَشَقَّةُ الصَّوْمِ
u'مَشَقَّةٌ عَظِيم':Added, #1: 1	مَشَقَّةِ الصِّيَامِ
u'مَشَقَّةٌ غَالِبٌ':Added, #3: 3	مَشَقَّةٍ عَظِيمَةٍ
u'مَشَقَّةٌ فَادِحٌ':Added, #1: 1	مَشَقَّةٍ غَالِبَةٍ
u'مَشَقَّةٌ فَاضِلٌ':Added, #3: 3	مَشَقَّةٍ فَادِحَةٍ
u'مَشَقَّةٌ فِرَاقٌ':Added, #1: 1	مَشَقَّةِ الْفَاضِلَةِ
u'مَشَقَّةٌ فقر':Added, #1: 1	مَشَقَّةَ فِرَاقِ
u'مَشَقَّةٌ فَقْرٌ':Added, #1: 1	مَشَقَّةِ الْفَقْرِ
u'مَشَقَّةٌ قَضَاءٌ':Added, #1: 1	مَشَقَّةِ الْفَقْرِ
u'مَشَقَّةٌ قَضَاءٌ':Added, #1: 1	مَشَقَّةُ الْقَضَاءِ
u'مَشَقَّةٌ قَمْلٌ':Added, #2: 2	مَشَقَّةِ الْقَضَاءِ
u'مَشَقَّةٌ قيام':Added, #1: 1	مَشَقَّةِ الْقَمْلِ
u'مَشَقَّةٌ قِيَامٌ':Added, #1: 1	مَشَقَّةُ الْقِيَامِ
u'مَشَقَّةٌ كَسْبٌ':Added, #1: 1	مَشَقَّةُ الْقِيَامِ
u'مَشَقَّةٌ مَالٌ':Added, #1: 1	مَشَقَّةَ كَسْبٍ
u'مَشَقَّةٌ مَرَضٌ':Added, #1: 1	مَشَقَّةِ الْمَالِ
u'مَشَقَّةٌ مَشْيٌ':Added, #1: 1	مَشَقَّةِ الْمَرَضِ
u'مَشَقَّةٌ مَشْيٌ':Added, #1: 1	مَشَقَّةَ الْمَشْيِ
u'مَشَقَّةٌ مُصابَرَة':Added, #1: 1	مَشَقَّةِ الْمَشْيِ
u'مَشَقَّةٌ مَعْصِيَةٌ':Added, #1: 1	مَشَقَّةِ مُصَابَرَةِ
u'مَشَقَّةٌ مَقْصُودٌ':Added, #1: 1	مَشَقَّةُ الْمَعْصِيَةِ
u'مَشَقَّةٌ مِنَّةٌ':Added, #1: 1	مَشَقَّةٍ مَقْصُودَةٍ
u'مَشَقَّةٌ نَزْعٌ':Added, #1: 1	مَشَقَّةِ الْمِنَّةِ
u'مَشَقَّةٌ نَزْعٌ':Added, #1: 1	مَشَقَّةَ النَّزْعِ
u'مَشَقَّةٌ نَزْعٌ':Added, #1: 1	مَشَقَّةُ النَّزْعِ
u'مَشَقَّةٌ هجر':Added, #1: 1	مَشَقَّةِ النَّزْعِ
u'مَشَقَّةٌ هَجْرٌ':Added, #1: 1	مَشَقَّةِ الْهَجْرِ
u'مَشَقَّةٌ وُجُوبٌ':Added, #1: 1	مَشَقَّةِ الْهَجْرِ
u'مَشَقَّةٌ وَحْدَةٌ':Added, #1: 1	مَشَقَّةِ وُجُوبِ
u'مَشَقَ كَاتِبٌ':Subject, #1: 1	مَشَقَّةِ الْوَحْدَةِ
u'مَشْهَدٌ بَدْرٌ':Added, #1: 1	مَشَقَ الْكَاتِبُ
u'مَشْهَدٌ شَابٌّ':Added, #2: 2	مَشْهَدَ بَدْرٍ
u'مَشْهَدٌ صَالِحٌ':Added, #1: 1	مَشْهَدِ الشَّابِّ
u'مَشْهَدٌ صَالِح':Added, #2: 2	مَشْهَدٍ صَالِحٍ
u'مَشْهَدٌ غُلاَمٌ':Added, #2: 2	مَشْهَدٍ صَالِحٍ
u'مَشْهَدٌ غُلاَمٌ':Added, #1: 1	مَشْهَدِ الْغُلَامِ
u'مَشْهَدٌ مَنْذُور':Added, #1: 1	مَشْهَدِ الْغُلاَمِ
u'مَشَى اِبْنٌ':Subject, #1: 1	مَشْهَدِ الْمَنْذُورِ
u'مَشْيٌ أَجْنَبِيٌّ':Added, #9: 9	مَشَى ابْنُ
u'مَشْيٌ أَجِيرٌ':Added, #1: 1	مَشْيِ الْأَجْنَبِيِّ
u'مَشَى أحَدٌ':Subject, #1: 1	مَشْيِ الْأَجِيرِ
u'مَشْيٌ أُسودٌ':Added, #1: 1	مَشَى أَحَدٌ
u'مَشَى أَصْحَابٌ':Subject, #1: 1	مَشْيِ أُسُودِ
u'مَشْيٌ أَصْحَابٌ':Added, #2: 2	مَشَى أَصْحَابُ
u'مَشْيٌ أَقْدَامٌ':Added, #1: 1	مَشْيُ أَصْحَابِ
u'مَشْيٌ أقْصَرُ':Added, #1: 1	مَشْيُ الْأَقْدَامِ
u'مَشَى أَكْثَرُ':Predicate, #1: 1	مَشْيُ أَقْصَرِ
u'مَشَى إمَامٌ':Subject, #1: 1	مَشَى أَكْثَرَ
u'مَشَى بَعْضٌ':Predicate, #1: 1	مَشَى الْإِمَامُ
u'مَشْيٌ بَهيمٌ':Added, #1: 1	مَشَى بَعْضَ
u'مَشْيٌ بَهِيمَةٌ':Added, #1: 1	مَشْيَ الْبَهِيمَةِ
u'مَشَى بَيْضاوِيّ':Subject, #1: 1	مَشْيَ الْبَهِيمَةِ
u'مَشَى بَيْنٌ':Predicate, #2: 2	مَشَى الْبَيْضَاوِيُّ
u'مَشَى تَقَلُّعٌ':Predicate, #3: 3	مَشَى بَيْنَ
u'مَشَى تِلْقاءٌ':Predicate, #1: 1	مَشَى تَقَلّعَ
u'مَشَى تِلْميذٌ':Subject, #1: 1	مَشَى تِلْقَاءَ
u'مَشَى ثَلاثُ':Predicate, #1: 1	مَشَى تِلْمِيذُ
u'مَشَى جَصَّاصٌ':Subject, #1: 1	مَشَى ثَلَاثَ
u'مَشَى جَمَاعَةٌ':Subject, #1: 1	مَشَى الْجَصَّاصُ
u'مَشْيٌ جَمَاعَةٌ':Added, #1: 1	مَشَى جَمَاعَةٌ
u'مَشْيٌ جِمَالٌ':Added, #3: 3	مَشْيِ الْجَمَاعَةِ
u'مَشَى جَمْعٌ':Subject, #2: 2	مَشْيَ الْجِمَالِ
u'مَشَى جَمِيع':Predicate, #3: 3	مَشَى جَمْعٌ
u'مَشَى حافِظٌ':Subject, #1: 1	مَشَى الْجَمِيعَ
u'مَشْيٌ حَجٌّ':Added, #1: 1	مَشَى الْحَافِظُ
u'مَشْيٌ حَجٌّ':Added, #1: 1	مَشْيَ الْحَجِّ
u'مَشَى حِمَارٌ':Subject, #1: 1	مَشْيِ الْحَجِّ
u'مَشْيٌ حَيِيٌّ':Added, #1: 1	مَشَى الْحِمَارُ
u'مَشَى خَلْفٌ':Predicate, #1: 1	مَشْيَ حَيِيّاتٍ
u'مَشَى رِجَالٌ':Subject, #1: 1	مَشَى خَلْفَ
u'مَشَى رَجُلٌ':Subject, #1: 1	مَشَى رِجَالٌ
u'مَشْيٌ رَجُلٌ':Added, #1: 1	مَشَى الرّجُلُ
u'مَشْيٌ رَجُلٌ':Added, #1: 1	مَشْيَ الرَّجُلِ
u'مَشَى رَسُولٌ':Subject, #1: 1	مَشْيُ الرَّجُلِ
u'مَشْيٌ رَسُولٌ':Added, #3: 3	مَشَى رَسُولُ
u'مَشَى زادٌ':Predicate, #1: 1	مَشْيَ رَسُولِ
u'مَشَى شَارِحٌ':Subject, #1: 1	مَشَى زَادَ
u'مَشَى شَاهِدٌ':Subject, #2: 2	مَشَى الشَّارِحُ
u'مَشَى شُرَّاحٌ':Subject, #2: 2	مَشَى الشَّاهِدُ
u'مَشَى شَيْخٌ':Subject, #2: 2	مَشَى شُرَّاحُ
u'مَشَى شَيْخٌ':Subject, #1: 1	مَشَى شَيْخُ
u'مَشَى صَاحِبٌ':Subject, #2: 2	مَشَى الشَّيْخُ
u'مَشَى صَحَابَةٌ':Subject, #3: 3	مَشَى صَاحِبُ
u'مَشَى صَدْرٌ':Subject, #1: 1	مَشَى الصَّحَابَةُ
u'مَشَى ضَيْفٌ':Subject, #1: 1	مَشَى صَدْرُ
u'مَشَى طَائِفٌ':Subject, #1: 1	مَشَى الضَّيْفُ
u'مَشَى طَبَرِيّ':Subject, #1: 1	مَشَى طَائِفَةٌ
u'مَشَى طَرِيقٌ':Predicate, #1: 1	مَشَى الطَّبَرِيُّ
u'مَشَى طُولٌ':Predicate, #1: 1	مَشَى الطَّرِيقَ
u'مَشَى عَبْدٌ':Subject, #1: 1	مَشَى طُولَ
u'مَشَى عُمَرٌ':Subject, #3: 3	مَشَى عَبْدُ
u'مَشْيٌ عمرة':Added, #2: 2	مَشَى عُمَرُ
u'مَشْيٌ عُمْرَةٌ':Added, #1: 1	مَشْيِ الْعُمْرَةِ
u'مَشَى فلان':Subject, #1: 1	مَشْيِ الْعُمْرَةِ
u'مَشْيٌ فلان':Added, #1: 1	مَشَى الطَّبَرِيُّ
u'مَشْيٌ قَادِرٌ':Added, #1: 1	مَشْيُ الْمَكِّيِّ
u'مَشَى قَالٌ':Predicate, #1: 1	مَشْيِ الْقَادِرِ
u'مَشْيٌ قَائِمٌ':Added, #1: 1	مَشَى قَالَ
u'مَشَى قِبَلٌ':Predicate, #1: 1	مَشْيَ الْقَائِمِ
u'مَشَى قَدْرٌ':Predicate, #4: 4	مَشَى قِبَلَ
u'مَشَى قَفَّالٌ':Subject, #1: 1	مَشَى قَدْرَ
u'مَشَى قَوْمٌ':Subject, #1: 1	مَشَى الْقَفَّالُ
u'مَشْيٌ كَلاَمٌ':Added, #1: 1	مَشَى قَوْمٌ
u'مَشَى لَيْثٌ':Subject, #1: 1	مَشْيَ كَلَامِ
u'مَشْيٌ مثل':Added, #1: 1	مَشَى اللّيْثُ
u'مَشْيٌ مِثْلٌ':Added, #1: 1	مَشْيُ مِثْلِهِ
u'مَشَى مَجْرُوحٌ':Subject, #1: 1	مَشْيُ مِثْلِهِ
u'مَشَى مُحَقِّقٌ':Subject, #2: 2	مَشَى الْمَجْرُوحُ
u'مَشْيٌ مُخَيَّرٌ':Added, #1: 1	مَشَى الْمُحَقِّقُ
u'مَشْيٌ مُصَافِحٌ':Added, #1: 1	مَشْيَ الْمُخَيَّرَةِ
u'مَشَى مُصَنِّفٌ':Subject, #2: 2	مَشْيَ الْمُصَافِحِ
u'مَشْيٌ مَكِّيّ':Added, #8: 8	مَشَى الْمُصَنِّفُ
u'مَشَى مُؤَلِّفٌ':Subject, #1: 1	مَشْيُ الْمَكِّيِّ
u'مَشْيٌ نَاسٌ':Added, #5: 5	مَشَى الْمُؤَلِّفُ
u'مَشَى نَجْمٌ':Subject, #1: 1	مَشْيَ النَّاسِ
u'مَشَى يَوْمٌ':Predicate, #1: 1	مَشَى نَجْمُ
u'مُصَاحَبَةٌ شُهُودٌ':Added, #1: 1	مَشَى يَوْمَ
u'مُصَاحَبَةٌ عين':Added, #1: 1	مُصَاحَبَةِ شُهُودِ
u'مُصَاحَبَةٌ عَيْنٌ':Added, #1: 1	مُصَاحَبَةَ الْعَيْنِ
u'مُصَاحَبَةٌ عَيْن':Added, #1: 1	مُصَاحَبَةَ الْعَيْنِ
u'مُصَاحَبَةٌ كُفَّارٌ':Added, #1: 1	مُصَاحَبَةَ الْعَيْنِ
u'مُصَاحَبَةٌ لبس':Added, #1: 1	مُصَاحَبَةِ الْكُفَّارِ
u'مُصَاحَبَةٌ لُبْسٌ':Added, #1: 1	مُصَاحَبَةِ اللُّبْسِ
u'مُصَاحَبَةٌ نَفْسٌ':Added, #1: 1	مُصَاحَبَةِ اللُّبْسِ
u'مُصَادَرَةٌ سُلْطَانٌ':Added, #1: 1	مُصَاحَبَةِ نَفْسٍ
u'مُصَادَرٌ سُلْطَانٌ':Added, #1: 1	مُصَادَرَةَ السُّلْطَانِ
u'مُصَادَفَةٌ حَيْضٌ':Added, #1: 1	مُصَادَرَةَ السُّلْطَانِ
u'مُصَادَفَةٌ خَصْمٌ':Added, #1: 1	مُصَادَفَةِ الْحَيْضِ
u'مُصَادَفَةٌ طَلاَقٌ':Added, #1: 1	مُصَادَفَةِ الْخَصْمِ
u'مُصَادَفَةٌ عتق':Added, #2: 2	مُصَادَفَةِ الطَّلَاقِ
u'مُصَادَفَةٌ عِتْقٌ':Added, #2: 2	مُصَادَفَةِ الْعِتْقِ
u'مُصَادَفَةٌ عَقْدٌ':Added, #2: 2	مُصَادَفَةِ الْعِتْقِ
u'مُصَادَفَةٌ مَحَلٌّ':Added, #1: 1	مُصَادَفَةِ الْعَقْدِ
u'مُصَادَفَةٌ وَقْتٌ':Added, #2: 2	مُصَادَفَةِ الْمَحَلِّ
u'مُصَادَقَةٌ فُجَّارٌ':Added, #1: 1	مُصَادَفَةِ الْوَقْتِ
u'مُصَادَقٌ فُجَّارٌ':Added, #1: 1	مُصَادَقَةَ الْفُجَّارِ
u'مُصَادَمَةٌ إِجْمَاعٌ':Added, #1: 1	مُصَادَقَةَ الْفُجَّارِ
u'مُصَادَمَةٌ قَاعِدٌ':Added, #1: 1	مُصَادَمَةُ الْإِجْمَاعِ
u'مُصَارَعَةٌ نَبِيٌّ':Added, #1: 1	مُصَادَمَةِ قَاعِدَةٍ
u'مُصَافَحَةٌ أَمْرَد':Added, #1: 1	مُصَارَعَةِ النَّبِيِّ
u'مُصَافَحَةٌ أهْلٌ':Added, #1: 1	مُصَافَحَةِ الْأَمْرَدِ
u'مُصَافَحَةٌ حَيٌّ':Added, #1: 1	مُصَافَحَةِ أَهْلِ
u'مُصَافَحَةٌ حَيٌّ':Added, #1: 1	مُصَافَحَةَ الْحَيِّ
u'مُصَافَحَةٌ رَجُلٌ':Added, #1: 1	مُصَافَحَةِ الْحَيِّ
u'مُصَافَحَةٌ رَجُلٌ':Added, #1: 1	مُصَافَحَةَ الرَّجُلِ
u'مُصَافَحَةٌ صَبِيٌّ':Added, #1: 1	مُصَافَحَةِ الرَّجُلِ
u'مُصَافَحَةٌ عَجُوزٌ':Added, #1: 1	مُصَافَحَةُ الصَّبِيِّ
u'مُصَافَحَةٌ كَافِرٌ':Added, #1: 1	مُصَافَحَةُ الْعَجُوزِ
u'مُصَافَحَةٌ نِساءٌ':Added, #1: 1	مُصَافَحَةُ الْكَافِرِ
u'مُصَالَحَةٌ أحْزَابٌ':Added, #3: 3	مُصَافَحَةَ النِّسَاءِ
u'مُصَالَحَةٌ أهْلٌ':Added, #1: 1	مُصَالَحَةِ الْأَحْزَابِ
u'مُصَالَحَةٌ فَرَّانٌ':Added, #1: 1	مُصَالَحَةُ أَهْلِ
u'مُصَالَحَةٌ كَفِيلٌ':Added, #1: 1	مُصَالَحَةُ الْفَرَّانِ
u'مُصَالَحَةٌ كَفِيلٌ':Added, #1: 1	مُصَالَحَةَ الْكَفِيلِ
u'مُصَالَحَةٌ مثل':Added, #1: 1	مُصَالَحَةُ الْكَفِيلِ
u'مُصَالَحَةٌ مِثْلٌ':Added, #1: 1	مُصَالَحَةُ مِثْلِهِ
u'مُصَاهَرَةٌ نَبِيٌّ':Added, #1: 1	مُصَالَحَةُ مِثْلِهِ
u'مُصَاوَلَةٌ أَقْرَانٌ':Added, #1: 1	مُصَاهَرَةُ النَّبِيِّ
u'مَصَّ بَقٌّ':Subject, #1: 1	مُصَاوَلَةِ الْأَقْرَانِ
u'مَصَّ ثَدْيٌ':Predicate, #1: 1	مَصَّ الْبَقُّ
u'مَصَّ ثَدْيٌ':Predicate, #1: 1	مَصَّ الثَّدْيَ
u'مَصَّ ثَلاثُ':Predicate, #3: 3	مَصَّ ثَدْيَ
u'مَصَّ دَمٌ':Predicate, #1: 1	مَصَّ ثَلَاثَ
u'مَصَّ ذُبابٌ':Predicate, #1: 1	مَصَّ الدَّمَ
u'مَصَّ ذُبابٌ':Subject, #1: 1	مَصَّ الذُّبَابَ
u'مَصَّرَ بصرة':Predicate, #1: 1	مَصَّ الذُّبَابُ
u'مَصْرَعٌ فُلاَنٌ':Added, #1: 1	مَصَّرَ الْبَصْرَةَ
u'مَصَّ صَبِيٌّ':Subject, #3: 3	مَصْرَعُ فُلاَنٍ
u'مَصَّ عُضْوٌ':Predicate, #1: 1	مَصَّ صَبِيٌّ
u'مَصَّ عَلَقٌ':Subject, #1: 1	مَصَّ عُضْوَ
u'مَصَّ عَلَق':Subject, #1: 1	مَصَّ الْعَلَقُ
u'مَصَّ قَارُورَةٌ':Predicate, #1: 1	مَصَّ الْعَلَقُ
u'مَصَّ قُرَادٌ':Predicate, #2: 2	مَصَّ الْقَارُورَةَ
u'مَصَّ قُرَادٌ':Subject, #1: 1	مَصَّ الْقُرَادَ
u'مَصَّ قَصَبٌ':Predicate, #1: 1	مَصَّ الْقُرَادُ
u'مَصَّ لبن':Predicate, #1: 1	مَصَّ قَصَبَ
u'مَصَّ لَبَنٌ':Predicate, #1: 1	أَمَصَّ اللَّبَنَ
u'مَصِيرٌ بَعْضٌ':Added, #1: 1	أَمَصَّ اللَّبَنَ
u'مَصِيرٌ جَمَاهِيرُ':Added, #2: 2	مَصِيرُ بَعْضِ
u'مَصِيرٌ رُطَبٌ':Added, #1: 1	مَصِيرُ جَمَاهِيرِ
u'مَصِيرٌ رَهْنٌ':Added, #1: 1	مَصِيرِ الرُّطَبِ
u'مَصِيرٌ ظِلٌّ':Added, #1: 1	مَصِيرَ الرَّهْنِ
u'مَصِيرٌ ظِلٌّ':Added, #1: 1	مَصِيرِ الظِّلِّ
u'مَصِيرٌ عَبْدٌ':Added, #3: 3	مَصِيرِ ظِلِّ
u'مَصِيرٌ عَبْدٌ':Added, #1: 1	مَصِيرُ عَبْدِ
u'مَصِيرٌ فَيْءٌ':Added, #4: 4	مَصِيرِ الْعَبْدِ
u'مَصِيرٌ فِيلٌ':Added, #1: 1	مَصِيرَ الْفَيْءِ
u'مَصِيرٌ مَنْزِلٌ':Added, #1: 1	مَصِيرُ الْفِيلِ
u'مَضَاءٌ عَقْدٌ':Added, #1: 1	مَصِيرُ مَنْزِلِ
u'مُضَاجَعَةٌ الْمَرْأَةُ':Added, #1: 1	مَضَاءَ الْعَقْدِ
u'مُضَادٌّ إمَامٌ':Added, #1: 1	مُضَاجَعَةِ الْمَرْأَةِ
u'مُضَادَّةٌ إمَامٌ':Added, #1: 1	مُضَادَّةَ الْإِمَامِ
u'مُضَادَّةٌ جَامِعٌ':Added, #1: 1	مُضَادَّةَ الْإِمَامِ
u'مُضَادَّةٌ حَقٌّ':Added, #1: 1	مُضَادَّةُ الْجَامِعِ
u'مُضَادَّةٌ دُخُولٌ':Added, #1: 1	مُضَادَّةِ الْحَقِّ
u'مُضَادَّةٌ شَارِعٌ':Added, #1: 1	مُضَادَّةِ الدُّخُولِ
u'مُضَادَّةٌ غَرَضٌ':Added, #1: 1	مُضَادَّةِ الشَّارِعِ
u'مُضَادٌّ جَامِعٌ':Added, #1: 1	مُضَادَّةُ غَرَضِ
u'مُضَادٌّ حَقٌّ':Added, #1: 1	مُضَادَّةُ الْجَامِعِ
u'مُضَادٌّ دُخُولٌ':Added, #1: 1	مُضَادَّةِ الْحَقِّ
u'مُضَادٌّ شَارِعٌ':Added, #1: 1	مُضَادَّةِ الدُّخُولِ
u'مُضَادٌّ غَرَضٌ':Added, #1: 1	مُضَادَّةِ الشَّارِعِ
u'مُضَارَبَةٌ أهْلٌ':Added, #1: 1	مُضَادَّةُ غَرَضِ
u'مُضَارَبَةٌ بَزّاز':Added, #1: 1	مُضَارَبَةِ أَهْلِ
u'مُضَارَبَةٌ بَزّازَة':Added, #1: 1	مُضَارَبَةِ الْبَزَّازِيَّةِ
u'مُضَارَبَةٌ جَوْهَرٌ':Added, #1: 1	مُضَارَبَةِ الْبَزَّازِيَّةِ
u'مُضَارَبَةٌ صَغِيرٌ':Added, #1: 1	مُضَارَبَةِ الْجَوْهَرَةِ
u'مُضَارَبَةٌ عَبَّاسٌ':Added, #1: 1	مُضَارَبَةِ الصَّغِيرِ
u'مُضَارَبَةٌ فَاسِدٌ':Added, #1: 1	مُضَارَبَةُ الْعَبَّاسِ
u'مُضَارَبَةٌ فلان':Added, #4: 4	مُضَارَبَةٍ فَاسِدَةٍ
u'مُضَارَبَةٌ قَائِمٌ':Added, #1: 1	مُضَارَبَةِ الْبَزَّازِيَّةِ
u'مُضَارَبَةٌ قَائِمَةٌ':Added, #1: 1	مُضَارَبَةٍ قَائِمَةٍ
u'مُضَارَبَةٌ قَرْضٌ':Added, #1: 1	مُضَارَبَةٍ قَائِمَةٍ
u'مُضَارَبَةٌ مُضَارِبٌ':Added, #1: 1	مُضَارَبَةَ قَرْضٍ
u'مُضَاعَفٌ أَجْرٌ':Added, #1: 1	مُضَارَبَةُ الْمُضَارِبِ
u'مُضَاعَفَةٌ أَجْرٌ':Added, #1: 1	مُضَاعَفَةُ الْأَجْرِ
u'مُضَاعَفَةٌ ثَوابٌ':Added, #1: 1	مُضَاعَفَةُ الْأَجْرِ
u'مُضَاعَفَةٌ حَديدٌ':Added, #1: 1	مُضَاعَفَةُ الثَّوَابِ
u'مُضَاعَفَةٌ زَكاةٌ':Added, #1: 1	مُضَاعَفَةِ الْحَدِيدِ
u'مُضَاعَفَةٌ سَيِّئٌ':Added, #1: 1	مُضَاعَفَةِ الزَّكَاةِ
u'مُضَاعَفَةٌ صدقة':Added, #1: 1	مُضَاعَفَةُ السَّيِّئَاتِ
u'مُضَاعَفَةٌ صدقة':Added, #1: 1	مُضَاعَفَةُ الصَّدَقَةِ
u'مُضَاعَفَةٌ صَدَقَةٌ':Added, #1: 1	مُضَاعَفَةِ الصَّدَقَةِ
u'مُضَاعَفَةٌ صَدَقَةٌ':Added, #1: 1	مُضَاعَفَةُ الصَّدَقَةِ
u'مُضَاعَفَةٌ صَلاَةٌ':Added, #1: 1	مُضَاعَفَةِ الصَّدَقَةِ
u'مُضَاعَفَةٌ صَلاَةٌ':Added, #2: 2	مُضَاعَفَةُ الصَّلَاةِ
u'مُضَاعَفَةٌ طَاعَةٌ':Added, #4: 4	مُضَاعَفَةِ الصَّلَاةِ
u'مُضَاعَفَةٌ عَذَابٌ':Added, #1: 1	مُضَاعَفَةِ الطَّاعَاتِ
u'مُضَاعَفَةٌ عقاب':Added, #1: 1	مُضَاعَفَةَ الْعَذَابِ
u'مُضَاعَفَةٌ عِقَابٌ':Added, #1: 1	مُضَاعَفَةُ الْعِقَابِ
u'مُضَاعَفَةٌ فَرَائِضُ':Added, #1: 1	مُضَاعَفَةُ الْعِقَابِ
u'مُضَاعَفَةٌ نَفْلٌ':Added, #1: 1	مُضَاعَفَةِ الْفَرَائِضِ
u'مُضَاعَفٌ ثَوابٌ':Added, #1: 1	مُضَاعَفَةُ النَّفْلِ
u'مُضَاعَفٌ حَديدٌ':Added, #1: 1	مُضَاعَفَةُ الثَّوَابِ
u'مُضَاعَفٌ زَكاةٌ':Added, #1: 1	مُضَاعَفَةِ الْحَدِيدِ
u'مُضَاعَفٌ سَيِّئٌ':Added, #1: 1	مُضَاعَفَةِ الزَّكَاةِ
u'مُضَاعَفٌ صدقة':Added, #1: 1	مُضَاعَفَةُ السَّيِّئَاتِ
u'مُضَاعَفٌ صدقة':Added, #1: 1	مُضَاعَفَةُ الصَّدَقَةِ
u'مُضَاعَفٌ صَدَقَةٌ':Added, #1: 1	مُضَاعَفَةِ الصَّدَقَةِ
u'مُضَاعَفٌ صَدَقَةٌ':Added, #1: 1	مُضَاعَفَةُ الصَّدَقَةِ
u'مُضَاعَفٌ صَلاَةٌ':Added, #1: 1	مُضَاعَفَةِ الصَّدَقَةِ
u'مُضَاعَفٌ صَلاَةٌ':Added, #2: 2	مُضَاعَفَةُ الصَّلَاةِ
u'مُضَاعَفٌ طَاعَةٌ':Added, #4: 4	مُضَاعَفَةِ الصَّلَاةِ
u'مُضَاعَفٌ عَذَابٌ':Added, #1: 1	مُضَاعَفَةِ الطَّاعَاتِ
u'مُضَاعَفٌ عقاب':Added, #1: 1	مُضَاعَفَةَ الْعَذَابِ
u'مُضَاعَفٌ عِقَابٌ':Added, #1: 1	مُضَاعَفَةُ الْعِقَابِ
u'مُضَاعَفٌ فَرَائِضُ':Added, #1: 1	مُضَاعَفَةُ الْعِقَابِ
u'مُضَاعَفٌ نَفْلٌ':Added, #1: 1	مُضَاعَفَةِ الْفَرَائِضِ
u'مُضَاهَاةٌ أُمُورٌ':Added, #1: 1	مُضَاعَفَةُ النَّفْلِ
u'مُضَاهَاةٌ تَشْرِيعٌ':Added, #1: 1	مُضَاهَاةَ الْأُمُورِ
u'مُضَايَقَةٌ أَبٌ':Added, #2: 2	مُضَاهَاةِ التَّشْرِيعِ
u'مَضَضٌ تَوْبِيخٌ':Added, #1: 1	مُضَايَقَةِ الْأَبِ
u'مَضَغَ حَبٌّ':Predicate, #1: 1	مَضَضُ التَّوْبِيخِ
u'مَضَغَ حَبَّةٌ':Predicate, #1: 1	مَضَغَ حَبَّةَ
u'مَضْغٌ سَذَابٌ':Added, #1: 1	مَضَغَ حَبَّةَ
u'مَضْغٌ طعام':Added, #1: 1	مَضْغُ السَّذَابِ
u'مَضْغٌ طعام':Added, #1: 1	مَضْغَ الطَّعَامِ
u'مَضْغٌ طعام':Added, #1: 1	مَضْغُ الطَّعَامِ
u'مَضْغٌ طَعَامٌ':Added, #1: 1	مَضْغِ الطّعَامِ
u'مَضْغٌ طَعَامٌ':Added, #1: 1	مَضْغَ الطَّعَامِ
u'مَضْغٌ طَعَامٌ':Added, #1: 1	مَضْغُ الطَّعَامِ
u'مَضْغٌ عَلَقٌ':Added, #1: 1	مَضْغِ الطّعَامِ
u'مَضْغٌ عَلَق':Added, #1: 1	مَضْغُ الْعَلَقِ
u'مَضَغَ عِلْكٌ':Predicate, #1: 1	مَضْغُ الْعَلَقِ
u'مَضْغٌ عِلْكٌ':Added, #4: 4	مَضَغَ الْعِلْكَ
u'مَضْغٌ عِلْكٌ':Added, #1: 1	مَضْغِ الْعِلْكِ
u'مَضْغٌ عِلْكٌ':Added, #3: 3	مَضْغَ الْعِلْكِ
u'مَضَغَ قَمْحٌ':Predicate, #9: 9	مَضْغُ الْعِلْكِ
u'مَضْغٌ كَلاَمٌ':Added, #1: 1	مَضَغَ قَمْحَةً
u'مَضْغٌ لَحْمٌ':Added, #2: 2	مَضْغَ الْكَلَامِ
u'مَضَغَ يَابِسٌ':Predicate, #1: 1	مَضْغُ لَحْمِ
u'مَضْمَضَةٌ رَسُولٌ':Added, #1: 1	مَضَغَ الْيَابِسَةَ
u'مَضْمَضَةٌ وُضُوءٌ':Added, #1: 1	مَضْمَضَةِ رَسُولِ
u'مَضَى اِبْنٌ':Subject, #1: 1	مَضْمَضَةِ الْوُضُوءِ
u'مَضَى أَجَلٌ':Subject, #3: 3	مَضَى ابْنُ
u'مَضَى أَجَلٌ':Subject, #10: 10	مَضَى الْأَجَلُ
u'مَضَى أَجَلٌ':Subject, #1: 1	مَضَى الأَجَلُ
u'مَضَى أحَدٌ':Subject, #2: 2	مَضَى أَجَلُ
u'مَضَى أَحْوالٌ':Subject, #1: 1	مَضَى أَحَدُ
u'مَضَى أحْوَالٌ':Subject, #1: 1	مَضَى أَحْوَالٌ
u'مَضَى أَدَاءٌ':Subject, #1: 1	مَضَى أَحْوَالٌ
u'مَضَى أَرْبَعُ':Subject, #1: 1	مَضَى الْأَدَاءُ
u'مَضَى أَرْبَعَةٌ':Subject, #2: 2	مَضَى أَرْبَعُ
u'مَضَى أَرْبَعَةٌ':Subject, #1: 1	مَضَى الْأَرْبَعَةُ
u'مَضَى إِسْنادٌ':Subject, #2: 2	مَضَى أَرْبَعَةُ
u'مَضَى إشارَة':Subject, #1: 1	مَضَى إِسْنَادُ
u'مَضَى أَشْهُرٌ':Subject, #1: 1	مَضَى إِشَارَةٌ
u'مَضَى أَشْيَاخٌ':Subject, #1: 1	مَضَى أَشْهُرٌ
u'مَضَى أَعْوَامٌ':Subject, #2: 2	مَضَى الْأَشْيَاخُ
u'مَضَى أَكْثَرُ':Subject, #1: 1	مَضَى أَعْوَامٌ
u'مَضَى إمَامٌ':Subject, #6: 6	مَضَى أَكْثَرُ
u'مَضَى أَمْرٌ':Subject, #1: 1	مَضَى الْإِمَامُ
u'مَضَى أَمْرٌ':Subject, #1: 1	مَضَى أَمْرُهُ
u'مَضَى أهْلٌ':Subject, #7: 7	مَضَى الْأَمْرُ
u'مَضَى أَوَّلُ':Subject, #3: 3	مَضَى أَهْلُ
u'مَضَى أيَّامٌ':Subject, #1: 1	مَضَى الْأَوَّلُ
u'مَضَى أَيَّامٌ':Subject, #3: 3	مَضَى أَيَّامٌ
u'مَضَى بَدْرٌ':Subject, #3: 3	مَضَى أَيَّامٌ
u'مَضَى بَطَلٌ':Predicate, #1: 1	مَضَى بَدْرٌ
u'مَضَى بَعْضٌ':Subject, #3: 3	مَضَى بَطَلَ
u'مَضَى بَعْضٌ':Subject, #10: 10	مَضَى بَعْضُ
u'مَضَى بَيْعٌ':Subject, #3: 3	مَضَى بَعْضُهُ
u'مَضَى بَيْنٌ':Predicate, #7: 7	مَضَى الْبَيْعُ
u'مَضَى تِسْعَةٌ':Subject, #2: 2	مَضَى بَيْنَ
u'مَضَى تَعْمِيرٌ':Subject, #1: 1	مَضَى تِسْعَةٌ
u'مَضَى تَفْسِيرٌ':Subject, #1: 1	مَضَى التَّعْمِيرُ
u'مَضَى تمام':Subject, #1: 1	مَضَى تَفْسِيرُ
u'مَضَى تَمامٌ':Subject, #2: 2	مَضَى تَمَامُ
u'مَضَى ثَلاثُ':Predicate, #2: 2	مَضَى تَمَامُ
u'مَضَى ثَلاثُ':Subject, #1: 1	مَضَى ثَلَاثَ
u'مَضَى ثَلاثُ':Subject, #1: 1	مَضَى الثَّلَاثُ
u'مَضَى ثَمانِيَةٌ':Predicate, #3: 3	مَضَى ثَلَاثُ
u'مَضَى ثَمانِيَةٌ':Subject, #1: 1	مَضَى ثَمَانِيَةَ
u'مَضَى ثَوابٌ':Predicate, #2: 2	مَضَى ثَمَانِيَةُ
u'مَضَى جُزْءٌ':Subject, #1: 1	مَضَى ثَوَابَ
u'مَضَى جُزْءٌ':Subject, #1: 1	مَضَى جُزْءُ
u'مَضَى جود':Subject, #3: 3	مَضَى جُزْءٌ
u'مَضَى جُودٌ':Subject, #1: 1	مَضَى الْجُودُ
u'مَضَى حَجَرٌ':Subject, #1: 1	مَضَى الْجُودُ
u'مَضَى حَديثٌ':Subject, #1: 1	مَضَى حَجَرٌ
u'مَضَى حَديثٌ':Subject, #1: 1	مَضَى حَدِيثُهُ
u'مَضَى حَديثٌ':Subject, #31: 31	مَضَى حَدِيثُ
u'مَضَى حساب':Subject, #3: 3	مَضَى الْحَدِيثُ
u'مَضَى حِسَابٌ':Subject, #1: 1	مَضَى حِسَابُهُ
u'مَضَى حُكْمٌ':Subject, #1: 1	مَضَى حِسَابُهُ
u'مَضَى حُكْمٌ':Subject, #1: 1	مَضَى حُكْمُهُ
u'مَضَى حول':Subject, #6: 6	مَضَى الْحُكْمُ
u'مَضَى حَوْلٌ':Subject, #3: 3	مَضَى الْحَوْلُ
u'مَضَى حول':Subject, #3: 3	مَضَى الْحَوْلُ
u'مَضَى حَوْلٌ':Subject, #5: 5	مَضَى حَوْلٌ
u'مَضَى حَيْضَةٌ':Subject, #5: 5	مَضَى حَوْلٌ
u'مَضَى خَبَرٌ':Subject, #2: 2	مَضَى حَيْضَةٌ
u'مَضَى خَبَر':Subject, #1: 1	مَضَى الْخَبَرُ
u'مَضَى خَبَرٌ':Subject, #1: 1	مَضَى الْخَبَرُ
u'مَضَى خَبَر':Subject, #1: 1	مَضَى خَبَرُ
u'مَضَى خِلاَفٌ':Subject, #1: 1	مَضَى خَبَرُ
u'مَضَى خَمْسَةٌ':Predicate, #1: 1	مَضَى خِلَافٌ
u'مَضَى ذكر':Subject, #2: 2	مَضَى خَمْسَةَ
u'مَضَى ذِكْرٌ':Subject, #2: 2	مَضَى ذِكْرُ
u'مَضَى ذكر':Subject, #2: 2	مَضَى ذِكْرُ
u'مَضَى ذِكْرٌ':Subject, #40: 40	مَضَى ذِكْرُهُ
u'مَضَى رَأْسٌ':Subject, #40: 40	مَضَى ذِكْرُهُ
u'مَضَى رُبُعٌ':Subject, #1: 1	مَضَى رَأْسُ
u'مَضَى رُبُعٌ':Subject, #1: 1	مَضَى رُبُعٌ
u'مَضَى رُبْعٌ':Subject, #1: 1	مَضَى رُبُعُ
u'مَضَى رَسُولٌ':Subject, #1: 1	مَضَى رُبْعُ
u'مَضَى رَمَضانُ':Subject, #12: 12	مَضَى رَسُولُ
u'مَضَى زادٌ':Predicate, #1: 1	مَضَى رَمَضَانُ
u'مَضَى زَكاةٌ':Subject, #1: 1	مَضَى زَادَ
u'مَضَى زَمانٌ':Subject, #1: 1	مَضَى زَكَاةٌ
u'مَضَى زَمَنٌ':Subject, #7: 7	مَضَى زَمَانٌ
u'مَضَى زَمَنٌ':Subject, #1: 1	مَضَى الزَّمَنُ
u'مَضَى زَمَنٌ':Subject, #1: 1	مَضَى زَمَنُهُ
u'مَضَى زَمَنٌ':Subject, #9: 9	مَضَى زَمَنٌ
u'مَضَى سَاعَةٌ':Subject, #9: 9	مَضَى زَمَنُ
u'مَضَى سَائِرٌ':Subject, #2: 2	مَضَى سَاعَةٌ
u'مَضَى سائِل':Subject, #6: 6	مَضَى سَائِرُ
u'مَضَى سَائِلٌ':Subject, #2: 2	مَضَى السَّائِلُ
u'مَضَى سَبْعَةٌ':Predicate, #2: 2	مَضَى السَّائِلُ
u'مَضَى سَبْعَةٌ':Subject, #1: 1	مَضَى سَبْعَةَ
u'مَضَى سِتٌّ':Subject, #1: 1	مَضَى سَبْعَةُ
u'مَضَى سقط':Predicate, #2: 2	مَضَى سِتَّةُ
u'مَضَى سَقَطٌ':Predicate, #2: 2	مَضَى سَقَطَ
u'مَضَى سَلَفٌ':Subject, #2: 2	مَضَى سَقَطَ
u'مَضَى سَنَةٌ':Subject, #1: 1	مَضَى السَّلَفُ
u'مَضَى سَواءٌ':Subject, #3: 3	مَضَى سَنَةٌ
u'مَضَى شَطْرٌ':Subject, #2: 2	مَضَى سَوَاءٌ
u'مَضَى شَهْرٌ':Subject, #2: 2	مَضَى شَطْرُ
u'مَضَى شَهْرٌ':Subject, #13: 13	مَضَى الشَّهْرُ
u'مَضَى شَهْرٌ':Subject, #1: 1	مَضَى شَهْرُ
u'مَضَى شوَاهِدُ':Subject, #49: 49	مَضَى شَهْرٌ
u'مَضَى شَوَاهِدُ':Subject, #1: 1	مَضَى شَوَاهِدُ
u'مَضَى شَيْءٌ':Subject, #1: 1	مَضَى شَوَاهِدُ
u'مَضَى صَدْرٌ':Subject, #1: 1	مَضَى شَيْءٌ
u'مَضَى صَدْرٌ':Subject, #2: 2	مَضَى صَدْرُ
u'مَضَى طَلاَقٌ':Subject, #4: 4	مَضَى صَدْرٌ
u'مَضَى عَالَمٌ':Subject, #1: 1	مَضَى الطَّلَاقُ
u'مَضَى عَامٌ':Subject, #1: 1	مَضَى عَالَمٌ
u'مَضَى عَامٌ':Subject, #1: 1	مَضَى الْعَامُ
u'مَضَى عَبْدٌ':Subject, #1: 1	مَضَى عَامٌ
u'مَضَى عَبْدٌ':Subject, #2: 2	مَضَى الْعَبْدُ
u'مَضَى عتق':Subject, #2: 2	مَضَى عَبْدُ
u'مَضَى عِتْقٌ':Subject, #4: 4	مَضَى عِتْقُهُ
u'مَضَى عُدٌّ':Predicate, #4: 4	مَضَى عِتْقُهُ
u'مَضَى عُرْسٌ':Subject, #1: 1	مَضَى عُدَّ
u'مَضَى عِشْرُون':Predicate, #2: 2	مَضَى الْعُرْسُ
u'مَضَى عَقْدٌ':Subject, #1: 1	مَضَى عِشْرُونَ
u'مَضَى علم':Predicate, #1: 1	مَضَى الْعَقْدُ
u'مَضَى عَلِيٌّ':Subject, #1: 1	مَضَى عَلِمَ
u'مَضَى عَمَلٌ':Subject, #1: 1	مَضَى عَلِيٌّ
u'مَضَى عند':Predicate, #3: 3	مَضَى عَمَلُ
u'مَضَى عُهْدَةٌ':Subject, #1: 1	مَضَى عِنْدَ
u'مَضَى عِيدٌ':Subject, #1: 1	مَضَى عُهْدَةٌ
u'مَضَى غَالِبٌ':Subject, #1: 1	مَضَى الْعِيدُ
u'مَضَى غَدٌ':Subject, #1: 1	مَضَى غَالِبُ
u'مَضَى فَسْخٌ':Subject, #12: 12	مَضَى الْغَدُ
u'مَضَى فِعْلٌ':Subject, #1: 1	مَضَى الْفَسْخُ
u'مَضَى فَلًا':Predicate, #1: 1	مَضَى فِعْلُهُ
u'مَضَى قَالٌ':Predicate, #1: 1	مَضَى فَلاَ
u'مَضَى قَدْرٌ':Subject, #12: 12	مَضَى قَالَ
u'مَضَى قُرْء':Subject, #3: 3	مَضَى قَدْرُ
u'مَضَى قَضَاءٌ':Subject, #1: 1	مَضَى قُرْءٌ
u'مَضَى قول':Subject, #1: 1	مَضَى الْقَضَاءُ
u'مَضَى قَوْلٌ':Subject, #1: 1	مَضَى قَوْلُ
u'مَضَى قول':Subject, #1: 1	مَضَى قَوْلُ
u'مَضَى قَوْلٌ':Subject, #1: 1	مَضَى قَوْلُهُ
u'مَضَى كِفَايَةٌ':Subject, #1: 1	مَضَى قَوْلُهُ
u'مَضَى كَفِيلٌ':Subject, #9: 9	مَضَى كِفَايَةٌ
u'مَضَى كَلاَمٌ':Subject, #1: 1	مَضَى الْكَفِيلُ
u'مَضَى كَلاَمٌ':Subject, #1: 1	مَضَى الْكَلاَمُ
u'مَضَى كَلْبٌ':Subject, #2: 2	مَضَى الْكَلَامُ
u'مَضَى لَيْلٌ':Subject, #1: 1	مَضَى الْكَلْبُ
u'مَضَى مَجْلِسٌ':Subject, #2: 2	مَضَى لَيْلَةٌ
u'مَضَى مُجْمَلٌ':Subject, #1: 1	مَضَى مَجْلِسٌ
u'مَضَى مُخْتَلَفٌ':Subject, #1: 1	مَضَى مُجْمَلٌ
u'مَضَى مُدَّةٌ':Subject, #2: 2	مَضَى الْمُخْتَلَفُ
u'مَضَى مَذْهَبٌ':Subject, #1: 1	مَضَى الْمُدَّةُ
u'مَضَى مُعْظَمٌ':Subject, #1: 1	مَضَى الْمَذْهَبُ
u'مَضَى مَنْزِلَةٌ':Predicate, #1: 1	مَضَى مُعْظَمُ
u'مَضَى مَوْصُولٌ':Predicate, #1: 1	مَضَى مَنْزِلَةَ
u'مَضَى نَاسٌ':Subject, #2: 2	مَضَى مَوْصُولاً
u'مَضَى نَجْمٌ':Subject, #1: 1	مَضَى النّاسُ
u'مَضَى نِصْفٌ':Subject, #2: 2	مَضَى النَّجْمُ
u'مَضَى نِصْفٌ':Subject, #1: 1	مَضَى نِصْفُهُ
u'مَضَى نِصْفٌ':Subject, #3: 3	مَضَى النِّصْفُ
u'مَضَى نَظَرٌ':Subject, #7: 7	مَضَى نِصْفُ
u'مَضَى نكاح':Subject, #1: 1	مَضَى نَظَرٌ
u'مَضَى نِكَاحٌ':Subject, #1: 1	مَضَى النِّكَاحُ
u'مَضَى نكاح':Subject, #1: 1	مَضَى النِّكَاحُ
u'مَضَى نِكَاحٌ':Subject, #2: 2	مَضَى نِكَاحُ
u'مَضَى هَدَرٌ':Subject, #2: 2	مَضَى نِكَاحُ
u'مَضَى هَدِيٌّ':Predicate, #1: 1	مَضَى هَدَرٌ
u'مَضَى هَدْيٌ':Subject, #1: 1	مَضَى هَدِيَّةً
u'مَضَى واحد':Subject, #1: 1	مَضَى هَدْيٌ
u'مَضَى وَاحِدٌ':Subject, #1: 1	مَضَى وَاحِدٌ
u'مَضَى وَجْهٌ':Subject, #1: 1	مَضَى وَاحِدٌ
u'مَضَى وَطْءٌ':Predicate, #1: 1	مَضَى وَجْهُ
u'مَضَى وَقْتٌ':Subject, #1: 1	مَضَى وَطْءَ
u'مَضَى وَقْتٌ':Subject, #12: 12	مَضَى وَقْتُ
u'مَضَى وَقْتٌ':Subject, #1: 1	مَضَى وَقْتٌ
u'مَضَى وَقْتٌ':Subject, #1: 1	مَضَى وَقْتُهُ
u'مَضَى وقع':Predicate, #20: 20	مَضَى الْوَقْتُ
u'مَضَى وَلَهٌ':Subject, #1: 1	مَضَى وَقَعَ
u'مَضَى يَوْمٌ':Predicate, #1: 1	مَضَى وَلَهُ
u'مَضَى يَوْمٌ':Subject, #3: 3	مَضَى الْيَوْمَ
u'مَضَى يَوْمٌ':Subject, #16: 16	مَضَى يَوْمٌ
u'مَضَى يَوْمٌ':Subject, #24: 24	مَضَى الْيَوْمُ
u'مُطَابَقَةٌ إِرَادَةٌ':Added, #4: 4	مَضَى يَوْمُ
u'مُطَابَقَةٌ اِعْتِقادٌ':Added, #1: 1	مُطَابَقَةِ إرَادَتِهِ
u'مُطَابَقَةٌ اِعْتِقادٌ':Added, #1: 1	مُطَابَقَةُ اعْتِقَادِ
u'مُطَابَقَةٌ جَوَابٌ':Added, #1: 1	مُطَابَقَةِ اعْتِقَادِهِ
u'مُطَابَقَةٌ جَوَابٌ':Added, #1: 1	مُطَابَقَةُ الْجَوَابِ
u'مُطَابَقَةٌ حُكْمٌ':Added, #2: 2	مُطَابَقَةِ جَوَابِهِ
u'مُطَابَقَةٌ خَارِجٌ':Added, #1: 1	مُطَابَقَةُ حُكْمِ
u'مُطَابَقَةٌ خَبَرٌ':Added, #2: 2	مُطَابَقَةِ خَارِجٍ
u'مُطَابَقَةٌ خَبَرٌ':Added, #1: 1	مُطَابَقَةُ الْخَبَرِ
u'مُطَابَقَةٌ خَبَر':Added, #1: 1	مُطَابَقَةِ الْخَبَرِ
u'مُطَابَقَةٌ خَبَر':Added, #1: 1	مُطَابَقَةُ الْخَبَرِ
u'مُطَابَقَةٌ رِوايَةٌ':Added, #1: 1	مُطَابَقَةِ الْخَبَرِ
u'مُطَابَقَةٌ صُورَةٌ':Added, #1: 1	مُطَابَقَةِ الرِّوَايَةِ
u'مُطَابَقَةٌ ضَمِيرٌ':Added, #1: 1	مُطَابَقَةِ الصُّورَةِ
u'مُطَابَقَةٌ ظَنٌّ':Added, #1: 1	مُطَابَقَةُ الضَّمِيرِ
u'مُطَابَقَةٌ ظَنٌّ':Added, #1: 1	مُطَابَقَةَ ظَنِّ
u'مُطَابَقَةٌ ظَنٌّ':Added, #1: 1	مُطَابَقَةِ ظَنِّ
u'مُطَابَقَةٌ نَصٌّ':Added, #1: 1	مُطَابَقَةِ ظَنِّهِ
u'مُطَابَقَةٌ نَفْسِيٌّ':Added, #1: 1	مُطَابَقَةُ النَّصِّ
u'مُطَابَقَةٌ وَاقِعٌ':Added, #1: 1	مُطَابَقَةِ النَّفْسِيَّةِ
u'مُطَابَقَةٌ وَضْعٌ':Added, #1: 1	مُطَابَقَةِ الْوَاقِعِ
u'مُطَابَقَةٌ يَمِينٌ':Added, #1: 1	مُطَابَقَةِ الْوَضْعِ
u'مُطَالَبٌ أَبٌ':Added, #1: 1	مُطَابَقَةِ الْيَمِينِ
u'مُطَالَبٌ أَبٌ':Added, #1: 1	مُطَالَبَةَ أَبٍ
u'مُطَالَبٌ أَبٌ':Added, #2: 2	مُطَالَبَةَ الْأَبِ
u'مُطَالَبٌ أَجْرٌ':Added, #4: 4	مُطَالَبَةُ الْأَبِ
u'مُطَالَبٌ أُجْرَةٌ':Added, #1: 1	مُطَالَبَةِ الْأَجْرِ
u'مُطَالَبٌ أَجْنَبِيٌّ':Added, #1: 1	مُطَالَبَةِ الْأُجْرَةِ
u'مُطَالَبٌ أَجِيرٌ':Added, #3: 3	مُطَالَبَةُ الْأَجْنَبِيِّ
u'مُطَالَبٌ أحَدٌ':Added, #1: 1	مُطَالَبَةَ الْأَجِيرِ
u'مُطَالَبٌ آدَمِيٌّ':Added, #1: 1	مُطَالَبَةِ أَحَدِ
u'مُطَالَبٌ اِسْتيفاءٌ':Added, #2: 2	مُطَالَبَةِ الْآدَمِيِّ
u'مُطَالَبٌ أصل':Added, #1: 1	مُطَالَبَةِ اسْتِيفَاءِ
u'مُطَالَبٌ أًصْلٌ':Added, #1: 1	مُطَالَبَةَ الْأَصْلِ
u'مُطَالَبٌ أَصيلٌ':Added, #1: 1	مُطَالَبَةَ الْأَصْلِ
u'مُطَالَبٌ الْمَرْأَةُ':Added, #6: 6	مُطَالَبَةِ الْأَصِيلِ
u'مُطَالَبٌ إمَامٌ':Added, #1: 1	مُطَالَبَةَ الْمَرْأَةِ
u'مُطَالَبٌ أَمينٌ':Added, #1: 1	مُطَالَبَةُ الْإِمَامِ
u'مُطَالَبٌ بَائِعٌ':Added, #2: 2	مُطَالَبَةُ أَمِينِهِ
u'مُطَالَبٌ بَائِعٌ':Added, #4: 4	مُطَالَبَةَ الْبَائِعِ
u'مُطَالَبٌ بَائِعٌ':Added, #4: 4	مُطَالَبَةِ الْبَائِعِ
u'مُطَالَبٌ بَدَلٌ':Added, #5: 5	مُطَالَبَةُ الْبَائِعِ
u'مُطَالَبٌ بَدَلٌ':Added, #1: 1	مُطَالَبَةِ الْبَدَلِ
u'مُطَالَبٌ بَدَلٌ':Added, #1: 1	مُطَالَبَةَ بَدَلِ
u'مُطَالَبَةٌ أَبٌ':Added, #1: 1	مُطَالَبَةُ بَدَلِ
u'مُطَالَبَةٌ أَبٌ':Added, #1: 1	مُطَالَبَةَ أَبٍ
u'مُطَالَبَةٌ أَبٌ':Added, #2: 2	مُطَالَبَةَ الْأَبِ
u'مُطَالَبَةٌ أَجْرٌ':Added, #4: 4	مُطَالَبَةُ الْأَبِ
u'مُطَالَبَةٌ أُجْرَةٌ':Added, #1: 1	مُطَالَبَةِ الْأَجْرِ
u'مُطَالَبَةٌ أَجْنَبِيٌّ':Added, #1: 1	مُطَالَبَةِ الْأُجْرَةِ
u'مُطَالَبَةٌ أَجِيرٌ':Added, #3: 3	مُطَالَبَةُ الْأَجْنَبِيِّ
u'مُطَالَبَةٌ أحَدٌ':Added, #1: 1	مُطَالَبَةَ الْأَجِيرِ
u'مُطَالَبَةٌ آدَمِيٌّ':Added, #1: 1	مُطَالَبَةِ أَحَدِ
u'مُطَالَبَةٌ اِسْتيفاءٌ':Added, #2: 2	مُطَالَبَةِ الْآدَمِيِّ
u'مُطَالَبَةٌ أصل':Added, #1: 1	مُطَالَبَةِ اسْتِيفَاءِ
u'مُطَالَبَةٌ أًصْلٌ':Added, #1: 1	مُطَالَبَةَ الْأَصْلِ
u'مُطَالَبَةٌ أَصيلٌ':Added, #1: 1	مُطَالَبَةَ الْأَصْلِ
u'مُطَالَبَةٌ الْمَرْأَةُ':Added, #6: 6	مُطَالَبَةِ الْأَصِيلِ
u'مُطَالَبَةٌ إمَامٌ':Added, #1: 1	مُطَالَبَةَ الْمَرْأَةِ
u'مُطَالَبَةٌ أَمينٌ':Added, #1: 1	مُطَالَبَةُ الْإِمَامِ
u'مُطَالَبَةٌ بَائِعٌ':Added, #2: 2	مُطَالَبَةُ أَمِينِهِ
u'مُطَالَبَةٌ بَائِعٌ':Added, #4: 4	مُطَالَبَةَ الْبَائِعِ
u'مُطَالَبَةٌ بَائِعٌ':Added, #4: 4	مُطَالَبَةِ الْبَائِعِ
u'مُطَالَبَةٌ بَدَلٌ':Added, #5: 5	مُطَالَبَةُ الْبَائِعِ
u'مُطَالَبَةٌ بَدَلٌ':Added, #1: 1	مُطَالَبَةِ الْبَدَلِ
u'مُطَالَبَةٌ بَدَلٌ':Added, #1: 1	مُطَالَبَةَ بَدَلِ
u'مُطَالَبَةٌ ثَمَنٌ':Added, #1: 1	مُطَالَبَةُ بَدَلِ
u'مُطَالَبَةٌ جَارٌ':Added, #1: 1	مُطَالَبَةُ الثَّمَنِ
u'مُطَالَبَةٌ جهاز':Added, #1: 1	مُطَالَبَةُ جَارِهِ
u'مُطَالَبَةٌ جِهَازٌ':Added, #1: 1	مُطَالَبَةِ الْجِهَازِ
u'مُطَالَبَةٌ حاكِمٌ':Added, #1: 1	مُطَالَبَةِ الْجِهَازِ
u'مُطَالَبَةٌ حاكِمٌ':Added, #1: 1	مُطَالَبَةَ الْحَاكِمِ
u'مُطَالَبَةٌ حَدٌّ':Added, #1: 1	مُطَالَبَةِ الْحَاكِمِ
u'مُطَالَبَةٌ حَقٌّ':Added, #1: 1	مُطَالَبَةِ الْحَدِّ
u'مُطَالَبَةٌ خَصْمٌ':Added, #1: 1	مُطَالَبَةُ حَقٍّ
u'مُطَالَبَةٌ خَصْمٌ':Added, #1: 1	مُطَالَبَةُ خَصْمِهِ
u'مُطَالَبَةٌ خَلِيفَةٌ':Added, #1: 1	مُطَالَبَةِ خَصْمِهِ
u'مُطَالَبَةٌ دَيْنٌ':Added, #1: 1	مُطَالَبَةُ الْخَلِيفَةِ
u'مُطَالَبَةٌ دَيْنٌ':Added, #1: 1	مُطَالَبَةَ الدَّيْنِ
u'مُطَالَبَةٌ رَاهِنٌ':Added, #1: 1	مُطَالَبَةِ الدَّيْنِ
u'مُطَالَبَةٌ رَاهِنٌ':Added, #1: 1	مُطَالَبَةُ الرَّاهِنِ
u'مُطَالَبَةٌ رَبُّ':Added, #1: 1	مُطَالَبَةِ الرَّاهِنِ
u'مُطَالَبَةٌ رَبُّ':Added, #2: 2	مُطَالَبَةَ رَبِّ
u'مُطَالَبَةٌ رَجُلٌ':Added, #5: 5	مُطَالَبَةُ رَبِّ
u'مُطَالَبَةٌ رَسُولٌ':Added, #1: 1	مُطَالَبَةُ الرَّجُلِ
u'مُطَالَبَةٌ زَوْجٌ':Added, #1: 1	مُطَالَبَةُ الرَّسُولِ
u'مُطَالَبَةٌ زَوْجٌ':Added, #2: 2	مُطَالَبَةَ الزَّوْجِ
u'مُطَالَبَةٌ زَوْجٌ':Added, #2: 2	مُطَالَبَةِ الزَّوْجِ
u'مُطَالَبَةٌ زَوْجَةٌ':Added, #3: 3	مُطَالَبَةُ الزَّوْجِ
u'مُطَالَبَةٌ زِيادَةٌ':Added, #1: 1	مُطَالَبَةِ الزَّوْجَةِ
u'مُطَالَبَةٌ زَيْدٌ':Added, #1: 1	مُطَالَبَةِ الزِّيَادَةِ
u'مُطَالَبَةٌ زَيْدٌ':Added, #1: 1	مُطَالَبَةُ زَيْدٍ
u'مُطَالَبَةٌ سَيِّدٌ':Added, #1: 1	مُطَالَبَةِ زَيْدٍ
u'مُطَالَبَةٌ سَيِّدٌ':Added, #1: 1	مُطَالَبَةُ سَيِّدِهِ
u'مُطَالَبَةٌ سَيِّدٌ':Added, #2: 2	مُطَالَبَةُ السَّيِّدِ
u'مُطَالَبَةٌ شَرْعٌ':Added, #2: 2	مُطَالَبَةِ السَّيِّدِ
u'مُطَالَبَةٌ شَرِيكٌ':Added, #1: 1	مُطَالَبَةِ الشَّرْعِ
u'مُطَالَبَةٌ شفعة':Added, #3: 3	مُطَالَبَةُ شَرِيكِهِ
u'مُطَالَبَةٌ شُفْعَةٌ':Added, #1: 1	مُطَالَبَةُ الشُّفْعَةِ
u'مُطَالَبَةٌ صَغِيرٌ':Added, #1: 1	مُطَالَبَةُ الشُّفْعَةِ
u'مُطَالَبَةٌ ضَامِنٌ':Added, #1: 1	مُطَالَبَةُ الصَّغِيرِ
u'مُطَالَبَةٌ ضَامِنٌ':Added, #1: 1	مُطَالَبَة الضَّامِنِ
u'مُطَالَبَةٌ ضَامِنٌ':Added, #1: 1	مُطَالَبَةِ الضَّامِنِ
u'مُطَالَبَةٌ ضَامِنٌ':Added, #1: 1	مُطَالَبَةِ ضَامِنِ
u'مُطَالَبَةٌ طَالِبٌ':Added, #4: 4	مُطَالَبَةُ الضَّامِنِ
u'مُطَالَبَةٌ طَالِبٌ':Added, #1: 1	مُطَالَبَةَ الطَّالِبِ
u'مُطَالَبَةٌ طَالِبٌ':Added, #1: 1	مُطَالَبَةُ الطَّالِبِ
u'مُطَالَبَةٌ طَبْعٌ':Added, #1: 1	مُطَالَبَةِ الطَّالِبِ
u'مُطَالَبَةٌ عَاقِلٌ':Added, #1: 1	مُطَالَبَةِ الطَّبْعِ
u'مُطَالَبَةٌ عَاقِلٌ':Added, #1: 1	مُطَالَبَةُ الْعَاقِلَةِ
u'مُطَالَبَةٌ عَامِلٌ':Added, #1: 1	مُطَالَبَةَ عَاقِلَةِ
u'مُطَالَبَةٌ غَاصِبٌ':Added, #2: 2	مُطَالَبَةِ الْعَامِلِ
u'مُطَالَبَةٌ غَاصِبٌ':Added, #1: 1	مُطَالَبَةَ الْغَاصِبِ
u'مُطَالَبَةٌ غَاصِبٌ':Added, #1: 1	مُطَالَبَةُ الْغَاصِبِ
u'مُطَالَبَةٌ غرماء':Added, #1: 1	مُطَالَبَةُ غَاصِبٍ
u'مُطَالَبَةٌ فلان':Added, #2: 2	مُطَالَبَةِ الْغُرَمَاءِ
u'مُطَالَبَةٌ قَاتِلٌ':Added, #1: 1	مُطَالَبَةُ الْوَاصِفِ
u'مُطَالَبَةٌ قَاذِفٌ':Added, #2: 2	مُطَالَبَةُ قَاتِلِ
u'مُطَالَبَةٌ قَبَائِلُ':Added, #1: 1	مُطَالَبَةِ الْقَاذِفِ
u'مُطَالَبَةٌ قَرِيبٌ':Added, #1: 1	مُطَالَبَةِ الْقَبَائِلِ
u'مُطَالَبَةٌ كَفِيلٌ':Added, #1: 1	مُطَالَبَةِ الْقَرِيبِ
u'مُطَالَبَةٌ كَفِيلٌ':Added, #3: 3	مُطَالَبَةُ الْكَفِيلِ
u'مُطَالَبَةٌ مَالِكٌ':Added, #5: 5	مُطَالَبَةِ الْكَفِيلِ
u'مُطَالَبَةٌ مَالِكٌ':Added, #1: 1	مُطَالَبَةَ الْمَالِكِ
u'مُطَالَبَةٌ مَبِيعٌ':Added, #2: 2	مُطَالَبَةُ الْمَالِكِ
u'مُطَالَبَةٌ مُتْلِفٌ':Added, #2: 2	مُطَالَبَةَ الْمَبِيعِ
u'مُطَالَبَةٌ مثل':Added, #1: 1	مُطَالَبَةُ الْمُتْلِفِ
u'مُطَالَبَةٌ مِثْلٌ':Added, #2: 2	مُطَالَبَةَ مِثْلِهِ
u'مُطَالَبَةٌ مُحْتَالٌ':Added, #2: 2	مُطَالَبَةَ مِثْلِهِ
u'مُطَالَبَةٌ مُحِيل':Added, #1: 1	مُطَالَبَةَ الْمُحْتَالِ
u'مُطَالَبَةٌ مُحِيل':Added, #1: 1	مُطَالَبَةَ الْمُحِيلِ
u'مُطَالَبَةٌ مُحِيل':Added, #2: 2	مُطَالَبَةِ الْمُحِيلِ
u'مُطَالَبَةٌ مُخَالَفَةٌ':Added, #3: 3	مُطَالَبَةُ الْمُحِيلِ
u'مُطَالَبَةٌ مَدِينٌ':Added, #1: 1	مُطَالَبَةَ الْمُخَالَفَةِ
u'مُطَالَبَةٌ مَدِينٌ':Added, #1: 1	مُطَالَبَةُ الْمَدِينِ
u'مُطَالَبَةٌ مَدْيُونٌ':Added, #1: 1	مُطَالَبَةِ مَدِينِهِ
u'مُطَالَبَةٌ مَدْيُونٌ':Added, #1: 1	مُطَالَبَةِ الْمَدْيُونِ
u'مُطَالَبَةٌ مُرْتَهِنٌ':Added, #2: 2	مُطَالَبَةُ الْمَدْيُونِ
u'مُطَالَبَةٌ مُرْتَهِنٌ':Added, #1: 1	مُطَالَبَةُ الْمُرْتَهِنِ
u'مُطَالَبَةٌ مُرْسَلٌ':Added, #1: 1	مُطَالَبَةِ الْمُرْتَهِنِ
u'مُطَالَبَةٌ مُسْتَحِقٌّ':Added, #1: 1	مُطَالَبَةُ الْمُرْسَلِ
u'مُطَالَبَةٌ مُسْتَحِقٌّ':Added, #1: 1	مُطَالَبَةِ الْمُسْتَحِقِّ
u'مُطَالَبَةٌ مَسْرُوقٌ':Added, #2: 2	مُطَالَبَةُ الْمُسْتَحِقِّ
u'مُطَالَبَةٌ مُسْلِمٌ':Added, #1: 1	مُطَالَبَةُ الْمَسْرُوقِ
u'مُطَالَبَةٌ مَضْمُونٌ':Added, #1: 1	مُطَالَبَةَ مُسْلِمٍ
u'مُطَالَبَةٌ مُعْتَرِضٌ':Added, #1: 1	مُطَالَبَةُ الْمَضْمُونِ
u'مُطَالَبَةٌ مُفْلِسٌ':Added, #2: 2	مُطَالَبَةُ الْمُعْتَرِضِ
u'مُطَالَبَةٌ مَقْتُولٌ':Added, #1: 1	مُطَالَبَةُ الْمُفْلِسِ
u'مُطَالَبَةٌ مَقْذُوفٌ':Added, #2: 2	مُطَالَبَةُ الْمَقْتُولِ
u'مُطَالَبَةٌ مَقْذُوفٌ':Added, #1: 1	مُطَالَبَةِ الْمَقْذُوفِ
u'مُطَالَبَةٌ مَكّاس':Added, #2: 2	مُطَالَبَةُ الْمَقْذُوفِ
u'مُطَالَبَةٌ مُكْرَهٌ':Added, #1: 1	مُطَالَبَةَ الْمَكَّاسِ
u'مُطَالَبَةٌ مُكْرِهٌ':Added, #1: 1	مُطَالَبَةُ مُكْرَهِهِ
u'مُطَالَبَةٌ مَلِكٌ':Added, #1: 1	مُطَالَبَةُ مُكْرِهِهِ
u'مُطَالَبَةٌ مُؤَجِّرٌ':Added, #1: 1	مُطَالَبَةِ الْمَلِكِ
u'مُطَالَبَةٌ مُوَكِّلٌ':Added, #2: 2	مُطَالَبَةُ الْمُؤَجِّرِ
u'مُطَالَبَةٌ مُوَكِّلٌ':Added, #1: 1	مُطَالَبَةَ الْمُوَكِّلِ
u'مُطَالَبَةٌ مُوَكِّلٌ':Added, #1: 1	مُطَالَبَةِ الْمُوَكِّلِ
u'مُطَالَبَةٌ مِيرَاثٌ':Added, #2: 2	مُطَالَبَةُ الْمُوَكِّلِ
u'مُطَالَبَةٌ ناذِر':Added, #2: 2	مُطَالَبَةَ الْمِيرَاثِ
u'مُطَالَبَةٌ نَحْوٌ':Added, #1: 1	مُطَالَبَةُ النَّاذِرِ
u'مُطَالَبَةٌ واحد':Added, #1: 1	مُطَالَبَةِ نَحْوِ
u'مُطَالَبَةٌ وَاحِدٌ':Added, #1: 1	مُطَالَبَةِ وَاحِدٍ
u'مُطَالَبَةٌ واحد':Added, #1: 1	مُطَالَبَةِ وَاحِدٍ
u'مُطَالَبَةٌ وَاحِدٌ':Added, #2: 2	مُطَالَبَةُ وَاحِدٍ
u'مُطَالَبَةٌ وَارِثٌ':Added, #2: 2	مُطَالَبَةُ وَاحِدٍ
u'مُطَالَبَةٌ وَارِثٌ':Added, #1: 1	مُطَالَبَةُ وَارِثِ
u'مُطَالَبَةٌ واصِف':Added, #2: 2	مُطَالَبَةُ الْوَارِثِ
u'مُطَالَبَةٌ وَالِدٌ':Added, #1: 1	مُطَالَبَةُ الْوَاصِفِ
u'مُطَالَبَةٌ وَالِدٌ':Added, #1: 1	مُطَالَبَةِ الْوَالِدِ
u'مُطَالَبَةٌ وَاهِبٌ':Added, #2: 2	مُطَالَبَةَ وَالِدِهِ
u'مُطَالَبَةٌ وَكِيلٌ':Added, #1: 1	مُطَالَبَةُ الْوَاهِبِ
u'مُطَالَبَةٌ وَكِيلٌ':Added, #1: 1	مُطَالَبَةِ الْوَكِيلِ
u'مُطَالَبَةٌ وَلِيٌّ':Added, #2: 2	مُطَالَبَةُ الْوَكِيلِ
u'مُطَالَبَةٌ وَلِيٌّ':Added, #1: 1	مُطَالَبَةِ الْوَلِيِّ
u'مُطَالَبَةٌ وَلِيٌّ':Added, #1: 1	مُطَالَبَةُ وَلِيِّ
u'مُطَالَبٌ ثَمَنٌ':Added, #2: 2	مُطَالَبَةَ الْوَلِيِّ
u'مُطَالَبٌ جَارٌ':Added, #1: 1	مُطَالَبَةُ الثَّمَنِ
u'مُطَالَبٌ جهاز':Added, #1: 1	مُطَالَبَةُ جَارِهِ
u'مُطَالَبٌ جِهَازٌ':Added, #1: 1	مُطَالَبَةِ الْجِهَازِ
u'مُطَالَبٌ حاكِمٌ':Added, #1: 1	مُطَالَبَةِ الْجِهَازِ
u'مُطَالَبٌ حاكِمٌ':Added, #1: 1	مُطَالَبَةَ الْحَاكِمِ
u'مُطَالَبٌ حَدٌّ':Added, #1: 1	مُطَالَبَةِ الْحَاكِمِ
u'مُطَالَبٌ حَقٌّ':Added, #1: 1	مُطَالَبَةِ الْحَدِّ
u'مُطَالَبٌ خَصْمٌ':Added, #1: 1	مُطَالَبَةُ حَقٍّ
u'مُطَالَبٌ خَصْمٌ':Added, #1: 1	مُطَالَبَةُ خَصْمِهِ
u'مُطَالَبٌ خَلِيفَةٌ':Added, #1: 1	مُطَالَبَةِ خَصْمِهِ
u'مُطَالَبٌ دَيْنٌ':Added, #1: 1	مُطَالَبَةُ الْخَلِيفَةِ
u'مُطَالَبٌ دَيْنٌ':Added, #1: 1	مُطَالَبَةَ الدَّيْنِ
u'مُطَالَبٌ رَاهِنٌ':Added, #1: 1	مُطَالَبَةِ الدَّيْنِ
u'مُطَالَبٌ رَاهِنٌ':Added, #1: 1	مُطَالَبَةُ الرَّاهِنِ
u'مُطَالَبٌ رَبُّ':Added, #1: 1	مُطَالَبَةِ الرَّاهِنِ
u'مُطَالَبٌ رَبُّ':Added, #2: 2	مُطَالَبَةَ رَبِّ
u'مُطَالَبٌ رَجُلٌ':Added, #5: 5	مُطَالَبَةُ رَبِّ
u'مُطَالَبٌ رَسُولٌ':Added, #1: 1	مُطَالَبَةُ الرَّجُلِ
u'مُطَالَبٌ زَوْجٌ':Added, #1: 1	مُطَالَبَةُ الرَّسُولِ
u'مُطَالَبٌ زَوْجٌ':Added, #2: 2	مُطَالَبَةَ الزَّوْجِ
u'مُطَالَبٌ زَوْجٌ':Added, #2: 2	مُطَالَبَةِ الزَّوْجِ
u'مُطَالَبٌ زَوْجَةٌ':Added, #3: 3	مُطَالَبَةُ الزَّوْجِ
u'مُطَالَبٌ زِيادَةٌ':Added, #1: 1	مُطَالَبَةِ الزَّوْجَةِ
u'مُطَالَبٌ زَيْدٌ':Added, #1: 1	مُطَالَبَةِ الزِّيَادَةِ
u'مُطَالَبٌ زَيْدٌ':Added, #1: 1	مُطَالَبَةُ زَيْدٍ
u'مُطَالَبٌ سَيِّدٌ':Added, #1: 1	مُطَالَبَةِ زَيْدٍ
u'مُطَالَبٌ سَيِّدٌ':Added, #1: 1	مُطَالَبَةُ سَيِّدِهِ
u'مُطَالَبٌ سَيِّدٌ':Added, #2: 2	مُطَالَبَةُ السَّيِّدِ
u'مُطَالَبٌ شَرْعٌ':Added, #2: 2	مُطَالَبَةِ السَّيِّدِ
u'مُطَالَبٌ شَرِيكٌ':Added, #1: 1	مُطَالَبَةِ الشَّرْعِ
u'مُطَالَبٌ شفعة':Added, #3: 3	مُطَالَبَةُ شَرِيكِهِ
u'مُطَالَبٌ شُفْعَةٌ':Added, #1: 1	مُطَالَبَةُ الشُّفْعَةِ
u'مُطَالَبٌ صَغِيرٌ':Added, #1: 1	مُطَالَبَةُ الشُّفْعَةِ
u'مُطَالَبٌ ضَامِنٌ':Added, #1: 1	مُطَالَبَةُ الصَّغِيرِ
u'مُطَالَبٌ ضَامِنٌ':Added, #1: 1	مُطَالَبَة الضَّامِنِ
u'مُطَالَبٌ ضَامِنٌ':Added, #1: 1	مُطَالَبَةِ الضَّامِنِ
u'مُطَالَبٌ ضَامِنٌ':Added, #1: 1	مُطَالَبَةِ ضَامِنِ
u'مُطَالَبٌ طَالِبٌ':Added, #4: 4	مُطَالَبَةُ الضَّامِنِ
u'مُطَالَبٌ طَالِبٌ':Added, #1: 1	مُطَالَبَةَ الطَّالِبِ
u'مُطَالَبٌ طَالِبٌ':Added, #1: 1	مُطَالَبَةُ الطَّالِبِ
u'مُطَالَبٌ طَبْعٌ':Added, #1: 1	مُطَالَبَةِ الطَّالِبِ
u'مُطَالَبٌ عَاقِلٌ':Added, #1: 1	مُطَالَبَةِ الطَّبْعِ
u'مُطَالَبٌ عَاقِلٌ':Added, #1: 1	مُطَالَبَةُ الْعَاقِلَةِ
u'مُطَالَبٌ عَامِلٌ':Added, #1: 1	مُطَالَبَةَ عَاقِلَةِ
u'مُطَالَبٌ غَاصِبٌ':Added, #2: 2	مُطَالَبَةِ الْعَامِلِ
u'مُطَالَبٌ غَاصِبٌ':Added, #1: 1	مُطَالَبَةَ الْغَاصِبِ
u'مُطَالَبٌ غَاصِبٌ':Added, #1: 1	مُطَالَبَةُ الْغَاصِبِ
u'مُطَالَبٌ غرماء':Added, #1: 1	مُطَالَبَةُ غَاصِبٍ
u'مُطَالَبٌ فلان':Added, #2: 2	مُطَالَبَةِ الْغُرَمَاءِ
u'مُطَالَبٌ قَاتِلٌ':Added, #1: 1	مُطَالَبَةُ الْوَاصِفِ
u'مُطَالَبٌ قَاذِفٌ':Added, #2: 2	مُطَالَبَةُ قَاتِلِ
u'مُطَالَبٌ قَبَائِلُ':Added, #1: 1	مُطَالَبَةِ الْقَاذِفِ
u'مُطَالَبٌ قَرِيبٌ':Added, #1: 1	مُطَالَبَةِ الْقَبَائِلِ
u'مُطَالَبٌ كَفِيلٌ':Added, #1: 1	مُطَالَبَةِ الْقَرِيبِ
u'مُطَالَبٌ كَفِيلٌ':Added, #3: 3	مُطَالَبَةُ الْكَفِيلِ
u'مُطَالَبٌ مَالِكٌ':Added, #5: 5	مُطَالَبَةِ الْكَفِيلِ
u'مُطَالَبٌ مَالِكٌ':Added, #1: 1	مُطَالَبَةَ الْمَالِكِ
u'مُطَالَبٌ مَبِيعٌ':Added, #2: 2	مُطَالَبَةُ الْمَالِكِ
u'مُطَالَبٌ مُتْلِفٌ':Added, #2: 2	مُطَالَبَةَ الْمَبِيعِ
u'مُطَالَبٌ مثل':Added, #1: 1	مُطَالَبَةُ الْمُتْلِفِ
u'مُطَالَبٌ مِثْلٌ':Added, #2: 2	مُطَالَبَةَ مِثْلِهِ
u'مُطَالَبٌ مُحْتَالٌ':Added, #2: 2	مُطَالَبَةَ مِثْلِهِ
u'مُطَالَبٌ مُحِيل':Added, #1: 1	مُطَالَبَةَ الْمُحْتَالِ
u'مُطَالَبٌ مُحِيل':Added, #1: 1	مُطَالَبَةَ الْمُحِيلِ
u'مُطَالَبٌ مُحِيل':Added, #2: 2	مُطَالَبَةِ الْمُحِيلِ
u'مُطَالَبٌ مُخَالَفَةٌ':Added, #3: 3	مُطَالَبَةُ الْمُحِيلِ
u'مُطَالَبٌ مَدِينٌ':Added, #1: 1	مُطَالَبَةَ الْمُخَالَفَةِ
u'مُطَالَبٌ مَدِينٌ':Added, #1: 1	مُطَالَبَةُ الْمَدِينِ
u'مُطَالَبٌ مَدْيُونٌ':Added, #1: 1	مُطَالَبَةِ مَدِينِهِ
u'مُطَالَبٌ مَدْيُونٌ':Added, #1: 1	مُطَالَبَةِ الْمَدْيُونِ
u'مُطَالَبٌ مُرْتَهِنٌ':Added, #2: 2	مُطَالَبَةُ الْمَدْيُونِ
u'مُطَالَبٌ مُرْتَهِنٌ':Added, #1: 1	مُطَالَبَةُ الْمُرْتَهِنِ
u'مُطَالَبٌ مُرْسَلٌ':Added, #1: 1	مُطَالَبَةِ الْمُرْتَهِنِ
u'مُطَالَبٌ مُسْتَحِقٌّ':Added, #1: 1	مُطَالَبَةُ الْمُرْسَلِ
u'مُطَالَبٌ مُسْتَحِقٌّ':Added, #1: 1	مُطَالَبَةِ الْمُسْتَحِقِّ
u'مُطَالَبٌ مَسْرُوقٌ':Added, #2: 2	مُطَالَبَةُ الْمُسْتَحِقِّ
u'مُطَالَبٌ مُسْلِمٌ':Added, #1: 1	مُطَالَبَةُ الْمَسْرُوقِ
u'مُطَالَبٌ مَضْمُونٌ':Added, #1: 1	مُطَالَبَةَ مُسْلِمٍ
u'مُطَالَبٌ مُعْتَرِضٌ':Added, #1: 1	مُطَالَبَةُ الْمَضْمُونِ
u'مُطَالَبٌ مُفْلِسٌ':Added, #2: 2	مُطَالَبَةُ الْمُعْتَرِضِ
u'مُطَالَبٌ مَقْتُولٌ':Added, #1: 1	مُطَالَبَةُ الْمُفْلِسِ
u'مُطَالَبٌ مَقْذُوفٌ':Added, #2: 2	مُطَالَبَةُ الْمَقْتُولِ
u'مُطَالَبٌ مَقْذُوفٌ':Added, #1: 1	مُطَالَبَةِ الْمَقْذُوفِ
u'مُطَالَبٌ مَكّاس':Added, #2: 2	مُطَالَبَةُ الْمَقْذُوفِ
u'مُطَالَبٌ مُكْرَهٌ':Added, #1: 1	مُطَالَبَةَ الْمَكَّاسِ
u'مُطَالَبٌ مُكْرِهٌ':Added, #1: 1	مُطَالَبَةُ مُكْرَهِهِ
u'مُطَالَبٌ مَلِكٌ':Added, #1: 1	مُطَالَبَةُ مُكْرِهِهِ
u'مُطَالَبٌ مُؤَجِّرٌ':Added, #1: 1	مُطَالَبَةِ الْمَلِكِ
u'مُطَالَبٌ مُوَكِّلٌ':Added, #2: 2	مُطَالَبَةُ الْمُؤَجِّرِ
u'مُطَالَبٌ مُوَكِّلٌ':Added, #1: 1	مُطَالَبَةَ الْمُوَكِّلِ
u'مُطَالَبٌ مُوَكِّلٌ':Added, #1: 1	مُطَالَبَةِ الْمُوَكِّلِ
u'مُطَالَبٌ مِيرَاثٌ':Added, #2: 2	مُطَالَبَةُ الْمُوَكِّلِ
u'مُطَالَبٌ ناذِر':Added, #2: 2	مُطَالَبَةَ الْمِيرَاثِ
u'مُطَالَبٌ نَحْوٌ':Added, #1: 1	مُطَالَبَةُ النَّاذِرِ
u'مُطَالَبٌ واحد':Added, #1: 1	مُطَالَبَةِ نَحْوِ
u'مُطَالَبٌ وَاحِدٌ':Added, #1: 1	مُطَالَبَةِ وَاحِدٍ
u'مُطَالَبٌ واحد':Added, #1: 1	مُطَالَبَةِ وَاحِدٍ
u'مُطَالَبٌ وَاحِدٌ':Added, #2: 2	مُطَالَبَةُ وَاحِدٍ
u'مُطَالَبٌ وَارِثٌ':Added, #2: 2	مُطَالَبَةُ وَاحِدٍ
u'مُطَالَبٌ وَارِثٌ':Added, #1: 1	مُطَالَبَةُ وَارِثِ
u'مُطَالَبٌ واصِف':Added, #2: 2	مُطَالَبَةُ الْوَارِثِ
u'مُطَالَبٌ وَالِدٌ':Added, #1: 1	مُطَالَبَةُ الْوَاصِفِ
u'مُطَالَبٌ وَالِدٌ':Added, #1: 1	مُطَالَبَةِ الْوَالِدِ
u'مُطَالَبٌ وَاهِبٌ':Added, #2: 2	مُطَالَبَةَ وَالِدِهِ
u'مُطَالَبٌ وَكِيلٌ':Added, #1: 1	مُطَالَبَةُ الْوَاهِبِ
u'مُطَالَبٌ وَكِيلٌ':Added, #1: 1	مُطَالَبَةِ الْوَكِيلِ
u'مُطَالَبٌ وَلِيٌّ':Added, #2: 2	مُطَالَبَةُ الْوَكِيلِ
u'مُطَالَبٌ وَلِيٌّ':Added, #1: 1	مُطَالَبَةِ الْوَلِيِّ
u'مُطَالَبٌ وَلِيٌّ':Added, #1: 1	مُطَالَبَةُ وَلِيِّ
u'مُطَالَعَةٌ أَحْكَامٌ':Added, #2: 2	مُطَالَبَةَ الْوَلِيِّ
u'مُطَالَعَةٌ أَحْوالٌ':Added, #1: 1	مُطَالَعَةِ الْأَحْكَامِ
u'مُطَالَعَةٌ أحْوَالٌ':Added, #1: 1	مُطَالَعَةِ أَحْوَالِ
u'مُطَالَعَةٌ إمَامٌ':Added, #1: 1	مُطَالَعَةِ أَحْوَالِ
u'مُطَالَعَةٌ إمَامٌ':Added, #1: 1	مُطَالَعَةُ الْإِمَامِ
u'مُطَالَعَةٌ بَقِيَّةٌ':Added, #1: 1	مُطَالَعَةِ الْإِمَامِ
u'مُطَالَعَةٌ خَلِيفَةٌ':Added, #1: 1	مُطَالَعَةِ بَقِيَّتِهِ
u'مُطَالَعَةٌ عظام':Added, #1: 1	مُطَالَعَةُ الْخَلِيفَةِ
u'مُطَالَعَةٌ عِظَامٌ':Added, #2: 2	مُطَالَعَةِ الْعِظَامِ
u'مُطَالَعَةٌ عَقَائِدُ':Added, #2: 2	مُطَالَعَةِ الْعِظَامِ
u'مُطَالَعَةٌ فَجْرٌ':Added, #1: 1	مُطَالَعَةَ عَقَائِدِ
u'مُطَالَعَةٌ كِتَابٌ':Added, #1: 1	مُطَالَعَةُ الْفَجْرِ
u'مُطَالَعَةٌ كُتُبٌ':Added, #4: 4	مُطَالَعَةُ الْكِتَابِ
u'مُطَالَعَةٌ كُتُبٌ':Added, #1: 1	مُطَالَعَةِ الْكُتُبِ
u'مُطَالَعَةٌ نَاسٌ':Added, #1: 1	مُطَالَعَةِ كُتُبِ
u'مُطَالَعَةٌ ولد':Added, #1: 1	مُطَالَعَةِ النَّاسِ
u'مُطَالَعَةٌ وَلَدٌ':Added, #2: 2	مُطَالَعَةِ وَلَدِهِ
u'مَطَرٌ أَوَّلُ':Added, #2: 2	مُطَالَعَةِ وَلَدِهِ
u'مَطَرٌ جَبَلٌ':Added, #1: 1	مَطَرِ أَوَّلِ
u'مَطَرٌ رَبِيعٌ':Added, #1: 1	مَطَرِ الْجَبَلِ
u'مَطَرٌ رَبِيعٌ':Added, #1: 1	مَطَرَ الرَّبِيعِ
u'مَطَرٌ سَمَاءٌ':Added, #2: 2	مَطَرُ الرَّبِيعِ
u'مَطَرٌ سَمَاءٌ':Added, #1: 1	مَطَرَ السّمَاءِ
u'مَطَرٌ سَنَةٌ':Added, #1: 1	مَطَرِ السَّمَاءِ
u'مَطَرٌ عَادَةٌ':Added, #3: 3	مَطَرِ السَّنَةِ
u'مَطَرٌ مُسْتَدام':Added, #1: 1	مَطَرَ الْعَادَةِ
u'مَطَرٌ مُسْتَنْقَعٌ':Added, #1: 1	مَطَرٍ مُسْتَدَامٍ
u'مَطَرٌ مُعْتَادٌ':Added, #2: 2	مَطَرٍ مُسْتَنْقَعٍ
u'مَطَرٌ وَبْلٌ':Added, #2: 2	مَطَرٍ مُعْتَادٍ
u'مَطَلَ أَبٌ':Subject, #1: 1	مَطَرٍ وَبْلٍ
u'مَطَلَ دَيْنٌ':Predicate, #1: 1	مَطَلَ الْأَبُ
u'مَطْلَعٌ بَحْثٌ':Added, #1: 1	مَطَلَ الدَّيْنَ
u'مَطْلَعٌ بَلَدٌ':Added, #3: 3	مَطْلَعِ الْبَحْثِ
u'مَطْلَعٌ خِلاَفٌ':Added, #1: 1	مَطْلَعِ الْبَلَدِ
u'مَطْلَعٌ سُهَيْلٌ':Added, #1: 1	مَطْلَعُ الْخِلَافِ
u'مَطْلَعٌ شمس':Added, #1: 1	مَطْلَعِ سُهَيْلٍ
u'مَطْلَعٌ شَمْسٌ':Added, #4: 4	مَطْلَعِ الشَّمْسِ
u'مَطْلَعٌ فَجْرٌ':Added, #4: 4	مَطْلَعِ الشَّمْسِ
u'مَطْلَعٌ قُطْبٌ':Added, #10: 10	مَطْلَعِ الْفَجْرِ
u'مَطْلَعٌ كَلاَمٌ':Added, #1: 1	مَطْلَعُ الْقُطْبِ
u'مَطْلَعٌ هِلاَلٌ':Added, #1: 1	مَطْلَعِ الْكَلَامِ
u'مَطَلَ غَرِيمٌ':Subject, #1: 1	مَطْلَعِ الْهِلَالِ
u'مُعَادَاةٌ أَعْدَاءٌ':Added, #1: 1	مَطَلَ غَرِيمُهُ
u'مُعَادَاةٌ أهْلٌ':Added, #1: 1	مُعَادَاةَ الْأَعْدَاءِ
u'مُعَادَاةٌ أَوْلِيَاءُ':Added, #2: 2	مُعَادَاةِ أَهْلِ
u'مُعَادَاةٌ أَوْلِيَاءُ':Added, #1: 1	مُعَادَاةَ أَوْلِيَاءِ
u'مُعَادَاةٌ رِجَالٌ':Added, #1: 1	مُعَادَاةِ أَوْلِيَاءِ
u'مُعَادَاةٌ نَبِيٌّ':Added, #2: 2	مُعَادَاةِ الرِّجَالِ
u'مَعَاذٌ اللهُ':Added, #1: 1	مُعَادَاةِ النَّبِيِّ
u'مُعَارَضَةٌ أحَدٌ':Added, #2: 2	مَعَاذَ اللهِ
u'مُعَارَضَةٌ أصل':Added, #1: 1	مُعَارَضَةِ أَحَدٍ
u'مُعَارَضَةٌ أًصْلٌ':Added, #1: 1	مُعَارَضَةِ أَصْلِ
u'مُعَارَضَةٌ أصل':Added, #1: 1	مُعَارَضَةِ أَصْلِ
u'مُعَارَضَةٌ أًصْلٌ':Added, #1: 1	مُعَارَضَةُ الْأَصْلِ
u'مُعَارَضَةٌ أصل':Added, #1: 1	مُعَارَضَةُ الْأَصْلِ
u'مُعَارَضَةٌ أًصْلٌ':Added, #5: 5	مُعَارَضَةِ الْأَصْلِ
u'مُعَارَضَةٌ آيَةٌ':Added, #5: 5	مُعَارَضَةِ الْأَصْلِ
u'مُعَارَضَةٌ بَيِّنَةٌ':Added, #1: 1	مُعَارَضَةُ الْآيَةِ
u'مُعَارَضَةٌ بَيِّنَةٌ':Added, #1: 1	مُعَارَضَةُ الْبَيِّنَةِ
u'مُعَارَضَةٌ بَيِّنَةٌ':Added, #1: 1	مُعَارَضَةِ بَيِّنَةٍ
u'مُعَارَضَةٌ تَرْجِيحٌ':Added, #1: 1	مُعَارَضَةِ بَيِّنَةِ
u'مُعَارَضَةٌ ثَانِي':Added, #1: 1	مُعَارَضَةِ التَّرْجِيحِ
u'مُعَارَضَةٌ ثَانِيَةٌ':Added, #1: 1	مُعَارَضَةَ الثَّانِيَةِ
u'مُعَارَضَةٌ جِنٌّ':Added, #1: 1	مُعَارَضَةَ الثَّانِيَةِ
u'مُعَارَضَةٌ جَوَازٌ':Added, #1: 1	مُعَارَضَةِ الْجِنِّ
u'مُعَارَضَةٌ حَديثٌ':Added, #1: 1	مُعَارَضَةِ جَوَازِ
u'مُعَارَضَةٌ حَديثٌ':Added, #1: 1	مُعَارَضَةِ حَدِيثِ
u'مُعَارَضَةٌ خَبَرٌ':Added, #3: 3	مُعَارَضَةِ الْحَدِيثِ
u'مُعَارَضَةٌ خَبَرٌ':Added, #1: 1	مُعَارَضَةُ الْخَبَرِ
u'مُعَارَضَةٌ خَبَر':Added, #1: 1	مُعَارَضَةِ الْخَبَرِ
u'مُعَارَضَةٌ خَبَر':Added, #1: 1	مُعَارَضَةُ الْخَبَرِ
u'مُعَارَضَةٌ خَبَرٌ':Added, #1: 1	مُعَارَضَةِ الْخَبَرِ
u'مُعَارَضَةٌ خَبَرٌ':Added, #1: 1	مُعَارَضَةِ خَبَرٍ
u'مُعَارَضَةٌ خَبَر':Added, #1: 1	مُعَارَضَةِ خَبَرِ
u'مُعَارَضَةٌ خَبَر':Added, #1: 1	مُعَارَضَةِ خَبَرٍ
u'مُعَارَضَةٌ خلق':Added, #1: 1	مُعَارَضَةِ خَبَرِ
u'مُعَارَضَةٌ خَلْقٌ':Added, #1: 1	مُعَارَضَةِ الْخَلْقِ
u'مُعَارَضَةٌ دَلالَةٌ':Added, #1: 1	مُعَارَضَةِ الْخَلْقِ
u'مُعَارَضَةٌ دَليلٌ':Added, #1: 1	مُعَارَضَةُ الدَّلَالَةِ
u'مُعَارَضَةٌ دَليلٌ':Added, #1: 1	مُعَارَضَةِ الدَّلِيلِ
u'مُعَارَضَةٌ ذِمَّةٌ':Added, #3: 3	مُعَارَضَةِ دَلِيلِ
u'مُعَارَضَةٌ سائِل':Added, #1: 1	مُعَارَضَةُ الذِّمَّةِ
u'مُعَارَضَةٌ سَائِلٌ':Added, #1: 1	مُعَارَضَةِ السَّائِلِ
u'مُعَارَضَةٌ شَرْعٌ':Added, #1: 1	مُعَارَضَةِ السَّائِلِ
u'مُعَارَضَةٌ طُعْمٌ':Added, #1: 1	مُعَارَضَةِ الشَّرْعِ
u'مُعَارَضَةٌ طُعْمٌ':Added, #1: 1	مُعَارَضَةُ الطُّعْمِ
u'مُعَارَضَةٌ ظَواهِرُ':Added, #1: 1	مُعَارَضَةِ الطُّعْمِ
u'مُعَارَضَةٌ عِلَّةٌ':Added, #1: 1	مُعَارَضَةُ الظَّوَاهِرِ
u'مُعَارَضَةٌ عِلَّةٌ':Added, #1: 1	مُعَارَضَةِ عِلَّةِ
u'مُعَارَضَةٌ عِلَّةٌ':Added, #1: 1	مُعَارَضَةُ عِلَّتِهِ
u'مُعَارَضَةٌ عُمُومٌ':Added, #1: 1	مُعَارَضَةِ عِلَّتِهِ
u'مُعَارَضَةٌ فَاسِدٌ':Added, #1: 1	مُعَارَضَةِ الْعُمُومِ
u'مُعَارَضَةٌ قول':Added, #1: 1	مُعَارَضَةُ الْفَاسِدِ
u'مُعَارَضَةٌ قَوْلٌ':Added, #1: 1	مُعَارَضَةِ قَوْلِهِ
u'مُعَارَضَةٌ قول':Added, #1: 1	مُعَارَضَةِ قَوْلِهِ
u'مُعَارَضَةٌ قَوْلٌ':Added, #2: 2	مُعَارَضَةِ قَوْلِ
u'مُعَارَضَةٌ قِيَاسٌ':Added, #2: 2	مُعَارَضَةِ قَوْلِ
u'مُعَارَضَةٌ قِيَاسٌ':Added, #1: 1	مُعَارَضَةِ الْقِيَاسِ
u'مُعَارَضَةٌ قِيَاسٌ':Added, #1: 1	مُعَارَضَةِ الْقِيَاسَيْنِ
u'مُعَارَضَةٌ قِيَاسٌ':Added, #1: 1	مُعَارَضَةَ قِيَاسَيْنِ
u'مُعَارَضَةٌ كِتَابٌ':Added, #1: 1	مُعَارَضَةُ قِيَاسَيْنِ
u'مُعَارَضَةٌ كَلاَمٌ':Added, #2: 2	مُعَارَضَةِ الْكِتَابِ
u'مُعَارَضَةٌ كَوْنٌ':Added, #1: 1	مُعَارَضَةِ كَلَامِ
u'مُعَارَضَةٌ مَالٌ':Added, #1: 1	مُعَارَضَةِ كَوْنِ
u'مُعَارَضَةٌ مَانِعٌ':Added, #1: 1	مُعَارَضَةِ الْمَالِ
u'مُعَارَضَةٌ مَحْض':Added, #1: 1	مُعَارَضَةِ الْمَانِعِ
u'مُعَارَضَةٌ مَرِيضٌ':Added, #2: 2	مُعَارَضَةٍ مَحْضَةٍ
u'مُعَارَضَةٌ مُطْلِقٌ':Added, #1: 1	مُعَارَضَةُ الْمَرِيضِ
u'مُعَارَضَةٌ مُعَارَضَةٌ':Added, #1: 1	مُعَارَضَةِ مُطْلِقِهِ
u'مُعَارَضَةٌ مُعْتَرِضٌ':Added, #1: 1	مُعَارَضَةُ الْمُعَارَضَةِ
u'مُعَارَضَةٌ مَنْصُوصٌ':Added, #2: 2	مُعَارَضَةُ الْمُعْتَرِضِ
u'مُعَارَضَةٌ مَنْطُوقٌ':Added, #1: 1	مُعَارَضَةُ الْمَنْصُوصِ
u'مُعَارَضَةٌ نَصٌّ':Added, #1: 1	مُعَارَضَةِ الْمَنْطُوقِ
u'مُعَارَضَةٌ نَصٌّ':Added, #1: 1	مُعَارَضَةَ النَّصِّ
u'مُعَارَضَةٌ نَصٌّ':Added, #1: 1	مُعَارَضَةُ النَّصِّ
u'مُعَارَضَةٌ وَصْفٌ':Added, #1: 1	مُعَارَضَةِ نَصٍّ
u'مَعَاشٌ خلق':Added, #1: 1	مُعَارَضَةِ وَصْفٍ
u'مَعَاشٌ خَلْقٌ':Added, #1: 1	مَعَاشِ الْخَلْقِ
u'مُعَاشَرَةٌ أَبْنَاءٌ':Added, #1: 1	مَعَاشِ الْخَلْقِ
u'مُعَاشَرَةٌ أَزْواجٌ':Added, #1: 1	مُعَاشَرَةِ أَبْنَاءِ
u'مُعَاشَرَةٌ الْمَرْأَةُ':Added, #3: 3	مُعَاشَرَةَ الْأَزْوَاجِ
u'مُعَاشَرَةٌ إِنْسانٌ':Added, #1: 1	مُعَاشَرَةُ الْمَرْأَةِ
u'مُعَاشَرَةٌ أهْلٌ':Added, #1: 1	مُعَاشَرَةُ الْإِنْسَانِ
u'مُعَاشَرَةٌ خلق':Added, #1: 1	مُعَاشَرَةَ الْأَهْلِ
u'مُعَاشَرَةٌ خَلْقٌ':Added, #1: 1	مُعَاشَرَةِ الْخَلْقِ
u'مُعَاشَرَةٌ رَجْعِيٌّ':Added, #1: 1	مُعَاشَرَةِ الْخَلْقِ
u'مُعَاشَرَةٌ رَجْعِيَّةٌ':Added, #1: 1	مُعَاشَرَةَ الرَّجْعِيَّةِ
u'مُعَاشَرَةٌ زَوْجٌ':Added, #1: 1	مُعَاشَرَةَ الرَّجْعِيَّةِ
u'مُعَاشَرَةٌ نَاسٌ':Added, #1: 1	مُعَاشَرَةِ الزَّوْجِ
u'مُعَاشَرَةٌ نَاسٌ':Added, #1: 1	مُعَاشَرَةَ النَّاسِ
u'مُعَاشَرَةٌ ولد':Added, #4: 4	مُعَاشَرَةِ النَّاسِ
u'مُعَاشَرَةٌ وَلَدٌ':Added, #1: 1	مُعَاشَرَةُ الْوَلَدِ
u'مَعَاشٌ سَلَفٌ':Added, #1: 1	مُعَاشَرَةُ الْوَلَدِ
u'مَعَاشٌ صَبِيٌّ':Added, #1: 1	مَعَاشَ السَّلَفِ
u'مَعَاشٌ نَاسٌ':Added, #1: 1	مَعَاشِ الصَّبِيِّ
u'مُعَالَجٌ أَجْسَادٌ':Added, #1: 1	مَعَاشِ النَّاسِ
u'مُعَالَجٌ أدْوَاءٌ':Added, #1: 1	مُعَالَجَةُ الْأَجْسَادِ
u'مُعَالَجٌ أَمْرَاضٌ':Added, #1: 1	مُعَالَجَةُ الْأَدْوَاءِ
u'مُعَالَجٌ بُرودَةٌ':Added, #3: 3	مُعَالَجَةُ الْأَمْرَاضِ
u'مُعَالَجَةٌ أَجْسَادٌ':Added, #1: 1	مُعَالَجَةَ الْبُرُودَةِ
u'مُعَالَجَةٌ أدْوَاءٌ':Added, #1: 1	مُعَالَجَةُ الْأَجْسَادِ
u'مُعَالَجَةٌ أَمْرَاضٌ':Added, #1: 1	مُعَالَجَةُ الْأَدْوَاءِ
u'مُعَالَجَةٌ بُرودَةٌ':Added, #3: 3	مُعَالَجَةُ الْأَمْرَاضِ
u'مُعَالَجَةٌ تَوْبَةٌ':Added, #1: 1	مُعَالَجَةَ الْبُرُودَةِ
u'مُعَالَجَةٌ ذكر':Added, #1: 1	مُعَالَجَةِ التَّوْبَةِ
u'مُعَالَجَةٌ ذَكَرٌ':Added, #1: 1	مُعَالَجَةِ الذَّكَرِ
u'مُعَالَجَةٌ سُقُوطٌ':Added, #1: 1	مُعَالَجَةِ الذَّكَرِ
u'مُعَالَجَةٌ صَبِيٌّ':Added, #1: 1	مُعَالَجَةِ سُقُوطِ
u'مُعَالَجَةٌ صِبْيَانٌ':Added, #1: 1	مُعَالَجَةُ الصَّبِيِّ
u'مُعَالَجَةٌ عُذْرَةٌ':Added, #1: 1	مُعَالَجَةَ الصِّبْيَانِ
u'مُعَالَجَةٌ عَصِيرٌ':Added, #1: 1	مُعَالَجَةُ الْعُذْرَةِ
u'مُعَالَجَةٌ عَصِيرٌ':Added, #1: 1	مُعَالَجَةَ الْعَصِيرِ
u'مُعَالَجَةٌ عَلِيلٌ':Added, #1: 1	مُعَالَجَةُ الْعَصِيرِ
u'مُعَالَجَةٌ مُسْتَأْجِرٌ':Added, #1: 1	مُعَالَجَةِ الْعَلِيلِ
u'مُعَالَجَةٌ مَطْعُونٌ':Added, #1: 1	مُعَالَجَةِ الْمُسْتَأْجِرِ
u'مُعَالَجٌ تَوْبَةٌ':Added, #1: 1	مُعَالَجَةَ الْمَطْعُونِ
u'مُعَالَجٌ ذكر':Added, #1: 1	مُعَالَجَةِ التَّوْبَةِ
u'مُعَالَجٌ ذَكَرٌ':Added, #1: 1	مُعَالَجَةِ الذَّكَرِ
u'مُعَالَجٌ سُقُوطٌ':Added, #1: 1	مُعَالَجَةِ الذَّكَرِ
u'مُعَالَجٌ صَبِيٌّ':Added, #1: 1	مُعَالَجَةِ سُقُوطِ
u'مُعَالَجٌ صِبْيَانٌ':Added, #1: 1	مُعَالَجَةُ الصَّبِيِّ
u'مُعَالَجٌ عُذْرَةٌ':Added, #1: 1	مُعَالَجَةَ الصِّبْيَانِ
u'مُعَالَجٌ عَصِيرٌ':Added, #1: 1	مُعَالَجَةُ الْعُذْرَةِ
u'مُعَالَجٌ عَصِيرٌ':Added, #1: 1	مُعَالَجَةَ الْعَصِيرِ
u'مُعَالَجٌ عَلِيلٌ':Added, #1: 1	مُعَالَجَةُ الْعَصِيرِ
u'مُعَالَجٌ مُسْتَأْجِرٌ':Added, #1: 1	مُعَالَجَةِ الْعَلِيلِ
u'مُعَالَجٌ مَطْعُونٌ':Added, #1: 1	مُعَالَجَةِ الْمُسْتَأْجِرِ
u'مُعَامَلَةٌ أَحْبابٌ':Added, #1: 1	مُعَالَجَةَ الْمَطْعُونِ
u'مُعَامَلَةٌ أَسْماءٌ':Added, #1: 1	مُعَامَلَةِ الْأَحْبَابِ
u'مُعَامَلَةٌ أَشْجَارٌ':Added, #1: 1	مُعَامَلَةَ الْأَسْمَاءِ
u'مُعَامَلَةٌ إِعارَةٌ':Added, #1: 1	مُعَامَلَةِ الْأَشْجَارِ
u'مُعَامَلَةٌ أَعْلاَمٌ':Added, #1: 1	مُعَامَلَةَ الْإِعَارَةِ
u'مُعَامَلَةٌ إمَاءٌ':Added, #1: 1	مُعَامَلَةَ الْأَعْلَامِ
u'مُعَامَلَةٌ إِنْسانٌ':Added, #1: 1	مُعَامَلَةَ الْإِمَاءِ
u'مُعَامَلَةٌ أهْلٌ':Added, #1: 1	مُعَامَلَةُ الْإِنْسَانِ
u'مُعَامَلَةٌ أهْلٌ':Added, #2: 2	مُعَامَلَةَ أَهْلِ
u'مُعَامَلَةٌ تُجَّارٌ':Added, #2: 2	مُعَامَلَةِ أَهْلِ
u'مُعَامَلَةٌ تَعْلِيقٌ':Added, #1: 1	مُعَامَلَةَ التُّجَّارِ
u'مُعَامَلَةٌ جُنْدِيٌّ':Added, #1: 1	مُعَامَلَةَ التَّعْلِيقِ
u'مُعَامَلَةٌ حَرائِرُ':Added, #2: 2	مُعَامَلَةَ الْجُنْدِيِّ
u'مُعَامَلَةٌ حَرَائِرُ':Added, #1: 1	مُعَامَلَةَ الْحَرَائِرِ
u'مُعَامَلَةٌ حَقٌّ':Added, #1: 1	مُعَامَلَةَ الْحَرَائِرِ
u'مُعَامَلَةٌ خلق':Added, #1: 1	مُعَامَلَةِ الْحَقِّ
u'مُعَامَلَةٌ خَلْقٌ':Added, #1: 1	مُعَامَلَةِ الْخَلْقِ
u'مُعَامَلَةٌ ذِمِّيٌّ':Added, #1: 1	مُعَامَلَةِ الْخَلْقِ
u'مُعَامَلَةٌ رَبُّ':Added, #1: 1	مُعَامَلَةِ ذِمِّيٍّ
u'مُعَامَلَةٌ رَقيقٌ':Added, #1: 1	مُعَامَلَةَ الرَّبِّ
u'مُعَامَلَةٌ رَقيق':Added, #1: 1	مُعَامَلَةِ الرَّقِيقِ
u'مُعَامَلَةٌ زَوْجَةٌ':Added, #1: 1	مُعَامَلَةِ الرَّقِيقِ
u'مُعَامَلَةٌ سَنَةٌ':Added, #1: 1	مُعَامَلَةَ زَوْجَةِ
u'مُعَامَلَةٌ سَيِّدٌ':Added, #1: 1	مُعَامَلَةَ سَنَةٍ
u'مُعَامَلَةٌ سَيِّدٌ':Added, #1: 1	مُعَامَلَةِ سَيِّدِهِ
u'مُعَامَلَةٌ سَيِّدٌ':Added, #2: 2	مُعَامَلَةُ السَّيِّدِ
u'مُعَامَلَةٌ شَهِيدٌ':Added, #2: 2	مُعَامَلَةِ السَّيِّدِ
u'مُعَامَلَةٌ صغار':Added, #3: 3	مُعَامَلَةَ الشَّهِيدِ
u'مُعَامَلَةٌ صغار':Added, #1: 1	مُعَامَلَةَ الصِّغَارِ
u'مُعَامَلَةٌ صَغِيرٌ':Added, #1: 1	مُعَامَلَةُ الصِّغَارِ
u'مُعَامَلَةٌ عَبْدٌ':Added, #1: 1	مُعَامَلَةُ الصَّغِيرِ
u'مُعَامَلَةٌ عَبِيدٌ':Added, #1: 1	مُعَامَلَةُ عَبْدٍ
u'مُعَامَلَةٌ غرباء':Added, #5: 5	مُعَامَلَةِ الْعَبِيدِ
u'مُعَامَلَةٌ غَرِيبٌ':Added, #1: 1	مُعَامَلَةَ الْغُرَبَاءِ
u'مُعَامَلَةٌ غير':Added, #1: 1	مُعَامَلَةِ الْغَرِيبِ
u'مُعَامَلَةٌ غَيْرٌ':Added, #1: 1	مُعَامَلَةِ غَيْرِهِ
u'مُعَامَلَةٌ فَاسِدٌ':Added, #1: 1	مُعَامَلَةِ غَيْرِهِ
u'مُعَامَلَةٌ كَافِرٌ':Added, #1: 1	مُعَامَلَةٍ فَاسِدَةٍ
u'مُعَامَلَةٌ لَفْظٌ':Added, #1: 1	مُعَامَلَةَ الْكَافِرِ
u'مُعَامَلَةٌ مَالٌ':Added, #1: 1	مُعَامَلَةَ لَفْظِ
u'مُعَامَلَةٌ مُبَاحٌ':Added, #1: 1	مُعَامَلَةَ الْمَالِ
u'مُعَامَلَةٌ مُتَوَاطِئٌ':Added, #3: 3	مُعَامَلَةَ الْمُبَاحِ
u'مُعَامَلَةٌ مثل':Added, #1: 1	مُعَامَلَةِ الْمُتَوَاطِئِ
u'مُعَامَلَةٌ مِثْلٌ':Added, #1: 1	مُعَامَلَةِ مِثْلِهِ
u'مُعَامَلَةٌ مَخْلُوقٌ':Added, #1: 1	مُعَامَلَةِ مِثْلِهِ
u'مُعَامَلَةٌ مُرْتَدٌّ':Added, #1: 1	مُعَامَلَةَ الْمَخْلُوقِ
u'مُعَامَلَةٌ مُسْلِمٌ':Added, #1: 1	مُعَامَلَةُ الْمُرْتَدَّةِ
u'مُعَامَلَةٌ مُفْرَدٌ':Added, #1: 1	مُعَامَلَةِ الْمُسْلِمِ
u'مُعَامَلَةٌ مَوْجُودٌ':Added, #1: 1	مُعَامَلَةَ الْمُفْرَدِ
u'مُعَامَلَةٌ نَاسٌ':Added, #1: 1	مُعَامَلَةُ مَوْجُودٍ
u'مُعَامَلَةٌ نَاسٌ':Added, #1: 1	مُعَامَلَةُ النَّاسِ
u'مُعَامَلَةٌ نَبِيٌّ':Added, #2: 2	مُعَامَلَةِ النَّاسِ
u'مُعَامَلَةٌ نَخِيلٌ':Added, #1: 1	مُعَامَلَةِ النَّبِيِّ
u'مُعَامَلَةٌ نِساءٌ':Added, #1: 1	مُعَامَلَةِ النَّخِيلِ
u'مُعَامَلَةٌ نَفْيٌ':Added, #2: 2	مُعَامَلَةِ النِّسَاءِ
u'مُعَانَدَةٌ حَقٌّ':Added, #1: 1	مُعَامَلَةَ النَّفْيِ
u'مُعَانَدَةٌ سُلْطَانٌ':Added, #1: 1	مُعَانَدَةُ الْحَقِّ
u'مُعَاهَدَةٌ قُرْآنٌ':Added, #1: 1	مُعَانَدَةُ السُّلْطَانِ
u'مُعَاوَدَةٌ حِفْظٌ':Added, #1: 1	مُعَاهَدَةِ الْقُرْآنِ
u'مُعَاوَدَةٌ دَمٌ':Added, #1: 1	مُعَاوَدَةُ حِفْظِهِ
u'مُعَاوَدَةٌ دَمٌ':Added, #3: 3	مُعَاوَدَةَ الدَّمِ
u'مُعَاوَدَةٌ ذَنْبٌ':Added, #5: 5	مُعَاوَدَةِ الدَّمِ
u'مُعَاوَدَةٌ زَيْدٌ':Added, #1: 1	مُعَاوَدَةِ الذَّنْبِ
u'مُعَاوَدَةٌ غَزْوٌ':Added, #1: 1	مُعَاوَدَةُ زَيْدٍ
u'مُعَاوَدَةٌ كَرَّةٌ':Added, #1: 1	مُعَاوَدَةُ الْغَزْوِ
u'مُعَاوَدَةٌ مَاءٌ':Added, #1: 1	مُعَاوَدَةِ الْكَرّةِ
u'مُعَاوَدَةٌ مثل':Added, #1: 1	مُعَاوَدَةُ الْمَاءِ
u'مُعَاوَدَةٌ مِثْلٌ':Added, #1: 1	مُعَاوَدَةِ مِثْلِ
u'مُعَاوَدَةٌ مثل':Added, #1: 1	مُعَاوَدَةِ مِثْلِ
u'مُعَاوَدَةٌ مِثْلٌ':Added, #1: 1	مُعَاوَدَةِ مِثْلِهِ
u'مُعَاوَدَةٌ وَطْءٌ':Added, #1: 1	مُعَاوَدَةِ مِثْلِهِ
u'مُعَاوَدَةٌ وَطْءٌ':Added, #1: 1	مُعَاوَدَةَ الْوَطْءِ
u'مُعَاوَنَةٌ إمَامٌ':Added, #1: 1	مُعَاوَدَةِ الْوَطْءِ
u'مُعَاوَنَةٌ ظالِمٌ':Added, #1: 1	مُعَاوَنَةُ الْإِمَامِ
u'مُعَاوَنَةٌ عَامِلٌ':Added, #1: 1	مُعَاوَنَةِ الظَّالِمِ
u'مُعَاوَنَةٌ عَبِيدٌ':Added, #1: 1	مُعَاوَنَةَ الْعَامِلِ
u'مُعَاوَنَةٌ غير':Added, #2: 2	مُعَاوَنَةَ عَبِيدِ
u'مُعَاوَنَةٌ غَيْرٌ':Added, #1: 1	مُعَاوَنَةِ الْغَيْرِ
u'مُعَاوَنَةٌ وَكِيلٌ':Added, #1: 1	مُعَاوَنَةِ الْغَيْرِ
u'مُعَاوَنَةٌ وُلاَةٌ':Added, #1: 1	مُعَاوَنَةَ الْوَكِيلِ
u'مُعَايَنَةٌ آيَةٌ':Added, #1: 1	مُعَاوَنَةِ وُلَاةِ
u'مُعَايَنَةٌ بَيْعٌ':Added, #1: 1	مُعَايَنَةِ الْآيَةِ
u'مُعَايَنَةٌ بَيِّنَةٌ':Added, #1: 1	مُعَايَنَةِ الْبَيْعِ
u'مُعَايَنَةٌ بَيِّنَةٌ':Added, #1: 1	مُعَايَنَةُ الْبَيِّنَةِ
u'مُعَايَنَةٌ تَسْلِيمٌ':Added, #2: 2	مُعَايَنَةِ الْبَيِّنَةِ
u'مُعَايَنَةٌ جُرْحٌ':Added, #1: 1	مُعَايَنَةِ تَسْلِيمِ
u'مُعَايَنَةٌ جَسَدٌ':Added, #2: 2	مُعَايَنَةِ الْجُرْحِ
u'مُعَايَنَةٌ حُجَّةٌ':Added, #1: 1	مُعَايَنَةُ جَسَدِ
u'مُعَايَنَةٌ حَدٌّ':Added, #1: 1	مُعَايَنَةِ الْحُجَّةِ
u'مُعَايَنَةٌ حَوْزٌ':Added, #1: 1	مُعَايَنَةَ حَدٍّ
u'مُعَايَنَةٌ دُخُولٌ':Added, #2: 2	مُعَايَنَةُ الْحَوْزِ
u'مُعَايَنَةٌ رَهْنٌ':Added, #1: 1	مُعَايَنَةِ الدُّخُولِ
u'مُعَايَنَةٌ شرب':Added, #1: 1	مُعَايَنَةِ الرَّهْنِ
u'مُعَايَنَةٌ شُرْبٌ':Added, #1: 1	مُعَايَنَةُ الشُّرْبِ
u'مُعَايَنَةٌ عَذَابٌ':Added, #1: 1	مُعَايَنَةُ الشُّرْبِ
u'مُعَايَنَةٌ عَذَابٌ':Added, #1: 1	مُعَايَنَةِ الْعَذَابِ
u'مُعَايَنَةٌ فِعْلٌ':Added, #2: 2	مُعَايَنَةِ عَذَابِ
u'مُعَايَنَةٌ قَبْضٌ':Added, #1: 1	مُعَايَنَةُ فِعْلِ
u'مُعَايَنَةٌ قَبْضٌ':Added, #1: 1	مُعَايَنَةَ الْقَبْضِ
u'مُعَايَنَةٌ قِبْلَةٌ':Added, #7: 7	مُعَايَنَةِ الْقَبْضِ
u'مُعَايَنَةٌ قتل':Added, #1: 1	مُعَايَنَةِ الْقِبْلَةِ
u'مُعَايَنَةٌ قَتْلٌ':Added, #7: 7	مُعَايَنَةِ الْقَتْلِ
u'مُعَايَنَةٌ قَطْعٌ':Added, #7: 7	مُعَايَنَةِ الْقَتْلِ
u'مُعَايَنَةٌ مَشْهُودٌ':Added, #1: 1	مُعَايَنَةِ الْقَطْعِ
u'مُعَايَنَةٌ مَلاَئِكَةٌ':Added, #1: 1	مُعَايَنَةُ الْمَشْهُودِ
u'مُعَايَنَةٌ مَلَكٌ':Added, #1: 1	مُعَايَنَةُ الْمَلَائِكَةِ
u'مُعَايَنَةٌ نُزُولٌ':Added, #1: 1	مُعَايَنَةُ مَلَكِ
u'مُعَايَنَةٌ نكاح':Added, #1: 1	مُعَايَنَةِ نُزُولِ
u'مُعَايَنَةٌ نِكَاحٌ':Added, #1: 1	مُعَايَنَةِ النِّكَاحِ
u'مُعَايَنَةٌ وَعِيدٌ':Added, #1: 1	مُعَايَنَةِ النِّكَاحِ
u'مُعَايَنَةٌ يَدٌ':Added, #1: 1	مُعَايَنَةِ وَعِيدِهِ
u'مُعَايَنَةٌ يَدٌ':Added, #1: 1	مُعَايَنَةِ يَدٍ
u'مُعَايَنَةٌ يَدٌ':Added, #2: 2	مُعَايَنَةَ الْيَدِ
u'مَعْرِفَةٌ إبَاحَةٌ':Added, #2: 2	مُعَايَنَةِ الْيَدِ
u'مَعْرِفَة إبَاحَةٌ':Added, #1: 1	مَعْرِفَةِ إبَاحَةِ
u'مَعْرِفَةٌ أبْنيَةٌ':Added, #1: 1	مَعْرِفَةِ إبَاحَةِ
u'مَعْرِفَة أبْنيَةٌ':Added, #1: 1	مَعْرِفَةِ أَبْنِيَةِ
u'مَعْرِفَةٌ اِتِّحَادٌ':Added, #1: 1	مَعْرِفَةِ أَبْنِيَةِ
u'مَعْرِفَة اِتِّحَادٌ':Added, #1: 1	مَعْرِفَةِ اتِّحَادِ
u'مَعْرِفَةٌ إِثْمٌ':Added, #1: 1	مَعْرِفَةِ اتِّحَادِ
u'مَعْرِفَة إِثْمٌ':Added, #1: 1	مَعْرِفَةِ الْإِثْمِ
u'مَعْرِفَةٌ أَجْرٌ':Added, #1: 1	مَعْرِفَةِ الْإِثْمِ
u'مَعْرِفَة أَجْرٌ':Added, #1: 1	مَعْرِفَةِ أَجْرِ
u'مَعْرِفَةٌ أُجْرَةٌ':Added, #1: 1	مَعْرِفَةِ أَجْرِ
u'مَعْرِفَة أُجْرَةٌ':Added, #2: 2	مَعْرِفَةُ الْأُجْرَةِ
u'مَعْرِفَةٌ إِجْمَاعٌ':Added, #2: 2	مَعْرِفَةُ الْأُجْرَةِ
u'مَعْرِفَة إِجْمَاعٌ':Added, #2: 2	مَعْرِفَةِ الْإِجْمَاعِ
u'مَعْرِفَةٌ آحَادٌ':Added, #2: 2	مَعْرِفَةِ الْإِجْمَاعِ
u'مَعْرِفَة آحَادٌ':Added, #1: 1	مَعْرِفَةُ الْآحَادِ
u'مَعْرِفَةٌ أَحادِيثُ':Added, #1: 1	مَعْرِفَةُ الْآحَادِ
u'مَعْرِفَة أَحادِيثُ':Added, #1: 1	مَعْرِفَةُ أَحَادِيثِ
u'مَعْرِفَةٌ أَحادِيثُ':Added, #1: 1	مَعْرِفَةُ أَحَادِيثِ
u'مَعْرِفَة أَحادِيثُ':Added, #2: 2	مَعْرِفَةِ الْأَحَادِيثِ
u'مَعْرِفَةٌ أحَدٌ':Added, #2: 2	مَعْرِفَةِ الْأَحَادِيثِ
u'مَعْرِفَة أحَدٌ':Added, #1: 1	مَعْرِفَةُ أَحَدٍ
u'مَعْرِفَةٌ أَحْكَامٌ':Added, #1: 1	مَعْرِفَةُ أَحَدٍ
u'مَعْرِفَة أَحْكَامٌ':Added, #1: 1	مَعْرِفَةُ أَحْكَامِ
u'مَعْرِفَةٌ أَحْكَامٌ':Added, #1: 1	مَعْرِفَةُ أَحْكَامِ
u'مَعْرِفَةٌ أَحْكَامٌ':Added, #1: 1	مَعْرِفَةُ أَحْكَامِهِ
u'مَعْرِفَة أَحْكَامٌ':Added, #1: 1	مَعْرِفَةِ أَحْكَامِهِ
u'مَعْرِفَة أَحْكَامٌ':Added, #1: 1	مَعْرِفَةُ أَحْكَامِهِ
u'مَعْرِفَةٌ أَحْكَامٌ':Added, #1: 1	مَعْرِفَةِ أَحْكَامِهِ
u'مَعْرِفَة أَحْكَامٌ':Added, #2: 2	مَعْرِفَةَ أَحْكَامِ
u'مَعْرِفَةٌ أَحْكَامٌ':Added, #2: 2	مَعْرِفَةَ أَحْكَامِ
u'مَعْرِفَة أَحْكَامٌ':Added, #5: 5	مَعْرِفَةِ أَحْكَامِ
u'مَعْرِفَةٌ أَحْكَامٌ':Added, #5: 5	مَعْرِفَةِ أَحْكَامِ
u'مَعْرِفَة أَحْكَامٌ':Added, #5: 5	مَعْرِفَةُ الْأَحْكَامِ
u'مَعْرِفَةٌ أَحْكَامٌ':Added, #5: 5	مَعْرِفَةُ الْأَحْكَامِ
u'مَعْرِفَة أَحْكَامٌ':Added, #9: 9	مَعْرِفَةِ الْأَحْكَامِ
u'مَعْرِفَةٌ أخْبَارٌ':Added, #9: 9	مَعْرِفَةِ الْأَحْكَامِ
u'مَعْرِفَة أخْبَارٌ':Added, #2: 2	مَعْرِفَةِ الْأَخْبَارِ
u'مَعْرِفَةٌ أَخْبَارٌ':Added, #2: 2	مَعْرِفَةِ الْأَخْبَارِ
u'مَعْرِفَة أَخْبَارٌ':Added, #2: 2	مَعْرِفَةِ الْأَخْبَارِ
u'مَعْرِفَةٌ اِخْتِلاَفٌ':Added, #2: 2	مَعْرِفَةِ الْأَخْبَارِ
u'مَعْرِفَة اِخْتِلاَفٌ':Added, #1: 1	مَعْرِفَةُ اخْتِلَافِ
u'مَعْرِفَةٌ أَخَصُّ':Added, #1: 1	مَعْرِفَةُ اخْتِلَافِ
u'مَعْرِفَة أَخَصُّ':Added, #1: 1	مَعْرِفَةُ الْأَخَصِّ
u'مَعْرِفَةٌ آدابٌ':Added, #1: 1	مَعْرِفَةُ الْأَخَصِّ
u'مَعْرِفَة آدابٌ':Added, #4: 4	مَعْرِفَةِ آدَابِ
u'مَعْرِفَةٌ أَذَانٌ':Added, #4: 4	مَعْرِفَةِ آدَابِ
u'مَعْرِفَة أَذَانٌ':Added, #1: 1	مَعْرِفَةِ الْأَذَانِ
u'مَعْرِفَةٌ إِرَادَةٌ':Added, #1: 1	مَعْرِفَةِ الْأَذَانِ
u'مَعْرِفَة إِرَادَةٌ':Added, #1: 1	مَعْرِفَةِ إرَادَةِ
u'مَعْرِفَةٌ أرْبَابٌ':Added, #1: 1	مَعْرِفَةِ إرَادَةِ
u'مَعْرِفَة أرْبَابٌ':Added, #1: 1	مَعْرِفَةُ أَرْبَابِهِ
u'مَعْرِفَةٌ أَرْبَعَةٌ':Added, #1: 1	مَعْرِفَةُ أَرْبَابِهِ
u'مَعْرِفَة أَرْبَعَةٌ':Added, #1: 1	مَعْرِفَةِ أَرْبَعَةِ
u'مَعْرِفَةٌ أرْضٌ':Added, #1: 1	مَعْرِفَةِ أَرْبَعَةِ
u'مَعْرِفَة أرْضٌ':Added, #1: 1	مَعْرِفَةُ أَرْضِ
u'مَعْرِفَةٌ أرْضٌ':Added, #1: 1	مَعْرِفَةُ أَرْضِ
u'مَعْرِفَة أرْضٌ':Added, #1: 1	مَعْرِفَةَ الْأَرْضِ
u'مَعْرِفَةٌ أرْضٌ':Added, #1: 1	مَعْرِفَةَ الْأَرْضِ
u'مَعْرِفَة أرْضٌ':Added, #2: 2	مَعْرِفَةُ الْأَرْضِ
u'مَعْرِفَةٌ أسْبَابٌ':Added, #2: 2	مَعْرِفَةُ الْأَرْضِ
u'مَعْرِفَة أسْبَابٌ':Added, #1: 1	مَعْرِفَةُ أَسْبَابِ
u'مَعْرِفَةٌ أَسْبَابٌ':Added, #1: 1	مَعْرِفَةُ أَسْبَابِ
u'مَعْرِفَة أَسْبَابٌ':Added, #1: 1	مَعْرِفَةُ أَسْبَابِ
u'مَعْرِفَةٌ أسْبَابٌ':Added, #1: 1	مَعْرِفَةُ أَسْبَابِ
u'مَعْرِفَة أسْبَابٌ':Added, #1: 1	مَعْرِفَةِ الْأَسْبَابِ
u'مَعْرِفَةٌ أَسْبَابٌ':Added, #1: 1	مَعْرِفَةِ الْأَسْبَابِ
u'مَعْرِفَة أَسْبَابٌ':Added, #1: 1	مَعْرِفَةِ الْأَسْبَابِ
u'مَعْرِفَةٌ اِسْتِعْمالٌ':Added, #1: 1	مَعْرِفَةِ الْأَسْبَابِ
u'مَعْرِفَة اِسْتِعْمالٌ':Added, #1: 1	مَعْرِفَةِ اسْتِعْمَالِ
u'مَعْرِفَةٌ أسْرَارٌ':Added, #1: 1	مَعْرِفَةِ اسْتِعْمَالِ
u'مَعْرِفَة أسْرَارٌ':Added, #1: 1	مَعْرِفَةِ أَسْرَارِ
u'مَعْرِفَةٌ أَسْرَارٌ':Added, #1: 1	مَعْرِفَةِ أَسْرَارِ
u'مَعْرِفَة أَسْرَارٌ':Added, #1: 1	مَعْرِفَةِ أَسْرَارِ
u'مَعْرِفَةٌ اِسْمٌ':Added, #1: 1	مَعْرِفَةِ أَسْرَارِ
u'مَعْرِفَة اِسْمٌ':Added, #1: 1	مَعْرِفَةُ اسْمِهِ
u'مَعْرِفَةٌ أَسْماءٌ':Added, #1: 1	مَعْرِفَةُ اسْمِهِ
u'مَعْرِفَة أَسْماءٌ':Added, #1: 1	مَعْرِفَةِ أَسْمَاءٍ
u'مَعْرِفَةٌ أَسْماءٌ':Added, #1: 1	مَعْرِفَةِ أَسْمَاءٍ
u'مَعْرِفَة أَسْماءٌ':Added, #1: 1	مَعْرِفَةَ الْأَسْمَاءِ
u'مَعْرِفَةٌ أَشْيَاءٌ':Added, #1: 1	مَعْرِفَةَ الْأَسْمَاءِ
u'مَعْرِفَة أَشْيَاءٌ':Added, #2: 2	مَعْرِفَةِ الْأَشْيَاءِ
u'مَعْرِفَةٌ إصابَةٌ':Added, #2: 2	مَعْرِفَةِ الْأَشْيَاءِ
u'مَعْرِفَة إصابَةٌ':Added, #1: 1	مَعْرِفَةِ إصَابَتِهِ
u'مَعْرِفَةٌ اِصْطِلاحٌ':Added, #1: 1	مَعْرِفَةِ إصَابَتِهِ
u'مَعْرِفَة اِصْطِلاحٌ':Added, #1: 1	مَعْرِفَةِ اصْطِلَاحِ
u'مَعْرِفَةٌ أًصْلٌ':Added, #1: 1	مَعْرِفَةِ اصْطِلَاحِ
u'مَعْرِفَة أًصْلٌ':Added, #1: 1	مَعْرِفَةِ أَصْلٍ
u'مَعْرِفَةٌ أًصْلٌ':Added, #1: 1	مَعْرِفَةِ أَصْلٍ
u'مَعْرِفَة أًصْلٌ':Added, #1: 1	مَعْرِفَةِ أَصْلَيْنِ
u'مَعْرِفَةٌ أصل':Added, #1: 1	مَعْرِفَةِ أَصْلَيْنِ
u'مَعْرِفَة أصل':Added, #3: 3	مَعْرِفَةِ أَصْلِ
u'مَعْرِفَةٌ أًصْلٌ':Added, #3: 3	مَعْرِفَةِ أَصْلِ
u'مَعْرِفَة أًصْلٌ':Added, #3: 3	مَعْرِفَةِ أَصْلِ
u'مَعْرِفَةٌ أَصْلِيٌّ':Added, #3: 3	مَعْرِفَةِ أَصْلِ
u'مَعْرِفَة أَصْلِيٌّ':Added, #1: 1	مَعْرِفَةِ الْأَصْلِيِّ
u'مَعْرِفَةٌ أَصْلِيٌّ':Added, #1: 1	مَعْرِفَةِ الْأَصْلِيِّ
u'مَعْرِفَة أَصْلِيٌّ':Added, #1: 1	مَعْرِفَةِ الْأَصْلِيَّةِ
u'مَعْرِفَةٌ أُصولٌ':Added, #1: 1	مَعْرِفَةِ الْأَصْلِيَّةِ
u'مَعْرِفَةٌ أُصولٌ':Added, #2: 2	مَعْرِفَةَ أُصُولِ
u'مَعْرِفَة أُصولٌ':Added, #2: 2	مَعْرِفَةُ أُصُولِ
u'مَعْرِفَة أُصولٌ':Added, #2: 2	مَعْرِفَةَ أُصُولِ
u'مَعْرِفَةٌ أُصولٌ':Added, #2: 2	مَعْرِفَةُ أُصُولِ
u'مَعْرِفَة أُصولٌ':Added, #2: 2	مَعْرِفَةِ الْأُصُولِ
u'مَعْرِفَةٌ أُصولٌ':Added, #2: 2	مَعْرِفَةِ الْأُصُولِ
u'مَعْرِفَة أُصولٌ':Added, #8: 8	مَعْرِفَةِ أُصُولِ
u'مَعْرِفَةٌ أَطْهَارٌ':Added, #8: 8	مَعْرِفَةِ أُصُولِ
u'مَعْرِفَة أَطْهَارٌ':Added, #1: 1	مَعْرِفَةِ الْأَطْهَارِ
u'مَعْرِفَةٌ اِعْتِقادٌ':Added, #1: 1	مَعْرِفَةِ الْأَطْهَارِ
u'مَعْرِفَة اِعْتِقادٌ':Added, #1: 1	مَعْرِفَةُ اعْتِقَادٍ
u'مَعْرِفَةٌ أَعْذَارٌ':Added, #1: 1	مَعْرِفَةُ اعْتِقَادٍ
u'مَعْرِفَة أَعْذَارٌ':Added, #1: 1	مَعْرِفَةِ الْأَعْذَارِ
u'مَعْرِفَةٌ أَعْشَابٌ':Added, #1: 1	مَعْرِفَةِ الْأَعْذَارِ
u'مَعْرِفَة أَعْشَابٌ':Added, #1: 1	مَعْرِفَةِ الْأَعْشَابِ
u'مَعْرِفَةٌ أعْيانٌ':Added, #1: 1	مَعْرِفَةِ الْأَعْشَابِ
u'مَعْرِفَة أعْيانٌ':Added, #1: 1	مَعْرِفَةُ أَعْيَانِ
u'مَعْرِفَةٌ أَعْيَانٌ':Added, #1: 1	مَعْرِفَةُ أَعْيَانِ
u'مَعْرِفَة أَعْيَانٌ':Added, #1: 1	مَعْرِفَةُ أَعْيَانِ
u'مَعْرِفَةٌ إِفْرَادٌ':Added, #1: 1	مَعْرِفَةُ أَعْيَانِ
u'مَعْرِفَة إِفْرَادٌ':Added, #1: 1	مَعْرِفَةِ الْإِفْرَادِ
u'مَعْرِفَةٌ أقْرَبُ':Added, #1: 1	مَعْرِفَةِ الْإِفْرَادِ
u'مَعْرِفَة أقْرَبُ':Added, #1: 1	مَعْرِفَةِ الْأَقْرَبِ
u'مَعْرِفَةٌ أَقْسَامٌ':Added, #1: 1	مَعْرِفَةِ الْأَقْرَبِ
u'مَعْرِفَة أَقْسَامٌ':Added, #1: 1	مَعْرِفَةِ أَقْسَامِ
u'مَعْرِفَةٌ أقَلُّ':Added, #1: 1	مَعْرِفَةِ أَقْسَامِ
u'مَعْرِفَة أقَلُّ':Added, #1: 1	مَعْرِفَةِ أَقَلِّ
u'مَعْرِفَةٌ أَقْوَالٌ':Added, #1: 1	مَعْرِفَةِ أَقَلِّ
u'مَعْرِفَة أَقْوَالٌ':Added, #1: 1	مَعْرِفَةِ أَقْوَالِ
u'مَعْرِفَةٌ أَكْثَرُ':Added, #1: 1	مَعْرِفَةِ أَقْوَالِ
u'مَعْرِفَة أَكْثَرُ':Added, #1: 1	مَعْرِفَةَ أَكْثَرِ
u'مَعْرِفَةٌ أَكْثَرُ':Added, #1: 1	مَعْرِفَةَ أَكْثَرِ
u'مَعْرِفَة أَكْثَرُ':Added, #3: 3	مَعْرِفَةِ الْأَكْثَرِ
u'مَعْرِفَةٌ اللهُ':Added, #3: 3	مَعْرِفَةِ الْأَكْثَرِ
u'مَعْرِفَة اللهُ':Added, #1: 1	مَعْرِفَةُ اللهِ
u'مَعْرِفَةٌ إمَامٌ':Added, #1: 1	مَعْرِفَةُ اللهِ
u'مَعْرِفَةٌ إمَامٌ':Added, #1: 1	مَعْرِفَةَ الْإِمَامِ
u'مَعْرِفَة إمَامٌ':Added, #1: 1	مَعْرِفَةُ الْإِمَامِ
u'مَعْرِفَة إمَامٌ':Added, #1: 1	مَعْرِفَةَ الْإِمَامِ
u'مَعْرِفَةٌ أَمَدٌ':Added, #1: 1	مَعْرِفَةُ الْإِمَامِ
u'مَعْرِفَة أَمَدٌ':Added, #2: 2	مَعْرِفَةِ أَمَدِ
u'مَعْرِفَةٌ أَمْرٌ':Added, #2: 2	مَعْرِفَةِ أَمَدِ
u'مَعْرِفَة أَمْرٌ':Added, #1: 1	مَعْرِفَةِ الْأَمْرِ
u'مَعْرِفَةٌ أُمُورٌ':Added, #1: 1	مَعْرِفَةِ الْأَمْرِ
u'مَعْرِفَة أُمُورٌ':Added, #1: 1	مَعْرِفَةَ الْأُمُورِ
u'مَعْرِفَةٌ اِنْتِهاءٌ':Added, #1: 1	مَعْرِفَةَ الْأُمُورِ
u'مَعْرِفَة اِنْتِهاءٌ':Added, #3: 3	مَعْرِفَةِ انْتِهَاءِ
u'مَعْرِفَةٌ اِنْدِمالٌ':Added, #3: 3	مَعْرِفَةِ انْتِهَاءِ
u'مَعْرِفَة اِنْدِمالٌ':Added, #3: 3	مَعْرِفَةِ انْدِمَالِهِ
u'مَعْرِفَةٌ اِنْفِصالٌ':Added, #3: 3	مَعْرِفَةِ انْدِمَالِهِ
u'مَعْرِفَة اِنْفِصالٌ':Added, #1: 1	مَعْرِفَةِ انْفِصَالِهِ
u'مَعْرِفَةٌ أَنْقَاضٌ':Added, #1: 1	مَعْرِفَةِ انْفِصَالِهِ
u'مَعْرِفَة أَنْقَاضٌ':Added, #1: 1	مَعْرِفَةِ الْأَنْقَاضِ
u'مَعْرِفَةٌ اِنْقِسَامٌ':Added, #1: 1	مَعْرِفَةِ الْأَنْقَاضِ
u'مَعْرِفَة اِنْقِسَامٌ':Added, #1: 1	مَعْرِفَةِ انْقِسَامِهِ
u'مَعْرِفَةٌ أهْلٌ':Added, #1: 1	مَعْرِفَةِ انْقِسَامِهِ
u'مَعْرِفَة أهْلٌ':Added, #3: 3	مَعْرِفَةِ أَهْلِ
u'مَعْرِفَةٌ أَهْلِيٌّ':Added, #3: 3	مَعْرِفَةِ أَهْلِ
u'مَعْرِفَة أَهْلِيٌّ':Added, #2: 2	مَعْرِفَةُ أَهْلِيَّتِهِ
u'مَعْرِفَةٌ أهْلِيَّةٌ':Added, #2: 2	مَعْرِفَةُ أَهْلِيَّتِهِ
u'مَعْرِفَة أهْلِيَّةٌ':Added, #2: 2	مَعْرِفَةُ أَهْلِيَّتِهِ
u'مَعْرِفَةٌ أَوْصَافٌ':Added, #2: 2	مَعْرِفَةُ أَهْلِيَّتِهِ
u'مَعْرِفَة أَوْصَافٌ':Added, #1: 1	مَعْرِفَةُ أَوْصَافِ
u'مَعْرِفَةٌ أَوْضَاعٌ':Added, #1: 1	مَعْرِفَةُ أَوْصَافِ
u'مَعْرِفَة أَوْضَاعٌ':Added, #1: 1	مَعْرِفَةِ الْأَوْضَاعِ
u'مَعْرِفَةٌ أَوْقَاتٌ':Added, #1: 1	مَعْرِفَةِ الْأَوْضَاعِ
u'مَعْرِفَةٌ أَوْقَاتٌ':Added, #1: 1	مَعْرِفَةَ الْأَوْقَاتِ
u'مَعْرِفَةٌ أَوْقَاتٌ':Added, #1: 1	مَعْرِفَةُ الْأَوْقَاتِ
u'مَعْرِفَة أَوْقَاتٌ':Added, #1: 1	مَعْرِفَةِ الْأَوْقَاتِ
u'مَعْرِفَة أَوْقَاتٌ':Added, #1: 1	مَعْرِفَةَ الْأَوْقَاتِ
u'مَعْرِفَة أَوْقَاتٌ':Added, #1: 1	مَعْرِفَةُ الْأَوْقَاتِ
u'مَعْرِفَةٌ أَوْقَاتٌ':Added, #1: 1	مَعْرِفَةِ الْأَوْقَاتِ
u'مَعْرِفَة أَوْقَاتٌ':Added, #1: 1	مَعْرِفَةِ أَوْقَاتِ
u'مَعْرِفَةٌ أَوَّلُ':Added, #1: 1	مَعْرِفَةِ أَوْقَاتِ
u'مَعْرِفَةٌ أَوَّلُ':Added, #1: 1	مَعْرِفَةَ الْأَوَّلِ
u'مَعْرِفَةٌ أَوَّلُ':Added, #1: 1	مَعْرِفَةُ الْأَوَّلِ
u'مَعْرِفَة أَوَّلُ':Added, #1: 1	مَعْرِفَةِ الْأَوَّلِ
u'مَعْرِفَة أَوَّلُ':Added, #1: 1	مَعْرِفَةَ الْأَوَّلِ
u'مَعْرِفَة أَوَّلُ':Added, #1: 1	مَعْرِفَةُ الْأَوَّلِ
u'مَعْرِفَةٌ أَوَّلُ':Added, #1: 1	مَعْرِفَةِ الْأَوَّلِ
u'مَعْرِفَة أَوَّلُ':Added, #2: 2	مَعْرِفَةِ أَوَّلِ
u'مَعْرِفَةٌ أَوْلِيَاءُ':Added, #2: 2	مَعْرِفَةِ أَوَّلِ
u'مَعْرِفَة أَوْلِيَاءُ':Added, #1: 1	مَعْرِفَةِ الْأَوْلِيَاءِ
u'مَعْرِفَةٌ إِيجَابٌ':Added, #1: 1	مَعْرِفَةِ الْأَوْلِيَاءِ
u'مَعْرِفَة إِيجَابٌ':Added, #1: 1	مَعْرِفَةِ الْإِيجَابِ
u'مَعْرِفَةٌ بَاطن':Added, #1: 1	مَعْرِفَةِ الْإِيجَابِ
u'مَعْرِفَةٌ باطِنٌ':Added, #1: 1	مَعْرِفَةَ الْبَاطِنِ
u'مَعْرِفَة بَاطن':Added, #1: 1	مَعْرِفَةَ الْبَاطِنِ
u'مَعْرِفَة باطِنٌ':Added, #1: 1	مَعْرِفَةَ الْبَاطِنِ
u'مَعْرِفَةٌ بَاطن':Added, #1: 1	مَعْرِفَةَ الْبَاطِنِ
u'مَعْرِفَةٌ بَاطن':Added, #1: 1	مَعْرِفَةَ بَاطِنِ
u'مَعْرِفَةٌ باطِنٌ':Added, #1: 1	مَعْرِفَةُ بَاطِنِ
u'مَعْرِفَةٌ باطِنٌ':Added, #1: 1	مَعْرِفَةَ بَاطِنِ
u'مَعْرِفَة بَاطن':Added, #1: 1	مَعْرِفَةُ بَاطِنِ
u'مَعْرِفَة بَاطن':Added, #1: 1	مَعْرِفَةَ بَاطِنِ
u'مَعْرِفَة باطِنٌ':Added, #1: 1	مَعْرِفَةُ بَاطِنِ
u'مَعْرِفَة باطِنٌ':Added, #1: 1	مَعْرِفَةَ بَاطِنِ
u'مَعْرِفَةٌ بَاعِثٌ':Added, #1: 1	مَعْرِفَةُ بَاطِنِ
u'مَعْرِفَةٌ بَاعِثٌ':Added, #1: 1	مَعْرِفَةُ الْبَاعِثِ
u'مَعْرِفَة بَاعِثٌ':Added, #1: 1	مَعْرِفَةِ الْبَاعِثِ
u'مَعْرِفَة بَاعِثٌ':Added, #1: 1	مَعْرِفَةُ الْبَاعِثِ
u'مَعْرِفَةٌ بِدَعٌ':Added, #1: 1	مَعْرِفَةِ الْبَاعِثِ
u'مَعْرِفَة بِدَعٌ':Added, #1: 1	مَعْرِفَةِ الْبِدَعِ
u'مَعْرِفَةٌ بَراءةٌ':Added, #1: 1	مَعْرِفَةِ الْبِدَعِ
u'مَعْرِفَة بَراءةٌ':Added, #1: 1	مَعْرِفَةِ الْبَرَاءَةِ
u'مَعْرِفَةٌ بَراءةٌ':Added, #1: 1	مَعْرِفَةِ الْبَرَاءَةِ
u'مَعْرِفَة بَراءةٌ':Added, #1: 1	مَعْرِفَةُ بَرَاءَةِ
u'مَعْرِفَةٌ بَعْضٌ':Added, #1: 1	مَعْرِفَةُ بَرَاءَةِ
u'مَعْرِفَة بَعْضٌ':Added, #2: 2	مَعْرِفَةِ بَعْضِ
u'مَعْرِفَةٌ بُلُوغٌ':Added, #2: 2	مَعْرِفَةِ بَعْضِ
u'مَعْرِفَة بُلُوغٌ':Added, #3: 3	مَعْرِفَةِ الْبُلُوغِ
u'مَعْرِفَةٌ بِنَاءٌ':Added, #3: 3	مَعْرِفَةِ الْبُلُوغِ
u'مَعْرِفَة بِنَاءٌ':Added, #1: 1	مَعْرِفَةُ الْبِنَاءِ
u'مَعْرِفَةٌ بُيُوتٌ':Added, #1: 1	مَعْرِفَةُ الْبِنَاءِ
u'مَعْرِفَة بُيُوتٌ':Added, #1: 1	مَعْرِفَةُ بُيُوتِهِ
u'مَعْرِفَةٌ تَارِيخٌ':Added, #1: 1	مَعْرِفَةُ بُيُوتِهِ
u'مَعْرِفَة تَارِيخٌ':Added, #1: 1	مَعْرِفَةُ التَّارِيخِ
u'مَعْرِفَةٌ تَارِيخٌ':Added, #1: 1	مَعْرِفَةُ التَّارِيخِ
u'مَعْرِفَة تَارِيخٌ':Added, #7: 7	مَعْرِفَةِ التَّارِيخِ
u'مَعْرِفَةٌ تجَانُسٌ':Added, #7: 7	مَعْرِفَةِ التَّارِيخِ
u'مَعْرِفَة تجَانُسٌ':Added, #1: 1	مَعْرِفَةِ التَّجَانُسِ
u'مَعْرِفَةٌ تَصْحِيحٌ':Added, #1: 1	مَعْرِفَةِ التَّجَانُسِ
u'مَعْرِفَة تَصْحِيحٌ':Added, #1: 1	مَعْرِفَةِ التَّصْحِيحِ
u'مَعْرِفَةٌ تَصرِيفٌ':Added, #1: 1	مَعْرِفَةِ التَّصْحِيحِ
u'مَعْرِفَة تَصرِيفٌ':Added, #1: 1	مَعْرِفَةِ التَّصْرِيفِ
u'مَعْرِفَةٌ تَطَاوُلٌ':Added, #1: 1	مَعْرِفَةِ التَّصْرِيفِ
u'مَعْرِفَة تَطَاوُلٌ':Added, #1: 1	مَعْرِفَةِ تَطَاوُلِ
u'مَعْرِفَةٌ تَعَلُّقٌ':Added, #1: 1	مَعْرِفَةِ تَطَاوُلِ
u'مَعْرِفَة تَعَلُّقٌ':Added, #1: 1	مَعْرِفَةِ تَعَلُّقِ
u'مَعْرِفَةٌ تَغْلِيظٌ':Added, #1: 1	مَعْرِفَةِ تَعَلُّقِ
u'مَعْرِفَة تَغْلِيظٌ':Added, #1: 1	مَعْرِفَةِ التَّغْلِيظِ
u'مَعْرِفَةٌ تَفَاصِيلُ':Added, #1: 1	مَعْرِفَةِ التَّغْلِيظِ
u'مَعْرِفَة تَفَاصِيلُ':Added, #1: 1	مَعْرِفَةُ تَفَاصِيلِ
u'مَعْرِفَةٌ تَفَاضُلٌ':Added, #1: 1	مَعْرِفَةُ تَفَاصِيلِ
u'مَعْرِفَة تَفَاضُلٌ':Added, #1: 1	مَعْرِفَةِ التَّفَاضُلِ
u'مَعْرِفَةٌ تَفْسِيرٌ':Added, #1: 1	مَعْرِفَةِ التَّفَاضُلِ
u'مَعْرِفَة تَفْسِيرٌ':Added, #1: 1	مَعْرِفَةُ تَفْسِيرِ
u'مَعْرِفَةٌ تَفْسِيرٌ':Added, #1: 1	مَعْرِفَةُ تَفْسِيرِ
u'مَعْرِفَة تَفْسِيرٌ':Added, #1: 1	مَعْرِفَةِ تَفْسِيرِهِ
u'مَعْرِفَةٌ تَفْسِيرٌ':Added, #1: 1	مَعْرِفَةِ تَفْسِيرِهِ
u'مَعْرِفَة تَفْسِيرٌ':Added, #3: 3	مَعْرِفَةِ تَفْسِيرِ
u'مَعْرِفَةٌ تَفْوِيضٌ':Added, #3: 3	مَعْرِفَةِ تَفْسِيرِ
u'مَعْرِفَة تَفْوِيضٌ':Added, #1: 1	مَعْرِفَةِ التَّفْوِيضِ
u'مَعْرِفَةٌ تَقْسيطٌ':Added, #1: 1	مَعْرِفَةِ التَّفْوِيضِ
u'مَعْرِفَة تَقْسيطٌ':Added, #1: 1	مَعْرِفَةَ التَّقْسِيطِ
u'مَعْرِفَةٌ تَماثُلٌ':Added, #1: 1	مَعْرِفَةَ التَّقْسِيطِ
u'مَعْرِفَةٌ تَماثُلٌ':Added, #1: 1	مَعْرِفَةَ التَّمَاثُلِ
u'مَعْرِفَة تَماثُلٌ':Added, #1: 1	مَعْرِفَةِ التَّمَاثُلِ
u'مَعْرِفَة تَماثُلٌ':Added, #1: 1	مَعْرِفَةَ التَّمَاثُلِ
u'مَعْرِفَةٌ تَمْييزٌ':Added, #1: 1	مَعْرِفَةِ التَّمَاثُلِ
u'مَعْرِفَة تَمْييزٌ':Added, #1: 1	مَعْرِفَةَ التَّمْيِيزِ
u'مَعْرِفَةٌ تَوابِعُ':Added, #1: 1	مَعْرِفَةَ التَّمْيِيزِ
u'مَعْرِفَة تَوابِعُ':Added, #1: 1	مَعْرِفَةُ تَوَابِعِ
u'مَعْرِفَةٌ تَوَابِعُ':Added, #1: 1	مَعْرِفَةُ تَوَابِعِ
u'مَعْرِفَة تَوَابِعُ':Added, #1: 1	مَعْرِفَةُ تَوَابِعِ
u'مَعْرِفَةٌ تَوَافُقٌ':Added, #1: 1	مَعْرِفَةُ تَوَابِعِ
u'مَعْرِفَة تَوَافُقٌ':Added, #1: 1	مَعْرِفَةِ التَّوَافُقِ
u'مَعْرِفَةٌ ثُبُوتٌ':Added, #1: 1	مَعْرِفَةِ التَّوَافُقِ
u'مَعْرِفَة ثُبُوتٌ':Added, #1: 1	مَعْرِفَةِ ثُبُوتِهِ
u'مَعْرِفَةٌ ثِقَةٌ':Added, #1: 1	مَعْرِفَةِ ثُبُوتِهِ
u'مَعْرِفَة ثِقَةٌ':Added, #1: 1	مَعْرِفَةِ ثِقَتِهِ
u'مَعْرِفَةٌ ثَمَنٌ':Added, #1: 1	مَعْرِفَةِ ثِقَتِهِ
u'مَعْرِفَة ثَمَنٌ':Added, #1: 1	مَعْرِفَةَ الثَّمَنِ
u'مَعْرِفَةٌ ثَمَنٌ':Added, #1: 1	مَعْرِفَةَ الثَّمَنِ
u'مَعْرِفَة ثَمَنٌ':Added, #2: 2	مَعْرِفَةِ الثَّمَنِ
u'مَعْرِفَةٌ ثَمَنٌ':Added, #2: 2	مَعْرِفَةِ الثَّمَنِ
u'مَعْرِفَة ثَمَنٌ':Added, #4: 4	مَعْرِفَةُ الثَّمَنِ
u'مَعْرِفَةٌ جَرْيٌ':Added, #4: 4	مَعْرِفَةُ الثَّمَنِ
u'مَعْرِفَة جَرْيٌ':Added, #1: 1	مَعْرِفَةُ الْجَرْيِ
u'مَعْرِفَةٌ جُزْءٌ':Added, #1: 1	مَعْرِفَةُ الْجَرْيِ
u'مَعْرِفَة جُزْءٌ':Added, #1: 1	مَعْرِفَةِ جُزْءِ
u'مَعْرِفَةٌ جَمْعٌ':Added, #1: 1	مَعْرِفَةِ جُزْءِ
u'مَعْرِفَة جَمْعٌ':Added, #1: 1	مَعْرِفَةٍ جَمْعٍ
u'مَعْرِفَةٌ جُمَلٌ':Added, #1: 1	مَعْرِفَةٍ جَمْعٍ
u'مَعْرِفَة جُمَلٌ':Added, #1: 1	مَعْرِفَةُ جُمَلِهِ
u'مَعْرِفَةٌ جَمِيع':Added, #1: 1	مَعْرِفَةُ جُمَلِهِ
u'مَعْرِفَة جَمِيع':Added, #1: 1	مَعْرِفَةُ الْجَمِيعِ
u'مَعْرِفَةٌ جَمِيع':Added, #1: 1	مَعْرِفَةُ الْجَمِيعِ
u'مَعْرِفَة جَمِيع':Added, #3: 3	مَعْرِفَةِ الْجَمِيعِ
u'مَعْرِفَةٌ جِنْسٌ':Added, #3: 3	مَعْرِفَةِ الْجَمِيعِ
u'مَعْرِفَة جِنْسٌ':Added, #1: 1	مَعْرِفَةِ الْجِنْسِ
u'مَعْرِفَةٌ جِنْسٌ':Added, #1: 1	مَعْرِفَةِ الْجِنْسِ
u'مَعْرِفَة جِنْسٌ':Added, #2: 2	مَعْرِفَةُ جِنْسِ
u'مَعْرِفَةٌ جِنْسِيٌّ':Added, #2: 2	مَعْرِفَةُ جِنْسِ
u'مَعْرِفَة جِنْسِيٌّ':Added, #2: 2	مَعْرِفَةِ الْجِنْسِيَّةِ
u'مَعْرِفَةٌ جِهَةٌ':Added, #2: 2	مَعْرِفَةِ الْجِنْسِيَّةِ
u'مَعْرِفَةٌ جِهَةٌ':Added, #1: 1	مَعْرِفَةَ جِهَةِ
u'مَعْرِفَة جِهَةٌ':Added, #1: 1	مَعْرِفَةِ جِهَةِ
u'مَعْرِفَة جِهَةٌ':Added, #1: 1	مَعْرِفَةَ جِهَةِ
u'مَعْرِفَةٌ جِهَةٌ':Added, #1: 1	مَعْرِفَةِ جِهَةِ
u'مَعْرِفَة جِهَةٌ':Added, #2: 2	مَعْرِفَةِ الْجِهَةِ
u'مَعْرِفَةٌ جَيِّدٌ':Added, #2: 2	مَعْرِفَةِ الْجِهَةِ
u'مَعْرِفَة جَيِّدٌ':Added, #1: 1	مَعْرِفَةُ الْجَيِّدِ
u'مَعْرِفَةٌ حاضِنٌ':Added, #1: 1	مَعْرِفَةُ الْجَيِّدِ
u'مَعْرِفَة حاضِنٌ':Added, #1: 1	مَعْرِفَةِ الْحَاضِنِ
u'مَعْرِفَةٌ حاكِمٌ':Added, #1: 1	مَعْرِفَةِ الْحَاضِنِ
u'مَعْرِفَةٌ حاكِمٌ':Added, #1: 1	مَعْرِفَةَ الْحَاكِمِ
u'مَعْرِفَة حاكِمٌ':Added, #1: 1	مَعْرِفَةُ الْحَاكِمِ
u'مَعْرِفَة حاكِمٌ':Added, #1: 1	مَعْرِفَةَ الْحَاكِمِ
u'مَعْرِفَةٌ حالٌ':Added, #1: 1	مَعْرِفَةُ الْحَاكِمِ
u'مَعْرِفَة حالٌ':Added, #1: 1	مَعْرِفَةُ الْحَالِ
u'مَعْرِفَةٌ حالٌ':Added, #1: 1	مَعْرِفَةُ الْحَالِ
u'مَعْرِفَة حالٌ':Added, #2: 2	مَعْرِفَةُ حَالِ
u'مَعْرِفَةٌ حالٌ':Added, #2: 2	مَعْرِفَةُ حَالِ
u'مَعْرِفَة حالٌ':Added, #3: 3	مَعْرِفَةِ حَالِ
u'مَعْرِفَةٌ حالٌ':Added, #3: 3	مَعْرِفَةِ حَالِ
u'مَعْرِفَة حالٌ':Added, #3: 3	مَعْرِفَةِ حَالِهِ
u'مَعْرِفَةٌ حامِلٌ':Added, #3: 3	مَعْرِفَةِ حَالِهِ
u'مَعْرِفَة حامِلٌ':Added, #1: 1	مَعْرِفَةُ حَامِلِهِ
u'مَعْرِفَةٌ حَدٌّ':Added, #1: 1	مَعْرِفَةُ حَامِلِهِ
u'مَعْرِفَة حَدٌّ':Added, #1: 1	مَعْرِفَةِ الْحَدِّ
u'مَعْرِفَةٌ حَدٌّ':Added, #1: 1	مَعْرِفَةِ الْحَدِّ
u'مَعْرِفَة حَدٌّ':Added, #1: 1	مَعْرِفَةِ حَدِّ
u'مَعْرِفَةٌ حُدوثٌ':Added, #1: 1	مَعْرِفَةِ حَدِّ
u'مَعْرِفَة حُدوثٌ':Added, #1: 1	مَعْرِفَةِ حُدُوثِ
u'مَعْرِفَةٌ حُدوثٌ':Added, #1: 1	مَعْرِفَةِ حُدُوثِ
u'مَعْرِفَة حُدوثٌ':Added, #1: 1	مَعْرِفَةُ حُدُوثِهِ
u'مَعْرِفَةٌ حُدودٌ':Added, #1: 1	مَعْرِفَةُ حُدُوثِهِ
u'مَعْرِفَة حُدودٌ':Added, #1: 1	مَعْرِفَةِ الْحُدُودِ
u'مَعْرِفَةٌ حُدودٌ':Added, #1: 1	مَعْرِفَةِ الْحُدُودِ
u'مَعْرِفَة حُدودٌ':Added, #1: 1	مَعْرِفَةِ حُدُودِهِ
u'مَعْرِفَةٌ حَديثٌ':Added, #1: 1	مَعْرِفَةِ حُدُودِهِ
u'مَعْرِفَة حَديثٌ':Added, #1: 1	مَعْرِفَةَ حَدِيثِ
u'مَعْرِفَةٌ حَديثٌ':Added, #1: 1	مَعْرِفَةَ حَدِيثِ
u'مَعْرِفَة حَديثٌ':Added, #2: 2	مَعْرِفَةُ الْحَدِيثِ
u'مَعْرِفَةٌ حَديثٌ':Added, #2: 2	مَعْرِفَةُ الْحَدِيثِ
u'مَعْرِفَة حَديثٌ':Added, #3: 3	مَعْرِفَةِ الْحَدِيثِ
u'مَعْرِفَةٌ حَرَكَةٌ':Added, #3: 3	مَعْرِفَةِ الْحَدِيثِ
u'مَعْرِفَة حَرَكَةٌ':Added, #1: 1	مَعْرِفَةِ الْحَرَكَةِ
u'مَعْرِفَةٌ حُروفٌ':Added, #1: 1	مَعْرِفَةِ الْحَرَكَةِ
u'مَعْرِفَة حُروفٌ':Added, #1: 1	مَعْرِفَةِ الْحُرُوفِ
u'مَعْرِفَةٌ حساب':Added, #1: 1	مَعْرِفَةِ الْحُرُوفِ
u'مَعْرِفَة حساب':Added, #1: 1	مَعْرِفَةُ الْحِسَابِ
u'مَعْرِفَةٌ حِسَابٌ':Added, #1: 1	مَعْرِفَةُ الْحِسَابِ
u'مَعْرِفَة حِسَابٌ':Added, #1: 1	مَعْرِفَةُ الْحِسَابِ
u'مَعْرِفَةٌ حساب':Added, #1: 1	مَعْرِفَةُ الْحِسَابِ
u'مَعْرِفَة حساب':Added, #3: 3	مَعْرِفَةِ الْحِسَابِ
u'مَعْرِفَةٌ حِسَابٌ':Added, #3: 3	مَعْرِفَةِ الْحِسَابِ
u'مَعْرِفَة حِسَابٌ':Added, #3: 3	مَعْرِفَةِ الْحِسَابِ
u'مَعْرِفَةٌ حَسَنٌ':Added, #3: 3	مَعْرِفَةِ الْحِسَابِ
u'مَعْرِفَة حَسَنٌ':Added, #1: 1	مَعْرِفَةِ الْحَسَنِ
u'مَعْرِفَةٌ حَقٌّ':Added, #1: 1	مَعْرِفَةِ الْحَسَنِ
u'مَعْرِفَة حَقٌّ':Added, #1: 1	مَعْرِفَةُ الْحَقِّ
u'مَعْرِفَةٌ حَقٌّ':Added, #1: 1	مَعْرِفَةُ الْحَقِّ
u'مَعْرِفَة حَقٌّ':Added, #4: 4	مَعْرِفَةِ الْحَقِّ
u'مَعْرِفَةٌ حَقِيقٌ':Added, #4: 4	مَعْرِفَةِ الْحَقِّ
u'مَعْرِفَة حَقِيقٌ':Added, #1: 1	مَعْرِفَةَ حَقِيقَتِهِ
u'مَعْرِفَةٌ حَقِيقٌ':Added, #1: 1	مَعْرِفَةَ حَقِيقَتِهِ
u'مَعْرِفَة حَقِيقٌ':Added, #2: 2	مَعْرِفَةِ حَقِيقَتِهِ
u'مَعْرِفَةٌ حَقِيقٌ':Added, #2: 2	مَعْرِفَةِ حَقِيقَتِهِ
u'مَعْرِفَة حَقِيقٌ':Added, #4: 4	مَعْرِفَةَ حَقِيقَةِ
u'مَعْرِفَةٌ حَقِيقٌ':Added, #4: 4	مَعْرِفَةَ حَقِيقَةِ
u'مَعْرِفَة حَقِيقٌ':Added, #5: 5	مَعْرِفَةُ حَقِيقَةِ
u'مَعْرِفَةٌ حَقِيقٌ':Added, #5: 5	مَعْرِفَةُ حَقِيقَةِ
u'مَعْرِفَة حَقِيقٌ':Added, #6: 6	مَعْرِفَةِ حَقِيقَةِ
u'مَعْرِفَةٌ حَقِيقَةٌ':Added, #6: 6	مَعْرِفَةِ حَقِيقَةِ
u'مَعْرِفَة حَقِيقَةٌ':Added, #1: 1	مَعْرِفَةَ حَقِيقَتِهِ
u'مَعْرِفَةٌ حَقِيقَةٌ':Added, #1: 1	مَعْرِفَةَ حَقِيقَتِهِ
u'مَعْرِفَة حَقِيقَةٌ':Added, #2: 2	مَعْرِفَةِ حَقِيقَتِهِ
u'مَعْرِفَةٌ حَقِيقَةٌ':Added, #2: 2	مَعْرِفَةِ حَقِيقَتِهِ
u'مَعْرِفَة حَقِيقَةٌ':Added, #4: 4	مَعْرِفَةَ حَقِيقَةِ
u'مَعْرِفَةٌ حَقِيقَةٌ':Added, #4: 4	مَعْرِفَةَ حَقِيقَةِ
u'مَعْرِفَة حَقِيقَةٌ':Added, #5: 5	مَعْرِفَةُ حَقِيقَةِ
u'مَعْرِفَةٌ حَقِيقَةٌ':Added, #5: 5	مَعْرِفَةُ حَقِيقَةِ
u'مَعْرِفَة حَقِيقَةٌ':Added, #6: 6	مَعْرِفَةِ حَقِيقَةِ
u'مَعْرِفَةٌ حُكْمٌ':Added, #6: 6	مَعْرِفَةِ حَقِيقَةِ
u'مَعْرِفَةٌ حُكْمٌ':Added, #1: 1	مَعْرِفَةَ حُكْمِ
u'مَعْرِفَةٌ حُكْمٌ':Added, #1: 1	مَعْرِفَةُ حُكْمِ
u'مَعْرِفَة حُكْمٌ':Added, #1: 1	مَعْرِفَةِ حُكْمٍ
u'مَعْرِفَة حُكْمٌ':Added, #1: 1	مَعْرِفَةَ حُكْمِ
u'مَعْرِفَة حُكْمٌ':Added, #1: 1	مَعْرِفَةُ حُكْمِ
u'مَعْرِفَةٌ حُكْمٌ':Added, #1: 1	مَعْرِفَةِ حُكْمٍ
u'مَعْرِفَةٌ حُكْمٌ':Added, #2: 2	مَعْرِفَةُ حُكْمِهِ
u'مَعْرِفَة حُكْمٌ':Added, #2: 2	مَعْرِفَةِ حُكْمِهِ
u'مَعْرِفَة حُكْمٌ':Added, #2: 2	مَعْرِفَةُ حُكْمِهِ
u'مَعْرِفَةٌ حُكْمٌ':Added, #2: 2	مَعْرِفَةِ حُكْمِهِ
u'مَعْرِفَة حُكْمٌ':Added, #3: 3	مَعْرِفَةِ حُكْمِ
u'مَعْرِفَةٌ حُكْمٌ':Added, #3: 3	مَعْرِفَةِ حُكْمِ
u'مَعْرِفَةٌ حُكْمٌ':Added, #4: 4	مَعْرِفَةُ الْحُكْمِ
u'مَعْرِفَة حُكْمٌ':Added, #4: 4	مَعْرِفَةِ الْحُكْمِ
u'مَعْرِفَة حُكْمٌ':Added, #4: 4	مَعْرِفَةُ الْحُكْمِ
u'مَعْرِفَةٌ حكمة':Added, #4: 4	مَعْرِفَةِ الْحُكْمِ
u'مَعْرِفَةٌ حكمة':Added, #1: 1	مَعْرِفَةَ الْحِكْمَةِ
u'مَعْرِفَة حكمة':Added, #1: 1	مَعْرِفَةِ الْحِكْمَةِ
u'مَعْرِفَة حكمة':Added, #1: 1	مَعْرِفَةَ الْحِكْمَةِ
u'مَعْرِفَةٌ حِكْمَةٌ':Added, #1: 1	مَعْرِفَةِ الْحِكْمَةِ
u'مَعْرِفَةٌ حِكْمَةٌ':Added, #1: 1	مَعْرِفَةَ الْحِكْمَةِ
u'مَعْرِفَة حِكْمَةٌ':Added, #1: 1	مَعْرِفَةِ الْحِكْمَةِ
u'مَعْرِفَة حِكْمَةٌ':Added, #1: 1	مَعْرِفَةَ الْحِكْمَةِ
u'مَعْرِفَةٌ حُكُومَةٌ':Added, #1: 1	مَعْرِفَةِ الْحِكْمَةِ
u'مَعْرِفَة حُكُومَةٌ':Added, #1: 1	مَعْرِفَةِ الْحُكُومَةِ
u'مَعْرِفَةٌ حوادِثُ':Added, #1: 1	مَعْرِفَةِ الْحُكُومَةِ
u'مَعْرِفَة حوادِثُ':Added, #1: 1	مَعْرِفَةِ الْحَوَادِثِ
u'مَعْرِفَةٌ حَيَاةٌ':Added, #1: 1	مَعْرِفَةِ الْحَوَادِثِ
u'مَعْرِفَة حَيَاةٌ':Added, #1: 1	مَعْرِفَةُ الْحَيَاةِ
u'مَعْرِفَةٌ خَارِجٌ':Added, #1: 1	مَعْرِفَةُ الْحَيَاةِ
u'مَعْرِفَة خَارِجٌ':Added, #1: 1	مَعْرِفَةُ الْخَارِجِ
u'مَعْرِفَةٌ خَالِصٌ':Added, #1: 1	مَعْرِفَةُ الْخَارِجِ
u'مَعْرِفَة خَالِصٌ':Added, #1: 1	مَعْرِفَةِ الْخَالِصِ
u'مَعْرِفَةٌ خَالِقٌ':Added, #1: 1	مَعْرِفَةِ الْخَالِصِ
u'مَعْرِفَة خَالِقٌ':Added, #1: 1	مَعْرِفَةُ الْخَالِقِ
u'مَعْرِفَةٌ خَتْمٌ':Added, #1: 1	مَعْرِفَةُ الْخَالِقِ
u'مَعْرِفَة خَتْمٌ':Added, #2: 2	مَعْرِفَةِ خَتْمِ
u'مَعْرِفَةٌ خَطٌّ':Added, #2: 2	مَعْرِفَةِ خَتْمِ
u'مَعْرِفَة خَطٌّ':Added, #1: 1	مَعْرِفَةُ الْخَطِّ
u'مَعْرِفَةٌ خَطٌّ':Added, #1: 1	مَعْرِفَةُ الْخَطِّ
u'مَعْرِفَة خَطٌّ':Added, #1: 1	مَعْرِفَةِ خَطِّ
u'مَعْرِفَةٌ خَطٌّ':Added, #1: 1	مَعْرِفَةِ خَطِّ
u'مَعْرِفَةٌ خَطٌّ':Added, #1: 1	مَعْرِفَةُ خَطِّهِ
u'مَعْرِفَة خَطٌّ':Added, #1: 1	مَعْرِفَةِ خَطِّهِ
u'مَعْرِفَة خَطٌّ':Added, #1: 1	مَعْرِفَةُ خَطِّهِ
u'مَعْرِفَةٌ خَطٌّ':Added, #1: 1	مَعْرِفَةِ خَطِّهِ
u'مَعْرِفَة خَطٌّ':Added, #2: 2	مَعْرِفَةُ خَطِّ
u'مَعْرِفَةٌ خَطٌّ':Added, #2: 2	مَعْرِفَةُ خَطِّ
u'مَعْرِفَة خَطٌّ':Added, #6: 6	مَعْرِفَةِ الْخَطِّ
u'مَعْرِفَةٌ خِطَابٌ':Added, #6: 6	مَعْرِفَةِ الْخَطِّ
u'مَعْرِفَة خِطَابٌ':Added, #1: 1	مَعْرِفَةُ خِطَابِ
u'مَعْرِفَةٌ خُفٌّ':Added, #1: 1	مَعْرِفَةُ خِطَابِ
u'مَعْرِفَة خُفٌّ':Added, #1: 1	مَعْرِفَةُ الْخُفِّ
u'مَعْرِفَةٌ خِلاَفٌ':Added, #1: 1	مَعْرِفَةُ الْخُفِّ
u'مَعْرِفَة خِلاَفٌ':Added, #1: 1	مَعْرِفَةِ الْخِلَافِ
u'مَعْرِفَةٌ دَاءٌ':Added, #1: 1	مَعْرِفَةِ الْخِلَافِ
u'مَعْرِفَةٌ دَاءٌ':Added, #1: 1	مَعْرِفَةِ دَاءٍ
u'مَعْرِفَة دَاءٌ':Added, #1: 1	مَعْرِفَةِ دَاءِ
u'مَعْرِفَة دَاءٌ':Added, #1: 1	مَعْرِفَةِ دَاءٍ
u'مَعْرِفَةٌ دَابَّةٌ':Added, #1: 1	مَعْرِفَةِ دَاءِ
u'مَعْرِفَة دَابَّةٌ':Added, #1: 1	مَعْرِفَةِ الدَّابَّةِ
u'مَعْرِفَةٌ دَابَّةٌ':Added, #1: 1	مَعْرِفَةِ الدَّابَّةِ
u'مَعْرِفَة دَابَّةٌ':Added, #2: 2	مَعْرِفَةُ الدَّابَّةِ
u'مَعْرِفَةٌ دَافِعٌ':Added, #2: 2	مَعْرِفَةُ الدَّابَّةِ
u'مَعْرِفَة دَافِعٌ':Added, #1: 1	مَعْرِفَةُ الدَّافِعِ
u'مَعْرِفَةٌ دَلائِلُ':Added, #1: 1	مَعْرِفَةُ الدَّافِعِ
u'مَعْرِفَة دَلائِلُ':Added, #1: 1	مَعْرِفَةَ الدَّلَائِلِ
u'مَعْرِفَةٌ دَليلٌ':Added, #1: 1	مَعْرِفَةَ الدَّلَائِلِ
u'مَعْرِفَة دَليلٌ':Added, #1: 1	مَعْرِفَةَ الدَّلِيلِ
u'مَعْرِفَةٌ دَليلٌ':Added, #1: 1	مَعْرِفَةَ الدَّلِيلِ
u'مَعْرِفَة دَليلٌ':Added, #1: 1	مَعْرِفَةُ دَلِيلِ
u'مَعْرِفَةٌ دَليلٌ':Added, #1: 1	مَعْرِفَةُ دَلِيلِ
u'مَعْرِفَة دَليلٌ':Added, #2: 2	مَعْرِفَةِ الدَّلِيلِ
u'مَعْرِفَةٌ دَليلٌ':Added, #2: 2	مَعْرِفَةِ الدَّلِيلِ
u'مَعْرِفَة دَليلٌ':Added, #3: 3	مَعْرِفَةِ دَلِيلِهِ
u'مَعْرِفَةٌ دَهْرٌ':Added, #3: 3	مَعْرِفَةِ دَلِيلِهِ
u'مَعْرِفَة دَهْرٌ':Added, #1: 1	مَعْرِفَةَ الدَّهْرِ
u'مَعْرِفَةٌ دُورٌ':Added, #1: 1	مَعْرِفَةَ الدَّهْرِ
u'مَعْرِفَة دُورٌ':Added, #1: 1	مَعْرِفَةُ الدُّورِ
u'مَعْرِفَةٌ دُولابٌ':Added, #1: 1	مَعْرِفَةُ الدُّورِ
u'مَعْرِفَة دُولابٌ':Added, #1: 1	مَعْرِفَةُ الدُّولَابِ
u'مَعْرِفَةٌ دِينٌ':Added, #1: 1	مَعْرِفَةُ الدُّولَابِ
u'مَعْرِفَةٌ دِينٌ':Added, #1: 1	مَعْرِفَةُ دِينِ
u'مَعْرِفَة دِينٌ':Added, #1: 1	مَعْرِفَةِ دِينِ
u'مَعْرِفَة دِينٌ':Added, #1: 1	مَعْرِفَةُ دِينِ
u'مَعْرِفَةٌ ذَهَابٌ':Added, #1: 1	مَعْرِفَةِ دِينِ
u'مَعْرِفَة ذَهَابٌ':Added, #7: 7	مَعْرِفَةِ ذَهَابِ
u'مَعْرِفَةٌ رَاجِحٌ':Added, #7: 7	مَعْرِفَةِ ذَهَابِ
u'مَعْرِفَة رَاجِحٌ':Added, #1: 1	مَعْرِفَةِ الرَّاجِحِ
u'مَعْرِفَةٌ رَأْسٌ':Added, #1: 1	مَعْرِفَةِ الرَّاجِحِ
u'مَعْرِفَة رَأْسٌ':Added, #3: 3	مَعْرِفَةِ رَأْسِ
u'مَعْرِفَةٌ رَاكِبٌ':Added, #3: 3	مَعْرِفَةِ رَأْسِ
u'مَعْرِفَةٌ رَاكِبٌ':Added, #1: 1	مَعْرِفَةُ الرَّاكِبِ
u'مَعْرِفَة رَاكِبٌ':Added, #1: 1	مَعْرِفَةِ الرَّاكِبِ
u'مَعْرِفَة رَاكِبٌ':Added, #1: 1	مَعْرِفَةُ الرَّاكِبِ
u'مَعْرِفَةٌ رَبُّ':Added, #1: 1	مَعْرِفَةِ الرَّاكِبِ
u'مَعْرِفَة رَبُّ':Added, #1: 1	مَعْرِفَةُ الرَّبِّ
u'مَعْرِفَةٌ رَبُّ':Added, #1: 1	مَعْرِفَةُ الرَّبِّ
u'مَعْرِفَة رَبُّ':Added, #1: 1	مَعْرِفَةُ رَبِّهِ
u'مَعْرِفَةٌ رِجَالٌ':Added, #1: 1	مَعْرِفَةُ رَبِّهِ
u'مَعْرِفَة رِجَالٌ':Added, #1: 1	مَعْرِفَةَ الرِّجَالِ
u'مَعْرِفَةٌ رِجَالٌ':Added, #1: 1	مَعْرِفَةَ الرِّجَالِ
u'مَعْرِفَة رِجَالٌ':Added, #2: 2	مَعْرِفَةِ الرِّجَالِ
u'مَعْرِفَةٌ رَسُولٌ':Added, #2: 2	مَعْرِفَةِ الرِّجَالِ
u'مَعْرِفَة رَسُولٌ':Added, #1: 1	مَعْرِفَةُ الرَّسُولِ
u'مَعْرِفَةٌ رضاع':Added, #1: 1	مَعْرِفَةُ الرَّسُولِ
u'مَعْرِفَة رضاع':Added, #1: 1	مَعْرِفَةِ رَضَاعِهِ
u'مَعْرِفَةٌ رِقٌّ':Added, #1: 1	مَعْرِفَةِ رَضَاعِهِ
u'مَعْرِفَة رِقٌّ':Added, #1: 1	مَعْرِفَةُ الرِّقِّ
u'مَعْرِفَةٌ رَقَبَةٌ':Added, #1: 1	مَعْرِفَةُ الرِّقِّ
u'مَعْرِفَة رَقَبَةٌ':Added, #1: 1	مَعْرِفَةِ الرَّقَبَةِ
u'مَعْرِفَةٌ رَمْيٌ':Added, #1: 1	مَعْرِفَةِ الرَّقَبَةِ
u'مَعْرِفَة رَمْيٌ':Added, #1: 1	مَعْرِفَةُ الرَّمْيِ
u'مَعْرِفَةٌ رَهْنٌ':Added, #1: 1	مَعْرِفَةُ الرَّمْيِ
u'مَعْرِفَة رَهْنٌ':Added, #1: 1	مَعْرِفَةِ الرَّهْنِ
u'مَعْرِفَةٌ زادٌ':Added, #1: 1	مَعْرِفَةِ الرَّهْنِ
u'مَعْرِفَة زادٌ':Added, #1: 1	مَعْرِفَةُ الزَّادِ
u'مَعْرِفَةٌ زَوالٌ':Added, #1: 1	مَعْرِفَةُ الزَّادِ
u'مَعْرِفَة زَوالٌ':Added, #1: 1	مَعْرِفَةِ زَوَالِ
u'مَعْرِفَةٌ زَوالٌ':Added, #1: 1	مَعْرِفَةِ زَوَالِ
u'مَعْرِفَة زَوالٌ':Added, #3: 3	مَعْرِفَةِ الزَّوَالِ
u'مَعْرِفَةٌ زُيوفٌ':Added, #3: 3	مَعْرِفَةِ الزَّوَالِ
u'مَعْرِفَة زُيوفٌ':Added, #1: 1	مَعْرِفَةِ الزُّيُوفِ
u'مَعْرِفَةٌ زُيُوفٌ':Added, #1: 1	مَعْرِفَةِ الزُّيُوفِ
u'مَعْرِفَة زُيُوفٌ':Added, #1: 1	مَعْرِفَةِ الزُّيُوفِ
u'مَعْرِفَةٌ سَبَبٌ':Added, #1: 1	مَعْرِفَةِ الزُّيُوفِ
u'مَعْرِفَة سَبَبٌ':Added, #1: 1	مَعْرِفَةِ السَّبَبِ
u'مَعْرِفَةٌ سَبْعَةٌ':Added, #1: 1	مَعْرِفَةِ السَّبَبِ
u'مَعْرِفَة سَبْعَةٌ':Added, #1: 1	مَعْرِفَةُ سَبْعَةِ
u'مَعْرِفَةٌ سِتٌّ':Added, #1: 1	مَعْرِفَةُ سَبْعَةِ
u'مَعْرِفَة سِتٌّ':Added, #1: 1	مَعْرِفَةِ سِتَّةِ
u'مَعْرِفَةٌ سِرٌّ':Added, #1: 1	مَعْرِفَةِ سِتَّةِ
u'مَعْرِفَة سِرٌّ':Added, #1: 1	مَعْرِفَةِ السِّرِّ
u'مَعْرِفَةٌ سَعَةٌ':Added, #1: 1	مَعْرِفَةِ السِّرِّ
u'مَعْرِفَة سَعَةٌ':Added, #1: 1	مَعْرِفَةِ سَعَةِ
u'مَعْرِفَةٌ سَقِيمٌ':Added, #1: 1	مَعْرِفَةِ سَعَةِ
u'مَعْرِفَة سَقِيمٌ':Added, #1: 1	مَعْرِفَةِ السَّقِيمِ
u'مَعْرِفَةٌ سكر':Added, #1: 1	مَعْرِفَةِ السَّقِيمِ
u'مَعْرِفَة سكر':Added, #3: 3	مَعْرِفَةِ السُّكْرِ
u'مَعْرِفَةٌ سُكْرٌ':Added, #3: 3	مَعْرِفَةِ السُّكْرِ
u'مَعْرِفَة سُكْرٌ':Added, #3: 3	مَعْرِفَةِ السُّكْرِ
u'مَعْرِفَةٌ سَكْرَان':Added, #3: 3	مَعْرِفَةِ السُّكْرِ
u'مَعْرِفَة سَكْرَان':Added, #1: 1	مَعْرِفَةِ السَّكْرَانِ
u'مَعْرِفَةٌ سَلاَمَةٌ':Added, #1: 1	مَعْرِفَةِ السَّكْرَانِ
u'مَعْرِفَة سَلاَمَةٌ':Added, #1: 1	مَعْرِفَةِ سَلَامَتِهِ
u'مَعْرِفَةٌ سَمْعٌ':Added, #1: 1	مَعْرِفَةِ سَلَامَتِهِ
u'مَعْرِفَة سَمْعٌ':Added, #1: 1	مَعْرِفَةِ السَّمْعِ
u'مَعْرِفَةٌ سِنٌّ':Added, #1: 1	مَعْرِفَةِ السَّمْعِ
u'مَعْرِفَة سِنٌّ':Added, #1: 1	مَعْرِفَةَ سِنِّهِ
u'مَعْرِفَةٌ سنن':Added, #1: 1	مَعْرِفَةَ سِنِّهِ
u'مَعْرِفَة سنن':Added, #1: 1	مَعْرِفَةِ السُّنَنِ
u'مَعْرِفَةٌ سهام':Added, #1: 1	مَعْرِفَةِ السُّنَنِ
u'مَعْرِفَة سهام':Added, #1: 1	مَعْرِفَةَ سِهَامِ
u'مَعْرِفَةٌ سِهَامٌ':Added, #1: 1	مَعْرِفَةَ سِهَامِ
u'مَعْرِفَة سِهَامٌ':Added, #1: 1	مَعْرِفَةَ سِهَامِ
u'مَعْرِفَةٌ سهام':Added, #1: 1	مَعْرِفَةَ سِهَامِ
u'مَعْرِفَة سهام':Added, #1: 1	مَعْرِفَةَ سِهَامِهِ
u'مَعْرِفَةٌ سِهَامٌ':Added, #1: 1	مَعْرِفَةَ سِهَامِهِ
u'مَعْرِفَة سِهَامٌ':Added, #1: 1	مَعْرِفَةَ سِهَامِهِ
u'مَعْرِفَةٌ سهام':Added, #1: 1	مَعْرِفَةَ سِهَامِهِ
u'مَعْرِفَة سهام':Added, #2: 2	مَعْرِفَةِ سِهَامِ
u'مَعْرِفَةٌ سِهَامٌ':Added, #2: 2	مَعْرِفَةِ سِهَامِ
u'مَعْرِفَة سِهَامٌ':Added, #2: 2	مَعْرِفَةِ سِهَامِ
u'مَعْرِفَةٌ سَهْمٌ':Added, #2: 2	مَعْرِفَةِ سِهَامِ
u'مَعْرِفَة سَهْمٌ':Added, #1: 1	مَعْرِفَةِ السَّهْمِ
u'مَعْرِفَةٌ سَهْمٌ':Added, #1: 1	مَعْرِفَةِ السَّهْمِ
u'مَعْرِفَة سَهْمٌ':Added, #1: 1	مَعْرِفَةَ سَهْمِهِ
u'مَعْرِفَةٌ سَيِّدٌ':Added, #1: 1	مَعْرِفَةَ سَهْمِهِ
u'مَعْرِفَة سَيِّدٌ':Added, #1: 1	مَعْرِفَةُ السَّيِّدِ
u'مَعْرِفَةٌ شَاهِدٌ':Added, #1: 1	مَعْرِفَةُ السَّيِّدِ
u'مَعْرِفَة شَاهِدٌ':Added, #1: 1	مَعْرِفَةُ شَاهِدِ
u'مَعْرِفَةٌ شِبْهٌ':Added, #1: 1	مَعْرِفَةُ شَاهِدِ
u'مَعْرِفَة شِبْهٌ':Added, #1: 1	مَعْرِفَةَ شِبْهِ
u'مَعْرِفَةٌ شَخْصٌ':Added, #1: 1	مَعْرِفَةَ شِبْهِ
u'مَعْرِفَة شَخْصٌ':Added, #1: 1	مَعْرِفَةُ شَخْصِهِ
u'مَعْرِفَةٌ شَرَائِطُ':Added, #1: 1	مَعْرِفَةُ شَخْصِهِ
u'مَعْرِفَة شَرَائِطُ':Added, #1: 1	مَعْرِفَةُ شَرَائِطِ
u'مَعْرِفَةٌ شَرْطٌ':Added, #1: 1	مَعْرِفَةُ شَرَائِطِ
u'مَعْرِفَة شَرْطٌ':Added, #2: 2	مَعْرِفَةُ شَرْطِ
u'مَعْرِفَةٌ شَرْعٌ':Added, #2: 2	مَعْرِفَةُ شَرْطِ
u'مَعْرِفَة شَرْعٌ':Added, #1: 1	مَعْرِفَةَ الشَّرْعِ
u'مَعْرِفَةٌ شَرْعِيٌّ':Added, #1: 1	مَعْرِفَةَ الشَّرْعِ
u'مَعْرِفَة شَرْعِيٌّ':Added, #1: 1	مَعْرِفَةِ شَرْعِيَّةِ
u'مَعْرِفَةٌ شُرُوطٌ':Added, #1: 1	مَعْرِفَةِ شَرْعِيَّةِ
u'مَعْرِفَة شُرُوطٌ':Added, #1: 1	مَعْرِفَةُ شُرُوطِ
u'مَعْرِفَةٌ شُرُوطٌ':Added, #1: 1	مَعْرِفَةُ شُرُوطِ
u'مَعْرِفَة شُرُوطٌ':Added, #1: 1	مَعْرِفَةُ شُرُوطِهِ
u'مَعْرِفَةٌ شُرُوطٌ':Added, #1: 1	مَعْرِفَةُ شُرُوطِهِ
u'مَعْرِفَة شُرُوطٌ':Added, #2: 2	مَعْرِفَةُ الشُّرُوطِ
u'مَعْرِفَةٌ شِعْرٌ':Added, #2: 2	مَعْرِفَةُ الشُّرُوطِ
u'مَعْرِفَة شِعْرٌ':Added, #1: 1	مَعْرِفَةُ الشِّعْرِ
u'مَعْرِفَةٌ شكر':Added, #1: 1	مَعْرِفَةُ الشِّعْرِ
u'مَعْرِفَة شكر':Added, #1: 1	مَعْرِفَةُ شُكْرِ
u'مَعْرِفَةٌ شُكْرٌ':Added, #1: 1	مَعْرِفَةُ شُكْرِ
u'مَعْرِفَة شُكْرٌ':Added, #1: 1	مَعْرِفَةُ شُكْرِ
u'مَعْرِفَةٌ شَمٌّ':Added, #1: 1	مَعْرِفَةُ شُكْرِ
u'مَعْرِفَة شَمٌّ':Added, #1: 1	مَعْرِفَةِ الشَّمِّ
u'مَعْرِفَةٌ شُهُودٌ':Added, #1: 1	مَعْرِفَةِ الشَّمِّ
u'مَعْرِفَة شُهُودٌ':Added, #1: 1	مَعْرِفَةُ الشُّهُودِ
u'مَعْرِفَةٌ شُهُودٌ':Added, #1: 1	مَعْرِفَةُ الشُّهُودِ
u'مَعْرِفَة شُهُودٌ':Added, #2: 2	مَعْرِفَةَ الشُّهُودِ
u'مَعْرِفَةٌ شَيْءٌ':Added, #2: 2	مَعْرِفَةَ الشُّهُودِ
u'مَعْرِفَة شَيْءٌ':Added, #3: 3	مَعْرِفَةُ الشَّيْءِ
u'مَعْرِفَةٌ شَيْءٌ':Added, #3: 3	مَعْرِفَةُ الشَّيْءِ
u'مَعْرِفَة شَيْءٌ':Added, #3: 3	مَعْرِفَةِ شَيْءٍ
u'مَعْرِفَةٌ صَاحِبٌ':Added, #3: 3	مَعْرِفَةِ شَيْءٍ
u'مَعْرِفَة صَاحِبٌ':Added, #1: 1	مَعْرِفَةَ صَاحِبِ
u'مَعْرِفَةٌ صَاحِبٌ':Added, #1: 1	مَعْرِفَةَ صَاحِبِ
u'مَعْرِفَة صَاحِبٌ':Added, #1: 1	مَعْرِفَةُ صَاحِبِهِ
u'مَعْرِفَةٌ صَانِعٌ':Added, #1: 1	مَعْرِفَةُ صَاحِبِهِ
u'مَعْرِفَة صَانِعٌ':Added, #1: 1	مَعْرِفَةِ الصَّانِعِ
u'مَعْرِفَةٌ صَانِعٌ':Added, #1: 1	مَعْرِفَةِ الصَّانِعِ
u'مَعْرِفَة صَانِعٌ':Added, #1: 1	مَعْرِفَةِ صَانِعِهِ
u'مَعْرِفَةٌ صَحَابَةٌ':Added, #1: 1	مَعْرِفَةِ صَانِعِهِ
u'مَعْرِفَة صَحَابَةٌ':Added, #1: 1	مَعْرِفَة الصَّحَابَةِ
u'مَعْرِفَةٌ صَحَابَةٌ':Added, #1: 1	مَعْرِفَة الصَّحَابَةِ
u'مَعْرِفَة صَحَابَةٌ':Added, #28: 28	مَعْرِفَةِ الصَّحَابَةِ
u'مَعْرِفَةٌ صَحَابِيٌّ':Added, #28: 28	مَعْرِفَةِ الصَّحَابَةِ
u'مَعْرِفَة صَحَابِيٌّ':Added, #1: 1	مَعْرِفَةِ الصَّحَابِيِّ
u'مَعْرِفَةٌ صِحَّةٌ':Added, #1: 1	مَعْرِفَةِ الصَّحَابِيِّ
u'مَعْرِفَة صِحَّةٌ':Added, #1: 1	مَعْرِفَةُ صِحَّةِ
u'مَعْرِفَةٌ صِحَّةٌ':Added, #1: 1	مَعْرِفَةُ صِحَّةِ
u'مَعْرِفَة صِحَّةٌ':Added, #2: 2	مَعْرِفَةِ صِحَّةِ
u'مَعْرِفَةٌ صَحِيحٌ':Added, #2: 2	مَعْرِفَةِ صِحَّةِ
u'مَعْرِفَة صَحِيحٌ':Added, #1: 1	مَعْرِفَةُ الصَّحِيحَةِ
u'مَعْرِفَةٌ صَحِيحٌ':Added, #1: 1	مَعْرِفَةُ الصَّحِيحَةِ
u'مَعْرِفَة صَحِيحٌ':Added, #1: 1	مَعْرِفَةِ صَحِيحِ
u'مَعْرِفَةٌ صَحِيحٌ':Added, #1: 1	مَعْرِفَةِ صَحِيحِ
u'مَعْرِفَة صَحِيحٌ':Added, #1: 1	مَعْرِفَةِ صَحِيحِهِ
u'مَعْرِفَةٌ صَحِيحٌ':Added, #1: 1	مَعْرِفَةِ صَحِيحِهِ
u'مَعْرِفَةٌ صَحِيحٌ':Added, #2: 2	مَعْرِفَةُ الصَّحِيحِ
u'مَعْرِفَة صَحِيحٌ':Added, #2: 2	مَعْرِفَةِ الصَّحِيحِ
u'مَعْرِفَة صَحِيحٌ':Added, #2: 2	مَعْرِفَةُ الصَّحِيحِ
u'مَعْرِفَةٌ صدق':Added, #2: 2	مَعْرِفَةِ الصَّحِيحِ
u'مَعْرِفَة صدق':Added, #1: 1	مَعْرِفَةُ الصِّدْقِ
u'مَعْرِفَةٌ صِدْقٌ':Added, #1: 1	مَعْرِفَةُ الصِّدْقِ
u'مَعْرِفَة صِدْقٌ':Added, #1: 1	مَعْرِفَةُ الصِّدْقِ
u'مَعْرِفَةٌ صَغِيرٌ':Added, #1: 1	مَعْرِفَةُ الصِّدْقِ
u'مَعْرِفَة صَغِيرٌ':Added, #1: 1	مَعْرِفَةِ الصَّغِيرِ
u'مَعْرِفَةٌ صِفَةٌ':Added, #1: 1	مَعْرِفَةِ الصَّغِيرِ
u'مَعْرِفَة صِفَةٌ':Added, #1: 1	مَعْرِفَةَ الصِّفَاتِ
u'مَعْرِفَةٌ صِفَةٌ':Added, #1: 1	مَعْرِفَةَ الصِّفَاتِ
u'مَعْرِفَة صِفَةٌ':Added, #1: 1	مَعْرِفَةِ صِفَاتِ
u'مَعْرِفَةٌ صِفَةٌ':Added, #1: 1	مَعْرِفَةِ صِفَاتِ
u'مَعْرِفَة صِفَةٌ':Added, #1: 1	مَعْرِفَةِ صِفَةِ
u'مَعْرِفَةٌ صِفَةٌ':Added, #1: 1	مَعْرِفَةِ صِفَةِ
u'مَعْرِفَة صِفَةٌ':Added, #3: 3	مَعْرِفَةِ الصِّفَاتِ
u'مَعْرِفَةٌ صَوَابٌ':Added, #3: 3	مَعْرِفَةِ الصِّفَاتِ
u'مَعْرِفَة صَوَابٌ':Added, #1: 1	مَعْرِفَةِ الصَّوَابِ
u'مَعْرِفَةٌ صُورَةٌ':Added, #1: 1	مَعْرِفَةِ الصَّوَابِ
u'مَعْرِفَة صُورَةٌ':Added, #1: 1	مَعْرِفَةُ صُورَتِهِ
u'مَعْرِفَةٌ صِيغَةٌ':Added, #1: 1	مَعْرِفَةُ صُورَتِهِ
u'مَعْرِفَة صِيغَةٌ':Added, #1: 1	مَعْرِفَةُ صِيغَةِ
u'مَعْرِفَةٌ صَيْفٌ':Added, #1: 1	مَعْرِفَةُ صِيغَةِ
u'مَعْرِفَة صَيْفٌ':Added, #1: 1	مَعْرِفَةِ الصَّيْفِ
u'مَعْرِفَةٌ ضَامِنٌ':Added, #1: 1	مَعْرِفَةِ الصَّيْفِ
u'مَعْرِفَة ضَامِنٌ':Added, #1: 1	مَعْرِفَةُ الضَّامِنِ
u'مَعْرِفَةٌ ضَرَرٌ':Added, #1: 1	مَعْرِفَةُ الضَّامِنِ
u'مَعْرِفَة ضَرَرٌ':Added, #1: 1	مَعْرِفَةِ الضَّرَرِ
u'مَعْرِفَةٌ ضَرُورِيٌّ':Added, #1: 1	مَعْرِفَةِ الضَّرَرِ
u'مَعْرِفَة ضَرُورِيٌّ':Added, #1: 1	مَعْرِفَةُ الضَّرُورِيَّاتِ
u'مَعْرِفَةٌ ضَرُورِيَّاتٌ':Added, #1: 1	مَعْرِفَةُ الضَّرُورِيَّاتِ
u'مَعْرِفَة ضَرُورِيَّاتٌ':Added, #1: 1	مَعْرِفَةُ الضَّرُورِيَّاتِ
u'مَعْرِفَةٌ طَائِعٌ':Added, #1: 1	مَعْرِفَةُ الضَّرُورِيَّاتِ
u'مَعْرِفَة طَائِعٌ':Added, #1: 1	مَعْرِفَةُ الطَّائِعِ
u'مَعْرِفَةٌ طَرِيقٌ':Added, #1: 1	مَعْرِفَةُ الطَّائِعِ
u'مَعْرِفَة طَرِيقٌ':Added, #1: 1	مَعْرِفَةِ طَرِيقِ
u'مَعْرِفَةٌ طَرِيقٌ':Added, #1: 1	مَعْرِفَةِ طَرِيقِ
u'مَعْرِفَة طَرِيقٌ':Added, #2: 2	مَعْرِفَةِ الطَّرِيقِ
u'مَعْرِفَةٌ طَعْمٌ':Added, #2: 2	مَعْرِفَةِ الطَّرِيقِ
u'مَعْرِفَة طَعْمٌ':Added, #1: 1	مَعْرِفَةِ الطَّعْمِ
u'مَعْرِفَةٌ طَعْمٌ':Added, #1: 1	مَعْرِفَةِ الطَّعْمِ
u'مَعْرِفَة طَعْمٌ':Added, #2: 2	مَعْرِفَةُ طَعْمِ
u'مَعْرِفَةٌ طُولٌ':Added, #2: 2	مَعْرِفَةُ طَعْمِ
u'مَعْرِفَة طُولٌ':Added, #1: 1	مَعْرِفَةِ طُولِ
u'مَعْرِفَةٌ عَادَةٌ':Added, #1: 1	مَعْرِفَةِ طُولِ
u'مَعْرِفَة عَادَةٌ':Added, #1: 1	مَعْرِفَةِ عَادَاتِ
u'مَعْرِفَةٌ عَارِفٌ':Added, #1: 1	مَعْرِفَةِ عَادَاتِ
u'مَعْرِفَة عَارِفٌ':Added, #1: 1	مَعْرِفَةُ عَارِفٍ
u'مَعْرِفَةٌ عَاقِدٌ':Added, #1: 1	مَعْرِفَةُ عَارِفٍ
u'مَعْرِفَةٌ عَاقِدٌ':Added, #1: 1	مَعْرِفَةَ الْعَاقِدَيْنِ
u'مَعْرِفَة عَاقِدٌ':Added, #1: 1	مَعْرِفَةُ الْعَاقِدَيْنِ
u'مَعْرِفَة عَاقِدٌ':Added, #1: 1	مَعْرِفَةَ الْعَاقِدَيْنِ
u'مَعْرِفَةٌ عَاقِدٌ':Added, #1: 1	مَعْرِفَةُ الْعَاقِدَيْنِ
u'مَعْرِفَة عَاقِدٌ':Added, #2: 2	مَعْرِفَةِ الْعَاقِدَيْنِ
u'مَعْرِفَةٌ عَاقِلٌ':Added, #2: 2	مَعْرِفَةِ الْعَاقِدَيْنِ
u'مَعْرِفَة عَاقِلٌ':Added, #1: 1	مَعْرِفَةِ الْعَاقِلَةِ
u'مَعْرِفَةٌ عِبَادَةٌ':Added, #1: 1	مَعْرِفَةِ الْعَاقِلَةِ
u'مَعْرِفَة عِبَادَةٌ':Added, #1: 1	مَعْرِفَةَ الْعِبَادَةِ
u'مَعْرِفَةٌ عَبْدٌ':Added, #1: 1	مَعْرِفَةَ الْعِبَادَةِ
u'مَعْرِفَة عَبْدٌ':Added, #3: 3	مَعْرِفَةُ الْعَبْدِ
u'مَعْرِفَةٌ عَدَالَةٌ':Added, #3: 3	مَعْرِفَةُ الْعَبْدِ
u'مَعْرِفَة عَدَالَةٌ':Added, #1: 1	مَعْرِفَةُ عَدَالَةِ
u'مَعْرِفَةٌ عَدَالَةٌ':Added, #1: 1	مَعْرِفَةُ عَدَالَةِ
u'مَعْرِفَةٌ عَدَالَةٌ':Added, #2: 2	مَعْرِفَةَ الْعَدَالَةِ
u'مَعْرِفَة عَدَالَةٌ':Added, #2: 2	مَعْرِفَةُ الْعَدَالَةِ
u'مَعْرِفَة عَدَالَةٌ':Added, #2: 2	مَعْرِفَةَ الْعَدَالَةِ
u'مَعْرِفَةٌ عِدَّةٌ':Added, #2: 2	مَعْرِفَةُ الْعَدَالَةِ
u'مَعْرِفَة عِدَّةٌ':Added, #1: 1	مَعْرِفَةِ الْعِدَّةِ
u'مَعْرِفَةٌ عَدَدِيٌّ':Added, #1: 1	مَعْرِفَةِ الْعِدَّةِ
u'مَعْرِفَة عَدَدِيٌّ':Added, #1: 1	مَعْرِفَةِ الْعَدَدِيِّ
u'مَعْرِفَةٌ عَدْلٌ':Added, #1: 1	مَعْرِفَةِ الْعَدَدِيِّ
u'مَعْرِفَة عَدْلٌ':Added, #3: 3	مَعْرِفَةِ عَدْلَيْنِ
u'مَعْرِفَةٌ عَرَبِيٌّ':Added, #3: 3	مَعْرِفَةِ عَدْلَيْنِ
u'مَعْرِفَة عَرَبِيٌّ':Added, #1: 1	مَعْرِفَةَ الْعَرَبِيَّةِ
u'مَعْرِفَةٌ عرف':Added, #1: 1	مَعْرِفَةَ الْعَرَبِيَّةِ
u'مَعْرِفَة عرف':Added, #1: 1	مَعْرِفَةِ عُرْفِ
u'مَعْرِفَةٌ عُرْفٌ':Added, #1: 1	مَعْرِفَةِ عُرْفِ
u'مَعْرِفَة عُرْفٌ':Added, #1: 1	مَعْرِفَةِ عُرْفِ
u'مَعْرِفَةٌ عَقْلٌ':Added, #1: 1	مَعْرِفَةِ عُرْفِ
u'مَعْرِفَة عَقْلٌ':Added, #1: 1	مَعْرِفَةُ عَقْلِ
u'مَعْرِفَةٌ عَقْلٌ':Added, #1: 1	مَعْرِفَةُ عَقْلِ
u'مَعْرِفَة عَقْلٌ':Added, #1: 1	مَعْرِفَةُ عَقْلِهِ
u'مَعْرِفَةٌ عِلاَجٌ':Added, #1: 1	مَعْرِفَةُ عَقْلِهِ
u'مَعْرِفَة عِلاَجٌ':Added, #1: 1	مَعْرِفَةُ عِلَاجِ
u'مَعْرِفَةٌ عِلَّةٌ':Added, #1: 1	مَعْرِفَةُ عِلَاجِ
u'مَعْرِفَة عِلَّةٌ':Added, #1: 1	مَعْرِفَةِ الْعِلَّةِ
u'مَعْرِفَةٌ عِلَّةٌ':Added, #1: 1	مَعْرِفَةِ الْعِلَّةِ
u'مَعْرِفَة عِلَّةٌ':Added, #3: 3	مَعْرِفَةُ الْعِلَّةِ
u'مَعْرِفَةٌ عِلَلٌ':Added, #3: 3	مَعْرِفَةُ الْعِلَّةِ
u'مَعْرِفَة عِلَلٌ':Added, #1: 1	مَعْرِفَةِ عِلَلِ
u'مَعْرِفَةٌ عِلَلٌ':Added, #1: 1	مَعْرِفَةِ عِلَلِ
u'مَعْرِفَة عِلَلٌ':Added, #1: 1	مَعْرِفَةُ عِلَلِهِ
u'مَعْرِفَةٌ علم':Added, #1: 1	مَعْرِفَةُ عِلَلِهِ
u'مَعْرِفَةٌ علم':Added, #1: 1	مَعْرِفَةَ الْعِلْمِ
u'مَعْرِفَة علم':Added, #1: 1	مَعْرِفَةُ الْعِلْمِ
u'مَعْرِفَة علم':Added, #1: 1	مَعْرِفَةَ الْعِلْمِ
u'مَعْرِفَةٌ عِلْمٌ':Added, #1: 1	مَعْرِفَةُ الْعِلْمِ
u'مَعْرِفَةٌ عِلْمٌ':Added, #1: 1	مَعْرِفَةَ الْعِلْمِ
u'مَعْرِفَة عِلْمٌ':Added, #1: 1	مَعْرِفَةُ الْعِلْمِ
u'مَعْرِفَة عِلْمٌ':Added, #1: 1	مَعْرِفَةَ الْعِلْمِ
u'مَعْرِفَةٌ علم':Added, #1: 1	مَعْرِفَةُ الْعِلْمِ
u'مَعْرِفَة علم':Added, #1: 1	مَعْرِفَةُ عِلْمِ
u'مَعْرِفَةٌ عِلْمٌ':Added, #1: 1	مَعْرِفَةُ عِلْمِ
u'مَعْرِفَة عِلْمٌ':Added, #1: 1	مَعْرِفَةُ عِلْمِ
u'مَعْرِفَةٌ علم':Added, #1: 1	مَعْرِفَةُ عِلْمِ
u'مَعْرِفَة علم':Added, #1: 1	مَعْرِفَةُ عِلْمِهِ
u'مَعْرِفَةٌ عِلْمٌ':Added, #1: 1	مَعْرِفَةُ عِلْمِهِ
u'مَعْرِفَة عِلْمٌ':Added, #1: 1	مَعْرِفَةُ عِلْمِهِ
u'مَعْرِفَةٌ علم':Added, #1: 1	مَعْرِفَةُ عِلْمِهِ
u'مَعْرِفَة علم':Added, #2: 2	مَعْرِفَةِ الْعِلْمِ
u'مَعْرِفَةٌ عِلْمٌ':Added, #2: 2	مَعْرِفَةِ الْعِلْمِ
u'مَعْرِفَة عِلْمٌ':Added, #2: 2	مَعْرِفَةِ الْعِلْمِ
u'مَعْرِفَةٌ عَمَلٌ':Added, #2: 2	مَعْرِفَةِ الْعِلْمِ
u'مَعْرِفَة عَمَلٌ':Added, #1: 1	مَعْرِفَةُ عَمَلٍ
u'مَعْرِفَةٌ عَمَلٌ':Added, #1: 1	مَعْرِفَةُ عَمَلٍ
u'مَعْرِفَة عَمَلٌ':Added, #2: 2	مَعْرِفَةِ الْعَمَلِ
u'مَعْرِفَةٌ عَيْبٌ':Added, #2: 2	مَعْرِفَةِ الْعَمَلِ
u'مَعْرِفَةٌ عَيْبٌ':Added, #1: 1	مَعْرِفَةُ الْعَيْبِ
u'مَعْرِفَة عَيْبٌ':Added, #1: 1	مَعْرِفَةِ الْعَيْبِ
u'مَعْرِفَة عَيْبٌ':Added, #1: 1	مَعْرِفَةُ الْعَيْبِ
u'مَعْرِفَةٌ عَيْبٌ':Added, #1: 1	مَعْرِفَةِ الْعَيْبِ
u'مَعْرِفَة عَيْبٌ':Added, #2: 2	مَعْرِفَةِ عَيْبِ
u'مَعْرِفَةٌ عين':Added, #2: 2	مَعْرِفَةِ عَيْبِ
u'مَعْرِفَةٌ عين':Added, #1: 1	مَعْرِفَةَ الْعَيْنِ
u'مَعْرِفَة عين':Added, #1: 1	مَعْرِفَةُ الْعَيْنِ
u'مَعْرِفَة عين':Added, #1: 1	مَعْرِفَةَ الْعَيْنِ
u'مَعْرِفَةٌ عَيْنٌ':Added, #1: 1	مَعْرِفَةُ الْعَيْنِ
u'مَعْرِفَةٌ عَيْنٌ':Added, #1: 1	مَعْرِفَةَ الْعَيْنِ
u'مَعْرِفَةٌ عَيْن':Added, #1: 1	مَعْرِفَةُ الْعَيْنِ
u'مَعْرِفَةٌ عَيْن':Added, #1: 1	مَعْرِفَةَ الْعَيْنِ
u'مَعْرِفَة عَيْنٌ':Added, #1: 1	مَعْرِفَةُ الْعَيْنِ
u'مَعْرِفَة عَيْنٌ':Added, #1: 1	مَعْرِفَةَ الْعَيْنِ
u'مَعْرِفَة عَيْن':Added, #1: 1	مَعْرِفَةُ الْعَيْنِ
u'مَعْرِفَة عَيْن':Added, #1: 1	مَعْرِفَةَ الْعَيْنِ
u'مَعْرِفَةٌ عين':Added, #1: 1	مَعْرِفَةُ الْعَيْنِ
u'مَعْرِفَة عين':Added, #1: 1	مَعْرِفَةُ عَيْنِهِ
u'مَعْرِفَةٌ عَيْنٌ':Added, #1: 1	مَعْرِفَةُ عَيْنِهِ
u'مَعْرِفَةٌ عَيْن':Added, #1: 1	مَعْرِفَةُ عَيْنِهِ
u'مَعْرِفَة عَيْنٌ':Added, #1: 1	مَعْرِفَةُ عَيْنِهِ
u'مَعْرِفَة عَيْن':Added, #1: 1	مَعْرِفَةُ عَيْنِهِ
u'مَعْرِفَةٌ عين':Added, #1: 1	مَعْرِفَةُ عَيْنِهِ
u'مَعْرِفَة عين':Added, #2: 2	مَعْرِفَةُ عَيْنِ
u'مَعْرِفَةٌ عَيْنٌ':Added, #2: 2	مَعْرِفَةُ عَيْنِ
u'مَعْرِفَةٌ عَيْن':Added, #2: 2	مَعْرِفَةُ عَيْنِ
u'مَعْرِفَة عَيْنٌ':Added, #2: 2	مَعْرِفَةُ عَيْنِ
u'مَعْرِفَة عَيْن':Added, #2: 2	مَعْرِفَةُ عَيْنِ
u'مَعْرِفَةٌ عين':Added, #2: 2	مَعْرِفَةُ عَيْنِ
u'مَعْرِفَة عين':Added, #3: 3	مَعْرِفَةِ عَيْنِ
u'مَعْرِفَةٌ عَيْنٌ':Added, #3: 3	مَعْرِفَةِ عَيْنِ
u'مَعْرِفَةٌ عَيْن':Added, #3: 3	مَعْرِفَةِ عَيْنِ
u'مَعْرِفَة عَيْنٌ':Added, #3: 3	مَعْرِفَةِ عَيْنِ
u'مَعْرِفَة عَيْن':Added, #3: 3	مَعْرِفَةِ عَيْنِ
u'مَعْرِفَةٌ عُيُوبٌ':Added, #3: 3	مَعْرِفَةِ عَيْنِ
u'مَعْرِفَة عُيُوبٌ':Added, #1: 1	مَعْرِفَةِ الْعُيُوبِ
u'مَعْرِفَةٌ عُيُوبٌ':Added, #1: 1	مَعْرِفَةِ الْعُيُوبِ
u'مَعْرِفَة عُيُوبٌ':Added, #1: 1	مَعْرِفَةِ عُيُوبِ
u'مَعْرِفَةٌ غَايَةٌ':Added, #1: 1	مَعْرِفَةِ عُيُوبِ
u'مَعْرِفَة غَايَةٌ':Added, #1: 1	مَعْرِفَةِ غَايَةِ
u'مَعْرِفَةٌ غَايَةٌ':Added, #1: 1	مَعْرِفَةِ غَايَةِ
u'مَعْرِفَةٌ غَايَةٌ':Added, #1: 1	مَعْرِفَةَ غَايَتِهِ
u'مَعْرِفَة غَايَةٌ':Added, #1: 1	مَعْرِفَةِ غَايَتِهِ
u'مَعْرِفَة غَايَةٌ':Added, #1: 1	مَعْرِفَةَ غَايَتِهِ
u'مَعْرِفَةٌ غَبْنٌ':Added, #1: 1	مَعْرِفَةِ غَايَتِهِ
u'مَعْرِفَةٌ غَبْنٌ':Added, #1: 1	مَعْرِفَةَ الْغَبْنِ
u'مَعْرِفَةٌ غَبْنٌ':Added, #1: 1	مَعْرِفَةُ الْغَبْنِ
u'مَعْرِفَة غَبْنٌ':Added, #1: 1	مَعْرِفَةِ الْغَبْنِ
u'مَعْرِفَة غَبْنٌ':Added, #1: 1	مَعْرِفَةَ الْغَبْنِ
u'مَعْرِفَة غَبْنٌ':Added, #1: 1	مَعْرِفَةُ الْغَبْنِ
u'مَعْرِفَةٌ غَرَضٌ':Added, #1: 1	مَعْرِفَةِ الْغَبْنِ
u'مَعْرِفَة غَرَضٌ':Added, #1: 1	مَعْرِفَةُ الْغَرَضِ
u'مَعْرِفَةٌ غِطَاءٌ':Added, #1: 1	مَعْرِفَةُ الْغَرَضِ
u'مَعْرِفَة غِطَاءٌ':Added, #1: 1	مَعْرِفَةُ غِطَاءِ
u'مَعْرِفَةٌ غناء':Added, #1: 1	مَعْرِفَةُ غِطَاءِ
u'مَعْرِفَة غناء':Added, #2: 2	مَعْرِفَةُ الْغِنَاءِ
u'مَعْرِفَةٌ غِنَاءٌ':Added, #2: 2	مَعْرِفَةُ الْغِنَاءِ
u'مَعْرِفَة غِنَاءٌ':Added, #2: 2	مَعْرِفَةُ الْغِنَاءِ
u'مَعْرِفَةٌ غَنِيٌّ':Added, #2: 2	مَعْرِفَةُ الْغِنَاءِ
u'مَعْرِفَة غَنِيٌّ':Added, #1: 1	مَعْرِفَةِ الْغَنِيِّ
u'مَعْرِفَةٌ غَوَامِضُ':Added, #1: 1	مَعْرِفَةِ الْغَنِيِّ
u'مَعْرِفَة غَوَامِضُ':Added, #12: 12	مَعْرِفَةِ غَوَامِضِ
u'مَعْرِفَةٌ فَائِدَةٌ':Added, #12: 12	مَعْرِفَةِ غَوَامِضِ
u'مَعْرِفَة فَائِدَةٌ':Added, #1: 1	مَعْرِفَةُ فَائِدَةِ
u'مَعْرِفَةٌ فراغ':Added, #1: 1	مَعْرِفَةُ فَائِدَةِ
u'مَعْرِفَة فراغ':Added, #1: 1	مَعْرِفَةَ فَرَاغِهِ
u'مَعْرِفَةٌ فَرَاغٌ':Added, #1: 1	مَعْرِفَةَ فَرَاغِهِ
u'مَعْرِفَة فَرَاغٌ':Added, #1: 1	مَعْرِفَةَ فَرَاغِهِ
u'مَعْرِفَةٌ فَرَائِضُ':Added, #1: 1	مَعْرِفَةَ فَرَاغِهِ
u'مَعْرِفَة فَرَائِضُ':Added, #1: 1	مَعْرِفَةِ الْفَرَائِضِ
u'مَعْرِفَةٌ فرق':Added, #1: 1	مَعْرِفَةِ الْفَرَائِضِ
u'مَعْرِفَةٌ فرق':Added, #1: 1	مَعْرِفَةُ الْفَرْقِ
u'مَعْرِفَة فرق':Added, #1: 1	مَعْرِفَةِ الْفَرْقِ
u'مَعْرِفَة فرق':Added, #1: 1	مَعْرِفَةُ الْفَرْقِ
u'مَعْرِفَةٌ فَرْقٌ':Added, #1: 1	مَعْرِفَةِ الْفَرْقِ
u'مَعْرِفَةٌ فَرْقٌ':Added, #1: 1	مَعْرِفَةُ الْفَرْقِ
u'مَعْرِفَة فَرْقٌ':Added, #1: 1	مَعْرِفَةِ الْفَرْقِ
u'مَعْرِفَة فَرْقٌ':Added, #1: 1	مَعْرِفَةُ الْفَرْقِ
u'مَعْرِفَةٌ فُرُوعٌ':Added, #1: 1	مَعْرِفَةِ الْفَرْقِ
u'مَعْرِفَة فُرُوعٌ':Added, #1: 1	مَعْرِفَةِ الْفُرُوعِ
u'مَعْرِفَةٌ فُرُوعٌ':Added, #1: 1	مَعْرِفَةِ الْفُرُوعِ
u'مَعْرِفَة فُرُوعٌ':Added, #2: 2	مَعْرِفَةِ فُرُوعِ
u'مَعْرِفَةٌ فِسْقٌ':Added, #2: 2	مَعْرِفَةِ فُرُوعِ
u'مَعْرِفَة فِسْقٌ':Added, #1: 1	مَعْرِفَةِ الْفِسْقِ
u'مَعْرِفَةٌ فَصْلٌ':Added, #1: 1	مَعْرِفَةِ الْفِسْقِ
u'مَعْرِفَة فَصْلٌ':Added, #1: 1	مَعْرِفَةُ الْفَصْلِ
u'مَعْرِفَةٌ فَصْلٌ':Added, #1: 1	مَعْرِفَةُ الْفَصْلِ
u'مَعْرِفَة فَصْلٌ':Added, #1: 1	مَعْرِفَةِ فَصْلَيْنِ
u'مَعْرِفَةٌ فِقْهٌ':Added, #1: 1	مَعْرِفَةِ فَصْلَيْنِ
u'مَعْرِفَة فِقْهٌ':Added, #1: 1	مَعْرِفَةُ فِقْهِ
u'مَعْرِفَةٌ فِقْهٌ':Added, #1: 1	مَعْرِفَةُ فِقْهِ
u'مَعْرِفَة فِقْهٌ':Added, #2: 2	مَعْرِفَةُ الْفِقْهِ
u'مَعْرِفَةٌ فِقْهٌ':Added, #2: 2	مَعْرِفَةُ الْفِقْهِ
u'مَعْرِفَة فِقْهٌ':Added, #5: 5	مَعْرِفَةِ الْفِقْهِ
u'مَعْرِفَةٌ فلان':Added, #5: 5	مَعْرِفَةِ الْفِقْهِ
u'مَعْرِفَة فلان':Added, #1: 1	مَعْرِفَةِ الْمَرْوِيِّ
u'مَعْرِفَةٌ فُلاَنٌ':Added, #1: 1	مَعْرِفَةِ الْمَرْوِيِّ
u'مَعْرِفَة فُلاَنٌ':Added, #2: 2	مَعْرِفَةُ فُلَانٍ
u'مَعْرِفَةٌ قَابِضٌ':Added, #2: 2	مَعْرِفَةُ فُلَانٍ
u'مَعْرِفَة قَابِضٌ':Added, #2: 2	مَعْرِفَةَ الْقَابِضِ
u'مَعْرِفَةٌ قَاتِلٌ':Added, #2: 2	مَعْرِفَةَ الْقَابِضِ
u'مَعْرِفَة قَاتِلٌ':Added, #1: 1	مَعْرِفَةِ الْقَاتِلِ
u'مَعْرِفَةٌ قَاعِدٌ':Added, #1: 1	مَعْرِفَةِ الْقَاتِلِ
u'مَعْرِفَة قَاعِدٌ':Added, #1: 1	مَعْرِفَةِ الْقَاعِدَةِ
u'مَعْرِفَةٌ قُبْحٌ':Added, #1: 1	مَعْرِفَةِ الْقَاعِدَةِ
u'مَعْرِفَة قُبْحٌ':Added, #1: 1	مَعْرِفَةِ قُبْحِ
u'مَعْرِفَةٌ قِبْلَةٌ':Added, #1: 1	مَعْرِفَةِ قُبْحِ
u'مَعْرِفَة قِبْلَةٌ':Added, #1: 1	مَعْرِفَةُ الْقِبْلَةِ
u'مَعْرِفَةٌ قِبْلَةٌ':Added, #1: 1	مَعْرِفَةُ الْقِبْلَةِ
u'مَعْرِفَة قِبْلَةٌ':Added, #5: 5	مَعْرِفَةِ الْقِبْلَةِ
u'مَعْرِفَةٌ قَدْرٌ':Added, #5: 5	مَعْرِفَةِ الْقِبْلَةِ
u'مَعْرِفَة قَدْرٌ':Added, #1: 1	مَعْرِفَةَ قَدْرِهِ
u'مَعْرِفَةٌ قَدْرٌ':Added, #1: 1	مَعْرِفَةَ قَدْرِهِ
u'مَعْرِفَة قَدْرٌ':Added, #2: 2	مَعْرِفَةُ الْقَدْرِ
u'مَعْرِفَةٌ قَدْرٌ':Added, #2: 2	مَعْرِفَةُ الْقَدْرِ
u'مَعْرِفَة قَدْرٌ':Added, #2: 2	مَعْرِفَةَ قَدْرِ
u'مَعْرِفَةٌ قَدْرٌ':Added, #2: 2	مَعْرِفَةَ قَدْرِ
u'مَعْرِفَة قَدْرٌ':Added, #3: 3	مَعْرِفَةُ قَدْرِهِ
u'مَعْرِفَةٌ قَدْرٌ':Added, #3: 3	مَعْرِفَةُ قَدْرِهِ
u'مَعْرِفَة قَدْرٌ':Added, #4: 4	مَعْرِفَةِ الْقَدْرِ
u'مَعْرِفَةٌ قَدْرٌ':Added, #4: 4	مَعْرِفَةِ الْقَدْرِ
u'مَعْرِفَة قَدْرٌ':Added, #5: 5	مَعْرِفَةِ قَدْرِهِ
u'مَعْرِفَةٌ قَدْرٌ':Added, #5: 5	مَعْرِفَةِ قَدْرِهِ
u'مَعْرِفَة قَدْرٌ':Added, #6: 6	مَعْرِفَةُ قَدْرِ
u'مَعْرِفَةٌ قَدْرٌ':Added, #6: 6	مَعْرِفَةُ قَدْرِ
u'مَعْرِفَة قَدْرٌ':Added, #8: 8	مَعْرِفَةِ قَدْرِ
u'مَعْرِفَةٌ قدرة':Added, #8: 8	مَعْرِفَةِ قَدْرِ
u'مَعْرِفَة قدرة':Added, #1: 1	مَعْرِفَةُ قُدْرَتِهِ
u'مَعْرِفَةٌ قُدْرَةٌ':Added, #1: 1	مَعْرِفَةُ قُدْرَتِهِ
u'مَعْرِفَة قُدْرَةٌ':Added, #1: 1	مَعْرِفَةُ قُدْرَتِهِ
u'مَعْرِفَةٌ قَدِيمٌ':Added, #1: 1	مَعْرِفَةُ قُدْرَتِهِ
u'مَعْرِفَة قَدِيمٌ':Added, #1: 1	مَعْرِفَةُ الْقَدِيمِ
u'مَعْرِفَةٌ قِرَاءةٌ':Added, #1: 1	مَعْرِفَةُ الْقَدِيمِ
u'مَعْرِفَة قِرَاءةٌ':Added, #1: 1	مَعْرِفَةِ قِرَاءَتِهِ
u'مَعْرِفَةٌ قَرَابَةٌ':Added, #1: 1	مَعْرِفَةِ قِرَاءَتِهِ
u'مَعْرِفَة قَرَابَةٌ':Added, #1: 1	مَعْرِفَةِ الْقَرَابَةِ
u'مَعْرِفَةٌ قُرْبٌ':Added, #1: 1	مَعْرِفَةِ الْقَرَابَةِ
u'مَعْرِفَة قُرْبٌ':Added, #1: 1	مَعْرِفَةَ الْقُرْبِ
u'مَعْرِفَةٌ قِسْطٌ':Added, #1: 1	مَعْرِفَةَ الْقُرْبِ
u'مَعْرِفَة قِسْطٌ':Added, #1: 1	مَعْرِفَةِ الْقِسْطِ
u'مَعْرِفَةٌ قَصْدٌ':Added, #1: 1	مَعْرِفَةِ الْقِسْطِ
u'مَعْرِفَة قَصْدٌ':Added, #1: 1	مَعْرِفَةَ قَصْدِ
u'مَعْرِفَةٌ قضاة':Added, #1: 1	مَعْرِفَةَ قَصْدِ
u'مَعْرِفَة قضاة':Added, #1: 1	مَعْرِفَةَ الْقُضَاةِ
u'مَعْرِفَةٌ قَوَاعِدُ':Added, #1: 1	مَعْرِفَةَ الْقُضَاةِ
u'مَعْرِفَة قَوَاعِدُ':Added, #1: 1	مَعْرِفَةِ قَوَاعِدِ
u'مَعْرِفَةٌ قول':Added, #1: 1	مَعْرِفَةِ قَوَاعِدِ
u'مَعْرِفَةٌ قول':Added, #1: 1	مَعْرِفَةُ قَوْلِ
u'مَعْرِفَة قول':Added, #1: 1	مَعْرِفَةِ قَوْلِ
u'مَعْرِفَة قول':Added, #1: 1	مَعْرِفَةُ قَوْلِ
u'مَعْرِفَةٌ قَوْلٌ':Added, #1: 1	مَعْرِفَةِ قَوْلِ
u'مَعْرِفَةٌ قَوْلٌ':Added, #1: 1	مَعْرِفَةُ قَوْلِ
u'مَعْرِفَة قَوْلٌ':Added, #1: 1	مَعْرِفَةِ قَوْلِ
u'مَعْرِفَة قَوْلٌ':Added, #1: 1	مَعْرِفَةُ قَوْلِ
u'مَعْرِفَةٌ قول':Added, #1: 1	مَعْرِفَةِ قَوْلِ
u'مَعْرِفَة قول':Added, #1: 1	مَعْرِفَةِ قَوْلِهِ
u'مَعْرِفَةٌ قَوْلٌ':Added, #1: 1	مَعْرِفَةِ قَوْلِهِ
u'مَعْرِفَة قَوْلٌ':Added, #1: 1	مَعْرِفَةِ قَوْلِهِ
u'مَعْرِفَةٌ قِيَاسٌ':Added, #1: 1	مَعْرِفَةِ قَوْلِهِ
u'مَعْرِفَة قِيَاسٌ':Added, #3: 3	مَعْرِفَةِ الْقِيَاسِ
u'مَعْرِفَةٌ قِيمَةٌ':Added, #3: 3	مَعْرِفَةِ الْقِيَاسِ
u'مَعْرِفَة قِيمَةٌ':Added, #1: 1	مَعْرِفَةِ الْقِيمَةِ
u'مَعْرِفَةٌ قِيمَةٌ':Added, #1: 1	مَعْرِفَةِ الْقِيمَةِ
u'مَعْرِفَة قِيمَةٌ':Added, #1: 1	مَعْرِفَةَ قِيمَةِ
u'مَعْرِفَةٌ قِيمَةٌ':Added, #1: 1	مَعْرِفَةَ قِيمَةِ
u'مَعْرِفَة قِيمَةٌ':Added, #1: 1	مَعْرِفَةَ قِيمَتِهِ
u'مَعْرِفَةٌ قِيمَةٌ':Added, #1: 1	مَعْرِفَةَ قِيمَتِهِ
u'مَعْرِفَة قِيمَةٌ':Added, #2: 2	مَعْرِفَةُ قِيمَتِهِ
u'مَعْرِفَةٌ قِيمَةٌ':Added, #2: 2	مَعْرِفَةُ قِيمَتِهِ
u'مَعْرِفَة قِيمَةٌ':Added, #3: 3	مَعْرِفَةِ قِيمَتِهِ
u'مَعْرِفَةٌ قِيمَةٌ':Added, #3: 3	مَعْرِفَةِ قِيمَتِهِ
u'مَعْرِفَة قِيمَةٌ':Added, #5: 5	مَعْرِفَةِ قِيمَةِ
u'مَعْرِفَةٌ كبائر':Added, #5: 5	مَعْرِفَةِ قِيمَةِ
u'مَعْرِفَة كبائر':Added, #1: 1	مَعْرِفَةِ الْكَبَائِرِ
u'مَعْرِفَةٌ كِتَابٌ':Added, #1: 1	مَعْرِفَةِ الْكَبَائِرِ
u'مَعْرِفَةٌ كِتَابٌ':Added, #1: 1	مَعْرِفَةُ الْكِتَابِ
u'مَعْرِفَة كِتَابٌ':Added, #1: 1	مَعْرِفَةِ الْكِتَابِ
u'مَعْرِفَة كِتَابٌ':Added, #1: 1	مَعْرِفَةُ الْكِتَابِ
u'مَعْرِفَةٌ كِتَابَةٌ':Added, #1: 1	مَعْرِفَةِ الْكِتَابِ
u'مَعْرِفَة كِتَابَةٌ':Added, #2: 2	مَعْرِفَةِ الْكِتَابَةِ
u'مَعْرِفَةٌ كَرٌّ':Added, #2: 2	مَعْرِفَةِ الْكِتَابَةِ
u'مَعْرِفَة كَرٌّ':Added, #1: 1	مَعْرِفَةِ الْكَرِّ
u'مَعْرِفَةٌ كفر':Added, #1: 1	مَعْرِفَةِ الْكَرِّ
u'مَعْرِفَة كفر':Added, #1: 1	مَعْرِفَةِ الْكُفْرِ
u'مَعْرِفَةٌ كُفْرٌ':Added, #1: 1	مَعْرِفَةِ الْكُفْرِ
u'مَعْرِفَة كُفْرٌ':Added, #1: 1	مَعْرِفَةِ الْكُفْرِ
u'مَعْرِفَةٌ كَفِيلٌ':Added, #1: 1	مَعْرِفَةِ الْكُفْرِ
u'مَعْرِفَةٌ كَفِيلٌ':Added, #1: 1	مَعْرِفَةَ الْكَفِيلِ
u'مَعْرِفَة كَفِيلٌ':Added, #1: 1	مَعْرِفَةِ الْكَفِيلِ
u'مَعْرِفَة كَفِيلٌ':Added, #1: 1	مَعْرِفَةَ الْكَفِيلِ
u'مَعْرِفَةٌ كَلاَمٌ':Added, #1: 1	مَعْرِفَةِ الْكَفِيلِ
u'مَعْرِفَة كَلاَمٌ':Added, #1: 1	مَعْرِفَةِ كَلَامِ
u'مَعْرِفَةٌ كَلاَمٌ':Added, #1: 1	مَعْرِفَةِ كَلَامِ
u'مَعْرِفَة كَلاَمٌ':Added, #4: 4	مَعْرِفَةِ الْكَلَامِ
u'مَعْرِفَةٌ كَمِّيٌّ':Added, #4: 4	مَعْرِفَةِ الْكَلَامِ
u'مَعْرِفَة كَمِّيٌّ':Added, #1: 1	مَعْرِفَةِ كَمِّيَّةِ
u'مَعْرِفَةٌ كَمِّيٌّ':Added, #1: 1	مَعْرِفَةِ كَمِّيَّةِ
u'مَعْرِفَة كَمِّيٌّ':Added, #1: 1	مَعْرِفَةِ كَمِّيَّتِهِ
u'مَعْرِفَةٌ كُنْهٌ':Added, #1: 1	مَعْرِفَةِ كَمِّيَّتِهِ
u'مَعْرِفَة كُنْهٌ':Added, #1: 1	مَعْرِفَةِ كُنْهِ
u'مَعْرِفَةٌ كَوْنٌ':Added, #1: 1	مَعْرِفَةِ كُنْهِ
u'مَعْرِفَة كَوْنٌ':Added, #1: 1	مَعْرِفَةُ كَوْنِ
u'مَعْرِفَةٌ كَوْنٌ':Added, #1: 1	مَعْرِفَةُ كَوْنِ
u'مَعْرِفَة كَوْنٌ':Added, #2: 2	مَعْرِفَةُ كَوْنِهِ
u'مَعْرِفَةٌ كَوْنٌ':Added, #2: 2	مَعْرِفَةُ كَوْنِهِ
u'مَعْرِفَة كَوْنٌ':Added, #3: 3	مَعْرِفَةَ كَوْنِ
u'مَعْرِفَةٌ كَوْنٌ':Added, #3: 3	مَعْرِفَةَ كَوْنِ
u'مَعْرِفَة كَوْنٌ':Added, #4: 4	مَعْرِفَةِ كَوْنِهِ
u'مَعْرِفَةٌ كَيْفِيَّةٌ':Added, #4: 4	مَعْرِفَةِ كَوْنِهِ
u'مَعْرِفَةٌ كَيْفِيَّةٌ':Added, #1: 1	مَعْرِفَةَ كَيْفِيَّةِ
u'مَعْرِفَة كَيْفِيَّةٌ':Added, #1: 1	مَعْرِفَةُ كَيْفِيَّةِ
u'مَعْرِفَة كَيْفِيَّةٌ':Added, #1: 1	مَعْرِفَةَ كَيْفِيَّةِ
u'مَعْرِفَةٌ كَيْفِيَّةٌ':Added, #1: 1	مَعْرِفَةُ كَيْفِيَّةِ
u'مَعْرِفَة كَيْفِيَّةٌ':Added, #4: 4	مَعْرِفَةِ كَيْفِيَّةِ
u'مَعْرِفَةٌ كَيْلٌ':Added, #4: 4	مَعْرِفَةِ كَيْفِيَّةِ
u'مَعْرِفَة كَيْلٌ':Added, #1: 1	مَعْرِفَةِ كَيْلٍ
u'مَعْرِفَةٌ لِسَانٌ':Added, #1: 1	مَعْرِفَةِ كَيْلٍ
u'مَعْرِفَة لِسَانٌ':Added, #1: 1	مَعْرِفَةِ اللِّسَانِ
u'مَعْرِفَةٌ لِسَانٌ':Added, #1: 1	مَعْرِفَةِ اللِّسَانِ
u'مَعْرِفَةٌ لِسَانٌ':Added, #1: 1	مَعْرِفَةُ لِسَانِ
u'مَعْرِفَة لِسَانٌ':Added, #1: 1	مَعْرِفَةِ لِسَانِ
u'مَعْرِفَة لِسَانٌ':Added, #1: 1	مَعْرِفَةُ لِسَانِ
u'مَعْرِفَةٌ لُغَةٌ':Added, #1: 1	مَعْرِفَةِ لِسَانِ
u'مَعْرِفَة لُغَةٌ':Added, #1: 1	مَعْرِفَةِ لُغَتِهِ
u'مَعْرِفَةٌ لُغَةٌ':Added, #1: 1	مَعْرِفَةِ لُغَتِهِ
u'مَعْرِفَة لُغَةٌ':Added, #2: 2	مَعْرِفَةِ اللُّغَاتِ
u'مَعْرِفَةٌ لُغَةٌ':Added, #2: 2	مَعْرِفَةِ اللُّغَاتِ
u'مَعْرِفَة لُغَةٌ':Added, #4: 4	مَعْرِفَةِ اللُّغَةِ
u'مَعْرِفَةٌ مَالٌ':Added, #4: 4	مَعْرِفَةِ اللُّغَةِ
u'مَعْرِفَةٌ مَالٌ':Added, #1: 1	مَعْرِفَةَ الْمَالِ
u'مَعْرِفَةٌ مَالٌ':Added, #1: 1	مَعْرِفَةُ الْمَالِ
u'مَعْرِفَة مَالٌ':Added, #1: 1	مَعْرِفَةِ الْمَالِ
u'مَعْرِفَة مَالٌ':Added, #1: 1	مَعْرِفَةَ الْمَالِ
u'مَعْرِفَة مَالٌ':Added, #1: 1	مَعْرِفَةُ الْمَالِ
u'مَعْرِفَةٌ مَالِكٌ':Added, #1: 1	مَعْرِفَةِ الْمَالِ
u'مَعْرِفَةٌ مَالِكٌ':Added, #1: 1	مَعْرِفَةَ الْمَالِكِ
u'مَعْرِفَة مَالِكٌ':Added, #1: 1	مَعْرِفَةِ الْمَالِكِ
u'مَعْرِفَة مَالِكٌ':Added, #1: 1	مَعْرِفَةَ الْمَالِكِ
u'مَعْرِفَةٌ مَالِكٌ':Added, #1: 1	مَعْرِفَةِ الْمَالِكِ
u'مَعْرِفَة مَالِكٌ':Added, #4: 4	مَعْرِفَةِ مَالِكِهِ
u'مَعْرِفَةٌ مَالِيٌّ':Added, #4: 4	مَعْرِفَةِ مَالِكِهِ
u'مَعْرِفَة مَالِيٌّ':Added, #2: 2	مَعْرِفَةِ الْمَالِيَّةِ
u'مَعْرِفَةٌ مَبِيعٌ':Added, #2: 2	مَعْرِفَةِ الْمَالِيَّةِ
u'مَعْرِفَة مَبِيعٌ':Added, #2: 2	مَعْرِفَةِ الْمَبِيعِ
u'مَعْرِفَةٌ مَبِيعٌ':Added, #2: 2	مَعْرِفَةِ الْمَبِيعِ
u'مَعْرِفَة مَبِيعٌ':Added, #3: 3	مَعْرِفَةُ الْمَبِيعِ
u'مَعْرِفَةٌ مَتَاعٌ':Added, #3: 3	مَعْرِفَةُ الْمَبِيعِ
u'مَعْرِفَة مَتَاعٌ':Added, #1: 1	مَعْرِفَةُ الْمَتَاعِ
u'مَعْرِفَةٌ مُتَّفَقٌ':Added, #1: 1	مَعْرِفَةُ الْمَتَاعِ
u'مَعْرِفَة مُتَّفَقٌ':Added, #1: 1	مَعْرِفَةُ الْمُتَّفَقِ
u'مَعْرِفَةٌ مُتَوَاتِرٌ':Added, #1: 1	مَعْرِفَةُ الْمُتَّفَقِ
u'مَعْرِفَة مُتَوَاتِرٌ':Added, #1: 1	مَعْرِفَةِ الْمُتَوَاتِرِ
u'مَعْرِفَةٌ مُثْبَتٌ':Added, #1: 1	مَعْرِفَةِ الْمُتَوَاتِرِ
u'مَعْرِفَة مُثْبَتٌ':Added, #1: 1	مَعْرِفَةُ الْمُثْبَتِ
u'مَعْرِفَةٌ مثل':Added, #1: 1	مَعْرِفَةُ الْمُثْبَتِ
u'مَعْرِفَة مثل':Added, #1: 1	مَعْرِفَةِ مِثْلِهِ
u'مَعْرِفَةٌ مِثْلٌ':Added, #1: 1	مَعْرِفَةِ مِثْلِهِ
u'مَعْرِفَة مِثْلٌ':Added, #1: 1	مَعْرِفَةِ مِثْلِهِ
u'مَعْرِفَةٌ مُثَمَّنٌ':Added, #1: 1	مَعْرِفَةِ مِثْلِهِ
u'مَعْرِفَة مُثَمَّنٌ':Added, #1: 1	مَعْرِفَةُ الْمُثَمَّنِ
u'مَعْرِفَةٌ مَجَازٌ':Added, #1: 1	مَعْرِفَةُ الْمُثَمَّنِ
u'مَعْرِفَة مَجَازٌ':Added, #1: 1	مَعْرِفَةِ الْمَجَازِ
u'مَعْرِفَةٌ مُجْتَهِد':Added, #1: 1	مَعْرِفَةِ الْمَجَازِ
u'مَعْرِفَة مُجْتَهِد':Added, #1: 1	مَعْرِفَةِ الْمُجْتَهِدِ
u'مَعْرِفَةٌ مَجْهُولٌ':Added, #1: 1	مَعْرِفَةِ الْمُجْتَهِدِ
u'مَعْرِفَة مَجْهُولٌ':Added, #1: 1	مَعْرِفَةُ الْمَجْهُولِ
u'مَعْرِفَةٌ مُحَاذَاةٌ':Added, #1: 1	مَعْرِفَةُ الْمَجْهُولِ
u'مَعْرِفَة مُحَاذَاةٌ':Added, #1: 1	مَعْرِفَةُ الْمُحَاذَاةِ
u'مَعْرِفَةٌ مَحَالٌّ':Added, #1: 1	مَعْرِفَةُ الْمُحَاذَاةِ
u'مَعْرِفَةٌ مَحَالُّ':Added, #1: 1	مَعْرِفَةُ مَحَالِّ
u'مَعْرِفَة مَحَالٌّ':Added, #1: 1	مَعْرِفَةُ مَحَالِّ
u'مَعْرِفَة مَحَالُّ':Added, #1: 1	مَعْرِفَةُ مَحَالِّ
u'مَعْرِفَةٌ مَحْدُودٌ':Added, #1: 1	مَعْرِفَةُ مَحَالِّ
u'مَعْرِفَة مَحْدُودٌ':Added, #1: 1	مَعْرِفَةُ الْمَحْدُودِ
u'مَعْرِفَةٌ مُحَرَّمٌ':Added, #1: 1	مَعْرِفَةُ الْمَحْدُودِ
u'مَعْرِفَة مُحَرَّمٌ':Added, #1: 1	مَعْرِفَةُ الْمُحَرَّمِ
u'مَعْرِفَةٌ مَحْض':Added, #1: 1	مَعْرِفَةُ الْمُحَرَّمِ
u'مَعْرِفَة مَحْض':Added, #1: 1	مَعْرِفَةٍ مَحْضَةٍ
u'مَعْرِفَةٌ مُحْكَمٌ':Added, #1: 1	مَعْرِفَةٍ مَحْضَةٍ
u'مَعْرِفَة مُحْكَمٌ':Added, #1: 1	مَعْرِفَةَ الْمُحْكَمِ
u'مَعْرِفَةٌ مَحْكُومٌ':Added, #1: 1	مَعْرِفَةَ الْمُحْكَمِ
u'مَعْرِفَة مَحْكُومٌ':Added, #1: 1	مَعْرِفَةُ الْمَحْكُومِ
u'مَعْرِفَةٌ مَحَلٌّ':Added, #1: 1	مَعْرِفَةُ الْمَحْكُومِ
u'مَعْرِفَة مَحَلٌّ':Added, #1: 1	مَعْرِفَةِ مَحَلِّ
u'مَعْرِفَةٌ مَحَلٌّ':Added, #1: 1	مَعْرِفَةِ مَحَلِّ
u'مَعْرِفَة مَحَلٌّ':Added, #1: 1	مَعْرِفَةَ مَحَلِّهِ
u'مَعْرِفَةٌ مَحْمَلٌ':Added, #1: 1	مَعْرِفَةَ مَحَلِّهِ
u'مَعْرِفَة مَحْمَلٌ':Added, #1: 1	مَعْرِفَةُ الْمَحْمَلِ
u'مَعْرِفَةٌ مَدَاخِلُ':Added, #1: 1	مَعْرِفَةُ الْمَحْمَلِ
u'مَعْرِفَة مَدَاخِلُ':Added, #1: 1	مَعْرِفَةُ مَدَاخِلِهِ
u'مَعْرِفَةٌ مُدَّةٌ':Added, #1: 1	مَعْرِفَةُ مَدَاخِلِهِ
u'مَعْرِفَةٌ مُدَّةٌ':Added, #1: 1	مَعْرِفَة مُدَّةِ
u'مَعْرِفَةٌ مُدَّةٌ':Added, #1: 1	مَعْرِفَةُ مُدَّةِ
u'مَعْرِفَة مُدَّةٌ':Added, #1: 1	مَعْرِفَةِ مُدَّةِ
u'مَعْرِفَة مُدَّةٌ':Added, #1: 1	مَعْرِفَة مُدَّةِ
u'مَعْرِفَة مُدَّةٌ':Added, #1: 1	مَعْرِفَةُ مُدَّةِ
u'مَعْرِفَةٌ مُدَّةٌ':Added, #1: 1	مَعْرِفَةِ مُدَّةِ
u'مَعْرِفَة مُدَّةٌ':Added, #1: 1	مَعْرِفَةُ مُدَّتِهِ
u'مَعْرِفَةٌ مَدْلُولٌ':Added, #1: 1	مَعْرِفَةُ مُدَّتِهِ
u'مَعْرِفَة مَدْلُولٌ':Added, #1: 1	مَعْرِفَةَ الْمَدْلُولِ
u'مَعْرِفَةٌ مَذْهَبٌ':Added, #1: 1	مَعْرِفَةَ الْمَدْلُولِ
u'مَعْرِفَة مَذْهَبٌ':Added, #1: 1	مَعْرِفَةُ مَذْهَبِ
u'مَعْرِفَةٌ مَذْهَبٌ':Added, #1: 1	مَعْرِفَةُ مَذْهَبِ
u'مَعْرِفَة مَذْهَبٌ':Added, #3: 3	مَعْرِفَةِ الْمَذْهَبِ
u'مَعْرِفَةٌ مراد':Added, #3: 3	مَعْرِفَةِ الْمَذْهَبِ
u'مَعْرِفَة مراد':Added, #1: 1	مَعْرِفَةُ الْمُرَادِ
u'مَعْرِفَةٌ مُرَادٌ':Added, #1: 1	مَعْرِفَةُ الْمُرَادِ
u'مَعْرِفَة مُرَادٌ':Added, #1: 1	مَعْرِفَةُ الْمُرَادِ
u'مَعْرِفَةٌ مراد':Added, #1: 1	مَعْرِفَةُ الْمُرَادِ
u'مَعْرِفَة مراد':Added, #1: 1	مَعْرِفَةُ مُرَادِ
u'مَعْرِفَةٌ مُرَادٌ':Added, #1: 1	مَعْرِفَةُ مُرَادِ
u'مَعْرِفَة مُرَادٌ':Added, #1: 1	مَعْرِفَةُ مُرَادِ
u'مَعْرِفَةٌ مَرْوِيّ':Added, #1: 1	مَعْرِفَةُ مُرَادِ
u'مَعْرِفَة مَرْوِيّ':Added, #1: 1	مَعْرِفَةِ الْمَرْوِيِّ
u'مَعْرِفَةٌ مَسَائِلُ':Added, #1: 1	مَعْرِفَةِ الْمَرْوِيِّ
u'مَعْرِفَة مَسَائِلُ':Added, #1: 1	مَعْرِفَةُ الْمَسَائِلِ
u'مَعْرِفَةٌ مُسْتَأْجِرٌ':Added, #1: 1	مَعْرِفَةُ الْمَسَائِلِ
u'مَعْرِفَة مُسْتَأْجِرٌ':Added, #1: 1	مَعْرِفَةُ الْمُسْتَأْجِرِ
u'مَعْرِفَةٌ مُسْتَحِقٌّ':Added, #1: 1	مَعْرِفَةُ الْمُسْتَأْجِرِ
u'مَعْرِفَة مُسْتَحِقٌّ':Added, #1: 1	مَعْرِفَةَ مُسْتَحِقِّهِ
u'مَعْرِفَةٌ مَسْكُوتٌ':Added, #1: 1	مَعْرِفَةَ مُسْتَحِقِّهِ
u'مَعْرِفَة مَسْكُوتٌ':Added, #1: 1	مَعْرِفَةِ الْمَسْكُوتِ
u'مَعْرِفَةٌ مُشَاهَدٌ':Added, #1: 1	مَعْرِفَةِ الْمَسْكُوتِ
u'مَعْرِفَة مُشَاهَدٌ':Added, #1: 1	مَعْرِفَةِ الْمُشَاهَدَةِ
u'مَعْرِفَةٌ مُشَاهَدَةٌ':Added, #1: 1	مَعْرِفَةِ الْمُشَاهَدَةِ
u'مَعْرِفَة مُشَاهَدَةٌ':Added, #1: 1	مَعْرِفَةِ الْمُشَاهَدَةِ
u'مَعْرِفَةٌ مَشْرُوعِيَّةٌ':Added, #1: 1	مَعْرِفَةِ الْمُشَاهَدَةِ
u'مَعْرِفَة مَشْرُوعِيَّةٌ':Added, #1: 1	مَعْرِفَةِ مَشْرُوعِيَّةِ
u'مَعْرِفَةٌ مَشْهُودٌ':Added, #1: 1	مَعْرِفَةِ مَشْرُوعِيَّةِ
u'مَعْرِفَة مَشْهُودٌ':Added, #1: 1	مَعْرِفَةُ الْمَشْهُودِ
u'مَعْرِفَةٌ مُصْطَلَحٌ':Added, #1: 1	مَعْرِفَةُ الْمَشْهُودِ
u'مَعْرِفَة مُصْطَلَحٌ':Added, #1: 1	مَعْرِفَةُ الْمُصْطَلَحِ
u'مَعْرِفَةٌ مُضَافٌ':Added, #1: 1	مَعْرِفَةُ الْمُصْطَلَحِ
u'مَعْرِفَة مُضَافٌ':Added, #1: 1	مَعْرِفَةِ الْمُضَافِ
u'مَعْرِفَةٌ مَضْمُونٌ':Added, #1: 1	مَعْرِفَةِ الْمُضَافِ
u'مَعْرِفَة مَضْمُونٌ':Added, #1: 1	مَعْرِفَةَ الْمَضْمُونِ
u'مَعْرِفَةٌ مَضْمُونٌ':Added, #1: 1	مَعْرِفَةَ الْمَضْمُونِ
u'مَعْرِفَة مَضْمُونٌ':Added, #2: 2	مَعْرِفَةِ الْمَضْمُونِ
u'مَعْرِفَةٌ مَضْمُونٌ':Added, #2: 2	مَعْرِفَةِ الْمَضْمُونِ
u'مَعْرِفَة مَضْمُونٌ':Added, #3: 3	مَعْرِفَةُ الْمَضْمُونِ
u'مَعْرِفَةٌ مُطَابِقٌ':Added, #3: 3	مَعْرِفَةُ الْمَضْمُونِ
u'مَعْرِفَة مُطَابِقٌ':Added, #1: 1	مَعْرِفَةِ الْمُطَابِقَةِ
u'مَعْرِفَةٌ مُطَابَقَةٌ':Added, #1: 1	مَعْرِفَةِ الْمُطَابِقَةِ
u'مَعْرِفَة مُطَابَقَةٌ':Added, #1: 1	مَعْرِفَةِ الْمُطَابَقَةِ
u'مَعْرِفَةٌ مُطْلَقٌ':Added, #1: 1	مَعْرِفَةِ الْمُطَابَقَةِ
u'مَعْرِفَة مُطْلَقٌ':Added, #1: 1	مَعْرِفَةُ مُطْلَقِ
u'مَعْرِفَةٌ مُعَامَلَةٌ':Added, #1: 1	مَعْرِفَةُ مُطْلَقِ
u'مَعْرِفَة مُعَامَلَةٌ':Added, #1: 1	مَعْرِفَةُ مُعَامَلَتِهِ
u'مَعْرِفَةٌ مَعْبُودٌ':Added, #1: 1	مَعْرِفَةُ مُعَامَلَتِهِ
u'مَعْرِفَة مَعْبُودٌ':Added, #1: 1	مَعْرِفَةِ الْمَعْبُودِ
u'مَعْرِفَةٌ مُعْجِزٌ':Added, #1: 1	مَعْرِفَةِ الْمَعْبُودِ
u'مَعْرِفَةٌ مُعْجِزٌ':Added, #1: 1	مَعْرِفَةُ الْمُعْجِزِ
u'مَعْرِفَة مُعْجِزٌ':Added, #1: 1	مَعْرِفَةِ الْمُعْجِزِ
u'مَعْرِفَة مُعْجِزٌ':Added, #1: 1	مَعْرِفَةُ الْمُعْجِزِ
u'مَعْرِفَةٌ مُعَرَّفٌ':Added, #1: 1	مَعْرِفَةِ الْمُعْجِزِ
u'مَعْرِفَة مُعَرَّفٌ':Added, #1: 1	مَعْرِفَةِ الْمُعَرَّفِ
u'مَعْرِفَةٌ مَعْقُودٌ':Added, #1: 1	مَعْرِفَةِ الْمُعَرَّفِ
u'مَعْرِفَة مَعْقُودٌ':Added, #1: 1	مَعْرِفَةُ الْمَعْقُودِ
u'مَعْرِفَةٌ مَعْقُودٌ':Added, #1: 1	مَعْرِفَةُ الْمَعْقُودِ
u'مَعْرِفَة مَعْقُودٌ':Added, #3: 3	مَعْرِفَةِ الْمَعْقُودِ
u'مَعْرِفَةٌ مُعِير':Added, #3: 3	مَعْرِفَةِ الْمَعْقُودِ
u'مَعْرِفَة مُعِير':Added, #2: 2	مَعْرِفَةِ الْمُعِيرِ
u'مَعْرِفَةٌ مَغْسُولٌ':Added, #2: 2	مَعْرِفَةِ الْمُعِيرِ
u'مَعْرِفَة مَغْسُولٌ':Added, #1: 1	مَعْرِفَةَ الْمَغْسُولِ
u'مَعْرِفَةٌ مُفْرَدٌ':Added, #1: 1	مَعْرِفَةَ الْمَغْسُولِ
u'مَعْرِفَة مُفْرَدٌ':Added, #1: 1	مَعْرِفَةِ مُفْرَدَاتِهِ
u'مَعْرِفَةٌ مَفْصِلٌ':Added, #1: 1	مَعْرِفَةِ مُفْرَدَاتِهِ
u'مَعْرِفَة مَفْصِلٌ':Added, #1: 1	مَعْرِفَةِ الْمَفْصِلِ
u'مَعْرِفَةٌ مَقَادِيرُ':Added, #1: 1	مَعْرِفَةِ الْمَفْصِلِ
u'مَعْرِفَة مَقَادِيرُ':Added, #1: 1	مَعْرِفَةِ الْمَقَادِيرِ
u'مَعْرِفَةٌ مَقَادِيرُ':Added, #1: 1	مَعْرِفَةِ الْمَقَادِيرِ
u'مَعْرِفَة مَقَادِيرُ':Added, #1: 1	مَعْرِفَةَ مَقَادِيرِ
u'مَعْرِفَةٌ مَقَادِيرُ':Added, #1: 1	مَعْرِفَةَ مَقَادِيرِ
u'مَعْرِفَة مَقَادِيرُ':Added, #1: 1	مَعْرِفَةِ مَقَادِيرِهِ
u'مَعْرِفَةٌ مَقَامٌ':Added, #1: 1	مَعْرِفَةِ مَقَادِيرِهِ
u'مَعْرِفَة مَقَامٌ':Added, #1: 1	مَعْرِفَةِ مَقَامِ
u'مَعْرِفَةٌ مِقْدَارٌ':Added, #1: 1	مَعْرِفَةِ مَقَامِ
u'مَعْرِفَةٌ مِقْدَارٌ':Added, #1: 1	مَعْرِفَةُ الْمِقْدَارِ
u'مَعْرِفَة مِقْدَارٌ':Added, #1: 1	مَعْرِفَةِ الْمِقْدَارِ
u'مَعْرِفَة مِقْدَارٌ':Added, #1: 1	مَعْرِفَةُ الْمِقْدَارِ
u'مَعْرِفَةٌ مِقْدَارٌ':Added, #1: 1	مَعْرِفَةِ الْمِقْدَارِ
u'مَعْرِفَة مِقْدَارٌ':Added, #1: 1	مَعْرِفَةَ مِقْدَارِهِ
u'مَعْرِفَةٌ مِقْدَارٌ':Added, #1: 1	مَعْرِفَةَ مِقْدَارِهِ
u'مَعْرِفَة مِقْدَارٌ':Added, #2: 2	مَعْرِفَةِ مِقْدَارِهِ
u'مَعْرِفَةٌ مِقْدَارٌ':Added, #2: 2	مَعْرِفَةِ مِقْدَارِهِ
u'مَعْرِفَة مِقْدَارٌ':Added, #4: 4	مَعْرِفَةُ مِقْدَارِ
u'مَعْرِفَةٌ مِقْدَارٌ':Added, #4: 4	مَعْرِفَةُ مِقْدَارِ
u'مَعْرِفَة مِقْدَارٌ':Added, #4: 4	مَعْرِفَةُ مِقْدَارِهِ
u'مَعْرِفَةٌ مِقْدَارٌ':Added, #4: 4	مَعْرِفَةُ مِقْدَارِهِ
u'مَعْرِفَة مِقْدَارٌ':Added, #5: 5	مَعْرِفَةِ مِقْدَارِ
u'مَعْرِفَةٌ مَقْصُودٌ':Added, #5: 5	مَعْرِفَةِ مِقْدَارِ
u'مَعْرِفَة مَقْصُودٌ':Added, #1: 1	مَعْرِفَةِ الْمَقْصُودِ
u'مَعْرِفَةٌ مَقْضِيّ':Added, #1: 1	مَعْرِفَةِ الْمَقْصُودِ
u'مَعْرِفَة مَقْضِيّ':Added, #1: 1	مَعْرِفَةَ الْمَقْضِيِّ
u'مَعْرِفَةٌ مَكَانٌ':Added, #1: 1	مَعْرِفَةَ الْمَقْضِيِّ
u'مَعْرِفَة مَكَانٌ':Added, #1: 1	مَعْرِفَةُ الْمَكَانِ
u'مَعْرِفَةٌ مَكْفُولٌ':Added, #1: 1	مَعْرِفَةُ الْمَكَانِ
u'مَعْرِفَة مَكْفُولٌ':Added, #1: 1	مَعْرِفَةُ الْمَكْفُولِ
u'مَعْرِفَةٌ مَلَكَةٌ':Added, #1: 1	مَعْرِفَةُ الْمَكْفُولِ
u'مَعْرِفَة مَلَكَةٌ':Added, #1: 1	مَعْرِفَةَ الْمَلَكَاتِ
u'مَعْرِفَةٌ مُمَاثَلَةٌ':Added, #1: 1	مَعْرِفَةَ الْمَلَكَاتِ
u'مَعْرِفَة مُمَاثَلَةٌ':Added, #4: 4	مَعْرِفَةِ الْمُمَاثَلَةِ
u'مَعْرِفَةٌ مُنَاسَبَةٌ':Added, #4: 4	مَعْرِفَةِ الْمُمَاثَلَةِ
u'مَعْرِفَة مُنَاسَبَةٌ':Added, #1: 1	مَعْرِفَةِ الْمُنَاسَبَةِ
u'مَعْرِفَةٌ مَنْفَعَةٌ':Added, #1: 1	مَعْرِفَةِ الْمُنَاسَبَةِ
u'مَعْرِفَة مَنْفَعَةٌ':Added, #1: 1	مَعْرِفَةُ الْمَنْفَعَةِ
u'مَعْرِفَةٌ مُوَافَقَةٌ':Added, #1: 1	مَعْرِفَةُ الْمَنْفَعَةِ
u'مَعْرِفَة مُوَافَقَةٌ':Added, #1: 1	مَعْرِفَةِ الْمُوَافَقَةِ
u'مَعْرِفَةٌ مَوَاقِيتُ':Added, #1: 1	مَعْرِفَةِ الْمُوَافَقَةِ
u'مَعْرِفَة مَوَاقِيتُ':Added, #1: 1	مَعْرِفَةِ الْمَوَاقِيتِ
u'مَعْرِفَةٌ مُؤَذِّنٌ':Added, #1: 1	مَعْرِفَةِ الْمَوَاقِيتِ
u'مَعْرِفَة مُؤَذِّنٌ':Added, #1: 1	مَعْرِفَةُ الْمُؤَذِّنِ
u'مَعْرِفَةٌ مَوْصُوفٌ':Added, #1: 1	مَعْرِفَةُ الْمُؤَذِّنِ
u'مَعْرِفَة مَوْصُوفٌ':Added, #1: 1	مَعْرِفَةُ الْمَوْصُوفِ
u'مَعْرِفَةٌ مَوْضُوعٌ':Added, #1: 1	مَعْرِفَةُ الْمَوْصُوفِ
u'مَعْرِفَة مَوْضُوعٌ':Added, #1: 1	مَعْرِفَةِ الْمَوْضُوعِ
u'مَعْرِفَةٌ مَوْقِفٌ':Added, #1: 1	مَعْرِفَةِ الْمَوْضُوعِ
u'مَعْرِفَة مَوْقِفٌ':Added, #1: 1	مَعْرِفَةُ الْمَوْقِفِ
u'مَعْرِفَةٌ نَاسِخٌ':Added, #1: 1	مَعْرِفَةُ الْمَوْقِفِ
u'مَعْرِفَةٌ نَاسِخ':Added, #1: 1	مَعْرِفَةُ النَّاسِخِ
u'مَعْرِفَة نَاسِخٌ':Added, #1: 1	مَعْرِفَةُ النَّاسِخِ
u'مَعْرِفَة نَاسِخ':Added, #1: 1	مَعْرِفَةُ النَّاسِخِ
u'مَعْرِفَةٌ نَاسِخٌ':Added, #1: 1	مَعْرِفَةُ النَّاسِخِ
u'مَعْرِفَةٌ نَاسِخ':Added, #3: 3	مَعْرِفَةِ النَّاسِخِ
u'مَعْرِفَة نَاسِخٌ':Added, #3: 3	مَعْرِفَةِ النَّاسِخِ
u'مَعْرِفَة نَاسِخ':Added, #3: 3	مَعْرِفَةِ النَّاسِخِ
u'مَعْرِفَةٌ نبات':Added, #3: 3	مَعْرِفَةِ النَّاسِخِ
u'مَعْرِفَة نبات':Added, #1: 1	مَعْرِفَةِ النَّبَاتِ
u'مَعْرِفَةٌ نَبَاتٌ':Added, #1: 1	مَعْرِفَةِ النَّبَاتِ
u'مَعْرِفَة نَبَاتٌ':Added, #1: 1	مَعْرِفَةِ النَّبَاتِ
u'مَعْرِفَةٌ نُبُوَّةٌ':Added, #1: 1	مَعْرِفَةِ النَّبَاتِ
u'مَعْرِفَة نُبُوَّةٌ':Added, #1: 1	مَعْرِفَةِ النُّبُوَّةِ
u'مَعْرِفَةٌ نَتِيجَةٌ':Added, #1: 1	مَعْرِفَةِ النُّبُوَّةِ
u'مَعْرِفَة نَتِيجَةٌ':Added, #1: 1	مَعْرِفَةِ النَّتِيجَةِ
u'مَعْرِفَةٌ نَحْوٌ':Added, #1: 1	مَعْرِفَةِ النَّتِيجَةِ
u'مَعْرِفَة نَحْوٌ':Added, #1: 1	مَعْرِفَةُ النَّحْوِ
u'مَعْرِفَةٌ نِسْبَةٌ':Added, #1: 1	مَعْرِفَةُ النَّحْوِ
u'مَعْرِفَة نِسْبَةٌ':Added, #1: 1	مَعْرِفَةُ نِسْبَةِ
u'مَعْرِفَةٌ نصب':Added, #1: 1	مَعْرِفَةُ نِسْبَةِ
u'مَعْرِفَة نصب':Added, #1: 1	مَعْرِفَةِ النُّصُبِ
u'مَعْرِفَةٌ نُصُبٌ':Added, #1: 1	مَعْرِفَةِ النُّصُبِ
u'مَعْرِفَة نُصُبٌ':Added, #1: 1	مَعْرِفَةِ النُّصُبِ
u'مَعْرِفَةٌ نِصْفٌ':Added, #1: 1	مَعْرِفَةِ النُّصُبِ
u'مَعْرِفَة نِصْفٌ':Added, #1: 1	مَعْرِفَةِ نِصْفِ
u'مَعْرِفَةٌ نَصِيبٌ':Added, #1: 1	مَعْرِفَةِ نِصْفِ
u'مَعْرِفَةٌ نَصِيبٌ':Added, #1: 1	مَعْرِفَةَ النَّصِيبِ
u'مَعْرِفَة نَصِيبٌ':Added, #1: 1	مَعْرِفَةِ النَّصِيبِ
u'مَعْرِفَة نَصِيبٌ':Added, #1: 1	مَعْرِفَةَ النَّصِيبِ
u'مَعْرِفَةٌ نَصِيبٌ':Added, #1: 1	مَعْرِفَةِ النَّصِيبِ
u'مَعْرِفَة نَصِيبٌ':Added, #3: 3	مَعْرِفَةَ نَصِيبِ
u'مَعْرِفَةٌ نَصِيبٌ':Added, #3: 3	مَعْرِفَةَ نَصِيبِ
u'مَعْرِفَة نَصِيبٌ':Added, #8: 8	مَعْرِفَةِ نَصِيبِ
u'مَعْرِفَةٌ نظائر':Added, #8: 8	مَعْرِفَةِ نَصِيبِ
u'مَعْرِفَة نظائر':Added, #1: 1	مَعْرِفَة نَظَائِرِ
u'مَعْرِفَةٌ نَظَرٌ':Added, #1: 1	مَعْرِفَة نَظَائِرِ
u'مَعْرِفَة نَظَرٌ':Added, #1: 1	مَعْرِفَةِ النَّظَرِ
u'مَعْرِفَةٌ نَفْسٌ':Added, #1: 1	مَعْرِفَةِ النَّظَرِ
u'مَعْرِفَة نَفْسٌ':Added, #1: 1	مَعْرِفَةُ النَّفْسِ
u'مَعْرِفَةٌ نَفْسٌ':Added, #1: 1	مَعْرِفَةُ النَّفْسِ
u'مَعْرِفَة نَفْسٌ':Added, #1: 1	مَعْرِفَةِ نَفْسِهِ
u'مَعْرِفَةٌ نَفْعٌ':Added, #1: 1	مَعْرِفَةِ نَفْسِهِ
u'مَعْرِفَة نَفْعٌ':Added, #1: 1	مَعْرِفَةِ النَّفْعِ
u'مَعْرِفَةٌ نَفْعٌ':Added, #1: 1	مَعْرِفَةِ النَّفْعِ
u'مَعْرِفَة نَفْعٌ':Added, #1: 1	مَعْرِفَةُ نَفْعٍ
u'مَعْرِفَةٌ نُقْصَانٌ':Added, #1: 1	مَعْرِفَةُ نَفْعٍ
u'مَعْرِفَة نُقْصَانٌ':Added, #5: 5	مَعْرِفَةِ النُّقْصَانِ
u'مَعْرِفَةٌ نِهَايَةٌ':Added, #5: 5	مَعْرِفَةِ النُّقْصَانِ
u'مَعْرِفَة نِهَايَةٌ':Added, #1: 1	مَعْرِفَةِ نِهَايَةِ
u'مَعْرِفَةٌ هِدَايَةٌ':Added, #1: 1	مَعْرِفَةِ نِهَايَةِ
u'مَعْرِفَة هِدَايَةٌ':Added, #1: 1	مَعْرِفَةِ الْهِدَايَةِ
u'مَعْرِفَةٌ هَدْيٌ':Added, #1: 1	مَعْرِفَةِ الْهِدَايَةِ
u'مَعْرِفَة هَدْيٌ':Added, #1: 1	مَعْرِفَةُ الْهَدْيِ
u'مَعْرِفَةٌ وَاجِبٌ':Added, #1: 1	مَعْرِفَةُ الْهَدْيِ
u'مَعْرِفَة وَاجِبٌ':Added, #1: 1	مَعْرِفَةِ الْوَاجِبَاتِ
u'مَعْرِفَةٌ وَاجِبٌ':Added, #1: 1	مَعْرِفَةِ الْوَاجِبَاتِ
u'مَعْرِفَة وَاجِبٌ':Added, #2: 2	مَعْرِفَةُ الْوَاجِبِ
u'مَعْرِفَةٌ واحد':Added, #2: 2	مَعْرِفَةُ الْوَاجِبِ
u'مَعْرِفَة واحد':Added, #1: 1	مَعْرِفَةِ وَاحِدٍ
u'مَعْرِفَةٌ وَاحِدٌ':Added, #1: 1	مَعْرِفَةِ وَاحِدٍ
u'مَعْرِفَة وَاحِدٌ':Added, #1: 1	مَعْرِفَةِ وَاحِدٍ
u'مَعْرِفَةٌ وَجْهٌ':Added, #1: 1	مَعْرِفَةِ وَاحِدٍ
u'مَعْرِفَةٌ وَجْهٌ':Added, #1: 1	مَعْرِفَةُ الْوَجْهِ
u'مَعْرِفَة وَجْهٌ':Added, #1: 1	مَعْرِفَةِ الْوَجْهِ
u'مَعْرِفَة وَجْهٌ':Added, #1: 1	مَعْرِفَةُ الْوَجْهِ
u'مَعْرِفَةٌ وَجْهٌ':Added, #1: 1	مَعْرِفَةِ الْوَجْهِ
u'مَعْرِفَة وَجْهٌ':Added, #1: 1	مَعْرِفَةُ وَجْهِ
u'مَعْرِفَةٌ وَجْهٌ':Added, #1: 1	مَعْرِفَةُ وَجْهِ
u'مَعْرِفَة وَجْهٌ':Added, #2: 2	مَعْرِفَةَ وَجْهِهِ
u'مَعْرِفَةٌ وُجُوبٌ':Added, #2: 2	مَعْرِفَةَ وَجْهِهِ
u'مَعْرِفَة وُجُوبٌ':Added, #1: 1	مَعْرِفَةُ وُجُوبِ
u'مَعْرِفَةٌ وُجُوبٌ':Added, #1: 1	مَعْرِفَةُ وُجُوبِ
u'مَعْرِفَة وُجُوبٌ':Added, #2: 2	مَعْرِفَةِ وُجُوبِ
u'مَعْرِفَةٌ وُجُودٌ':Added, #2: 2	مَعْرِفَةِ وُجُوبِ
u'مَعْرِفَة وُجُودٌ':Added, #1: 1	مَعْرِفَةِ وُجُودِ
u'مَعْرِفَةٌ وُجُوهٌ':Added, #1: 1	مَعْرِفَةِ وُجُودِ
u'مَعْرِفَة وُجُوهٌ':Added, #2: 2	مَعْرِفَةُ وُجُوهِ
u'مَعْرِفَةٌ وَرَثَةٌ':Added, #2: 2	مَعْرِفَةُ وُجُوهِ
u'مَعْرِفَة وَرَثَةٌ':Added, #1: 1	مَعْرِفَةِ وَرَثَتِهِ
u'مَعْرِفَةٌ وَرَثَةٌ':Added, #1: 1	مَعْرِفَةِ وَرَثَتِهِ
u'مَعْرِفَة وَرَثَةٌ':Added, #2: 2	مَعْرِفَةُ الْوَرَثَةِ
u'مَعْرِفَةٌ وَزْنٌ':Added, #2: 2	مَعْرِفَةُ الْوَرَثَةِ
u'مَعْرِفَةٌ وَزْنٌ':Added, #1: 1	مَعْرِفَةُ الْوَزْنِ
u'مَعْرِفَة وَزْنٌ':Added, #1: 1	مَعْرِفَةِ الْوَزْنِ
u'مَعْرِفَة وَزْنٌ':Added, #1: 1	مَعْرِفَةُ الْوَزْنِ
u'مَعْرِفَةٌ وَزْنٌ':Added, #1: 1	مَعْرِفَةِ الْوَزْنِ
u'مَعْرِفَة وَزْنٌ':Added, #1: 1	مَعْرِفَةُ وَزْنِ
u'مَعْرِفَةٌ وَزْنٌ':Added, #1: 1	مَعْرِفَةُ وَزْنِ
u'مَعْرِفَةٌ وَزْنٌ':Added, #1: 1	مَعْرِفَةُ وَزْنِهِ
u'مَعْرِفَة وَزْنٌ':Added, #1: 1	مَعْرِفَةِ وَزْنِهِ
u'مَعْرِفَة وَزْنٌ':Added, #1: 1	مَعْرِفَةُ وَزْنِهِ
u'مَعْرِفَةٌ وَزْنٌ':Added, #1: 1	مَعْرِفَةِ وَزْنِهِ
u'مَعْرِفَةٌ وَزْنٌ':Added, #2: 2	مَعْرِفَةَ وَزْنِ
u'مَعْرِفَة وَزْنٌ':Added, #2: 2	مَعْرِفَةِ وَزْنِ
u'مَعْرِفَة وَزْنٌ':Added, #2: 2	مَعْرِفَةَ وَزْنِ
u'مَعْرِفَةٌ وَصْفٌ':Added, #2: 2	مَعْرِفَةِ وَزْنِ
u'مَعْرِفَةٌ وَصْفٌ':Added, #1: 1	مَعْرِفَةَ الْوَصْفِ
u'مَعْرِفَةٌ وَصْفٌ':Added, #1: 1	مَعْرِفَةُ الْوَصْفِ
u'مَعْرِفَة وَصْفٌ':Added, #1: 1	مَعْرِفَةِ الْوَصْفِ
u'مَعْرِفَة وَصْفٌ':Added, #1: 1	مَعْرِفَةَ الْوَصْفِ
u'مَعْرِفَة وَصْفٌ':Added, #1: 1	مَعْرِفَةُ الْوَصْفِ
u'مَعْرِفَةٌ وَصْفٌ':Added, #1: 1	مَعْرِفَةِ الْوَصْفِ
u'مَعْرِفَة وَصْفٌ':Added, #1: 1	مَعْرِفَةِ وَصْفِ
u'مَعْرِفَةٌ وَصْفٌ':Added, #1: 1	مَعْرِفَةِ وَصْفِ
u'مَعْرِفَة وَصْفٌ':Added, #2: 2	مَعْرِفَةَ وَصْفِ
u'مَعْرِفَةٌ وُصُولٌ':Added, #2: 2	مَعْرِفَةَ وَصْفِ
u'مَعْرِفَة وُصُولٌ':Added, #1: 1	مَعْرِفَةَ الْوُصُولِ
u'مَعْرِفَةٌ وَصِيٌّ':Added, #1: 1	مَعْرِفَةَ الْوُصُولِ
u'مَعْرِفَة وَصِيٌّ':Added, #2: 2	مَعْرِفَةِ الْوَصِيَّةِ
u'مَعْرِفَةٌ وَصِيَّةٌ':Added, #2: 2	مَعْرِفَةِ الْوَصِيَّةِ
u'مَعْرِفَة وَصِيَّةٌ':Added, #2: 2	مَعْرِفَةِ الْوَصِيَّةِ
u'مَعْرِفَةٌ وَضْعٌ':Added, #2: 2	مَعْرِفَةِ الْوَصِيَّةِ
u'مَعْرِفَة وَضْعٌ':Added, #1: 1	مَعْرِفَةِ الْوَضْعِ
u'مَعْرِفَةٌ وَضْعٌ':Added, #1: 1	مَعْرِفَةِ الْوَضْعِ
u'مَعْرِفَة وَضْعٌ':Added, #3: 3	مَعْرِفَةِ وَضْعِ
u'مَعْرِفَةٌ وَظَائِفُ':Added, #3: 3	مَعْرِفَةِ وَضْعِ
u'مَعْرِفَة وَظَائِفُ':Added, #1: 1	مَعْرِفَةُ الْوَظَائِفِ
u'مَعْرِفَةٌ وَقْتٌ':Added, #1: 1	مَعْرِفَةُ الْوَظَائِفِ
u'مَعْرِفَة وَقْتٌ':Added, #1: 1	مَعْرِفَةِ وَقْتِ
u'مَعْرِفَةٌ وَقْتٌ':Added, #1: 1	مَعْرِفَةِ وَقْتِ
u'مَعْرِفَة وَقْتٌ':Added, #2: 2	مَعْرِفَةِ الْوَقْتِ
u'مَعْرِفَةٌ وَقْفٌ':Added, #2: 2	مَعْرِفَةِ الْوَقْتِ
u'مَعْرِفَة وَقْفٌ':Added, #1: 1	مَعْرِفَةُ الْوَقْفِ
u'مَعْرِفَةٌ وَكِيلٌ':Added, #1: 1	مَعْرِفَةُ الْوَقْفِ
u'مَعْرِفَة وَكِيلٌ':Added, #1: 1	مَعْرِفَةُ وَكِيلِهِ
u'مَعْرِفَةٌ وَكِيلٌ':Added, #1: 1	مَعْرِفَةُ وَكِيلِهِ
u'مَعْرِفَة وَكِيلٌ':Added, #2: 2	مَعْرِفَةَ وَكِيلِ
u'مَعْرِفَةٌ يسار':Added, #2: 2	مَعْرِفَةَ وَكِيلِ
u'مَعْرِفَة يسار':Added, #1: 1	مَعْرِفَةُ الْيَسَارِ
u'مَعْرِفَةٌ يَسَارٌ':Added, #1: 1	مَعْرِفَةُ الْيَسَارِ
u'مَعْرِفَة يَسَارٌ':Added, #1: 1	مَعْرِفَةُ الْيَسَارِ
u'مَعْرِفَةٌ يَمِينٌ':Added, #1: 1	مَعْرِفَةُ الْيَسَارِ
u'مَعْرِفَة يَمِينٌ':Added, #6: 6	مَعْرِفَةِ الْيَمِينِ
u'مَعْرِفَةٌ يَوْمٌ':Added, #6: 6	مَعْرِفَةِ الْيَمِينِ
u'مَعْرِفَة يَوْمٌ':Added, #1: 1	مَعْرِفَةِ الْيَوْمِ
u'مَعَكَ أعْظَمُ':Predicate, #1: 1	مَعْرِفَةِ الْيَوْمِ
u'مَعَكَ أعْظَمُ':Subject, #1: 1	مَعَكَ أَعْظَمَ
u'مَعَكَ بَارِحٌ':Predicate, #1: 1	مَعَكَ أَعْظَمُ
u'مَعَكَ تَمْرٌ':Subject, #1: 1	مَعَكَ الْبَارِحَةَ
u'مَعَكَ جمعة':Predicate, #2: 2	مَعَكَ تَمْرٌ
u'مَعَكَ جُمُعَةٌ':Predicate, #1: 1	مَعَكَ الْجُمُعَةَ
u'مَعَكَ شَيْءٌ':Subject, #1: 1	مَعَكَ الْجُمُعَةَ
u'مَعَكَ صَلاَةٌ':Predicate, #1: 1	مَعَكَ شَيْءٌ
u'مَعَكَ عَهْدٌ':Subject, #1: 1	مَعَكَ الصَّلاَةَ
u'مَعَكَ قَالٌ':Predicate, #1: 1	مَعَكَ عَهْدٌ
u'مَعَكَ قُرْآنٌ':Subject, #5: 5	مَعَكَ قَالَ
u'مَعَكَ مَاءٌ':Subject, #2: 2	مَعَكَ قُرْآنٌ
u'مَعَكَ وَضُوءٌ':Subject, #3: 3	مَعَكَ مَاءٌ
u'مَعَكَ يَوْمٌ':Predicate, #1: 1	مَعَكَ وَضُوءٌ
u'مَعْمَعَةٌ حَرْبٌ':Added, #4: 4	مَعَكَ يَوْمَ
u'مَعْمَعَةٌ قتال':Added, #2: 2	مَعْمَعَةِ الْحَرْبِ
u'مَعْمَعَةٌ قِتَالٌ':Added, #2: 2	مَعْمَعَةِ الْقِتَالِ
u'مَعَنَ مَاءٌ':Subject, #2: 2	مَعْمَعَةِ الْقِتَالِ
u'مَعَنَ نَظَرٌ':Predicate, #1: 1	مَعَنَ الْمَاءُ
u'مَعِنَ نَظَرٌ':Predicate, #7: 7	أَمْعَنَ النَّظَرَ
u'مُغَايَرَةٌ إِسْلامٌ':Added, #7: 7	أَمْعَنَ النَّظَرَ
u'مُغَايَرَةٌ أُسْلوبٌ':Added, #1: 1	مُغَايَرَةِ الْإِسْلَامِ
u'مُغَايَرَةٌ حَديثٌ':Added, #1: 1	مُغَايَرَةَ الْأُسْلُوبَيْنِ
u'مُغَايَرَةٌ حُكْمٌ':Added, #1: 1	مُغَايَرَةِ حَدِيثِ
u'مُغَايَرَةٌ عَلاَقَةٌ':Added, #1: 1	مُغَايَرَةِ الْحُكْمِ
u'مُغَايَرَةٌ قَوْلٌ':Added, #1: 1	مُغَايَرَةِ الْعَلَاقَةِ
u'مُغَايَرَةٌ وَصْفٌ':Added, #1: 1	مُغَايَرَةِ الْقَوْلَيْنِ
u'مَغِيبٌ أصل':Added, #1: 1	مُغَايَرَةِ الْوَصْفَيْنِ
u'مَغِيبٌ أًصْلٌ':Added, #3: 3	مَغِيبِ الْأَصْلِ
u'مَغِيبٌ بَيَاضٌ':Added, #3: 3	مَغِيبِ الْأَصْلِ
u'مَغِيبٌ حَشَفَةٌ':Added, #1: 1	مَغِيبَ الْبَيَاضِ
u'مَغِيبٌ حَشَفَةٌ':Added, #1: 1	مَغِيبُ حَشَفَةِ
u'مَغِيبٌ حَشَفَةٌ':Added, #1: 1	مَغِيبِ حَشَفَةِ
u'مَغِيبٌ حَشَفَةٌ':Added, #5: 5	مَغِيبِ الْحَشَفَةِ
u'مَغِيبٌ حكمة':Added, #9: 9	مَغِيبُ الْحَشَفَةِ
u'مَغِيبٌ حِكْمَةٌ':Added, #1: 1	مَغِيبُ حِكْمَةٍ
u'مَغِيبٌ رَجُلٌ':Added, #1: 1	مَغِيبُ حِكْمَةٍ
u'مَغِيبٌ زُهَرَةٌ':Added, #1: 1	مَغِيبُ الرَّجُلِ
u'مَغِيبٌ شفق':Added, #1: 1	مَغِيبِ الزّهَرَةِ
u'مَغِيبٌ شَفَقٌ':Added, #24: 24	مَغِيبِ الشَّفَقِ
u'مَغِيبٌ شفق':Added, #24: 24	مَغِيبِ الشَّفَقِ
u'مَغِيبٌ شَفَقٌ':Added, #5: 5	مَغِيبُ الشَّفَقِ
u'مَغِيبٌ شمس':Added, #5: 5	مَغِيبُ الشَّفَقِ
u'مَغِيبٌ شمس':Added, #1: 1	مَغِيبَ الشَّمْسِ
u'مَغِيبٌ شَمْسٌ':Added, #1: 1	مَغِيبُ الشَّمْسِ
u'مَغِيبٌ شَمْسٌ':Added, #1: 1	مَغِيبَ الشَّمْسِ
u'مَغِيبٌ شمس':Added, #1: 1	مَغِيبُ الشَّمْسِ
u'مَغِيبٌ شَمْسٌ':Added, #7: 7	مَغِيبِ الشَّمْسِ
u'مُفَاتَحَةٌ كَلاَمٌ':Added, #7: 7	مَغِيبِ الشَّمْسِ
u'مُفَاجَأَةٌ حَيْضٌ':Added, #1: 1	مُفَاتَحَةُ الْكَلَامِ
u'مُفَاجَأَةٌ عَدُوٌّ':Added, #1: 1	مُفَاجَأَةَ الْحَيْضِ
u'مُفَاجَأَةٌ فَجْرٌ':Added, #2: 2	مُفَاجَأَةِ الْعَدُوِّ
u'مُفَاجَأَةٌ مُصِيبٌ':Added, #2: 2	مُفَاجَأَةَ الْفَجْرِ
u'مُفَاجَأَةٌ مُصِيبَةٌ':Added, #1: 1	مُفَاجَأَةِ الْمُصِيبَةِ
u'مُفَاجَأَةٌ مَكْرُوهٌ':Added, #1: 1	مُفَاجَأَةِ الْمُصِيبَةِ
u'مُفَارَقَةٌ أبدانٌ':Added, #1: 1	مُفَاجَأَةِ الْمَكْرُوهِ
u'مُفَارَقَةٌ أحَدٌ':Added, #2: 2	مُفَارَقَةُ الْأَبْدَانِ
u'مُفَارَقَةٌ إِخْوَانٌ':Added, #1: 1	مُفَارَقَةُ أَحَدِ
u'مُفَارَقَةٌ أرْضٌ':Added, #1: 1	مُفَارَقَةُ الْإِخْوَانِ
u'مُفَارَقَةٌ أرْضٌ':Added, #1: 1	مُفَارَقَةِ أَرْضِ
u'مُفَارَقَةٌ إمَامٌ':Added, #2: 2	مُفَارَقَةِ الْأَرْضِ
u'مُفَارَقَةٌ إمَامٌ':Added, #1: 1	مُفَارَقَةُ الْإِمَامِ
u'مُفَارَقَةٌ إمَامٌ':Added, #1: 1	مُفَارَقَةُ إمَامِهِ
u'مُفَارَقَةٌ إمَامٌ':Added, #2: 2	مُفَارَقَةَ الْإِمَامِ
u'مُفَارَقَةٌ إمَامٌ':Added, #2: 2	مُفَارَقَةَ إمَامِهِ
u'مُفَارَقَةٌ أَمْرٌ':Added, #4: 4	مُفَارَقَةِ الْإِمَامِ
u'مُفَارَقَةٌ أهْلٌ':Added, #1: 1	مُفَارَقَةُ الْأَمْرِ
u'مُفَارَقَةٌ أهْلٌ':Added, #1: 1	مُفَارَقَةَ الْأَهْلِ
u'مُفَارَقَةٌ أَوَّلُ':Added, #1: 1	مُفَارَقَةِ الْأَهْلِ
u'مُفَارَقَةٌ بَعْضٌ':Added, #1: 1	مُفَارَقَةَ الْأَوَّلِ
u'مُفَارَقَةٌ بَقِيَّةٌ':Added, #1: 1	مُفَارَقَةَ بَعْضٍ
u'مُفَارَقَةٌ بَقِيَّةٌ':Added, #1: 1	مُفَارَقَةِ الْبَقِيَّةِ
u'مُفَارَقَةٌ بَلَدٌ':Added, #1: 1	مُفَارَقَةِ بَقِيَّةِ
u'مُفَارَقَةٌ بُنْيانٌ':Added, #1: 1	مُفَارَقَةِ الْبَلَدِ
u'مُفَارَقَةٌ بَيْتٌ':Added, #5: 5	مُفَارَقَةِ الْبُنْيَانِ
u'مُفَارَقَةٌ بَيْتٌ':Added, #1: 1	مُفَارَقَةِ بَيْتِهِ
u'مُفَارَقَةٌ بُيُوتٌ':Added, #2: 2	مُفَارَقَةِ بَيْتِ
u'مُفَارَقَةٌ بُيُوتٌ':Added, #1: 1	مُفَارَقَةِ الْبُيُوتِ
u'مُفَارَقَةٌ بُيُوتٌ':Added, #2: 2	مُفَارَقَةَ الْبُيُوتِ
u'مُفَارَقَةٌ جَمَاعَةٌ':Added, #2: 2	مُفَارَقَةُ الْبُيُوتِ
u'مُفَارَقَةٌ جَمَاعَةٌ':Added, #1: 1	مُفَارَقَةُ الْجَمَاعَةِ
u'مُفَارَقَةٌ جَنَّةٌ':Added, #1: 1	مُفَارَقَةِ الْجَمَاعَةِ
u'مُفَارَقَةٌ خطبة':Added, #1: 1	مُفَارَقَةُ الْجَنَّةِ
u'مُفَارَقَةٌ خِطْبَةٌ':Added, #1: 1	مُفَارَقَةَ الْخِطْبَةِ
u'مُفَارَقَةٌ روحٌ':Added, #1: 1	مُفَارَقَةَ الْخِطْبَةِ
u'مُفَارَقَةٌ روحٌ':Added, #1: 1	مُفَارَقَةِ الرُّوحِ
u'مُفَارَقَةٌ طَائِفٌ':Added, #2: 2	مُفَارَقَةُ الرُّوحِ
u'مُفَارَقَةٌ عَرَبٌ':Added, #1: 1	مُفَارَقَةُ الطَّائِفَةِ
u'مُفَارَقَةٌ عَرْضٌ':Added, #1: 1	مُفَارَقَةُ الْعَرَبِ
u'مُفَارَقَةٌ عُمْرَانٌ':Added, #1: 1	مُفَارَقَةُ عَرْضِهِ
u'مُفَارَقَةٌ عُمْرَانٌ':Added, #1: 1	مُفَارَقَةُ الْعُمْرَانِ
u'مُفَارَقَةٌ غَصْبٌ':Added, #1: 1	مُفَارَقَةِ الْعُمْرَانِ
u'مُفَارَقَةٌ كَبِيرٌ':Added, #1: 1	مُفَارَقَةِ الْغَصْبِ
u'مُفَارَقَةٌ مَأْلُوفٌ':Added, #1: 1	مُفَارَقَةِ الْكَبِيرَةِ
u'مُفَارَقَةٌ مَجْلِسٌ':Added, #2: 2	مُفَارَقَةِ الْمَأْلُوفِ
u'مُفَارَقَةٌ مُحْتَالٌ':Added, #1: 1	مُفَارَقَةُ الْمَجْلِسِ
u'مُفَارَقَةٌ مَرِيضٌ':Added, #1: 1	مُفَارَقَةِ الْمُحْتَالِ
u'مُفَارَقَةٌ مَعْصِيَةٌ':Added, #1: 1	مُفَارَقَةُ الْمَرِيضِ
u'مُفَارَقَةٌ مُغْتاب':Added, #2: 2	مُفَارَقَةِ الْمَعْصِيَةِ
u'مُفَارَقَةٌ مُفْلِسٌ':Added, #1: 1	مُفَارَقَةُ الْمُغْتَابِ
u'مُفَارَقَةٌ مَكْتُوبٌ':Added, #1: 1	مُفَارَقَةِ الْمُفْلِسِ
u'مُفَارَقَةٌ مَنْزِلٌ':Added, #1: 1	مُفَارَقَةِ الْمَكْتُوبِ
u'مُفَارَقَةٌ مَنِيٌّ':Added, #1: 1	مُفَارَقَةُ الْمَنْزِلِ
u'مُفَارَقَةٌ مَوْضِعٌ':Added, #1: 1	مُفَارَقَةُ الْمَنِيِّ
u'مُفَارَقَةٌ مَوْقِفٌ':Added, #1: 1	مُفَارَقَةُ الْمَوْضِعِ
u'مُفَارَقَةٌ مُوَكِّلٌ':Added, #1: 1	مُفَارَقَةِ مَوْقِفِ
u'مُفَارَقَةٌ مُوَكِّلٌ':Added, #1: 1	مُفَارَقَةِ الْمُوَكِّلِ
u'مُفَارَقَةٌ مُوَكِّلٌ':Added, #2: 2	مُفَارَقَةَ الْمُوَكِّلِ
u'مُفَارَقَةٌ نذر':Added, #4: 4	مُفَارَقَةُ الْمُوَكِّلِ
u'مُفَارَقَةٌ نَذْرٌ':Added, #1: 1	مُفَارَقَةُ النَّذْرِ
u'مُفَارَقَةٌ وَطَنٌ':Added, #1: 1	مُفَارَقَةُ النَّذْرِ
u'مُفَارَقَةٌ وَكِيلٌ':Added, #1: 1	مُفَارَقَةَ الْوَطَنِ
u'مُفَارَقَةٌ يَسِيرٌ':Added, #4: 4	مُفَارَقَةُ الْوَكِيلِ
u'مُفَاوَضَةٌ فَاسِدٌ':Added, #1: 1	مُفَارَقَةَ الْيَسِيرِ
u'مُفَاوَضَةٌ نَظِيرٌ':Added, #1: 1	مُفَاوَضَةٍ فَاسِدَةٍ
u'مُقَابَلٌ اِبْنٌ':Added, #1: 1	مُفَاوَضَةَ النَّظِيرِ
u'مُقَابَلٌ إِتْلاَفٌ':Added, #3: 3	مُقَابَلَةِ ابْنِ
u'مُقَابَلٌ إِثْمٌ':Added, #1: 1	مُقَابَلَةِ إتْلَافِ
u'مُقَابَلٌ أُجْرَةٌ':Added, #1: 1	مُقَابَلَةِ الْإِثْمِ
u'مُقَابَلٌ أَجَلٌ':Added, #2: 2	مُقَابَلَةِ الْأُجْرَةِ
u'مُقَابَلٌ أَجَلٌ':Added, #1: 1	مُقَابَلَةَ الْأَجَلِ
u'مُقَابَلٌ آحَادٌ':Added, #1: 1	مُقَابَلَةِ الْأَجَلِ
u'مُقَابَلٌ إحْسَانٌ':Added, #1: 1	مُقَابَلَةَ الْآحَادِ
u'مُقَابَلٌ إحْسَانٌ':Added, #1: 1	مُقَابَلَةِ إحْسَانِهِ
u'مُقَابَلٌ إحْسَانٌ':Added, #1: 1	مُقَابَلَةِ الْإِحْسَانِ
u'مُقَابَلٌ إِحْيَاءٌ':Added, #2: 2	مُقَابَلَةِ إحْسَانٍ
u'مُقَابَلٌ اِخْتِصَاصٌ':Added, #1: 1	مُقَابَلَةِ إحْيَاءِ
u'مُقَابَلٌ أخفُّ':Added, #1: 1	مُقَابَلَةِ اخْتِصَاصِهِ
u'مُقَابَلٌ إِذْنٌ':Added, #1: 1	مُقَابَلَةُ أَخَفِّ
u'مُقَابَلٌ أرْضٌ':Added, #1: 1	مُقَابَلَةِ إذْنِهِ
u'مُقَابَلٌ إِرْضاعٌ':Added, #1: 1	مُقَابَلَةِ الْأَرْضِ
u'مُقَابَلٌ إِزَالَةٌ':Added, #1: 1	مُقَابَلَةِ الْإِرْضَاعِ
u'مُقَابَلٌ اِسْتِمْتاعٌ':Added, #1: 1	مُقَابَلَةِ إزَالَةِ
u'مُقَابَلٌ إِشْفاقٌ':Added, #1: 1	مُقَابَلَةِ اسْتِمْتَاعِهِ
u'مُقَابَلٌ أَصابِعُ':Added, #1: 1	مُقَابَلَةِ الْإِشْفَاقِ
u'مُقَابَلٌ أصل':Added, #1: 1	مُقَابَلَةِ الْأَصَابِعِ
u'مُقَابَلٌ أًصْلٌ':Added, #1: 1	مُقَابَلَةِ الْأَصْلِ
u'مُقَابَلٌ أَعْضَاءٌ':Added, #1: 1	مُقَابَلَةِ الْأَصْلِ
u'مُقَابَلٌ أَعْضَاءٌ':Added, #1: 1	مُقَابَلَةِ الْأَعْضَاءِ
u'مُقَابَلٌ أَعْمَالٌ':Added, #4: 4	مُقَابَلَةُ الْأَعْضَاءِ
u'مُقَابَلٌ أَفْرَادٌ':Added, #1: 1	مُقَابَلَةِ الْأَعْمَالِ
u'مُقَابَلٌ أَقْرَانٌ':Added, #1: 1	مُقَابَلَةِ الْأَفْرَادِ
u'مُقَابَلٌ أقَلُّ':Added, #1: 1	مُقَابَلَةِ أَقْرَانِهِ
u'مُقَابَلٌ اِلْتِزَامٌ':Added, #1: 1	مُقَابَلَةِ أَقَلِّ
u'مُقَابَلٌ ألف':Added, #1: 1	مُقَابَلَةِ الْتِزَامِهِ
u'مُقَابَلٌ ألْفٌ':Added, #1: 1	مُقَابَلَةِ الْأَلْفِ
u'مُقَابَلٌ أَلْفٌ':Added, #1: 1	مُقَابَلَةِ الْأَلْفِ
u'مُقَابَلٌ الْمَرْأَةُ':Added, #1: 1	مُقَابَلَةِ الْأَلْفِ
u'مُقَابَلٌ أمَانٌ':Added, #3: 3	مُقَابَلَةِ الْمَرْأَةِ
u'مُقَابَلٌ أَمْوَالٌ':Added, #1: 1	مُقَابَلَةِ الْأَمَانِ
u'مُقَابَلٌ اِنْتِهاكٌ':Added, #1: 1	مُقَابَلَةُ الْأَمْوَالِ
u'مُقَابَلٌ إِنْعامٌ':Added, #1: 1	مُقَابَلَةِ انْتِهَاكِ
u'مُقَابَلٌ إِنْعامٌ':Added, #1: 1	مُقَابَلَةِ الْإِنْعَامِ
u'مُقَابَلٌ أيَّامٌ':Added, #1: 1	مُقَابَلَةِ إنْعَامِ
u'مُقَابَلٌ أَيَّامٌ':Added, #3: 3	مُقَابَلَةِ الْأَيَّامِ
u'مُقَابَلٌ آيَةٌ':Added, #3: 3	مُقَابَلَةِ الْأَيَّامِ
u'مُقَابَلٌ بَابٌ':Added, #1: 1	مُقَابَلَةِ الْآيَةِ
u'مُقَابَلٌ بِدْعَةٌ':Added, #2: 2	مُقَابَلَةِ بَابِ
u'مُقَابَلٌ بَدَلٌ':Added, #1: 1	مُقَابَلَةِ الْبِدْعَةِ
u'مُقَابَلٌ بَذْلٌ':Added, #1: 1	مُقَابَلَةِ بَدَلٍ
u'مُقَابَلٌ بَراءةٌ':Added, #2: 2	مُقَابَلَةِ الْبَذْلِ
u'مُقَابَلٌ بَعْضٌ':Added, #4: 4	مُقَابَلَةِ الْبَرَاءَةِ
u'مُقَابَلٌ بَعْضٌ':Added, #1: 1	مُقَابَلَةِ الْبَعْضِ
u'مُقَابَلٌ بَعْضٌ':Added, #1: 1	مُقَابَلَةَ بَعْضِ
u'مُقَابَلٌ بَيِّنَةٌ':Added, #2: 2	مُقَابَلَةِ بَعْضِهِ
u'مُقَابَلَةٌ اِبْنٌ':Added, #1: 1	مُقَابَلَةِ بَيِّنَةِ
u'مُقَابَلَةٌ إِتْلاَفٌ':Added, #3: 3	مُقَابَلَةِ ابْنِ
u'مُقَابَلَةٌ إِثْمٌ':Added, #1: 1	مُقَابَلَةِ إتْلَافِ
u'مُقَابَلَةٌ أُجْرَةٌ':Added, #1: 1	مُقَابَلَةِ الْإِثْمِ
u'مُقَابَلَةٌ أَجَلٌ':Added, #2: 2	مُقَابَلَةِ الْأُجْرَةِ
u'مُقَابَلَةٌ أَجَلٌ':Added, #1: 1	مُقَابَلَةَ الْأَجَلِ
u'مُقَابَلَةٌ آحَادٌ':Added, #1: 1	مُقَابَلَةِ الْأَجَلِ
u'مُقَابَلَةٌ إحْسَانٌ':Added, #1: 1	مُقَابَلَةَ الْآحَادِ
u'مُقَابَلَةٌ إحْسَانٌ':Added, #1: 1	مُقَابَلَةِ إحْسَانِهِ
u'مُقَابَلَةٌ إحْسَانٌ':Added, #1: 1	مُقَابَلَةِ الْإِحْسَانِ
u'مُقَابَلَةٌ إِحْيَاءٌ':Added, #2: 2	مُقَابَلَةِ إحْسَانٍ
u'مُقَابَلَةٌ اِخْتِصَاصٌ':Added, #1: 1	مُقَابَلَةِ إحْيَاءِ
u'مُقَابَلَةٌ أخفُّ':Added, #1: 1	مُقَابَلَةِ اخْتِصَاصِهِ
u'مُقَابَلَةٌ إِذْنٌ':Added, #1: 1	مُقَابَلَةُ أَخَفِّ
u'مُقَابَلَةٌ أرْضٌ':Added, #1: 1	مُقَابَلَةِ إذْنِهِ
u'مُقَابَلَةٌ إِرْضاعٌ':Added, #1: 1	مُقَابَلَةِ الْأَرْضِ
u'مُقَابَلَةٌ إِزَالَةٌ':Added, #1: 1	مُقَابَلَةِ الْإِرْضَاعِ
u'مُقَابَلَةٌ اِسْتِمْتاعٌ':Added, #1: 1	مُقَابَلَةِ إزَالَةِ
u'مُقَابَلَةٌ إِشْفاقٌ':Added, #1: 1	مُقَابَلَةِ اسْتِمْتَاعِهِ
u'مُقَابَلَةٌ أَصابِعُ':Added, #1: 1	مُقَابَلَةِ الْإِشْفَاقِ
u'مُقَابَلَةٌ أصل':Added, #1: 1	مُقَابَلَةِ الْأَصَابِعِ
u'مُقَابَلَةٌ أًصْلٌ':Added, #1: 1	مُقَابَلَةِ الْأَصْلِ
u'مُقَابَلَةٌ أَعْضَاءٌ':Added, #1: 1	مُقَابَلَةِ الْأَصْلِ
u'مُقَابَلَةٌ أَعْضَاءٌ':Added, #1: 1	مُقَابَلَةِ الْأَعْضَاءِ
u'مُقَابَلَةٌ أَعْمَالٌ':Added, #4: 4	مُقَابَلَةُ الْأَعْضَاءِ
u'مُقَابَلَةٌ أَفْرَادٌ':Added, #1: 1	مُقَابَلَةِ الْأَعْمَالِ
u'مُقَابَلَةٌ أَقْرَانٌ':Added, #1: 1	مُقَابَلَةِ الْأَفْرَادِ
u'مُقَابَلَةٌ أقَلُّ':Added, #1: 1	مُقَابَلَةِ أَقْرَانِهِ
u'مُقَابَلَةٌ اِلْتِزَامٌ':Added, #1: 1	مُقَابَلَةِ أَقَلِّ
u'مُقَابَلَةٌ ألف':Added, #1: 1	مُقَابَلَةِ الْتِزَامِهِ
u'مُقَابَلَةٌ ألْفٌ':Added, #1: 1	مُقَابَلَةِ الْأَلْفِ
u'مُقَابَلَةٌ أَلْفٌ':Added, #1: 1	مُقَابَلَةِ الْأَلْفِ
u'مُقَابَلَةٌ الْمَرْأَةُ':Added, #1: 1	مُقَابَلَةِ الْأَلْفِ
u'مُقَابَلَةٌ أمَانٌ':Added, #3: 3	مُقَابَلَةِ الْمَرْأَةِ
u'مُقَابَلَةٌ أَمْوَالٌ':Added, #1: 1	مُقَابَلَةِ الْأَمَانِ
u'مُقَابَلَةٌ اِنْتِهاكٌ':Added, #1: 1	مُقَابَلَةُ الْأَمْوَالِ
u'مُقَابَلَةٌ إِنْعامٌ':Added, #1: 1	مُقَابَلَةِ انْتِهَاكِ
u'مُقَابَلَةٌ إِنْعامٌ':Added, #1: 1	مُقَابَلَةِ الْإِنْعَامِ
u'مُقَابَلَةٌ أيَّامٌ':Added, #1: 1	مُقَابَلَةِ إنْعَامِ
u'مُقَابَلَةٌ أَيَّامٌ':Added, #3: 3	مُقَابَلَةِ الْأَيَّامِ
u'مُقَابَلَةٌ آيَةٌ':Added, #3: 3	مُقَابَلَةِ الْأَيَّامِ
u'مُقَابَلَةٌ بَابٌ':Added, #1: 1	مُقَابَلَةِ الْآيَةِ
u'مُقَابَلَةٌ بِدْعَةٌ':Added, #2: 2	مُقَابَلَةِ بَابِ
u'مُقَابَلَةٌ بَدَلٌ':Added, #1: 1	مُقَابَلَةِ الْبِدْعَةِ
u'مُقَابَلَةٌ بَذْلٌ':Added, #1: 1	مُقَابَلَةِ بَدَلٍ
u'مُقَابَلَةٌ بَراءةٌ':Added, #2: 2	مُقَابَلَةِ الْبَذْلِ
u'مُقَابَلَةٌ بَعْضٌ':Added, #4: 4	مُقَابَلَةِ الْبَرَاءَةِ
u'مُقَابَلَةٌ بَعْضٌ':Added, #1: 1	مُقَابَلَةِ الْبَعْضِ
u'مُقَابَلَةٌ بَعْضٌ':Added, #1: 1	مُقَابَلَةَ بَعْضِ
u'مُقَابَلَةٌ بَيِّنَةٌ':Added, #2: 2	مُقَابَلَةِ بَعْضِهِ
u'مُقَابَلَةٌ تالِف':Added, #1: 1	مُقَابَلَةِ بَيِّنَةِ
u'مُقَابَلَةٌ تِبْن':Added, #1: 1	مُقَابَلَةِ التَّالِفَةِ
u'مُقَابَلَةٌ تَحْرِيرٌ':Added, #1: 1	مُقَابَلَةِ التِّبْنِ
u'مُقَابَلَةٌ تَرْكٌ':Added, #1: 1	مُقَابَلَةِ تَحْرِيرِ
u'مُقَابَلَةٌ تَسْلِيمٌ':Added, #4: 4	مُقَابَلَةِ تَرْكِ
u'مُقَابَلَةٌ تَصْرِيحٌ':Added, #1: 1	مُقَابَلَةُ تَسْلِيمٍ
u'مُقَابَلَةٌ تَعْلِيقٌ':Added, #1: 1	مُقَابَلَةِ التَّصْرِيحِ
u'مُقَابَلَةٌ تَعْلِيلٌ':Added, #1: 1	مُقَابَلَةُ التَّعْلِيقِ
u'مُقَابَلَةٌ تَعْوِيضٌ':Added, #1: 1	مُقَابَلَةِ تَعْلِيلِ
u'مُقَابَلَةٌ تَقْصيرٌ':Added, #1: 1	مُقَابَلَةِ تَعْوِيضِهِ
u'مُقَابَلَةٌ تَكَلُّمٌ':Added, #1: 1	مُقَابَلَةِ التَّقْصِيرِ
u'مُقَابَلَةٌ تَمْكِين':Added, #1: 1	مُقَابَلَةِ التَّكَلُّمِ
u'مُقَابَلَةٌ تَوْفِيرٌ':Added, #6: 6	مُقَابَلَةِ التَّمْكِينِ
u'مُقَابَلَةٌ ثَانِي':Added, #1: 1	مُقَابَلَةِ تَوْفِيرِ
u'مُقَابَلَةٌ ثَانِيَةٌ':Added, #2: 2	مُقَابَلَةِ الثَّانِيَةِ
u'مُقَابَلَةٌ ثُبُوتٌ':Added, #2: 2	مُقَابَلَةِ الثَّانِيَةِ
u'مُقَابَلَةٌ ثَلاثُ':Added, #1: 1	مُقَابَلَةِ ثُبُوتِ
u'مُقَابَلَةٌ ثَلاثَةٌ':Added, #6: 6	مُقَابَلَةِ الثَّلَاثِ
u'مُقَابَلَةٌ ثَلاثَةٌ':Added, #1: 1	مُقَابَلَةِ ثَلَاثَةِ
u'مُقَابَلَةٌ ثَمَنٌ':Added, #2: 2	مُقَابَلَةِ ثَلَاثَةٍ
u'مُقَابَلَةٌ ثَوابٌ':Added, #4: 4	مُقَابَلَةِ الثَّمَنِ
u'مُقَابَلَةٌ ثَوْبٌ':Added, #1: 1	مُقَابَلَةِ الثَّوَابِ
u'مُقَابَلَةٌ جُزْءٌ':Added, #1: 1	مُقَابَلَةِ الثَّوْبِ
u'مُقَابَلَةٌ جُزْءٌ':Added, #2: 2	مُقَابَلَةِ جُزْءٍ
u'مُقَابَلَةٌ جَمَاعَةٌ':Added, #4: 4	مُقَابَلَةِ الْجُزْءِ
u'مُقَابَلَةٌ جمع':Added, #1: 1	مُقَابَلَةِ الْجَمَاعَةِ
u'مُقَابَلَةٌ جَمْعٌ':Added, #1: 1	مُقَابَلَةُ الْجَمْعِ
u'مُقَابَلَةٌ جمع':Added, #1: 1	مُقَابَلَةُ الْجَمْعِ
u'مُقَابَلَةٌ جَمْعٌ':Added, #3: 3	مُقَابَلَةِ الْجَمْعِ
u'مُقَابَلَةٌ جمع':Added, #3: 3	مُقَابَلَةِ الْجَمْعِ
u'مُقَابَلَةٌ جَمْعٌ':Added, #5: 5	مُقَابَلَةَ الْجَمْعِ
u'مُقَابَلَةٌ جُمْلَةٌ':Added, #5: 5	مُقَابَلَةَ الْجَمْعِ
u'مُقَابَلَةٌ جُمْلَةٌ':Added, #1: 1	مُقَابَلَةَ الْجُمْلَةِ
u'مُقَابَلَةٌ جُمْلَةٌ':Added, #1: 1	مُقَابَلَةُ الْجُمْلَةِ
u'مُقَابَلَةٌ جَمِيع':Added, #1: 1	مُقَابَلَةُ جُمْلَةٍ
u'مُقَابَلَةٌ جِنَايَةٌ':Added, #2: 2	مُقَابَلَةِ الْجَمِيعِ
u'مُقَابَلَةٌ جِنَايَةٌ':Added, #1: 1	مُقَابَلَةَ الْجِنَايَةِ
u'مُقَابَلَةٌ جِنَايَةٌ':Added, #1: 1	مُقَابَلَةِ الْجِنَايَةِ
u'مُقَابَلَةٌ جِنْسٌ':Added, #3: 3	مُقَابَلَةِ جِنَايَةٍ
u'مُقَابَلَةٌ جِنْسٌ':Added, #1: 1	مُقَابَلَةَ الْجِنْسِ
u'مُقَابَلَةٌ جِنْسٌ':Added, #1: 1	مُقَابَلَةُ الْجِنْسِ
u'مُقَابَلَةٌ جِنْسٌ':Added, #1: 1	مُقَابَلَةِ جِنْسِ
u'مُقَابَلَةٌ جِنْسٌ':Added, #2: 2	مُقَابَلَةِ جِنْسِهِ
u'مُقَابَلَةٌ جِهَةٌ':Added, #3: 3	مُقَابَلَةِ الْجِنْسِ
u'مُقَابَلَةٌ حُبٌّ':Added, #1: 1	مُقَابَلَةِ جِهَةِ
u'مُقَابَلَةٌ حَجَرٌ':Added, #1: 1	مُقَابَلَةِ حُبِّ
u'مُقَابَلَةٌ حُجْرَةٌ':Added, #1: 1	مُقَابَلَةِ الْحَجَرِ
u'مُقَابَلَةٌ حُدوثٌ':Added, #1: 1	مُقَابَلَةِ حُجْرَةِ
u'مُقَابَلَةٌ حُرٌّ':Added, #2: 2	مُقَابَلَةِ حُدُوثِ
u'مُقَابَلَةٌ حَقٌّ':Added, #1: 1	مُقَابَلَةَ الْحُرِّ
u'مُقَابَلَةٌ حَمْلٌ':Added, #1: 1	مُقَابَلَةَ الْحَقِّ
u'مُقَابَلَةٌ خُبْزٌ':Added, #1: 1	مُقَابَلَةِ الْحَمْلِ
u'مُقَابَلَةٌ خُصُومَةٌ':Added, #1: 1	مُقَابَلَةِ الْخُبْزِ
u'مُقَابَلَةٌ خَطٌّ':Added, #3: 3	مُقَابَلَةِ الْخُصُومَةِ
u'مُقَابَلَةٌ خُلْعٌ':Added, #2: 2	مُقَابَلَةِ الْخَطِّ
u'مُقَابَلَةٌ دَارٌ':Added, #1: 1	مُقَابَلَةِ الْخُلْعِ
u'مُقَابَلَةٌ دِرْهَمٌ':Added, #1: 1	مُقَابَلَةَ الدَّارِ
u'مُقَابَلَةٌ دِرْهَم':Added, #2: 2	مُقَابَلَةِ الدِّرْهَمِ
u'مُقَابَلَةٌ دفع':Added, #2: 2	مُقَابَلَةِ الدِّرْهَمِ
u'مُقَابَلَةٌ دَفْعٌ':Added, #1: 1	مُقَابَلَةِ الدَّفْعِ
u'مُقَابَلَةٌ دِيَةٌ':Added, #1: 1	مُقَابَلَةِ الدَّفْعِ
u'مُقَابَلَةٌ دَيْنٌ':Added, #1: 1	مُقَابَلَةِ الدِّيَةِ
u'مُقَابَلَةٌ دَيْنٌ':Added, #2: 2	مُقَابَلَةِ دَيْنِ
u'مُقَابَلَةٌ دَيْنٌ':Added, #3: 3	مُقَابَلَةِ الدَّيْنِ
u'مُقَابَلَةٌ دِينارٌ':Added, #4: 4	مُقَابَلَةِ دَيْنِهِ
u'مُقَابَلَةٌ ذَبٌّ':Added, #1: 1	مُقَابَلَةِ الدِّينَارِ
u'مُقَابَلَةٌ ذِراعٌ':Added, #2: 2	مُقَابَلَةِ الذَّبِّ
u'مُقَابَلَةٌ ذكر':Added, #2: 2	مُقَابَلَةِ الذِّرَاعِ
u'مُقَابَلَةٌ ذَكَرٌ':Added, #1: 1	مُقَابَلَةِ الذَّكَرِ
u'مُقَابَلَةٌ رَاجِحٌ':Added, #1: 1	مُقَابَلَةِ الذَّكَرِ
u'مُقَابَلَةٌ رَأْسٌ':Added, #4: 4	مُقَابَلَةِ الرَّاجِحِ
u'مُقَابَلَةٌ رَامِحٌ':Added, #1: 1	مُقَابَلَةِ رَأْسِ
u'مُقَابَلَةٌ رَجُلٌ':Added, #1: 1	مُقَابَلَةِ الرّامِحِ
u'مُقَابَلَةٌ رُخْصَةٌ':Added, #1: 1	مُقَابَلَةِ الرَّجُلَيْنِ
u'مُقَابَلَةٌ رُخْصَةٌ':Added, #1: 1	مُقَابَلَةِ الرُّخْصَةِ
u'مُقَابَلَةٌ رَدٌّ':Added, #1: 1	مُقَابَلَةِ رُخْصَةٍ
u'مُقَابَلَةٌ رَدٌّ':Added, #1: 1	مُقَابَلَةِ الرَّدِّ
u'مُقَابَلَةٌ رَقَبَةٌ':Added, #1: 1	مُقَابَلَةِ رَدِّهِ
u'مُقَابَلَةٌ زائِدٌ':Added, #1: 1	مُقَابَلَةِ رَقَبَتِهِ
u'مُقَابَلَةٌ زِيادَةٌ':Added, #2: 2	مُقَابَلَةِ الزَّائِدِ
u'مُقَابَلَةٌ سِتٌّ':Added, #2: 2	مُقَابَلَةِ الزِّيَادَةِ
u'مُقَابَلَةٌ سِتٌّ':Added, #1: 1	مُقَابَلَةِ السِّتَّةِ
u'مُقَابَلَةٌ سِتٌّ':Added, #1: 1	مُقَابَلَةِ سِتٍّ
u'مُقَابَلَةٌ سَلاَمَةٌ':Added, #1: 1	مُقَابَلَةِ سِتَّةٍ
u'مُقَابَلَةٌ سَلْطَنَةٌ':Added, #1: 1	مُقَابَلَةِ السَّلَامَةِ
u'مُقَابَلَةٌ سَلِيمٌ':Added, #1: 1	مُقَابَلَةِ سَلْطَنَةِ
u'مُقَابَلَةٌ سُلَيْمانِيّ':Added, #2: 2	مُقَابَلَةِ السَّلِيمِ
u'مُقَابَلَةٌ سِواكٌ':Added, #1: 1	مُقَابَلَةِ السُّلَيْمَانِيَّةِ
u'مُقَابَلَةٌ سَيِّئٌ':Added, #1: 1	مُقَابَلَةِ السِّوَاكِ
u'مُقَابَلَةٌ شَائِعٌ':Added, #1: 1	مُقَابَلَةِ سَيِّئَاتِهِ
u'مُقَابَلَةٌ شَخْصٌ':Added, #1: 1	مُقَابَلَةِ الشَّائِعِ
u'مُقَابَلَةٌ شَرْطٌ':Added, #1: 1	مُقَابَلَةِ شَخْصٍ
u'مُقَابَلَةٌ شَرْطٌ':Added, #1: 1	مُقَابَلَةَ الشَّرْطِ
u'مُقَابَلَةٌ شِفَاءٌ':Added, #1: 1	مُقَابَلَةُ الشَّرْطِ
u'مُقَابَلَةٌ شَفَاعَةٌ':Added, #2: 2	مُقَابَلَةِ الشِّفَاءِ
u'مُقَابَلَةٌ شمس':Added, #1: 1	مُقَابَلَةِ شَفَاعَةٍ
u'مُقَابَلَةٌ شَمْسٌ':Added, #5: 5	مُقَابَلَةِ الشَّمْسِ
u'مُقَابَلَةٌ شَيْءٌ':Added, #5: 5	مُقَابَلَةِ الشَّمْسِ
u'مُقَابَلَةٌ شَيْءٌ':Added, #15: 15	مُقَابَلَةِ شَيْءٍ
u'مُقَابَلَةٌ صبر':Added, #2: 2	مُقَابَلَةُ شَيْءٍ
u'مُقَابَلَةٌ صَبْرٌ':Added, #1: 1	مُقَابَلَةِ صَبْرِهِ
u'مُقَابَلَةٌ صَبِيٌّ':Added, #1: 1	مُقَابَلَةِ صَبْرِهِ
u'مُقَابَلَةٌ صَحَابَةٌ':Added, #1: 1	مُقَابَلَةِ الصَّبِيِّ
u'مُقَابَلَةٌ صِحَّةٌ':Added, #1: 1	مُقَابَلَةِ الصَّحَابَةِ
u'مُقَابَلَةٌ صَحِيحٌ':Added, #2: 2	مُقَابَلَةِ صِحَّةِ
u'مُقَابَلَةٌ صداق':Added, #1: 1	مُقَابَلَةِ الصَّحِيحِ
u'مُقَابَلَةٌ صَدَاقٌ':Added, #1: 1	مُقَابَلَةِ الصَّدَاقِ
u'مُقَابَلَةٌ صَرِيحٌ':Added, #1: 1	مُقَابَلَةِ الصَّدَاقِ
u'مُقَابَلَةٌ صِفَةٌ':Added, #2: 2	مُقَابَلَةِ الصَّرِيحِ
u'مُقَابَلَةٌ ضَرَرٌ':Added, #1: 1	مُقَابَلَةِ صِفَاتِ
u'مُقَابَلَةٌ ضَمَانٌ':Added, #1: 1	مُقَابَلَةِ ضَرَرٍ
u'مُقَابَلَةٌ طَلاَقٌ':Added, #1: 1	مُقَابَلَةِ الضَّمَانِ
u'مُقَابَلَةٌ طَلاَقٌ':Added, #1: 1	مُقَابَلَةِ طَلَاقٍ
u'مُقَابَلَةٌ طَلاَقٌ':Added, #1: 1	مُقَابَلَةِ طَلَاقِهِ
u'مُقَابَلَةٌ طُولٌ':Added, #4: 4	مُقَابَلَةِ الطَّلَاقِ
u'مُقَابَلَةٌ ظاهِرٌ':Added, #1: 1	مُقَابَلَةِ طُولِ
u'مُقَابَلَةٌ ظاهِرٌ':Added, #1: 1	مُقَابَلَةَ الظَّاهِرِ
u'مُقَابَلَةٌ عَدَمٌ':Added, #3: 3	مُقَابَلَةِ الظَّاهِرِ
u'مُقَابَلَةٌ عَرَضٌ':Added, #1: 1	مُقَابَلَةَ الْعَدَمِ
u'مُقَابَلَةٌ عَشْرٌ':Added, #1: 1	مُقَابَلَةِ الْعَرَضِ
u'مُقَابَلَةٌ عَمَلٌ':Added, #1: 1	مُقَابَلَةِ عَشْرَةِ
u'مُقَابَلَةٌ عَمَلٌ':Added, #10: 10	مُقَابَلَةِ الْعَمَلِ
u'مُقَابَلَةٌ عَمَلٌ':Added, #1: 1	مُقَابَلَةُ الْعَمَلِ
u'مُقَابَلَةٌ عَمَلٌ':Added, #2: 2	مُقَابَلَةِ عَمَلٍ
u'مُقَابَلَةٌ عَمَلٌ':Added, #2: 2	مُقَابَلَةِ عَمَلِ
u'مُقَابَلَةٌ عِوَضٌ':Added, #9: 9	مُقَابَلَةِ عَمَلِهِ
u'مُقَابَلَةٌ عِوَضٌ':Added, #1: 1	مُقَابَلَةُ الْعِوَضِ
u'مُقَابَلَةٌ عِوَضٌ':Added, #2: 2	مُقَابَلَةِ الْعِوَضِ
u'مُقَابَلَةٌ عَيْبٌ':Added, #5: 5	مُقَابَلَةِ عِوَضٍ
u'مُقَابَلَةٌ عين':Added, #1: 1	مُقَابَلَةِ الْعَيْبِ
u'مُقَابَلَةٌ عَيْنٌ':Added, #2: 2	مُقَابَلَةِ الْعَيْنِ
u'مُقَابَلَةٌ عَيْن':Added, #2: 2	مُقَابَلَةِ الْعَيْنِ
u'مُقَابَلَةٌ عين':Added, #2: 2	مُقَابَلَةِ الْعَيْنِ
u'مُقَابَلَةٌ عَيْنٌ':Added, #2: 2	مُقَابَلَةِ عَيْنِ
u'مُقَابَلَةٌ عَيْن':Added, #2: 2	مُقَابَلَةِ عَيْنِ
u'مُقَابَلَةٌ غَالِبٌ':Added, #2: 2	مُقَابَلَةِ عَيْنِ
u'مُقَابَلَةٌ غَرَضٌ':Added, #6: 6	مُقَابَلَةِ الْغَالِبِ
u'مُقَابَلَةٌ غُرْمٌ':Added, #1: 1	مُقَابَلَةِ غَرَضٍ
u'مُقَابَلَةٌ غُنْمٌ':Added, #1: 1	مُقَابَلَةِ الْغُرْمِ
u'مُقَابَلَةٌ غير':Added, #1: 1	مُقَابَلَةِ الْغُنْمِ
u'مُقَابَلَةٌ غَيْرٌ':Added, #3: 3	مُقَابَلَةِ غَيْرِهِ
u'مُقَابَلَةٌ فَاضِلٌ':Added, #3: 3	مُقَابَلَةِ غَيْرِهِ
u'مُقَابَلَةٌ فرد':Added, #1: 1	مُقَابَلَةِ الْفَاضِلِ
u'مُقَابَلَةٌ فَرْدٌ':Added, #1: 1	مُقَابَلَةُ الْفَرْدِ
u'مُقَابَلَةٌ فرد':Added, #1: 1	مُقَابَلَةُ الْفَرْدِ
u'مُقَابَلَةٌ فَرْدٌ':Added, #4: 4	مُقَابَلَةَ الْفَرْدِ
u'مُقَابَلَةٌ فَرْضٌ':Added, #4: 4	مُقَابَلَةَ الْفَرْدِ
u'مُقَابَلَةٌ فساد':Added, #1: 1	مُقَابَلَةِ الْفَرْضِ
u'مُقَابَلَةٌ فَسَادٌ':Added, #1: 1	مُقَابَلَةِ الْفَسَادِ
u'مُقَابَلَةٌ فِعْلٌ':Added, #1: 1	مُقَابَلَةِ الْفَسَادِ
u'مُقَابَلَةٌ فِعْلٌ':Added, #1: 1	مُقَابَلَةِ فِعْلِ
u'مُقَابَلَةٌ فِعْلٌ':Added, #1: 1	مُقَابَلَةِ فِعْلِهِ
u'مُقَابَلَةٌ فَكٌّ':Added, #3: 3	مُقَابَلَةِ الْفِعْلِ
u'مُقَابَلَةٌ فَكٌّ':Added, #1: 1	مُقَابَلَةَ فَكِّ
u'مُقَابَلَةٌ فلان':Added, #2: 2	مُقَابَلَةِ فَكِّ
u'مُقَابَلَةٌ فلان':Added, #1: 1	مُقَابَلَةِ الْجُبْرَانِ
u'مُقَابَلَةٌ فُلُوسٌ':Added, #1: 1	مُقَابَلَةِ السُّلَيْمَانِيَّةِ
u'مُقَابَلَةٌ فَوَائِدُ':Added, #1: 1	مُقَابَلَةِ الْفُلُوسِ
u'مُقَابَلَةٌ قَاطِعٌ':Added, #1: 1	مُقَابَلَةِ الْفَوَائِدِ
u'مُقَابَلَةٌ قَاطِعٌ':Added, #1: 1	مُقَابَلَةِ الْقَاطِعِ
u'مُقَابَلَةٌ قَاعِدٌ':Added, #2: 2	مُقَابَلَةِ قَاطِعِ
u'مُقَابَلَةٌ قَبِيحٌ':Added, #1: 1	مُقَابَلَةِ قَاعِدَةٍ
u'مُقَابَلَةٌ قتل':Added, #2: 2	مُقَابَلَةِ الْقَبِيحِ
u'مُقَابَلَةٌ قَتْلٌ':Added, #1: 1	مُقَابَلَةِ الْقَتْلِ
u'مُقَابَلَةٌ قِرَاءةٌ':Added, #1: 1	مُقَابَلَةِ الْقَتْلِ
u'مُقَابَلَةٌ قسمة':Added, #2: 2	مُقَابَلَةِ الْقِرَاءَةِ
u'مُقَابَلَةٌ قِسْمَةٌ':Added, #1: 1	مُقَابَلَةِ الْقِسْمَةِ
u'مُقَابَلَةٌ قَلِيلٌ':Added, #1: 1	مُقَابَلَةِ الْقِسْمَةِ
u'مُقَابَلَةٌ قُوَّةٌ':Added, #1: 1	مُقَابَلَةِ الْقَلِيلِ
u'مُقَابَلَةٌ قُوَّة':Added, #1: 1	مُقَابَلَةِ قُوَّةِ
u'مُقَابَلَةٌ قَوْلٌ':Added, #1: 1	مُقَابَلَةِ قُوَّةِ
u'مُقَابَلَةٌ قَوْلٌ':Added, #1: 1	مُقَابَلَةُ قَوْلٍ
u'مُقَابَلَةٌ قول':Added, #1: 1	مُقَابَلَةِ قَوْلٍ
u'مُقَابَلَةٌ قَوْلٌ':Added, #3: 3	مُقَابَلَةِ قَوْلِهِ
u'مُقَابَلَةٌ قَوِيٌّ':Added, #3: 3	مُقَابَلَةِ قَوْلِهِ
u'مُقَابَلَةٌ قِيَاسٌ':Added, #11: 11	مُقَابَلَةِ الْقَوِيِّ
u'مُقَابَلَةٌ قِيَاسٌ':Added, #3: 3	مُقَابَلَةِ قِيَاسٍ
u'مُقَابَلَةٌ قيام':Added, #5: 5	مُقَابَلَةِ الْقِيَاسِ
u'مُقَابَلَةٌ قِيَامٌ':Added, #1: 1	مُقَابَلَةِ الْقِيَامِ
u'مُقَابَلَةٌ قيام':Added, #1: 1	مُقَابَلَةِ الْقِيَامِ
u'مُقَابَلَةٌ قِيَامٌ':Added, #1: 1	مُقَابَلَةِ قِيَامِهِ
u'مُقَابَلَةٌ كَامِلٌ':Added, #1: 1	مُقَابَلَةِ قِيَامِهِ
u'مُقَابَلَةٌ كِتَابٌ':Added, #1: 1	مُقَابَلَةِ الْكَامِلِ
u'مُقَابَلَةٌ كُتُبٌ':Added, #1: 1	مُقَابَلَةِ الْكِتَابِ
u'مُقَابَلَةٌ كَثِيرٌ':Added, #1: 1	مُقَابَلَةُ الْكُتُبِ
u'مُقَابَلَةٌ كَثِيرٌ':Added, #1: 1	مُقَابَلَةِ الْكَثِيرِ
u'مُقَابَلَةٌ كَفٌّ':Added, #1: 1	مُقَابَلَةِ كَثِيرَةِ
u'مُقَابَلَةٌ كفر':Added, #1: 1	مُقَابَلَةِ الْكَفِّ
u'مُقَابَلَةٌ كُفْرٌ':Added, #1: 1	مُقَابَلَةِ الْكُفْرِ
u'مُقَابَلَةٌ كَلاَمٌ':Added, #1: 1	مُقَابَلَةِ الْكُفْرِ
u'مُقَابَلَةٌ كِنَايَةٌ':Added, #1: 1	مُقَابَلَةِ كَلَامِ
u'مُقَابَلَةٌ كَوْنٌ':Added, #1: 1	مُقَابَلَةِ الْكِنَايَةِ
u'مُقَابَلَةٌ كِيسٌ':Added, #1: 1	مُقَابَلَةِ كَوْنِهِ
u'مُقَابَلَةٌ لبن':Added, #2: 2	مُقَابَلَةِ الْكِيسِ
u'مُقَابَلَةٌ لَبَنٌ':Added, #1: 1	مُقَابَلَةِ لَبَنِ
u'مُقَابَلَةٌ لُغَةٌ':Added, #1: 1	مُقَابَلَةِ لَبَنِ
u'مُقَابَلَةٌ لَيْلٌ':Added, #1: 1	مُقَابَلَةِ لُغَةٍ
u'مُقَابَلَةٌ مَالٌ':Added, #1: 1	مُقَابَلَةِ اللَّيْلِ
u'مُقَابَلَةٌ مَالٌ':Added, #11: 11	مُقَابَلَةِ مَالٍ
u'مُقَابَلَةٌ مَالٌ':Added, #1: 1	مُقَابَلَةُ الْمَالِ
u'مُقَابَلَةٌ مَالٌ':Added, #1: 1	مُقَابَلَةِ الْمَالِ
u'مُقَابَلَةٌ مَالٌ':Added, #1: 1	مُقَابَلَة مَالٍ
u'مُقَابَلَةٌ مَالٌ':Added, #1: 1	مُقَابَلَةِ مَالِ
u'مُقَابَلَةٌ مَالٌ':Added, #1: 1	مُقَابَلَةِ مَالِهِ
u'مُقَابَلَةٌ مَبِيعٌ':Added, #2: 2	مُقَابَلَةُ مَالٍ
u'مُقَابَلَةٌ مَبِيعٌ':Added, #1: 1	مُقَابَلَةِ الْمَبِيعِ
u'مُقَابَلَةٌ مُتَشَابِهٌ':Added, #1: 1	مُقَابَلَةِ مَبِيعٍ
u'مُقَابَلَةٌ مُتَعَلِّقٌ':Added, #1: 1	مُقَابَلَةِ الْمُتَشَابِهِ
u'مُقَابَلَةٌ مثل':Added, #1: 1	مُقَابَلَةِ الْمُتَعَلِّقِ
u'مُقَابَلَةٌ مِثْلٌ':Added, #1: 1	مُقَابَلَةِ مِثْلِ
u'مُقَابَلَةٌ مثل':Added, #1: 1	مُقَابَلَةِ مِثْلِ
u'مُقَابَلَةٌ مِثْلٌ':Added, #3: 3	مُقَابَلَةِ مِثْلِهِ
u'مُقَابَلَةٌ مُجْتَهِد':Added, #3: 3	مُقَابَلَةِ مِثْلِهِ
u'مُقَابَلَةٌ مُجْتَهِد':Added, #1: 1	مُقَابَلَةَ الْمُجْتَهِدِ
u'مُقَابَلَةٌ مَجْمُوعٌ':Added, #1: 1	مُقَابَلَةِ الْمُجْتَهِدِ
u'مُقَابَلَةٌ مَحَبَّةٌ':Added, #1: 1	مُقَابَلَةَ مَجْمُوعِ
u'مُقَابَلَةٌ مُحَقَّقٌ':Added, #1: 1	مُقَابَلَةِ الْمَحَبَّةِ
u'مُقَابَلَةٌ مُدٌّ':Added, #1: 1	مُقَابَلَةِ الْمُحَقَّقِ
u'مُقَابَلَةٌ مُدٌّ':Added, #1: 1	مُقَابَلَةِ الْمُدِّ
u'مُقَابَلَةٌ مَذْهَبٌ':Added, #2: 2	مُقَابَلَةِ مُدٍّ
u'مُقَابَلَةٌ مُسْتَحَبٌّ':Added, #1: 1	مُقَابَلَةِ الْمَذْهَبِ
u'مُقَابَلَةٌ مِسْكٌ':Added, #1: 1	مُقَابَلَةِ الْمُسْتَحَبِّ
u'مُقَابَلَةٌ مُضَافٌ':Added, #1: 1	مُقَابَلَةِ الْمِسْكَيْنِ
u'مُقَابَلَةٌ مُعَجَّلٌ':Added, #1: 1	مُقَابَلَةِ الْمُضَافِ
u'مُقَابَلَةٌ مُلْزِمٌ':Added, #1: 1	مُقَابَلَةِ الْمُعَجَّلَةِ
u'مُقَابَلَةٌ مِلْكٌ':Added, #1: 1	مُقَابَلَةِ الْمُلْزِمِ
u'مُقَابَلَةٌ مِلْكٌ':Added, #1: 1	مُقَابَلَةِ الْمِلْكِ
u'مُقَابَلَةٌ مِلْكٌ':Added, #1: 1	مُقَابَلَةِ مِلْكِهِ
u'مُقَابَلَةٌ مُمْتَنِعٌ':Added, #4: 4	مُقَابَلَةِ مِلْكِ
u'مُقَابَلَةٌ مَنَافِعُ':Added, #1: 1	مُقَابَلَةِ الْمُمْتَنِعِ
u'مُقَابَلَةٌ مَنَافِعُ':Added, #1: 1	مُقَابَلَةِ الْمَنَافِعِ
u'مُقَابَلَةٌ مَنَافِعُ':Added, #1: 1	مُقَابَلَةِ مَنَافِعِهِ
u'مُقَابَلَةٌ مَنْفَعَةٌ':Added, #3: 3	مُقَابَلَةِ مَنَافِعِ
u'مُقَابَلَةٌ مَنْفَعَةٌ':Added, #1: 1	مُقَابَلَةِ الْمَنْفَعَةِ
u'مُقَابَلَةٌ مَنْفَعَةٌ':Added, #1: 1	مُقَابَلَةِ مَنْفَعَةٍ
u'مُقَابَلَةٌ مَنْقُولٌ':Added, #2: 2	مُقَابَلَةِ مَنْفَعَةِ
u'مُقَابَلَةٌ مَهْرٌ':Added, #3: 3	مُقَابَلَةِ الْمَنْقُولِ
u'مُقَابَلَةٌ مَوْهُوبٌ':Added, #1: 1	مُقَابَلَةِ الْمَهْرِ
u'مُقَابَلَةٌ ميل':Added, #1: 1	مُقَابَلَةِ الْمَوْهُوبِ
u'مُقَابَلَةٌ مَيْلٌ':Added, #1: 1	مُقَابَلَةِ الْمَيْلِ
u'مُقَابَلَةٌ نَجَس':Added, #1: 1	مُقَابَلَةِ الْمَيْلِ
u'مُقَابَلَةٌ نَصٌّ':Added, #1: 1	مُقَابَلَةُ النَّجَسِيَّةِ
u'مُقَابَلَةٌ نِصْفٌ':Added, #33: 33	مُقَابَلَةِ النَّصِّ
u'مُقَابَلَةٌ نِصْفٌ':Added, #1: 1	مُقَابَلَةِ النِّصْفِ
u'مُقَابَلَةٌ نِصْفٌ':Added, #1: 1	مُقَابَلَةُ نِصْفِ
u'مُقَابَلَةٌ نَصْلٌ':Added, #2: 2	مُقَابَلَةُ نِصْفِهِ
u'مُقَابَلَةٌ نُصُوصٌ':Added, #1: 1	مُقَابَلَةِ النَّصْلِ
u'مُقَابَلَةٌ نِعَمٌ':Added, #2: 2	مُقَابَلَةِ النُّصُوصِ
u'مُقَابَلَةٌ نعمة':Added, #1: 1	مُقَابَلَةِ نِعَمِهِ
u'مُقَابَلَةٌ نِعْمَةٌ':Added, #1: 1	مُقَابَلَةِ نِعْمَةٍ
u'مُقَابَلَةٌ نَفَقَةٌ':Added, #1: 1	مُقَابَلَةِ نِعْمَةٍ
u'مُقَابَلَةٌ نُفُوسٌ':Added, #1: 1	مُقَابَلَةِ النَّفَقَةِ
u'مُقَابَلَةٌ نَقْصٌ':Added, #2: 2	مُقَابَلَةَ النُّفُوسِ
u'مُقَابَلَةٌ نَقْصٌ':Added, #1: 1	مُقَابَلَةِ النَّقْصِ
u'مُقَابَلَةٌ نكاح':Added, #1: 1	مُقَابَلَةِ نَقْصِ
u'مُقَابَلَةٌ نِكَاحٌ':Added, #1: 1	مُقَابَلَةِ النِّكَاحِ
u'مُقَابَلَةٌ نُكْتَةٌ':Added, #1: 1	مُقَابَلَةِ النِّكَاحِ
u'مُقَابَلَةٌ هَدْيٌ':Added, #1: 1	مُقَابَلَةِ النُّكْتَةِ
u'مُقَابَلَةٌ واحد':Added, #1: 1	مُقَابَلَةِ الْهَدْيِ
u'مُقَابَلَةٌ وَاحِدٌ':Added, #1: 1	مُقَابَلَةِ الْوَاحِدَةِ
u'مُقَابَلَةٌ واحد':Added, #1: 1	مُقَابَلَةِ الْوَاحِدَةِ
u'مُقَابَلَةٌ وَاحِدٌ':Added, #2: 2	مُقَابَلَةُ الْوَاحِدِ
u'مُقَابَلَةٌ واحد':Added, #2: 2	مُقَابَلَةُ الْوَاحِدِ
u'مُقَابَلَةٌ وَاحِدٌ':Added, #3: 3	مُقَابَلَةِ الْوَاحِدِ
u'مُقَابَلَةٌ وَجْهٌ':Added, #3: 3	مُقَابَلَةِ الْوَاحِدِ
u'مُقَابَلَةٌ وَجْهٌ':Added, #1: 1	مُقَابَلَةِ وَجْهٍ
u'مُقَابَلَةٌ وُجُوبٌ':Added, #1: 1	مُقَابَلَةُ وَجْهِهِ
u'مُقَابَلَةٌ وُجُودٌ':Added, #3: 3	مُقَابَلَةِ وُجُوبِ
u'مُقَابَلَةٌ وَطْءٌ':Added, #1: 1	مُقَابَلَةِ الْوُجُودِ
u'مُقَابَلَةٌ وَلاَءٌ':Added, #2: 2	مُقَابَلَةِ الْوَطْءِ
u'مُقَابَلَةٌ يَوْمٌ':Added, #2: 2	مُقَابَلَةِ وَلَاءِ
u'مُقَابَلٌ تالِف':Added, #1: 1	مُقَابَلَةِ الْيَوْمِ
u'مُقَابَلٌ تِبْن':Added, #1: 1	مُقَابَلَةِ التَّالِفَةِ
u'مُقَابَلٌ تَحْرِيرٌ':Added, #1: 1	مُقَابَلَةِ التِّبْنِ
u'مُقَابَلٌ تَرْكٌ':Added, #1: 1	مُقَابَلَةِ تَحْرِيرِ
u'مُقَابَلٌ تَسْلِيمٌ':Added, #4: 4	مُقَابَلَةِ تَرْكِ
u'مُقَابَلٌ تَصْرِيحٌ':Added, #1: 1	مُقَابَلَةُ تَسْلِيمٍ
u'مُقَابَلٌ تَعْلِيقٌ':Added, #1: 1	مُقَابَلَةِ التَّصْرِيحِ
u'مُقَابَلٌ تَعْلِيلٌ':Added, #1: 1	مُقَابَلَةُ التَّعْلِيقِ
u'مُقَابَلٌ تَعْوِيضٌ':Added, #1: 1	مُقَابَلَةِ تَعْلِيلِ
u'مُقَابَلٌ تَقْصيرٌ':Added, #1: 1	مُقَابَلَةِ تَعْوِيضِهِ
u'مُقَابَلٌ تَكَلُّمٌ':Added, #1: 1	مُقَابَلَةِ التَّقْصِيرِ
u'مُقَابَلٌ تَمْكِين':Added, #1: 1	مُقَابَلَةِ التَّكَلُّمِ
u'مُقَابَلٌ تَوْفِيرٌ':Added, #6: 6	مُقَابَلَةِ التَّمْكِينِ
u'مُقَابَلٌ ثَانِي':Added, #1: 1	مُقَابَلَةِ تَوْفِيرِ
u'مُقَابَلٌ ثَانِيَةٌ':Added, #2: 2	مُقَابَلَةِ الثَّانِيَةِ
u'مُقَابَلٌ ثُبُوتٌ':Added, #2: 2	مُقَابَلَةِ الثَّانِيَةِ
u'مُقَابَلٌ ثَلاثُ':Added, #1: 1	مُقَابَلَةِ ثُبُوتِ
u'مُقَابَلٌ ثَلاثَةٌ':Added, #6: 6	مُقَابَلَةِ الثَّلَاثِ
u'مُقَابَلٌ ثَلاثَةٌ':Added, #1: 1	مُقَابَلَةِ ثَلَاثَةِ
u'مُقَابَلٌ ثَمَنٌ':Added, #2: 2	مُقَابَلَةِ ثَلَاثَةٍ
u'مُقَابَلٌ ثَوابٌ':Added, #4: 4	مُقَابَلَةِ الثَّمَنِ
u'مُقَابَلٌ ثَوْبٌ':Added, #1: 1	مُقَابَلَةِ الثَّوَابِ
u'مُقَابَلٌ جُزْءٌ':Added, #1: 1	مُقَابَلَةِ الثَّوْبِ
u'مُقَابَلٌ جُزْءٌ':Added, #2: 2	مُقَابَلَةِ جُزْءٍ
u'مُقَابَلٌ جَمَاعَةٌ':Added, #4: 4	مُقَابَلَةِ الْجُزْءِ
u'مُقَابَلٌ جمع':Added, #1: 1	مُقَابَلَةِ الْجَمَاعَةِ
u'مُقَابَلٌ جَمْعٌ':Added, #1: 1	مُقَابَلَةُ الْجَمْعِ
u'مُقَابَلٌ جمع':Added, #1: 1	مُقَابَلَةُ الْجَمْعِ
u'مُقَابَلٌ جَمْعٌ':Added, #3: 3	مُقَابَلَةِ الْجَمْعِ
u'مُقَابَلٌ جمع':Added, #3: 3	مُقَابَلَةِ الْجَمْعِ
u'مُقَابَلٌ جَمْعٌ':Added, #5: 5	مُقَابَلَةَ الْجَمْعِ
u'مُقَابَلٌ جُمْلَةٌ':Added, #5: 5	مُقَابَلَةَ الْجَمْعِ
u'مُقَابَلٌ جُمْلَةٌ':Added, #1: 1	مُقَابَلَةَ الْجُمْلَةِ
u'مُقَابَلٌ جُمْلَةٌ':Added, #1: 1	مُقَابَلَةُ الْجُمْلَةِ
u'مُقَابَلٌ جَمِيع':Added, #1: 1	مُقَابَلَةُ جُمْلَةٍ
u'مُقَابَلٌ جِنَايَةٌ':Added, #2: 2	مُقَابَلَةِ الْجَمِيعِ
u'مُقَابَلٌ جِنَايَةٌ':Added, #1: 1	مُقَابَلَةَ الْجِنَايَةِ
u'مُقَابَلٌ جِنَايَةٌ':Added, #1: 1	مُقَابَلَةِ الْجِنَايَةِ
u'مُقَابَلٌ جِنْسٌ':Added, #3: 3	مُقَابَلَةِ جِنَايَةٍ
u'مُقَابَلٌ جِنْسٌ':Added, #1: 1	مُقَابَلَةَ الْجِنْسِ
u'مُقَابَلٌ جِنْسٌ':Added, #1: 1	مُقَابَلَةُ الْجِنْسِ
u'مُقَابَلٌ جِنْسٌ':Added, #1: 1	مُقَابَلَةِ جِنْسِ
u'مُقَابَلٌ جِنْسٌ':Added, #2: 2	مُقَابَلَةِ جِنْسِهِ
u'مُقَابَلٌ جِهَةٌ':Added, #3: 3	مُقَابَلَةِ الْجِنْسِ
u'مُقَابَلٌ حُبٌّ':Added, #1: 1	مُقَابَلَةِ جِهَةِ
u'مُقَابَلٌ حَجَرٌ':Added, #1: 1	مُقَابَلَةِ حُبِّ
u'مُقَابَلٌ حُجْرَةٌ':Added, #1: 1	مُقَابَلَةِ الْحَجَرِ
u'مُقَابَلٌ حُدوثٌ':Added, #1: 1	مُقَابَلَةِ حُجْرَةِ
u'مُقَابَلٌ حُرٌّ':Added, #2: 2	مُقَابَلَةِ حُدُوثِ
u'مُقَابَلٌ حَقٌّ':Added, #1: 1	مُقَابَلَةَ الْحُرِّ
u'مُقَابَلٌ حَمْلٌ':Added, #1: 1	مُقَابَلَةَ الْحَقِّ
u'مُقَابَلٌ خُبْزٌ':Added, #1: 1	مُقَابَلَةِ الْحَمْلِ
u'مُقَابَلٌ خُصُومَةٌ':Added, #1: 1	مُقَابَلَةِ الْخُبْزِ
u'مُقَابَلٌ خَطٌّ':Added, #3: 3	مُقَابَلَةِ الْخُصُومَةِ
u'مُقَابَلٌ خُلْعٌ':Added, #2: 2	مُقَابَلَةِ الْخَطِّ
u'مُقَابَلٌ دَارٌ':Added, #1: 1	مُقَابَلَةِ الْخُلْعِ
u'مُقَابَلٌ دِرْهَمٌ':Added, #1: 1	مُقَابَلَةَ الدَّارِ
u'مُقَابَلٌ دِرْهَم':Added, #2: 2	مُقَابَلَةِ الدِّرْهَمِ
u'مُقَابَلٌ دفع':Added, #2: 2	مُقَابَلَةِ الدِّرْهَمِ
u'مُقَابَلٌ دَفْعٌ':Added, #1: 1	مُقَابَلَةِ الدَّفْعِ
u'مُقَابَلٌ دِيَةٌ':Added, #1: 1	مُقَابَلَةِ الدَّفْعِ
u'مُقَابَلٌ دَيْنٌ':Added, #1: 1	مُقَابَلَةِ الدِّيَةِ
u'مُقَابَلٌ دَيْنٌ':Added, #2: 2	مُقَابَلَةِ دَيْنِ
u'مُقَابَلٌ دَيْنٌ':Added, #3: 3	مُقَابَلَةِ الدَّيْنِ
u'مُقَابَلٌ دِينارٌ':Added, #4: 4	مُقَابَلَةِ دَيْنِهِ
u'مُقَابَلٌ ذَبٌّ':Added, #1: 1	مُقَابَلَةِ الدِّينَارِ
u'مُقَابَلٌ ذِراعٌ':Added, #2: 2	مُقَابَلَةِ الذَّبِّ
u'مُقَابَلٌ ذكر':Added, #2: 2	مُقَابَلَةِ الذِّرَاعِ
u'مُقَابَلٌ ذَكَرٌ':Added, #1: 1	مُقَابَلَةِ الذَّكَرِ
u'مُقَابَلٌ رَاجِحٌ':Added, #1: 1	مُقَابَلَةِ الذَّكَرِ
u'مُقَابَلٌ رَأْسٌ':Added, #4: 4	مُقَابَلَةِ الرَّاجِحِ
u'مُقَابَلٌ رَامِحٌ':Added, #1: 1	مُقَابَلَةِ رَأْسِ
u'مُقَابَلٌ رَجُلٌ':Added, #1: 1	مُقَابَلَةِ الرّامِحِ
u'مُقَابَلٌ رُخْصَةٌ':Added, #1: 1	مُقَابَلَةِ الرَّجُلَيْنِ
u'مُقَابَلٌ رُخْصَةٌ':Added, #1: 1	مُقَابَلَةِ الرُّخْصَةِ
u'مُقَابَلٌ رَدٌّ':Added, #1: 1	مُقَابَلَةِ رُخْصَةٍ
u'مُقَابَلٌ رَدٌّ':Added, #1: 1	مُقَابَلَةِ الرَّدِّ
u'مُقَابَلٌ رَقَبَةٌ':Added, #1: 1	مُقَابَلَةِ رَدِّهِ
u'مُقَابَلٌ زائِدٌ':Added, #1: 1	مُقَابَلَةِ رَقَبَتِهِ
u'مُقَابَلٌ زِيادَةٌ':Added, #2: 2	مُقَابَلَةِ الزَّائِدِ
u'مُقَابَلٌ سِتٌّ':Added, #2: 2	مُقَابَلَةِ الزِّيَادَةِ
u'مُقَابَلٌ سِتٌّ':Added, #1: 1	مُقَابَلَةِ السِّتَّةِ
u'مُقَابَلٌ سِتٌّ':Added, #1: 1	مُقَابَلَةِ سِتٍّ
u'مُقَابَلٌ سَلاَمَةٌ':Added, #1: 1	مُقَابَلَةِ سِتَّةٍ
u'مُقَابَلٌ سَلْطَنَةٌ':Added, #1: 1	مُقَابَلَةِ السَّلَامَةِ
u'مُقَابَلٌ سَلِيمٌ':Added, #1: 1	مُقَابَلَةِ سَلْطَنَةِ
u'مُقَابَلٌ سُلَيْمانِيّ':Added, #2: 2	مُقَابَلَةِ السَّلِيمِ
u'مُقَابَلٌ سِواكٌ':Added, #1: 1	مُقَابَلَةِ السُّلَيْمَانِيَّةِ
u'مُقَابَلٌ سَيِّئٌ':Added, #1: 1	مُقَابَلَةِ السِّوَاكِ
u'مُقَابَلٌ شَائِعٌ':Added, #1: 1	مُقَابَلَةِ سَيِّئَاتِهِ
u'مُقَابَلٌ شَخْصٌ':Added, #1: 1	مُقَابَلَةِ الشَّائِعِ
u'مُقَابَلٌ شَرْطٌ':Added, #1: 1	مُقَابَلَةِ شَخْصٍ
u'مُقَابَلٌ شَرْطٌ':Added, #1: 1	مُقَابَلَةَ الشَّرْطِ
u'مُقَابَلٌ شِفَاءٌ':Added, #1: 1	مُقَابَلَةُ الشَّرْطِ
u'مُقَابَلٌ شَفَاعَةٌ':Added, #2: 2	مُقَابَلَةِ الشِّفَاءِ
u'مُقَابَلٌ شمس':Added, #1: 1	مُقَابَلَةِ شَفَاعَةٍ
u'مُقَابَلٌ شَمْسٌ':Added, #5: 5	مُقَابَلَةِ الشَّمْسِ
u'مُقَابَلٌ شَيْءٌ':Added, #5: 5	مُقَابَلَةِ الشَّمْسِ
u'مُقَابَلٌ شَيْءٌ':Added, #15: 15	مُقَابَلَةِ شَيْءٍ
u'مُقَابَلٌ صبر':Added, #2: 2	مُقَابَلَةُ شَيْءٍ
u'مُقَابَلٌ صَبْرٌ':Added, #1: 1	مُقَابَلَةِ صَبْرِهِ
u'مُقَابَلٌ صَبِيٌّ':Added, #1: 1	مُقَابَلَةِ صَبْرِهِ
u'مُقَابَلٌ صَحَابَةٌ':Added, #1: 1	مُقَابَلَةِ الصَّبِيِّ
u'مُقَابَلٌ صِحَّةٌ':Added, #1: 1	مُقَابَلَةِ الصَّحَابَةِ
u'مُقَابَلٌ صَحِيحٌ':Added, #2: 2	مُقَابَلَةِ صِحَّةِ
u'مُقَابَلٌ صداق':Added, #1: 1	مُقَابَلَةِ الصَّحِيحِ
u'مُقَابَلٌ صَدَاقٌ':Added, #1: 1	مُقَابَلَةِ الصَّدَاقِ
u'مُقَابَلٌ صَرِيحٌ':Added, #1: 1	مُقَابَلَةِ الصَّدَاقِ
u'مُقَابَلٌ صِفَةٌ':Added, #2: 2	مُقَابَلَةِ الصَّرِيحِ
u'مُقَابَلٌ ضَرَرٌ':Added, #1: 1	مُقَابَلَةِ صِفَاتِ
u'مُقَابَلٌ ضَمَانٌ':Added, #1: 1	مُقَابَلَةِ ضَرَرٍ
u'مُقَابَلٌ طَلاَقٌ':Added, #1: 1	مُقَابَلَةِ الضَّمَانِ
u'مُقَابَلٌ طَلاَقٌ':Added, #1: 1	مُقَابَلَةِ طَلَاقٍ
u'مُقَابَلٌ طَلاَقٌ':Added, #1: 1	مُقَابَلَةِ طَلَاقِهِ
u'مُقَابَلٌ طُولٌ':Added, #4: 4	مُقَابَلَةِ الطَّلَاقِ
u'مُقَابَلٌ ظاهِرٌ':Added, #1: 1	مُقَابَلَةِ طُولِ
u'مُقَابَلٌ ظاهِرٌ':Added, #1: 1	مُقَابَلَةَ الظَّاهِرِ
u'مُقَابَلٌ عَدَمٌ':Added, #3: 3	مُقَابَلَةِ الظَّاهِرِ
u'مُقَابَلٌ عَرَضٌ':Added, #1: 1	مُقَابَلَةَ الْعَدَمِ
u'مُقَابَلٌ عَشْرٌ':Added, #1: 1	مُقَابَلَةِ الْعَرَضِ
u'مُقَابَلٌ عَمَلٌ':Added, #1: 1	مُقَابَلَةِ عَشْرَةِ
u'مُقَابَلٌ عَمَلٌ':Added, #10: 10	مُقَابَلَةِ الْعَمَلِ
u'مُقَابَلٌ عَمَلٌ':Added, #1: 1	مُقَابَلَةُ الْعَمَلِ
u'مُقَابَلٌ عَمَلٌ':Added, #2: 2	مُقَابَلَةِ عَمَلٍ
u'مُقَابَلٌ عَمَلٌ':Added, #2: 2	مُقَابَلَةِ عَمَلِ
u'مُقَابَلٌ عِوَضٌ':Added, #9: 9	مُقَابَلَةِ عَمَلِهِ
u'مُقَابَلٌ عِوَضٌ':Added, #1: 1	مُقَابَلَةُ الْعِوَضِ
u'مُقَابَلٌ عِوَضٌ':Added, #2: 2	مُقَابَلَةِ الْعِوَضِ
u'مُقَابَلٌ عَيْبٌ':Added, #5: 5	مُقَابَلَةِ عِوَضٍ
u'مُقَابَلٌ عين':Added, #1: 1	مُقَابَلَةِ الْعَيْبِ
u'مُقَابَلٌ عَيْنٌ':Added, #2: 2	مُقَابَلَةِ الْعَيْنِ
u'مُقَابَلٌ عَيْن':Added, #2: 2	مُقَابَلَةِ الْعَيْنِ
u'مُقَابَلٌ عين':Added, #2: 2	مُقَابَلَةِ الْعَيْنِ
u'مُقَابَلٌ عَيْنٌ':Added, #2: 2	مُقَابَلَةِ عَيْنِ
u'مُقَابَلٌ عَيْن':Added, #2: 2	مُقَابَلَةِ عَيْنِ
u'مُقَابَلٌ غَالِبٌ':Added, #2: 2	مُقَابَلَةِ عَيْنِ
u'مُقَابَلٌ غَرَضٌ':Added, #6: 6	مُقَابَلَةِ الْغَالِبِ
u'مُقَابَلٌ غُرْمٌ':Added, #1: 1	مُقَابَلَةِ غَرَضٍ
u'مُقَابَلٌ غُنْمٌ':Added, #1: 1	مُقَابَلَةِ الْغُرْمِ
u'مُقَابَلٌ غير':Added, #1: 1	مُقَابَلَةِ الْغُنْمِ
u'مُقَابَلٌ غَيْرٌ':Added, #3: 3	مُقَابَلَةِ غَيْرِهِ
u'مُقَابَلٌ فَاضِلٌ':Added, #3: 3	مُقَابَلَةِ غَيْرِهِ
u'مُقَابَلٌ فرد':Added, #1: 1	مُقَابَلَةِ الْفَاضِلِ
u'مُقَابَلٌ فَرْدٌ':Added, #1: 1	مُقَابَلَةُ الْفَرْدِ
u'مُقَابَلٌ فرد':Added, #1: 1	مُقَابَلَةُ الْفَرْدِ
u'مُقَابَلٌ فَرْدٌ':Added, #4: 4	مُقَابَلَةَ الْفَرْدِ
u'مُقَابَلٌ فَرْضٌ':Added, #4: 4	مُقَابَلَةَ الْفَرْدِ
u'مُقَابَلٌ فساد':Added, #1: 1	مُقَابَلَةِ الْفَرْضِ
u'مُقَابَلٌ فَسَادٌ':Added, #1: 1	مُقَابَلَةِ الْفَسَادِ
u'مُقَابَلٌ فِعْلٌ':Added, #1: 1	مُقَابَلَةِ الْفَسَادِ
u'مُقَابَلٌ فِعْلٌ':Added, #1: 1	مُقَابَلَةِ فِعْلِ
u'مُقَابَلٌ فِعْلٌ':Added, #1: 1	مُقَابَلَةِ فِعْلِهِ
u'مُقَابَلٌ فَكٌّ':Added, #3: 3	مُقَابَلَةِ الْفِعْلِ
u'مُقَابَلٌ فَكٌّ':Added, #1: 1	مُقَابَلَةَ فَكِّ
u'مُقَابَلٌ فلان':Added, #2: 2	مُقَابَلَةِ فَكِّ
u'مُقَابَلٌ فلان':Added, #1: 1	مُقَابَلَةِ الْجُبْرَانِ
u'مُقَابَلٌ فُلُوسٌ':Added, #1: 1	مُقَابَلَةِ السُّلَيْمَانِيَّةِ
u'مُقَابَلٌ فَوَائِدُ':Added, #1: 1	مُقَابَلَةِ الْفُلُوسِ
u'مُقَابَلٌ قَاطِعٌ':Added, #1: 1	مُقَابَلَةِ الْفَوَائِدِ
u'مُقَابَلٌ قَاطِعٌ':Added, #1: 1	مُقَابَلَةِ الْقَاطِعِ
u'مُقَابَلٌ قَاعِدٌ':Added, #2: 2	مُقَابَلَةِ قَاطِعِ
u'مُقَابَلٌ قَبِيحٌ':Added, #1: 1	مُقَابَلَةِ قَاعِدَةٍ
u'مُقَابَلٌ قتل':Added, #2: 2	مُقَابَلَةِ الْقَبِيحِ
u'مُقَابَلٌ قَتْلٌ':Added, #1: 1	مُقَابَلَةِ الْقَتْلِ
u'مُقَابَلٌ قِرَاءةٌ':Added, #1: 1	مُقَابَلَةِ الْقَتْلِ
u'مُقَابَلٌ قسمة':Added, #2: 2	مُقَابَلَةِ الْقِرَاءَةِ
u'مُقَابَلٌ قِسْمَةٌ':Added, #1: 1	مُقَابَلَةِ الْقِسْمَةِ
u'مُقَابَلٌ قَلِيلٌ':Added, #1: 1	مُقَابَلَةِ الْقِسْمَةِ
u'مُقَابَلٌ قُوَّةٌ':Added, #1: 1	مُقَابَلَةِ الْقَلِيلِ
u'مُقَابَلٌ قُوَّة':Added, #1: 1	مُقَابَلَةِ قُوَّةِ
u'مُقَابَلٌ قَوْلٌ':Added, #1: 1	مُقَابَلَةِ قُوَّةِ
u'مُقَابَلٌ قَوْلٌ':Added, #1: 1	مُقَابَلَةُ قَوْلٍ
u'مُقَابَلٌ قول':Added, #1: 1	مُقَابَلَةِ قَوْلٍ
u'مُقَابَلٌ قَوْلٌ':Added, #3: 3	مُقَابَلَةِ قَوْلِهِ
u'مُقَابَلٌ قَوِيٌّ':Added, #3: 3	مُقَابَلَةِ قَوْلِهِ
u'مُقَابَلٌ قِيَاسٌ':Added, #11: 11	مُقَابَلَةِ الْقَوِيِّ
u'مُقَابَلٌ قِيَاسٌ':Added, #3: 3	مُقَابَلَةِ قِيَاسٍ
u'مُقَابَلٌ قيام':Added, #5: 5	مُقَابَلَةِ الْقِيَاسِ
u'مُقَابَلٌ قِيَامٌ':Added, #1: 1	مُقَابَلَةِ الْقِيَامِ
u'مُقَابَلٌ قيام':Added, #1: 1	مُقَابَلَةِ الْقِيَامِ
u'مُقَابَلٌ قِيَامٌ':Added, #1: 1	مُقَابَلَةِ قِيَامِهِ
u'مُقَابَلٌ كَامِلٌ':Added, #1: 1	مُقَابَلَةِ قِيَامِهِ
u'مُقَابَلٌ كِتَابٌ':Added, #1: 1	مُقَابَلَةِ الْكَامِلِ
u'مُقَابَلٌ كُتُبٌ':Added, #1: 1	مُقَابَلَةِ الْكِتَابِ
u'مُقَابَلٌ كَثِيرٌ':Added, #1: 1	مُقَابَلَةُ الْكُتُبِ
u'مُقَابَلٌ كَثِيرٌ':Added, #1: 1	مُقَابَلَةِ الْكَثِيرِ
u'مُقَابَلٌ كَفٌّ':Added, #1: 1	مُقَابَلَةِ كَثِيرَةِ
u'مُقَابَلٌ كفر':Added, #1: 1	مُقَابَلَةِ الْكَفِّ
u'مُقَابَلٌ كُفْرٌ':Added, #1: 1	مُقَابَلَةِ الْكُفْرِ
u'مُقَابَلٌ كَلاَمٌ':Added, #1: 1	مُقَابَلَةِ الْكُفْرِ
u'مُقَابَلٌ كِنَايَةٌ':Added, #1: 1	مُقَابَلَةِ كَلَامِ
u'مُقَابَلٌ كَوْنٌ':Added, #1: 1	مُقَابَلَةِ الْكِنَايَةِ
u'مُقَابَلٌ كِيسٌ':Added, #1: 1	مُقَابَلَةِ كَوْنِهِ
u'مُقَابَلٌ لبن':Added, #2: 2	مُقَابَلَةِ الْكِيسِ
u'مُقَابَلٌ لَبَنٌ':Added, #1: 1	مُقَابَلَةِ لَبَنِ
u'مُقَابَلٌ لُغَةٌ':Added, #1: 1	مُقَابَلَةِ لَبَنِ
u'مُقَابَلٌ لَيْلٌ':Added, #1: 1	مُقَابَلَةِ لُغَةٍ
u'مُقَابَلٌ مَالٌ':Added, #1: 1	مُقَابَلَةِ اللَّيْلِ
u'مُقَابَلٌ مَالٌ':Added, #11: 11	مُقَابَلَةِ مَالٍ
u'مُقَابَلٌ مَالٌ':Added, #1: 1	مُقَابَلَةُ الْمَالِ
u'مُقَابَلٌ مَالٌ':Added, #1: 1	مُقَابَلَةِ الْمَالِ
u'مُقَابَلٌ مَالٌ':Added, #1: 1	مُقَابَلَة مَالٍ
u'مُقَابَلٌ مَالٌ':Added, #1: 1	مُقَابَلَةِ مَالِ
u'مُقَابَلٌ مَالٌ':Added, #1: 1	مُقَابَلَةِ مَالِهِ
u'مُقَابَلٌ مَبِيعٌ':Added, #2: 2	مُقَابَلَةُ مَالٍ
u'مُقَابَلٌ مَبِيعٌ':Added, #1: 1	مُقَابَلَةِ الْمَبِيعِ
u'مُقَابَلٌ مُتَشَابِهٌ':Added, #1: 1	مُقَابَلَةِ مَبِيعٍ
u'مُقَابَلٌ مُتَعَلِّقٌ':Added, #1: 1	مُقَابَلَةِ الْمُتَشَابِهِ
u'مُقَابَلٌ مثل':Added, #1: 1	مُقَابَلَةِ الْمُتَعَلِّقِ
u'مُقَابَلٌ مِثْلٌ':Added, #1: 1	مُقَابَلَةِ مِثْلِ
u'مُقَابَلٌ مثل':Added, #1: 1	مُقَابَلَةِ مِثْلِ
u'مُقَابَلٌ مِثْلٌ':Added, #3: 3	مُقَابَلَةِ مِثْلِهِ
u'مُقَابَلٌ مُجْتَهِد':Added, #3: 3	مُقَابَلَةِ مِثْلِهِ
u'مُقَابَلٌ مُجْتَهِد':Added, #1: 1	مُقَابَلَةَ الْمُجْتَهِدِ
u'مُقَابَلٌ مَجْمُوعٌ':Added, #1: 1	مُقَابَلَةِ الْمُجْتَهِدِ
u'مُقَابَلٌ مَحَبَّةٌ':Added, #1: 1	مُقَابَلَةَ مَجْمُوعِ
u'مُقَابَلٌ مُحَقَّقٌ':Added, #1: 1	مُقَابَلَةِ الْمَحَبَّةِ
u'مُقَابَلٌ مُدٌّ':Added, #1: 1	مُقَابَلَةِ الْمُحَقَّقِ
u'مُقَابَلٌ مُدٌّ':Added, #1: 1	مُقَابَلَةِ الْمُدِّ
u'مُقَابَلٌ مَذْهَبٌ':Added, #2: 2	مُقَابَلَةِ مُدٍّ
u'مُقَابَلٌ مُسْتَحَبٌّ':Added, #1: 1	مُقَابَلَةِ الْمَذْهَبِ
u'مُقَابَلٌ مِسْكٌ':Added, #1: 1	مُقَابَلَةِ الْمُسْتَحَبِّ
u'مُقَابَلٌ مُضَافٌ':Added, #1: 1	مُقَابَلَةِ الْمِسْكَيْنِ
u'مُقَابَلٌ مُعَجَّلٌ':Added, #1: 1	مُقَابَلَةِ الْمُضَافِ
u'مُقَابَلٌ مُلْزِمٌ':Added, #1: 1	مُقَابَلَةِ الْمُعَجَّلَةِ
u'مُقَابَلٌ مِلْكٌ':Added, #1: 1	مُقَابَلَةِ الْمُلْزِمِ
u'مُقَابَلٌ مِلْكٌ':Added, #1: 1	مُقَابَلَةِ الْمِلْكِ
u'مُقَابَلٌ مِلْكٌ':Added, #1: 1	مُقَابَلَةِ مِلْكِهِ
u'مُقَابَلٌ مُمْتَنِعٌ':Added, #4: 4	مُقَابَلَةِ مِلْكِ
u'مُقَابَلٌ مَنَافِعُ':Added, #1: 1	مُقَابَلَةِ الْمُمْتَنِعِ
u'مُقَابَلٌ مَنَافِعُ':Added, #1: 1	مُقَابَلَةِ الْمَنَافِعِ
u'مُقَابَلٌ مَنَافِعُ':Added, #1: 1	مُقَابَلَةِ مَنَافِعِهِ
u'مُقَابَلٌ مَنْفَعَةٌ':Added, #3: 3	مُقَابَلَةِ مَنَافِعِ
u'مُقَابَلٌ مَنْفَعَةٌ':Added, #1: 1	مُقَابَلَةِ الْمَنْفَعَةِ
u'مُقَابَلٌ مَنْفَعَةٌ':Added, #1: 1	مُقَابَلَةِ مَنْفَعَةٍ
u'مُقَابَلٌ مَنْقُولٌ':Added, #2: 2	مُقَابَلَةِ مَنْفَعَةِ
u'مُقَابَلٌ مَهْرٌ':Added, #3: 3	مُقَابَلَةِ الْمَنْقُولِ
u'مُقَابَلٌ مَوْهُوبٌ':Added, #1: 1	مُقَابَلَةِ الْمَهْرِ
u'مُقَابَلٌ ميل':Added, #1: 1	مُقَابَلَةِ الْمَوْهُوبِ
u'مُقَابَلٌ مَيْلٌ':Added, #1: 1	مُقَابَلَةِ الْمَيْلِ
u'مُقَابَلٌ نَجَس':Added, #1: 1	مُقَابَلَةِ الْمَيْلِ
u'مُقَابَلٌ نَصٌّ':Added, #1: 1	مُقَابَلَةُ النَّجَسِيَّةِ
u'مُقَابَلٌ نِصْفٌ':Added, #33: 33	مُقَابَلَةِ النَّصِّ
u'مُقَابَلٌ نِصْفٌ':Added, #1: 1	مُقَابَلَةِ النِّصْفِ
u'مُقَابَلٌ نِصْفٌ':Added, #1: 1	مُقَابَلَةُ نِصْفِ
u'مُقَابَلٌ نَصْلٌ':Added, #2: 2	مُقَابَلَةُ نِصْفِهِ
u'مُقَابَلٌ نُصُوصٌ':Added, #1: 1	مُقَابَلَةِ النَّصْلِ
u'مُقَابَلٌ نِعَمٌ':Added, #2: 2	مُقَابَلَةِ النُّصُوصِ
u'مُقَابَلٌ نعمة':Added, #1: 1	مُقَابَلَةِ نِعَمِهِ
u'مُقَابَلٌ نِعْمَةٌ':Added, #1: 1	مُقَابَلَةِ نِعْمَةٍ
u'مُقَابَلٌ نَفَقَةٌ':Added, #1: 1	مُقَابَلَةِ نِعْمَةٍ
u'مُقَابَلٌ نُفُوسٌ':Added, #1: 1	مُقَابَلَةِ النَّفَقَةِ
u'مُقَابَلٌ نَقْصٌ':Added, #2: 2	مُقَابَلَةَ النُّفُوسِ
u'مُقَابَلٌ نَقْصٌ':Added, #1: 1	مُقَابَلَةِ النَّقْصِ
u'مُقَابَلٌ نكاح':Added, #1: 1	مُقَابَلَةِ نَقْصِ
u'مُقَابَلٌ نِكَاحٌ':Added, #1: 1	مُقَابَلَةِ النِّكَاحِ
u'مُقَابَلٌ نُكْتَةٌ':Added, #1: 1	مُقَابَلَةِ النِّكَاحِ
u'مُقَابَلٌ هَدْيٌ':Added, #1: 1	مُقَابَلَةِ النُّكْتَةِ
u'مُقَابَلٌ واحد':Added, #1: 1	مُقَابَلَةِ الْهَدْيِ
u'مُقَابَلٌ وَاحِدٌ':Added, #1: 1	مُقَابَلَةِ الْوَاحِدَةِ
u'مُقَابَلٌ واحد':Added, #1: 1	مُقَابَلَةِ الْوَاحِدَةِ
u'مُقَابَلٌ وَاحِدٌ':Added, #2: 2	مُقَابَلَةُ الْوَاحِدِ
u'مُقَابَلٌ واحد':Added, #2: 2	مُقَابَلَةُ الْوَاحِدِ
u'مُقَابَلٌ وَاحِدٌ':Added, #3: 3	مُقَابَلَةِ الْوَاحِدِ
u'مُقَابَلٌ وَجْهٌ':Added, #3: 3	مُقَابَلَةِ الْوَاحِدِ
u'مُقَابَلٌ وَجْهٌ':Added, #1: 1	مُقَابَلَةِ وَجْهٍ
u'مُقَابَلٌ وُجُوبٌ':Added, #1: 1	مُقَابَلَةُ وَجْهِهِ
u'مُقَابَلٌ وُجُودٌ':Added, #3: 3	مُقَابَلَةِ وُجُوبِ
u'مُقَابَلٌ وَطْءٌ':Added, #1: 1	مُقَابَلَةِ الْوُجُودِ
u'مُقَابَلٌ وَلاَءٌ':Added, #2: 2	مُقَابَلَةِ الْوَطْءِ
u'مُقَابَلٌ يَوْمٌ':Added, #2: 2	مُقَابَلَةِ وَلَاءِ
u'مُقَارَبَةٌ أَجَلٌ':Added, #1: 1	مُقَابَلَةِ الْيَوْمِ
u'مُقَارَبَةٌ اِنْقِضاءٌ':Added, #1: 1	مُقَارَبَةُ الْأَجَلِ
u'مُقَارَبَةٌ بُلُوغٌ':Added, #1: 1	مُقَارَبَةُ انْقِضَاءِ
u'مُقَارَبَةٌ صَاحِبٌ':Added, #1: 1	مُقَارَبَةِ الْبُلُوغِ
u'مُقَارَبَةٌ نِيَّةٌ':Added, #1: 1	مُقَارَبَةَ صَاحِبِهِ
u'مُقَارَعَةٌ خُصُومٌ':Added, #1: 1	مُقَارَبَةِ النِّيَّةِ
u'مُقَارَنٌ أحَدٌ':Added, #1: 1	مُقَارَعَةُ الْخُصُومِ
u'مُقَارَنٌ أَوَّلُ':Added, #1: 1	مُقَارَنَةُ أَحَدِ
u'مُقَارَنٌ إيمَانٌ':Added, #1: 1	مُقَارَنَةُ أَوَّلِ
u'مُقَارَنَةٌ أحَدٌ':Added, #2: 2	مُقَارَنَةُ الْإِيمَانِ
u'مُقَارَنَةٌ أَوَّلُ':Added, #1: 1	مُقَارَنَةُ أَحَدِ
u'مُقَارَنَةٌ إيمَانٌ':Added, #1: 1	مُقَارَنَةُ أَوَّلِ
u'مُقَارَنَةٌ تَكْبيرٌ':Added, #2: 2	مُقَارَنَةُ الْإِيمَانِ
u'مُقَارَنَةٌ حُرِّيَّةٌ':Added, #2: 2	مُقَارَنَةَ التَّكْبِيرِ
u'مُقَارَنَةٌ حُصُول':Added, #1: 1	مُقَارَنَةُ الْحُرِّيَّةِ
u'مُقَارَنَةٌ خُرُوجٌ':Added, #1: 1	مُقَارَنَةِ حُصُولِ
u'مُقَارَنَةٌ دَالٌ':Added, #1: 1	مُقَارَنَةُ الْخُرُوجِ
u'مُقَارَنَةٌ دلك':Added, #1: 1	مُقَارَنَةِ الدَّالِ
u'مُقَارَنَةٌ دَلْكٌ':Added, #1: 1	مُقَارَنَةُ الدَّلْكِ
u'مُقَارَنَةٌ دَليلٌ':Added, #1: 1	مُقَارَنَةُ الدَّلْكِ
u'مُقَارَنَةٌ رَفْعٌ':Added, #1: 1	مُقَارَنَةُ الدَّلِيلِ
u'مُقَارَنَةٌ سَبَبٌ':Added, #1: 1	مُقَارَنَةُ الرَّفْعِ
u'مُقَارَنَةٌ شَرْطٌ':Added, #2: 2	مُقَارَنَةُ السَّبَبِ
u'مُقَارَنَةٌ شَرْطٌ':Added, #1: 1	مُقَارَنَةُ شَرْطِ
u'مُقَارَنَةٌ شَرْطٌ':Added, #2: 2	مُقَارَنَةَ الشَّرْطِ
u'مُقَارَنَةٌ شَهْوَةٌ':Added, #2: 2	مُقَارَنَةُ الشَّرْطِ
u'مُقَارَنَةٌ صَلاَةٌ':Added, #1: 1	مُقَارَنَةُ الشَّهْوَةِ
u'مُقَارَنَةٌ عِلَّةٌ':Added, #1: 1	مُقَارَنَةِ الصَّلَاةِ
u'مُقَارَنَةٌ قدرة':Added, #3: 3	مُقَارَنَةِ الْعِلَّةِ
u'مُقَارَنَةٌ قدرة':Added, #1: 1	مُقَارَنَةَ الْقُدْرَةِ
u'مُقَارَنَةٌ قُدْرَةٌ':Added, #1: 1	مُقَارَنَةِ الْقُدْرَةِ
u'مُقَارَنَةٌ قُدْرَةٌ':Added, #1: 1	مُقَارَنَةَ الْقُدْرَةِ
u'مُقَارَنَةٌ كُفْرٌ':Added, #1: 1	مُقَارَنَةِ الْقُدْرَةِ
u'مُقَارَنَةٌ لَفْظٌ':Added, #1: 1	مُقَارَنَةِ كُفْرٍ
u'مُقَارَنَةٌ مَانِعٌ':Added, #1: 1	مُقَارَنَةُ اللَّفْظِ
u'مُقَارَنَةٌ مَانِعٌ':Added, #1: 1	مُقَارَنَةُ الْمَانِعِ
u'مُقَارَنَةٌ مُتَجَدِّدٌ':Added, #1: 1	مُقَارَنَةِ الْمَانِعِ
u'مُقَارَنَةٌ مَجْمُوعٌ':Added, #1: 1	مُقَارَنَةُ مُتَجَدِّدٍ
u'مُقَارَنَةٌ مَجْمُوعٌ':Added, #1: 1	مُقَارَنَةِ الْمَجْمُوعِ
u'مُقَارَنَةٌ مُخَصَّصٌ':Added, #2: 2	مُقَارَنَةُ الْمَجْمُوعِ
u'مُقَارَنَةٌ مَنْعٌ':Added, #1: 1	مُقَارَنَةَ الْمُخَصَّصِ
u'مُقَارَنَةٌ نَفْيٌ':Added, #1: 1	مُقَارَنَةِ الْمَنْعِ
u'مُقَارَنَةٌ نكاح':Added, #1: 1	مُقَارَنَةُ النَّفْيِ
u'مُقَارَنَةٌ نِكَاحٌ':Added, #1: 1	مُقَارَنَةِ النِّكَاحِ
u'مُقَارَنَةٌ نِيَّةٌ':Added, #1: 1	مُقَارَنَةِ النِّكَاحِ
u'مُقَارَنَةٌ نِيَّةٌ':Added, #3: 3	مُقَارَنَةِ النِّيَّةِ
u'مُقَارَنَةٌ يسار':Added, #9: 9	مُقَارَنَةُ النِّيَّةِ
u'مُقَارَنَةٌ يَسَارٌ':Added, #1: 1	مُقَارَنَةُ الْيَسَارِ
u'مُقَارَنٌ تَكْبيرٌ':Added, #1: 1	مُقَارَنَةُ الْيَسَارِ
u'مُقَارَنٌ حُرِّيَّةٌ':Added, #2: 2	مُقَارَنَةَ التَّكْبِيرِ
u'مُقَارَنٌ حُصُول':Added, #1: 1	مُقَارَنَةُ الْحُرِّيَّةِ
u'مُقَارَنٌ خُرُوجٌ':Added, #1: 1	مُقَارَنَةِ حُصُولِ
u'مُقَارَنٌ دَالٌ':Added, #1: 1	مُقَارَنَةُ الْخُرُوجِ
u'مُقَارَنٌ دلك':Added, #1: 1	مُقَارَنَةِ الدَّالِ
u'مُقَارَنٌ دَلْكٌ':Added, #1: 1	مُقَارَنَةُ الدَّلْكِ
u'مُقَارَنٌ دَليلٌ':Added, #1: 1	مُقَارَنَةُ الدَّلْكِ
u'مُقَارَنٌ رَفْعٌ':Added, #1: 1	مُقَارَنَةُ الدَّلِيلِ
u'مُقَارَنٌ سَبَبٌ':Added, #1: 1	مُقَارَنَةُ الرَّفْعِ
u'مُقَارَنٌ شَرْطٌ':Added, #2: 2	مُقَارَنَةُ السَّبَبِ
u'مُقَارَنٌ شَرْطٌ':Added, #1: 1	مُقَارَنَةُ شَرْطِ
u'مُقَارَنٌ شَرْطٌ':Added, #2: 2	مُقَارَنَةَ الشَّرْطِ
u'مُقَارَنٌ شَهْوَةٌ':Added, #2: 2	مُقَارَنَةُ الشَّرْطِ
u'مُقَارَنٌ صَلاَةٌ':Added, #1: 1	مُقَارَنَةُ الشَّهْوَةِ
u'مُقَارَنٌ عِلَّةٌ':Added, #1: 1	مُقَارَنَةِ الصَّلَاةِ
u'مُقَارَنٌ قدرة':Added, #3: 3	مُقَارَنَةِ الْعِلَّةِ
u'مُقَارَنٌ قدرة':Added, #1: 1	مُقَارَنَةَ الْقُدْرَةِ
u'مُقَارَنٌ قُدْرَةٌ':Added, #1: 1	مُقَارَنَةِ الْقُدْرَةِ
u'مُقَارَنٌ قُدْرَةٌ':Added, #1: 1	مُقَارَنَةَ الْقُدْرَةِ
u'مُقَارَنٌ كُفْرٌ':Added, #1: 1	مُقَارَنَةِ الْقُدْرَةِ
u'مُقَارَنٌ لَفْظٌ':Added, #1: 1	مُقَارَنَةِ كُفْرٍ
u'مُقَارَنٌ مَانِعٌ':Added, #1: 1	مُقَارَنَةُ اللَّفْظِ
u'مُقَارَنٌ مَانِعٌ':Added, #1: 1	مُقَارَنَةُ الْمَانِعِ
u'مُقَارَنٌ مُتَجَدِّدٌ':Added, #1: 1	مُقَارَنَةِ الْمَانِعِ
u'مُقَارَنٌ مَجْمُوعٌ':Added, #1: 1	مُقَارَنَةُ مُتَجَدِّدٍ
u'مُقَارَنٌ مَجْمُوعٌ':Added, #1: 1	مُقَارَنَةِ الْمَجْمُوعِ
u'مُقَارَنٌ مُخَصَّصٌ':Added, #2: 2	مُقَارَنَةُ الْمَجْمُوعِ
u'مُقَارَنٌ مَنْعٌ':Added, #1: 1	مُقَارَنَةَ الْمُخَصَّصِ
u'مُقَارَنٌ نَفْيٌ':Added, #1: 1	مُقَارَنَةِ الْمَنْعِ
u'مُقَارَنٌ نكاح':Added, #1: 1	مُقَارَنَةُ النَّفْيِ
u'مُقَارَنٌ نِكَاحٌ':Added, #1: 1	مُقَارَنَةِ النِّكَاحِ
u'مُقَارَنٌ نِيَّةٌ':Added, #1: 1	مُقَارَنَةِ النِّكَاحِ
u'مُقَارَنٌ نِيَّةٌ':Added, #3: 3	مُقَارَنَةِ النِّيَّةِ
u'مُقَارَنٌ يسار':Added, #9: 9	مُقَارَنَةُ النِّيَّةِ
u'مُقَارَنٌ يَسَارٌ':Added, #1: 1	مُقَارَنَةُ الْيَسَارِ
u'مُقَاصَّةٌ دَيْنٌ':Added, #1: 1	مُقَارَنَةُ الْيَسَارِ
u'مَقَالٌ إمَامٌ':Added, #1: 1	مُقَاصَّةِ الدَّيْنَيْنِ
u'مَقَالَةٌ اِبْنٌ':Added, #2: 2	مَقَالِ الْإِمَامِ
u'مَقَالَةٌ اِبْنٌ':Added, #1: 1	مَقَالَةُ ابْنِ
u'مَقَالَةٌ اِبْنٌ':Added, #1: 1	مَقَالَةِ ابْنِ
u'مَقَالَةٌ اِبْنٌ':Added, #1: 1	مَقَالَةَ ابْنِهِ
u'مَقَالَةٌ أُسْتَاذٌ':Added, #3: 3	مَقَالَةَ ابْنِ
u'مَقَالَةٌ إمَامٌ':Added, #1: 1	مَقَالَةَ الْأُسْتَاذِ
u'مَقَالَةٌ إمَامٌ':Added, #4: 4	مَقَالَةَ الْإِمَامِ
u'مَقَالَةٌ بَائِعٌ':Added, #6: 6	مَقَالَةِ الْإِمَامِ
u'مَقَالَةٌ بَعْضٌ':Added, #1: 1	مَقَالَةِ الْبَائِعِ
u'مَقَالَةٌ تِلْميذٌ':Added, #4: 4	مَقَالَةِ بَعْضِ
u'مَقَالَةٌ رَاهِبٌ':Added, #1: 1	مَقَالَةِ تِلْمِيذِهِ
u'مَقَالَةٌ رَسُولٌ':Added, #1: 1	مَقَالَةِ الرّاهِبِ
u'مَقَالَةٌ رَسُولٌ':Added, #1: 1	مَقَالَةَ رَسُولِ
u'مَقَالَةٌ سُوءٌ':Added, #1: 1	مَقَالَةِ رَسُولِ
u'مَقَالَةٌ سُوءٌ':Added, #1: 1	مَقَالَةُ السّوءِ
u'مَقَالَةٌ صَاحِبٌ':Added, #1: 1	مَقَالَةُ السُّوءِ
u'مَقَالَةٌ صَاحِبٌ':Added, #1: 1	مَقَالَةَ صَاحِبِ
u'مَقَالَةٌ عَاذِلٌ':Added, #1: 1	مَقَالَةِ صَاحِبِ
u'مَقَالَةٌ عَبْدٌ':Added, #1: 1	مَقَالَةَ عَاذِلٍ
u'مَقَالَةٌ عَبْدٌ':Added, #1: 1	مَقَالَةَ عَبْدِ
u'مَقَالَةٌ علماء':Added, #1: 1	مَقَالَةُ عَبْدِ
u'مَقَالَةٌ عُلَمَاءُ':Added, #1: 1	مَقَالَةِ الْعُلَمَاءِ
u'مَقَالَةٌ غَائِبٌ':Added, #1: 1	مَقَالَةِ الْعُلَمَاءِ
u'مَقَالَةٌ غير':Added, #2: 2	مَقَالَةَ غَائِبٍ
u'مَقَالَةٌ غَيْرٌ':Added, #1: 1	مَقَالَةِ غَيْرِهِ
u'مَقَالَةٌ قَائِلٌ':Added, #1: 1	مَقَالَةِ غَيْرِهِ
u'مَقَالَةٌ قَائِلٌ':Added, #1: 1	مَقَالَةَ قَائِلِ
u'مَقَالَةٌ مَالِكٌ':Added, #1: 1	مَقَالَةِ قَائِلٍ
u'مَقَالَةٌ مُعْتَزِلٌ':Added, #1: 1	مَقَالَةِ مَالِكٍ
u'مَقَالَةٌ مُعْتَزِلٌ':Added, #1: 1	مَقَالَةَ الْمُعْتَزِلَةِ
u'مَقَالَةٌ مُعْتَزِلَةٌ':Added, #1: 1	مَقَالَةِ الْمُعْتَزِلَةِ
u'مَقَالَةٌ مُعْتَزِلَةٌ':Added, #1: 1	مَقَالَةَ الْمُعْتَزِلَةِ
u'مَقَالَةٌ نَاسٌ':Added, #1: 1	مَقَالَةِ الْمُعْتَزِلَةِ
u'مَقَالَةٌ نَوَوِيٌّ':Added, #1: 1	مَقَالَةِ النَّاسِ
u'مَقَالَةٌ وَاهِبٌ':Added, #1: 1	مَقَالَةَ النَّوَوِيِّ
u'مَقَالَةٌ وَكِيلٌ':Added, #1: 1	مَقَالَةَ الْوَاهِبِ
u'مَقَالَةٌ يهود':Added, #1: 1	مَقَالَةِ الْوَكِيلِ
u'مَقَالَةٌ يَهُودٌ':Added, #1: 1	مَقَالَةُ الْيَهُودِ
u'مَقَالٌ شَرْعٌ':Added, #1: 1	مَقَالَةُ الْيَهُودِ
u'مَقَالٌ عَكْسٌ':Added, #1: 1	مَقَالِ الشَّرْعِ
u'مَقَالٌ قَائِلٌ':Added, #1: 1	مَقَالُ الْعَكْسِ
u'مَقَالٌ قَوْمٌ':Added, #1: 1	مَقَالِ الْقَائِلِ
u'مُقَامٌ أَبٌ':Added, #1: 1	مَقَالُ الْقَوْمِ
u'مُقَامٌ أَرْبَعَةٌ':Added, #2: 2	مُقَامَ الْأَبِ
u'مُقَامٌ أَرْبَعَةٌ':Added, #1: 1	مُقَامَ أَرْبَعَةِ
u'مُقَامٌ إِسَالَةٌ':Added, #1: 1	مُقَامِ أَرْبَعَةِ
u'مُقَامٌ أَفْعَالٌ':Added, #1: 1	مُقَامَ الْإِسَالَةِ
u'مُقَامٌ إقْرَارٌ':Added, #1: 1	مُقَامَ أَفْعَالِ
u'مُقَامٌ إمَامٌ':Added, #1: 1	مُقَامَ إقْرَارِهِ
u'مُقَامٌ إِيجَابٌ':Added, #3: 3	مُقَامِ الإِمَامِ
u'مُقَامٌ بَاطن':Added, #1: 1	مُقَامَ الْإِيجَابِ
u'مُقَامٌ باطِنٌ':Added, #1: 1	مُقَامَ الْبَاطِنِ
u'مُقَامٌ بِكْرٌ':Added, #1: 1	مُقَامَ الْبَاطِنِ
u'مُقَامٌ حَقِيقٌ':Added, #1: 1	مُقَامُ الْبِكْرِ
u'مُقَامٌ حَقِيقَةٌ':Added, #8: 8	مُقَامَ حَقِيقَةِ
u'مُقَامٌ دِبَاغٌ':Added, #8: 8	مُقَامَ حَقِيقَةِ
u'مُقَامٌ دُخُولٌ':Added, #1: 1	مُقَامَ الدِّبَاغِ
u'مُقَامٌ رَجُلٌ':Added, #1: 1	مُقَامَ الدُّخُولِ
u'مُقَامٌ رَجُلٌ':Added, #1: 1	مُقَامُ الرَّجُلِ
u'مُقَامٌ سَابِقٌ':Added, #1: 1	مُقَامُ رَجُلٍ
u'مُقَامٌ سَابِقٌ':Added, #1: 1	مُقَامُ السَّابِقِ
u'مُقَامٌ سَاكِنٌ':Added, #1: 1	مُقَامُ سَابِقٍ
u'مُقَامٌ شَرْطٌ':Added, #1: 1	مُقَامُ سَاكِنِ
u'مُقَامٌ صَفٌّ':Added, #1: 1	مُقَامَ شَرْطٍ
u'مُقَامٌ عِبَارَةٌ':Added, #1: 1	مُقَامِ الصَّفِّ
u'مُقَامٌ عِبَارَةٌ':Added, #1: 1	مُقَامَ الْعِبَارَةِ
u'مُقَامٌ عِلَّةٌ':Added, #1: 1	مُقَامَ عِبَارَتِهِ
u'مُقَامٌ علم':Added, #1: 1	مُقَامَ الْعِلَّةِ
u'مُقَامٌ عِلْمٌ':Added, #1: 1	مُقَامَ الْعِلْمِ
u'مُقَامٌ غُسْلٌ':Added, #1: 1	مُقَامَ الْعِلْمِ
u'مُقَامٌ فِعْلٌ':Added, #1: 1	مُقَامَ الْغُسْلِ
u'مُقَامٌ قَبُولٌ':Added, #1: 1	مُقَامَ فِعْلِ
u'مُقَامٌ كَيْلٌ':Added, #1: 1	مُقَامَ الْقَبُولِ
u'مُقَامٌ مَدْلُولٌ':Added, #1: 1	مُقَامَ الْكَيْلِ
u'مُقَامٌ مَدْلُولٌ':Added, #1: 1	مُقَامَ الْمَدْلُولِ
u'مُقَامٌ مُطَلَّقٌ':Added, #1: 1	مُقَامَ مَدْلُولِهِ
u'مُقَامٌ مُعْدِمٌ':Added, #1: 1	مُقَامِ الْمُطَلَّقَةِ
u'مُقَامٌ مَعْقُودٌ':Added, #1: 1	مُقَامَ الْمُعْدِمِ
u'مُقَامٌ مَفْعُولٌ':Added, #1: 1	مُقَامَ الْمَعْقُودِ
u'مُقَامٌ مِلْكٌ':Added, #1: 1	مُقَامَ الْمَفْعُولِ
u'مُقَامٌ مَنْفَعَةٌ':Added, #1: 1	مُقَامَ مِلْكِ
u'مُقَامٌ مُهَاجِرٌ':Added, #1: 1	مُقَامَ الْمَنْفَعَةِ
u'مُقَامٌ نَفْسٌ':Added, #1: 1	مُقَامِ الْمُهَاجِرِ
u'مُقَامٌ وَاجِبٌ':Added, #3: 3	مُقَامَ نَفْسِهِ
u'مُقَامٌ واحد':Added, #1: 1	مُقَامَ الْوَاجِبِ
u'مُقَامٌ واحد':Added, #1: 1	مُقَامٍ وَاحِدٍ
u'مُقَامٌ وَاحِدٌ':Added, #1: 1	مُقَامُ وَاحِدٍ
u'مُقَامٌ وَاحِدٌ':Added, #1: 1	مُقَامٍ وَاحِدٍ
u'مُقَامٌ وُجُوبٌ':Added, #1: 1	مُقَامُ وَاحِدٍ
u'مُقَامٌ وُجُوبٌ':Added, #1: 1	مُقَامَ وُجُوبِ
u'مُقَامٌ وَطْءٌ':Added, #3: 3	مُقَامَ الْوُجُوبِ
u'مُقَامٌ يَقْظَان':Added, #3: 3	مُقَامَ الْوَطْءِ
u'مُقَاوَمَةٌ إمَامٌ':Added, #1: 1	مُقَامَ الْيَقْظَانِ
u'مُقَاوَمَةٌ حَبَشَة':Added, #1: 1	مُقَاوَمَةُ الْإِمَامِ
u'مُقَاوَمَةٌ سُلْطَانٌ':Added, #1: 1	مُقَاوَمَةُ الْحَبَشَةِ
u'مُقَاوَمَةٌ صَرِيحٌ':Added, #1: 1	مُقَاوَمَةُ السُّلْطَانِ
u'مُقَاوَمَةٌ عَدُوٌّ':Added, #1: 1	مُقَاوَمَةِ الصَّرِيحِ
u'مُقَاوَمَةٌ نَصٌّ':Added, #1: 1	مُقَاوَمَةِ عَدُوِّهِ
u'مَقْتٌ حسد':Added, #1: 1	مُقَاوَمَةِ النَّصِّ
u'مَقْتٌ حَسَدٌ':Added, #1: 1	مَقْتُ الْحَسَدِ
u'مَقْتٌ نَاسٌ':Added, #1: 1	مَقْتُ الْحَسَدِ
u'مَقْدَمٌ رَسُولٌ':Added, #1: 1	مَقْتُ النَّاسِ
u'مَقْدَمٌ رَسُولٌ':Added, #2: 2	مَقْدَمَ رَسُولِ
u'مَقْدَمٌ نَبِيٌّ':Added, #9: 9	مَقْدَمِ رَسُولِ
u'مَقْدَمٌ نَبِيٌّ':Added, #2: 2	مَقْدَمَ النَّبِيِّ
u'مَقْطَعٌ حَقٌّ':Added, #2: 2	مَقْدَمِ النَّبِيِّ
u'مَقْطَعٌ حُقوقٌ':Added, #2: 2	مَقْطَعِ الْحَقِّ
u'مَقْطَعٌ حُقُوقٌ':Added, #2: 2	مَقْطَعُ الْحُقُوقِ
u'مَقْطَعٌ فَصَاحَةٌ':Added, #2: 2	مَقْطَعُ الْحُقُوقِ
u'مَقْطَعٌ مَحْسُوبٌ':Added, #1: 1	مَقْطَعِ الْفَصَاحَةِ
u'مُكَابَرَةٌ عَقْلٌ':Added, #1: 1	مَقْطَعٍ مَحْسُوبٍ
u'مُكَابَرَةٌ نَفْسٌ':Added, #1: 1	مُكَابَرَةِ الْعَقْلِ
u'مُكَاتَبَةٌ أَبٌ':Added, #1: 1	مُكَابَرَةِ نَفْسِهِ
u'مُكَاتَبَةٌ أُمٌّ':Added, #2: 2	مُكَاتَبَةِ الْأَبِ
u'مُكَاتَبَةٌ أُمٌّ':Added, #2: 2	مُكَاتَبَةِ أُمِّ
u'مُكَاتَبَةٌ إمَامٌ':Added, #3: 3	مُكَاتَبَةِ الْأُمِّ
u'مُكَاتَبَةٌ أمَةٌ':Added, #1: 1	مُكَاتَبَةُ الْإِمَامِ
u'مُكَاتَبَةٌ أهْلٌ':Added, #2: 2	مُكَاتَبَةِ الْأَمَةِ
u'مُكَاتَبَةٌ أهْلٌ':Added, #1: 1	مُكَاتَبَةَ أَهْلِ
u'مُكَاتَبَةٌ أَوَّلُ':Added, #1: 1	مُكَاتَبَةِ أَهْلِ
u'مُكَاتَبَةٌ أَوَّلُ':Added, #11: 11	مُكَاتَبَةِ الْأَوَّلِ
u'مُكَاتَبَةٌ جَمَاعَةٌ':Added, #3: 3	مُكَاتَبَةُ الْأَوَّلِ
u'مُكَاتَبَةٌ حاكِمٌ':Added, #1: 1	مُكَاتَبَةُ جَمَاعَةٍ
u'مُكَاتَبَةٌ ذِمِّيٌّ':Added, #1: 1	مُكَاتَبَةِ حَاكِمِ
u'مُكَاتَبَةٌ رَجُلٌ':Added, #2: 2	مُكَاتَبَةُ الذِّمِّيِّ
u'مُكَاتَبَةٌ رَجُلٌ':Added, #1: 1	مُكَاتَبَةُ الرَّجُلِ
u'مُكَاتَبَةٌ رَجُلٌ':Added, #1: 1	مُكَاتَبَةِ الرَّجُلِ
u'مُكَاتَبَةٌ رَقيقٌ':Added, #1: 1	مُكَاتَبَةِ الرَّجُلَيْنِ
u'مُكَاتَبَةٌ رَقيق':Added, #1: 1	مُكَاتَبَةُ رَقِيقٍ
u'مُكَاتَبَةٌ رَقيقٌ':Added, #1: 1	مُكَاتَبَةُ رَقِيقٍ
u'مُكَاتَبَةٌ رَقيق':Added, #1: 1	مُكَاتَبَةُ رَقِيقِهِ
u'مُكَاتَبَةٌ رَقيقٌ':Added, #1: 1	مُكَاتَبَةُ رَقِيقِهِ
u'مُكَاتَبَةٌ رَقيق':Added, #2: 2	مُكَاتَبَةَ الرَّقِيقِ
u'مُكَاتَبَةٌ رَهْنٌ':Added, #2: 2	مُكَاتَبَةَ الرَّقِيقِ
u'مُكَاتَبَةٌ رُؤَسَاءُ':Added, #1: 1	مُكَاتَبَةٍ رَهْنٍ
u'مُكَاتَبَةٌ سَيِّدٌ':Added, #1: 1	مُكَاتَبَةِ الرُّؤَسَاءِ
u'مُكَاتَبَةٌ صَغِيرٌ':Added, #1: 1	مُكَاتَبَةِ سَيِّدِهِ
u'مُكَاتَبَةٌ صَغِيرٌ':Added, #1: 1	مُكَاتَبَةُ الصَّغِيرِ
u'مُكَاتَبَةٌ عَبْدٌ':Added, #1: 1	مُكَاتَبَةِ الصَّغِيرِ
u'مُكَاتَبَةٌ عَبْدٌ':Added, #1: 1	مُكَاتَبَةَ الْعَبْدِ
u'مُكَاتَبَةٌ عَبْدٌ':Added, #1: 1	مُكَاتَبَةِ الْعَبْدَيْنِ
u'مُكَاتَبَةٌ عَبْدٌ':Added, #1: 1	مُكَاتَبَةِ عَبْدِهِ
u'مُكَاتَبَةٌ غير':Added, #2: 2	مُكَاتَبَةُ عَبْدِهِ
u'مُكَاتَبَةٌ غَيْرٌ':Added, #1: 1	مُكَاتَبَةُ غَيْرِهِ
u'مُكَاتَبَةٌ فُلاَنٌ':Added, #1: 1	مُكَاتَبَةُ غَيْرِهِ
u'مُكَاتَبَةٌ فُلاَنٌ':Added, #1: 1	مُكَاتَبَةَ فُلَانٍ
u'مُكَاتَبَةٌ مثل':Added, #1: 1	مُكَاتَبَةُ فُلَانِ
u'مُكَاتَبَةٌ مثل':Added, #1: 1	مُكَاتَبَةَ مِثْلِهِ
u'مُكَاتَبَةٌ مِثْلٌ':Added, #1: 1	مُكَاتَبَةُ مِثْلِهِ
u'مُكَاتَبَةٌ مِثْلٌ':Added, #1: 1	مُكَاتَبَةَ مِثْلِهِ
u'مُكَاتَبَةٌ مثل':Added, #1: 1	مُكَاتَبَةُ مِثْلِهِ
u'مُكَاتَبَةٌ مِثْلٌ':Added, #5: 5	مُكَاتَبَةِ مِثْلِهِ
u'مُكَاتَبَةٌ مُدَبَّرٌ':Added, #5: 5	مُكَاتَبَةِ مِثْلِهِ
u'مُكَاتَبَةٌ مُرْتَدٌّ':Added, #1: 1	مُكَاتَبَةِ الْمُدَبَّرِ
u'مُكَاتَبَةٌ مُرْتَدٌّ':Added, #1: 1	مُكَاتَبَةُ الْمُرْتَدِّ
u'مُكَاتَبَةٌ مَرِيضٌ':Added, #1: 1	مُكَاتَبَةِ الْمُرْتَدِّ
u'مُكَاتَبَةٌ مُسْلِمٌ':Added, #2: 2	مُكَاتَبَةِ الْمَرِيضِ
u'مُكَاتَبَةٌ مُسْلِمٌ':Added, #1: 1	مُكَاتَبَةُ الْمُسْلِمِ
u'مُكَاتَبَةٌ نَصِيبٌ':Added, #1: 1	مُكَاتَبَةِ الْمُسْلِمِ
u'مُكَاتَبَةٌ نَظِيرٌ':Added, #1: 1	مُكَاتَبَةِ نَصِيبِهِ
u'مُكَاتَبَةٌ وَصِيٌّ':Added, #1: 1	مُكَاتَبَةِ النَّظِيرِ
u'مُكَاتَبَةٌ ولد':Added, #1: 1	مُكَاتَبَةِ الْوَصِيِّ
u'مُكَاتَبَةٌ وَلَدٌ':Added, #1: 1	مُكَاتَبَةَ وَلَدِهِ
u'مُكَاشَفَةٌ حالٌ':Added, #1: 1	مُكَاتَبَةَ وَلَدِهِ
u'مُكَافَأَةٌ دُعَاءٌ':Added, #1: 1	مُكَاشَفَةِ الْحَالِ
u'مُكَافَأَةٌ قصاص':Added, #1: 1	مُكَافَأَةَ الدُّعَاءِ
u'مُكَافَأَةٌ قِصَاصٌ':Added, #1: 1	مُكَافَأَةِ الْقِصَاصِ
u'مُكَافَحَةٌ أَعْدَاءٌ':Added, #1: 1	مُكَافَأَةِ الْقِصَاصِ
u'مُكَافَحَةٌ عَدُوٌّ':Added, #1: 1	مُكَافَحَةِ الْأَعْدَاءِ
u'مَكَانَةٌ اِبْنٌ':Added, #2: 2	مُكَافَحَةَ الْعَدُوِّ
u'مَكَانَةٌ وَدِيعَةٌ':Added, #2: 2	مَكَانَةُ ابْنِ
u'مُكَايَدَةٌ عَدُوٌّ':Added, #1: 1	مَكَانَةَ وَدِيعَةٍ
u'مَكَثَ أَكْثَرُ':Predicate, #2: 2	مُكَايَدَةِ الْعَدُوِّ
u'مَكَثَ إمَامٌ':Subject, #1: 1	مَكَثَ أَكْثَرَ
u'مُكْثٌ إمَامٌ':Added, #1: 1	مَكَثَ الإِمَامُ
u'مُكْثٌ إمَامٌ':Added, #1: 1	مُكْثِ الإِمَامِ
u'مَكَثَ رَجُلٌ':Subject, #1: 1	مُكْثِ الْإِمَامِ
u'مَكَثَ رَسُولٌ':Subject, #1: 1	مَكَثَ الرَّجُلُ
u'مَكَثَ سُرَّاقٌ':Subject, #6: 6	مَكَثَ رَسُولُ
u'مُكْثٌ سِلْعَةٌ':Added, #1: 1	مَكَثَ السُّرَّاقُ
u'مَكَثَ ضَرٌّ':Predicate, #1: 1	مُكْثُ السِّلْعَةِ
u'مَكَثَ ضَيِّقٌ':Subject, #1: 1	مَكَثَ ضَرَّ
u'مَكَثَ عند':Predicate, #1: 1	مَكَثَ الضَّيِّقُ
u'مَكَثَ قَدْرٌ':Predicate, #1: 1	مَكَثَ عِنْدَ
u'مَكَثَ مثل':Predicate, #4: 4	مَكَثَ قَدْرَ
u'مَكَثَ مِثْلٌ':Predicate, #1: 1	مَكَثَ مِثْلَ
u'مَكَثَ مُدَّةٌ':Predicate, #1: 1	مَكَثَ مِثْلَ
u'مَكَثَ مِقْدَارٌ':Predicate, #1: 1	مَكَثَ الْمُدَّةَ
u'مُكْثٌ مِقْدَارٌ':Added, #1: 1	مَكَثَ مِقْدَارَ
u'مَكَثَ نَبِيٌّ':Subject, #1: 1	مُكْثُ الْمِقْدَارِ
u'مُكْثٌ نَحْوٌ':Added, #2: 2	مَكَثَ النَّبِيُّ
u'مُكْثٌ وَحْيٌ':Added, #1: 1	مُكْثِ نَحْوِ
u'مُكْثٌ ولد':Added, #1: 1	مُكْثُ الْوَحْيِ
u'مُكْثٌ وَلَدٌ':Added, #1: 1	مُكْثُ الْوَلَدِ
u'مَكَثَ يَقْظَان':Predicate, #1: 1	مُكْثُ الْوَلَدِ
u'مَكْرٌ عَاقِلٌ':Added, #1: 1	مَكَثَ يَقْظَانَ
u'مَكَرَ لَيْلٌ':Subject, #1: 1	مَكْرُ الْعَاقِلِ
u'مَكْرٌ لَيْلٌ':Added, #1: 1	مَكَرَ اللَّيْلُ
u'مَكْرٌ مُفْرَدٌ':Added, #2: 2	مَكْرُ اللَّيْلِ
u'مَكَّنَ أهْلٌ':Subject, #1: 1	مَكْرُ الْمُفْرَدِ
u'مَكَّنَ رَجُلٌ':Predicate, #1: 1	مَكَّنَ أَهْلُ
u'مَكَّنَ عَبْدٌ':Predicate, #1: 1	مَكَّنَ الرَّجُلَ
u'مَكَّنَ وَارِثٌ':Predicate, #1: 1	مَكَّنَ الْعَبْدَ
u'مَكِيدَةٌ نَاسٌ':Added, #1: 1	مَكَّنَ الْوَارِثَ
u'مَلَأَ اِبْنٌ':Subject, #1: 1	مَكِيدَةَ النَّاسِ
u'مَلَأَ آدَمِيٌّ':Subject, #2: 2	مَلَأَ ابْنُ
u'مَلَأَ أسْمَاعٌ':Predicate, #1: 1	مَلَأَ آدَمِيٌّ
u'مَلَأَ آفاقٌ':Predicate, #1: 1	مَلَأَ الْأَسْمَاعَ
u'مَلَأَ إِناءٌ':Predicate, #1: 1	مَلَأَ الْآفَاقَ
u'مَلَأَ أَنْهُرٌ':Predicate, #2: 2	مَلَأَ الْإِنَاءَ
u'مَلَأَ بِطاحٌ':Predicate, #1: 1	مَلَأَ الْأَنْهُرَ
u'مَلَأَ ثُلاثِيٌّ':Predicate, #1: 1	مَلَأَ الْبِطَاحَ
u'مَلَّ أَجِيرٌ':Predicate, #1: 1	مَلَأَ الثُّلَاثِيَّ
u'مَلَّ إِخَاءٌ':Predicate, #1: 1	مَلَّكَ الْأَجِيرَ
u'مَلَأَ خَابِيَةٌ':Predicate, #1: 1	مَلَّ الْإِخَاءَ
u'مَلَأَ ظَلامٌ':Subject, #1: 1	مَلَأَ الْخَابِيَةَ
u'مَلَأَ فَاهٌ':Subject, #1: 1	مَلَأَ الظَّلَامُ
u'مَلَأَ فَمٌ':Predicate, #2: 2	مَلَأَ فَاهُ
u'مَلَأَ فَمٌ':Predicate, #18: 18	مَلَأَ الْفَمَ
u'مَلَأَ كَيْلٌ':Predicate, #1: 1	مَلَأَ فَمَ
u'مَلَأَ مَاءٌ':Predicate, #1: 1	مَلَأَ الْكَيْلَ
u'مَلَّ أَمْرٌ':Predicate, #1: 1	مَلَأَ الْمَاءَ
u'مَلَّ إِنْسانٌ':Predicate, #2: 2	مَلَّكَ أَمْرَ
u'مَلَأَ وَادِي':Predicate, #2: 2	مَلَّكَ الْإِنْسَانَ
u'مَلَّ صحبة':Predicate, #1: 1	مَلَأَ الْوَادِيَ
u'مَلَّ صُحْبَةٌ':Predicate, #1: 1	مَلَّ صُحْبَةَ
u'مَلَّ طعام':Predicate, #1: 1	مَلَّ صُحْبَةَ
u'مَلَّ طَعَامٌ':Predicate, #2: 2	مَلَّكَ الطَّعَامَ
u'مَلَّ عَبْدٌ':Predicate, #2: 2	مَلَّكَ الطَّعَامَ
u'مَلَّ غير':Predicate, #1: 1	مَلَّكَ الْعَبْدَ
u'مَلَّ غَيْرٌ':Predicate, #1: 1	مَلَّكَ الْغَيْرَ
u'مَلَّ فَقِيرٌ':Predicate, #1: 1	مَلَّكَ الْغَيْرَ
u'مَلَكَ أَبٌ':Predicate, #1: 1	مَلَّكَ الْفَقِيرَ
u'مَلَكَ أَبٌ':Subject, #1: 1	مَلَكَ أَبَ
u'مَلَكَ إِبْرِيقٌ':Predicate, #1: 1	مَلَكَ الْأَبُ
u'مَلَكَ اِبْنٌ':Predicate, #1: 1	مَلَكَ إبْرِيقَ
u'مَلَكَ اِبْنٌ':Subject, #4: 4	مَلَكَ ابْنَ
u'مُلْكٌ اِبْنٌ':Added, #1: 1	مَلَكَ ابْنُهُ
u'مَلَكَ اِبْنَة':Predicate, #3: 3	مُلْكُ ابْنِ
u'مَلَكَ أَجْرٌ':Predicate, #1: 1	مَلَكَ ابْنَةَ
u'مَلَكَ أُجْرَةٌ':Predicate, #1: 1	مَلَكَ الْأَجْرَ
u'مَلَكَ أَجِيرٌ':Predicate, #4: 4	مَلَكَ الْأُجْرَةَ
u'مَلَّكَ أَجِيرٌ':Predicate, #1: 1	مَلَكَ الْأَجِيرَ
u'مَلَكَ أحَدٌ':Predicate, #1: 1	مَلَّكَ الْأَجِيرَ
u'مَلَكَ أحَدٌ':Subject, #1: 1	مَلَكَ أَحَدَ
u'مَلَكَ إِخْبَارٌ':Predicate, #9: 9	مَلَكَ أَحَدُ
u'مَلَكَ أخْذٌ':Predicate, #2: 2	مَلَكَ الْإِخْبَارَ
u'مُلْكٌ آخِرَةٌ':Added, #2: 2	مَلَكَ الْأَخْذَ
u'مَلَكَ أَرْبَعَةٌ':Predicate, #1: 1	مُلْكُ الْآخِرَةِ
u'مَلَكَ أرْضٌ':Predicate, #1: 1	مَلَكَ أَرْبَعَةَ
u'مَلَكَ اِسْتيفاءٌ':Predicate, #5: 5	مَلَكَ الْأَرْضَ
u'مَلَكَ إِسْقاطٌ':Subject, #2: 2	مَلَكَ اسْتِيفَاءَ
u'مَلَكَ أصل':Predicate, #1: 1	مَلَكَ إسْقَاطُهُ
u'مَلَكَ أًصْلٌ':Predicate, #2: 2	مَلَكَ أَصْلَ
u'مَلَكَ أصل':Predicate, #2: 2	مَلَكَ أَصْلَ
u'مَلَكَ أًصْلٌ':Predicate, #2: 2	مَلَكَ الْأَصْلَ
u'مُلْكٌ أعاجم':Added, #2: 2	مَلَكَ الْأَصْلَ
u'مَلَكَ إِعارَةٌ':Predicate, #1: 1	مُلْكَ الْأَعَاجِمِ
u'مُلْكٌ أعْظَمُ':Added, #1: 1	مَلَكَ الْإِعَارَةَ
u'مَلَّ كَافِرٌ':Predicate, #1: 1	مُلْكِ أَعْظَمِ
u'مَلَكَ إقامَةٌ':Predicate, #1: 1	مَلَّكَ الْكَافِرَ
u'مَلَكَ إقْرَارٌ':Predicate, #1: 1	مَلَكَ إقَامَةَ
u'مَلَكَ أقَلُّ':Predicate, #5: 5	مَلَكَ الْإِقْرَارَ
u'مَلَكَ ألف':Predicate, #2: 2	مَلَكَ أَقَلَّ
u'مَلَكَ ألْفٌ':Predicate, #1: 1	مَلَكَ الْأَلْفَ
u'مَلَكَ أَلْفٌ':Predicate, #1: 1	مَلَكَ الْأَلْفَ
u'مَلَكَ ألف':Predicate, #1: 1	مَلَكَ الْأَلْفَ
u'مَلَكَ ألْفٌ':Predicate, #1: 1	مَلَكَ أَلْفَ
u'مَلَكَ أَلْفٌ':Predicate, #1: 1	مَلَكَ أَلْفَ
u'مَلَكَ أُمٌّ':Predicate, #1: 1	مَلَكَ أَلْفَ
u'مَلَكَ أمَةٌ':Predicate, #2: 2	مَلَكَ الْأُمَّ
u'مَلَكَ أمَةٌ':Predicate, #1: 1	مَلَكَ الأَمَةَ
u'مَلَكَ أَمْرٌ':Predicate, #1: 1	مَلَكَ الْأَمَةَ
u'مَلَّكَ أَمْرٌ':Predicate, #2: 2	مَلَكَ الْأَمْرَ
u'مَلَكَ إِنْزالٌ':Predicate, #2: 2	مَلَّكَ أَمْرَ
u'مَلَّكَ إِنْسانٌ':Predicate, #1: 1	مَلَكَ الْإِنْزَالَ
u'مَلَكَ إِنْسانٌ':Subject, #2: 2	مَلَّكَ الْإِنْسَانَ
u'مَلَكَ إِنْشاءٌ':Predicate, #1: 1	مَلَكَ إنْسَانٌ
u'مَلَكَ إِنْشاءٌ':Predicate, #4: 4	مَلَكَ إنْشَاءَ
u'مَلَكَ أَوَّلُ':Subject, #6: 6	مَلَكَ الْإِنْشَاءَ
u'مَلَكَ باقِي':Predicate, #1: 1	مَلَكَ الْأَوَّلُ
u'مَلَكَ بَائِعٌ':Subject, #1: 1	مَلَكَ الْبَاقِيَ
u'مَلَكَ بَدَلٌ':Predicate, #1: 1	مَلَكَ بَائِعُهُ
u'مَلَكَ بَدَلٌ':Predicate, #2: 2	مَلَكَ بَدَلَ
u'مَلَكَ بَذْرٌ':Predicate, #5: 5	مَلَكَ الْبَدَلَ
u'مَلَكَ بَعْضٌ':Predicate, #1: 1	مَلَكَ الْبَذْرَ
u'مَلَكَ بَعْضٌ':Predicate, #1: 1	مَلَكَ الْبَعْضَ
u'مَلَكَ بُقْعَةٌ':Predicate, #7: 7	مَلَكَ بَعْضَ
u'مَلَكَ بَقِيَّةٌ':Predicate, #1: 1	مَلَكَ الْبُقْعَةَ
u'مَلَكَ بِلادٌ':Predicate, #1: 1	مَلَكَ الْبَقِيَّةَ
u'مَلَكَ بِنْتٌ':Predicate, #1: 1	مَلَكَ الْبِلَادَ
u'مَلَكَ بَيْعٌ':Predicate, #3: 3	مَلَكَ بِنْتَ
u'مَلَكَ بَيْعٌ':Predicate, #3: 3	مَلَكَ بَيْعَ
u'مَلَكَ تَتِمَّةٌ':Predicate, #6: 6	مَلَكَ الْبَيْعَ
u'مَلَكَ تَتِمَّةٌ':Predicate, #1: 1	مَلَكَ التَّتِمَّةَ
u'مَلَكَ تِجَارَةٌ':Predicate, #2: 2	مَلَكَ تَتِمَّةَ
u'مَلَكَ تَزْوِيجٌ':Predicate, #1: 1	مَلَكَ التِّجَارَةَ
u'مَلَكَ تَزْوِيجٌ':Predicate, #1: 1	مَلَكَ التَّزْوِيجَ
u'مَلَكَ تَسْلِيمٌ':Predicate, #1: 1	مَلَكَ تَزْوِيجَ
u'مَلَكَ تَصَرُّفٌ':Predicate, #1: 1	مَلَكَ التَّسْلِيمَ
u'مَلَكَ تَعْجِيل':Predicate, #10: 10	مَلَكَ التَّصَرُّفَ
u'مَلَكَ تَعْلِيقٌ':Predicate, #1: 1	مَلَكَ تَعْجِيلَ
u'مَلَكَ تَعْيِينٌ':Predicate, #2: 2	مَلَكَ التَّعْلِيقَ
u'مَلَكَ تَقَاضِي':Predicate, #1: 1	مَلَكَ تَعْيِينَ
u'مَلَكَ تَقَاضِي':Predicate, #1: 1	مَلَكَ التَّقَاضِيَ
u'مَلَكَ تمام':Predicate, #1: 1	مَلَكَ تَقَاضِيَ
u'مَلَكَ تَمامٌ':Predicate, #1: 1	مَلَكَ تَمَامَ
u'مَلَكَ تَنْجِيزٌ':Predicate, #1: 1	مَلَكَ تَمَامَ
u'مَلَكَ تَوْكِيلٌ':Predicate, #1: 1	مَلَكَ التَّنْجِيزَ
u'مَلَكَ ثَانِي':Predicate, #1: 1	مَلَكَ التَّوْكِيلَ
u'مَلَكَ ثَانِيَةٌ':Predicate, #1: 1	مَلَكَ الثَّانِيَةَ
u'مَلَكَ ثَمَرَةٌ':Predicate, #1: 1	مَلَكَ الثَّانِيَةَ
u'مَلَكَ ثَمَنٌ':Predicate, #1: 1	مَلَكَ الثَّمَرَةَ
u'مَلَكَ ثَمَنٌ':Predicate, #5: 5	مَلَكَ ثَمَنَ
u'مَلَكَ ثَوْبٌ':Predicate, #8: 8	مَلَكَ الثَّمَنَ
u'مَلَكَ جَارِي':Predicate, #1: 1	مَلَكَ الثَّوْبَ
u'مَلَكَ جَارِي':Predicate, #1: 1	مَلَكَ جَارِيَةَ
u'مَلَكَ جَارِي':Predicate, #5: 5	مَلَكَ جَارِيَةً
u'مَلَكَ جَارِيَةٌ':Predicate, #9: 9	مَلَكَ الْجَارِيَةَ
u'مَلَكَ جَارِيَةٌ':Predicate, #1: 1	مَلَكَ جَارِيَةَ
u'مُلْكٌ جَزْلٌ':Added, #9: 9	مَلَكَ الْجَارِيَةَ
u'مَلَكَ جَمِيع':Predicate, #1: 1	مُلْكٍ جَزْلٍ
u'مَلَكَ حَبَشَة':Predicate, #1: 1	مَلَكَ الْجَمِيعَ
u'مُلْكٌ حَبَشَة':Added, #1: 1	مَلَكَ الْحَبَشَةَ
u'مَلَكَ حُرٌّ':Subject, #2: 2	مُلْكِ الْحَبَشَةِ
u'مَلَكَ حَرِيمٌ':Predicate, #4: 4	مَلَكَ الْحُرُّ
u'مَلَكَ حِصَصٌ':Predicate, #2: 2	مَلَكَ الْحَرِيمَ
u'مَلَكَ حَطّ':Predicate, #1: 1	مَلَكَ الْحِصَصَ
u'مَلَكَ حِفْظٌ':Predicate, #1: 1	مَلَكَ الْحَطَّ
u'مَلَكَ حَمَامٌ':Predicate, #3: 3	مَلَكَ الْحِفْظَ
u'مَلَكَ حَمْلٌ':Predicate, #1: 1	مَلَكَ الْحَمَامَ
u'مَلَكَ خدمة':Predicate, #1: 1	مَلَكَ الْحَمْلَ
u'مَلَكَ خِدْمَةٌ':Predicate, #1: 1	مَلَكَ خِدْمَةَ
u'مَلَكَ خُصُومَةٌ':Predicate, #1: 1	مَلَكَ خِدْمَةَ
u'مَلَكَ خَمْسَةٌ':Predicate, #1: 1	مَلَكَ الْخُصُومَةَ
u'مَلَكَ دُرٌّ':Predicate, #4: 4	مَلَكَ خَمْسَةَ
u'مَلَكَ دَرَاهِمُ':Predicate, #2: 2	مَلَكَ الدُّرَّةَ
u'مَلَكَ دَرَاهِمُ':Predicate, #1: 1	مَلَكَ الدَّرَاهِمَ
u'مَلَكَ دُرَّةٌ':Predicate, #1: 1	مَلَكَ دَرَاهِمَ
u'مَلَكَ دَقيقٌ':Predicate, #2: 2	مَلَكَ الدُّرَّةَ
u'مَلَكَ دَيْنٌ':Predicate, #1: 1	مَلَكَ الدَّقِيقَ
u'مَلَكَ ذِمِّيٌّ':Subject, #5: 5	مَلَكَ الدَّيْنَ
u'مَلَكَ رَأْسٌ':Predicate, #2: 2	مَلَكَ الذِّمِّيُّ
u'مَلَكَ رُبْعٌ':Predicate, #1: 1	مَلَكَ رَأْسَ
u'مَلَكَ رَجُلٌ':Subject, #1: 1	مَلَكَ رُبْعَ
u'مَلَّكَ رَجُلٌ':Subject, #3: 3	مَلَكَ رَجُلٌ
u'مَلَكَ رَجُلٌ':Subject, #4: 4	مَلَّكَ الرَّجُلُ
u'مَلَكَ رُجُوعٌ':Predicate, #5: 5	مَلَكَ الرَّجُلُ
u'مَلَكَ رَدٌّ':Predicate, #4: 4	مَلَكَ الرُّجُوعَ
u'مَلَكَ رَدٌّ':Predicate, #1: 1	مَلَكَ الرَّدَّ
u'مَلَكَ رَقَبَةٌ':Predicate, #1: 1	مَلَكَ رَدَّ
u'مَلَكَ رَهْنٌ':Predicate, #5: 5	مَلَكَ الرَّقَبَةَ
u'مَلَكَ زادٌ':Predicate, #1: 1	مَلَكَ الرَّهْنَ
u'مَلَكَ زَرْعٌ':Predicate, #6: 6	مَلَكَ الزَّادَ
u'مَلَكَ زَكاةٌ':Predicate, #1: 1	مَلَكَ الزَّرْعَ
u'مَلَكَ زَوائِدُ':Predicate, #1: 1	مَلَكَ الزَّكَاةَ
u'مَلَكَ زَوْجٌ':Subject, #1: 1	مَلَكَ الزَّوَائِدَ
u'مَلَكَ زَيْدٌ':Subject, #11: 11	مَلَكَ الزَّوْجُ
u'مَلَكَ سَارِقٌ':Predicate, #1: 1	مَلَكَ زَيْدٌ
u'مَلَكَ سَارِقٌ':Subject, #1: 1	مَلَكَ السَّارِقَ
u'مَلَكَ سَاقٌ':Predicate, #3: 3	مَلَكَ السَّارِقُ
u'مَلَكَ سِتٌّ':Predicate, #2: 2	مَلَكَ السَّاقَ
u'مَلَكَ سُفْلٌ':Predicate, #1: 1	مَلَكَ سِتَّةَ
u'مَلَكَ سَلَبٌ':Predicate, #1: 1	مَلَكَ السُّفْلَ
u'مُلْكٌ سُلْطَانٌ':Added, #1: 1	مَلَكَ سَلَبَ
u'مُلْكٌ سَمَاواتٌ':Added, #1: 1	مُلْكُ سُلْطَانٍ
u'مَلَكَ سَمَكٌ':Predicate, #1: 1	مُلْكُ السّمَاوَاتِ
u'مُلْكٌ سموات':Added, #1: 1	مَلَكَ السَّمَكَةَ
u'مَلَكَ سَيِّدٌ':Subject, #2: 2	مُلْكُ السَّمَوَاتِ
u'مَلَّكَ سَيِّدٌ':Subject, #1: 1	مَلَكَ السَّيِّدُ
u'مَلَكَ شَجَرٌ':Predicate, #3: 3	مَلَّكَ السَّيِّدُ
u'مَلَكَ شَرِيكٌ':Subject, #1: 1	مَلَكَ الشَّجَرَ
u'مَلَكَ شَيْءٌ':Predicate, #1: 1	مَلَكَ شَرِيكُهُ
u'مَلَكَ صبر':Predicate, #1: 1	مَلَكَ الشَّيْءَ
u'مَلَكَ صَبْرٌ':Predicate, #1: 1	مَلَكَ الصَّبْرَ
u'مَلَكَ صَبِيٌّ':Predicate, #1: 1	مَلَكَ الصَّبْرَ
u'مَلَكَ صَبِيٌّ':Subject, #1: 1	مَلَكَ الصَّبِيَّ
u'مَلَكَ صَغِيرٌ':Subject, #1: 1	مَلَكَ الصَّبِيُّ
u'مَلَكَ صَيْدٌ':Predicate, #1: 1	مَلَكَ الصَّغِيرُ
u'مَلَكَ طعام':Predicate, #5: 5	مَلَكَ الصَّيْدَ
u'مَلَكَ طَعَامٌ':Predicate, #1: 1	مَلَكَ الطَّعَامَ
u'مَلَّكَ طعام':Predicate, #1: 1	مَلَكَ الطَّعَامَ
u'مَلَّكَ طَعَامٌ':Predicate, #2: 2	مَلَّكَ الطَّعَامَ
u'مَلَكَ ظَرْفٌ':Predicate, #2: 2	مَلَّكَ الطَّعَامَ
u'مَلَكَ عَامِلٌ':Subject, #1: 1	مَلَكَ الظَّرْفَ
u'مَلَكَ عَبْدٌ':Predicate, #1: 1	مَلَكَ الْعَامِلُ
u'مَلَّكَ عَبْدٌ':Predicate, #10: 10	مَلَكَ الْعَبْدَ
u'مَلَكَ عَبْدٌ':Subject, #1: 1	مَلَّكَ الْعَبْدَ
u'مَلَكَ عَبْدٌ':Subject, #1: 1	مَلَكَ عَبْدُهُ
u'مَلَكَ عَدَدٌ':Predicate, #2: 2	مَلَكَ الْعَبْدُ
u'مَلَكَ عَرْضٌ':Predicate, #1: 1	مَلَكَ الْعَدَدَ
u'مَلَكَ عَرَضٌ':Predicate, #1: 1	مَلَكَ الْعَرْضَ
u'مَلَكَ عزل':Predicate, #1: 1	مَلَكَ عَرَضَ
u'مَلَكَ عَشْرٌ':Predicate, #1: 1	مَلَكَ عَزْلَ
u'مَلَكَ عَفْوٌ':Predicate, #1: 1	مَلَكَ عَشْرَةَ
u'مَلَكَ عَقَارٌ':Predicate, #1: 1	مَلَكَ الْعَفْوَ
u'مَلَكَ عقدة':Predicate, #3: 3	مَلَكَ الْعَقَارَ
u'مَلَكَ عُقْدَةٌ':Predicate, #1: 1	مَلَكَ عُقْدَةَ
u'مَلَكَ عين':Predicate, #1: 1	مَلَكَ عُقْدَةَ
u'مَلَكَ عَيْنٌ':Predicate, #5: 5	مَلَكَ الْعَيْنَ
u'مَلَكَ عَيْن':Predicate, #5: 5	مَلَكَ الْعَيْنَ
u'مَلَكَ غَاصِبٌ':Subject, #5: 5	مَلَكَ الْعَيْنَ
u'مَلَكَ غَلَّةٌ':Predicate, #2: 2	مَلَكَ الْغَاصِبُ
u'مَلَّكَ غير':Predicate, #1: 1	مَلَكَ الْغَلَّةَ
u'مَلَّكَ غَيْرٌ':Predicate, #1: 1	مَلَّكَ الْغَيْرَ
u'مَلَكَ غير':Subject, #1: 1	مَلَّكَ الْغَيْرَ
u'مَلَكَ غَيْرٌ':Subject, #1: 1	مَلَكَ غَيْرُهُ
u'مَلَكَ فِرْعَوْنُ':Subject, #1: 1	مَلَكَ غَيْرُهُ
u'مَلَكَ فَسْخٌ':Predicate, #1: 1	مَلَكَ فِرْعَوْنُ
u'مَلَكَ فَسْخٌ':Predicate, #1: 1	مَلَكَ فَسْخَ
u'مَلَكَ فِعْلٌ':Predicate, #2: 2	مَلَكَ الْفَسْخَ
u'مَلَّكَ فَقِيرٌ':Predicate, #1: 1	مَلَكَ الْفِعْلَ
u'مَلَكَ فَقِيرٌ':Subject, #1: 1	مَلَّكَ الْفَقِيرَ
u'مَلَكَ فلان':Predicate, #1: 1	مَلَكَ الْفَقِيرُ
u'مُلْكٌ فُلاَنٌ':Added, #1: 1	مَلَكَ يُونَانَ
u'مَلَكَ قَبْضٌ':Predicate, #1: 1	مُلْكِ فُلاَنٍ
u'مَلَكَ قَبْضٌ':Predicate, #1: 1	مَلَكَ الْقَبْضَ
u'مَلَكَ قَبُولٌ':Predicate, #2: 2	مَلَكَ قَبْضَ
u'مَلَكَ قَدْرٌ':Predicate, #1: 1	مَلَكَ الْقَبُولَ
u'مَلَكَ قرار':Predicate, #4: 4	مَلَكَ قَدْرَ
u'مَلَكَ قَرَارٌ':Predicate, #3: 3	مَلَكَ الْقَرَارَ
u'مَلَكَ قَرِيبٌ':Predicate, #3: 3	مَلَكَ الْقَرَارَ
u'مَلَكَ قَضَاءٌ':Subject, #1: 1	مَلَكَ الْقَرِيبَ
u'مَلَكَ قِمَّةٌ':Predicate, #1: 1	مَلَكَ الْقَضَاءُ
u'مَلَكَ قُوتٌ':Predicate, #1: 1	مَلَكَ قِمَّةَ
u'مَلَكَ قِيمَةٌ':Predicate, #4: 4	مَلَكَ قُوتَ
u'مَلَكَ قِيمَةٌ':Predicate, #1: 1	مَلَكَ قِيمَةَ
u'مَلَّكَ كَافِرٌ':Predicate, #3: 3	مَلَكَ الْقِيمَةَ
u'مَلَكَ كِتَابَةٌ':Predicate, #1: 1	مَلَّكَ الْكَافِرَ
u'مَلَكَ كِرَاءٌ':Predicate, #1: 1	مَلَكَ الْكِتَابَةَ
u'مَلَكَ كَفَّارٌ':Predicate, #1: 1	مَلَكَ كِرَاءَ
u'مَلَكَ كَفَّارَةٌ':Predicate, #1: 1	مَلَكَ الْكَفَّارَةَ
u'مَلَكَ كَفِيلٌ':Subject, #1: 1	مَلَكَ الْكَفَّارَةَ
u'مَلَكَ لَحْمٌ':Predicate, #3: 3	مَلَكَ الْكَفِيلُ
u'مَلَكَ مَاءٌ':Predicate, #2: 2	مَلَكَ لَحْمَ
u'مَلَكَ مَاشِي':Predicate, #7: 7	مَلَكَ الْمَاءَ
u'مَلَكَ مَالٌ':Predicate, #2: 2	مَلَكَ مَاشِيَةً
u'مَلَكَ مَأْمُورٌ':Subject, #3: 3	مَلَكَ الْمَالَ
u'مَلَكَ مَبِيعٌ':Predicate, #1: 1	مَلَكَ الْمَأْمُورُ
u'مَلَكَ مَتَاعٌ':Predicate, #11: 11	مَلَكَ الْمَبِيعَ
u'مَلَكَ مَحَلٌّ':Predicate, #1: 1	مَلَكَ الْمَتَاعَ
u'مَلَكَ مُدَبَّرٌ':Subject, #1: 1	مَلَكَ مَحَلَّ
u'مَلَكَ مَدْفُوعٌ':Predicate, #1: 1	مَلَكَ الْمُدَبَّرُ
u'مَلَكَ مَدْفُوعٌ':Subject, #3: 3	مَلَكَ الْمَدْفُوعَ
u'مَلَكَ مُرْتَهِنٌ':Subject, #3: 3	مَلَكَ الْمَدْفُوعُ
u'مَلَكَ مَرْهُونٌ':Predicate, #1: 1	مَلَكَ الْمُرْتَهِنُ
u'مَلَكَ مُسْتَأْجِرٌ':Subject, #2: 2	مَلَكَ الْمَرْهُونَ
u'مَلَكَ مُسْتَحَقٌّ':Predicate, #4: 4	مَلَكَ الْمُسْتَأْجِرُ
u'مَلَكَ مُسْتَعِيرٌ':Subject, #2: 2	مَلَكَ الْمُسْتَحَقَّ
u'مَلَكَ مَسْرُوقٌ':Predicate, #1: 1	مَلَكَ الْمُسْتَعِيرُ
u'مَلَكَ مُسْلِمٌ':Subject, #4: 4	مَلَكَ الْمَسْرُوقَ
u'مَلَّكَ مُصَالِحٌ':Predicate, #1: 1	مَلَكَ الْمُسْلِمُ
u'مَلَكَ مَضْمُونٌ':Predicate, #1: 1	مَلَّكَ الْمُصَالِحَ
u'مَلَكَ مُطَالَبٌ':Predicate, #4: 4	مَلَكَ الْمَضْمُونَ
u'مَلَكَ مُطَالَبٌ':Predicate, #1: 1	مَلَكَ الْمُطَالَبَةَ
u'مَلَكَ مُطَالَبَةٌ':Predicate, #1: 1	مَلَكَ مُطَالَبَةَ
u'مَلَكَ مُطَالَبَةٌ':Predicate, #1: 1	مَلَكَ الْمُطَالَبَةَ
u'مَلَكَ مَغْصُوب':Predicate, #1: 1	مَلَكَ مُطَالَبَةَ
u'مَلَكَ مِقْدَارٌ':Predicate, #1: 1	مَلَكَ الْمَغْصُوبَ
u'مَلَكَ مُلْتَقِط':Subject, #1: 1	مَلَكَ مِقْدَارَ
u'مُلْكٌ مَلِكٌ':Added, #2: 2	مَلَكَ الْمُلْتَقِطُ
u'مَلَكَ مَنَافِعُ':Predicate, #1: 1	مُلْكِ مَلِكٍ
u'مَلَكَ مَنْفَعَةٌ':Predicate, #4: 4	مَلَكَ الْمَنَافِعَ
u'مَلَّكَ مَنْفَعَةٌ':Predicate, #12: 12	مَلَكَ الْمَنْفَعَةَ
u'مَلَكَ مَنْفَعَةٌ':Predicate, #1: 1	مَلَّكَ مَنْفَعَةَ
u'مَلَكَ مَنْقُولٌ':Predicate, #2: 2	مَلَكَ مَنْفَعَةَ
u'مَلَكَ مُوَرِّث':Predicate, #1: 1	مَلَكَ الْمَنْقُولَ
u'مَلَكَ مَوْضِعٌ':Predicate, #1: 1	مَلَكَ مُوَرِّثَةً
u'مَلَكَ مَوْقُوفٌ':Predicate, #1: 1	مَلَكَ مَوْضِعَ
u'مَلَكَ مَوْهُوبٌ':Predicate, #1: 1	مَلَكَ الْمَوْقُوفَ
u'مَلَكَ نَخْلٌ':Predicate, #2: 2	مَلَكَ الْمَوْهُوبَ
u'مَلَكَ نصاب':Predicate, #1: 1	مَلَكَ النَّخْلَ
u'مَلَكَ نِصَابٌ':Predicate, #1: 1	مَلَكَ النِّصَابَ
u'مَلَكَ نصاب':Predicate, #1: 1	مَلَكَ النِّصَابَ
u'مَلَكَ نِصَابٌ':Predicate, #6: 6	مَلَكَ نِصَابَ
u'مَلَكَ نصب':Predicate, #6: 6	مَلَكَ نِصَابَ
u'مَلَكَ نَصْبٌ':Predicate, #1: 1	مَلَكَ نَصْبَ
u'مَلَكَ نِصْفٌ':Predicate, #1: 1	مَلَكَ نَصْبَ
u'مَلَكَ نِصْفٌ':Predicate, #3: 3	مَلَكَ نِصْفَ
u'مَلَكَ نَصِيبٌ':Predicate, #5: 5	مَلَكَ النِّصْفَ
u'مَلَكَ نَظَرٌ':Subject, #6: 6	مَلَكَ نَصِيبَ
u'مَلَكَ هِبَةٌ':Predicate, #1: 1	مَلَكَ نَظَرٌ
u'مَلَكَ وَارِثٌ':Subject, #1: 1	مَلَكَ الْهِبَةَ
u'مَلَكَ وَاقِفٌ':Subject, #3: 3	مَلَكَ الْوَارِثُ
u'مَلَكَ وَالِدٌ':Subject, #4: 4	مَلَكَ الْوَاقِفُ
u'مَلَكَ وَاهِبٌ':Subject, #1: 1	مَلَكَ الْوَالِدُ
u'مَلَكَ وُرَّاثٌ':Subject, #1: 1	مَلَكَ الْوَاهِبُ
u'مَلَكَ وَصِيٌّ':Predicate, #1: 1	مَلَكَ الْوُرَّاثُ
u'مَلَكَ وَصِيَّةٌ':Predicate, #1: 1	مَلَكَ الْوَصِيَّةَ
u'مَلَكَ وَضْعٌ':Predicate, #1: 1	مَلَكَ الْوَصِيَّةَ
u'مَلَكَ وَطْءٌ':Predicate, #1: 1	مَلَكَ وَضْعَ
u'مَلَكَ وَكِيلٌ':Subject, #1: 1	مَلَكَ وَطْءَ
u'مَلَكَ ولد':Predicate, #2: 2	مَلَكَ الْوَكِيلُ
u'مَلَكَ وَلَدٌ':Predicate, #5: 5	مَلَكَ الْوَلَدَ
u'مَلَكَ ولد':Subject, #5: 5	مَلَكَ الْوَلَدَ
u'مَلَكَ وَلَدٌ':Subject, #2: 2	مَلَكَ الْوَلَدُ
u'مَلَكِيَّةٌ جَمَلٌ':Added, #2: 2	مَلَكَ الْوَلَدُ
u'مَلَكِيَّةٌ حِمَارٌ':Added, #1: 1	مَلَكِيَّةِ جَمَلٍ
u'مَلَكِيَّةٌ حِمَارٌ':Added, #1: 1	مَلَكِيَّةِ حِمَارٍ
u'مَلَكِيٌّ جَمَلٌ':Added, #2: 2	مَلَكِيَّةَ حِمَارٍ
u'مَلَكِيٌّ حِمَارٌ':Added, #1: 1	مَلَكِيَّةِ جَمَلٍ
u'مَلَكِيٌّ حِمَارٌ':Added, #1: 1	مَلَكِيَّةِ حِمَارٍ
u'مَلَكَ يمن':Predicate, #2: 2	مَلَكِيَّةَ حِمَارٍ
u'مَلَكَ يَمَنُ':Predicate, #1: 1	مَلَكَ الْيَمَنَ
u'مُلْكٌ يمن':Added, #1: 1	مَلَكَ الْيَمَنَ
u'مُلْكٌ يمن':Added, #1: 1	مُلْكُ الْيَمَنِ
u'مُلْكٌ يَمَنُ':Added, #1: 1	مُلْكِ الْيَمَنِ
u'مُلْكٌ يَمَنُ':Added, #1: 1	مُلْكُ الْيَمَنِ
u'مَلَكَ يَوْمٌ':Predicate, #1: 1	مُلْكِ الْيَمَنِ
u'مَلَّ مُصَالِحٌ':Predicate, #2: 2	مَلَكَ يَوْمَ
u'مَلَّ مَنْفَعَةٌ':Predicate, #1: 1	مَلَّكَ الْمُصَالِحَ
u'مُمَاثَلَةٌ صُورَةٌ':Added, #1: 1	مَلَّكَ مَنْفَعَةَ
u'مُمَاثَلَةٌ فَرْعٌ':Added, #1: 1	مُمَاثَلَةَ صُورَةٍ
u'مُمَارَسَةٌ مَبِيعٌ':Added, #1: 1	مُمَاثَلَةُ الْفَرْعِ
u'مُمَارَسٌ مَبِيعٌ':Added, #1: 1	مُمَارَسَةِ الْمَبِيعِ
u'مُمَازَجَةٌ نُفُوسٌ':Added, #1: 1	مُمَارَسَةِ الْمَبِيعِ
u'مُمَازَحَةٌ عَدُوٌّ':Added, #1: 1	مُمَازَجَةِ النُّفُوسِ
u'مُمَاشَاةٌ مُرِيبٌ':Added, #1: 1	مُمَازَحَةِ عَدُوٍّ
u'مَمْلَكَةٌ حَبَشَة':Added, #1: 1	مُمَاشَاةَ الْمُرِيبِ
u'مَمْلَكَةٌ رُومٌ':Added, #1: 1	مَمْلَكَةِ الْحَبَشَةِ
u'مَنَابٌ آمِرٌ':Added, #1: 1	مَمْلَكَةِ الرُّومِ
u'مَنَابٌ سُنَّةٌ':Added, #1: 1	مَنَابَ الْآمِرِ
u'مَنَابٌ شَفْعٌ':Added, #2: 2	مَنَابَ السُّنَّةِ
u'مَنَابٌ غَسْلٌ':Added, #1: 1	مَنَابَ الشَّفْعِ
u'مَنَابٌ قَبْضٌ':Added, #1: 1	مَنَابَ الْغَسْلِ
u'مَنَابٌ قُرْبَةٌ':Added, #1: 1	مَنَابَ الْقَبْضِ
u'مَنَابٌ مَفْعُولٌ':Added, #1: 1	مَنَابَ الْقُرْبَةِ
u'مَنَابٌ نَفْسٌ':Added, #1: 1	مَنَابَ الْمَفْعُولَيْنِ
u'مُنَاجَاةٌ رَبُّ':Added, #7: 7	مَنَابَ نَفْسِهِ
u'مُنَاجَاةٌ رَبُّ':Added, #1: 1	مُنَاجَاةِ الرَّبِّ
u'مُنَاجَاةٌ رَسُولٌ':Added, #1: 1	مُنَاجَاةُ رَبّهِ
u'مُنَاجَاةٌ رَسُولٌ':Added, #2: 2	مُنَاجَاةِ الرَّسُولِ
u'مُنَادَمَةٌ نَاسٌ':Added, #2: 2	مُنَاجَاةِ رَسُولِ
u'مُنَازَعٌ إمَارَةٌ':Added, #1: 1	مُنَادَمَةِ النّاسِ
u'مُنَازَعٌ إمَامٌ':Added, #1: 1	مُنَازَعَةَ الْإِمَارَةِ
u'مُنَازَعٌ بَعْضٌ':Added, #1: 1	مُنَازَعَةَ الْإِمَامِ
u'مُنَازَعَةٌ إمَارَةٌ':Added, #1: 1	مُنَازَعَةُ بَعْضِ
u'مُنَازَعَةٌ إمَامٌ':Added, #1: 1	مُنَازَعَةَ الْإِمَارَةِ
u'مُنَازَعَةٌ بَعْضٌ':Added, #1: 1	مُنَازَعَةَ الْإِمَامِ
u'مُنَازَعَةٌ ثَلاثُ':Added, #1: 1	مُنَازَعَةُ بَعْضِ
u'مُنَازَعَةٌ جَائِرٌ':Added, #1: 1	مُنَازَعَةُ الثَّلَاثِ
u'مُنَازَعَةٌ حَقٌّ':Added, #1: 1	مُنَازَعَةِ الْجَائِرِ
u'مُنَازَعَةٌ خَصْمٌ':Added, #1: 1	مُنَازَعَةِ الْحَقِّ
u'مُنَازَعَةٌ شَارِعٌ':Added, #1: 1	مُنَازَعَةُ الْخَصْمِ
u'مُنَازَعَةٌ شَرِيكٌ':Added, #1: 1	مُنَازَعَةَ الشَّارِعِ
u'مُنَازَعَةٌ شَهَوَاتٌ':Added, #1: 1	مُنَازَعَةِ شَرِيكِهِ
u'مُنَازَعَةٌ شَهَوَاتٌ':Added, #1: 1	مُنَازَعَةَ الشَّهَوَاتِ
u'مُنَازَعَةٌ شَيْخٌ':Added, #1: 1	مُنَازَعَةُ الشَّهَوَاتِ
u'مُنَازَعَةٌ غير':Added, #1: 1	مُنَازَعَةِ الشَّيْخِ
u'مُنَازَعَةٌ غَيْرٌ':Added, #1: 1	مُنَازَعَةُ الْغَيْرِ
u'مُنَازَعَةٌ فرق':Added, #1: 1	مُنَازَعَةُ الْغَيْرِ
u'مُنَازَعَةٌ فِرَقٌ':Added, #6: 6	مُنَازَعَةُ الْفِرَقِ
u'مُنَازَعَةٌ فَرِيقٌ':Added, #6: 6	مُنَازَعَةُ الْفِرَقِ
u'مُنَازَعَةٌ قَطِيعٌ':Added, #4: 4	مُنَازَعَةُ الْفَرِيقَيْنِ
u'مُنَازَعَةٌ قَطِيعَةٌ':Added, #1: 1	مُنَازَعَةَ الْقَطِيعَةِ
u'مُنَازَعَةٌ كَامِلٌ':Added, #1: 1	مُنَازَعَةَ الْقَطِيعَةِ
u'مُنَازَعَةٌ مَانِعٌ':Added, #1: 1	مُنَازَعَةُ الْكَامِلِ
u'مُنَازَعَةٌ وَلِيٌّ':Added, #2: 2	مُنَازَعَةٍ مَانِعَةٍ
u'مُنَازَعٌ ثَلاثُ':Added, #1: 1	مُنَازَعَةُ وَلِيِّ
u'مُنَازَعٌ جَائِرٌ':Added, #1: 1	مُنَازَعَةُ الثَّلَاثِ
u'مُنَازَعٌ حَقٌّ':Added, #1: 1	مُنَازَعَةِ الْجَائِرِ
u'مُنَازَعٌ خَصْمٌ':Added, #1: 1	مُنَازَعَةِ الْحَقِّ
u'مُنَازَعٌ شَارِعٌ':Added, #1: 1	مُنَازَعَةُ الْخَصْمِ
u'مُنَازَعٌ شَرِيكٌ':Added, #1: 1	مُنَازَعَةَ الشَّارِعِ
u'مُنَازَعٌ شَهَوَاتٌ':Added, #1: 1	مُنَازَعَةِ شَرِيكِهِ
u'مُنَازَعٌ شَهَوَاتٌ':Added, #1: 1	مُنَازَعَةَ الشَّهَوَاتِ
u'مُنَازَعٌ شَيْخٌ':Added, #1: 1	مُنَازَعَةُ الشَّهَوَاتِ
u'مُنَازَعٌ غير':Added, #1: 1	مُنَازَعَةِ الشَّيْخِ
u'مُنَازَعٌ غَيْرٌ':Added, #1: 1	مُنَازَعَةُ الْغَيْرِ
u'مُنَازَعٌ فرق':Added, #1: 1	مُنَازَعَةُ الْغَيْرِ
u'مُنَازَعٌ فِرَقٌ':Added, #6: 6	مُنَازَعَةُ الْفِرَقِ
u'مُنَازَعٌ فَرِيقٌ':Added, #6: 6	مُنَازَعَةُ الْفِرَقِ
u'مُنَازَعٌ قَطِيعٌ':Added, #4: 4	مُنَازَعَةُ الْفَرِيقَيْنِ
u'مُنَازَعٌ قَطِيعَةٌ':Added, #1: 1	مُنَازَعَةَ الْقَطِيعَةِ
u'مُنَازَعٌ كَامِلٌ':Added, #1: 1	مُنَازَعَةَ الْقَطِيعَةِ
u'مُنَازَعٌ مَانِعٌ':Added, #1: 1	مُنَازَعَةُ الْكَامِلِ
u'مُنَازَعٌ وَلِيٌّ':Added, #2: 2	مُنَازَعَةٍ مَانِعَةٍ
u'مُنَاسَبَةٌ أَحْكَامٌ':Added, #1: 1	مُنَازَعَةُ وَلِيِّ
u'مُنَاسَبَةٌ إيرَادٌ':Added, #1: 1	مُنَاسَبَةَ الْأَحْكَامِ
u'مُنَاسَبَةٌ تَرْتِيبٌ':Added, #1: 1	مُنَاسَبَةِ إيرَادِ
u'مُنَاسَبَةٌ تَسْمِيَة':Added, #1: 1	مُنَاسَبَةُ تَرْتِيبِ
u'مُنَاسَبَةٌ تَعْلِيلٌ':Added, #1: 1	مُنَاسَبَةِ تَسْمِيَةٍ
u'مُنَاسَبَةٌ تَغْيِيرٌ':Added, #1: 1	مُنَاسَبَةِ التَّعْلِيلِ
u'مُنَاسَبَةٌ حالٌ':Added, #1: 1	مُنَاسَبَةِ تَغْيِيرِ
u'مُنَاسَبَةٌ حُكْمٌ':Added, #1: 1	مُنَاسَبَةِ الْحَالِ
u'مُنَاسَبَةٌ ذكر':Added, #1: 1	مُنَاسَبَةُ الْحُكْمِ
u'مُنَاسَبَةٌ ذكر':Added, #1: 1	مُنَاسَبَةُ ذِكْرِ
u'مُنَاسَبَةٌ ذِكْرٌ':Added, #1: 1	مُنَاسَبَةِ ذِكْرِ
u'مُنَاسَبَةٌ ذِكْرٌ':Added, #1: 1	مُنَاسَبَةُ ذِكْرِ
u'مُنَاسَبَةٌ ذَهَبٌ':Added, #1: 1	مُنَاسَبَةِ ذِكْرِ
u'مُنَاسَبَةٌ رَهْنٌ':Added, #1: 1	مُنَاسَبَةُ الذّهَبِ
u'مُنَاسَبَةٌ سَفَرٌ':Added, #1: 1	مُنَاسَبَةِ الرَّهْنِ
u'مُنَاسَبَةٌ شفعة':Added, #1: 1	مُنَاسَبَةِ السَّفَرِ
u'مُنَاسَبَةٌ شُفْعَةٌ':Added, #2: 2	مُنَاسَبَةِ الشُّفْعَةِ
u'مُنَاسَبَةٌ عَذَابٌ':Added, #2: 2	مُنَاسَبَةِ الشُّفْعَةِ
u'مُنَاسَبَةٌ قسمة':Added, #1: 1	مُنَاسَبَةِ عَذَابِ
u'مُنَاسَبَةٌ قِسْمَةٌ':Added, #1: 1	مُنَاسَبَةُ الْقِسْمَةِ
u'مُنَاسَبَةٌ كِتَابٌ':Added, #1: 1	مُنَاسَبَةُ الْقِسْمَةِ
u'مُنَاسَبَةٌ كِتَابٌ':Added, #1: 1	مُنَاسَبَةِ كِتَابِ
u'مُنَاسَبَةٌ لَفْظٌ':Added, #2: 2	مُنَاسَبَةُ كِتَابِ
u'مُنَاسَبَةٌ مَحْذُوفٌ':Added, #1: 1	مُنَاسَبَةُ لَفْظَيْنِ
u'مُنَاسَبَةٌ مَحْذُوفٌ':Added, #1: 1	مُنَاسَبَةُ الْمَحْذُوفِ
u'مُنَاسَبَةٌ مَحَلٌّ':Added, #1: 1	مُنَاسَبَةِ الْمَحْذُوفِ
u'مُنَاسَبَةٌ مُضَادٌّ':Added, #1: 1	مُنَاسَبَةُ مَحَلِّ
u'مُنَاسَبَةٌ مُضَادَّةٌ':Added, #1: 1	مُنَاسَبَةَ الْمُضَادَّةِ
u'مُنَاسَبَةٌ مُقَابَلٌ':Added, #1: 1	مُنَاسَبَةَ الْمُضَادَّةِ
u'مُنَاسَبَةٌ مُقَابَلَةٌ':Added, #1: 1	مُنَاسَبَةُ الْمُقَابَلَةِ
u'مُنَاسَبَةٌ مَقَامٌ':Added, #1: 1	مُنَاسَبَةُ الْمُقَابَلَةِ
u'مُنَاسَبَةٌ وَصْفٌ':Added, #1: 1	مُنَاسَبَةِ الْمَقَامِ
u'مُنَاسَبَةٌ وَصْفٌ':Added, #1: 1	مُنَاسَبَةُ الْوَصْفِ
u'مُنَاسَبَةٌ وَصْفٌ':Added, #2: 2	مُنَاسَبَةِ الْوَصْفِ
u'مُنَاشَدَةٌ رَسُولٌ':Added, #2: 2	مُنَاسَبَةِ وَصْفٍ
u'مُنَاظَرَةٌ اِبْنٌ':Added, #1: 1	مُنَاشَدَةُ الرّسُولِ
u'مُنَاظَرَةٌ إمَامٌ':Added, #1: 1	مُنَاظَرَةِ ابْنِ
u'مُنَاظَرَةٌ أهْلٌ':Added, #1: 1	مُنَاظَرَةِ الْإِمَامِ
u'مُنَاظَرَةٌ خُصُومٌ':Added, #1: 1	مُنَاظَرَة أَهْلِ
u'مُنَاظَرَةٌ سائِل':Added, #1: 1	مُنَاظَرَةِ الْخُصُومِ
u'مُنَاظَرَةٌ سَائِلٌ':Added, #1: 1	مُنَاظَرَةَ السَّائِلِ
u'مُنَاظَرَةٌ مُتَعَلِّمٌ':Added, #1: 1	مُنَاظَرَةَ السَّائِلِ
u'مُنَافَسَةٌ أكفاء':Added, #1: 1	مُنَاظَرَةَ الْمُتَعَلِّمِ
u'مُنَافَسَةٌ صَاحِبٌ':Added, #1: 1	مُنَافَسَةِ الْأَكْفَاءِ
u'مُنَاقَضَةٌ جمع':Added, #1: 1	مُنَافَسَةِ الصَّاحِبِ
u'مُنَاقَضَةٌ جَمْعٌ':Added, #1: 1	مُنَاقَضَةُ الْجَمْعِ
u'مُنَاقَضَةٌ شافِعِيّ':Added, #1: 1	مُنَاقَضَةُ الْجَمْعِ
u'مُنَاقَضَةٌ فلان':Added, #1: 1	مُنَاقَضَةُ الشَّافِعِيِّ
u'مُنَاقَضَةٌ نَصٌّ':Added, #1: 1	مُنَاقَضَةُ الشَّافِعِيِّ
u'مَنَّ إمَامٌ':Subject, #2: 2	مُنَاقَضَةِ النَّصِّ
u'مُنَاهَضَةٌ حِصْنٌ':Added, #3: 3	مَنَّ الْإِمَامُ
u'مِنَّةٌ أحَدٌ':Added, #1: 1	مُنَاهَضَةِ الْحِصْنِ
u'مِنَّةٌ رُكوبٌ':Added, #1: 1	مِنَّةُ أَحَدٍ
u'مَنَحَ جُهَّالٌ':Predicate, #1: 1	مِنَّةَ الرُّكُوبِ
u'مَنَّ رَسُولٌ':Subject, #1: 1	مَنَحَ الْجُهَّالَ
u'مَنْسَكٌ اِبْنٌ':Added, #2: 2	مَنَّ رَسُولُ
u'مَنْسَك اِبْنٌ':Added, #13: 13	مَنْسَكِ ابْنِ
u'مَنْسَكٌ سَعِيدٌ':Added, #13: 13	مَنْسَكِ ابْنِ
u'مَنْسَك سَعِيدٌ':Added, #1: 1	مَنْسَكِ سَعِيدِ
u'مَنْسَكٌ طَرابُلْسِيّ':Added, #1: 1	مَنْسَكِ سَعِيدِ
u'مَنْسَك طَرابُلْسِيّ':Added, #1: 1	مَنْسَكِ الطَّرَابُلْسِيِّ
u'مَنْسَكٌ عَفِيفٌ':Added, #1: 1	مَنْسَكِ الطَّرَابُلْسِيِّ
u'مَنْسَك عَفِيفٌ':Added, #1: 1	مَنْسَكِ الْعَفِيفِ
u'مَنْسَكٌ فَارِسِيٌّ':Added, #1: 1	مَنْسَكِ الْعَفِيفِ
u'مَنْسَك فَارِسِيٌّ':Added, #1: 1	مَنْسَكِ الْفَارِسِيِّ
u'مَنْسَكٌ فلان':Added, #1: 1	مَنْسَكِ الْفَارِسِيِّ
u'مَنْسَك فلان':Added, #1: 1	مَنْسَكِ الطَّرَابُلْسِيِّ
u'مَنْطِقٌ طَيْرٌ':Added, #1: 1	مَنْسَكِ الطَّرَابُلْسِيِّ
u'مَنْطِقٌ طَيْرٌ':Added, #2: 2	مَنْطِقِ الطَّيْرِ
u'مَنْطِقٌ فَلاَسِفَةٌ':Added, #4: 4	مَنْطِقَ الطَّيْرِ
u'مَنْظَرٌ حَسَنٌ':Added, #1: 1	مَنْطِقِ الْفَلَاسِفَةِ
u'مَنْظَرٌ صَاحِبٌ':Added, #1: 1	مَنْظَرٍ حَسَنٍ
u'مَنْظَرٌ عين':Added, #1: 1	مَنْظَرِ صَاحِبِهِ
u'مَنْظَرٌ عَيْنٌ':Added, #2: 2	مَنْظَرَ الْعَيْنِ
u'مَنْظَرٌ عَيْن':Added, #2: 2	مَنْظَرَ الْعَيْنِ
u'مَنْظَرٌ مُجْتَهِد':Added, #2: 2	مَنْظَرَ الْعَيْنِ
u'مَنْعٌ أَبٌ':Added, #1: 1	مَنْظَرُ الْمُجْتَهِدِ
u'مَنْعٌ أَبٌ':Added, #1: 1	مَنْعُ الْأَبِ
u'مَنَعَ اِبْتِداءٌ':Predicate, #2: 2	مَنْعِ الْأَبِ
u'مَنْعٌ اِبْتِداءٌ':Added, #1: 1	مَنَعَ ابْتِدَاءَ
u'مَنْعٌ إبدالٌ':Added, #2: 2	مَنْعِ ابْتِدَاءِ
u'مَنْعٌ إبدالٌ':Added, #1: 1	مَنْعُ إبْدَالِ
u'مَنَعَ إبْلِيسُ':Predicate, #1: 1	مَنْعِ إبْدَالِهِ
u'مَنَعَ اِبْنٌ':Subject, #1: 1	مَنَعَ إبْلِيسَ
u'مَنْعٌ اِبْنٌ':Added, #14: 14	مَنَعَ ابْنُ
u'مَنْعٌ اِبْنٌ':Added, #1: 1	مَنْعِ ابْنِ
u'مَنْعٌ اِبْنٌ':Added, #1: 1	مَنْع ابْنِهِ
u'مَنْعٌ اِبْنٌ':Added, #2: 2	مَنْعُ ابْنِ
u'مَنْعٌ اِتِّحَادٌ':Added, #2: 2	مَنْعُ ابْنِهِ
u'مَنَعَ إتْمَامٌ':Predicate, #1: 1	مَنْعَ اتِّحَادِ
u'مَنَعَ إتْمَامٌ':Predicate, #1: 1	مَنَعَ إتْمَامَ
u'مَنَعَ آثَارٌ':Predicate, #1: 1	مَنَعَ الْإِتْمَامَ
u'مَنْعٌ آثَارٌ':Added, #1: 1	مَنَعَ الْآثَارَ
u'مَنْعٌ إِثْمٌ':Added, #1: 1	مَنْعُ آثَارِ
u'مَنَعَ إجَارَةٌ':Predicate, #1: 1	مَنْعِ الْإِثْمِ
u'مَنْعٌ إجَارَةٌ':Added, #4: 4	مَنَعَ الْإِجَارَةَ
u'مَنْعٌ إجَارَةٌ':Added, #1: 1	مَنْعَ الْإِجَارَةِ
u'مَنْعٌ إِجْبَارٌ':Added, #5: 5	مَنْعِ إجَارَةِ
u'مَنْعٌ إِجْبَارٌ':Added, #1: 1	مَنْعَ الْإِجْبَارِ
u'مَنَعَ اِجْتِمَاعٌ':Predicate, #1: 1	مَنْعُ الْإِجْبَارِ
u'مَنْعٌ اِجْتِمَاعٌ':Added, #1: 1	مَنَعَ اجْتِمَاعَ
u'مَنْعٌ أَجْذَم':Added, #2: 2	مَنْعُ اجْتِمَاعِ
u'مَنَعَ إِجْزَاءٌ':Predicate, #1: 1	مَنْعُ الْأَجْذَمِ
u'مَنْعٌ إِجْزَاءٌ':Added, #2: 2	مَنَعَ الْإِجْزَاءَ
u'مَنَعَ إِجْمَاعٌ':Predicate, #2: 2	مَنْعِ الْإِجْزَاءِ
u'مَنْعٌ إِجْمَالٌ':Added, #1: 1	مَنَعَ الْإِجْمَاعَ
u'مَنْعٌ أَجْنَبِيٌّ':Added, #1: 1	مَنْعُ الْإِجْمَالِ
u'مَنْعٌ أَجْنَبِيٌّ':Added, #1: 1	مَنْعُ الْأَجْنَبِيِّ
u'مَنَعَ أَجِيرٌ':Predicate, #1: 1	مَنْعِ الْأَجْنَبِيِّ
u'مَنَعَ أَجِيرٌ':Predicate, #1: 1	مَنَعَ أَجِيرَ
u'مَنْعٌ أَجِيرٌ':Added, #1: 1	مَنَعَ الأَجِيرَ
u'مَنَعَ إِحْبَاطٌ':Predicate, #1: 1	مَنْعُ الْأَجِيرِ
u'مَنَعَ أحَدٌ':Predicate, #1: 1	مَنَعَ إحْبَاطَ
u'مَنَعَ أحَدٌ':Subject, #1: 1	مَنَعَ أَحَدَ
u'مَنْعٌ أحَدٌ':Added, #2: 2	مَنَعَ أَحَدُ
u'مَنْعٌ أحَدٌ':Added, #1: 1	مَنْعَ أَحَدِ
u'مَنْعٌ أحَدٌ':Added, #1: 1	مَنْعُ أَحَدٍ
u'مَنْعٌ إِحْدَاثٌ':Added, #1: 1	مَنْعُ أَحَدِ
u'مَنْعٌ إِحْدَاثٌ':Added, #2: 2	مَنْعُ إحْدَاثِ
u'مَنَعَ أخْذٌ':Predicate, #2: 2	مَنْعِ إحْدَاثِ
u'مَنْعٌ أخْذٌ':Added, #1: 1	مَنَعَ أَخْذَ
u'مَنْعٌ أخْذٌ':Added, #1: 1	مَنْعَ أَخْذِهِ
u'مَنْعٌ أخْذٌ':Added, #2: 2	مَنْعُ الْأَخْذِ
u'مَنْعٌ إِخْرَاجٌ':Added, #2: 2	مَنْعِ الْأَخْذِ
u'مَنْعٌ إِخْلالٌ':Added, #1: 1	مَنْعِ الْإِخْرَاجِ
u'مَنْعٌ أَخِيرٌ':Added, #1: 1	مَنْعُ الْإِخْلَالِ
u'مَنَعَ أَدَاءٌ':Subject, #1: 1	مَنْعُ الْأَخِيرِ
u'مَنْعٌ إِدْرَاكٌ':Added, #1: 1	مَنَعَ الْأَدَاءُ
u'مَنْعٌ إِرَادَةٌ':Added, #1: 1	مَنْعُ إدْرَاكِ
u'مَنْعٌ إِرَادَةٌ':Added, #1: 1	مَنْعُ إرَادَةِ
u'مَنْعٌ اِرْتِقَاءٌ':Added, #1: 1	مَنْعَ الْإِرَادَةِ
u'مَنْعٌ إِرْثٌ':Added, #1: 1	مَنْعِ ارْتِقَاءِ
u'مَنْعٌ إِرْثٌ':Added, #1: 1	مَنْعِ إرْثِ
u'مَنْعٌ إِرْثٌ':Added, #1: 1	مَنْعُ الْإِرْثِ
u'مَنْعٌ أَزْواجٌ':Added, #2: 2	مَنْعِ الْإِرْثِ
u'مَنْعٌ اِسْتِبَاحَةٌ':Added, #1: 1	مَنْعُ الْأَزْوَاجِ
u'مَنْعٌ اِسْتِثْنَاءٌ':Added, #1: 1	مَنْعَ اسْتِبَاحَةِ
u'مَنْعٌ اِسْتِدَامَةٌ':Added, #2: 2	مَنْعَ اسْتِثْنَاءِ
u'مَنْعٌ اِسْتِدْلاَلٌ':Added, #1: 1	مَنْعُ اسْتِدَامَتِهِ
u'مَنْعٌ اِسْتِعْمالٌ':Added, #1: 1	مَنْعُ اسْتِدْلَالِهِ
u'مَنْعٌ اِسْتِعْمالٌ':Added, #1: 1	مَنْعِ اسْتِعْمَالِ
u'مَنْعٌ اِسْتِعْمالٌ':Added, #1: 1	مَنْعُ اسْتِعْمَالِهِ
u'مَنْعٌ اِسْتِقْبالٌ':Added, #2: 2	مَنْعَ اسْتِعْمَالِ
u'مَنْعٌ اِسْتِقْلالٌ':Added, #1: 1	مَنْعِ اسْتِقْبَالِ
u'مَنْعٌ اِسْتِماعٌ':Added, #1: 1	مَنْعُ اسْتِقْلَالِهِ
u'مَنْعٌ اِسْتيفاءٌ':Added, #1: 1	مَنْعِ اسْتِمَاعِ
u'مَنْعٌ إِسْراعٌ':Added, #2: 2	مَنْعُ اسْتِيفَاءِ
u'مَنْعٌ إشارَة':Added, #1: 1	مَنْعُ الْإِسْرَاعِ
u'مَنَعَ أَصْحَابٌ':Subject, #1: 1	مَنْعَ الْإِشَارَةِ
u'مَنَعَ أَصْحَابٌ':Subject, #1: 1	مَنَعَ أَصْحَابُ
u'مَنْعٌ أصل':Added, #1: 1	مَنَعَ الْأَصْحَابُ
u'مَنْعٌ أًصْلٌ':Added, #1: 1	مَنْعِ أَصْلِ
u'مَنْعٌ إِطْعامٌ':Added, #1: 1	مَنْعِ أَصْلِ
u'مَنَعَ إِطْلاقٌ':Predicate, #1: 1	مَنْعِ إطْعَامِ
u'مَنْعٌ إِطْلاقٌ':Added, #1: 1	مَنَعَ الْإِطْلَاقَ
u'مَنْعٌ إِطْلاقٌ':Added, #1: 1	مَنْعَ إطْلَاقِ
u'مَنْعٌ إِطْلاقٌ':Added, #1: 1	مَنْعِ إطْلَاقِهِ
u'مَنْعٌ إِطْلاقٌ':Added, #1: 1	مَنْعِ الْإِطْلَاقِ
u'مَنْعٌ إِعارَةٌ':Added, #2: 2	مَنْعِ إطْلَاقِ
u'مَنْعٌ إِعارَةٌ':Added, #1: 1	مَنْعَ إعَارَةِ
u'مَنَعَ اِعْتِبارٌ':Predicate, #1: 1	مَنْعَ الْإِعَارَةِ
u'مَنْعٌ اِعْتِبارٌ':Added, #1: 1	مَنَعَ اعْتِبَارَ
u'مَنْعٌ إعْطَاءٌ':Added, #1: 1	مَنْعُ اعْتِبَارِ
u'مَنْعٌ إعْطَاءٌ':Added, #1: 1	مَنْعُ إعْطَاءِ
u'مَنْعٌ إِعْلاءٌ':Added, #1: 1	مَنْعِ إعْطَاءِ
u'مَنَعَ اِقْتِداءٌ':Predicate, #2: 2	مَنْعِ الْإِعْلَاءِ
u'مَنْعٌ اِقْتِداءٌ':Added, #1: 1	مَنَعَ اقْتِدَاءَ
u'مَنَعَ اِقْتِضَاءٌ':Predicate, #4: 4	مَنْعِ اقْتِدَاءِ
u'مَنَعَ إقْرَارٌ':Predicate, #1: 1	مَنَعَ اقْتِضَاءَ
u'مَنْعٌ إقْرَارٌ':Added, #1: 1	مَنَعَ الْإِقْرَارَ
u'مَنْعٌ إقْرَارٌ':Added, #1: 1	مَنْعُ إقْرَارِهِ
u'مَنْعٌ إِقْراضٌ':Added, #1: 1	مَنْعِ الْإِقْرَارِ
u'مَنْعٌ إقْطَاعٌ':Added, #1: 1	مَنْعِ إقْرَاضِ
u'مَنْعٌ اِكْتِسَابٌ':Added, #3: 3	مَنْعِ إقْطَاعِ
u'مَنَعَ أَكْثَرُ':Subject, #1: 1	مَنْعَ اكْتِسَابِهِ
u'مَنْعٌ أكل':Added, #2: 2	مَنَعَ أَكْثَرُ
u'مَنْعٌ أكل':Added, #1: 1	مَنْعَ الْأَكْلِ
u'مَنْعٌ أكل':Added, #1: 1	مَنْعُ الْأَكْلِ
u'مَنْعٌ أَكْلٌ':Added, #1: 1	مَنْعِ الْأَكْلِ
u'مَنْعٌ أَكْلٌ':Added, #1: 1	مَنْعَ الْأَكْلِ
u'مَنْعٌ أَكْلٌ':Added, #1: 1	مَنْعُ الْأَكْلِ
u'مَنْعٌ أكل':Added, #1: 1	مَنْعِ الْأَكْلِ
u'مَنْعٌ أَكْلٌ':Added, #2: 2	مَنْعِ أَكْلِهِ
u'مَنْعٌ أكل':Added, #2: 2	مَنْعِ أَكْلِهِ
u'مَنْعٌ أَكْلٌ':Added, #3: 3	مَنْعُ أَكْلِ
u'مَنْعٌ أكل':Added, #3: 3	مَنْعُ أَكْلِ
u'مَنْعٌ أَكْلٌ':Added, #4: 4	مَنْعُ أَكْلِهِ
u'مَنْعٌ إِكْمَالٌ':Added, #4: 4	مَنْعُ أَكْلِهِ
u'مَنْعٌ اِلْتِقَاطٌ':Added, #2: 2	مَنْعِ الْإِكْمَالِ
u'مَنْعٌ إلْحَاقٌ':Added, #1: 1	مَنْعِ الْتِقَاطِ
u'مَنْعٌ إلْحَاقٌ':Added, #1: 1	مَنْعَ الْإِلْحَاقِ
u'مَنْعٌ إِلْزَامٌ':Added, #1: 1	مَنْعِ إلْحَاقِ
u'مَنْعٌ الْمَرْأَةُ':Added, #1: 1	مَنْعِ إلْزَامِهِ
u'مَنْعٌ الْمَرْأَةُ':Added, #2: 2	مَنْعِ الْمَرْأَةِ
u'مَنَعَ المُشْتَرِي':Predicate, #5: 5	مَنْعُ الْمَرْأَةِ
u'مَنْعٌ أُمٌّ':Added, #2: 2	مَنَعَ الْمُشْتَرِيَ
u'مَنَعَ إمَامٌ':Predicate, #1: 1	مَنْعُ أُمِّهِ
u'مَنَعَ إمَامٌ':Subject, #1: 1	مَنَعَ الْإِمَامَ
u'مَنْعٌ إمَامٌ':Added, #5: 5	مَنَعَ الْإِمَامُ
u'مَنَعَ إمَامَةٌ':Predicate, #2: 2	مَنْعُ الْإِمَامِ
u'مَنْعٌ إمَامَةٌ':Added, #1: 1	مَنَعَ الْإِمَامَةَ
u'مَنْعٌ إمَامَةٌ':Added, #2: 2	مَنْعَ إمَامَةِ
u'مَنْعٌ أمَانٌ':Added, #2: 2	مَنْعِ إمَامَةِ
u'مَنْعٌ أمَةٌ':Added, #1: 1	مَنْعُ أَمَانِهِ
u'مَنْعٌ أَمْرٌ':Added, #2: 2	مَنْعُ الْأَمَةِ
u'مَنْعٌ اِمْرَأَةٌ':Added, #1: 1	مَنْعِ أَمْرٍ
u'مَنْعٌ اِمْرَأَةٌ':Added, #2: 2	مَنْعَ امْرَأَتِهِ
u'مَنْعٌ أَمْرَد':Added, #3: 3	مَنْعُ امْرَأَتِهِ
u'مَنَعَ إِمْضاءٌ':Predicate, #1: 1	مَنْعَ الْأَمْرَدِ
u'مَنْعٌ اِنْتِفاء':Added, #1: 1	مَنَعَ الْإِمْضَاءَ
u'مَنْعٌ اِنْتِفاء':Added, #1: 1	مَنْعِ انْتِفَاءِ
u'مَنَعَ اِنْتِفاعٌ':Predicate, #4: 4	مَنْعُ انْتِفَاءِ
u'مَنْعٌ إِنْسانٌ':Added, #1: 1	مَنَعَ الاِنْتِفَاعَ
u'مَنْعٌ إِنْسانٌ':Added, #1: 1	مَنْعُ الْإِنْسَانِ
u'مَنَعَ اِنْعِقَادٌ':Predicate, #1: 1	مَنْعَ إنْسَانٍ
u'مَنْعٌ اِنْعِقَادٌ':Added, #4: 4	مَنَعَ انْعِقَادَ
u'مَنْعٌ اِنْعِقَادٌ':Added, #1: 1	مَنْعِ انْعِقَادِهِ
u'مَنْعٌ اِنْعِقَادٌ':Added, #2: 2	مَنْعُ انْعِقَادِ
u'مَنَعَ إِنْفاقٌ':Predicate, #2: 2	مَنْعِ انْعِقَادِ
u'مَنَعَ أهْلٌ':Predicate, #1: 1	مَنَعَ الْإِنْفَاقَ
u'مَنَعَ أهْلٌ':Subject, #4: 4	مَنَعَ أَهْلَ
u'مَنْعٌ أهْلٌ':Added, #1: 1	مَنَعَ أَهْلُ
u'مَنْعٌ أَوَّلُ':Added, #1: 1	مَنْعُ أَهْلِ
u'مَنْعٌ أَوْلاَدٌ':Added, #1: 1	مَنْعِ الْأَوَّلِ
u'مَنَعَ إِيجَابٌ':Predicate, #1: 1	مَنْعَ الْأَوْلَادِ
u'مَنْعٌ بالِغٌ':Added, #1: 1	مَنَعَ إيجَابَ
u'مَنْعٌ بالِغٌ':Added, #1: 1	مَنْعِ الْبَالِغِ
u'مَنَعَ بَائِعٌ':Subject, #2: 2	مَنْعُ الْبَالِغِ
u'مَنْعٌ بَائِعٌ':Added, #2: 2	مَنَعَ الْبَائِعُ
u'مَنْعٌ بَائِعٌ':Added, #1: 1	مَنْعَ الْبَائِعِ
u'مَنْعٌ بِدْعَةٌ':Added, #1: 1	مَنْعِ الْبَائِعِ
u'مَنَعَ بَعْضٌ':Predicate, #1: 1	مَنْعِ الْبِدْعَةِ
u'مَنَعَ بَعْضٌ':Subject, #1: 1	مَنَعَ بَعْضَ
u'مَنْعٌ بَعْضٌ':Added, #11: 11	مَنَعَ بَعْضُ
u'مَنْعٌ بَعْضٌ':Added, #1: 1	مَنْعِ الْبَعْضِ
u'مَنْعٌ بَعْضٌ':Added, #1: 1	مَنْعِ بَعْضِ
u'مَنَعَ بَقاءٌ':Predicate, #4: 4	مَنْعُ بَعْضِ
u'مَنْعٌ بَقِيَّةٌ':Added, #1: 1	مَنَعَ الْبَقَاءَ
u'مَنْعٌ بِنَاءٌ':Added, #1: 1	مَنْعُ بَقِيَّةِ
u'مَنْعٌ بِنَاءٌ':Added, #1: 1	مَنْعُ الْبِنَاءِ
u'مَنَعَ بَيَانٌ':Predicate, #2: 2	مَنْعِ الْبِنَاءِ
u'مَنَعَ بَيْتٌ':Predicate, #1: 1	مَنَعَ بَيَانَ
u'مَنَعَ بَيْتٌ':Subject, #1: 1	مَنَعَ الْبَيْتَ
u'مَنَعَ بَيْعٌ':Predicate, #1: 1	مَنَعَ بَيْتُ
u'مَنَعَ بَيْعٌ':Predicate, #2: 2	مَنَعَ الْبَيْعَ
u'مَنْعٌ بَيْعٌ':Added, #3: 3	مَنَعَ بَيْعَ
u'مَنْعٌ بَيْعٌ':Added, #14: 14	مَنْعُ بَيْعِ
u'مَنْعٌ بَيْعٌ':Added, #15: 15	مَنْعِ بَيْعِ
u'مَنْعٌ بَيْعٌ':Added, #2: 2	مَنْعَ بَيْعِ
u'مَنْعٌ بَيْعٌ':Added, #2: 2	مَنْعَ بَيْعِهِ
u'مَنْعٌ بَيْعٌ':Added, #3: 3	مَنْعُ الْبَيْعِ
u'مَنْعٌ بَيْعٌ':Added, #3: 3	مَنْعِ الْبَيْعِ
u'مَنْعٌ بَيْعٌ':Added, #3: 3	مَنْعُ بَيْعِهِ
u'مَنْعٌ بَيِّنَةٌ':Added, #7: 7	مَنْعِ بَيْعِهِ
u'مَنْعٌ تَأْثِيرٌ':Added, #1: 1	مَنْعَ الْبَيِّنَةِ
u'مَنْعٌ تَأْخِيرٌ':Added, #1: 1	مَنْعِ التَّأْثِيرِ
u'مَنْعٌ تَأْخِيرٌ':Added, #1: 1	مَنْعُ التَّأْخِيرِ
u'مَنْعٌ تَبَرُّعٌ':Added, #3: 3	مَنْعِ تَأْخِيرِ
u'مَنْعٌ تَثْلِيثٌ':Added, #1: 1	مَنْعِ التَّبَرُّعِ
u'مَنْعٌ تَجَوُّزٌ':Added, #1: 1	مَنْعِ التَّثْلِيثِ
u'مَنْعٌ تَجْوِيزٌ':Added, #1: 1	مَنْعِ التَّجَوُّزِ
u'مَنْعٌ تَحْرِيمٌ':Added, #1: 1	مَنْعُ تَجْوِيزِ
u'مَنْعٌ تَحْرِيمٌ':Added, #1: 1	مَنْعِ التَّحْرِيمِ
u'مَنْعٌ تَحْرِيمٌ':Added, #1: 1	مَنْعَ تَحْرِيمٍ
u'مَنْعٌ تَحْرِيمٌ':Added, #1: 1	مَنْعِ تَحْرِيمِ
u'مَنْعٌ تَحْشِيَة':Added, #3: 3	مَنْعُ تَحْرِيمٍ
u'مَنْعٌ تَحَقُّقٌ':Added, #1: 1	مَنْعُ التَّحْشِيَةِ
u'مَنْعٌ تَحْقِيقٌ':Added, #1: 1	مَنْعُ تَحَقُّقِ
u'مَنْعٌ تَحْكِيمٌ':Added, #1: 1	مَنْعَ تَحْقِيقِ
u'مَنْعٌ تَحْلِيف':Added, #1: 1	مَنْعُ التَّحْكِيمِ
u'مَنْعٌ تَحْمِيلٌ':Added, #1: 1	مَنْعَ التَّحْلِيفِ
u'مَنْعٌ تَخْرِيجٌ':Added, #1: 1	مَنْعَ تَحْمِيلِ
u'مَنَعَ تَخْصِيصٌ':Predicate, #1: 1	مَنْعَ التَّخْرِيجِ
u'مَنَعَ تَخْصِيصٌ':Predicate, #1: 1	مَنَعَ التَّخْصِيصَ
u'مَنْعٌ تَخْصِيصٌ':Added, #1: 1	مَنَعَ تَخْصِيصَ
u'مَنْعٌ تَخْصِيصٌ':Added, #1: 1	مَنْعِ التَّخْصِيصِ
u'مَنْعٌ تَخْصِيصٌ':Added, #1: 1	مَنْعَ تَخْصِيصِ
u'مَنَعَ تَخَلُّفٌ':Predicate, #1: 1	مَنْعِ تَخْصِيصِ
u'مَنْعٌ تَخَلُّفٌ':Added, #1: 1	مَنَعَ التَّخَلُّفَ
u'مَنْعٌ تَخْيِيرٌ':Added, #1: 1	مَنْعُ تَخَلُّفِ
u'مَنْعٌ تَخْيِيرٌ':Added, #1: 1	مَنْعَ التَّخْيِيرِ
u'مَنْعٌ تَدَارُكٌ':Added, #1: 1	مَنْعُ التَّخْيِيرِ
u'مَنَعَ تَذَكُّرٌ':Subject, #1: 1	مَنْعَ التَّدَارُكِ
u'مَنْعٌ تَرَاخِي':Added, #1: 1	مَنَعَ تَذَكُّرُهُ
u'مَنْعٌ تَرَادُفٌ':Added, #1: 1	مَنْعُ تَرَاخِيهِ
u'مَنَعَ تَرْتِيبٌ':Predicate, #1: 1	مَنْعِ تَرَادُفِ
u'مَنْعٌ تَرْجِيحٌ':Added, #1: 1	مَنَعَ تَرْتِيبَ
u'مَنْعٌ تَرْخِيصٌ':Added, #1: 1	مَنْعُ التَّرْجِيحِ
u'مَنْعٌ تَرْكٌ':Added, #2: 2	مَنْعِ التَّرْخِيصِ
u'مَنَعَ تَزَوُّجٌ':Subject, #1: 1	مَنْعَ تَرْكِهِ
u'مَنْعٌ تَزْوِيجٌ':Added, #1: 1	مَنَعَ التَّزَوُّجُ
u'مَنْعٌ تَزْوِيجٌ':Added, #1: 1	مَنْعِ تَزْوِيجِ
u'مَنْعٌ تَسْلِيمٌ':Added, #2: 2	مَنْعَ التَّزْوِيجِ
u'مَنْعٌ تَسْوِيغ':Added, #1: 1	مَنْعِ التَّسْلِيمِ
u'مَنْعٌ تَصْدِيقٌ':Added, #1: 1	مَنْعِ تَسْوِيغِ
u'مَنَعَ تَصَرُّفٌ':Predicate, #1: 1	مَنْعُ التَّصْدِيقِ
u'مَنْعٌ تَصَرُّفٌ':Added, #2: 2	مَنَعَ التَّصَرُّفَ
u'مَنْعٌ تَصَرُّفٌ':Added, #10: 10	مَنْعُ التَّصَرُّفِ
u'مَنْعٌ تَصَرُّفٌ':Added, #1: 1	مَنْعِ التَّصَرُّفِ
u'مَنْعٌ تَصَوُّرٌ':Added, #1: 1	مَنْعِ تَصَرُّفِهِ
u'مَنْعٌ تَضْحِيَةٌ':Added, #2: 2	مَنْعِ تَصَوُّرِ
u'مَنْعٌ تَضْمِينٌ':Added, #1: 1	مَنْعِ التَّضْحِيَةِ
u'مَنْعٌ تَطَهُّرٌ':Added, #1: 1	مَنْعُ تَضْمِينِهِ
u'مَنْعٌ تَعَادُلٌ':Added, #2: 2	مَنْعِ التَّطَهُّرِ
u'مَنْعٌ تَعَدُّدٌ':Added, #1: 1	مَنْعِ تَعَادُلِ
u'مَنْعٌ تَعَرُّضٌ':Added, #1: 1	مَنْعُ التَّعَدُّدِ
u'مَنْعٌ تَعْرِيضٌ':Added, #1: 1	مَنْعِ التَّعَرُّضِ
u'مَنَعَ تَعَلُّقٌ':Predicate, #1: 1	مَنْعِ التَّعْرِيضِ
u'مَنْعٌ تَعَلُّقٌ':Added, #1: 1	مَنَعَ تَعَلُّقَ
u'مَنَعَ تَعْلِيقٌ':Subject, #1: 1	مَنْعِ تَعَلُّقِهِ
u'مَنْعٌ تَعْلِيقٌ':Added, #1: 1	مَنَعَ التَّعْلِيقُ
u'مَنَعَ تَعْلِيلٌ':Predicate, #1: 1	مَنْعُ التَّعْلِيقِ
u'مَنْعٌ تَعْلِيلٌ':Added, #1: 1	مَنَعَ التَّعْلِيلَ
u'مَنْعٌ تَعْلِيلٌ':Added, #2: 2	مَنْعِ تَعْلِيلِهِ
u'مَنْعٌ تَعْلِيلٌ':Added, #3: 3	مَنْعِ التَّعْلِيلِ
u'مَنْعٌ تَعْمِيمٌ':Added, #3: 3	مَنْعِ تَعْلِيلِ
u'مَنْعٌ تَعْمِيمٌ':Added, #1: 1	مَنْعِ تَعْمِيمِ
u'مَنْعٌ تَعَيُّنٌ':Added, #1: 1	مَنْعِ تَعْمِيمِهِ
u'مَنَعَ تَغَيُّرٌ':Subject, #1: 1	مَنْعُ تَعَيُّنِ
u'مَنْعٌ تَغْيِيرٌ':Added, #1: 1	مَنَعَ تَغَيُّرُهُ
u'مَنْعٌ تَفَاضُلٌ':Added, #1: 1	مَنْعِ تَغْيِيرِ
u'مَنْعٌ تَفْرِيقٌ':Added, #1: 1	مَنْعِ التَّفَاضُلِ
u'مَنْعٌ تَفْرِيقٌ':Added, #1: 1	مَنْعَ التَّفْرِيقِ
u'مَنْعٌ تَفْرِيقٌ':Added, #2: 2	مَنْعِ التَّفْرِيقِ
u'مَنْعٌ تَقْديمٌ':Added, #4: 4	مَنْعُ التَّفْرِيقِ
u'مَنْعٌ تَقْديمٌ':Added, #1: 1	مَنْعُ التَّقْدِيمِ
u'مَنْعٌ تَقْديمٌ':Added, #1: 1	مَنْعِ التَّقْدِيمِ
u'مَنْعٌ تَقْديمٌ':Added, #1: 1	مَنْعِ تَقْدِيمِ
u'مَنْعٌ تَقْديمٌ':Added, #2: 2	مَنْعَ التَّقْدِيمِ
u'مَنَعَ تَقْليدٌ':Predicate, #2: 2	مَنْعُ تَقْدِيمِ
u'مَنَعَ تَقْليد':Predicate, #1: 1	مَنَعَ تَقْلِيدَ
u'مَنْعٌ تَقْليدٌ':Added, #1: 1	مَنَعَ تَقْلِيدَ
u'مَنْعٌ تَقْليد':Added, #1: 1	مَنْعُ التَّقْلِيدِ
u'مَنْعٌ تَقْليدٌ':Added, #1: 1	مَنْعُ التَّقْلِيدِ
u'مَنْعٌ تَقْليد':Added, #1: 1	مَنْعُ تَقْلِيدِ
u'مَنْعٌ تَقْليدٌ':Added, #1: 1	مَنْعُ تَقْلِيدِ
u'مَنْعٌ تَقْليد':Added, #1: 1	مَنْعَ تَقْلِيدِهِ
u'مَنْعٌ تَقْليدٌ':Added, #1: 1	مَنْعَ تَقْلِيدِهِ
u'مَنْعٌ تَقْليد':Added, #2: 2	مَنْعِ التَّقْلِيدِ
u'مَنْعٌ تَقْليدٌ':Added, #2: 2	مَنْعِ التَّقْلِيدِ
u'مَنْعٌ تَقْليد':Added, #2: 2	مَنْعِ تَقْلِيدِ
u'مَنْعٌ تَكْفيرٌ':Added, #2: 2	مَنْعِ تَقْلِيدِ
u'مَنْعٌ تَكْليفٌ':Added, #1: 1	مَنْعِ التَّكْفِيرِ
u'مَنْعٌ تَكْليفٌ':Added, #1: 1	مَنْعَ التَّكْلِيفِ
u'مَنْعٌ تَكْليفٌ':Added, #1: 1	مَنْعِ التَّكْلِيفِ
u'مَنْعٌ تَلَذُّذٌ':Added, #2: 2	مَنْعِ تَكْلِيفِ
u'مَنَعَ تمام':Predicate, #1: 1	مَنْعُ التَّلَذُّذِ
u'مَنَعَ تَمامٌ':Predicate, #1: 1	مَنَعَ تَمَامَ
u'مَنْعٌ تمام':Added, #1: 1	مَنَعَ تَمَامَ
u'مَنْعٌ تَمامٌ':Added, #1: 1	مَنْعُ التَّمَامِ
u'مَنْعٌ تمام':Added, #1: 1	مَنْعُ التَّمَامِ
u'مَنْعٌ تَمامٌ':Added, #1: 1	مَنْعِ تَمَامِ
u'مَنَعَ تَمْلِيكٌ':Predicate, #1: 1	مَنْعِ تَمَامِ
u'مَنَعَ تَنَاوُلٌ':Predicate, #1: 1	مَنَعَ تَمْلِيكَ
u'مَنْعٌ تَنْزِيه':Added, #1: 1	مَنَعَ التَّنَاوُلَ
u'مَنْعٌ تَنَفُّلٌ':Added, #1: 1	مَنْعِ التَّنْزِيهِ
u'مَنْعٌ تَنَفُّلٌ':Added, #1: 1	مَنْعَ التَّنَفُّلِ
u'مَنْعٌ تَنْوِينٌ':Added, #1: 1	مَنْعُ التَّنَفُّلِ
u'مَنْعٌ تَوَارُثٌ':Added, #1: 1	مَنْعُ تَنْوِينِ
u'مَنْعٌ تَوْسِيعٌ':Added, #1: 1	مَنْعَ تَوَارُثِ
u'مَنْعٌ تَوْسِيعٌ':Added, #1: 1	مَنْعَ تَوْسِيعِ
u'مَنْعٌ تَوَقُّفٌ':Added, #1: 1	مَنْعِ تَوْسِيعِهِ
u'مَنْعٌ تَوَقُّفٌ':Added, #1: 1	مَنْعُ تَوَقُّفِهِ
u'مَنْعٌ تَوْكِيلٌ':Added, #2: 2	مَنْعُ تَوَقُّفِ
u'مَنْعٌ تَوْكِيلٌ':Added, #1: 1	مَنْعُ التَّوْكِيلِ
u'مَنْعٌ تَوْكِيلٌ':Added, #1: 1	مَنْعِ التَّوْكِيلِ
u'مَنْعٌ تَوْكِيلٌ':Added, #1: 1	مَنْعَ تَوْكِيلِ
u'مَنْعٌ تَوْكِيلٌ':Added, #1: 1	مَنْعِ تَوْكِيلِ
u'مَنْعٌ تَوَلُّدٌ':Added, #2: 2	مَنْعَ التَّوْكِيلِ
u'مَنَعَ تَوْلِيَةٌ':Predicate, #1: 1	مَنْعِ تَوَلُّدِ
u'مَنْعٌ تَيَمُّمٌ':Added, #1: 1	مَنَعَ تَوْلِيَةَ
u'مَنْعٌ تَيَمُّمٌ':Added, #1: 1	مَنْعُ التَّيَمُّمِ
u'مَنَعَ ثَالِثٌ':Predicate, #1: 1	مَنْعِ التَّيَمُّمِ
u'مَنَعَ ثَانِي':Predicate, #1: 1	مَنَعَ الثَّالِثَ
u'مَنَعَ ثُبُوتٌ':Subject, #1: 1	مَنَعَ الثَّانِيَ
u'مَنْعٌ ثُبُوتٌ':Added, #1: 1	مَنَعَ ثُبُوتُهُ
u'مَنْعٌ ثُبُوتٌ':Added, #1: 1	مَنْعُ ثُبُوتِهِ
u'مَنْعٌ ثُبُوتٌ':Added, #2: 2	مَنْعِ ثُبُوتِ
u'مَنَعَ جَارٌ':Predicate, #3: 3	مَنْعُ ثُبُوتِ
u'مَنْعٌ جَارٌ':Added, #1: 1	مَنَعَ الْجَارَ
u'مَنْعٌ جَامِعٌ':Added, #3: 3	مَنْعُ جَارِهِ
u'مَنْعٌ جَائِزٌ':Added, #1: 1	مَنْعُ الْجَامِعِ
u'مَنْعٌ جَرَيان':Added, #1: 1	مَنْعُ الْجَائِزِ
u'مَنْعٌ جَزَاءٌ':Added, #1: 1	مَنْعِ جَرَيَانِ
u'مَنَعَ جماع':Predicate, #1: 1	مَنْعِ الْجَزَاءِ
u'مَنَعَ جِمَاعٌ':Predicate, #2: 2	مَنَعَ الْجِمَاعَ
u'مَنَعَ جَمَاعَةٌ':Subject, #2: 2	مَنَعَ الْجِمَاعَ
u'مَنَعَ جمع':Predicate, #1: 1	مَنَعَ جَمَاعَةٌ
u'مَنَعَ جَمْعٌ':Predicate, #1: 1	مَنَعَ الْجَمْعَ
u'مَنْعٌ جمع':Added, #1: 1	مَنَعَ الْجَمْعَ
u'مَنْعٌ جمع':Added, #1: 1	مَنْعُ الْجَمْعِ
u'مَنْعٌ جَمْعٌ':Added, #1: 1	مَنْعِ الْجَمْعِ
u'مَنْعٌ جَمْعٌ':Added, #1: 1	مَنْعُ الْجَمْعِ
u'مَنْعٌ جمع':Added, #1: 1	مَنْعِ الْجَمْعِ
u'مَنْعٌ جَمْعٌ':Added, #2: 2	مَنْعِ جَمْعِ
u'مَنَعَ جُمْلَةٌ':Predicate, #2: 2	مَنْعِ جَمْعِ
u'مَنْعٌ جَمِيع':Added, #1: 1	مَنَعَ جُمْلَةَ
u'مَنَعَ جَوَازٌ':Predicate, #1: 1	مَنْعُ الْجَمِيعِ
u'مَنَعَ جَوَازٌ':Predicate, #3: 3	مَنَعَ الْجَوَازَ
u'مَنْعٌ جَوَازٌ':Added, #5: 5	مَنَعَ جَوَازَ
u'مَنْعٌ جَوَازٌ':Added, #1: 1	مَنْعَ الْجَوَازِ
u'مَنْعٌ جَوَازٌ':Added, #1: 1	مَنْع جَوَازِ
u'مَنْعٌ حاكِمٌ':Added, #1: 1	مَنْعَ جَوَازِ
u'مَنْعٌ حائِضٌ':Added, #2: 2	مَنْعِ الْحَاكِمِ
u'مَنْعٌ حائِضٌ':Added, #1: 1	مَنْعَ الْحَائِضِ
u'مَنَعَ حائِلٌ':Subject, #1: 1	مَنْعِ الْحَائِضِ
u'مَنَعَ حائِلٌ':Subject, #1: 1	مَنَعَ الْحَائِلُ
u'مَنْعٌ حَبْسٌ':Added, #1: 1	مَنَعَ حَائِلُ
u'مَنْعٌ حَبْسٌ':Added, #1: 1	مَنْعِ الْحَبْسِ
u'مَنَعَ حَجْرٌ':Predicate, #1: 1	مَنْعِ حَبْسِهِ
u'مَنْعٌ حَجْرٌ':Added, #1: 1	مَنَعَ الْحَجْرَ
u'مَنْعٌ حَدٌّ':Added, #1: 1	مَنْعِ الْحَجْرِ
u'مَنْعٌ حَدٌّ':Added, #1: 1	مَنْعُ الْحَدِّ
u'مَنَعَ حُدوثٌ':Predicate, #2: 2	مَنْعِ الْحَدِّ
u'مَنْعٌ حَرْب':Added, #3: 3	مَنَعَ حُدُوثَ
u'مَنْعٌ حَرْبَة':Added, #1: 1	مَنْعَ حَرْبِيَّةٍ
u'مَنْعٌ حَرْبِيّ':Added, #1: 1	مَنْعَ حَرْبِيَّةٍ
u'مَنْعٌ حَصْرٌ':Added, #1: 1	مَنْعَ حَرْبِيَّةٍ
u'مَنْعٌ حَصْرٌ':Added, #1: 1	مَنْعُ الْحَصْرِ
u'مَنَعَ حَقٌّ':Predicate, #2: 2	مَنْعِ الْحَصْرِ
u'مَنَعَ حَقٌّ':Subject, #1: 1	مَنَعَ حَقَّ
u'مَنْعٌ حَقٌّ':Added, #1: 1	مَنَعَ حَقُّ
u'مَنْعٌ حَقٌّ':Added, #1: 1	مَنْعَ الْحَقِّ
u'مَنْعٌ حَقٌّ':Added, #1: 1	مَنْعَ حَقِّ
u'مَنْعٌ حَقٌّ':Added, #2: 2	مَنْعِ الْحَقِّ
u'مَنْعٌ حُقوقٌ':Added, #5: 5	مَنْعُ الْحَقِّ
u'مَنْعٌ حُقُوقٌ':Added, #1: 1	مَنْعُ الْحُقُوقِ
u'مَنْعٌ حُقوقٌ':Added, #1: 1	مَنْعُ الْحُقُوقِ
u'مَنْعٌ حُقُوقٌ':Added, #1: 1	مَنْعِ حُقُوقِهِ
u'مَنَعَ حُكْمٌ':Predicate, #1: 1	مَنْعِ حُقُوقِهِ
u'مَنْعٌ حُكْمٌ':Added, #1: 1	مَنَعَ الْحُكْمَ
u'مَنْعٌ حُكْمٌ':Added, #2: 2	مَنْعَ الْحُكْمِ
u'مَنْعٌ حُكْمٌ':Added, #2: 2	مَنْعُ الْحُكْمِ
u'مَنْعٌ حُكْمٌ':Added, #4: 4	مَنْعِ حُكْمِ
u'مَنْعٌ حُكْمٌ':Added, #6: 6	مَنْعُ حُكْمِ
u'مَنْعٌ حِلٌّ':Added, #8: 8	مَنْعِ الْحُكْمِ
u'مَنْعٌ حِلٌّ':Added, #1: 1	مَنْعِ الْحِلِّ
u'مَنْعٌ حِلٌّ':Added, #1: 1	مَنْعُ حِلِّ
u'مَنْعٌ حلب':Added, #1: 1	مَنْعِ حِلِّ
u'مَنَعَ حَمْلٌ':Predicate, #1: 1	مَنْعُ حَلْبِ
u'مَنْعٌ حَمْلٌ':Added, #2: 2	مَنَعَ الْحَمْلَ
u'مَنَعَ حَنَفِيَّةٌ':Subject, #1: 1	مَنْعَ حَمْلِ
u'مَنْعٌ حَوَالَةٌ':Added, #1: 1	مَنَعَ الْحَنَفِيَّةُ
u'مَنْعٌ حَيْضٌ':Added, #1: 1	مَنْعُ الْحَوَالَةِ
u'مَنْعٌ خاصّ':Added, #1: 1	مَنْعِ الْحَيْضِ
u'مَنَعَ خُرُوجٌ':Predicate, #1: 1	مَنْعُ خَاصِّ
u'مَنْعٌ خُرُوجٌ':Added, #1: 1	مَنَعَ الْخُرُوجَ
u'مَنْعٌ خُرُوجٌ':Added, #1: 1	مَنْعُ الْخُرُوجِ
u'مَنْعٌ خُرُوجٌ':Added, #1: 1	مَنْعُ خُرُوجِ
u'مَنَعَ خَصْمٌ':Subject, #2: 2	مَنْعِ الْخُرُوجِ
u'مَنْعٌ خَصْمٌ':Added, #1: 1	مَنَعَ الْخَصْمُ
u'مَنَعَ خُصُومٌ':Predicate, #1: 1	مَنْعِ الْخَصْمِ
u'مَنْعٌ خَطَأٌ':Added, #1: 1	مَنَعَ الْخُصُومَ
u'مَنَعَ خِطَابٌ':Predicate, #1: 1	مَنْعُ خَطَأِ
u'مَنَعَ خِلاَفٌ':Predicate, #1: 1	مَنَعَ الْخِطَابَ
u'مَنْعٌ خِلاَفٌ':Added, #1: 1	مَنَعَ الْخِلَافَ
u'مَنْعٌ خلق':Added, #1: 1	مَنْعُ خِلَافِهِ
u'مَنْعٌ خَلْقٌ':Added, #1: 1	مَنْعُ الْخَلْقِ
u'مَنْعٌ خَيْلٌ':Added, #1: 1	مَنْعُ الْخَلْقِ
u'مَنَعَ دُخُولٌ':Predicate, #1: 1	مَنْعِ الْخَيْلِ
u'مَنْعٌ دُخُولٌ':Added, #2: 2	مَنَعَ دُخُولَ
u'مَنْعٌ دُخُولٌ':Added, #1: 1	مَنْعِ الدُّخُولِ
u'مَنْعٌ دُخُولٌ':Added, #1: 1	مَنْعُ دُخُولِ
u'مَنْعٌ دُعَاءٌ':Added, #1: 1	مَنْعِ دُخُولِهِ
u'مَنَعَ دفع':Predicate, #1: 1	مَنْعِ الدُّعَاءِ
u'مَنَعَ دَفْعٌ':Predicate, #1: 1	مَنَعَ الدَّفْعَ
u'مَنْعٌ دفع':Added, #1: 1	مَنَعَ الدَّفْعَ
u'مَنْعٌ دَفْعٌ':Added, #1: 1	مَنْعِ دَفْعِ
u'مَنْعٌ دَلالَةٌ':Added, #1: 1	مَنْعِ دَفْعِ
u'مَنَعَ دَليلٌ':Subject, #1: 1	مَنْعِ دَلَالَةِ
u'مَنْعٌ دَليلٌ':Added, #1: 1	مَنَعَ دَلِيلُ
u'مَنَعَ دَمٌ':Predicate, #1: 1	مَنْعِ الدَّلِيلِ
u'مَنْعٌ دَمٌ':Added, #2: 2	مَنَعَ الدَّمَ
u'مَنْعٌ دَوَابُّ':Added, #1: 1	مَنْعِ دَمٍ
u'مَنْعٌ دَوَابُّ':Added, #1: 1	مَنْعُ الدَّوَابِّ
u'مَنَعَ دَوامٌ':Predicate, #2: 2	مَنْعَ الدَّوَابِّ
u'مَنَعَ دَيْنٌ':Subject, #1: 1	مَنَعَ الدَّوَامَ
u'مَنَعَ دَيْنٌ':Subject, #1: 1	مَنَعَ الدَّيْنُ
u'مَنْعٌ دَيْنٌ':Added, #1: 1	مَنَعَ دَيْنُ
u'مَنْعٌ دَيْنٌ':Added, #1: 1	مَنْعِ دَيْنِ
u'مَنْعٌ ذَرائِعُ':Added, #4: 4	مَنْعِ الدَّيْنِ
u'مَنْعٌ ذَريعٌ':Added, #1: 1	مَنْعُ الذَّرَائِعِ
u'مَنْعٌ ذَريعَةٌ':Added, #1: 1	مَنْعِ الذَّرِيعَةِ
u'مَنْعٌ ذِمِّيٌّ':Added, #1: 1	مَنْعِ الذَّرِيعَةِ
u'مَنْعٌ ذِمِّيٌّ':Added, #1: 1	مَنْعَ الذِّمِّيَّةِ
u'مَنَعَ ذَوْقٌ':Predicate, #2: 2	مَنْعَ الذِّمِّيِّ
u'مَنَعَ رَاعِي':Predicate, #1: 1	مَنَعَ الذَّوْقَ
u'مَنْعٌ رَاهِنٌ':Added, #1: 1	مَنَعَ الرَّاعِيَ
u'مَنْعٌ رَاهِنٌ':Added, #1: 1	مَنْعُ الرَّاهِنِ
u'مَنْعٌ رَائِحٌ':Added, #1: 1	مَنْعِ الرَّاهِنِ
u'مَنْعٌ رَائِحٌ':Added, #1: 1	مَنْعِ الرَّائِحَةِ
u'مَنْعٌ رَائِحَةٌ':Added, #1: 1	مَنْعُ رَائِحَتِهِ
u'مَنْعٌ رَائِحَةٌ':Added, #1: 1	مَنْعِ الرَّائِحَةِ
u'مَنَعَ رَبُّ':Subject, #1: 1	مَنْعُ رَائِحَتِهِ
u'مَنْعٌ رَبُّ':Added, #1: 1	مَنَعَ رَبُّ
u'مَنْعٌ رَجُلٌ':Added, #1: 1	مَنْعِ رَبِّ
u'مَنْعٌ رَجُلٌ':Added, #1: 1	مَنْعِ الرَّجُلِ
u'مَنَعَ رُجُوعٌ':Predicate, #2: 2	مَنْعُ الرَّجُلِ
u'مَنْعٌ رُجُوعٌ':Added, #2: 2	مَنَعَ الرُّجُوعَ
u'مَنْعٌ رُجُوعٌ':Added, #1: 1	مَنْعَ الرُّجُوعِ
u'مَنْعٌ رُجُوعٌ':Added, #2: 2	مَنْعُ الرُّجُوعِ
u'مَنْعٌ رُجُوعٌ':Added, #3: 3	مَنْعِ الرُّجُوعِ
u'مَنْعٌ رحلة':Added, #3: 3	مَنْعِ رُجُوعِ
u'مَنْعٌ رِحْلَةٌ':Added, #1: 1	مَنْعِ الرِّحْلَةِ
u'مَنَعَ رَدٌّ':Predicate, #1: 1	مَنْعِ الرِّحْلَةِ
u'مَنْعٌ رَدٌّ':Added, #1: 1	مَنَعَ الرَّدَّ
u'مَنْعٌ رَدٌّ':Added, #1: 1	مَنْعَ الرَّدِّ
u'مَنْعٌ رَدٌّ':Added, #1: 1	مَنْعِ رَدِّ
u'مَنْعٌ رَدٌّ':Added, #2: 2	مَنْعِ الرَّدِّ
u'مَنْعٌ رِدَّةٌ':Added, #3: 3	مَنْعُ الرَّدِّ
u'مَنَعَ رِزْقٌ':Predicate, #1: 1	مَنْعِ الرِّدَّةِ
u'مَنْعٌ رَسُولٌ':Added, #1: 1	مَنَعَ الرِّزْقَ
u'مَنَعَ رفاد':Predicate, #1: 1	مَنْعِ رَسُولِ
u'مَنْعٌ رِفْدٌ':Added, #1: 1	مَنَعَ الرّفَادَ
u'مَنْعٌ رَفْعٌ':Added, #1: 1	مَنْعِ رِفْدِهِ
u'مَنْعٌ رِقٌّ':Added, #3: 3	مَنْعِ الرَّفْعِ
u'مَنَعَ رُقادٌ':Predicate, #1: 1	مَنْعِ الرِّقِّ
u'مَنْعٌ رَقَبَةٌ':Added, #1: 1	مَنَعَ الرّقَادَ
u'مَنَعَ رَمْيٌ':Predicate, #1: 1	مَنْعِ الرَّقَبَةِ
u'مَنْعٌ رَمْيٌ':Added, #1: 1	مَنَعَ الرَّمْيَ
u'مَنْعٌ رَهْنٌ':Added, #1: 1	مَنْعِ رَمْيِهِ
u'مَنْعٌ رَهْنٌ':Added, #1: 1	مَنْعِ الرَّهْنِ
u'مَنْعٌ رَهْنٌ':Added, #1: 1	مَنْعُ رَهْنِهِ
u'مَنْعٌ رَهْنٌ':Added, #2: 2	مَنْعُ الرَّهْنِ
u'مَنَعَ رِوايَةٌ':Predicate, #2: 2	مَنْعِ رَهْنِهِ
u'مَنَعَ رُؤْيَةٌ':Predicate, #2: 2	مَنَعَ الرِّوَايَةَ
u'مَنْعٌ رُؤْيَةٌ':Added, #2: 2	مَنَعَ رُؤْيَةَ
u'مَنَعَ زَكاةٌ':Predicate, #1: 1	مَنْعُ الرُّؤْيَةِ
u'مَنْعٌ زَكاةٌ':Added, #9: 9	مَنَعَ الزَّكَاةَ
u'مَنْعٌ زَكاةٌ':Added, #1: 1	مَنْعَ الزَّكَاةِ
u'مَنْعٌ زَكاةٌ':Added, #1: 1	مَنْعُ زَكَاةٍ
u'مَنْعٌ زَكاةٌ':Added, #3: 3	مَنْعُ الزَّكَاةِ
u'مَنْعٌ زَوالٌ':Added, #3: 3	مَنْعِ الزَّكَاةِ
u'مَنَعَ زَوْجٌ':Predicate, #1: 1	مَنْعُ الزَّوَالِ
u'مَنْعٌ زَوْجٌ':Added, #1: 1	مَنَعَ الزَّوْجَ
u'مَنْعٌ زَوْجٌ':Added, #3: 3	مَنْعَ الزَّوْجِ
u'مَنْعٌ زَوْجَةٌ':Added, #8: 8	مَنْعُ الزَّوْجِ
u'مَنْعٌ زَوْجَةٌ':Added, #1: 1	مَنْعَ زَوْجَتِهِ
u'مَنْعٌ زَوْجَةٌ':Added, #2: 2	مَنْعُ الزَّوْجَةِ
u'مَنْعٌ زِيادَةٌ':Added, #6: 6	مَنْعُ زَوْجَتِهِ
u'مَنْعٌ زِيادَةٌ':Added, #1: 1	مَنْعَ الزِّيَادَةِ
u'مَنْعٌ سَائِرٌ':Added, #3: 3	مَنْعُ الزِّيَادَةِ
u'مَنْعٌ سائِل':Added, #1: 1	مَنْعِ سَائِرِ
u'مَنْعٌ سَائِلٌ':Added, #1: 1	مَنْعِ السَّائِلِ
u'مَنْعٌ سَبَبٌ':Added, #1: 1	مَنْعِ السَّائِلِ
u'مَنْعٌ سَبُعٌ':Added, #1: 1	مَنْعِ السَّبَبِ
u'مَنْعٌ سَبُعٌ':Added, #1: 1	مَنْعُ السَّبُعِ
u'مَنْعٌ سَفَرٌ':Added, #1: 1	مَنْعِ السَّبُعِ
u'مَنْعٌ سَفَرٌ':Added, #1: 1	مَنْعُ السَّفَرِ
u'مَنْعٌ سَفَرٌ':Added, #1: 1	مَنْعِ سَفَرِ
u'مَنْعٌ سُقُوطٌ':Added, #2: 2	مَنْعِ السَّفَرِ
u'مَنْعٌ سُكُوتٌ':Added, #1: 1	مَنْعُ سُقُوطِهِ
u'مَنْعٌ سُلْطَانٌ':Added, #1: 1	مَنْعِ السُّكُوتِ
u'مَنْعٌ سُلْطَانٌ':Added, #1: 1	مَنْعَ السُّلْطَانِ
u'مَنْعٌ سَلَمٌ':Added, #1: 1	مَنْعِ السُّلْطَانِ
u'مَنْعٌ سَلَمٌ':Added, #1: 1	مَنْعُ السَّلَمِ
u'مَنْعٌ سُلُوكٌ':Added, #1: 1	مَنْعِ السَّلَمِ
u'مَنْعٌ سُلُوك':Added, #1: 1	مَنْعِ السُّلُوكِ
u'مَنْعٌ سَهْمٌ':Added, #1: 1	مَنْعِ السُّلُوكِ
u'مَنْعٌ سَيِّدٌ':Added, #1: 1	مَنْعَ سَهْمِهِ
u'مَنْعٌ سَيِّدٌ':Added, #2: 2	مَنْعُ السَّيِّدِ
u'مَنْعٌ شَابٌّ':Added, #4: 4	مَنْعِ السَّيِّدِ
u'مَنْعٌ شَارِحٌ':Added, #1: 1	مَنْعِ الشَّابَّةِ
u'مَنَعَ شَارِعٌ':Predicate, #1: 1	مَنْعُ الشَّارِحِ
u'مَنَعَ شَارِعٌ':Subject, #1: 1	مَنَعَ الشَّارِعَ
u'مَنْعٌ شَارِعٌ':Added, #1: 1	مَنَعَ الشَّارِعُ
u'مَنَعَ شافِعِيّ':Subject, #1: 1	مَنْعُ الشَّارِعِ
u'مَنَعَ شَاهِدٌ':Predicate, #2: 2	مَنَعَ الشَّافِعِيُّ
u'مَنْعٌ شَاهِدٌ':Added, #1: 1	مَنَعَ الشَّاهِدَ
u'مَنْعٌ شَبَهٌ':Added, #1: 1	مَنْعِ الشَّاهِدِ
u'مَنْعٌ شِرَاءٌ':Added, #1: 1	مَنْعُ الشَّبَهِ
u'مَنْعٌ شِرَاءٌ':Added, #1: 1	مَنْعَ الشِّرَاءِ
u'مَنْعٌ شرب':Added, #1: 1	مَنْعِ الشِّرَاءِ
u'مَنْعٌ شُرْبٌ':Added, #1: 1	مَنْعَ شُرْبِ
u'مَنْعٌ شَرْطٌ':Added, #1: 1	مَنْعَ شُرْبِ
u'مَنْعٌ شَرْطٌ':Added, #1: 1	مَنْعُ الشَّرْطِ
u'مَنْعٌ شَرْطٌ':Added, #1: 1	مَنْعِ الشَّرْطِ
u'مَنَعَ شَرْعٌ':Subject, #2: 2	مَنْعَ الشَّرْطِ
u'مَنْعٌ شَرْعٌ':Added, #3: 3	مَنَعَ الشَّرْعُ
u'مَنْعٌ شَرْعٌ':Added, #1: 1	مَنْعَ الشَّرْعِ
u'مَنْعٌ شركة':Added, #4: 4	مَنْعُ الشَّرْعِ
u'مَنْعٌ شركة':Added, #1: 1	مَنْعُ الشَّرِكَةِ
u'مَنْعٌ شَرِكَةٌ':Added, #1: 1	مَنْعِ الشِّرْكَةِ
u'مَنْعٌ شِرْكَةٌ':Added, #1: 1	مَنْعُ الشَّرِكَةِ
u'مَنْعٌ شُرُوطٌ':Added, #1: 1	مَنْعِ الشِّرْكَةِ
u'مَنْعٌ شَرِيكٌ':Added, #1: 1	مَنْعَ الشُّرُوطِ
u'مَنْعٌ شَرِيكٌ':Added, #1: 1	مَنْعَ شَرِيكِهِ
u'مَنْعٌ شَرِيكٌ':Added, #1: 1	مَنْعُ شَرِيكِهِ
u'مَنْعٌ شعار':Added, #2: 2	مَنْعُ الشَّرِيكِ
u'مَنْعٌ شِعَارٌ':Added, #1: 1	مَنْعَ الشِّعَارِ
u'مَنْعٌ شفعة':Added, #1: 1	مَنْعَ الشِّعَارِ
u'مَنْعٌ شُفْعَةٌ':Added, #1: 1	مَنْعُ الشُّفْعَةِ
u'مَنْعٌ شَهَادَةٌ':Added, #1: 1	مَنْعُ الشُّفْعَةِ
u'مَنْعٌ شَهَادَةٌ':Added, #1: 1	مَنْعِ شَهَادَةِ
u'مَنَعَ صَاحِبٌ':Subject, #1: 1	مَنْعِ شَهَادَتِهِ
u'مَنْعٌ صَاحِبٌ':Added, #2: 2	مَنَعَ صَاحِبُ
u'مَنْعٌ صَاحِبٌ':Added, #1: 1	مَنْعُ صَاحِبِهِ
u'مَنْعٌ صَاحِبٌ':Added, #2: 2	مَنْعُ صَاحِبِ
u'مَنْعٌ صَاحِبٌ':Added, #2: 2	مَنْعِ صَاحِبِ
u'مَنَعَ صَبِيٌّ':Predicate, #3: 3	مَنْعَ صَاحِبِ
u'مَنْعٌ صَبِيٌّ':Added, #1: 1	مَنَعَ الصَّبِيَّ
u'مَنْعٌ صِبْيَانٌ':Added, #1: 1	مَنْعُ الصَّبِيِّ
u'مَنْعٌ صَحَابَةٌ':Added, #1: 1	مَنْعُ الصِّبْيَانِ
u'مَنَعَ صِحَّةٌ':Predicate, #1: 1	مَنْعِ الصَّحَابَةِ
u'مَنَعَ صِحَّةٌ':Predicate, #2: 2	مَنَعَ الصِّحَّةَ
u'مَنْعٌ صِحَّةٌ':Added, #4: 4	مَنَعَ صِحَّةَ
u'مَنْعٌ صِحَّةٌ':Added, #1: 1	مَنْعَ الصِّحَّةِ
u'مَنْعٌ صِحَّةٌ':Added, #2: 2	مَنْعِ الصِّحَّةِ
u'مَنْعٌ صِحَّةٌ':Added, #2: 2	مَنْعُ صِحَّتِهِ
u'مَنْعٌ صِحَّةٌ':Added, #3: 3	مَنْعُ الصِّحَّةِ
u'مَنْعٌ صِحَّةٌ':Added, #3: 3	مَنْعُ صِحَّةِ
u'مَنْعٌ صَرْفٌ':Added, #4: 4	مَنْعِ صِحَّةِ
u'مَنْعٌ صَرْف':Added, #1: 1	مَنْعُ الصَّرْفِ
u'مَنْعٌ صَرْفٌ':Added, #1: 1	مَنْعُ الصَّرْفِ
u'مَنْعٌ صَرْف':Added, #1: 1	مَنْعُ صَرْفِ
u'مَنْعٌ صَرْفٌ':Added, #1: 1	مَنْعُ صَرْفِ
u'مَنْعٌ صَرْفٌ':Added, #1: 1	مَنْع صَرْفِهِ
u'مَنْعٌ صَرْف':Added, #1: 1	مَنْعِ صَرْفِهِ
u'مَنْعٌ صَرْف':Added, #1: 1	مَنْع صَرْفِهِ
u'مَنْعٌ صَرْفٌ':Added, #1: 1	مَنْعِ صَرْفِهِ
u'مَنْعٌ صَرْف':Added, #2: 2	مَنْعِ صَرْفِ
u'مَنْعٌ صَغِيرٌ':Added, #2: 2	مَنْعِ صَرْفِ
u'مَنْعٌ صَغِيرٌ':Added, #1: 1	مَنْعَ الصَّغِيرِ
u'مَنْعٌ صَغِيرٌ':Added, #1: 1	مَنْعُ الصَّغِيرِ
u'مَنَعَ صَلاَةٌ':Predicate, #1: 1	مَنْعَ صَغِيرٍ
u'مَنْعٌ صَلاَةٌ':Added, #5: 5	مَنَعَ الصَّلَاةَ
u'مَنْعٌ صَلاَةٌ':Added, #1: 1	مَنْعَ الصَّلَاةِ
u'مَنْعٌ صَلاَةٌ':Added, #1: 1	مَنْعِ صَلَاةِ
u'مَنْعٌ صَلاَةٌ':Added, #3: 3	مَنْعُ الصَّلَاةِ
u'مَنْعٌ صَلاَحِيَّةٌ':Added, #6: 6	مَنْعِ الصَّلَاةِ
u'مَنْعٌ صِلَةٌ':Added, #1: 1	مَنْعُ صَلَاحِيَّةِ
u'مَنْعٌ صلح':Added, #1: 1	مَنْعُ الصِّلَةِ
u'مَنْعٌ صُلْحٌ':Added, #1: 1	مَنْعُ الصُّلْحِ
u'مَنْعٌ صلح':Added, #1: 1	مَنْعُ الصُّلْحِ
u'مَنْعٌ صُلْحٌ':Added, #2: 2	مَنْعِ الصُّلْحِ
u'مَنَعَ صُوف':Predicate, #2: 2	مَنْعِ الصُّلْحِ
u'مَنْعٌ صَوْمٌ':Added, #1: 1	مَنَعَ صُوفَةَ
u'مَنْعٌ صِيَامٌ':Added, #1: 1	مَنْعِ صَوْمِ
u'مَنْعٌ صِيَامٌ':Added, #1: 1	مَنْعِ صِيَامِهِ
u'مَنْعٌ صَيْدٌ':Added, #2: 2	مَنْعِ صِيَامِ
u'مَنْعٌ ضَرَرٌ':Added, #1: 1	مَنْعُ الصَّيْدِ
u'مَنْعٌ ضَمٌّ':Added, #1: 1	مَنْعِ ضَرَرِ
u'مَنْعٌ ضَمَانٌ':Added, #3: 3	مَنْعِ الضَّمِّ
u'مَنْعٌ ضَوْءٌ':Added, #2: 2	مَنْعِ الضَّمَانِ
u'مَنْعٌ ضَوْءٌ':Added, #1: 1	مَنْعِ ضَوْءٍ
u'مَنْعٌ طَاعَةٌ':Added, #2: 2	مَنْعِ الضَّوْءِ
u'مَنْعٌ طعام':Added, #1: 1	مَنْعِ الطَّاعَةِ
u'مَنْعٌ طَعَامٌ':Added, #2: 2	مَنْعِ طَعَامٍ
u'مَنْعٌ طَلاَقٌ':Added, #2: 2	مَنْعِ طَعَامٍ
u'مَنْعٌ طَلاَقٌ':Added, #1: 1	مَنْعَ الطَّلَاقِ
u'مَنْعٌ طَهَارَةٌ':Added, #3: 3	مَنْعِ الطَّلَاقِ
u'مَنْعٌ طَهَارَةٌ':Added, #1: 1	مَنْعُ الطَّهَارَةِ
u'مَنْعٌ طواف':Added, #1: 1	مَنْعِ الطَّهَارَةِ
u'مَنْعٌ طَوَافٌ':Added, #2: 2	مَنْعَ الطَّوَافِ
u'مَنْعٌ طِينٌ':Added, #2: 2	مَنْعَ الطَّوَافِ
u'مَنْعٌ ظاهِر':Added, #1: 1	مَنْعُ الطِّينِ
u'مَنْعٌ ظاهِرَة':Added, #1: 1	مَنْعَ الظَّاهِرِيَّةِ
u'مَنْعٌ ظاهِرِيّ':Added, #1: 1	مَنْعَ الظَّاهِرِيَّةِ
u'مَنْعٌ ظُلْمٌ':Added, #1: 1	مَنْعَ الظَّاهِرِيَّةِ
u'مَنْعٌ ظلمة':Added, #1: 1	مَنْعُ الظُّلْمِ
u'مَنْعٌ ظُلْمَةٌ':Added, #1: 1	مَنْعَ الظُّلْمَةِ
u'مَنْعٌ ظُهورٌ':Added, #1: 1	مَنْعَ الظُّلْمَةِ
u'مَنْعٌ عَاجِزٌ':Added, #3: 3	مَنْعِ ظُهُورِهِ
u'مَنْعٌ عَالِمٌ':Added, #1: 1	مَنْعُ عَاجِزٍ
u'مَنْعٌ عَامٌّ':Added, #1: 1	مَنْعَ الْعَالِمِ
u'مَنْعٌ عَامٌّ':Added, #1: 1	مَنْعُ الْعَامَّةِ
u'مَنْعٌ عَامِلٌ':Added, #1: 1	مَنْعِ الْعَامَّةِ
u'مَنَعَ عَبْدٌ':Predicate, #1: 1	مَنْعَ الْعَامِلِ
u'مَنْعٌ عَبْدٌ':Added, #1: 1	مَنَعَ الْعَبْدَ
u'مَنْعٌ عَبْدٌ':Added, #1: 1	مَنْعُ عَبْدٍ
u'مَنْعٌ عَبْدٌ':Added, #2: 2	مَنْعُ الْعَبْدِ
u'مَنْعٌ عَدَمٌ':Added, #2: 2	مَنْعُ عَبْدِهِ
u'مَنْعٌ عَدَمٌ':Added, #1: 1	مَنْعِ عَدَمِ
u'مَنْعٌ عَدُوٌّ':Added, #3: 3	مَنْعُ عَدَمِ
u'مَنْعٌ عَدُوٌّ':Added, #1: 1	مَنْعَ الْعَدُوِّ
u'مَنْعٌ عَدُوٌّ':Added, #1: 1	مَنْعُ الْعَدُوِّ
u'مَنَعَ عُرُوضٌ':Predicate, #2: 2	مَنْعِ الْعَدُوِّ
u'مَنْعٌ عطف':Added, #1: 1	مَنَعَ عُرُوضَ
u'مَنْعٌ عَطْفٌ':Added, #1: 1	مَنْعِ الْعَطْفِ
u'مَنْعٌ عَقْدٌ':Added, #1: 1	مَنْعِ الْعَطْفِ
u'مَنْعٌ عَقْدٌ':Added, #1: 1	مَنْعِ الْعَقْدِ
u'مَنْعٌ عَقْدٌ':Added, #1: 1	مَنْعِ عَقْدِهِ
u'مَنْعٌ عَقْلٌ':Added, #2: 2	مَنْعَ الْعَقْدِ
u'مَنَعَ عَكْسٌ':Predicate, #1: 1	مَنْعُ الْعَقْلِ
u'مَنْعٌ عِلَّةٌ':Added, #1: 1	مَنَعَ الْعَكْسَ
u'مَنْعٌ علم':Added, #2: 2	مَنْعُ الْعِلَّةِ
u'مَنْعٌ عِلْمٌ':Added, #1: 1	مَنْعِ الْعِلْمِ
u'مَنَعَ علماء':Subject, #1: 1	مَنْعِ الْعِلْمِ
u'مَنَعَ عُلَمَاءُ':Subject, #1: 1	مَنَعَ الْعُلَمَاءُ
u'مَنَعَ عِلِّيٌّ':Predicate, #1: 1	مَنَعَ الْعُلَمَاءُ
u'مَنْعٌ عِلِّيٌّ':Added, #1: 1	مَنَعَ عِلِّيَّةَ
u'مَنْعٌ عِلِّيٌّ':Added, #1: 1	مَنْعَ الْعِلِّيَّةِ
u'مَنْعٌ عِلِّيٌّ':Added, #1: 1	مَنْعَ عِلِّيَّةِ
u'مَنْعٌ عِلِّيٌّ':Added, #2: 2	مَنْعُ عِلِّيَّةِ
u'مَنْعٌ عِمَامَةٌ':Added, #3: 3	مَنْعِ الْعِلِّيَّةِ
u'مَنَعَ عُمَرٌ':Predicate, #1: 1	مَنْعَ الْعِمَامَةِ
u'مَنَعَ عُمَرٌ':Subject, #1: 1	مَنَعَ عُمَرَ
u'مَنْعٌ عمرة':Added, #1: 1	مَنَعَ عُمَرُ
u'مَنْعٌ عمرة':Added, #1: 1	مَنْعَ الْعُمْرَةِ
u'مَنْعٌ عُمْرَةٌ':Added, #1: 1	مَنْعُ الْعُمْرَةِ
u'مَنْعٌ عُمْرَةٌ':Added, #1: 1	مَنْعَ الْعُمْرَةِ
u'مَنْعٌ عَمَلٌ':Added, #1: 1	مَنْعُ الْعُمْرَةِ
u'مَنْعٌ عُمُومٌ':Added, #5: 5	مَنْعِ الْعَمَلِ
u'مَنْعٌ عُمُومٌ':Added, #1: 1	مَنْعَ عُمُومِ
u'مَنْعٌ عَوْدٌ':Added, #2: 2	مَنْعُ عُمُومِ
u'مَنْعٌ عِوَضٌ':Added, #1: 1	مَنْعِ الْعَوْدِ
u'مَنَعَ عَيْبٌ':Subject, #1: 1	مَنْعُ عِوَضِهِ
u'مَنْعٌ عين':Added, #1: 1	مَنَعَ الْعَيْبُ
u'مَنْعٌ عَيْنٌ':Added, #2: 2	مَنْعِ الْعَيْنِ
u'مَنْعٌ عَيْن':Added, #2: 2	مَنْعِ الْعَيْنِ
u'مَنْعٌ غِذَاءٌ':Added, #2: 2	مَنْعِ الْعَيْنِ
u'مَنْعٌ غِرَاسٌ':Added, #1: 1	مَنْعِ الْغِذَاءِ
u'مَنْعٌ غَسْلٌ':Added, #1: 1	مَنْعَ الْغِرَاسِ
u'مَنْعٌ غُسْلٌ':Added, #1: 1	مَنْعَ غَسْلِ
u'مَنَعَ غير':Predicate, #1: 1	مَنْعَ غُسْلِ
u'مَنَعَ غَيْرٌ':Predicate, #1: 1	مَنَعَ غَيْرَ
u'مَنْعٌ غير':Added, #1: 1	مَنَعَ غَيْرَ
u'مَنْعٌ غير':Added, #1: 1	مَنْعَ غَيْرِ
u'مَنْعٌ غير':Added, #1: 1	مَنْعُ غَيْرِ
u'مَنْعٌ غَيْرٌ':Added, #1: 1	مَنْعِ غَيْرِ
u'مَنْعٌ غَيْرٌ':Added, #1: 1	مَنْعَ غَيْرِ
u'مَنْعٌ غَيْرٌ':Added, #1: 1	مَنْعُ غَيْرِ
u'مَنْعٌ غير':Added, #1: 1	مَنْعِ غَيْرِ
u'مَنْعٌ غَيْرٌ':Added, #3: 3	مَنْعُ غَيْرِهِ
u'مَنْعٌ غير':Added, #3: 3	مَنْعُ غَيْرِهِ
u'مَنْعٌ غَيْرٌ':Added, #4: 4	مَنْعُ الْغَيْرِ
u'مَنْعٌ فَأْسٌ':Added, #4: 4	مَنْعُ الْغَيْرِ
u'مَنْعٌ فَاعِلٌ':Added, #2: 2	مَنْعُ الْفَأْسِ
u'مَنْعٌ فَتْحٌ':Added, #1: 1	مَنْعِ الْفَاعِلَيْنِ
u'مَنْعٌ فَتْحٌ':Added, #1: 1	مَنْعِ الْفَتْحِ
u'مَنْعٌ فَحْلٌ':Added, #4: 4	مَنْعِ فَتْحِ
u'مَنْعٌ فَحْلٌ':Added, #1: 1	مَنْعَ الْفَحْلِ
u'مَنْعٌ فِدَاءٌ':Added, #2: 2	مَنْعُ الْفَحْلِ
u'مَنْعٌ فرق':Added, #1: 1	مَنْعِ الْفِدَاءِ
u'مَنْعٌ فَرْقٌ':Added, #1: 1	مَنْعَ الْفَرْقِ
u'مَنَعَ فساد':Predicate, #1: 1	مَنْعَ الْفَرْقِ
u'مَنَعَ فَسَادٌ':Predicate, #1: 1	مَنَعَ فَسَادَ
u'مَنْعٌ فساد':Added, #1: 1	مَنَعَ فَسَادَ
u'مَنْعٌ فَسَادٌ':Added, #1: 1	مَنْعُ الْفَسَادِ
u'مَنْعٌ فساد':Added, #1: 1	مَنْعُ الْفَسَادِ
u'مَنْعٌ فَسَادٌ':Added, #2: 2	مَنْعُ فَسَادِ
u'مَنْعٌ فَسْخٌ':Added, #2: 2	مَنْعُ فَسَادِ
u'مَنْعٌ فَسْخٌ':Added, #1: 1	مَنْعُ الْفَسْخِ
u'مَنَعَ فَضْلٌ':Predicate, #1: 1	مَنْعِ فَسْخِ
u'مَنْعٌ فَضْلٌ':Added, #11: 11	مَنَعَ فَضْلَ
u'مَنْعٌ فَضْلٌ':Added, #1: 1	مَنْعَ فَضْلِ
u'مَنْعٌ فَضْلٌ':Added, #2: 2	مَنْعُ فَضْلِ
u'مَنْعٌ فِعْلٌ':Added, #3: 3	مَنْعِ فَضْلِ
u'مَنْعٌ فِعْلٌ':Added, #1: 1	مَنْعِ الْفِعْلِ
u'مَنْعٌ فِعْلٌ':Added, #1: 1	مَنْعُ فِعْلِهِ
u'مَنَعَ فقراء':Predicate, #2: 2	مَنْعُ فِعْلِ
u'مَنْعٌ فَكٌّ':Added, #1: 1	مَنَعَ الْفُقَرَاءَ
u'مَنَعَ فلان':Predicate, #1: 1	مَنْعُ فَكِّ
u'مَنَعَ فلان':Subject, #1: 1	مَنَعَ الرَّازِيَّ
u'مَنْعٌ فلان':Added, #2: 2	مَنَعَ الشَّافِعِيُّ
u'مَنْعٌ فلان':Added, #1: 1	مَنْعَ الظَّاهِرِيَّةِ
u'مَنْعٌ فلان':Added, #1: 1	مَنْعِ الْمَكِّيِّ
u'مَنَعَ قَاتِلٌ':Predicate, #1: 1	مَنْعِ الْهَاشِمِيِّ
u'مَنَعَ قَالٌ':Predicate, #1: 1	مَنَعَ الْقَاتِلَ
u'مَنَعَ قَائِلٌ':Predicate, #1: 1	مَنَعَ قَالَ
u'مَنْعٌ قَبْرٌ':Added, #1: 1	مَنَعَ الْقَائِلِينَ
u'مَنَعَ قَبُولٌ':Predicate, #1: 1	مَنْعِ الْقَبْرِ
u'مَنْعٌ قَبُولٌ':Added, #1: 1	مَنَعَ قَبُولَ
u'مَنْعٌ قَبُولٌ':Added, #1: 1	مَنْعَ قَبُولِ
u'مَنْعٌ قَبُولٌ':Added, #1: 1	مَنْعُ قَبُولِ
u'مَنْعٌ قَبُولٌ':Added, #1: 1	مَنْعِ قَبُولِ
u'مَنَعَ قَبِيحٌ':Predicate, #1: 1	مَنْعُ قَبُولِهِ
u'مَنَعَ قتل':Predicate, #1: 1	مَنَعَ الْقَبِيحَ
u'مَنَعَ قَتْلٌ':Predicate, #1: 1	مَنَعَ الْقَتْلَ
u'مَنْعٌ قتل':Added, #1: 1	مَنَعَ الْقَتْلَ
u'مَنْعٌ قتل':Added, #1: 1	مَنْعُ الْقَتْلِ
u'مَنْعٌ قَتْلٌ':Added, #1: 1	مَنْعِ الْقَتْلِ
u'مَنْعٌ قَتْلٌ':Added, #1: 1	مَنْعُ الْقَتْلِ
u'مَنْعٌ قتل':Added, #1: 1	مَنْعِ الْقَتْلِ
u'مَنْعٌ قَتْلٌ':Added, #1: 1	مَنْعِ قَتْلِ
u'مَنْعٌ قُدُومٌ':Added, #1: 1	مَنْعِ قَتْلِ
u'مَنْعٌ قُدُومٌ':Added, #1: 1	مَنْعِ الْقُدُومِ
u'مَنْعٌ قَديدٌ':Added, #2: 2	مَنْعُ الْقُدُومِ
u'مَنْعٌ قراض':Added, #1: 1	مَنْعِ الْقَدِيدِ
u'مَنَعَ قُرْبَانٌ':Predicate, #1: 1	مَنْعُ الْقِرَاضِ
u'مَنْعٌ قُرْبَانٌ':Added, #1: 1	مَنَعَ الْقُرْبَانَ
u'مَنْعٌ قَرْضٌ':Added, #3: 3	مَنْعُ الْقُرْبَانِ
u'مَنَعَ قسمة':Predicate, #1: 1	مَنْعِ قَرْضِ
u'مَنَعَ قِسْمَةٌ':Predicate, #1: 1	مَنَعَ قِسْمَةَ
u'مَنْعٌ قسمة':Added, #1: 1	مَنَعَ قِسْمَةَ
u'مَنْعٌ قِسْمَةٌ':Added, #1: 1	مَنْعِ قِسْمَةِ
u'مَنْعٌ قصاص':Added, #1: 1	مَنْعِ قِسْمَةِ
u'مَنْعٌ قِصَاصٌ':Added, #1: 1	مَنْعِ الْقِصَاصِ
u'مَنْعٌ قَصْرٌ':Added, #1: 1	مَنْعِ الْقِصَاصِ
u'مَنْعٌ قَصْرٌ':Added, #1: 1	مَنْعَ الْقَصْرِ
u'مَنَعَ قَضَاءٌ':Predicate, #1: 1	مَنْعِ قَصْرِ
u'مَنْعٌ قَضَاءٌ':Added, #1: 1	مَنَعَ الْقَضَاءَ
u'مَنْعٌ قَضَاءٌ':Added, #1: 1	مَنْعَ الْقَضَاءِ
u'مَنْعٌ قَضَاءٌ':Added, #1: 1	مَنْعِ قَضَاءِ
u'مَنَعَ قَطْعٌ':Predicate, #2: 2	مَنْعِ الْقَضَاءِ
u'مَنْعٌ قَطْعٌ':Added, #1: 1	مَنَعَ قَطْعَ
u'مَنْعٌ قَلِيلٌ':Added, #1: 1	مَنْعَ الْقَطْعِ
u'مَنْعٌ قول':Added, #2: 2	مَنْعِ الْقَلِيلِ
u'مَنْعٌ قول':Added, #1: 1	مَنْعَ الْقَوْلِ
u'مَنْعٌ قَوْلٌ':Added, #1: 1	مَنْعِ الْقَوْلِ
u'مَنْعٌ قَوْلٌ':Added, #1: 1	مَنْعَ الْقَوْلِ
u'مَنْعٌ قول':Added, #1: 1	مَنْعِ الْقَوْلِ
u'مَنْعٌ قول':Added, #1: 1	مَنْعَ قَوْلِهِ
u'مَنْعٌ قَوْلٌ':Added, #1: 1	مَنْعُ قَوْلِهِ
u'مَنْعٌ قَوْلٌ':Added, #1: 1	مَنْعَ قَوْلِهِ
u'مَنَعَ قَوْمٌ':Subject, #1: 1	مَنْعُ قَوْلِهِ
u'مَنْعٌ قَيْءٌ':Added, #13: 13	مَنَعَ قَوْمٌ
u'مَنَعَ قِيَاسٌ':Predicate, #1: 1	مَنْعِ الْقَيْءِ
u'مَنْعٌ قِيَاسٌ':Added, #2: 2	مَنَعَ الْقِيَاسَ
u'مَنْعٌ قِيَاسٌ':Added, #1: 1	مَنْعُ الْقِيَاسِ
u'مَنْعٌ قِيَاسٌ':Added, #3: 3	مَنْعَ الْقِيَاسِ
u'مَنْعٌ قيام':Added, #3: 3	مَنْعِ الْقِيَاسِ
u'مَنْعٌ قِيَامٌ':Added, #1: 1	مَنْعِ قِيَامِ
u'مَنَعَ كَافِرٌ':Predicate, #1: 1	مَنْعِ قِيَامِ
u'مَنْعٌ كَافِرٌ':Added, #1: 1	مَنَعَ الْكَافِرَ
u'مَنْعٌ كِتَابَةٌ':Added, #1: 1	مَنْعُ كَافِرَةٍ
u'مَنْعٌ كَثْرَةٌ':Added, #1: 1	مَنْعَ الْكِتَابَةِ
u'مَنْعٌ كَثْرَةٌ':Added, #1: 1	مَنْعُ الْكَثْرَةِ
u'مَنْعٌ كَثِيرٌ':Added, #1: 1	مَنْعُ كَثْرَةِ
u'مَنْعٌ كَرَاهَةٌ':Added, #1: 1	مَنْعِ كَثِيرِهِ
u'مَنْعٌ كَرَاهَةٌ':Added, #1: 1	مَنْعَ الْكَرَاهَةِ
u'مَنْعٌ كَفَّارٌ':Added, #1: 1	مَنْعُ كَرَاهَةٍ
u'مَنْعٌ كَفَّارَةٌ':Added, #1: 1	مَنْعِ الْكَفَّارَةِ
u'مَنَعَ كَلاَمٌ':Predicate, #1: 1	مَنْعِ الْكَفَّارَةِ
u'مَنْعٌ كَلاَمٌ':Added, #7: 7	مَنَعَ الْكَلَامَ
u'مَنْعٌ كُلِّيٌّ':Added, #4: 4	مَنْعِ الْكَلَامِ
u'مَنْعٌ كُلِّيَّةٌ':Added, #1: 1	مَنْعُ الْكُلِّيَّةِ
u'مَنَعَ كَوْنٌ':Predicate, #1: 1	مَنْعُ الْكُلِّيَّةِ
u'مَنْعٌ كَوْنٌ':Added, #5: 5	مَنَعَ كَوْنَ
u'مَنْعٌ كَوْنٌ':Added, #18: 18	مَنْعُ كَوْنِ
u'مَنْعٌ كَوْنٌ':Added, #2: 2	مَنْعَ كَوْنِ
u'مَنْعٌ كَوْنٌ':Added, #2: 2	مَنْعَ كَوْنِهِ
u'مَنْعٌ كَوْنٌ':Added, #3: 3	مَنْعِ كَوْنِهِ
u'مَنْعٌ كَوْنٌ':Added, #4: 4	مَنْعِ كَوْنِ
u'مَنْعٌ لبس':Added, #5: 5	مَنْعُ كَوْنِهِ
u'مَنْعٌ لُبْسٌ':Added, #1: 1	مَنْع لُبْسِ
u'مَنْعٌ لبس':Added, #1: 1	مَنْع لُبْسِ
u'مَنْعٌ لُبْسٌ':Added, #2: 2	مَنْعِ لُبْسِهِ
u'مَنْعٌ لُزُومٌ':Added, #2: 2	مَنْعِ لُبْسِهِ
u'مَنْعٌ لُزُومٌ':Added, #1: 1	مَنْعُ اللُّزُومِ
u'مَنْعٌ لُزُومٌ':Added, #2: 2	مَنْعُ لُزُومِ
u'مَنْعٌ لَفْظٌ':Added, #2: 2	مَنْعِ لُزُومِ
u'مَنَعَ لقطة':Predicate, #1: 1	مَنْعَ لَفْظِ
u'مَنْعٌ مَاءٌ':Added, #1: 1	مَنَعَ اللُّقَطَةَ
u'مَنْعٌ مَاءٌ':Added, #1: 1	مَنْعِ الْمَاءِ
u'مَنْعٌ مَالٌ':Added, #1: 1	مَنْعِ مَاءٍ
u'مَنْعٌ مَالٌ':Added, #1: 1	مَنْعِ مَالِهِ
u'مَنْعٌ مَالٌ':Added, #2: 2	مَنْعُ الْمَالِ
u'مَنْعٌ مَالٌ':Added, #3: 3	مَنْعِ الْمَالِ
u'مَنَعَ مَالِكٌ':Predicate, #5: 5	مَنْعَ الْمَالِ
u'مَنَعَ مَالِكٌ':Subject, #2: 2	مَنَعَ الْمَالِكَ
u'مَنْعٌ مَالِكٌ':Added, #9: 9	مَنَعَ مَالِكٌ
u'مَنْعٌ مَالِكٌ':Added, #1: 1	مَنْعُ الْمَالِكِ
u'مَنْعٌ مَالِكٌ':Added, #2: 2	مَنْعِ مَالِكٍ
u'مَنَعَ مَانِعٌ':Subject, #3: 3	مَنْعِ الْمَالِكِ
u'مَنْعٌ مَانِعٌ':Added, #9: 9	مَنَعَ مَانِعٌ
u'مَنْعٌ مانِع':Added, #1: 1	مَنْعِ الْمَانِعِ
u'مَنْعٌ مُبَاشَرَةٌ':Added, #1: 1	مَنْعُ مَانِعِيَّةِ
u'مَنْعٌ مُبْتَدَأٌ':Added, #1: 1	مَنْعِ مُبَاشَرَةِ
u'مَنَعَ مُبْطِلٌ':Predicate, #1: 1	مَنْعِ مُبْتَدَأٍ
u'مَنْعٌ مُتَجَاوِزٌ':Added, #1: 1	مَنَعَ الْمُبْطِلَ
u'مَنْعٌ مُتَّصِلٌ':Added, #1: 1	مَنْعِ الْمُتَجَاوِزِ
u'مَنَعَ مُتَعَلِّقٌ':Subject, #2: 2	مَنْعِ الْمُتَّصِلَةِ
u'مَنَعَ مَجَازٌ':Predicate, #1: 1	مَنَعَ مُتَعَلِّقُهُ
u'مَنْعٌ مُجْتَهِد':Added, #1: 1	مَنَعَ الْمَجَازَ
u'مَنْعٌ مُجْتَهِد':Added, #1: 1	مَنْعِ الْمُجْتَهِدِ
u'مَنْعٌ مَجْمُوعٌ':Added, #2: 2	مَنْعَ الْمُجْتَهِدِ
u'مَنْعٌ مَحْبُوسٌ':Added, #2: 2	مَنْعُ الْمَجْمُوعَةِ
u'مَنْعٌ مَحْبُوسٌ':Added, #1: 1	مَنْعَ الْمَحْبُوسِ
u'مَنْعٌ مَحْبُوسٌ':Added, #1: 1	مَنْعِ الْمَحْبُوسِ
u'مَنْعٌ مُحْتَاجٌ':Added, #2: 2	مَنْعُ الْمَحْبُوسِ
u'مَنْعٌ مُحْرِمٌ':Added, #1: 1	مَنْعُ الْمُحْتَاجِ
u'مَنَعَ مُحَقِّقٌ':Subject, #2: 2	مَنْعِ الْمُحْرِمِ
u'مَنْعٌ مُحَقِّقٌ':Added, #1: 1	مَنَعَ الْمُحَقِّقُ
u'مَنَعَ مُخَابَرَةٌ':Predicate, #1: 1	مَنْعُ الْمُحَقِّقِ
u'مَنْعٌ مُخَالَفَةٌ':Added, #1: 1	مَنَعَ الْمُخَابَرَةَ
u'مَنَعَ مُدَبَّرٌ':Predicate, #1: 1	مَنْعُ مُخَالَفَتِهِ
u'مَنْعٌ مَدْيُونٌ':Added, #1: 1	مَنَعَ الْمُدَبَّرَ
u'مَنْعٌ مُرابَحَة':Added, #1: 1	مَنْعِ الْمَدْيُونِ
u'مَنْعٌ مُرْتَهِنٌ':Added, #1: 1	مَنْعَ الْمُرَابَحَةِ
u'مَنْعٌ مَسٌّ':Added, #1: 1	مَنْعَ الْمُرْتَهِنِ
u'مَنَعَ مَسَاجِدُ':Predicate, #1: 1	مَنْعُ مَسِّ
u'مَنْعٌ مُسَافِرٌ':Added, #3: 3	مَنَعَ مَسَاجِدَ
u'مَنَعَ مَسْأَلَةٌ':Predicate, #2: 2	مَنْعُ مُسَافِرٍ
u'مَنْعٌ مُسَاوَاةٌ':Added, #1: 1	مَنَعَ الْمَسْأَلَةَ
u'مَنْعٌ مُسْتَحَبٌّ':Added, #2: 2	مَنْعِ الْمُسَاوَاةِ
u'مَنْعٌ مُسْتَدام':Added, #2: 2	مَنْعُ الْمُسْتَحَبِّ
u'مَنَعَ مُسْتَوْجِبٌ':Predicate, #1: 1	مَنْعُ مُسْتَدَامٍ
u'مَنَعَ مَسْجِدٌ':Predicate, #1: 1	مَنَعَ الْمُسْتَوْجِبِينَ
u'مَنْعٌ مَسْحٌ':Added, #1: 1	مَنَعَ الْمَسْجِدَ
u'مَنْعٌ مَسْحٌ':Added, #1: 1	مَنْعِ الْمَسْحِ
u'مَنْعٌ مُسْلِمٌ':Added, #2: 2	مَنْعَ الْمَسْحِ
u'مَنْعٌ مِسْمَارٌ':Added, #1: 1	مَنْعَ الْمُسْلِمِ
u'مَنْعٌ مُسْنَدٌ':Added, #1: 1	مَنْعِ مِسْمَارِ
u'مَنَعَ مُشَاهَدٌ':Predicate, #1: 1	مَنْعِ مُسْنَدٍ
u'مَنَعَ مُشَاهَدَةٌ':Predicate, #1: 1	مَنَعَ الْمُشَاهَدَةَ
u'مَنْعٌ مَشَايِخُ':Added, #1: 1	مَنَعَ الْمُشَاهَدَةَ
u'مَنَعَ مُشْتَرِي':Predicate, #1: 1	مَنْعَ الْمَشَايِخِ
u'مَنَعَ مُصَنِّفٌ':Subject, #2: 2	مَنَعَ الْمُشْتَرِيَ
u'مَنْعٌ مُطَالَبٌ':Added, #4: 4	مَنَعَ الْمُصَنِّفُ
u'مَنْعٌ مُطَالَبَةٌ':Added, #1: 1	مَنْعِ الْمُطَالَبَةِ
u'مَنْعٌ مُعَارَضَةٌ':Added, #1: 1	مَنْعِ الْمُطَالَبَةِ
u'مَنْعٌ مُعَامَلَةٌ':Added, #1: 1	مَنْعُ مُعَارَضَةِ
u'مَنَعَ مُعْتَرِضٌ':Subject, #2: 2	مَنْعَ مُعَامَلَتِهِ
u'مَنْعٌ مُعَلِّمٌ':Added, #1: 1	مَنَعَ الْمُعْتَرِضُ
u'مَنْعٌ مُعِير':Added, #1: 1	مَنْعُ الْمُعَلِّمِ
u'مَنَعَ مُقَاصَّةٌ':Predicate, #1: 1	مَنْعُ الْمُعِيرِ
u'مَنَعَ مُقَدِّمٌ':Predicate, #1: 1	مَنَعَ الْمُقَاصَّةَ
u'مَنْعٌ مُقَدِّمٌ':Added, #1: 1	مَنَعَ مُقَدِّمَةً
u'مَنْعٌ مُقَدِّمٌ':Added, #1: 1	مَنْعِ الْمُقَدِّمَةِ
u'مَنْعٌ مُقَدِّمٌ':Added, #1: 1	مَنْعُ مُقَدِّمَةٍ
u'مَنْعٌ مُقَدِّمٌ':Added, #1: 1	مَنْعُ مُقَدِّمَةِ
u'مَنْعٌ مُقَدِّمَةٌ':Added, #2: 2	مَنْعِ مُقَدِّمَةٍ
u'مَنْعٌ مُقَدِّمَةٌ':Added, #1: 1	مَنْعِ الْمُقَدِّمَةِ
u'مَنْعٌ مُقَدِّمَةٌ':Added, #1: 1	مَنْعُ مُقَدِّمَةٍ
u'مَنْعٌ مُقَدِّمَةٌ':Added, #1: 1	مَنْعُ مُقَدِّمَةِ
u'مَنَعَ مُكْتَرِي':Predicate, #2: 2	مَنْعِ مُقَدِّمَةٍ
u'مَنَعَ مَكْفُولٌ':Predicate, #1: 1	مَنَعَ الْمُكْتَرِيَ
u'مَنْعٌ مَكِّيّ':Added, #1: 1	مَنَعَ الْمَكْفُولَ
u'مَنَعَ مُلاَزَمَةٌ':Predicate, #1: 1	مَنْعِ الْمَكِّيِّ
u'مَنْعٌ مُلاَزَمَةٌ':Added, #1: 1	مَنَعَ الْمُلَازَمَةَ
u'مَنَعَ مِلْكٌ':Predicate, #7: 7	مَنْعُ الْمُلَازَمَةِ
u'مَنْعٌ مِلْكٌ':Added, #1: 1	مَنَعَ الْمِلْكَ
u'مَنْعٌ مِلْكٌ':Added, #1: 1	مَنْعَ الْمِلْكِ
u'مَنَعَ مَمْلُوكٌ':Predicate, #1: 1	مَنْعُ مِلْكِ
u'مَنْعٌ مُمَيِّزٌ':Added, #1: 1	مَنَعَ الْمَمْلُوكَ
u'مَنْعٌ مُنَاسَبَةٌ':Added, #1: 1	مَنْعِ الْمُمَيِّزِ
u'مَنْعٌ مُنَاسَبَةٌ':Added, #1: 1	مَنْعَ الْمُنَاسَبَةِ
u'مَنْعٌ مُناقَلَة':Added, #2: 2	مَنْعُ الْمُنَاسَبَةِ
u'مَنْعٌ مَنْعٌ':Added, #1: 1	مَنْعِ الْمُنَاقَلَةِ
u'مَنْعٌ مُنْفَصِلٌ':Added, #1: 1	مَنْعُ مَنْعِهِ
u'مَنْعٌ مَوَانِعُ':Added, #1: 1	مَنْعِ الْمُنْفَصِلَةِ
u'مَنْعٌ مَوْتٌ':Added, #2: 2	مَنْعِ الْمَوَانِعِ
u'مَنْعٌ مُؤَجِّرٌ':Added, #1: 1	مَنْعَ الْمَوْتِ
u'مَنَعَ مُودَعٌ':Subject, #1: 1	مَنْعُ الْمُؤَجِّرِ
u'مَنَعَ مُوسِرٌ':Subject, #1: 1	مَنَعَ الْمُودَعُ
u'مَنْعٌ مُوسِرٌ':Added, #1: 1	مَنَعَ مُوسِرٌ
u'مَنْعٌ مَوْقُوفٌ':Added, #1: 1	مَنْعُ الْمُوسِرِ
u'مَنْعٌ مُوَكِّلٌ':Added, #1: 1	مَنْع الْمَوْقُوفِ
u'مَنْعٌ مُؤْلِمٌ':Added, #2: 2	مَنْعُ الْمُوَكِّلِ
u'مَنَعَ مِيرَاثٌ':Predicate, #1: 1	مَنْعُ الْمُؤْلِمِ
u'مَنَعَ ناذِر':Subject, #1: 1	مَنَعَ الْمِيرَاثَ
u'مَنَعَ نَاسٌ':Predicate, #1: 1	مَنَعَ النَّاذِرُ
u'مَنْعٌ نَاسٌ':Added, #3: 3	مَنَعَ النَّاسَ
u'مَنْعٌ نَاسٌ':Added, #1: 1	مَنْعَ النَّاسِ
u'مَنْعٌ نَاسٌ':Added, #2: 2	مَنْعِ النَّاسِ
u'مَنْعٌ نَاظِرٌ':Added, #5: 5	مَنْعُ النَّاسِ
u'مَنَعَ نَبِيٌّ':Subject, #1: 1	مَنْعِ النَّاظِرِ
u'مَنْعٌ نَبِيٌّ':Added, #3: 3	مَنَعَ النَّبِيُّ
u'مَنَعَ نَحْوٌ':Subject, #1: 1	مَنْعِ النَّبِيِّ
u'مَنْعٌ نَحْوٌ':Added, #1: 1	مَنَعَ نَحْوُ
u'مَنْعٌ نِساءٌ':Added, #1: 1	مَنْعِ نَحْوِ
u'مَنْعٌ نِساءٌ':Added, #3: 3	مَنْعَ النِّسَاءِ
u'مَنْعٌ نِساءٌ':Added, #4: 4	مَنْعُ النِّسَاءِ
u'مَنَعَ نَسَبٌ':Predicate, #4: 4	مَنْعِ النِّسَاءِ
u'مَنْعٌ نِسْبَةٌ':Added, #1: 1	مَنَعَ النَّسَبَ
u'مَنْعٌ نِسْبَةٌ':Added, #1: 1	مَنْعُ نِسْبَةِ
u'مَنْعٌ نَشٌّ':Added, #1: 1	مَنْعُ نِسْبَتِهِ
u'مَنَعَ نَظَرٌ':Predicate, #2: 2	مَنْعِ النَّشِّ
u'مَنْعٌ نَظَرٌ':Added, #2: 2	مَنَعَ النَّظَرَ
u'مَنْعٌ نَظَرٌ':Added, #1: 1	مَنْع النَّظَرِ
u'مَنْعٌ نَظَرٌ':Added, #1: 1	مَنْعَ النَّظَرِ
u'مَنْعٌ نَظْرَةٌ':Added, #2: 2	مَنْعِ النَّظَرِ
u'مَنَعَ نفاذ':Predicate, #1: 1	مَنْعِ نَظْرَةِ
u'مَنَعَ نَفَاذٌ':Predicate, #1: 1	مَنَعَ النَّفَاذَ
u'مَنْعٌ نَفْسٌ':Added, #1: 1	مَنَعَ النَّفَاذَ
u'مَنْعٌ نَفْسٌ':Added, #3: 3	مَنْعُ النَّفْسِ
u'مَنْعٌ نَفْسٌ':Added, #3: 3	مَنْعِ النَّفْسِ
u'مَنْعٌ نَفْسٌ':Added, #7: 7	مَنْعُ نَفْسِهِ
u'مَنْعٌ نَفْعٌ':Added, #9: 9	مَنْعَ نَفْسِهِ
u'مَنَعَ نَفَقَةٌ':Predicate, #1: 1	مَنْعِ نَفْعِ
u'مَنْعٌ نَفَقَةٌ':Added, #1: 1	مَنَعَ النَّفَقَةَ
u'مَنْعٌ نَفَقَةٌ':Added, #1: 1	مَنْعِ النَّفَقَةِ
u'مَنَعَ نَفْيٌ':Predicate, #1: 1	مَنْعُ نَفَقَةِ
u'مَنَعَ نَقْصٌ':Predicate, #1: 1	مَنَعَ نَفْيَ
u'مَنْعٌ نَقْصٌ':Added, #2: 2	مَنَعَ النَّقْصَ
u'مَنْعٌ نَقْضٌ':Added, #1: 1	مَنْعُ النَّقْصِ
u'مَنَعَ نقل':Predicate, #1: 1	مَنْعِ نَقْضِ
u'مَنَعَ نَقْلٌ':Predicate, #1: 1	مَنَعَ النَّقْلَ
u'مَنْعٌ نقل':Added, #1: 1	مَنَعَ النَّقْلَ
u'مَنْعٌ نقل':Added, #1: 1	مَنْعَ النَّقْلِ
u'مَنْعٌ نَقْلٌ':Added, #1: 1	مَنْعِ النَّقْلِ
u'مَنْعٌ نَقْلٌ':Added, #1: 1	مَنْعَ النَّقْلِ
u'مَنْعٌ نقل':Added, #1: 1	مَنْعِ النَّقْلِ
u'مَنْعٌ نَقْلٌ':Added, #3: 3	مَنْعِ نَقْلِ
u'مَنْعٌ نكاح':Added, #3: 3	مَنْعِ نَقْلِ
u'مَنْعٌ نِكَاحٌ':Added, #1: 1	مَنْعَ النِّكَاحِ
u'مَنْعٌ نكاح':Added, #1: 1	مَنْعَ النِّكَاحِ
u'مَنْعٌ نكاح':Added, #1: 1	مَنْعُ نِكَاحِ
u'مَنْعٌ نِكَاحٌ':Added, #1: 1	مَنْعِ نِكَاحِ
u'مَنْعٌ نِكَاحٌ':Added, #1: 1	مَنْعُ نِكَاحِ
u'مَنْعٌ نكاح':Added, #1: 1	مَنْعِ نِكَاحِ
u'مَنْعٌ نِكَاحٌ':Added, #8: 8	مَنْعِ النِّكَاحِ
u'مَنَعَ نَوْمٌ':Predicate, #8: 8	مَنْعِ النِّكَاحِ
u'مَنْعٌ هاشِمِيّ':Added, #2: 2	مَنَعَ النّوْمَ
u'مَنْعٌ هِبَةٌ':Added, #1: 1	مَنْعِ الْهَاشِمِيِّ
u'مَنْعٌ هجر':Added, #1: 1	مَنْعِ الْهِبَةِ
u'مَنْعٌ هَجْرٌ':Added, #1: 1	مَنْعِ الْهَجْرِ
u'مَنْعٌ هَدْمٌ':Added, #1: 1	مَنْعِ الْهَجْرِ
u'مَنَعَ وَاجِبٌ':Predicate, #1: 1	مَنْعِ هَدْمِ
u'مَنْعٌ وَاجِبٌ':Added, #1: 1	مَنَعَ الْوَاجِبَ
u'مَنْعٌ وَاجِبٌ':Added, #1: 1	مَنْعِ الْوَاجِبِ
u'مَنْعٌ وَاجِبٌ':Added, #1: 1	مَنْعُ الْوَاجِبَاتِ
u'مَنَعَ واحد':Subject, #5: 5	مَنْعُ الْوَاجِبِ
u'مَنَعَ وَاحِدٌ':Subject, #1: 1	مَنَعَ وَاحِدٌ
u'مَنْعٌ وَارِثٌ':Added, #1: 1	مَنَعَ وَاحِدٌ
u'مَنْعٌ وَارِثٌ':Added, #1: 1	مَنْعِ الْوَارِثِ
u'مَنْعٌ وَاقِفٌ':Added, #2: 2	مَنْعُ الْوَارِثِ
u'مَنَعَ وُجُوبٌ':Predicate, #2: 2	مَنْعُ الْوَاقِفِ
u'مَنَعَ وُجُوبٌ':Predicate, #2: 2	مَنَعَ الْوُجُوبَ
u'مَنْعٌ وُجُوبٌ':Added, #4: 4	مَنَعَ وُجُوبَ
u'مَنْعٌ وُجُوبٌ':Added, #1: 1	مَنْعَ الْوُجُوبِ
u'مَنْعٌ وُجُوبٌ':Added, #1: 1	مَنْعِ الْوُجُوبِ
u'مَنْعٌ وُجُوبٌ':Added, #1: 1	مَنْعَ وُجُوبِ
u'مَنْعٌ وُجُوبٌ':Added, #2: 2	مَنْعُ الْوُجُوبِ
u'مَنَعَ وُجُودٌ':Subject, #3: 3	مَنْعِ وُجُوبِ
u'مَنْعٌ وُجُودٌ':Added, #2: 2	مَنَعَ وُجُودُهُ
u'مَنْعٌ وُجُودٌ':Added, #3: 3	مَنْعَ وُجُودِ
u'مَنْعٌ وُجُودٌ':Added, #3: 3	مَنْعِ وُجُودِهِ
u'مَنْعٌ وُجُودٌ':Added, #4: 4	مَنْعِ وُجُودِ
u'مَنْعٌ وَدِيعٌ':Added, #8: 8	مَنْعُ وُجُودِ
u'مَنْعٌ وَدِيعَةٌ':Added, #1: 1	مَنْعِ الْوَدِيعَةِ
u'مَنْعٌ وَرَثَةٌ':Added, #1: 1	مَنْعِ الْوَدِيعَةِ
u'مَنْعٌ وُرُودٌ':Added, #1: 1	مَنْعَ وَرَثَتِهِ
u'مَنْعٌ وصال':Added, #1: 1	مَنْعُ وُرُودِهِ
u'مَنْعٌ وِصَالٌ':Added, #1: 1	مَنْعِ الْوِصَالِ
u'مَنَعَ وَصْفٌ':Predicate, #1: 1	مَنْعِ الْوِصَالِ
u'مَنْعٌ وَصْفٌ':Added, #1: 1	مَنَعَ وَصْفَ
u'مَنَعَ وُصُولٌ':Predicate, #1: 1	مَنْعَ الْوَصْفِ
u'مَنَعَ وَصِيٌّ':Predicate, #1: 1	مَنَعَ وُصُولَ
u'مَنْعٌ وَصِيٌّ':Added, #1: 1	مَنَعَ الْوَصِيَّةَ
u'مَنَعَ وَصِيَّةٌ':Predicate, #1: 1	مَنْعُ الْوَصِيِّ
u'مَنَعَ وَضَحٌ':Predicate, #1: 1	مَنَعَ الْوَصِيَّةَ
u'مَنْعٌ وُضُوءٌ':Added, #1: 1	مَنَعَ الْوَضَحَ
u'مَنَعَ وَطْءٌ':Predicate, #1: 1	مَنْعِ الْوُضُوءِ
u'مَنْعٌ وَطْءٌ':Added, #1: 1	مَنَعَ الْوَطْءَ
u'مَنْعٌ وَطْءٌ':Added, #1: 1	مَنْعَ الْوَطْءِ
u'مَنْعٌ وَطْءٌ':Added, #1: 1	مَنْعُ الْوَطْءِ
u'مَنْعٌ وَطْءٌ':Added, #1: 1	مَنْعُ وَطْءِ
u'مَنْعٌ وَطْءٌ':Added, #1: 1	مَنْعِ وَطْءِ
u'مَنَعَ وَفَاءٌ':Predicate, #3: 3	مَنْعِ الْوَطْءِ
u'مَنْعٌ وَقْفٌ':Added, #1: 1	مَنَعَ الْوَفَاءَ
u'مَنْعٌ وُقُوعٌ':Added, #2: 2	مَنْعِ الْوَقْفِ
u'مَنْعٌ وُقُوعٌ':Added, #1: 1	مَنْعِ الْوُقُوعِ
u'مَنْعٌ وُقُوعٌ':Added, #1: 1	مَنْعَ وُقُوعِ
u'مَنْعٌ وُقُوفٌ':Added, #2: 2	مَنْعِ وُقُوعِ
u'مَنْعٌ وَكِيلٌ':Added, #2: 2	مَنْعُ الْوُقُوفِ
u'مَنْعٌ وُلاَةٌ':Added, #3: 3	مَنْعِ الْوَكِيلِ
u'مَنَعَ وِلاَيَةٌ':Predicate, #1: 1	مَنْعِ الْوُلَاةِ
u'مَنَعَ ولد':Predicate, #1: 1	مَنَعَ الْوِلَايَةَ
u'مَنَعَ وَلَدٌ':Predicate, #2: 2	مَنَعَ الْوَلَدَ
u'مَنْعٌ ولد':Added, #2: 2	مَنَعَ الْوَلَدَ
u'مَنْعٌ وَلَدٌ':Added, #1: 1	مَنْعِ الْوَلَدِ
u'مَنْعٌ ولد':Added, #1: 1	مَنْعِ الْوَلَدِ
u'مَنْعٌ ولد':Added, #2: 2	مَنْعَ الْوَلَدِ
u'مَنْعٌ وَلَدٌ':Added, #2: 2	مَنْعُ الْوَلَدِ
u'مَنْعٌ وَلَدٌ':Added, #2: 2	مَنْعَ الْوَلَدِ
u'مَنْعٌ ولد':Added, #2: 2	مَنْعُ الْوَلَدِ
u'مَنْعٌ وَلَدٌ':Added, #2: 2	مَنْعُ وَلَدِ
u'مَنْعٌ ولد':Added, #2: 2	مَنْعُ وَلَدِ
u'مَنْعٌ وَلَدٌ':Added, #8: 8	مَنْعُ وَلَدِهِ
u'مَنَعَ وَلِيٌّ':Predicate, #8: 8	مَنْعُ وَلَدِهِ
u'مَنْعٌ وَلِيٌّ':Added, #1: 1	مَنَعَ الْوَلِيَّ
u'مَنَعَ يَسِيرٌ':Subject, #1: 1	مَنْعِ وَلِيِّ
u'مِنَنٌ أَشْيَاءٌ':Added, #2: 2	مَنَعَ يَسِيرُ
u'مِنَنٌ رِجَالٌ':Added, #1: 1	مِنَنَ الْأَشْيَاءِ
u'مَهَابَةٌ كذب':Added, #2: 2	مِنَنُ الرِّجَالِ
u'مَهَابَةٌ كَذِبٌ':Added, #1: 1	مَهَابَةُ الْكَذِبِ
u'مُهَادَنَةٌ أئِمَّةٌ':Added, #1: 1	مَهَابَةُ الْكَذِبِ
u'مُهَادَنَةٌ بَعْضٌ':Added, #1: 1	مُهَادَنَةِ الأَئِمَّةِ
u'مُهَادَنَةٌ قُرَيْشٌ':Added, #2: 2	مُهَادَنَةُ بَعْضِ
u'مُهَادَنَةٌ كُفَّارٌ':Added, #1: 1	مُهَادَنَةِ قُرَيْشٍ
u'مُهَادَنَةٌ نَبِيٌّ':Added, #2: 2	مُهَادَنَةُ الْكُفَّارِ
u'مَهَانَةٌ نَفْسٌ':Added, #1: 1	مُهَادَنَةِ النَّبِيِّ
u'مَهَّدَ دِينٌ':Predicate, #1: 1	مَهَانَةِ النَّفْسِ
u'مَهَّدَ سَيْل':Subject, #1: 1	مَهَّدَ الدِّينَ
u'مَهْدٌ صَبِيٌّ':Added, #1: 1	مَهَّدَ السَّيْلُ
u'مَهْدٌ عُذْرٌ':Added, #2: 2	مَهْدِ الصَّبِيِّ
u'مَهَّدَ قَوَاعِدُ':Predicate, #1: 1	مَهْدُ الْعُذْرِ
u'مَهْرٌ اِبْنٌ':Added, #1: 1	مَهَّدَ قَوَاعِدَ
u'مَهْرٌ اِبْنٌ':Added, #1: 1	مَهْرَ ابْنِهِ
u'مَهْرٌ اِبْنَة':Added, #1: 1	مَهْرِ ابْنِهِ
u'مَهْرٌ اِبْنَة':Added, #4: 4	مَهْرَ ابْنَتِهِ
u'مَهْرٌ أَزْواجٌ':Added, #8: 8	مَهْرِ ابْنَتِهِ
u'مَهْرٌ الْمَرْأَةُ':Added, #1: 1	مَهْرُ أَزْوَاجِ
u'مَهْرٌ الْمَرْأَةُ':Added, #2: 2	مَهْرَ الْمَرْأَةِ
u'مَهْرٌ الْمَرْأَةُ':Added, #2: 2	مَهْرُ الْمَرْأَةِ
u'مَهْرٌ أُمٌّ':Added, #3: 3	مَهْرِ الْمَرْأَةِ
u'مَهْرٌ أُمٌّ':Added, #1: 1	مَهْرُ أُمِّهِ
u'مَهْرٌ أُمٌّ':Added, #1: 1	مَهْرِ أُمِّهِ
u'مَهْرٌ إمَاءٌ':Added, #2: 2	مَهْرَ أُمِّ
u'مَهْرٌ أمَةٌ':Added, #1: 1	مَهْرَ الْإِمَاءِ
u'مَهْرٌ أمَةٌ':Added, #1: 1	مَهْرَ أَمَةٍ
u'مَهْرٌ أمَةٌ':Added, #1: 1	مَهْرُ أَمَةِ
u'مَهْرٌ أمَةٌ':Added, #2: 2	مَهْرَ الْأَمَةِ
u'مَهْرٌ أمَةٌ':Added, #2: 2	مَهْرِ أَمَةٍ
u'مَهْرٌ أمَةٌ':Added, #3: 3	مَهْرَ أَمَتِهِ
u'مَهْرٌ أمَةٌ':Added, #5: 5	مَهْرِ الْأَمَةِ
u'مَهْرٌ اِمْرَأَةٌ':Added, #6: 6	مَهْرُ الْأَمَةِ
u'مَهْرٌ اِمْرَأَةٌ':Added, #1: 1	مَهْرُ امْرَأَةٍ
u'مَهْرٌ اِمْرَأَةٌ':Added, #2: 2	مَهْرَ امْرَأَةٍ
u'مَهْرٌ اِمْرَأَةٌ':Added, #2: 2	مَهْرَ امْرَأَةِ
u'مَهْرٌ اِمْرَأَةٌ':Added, #3: 3	مَهْرِ امْرَأَةٍ
u'مَهْرٌ اِمْرَأَةٌ':Added, #3: 3	مَهْرَ امْرَأَتِهِ
u'مَهْرٌ اِمْرَأَةٌ':Added, #3: 3	مَهْرُ امْرَأَتِهِ
u'مَهْرٌ أَوَّلُ':Added, #7: 7	مَهْرِ امْرَأَتِهِ
u'مَهْرٌ بَزّاز':Added, #2: 2	مَهْرُ الْأَوَّلِ
u'مَهْرٌ بَزّازَة':Added, #1: 1	مَهْرِ الْبَزَّازِيَّةِ
u'مَهْرٌ بِضْعٌ':Added, #1: 1	مَهْرِ الْبَزَّازِيَّةِ
u'مَهْرٌ بَغِيٌّ':Added, #1: 1	مَهْرَ بِضْعٍ
u'مَهْرٌ بَغِيٌّ':Added, #1: 1	مَهْرُ الْبَغِيِّ
u'مَهْرٌ بَغِيٌّ':Added, #3: 3	مَهْرَ الْبَغِيِّ
u'مَهْرٌ بِكْرٌ':Added, #6: 6	مَهْرِ الْبَغِيِّ
u'مَهْرٌ بِكْرٌ':Added, #1: 1	مَهْرَ الْبِكْرِ
u'مَهْرٌ بِكْرٌ':Added, #1: 1	مَهْرِ الْبِكْرِ
u'مَهْرٌ بِكْرٌ':Added, #2: 2	مَهْرُ الْبِكْرِ
u'مَهْرٌ بِكْرٌ':Added, #2: 2	مَهْرِ بِكْرٍ
u'مَهْرٌ بِكْرٌ':Added, #3: 3	مَهْرَ بِكْرٍ
u'مَهْرٌ بناتٌ':Added, #8: 8	مَهْرُ بِكْرٍ
u'مَهْرٌ بناتٌ':Added, #1: 1	مَهْرِ بَنَاتٍ
u'مَهْرٌ بِنْتٌ':Added, #2: 2	مَهْرِ بَنَاتِهِ
u'مَهْرٌ بِنْتٌ':Added, #1: 1	مَهْرِ الْبِنْتِ
u'مَهْرٌ ثَابِتٌ':Added, #1: 1	مَهْرَ بِنْتِهِ
u'مَهْرٌ ثابتة':Added, #3: 3	مَهْرِ الثَّابِتَةِ
u'مَهْرٌ ثَانِي':Added, #3: 3	مَهْرِ الثَّابِتَةِ
u'مَهْرٌ ثَانِيَةٌ':Added, #1: 1	مَهْرِ الثَّانِيَةِ
u'مَهْرٌ ثَلاثَةٌ':Added, #1: 1	مَهْرِ الثَّانِيَةِ
u'مَهْرٌ ثَيِّبٌ':Added, #1: 1	مَهْرِ الثَّلَاثَةِ
u'مَهْرٌ ثَيِّبٌ':Added, #1: 1	مَهْرَ الثَّيِّبِ
u'مَهْرٌ ثَيِّبٌ':Added, #2: 2	مَهْرِ الثَّيِّبِ
u'مَهْرٌ ثَيِّبٌ':Added, #3: 3	مَهْرُ ثَيِّبٍ
u'مَهْرٌ جَارِي':Added, #4: 4	مَهْرِ ثَيِّبٍ
u'مَهْرٌ جَارِي':Added, #1: 1	مَهْرَ الْجَارِيَةِ
u'مَهْرٌ جَارِي':Added, #1: 1	مَهْرُ جَارِيَتِهِ
u'مَهْرٌ جَارِيَةٌ':Added, #2: 2	مَهْرِ جَارِيَةٍ
u'مَهْرٌ جَارِيَةٌ':Added, #1: 1	مَهْرَ الْجَارِيَةِ
u'مَهْرٌ جَارِيَةٌ':Added, #1: 1	مَهْرُ جَارِيَتِهِ
u'مَهْرٌ حُرٌّ':Added, #2: 2	مَهْرِ جَارِيَةٍ
u'مَهْرٌ حُرٌّ':Added, #1: 1	مَهْرُ حُرَّةٍ
u'مَهْرٌ حُرٌّ':Added, #1: 1	مَهْرِ حُرَّةٍ
u'مَهْرٌ حُرٌّ':Added, #2: 2	مَهْرِ الْحُرَّةِ
u'مَهْرٌ حور':Added, #3: 3	مَهْرَ حُرَّةٍ
u'مَهْرٌ خَارِجٌ':Added, #1: 1	مَهْرُ الْحُورِ
u'مَهْرٌ دَاخِلٌ':Added, #4: 4	مَهْرِ الْخَارِجَةِ
u'مَهْرٌ دَاخِلَةٌ':Added, #6: 6	مَهْرِ الدَّاخِلَةِ
u'مَهْرٌ دَيْنٌ':Added, #6: 6	مَهْرِ الدَّاخِلَةِ
u'مَهْرٌ ذِمِّيٌّ':Added, #1: 1	مَهْرُ دَيْنٍ
u'مَهْرٌ رَقيقٌ':Added, #1: 1	مَهْرِ الذِّمِّيِّ
u'مَهْرٌ رَقيق':Added, #1: 1	مَهْرِ الرَّقِيقِ
u'مَهْرٌ زَوْجَةٌ':Added, #1: 1	مَهْرِ الرَّقِيقِ
u'مَهْرٌ زَوْجَةٌ':Added, #1: 1	مَهْرِ زَوْجَةٍ
u'مَهْرٌ زَوْجَةٌ':Added, #1: 1	مَهْرُ زَوْجَتِهِ
u'مَهْرٌ زَوْجَةٌ':Added, #1: 1	مَهْرِ زَوْجَتِهِ
u'مَهْرٌ سِرٌّ':Added, #2: 2	مَهْرَ زَوْجَتِهِ
u'مَهْرٌ سِرٌّ':Added, #2: 2	مَهْرِ السِّرِّ
u'مَهْرٌ سِرٌّ':Added, #3: 3	مَهْرَ السِّرِّ
u'مَهْرٌ صداق':Added, #6: 6	مَهْرُ السِّرِّ
u'مَهْرٌ صَدَاقٌ':Added, #1: 1	مَهْرِ صَدَاقٍ
u'مَهْرٌ صَغِيرٌ':Added, #1: 1	مَهْرِ صَدَاقٍ
u'مَهْرٌ صَغِيرٌ':Added, #1: 1	مَهْرُ الصَّغِيرَةِ
u'مَهْرٌ صَغِيرٌ':Added, #2: 2	مَهْرَ الصَّغِيرَةِ
u'مَهْرٌ ضَرَّةٌ':Added, #3: 3	مَهْرِ الصَّغِيرَةِ
u'مَهَرَ عَبْدٌ':Predicate, #1: 1	مَهْرَ الضَّرَّةِ
u'مَهْرٌ عَبْدٌ':Added, #1: 1	أَمْهَرَ عَبْدَ
u'مَهْرٌ عَلاَنِيَةٌ':Added, #1: 1	مَهْرُ الْعَبْدِ
u'مَهْرٌ عَلاَنِيَةٌ':Added, #1: 1	مَهْرَ الْعَلَانِيَةِ
u'مَهْرٌ عَيْنٌ':Added, #5: 5	مَهْرُ الْعَلَانِيَةِ
u'مَهْرٌ عَيْن':Added, #1: 1	مَهْرِ عَيْنٍ
u'مَهْرٌ غير':Added, #1: 1	مَهْرِ عَيْنٍ
u'مَهْرٌ غَيْرٌ':Added, #2: 2	مَهْرِ غَيْرِ
u'مَهْرٌ فَاسِدٌ':Added, #2: 2	مَهْرِ غَيْرِ
u'مَهْرٌ فَتْحٌ':Added, #1: 1	مَهْرٍ فَاسِدٍ
u'مَهْرٌ فلان':Added, #1: 1	مَهْرِ فَتْحِ
u'مَهْرٌ كَامِلٌ':Added, #1: 1	مَهْرِ الْبَزَّازِيَّةِ
u'مَهْرٌ كِتاب':Added, #2: 2	مَهْرٍ كَامِلٍ
u'مَهْرٌ كِتابَة':Added, #1: 1	مَهْرِ الْكِتَابِيَّةِ
u'مَهْرٌ كِتابِيّ':Added, #1: 1	مَهْرِ الْكِتَابِيَّةِ
u'مَهْرٌ مُتَّفَقٌ':Added, #1: 1	مَهْرِ الْكِتَابِيَّةِ
u'مَهْرٌ مثل':Added, #1: 1	مَهْرِ الْمُتَّفَقِ
u'مَهْرٌ مِثْلٌ':Added, #13: 13	مَهْرُ مِثْلِ
u'مَهْرٌ مثل':Added, #13: 13	مَهْرُ مِثْلِ
u'مَهْرٌ مِثْلٌ':Added, #16: 16	مَهْرِ مِثْلِ
u'مَهْرٌ مثل':Added, #16: 16	مَهْرِ مِثْلِ
u'مَهْرٌ مِثْلٌ':Added, #171: 171	مَهْرَ الْمِثْلِ
u'مَهْرٌ مثل':Added, #171: 171	مَهْرَ الْمِثْلِ
u'مَهْرٌ مِثْلٌ':Added, #1: 1	مَهْر الْمِثْلِ
u'مَهْرٌ مثل':Added, #1: 1	مَهْر الْمِثْلِ
u'مَهْرٌ مِثْلٌ':Added, #2: 2	مَهْرَ مِثْلِ
u'مَهْرٌ مثل':Added, #2: 2	مَهْرَ مِثْلِ
u'مَهْرٌ مِثْلٌ':Added, #2: 2	مَهْرِ مِثْلِهِ
u'مَهْرٌ مثل':Added, #2: 2	مَهْرِ مِثْلِهِ
u'مَهْرٌ مِثْلٌ':Added, #505: 505	مَهْرِ الْمِثْلِ
u'مَهْرٌ مثل':Added, #505: 505	مَهْرِ الْمِثْلِ
u'مَهْرٌ مِثْلٌ':Added, #545: 545	مَهْرُ الْمِثْلِ
u'مَهْرٌ مِثْلٌ':Added, #545: 545	مَهْرُ الْمِثْلِ
u'مَهْرٌ مِثْلٌ':Added, #5: 5	مَهْرُ مِثْلٍ
u'مَهْرٌ مُجْبَرٌ':Added, #6: 6	مَهْرِ مِثْلٍ
u'مَهْرٌ مَجُوسِيَّةٌ':Added, #1: 1	مَهْرِ الْمُجْبَرَةِ
u'مَهْرٌ مُدَبَّرٌ':Added, #1: 1	مَهْرَ مَجُوسِيَّةٍ
u'مَهْرٌ مُسْتَقِلٌّ':Added, #1: 1	مَهْرُ الْمُدَبَّرَةِ
u'مَهْرٌ مُطاوِع':Added, #1: 1	مَهْرٍ مُسْتَقِلٍّ
u'مَهْرٌ مَعْلُومٌ':Added, #1: 1	مَهْرَ مُطَاوِعَةٍ
u'مَهْرٌ مُعَيَّنٌ':Added, #4: 4	مَهْرٍ مَعْلُومٍ
u'مَهْرٌ مُفَوَّضٌ':Added, #2: 2	مَهْرٍ مُعَيَّنٍ
u'مَهْرٌ مُكَاتَبَةٌ':Added, #1: 1	مَهْرَ الْمُفَوَّضَةِ
u'مَهْرٌ مُكَاتَبَةٌ':Added, #1: 1	مَهْرَ الْمُكَاتَبَةِ
u'مَهْرٌ مَلِكٌ':Added, #1: 1	مَهْرَ مُكَاتَبَتِهِ
u'مَهْرٌ مُؤَجَّلٌ':Added, #1: 1	مَهْرِ الْمَلِكِ
u'مَهْرٌ مَوْقُوفٌ':Added, #1: 1	مَهْرٍ مُؤَجَّلٍ
u'مَهْرٌ مُومِسٌ':Added, #1: 1	مَهْرُ الْمَوْقُوفَةِ
u'مَهْرٌ مُؤْمِنٌ':Added, #1: 1	مَهْرُ الْمُومِسَاتِ
u'مَهْرٌ نكاح':Added, #1: 1	مَهْرِ الْمُؤْمِنَةِ
u'مَهْرٌ نِكَاحٌ':Added, #1: 1	مَهْرِ النِّكَاحِ
u'مَهْرٌ نكاح':Added, #1: 1	مَهْرِ النِّكَاحِ
u'مَهْرٌ نِكَاحٌ':Added, #2: 2	مَهْرُ النِّكَاحِ
u'مَهْرٌ وَاجِبٌ':Added, #2: 2	مَهْرُ النِّكَاحِ
u'مَهْرٌ واحد':Added, #1: 1	مَهْرٍ وَاجِبٍ
u'مَهْرٌ وَاحِدٌ':Added, #2: 2	مَهْرُ وَاحِدٍ
u'مَهْرٌ واحد':Added, #2: 2	مَهْرُ وَاحِدٍ
u'مَهْرٌ وَاحِدٌ':Added, #4: 4	مَهْرٍ وَاحِدٍ
u'مَهْرٌ وَطْءٌ':Added, #4: 4	مَهْرٍ وَاحِدٍ
u'مَهْرٌ وَطْءٌ':Added, #1: 1	مَهْرَ الْوَطْءِ
u'مَهْرٌ يَتِيمٌ':Added, #1: 1	مَهْرُ الْوَطْءِ
u'مَهْرٌ يَتِيمٌ':Added, #1: 1	مَهْرُ الْيَتِيمَةِ
u'مُهْلَةٌ بَحْثٌ':Added, #1: 1	مَهْرِ الْيَتِيمَةِ
u'مُهْلَةٌ ثَلاثَةٌ':Added, #1: 1	مُهْلَةِ الْبَحْثِ
u'مُهْلَةٌ عَمَلٌ':Added, #1: 1	مُهْلَةُ ثَلَاثَةِ
u'مُهْلَةٌ نَظَرٌ':Added, #1: 1	مُهْلَةِ الْعَمَلِ
u'مَهَلَ فُلاَنٌ':Predicate, #7: 7	مُهْلَةِ النَّظَرِ
u'مِهْنَةٌ أهْلٌ':Added, #1: 1	أَمْهَلَ فُلَانَ
u'مَهَنَ قَوْمٌ':Subject, #4: 4	مِهْنَةِ أَهْلِهِ
u'مُهُورٌ أَبْنَاءٌ':Added, #1: 1	مَهَنَ الْقَوْمُ
u'مُهُورٌ أَزْواجٌ':Added, #1: 1	مُهُورَ الْأَبْنَاءِ
u'مُهُورٌ أَزْواجٌ':Added, #1: 1	مُهُورُ أَزْوَاجِ
u'مُهُورٌ سَائِرٌ':Added, #1: 1	مُهُورِ أَزْوَاجِهِ
u'مُهُورٌ نِساءٌ':Added, #1: 1	مُهُورِ سَائِرِ
u'مَوَاتٌ أرْضٌ':Added, #2: 2	مُهُورِ النِّسَاءِ
u'مَوَاتٌ أرْضٌ':Added, #1: 1	مَوَاتَ أَرْضِ
u'مَوَاتٌ أرْضٌ':Added, #1: 1	مَوَاتِ الأَرْضِ
u'مَوَاتٌ أرْضٌ':Added, #2: 2	مَوَاتِ أَرْضِ
u'مَوَاتٌ بصرة':Added, #2: 2	مَوَاتُ الْأَرْضِ
u'مَوَاتٌ بَلَدٌ':Added, #2: 2	مَوَاتِ الْبَصْرَةِ
u'مَوَاتٌ حَرْبٌ':Added, #1: 1	مَوَاتَ بَلَدِهِ
u'مَوَاتٌ حَرَمٌ':Added, #1: 1	مَوَاتِ حَرْبٍ
u'مَوَاتٌ حَرَمٌ':Added, #1: 1	مَوَاتِ الْحَرَمِ
u'مَوَاتٌ حَرِيمٌ':Added, #3: 3	مَوَاتَ الْحَرَمِ
u'مَوَاتٌ نَقِيعٌ':Added, #1: 1	مَوَاتُ الْحَرِيمِ
u'مُوَاجَهَةٌ أرْضٌ':Added, #1: 1	مَوَاتِ النَّقِيعِ
u'مُؤَاخَاةٌ حاطِبٌ':Added, #1: 1	مُوَاجَهَةِ الْأَرْضِ
u'مُؤَاخَاةٌ حاطِبٌ':Added, #1: 1	مُؤَاخَاةَ حَاطِبِ
u'مُؤَاخَاةٌ نَاسٌ':Added, #1: 1	مُؤَاخَاةُ حَاطِبِ
u'مُؤَاخَذَةٌ رَجُلٌ':Added, #1: 1	مُؤَاخَاةِ النَّاسِ
u'مُؤَاخَذَةٌ غير':Added, #1: 1	مُؤَاخَذَةِ الرَّجُلِ
u'مُؤَاخَذَةٌ غَيْرٌ':Added, #1: 1	مُؤَاخَذَةَ غَيْرِ
u'مُوَازَاةٌ شاذَرْوان':Added, #1: 1	مُؤَاخَذَةَ غَيْرِ
u'مُوَازَنَةٌ أَعْمَالٌ':Added, #1: 1	مُوَازَاةِ الشَّاذَرْوَانِ
u'مُوَاسَاةٌ أحَدٌ':Added, #1: 1	مُوَازَنَةِ الْأَعْمَالِ
u'مُوَاسَاةٌ جَائِعٌ':Added, #1: 1	مُوَاسَاةُ أَحَدٍ
u'مُوَاسَاةٌ عِبَادٌ':Added, #1: 1	مُوَاسَاةِ الْجَائِعِ
u'مُوَاسَاةٌ غير':Added, #1: 1	مُوَاسَاةَ عِبَادِ
u'مُوَاسَاةٌ غَيْرٌ':Added, #2: 2	مُوَاسَاةُ غَيْرِهِ
u'مُوَاسَاةٌ قَرَابَةٌ':Added, #2: 2	مُوَاسَاةُ غَيْرِهِ
u'مُوَاسَاةٌ مُسَاعِفٌ':Added, #1: 1	مُوَاسَاةِ قَرَابَةٍ
u'مُوَاسَاةٌ مُضْطَرٌّ':Added, #1: 1	مُوَاسَاةَ الْمُسَاعِفِ
u'مُوَاظَبَةٌ ثَوابٌ':Added, #2: 2	مُوَاسَاةِ الْمُضْطَرِّ
u'مُوَاظَبَةٌ رَسُولٌ':Added, #1: 1	مُوَاظَبَةَ الثَّوَابِ
u'مُوَاظَبَةٌ مَشْيٌ':Added, #1: 1	مُوَاظَبَةَ رَسُولِ
u'مُوَاظَبَةٌ مَشْيٌ':Added, #3: 3	مُوَاظَبَةُ الْمَشْيِ
u'مُوَاظَبَةٌ نَبِيٌّ':Added, #4: 4	مُوَاظَبَةَ الْمَشْيِ
u'مُوَاظَبَةٌ نَبِيٌّ':Added, #1: 1	مُوَاظَبَةِ النَّبِيِّ
u'مُوَافَقَةٌ اِبْنٌ':Added, #2: 2	مُوَاظَبَةُ النَّبِيِّ
u'مُوَافَقَةٌ آثَارٌ':Added, #3: 3	مُوَافَقَةَ ابْنِ
u'مُوَافَقَةٌ أثَرٌ':Added, #1: 1	مُوَافَقَةِ الْآثَارِ
u'مُوَافَقَةٌ اِجْتِهَادٌ':Added, #2: 2	مُوَافَقَةِ الْأَثَرِ
u'مُوَافَقَةٌ أحَدٌ':Added, #1: 1	مُوَافَقَةُ اجْتِهَادِ
u'مُوَافَقَةٌ أحَدٌ':Added, #1: 1	مُوَافَقَةُ أَحَدِ
u'مُوَافَقَةٌ أَحْكَامٌ':Added, #1: 1	مُوَافَقَةِ أَحَدِ
u'مُوَافَقَةٌ أخْبَارٌ':Added, #1: 1	مُوَافَقَةُ الْأَحْكَامِ
u'مُوَافَقَةٌ أَخْبَارٌ':Added, #1: 1	مُوَافَقَةِ الْأَخْبَارِ
u'مُوَافَقَةٌ أخْلاقٌ':Added, #1: 1	مُوَافَقَةِ الْأَخْبَارِ
u'مُوَافَقَةٌ أَخْلاَقٌ':Added, #14: 14	مُوَافَقَةِ الْأَخْلَاقِ
u'مُوَافَقَةٌ إِخْوَانٌ':Added, #14: 14	مُوَافَقَةِ الْأَخْلَاقِ
u'مُوَافَقَةٌ أَصْحَابٌ':Added, #1: 1	مُوَافَقَةُ الْإِخْوَانِ
u'مُوَافَقَةٌ أًصْلٌ':Added, #1: 1	مُوَافَقَةُ الْأَصْحَابِ
u'مُوَافَقَةٌ أصل':Added, #1: 1	مُوَافَقَةِ أَصْلٍ
u'مُوَافَقَةٌ أصل':Added, #1: 1	مُوَافَقَةَ الْأَصْلِ
u'مُوَافَقَةٌ أصل':Added, #1: 1	مُوَافَقَةُ الْأَصْلِ
u'مُوَافَقَةٌ أًصْلٌ':Added, #1: 1	مُوَافَقَةِ الْأَصْلِ
u'مُوَافَقَةٌ أًصْلٌ':Added, #1: 1	مُوَافَقَةَ الْأَصْلِ
u'مُوَافَقَةٌ أًصْلٌ':Added, #1: 1	مُوَافَقَةُ الْأَصْلِ
u'مُوَافَقَةٌ أَكْثَرُ':Added, #1: 1	مُوَافَقَةِ الْأَصْلِ
u'مُوَافَقَةٌ إمَامٌ':Added, #1: 1	مُوَافَقَةِ الْأَكْثَرِ
u'مُوَافَقَةٌ إمَامٌ':Added, #1: 1	مُوَافَقَةِ الْإِمَامِ
u'مُوَافَقَةٌ أَمْرٌ':Added, #3: 3	مُوَافَقَةُ الْإِمَامِ
u'مُوَافَقَةٌ أَمْرٌ':Added, #1: 1	مُوَافَقَةَ أَمْرِ
u'مُوَافَقَةٌ أَمْرٌ':Added, #2: 2	مُوَافَقَةُ أَمْرِ
u'مُوَافَقَةٌ أَمْرٌ':Added, #2: 2	مُوَافَقَةِ أَمْرِ
u'مُوَافَقَةٌ أَمْرٌ':Added, #4: 4	مُوَافَقَةِ الْأَمْرِ
u'مُوَافَقَةٌ أهْلٌ':Added, #9: 9	مُوَافَقَةُ الْأَمْرِ
u'مُوَافَقَةٌ أَوَّلُ':Added, #3: 3	مُوَافَقَةَ أَهْلِ
u'مُوَافَقَةٌ آيَةٌ':Added, #1: 1	مُوَافَقَةُ الْأَوَّلِ
u'مُوَافَقَةٌ بَعْضٌ':Added, #1: 1	مُوَافَقَةِ الْآيَةِ
u'مُوَافَقَةٌ بَعْضٌ':Added, #1: 1	مُوَافَقَةُ بَعْضِ
u'مُوَافَقَةٌ تَعَلُّقٌ':Added, #1: 1	مُوَافَقَةِ بَعْضِ
u'مُوَافَقَةٌ جَمَاعَةٌ':Added, #1: 1	مُوَافَقَةِ تَعَلُّقِ
u'مُوَافَقَةٌ جُمْهُورٌ':Added, #1: 1	مُوَافَقَةَ الْجَمَاعَةِ
u'مُوَافَقَةٌ حُكْمٌ':Added, #1: 1	مُوَافَقَةُ الْجُمْهُورِ
u'مُوَافَقَةٌ حُكْمٌ':Added, #1: 1	مُوَافَقَةَ الْحُكْمِ
u'مُوَافَقَةٌ حُكْمٌ':Added, #1: 1	مُوَافَقَةِ الْحُكْمِ
u'مُوَافَقَةٌ حُكْمٌ':Added, #1: 1	مُوَافَقَةِ حُكْمٍ
u'مُوَافَقَةٌ حَنَفِيَّةٌ':Added, #1: 1	مُوَافَقَةِ حُكْمِهِ
u'مُوَافَقَةٌ خَصْمٌ':Added, #1: 1	مُوَافَقَةَ الْحَنَفِيَّةِ
u'مُوَافَقَةٌ خِلاَفٌ':Added, #1: 1	مُوَافَقَةِ الْخَصْمِ
u'مُوَافَقَةٌ دِينٌ':Added, #1: 1	مُوَافَقَةَ الْخِلَافِ
u'مُوَافَقَةٌ رَاهِنٌ':Added, #1: 1	مُوَافَقَةِ الدِّينِ
u'مُوَافَقَةٌ رَسُولٌ':Added, #1: 1	مُوَافَقَةُ الرَّاهِنِ
u'مُوَافَقَةٌ زَوْجٌ':Added, #1: 1	مُوَافَقَةَ الرَّسُولِ
u'مُوَافَقَةٌ سُنَّةٌ':Added, #2: 2	مُوَافَقَةُ الزَّوْجِ
u'مُوَافَقَةٌ سُنَّةٌ':Added, #1: 1	مُوَافَقَةَ السُّنَّةِ
u'مُوَافَقَةٌ شافِعِيّ':Added, #1: 1	مُوَافَقَةِ السُّنَّةِ
u'مُوَافَقَةٌ شَاهِدٌ':Added, #1: 1	مُوَافَقَةَ الشَّافِعِيِّ
u'مُوَافَقَةٌ شَرْطٌ':Added, #1: 1	مُوَافَقَةِ شَاهِدِ
u'مُوَافَقَةٌ شَرْعٌ':Added, #1: 1	مُوَافَقَةِ شَرْطِهِ
u'مُوَافَقَةٌ شَرِيعَةٌ':Added, #1: 1	مُوَافَقَةِ الشَّرْعِ
u'مُوَافَقَةٌ شَهْرٌ':Added, #1: 1	مُوَافَقَةُ الشَّرِيعَةِ
u'مُوَافَقَةٌ صَاحِبٌ':Added, #1: 1	مُوَافَقَةِ الشَّهْرَيْنِ
u'مُوَافَقَةٌ صَغِيرٌ':Added, #1: 1	مُوَافَقَةِ صَاحِبِهِ
u'مُوَافَقَةٌ طَبْعٌ':Added, #1: 1	مُوَافَقَةِ الصَّغِيرَةِ
u'مُوَافَقَةٌ ظاهِرٌ':Added, #1: 1	مُوَافَقَةِ طَبْعِ
u'مُوَافَقَةٌ عَادَةٌ':Added, #1: 1	مُوَافَقَةُ ظَاهِرِ
u'مُوَافَقَةٌ عَدَدٌ':Added, #1: 1	مُوَافَقَةِ الْعَادَةِ
u'مُوَافَقَةٌ عَدْلٌ':Added, #1: 1	مُوَافَقَةِ عَدَدِ
u'مُوَافَقَةٌ عِلاَجٌ':Added, #1: 1	مُوَافَقَةِ الْعَدْلِ
u'مُوَافَقَةٌ عَمَلٌ':Added, #2: 2	مُوَافَقَةُ الْعِلَاجِ
u'مُوَافَقَةٌ غير':Added, #1: 1	مُوَافَقَةُ الْعَمَلِ
u'مُوَافَقَةٌ غَيْرٌ':Added, #1: 1	مُوَافَقَةُ غَيْرِ
u'مُوَافَقَةٌ غير':Added, #1: 1	مُوَافَقَةُ غَيْرِ
u'مُوَافَقَةٌ غَيْرٌ':Added, #2: 2	مُوَافَقَةِ غَيْرِهِ
u'مُوَافَقَةٌ فِعْلٌ':Added, #2: 2	مُوَافَقَةِ غَيْرِهِ
u'مُوَافَقَةٌ فِعْلٌ':Added, #1: 1	مُوَافَقَةُ الْفِعْلِ
u'مُوَافَقَةٌ فِعْلٌ':Added, #1: 1	مُوَافَقَةِ فِعْلِهِ
u'مُوَافَقَةٌ فِعْلٌ':Added, #2: 2	مُوَافَقَةِ الْفِعْلِ
u'مُوَافَقَةٌ فلان':Added, #2: 2	مُوَافَقَةِ فِعْلِ
u'مُوَافَقَةٌ فلان':Added, #1: 1	مُوَافَقَةَ الزَّمَخْشَرِيِّ
u'مُوَافَقَةٌ قَبُولٌ':Added, #1: 1	مُوَافَقَةَ الشَّافِعِيِّ
u'مُوَافَقَةٌ قَبُولٌ':Added, #1: 1	مُوَافَقَةِ الْقَبُولِ
u'مُوَافَقَةٌ قَدْرٌ':Added, #2: 2	مُوَافَقَةُ الْقَبُولِ
u'مُوَافَقَةٌ قُرْآنٌ':Added, #1: 1	مُوَافَقَةُ قَدْرٍ
u'مُوَافَقَةٌ قَضَاءٌ':Added, #1: 1	مُوَافَقَةِ الْقُرْآنِ
u'مُوَافَقَةٌ قلب':Added, #2: 2	مُوَافَقَةُ الْقَضَاءِ
u'مُوَافَقَةٌ قَلْبٌ':Added, #1: 1	مُوَافَقَةِ الْقَلْبِ
u'مُوَافَقَةٌ قَلْب':Added, #1: 1	مُوَافَقَةِ الْقَلْبِ
u'مُوَافَقَةٌ قلب':Added, #1: 1	مُوَافَقَةِ الْقَلْبِ
u'مُوَافَقَةٌ قَلْبٌ':Added, #1: 1	مُوَافَقَةُ قَلْبِهِ
u'مُوَافَقَةٌ قَلْب':Added, #1: 1	مُوَافَقَةُ قَلْبِهِ
u'مُوَافَقَةٌ قول':Added, #1: 1	مُوَافَقَةُ قَلْبِهِ
u'مُوَافَقَةٌ قَوْلٌ':Added, #1: 1	مُوَافَقَةُ الْقَوْلِ
u'مُوَافَقَةٌ قول':Added, #1: 1	مُوَافَقَةُ الْقَوْلِ
u'مُوَافَقَةٌ قَوْلٌ':Added, #1: 1	مُوَافَقَةِ قَوْلِهِ
u'مُوَافَقَةٌ قِيَاسٌ':Added, #1: 1	مُوَافَقَةِ قَوْلِهِ
u'مُوَافَقَةٌ كُفَّارٌ':Added, #1: 1	مُوَافَقَةِ الْقِيَاسِ
u'مُوَافَقَةٌ كَلاَمٌ':Added, #1: 1	مُوَافَقَةِ الْكُفَّارِ
u'مُوَافَقَةٌ كَلاَمٌ':Added, #1: 1	مُوَافَقَةُ كَلَامِ
u'مُوَافَقَةٌ لِسَانٌ':Added, #4: 4	مُوَافَقَةِ كَلَامِ
u'مُوَافَقَةٌ لَفْظٌ':Added, #1: 1	مُوَافَقَةِ اللِّسَانِ
u'مُوَافَقَةٌ مَالِكٌ':Added, #1: 1	مُوَافَقَةُ لَفْظَيْنِ
u'مُوَافَقَةٌ مُجْتَهِد':Added, #1: 1	مُوَافَقَةَ مَالِكٍ
u'مُوَافَقَةٌ مُحَرَّمٌ':Added, #2: 2	مُوَافَقَةِ الْمُجْتَهِدِ
u'مُوَافَقَةٌ مُحَمَّدٌ':Added, #1: 1	مُوَافَقَةِ الْمُحَرَّمِ
u'مُوَافَقَةٌ مُخَاطَبٌ':Added, #1: 1	مُوَافَقَةِ مُحَمَّدٍ
u'مُوَافَقَةٌ مَذْهَبٌ':Added, #1: 1	مُوَافَقَةِ الْمُخَاطَبِ
u'مُوَافَقَةٌ مَذْهَبٌ':Added, #1: 1	مُوَافَقَةُ مَذْهَبِ
u'مُوَافَقَةٌ مَسْكُوتٌ':Added, #1: 1	مُوَافَقَةِ مَذْهَبِ
u'مُوَافَقَةٌ مَلاَئِكَةٌ':Added, #1: 1	مُوَافَقَةِ الْمَسْكُوتِ
u'مُوَافَقَةٌ نُبُوَّةٌ':Added, #1: 1	مُوَافَقَةِ الْمَلَائِكَةِ
u'مُوَافَقَةٌ نَبِيٌّ':Added, #1: 1	مُوَافَقَةِ النُّبُوَّةِ
u'مُوَافَقَةٌ نُحَاةٌ':Added, #1: 1	مُوَافَقَةُ النَّبِيِّ
u'مُوَافَقَةٌ نَصٌّ':Added, #1: 1	مُوَافَقَةُ النُّحَاةِ
u'مُوَافَقَةٌ نُصُوصٌ':Added, #1: 1	مُوَافَقَةِ النَّصِّ
u'مُوَافَقَةٌ نَفْسٌ':Added, #1: 1	مُوَافَقَةِ نُصُوصِ
u'مُوَافَقَةٌ وَجْهٌ':Added, #1: 1	مُوَافَقَةِ النَّفْسِ
u'مُوَافَقَةٌ وَصْفٌ':Added, #1: 1	مُوَافَقَةِ الْوَجْهِ
u'مُؤَامَرَةٌ سُلْطَانٌ':Added, #1: 1	مُوَافَقَةِ وَصْفِ
u'مَوْتٌ أَبٌ':Added, #3: 3	مُؤَامَرَةِ سُلْطَانٍ
u'مَوْتٌ أَبٌ':Added, #1: 1	مَوْتِ أَبِ
u'مَوْتٌ أَبٌ':Added, #2: 2	مَوْتُ الْأَبِ
u'مَوْتٌ أَبٌ':Added, #3: 3	مَوْتَ الْأَبِ
u'مَوْتٌ اِبْنٌ':Added, #50: 50	مَوْتِ الْأَبِ
u'مَوْتٌ اِبْنٌ':Added, #1: 1	مَوْتَ ابْنِهِ
u'مَوْتٌ اِبْنٌ':Added, #2: 2	مَوْتِ ابْنِ
u'مَوْتٌ اِبْنَة':Added, #2: 2	مَوْتُ ابْنِهِ
u'مَوْتٌ أَجْنَبِيٌّ':Added, #1: 1	مَوْتِ ابْنَتِهِ
u'مَوْتٌ أحَدٌ':Added, #1: 1	مَوْتِ الْأَجْنَبِيِّ
u'مَوْتٌ أحَدٌ':Added, #2: 2	مَوْتُ أَحَدِ
u'مَوْتٌ أَخِيرٌ':Added, #5: 5	مَوْتِ أَحَدِ
u'مَوْتٌ أصل':Added, #1: 1	مَوْتِ الْأَخِيرِ
u'مَوْتٌ أصل':Added, #1: 1	مَوْتَ الْأَصْلِ
u'مَوْتٌ أًصْلٌ':Added, #1: 1	مَوْتُ الْأَصْلِ
u'مَوْتٌ أًصْلٌ':Added, #1: 1	مَوْتَ الْأَصْلِ
u'مَوْتٌ أَقْرَانٌ':Added, #1: 1	مَوْتُ الْأَصْلِ
u'مَوْتٌ أَقْرَانٌ':Added, #1: 1	مَوْتُ أَقْرَانِهِ
u'مَوْتٌ أَقْرَانٌ':Added, #1: 1	مَوْتِ أَقْرَانِهِ
u'مَوْتٌ الْمَرْأَةُ':Added, #2: 2	مَوْتِ الْأَقْرَانِ
u'مَوْتٌ الْمَرْأَةُ':Added, #1: 1	مَوْتُ الْمَرْأَةِ
u'مَوْتٌ أُمٌّ':Added, #2: 2	مَوْتِ الْمَرْأَةِ
u'مَوْتٌ أُمٌّ':Added, #18: 18	مَوْتِ الْأُمِّ
u'مَوْتٌ أُمٌّ':Added, #1: 1	مَوْتُ الْأُمِّ
u'مَوْتٌ أُمٌّ':Added, #1: 1	مَوْتَ أُمّهِ
u'مَوْتٌ أُمٌّ':Added, #3: 3	مَوْتَ الْأُمِّ
u'مَوْتٌ إمَامٌ':Added, #8: 8	مَوْتِ أُمِّهِ
u'مَوْتٌ إمَامٌ':Added, #1: 1	مَوْتُ الْإِمَامِ
u'مَوْتٌ آمِرٌ':Added, #2: 2	مَوْتِ الْإِمَامِ
u'مَوْتٌ اِمْرَأَةٌ':Added, #2: 2	مَوْتِ الْآمِرِ
u'مَوْتٌ أَمينٌ':Added, #1: 1	مَوْتُ امْرَأَةٍ
u'مَوْتٌ إِنْسانٌ':Added, #1: 1	مَوْتِ الْأَمِينِ
u'مَوْتٌ إِنْسانٌ':Added, #1: 1	مَوْتِ الإِنْسَانِ
u'مَوْتٌ إِنْسانٌ':Added, #1: 1	مَوْتَ الْإِنْسَانِ
u'مَوْتٌ إِنْسانٌ':Added, #2: 2	مَوْتِ الْإِنْسَانِ
u'مَوْتٌ أَوَّلُ':Added, #3: 3	مَوْتِ إنْسَانٍ
u'مَوْتٌ أَوْلاَدٌ':Added, #12: 12	مَوْتِ الْأَوَّلِ
u'مَوْتٌ بادِئٌ':Added, #2: 2	مَوْتِ الْأَوْلَادِ
u'مَوْتٌ بَائِعٌ':Added, #1: 1	مَوْتِ الْبَادِئِ
u'مَوْتٌ بَائِعٌ':Added, #2: 2	مَوْتِ بَائِعٍ
u'مَوْتٌ بَطْنٌ':Added, #7: 7	مَوْتِ الْبَائِعِ
u'مَوْتٌ بَعْضٌ':Added, #1: 1	مَوْتِ الْبَطْنِ
u'مَوْتٌ بِنْتٌ':Added, #1: 1	مَوْتِ بَعْضِ
u'مَوْتٌ بِنْتٌ':Added, #1: 1	مَوْتِ الْبِنْتِ
u'مَوْتٌ ثَالِثٌ':Added, #1: 1	مَوْتِ بِنْتِ
u'مَوْتٌ جَاهِلِيٌّ':Added, #1: 1	مَوْتُ الثَّالِثِ
u'مَوْتٌ جَاهِلِيَّةٌ':Added, #1: 1	مَوْتُ جَاهِلِيَّةٍ
u'مَوْتٌ جَرِيحٌ':Added, #1: 1	مَوْتُ جَاهِلِيَّةٍ
u'مَوْتٌ جَمَّالٌ':Added, #2: 2	مَوْتِ الْجَرِيحِ
u'مَوْتٌ حافِرٌ':Added, #1: 1	مَوْتِ الْجَمَّالِ
u'مَوْتٌ حُرٌّ':Added, #2: 2	مَوْتِ الْحَافِرِ
u'مَوْتٌ حُرٌّ':Added, #1: 1	مَوْتُ حُرَّةٍ
u'مَوْتٌ حَيٌّ':Added, #2: 2	مَوْتِ الْحُرِّ
u'مَوْتٌ حَيَوَانٌ':Added, #1: 1	مَوْتُ حَيٍّ
u'مَوْتٌ حَيَوَانٌ':Added, #1: 1	مَوْتَ الْحَيَوَانِ
u'مَوْتٌ حَيَوَانٌ':Added, #1: 1	مَوْتَ حَيَوَانٍ
u'مَوْتٌ خَلِيفَةٌ':Added, #1: 1	مَوْتُ حَيَوَانٍ
u'مَوْتٌ دَابَّةٌ':Added, #2: 2	مَوْتِ الْخَلِيفَةِ
u'مَوْتٌ دَاخِلٌ':Added, #2: 2	مَوْتَ دَابَّةٍ
u'مَوْتٌ دَائِنٌ':Added, #1: 1	مَوْتَ الدَّاخِلِ
u'مَوْتٌ دُودٌ':Added, #2: 2	مَوْتِ الدَّائِنِ
u'مَوْتٌ رَاهِنٌ':Added, #1: 1	مَوْتُ دُودِ
u'مَوْتٌ رَبُّ':Added, #4: 4	مَوْتِ الرَّاهِنِ
u'مَوْتٌ رَبُّ':Added, #1: 1	مَوْتَ رَبِّ
u'مَوْتٌ رَبُّ':Added, #4: 4	مَوْتِ رَبِّ
u'مَوْتٌ رَجُلٌ':Added, #5: 5	مَوْتُ رَبِّ
u'مَوْتٌ رَجُلٌ':Added, #1: 1	مَوْتُ الرَّجُلِ
u'مَوْتٌ رَجُلٌ':Added, #1: 1	مَوْتُ رَجُلٍ
u'مَوْتٌ رَسُولٌ':Added, #2: 2	مَوْتِ الرَّجُلِ
u'مَوْتٌ رَقيقٌ':Added, #1: 1	مَوْت الرّسُولِ
u'مَوْتٌ رَقيق':Added, #1: 1	مَوْتُ رَقِيقِهِ
u'مَوْتٌ زَوْجٌ':Added, #1: 1	مَوْتُ رَقِيقِهِ
u'مَوْتٌ زَوْجٌ':Added, #1: 1	مَوْتُ زَوْجِ
u'مَوْتٌ زَوْجٌ':Added, #1: 1	مَوْتِ زَوْجٍ
u'مَوْتٌ زَوْجٌ':Added, #2: 2	مَوْتَ الزَّوْجِ
u'مَوْتٌ زَوْجٌ':Added, #37: 37	مَوْتِ الزَّوْجِ
u'مَوْتٌ زَوْجَةٌ':Added, #3: 3	مَوْتُ الزَّوْجِ
u'مَوْتٌ زَيْدٌ':Added, #1: 1	مَوْتُ الزَّوْجَاتِ
u'مَوْتٌ زَيْدٌ':Added, #2: 2	مَوْتُ زَيْدٍ
u'مَوْتٌ سَاكِنٌ':Added, #8: 8	مَوْتِ زَيْدٍ
u'مَوْتٌ سُلْطَانٌ':Added, #2: 2	مَوْتِ السَّاكِنِ
u'مَوْتٌ سَيِّدٌ':Added, #1: 1	مَوْتُ السُّلْطَانِ
u'مَوْتٌ سَيِّدٌ':Added, #1: 1	مَوْتِ سَيِّدِ
u'مَوْتٌ سَيِّدٌ':Added, #1: 1	مَوْتَ سَيِّدِهِ
u'مَوْتٌ سَيِّدٌ':Added, #2: 2	مَوْتُ السَّيِّدِ
u'مَوْتٌ سَيِّدٌ':Added, #32: 32	مَوْتِ السَّيِّدِ
u'مَوْتٌ شَاةٌ':Added, #6: 6	مَوْتِ سَيِّدِهِ
u'مَوْتٌ شَاهِدٌ':Added, #1: 1	مَوْتَ الشَّاةِ
u'مَوْتٌ شَاهِدٌ':Added, #2: 2	مَوْتِ الشَّاهِدِ
u'مَوْتٌ شَرِيكٌ':Added, #3: 3	مَوْتَ الشَّاهِدِ
u'مَوْتٌ شُهُودٌ':Added, #1: 1	مَوْتِ شَرِيكِهِ
u'مَوْتٌ شُهُودٌ':Added, #1: 1	مَوْتَ الشُّهُودِ
u'مَوْتٌ شُهُودٌ':Added, #1: 1	مَوْتُ الشُّهُودِ
u'مَوْتٌ صَاحِبٌ':Added, #4: 4	مَوْتِ الشُّهُودِ
u'مَوْتٌ صَاحِبٌ':Added, #2: 2	مَوْتِ صَاحِبِ
u'مَوْتٌ صَاحِبٌ':Added, #2: 2	مَوْتَ صَاحِبِهِ
u'مَوْتٌ صَاحِبٌ':Added, #3: 3	مَوْتُ صَاحِبِ
u'مَوْتٌ صَبِيٌّ':Added, #4: 4	مَوْتِ صَاحِبِهِ
u'مَوْتٌ صَبِيٌّ':Added, #2: 2	مَوْتُ الصَّبِيِّ
u'مَوْتٌ صغار':Added, #2: 2	مَوْتِ الصَّبِيِّ
u'مَوْتٌ صَيْدٌ':Added, #1: 1	مَوْتُ الصِّغَارِ
u'مَوْتٌ ضَامِنٌ':Added, #3: 3	مَوْتُ الصَّيْدِ
u'مَوْتٌ ضَامِنٌ':Added, #1: 1	مَوْتِ الضَّامِنِ
u'مَوْتٌ طَالِبٌ':Added, #1: 1	مَوْتِ ضَامِنِهِ
u'مَوْتٌ طَيْرٌ':Added, #1: 1	مَوْتُ الطَّالِبِ
u'مَوْتٌ عَادِلٌ':Added, #1: 1	مَوْتِ طَيْرِ
u'مَوْتٌ عَاقِدٌ':Added, #1: 1	مَوْتِ الْعَادِلِ
u'مَوْتٌ عَالِمٌ':Added, #2: 2	مَوْتِ الْعَاقِدِ
u'مَوْتٌ عَامِرٌ':Added, #1: 1	مَوْتِ عَالِمٍ
u'مَوْتٌ عَامِلٌ':Added, #2: 2	مَوْتُ عَامِرٍ
u'مَوْتٌ عَامِلٌ':Added, #1: 1	مَوْتُ الْعَامِلِ
u'مَوْتٌ عَبْدٌ':Added, #1: 1	مَوْتِ الْعَامِلِ
u'مَوْتٌ عَبْدٌ':Added, #10: 10	مَوْتِ الْعَبْدِ
u'مَوْتٌ عَبْدٌ':Added, #1: 1	مَوْتَ عَبْدٍ
u'مَوْتٌ عَبْدٌ':Added, #1: 1	مَوْتُ عَبْدِ
u'مَوْتٌ عَبْدٌ':Added, #2: 2	مَوْتَ الْعَبْدِ
u'مَوْتٌ عَبْدٌ':Added, #2: 2	مَوْتُ الْعَبْدِ
u'مَوْتٌ عَتِيقٌ':Added, #2: 2	مَوْتِ عَبْدِ
u'مَوْتٌ عَتِيقٌ':Added, #1: 1	مَوْتِ الْعَتِيقَةِ
u'مَوْتٌ عَتِيقٌ':Added, #2: 2	مَوْتِ عَتِيقِهِ
u'مَوْتٌ علماء':Added, #3: 3	مَوْتِ الْعَتِيقِ
u'مَوْتٌ عُلَمَاءُ':Added, #1: 1	مَوْتَ الْعُلَمَاءِ
u'مَوْتٌ علماء':Added, #1: 1	مَوْتَ الْعُلَمَاءِ
u'مَوْتٌ عُلَمَاءُ':Added, #3: 3	مَوْتُ الْعُلَمَاءِ
u'مَوْتٌ عَلِيٌّ':Added, #3: 3	مَوْتُ الْعُلَمَاءِ
u'مَوْتٌ عَمٌّ':Added, #2: 2	مَوْتِ عَلِيٍّ
u'مَوْتٌ غَرِيبٌ':Added, #1: 1	مَوْتِ الْعَمِّ
u'مَوْتٌ غَرِيمٌ':Added, #4: 4	مَوْتُ الْغَرِيبِ
u'مَوْتٌ غُلاَمٌ':Added, #2: 2	مَوْتُ الْغَرِيمِ
u'مَوْتٌ فَأْرٌ':Added, #1: 1	مَوْتِ الْغُلَامِ
u'مَوْتٌ فَاعِلٌ':Added, #1: 1	مَوْتِ الْفَأْرَةِ
u'مَوْتٌ فُجَاءةٌ':Added, #1: 1	مَوْتِ الْفَاعِلِ
u'مَوْتٌ فَجْأَةٌ':Added, #1: 1	مَوْتِ الْفُجَاءَةِ
u'مَوْتٌ فَجْأَةٌ':Added, #1: 1	مَوْتُ الْفَجْأَةِ
u'مَوْتٌ فَجْأَةٌ':Added, #4: 4	مَوْتَ الْفَجْأَةِ
u'مَوْتٌ فَرَسٌ':Added, #5: 5	مَوْتِ الْفَجْأَةِ
u'مَوْتٌ فَرَسٌ':Added, #1: 1	مَوْتُ الْفَرَسِ
u'مَوْتٌ فلان':Added, #1: 1	مَوْتِ فَرَسِهِ
u'مَوْتٌ فلان':Added, #1: 1	مَوْتِ الْمُتَصَدِّقِ
u'مَوْتٌ فلان':Added, #1: 1	مَوْتُ النَّجَاشِيِّ
u'مَوْتٌ فُلاَنٌ':Added, #1: 1	مَوْتِ النَّجَاشِيِّ
u'مَوْتٌ فُلاَنٌ':Added, #2: 2	مَوْتُ فُلَانٍ
u'مَوْتٌ فُلاَنٌ':Added, #34: 34	مَوْتِ فُلَانٍ
u'مَوْتٌ قَاتِلٌ':Added, #4: 4	مَوْتَ فُلَانٍ
u'مَوْتٌ قَاسِمٌ':Added, #1: 1	مَوْتِ الْقَاتِلِ
u'مَوْتٌ قَائِلٌ':Added, #1: 1	مَوْتِ الْقَاسِمِ
u'مَوْتٌ قَبِيلَةٌ':Added, #1: 1	مَوْتُ الْقَائِلِ
u'مَوْتٌ قَرِيبٌ':Added, #1: 1	مَوْتُ قَبِيلَةٍ
u'مَوْتٌ قَرِيبٌ':Added, #1: 1	مَوْتُ قَرِيبِهِ
u'مَوْتٌ قَرِيبٌ':Added, #1: 1	مَوْتِ قَرِيبِهِ
u'مَوْتٌ قلب':Added, #2: 2	مَوْتِ الْقَرِيبِ
u'مَوْتٌ قَلْبٌ':Added, #2: 2	مَوْتُ الْقَلْبِ
u'مَوْتٌ قَلْب':Added, #2: 2	مَوْتُ الْقَلْبِ
u'مَوْتٌ كَاتِبٌ':Added, #2: 2	مَوْتُ الْقَلْبِ
u'مَوْتٌ كَفِيلٌ':Added, #1: 1	مَوْتِ الْكَاتِبِ
u'مَوْتٌ كَلْبٌ':Added, #3: 3	مَوْتِ الْكَفِيلِ
u'مَوْتٌ لَقِيطٌ':Added, #1: 1	مَوْتُ الْكَلْبِ
u'مَوْتٌ مَالِكٌ':Added, #1: 1	مَوْتِ اللَّقِيطِ
u'مَوْتٌ مَالِكٌ':Added, #1: 1	مَوْتِ الْمَالِكِ
u'مَوْتٌ مَالِكٌ':Added, #1: 1	مَوْتِ مَالِكِهِ
u'مَوْتٌ مُبْرِئٌ':Added, #2: 2	مَوْتُ الْمَالِكِ
u'مَوْتٌ مَبِيعٌ':Added, #1: 1	مَوْتِ الْمُبْرِئِ
u'مَوْتٌ مُتَبَرِّعٌ':Added, #1: 1	مَوْتِ الْمَبِيعِ
u'مَوْتٌ مُتَصَدِّق':Added, #1: 1	مَوْتِ الْمُتَبَرِّعِ
u'مَوْتٌ مُتَعَاقِدٌ':Added, #1: 1	مَوْتِ الْمُتَصَدِّقِ
u'مَوْتٌ مُجَاهِدٌ':Added, #3: 3	مَوْتِ الْمُتَعَاقِدَيْنِ
u'مَوْتٌ مُجْتَهِد':Added, #1: 1	مَوْتِ الْمُجَاهِدِ
u'مَوْتٌ مَجْرُوحٌ':Added, #1: 1	مَوْتُ الْمُجْتَهِدِ
u'مَوْتٌ مَجْنِيٌّ':Added, #6: 6	مَوْتِ الْمَجْرُوحِ
u'مَوْتٌ مَجُوسِيٌّ':Added, #2: 2	مَوْتِ الْمَجْنِيِّ
u'مَوْتٌ مُحِيل':Added, #1: 1	مَوْتِ الْمَجُوسِيِّ
u'مَوْتٌ مُخَالِفٌ':Added, #1: 1	مَوْتِ الْمُحِيلِ
u'مَوْتٌ مُخْتَارٌ':Added, #1: 1	مَوْتِ الْمُخَالِفِ
u'مَوْتٌ مِدْيَانٌ':Added, #1: 1	مَوْتِ الْمُخْتَارَةِ
u'مَوْتٌ مَدِينٌ':Added, #1: 1	مَوْتِ الْمِدْيَانِ
u'مَوْتٌ مُرْتَدٌّ':Added, #2: 2	مَوْتِ الْمَدِينِ
u'مَوْتٌ مُرْتَهِنٌ':Added, #8: 8	مَوْتِ الْمُرْتَدِّ
u'مَوْتٌ مُرْضِعٌ':Added, #2: 2	مَوْتِ الْمُرْتَهِنِ
u'مَوْتٌ مَرِيضٌ':Added, #1: 1	مَوْتُ الْمُرْضِعَةِ
u'مَوْتٌ مُزَارِعٌ':Added, #7: 7	مَوْتِ الْمَرِيضِ
u'مَوْتٌ مُزَارِعٌ':Added, #1: 1	مَوْتُ الْمُزَارِعِ
u'مَوْتٌ مُسْتَأْجِرٌ':Added, #1: 1	مَوْتِ الْمُزَارِعِ
u'مَوْتٌ مُسْتَأْجِرٌ':Added, #1: 1	مَوْتُ الْمُسْتَأْجِرِ
u'مَوْتٌ مُسْتَحِقٌّ':Added, #4: 4	مَوْتِ الْمُسْتَأْجِرِ
u'مَوْتٌ مَشْهُودٌ':Added, #1: 1	مَوْتَ الْمُسْتَحِقِّ
u'مَوْتٌ مُضَارِبٌ':Added, #1: 1	مَوْتِ الْمَشْهُودِ
u'مَوْتٌ مُضَارِبٌ':Added, #1: 1	مَوْتُ الْمُضَارِبِ
u'مَوْتٌ مَطْلُوبٌ':Added, #1: 1	مَوْتِ الْمُضَارِبِ
u'مَوْتٌ مُعْتَقٌ':Added, #4: 4	مَوْتِ الْمَطْلُوبِ
u'مَوْتٌ مُعْسِرٌ':Added, #3: 3	مَوْتِ الْمُعْتَقِ
u'مَوْتٌ مُعَلَّقٌ':Added, #1: 1	مَوْتُ الْمُعْسِرِ
u'مَوْتٌ مُعَلِّقٌ':Added, #1: 1	مَوْتِ الْمُعَلَّقِ
u'مَوْتٌ مُعَمَّرٌ':Added, #1: 1	مَوْتِ الْمُعَلِّقِ
u'مَوْتٌ مَغْصُوب':Added, #1: 1	مَوْتِ الْمُعَمَّرِ
u'مَوْتٌ مَفْقُودٌ':Added, #1: 1	مَوْتِ الْمَغْصُوبِ
u'مَوْتٌ مُفْلِسٌ':Added, #1: 1	مَوْتِ الْمَفْقُودِ
u'مَوْتٌ مَقْتُولٌ':Added, #2: 2	مَوْتِ الْمُفْلِسِ
u'مَوْتٌ مَقْطُوعٌ':Added, #1: 1	مَوْتِ مَقْتُولِهِ
u'مَوْتٌ مُنْكِرٌ':Added, #1: 1	مَوْتِ الْمَقْطُوعِ
u'مَوْتٌ مُوجِبٌ':Added, #1: 1	مَوْتِ الْمُنْكِرِ
u'مَوْتٌ مُؤَجِّرٌ':Added, #1: 1	مَوْتِ الْمُوجِبِ
u'مَوْتٌ مُودِعٌ':Added, #2: 2	مَوْتِ الْمُؤَجِّرِ
u'مَوْتٌ مُوَرِّث':Added, #1: 1	مَوْتِ الْمُودِعِ
u'مَوْتٌ مُوَرِّث':Added, #14: 14	مَوْتِ الْمُوَرِّثِ
u'مَوْتٌ مُوَرِّث':Added, #1: 1	مَوْتَ الْمُوَرِّثِ
u'مَوْتٌ مَوْرُوثٌ':Added, #2: 2	مَوْتُ الْمُوَرِّثِ
u'مَوْتٌ مَوْرُوثٌ':Added, #1: 1	مَوْتَ مَوْرُوثِهِ
u'مَوْتٌ مَوْرُوثٌ':Added, #5: 5	مَوْتِ الْمَوْرُوثِ
u'مَوْتٌ مُوَكِّلٌ':Added, #9: 9	مَوْتِ مَوْرُوثِهِ
u'مَوْتٌ مُوَكِّلٌ':Added, #1: 1	مَوْتَ الْمُوَكِّلِ
u'مَوْتٌ مُوَكِّلٌ':Added, #1: 1	مَوْتُ الْمُوَكِّلِ
u'مَوْتٌ مُوَكِّلٌ':Added, #1: 1	مَوْتُ مُوَكِّلِهِ
u'مَوْتٌ مَوْهُوبٌ':Added, #5: 5	مَوْتِ الْمُوَكِّلِ
u'مَوْتٌ نَازِلٌ':Added, #2: 2	مَوْتِ الْمَوْهُوبِ
u'مَوْتٌ نَبِيٌّ':Added, #1: 1	مَوْتِ النَّازِلِ
u'مَوْتٌ نَجاشِيّ':Added, #6: 6	مَوْتِ النَّبِيِّ
u'مَوْتٌ نَجاشِيّ':Added, #1: 1	مَوْتُ النَّجَاشِيِّ
u'مَوْتٌ هَالِكٌ':Added, #1: 1	مَوْتِ النَّجَاشِيِّ
u'مَوْتٌ هِرٌّ':Added, #1: 1	مَوْتِ هَالِكٍ
u'مَوْتٌ هزال':Added, #1: 1	مَوْتُ الْهِرَّةِ
u'مَوْتٌ هُزَالٌ':Added, #1: 1	مَوْتُ الْهُزَالِ
u'مَوْتٌ واحد':Added, #1: 1	مَوْتُ الْهُزَالِ
u'مَوْتٌ وَاحِدٌ':Added, #2: 2	مَوْتِ وَاحِدٍ
u'مَوْتٌ وَارِثٌ':Added, #2: 2	مَوْتِ وَاحِدٍ
u'مَوْتٌ وَاقِفٌ':Added, #1: 1	مَوْتِ الْوَارِثِ
u'مَوْتٌ وَاقِفٌ':Added, #10: 10	مَوْتِ الْوَاقِفِ
u'مَوْتٌ وَالِدٌ':Added, #1: 1	مَوْتُ الْوَاقِفِ
u'مَوْتٌ وَالِدٌ':Added, #1: 1	مَوْتِ وَالِدِهِ
u'مَوْتٌ وَاهِبٌ':Added, #2: 2	مَوْتُ الْوَالِدِ
u'مَوْتٌ وَاهِبٌ':Added, #2: 2	مَوْتُ الْوَاهِبِ
u'مَوْتٌ وَصِيٌّ':Added, #9: 9	مَوْتِ الْوَاهِبِ
u'مَوْتٌ وَكِيلٌ':Added, #2: 2	مَوْتِ الْوَصِيِّ
u'مَوْتٌ وَكِيلٌ':Added, #1: 1	مَوْتَ الْوَكِيلِ
u'مَوْتٌ وَكِيلٌ':Added, #1: 1	مَوْتِ الْوَكِيلِ
u'مَوْتٌ ولد':Added, #2: 2	مَوْتُ الْوَكِيلِ
u'مَوْتٌ وَلَدٌ':Added, #1: 1	مَوْتَ الْوَلَدِ
u'مَوْتٌ ولد':Added, #1: 1	مَوْتَ الْوَلَدِ
u'مَوْتٌ وَلَدٌ':Added, #1: 1	مَوْتِ وَلَدِ
u'مَوْتٌ ولد':Added, #1: 1	مَوْتِ وَلَدِ
u'مَوْتٌ وَلَدٌ':Added, #1: 1	مَوْتِ وَلَدِهِ
u'مَوْتٌ ولد':Added, #1: 1	مَوْتِ وَلَدِهِ
u'مَوْتٌ وَلَدٌ':Added, #9: 9	مَوْتِ الْوَلَدِ
u'مَوْتٌ وَلِيٌّ':Added, #9: 9	مَوْتِ الْوَلَدِ
u'مَوْتٌ وهبة':Added, #3: 3	مَوْتِ وَلِيِّ
u'مَوَدَّةٌ أحْمَق':Added, #1: 1	مَوْتٍ وَهِبَةٍ
u'مَوَدَّةٌ حَسُودٌ':Added, #1: 1	مَوَدَّةِ الْأَحْمَقِ
u'مَوَدَّةٌ رِجَالٌ':Added, #1: 1	مَوَدَّةَ الْحَسُودِ
u'مَوَدَّةٌ شِرِّيرٌ':Added, #1: 1	مَوَدَّةَ الرِّجَالِ
u'مَوَدَّةٌ صَاحِبٌ':Added, #1: 1	مَوَدَّةَ الشِّرِّيرِ
u'مَوَدَّةٌ غير':Added, #1: 1	مَوَدَّةِ صَاحِبِهِ
u'مَوَدَّةٌ غَيْرٌ':Added, #1: 1	مَوَدَّةُ غَيْرِهِ
u'مَوَدَّةٌ قَرِيبٌ':Added, #1: 1	مَوَدَّةُ غَيْرِهِ
u'مَوَدَّةٌ قَوْمٌ':Added, #1: 1	مَوَدَّةِ قَرِيبِهِ
u'مَوَدَّةٌ مُمْتَنِعٌ':Added, #1: 1	مَوَدَّةَ قَوْمٍ
u'مَوَدَّةٌ نَاسٌ':Added, #1: 1	مَوَدَّةَ مُمْتَنِعٍ
u'مَوْقِعٌ أصل':Added, #1: 1	مَوَدَّةَ النَّاسِ
u'مَوْقِعٌ أًصْلٌ':Added, #1: 1	مَوْقِعَ أَصْلِ
u'مَوْقِعٌ أَمْرٌ':Added, #1: 1	مَوْقِعَ أَصْلِ
u'مَوْقِعٌ بَيَانٌ':Added, #1: 1	مَوْقِعَ الْأَمْرِ
u'مَوْقِعٌ بَيَانٌ':Added, #1: 1	مَوْقِعِ الْبَيَانِ
u'مَوْقِعٌ تَأْكِيدٌ':Added, #4: 4	مَوْقِعَ الْبَيَانِ
u'مَوْقِعٌ تَعْلِيلٌ':Added, #1: 1	مَوْقِعَ التَّأْكِيدِ
u'مَوْقِعٌ ثَلاثُ':Added, #1: 1	مَوْقِعَ التَّعْلِيلِ
u'مَوْقِعٌ جَوَازٌ':Added, #1: 1	مَوْقِعَ الثَّلَاثِ
u'مَوْقِعٌ حَدٌّ':Added, #3: 3	مَوْقِعَ الْجَوَازِ
u'مَوْقِعٌ حَصىً':Added, #1: 1	مَوْقِعَ الْحَدِّ
u'مَوْقِعٌ حَصَياتٌ':Added, #1: 1	مَوْقِعَ حَصَيَاتِهِ
u'مَوْقِعٌ حَصَيَاتٌ':Added, #1: 1	مَوْقِعَ حَصَيَاتِهِ
u'مَوْقِعٌ سُوَيْداء':Added, #1: 1	مَوْقِعَ حَصَيَاتِهِ
u'مَوْقِعٌ صَحِيحٌ':Added, #1: 1	مَوْقِعَ السُّوَيْدَاءِ
u'مَوْقِعٌ صدقة':Added, #2: 2	مَوْقِعَ الصَّحِيحِ
u'مَوْقِعٌ صَدَقَةٌ':Added, #2: 2	مَوْقِعَ الصَّدَقَةِ
u'مَوْقِعٌ عَدَاوَةٌ':Added, #2: 2	مَوْقِعَ الصَّدَقَةِ
u'مَوْقِعٌ عَدَاوَةٌ':Added, #2: 2	مَوْقِعَ الْعَدَاوَةِ
u'مَوْقِعٌ فَرْضٌ':Added, #2: 2	مَوْقِعُ الْعَدَاوَةِ
u'مَوْقِعٌ مُسْتَحَقٌّ':Added, #1: 1	مَوْقِعَ الْفَرْضِ
u'مَوْقِعٌ مُعْرَبٌ':Added, #1: 1	مَوْقِعَ الْمُسْتَحَقِّ
u'مَوْقِعٌ نَبْلٌ':Added, #1: 1	مَوْقِعَ الْمُعْرَبِ
u'مَوْقِعٌ نعمة':Added, #1: 1	مَوْقِعَ نَبْلِهِ
u'مَوْقِعٌ نِعْمَةٌ':Added, #1: 1	مَوْقِعَ نِعْمَةٍ
u'مَوْقِعٌ نَهْيٌ':Added, #1: 1	مَوْقِعَ نِعْمَةٍ
u'مَوْقِعٌ وَاجِبٌ':Added, #1: 1	مَوْقِعَ النَّهْيِ
u'مَوْقِعٌ واحد':Added, #1: 1	مَوْقِعَ الْوَاجِبِ
u'مَوْقِعٌ وَاحِدٌ':Added, #1: 1	مَوْقِعَ الْوَاحِدَةِ
u'مَوْقِعٌ يَقِينٌ':Added, #1: 1	مَوْقِعَ الْوَاحِدَةِ
u'مَوْلِدٌ رَجُلٌ':Added, #1: 1	مَوْقِعَ الْيَقِينِ
u'مَوْلِدٌ رَسُولٌ':Added, #2: 2	مَوْلِدُ الرَّجُلِ
u'مَوْلِدٌ رَسُولٌ':Added, #1: 1	مَوْلِدَ رَسُولِ
u'مَوْلِدٌ رَسُولٌ':Added, #1: 1	مَوْلِدُ رَسُولِ
u'مَوْلِدٌ شافِعِيّ':Added, #2: 2	مَوْلِدِ رَسُولِ
u'مَوْلِدٌ عَبْدٌ':Added, #1: 1	مَوْلِدُ الشَّافِعِيِّ
u'مَوْلِدٌ فلان':Added, #1: 1	مَوْلِدِ عَبْدِ
u'مَوْلِدٌ مُبَارَكٌ':Added, #1: 1	مَوْلِدُ الشَّافِعِيِّ
u'مَوْلِدٌ مُجَاهِدٌ':Added, #1: 1	مَوْلِدُ الْمُبَارَكِ
u'مَوْلِدٌ نَبِيٌّ':Added, #1: 1	مَوْلِدِ مُجَاهِدٍ
u'مَوَّهَ إِناءٌ':Predicate, #2: 2	مَوْلِدِ النَّبِيِّ
u'مَوَّهَ حَديدٌ':Predicate, #1: 1	مَوَّهَ إنَاءَ
u'مَوَّهَ سِكِّينٌ':Predicate, #1: 1	مَوَّهَ الْحَدِيدَ
u'مَيْتٌ آدَمِيٌّ':Added, #1: 1	مَوَّهَ السِّكِّينَ
u'مَيْتٌ آدَمِيٌّ':Added, #2: 2	مَيْتَةَ آدَمِيٍّ
u'مَيْتٌ آدَمِيٌّ':Added, #2: 2	مَيْتَةَ الْآدَمِيِّ
u'مَيْتٌ آدَمِيٌّ':Added, #3: 3	مَيْتَةُ الْآدَمِيِّ
u'مَيْتٌ بَحْرٌ':Added, #3: 3	مَيْتَةِ الْآدَمِيِّ
u'مَيْتٌ بَحْرٌ':Added, #1: 1	مَيْتَةُ الْبَحْرِ
u'مَيْتٌ بَحْرٌ':Added, #2: 2	مَيْتَةَ الْبَحْرِ
u'مَيْتٌ بَحْرِيٌّ':Added, #3: 3	مَيْتَةِ الْبَحْرِ
u'مَيْتٌ بَرِّيٌّ':Added, #1: 1	مَيْتَةُ بَحْرِيٍّ
u'مَيْتَةٌ آدَمِيٌّ':Added, #1: 1	مَيْتَةُ بَرِّيٍّ
u'مَيْتَةٌ آدَمِيٌّ':Added, #2: 2	مَيْتَةَ آدَمِيٍّ
u'مَيْتَةٌ آدَمِيٌّ':Added, #2: 2	مَيْتَةَ الْآدَمِيِّ
u'مَيْتَةٌ آدَمِيٌّ':Added, #3: 3	مَيْتَةُ الْآدَمِيِّ
u'مَيْتَةٌ بَحْرٌ':Added, #3: 3	مَيْتَةِ الْآدَمِيِّ
u'مَيْتَةٌ بَحْرٌ':Added, #1: 1	مَيْتَةُ الْبَحْرِ
u'مَيْتَةٌ بَحْرٌ':Added, #2: 2	مَيْتَةَ الْبَحْرِ
u'مَيْتَةٌ بَحْرِيٌّ':Added, #3: 3	مَيْتَةِ الْبَحْرِ
u'مَيْتَةٌ بَرِّيٌّ':Added, #1: 1	مَيْتَةُ بَحْرِيٍّ
u'مَيْتَةٌ ثَالِثٌ':Added, #1: 1	مَيْتَةُ بَرِّيٍّ
u'مَيْتَةٌ جَرَادٌ':Added, #2: 2	مَيْتَةٍ ثَالِثَةٍ
u'مَيْتَةٌ حَيَوَانٌ':Added, #1: 1	مَيْتَةُ الْجَرَادِ
u'مَيْتَةٌ خِنْزِيرٌ':Added, #1: 1	مَيْتَةِ الْحَيَوَانِ
u'مَيْتَةٌ رَحْبٌ':Added, #1: 1	مَيْتَةَ خِنْزِيرٍ
u'مَيْتَةٌ سَبُعٌ':Added, #1: 1	مَيْتَةٍ رَحْبٍ
u'مَيْتَةٌ سَمَكٌ':Added, #1: 1	مَيْتَةِ السَّبُعِ
u'مَيْتَةٌ سَمَكٌ':Added, #1: 1	مَيْتَةِ السَّمَكِ
u'مَيْتَةٌ سُوءٌ':Added, #1: 1	مَيْتَةُ سَمَكٍ
u'مَيْتَةٌ سُوءٌ':Added, #1: 1	مَيْتَةَ السُّوءِ
u'مَيْتَةٌ صَيْدٌ':Added, #1: 1	مَيْتَةُ السُّوءِ
u'مَيْتَةٌ ضَفَادِعُ':Added, #2: 2	مَيْتَةِ صَيْدِ
u'مَيْتَةٌ غير':Added, #1: 1	مَيْتَةُ الضَّفَادِعِ
u'مَيْتَةٌ غَيْرٌ':Added, #1: 1	مَيْتَةِ غَيْرِ
u'مَيْتَةٌ كَلْبٌ':Added, #1: 1	مَيْتَةِ غَيْرِ
u'مَيْتَةٌ مَاءٌ':Added, #1: 1	مَيْتَةَ كَلْبٍ
u'مَيْتَةٌ مَأْكُولٌ':Added, #1: 1	مَيْتَةِ الْمَاءِ
u'مَيْتَةٌ مَدْبُوغٌ':Added, #1: 1	مَيْتَةِ مَأْكُولٍ
u'مَيْتَةٌ مُسْلِمٌ':Added, #1: 1	مَيْتَةٍ مَدْبُوغٍ
u'مَيْتَةٌ مُسْلِمٌ':Added, #1: 1	مَيْتَةِ الْمُسْلِمِ
u'مَيْتٌ جَرَادٌ':Added, #1: 1	مَيْتَةَ مُسْلِمٍ
u'مَيْتٌ حَيَوَانٌ':Added, #1: 1	مَيْتَةُ الْجَرَادِ
u'مَيْتٌ خِنْزِيرٌ':Added, #1: 1	مَيْتَةِ الْحَيَوَانِ
u'مَيْتٌ سَبُعٌ':Added, #1: 1	مَيْتَةَ خِنْزِيرٍ
u'مَيْتٌ سَمَكٌ':Added, #1: 1	مَيْتَةِ السَّبُعِ
u'مَيْتٌ سَمَكٌ':Added, #1: 1	مَيْتَةِ السَّمَكِ
u'مَيْتٌ سُوءٌ':Added, #1: 1	مَيْتَةُ سَمَكٍ
u'مَيْتٌ سُوءٌ':Added, #1: 1	مَيْتَةَ السُّوءِ
u'مَيْتٌ صَيْدٌ':Added, #1: 1	مَيْتَةُ السُّوءِ
u'مَيْتٌ ضَفَادِعُ':Added, #2: 2	مَيْتَةِ صَيْدِ
u'مَيْتٌ غير':Added, #1: 1	مَيْتَةُ الضَّفَادِعِ
u'مَيْتٌ غَيْرٌ':Added, #1: 1	مَيْتَةِ غَيْرِ
u'مَيْتٌ كَلْبٌ':Added, #1: 1	مَيْتَةِ غَيْرِ
u'مَيْتٌ مَاءٌ':Added, #1: 1	مَيْتَةَ كَلْبٍ
u'مَيْتٌ مَأْكُولٌ':Added, #1: 1	مَيْتَةِ الْمَاءِ
u'مَيْتٌ مُسْلِمٌ':Added, #1: 1	مَيْتَةِ مَأْكُولٍ
u'مَيْتٌ مُسْلِمٌ':Added, #1: 1	مَيْتَةِ الْمُسْلِمِ
u'مَيَّزَ أهْلٌ':Subject, #1: 1	مَيْتَةَ مُسْلِمٍ
u'مَيَّزَ بَيْنٌ':Predicate, #1: 1	مَيَّزَ أَهْلُ
u'مَيَّزَ حِصَّةٌ':Predicate, #2: 2	مَيَّزَ بَيْنَ
u'مَيْزٌ حَقٌّ':Added, #1: 1	مَيَّزَ حِصَّةَ
u'مَيَّزَ رُطَبٌ':Predicate, #1: 1	مَيْزُ حَقٍّ
u'مَيَّزَ مَرْفُوعٌ':Predicate, #1: 1	مَيَّزَ الرُّطَبَ
u'مَيَّزَ مُسْنَدٌ':Predicate, #1: 1	مَيَّزَ الْمَرْفُوعَ
u'ميل اِبْنٌ':Added, #1: 1	مَيَّزَ الْمُسْنَدَ
u'مَيْلٌ اِبْنٌ':Added, #11: 11	مَيْلُ ابْنِ
u'ميل أُسْتَاذٌ':Added, #11: 11	مَيْلُ ابْنِ
u'مَيْلٌ أُسْتَاذٌ':Added, #1: 1	مَيْلُ الْأُسْتَاذِ
u'ميل أصل':Added, #1: 1	مَيْلُ الْأُسْتَاذِ
u'ميل أًصْلٌ':Added, #1: 1	مَيْلُ الْأَصْلِ
u'مَيْلٌ أصل':Added, #1: 1	مَيْلُ الْأَصْلِ
u'مَيْلٌ أًصْلٌ':Added, #1: 1	مَيْلُ الْأَصْلِ
u'ميل أَعْضَاءٌ':Added, #1: 1	مَيْلُ الْأَصْلِ
u'مَيْلٌ أَعْضَاءٌ':Added, #1: 1	مَيْلِ الْأَعْضَاءِ
u'ميل إمَامٌ':Added, #1: 1	مَيْلِ الْأَعْضَاءِ
u'مَيْلٌ إمَامٌ':Added, #5: 5	مَيْلُ إمَامِ
u'ميل أئِمَّةٌ':Added, #5: 5	مَيْلُ إمَامِ
u'مَيْلٌ أئِمَّةٌ':Added, #1: 1	مَيْلِ الْأَئِمَّةِ
u'ميل بَدْرٌ':Added, #1: 1	مَيْلِ الْأَئِمَّةِ
u'مَيْلٌ بَدْرٌ':Added, #1: 1	مَيْلَ بَدْرٍ
u'ميل بَعْضٌ':Added, #1: 1	مَيْلَ بَدْرٍ
u'مَيْلٌ بَعْضٌ':Added, #2: 2	مَيْلُ بَعْضِ
u'ميل جِدار':Added, #2: 2	مَيْلُ بَعْضِ
u'مَيْلٌ جِدار':Added, #1: 1	مَيْلُ الْجِدَارِ
u'ميل حائِطٌ':Added, #1: 1	مَيْلُ الْجِدَارِ
u'مَيْلٌ حائِطٌ':Added, #1: 1	مَيْلِ الْحَائِطِ
u'ميل حَلْوانِيٌّ':Added, #1: 1	مَيْلِ الْحَائِطِ
u'مَيْلٌ حَلْوانِيٌّ':Added, #1: 1	مَيْلُ الْحَلْوَانِيِّ
u'ميل حَنَفِيَّةٌ':Added, #1: 1	مَيْلُ الْحَلْوَانِيِّ
u'مَيْلٌ حَنَفِيَّةٌ':Added, #1: 1	مَيْلُ الْحَنَفِيَّةِ
u'ميل ذَهَبٌ':Added, #1: 1	مَيْلُ الْحَنَفِيَّةِ
u'مَيْلٌ ذَهَبٌ':Added, #1: 1	مَيْلُ الذَّهَبِ
u'ميل رَأْسٌ':Added, #1: 1	مَيْلُ الذَّهَبِ
u'مَيْلٌ رَأْسٌ':Added, #2: 2	مَيْلُ رَأْسِهِ
u'ميل شَارِحٌ':Added, #2: 2	مَيْلُ رَأْسِهِ
u'مَيْلٌ شَارِحٌ':Added, #23: 23	مَيْلُ الشَّارِحِ
u'ميل شَارِحٌ':Added, #23: 23	مَيْلُ الشَّارِحِ
u'مَيْلٌ شَارِحٌ':Added, #2: 2	مَيْلُ شَارِحِ
u'ميل شافِعِيّ':Added, #2: 2	مَيْلُ شَارِحِ
u'مَيْلٌ شافِعِيّ':Added, #4: 4	مَيْلُ الشَّافِعِيِّ
u'ميل شمس':Added, #4: 4	مَيْلُ الشَّافِعِيِّ
u'مَيْلٌ شمس':Added, #1: 1	مَيْلُ الشَّمْسِ
u'ميل شَمْسٌ':Added, #1: 1	مَيْلُ الشَّمْسِ
u'مَيْلٌ شَمْسٌ':Added, #1: 1	مَيْلُ الشَّمْسِ
u'ميل شَيْخٌ':Added, #1: 1	مَيْلُ الشَّمْسِ
u'مَيْلٌ شَيْخٌ':Added, #14: 14	مَيْلُ الشَّيْخِ
u'ميل شَيْخٌ':Added, #14: 14	مَيْلُ الشَّيْخِ
u'مَيْلٌ شَيْخٌ':Added, #1: 1	مَيْلُ الشَّيْخَيْنِ
u'ميل صَاحِبٌ':Added, #1: 1	مَيْلُ الشَّيْخَيْنِ
u'مَيْلٌ صَاحِبٌ':Added, #9: 9	مَيْلُ صَاحِبِ
u'ميل صُوفِيٌّ':Added, #9: 9	مَيْلُ صَاحِبِ
u'مَيْلٌ صُوفِيٌّ':Added, #1: 1	مَيْلُ الصُّوفِيَّةِ
u'ميل صُوفِيَّةٌ':Added, #1: 1	مَيْلُ الصُّوفِيَّةِ
u'مَيْلٌ صُوفِيَّةٌ':Added, #1: 1	مَيْلُ الصُّوفِيَّةِ
u'ميل طِبَاعٌ':Added, #1: 1	مَيْلُ الصُّوفِيَّةِ
u'مَيْلٌ طِبَاعٌ':Added, #1: 1	مَيْلَ الطِّبَاعِ
u'ميل طَبْعٌ':Added, #1: 1	مَيْلَ الطِّبَاعِ
u'مَيْلٌ طَبْعٌ':Added, #1: 1	مَيْلِ طَبْعِ
u'ميل طَبْعٌ':Added, #1: 1	مَيْلِ طَبْعِ
u'مَيْلٌ طَبْعٌ':Added, #1: 1	مَيْلَ طَبْعِهِ
u'ميل طَبْعٌ':Added, #1: 1	مَيْلَ طَبْعِهِ
u'مَيْلٌ طَبْعٌ':Added, #2: 2	مَيْلِ الطَّبْعِ
u'ميل طِلاَءٌ':Added, #2: 2	مَيْلِ الطَّبْعِ
u'مَيْلٌ طِلاَءٌ':Added, #1: 1	مَيْلِ الطِّلَاءِ
u'ميل غير':Added, #1: 1	مَيْلِ الطِّلَاءِ
u'ميل غَيْرٌ':Added, #1: 1	مَيْلُ الْغَيْرِ
u'مَيْلٌ غير':Added, #1: 1	مَيْلُ الْغَيْرِ
u'مَيْلٌ غَيْرٌ':Added, #1: 1	مَيْلُ الْغَيْرِ
u'ميل فلان':Added, #1: 1	مَيْلُ الْغَيْرِ
u'مَيْلٌ فلان':Added, #1: 1	مَيْلُ الْحَارِثِيِّ
u'ميل فلان':Added, #1: 1	مَيْلُ الْحَارِثِيِّ
u'مَيْلٌ فلان':Added, #4: 4	مَيْلُ الشَّافِعِيِّ
u'ميل قلب':Added, #4: 4	مَيْلُ الشَّافِعِيِّ
u'ميل قلب':Added, #1: 1	مَيْلُ الْقَلْبِ
u'مَيْلٌ قلب':Added, #1: 1	مَيْلِ الْقَلْبِ
u'مَيْلٌ قلب':Added, #1: 1	مَيْلُ الْقَلْبِ
u'ميل قَلْبٌ':Added, #1: 1	مَيْلِ الْقَلْبِ
u'ميل قَلْبٌ':Added, #1: 1	مَيْلُ الْقَلْبِ
u'ميل قَلْب':Added, #1: 1	مَيْلِ الْقَلْبِ
u'ميل قَلْب':Added, #1: 1	مَيْلُ الْقَلْبِ
u'مَيْلٌ قَلْبٌ':Added, #1: 1	مَيْلِ الْقَلْبِ
u'مَيْلٌ قَلْبٌ':Added, #1: 1	مَيْلُ الْقَلْبِ
u'مَيْلٌ قَلْب':Added, #1: 1	مَيْلِ الْقَلْبِ
u'مَيْلٌ قَلْب':Added, #1: 1	مَيْلُ الْقَلْبِ
u'ميل قلب':Added, #1: 1	مَيْلِ الْقَلْبِ
u'مَيْلٌ قلب':Added, #1: 1	مَيْلُ قَلْبِهِ
u'ميل قَلْبٌ':Added, #1: 1	مَيْلُ قَلْبِهِ
u'ميل قَلْب':Added, #1: 1	مَيْلُ قَلْبِهِ
u'مَيْلٌ قَلْبٌ':Added, #1: 1	مَيْلُ قَلْبِهِ
u'مَيْلٌ قَلْب':Added, #1: 1	مَيْلُ قَلْبِهِ
u'ميل قلب':Added, #1: 1	مَيْلُ قَلْبِهِ
u'مَيْلٌ قلب':Added, #2: 2	مَيْلِ قَلْبِهِ
u'ميل قَلْبٌ':Added, #2: 2	مَيْلِ قَلْبِهِ
u'ميل قَلْب':Added, #2: 2	مَيْلِ قَلْبِهِ
u'مَيْلٌ قَلْبٌ':Added, #2: 2	مَيْلِ قَلْبِهِ
u'مَيْلٌ قَلْب':Added, #2: 2	مَيْلِ قَلْبِهِ
u'ميل قلب':Added, #2: 2	مَيْلِ قَلْبِهِ
u'مَيْلٌ قلب':Added, #3: 3	مَيْلَ الْقَلْبِ
u'ميل قَلْبٌ':Added, #3: 3	مَيْلَ الْقَلْبِ
u'ميل قَلْب':Added, #3: 3	مَيْلَ الْقَلْبِ
u'مَيْلٌ قَلْبٌ':Added, #3: 3	مَيْلَ الْقَلْبِ
u'مَيْلٌ قَلْب':Added, #3: 3	مَيْلَ الْقَلْبِ
u'ميل قُلُوبٌ':Added, #3: 3	مَيْلَ الْقَلْبِ
u'مَيْلٌ قُلُوبٌ':Added, #1: 1	مَيْلِ الْقُلُوبِ
u'ميل كَلاَمٌ':Added, #1: 1	مَيْلِ الْقُلُوبِ
u'ميل كَلاَمٌ':Added, #2: 2	مَيْلُ كَلَامِ
u'مَيْلٌ كَلاَمٌ':Added, #2: 2	مَيْلِ كَلَامِ
u'مَيْلٌ كَلاَمٌ':Added, #2: 2	مَيْلُ كَلَامِ
u'ميل مَائِلٌ':Added, #2: 2	مَيْلِ كَلَامِ
u'مَيْلٌ مَائِلٌ':Added, #1: 1	مَيْلَ الْمَائِلِ
u'ميل مَجْدٌ':Added, #1: 1	مَيْلَ الْمَائِلِ
u'مَيْلٌ مَجْدٌ':Added, #12: 12	مَيْلُ الْمَجْدِ
u'ميل مَذْمُومٌ':Added, #12: 12	مَيْلُ الْمَجْدِ
u'مَيْلٌ مَذْمُومٌ':Added, #2: 2	مَيْلٍ مَذْمُومٍ
u'ميل مُصَنِّفٌ':Added, #2: 2	مَيْلٍ مَذْمُومٍ
u'مَيْلٌ مُصَنِّفٌ':Added, #36: 36	مَيْلُ الْمُصَنِّفِ
u'ميل مُضِيءٌ':Added, #36: 36	مَيْلُ الْمُصَنِّفِ
u'مَيْلٌ مُضِيءٌ':Added, #1: 1	مَيْلُ الْمُضِيءِ
u'ميل نِساءٌ':Added, #1: 1	مَيْلُ الْمُضِيءِ
u'مَيْلٌ نِساءٌ':Added, #1: 1	مَيْلِ النِّسَاءِ
u'ميل نَفْسٌ':Added, #1: 1	مَيْلِ النِّسَاءِ
u'مَيْلٌ نَفْسٌ':Added, #1: 1	مَيْلَ النَّفْسِ
u'ميل نَفْسٌ':Added, #1: 1	مَيْلَ النَّفْسِ
u'مَيْلٌ نَفْسٌ':Added, #5: 5	مَيْلِ النَّفْسِ
u'ميل نَفْسٌ':Added, #5: 5	مَيْلِ النَّفْسِ
u'مَيْلٌ نَفْسٌ':Added, #6: 6	مَيْلُ النَّفْسِ
u'ميل نُفُوسٌ':Added, #6: 6	مَيْلُ النَّفْسِ
u'مَيْلٌ نُفُوسٌ':Added, #1: 1	مَيْلَ النُّفُوسِ
u'ميل نُفُوسٌ':Added, #1: 1	مَيْلَ النُّفُوسِ
u'مَيْلٌ نُفُوسٌ':Added, #2: 2	مَيْلِ النُّفُوسِ
u'مَيْمَنَةٌ خَيْلٌ':Added, #2: 2	مَيْلِ النُّفُوسِ
u'مَيْمَنَةٌ صَفٌّ':Added, #1: 1	مَيْمَنَةِ الْخَيْلِ
u'مَيْمَنَةٌ قِبْلَةٌ':Added, #3: 3	مَيْمَنَةِ الصَّفِّ
u'مَيْمَنَةٌ وسط':Added, #1: 1	مَيْمَنَةِ الْقِبْلَةِ
u'مَيْمَنَةٌ وَسَطٌ':Added, #1: 1	مَيْمَنَةِ الْوَسَطِ
u'نَاءَ طَالِعٌ':Subject, #1: 1	مَيْمَنَةِ الْوَسَطِ
u'نَابَ إمَامٌ':Predicate, #1: 1	نَاءَ الطَّالِعُ
u'نَابَ إمَامٌ':Subject, #1: 1	نَابَ الْإِمَامَ
u'نَابَ أَمْرٌ':Subject, #1: 1	نَابَ الْإِمَامُ
u'نَابَ بَيْتٌ':Predicate, #2: 2	نَابَ أَمْرٌ
u'نَابَ غَائِبٌ':Subject, #1: 1	نَابَ الْبَيْتَ
u'نَابَ مَضْمُونٌ':Subject, #1: 1	أَنَابَ الْغَائِبُ
u'نَابَ مُوجِبٌ':Subject, #3: 3	نَابَ الْمَضْمُونُ
u'نَابَ نَاظِرٌ':Subject, #1: 1	نَابَ مُوجِبُ
u'نَابَ نَائِبٌ':Subject, #1: 1	أَنَابَ النَّاظِرُ
u'نَابَ وَجْبَةٌ':Predicate, #1: 1	نَابَ نَائِبُ
u'نَاجَى فُلاَنٌ':Subject, #1: 1	نَابَ الْوَجْبَةَ
u'نَاحَ رَجُلٌ':Subject, #1: 1	نَاجَى فُلَانٌ
u'نَاحَ نِسْوَةٌ':Subject, #1: 1	نَاحَ الرَّجُلُ
u'نَادَى اللَّهُمَّ':Predicate, #1: 1	نَاحَ نِسْوَةٌ
u'نَادَى إمَامٌ':Subject, #1: 1	نَادَى اللَّهُمَّ
u'نَادَى أمَانٌ':Predicate, #1: 1	نَادَى الْإِمَامُ
u'نَادَى أَمينٌ':Subject, #1: 1	نَادَى الْأَمَانَ
u'نَادَى أهْلٌ':Predicate, #1: 1	نَادَى أَمِينُ
u'نَادَى ثَالِثٌ':Predicate, #1: 1	نَادَى أَهْلَ
u'نَادَى ثَالِثٌ':Predicate, #1: 1	نَادَى الثّالِثَةَ
u'نَادَى رَجُلٌ':Subject, #1: 1	نَادَى الثَّالِثَةَ
u'نَادَى رَسُولٌ':Predicate, #7: 7	نَادَى رَجُلٌ
u'نَادَى رَسُولٌ':Subject, #4: 4	نَادَى رَسُولَ
u'نَادَى سَعِيدٌ':Subject, #2: 2	نَادَى رَسُولُ
u'نَادَى صَلاَةٌ':Subject, #1: 1	نَادَى سَعِيدُ
u'نَادَى عمرة':Predicate, #1: 1	نَادَى الصَّلَاةُ
u'نَادَى فلان':Subject, #1: 1	نَادَى عَمْرَةَ
u'نَادَى قَوْمٌ':Subject, #2: 2	نَادَى بِلاَلٌ
u'نَادَى مُسْلِمٌ':Subject, #1: 1	نَادَى الْقَوْمُ
u'نَادَى مُؤَذِّنٌ':Predicate, #1: 1	نَادَى الْمُسْلِمُ
u'نَادَى نَبِيٌّ':Predicate, #1: 1	نَادَى الْمُؤَذِّنَ
u'نَادَى نَبِيٌّ':Predicate, #1: 1	نَادَى نَبِيَّ
u'نَادَى يَوْمٌ':Predicate, #4: 4	نَادَى النَّبِيَّ
u'نَارَ جَهَنَّمُ':Predicate, #3: 3	نَادَى يَوْمَ
u'نَارَ كَوْنٌ':Predicate, #16: 16	نَارَ جَهَنَّمَ
u'نَازَعَ اِبْنٌ':Subject, #1: 1	أَنَارَ الْكَوْنَ
u'نَازَعَ المُشْتَرِي':Predicate, #2: 2	نَازَعَ ابْنُ
u'نَازَعَ أهْلٌ':Subject, #1: 1	نَازَعَ الْمُشْتَرِيَ
u'نَازَعَ بَعْضٌ':Subject, #2: 2	نَازَعَ أَهْلُ
u'نَازَعَ جَمَاعَةٌ':Subject, #2: 2	نَازَعَ الْبَعْضُ
u'نَازَعَ رَبُّ':Subject, #1: 1	نَازَعَ جَمَاعَةٌ
u'نَازَعَ رَسُولٌ':Predicate, #2: 2	نَازَعَ رَبُّ
u'نَازَعَ شَارِحٌ':Subject, #1: 1	نَازَعَ رَسُولَ
u'نَازَعَ صَاحِبٌ':Subject, #1: 1	نَازَعَ الشَّارِحُ
u'نَازَعَ عند':Predicate, #2: 2	نَازَعَ صَاحِبُ
u'نَازَعَ قَيِّمٌ':Predicate, #1: 1	نَازَعَ عِنْدَ
u'نَازَعَ كَمَالٌ':Subject, #2: 2	نَازَعَ الْقَيِّمَ
u'نَازَعَ مَشَايِخُ':Subject, #1: 1	نَازَعَ الْكَمَالُ
u'نَازَعَ مُشْتَرِي':Predicate, #1: 1	نَازَعَ الْمَشَايِخُ
u'نَازَعَ نَائِبٌ':Predicate, #1: 1	نَازَعَ الْمُشْتَرِيَ
u'نَازَعَ وَصِيٌّ':Subject, #1: 1	نَازَعَ النَّائِبَ
u'نَازَعَ ولد':Subject, #1: 1	نَازَعَ الْوَصِيُّ
u'نَازَعَ وَلَدٌ':Subject, #1: 1	نَازَعَ الْوَلَدُ
u'نَازَلَ عَدُوٌّ':Predicate, #1: 1	نَازَعَ الْوَلَدُ
u'نَاسَبَ بَيَانٌ':Predicate, #1: 1	نَازَلَ الْعَدُوَّ
u'نَاسَبَ تَعْبِيرٌ':Predicate, #1: 1	نَاسَبَ بَيَانَ
u'نَاسَبَ تَعَرُّضٌ':Subject, #1: 1	نَاسَبَ التَّعْبِيرَ
u'نَاسَبَ حُكْمٌ':Predicate, #1: 1	نَاسَبَ التَّعَرُّضُ
u'نَاسَبَ ذكر':Predicate, #1: 1	نَاسَبَ الْحُكْمَ
u'نَاسَبَ ذِكْرٌ':Predicate, #4: 4	نَاسَبَ ذِكْرَ
u'نَاسَبَ ذكر':Subject, #4: 4	نَاسَبَ ذِكْرَ
u'نَاسَبَ ذِكْرٌ':Subject, #1: 1	نَاسَبَ ذِكْرُ
u'نَاسَبَ ذكر':Subject, #1: 1	نَاسَبَ ذِكْرُ
u'نَاسَبَ ذِكْرٌ':Subject, #1: 1	نَاسَبَ ذِكْرُهُ
u'نَاسَبَ فِرَاقٌ':Predicate, #1: 1	نَاسَبَ ذِكْرُهُ
u'نَاطَ إِسْقاطٌ':Predicate, #1: 1	نَاسَبَ الْفِرَاقَ
u'نَاطَ تَوْلِيَةٌ':Predicate, #1: 1	أَنَاطَ الْإِسْقَاطَ
u'نَاطَ حُكْمٌ':Predicate, #1: 1	أَنَاطَ التَّوْلِيَةَ
u'نَاطَ حِلٌّ':Predicate, #3: 3	أَنَاطَ الْحُكْمَ
u'نَاطَ شَارِعٌ':Subject, #1: 1	أَنَاطَ الْحِلَّ
u'نَاطَ شَارِعٌ':Subject, #1: 1	أَنَاطَ الشَّارِعُ
u'نَاطَ مُصَنِّفٌ':Subject, #1: 1	نَاطَ الشَّارِعُ
u'نَاظَرَ اِبْنٌ':Subject, #3: 3	أَنَاطَ الْمُصَنِّفُ
u'نَاظَرَ أهْلٌ':Predicate, #1: 1	نَاظَرَ ابْنُ
u'نَاظَرَ فلان':Predicate, #1: 1	نَاظَرَ أَهْلَ
u'نَافَقَ نَاسٌ':Subject, #1: 1	نَاظَرَ سُفْيَانَ
u'نَافَى اِبْتِداءٌ':Predicate, #1: 1	نَافَقَ نَاسٌ
u'نَافَى حُكْمٌ':Subject, #1: 1	نَافَى ابْتِدَاءَ
u'نَافَى خُشُوعٌ':Predicate, #1: 1	نَافَى حُكْمُهُ
u'نَافَى عَقْدٌ':Predicate, #1: 1	نَافَى الْخُشُوعَ
u'نَافَى قول':Predicate, #1: 1	نَافَى الْعَقْدَ
u'نَافَى قَوْلٌ':Predicate, #1: 1	نَافَى قَوْلَكَ
u'نَاقَشَ بَعْضٌ':Subject, #1: 1	نَافَى قَوْلَكَ
u'نَاقَشَ مُحَقِّقٌ':Subject, #1: 1	نَاقَشَ بَعْضُ
u'نَاقَضَ إجَارَةٌ':Predicate, #1: 1	نَاقَشَ الْمُحَقِّقُ
u'نَاقَضَ إِجْمَاعٌ':Predicate, #1: 1	نَاقَضَ الْإِجَارَةَ
u'نَاقَضَ شافِعِيّ':Subject, #1: 1	نَاقَضَ الْإِجْمَاعَ
u'نَاقَضَ عَمَلٌ':Subject, #2: 2	نَاقَضَ الشَّافِعِيُّ
u'نَاقَضَ فلان':Subject, #1: 1	نَاقَضَ عَمَلُهُ
u'نَاقَضَ كِتَابٌ':Predicate, #2: 2	نَاقَضَ الشَّافِعِيُّ
u'نَاقَضَ مُحَمَّدٌ':Predicate, #1: 1	نَاقَضَ كِتَابَ
u'نَاقَضَ مُصَنِّفٌ':Subject, #1: 1	نَاقَضَ مُحَمَّدَ
u'نَاقَضَ وَكِيلٌ':Subject, #1: 1	نَاقَضَ الْمُصَنِّفُ
u'نَاقَضَ وَكِيلٌ':Subject, #1: 1	نَاقَضَ الْوَكِيلُ
u'نال اِبْنٌ':Predicate, #1: 1	نَاقَضَ وَكِيلُ
u'نَالَ اِبْنٌ':Predicate, #1: 1	نَالَ ابْنَ
u'نال إِنْسانٌ':Predicate, #1: 1	نَالَ ابْنَ
u'نَالَ إِنْسانٌ':Predicate, #1: 1	نَالَ الْإِنْسَانَ
u'نال أهْلٌ':Subject, #1: 1	نَالَ الْإِنْسَانَ
u'نَالَ أهْلٌ':Subject, #1: 1	نَالَ أَهْلُ
u'نال بَعْضٌ':Predicate, #1: 1	نَالَ أَهْلُ
u'نَالَ بَعْضٌ':Predicate, #2: 2	نَالَ بَعْضَ
u'نال حُسْنٌ':Predicate, #2: 2	نَالَ بَعْضَ
u'نَالَ حُسْنٌ':Predicate, #1: 1	نَالَ الْحُسْنَ
u'نال دنيا':Subject, #1: 1	نَالَ الْحُسْنَ
u'نَالَ دنيا':Subject, #1: 1	نَالَ دُنْيَاهُ
u'نال دُنْيا':Subject, #1: 1	نَالَ دُنْيَاهُ
u'نَالَ دُنْيا':Subject, #1: 1	نَالَ دُنْيَاهُ
u'نال رَاحَةٌ':Predicate, #1: 1	نَالَ دُنْيَاهُ
u'نَالَ رَاحَةٌ':Predicate, #1: 1	نَالَ رَاحَةَ
u'نال رُتْبَةٌ':Predicate, #1: 1	نَالَ رَاحَةَ
u'نَالَ رُتْبَةٌ':Predicate, #2: 2	نَالَ رُتْبَةَ
u'نال رَجُلٌ':Subject, #2: 2	نَالَ رُتْبَةَ
u'نَالَ رَجُلٌ':Subject, #1: 1	نَالَ رَجُلٌ
u'نال شِبْرٌ':Predicate, #1: 1	نَالَ رَجُلٌ
u'نَالَ شِبْرٌ':Predicate, #1: 1	نَالَ الشِّبْرَ
u'نال شرف':Predicate, #1: 1	نَالَ الشِّبْرَ
u'نَالَ شرف':Predicate, #1: 1	نَالَ الشَّرَفَ
u'نال شَرَفٌ':Predicate, #1: 1	نَالَ الشَّرَفَ
u'نَالَ شَرَفٌ':Predicate, #1: 1	نَالَ الشَّرَفَ
u'نال صَاحِبٌ':Subject, #1: 1	نَالَ الشَّرَفَ
u'نَالَ صَاحِبٌ':Subject, #1: 1	نَالَ صَاحِبُهُ
u'نال عِزٌّ':Predicate, #1: 1	نَالَ صَاحِبُهُ
u'نَالَ عِزٌّ':Predicate, #1: 1	نَالَ الْعِزَّ
u'نال عَشِيرٌ':Predicate, #1: 1	نَالَ الْعِزَّ
u'نَالَ عَشِيرٌ':Predicate, #1: 1	نَالَ الْعَشِيرَةَ
u'نال عَشِيرَةٌ':Predicate, #1: 1	نَالَ الْعَشِيرَةَ
u'نَالَ عَشِيرَةٌ':Predicate, #1: 1	نَالَ الْعَشِيرَةَ
u'نال عُلُوٌّ':Predicate, #1: 1	نَالَ الْعَشِيرَةَ
u'نَالَ عُلُوٌّ':Predicate, #1: 1	نَالَ الْعُلُوَّ
u'نال فَضْلٌ':Predicate, #1: 1	نَالَ الْعُلُوَّ
u'نَالَ فَضْلٌ':Predicate, #2: 2	نَالَ فَضْلَ
u'نال فلان':Subject, #2: 2	نَالَ فَضْلَ
u'نَالَ فلان':Subject, #1: 1	نَالَ جَعْفَرٌ
u'نال كَرَامَةٌ':Predicate, #1: 1	نَالَ جَعْفَرٌ
u'نَالَ كَرَامَةٌ':Predicate, #1: 1	نَالَ الْكَرَامَةَ
u'نال لَذَّةٌ':Predicate, #1: 1	نَالَ الْكَرَامَةَ
u'نَالَ لَذَّةٌ':Predicate, #3: 3	نَالَ اللَّذَّةَ
u'نال مثل':Predicate, #3: 3	نَالَ اللَّذَّةَ
u'نَالَ مثل':Predicate, #1: 1	نَالَ مِثْلَ
u'نال مِثْلٌ':Predicate, #1: 1	نَالَ مِثْلَ
u'نَالَ مِثْلٌ':Predicate, #1: 1	نَالَ مِثْلَ
u'نال مَحْمَدَةٌ':Predicate, #1: 1	نَالَ مِثْلَ
u'نَالَ مَحْمَدَةٌ':Predicate, #1: 1	نَالَ مَحْمَدَةَ
u'نَامَ أَكْثَرُ':Predicate, #1: 1	نَالَ مَحْمَدَةَ
u'نَامَ إِنْسانٌ':Subject, #2: 2	نَامَ أَكْثَرَ
u'نَامَ أهْلٌ':Subject, #1: 1	نَامَ إنْسَانٌ
u'نَامَ بَعْضٌ':Subject, #3: 3	نَامَ أَهْلُ
u'نَامَ ثَلاثُ':Predicate, #1: 1	نَامَ بَعْضُ
u'نَامَ جَمِيع':Subject, #1: 1	نَامَ ثَلاَثَ
u'نَامَ حاكِمٌ':Subject, #1: 1	نَامَ الْجَمِيعُ
u'نَامَ حَديثٌ':Predicate, #1: 1	نَامَ الْحَاكِمُ
u'نَامَ خَلْفٌ':Predicate, #1: 1	نَامَ الْحَديِثَ
u'نَامَ رَجُلٌ':Subject, #6: 6	نَامَ خَلْفَ
u'نَامَ رَجُلٌ':Subject, #1: 1	نَامَ رَجُلٌ
u'نَامَ رَسُولٌ':Subject, #4: 4	نَامَ الرَّجُلُ
u'نَامَ صَفْوَان':Subject, #3: 3	نَامَ رَسُولُ
u'نَامَ طَالِبٌ':Subject, #1: 1	نَامَ صَفْوَانُ
u'نَامَ عَبْدٌ':Subject, #2: 2	نَامَ الطَّالِبُ
u'نَامَ عَبْدٌ':Subject, #2: 2	نَامَ عَبْدٌ
u'نَامَ عند':Predicate, #6: 6	نَامَ الْعَبْدُ
u'نَامَ عين':Subject, #4: 4	نَامَ عِنْدَ
u'نَامَ عَيْنٌ':Subject, #1: 1	نَامَ عَيْنُهُ
u'نَامَ عَيْن':Subject, #1: 1	نَامَ عَيْنُهُ
u'نَامَ غُلاَمٌ':Subject, #1: 1	نَامَ عَيْنُهُ
u'نَامَ غير':Predicate, #1: 1	أَنَامَ الْغُلامُ
u'نَامَ غَيْرٌ':Predicate, #1: 1	نَامَ غَيْرَ
u'نَامَ فَلًا':Predicate, #1: 1	نَامَ غَيْرَ
u'نَامَ قلب':Subject, #4: 4	نَامَ فَلاَ
u'نَامَ قَلْبٌ':Subject, #1: 1	نَامَ قَلْبُهُ
u'نَامَ قَلْب':Subject, #1: 1	نَامَ قَلْبُهُ
u'نَامَ قَوْمٌ':Subject, #1: 1	نَامَ قَلْبُهُ
u'نَامَ كَلْبٌ':Subject, #3: 3	نَامَ الْقَوْمُ
u'نَامَ لاَحِقٌ':Subject, #1: 1	نَامَ الْكَلْبُ
u'نَامَ لَيْلٌ':Predicate, #1: 1	نَامَ لَاحِقٌ
u'نَامَ لَيْلٌ':Predicate, #1: 1	نَامَ اللَّيْلَ
u'نَامَ لَيْلٌ':Predicate, #1: 1	نَامَ لَيْلَةَ
u'نَامَ مُودَعٌ':Subject, #2: 2	نَامَ لَيْلَةً
u'نَامَ نَاسٌ':Subject, #2: 2	نَامَ الْمُودَعُ
u'نَامَ نَبِيٌّ':Subject, #1: 1	نَامَ النَّاسُ
u'نَامَ نِساءٌ':Subject, #1: 1	نَامَ النَّبِيُّ
u'نَامَ ولد':Subject, #2: 2	نَامَ النِّسَاءُ
u'نَامَ وَلَدٌ':Subject, #1: 1	نَامَ الْوَلَدُ
u'نَامَ وَنِيَّةٌ':Subject, #1: 1	نَامَ الْوَلَدُ
u'نَاهَزَ بُلُوغٌ':Predicate, #2: 2	نَامَ وَنِيَّتُهُ
u'نَاهَزَ ثَمانِين':Predicate, #1: 1	نَاهَزَ الْبُلُوغَ
u'نَاوَلَ إِناءٌ':Predicate, #1: 1	نَاهَزَ الثَّمَانِينَ
u'نَاوَلَ بَعْضٌ':Subject, #1: 1	نَاوَلَ الْإِنَاءَ
u'نَاوَلَ حالِق':Predicate, #1: 1	نَاوَلَ بَعْضُ
u'نَاوَلَ حالِق':Subject, #1: 1	نَاوَلَ الْحَالِقَ
u'نَاوَلَ حَلاَّقٌ':Predicate, #1: 1	نَاوَلَ الْحَالِقُ
u'نَاوَلَ ضَيْفٌ':Predicate, #2: 2	نَاوَلَ الْحَلاَّقَ
u'نَاوَلَ ضَيْفٌ':Subject, #1: 1	نَاوَلَ الضَّيْفَ
u'نَاوَلَ طعام':Predicate, #1: 1	نَاوَلَ الضَّيْفُ
u'نَاوَلَ طَعَامٌ':Predicate, #1: 1	نَاوَلَ الطَّعَامَ
u'نَاوَلَ عَبْدٌ':Predicate, #1: 1	نَاوَلَ الطَّعَامَ
u'نَاوَلَ عظام':Predicate, #1: 1	نَاوَلَ عَبْدَ
u'نَاوَلَ عِظَامٌ':Predicate, #1: 1	نَاوَلَ الْعِظَامَ
u'نَاوَلَ فُلاَنٌ':Subject, #1: 1	نَاوَلَ الْعِظَامَ
u'نبات إِبْطٌ':Added, #1: 1	نَاوَلَ فُلَانٌ
u'نَبَاتٌ إِبْطٌ':Added, #1: 1	نَبَاتُ الْإِبْطِ
u'نبات أرْضٌ':Added, #1: 1	نَبَاتُ الْإِبْطِ
u'نَبَاتٌ أرْضٌ':Added, #6: 6	نَبَاتِ الْأَرْضِ
u'نبات أسْنَانٌ':Added, #6: 6	نَبَاتِ الْأَرْضِ
u'نَبَاتٌ أسْنَانٌ':Added, #1: 1	نَبَاتَ الْأَسْنَانِ
u'نبات أَوْدِيَةٌ':Added, #1: 1	نَبَاتَ الْأَسْنَانِ
u'نَبَاتٌ أَوْدِيَةٌ':Added, #1: 1	نَبَاتِ الْأَوْدِيَةِ
u'نبات بَرٌّ':Added, #1: 1	نَبَاتِ الْأَوْدِيَةِ
u'نَبَاتٌ بَرٌّ':Added, #1: 1	نَبَاتَ الْبَرِّ
u'نبات برديُّ':Added, #1: 1	نَبَاتَ الْبَرِّ
u'نَبَاتٌ برديُّ':Added, #1: 1	نَبَاتِ الْبَرْدِيِّ
u'نبات بَرْدِيٌّ':Added, #1: 1	نَبَاتِ الْبَرْدِيِّ
u'نَبَاتٌ بَرْدِيٌّ':Added, #1: 1	نَبَاتِ الْبَرْدِيِّ
u'نبات ثَدْيٌ':Added, #1: 1	نَبَاتِ الْبَرْدِيِّ
u'نَبَاتٌ ثَدْيٌ':Added, #1: 1	نَبَاتِ الثَّدْيَيْنِ
u'نبات جِبَالٌ':Added, #1: 1	نَبَاتِ الثَّدْيَيْنِ
u'نَبَاتٌ جِبَالٌ':Added, #1: 1	نَبَاتِ الْجِبَالِ
u'نبات حَرَمٌ':Added, #1: 1	نَبَاتِ الْجِبَالِ
u'نَبَاتٌ حَرَمٌ':Added, #1: 1	نَبَاتُ الْحَرَمِ
u'نبات حَرَمٌ':Added, #1: 1	نَبَاتُ الْحَرَمِ
u'نَبَاتٌ حَرَمٌ':Added, #6: 6	نَبَاتِ الْحَرَمِ
u'نبات رَعْدٌ':Added, #6: 6	نَبَاتِ الْحَرَمِ
u'نَبَاتٌ رَعْدٌ':Added, #1: 1	نَبَاتَ الرَّعْدِ
u'نبات زَرْعٌ':Added, #1: 1	نَبَاتَ الرَّعْدِ
u'نَبَاتٌ زَرْعٌ':Added, #3: 3	نَبَاتِ الزَّرْعِ
u'نبات سِنٌّ':Added, #3: 3	نَبَاتِ الزَّرْعِ
u'نَبَاتٌ سِنٌّ':Added, #3: 3	نَبَاتَ سِنِّ
u'نبات شَعْرٌ':Added, #3: 3	نَبَاتَ سِنِّ
u'نَبَاتٌ شَعْرٌ':Added, #1: 1	نَبَاتُ شَعْرِ
u'نبات شَعْرٌ':Added, #1: 1	نَبَاتُ شَعْرِ
u'نَبَاتٌ شَعْرٌ':Added, #1: 1	نَبَاتِ شَعْرِهِ
u'نبات شَعْرٌ':Added, #1: 1	نَبَاتِ شَعْرِهِ
u'نَبَاتٌ شَعْرٌ':Added, #3: 3	نَبَاتِ شَعْرِ
u'نبات شَعْرٌ':Added, #3: 3	نَبَاتِ شَعْرِ
u'نَبَاتٌ شَعْرٌ':Added, #4: 4	نَبَاتِ الشَّعْرِ
u'نبات صَحْرَاءُ':Added, #4: 4	نَبَاتِ الشَّعْرِ
u'نَبَاتٌ صَحْرَاءُ':Added, #1: 1	نَبَاتِ الصَّحْرَاءِ
u'نبات عَانَةٌ':Added, #1: 1	نَبَاتِ الصَّحْرَاءِ
u'نَبَاتٌ عَانَةٌ':Added, #1: 1	نَبَاتِ الْعَانَةِ
u'نبات عَانَةٌ':Added, #1: 1	نَبَاتِ الْعَانَةِ
u'نَبَاتٌ عَانَةٌ':Added, #2: 2	نَبَاتِ عَانَةِ
u'نبات لِحْيَةٌ':Added, #2: 2	نَبَاتِ عَانَةِ
u'نبات لِحْيَةٌ':Added, #1: 1	نَبَاتُ اللِّحْيَةِ
u'نَبَاتٌ لِحْيَةٌ':Added, #1: 1	نَبَاتِ اللِّحْيَةِ
u'نَبَاتٌ لِحْيَةٌ':Added, #1: 1	نَبَاتُ اللِّحْيَةِ
u'نبات لِحْيَةٌ':Added, #1: 1	نَبَاتِ اللِّحْيَةِ
u'نَبَاتٌ لِحْيَةٌ':Added, #2: 2	نَبَاتِ لِحْيَتِهِ
u'نبات لِسَانٌ':Added, #2: 2	نَبَاتِ لِحْيَتِهِ
u'نَبَاتٌ لِسَانٌ':Added, #1: 1	نَبَاتِ لِسَانٍ
u'نبات مَسْمُومٌ':Added, #1: 1	نَبَاتِ لِسَانٍ
u'نَبَاتٌ مَسْمُومٌ':Added, #1: 1	نَبَاتٍ مَسْمُومٍ
u'نبات مُضِرٌّ':Added, #1: 1	نَبَاتٍ مَسْمُومٍ
u'نَبَاتٌ مُضِرٌّ':Added, #1: 1	نَبَاتٍ مُضِرٍّ
u'نبات نَقِيعٌ':Added, #1: 1	نَبَاتٍ مُضِرٍّ
u'نَبَاتٌ نَقِيعٌ':Added, #2: 2	نَبَاتِ النَّقِيعِ
u'نباح إِنْسانٌ':Added, #2: 2	نَبَاتِ النَّقِيعِ
u'نُبَاحٌ إِنْسانٌ':Added, #1: 1	نُبَاحُ الْإِنْسَانِ
u'نباح كلاب':Added, #1: 1	نُبَاحُ الْإِنْسَانِ
u'نُبَاحٌ كلاب':Added, #1: 1	نُبَاحُ الْكِلَابِ
u'نباح كِلاَبٌ':Added, #1: 1	نُبَاحُ الْكِلَابِ
u'نُبَاحٌ كِلاَبٌ':Added, #1: 1	نُبَاحُ الْكِلَابِ
u'نباح كلاب':Added, #1: 1	نُبَاحُ الْكِلَابِ
u'نُبَاحٌ كلاب':Added, #1: 1	نُبَاحَ كِلابٍ
u'نباح كِلاَبٌ':Added, #1: 1	نُبَاحَ كِلابٍ
u'نُبَاحٌ كِلاَبٌ':Added, #1: 1	نُبَاحَ كِلابٍ
u'نباح كَلْبٌ':Added, #1: 1	نُبَاحَ كِلابٍ
u'نُبَاحٌ كَلْبٌ':Added, #2: 2	نُبَاحَ الْكَلْبِ
u'نباح كَلْبٌ':Added, #2: 2	نُبَاحَ الْكَلْبِ
u'نُبَاحٌ كَلْبٌ':Added, #2: 2	نُبَاحَ كَلْبٍ
u'نَبَأَ فَاطِمٌ':Predicate, #2: 2	نُبَاحَ كَلْبٍ
u'نَبَاهَةٌ خَامِلٌ':Added, #2: 2	أَنْبَأَ فَاطِمَةَ
u'نَبَاهَةٌ ذكر':Added, #1: 1	نَبَاهَةَ خَامِلٍ
u'نَبَاهَةٌ ذِكْرٌ':Added, #1: 1	نَبَاهَةِ الذِّكْرِ
u'نَبَتَ أَبْيَض':Predicate, #1: 1	نَبَاهَةِ الذِّكْرِ
u'نَبْتٌ أرْضٌ':Added, #1: 1	نَبَتَ أَبْيَضَ
u'نَبْتٌ أرْضٌ':Added, #1: 1	نَبْتُ الأَرْضِ
u'نَبَتَ أسْوَد':Predicate, #1: 1	نَبْتِ الأَرْضِ
u'نَبَتَ أصل':Subject, #1: 1	نَبَتَ أَسْوَدَ
u'نَبَتَ أًصْلٌ':Subject, #1: 1	نَبَتَ أَصْلُهُ
u'نَبَتَ بَذْرٌ':Subject, #1: 1	نَبَتَ أَصْلُهُ
u'نبتة بَقِيَّةٌ':Added, #1: 1	نَبَتَ الْبَذْرُ
u'نَبْتَةٌ بَقِيَّةٌ':Added, #1: 1	نَبْتَةَ بَقِيَّةِ
u'نَبَتَ حَبٌّ':Subject, #1: 1	نَبْتَةَ بَقِيَّةِ
u'نَبَتَ زَرْعٌ':Subject, #1: 1	نَبَتَ الْحَبُّ
u'نَبَتَ زَرْعٌ':Subject, #15: 15	نَبَتَ الزَّرْعُ
u'نَبَتَ زَرْعٌ':Subject, #1: 1	نَبَتَ زَرْعٌ
u'نَبَتَ سَاقِطٌ':Subject, #2: 2	نَبَتَ زَرْعُ
u'نَبَتَ سِنٌّ':Subject, #1: 1	نَبَتَ السَّاقِطُ
u'نَبَتَ سِنٌّ':Subject, #1: 1	نَبَتَ سِنٌّ
u'نَبَتَ شَجَرٌ':Subject, #1: 1	نَبَتَ سِنُّ
u'نَبَتَ شَجَرٌ':Subject, #1: 1	نَبَتَ الشَّجَرُ
u'نَبَتَ شَعْرٌ':Subject, #1: 1	نَبَتَ شَجَرُ
u'نَبَتَ شَعْرٌ':Subject, #1: 1	نَبَتَ شَعْرٌ
u'نَبَتَ شَعْرٌ':Subject, #1: 1	نَبَتَ شَعْرُ
u'نَبَتَ شَعْرٌ':Subject, #3: 3	نَبَتَ شَعْرُهُ
u'نَبَتَ شَيْءٌ':Subject, #5: 5	نَبَتَ الشَّعْرُ
u'نَبَتَ عُشْبٌ':Subject, #1: 1	نَبَتَ شَيْءٌ
u'نَبَتَ قَصَبٌ':Subject, #2: 2	نَبَتَ الْعُشْبُ
u'نَبَتَ كَفٌّ':Subject, #2: 2	نَبَتَ الْقَصَبُ
u'نَبَتَ لَحْمٌ':Subject, #1: 1	نَبَتَ كَفٌّ
u'نَبَتَ مرٌّ':Predicate, #6: 6	نَبَتَ لَحْمُهُ
u'نَبْتٌ مَشْمُومٌ':Added, #1: 1	نَبَتَ مَرَّةً
u'نَبَتَ نِصْفٌ':Subject, #1: 1	نَبْتٍ مَشْمُومٍ
u'نَبَتَ وَلَهٌ':Subject, #1: 1	نَبَتَ نِصْفُ
u'نبذ إِسْلامٌ':Predicate, #1: 1	نَبَتَ وَلَهُ
u'نَبَذَ إِسْلامٌ':Predicate, #2: 2	نَبَذَ الْإِسْلَامَ
u'نبذ إمَامٌ':Subject, #2: 2	نَبَذَ الْإِسْلَامَ
u'نَبَذَ إمَامٌ':Subject, #1: 1	نَبَذَ الْإِمَامُ
u'نبذ بَاطِلٌ':Predicate, #1: 1	نَبَذَ الْإِمَامُ
u'نَبَذَ بَاطِلٌ':Predicate, #1: 1	نَبَذَ الْبَاطِلَ
u'نبذ ذِمِّيٌّ':Subject, #1: 1	نَبَذَ الْبَاطِلَ
u'نَبَذَ ذِمِّيٌّ':Subject, #1: 1	نَبَذَ ذِمِّيٌّ
u'نبذ سِلْعَةٌ':Predicate, #1: 1	نَبَذَ ذِمِّيٌّ
u'نَبَذَ سِلْعَةٌ':Predicate, #1: 1	نَبَذَ السِّلْعَةَ
u'نبذ شَيْءٌ':Predicate, #1: 1	نَبَذَ السِّلْعَةَ
u'نَبَذَ شَيْءٌ':Predicate, #2: 2	نَبَذَ الشَّيْءَ
u'نَبْذٌ عَقْدٌ':Added, #2: 2	نَبَذَ الشَّيْءَ
u'نبذ عَهْدٌ':Predicate, #1: 1	نَبْذَ الْعَقْدِ
u'نَبَذَ عَهْدٌ':Predicate, #1: 1	نَبَذَ الْعَهْدَ
u'نَبْذٌ عَهْدٌ':Added, #1: 1	نَبَذَ الْعَهْدَ
u'نَبْذٌ عُهُودٌ':Added, #1: 1	نَبْذُ الْعَهْدِ
u'نبذ فَرِيقٌ':Subject, #1: 1	نَبْذَ الْعُهُودِ
u'نَبَذَ فَرِيقٌ':Subject, #2: 2	نَبَذَ فَرِيقٌ
u'نبذ مَاءٌ':Predicate, #2: 2	نَبَذَ فَرِيقٌ
u'نَبَذَ مَاءٌ':Predicate, #1: 1	نَبَذَ الْمَاءَ
u'نَبْذٌ مَبِيعٌ':Added, #1: 1	نَبَذَ الْمَاءَ
u'نَبْذٌ مُرُوءةٌ':Added, #1: 1	نَبْذَ الْمَبِيعِ
u'نَبَشَ قَبْرٌ':Predicate, #1: 1	نَبْذُ الْمُرُوءَةِ
u'نَبَشَ كَفَنٌ':Predicate, #2: 2	نَبَشَ الْقَبْرَ
u'نَبْعَةٌ عَزْمٌ':Added, #1: 1	نَبَشَ الْكَفَنَ
u'نَبْعٌ شَيْءٌ':Added, #1: 1	نَبْعَةَ الْعَزْمِ
u'نَبَعَ عَيْنٌ':Subject, #1: 1	نَبْعِ شَيْءٍ
u'نَبَعَ عَيْن':Subject, #1: 1	نَبَعَ عَيْنٌ
u'نَبْعٌ عَيْنٌ':Added, #1: 1	نَبَعَ عَيْنٌ
u'نَبْعٌ عَيْن':Added, #2: 2	نَبْعُ عَيْنٍ
u'نَبَعَ مَاءٌ':Subject, #2: 2	نَبْعُ عَيْنٍ
u'نَبْعٌ مَاءٌ':Added, #2: 2	نَبَعَ الْمَاءُ
u'نَبْعٌ نَهْرٌ':Added, #10: 10	نَبْعِ الْمَاءِ
u'نُبْلٌ رَأْيٌ':Added, #1: 1	نَبْعُ النَّهْرِ
u'نُبْلٌ فقر':Added, #1: 1	نُبْلَ الرَّأْيِ
u'نُبْلٌ فَقْرٌ':Added, #1: 1	نُبْلِ الْفَقْرِ
u'نَبَّهَ اِبْنٌ':Subject, #1: 1	نُبْلِ الْفَقْرِ
u'نَبَّهَ بَعْضٌ':Subject, #2: 2	نَبَّهَ ابْنُ
u'نَبَّهَ حَديثٌ':Subject, #1: 1	نَبَّهَ بَعْضُ
u'نَبَّهَ رَسُولٌ':Subject, #1: 1	نَبَّهَ الْحَدِيثُ
u'نَبَّهَ رَمْلِيٌّ':Subject, #1: 1	نَبَّهَ رَسُولُ
u'نَبَّهَ سَلَفٌ':Subject, #1: 1	نَبَّهَ الرَّمْلِيُّ
u'نَبَّهَ شَارِعٌ':Subject, #1: 1	نَبَّهَ السَّلَفُ
u'نَبَّهَ شَرْعٌ':Subject, #1: 1	نَبَّهَ الشَّارِعُ
u'نَبَّهَ صَاحِبٌ':Subject, #1: 1	نَبَّهَ الشَّرْعُ
u'نَبَّهَ غير':Predicate, #2: 2	نَبَّهَ صَاحِبُ
u'نَبَّهَ غَيْرٌ':Predicate, #1: 1	نَبَّهَ غَيْرَ
u'نَبَّهَ قول':Subject, #1: 1	نَبَّهَ غَيْرَ
u'نَبَّهَ قَوْلٌ':Subject, #1: 1	نَبَّهَ قَوْلُهُ
u'نَبَّهَ مَالِكٌ':Subject, #1: 1	نَبَّهَ قَوْلُهُ
u'نَبَّهَ مُصَنِّفٌ':Subject, #1: 1	نَبَّهَ مَالِكٌ
u'نَبَّهَ نَوَوِيٌّ':Subject, #5: 5	نَبَّهَ الْمُصَنِّفُ
u'نَبْوَةٌ نُفُورٌ':Added, #2: 2	نَبَّهَ النَّوَوِيُّ
u'نَتَجَ بِغالٌ':Predicate, #1: 1	نَبْوَةَ نُفُورٍ
u'نَتَجَ مَالٌ':Subject, #1: 1	نَتَجَ الْبِغَالَ
u'نَتْفٌ إِبْطٌ':Added, #5: 5	نَتَجَ الْمَالُ
u'نَتْفٌ إِبْطٌ':Added, #1: 1	نَتْفِ إبْطِهِ
u'نَتْفٌ أَنْفٌ':Added, #1: 1	نَتْفَ الإِبْطِ
u'نَتَفَ بَعْضٌ':Predicate, #2: 2	نَتْفُ الْأَنْفِ
u'نَتَفَ ثَلاثُ':Predicate, #1: 1	نَتَفَ بَعْضَ
u'نَتَفَ رِيشٌ':Predicate, #1: 1	نَتَفَ ثَلَاثَ
u'نَتْفٌ رِيشٌ':Added, #3: 3	نَتَفَ رِيشَ
u'نَتْفٌ رِيشٌ':Added, #1: 1	نَتْفُ رِيشِهِ
u'نَتَفَ شَعْرٌ':Predicate, #2: 2	نَتْفُ رِيشِ
u'نَتْفٌ شَعَرٌ':Added, #2: 2	نَتَفَ شَعْرَةً
u'نَتْفٌ شَعْرٌ':Added, #1: 1	نَتْفُ الشَّعَرِ
u'نَتْفٌ شَعْرٌ':Added, #1: 1	نَتْفَ الشَّعْرِ
u'نَتْفٌ شَعَرٌ':Added, #1: 1	نَتْفِ الشَّعْرِ
u'نَتْفٌ شَعْرٌ':Added, #1: 1	نَتْفُ شَعَرِ
u'نَتْفٌ شَعْرٌ':Added, #1: 1	نَتْفُ شَعْرٍ
u'نَتْفٌ شَعْرٌ':Added, #1: 1	نَتْفِ شَعْرِهِ
u'نَتْفٌ شيب':Added, #2: 2	نَتْفُ شَعْرِ
u'نَتْفٌ شيب':Added, #1: 1	نَتْفُ الشِّيبِ
u'نَتْفٌ شَيْبٌ':Added, #1: 1	نَتْفَ الشَّيْبِ
u'نَتْفٌ شيب':Added, #1: 1	نَتْفَ الشَّيْبِ
u'نَتْفٌ شيب':Added, #3: 3	نَتْفُ الشَّيْبِ
u'نَتْفٌ شَيْبٌ':Added, #3: 3	نَتْفِ الشَّيْبِ
u'نَتْفٌ شَيْبٌ':Added, #3: 3	نَتْفُ الشَّيْبِ
u'نَتْفٌ صُوفٌ':Added, #3: 3	نَتْفِ الشَّيْبِ
u'نَتْفٌ عَانَةٌ':Added, #1: 1	نَتْفَ صُوفٍ
u'نَتْفٌ فَرْجٌ':Added, #1: 1	نَتْفِ الْعَانَةِ
u'نَتَفَ لِحْيَةٌ':Predicate, #1: 1	نَتْفُ الْفَرْجِ
u'نَتْفٌ لِحْيَةٌ':Added, #1: 1	نَتَفَ لِحْيَةَ
u'نَتْنٌ إِبْطٌ':Added, #1: 1	نَتْفُ اللِّحْيَةِ
u'نَتْنٌ أَنْفٌ':Added, #1: 1	نَتْنُ الْإِبْطِ
u'نَتْنٌ رَائِحٌ':Added, #1: 1	نَتْنُ الْأَنْفِ
u'نَتْنٌ رَائِحٌ':Added, #1: 1	نَتْنُ رَائِحَةِ
u'نَتْنٌ رَائِحَةٌ':Added, #2: 2	نَتْنِ رَائِحَةٍ
u'نَتْنٌ رَائِحَةٌ':Added, #1: 1	نَتْنُ رَائِحَةِ
u'نَتْنٌ رحم':Added, #2: 2	نَتْنِ رَائِحَةٍ
u'نَتْنٌ رَحِمٌ':Added, #1: 1	نَتْنِ الرَّحِمِ
u'نَتْنٌ ريحٌ':Added, #1: 1	نَتْنِ الرَّحِمِ
u'نَتْنٌ سِرْقِين':Added, #1: 1	نَتْنِ رِيحِهِ
u'نَتْنٌ فَرْجٌ':Added, #1: 1	نَتْنِ السِّرْقِينِ
u'نَتْنٌ فَمٌ':Added, #1: 1	نَتْنُ الْفَرْجِ
u'نَتْنٌ فَمٌ':Added, #1: 1	نَتْنَ الْفَمِ
u'نُتُوءٌ صَدْرٌ':Added, #2: 2	نَتْنُ الْفَمِ
u'نُتُوءٌ وسط':Added, #1: 1	نُتُوءُ الصَّدْرِ
u'نُتُوءٌ وَسَطٌ':Added, #1: 1	نُتُوءُ وَسَطِ
u'نثار عُرْسٌ':Added, #1: 1	نُتُوءُ وَسَطِ
u'نِثَارٌ عُرْسٌ':Added, #1: 1	نِثَارَ الْعُرْسِ
u'نَثْرٌ دَرَاهِمُ':Added, #1: 1	نِثَارَ الْعُرْسِ
u'نَثْرٌ دَرَاهِمُ':Added, #1: 1	نَثْرُ الدَّرَاهِمِ
u'نَثْرٌ دَقَل':Added, #1: 1	نَثْرِ الدَّرَاهِمِ
u'نَثَرَ ذُرِّيَّةٌ':Predicate, #2: 2	نَثْرَ الدَّقَلِ
u'نَثَرَ سُكَّرٌ':Predicate, #1: 1	نَثَرَ ذُرِّيَّةَ
u'نَثْرٌ سُكَّرٌ':Added, #4: 4	نَثَرَ السُّكَّرَ
u'نَثْرٌ لَوْزٌ':Added, #1: 1	نَثْرُ السُّكَّرِ
u'نَجَا أحَدٌ':Subject, #2: 2	نَثْرُ اللَّوْزِ
u'نَجَا أَوَّلُ':Subject, #2: 2	نَجَا أَحَدٌ
u'نَجَابَةٌ أَوْلاَدٌ':Added, #1: 1	نَجَا أَوَّلُ
u'نَجَابَةٌ ولد':Added, #1: 1	نَجَابَةِ أَوْلَادِ
u'نَجَابَةٌ وَلَدٌ':Added, #2: 2	نَجَابَةِ الْوَلَدِ
u'نجاة بَعْضٌ':Added, #2: 2	نَجَابَةِ الْوَلَدِ
u'نَجَاةٌ بَعْضٌ':Added, #1: 1	نَجَاةُ الْبَعْضِ
u'نِجَادٌ سَيْفٌ':Added, #1: 1	نَجَاةُ الْبَعْضِ
u'نِجَادٌ مُهَنَّدٌ':Added, #1: 1	نِجَادِ السّيْفِ
u'نَجَاسَةٌ أبدانٌ':Added, #3: 3	نِجَادُ مُهَنّدٍ
u'نَجَاسَةٌ أَبْوَالٌ':Added, #2: 2	نَجَاسَةُ الْأَبْدَانِ
u'نَجَاسَةٌ آثَامٌ':Added, #1: 1	نَجَاسَةِ الأَبْوَالِ
u'نَجَاسَةٌ أحَدٌ':Added, #2: 2	نَجَاسَةِ الْآثَامِ
u'نَجَاسَةٌ أرْضٌ':Added, #1: 1	نَجَاسَةِ أَحَدِ
u'نَجَاسَةٌ أرْضٌ':Added, #1: 1	نَجَاسَةُ أَرْضٍ
u'نَجَاسَةٌ إِناءٌ':Added, #2: 2	نَجَاسَةِ الْأَرْضِ
u'نَجَاسَةٌ بَاطن':Added, #1: 1	نَجَاسَةِ الْإِنَاءِ
u'نَجَاسَةٌ باطِنٌ':Added, #1: 1	نَجَاسَةَ بَاطِنِ
u'نَجَاسَةٌ بَاطن':Added, #1: 1	نَجَاسَةَ بَاطِنِ
u'نَجَاسَةٌ باطِنٌ':Added, #3: 3	نَجَاسَةِ الْبَاطِنِ
u'نَجَاسَةٌ بدن':Added, #3: 3	نَجَاسَةِ الْبَاطِنِ
u'نَجَاسَةٌ بَدَنٌ':Added, #1: 1	نَجَاسَةَ الْبَدَنِ
u'نَجَاسَةٌ بدن':Added, #1: 1	نَجَاسَةَ الْبَدَنِ
u'نَجَاسَةٌ بَدَنٌ':Added, #1: 1	نَجَاسَةِ بَدَنِ
u'نَجَاسَةٌ بدن':Added, #1: 1	نَجَاسَةِ بَدَنِ
u'نَجَاسَةٌ بَدَنٌ':Added, #1: 1	نَجَاسَةَ بَدَنِهِ
u'نَجَاسَةٌ بدن':Added, #1: 1	نَجَاسَةَ بَدَنِهِ
u'نَجَاسَةٌ بَدَنٌ':Added, #2: 2	نَجَاسَةِ بَدَنِهِ
u'نَجَاسَةٌ بَهائِمُ':Added, #2: 2	نَجَاسَةِ بَدَنِهِ
u'نَجَاسَةٌ بَوْلٌ':Added, #1: 1	نَجَاسَةِ الْبَهَائِمِ
u'نَجَاسَةٌ بَوْلٌ':Added, #1: 1	نَجَاسَةَ الْبَوْلِ
u'نَجَاسَةٌ بَوْلٌ':Added, #1: 1	نَجَاسَةِ الْبَوْلِ
u'نَجَاسَةٌ بَوْلٌ':Added, #2: 2	نَجَاسَةُ الْبَوْلِ
u'نَجَاسَةٌ بَوْلٌ':Added, #2: 2	نَجَاسَةُ بَوْلِ
u'نَجَاسَةٌ بِئْرٌ':Added, #2: 2	نَجَاسَةِ بَوْلِ
u'نَجَاسَةٌ بِئْرٌ':Added, #1: 1	نَجَاسَةُ الْبِئْرِ
u'نَجَاسَةٌ بيض':Added, #3: 3	نَجَاسَةِ الْبِئْرِ
u'نَجَاسَةٌ ثَوْبٌ':Added, #2: 2	نَجَاسَةُ بَيْضِ
u'نَجَاسَةٌ ثَوْبٌ':Added, #1: 1	نَجَاسَةَ الثَّوْبِ
u'نَجَاسَةٌ ثَوْبٌ':Added, #1: 1	نَجَاسَةِ ثَوْبِ
u'نَجَاسَةٌ ثَوْبٌ':Added, #1: 1	نَجَاسَةُ ثَوْبِهِ
u'نَجَاسَةٌ ثَوْبٌ':Added, #1: 1	نَجَاسَةِ ثَوْبِهِ
u'نَجَاسَةٌ جَديدٌ':Added, #2: 2	نَجَاسَةِ الثَّوْبِ
u'نَجَاسَةٌ جَدِيدٌ':Added, #1: 1	نَجَاسَةُ الْجَدِيدِ
u'نَجَاسَةٌ جَنَابَةٌ':Added, #1: 1	نَجَاسَةُ الْجَدِيدِ
u'نَجَاسَةٌ حَقِيقِيٌّ':Added, #1: 1	نَجَاسَةِ الْجَنَابَةِ
u'نَجَاسَةٌ حُكْم':Added, #1: 1	نَجَاسَةٍ حَقِيقِيَّةٍ
u'نَجَاسَةٌ حُكْمِيّ':Added, #3: 3	نَجَاسَةٍ حُكْمِيَّةٍ
u'نَجَاسَةٌ حَيْضٌ':Added, #3: 3	نَجَاسَةٍ حُكْمِيَّةٍ
u'نَجَاسَةٌ خُرْء':Added, #1: 1	نَجَاسَةُ الْحَيْضِ
u'نَجَاسَةٌ خَلاَءٌ':Added, #1: 1	نَجَاسَةِ خُرْءِ
u'نَجَاسَةٌ خَمْرٌ':Added, #2: 2	نَجَاسَةِ الْخَلَاءِ
u'نَجَاسَةٌ خِنْزِيرٌ':Added, #1: 1	نَجَاسَةَ الْخَمْرِ
u'نَجَاسَةٌ خِنْزِيرٌ':Added, #1: 1	نَجَاسَةَ الْخِنْزِيرِ
u'نَجَاسَةٌ خِنْزِيرٌ':Added, #1: 1	نَجَاسَةُ الْخِنْزِيرِ
u'نَجَاسَةٌ دُخَانٌ':Added, #1: 1	نَجَاسَةُ خِنْزِيرٍ
u'نَجَاسَةٌ دَمٌ':Added, #1: 1	نَجَاسَةِ دُخَانِ
u'نَجَاسَةٌ دَمٌ':Added, #1: 1	نَجَاسَةُ الدَّمِ
u'نَجَاسَةٌ دُهْنٌ':Added, #1: 1	نَجَاسَةُ دَمِ
u'نَجَاسَةٌ ذكر':Added, #2: 2	نَجَاسَةِ دُهْنٍ
u'نَجَاسَةٌ ذَكَرٌ':Added, #2: 2	نَجَاسَةِ الذَّكَرِ
u'نَجَاسَةٌ رُبُعٌ':Added, #2: 2	نَجَاسَةِ الذَّكَرِ
u'نَجَاسَةٌ رَجُلٌ':Added, #1: 1	نَجَاسَةَ الرُّبُعِ
u'نَجَاسَةٌ رَطْبَةٌ':Added, #2: 2	نَجَاسَةُ الرَّجُلِ
u'نَجَاسَةٌ ريحٌ':Added, #3: 3	نَجَاسَةٍ رَطْبَةٍ
u'نَجَاسَةٌ زِبْلٌ':Added, #1: 1	نَجَاسَةِ الرِّيحِ
u'نَجَاسَةٌ زَيْتٌ':Added, #1: 1	نَجَاسَةِ الزِّبْلِ
u'نَجَاسَةٌ سَائِرٌ':Added, #1: 1	نَجَاسَةِ الزَّيْتِ
u'نَجَاسَةٌ سَبِيلٌ':Added, #1: 1	نَجَاسَةِ سَائِرِ
u'نَجَاسَةٌ سِتٌّ':Added, #1: 1	نَجَاسَةِ السَّبِيلَيْنِ
u'نَجَاسَةٌ سِنٌّ':Added, #1: 1	نَجَاسَةِ سِتَّةٍ
u'نَجَاسَةٌ سِنٌّ':Added, #1: 1	نَجَاسَةِ السِّنِّ
u'نَجَاسَةٌ سُؤْرٌ':Added, #1: 1	نَجَاسَةُ سِنِّ
u'نَجَاسَةٌ سُؤْرٌ':Added, #1: 1	نَجَاسَةِ السُّؤْرِ
u'نَجَاسَةٌ سُؤْرٌ':Added, #1: 1	نَجَاسَةُ سُؤْرِ
u'نَجَاسَةٌ سُؤْرٌ':Added, #1: 1	نَجَاسَةُ سُؤْرِهِ
u'نَجَاسَةٌ سُؤْرٌ':Added, #2: 2	نَجَاسَةَ سُؤْرِ
u'نَجَاسَةٌ سُؤْرٌ':Added, #2: 2	نَجَاسَةِ سُؤْرِ
u'نَجَاسَةٌ سُؤْرٌ':Added, #3: 3	نَجَاسَةِ سُؤْرِهِ
u'نَجَاسَةٌ سُؤْرٌ':Added, #4: 4	نَجَاسَةَ السُّؤْرِ
u'نَجَاسَةٌ شَارِعٌ':Added, #5: 5	نَجَاسَةُ السُّؤْرِ
u'نَجَاسَةٌ شَعْرٌ':Added, #1: 1	نَجَاسَةُ الشَّارِعِ
u'نَجَاسَةٌ شَعْرٌ':Added, #1: 1	نَجَاسَةُ شَعْرِ
u'نَجَاسَةٌ شَيْءٌ':Added, #2: 2	نَجَاسَةِ شَعْرِ
u'نَجَاسَةٌ شَيْءٌ':Added, #1: 1	نَجَاسَةَ شَيْءٍ
u'نَجَاسَةٌ طَاهِرٌ':Added, #1: 1	نَجَاسَةِ شَيْءٍ
u'نَجَاسَةٌ طُرُقٌ':Added, #3: 3	نَجَاسَةِ طَاهِرٍ
u'نَجَاسَةٌ طِينٌ':Added, #1: 1	نَجَاسَةِ الطُّرُقِ
u'نَجَاسَةٌ طِينٌ':Added, #1: 1	نَجَاسَةَ الطِّينِ
u'نَجَاسَةٌ طِينٌ':Added, #1: 1	نَجَاسَةَ طِينِ
u'نَجَاسَةٌ ظاهِرٌ':Added, #2: 2	نَجَاسَةُ طِينِ
u'نَجَاسَةٌ ظاهِرَة':Added, #2: 2	نَجَاسَةٍ ظَاهِرَةٍ
u'نَجَاسَةٌ عَرَقٌ':Added, #2: 2	نَجَاسَةٍ ظَاهِرَةٍ
u'نَجَاسَةٌ عَصَبٌ':Added, #1: 1	نَجَاسَةِ الْعَرَقِ
u'نَجَاسَةٌ عُضْوٌ':Added, #1: 1	نَجَاسَةِ الْعَصَبِ
u'نَجَاسَةٌ عَظْمٌ':Added, #1: 1	نَجَاسَةِ الْعُضْوِ
u'نَجَاسَةٌ عين':Added, #3: 3	نَجَاسَةِ عَظْمٍ
u'نَجَاسَةٌ عَيْنٌ':Added, #1: 1	نَجَاسَةِ الْعَيْنِ
u'نَجَاسَةٌ عَيْن':Added, #1: 1	نَجَاسَةِ الْعَيْنِ
u'نَجَاسَةٌ عين':Added, #1: 1	نَجَاسَةِ الْعَيْنِ
u'نَجَاسَةٌ عَيْنٌ':Added, #1: 1	نَجَاسَةِ عَيْنِ
u'نَجَاسَةٌ عَيْن':Added, #1: 1	نَجَاسَةِ عَيْنِ
u'نَجَاسَةٌ عين':Added, #1: 1	نَجَاسَةِ عَيْنِ
u'نَجَاسَةٌ عَيْنٌ':Added, #2: 2	نَجَاسَةُ عَيْنِهِ
u'نَجَاسَةٌ عَيْن':Added, #2: 2	نَجَاسَةُ عَيْنِهِ
u'نَجَاسَةٌ عين':Added, #2: 2	نَجَاسَةُ عَيْنِهِ
u'نَجَاسَةٌ عَيْنٌ':Added, #3: 3	نَجَاسَةَ الْعَيْنِ
u'نَجَاسَةٌ عَيْن':Added, #3: 3	نَجَاسَةَ الْعَيْنِ
u'نَجَاسَةٌ عين':Added, #3: 3	نَجَاسَةَ الْعَيْنِ
u'نَجَاسَةٌ عين':Added, #3: 3	نَجَاسَةَ عَيْنِهِ
u'نَجَاسَةٌ عَيْنٌ':Added, #3: 3	نَجَاسَةِ عَيْنِهِ
u'نَجَاسَةٌ عَيْنٌ':Added, #3: 3	نَجَاسَةَ عَيْنِهِ
u'نَجَاسَةٌ عَيْن':Added, #3: 3	نَجَاسَةِ عَيْنِهِ
u'نَجَاسَةٌ عَيْن':Added, #3: 3	نَجَاسَةَ عَيْنِهِ
u'نَجَاسَةٌ عَيْنِيَّةٌ':Added, #3: 3	نَجَاسَةِ عَيْنِهِ
u'نَجَاسَةٌ غَسْلٌ':Added, #1: 1	نَجَاسَةٍ عَيْنِيَّةٍ
u'نَجَاسَةٌ غير':Added, #1: 1	نَجَاسَةُ غَسْلٍ
u'نَجَاسَةٌ غَيْرٌ':Added, #1: 1	نَجَاسَةِ غَيْرِ
u'نَجَاسَةٌ غير':Added, #1: 1	نَجَاسَةِ غَيْرِ
u'نَجَاسَةٌ غَيْرٌ':Added, #1: 1	نَجَاسَةِ غَيْرِهِ
u'نَجَاسَةٌ غير':Added, #1: 1	نَجَاسَةِ غَيْرِهِ
u'نَجَاسَةٌ غَيْرٌ':Added, #2: 2	نَجَاسَةَ غَيْرِ
u'نَجَاسَةٌ فَاحِشٌ':Added, #2: 2	نَجَاسَةَ غَيْرِ
u'نَجَاسَةٌ فَأْرٌ':Added, #2: 2	نَجَاسَةٍ فَاحِشَةٍ
u'نَجَاسَةٌ فَأْرٌ':Added, #1: 1	نَجَاسَةُ الْفَأْرَةِ
u'نَجَاسَةٌ فَمٌ':Added, #2: 2	نَجَاسَةُ فَأْرَةٍ
u'نَجَاسَةٌ فَمٌ':Added, #1: 1	نَجَاسَةِ الْفَمِ
u'نَجَاسَةٌ فَمٌ':Added, #1: 1	نَجَاسَةِ فَمِ
u'نَجَاسَةٌ فَمٌ':Added, #1: 1	نَجَاسَةُ فَمِهِ
u'نَجَاسَةٌ فَمٌ':Added, #1: 1	نَجَاسَةِ فَمِهِ
u'نَجَاسَةٌ قَيْءٌ':Added, #2: 2	نَجَاسَةُ الْفَمِ
u'نَجَاسَةٌ قَيْءٌ':Added, #1: 1	نَجَاسَةَ الْقَيْءِ
u'نَجَاسَةٌ كَلْبٌ':Added, #2: 2	نَجَاسَةِ الْقَيْءِ
u'نَجَاسَةٌ كَلْبٌ':Added, #11: 11	نَجَاسَةِ الْكَلْبِ
u'نَجَاسَةٌ كَلْبٌ':Added, #1: 1	نَجَاسَةَ الْكَلْبِ
u'نَجَاسَةٌ كَلْبٌ':Added, #2: 2	نَجَاسَةُ كَلْبٍ
u'نَجَاسَةٌ لبن':Added, #4: 4	نَجَاسَةُ الْكَلْبِ
u'نَجَاسَةٌ لَبَنٌ':Added, #1: 1	نَجَاسَةَ لَبَنِهِ
u'نَجَاسَةٌ لبن':Added, #1: 1	نَجَاسَةَ لَبَنِهِ
u'نَجَاسَةٌ لَبَنٌ':Added, #2: 2	نَجَاسَةِ لَبَنِ
u'نَجَاسَةٌ لَحْمٌ':Added, #2: 2	نَجَاسَةِ لَبَنِ
u'نَجَاسَةٌ لَحْمٌ':Added, #1: 1	نَجَاسَةَ اللَّحْمِ
u'نَجَاسَةٌ لَحْمٌ':Added, #1: 1	نَجَاسَةُ اللَّحْمِ
u'نَجَاسَةٌ لَحْمٌ':Added, #1: 1	نَجَاسَةُ لَحْمِهِ
u'نَجَاسَةٌ لَحْمٌ':Added, #2: 2	نَجَاسَةِ اللَّحْمِ
u'نَجَاسَةٌ لَحْمٌ':Added, #2: 2	نَجَاسَةِ لَحْمِهِ
u'نَجَاسَةٌ لعاب':Added, #3: 3	نَجَاسَةَ لَحْمِهِ
u'نَجَاسَةٌ لُعَابٌ':Added, #1: 1	نَجَاسَةِ اللُّعَابِ
u'نَجَاسَةٌ مَاءٌ':Added, #1: 1	نَجَاسَةِ اللُّعَابِ
u'نَجَاسَةٌ مَاءٌ':Added, #1: 1	نَجَاسَةُ مَاءٍ
u'نَجَاسَةٌ مَاءٌ':Added, #24: 24	نَجَاسَةِ الْمَاءِ
u'نَجَاسَةٌ مَاءٌ':Added, #3: 3	نَجَاسَةَ مَاءٍ
u'نَجَاسَةٌ مَاءٌ':Added, #5: 5	نَجَاسَةُ الْمَاءِ
u'نَجَاسَةٌ مَالٌ':Added, #6: 6	نَجَاسَةَ الْمَاءِ
u'نَجَاسَةٌ مَانِعٌ':Added, #1: 1	نَجَاسَةِ الْمَالِ
u'نَجَاسَةٌ مَائِعٌ':Added, #1: 1	نَجَاسَةٍ مَانِعَةٍ
u'نَجَاسَةٌ مُتَيَقِّن':Added, #2: 2	نَجَاسَةٍ مَائِعَةٍ
u'نَجَاسَةٌ مُحَرَّمٌ':Added, #1: 1	نَجَاسَةٍ مُتَيَقِّنَةٍ
u'نَجَاسَةٌ مَحَلٌّ':Added, #1: 1	نَجَاسَةِ الْمُحَرَّمِ
u'نَجَاسَةٌ مَحَلٌّ':Added, #1: 1	نَجَاسَةَ الْمَحَلِّ
u'نَجَاسَةٌ مَحَلٌّ':Added, #1: 1	نَجَاسَةِ الْمَحَلِّ
u'نَجَاسَةٌ مَخْرَجٌ':Added, #2: 2	نَجَاسَةَ مَحَلِّ
u'نَجَاسَةٌ مزال':Added, #2: 2	نَجَاسَةِ الْمَخْرَجِ
u'نَجَاسَةٌ مُسْتَعْمَلٌ':Added, #1: 1	نَجَاسَةِ الْمُزَالِ
u'نَجَاسَةٌ مِسْكٌ':Added, #1: 1	نَجَاسَةِ الْمُسْتَعْمَلِ
u'نَجَاسَةٌ مُشْرِك':Added, #1: 1	نَجَاسَةُ الْمِسْكِ
u'نَجَاسَةٌ مُصَابٌ':Added, #1: 1	نَجَاسَةُ الْمُشْرِكِ
u'نَجَاسَةٌ مُصِيبٌ':Added, #1: 1	نَجَاسَةِ مُصَابِ
u'نَجَاسَةٌ مَعْذُورٌ':Added, #1: 1	نَجَاسَةِ الْمُصِيبِ
u'نَجَاسَةٌ مُمَاسَّةٌ':Added, #1: 1	نَجَاسَةِ الْمَعْذُورِ
u'نَجَاسَةٌ مُنَجِّس':Added, #1: 1	نَجَاسَةٍ مُمَاسَّةٍ
u'نَجَاسَةٌ مُنْفَصِلٌ':Added, #1: 1	نَجَاسَةٍ مُنَجِّسَةٍ
u'نَجَاسَةٌ مَنِيٌّ':Added, #6: 6	نَجَاسَةِ الْمُنْفَصِلِ
u'نَجَاسَةٌ مَنِيٌّ':Added, #2: 2	نَجَاسَةُ الْمَنِيِّ
u'نَجَاسَةٌ مَوْتٌ':Added, #3: 3	نَجَاسَةِ الْمَنِيِّ
u'نَجَاسَةٌ مُؤَثِّرٌ':Added, #1: 1	نَجَاسَةِ الْمَوْتِ
u'نَجَاسَةٌ مَوْضِعٌ':Added, #1: 1	نَجَاسَةٍ مُؤَثِّرَةٍ
u'نَجَاسَةٌ مَيْتٌ':Added, #1: 1	نَجَاسَةُ مَوْضِعِ
u'نَجَاسَةٌ مَيْتٌ':Added, #1: 1	نَجَاسَةَ الْمَيْتَةِ
u'نَجَاسَةٌ مَيْتٌ':Added, #1: 1	نَجَاسَةِ مَيْتَةِ
u'نَجَاسَةٌ مَيْتَةٌ':Added, #2: 2	نَجَاسَةَ الْمَيْتَاتِ
u'نَجَاسَةٌ مَيْتَةٌ':Added, #1: 1	نَجَاسَةَ الْمَيْتَةِ
u'نَجَاسَةٌ مَيْتَةٌ':Added, #1: 1	نَجَاسَةِ مَيْتَةِ
u'نَجَاسَةٌ نَادِرٌ':Added, #2: 2	نَجَاسَةَ الْمَيْتَاتِ
u'نَجَاسَةٌ نَادِرَةٌ':Added, #1: 1	نَجَاسَةٍ نَادِرَةٍ
u'نَجَاسَةٌ هِرٌّ':Added, #1: 1	نَجَاسَةٍ نَادِرَةٍ
u'نَجَاسَةٌ وَجْهٌ':Added, #2: 2	نَجَاسَةِ الْهِرَّةِ
u'نَجَاسَةٌ يَابِسٌ':Added, #2: 2	نَجَاسَةِ وَجْهِ
u'نَجَاسَةٌ يَدٌ':Added, #2: 2	نَجَاسَةٍ يَابِسَةٍ
u'نَجَا قَالٌ':Predicate, #1: 1	نَجَاسَةِ الْيَدِ
u'نَجَحَ قَالٌ':Predicate, #1: 1	نَجَا قَالَ
u'نَجِدَ أَلْوَانٌ':Predicate, #1: 1	أَنْجَحَ قَالَ
u'نَجْدَةٌ شَاعِر':Added, #1: 1	نَجِدَ الْأَلْوَانَ
u'نَجْدٌ مُقَدَّمٌ':Added, #1: 1	نَجْدَةَ الشَّاعِرِ
u'نَجْدٌ مُقَدَّمٌ':Added, #1: 1	نَجْدُ الْمُقَدّمِ
u'نَجْدٌ مُقَدِّمٌ':Added, #1: 1	نَجْدِ الْمُقَدّمِ
u'نَجْدٌ مُقَدِّمٌ':Added, #1: 1	نَجْدُ الْمُقَدّمِ
u'نَجْرٌ خَشَبٌ':Added, #1: 1	نَجْدِ الْمُقَدّمِ
u'نَجَرَ خَشَبَةٌ':Predicate, #1: 1	نَجْرِ الْخَشَبِ
u'نَجَرَ وَجْهٌ':Predicate, #1: 1	نَجَرَ الْخَشَبَةَ
u'نَجَّزَ أقَلُّ':Predicate, #2: 2	نَجَرَ وَجْهَ
u'نَجَّزَ تَخْيِيرٌ':Predicate, #1: 1	نَجَّزَ أَقَلَّ
u'نَجَّزَ ثَلاثُ':Predicate, #1: 1	نَجَّزَ التَّخْيِيرَ
u'نَجَزَ خُلْعٌ':Subject, #2: 2	نَجَّزَ الثَّلَاثَ
u'نَجَزَ سَبَبٌ':Predicate, #1: 1	نَجَزَ الْخُلْعُ
u'نَجَزَ طَلاَقٌ':Predicate, #1: 1	نَجَزَ السَّبَبَ
u'نَجَّزَ طَلاَقٌ':Predicate, #1: 1	نَجَزَ الطَّلَاقَ
u'نَجَّزَ ظهار':Predicate, #5: 5	نَجَّزَ الطَّلَاقَ
u'نَجَّزَ عتق':Predicate, #1: 1	نَجَّزَ الظِّهَارَ
u'نَجَّزَ عِتْقٌ':Predicate, #4: 4	نَجَّزَ الْعِتْقَ
u'نَجَزَ عتق':Subject, #4: 4	نَجَّزَ الْعِتْقَ
u'نَجَزَ عِتْقٌ':Subject, #1: 1	نَجَزَ عِتْقُ
u'نَجَزَ عتق':Subject, #1: 1	نَجَزَ عِتْقُ
u'نَجَزَ عِتْقٌ':Subject, #1: 1	نَجَزَ عِتْقُهُ
u'نَجَّزَ كَفَالَةٌ':Predicate, #1: 1	نَجَزَ عِتْقُهُ
u'نَجَّزَ نذر':Predicate, #1: 1	نَجَّزَ الْكَفَالَةَ
u'نَجَّزَ نَذْرٌ':Predicate, #1: 1	نَجَّزَ النَّذْرَ
u'نَجَزَ واحد':Predicate, #1: 1	نَجَّزَ النَّذْرَ
u'نَجَزَ وَاحِدٌ':Predicate, #1: 1	نَجَزَ وَاحِدَةً
u'نَجِزَ وَقْفٌ':Predicate, #1: 1	نَجَزَ وَاحِدَةً
u'نَجُسَ بَوْلٌ':Subject, #1: 1	أَنْجَزَ الْوَقْفَ
u'نَجَّسَ بِئْرٌ':Predicate, #2: 2	نَجُسَ بَوْلُ
u'نَجَّسَ ثَوْبٌ':Predicate, #2: 2	نَجَّسَ الْبِئْرَ
u'نَجَّسَ جَمِيع':Predicate, #1: 1	نَجَّسَ ثَوْبَ
u'نَجُسَ دُخَّان':Subject, #1: 1	نَجَّسَ الْجَمِيعَ
u'نَجَسٌ رَطْبٌ':Added, #1: 1	نَجُسَ دُخَّانُهُ
u'نَجَسٌ عين':Added, #1: 1	نَجَسٍ رَطْبٍ
u'نَجَسٌ عَيْنٌ':Added, #3: 3	نَجَسَ الْعَيْنِ
u'نَجَسٌ عَيْن':Added, #3: 3	نَجَسَ الْعَيْنِ
u'نَجَسٌ عين':Added, #3: 3	نَجَسَ الْعَيْنِ
u'نَجَسٌ عين':Added, #4: 4	نَجَسُ الْعَيْنِ
u'نَجَسٌ عَيْنٌ':Added, #4: 4	نَجَسِ الْعَيْنِ
u'نَجَسٌ عَيْنٌ':Added, #4: 4	نَجَسُ الْعَيْنِ
u'نَجَسٌ عَيْن':Added, #4: 4	نَجَسِ الْعَيْنِ
u'نَجَسٌ عَيْن':Added, #4: 4	نَجَسُ الْعَيْنِ
u'نَجِسَ مَاءٌ':Subject, #4: 4	نَجَسِ الْعَيْنِ
u'نَجَسٌ مُغَلَّظ':Added, #1: 1	نَجِسَ الْمَاءُ
u'نَجَّسَ وَرَقَةٌ':Predicate, #1: 1	نَجَسٍ مُغَلَّظٍ
u'نجل هَاشِمٌ':Added, #1: 1	نَجَّسَ وَرَقَةَ
u'نَجْلٌ هَاشِمٌ':Added, #1: 1	نَجْلِ هَاشِمٍ
u'نَجْمٌ أئِمَّةٌ':Added, #1: 1	نَجْلِ هَاشِمٍ
u'نَجْمٌ أئِمَّةٌ':Added, #2: 2	نَجْمَ الْأَئِمَّةِ
u'نَجْمٌ أئِمَّةٌ':Added, #5: 5	نَجْمِ الْأَئِمَّةِ
u'نَجْمٌ دَيْنٌ':Added, #9: 9	نَجْمُ الْأَئِمَّةِ
u'نَجْمٌ دِينٌ':Added, #1: 1	نَجْمَ الدَّيْنِ
u'نَجْمٌ دِينٌ':Added, #20: 20	نَجْمِ الدِّينِ
u'نَجْمٌ دِينٌ':Added, #4: 4	نَجْمَ الدِّينِ
u'نَجْمٌ سَمَاءٌ':Added, #92: 92	نَجْمُ الدِّينِ
u'نَجْمٌ سنن':Added, #1: 1	نَجْمُ السَّمَاءِ
u'نَجْمٌ كِتَابَةٌ':Added, #1: 1	نَجْمُ السُّنَنِ
u'نَجْمٌ كِتَابَةٌ':Added, #1: 1	نَجْمُ الْكِتَابَةِ
u'نَجَمَ مُبْتَدِعٌ':Subject, #3: 3	نَجْمِ كِتَابَةٍ
u'نَجَمَ نِفَاقٌ':Subject, #1: 1	نَجَمَ مُبْتَدِعٌ
u'نَجْمٌ واحد':Added, #1: 1	نَجَمَ نِفَاقُهُ
u'نَجْمٌ وَاحِدٌ':Added, #4: 4	نَجْمٍ وَاحِدٍ
u'نَجْمٌ وَاطِئٌ':Added, #4: 4	نَجْمٍ وَاحِدٍ
u'نُجُومٌ أَبٌ':Added, #2: 2	نَجْمِ الْوَاطِئِ
u'نُجُومٌ أُمٌّ':Added, #2: 2	نُجُومِ الْأَبِ
u'نُجُومٌ أُمٌّ':Added, #1: 1	نُجُومِ أُمِّهِ
u'نُجُومٌ سَمَاءٌ':Added, #5: 5	نُجُومِ الْأُمِّ
u'نُجُومٌ سَمَاءٌ':Added, #1: 1	نُجُومِ السّمَاءِ
u'نُجُومٌ سَمَاءٌ':Added, #1: 1	نُجُومُ سَمَاءٍ
u'نُجُومٌ ظَلامٌ':Added, #9: 9	نُجُومِ السَّمَاءِ
u'نُجُومٌ فَاسِدٌ':Added, #1: 1	نُجُومُ ظَلَامٍ
u'نُجُومٌ كِتَابَةٌ':Added, #1: 1	نُجُومِ الْفَاسِدَةِ
u'نُجُومٌ كِتَابَةٌ':Added, #1: 1	نُجُومِ كِتَابَةِ
u'نُجُومٌ كِتَابَةٌ':Added, #1: 1	نُجُومُ كِتَابَتِهِ
u'نُجُومٌ كِتَابَةٌ':Added, #23: 23	نُجُومِ الْكِتَابَةِ
u'نُجُومٌ كِتَابَةٌ':Added, #2: 2	نُجُومُ الْكِتَابَةِ
u'نُجُومٌ كِتَابَةٌ':Added, #2: 2	نُجُومِ كِتَابَتِهِ
u'نُجُومٌ لَيْلٌ':Added, #8: 8	نُجُومَ الْكِتَابَةِ
u'نُجُومٌ نَاسٌ':Added, #2: 2	نُجُومَ اللَّيْلِ
u'نَجْوَى ثَلاثَةٌ':Added, #1: 1	نُجُومَ النَّاسِ
u'نَجَّى فَاطِمٌ':Predicate, #1: 1	نَجْوَى ثَلَاثَةٍ
u'نَحَا اِبْنٌ':Subject, #1: 1	نَجَّى فَاطِمَةَ
u'نَحَا تونِسِيّ':Subject, #1: 1	نَحَا ابْنُ
u'نَحَا طَبَرِيّ':Subject, #1: 1	نَحَا التُّونِسِيُّ
u'نَحَا فلان':Subject, #1: 1	نَحَا الطَّبَرِيُّ
u'نَحْتٌ تُرَابٌ':Added, #1: 1	نَحَا الطَّبَرِيُّ
u'نَحَتَ حِجارَةٌ':Predicate, #1: 1	نَحْتَ التُّرَابِ
u'نَحَرَ إِبِلٌ':Predicate, #1: 1	نَحَتَ الْحِجَارَةَ
u'نَحْرٌ إِبِلٌ':Added, #2: 2	نَحَرَ الْإِبِلَ
u'نَحْرٌ إِبِلٌ':Added, #1: 1	نَحْرِ الْإِبِلِ
u'نَحْرٌ إِبِلٌ':Added, #2: 2	نَحْرِ الإِبِلِ
u'نَحْرٌ أحَدٌ':Added, #2: 2	نَحْرُ الْإِبِلِ
u'نَحَرَ أُمٌّ':Predicate, #1: 1	نَحْرَ أَحَدِ
u'نَحْرٌ إمَامٌ':Added, #1: 1	نَحَرَ الْأُمَّ
u'نَحْرٌ إمَامٌ':Added, #1: 1	نَحْرِ الإِمَامِ
u'نَحْرٌ إمَامٌ':Added, #1: 1	نَحْرَ الْإِمَامِ
u'نَحَرَ أَوَّلُ':Predicate, #3: 3	نَحْرِ الْإِمَامِ
u'نَحْرٌ أَوَّلُ':Added, #2: 2	نَحَرَ الْأَوَّلَ
u'نَحَرَ بَدَلٌ':Predicate, #1: 1	نَحْرُ أَوَّلِ
u'نَحْرٌ بَدَلٌ':Added, #1: 1	نَحَرَ الْبَدَلَ
u'نَحْرٌ بَدَلٌ':Added, #1: 1	نَحْرِ بَدَلِهِ
u'نَحَرَ بدن':Predicate, #2: 2	نَحْرِ الْبَدَلِ
u'نَحَرَ بُدْنٌ':Predicate, #1: 1	نَحَرَ الْبُدْنَ
u'نَحْرٌ بدن':Added, #1: 1	نَحَرَ الْبُدْنَ
u'نَحْرٌ بُدْنٌ':Added, #4: 4	نَحْرُ الْبُدْنِ
u'نَحَرَ بَعْضٌ':Predicate, #4: 4	نَحْرُ الْبُدْنِ
u'نَحْرٌ بَعْضٌ':Added, #3: 3	نَحَرَ بَعْضَ
u'نَحَرَ ثَلاثُ':Predicate, #2: 2	نَحْرِ بَعْضِ
u'نَحْرٌ ثَوْرٌ':Added, #4: 4	نَحَرَ ثَلاَثَ
u'نَحْرٌ جَزُورٌ':Added, #1: 1	نَحْرِ الثّوْرِ
u'نَحْرٌ جَزُورٌ':Added, #1: 1	نَحْرُ الْجَزُورِ
u'نَحَرَ حاجٌّ':Subject, #1: 1	نَحْرَ جَزُورٍ
u'نَحْرٌ حُرٌّ':Added, #1: 1	نَحَرَ الْحَاجُّ
u'نَحَرَ خَمْسٌ':Predicate, #1: 1	نَحْرَ حُرٍّ
u'نَحَرَ رَسُولٌ':Subject, #1: 1	نَحَرَ خَمْسَ
u'نَحْرٌ رَسُولٌ':Added, #6: 6	نَحَرَ رَسُولُ
u'نَحَرَ شَاةٌ':Predicate, #1: 1	نَحْرِ رَسُولِ
u'نَحْرٌ ظَهيرٌ':Added, #1: 1	نَحَرَ الشَّاةَ
u'نَحْرٌ ظَهيرٌ':Added, #1: 1	نَحْرَ الظّهِيرَةِ
u'نَحْرٌ ظَهيرٌ':Added, #2: 2	نَحْرِ الظَّهِيرَةِ
u'نَحْرٌ ظَهيرَةٌ':Added, #3: 3	نَحْرِ الظّهِيرَةِ
u'نَحْرٌ ظَهيرَةٌ':Added, #1: 1	نَحْرَ الظّهِيرَةِ
u'نَحْرٌ ظَهيرَةٌ':Added, #2: 2	نَحْرِ الظَّهِيرَةِ
u'نَحَرَ عَامٌ':Predicate, #3: 3	نَحْرِ الظّهِيرَةِ
u'نَحْرٌ عَدُوٌّ':Added, #1: 1	نَحَرَ عَامَ
u'نَحْرٌ غير':Added, #5: 5	نَحْرِ الْعَدُوِّ
u'نَحْرٌ غَيْرٌ':Added, #1: 1	نَحْرُ غَيْرِهِ
u'نَحْرٌ فُلاَنٌ':Added, #1: 1	نَحْرُ غَيْرِهِ
u'نَحْرٌ فُلاَنٌ':Added, #1: 1	نَحْرِ فُلَانٍ
u'نَحَرَ فِيلٌ':Predicate, #2: 2	نَحْرُ فُلَانٍ
u'نَحْرٌ مُهْرٌ':Added, #1: 1	نَحَرَ الْفِيلَ
u'نَحْرٌ نَفْسٌ':Added, #1: 1	نَحْرِ مُهْرِهِ
u'نَحَرَ هَدْيٌ':Predicate, #1: 1	نَحْرَ نَفْسِهِ
u'نَحْرٌ هَدْيٌ':Added, #4: 4	نَحَرَ الْهَدْيَ
u'نَحْرٌ هَدْيٌ':Added, #1: 1	نَحْرِ الْهَدْيِ
u'نَحْرٌ ولد':Added, #1: 1	نَحْرُ هَدْيٍ
u'نَحْرٌ وَلَدٌ':Added, #1: 1	نَحْرِ وَلَدِهِ
u'نَحْسٌ مُسْتَمِرٌّ':Added, #1: 1	نَحْرِ وَلَدِهِ
u'نَحَلَ بَعْضٌ':Predicate, #2: 2	نَحْسٍ مُسْتَمِرٍّ
u'نَحَلَ عَائِشٌ':Predicate, #1: 1	نَحَلَ بَعْضَ
u'نَحَلَ وَالِدٌ':Subject, #1: 1	نَحَلَ عَائِشَةَ
u'نَحْوٌ أَبٌ':Added, #4: 4	نَحَلَ وَالِدٌ
u'نَحْوٌ أَبٌ':Added, #1: 1	نَحْو الْأَبِ
u'نَحْوٌ أَبٌ':Added, #1: 1	نَحْوَ الْأَبِ
u'نَحْوٌ إِبَانَةٌ':Added, #1: 1	نَحْوِ الْأَبِ
u'نَحْوٌ إِبْرِيقٌ':Added, #1: 1	نَحْوَ الْإِبَانَةِ
u'نَحْوٌ اِبْنٌ':Added, #1: 1	نَحْوِ إبْرِيقٍ
u'نَحْوٌ اِبْنٌ':Added, #1: 1	نَحْوُ ابْنِ
u'نَحْوٌ اِبْنٌ':Added, #1: 1	نَحْوِ ابْنِ
u'نَحْوٌ اِبْنٌ':Added, #1: 1	نَحْوَ ابْنِهِ
u'نَحْوٌ اِبْنٌ':Added, #1: 1	نَحْوِ ابْنِهِ
u'نَحْوٌ إِتْلاَفٌ':Added, #2: 2	نَحْوَ ابْنِ
u'نَحْوٌ إجَارَةٌ':Added, #1: 1	نَحْوِ إتْلَافِ
u'نَحْوٌ إجَارَةٌ':Added, #1: 1	نَحْوَ إجَارَتِهِ
u'نَحْوٌ إجَازَةٌ':Added, #1: 1	نَحْوِ الْإِجَارَةِ
u'نَحْوٌ أَجْذَم':Added, #1: 1	نَحْوِ إجَازَتِهِ
u'نَحْوٌ أُجْرَةٌ':Added, #1: 1	نَحْوِ الْأَجْذَمِ
u'نَحْوٌ أحَدٌ':Added, #1: 1	نَحْوِ أُجْرَةٍ
u'نَحْوٌ أحَدٌ':Added, #1: 1	نَحْوُ أَحَدٍ
u'نَحْوٌ أَخٌ':Added, #2: 2	نَحْوِ أَحَدِ
u'نَحْوٌ أَخٌ':Added, #2: 2	نَحْوَ الْأَخِ
u'نَحْوٌ أَخٌ':Added, #2: 2	نَحْوُ الْأَخِ
u'نَحْوٌ إِخْبَارٌ':Added, #2: 2	نَحْوِ الْأَخِ
u'نَحْوٌ إِخْبَارٌ':Added, #1: 1	نَحْوِ إخْبَارِ
u'نَحْوٌ أُخْتٌ':Added, #1: 1	نَحْوُ الْإِخْبَارِ
u'نَحْوٌ أخْذٌ':Added, #1: 1	نَحْوَ الْأُخْتِ
u'نَحْوٌ آخِرَةٌ':Added, #1: 1	نَحْوِ أَخْذِ
u'نَحْوٌ أخْلاقٌ':Added, #1: 1	نَحْوُ آخِرَةِ
u'نَحْوٌ أَخْلاَقٌ':Added, #1: 1	نَحْوِ أَخْلَاقِ
u'نَحْوٌ أُخُوَّةٌ':Added, #1: 1	نَحْوِ أَخْلَاقِ
u'نَحْوٌ إِخْوَةٌ':Added, #1: 1	نَحْوِ أُخُوَّةٍ
u'نَحْوٌ أدَب':Added, #1: 1	نَحْوَ الْإِخْوَةِ
u'نَحْوٌ أَذَانٌ':Added, #1: 1	نَحْوِ أَدَبِ
u'نَحْوٌ إِذْنٌ':Added, #1: 1	نَحْوَ الْأَذَانِ
u'نَحْوٌ إِرَادَةٌ':Added, #1: 1	نَحْوِ الْإِذْنِ
u'نَحْوٌ إِرَاقَةٌ':Added, #1: 1	نَحْوِ إرَادَةِ
u'نَحْوٌ أَرْبَعُ':Added, #1: 1	نَحْوِ إرَاقَةِ
u'نَحْوٌ أَرْبَعُ':Added, #1: 1	نَحْوُ أَرْبَعِ
u'نَحْوٌ أَرْبَعُ':Added, #1: 1	نَحْوُ الْأَرْبَعِ
u'نَحْوٌ أَرْبَعَةٌ':Added, #2: 2	نَحْوَ أَرْبَعِ
u'نَحْوٌ أَرْبَعَةٌ':Added, #1: 1	نَحْوَ أَرْبَعَةِ
u'نَحْوٌ أَرْبَعَةٌ':Added, #1: 1	نَحْوُ أَرْبَعَةِ
u'نَحْوٌ إِرْثٌ':Added, #1: 1	نَحْوِ أَرْبَعَةٍ
u'نَحْوٌ إِرْثٌ':Added, #2: 2	نَحْوِ إرْثٍ
u'نَحْوٌ أرْضٌ':Added, #2: 2	نَحْوَ الْإِرْثِ
u'نَحْوٌ أرْضٌ':Added, #1: 1	نَحْوِ أَرْضٍ
u'نَحْوٌ أرْضٌ':Added, #1: 1	نَحْوَ الأَرْضِ
u'نَحْوٌ أرْضٌ':Added, #1: 1	نَحْوِ الْأَرْضِ
u'نَحْوٌ أرْضٌ':Added, #2: 2	نَحْوَ أَرْضٍ
u'نَحْوٌ أَرَضَةٌ':Added, #3: 3	نَحْوَ أَرْضِ
u'نَحْوٌ إِزَارٌ':Added, #1: 1	نَحْوِ الْأَرَضَةِ
u'نَحْوٌ إِزَالَةٌ':Added, #1: 1	نَحْوِ الْإِزَارِ
u'نَحْوٌ أَزْهَر':Added, #1: 1	نَحْوِ إزَالَةٍ
u'نَحْوٌ أسَاسٌ':Added, #1: 1	نَحْوِ الْأَزْهَرِ
u'نَحْوٌ أَسَاسٌ':Added, #1: 1	نَحْوَ أَسَاسِ
u'نَحْوٌ أَساكِفَةٌ':Added, #1: 1	نَحْوَ أَسَاسِ
u'نَحْوٌ أَسالِيبُ':Added, #1: 1	نَحْوُ الْأَسَاكِفَةِ
u'نَحْوٌ اِسْتِدَامَةٌ':Added, #1: 1	نَحْوِ أَسَالِيبِ
u'نَحْوٌ اِسْتِغْرَاقٌ':Added, #1: 1	نَحْوِ اسْتِدَامَةِ
u'نَحْوٌ أَسَدٌ':Added, #1: 1	نَحْوِ اسْتِغْرَاقِهِ
u'نَحْوٌ إِسْراءٌ':Added, #1: 1	نَحْوُ الْأَسَدِ
u'نَحْوٌ اِسْمٌ':Added, #2: 2	نَحْوِ الْإِسْرَاءِ
u'نَحْوٌ إِسْنادٌ':Added, #2: 2	نَحْوَ اسْمِ
u'نَحْوٌ أَصابِعُ':Added, #1: 1	نَحْوَ إِسْنَادِ
u'نَحْوٌ إِصْبَعٌ':Added, #1: 1	نَحْوِ الْأَصَابِعِ
u'نَحْوٌ أَصْحَابٌ':Added, #1: 1	نَحْوُ الْإِصْبَعِ
u'نَحْوٌ أَصْحَابٌ':Added, #1: 1	نَحْوِ أَصْحَابِ
u'نَحْوٌ إضافَةٌ':Added, #1: 1	نَحْوَ أَصْحَابِهِ
u'نَحْوٌ أَطْفَالٌ':Added, #1: 1	نَحْوِ إضَافَةِ
u'نَحْوٌ إِطْلاقٌ':Added, #1: 1	نَحْوِ أَطْفَالِهِ
u'نَحْوٌ أَطْنَابٌ':Added, #1: 1	نَحْوِ إطْلَاقِ
u'نَحْوٌ أعْرَج':Added, #1: 1	نَحْوَ أَطْنَابٍ
u'نَحْوٌ إعْلاَمٌ':Added, #1: 1	نَحْوَ الْأَعْرَجِ
u'نَحْوٌ أعْوَر':Added, #1: 1	نَحْوَ الْإِعْلَامِ
u'نَحْوٌ إغْرَاقٌ':Added, #1: 1	نَحْوَ الْأَعْوَرِ
u'نَحْوٌ إِفْرَادٌ':Added, #1: 1	نَحْوَ إغْرَاقٍ
u'نَحْوٌ أَفْعَالٌ':Added, #1: 1	نَحْوِ إفْرَادِ
u'نَحْوٌ أفيُونٌ':Added, #1: 1	نَحْوَ أَفْعَالٍ
u'نَحْوٌ إقالَةٌ':Added, #2: 2	نَحْوِ الْأَفْيُونِ
u'نَحْوٌ إقْبالٌ':Added, #1: 1	نَحْوَ الْإِقَالَةِ
u'نَحْوٌ إقْرَارٌ':Added, #1: 1	نَحْوُ إقْبَالِهِ
u'نَحْوٌ إقْرَارٌ':Added, #1: 1	نَحْو الْإِقْرَارِ
u'نَحْوٌ إقْرَارٌ':Added, #1: 1	نَحْوُ الْإِقْرَارِ
u'نَحْوٌ أكفاء':Added, #1: 1	نَحْوِ الْإِقْرَارِ
u'نَحْوٌ أكل':Added, #1: 1	نَحْوَ الْأَكْفَاءِ
u'نَحْوٌ أَكْلٌ':Added, #1: 1	نَحْوِ أَكْلِ
u'نَحْوٌ أَكْلٌ':Added, #1: 1	نَحْوِ أَكْلٍ
u'نَحْوٌ أكل':Added, #1: 1	نَحْوِ أَكْلِ
u'نَحْوٌ أَكْلٌ':Added, #1: 1	نَحْوُ أَكْلِهِ
u'نَحْوٌ أكل':Added, #1: 1	نَحْوُ أَكْلِهِ
u'نَحْوٌ أَكْلٌ':Added, #1: 1	نَحْوِ الْأَكْلِ
u'نَحْوٌ اِلْتِقَاءٌ':Added, #1: 1	نَحْوِ الْأَكْلِ
u'نَحْوٌ ألْفٌ':Added, #1: 1	نَحْوِ الْتِقَاءِ
u'نَحْوٌ ألْفٌ':Added, #1: 1	نَحْوَ أَلْفٍ
u'نَحْوٌ أَلْفٌ':Added, #1: 1	نَحْوِ أَلْفٍ
u'نَحْوٌ أَلْفٌ':Added, #1: 1	نَحْوَ أَلْفٍ
u'نَحْوٌ ألف':Added, #1: 1	نَحْوِ أَلْفٍ
u'نَحْوٌ ألف':Added, #2: 2	نَحْوَ أَلْفِ
u'نَحْوٌ ألْفٌ':Added, #2: 2	نَحْوُ أَلْفِ
u'نَحْوٌ ألْفٌ':Added, #2: 2	نَحْوَ أَلْفِ
u'نَحْوٌ أَلْفٌ':Added, #2: 2	نَحْوُ أَلْفِ
u'نَحْوٌ أَلْفٌ':Added, #2: 2	نَحْوَ أَلْفِ
u'نَحْوٌ الْمَرْأَةُ':Added, #2: 2	نَحْوُ أَلْفِ
u'نَحْوٌ أُمٌّ':Added, #1: 1	نَحْوِ الْمَرْأَةِ
u'نَحْوٌ إمَامٌ':Added, #3: 3	نَحْوِ أُمِّ
u'نَحْوٌ إمَامٌ':Added, #1: 1	نَحْوِ إمَامِ
u'نَحْوٌ إمَامَةٌ':Added, #2: 2	نَحْوِ إمَامٍ
u'نَحْوٌ إمَامَةٌ':Added, #1: 1	نَحْوِ الْإِمَامَةِ
u'نَحْوٌ إمَامَةٌ':Added, #1: 1	نَحْوَ إمَامَةٍ
u'نَحْوٌ أمَةٌ':Added, #1: 1	نَحْوِ إمَامَةٍ
u'نَحْوٌ أَمْرٌ':Added, #1: 1	نَحْوِ أَمَةِ
u'نَحْوٌ أَمْرٌ':Added, #1: 1	نَحْوِ الْأَمْرِ
u'نَحْوٌ اِمْرَأَةٌ':Added, #1: 1	نَحْوُ أَمْرٍ
u'نَحْوٌ اِمْرَأَةٌ':Added, #1: 1	نَحْوِ امْرَأَةٍ
u'نَحْوٌ اِمْرَأَةٌ':Added, #1: 1	نَحْوُ امْرَأَتِهِ
u'نَحْوٌ أَميرٌ':Added, #2: 2	نَحْوَ امْرَأَةٍ
u'نَحْوٌ إِناءٌ':Added, #1: 1	نَحْوِ الْأَمِيرِ
u'نَحْوٌ إِناءٌ':Added, #1: 1	نَحْوَ الْإِنَاءِ
u'نَحْوٌ أنبياء':Added, #2: 2	نَحْوِ إنَاءٍ
u'نَحْوٌ اِنْتِقاصٌ':Added, #1: 1	نَحْوِ الْأَنْبِيَاءِ
u'نَحْوٌ إِنْسانٌ':Added, #1: 1	نَحْوِ انْتِقَاصٍ
u'نَحْوٌ أَنْفٌ':Added, #1: 1	نَحْوَ الْإِنْسَانِ
u'نَحْوٌ إِنْقَاذٌ':Added, #1: 1	نَحْوِ أَنْفِهِ
u'نَحْوٌ اِنْهِدامٌ':Added, #1: 1	نَحْوُ إنْقَاذِ
u'نَحْوٌ اِنْهِدامٌ':Added, #1: 1	نَحْوَ انْهِدَامِ
u'نَحْوٌ أهْلٌ':Added, #1: 1	نَحْوِ انْهِدَامٍ
u'نَحْوٌ أهْلٌ':Added, #1: 1	نَحْوَ أَهْلِ
u'نَحْوٌ أَوَّلُ':Added, #1: 1	نَحْوَ أَهْلِهِ
u'نَحْوٌ أَوَّلُ':Added, #11: 11	نَحْوَ الأَوَّلِ
u'نَحْوٌ أَوَّلُ':Added, #1: 1	نَحْوِ الْأَوَّلِ
u'نَحْوٌ أَوَّلُ':Added, #1: 1	نَحْوُ أَوَّلِ
u'نَحْوٌ أَوَّلُ':Added, #4: 4	نَحْوَ الْأَوَّلِ
u'نَحْوٌ آيَةٌ':Added, #6: 6	نَحْوُ الْأَوَّلِ
u'نَحْوٌ آيَةٌ':Added, #1: 1	نَحْوِ الْآيَةِ
u'نَحْوٌ آيَةٌ':Added, #1: 1	نَحْوَ آيَةِ
u'نَحْوٌ أيتام':Added, #2: 2	نَحْوِ آيَةِ
u'نَحْوٌ بَابٌ':Added, #1: 1	نَحْوِ الْأَيْتَامِ
u'نَحْوٌ بَابٌ':Added, #1: 1	نَحْوَ الْبَابِ
u'نَحْوٌ بَابٌ':Added, #1: 1	نَحْوَ بَابِ
u'نَحْوٌ بَاحِثٌ':Added, #1: 1	نَحْوِ بَابِ
u'نَحْوٌ بَائِعٌ':Added, #1: 1	نَحْوَ بَاحِثٍ
u'نَحْوٌ بَائِعٌ':Added, #1: 1	نَحْوِ الْبَائِعِ
u'نَحْوٌ بَحْرٌ':Added, #1: 1	نَحْوِ بَائِعٍ
u'نَحْوٌ بَدْرٌ':Added, #1: 1	نَحْوِ الْبَحْرِ
u'نَحْوٌ بدن':Added, #1: 1	نَحْوَ بَدْرٍ
u'نَحْوٌ بَدَنٌ':Added, #1: 1	نَحْوِ بَدَنِ
u'نَحْوٌ بُرٌّ':Added, #1: 1	نَحْوِ بَدَنِ
u'نَحْوٌ بَراغِيثُ':Added, #1: 1	نَحْوَ الْبُرِّ
u'نَحْوٌ بَرْذَعَة':Added, #1: 1	نَحْوِ الْبَرَاغِيثِ
u'نَحْوٌ بُرْقُعٌ':Added, #1: 1	نَحْوِ الْبَرْذعَةِ
u'نَحْوٌ بُرْمَةٌ':Added, #1: 1	نَحْوَ الْبُرْقُعِ
u'نَحْوٌ بُروجٌ':Added, #1: 1	نَحْوَ بُرْمَةٍ
u'نَحْوٌ بَرِيَّةٌ':Added, #2: 2	نَحْوَ الْبُرُوجِ
u'نَحْوٌ بِزْرٌ':Added, #1: 1	نَحْوِ بَرِيَّةٍ
u'نَحْوٌ بِزْرٌ':Added, #1: 1	نَحْوَ الْبِزْرِ
u'نَحْوٌ بساط':Added, #1: 1	نَحْوِ بِزْرِ
u'نَحْوٌ بِساطٌ':Added, #1: 1	نَحْوِ بِسَاطٍ
u'نَحْوٌ بُسْتانٌ':Added, #1: 1	نَحْوِ بِسَاطٍ
u'نَحْوٌ بُصاقٌ':Added, #1: 1	نَحْوَ بُسْتَانِ
u'نَحْوٌ بَصَلٌ':Added, #1: 1	نَحْوِ الْبُصَاقِ
u'نَحْوٌ بَطْنٌ':Added, #3: 3	نَحْوِ الْبَصَلِ
u'نَحْوٌ بِطِّيخٌ':Added, #1: 1	نَحْوِ الْبَطْنِ
u'نَحْوٌ بِطِّيخٌ':Added, #1: 1	نَحْوُ الْبِطِّيخِ
u'نَحْوٌ بِطِّيخٌ':Added, #1: 1	نَحْوَ بِطِّيخٍ
u'نَحْوٌ بَعيرٌ':Added, #2: 2	نَحْوِ الْبِطِّيخِ
u'نَحْوٌ بَقاءٌ':Added, #1: 1	نَحْوَ الْبَعِيرِ
u'نَحْوٌ بَقَرٌ':Added, #1: 1	نَحْوِ بَقَاءِ
u'نَحْوٌ بَقَرٌ':Added, #1: 1	نَحْوَ الْبَقَرَةِ
u'نَحْوٌ بَقَرٌ':Added, #1: 1	نَحْوِ الْبَقَرَةِ
u'نَحْوٌ بَقَرٌ':Added, #1: 1	نَحْوِ بَقَرٍ
u'نَحْوٌ بَقَرٌ':Added, #1: 1	نَحْوِ بَقَرَةٍ
u'نَحْوٌ بَلَدٌ':Added, #2: 2	نَحْوِ الْبَقَرِ
u'نَحْوٌ بَنْجٌ':Added, #1: 1	نَحْوِ بَلَدٍ
u'نَحْوٌ بَنَفْسَجٌ':Added, #1: 1	نَحْوَ الْبَنْجِ
u'نَحْوٌ بُنُوَّة':Added, #1: 1	نَحْوِ بَنَفْسَجٍ
u'نَحْوٌ بَهِيمَةٌ':Added, #1: 1	نَحْوِ بُنُوَّةٍ
u'نَحْوٌ بَوْلٌ':Added, #1: 1	نَحْوِ بَهِيمَةٍ
u'نَحْوٌ بَوْلٌ':Added, #1: 1	نَحْوَ الْبَوْلِ
u'نَحْوٌ بَوْلٌ':Added, #1: 1	نَحْوُ الْبَوْلِ
u'نَحْوٌ بِئْرٌ':Added, #1: 1	نَحْوِ الْبَوْلِ
u'نَحْوٌ بِئْرٌ':Added, #1: 1	نَحْوِ بِئْرِ
u'نَحْوٌ بِئْرٌ':Added, #2: 2	نَحْوِ بِئْرٍ
u'نَحْوٌ بَيْتٌ':Added, #3: 3	نَحْوَ بِئْرِ
u'نَحْوٌ بَيْتٌ':Added, #18: 18	نَحْوَ بَيْتِ
u'نَحْوٌ بَيْتٌ':Added, #1: 1	نَحْوِ بَيْتٍ
u'نَحْوٌ بيض':Added, #4: 4	نَحْوَ الْبَيْتِ
u'نَحْوٌ بَيْضَةٌ':Added, #1: 1	نَحْوِ الْبَيْضِ
u'نَحْوٌ بَيْعٌ':Added, #1: 1	نَحْوِ بَيْضَةٍ
u'نَحْوٌ بِيَعٌ':Added, #12: 12	نَحْوِ الْبَيْعِ
u'نَحْوٌ بَيْعٌ':Added, #1: 1	نَحْوِ الْبِيَعِ
u'نَحْوٌ بَيْعٌ':Added, #1: 1	نَحْوُ بَيْعِ
u'نَحْوٌ بَيْعٌ':Added, #1: 1	نَحْوُ بَيْعِهِ
u'نَحْوٌ بَيْعٌ':Added, #2: 2	نَحْوِ بَيْعِ
u'نَحْوٌ بَيْعٌ':Added, #2: 2	نَحْوِ بَيْعِهِ
u'نَحْوٌ بَيْعٌ':Added, #3: 3	نَحْوَ بَيْعِ
u'نَحْوٌ بَيْعٌ':Added, #3: 3	نَحْوِ بَيْعٍ
u'نَحْوٌ بَيْعٌ':Added, #4: 4	نَحْوَ الْبَيْعِ
u'نَحْوٌ تِبْر':Added, #4: 4	نَحْوُ الْبَيْعِ
u'نَحْوٌ تَبَرُّدٌ':Added, #1: 1	نَحْوَ التِّبْرِ
u'نَحْوٌ تَجْفِيفٌ':Added, #1: 1	نَحْوِ التَّبَرُّدِ
u'نَحْوٌ تَحْرِيمٌ':Added, #1: 1	نَحْوَ التَّجْفِيفِ
u'نَحْوٌ تَحْقِيقٌ':Added, #1: 1	نَحْوُ تَحْرِيمِ
u'نَحْوٌ تَحِيَّةٌ':Added, #2: 2	نَحْوَ تَحْقِيقِ
u'نَحْوٌ تَخْيِيرٌ':Added, #1: 1	نَحْوِ التَّحِيَّةِ
u'نَحْوٌ تَدْرِيسٌ':Added, #1: 1	نَحْوِ التَّخْيِيرِ
u'نَحْوٌ تُرَابٌ':Added, #3: 3	نَحْو التَّدْرِيسِ
u'نَحْوٌ تُرَابٌ':Added, #1: 1	نَحْوِ التُّرَابِ
u'نَحْوٌ تَزْكِيَةٌ':Added, #1: 1	نَحْوُ تُرَابٍ
u'نَحْوٌ تَسْبِيحٌ':Added, #1: 1	نَحْوَ تَزْكِيَتِهِ
u'نَحْوٌ تَسْبِيحٌ':Added, #1: 1	نَحْو التَّسْبِيحِ
u'نَحْوٌ تِسْعَةٌ':Added, #2: 2	نَحْوِ التَّسْبِيحِ
u'نَحْوٌ تَسْمِيَة':Added, #1: 1	نَحْوُ تِسْعَةٍ
u'نَحْوٌ تَشْذِيبٌ':Added, #1: 1	نَحْوُ التَّسْمِيَةِ
u'نَحْوٌ تَشَهُّدٌ':Added, #1: 1	نَحْوَ التَّشْذِيبِ
u'نَحْوٌ تَشْيِيعٌ':Added, #1: 1	نَحْوُ التَّشَهُّدِ
u'نَحْوٌ تَصَرُّفٌ':Added, #1: 1	نَحْوُ تَشْيِيعِ
u'نَحْوٌ تَعَالِيقُ':Added, #1: 1	نَحْوُ التَّصَرُّفِ
u'نَحْوٌ تَعْظِيمٌ':Added, #1: 1	نَحْوِ التَّعَالِيقِ
u'نَحْوٌ تَعْلِيقٌ':Added, #1: 1	نَحْوَ تَعْظِيمِ
u'نَحْوٌ تَفْرِيع':Added, #1: 1	نَحْوُ تَعْلِيقِ
u'نَحْوٌ تَقْديمٌ':Added, #1: 1	نَحْوِ تَفْرِيعِ
u'نَحْوٌ تَقِيٌّ':Added, #1: 1	نَحْوِ تَقْدِيمِ
u'نَحْوٌ تَكْبِير':Added, #1: 1	نَحْوُ التَّقِيِّ
u'نَحْوٌ تَكَلُّمٌ':Added, #1: 1	نَحْوَ التَّكْبِيرَةِ
u'نَحْوٌ تِلْقاءٌ':Added, #1: 1	نَحْوِ التَّكَلُّمِ
u'نَحْوٌ تَمْر':Added, #1: 1	نَحْوَ تِلْقَاءِ
u'نَحْوٌ تَمْر':Added, #2: 2	نَحْوُ التَّمْرِ
u'نَحْوٌ تَنْبِيه':Added, #3: 3	نَحْوِ التَّمْرِ
u'نَحْوٌ تَنْزِيلٌ':Added, #1: 1	نَحْوِ التَّنْبِيهِ
u'نَحْوٌ تَنَفُّلٌ':Added, #1: 1	نَحْوَ تَنْزِيلِ
u'نَحْوٌ تَنْفِيذٌ':Added, #1: 1	نَحْوِ التَّنَفُّلِ
u'نَحْوٌ تُوتٌ':Added, #1: 1	نَحْوِ تَنْفِيذِ
u'نَحْوٌ تَوْكِيلٌ':Added, #3: 3	نَحْوُ التُّوتِ
u'نَحْوٌ تَيَمُّمٌ':Added, #1: 1	نَحْوُ التَّوْكِيلِ
u'نَحْوٌ تَيَمُّمٌ':Added, #1: 1	نَحْوُ التَّيَمُّمِ
u'نَحْوٌ تينٌ':Added, #1: 1	نَحْوِ التَّيَمُّمِ
u'نَحْوٌ تينٌ':Added, #1: 1	نَحْوُ التِّينِ
u'نَحْوٌ ثُقْبٌ':Added, #1: 1	نَحْوِ التِّينِ
u'نَحْوٌ ثَلاثُ':Added, #1: 1	نَحْوِ ثُقْبٍ
u'نَحْوٌ ثَلاثَةٌ':Added, #2: 2	نَحْوُ ثَلَاثِ
u'نَحْوٌ ثَلاثَةٌ':Added, #1: 1	نَحْوَ الثَّلَاثَةِ
u'نَحْوٌ ثَلاثَةٌ':Added, #1: 1	نَحْوَ ثَلَاثَةِ
u'نَحْوٌ ثِمارٌ':Added, #4: 4	نَحْوِ ثَلَاثَةِ
u'نَحْوٌ ثَمانِيَةٌ':Added, #2: 2	نَحْوِ الثِّمَارِ
u'نَحْوٌ ثَمانِيَةٌ':Added, #1: 1	نَحْوَ ثَمَانِيَةِ
u'نَحْوٌ ثَمَرٌ':Added, #1: 1	نَحْوُ ثَمَانِيَةِ
u'نَحْوٌ ثَمَرٌ':Added, #1: 1	نَحْوِ الثَّمَرِ
u'نَحْوٌ ثَمَرَةٌ':Added, #2: 2	نَحْوُ الثَّمَرِ
u'نَحْوٌ ثَمَرَةٌ':Added, #1: 1	نَحْوُ الثَّمَرَةِ
u'نَحْوٌ ثَمَرَةٌ':Added, #2: 2	نَحْوِ الثَّمَرَةِ
u'نَحْوٌ ثَوْبٌ':Added, #5: 5	نَحْوَ الثَّمَرَةِ
u'نَحْوٌ ثَوْبٌ':Added, #1: 1	نَحْوُ الثَّوْبِ
u'نَحْوٌ ثَوْبٌ':Added, #1: 1	نَحْوُ ثَوْبٍ
u'نَحْوٌ ثَوْبٌ':Added, #1: 1	نَحْوَ ثَوْبِهِ
u'نَحْوٌ ثَوْرٌ':Added, #2: 2	نَحْوِ الثَّوْبِ
u'نَحْوٌ ثُومٌ':Added, #1: 1	نَحْوُ الثَّوْرِ
u'نَحْوٌ ثُومٌ':Added, #1: 1	نَحْوَ الثُّومِ
u'نَحْوٌ ثِيابٌ':Added, #2: 2	نَحْوَ ثُومٍ
u'نَحْوٌ ثِيابٌ':Added, #1: 1	نَحْوِ الثِّيَابِ
u'نَحْوٌ جَارِي':Added, #2: 2	نَحْوُ الثِّيَابِ
u'نَحْوٌ جَارِيَةٌ':Added, #1: 1	نَحْوُ جَارِيَةٍ
u'نَحْوٌ جَامُوسٌ':Added, #1: 1	نَحْوُ جَارِيَةٍ
u'نَحْوٌ جَاهٌ':Added, #1: 1	نَحْوَ الْجَامُوسَةِ
u'نَحْوٌ جَائِحٌ':Added, #2: 2	نَحْوِ الْجَاهِ
u'نَحْوٌ جاَئِحَةٌ':Added, #1: 1	نَحْوَ جَائِحَةٍ
u'نَحْوٌ جِدار':Added, #1: 1	نَحْوَ جَائِحَةٍ
u'نَحْوٌ جُذَامٌ':Added, #1: 1	نَحْوِ جِدَارٍ
u'نَحْوٌ جُذَامٌ':Added, #1: 1	نَحْوَ الْجُذَامِ
u'نَحْوٌ جُذَامٌ':Added, #1: 1	نَحْوَ جُذَامٍ
u'نَحْوٌ جُذَامٌ':Added, #1: 1	نَحْوُ جُذَامٍ
u'نَحْوٌ جَرَادٌ':Added, #2: 2	نَحْوِ الْجُذَامِ
u'نَحْوٌ جَرَادٌ':Added, #1: 1	نَحْوَ الْجَرَادِ
u'نَحْوٌ جَرَادٌ':Added, #1: 1	نَحْوِ الْجَرَادِ
u'نَحْوٌ جِزْيَةٌ':Added, #3: 3	نَحْوُ الْجَرَادِ
u'نَحْوٌ جُلْجُلاَنٌ':Added, #1: 1	نَحْوِ الْجِزْيَةِ
u'نَحْوٌ جلد':Added, #1: 1	نَحْوِ الْجُلْجُلَانِ
u'نَحْوٌ جِلْدٌ':Added, #1: 1	نَحْوُ الْجِلْدِ
u'نَحْوٌ جلد':Added, #1: 1	نَحْوُ الْجِلْدِ
u'نَحْوٌ جِلْدٌ':Added, #1: 1	نَحْوِ جِلْدِ
u'نَحْوٌ جلسة':Added, #1: 1	نَحْوِ جِلْدِ
u'نَحْوٌ جِلْسَةٌ':Added, #1: 1	نَحْوِ جِلْسَةِ
u'نَحْوٌ جُلُوسٌ':Added, #1: 1	نَحْوِ جِلْسَةِ
u'نَحْوٌ جماع':Added, #1: 1	نَحْوُ الْجُلُوسِ
u'نَحْوٌ جماع':Added, #1: 1	نَحْوَ الْجِمَاعِ
u'نَحْوٌ جِمَاعٌ':Added, #1: 1	نَحْوِ الْجِمَاعِ
u'نَحْوٌ جِمَاعٌ':Added, #1: 1	نَحْوَ الْجِمَاعِ
u'نَحْوٌ جِمَالٌ':Added, #1: 1	نَحْوِ الْجِمَاعِ
u'نَحْوٌ جمع':Added, #1: 1	نَحْوُ جِمَالٍ
u'نَحْوٌ جُمَعٌ':Added, #1: 1	نَحْوِ الْجُمَعِ
u'نَحْوٌ جمعة':Added, #1: 1	نَحْوِ الْجُمَعِ
u'نَحْوٌ جمعة':Added, #1: 1	نَحْوَ الْجُمُعَةِ
u'نَحْوٌ جُمُعَةٌ':Added, #1: 1	نَحْوُ الْجُمُعَةِ
u'نَحْوٌ جُمُعَةٌ':Added, #1: 1	نَحْوَ الْجُمُعَةِ
u'نَحْوٌ جمعة':Added, #1: 1	نَحْوُ الْجُمُعَةِ
u'نَحْوٌ جُمُعَةٌ':Added, #1: 1	نَحْوِ جُمُعَةٍ
u'نَحْوٌ جَمَلٌ':Added, #1: 1	نَحْوِ جُمُعَةٍ
u'نَحْوٌ جُمْلَةٌ':Added, #1: 1	نَحْوِ الْجَمَلِ
u'نَحْوٌ جَنَابَةٌ':Added, #1: 1	نَحْوَ الْجُمْلَةِ
u'نَحْوٌ جَنَابَةٌ':Added, #1: 1	نَحْوِ جَنَابَةٍ
u'نَحْوٌ جِنْسٌ':Added, #2: 2	نَحْوِ الْجَنَابَةِ
u'نَحْوٌ جُنُونٌ':Added, #1: 1	نَحْوُ الْجِنْسِ
u'نَحْوٌ جهاد':Added, #1: 1	نَحْوُ جُنُونٍ
u'نَحْوٌ جِهَادٌ':Added, #1: 1	نَحْوِ الْجِهَادِ
u'نَحْوٌ جهاد':Added, #1: 1	نَحْوِ الْجِهَادِ
u'نَحْوٌ جِهَادٌ':Added, #1: 1	نَحْوِ جِهَادٍ
u'نَحْوٌ جِهَةٌ':Added, #1: 1	نَحْوِ جِهَادٍ
u'نَحْوٌ جِهَةٌ':Added, #1: 1	نَحْوَ جِهَاتٍ
u'نَحْوٌ جُوَالِقٌ':Added, #1: 1	نَحْوِ جِهَةِ
u'نَحْوٌ جُوخٌ':Added, #1: 1	نَحْوَ الْجُوَالِقِ
u'نَحْوٌ جَوْزٌ':Added, #1: 1	نَحْوِ الْجُوخَةِ
u'نَحْوٌ جَوْزٌ':Added, #1: 1	نَحْوَ الْجَوْزِ
u'نَحْوٌ جَوْزٌ':Added, #1: 1	نَحْوُ الْجَوْزِ
u'نَحْوٌ جَوْهَرٌ':Added, #3: 3	نَحْوِ الْجَوْزِ
u'نَحْوٌ جَيْبٌ':Added, #1: 1	نَحْوَ الْجَوْهَرِ
u'نَحْوٌ جِيفَةٌ':Added, #2: 2	نَحْوِ الْجَيْبِ
u'نَحْوٌ حاسِبٌ':Added, #1: 1	نَحْوِ الْجِيفَةِ
u'نَحْوٌ حالٌ':Added, #2: 2	نَحْوِ الْحَاسِبِ
u'نَحْوٌ حائِضٌ':Added, #1: 1	نَحْوِ الْحَالِ
u'نَحْوٌ حائِضٌ':Added, #1: 1	نَحْوُ الْحَائِضِ
u'نَحْوٌ حائِطٌ':Added, #1: 1	نَحْوِ حَائِضٍ
u'نَحْوٌ حَبٌّ':Added, #1: 1	نَحْوُ حَائِطٍ
u'نَحْوٌ حَبٌّ':Added, #1: 1	نَحْوِ الْحَبِّ
u'نَحْوٌ حَبٌّ':Added, #1: 1	نَحْوَ الْحَبَّةِ
u'نَحْوٌ حَبٌّ':Added, #1: 1	نَحْو الْحَبَّتَيْنِ
u'نَحْوٌ حَبَّةٌ':Added, #1: 1	نَحْوَ حَبِّ
u'نَحْوٌ حَبْسٌ':Added, #1: 1	نَحْوَ الْحَبَّةِ
u'نَحْوٌ حَبْكَةٌ':Added, #1: 1	نَحْوُ حَبْسِ
u'نَحْوٌ حَجٌّ':Added, #1: 1	نَحْوِ الْحَبْكَةِ
u'نَحْوٌ حَجٌّ':Added, #1: 1	نَحْوُ الْحَجِّ
u'نَحْوٌ حِجارَةٌ':Added, #2: 2	نَحْوِ الْحَجِّ
u'نَحْوٌ حَجَّام':Added, #1: 1	نَحْو الْحِجَارَةِ
u'نَحْوٌ حِجَامَةٌ':Added, #1: 1	نَحْوِ الْحَجَّامِ
u'نَحْوٌ حِجَامَةٌ':Added, #1: 1	نَحْوِ الْحِجَامَةِ
u'نَحْوٌ حُجَّةٌ':Added, #1: 1	نَحْوِ حِجَامَةٍ
u'نَحْوٌ حَجَرٌ':Added, #1: 1	نَحْوَ حُجَّةٍ
u'نَحْوٌ حَجْرٌ':Added, #1: 1	نَحْوَ الْحَجَرِ
u'نَحْوٌ حَدٌّ':Added, #1: 1	نَحْوِ الْحَجْرِ
u'نَحْوٌ حُداءٌ':Added, #1: 1	نَحْوُ حَدِّ
u'نَحْوٌ حِداءٌ':Added, #1: 1	نَحْوَ الْحُدَاءِ
u'نَحْوٌ حَديثٌ':Added, #1: 1	نَحْوَ الْحِدَاءِ
u'نَحْوٌ حَديثٌ':Added, #1: 1	نَحْوَ الْحَدِيثِ
u'نَحْوٌ حَديثٌ':Added, #1: 1	نَحْوَ حَدِيثِهِ
u'نَحْوٌ حَديثٌ':Added, #2: 2	نَحْو حَدِيثِ
u'نَحْوٌ حَديثٌ':Added, #2: 2	نَحْوِ حَدِيثِ
u'نَحْوٌ حَديثٌ':Added, #71: 71	نَحْوَ حَدِيثِ
u'نَحْوٌ حَديدٌ':Added, #9: 9	نَحْوُ حَدِيثِ
u'نَحْوٌ حَديدٌ':Added, #1: 1	نَحْوَ الْحَدِيدِ
u'نَحْوٌ حَرْب':Added, #1: 1	نَحْوِ الْحَدِيدِ
u'نَحْوٌ حَرْبَة':Added, #1: 1	نَحْوُ الْحَرْبِيَّةِ
u'نَحْوٌ حَرْبِيّ':Added, #1: 1	نَحْوُ الْحَرْبِيَّةِ
u'نَحْوٌ حَرْثٌ':Added, #1: 1	نَحْوُ الْحَرْبِيَّةِ
u'نَحْوٌ حَرْثٌ':Added, #1: 1	نَحْوَ الْحَرْثِ
u'نَحْوٌ حَرْفٌ':Added, #1: 1	نَحْوُ حَرْثٍ
u'نَحْوٌ حَرِيقٌ':Added, #1: 1	نَحْوُ حَرْفَيْنِ
u'نَحْوٌ حَرِيقٌ':Added, #1: 1	نَحْوِ حَرِيقٍ
u'نَحْوٌ حَشِيشٌ':Added, #1: 1	نَحْوِ حَرِيقِ
u'نَحْوٌ حَشِيشٌ':Added, #1: 1	نَحْوَ الْحَشِيشَةِ
u'نَحْوٌ حَشِيشٌ':Added, #2: 2	نَحْوِ الْحَشِيشِ
u'نَحْوٌ حَصَادٌ':Added, #5: 5	نَحْوِ الْحَشِيشَةِ
u'نَحْوٌ حَصّاد':Added, #1: 1	نَحْوَ الْحَصَادِ
u'نَحْوٌ حَصَادٌ':Added, #1: 1	نَحْوِ الْحَصَّادِ
u'نَحْوٌ حُصُرٌ':Added, #1: 1	نَحْوِ حَصَادِهِ
u'نَحْوٌ حَصِيرٌ':Added, #1: 1	نَحْوِ حُصُرِ
u'نَحْوٌ حَصِيرٌ':Added, #1: 1	نَحْوِ الْحَصِيرِ
u'نَحْوٌ حَظٌّ':Added, #2: 2	نَحْوَ الْحَصِيرِ
u'نَحْوٌ حَفْرٌ':Added, #1: 1	نَحْوَ الْحَظِّ
u'نَحْوٌ حَفْرٌ':Added, #1: 1	نَحْوَ حَفْرِ
u'نَحْوٌ حَقِيقِيٌّ':Added, #1: 1	نَحْوُ حَفْرِ
u'نَحْوٌ حُكْمٌ':Added, #1: 1	نَحْوِ الْحَقِيقِيِّ
u'نَحْوٌ حلاب':Added, #1: 1	نَحْوِ حُكْمٍ
u'نَحْوٌ حَلْقٌ':Added, #1: 1	نَحْوَ الْحِلاَبِ
u'نَحْوٌ حَمَّادٌ':Added, #1: 1	نَحْوِ الْحَلْقِ
u'نَحْوٌ حِمَارٌ':Added, #1: 1	نَحْوَ حَمَّادِ
u'نَحْوٌ حِمَارٌ':Added, #1: 1	نَحْوَ الْحِمَارِ
u'نَحْوٌ حَمَّامٌ':Added, #1: 1	نَحْوُ حِمَارٍ
u'نَحْوٌ حَمَامَةٌ':Added, #3: 3	نَحْوِ حَمَّامٍ
u'نَحْوٌ حَمَامَةٌ':Added, #1: 1	نَحْوِ الْحَمَامَةِ
u'نَحْوٌ حَمَامَةٌ':Added, #1: 1	نَحْوَ حَمَامَةٍ
u'نَحْوٌ حَمْدٌ':Added, #1: 1	نَحْوِ حَمَامَةٍ
u'نَحْوٌ حِمَّصٌ':Added, #1: 1	نَحْوُ الْحَمْدِ
u'نَحْوٌ حَمْلٌ':Added, #1: 1	نَحْوُ الْحِمَّصَةِ
u'نَحْوٌ حَمْلٌ':Added, #1: 1	نَحْوَ الْحَمْلِ
u'نَحْوٌ حَمَلَةٌ':Added, #1: 1	نَحْوُ الْحَمْلِ
u'نَحْوٌ حَمِيرٌ':Added, #1: 1	نَحْوِ حَمَلَةِ
u'نَحْوٌ حِنَّاءٌ':Added, #1: 1	نَحْوِ الْحَمِيرِ
u'نَحْوٌ حِنْطَةٌ':Added, #1: 1	نَحْوِ الْحِنَّاءِ
u'نَحْوٌ حَوْضٌ':Added, #3: 3	نَحْوِ الْحِنْطَةِ
u'نَحْوٌ حَيٌّ':Added, #3: 3	نَحْوِ الْحَوْضِ
u'نَحْوٌ حَيٌّ':Added, #1: 1	نَحْوِ الْحَيِّ
u'نَحْوٌ حَيٌّ':Added, #1: 1	نَحْوِ الْحَيَّاتِ
u'نَحْوٌ حَيَّاتٌ':Added, #1: 1	نَحْوُ حَيَّةٍ
u'نَحْوٌ حِيَاضٌ':Added, #1: 1	نَحْوِ الْحَيَّاتِ
u'نَحْوٌ حَيَّةٌ':Added, #1: 1	نَحْوُ الْحِيَاضِ
u'نَحْوٌ حَيَّةٌ':Added, #1: 1	نَحْوِ الْحَيَّاتِ
u'نَحْوٌ حَيْضٌ':Added, #1: 1	نَحْوُ حَيَّةٍ
u'نَحْوٌ حِيَلٌ':Added, #1: 1	نَحْوِ حَيْضٍ
u'نَحْوٌ حَيَوَانٌ':Added, #1: 1	نَحْوِ حِيَلِ
u'نَحْوٌ حَيَوَانٌ':Added, #1: 1	نَحْوِ حَيَوَانٍ
u'نَحْوٌ خَابِيَةٌ':Added, #1: 1	نَحْوِ حَيَوَانِ
u'نَحْوٌ خَاتِنٌ':Added, #1: 1	نَحْو خَابِيَةِ
u'نَحْوٌ خَالِقٌ':Added, #1: 1	نَحْوَ الْخَاتِنِ
u'نَحْوٌ خَبَرٌ':Added, #1: 1	نَحْوَ الْخَالِقِ
u'نَحْوٌ خَبَر':Added, #1: 1	نَحْوَ الْخَبَرِ
u'نَحْوٌ خَبَرٌ':Added, #1: 1	نَحْوَ الْخَبَرِ
u'نَحْوٌ خَبَر':Added, #1: 1	نَحْوُ خَبَرِ
u'نَحْوٌ خَتْمٌ':Added, #1: 1	نَحْوُ خَبَرِ
u'نَحْوٌ خَدٌّ':Added, #1: 1	نَحْوِ الْخَتْمِ
u'نَحْوٌ خدش':Added, #2: 2	نَحْوِ الْخَدِّ
u'نَحْوٌ خَدْشٌ':Added, #1: 1	نَحْوَ الْخَدْشِ
u'نَحْوٌ خرق':Added, #1: 1	نَحْوَ الْخَدْشِ
u'نَحْوٌ خِرَقٌ':Added, #1: 1	نَحْوَ الْخِرَقِ
u'نَحْوٌ خُرُوجٌ':Added, #1: 1	نَحْوَ الْخِرَقِ
u'نَحْوٌ خُرُوجٌ':Added, #1: 1	نَحْوَ الْخُرُوجِ
u'نَحْوٌ خَشَبٌ':Added, #1: 1	نَحْوُ الْخُرُوجِ
u'نَحْوٌ خَشَبٌ':Added, #1: 1	نَحْو خَشَبٍ
u'نَحْوٌ خِصاء':Added, #2: 2	نَحْوِ خَشَبٍ
u'نَحْوٌ خَصِيٌّ':Added, #1: 1	نَحْوِ الْخِصَاءِ
u'نَحْوٌ خَصِيٌّ':Added, #1: 1	نَحْوِ الْخَصِيِّ
u'نَحْوٌ خطبة':Added, #1: 1	نَحْوِ خَصِيٍّ
u'نَحْوٌ خُطْبَةٌ':Added, #1: 1	نَحْوَ الْخُطْبَةِ
u'نَحْوٌ خُفٌّ':Added, #1: 1	نَحْوَ الْخُطْبَةِ
u'نَحْوٌ خلق':Added, #1: 1	نَحْوِ خُفٍّ
u'نَحْوٌ خَلْقٌ':Added, #1: 1	نَحْوَ خَلْقِ
u'نَحْوٌ خَمْرٌ':Added, #1: 1	نَحْوَ خَلْقِ
u'نَحْوٌ خَمْسٌ':Added, #2: 2	نَحْوِ الْخَمْرِ
u'نَحْوٌ خُمُسٌ':Added, #1: 1	نَحْوِ الْخَمْسِ
u'نَحْوٌ خَمْسٌ':Added, #1: 1	نَحْوَ الْخُمُسِ
u'نَحْوٌ خَمْسَةٌ':Added, #1: 1	نَحْوِ خَمْسِ
u'نَحْوٌ خَمْسَةٌ':Added, #1: 1	نَحْوُ خَمْسَةٍ
u'نَحْوٌ خُنْفُسٌ':Added, #4: 4	نَحْوِ خَمْسَةِ
u'نَحْوٌ خَوْفٌ':Added, #1: 1	نَحْوَ الْخُنْفُسِ
u'نَحْوٌ خَيَّاطٌ':Added, #1: 1	نَحْوُ خَوْفٍ
u'نَحْوٌ خِيَاطَةٌ':Added, #1: 1	نَحْوُ الْخَيَّاطِ
u'نَحْوٌ خِيَاطَةٌ':Added, #2: 2	نَحْوُ الْخِيَاطَةِ
u'نَحْوٌ خَيْلٌ':Added, #3: 3	نَحْوِ الْخِيَاطَةِ
u'نَحْوٌ دَابَّةٌ':Added, #1: 1	نَحْوِ الْخَيْلِ
u'نَحْوٌ دَابَّةٌ':Added, #1: 1	نَحْوَ الدَّابَّةِ
u'نَحْوٌ دَابَّةٌ':Added, #1: 1	نَحْوِ الدَّابَّةِ
u'نَحْوٌ دَارٌ':Added, #2: 2	نَحْوُ الدَّابَّةِ
u'نَحْوٌ دَارٌ':Added, #1: 1	نَحْوَ الدَّارِ
u'نَحْوٌ دَارٌ':Added, #1: 1	نَحْوُ دَارٍ
u'نَحْوٌ دَارٌ':Added, #2: 2	نَحْوِ الدَّارِ
u'نَحْوٌ دَارٌ':Added, #2: 2	نَحْوُ دَارِ
u'نَحْوٌ دَجَاجٌ':Added, #3: 3	نَحْوَ دَارِ
u'نَحْوٌ دَجاج':Added, #1: 1	نَحْوُ الدَّجَاجِ
u'نَحْوٌ دَجَاجٌ':Added, #1: 1	نَحْوِ الدَّجَاجَةِ
u'نَحْوٌ دُخُولٌ':Added, #2: 2	نَحْوِ الدَّجَاجِ
u'نَحْوٌ دُخُولٌ':Added, #1: 1	نَحْوِ الدُّخُولِ
u'نَحْوٌ دُخُولٌ':Added, #1: 1	نَحْوُ دُخُولِ
u'نَحْوٌ دَرَاهِمُ':Added, #1: 1	نَحْوِ دُخُولِ
u'نَحْوٌ دَرَاهِمُ':Added, #2: 2	نَحْوَ الدَّرَاهِمِ
u'نَحْوٌ دَرَاهِمُ':Added, #3: 3	نَحْوُ الدَّرَاهِمِ
u'نَحْوٌ دَرْسٌ':Added, #3: 3	نَحْوِ الدَّرَاهِمِ
u'نَحْوٌ دِرْهَمٌ':Added, #1: 1	نَحْوِ دَرْسٍ
u'نَحْوٌ دِرْهَم':Added, #1: 1	نَحْوِ الدِّرْهَمِ
u'نَحْوٌ دِرْهَمٌ':Added, #1: 1	نَحْوِ الدِّرْهَمِ
u'نَحْوٌ دِرْهَمٌ':Added, #1: 1	نَحْوُ دِرْهَمٍ
u'نَحْوٌ دِرْهَم':Added, #1: 1	نَحْوِ دِرْهَمٍ
u'نَحْوٌ دِرْهَم':Added, #1: 1	نَحْوُ دِرْهَمٍ
u'نَحْوٌ دُعَاءٌ':Added, #1: 1	نَحْوِ دِرْهَمٍ
u'نَحْوٌ دَمٌ':Added, #1: 1	نَحْوِ الدُّعَاءِ
u'نَحْوٌ دَمٌ':Added, #1: 1	نَحْوِ الدَّمِ
u'نَحْوٌ دَمٌ':Added, #1: 1	نَحْوَ دَمٍ
u'نَحْوٌ دَنٌّ':Added, #1: 1	نَحْوُ دَمٍ
u'نَحْوٌ دُورٌ':Added, #1: 1	نَحْوِ الدَّنِّ
u'نَحْوٌ دِينارٌ':Added, #1: 1	نَحْوِ الدُّورِ
u'نَحْوٌ دِينارٌ':Added, #1: 1	نَحْوُ دِينَارٍ
u'نَحْوٌ ذُبابٌ':Added, #2: 2	نَحْوِ الدِّينَارِ
u'نَحْوٌ ذُبابٌ':Added, #1: 1	نَحْوُ ذُبَابٍ
u'نَحْوٌ ذكر':Added, #2: 2	نَحْوَ ذُبَابٍ
u'نَحْوٌ ذكر':Added, #1: 1	نَحْوَ ذِكْرِ
u'نَحْوٌ ذِكْرٌ':Added, #1: 1	نَحْوُ ذِكْرِ
u'نَحْوٌ ذِكْرٌ':Added, #1: 1	نَحْوَ ذِكْرِ
u'نَحْوٌ ذِكْرٌ':Added, #1: 1	نَحْوُ ذِكْرِ
u'نَحْوٌ ذَهَبٌ':Added, #1: 1	نَحْوِ ذِكْرٍ
u'نَحْوٌ رَأْسٌ':Added, #1: 1	نَحْوَ الذَّهَبِ
u'نَحْوٌ رَأْيٌ':Added, #1: 1	نَحْوِ الرَّأْسِ
u'نَحْوٌ رَائِحٌ':Added, #1: 1	نَحْوَ رَأْيِ
u'نَحْوٌ رَائِحَةٌ':Added, #1: 1	نَحْوِ رَائِحَةِ
u'نَحْوٌ رِبَاطَاتٌ':Added, #1: 1	نَحْوِ رَائِحَةِ
u'نَحْوٌ رَبْطٌ':Added, #1: 1	نَحْوِ الرِّبَاطَاتِ
u'نَحْوٌ رُبْعٌ':Added, #1: 1	نَحْوِ رَبْطِ
u'نَحْوٌ رُبْعٌ':Added, #1: 1	نَحْوُ الرُّبْعِ
u'نَحْوٌ رُبْعٌ':Added, #1: 1	نَحْوِ الرُّبْعِ
u'نَحْوٌ رُبْعٌ':Added, #1: 1	نَحْوُ رُبْعِ
u'نَحْوٌ رِجَالٌ':Added, #1: 1	نَحْوِ رُبْعِ
u'نَحْوٌ رجعة':Added, #1: 1	نَحْوِ رِجَالٍ
u'نَحْوٌ رَجْعَةٌ':Added, #1: 1	نَحْوُ الرَّجْعَةِ
u'نَحْوٌ رَجُلٌ':Added, #1: 1	نَحْوُ الرَّجْعَةِ
u'نَحْوٌ رَجُلٌ':Added, #1: 1	نَحْوَ الرَّجُلِ
u'نَحْوٌ رَجُلٌ':Added, #1: 1	نَحْوُ الرَّجُلِ
u'نَحْوٌ رِجْلٌ':Added, #1: 1	نَحْوِ الرَّجُلِ
u'نَحْوٌ رَجُلٌ':Added, #1: 1	نَحْوِ الرِّجْلِ
u'نَحْوٌ رَجُلٌ':Added, #1: 1	نَحْوَ رَجُلٍ
u'نَحْوٌ رَحْبَةٌ':Added, #2: 2	نَحْوِ رَجُلٍ
u'نَحْوٌ رَحْمَن':Added, #1: 1	نَحْوُ رَحْبَةٍ
u'نَحْوٌ رَحْمَن':Added, #1: 1	نَحْوَ الرَّحْمَنِ
u'نَحْوٌ رَدٌّ':Added, #1: 1	نَحْو رَحْمَنٍ
u'نَحْوٌ رَدٌّ':Added, #1: 1	نَحْوِ الرَّدِّ
u'نَحْوٌ رَدٌّ':Added, #1: 1	نَحْوِ رَدِّ
u'نَحْوٌ رَدٌّ':Added, #2: 2	نَحْوَ الرَّدِّ
u'نَحْوٌ رِدَّةٌ':Added, #5: 5	نَحْوُ الرَّدِّ
u'نَحْوٌ رَسُولٌ':Added, #1: 1	نَحْوِ رِدَّةِ
u'نَحْوٌ رُسُومٌ':Added, #4: 4	نَحْوَ رَسُولِ
u'نَحْوٌ رضاع':Added, #1: 1	نَحْوُ الرُّسُومِ
u'نَحْوٌ رضاع':Added, #1: 1	نَحْوَ الرَّضَاعِ
u'نَحْوٌ رِطْلٌ':Added, #1: 1	نَحْوَ رَضَاعٍ
u'نَحْوٌ رَغيفٌ':Added, #1: 1	نَحْوُ رِطْلَيْنِ
u'نَحْوٌ رَفْعٌ':Added, #1: 1	نَحْوِ الرَّغِيفِ
u'نَحْوٌ رِقٌّ':Added, #1: 1	نَحْوَ رَفْعِ
u'نَحْوٌ رَقَبَةٌ':Added, #1: 1	نَحْوُ الرِّقِّ
u'نَحْوٌ رَقَبَةٌ':Added, #1: 1	نَحْوِ الرَّقَبَةِ
u'نَحْوٌ رَقْصٌ':Added, #1: 1	نَحْوِ رَقَبَةٍ
u'نَحْوٌ رَقيقٌ':Added, #1: 1	نَحْوَ الرَّقْصِ
u'نَحْوٌ رَقيق':Added, #1: 1	نَحْوِ رَقِيقٍ
u'نَحْوٌ رُكوبٌ':Added, #1: 1	نَحْوِ رَقِيقٍ
u'نَحْوٌ رُكوبٌ':Added, #1: 1	نَحْوُ الرُّكُوبِ
u'نَحْوٌ رُكوعٌ':Added, #1: 1	نَحْوَ رُكُوبِ
u'نَحْوٌ رُكوعٌ':Added, #1: 1	نَحْوُ الرُّكُوعِ
u'نَحْوٌ رُمَّانٌ':Added, #3: 3	نَحْوِ الرُّكُوعِ
u'نَحْوٌ رُمَّانٌ':Added, #1: 1	نَحْوِ الرُّمَّانِ
u'نَحْوٌ رَمْيٌ':Added, #1: 1	نَحْوَ رُمَّانٍ
u'نَحْوٌ رَهْنٌ':Added, #1: 1	نَحْوَ الرَّمْيِ
u'نَحْوٌ رِوايَةٌ':Added, #1: 1	نَحْوِ الرَّهْنِ
u'نَحْوٌ رِوايَةٌ':Added, #1: 1	نَحْو رِوَايَةِ
u'نَحْوٌ رِوايَةٌ':Added, #1: 1	نَحْوِ رِوَايَةِ
u'نَحْوٌ رِوايَةٌ':Added, #39: 39	نَحْوَ رِوَايَةِ
u'نَحْوٌ رِوايَةٌ':Added, #3: 3	نَحْوَ الرِّوَايَةِ
u'نَحْوٌ رُومٌ':Added, #4: 4	نَحْوُ رِوَايَةِ
u'نَحْوٌ ريحٌ':Added, #2: 2	نَحْوَ الرُّومِ
u'نَحْوٌ ريحٌ':Added, #1: 1	نَحْوَ الرِّيحِ
u'نَحْوٌ رِيقٌ':Added, #1: 1	نَحْوِ رِيحٍ
u'نَحْوٌ زادٌ':Added, #1: 1	نَحْوِ رِيقِ
u'نَحْوٌ زادٌ':Added, #1: 1	نَحْوُ الزَّادِ
u'نَحْوٌ زُجاجٌ':Added, #1: 1	نَحْوِ الزَّادِ
u'نَحْوٌ زَحْمَةٌ':Added, #1: 1	نَحْوِ الزُّجَاجِ
u'نَحْوٌ زَرْدَة':Added, #1: 1	نَحْوِ الزَّحْمَةِ
u'نَحْوٌ زَرْعٌ':Added, #1: 1	نَحْوِ زَرْدَةٍ
u'نَحْوٌ زَرْعٌ':Added, #1: 1	نَحْوُ زَرْعٍ
u'نَحْوٌ زَعْفَرانٌ':Added, #1: 1	نَحْوِ زَرْعٍ
u'نَحْوٌ زَكاةٌ':Added, #1: 1	نَحْوِ الزَّعْفَرَانِ
u'نَحْوٌ زَكاةٌ':Added, #1: 1	نَحْوِ الزَّكَاةِ
u'نَحْوٌ زَلازِلٌ':Added, #1: 1	نَحْو زَكَاةِ
u'نَحْوٌ زَلْزَلَةٌ':Added, #1: 1	نَحْوُ الزَّلَازِلِ
u'نَحْوٌ زُنَّارٌ':Added, #1: 1	نَحْوِ الزَّلْزَلَةِ
u'نَحْوٌ زِنْديقٌ':Added, #1: 1	نَحْوَ الزُّنَّارِ
u'نَحْوٌ زَوْجٌ':Added, #1: 1	نَحْوِ زِنْدِيقٍ
u'نَحْوٌ زَوْجَةٌ':Added, #1: 1	نَحْوَ الزَّوْجِ
u'نَحْوٌ زَوْجَةٌ':Added, #1: 1	نَحْوِ الزَّوْجَةِ
u'نَحْوٌ زَوْجَةٌ':Added, #1: 1	نَحْوَ زَوْجَتِهِ
u'نَحْوٌ زِيادَةٌ':Added, #1: 1	نَحْوُ زَوْجَتِهِ
u'نَحْوٌ زِيادَةٌ':Added, #1: 1	نَحْوَ زِيَادَةٍ
u'نَحْوٌ زِيارَةٌ':Added, #2: 2	نَحْوِ الزِّيَادَةِ
u'نَحْوٌ زَيْتٌ':Added, #1: 1	نَحْوِ الزِّيَارَةِ
u'نَحْوٌ زَيْتٌ':Added, #1: 1	نَحْوُ الزَّيْتَيْنِ
u'نَحْوٌ زَيْتٌ':Added, #1: 1	نَحْوُ زَيْتَيْنِ
u'نَحْوٌ زَيْتونٌ':Added, #2: 2	نَحْوِ الزَّيْتِ
u'نَحْوٌ زَيْدٌ':Added, #1: 1	نَحْوِ الزَّيْتُونِ
u'نَحْوٌ زَيْدٌ':Added, #1: 1	نَحْوُ زَيْدٍ
u'نَحْوٌ سَارِي':Added, #1: 1	نَحْوِ زَيْدٍ
u'نَحْوٌ سَاقٌ':Added, #1: 1	نَحْوِ سَارِيَةٍ
u'نَحْوٌ سَبٌّ':Added, #1: 1	نَحْوُ السَّاقِ
u'نَحْوٌ سَبٌّ':Added, #1: 1	نَحْوُ سَبٍّ
u'نَحْوٌ سَبُعٌ':Added, #1: 1	نَحْوِ سَبٍّ
u'نَحْوٌ سَبُعٌ':Added, #1: 1	نَحْوِ السَّبُعِ
u'نَحْوٌ سَبْعَةٌ':Added, #1: 1	نَحْوِ سَبُعٍ
u'نَحْوٌ سَبْعَةٌ':Added, #1: 1	نَحْوَ السَّبْعَةِ
u'نَحْوٌ سِتٌّ':Added, #1: 1	نَحْوِ سَبْعَةٍ
u'نَحْوٌ سِتٌّ':Added, #1: 1	نَحْوِ السِّتَّةِ
u'نَحْوٌ سِتٌّ':Added, #1: 1	نَحْوُ سِتِّ
u'نَحْوٌ سِتٌّ':Added, #1: 1	نَحْوَ سِتَّةٍ
u'نَحْوٌ سِتٌّ':Added, #1: 1	نَحْوِ سِتَّةِ
u'نَحْوٌ سِتٌّ':Added, #2: 2	نَحْوَ سِتَّةِ
u'نَحْوٌ سِجِلٌّ':Added, #4: 4	نَحْوُ سِتَّةِ
u'نَحْوٌ سَخْلَة':Added, #1: 1	نَحْوِ سِجِلِّ
u'نَحْوٌ سِدْرٌ':Added, #1: 1	نَحْوِ سَخْلَةٍ
u'نَحْوٌ سَرَاوِيلُ':Added, #1: 1	نَحْوِ سِدْرٍ
u'نَحْوٌ سَرْجٌ':Added, #1: 1	نَحْوَ السَّرَاوِيلِ
u'نَحْوٌ سَرْجٌ':Added, #1: 1	نَحْوَ سَرْجٍ
u'نَحْوٌ سَرقَةٌ':Added, #1: 1	نَحْوُ سَرْجٍ
u'نَحْوٌ سَرِقَةٌ':Added, #1: 1	نَحْوِ السَّرِقَةِ
u'نَحْوٌ سَرقَةٌ':Added, #1: 1	نَحْوِ السَّرِقَةِ
u'نَحْوٌ سَرِقَةٌ':Added, #1: 1	نَحْوِ سَرِقَةٍ
u'نَحْوٌ سَفَلَةٌ':Added, #1: 1	نَحْوِ سَرِقَةٍ
u'نَحْوٌ سِقَاءٌ':Added, #1: 1	نَحْوِ السَّفَلَةِ
u'نَحْوٌ سَقْفٌ':Added, #1: 1	نَحْوَ سِقَاءِ
u'نَحْوٌ سِكَّةٌ':Added, #1: 1	نَحْوَ سَقْفِ
u'نَحْوٌ سُكَّرٌ':Added, #2: 2	نَحْوَ السِّكَّةِ
u'نَحْوٌ سِلاَحٌ':Added, #1: 1	نَحْوُ السُّكَّرِ
u'نَحْوٌ سُلْطَانٌ':Added, #1: 1	نَحْوُ السِّلَاحِ
u'نَحْوٌ سُلْطَانٌ':Added, #1: 1	نَحْوَ السُّلْطَانِ
u'نَحْوٌ سُلْطَانٌ':Added, #1: 1	نَحْوُ السُّلْطَانِ
u'نَحْوٌ سَمَاءٌ':Added, #2: 2	نَحْوِ السُّلْطَانِ
u'نَحْوٌ سَمَاءٌ':Added, #20: 20	نَحْوَ السَّمَاءِ
u'نَحْوٌ سَمَاعٌ':Added, #2: 2	نَحْوِ السَّمَاءِ
u'نَحْوٌ سِمْحاق':Added, #1: 1	نَحْوُ سَمَاعِ
u'نَحْوٌ سِمْسَارٌ':Added, #1: 1	نَحْوُ السِّمْحَاقِ
u'نَحْوٌ سَمَكٌ':Added, #1: 1	نَحْوُ السِّمْسَارِ
u'نَحْوٌ سَمْنٌ':Added, #1: 1	نَحْوِ السَّمَكِ
u'نَحْوٌ سَمْنٌ':Added, #1: 1	نَحْوَ السَّمْنِ
u'نَحْوٌ سَنَةٌ':Added, #1: 1	نَحْوِ السَّمْنِ
u'نَحْوٌ سنن':Added, #1: 1	نَحْو سَنَةٍ
u'نَحْوٌ سُوءٌ':Added, #1: 1	نَحْوِ السُّنَنِ
u'نَحْوٌ سَوادٌ':Added, #1: 1	نَحْوِ سُوءِ
u'نَحْوٌ سِواكٌ':Added, #1: 1	نَحْوَ سَوَادِ
u'نَحْوٌ سُؤَالٌ':Added, #1: 1	نَحْوِ السِّوَاكِ
u'نَحْوٌ سُؤَالٌ':Added, #1: 1	نَحْوِ السُّؤَالِ
u'نَحْوٌ سُورَةٌ':Added, #2: 2	نَحْوَ سُؤَالِ
u'نَحْوٌ سُورَةٌ':Added, #1: 1	نَحْوُ سُورَةِ
u'نَحْوٌ سُورَةٌ':Added, #1: 1	نَحْوِ سُورَةِ
u'نَحْوٌ سُورَةٌ':Added, #2: 2	نَحْوِ السُّورَةِ
u'نَحْوٌ سُوقٌ':Added, #4: 4	نَحْوَ سُورَةِ
u'نَحْوٌ سُوقٌ':Added, #1: 1	نَحْوَ السُّوقِ
u'نَحْوٌ سِياقٌ':Added, #1: 1	نَحْوِ السُّوقِ
u'نَحْوٌ سَيْفٌ':Added, #4: 4	نَحْوَ سِيَاقِ
u'نَحْوٌ سَيْل':Added, #1: 1	نَحْوِ سَيْفٍ
u'نَحْوٌ شَاةٌ':Added, #2: 2	نَحْوِ سَيْلٍ
u'نَحْوٌ شَاةٌ':Added, #1: 1	نَحْوِ الشَّاةِ
u'نَحْوٌ شَاةٌ':Added, #1: 1	نَحْوَ شَاةٍ
u'نَحْوٌ شَاةٌ':Added, #2: 2	نَحْوُ شَاةٍ
u'نَحْوٌ شَارِعٌ':Added, #4: 4	نَحْوِ شَاةٍ
u'نَحْوٌ شاش':Added, #1: 1	نَحْوِ الشَّارِعِ
u'نَحْوٌ شَاعِر':Added, #1: 1	نَحْوِ الشَّاشِ
u'نَحْوٌ شَبٌّ':Added, #1: 1	نَحْوِ شَاعِرٍ
u'نَحْوٌ شِبْرٌ':Added, #1: 1	نَحْوِ الشَّبِّ
u'نَحْوٌ شبكة':Added, #1: 1	نَحْوَ شِبْرٍ
u'نَحْوٌ شَبَكَةٌ':Added, #1: 1	نَحْوِ الشَّبَكَةِ
u'نَحْوٌ شَجَرٌ':Added, #1: 1	نَحْوِ الشَّبَكَةِ
u'نَحْوٌ شَجَرٌ':Added, #1: 1	نَحْوِ شَجَرٍ
u'نَحْوٌ شَجَرَةٌ':Added, #3: 3	نَحْوِ الشَّجَرِ
u'نَحْوٌ شَجَرَةٌ':Added, #1: 1	نَحْوُ شَجَرَةِ
u'نَحْوٌ شَخْصٌ':Added, #2: 2	نَحْوِ الشَّجَرَةِ
u'نَحْوٌ شَدٌّ':Added, #1: 1	نَحْوَ الشَّخْصِ
u'نَحْوٌ شِرَاءٌ':Added, #1: 1	نَحْوِ شَدِّ
u'نَحْوٌ شِرَاءٌ':Added, #1: 1	نَحْوُ الشِّرَاءِ
u'نَحْوٌ شرب':Added, #1: 1	نَحْوِ الشِّرَاءِ
u'نَحْوٌ شُرْبٌ':Added, #1: 1	نَحْوِ الشُّرْبِ
u'نَحْوٌ شرب':Added, #1: 1	نَحْوِ الشُّرْبِ
u'نَحْوٌ شُرْبٌ':Added, #1: 1	نَحْوِ شُرْبِ
u'نَحْوٌ شَرْطٌ':Added, #1: 1	نَحْوِ شُرْبِ
u'نَحْوٌ شرق':Added, #1: 1	نَحْوِ شَرْطِ
u'نَحْوٌ شَرْقٌ':Added, #2: 2	نَحْوَ الشَّرْقِ
u'نَحْوٌ شركة':Added, #2: 2	نَحْوَ الشَّرْقِ
u'نَحْوٌ شَرِكَةٌ':Added, #2: 2	نَحْوِ الشَّرِكَةِ
u'نَحْوٌ شَرِيعَةٌ':Added, #2: 2	نَحْوِ الشَّرِكَةِ
u'نَحْوٌ شَعْبٌ':Added, #1: 1	نَحْوَ الشَّرِيعَةِ
u'نَحْوٌ شِعْبٌ':Added, #1: 1	نَحْوُ الشّعْبِ
u'نَحْوٌ شَعْرٌ':Added, #1: 1	نَحْوُ الشّعْبِ
u'نَحْوٌ شِعْرٌ':Added, #1: 1	نَحْوَ الشَّعْرِ
u'نَحْوٌ شَعْرٌ':Added, #1: 1	نَحْوِ الشِّعْرِ
u'نَحْوٌ شَعْرٌ':Added, #1: 1	نَحْوِ شَعْرٍ
u'نَحْوٌ شَعِيرٌ':Added, #3: 3	نَحْوِ الشَّعْرِ
u'نَحْوٌ شفعة':Added, #1: 1	نَحْوِ الشَّعِيرِ
u'نَحْوٌ شُفْعَةٌ':Added, #2: 2	نَحْوَ شُفْعَةِ
u'نَحْوٌ شمس':Added, #2: 2	نَحْوَ شُفْعَةِ
u'نَحْوٌ شَمْسٌ':Added, #2: 2	نَحْوَ الشَّمْسِ
u'نَحْوٌ شَمْعٌ':Added, #2: 2	نَحْوَ الشَّمْسِ
u'نَحْوٌ شَمْعٌ':Added, #1: 1	نَحْوُ الشَّمْعِ
u'نَحْوٌ شَهْرٌ':Added, #1: 1	نَحْوِ الشَّمْعِ
u'نَحْوٌ شَهْرٌ':Added, #1: 1	نَحْوُ الشَّهْرِ
u'نَحْوٌ شَهْرٌ':Added, #1: 1	نَحْوَ الشَّهْرَيْنِ
u'نَحْوٌ شَهْرٌ':Added, #1: 1	نَحْوَ شَهْرٍ
u'نَحْوٌ شَيْءٌ':Added, #1: 1	نَحْوَ شَهْرَيْنِ
u'نَحْوٌ شَيْءٌ':Added, #1: 1	نَحْوُ الشَّيْءِ
u'نَحْوٌ شِيَاهٌ':Added, #2: 2	نَحْوَ الشَّيْءِ
u'نَحْوٌ شَيْخٌ':Added, #1: 1	نَحْوِ الشِّيَاهِ
u'نَحْوٌ صَاعٌ':Added, #1: 1	نَحْوَ الشَّيْخِ
u'نَحْوٌ صَاعٌ':Added, #1: 1	نَحْوَ الصَّاعِ
u'نَحْوٌ صَاهِلٌ':Added, #2: 2	نَحْوِ الصَّاعِ
u'نَحْوٌ صُبْحٌ':Added, #1: 1	نَحْوُ صَاهِلٍ
u'نَحْوٌ صَبِيٌّ':Added, #1: 1	نَحْوُ الصُّبْحِ
u'نَحْوٌ صَبِيٌّ':Added, #1: 1	نَحْوَ الصَّبِيِّ
u'نَحْوٌ صَبِيٌّ':Added, #1: 1	نَحْوِ الصَّبِيِّ
u'نَحْوٌ صَبِيٌّ':Added, #1: 1	نَحْوَ صَبِيٍّ
u'نَحْوٌ صِبْيَانٌ':Added, #1: 1	نَحْوِ صَبِيٍّ
u'نَحْوٌ صِبْيَانٌ':Added, #1: 1	نَحْوِ الصِّبْيَانِ
u'نَحْوٌ صَحَابَةٌ':Added, #1: 1	نَحْوُ صِبْيَانٍ
u'نَحْوٌ صَحْرَاءُ':Added, #1: 1	نَحْوِ الصَّحَابَةِ
u'نَحْوٌ صَحِيحٌ':Added, #1: 1	نَحْوِ الصَّحْرَاءِ
u'نَحْوٌ صُدَاعٌ':Added, #1: 1	نَحْوُ الصَّحِيحَيْنِ
u'نَحْوٌ صداق':Added, #1: 1	نَحْوِ صُدَاعٍ
u'نَحْوٌ صَدَاقٌ':Added, #3: 3	نَحْوِ صَدَاقٍ
u'نَحْوٌ صَدْرٌ':Added, #3: 3	نَحْوِ صَدَاقٍ
u'نَحْوٌ صدقة':Added, #1: 1	نَحْوَ الصَّدْرِ
u'نَحْوٌ صَدَقَةٌ':Added, #1: 1	نَحْوِ الصَّدَقَةِ
u'نَحْوٌ صدقة':Added, #1: 1	نَحْوِ الصَّدَقَةِ
u'نَحْوٌ صَدَقَةٌ':Added, #2: 2	نَحْوِ صَدَقَةٍ
u'نَحْوٌ صَرِيخ':Added, #2: 2	نَحْوِ صَدَقَةٍ
u'نَحْوٌ صَغِيرٌ':Added, #1: 1	نَحْوَ الصّرِيخِ
u'نَحْوٌ صَغِيرٌ':Added, #1: 1	نَحْوَ الصَّغِيرِ
u'نَحْوٌ صَغِيرٌ':Added, #1: 1	نَحْوِ الصَّغِيرِ
u'نَحْوٌ صِفَةٌ':Added, #1: 1	نَحْوِ الصَّغِيرَةِ
u'نَحْوٌ صَفْحَةٌ':Added, #1: 1	نَحْو الصِّفَةِ
u'نَحْوٌ صفر':Added, #1: 1	نَحْوِ صَفْحَةٍ
u'نَحْوٌ صُفْرٌ':Added, #1: 1	نَحْوَ الصُّفْرِ
u'نَحْوٌ صَقْرٌ':Added, #1: 1	نَحْوَ الصُّفْرِ
u'نَحْوٌ صَلاَةٌ':Added, #2: 2	نَحْوُ الصَّقْرِ
u'نَحْوٌ صَلاَةٌ':Added, #11: 11	نَحْوِ الصَّلَاةِ
u'نَحْوٌ صَلاَةٌ':Added, #1: 1	نَحْوَ الصَّلَاةِ
u'نَحْوٌ صَلاَةٌ':Added, #1: 1	نَحْوِ صَلَاةِ
u'نَحْوٌ صَلاَةٌ':Added, #1: 1	نَحْوَ صَلاَتِهِ
u'نَحْوٌ صِلَةٌ':Added, #3: 3	نَحْوُ الصَّلَاةِ
u'نَحْوٌ صلح':Added, #1: 1	نَحْوِ صِلَةِ
u'نَحْوٌ صلح':Added, #1: 1	نَحْوَ صُلْحِ
u'نَحْوٌ صُلْحٌ':Added, #1: 1	نَحْوُ صُلْحِ
u'نَحْوٌ صُلْحٌ':Added, #1: 1	نَحْوَ صُلْحِ
u'نَحْوٌ صَنَمٌ':Added, #1: 1	نَحْوُ صُلْحِ
u'نَحْوٌ صَهَارِيجُ':Added, #1: 1	نَحْوِ الصَّنَمِ
u'نَحْوٌ صَوْتٌ':Added, #1: 1	نَحْوِ الصَّهَارِيجِ
u'نَحْوٌ صُورَةٌ':Added, #1: 1	نَحْوَ الصَّوْتِ
u'نَحْوٌ صَوْمٌ':Added, #1: 1	نَحْوِ صُورَةِ
u'نَحْوٌ صَوْمٌ':Added, #1: 1	نَحْوُ الصَّوْمِ
u'نَحْوٌ صَيْدٌ':Added, #2: 2	نَحْوِ الصَّوْمِ
u'نَحْوٌ صَيْدٌ':Added, #1: 1	نَحْوُ الصَّيْدِ
u'نَحْوٌ صَيْفٌ':Added, #1: 1	نَحْوِ الصَّيْدِ
u'نَحْوٌ صِينِيٌّ':Added, #1: 1	نَحْوَ الصَّيْفِ
u'نَحْوٌ ضَارِبٌ':Added, #1: 1	نَحْوِ الصِّينِيِّ
u'نَحْوٌ ضَارِبٌ':Added, #1: 1	نَحْوِ الضَّارِبِ
u'نَحْوٌ ضَارِبٌ':Added, #1: 1	نَحْوُ ضَارِبٍ
u'نَحْوٌ ضَالٌّ':Added, #1: 1	نَحْوِ ضَارِبٍ
u'نَحْوٌ ضَبٌّ':Added, #1: 1	نَحْوِ الضَّالَّةِ
u'نَحْوٌ ضَرْبٌ':Added, #1: 1	نَحْوُ الضَّبِّ
u'نَحْوٌ ضَرْبٌ':Added, #1: 1	نَحْوُ الضَّرْبِ
u'نَحْوٌ ضَرْبٌ':Added, #1: 1	نَحْوَ ضَرْبٍ
u'نَحْوٌ ضَوْءٌ':Added, #2: 2	نَحْوِ ضَرْبٍ
u'نَحْوٌ طَاحُونٌ':Added, #1: 1	نَحْوِ الضَّوْءِ
u'نَحْوٌ طَالِقٌ':Added, #1: 1	نَحْوِ الطَّاحُونِ
u'نَحْوٌ طَائِرٌ':Added, #1: 1	نَحْوُ طَالِقٍ
u'نَحْوٌ طَبْخٌ':Added, #1: 1	نَحْوُ طَائِرٍ
u'نَحْوٌ طَبَقٌ':Added, #1: 1	نَحْوِ الطَّبْخِ
u'نَحْوٌ طَبْلٌ':Added, #1: 1	نَحْوَ الطَّبَقِ
u'نَحْوٌ طُبُولٌ':Added, #1: 1	نَحْوَ طَبْلٍ
u'نَحْوٌ طُحْلُبٌ':Added, #1: 1	نَحْوِ طُبُولٍ
u'نَحْوٌ طَرْدٌ':Added, #1: 1	نَحْوُ الطُّحْلُبِ
u'نَحْوٌ طَرِيقٌ':Added, #1: 1	نَحْوِ طَرْدِ
u'نَحْوٌ طَرِيقٌ':Added, #1: 1	نَحْوُ الطَّرِيقِ
u'نَحْوٌ طعام':Added, #1: 1	نَحْوَ طَرِيقِ
u'نَحْوٌ طَعَامٌ':Added, #1: 1	نَحْوُ طَعَامٍ
u'نَحْوٌ طعام':Added, #1: 1	نَحْوُ طَعَامٍ
u'نَحْوٌ طَعَامٌ':Added, #1: 1	نَحْوِ طَعَامِهِ
u'نَحْوٌ طِفْلٌ':Added, #1: 1	نَحْوِ طَعَامِهِ
u'نَحْوٌ طِفْلٌ':Added, #1: 1	نَحْوُ الطِّفْلِ
u'نَحْوٌ طَلاَقٌ':Added, #1: 1	نَحْوِ الطِّفْلِ
u'نَحْوٌ طَلاَقٌ':Added, #1: 1	نَحْوَ الطَّلَاقِ
u'نَحْوٌ طَلاَقٌ':Added, #1: 1	نَحْوُ الطّلَاقِ
u'نَحْوٌ طَلاَقٌ':Added, #1: 1	نَحْوِ طَلَاقٍ
u'نَحْوٌ طُلُوعٌ':Added, #5: 5	نَحْوِ الطَّلَاقِ
u'نَحْوٌ طَهَارَةٌ':Added, #1: 1	نَحْوُ طُلُوعِ
u'نَحْوٌ طَهَارَةٌ':Added, #1: 1	نَحْوَ طَهَارَةِ
u'نَحْوٌ طواف':Added, #1: 1	نَحْوِ طَهَارَةٍ
u'نَحْوٌ طَوَافٌ':Added, #1: 1	نَحْوَ طَوَافِ
u'نَحْوٌ طواف':Added, #1: 1	نَحْوَ طَوَافِ
u'نَحْوٌ طَوَافٌ':Added, #3: 3	نَحْوِ الطَّوَافِ
u'نَحْوٌ طِينٌ':Added, #3: 3	نَحْوِ الطَّوَافِ
u'نَحْوٌ طِينٌ':Added, #1: 1	نَحْوَ الطِّينِ
u'نَحْوٌ طِينٌ':Added, #1: 1	نَحْوُ الطِّينِ
u'نَحْوٌ ظالِمٌ':Added, #1: 1	نَحْوِ طِينٍ
u'نَحْوٌ ظِباءٌ':Added, #2: 2	نَحْوِ ظَالِمٍ
u'نَحْوٌ ظَلامٌ':Added, #1: 1	نَحْوُ الظِّبَاءِ
u'نَحْوٌ ظلمة':Added, #1: 1	نَحْوَ ظَلَامٍ
u'نَحْوٌ ظُلْمَةٌ':Added, #1: 1	نَحْوَ ظُلْمَةٍ
u'نَحْوٌ ظُهْرٌ':Added, #1: 1	نَحْوَ ظُلْمَةٍ
u'نَحْوٌ ظُهْرٌ':Added, #1: 1	نَحْوَ الظُّهْرِ
u'نَحْوٌ عَاقِدٌ':Added, #2: 2	نَحْوِ الظُّهْرِ
u'نَحْوٌ عَالِمٌ':Added, #3: 3	نَحْوَ الْعَاقِدِ
u'نَحْوٌ عِبَادَةٌ':Added, #1: 1	نَحْوِ عَالِمٍ
u'نَحْوٌ عِبَادَةٌ':Added, #1: 1	نَحْوَ الْعِبَادَاتِ
u'نَحْوٌ عِبَارَةٌ':Added, #2: 2	نَحْوِ الْعِبَادَاتِ
u'نَحْوٌ عِبَارَةٌ':Added, #1: 1	نَحْو عِبَارَةِ
u'نَحْوٌ عِبَارَةٌ':Added, #1: 1	نَحْوِ عِبَارَةِ
u'نَحْوٌ عَبْدٌ':Added, #2: 2	نَحْوَ عِبَارَةِ
u'نَحْوٌ عَبْدٌ':Added, #1: 1	نَحْوُ الْعَبْدِ
u'نَحْوٌ عَبْدٌ':Added, #1: 1	نَحْوِ عَبْدِ
u'نَحْوٌ عَبْدٌ':Added, #1: 1	نَحْوُ عَبْدِهِ
u'نَحْوٌ عَبْدٌ':Added, #2: 2	نَحْوَ الْعَبْدِ
u'نَحْوٌ عَبْدٌ':Added, #2: 2	نَحْوُ عَبْدِ
u'نَحْوٌ عَبِيدٌ':Added, #5: 5	نَحْوِ الْعَبْدِ
u'نَحْوٌ عتق':Added, #1: 1	نَحْوِ الْعَبِيدِ
u'نَحْوٌ عِتْقٌ':Added, #1: 1	نَحْوَ الْعِتْقِ
u'نَحْوٌ عتق':Added, #1: 1	نَحْوَ الْعِتْقِ
u'نَحْوٌ عِتْقٌ':Added, #1: 1	نَحْوِ عِتْقِ
u'نَحْوٌ عِتْقٌ':Added, #1: 1	نَحْوِ عِتْقٍ
u'نَحْوٌ عجز':Added, #1: 1	نَحْوِ عِتْقِ
u'نَحْوٌ عَجْزٌ':Added, #1: 1	نَحْوِ عَجْزِ
u'نَحْوٌ عَجِينٌ':Added, #1: 1	نَحْوِ عَجْزِ
u'نَحْوٌ عِدَّةٌ':Added, #1: 1	نَحْوِ الْعَجِينِ
u'نَحْوٌ عَدَسٌ':Added, #1: 1	نَحْوِ الْعِدَّةِ
u'نَحْوٌ عَدُوٌّ':Added, #1: 1	نَحْوَ عَدَسٍ
u'نَحْوٌ عَدُوٌّ':Added, #1: 1	نَحْوَ الْعَدُوِّ
u'نَحْوٌ عَذِرَةٌ':Added, #1: 1	نَحْوِ عَدُوٍّ
u'نَحْوٌ عِرَاقٌ':Added, #1: 1	نَحْوِ الْعَذِرَةِ
u'نَحْوٌ عُرْسٌ':Added, #1: 1	نَحْوَ الْعِرَاقِ
u'نَحْوٌ عُرُوضٌ':Added, #1: 1	نَحْوِ الْعُرْسِ
u'نَحْوٌ عُرُوضٌ':Added, #1: 1	نَحْوَ الْعُرُوضِ
u'نَحْوٌ عزل':Added, #1: 1	نَحْوُ الْعُرُوضِ
u'نَحْوٌ عَسْكَرٌ':Added, #1: 1	نَحْوُ عَزْلِ
u'نَحْوٌ عَسَلٌ':Added, #1: 1	نَحْوَ الْعَسْكَرِ
u'نَحْوٌ عَشْرٌ':Added, #2: 2	نَحْوِ عَسَلٍ
u'نَحْوٌ عَشْرٌ':Added, #1: 1	نَحْوَ عَشْرِ
u'نَحْوٌ عَشْرٌ':Added, #1: 1	نَحْوِ عَشْرِ
u'نَحْوٌ عَشْرٌ':Added, #1: 1	نَحْوَ عَشْرَةِ
u'نَحْوٌ عَشْرٌ':Added, #1: 1	نَحْوِ عَشْرَةِ
u'نَحْوٌ عُضْوٌ':Added, #2: 2	نَحْوُ عَشْرِ
u'نَحْوٌ عُضْوٌ':Added, #1: 1	نَحْوِ الْعُضْوِ
u'نَحْوٌ عَظْمٌ':Added, #1: 1	نَحْوُ عُضْوٍ
u'نَحْوٌ عَظِيمٌ':Added, #1: 1	نَحْو عَظْمٍ
u'نَحْوٌ عَظِيم':Added, #1: 1	نَحْوِ الْعَظِيمِ
u'نَحْوٌ عَقَارٌ':Added, #1: 1	نَحْوِ الْعَظِيمِ
u'نَحْوٌ عَلَقَةٌ':Added, #3: 3	نَحْوِ الْعَقَارِ
u'نَحْوٌ علم':Added, #1: 1	نَحْوِ الْعَلَقَةِ
u'نَحْوٌ عِلْمٌ':Added, #1: 1	نَحْوِ الْعِلْمِ
u'نَحْوٌ علم':Added, #1: 1	نَحْوِ الْعِلْمِ
u'نَحْوٌ عِلْمٌ':Added, #1: 1	نَحْوِ عِلْمٍ
u'نَحْوٌ علم':Added, #1: 1	نَحْوِ عِلْمٍ
u'نَحْوٌ عِلْمٌ':Added, #1: 1	نَحْوُ عِلْمِهِ
u'نَحْوٌ علم':Added, #1: 1	نَحْوُ عِلْمِهِ
u'نَحْوٌ عِلْمٌ':Added, #2: 2	نَحْوَ الْعِلْمِ
u'نَحْوٌ علم':Added, #2: 2	نَحْوَ الْعِلْمِ
u'نَحْوٌ عِلْمٌ':Added, #3: 3	نَحْوُ الْعِلْمِ
u'نَحْوٌ علماء':Added, #3: 3	نَحْوُ الْعِلْمِ
u'نَحْوٌ عُلَمَاءُ':Added, #1: 1	نَحْوَ الْعُلَمَاءِ
u'نَحْوٌ علماء':Added, #1: 1	نَحْوَ الْعُلَمَاءِ
u'نَحْوٌ عُلَمَاءُ':Added, #1: 1	نَحْوِ عُلَمَاءِ
u'نَحْوٌ علماء':Added, #1: 1	نَحْوِ عُلَمَاءِ
u'نَحْوٌ عُلَمَاءُ':Added, #2: 2	نَحْوِ الْعُلَمَاءِ
u'نَحْوٌ عَمٌّ':Added, #2: 2	نَحْوِ الْعُلَمَاءِ
u'نَحْوٌ عِمَارَةٌ':Added, #1: 1	نَحْوُ الْعَمِّ
u'نَحْوٌ عِمَارَةٌ':Added, #1: 1	نَحْو الْعِمَارَةِ
u'نَحْوٌ عِمَامَةٌ':Added, #1: 1	نَحْوِ الْعِمَارَةِ
u'نَحْوٌ عِمَامَةٌ':Added, #1: 1	نَحْوِ عِمَامَةٍ
u'نَحْوٌ عَمَّةٌ':Added, #2: 2	نَحْوِ الْعِمَامَةِ
u'نَحْوٌ عِنَبٌ':Added, #1: 1	نَحْوِ الْعَمَّةِ
u'نَحْوٌ عَنْبَرٌ':Added, #2: 2	نَحْوِ الْعِنَبِ
u'نَحْوٌ عِيَادَةٌ':Added, #1: 1	نَحْوُ عَنْبَرٍ
u'نَحْوٌ عَيْبٌ':Added, #1: 1	نَحْوُ عِيَادَةِ
u'نَحْوٌ غَاصِبٌ':Added, #2: 2	نَحْوِ عَيْبٍ
u'نَحْوٌ غَاصِبٌ':Added, #1: 1	نَحْوِ غَاصِبٍ
u'نَحْوٌ غَاصِبٌ':Added, #2: 2	نَحْوِ الْغَاصِبِ
u'نَحْوٌ غُدْرَانٌ':Added, #2: 2	نَحْوَ غَاصِبِهِ
u'نَحْوٌ غِذَاءٌ':Added, #1: 1	نَحْوِ الْغُدْرَانِ
u'نَحْوٌ غِرَاسٌ':Added, #1: 1	نَحْوِ الْغِذَاءِ
u'نَحْوٌ غِرْبَالٌ':Added, #1: 1	نَحْوَ الْغِرَاسِ
u'نَحْوٌ غِرْبَانٌ':Added, #2: 2	نَحْوَ غِرْبَالٍ
u'نَحْوٌ غَرْسٌ':Added, #1: 1	نَحْوِ الْغِرْبَانِ
u'نَحْوٌ غَزَالٌ':Added, #1: 1	نَحْوِ الْغَرْسِ
u'نَحْوٌ غَزْلٌ':Added, #1: 1	نَحْوُ الْغَزَالَةِ
u'نَحْوٌ غَسْلٌ':Added, #1: 1	نَحْوَ الْغَزْلِ
u'نَحْوٌ غُسْلٌ':Added, #1: 1	نَحْوَ غَسْلِ
u'نَحْوٌ غَشَيان':Added, #1: 1	نَحْوِ غُسْلِ
u'نَحْوٌ غَصْبٌ':Added, #1: 1	نَحْوِ غَشَيَانِ
u'نَحْوٌ غَصْبٌ':Added, #1: 1	نَحْوَ الْغَصْبِ
u'نَحْوٌ غَلَبَةٌ':Added, #2: 2	نَحْوِ الْغَصْبِ
u'نَحْوٌ غَنَمٌ':Added, #1: 1	نَحْوِ الْغَلَبَةِ
u'نَحْوٌ غِيبَةٌ':Added, #1: 1	نَحْوِ الْغَنَمِ
u'نَحْوٌ غير':Added, #1: 1	نَحْوِ الْغِيبَةِ
u'نَحْوٌ غَيْرٌ':Added, #1: 1	نَحْوَ الْغَيْرِ
u'نَحْوٌ غَيْمٌ':Added, #1: 1	نَحْوَ الْغَيْرِ
u'نَحْوٌ فَاتِحٌ':Added, #1: 1	نَحْوِ غَيْمٍ
u'نَحْوٌ فَاتِحٌ':Added, #1: 1	نَحْوُ الْفَاتِحَةِ
u'نَحْوٌ فَاتِحَةٌ':Added, #2: 2	نَحْوِ الْفَاتِحَةِ
u'نَحْوٌ فَاتِحَةٌ':Added, #1: 1	نَحْوُ الْفَاتِحَةِ
u'نَحْوٌ فَأْرٌ':Added, #2: 2	نَحْوِ الْفَاتِحَةِ
u'نَحْوٌ فَأْرٌ':Added, #2: 2	نَحْوِ الْفَأْرَةِ
u'نَحْوٌ فَارِسٌ':Added, #3: 3	نَحْوِ فَأْرَةٍ
u'نَحْوٌ فَاسِقٌ':Added, #1: 1	نَحْوَ فَارِسٍ
u'نَحْوٌ فَاسِقٌ':Added, #1: 1	نَحْوِ الْفَاسِقِ
u'نَحْوٌ فَاسِقٌ':Added, #1: 1	نَحْوِ فَاسِقٍ
u'نَحْوٌ فَاكِهٌ':Added, #2: 2	نَحْوُ فَاسِقٍ
u'نَحْوٌ فَاكِهٌ':Added, #1: 1	نَحْوُ الْفَاكِهَةِ
u'نَحْوٌ فَاكِهَةٌ':Added, #1: 1	نَحْوِ الْفَاكِهَةِ
u'نَحْوٌ فَاكِهَةٌ':Added, #1: 1	نَحْوُ الْفَاكِهَةِ
u'نَحْوٌ فُتَاتٌ':Added, #1: 1	نَحْوِ الْفَاكِهَةِ
u'نَحْوٌ فَحْلٌ':Added, #1: 1	نَحْوِ فُتَاتِ
u'نَحْوٌ فُرَاتٌ':Added, #1: 1	نَحْوُ فَحْلِ
u'نَحْوٌ فَرَسٌ':Added, #1: 1	نَحْوُ الْفُرَاتِ
u'نَحْوٌ فَرْسَخٌ':Added, #1: 1	نَحْوُ الْفَرَسِ
u'نَحْوٌ فَرْسَخٌ':Added, #1: 1	نَحْوَ فَرْسَخٍ
u'نَحْوٌ فَرْسَخٌ':Added, #1: 1	نَحْوِ فَرْسَخٍ
u'نَحْوٌ فُرْنٌ':Added, #1: 1	نَحْوِ فَرْسَخَيْنِ
u'نَحْوٌ فساد':Added, #1: 1	نَحْوِ الْفُرْنِ
u'نَحْوٌ فَسَادٌ':Added, #1: 1	نَحْو الْفَسَادِ
u'نَحْوٌ فُسَّاقٌ':Added, #1: 1	نَحْو الْفَسَادِ
u'نَحْوٌ فُسْتُقٌ':Added, #1: 1	نَحْوِ فُسَّاقٍ
u'نَحْوٌ فَسْخٌ':Added, #1: 1	نَحْوِ الْفُسْتُقِ
u'نَحْوٌ فِسْقٌ':Added, #1: 1	نَحْوِ فَسْخٍ
u'نَحْوٌ فِسْقٌ':Added, #1: 1	نَحْوِ الْفِسْقِ
u'نَحْوٌ فِسْقٌ':Added, #1: 1	نَحْوَ فِسْقٍ
u'نَحْوٌ فسقة':Added, #1: 1	نَحْوِ فِسْقٍ
u'نَحْوٌ فسقة':Added, #1: 1	نَحْوِ الْفَسَقَةِ
u'نَحْوٌ فَصْد':Added, #1: 1	نَحْوِ فَسَقَةٍ
u'نَحْوٌ فَصْد':Added, #1: 1	نَحْوُ الْفَصْدِ
u'نَحْوٌ فِضَّةٌ':Added, #1: 1	نَحْوِ الْفَصْدِ
u'نَحْوٌ فَضِيلَةٌ':Added, #1: 1	نَحْوِ الْفِضَّةِ
u'نَحْوٌ فِعْلٌ':Added, #1: 1	نَحْوُ فَضِيلَةٍ
u'نَحْوٌ فقراء':Added, #1: 1	نَحْوَ فِعْلِ
u'نَحْوٌ فقراء':Added, #1: 1	نَحْوَ الْفُقَرَاءِ
u'نَحْوٌ فَكٌّ':Added, #1: 1	نَحْوِ الْفُقَرَاءِ
u'نَحْوٌ فَكٌّ':Added, #1: 1	نَحْوُ فَكِّ
u'نَحْوٌ فلان':Added, #1: 1	نَحْوِ فَكِّ
u'نَحْوٌ فلان':Added, #1: 1	نَحْوَ الرَّحْمَنِ
u'نَحْوٌ فلان':Added, #1: 1	نَحْوُ الزَّيْدَانِ
u'نَحْوٌ فلان':Added, #1: 1	نَحْوَ الْمَكِّيِّ
u'نَحْوٌ فلان':Added, #1: 1	نَحْوِ النِّيلَةِ
u'نَحْوٌ فلان':Added, #1: 1	نَحْوِ جَعْفَرٍ
u'نَحْوٌ فَلْسٌ':Added, #1: 1	نَحْو رَحْمَنٍ
u'نَحْوٌ فَلْسٌ':Added, #1: 1	نَحْوُ الْفَلْسَيْنِ
u'نَحْوٌ فَلْسَفِيُّ':Added, #1: 1	نَحْوُ فَلْسٍ
u'نَحْوٌ فُلُوسٌ':Added, #1: 1	نَحْوَ الْفَلْسَفِيِّ
u'نَحْوٌ فُنْدُقٌ':Added, #1: 1	نَحْوُ الْفُلُوسِ
u'نَحْوٌ فُولٌ':Added, #1: 1	نَحْوِ فُنْدُقٍ
u'نَحْوٌ فَيْءٌ':Added, #3: 3	نَحْوِ الْفُولِ
u'نَحْوٌ قَادِرٌ':Added, #1: 1	نَحْوِ الْفَيْءِ
u'نَحْوٌ قَامَةٌ':Added, #1: 1	نَحْوَ قَادِرٍ
u'نَحْوٌ قُبَّةٌ':Added, #1: 1	نَحْو قَامَةٍ
u'نَحْوٌ قُبْلَةٌ':Added, #1: 1	نَحْوُ الْقُبَّةِ
u'نَحْوٌ قِبْلَةٌ':Added, #1: 1	نَحْوِ الْقُبْلَةِ
u'نَحْوٌ قِبْلَةٌ':Added, #1: 1	نَحْو الْقِبْلَةِ
u'نَحْوٌ قِبْلَةٌ':Added, #1: 1	نَحْوِ الْقِبْلَةِ
u'نَحْوٌ قِبْلَةٌ':Added, #1: 1	نَحْوَ قِبْلَتِهِ
u'نَحْوٌ قَبُولٌ':Added, #36: 36	نَحْوَ الْقِبْلَةِ
u'نَحْوٌ قَتْلٌ':Added, #1: 1	نَحْوُ قَبُولِ
u'نَحْوٌ قتل':Added, #1: 1	نَحْوِ قَتْلٍ
u'نَحْوٌ قَتْلٌ':Added, #1: 1	نَحْوِ قَتْلِهِ
u'نَحْوٌ قِثَّاءٌ':Added, #1: 1	نَحْوِ قَتْلِهِ
u'نَحْوٌ قِثَّاءٌ':Added, #1: 1	نَحْوُ الْقِثَّاءِ
u'نَحْوٌ قَدْرٌ':Added, #3: 3	نَحْوِ الْقِثَّاءِ
u'نَحْوٌ قدرة':Added, #1: 1	نَحْوَ قَدْرِ
u'نَحْوٌ قُدْرَةٌ':Added, #1: 1	نَحْوِ الْقُدْرَةِ
u'نَحْوٌ قذف':Added, #1: 1	نَحْوِ الْقُدْرَةِ
u'نَحْوٌ قَذْفٌ':Added, #1: 1	نَحْوِ الْقَذْفِ
u'نَحْوٌ قذف':Added, #1: 1	نَحْوِ الْقَذْفِ
u'نَحْوٌ قَذْفٌ':Added, #2: 2	نَحْوُ الْقَذْفِ
u'نَحْوٌ قِرَاءةٌ':Added, #2: 2	نَحْوُ الْقَذْفِ
u'نَحْوٌ قِرَاءةٌ':Added, #1: 1	نَحْوِ الْقِرَاءَةِ
u'نَحْوٌ قِرَاءةٌ':Added, #1: 1	نَحْوِ قِرَاءَةِ
u'نَحْوٌ قِرَاءةٌ':Added, #2: 2	نَحْوَ الْقِرَاءَةِ
u'نَحْوٌ قِرَاءةٌ':Added, #2: 2	نَحْوُ الْقِرَاءَةِ
u'نَحْوٌ قراض':Added, #5: 5	نَحْوَ قِرَاءَتِهِ
u'نَحْوٌ قُرْآنٌ':Added, #1: 1	نَحْوِ الْقِرَاضِ
u'نَحْوٌ قِرْدٌ':Added, #1: 1	نَحْوُ الْقُرْآنِ
u'نَحْوٌ قَرْضٌ':Added, #1: 1	نَحْوُ الْقِرْدِ
u'نَحْوٌ قَرْنٌ':Added, #2: 2	نَحْوَ الْقَرْضِ
u'نَحْوٌ قَرِيبٌ':Added, #1: 1	نَحْوِ الْقَرْنِ
u'نَحْوٌ قَسَمٌ':Added, #1: 1	نَحْوِ الْقَرِيبِ
u'نَحْوٌ قَسْمٌ':Added, #1: 1	نَحْوَ قَسَمِ
u'نَحْوٌ قَسْمٌ':Added, #1: 1	نَحْوَ قَسْمِ
u'نَحْوٌ قَصٌّ':Added, #1: 1	نَحْوِ قَسْمِ
u'نَحْوٌ قصاص':Added, #1: 1	نَحْوَ قَصِّ
u'نَحْوٌ قِصَاصٌ':Added, #1: 1	نَحْوَ الْقِصَاصِ
u'نَحْوٌ قِصَّةٌ':Added, #1: 1	نَحْوَ الْقِصَاصِ
u'نَحْوٌ قِصَّةٌ':Added, #1: 1	نَحْوَ الْقِصَّةِ
u'نَحْوٌ قَصْرٌ':Added, #1: 1	نَحْوَ قِصَّةِ
u'نَحْوٌ قَصْرٌ':Added, #1: 1	نَحْوِ الْقَصْرِ
u'نَحْوٌ قَصْعَةٌ':Added, #1: 1	نَحْوِ قَصْرِ
u'نَحْوٌ قَضَاءٌ':Added, #1: 1	نَحْوِ الْقَصْعَةِ
u'نَحْوٌ قَضَاءٌ':Added, #1: 1	نَحْوَ الْقَضَاءِ
u'نَحْوٌ قَضَاءٌ':Added, #1: 1	نَحْوُ الْقَضَاءِ
u'نَحْوٌ قَضَاءٌ':Added, #1: 1	نَحْوِ الْقَضَاءِ
u'نَحْوٌ قضاة':Added, #1: 1	نَحْوَ قَضَاءِ
u'نَحْوٌ قَضِيبٌ':Added, #1: 1	نَحْوِ الْقُضَاةِ
u'نَحْوٌ قَطْعٌ':Added, #1: 1	نَحْوَ قَضِيبٍ
u'نَحْوٌ قُطْنٌ':Added, #1: 1	نَحْوِ قَطْعِ
u'نَحْوٌ قُطْنٌ':Added, #1: 1	نَحْوَ الْقُطْنِ
u'نَحْوٌ قُطْنٌ':Added, #1: 1	نَحْوِ قُطْنٍ
u'نَحْوٌ قطنة':Added, #2: 2	نَحْوِ الْقُطْنِ
u'نَحْوٌ قُطْنَةٌ':Added, #2: 2	نَحْوِ قُطْنَةٍ
u'نَحْوٌ قُفَّازٌ':Added, #2: 2	نَحْوِ قُطْنَةٍ
u'نَحْوٌ قُفَّازٌ':Added, #1: 1	نَحْوَ الْقُفَّازِ
u'نَحْوٌ قُفَّازٌ':Added, #1: 1	نَحْوَ الْقُفَّازَيْنِ
u'نَحْوٌ قُفَّةٌ':Added, #2: 2	نَحْوِ الْقُفَّازَيْنِ
u'نَحْوٌ قِمَارٌ':Added, #1: 1	نَحْوِ قُفَّةٍ
u'نَحْوٌ قَمْحٌ':Added, #1: 1	نَحْوُ قِمَارٍ
u'نَحْوٌ قَمْحٌ':Added, #1: 1	نَحْوَ الْقَمْحِ
u'نَحْوٌ قَنَاةٌ':Added, #1: 1	نَحْوُ الْقَمْحِ
u'نَحْوٌ قَنَاةٌ':Added, #1: 1	نَحْو الْقَنَاةِ
u'نَحْوٌ قَنَاةٌ':Added, #1: 1	نَحْوَ الْقَنَاةِ
u'نَحْوٌ قَنَاةٌ':Added, #1: 1	نَحْوِ الْقَنَاةِ
u'نَحْوٌ قَنَادِيلُ':Added, #1: 1	نَحْوِ قَنَاةٍ
u'نَحْوٌ قَنَادِيلُ':Added, #1: 1	نَحْوَ الْقَنَادِيلِ
u'نَحْوٌ قُنُوتٌ':Added, #1: 1	نَحْوِ الْقَنَادِيلِ
u'نَحْوٌ قُوتٌ':Added, #1: 1	نَحْوِ الْقُنُوتِ
u'نَحْوٌ قول':Added, #1: 1	نَحْوِ الْقُوتِ
u'نَحْوٌ قَوْلٌ':Added, #12: 12	نَحْوِ قَوْلِهِ
u'نَحْوٌ قول':Added, #12: 12	نَحْوِ قَوْلِهِ
u'نَحْوٌ قَوْلٌ':Added, #13: 13	نَحْوَ قَوْلِ
u'نَحْوٌ قول':Added, #13: 13	نَحْوَ قَوْلِ
u'نَحْوٌ قَوْلٌ':Added, #14: 14	نَحْوُ قَوْلِ
u'نَحْوٌ قول':Added, #14: 14	نَحْوُ قَوْلِ
u'نَحْوٌ قَوْلٌ':Added, #15: 15	نَحْوُ قَوْلِهِ
u'نَحْوٌ قول':Added, #15: 15	نَحْوُ قَوْلِهِ
u'نَحْوٌ قَوْلٌ':Added, #1: 1	نَحْوُ الْقَوْلِ
u'نَحْوٌ قول':Added, #1: 1	نَحْوُ الْقَوْلِ
u'نَحْوٌ قَوْلٌ':Added, #27: 27	نَحْوَ قَوْلِهِ
u'نَحْوٌ قول':Added, #27: 27	نَحْوَ قَوْلِهِ
u'نَحْوٌ قَوْلٌ':Added, #2: 2	نَحْوَ الْقَوْلِ
u'نَحْوٌ قول':Added, #2: 2	نَحْوَ الْقَوْلِ
u'نَحْوٌ قَوْلٌ':Added, #3: 3	نَحْوِ قَوْلِ
u'نَحْوٌ قِيَاسٌ':Added, #3: 3	نَحْوِ قَوْلِ
u'نَحْوٌ قيام':Added, #1: 1	نَحْوَ قِيَاسِ
u'نَحْوٌ قِيَامٌ':Added, #1: 1	نَحْوُ الْقِيَامِ
u'نَحْوٌ قَيْدٌ':Added, #1: 1	نَحْوُ الْقِيَامِ
u'نَحْوٌ قَيْنٌ':Added, #1: 1	نَحْوَ قَيْدِ
u'نَحْوٌ قَيْنَةٌ':Added, #1: 1	نَحْوَ الْقَيْنَاتِ
u'نَحْوٌ كَاذِبٌ':Added, #1: 1	نَحْوَ الْقَيْنَاتِ
u'نَحْوٌ كَاذِبٌ':Added, #1: 1	نَحْوَ كَاذِبٍ
u'نَحْوٌ كَالٌّ':Added, #1: 1	نَحْوُ كَاذِبٍ
u'نَحْوٌ كَبِدٌ':Added, #1: 1	نَحْوُ كَالٍّ
u'نَحْوٌ كبر':Added, #1: 1	نَحْوِ كَبِدٍ
u'نَحْوٌ كِبَرٌ':Added, #1: 1	نَحْوِ كِبَرِ
u'نَحْوٌ كِتَابٌ':Added, #1: 1	نَحْوِ كِبَرِ
u'نَحْوٌ كِتَابٌ':Added, #1: 1	نَحْوَ الْكِتَابِ
u'نَحْوٌ كِتَابٌ':Added, #1: 1	نَحْوَ كِتَابِ
u'نَحْوٌ كِتَابَةٌ':Added, #1: 1	نَحْوِ كِتَابِ
u'نَحْوٌ كِتَابَةٌ':Added, #1: 1	نَحْوُ الْكِتَابَاتِ
u'نَحْوٌ كِتَابَةٌ':Added, #1: 1	نَحْوُ الْكِتَابَةِ
u'نَحْوٌ كَتَّانٌ':Added, #1: 1	نَحْوَ كِتَابَةِ
u'نَحْوٌ كُتُبٌ':Added, #1: 1	نَحْوِ الْكَتَّانِ
u'نَحْوٌ كُتُبٌ':Added, #1: 1	نَحْوِ كُتُبِ
u'نَحْوٌ كَثْرَةٌ':Added, #2: 2	نَحْوُ كُتُبِ
u'نَحْوٌ كُرَّاسٌ':Added, #1: 1	نَحْوِ كَثْرَةِ
u'نَحْوٌ كُرَّاسٌ':Added, #1: 1	نَحْوِ كُرَّاسٍ
u'نَحْوٌ كِرْباس':Added, #1: 1	نَحْو كُرَّاسَيْنِ
u'نَحْوٌ كرش':Added, #1: 1	نَحْوِ الْكِرْبَاسِ
u'نَحْوٌ كَرِشٌ':Added, #2: 2	نَحْوِ الْكَرِشِ
u'نَحْوٌ كَرَمٌ':Added, #2: 2	نَحْوِ الْكَرِشِ
u'نَحْوٌ كَسْبٌ':Added, #1: 1	نَحْوُ كَرَمٍ
u'نَحْوٌ كسرة':Added, #1: 1	نَحْوِ الْكَسْبِ
u'نَحْوٌ كِسْرَةٌ':Added, #1: 1	نَحْوَ كِسْرَةٍ
u'نَحْوٌ كسرة':Added, #1: 1	نَحْوَ كِسْرَةٍ
u'نَحْوٌ كِسْرَةٌ':Added, #3: 3	نَحْوِ كِسْرَةِ
u'نَحْوٌ كُسُورٌ':Added, #3: 3	نَحْوِ كِسْرَةِ
u'نَحْوٌ كعبة':Added, #1: 1	نَحْوَ الْكُسُورِ
u'نَحْوٌ كَعْبَةٌ':Added, #1: 1	نَحْوِ الْكَعْبَةِ
u'نَحْوٌ كعبة':Added, #1: 1	نَحْوِ الْكَعْبَةِ
u'نَحْوٌ كَعْبَةٌ':Added, #9: 9	نَحْوَ الْكَعْبَةِ
u'نَحْوٌ كَفَّارٌ':Added, #9: 9	نَحْوَ الْكَعْبَةِ
u'نَحْوٌ كَفَّارَةٌ':Added, #2: 2	نَحْوِ الْكَفَّارَةِ
u'نَحْوٌ كَفَّارَةٌ':Added, #2: 2	نَحْوِ الْكَفَّارَةِ
u'نَحْوٌ كفر':Added, #2: 2	نَحْوِ كَفَّارَةٍ
u'نَحْوٌ كُفْرٌ':Added, #1: 1	نَحْوُ الْكُفْرِ
u'نَحْوٌ كلاب':Added, #1: 1	نَحْوُ الْكُفْرِ
u'نَحْوٌ كِلاَبٌ':Added, #2: 2	نَحْوِ كِلَابٍ
u'نَحْوٌ كَلاَمٌ':Added, #2: 2	نَحْوِ كِلَابٍ
u'نَحْوٌ كَلاَمٌ':Added, #1: 1	نَحْوَ الْكَلَامِ
u'نَحْوٌ كَلاَمٌ':Added, #1: 1	نَحْوَ الْكَلاَمِ
u'نَحْوٌ كَلْبٌ':Added, #2: 2	نَحْوَ كَلَامِ
u'نَحْوٌ كَلْبٌ':Added, #1: 1	نَحْوَ كَلْبٍ
u'نَحْوٌ كَلْبٌ':Added, #1: 1	نَحْوَ كَلْبِ
u'نَحْوٌ كَلْبٌ':Added, #1: 1	نَحْوِ كَلْبِ
u'نَحْوٌ كَلْبٌ':Added, #2: 2	نَحْوُ كَلْبٍ
u'نَحْوٌ كَلِمَةٌ':Added, #3: 3	نَحْوِ الْكَلْبِ
u'نَحْوٌ كَلِمَةٌ':Added, #1: 1	نَحْوُ الْكَلِمَةِ
u'نَحْوٌ كَمَالٌ':Added, #1: 1	نَحْوُ كَلِمَةِ
u'نَحْوٌ كَمَنْجَةٌ':Added, #1: 1	نَحْوَ الْكَمَالِ
u'نَحْوٌ كِنَايَةٌ':Added, #1: 1	نَحْوِ الْكَمَنْجَةِ
u'نَحْوٌ كَنِيسَةٌ':Added, #1: 1	نَحْوَ الْكِنَايَاتِ
u'نَحْوٌ كَوْكَبٌ':Added, #2: 2	نَحْوِ الْكَنِيسَةِ
u'نَحْوٌ كَوْنٌ':Added, #1: 1	نَحْوِ كَوْكَبِ
u'نَحْوٌ كَوْنٌ':Added, #1: 1	نَحْوِ كَوْنِ
u'نَحْوٌ كَوْنٌ':Added, #1: 1	نَحْوِ كَوْنِهِ
u'نَحْوٌ كَوْنٌ':Added, #3: 3	نَحْوَ كَوْنِ
u'نَحْوٌ كَوْنٌ':Added, #3: 3	نَحْوَ كَوْنِهِ
u'نَحْوٌ كَيَّالٌ':Added, #5: 5	نَحْوُ كَوْنِهِ
u'نَحْوٌ كِيسٌ':Added, #1: 1	نَحْوِ الْكَيَّالِ
u'نَحْوٌ كَيْلٌ':Added, #1: 1	نَحْوِ كِيسِ
u'نَحْوٌ لبن':Added, #1: 1	نَحْوِ الْكَيْلِ
u'نَحْوٌ لَبَنٌ':Added, #1: 1	نَحْوُ اللَّبَنِ
u'نَحْوٌ لبن':Added, #1: 1	نَحْوُ اللَّبَنِ
u'نَحْوٌ لَبَنٌ':Added, #1: 1	نَحْوُ لَبَنِ
u'نَحْوٌ لَبَنٌ':Added, #1: 1	نَحْوُ لَبَنِ
u'نَحْوٌ لبنة':Added, #1: 1	نَحْوِ لَبَنٍ
u'نَحْوٌ لَبِنَةٌ':Added, #1: 1	نَحْوِ اللَّبِنَةِ
u'نَحْوٌ لَحْمٌ':Added, #1: 1	نَحْوِ اللَّبِنَةِ
u'نَحْوٌ لَحْمٌ':Added, #1: 1	نَحْوَ اللَّحْمِ
u'نَحْوٌ لَحْمٌ':Added, #1: 1	نَحْوِ اللَّحْمِ
u'نَحْوٌ لحمة':Added, #2: 2	نَحْوُ اللَّحْمِ
u'نَحْوٌ لَحْمَةٌ':Added, #1: 1	نَحْوَ لَحْمَةٍ
u'نَحْوٌ لِحْيَةٌ':Added, #1: 1	نَحْوَ لَحْمَةٍ
u'نَحْوٌ لُصُوصٌ':Added, #1: 1	نَحْوِ اللِّحْيَةِ
u'نَحْوٌ لُصُوصٌ':Added, #1: 1	نَحْوِ اللُّصُوصِ
u'نَحْوٌ لَفْظٌ':Added, #1: 1	نَحْوِ لُصُوصٍ
u'نَحْوٌ لَفْظٌ':Added, #2: 2	نَحْوَ اللَّفْظِ
u'نَحْوٌ لُؤْلُؤٌ':Added, #3: 3	نَحْوَ لَفْظِ
u'نَحْوٌ لَوْنٌ':Added, #2: 2	نَحْوِ اللُّؤْلُؤِ
u'نَحْوٌ مَاءٌ':Added, #1: 1	نَحْوَ لَوْنٍ
u'نَحْوٌ مَاءٌ':Added, #1: 1	نَحْوَ الْمَاءِ
u'نَحْوٌ مَاءٌ':Added, #1: 1	نَحْوُ الْمَاءِ
u'نَحْوٌ مَاءٌ':Added, #1: 1	نَحْوُ مَاءٍ
u'نَحْوٌ مَاءٌ':Added, #1: 1	نَحْوِ مَاءِ
u'نَحْوٌ مَاءٌ':Added, #2: 2	نَحْوَ مَاءِ
u'نَحْوٌ مَاشِي':Added, #2: 2	نَحْوِ مَاءٍ
u'نَحْوٌ مَاشِيَةٌ':Added, #1: 1	نَحْوَ الْمَاشِيَةِ
u'نَحْوٌ مَاعُونٌ':Added, #1: 1	نَحْوَ الْمَاشِيَةِ
u'نَحْوٌ مَاكِرٌ':Added, #1: 1	نَحْوَ مَاعُونٍ
u'نَحْوٌ مَالٌ':Added, #1: 1	نَحْوِ الْمَاكِرِ
u'نَحْوٌ مَالٌ':Added, #1: 1	نَحْوُ مَالٍ
u'نَحْوٌ مَالٌ':Added, #2: 2	نَحْوِ الْمَالِ
u'نَحْوٌ مَالِكٌ':Added, #2: 2	نَحْوِ مَالٍ
u'نَحْوٌ مَالِكٌ':Added, #1: 1	نَحْوُ مَالِكٍ
u'نَحْوٌ مُبَادَرَةٌ':Added, #2: 2	نَحْوَ مَالِكِ
u'نَحْوٌ مُبَاشَرَةٌ':Added, #1: 1	نَحْوِ الْمُبَادَرَةِ
u'نَحْوٌ مُبتدَعٌ':Added, #1: 1	نَحْوَ الْمُبَاشَرَةِ
u'نَحْوٌ مُتَرَدِّي':Added, #1: 1	نَحْوِ مُبْتَدَعَةٍ
u'نَحْوٌ مُتَمَتِّعٌ':Added, #1: 1	نَحْوِ الْمُتَرَدِّيَةِ
u'نَحْوٌ مَجْذُومٌ':Added, #1: 1	نَحْوِ الْمُتَمَتِّعِ
u'نَحْوٌ مَجْلِسٌ':Added, #1: 1	نَحْوِ الْمَجْذُومِ
u'نَحْوٌ مَجْلِسٌ':Added, #1: 1	نَحْوُ مَجْلِسٍ
u'نَحْوٌ مَجُوسِيٌّ':Added, #1: 1	نَحْوُ مَجْلِسِ
u'نَحْوٌ مَجُوسِيَّةٌ':Added, #1: 1	نَحْوُ الْمَجُوسِيِّ
u'نَحْوٌ مَجِيءٌ':Added, #1: 1	نَحْوُ الْمَجُوسِيَّةِ
u'نَحْوٌ مُحْدِثٌ':Added, #1: 1	نَحْوُ مَجِيءِ
u'نَحْوٌ مَحْرَمٌ':Added, #1: 1	نَحْوِ الْمُحْدِثِ
u'نَحْوٌ مَحْسُودٌ':Added, #1: 1	نَحْوِ مَحْرَمٍ
u'نَحْوٌ مَحَلٌّ':Added, #1: 1	نَحْوَ الْمَحْسُودِ
u'نَحْوٌ مَحْمُودٌ':Added, #1: 1	نَحْوِ مَحَلِّهِ
u'نَحْوٌ مُخْبِرٌ':Added, #1: 1	نَحْوُ مَحْمُودِ
u'نَحْوٌ مُخْرِجٌ':Added, #1: 1	نَحْوُ مُخْبِرٍ
u'نَحْوٌ مُدٌّ':Added, #1: 1	نَحْوِ مُخْرِجٍ
u'نَحْوٌ مَدَارِسُ':Added, #1: 1	نَحْوِ مُدٍّ
u'نَحْوٌ مُدَّةٌ':Added, #1: 1	نَحْوِ الْمَدَارِسِ
u'نَحْوٌ مَدْخَلٌ':Added, #1: 1	نَحْوِ الْمُدَّةِ
u'نَحْوٌ مُدَرِّسٌ':Added, #1: 1	نَحْوُ مَدْخَلٍ
u'نَحْوٌ مَدْرَسَةٌ':Added, #1: 1	نَحْوَ الْمُدَرِّسِ
u'نَحْوٌ مَدِينٌ':Added, #2: 2	نَحْوَ مَدْرَسَةٍ
u'نَحْوٌ مَدِينَةٌ':Added, #2: 2	نَحْوِ الْمَدِينَةِ
u'نَحْوٌ مَرْزُوقٌ':Added, #2: 2	نَحْوِ الْمَدِينَةِ
u'نَحْوٌ مَرَضٌ':Added, #1: 1	نَحْوَ مَرْزُوقٍ
u'نَحْوٌ مَرَضٌ':Added, #1: 1	نَحْوُ الْمَرَضِ
u'نَحْوٌ مَرَضٌ':Added, #1: 1	نَحْوِ الْمَرَضِ
u'نَحْوٌ مَرَضٌ':Added, #1: 1	نَحْوَ مَرَضٍ
u'نَحْوٌ مَرْكُوبٌ':Added, #1: 1	نَحْوِ مَرَضٍ
u'نَحْوٌ مرو':Added, #1: 1	نَحْوِ مَرْكُوبٍ
u'نَحْوٌ مَرِيضٌ':Added, #9: 9	نَحْوَ الْمَرْوَةِ
u'نَحْوٌ مَزَارِعُ':Added, #1: 1	نَحْوُ الْمَرِيضِ
u'نَحْوٌ مَسٌّ':Added, #1: 1	نَحْوِ الْمَزَارِعِ
u'نَحْوٌ مَسٌّ':Added, #1: 1	نَحْوُ مَسِّ
u'نَحْوٌ مَسَافَةٌ':Added, #1: 1	نَحْوِ مَسِّ
u'نَحْوٌ مُسَافِرٌ':Added, #1: 1	نَحْوَ الْمَسَافَةِ
u'نَحْوٌ مساكين':Added, #1: 1	نَحْوَ الْمُسَافِرِ
u'نَحْوٌ مَسْأَلَةٌ':Added, #1: 1	نَحْوِ الْمَسَاكِينِ
u'نَحْوٌ مَسْأَلَةٌ':Added, #1: 1	نَحْوِ الْمَسْأَلَةِ
u'نَحْوٌ مَسَائِلُ':Added, #1: 1	نَحْوَ مَسْأَلَةِ
u'نَحْوٌ مُسْتَمِرٌّ':Added, #2: 2	نَحْوِ مَسَائِلِ
u'نَحْوٌ مَسْجِدٌ':Added, #1: 1	نَحْوِ مُسْتَمِرٍّ
u'نَحْوٌ مَسْجِدٌ':Added, #1: 1	نَحْوُ الْمَسْجِدِ
u'نَحْوٌ مَسْجِدٌ':Added, #1: 1	نَحْوِ مَسْجِدٍ
u'نَحْوٌ مَسْرُوقٌ':Added, #2: 2	نَحْوِ الْمَسْجِدِ
u'نَحْوٌ مِسْكٌ':Added, #1: 1	نَحْوِ الْمَسْرُوقِ
u'نَحْوٌ مَسْكَنٌ':Added, #1: 1	نَحْوِ الْمِسْكِ
u'نَحْوٌ مُسْلِمٌ':Added, #1: 1	نَحْوُ الْمَسْكَنِ
u'نَحْوٌ مَسِيرٌ':Added, #2: 2	نَحْوَ مُسْلِمٍ
u'نَحْوٌ مَسِيلٌ':Added, #1: 1	نَحْوِ الْمَسِيرِ
u'نَحْوٌ مُشْتَرَكٌ':Added, #1: 1	نَحْوَ الْمَسِيلِ
u'نَحْوٌ مَشْرِقٌ':Added, #2: 2	نَحْوِ الْمُشْتَرَكِ
u'نَحْوٌ مُشْرِقٌ':Added, #1: 1	نَحْوَ الْمشْرِقِ
u'نَحْوٌ مَشْرِقٌ':Added, #1: 1	نَحْوَ الْمشْرِقِ
u'نَحْوٌ مَشْرِقٌ':Added, #1: 1	نَحْوِ الْمَشْرِقِ
u'نَحْوٌ مَشِيمَة':Added, #8: 8	نَحْوَ الْمَشْرِقِ
u'نَحْوٌ مُصْحَفٌ':Added, #1: 1	نَحْوِ الْمَشِيمَةِ
u'نَحْوٌ مُصْحَفٌ':Added, #1: 1	نَحْوِ الْمُصْحَفِ
u'نَحْوٌ مُصْحَفٌ':Added, #1: 1	نَحْو مُصْحَفٍ
u'نَحْوٌ مِصْرٌ':Added, #1: 1	نَحْوَ مُصْحَفِ
u'نَحْوٌ مِصْرِيٌّ':Added, #1: 1	نَحْوَ الْمِصْرِ
u'نَحْوٌ مِصْرِيٌّ':Added, #1: 1	نَحْوِ الْمِصْرِيِّ
u'نَحْوٌ مَضْرَبٌ':Added, #2: 2	نَحْوَ الْمِصْرِيِّ
u'نَحْوٌ مَضْمَضَةٌ':Added, #1: 1	نَحْوَ مَضْرَبٍ
u'نَحْوٌ مُطَالَبٌ':Added, #1: 1	نَحْوَ الْمَضْمَضَةِ
u'نَحْوٌ مُطَالَبَةٌ':Added, #1: 1	نَحْوِ مُطَالَبَتِهِ
u'نَحْوٌ مَطَرٌ':Added, #1: 1	نَحْوِ مُطَالَبَتِهِ
u'نَحْوٌ مَطْلُوبٌ':Added, #1: 1	نَحْوِ مَطَرٍ
u'نَحْوٌ مُعارِضٌ':Added, #1: 1	نَحْوَ الْمَطْلُوبِ
u'نَحْوٌ مُعْسِرٌ':Added, #1: 1	نَحْوِ مُعَارِضٍ
u'نَحْوٌ مَعْلُومٌ':Added, #1: 1	نَحْوِ مُعْسِرٍ
u'نَحْوٌ مَغْرِبٌ':Added, #1: 1	نَحْوُ الْمَعْلُومِ
u'نَحْوٌ مُفْلِسٌ':Added, #1: 1	نَحْوِ الْمَغْرِبِ
u'نَحْوٌ مَقَامٌ':Added, #1: 1	نَحْوِ مُفْلِسٍ
u'نَحْوٌ مَقْبَرَةٌ':Added, #1: 1	نَحْوُ مَقَامٍ
u'نَحْوٌ مَقْصِدٌ':Added, #2: 2	نَحْوَ الْمَقْبَرَةِ
u'نَحْوٌ مَقْصُورٌ':Added, #1: 1	نَحْوِ مَقْصِدِهِ
u'نَحْوٌ مَقْصُورٌ':Added, #1: 1	نَحْوَ مَقْصُورَةِ
u'نَحْوٌ مَقْصُورَةٌ':Added, #1: 1	نَحْوُ مَقْصُورَةٍ
u'نَحْوٌ مَقْصُورَةٌ':Added, #1: 1	نَحْوَ مَقْصُورَةِ
u'نَحْوٌ مُكَاتَبَةٌ':Added, #1: 1	نَحْوُ مَقْصُورَةٍ
u'نَحْوٌ مَكْتُوبٌ':Added, #1: 1	نَحْوُ مُكَاتَبَةٍ
u'نَحْوٌ مَكْسٌ':Added, #1: 1	نَحْوَ الْمَكْتُوبَةِ
u'نَحْوٌ مُكَلَّفٌ':Added, #1: 1	نَحْوِ مَكْسٍ
u'نَحْوٌ مَكِّيّ':Added, #1: 1	نَحْوَ الْمُكَلَّفِ
u'نَحْوٌ مَكِيلٌ':Added, #1: 1	نَحْوَ الْمَكِّيِّ
u'نَحْوٌ مِلْحَفَةٌ':Added, #1: 1	نَحْوُ الْمَكِيلِ
u'نَحْوٌ مِلْكٌ':Added, #1: 1	نَحْوَ الْمِلْحَفَةِ
u'نَحْوٌ مَنَارٌ':Added, #1: 1	نَحْوِ الْمِلْكِ
u'نَحْوٌ مُنَازَعٌ':Added, #3: 3	نَحْوِ الْمَنَارَةِ
u'نَحْوٌ مُنَازَعَةٌ':Added, #1: 1	نَحْوَ الْمُنَازَعَةِ
u'نَحْوٌ مِنْبَرٌ':Added, #1: 1	نَحْوَ الْمُنَازَعَةِ
u'نَحْوٌ مِنْبَرٌ':Added, #1: 1	نَحْوِ مِنْبَرٍ
u'نَحْوٌ مَنْزِلٌ':Added, #2: 2	نَحْوَ الْمِنْبَرِ
u'نَحْوٌ مَنْصُورٌ':Added, #1: 1	نَحْوَ الْمَنْزِلِ
u'نَحْوٌ مِنْطَقَةٌ':Added, #1: 1	نَحْوُ مَنْصُورٍ
u'نَحْوٌ مَنْكِبٌ':Added, #1: 1	نَحْوِ الْمِنْطَقَةِ
u'نَحْوٌ مَهْدٌ':Added, #1: 1	نَحْوَ الْمَنْكِبَيْنِ
u'نَحْوٌ مَهْرٌ':Added, #1: 1	نَحْوِ مَهْدٍ
u'نَحْوٌ مَهْرٌ':Added, #1: 1	نَحْوَ الْمَهْرِ
u'نَحْوٌ مَهْرٌ':Added, #1: 1	نَحْوُ الْمَهْرِ
u'نَحْوٌ مُوَاسَاةٌ':Added, #1: 1	نَحْوِ الْمَهْرِ
u'نَحْوٌ مُودَعٌ':Added, #1: 1	نَحْوُ مُوَاسَاةِ
u'نَحْوٌ مَوْزُونٌ':Added, #1: 1	نَحْوَ الْمُودَعِ
u'نَحْوٌ مَيْتٌ':Added, #1: 1	نَحْوَ الْمَوْزُونَاتِ
u'نَحْوٌ مَيْتٌ':Added, #1: 1	نَحْوَ الْمَيْتَةِ
u'نَحْوٌ مَيْتَةٌ':Added, #1: 1	نَحْوُ الْمَيْتَةِ
u'نَحْوٌ مَيْتَةٌ':Added, #1: 1	نَحْوَ الْمَيْتَةِ
u'نَحْوٌ مِيرَاثٌ':Added, #1: 1	نَحْوُ الْمَيْتَةِ
u'نَحْوٌ ميل':Added, #1: 1	نَحْوُ الْمِيرَاثِ
u'نَحْوٌ مِيلٌ':Added, #1: 1	نَحْوَ مِيلٍ
u'نَحْوٌ مِيلٌ':Added, #1: 1	نَحْوَ مِيلٍ
u'نَحْوٌ ميل':Added, #1: 1	نَحْوِ مِيلَيْنِ
u'نَحْوٌ مِيلٌ':Added, #3: 3	نَحْوُ مِيلٍ
u'نَحْوٌ ميل':Added, #3: 3	نَحْوُ مِيلٍ
u'نَحْوٌ مِيلٌ':Added, #4: 4	نَحْوُ الْمِيلِ
u'نَحْوٌ نَاسٌ':Added, #4: 4	نَحْوُ الْمِيلِ
u'نَحْوٌ نَائِمٌ':Added, #1: 1	نَحْوَ النَّاسِ
u'نَحْوٌ نَبِيذٌ':Added, #1: 1	نَحْوُ النَّائِمِ
u'نَحْوٌ نَجَاسَةٌ':Added, #2: 2	نَحْوِ النَّبِيذِ
u'نَحْوٌ نَجْدٌ':Added, #1: 1	نَحْوِ النَّجَاسَةِ
u'نَحْوٌ نُحَاسٌ':Added, #1: 1	نَحْوَ نَجْدٍ
u'نَحْوٌ نَحْلٌ':Added, #1: 1	نَحْوُ نُحَاسٍ
u'نَحْوٌ نذر':Added, #1: 1	نَحْوِ النَّحْلِ
u'نَحْوٌ نَذْرٌ':Added, #1: 1	نَحْوِ النَّذْرِ
u'نَحْوٌ نذر':Added, #1: 1	نَحْوِ النَّذْرِ
u'نَحْوٌ نَذْرٌ':Added, #1: 1	نَحْوِ نَذْرِ
u'نَحْوٌ نَذْرٌ':Added, #1: 1	نَحْوِ نَذْرٍ
u'نَحْوٌ نِساءٌ':Added, #1: 1	نَحْوِ نَذْرِ
u'نَحْوٌ نَسَبٌ':Added, #1: 1	نَحْوِ النِّسَاءِ
u'نَحْوٌ نِسْيَانٌ':Added, #1: 1	نَحْوَ النَّسَبِ
u'نَحْوٌ نِصْفٌ':Added, #1: 1	نَحْوِ النِّسْيَانِ
u'نَحْوٌ نِصْفٌ':Added, #2: 2	نَحْوَ النِّصْفِ
u'نَحْوٌ نِصْفٌ':Added, #3: 3	نَحْوَ نِصْفِ
u'نَحْوٌ نَظَرٌ':Added, #3: 3	نَحْوِ نِصْفِ
u'نَحْوٌ نَظَرٌ':Added, #1: 1	نَحْوَ النَّظَرِ
u'نَحْوٌ نَفْسٌ':Added, #2: 2	نَحْوُ النَّظَرِ
u'نَحْوٌ نَفْسٌ':Added, #1: 1	نَحْوِ نَفْسِ
u'نَحْوٌ نُفَسَاءُ':Added, #1: 1	نَحْوَ نَفْسِهِ
u'نَحْوٌ نَفَقَةٌ':Added, #2: 2	نَحْوِ النُّفَسَاءِ
u'نَحْوٌ نَفْيٌ':Added, #2: 2	نَحْوِ نَفَقَةٍ
u'نَحْوٌ نَقْشٌ':Added, #1: 1	نَحْوِ نَفْيِ
u'نَحْوٌ نقل':Added, #1: 1	نَحْوِ نَقْشِهِ
u'نَحْوٌ نَقْلٌ':Added, #1: 1	نَحْوُ نَقْلِ
u'نَحْوٌ نَقِيعٌ':Added, #1: 1	نَحْوُ نَقْلِ
u'نَحْوٌ نكاح':Added, #1: 1	نَحْوِ النَّقِيعِ
u'نَحْوٌ نكاح':Added, #1: 1	نَحْوُ النِّكَاحِ
u'نَحْوٌ نِكَاحٌ':Added, #1: 1	نَحْوِ النِّكَاحِ
u'نَحْوٌ نِكَاحٌ':Added, #1: 1	نَحْوُ النِّكَاحِ
u'نَحْوٌ نكاح':Added, #1: 1	نَحْوِ النِّكَاحِ
u'نَحْوٌ نكاح':Added, #1: 1	نَحْوَ نِكَاحِ
u'نَحْوٌ نِكَاحٌ':Added, #1: 1	نَحْوُ نِكَاحِ
u'نَحْوٌ نِكَاحٌ':Added, #1: 1	نَحْوَ نِكَاحِ
u'نَحْوٌ نَهْبٌ':Added, #1: 1	نَحْوُ نِكَاحِ
u'نَحْوٌ نَهْرٌ':Added, #1: 1	نَحْوِ نَهْبٍ
u'نَحْوٌ نَهْرٌ':Added, #2: 2	نَحْوِ النَّهْرِ
u'نَحْوٌ نَهْيٌ':Added, #2: 2	نَحْوِ نَهْرٍ
u'نَحْوٌ نَوْحٌ':Added, #1: 1	نَحْوَ النَّهْيِ
u'نَحْوٌ نَوْمٌ':Added, #1: 1	نَحْوِ النَّوْحِ
u'نَحْوٌ نِيَّةٌ':Added, #1: 1	نَحْوِ نَوْمِهِ
u'نَحْوٌ نِيَّةٌ':Added, #1: 1	نَحْوُ النِّيَّةِ
u'نَحْوٌ نِيَّةٌ':Added, #1: 1	نَحْوِ النِّيَّةِ
u'نَحْوٌ نِيل':Added, #1: 1	نَحْوِ نِيَّةِ
u'نَحْوٌ نِيلَة':Added, #1: 1	نَحْوِ النِّيلَةِ
u'نَحْوٌ ه':Added, #1: 1	نَحْوِ النِّيلَةِ
u'نَحْوٌ هات':Added, #1: 1	نَحْوُ هَاتِ
u'نَحْوٌ هِبَةٌ':Added, #1: 1	نَحْوُ هَاتِ
u'نَحْوٌ هِبَةٌ':Added, #1: 1	نَحْوُ الْهِبَةِ
u'نَحْوٌ هِبَةٌ':Added, #1: 1	نَحْوَ هِبَةِ
u'نَحْوٌ هِبَةٌ':Added, #1: 1	نَحْوِ هِبَةِ
u'نَحْوٌ هَجِينٌ':Added, #6: 6	نَحْوِ الْهِبَةِ
u'نَحْوٌ هَدْيٌ':Added, #1: 1	نَحْوِ الْهَجِينِ
u'نَحْوٌ هِرٌّ':Added, #1: 1	نَحْوَ هَدْيِ
u'نَحْوٌ هِرٌّ':Added, #1: 1	نَحْوَ الْهِرَّةِ
u'نَحْوٌ هَوَاءٌ':Added, #4: 4	نَحْوِ الْهِرَّةِ
u'نَحْوٌ هَوْدَجٌ':Added, #1: 1	نَحْوَ الْهَوَاءِ
u'نَحْوٌ هُونٌ':Added, #2: 2	نَحْوِ هَوْدَجٍ
u'نَحْوٌ وَاهِبٌ':Added, #1: 1	نَحْوُ الْهُونِ
u'نَحْوٌ وَتْرٌ':Added, #1: 1	نَحْوَ الْوَاهِبِ
u'نَحْوٌ وَثَنِيٌّ':Added, #1: 1	نَحْوِ الْوَتْرِ
u'نَحْوٌ وَجْهٌ':Added, #1: 1	نَحْوُ الْوَثَنِيَّةِ
u'نَحْوٌ وَجْهٌ':Added, #1: 1	نَحْوَ وَجْهِهِ
u'نَحْوٌ وُجُوهٌ':Added, #2: 2	نَحْوِ الْوَجْهِ
u'نَحْوٌ وَدِيعٌ':Added, #1: 1	نَحْوِ وُجُوهِ
u'نَحْوٌ وَدِيعٌ':Added, #1: 1	نَحْوِ الْوَدِيعِ
u'نَحْوٌ وَدِيعَةٌ':Added, #1: 1	نَحْو الْوَدِيعَةِ
u'نَحْوٌ وَرْدٌ':Added, #1: 1	نَحْو الْوَدِيعَةِ
u'نَحْوٌ ورق':Added, #1: 1	نَحْوِ الْوَرْدِ
u'نَحْوٌ وَرَقٌ':Added, #1: 1	نَحْوُ وَرَقِ
u'نَحْوٌ وَرَقٌ':Added, #1: 1	نَحْوُ وَرَقِ
u'نَحْوٌ وَرَقَةٌ':Added, #2: 2	نَحْوِ وَرَقَتَيْنِ
u'نَحْوٌ وِشَاحٌ':Added, #4: 4	نَحْوِ وَرَقَةٍ
u'نَحْوٌ وَصِيٌّ':Added, #1: 1	نَحْوِ وِشَاحٍ
u'نَحْوٌ وَصِيٌّ':Added, #1: 1	نَحْوَ الْوَصِيِّ
u'نَحْوٌ وَصِيٌّ':Added, #1: 1	نَحْوُ الْوَصِيَّةِ
u'نَحْوٌ وَصِيٌّ':Added, #1: 1	نَحْوَ وَصِيٍّ
u'نَحْوٌ وَصِيٌّ':Added, #1: 1	نَحْوِ وَصِيَّةٍ
u'نَحْوٌ وَصِيٌّ':Added, #2: 2	نَحْوِ الْوَصِيِّ
u'نَحْوٌ وَصِيَّةٌ':Added, #3: 3	نَحْوَ الْوَصِيَّةِ
u'نَحْوٌ وَصِيَّةٌ':Added, #1: 1	نَحْوُ الْوَصِيَّةِ
u'نَحْوٌ وَصِيَّةٌ':Added, #1: 1	نَحْوِ وَصِيَّةٍ
u'نَحْوٌ وُضُوءٌ':Added, #3: 3	نَحْوَ الْوَصِيَّةِ
u'نَحْوٌ وُضُوءٌ':Added, #1: 1	نَحْوَ الْوُضُوءِ
u'نَحْوٌ وَطْءٌ':Added, #1: 1	نَحْوُ الْوُضُوءِ
u'نَحْوٌ وَقْفٌ':Added, #1: 1	نَحْوَ الْوَطْءِ
u'نَحْوٌ وُقُوفٌ':Added, #1: 1	نَحْوِ الْوَقْفِ
u'نَحْوٌ وِلاَيَةٌ':Added, #1: 1	نَحْوِ الْوُقُوفِ
u'نَحْوٌ يَاقُوتٌ':Added, #1: 1	نَحْوِ الْوِلَايَةِ
u'نَحْوٌ يَدٌ':Added, #1: 1	نَحْوِ الْيَاقُوتِ
u'نَحْوٌ يَدٌ':Added, #1: 1	نَحْوَ الْيَدِ
u'نَحْوٌ يَدٌ':Added, #1: 1	نَحْوُ الْيَدِ
u'نَحْوٌ يَدٌ':Added, #1: 1	نَحْوُ الْيَدَيْنِ
u'نَحْوٌ يمن':Added, #3: 3	نَحْوِ الْيَدِ
u'نَحْوٌ يَمَنُ':Added, #3: 3	نَحْوَ الْيَمَنِ
u'نَحْوٌ يَوْمٌ':Added, #3: 3	نَحْوَ الْيَمَنِ
u'نَحْوٌ يَوْمٌ':Added, #1: 1	نَحْوِ الْيَوْمَيْنِ
u'نَحْوٌ يَوْمٌ':Added, #1: 1	نَحْوَ يَوْمٍ
u'نَحْوٌ يَوْمٌ':Added, #1: 1	نَحْوُ يَوْمِ
u'نَحَّى اِسْمٌ':Predicate, #1: 1	نَحْوِ يَوْمِ
u'نَحَّى حافِظٌ':Predicate, #1: 1	نَحَّى اسْمَ
u'نَحَّى دَلْوٌ':Predicate, #1: 1	نَحَّى حَافِظَ
u'نَحَّى ذكر':Predicate, #1: 1	نَحَّى الدَّلْوَ
u'نَحَّى ذِكْرٌ':Predicate, #1: 1	نَحَّى ذِكْرَ
u'نَحَّى رَجُلٌ':Subject, #1: 1	نَحَّى ذِكْرَ
u'نَحَّى غُصْنٌ':Predicate, #1: 1	نَحَّى رَجُلٌ
u'نَحَى نَاحِي':Predicate, #1: 1	نَحَّى غُصْنَ
u'نَحَى نَاحِيَةٌ':Predicate, #1: 1	نَحَى نَاحِيَةَ
u'نَحَّى نَجَاسَةٌ':Predicate, #1: 1	نَحَى نَاحِيَةَ
u'نَخَسَ أَجْنَبِيٌّ':Subject, #1: 1	نَحَّى النَّجَاسَةَ
u'نَخَسَ دَابَّةٌ':Predicate, #1: 1	نَخَسَ أَجْنَبِيٌّ
u'نَخَسَ دَابَّةٌ':Predicate, #1: 1	نَخَسَ دَابَّةَ
u'نَخْلٌ أنصار':Added, #3: 3	نَخَسَ الدَّابَّةَ
u'نَخْلٌ أنصار':Added, #1: 1	نَخْلَ الأَنْصَارِ
u'نَخْلٌ أَنْصارٌ':Added, #1: 1	نَخْلُ الأَنْصَارِ
u'نَخْلٌ أَنْصارٌ':Added, #1: 1	نَخْلَ الأَنْصَارِ
u'نَخْلٌ أَنْصَارٌ':Added, #1: 1	نَخْلُ الأَنْصَارِ
u'نَخْلٌ أَنْصَارٌ':Added, #1: 1	نَخْلَ الأَنْصَارِ
u'نَخْلٌ بصرة':Added, #1: 1	نَخْلُ الأَنْصَارِ
u'نَخْلٌ تِجَارَةٌ':Added, #2: 2	نَخْلَ الْبَصْرَةِ
u'نَخْلٌ حائِطٌ':Added, #1: 1	نَخْلُ التِّجَارَةِ
u'نَخْلٌ صغار':Added, #1: 1	نَخْلِ حَائِطٍ
u'نَخْلٌ عَظِيم':Added, #1: 1	نَخْلٍ صِغَارٍ
u'نَخْلٌ فُلاَنٌ':Added, #1: 1	نَخْلٍ عَظِيمٍ
u'نَخْلٌ فُلاَنٌ':Added, #1: 1	نَخْلَ فُلَانٍ
u'نَخْلٌ كُفَّارٌ':Added, #1: 1	نَخْلِ فُلَانٍ
u'نَخْلٌ مَدِينٌ':Added, #2: 2	نَخْلِ الْكُفَّارِ
u'نَخْلٌ مَدِينٌ':Added, #1: 1	نَخْلُ الْمَدِينَةِ
u'نَخْلٌ مَدِينَةٌ':Added, #1: 1	نَخْلِ الْمَدِينَةِ
u'نَخْلٌ مَدِينَةٌ':Added, #1: 1	نَخْلُ الْمَدِينَةِ
u'نَخْلٌ مُساقاة':Added, #1: 1	نَخْلِ الْمَدِينَةِ
u'نَخْلٌ مَعْلُومٌ':Added, #1: 1	نَخْلِ الْمُسَاقَاةِ
u'نَخْوَةٌ جَاهِلِيٌّ':Added, #2: 2	نَخْلٍ مَعْلُومٍ
u'نَخْوَةٌ جَاهِلِيَّةٌ':Added, #1: 1	نَخْوَةَ الْجَاهِلِيّةِ
u'نَخْوَةٌ مُتَقَاعِسٌ':Added, #1: 1	نَخْوَةَ الْجَاهِلِيّةِ
u'نِدَاءٌ أَبْعَدُ':Added, #1: 1	نَخْوَةَ الْمُتَقَاعِسِ
u'نِدَاءٌ اِبْنٌ':Added, #1: 1	نِدَاءَ الْأَبْعَدِ
u'نِدَاءٌ أَصْحَابٌ':Added, #1: 1	نِدَاءِ ابْنِ
u'نِدَاءٌ أمراء':Added, #1: 1	نِدَاءُ أَصْحَابِ
u'نِدَاءٌ أمراء':Added, #1: 1	نِدَاءُ الْأُمَرَاءِ
u'نِدَاءٌ جمعة':Added, #2: 2	نِدَاءِ الْأُمَرَاءِ
u'نِدَاءٌ جُمُعَةٌ':Added, #1: 1	نِدَاءَ الْجُمُعَةِ
u'نِدَاءٌ جمعة':Added, #1: 1	نِدَاءَ الْجُمُعَةِ
u'نِدَاءٌ جُمُعَةٌ':Added, #2: 2	نِدَاءُ الْجُمُعَةِ
u'نِدَاءٌ جمعة':Added, #2: 2	نِدَاءُ الْجُمُعَةِ
u'نِدَاءٌ جُمُعَةٌ':Added, #7: 7	نِدَاءِ الْجُمُعَةِ
u'نِدَاءٌ رَسُولٌ':Added, #7: 7	نِدَاءِ الْجُمُعَةِ
u'نِدَاءٌ صُبْحٌ':Added, #1: 1	نِدَاءَ رَسُولِ
u'نِدَاءٌ صَلاَةٌ':Added, #9: 9	نِدَاءِ الصُّبْحِ
u'نِدَاءٌ عَبَّاسٌ':Added, #1: 1	نِدَاءِ صَلَاةِ
u'نِدَاءٌ عَبْدٌ':Added, #1: 1	نِدَاءَ الْعَبّاسِ
u'نِدَاءٌ فلان':Added, #1: 1	نِدَاءِ عَبْدِهِ
u'نِدَاءٌ فلان':Added, #1: 1	نِدَاءُ بِلالٍ
u'نِدَاءٌ فلان':Added, #1: 1	نِدَاءُ بِلَالٍ
u'نِدَاءٌ نَبِيٌّ':Added, #1: 1	نِدَاءُ بِلاَلٍ
u'نِدَاءٌ واحد':Added, #1: 1	نِدَاءُ النَّبِيِّ
u'نِدَاءٌ وَاحِدٌ':Added, #1: 1	نِدَاءَ وَاحِدٍ
u'نِدَاءٌ يَوْمٌ':Added, #1: 1	نِدَاءَ وَاحِدٍ
u'نَدْبٌ إِتْيانٌ':Added, #1: 1	نِدَاءِ يَوْمِ
u'نَدْبٌ اِحْتِرَامٌ':Added, #1: 1	نَدْبِ الْإِتْيَانِ
u'نَدْبٌ أخْذٌ':Added, #1: 1	نَدْبُ احْتِرَامِ
u'نَدْبٌ أَذَانٌ':Added, #1: 1	نَدْبُ الْأَخْذِ
u'نَدْبٌ أَذَانٌ':Added, #2: 2	نَدْبِ الْأَذَانِ
u'نَدْبٌ إِرَاقَةٌ':Added, #3: 3	نَدْبَ الْأَذَانِ
u'نَدْبٌ إِعادَةٌ':Added, #1: 1	نَدْبِ الْإِرَاقَةِ
u'نَدْبٌ إِعادَةٌ':Added, #1: 1	نَدْبَ إعَادَةِ
u'نَدْبٌ إِعادَةٌ':Added, #1: 1	نَدْبُ إعَادَةِ
u'نَدْبٌ اِعْتِكافٌ':Added, #2: 2	نَدْبِ إعَادَةِ
u'نَدْبٌ الْمَرْءُ':Added, #1: 1	نَدْبُ اعْتِكَافِ
u'نَدْبٌ بروزٌ':Added, #1: 1	نَدْبُ الْمَرْءِ
u'نَدْبٌ بَيات':Added, #1: 1	نَدْبِ الْبُرُوزِ
u'نَدْبٌ تَأْخِيرٌ':Added, #1: 1	نَدْبُ الْبَيَاتِ
u'نَدْبٌ تَأْخِيرٌ':Added, #1: 1	نَدْبَ التَّأْخِيرِ
u'نَدْبٌ تَأْخِيرٌ':Added, #1: 1	نَدْبُ تَأْخِيرِ
u'نَدْبٌ تَحَامُلٌ':Added, #2: 2	نَدْبُ التَّأْخِيرِ
u'نَدْبٌ تَحْدِيدٌ':Added, #1: 1	نَدْبِ التَّحَامُلِ
u'نَدْبٌ تَخَلُّفٌ':Added, #1: 1	نَدْبَ التَّحْدِيدِ
u'نَدْبٌ تَرْكٌ':Added, #1: 1	نَدْبِ تَخَلُّفِهِ
u'نَدْبٌ تَصَدُّقٌ':Added, #1: 1	نَدْبِ تَرْكِ
u'نَدْبٌ تَصَدُّقٌ':Added, #1: 1	نَدْبَ التَّصَدُّقِ
u'نَدْبٌ تَعْجِيل':Added, #3: 3	نَدْبِ التَّصَدُّقِ
u'نَدْبٌ تَعْلِيمٌ':Added, #2: 2	نَدْبِ التَّعْجِيلِ
u'نَدْبٌ تَعَوُّذٌ':Added, #1: 1	نَدْبَ التَّعْلِيمِ
u'نَدْبٌ تَقْديمٌ':Added, #2: 2	نَدْبِ التَّعَوُّذِ
u'نَدْبٌ تَقْديمٌ':Added, #1: 1	نَدْبِ التَّقْدِيمِ
u'نَدْبٌ تَقْصيرٌ':Added, #1: 1	نَدْبُ تَقْدِيمِ
u'نَدْبٌ تَقْصيرٌ':Added, #1: 1	نَدْبِ التَّقْصِيرِ
u'نَدْبٌ تَكْرارٌ':Added, #3: 3	نَدْبِ تَقْصِيرِ
u'نَدْبٌ تَنْبِيهٌ':Added, #1: 1	نَدْبِ تَكْرَارِ
u'نَدْبٌ تَنْظِيفٌ':Added, #2: 2	نَدْبِ تَنْبِيهِ
u'نَدْبٌ تَنَفُّلٌ':Added, #2: 2	نَدْبَ التَّنْظِيفِ
u'نَدْبٌ جَمَاعَةٌ':Added, #1: 1	نَدْبِ التَّنَفُّلِ
u'نَدَبَ حاكِمٌ':Subject, #1: 1	نَدْبَ الْجَمَاعَةِ
u'نَدْبٌ خُرُوجٌ':Added, #1: 1	نَدَبَ الْحَاكِمُ
u'نَدْبٌ خُرُوجٌ':Added, #1: 1	نَدْبَ الْخُرُوجِ
u'نَدْبٌ خُرُوجٌ':Added, #1: 1	نَدْبِ الْخُرُوجِ
u'نَدْبٌ دُعَاءٌ':Added, #1: 1	نَدْبَ خُرُوجِ
u'نَدْبٌ دُعَاءٌ':Added, #1: 1	نَدْبُ الدُّعَاءِ
u'نَدْبٌ ذكر':Added, #1: 1	نَدْبِ دُعَاءِ
u'نَدْبٌ ذِكْرٌ':Added, #1: 1	نَدْبِ ذِكْرِهِ
u'نَدْبٌ ذَهَابٌ':Added, #1: 1	نَدْبِ ذِكْرِهِ
u'نَدْبٌ رُجُوعٌ':Added, #1: 1	نَدْبِ الذَّهَابِ
u'نَدَبَ رَسُولٌ':Subject, #2: 2	نَدْبِ الرُّجُوعِ
u'نَدْبٌ رَسُولٌ':Added, #4: 4	نَدَبَ رَسُولُ
u'نَدْبٌ رَفْعٌ':Added, #1: 1	نَدْبُ رَسُولِ
u'نَدْبٌ زَوْجٌ':Added, #1: 1	نَدْبِ الرَّفْعِ
u'نَدْبٌ زِيادَةٌ':Added, #1: 1	نَدْبُ الزَّوْجِ
u'نَدْبٌ سلام':Added, #1: 1	نَدْبِ زِيَادَتِهِ
u'نَدْبٌ سَلاَمٌ':Added, #1: 1	نَدْبِ السَّلَامِ
u'نَدَبَ شَارِعٌ':Subject, #1: 1	نَدْبِ السَّلَامِ
u'نَدَبَ شَرْعٌ':Subject, #2: 2	نَدَبَ الشَّارِعُ
u'نَدْبٌ شَرْعٌ':Added, #6: 6	نَدَبَ الشَّرْعُ
u'نَدْبٌ صدقة':Added, #1: 1	نَدْبِ الشَّرْعِ
u'نَدْبٌ صَدَقَةٌ':Added, #1: 1	نَدْبُ الصَّدَقَةِ
u'نَدْبٌ صَلاَةٌ':Added, #1: 1	نَدْبُ الصَّدَقَةِ
u'نَدَبَ صَوْمٌ':Predicate, #1: 1	نَدْبَ الصَّلَاةِ
u'نَدْبٌ صَوْمٌ':Added, #1: 1	نَدَبَ الصَّوْمَ
u'نَدْبٌ صَوْمٌ':Added, #1: 1	نَدْبُ صَوْمِ
u'نَدْبٌ صَوْمٌ':Added, #1: 1	نَدْبُ صَوْمِهِ
u'نَدْبٌ طلب':Added, #1: 1	نَدْبِ صَوْمِهِ
u'نَدْبٌ طَلَبٌ':Added, #1: 1	نَدْبُ طَلَبِ
u'نَدْبٌ طواف':Added, #1: 1	نَدْبُ طَلَبِ
u'نَدْبٌ طَوَافٌ':Added, #1: 1	نَدْبِ طَوَافِ
u'نَدْبٌ عَدَمٌ':Added, #1: 1	نَدْبِ طَوَافِ
u'نَدَّ بَعيرٌ':Subject, #1: 1	نَدْبُ عَدَمِ
u'نَدَّ بَعيرٌ':Subject, #2: 2	نَدَّ الْبَعِيرُ
u'نَدْبٌ غُسْلٌ':Added, #3: 3	نَدَّ بَعِيرٌ
u'نَدْبٌ غَسْلٌ':Added, #1: 1	نَدْبِ غُسْلِ
u'نَدْبٌ فِعْلٌ':Added, #3: 3	نَدْبِ غَسْلِ
u'نَدْبٌ فِعْلٌ':Added, #1: 1	نَدْبِ الْفِعْلِ
u'نَدْبٌ فَكٌّ':Added, #1: 1	نَدْبُ فِعْلِهِ
u'نَدْبٌ قتل':Added, #1: 1	نَدْبِ فَكِّ
u'نَدْبٌ قتل':Added, #1: 1	نَدْبُ قَتْلِهِ
u'نَدْبٌ قَتْلٌ':Added, #1: 1	نَدْبِ قَتْلِهِ
u'نَدْبٌ قَتْلٌ':Added, #1: 1	نَدْبُ قَتْلِهِ
u'نَدْبٌ قِرَاءةٌ':Added, #1: 1	نَدْبِ قَتْلِهِ
u'نَدْبٌ قَطْعٌ':Added, #1: 1	نَدْبَ قِرَاءَةِ
u'نَدْبٌ قيام':Added, #1: 1	نَدْبِ قَطْعِهِ
u'نَدْبٌ قِيَامٌ':Added, #2: 2	نَدْبِ الْقِيَامِ
u'نَدْبٌ كَفَّارٌ':Added, #2: 2	نَدْبِ الْقِيَامِ
u'نَدْبٌ كَفَّارَةٌ':Added, #1: 1	نَدْبِ الْكَفَّارَةِ
u'نَدْبٌ لبس':Added, #1: 1	نَدْبِ الْكَفَّارَةِ
u'نَدْبٌ لُبْسٌ':Added, #1: 1	نَدْبِ لُبْسِ
u'نَدْبٌ لبس':Added, #1: 1	نَدْبِ لُبْسِ
u'نَدْبٌ لُبْسٌ':Added, #1: 1	نَدْبِ لُبْسِهِ
u'نَدْبٌ مُسَارَعَةٌ':Added, #1: 1	نَدْبِ لُبْسِهِ
u'نَدَبَ مُسْلِمٌ':Predicate, #1: 1	نَدْبِ الْمُسَارَعَةِ
u'نَدْبٌ مُشَاوَرَةٌ':Added, #2: 2	نَدَبَ الْمُسْلِمِينَ
u'نَدْبٌ مُصَافَحَةٌ':Added, #1: 1	نَدْبَ الْمُشَاوَرَةِ
u'نَدَبَ مُكَاتَبَةٌ':Predicate, #1: 1	نَدْبُ الْمُصَافَحَةِ
u'نَدْبٌ مُكَاتَبَةٌ':Added, #1: 1	نَدَبَ مُكَاتَبَةَ
u'نَدَبَ نَبِيٌّ':Subject, #1: 1	نَدْبِ مُكَاتَبَةِ
u'نَدَبَ نَظَرٌ':Predicate, #2: 2	نَدَبَ النَّبِيُّ
u'نَدْبٌ نَفْلٌ':Added, #1: 1	نَدَبَ النَّظَرَ
u'نَدْبٌ وَضْعٌ':Added, #1: 1	نَدْبُ النَّفْلِ
u'نَدْبٌ وُضُوءٌ':Added, #1: 1	نَدْبِ وَضْعِ
u'نَدَّ حَلٌّ':Predicate, #1: 1	نَدْبِ الْوُضُوءِ
u'نَدَرَ إِمْكانٌ':Predicate, #1: 1	نَدَّ حَلَّ
u'نَدْرَةٌ مَعْدِنٌ':Added, #1: 1	نَدَرَ الْإِمْكَانَ
u'نَدَفَ قُطْنٌ':Predicate, #1: 1	نَدْرَةِ الْمَعْدِنِ
u'نَدِمَ بَائِعٌ':Subject, #1: 1	نَدَفَ الْقُطْنَ
u'نَدِمَ عَبْدٌ':Subject, #1: 1	نَدِمَ الْبَائِعُ
u'نَدَمٌ عَبْدٌ':Added, #1: 1	نَدِمَ عَبْدُ
u'نَدِمَ غَاصِبٌ':Subject, #1: 1	نَدَمُ الْعَبْدِ
u'نَدِمَ فلان':Subject, #1: 1	نَدِمَ الْغَاصِبُ
u'نَدِمَ مُحَمَّدٌ':Subject, #2: 2	نَدِمَ عُثْمَانُ
u'نَدِمَ مَغْبُونٌ':Subject, #1: 1	نَدِمَ مُحَمّدٌ
u'نَدِمَ نَاسٌ':Subject, #1: 1	نَدِمَ الْمَغْبُونُ
u'نَدِمَ يَسِيرٌ':Subject, #1: 1	نَدِمَ النّاسُ
u'نُدُورٌ عَوْدٌ':Added, #1: 1	نَدِمَ الْيَسِيرُ
u'نُدُورٌ كَوْنٌ':Added, #1: 1	نُدُورِ عَوْدِ
u'نَذَالَةٌ خَطٌّ':Added, #1: 1	نُدُورُ كَوْنِهِ
u'نَذَرَ اِبْتِداءٌ':Predicate, #1: 1	نَذَالَةِ خَطِّهِ
u'نَذَرَ أبَدٌ':Predicate, #1: 1	نَذَرَ ابْتِدَاءَ
u'نَذَرَ إتْمَامٌ':Predicate, #1: 1	نَذَرَ الْأَبَدَ
u'نَذَرَ إِتْيانٌ':Predicate, #4: 4	نَذَرَ إتْمَامَ
u'نَذَرَ إِتْيانٌ':Predicate, #1: 1	نَذَرَ الْإِتْيَانَ
u'نذر إِتْيانٌ':Added, #7: 7	نَذَرَ إتْيَانَ
u'نَذْرٌ إِتْيانٌ':Added, #1: 1	نَذْرُ إتْيَانِ
u'نذر أَحْرارٌ':Added, #1: 1	نَذْرُ إتْيَانِ
u'نَذْرٌ أَحْرارٌ':Added, #1: 1	نَذْرُ الْأَحْرَارِ
u'نَذَرَ إِحْرَامٌ':Predicate, #1: 1	نَذْرُ الْأَحْرَارِ
u'نذر إِحْرَامٌ':Added, #4: 4	نَذَرَ الْإِحْرَامَ
u'نَذْرٌ إِحْرَامٌ':Added, #1: 1	نَذْرِ الْإِحْرَامِ
u'نَذَرَ أَدَاءٌ':Predicate, #1: 1	نَذْرِ الْإِحْرَامِ
u'نَذَرَ أَرْبَعُ':Predicate, #1: 1	نَذَرَ أَدَاءَ
u'نَذَرَ أصل':Predicate, #1: 1	نَذَرَ أَرْبَعَ
u'نَذَرَ أًصْلٌ':Predicate, #1: 1	نَذَرَ أَصْلَ
u'نَذَرَ إِطْعامٌ':Predicate, #1: 1	نَذَرَ أَصْلَ
u'نَذَرَ اِعْتاق':Predicate, #2: 2	نَذَرَ إطْعَامَ
u'نَذَرَ إِعْتاقٌ':Predicate, #1: 1	نَذَرَ اعْتَاقَ
u'نَذَرَ اِعْتِكافٌ':Predicate, #5: 5	نَذَرَ إعْتَاقَ
u'نذر اِعْتِكافٌ':Added, #73: 73	نَذَرَ اعْتِكَافَ
u'نذر اِعْتِكافٌ':Added, #1: 1	نَذْرُ اعْتِكَافِ
u'نَذْرٌ اِعْتِكافٌ':Added, #1: 1	نَذْرِ اعْتِكَافِ
u'نَذْرٌ اِعْتِكافٌ':Added, #1: 1	نَذْرُ اعْتِكَافِ
u'نذر اِعْتِكافٌ':Added, #1: 1	نَذْرِ اعْتِكَافِ
u'نذر اِعْتِكافٌ':Added, #1: 1	نَذْرَ اعْتِكَافِهِ
u'نَذْرٌ اِعْتِكافٌ':Added, #1: 1	نَذْرُ اعْتِكَافِهِ
u'نَذْرٌ اِعْتِكافٌ':Added, #1: 1	نَذْرَ اعْتِكَافِهِ
u'نذر إعْطَاءٌ':Added, #1: 1	نَذْرُ اعْتِكَافِهِ
u'نَذْرٌ إعْطَاءٌ':Added, #2: 2	نَذْرِ إعْطَاءِ
u'نَذَرَ أَكْثَرُ':Predicate, #2: 2	نَذْرِ إعْطَاءِ
u'نَذَرَ ألف':Predicate, #1: 1	نَذَرَ أَكْثَرَ
u'نَذَرَ ألْفٌ':Predicate, #2: 2	نَذَرَ أَلْفَ
u'نَذَرَ أَلْفٌ':Predicate, #2: 2	نَذَرَ أَلْفَ
u'نذر أُمٌّ':Added, #2: 2	نَذَرَ أَلْفَ
u'نَذْرٌ أُمٌّ':Added, #1: 1	نَذْرِ أُمّهِ
u'نَذَرَ إمَامٌ':Subject, #1: 1	نَذْرِ أُمّهِ
u'نَذَرَ إِنْسانٌ':Subject, #4: 4	نَذَرَ الْإِمَامُ
u'نذر إِنْسانٌ':Added, #1: 1	نَذَرَ الإِنْسَانُ
u'نَذْرٌ إِنْسانٌ':Added, #1: 1	نَذْرَ الْإِنْسَانِ
u'نَذَرَ إهْدَاءٌ':Predicate, #1: 1	نَذْرَ الْإِنْسَانِ
u'نَذَرَ أهْلٌ':Subject, #1: 1	نَذَرَ إهْدَاءَ
u'نَذَرَ أَوَّلُ':Predicate, #1: 1	نَذَرَ أَهْلُ
u'نَذَرَ أيَّامٌ':Predicate, #1: 1	نَذَرَ الْأَوَّلَ
u'نَذَرَ أَيَّامٌ':Predicate, #1: 1	نَذَرَ أَيَّامَ
u'نذر أيَّامٌ':Added, #1: 1	نَذَرَ أَيَّامَ
u'نذر أَيَّامٌ':Added, #1: 1	نَذْرِ الْأَيَّامِ
u'نَذْرٌ أيَّامٌ':Added, #1: 1	نَذْرِ الْأَيَّامِ
u'نَذْرٌ أَيَّامٌ':Added, #1: 1	نَذْرِ الْأَيَّامِ
u'نذر أيَّامٌ':Added, #1: 1	نَذْرِ الْأَيَّامِ
u'نذر أيَّامٌ':Added, #1: 1	نَذْرُ أَيَّامِ
u'نذر أَيَّامٌ':Added, #1: 1	نَذْرِ أَيَّامٍ
u'نذر أَيَّامٌ':Added, #1: 1	نَذْرُ أَيَّامِ
u'نَذْرٌ أيَّامٌ':Added, #1: 1	نَذْرِ أَيَّامٍ
u'نَذْرٌ أيَّامٌ':Added, #1: 1	نَذْرُ أَيَّامِ
u'نَذْرٌ أَيَّامٌ':Added, #1: 1	نَذْرِ أَيَّامٍ
u'نَذْرٌ أَيَّامٌ':Added, #1: 1	نَذْرُ أَيَّامِ
u'نَذَرَ بَائِعٌ':Subject, #1: 1	نَذْرِ أَيَّامٍ
u'نَذَرَ بَعْضٌ':Predicate, #1: 1	نَذَرَ الْبَائِعُ
u'نذر بَعْضٌ':Added, #6: 6	نَذَرَ بَعْضَ
u'نَذْرٌ بَعْضٌ':Added, #1: 1	نَذْرُ بَعْضِ
u'نذر بِنَاءٌ':Added, #1: 1	نَذْرُ بَعْضِ
u'نَذْرٌ بِنَاءٌ':Added, #2: 2	نَذْرُ بِنَاءِ
u'نذر بَيْعٌ':Added, #2: 2	نَذْرُ بِنَاءِ
u'نَذْرٌ بَيْعٌ':Added, #1: 1	نَذْرُ بَيْعِ
u'نَذَرَ تَجْدِيدٌ':Predicate, #1: 1	نَذْرُ بَيْعِ
u'نذر تَحْلِيقٌ':Added, #1: 1	نَذَرَ التَّجْدِيدَ
u'نَذْرٌ تَحْلِيقٌ':Added, #1: 1	نَذْرُ التَّحْلِيقِ
u'نذر تَرْكٌ':Added, #1: 1	نَذْرُ التَّحْلِيقِ
u'نَذْرٌ تَرْكٌ':Added, #1: 1	نَذْرُ تَرْكِ
u'نَذَرَ تَصَدُّقٌ':Predicate, #1: 1	نَذْرُ تَرْكِ
u'نذر تَصَدُّقٌ':Added, #19: 19	نَذَرَ التَّصَدُّقَ
u'نَذْرٌ تَصَدُّقٌ':Added, #1: 1	نَذْرَ التَّصَدُّقِ
u'نذر تَصَدُّقٌ':Added, #1: 1	نَذْرَ التَّصَدُّقِ
u'نَذْرٌ تَصَدُّقٌ':Added, #2: 2	نَذْرُ التَّصَدُّقِ
u'نذر تَصَدُّقٌ':Added, #2: 2	نَذْرُ التَّصَدُّقِ
u'نَذْرٌ تَصَدُّقٌ':Added, #3: 3	نَذْرِ التَّصَدُّقِ
u'نَذَرَ تَضْحِيَةٌ':Predicate, #3: 3	نَذْرِ التَّصَدُّقِ
u'نذر تَقَرُّبٌ':Added, #3: 3	نَذَرَ التَّضْحِيَةَ
u'نَذْرٌ تَقَرُّبٌ':Added, #1: 1	نَذْرِ تَقَرُّبٍ
u'نَذَرَ تَكْفينٌ':Predicate, #1: 1	نَذْرِ تَقَرُّبٍ
u'نَذَرَ تَمَتُّعٌ':Predicate, #1: 1	نَذَرَ تَكْفِينَ
u'نذر تَيَمُّمٌ':Added, #1: 1	نَذَرَ التَّمَتُّعَ
u'نَذْرٌ تَيَمُّمٌ':Added, #1: 1	نَذْرُ التَّيَمُّمِ
u'نَذَرَ جَذَع':Predicate, #1: 1	نَذْرُ التَّيَمُّمِ
u'نذر جَمَاعَةٌ':Added, #2: 2	نَذَرَ جَذَعَةً
u'نَذْرٌ جَمَاعَةٌ':Added, #1: 1	نَذْرِ الْجَمَاعَةِ
u'نَذَرَ جهاد':Predicate, #1: 1	نَذْرِ الْجَمَاعَةِ
u'نَذَرَ جِهَادٌ':Predicate, #1: 1	نَذَرَ الْجِهَادَ
u'نَذَرَ جِوَارٌ':Predicate, #1: 1	نَذَرَ الْجِهَادَ
u'نذر حاجٌّ':Added, #1: 1	نَذَرَ جِوَارَ
u'نَذْرٌ حاجٌّ':Added, #1: 1	نَذْرِ الْحَاجِّ
u'نَذَرَ حَجٌّ':Predicate, #1: 1	نَذْرِ الْحَاجِّ
u'نذر حَجٌّ':Added, #20: 20	نَذَرَ الْحَجَّ
u'نَذْرٌ حَجٌّ':Added, #2: 2	نَذْرُ الْحَجِّ
u'نذر حِجَّةٌ':Added, #2: 2	نَذْرُ الْحَجِّ
u'نَذْرٌ حِجَّةٌ':Added, #1: 1	نَذْرُ الْحِجَّةِ
u'نَذَرَ خُرُوجٌ':Predicate, #1: 1	نَذْرُ الْحِجَّةِ
u'نذر دَرَاهِمُ':Added, #1: 1	نَذَرَ الْخُرُوجَ
u'نَذْرٌ دَرَاهِمُ':Added, #1: 1	نَذْرُ الدَّرَاهِمِ
u'نذر ذِبْحٌ':Added, #1: 1	نَذْرُ الدَّرَاهِمِ
u'نَذْرٌ ذِبْحٌ':Added, #1: 1	نَذْرِ ذِبْحِ
u'نَذَرَ ذَهَابٌ':Predicate, #1: 1	نَذْرِ ذِبْحِ
u'نَذَرَ رَبُّ':Subject, #1: 1	نَذَرَ الذَّهَابَ
u'نَذَرَ رباط':Predicate, #4: 4	نَذَرَ رَبُّ
u'نَذَرَ رِبَاطٌ':Predicate, #3: 3	نَذَرَ الرِّبَاطَ
u'نَذَرَ رَجُلٌ':Subject, #3: 3	نَذَرَ الرِّبَاطَ
u'نَذَرَ رَجُلٌ':Subject, #1: 1	نَذَرَ رَجُلٌ
u'نَذَرَ رُكوبٌ':Predicate, #2: 2	نَذَرَ الرَّجُلُ
u'نَذَرَ زِيارَةٌ':Predicate, #4: 4	نَذَرَ الرُّكُوبَ
u'نَذْرٌ سَابِقٌ':Added, #1: 1	نَذَرَ زِيَارَةَ
u'نَذَرَ سَتْرٌ':Predicate, #1: 1	نَذْرٍ سَابِقٍ
u'نَذَرَ سجدة':Predicate, #2: 2	نَذَرَ سَتْرَ
u'نَذَرَ سَجْدَةٌ':Predicate, #2: 2	نَذَرَ سَجْدَةَ
u'نَذَرَ سُجُودٌ':Predicate, #2: 2	نَذَرَ سَجْدَةَ
u'نَذَرَ سنن':Predicate, #1: 1	نَذَرَ سُجُودَ
u'نَذَرَ شَخْصٌ':Subject, #1: 1	نَذَرَ السُّنَنَ
u'نَذَرَ شرب':Predicate, #1: 1	نَذَرَ شَخْصٌ
u'نَذَرَ شُرْبٌ':Predicate, #1: 1	نَذَرَ شُرْبَ
u'نذر شرب':Added, #1: 1	نَذَرَ شُرْبَ
u'نَذْرٌ شرب':Added, #1: 1	نَذْرَ شُرْبِ
u'نذر شُرْبٌ':Added, #1: 1	نَذْرَ شُرْبِ
u'نَذْرٌ شُرْبٌ':Added, #1: 1	نَذْرَ شُرْبِ
u'نذر شُكْرٌ':Added, #1: 1	نَذْرَ شُرْبِ
u'نَذْرٌ شُكْرٌ':Added, #1: 1	نَذْرُ شُكْرٍ
u'نذر شكر':Added, #1: 1	نَذْرُ شُكْرٍ
u'نَذْرٌ شكر':Added, #1: 1	نَذْرُ شُكْرِهِ
u'نذر شُكْرٌ':Added, #1: 1	نَذْرُ شُكْرِهِ
u'نَذْرٌ شُكْرٌ':Added, #1: 1	نَذْرُ شُكْرِهِ
u'نذر شُمُوعٌ':Added, #1: 1	نَذْرُ شُكْرِهِ
u'نَذْرٌ شُمُوعٌ':Added, #1: 1	نَذْرِ الشُّمُوعِ
u'نذر شَيْءٌ':Added, #1: 1	نَذْرِ الشُّمُوعِ
u'نَذْرٌ شَيْءٌ':Added, #2: 2	نَذْرُ شَيْءٍ
u'نذر شَيْخٌ':Added, #2: 2	نَذْرُ شَيْءٍ
u'نَذْرٌ شَيْخٌ':Added, #1: 1	نَذْرِ الشَّيْخِ
u'نَذَرَ صدقة':Predicate, #1: 1	نَذْرِ الشَّيْخِ
u'نَذَرَ صَدَقَةٌ':Predicate, #1: 1	نَذَرَ صَدَقَةَ
u'نَذَرَ صدقة':Predicate, #1: 1	نَذَرَ صَدَقَةَ
u'نَذَرَ صَدَقَةٌ':Predicate, #24: 24	نَذَرَ الصَّدَقَةَ
u'نذر صدقة':Added, #24: 24	نَذَرَ الصَّدَقَةَ
u'نَذْرٌ صدقة':Added, #3: 3	نَذْرِ الصَّدَقَةِ
u'نذر صَدَقَةٌ':Added, #3: 3	نَذْرِ الصَّدَقَةِ
u'نَذْرٌ صَدَقَةٌ':Added, #3: 3	نَذْرِ الصَّدَقَةِ
u'نَذَرَ صَرْفٌ':Predicate, #3: 3	نَذْرِ الصَّدَقَةِ
u'نَذَرَ صَرْف':Predicate, #1: 1	نَذَرَ صَرْفَ
u'نَذَرَ صَلاَةٌ':Predicate, #1: 1	نَذَرَ صَرْفَ
u'نَذَرَ صَلاَةٌ':Predicate, #21: 21	نَذَرَ الصَّلَاةَ
u'نذر صَلاَةٌ':Added, #2: 2	نَذَرَ صَلَاةَ
u'نَذْرٌ صَلاَةٌ':Added, #1: 1	نَذْرُ الصَّلَاةِ
u'نذر صَلاَةٌ':Added, #1: 1	نَذْرُ الصَّلَاةِ
u'نَذْرٌ صَلاَةٌ':Added, #1: 1	نَذْرِ صَلَاةِ
u'نذر صَلاَةٌ':Added, #1: 1	نَذْرِ صَلَاةِ
u'نَذْرٌ صَلاَةٌ':Added, #2: 2	نَذْرِ الصَّلَاةِ
u'نَذَرَ صَوْمٌ':Predicate, #2: 2	نَذْرِ الصَّلَاةِ
u'نَذَرَ صَوْمٌ':Predicate, #120: 120	نَذَرَ صَوْمَ
u'نذر صَوْمٌ':Added, #7: 7	نَذَرَ الصَّوْمَ
u'نَذْرٌ صَوْمٌ':Added, #10: 10	نَذْرِ الصَّوْمِ
u'نذر صَوْمٌ':Added, #10: 10	نَذْرِ الصَّوْمِ
u'نَذْرٌ صَوْمٌ':Added, #19: 19	نَذْرِ صَوْمِ
u'نذر صَوْمٌ':Added, #19: 19	نَذْرِ صَوْمِ
u'نَذْرٌ صَوْمٌ':Added, #1: 1	نَذْرِ صَوْمٍ
u'نذر صَوْمٌ':Added, #1: 1	نَذْرِ صَوْمٍ
u'نَذْرٌ صَوْمٌ':Added, #1: 1	نَذْرِ صَوْمِهِ
u'نذر صَوْمٌ':Added, #1: 1	نَذْرِ صَوْمِهِ
u'نَذْرٌ صَوْمٌ':Added, #2: 2	نَذْرُ الصَّوْمِ
u'نذر صَوْمٌ':Added, #2: 2	نَذْرُ الصَّوْمِ
u'نَذْرٌ صَوْمٌ':Added, #2: 2	نَذْرُ صَوْمِهِ
u'نذر صَوْمٌ':Added, #2: 2	نَذْرُ صَوْمِهِ
u'نَذْرٌ صَوْمٌ':Added, #7: 7	نَذْرُ صَوْمِ
u'نَذَرَ صِيَامٌ':Predicate, #7: 7	نَذْرُ صَوْمِ
u'نَذَرَ صِيَامٌ':Predicate, #14: 14	نَذَرَ صِيَامَ
u'نذر صِيَامٌ':Added, #1: 1	نَذَرَ الصِّيَامَ
u'نذر صِيَامٌ':Added, #1: 1	نَذْرُ الصِّيَامِ
u'نَذْرٌ صِيَامٌ':Added, #1: 1	نَذْرِ الصِّيَامِ
u'نَذْرٌ صِيَامٌ':Added, #1: 1	نَذْرُ الصِّيَامِ
u'نذر صِيَامٌ':Added, #1: 1	نَذْرِ الصِّيَامِ
u'نَذْرٌ صِيَامٌ':Added, #1: 1	نَذْرُ صِيَامِ
u'نَذَرَ ضَرْبٌ':Predicate, #1: 1	نَذْرُ صِيَامِ
u'نذر طَاعَةٌ':Added, #1: 1	نَذَرَ ضَرْبَ
u'نَذْرٌ طَاعَةٌ':Added, #1: 1	نَذْرَ الطَّاعَةِ
u'نذر طَاعَةٌ':Added, #1: 1	نَذْرَ الطَّاعَةِ
u'نذر طَاعَةٌ':Added, #3: 3	نَذْرُ الطَّاعَةِ
u'نَذْرٌ طَاعَةٌ':Added, #3: 3	نَذْرِ الطَّاعَةِ
u'نَذْرٌ طَاعَةٌ':Added, #3: 3	نَذْرُ الطَّاعَةِ
u'نَذْرٌ طَلاَقٌ':Added, #3: 3	نَذْرِ الطَّاعَةِ
u'نَذَرَ طواف':Predicate, #1: 1	نَذْرٍ طَلَاقٍ
u'نَذَرَ طَوَافٌ':Predicate, #6: 6	نَذَرَ الطَّوَافَ
u'نذر عَاجِزٌ':Added, #6: 6	نَذَرَ الطَّوَافَ
u'نَذْرٌ عَاجِزٌ':Added, #1: 1	نَذْرُ الْعَاجِزِ
u'نذر عِبَادَةٌ':Added, #1: 1	نَذْرُ الْعَاجِزِ
u'نَذْرٌ عِبَادَةٌ':Added, #1: 1	نَذْرُ الْعِبَادَاتِ
u'نذر عِبَادَةٌ':Added, #1: 1	نَذْرُ الْعِبَادَاتِ
u'نَذْرٌ عِبَادَةٌ':Added, #1: 1	نَذْرُ عِبَادَةٍ
u'نَذَرَ عَبْدٌ':Subject, #1: 1	نَذْرُ عِبَادَةٍ
u'نَذَرَ عَبْدٌ':Subject, #1: 1	نَذَرَ عَبْدٌ
u'نذر عَبْدٌ':Added, #4: 4	نَذَرَ الْعَبْدُ
u'نذر عَبْدٌ':Added, #1: 1	نَذْرَ عَبْدِ
u'نذر عَبْدٌ':Added, #1: 1	نَذْرُ عَبْدِ
u'نَذْرٌ عَبْدٌ':Added, #1: 1	نَذْرِ عَبْدِ
u'نَذْرٌ عَبْدٌ':Added, #1: 1	نَذْرَ عَبْدِ
u'نَذْرٌ عَبْدٌ':Added, #1: 1	نَذْرُ عَبْدِ
u'نَذَرَ عتق':Predicate, #1: 1	نَذْرِ عَبْدِ
u'نَذَرَ عِتْقٌ':Predicate, #14: 14	نَذَرَ عِتْقَ
u'نذر عتق':Added, #14: 14	نَذَرَ عِتْقَ
u'نذر عتق':Added, #1: 1	نَذْر الْعِتْقِ
u'نَذْرٌ عتق':Added, #1: 1	نَذْرُ الْعِتْقِ
u'نَذْرٌ عتق':Added, #1: 1	نَذْر الْعِتْقِ
u'نذر عِتْقٌ':Added, #1: 1	نَذْرُ الْعِتْقِ
u'نذر عِتْقٌ':Added, #1: 1	نَذْر الْعِتْقِ
u'نَذْرٌ عِتْقٌ':Added, #1: 1	نَذْرُ الْعِتْقِ
u'نَذْرٌ عِتْقٌ':Added, #1: 1	نَذْر الْعِتْقِ
u'نذر عتق':Added, #1: 1	نَذْرُ الْعِتْقِ
u'نَذْرٌ عتق':Added, #1: 1	نَذْرِ عِتْقِ
u'نذر عِتْقٌ':Added, #1: 1	نَذْرِ عِتْقِ
u'نذر عِتْقٌ':Added, #1: 1	نَذْرِ عِتْقٍ
u'نَذْرٌ عِتْقٌ':Added, #1: 1	نَذْرِ عِتْقِ
u'نَذْرٌ عِتْقٌ':Added, #1: 1	نَذْرِ عِتْقٍ
u'نَذَرَ عَدَمٌ':Predicate, #1: 1	نَذْرِ عِتْقِ
u'نَذَرَ عَشْرٌ':Predicate, #2: 2	نَذَرَ عَدَمَ
u'نَذَرَ عُكُوفٌ':Predicate, #1: 1	نَذَرَ عَشْرَ
u'نذر عُكُوفٌ':Added, #1: 1	نَذَرَ عُكُوفَ
u'نَذْرٌ عُكُوفٌ':Added, #1: 1	نَذْرُ عُكُوفٍ
u'نذر عمرة':Added, #1: 1	نَذْرُ عُكُوفٍ
u'نَذْرٌ عمرة':Added, #1: 1	نَذْرِ الْعُمْرَةِ
u'نذر عُمْرَةٌ':Added, #1: 1	نَذْرِ الْعُمْرَةِ
u'نَذْرٌ عُمْرَةٌ':Added, #1: 1	نَذْرِ الْعُمْرَةِ
u'نذر غضب':Added, #1: 1	نَذْرِ الْعُمْرَةِ
u'نَذْرٌ غضب':Added, #2: 2	نَذْرُ الْغَضَبِ
u'نذر غَضَبٌ':Added, #2: 2	نَذْرُ الْغَضَبِ
u'نَذْرٌ غَضَبٌ':Added, #2: 2	نَذْرُ الْغَضَبِ
u'نَذَرَ غير':Predicate, #2: 2	نَذْرُ الْغَضَبِ
u'نَذَرَ غَيْرٌ':Predicate, #1: 1	نَذَرَ غَيْرَ
u'نَذَرَ غير':Subject, #1: 1	نَذَرَ غَيْرَ
u'نَذَرَ غَيْرٌ':Subject, #2: 2	نَذَرَ غَيْرُ
u'نذر غير':Added, #2: 2	نَذَرَ غَيْرُ
u'نذر غَيْرٌ':Added, #1: 1	نَذْرِ غَيْرِ
u'نَذْرٌ غير':Added, #1: 1	نَذْرِ غَيْرِ
u'نَذْرٌ غَيْرٌ':Added, #1: 1	نَذْرِ غَيْرِ
u'نذر غير':Added, #1: 1	نَذْرِ غَيْرِ
u'نذر غَيْرٌ':Added, #1: 1	نَذْرِ غَيْرِهِ
u'نَذْرٌ غير':Added, #1: 1	نَذْرِ غَيْرِهِ
u'نَذْرٌ غَيْرٌ':Added, #1: 1	نَذْرِ غَيْرِهِ
u'نَذَرَ فِعْلٌ':Predicate, #1: 1	نَذْرِ غَيْرِهِ
u'نذر قُدُومٌ':Added, #1: 1	نَذَرَ فِعْلَ
u'نَذْرٌ قُدُومٌ':Added, #2: 2	نَذْرَ الْقُدُومِ
u'نَذَرَ قِرَاءةٌ':Predicate, #2: 2	نَذْرَ الْقُدُومِ
u'نَذَرَ قِرَاءةٌ':Predicate, #1: 1	نَذَرَ الْقِرَاءَةَ
u'نَذَرَ قِرَانٌ':Predicate, #2: 2	نَذَرَ قِرَاءَةَ
u'نذر قُرْبٌ':Added, #7: 7	نَذَرَ الْقِرَانَ
u'نَذْرٌ قُرْبٌ':Added, #1: 1	نَذْرِ الْقُرْبِ
u'نذر قُرَبٌ':Added, #1: 1	نَذْرِ الْقُرْبِ
u'نَذْرٌ قُرَبٌ':Added, #2: 2	نَذْرُ الْقُرَبِ
u'نذر قُرْبَةٌ':Added, #2: 2	نَذْرُ الْقُرَبِ
u'نَذْرٌ قُرْبَةٌ':Added, #1: 1	نَذْرِ الْقُرْبَةِ
u'نذر قُرْبَةٌ':Added, #1: 1	نَذْرِ الْقُرْبَةِ
u'نَذْرٌ قُرْبَةٌ':Added, #2: 2	نَذْرَ قُرْبَةٍ
u'نذر قُرْبَةٌ':Added, #2: 2	نَذْرَ قُرْبَةٍ
u'نَذْرٌ قُرْبَةٌ':Added, #5: 5	نَذْرُ قُرْبَةٍ
u'نَذَرَ قَضَاءٌ':Predicate, #5: 5	نَذْرُ قُرْبَةٍ
u'نذر قطعة':Added, #1: 1	نَذَرَ قَضَاءَ
u'نَذْرٌ قطعة':Added, #1: 1	نَذْرُ الْقِطْعَةِ
u'نذر قِطْعَةٌ':Added, #1: 1	نَذْرُ الْقِطْعَةِ
u'نَذْرٌ قِطْعَةٌ':Added, #1: 1	نَذْرُ الْقِطْعَةِ
u'نَذَرَ قِنْدِيلٌ':Predicate, #1: 1	نَذْرُ الْقِطْعَةِ
u'نَذَرَ قيام':Predicate, #1: 1	نَذَرَ قِنْدِيلَ
u'نَذَرَ قِيَامٌ':Predicate, #1: 1	نَذَرَ الْقِيَامَ
u'نَذَرَ قيام':Predicate, #1: 1	نَذَرَ الْقِيَامَ
u'نَذَرَ قِيَامٌ':Predicate, #2: 2	نَذَرَ قِيَامَ
u'نَذَرَ كَافِرٌ':Subject, #2: 2	نَذَرَ قِيَامَ
u'نذر كَافِرٌ':Added, #1: 1	نَذَرَ الْكَافِرُ
u'نذر كَافِرٌ':Added, #1: 1	نَذْرُ الْكَافِرِ
u'نَذْرٌ كَافِرٌ':Added, #1: 1	نَذْرِ الْكَافِرِ
u'نَذْرٌ كَافِرٌ':Added, #1: 1	نَذْرُ الْكَافِرِ
u'نذر لجاج':Added, #1: 1	نَذْرِ الْكَافِرِ
u'نَذْرٌ لجاج':Added, #16: 16	نَذْرِ اللَّجَاجِ
u'نذر لجاج':Added, #16: 16	نَذْرِ اللَّجَاجِ
u'نَذْرٌ لجاج':Added, #1: 1	نَذْرِ اللِّجَاجِ
u'نذر لجاج':Added, #1: 1	نَذْرِ اللِّجَاجِ
u'نذر لجاج':Added, #4: 4	نَذْرَ اللَّجَاجِ
u'نَذْرٌ لجاج':Added, #4: 4	نَذْرُ اللَّجَاجِ
u'نَذْرٌ لجاج':Added, #4: 4	نَذْرَ اللَّجَاجِ
u'نَذَرَ لَيَالِي':Predicate, #4: 4	نَذْرُ اللَّجَاجِ
u'نَذَرَ لَيْلٌ':Predicate, #2: 2	نَذَرَ لَيَالِيَ
u'نَذَرَ لَيْلٌ':Predicate, #1: 1	نَذَرَ اللَّيْلَةَ
u'نذر مُبَاحٌ':Added, #3: 3	نَذَرَ لَيْلَةً
u'نَذْرٌ مُبَاحٌ':Added, #1: 1	نَذْرِ الْمُبَاحِ
u'نذر مُبَاحٌ':Added, #1: 1	نَذْرِ الْمُبَاحِ
u'نَذْرٌ مُبَاحٌ':Added, #1: 1	نَذْرُ الْمُبَاحَاتِ
u'نذر مُبَاحٌ':Added, #1: 1	نَذْرُ الْمُبَاحَاتِ
u'نَذْرٌ مُبَاحٌ':Added, #6: 6	نَذْرُ الْمُبَاحِ
u'نَذْرٌ مُبْهَمٌ':Added, #6: 6	نَذْرُ الْمُبَاحِ
u'نَذَرَ مُتَابَعٌ':Predicate, #1: 1	نَذْرٍ مُبْهَمٍ
u'نَذَرَ مُتَابَعَةٌ':Predicate, #1: 1	نَذَرَ مُتَابَعَةَ
u'نَذْرٌ مُتَتَابِعٌ':Added, #1: 1	نَذَرَ مُتَابَعَةَ
u'نَذَرَ مثل':Predicate, #1: 1	نَذْرٍ مُتَتَابِعٍ
u'نَذَرَ مِثْلٌ':Predicate, #1: 1	نَذَرَ مِثْلَ
u'نذر مُجَازَاةٌ':Added, #1: 1	نَذَرَ مِثْلَ
u'نذر مُجَازَاةٌ':Added, #1: 1	نَذْرَ الْمُجَازَاةِ
u'نَذْرٌ مُجَازَاةٌ':Added, #1: 1	نَذْرُ الْمُجَازَاةِ
u'نَذْرٌ مُجَازَاةٌ':Added, #1: 1	نَذْرَ الْمُجَازَاةِ
u'نذر مُجَازَاةٌ':Added, #1: 1	نَذْرُ الْمُجَازَاةِ
u'نذر مُجَازَاةٌ':Added, #1: 1	نَذْرَ مُجَازَاةٍ
u'نَذْرٌ مُجَازَاةٌ':Added, #1: 1	نَذْرُ مُجَازَاةٍ
u'نَذْرٌ مُجَازَاةٌ':Added, #1: 1	نَذْرَ مُجَازَاةٍ
u'نذر مُجَازَاةٌ':Added, #1: 1	نَذْرُ مُجَازَاةٍ
u'نَذْرٌ مُجَازَاةٌ':Added, #3: 3	نَذْرِ الْمُجَازَاةِ
u'نَذَرَ مَجْذُومٌ':Subject, #3: 3	نَذْرِ الْمُجَازَاةِ
u'نَذَرَ مُحَافَظَةٌ':Predicate, #1: 1	نَذَرَ مَجْذُومٌ
u'نَذْرٌ مُخْتَلَفٌ':Added, #1: 1	نَذَرَ الْمُحَافَظَةَ
u'نذر مَخْلُوقٌ':Added, #1: 1	نَذْرٍ مُخْتَلَفٍ
u'نَذْرٌ مَخْلُوقٌ':Added, #1: 1	نَذْرُ مَخْلُوقٍ
u'نذر مَدِينٌ':Added, #1: 1	نَذْرُ مَخْلُوقٍ
u'نَذْرٌ مَدِينٌ':Added, #4: 4	نَذْرِ الْمَدِينِ
u'نَذَرَ مَرِيضٌ':Subject, #4: 4	نَذْرِ الْمَدِينِ
u'نَذَرَ مُسَافِرٌ':Subject, #1: 1	نَذَرَ الْمَرِيضُ
u'نذر مساكين':Added, #1: 1	نَذَرَ الْمُسَافِرُ
u'نذر مساكين':Added, #3: 3	نَذْرُ الْمَسَاكِينِ
u'نَذْرٌ مساكين':Added, #3: 3	نَذْرِ الْمَسَاكِينِ
u'نَذْرٌ مساكين':Added, #3: 3	نَذْرُ الْمَسَاكِينِ
u'نَذَرَ مَسْحٌ':Predicate, #3: 3	نَذْرِ الْمَسَاكِينِ
u'نَذَرَ مَشْيٌ':Predicate, #1: 1	نَذَرَ مَسْحَ
u'نذر مَشْيٌ':Added, #17: 17	نَذَرَ الْمَشْيَ
u'نَذْرٌ مَشْيٌ':Added, #2: 2	نَذْرِ الْمَشْيِ
u'نَذْرٌ مَضْمُونٌ':Added, #2: 2	نَذْرِ الْمَشْيِ
u'نَذْرٌ مُطْلَقٌ':Added, #1: 1	نَذْرٍ مَضْمُونٍ
u'نذر مَعْصِيَةٌ':Added, #6: 6	نَذْرٍ مُطْلَقٍ
u'نذر مَعْصِيَةٌ':Added, #1: 1	نَذْرَ الْمَعْصِيَةِ
u'نَذْرٌ مَعْصِيَةٌ':Added, #1: 1	نَذْرُ الْمَعْصِيَةِ
u'نَذْرٌ مَعْصِيَةٌ':Added, #1: 1	نَذْرَ الْمَعْصِيَةِ
u'نذر مَعْصِيَةٌ':Added, #1: 1	نَذْرُ الْمَعْصِيَةِ
u'نَذْرٌ مَعْصِيَةٌ':Added, #2: 2	نَذْرِ الْمَعْصِيَةِ
u'نذر مَعْصِيَةٌ':Added, #2: 2	نَذْرِ الْمَعْصِيَةِ
u'نَذْرٌ مَعْصِيَةٌ':Added, #2: 2	نَذْرَ مَعْصِيَةٍ
u'نذر مَعْصِيَةٌ':Added, #2: 2	نَذْرَ مَعْصِيَةٍ
u'نَذْرٌ مَعْصِيَةٌ':Added, #5: 5	نَذْرُ مَعْصِيَةٍ
u'نذر مُعَيَّنٌ':Added, #5: 5	نَذْرُ مَعْصِيَةٍ
u'نَذْرٌ مُعَيَّنٌ':Added, #1: 1	نَذْرِ مُعَيَّنٍ
u'نَذْرٌ مُعَيَّنٌ':Added, #1: 1	نَذْرِ مُعَيَّنٍ
u'نذر مُفْلِسٌ':Added, #8: 8	نَذْرٍ مُعَيَّنٍ
u'نَذْرٌ مُفْلِسٌ':Added, #1: 1	نَذْرِ الْمُفْلِسِ
u'نَذَرَ مُقْتَرِضٌ':Subject, #1: 1	نَذْرِ الْمُفْلِسِ
u'نذر مَكَانٌ':Added, #1: 1	نَذَرَ الْمُقْتَرِضُ
u'نَذْرٌ مَكَانٌ':Added, #1: 1	نَذْرِ الْمَكَانِ
u'نذر مَكْرُوهٌ':Added, #1: 1	نَذْرِ الْمَكَانِ
u'نَذْرٌ مَكْرُوهٌ':Added, #2: 2	نَذْرِ الْمَكْرُوهِ
u'نذر مَكْرُوهٌ':Added, #2: 2	نَذْرِ الْمَكْرُوهِ
u'نَذْرٌ مَكْرُوهٌ':Added, #3: 3	نَذْرُ الْمَكْرُوهِ
u'نَذَرَ مُكَلَّفٌ':Subject, #3: 3	نَذْرُ الْمَكْرُوهِ
u'نَذَرَ مَمْلُوكٌ':Subject, #1: 1	نَذَرَ الْمُكَلَّفُ
u'نَذَرَ نَحْرٌ':Predicate, #1: 1	نَذَرَ الْمَمْلُوكُ
u'نذر نَحْوٌ':Added, #3: 3	نَذَرَ نَحْرَ
u'نَذْرٌ نَحْوٌ':Added, #1: 1	نَذْرِ نَحْوِ
u'نذر نُسُكٌ':Added, #1: 1	نَذْرِ نَحْوِ
u'نَذْرٌ نُسُكٌ':Added, #1: 1	نَذْرِ النُّسُكِ
u'نَذَرَ نِصْفٌ':Predicate, #1: 1	نَذْرِ النُّسُكِ
u'نَذَرَ هَدْيٌ':Predicate, #1: 1	نَذَرَ نِصْفَ
u'نَذَرَ هَدْيٌ':Predicate, #1: 1	نَذَرَ الْهَدْيَ
u'نذر هَدْيٌ':Added, #4: 4	نَذَرَ هَدْيَ
u'نَذْرٌ هَدْيٌ':Added, #1: 1	نَذْرُ الْهَدْيِ
u'نذر هَدِيٌّ':Added, #1: 1	نَذْرُ الْهَدْيِ
u'نَذْرٌ هَدِيٌّ':Added, #1: 1	نَذْرُ الْهَدِيَّةِ
u'نذر هَدْيٌ':Added, #1: 1	نَذْرُ الْهَدِيَّةِ
u'نَذْرٌ هَدْيٌ':Added, #1: 1	نَذْرُ هَدْيِ
u'نذر هَدِيَّةٌ':Added, #1: 1	نَذْرُ هَدْيِ
u'نَذْرٌ هَدِيَّةٌ':Added, #1: 1	نَذْرُ الْهَدِيَّةِ
u'نَذَرَ هَرِمٌ':Subject, #1: 1	نَذْرُ الْهَدِيَّةِ
u'نذر وَاجِبٌ':Added, #1: 1	نَذَرَ الْهَرِمُ
u'نَذْرٌ وَاجِبٌ':Added, #1: 1	نَذْرُ الْوَاجِبِ
u'نذر وَاجِبٌ':Added, #1: 1	نَذْرُ الْوَاجِبِ
u'نَذْرٌ وَاجِبٌ':Added, #1: 1	نَذْرُ الْوَاجِبَاتِ
u'نَذَرَ وَتْرٌ':Predicate, #1: 1	نَذْرُ الْوَاجِبَاتِ
u'نَذَرَ وَجَبٌ':Predicate, #1: 1	نَذَرَ الْوَتْرَ
u'نَذَرَ وُضُوءٌ':Predicate, #1: 1	نَذَرَ وَجَبَ
u'نَذَرَ وُقُوفٌ':Predicate, #2: 2	نَذَرَ الْوُضُوءَ
u'نذر ولد':Added, #1: 1	نَذَرَ الْوُقُوفَ
u'نَذْرٌ ولد':Added, #1: 1	نَذْرُ وَلَدِهِ
u'نذر وَلَدٌ':Added, #1: 1	نَذْرُ وَلَدِهِ
u'نَذْرٌ وَلَدٌ':Added, #1: 1	نَذْرُ وَلَدِهِ
u'نَذَرَ يَوْمٌ':Predicate, #1: 1	نَذْرُ وَلَدِهِ
u'نَذَرَ يَوْمٌ':Predicate, #1: 1	نَذَرَ الْيَوْمَ
u'نذر يَوْمٌ':Added, #2: 2	نَذَرَ يَوْمَ
u'نَذْرٌ يَوْمٌ':Added, #1: 1	نَذْرِ يَوْمِ
u'نذر يَوْمٌ':Added, #1: 1	نَذْرِ يَوْمِ
u'نَذْرٌ يَوْمٌ':Added, #2: 2	نَذْرِ الْيَوْمِ
u'نذر يَوْمٌ':Added, #2: 2	نَذْرِ الْيَوْمِ
u'نَذْرٌ يَوْمٌ':Added, #2: 2	نَذْرُ يَوْمٍ
u'نُذُورٌ جَاهِلِيٌّ':Added, #2: 2	نَذْرُ يَوْمٍ
u'نُذُورٌ جَاهِلِيَّةٌ':Added, #1: 1	نُذُورِ الْجَاهِلِيَّةِ
u'نُذُورٌ مُدَوَّنٌ':Added, #1: 1	نُذُورِ الْجَاهِلِيَّةِ
u'نُذُورٌ مُدَوَّنَةٌ':Added, #1: 1	نُذُورِ الْمُدَوَّنَةِ
u'نُذُورٌ مُقَدِّمٌ':Added, #1: 1	نُذُورِ الْمُدَوَّنَةِ
u'نُذُورٌ مُقَدِّمَةٌ':Added, #1: 1	نُذُورِ الْمُقَدِّمَاتِ
u'نَزَا حِمَارٌ':Subject, #1: 1	نُذُورِ الْمُقَدِّمَاتِ
u'نَزَا حِمَارٌ':Subject, #1: 1	نَزَا الْحِمَارُ
u'نَزَا ذِئْبٌ':Subject, #1: 1	نَزَا حِمَارٌ
u'نَزَا ظَبْيٌ':Subject, #2: 2	نَزَا الذِّئْبُ
u'نزاع زَوْجٌ':Added, #3: 3	نَزَا ظَبْيٌ
u'نِزَاعٌ زَوْجٌ':Added, #1: 1	نِزَاعِ الزَّوْجِ
u'نَزَا فَحْلٌ':Subject, #1: 1	نِزَاعِ الزَّوْجِ
u'نَزَا فَحْلٌ':Subject, #1: 1	نَزَا الْفَحْلُ
u'نزال أرْضٌ':Added, #1: 1	نَزَا فَحْلٌ
u'نزال عَدُوٌّ':Added, #2: 2	أَنْزَالِ الْأَرْضِ
u'نِزَالٌ عَدُوٌّ':Added, #1: 1	نِزَالِ الْعَدُوِّ
u'نزال كَرْمٌ':Added, #1: 1	نِزَالِ الْعَدُوِّ
u'نزال كُرُومٌ':Added, #1: 1	أَنْزَالَ كَرْمٍ
u'نَزَاهَةٌ نَفْسٌ':Added, #1: 1	أَنْزَالَ الْكُرُومِ
u'نَزَحَ بَعْضٌ':Predicate, #1: 1	نَزَاهَةُ النَّفْسِ
u'نَزَحَ قَدْرٌ':Predicate, #1: 1	نَزَحَ الْبَعْضَ
u'نَزَحَ مَاءٌ':Predicate, #1: 1	نَزَحَ الْقَدْرَ
u'نَزَحَ مَاءٌ':Predicate, #1: 1	نَزَحَ الْمَاءَ
u'نَزَعَ اِبْنٌ':Predicate, #2: 2	نَزَحَ مَاءَ
u'نَزَعَ أحَدٌ':Predicate, #1: 1	نَزَعَ ابْنَ
u'نَزَعَ أحَدٌ':Subject, #4: 4	نَزَعَ أَحَدَ
u'نَزْعٌ أحَدٌ':Added, #1: 1	نَزَعَ أَحَدُ
u'نَزْعٌ أحَدٌ':Added, #1: 1	نَزْعَ أَحَدِ
u'نَزْعٌ أحَدٌ':Added, #1: 1	نَزْعُ أَحَدِ
u'نَزَعَ أَخِلَّةٌ':Predicate, #1: 1	نَزْعِ أَحَدِ
u'نَزْعٌ إِزَارٌ':Added, #1: 1	نَزَعَ الأَخِلَّةَ
u'نَزْعٌ إِزَارٌ':Added, #2: 2	نَزْعُ الْإِزَارِ
u'نَزَعَ أَكْثَرُ':Predicate, #2: 2	نَزْعِ الْإِزَارِ
u'نَزْعٌ أَكْثَرُ':Added, #2: 2	نَزَعَ أَكْثَرَ
u'نَزْعٌ أَكْفَانٌ':Added, #1: 1	نَزْعُ أَكْثَرِ
u'نَزَعَ بَابٌ':Predicate, #1: 1	نَزْعَ الْأَكْفَانِ
u'نَزَعَ بَرَكَةٌ':Predicate, #1: 1	نَزَعَ بَابَ
u'نَزَعَ بَعْضٌ':Predicate, #1: 1	نَزَعَ الْبَرَكَةَ
u'نَزَعَ تَاجٌ':Predicate, #1: 1	نَزَعَ بَعْضَ
u'نَزْعٌ تَحْتَانِيٌّ':Added, #1: 1	نَزَعَ تَاجَ
u'نَزَعَ ثَنِيَّةٌ':Predicate, #3: 3	نَزْعُ التَّحْتَانِيِّ
u'نَزَعَ ثَوْبٌ':Predicate, #2: 2	نَزَعَ ثَنِيَّةَ
u'نَزَعَ ثَوْبٌ':Predicate, #1: 1	نَزَعَ ثَوْبَ
u'نَزْعٌ ثَوْبٌ':Added, #4: 4	نَزَعَ الثَّوْبَ
u'نَزَعَ ثِيابٌ':Predicate, #2: 2	نَزْعِ الثَّوْبِ
u'نَزْعٌ ثِيابٌ':Added, #2: 2	نَزَعَ الثِّيَابَ
u'نَزْعٌ ثِيابٌ':Added, #1: 1	نَزْعِ ثِيَابِهِ
u'نَزْعٌ جَبِيرَة':Added, #3: 3	نَزْعِ الثِّيَابِ
u'نَزَعَ جِلْدَةٌ':Predicate, #1: 1	نَزْعُ الْجَبِيرَةِ
u'نَزْعٌ حِلْيَةٌ':Added, #2: 2	نَزَعَ الْجِلْدَةَ
u'نَزْعٌ خِضَابٌ':Added, #3: 3	نَزْعِ الْحِلْيَةِ
u'نَزَعَ خُفٌّ':Predicate, #1: 1	نَزْعِ الْخِضَابِ
u'نَزْعٌ خُفٌّ':Added, #4: 4	نَزَعَ الْخُفَّ
u'نَزْعٌ خُفٌّ':Added, #13: 13	نَزْعُ الْخُفِّ
u'نَزْعٌ خُفٌّ':Added, #1: 1	نَزْعُ خُفٍّ
u'نَزْعٌ خُفٌّ':Added, #2: 2	نَزْعَ الْخُفِّ
u'نَزْعٌ خُفٌّ':Added, #2: 2	نَزْعِ الْخُفَّيْنِ
u'نَزْعٌ خُفٌّ':Added, #4: 4	نَزْعُ الْخُفَّيْنِ
u'نَزْعٌ خَيْطٌ':Added, #8: 8	نَزْعِ الْخُفِّ
u'نَزْعٌ خَيْطٌ':Added, #1: 1	نَزْعُ خَيْطِهِ
u'نَزَعَ دَلٌّ':Predicate, #2: 2	نَزْعِ الْخَيْطِ
u'نَزْعٌ رايَة':Added, #1: 1	نَزَعَ دَلَّ
u'نَزَعَ رَجُلٌ':Subject, #1: 1	نَزْعَ الرّايَةِ
u'نَزَعَ سَرْجٌ':Predicate, #2: 2	نَزَعَ الرَّجُلُ
u'نَزَعَ سِنٌّ':Predicate, #1: 1	نَزَعَ السَّرْجَ
u'نَزْعٌ سَوْطٌ':Added, #9: 9	نَزَعَ سِنَّ
u'نَزَعَ شَوْكَةٌ':Predicate, #1: 1	نَزْعُ سَوْطٍ
u'نَزْعٌ شَيْءٌ':Added, #1: 1	نَزَعَ الشَّوْكَةَ
u'نَزْعٌ صَبِيٌّ':Added, #2: 2	نَزْعُ شَيْءٍ
u'نَزَعَ صغار':Predicate, #1: 1	نَزْعِ الصَّبِيِّ
u'نَزَعَ صَغَارٌ':Predicate, #2: 2	نَزَعَ صَغَارَ
u'نَزْعٌ ضرس':Added, #2: 2	نَزَعَ صَغَارَ
u'نَزْعٌ ضِرْسٌ':Added, #1: 1	نَزْعَ الضِّرْسِ
u'نَزَعَ طِيبٌ':Predicate, #1: 1	نَزْعَ الضِّرْسِ
u'نَزْعٌ عجم':Added, #1: 1	نَزَعَ الطِّيبَ
u'نَزْعٌ عَجَمٌ':Added, #1: 1	نَزْعِ عَجَمِهِ
u'نَزْعٌ عِرْقٌ':Added, #1: 1	نَزْعِ عَجَمِهِ
u'نَزْعٌ عظام':Added, #1: 1	نَزْعِ الْعِرْقِ
u'نَزْعٌ عِظَامٌ':Added, #1: 1	نَزْعِ الْعِظَامِ
u'نَزْعٌ عظام':Added, #1: 1	نَزْعِ الْعِظَامِ
u'نَزْعٌ عِظَامٌ':Added, #1: 1	نَزْعِ عِظَامِهِ
u'نَزْعٌ عَظْمٌ':Added, #1: 1	نَزْعِ عِظَامِهِ
u'نَزْعٌ عَظْمٌ':Added, #1: 1	نَزْعَ الْعَظْمِ
u'نَزْعٌ عَظْمٌ':Added, #1: 1	نَزْعِ عَظْمِهِ
u'نَزْعٌ عَظْمٌ':Added, #2: 2	نَزْعِ الْعَظْمِ
u'نَزَعَ عُقُولٌ':Predicate, #4: 4	نَزْعُ عَظْمِهِ
u'نَزَعَ عِمَامَةٌ':Predicate, #1: 1	نَزَعَ عُقُولَ
u'نَزْعٌ عِمَامَةٌ':Added, #1: 1	نَزَعَ الْعِمَامَةَ
u'نَزْعٌ عِمَامَةٌ':Added, #1: 1	نَزْعِ عِمَامَةٍ
u'نَزْعٌ عِمَامَةٌ':Added, #1: 1	نَزْعَ عِمَامَتِهِ
u'نَزْعٌ غَرِيمٌ':Added, #1: 1	نَزْعِ عِمَامَتِهِ
u'نَزْعٌ غير':Added, #1: 1	نَزْعَ الْغَرِيمِ
u'نَزْعٌ غَيْرٌ':Added, #1: 1	نَزْعِ غَيْرِ
u'نَزْعٌ فرد':Added, #1: 1	نَزْعِ غَيْرِ
u'نَزْعٌ فَرْدٌ':Added, #1: 1	نَزْعِ الْفَرْدِ
u'نَزْعٌ فَصٌّ':Added, #1: 1	نَزْعِ الْفَرْدِ
u'نَزْعٌ فُضُولٌ':Added, #1: 1	نَزْعِ الْفَصِّ
u'نَزْعٌ فلان':Added, #1: 1	نَزْعُ الْفُضُولِ
u'نَزَعَ قَمِيصٌ':Predicate, #1: 1	نَزْعَ الرّايَةِ
u'نَزْعٌ قَمِيصٌ':Added, #1: 1	نَزَعَ الْقَمِيصَ
u'نَزْعٌ قَمِيصٌ':Added, #1: 1	نَزْعُ الْقَمِيصِ
u'نَزْعٌ قَمِيصٌ':Added, #1: 1	نَزْعِ الْقَمِيصِ
u'نَزْعٌ قَوْسٌ':Added, #1: 1	نَزْعَ قَمِيصِهِ
u'نَزْعٌ كِنَانَةٌ':Added, #1: 1	نَزْعِ الْقَوْسِ
u'نَزْعٌ لاَمٌ':Added, #1: 1	نَزْعُ كِنَانَتِهِ
u'نَزْعٌ مَأْكُولٌ':Added, #1: 1	نَزْعُ لَامَتِهِ
u'نَزْعٌ مَأْكُولٌ':Added, #1: 1	نَزْعِ الْمَأْكُولِ
u'نَزَعَ مَالٌ':Predicate, #1: 1	نَزْعِ مَأْكُولٍ
u'نَزْعٌ مَالٌ':Added, #1: 1	نَزَعَ الْمَالَ
u'نَزْعٌ مُكَعَّبٌ':Added, #2: 2	نَزْعُ مَالِهِ
u'نَزَعَ نَازِعٌ':Subject, #1: 1	نَزْعُ الْمُكَعَّبِ
u'نَزْعٌ نَاسٌ':Added, #1: 1	نَزَعَ نَازِعٌ
u'نَزَعَ نصاب':Predicate, #1: 1	نَزْعِ النَّاسِ
u'نَزَعَ نِصَابٌ':Predicate, #1: 1	نَزَعَ نِصَابَ
u'نَزَعَ نَعْلٌ':Predicate, #1: 1	نَزَعَ نِصَابَ
u'نَزْعٌ نَعْلٌ':Added, #1: 1	نَزَعَ النَّعْلَ
u'نَزْعٌ نَفْسٌ':Added, #1: 1	نَزْعِ النَّعْلِ
u'نَزْعٌ ولد':Added, #1: 1	نَزْعَ النَّفْسِ
u'نَزْعٌ ولد':Added, #1: 1	نَزْعُ الْوَلَدِ
u'نَزْعٌ وَلَدٌ':Added, #1: 1	نَزْعِ الْوَلَدِ
u'نَزْعٌ وَلَدٌ':Added, #1: 1	نَزْعُ الْوَلَدِ
u'نَزْعٌ ولد':Added, #1: 1	نَزْعِ الْوَلَدِ
u'نَزْعٌ وَلَدٌ':Added, #1: 1	نَزْعَ وَلَدِهِ
u'نَزْعٌ يَسِيرٌ':Added, #1: 1	نَزْعَ وَلَدِهِ
u'نَزَغَ شَيْطَانٌ':Subject, #1: 1	نَزْعِ يَسِيرِهِ
u'نزف دَمٌ':Added, #1: 1	نَزَغَ الشَّيْطَانُ
u'نَزْفٌ دَمٌ':Added, #1: 1	نَزْفُ الدَّمِ
u'نزف دَمٌ':Added, #1: 1	نَزْفُ الدَّمِ
u'نَزْفٌ دَمٌ':Added, #3: 3	نَزْفَ الدَّمِ
u'نَزَفَ شُؤُونٌ':Subject, #3: 3	نَزْفَ الدَّمِ
u'نَزَلَ إبْلِيسُ':Subject, #1: 1	نَزَفَ الشّؤُونُ
u'نَزَلَ اِبْنٌ':Subject, #1: 1	نَزَلَ إبْلِيسُ
u'نَزَّلَ أَحادِيثُ':Predicate, #1: 1	نَزَلَ ابْنُ
u'نَزَلَ إِحْرَامٌ':Subject, #1: 1	نَزَّلَ أَحَادِيثَ
u'نَزَّلَ أَحْسَنُ':Predicate, #1: 1	نَزَلَ الْإِحْرَامُ
u'نَزَلَ آخِرُ':Subject, #4: 4	نَزَّلَ أَحْسَنَ
u'نَزِلَ آدَمُ':Predicate, #1: 1	نَزَلَ آخِرُ
u'نَزِلَ أَرْبَعُ':Predicate, #1: 1	أَنْزَلَ آدَمَ
u'نَزَلَ اِرْتِياب':Subject, #1: 1	أَنْزَلَ أَرْبَعَ
u'نَزَلَ أصل':Subject, #1: 1	نَزَلَ ارْتِيَابُ
u'نَزَلَ أًصْلٌ':Subject, #1: 1	نَزَلَ أَصْلُ
u'نَزَلَ أعزاب':Subject, #1: 1	نَزَلَ أَصْلُ
u'نَزَلَ إقْرَارٌ':Subject, #1: 1	نَزَلَ الْأَعْزَابُ
u'نَزَلَ إقْرَارٌ':Subject, #1: 1	نَزَلَ إقْرَارُهُ
u'نَزَلَ إمَامٌ':Subject, #2: 2	نَزَلَ الْإِقْرَارُ
u'نَزَلَ أَمْرٌ':Subject, #1: 1	نَزَلَ الْإِمَامُ
u'نَزَلَ أَمْرٌ':Subject, #1: 1	نَزَلَ الْأَمْرُ
u'نَزِلَ إِنْجيلٌ':Predicate, #1: 1	نَزَلَ أَمْرٌ
u'نَزَلَ أهْلٌ':Subject, #8: 8	أَنْزَلَ الْإِنْجِيلَ
u'نَزَلَ أَوَّلُ':Subject, #1: 1	نَزَلَ أَهْلُ
u'نَزَلَ أَوَّلُ':Subject, #1: 1	نَزَلَ الْأَوَّلُ
u'نَزِلَ أيَّامٌ':Predicate, #2: 2	نَزَلَ أَوَّلُ
u'نَزِلَ أَيَّامٌ':Predicate, #1: 1	أَنْزَلَ الْأَيَّامَ
u'نَزَلَ بَراءةٌ':Subject, #1: 1	أَنْزَلَ الْأَيَّامَ
u'نَزَّلَ بَعْضٌ':Subject, #1: 1	نَزَلَ بَرَاءَةٌ
u'نَزَلَ بَعْضٌ':Subject, #1: 1	نَزَّلَ بَعْضُ
u'نَزِلَ بَلاءٌ':Predicate, #2: 2	نَزَلَ بَعْضُ
u'نَزَلٌ بلغة':Added, #1: 1	أَنْزَلَ الْبَلَاءَ
u'نَزَلٌ بلغة':Added, #1: 1	نَزَلَ بِلُغَتِهِ
u'نَزَلَ بَوْلٌ':Subject, #6: 6	نَزَلَ بِلُغَةِ
u'نَزَلَ بِئْرٌ':Predicate, #3: 3	نَزَلَ الْبَوْلُ
u'نَزَلَ بَيْعٌ':Subject, #2: 2	نَزَلَ الْبِئْرَ
u'نَزَلَ بَيْنٌ':Predicate, #2: 2	نَزَلَ الْبَيْعُ
u'نَزَلَ تَاجِرٌ':Subject, #8: 8	نَزَلَ بَيْنَ
u'نَزِلَ تَحْرِيمٌ':Predicate, #1: 1	نَزَلَ تَاجِرٌ
u'نَزَلَ تَحْرِيمٌ':Subject, #3: 3	أَنْزَلَ تَحْرِيمَ
u'نَزَلَ تَحْرِيمٌ':Subject, #18: 18	نَزَلَ تَحْرِيمُ
u'نَزَلَ تَحْقِيقٌ':Subject, #1: 1	نَزَلَ التَّحْرِيمُ
u'نَزَلَ تَرْكٌ':Subject, #1: 1	نَزَلَ التّحْقِيقُ
u'نَزَلَ تَزَوُّجٌ':Predicate, #1: 1	نَزَلَ تَرْكُ
u'نَزِلَ تَوْرَاةٌ':Predicate, #1: 1	نَزَلَ تَزَوّجَ
u'نَزَلَ جَازٌ':Predicate, #17: 17	أَنْزَلَ التَّوْرَاةَ
u'نَزَلَ جَزَاءٌ':Subject, #1: 1	نَزَلَ جَازَ
u'نَزَلَ جِعْران':Predicate, #1: 1	نَزَلَ الْجَزَاءُ
u'نَزَلَ جَنِينٌ':Subject, #2: 2	نَزَلَ الْجِعْرَانَةَ
u'نَزَلَ جَيْشٌ':Subject, #1: 1	نَزَلَ جَنِينُ
u'نَزَلَ حادِثٌ':Subject, #1: 1	نَزَلَ الْجَيْشُ
u'نَزَلَ حجاب':Subject, #1: 1	نَزَلَ الْحَادِثُ
u'نَزَلَ حِجابٌ':Subject, #4: 4	نَزَلَ الْحِجَابُ
u'نَزَلَ حَجَرٌ':Predicate, #4: 4	نَزَلَ الْحِجَابُ
u'نَزَلَ حِجْرٌ':Predicate, #1: 1	نَزَلَ الْحَجَرَ
u'نَزَلَ حَجَرٌ':Subject, #1: 1	نَزَلَ الْحِجْرَ
u'نَزِلَ حَطَبٌ':Predicate, #1: 1	نَزَلَ الْحَجَرُ
u'نَزِلَ حَقٌّ':Predicate, #1: 1	أَنْزَلَ الْحَطَبَ
u'نَزَلَ حُكْمٌ':Subject, #1: 1	أَنْزَلَ الْحَقَّ
u'نَزَلَ حَمْز':Subject, #1: 1	نَزَلَ حُكْمُهُ
u'نَزَلَ خَارِجٌ':Predicate, #1: 1	نَزَلَ حَمْزَةُ
u'نَزَلَ خَانٌ':Predicate, #1: 1	نَزَلَ خَارِجَ
u'نَزَلَ خدمة':Subject, #1: 1	نَزَلَ الْخَانَ
u'نَزَلَ خُلْعٌ':Subject, #1: 1	نَزَلَ خَدَمْتُهُ
u'نَزَلَ خَلِيفَةٌ':Subject, #1: 1	نَزَلَ الْخُلْعُ
u'نَزِلَ دَاءٌ':Predicate, #1: 1	نَزَلَ الْخَلِيفَةُ
u'نَزَلَ دَخَلٌ':Predicate, #5: 5	أَنْزَلَ الدَّاءَ
u'نَزَلَ دَمٌ':Subject, #1: 1	نَزَلَ دَخَلَ
u'نَزَّلَ دُموعٌ':Predicate, #9: 9	نَزَلَ الدَّمُ
u'نَزِلَ دَواءٌ':Predicate, #1: 1	نَزَّلَ الدُّمُوعَ
u'نَزَّلَ دَيْنٌ':Predicate, #1: 1	أَنْزَلَ الدَّوَاءَ
u'نَزَلَ رَاكِبٌ':Subject, #1: 1	نَزَّلَ الدَّيْنَ
u'نَزَلَ رَجُلٌ':Subject, #1: 1	نَزَلَ الرَّاكِبُ
u'نَزَلَ رَجُلٌ':Subject, #1: 1	نَزَلَ الرَّجُلُ
u'نَزِلَ رحمة':Predicate, #2: 2	نَزَلَ رَجُلٌ
u'نَزِلَ رَحْمَةٌ':Predicate, #1: 1	أَنْزَلَ الرَّحْمَةَ
u'نَزَّلَ رَحْمَن':Subject, #1: 1	أَنْزَلَ الرَّحْمَةَ
u'نَزَلَ رَسُولٌ':Subject, #1: 1	نَزَّلَ الرَّحْمَنُ
u'نَزِلَ رَغْبَةٌ':Predicate, #22: 22	نَزَلَ رَسُولُ
u'نَزَلَ ركب':Subject, #1: 1	أَنْزَلَ الرَّغْبَةَ
u'نَزَلَ رَكْبٌ':Subject, #1: 1	نَزَلَ الرّكْبُ
u'نَزَلَ رُكْبٌ':Subject, #1: 1	نَزَلَ الرّكْبُ
u'نَزَلَ رَمَضانُ':Subject, #1: 1	نَزَلَ الرّكْبُ
u'نَزَلَ رُومٌ':Subject, #3: 3	نَزَلَ رَمَضَانُ
u'نَزَلَ سَحَابٌ':Subject, #1: 1	نَزَلَ الرُّومُ
u'نَزَلَ سعر':Subject, #1: 1	نَزَلَ السَّحَابُ
u'نَزَلَ سِعْرٌ':Subject, #1: 1	نَزَلَ سِعْرُهُ
u'نَزَّلَ سُكُوتٌ':Predicate, #1: 1	نَزَلَ سِعْرُهُ
u'نَزِلَ سَكِينَةٌ':Predicate, #2: 2	نَزَّلَ السُّكُوتَ
u'نَزَلَ سُلْطَانٌ':Subject, #1: 1	أَنْزَلَ السَّكِينَةَ
u'نَزَلَ سَمَاءٌ':Subject, #1: 1	نَزَلَ سُلْطَانٌ
u'نَزِلَ سُورَةٌ':Predicate, #4: 4	نَزَلَ السَّمَاءُ
u'نَزِلَ شَرِيعَةٌ':Predicate, #2: 2	أَنْزَلَ سُورَةَ
u'نَزَلَ شَعْبٌ':Subject, #1: 1	أَنْزَلَ الشَّرِيعَةَ
u'نَزَلَ شِعْبٌ':Subject, #1: 1	نَزَلَ الشّعْبُ
u'نَزَلَ شَعْرٌ':Subject, #1: 1	نَزَلَ الشّعْبُ
u'نَزَلَ شَعْرٌ':Subject, #1: 1	نَزَلَ الشَّعْرُ
u'نَزَلَ شَعْرٌ':Subject, #1: 1	نَزَلَ شَعْرُ
u'نَزِلَ شِفَاءٌ':Predicate, #2: 2	نَزَلَ شَعْرُهُ
u'نَزَلَ شَهْرٌ':Subject, #1: 1	أَنْزَلَ الشِّفَاءَ
u'نَزَلَ شيب':Subject, #1: 1	نَزَلَ شَهْرُ
u'نَزَلَ شَيْبٌ':Subject, #1: 1	نَزَلَ الشّيْبُ
u'نَزَلَ شَيْخٌ':Subject, #1: 1	نَزَلَ الشّيْبُ
u'نَزَلَ صَدْرٌ':Subject, #1: 1	نَزَلَ شَيْخٌ
u'نَزَلَ طَلْحٌ':Subject, #1: 1	نَزَلَ صَدْرُ
u'نَزَلَ طلحة':Subject, #1: 1	نَزَلَ طَلْحَةُ
u'نَزَلَ عَبْدٌ':Subject, #1: 1	نَزَلَ طَلْحَةُ
u'نَزَلَ عَبْدٌ':Subject, #1: 1	نَزَلَ عَبْدٌ
u'نَزَلَ عتاب':Subject, #1: 1	نَزَلَ عَبْدُ
u'نَزَلَ عِتَابٌ':Subject, #1: 1	نَزَلَ عِتَابُهُ
u'نَزَلَ عتق':Subject, #1: 1	نَزَلَ عِتَابُهُ
u'نَزَلَ عِتْقٌ':Subject, #1: 1	نَزَلَ الْعِتْقُ
u'نَزَلَ عَدُوٌّ':Subject, #1: 1	نَزَلَ الْعِتْقُ
u'نَزَلَ عَذَابٌ':Subject, #1: 1	نَزَلَ الْعَدُوُّ
u'نَزَلَ عصبة':Subject, #2: 2	نَزَلَ عَذَابٌ
u'نَزَلَ عَصَبَةٌ':Subject, #1: 1	نَزَلَ عَصَبَةُ
u'نَزَلَ عَفْوٌ':Subject, #1: 1	نَزَلَ عَصَبَةُ
u'نَزَلَ عَقْدٌ':Subject, #1: 1	نَزَلَ الْعَفْوُ
u'نَزَلَ عَقِيقٌ':Predicate, #1: 1	نَزَلَ الْعَقْدُ
u'نَزَّلَ عَمَّةٌ':Predicate, #1: 1	نَزَلَ الْعَقِيقَ
u'نَزِلَ عند':Predicate, #2: 2	نَزَّلَ الْعَمَّةَ
u'نَزَلَ عند':Predicate, #1: 1	أَنْزَلَ عِنْدَ
u'نَزَلَ غَاصِبٌ':Subject, #1: 1	نَزَلَ عِنْدَ
u'نَزَلَ فَاتِحٌ':Subject, #2: 2	نَزَلَ الْغَاصِبُ
u'نَزَلَ فَاتِحَةٌ':Subject, #1: 1	نَزَلَ فَاتِحَةُ
u'نَزَلَ فَرْضٌ':Subject, #1: 1	نَزَلَ فَاتِحَةُ
u'نَزَلَ فَرْضٌ':Subject, #1: 1	نَزَلَ فَرْضُ
u'نَزَّلَ فُرْقَانٌ':Predicate, #1: 1	نَزَلَ فَرْضُهُ
u'نَزَلَ فلان':Predicate, #1: 1	نَزَّلَ الْفُرْقَانَ
u'نَزَلَ فلان':Predicate, #1: 1	نَزَلَ الْمُزْدَلِفَةَ
u'نَزَّلَ فلان':Subject, #1: 1	نَزَلَ مَكّةَ
u'نَزَلَ فلان':Subject, #1: 1	نَزَّلَ الرَّحْمَنُ
u'نَزَلَ قَالٌ':Predicate, #1: 1	نَزَلَ حَمْزَةُ
u'نَزَلَ قَدَرٌ':Subject, #1: 1	نَزَلَ قَالَ
u'نَزِلَ قُرْآنٌ':Predicate, #1: 1	نَزَلَ الْقَدَرُ
u'نَزَلَ قُرْآنٌ':Subject, #4: 4	أَنْزَلَ الْقُرْآنَ
u'نَزَّلَ قول':Subject, #30: 30	نَزَلَ الْقُرْآنُ
u'نَزَّلَ قَوْلٌ':Subject, #1: 1	نَزَّلَ قَوْلُهُ
u'نَزَلَ قول':Subject, #1: 1	نَزَّلَ قَوْلُهُ
u'نَزَلَ قَوْلٌ':Subject, #2: 2	نَزَلَ قَوْلُ
u'نَزَلَ قول':Subject, #2: 2	نَزَلَ قَوْلُ
u'نَزَلَ قَوْلٌ':Subject, #4: 4	نَزَلَ قَوْلُهُ
u'نَزَلَ قَوْمٌ':Subject, #4: 4	نَزَلَ قَوْلُهُ
u'نَزِلَ كِتَابٌ':Predicate, #2: 2	نَزَلَ قَوْمٌ
u'نَزَلَ كِتَابٌ':Subject, #3: 3	أَنْزَلَ الْكِتَابَ
u'نَزِلَ كُتُبٌ':Predicate, #2: 2	نَزَلَ الْكِتَابُ
u'نَزِلَ كُفَّارٌ':Predicate, #1: 1	أَنْزَلَ الْكُتُبَ
u'نَزَلَ كُفَّارٌ':Subject, #1: 1	أَنْزَلَ الْكُفّارَ
u'نَزَّلَ كفر':Predicate, #1: 1	نَزَلَ الْكُفَّارُ
u'نَزَّلَ كُفْرٌ':Predicate, #1: 1	نَزَّلَ الْكُفْرَ
u'نَزَلَ كُوفَةٌ':Predicate, #1: 1	نَزَّلَ الْكُفْرَ
u'نَزَلَ لَبَنٌ':Subject, #2: 2	نَزَلَ الْكُوفَةَ
u'نَزَلَ لبن':Subject, #1: 1	نَزَلَ لَبَنٌ
u'نَزَلَ لَبَنٌ':Subject, #4: 4	نَزَلَ اللَّبَنُ
u'نَزَلَ لَغْوٌ':Subject, #4: 4	نَزَلَ اللَّبَنُ
u'نَزَلَ لَفْظٌ':Subject, #1: 1	نَزَلَ لَغْوُ
u'نَزِلَ لَمْسٌ':Predicate, #1: 1	نَزَلَ اللَّفْظُ
u'نَزَلَ لَيْثٌ':Subject, #1: 1	أَنْزَلَ اللَّمْسَ
u'نَزَلَ لَيْلٌ':Predicate, #1: 1	نَزَلَ اللَّيْثُ
u'نَزَلَ مَاءٌ':Subject, #1: 1	نَزَلَ لَيْلَةَ
u'نَزَلَ مَآبٌ':Predicate, #3: 3	نَزَلَ الْمَاءُ
u'نَزَّلَ مَأْمُورٌ':Predicate, #1: 1	نَزَلَ مَآبَ
u'نَزَلَ مَائِدٌ':Subject, #1: 1	نَزَّلَ الْمَأْمُورَ
u'نَزَلَ مَائِدَةٌ':Subject, #1: 1	نَزَلَ الْمَائِدَةُ
u'نَزَلَ مثل':Subject, #1: 1	نَزَلَ الْمَائِدَةُ
u'نَزَلَ مِثْلٌ':Subject, #2: 2	نَزَلَ مِثْلُ
u'نَزَلَ مُحَمَّدٌ':Subject, #2: 2	نَزَلَ مِثْلُ
u'نَزَلَ مَدِينٌ':Predicate, #1: 1	نَزَلَ مُحَمَّدٌ
u'نَزَلَ مَدِينَةٌ':Predicate, #1: 1	نَزَلَ الْمَدِينَةَ
u'نَزَلَ مرٌّ':Predicate, #1: 1	نَزَلَ الْمَدِينَةَ
u'نَزِلَ مَطَرٌ':Predicate, #1: 1	نَزَلَ مُرَّ
u'نَزَلَ مَطَرٌ':Subject, #2: 2	أَنْزَلَ الْمَطَرَ
u'نَزَلَ مُعَلَّقٌ':Subject, #1: 1	نَزَلَ الْمَطَرُ
u'نَزَّلَ مُلاَئِمٌ':Predicate, #1: 1	نَزَلَ الْمُعَلَّقُ
u'نَزَلَ مَلَكٌ':Subject, #1: 1	نَزَّلَ الْمُلَائِمَةَ
u'نَزَلَ مَلَكٌ':Subject, #1: 1	نَزَلَ الْمَلَكُ
u'نَزَلَ مَلَكٌ':Subject, #1: 1	نَزَلَ مَلَكٌ
u'نَزَلَ مَنْزِلٌ':Predicate, #1: 1	نَزَلَ مَلَكُ
u'نَزَلَ مَنْزِلٌ':Predicate, #1: 1	نَزَلَ الْمَنْزِلَ
u'نَزَّلَ مَنْزِلٌ':Predicate, #1: 1	نَزَلَ مَنْزِلَ
u'نَزَلَ مَنْزِلٌ':Predicate, #1: 1	نَزَّلَ مَنْزِلاً
u'نَزَلَ مَنْزِلَةٌ':Predicate, #5: 5	نَزَلَ مَنْزِلاً
u'نَزِلَ مَنِيٌّ':Predicate, #9: 9	نَزَلَ مَنْزِلَةَ
u'نَزَلَ مَنِيٌّ':Subject, #2: 2	أَنْزَلَ الْمَنِيَّ
u'نَزَلَ مَنِيٌّ':Subject, #1: 1	نَزَلَ الْمَنِيُّ
u'نَزَلَ مِيرَاثٌ':Subject, #1: 1	نَزَلَ مَنِيُّهُ
u'نَزَلَ نَاسٌ':Subject, #1: 1	نَزَلَ الْمِيرَاثُ
u'نَزَلَ نَاسٌ':Subject, #2: 2	نَزَلَ النّاسُ
u'نَزَلَ نَبِيٌّ':Subject, #2: 2	نَزَلَ النَّاسُ
u'نَزَلَ نذر':Subject, #3: 3	نَزَلَ النَّبِيُّ
u'نَزَلَ نَذْرٌ':Subject, #1: 1	نَزَلَ نَذْرُهُ
u'نَزَلَ نَزَلٌ':Predicate, #1: 1	نَزَلَ نَذْرُهُ
u'نَزَلَ نَصٌّ':Predicate, #1: 1	نَزَلَ نَزَلَ
u'نَزَلَ نَظَرٌ':Predicate, #1: 1	نَزَلَ نَصَّ
u'نَزَلَ نِفَاقٌ':Subject, #1: 1	نَزَلَ نَظَرَ
u'نَزَلَ وَجَبٌ':Predicate, #2: 2	نَزَلَ النِّفَاقُ
u'نَزِلَ وَجَبٌ':Predicate, #1: 1	نَزَلَ وَجَبَ
u'نَزَلَ وَحْيٌ':Subject, #2: 2	أَنْزَلَ وَجَبَ
u'نَزَلَ وَحْيٌ':Subject, #1: 1	نَزَلَ وَحْيٌ
u'نَزِلَ وَفْدٌ':Predicate, #4: 4	نَزَلَ الْوَحْيُ
u'نَزَلَ وَقْفٌ':Subject, #4: 4	أَنْزَلَ وَفْدَ
u'نَزَلَ وَقْفٌ':Subject, #1: 1	نَزَلَ الْوَقْفُ
u'نَزَلَ يَدٌ':Subject, #3: 3	نَزَلَ وَقْفُهُ
u'نَزَلَ يَوْمٌ':Predicate, #1: 1	نَزَلَ يَدُهُ
u'نَزَّهَ إِسْلامٌ':Predicate, #1: 1	نَزَلَ يَوْمَ
u'نُزُوعٌ نَفْسٌ':Added, #1: 1	نَزَّهَ الْإِسْلَامَ
u'نُزُولٌ أَجْرٌ':Added, #1: 1	نُزُوعَ نَفْسٍ
u'نُزُولٌ أَضْيَافٌ':Added, #1: 1	نُزُولِ الْأَجْرِ
u'نُزُولٌ أَمْرٌ':Added, #1: 1	نُزُولُ الْأَضْيَافِ
u'نُزُولٌ أنصار':Added, #1: 1	نُزُولُ الْأَمْرِ
u'نُزُولٌ أَنْصارٌ':Added, #1: 1	نُزُولِ الْأَنْصَارِ
u'نُزُولٌ أَنْصَارٌ':Added, #1: 1	نُزُولِ الْأَنْصَارِ
u'نُزُولٌ أهْلٌ':Added, #1: 1	نُزُولِ الْأَنْصَارِ
u'نُزُولٌ أهْلٌ':Added, #1: 1	نُزُولِ أَهْلِ
u'نُزُولٌ أَوَّلُ':Added, #2: 2	نُزُولَ أَهْلِ
u'نُزُولٌ أَوَّلُ':Added, #1: 1	نُزُولِ أَوّلِ
u'نُزُولٌ آيَةٌ':Added, #1: 1	نُزُولُ أَوَّلِهِ
u'نُزُولٌ آيَةٌ':Added, #10: 10	نُزُولِ الآيَةِ
u'نُزُولٌ آيَةٌ':Added, #10: 10	نُزُولِ آيَةِ
u'نُزُولٌ آيَةٌ':Added, #1: 1	نُزُولَ الآيَةِ
u'نُزُولٌ آيَةٌ':Added, #1: 1	نُزُولَ الْآيَةِ
u'نُزُولٌ آيَةٌ':Added, #1: 1	نُزُولَ آيَةِ
u'نُزُولٌ آيَةٌ':Added, #23: 23	نُزُولِ الْآيَةِ
u'نُزُولٌ آيَةٌ':Added, #2: 2	نُزُولُ الْآيَةِ
u'نُزُولٌ آيَةٌ':Added, #3: 3	نُزُولُ الآيَةِ
u'نُزُولٌ بَراءةٌ':Added, #3: 3	نُزُولُ آيَةِ
u'نُزُولٌ بَراءةٌ':Added, #1: 1	نُزُولُ بَرَاءَةِ
u'نُزُولٌ بَعْضٌ':Added, #1: 1	نُزُولِ بَرَاءَةٍ
u'نُزُولٌ بَلاءٌ':Added, #1: 1	نُزُولِ بَعْضِ
u'نُزُولٌ بَلاءٌ':Added, #2: 2	نُزُولِ الْبَلاَءِ
u'نُزُولٌ بَوْلٌ':Added, #7: 7	نُزُولِ الْبَلَاءِ
u'نُزُولٌ بِئْرٌ':Added, #1: 1	نُزُولَ الْبَوْلِ
u'نُزُولٌ بِئْرٌ':Added, #1: 1	نُزُولَ الْبِئْرِ
u'نُزُولٌ بِئْرٌ':Added, #1: 1	نُزُولِ الْبِئْرِ
u'نُزُولٌ تَحْرِيمٌ':Added, #1: 1	نُزُولِ بِئْرٍ
u'نُزُولٌ تَوْبَةٌ':Added, #5: 5	نُزُولِ تَحْرِيمِ
u'نُزُولٌ تَوْرَاةٌ':Added, #1: 1	نُزُولِ تَوْبَةِ
u'نُزُولٌ جُزْءٌ':Added, #1: 1	نُزُولِ التَّوْرَاةِ
u'نُزُولٌ جَزَاءٌ':Added, #1: 1	نُزُولِ الْجُزْءِ
u'نُزُولٌ جَزَاءٌ':Added, #2: 2	نُزُولَ الْجَزَاءِ
u'نُزُولٌ جَزَاءٌ':Added, #5: 5	نُزُولُ الْجَزَاءِ
u'نُزُولٌ جِزْيَةٌ':Added, #7: 7	نُزُولِ الْجَزَاءِ
u'نُزُولٌ حادِثٌ':Added, #2: 2	نُزُولِ الْجِزْيَةِ
u'نُزُولٌ حجاب':Added, #2: 2	نُزُولِ الْحَادِثَةِ
u'نُزُولٌ حجاب':Added, #1: 1	نُزُولَ الْحِجَابِ
u'نُزُولٌ حِجابٌ':Added, #1: 1	نُزُولِ الْحِجَابِ
u'نُزُولٌ حِجابٌ':Added, #1: 1	نُزُولَ الْحِجَابِ
u'نُزُولٌ حُدودٌ':Added, #1: 1	نُزُولِ الْحِجَابِ
u'نُزُولٌ حُرْمَةٌ':Added, #1: 1	نُزُولِ الْحُدُودِ
u'نُزُولٌ حُرْمَةٌ':Added, #2: 2	نُزُولِ الْحُرْمَةِ
u'نُزُولٌ حُرِّيَّةٌ':Added, #2: 2	نُزُولِ حُرْمَةِ
u'نُزُولٌ حوادِثُ':Added, #1: 1	نُزُولِ الْحُرِّيَّةِ
u'نُزُولٌ خُمُسٌ':Added, #1: 1	نُزُولِ الْحَوَادِثِ
u'نُزُولٌ دَمٌ':Added, #2: 2	نُزُولِ الْخُمُسِ
u'نُزُولٌ رَاكِبٌ':Added, #3: 3	نُزُولِ الدَّمِ
u'نُزُولٌ رُخْصَةٌ':Added, #1: 1	نُزُولِ الرَّاكِبِ
u'نُزُولٌ رَسُولٌ':Added, #1: 1	نُزُولِ الرُّخْصَةِ
u'نُزُولٌ رَسُولٌ':Added, #1: 1	نُزُولِ رَسُولِهِ
u'نُزُولٌ ركب':Added, #2: 2	نُزُولَ رَسُولِ
u'نُزُولٌ رَكْبٌ':Added, #1: 1	نُزُولِ الرَّكْبِ
u'نُزُولٌ سِعْرٌ':Added, #1: 1	نُزُولِ الرَّكْبِ
u'نُزُولٌ سُورَةٌ':Added, #1: 1	نُزُولِ سِعْرٍ
u'نُزُولٌ سُورَةٌ':Added, #1: 1	نُزُولَ سُورَةِ
u'نُزُولٌ سُورَةٌ':Added, #2: 2	نُزُولُ سُورَةِ
u'نُزُولٌ شَرْطٌ':Added, #7: 7	نُزُولِ سُورَةِ
u'نُزُولٌ شِفَاءٌ':Added, #3: 3	نُزُولِ الشَّرْطِ
u'نُزُولٌ شَيْءٌ':Added, #1: 1	نُزُولَ الشِّفَاءِ
u'نُزُولٌ صَلاَةٌ':Added, #1: 1	نُزُولِ شَيْءٍ
u'نُزُولٌ طَلاَقٌ':Added, #1: 1	نُزُولِ صَلَاةِ
u'نُزُولٌ طَلاَقٌ':Added, #1: 1	نُزُولُ الطَّلَاقِ
u'نُزُولٌ عتق':Added, #3: 3	نُزُولِ الطَّلَاقِ
u'نُزُولٌ عتق':Added, #3: 3	نُزُولَ الْعِتْقِ
u'نُزُولٌ عِتْقٌ':Added, #3: 3	نُزُولُ الْعِتْقِ
u'نُزُولٌ عِتْقٌ':Added, #3: 3	نُزُولَ الْعِتْقِ
u'نُزُولٌ عتق':Added, #3: 3	نُزُولُ الْعِتْقِ
u'نُزُولٌ عِتْقٌ':Added, #4: 4	نُزُولِ الْعِتْقِ
u'نُزُولٌ عَذَابٌ':Added, #4: 4	نُزُولِ الْعِتْقِ
u'نُزُولٌ عَذَابٌ':Added, #1: 1	نُزُولِ عَذَابِ
u'نُزُولٌ عَسْكَرٌ':Added, #2: 2	نُزُولِ الْعَذَابِ
u'نُزُولٌ غَيْثٌ':Added, #2: 2	نُزُولِ الْعَسْكَرِ
u'نُزُولٌ غَيْثٌ':Added, #3: 3	نُزُولَ الْغَيْثِ
u'نُزُولٌ فِتَنٌ':Added, #4: 4	نُزُولِ الْغَيْثِ
u'نُزُولٌ فِتَنٌ':Added, #1: 1	نُزُولَ الْفِتَنِ
u'نُزُولٌ فَرَائِضُ':Added, #1: 1	نُزُولِ الْفِتَنِ
u'نُزُولٌ فَرْضٌ':Added, #2: 2	نُزُولِ الْفَرَائِضِ
u'نُزُولٌ فَرْضٌ':Added, #1: 1	نُزُولَ فَرْضٍ
u'نُزُولٌ فُرْقَانٌ':Added, #1: 1	نُزُولِ فَرْضِ
u'نُزُولٌ فَرِيضَةٌ':Added, #1: 1	نُزُولِ الْفُرْقَانِ
u'نُزُولٌ فَرِيضَةٌ':Added, #1: 1	نُزُولُ فَرِيضَةِ
u'نُزُولٌ فلان':Added, #1: 1	نُزُولِ فَرِيضَةِ
u'نُزُولٌ فَنَاءٌ':Added, #1: 1	نُزُولِ الْمَكِّيَّةِ
u'نُزُولٌ قَبْرٌ':Added, #1: 1	نُزُولِ الْفَنَاءِ
u'نُزُولٌ قُرْآنٌ':Added, #1: 1	نُزُولِ الْقَبْرِ
u'نُزُولٌ قُرْآنٌ':Added, #2: 2	نُزُولَ الْقُرْآنِ
u'نُزُولٌ قُرْآنٌ':Added, #2: 2	نُزُولُ الْقُرْآنِ
u'نُزُولٌ قَسْمٌ':Added, #7: 7	نُزُولِ الْقُرْآنِ
u'نُزُولٌ قوافل':Added, #1: 1	نُزُولِ قَسْمِ
u'نُزُولٌ قَوَافِلُ':Added, #1: 1	نُزُولِ قَوَافِلِ
u'نُزُولٌ قول':Added, #1: 1	نُزُولِ قَوَافِلِ
u'نُزُولٌ قَوْلٌ':Added, #10: 10	نُزُولِ قَوْلِهِ
u'نُزُولٌ قول':Added, #10: 10	نُزُولِ قَوْلِهِ
u'نُزُولٌ قَوْلٌ':Added, #2: 2	نُزُولِ قَوْلِ
u'نُزُولٌ قول':Added, #2: 2	نُزُولِ قَوْلِ
u'نُزُولٌ قَوْلٌ':Added, #2: 2	نُزُولُ قَوْلِهِ
u'نُزُولٌ كِتَابٌ':Added, #2: 2	نُزُولُ قَوْلِهِ
u'نُزُولٌ كَفَّارٌ':Added, #1: 1	نُزُولَ كِتَابٍ
u'نُزُولٌ كَفَّارَةٌ':Added, #2: 2	نُزُولِ الْكَفَّارَةِ
u'نُزُولٌ كَفِيلٌ':Added, #2: 2	نُزُولِ الْكَفَّارَةِ
u'نُزُولٌ كَهْفٌ':Added, #1: 1	نُزُولِ الْكَفِيلِ
u'نُزُولٌ لبن':Added, #1: 1	نُزُولِ الْكَهْفِ
u'نُزُولٌ لبن':Added, #2: 2	نُزُولُ اللَّبَنِ
u'نُزُولٌ لَبَنٌ':Added, #2: 2	نُزُولِ اللَّبَنِ
u'نُزُولٌ لَبَنٌ':Added, #2: 2	نُزُولُ اللَّبَنِ
u'نُزُولٌ لعنة':Added, #2: 2	نُزُولِ اللَّبَنِ
u'نُزُولٌ لَعْنَةٌ':Added, #1: 1	نُزُولَ اللَّعْنَةِ
u'نُزُولٌ مَاءٌ':Added, #1: 1	نُزُولَ اللَّعْنَةِ
u'نُزُولٌ مَاءٌ':Added, #1: 1	نُزُولُ الْمَاءِ
u'نُزُولٌ مَاءٌ':Added, #1: 1	نُزُولِ مَاءٍ
u'نُزُولٌ مَائِدٌ':Added, #2: 2	نُزُولَ الْمَاءِ
u'نُزُولٌ مَائِدَةٌ':Added, #22: 22	نُزُولِ الْمَائِدَةِ
u'نُزُولٌ مُحَصَّبٌ':Added, #22: 22	نُزُولِ الْمَائِدَةِ
u'نُزُولٌ مَسْأَلَةٌ':Added, #3: 3	نُزُولُ الْمُحَصَّبِ
u'نُزُولٌ مَطَرٌ':Added, #1: 1	نُزُولِ الْمَسْأَلَةِ
u'نُزُولٌ مَطَرٌ':Added, #1: 1	نُزُولَ الْمَطَرِ
u'نُزُولٌ مَكِّيّ':Added, #7: 7	نُزُولِ الْمَطَرِ
u'نُزُولٌ مُلاَحَظَةٌ':Added, #1: 1	نُزُولِ الْمَكِّيَّةِ
u'نُزُولٌ مَلاَئِكَةٌ':Added, #1: 1	نُزُولُ مُلَاحَظَتِهِ
u'نُزُولٌ مَلَكٌ':Added, #1: 1	نُزُولُ الْمَلَائِكَةِ
u'نُزُولٌ مَلَكٌ':Added, #1: 1	نُزُولِ الْمَلَكِ
u'نُزُولٌ مُلِمٌّ':Added, #5: 5	نُزُولِ الْمَلَكَيْنِ
u'نُزُولٌ مُلِمَّةٌ':Added, #1: 1	نُزُولِ الْمُلِمَّاتِ
u'نُزُولٌ مَنِيٌّ':Added, #1: 1	نُزُولِ الْمُلِمَّاتِ
u'نُزُولٌ مَنِيٌّ':Added, #1: 1	نُزُولُ الْمَنِيِّ
u'نُزُولٌ وَافِدٌ':Added, #1: 1	نُزُولِ الْمَنِيِّ
u'نُزُولٌ وَبَاءٌ':Added, #1: 1	نُزُولِ الْوَافِدِ
u'نُزُولٌ وَحْيٌ':Added, #1: 1	نُزُولِ الْوَبَاءِ
u'نُزُولٌ وَحْيٌ':Added, #10: 10	نُزُولِ الْوَحْيِ
u'نُزُولٌ وَحْيٌ':Added, #2: 2	نُزُولَ الْوَحْيِ
u'نُزُولٌ وُضُوءٌ':Added, #2: 2	نُزُولُ الْوَحْيِ
u'نُزُولٌ وَعِيدٌ':Added, #1: 1	نُزُولِ الْوُضُوءِ
u'نَسَبٌ أَبٌ':Added, #1: 1	نُزُولُ الْوَعِيدِ
u'نَسَبَ اِبْنٌ':Subject, #3: 3	نَسَبِ الْأَبِ
u'نَسَبٌ اِبْنٌ':Added, #7: 7	نَسَبَ ابْنُ
u'نَسَبٌ أحَدٌ':Added, #1: 1	نَسَبُ ابْنِ
u'نَسَبٌ أحَدٌ':Added, #1: 1	نَسَبُ أَحَدٍ
u'نَسَبٌ أصْغَرٌ':Added, #4: 4	نَسَبَ أَحَدِ
u'نَسَبٌ أَصْغَرُ':Added, #1: 1	نَسَبِ الْأَصْغَرِ
u'نَسَبٌ أصْغَرٌ':Added, #1: 1	نَسَبِ الْأَصْغَرِ
u'نَسَبٌ أَصْغَرُ':Added, #6: 6	نَسَبُ الْأَصْغَرِ
u'نَسَبٌ أصل':Added, #6: 6	نَسَبُ الْأَصْغَرِ
u'نَسَبٌ أًصْلٌ':Added, #1: 1	نَسَبِ الْأَصْلِ
u'نَسَبٌ أقْرَع':Added, #1: 1	نَسَبِ الْأَصْلِ
u'نَسَبٌ أكْبَرُ':Added, #1: 1	نَسَبُ الْأَقْرَعِ
u'نَسَبٌ أكْبَرُ':Added, #2: 2	نَسَبَ الْأَكْبَرِ
u'نَسَبٌ أُمٌّ':Added, #8: 8	نَسَبُ الْأَكْبَرِ
u'نَسَبٌ أُمٌّ':Added, #1: 1	نَسَبَ أُمّهِ
u'نَسَبٌ أُمٌّ':Added, #1: 1	نَسَبَ أُمِّهِ
u'نَسَبٌ أُمٌّ':Added, #1: 1	نَسَبُ أُمّهِ
u'نَسَبٌ اِمْرَأَةٌ':Added, #3: 3	نَسَبِ أُمِّهِ
u'نَسَبَ أَمْوَالٌ':Predicate, #2: 2	نَسَبَ امْرَأَتِهِ
u'نَسَبٌ أنبياء':Added, #1: 1	نَسَبَ الْأَمْوَالَ
u'نَسَبٌ أنصار':Added, #1: 1	نَسَبِ الْأَنْبِيَاءِ
u'نَسَبٌ أنصار':Added, #1: 1	نَسَبُ الْأَنْصَارِ
u'نَسَبٌ أَنْصارٌ':Added, #1: 1	نَسَبِ الْأَنْصَارِ
u'نَسَبٌ أَنْصارٌ':Added, #1: 1	نَسَبُ الْأَنْصَارِ
u'نَسَبٌ أَنْصَارٌ':Added, #1: 1	نَسَبِ الْأَنْصَارِ
u'نَسَبٌ أَنْصَارٌ':Added, #1: 1	نَسَبُ الْأَنْصَارِ
u'نَسَبٌ أَوَّلُ':Added, #1: 1	نَسَبِ الْأَنْصَارِ
u'نَسَبٌ أَوَّلُ':Added, #1: 1	نَسَبِ الْأَوَّلِ
u'نَسَبٌ أَوَّلُ':Added, #1: 1	نَسَبُ أَوَّلِ
u'نَسَبٌ أَوْلاَدٌ':Added, #4: 4	نَسَبُ الْأَوَّلِ
u'نَسَبَ بَعْضٌ':Subject, #3: 3	نَسَبُ الْأَوْلَادِ
u'نَسَبٌ بَعْضٌ':Added, #1: 1	نَسَبَ بَعْضُ
u'نَسَبٌ بِنْتٌ':Added, #1: 1	نَسَبُ بَعْضِهِ
u'نِسْبَةٌ إِبْطَالٌ':Added, #1: 1	نَسَبَ الْبِنْتِ
u'نِسْبَةٌ أثَرٌ':Added, #1: 1	نِسْبَةِ الْإِبْطَالِ
u'نِسْبَةٌ آحَادٌ':Added, #1: 1	نِسْبَةَ الْأَثَرِ
u'نِسْبَةٌ آحَادٌ':Added, #1: 1	نِسْبَةَ آحَادِهِ
u'نِسْبَةٌ أَحْكَامٌ':Added, #1: 1	نِسْبَةَ الْآحَادِ
u'نِسْبَةٌ آدَمِيٌّ':Added, #1: 1	نِسْبَةِ أَحْكَامِ
u'نِسْبَةٌ إِرْثٌ':Added, #3: 3	نِسْبَةُ آدَمِيٍّ
u'نِسْبَةٌ إِرْثٌ':Added, #1: 1	نِسْبَةُ إرْثِ
u'نِسْبَةٌ إِرْثٌ':Added, #1: 1	نِسْبَةَ إرْثِهِ
u'نِسْبَةٌ أَسْماءٌ':Added, #5: 5	نِسْبَةُ إرْثِهِ
u'نِسْبَةٌ أصل':Added, #1: 1	نِسْبَةِ الْأَسْمَاءِ
u'نِسْبَةٌ أًصْلٌ':Added, #1: 1	نِسْبَةَ الْأَصْلِ
u'نِسْبَةٌ أُصولٌ':Added, #1: 1	نِسْبَةَ الْأَصْلِ
u'نِسْبَةٌ أَفْعَالٌ':Added, #1: 1	نِسْبَةِ الْأُصُولِ
u'نِسْبَةٌ أَلْفَاظٌ':Added, #1: 1	نِسْبَةِ الْأَفْعَالِ
u'نِسْبَةٌ أُمَّةٌ':Added, #1: 1	نِسْبَةِ الْأَلْفَاظِ
u'نِسْبَةٌ أَوَّلُ':Added, #1: 1	نِسْبَةُ الْأُمَّةِ
u'نِسْبَةٌ أَوَّلُ':Added, #1: 1	نِسْبَةَ الْأَوَّلِ
u'نِسْبَةٌ أَوَّلُ':Added, #1: 1	نِسْبَةُ الْأَوَّلِ
u'نِسْبَةٌ أيَّامٌ':Added, #1: 1	نِسْبَةِ الْأَوَّلِ
u'نِسْبَةٌ أَيَّامٌ':Added, #1: 1	نِسْبَةِ الْأَيَّامِ
u'نِسْبَةٌ بَابٌ':Added, #1: 1	نِسْبَةِ الْأَيَّامِ
u'نِسْبَةٌ بَارِئٌ':Added, #1: 1	نِسْبَةَ بَابِ
u'نِسْبَةٌ بَدَلٌ':Added, #1: 1	نِسْبَةِ الْبَارِئِ
u'نِسْبَةٌ بَدَلٌ':Added, #1: 1	نِسْبَةُ بَدَلِ
u'نِسْبَةٌ بَدَلٌ':Added, #1: 1	نِسْبَةِ بَدَلِ
u'نِسْبَةٌ بَذْرٌ':Added, #2: 2	نِسْبَةَ بَدَلِ
u'نِسْبَةٌ تَبَع':Added, #1: 1	نِسْبَةِ بَذْرِهِ
u'نِسْبَةٌ تَبَعِيّ':Added, #1: 1	نِسْبَةَ التَّبَعِيَّةِ
u'نِسْبَةٌ تَبَعِيَّة':Added, #1: 1	نِسْبَةَ التَّبَعِيَّةِ
u'نِسْبَةٌ تَحْرِيمٌ':Added, #1: 1	نِسْبَةَ التَّبَعِيَّةِ
u'نِسْبَةٌ تَحْسِين':Added, #1: 1	نِسْبَةِ التَّحْرِيمِ
u'نِسْبَةٌ تَخْيِيرٌ':Added, #1: 1	نِسْبَةِ التَّحْسِينِ
u'نِسْبَةٌ تَرْكٌ':Added, #1: 1	نِسْبَةَ التَّخْيِيرِ
u'نِسْبَةٌ تَشْرِيك':Added, #2: 2	نِسْبَةُ تَرْكِ
u'نِسْبَةٌ تَصْحِيحٌ':Added, #1: 1	نِسْبَةِ التَّشْرِيكِ
u'نِسْبَةٌ تَصْرِيحٌ':Added, #1: 1	نِسْبَةَ التَّصْحِيحِ
u'نِسْبَةٌ تَعْرِيفٌ':Added, #1: 1	نِسْبَةِ التَّصْرِيحِ
u'نِسْبَةٌ تَقْصيرٌ':Added, #1: 1	نِسْبَةَ تَعْرِيفٍ
u'نِسْبَةٌ تَوَسُّط':Added, #1: 1	نِسْبَةِ تَقْصِيرٍ
u'نِسْبَةٌ ثُبُوتٌ':Added, #1: 1	نِسْبَةِ تَوَسُّطٍ
u'نِسْبَةٌ ثُبُوتٌ':Added, #1: 1	نِسْبَةُ الثُّبُوتِ
u'نِسْبَةٌ ثَلاثَةٌ':Added, #1: 1	نِسْبَةُ ثُبُوتِ
u'نِسْبَةٌ ثَمَرَةٌ':Added, #1: 1	نِسْبَةَ الثَّلَاثَةِ
u'نِسْبَةٌ ثَوْبٌ':Added, #1: 1	نِسْبَةُ الثَّمَرَةِ
u'نِسْبَةٌ ثَوْبٌ':Added, #1: 1	نِسْبَةَ الثَّوْبِ
u'نِسْبَةٌ جِرَاحَةٌ':Added, #2: 2	نِسْبَةِ الثَّوْبِ
u'نِسْبَةٌ جِرْمٌ':Added, #1: 1	نِسْبَةُ الْجِرَاحَةِ
u'نِسْبَةٌ جِنْسٌ':Added, #1: 1	نِسْبَةُ الْجِرْمِ
u'نِسْبَةٌ جَنِينٌ':Added, #1: 1	نِسْبَةَ جِنْسٍ
u'نِسْبَةٌ جهل':Added, #1: 1	نِسْبَةِ الْجَنِينِ
u'نِسْبَةٌ جَهْلٌ':Added, #1: 1	نِسْبَةُ الْجَهْلِ
u'نِسْبَةٌ جَوَازٌ':Added, #1: 1	نِسْبَةُ الْجَهْلِ
u'نِسْبَةٌ جَوَازٌ':Added, #1: 1	نِسْبَةُ الْجَوَازِ
u'نِسْبَةٌ حالٌ':Added, #1: 1	نِسْبَةِ جَوَازِ
u'نِسْبَةٌ حَديثٌ':Added, #1: 1	نِسْبَةِ حَالِ
u'نِسْبَةٌ حُرْمَةٌ':Added, #1: 1	نِسْبَةُ الْحَدِيثِ
u'نِسْبَةٌ حُرِّيَّةٌ':Added, #1: 1	نِسْبَةُ الْحُرْمَةِ
u'نِسْبَةٌ حَصْرٌ':Added, #2: 2	نِسْبَةِ الْحُرِّيَّةِ
u'نِسْبَةٌ حَظٌّ':Added, #1: 1	نِسْبَةِ الْحَصْرِ
u'نِسْبَةٌ حَقٌّ':Added, #1: 1	نِسْبَةِ الْحَظِّ
u'نِسْبَةٌ حَقِيقٌ':Added, #1: 1	نِسْبَةِ حَقِّهِ
u'نِسْبَةٌ حَقِيقَةٌ':Added, #1: 1	نِسْبَةُ الْحَقِيقَتَيْنِ
u'نِسْبَةٌ حُكْمٌ':Added, #1: 1	نِسْبَةُ حَقِيقَةٍ
u'نِسْبَةٌ حُكْمٌ':Added, #1: 1	نِسْبَةَ الْحُكْمِ
u'نِسْبَةٌ خَطَأٌ':Added, #1: 1	نِسْبَةِ الْحُكْمِ
u'نِسْبَةٌ خلق':Added, #2: 2	نِسْبَةَ الْخَطَأِ
u'نِسْبَةٌ خَلْقٌ':Added, #1: 1	نِسْبَةُ خَلْقِ
u'نِسْبَةٌ خَمْسَةٌ':Added, #1: 1	نِسْبَةُ خَلْقِ
u'نِسْبَةٌ دُيونٌ':Added, #1: 1	نِسْبَةَ خَمْسَةِ
u'نِسْبَةٌ ذاتِيٌّ':Added, #1: 1	نِسْبَةِ الدُّيُونِ
u'نِسْبَةٌ رِبْحٌ':Added, #1: 1	نِسْبَةَ الذَّاتِيَّاتِ
u'نِسْبَةٌ رِوايَةٌ':Added, #1: 1	نِسْبَةِ الرِّبْحِ
u'نِسْبَةٌ رُؤْيَةٌ':Added, #1: 1	نِسْبَةُ الرِّوَايَةِ
u'نِسْبَةٌ زَمانٌ':Added, #1: 1	نِسْبَةِ الرُّؤْيَةِ
u'نِسْبَةٌ سهام':Added, #1: 1	نِسْبَةَ الزَّمَانِ
u'نِسْبَةٌ سِهَامٌ':Added, #1: 1	نِسْبَةَ السِّهَامِ
u'نِسْبَةٌ سهام':Added, #1: 1	نِسْبَةَ السِّهَامِ
u'نِسْبَةٌ سهام':Added, #1: 1	نِسْبَةَ سِهَامِ
u'نِسْبَةٌ سِهَامٌ':Added, #1: 1	نِسْبَةُ سِهَامِ
u'نِسْبَةٌ سِهَامٌ':Added, #1: 1	نِسْبَةَ سِهَامِ
u'نِسْبَةٌ سهام':Added, #1: 1	نِسْبَةُ سِهَامِ
u'نِسْبَةٌ سِهَامٌ':Added, #1: 1	نِسْبَةِ سِهَامِهِ
u'نِسْبَةٌ سَهْمٌ':Added, #1: 1	نِسْبَةِ سِهَامِهِ
u'نِسْبَةٌ سَهْوٌ':Added, #1: 1	نِسْبَةُ سَهْمِ
u'نِسْبَةٌ سُؤَالٌ':Added, #1: 1	نِسْبَةُ السَّهْوِ
u'نِسْبَةٌ شافِعِيّ':Added, #2: 2	نِسْبَةُ السُّؤَالِ
u'نِسْبَةٌ شَرْحٌ':Added, #1: 1	نِسْبَةِ الشَّافِعِيِّ
u'نِسْبَةٌ شركاء':Added, #1: 1	نِسْبَةُ شَرْحِ
u'نِسْبَةٌ شمس':Added, #1: 1	نِسْبَةِ الشُّرَكَاءِ
u'نِسْبَةٌ شَمْسٌ':Added, #1: 1	نِسْبَةُ الشَّمْسِ
u'نِسْبَةٌ شَيْءٌ':Added, #1: 1	نِسْبَةُ الشَّمْسِ
u'نِسْبَةٌ شَيْءٌ':Added, #1: 1	نِسْبَةِ الشَّيْءِ
u'نِسْبَةٌ صدق':Added, #1: 1	نِسْبَةُ شَيْءٍ
u'نِسْبَةٌ صِدْقٌ':Added, #2: 2	نِسْبَةِ الصِّدْقِ
u'نِسْبَةٌ طِبٌّ':Added, #2: 2	نِسْبَةِ الصِّدْقِ
u'نِسْبَةٌ طِبٌّ':Added, #1: 1	نِسْبَةَ طِبِّ
u'نِسْبَةٌ عُبُودِيَّةٌ':Added, #1: 1	نِسْبَةِ طِبِّ
u'نِسْبَةٌ عَدَمٌ':Added, #2: 2	نِسْبَةُ الْعُبُودِيَّةِ
u'نِسْبَةٌ عُشْرٌ':Added, #1: 1	نِسْبَةِ عَدَمِهِ
u'نِسْبَةٌ عُمُومٌ':Added, #1: 1	نِسْبَةَ الْعُشْرِ
u'نِسْبَةٌ غَلَطٌ':Added, #1: 1	نِسْبَةَ الْعُمُومِ
u'نِسْبَةٌ غير':Added, #1: 1	نِسْبَةِ الْغَلَطِ
u'نِسْبَةٌ غَيْرٌ':Added, #2: 2	نِسْبَةِ غَيْرِ
u'نِسْبَةٌ غير':Added, #2: 2	نِسْبَةِ غَيْرِ
u'نِسْبَةٌ غَيْرٌ':Added, #2: 2	نِسْبَةُ غَيْرِهِ
u'نِسْبَةٌ فَرْعٌ':Added, #2: 2	نِسْبَةُ غَيْرِهِ
u'نِسْبَةٌ فساد':Added, #1: 1	نِسْبَةِ الْفَرْعِ
u'نِسْبَةٌ فَسَادٌ':Added, #1: 1	نِسْبَةَ فَسَادٍ
u'نِسْبَةٌ فِعْلٌ':Added, #1: 1	نِسْبَةَ فَسَادٍ
u'نِسْبَةٌ فِعْلٌ':Added, #1: 1	نِسْبَةُ فِعْلِ
u'نِسْبَةٌ فِعْلٌ':Added, #3: 3	نِسْبَةُ الْفِعْلِ
u'نِسْبَةٌ فِعْلٌ':Added, #4: 4	نِسْبَةَ الْفِعْلِ
u'نِسْبَةٌ فلان':Added, #4: 4	نِسْبَةِ الْفِعْلِ
u'نِسْبَةٌ قَائِلٌ':Added, #1: 1	نِسْبَةِ الشَّافِعِيِّ
u'نِسْبَةٌ قَائِلٌ':Added, #1: 1	نِسْبَةُ الْقَائِلِ
u'نِسْبَةٌ قَائِمٌ':Added, #1: 1	نِسْبَةِ قَائِلِهِ
u'نِسْبَةٌ قَبِيحٌ':Added, #1: 1	نِسْبَةِ قَائِمٍ
u'نِسْبَةٌ قَدَرٌ':Added, #1: 1	نِسْبَةِ الْقَبِيحِ
u'نِسْبَةٌ قَدَرُ':Added, #1: 1	نِسْبَةَ الْقَدَرِ
u'نِسْبَةٌ قَدَر':Added, #1: 1	نِسْبَةَ الْقَدَرِيَّةِ
u'نِسْبَةٌ قَدْرٌ':Added, #1: 1	نِسْبَةَ الْقَدَرِيَّةِ
u'نِسْبَةٌ قَدَرِيّ':Added, #1: 1	نِسْبَةُ قَدْرِ
u'نِسْبَةٌ قِرَاءةٌ':Added, #1: 1	نِسْبَةَ الْقَدَرِيَّةِ
u'نِسْبَةٌ قول':Added, #1: 1	نِسْبَةِ الْقِرَاءَاتِ
u'نِسْبَةٌ قول':Added, #1: 1	نِسْبَةَ الْقَوْلِ
u'نِسْبَةٌ قول':Added, #1: 1	نِسْبَةُ الْقَوْلِ
u'نِسْبَةٌ قَوْلٌ':Added, #1: 1	نِسْبَةِ الْقَوْلِ
u'نِسْبَةٌ قَوْلٌ':Added, #1: 1	نِسْبَةَ الْقَوْلِ
u'نِسْبَةٌ قَوْلٌ':Added, #1: 1	نِسْبَةُ الْقَوْلِ
u'نِسْبَةٌ قيام':Added, #1: 1	نِسْبَةِ الْقَوْلِ
u'نِسْبَةٌ قِيَامٌ':Added, #1: 1	نِسْبَةُ الْقِيَامِ
u'نِسْبَةٌ قِيَامٌ':Added, #1: 1	نِسْبَةُ الْقِيَامِ
u'نِسْبَةٌ قِيمَةٌ':Added, #1: 1	نِسْبَةُ قِيَامٍ
u'نِسْبَةٌ قِيمَةٌ':Added, #1: 1	نِسْبَةُ قِيمَتِهِ
u'نِسْبَةٌ كُنْيَةٌ':Added, #2: 2	نِسْبَةِ الْقِيمَةِ
u'نِسْبَةٌ لِسَانٌ':Added, #1: 1	نِسْبَةِ الْكُنْيَةِ
u'نِسْبَةٌ لَفْظٌ':Added, #1: 1	نِسْبَةَ لِسَانٍ
u'نِسْبَةٌ مَالٌ':Added, #1: 1	نِسْبَةَ اللَّفْظِ
u'نِسْبَةٌ مَالٌ':Added, #1: 1	نِسْبَةَ الْمَالَيْنِ
u'نِسْبَةٌ مَانِعٌ':Added, #1: 1	نِسْبَةِ الْمَالَيْنِ
u'نِسْبَةٌ مُتَمَاثِلٌ':Added, #1: 1	نِسْبَةُ الْمَانِعِ
u'نِسْبَةٌ مَجَازٌ':Added, #1: 1	نِسْبَةٍ مُتَمَاثِلَةٍ
u'نِسْبَةٌ مَجِيءٌ':Added, #1: 1	نِسْبَةَ الْمَجَازَيْنِ
u'نِسْبَةٌ مُحْصَنٌ':Added, #2: 2	نِسْبَةَ الْمَجِيءِ
u'نِسْبَةٌ مَخْصُوصٌ':Added, #1: 1	نِسْبَةُ الْمُحْصَنِ
u'نِسْبَةٌ مُذَكَّرٌ':Added, #1: 1	نِسْبَةٍ مَخْصُوصَةٍ
u'نِسْبَةٌ مُشْتَرَكٌ':Added, #1: 1	نِسْبَةِ الْمُذَكَّرِ
u'نِسْبَةٌ مَطْلُوبٌ':Added, #1: 1	نِسْبَةَ الْمُشْتَرَكِ
u'نِسْبَةٌ مُعْتَقٌ':Added, #1: 1	نِسْبَةِ الْمَطْلُوبِ
u'نِسْبَةٌ مُعْتَقٌ':Added, #1: 1	نِسْبَةِ الْمُعْتَقَةِ
u'نِسْبَةٌ مَعْنًى':Added, #1: 1	نِسْبَةَ مُعْتَقِهِ
u'نِسْبَةٌ مَكْرُوهٌ':Added, #1: 1	نِسْبَةِ الْمَعْنَيَيْنِ
u'نِسْبَةٌ مِلْكٌ':Added, #1: 1	نِسْبَةُ الْمَكْرُوهِ
u'نِسْبَةٌ مِلْكٌ':Added, #1: 1	نِسْبَةَ مِلْكٍ
u'نِسْبَةٌ مُنْتَقِلٌ':Added, #2: 2	نِسْبَةِ الْمِلْكِ
u'نِسْبَةٌ مُوجَبٌ':Added, #1: 1	نِسْبَةُ الْمُنْتَقِلِ
u'نِسْبَةٌ مُؤَنَّثٌ':Added, #1: 1	نِسْبَةٍ مُوجَبَةٍ
u'نِسْبَةٌ نِسْبَةٌ':Added, #1: 1	نِسْبَةِ الْمُؤَنَّثِ
u'نِسْبَةٌ نِصْفٌ':Added, #1: 1	نِسْبَةِ النِّسْبَةِ
u'نِسْبَةٌ نَصِيبٌ':Added, #1: 1	نِسْبَةُ النِّصْفِ
u'نِسْبَةٌ نُطْقٌ':Added, #1: 1	نِسْبَةُ نَصِيبِ
u'نِسْبَةٌ نَفْسٌ':Added, #1: 1	نِسْبَةُ النُّطْقِ
u'نِسْبَةٌ نَفْسٌ':Added, #1: 1	نِسْبَةِ نَفْسِ
u'نِسْبَةٌ نَفْيٌ':Added, #1: 1	نِسْبَةَ نَفْسِهِ
u'نِسْبَةٌ نَقْدٌ':Added, #1: 1	نِسْبَةِ نَفْيِ
u'نِسْبَةٌ نَقْد':Added, #1: 1	نِسْبَةِ النَّقْدِ
u'نِسْبَةٌ نَقْصٌ':Added, #1: 1	نِسْبَةِ النَّقْدِ
u'نِسْبَةٌ نُقْصَانٌ':Added, #1: 1	نِسْبَةُ نَقْصِهِ
u'نِسْبَةٌ واحد':Added, #1: 1	نِسْبَةُ النُّقْصَانِ
u'نِسْبَةٌ وَاحِدٌ':Added, #1: 1	نِسْبَةِ الْوَاحِدِ
u'نِسْبَةٌ واحد':Added, #1: 1	نِسْبَةِ الْوَاحِدِ
u'نِسْبَةٌ وَاحِدٌ':Added, #2: 2	نِسْبَةٍ وَاحِدَةٍ
u'نِسْبَةٌ وَاضِعٌ':Added, #2: 2	نِسْبَةٍ وَاحِدَةٍ
u'نِسْبَةٌ وَجْهٌ':Added, #1: 1	نِسْبَةِ الْوَاضِعِ
u'نِسْبَةٌ وُجُودٌ':Added, #1: 1	نِسْبَةِ الْوَجْهَيْنِ
u'نِسْبَةٌ وَسِيلَةٌ':Added, #1: 1	نِسْبَةُ الْوُجُودِ
u'نِسْبَةٌ وَقْتٌ':Added, #1: 1	نِسْبَةِ الْوَسِيلَةِ
u'نِسْبَةٌ وَقْفٌ':Added, #1: 1	نِسْبَةَ الْوَقْتِ
u'نِسْبَةٌ ولد':Added, #1: 1	نِسْبَةَ الْوَقْفِ
u'نِسْبَةٌ ولد':Added, #1: 1	نِسْبَةَ الْوَلَدِ
u'نِسْبَةٌ وَلَدٌ':Added, #1: 1	نِسْبَةِ الْوَلَدِ
u'نِسْبَةٌ وَلَدٌ':Added, #1: 1	نِسْبَةَ الْوَلَدِ
u'نِسْبَةٌ وَلَدٌ':Added, #1: 1	نِسْبَةِ الْوَلَدِ
u'نَسَبٌ تَوْأَمٌ':Added, #1: 1	نِسْبَةِ وَلَدٍ
u'نَسَبٌ ثَابِتٌ':Added, #2: 2	نَسَبَ التَّوْأَمَيْنِ
u'نَسَبٌ ثَالِثٌ':Added, #1: 1	نَسَبٍ ثَابِتٍ
u'نَسَبٌ ثَلاثَةٌ':Added, #1: 1	نَسَبُ الثَّالِثِ
u'نَسَبٌ جَارِي':Added, #2: 2	نَسَبُ الثَّلَاثَةِ
u'نَسَبٌ جَارِيَةٌ':Added, #1: 1	نَسَبُ الْجَارِيَةِ
u'نَسَبَ جَمَاعَةٌ':Subject, #1: 1	نَسَبُ الْجَارِيَةِ
u'نَسَبٌ جَمُوحٌ':Added, #1: 1	نَسَبَ جَمَاعَةٌ
u'نَسَبٌ حَبَشَة':Added, #1: 1	نَسَبُ الْجَمُوحِ
u'نَسَبٌ حُرٌّ':Added, #1: 1	نَسَبَ الْحَبَشَةِ
u'نَسَبٌ حَكَمٌ':Added, #1: 1	نَسَبَ حُرٍّ
u'نَسَبٌ حَنْظَلٌ':Added, #1: 1	نَسَبُ حَكَمٍ
u'نَسَبٌ حَيٌّ':Added, #1: 1	نَسَبُ الْحَنْظَلِيّةِ
u'نَسَبٌ حَيٌّ':Added, #1: 1	نَسَبَ الْحَيِّ
u'نَسَبَ خُزَاعَةٌ':Predicate, #2: 2	نَسَبُ الْحَيِّ
u'نَسَبَ خِلاَفٌ':Predicate, #1: 1	نَسَبَ خُزَاعَةَ
u'نَسَبٌ رَاوِي':Added, #1: 1	نَسَبَ خِلَافَ
u'نَسَبَ رِبْحٌ':Predicate, #2: 2	نَسَبِ رَاوِيهِ
u'نَسَبٌ رَجُلٌ':Added, #2: 2	نَسَبَ الرِّبْحَ
u'نَسَبٌ رَسُولٌ':Added, #1: 1	نَسَبَ رَجُلٍ
u'نَسَبٌ رَسُولٌ':Added, #1: 1	نَسَبُ رَسُولِ
u'نَسَبٌ زَوْجٌ':Added, #5: 5	نَسَبِ رَسُولِ
u'نَسَبٌ زَوْجَةٌ':Added, #3: 3	نَسَبِ الزَّوْجِ
u'نَسَبٌ زَيْدٌ':Added, #1: 1	نَسَبِ الزَّوْجَةِ
u'نَسَبٌ زَيْدٌ':Added, #1: 1	نَسَبِ زَيْدٍ
u'نَسَبٌ سَالِمٌ':Added, #1: 1	نَسَبِ زَيْدِ
u'نَسَبَ شَخْصٌ':Subject, #1: 1	نَسَبُ سَالِمٍ
u'نَسَبٌ شَخْصٌ':Added, #1: 1	نَسَبَ شَخْصٌ
u'نَسَبَ شَيْخٌ':Subject, #2: 2	نَسَبَ الشَّخْصِ
u'نَسَبٌ صَبِيٌّ':Added, #1: 1	نَسَبَ شَيْخُ
u'نَسَبٌ عَبْدٌ':Added, #1: 1	نَسَبَ صَبِيٍّ
u'نَسَبٌ عَبْدٌ':Added, #1: 1	نَسَبَ الْعَبْدِ
u'نَسَبٌ عَبْدٌ':Added, #1: 1	نَسَبِ الْعَبْدِ
u'نَسَبٌ عجم':Added, #1: 1	نَسَبِ عَبْدِ
u'نَسَبٌ عَجَمٌ':Added, #2: 2	نَسَبِ الْعَجَمِ
u'نَسَبٌ عَقْدٌ':Added, #2: 2	نَسَبِ الْعَجَمِ
u'نَسَبَ عَيْبٌ':Predicate, #1: 1	نَسَبَ الْعَقْدَيْنِ
u'نَسَبٌ غُلاَمٌ':Added, #1: 1	نَسَبَ الْعَيْبَ
u'نَسَبٌ غُلاَمٌ':Added, #1: 1	نَسَبُ الْغُلَامِ
u'نَسَبٌ غير':Added, #2: 2	نَسَبَ الْغُلَامِ
u'نَسَبٌ غَيْرٌ':Added, #1: 1	نَسَبِ الْغَيْرِ
u'نَسَبٌ غير':Added, #1: 1	نَسَبِ الْغَيْرِ
u'نَسَبٌ غير':Added, #1: 1	نَسَبُ غَيْرِ
u'نَسَبٌ غَيْرٌ':Added, #1: 1	نَسَبِ غَيْرِ
u'نَسَبٌ غَيْرٌ':Added, #1: 1	نَسَبُ غَيْرِ
u'نَسَبٌ غير':Added, #1: 1	نَسَبِ غَيْرِ
u'نَسَبٌ غَيْرٌ':Added, #1: 1	نَسَبُ غَيْرِهِ
u'نَسَبٌ غير':Added, #1: 1	نَسَبُ غَيْرِهِ
u'نَسَبٌ غَيْرٌ':Added, #5: 5	نَسَبَ غَيْرِهِ
u'نَسَبٌ فَزَعٌ':Added, #5: 5	نَسَبَ غَيْرِهِ
u'نَسَبَ فلان':Predicate, #1: 1	نَسَبُ الْفَزَعِ
u'نَسَبٌ فلان':Added, #2: 2	نَسَبَ عَدْنَانَ
u'نَسَبٌ قَاتِلٌ':Added, #1: 1	نَسَبُ زُبَيْدٍ
u'نَسَبٌ قُرَيْشٌ':Added, #1: 1	نَسَبَ قَاتِلٍ
u'نَسَبٌ قصار':Added, #1: 1	نَسَبِ قُرَيْشٍ
u'نَسَبَ قول':Predicate, #1: 1	نَسَبُ الْقِصَارِ
u'نَسَبَ قَوْلٌ':Predicate, #2: 2	نَسَبَ الْقَوْلَ
u'نَسَبَ قَوْمٌ':Subject, #2: 2	نَسَبَ الْقَوْلَ
u'نَسَبٌ لَعْن':Added, #2: 2	نَسَبَ قَوْمٌ
u'نَسَبٌ لَقِيطٌ':Added, #1: 1	نَسَبَ اللَّعْنِ
u'نَسَبٌ لَقِيطٌ':Added, #1: 1	نَسَبُ اللَّقِيطِ
u'نَسَبٌ مَالِكٌ':Added, #3: 3	نَسَبَ اللَّقِيطِ
u'نَسَبٌ مُتَّفَقٌ':Added, #1: 1	نَسَبُ مَالِكِ
u'نَسَبٌ مَجْهُولٌ':Added, #1: 1	نَسَبُ الْمُتَّفَقِ
u'نَسَبٌ مَجْهُولٌ':Added, #1: 1	نَسَبِ الْمَجْهُولِ
u'نَسَبٌ مُحَمَّدٌ':Added, #2: 2	نَسَبُ الْمَجْهُولِ
u'نَسَبٌ مَذْكُورٌ':Added, #1: 1	نَسَبِ مُحَمّدٍ
u'نَسَبٌ مُسْلِمٌ':Added, #1: 1	نَسَبِ الْمَذْكُورِ
u'نَسَبٌ مُسْلِمٌ':Added, #1: 1	نَسَبِ الْمُسْلِمِ
u'نَسَبٌ مَشْرِقِيٌّ':Added, #1: 1	نَسَبِ مُسْلِمٍ
u'نَسَبٌ مُصَدَّقٌ':Added, #1: 1	نَسَبِ الْمَشْرِقِيِّ
u'نَسَبٌ مَعْلُومٌ':Added, #1: 1	نَسَبِ الْمُصَدَّقِ
u'نَسَبٌ مَكْفُولٌ':Added, #1: 1	نَسَبٍ مَعْلُومٍ
u'نَسَبٌ مُكَلَّفٌ':Added, #1: 1	نَسَبَ الْمَكْفُولِ
u'نَسَبٌ مُلْتَبِسٌ':Added, #1: 1	نَسَبُ الْمُكَلَّفِ
u'نَسَبٌ مِلْكٌ':Added, #1: 1	نَسَبٍ مُلْتَبِسٍ
u'نَسَبٌ مُوَكِّلٌ':Added, #2: 2	نَسَبَ مِلْكِ
u'نَسَبٌ مَوْلُودٌ':Added, #2: 2	نَسَبِ الْمُوَكِّلِ
u'نَسَبٌ مَوْلُودٌ':Added, #1: 1	نَسَبِ الْمَوْلُودِ
u'نَسَبٌ مَوْلُودٌ':Added, #1: 1	نَسَبَ مَوْلُودٍ
u'نَسَبٌ مَوْلُودٌ':Added, #1: 1	نَسَبِ مَوْلُودٍ
u'نَسَبَ مِيرَاثٌ':Predicate, #3: 3	نَسَبُ الْمَوْلُودِ
u'نَسَبٌ نَابِغٌ':Added, #1: 1	نَسَبَ الْمِيرَاثَ
u'نَسَبٌ نَبِيٌّ':Added, #1: 1	نَسَبِ النّابِغَةِ
u'نَسَبٌ نَبِيٌّ':Added, #1: 1	نَسَبُ النَّبِيِّ
u'نَسَبٌ نَصِيبٌ':Added, #1: 1	نَسَبِ النَّبِيِّ
u'نَسَبٌ نُعْمَانُ':Added, #1: 1	نَسَبَ نَصِيبِهِ
u'نَسَبٌ نُعْمَانُ':Added, #1: 1	نَسَبُ النّعْمَانِ
u'نَسَبٌ نمر':Added, #2: 2	نَسَبِ النّعْمَانِ
u'نَسَبٌ نَمِرٌ':Added, #1: 1	نَسَبُ النّمِرِ
u'نَسَبٌ واحد':Added, #1: 1	نَسَبُ النّمِرِ
u'نَسَبٌ وَاحِدٌ':Added, #5: 5	نَسَبُ وَاحِدٍ
u'نَسَبٌ وِلاَدَةٌ':Added, #5: 5	نَسَبُ وَاحِدٍ
u'نَسَبٌ وِلاَدَةٌ':Added, #1: 1	نَسَبُ وِلَادَةٍ
u'نَسَبٌ ولد':Added, #2: 2	نَسَبَ الْوِلَادَةِ
u'نَسَبٌ وَلَدٌ':Added, #111: 111	نَسَبُ الْوَلَدِ
u'نَسَبٌ ولد':Added, #111: 111	نَسَبُ الْوَلَدِ
u'نَسَبٌ وَلَدٌ':Added, #11: 11	نَسَبَ وَلَدِ
u'نَسَبٌ وَلَدٌ':Added, #11: 11	نَسَبَ وَلَدِ
u'نَسَبٌ وَلَدٌ':Added, #12: 12	نَسَبُ الْوَلَدَيْنِ
u'نَسَبٌ ولد':Added, #1: 1	نَسَبُ وَلَدٍ
u'نَسَبٌ وَلَدٌ':Added, #1: 1	نَسَبُ وَلَدِهِ
u'نَسَبٌ ولد':Added, #1: 1	نَسَبُ وَلَدِهِ
u'نَسَبٌ وَلَدٌ':Added, #22: 22	نَسَبُ وَلَدِ
u'نَسَبٌ ولد':Added, #22: 22	نَسَبُ وَلَدِ
u'نَسَبٌ ولد':Added, #2: 2	نَسَبَ وَلَدِهِ
u'نَسَبٌ وَلَدٌ':Added, #2: 2	نَسَبِ وَلَدِهِ
u'نَسَبٌ وَلَدٌ':Added, #2: 2	نَسَبَ وَلَدِهِ
u'نَسَبٌ ولد':Added, #2: 2	نَسَبِ وَلَدِهِ
u'نَسَبٌ وَلَدٌ':Added, #42: 42	نَسَبِ الْوَلَدِ
u'نَسَبٌ ولد':Added, #42: 42	نَسَبِ الْوَلَدِ
u'نَسَبٌ وَلَدٌ':Added, #46: 46	نَسَبَ الْوَلَدِ
u'نَسَبٌ وَلَدٌ':Added, #46: 46	نَسَبَ الْوَلَدِ
u'نَسَبٌ ولد':Added, #4: 4	نَسَبَ الْوَلَدَيْنِ
u'نَسَبٌ وَلَدٌ':Added, #5: 5	نَسَبِ وَلَدِ
u'نَسَبٌ وَلَدٌ':Added, #5: 5	نَسَبِ وَلَدِ
u'نَسَبٌ يمن':Added, #8: 8	نَسَبَ وَلَدٍ
u'نَسَبٌ يَمَنُ':Added, #1: 1	نَسَبِ الْيَمَنِ
u'نَسَجَ بَعْضٌ':Predicate, #1: 1	نَسَبِ الْيَمَنِ
u'نَسَجَ ثَوْبٌ':Predicate, #1: 1	نَسَجَ بَعْضَ
u'نسج ثَوْبٌ':Added, #2: 2	نَسَجَ الثَّوْبَ
u'نسج ثَوْبٌ':Added, #1: 1	نَسْجَ ثَوْبٍ
u'نَسْجٌ ثَوْبٌ':Added, #1: 1	نَسْجِ ثَوْبٍ
u'نَسْجٌ ثَوْبٌ':Added, #1: 1	نَسْجَ ثَوْبٍ
u'نسج ثَوْبٌ':Added, #1: 1	نَسْجِ ثَوْبٍ
u'نَسْجٌ ثَوْبٌ':Added, #4: 4	نَسْجِ الثَّوْبِ
u'نسج ثِيابٌ':Added, #4: 4	نَسْجِ الثَّوْبِ
u'نَسْجٌ ثِيابٌ':Added, #1: 1	نَسْجِ الثِّيَابِ
u'نَسَجَ حَديدٌ':Predicate, #1: 1	نَسْجِ الثِّيَابِ
u'نَسَجَ خِمَارٌ':Predicate, #1: 1	نَسَجَ الْحَدِيدَ
u'نسج رَجُلٌ':Added, #1: 1	نَسَجَ الْخِمَارَ
u'نَسْجٌ رَجُلٌ':Added, #1: 1	نَسْجَ رَجُلٍ
u'نسج زِيادَةٌ':Added, #1: 1	نَسْجَ رَجُلٍ
u'نَسْجٌ زِيادَةٌ':Added, #1: 1	نَسْجِ زِيَادَةٍ
u'نسج شَعْرٌ':Added, #1: 1	نَسْجِ زِيَادَةٍ
u'نَسْجٌ شَعْرٌ':Added, #1: 1	نَسْجُ الشَّعْرِ
u'نسج عَنْكَبُوتٌ':Added, #1: 1	نَسْجُ الشَّعْرِ
u'نَسْجٌ عَنْكَبُوتٌ':Added, #1: 1	نَسْجِ الْعَنْكَبُوتِ
u'نَسَجَ غَزْلٌ':Predicate, #1: 1	نَسْجِ الْعَنْكَبُوتِ
u'نسج غَزْلٌ':Added, #5: 5	نَسَجَ الْغَزْلَ
u'نَسْجٌ غَزْلٌ':Added, #1: 1	نَسْجِ غَزْلٍ
u'نسج غَزْلٌ':Added, #1: 1	نَسْجِ غَزْلٍ
u'نَسْجٌ غَزْلٌ':Added, #3: 3	نَسْجِ الْغَزْلِ
u'نسج فُلاَنٌ':Added, #3: 3	نَسْجِ الْغَزْلِ
u'نَسْجٌ فُلاَنٌ':Added, #5: 5	نَسْجِ فُلَانٍ
u'نَسَجَ كِرْباس':Predicate, #5: 5	نَسْجِ فُلَانٍ
u'نسج كسل':Added, #1: 1	نَسَجَ الْكِرْبَاسَ
u'نَسْجٌ كسل':Added, #1: 1	نَسْجِ الْكَسَلِ
u'نسج كَسَلٌ':Added, #1: 1	نَسْجِ الْكَسَلِ
u'نَسْجٌ كَسَلٌ':Added, #1: 1	نَسْجِ الْكَسَلِ
u'نَسَجَ وَسَائِدُ':Predicate, #1: 1	نَسْجِ الْكَسَلِ
u'نَسَخَ أحَدٌ':Subject, #2: 2	نَسَجَ الْوَسَائِدَ
u'نَسَخَ إِطْلاقٌ':Predicate, #1: 1	نَسَخَ أَحَدُ
u'نَسَخَ آيَةٌ':Predicate, #1: 1	نَسَخَ الْإِطْلَاقَ
u'نَسَخَ بَاطِلٌ':Predicate, #1: 1	نَسَخَ آيَةَ
u'نَسَخَ بَعْضٌ':Predicate, #1: 1	نَسَخَ الْبَاطِلَ
u'نَسَخَ سُنَّةٌ':Predicate, #1: 1	نَسَخَ بَعْضَ
u'نَسَخَ شمس':Predicate, #1: 1	نَسَخَ السُّنَّةَ
u'نَسَخَ شَمْسٌ':Predicate, #1: 1	نَسَخَ الشَّمْسَ
u'نَسَخَ صَوْمٌ':Subject, #1: 1	نَسَخَ الشَّمْسَ
u'نَسَخَ قُرْآنٌ':Subject, #1: 1	نَسَخَ صَوْمُ
u'نَسَخَ قول':Subject, #1: 1	نَسَخَ الْقُرْآنُ
u'نَسَخَ قَوْلٌ':Subject, #1: 1	نَسَخَ قَوْلُهُ
u'نَسَخَ قول':Subject, #1: 1	نَسَخَ قَوْلُهُ
u'نَسَخَ قَوْلٌ':Subject, #2: 2	نَسَخَ الْقَوْلُ
u'نَسَخَ كَافِرٌ':Subject, #2: 2	نَسَخَ الْقَوْلُ
u'نَسَخَ مَأْمُورٌ':Predicate, #1: 1	نَسَخَ الْكَافِرُ
u'نَسَخَ مُتَأَخِّرٌ':Subject, #1: 1	نَسَخَ الْمَأْمُورَ
u'نَسَخَ مُتْعَةٌ':Predicate, #2: 2	نَسَخَ الْمُتَأَخِّرُ
u'نَسَخَ وُجُوبٌ':Predicate, #1: 1	نَسَخَ الْمُتْعَةَ
u'نَسَفَ بَيْنٌ':Predicate, #1: 1	نَسَخَ وُجُوبَ
u'نَسَّقَ طَلاَقٌ':Predicate, #1: 1	نَسَفَ بَيْنَ
u'نَسُكَ شَرِيفٌ':Subject, #1: 1	نَسَّقَ الطَّلَاقَ
u'نَسُكَ وَضِيعٌ':Subject, #1: 1	نَسُكَ الشَّرِيفُ
u'نَسْلٌ أَنْعامٌ':Added, #1: 1	نَسُكَ الْوَضِيعُ
u'نَسْلٌ أَنْعَامٌ':Added, #1: 1	نَسْلِ أَنْعَامٍ
u'نَسْلٌ أَنْعامٌ':Added, #1: 1	نَسْلِ أَنْعَامٍ
u'نَسْلٌ أَنْعَامٌ':Added, #2: 2	نَسْلِ الْأَنْعَامِ
u'نَسْلٌ حِمَارٌ':Added, #2: 2	نَسْلِ الْأَنْعَامِ
u'نَسْلٌ حَيَوَانٌ':Added, #4: 4	نَسْلِ الْحِمَارِ
u'نَسْلٌ حَيَوَانٌ':Added, #1: 1	نَسْلَ الْحَيَوَانِ
u'نَسْلٌ عَرَبٌ':Added, #2: 2	نَسْلِ حَيَوَانٍ
u'نَسْلٌ عَلِيٌّ':Added, #1: 1	نَسْلِ الْعَرَبِ
u'نَسْلٌ فُلاَنٌ':Added, #1: 1	نَسْلِ عَلِيِّ
u'نَسْلٌ كَلْبٌ':Added, #1: 1	نَسْلِ فُلَانٍ
u'نَسْلٌ مَوْقُوفٌ':Added, #1: 1	نَسْلِ كَلْبٍ
u'نَسْلٌ يهود':Added, #1: 1	نَسْلِ الْمَوْقُوفِ
u'نَسْلٌ يَهُودٌ':Added, #1: 1	نَسْلُ الْيَهُودِ
u'نَسِيَ أحَدٌ':Subject, #1: 1	نَسْلُ الْيَهُودِ
u'نَسِيَ إِحْرَامٌ':Predicate, #2: 2	نَسِيَ أَحَدُ
u'نَسِيَ أَرْبَعُ':Predicate, #2: 2	نَسِيَ الْإِحْرَامَ
u'نَسِيَ اِسْتِعْمالٌ':Predicate, #7: 7	نَسِيَ أَرْبَعَ
u'نَسِيَ اِسْمٌ':Predicate, #1: 1	نَسِيَ اسْتِعْمَالَ
u'نَسِيَ أصل':Predicate, #1: 1	نَسِيَ اسْمَ
u'نَسِيَ أًصْلٌ':Predicate, #1: 1	نَسِيَ الْأَصْلَ
u'نَسِيَ أصل':Subject, #1: 1	نَسِيَ الْأَصْلَ
u'نَسِيَ أًصْلٌ':Subject, #2: 2	نَسِيَ الْأَصْلُ
u'نَسِيَ أَعْضَاءٌ':Predicate, #2: 2	نَسِيَ الْأَصْلُ
u'نَسِيَ إمَامٌ':Subject, #1: 1	نَسِيَ أَعْضَاءَ
u'نَسِيَ إمَامٌ':Subject, #1: 1	نَسِيَ إمَامُ
u'نَسِيَ إمَامٌ':Subject, #2: 2	نَسِيَ إمَامُهُ
u'نَسِيَ أُمْنِيَّةٌ':Predicate, #6: 6	نَسِيَ الْإِمَامُ
u'نِسْيَانٌ أصل':Added, #1: 1	نَسِيَ الْأُمْنِيَّةَ
u'نِسْيَانٌ أًصْلٌ':Added, #1: 1	نِسْيَانَ الْأَصْلِ
u'نِسْيَانٌ أصل':Added, #1: 1	نِسْيَانَ الْأَصْلِ
u'نِسْيَانٌ أًصْلٌ':Added, #5: 5	نِسْيَانِ الْأَصْلِ
u'نِسْيَانٌ إِعْرابٌ':Added, #5: 5	نِسْيَانِ الْأَصْلِ
u'نِسْيَانٌ أنبياء':Added, #1: 1	نِسْيَانُ الْإِعْرَابِ
u'نِسْيَانٌ أَوَّلُ':Added, #1: 1	نِسْيَانُ الْأَنْبِيَاءِ
u'نِسْيَانٌ آيَةٌ':Added, #1: 1	نِسْيَانَ الْأَوَّلِ
u'نِسْيَانٌ بَعْضٌ':Added, #1: 1	نِسْيَانَ آيَةٍ
u'نِسْيَانٌ بَعْضٌ':Added, #1: 1	نِسْيَانِ بَعْضِ
u'نِسْيَانٌ تَعْلِيقٌ':Added, #2: 2	نِسْيَانُ بَعْضِ
u'نِسْيَانٌ تَكْبيرٌ':Added, #1: 1	نِسْيَانِ التَّعْلِيقِ
u'نِسْيَانٌ حَديثٌ':Added, #1: 1	نِسْيَانُ التَّكْبِيرِ
u'نِسْيَانٌ خَطٌّ':Added, #1: 1	نِسْيَانِ حَدِيثٍ
u'نِسْيَانٌ شَيْءٌ':Added, #1: 1	نِسْيَانَ الْخَطِّ
u'نِسْيَانٌ صَحَابَةٌ':Added, #1: 1	نِسْيَانُ شَيْءٍ
u'نِسْيَانٌ صِفَةٌ':Added, #1: 1	نِسْيَانِ الصَّحَابَةِ
u'نِسْيَانٌ صنعة':Added, #1: 1	نِسْيَانَ الصِّفَاتِ
u'نِسْيَانٌ صَنْعَةٌ':Added, #1: 1	نِسْيَانِ الصَّنْعَةِ
u'نِسْيَانٌ عِبَادَةٌ':Added, #1: 1	نِسْيَانِ الصَّنْعَةِ
u'نِسْيَانٌ عَبْدٌ':Added, #1: 1	نِسْيَانَ الْعِبَادَةِ
u'نِسْيَانٌ عُضْوٌ':Added, #1: 1	نِسْيَانِ عَبْدِ
u'نِسْيَانٌ عواقب':Added, #1: 1	نِسْيَانَ عُضْوٍ
u'نِسْيَانٌ عَوَاقِبُ':Added, #1: 1	نِسْيَانَ الْعَوَاقِبِ
u'نِسْيَانٌ عَيْنٌ':Added, #1: 1	نِسْيَانَ الْعَوَاقِبِ
u'نِسْيَانٌ عَيْن':Added, #2: 2	نِسْيَانِ عَيْنٍ
u'نِسْيَانٌ فَاتِحٌ':Added, #2: 2	نِسْيَانِ عَيْنٍ
u'نِسْيَانٌ فَاتِحَةٌ':Added, #1: 1	نِسْيَانِ الْفَاتِحَةِ
u'نِسْيَانٌ قُرْآنٌ':Added, #1: 1	نِسْيَانِ الْفَاتِحَةِ
u'نِسْيَانٌ قُرْآنٌ':Added, #1: 1	نِسْيَانُ الْقُرْآنِ
u'نِسْيَانٌ قُرْآنٌ':Added, #3: 3	نِسْيَانِ الْقُرْآنِ
u'نِسْيَانٌ قيام':Added, #4: 4	نِسْيَانَ الْقُرْآنِ
u'نِسْيَانٌ قِيَامٌ':Added, #1: 1	نِسْيَانِ الْقِيَامِ
u'نِسْيَانٌ كذب':Added, #1: 1	نِسْيَانِ الْقِيَامِ
u'نِسْيَانٌ كَوْنٌ':Added, #1: 1	نِسْيَانُ كِذْبِهِ
u'نِسْيَانٌ مثل':Added, #1: 1	نِسْيَانِ كَوْنِهِ
u'نِسْيَانٌ مِثْلٌ':Added, #1: 1	نِسْيَانَ مِثْلِ
u'نِسْيَانٌ نعمة':Added, #1: 1	نِسْيَانَ مِثْلِ
u'نِسْيَانٌ نِعْمَةٌ':Added, #1: 1	نِسْيَانُ النِّعْمَةِ
u'نِسْيَانٌ نُوَبٌ':Added, #1: 1	نِسْيَانُ النِّعْمَةِ
u'نَسِيَ أَوَّلُ':Predicate, #1: 1	نِسْيَانِ النُّوَبِ
u'نَسِيبٌ اِبْنٌ':Added, #1: 1	نَسِيَ الْأَوَّلَ
u'نَسِيَ باقِي':Predicate, #1: 1	نَسِيبُ ابْنِ
u'نَسِيبٌ دَوْلَةٌ':Added, #2: 2	نَسِيَ الْبَاقِيَ
u'نَسِيَ بَسْمَلَةٌ':Predicate, #1: 1	نَسِيبُ الدَّوْلَةِ
u'نَسِيَ بَعْضٌ':Predicate, #1: 1	نَسِيَ الْبَسْمَلَةَ
u'نَسِيَ تَذْكِرَةٌ':Predicate, #1: 1	نَسِيَ بَعْضَ
u'نَسِيَ تَرْتِيبٌ':Predicate, #1: 1	نَسِيَ تَذْكِرَةَ
u'نَسِيَ تَسْبِيحٌ':Predicate, #3: 3	نَسِيَ التَّرْتِيبَ
u'نَسِيَ تَسْبِيحٌ':Predicate, #1: 1	نَسِيَ التَّسْبِيحَ
u'نَسِيَ تَسْمِيَة':Predicate, #2: 2	نَسِيَ تَسْبِيحَ
u'نَسِيَ تَشَهُّدٌ':Predicate, #10: 10	نَسِيَ التَّسْمِيَةَ
u'نَسِيَ تَعَوُّذٌ':Predicate, #5: 5	نَسِيَ التَّشَهُّدَ
u'نَسِيَ تَعْيِينٌ':Predicate, #1: 1	نَسِيَ التَّعَوُّذَ
u'نَسِيَ تَقْيِيد':Predicate, #1: 1	نَسِيَ تَعْيِينَ
u'نَسِيَ تَكْبِير':Predicate, #1: 1	نَسِيَ التَّقْيِيدَ
u'نَسِيَ تَكْبِير':Predicate, #1: 1	نَسِيَ تَكْبِيرَةً
u'نَسِيَ تَكْبيرٌ':Predicate, #3: 3	نَسِيَ تَكْبِيرَةَ
u'نَسِيَ ثَلاثُ':Predicate, #9: 9	نَسِيَ التَّكْبِيرَ
u'نَسِيَ ثَمانِي':Predicate, #3: 3	نَسِيَ ثَلَاثَ
u'نَسِيَ جُلُوسٌ':Predicate, #1: 1	نَسِيَ الثَّمَانِيَ
u'نَسِيَ جَنَابَةٌ':Predicate, #1: 1	نَسِيَ الْجُلُوسَ
u'نَسِيَ جهر':Predicate, #1: 1	نَسِيَ الْجَنَابَةَ
u'نَسِيَ جَهْرٌ':Predicate, #1: 1	نَسِيَ الْجَهْرَ
u'نَسِيَ حاكِمٌ':Subject, #1: 1	نَسِيَ الْجَهْرَ
u'نَسِيَ حَديثٌ':Subject, #1: 1	نَسِيَ الْحَاكِمُ
u'نَسِيَ حِرْفَةٌ':Predicate, #1: 1	نَسِيَ الْحَدِيثُ
u'نَسِيَ حَسَنٌ':Subject, #1: 1	نَسِيَ الْحِرْفَةَ
u'نَسِيَ خامس':Predicate, #3: 3	نَسِيَ الْحَسَنُ
u'نَسِيَ خَامِسٌ':Predicate, #1: 1	نَسِيَ الْخَامِسَ
u'نَسِيَ خَبَرٌ':Predicate, #1: 1	نَسِيَ الْخَامِسَ
u'نَسِيَ خَبَر':Predicate, #1: 1	نَسِيَ الْخَبَرَ
u'نَسِيَ دَليلٌ':Predicate, #1: 1	نَسِيَ الْخَبَرَ
u'نَسِيَ رَاوِي':Predicate, #2: 2	نَسِيَ الدَّلِيلَ
u'نَسِيَ رَقَبَةٌ':Predicate, #1: 1	نَسِيَ رَاوِيَ
u'نَسِيَ رُكوعٌ':Predicate, #4: 4	نَسِيَ الرَّقَبَةَ
u'نَسِيَ رَمَلٌ':Predicate, #2: 2	نَسِيَ الرُّكُوعَ
u'نَسِيَ سجدة':Predicate, #2: 2	نَسِيَ الرَّمَلَ
u'نَسِيَ سَجْدَةٌ':Predicate, #2: 2	نَسِيَ سَجْدَةَ
u'نَسِيَ سُجُودٌ':Predicate, #2: 2	نَسِيَ سَجْدَةَ
u'نَسِيَ سُجُودٌ':Predicate, #10: 10	نَسِيَ سُجُودَ
u'نَسِيَ سلام':Predicate, #2: 2	نَسِيَ السُّجُودَ
u'نَسِيَ سَلاَمٌ':Predicate, #6: 6	نَسِيَ السَّلَامَ
u'نَسِيَ سُهَيْلٌ':Subject, #6: 6	نَسِيَ السَّلَامَ
u'نَسِيَ سِواكٌ':Predicate, #1: 1	نَسِيَ سُهَيْلٌ
u'نَسِيَ سُورَةٌ':Predicate, #2: 2	نَسِيَ السِّوَاكَ
u'نَسِيَ شَاهِدٌ':Subject, #3: 3	نَسِيَ السُّورَةَ
u'نَسِيَ شِدَّةٌ':Predicate, #1: 1	نَسِيَ الشَّاهِدُ
u'نَسِيَ شَهَادَةٌ':Predicate, #2: 2	أَنْسَى شِدَّةَ
u'نَسِيَ شُهُودٌ':Subject, #1: 1	نَسِيَ الشَّهَادَةَ
u'نَسِيَ صَاحِبٌ':Predicate, #1: 1	نَسِيَ الشُّهُودُ
u'نَسِيَ صَلاَةٌ':Predicate, #1: 1	نَسِيَ صَاحِبَ
u'نَسِيَ صَلاَةٌ':Predicate, #1: 1	نَسِيَ الصَّلَاةَ
u'نَسِيَ صنعة':Predicate, #5: 5	نَسِيَ صَلَاةَ
u'نَسِيَ صَنْعَةٌ':Predicate, #1: 1	نَسِيَ الصَّنْعَةَ
u'نَسِيَ صَوْمٌ':Predicate, #1: 1	نَسِيَ الصَّنْعَةَ
u'نَسِيَ طَهَارَةٌ':Predicate, #2: 2	نَسِيَ الصَّوْمَ
u'نَسِيَ طواف':Predicate, #1: 1	نَسِيَ الطَّهَارَةَ
u'نَسِيَ طَوَافٌ':Predicate, #1: 1	نَسِيَ طَوَافَ
u'نَسِيَ ظاهِرٌ':Subject, #1: 1	نَسِيَ طَوَافَ
u'نَسِيَ ظُهْرٌ':Predicate, #1: 1	نَسِيَ ظَاهِرٌ
u'نَسِيَ عَبْدٌ':Subject, #5: 5	نَسِيَ الظُّهْرَ
u'نَسِيَ عَبْدٌ':Subject, #1: 1	نَسِيَ عَبْدٌ
u'نَسِيَ عِشَاءٌ':Predicate, #2: 2	نَسِيَ الْعَبْدُ
u'نَسِيَ عَصْرٌ':Predicate, #1: 1	نَسِيَ الْعِشَاءَ
u'نَسِيَ عَوْم':Predicate, #1: 1	نَسِيَ الْعَصْرَ
u'نَسِيَ غَرِيمٌ':Subject, #1: 1	أَنْسَى الْعَوْمَ
u'نَسِيَ غَسْلٌ':Predicate, #1: 1	نَسِيَ الْغَرِيمُ
u'نَسِيَ فَاتِحٌ':Predicate, #3: 3	نَسِيَ غَسْلَ
u'نَسِيَ فَاتِحَةٌ':Predicate, #7: 7	نَسِيَ الْفَاتِحَةَ
u'نَسِيَ فَجْرٌ':Predicate, #7: 7	نَسِيَ الْفَاتِحَةَ
u'نَسِيَ قَالٌ':Predicate, #1: 1	نَسِيَ الْفَجْرَ
u'نَسِيَ قِرَاءةٌ':Predicate, #1: 1	نَسِيَ قَالَ
u'نَسِيَ قِرَاءةٌ':Predicate, #5: 5	نَسِيَ قِرَاءَةَ
u'نَسِيَ قعدة':Predicate, #7: 7	نَسِيَ الْقِرَاءَةَ
u'نَسِيَ قَعْدَةٌ':Predicate, #1: 1	نَسِيَ الْقَعْدَةَ
u'نَسِيَ قُنُوتٌ':Predicate, #1: 1	نَسِيَ الْقَعْدَةَ
u'نَسِيَ قول':Predicate, #4: 4	نَسِيَ الْقُنُوتَ
u'نَسِيَ قَوْلٌ':Predicate, #2: 2	أَنْسَى قَوْلَ
u'نَسِيَ كَاتِبٌ':Subject, #2: 2	أَنْسَى قَوْلَ
u'نَسِيَ كِتَابٌ':Predicate, #1: 1	نَسِيَ الْكَاتِبُ
u'نَسِيَ لَفْظٌ':Predicate, #2: 2	نَسِيَ الْكِتَابَ
u'نَسِيَ لَيْلٌ':Predicate, #1: 1	نَسِيَ اللَّفْظَ
u'نَسِيَ مَاءٌ':Predicate, #1: 1	نَسِيَ لَيْلَةَ
u'نَسِيَ مَاءٌ':Predicate, #13: 13	نَسِيَ الْمَاءَ
u'نَسِيَ مثل':Predicate, #1: 1	نَسِيَ مَاءَ
u'نَسِيَ مِثْلٌ':Predicate, #1: 1	نَسِيَ مِثْلَ
u'نَسِيَ مُحْدِثٌ':Subject, #1: 1	نَسِيَ مِثْلَ
u'نَسِيَ مُحْرِمٌ':Subject, #1: 1	نَسِيَ الْمُحْدِثُ
u'نَسِيمٌ ريحٌ':Added, #1: 1	نَسِيَ الْمُحْرِمُ
u'نَسِيَ مَسْحٌ':Predicate, #1: 1	نَسِيمِ الرِّيحِ
u'نَسِيَ مَسْحٌ':Predicate, #1: 1	نَسِيَ الْمَسْحَ
u'نَسِيَ مَضْمَضَةٌ':Predicate, #7: 7	نَسِيَ مَسْحَ
u'نَسِيَ مُطَالَبٌ':Predicate, #3: 3	نَسِيَ الْمَضْمَضَةَ
u'نَسِيَ مُطَالَبَةٌ':Predicate, #4: 4	نَسِيَ الْمُطَالَبَةَ
u'نَسِيَ مَطْلُوب':Predicate, #4: 4	نَسِيَ الْمُطَالَبَةَ
u'نَسِيَ مُعْتَقٌ':Predicate, #1: 1	نَسِيَ مَطْلُوبِيَّةَ
u'نَسِيمٌ عَرَقٌ':Added, #1: 1	نَسِيَ الْمُعْتَقَةَ
u'نَسِيَ مَغْصُوب':Subject, #1: 1	نَسِيمَ الْعَرَقِ
u'نَسِيمٌ هَوَاءٌ':Added, #1: 1	نَسِيَ الْمَغْصُوبُ
u'نَسِيَ نكاح':Predicate, #1: 1	نَسِيمُ الْهَوَاءِ
u'نَسِيَ نِكَاحٌ':Predicate, #1: 1	نَسِيَ النِّكَاحَ
u'نَسِيَ نِيَّةٌ':Predicate, #1: 1	نَسِيَ النِّكَاحَ
u'نَسِيَ نِيَّةٌ':Predicate, #1: 1	نَسِيَ نِيَّةَ
u'نَسِيَ وَدِيعٌ':Predicate, #7: 7	نَسِيَ النِّيَّةَ
u'نَسِيَ وَدِيعَةٌ':Predicate, #2: 2	نَسِيَ الْوَدِيعَةَ
u'نَسِيَ وَصِيٌّ':Predicate, #2: 2	نَسِيَ الْوَدِيعَةَ
u'نَسِيَ وَصِيَّةٌ':Predicate, #1: 1	نَسِيَ الْوَصِيَّةَ
u'نَسِيَ وَقْتٌ':Predicate, #1: 1	نَسِيَ الْوَصِيَّةَ
u'نَسِيَ يَمِينٌ':Predicate, #1: 1	نَسِيَ وَقْتَ
u'نَسِيَ يَوْمٌ':Predicate, #1: 1	نَسِيَ الْيَمِينَ
u'نَشَأَ إجَارَةٌ':Predicate, #2: 2	نَسِيَ الْيَوْمَ
u'نَشَأَ إِحْرَامٌ':Predicate, #1: 1	أَنْشَأَ الْإِجَارَةَ
u'نَشَأَ إِحْرَامٌ':Predicate, #1: 1	أَنْشَأَ إحْرَامَ
u'نَشَأَ إِشْكالٌ':Subject, #3: 3	أَنْشَأَ الْإِحْرَامَ
u'نَشَأَ أَمْرٌ':Predicate, #1: 1	نَشَأَ إشْكَالٌ
u'نَشَأَ أَمْرٌ':Subject, #1: 1	أَنْشَأَ الْأَمْرَ
u'نَشَأَ أَمْرٌ':Subject, #1: 1	نَشَأَ أَمْرُ
u'نَشَأَ إِيدَاعٌ':Predicate, #2: 2	نَشَأَ الْأَمْرُ
u'نَشَأَ بَيْنٌ':Predicate, #1: 1	أَنْشَأَ الْإِيدَاعَ
u'نَشَأَ تَدْبِيرٌ':Predicate, #9: 9	نَشَأَ بَيْنَ
u'نَشَأَ تُرْكِيّ':Subject, #1: 1	أَنْشَأَ تَدْبِيرَ
u'نَشَأَ تَسْمِيَة':Subject, #1: 1	نَشَأَ التُّرْكِيُّ
u'نَشَأَ تَلْبيَةٌ':Predicate, #1: 1	نَشَأَ تَسْمِيَتُهُ
u'نَشَأَ تَوْكِيلٌ':Predicate, #2: 2	أَنْشَأَ التَّلْبِيَةَ
u'نَشَأَ حَجٌّ':Predicate, #1: 1	أَنْشَأَ التَّوْكِيلَ
u'نَشَأَ خُرُوجٌ':Subject, #2: 2	أَنْشَأَ الْحَجَّ
u'نَشَأَ خُصُومَةٌ':Predicate, #1: 1	نَشَأَ خُرُوجُهُ
u'نَشَأَ خِلاَفٌ':Subject, #1: 1	أَنْشَأَ الْخُصُومَةَ
u'نَشَأَ دَوْرٌ':Subject, #3: 3	نَشَأَ الْخِلَافُ
u'نَشَأَ سَفَرٌ':Predicate, #1: 1	نَشَأَ الدَّوْرُ
u'نَشَأَ سَفَرٌ':Predicate, #16: 16	أَنْشَأَ السَّفَرَ
u'نَشَأَ سُؤَالٌ':Subject, #4: 4	أَنْشَأَ سَفَرَ
u'نَشَأَ صَلاَةٌ':Predicate, #1: 1	نَشَأَ سُؤَالٌ
u'نشاط دَوَابُّ':Added, #1: 1	أَنْشَأَ الصَّلَاةَ
u'نَشَاطٌ دَوَابُّ':Added, #1: 1	نَشَاطِ الدَّوَابِّ
u'نَشَأَ طَلاَقٌ':Predicate, #1: 1	نَشَاطِ الدَّوَابِّ
u'نَشَأَ ظَنٌّ':Subject, #3: 3	أَنْشَأَ الطَّلَاقَ
u'نَشَأَ عتق':Predicate, #3: 3	نَشَأَ الظَّنُّ
u'نَشَأَ عِتْقٌ':Predicate, #2: 2	أَنْشَأَ الْعِتْقَ
u'نَشَأَ عَقْدٌ':Predicate, #2: 2	أَنْشَأَ الْعِتْقَ
u'نَشَأَ فَسْخٌ':Predicate, #1: 1	أَنْشَأَ الْعَقْدَ
u'نَشَأَ فِعْلٌ':Predicate, #1: 1	أَنْشَأَ الْفَسْخَ
u'نَشَأَ فَقْدٌ':Subject, #1: 1	أَنْشَأَ الْفِعْلَ
u'نَشَأَ قُرَشِيٌّ':Subject, #1: 1	نَشَأَ الْفَقْدُ
u'نَشَأَ قول':Subject, #1: 1	نَشَأَ قُرَشِيٌّ
u'نَشَأَ قَوْلٌ':Subject, #1: 1	نَشَأَ قَوْلُ
u'نَشَأَ كِتَابَةٌ':Predicate, #1: 1	نَشَأَ قَوْلُ
u'نَشَأَ نذر':Predicate, #1: 1	أَنْشَأَ الْكِتَابَةَ
u'نَشَأَ نَذْرٌ':Predicate, #1: 1	أَنْشَأَ النَّذْرَ
u'نَشَأَ نزاع':Subject, #1: 1	أَنْشَأَ النَّذْرَ
u'نَشَأَ نِزَاعٌ':Subject, #1: 1	نَشَأَ النِّزَاعُ
u'نَشَأَ وَدِيعٌ':Predicate, #1: 1	نَشَأَ النِّزَاعُ
u'نَشَأَ وَدِيعَةٌ':Predicate, #2: 2	أَنْشَأَ الْوَدِيعَةَ
u'نَشَأَ ولد':Subject, #2: 2	أَنْشَأَ الْوَدِيعَةَ
u'نَشَأَ وَلَدٌ':Subject, #1: 1	نَشَأَ الْوَلَدُ
u'نَشَدَ ضَالٌّ':Predicate, #1: 1	نَشَأَ الْوَلَدُ
u'نَشَدَ ضَالٌّ':Predicate, #1: 1	نَشَدَ الضَّالَّةَ
u'نَشَدَ نَاسٌ':Predicate, #1: 1	نَشَدَ ضَالَّةً
u'نَشْرٌ آثَارٌ':Added, #1: 1	نَشَدَ النَّاسَ
u'نَشْرٌ أسْنَانٌ':Added, #1: 1	نَشْرِ الْآثَارِ
u'نَشْرٌ أَصابِعُ':Added, #1: 1	نَشْرُ الْأَسْنَانِ
u'نَشْرٌ أَلْوِيَةٌ':Added, #1: 1	نَشْرِ الْأَصَابِعِ
u'نَشْرٌ بَاطن':Added, #1: 1	نَشْرِ الْأَلْوِيَةِ
u'نَشْرٌ باطِنٌ':Added, #1: 1	نَشْرُ بَاطِنِ
u'نَشْرٌ جِدال':Added, #1: 1	نَشْرُ بَاطِنِ
u'نَشَرَ حُرْمَةٌ':Predicate, #1: 1	نَشْرِ الْجِدَالِ
u'نَشْرٌ ذكر':Added, #1: 1	نَشَرَ الْحُرْمَةَ
u'نَشْرٌ ذِكْرٌ':Added, #1: 1	نَشْرُ الذِّكْرِ
u'نَشْرٌ رَائِحٌ':Added, #1: 1	نَشْرُ الذِّكْرِ
u'نَشْرٌ رَائِحَةٌ':Added, #1: 1	نَشْرَ رَائِحَةٍ
u'نَشْرٌ رُخَصٌ':Added, #1: 1	نَشْرَ رَائِحَةٍ
u'نَشْرٌ صَحَائِفُ':Added, #1: 1	نَشْرُ الرُّخَصِ
u'نَشْرٌ صُوفٌ':Added, #1: 1	نَشْرُ الصَّحَائِفِ
u'نَشْرٌ ظاهِرٌ':Added, #2: 2	نَشْرُ الصُّوفِ
u'نَشِرَ عَظْمٌ':Predicate, #1: 1	نَشْرٍ ظَاهِرٍ
u'نَشْرٌ علم':Added, #2: 2	أَنْشَرَ الْعَظْمَ
u'نَشْرٌ عِلْمٌ':Added, #1: 1	نَشْرِ الْعِلْمِ
u'نَشْرٌ فَضِيلَةٌ':Added, #1: 1	نَشْرِ الْعِلْمِ
u'نَشْرٌ كُتُبٌ':Added, #2: 2	نَشْرَ فَضِيلَةٍ
u'نَشْرٌ كَلاَمٌ':Added, #1: 1	نَشْرُ الْكُتُبِ
u'نَشَرَ مُصْحَفٌ':Predicate, #1: 1	نَشْرَ الْكَلَامِ
u'نَشْرٌ مُصَنَّفٌ':Added, #1: 1	نَشَرَ الْمُصْحَفَ
u'نَشَرَ مُلْكٌ':Predicate, #1: 1	نَشْرُ الْمُصَنَّفِ
u'نُشُوءٌ صِغَرٌ':Added, #1: 1	نَشَرَ الْمُلْكَ
u'نَشْوَةٌ شكر':Added, #1: 1	نُشُوءَ الصِّغَرِ
u'نَشْوَةٌ شُكْرٌ':Added, #1: 1	نَشْوَةِ الشُّكْرِ
u'نُشُورٌ عَظْمٌ':Added, #1: 1	نَشْوَةِ الشُّكْرِ
u'نُشُوزٌ الْمَرْءُ':Added, #1: 1	نُشُورُ الْعَظْمِ
u'نُشُوزٌ الْمَرْأَةُ':Added, #1: 1	نُشُوزَ الْمَرْءِ
u'نُشُوزٌ الْمَرْأَةُ':Added, #1: 1	نُشُوزُ الْمَرْأَةِ
u'نُشُوزٌ أُمٌّ':Added, #2: 2	نُشُوزِ الْمَرْأَةِ
u'نُشُوزٌ زَوْجٌ':Added, #1: 1	نُشُوزِ الْأُمِّ
u'نصاب حَرَمٌ':Added, #1: 1	نُشُوزِ الزَّوْجِ
u'نصاب حَرَمٌ':Added, #1: 1	أَنْصَابُ الْحَرَمِ
u'نَصَّ اِبْنٌ':Subject, #1: 1	أَنْصَابِ الْحَرَمِ
u'نَصَّ أحَدٌ':Subject, #23: 23	نَصَّ ابْنُ
u'نَصَّ أَصْحَابٌ':Subject, #1: 1	نَصَّ أَحَدٌ
u'نَصَّ إمَامٌ':Subject, #4: 4	نَصَّ الْأَصْحَابُ
u'نَصَّ أهْلٌ':Subject, #48: 48	نَصَّ الْإِمَامُ
u'نَصَّ أئِمَّةٌ':Subject, #2: 2	نَصَّ أَهْلُ
u'نَصَّ أئِمَّةٌ':Subject, #1: 1	نَصَّ أَئِمَّةُ
u'نصب إبدالٌ':Added, #3: 3	نَصَّ الْأَئِمَّةُ
u'نَصْبٌ إبدالٌ':Added, #3: 3	نَصْبَ الْإِبْدَالِ
u'نصب أبدانٌ':Added, #3: 3	نَصْبَ الْإِبْدَالِ
u'نَصْبٌ أبدانٌ':Added, #1: 1	نَصْبِ الْأَبْدَانِ
u'نَصَّبَ اِبْنٌ':Predicate, #1: 1	نَصْبِ الْأَبْدَانِ
u'نصب أَبْوَابٌ':Added, #1: 1	نَصَّبَ ابْنَ
u'نَصْبٌ أَبْوَابٌ':Added, #1: 1	نَصْبُ الْأَبْوَابِ
u'نصب اِتِّهَامٌ':Added, #1: 1	نَصْبُ الْأَبْوَابِ
u'نَصْبٌ اِتِّهَامٌ':Added, #1: 1	نَصْبِ اتِّهَامٍ
u'نَصَبَ أُحْبُولَةٌ':Predicate, #1: 1	نَصْبِ اتِّهَامٍ
u'نصب أَحْجارٌ':Added, #1: 1	نَصَبَ الْأُحْبُولَةَ
u'نَصْبٌ أَحْجارٌ':Added, #1: 1	نَصْبِ أَحْجَارٍ
u'نصب أَحْكَامٌ':Added, #1: 1	نَصْبِ أَحْجَارٍ
u'نَصْبٌ أَحْكَامٌ':Added, #1: 1	نَصْبُ أَحْكَامٍ
u'نصب أدْعِيَةٌ':Added, #1: 1	نَصْبُ أَحْكَامٍ
u'نَصْبٌ أدْعِيَةٌ':Added, #1: 1	نَصْبُ الْأَدْعِيَةِ
u'نصب أسْبَابٌ':Added, #1: 1	نَصْبُ الْأَدْعِيَةِ
u'نصب أَسْبَابٌ':Added, #1: 1	نَصْبِ الْأَسْبَابِ
u'نَصْبٌ أسْبَابٌ':Added, #1: 1	نَصْبِ الْأَسْبَابِ
u'نَصْبٌ أَسْبَابٌ':Added, #1: 1	نَصْبِ الْأَسْبَابِ
u'نَصَبَ أَعْلاَمٌ':Predicate, #1: 1	نَصْبِ الْأَسْبَابِ
u'نَصَبَ ألف':Predicate, #1: 1	نَصَبَ أَعْلَامَ
u'نَصَبَ ألْفٌ':Predicate, #1: 1	نَصَبَ الْأَلْفَ
u'نَصَبَ أَلْفٌ':Predicate, #1: 1	نَصَبَ الْأَلْفَ
u'نصب ألف':Added, #1: 1	نَصَبَ الْأَلْفَ
u'نَصْبٌ ألف':Added, #1: 1	نَصْبَ الْأَلِفِ
u'نصب أمَارَةٌ':Added, #1: 1	نَصْبَ الْأَلِفِ
u'نصب أمَارَةٌ':Added, #1: 1	نَصْبَ الْأَمَارَةِ
u'نصب أمَارَةٌ':Added, #1: 1	نَصْبُ الْأَمَارَةِ
u'نَصْبٌ أمَارَةٌ':Added, #1: 1	نَصْبِ الْأَمَارَةِ
u'نَصْبٌ أمَارَةٌ':Added, #1: 1	نَصْبَ الْأَمَارَةِ
u'نَصْبٌ أمَارَةٌ':Added, #1: 1	نَصْبُ الْأَمَارَةِ
u'نَصَّبَ إمَامٌ':Subject, #1: 1	نَصْبِ الْأَمَارَةِ
u'نصب إمَامٌ':Added, #2: 2	نَصَّبَ الْإِمَامُ
u'نَصْبٌ إمَامٌ':Added, #1: 1	نَصْبِ إمَامٍ
u'نصب إمَامٌ':Added, #1: 1	نَصْبِ إمَامٍ
u'نَصْبٌ إمَامٌ':Added, #2: 2	نَصْبُ إمَامٍ
u'نصب إمَامٌ':Added, #2: 2	نَصْبُ إمَامٍ
u'نَصْبٌ إمَامٌ':Added, #3: 3	نَصْبُ الْإِمَامِ
u'نصب إمَامٌ':Added, #3: 3	نَصْبُ الْإِمَامِ
u'نَصْبٌ إمَامٌ':Added, #7: 7	نَصْبِ الْإِمَامِ
u'نصب إمَامَةٌ':Added, #7: 7	نَصْبِ الْإِمَامِ
u'نَصْبٌ إمَامَةٌ':Added, #1: 1	نَصْبِ إمَامَةٍ
u'نصب أَنْعامٌ':Added, #1: 1	نَصْبِ إمَامَةٍ
u'نصب أَنْعَامٌ':Added, #1: 1	نَصْبِ الْأَنْعَامِ
u'نَصْبٌ أَنْعامٌ':Added, #1: 1	نَصْبِ الْأَنْعَامِ
u'نَصْبٌ أَنْعَامٌ':Added, #1: 1	نَصْبِ الْأَنْعَامِ
u'نصب أهْلٌ':Added, #1: 1	نَصْبِ الْأَنْعَامِ
u'نَصْبٌ أهْلٌ':Added, #1: 1	نَصْبُ أَهْلِ
u'نصب أَوْثَانٌ':Added, #1: 1	نَصْبُ أَهْلِ
u'نَصْبٌ أَوْثَانٌ':Added, #1: 1	نَصْبِ الْأَوْثَانِ
u'نصب أَوْصِيَاءٌ':Added, #1: 1	نَصْبِ الْأَوْثَانِ
u'نصب أَوْصِيَاءٌ':Added, #1: 1	نَصْبُ الْأَوْصِيَاءِ
u'نَصْبٌ أَوْصِيَاءٌ':Added, #1: 1	نَصْبِ الْأَوْصِيَاءِ
u'نَصْبٌ أَوْصِيَاءٌ':Added, #1: 1	نَصْبُ الْأَوْصِيَاءِ
u'نصب أئِمَّةٌ':Added, #1: 1	نَصْبِ الْأَوْصِيَاءِ
u'نصب أئِمَّةٌ':Added, #1: 1	نَصْبُ الْأَئِمَّةِ
u'نَصْبٌ أئِمَّةٌ':Added, #1: 1	نَصْبِ الْأَئِمَّةِ
u'نَصْبٌ أئِمَّةٌ':Added, #1: 1	نَصْبُ الْأَئِمَّةِ
u'نصب أئِمَّةٌ':Added, #1: 1	نَصْبِ الْأَئِمَّةِ
u'نَصْبٌ أئِمَّةٌ':Added, #2: 2	نَصْبُ أَئِمَّةِ
u'نصب بِيدٌ':Added, #2: 2	نَصْبُ أَئِمَّةِ
u'نَصَبٌ بِيدٌ':Added, #2: 2	نَصَبَ بِيَدِهِ
u'نصب تَنُّورٌ':Added, #2: 2	نَصَبَ بِيَدِهِ
u'نَصْبٌ تَنُّورٌ':Added, #1: 1	نَصْبِ التَّنُّورِ
u'نصب ثَالِثٌ':Added, #1: 1	نَصْبِ التَّنُّورِ
u'نصب ثَالِثٌ':Added, #1: 1	نَصْبَ ثَالِثٍ
u'نَصْبٌ ثَالِثٌ':Added, #1: 1	نَصْبُ ثَالِثٍ
u'نَصْبٌ ثَالِثٌ':Added, #1: 1	نَصْبَ ثَالِثٍ
u'نصب ثَلاثَةٌ':Added, #1: 1	نَصْبُ ثَالِثٍ
u'نَصْبٌ ثَلاثَةٌ':Added, #1: 1	نَصْبِ ثَلَاثَةٍ
u'نَصَبَ ثَوْبٌ':Predicate, #1: 1	نَصْبِ ثَلَاثَةٍ
u'نصب جَمَاجِمُ':Added, #1: 1	نَصَبَ ثَوْبَ
u'نَصْبٌ جَمَاجِمُ':Added, #1: 1	نَصْبِ الْجَمَاجِمِ
u'نصب جُمَلٌ':Added, #1: 1	نَصْبِ الْجَمَاجِمِ
u'نَصْبٌ جُمَلٌ':Added, #1: 1	نَصْبُ جُمَلٍ
u'نصب جناح':Added, #1: 1	نَصْبُ جُمَلٍ
u'نَصْبٌ جناح':Added, #1: 1	نَصْبِ الْجَنَاحِ
u'نصب جَنَاحٌ':Added, #1: 1	نَصْبِ الْجَنَاحِ
u'نَصْبٌ جَنَاحٌ':Added, #1: 1	نَصْبِ الْجَنَاحِ
u'نصب حافِظٌ':Added, #1: 1	نَصْبِ الْجَنَاحِ
u'نَصْبٌ حافِظٌ':Added, #2: 2	نَصْبِ الْحَافِظِ
u'نَصَّبَ حاكِمٌ':Subject, #2: 2	نَصْبِ الْحَافِظِ
u'نَصَبَ حاكِمٌ':Subject, #2: 2	نَصَّبَ الْحَاكِمُ
u'نصب حاكِمٌ':Added, #9: 9	نَصَبَ الْحَاكِمُ
u'نَصْبٌ حاكِمٌ':Added, #1: 1	نَصْبُ الْحَاكِمِ
u'نصب حاكِمٌ':Added, #1: 1	نَصْبُ الْحَاكِمِ
u'نَصْبٌ حاكِمٌ':Added, #2: 2	نَصْبِ حَاكِمٍ
u'نصب حالٌ':Added, #2: 2	نَصْبِ حَاكِمٍ
u'نصب حالٌ':Added, #1: 1	نَصْبُ الْحَالِ
u'نَصْبٌ حالٌ':Added, #1: 1	نَصْبِ الْحَالِ
u'نَصْبٌ حالٌ':Added, #1: 1	نَصْبُ الْحَالِ
u'نَصَبَ حامِي':Predicate, #1: 1	نَصْبِ الْحَالِ
u'نصب حِبالَة':Added, #1: 1	نَصَبَ حَامِيَةً
u'نَصَبٌ حِبالَة':Added, #1: 1	نَصَبَ حِبَالَاتٍ
u'نَصَبَ حَرْبٌ':Predicate, #1: 1	نَصَبَ حِبَالَاتٍ
u'نصب حَرْث':Added, #1: 1	نَصَبَ الْحَرْبَ
u'نَصَبٌ حَرْث':Added, #1: 1	نَصَبِ الْحَرْثَيْنِ
u'نصب حُكَّامٌ':Added, #1: 1	نَصَبِ الْحَرْثَيْنِ
u'نَصْبٌ حُكَّامٌ':Added, #1: 1	نَصْبِ الْحُكَّامِ
u'نَصَبَ حُكْمٌ':Predicate, #1: 1	نَصْبِ الْحُكَّامِ
u'نصب خَطِيبٌ':Added, #1: 1	نَصَبَ الْحُكْمَ
u'نَصْبٌ خَطِيبٌ':Added, #2: 2	نَصْبِ الْخَطِيبِ
u'نَصَّبَ خِلاَفٌ':Predicate, #2: 2	نَصْبِ الْخَطِيبِ
u'نَصَبَ خِلاَفٌ':Predicate, #1: 1	نَصَّبَ الْخِلَافَ
u'نَصَبَ خِلاَفٌ':Predicate, #1: 1	نَصَبَ خِلَافَ
u'نصب خِلاَفٌ':Added, #2: 2	نَصَبَ الْخِلَافَ
u'نَصْبٌ خِلاَفٌ':Added, #1: 1	نَصْبِ الْخِلَافِ
u'نصب خَيْمَةٌ':Added, #1: 1	نَصْبِ الْخِلَافِ
u'نَصْبٌ خَيْمَةٌ':Added, #1: 1	نَصْبَ خَيْمَةٍ
u'نصب دَليلٌ':Added, #1: 1	نَصْبَ خَيْمَةٍ
u'نَصْبٌ دَليلٌ':Added, #1: 1	نَصْبُ الدَّلِيلِ
u'نصب ذَكاةٌ':Added, #1: 1	نَصْبُ الدَّلِيلِ
u'نَصْبٌ ذَكاةٌ':Added, #1: 1	نَصْبِ ذَكَاةِ
u'نصب رَجُلٌ':Added, #1: 1	نَصْبِ ذَكَاةِ
u'نَصْبٌ رَجُلٌ':Added, #1: 1	نَصْبِ رَجُلٍ
u'نصب رَحْمَن':Added, #1: 1	نَصْبِ رَجُلٍ
u'نَصْبٌ رَحْمَن':Added, #1: 1	نَصْبِ الرَّحْمَنِ
u'نصب رَحِيمٌ':Added, #1: 1	نَصْبِ الرَّحْمَنِ
u'نَصْبٌ رَحِيمٌ':Added, #1: 1	نَصْبُ الرَّحِيمِ
u'نَصَبَ رَسُولٌ':Subject, #1: 1	نَصْبُ الرَّحِيمِ
u'نصب زَكاةٌ':Added, #3: 3	نَصَبَ رَسُولُ
u'نَصْبٌ زَكاةٌ':Added, #1: 1	نَصْبِ الزَّكَاةِ
u'نصب سَعَفٌ':Added, #1: 1	نَصْبِ الزَّكَاةِ
u'نصب سَعَف':Added, #2: 2	نَصْبُ سَعَفٍ
u'نَصْبٌ سَعَفٌ':Added, #2: 2	نَصْبُ سَعَفٍ
u'نَصْبٌ سَعَف':Added, #2: 2	نَصْبُ سَعَفٍ
u'نصب سِكِّينٌ':Added, #2: 2	نَصْبُ سَعَفٍ
u'نَصْبٌ سِكِّينٌ':Added, #2: 2	نَصْبُ سِكِّينٍ
u'نَصَبَ سُلْطَانٌ':Subject, #2: 2	نَصْبُ سِكِّينٍ
u'نصب سُلَّمٌ':Added, #1: 1	نَصَبَ السُّلْطَانُ
u'نَصْبٌ سُلَّمٌ':Added, #1: 1	نَصْبَ السُّلَّمِ
u'نصب سُلَّمٌ':Added, #1: 1	نَصْبَ السُّلَّمِ
u'نَصْبٌ سُلَّمٌ':Added, #2: 2	نَصْبِ السُّلَّمِ
u'نصب شُبَّاكٌ':Added, #2: 2	نَصْبِ السُّلَّمِ
u'نَصْبٌ شُبَّاكٌ':Added, #1: 1	نَصْبُ شُبَّاكٍ
u'نصب شبكة':Added, #1: 1	نَصْبُ شُبَّاكٍ
u'نَصْبٌ شبكة':Added, #1: 1	نَصْبُ الشَّبَكَةِ
u'نصب شَبَكَةٌ':Added, #1: 1	نَصْبُ الشَّبَكَةِ
u'نَصْبٌ شَبَكَةٌ':Added, #1: 1	نَصْبُ الشَّبَكَةِ
u'نصب شبكة':Added, #1: 1	نَصْبُ الشَّبَكَةِ
u'نَصْبٌ شبكة':Added, #3: 3	نَصْبِ شَبَكَةٍ
u'نصب شَبَكَةٌ':Added, #3: 3	نَصْبِ شَبَكَةٍ
u'نَصْبٌ شَبَكَةٌ':Added, #3: 3	نَصْبِ شَبَكَةٍ
u'نصب شَخْصٌ':Added, #3: 3	نَصْبِ شَبَكَةٍ
u'نَصْبٌ شَخْصٌ':Added, #1: 1	نَصْبِ الشَّخْصِ
u'نَصَبَ شَرٌّ':Predicate, #1: 1	نَصْبِ الشَّخْصِ
u'نصب شَرٌّ':Added, #2: 2	نَصَبَ الشَّرَّ
u'نَصْبٌ شَرٌّ':Added, #1: 1	نَصْبَ الشَّرِّ
u'نصب شَرَائِعُ':Added, #1: 1	نَصْبَ الشَّرِّ
u'نَصْبٌ شَرَائِعُ':Added, #1: 1	نَصْبُ الشَّرَائِعِ
u'نصب شَرْطٌ':Added, #1: 1	نَصْبُ الشَّرَائِعِ
u'نَصْبٌ شَرْطٌ':Added, #1: 1	نَصْبُ شَرْطٍ
u'نصب شَرْعٌ':Added, #1: 1	نَصْبُ شَرْطٍ
u'نَصْبٌ شَرْعٌ':Added, #1: 1	نَصْبِ الشَّرْعِ
u'نصب شَرْعٌ':Added, #1: 1	نَصْبِ الشَّرْعِ
u'نَصْبٌ شَرْعٌ':Added, #1: 1	نَصْبُ شَرْعٍ
u'نصب شَرْعٌ':Added, #1: 1	نَصْبُ شَرْعٍ
u'نَصْبٌ شَرْعٌ':Added, #2: 2	نَصْبَ الشَّرْعِ
u'نصب شَرْعٌ':Added, #2: 2	نَصْبَ الشَّرْعِ
u'نَصْبٌ شَرْعٌ':Added, #3: 3	نَصْبُ الشَّرْعِ
u'نصب شَرَكٌ':Added, #3: 3	نَصْبُ الشَّرْعِ
u'نَصْبٌ شَرَكٌ':Added, #1: 1	نَصْبِ شَرَكٍ
u'نصب شركاء':Added, #1: 1	نَصْبِ شَرَكٍ
u'نَصْبٌ شركاء':Added, #1: 1	نَصْبِ الشُّرَكَاءِ
u'نَصَبَ شَيْخٌ':Subject, #1: 1	نَصْبِ الشُّرَكَاءِ
u'نصب صَبِيٌّ':Added, #1: 1	نَصَبَ الشَّيْخُ
u'نَصْبٌ صَبِيٌّ':Added, #1: 1	نَصْبِ الصَّبِيِّ
u'نَصَبَ طَاحُونٌ':Predicate, #1: 1	نَصْبِ الصَّبِيِّ
u'نصب طَرْدٌ':Added, #1: 1	نَصَبَ طَاحُونَةً
u'نَصْبٌ طَرْدٌ':Added, #1: 1	نَصْبُ الطَّرْدِ
u'نصب ظَرْفٌ':Added, #1: 1	نَصْبُ الطَّرْدِ
u'نَصْبٌ ظَرْفٌ':Added, #1: 1	نَصْبُ الظَّرْفِ
u'نصب عَادَةٌ':Added, #1: 1	نَصْبُ الظَّرْفِ
u'نَصْبٌ عَادَةٌ':Added, #9: 9	نَصْبِ الْعَادَةِ
u'نَصَّبَ عَاشِرٌ':Predicate, #9: 9	نَصْبِ الْعَادَةِ
u'نصب عَاشِرٌ':Added, #1: 1	نَصَّبَ الْعَاشِرَ
u'نَصْبٌ عَاشِرٌ':Added, #1: 1	نَصْبُ الْعَاشِرِ
u'نصب عَبْدٌ':Added, #1: 1	نَصْبُ الْعَاشِرِ
u'نَصْبٌ عَبْدٌ':Added, #1: 1	نَصْبُ عَبْدِهِ
u'نَصَّبَ عُشَارٌ':Predicate, #1: 1	نَصْبُ عَبْدِهِ
u'نَصَّ بَعْضٌ':Subject, #1: 1	نَصَّبَ الْعُشَارَ
u'نَصَّ بَعْضٌ':Subject, #2: 2	نَصَّ الْبَعْضُ
u'نصب غَرَضٌ':Added, #3: 3	نَصَّ بَعْضُ
u'نَصْبٌ غَرَضٌ':Added, #1: 1	نَصْبُ غَرَضَيْنِ
u'نصب غير':Added, #1: 1	نَصْبُ غَرَضَيْنِ
u'نصب غَيْرٌ':Added, #1: 1	نَصْبُ غَيْرِ
u'نَصْبٌ غير':Added, #1: 1	نَصْبُ غَيْرِ
u'نَصْبٌ غَيْرٌ':Added, #1: 1	نَصْبُ غَيْرِ
u'نصب غير':Added, #1: 1	نَصْبُ غَيْرِ
u'نصب غَيْرٌ':Added, #4: 4	نَصْبُ غَيْرِهِ
u'نَصْبٌ غير':Added, #4: 4	نَصْبُ غَيْرِهِ
u'نَصْبٌ غَيْرٌ':Added, #4: 4	نَصْبُ غَيْرِهِ
u'نصب فَاسِقٌ':Added, #4: 4	نَصْبُ غَيْرِهِ
u'نَصْبٌ فَاسِقٌ':Added, #2: 2	نَصْبُ الْفَاسِقِ
u'نصب فَاصِلٌ':Added, #2: 2	نَصْبُ الْفَاسِقِ
u'نَصْبٌ فَاصِلٌ':Added, #1: 1	نَصْبِ فَاصِلٍ
u'نَصَبَ فَاهٌ':Subject, #1: 1	نَصْبِ فَاصِلٍ
u'نصب فَخٌّ':Added, #1: 1	نَصَبَ فَاهُ
u'نَصْبٌ فَخٌّ':Added, #1: 1	نَصْبِ الْفَخِّ
u'نصب فُسْطَاطٌ':Added, #1: 1	نَصْبِ الْفَخِّ
u'نَصْبٌ فُسْطَاطٌ':Added, #1: 1	نَصْبِ الْفُسْطَاطِ
u'نصب فَقَارٌ':Added, #1: 1	نَصْبِ الْفُسْطَاطِ
u'نَصْبٌ فَقَارٌ':Added, #1: 1	نَصْبُ فَقَارِ
u'نصب فَقِيهٌ':Added, #1: 1	نَصْبُ فَقَارِ
u'نَصْبٌ فَقِيهٌ':Added, #1: 1	نَصْبُ فَقِيهِ
u'نصب فلان':Added, #1: 1	نَصْبُ فَقِيهِ
u'نَصْبٌ فلان':Added, #1: 1	نَصْبِ الرَّحْمَنِ
u'نصب قَاسِمٌ':Added, #1: 1	نَصْبِ الرَّحْمَنِ
u'نَصْبٌ قَاسِمٌ':Added, #1: 1	نَصْبَ قَاسِمٍ
u'نصب قَاسِمٌ':Added, #1: 1	نَصْبَ قَاسِمٍ
u'نَصْبٌ قَاسِمٌ':Added, #2: 2	نَصْبِ الْقَاسِمِ
u'نصب قَاسِمٌ':Added, #2: 2	نَصْبِ الْقَاسِمِ
u'نَصْبٌ قَاسِمٌ':Added, #3: 3	نَصْبُ قَاسِمٍ
u'نصب قَامَةٌ':Added, #3: 3	نَصْبُ قَاسِمٍ
u'نَصْبٌ قَامَةٌ':Added, #1: 1	نَصْبُ الْقَامَةِ
u'نصب قَائِمٌ':Added, #1: 1	نَصْبُ الْقَامَةِ
u'نَصْبٌ قَائِمٌ':Added, #1: 1	نَصْبُ قَائِمٍ
u'نَصَبَ قِبْلَةٌ':Predicate, #1: 1	نَصْبُ قَائِمٍ
u'نصب قتل':Added, #2: 2	نَصَبَ قِبْلَةَ
u'نَصْبٌ قتل':Added, #1: 1	نَصْبِ الْقَتْلِ
u'نصب قَتْلٌ':Added, #1: 1	نَصْبِ الْقَتْلِ
u'نَصْبٌ قَتْلٌ':Added, #1: 1	نَصْبِ الْقَتْلِ
u'نَصَبَ قِدْرٌ':Predicate, #1: 1	نَصْبِ الْقَتْلِ
u'نصب قِدْرٌ':Added, #1: 1	نَصَبَ الْقِدْرَ
u'نَصْبٌ قِدْرٌ':Added, #1: 1	نَصْبُ الْقِدْرِ
u'نصب قدم':Added, #1: 1	نَصْبُ الْقِدْرِ
u'نَصْبٌ قدم':Added, #1: 1	نَصْبِ الْقَدَمِ
u'نصب قَدَمٌ':Added, #1: 1	نَصْبِ الْقَدَمِ
u'نَصْبٌ قَدَمٌ':Added, #1: 1	نَصْبِ الْقَدَمِ
u'نصب قَدَمٌ':Added, #1: 1	نَصْبِ الْقَدَمِ
u'نَصْبٌ قَدَمٌ':Added, #1: 1	نَصْبُ الْقَدَمَيْنِ
u'نصب قَرِينٌ':Added, #1: 1	نَصْبُ الْقَدَمَيْنِ
u'نَصْبٌ قَرِينٌ':Added, #1: 1	نَصْبِ الْقَرِينَةِ
u'نصب قَرِينٌ':Added, #1: 1	نَصْبِ الْقَرِينَةِ
u'نَصْبٌ قَرِينٌ':Added, #1: 1	نَصْبِ قَرِينَةِ
u'نصب قَضَاءٌ':Added, #1: 1	نَصْبِ قَرِينَةِ
u'نَصْبٌ قَضَاءٌ':Added, #1: 1	نَصْبُ الْقَضَاءِ
u'نصب قضاة':Added, #1: 1	نَصْبُ الْقَضَاءِ
u'نَصْبٌ قضاة':Added, #1: 1	نَصْبُ الْقُضَاةِ
u'نصب قَيِّمٌ':Added, #1: 1	نَصْبُ الْقُضَاةِ
u'نَصْبٌ قَيِّمٌ':Added, #1: 1	نَصْبُ الْقَيِّمِ
u'نصب قَيِّمٌ':Added, #1: 1	نَصْبُ الْقَيِّمِ
u'نَصْبٌ قَيِّمٌ':Added, #1: 1	نَصْبُ قَيِّمٍ
u'نصب قَيِّمٌ':Added, #1: 1	نَصْبُ قَيِّمٍ
u'نَصْبٌ قَيِّمٌ':Added, #2: 2	نَصْبِ قَيِّمٍ
u'نصب مَالٌ':Added, #2: 2	نَصْبِ قَيِّمٍ
u'نَصْبٌ مَالٌ':Added, #1: 1	نَصْبَ مَالِهِ
u'نصب مَائِدٌ':Added, #1: 1	نَصْبَ مَالِهِ
u'نَصْبٌ مَائِدٌ':Added, #1: 1	نَصْبِ مَائِدَةٍ
u'نصب مَائِدَةٌ':Added, #1: 1	نَصْبِ مَائِدَةٍ
u'نَصْبٌ مَائِدَةٌ':Added, #1: 1	نَصْبِ مَائِدَةٍ
u'نَصَّبَ مُبْتَدِعٌ':Subject, #1: 1	نَصْبِ مَائِدَةٍ
u'نصب مثل':Added, #1: 1	نَصَّبَ الْمُبْتَدِعُ
u'نَصْبٌ مثل':Added, #1: 1	نَصْبُ مِثْلِ
u'نصب مِثْلٌ':Added, #1: 1	نَصْبُ مِثْلِ
u'نَصْبٌ مِثْلٌ':Added, #1: 1	نَصْبُ مِثْلِ
u'نَصَبَ مَجَانِيقُ':Predicate, #1: 1	نَصْبُ مِثْلِ
u'نصب مَجَانِيقُ':Added, #1: 1	نَصَبَ الْمَجَانِيقَ
u'نَصْبٌ مَجَانِيقُ':Added, #1: 1	نَصْبُ الْمَجَانِيقِ
u'نصب مِحْرَابٌ':Added, #1: 1	نَصْبُ الْمَجَانِيقِ
u'نَصْبٌ مِحْرَابٌ':Added, #1: 1	نَصْبِ مِحْرَابِهِ
u'نَصَبَ مُحْرِمٌ':Subject, #1: 1	نَصْبِ مِحْرَابِهِ
u'نصب مِرْحَاضٌ':Added, #1: 1	نَصَبَ الْمُحْرِمُ
u'نَصْبٌ مِرْحَاضٌ':Added, #1: 1	نَصْبَ مِرْحَاضٍ
u'نصب مُسْتَدْرِك':Added, #1: 1	نَصْبَ مِرْحَاضٍ
u'نَصْبٌ مُسْتَدْرِك':Added, #1: 1	نَصْبَ الْمُسْتَدْرِكِ
u'نصب مُسَخَّرٌ':Added, #1: 1	نَصْبَ الْمُسْتَدْرِكِ
u'نصب مُسَخَّرٌ':Added, #1: 1	نَصْبَ الْمُسَخَّرِ
u'نَصْبٌ مُسَخَّرٌ':Added, #1: 1	نَصْبِ الْمُسَخَّرِ
u'نَصْبٌ مُسَخَّرٌ':Added, #1: 1	نَصْبَ الْمُسَخَّرِ
u'نصب مُسَخَّرٌ':Added, #1: 1	نَصْبِ الْمُسَخَّرِ
u'نَصْبٌ مُسَخَّرٌ':Added, #1: 1	نَصْبُ مُسَخَّرٍ
u'نصب مُشْرِفٌ':Added, #1: 1	نَصْبُ مُسَخَّرٍ
u'نَصْبٌ مُشْرِفٌ':Added, #1: 1	نَصْبُ الْمُشْرِفِ
u'نصب مَصَادِرُ':Added, #1: 1	نَصْبُ الْمُشْرِفِ
u'نَصْبٌ مَصَادِرُ':Added, #1: 1	نَصْبَ الْمَصَادِرِ
u'نصب مَصْدَرٌ':Added, #1: 1	نَصْبَ الْمَصَادِرِ
u'نصب مَصْدَرٌ':Added, #1: 1	نَصْبَ الْمَصْدَرِ
u'نَصْبٌ مَصْدَرٌ':Added, #1: 1	نَصْبُ الْمَصْدَرِ
u'نَصْبٌ مَصْدَرٌ':Added, #1: 1	نَصْبَ الْمَصْدَرِ
u'نصب مُضَارِعٌ':Added, #1: 1	نَصْبُ الْمَصْدَرِ
u'نَصْبٌ مُضَارِعٌ':Added, #1: 1	نَصْبِ الْمُضَارِعِ
u'نصب مَفْعُولٌ':Added, #1: 1	نَصْبِ الْمُضَارِعِ
u'نصب مَفْعُولٌ':Added, #1: 1	نَصْبَ الْمَفْعُولِ
u'نَصْبٌ مَفْعُولٌ':Added, #1: 1	نَصْبُ الْمَفْعُولِ
u'نَصْبٌ مَفْعُولٌ':Added, #1: 1	نَصْبَ الْمَفْعُولِ
u'نصب مَقَادِيرُ':Added, #1: 1	نَصْبُ الْمَفْعُولِ
u'نَصْبٌ مَقَادِيرُ':Added, #4: 4	نَصْبَ الْمَقَادِيرِ
u'نصب مِقْدَارٌ':Added, #4: 4	نَصْبَ الْمَقَادِيرِ
u'نصب مِقْدَارٌ':Added, #1: 1	نَصْبَ الْمِقْدَارِ
u'نَصْبٌ مِقْدَارٌ':Added, #1: 1	نَصْبُ الْمِقْدَارِ
u'نَصْبٌ مِقْدَارٌ':Added, #1: 1	نَصْبَ الْمِقْدَارِ
u'نصب مُقَلِّدٌ':Added, #1: 1	نَصْبُ الْمِقْدَارِ
u'نَصْبٌ مُقَلِّدٌ':Added, #2: 2	نَصْبِ مُقَلِّدٍ
u'نَصَّبَ مَلِكٌ':Subject, #2: 2	نَصْبِ مُقَلِّدٍ
u'نَصَبَ مَنَاجِلُ':Predicate, #1: 1	نَصَّبَ الْمَلِكُ
u'نَصَبَ مَنْجَنِيقٌ':Predicate, #1: 1	نَصَبَ مَنَاجِلَ
u'نصب مَنْجَنِيقٌ':Added, #2: 2	نَصَبَ الْمَنْجَنِيقَ
u'نصب مَنْجَنِيقٌ':Added, #1: 1	نَصْبُ الْمَنْجَنِيقِ
u'نَصْبٌ مَنْجَنِيقٌ':Added, #1: 1	نَصْبِ الْمَنْجَنِيقِ
u'نَصْبٌ مَنْجَنِيقٌ':Added, #1: 1	نَصْبُ الْمَنْجَنِيقِ
u'نصب مُؤَذِّنٌ':Added, #1: 1	نَصْبِ الْمَنْجَنِيقِ
u'نصب مُؤَذِّنٌ':Added, #2: 2	نَصْبُ الْمُؤَذِّنِ
u'نَصْبٌ مُؤَذِّنٌ':Added, #2: 2	نَصْبِ الْمُؤَذِّنِ
u'نَصْبٌ مُؤَذِّنٌ':Added, #2: 2	نَصْبُ الْمُؤَذِّنِ
u'نصب مِيزَابٌ':Added, #2: 2	نَصْبِ الْمُؤَذِّنِ
u'نَصْبٌ مِيزَابٌ':Added, #1: 1	نَصْبِ الْمِيزَابِ
u'نصب نَاظِرٌ':Added, #1: 1	نَصْبِ الْمِيزَابِ
u'نَصْبٌ نَاظِرٌ':Added, #1: 1	نَصْبَ نَاظِرٍ
u'نصب نَاظِرٌ':Added, #1: 1	نَصْبَ نَاظِرٍ
u'نَصْبٌ نَاظِرٌ':Added, #5: 5	نَصْبُ نَاظِرٍ
u'نصب نَبِيٌّ':Added, #5: 5	نَصْبُ نَاظِرٍ
u'نَصْبٌ نَبِيٌّ':Added, #1: 1	نَصْبُ النَّبِيِّ
u'نصب نصاب':Added, #1: 1	نَصْبُ النَّبِيِّ
u'نَصْبٌ نصاب':Added, #1: 1	نَصْبُ النِّصَابِ
u'نصب نِصَابٌ':Added, #1: 1	نَصْبُ النِّصَابِ
u'نَصْبٌ نِصَابٌ':Added, #1: 1	نَصْبُ النِّصَابِ
u'نصب نصاب':Added, #1: 1	نَصْبُ النِّصَابِ
u'نَصْبٌ نصاب':Added, #2: 2	نَصْبَ النِّصَابِ
u'نصب نِصَابٌ':Added, #2: 2	نَصْبَ النِّصَابِ
u'نَصْبٌ نِصَابٌ':Added, #2: 2	نَصْبَ النِّصَابِ
u'نَصَبَ نصب':Predicate, #2: 2	نَصْبَ النِّصَابِ
u'نَصَبَ نُصُبٌ':Predicate, #1: 1	نَصَبَ النُّصُبَ
u'نصب نَفْسٌ':Added, #1: 1	نَصَبَ النُّصُبَ
u'نَصْبٌ نَفْسٌ':Added, #1: 1	نَصْبِ نَفْسِهِ
u'نَصَبَ واحد':Predicate, #1: 1	نَصْبِ نَفْسِهِ
u'نَصَبَ وَاحِدٌ':Predicate, #2: 2	نَصَبَ الْوَاحِدَةَ
u'نصب واحد':Added, #2: 2	نَصَبَ الْوَاحِدَةَ
u'نَصْبٌ واحد':Added, #2: 2	نَصْبُ وَاحِدٍ
u'نصب وَاحِدٌ':Added, #2: 2	نَصْبُ وَاحِدٍ
u'نَصْبٌ وَاحِدٌ':Added, #2: 2	نَصْبُ وَاحِدٍ
u'نَصَبَ وَاقِفٌ':Subject, #2: 2	نَصْبُ وَاحِدٍ
u'نصب وَصْفٌ':Added, #3: 3	نَصَبَ الْوَاقِفُ
u'نَصْبٌ وَصْفٌ':Added, #1: 1	نَصْبُ الْوَصْفِ
u'نصب وَصِيٌّ':Added, #1: 1	نَصْبُ الْوَصْفِ
u'نصب وَصِيٌّ':Added, #1: 1	نَصْبَ وَصِيٍّ
u'نَصْبٌ وَصِيٌّ':Added, #1: 1	نَصْبُ وَصِيٍّ
u'نَصْبٌ وَصِيٌّ':Added, #1: 1	نَصْبَ وَصِيٍّ
u'نصب وَصِيٌّ':Added, #1: 1	نَصْبُ وَصِيٍّ
u'نَصْبٌ وَصِيٌّ':Added, #1: 1	نَصْبِ وَصِيَّيْنِ
u'نصب وَصِيٌّ':Added, #1: 1	نَصْبِ وَصِيَّيْنِ
u'نَصْبٌ وَصِيٌّ':Added, #22: 22	نَصْبِ الْوَصِيِّ
u'نصب وَصِيٌّ':Added, #22: 22	نَصْبِ الْوَصِيِّ
u'نَصْبٌ وَصِيٌّ':Added, #3: 3	نَصْبُ الْوَصِيِّ
u'نصب وَصِيٌّ':Added, #3: 3	نَصْبُ الْوَصِيِّ
u'نَصْبٌ وَصِيٌّ':Added, #3: 3	نَصْبِ وَصِيٍّ
u'نصب وَصِيٌّ':Added, #3: 3	نَصْبِ وَصِيٍّ
u'نَصْبٌ وَصِيٌّ':Added, #7: 7	نَصْبَ الْوَصِيِّ
u'نصب وَكِيلٌ':Added, #7: 7	نَصْبَ الْوَصِيِّ
u'نَصْبٌ وَكِيلٌ':Added, #1: 1	نَصْبُ الْوَكِيلِ
u'نصب وَكِيلٌ':Added, #1: 1	نَصْبُ الْوَكِيلِ
u'نَصْبٌ وَكِيلٌ':Added, #3: 3	نَصْبِ الْوَكِيلِ
u'نصب وَكِيلٌ':Added, #3: 3	نَصْبِ الْوَكِيلِ
u'نَصْبٌ وَكِيلٌ':Added, #4: 4	نَصْبَ الْوَكِيلِ
u'نَصَّبَ وُلاَةٌ':Subject, #4: 4	نَصْبَ الْوَكِيلِ
u'نصب وُلاَةٌ':Added, #1: 1	نَصَّبَ الْوُلَاةُ
u'نَصْبٌ وُلاَةٌ':Added, #1: 1	نَصْبَ الْوُلَاةِ
u'نصب وِلاَيَةٌ':Added, #1: 1	نَصْبَ الْوُلَاةِ
u'نَصْبٌ وِلاَيَةٌ':Added, #1: 1	نَصْبُ وِلَايَةِ
u'نصب وَلِيٌّ':Added, #1: 1	نَصْبُ وِلَايَةِ
u'نَصْبٌ وَلِيٌّ':Added, #1: 1	نَصْبُ الْوَلِيِّ
u'نصب يَدٌ':Added, #1: 1	نَصْبُ الْوَلِيِّ
u'نَصْبٌ يَدٌ':Added, #3: 3	نَصْبِ الْيَدَيْنِ
u'نَصَّ جَلّاب':Subject, #3: 3	نَصْبِ الْيَدَيْنِ
u'نَصَّ جَمَاعَةٌ':Subject, #1: 1	نَصَّ الْجَلَّابُ
u'نَصَّ حاكِمٌ':Subject, #2: 2	نَصَّ جَمَاعَةٌ
u'نَصَحَ رَجُلٌ':Subject, #1: 1	نَصَّ الْحَاكِمُ
u'نَصَحَ زَمانٌ':Subject, #1: 1	نَصَحَ الرَّجُلُ
u'نَصَّ حَفْصٌ':Subject, #1: 1	نَصَحَ الزّمَانُ
u'نَصْرٌ اِبْنٌ':Added, #1: 1	نَصَّ حَفْصُ
u'نَصْرٌ أَخٌ':Added, #1: 1	نَصْرَ ابْنِ
u'نَصْرٌ إِسْلامٌ':Added, #1: 1	نَصْرِ الْأَخِ
u'نَصَرَ إلَهٌ':Subject, #2: 2	نَصْرُ الْإِسْلَامِ
u'نَصْرَانِيٌّ اِمْرَأَةٌ':Added, #2: 2	نَصَرَ الْإِلَهُ
u'نَصْرَانِيَّةٌ اِمْرَأَةٌ':Added, #1: 1	نَصْرَانِيَّةَ امْرَأَةِ
u'نَصْرَانِيَّةٌ حامِلٌ':Added, #1: 1	نَصْرَانِيَّةَ امْرَأَةِ
u'نَصَرَ أَوَّلُ':Predicate, #2: 2	نَصْرَانِيَّةٍ حَامِلٍ
u'نصرة أَبٌ':Added, #1: 1	نَصَرَ الْأَوَّلَ
u'نُصْرَةٌ أَبٌ':Added, #1: 1	نُصْرَةَ الْأَبِ
u'نصرة إِنْسانٌ':Added, #1: 1	نُصْرَةَ الْأَبِ
u'نُصْرَةٌ إِنْسانٌ':Added, #1: 1	نُصْرَةِ إنْسَانٍ
u'نصرة أهْلٌ':Added, #1: 1	نُصْرَةِ إنْسَانٍ
u'نُصْرَةٌ أهْلٌ':Added, #1: 1	نُصْرَةِ أَهْلِ
u'نصرة بَاطِلٌ':Added, #1: 1	نُصْرَةِ أَهْلِ
u'نُصْرَةٌ بَاطِلٌ':Added, #1: 1	نُصْرَةِ الْبَاطِلِ
u'نصرة بُقْعَةٌ':Added, #1: 1	نُصْرَةِ الْبَاطِلِ
u'نُصْرَةٌ بُقْعَةٌ':Added, #2: 2	نُصْرَةُ الْبُقْعَةِ
u'نصرة حَقٌّ':Added, #2: 2	نُصْرَةُ الْبُقْعَةِ
u'نُصْرَةٌ حَقٌّ':Added, #1: 1	نُصْرَةَ الْحَقِّ
u'نصرة حَقٌّ':Added, #1: 1	نُصْرَةَ الْحَقِّ
u'نُصْرَةٌ حَقٌّ':Added, #2: 2	نُصْرَةِ الْحَقِّ
u'نصرة دِينٌ':Added, #2: 2	نُصْرَةِ الْحَقِّ
u'نُصْرَةٌ دِينٌ':Added, #1: 1	نُصْرَةُ الدِّينِ
u'نصرة دِينٌ':Added, #1: 1	نُصْرَةُ الدِّينِ
u'نصرة دَيْنٌ':Added, #1: 1	نُصْرَةِ دِينِ
u'نصرة دَيْنٌ':Added, #1: 1	نُصْرَةَ دَيْنِ
u'نُصْرَةٌ دِينٌ':Added, #1: 1	نُصْرَةِ دَيْنِ
u'نُصْرَةٌ دَيْنٌ':Added, #1: 1	نُصْرَةِ دِينِ
u'نُصْرَةٌ دَيْنٌ':Added, #1: 1	نُصْرَةَ دَيْنِ
u'نصرة رَجُلٌ':Added, #1: 1	نُصْرَةِ دَيْنِ
u'نُصْرَةٌ رَجُلٌ':Added, #1: 1	نُصْرَةِ رَجُلٍ
u'نصرة رُسُلٌ':Added, #1: 1	نُصْرَةِ رَجُلٍ
u'نُصْرَةٌ رُسُلٌ':Added, #1: 1	نُصْرَةَ الرُّسُلِ
u'نصرة رَسُولٌ':Added, #1: 1	نُصْرَةَ الرُّسُلِ
u'نُصْرَةٌ رَسُولٌ':Added, #1: 1	نُصْرَةِ الرّسُولِ
u'نصرة رُومٌ':Added, #1: 1	نُصْرَةِ الرّسُولِ
u'نُصْرَةٌ رُومٌ':Added, #1: 1	نُصْرَةَ الرُّومِ
u'نصرة طَائِفٌ':Added, #1: 1	نُصْرَةَ الرُّومِ
u'نُصْرَةٌ طَائِفٌ':Added, #1: 1	نُصْرَةِ الطَّائِفَةِ
u'نصرة فَارِسٌ':Added, #1: 1	نُصْرَةِ الطَّائِفَةِ
u'نُصْرَةٌ فَارِسٌ':Added, #1: 1	نُصْرَةَ فَارِسٍ
u'نصرة قتال':Added, #1: 1	نُصْرَةَ فَارِسٍ
u'نصرة قِتَالٌ':Added, #1: 1	نُصْرَةُ الْقِتَالِ
u'نُصْرَةٌ قتال':Added, #1: 1	نُصْرَةُ الْقِتَالِ
u'نُصْرَةٌ قِتَالٌ':Added, #1: 1	نُصْرَةُ الْقِتَالِ
u'نصرة قول':Added, #1: 1	نُصْرَةُ الْقِتَالِ
u'نصرة قَوْلٌ':Added, #1: 1	نُصْرَةُ الْقَوْلِ
u'نُصْرَةٌ قول':Added, #1: 1	نُصْرَةُ الْقَوْلِ
u'نُصْرَةٌ قَوْلٌ':Added, #1: 1	نُصْرَةُ الْقَوْلِ
u'نصرة قَوْلٌ':Added, #1: 1	نُصْرَةُ الْقَوْلِ
u'نُصْرَةٌ قَوْلٌ':Added, #1: 1	نُصْرَةِ الْقَوْلَيْنِ
u'نصرة قول':Added, #1: 1	نُصْرَةِ الْقَوْلَيْنِ
u'نصرة قَوْلٌ':Added, #2: 2	نُصْرَةِ قَوْلِ
u'نُصْرَةٌ قول':Added, #2: 2	نُصْرَةِ قَوْلِ
u'نُصْرَةٌ قَوْلٌ':Added, #2: 2	نُصْرَةِ قَوْلِ
u'نصرة مَذْهَبٌ':Added, #2: 2	نُصْرَةِ قَوْلِ
u'نُصْرَةٌ مَذْهَبٌ':Added, #1: 1	نُصْرَةِ مَذْهَبِهِ
u'نصرة مَظْلُومٌ':Added, #1: 1	نُصْرَةِ مَذْهَبِهِ
u'نُصْرَةٌ مَظْلُومٌ':Added, #1: 1	نُصْرَةُ مَظْلُومٍ
u'نصرة مُظْهِرٌ':Added, #1: 1	نُصْرَةُ مَظْلُومٍ
u'نُصْرَةٌ مُظْهِرٌ':Added, #1: 1	نُصْرَةِ مُظْهِرِ
u'نَصْرٌ تَمَّارٌ':Added, #1: 1	نُصْرَةِ مُظْهِرِ
u'نَصَرَ جَوَازٌ':Predicate, #1: 1	نَصْرِ التَّمَّارِ
u'نَصَرَ حِجارَةٌ':Predicate, #1: 1	نَصَرَ جَوَازَ
u'نَصْرٌ خَالِقٌ':Added, #3: 3	نَصَرَ الْحِجَارَةَ
u'نَصْرٌ دِينٌ':Added, #1: 1	نَصْرُ الْخَالِقِ
u'نَصَّ رَسُولٌ':Subject, #1: 1	نَصْرِ دِينِهِ
u'نَصَرَ شَيْخٌ':Subject, #5: 5	نَصَّ رَسُولُ
u'نَصْرٌ عَبْدٌ':Added, #1: 1	نَصَرَ الشَّيْخُ
u'نَصْرٌ قول':Added, #1: 1	نَصْرِ عَبْدِ
u'نَصْرٌ قَوْلٌ':Added, #1: 1	نَصْرَ قَوْلِ
u'نَصْرٌ مُحَمَّدٌ':Added, #1: 1	نَصْرَ قَوْلِ
u'نَصْرٌ مَذْهَبٌ':Added, #2: 2	نَصْرَ مُحَمّدٍ
u'نَصْرٌ مَظْلُومٌ':Added, #1: 1	نَصْرِ الْمَذْهَبِ
u'نَصْرٌ مَظْلُومٌ':Added, #1: 1	نَصْرِ الْمَظْلُومِ
u'نَصْرٌ مَظْلُومٌ':Added, #2: 2	نَصْرَ الْمَظْلُومِ
u'نَصْرٌ نَبِيٌّ':Added, #2: 2	نَصْرُ الْمَظْلُومِ
u'نَصَرَ وَجْهٌ':Predicate, #1: 1	نَصْرَ نَبِيِّهِ
u'نَصَرَ يَوْمٌ':Predicate, #1: 1	نَصَرَ الْوَجْهَ
u'نَصَّ شَارِحٌ':Subject, #1: 1	نَصَرَ يَوْمَ
u'نَصَّ شَارِعٌ':Subject, #1: 1	نَصَّ شَارِحُ
u'نَصَّ شافِعِيّ':Subject, #7: 7	نَصَّ الشَّارِعُ
u'نَصَّ شُهُودٌ':Subject, #79: 79	نَصَّ الشَّافِعِيُّ
u'نَصَّ شُهُودٌ':Subject, #1: 1	نَصَّ الشُّهُودُ
u'نَصَّ شُهُودٌ':Subject, #1: 1	نَصَّ شُهُودُ
u'نَصَّ شَيْخٌ':Subject, #1: 1	نَصَّ شُهُودُهُ
u'نَصَّ شَيْخٌ':Subject, #1: 1	نَصَّ شَيْخُ
u'نَصَّ صَاحِبٌ':Subject, #3: 3	نَصَّ الشَّيْخُ
u'نَصَّ ضَابِطٌ':Subject, #2: 2	نَصَّ صَاحِبُ
u'نَصَّ علماء':Subject, #1: 1	نَصَّ ضَابِطُ
u'نَصَّ عُلَمَاءُ':Subject, #5: 5	نَصَّ الْعُلَمَاءُ
u'نَصَّ غير':Subject, #5: 5	نَصَّ الْعُلَمَاءُ
u'نَصَّ غَيْرٌ':Subject, #2: 2	نَصَّ غَيْرُ
u'نَصَّ فَارِسِيٌّ':Subject, #2: 2	نَصَّ غَيْرُ
u'نَصَّ فَاضِلٌ':Subject, #1: 1	نَصَّ الْفَارِسِيُّ
u'نَصَّفَ دِيَةٌ':Predicate, #1: 1	نَصَّ الْفَاضِلُ
u'نَصَفَ رَبُّ':Subject, #1: 1	نَصَّفَ دِيَةَ
u'نَصَّ فلان':Subject, #1: 1	نَصَفَ رَبُّ
u'نَصَّ فلان':Subject, #1: 1	نَصَّ التِّرْمِذِيُّ
u'نَصَّ قُرْآنٌ':Subject, #79: 79	نَصَّ الشَّافِعِيُّ
u'نَصَّ كِتَابٌ':Subject, #1: 1	نَصَّ الْقُرْآنُ
u'نَصَّ كِتَابٌ':Subject, #1: 1	نَصَّ كِتَابُ
u'نَصْلٌ سِكِّينٌ':Added, #3: 3	نَصَّ الْكِتَابُ
u'نَصْلٌ سَهْمٌ':Added, #1: 1	نَصْلُ السِّكِّينِ
u'نَصْلٌ سَيْفٌ':Added, #1: 1	نَصْلِ السَّهْمِ
u'نَصْلٌ سَيْفٌ':Added, #1: 1	نَصْلَ سَيْفٍ
u'نَصْلٌ سَيْفٌ':Added, #1: 1	نَصْلَ سَيْفِهِ
u'نَصَّ مَالٌ':Subject, #3: 3	نَصْلِ السَّيْفِ
u'نَصَّ مَالِكٌ':Subject, #1: 1	نَصَّ الْمَالُ
u'نَصَّ مُتَوَهِّمٌ':Subject, #2: 2	نَصَّ مَالِكٌ
u'نَصَّ مُحَمَّدٌ':Subject, #1: 1	نَصَّ الْمُتَوَهِّمُ
u'نَصَّ مُحَمَّدٌ':Subject, #26: 26	نَصَّ مُحَمَّدٌ
u'نَصَّ مرٌّ':Predicate, #2: 2	نَصَّ مُحَمَّدُ
u'نَصَّ مَشَايِخُ':Subject, #1: 1	نَصَّ مَرَّةً
u'نَصَّ مُصَنِّفٌ':Subject, #1: 1	نَصَّ الْمَشَايِخُ
u'نَصَّ مُؤَلِّفٌ':Subject, #6: 6	نَصَّ الْمُصَنِّفُ
u'نَصَّ وَاقِفٌ':Subject, #1: 1	نَصَّ الْمُؤَلِّفُ
u'نُصُوصٌ أَشْيَاخٌ':Added, #4: 4	نَصَّ الْوَاقِفُ
u'نُصُوصٌ أَصْحَابٌ':Added, #1: 1	نُصُوصُ الْأَشْيَاخِ
u'نُصُوصٌ أُمٌّ':Added, #1: 1	نُصُوصِ الْأَصْحَابِ
u'نُصُوصٌ إمَامٌ':Added, #1: 1	نُصُوصَ الْأُمِّ
u'نُصُوصٌ إمَامٌ':Added, #1: 1	نُصُوصَ إمَامِهِ
u'نُصُوصٌ إمَامٌ':Added, #2: 2	نُصُوصَ الْإِمَامِ
u'نُصُوصٌ إمَامٌ':Added, #2: 2	نُصُوصِ إمَامِهِ
u'نُصُوصٌ إمَامٌ':Added, #3: 3	نُصُوصُ الْإِمَامِ
u'نُصُوصٌ أئِمَّةٌ':Added, #7: 7	نُصُوصِ الْإِمَامِ
u'نُصُوصٌ أئِمَّةٌ':Added, #1: 1	نُصُوصَ الْأَئِمَّةِ
u'نُصُوصٌ حِلٌّ':Added, #3: 3	نُصُوصِ الْأَئِمَّةِ
u'نُصُوصٌ رُخَصٌ':Added, #1: 1	نُصُوصَ الْحِلِّ
u'نُصُوصٌ زَكَواتٌ':Added, #1: 1	نُصُوصِ الرُّخَصِ
u'نُصُوصٌ سُنَّةٌ':Added, #1: 1	نُصُوصِ الزَّكَوَاتِ
u'نُصُوصٌ شَارِعٌ':Added, #2: 2	نُصُوصُ السُّنَّةِ
u'نُصُوصٌ شَارِعٌ':Added, #1: 1	نُصُوصُ الشَّارِعِ
u'نُصُوصٌ شافِعِيّ':Added, #2: 2	نُصُوصِ الشَّارِعِ
u'نُصُوصٌ شافِعِيّ':Added, #14: 14	نُصُوصِ الشَّافِعِيِّ
u'نُصُوصٌ شافِعِيّ':Added, #3: 3	نُصُوصَ الشَّافِعِيِّ
u'نُصُوصٌ شَرْعٌ':Added, #5: 5	نُصُوصُ الشَّافِعِيِّ
u'نُصُوصٌ فِعْلٌ':Added, #2: 2	نُصُوصِ الشَّرْعِ
u'نُصُوصٌ فلان':Added, #1: 1	نُصُوصُ الْفِعْلِ
u'نُصُوصٌ فلان':Added, #14: 14	نُصُوصِ الشَّافِعِيِّ
u'نُصُوصٌ فلان':Added, #3: 3	نُصُوصَ الشَّافِعِيِّ
u'نُصُوصٌ قَضَاءٌ':Added, #5: 5	نُصُوصُ الشَّافِعِيِّ
u'نُصُوصٌ قَضَاءٌ':Added, #1: 1	نُصُوصُ الْقَضَاءِ
u'نُصُوصٌ قَضَاءٌ':Added, #1: 1	نُصُوصِ الْقَضَاءِ
u'نُصُوصٌ كِتَابٌ':Added, #1: 1	نُصُوصُ قَضَاءِ
u'نُصُوصٌ كِتَابٌ':Added, #1: 1	نُصُوصَ الْكِتَابِ
u'نُصُوصٌ كِتَابٌ':Added, #1: 1	نُصُوصُ الْكِتَابِ
u'نُصُوصٌ كُتُبٌ':Added, #3: 3	نُصُوصِ الْكِتَابِ
u'نُصُوصٌ مُدَوَّنٌ':Added, #1: 1	نُصُوصُ كُتُبِ
u'نُصُوصٌ مُدَوَّنَةٌ':Added, #2: 2	نُصُوصُ الْمُدَوَّنَةِ
u'نُصُوصٌ مَذْهَبٌ':Added, #2: 2	نُصُوصُ الْمُدَوَّنَةِ
u'نُصُوصٌ مَذْهَبٌ':Added, #1: 1	نُصُوصِ الْمَذْهَبِ
u'نُصُوصٌ مَسْحٌ':Added, #5: 5	نُصُوصُ الْمَذْهَبِ
u'نُصُوصٌ وَاقِفٌ':Added, #1: 1	نُصُوصُ الْمَسْحِ
u'نُصُوصٌ وَعِيدٌ':Added, #1: 1	نُصُوصُ الْوَاقِفِ
u'نَضَارَةٌ وَجْهٌ':Added, #2: 2	نُصُوصِ الْوَعِيدِ
u'نَضَبَ مَاءٌ':Subject, #1: 1	نَضَارَةِ الْوَجْهِ
u'نَضَبَ مَاءٌ':Subject, #12: 12	نَضَبَ الْمَاءُ
u'نَضَّ ثَمَنٌ':Subject, #3: 3	نَضَبَ مَاءُ
u'نَضَّ جَازٌ':Predicate, #2: 2	نَضَّ الثَّمَنُ
u'نُضْجٌ بَاطن':Added, #1: 1	نَضَّ جَازَ
u'نُضْجٌ باطِنٌ':Added, #1: 1	نُضْجِ بَاطِنِهِ
u'نَضِجَ بَعْضٌ':Predicate, #1: 1	نُضْجِ بَاطِنِهِ
u'نَضِجَ جَازٌ':Predicate, #1: 1	نَضِجَ بَعْضَ
u'نَضَّجَ دَمامِلُ':Predicate, #1: 1	نَضِجَ جَازَ
u'نُضْجٌ عِنَبٌ':Added, #1: 1	نَضَّجَ الدَّمَامِلَ
u'نَضَحَ بَوْلٌ':Predicate, #1: 1	نُضْجِ الْعِنَبِ
u'نضح دَمٌ':Added, #1: 1	نَضَحَ بَوْلَ
u'نَضْحٌ دَمٌ':Added, #3: 3	نَضْحِ دَمِ
u'نضح رُمَّانٌ':Added, #3: 3	نَضْحِ دَمِ
u'نَضْحٌ رُمَّانٌ':Added, #1: 1	نَضْحُ الرّمّانِ
u'نضح عَبِيرٌ':Added, #1: 1	نَضْحُ الرّمّانِ
u'نَضْحٌ عَبِيرٌ':Added, #1: 1	نَضْحُ الْعَبِيرِ
u'نَضَحَ مَاءٌ':Predicate, #1: 1	نَضْحُ الْعَبِيرِ
u'نضح مَاءٌ':Added, #1: 1	نَضَحَ الْمَاءَ
u'نضح مَاءٌ':Added, #1: 1	نَضْحَ الْمَاءِ
u'نَضْحٌ مَاءٌ':Added, #1: 1	نَضْحِ الْمَاءِ
u'نَضْحٌ مَاءٌ':Added, #1: 1	نَضْحَ الْمَاءِ
u'نضح مَكَانٌ':Added, #1: 1	نَضْحِ الْمَاءِ
u'نَضْحٌ مَكَانٌ':Added, #1: 1	نَضْحِ مَكَانِ
u'نضح نَبْلٌ':Added, #1: 1	نَضْحِ مَكَانِ
u'نَضْحٌ نَبْلٌ':Added, #1: 1	نَضْحَ النَّبْلِ
u'نضح نَبْلٌ':Added, #1: 1	نَضْحَ النَّبْلِ
u'نضح نَبْلٌ':Added, #2: 2	نَضْحُ النَّبْلِ
u'نَضْحٌ نَبْلٌ':Added, #2: 2	نَضْحِ النَّبْلِ
u'نَضْحٌ نَبْلٌ':Added, #2: 2	نَضْحُ النَّبْلِ
u'نَضَّ رِبْحٌ':Subject, #2: 2	نَضْحِ النَّبْلِ
u'نَضْرَةٌ سُرُورٌ':Added, #1: 1	نَضَّ الرِّبْحُ
u'نَضْرَةٌ نَعِيمٌ':Added, #1: 1	نَضْرَةُ السُّرُورِ
u'نَضْرَةٌ نَعِيمٌ':Added, #1: 1	نَضْرَةِ النَّعِيمِ
u'نَضَلَ أحَدٌ':Subject, #2: 2	نَضْرَةُ النَّعِيمِ
u'نَضَّ مَالٌ':Subject, #2: 2	نَضَلَ أَحَدُ
u'نُضُوبٌ مَاءٌ':Added, #3: 3	نَضَّ الْمَالُ
u'نَطَقَ أحَدٌ':Subject, #1: 1	نُضُوبُ الْمَاءِ
u'نَطَقَ أحَدٌ':Subject, #1: 1	نَطَقَ أَحَدٌ
u'نَطَقَ أَعْجَميٌّ':Subject, #1: 1	نَطَقَ أَحَدُ
u'نُطْقٌ آيَةٌ':Added, #1: 1	نَطَقَ الْأَعْجَمِيُّ
u'نَطَقَ حَديثٌ':Subject, #1: 1	نُطْقَ الْآيَةِ
u'نَطَقَ دِينٌ':Subject, #3: 3	نَطَقَ الْحَدِيثُ
u'نَطَقَ سَفِيهٌ':Subject, #1: 1	نَطَقَ دِينُ
u'نُطْقٌ شَاهِدٌ':Added, #1: 1	نَطَقَ السَّفِيهُ
u'نُطْقٌ شَرْعٌ':Added, #1: 1	نُطْقَ الشَّاهِدَيْنِ
u'نُطْقٌ صَبِيٌّ':Added, #1: 1	نُطْقِ الشَّرْعِ
u'نَطَقَ عَجَمِيٌّ':Subject, #1: 1	نُطْقِ الصَّبِيِّ
u'نَطَقَ عَرَبِيٌّ':Subject, #1: 1	نَطَقَ عَجَمِيٌّ
u'نُطْقٌ غَائِبٌ':Added, #1: 1	نَطَقَ الْعَرَبِيُّ
u'نَطَقَ فَلًا':Predicate, #1: 1	نُطْقِ الْغَائِبِ
u'نَطَقَ قُرْآنٌ':Subject, #2: 2	نَطَقَ فَلاَ
u'نَطَقَ كَافِرٌ':Subject, #1: 1	نَطَقَ الْقُرْآنُ
u'نَطَقَ كِتَابٌ':Subject, #2: 2	نَطَقَ الْكَافِرُ
u'نَطَقَ مُبْتَدِئٌ':Subject, #2: 2	نَطَقَ الْكِتَابُ
u'نَطَقَ نَبِيٌّ':Subject, #1: 1	نَطَقَ الْمُبْتَدِئُ
u'نَطَقَ واحد':Subject, #1: 1	نَطَقَ النَّبِيُّ
u'نَطَقَ وَاحِدٌ':Subject, #1: 1	نَطَقَ وَاحِدٌ
u'نَظَافَةٌ أَعْضَاءٌ':Added, #1: 1	نَطَقَ وَاحِدٌ
u'نَظَافَةٌ بدن':Added, #1: 1	نَظَافَةِ الْأَعْضَاءِ
u'نَظَافَةٌ بَدَنٌ':Added, #1: 1	نَظَافَةَ الْبَدَنِ
u'نَظَافَةٌ ثَوْبٌ':Added, #1: 1	نَظَافَةَ الْبَدَنِ
u'نَظَافَةٌ ثَوْبٌ':Added, #1: 1	نَظَافَةَ الثَّوْبِ
u'نَظَافَةٌ مَطْبُوخٌ':Added, #1: 1	نَظَافَةِ الثَّوْبِ
u'نظام أُلْفَةٌ':Added, #1: 1	نَظَافَةَ الْمَطْبُوخِ
u'نِظَامٌ أُلْفَةٌ':Added, #1: 1	نِظَامِ الْأُلْفَةِ
u'نظام أَوَّلُ':Added, #1: 1	نِظَامِ الْأُلْفَةِ
u'نِظَامٌ أَوَّلُ':Added, #1: 1	نِظَامِ أَوَّلِهِ
u'نظام إيمَانٌ':Added, #1: 1	نِظَامِ أَوَّلِهِ
u'نِظَامٌ إيمَانٌ':Added, #2: 2	نِظَامُ الْإِيمَانِ
u'نظام تَقْديرٌ':Added, #2: 2	نِظَامُ الْإِيمَانِ
u'نِظَامٌ تَقْديرٌ':Added, #1: 1	نِظَامِ التَّقْدِيرِ
u'نظام تَقْديرٌ':Added, #1: 1	نِظَامِ التَّقْدِيرِ
u'نِظَامٌ تَقْديرٌ':Added, #1: 1	نِظَامَ تَقْدِيرِهِ
u'نظام تمام':Added, #1: 1	نِظَامَ تَقْدِيرِهِ
u'نظام تَمامٌ':Added, #1: 1	نِظَامَ تَمَامِ
u'نِظَامٌ تمام':Added, #1: 1	نِظَامَ تَمَامِ
u'نِظَامٌ تَمامٌ':Added, #1: 1	نِظَامَ تَمَامِ
u'نظام تَوْحِيدٌ':Added, #1: 1	نِظَامَ تَمَامِ
u'نِظَامٌ تَوْحِيدٌ':Added, #1: 1	نِظَامُ التَّوْحِيدِ
u'نظام جَامِعٌ':Added, #1: 1	نِظَامُ التَّوْحِيدِ
u'نِظَامٌ جَامِعٌ':Added, #1: 1	نِظَامٍ جَامِعٍ
u'نظام جمع':Added, #1: 1	نِظَامٍ جَامِعٍ
u'نِظَامٌ جمع':Added, #1: 1	نِظَامُ الْجَمْعِ
u'نظام جَمْعٌ':Added, #1: 1	نِظَامُ الْجَمْعِ
u'نِظَامٌ جَمْعٌ':Added, #1: 1	نِظَامُ الْجَمْعِ
u'نظام حكمة':Added, #1: 1	نِظَامُ الْجَمْعِ
u'نِظَامٌ حكمة':Added, #1: 1	نِظَامِ الْحِكْمَةِ
u'نظام حِكْمَةٌ':Added, #1: 1	نِظَامِ الْحِكْمَةِ
u'نِظَامٌ حِكْمَةٌ':Added, #1: 1	نِظَامِ الْحِكْمَةِ
u'نظام دَوْلَةٌ':Added, #1: 1	نِظَامِ الْحِكْمَةِ
u'نِظَامٌ دَوْلَةٌ':Added, #1: 1	نِظَامِ الدَّوْلَةِ
u'نظام دِينٌ':Added, #1: 1	نِظَامِ الدَّوْلَةِ
u'نظام دِينٌ':Added, #3: 3	نِظَامُ الدِّينِ
u'نِظَامٌ دِينٌ':Added, #3: 3	نِظَامِ الدِّينِ
u'نِظَامٌ دِينٌ':Added, #3: 3	نِظَامُ الدِّينِ
u'نظام شَبَهٌ':Added, #3: 3	نِظَامِ الدِّينِ
u'نِظَامٌ شَبَهٌ':Added, #1: 1	نِظَامَ الشَّبَهِ
u'نظام شَيْءٌ':Added, #1: 1	نِظَامَ الشَّبَهِ
u'نِظَامٌ شَيْءٌ':Added, #1: 1	نِظَامُ الشَّيْءِ
u'نظام صَوَابٌ':Added, #1: 1	نِظَامُ الشَّيْءِ
u'نِظَامٌ صَوَابٌ':Added, #1: 1	نِظَامِ الصَّوَابِ
u'نظام عَالَمٌ':Added, #1: 1	نِظَامِ الصَّوَابِ
u'نِظَامٌ عَالَمٌ':Added, #2: 2	نِظَامُ الْعَالَمِ
u'نظام قُرْآنٌ':Added, #2: 2	نِظَامُ الْعَالَمِ
u'نِظَامٌ قُرْآنٌ':Added, #1: 1	نِظَامُ الْقُرْآنِ
u'نظام كَلاَمٌ':Added, #1: 1	نِظَامُ الْقُرْآنِ
u'نِظَامٌ كَلاَمٌ':Added, #2: 2	نِظَامَ الْكَلَامِ
u'نظام كَلاَمٌ':Added, #2: 2	نِظَامَ الْكَلَامِ
u'نظام كَلاَمٌ':Added, #3: 3	نِظَامُ الْكَلَامِ
u'نِظَامٌ كَلاَمٌ':Added, #3: 3	نِظَامِ الْكَلَامِ
u'نِظَامٌ كَلاَمٌ':Added, #3: 3	نِظَامُ الْكَلَامِ
u'نظام مُتَّسِقٌ':Added, #3: 3	نِظَامِ الْكَلَامِ
u'نِظَامٌ مُتَّسِقٌ':Added, #1: 1	نِظَامٍ مُتَّسِقٍ
u'نظام مَصَالِحُ':Added, #1: 1	نِظَامٍ مُتَّسِقٍ
u'نِظَامٌ مَصَالِحُ':Added, #1: 1	نِظَامُ الْمَصَالِحِ
u'نظام مَصَالِحُ':Added, #1: 1	نِظَامُ الْمَصَالِحِ
u'نِظَامٌ مَصَالِحُ':Added, #1: 1	نِظَامِ مَصَالِحِ
u'نظام مَعَاشٌ':Added, #1: 1	نِظَامِ مَصَالِحِ
u'نِظَامٌ مَعَاشٌ':Added, #1: 1	نِظَامَ الْمَعَاشِ
u'نظام مَعِيشَةٌ':Added, #1: 1	نِظَامَ الْمَعَاشِ
u'نِظَامٌ مَعِيشَةٌ':Added, #1: 1	نِظَامُ الْمَعِيشَةِ
u'نظام نَشْرٌ':Added, #1: 1	نِظَامُ الْمَعِيشَةِ
u'نِظَامٌ نَشْرٌ':Added, #1: 1	نِظَامُ نَشْرٍ
u'نظام واحد':Added, #1: 1	نِظَامُ نَشْرٍ
u'نِظَامٌ واحد':Added, #2: 2	نِظَامٍ وَاحِدٍ
u'نظام وَاحِدٌ':Added, #2: 2	نِظَامٍ وَاحِدٍ
u'نِظَامٌ وَاحِدٌ':Added, #2: 2	نِظَامٍ وَاحِدٍ
u'نَظَرٌ أَبٌ':Added, #2: 2	نِظَامٍ وَاحِدٍ
u'نَظَرَ إِبْطَالٌ':Predicate, #1: 1	نَظَرُ الْأَبِ
u'نَظَرٌ اِبْنٌ':Added, #1: 1	نَظَرَ إبْطَالَ
u'نَظَرٌ اِبْنٌ':Added, #1: 1	نَظَرَ ابْنِ
u'نَظَرٌ أَجْنَبِيٌّ':Added, #1: 1	نَظَرِ ابْنِ
u'نَظَرٌ أَجْنَبِيٌّ':Added, #1: 1	نَظَرِ أَجْنَبِيَّةٍ
u'نَظَرٌ أَجْنَبِيٌّ':Added, #1: 1	نَظَرُ الْأَجْنَبِيِّ
u'نَظَرٌ إحَاطَةٌ':Added, #2: 2	نَظَرُ الْأَجْنَبِيَّةِ
u'نَظَرَ أحَدٌ':Subject, #1: 1	نَظَرُ إحَاطَةٍ
u'نَظَرَ أحَدٌ':Subject, #1: 1	نَظَرَ أَحَدٌ
u'نَظَرَ أَصْحَابٌ':Subject, #1: 1	نَظَرَ أَحَدُ
u'نَظَرَ أَطْوَلُ':Predicate, #7: 7	نَظَرَ أَصْحَابُ
u'نَظَرٌ الْمَرْأَةُ':Added, #1: 1	نَظَرَ أَطْوَلَ
u'نَظَرٌ الْمَرْأَةُ':Added, #3: 3	نَظَرُ الْمَرْأَةِ
u'نَظَرٌ الْمَرْأَةُ':Added, #3: 3	نَظَرِ الْمَرْأَةِ
u'نَظَرٌ إمَاءٌ':Added, #4: 4	نَظَرَ الْمَرْأَةِ
u'نَظَرَ إمَامٌ':Subject, #1: 1	نَظَرَ الْإِمَاءِ
u'نَظَرٌ إمَامٌ':Added, #3: 3	نَظَرَ الْإِمَامُ
u'نَظَرٌ إمَامٌ':Added, #1: 1	نَظَرُ إِمَامِ
u'نَظَرٌ إمَامٌ':Added, #1: 1	نَظَرِ إمَامِهِ
u'نَظَرٌ أمَةٌ':Added, #3: 3	نَظَرِ الْإِمَامِ
u'نَظَرٌ أمَةٌ':Added, #1: 1	نَظَرَ الْأَمَةِ
u'نَظَرٌ أمراء':Added, #1: 1	نَظَرُ أَمَتِهِ
u'نَظَرٌ اِمْرَأَةٌ':Added, #1: 1	نَظَرِ الْأُمَرَاءِ
u'نَظَرٌ أَمْرَد':Added, #1: 1	نَظَرِ امْرَأَةٍ
u'نَظَرَ أَميرٌ':Subject, #3: 3	نَظَرُ الْأَمْرَدِ
u'نَظَرَ إِنْسانٌ':Subject, #2: 2	نَظَرَ الْأَمِيرُ
u'نَظَرٌ إِنْسانٌ':Added, #2: 2	نَظَرَ إنْسَانٌ
u'نَظَرٌ أهْلٌ':Added, #1: 1	نَظَرِ الْإِنْسَانِ
u'نَظَرٌ أَوْقَافٌ':Added, #3: 3	نَظَرِ أَهْلِ
u'نَظَرٌ أَوَّلُ':Added, #2: 2	نَظَرِ الْأَوْقَافِ
u'نَظَرٌ أئِمَّةٌ':Added, #1: 1	نَظَرِ الْأَوَّلِ
u'نَظَرٌ أئِمَّةٌ':Added, #1: 1	نَظَرَ الْأَئِمَّةِ
u'نَظَرٌ بَائِعٌ':Added, #1: 1	نَظَرُ الْأَئِمَّةِ
u'نَظَرَ بَصَرٌ':Subject, #1: 1	نَظَرَ الْبَائِعِ
u'نَظَرٌ بَصيرٌ':Added, #1: 1	نَظَرَ الْبَصَرُ
u'نَظَرَ بَعْضٌ':Subject, #1: 1	نَظَرِ الْبَصِيرِ
u'نَظَرٌ بَعْضٌ':Added, #1: 1	نَظَرَ بَعْضُ
u'نَظَرٌ بُغْضٌ':Added, #1: 1	نَظَرِ بَعْضِ
u'نَظَرٌ بَيْتٌ':Added, #1: 1	نَظَرُ الْبُغْضِ
u'نَظْرَةٌ تَخْيِيرٌ':Added, #1: 1	نَظَرَ بَيْتِ
u'نَظْرَةٌ فُجَاءةٌ':Added, #1: 1	نَظْرَةَ تَخْيِيرٍ
u'نَظْرَةٌ فَجْأَةٌ':Added, #1: 1	نَظْرَةِ الْفُجَاءَةِ
u'نَظْرَةٌ كَافِرٌ':Added, #1: 1	نَظْرَةِ الْفَجْأَةِ
u'نَظْرَةٌ واحد':Added, #1: 1	نَظْرَةِ الْكَافِرَةِ
u'نَظْرَةٌ وَاحِدٌ':Added, #3: 3	نَظْرَةٍ وَاحِدَةٍ
u'نَظَرٌ تَأْدِيبٌ':Added, #3: 3	نَظْرَةٍ وَاحِدَةٍ
u'نَظَرٌ ثَانِي':Added, #1: 1	نَظَرُ تَأْدِيبِهِ
u'نَظَرٌ ثَانِيَةٌ':Added, #1: 1	نَظَرِ الثَّانِيَةِ
u'نَظَرٌ ثَوابٌ':Added, #1: 1	نَظَرِ الثَّانِيَةِ
u'نَظَرٌ جَاهِلٌ':Added, #1: 1	نَظَرَ الثَّوَابِ
u'نَظَرٌ جَمَاعَةٌ':Added, #1: 1	نَظَرُ الْجَاهِلِ
u'نَظَرٌ جَمَاعَةٌ':Added, #1: 1	نَظَرَ الْجَمَاعَةِ
u'نَظَرَ جَمَلٌ':Subject, #1: 1	نَظَرِ الْجَمَاعَةِ
u'نَظَرٌ جِنٌّ':Added, #1: 1	نَظَرَ الْجَمَلُ
u'نَظَرٌ جِنْسٌ':Added, #1: 1	نَظَرِ الْجِنِّ
u'نَظَرٌ جِنْسٌ':Added, #12: 12	نَظَرَ الْجِنْسِ
u'نَظَرَ حاكِمٌ':Subject, #5: 5	نَظَرُ الْجِنْسِ
u'نَظَرٌ حاكِمٌ':Added, #9: 9	نَظَرَ الْحَاكِمُ
u'نَظَرٌ حاكِمٌ':Added, #1: 1	نَظَرَ الْحَاكِمِ
u'نَظَرٌ حاكِمٌ':Added, #1: 1	نَظَرِ الْحَاكِمِ
u'نَظَرٌ حُرُمٌ':Added, #2: 2	نَظَرُ الْحَاكِمِ
u'نَظَرَ حَقٌّ':Predicate, #1: 1	نَظَرِ حُرُمِ
u'نَظَرٌ خَاتِنٌ':Added, #1: 1	نَظَرَ حَقَّ
u'نَظَرٌ خاصّ':Added, #1: 1	نَظَرُ الْخَاتِنِ
u'نَظَرٌ خَصْمٌ':Added, #1: 1	نَظَرٍ خَاصٍّ
u'نَظَرٌ دَقيقٌ':Added, #1: 1	نَظَرِ الْخَصْمِ
u'نَظَرٌ دَمٌ':Added, #1: 1	نَظَرٍ دَقِيقٍ
u'نَظَرٌ دِينِيٌّ':Added, #1: 1	نَظَرِ دَمِهِ
u'نَظَرٌ ذكر':Added, #1: 1	نَظَرٍ دِينِيٍّ
u'نَظَرٌ ذَكَرٌ':Added, #1: 1	نَظَرُ ذَكَرِهِ
u'نَظَرٌ ذُكورٌ':Added, #1: 1	نَظَرُ ذَكَرِهِ
u'نَظَرٌ ذِمِّيٌّ':Added, #1: 1	نَظَرِ الذُّكُورِ
u'نَظَرٌ ذِمِّيٌّ':Added, #1: 1	نَظَرُ الذِّمِّيَّةِ
u'نَظَرٌ رِجَالٌ':Added, #3: 3	نَظَرِ الذِّمِّيَّةِ
u'نَظَرٌ رِجَالٌ':Added, #1: 1	نَظَرُ الرِّجَالِ
u'نَظَرَ رَجُلٌ':Subject, #1: 1	نَظَرِ الرِّجَالِ
u'نَظَرٌ رَجُلٌ':Added, #4: 4	نَظَرَ الرَّجُلُ
u'نَظَرٌ رَجُلٌ':Added, #12: 12	نَظَرُ الرَّجُلِ
u'نَظَرٌ رَجُلٌ':Added, #15: 15	نَظَرِ الرَّجُلِ
u'نَظَرٌ رَجُلٌ':Added, #1: 1	نَظَرَ الرَّجُلِ
u'نَظَرٌ رَجُلٌ':Added, #1: 1	نَظَرَ رَجُلٍ
u'نَظَرٌ رَجُلٌ':Added, #1: 1	نَظَرُ رَجُلٍ
u'نَظَرٌ رَجُلٌ':Added, #2: 2	نَظَرِ رَجُلٍ
u'نَظَرٌ رحمة':Added, #2: 2	نَظَرُ رَجُلَيْنِ
u'نَظَرٌ رَحْمَةٌ':Added, #1: 1	نَظَرَ رَحْمَةٍ
u'نَظَرَ رَسُولٌ':Subject, #1: 1	نَظَرَ رَحْمَةٍ
u'نَظَرَ رَسُولٌ':Subject, #1: 1	نَظَرَ الرَّسُولُ
u'نَظَرٌ رَسُولٌ':Added, #6: 6	نَظَرَ رَسُولُ
u'نَظَرٌ رَسُولٌ':Added, #1: 1	نَظَرِ رَسُولِهِ
u'نَظَرٌ رُعْبٌ':Added, #2: 2	نَظَرُ الرَّسُولِ
u'نَظَرٌ زاهِدٌ':Added, #1: 1	نَظَرَ الرُّعْبِ
u'نَظَرٌ سَائِرٌ':Added, #1: 1	نَظَرَ الزَّاهِدِ
u'نَظَرَ سائِل':Subject, #1: 1	نَظَرِ سَائِرِ
u'نَظَرَ سَائِلٌ':Subject, #1: 1	نَظَرَ السَّائِلُ
u'نَظَرٌ سُرَّةٌ':Added, #1: 1	نَظَرَ السَّائِلُ
u'نَظَرَ سُلْطَانٌ':Subject, #1: 1	نَظَرِ السُّرَّةِ
u'نَظَرٌ سُلْطَانٌ':Added, #5: 5	نَظَرَ السُّلْطَانُ
u'نَظَرٌ سُلْطَانٌ':Added, #1: 1	نَظَرُ السُّلْطَانِ
u'نَظَرَ سنن':Predicate, #2: 2	نَظَرِ السُّلْطَانِ
u'نَظَرَ شَارِعٌ':Subject, #1: 1	نَظَرَ السُّنَنَ
u'نَظَرٌ شَارِعٌ':Added, #1: 1	نَظَرَ الشَّارِعُ
u'نَظَرٌ شافِعِيّ':Added, #6: 6	نَظَرِ الشَّارِعِ
u'نَظَرٌ شَاهِدٌ':Added, #1: 1	نَظَرِ الشَّافِعِيِّ
u'نَظَرٌ شَائِبٌ':Added, #1: 1	نَظَرُ الشَّاهِدَيْنِ
u'نَظَرَ شَخْصٌ':Subject, #2: 2	نَظَرُ الشَّائِبَةِ
u'نَظَرَ شَرْعٌ':Subject, #2: 2	نَظَرَ الشَّخْصُ
u'نَظَرٌ شَرْعٌ':Added, #1: 1	نَظَرَ الشَّرْعُ
u'نَظَرٌ شَعْرٌ':Added, #13: 13	نَظَرِ الشَّرْعِ
u'نَظَرٌ شَعْرٌ':Added, #2: 2	نَظَرِ شَعْرِ
u'نَظَرٌ شَيْخٌ':Added, #3: 3	نَظَرُ شَعْرِ
u'نَظَرَ صَاحِبٌ':Subject, #1: 1	نَظَرُ الشَّيْخِ
u'نَظَرٌ صَبِيٌّ':Added, #1: 1	نَظَرَ صَاحِبُ
u'نَظَرٌ صَبِيٌّ':Added, #1: 1	نَظَرَ الصَّبِيِّ
u'نَظَرٌ صَحَابَةٌ':Added, #1: 1	نَظَرُ الصَّبِيِّ
u'نَظَرٌ صِحَّةٌ':Added, #1: 1	نَظَرِ الصَّحَابَةِ
u'نَظَرٌ صَحِيحٌ':Added, #1: 1	نَظَرُ الصِّحَّةِ
u'نَظَرٌ صَقْرٌ':Added, #1: 1	نَظَرَ الصَّحِيحِ
u'نَظَرٌ ضَيْعَةٌ':Added, #1: 1	نَظَرَ الصَّقْرِ
u'نَظَرٌ طَبِيبٌ':Added, #1: 1	نَظَرِ ضَيْعَةٍ
u'نَظَرٌ ظاهِرٌ':Added, #2: 2	نَظَرِ الطَّبِيبِ
u'نَظَرٌ ظاهِرٌ':Added, #1: 1	نَظَرُ الظَّاهِرِ
u'نَظَرٌ عَالِمٌ':Added, #1: 1	نَظَرٍ ظَاهِرٍ
u'نَظَرٌ عَامٌّ':Added, #1: 1	نَظَرِ عَالِمٍ
u'نَظَرٌ عَامٌ':Added, #1: 1	نَظَرٍ عَامٍّ
u'نَظَرَ عِبَارَةٌ':Predicate, #1: 1	نَظَرِ عَامِهِ
u'نَظَرَ عَبَّاسٌ':Subject, #1: 1	نَظَرَ عِبَارَةَ
u'نَظَرَ عَبْدٌ':Subject, #1: 1	نَظَرَ الْعَبّاسُ
u'نَظَرٌ عَبْدٌ':Added, #1: 1	نَظَرَ عَبْدُ
u'نَظَرٌ عَبْدٌ':Added, #1: 1	نَظَرِ عَبْدِ
u'نَظَرٌ عَبْل':Added, #3: 3	نَظَرِ الْعَبْدِ
u'نَظَرَ عَرَبٌ':Subject, #1: 1	نَظَرُ الْعَبْلِ
u'نَظَرٌ عَقْلٌ':Added, #1: 1	نَظَرَ الْعَرَبُ
u'نَظَرٌ عَقْلٌ':Added, #1: 1	نَظَرَ الْعَقْلِ
u'نَظَرٌ عَقْلٌ':Added, #2: 2	نَظَرُ الْعَقْلِ
u'نَظَرٌ عُقَلاَءُ':Added, #4: 4	نَظَرِ الْعَقْلِ
u'نَظَرٌ عُقَلاَءُ':Added, #1: 1	نَظَرُ عُقَلَاءِ
u'نَظَرٌ عُقُولٌ':Added, #2: 2	نَظَرِ الْعُقَلَاءِ
u'نَظَرَ عُمَرٌ':Subject, #1: 1	نَظَرِ الْعُقُولِ
u'نَظَرَ عَوْرَةٌ':Predicate, #2: 2	نَظَرَ عُمَرُ
u'نَظَرٌ عَوْرَةٌ':Added, #1: 1	نَظَرَ عَوْرَةَ
u'نَظَرٌ عَوْرَةٌ':Added, #1: 1	نَظَرُ عَوْرَةٍ
u'نَظَرٌ عَوْرَةٌ':Added, #1: 1	نَظَرِ عَوْرَةِ
u'نَظَرٌ عين':Added, #3: 3	نَظَرُ عَوْرَتِهِ
u'نَظَرٌ عين':Added, #1: 1	نَظَرُ الْعَيْنِ
u'نَظَرٌ عَيْنٌ':Added, #1: 1	نَظَرِ الْعَيْنِ
u'نَظَرٌ عَيْنٌ':Added, #1: 1	نَظَرُ الْعَيْنِ
u'نَظَرٌ عَيْن':Added, #1: 1	نَظَرِ الْعَيْنِ
u'نَظَرٌ عَيْن':Added, #1: 1	نَظَرُ الْعَيْنِ
u'نَظَرٌ عَيْنٌ':Added, #1: 1	نَظَرِ الْعَيْنِ
u'نَظَرٌ عَيْنٌ':Added, #1: 1	نَظَرَ الْعَيْنَيْنِ
u'نَظَرٌ عَيْن':Added, #1: 1	نَظَرُ الْعَيْنَيْنِ
u'نَظَرٌ عَيْن':Added, #1: 1	نَظَرَ الْعَيْنَيْنِ
u'نَظَرٌ عين':Added, #1: 1	نَظَرُ الْعَيْنَيْنِ
u'نَظَرٌ عَيْنٌ':Added, #1: 1	نَظَرِ عَيْنِهِ
u'نَظَرٌ عَيْن':Added, #1: 1	نَظَرِ عَيْنِهِ
u'نَظَرٌ غَضْبَان':Added, #1: 1	نَظَرِ عَيْنِهِ
u'نَظَرَ غير':Predicate, #1: 1	نَظَرُ الْغَضْبَانِ
u'نَظَرَ غَيْرٌ':Predicate, #1: 1	نَظَرَ غَيْرَ
u'نَظَرٌ غير':Added, #1: 1	نَظَرَ غَيْرَ
u'نَظَرٌ غَيْرٌ':Added, #1: 1	نَظَرَ الْغَيْرِ
u'نَظَرٌ غير':Added, #1: 1	نَظَرَ الْغَيْرِ
u'نَظَرٌ غَيْرٌ':Added, #2: 2	نَظَرِ غَيْرِ
u'نَظَرٌ غير':Added, #2: 2	نَظَرِ غَيْرِ
u'نَظَرٌ غَيْرٌ':Added, #2: 2	نَظَرِ غَيْرِهِ
u'نَظَرٌ غير':Added, #2: 2	نَظَرِ غَيْرِهِ
u'نَظَرٌ غَيْرٌ':Added, #3: 3	نَظَرُ غَيْرِ
u'نَظَرٌ فَجْأَةٌ':Added, #3: 3	نَظَرُ غَيْرِ
u'نَظَرَ فَرْجٌ':Predicate, #4: 4	نَظَرِ الْفَجْأَةِ
u'نَظَرَ فَرْجٌ':Predicate, #1: 1	نَظَرَ فَرْجَ
u'نَظَرٌ فَرْجٌ':Added, #2: 2	نَظَرَ الْفَرْجَ
u'نَظَرٌ فَرْجٌ':Added, #1: 1	نَظَرَ الْفَرْجِ
u'نَظَرٌ فَرْجٌ':Added, #1: 1	نَظَرُ فَرْجٍ
u'نَظَرٌ فَرْجٌ':Added, #1: 1	نَظَرُ فَرْجِ
u'نَظَرٌ فَرْجٌ':Added, #2: 2	نَظَرِ الْفَرْجِ
u'نَظَرٌ فقراء':Added, #4: 4	نَظَرُ الْفَرْجِ
u'نَظَرٌ فَقِيهٌ':Added, #1: 1	نَظَرِ الْفُقَرَاءِ
u'نَظَرٌ فَقِيهٌ':Added, #2: 2	نَظَرِ الْفَقِيهِ
u'نَظَرَ فلان':Subject, #4: 4	نَظَرُ الْفَقِيهِ
u'نَظَرَ فُلاَنٌ':Subject, #1: 1	نَظَرَ الْمُنْذِرِيُّ
u'نَظَرٌ فلان':Added, #1: 1	نَظَرَ فُلَانٌ
u'نَظَرٌ قَابِلٌ':Added, #1: 1	نَظَرِ الشَّافِعِيِّ
u'نَظَرٌ قَاسِمٌ':Added, #1: 1	نَظَرُ الْقَابِلَةِ
u'نَظَرٌ قَاسِمٌ':Added, #1: 1	نَظَرُ الْقَاسِمِ
u'نَظَرٌ قَائِلٌ':Added, #1: 1	نَظَرِ الْقَاسِمِ
u'نَظَرَ قِبَلٌ':Predicate, #1: 1	نَظَرِ قَائِلِهِ
u'نَظَرٌ قَضَاءٌ':Added, #2: 2	نَظَرَ قِبَلَ
u'نَظَرٌ قَضَاءٌ':Added, #1: 1	نَظَرُ الْقَضَاءِ
u'نَظَرٌ قَوَابِلُ':Added, #1: 1	نَظَرِ الْقَضَاءِ
u'نَظَرٌ كَافِرٌ':Added, #1: 1	نَظَرُ الْقَوَابِلِ
u'نَظَرٌ كَافِرٌ':Added, #1: 1	نَظَرِ الْكَافِرِ
u'نَظَرٌ كَافِرٌ':Added, #1: 1	نَظَرِ الْكَافِرَةِ
u'نَظَرٌ كِتَابٌ':Added, #2: 2	نَظَرُ الْكَافِرَةِ
u'نَظَرٌ كِتَابَةٌ':Added, #1: 1	نَظَرُ الْكِتَابِ
u'نَظَرَ كُتُبٌ':Predicate, #1: 1	نَظَرِ الْكِتَابَةِ
u'نَظَرٌ كعبة':Added, #1: 1	نَظَرَ كُتُبَ
u'نَظَرٌ كَعْبَةٌ':Added, #1: 1	نَظَرِ الْكَعْبَةِ
u'نَظَرٌ لَذَّةٌ':Added, #1: 1	نَظَرِ الْكَعْبَةِ
u'نَظَرَ مَالِكٌ':Subject, #1: 1	نَظَرُ لَذَّةٍ
u'نَظَرٌ مَالِكٌ':Added, #1: 1	نَظَرَ مَالِكٌ
u'نَظَرٌ مَالِكٌ':Added, #1: 1	نَظَرُ مَالِكٍ
u'نَظَرٌ مُبْغِضٌ':Added, #1: 1	نَظَرِ مَالِكٍ
u'نَظَرٌ مُتَقَدِّمٌ':Added, #1: 1	نَظَرَ الْمُبْغِضِ
u'نَظَرٌ مُثَقَّفٌ':Added, #1: 1	نَظَرٍ مُتَقَدِّمٍ
u'نَظَرٌ مُثَقِّفٌ':Added, #1: 1	نَظَرَ الْمُثَقّفِ
u'نَظَرٌ مُجْتَهِد':Added, #1: 1	نَظَرَ الْمُثَقّفِ
u'نَظَرٌ مُجْتَهِد':Added, #17: 17	نَظَرِ الْمُجْتَهِدِ
u'نَظَرٌ مُجْتَهِد':Added, #1: 1	نَظَرُ مُجْتَهِدٍ
u'نَظَرٌ مَجْنُونٌ':Added, #3: 3	نَظَرُ الْمُجْتَهِدِ
u'نَظَرٌ مَحْرَمٌ':Added, #1: 1	نَظَرَ الْمَجْنُونِ
u'نَظَرٌ مَحْرَمٌ':Added, #1: 1	نَظَرُ الْمَحْرَمِ
u'نَظَرٌ مُحْرِمٌ':Added, #1: 1	نَظَرِ الْمَحْرَمِ
u'نَظَرٌ مُحَرَّمٌ':Added, #1: 1	نَظَرَ الْمُحْرِمِ
u'نَظَرَ مُحَمَّدٌ':Subject, #1: 1	نَظَرٍ مُحَرَّمٍ
u'نَظَرٌ مُحَمَّدٌ':Added, #1: 1	نَظَرَ مُحَمَّدٌ
u'نَظَرٌ مَخْدُومٌ':Added, #1: 1	نَظَرُ مُحَمَّدٍ
u'نَظَرَ مرٌّ':Predicate, #1: 1	نَظَرِ الْمَخْدُومِ
u'نَظَرٌ مرٌّ':Added, #1: 1	نَظَرَ مَرَّةً
u'نَظَرَ مُسْتَحِقٌّ':Predicate, #1: 1	نَظَرَ مَرَّتَيْنِ
u'نَظَرَ مُسْتَعْمَلٌ':Subject, #1: 1	نَظَرَ الْمُسْتَحِقِّينَ
u'نَظَرٌ مَسْجِدٌ':Added, #1: 1	نَظَرَ الْمُسْتَعْمَلُ
u'نَظَرٌ مُسْلِمٌ':Added, #1: 1	نَظَرُ الْمَسْجِدِ
u'نَظَرَ مُصَنِّفٌ':Subject, #1: 1	نَظَرُ الْمُسْلِمَةِ
u'نَظَرٌ مُصِيبٌ':Added, #2: 2	نَظَرَ الْمُصَنِّفُ
u'نَظَرٌ مُعْتَرِضٌ':Added, #1: 1	نَظَرٍ مُصِيبٍ
u'نَظَرٌ مُعْتَرِضٌ':Added, #1: 1	نَظَرُ الْمُعْتَرِضِ
u'نَظَرٌ مُقَلَّدٌ':Added, #3: 3	نَظَرِ الْمُعْتَرِضِ
u'نَظَرٌ مَلاَبِسُ':Added, #1: 1	نَظَرِ الْمُقَلَّدِ
u'نَظَرٌ مَمْلُوكٌ':Added, #1: 1	نَظَرُ مَلَابِسِ
u'نَظَرٌ مُنْتَصِبٌ':Added, #1: 1	نَظَرِ الْمَمْلُوكَةِ
u'نَظَرٌ مَنْسُوبٌ':Added, #1: 1	نَظَرُ الْمُنْتَصِبِ
u'نَظَرٌ مَنْكُوح':Added, #2: 2	نَظَرُ الْمَنْسُوبِ
u'نَظَرٌ مَوْضِعٌ':Added, #2: 2	نَظَرُ الْمَنْكُوحَةِ
u'نَظَرٌ مُوَكِّلٌ':Added, #2: 2	نَظَرُ مَوْضِعِ
u'نَظَرَ نَاسٌ':Subject, #2: 2	نَظَرِ الْمُوَكِّلِ
u'نَظَرٌ نَاسٌ':Added, #5: 5	نَظَرَ النَّاسُ
u'نَظَرَ نَاظِرٌ':Subject, #4: 4	نَظَرِ النَّاسِ
u'نَظَرٌ نَاظِرٌ':Added, #2: 2	نَظَرَ النَّاظِرُ
u'نَظَرٌ نَاظِرٌ':Added, #1: 1	نَظَرُ النَّاظِرِ
u'نَظَرَ نَبِيٌّ':Subject, #2: 2	نَظَرِ النَّاظِرِ
u'نَظَرَ نِساءٌ':Subject, #1: 1	نَظَرَ النَّبِيُّ
u'نَظَرٌ نِساءٌ':Added, #2: 2	نَظَرَ النِّسَاءُ
u'نَظَرٌ نِساءٌ':Added, #1: 1	نَظَرَ النِّسَاءِ
u'نَظَرٌ نِسْوَةٌ':Added, #4: 4	نَظَرِ النِّسَاءِ
u'نَظَرٌ نَفْسٌ':Added, #1: 1	نَظَرُ النِّسْوَةِ
u'نَظَرٌ نَقِيبٌ':Added, #1: 1	نَظَرِ نَفْسِهِ
u'نَظَرٌ نَوَوِيٌّ':Added, #1: 1	نَظَرِ النَّقِيبِ
u'نَظَرٌ واحد':Added, #1: 1	نَظَرِ النَّوَوِيِّ
u'نَظَرٌ وَاحِدٌ':Added, #1: 1	نَظَرَ الْوَاحِدِ
u'نَظَرٌ واحد':Added, #1: 1	نَظَرَ الْوَاحِدِ
u'نَظَرٌ وَاحِدٌ':Added, #1: 1	نَظَرِ الْوَاحِدَةِ
u'نَظَرٌ واحد':Added, #1: 1	نَظَرِ الْوَاحِدَةِ
u'نَظَرٌ وَاحِدٌ':Added, #1: 1	نَظَرِ وَاحِدٍ
u'نَظَرٌ وَاقِفٌ':Added, #1: 1	نَظَرِ وَاحِدٍ
u'نَظَرٌ وَجْهٌ':Added, #1: 1	نَظَرُ الْوَاقِفِ
u'نَظَرٌ وَجْهٌ':Added, #1: 1	نَظَرَ وَجْهِ
u'نَظَرٌ وَجْهٌ':Added, #2: 2	نَظَرُ الْوَجْهِ
u'نَظَرٌ وَجْهٌ':Added, #3: 3	نَظَرِ وَجْهٍ
u'نَظَرَ وُجُوبٌ':Predicate, #5: 5	نَظَرُ وَجْهِ
u'نَظَرٌ وَزِيرٌ':Added, #1: 1	نَظَرَ وُجُوبَ
u'نَظَرٌ وَصِيٌّ':Added, #1: 1	نَظَرَ الْوَزِيرِ
u'نَظَرَ وَقْفٌ':Predicate, #1: 1	نَظَرِ الْوَصِيِّ
u'نَظَرٌ وَقْفٌ':Added, #2: 2	نَظَرَ الْوَقْفَ
u'نَظَرٌ وَقْفٌ':Added, #1: 1	نَظَرَ الْوَقْفِ
u'نَظَرٌ وَقْفٌ':Added, #1: 1	نَظَرُ الْوَقْفِ
u'نَظَرٌ وَقْفٌ':Added, #1: 1	نَظَرَ وَقْفِهِ
u'نَظَرٌ وَقْفٌ':Added, #2: 2	نَظَرَ وَقْفٍ
u'نَظَرَ وَكِيلٌ':Subject, #2: 2	نَظَرُ وَقْفٍ
u'نَظَرٌ وَلِيٌّ':Added, #2: 2	نَظَرَ الْوَكِيلُ
u'نَظَرٌ وَلِيٌّ':Added, #1: 1	نَظَرِ وَلِيِّ
u'نَظَرٌ وَلِيٌّ':Added, #1: 1	نَظَرِ وَلِيِّهِ
u'نَظَرٌ يَدٌ':Added, #2: 2	نَظَرِ الْوَلِيِّ
u'نَظْمٌ اِبْنٌ':Added, #1: 1	نَظَرِ الْيَدَيْنِ
u'نَظْمٌ آيَةٌ':Added, #5: 5	نَظْمِ ابْنِ
u'نَظْمٌ آيَةٌ':Added, #2: 2	نَظْمَ الْآيَةِ
u'نَظْمٌ تَكَلُّمٌ':Added, #3: 3	نَظْمُ الْآيَةِ
u'نَظَّمَ جزع':Subject, #2: 2	نَظْمِ التَّكَلُّمِ
u'نَظَمَ جَوَابٌ':Predicate, #1: 1	نَظَّمَ الْجَزْعُ
u'نَظْمٌ دَرٌّ':Added, #1: 1	نَظَمَ الْجَوَابَ
u'نَظْمٌ زَوائِدُ':Added, #1: 1	نَظْمُ الدَّرِّ
u'نَظْمٌ شَعْرٌ':Added, #1: 1	نَظْمِ زَوَائِدِ
u'نَظْمٌ شِعْرٌ':Added, #1: 1	نَظْمِ الشَّعْرِ
u'نَظَمَ شَيْخٌ':Subject, #1: 1	نَظْمِ الشِّعْرِ
u'نَظْمٌ شَيْخٌ':Added, #1: 1	نَظَمَ الشَّيْخُ
u'نَظْمٌ صَاحِبٌ':Added, #1: 1	نَظْمِ شَيْخِ
u'نَظْمٌ صَلاَةٌ':Added, #1: 1	نَظْمِ صَاحِبِ
u'نُظُمٌ صَلاَةٌ':Added, #1: 1	نَظْمُ الصَّلَاةِ
u'نَظْمٌ صَلاَةٌ':Added, #1: 1	نُظُمِ الصَّلَاةِ
u'نَظْمٌ صَلاَةٌ':Added, #1: 1	نَظْمُ صَلَاةِ
u'نَظْمٌ صَلاَةٌ':Added, #2: 2	نَظْمَ الصَّلَاةِ
u'نَظْمٌ صَلاَةٌ':Added, #2: 2	نَظْمِ الصَّلَاةِ
u'نَظْمٌ صَلاَةٌ':Added, #2: 2	نَظْمِ صَلَاتِهِ
u'نَظْمٌ صَلاَةٌ':Added, #3: 3	نَظْمَ صَلَاةِ
u'نَظْمٌ فِقْهٌ':Added, #5: 5	نَظْمِ صَلَاةِ
u'نَظَمَ فَقِيهٌ':Subject, #1: 1	نَظْمِ الْفِقْهِ
u'نَظْمٌ فلان':Added, #1: 1	نَظَمَ الْفَقِيهُ
u'نَظْمٌ فلان':Added, #1: 1	نَظْمُ الصَّلَاتَيْنِ
u'نَظَمَ فَوَارِسُ':Predicate, #1: 1	نَظْمِ الصَّلَاتَيْنِ
u'نَظْمٌ قِرَاءةٌ':Added, #1: 1	نَظَمَ الْفَوَارِسَ
u'نَظَمَ قُرْآنٌ':Predicate, #1: 1	نَظْمُ الْقِرَاءَةِ
u'نَظْمٌ قُرْآنٌ':Added, #1: 1	نَظَمَ الْقُرْآنَ
u'نَظْمٌ قُرْآنٌ':Added, #10: 10	نَظْمِ الْقُرْآنِ
u'نَظْمٌ قُرْآنٌ':Added, #1: 1	نَظْمُ الْقُرْآنِ
u'نَظْمٌ قِيَاسٌ':Added, #5: 5	نَظْمَ الْقُرْآنِ
u'نَظْمٌ كِتَابٌ':Added, #2: 2	نَظْمِ الْقِيَاسِ
u'نَظْمٌ كِتَابٌ':Added, #1: 1	نَظْمِ الْكِتَابِ
u'نَظْمٌ كَلاَمٌ':Added, #1: 1	نَظْمِ كِتَابِ
u'نَظْمٌ كَلاَمٌ':Added, #1: 1	نَظْمَ الْكَلَامِ
u'نَظْمٌ كَلاَمٌ':Added, #1: 1	نَظْمِ كَلَامِ
u'نَظْمٌ كَنْزٌ':Added, #3: 3	نَظْمِ الْكَلَامِ
u'نَظْمٌ مَذْهَبٌ':Added, #8: 8	نَظْمِ الْكَنْزِ
u'نَظَمَ مَسْأَلَةٌ':Predicate, #1: 1	نَظْمَ مَذْهَبِهِ
u'نَظَمَ مَسْأَلَةٌ':Predicate, #1: 1	نَظَمَ الْمَسْأَلَةَ
u'نَظْمٌ مَسْأَلَةٌ':Added, #1: 1	نَظَمَ مَسْأَلَةَ
u'نَظْمٌ مُفْرَدٌ':Added, #1: 1	نَظْمِ الْمَسْأَلَةِ
u'نَظْمٌ نِهَايَةٌ':Added, #1: 1	نَظْمِ الْمُفْرَدَاتِ
u'نَظْمٌ نِهَايَةٌ':Added, #2: 2	نَظْمِ النِّهَايَةِ
u'نَظَمَ وَزِيرٌ':Subject, #3: 3	نَظْمِ نِهَايَةِ
u'نِعَالٌ قَوْمٌ':Added, #1: 1	نَظَمَ الْوَزِيرُ
u'نِعَالٌ قَوْمٌ':Added, #2: 2	نِعَالَ الْقَوْمِ
u'نَعْتٌ إِجْمَالٌ':Added, #2: 2	نِعَالِ الْقَوْمِ
u'نَعْتٌ إِخْلاَصٌ':Added, #2: 2	نَعْتَ الْإِجْمَالِ
u'نَعْتٌ الْمَرْأَةُ':Added, #1: 1	نَعْتِ الْإِخْلَاصِ
u'نَعْتٌ حُرِّيَّةٌ':Added, #1: 1	نَعْتُ الْمَرْأَةِ
u'نَعْتٌ حَقٌّ':Added, #2: 2	نَعْتِ الْحُرِّيَّةِ
u'نَعْتٌ خُصُومٌ':Added, #1: 1	نَعْتِ الْحَقِّ
u'نَعَتَ رَسُولٌ':Predicate, #1: 1	نَعْتِ الْخُصُومِ
u'نَعَتَ رَسُولٌ':Subject, #1: 1	نَعَتَ رَسُولَ
u'نَعْتٌ رَسُولٌ':Added, #1: 1	نَعَتَ رَسُولُ
u'نَعْتٌ رَسُولٌ':Added, #1: 1	نَعْتُ رَسُولِ
u'نَعْتٌ صدقة':Added, #2: 2	نَعْتِ رَسُولِ
u'نَعْتٌ صَدَقَةٌ':Added, #1: 1	نَعْتِ الصَّدَقَةِ
u'نَعْتٌ فَرْدٌ':Added, #1: 1	نَعْتِ الصَّدَقَةِ
u'نَعْتٌ نَكِرٌ':Added, #4: 4	نَعْتُ فَرْدٍ
u'نَعْتٌ نَكِرٌ':Added, #1: 1	نَعْتَ النّكِرَةِ
u'نَعْتٌ نكرة':Added, #1: 1	نَعْتِ النّكِرَةِ
u'نَعْتٌ نكرة':Added, #1: 1	نَعْتَ النّكِرَةِ
u'نَعْتٌ نَكِرَةٌ':Added, #1: 1	نَعْتِ النّكِرَةِ
u'نَعْتٌ نَكِرَةٌ':Added, #1: 1	نَعْتَ النّكِرَةِ
u'نَعَتَ وَضْعٌ':Predicate, #1: 1	نَعْتِ النّكِرَةِ
u'نَعَرَ عِرْقٌ':Subject, #1: 1	نَعَتَ وَضْعَ
u'نَعَسَ خَلْفٌ':Predicate, #1: 1	نَعَرَ الْعِرْقُ
u'نَعَسَ رَسُولٌ':Subject, #1: 1	نَعَسَ خَلْفَ
u'نَعَسَ قَوْمٌ':Subject, #1: 1	نَعَسَ رَسُولُ
u'نَعَسَ نَبِيٌّ':Subject, #1: 1	نَعَسَ الْقَوْمُ
u'نَعَسَ يَوْمٌ':Predicate, #1: 1	نَعَسَ النَّبِيُّ
u'نَعْشٌ الْمَرْأَةُ':Added, #1: 1	نَعَسَ يَوْمَ
u'نَعْشٌ الْمَرْأَةُ':Added, #1: 1	نَعْشَ الْمَرْأَةِ
u'نَعْشٌ الْمَرْأَةُ':Added, #2: 2	نَعْشُ الْمَرْأَةِ
u'نَعَلَ خُفٌّ':Predicate, #2: 2	نَعْشِ الْمَرْأَةِ
u'نَعِلَ خُفٌّ':Predicate, #1: 1	أَنْعَلَ الْخُفَّ
u'نَعْلٌ خُفٌّ':Added, #1: 1	أَنْعَلَ الْخُفَّ
u'نَعَلَ دَابَّةٌ':Predicate, #1: 1	نَعْلِ الْخُفِّ
u'نَعِلَ دَابَّةٌ':Predicate, #2: 2	أَنْعَلَ الدَّابَّةَ
u'نَعْلٌ دَابَّةٌ':Added, #2: 2	أَنْعَلَ الدَّابَّةَ
u'نَعْلٌ رَجُلٌ':Added, #1: 1	نَعْلِ الدَّابَّةِ
u'نَعْلٌ رَسُولٌ':Added, #1: 1	نَعْلَ رَجُلٍ
u'نَعْلٌ سَيْفٌ':Added, #1: 1	نَعْلِ رَسُولِ
u'نَعْلٌ غير':Added, #1: 1	نَعْلُ سَيْفِ
u'نَعْلٌ غَيْرٌ':Added, #1: 1	نَعْلِ غَيْرِهِ
u'نَعْلٌ قُرَشِيٌّ':Added, #1: 1	نَعْلِ غَيْرِهِ
u'نَعْلٌ نَبِيٌّ':Added, #1: 1	نَعْلُ قُرَشِيٍّ
u'نَعْلٌ واحد':Added, #1: 1	نَعْلَ النَّبِيِّ
u'نَعْلٌ وَاحِدٌ':Added, #1: 1	نَعْلٍ وَاحِدٍ
u'نعمة إِسْلامٌ':Added, #1: 1	نَعْلٍ وَاحِدٍ
u'نِعْمَةٌ إِسْلامٌ':Added, #1: 1	نِعْمَةِ الْإِسْلَامِ
u'نعمة إِعْتاقٌ':Added, #1: 1	نِعْمَةِ الْإِسْلَامِ
u'نِعْمَةٌ إِعْتاقٌ':Added, #1: 1	نِعْمَةَ الْإِعْتَاقِ
u'نعمة أَعْضَاءٌ':Added, #1: 1	نِعْمَةَ الْإِعْتَاقِ
u'نِعْمَةٌ أَعْضَاءٌ':Added, #2: 2	نِعْمَةِ الْأَعْضَاءِ
u'نعمة اِقْتِضَاءٌ':Added, #2: 2	نِعْمَةِ الْأَعْضَاءِ
u'نِعْمَةٌ اِقْتِضَاءٌ':Added, #1: 1	نِعْمَةِ اقْتِضَاءِ
u'نعمة أكل':Added, #1: 1	نِعْمَةِ اقْتِضَاءِ
u'نعمة أَكْلٌ':Added, #1: 1	نِعْمَةِ الْأَكْلِ
u'نِعْمَةٌ أكل':Added, #1: 1	نِعْمَةِ الْأَكْلِ
u'نِعْمَةٌ أَكْلٌ':Added, #1: 1	نِعْمَةِ الْأَكْلِ
u'نعمة أُلْفَةٌ':Added, #1: 1	نِعْمَةِ الْأَكْلِ
u'نِعْمَةٌ أُلْفَةٌ':Added, #1: 1	نِعْمَةُ الْأُلْفَةِ
u'نعمة اللهُ':Added, #1: 1	نِعْمَةُ الْأُلْفَةِ
u'نِعْمَةٌ اللهُ':Added, #1: 1	نِعْمَةِ اللهِ
u'نعمة أَمْنٌ':Added, #1: 1	نِعْمَةِ اللهِ
u'نِعْمَةٌ أَمْنٌ':Added, #1: 1	نِعْمَةِ الْأَمْنِ
u'نعمة إيمَانٌ':Added, #1: 1	نِعْمَةِ الْأَمْنِ
u'نِعْمَةٌ إيمَانٌ':Added, #2: 2	نِعْمَةُ الْإِيمَانِ
u'نعمة بِدْعَةٌ':Added, #2: 2	نِعْمَةُ الْإِيمَانِ
u'نِعْمَةٌ بِدْعَةٌ':Added, #1: 1	نِعْمَةُ الْبِدْعَةِ
u'نعمة بدن':Added, #1: 1	نِعْمَةُ الْبِدْعَةِ
u'نعمة بَدَنٌ':Added, #3: 3	نِعْمَةِ الْبَدَنِ
u'نِعْمَةٌ بدن':Added, #3: 3	نِعْمَةِ الْبَدَنِ
u'نِعْمَةٌ بَدَنٌ':Added, #3: 3	نِعْمَةِ الْبَدَنِ
u'نعمة بَصَرٌ':Added, #3: 3	نِعْمَةِ الْبَدَنِ
u'نِعْمَةٌ بَصَرٌ':Added, #1: 1	نِعْمَةُ الْبَصَرِ
u'نعمة بَيْتٌ':Added, #1: 1	نِعْمَةُ الْبَصَرِ
u'نِعْمَةٌ بَيْتٌ':Added, #1: 1	نِعْمَةِ الْبَيْتِ
u'نعمة ثَناءٌ':Added, #1: 1	نِعْمَةِ الْبَيْتِ
u'نِعْمَةٌ ثَناءٌ':Added, #1: 1	نِعْمَةُ ثَنَاءِ
u'نعمة جَاهِلٌ':Added, #1: 1	نِعْمَةُ ثَنَاءِ
u'نِعْمَةٌ جَاهِلٌ':Added, #1: 1	نِعْمَةُ الْجَاهِلِ
u'نعمة جَسَدٌ':Added, #1: 1	نِعْمَةُ الْجَاهِلِ
u'نِعْمَةٌ جَسَدٌ':Added, #1: 1	نِعْمَةُ الْجَسَدِ
u'نعمة حُرِّيَّةٌ':Added, #1: 1	نِعْمَةُ الْجَسَدِ
u'نِعْمَةٌ حُرِّيَّةٌ':Added, #2: 2	نِعْمَةِ الْحُرِّيَّةِ
u'نعمة حَقٌّ':Added, #2: 2	نِعْمَةِ الْحُرِّيَّةِ
u'نِعْمَةٌ حَقٌّ':Added, #1: 1	نِعْمَةِ الْحَقِّ
u'نعمة خلق':Added, #1: 1	نِعْمَةِ الْحَقِّ
u'نعمة خَلْقٌ':Added, #1: 1	نِعْمَةِ الْخَلْقِ
u'نِعْمَةٌ خلق':Added, #1: 1	نِعْمَةِ الْخَلْقِ
u'نِعْمَةٌ خَلْقٌ':Added, #1: 1	نِعْمَةِ الْخَلْقِ
u'نعمة رَبُّ':Added, #1: 1	نِعْمَةِ الْخَلْقِ
u'نِعْمَةٌ رَبُّ':Added, #1: 1	نِعْمَةِ رَبِّهِ
u'نعمة رَحْمَن':Added, #1: 1	نِعْمَةِ رَبِّهِ
u'نِعْمَةٌ رَحْمَن':Added, #1: 1	نِعْمَةَ الرَّحْمَنِ
u'نعمة زَوْجٌ':Added, #1: 1	نِعْمَةَ الرَّحْمَنِ
u'نِعْمَةٌ زَوْجٌ':Added, #1: 1	نِعْمَةِ الزَّوْجِ
u'نعمة زَوْجِيٌّ':Added, #1: 1	نِعْمَةِ الزَّوْجِ
u'نِعْمَةٌ زَوْجِيٌّ':Added, #1: 1	نِعْمَةِ الزَّوْجِيَّةِ
u'نعمة سَبَبٌ':Added, #1: 1	نِعْمَةِ الزَّوْجِيَّةِ
u'نِعْمَةٌ سَبَبٌ':Added, #1: 1	نِعْمَةِ سَبَبٍ
u'نعمة سَبَبٌ':Added, #1: 1	نِعْمَةِ سَبَبٍ
u'نِعْمَةٌ سَبَبٌ':Added, #2: 2	نِعْمَةِ السَّبَبِ
u'نعمة سَيِّدٌ':Added, #2: 2	نِعْمَةِ السَّبَبِ
u'نِعْمَةٌ سَيِّدٌ':Added, #1: 1	نِعْمَةُ السَّيِّدِ
u'نعمة صبر':Added, #1: 1	نِعْمَةُ السَّيِّدِ
u'نعمة صَبْرٌ':Added, #1: 1	نِعْمَةِ الصَّبْرِ
u'نِعْمَةٌ صبر':Added, #1: 1	نِعْمَةِ الصَّبْرِ
u'نِعْمَةٌ صَبْرٌ':Added, #1: 1	نِعْمَةِ الصَّبْرِ
u'نعمة عتاق':Added, #1: 1	نِعْمَةِ الصَّبْرِ
u'نِعْمَةٌ عتاق':Added, #1: 1	نِعْمَةَ عَتَاقٍ
u'نعمة عتق':Added, #1: 1	نِعْمَةَ عَتَاقٍ
u'نعمة عِتْقٌ':Added, #1: 1	نِعْمَةُ عِتْقِهِ
u'نِعْمَةٌ عتق':Added, #1: 1	نِعْمَةُ عِتْقِهِ
u'نِعْمَةٌ عِتْقٌ':Added, #1: 1	نِعْمَةُ عِتْقِهِ
u'نعمة عتق':Added, #1: 1	نِعْمَةُ عِتْقِهِ
u'نعمة عِتْقٌ':Added, #2: 2	نِعْمَةُ الْعِتْقِ
u'نِعْمَةٌ عتق':Added, #2: 2	نِعْمَةُ الْعِتْقِ
u'نِعْمَةٌ عِتْقٌ':Added, #2: 2	نِعْمَةُ الْعِتْقِ
u'نعمة عَدُوٌّ':Added, #2: 2	نِعْمَةُ الْعِتْقِ
u'نِعْمَةٌ عَدُوٌّ':Added, #1: 1	نِعْمَةِ الْعَدُوِّ
u'نعمة عَقْلٌ':Added, #1: 1	نِعْمَةِ الْعَدُوِّ
u'نِعْمَةٌ عَقْلٌ':Added, #1: 1	نِعْمَةَ الْعَقْلِ
u'نعمة غير':Added, #1: 1	نِعْمَةَ الْعَقْلِ
u'نعمة غَيْرٌ':Added, #1: 1	نِعْمَةِ غَيْرِهِ
u'نِعْمَةٌ غير':Added, #1: 1	نِعْمَةِ غَيْرِهِ
u'نِعْمَةٌ غَيْرٌ':Added, #1: 1	نِعْمَةِ غَيْرِهِ
u'نعمة غير':Added, #1: 1	نِعْمَةِ غَيْرِهِ
u'نعمة غَيْرٌ':Added, #4: 4	نِعْمَةِ الْغَيْرِ
u'نِعْمَةٌ غير':Added, #4: 4	نِعْمَةِ الْغَيْرِ
u'نِعْمَةٌ غَيْرٌ':Added, #4: 4	نِعْمَةِ الْغَيْرِ
u'نعمة فَاجِرٌ':Added, #4: 4	نِعْمَةِ الْغَيْرِ
u'نِعْمَةٌ فَاجِرٌ':Added, #1: 1	نِعْمَةِ فَاجِرٍ
u'نعمة فلان':Added, #1: 1	نِعْمَةِ فَاجِرٍ
u'نِعْمَةٌ فلان':Added, #1: 1	نِعْمَةَ الرَّحْمَنِ
u'نعمة قُدُومٌ':Added, #1: 1	نِعْمَةَ الرَّحْمَنِ
u'نِعْمَةٌ قُدُومٌ':Added, #2: 2	نِعْمَةِ الْقُدُومِ
u'نعمة مَالٌ':Added, #2: 2	نِعْمَةِ الْقُدُومِ
u'نِعْمَةٌ مَالٌ':Added, #7: 7	نِعْمَةِ الْمَالِ
u'نعمة مُحْسِنٌ':Added, #7: 7	نِعْمَةِ الْمَالِ
u'نِعْمَةٌ مُحْسِنٌ':Added, #1: 1	نِعْمَةِ الْمُحْسِنِ
u'نعمة مُحْسِنٌ':Added, #1: 1	نِعْمَةِ الْمُحْسِنِ
u'نِعْمَةٌ مُحْسِنٌ':Added, #1: 1	نِعْمَةِ مُحْسِنٍ
u'نعمة مَحْسُودٌ':Added, #1: 1	نِعْمَةِ مُحْسِنٍ
u'نِعْمَةٌ مَحْسُودٌ':Added, #1: 1	نِعْمَةُ الْمَحْسُودِ
u'نعمة مُفِيدٌ':Added, #1: 1	نِعْمَةُ الْمَحْسُودِ
u'نِعْمَةٌ مُفِيدٌ':Added, #1: 1	نِعْمَةَ الْمُفِيدِ
u'نعمة مِلْكٌ':Added, #1: 1	نِعْمَةَ الْمُفِيدِ
u'نِعْمَةٌ مِلْكٌ':Added, #1: 1	نِعْمَةَ الْمِلْكِ
u'نعمة مِلْكٌ':Added, #1: 1	نِعْمَةَ الْمِلْكِ
u'نِعْمَةٌ مِلْكٌ':Added, #5: 5	نِعْمَةُ الْمِلْكِ
u'نعمة نَاسٌ':Added, #5: 5	نِعْمَةُ الْمِلْكِ
u'نِعْمَةٌ نَاسٌ':Added, #1: 1	نِعْمَةِ النَّاسِ
u'نعمة نكاح':Added, #1: 1	نِعْمَةِ النَّاسِ
u'نعمة نِكَاحٌ':Added, #18: 18	نِعْمَةِ النِّكَاحِ
u'نِعْمَةٌ نكاح':Added, #18: 18	نِعْمَةِ النِّكَاحِ
u'نِعْمَةٌ نِكَاحٌ':Added, #18: 18	نِعْمَةِ النِّكَاحِ
u'نعمة نكاح':Added, #18: 18	نِعْمَةِ النِّكَاحِ
u'نعمة نكاح':Added, #2: 2	نِعْمَةَ النِّكَاحِ
u'نعمة نِكَاحٌ':Added, #2: 2	نِعْمَةُ النِّكَاحِ
u'نعمة نِكَاحٌ':Added, #2: 2	نِعْمَةَ النِّكَاحِ
u'نِعْمَةٌ نكاح':Added, #2: 2	نِعْمَةُ النِّكَاحِ
u'نِعْمَةٌ نكاح':Added, #2: 2	نِعْمَةَ النِّكَاحِ
u'نِعْمَةٌ نِكَاحٌ':Added, #2: 2	نِعْمَةُ النِّكَاحِ
u'نِعْمَةٌ نِكَاحٌ':Added, #2: 2	نِعْمَةَ النِّكَاحِ
u'نعمة هُدْهُدٌ':Added, #2: 2	نِعْمَةُ النِّكَاحِ
u'نِعْمَةٌ هُدْهُدٌ':Added, #1: 1	نِعْمَةَ الْهُدْهُدِ
u'نعمة وَالِدٌ':Added, #1: 1	نِعْمَةَ الْهُدْهُدِ
u'نِعْمَةٌ وَالِدٌ':Added, #1: 1	نِعْمَةِ وَالِدِهِ
u'نعمة وُجُودٌ':Added, #1: 1	نِعْمَةِ وَالِدِهِ
u'نعمة وُجُودٌ':Added, #1: 1	نِعْمَةُ الْوُجُودِ
u'نِعْمَةٌ وُجُودٌ':Added, #1: 1	نِعْمَةِ الْوُجُودِ
u'نِعْمَةٌ وُجُودٌ':Added, #1: 1	نِعْمَةُ الْوُجُودِ
u'نعمة يَدٌ':Added, #1: 1	نِعْمَةِ الْوُجُودِ
u'نِعْمَةٌ يَدٌ':Added, #1: 1	نِعْمَةِ الْيَدِ
u'نَعَمٌ جِزْيَةٌ':Added, #1: 1	نِعْمَةِ الْيَدِ
u'نَعَمٌ زَكاةٌ':Added, #4: 4	نَعَمِ الْجِزْيَةِ
u'نِعَمٌ زَوْجٌ':Added, #4: 4	نَعَمِ الزَّكَاةِ
u'نَعِمَ زَيْدٌ':Subject, #1: 1	نِعَمَ الزَّوْجِ
u'نَعَمَ شرد':Predicate, #1: 1	نَعِمَ زَيْدٌ
u'نَعَمٌ صدقة':Added, #1: 1	نَعَمَ شَرَدَ
u'نَعَمٌ صَدَقَةٌ':Added, #2: 2	نَعَمَ الصَّدَقَةِ
u'نَعَمٌ صدقة':Added, #2: 2	نَعَمَ الصَّدَقَةِ
u'نَعَمٌ صَدَقَةٌ':Added, #7: 7	نَعَمِ الصَّدَقَةِ
u'نَعَّمَ عين':Predicate, #7: 7	نَعَمِ الصَّدَقَةِ
u'نَعَّمَ عَيْنٌ':Predicate, #1: 1	نَعَّمَ عَيْنَكَ
u'نَعَّمَ عَيْن':Predicate, #1: 1	نَعَّمَ عَيْنَكَ
u'نَعَمٌ غير':Added, #1: 1	نَعَّمَ عَيْنَكَ
u'نَعَمٌ غَيْرٌ':Added, #1: 1	نَعَمُ غَيْرِ
u'نَعَمٌ فَيْءٌ':Added, #1: 1	نَعَمُ غَيْرِ
u'نَعْيٌ أهْلٌ':Added, #1: 1	نَعَمِ الْفَيْءِ
u'نَعْيٌ بَعْضٌ':Added, #2: 2	نَعْيُ أَهْلِ
u'نَعِيبٌ غُرَابٌ':Added, #1: 1	نَعْيُ بَعْضِ
u'نَعَى رَسُولٌ':Subject, #1: 1	نَعِيبَ غُرَابٍ
u'نَعَى سُوءٌ':Predicate, #1: 1	نَعَى رَسُولُ
u'نَعَى فلان':Predicate, #1: 1	نَعَى سُوءَ
u'نَعَى فلان':Subject, #1: 1	نَعَى جَعْفَرَ
u'نَعْيٌ فلان':Added, #1: 1	نَعَى جَعْفَرٌ
u'نَعْيٌ فلان':Added, #3: 3	نَعْيُ جَعْفَرٍ
u'نَعِيمٌ آخِرَةٌ':Added, #3: 3	نَعْيُ جَعْفَرِ
u'نَعِيمٌ أهْلٌ':Added, #1: 1	نَعِيمِ الْآخِرَةِ
u'نَعِيمٌ أهْلٌ':Added, #1: 1	نَعِيمَ أَهْلِ
u'نَعِيمَةٌ رَضيعٌ':Added, #1: 1	نَعِيمِ أَهْلِ
u'نَعِيمٌ جَنَّةٌ':Added, #1: 1	نَعِيمَةَ رَضِيعِ
u'نَعِيمٌ جَنَّةٌ':Added, #1: 1	نَعِيمُ الْجَنّةِ
u'نَعِيمٌ جَنَّةٌ':Added, #1: 1	نَعِيمِ الْجَنَّةِ
u'نَعِيمٌ جَنَّةٌ':Added, #2: 2	نَعِيمَ الْجَنَّةِ
u'نَعِيمٌ عَيْشٌ':Added, #2: 2	نَعِيمُ الْجَنَّةِ
u'نَعِيمٌ قَبْرٌ':Added, #1: 1	نَعِيمِ الْعَيْشِ
u'نَعِيمٌ قَبْرٌ':Added, #1: 1	نَعِيمُ الْقَبْرِ
u'نَعِيمٌ مَأْكَلٌ':Added, #1: 1	نَعِيمِ الْقَبْرِ
u'نَعْيٌ نَوْفَلٌ':Added, #1: 1	نَعِيمُ الْمَأْكَلِ
u'نَغَّصَ مَوْتٌ':Subject, #1: 1	نَعْيُ نَوْفَلِ
u'نَفَادٌ تَصَرُّفٌ':Added, #2: 2	نَغَّصَ الْمَوْتُ
u'نَفَادٌ خَشَبٌ':Added, #1: 1	نَفَادِ التَّصَرُّفِ
u'نَفَادٌ طعام':Added, #1: 1	نَفَادِ الْخَشَبِ
u'نَفَادٌ طَعَامٌ':Added, #1: 1	نَفَادُ الطّعَامِ
u'نَفَادٌ كَلِمَةٌ':Added, #1: 1	نَفَادُ الطّعَامِ
u'نَفَادٌ مَالٌ':Added, #1: 1	نَفَادُ الْكَلِمَاتِ
u'نفاذ أَحْكَامٌ':Added, #1: 1	نَفَادِ مَالِهِ
u'نَفَاذٌ أَحْكَامٌ':Added, #1: 1	نَفَاذِ أَحْكَامِ
u'نفاذ أَقْوَالٌ':Added, #1: 1	نَفَاذِ أَحْكَامِ
u'نَفَاذٌ أَقْوَالٌ':Added, #1: 1	نَفَاذُ الْأَقْوَالِ
u'نفاذ بَعْضٌ':Added, #1: 1	نَفَاذُ الْأَقْوَالِ
u'نَفَاذٌ بَعْضٌ':Added, #1: 1	نَفَاذِ بَعْضِ
u'نفاذ بَيْعٌ':Added, #1: 1	نَفَاذِ بَعْضِ
u'نَفَاذٌ بَيْعٌ':Added, #3: 3	نَفَاذِ الْبَيْعِ
u'نفاذ تَبَرُّعٌ':Added, #3: 3	نَفَاذِ الْبَيْعِ
u'نَفَاذٌ تَبَرُّعٌ':Added, #1: 1	نَفَاذَ تَبَرُّعِهِ
u'نفاذ تَدْبِيرٌ':Added, #1: 1	نَفَاذَ تَبَرُّعِهِ
u'نَفَاذٌ تَدْبِيرٌ':Added, #1: 1	نَفَاذُ التَّدْبِيرِ
u'نفاذ تَصَرُّفٌ':Added, #1: 1	نَفَاذُ التَّدْبِيرِ
u'نَفَاذٌ تَصَرُّفٌ':Added, #1: 1	نَفَاذَ التَّصَرُّفِ
u'نفاذ تَصَرُّفٌ':Added, #1: 1	نَفَاذَ التَّصَرُّفِ
u'نَفَاذٌ تَصَرُّفٌ':Added, #1: 1	نَفَاذِ تَصَرُّفَاتِ
u'نفاذ تَصَرُّفٌ':Added, #1: 1	نَفَاذِ تَصَرُّفَاتِ
u'نَفَاذٌ تَصَرُّفٌ':Added, #2: 2	نَفَاذَ تَصَرُّفَاتِهِ
u'نفاذ تَصَرُّفٌ':Added, #2: 2	نَفَاذَ تَصَرُّفَاتِهِ
u'نَفَاذٌ تَصَرُّفٌ':Added, #3: 3	نَفَاذِ التَّصَرُّفِ
u'نفاذ تَصَرُّفٌ':Added, #3: 3	نَفَاذِ التَّصَرُّفِ
u'نَفَاذٌ تَصَرُّفٌ':Added, #3: 3	نَفَاذِ تَصَرُّفَاتِهِ
u'نفاذ تَصَرُّفٌ':Added, #3: 3	نَفَاذِ تَصَرُّفَاتِهِ
u'نَفَاذٌ تَصَرُّفٌ':Added, #3: 3	نَفَاذِ تَصَرُّفِهِ
u'نفاذ تَقَبُّلٌ':Added, #3: 3	نَفَاذِ تَصَرُّفِهِ
u'نَفَاذٌ تَقَبُّلٌ':Added, #3: 3	نَفَاذِ تَقَبُّلِهِ
u'نفاذ تَوْكِيلٌ':Added, #3: 3	نَفَاذِ تَقَبُّلِهِ
u'نَفَاذٌ تَوْكِيلٌ':Added, #1: 1	نَفَاذَ تَوْكِيلِهِ
u'نفاذ حُكْمٌ':Added, #1: 1	نَفَاذَ تَوْكِيلِهِ
u'نَفَاذٌ حُكْمٌ':Added, #2: 2	نَفَاذِ الْحُكْمِ
u'نفاذ خَشَبٌ':Added, #2: 2	نَفَاذِ الْحُكْمِ
u'نَفَاذٌ خَشَبٌ':Added, #1: 1	نَفَاذِ الْخَشَبِ
u'نفاذ خُطَّةٌ':Added, #1: 1	نَفَاذِ الْخَشَبِ
u'نَفَاذٌ خُطَّةٌ':Added, #1: 1	نَفَاذِ الْخُطَّةِ
u'نفاذ شِرَاءٌ':Added, #1: 1	نَفَاذِ الْخُطَّةِ
u'نَفَاذٌ شِرَاءٌ':Added, #1: 1	نَفَاذِ الشِّرَاءِ
u'نفاذ عتق':Added, #1: 1	نَفَاذِ الشِّرَاءِ
u'نَفَاذٌ عتق':Added, #1: 1	نَفَاذَ الْعِتْقِ
u'نفاذ عِتْقٌ':Added, #1: 1	نَفَاذَ الْعِتْقِ
u'نَفَاذٌ عِتْقٌ':Added, #1: 1	نَفَاذَ الْعِتْقِ
u'نفاذ عتق':Added, #1: 1	نَفَاذَ الْعِتْقِ
u'نَفَاذٌ عتق':Added, #1: 1	نَفَاذُ عِتْقِهِ
u'نفاذ عِتْقٌ':Added, #1: 1	نَفَاذُ عِتْقِهِ
u'نَفَاذٌ عِتْقٌ':Added, #1: 1	نَفَاذُ عِتْقِهِ
u'نفاذ عزل':Added, #1: 1	نَفَاذُ عِتْقِهِ
u'نَفَاذٌ عزل':Added, #1: 1	نَفَاذُ الْعَزْلِ
u'نفاذ عَقْدٌ':Added, #1: 1	نَفَاذُ الْعَزْلِ
u'نَفَاذٌ عَقْدٌ':Added, #1: 1	نَفَاذُ الْعَقْدِ
u'نفاذ عَقْدٌ':Added, #1: 1	نَفَاذُ الْعَقْدِ
u'نَفَاذٌ عَقْدٌ':Added, #3: 3	نَفَاذَ الْعَقْدِ
u'نفاذ قَضَاءٌ':Added, #3: 3	نَفَاذَ الْعَقْدِ
u'نَفَاذٌ قَضَاءٌ':Added, #17: 17	نَفَاذِ الْقَضَاءِ
u'نفاذ قَضَاءٌ':Added, #17: 17	نَفَاذِ الْقَضَاءِ
u'نفاذ قَضَاءٌ':Added, #2: 2	نَفَاذَ الْقَضَاءِ
u'نَفَاذٌ قَضَاءٌ':Added, #2: 2	نَفَاذُ الْقَضَاءِ
u'نَفَاذٌ قَضَاءٌ':Added, #2: 2	نَفَاذَ الْقَضَاءِ
u'نفاذ قَضَاءٌ':Added, #2: 2	نَفَاذُ الْقَضَاءِ
u'نَفَاذٌ قَضَاءٌ':Added, #2: 2	نَفَاذِ قَضَاءِ
u'نفاذ قول':Added, #2: 2	نَفَاذِ قَضَاءِ
u'نفاذ قول':Added, #1: 1	نَفَاذُ الْقَوْلِ
u'نَفَاذٌ قول':Added, #1: 1	نَفَاذِ الْقَوْلِ
u'نَفَاذٌ قول':Added, #1: 1	نَفَاذُ الْقَوْلِ
u'نفاذ قَوْلٌ':Added, #1: 1	نَفَاذِ الْقَوْلِ
u'نفاذ قَوْلٌ':Added, #1: 1	نَفَاذُ الْقَوْلِ
u'نَفَاذٌ قَوْلٌ':Added, #1: 1	نَفَاذِ الْقَوْلِ
u'نَفَاذٌ قَوْلٌ':Added, #1: 1	نَفَاذُ الْقَوْلِ
u'نفاذ قَوْلٌ':Added, #1: 1	نَفَاذِ الْقَوْلِ
u'نَفَاذٌ قَوْلٌ':Added, #1: 1	نَفَاذُ قَوْلٍ
u'نفاذ مِلْكٌ':Added, #1: 1	نَفَاذُ قَوْلٍ
u'نَفَاذٌ مِلْكٌ':Added, #1: 1	نَفَاذِ مِلْكِ
u'نفاذ نكاح':Added, #1: 1	نَفَاذِ مِلْكِ
u'نَفَاذٌ نكاح':Added, #1: 1	نَفَاذَ النِّكَاحِ
u'نفاذ نِكَاحٌ':Added, #1: 1	نَفَاذَ النِّكَاحِ
u'نَفَاذٌ نِكَاحٌ':Added, #1: 1	نَفَاذَ النِّكَاحِ
u'نفاذ نكاح':Added, #1: 1	نَفَاذَ النِّكَاحِ
u'نَفَاذٌ نكاح':Added, #2: 2	نَفَاذِ النِّكَاحِ
u'نفاذ نِكَاحٌ':Added, #2: 2	نَفَاذِ النِّكَاحِ
u'نَفَاذٌ نِكَاحٌ':Added, #2: 2	نَفَاذِ النِّكَاحِ
u'نفاذ وُجُودٌ':Added, #2: 2	نَفَاذِ النِّكَاحِ
u'نَفَاذٌ وُجُودٌ':Added, #1: 1	نَفَاذِ وُجُودِ
u'نفاس مُسْتَقِلٌّ':Added, #1: 1	نَفَاذِ وُجُودِ
u'نِفَاسٌ مُسْتَقِلٌّ':Added, #1: 1	نِفَاسٍ مُسْتَقِلٍّ
u'نِفَاقٌ تَكْذيبٌ':Added, #1: 1	نِفَاسٍ مُسْتَقِلٍّ
u'نِفَاقٌ عَبْدٌ':Added, #1: 1	نِفَاقُ التَّكْذِيبِ
u'نِفَاقٌ عَمَلٌ':Added, #1: 1	نِفَاقِ عَبْدِ
u'نِفَاقٌ عَمَلٌ':Added, #1: 1	نِفَاقِ الْعَمَلِ
u'نِفَاقٌ فَاعِلٌ':Added, #3: 3	نِفَاقُ الْعَمَلِ
u'نِفَاقٌ كذب':Added, #1: 1	نِفَاقَ فَاعِلِ
u'نِفَاقٌ كَذِبٌ':Added, #2: 2	نِفَاقُ الْكَذِبِ
u'نَفْثٌ دَمٌ':Added, #2: 2	نِفَاقُ الْكَذِبِ
u'نَفْثٌ دَمٌ':Added, #2: 2	نَفْثَ الدَّمِ
u'نَفَخَ أَحْسَنُ':Subject, #4: 4	نَفْثِ الدَّمِ
u'نَفْخَةٌ إِحْيَاءٌ':Added, #1: 1	نَفَخَ أَحْسَنُ
u'نَفْخَةٌ بَعْثٌ':Added, #1: 1	نَفْخَةُ الْإِحْيَاءِ
u'نَفْخَةٌ بَعْثٌ':Added, #1: 1	نَفْخَةَ الْبَعْثِ
u'نَفْخَةٌ روحٌ':Added, #1: 1	نَفْخَةُ الْبَعْثِ
u'نَفْخَةٌ روحٌ':Added, #1: 1	نَفْخَةُ رُوحِ
u'نَفْخَةٌ فَزَعٌ':Added, #2: 2	نَفْخَةِ رُوحِ
u'نَفْخَةٌ مَلَكٌ':Added, #1: 1	نَفْخَةُ الْفَزَعِ
u'نَفْخَةٌ واحد':Added, #1: 1	نَفْخَةُ الْمَلَكِ
u'نَفْخَةٌ وَاحِدٌ':Added, #1: 1	نَفْخَةٍ وَاحِدَةٍ
u'نَفَخَ تُرَابٌ':Predicate, #1: 1	نَفْخَةٍ وَاحِدَةٍ
u'نَفَخَ شَيْطَانٌ':Subject, #1: 1	نَفَخَ التُّرَابَ
u'نَفَخَ عُرُوقٌ':Predicate, #3: 3	نَفَخَ الشَّيْطَانُ
u'نَفِدَ تَمْر':Subject, #1: 1	نَفَخَ الْعُرُوقَ
u'نَفِدَ شِرَاءٌ':Subject, #1: 1	نَفِدَ التّمْرُ
u'نَفِدَ ضرس':Subject, #2: 2	نَفِدَ الشِّرَاءُ
u'نَفِدَ ضِرْسٌ':Subject, #1: 1	نَفِدَ الضّرْسُ
u'نَفِدَ طعام':Subject, #1: 1	نَفِدَ الضّرْسُ
u'نَفِدَ طَعَامٌ':Subject, #1: 1	نَفِدَ الطَّعَامُ
u'نَفِدَ عتق':Subject, #1: 1	نَفِدَ الطَّعَامُ
u'نَفِدَ عِتْقٌ':Subject, #1: 1	نَفِدَ الْعِتْقُ
u'نَفِدَ مَاءٌ':Subject, #1: 1	نَفِدَ الْعِتْقُ
u'نَفَدَ مَالٌ':Predicate, #1: 1	نَفِدَ الْمَاءُ
u'نَفِدَ مَالٌ':Subject, #1: 1	نَفَدَ الْمَالَ
u'نَفَدَ مَقَاتِلُ':Predicate, #1: 1	نَفِدَ الْمَالُ
u'نَفِدَ مَقَاتِلُ':Predicate, #1: 1	أَنْفَدَ الْمَقَاتِلَ
u'نَفَذَ إِبْطَالٌ':Subject, #1: 1	أَنْفَدَ الْمَقَاتِلَ
u'نَفَّذَ أَحْكَامٌ':Predicate, #2: 2	نَفَذَ إبْطَالُهُ
u'نَفَذَ إِذْنٌ':Subject, #1: 1	نَفَّذَ الْأَحْكَامَ
u'نَفَذَ اِسْتِيلاد':Subject, #1: 1	نَفَذَ إذْنُهُ
u'نَفَذَ إِعْتاقٌ':Subject, #1: 1	نَفَذَ اسْتِيلَادُهُ
u'نَفَذَ إِعْتاقٌ':Subject, #10: 10	نَفَذَ إعْتَاقُهُ
u'نَفَذَ إقْرَارٌ':Subject, #4: 4	نَفَذَ الْإِعْتَاقُ
u'نَفَذَ إقْرَارٌ':Subject, #2: 2	نَفَذَ الْإِقْرَارُ
u'نَفَذَ أَمْرٌ':Subject, #7: 7	نَفَذَ إقْرَارُهُ
u'نَفَذَ أَمْرٌ':Subject, #1: 1	نَفَذَ الْأَمْرُ
u'نَفَذَ أَوَّلُ':Subject, #1: 1	نَفَذَ أَمْرُهُ
u'نَفَّذَ أَوَّلُ':Subject, #1: 1	نَفَذَ الْأَوَّلُ
u'نَفَذَ بتل':Subject, #2: 2	نَفَّذَ الْأَوَّلُ
u'نَفَذَ بَيْعٌ':Subject, #1: 1	نَفَذَ الْبَتْلُ
u'نَفَذَ بَيْعٌ':Subject, #1: 1	نَفَذَ بَيْعٌ
u'نَفَذَ بَيْعٌ':Subject, #1: 1	نَفَذَ بَيْعُ
u'نَفَذَ بَيْعٌ':Subject, #29: 29	نَفَذَ بَيْعُهُ
u'نَفَذَ بيوع':Subject, #37: 37	نَفَذَ الْبَيْعُ
u'نَفَذَ تَاسِعٌ':Subject, #1: 1	نَفَذَ الْبُيُوعُ
u'نَفَذَ تَبَرُّعٌ':Subject, #1: 1	نَفَذَ التَّاسِعَةُ
u'نَفَذَ تَبَرُّعٌ':Subject, #1: 1	نَفَذَ التَّبَرُّعُ
u'نَفَذَ تَدْبِيرٌ':Subject, #1: 1	نَفَذَ تَبَرُّعُهُ
u'نَفَذَ تَصَرُّفٌ':Subject, #1: 1	نَفَذَ تَدْبِيرُهُ
u'نَفَذَ تَصَرُّفٌ':Subject, #18: 18	نَفَذَ تَصَرُّفُهُ
u'نَفَذَ تَصَرُّفٌ':Subject, #2: 2	نَفَذَ التَّصَرُّفُ
u'نَفَذَ تَطْلِيقٌ':Subject, #4: 4	نَفَذَ تَصَرُّفُ
u'نَفَذَ تَفْرِيقٌ':Subject, #2: 2	نَفَذَ تَطْلِيقُهُ
u'نَفَذَ حَجٌّ':Subject, #1: 1	نَفَذَ التَّفْرِيقُ
u'نَفَذَ حَجْرٌ':Subject, #1: 1	نَفَذَ حَجُّ
u'نَفَّذَ حُكْمٌ':Predicate, #1: 1	نَفَذَ حَجْرُ
u'نَفَذَ حُكْمٌ':Subject, #1: 1	نَفَّذَ حُكْمَ
u'نَفَذَ حُكْمٌ':Subject, #1: 1	نَفَذَ حُكْمُ
u'نَفَذَ حُكْمٌ':Subject, #34: 34	نَفَذَ حُكْمُهُ
u'نَفَذَ خُلْعٌ':Subject, #6: 6	نَفَذَ الْحُكْمُ
u'نَفَذَ رباط':Subject, #3: 3	نَفَذَ الْخُلْعُ
u'نَفَذَ رِبَاطٌ':Subject, #1: 1	نَفَذَ الرِّبَاطُ
u'نَفَذَ سَابِقٌ':Subject, #1: 1	نَفَذَ الرِّبَاطُ
u'نَفَذَ سَهْمٌ':Subject, #1: 1	نَفَذَ السَّابِقُ
u'نَفَذَ شِرَاءٌ':Subject, #1: 1	نَفَذَ السَّهْمُ
u'نَفَذَ صلح':Subject, #10: 10	نَفَذَ الشِّرَاءُ
u'نَفَذَ صُلْحٌ':Subject, #4: 4	نَفَذَ الصُّلْحُ
u'نَفَذَ طَلاَقٌ':Subject, #4: 4	نَفَذَ الصُّلْحُ
u'نَفَذَ عتق':Subject, #2: 2	نَفَذَ الطَّلَاقُ
u'نَفَذَ عِتْقٌ':Subject, #13: 13	نَفَذَ الْعِتْقُ
u'نَفَذَ عتق':Subject, #13: 13	نَفَذَ الْعِتْقُ
u'نَفَذَ عِتْقٌ':Subject, #2: 2	نَفَذَ عِتْقُ
u'نَفَذَ عتق':Subject, #2: 2	نَفَذَ عِتْقُ
u'نَفَذَ عِتْقٌ':Subject, #43: 43	نَفَذَ عِتْقُهُ
u'نَفَذَ عَقْدٌ':Predicate, #43: 43	نَفَذَ عِتْقُهُ
u'نَفَذَ عَقْدٌ':Subject, #1: 1	نَفَذَ الْعَقْدَ
u'نَفَذَ عَقْدٌ':Subject, #3: 3	نَفَذَ عَقْدُهُ
u'نَفَذَ عند':Predicate, #4: 4	نَفَذَ الْعَقْدُ
u'نَفَذَ غير':Predicate, #9: 9	نَفَذَ عِنْدَ
u'نَفَذَ غَيْرٌ':Predicate, #1: 1	نَفَذَ غَيْرَ
u'نَفَذَ فَسْخٌ':Subject, #1: 1	نَفَذَ غَيْرَ
u'نَفَذَ فِعْلٌ':Subject, #2: 2	نَفَذَ الْفَسْخُ
u'نَفَذَ قَضَاءٌ':Subject, #1: 1	نَفَذَ فِعْلُ
u'نَفَذَ قَضَاءٌ':Subject, #1: 1	نَفَذَ قَضَاءٌ
u'نَفَذَ قَضَاءٌ':Subject, #3: 3	نَفَذَ الْقَضَاءُ
u'نَفَذَ قول':Subject, #3: 3	نَفَذَ قَضَاءُ
u'نَفَذَ قَوْلٌ':Subject, #1: 1	نَفَذَ قَوْلُهُ
u'نَفَّذَ كِتَابٌ':Predicate, #1: 1	نَفَذَ قَوْلُهُ
u'نَفَذَ كَرْمٌ':Subject, #1: 1	نَفَّذَ كِتَابَ
u'نَفَذَ مَاءٌ':Subject, #1: 1	نَفَذَ الْكَرْمُ
u'نَفَذَ مَالٌ':Subject, #1: 1	نَفَذَ الْمَاءُ
u'نَفَذَ مِلْكٌ':Subject, #1: 1	نَفَذَ الْمَالُ
u'نَفَذَ مَنِيٌّ':Subject, #1: 1	نَفَذَ مِلْكُهُ
u'نَفَذَ نَفَذٌ':Predicate, #2: 2	نَفَذَ الْمَنِيُّ
u'نَفَذَ نكاح':Subject, #1: 1	نَفَذَ نَفَذَ
u'نَفَذَ نِكَاحٌ':Subject, #2: 2	نَفَذَ النِّكَاحُ
u'نَفَذَ نكاح':Subject, #2: 2	نَفَذَ النِّكَاحُ
u'نَفَذَ نِكَاحٌ':Subject, #3: 3	نَفَذَ نِكَاحُ
u'نَفَذَ نكاح':Subject, #3: 3	نَفَذَ نِكَاحُ
u'نَفَذَ نِكَاحٌ':Subject, #3: 3	نَفَذَ نِكَاحُهُ
u'نَفَذَ واحد':Subject, #3: 3	نَفَذَ نِكَاحُهُ
u'نَفَذَ وَاحِدٌ':Subject, #1: 1	نَفَذَ وَاحِدٌ
u'نَفَرَ بَعْضٌ':Subject, #1: 1	نَفَذَ وَاحِدٌ
u'نَفَرَ بَعيرٌ':Subject, #1: 1	نَفَرَ بَعْضُ
u'نفرة طَبْعٌ':Added, #1: 1	نَفَرَ الْبَعِيرُ
u'نَفْرَةٌ طَبْعٌ':Added, #3: 3	نَفْرَةِ الطَّبْعِ
u'نَفَرَ سَلَفٌ':Subject, #3: 3	نَفْرَةِ الطَّبْعِ
u'نَفَّرَ صَيْدٌ':Predicate, #1: 1	نَفَرَ السَّلَفُ
u'نَفَرَ فَرَسٌ':Subject, #1: 1	نَفَّرَ صَيْدَ
u'نَفَرَ فَرَسٌ':Subject, #1: 1	نَفَرَ الْفَرَسُ
u'نَفَرَ مَالِكٌ':Subject, #1: 1	نَفَرَ فَرَسُ
u'نَفَرَ مُتَعَجِّل':Subject, #1: 1	نَفَرَ مَالِكٌ
u'نَفَّرَ مُحْرِمٌ':Subject, #1: 1	نَفَرَ الْمُتَعَجِّلُ
u'نَفَّرَ نَاسٌ':Predicate, #1: 1	نَفَّرَ مُحْرِمٌ
u'نَفَرَ نَاسٌ':Subject, #1: 1	نَفَّرَ النَّاسَ
u'نَفَرَ نفر':Predicate, #6: 6	نَفَرَ النَّاسُ
u'نَفَرَ نَفْرٌ':Predicate, #3: 3	نَفَرَ النَّفْرَ
u'نَفَرَ نفر':Subject, #3: 3	نَفَرَ النَّفْرَ
u'نَفَرَ نَفْرٌ':Subject, #1: 1	نَفَرَ النَّفْرُ
u'نَفَرَ واحد':Subject, #1: 1	نَفَرَ النَّفْرُ
u'نَفَرَ وَاحِدٌ':Subject, #1: 1	نَفَرَ وَاحِدٌ
u'نَفْسٌ أَبٌ':Added, #1: 1	نَفَرَ وَاحِدٌ
u'نَفْسٌ إبَاحَةٌ':Added, #1: 1	نَفْسِ الْأَبِ
u'نَفْسٌ اِبْنٌ':Added, #1: 1	نَفْسِ الْإِبَاحَةِ
u'نَفْسٌ إِتْلاَفٌ':Added, #1: 1	نَفْسِ ابْنِ
u'نَفْسٌ إِثْبَاتٌ':Added, #1: 1	نَفْسِ الْإِتْلَافِ
u'نَفْسٌ إِثْمٌ':Added, #1: 1	نَفْسَ الْإِثْبَاتِ
u'نَفْسٌ إجَازَةٌ':Added, #1: 1	نَفْسُ الْإِثْمِ
u'نَفْسٌ أَجْزَاءٌ':Added, #1: 1	نَفْسِ الْإِجَازَةِ
u'نَفْسٌ أَجَلٌ':Added, #1: 1	نَفْسِ الْأَجْزَاءِ
u'نَفْسٌ آحَادٌ':Added, #1: 1	نَفْسَ الْأَجَلِ
u'نَفْسٌ إِحْرَامٌ':Added, #1: 1	نَفْسُ الْآحَادِ
u'نَفْسٌ إِحْرَامٌ':Added, #1: 1	نَفْسُ الْإِحْرَامِ
u'نَفْسٌ إِحْرَامٌ':Added, #1: 1	نَفْسِ الْإِحْرَامِ
u'نَفْسٌ إحْسَانٌ':Added, #2: 2	نَفْسَ الْإِحْرَامِ
u'نَفْسٌ إحْسَانٌ':Added, #1: 1	نَفْسُ الْإِحْسَانِ
u'نَفْسٌ أَحْكَامٌ':Added, #1: 1	نَفْسِ الْإِحْسَانِ
u'نَفْسٌ أَحْكَامٌ':Added, #1: 1	نَفْسُ الْأَحْكَامِ
u'نَفْسٌ إِحْيَاءٌ':Added, #1: 1	نَفْسِ الْأَحْكَامِ
u'نَفْسٌ اِخْتِلاطٌ':Added, #1: 1	نَفْسِ الْإِحْيَاءِ
u'نَفْسٌ اِخْتِيَارٌ':Added, #1: 1	نَفْسَ اخْتِلَاطِ
u'نَفْسٌ أخْذٌ':Added, #1: 1	نَفْسُ اخْتِيَارِهِ
u'نَفْسٌ أخْذٌ':Added, #1: 1	نَفْسُ الْأَخْذِ
u'نَفْسٌ أَدَاءٌ':Added, #2: 2	نَفْسَ الْأَخْذِ
u'نَفْسٌ آدَمِيٌّ':Added, #1: 1	نَفْسُ الْأَدَاءِ
u'نَفْسٌ آدَمِيٌّ':Added, #2: 2	نَفْسِ آدَمِيٍّ
u'نَفْسٌ أَذَانٌ':Added, #2: 2	نَفْسِ الْآدَمِيِّ
u'نَفْسٌ أرْضٌ':Added, #4: 4	نَفْسِ الْأَذَانِ
u'نَفْسٌ أرْضٌ':Added, #1: 1	نَفْسَ الْأَرْضِ
u'نَفْسٌ إِزَالَةٌ':Added, #2: 2	نَفْسِ الْأَرْضِ
u'نَفْسٌ أَزْمِنَةٌ':Added, #1: 1	نَفْسَ إزَالَةِ
u'نَفْسٌ أُسْبُوعٌ':Added, #1: 1	نَفْسُ الْأَزْمِنَةِ
u'نَفْسٌ إِسْلامٌ':Added, #1: 1	نَفْسَ الْأُسْبُوعِ
u'نَفْسٌ إِسْلامٌ':Added, #1: 1	نَفْسُ إسْلَامِ
u'نَفْسٌ إِسْلامٌ':Added, #1: 1	نَفْسَ الْإِسْلَامِ
u'نَفْسٌ إِشْغالٌ':Added, #1: 1	نَفْسِ الْإِسْلَامِ
u'نَفْسٌ أَصابِعُ':Added, #1: 1	نَفْسَ إشْغَالِ
u'نَفْسٌ إِصْرارٌ':Added, #1: 1	نَفْسِ أَصَابِعِهِ
u'نَفْسٌ أصل':Added, #1: 1	نَفْسَ الْإِصْرَارِ
u'نَفْسٌ أصل':Added, #1: 1	نَفْسُ الْأَصْلِ
u'نَفْسٌ أًصْلٌ':Added, #1: 1	نَفْسِ الْأَصْلِ
u'نَفْسٌ أًصْلٌ':Added, #1: 1	نَفْسُ الْأَصْلِ
u'نَفْسٌ أَصيلٌ':Added, #1: 1	نَفْسِ الْأَصْلِ
u'نَفْسٌ إِعارَةٌ':Added, #1: 1	نَفْسَ الْأَصِيلِ
u'نَفْسٌ إِعْتاقٌ':Added, #1: 1	نَفْسُ الْإِعَارَةِ
u'نَفْسٌ إعْطَاءٌ':Added, #1: 1	نَفْسُ الْإِعْتَاقِ
u'نَفْسٌ إقْرَارٌ':Added, #1: 1	نَفْسُ الْإِعْطَاءِ
u'نَفْسٌ إقْرَارٌ':Added, #1: 1	نَفْسَ الْإِقْرَارِ
u'نَفْسٌ أقْرَع':Added, #1: 1	نَفْسِ الْإِقْرَارِ
u'نَفْسٌ أكل':Added, #1: 1	نَفْسُ الْأَقْرَعِ
u'نَفْسٌ أَكْلٌ':Added, #1: 1	نَفْسِ الْأَكْلِ
u'نَفْسٌ آلةٌ':Added, #1: 1	نَفْسِ الْأَكْلِ
u'نَفْسٌ آلةٌ':Added, #1: 1	نَفْسُ الْآلَةِ
u'نَفْسٌ أَلْفَاظٌ':Added, #1: 1	نَفْسِ الْآلَةِ
u'نَفْسٌ أَلْفَاظٌ':Added, #1: 1	نَفْسَ الْأَلْفَاظِ
u'نَفْسٌ الْمَرْأَةُ':Added, #1: 1	نَفْسِ الْأَلْفَاظِ
u'نَفْسٌ الْمَرْأَةُ':Added, #1: 1	نَفْسُ الْمَرْأَةِ
u'نَفْسٌ إمَامٌ':Added, #2: 2	نَفْسِ الْمَرْأَةِ
u'نَفْسٌ إمَامٌ':Added, #1: 1	نَفْسَ الْإِمَامِ
u'نَفْسٌ إمَامٌ':Added, #1: 1	نَفْسِ الْإِمَامِ
u'نَفْسٌ أَمْرٌ':Added, #6: 6	نَفْسُ إمَامِهِ
u'نَفْسٌ أَمْرٌ':Added, #1: 1	نَفْسَ الْأَمْرِ
u'نَفْسٌ أَمْرٌ':Added, #360: 360	نَفْسِ الْأَمْرِ
u'نَفْسٌ إِنْسانٌ':Added, #3: 3	نَفْسُ الْأَمْرِ
u'نَفْسٌ إِنْسانٌ':Added, #1: 1	نَفْسَ الْإِنْسَانِ
u'نَفْسٌ إِنْسانٌ':Added, #1: 1	نَفْسِ الْإِنْسَانِ
u'نَفْسٌ إِنْسانٌ':Added, #1: 1	نَفْسَ إنْسَانٍ
u'نَفْسٌ اِنْفِساخٌ':Added, #3: 3	نَفْسُ الْإِنْسَانِ
u'نَفْسٌ أَوْسَاطٌ':Added, #1: 1	نَفْسِ انْفِسَاخِ
u'نَفْسٌ أَوْلاَدٌ':Added, #1: 1	نَفْسِ أَوْسَاطِ
u'نَفْسٌ أيَّامٌ':Added, #1: 1	نَفْسَ أَوْلَادِهِ
u'نَفْسٌ أَيَّامٌ':Added, #1: 1	نَفْسِ أَيَّامِ
u'نَفْسٌ آيَةٌ':Added, #1: 1	نَفْسِ أَيَّامِ
u'نَفْسٌ إِيجَابٌ':Added, #1: 1	نَفْسُ الْآيَةِ
u'نَفْسٌ إيمَانٌ':Added, #1: 1	نَفْسِ الْإِيجَابِ
u'نَفْسٌ بَخِيلٌ':Added, #4: 4	نَفْسِ الْإِيمَانِ
u'نَفْسٌ بِدْعَةٌ':Added, #1: 1	نَفْسَ الْبَخِيلِ
u'نَفْسٌ بَدَلٌ':Added, #1: 1	نَفْسِ الْبِدْعَةِ
u'نَفْسٌ بدن':Added, #1: 1	نَفْسِ الْبَدَلِ
u'نَفْسٌ بَدَنٌ':Added, #1: 1	نَفْسِ الْبَدَنِ
u'نَفْسٌ بعثة':Added, #1: 1	نَفْسِ الْبَدَنِ
u'نَفْسٌ بَقاءٌ':Added, #1: 1	نَفْسَ بَعْثَةِ
u'نَفْسٌ بَلَدٌ':Added, #1: 1	نَفْسِ الْبَقَاءِ
u'نَفْسٌ بُلُوغٌ':Added, #2: 2	نَفْسُ الْبَلَدِ
u'نَفْسٌ بِنَاءٌ':Added, #1: 1	نَفْسَ الْبُلُوغِ
u'نَفْسٌ بِنَاءٌ':Added, #1: 1	نَفْسَ الْبِنَاءِ
u'نَفْسٌ بَيْعٌ':Added, #3: 3	نَفْسِ الْبِنَاءِ
u'نَفْسٌ بَيْعٌ':Added, #1: 1	نَفْسُ الْبَيْعِ
u'نَفْسٌ تَأْخِيرٌ':Added, #6: 6	نَفْسِ الْبَيْعِ
u'نَفْسٌ تَحْدِيثٌ':Added, #1: 1	نَفْسِ التَّأْخِيرِ
u'نَفْسٌ تَحْرِيمٌ':Added, #1: 1	نَفْسِ التَّحْدِيثِ
u'نَفْسٌ تَحَقُّقٌ':Added, #2: 2	نَفْسُ التَّحْرِيمِ
u'نَفْسٌ تَخْصِيصٌ':Added, #1: 1	نَفْسُ تَحَقُّقِ
u'نَفْسٌ تَدْرِيسٌ':Added, #1: 1	نَفْسِ التَّخْصِيصِ
u'نَفْسٌ تُرْبَةٌ':Added, #1: 1	نَفْسِ التَّدْرِيسِ
u'نَفْسٌ تَزَوُّجٌ':Added, #1: 1	نَفْسِ التُّرْبَةِ
u'نَفْسٌ تَسْلِيمٌ':Added, #4: 4	نَفْسِ التَّزَوُّجِ
u'نَفْسٌ تَشْبِيه':Added, #2: 2	نَفْسَ التَّسْلِيمِ
u'نَفْسٌ تَشْرِيعٌ':Added, #1: 1	نَفْسِ التَّشْبِيهِ
u'نَفْسٌ تَشْرِيعٌ':Added, #1: 1	نَفْسُ التَّشْرِيعِ
u'نَفْسٌ تَصْدِيقٌ':Added, #1: 1	نَفْسِ التَّشْرِيعِ
u'نَفْسٌ تَصَرُّفٌ':Added, #1: 1	نَفْسُ التَّصْدِيقِ
u'نَفْسٌ تَصَرُّفٌ':Added, #1: 1	نَفْسِ تَصَرُّفَاتِ
u'نَفْسٌ تَصَوُّرٌ':Added, #3: 3	نَفْسِ التَّصَرُّفِ
u'نَفَسٌ تَصَوُّرٌ':Added, #1: 1	نَفْسُ تَصَوُّرِ
u'نَفْسٌ تَصَوُّرٌ':Added, #1: 1	نَفَسِ تَصَوُّرِهِ
u'نَفْسٌ تَصَوُّرٌ':Added, #1: 1	نَفْسَ تَصَوُّرِهِ
u'نَفْسٌ تَعْبِيرٌ':Added, #1: 1	نَفْسُ تَصَوُّرِهِ
u'نَفْسٌ تَعَلُّقٌ':Added, #1: 1	نَفْسِ التَّعْبِيرِ
u'نَفْسٌ تَعْلِيقٌ':Added, #1: 1	نَفْسُ التَّعَلُّقِ
u'نَفْسٌ تَعْلِيقٌ':Added, #1: 1	نَفْسُ تَعْلِيقِهِ
u'نَفْسٌ تَعْلِيلٌ':Added, #3: 3	نَفْسُ التَّعْلِيقِ
u'نَفْسٌ تَفْسِيرٌ':Added, #1: 1	نَفْسَ التَّعْلِيلِ
u'نَفْسٌ تَفَضُّلٌ':Added, #1: 1	نَفْسَ التَّفْسِيرِ
u'نَفْسٌ تَكْبيرٌ':Added, #1: 1	نَفْسِ التَّفَضُّلِ
u'نَفْسٌ تَكْليفٌ':Added, #1: 1	نَفْسُ التَّكْبِيرِ
u'نَفْسٌ تَلَفُّظٌ':Added, #1: 1	نَفْسِ التَّكْلِيفِ
u'نَفْسٌ تَمْلِيك':Added, #1: 1	نَفْسُ التَّلَفُّظِ
u'نَفْسٌ تَمْوِيهٌ':Added, #1: 1	نَفْسُ التَّمْلِيكِ
u'نَفْسٌ ثَابِتٌ':Added, #1: 1	نَفْسِ التَّمْوِيهِ
u'نَفْسٌ ثُبُوتٌ':Added, #2: 2	نَفْسَ الثَّابِتِ
u'نَفْسٌ ثَقْبٌ':Added, #2: 2	نَفْسَ ثُبُوتِ
u'نَفْسٌ ثَمَرَةٌ':Added, #1: 1	نَفْسُ الثَّقْبِ
u'نَفْسٌ ثَمَنٌ':Added, #2: 2	نَفْسُ الثَّمَرَةِ
u'نَفْسٌ ثَمَنٌ':Added, #3: 3	نَفْسِ الثَّمَنِ
u'نَفْسٌ ثَوابٌ':Added, #6: 6	نَفْسَ الثَّمَنِ
u'نَفْسٌ ثَوابٌ':Added, #1: 1	نَفْسُ ثَوَابِ
u'نَفْسٌ جَارِي':Added, #1: 1	نَفْسُ ثَوَابِهِ
u'نَفْسٌ جَارِي':Added, #1: 1	نَفْسِ الْجَارِيَةِ
u'نَفْسٌ جَارِيَةٌ':Added, #2: 2	نَفْسُ الْجَارِيَةِ
u'نَفْسٌ جَارِيَةٌ':Added, #1: 1	نَفْسِ الْجَارِيَةِ
u'نَفْسٌ جَبَانٌ':Added, #2: 2	نَفْسُ الْجَارِيَةِ
u'نَفْسٌ جَبَلٌ':Added, #1: 1	نَفْسِ الْجَبَانِ
u'نَفْسٌ جِدار':Added, #1: 1	نَفْسِ الْجَبَلِ
u'نَفْسٌ جِدار':Added, #1: 1	نَفْسِ الْجِدَارِ
u'نَفْسٌ جُذَاذٌ':Added, #1: 1	نَفْسِ جِدَارِ
u'نَفْسٌ جِرَابٌ':Added, #1: 1	نَفْسِ الْجُذَاذِ
u'نَفْسٌ جِرَاحَةٌ':Added, #1: 1	نَفْسَ الْجِرَابِ
u'نَفْسٌ جُرْحٌ':Added, #1: 1	نَفْسِ الْجِرَاحَةِ
u'نَفْسٌ جُزْءٌ':Added, #1: 1	نَفْسَ الْجُرْحِ
u'نَفْسٌ جماع':Added, #1: 1	نَفْسِ الْجُزْءِ
u'نَفْسٌ جِمَاعٌ':Added, #1: 1	نَفْسُ الْجِمَاعِ
u'نَفْسٌ جمع':Added, #1: 1	نَفْسُ الْجِمَاعِ
u'نَفْسٌ جَمْعٌ':Added, #1: 1	نَفْسُ الْجَمْعِ
u'نَفْسٌ جِنْسٌ':Added, #1: 1	نَفْسُ الْجَمْعِ
u'نَفْسٌ جَنِينٌ':Added, #1: 1	نَفْسِ الْجِنْسِ
u'نَفْسٌ جُوَالِقٌ':Added, #4: 4	نَفْسِ الْجَنِينِ
u'نَفْسٌ حاجَةٌ':Added, #1: 1	نَفْسَ الْجُوَالِقِ
u'نَفْسٌ حاجَةٌ':Added, #1: 1	نَفْسَ الْحَاجَةِ
u'نَفْسٌ حانوتٌ':Added, #1: 1	نَفْسُ الْحَاجَةِ
u'نَفْسٌ حائِطٌ':Added, #1: 1	نَفْسَ الْحَانُوتِ
u'نَفْسٌ حَبْسٌ':Added, #1: 1	نَفْسِ الْحَائِطِ
u'نَفْسٌ حَبْسٌ':Added, #1: 1	نَفْسَ الْحَبْسِ
u'نَفْسٌ حَجٌّ':Added, #1: 1	نَفْسُ الْحَبْسِ
u'نَفْسٌ حَجٌّ':Added, #1: 1	نَفْسَ الْحَجِّ
u'نَفْسٌ حَجٌّ':Added, #1: 1	نَفْسُ الْحَجِّ
u'نَفْسٌ حُجَّةٌ':Added, #4: 4	نَفْسِ الْحَجِّ
u'نَفْسٌ حُجَّةٌ':Added, #1: 1	نَفْسُ الْحُجَّةِ
u'نَفْسٌ حَدٌّ':Added, #1: 1	نَفْسِ الْحُجَّةِ
u'نَفْسٌ حَدٌّ':Added, #1: 1	نَفْسُ الْحَدِّ
u'نَفْسٌ حَدَثٌ':Added, #3: 3	نَفْسِ الْحَدِّ
u'نَفْسٌ حُدوثٌ':Added, #1: 1	نَفْسُ حَدَثِ
u'نَفْسٌ حُدودٌ':Added, #1: 1	نَفْسُ الْحُدُوثِ
u'نَفْسٌ حَديثٌ':Added, #1: 1	نَفْسُ الْحُدُودِ
u'نَفْسٌ حُرٌّ':Added, #2: 2	نَفْسِ الْحَدِيثِ
u'نَفْسٌ حُرٌّ':Added, #2: 2	نَفْسَ الْحُرِّ
u'نَفْسٌ حَرَجٌ':Added, #2: 2	نَفْسِ الْحُرِّ
u'نَفْسٌ حَرَكَةٌ':Added, #1: 1	نَفْسِ حَرَجِ
u'نَفْسٌ حَرَكَةٌ':Added, #1: 1	نَفْسُ الْحَرَكَةِ
u'نَفْسٌ حَسَنٌ':Added, #1: 1	نَفْسِ الْحَرَكَةِ
u'نَفْسٌ حُضورٌ':Added, #1: 1	نَفْسُ الْحَسَنِ
u'نَفْسٌ حُضُورٌ':Added, #1: 1	نَفْسُ الْحُضُورِ
u'نَفْسٌ حِفْظٌ':Added, #1: 1	نَفْسُ الْحُضُورِ
u'نَفْسٌ حَقٌّ':Added, #1: 1	نَفْسِ الْحِفْظِ
u'نَفْسٌ حَقٌّ':Added, #1: 1	نَفْسَ حَقِّهِ
u'نَفْسٌ حَقٌّ':Added, #2: 2	نَفْسِ الْحَقِّ
u'نَفْسٌ حَقٌّ':Added, #2: 2	نَفْسُ حَقِّهِ
u'نَفْسٌ حَقِيقٌ':Added, #5: 5	نَفْسَ الْحَقِّ
u'نَفْسٌ حَقِيقٌ':Added, #1: 1	نَفْسَ الْحَقِيقَةِ
u'نَفْسٌ حَقِيقٌ':Added, #1: 1	نَفْسِ الْحَقِيقَةِ
u'نَفْسٌ حَقِيقَةٌ':Added, #1: 1	نَفْسَ حَقِيقَةِ
u'نَفْسٌ حَقِيقَةٌ':Added, #1: 1	نَفْسَ الْحَقِيقَةِ
u'نَفْسٌ حَقِيقَةٌ':Added, #1: 1	نَفْسِ الْحَقِيقَةِ
u'نَفْسٌ حُكْمٌ':Added, #1: 1	نَفْسَ حَقِيقَةِ
u'نَفْسٌ حُكْمٌ':Added, #10: 10	نَفْسُ الْحُكْمِ
u'نَفْسٌ حُكْمٌ':Added, #1: 1	نَفْسَ الْحُكْمِ
u'نَفْسٌ حُكْمٌ':Added, #1: 1	نَفْسِ حُكْمِ
u'نَفْسٌ حُكْمٌ':Added, #1: 1	نَفْسُ حُكْمِهِ
u'نَفْسٌ حكمة':Added, #5: 5	نَفْسِ الْحُكْمِ
u'نَفْسٌ حكمة':Added, #1: 1	نَفْسَ الْحِكْمَةِ
u'نَفْسٌ حِكْمَةٌ':Added, #1: 1	نَفْسِ الْحِكْمَةِ
u'نَفْسٌ حِكْمَةٌ':Added, #1: 1	نَفْسَ الْحِكْمَةِ
u'نَفْسٌ حَيٌّ':Added, #1: 1	نَفْسِ الْحِكْمَةِ
u'نَفْسٌ حَيْضٌ':Added, #1: 1	نَفْسَ الْحَيِّ
u'نَفْسٌ حَيْضٌ':Added, #2: 2	نَفْسَ الْحَيْضِ
u'نَفْسٌ حَيَوَانٌ':Added, #2: 2	نَفْسُ الْحَيْضِ
u'نَفْسٌ خَبَرٌ':Added, #2: 2	نَفْسِ الْحَيَوَانَاتِ
u'نَفْسٌ خَبَر':Added, #1: 1	نَفْسَ الْخَبَرِ
u'نَفْسٌ خَبَرٌ':Added, #1: 1	نَفْسَ الْخَبَرِ
u'نَفْسٌ خَبَر':Added, #2: 2	نَفْسِ الْخَبَرِ
u'نَفْسٌ خَبَرٌ':Added, #2: 2	نَفْسِ الْخَبَرِ
u'نَفْسٌ خَبَر':Added, #3: 3	نَفْسُ الْخَبَرِ
u'نَفْسٌ خدمة':Added, #3: 3	نَفْسُ الْخَبَرِ
u'نَفْسٌ خِدْمَةٌ':Added, #1: 1	نَفْسَ الْخِدْمَةِ
u'نَفْسٌ خُرُوجٌ':Added, #1: 1	نَفْسَ الْخِدْمَةِ
u'نَفْسٌ خُرُوجٌ':Added, #1: 1	نَفْسِ الْخُرُوجِ
u'نَفْسٌ خُرُوجٌ':Added, #1: 1	نَفْسَ خُرُوجِ
u'نَفْسٌ خُرُوجٌ':Added, #3: 3	نَفْسُ الْخُرُوجِ
u'نَفْسٌ خَطَأٌ':Added, #4: 4	نَفْسَ الْخُرُوجِ
u'نَفْسٌ خَطَأٌ':Added, #1: 1	نَفْسَ الْخَطَأِ
u'نَفْسٌ خِطَابٌ':Added, #1: 1	نَفْسِ الْخَطَأِ
u'نَفْسٌ خطبة':Added, #1: 1	نَفْسُ الْخِطَابِ
u'نَفْسٌ خُطْبَةٌ':Added, #1: 1	نَفْسِ الْخُطْبَةِ
u'نَفْسٌ خُفٌّ':Added, #1: 1	نَفْسِ الْخُطْبَةِ
u'نَفْسٌ خَلاَءٌ':Added, #2: 2	نَفْسِ الْخُفِّ
u'نَفْسٌ خلط':Added, #1: 1	نَفْسِ الْخَلَاءِ
u'نَفْسٌ خَلْوَةٌ':Added, #1: 1	نَفْسَ الْخَلْطِ
u'نَفْسٌ خَلْوَةٌ':Added, #1: 1	نَفْسِ الْخَلْوَةِ
u'نَفْسٌ خَمْرٌ':Added, #3: 3	نَفْسُ الْخَلْوَةِ
u'نَفْسٌ خُمُسٌ':Added, #2: 2	نَفْسِ الْخَمْرِ
u'نَفْسٌ خيار':Added, #1: 1	نَفْسِ خُمُسِ
u'نَفْسٌ خِيَارٌ':Added, #1: 1	نَفْسِ الْخِيَارِ
u'نَفْسٌ خيار':Added, #1: 1	نَفْسِ الْخِيَارِ
u'نَفْسٌ خِيَارٌ':Added, #3: 3	نَفْسُ الْخِيَارِ
u'نَفْسٌ خِيَاطَةٌ':Added, #3: 3	نَفْسُ الْخِيَارِ
u'نَفْسٌ خَيْلٌ':Added, #1: 1	نَفْسِ الْخِيَاطَةِ
u'نَفْسٌ دَابَّةٌ':Added, #1: 1	نَفْسُ الْخَيْلِ
u'نَفْسٌ دَاخِلٌ':Added, #1: 1	نَفْسُ دَابَّةٍ
u'نَفْسٌ دَارٌ':Added, #1: 1	نَفْسِ الدَّاخِلِ
u'نَفْسٌ دَاعِرٌ':Added, #2: 2	نَفْسِ الدَّارِ
u'نَفَسٌ دَائِمٌ':Added, #1: 1	نَفْسِ الدَّاعِرِ
u'نَفْسٌ دُخُولٌ':Added, #1: 1	نَفَسٍ دَائِمٍ
u'نَفْسٌ دُخُولٌ':Added, #1: 1	نَفْسُ الدُّخُولِ
u'نَفْسٌ دِرْهَمٌ':Added, #1: 1	نَفْسِ الدّخُولِ
u'نَفْسٌ دِرْهَم':Added, #2: 2	نَفْسُ الدِّرْهَمِ
u'نَفْسٌ دُعَاءٌ':Added, #2: 2	نَفْسُ الدِّرْهَمِ
u'نَفْسٌ دُعَاءٌ':Added, #1: 1	نَفْسَ الدُّعَاءِ
u'نَفْسٌ دُعَاءٌ':Added, #1: 1	نَفْسِ الدُّعَاءِ
u'نَفْسٌ دفن':Added, #3: 3	نَفْسُ الدُّعَاءِ
u'نَفْسٌ دَلالَةٌ':Added, #1: 1	نَفْسِ الدِّفْنِ
u'نَفْسٌ دَلالَةٌ':Added, #1: 1	نَفْسَ الدَّلَالَةِ
u'نَفْسٌ دَليلٌ':Added, #1: 1	نَفْسِ الدَّلَالَةِ
u'نَفْسٌ دَليلٌ':Added, #1: 1	نَفْسِ الدَّلِيلِ
u'نَفْسٌ دَمٌ':Added, #4: 4	نَفْسَ الدَّلِيلِ
u'نَفْسٌ دُودَةٌ':Added, #1: 1	نَفْسَ الدَّمِ
u'نَفْسٌ دِيَةٌ':Added, #1: 1	نَفْسَ الدُّودَةِ
u'نَفْسٌ دَيْنٌ':Added, #1: 1	نَفْسِ الدِّيَةِ
u'نَفْسٌ دَيْنٌ':Added, #1: 1	نَفْسُ الدَّيْنِ
u'نَفْسٌ ذَرائِعُ':Added, #1: 1	نَفْسِ الدَّيْنِ
u'نَفْسٌ رَأْسٌ':Added, #1: 1	نَفْسِ الذَّرَائِعِ
u'نَفْسٌ راغِب':Added, #1: 1	نَفْسِ الرَّأْسِ
u'نَفْسٌ رَاهِنٌ':Added, #1: 1	نَفْسِ رَاغِبٍ
u'نَفْسٌ رُجْحانٌ':Added, #3: 3	نَفْسِ الرَّاهِنِ
u'نَفْسٌ رِجْسٌ':Added, #1: 1	نَفْسِ الرُّجْحَانِ
u'نَفْسٌ رجعة':Added, #1: 1	نَفْسُ الرِّجْسِ
u'نَفْسٌ رَجْعَةٌ':Added, #1: 1	نَفْسِ الرَّجْعَةِ
u'نَفْسٌ رَجُلٌ':Added, #1: 1	نَفْسِ الرَّجْعَةِ
u'نَفْسٌ رَجُلٌ':Added, #1: 1	نَفْسِ الرَّجُلِ
u'نَفْسٌ رَجُلٌ':Added, #1: 1	نَفْسِ رَجُلٍ
u'نَفَسٌ رَحْمَن':Added, #2: 2	نَفْسَ رَجُلٍ
u'نَفْسٌ رَحْمَن':Added, #1: 1	نَفَسِ الرَّحْمَنِ
u'نَفْسٌ رَحْمَن':Added, #1: 1	نَفْسَ الرَّحْمَنِ
u'نَفْسٌ رِدَّةٌ':Added, #1: 1	نَفْسِ الرَّحْمَنِ
u'نَفْسٌ رَسُولٌ':Added, #1: 1	نَفْسُ الرِّدَّةِ
u'نَفْسٌ رَسُولٌ':Added, #1: 1	نَفْسُ رَسُولِ
u'نَفْسٌ رُطوبَةٌ':Added, #1: 1	نَفْسِ رَسُولِ
u'نَفْسٌ رَفْعٌ':Added, #2: 2	نَفْسُ الرُّطُوبَةِ
u'نَفْسٌ رَفْعٌ':Added, #1: 1	نَفْسُ الرَّفْعِ
u'نَفْسٌ رَفْعٌ':Added, #1: 1	نَفْسِ الرَّفْعِ
u'نَفْسٌ ركبة':Added, #1: 1	نَفْسَ رَفْعِ
u'نَفْسٌ رُكْبَةٌ':Added, #1: 1	نَفْسَ الرُّكْبَةِ
u'نَفْسٌ رُكْنٌ':Added, #1: 1	نَفْسَ الرُّكْبَةِ
u'نَفْسٌ رُكْن':Added, #6: 6	نَفْسِ الرُّكْنِ
u'نَفْسٌ رُكوعٌ':Added, #6: 6	نَفْسِ الرُّكْنِ
u'نَفْسٌ رَمْلٌ':Added, #1: 1	نَفْسُ الرُّكُوعِ
u'نَفْسٌ رَهْنٌ':Added, #2: 2	نَفْسِ الرَّمْلِ
u'نَفْسٌ روائح':Added, #2: 2	نَفْسِ الرَّهْنِ
u'نَفْسٌ رَوائِحُ':Added, #1: 1	نَفْسِ الرَّوَائِحِ
u'نَفْسٌ رَوَائِحُ':Added, #1: 1	نَفْسِ الرَّوَائِحِ
u'نَفْسٌ زائِدٌ':Added, #1: 1	نَفْسِ الرَّوَائِحِ
u'نَفْسٌ زِفافٌ':Added, #1: 1	نَفْسُ الزَّائِدِ
u'نَفْسٌ زَكاةٌ':Added, #1: 1	نَفْسَ الزِّفَافِ
u'نَفْسٌ زَمانٌ':Added, #1: 1	نَفْسَ الزَّكَاةِ
u'نَفْسٌ زَهوقٌ':Added, #1: 1	نَفْسَ الزَّمَانِ
u'نَفْسٌ زَوالٌ':Added, #1: 1	نَفْسُ زَهُوقِ
u'نَفْسٌ زَوْجٌ':Added, #1: 1	نَفْسُ زَوَالِ
u'نَفْسٌ زِيادَةٌ':Added, #2: 2	نَفْسِ الزَّوْجِ
u'نَفْسٌ زِيادَةٌ':Added, #1: 1	نَفْسَ الزِّيَادَةِ
u'نَفْسٌ زَيْدٌ':Added, #1: 1	نَفْسُ زِيَادَةِ
u'نَفْسٌ زَيْدٌ':Added, #1: 1	نَفْسُ زَيْدٍ
u'نَفْسٌ زِينَةٌ':Added, #1: 1	نَفْسُ زَيْدِ
u'نَفْسٌ ساج':Added, #1: 1	نَفْسَ الزِّينَةِ
u'نَفْسٌ ساجَة':Added, #2: 2	نَفْسِ السَّاجَةِ
u'نَفَسٌ سَاعَةٌ':Added, #2: 2	نَفْسِ السَّاجَةِ
u'نَفَسٌ سَاعَةٌ':Added, #1: 1	نَفَسَ السّاعَةِ
u'نَفْسٌ سَاقٌ':Added, #3: 3	نَفَسِ السّاعَةِ
u'نَفْسٌ سَامِعٌ':Added, #1: 1	نَفْسِ السَّاقِ
u'نَفْسٌ سَامِعٌ':Added, #1: 1	نَفْسُ السَّامِعِ
u'نَفْسٌ سَائِرٌ':Added, #3: 3	نَفْسِ السَّامِعِ
u'نَفْسٌ سَبَبٌ':Added, #1: 1	نَفْسِ السَّائِرِ
u'نَفْسٌ سَبْرٌ':Added, #2: 2	نَفْسِ السَّبَبِ
u'نَفْسٌ سِجِلٌّ':Added, #1: 1	نَفْسَ السَّبْرِ
u'نَفْسٌ سُجُودٌ':Added, #1: 1	نَفْسُ السِّجِلَّاتِ
u'نَفْسٌ سُجُودٌ':Added, #1: 1	نَفْسُ السُّجُودِ
u'نَفْسٌ سَفَرٌ':Added, #1: 1	نَفْسَ سُجُودِ
u'نَفْسٌ سَفَرٌ':Added, #1: 1	نَفْسُ السَّفَرِ
u'نَفْسٌ سَفَهٌ':Added, #4: 4	نَفْسَ السَّفَرِ
u'نَفْسٌ سكر':Added, #1: 1	نَفْسِ السَّفَهِ
u'نَفْسٌ سُكَّرٌ':Added, #1: 1	نَفْسُ السُّكْرِ
u'نَفْسٌ سُكْرٌ':Added, #1: 1	نَفْسَ السُّكَّرِ
u'نَفْسٌ سُكُونٌ':Added, #1: 1	نَفْسُ السُّكْرِ
u'نَفْسٌ سِلاَحٌ':Added, #1: 1	نَفْسِ السُّكُونِ
u'نَفْسٌ سِلَعٌ':Added, #2: 2	نَفْسِ السِّلَاحِ
u'نَفْسٌ سَمَاعٌ':Added, #1: 1	نَفْسِ السِّلَعِ
u'نَفْسٌ سَمَاعٌ':Added, #1: 1	نَفْسُ السَّمَاعِ
u'نَفْسٌ سُنَّةٌ':Added, #1: 1	نَفْسَ سَمَاعِ
u'نَفْسٌ سُنَّةٌ':Added, #1: 1	نَفْسَ السُّنَّةِ
u'نَفْسٌ سَوادٌ':Added, #1: 1	نَفْسُ السُّنَّةِ
u'نَفْسٌ سَوادٌ':Added, #1: 1	نَفْسِ السَّوَادِ
u'نَفْسٌ سُؤَالٌ':Added, #1: 1	نَفْسِ سَوَادِ
u'نَفْسٌ سورٌ':Added, #1: 1	نَفْسِ السُّؤَالِ
u'نَفْسٌ سورٌ':Added, #1: 1	نَفْسَ السُّورِ
u'نَفْسٌ شَارِعٌ':Added, #1: 1	نَفْسِ السُّورِ
u'نَفْسٌ شَجَرَةٌ':Added, #1: 1	نَفْسِ الشَّارِعِ
u'نَفْسٌ شَجَرَةٌ':Added, #1: 1	نَفْسَ الشَّجَرَةِ
u'نَفْسٌ شَخْصٌ':Added, #2: 2	نَفْسِ الشَّجَرَةِ
u'نَفْسٌ شِرَاءٌ':Added, #1: 1	نَفْسُ الشَّخْصِ
u'نَفْسٌ شرب':Added, #4: 4	نَفْسَ الشِّرَاءِ
u'نَفْسٌ شرب':Added, #1: 1	نَفْسُ الشُّرْبِ
u'نَفْسٌ شُرْبٌ':Added, #1: 1	نَفْسِ الشِّرْبِ
u'نَفْسٌ شِرْبٌ':Added, #1: 1	نَفْسُ الشُّرْبِ
u'نَفْسٌ شَرْطٌ':Added, #1: 1	نَفْسِ الشِّرْبِ
u'نَفْسٌ شَرْطٌ':Added, #1: 1	نَفْسُ الشَّرْطِ
u'نَفْسٌ شركة':Added, #1: 1	نَفْسِ الشَّرْطِ
u'نَفْسٌ شركة':Added, #1: 1	نَفْس الشَّرِكَةِ
u'نَفْسٌ شَرِكَةٌ':Added, #1: 1	نَفْسِ الشَّرِكَةِ
u'نَفْسٌ شَرِكَةٌ':Added, #1: 1	نَفْس الشَّرِكَةِ
u'نَفْسٌ شَرِيعَةٌ':Added, #1: 1	نَفْسِ الشَّرِكَةِ
u'نَفْسٌ شَرِيفٌ':Added, #1: 1	نَفْسِ الشَّرِيعَةِ
u'نَفْسٌ شَعِيرٌ':Added, #1: 1	نَفْسُ الشَّرِيفِ
u'نَفْسٌ شَهَادَةٌ':Added, #1: 1	نَفْسُ الشَّعِيرِ
u'نَفْسٌ شَهَادَةٌ':Added, #1: 1	نَفْسَ الشَّهَادَةِ
u'نَفْسٌ شَهَادَةٌ':Added, #1: 1	نَفْسِ شَهَادَةِ
u'نَفْسٌ شَوْكٌ':Added, #5: 5	نَفْسِ الشَّهَادَةِ
u'نَفْسٌ شَوْكِ':Added, #1: 1	نَفْسِ الشَّوْكِ
u'نَفْسٌ شَيْءٌ':Added, #1: 1	نَفْسِ الشَّوْكِ
u'نَفْسٌ شَيْءٌ':Added, #1: 1	نَفْسَ الشَّيْءِ
u'نَفْسٌ شَيْءٌ':Added, #1: 1	نَفْسِ الشَّيْءِ
u'نَفْسٌ صَاحِبٌ':Added, #2: 2	نَفْسُ الشَّيْءِ
u'نَفْسٌ صَائِمٌ':Added, #1: 1	نَفْسِ صَاحِبِهِ
u'نَفْسٌ صِحَّةٌ':Added, #1: 1	نَفْسِ الصَّائِمِ
u'نَفْسٌ صدقة':Added, #1: 1	نَفْسُ الصِّحَّةِ
u'نَفْسٌ صَدَقَةٌ':Added, #2: 2	نَفْسِ الصَّدَقَةِ
u'نَفْسٌ صِفَةٌ':Added, #2: 2	نَفْسِ الصَّدَقَةِ
u'نَفْسٌ صَلاَةٌ':Added, #1: 1	نَفْسَ الصِّفَةِ
u'نَفْسٌ صَلاَةٌ':Added, #19: 19	نَفْسِ الصَّلَاةِ
u'نَفْسٌ صَلاَةٌ':Added, #1: 1	نَفْسَ الصَّلَاةِ
u'نَفْسٌ صلْبٌ':Added, #2: 2	نَفْسُ الصَّلَاةِ
u'نَفْسٌ صُورَةٌ':Added, #2: 2	نَفْسِ الصُّلْبِ
u'نَفْسٌ صَوْمٌ':Added, #1: 1	نَفْسِ صُورَةِ
u'نَفْسٌ صَوْمٌ':Added, #1: 1	نَفْسَ الصَّوْمِ
u'نَفْسٌ صَوْمٌ':Added, #1: 1	نَفْسُ الصَّوْمِ
u'نَفْسٌ صَيْدٌ':Added, #1: 1	نَفْسِ الصَّوْمِ
u'نَفْسٌ صَيْدٌ':Added, #1: 1	نَفْسَ الصَّيْدِ
u'نَفْسٌ صَيْدٌ':Added, #2: 2	نَفْسُ الصَّيْدِ
u'نَفْسٌ صِيغَةٌ':Added, #2: 2	نَفْسِ الصَّيْدِ
u'نَفْسٌ ضَرْبٌ':Added, #2: 2	نَفْسِ الصِّيغَةِ
u'نَفْسٌ ضَمَانٌ':Added, #1: 1	نَفْسِ الضَّرْبِ
u'نَفْسٌ طَالِبٌ':Added, #1: 1	نَفْسُ الضَّمَانِ
u'نَفْسٌ طَالِبٌ':Added, #1: 1	نَفْسُ الطّالِبِ
u'نَفْسٌ طَائِفٌ':Added, #2: 2	نَفْسِ الطَّالِبِ
u'نَفْسٌ طَائِفٌ':Added, #1: 1	نَفْسُ طَائِفَةٍ
u'نَفْسٌ طحن':Added, #1: 1	نَفْسِ طَائِفَةٍ
u'نَفْسٌ طَرِيقٌ':Added, #1: 1	نَفْسِ الطَّحْنِ
u'نَفْسٌ طعام':Added, #2: 2	نَفْسِ الطَّرِيقِ
u'نَفْسٌ طعام':Added, #1: 1	نَفْسَ الطَّعَامِ
u'نَفْسٌ طَعَامٌ':Added, #1: 1	نَفْسِ الطَّعَامِ
u'نَفْسٌ طَعَامٌ':Added, #1: 1	نَفْسَ الطَّعَامِ
u'نَفْسٌ طَلاَقٌ':Added, #1: 1	نَفْسِ الطَّعَامِ
u'نَفْسٌ طَلاَقٌ':Added, #1: 1	نَفْسُ الطَّلاَقِ
u'نَفْسٌ طَلاَقٌ':Added, #3: 3	نَفْسِ الطَّلَاقِ
u'نَفْسٌ طلب':Added, #5: 5	نَفْسَ الطَّلَاقِ
u'نَفْسٌ طَلَبٌ':Added, #1: 1	نَفْسُ طَلَبِهِ
u'نَفْسٌ طلب':Added, #1: 1	نَفْسُ طَلَبِهِ
u'نَفْسٌ طَلَبٌ':Added, #3: 3	نَفْسِ الطَّلَبِ
u'نَفْسٌ طَهَارَةٌ':Added, #3: 3	نَفْسِ الطَّلَبِ
u'نَفْسٌ طواف':Added, #1: 1	نَفْسِ الطَّهَارَةِ
u'نَفْسٌ طَوَافٌ':Added, #1: 1	نَفْسِ الطَّوَافِ
u'نَفْسٌ طِيبٌ':Added, #1: 1	نَفْسِ الطَّوَافِ
u'نَفْسٌ طِيبٌ':Added, #1: 1	نَفْسُ الطِّيبِ
u'نَفْسٌ ظَنٌّ':Added, #5: 5	نَفْسِ الطِّيبِ
u'نَفْسٌ عَالَمِيٌّ':Added, #1: 1	نَفْسُ الظَّنِّ
u'نَفْسٌ عَامٌّ':Added, #2: 2	نَفْسُ الْعَالَمِيَّةِ
u'نَفْسٌ عِبَادَةٌ':Added, #2: 2	نَفْسِ عَامَّةِ
u'نَفْسٌ عِبَادَةٌ':Added, #1: 1	نَفْسَ الْعِبَادَةِ
u'نَفْسٌ عِبَارَةٌ':Added, #2: 2	نَفْسِ الْعِبَادَةِ
u'نَفْسٌ عِبَارَةٌ':Added, #1: 1	نَفْسَ الْعِبَارَةِ
u'نَفْسٌ عَبْدٌ':Added, #1: 1	نَفْسِ الْعِبَارَةِ
u'نَفْسٌ عَبْدٌ':Added, #16: 16	نَفْسِ الْعَبْدِ
u'نَفْسٌ عَبْدٌ':Added, #1: 1	نَفْسُ عَبْدِ
u'نَفْسٌ عَدَالَةٌ':Added, #7: 7	نَفْسَ الْعَبْدِ
u'نَفْسٌ عَدَدٌ':Added, #1: 1	نَفْسُ الْعَدَالَةِ
u'نَفْسٌ عَدَمٌ':Added, #1: 1	نَفْسِ الْعَدَدِ
u'نَفْسٌ عَدَمٌ':Added, #1: 1	نَفْسُ الْعَدَمِ
u'نَفْسٌ عَرْضٌ':Added, #1: 1	نَفْسِ الْعَدَمِ
u'نَفْسٌ عِصَامٌ':Added, #1: 1	نَفْسِ الْعَرْضِ
u'نَفْسٌ عُضْوٌ':Added, #1: 1	نَفْسُ عِصَامٍ
u'نَفْسٌ عَطْشَان':Added, #2: 2	نَفْسِ الْعُضْوِ
u'نَفْسٌ عَفْوٌ':Added, #2: 2	نَفْسِ الْعَطْشَانِ
u'نَفْسٌ عَقْدٌ':Added, #1: 1	نَفْسَ الْعَفْوِ
u'نَفْسٌ عَقْدٌ':Added, #17: 17	نَفْسِ الْعَقْدِ
u'نَفْسٌ عَقْدٌ':Added, #1: 1	نَفْس الْعَقْدِ
u'نَفْسٌ عَقْدٌ':Added, #1: 1	نَفْسَ الْعَقْدِ
u'نَفْسٌ عَقْلٌ':Added, #1: 1	نَفْسُ الْعَقْدِ
u'نَفْسٌ عِلَّةٌ':Added, #1: 1	نَفْسُ الْعَقْلِ
u'نَفْسٌ عِلَّةٌ':Added, #2: 2	نَفْسَ الْعِلَّةِ
u'نَفْسٌ عِلَّةٌ':Added, #2: 2	نَفْسُ الْعِلَّةِ
u'نَفْسٌ علم':Added, #4: 4	نَفْسِ الْعِلَّةِ
u'نَفْسٌ عِلْمٌ':Added, #1: 1	نَفْسَ الْعِلْمِ
u'نَفْسٌ علم':Added, #1: 1	نَفْسَ الْعِلْمِ
u'نَفْسٌ عِلْمٌ':Added, #3: 3	نَفْسِ الْعِلْمِ
u'نَفْسٌ علم':Added, #3: 3	نَفْسِ الْعِلْمِ
u'نَفْسٌ عِلْمٌ':Added, #6: 6	نَفْسُ الْعِلْمِ
u'نَفْسٌ عَمَلٌ':Added, #6: 6	نَفْسُ الْعِلْمِ
u'نَفْسٌ عَمَلٌ':Added, #1: 1	نَفْسِ الْعَمَلَيْنِ
u'نَفْسٌ عَمَلٌ':Added, #1: 1	نَفْسِ عَمَلِهِ
u'نَفْسٌ عَمَلٌ':Added, #3: 3	نَفْسَ الْعَمَلِ
u'نَفْسٌ عَمَلٌ':Added, #3: 3	نَفْسِ الْعَمَلِ
u'نَفْسٌ عَيْبٌ':Added, #5: 5	نَفْسُ الْعَمَلِ
u'نَفْسٌ عين':Added, #1: 1	نَفْسِ الْعَيْبِ
u'نَفْسٌ عين':Added, #1: 1	نَفْسَ الْعَيْنِ
u'نَفْسٌ عَيْنٌ':Added, #1: 1	نَفْسُ الْعَيْنِ
u'نَفْسٌ عَيْنٌ':Added, #1: 1	نَفْسَ الْعَيْنِ
u'نَفْسٌ عَيْن':Added, #1: 1	نَفْسُ الْعَيْنِ
u'نَفْسٌ عَيْن':Added, #1: 1	نَفْسَ الْعَيْنِ
u'نَفْسٌ عين':Added, #1: 1	نَفْسُ الْعَيْنِ
u'نَفْسٌ عَيْنٌ':Added, #4: 4	نَفْسِ الْعَيْنِ
u'نَفْسٌ عَيْن':Added, #4: 4	نَفْسِ الْعَيْنِ
u'نَفْسٌ غاسِل':Added, #4: 4	نَفْسِ الْعَيْنِ
u'نَفْسٌ غَائِبٌ':Added, #2: 2	نَفْسُ الْغَاسِلِ
u'نَفْسٌ غُسْلٌ':Added, #1: 1	نَفْسِ الْغَائِبِ
u'نَفْسٌ غَصْبٌ':Added, #2: 2	نَفْسُ الْغُسْلِ
u'نَفْسٌ غَصْبٌ':Added, #1: 1	نَفْسَ الْغَصْبِ
u'نَفْسٌ غَلَّةٌ':Added, #1: 1	نَفْسُ الْغَصْبِ
u'نَفْسٌ غير':Added, #1: 1	نَفْسِ الْغَلَّةِ
u'نَفْسٌ غَيْرٌ':Added, #1: 1	نَفْسُ غَيْرِ
u'نَفْسٌ غير':Added, #1: 1	نَفْسُ غَيْرِ
u'نَفْسٌ غَيْرٌ':Added, #1: 1	نَفْسَ غَيْرِهِ
u'نَفْسٌ غير':Added, #1: 1	نَفْسَ غَيْرِهِ
u'نَفْسٌ غَيْرٌ':Added, #8: 8	نَفْسِ غَيْرِهِ
u'نَفْسٌ فَاسِقٌ':Added, #8: 8	نَفْسِ غَيْرِهِ
u'نَفْسٌ فَتْحٌ':Added, #1: 1	نَفْسِ الْفَاسِقِ
u'نَفْسٌ فَحْلٌ':Added, #1: 1	نَفْسَ الْفَتْحِ
u'نَفْسٌ فخر':Added, #1: 1	نَفْسُ الْفَحْلِ
u'نَفْسٌ فَخْرٌ':Added, #1: 1	نَفْسُ فَخْرِ
u'نَفْسٌ فرار':Added, #1: 1	نَفْسُ فَخْرِ
u'نَفْسٌ فِرَارٌ':Added, #1: 1	نَفْسَ الْفِرَارِ
u'نَفْسٌ فِرَاشٌ':Added, #1: 1	نَفْسَ الْفِرَارِ
u'نَفْسٌ فرد':Added, #1: 1	نَفْسِ الْفِرَاشِ
u'نَفْسٌ فَرْدٌ':Added, #1: 1	نَفْسُ الْفَرْدِ
u'نَفْسٌ فَرْعٌ':Added, #1: 1	نَفْسُ الْفَرْدِ
u'نَفْسٌ فِرْقَةٌ':Added, #1: 1	نَفْسُ الْفَرْعِ
u'نَفْسٌ فُسْطَاطٌ':Added, #1: 1	نَفْسِ الْفِرْقَةِ
u'نَفْسٌ فِعْلٌ':Added, #1: 1	نَفْسَ الْفُسْطَاطِ
u'نَفْسٌ فِعْلٌ':Added, #1: 1	نَفْسَ الْفِعْلِ
u'نَفْسٌ فِعْلٌ':Added, #1: 1	نَفْسِ فِعْلٍ
u'نَفْسٌ فِعْلٌ':Added, #3: 3	نَفْسُ فِعْلِ
u'نَفْسٌ فِعْلٌ':Added, #6: 6	نَفْسِ الْفِعْلِ
u'نَفْسٌ فَقِيهٌ':Added, #7: 7	نَفْسُ الْفِعْلِ
u'نَفَسٌ فلان':Added, #1: 1	نَفْسِ الْفَقِيهِ
u'نَفْسٌ فلان':Added, #1: 1	نَفَسِ الرَّحْمَنِ
u'نَفْسٌ فلان':Added, #1: 1	نَفْسَ الرَّحْمَنِ
u'نَفْسٌ فلان':Added, #1: 1	نَفْسِ الرَّحْمَنِ
u'نَفْسٌ فلان':Added, #1: 1	نَفْسُ الْقَادِرِيَّةِ
u'نَفْسٌ فلان':Added, #1: 1	نَفْسَ الْمُتَصَدِّقِ
u'نَفْسٌ فُلاَنٌ':Added, #1: 1	نَفْسِ رَاغِبٍ
u'نَفْسٌ فُلاَنٌ':Added, #1: 1	نَفْسَ فُلَانٍ
u'نَفْسٌ فُلاَنٌ':Added, #1: 1	نَفْسُ فُلَانٍ
u'نَفْسٌ فَمٌ':Added, #4: 4	نَفْسِ فُلَانٍ
u'نَفْسٌ فَهْمٌ':Added, #2: 2	نَفْسِ الْفَمِ
u'نَفْسٌ قَاتِلٌ':Added, #1: 1	نَفْسُ الْفَهْمِ
u'نَفْسٌ قَادِرٌ':Added, #1: 1	نَفْسَ الْقَاتِلِ
u'نَفْسٌ قادِر':Added, #1: 1	نَفْسُ الْقَادِرِ
u'نَفْسٌ قَبْرٌ':Added, #1: 1	نَفْسُ الْقَادِرِيَّةِ
u'نَفْسٌ قَبْرٌ':Added, #1: 1	نَفْسُ الْقَبْرِ
u'نَفْسٌ قَبْرٌ':Added, #1: 1	نَفْسِ الْقَبْرِ
u'نَفْسٌ قَبْضٌ':Added, #1: 1	نَفْسَ قَبْرِهِ
u'نَفْسٌ قَبْضٌ':Added, #1: 1	نَفْسَ الْقَبْضِ
u'نَفْسٌ قَبُولٌ':Added, #2: 2	نَفْسِ الْقَبْضِ
u'نَفْسٌ قتل':Added, #1: 1	نَفْسَ الْقَبُولِ
u'نَفْسٌ قَتْلٌ':Added, #1: 1	نَفْسَ الْقَتْلِ
u'نَفْسٌ قتل':Added, #1: 1	نَفْسَ الْقَتْلِ
u'نَفْسٌ قَتْلٌ':Added, #3: 3	نَفْسِ الْقَتْلِ
u'نَفْسٌ قذف':Added, #3: 3	نَفْسِ الْقَتْلِ
u'نَفْسٌ قذف':Added, #1: 1	نَفْسَ الْقَذْفِ
u'نَفْسٌ قذف':Added, #1: 1	نَفْسُ الْقَذْفِ
u'نَفْسٌ قَذْفٌ':Added, #1: 1	نَفْسِ الْقَذْفِ
u'نَفْسٌ قَذْفٌ':Added, #1: 1	نَفْسَ الْقَذْفِ
u'نَفْسٌ قَذْفٌ':Added, #1: 1	نَفْسُ الْقَذْفِ
u'نَفْسٌ قِرَاءةٌ':Added, #1: 1	نَفْسِ الْقَذْفِ
u'نَفْسٌ قِرَاءةٌ':Added, #1: 1	نَفْسُ الْقِرَاءَةِ
u'نَفْسٌ قرار':Added, #1: 1	نَفْسِ الْقِرَاءَةِ
u'نَفْسٌ قَرَارٌ':Added, #1: 1	نَفْسِ الْقَرَارِ
u'نَفْسٌ قُرْبٌ':Added, #1: 1	نَفْسِ الْقَرَارِ
u'نَفْسٌ قُرْبٌ':Added, #1: 1	نَفْسِ الْقُرْبِ
u'نَفْسٌ قَرْضٌ':Added, #2: 2	نَفْسُ قُرْبِ
u'نَفْسٌ قُرُوشٌ':Added, #1: 1	نَفْسَ الْقَرْضِ
u'نَفْسٌ قَرْيَةٌ':Added, #1: 1	نَفْسَ الْقُرُوشِ
u'نَفْسٌ قَضَاءٌ':Added, #1: 1	نَفْسُ الْقَرْيَةِ
u'نَفْسٌ قَضَاءٌ':Added, #11: 11	نَفْسِ الْقَضَاءِ
u'نَفْسٌ قَضَاءٌ':Added, #5: 5	نَفْسَ الْقَضَاءِ
u'نَفْسٌ قَطْعٌ':Added, #8: 8	نَفْسُ الْقَضَاءِ
u'نَفْسٌ قَنَاةٌ':Added, #1: 1	نَفْسَ الْقَطْعِ
u'نَفْسٌ قَهْرٌ':Added, #2: 2	نَفْسَ الْقَنَاةِ
u'نَفْسٌ قول':Added, #1: 1	نَفْسِ الْقَهْرِ
u'نَفْسٌ قَوْلٌ':Added, #1: 1	نَفْسُ الْقَوْلِ
u'نَفْسٌ قول':Added, #1: 1	نَفْسُ الْقَوْلِ
u'نَفْسٌ قَوْلٌ':Added, #2: 2	نَفْسِ قَوْلِهِ
u'نَفْسٌ قِيَاسٌ':Added, #2: 2	نَفْسِ قَوْلِهِ
u'نَفْسٌ قيام':Added, #1: 1	نَفْسُ الْقِيَاسِ
u'نَفْسٌ قيام':Added, #1: 1	نَفْسُ الْقِيَامِ
u'نَفْسٌ قِيَامٌ':Added, #1: 1	نَفْسِ الْقِيَامِ
u'نَفْسٌ قِيَامٌ':Added, #1: 1	نَفْسُ الْقِيَامِ
u'نَفْسٌ قيام':Added, #1: 1	نَفْسِ الْقِيَامِ
u'نَفْسٌ قِيَامٌ':Added, #2: 2	نَفْسَ الْقِيَامِ
u'نَفْسٌ كِتَابٌ':Added, #2: 2	نَفْسَ الْقِيَامِ
u'نَفْسٌ كِتَابَةٌ':Added, #1: 1	نَفْسُ الْكِتَابِ
u'نَفْسٌ كرش':Added, #1: 1	نَفْسِ الْكِتَابَةِ
u'نَفْسٌ كَرِشٌ':Added, #1: 1	نَفْسِ الْكَرِشِ
u'نَفْسٌ كعبة':Added, #1: 1	نَفْسِ الْكَرِشِ
u'نَفْسٌ كَعْبَةٌ':Added, #1: 1	نَفْسُ الْكَعْبَةِ
u'نَفْسٌ كفر':Added, #1: 1	نَفْسُ الْكَعْبَةِ
u'نَفْسٌ كُفْرٌ':Added, #2: 2	نَفْسَ الْكُفْرِ
u'نَفْسٌ كَفِيلٌ':Added, #2: 2	نَفْسَ الْكُفْرِ
u'نَفْسٌ كَلاَمٌ':Added, #1: 1	نَفْسُ الْكَفِيلِ
u'نَفْسٌ كَلاَمٌ':Added, #1: 1	نَفْسُ الْكَلَامِ
u'نَفْسٌ كَلاَمٌ':Added, #1: 1	نَفْسُ كَلَامِ
u'نَفْسٌ كَلاَمٌ':Added, #1: 1	نَفْسِ كَلَامِ
u'نَفْسٌ كَلاَمٌ':Added, #1: 1	نَفْسِ كَلَامِهِ
u'نَفْسٌ كَلِمَةٌ':Added, #5: 5	نَفْسِ الْكَلَامِ
u'نَفْسٌ كَلِمَةٌ':Added, #1: 1	نَفْسُ الْكَلِمَةِ
u'نَفْسٌ كُمٌّ':Added, #1: 1	نَفْسِ الْكَلِمَةِ
u'نَفْسٌ كَوْنٌ':Added, #1: 1	نَفْسُ الْكُمِّ
u'نَفْسٌ كَيْلٌ':Added, #1: 1	نَفْسَ كَوْنِ
u'نَفْسٌ لِبَاسٌ':Added, #1: 1	نَفْسِ الْكَيْلِ
u'نَفْسٌ لبس':Added, #1: 1	نَفْسَ اللِّبَاسِ
u'نَفْسٌ لُبْسٌ':Added, #1: 1	نَفْسِ اللُّبْسِ
u'نَفْسٌ لبس':Added, #1: 1	نَفْسِ اللُّبْسِ
u'نَفْسٌ لُبْسٌ':Added, #1: 1	نَفْسُ لُبْسِ
u'نَفْسٌ لَحْدٌ':Added, #1: 1	نَفْسُ لُبْسِ
u'نَفْسٌ لَحْدٌ':Added, #1: 1	نَفْسُ اللَّحْدِ
u'نَفْسٌ لُغَةٌ':Added, #1: 1	نَفْسِ اللَّحْدِ
u'نَفْسٌ لَفْظٌ':Added, #1: 1	نَفْسِ اللُّغَةِ
u'نَفْسٌ لَفْظٌ':Added, #1: 1	نَفْسَ اللَّفْظِ
u'نَفْسٌ لَفْظٌ':Added, #1: 1	نَفْسُ اللَّفْظِ
u'نَفْسٌ لقطة':Added, #9: 9	نَفْسِ اللَّفْظِ
u'نَفْسٌ لقطة':Added, #1: 1	نَفْسَ اللُّقَطَةِ
u'نَفْسٌ لَقِيطٌ':Added, #1: 1	نَفْسِ اللُّقَطَةِ
u'نَفْسٌ لَمْسٌ':Added, #1: 1	نَفْسِ اللَّقِيطِ
u'نَفْسٌ مَالٌ':Added, #2: 2	نَفْسِ اللَّمْسِ
u'نَفْسٌ مَالِكٌ':Added, #1: 1	نَفْسٍ مَالٍ
u'نَفْسٌ مَالِكٌ':Added, #1: 1	نَفْسُ الْمَالِكِ
u'نَفْسٌ مَالِكٌ':Added, #1: 1	نَفْسَ مَالِكِهِ
u'نَفْسٌ مَأْمُورٌ':Added, #1: 1	نَفْسِ مَالِكِهِ
u'نَفْسٌ مُبَاحٌ':Added, #1: 1	نَفْسِ الْمَأْمُورِ
u'نَفْسٌ مُبَاشِرٌ':Added, #1: 1	نَفْسِ الْمُبَاحِ
u'نَفْسٌ مُبَاشَرَةٌ':Added, #1: 1	نَفْسِ الْمُبَاشِرِ
u'نَفْسٌ مَبِيعٌ':Added, #1: 1	نَفْسَ الْمُبَاشَرَةِ
u'نَفْسٌ مُتَصَدِّق':Added, #16: 16	نَفْسِ الْمَبِيعِ
u'نَفْسٌ مُتَعَلِّمٌ':Added, #1: 1	نَفْسَ الْمُتَصَدِّقِ
u'نَفْسٌ مُتَنازَع':Added, #1: 1	نَفْسِ الْمُتَعَلِّمِ
u'نَفْسٌ مُتَنَاوَلٌ':Added, #2: 2	نَفْسُ الْمُتَنَازَعِ
u'نَفْسٌ مَجَازِيٌّ':Added, #1: 1	نَفْسِ الْمُتَنَاوَلِ
u'نَفْسٌ مُجْتَهِد':Added, #1: 1	نَفْسِ الْمَجَازِيِّ
u'نَفْسٌ مُجْتَهِد':Added, #1: 1	نَفْسُ الْمُجْتَهِدِ
u'نَفْسٌ مَجْنِيٌّ':Added, #8: 8	نَفْسِ الْمُجْتَهِدِ
u'نَفْسٌ مُحَاسَبَةٌ':Added, #7: 7	نَفْسِ الْمَجْنِيِّ
u'نَفْسٌ مُحَرَّمٌ':Added, #1: 1	نَفْسِ الْمُحَاسَبَاتِ
u'نَفْسٌ مُحَرَّمٌ':Added, #1: 1	نَفْسُ الْمُحَرَّمِ
u'نَفْسٌ مَحْكُومٌ':Added, #1: 1	نَفْسِ الْمُحَرَّمِ
u'نَفْسٌ مُحَمَّدٌ':Added, #1: 1	نَفْسُ الْمَحْكُومِ
u'نَفْسٌ مُحَمَّدٌ':Added, #1: 1	نَفْسِ مُحَمّدِ
u'نَفْسٌ مُحَمَّدٌ':Added, #39: 39	نَفْسُ مُحَمَّدٍ
u'نَفْسٌ مَحْمُولٌ':Added, #7: 7	نَفْسُ مُحَمّدٍ
u'نَفْسٌ مَخْرَجٌ':Added, #1: 1	نَفْسَ الْمَحْمُولِ
u'نَفْسٌ مَخْرَجٌ':Added, #1: 1	نَفْسَ الْمَخْرَجِ
u'نَفْسٌ مَخْلُوطٌ':Added, #2: 2	نَفْسِ الْمَخْرَجِ
u'نَفْسٌ مُدَّةٌ':Added, #1: 1	نَفْسِ الْمَخْلُوطِ
u'نَفْسٌ مَدْلُولٌ':Added, #1: 1	نَفْسِ الْمُدَّةِ
u'نَفْسٌ مَدْلُولٌ':Added, #1: 1	نَفْسِ الْمَدْلُولِ
u'نَفْسٌ مَدْيُونٌ':Added, #1: 1	نَفْسَ مَدْلُولِهِ
u'نَفْسٌ مُرْتَهِنٌ':Added, #1: 1	نَفْسِ الْمَدْيُونِ
u'نَفْسٌ مَرْجِعٌ':Added, #2: 2	نَفْسِ الْمُرْتَهِنِ
u'نَفْسٌ مَرِيضٌ':Added, #1: 1	نَفْسُ مَرْجِعِهِ
u'نَفْسٌ مَسَاجِدُ':Added, #1: 1	نَفْسَ الْمَرِيضِ
u'نَفْسٌ مَسْأَلَةٌ':Added, #1: 1	نَفْسِ الْمَسَاجِدِ
u'نَفْسٌ مَسْأَلَةٌ':Added, #1: 1	نَفْسِ الْمَسْأَلَةِ
u'نَفْسٌ مُسْتَرِيب':Added, #1: 1	نَفْسِ مَسْأَلَةِ
u'نَفْسٌ مَسْجِدٌ':Added, #1: 1	نَفْسِ الْمُسْتَرِيبِ
u'نَفْسٌ مَسْجِدٌ':Added, #1: 1	نَفْسُ الْمَسْجِدِ
u'نَفْسٌ مَسْحٌ':Added, #2: 2	نَفْسِ الْمَسْجِدِ
u'نَفْسٌ مَطْلُوبٌ':Added, #1: 1	نَفْسُ مَسْحِ
u'نَفْسٌ مَطْلُوبٌ':Added, #2: 2	نَفْسَ الْمَطْلُوبِ
u'نَفْسٌ مُعْتَقٌ':Added, #2: 2	نَفْسِ الْمَطْلُوبِ
u'نَفْسٌ مَعْتُوهٌ':Added, #1: 1	نَفْسُ الْمُعْتَقِ
u'نَفْسٌ مَعِدَةٌ':Added, #1: 1	نَفْسِ الْمَعْتُوهِ
u'نَفْسٌ مَعْصُومٌ':Added, #1: 1	نَفْسِ الْمَعِدَةِ
u'نَفْسٌ مَعْقُودٌ':Added, #1: 1	نَفْسِ مَعْصُومَةٍ
u'نَفْسٌ مُعَلَّقٌ':Added, #1: 1	نَفْسُ الْمَعْقُودِ
u'نَفْسٌ مُعَلِّمٌ':Added, #1: 1	نَفْسِ الْمُعَلَّقِ
u'نَفْسٌ مَغْفِرَةٌ':Added, #1: 1	نَفْسِ الْمُعَلِّمِ
u'نَفْسٌ مَفْهُومٌ':Added, #1: 1	نَفْسَ الْمَغْفِرَةِ
u'نَفْسٌ مَفْهُومٌ':Added, #1: 1	نَفْسِ الْمَفْهُومِ
u'نَفْسٌ مُقاسَمَة':Added, #1: 1	نَفْسَ مَفْهُومِهِ
u'نَفْسٌ مُقَامٌ':Added, #1: 1	نَفْسُ الْمُقَاسَمَةِ
u'نَفْسٌ مَقْبُوضٌ':Added, #1: 1	نَفْسِ الْمُقَامِ
u'نَفْسٌ مَقْتُولٌ':Added, #1: 1	نَفْسِ الْمَقْبُوضِ
u'نَفْسٌ مَقْصُودٌ':Added, #2: 2	نَفْسِ الْمَقْتُولِ
u'نَفْسٌ مُكْرَهٌ':Added, #1: 1	نَفْسِ الْمَقْصُودِ
u'نَفْسٌ مَكْفُولٌ':Added, #3: 3	نَفْسِ الْمُكْرَهِ
u'نَفْسٌ مُلْتَقِط':Added, #5: 5	نَفْسِ الْمَكْفُولِ
u'نَفْسٌ مِلْكٌ':Added, #1: 1	نَفْسِ الْمُلْتَقِطِ
u'نَفْسٌ مِلْكٌ':Added, #2: 2	نَفْسَ الْمِلْكِ
u'نَفْسٌ مَمْنُوعٌ':Added, #4: 4	نَفْسِ الْمِلْكِ
u'نَفْسٌ مَنْبُوذٌ':Added, #1: 1	نَفْسُ الْمَمْنُوعِ
u'نَفْسٌ مَنْذُور':Added, #1: 1	نَفْسُ الْمَنْبُوذِ
u'نَفْسٌ مَنْفَعَةٌ':Added, #1: 1	نَفْسَ الْمَنْذُورِ
u'نَفْسٌ مَنْفَعَةٌ':Added, #1: 1	نَفْسِ الْمَنْفَعَةِ
u'نَفْسٌ مَنْهِيٌّ':Added, #2: 2	نَفْسِ مَنْفَعَتِهِ
u'نَفْسٌ مَهْرٌ':Added, #1: 1	نَفْسِ الْمَنْهِيِّ
u'نَفْسٌ مَوَاهِبُ':Added, #1: 1	نَفْسِ الْمَهْرِ
u'نَفْسٌ مُؤَثِّرٌ':Added, #1: 1	نَفْسُ الْمَوَاهِبِ
u'نَفْسٌ مَوْرِدٌ':Added, #1: 1	نَفْسِ الْمُؤَثِّرِ
u'نَفْسٌ مَوْضِعٌ':Added, #1: 1	نَفْسِ مَوْرِدِ
u'نَفْسٌ مَوْضِعٌ':Added, #1: 1	نَفْسَ الْمَوْضِعِ
u'نَفْسٌ مَوْعُودٌ':Added, #1: 1	نَفْسِ الْمَوْضِعِ
u'نَفْسٌ مُوَكِّلٌ':Added, #1: 1	نَفْسَ الْمَوْعُودِ
u'نَفْسٌ مُوَكِّلٌ':Added, #1: 1	نَفْسَ مُوَكِّلَتِهِ
u'نَفِسَ مَوْلُودٌ':Subject, #1: 1	نَفْسِ مُوَكِّلِهِ
u'نَفْسٌ مُؤْمِنٌ':Added, #1: 1	نَفِسَ الْمَوْلُودُ
u'نَفْسٌ مُؤْمِنٌ':Added, #13: 13	نَفْسُ الْمُؤْمِنِ
u'نَفْسٌ مُؤْمِنٌ':Added, #1: 1	نَفْسَ الْمُؤْمِنِ
u'نَفْسٌ مُؤْمِنٌ':Added, #1: 1	نَفْسٍ مُؤْمِنٍ
u'نَفْسٌ مُؤْمِنٌ':Added, #1: 1	نَفْسَ مُؤْمِنٍ
u'نَفْسٌ مُؤْمِنٌ':Added, #3: 3	نَفْسِ مُؤْمِنٍ
u'نَفْسٌ مَوْهُوبٌ':Added, #6: 6	نَفْسِ الْمُؤْمِنِ
u'نَفْسٌ مَيْتٌ':Added, #1: 1	نَفْسِ الْمَوْهُوبِ
u'نَفْسٌ مَيْتَةٌ':Added, #1: 1	نَفْسُ الْمَيْتَةِ
u'نَفْسٌ مِيزَانٌ':Added, #1: 1	نَفْسُ الْمَيْتَةِ
u'نَفْسٌ مِيقَاتٌ':Added, #1: 1	نَفْسِ الْمِيزَانِ
u'نَفْسٌ نَاسِخٌ':Added, #1: 1	نَفْسِ الْمِيقَاتِ
u'نَفْسٌ نَاسِخ':Added, #1: 1	نَفْسُ النَّاسِخِ
u'نَفْسٌ نَاظِرٌ':Added, #1: 1	نَفْسُ النَّاسِخِ
u'نَفْسٌ نُبُوَّةٌ':Added, #1: 1	نَفْسُ النَّاظِرِ
u'نَفْسٌ نُبُوَّةٌ':Added, #1: 1	نَفْسِ النُّبُوَّاتِ
u'نَفْسٌ نَبِيٌّ':Added, #1: 1	نَفْسِ النُّبُوَّةِ
u'نَفْسٌ نَجَاسَةٌ':Added, #3: 3	نَفْسِ النَّبِيِّ
u'نَفْسٌ نَجَاسَةٌ':Added, #1: 1	نَفْسَ النَّجَاسَةِ
u'نَفْسٌ نذر':Added, #1: 1	نَفْسِ النَّجَاسَةِ
u'نَفْسٌ نَذْرٌ':Added, #1: 1	نَفْسَ النَّذْرِ
u'نَفْسٌ نِسْبَةٌ':Added, #1: 1	نَفْسَ النَّذْرِ
u'نَفْسٌ نَصٌّ':Added, #1: 1	نَفْسِ النِّسْبَةِ
u'نَفْسٌ نَصِيبٌ':Added, #1: 1	نَفْسُ النَّصِّ
u'نَفْسٌ نَظْمٌ':Added, #1: 1	نَفْسَ نَصِيبِهِ
u'نَفْسٌ نَفْسِيٌّ':Added, #1: 1	نَفْسِ النَّظْمِ
u'نَفْسٌ نَفَقَةٌ':Added, #1: 1	نَفْسُ النَّفْسِيِّ
u'نَفْسٌ نكاح':Added, #1: 1	نَفْسِ النَّفَقَةِ
u'نَفْسٌ نِكَاحٌ':Added, #1: 1	نَفْسُ النِّكَاحِ
u'نَفْسٌ نكاح':Added, #1: 1	نَفْسُ النِّكَاحِ
u'نَفْسٌ نِكَاحٌ':Added, #2: 2	نَفْسَ النِّكَاحِ
u'نَفْسٌ نكاح':Added, #2: 2	نَفْسَ النِّكَاحِ
u'نَفْسٌ نِكَاحٌ':Added, #5: 5	نَفْسِ النِّكَاحِ
u'نَفْسٌ نِيَّةٌ':Added, #5: 5	نَفْسِ النِّكَاحِ
u'نَفْسٌ نِيَّةٌ':Added, #1: 1	نَفْسَ النِّيَّةِ
u'نَفْسٌ هِبَةٌ':Added, #1: 1	نَفْسِ النِّيَّةِ
u'نَفْسٌ هَوَاءٌ':Added, #1: 1	نَفْسِ الْهِبَةِ
u'نَفْسٌ وَاجِبٌ':Added, #1: 1	نَفْسِ الْهَوَاءِ
u'نَفْسٌ وَاجِبٌ':Added, #1: 1	نَفْسُ الْوَاجِبِ
u'نَفْسٌ واحد':Added, #3: 3	نَفْسِ الْوَاجِبِ
u'نَفْسٌ وَاحِدٌ':Added, #1: 1	نَفْسِ وَاحِدٍ
u'نَفَسٌ واحد':Added, #1: 1	نَفْسِ وَاحِدٍ
u'نَفَسٌ وَاحِدٌ':Added, #6: 6	نَفَسٍ وَاحِدٍ
u'نَفْسٌ وَاقِعٌ':Added, #6: 6	نَفَسٍ وَاحِدٍ
u'نَفْسٌ وَاقِفٌ':Added, #1: 1	نَفْسِ الْوَاقِعِ
u'نَفْسٌ وَاهِبٌ':Added, #1: 1	نَفْسِ الْوَاقِفِ
u'نَفْسٌ وُجُوبٌ':Added, #1: 1	نَفْسِ الْوَاهِبِ
u'نَفْسٌ وُجُوبٌ':Added, #1: 1	نَفْسَ الْوُجُوبِ
u'نَفْسٌ وُجُوبٌ':Added, #1: 1	نَفْسَ وُجُوبِ
u'نَفْسٌ وُجُوبٌ':Added, #1: 1	نَفْسُ وُجُوبِهِ
u'نَفْسٌ وُجُوبٌ':Added, #2: 2	نَفْسُ وُجُوبِ
u'نَفْسٌ وُجُوبٌ':Added, #2: 2	نَفْسِ وُجُوبِهِ
u'نَفْسٌ وُجُوبٌ':Added, #7: 7	نَفْسُ الْوُجُوبِ
u'نَفْسٌ وُجُودٌ':Added, #9: 9	نَفْسِ الْوُجُوبِ
u'نَفْسٌ وُجُودٌ':Added, #1: 1	نَفْسِ الْوُجُودِ
u'نَفْسٌ وُجُودٌ':Added, #1: 1	نَفْسِ وُجُودِهِ
u'نَفْسٌ وُرُودٌ':Added, #2: 2	نَفْسُ وُجُودِ
u'نَفْسٌ وَصْفٌ':Added, #1: 1	نَفْسِ وُرُودِ
u'نَفْسٌ وَصْفٌ':Added, #1: 1	نَفْسُ وَصْفِ
u'نَفْسٌ وَصِيٌّ':Added, #6: 6	نَفْسِ الْوَصْفِ
u'نَفْسٌ وَصِيَّةٌ':Added, #2: 2	نَفْسِ الْوَصِيَّةِ
u'نَفْسٌ وَضْعٌ':Added, #2: 2	نَفْسِ الْوَصِيَّةِ
u'نَفْسٌ وَضْعٌ':Added, #1: 1	نَفْسَ وَضْعِ
u'نَفْسٌ وُضُوءٌ':Added, #1: 1	نَفْسِ وَضْعِ
u'نَفْسٌ وَطْءٌ':Added, #1: 1	نَفْسِ الْوُضُوءِ
u'نَفْسٌ وَطْءٌ':Added, #1: 1	نَفْسَ الْوَطْءِ
u'نَفْسٌ وِعَاءٌ':Added, #2: 2	نَفْسِ الْوَطْءِ
u'نَفْسٌ وقاع':Added, #1: 1	نَفْسَ الْوِعَاءِ
u'نَفْسٌ وَقْتٌ':Added, #2: 2	نَفْسُ الْوِقَاعِ
u'نَفْسٌ وُقُوعٌ':Added, #1: 1	نَفْسِ الْوَقْتِ
u'نَفْسٌ وُقُوعٌ':Added, #1: 1	نَفْسَ الْوُقُوعِ
u'نَفْسٌ وُقُوفٌ':Added, #1: 1	نَفْسِ الْوُقُوعِ
u'نَفْسٌ وَلاَءٌ':Added, #1: 1	نَفْسَ الْوُقُوفِ
u'نَفْسٌ وِلاَدَةٌ':Added, #1: 1	نَفْسِ الْوَلَاءِ
u'نَفْسٌ وِلاَدَةٌ':Added, #2: 2	نَفْسُ الْوِلَادَةِ
u'نَفْسٌ ولد':Added, #5: 5	نَفْسِ الْوِلَادَةِ
u'نَفْسٌ وَلَدٌ':Added, #1: 1	نَفْسَ وَلَدِ
u'نَفْسٌ ولد':Added, #1: 1	نَفْسَ وَلَدِ
u'نَفْسٌ وَلَدٌ':Added, #4: 4	نَفْسِ الْوَلَدِ
u'نَفْسٌ يَمِينٌ':Added, #4: 4	نَفْسِ الْوَلَدِ
u'نَفْسٌ يَمِينٌ':Added, #1: 1	نَفْسُ الْيَمِينِ
u'نَفْسٌ يَوْمٌ':Added, #4: 4	نَفْسِ الْيَمِينِ
u'نَفْضٌ أَدِيمٌ':Added, #1: 1	نَفْسَ يَوْمٍ
u'نَفْضٌ تُرَابٌ':Added, #1: 1	نَفْضَ الأَدِيمِ
u'نَفْضٌ تُرَابٌ':Added, #1: 1	نَفْضُ التُّرَابِ
u'نَفْضٌ ثَوْبٌ':Added, #1: 1	نَفْضِ التُّرَابِ
u'نَفْضٌ ثَوْبٌ':Added, #1: 1	نَفْضَ الثَّوْبِ
u'نَفْضٌ زَيْتونٌ':Added, #2: 2	نَفْضِ الثَّوْبِ
u'نَفْضٌ مَاءٌ':Added, #1: 1	نَفْضِ زَيْتُونٍ
u'نَفْضٌ يَدٌ':Added, #1: 1	نَفْضُ الْمَاءِ
u'نَفْضٌ يَدٌ':Added, #1: 1	نَفْضَ الْيَدِ
u'نَفْضٌ يَدٌ':Added, #1: 1	نَفْضُ الْيَدَيْنِ
u'نَفْضٌ يَدٌ':Added, #1: 1	نَفْضِ الْيَدَيْنِ
u'نَفْعٌ إِجَابَةٌ':Added, #1: 1	نَفْضُ يَدِهِ
u'نَفْعٌ أحَدٌ':Added, #1: 1	نَفْعَ الْإِجَابَةِ
u'نَفْعٌ إحْسَانٌ':Added, #1: 1	نَفْعِ أَحَدِ
u'نَفْعٌ إِخْوَانٌ':Added, #1: 1	نَفْعَ إحْسَانِهِ
u'نَفْعٌ أَدَاءٌ':Added, #1: 1	نَفْعَ الْإِخْوَانِ
u'نَفْعٌ إِرْثٌ':Added, #1: 1	نَفْعَ الْأَدَاءِ
u'نَفْعٌ أرْضٌ':Added, #1: 1	نَفْعَ الْإِرْثِ
u'نَفْعٌ أرْضٌ':Added, #1: 1	نَفْعَ الْأَرْضِ
u'نَفْعٌ أَعْمَالٌ':Added, #1: 1	نَفْعُ الْأَرْضِ
u'نَفَعَ إقْرَارٌ':Subject, #1: 1	نَفْعِ الْأَعْمَالِ
u'نَفْعٌ إِلْقَاءٌ':Added, #1: 1	نَفَعَ إقْرَارُهُ
u'نَفَعَ المُشْتَرِي':Predicate, #1: 1	نَفْعِ الْإِلْقَاءِ
u'نَفْعٌ أهْلٌ':Added, #1: 1	نَفَعَ الْمُشْتَرِيَ
u'نَفْعٌ أَوَّلُ':Added, #1: 1	نَفْعِ أَهْلِ
u'نَفْعٌ بَائِعٌ':Added, #1: 1	نَفْعَ الْأَوَّلِ
u'نَفْعٌ بَائِعٌ':Added, #1: 1	نَفْعُ الْبَائِعِ
u'نَفْعٌ بَائِعٌ':Added, #1: 1	نَفْعِ الْبَائِعِ
u'نَفْعٌ بَائِعٌ':Added, #2: 2	نَفْعَ بَائِعٍ
u'نَفْعٌ بدن':Added, #5: 5	نَفْعَ الْبَائِعِ
u'نَفْعٌ بَدَنٌ':Added, #1: 1	نَفْعُ الْبَدَنِ
u'نَفْعٌ بَقاءٌ':Added, #1: 1	نَفْعُ الْبَدَنِ
u'نَفَعَ بَلاءٌ':Subject, #1: 1	نَفْعُ بَقَاءِ
u'نَفْعٌ بِئْرٌ':Added, #1: 1	نَفَعَ الْبَلَاءُ
u'نَفْعٌ بِئْرٌ':Added, #1: 1	نَفْعِ الْبِئْرِ
u'نَفْعٌ بِئْرٌ':Added, #1: 1	نَفْعَ بِئْرٍ
u'نَفْعٌ تَحْلِيف':Added, #1: 1	نَفْعُ بِئْرٍ
u'نَفْعٌ تَخْفِيفٌ':Added, #1: 1	نَفْعِ التَّحْلِيفِ
u'نَفْعٌ تَوْسِعَة':Added, #1: 1	نَفْعُ التَّخْفِيفِ
u'نَفْعٌ ثَوابٌ':Added, #1: 1	نَفْعُ تَوْسِعَةِ
u'نَفْعٌ جَائِزٌ':Added, #1: 1	نَفْعِ الثَّوَابِ
u'نَفْعٌ جَمَاعَةٌ':Added, #2: 2	نَفْعٍ جَائِزٍ
u'نَفْعٌ خَصْمٌ':Added, #1: 1	نَفْعِ الْجَمَاعَةِ
u'نَفْعٌ خَطٌّ':Added, #1: 1	نَفْعَ خَصْمِهِ
u'نَفْعٌ خلق':Added, #1: 1	نَفْعُ خَطِّهِ
u'نَفْعٌ خَلْقٌ':Added, #1: 1	نَفْعَ الْخَلْقِ
u'نَفْعٌ دَارٌ':Added, #1: 1	نَفْعَ الْخَلْقِ
u'نَفْعٌ دُعَاءٌ':Added, #2: 2	نَفْعِ دَارِهِ
u'نَفْعٌ دَواءٌ':Added, #1: 1	نَفْعِ الدُّعَاءِ
u'نَفْعٌ ذُرِّيَّةٌ':Added, #1: 1	نَفْعَ الدَّوَاءِ
u'نَفْعٌ رَقيقٌ':Added, #1: 1	نَفْعَ الذُّرِّيَّةِ
u'نَفْعٌ رَقيقٌ':Added, #1: 1	نَفْعَ الرَّقِيقِ
u'نَفْعٌ رَقيق':Added, #1: 1	نَفْعُ الرَّقِيقِ
u'نَفْعٌ رَقيق':Added, #1: 1	نَفْعَ الرَّقِيقِ
u'نَفْعٌ سَائِرٌ':Added, #1: 1	نَفْعُ الرَّقِيقِ
u'نَفْعٌ سَقْي':Added, #1: 1	نَفْعِ سَائِرِ
u'نَفْعٌ سَيِّدٌ':Added, #1: 1	نَفْعُ السَّقْيَاتِ
u'نَفْعٌ شَاهِدٌ':Added, #1: 1	نَفْعَ سَيِّدِهِ
u'نَفْعٌ شَرِيكٌ':Added, #1: 1	نَفْعَ الشَّاهِدِ
u'نَفْعٌ صَاحِبٌ':Added, #1: 1	نَفْعِ الشَّرِيكِ
u'نَفْعٌ صَحِيحٌ':Added, #1: 1	نَفْعَ صَاحِبِهِ
u'نَفْعٌ صَدْرٌ':Added, #1: 1	نَفْعِ الصَّحِيحَةِ
u'نَفْعٌ طَالِبٌ':Added, #1: 1	نَفْعَ الصَّدْرِ
u'نَفْعٌ طَالِبٌ':Added, #1: 1	نَفْعِ الطَّالِبِ
u'نَفْعٌ ظاهِرٌ':Added, #4: 4	نَفْعُ الطَّالِبِ
u'نَفْعٌ عَاقِدٌ':Added, #1: 1	نَفْعٍ ظَاهِرٍ
u'نَفْعٌ عَالَمٌ':Added, #2: 2	نَفْعُ الْعَاقِدِ
u'نَفْعٌ عَامٌّ':Added, #2: 2	نَفْعُ الْعَالَمِ
u'نَفْعٌ عَامٌّ':Added, #1: 1	نَفْعِ الْعَامَّةِ
u'نَفْعٌ عِبَادٌ':Added, #1: 1	نَفْعٍ عَامٍّ
u'نَفْعٌ عِبَادٌ':Added, #1: 1	نَفْعِ الْعِبَادِ
u'نَفْعٌ عَبْدٌ':Added, #5: 5	نَفْعُ الْعِبَادِ
u'نَفْعٌ عَمَلٌ':Added, #2: 2	نَفْعُ الْعَبْدِ
u'نَفْعٌ عين':Added, #2: 2	نَفْعَ عَمَلِهِ
u'نَفْعٌ عَيْنٌ':Added, #1: 1	نَفْعِ الْعَيْنِ
u'نَفْعٌ عَيْن':Added, #1: 1	نَفْعِ الْعَيْنِ
u'نَفْعٌ غير':Added, #1: 1	نَفْعِ الْعَيْنِ
u'نَفْعٌ غير':Added, #1: 1	نَفْعُ غَيْرِهِ
u'نَفْعٌ غَيْرٌ':Added, #1: 1	نَفْعِ غَيْرِهِ
u'نَفْعٌ غَيْرٌ':Added, #1: 1	نَفْعُ غَيْرِهِ
u'نَفْعٌ فقراء':Added, #1: 1	نَفْعِ غَيْرِهِ
u'نَفْعٌ فَقِيرٌ':Added, #2: 2	نَفْعُ الْفُقَرَاءِ
u'نَفَعَ فُلاَنٌ':Subject, #1: 1	نَفْعُ الْفَقِيرِ
u'نَفَعَ قلب':Predicate, #1: 1	نَفَعَ فُلَانٌ
u'نَفَعَ قَلْبٌ':Predicate, #1: 1	نَفَعَ الْقَلْبَ
u'نَفَعَ قَلْب':Predicate, #1: 1	نَفَعَ الْقَلْبَ
u'نَفَعَ قَلِيلٌ':Subject, #1: 1	نَفَعَ الْقَلْبَ
u'نَفْعٌ مَاءٌ':Added, #1: 1	نَفَعَ قَلِيلُهُ
u'نَفْعٌ مَالٌ':Added, #1: 1	نَفْعِ الْمَاءِ
u'نَفْعٌ مَالٌ':Added, #1: 1	نَفْعَ الْمَالِ
u'نَفْعٌ مَالٌ':Added, #1: 1	نَفْعِ مَالِ
u'نَفْعٌ مَالِيٌّ':Added, #1: 1	نَفْعُ مَالِهِ
u'نَفْعٌ مُبَاحٌ':Added, #1: 1	نَفْعٍ مَالِيٍّ
u'نَفْعٌ مَبِيعٌ':Added, #2: 2	نَفْعٍ مُبَاحٍ
u'نَفْعٌ مُتَّصِلٌ':Added, #2: 2	نَفْعَ الْمَبِيعِ
u'نَفْعٌ مَرِيضٌ':Added, #1: 1	نَفْعُ مُتَّصِلٍ
u'نَفْعٌ مساكين':Added, #1: 1	نَفْعِ الْمَرِيضِ
u'نَفْعٌ مُسْتَأْجِرٌ':Added, #1: 1	نَفْعُ الْمَسَاكِينِ
u'نَفَعَ مَسْجِدٌ':Predicate, #1: 1	نَفْعَ الْمُسْتَأْجِرِ
u'نَفْعٌ مَسْجِدٌ':Added, #2: 2	نَفَعَ الْمَسْجِدَ
u'نَفَعَ مُشْتَرِي':Predicate, #1: 1	نَفْعَ الْمَسْجِدِ
u'نَفَعَ مَصْرُوعٌ':Predicate, #1: 1	نَفَعَ الْمُشْتَرِيَ
u'نَفْعٌ مُقْتَرِضٌ':Added, #1: 1	نَفَعَ الْمَصْرُوعَ
u'نَفْعٌ مَلْدُوغ':Added, #2: 2	نَفْعُ الْمُقْتَرِضِ
u'نَفْعٌ مَوْقُوفٌ':Added, #1: 1	نَفْعَ الْمَلْدُوغِ
u'نَفْعٌ نَاسٌ':Added, #1: 1	نَفْعَ الْمَوْقُوفِ
u'نَفْعٌ نحلة':Added, #1: 1	نَفْعِ النَّاسِ
u'نَفْعٌ نَحْلَةٌ':Added, #1: 1	نَفْعُ النَّحْلَةِ
u'نَفْعٌ نَحْوٌ':Added, #1: 1	نَفْعُ النَّحْلَةِ
u'نَفْعٌ نَفْسٌ':Added, #1: 1	نَفْعِ نَحْوِ
u'نَفْعٌ نَفَقَةٌ':Added, #3: 3	نَفْعَ نَفْسِهِ
u'نَفْعٌ ه':Added, #1: 1	نَفْعَ النَّفَقَةِ
u'نَفْعٌ هات':Added, #1: 1	نَفْعَ هَاتِ
u'نَفْعٌ وَصِيٌّ':Added, #1: 1	نَفْعَ هَاتِ
u'نَفْعٌ وَصِيَّةٌ':Added, #1: 1	نَفْعِ الْوَصِيَّةِ
u'نَفْعٌ وَقْفٌ':Added, #1: 1	نَفْعِ الْوَصِيَّةِ
u'نَفْعٌ يَدٌ':Added, #1: 1	نَفْعِ الْوَقْفِ
u'نَفْعٌ يَدٌ':Added, #1: 1	نَفْعُ الْيَدِ
u'نَفَقَ حِمَارٌ':Subject, #1: 1	نَفْعِ الْيَدِ
u'نَفَقَ فَرَسٌ':Subject, #1: 1	نَفَقَ حِمَارُهُ
u'نَفَقَ فَرَسٌ':Subject, #2: 2	نَفَقَ فَرَسُ
u'نَفَقَ مَبِيعٌ':Predicate, #2: 2	نَفَقَ فَرَسُهُ
u'نَفَلَ اِبْنٌ':Predicate, #1: 1	نَفَقَ الْمَبِيعَ
u'نَفَّلَ اِبْنٌ':Predicate, #1: 1	نَفَلَ ابْنَ
u'نَفْلٌ أَسْلاَبٌ':Added, #1: 1	نَفَّلَ ابْنَ
u'نَفْلٌ أُمٌّ':Added, #1: 1	نَفْلَ الْأَسْلَابِ
u'نَفَلَ إمَامٌ':Subject, #1: 1	نَفْلِ أُمِّهِ
u'نَفْلٌ أَميرٌ':Added, #6: 6	نَفَلَ الْإِمَامُ
u'نَفْلٌ أهْلٌ':Added, #2: 2	نَفْلُ أَمِيرِ
u'نَفْلٌ أَوَّلُ':Added, #2: 2	نَفْلِ أَهْلِ
u'نَفْلٌ بالِغٌ':Added, #1: 1	نَفْلُ الْأَوَّلِ
u'نَفْلٌ بالِغٌ':Added, #1: 1	نَفْلَ الْبَالِغِ
u'نَفْلٌ بدن':Added, #6: 6	نَفْلِ الْبَالِغِ
u'نَفْلٌ بَدَنٌ':Added, #1: 1	نَفْلِ الْبَدَنِ
u'نَفْلٌ بعثة':Added, #1: 1	نَفْلِ الْبَدَنِ
u'نَفْلٌ بَقِيَّةٌ':Added, #1: 1	نَفْلُ بَعْثَةِ
u'نَفْلٌ تِجْفاف':Added, #1: 1	نَفْلِ بَقِيَّةِ
u'نَفْلٌ ثَالِثٌ':Added, #1: 1	نَفْلُ تِجْفَافَيْنِ
u'نَفْلٌ حَجٌّ':Added, #1: 1	نَفْلُ الثَّالِثِ
u'نَفْلٌ حَجٌّ':Added, #1: 1	نَفْلِ الْحَجِّ
u'نَفْلٌ حَجٌّ':Added, #2: 2	نَفْلُ الْحَجِّ
u'نَفْلٌ رَاتِبٌ':Added, #4: 4	نَفْلَ الْحَجِّ
u'نَفْلٌ رَاتِب':Added, #2: 2	نَفْلٍ رَاتِبٍ
u'نَفَّلَ رُبُعٌ':Predicate, #2: 2	نَفْلٍ رَاتِبٍ
u'نَفَّلَ رُبُعٌ':Subject, #4: 4	نَفَّلَ الرُّبُعَ
u'نَفْلٌ رُبْعٌ':Added, #1: 1	نَفَّلَ الرُّبُعُ
u'نَفَّلَ رَسُولٌ':Subject, #1: 1	نَفْلَ الرُّبْعِ
u'نَفَلَ رَسُولٌ':Subject, #1: 1	نَفَّلَ رَسُولُ
u'نَفْلٌ رَسُولٌ':Added, #3: 3	نَفَلَ رَسُولُ
u'نَفَلَ سَرِيٌّ':Predicate, #1: 1	نَفْلِ رَسُولِ
u'نَفَلَ سَرِيَّةٌ':Predicate, #2: 2	نَفَلَ السَّرِيَّةَ
u'نَفْلٌ سَفَرٌ':Added, #2: 2	نَفَلَ السَّرِيَّةَ
u'نَفَلَ سَلَبٌ':Predicate, #2: 2	نَفْلِ السَّفَرِ
u'نَفْلٌ صَبِيٌّ':Added, #2: 2	نَفَلَ السَّلَبَ
u'نَفْلٌ صَبِيٌّ':Added, #1: 1	نَفْلُ الصَّبِيِّ
u'نَفْلٌ صدقة':Added, #4: 4	نَفْلَ الصَّبِيِّ
u'نَفْلٌ صَدَقَةٌ':Added, #1: 1	نَفْلَ الصَّدَقَةِ
u'نَفْلٌ صَلاَةٌ':Added, #1: 1	نَفْلَ الصَّدَقَةِ
u'نَفْلٌ صَلاَةٌ':Added, #2: 2	نَفْلُ الصَّلَاةِ
u'نَفْلٌ صَلاَةٌ':Added, #2: 2	نَفْلِ الصَّلَاةِ
u'نَفْلٌ صَوْمٌ':Added, #2: 2	نَفْلِ صَلَاةٍ
u'نَفْلٌ صَوْمٌ':Added, #1: 1	نَفْلَ الصَّوْمِ
u'نَفْلٌ صَوْمٌ':Added, #1: 1	نَفْلُ الصَّوْمِ
u'نَفْلٌ طواف':Added, #1: 1	نَفْلِ الصَّوْمِ
u'نَفْلٌ طَوَافٌ':Added, #1: 1	نَفْلِ الطَّوَافِ
u'نَفْلٌ طواف':Added, #1: 1	نَفْلِ الطَّوَافِ
u'نَفْلٌ طَوَافٌ':Added, #2: 2	نَفْلِ طَوَافٍ
u'نَفَلَ عَامِلٌ':Predicate, #2: 2	نَفْلِ طَوَافٍ
u'نَفْلٌ عِبَادَةٌ':Added, #1: 1	نَفَلَ الْعَامِلَ
u'نَفْلٌ عِبَادَةٌ':Added, #1: 1	نَفْلِ الْعِبَادَاتِ
u'نَفْلٌ علم':Added, #1: 1	نَفْلِ الْعِبَادَةِ
u'نَفْلٌ عِلْمٌ':Added, #1: 1	نَفْلَ الْعِلْمِ
u'نَفْلٌ عمرة':Added, #1: 1	نَفْلَ الْعِلْمِ
u'نَفْلٌ عُمْرَةٌ':Added, #1: 1	نَفْلِ الْعُمْرَةِ
u'نَفْلٌ قِرَاءةٌ':Added, #1: 1	نَفْلِ الْعُمْرَةِ
u'نَفْلٌ قِرَاءةٌ':Added, #1: 1	نَفْلِ الْقِرَاءَةِ
u'نَفْلٌ قُرْآنٌ':Added, #1: 1	نَفْلُ قِرَاءَةِ
u'نَفْلٌ لاَزِمٌ':Added, #1: 1	نَفْلِ الْقُرْآنِ
u'نَفْلٌ مُطْلَقٌ':Added, #1: 1	نَفْلٍ لَازِمٍ
u'نَفْلٌ مُعْتَادٌ':Added, #2: 2	نَفْلٍ مُطْلَقٍ
u'نَفْلٌ مُعَيَّنٌ':Added, #2: 2	نَفْلٍ مُعْتَادٍ
u'نَفْلٌ مُؤَكَّدٌ':Added, #2: 2	نَفْلٍ مُعَيَّنٍ
u'نَفْلٌ نهار':Added, #1: 1	نَفْلٍ مُؤَكَّدٍ
u'نَفْلٌ نَهَارٌ':Added, #3: 3	نَفْلِ النَّهَارِ
u'نَفْلٌ وُضُوءٌ':Added, #3: 3	نَفْلِ النَّهَارِ
u'نَفْلٌ وُضُوءٌ':Added, #1: 1	نَفْلِ وُضُوءٍ
u'نُفُوذٌ إجَازَةٌ':Added, #2: 2	نَفْلِ الْوُضُوءِ
u'نُفُوذٌ أَحْكَامٌ':Added, #1: 1	نُفُوذُ إجَازَةِ
u'نُفُوذٌ أَحْكَامٌ':Added, #1: 1	نُفُوذَ أَحْكَامِهِ
u'نُفُوذٌ اِسْتِيلاد':Added, #1: 1	نُفُوذِ أَحْكَامِهِ
u'نُفُوذٌ إِعْتاقٌ':Added, #1: 1	نُفُوذِ اسْتِيلَادِ
u'نُفُوذٌ إقْرَارٌ':Added, #1: 1	نُفُوذِ إعْتَاقِ
u'نُفُوذٌ أَمْرٌ':Added, #2: 2	نُفُوذُ الْإِقْرَارِ
u'نُفُوذٌ أوامر':Added, #1: 1	نُفُوذُ أَمْرٍ
u'نُفُوذٌ أَوامِرُ':Added, #1: 1	نُفُوذِ أَوَامِرِ
u'نُفُوذٌ بَيْعٌ':Added, #1: 1	نُفُوذِ أَوَامِرِ
u'نُفُوذٌ تَبَرُّعٌ':Added, #1: 1	نُفُوذِ الْبَيْعِ
u'نُفُوذٌ تَبَرُّعٌ':Added, #1: 1	نُفُوذَ تَبَرُّعَاتِهِ
u'نُفُوذٌ تَصَرُّفٌ':Added, #1: 1	نُفُوذِ تَبَرُّعِهِ
u'نُفُوذٌ تَصَرُّفٌ':Added, #1: 1	نُفُوذُ تَصَرُّفَاتِهِ
u'نُفُوذٌ تَصَرُّفٌ':Added, #2: 2	نُفُوذُ تَصَرُّفِ
u'نُفُوذٌ تَصَرُّفٌ':Added, #2: 2	نُفُوذِ تَصَرُّفَاتِ
u'نُفُوذٌ تَصَرُّفٌ':Added, #2: 2	نُفُوذَ تَصَرُّفَاتِهِ
u'نُفُوذٌ تَصَرُّفٌ':Added, #3: 3	نُفُوذَ التَّصَرُّفِ
u'نُفُوذٌ تَصَرُّفٌ':Added, #3: 3	نُفُوذَ تَصَرُّفِ
u'نُفُوذٌ تَصَرُّفٌ':Added, #3: 3	نُفُوذِ تَصَرُّفِ
u'نُفُوذٌ تَصَرُّفٌ':Added, #3: 3	نُفُوذَ تَصَرُّفِهِ
u'نُفُوذٌ تَصَرُّفٌ':Added, #4: 4	نُفُوذُ التَّصَرُّفِ
u'نُفُوذٌ تَصَرُّفٌ':Added, #6: 6	نُفُوذِ تَصَرُّفَاتِهِ
u'نُفُوذٌ تَصَرُّفٌ':Added, #6: 6	نُفُوذِ تَصَرُّفِهِ
u'نُفُوذٌ تَصَرُّفٌ':Added, #8: 8	نُفُوذِ التَّصَرُّفِ
u'نُفُوذٌ تَوْلِيَةٌ':Added, #8: 8	نُفُوذُ تَصَرُّفِهِ
u'نُفُوذٌ حَدٌّ':Added, #1: 1	نُفُوذِ تَوْلِيَتِهِ
u'نُفُوذٌ حَقٌّ':Added, #1: 1	نُفُوذِ الْحَدِّ
u'نُفُوذٌ حُكْمٌ':Added, #1: 1	نُفُوذُ الْحَقِّ
u'نُفُوذٌ حُكْمٌ':Added, #1: 1	نُفُوذُ الْحُكْمِ
u'نُفُوذٌ حُكْمٌ':Added, #1: 1	نُفُوذُ حُكْمٍ
u'نُفُوذٌ حُكْمٌ':Added, #1: 1	نُفُوذُ حُكْمِهِ
u'نُفُوذٌ حُكْمٌ':Added, #3: 3	نُفُوذِ حُكْمِ
u'نُفُوذٌ حُكْمٌ':Added, #4: 4	نُفُوذِ حُكْمِهِ
u'نُفُوذٌ حُكْمٌ':Added, #5: 5	نُفُوذِ الْحُكْمِ
u'نُفُوذٌ رَائِحٌ':Added, #5: 5	نُفُوذَ حُكْمِهِ
u'نُفُوذٌ رَائِحَةٌ':Added, #1: 1	نُفُوذُ الرَّائِحَةِ
u'نُفُوذٌ شَيْءٌ':Added, #1: 1	نُفُوذُ الرَّائِحَةِ
u'نُفُوذٌ صدقة':Added, #1: 1	نُفُوذِ شَيْءٍ
u'نُفُوذٌ صَدَقَةٌ':Added, #1: 1	نُفُوذَ الصَّدَقَةِ
u'نُفُوذٌ ضَوْءٌ':Added, #1: 1	نُفُوذَ الصَّدَقَةِ
u'نُفُوذٌ طَلاَقٌ':Added, #1: 1	نُفُوذَ الضَّوْءِ
u'نُفُوذٌ طَلاَقٌ':Added, #1: 1	نُفُوذَ الطَّلَاقِ
u'نُفُوذٌ طَلاَقٌ':Added, #2: 2	نُفُوذَ طَلَاقِهِ
u'نُفُوذٌ طَلاَقٌ':Added, #2: 2	نُفُوذِ طَلَاقِهِ
u'نُفُوذٌ عتق':Added, #4: 4	نُفُوذُ الطَّلَاقِ
u'نُفُوذٌ عِتْقٌ':Added, #12: 12	نُفُوذِ الْعِتْقِ
u'نُفُوذٌ عتق':Added, #12: 12	نُفُوذِ الْعِتْقِ
u'نُفُوذٌ عِتْقٌ':Added, #1: 1	نُفُوذَ عِتْقِ
u'نُفُوذٌ عتق':Added, #1: 1	نُفُوذَ عِتْقِ
u'نُفُوذٌ عتق':Added, #1: 1	نُفُوذَ عِتْقِهِ
u'نُفُوذٌ عِتْقٌ':Added, #1: 1	نُفُوذُ عِتْقِهِ
u'نُفُوذٌ عِتْقٌ':Added, #1: 1	نُفُوذَ عِتْقِهِ
u'نُفُوذٌ عتق':Added, #1: 1	نُفُوذُ عِتْقِهِ
u'نُفُوذٌ عِتْقٌ':Added, #2: 2	نُفُوذُ عِتْقِ
u'نُفُوذٌ عتق':Added, #2: 2	نُفُوذُ عِتْقِ
u'نُفُوذٌ عِتْقٌ':Added, #2: 2	نُفُوذِ عِتْقِهِ
u'نُفُوذٌ عتق':Added, #2: 2	نُفُوذِ عِتْقِهِ
u'نُفُوذٌ عِتْقٌ':Added, #3: 3	نُفُوذُ الْعِتْقِ
u'نُفُوذٌ عتق':Added, #3: 3	نُفُوذُ الْعِتْقِ
u'نُفُوذٌ عِتْقٌ':Added, #6: 6	نُفُوذَ الْعِتْقِ
u'نُفُوذٌ عزل':Added, #6: 6	نُفُوذَ الْعِتْقِ
u'نُفُوذٌ عزل':Added, #1: 1	نُفُوذِ الْعَزْلِ
u'نُفُوذٌ عَقْدٌ':Added, #1: 1	نُفُوذِ عَزْلِهِ
u'نُفُوذٌ عَقْدٌ':Added, #2: 2	نُفُوذُ الْعَقْدِ
u'نُفُوذٌ عُقُودٌ':Added, #2: 2	نُفُوذِ الْعَقْدِ
u'نُفُوذٌ فَسْخٌ':Added, #1: 1	نُفُوذِ الْعُقُودِ
u'نُفُوذٌ فَسْخٌ':Added, #1: 1	نُفُوذِ الْفَسْخِ
u'نُفُوذٌ قسمة':Added, #1: 1	نُفُوذُ فَسْخِهِ
u'نُفُوذٌ قِسْمَةٌ':Added, #1: 1	نُفُوذِ الْقِسْمَةِ
u'نُفُوذٌ قَضَاءٌ':Added, #1: 1	نُفُوذِ الْقِسْمَةِ
u'نُفُوذٌ قَضَاءٌ':Added, #1: 1	نُفُوذُ الْقَضَاءِ
u'نُفُوذٌ قَضَاءٌ':Added, #1: 1	نُفُوذِ الْقَضَاءِ
u'نُفُوذٌ قَضَاءٌ':Added, #1: 1	نُفُوذَ قَضَاءِ
u'نُفُوذٌ قَضَاءٌ':Added, #1: 1	نُفُوذِ قَضَاءِ
u'نُفُوذٌ قَوْلٌ':Added, #2: 2	نُفُوذَ الْقَضَاءِ
u'نُفُوذٌ كِتَابَةٌ':Added, #1: 1	نُفُوذُ قَوْلٍ
u'نُفُوذٌ لعان':Added, #4: 4	نُفُوذِ الْكِتَابَةِ
u'نُفُوذٌ مَاءٌ':Added, #1: 1	نُفُوذِ اللِّعَانِ
u'نُفُوذٌ مَاءٌ':Added, #1: 1	نُفُوذِ الْمَاءِ
u'نُفُوذٌ مَقْتَلٌ':Added, #7: 7	نُفُوذَ الْمَاءِ
u'نُفُوذٌ مِقْدَارٌ':Added, #1: 1	نُفُوذَ مَقْتَلٍ
u'نُفُوذٌ مِلْكٌ':Added, #1: 1	نُفُوذُ الْمِقْدَارِ
u'نُفُوذٌ مَنِيٌّ':Added, #1: 1	نُفُوذُ الْمِلْكِ
u'نُفُوذٌ نكاح':Added, #1: 1	نُفُوذَ الْمَنِيِّ
u'نُفُوذٌ نِكَاحٌ':Added, #1: 1	نُفُوذِ نِكَاحِ
u'نُفُوذٌ نكاح':Added, #1: 1	نُفُوذِ نِكَاحِ
u'نُفُوذٌ نِكَاحٌ':Added, #1: 1	نُفُوذُ نِكَاحِهِ
u'نُفُوذٌ هِبَةٌ':Added, #1: 1	نُفُوذُ نِكَاحِهِ
u'نُفُوذٌ وَصِيٌّ':Added, #1: 1	نُفُوذُ الْهِبَةِ
u'نُفُوذٌ وَصِيٌّ':Added, #1: 1	نُفُوذُ الْوَصِيَّةِ
u'نُفُوذٌ وَصِيٌّ':Added, #1: 1	نُفُوذِ الْوَصِيَّةِ
u'نُفُوذٌ وَصِيَّةٌ':Added, #2: 2	نُفُوذَ الْوَصِيَّةِ
u'نُفُوذٌ وَصِيَّةٌ':Added, #1: 1	نُفُوذُ الْوَصِيَّةِ
u'نُفُوذٌ وَصِيَّةٌ':Added, #1: 1	نُفُوذِ الْوَصِيَّةِ
u'نُفُوذٌ وَعْدٌ':Added, #2: 2	نُفُوذَ الْوَصِيَّةِ
u'نُفُوذٌ وَعِيدٌ':Added, #1: 1	نُفُوذِ الْوَعْدِ
u'نُفُوذٌ وَعِيدٌ':Added, #2: 2	نُفُوذُ الْوَعِيدِ
u'نُفُوذٌ وِلاَيَةٌ':Added, #2: 2	نُفُوذِ الْوَعِيدِ
u'نُفُورٌ دَابَّةٌ':Added, #1: 1	نُفُوذِ الْوِلَايَةِ
u'نُفُورٌ قلب':Added, #1: 1	نُفُورِ الدَّابَّةِ
u'نُفُورٌ قَلْبٌ':Added, #1: 1	نُفُورُ قَلْبِهِ
u'نُفُورٌ قَلْب':Added, #1: 1	نُفُورُ قَلْبِهِ
u'نُفُورٌ نَاسٌ':Added, #1: 1	نُفُورُ قَلْبِهِ
u'نُفُوسٌ أَوْسَاطٌ':Added, #1: 1	نُفُورِ النَّاسِ
u'نُفُوسٌ رَعِيَّةٌ':Added, #2: 2	نُفُوسِ أَوْسَاطِ
u'نُفُوسٌ علماء':Added, #1: 1	نُفُوسِ الرَّعِيَّةِ
u'نُفُوسٌ عُلَمَاءُ':Added, #1: 1	نُفُوسِ الْعُلَمَاءِ
u'نُفُوسٌ لُصُوصٌ':Added, #1: 1	نُفُوسِ الْعُلَمَاءِ
u'نُفُوسٌ مَارٌّ':Added, #1: 1	نُفُوسَ اللُّصُوصِ
u'نُفُوسٌ مَارَّةٌ':Added, #1: 1	نُفُوسِ الْمَارَّةِ
u'نُفُوسٌ نَاسٌ':Added, #1: 1	نُفُوسِ الْمَارَّةِ
u'نَفَى أَبٌ':Subject, #5: 5	نُفُوسِ النَّاسِ
u'نَفْيٌ إبَاحَةٌ':Added, #2: 2	نَفَى الْأَبُ
u'نَفْيٌ إبَاحَةٌ':Added, #1: 1	نَفْيُ الْإِبَاحَةِ
u'نَفْيٌ اِبْتِداءٌ':Added, #2: 2	نَفْيِ الْإِبَاحَةِ
u'نَفَى اِبْنٌ':Subject, #1: 1	نَفْيُ ابْتِدَاءِ
u'نَفْيٌ اِبْنٌ':Added, #1: 1	نَفَى ابْنُ
u'نَفْيٌ أُبُوَّةٌ':Added, #1: 1	نَفْيُ ابْنِ
u'نَفْيٌ اِتِّخَاذٌ':Added, #1: 1	نَفْيُ أُبُوَّتِهِ
u'نَفْيٌ إِثْبَاتٌ':Added, #1: 1	نَفْيِ اتِّخَاذِ
u'نَفْيٌ أثَرٌ':Added, #1: 1	نَفْيِ إثْبَاتٍ
u'نَفْيٌ أثَرٌ':Added, #1: 1	نَفْيِ أَثَرِ
u'نَفَى إِثْمٌ':Predicate, #1: 1	نَفْيَ الْأَثَرِ
u'نَفْيٌ إِثْمٌ':Added, #1: 1	نَفَى الْإِثْمَ
u'نَفْيٌ إِثْمٌ':Added, #1: 1	نَفْيَ إثْمِ
u'نَفْيٌ إِثْمٌ':Added, #1: 1	نَفْيُ إِثْمِ
u'نَفْيٌ إِثْمٌ':Added, #1: 1	نَفْيَ الْإِثْمِ
u'نَفْيٌ إِثْمٌ':Added, #1: 1	نَفْيُ الْإِثْمِ
u'نَفْيٌ إجَازَةٌ':Added, #5: 5	نَفْيِ الْإِثْمِ
u'نَفْيٌ اِجْتِمَاعٌ':Added, #1: 1	نَفْيُ الْإِجَازَةِ
u'نَفْيٌ أَجْرٌ':Added, #1: 1	نَفْيِ اجْتِمَاعِ
u'نَفْيٌ إِجْزَاءٌ':Added, #2: 2	نَفْيَ الْأَجْرِ
u'نَفْيٌ إِجْزَاءٌ':Added, #1: 1	نَفْيَ الْإِجْزَاءِ
u'نَفْيٌ إِجْمَاعٌ':Added, #5: 5	نَفْيِ الْإِجْزَاءِ
u'نَفْيٌ إِجْمَاعٌ':Added, #2: 2	نَفْيِ الْإِجْمَاعِ
u'نَفَى إِجْمَالٌ':Predicate, #3: 3	نَفْيُ الْإِجْمَاعِ
u'نَفْيٌ إِجْمَالٌ':Added, #1: 1	نَفَى الْإِجْمَالَ
u'نَفْيٌ إِجْمَالٌ':Added, #1: 1	نَفْيَ الْإِجْمَالِ
u'نَفْيٌ إِجْمَالٌ':Added, #1: 1	نَفْيُ الْإِجْمَالِ
u'نَفَى أَجْنَبِيٌّ':Subject, #1: 1	نَفْيِ الْإِجْمَالِ
u'نَفْيٌ اِحْتِمَالٌ':Added, #2: 2	نَفَى أَجْنَبِيٌّ
u'نَفْيٌ اِحْتِمَالٌ':Added, #1: 1	نَفْيِ احْتِمَالِ
u'نَفْيٌ اِحْتِمَالٌ':Added, #2: 2	نَفْيَ احْتِمَالِ
u'نَفْيٌ أحَدٌ':Added, #2: 2	نَفْيُ احْتِمَالِ
u'نَفْيٌ أحَدٌ':Added, #1: 1	نَفْيُ أَحَدِ
u'نَفْيٌ إِحْرَازٌ':Added, #1: 1	نَفْيِ أَحَدِ
u'نَفْيٌ أَحْكَامٌ':Added, #1: 1	نَفْيُ الْإِحْرَازِ
u'نَفْيٌ أَحْكَامٌ':Added, #1: 1	نَفْيُ الْأَحْكَامِ
u'نَفْيٌ أخْبَارٌ':Added, #2: 2	نَفْيِ الْأَحْكَامِ
u'نَفْيٌ أَخْبَارٌ':Added, #1: 1	نَفْيِ أَخْبَارِ
u'نَفْيٌ اِخْتِيَارٌ':Added, #1: 1	نَفْيِ أَخْبَارِ
u'نَفْيٌ أَخَصُّ':Added, #1: 1	نَفْيُ اخْتِيَارِ
u'نَفْيٌ أَخَصُّ':Added, #1: 1	نَفْيُ الْأَخَصِّ
u'نَفْيٌ أدَب':Added, #5: 5	نَفْيِ الْأَخَصِّ
u'نَفْيٌ إِدْرَاكٌ':Added, #1: 1	نَفْيِ الْأَدَبِ
u'نَفْيٌ إذَاعَةٌ':Added, #1: 1	نَفْيُ إدْرَاكِ
u'نَفْيٌ إِذْنٌ':Added, #1: 1	نَفْيِ الْإِذَاعَةِ
u'نَفْيٌ إِرَادَةٌ':Added, #1: 1	نَفْيِ الْإِذْنِ
u'نَفْيٌ إِرْثٌ':Added, #3: 3	نَفْيِ الْإِرَادَةِ
u'نَفْيٌ إِرْسَالٌ':Added, #1: 1	نَفْيِ الْإِرْثِ
u'نَفْيٌ اِسْتِبْدَادٌ':Added, #1: 1	نَفْيَ إرْسَالِهِ
u'نَفْيٌ اِسْتِبْدَادٌ':Added, #1: 1	نَفْيُ اسْتِبْدَادٍ
u'نَفْيٌ اِسْتِبْعَادٌ':Added, #1: 1	نَفْيُ اسْتِبْدَادِ
u'نَفْيٌ اِسْتِحْقَاقٌ':Added, #1: 1	نَفْيِ اسْتِبْعَادِ
u'نَفْيٌ اِسْتِحْقَاقٌ':Added, #1: 1	نَفْيَ اسْتِحْقَاقِ
u'نَفْيٌ اِسْتِحْقَاقٌ':Added, #1: 1	نَفْيُ اسْتِحْقَاقِ
u'نَفْيٌ اِسْتِلْزامٌ':Added, #2: 2	نَفْيِ اسْتِحْقَاقِ
u'نَفْيٌ اِسْتيفاءٌ':Added, #1: 1	نَفْيِ اسْتِلْزَامِهِ
u'نَفْيٌ إِسْلامٌ':Added, #2: 2	نَفْيِ اسْتِيفَاءِ
u'نَفْيٌ إِسْلامٌ':Added, #1: 1	نَفْيُ الْإِسْلَامِ
u'نَفْيٌ اِسْمٌ':Added, #3: 3	نَفْيِ الْإِسْلَامِ
u'نَفَى أَسْماءٌ':Predicate, #1: 1	نَفْيُ اسْمِ
u'نَفَى اِشْتِراطٌ':Predicate, #1: 1	نَفَى الْأَسْمَاءَ
u'نَفْيٌ اِشْتِراطٌ':Added, #2: 2	نَفَى اشْتِرَاطَ
u'نَفْيٌ اِشْتِراطٌ':Added, #1: 1	نَفْيُ اشْتِرَاطِ
u'نَفْيٌ اِشْتِراطٌ':Added, #1: 1	نَفْيِ اشْتِرَاطِ
u'نَفَى أصل':Subject, #1: 1	نَفْيِ اشْتِرَاطِهِ
u'نَفَى أًصْلٌ':Subject, #1: 1	نَفَى الْأَصْلُ
u'نَفْيٌ أصل':Added, #1: 1	نَفَى الْأَصْلُ
u'نَفْيٌ أصل':Added, #1: 1	نَفْيَ أَصْلِ
u'نَفْيٌ أًصْلٌ':Added, #1: 1	نَفْيِ أَصْلِ
u'نَفْيٌ أًصْلٌ':Added, #1: 1	نَفْيَ أَصْلِ
u'نَفْيٌ أصل':Added, #1: 1	نَفْيِ أَصْلِ
u'نَفْيٌ أصل':Added, #1: 1	نَفْيَ الْأَصْلِ
u'نَفْيٌ أصل':Added, #1: 1	نَفْيُ الْأَصْلِ
u'نَفْيٌ أًصْلٌ':Added, #1: 1	نَفْيِ الْأَصْلِ
u'نَفْيٌ أًصْلٌ':Added, #1: 1	نَفْيَ الْأَصْلِ
u'نَفْيٌ أًصْلٌ':Added, #1: 1	نَفْيُ الْأَصْلِ
u'نَفْيٌ أصل':Added, #1: 1	نَفْيِ الْأَصْلِ
u'نَفْيٌ أًصْلٌ':Added, #2: 2	نَفْيُ أَصْلِ
u'نَفْيٌ اِطِّرادٌ':Added, #2: 2	نَفْيُ أَصْلِ
u'نَفْيٌ اِطِّرادٌ':Added, #1: 1	نَفْيُ اطِّرَادِ
u'نَفْيٌ إِطْلاقٌ':Added, #1: 1	نَفْيُ اطِّرَادِهِ
u'نَفْيٌ إِطْلاقٌ':Added, #1: 1	نَفْيِ إطْلَاقِ
u'نَفْيٌ إِطْلاقٌ':Added, #1: 1	نَفْيِ إطْلَاقِهِ
u'نَفْيٌ إِطْلاقٌ':Added, #1: 1	نَفْيَ الْإِطْلَاقِ
u'نَفْيٌ إِعارَةٌ':Added, #1: 1	نَفْيُ الْإِطْلَاقِ
u'نَفْيٌ اِعْتِبارٌ':Added, #2: 2	نَفْيِ الْإِعَارَةِ
u'نَفْيٌ أَعَمُّ':Added, #2: 2	نَفْيُ اعْتِبَارِ
u'نَفْيٌ أَعَمُّ':Added, #1: 1	نَفْيَ الْأَعَمِّ
u'نَفْيٌ أعْيانٌ':Added, #3: 3	نَفْيُ الْأَعَمِّ
u'نَفْيٌ أَعْيَانٌ':Added, #1: 1	نَفْيِ الْأَعْيَانِ
u'نَفْيٌ أَفْرَادٌ':Added, #1: 1	نَفْيِ الْأَعْيَانِ
u'نَفَى أقَلُّ':Predicate, #1: 1	نَفْيُ أَفْرَادِ
u'نَفْيٌ أقَلُّ':Added, #2: 2	نَفَى الْأَقَلَّ
u'نَفْيٌ إكْرَامٌ':Added, #1: 1	نَفْيُ الْأَقَلِّ
u'نَفْيٌ إكْرَاهٌ':Added, #1: 1	نَفْيَ إكْرَامِهِ
u'نَفْيٌ إِلْحَافٌ':Added, #1: 1	نَفْيِ إكْرَاهِ
u'نَفْيٌ إلْحَاقٌ':Added, #1: 1	نَفْيُ الْإِلْحَافِ
u'نَفْيٌ آلِهَةٌ':Added, #1: 1	نَفْيِ الْإِلْحَاقِ
u'نَفْيٌ أُلُوهِيَّةٌ':Added, #1: 1	نَفْيَ الْآلِهَةِ
u'نَفَى أَمْرٌ':Predicate, #1: 1	نَفْيِ الْأُلُوهِيَّةِ
u'نَفْيٌ أَمْرٌ':Added, #1: 1	نَفَى الْأَمْرَ
u'نَفْيٌ أَمْلاكٌ':Added, #1: 1	نَفْيَ الْأَمْرَيْنِ
u'نَفْيٌ أَمْلاَكٌ':Added, #1: 1	نَفْيِ الْأَمْلَاكِ
u'نَفْيٌ إِنْتاجٌ':Added, #1: 1	نَفْيِ الْأَمْلَاكِ
u'نَفْيٌ اِنْتِفاء':Added, #1: 1	نَفْيَ الْإِنْتَاجِ
u'نَفْيٌ اِنْقِطاعٌ':Added, #1: 1	نَفْيِ انْتِفَاءِ
u'نَفْيٌ أَنْوَاعٌ':Added, #3: 3	نَفْيِ انْقِطَاعِ
u'نَفَى أهْلٌ':Predicate, #1: 1	نَفْيَ أَنْوَاعِ
u'نَفَى أَوَّلُ':Predicate, #2: 2	نَفَى أَهْلَ
u'نَفَى أَوَّلُ':Predicate, #1: 1	نَفَى أَوَّلَ
u'نَفْيٌ أَوَّلُ':Added, #8: 8	نَفَى الْأَوَّلَ
u'نَفْيٌ أَوَّلُ':Added, #1: 1	نَفْيَ الْأَوَّلِ
u'نَفْيٌ أَوَّلُ':Added, #1: 1	نَفْيِ الْأَوَّلِ
u'نَفْيٌ أَوَّلِيٌّ':Added, #2: 2	نَفْيُ الْأَوَّلِ
u'نَفْيٌ أيَّامٌ':Added, #1: 1	نَفْيِ الْأَوَّلِيَّةِ
u'نَفْيٌ أَيَّامٌ':Added, #1: 1	نَفْيِ الْأَيَّامِ
u'نَفَى آيَةٌ':Subject, #1: 1	نَفْيِ الْأَيَّامِ
u'نَفْيٌ إِيجَابٌ':Added, #1: 1	نَفَى الْآيَةُ
u'نَفْيٌ إِيجَابٌ':Added, #1: 1	نَفْيُ الْإِيجَابِ
u'نَفْيٌ إِيجَابٌ':Added, #1: 1	نَفْيِ الْإِيجَابِ
u'نَفْيٌ إِيجَابٌ':Added, #1: 1	نَفْيِ إيجَابِ
u'نَفْيٌ إيمَانٌ':Added, #2: 2	نَفْيُ إيجَابِ
u'نَفْيٌ إيمَانٌ':Added, #1: 1	نَفْيَ الْإِيمَانِ
u'نَفْيٌ بَأسٌ':Added, #3: 3	نَفْيُ الْإِيمَانِ
u'نَفْيٌ بَحْثٌ':Added, #1: 1	نَفْيُ الْبَأْسِ
u'نَفْيٌ بُخْلٌ':Added, #1: 1	نَفْيَ الْبَحْثِ
u'نَفْيٌ بِدْعَةٌ':Added, #1: 1	نَفْيَ الْبُخْلِ
u'نَفْيٌ بَعْثٌ':Added, #1: 1	نَفْيِ الْبِدْعَةِ
u'نَفْيٌ بَعْضٌ':Added, #1: 1	نَفْيِ الْبَعْثِ
u'نَفْيٌ بَقاءٌ':Added, #1: 1	نَفْيَ الْبَعْضِ
u'نَفْيٌ بَقاءٌ':Added, #1: 1	نَفْيِ بَقَاءِ
u'نَفَى بُنُوَّة':Predicate, #2: 2	نَفْيِ الْبَقَاءِ
u'نَفْيٌ بَيَانٌ':Added, #1: 1	نَفَى الْبُنُوَّةَ
u'نَفْيٌ بَيْعٌ':Added, #1: 1	نَفْيُ بَيَانِ
u'نَفْيٌ تَأْثِيرٌ':Added, #1: 1	نَفْيِ الْبَيْعِ
u'نَفْيٌ تَبَايُنٌ':Added, #1: 1	نَفْيُ تَأْثِيرِهِ
u'نَفْيٌ تَبْدِيلٌ':Added, #1: 1	نَفْيُ التَّبَايُنِ
u'نَفْيٌ تَتَابُعٌ':Added, #1: 1	نَفْيَ التَّبْدِيلِ
u'نَفْيٌ تَجَوُّزٌ':Added, #2: 2	نَفْيِ التَّتَابُعِ
u'نَفْيٌ تَحْدِيدٌ':Added, #1: 1	نَفْيَ التَّجَوُّزِ
u'نَفْيٌ تَحْرِيمٌ':Added, #2: 2	نَفْيُ التَّحْدِيدِ
u'نَفْيٌ تَحْرِيمٌ':Added, #1: 1	نَفْيُ التَّحْرِيمِ
u'نَفْيٌ تَحَقُّقٌ':Added, #1: 1	نَفْيِ التَّحْرِيمِ
u'نَفْيٌ تَخْصِيصٌ':Added, #1: 1	نَفْيِ تَحَقُّقِهِ
u'نَفْيٌ تَخْصِيصٌ':Added, #1: 1	نَفْيُ التَّخْصِيصِ
u'نَفْيٌ تَرْجِيحٌ':Added, #1: 1	نَفْيِ تَخْصِيصِ
u'نَفْيٌ تَرْجِيحٌ':Added, #1: 1	نَفْيَ التَّرْجِيحِ
u'نَفْيٌ تَرْجِيحٌ':Added, #1: 1	نَفْيِ التَّرْجِيحِ
u'نَفْيٌ تَرِكَةٌ':Added, #2: 2	نَفْيُ التَّرْجِيحِ
u'نَفْيٌ تَرْكِيبٌ':Added, #1: 1	نَفْيِ التَّرِكَةِ
u'نَفْيٌ تَزْوِيجٌ':Added, #1: 1	نَفْيِ التَّرْكِيبِ
u'نَفْيٌ تَسْلِيمٌ':Added, #1: 1	نَفْيِ التَّزْوِيجِ
u'نَفْيٌ تَسْمِيَة':Added, #1: 1	نَفْيِ التَّسْلِيمِ
u'نَفَى تَشْبِيه':Predicate, #2: 2	نَفْيَ التَّسْمِيَةِ
u'نَفْيٌ تَشْبِيه':Added, #1: 1	نَفَى التَّشْبِيهَ
u'نَفْيٌ تَشْبِيه':Added, #1: 1	نَفْيُ التَّشْبِيهِ
u'نَفْيٌ تَشْبِيه':Added, #2: 2	نَفْيَ التَّشْبِيهِ
u'نَفْيٌ تَصْدِيقٌ':Added, #3: 3	نَفْيِ التَّشْبِيهِ
u'نَفَى تَصْرِيحٌ':Predicate, #1: 1	نَفْيَ التَّصْدِيقِ
u'نَفْيٌ تَطْلِيقٌ':Added, #1: 1	نَفَى التَّصْرِيحَ
u'نَفَى تَعَارُضٌ':Predicate, #1: 1	نَفْيِ التَّطْلِيقِ
u'نَفْيٌ تَعْدِيلٌ':Added, #1: 1	نَفَى التَّعَارُضَ
u'نَفْيٌ تَعْذِيب':Added, #1: 1	نَفْيَ تَعْدِيلِ
u'نَفَى تَعَلُّقٌ':Predicate, #1: 1	نَفْيَ التَّعْذِيبِ
u'نَفْيٌ تَعَلُّقٌ':Added, #2: 2	نَفَى تَعَلُّقَ
u'نَفْيٌ تَعْيِينٌ':Added, #1: 1	نَفْي التَّعَلُّقِ
u'نَفْيٌ تَعْيِينٌ':Added, #1: 1	نَفْيِ التَّعْيِينِ
u'نَفْيٌ تَفْصِيلٌ':Added, #1: 1	نَفْيُ تَعْيِينِ
u'نَفْيٌ تَقَيُّدٌ':Added, #1: 1	نَفْيِ التَّفْصِيلِ
u'نَفْيٌ تَكافُؤٌ':Added, #1: 1	نَفْيُ تَقَيُّدِهِ
u'نَفْيٌ تَكافُؤٌ':Added, #1: 1	نَفْيَ التَّكَافُؤِ
u'نَفْيٌ تَكْبيرٌ':Added, #1: 1	نَفْيُ التَّكَافُؤِ
u'نَفْيٌ تَكْرارٌ':Added, #1: 1	نَفْيِ التَّكْبِيرِ
u'نَفْيٌ تَكْرارٌ':Added, #1: 1	نَفْيَ التَّكْرَارِ
u'نَفْيٌ تَكْفيرٌ':Added, #1: 1	نَفْيُ التَّكْرَارِ
u'نَفْيٌ تَكْليفٌ':Added, #1: 1	نَفْيِ التَّكْفِيرِ
u'نَفْيٌ تَكْليفٌ':Added, #1: 1	نَفْيُ التَّكْلِيفِ
u'نَفْيٌ تَلازُم':Added, #2: 2	نَفْيَ التَّكْلِيفِ
u'نَفْيٌ تَلَوُّمٌ':Added, #1: 1	نَفْيُ التَّلَازُمِ
u'نَفْيٌ تَمَتُّعٌ':Added, #1: 1	نَفْيُ التَّلَوُّمِ
u'نَفْيٌ تَمْكِينٌ':Added, #1: 1	نَفْيَ التَّمَتُّعِ
u'نَفْيٌ تَمَلُّك':Added, #1: 1	نَفْيُ تَمْكِينِهِ
u'نَفْيٌ تَنْجِيزٌ':Added, #3: 3	نَفْيَ التَّمَلُّكِ
u'نَفْيٌ تَنْجِيزٌ':Added, #1: 1	نَفْيَ التَّنْجِيزِ
u'نَفْيٌ تَنْزِيه':Added, #3: 3	نَفْيِ التَّنْجِيزِ
u'نَفْيٌ تَوَالُدٌ':Added, #1: 1	نَفْيَ التَّنْزِيهِ
u'نَفْيٌ تَوْرِيث':Added, #1: 1	نَفْيِ التَّوَالُدِ
u'نَفْيٌ تَوَعُّدٌ':Added, #1: 1	نَفْيُ تَوْرِيثِ
u'نَفْيٌ تَوَهُّمٌ':Added, #1: 1	نَفْيِ التَّوَعُّدِ
u'نَفْيٌ تَوَهُّمٌ':Added, #1: 1	نَفْيَ تَوَهُّمِ
u'نَفْيٌ تَوَهُّمٌ':Added, #1: 1	نَفْيُ تَوَهُّمِ
u'نَفْيٌ ثُبُوتٌ':Added, #1: 1	نَفْيِ تَوَهُّمِ
u'نَفْيٌ ثُبُوتٌ':Added, #1: 1	نَفْيُ الثُّبُوتِ
u'نَفْيٌ ثَمَنٌ':Added, #3: 3	نَفْيُ ثُبُوتِ
u'نَفْيٌ ثَوابٌ':Added, #5: 5	نَفْيِ الثَّمَنِ
u'نَفْيٌ جَاهِلِيٌّ':Added, #1: 1	نَفْيِ الثَّوَابِ
u'نَفْيٌ جَاهِلِيَّةٌ':Added, #1: 1	نَفْيُ الْجَاهِلِيَّةِ
u'نَفْيٌ جَرْيٌ':Added, #1: 1	نَفْيُ الْجَاهِلِيَّةِ
u'نَفْيٌ جَزَاءٌ':Added, #1: 1	نَفْيِ جَرْيِهِ
u'نَفَى جزع':Predicate, #1: 1	نَفْيُ الْجَزَاءِ
u'نَفَى جَزَعٌ':Predicate, #1: 1	نَفَى الْجَزَعَ
u'نَفْيٌ جِسْمِيٌّ':Added, #1: 1	نَفَى الْجَزَعَ
u'نَفْيٌ جلد':Added, #1: 1	نَفْيِ الْجِسْمِيَّةِ
u'نَفْيٌ جَلْدٌ':Added, #1: 1	نَفْيِ الْجَلْدِ
u'نَفْيٌ جمع':Added, #1: 1	نَفْيِ الْجَلْدِ
u'نَفْيٌ جَمْعٌ':Added, #1: 1	نَفْيَ الْجَمْعِ
u'نَفْيٌ جمع':Added, #1: 1	نَفْيَ الْجَمْعِ
u'نَفْيٌ جَمْعٌ':Added, #2: 2	نَفْيِ الْجَمْعِ
u'نَفَى جَمِيع':Predicate, #2: 2	نَفْيِ الْجَمْعِ
u'نَفْيٌ جَمِيع':Added, #1: 1	نَفَى الْجَمِيعَ
u'نَفَى جناح':Predicate, #1: 1	نَفْيَ الْجَمِيعِ
u'نَفَى جُنَاحٌ':Predicate, #2: 2	نَفَى الْجُنَاحَ
u'نَفْيٌ جناح':Added, #2: 2	نَفَى الْجُنَاحَ
u'نَفْيٌ جناح':Added, #1: 1	نَفْيَ الْجُنَاحِ
u'نَفْيٌ جُنَاحٌ':Added, #1: 1	نَفْيُ الْجُنَاحِ
u'نَفْيٌ جُنَاحٌ':Added, #1: 1	نَفْيَ الْجُنَاحِ
u'نَفْيٌ جِنْسٌ':Added, #1: 1	نَفْيُ الْجُنَاحِ
u'نَفْيٌ جِنْسٌ':Added, #1: 1	نَفْيُ الْجِنْسِ
u'نَفْيٌ جِنْسٌ':Added, #1: 1	نَفْيِ الْجِنْسِ
u'نَفْيٌ جَهالَة':Added, #1: 1	نَفْيَ جِنْسِ
u'نَفْيٌ جِهَةٌ':Added, #1: 1	نَفْيِ الْجَهَالَةِ
u'نَفَى جَوَازٌ':Predicate, #1: 1	نَفْيِ الْجِهَةِ
u'نَفْيٌ جَوَازٌ':Added, #2: 2	نَفَى الْجَوَازَ
u'نَفْيٌ جَوَازٌ':Added, #16: 16	نَفْيِ الْجَوَازِ
u'نَفْيٌ جَوَازٌ':Added, #2: 2	نَفْيَ جَوَازِ
u'نَفْيٌ جَوَازٌ':Added, #2: 2	نَفْيُ جَوَازِ
u'نَفْيٌ جَوَازٌ':Added, #4: 4	نَفْيِ جَوَازِ
u'نَفْيٌ جَوَازٌ':Added, #6: 6	نَفْيَ الْجَوَازِ
u'نَفْيٌ حالٌ':Added, #8: 8	نَفْيُ الْجَوَازِ
u'نَفْيٌ حالٌ':Added, #1: 1	نَفْيِ الْحَالِ
u'نَفْيٌ حالٌ':Added, #1: 1	نَفْيَ حَالِ
u'نَفْيٌ حَجٌّ':Added, #2: 2	نَفْيُ الْحَالِ
u'نَفْيٌ حُجَّة':Added, #3: 3	نَفْيُ الْحَجِّ
u'نَفْيٌ حِجْرٌ':Added, #1: 1	نَفْيُ الْحُجِّيَّةِ
u'نَفْيٌ حُجِّيَّة':Added, #1: 1	نَفْيِ الْحِجْرِ
u'نَفْيٌ حَدٌّ':Added, #1: 1	نَفْيُ الْحُجِّيَّةِ
u'نَفْيٌ حَدٌّ':Added, #1: 1	نَفْيَ الْحَدِّ
u'نَفْيٌ حَدٌّ':Added, #2: 2	نَفْيِ الْحَدِّ
u'نَفْيٌ حَديثٌ':Added, #3: 3	نَفْيُ الْحَدِّ
u'نَفَى حَرَجٌ':Predicate, #1: 1	نَفْيِ حَدِيثٍ
u'نَفْيٌ حَرَجٌ':Added, #1: 1	نَفَى الْحَرَجَ
u'نَفْيٌ حَرَجٌ':Added, #3: 3	نَفْيَ الْحَرَجِ
u'نَفْيٌ حَرَجٌ':Added, #3: 3	نَفْيِ الْحَرَجِ
u'نَفْيٌ حُرْمَةٌ':Added, #6: 6	نَفْيُ الْحَرَجِ
u'نَفْيٌ حُرْمَةٌ':Added, #1: 1	نَفْيُ الْحُرْمَةِ
u'نَفْيٌ حُسْنٌ':Added, #1: 1	نَفْيَ حُرْمَةِ
u'نَفْيٌ حُصُول':Added, #1: 1	نَفْيُ حُسْنِ
u'نَفَى حَضَانَةٌ':Predicate, #1: 1	نَفْيُ الْحُصُولِ
u'نَفَى حَقٌّ':Predicate, #2: 2	نَفَى الْحَضَانَةَ
u'نَفْيٌ حَقٌّ':Added, #2: 2	نَفَى الْحَقَّ
u'نَفْيٌ حقائق':Added, #1: 1	نَفْيِ الْحَقِّ
u'نَفْيٌ حَقَائِقُ':Added, #1: 1	نَفْيُ الْحَقَائِقِ
u'نَفْيٌ حَقِيقٌ':Added, #1: 1	نَفْيُ الْحَقَائِقِ
u'نَفْيٌ حَقِيقٌ':Added, #1: 1	نَفْيَ الْحَقِيقَةِ
u'نَفْيٌ حَقِيقٌ':Added, #2: 2	نَفْيِ الْحَقِيقَةِ
u'نَفْيٌ حَقِيقَةٌ':Added, #6: 6	نَفْيُ الْحَقِيقَةِ
u'نَفْيٌ حَقِيقَةٌ':Added, #1: 1	نَفْيَ الْحَقِيقَةِ
u'نَفْيٌ حَقِيقَةٌ':Added, #2: 2	نَفْيِ الْحَقِيقَةِ
u'نَفْيٌ حَقِيقِيٌّ':Added, #6: 6	نَفْيُ الْحَقِيقَةِ
u'نَفَى حُكْمٌ':Predicate, #3: 3	نَفْيِ الْحَقِيقِيِّ
u'نَفْيٌ حُكْمٌ':Added, #2: 2	نَفَى الْحُكْمَ
u'نَفْيٌ حُكْمٌ':Added, #17: 17	نَفْيُ الْحُكْمِ
u'نَفْيٌ حُكْمٌ':Added, #1: 1	نَفْيَ حُكْمِ
u'نَفْيٌ حُكْمٌ':Added, #1: 1	نَفْيُ حُكْمِ
u'نَفْيٌ حُكْمٌ':Added, #23: 23	نَفْيَ الْحُكْمِ
u'نَفْيٌ حُكْمٌ':Added, #2: 2	نَفْيِ حُكْمِهِ
u'نَفْيٌ حُكْمٌ':Added, #35: 35	نَفْيِ الْحُكْمِ
u'نَفْيٌ حِلٌّ':Added, #3: 3	نَفْيِ حُكْمٍ
u'نَفْيٌ حِلٌّ':Added, #1: 1	نَفْيَ الْحِلِّ
u'نَفْيٌ حِلٌّ':Added, #1: 1	نَفْيِ الْحِلِّ
u'نَفْيٌ حِلٌّ':Added, #1: 1	نَفْيَ حِلِّ
u'نَفْيٌ حِلٌّ':Added, #1: 1	نَفْيِ حِلِّ
u'نَفْيٌ حِلٌّ':Added, #2: 2	نَفْيُ الْحِلِّ
u'نَفَى حَمْلٌ':Predicate, #2: 2	نَفْيُ حِلِّ
u'نَفْيٌ حَمْلٌ':Added, #4: 4	نَفَى الْحَمْلَ
u'نَفْيٌ حَمْلٌ':Added, #1: 1	نَفْيَ حَمْلٍ
u'نَفْيٌ حَمْلٌ':Added, #1: 1	نَفْيُ حَمْلٍ
u'نَفْيٌ حَمْلٌ':Added, #1: 1	نَفْيُ حَمْلِ
u'نَفْيٌ حَمْلٌ':Added, #3: 3	نَفْيُ الْحَمْلِ
u'نَفْيٌ حَمْلٌ':Added, #4: 4	نَفْيِ حَمْلٍ
u'نَفَى حِنْثٌ':Predicate, #5: 5	نَفْيِ الْحَمْلِ
u'نَفْيٌ حِنْثٌ':Added, #1: 1	نَفَى الْحِنْثَ
u'نَفْيٌ حَوَالَةٌ':Added, #1: 1	نَفْيَ الْحِنْثِ
u'نَفْيٌ خاصّ':Added, #2: 2	نَفْيِ الْحَوَالَةِ
u'نَفْيٌ خاصّ':Added, #1: 1	نَفْيَ الْخَاصِّ
u'نَفْيٌ خَبَرٌ':Added, #4: 4	نَفْيِ الْخَاصِّ
u'نَفْيٌ خَبَر':Added, #1: 1	نَفْيِ الْخَبَرِ
u'نَفْيٌ خَبَرٌ':Added, #1: 1	نَفْيِ الْخَبَرِ
u'نَفْيٌ خَبَر':Added, #1: 1	نَفْيِ خَبَرِ
u'نَفْيٌ خداع':Added, #1: 1	نَفْيِ خَبَرِ
u'نَفْيٌ خِدَاعٌ':Added, #1: 1	نَفْيَ الْخِدَاعِ
u'نَفْيٌ خراج':Added, #1: 1	نَفْيَ الْخِدَاعِ
u'نَفْيٌ خَرَاجٌ':Added, #1: 1	نَفْيُ الْخَرَاجِ
u'نَفَى خِلاَفٌ':Subject, #1: 1	نَفْيُ الْخَرَاجِ
u'نَفْيٌ خِلاَفٌ':Added, #1: 1	نَفَى الْخِلَافُ
u'نَفْيٌ خِلاَفٌ':Added, #1: 1	نَفْيُ الْخِلَافِ
u'نَفْيٌ خِلاَفٌ':Added, #2: 2	نَفْيِ الْخِلَافِ
u'نَفْيٌ خلق':Added, #4: 4	نَفْيَ الْخِلَافِ
u'نَفْيٌ خَلْقٌ':Added, #1: 1	نَفْيُ الْخَلْقِ
u'نَفْيٌ خَمْسَةٌ':Added, #1: 1	نَفْيُ الْخَلْقِ
u'نَفْيٌ خَوَاصُّ':Added, #1: 1	نَفْيُ الْخَمْسَةِ
u'نَفْيٌ خَوَاصّ':Added, #1: 1	نَفْيِ خَوَاصِّ
u'نَفَى خَوْفٌ':Predicate, #1: 1	نَفْيِ خَوَاصِّ
u'نَفَى خيار':Predicate, #1: 1	نَفَى الْخَوْفَ
u'نَفَى خِيَارٌ':Predicate, #1: 1	نَفَى خِيَارَ
u'نَفْيٌ خيار':Added, #1: 1	نَفَى خِيَارَ
u'نَفْيٌ خيار':Added, #1: 1	نَفْي خِيَارِ
u'نَفْيٌ خِيَارٌ':Added, #1: 1	نَفْيَ خِيَارِ
u'نَفْيٌ خِيَارٌ':Added, #1: 1	نَفْي خِيَارِ
u'نَفْيٌ خيار':Added, #1: 1	نَفْيَ خِيَارِ
u'نَفْيٌ خيار':Added, #2: 2	نَفْيَ الْخِيَارِ
u'نَفْيٌ خِيَارٌ':Added, #2: 2	نَفْيُ الْخِيَارِ
u'نَفْيٌ خِيَارٌ':Added, #2: 2	نَفْيَ الْخِيَارِ
u'نَفْيٌ خيار':Added, #2: 2	نَفْيُ الْخِيَارِ
u'نَفْيٌ خِيَارٌ':Added, #2: 2	نَفْيِ خِيَارِ
u'نَفْيٌ خيار':Added, #2: 2	نَفْيِ خِيَارِ
u'نَفْيٌ خِيَارٌ':Added, #4: 4	نَفْيِ الْخِيَارِ
u'نَفْيٌ خَيْرِيٌّ':Added, #4: 4	نَفْيِ الْخِيَارِ
u'نَفْيٌ دَاءٌ':Added, #1: 1	نَفْيُ الْخَيْرِيَّةِ
u'نَفْيٌ دُخُولٌ':Added, #1: 1	نَفْيِ دَاءِ
u'نَفْيٌ دُخُولٌ':Added, #1: 1	نَفْيَ الدُّخُولِ
u'نَفْيٌ دَلالَةٌ':Added, #1: 1	نَفْيِ الدُّخُولِ
u'نَفْيٌ دَلالَةٌ':Added, #1: 1	نَفْيُ دَلَالَةِ
u'نَفْيٌ دَلالَةٌ':Added, #1: 1	نَفْيِ دَلَالَةِ
u'نَفْيٌ دَليلٌ':Added, #3: 3	نَفْيِ الدَّلَالَةِ
u'نَفْيٌ دَليلٌ':Added, #1: 1	نَفْيُ الدَّلِيلِ
u'نَفْيٌ دَيْنٌ':Added, #1: 1	نَفْيِ الدَّلِيلِ
u'نَفْيٌ دَيْنٌ':Added, #1: 1	نَفْيِ الدَّيْنِ
u'نَفْيٌ دَيْنٌ':Added, #2: 2	نَفْيُ الدَّيْنِ
u'نَفَى ذِمِّيٌّ':Subject, #2: 2	نَفْيِ دَيْنٍ
u'نَفْيٌ ذِهْنيٌّ':Added, #1: 1	نَفَى الذِّمِّيُّ
u'نَفْيٌ رجعة':Added, #1: 1	نَفْيَ الذِّهْنِيِّ
u'نَفْيٌ رجعة':Added, #1: 1	نَفْيَ الرَّجْعَةِ
u'نَفْيٌ رَجْعَةٌ':Added, #1: 1	نَفْيِ الرَّجْعَةِ
u'نَفْيٌ رَجْعَةٌ':Added, #1: 1	نَفْيَ الرَّجْعَةِ
u'نَفْيٌ رجعة':Added, #1: 1	نَفْيِ الرَّجْعَةِ
u'نَفْيٌ رَجْعَةٌ':Added, #2: 2	نَفْيُ الرَّجْعَةِ
u'نَفَى رَجُلٌ':Subject, #2: 2	نَفْيُ الرَّجْعَةِ
u'نَفْيٌ رَجُلٌ':Added, #6: 6	نَفَى الرَّجُلُ
u'نَفْيٌ رُخْصَةٌ':Added, #2: 2	نَفْيِ رَجُلٍ
u'نَفْيٌ رَدٌّ':Added, #1: 1	نَفْيِ رُخْصَةِ
u'نَفْيٌ رَدٌّ':Added, #1: 1	نَفْيَ الرَّدِّ
u'نَفْيٌ رِسَالَةٌ':Added, #3: 3	نَفْيِ الرَّدِّ
u'نَفَى رَسُولٌ':Subject, #1: 1	نَفْيِ رِسَالَةِ
u'نَفْيٌ رَعْيٌ':Added, #2: 2	نَفَى رَسُولُ
u'نَفْيٌ رَفْعٌ':Added, #2: 2	نَفْيِ الرَّعْيِ
u'نَفْيٌ رِقٌّ':Added, #1: 1	نَفْيِ رَفْعِ
u'نَفْيٌ رُكْن':Added, #3: 3	نَفْيِ الرِّقِّ
u'نَفْيٌ رُكْنِيّ':Added, #1: 1	نَفْيُ الرُّكْنِيَّةِ
u'نَفْيٌ رُكوبٌ':Added, #1: 1	نَفْيُ الرُّكْنِيَّةِ
u'نَفْيٌ رَهْنٌ':Added, #1: 1	نَفْيَ الرُّكُوبِ
u'نَفْيٌ رَهْن':Added, #1: 1	نَفْيِ الرَّهْنِ
u'نَفْيٌ رَهْنِيَّة':Added, #1: 1	نَفْيِ الرَّهْنِيَّةِ
u'نَفَى رِوايَةٌ':Predicate, #1: 1	نَفْيِ الرَّهْنِيَّةِ
u'نَفْيٌ رِوايَةٌ':Added, #1: 1	نَفَى رِوَايَةَ
u'نَفْيٌ رُؤْيَةٌ':Added, #1: 1	نَفْيُ رِوَايَةِ
u'نَفْيٌ رُؤْيَةٌ':Added, #1: 1	نَفْيِ الرُّؤْيَةِ
u'نَفْيٌ رُؤْيَةٌ':Added, #1: 1	نَفْيَ رُؤْيَةِ
u'نَفْيٌ رَيْبٌ':Added, #2: 2	نَفْيُ الرُّؤْيَةِ
u'نَفْيٌ زائِدٌ':Added, #1: 1	نَفْيُ رَيْبِ
u'نَفْيٌ زائِدٌ':Added, #4: 4	نَفْيَ الزَّائِدِ
u'نَفْيٌ زَكاةٌ':Added, #4: 4	نَفْيِ الزَّائِدِ
u'نَفْيٌ زَكاةٌ':Added, #1: 1	نَفْيَ الزَّكَاةِ
u'نَفَى زَوْجٌ':Subject, #3: 3	نَفْيِ الزَّكَاةِ
u'نَفْيٌ زَوْجِيٌّ':Added, #5: 5	نَفَى الزَّوْجُ
u'نَفْيٌ زَوْجِيٌّ':Added, #1: 1	نَفْيَ الزَّوْجِيَّةِ
u'نَفَى زِيادَةٌ':Predicate, #4: 4	نَفْيِ الزَّوْجِيَّةِ
u'نَفْيٌ زِيادَةٌ':Added, #1: 1	نَفَى الزِّيَادَةَ
u'نَفْيٌ زِيادَةٌ':Added, #2: 2	نَفْيُ الزِّيَادَةِ
u'نَفْيٌ سَابِقٌ':Added, #6: 6	نَفْيِ الزِّيَادَةِ
u'نَفْيٌ سَائِرٌ':Added, #1: 1	نَفْيَ سَابِقَةِ
u'نَفَى سَبَبٌ':Predicate, #1: 1	نَفْيَ سَائِرِ
u'نَفْيٌ سَبَبٌ':Added, #1: 1	نَفَى السَّبَبَ
u'نَفْيٌ سَبَبٌ':Added, #1: 1	نَفْيُ السَّبَبِ
u'نَفْيٌ سَبَبٌ':Added, #1: 1	نَفْيِ السَّبَبِ
u'نَفْيٌ سَبَبِيَّةٌ':Added, #2: 2	نَفْيَ السَّبَبِ
u'نَفْيٌ سَبَبِيَّةٌ':Added, #1: 1	نَفْيُ سَبَبِيَّتِهِ
u'نَفْيٌ سَبَبِيَّةٌ':Added, #2: 2	نَفْيَ السَّبَبِيَّةِ
u'نَفْيٌ سَبَبِيَّةٌ':Added, #2: 2	نَفْيُ السَّبَبِيَّةِ
u'نَفَى سَبْقٌ':Predicate, #2: 2	نَفْيِ السَّبَبِيَّةِ
u'نَفْيٌ سَبَقٌ':Added, #1: 1	نَفَى السَّبْقَ
u'نَفَى سَبِيلٌ':Predicate, #1: 1	نَفْيِ السَّبَقِ
u'نَفْيٌ سَبِيلٌ':Added, #2: 2	نَفَى السَّبِيلَ
u'نَفْيٌ سَبِيلٌ':Added, #1: 1	نَفْيُ السَّبِيلِ
u'نَفْيٌ سَرقَةٌ':Added, #2: 2	نَفْيَ السَّبِيلِ
u'نَفْيٌ سَرقَةٌ':Added, #1: 1	نَفْي السَّرِقَةِ
u'نَفْيٌ سَرِقَةٌ':Added, #1: 1	نَفْيَ السَّرِقَةِ
u'نَفْيٌ سَرِقَةٌ':Added, #1: 1	نَفْي السَّرِقَةِ
u'نَفْيٌ سُلْطَانٌ':Added, #1: 1	نَفْيَ السَّرِقَةِ
u'نَفْيٌ سَمَاعٌ':Added, #2: 2	نَفْيِ السُّلْطَانِ
u'نَفْيٌ سَمَاعٌ':Added, #1: 1	نَفْيُ السَّمَاعِ
u'نَفْيٌ سُنَّةٌ':Added, #1: 1	نَفْيِ سَمَاعِ
u'نَفْيٌ سَهْمٌ':Added, #2: 2	نَفْيُ السُّنَّةِ
u'نَفْيٌ سَهْوٌ':Added, #1: 1	نَفْيَ السَّهْمِ
u'نَفْيٌ سُؤَالٌ':Added, #1: 1	نَفْيُ السَّهْوِ
u'نَفَى شافِعِيّ':Subject, #1: 1	نَفْيُ السُّؤَالِ
u'نَفَى شِبْهٌ':Predicate, #2: 2	نَفَى الشَّافِعِيُّ
u'نَفْيٌ شَبَهٌ':Added, #1: 1	نَفَى شِبْهَ
u'نَفْيٌ شَبِيهٌ':Added, #1: 1	نَفْيِ الشَّبَهِ
u'نَفَى شَخْصٌ':Subject, #1: 1	نَفْيُ الشَّبِيهِ
u'نَفْيٌ شِدَّةٌ':Added, #1: 1	نَفَى شَخْصٌ
u'نَفْيٌ شِرَاءٌ':Added, #1: 1	نَفْيِ الشِّدَّةِ
u'نَفْيٌ شِرَاءٌ':Added, #1: 1	نَفْيُ الشِّرَاءِ
u'نَفْيٌ شَرْطٌ':Added, #5: 5	نَفْيِ الشِّرَاءِ
u'نَفْيٌ شَرْعِيٌّ':Added, #2: 2	نَفْيَ الشَّرْطِ
u'نَفْيٌ شركة':Added, #2: 2	نَفْيَ شَرْعِيَّةِ
u'نَفْيٌ شركة':Added, #1: 1	نَفْيُ الشَّرِكَةِ
u'نَفْيٌ شَرِكَةٌ':Added, #1: 1	نَفْيِ الشَّرِكَةِ
u'نَفْيٌ شَرِكَةٌ':Added, #1: 1	نَفْيُ الشَّرِكَةِ
u'نَفْيٌ شَرِيكٌ':Added, #1: 1	نَفْيِ الشَّرِكَةِ
u'نَفْيٌ شَرِيكٌ':Added, #1: 1	نَفْيُ الشَّرِيكِ
u'نَفْيٌ شفعة':Added, #1: 1	نَفْيِ الشَّرِيكِ
u'نَفْيٌ شُفْعَةٌ':Added, #1: 1	نَفْيُ الشُّفْعَةِ
u'نَفْيٌ شفعة':Added, #1: 1	نَفْيُ الشُّفْعَةِ
u'نَفْيٌ شُفْعَةٌ':Added, #2: 2	نَفْيِ الشُّفْعَةِ
u'نَفْيٌ شَكٌّ':Added, #2: 2	نَفْيِ الشُّفْعَةِ
u'نَفْيٌ شُمُول':Added, #1: 1	نَفْيَ الشَّكِّ
u'نَفْيٌ شُمُول':Added, #1: 1	نَفْيَ الشُّمُولِ
u'نَفْيٌ شَهَادَةٌ':Added, #1: 1	نَفْيُ الشُّمُولِ
u'نَفْيٌ شُؤْمٌ':Added, #1: 1	نَفْي الشَّهَادَةِ
u'نَفْيٌ شَيْءٌ':Added, #1: 1	نَفْيُ الشُّؤْمِ
u'نَفْيٌ شَيْء':Added, #1: 1	نَفْيَ الشَّيْءِ
u'نَفْيٌ شَيْءٌ':Added, #1: 1	نَفْيُ الشَّيْئِيَّةِ
u'نَفْيٌ شَيْءٌ':Added, #1: 1	نَفْيَ شَيْءٍ
u'نَفْيٌ شَيْخٌ':Added, #4: 4	نَفْيِ شَيْءٍ
u'نَفْيٌ صَانِعٌ':Added, #1: 1	نَفْيُ الشَّيْخَيْنِ
u'نَفْيٌ صحبة':Added, #1: 1	نَفْيِ الصَّانِعِ
u'نَفْيٌ صُحْبَةٌ':Added, #1: 1	نَفْيَ صُحْبَةِ
u'نَفْيٌ صِحَّةٌ':Added, #1: 1	نَفْيَ صُحْبَةِ
u'نَفْيٌ صِحَّةٌ':Added, #10: 10	نَفْيِ الصِّحَّةِ
u'نَفْيٌ صِحَّةٌ':Added, #1: 1	نَفْيُ صِحَّةِ
u'نَفْيٌ صِحَّةٌ':Added, #1: 1	نَفْيِ صِحَّةِ
u'نَفْيٌ صِحَّةٌ':Added, #1: 1	نَفْيَ صِحَّتِهِ
u'نَفْيٌ صِحَّةٌ':Added, #1: 1	نَفْيِ صِحَّتِهِ
u'نَفْيٌ صِحَّةٌ':Added, #3: 3	نَفْيُ الصِّحَّةِ
u'نَفْيٌ صَخَبٌ':Added, #5: 5	نَفْيَ الصِّحَّةِ
u'نَفْيٌ صَدَاقَةٌ':Added, #1: 1	نَفْيِ الصّخَبِ
u'نَفَى صدقة':Predicate, #1: 1	نَفْيَ الصَّدَاقَةِ
u'نَفَى صَدَقَةٌ':Predicate, #1: 1	نَفَى الصَّدَقَةَ
u'نَفْيٌ صدقة':Added, #1: 1	نَفَى الصَّدَقَةَ
u'نَفْيٌ صدقة':Added, #1: 1	نَفْيَ الصَّدَقَةِ
u'نَفْيٌ صَدَقَةٌ':Added, #1: 1	نَفْيِ الصَّدَقَةِ
u'نَفْيٌ صَدَقَةٌ':Added, #1: 1	نَفْيَ الصَّدَقَةِ
u'نَفَى صِفَةٌ':Predicate, #1: 1	نَفْيِ الصَّدَقَةِ
u'نَفْيٌ صِفَةٌ':Added, #1: 1	نَفَى صِفَةَ
u'نَفْيٌ صِفَةٌ':Added, #1: 1	نَفْيَ الصِّفَةِ
u'نَفْيٌ صِفَةٌ':Added, #1: 1	نَفْيُ صِفَةٍ
u'نَفْيٌ صِفَةٌ':Added, #1: 1	نَفْيُ صِفَتِهِ
u'نَفْيٌ صَلاَةٌ':Added, #2: 2	نَفْيِ الصِّفَاتِ
u'نَفْيٌ صَلاَةٌ':Added, #1: 1	نَفْيَ الصَّلَاةِ
u'نَفْيٌ صَوْمٌ':Added, #2: 2	نَفْيِ الصَّلَاةِ
u'نَفْيٌ صِيَغٌ':Added, #1: 1	نَفْيِ الصَّوْمِ
u'نَفْيٌ ضحك':Added, #1: 1	نَفْيَ صِيَغِ
u'نَفْيٌ ضَحِكٌ':Added, #1: 1	نَفْيُ الضَّحِكِ
u'نَفْيٌ ضَمٌّ':Added, #1: 1	نَفْيُ الضَّحِكِ
u'نَفْيٌ ضَمَانٌ':Added, #1: 1	نَفْيَ ضَمِّ
u'نَفْيٌ ضَمَانٌ':Added, #1: 1	نَفْيَ ضَمَانِ
u'نَفْيٌ ضَمَانٌ':Added, #21: 21	نَفْيِ الضَّمَانِ
u'نَفْيٌ ضَمَانٌ':Added, #6: 6	نَفْيَ الضَّمَانِ
u'نَفَى طَلاَقٌ':Predicate, #7: 7	نَفْيُ الضَّمَانِ
u'نَفْيٌ طَلاَقٌ':Added, #1: 1	نَفَى الطَّلَاقَ
u'نَفْيٌ طَهَارَةٌ':Added, #2: 2	نَفْيِ الطَّلَاقِ
u'نَفْيٌ طَهُور':Added, #1: 1	نَفْيِ الطَّهَارَةِ
u'نَفَى ظاهِرٌ':Subject, #1: 1	نَفْيِ طَهُورِيَّةِ
u'نَفَى ظَنّ':Predicate, #1: 1	نَفَى ظَاهِرُ
u'نَفْيٌ ظَنٌّ':Added, #1: 1	نَفَى ظَنِّيَّةَ
u'نَفَى ظَنِّيّ':Predicate, #1: 1	نَفْيَ ظَنِّ
u'نَفْيٌ ظهار':Added, #1: 1	نَفَى ظَنِّيَّةَ
u'نَفْيٌ ظُهورٌ':Added, #1: 1	نَفْيُ الظِّهَارِ
u'نَفْيٌ ظُهورٌ':Added, #1: 1	نَفْيَ ظُهُورِهِ
u'نَفْيٌ عَالِمٌ':Added, #1: 1	نَفْيِ ظُهُورِهِ
u'نَفْيٌ عَامٌّ':Added, #1: 1	نَفْيِ الْعَالِمِ
u'نَفْيٌ عَامٌّ':Added, #2: 2	نَفْيَ الْعَامِّ
u'نَفَى عِبَادَةٌ':Predicate, #2: 2	نَفْيُ الْعَامِّ
u'نَفْيٌ عِبَادَةٌ':Added, #1: 1	نَفَى الْعِبَادَةَ
u'نَفْيٌ عتق':Added, #1: 1	نَفْيُ الْعِبَادَةِ
u'نَفْيٌ عِتْقٌ':Added, #1: 1	نَفْيُ الْعِتْقِ
u'نَفْيٌ عتق':Added, #1: 1	نَفْيُ الْعِتْقِ
u'نَفْيٌ عِتْقٌ':Added, #2: 2	نَفْيِ الْعِتْقِ
u'نَفْيٌ عَدَاوَةٌ':Added, #2: 2	نَفْيِ الْعِتْقِ
u'نَفْيٌ عِدَّةٌ':Added, #1: 1	نَفْيِ الْعَدَاوَةِ
u'نَفْيٌ عَدَمٌ':Added, #1: 1	نَفْيُ الْعِدَّةِ
u'نَفْيٌ عَدَمٌ':Added, #1: 1	نَفْيُ الْعَدَمِ
u'نَفْيٌ عَدَمٌ':Added, #1: 1	نَفْيُ عَدَمِ
u'نَفَى عُذْرٌ':Predicate, #2: 2	نَفْيَ عَدَمِ
u'نَفْيٌ عرف':Added, #1: 1	نَفَى الْعُذْرَ
u'نَفْيٌ عُرْفٌ':Added, #1: 1	نَفْيُ الْعُرْفِ
u'نَفْيٌ عصبة':Added, #1: 1	نَفْيُ الْعُرْفِ
u'نَفْيٌ عَصَبَةٌ':Added, #1: 1	نَفْيِ الْعَصَبَةِ
u'نَفْيٌ عِصْيَانٌ':Added, #1: 1	نَفْيِ الْعَصَبَةِ
u'نَفْيٌ عِصْيَانٌ':Added, #1: 1	نَفْيُ الْعِصْيَانِ
u'نَفْيٌ عقاب':Added, #1: 1	نَفْيِ عِصْيَانِ
u'نَفْيٌ عِقَابٌ':Added, #1: 1	نَفْيِ الْعِقَابِ
u'نَفْيٌ عَقْدٌ':Added, #1: 1	نَفْيِ الْعِقَابِ
u'نَفْيٌ عَقْدٌ':Added, #1: 1	نَفْيِ الْعَقْدِ
u'نَفْيٌ عَقْلٌ':Added, #1: 1	نَفْيُ عَقْدِ
u'نَفْيٌ عِلَّةٌ':Added, #1: 1	نَفْيِ الْعَقْلِ
u'نَفْيٌ عِلَّةٌ':Added, #1: 1	نَفْيِ عِلَّتِهِ
u'نَفْيٌ عِلَّةٌ':Added, #3: 3	نَفْيُ الْعِلَّةِ
u'نَفَى علم':Predicate, #3: 3	نَفْيِ الْعِلَّةِ
u'نَفَى عِلْمٌ':Predicate, #2: 2	نَفَى الْعِلْمَ
u'نَفْيٌ علم':Added, #2: 2	نَفَى الْعِلْمَ
u'نَفْيٌ عِلْمٌ':Added, #123: 123	نَفْيِ الْعِلْمِ
u'نَفْيٌ علم':Added, #123: 123	نَفْيِ الْعِلْمِ
u'نَفْيٌ علم':Added, #1: 1	نَفْيَ عِلْمٍ
u'نَفْيٌ علم':Added, #1: 1	نَفْيَ عِلْمِ
u'نَفْيٌ عِلْمٌ':Added, #1: 1	نَفْيِ عِلْمِ
u'نَفْيٌ عِلْمٌ':Added, #1: 1	نَفْيَ عِلْمٍ
u'نَفْيٌ عِلْمٌ':Added, #1: 1	نَفْيَ عِلْمِ
u'نَفْيٌ علم':Added, #1: 1	نَفْيِ عِلْمِ
u'نَفْيٌ عِلْمٌ':Added, #5: 5	نَفْيُ الْعِلْمِ
u'نَفْيٌ علم':Added, #5: 5	نَفْيُ الْعِلْمِ
u'نَفْيٌ عِلْمٌ':Added, #5: 5	نَفْيِ عِلْمِهِ
u'نَفْيٌ عِلِّيٌّ':Added, #5: 5	نَفْيِ عِلْمِهِ
u'نَفْيٌ عِلِّيٌّ':Added, #1: 1	نَفْيُ عِلِّيَّةِ
u'نَفْيٌ عِمَارَةٌ':Added, #1: 1	نَفْيِ عِلِّيَّةِ
u'نَفْيٌ عَمْد':Added, #1: 1	نَفْيِ الْعِمَارَةِ
u'نَفْيٌ عَمْدٌ':Added, #1: 1	نَفْيِ الْعَمْدِيَّةِ
u'نَفْيٌ عَمْدِيّ':Added, #2: 2	نَفْيِ الْعَمْدِ
u'نَفَى عُمُومٌ':Predicate, #1: 1	نَفْيِ الْعَمْدِيَّةِ
u'نَفْيٌ عُمُومٌ':Added, #1: 1	نَفَى الْعُمُومَ
u'نَفْيٌ عُمُومٌ':Added, #1: 1	نَفْيَ الْعُمُومِ
u'نَفْيٌ عُمُومٌ':Added, #1: 1	نَفْيِ الْعُمُومِ
u'نَفْيٌ عُمُومٌ':Added, #1: 1	نَفْيُ عُمُومِ
u'نَفَى عَوْدٌ':Predicate, #2: 2	نَفْيُ عُمُومِهِ
u'نَفَى عِوَضٌ':Predicate, #1: 1	نَفَى عَوْدَ
u'نَفْيٌ عِوَضٌ':Added, #1: 1	نَفَى الْعِوَضَ
u'نَفْيٌ عِوَضٌ':Added, #1: 1	نَفْيُ الْعِوَضِ
u'نَفْيٌ عِوَضٌ':Added, #1: 1	نَفْيِ عِوَضِهِ
u'نَفَى عَيْبٌ':Predicate, #6: 6	نَفْيِ الْعِوَضِ
u'نَفْيٌ عَيْبٌ':Added, #1: 1	نَفَى الْعَيْبَ
u'نَفْيٌ عَيْبٌ':Added, #1: 1	نَفْيُ الْعَيْبِ
u'نَفْيٌ عَيْبٌ':Added, #1: 1	نَفْيِ الْعَيْبِ
u'نَفْيٌ عين':Added, #3: 3	نَفْيَ عَيْبٍ
u'نَفْيٌ عَيْنٌ':Added, #1: 1	نَفْيَ الْعَيْنِ
u'نَفْيٌ عَيْن':Added, #1: 1	نَفْيَ الْعَيْنِ
u'نَفْيٌ عين':Added, #1: 1	نَفْيَ الْعَيْنِ
u'نَفْيٌ عَيْنٌ':Added, #1: 1	نَفْيِ عَيْنِ
u'نَفْيٌ عَيْن':Added, #1: 1	نَفْيِ عَيْنِ
u'نَفْيٌ عَيْنِيَّةٌ':Added, #1: 1	نَفْيِ عَيْنِ
u'نَفْيٌ عُيُوبٌ':Added, #1: 1	نَفْيِ الْعَيْنِيَّةِ
u'نَفْيٌ غَرابَة':Added, #1: 1	نَفْيَ الْعُيُوبِ
u'نَفْيٌ غَرابَة':Added, #1: 1	نَفْيُ الْغَرَابِيَّةِ
u'نَفْيٌ غَرَرٌ':Added, #1: 1	نَفْيِ الْغَرَابِيَّةِ
u'نَفْيٌ غَرَرٌ':Added, #1: 1	نَفْيُ الْغَرَرِ
u'نَفْيٌ غَسْلٌ':Added, #1: 1	نَفْيِ الْغَرَرِ
u'نَفْيٌ غُسْلٌ':Added, #1: 1	نَفْيُ الْغَسْلِ
u'نَفْيٌ غَصْبٌ':Added, #1: 1	نَفْيِ الْغُسْلِ
u'نَفْيٌ غَصْبٌ':Added, #2: 2	نَفْيِ الْغَصْبِ
u'نَفْيٌ غضب':Added, #3: 3	نَفْيَ الْغَصْبِ
u'نَفْيٌ غَضَبٌ':Added, #1: 1	نَفْيِ الْغَضَبِ
u'نَفْيٌ غَلَبَةٌ':Added, #1: 1	نَفْيِ الْغَضَبِ
u'نَفْيٌ غير':Added, #1: 1	نَفْيِ غَلَبَةِ
u'نَفْيٌ غَيْرٌ':Added, #1: 1	نَفْيَ غَيْرِ
u'نَفْيٌ غير':Added, #1: 1	نَفْيَ غَيْرِ
u'نَفْيٌ غَيْرٌ':Added, #2: 2	نَفْيِ غَيْرِ
u'نَفْيٌ غير':Added, #2: 2	نَفْيِ غَيْرِ
u'نَفْيٌ غير':Added, #2: 2	نَفْيَ غَيْرِهِ
u'نَفْيٌ غير':Added, #2: 2	نَفْيُ غَيْرِهِ
u'نَفْيٌ غَيْرٌ':Added, #2: 2	نَفْيِ غَيْرِهِ
u'نَفْيٌ غَيْرٌ':Added, #2: 2	نَفْيَ غَيْرِهِ
u'نَفْيٌ غَيْرٌ':Added, #2: 2	نَفْيُ غَيْرِهِ
u'نَفْيٌ فَارِقٌ':Added, #2: 2	نَفْيِ غَيْرِهِ
u'نَفْيٌ فَارِقٌ':Added, #2: 2	نَفْيَ الْفَارِقِ
u'نَفْيٌ فَارِقٌ':Added, #4: 4	نَفْيُ الْفَارِقِ
u'نَفْيٌ فَائِدَةٌ':Added, #6: 6	نَفْيِ الْفَارِقِ
u'نَفْيٌ فَائِدَةٌ':Added, #1: 1	نَفْيُ الْفَائِدَةِ
u'نَفْيٌ فَائِدَةٌ':Added, #1: 1	نَفْيِ الْفَائِدَةِ
u'نَفْيٌ فَائِدَةٌ':Added, #1: 1	نَفْيَ فَائِدَةِ
u'نَفْيٌ فَائِدَةٌ':Added, #1: 1	نَفْيُ فَائِدَتِهِ
u'نَفْيٌ فَرْض':Added, #2: 2	نَفْيَ الْفَائِدَةِ
u'نَفْيٌ فَرْضِيّ':Added, #1: 1	نَفْيُ الْفَرْضِيَّةِ
u'نَفْيٌ فَرْضِيَّة':Added, #1: 1	نَفْيُ الْفَرْضِيَّةِ
u'نَفْيٌ فرق':Added, #1: 1	نَفْيُ الْفَرْضِيَّةِ
u'نَفْيٌ فَرْقٌ':Added, #1: 1	نَفْيَ الْفَرْقِ
u'نَفْيٌ فُرْقَةٌ':Added, #1: 1	نَفْيَ الْفَرْقِ
u'نَفْيٌ فَرِيضَةٌ':Added, #1: 1	نَفْيِ الْفُرْقَةِ
u'نَفْيٌ فساد':Added, #1: 1	نَفْيِ الْفَرِيضَةِ
u'نَفْيٌ فَسَادٌ':Added, #1: 1	نَفْيَ الْفَسَادِ
u'نَفَى فَضْلٌ':Predicate, #1: 1	نَفْيَ الْفَسَادِ
u'نَفْيٌ فَضِيلٌ':Added, #1: 1	نَفَى فَضْلَ
u'نَفْيٌ فَضِيلٌ':Added, #6: 6	نَفْيُ الْفَضِيلَةِ
u'نَفْيٌ فَضِيلَةٌ':Added, #6: 6	نَفْيِ الْفَضِيلَةِ
u'نَفْيٌ فَضِيلَةٌ':Added, #6: 6	نَفْيُ الْفَضِيلَةِ
u'نَفَى فِعْلٌ':Predicate, #6: 6	نَفْيِ الْفَضِيلَةِ
u'نَفْيٌ فِعْلٌ':Added, #2: 2	نَفَى الْفِعْلَ
u'نَفْيٌ فِعْلٌ':Added, #16: 16	نَفْيِ فِعْلِ
u'نَفْيٌ فِعْلٌ':Added, #1: 1	نَفْيَ فِعْلِ
u'نَفْيٌ فِعْلٌ':Added, #1: 1	نَفْيُ فِعْلِ
u'نَفْيٌ فِعْلٌ':Added, #1: 1	نَفْيِ فِعْلٍ
u'نَفْيٌ فِعْلٌ':Added, #2: 2	نَفْيِ فِعْلِهِ
u'نَفْيٌ فِعْلٌ':Added, #3: 3	نَفْيُ الْفِعْلِ
u'نَفَى فلان':Subject, #4: 4	نَفْيِ الْفِعْلِ
u'نَفَى فلان':Subject, #1: 1	نَفَى عُثْمَانُ
u'نَفْيٌ فلان':Added, #2: 2	نَفَى الشَّافِعِيُّ
u'نَفْيٌ فَهْمٌ':Added, #1: 1	نَفْيُ الرُّكْنِيَّةِ
u'نَفْيٌ قَبُولٌ':Added, #1: 1	نَفْيَ فَهْمِ
u'نَفْيٌ قَبُولٌ':Added, #1: 1	نَفْيَ الْقَبُولِ
u'نَفْيٌ قَبُولٌ':Added, #1: 1	نَفْيِ قَبُولِ
u'نَفْيٌ قَبُولٌ':Added, #1: 1	نَفْيَ قَبُولِهِ
u'نَفْيٌ قَبُولٌ':Added, #2: 2	نَفْيُ الْقَبُولِ
u'نَفْيٌ قَبُولٌ':Added, #3: 3	نَفْيِ الْقَبُولِ
u'نَفْيٌ قتل':Added, #3: 3	نَفْيُ قَبُولِهِ
u'نَفْيٌ قَتْلٌ':Added, #1: 1	نَفْيُ الْقَتْلِ
u'نَفْيٌ قتل':Added, #1: 1	نَفْيُ الْقَتْلِ
u'نَفْيٌ قَتْلٌ':Added, #1: 1	نَفْيِ قَتْلِ
u'نَفْيٌ قتل':Added, #1: 1	نَفْيِ قَتْلِ
u'نَفْيٌ قَتْلٌ':Added, #2: 2	نَفْيِ الْقَتْلِ
u'نَفَى قَدَرٌ':Predicate, #2: 2	نَفْيِ الْقَتْلِ
u'نَفَى قدرة':Predicate, #1: 1	نَفَى الْقَدَرَ
u'نَفَى قُدْرَةٌ':Predicate, #1: 1	نَفَى الْقُدْرَةَ
u'نَفْيٌ قدرة':Added, #1: 1	نَفَى الْقُدْرَةَ
u'نَفْيٌ قُدْرَةٌ':Added, #2: 2	نَفْيِ الْقُدْرَةِ
u'نَفْيٌ قدرة':Added, #2: 2	نَفْيِ الْقُدْرَةِ
u'نَفْيٌ قُدْرَةٌ':Added, #3: 3	نَفْيَ الْقُدْرَةِ
u'نَفْيٌ قدم':Added, #3: 3	نَفْيَ الْقُدْرَةِ
u'نَفْيٌ قِدَمٌ':Added, #1: 1	نَفْيُ قِدَمِ
u'نَفَى قَذَرٌ':Predicate, #1: 1	نَفْيُ قِدَمِ
u'نَفْيٌ قذف':Added, #1: 1	نَفَى الْقَذَرَ
u'نَفْيٌ قَذْفٌ':Added, #1: 1	نَفْيُ الْقَذْفِ
u'نَفَى قِرَاءةٌ':Predicate, #1: 1	نَفْيُ الْقَذْفِ
u'نَفْيٌ قِرَاءةٌ':Added, #1: 1	نَفَى قِرَاءَةَ
u'نَفْيٌ قُرْبَانٌ':Added, #1: 1	نَفْيَ الْقِرَاءَةِ
u'نَفْيٌ قُرَيْشٌ':Added, #1: 1	نَفْيِ الْقُرْبَانِ
u'نَفْيٌ قَرِينٌ':Added, #1: 1	نَفْيَ قُرَيْشٍ
u'نَفْيٌ قصاص':Added, #1: 1	نَفْيِ الْقَرِينَةِ
u'نَفْيٌ قصاص':Added, #1: 1	نَفْيَ الْقِصَاصِ
u'نَفْيٌ قِصَاصٌ':Added, #1: 1	نَفْيِ الْقِصَاصِ
u'نَفْيٌ قِصَاصٌ':Added, #1: 1	نَفْيَ الْقِصَاصِ
u'نَفَى قَضَاءٌ':Predicate, #1: 1	نَفْيِ الْقِصَاصِ
u'نَفْيٌ قَضَاءٌ':Added, #1: 1	نَفَى الْقَضَاءَ
u'نَفْيٌ قَضَاءٌ':Added, #1: 1	نَفْيُ قَضَاءِ
u'نَفْيٌ قَضَاءٌ':Added, #1: 1	نَفْيِ قَضَاءِ
u'نَفْيٌ قَطْعٌ':Added, #2: 2	نَفْيِ الْقَضَاءِ
u'نَفْيٌ قَطْعٌ':Added, #1: 1	نَفْيِ قَطْعِ
u'نَفَى قَفَّالٌ':Subject, #1: 1	نَفْيِ قَطْعِهِ
u'نَفْيٌ قلب':Added, #1: 1	نَفَى الْقَفَّالُ
u'نَفْيٌ قَلْبٌ':Added, #1: 1	نَفْيُ قَلْبِهِ
u'نَفْيٌ قَلْب':Added, #1: 1	نَفْيُ قَلْبِهِ
u'نَفْيٌ قَمْلٌ':Added, #1: 1	نَفْيُ قَلْبِهِ
u'نَفْيٌ قَمِيصٌ':Added, #1: 1	نَفْيُ الْقَمْلِ
u'نَفْيٌ قَوَد':Added, #1: 1	نَفْيِ الْقَمِيصِ
u'نَفْيٌ قول':Added, #1: 1	نَفْيَ الْقَوَدِ
u'نَفْيٌ قَوْلٌ':Added, #11: 11	نَفْيِ قَوْلِ
u'نَفْيٌ قول':Added, #11: 11	نَفْيِ قَوْلِ
u'نَفْيٌ قول':Added, #1: 1	نَفْيُ الْقَوْلِ
u'نَفْيٌ قَوْلٌ':Added, #1: 1	نَفْيِ الْقَوْلِ
u'نَفْيٌ قَوْلٌ':Added, #1: 1	نَفْيُ الْقَوْلِ
u'نَفْيٌ قول':Added, #1: 1	نَفْيِ الْقَوْلِ
u'نَفْيٌ قَوْلٌ':Added, #1: 1	نَفْيِ قَوْلِهِ
u'نَفْيٌ قول':Added, #1: 1	نَفْيِ قَوْلِهِ
u'نَفْيٌ قَوْلٌ':Added, #3: 3	نَفْيَ الْقَوْلِ
u'نَفْيٌ قول':Added, #3: 3	نَفْيَ الْقَوْلِ
u'نَفْيٌ قَوْلٌ':Added, #4: 4	نَفْيُ قَوْلِ
u'نَفَى قِيَاسٌ':Predicate, #4: 4	نَفْيُ قَوْلِ
u'نَفْيٌ قِيَاسٌ':Added, #1: 1	نَفَى الْقِيَاسَ
u'نَفْيٌ قِيَاسٌ':Added, #1: 1	نَفْيَ الْقِيَاسِ
u'نَفْيٌ قِيَاسٌ':Added, #1: 1	نَفْيِ قِيَاسِ
u'نَفْيٌ قيام':Added, #2: 2	نَفْيِ الْقِيَاسِ
u'نَفْيٌ قيام':Added, #1: 1	نَفْيَ الْقِيَامِ
u'نَفْيٌ قيام':Added, #1: 1	نَفْيُ الْقِيَامِ
u'نَفْيٌ قِيَامٌ':Added, #1: 1	نَفْيِ الْقِيَامِ
u'نَفْيٌ قِيَامٌ':Added, #1: 1	نَفْيَ الْقِيَامِ
u'نَفْيٌ قِيَامٌ':Added, #1: 1	نَفْيُ الْقِيَامِ
u'نَفَى كِبْرِيَاءُ':Predicate, #1: 1	نَفْيِ الْقِيَامِ
u'نَفْيٌ كِبْرِيَاءُ':Added, #1: 1	نَفَى الْكِبْرِيَاءَ
u'نَفْيٌ كِبْرِيَاءُ':Added, #1: 1	نَفْيَ الْكِبْرِيَاءِ
u'نَفْيٌ كِبْرِيَاءُ':Added, #1: 1	نَفْيِ الْكِبْرِيَاءِ
u'نَفْيٌ كَثْرَةٌ':Added, #3: 3	نَفْيُ الْكِبْرِيَاءِ
u'نَفَى كَرَاهَةٌ':Predicate, #1: 1	نَفْيُ الْكَثْرَةِ
u'نَفْيٌ كَرَاهَةٌ':Added, #1: 1	نَفَى الْكَرَاهَةَ
u'نَفْيٌ كَرَاهَةٌ':Added, #1: 1	نَفْيُ كَرَاهَةِ
u'نَفْيٌ كَرَاهَةٌ':Added, #2: 2	نَفْيُ الْكَرَاهَةِ
u'نَفْيٌ كَرَاهَةٌ':Added, #4: 4	نَفْيَ الْكَرَاهَةِ
u'نَفْيٌ كَرَاهِيَةٌ':Added, #4: 4	نَفْيِ الْكَرَاهَةِ
u'نَفْيٌ كَسْبٌ':Added, #1: 1	نَفْيِ الْكَرَاهِيَةِ
u'نَفْيٌ كَفَّارٌ':Added, #1: 1	نَفْيُ كَسْبِ
u'نَفْيٌ كَفَّارَةٌ':Added, #1: 1	نَفْيِ الْكَفَّارَةِ
u'نَفْيٌ كَفَالَةٌ':Added, #1: 1	نَفْيِ الْكَفَّارَةِ
u'نَفْيٌ كفر':Added, #1: 1	نَفْيُ الْكَفَالَةِ
u'نَفْيٌ كُفْرٌ':Added, #1: 1	نَفْيِ الْكُفْرِ
u'نَفَى كَلاَمٌ':Predicate, #1: 1	نَفْيِ الْكُفْرِ
u'نَفْيٌ كَلاَمٌ':Added, #1: 1	نَفَى كَلَامَ
u'نَفْيٌ كَلاَمٌ':Added, #1: 1	نَفْيِ الْكَلَامِ
u'نَفْيٌ كُلِّيٌّ':Added, #1: 1	نَفْيِ كَلَامِ
u'نَفْيٌ كُلِّيَّةٌ':Added, #1: 1	نَفْيَ الْكُلِّيَّةِ
u'نَفْيٌ كَمَالٌ':Added, #1: 1	نَفْيَ الْكُلِّيَّةِ
u'نَفْيٌ كَمَالٌ':Added, #15: 15	نَفْيِ الْكَمَالِ
u'نَفْيٌ كَمَالٌ':Added, #7: 7	نَفْيَ الْكَمَالِ
u'نَفَى كَوْنٌ':Predicate, #7: 7	نَفْيُ الْكَمَالِ
u'نَفْيٌ كَوْنٌ':Added, #1: 1	نَفَى كَوْنَ
u'نَفْيٌ كَوْنٌ':Added, #13: 13	نَفْيُ كَوْنِهِ
u'نَفْيٌ كَوْنٌ':Added, #1: 1	نَفْيَ كَوْنِ
u'نَفْيٌ كَوْنٌ':Added, #3: 3	نَفْيِ كَوْنِهِ
u'نَفْيٌ كَوْنٌ':Added, #4: 4	نَفْيُ كَوْنِ
u'نَفَى لاَزِمٌ':Predicate, #6: 6	نَفْيِ كَوْنِ
u'نَفْيٌ لاَزِمٌ':Added, #1: 1	نَفَى لَازِمَ
u'نَفْيٌ لاَزِمٌ':Added, #1: 1	نَفْي اللَّازِمِ
u'نَفْيٌ لاَزِمٌ':Added, #1: 1	نَفْيُ اللَّازِمِ
u'نَفْيٌ لاَزِمٌ':Added, #1: 1	نَفْيٍ لَازِمٍ
u'نَفَى لُزُومٌ':Predicate, #3: 3	نَفْيَ اللَّازِمِ
u'نَفْيٌ لُزُومٌ':Added, #1: 1	نَفَى لُزُومَ
u'نَفْيٌ لُزُومٌ':Added, #1: 1	نَفْيَ اللُّزُومِ
u'نَفْيٌ لُزُومٌ':Added, #1: 1	نَفْيِ لُزُومِ
u'نَفْيٌ لَفْظٌ':Added, #2: 2	نَفْيُ اللُّزُومِ
u'نَفْيٌ لَفْظِيٌّ':Added, #1: 1	نَفْيِ اللَّفْظِ
u'نَفْيٌ مَالٌ':Added, #1: 1	نَفْيُ اللَّفْظِيِّ
u'نَفْيٌ مَانِعٌ':Added, #1: 1	نَفْيَ الْمَالِ
u'نَفْيٌ مَائِيُّ':Added, #1: 1	نَفْيَ مَانِعٍ
u'نَفْيٌ مُبَاحٌ':Added, #1: 1	نَفْيَ الْمَائِيَّةِ
u'نَفْيٌ مُبَاحٌ':Added, #1: 1	نَفْيَ الْمُبَاحِ
u'نَفْيٌ مُبَاحٌ':Added, #1: 1	نَفْيُ الْمُبَاحِ
u'نَفْيٌ مُبَالَغَةٌ':Added, #2: 2	نَفْيِ الْمُبَاحِ
u'نَفْيٌ مثل':Added, #1: 1	نَفْيِ الْمُبَالَغَةِ
u'نَفْيٌ مثل':Added, #1: 1	نَفْيَ الْمِثْلِ
u'نَفْيٌ مِثْلٌ':Added, #1: 1	نَفْيِ الْمِثْلِ
u'نَفْيٌ مِثْلٌ':Added, #1: 1	نَفْيَ الْمِثْلِ
u'نَفْيٌ مثل':Added, #1: 1	نَفْيِ الْمِثْلِ
u'نَفْيٌ مِثْلٌ':Added, #1: 1	نَفْيَ مِثْلِ
u'نَفْيٌ مِثْلٌ':Added, #1: 1	نَفْيَ مِثْلِ
u'نَفْيٌ مثل':Added, #1: 1	نَفْيِ مِثْلٍ
u'نَفْيٌ مِثْلٌ':Added, #1: 1	نَفْيِ مِثْلِهِ
u'نَفْيٌ مثل':Added, #1: 1	نَفْيِ مِثْلِهِ
u'نَفْيٌ مِثْلٌ':Added, #2: 2	نَفْيُ الْمِثْلِ
u'نَفْيٌ مثل':Added, #2: 2	نَفْيُ الْمِثْلِ
u'نَفْيٌ مِثْلٌ':Added, #2: 2	نَفْيَ مِثْلِهِ
u'نَفْيٌ مثل':Added, #2: 2	نَفْيَ مِثْلِهِ
u'نَفْيٌ مِثْلٌ':Added, #4: 4	نَفْيُ مِثْلِ
u'نَفْيٌ مثل':Added, #4: 4	نَفْيُ مِثْلِ
u'نَفْيٌ مِثْلٌ':Added, #4: 4	نَفْيُ مِثْلِهِ
u'نَفْيٌ مثل':Added, #4: 4	نَفْيُ مِثْلِهِ
u'نَفْيٌ مِثْلٌ':Added, #6: 6	نَفْيِ مِثْلِ
u'نَفْيٌ مَجَازٌ':Added, #6: 6	نَفْيِ مِثْلِ
u'نَفْيٌ مُجْتَهِد':Added, #1: 1	نَفْيِ الْمَجَازِ
u'نَفْيٌ مَجْمُوعٌ':Added, #1: 1	نَفْيَ الْمُجْتَهِدِ
u'نَفْيٌ مَجْمُوعٌ':Added, #1: 1	نَفْيَ الْمَجْمُوعِ
u'نَفْيٌ مَحْصُورٌ':Added, #1: 1	نَفْيِ الْمَجْمُوعِ
u'نَفْيٌ مَحَلِّيٌّ':Added, #1: 1	نَفْيٍ مَحْصُورٍ
u'نَفْيٌ مَحَلِّيَّةٌ':Added, #1: 1	نَفْيَ الْمَحَلِّيَّةِ
u'نَفْيٌ مُخَالَفَةٌ':Added, #1: 1	نَفْيَ الْمَحَلِّيَّةِ
u'نَفْيٌ مُخَنَّث':Added, #1: 1	نَفْيُ الْمُخَالَفَةِ
u'نَفْيٌ مَدْحٌ':Added, #1: 1	نَفْيُ الْمُخَنَّثِ
u'نَفْيٌ مَدْلُولٌ':Added, #1: 1	نَفْيِ الْمَدْحِ
u'نَفْيٌ مَذْكُورٌ':Added, #1: 1	نَفْيِ مَدْلُولِهِ
u'نَفْيٌ مَذْهَبٌ':Added, #1: 1	نَفْيِ الْمَذْكُورِ
u'نَفْيٌ مُرَجِّحٌ':Added, #2: 2	نَفْيِ مَذْهَبِ
u'نَفْيٌ مُرْسَلٌ':Added, #1: 1	نَفْيُ الْمُرَجِّحِ
u'نَفْيٌ مَسْأَلَةٌ':Added, #1: 1	نَفْيَ الْمُرْسَلِ
u'نَفَى مُسَاوَاةٌ':Predicate, #1: 1	نَفْيِ الْمَسْأَلَةِ
u'نَفْيٌ مُسَاوَاةٌ':Added, #1: 1	نَفَى الْمُسَاوَاةَ
u'نَفْيٌ مُسَاوَاةٌ':Added, #4: 4	نَفْيُ الْمُسَاوَاةِ
u'نَفْيٌ مُسَاوَاةٌ':Added, #5: 5	نَفْيَ الْمُسَاوَاةِ
u'نَفْيٌ مُسْتَحَبٌّ':Added, #8: 8	نَفْيِ الْمُسَاوَاةِ
u'نَفْيٌ مُسْتَنَدٌ':Added, #1: 1	نَفْيِ الْمُسْتَحَبِّ
u'نَفْيٌ مَسِيسٌ':Added, #1: 1	نَفْيِ الْمُسْتَنَدِ
u'نَفْيٌ مُشَابَهَةٌ':Added, #2: 2	نَفْيِ الْمَسِيسِ
u'نَفْيٌ مُشَابَهَةٌ':Added, #1: 1	نَفْيِ الْمُشَابَهَةِ
u'نَفْيٌ مُشَابَهَةٌ':Added, #1: 1	نَفْيُ مُشَابَهَتِهِ
u'نَفْيٌ مُشَارَكَةٌ':Added, #1: 1	نَفْيِ مُشَابَهَتِهِ
u'نَفْيٌ مُشَارَكَةٌ':Added, #2: 2	نَفْيِ مُشَارَكَةِ
u'نَفْيٌ مُشْتَرَكٌ':Added, #4: 4	نَفْيَ الْمُشَارَكَةِ
u'نَفْيٌ مَصْدَرٌ':Added, #4: 4	نَفْيَ الْمُشْتَرَكِ
u'نَفْيٌ مَصْدَرٌ':Added, #1: 1	نَفْيُ الْمَصْدَرِ
u'نَفْيٌ مُطَابَقَةٌ':Added, #2: 2	نَفْيِ الْمَصْدَرِ
u'نَفْيٌ مَطَرٌ':Added, #1: 1	نَفْيَ الْمُطَابَقَةِ
u'نَفْيٌ مُطْلَقٌ':Added, #1: 1	نَفْيِ الْمَطَرِ
u'نَفْيٌ مُطْلَقٌ':Added, #1: 1	نَفْيُ الْمُطْلَقِ
u'نَفْيٌ مُعارِضٌ':Added, #2: 2	نَفْيُ مُطْلَقِ
u'نَفْيٌ مَعْرِفَةٌ':Added, #3: 3	نَفْيِ الْمُعَارِضِ
u'نَفْيٌ مَعْرِفَة':Added, #1: 1	نَفْيِ الْمَعْرِفَةِ
u'نَفْيٌ مَعْرِفَةٌ':Added, #1: 1	نَفْيِ الْمَعْرِفَةِ
u'نَفْيٌ مَعْرِفَة':Added, #1: 1	نَفْيِ مَعْرِفَتِهِ
u'نَفْيٌ مَعْصِيَةٌ':Added, #1: 1	نَفْيِ مَعْرِفَتِهِ
u'نَفْيٌ مَعْصِيَةٌ':Added, #1: 1	نَفْيُ الْمَعْصِيَةِ
u'نَفْيٌ مُفْسِدٌ':Added, #1: 1	نَفْيِ الْمَعْصِيَةِ
u'نَفَى مَفْهُومٌ':Predicate, #1: 1	نَفْيِ الْمُفْسِدِ
u'نَفْيٌ مَفْهُومٌ':Added, #1: 1	نَفَى الْمَفْهُومَ
u'نَفْيٌ مَفْهُومٌ':Added, #1: 1	نَفْيُ الْمَفْهُومِ
u'نَفْيٌ مَفْهُومٌ':Added, #1: 1	نَفْيِ مَفْهُومِ
u'نَفْيٌ مُقَاصَّةٌ':Added, #2: 2	نَفْيِ الْمَفْهُومِ
u'نَفْيٌ مُقَاصَّةٌ':Added, #1: 1	نَفْيَ الْمُقَاصَّةِ
u'نَفْيٌ مُقَيَّدٌ':Added, #1: 1	نَفْيِ الْمُقَاصَّةِ
u'نَفْيٌ مَكَانٌ':Added, #4: 4	نَفْيُ الْمُقَيَّدِ
u'نَفْيٌ مَلْزُوم':Added, #1: 1	نَفْيَ الْمَكَانِ
u'نَفْيٌ مَلْزُوم':Added, #1: 1	نَفْيُ الْمَلْزُومِ
u'نَفْيٌ مَلْزُوم':Added, #1: 1	نَفْيِ مَلْزُومٍ
u'نَفْيٌ مَلْزُوم':Added, #2: 2	نَفْيَ الْمَلْزُومِ
u'نَفَى مِلْكٌ':Predicate, #2: 2	نَفْيِ الْمَلْزُومِ
u'نَفَى مِلْكٌ':Predicate, #1: 1	نَفَى الْمِلْكَ
u'نَفْيٌ مُلْكٌ':Added, #1: 1	نَفَى مِلْكَ
u'نَفْيٌ مِلْكٌ':Added, #1: 1	نَفْيَ الْمُلْكِ
u'نَفْيٌ مِلْكٌ':Added, #1: 1	نَفْيِ الْمِلْكِ
u'نَفْيٌ مِلْكٌ':Added, #1: 1	نَفْيَ مِلْكِ
u'نَفْيٌ مِلْكٌ':Added, #1: 1	نَفْيُ مِلْكِهِ
u'نَفْيٌ مِلْكٌ':Added, #1: 1	نَفْيِ مِلْكِهِ
u'نَفْيٌ مِلْكٌ':Added, #2: 2	نَفْيُ الْمِلْكِ
u'نَفْيٌ مُمَاثَلَةٌ':Added, #5: 5	نَفْيَ الْمِلْكِ
u'نَفَى مَمَرٌّ':Predicate, #1: 1	نَفْيَ الْمُمَاثَلَةِ
u'نَفْيٌ مَنٌّ':Added, #2: 2	نَفَى الْمَمَرَّ
u'نَفْيٌ مَنْدُوب':Added, #1: 1	نَفْيِ الْمَنِّ
u'نَفْيٌ مَنْدُوبِيَّة':Added, #2: 2	نَفْيَ الْمَنْدُوبِيَّةِ
u'نَفْيٌ مَنْطُوقٌ':Added, #2: 2	نَفْيَ الْمَنْدُوبِيَّةِ
u'نَفْيٌ مَهْرٌ':Added, #1: 1	نَفْيِ الْمَنْطُوقِ
u'نَفْيٌ مَهْرٌ':Added, #1: 1	نَفْيَ الْمَهْرِ
u'نَفْيٌ مُؤَاخَذَةٌ':Added, #3: 3	نَفْيِ الْمَهْرِ
u'نَفْيٌ مَوْتٌ':Added, #4: 4	نَفْيَ الْمُؤَاخَذَةِ
u'نَفْيٌ مُوجِبٌ':Added, #1: 1	نَفْيَ الْمَوْتِ
u'نَفْيٌ مُوجَبٌ':Added, #1: 1	نَفْيِ الْمُوجِبِ
u'نَفْيٌ مَوْصُوفٌ':Added, #1: 1	نَفْيُ مُوجَبِ
u'نَفْيٌ مُؤَلِّفٌ':Added, #2: 2	نَفْيَ الْمَوْصُوفِ
u'نَفْيٌ نَجَاسَةٌ':Added, #1: 1	نَفْيُ الْمُؤَلِّفِ
u'نَفَى نَسَبٌ':Predicate, #1: 1	نَفْيِ النَّجَاسَةِ
u'نَفَى نَسَبٌ':Predicate, #17: 17	نَفَى نَسَبَ
u'نَفْيٌ نَسَبٌ':Added, #1: 1	نَفَى النَّسَبَ
u'نَفْيٌ نَسَبٌ':Added, #1: 1	نَفْيَ النَّسَبِ
u'نَفْيٌ نَسَبٌ':Added, #1: 1	نَفْيُ نَسَبٍ
u'نَفْيٌ نَسَبٌ':Added, #1: 1	نَفْيُ نَسَبِ
u'نَفْيٌ نَسَبٌ':Added, #1: 1	نَفْيِ نَسَبٍ
u'نَفْيٌ نَسَبٌ':Added, #2: 2	نَفْيِ النَّسَبِ
u'نَفْيٌ نَسَبٌ':Added, #2: 2	نَفْيَ نَسَبِهِ
u'نَفْيٌ نَسَبٌ':Added, #3: 3	نَفْيَ نَسَبِ
u'نَفْيٌ نِصْفٌ':Added, #7: 7	نَفْيُ النَّسَبِ
u'نَفْيٌ نَظْمٌ':Added, #2: 2	نَفْيِ النِّصْفِ
u'نَفْيٌ نفاذ':Added, #1: 1	نَفْيُ النَّظْمِ
u'نَفْيٌ نَفَاذٌ':Added, #1: 1	نَفْيُ النَّفَاذِ
u'نَفَى نَفْسٌ':Predicate, #1: 1	نَفْيُ النَّفَاذِ
u'نَفَى نَفَقَةٌ':Predicate, #1: 1	نَفَى نَفْسَ
u'نَفْيٌ نَفَقَةٌ':Added, #1: 1	نَفَى النَّفَقَةَ
u'نَفْيٌ نَفْيٌ':Added, #1: 1	نَفْيِ نَفَقَةِ
u'نَفْيٌ نَقْصٌ':Added, #2: 2	نَفْيَ النَّفْيِ
u'نَفَى نقل':Predicate, #1: 1	نَفْيُ النَّقْصِ
u'نَفَى نَقْلٌ':Predicate, #2: 2	نَفَى النَّقْلَ
u'نَفْيٌ نكاح':Added, #2: 2	نَفَى النَّقْلَ
u'نَفْيٌ نِكَاحٌ':Added, #1: 1	نَفْيَ النِّكَاحِ
u'نَفْيٌ نكاح':Added, #1: 1	نَفْيَ النِّكَاحِ
u'نَفْيٌ نِكَاحٌ':Added, #1: 1	نَفْيُ نِكَاحِ
u'نَفْيٌ نكاح':Added, #1: 1	نَفْيُ نِكَاحِ
u'نَفْيٌ نِكَاحٌ':Added, #4: 4	نَفْيِ النِّكَاحِ
u'نَفْيٌ نَكِرٌ':Added, #4: 4	نَفْيِ النِّكَاحِ
u'نَفْيٌ نكرة':Added, #3: 3	نَفْيِ النَّكِرَةِ
u'نَفْيٌ نَكِرَةٌ':Added, #3: 3	نَفْيِ النَّكِرَةِ
u'نَفْيٌ نَهْيٌ':Added, #3: 3	نَفْيِ النَّكِرَةِ
u'نَفْيٌ نِيَّةٌ':Added, #1: 1	نَفْيُ النَّهْيِ
u'نَفَى هجود':Predicate, #5: 5	نَفْيِ النِّيَّةِ
u'نَفَى هُجُودٌ':Predicate, #1: 1	نَفَى الْهُجُودَ
u'نَفْيٌ واحد':Added, #1: 1	نَفَى الْهُجُودَ
u'نَفْيٌ وَاحِدٌ':Added, #1: 1	نَفْيَ وَاحِدٍ
u'نَفْيٌ وَاقِعٌ':Added, #1: 1	نَفْيَ وَاحِدٍ
u'نَفْيٌ وَالِدٌ':Added, #1: 1	نَفْيَ الْوَاقِعِ
u'نَفْيٌ وُثُوقٌ':Added, #1: 1	نَفْيِ الْوَالِدِ
u'نَفْيٌ وِجْدَانٌ':Added, #1: 1	نَفْيِ الْوُثُوقِ
u'نَفَى وُجُوبٌ':Predicate, #1: 1	نَفْيَ الْوِجْدَانِ
u'نَفْيٌ وُجُوبٌ':Added, #3: 3	نَفَى الْوُجُوبَ
u'نَفْيٌ وُجُوبٌ':Added, #1: 1	نَفْيَ وُجُوبِهِ
u'نَفْيٌ وُجُوبٌ':Added, #2: 2	نَفْيَ الْوُجُوبِ
u'نَفْيٌ وُجُوبٌ':Added, #2: 2	نَفْيِ وُجُوبِ
u'نَفْيٌ وُجُوبٌ':Added, #3: 3	نَفْيُ وُجُوبِهِ
u'نَفْيٌ وُجُوبٌ':Added, #4: 4	نَفْيُ الْوُجُوبِ
u'نَفْيٌ وُجُوبٌ':Added, #4: 4	نَفْيَ وُجُوبِ
u'نَفْيٌ وُجُوبٌ':Added, #5: 5	نَفْيُ وُجُوبِ
u'نَفَى وُجُودٌ':Predicate, #8: 8	نَفْيِ الْوُجُوبِ
u'نَفْيٌ وُجُودٌ':Added, #1: 1	نَفَى وُجُودَ
u'نَفْيٌ وُجُودٌ':Added, #1: 1	نَفْيِ وُجُودِ
u'نَفْيٌ وُجُودٌ':Added, #1: 1	نَفْيِ وُجُودِهِ
u'نَفْيٌ وُجُودٌ':Added, #2: 2	نَفْيُ الْوُجُودِ
u'نَفْيٌ وُجُودٌ':Added, #2: 2	نَفْيِ الْوُجُودِ
u'نَفْيٌ وَحْدَةٌ':Added, #5: 5	نَفْيُ وُجُودِ
u'نَفْيٌ وَدِيعٌ':Added, #1: 1	نَفْيِ الْوَحْدَةِ
u'نَفْيٌ وَدِيعَةٌ':Added, #1: 1	نَفْيُ الْوَدِيعَةِ
u'نَفْيٌ وَصْفٌ':Added, #1: 1	نَفْيُ الْوَدِيعَةِ
u'نَفْيٌ وَصْفٌ':Added, #1: 1	نَفْيِ الْوَصْفِ
u'نَفْيٌ وَصِيٌّ':Added, #1: 1	نَفْيُ الْوَصْفَيْنِ
u'نَفْيٌ وَصِيَّةٌ':Added, #1: 1	نَفْيِ الْوَصِيَّةِ
u'نَفَى وَضْعٌ':Predicate, #1: 1	نَفْيِ الْوَصِيَّةِ
u'نَفْيٌ وَضْعٌ':Added, #1: 1	نَفَى الْوَضْعَ
u'نَفْيٌ وَضْعٌ':Added, #1: 1	نَفْيَ وَضْعِ
u'نَفْيٌ وُضُوءٌ':Added, #1: 1	نَفْيُ وَضْعِ
u'نَفْيٌ وَطْءٌ':Added, #1: 1	نَفْيُ الْوُضُوءِ
u'نَفْيٌ وَطْءٌ':Added, #1: 1	نَفْيُ الْوَطْءِ
u'نَفْيٌ وَقْفٌ':Added, #4: 4	نَفْيِ الْوَطْءِ
u'نَفْيٌ وُقُوعٌ':Added, #1: 1	نَفْيَ وَقْفِ
u'نَفْيٌ وُقُوعٌ':Added, #1: 1	نَفْي الْوُقُوعِ
u'نَفْيٌ وُقُوعٌ':Added, #1: 1	نَفْيَ الْوُقُوعِ
u'نَفْيٌ وُقُوعٌ':Added, #1: 1	نَفْيُ الْوُقُوعِ
u'نَفْيٌ وُقُوعٌ':Added, #1: 1	نَفْيِ وُقُوعِ
u'نَفْيٌ وُقُوعٌ':Added, #1: 1	نَفْيِ وُقُوعِهِ
u'نَفْيٌ وِلاَدَةٌ':Added, #2: 2	نَفْيِ الْوُقُوعِ
u'نَفْيٌ وِلاَدَةٌ':Added, #1: 1	نَفْيَ الْوِلَادَةِ
u'نَفْيٌ وِلاَيَةٌ':Added, #1: 1	نَفْيِ الْوِلَادَةِ
u'نَفْيٌ وِلاَيَةٌ':Added, #1: 1	نَفْيُ وِلَايَةِ
u'نَفَى ولد':Predicate, #1: 1	نَفْيِ وِلَايَةِ
u'نَفَى وَلَدٌ':Predicate, #7: 7	نَفَى وَلَدَ
u'نَفَى ولد':Predicate, #7: 7	نَفَى وَلَدَ
u'نَفَى وَلَدٌ':Predicate, #8: 8	نَفَى الْوَلَدَ
u'نَفَى ولد':Subject, #8: 8	نَفَى الْوَلَدَ
u'نَفَى وَلَدٌ':Subject, #1: 1	نَفَى وَلَدُ
u'نَفْيٌ ولد':Added, #1: 1	نَفَى وَلَدُ
u'نَفْيٌ وَلَدٌ':Added, #11: 11	نَفْيُ الْوَلَدِ
u'نَفْيٌ ولد':Added, #11: 11	نَفْيُ الْوَلَدِ
u'نَفْيٌ وَلَدٌ':Added, #1: 1	نَفْيِ وَلَدِ
u'نَفْيٌ وَلَدٌ':Added, #1: 1	نَفْيِ وَلَدٍ
u'نَفْيٌ ولد':Added, #1: 1	نَفْيِ وَلَدِ
u'نَفْيٌ وَلَدٌ':Added, #21: 21	نَفْيِ الْوَلَدِ
u'نَفْيٌ ولد':Added, #21: 21	نَفْيِ الْوَلَدِ
u'نَفْيٌ وَلَدٌ':Added, #2: 2	نَفْيَ وَلَدِ
u'نَفْيٌ وَلَدٌ':Added, #2: 2	نَفْيَ وَلَدِ
u'نَفْيٌ ولد':Added, #2: 2	نَفْيُ وَلَدٍ
u'نَفْيٌ وَلَدٌ':Added, #5: 5	نَفْيَ الْوَلَدِ
u'نَفْيٌ يَمِينٌ':Added, #5: 5	نَفْيَ الْوَلَدِ
u'نَفْيٌ يَمِينٌ':Added, #1: 1	نَفْيَ الْيَمِينِ
u'نَقَبَ بَيْتٌ':Predicate, #3: 3	نَفْيِ الْيَمِينِ
u'نَقَّبَ بَيْتٌ':Predicate, #12: 12	نَقَبَ الْبَيْتَ
u'نَقْبٌ بَيْتٌ':Added, #1: 1	نَقَّبَ الْبَيْتَ
u'نَقَّبَ جِدار':Predicate, #1: 1	نَقْبِ الْبَيْتِ
u'نَقَبَ جِدار':Predicate, #1: 1	نَقَّبَ الْجِدَارَ
u'نَقَبَ حائِطٌ':Predicate, #3: 3	نَقَبَ الْجِدَارَ
u'نَقَبَ حَجَرٌ':Predicate, #1: 1	نَقَبَ الْحَائِطَ
u'نَقَبَ حِرْزٌ':Predicate, #1: 1	نَقَبَ الْحَجَرَ
u'نَقْبٌ حِرْزٌ':Added, #3: 3	نَقَبَ الْحِرْزَ
u'نَقَبَ سَارِقٌ':Subject, #1: 1	نَقْبِ الْحِرْزِ
u'نَقْبٌ صَاحِبٌ':Added, #1: 1	نَقَبَ سَارِقٌ
u'نَقَبَ لِصٌّ':Subject, #1: 1	نَقْبِ صَاحِبِهِ
u'نَقَبَ لِصٌّ':Subject, #2: 2	نَقَبَ لِصٌّ
u'نَقْبٌ مَدِينٌ':Added, #5: 5	نَقَبَ اللِّصُّ
u'نَقْبٌ مَدِينَةٌ':Added, #1: 1	نَقْبِ الْمَدِينَةِ
u'نَقْبٌ مِغْلاَقٌ':Added, #1: 1	نَقْبِ الْمَدِينَةِ
u'نَقَبَ واحد':Subject, #1: 1	نَقْبِ الْمِغْلَاقِ
u'نَقَبَ وَاحِدٌ':Subject, #5: 5	نَقَبَ وَاحِدٌ
u'نَقَّحَ إمَامٌ':Subject, #5: 5	نَقَبَ وَاحِدٌ
u'نَقَّحَ مَنْصُوصٌ':Predicate, #1: 1	نَقَّحَ إمَامُ
u'نَقَّحَ نَصٌّ':Predicate, #1: 1	نَقَّحَ الْمَنْصُوصَ
u'نَقْدٌ إجَارَةٌ':Added, #1: 1	نَقَّحَ النَّصَّ
u'نَقْد إجَارَةٌ':Added, #1: 1	نَقْدُ الْإِجَارَةِ
u'نَقَدَ أَجْرٌ':Predicate, #1: 1	نَقْدُ الْإِجَارَةِ
u'نَقَدَ أُجْرَةٌ':Predicate, #2: 2	نَقَدَ الْأَجْرَ
u'نَقْدٌ أُجْرَةٌ':Added, #2: 2	نَقَدَ الْأُجْرَةَ
u'نَقْد أُجْرَةٌ':Added, #4: 4	نَقْدِ الْأُجْرَةِ
u'نَقَدَ أفْضَلُ':Predicate, #4: 4	نَقْدِ الْأُجْرَةِ
u'نَقْدٌ أقْرَبُ':Added, #1: 1	نَقَدَ أَفْضَلَ
u'نَقْدٌ أقْرَبُ':Added, #1: 1	نَقْدَ أَقْرَبِ
u'نَقْد أقْرَبُ':Added, #1: 1	نَقْدِ أَقْرَبِ
u'نَقْد أقْرَبُ':Added, #1: 1	نَقْدَ أَقْرَبِ
u'نَقَدَ أقَلُّ':Predicate, #1: 1	نَقْدِ أَقْرَبِ
u'نَقْدٌ أقَلُّ':Added, #1: 1	نَقَدَ أَقَلَّ
u'نَقْد أقَلُّ':Added, #2: 2	نَقْدِ الْأَقَلِّ
u'نَقَدَ أَكْثَرُ':Predicate, #2: 2	نَقْدِ الْأَقَلِّ
u'نَقَدَ آمِرٌ':Subject, #1: 1	نَقَدَ أَكْثَرَ
u'نَقْدٌ اِمْرَأَةٌ':Added, #2: 2	نَقَدَ الْآمِرُ
u'نَقْد اِمْرَأَةٌ':Added, #1: 1	نَقْدَ امْرَأَتِهِ
u'نَقْدٌ أوائل':Added, #1: 1	نَقْدَ امْرَأَتِهِ
u'نَقْد أوائل':Added, #1: 1	نَقْدَ أَوَائِلِ
u'نَقَدَ بَائِعٌ':Predicate, #1: 1	نَقْدَ أَوَائِلِ
u'نَقَدَ بَائِعٌ':Subject, #3: 3	نَقَدَ الْبَائِعَ
u'نَقْدٌ بَائِعٌ':Added, #2: 2	نَقَدَ الْبَائِعُ
u'نَقْد بَائِعٌ':Added, #1: 1	نَقْدِ بَائِعِهِ
u'نَقَدَ بَعْضٌ':Predicate, #1: 1	نَقْدِ بَائِعِهِ
u'نَقَدَ بَعْضٌ':Predicate, #2: 2	نَقَدَ الْبَعْضَ
u'نَقْدٌ بَعْضٌ':Added, #2: 2	نَقَدَ بَعْضَ
u'نَقْدٌ بَعْضٌ':Added, #1: 1	نَقْدُ بَعْضِ
u'نَقْد بَعْضٌ':Added, #1: 1	نَقْدِ بَعْضِ
u'نَقْد بَعْضٌ':Added, #1: 1	نَقْدُ بَعْضِ
u'نَقْدٌ بَلَدٌ':Added, #1: 1	نَقْدِ بَعْضِ
u'نَقْد بَلَدٌ':Added, #10: 10	نَقْدِ بَلَدِ
u'نَقْدٌ بَلَدٌ':Added, #10: 10	نَقْدِ بَلَدِ
u'نَقْد بَلَدٌ':Added, #146: 146	نَقْدِ الْبَلَدِ
u'نَقْدٌ بَلَدٌ':Added, #146: 146	نَقْدِ الْبَلَدِ
u'نَقْدٌ بَلَدٌ':Added, #1: 1	نَقْدَ بَلَدِ
u'نَقْد بَلَدٌ':Added, #1: 1	نَقْدُ بَلَدٍ
u'نَقْد بَلَدٌ':Added, #1: 1	نَقْدَ بَلَدِ
u'نَقْدٌ بَلَدٌ':Added, #1: 1	نَقْدُ بَلَدٍ
u'نَقْد بَلَدٌ':Added, #1: 1	نَقْدِ بَلَدِهِ
u'نَقْدٌ بَلَدٌ':Added, #1: 1	نَقْدِ بَلَدِهِ
u'نَقْد بَلَدٌ':Added, #24: 24	نَقْدُ الْبَلَدِ
u'نَقْدٌ بَلَدٌ':Added, #24: 24	نَقْدُ الْبَلَدِ
u'نَقْد بَلَدٌ':Added, #3: 3	نَقْدَ بَلَدٍ
u'نَقْدٌ بَلَدٌ':Added, #3: 3	نَقْدَ بَلَدٍ
u'نَقْد بَلَدٌ':Added, #9: 9	نَقْدَ الْبَلَدِ
u'نَقْدٌ بَيْتٌ':Added, #9: 9	نَقْدَ الْبَلَدِ
u'نَقْدٌ بَيْتٌ':Added, #1: 1	نَقْدُ بَيْتِ
u'نَقْد بَيْتٌ':Added, #1: 1	نَقْدِ بَيْتِ
u'نَقْد بَيْتٌ':Added, #1: 1	نَقْدُ بَيْتِ
u'نَقْدٌ بَيْتٌ':Added, #1: 1	نَقْدِ بَيْتِ
u'نَقْد بَيْتٌ':Added, #6: 6	نَقْدَ بَيْتِ
u'نَقْدٌ تَقْويمٌ':Added, #6: 6	نَقْدَ بَيْتِ
u'نَقْد تَقْويمٌ':Added, #2: 2	نَقْدِ التَّقْوِيمِ
u'نَقَدَ ثَمَنٌ':Predicate, #2: 2	نَقْدِ التَّقْوِيمِ
u'نَقَدَ ثَمَنٌ':Predicate, #10: 10	نَقَدَ ثَمَنَ
u'نَقْدٌ ثَمَنٌ':Added, #49: 49	نَقَدَ الثَّمَنَ
u'نَقْد ثَمَنٌ':Added, #11: 11	نَقْدَ الثَّمَنِ
u'نَقْدٌ ثَمَنٌ':Added, #11: 11	نَقْدَ الثَّمَنِ
u'نَقْد ثَمَنٌ':Added, #13: 13	نَقْدُ الثَّمَنِ
u'نَقْدٌ ثَمَنٌ':Added, #13: 13	نَقْدُ الثَّمَنِ
u'نَقْد ثَمَنٌ':Added, #1: 1	نَقْدُ ثَمَنٍ
u'نَقْدٌ ثَمَنٌ':Added, #1: 1	نَقْدُ ثَمَنٍ
u'نَقْد ثَمَنٌ':Added, #1: 1	نَقْدَ ثَمَنِهِ
u'نَقْدٌ ثَمَنٌ':Added, #1: 1	نَقْدَ ثَمَنِهِ
u'نَقْد ثَمَنٌ':Added, #2: 2	نَقْدِ الثَّمَنَيْنِ
u'نَقْدٌ ثَمَنٌ':Added, #2: 2	نَقْدِ الثَّمَنَيْنِ
u'نَقْد ثَمَنٌ':Added, #2: 2	نَقْدِ ثَمَنِهِ
u'نَقْدٌ ثَمَنٌ':Added, #2: 2	نَقْدِ ثَمَنِهِ
u'نَقْد ثَمَنٌ':Added, #88: 88	نَقْدِ الثَّمَنِ
u'نَقَدَ حِصَّةٌ':Predicate, #88: 88	نَقْدِ الثَّمَنِ
u'نَقْدٌ حِصَّةٌ':Added, #1: 1	نَقَدَ حِصَّةَ
u'نَقْد حِصَّةٌ':Added, #1: 1	نَقْدِ حِصَّةِ
u'نَقْدٌ حِصَّةٌ':Added, #1: 1	نَقْدِ حِصَّةِ
u'نَقْد حِصَّةٌ':Added, #2: 2	نَقْدُ حِصَّةِ
u'نَقْدٌ خَارِجٌ':Added, #2: 2	نَقْدُ حِصَّةِ
u'نَقْد خَارِجٌ':Added, #2: 2	نَقْدُ الْخَارِجِ
u'نَقْدٌ خَالِصٌ':Added, #2: 2	نَقْدُ الْخَارِجِ
u'نَقْد خَالِصٌ':Added, #1: 1	نَقْدٍ خَالِصٍ
u'نَقَدَ دَرَاهِمُ':Predicate, #1: 1	نَقْدٍ خَالِصٍ
u'نَقَدَ دَرَاهِمُ':Predicate, #4: 4	نَقَدَ الدَّرَاهِمَ
u'نَقْدٌ دَرَاهِمُ':Added, #5: 5	نَقَدَ دَرَاهِمَ
u'نَقْد دَرَاهِمُ':Added, #1: 1	نَقْدِ الدَّرَاهِمِ
u'نَقَدَ دِرْهَمٌ':Predicate, #1: 1	نَقْدِ الدَّرَاهِمِ
u'نَقَدَ دِرْهَم':Predicate, #3: 3	نَقَدَ الدِّرْهَمَ
u'نَقْدٌ دِرْهَمٌ':Added, #3: 3	نَقَدَ الدِّرْهَمَ
u'نَقْدٌ دِرْهَم':Added, #1: 1	نَقْدِ الدِّرْهَمِ
u'نَقْد دِرْهَمٌ':Added, #1: 1	نَقْدِ الدِّرْهَمِ
u'نَقْد دِرْهَم':Added, #1: 1	نَقْدِ الدِّرْهَمِ
u'نَقَدَ دَنانيرُ':Predicate, #1: 1	نَقْدِ الدِّرْهَمِ
u'نَقَدَ دَنانيرُ':Predicate, #1: 1	نَقَدَ الدَّنَانِيرَ
u'نَقْدٌ دَنانيرُ':Added, #2: 2	نَقَدَ دَنَانِيرَ
u'نَقْد دَنانيرُ':Added, #1: 1	نَقْدِ الدَّنَانِيرِ
u'نَقْدٌ دَيْنٌ':Added, #1: 1	نَقْدِ الدَّنَانِيرِ
u'نَقْد دَيْنٌ':Added, #1: 1	نَقْدِ الدَّيْنِ
u'نَقَدَ دِينارٌ':Predicate, #1: 1	نَقْدِ الدَّيْنِ
u'نَقَدَ رَأْسٌ':Predicate, #1: 1	نَقَدَ دِينَارَ
u'نَقْدٌ رَأْسٌ':Added, #2: 2	نَقَدَ رَأْسَ
u'نَقْد رَأْسٌ':Added, #1: 1	نَقْدِ رَأْسِ
u'نَقَدَ رَجُلٌ':Subject, #1: 1	نَقْدِ رَأْسِ
u'نَقَدَ زَوْجٌ':Subject, #1: 1	نَقَدَ رَجُلٌ
u'نَقَدَ زُيوفٌ':Predicate, #1: 1	نَقَدَ الزَّوْجُ
u'نَقَدَ زُيُوفٌ':Predicate, #1: 1	نَقَدَ الزُّيُوفَ
u'نَقَدَ شُرُوعٌ':Predicate, #1: 1	نَقَدَ الزُّيُوفَ
u'نَقْدٌ شَعْرٌ':Added, #1: 1	نَقَدَ الشُّرُوعَ
u'نَقْدٌ شِعْرٌ':Added, #1: 1	نَقْدِ الشّعْرِ
u'نَقْد شَعْرٌ':Added, #1: 1	نَقْدِ الشّعْرِ
u'نَقْد شِعْرٌ':Added, #1: 1	نَقْدِ الشّعْرِ
u'نَقَدَ شَفِيعٌ':Subject, #1: 1	نَقْدِ الشّعْرِ
u'نَقْدٌ صَاحِبٌ':Added, #1: 1	نَقَدَ الشَّفِيعُ
u'نَقْد صَاحِبٌ':Added, #1: 1	نَقْدِ صَاحِبِهِ
u'نَقْدٌ صداق':Added, #1: 1	نَقْدِ صَاحِبِهِ
u'نَقْد صداق':Added, #1: 1	نَقْدِ الصَّدَاقِ
u'نَقْدٌ صَدَاقٌ':Added, #1: 1	نَقْدِ الصَّدَاقِ
u'نَقْد صَدَاقٌ':Added, #1: 1	نَقْدِ الصَّدَاقِ
u'نَقَدَ عَبْدٌ':Subject, #1: 1	نَقْدِ الصَّدَاقِ
u'نَقْدٌ عِوَضٌ':Added, #1: 1	نَقَدَ الْعَبْدُ
u'نَقْد عِوَضٌ':Added, #1: 1	نَقْدِ الْعِوَضِ
u'نَقْدٌ عِوَضٌ':Added, #1: 1	نَقْدِ الْعِوَضِ
u'نَقْد عِوَضٌ':Added, #2: 2	نَقْدُ الْعِوَضِ
u'نَقْدٌ غَالِبٌ':Added, #2: 2	نَقْدُ الْعِوَضِ
u'نَقْد غَالِبٌ':Added, #1: 1	نَقْدٍ غَالِبٍ
u'نَقَدَ غير':Predicate, #1: 1	نَقْدٍ غَالِبٍ
u'نَقَدَ غَيْرٌ':Predicate, #1: 1	نَقَدَ غَيْرَ
u'نَقْدٌ غير':Added, #1: 1	نَقَدَ غَيْرَ
u'نَقْد غير':Added, #1: 1	نَقْدُ غَيْرِ
u'نَقْدٌ غَيْرٌ':Added, #1: 1	نَقْدُ غَيْرِ
u'نَقْد غَيْرٌ':Added, #1: 1	نَقْدُ غَيْرِ
u'نَقْدٌ غير':Added, #1: 1	نَقْدُ غَيْرِ
u'نَقْد غير':Added, #1: 1	نَقْدَ غَيْرِهِ
u'نَقْدٌ غَيْرٌ':Added, #1: 1	نَقْدَ غَيْرِهِ
u'نَقْد غَيْرٌ':Added, #1: 1	نَقْدَ غَيْرِهِ
u'نَقَدَ قَاضِي':Predicate, #1: 1	نَقْدَ غَيْرِهِ
u'نَقَدَ كِرَاءٌ':Predicate, #1: 1	نَقَدَ الْقَاضِيَ
u'نَقَدَ كِرَاءٌ':Predicate, #2: 2	نَقَدَ كِرَاءَ
u'نَقْدٌ كِرَاءٌ':Added, #4: 4	نَقَدَ الْكِرَاءَ
u'نَقْدٌ كِرَاءٌ':Added, #1: 1	نَقْدُ الْكِرَاءِ
u'نَقْد كِرَاءٌ':Added, #1: 1	نَقْدِ الْكِرَاءِ
u'نَقْد كِرَاءٌ':Added, #1: 1	نَقْدُ الْكِرَاءِ
u'نَقْدٌ كُورَةٌ':Added, #1: 1	نَقْدِ الْكِرَاءِ
u'نَقْد كُورَةٌ':Added, #1: 1	نَقْدَ كُورَةِ
u'نَقْدٌ كُوفَةٌ':Added, #1: 1	نَقْدَ كُورَةِ
u'نَقْد كُوفَةٌ':Added, #1: 1	نَقْدُ الْكُوفَةِ
u'نَقَدَ مَالٌ':Predicate, #1: 1	نَقْدُ الْكُوفَةِ
u'نَقَدَ مَالٌ':Predicate, #1: 1	نَقَدَ الْمَالَ
u'نَقْدٌ مَالٌ':Added, #1: 1	نَقَدَ مَالَ
u'نَقْد مَالٌ':Added, #1: 1	نَقْدُ الْمَالِ
u'نَقْدٌ مَالٌ':Added, #1: 1	نَقْدُ الْمَالِ
u'نَقْد مَالٌ':Added, #2: 2	نَقْدِ الْمَالِ
u'نَقَدَ مَأْمُورٌ':Subject, #2: 2	نَقْدِ الْمَالِ
u'نَقَدَ مثل':Predicate, #1: 1	نَقَدَ الْمَأْمُورُ
u'نَقَدَ مِثْلٌ':Predicate, #1: 1	نَقَدَ مِثْلَ
u'نَقْدٌ مَحَلٌّ':Added, #1: 1	نَقَدَ مِثْلَ
u'نَقْد مَحَلٌّ':Added, #1: 1	نَقْدِ الْمَحَلِّ
u'نَقَدَ مُحِيل':Predicate, #1: 1	نَقْدِ الْمَحَلِّ
u'نَقَدَ مُحِيل':Subject, #2: 2	نَقَدَ الْمُحِيلَ
u'نَقَدَ مَدْفُوعٌ':Predicate, #1: 1	نَقَدَ الْمُحِيلُ
u'نَقَدَ مُسْتَبْضِع':Subject, #1: 1	نَقَدَ الْمَدْفُوعَةَ
u'نَقْدٌ مَضْرُوبٌ':Added, #1: 1	نَقَدَ الْمُسْتَبْضِعُ
u'نَقْد مَضْرُوبٌ':Added, #1: 1	نَقْدٍ مَضْرُوبٍ
u'نَقْدٌ مُعَجَّلٌ':Added, #1: 1	نَقْدٍ مَضْرُوبٍ
u'نَقْد مُعَجَّلٌ':Added, #1: 1	نَقْدِ الْمُعَجَّلِ
u'نَقْدٌ مَعْلُومٌ':Added, #1: 1	نَقْدِ الْمُعَجَّلِ
u'نَقْد مَعْلُومٌ':Added, #2: 2	نَقْدٍ مَعْلُومٍ
u'نَقْدٌ مُعَيَّنٌ':Added, #2: 2	نَقْدٍ مَعْلُومٍ
u'نَقْد مُعَيَّنٌ':Added, #2: 2	نَقْدٍ مُعَيَّنٍ
u'نَقْدٌ مَغْشُوشٌ':Added, #2: 2	نَقْدٍ مُعَيَّنٍ
u'نَقْد مَغْشُوشٌ':Added, #1: 1	نَقْدٍ مَغْشُوشٍ
u'نَقَدَ مِقْدَارٌ':Predicate, #1: 1	نَقْدٍ مَغْشُوشٍ
u'نَقْدٌ مَكَانٌ':Added, #1: 1	نَقَدَ مِقْدَارَ
u'نَقْدٌ مَكَانٌ':Added, #1: 1	نَقْدَ الْمَكَانِ
u'نَقْد مَكَانٌ':Added, #1: 1	نَقْدُ الْمَكَانِ
u'نَقْد مَكَانٌ':Added, #1: 1	نَقْدَ الْمَكَانِ
u'نَقَدَ نَجِيٌّ':Predicate, #1: 1	نَقْدُ الْمَكَانِ
u'نَقْدٌ نِصْفٌ':Added, #1: 1	نَقَدَ النَّجِيَّةَ
u'نَقْد نِصْفٌ':Added, #1: 1	نَقْدَ النِّصْفِ
u'نَقْدٌ نِصْفٌ':Added, #1: 1	نَقْدَ النِّصْفِ
u'نَقْد نِصْفٌ':Added, #2: 2	نَقْدُ نِصْفِ
u'نَقَدَ نَفَذٌ':Predicate, #2: 2	نَقْدُ نِصْفِ
u'نَقْدٌ واحد':Added, #1: 1	نَقَدَ نَفَذَ
u'نَقْد واحد':Added, #1: 1	نَقْدُ وَاحِدٍ
u'نَقْدٌ وَاحِدٌ':Added, #1: 1	نَقْدُ وَاحِدٍ
u'نَقْد وَاحِدٌ':Added, #1: 1	نَقْدُ وَاحِدٍ
u'نَقْدٌ واحد':Added, #1: 1	نَقْدُ وَاحِدٍ
u'نَقْد واحد':Added, #3: 3	نَقْدٍ وَاحِدٍ
u'نَقْدٌ وَاحِدٌ':Added, #3: 3	نَقْدٍ وَاحِدٍ
u'نَقْد وَاحِدٌ':Added, #3: 3	نَقْدٍ وَاحِدٍ
u'نَقَدَ وَكِيلٌ':Subject, #3: 3	نَقْدٍ وَاحِدٍ
u'نَقْدٌ يَوْمٌ':Added, #2: 2	نَقَدَ الْوَكِيلُ
u'نَقْد يَوْمٌ':Added, #1: 1	نَقْدِ يَوْمِ
u'نَقِذَ مَالٌ':Predicate, #1: 1	نَقْدِ يَوْمِ
u'نَقْرٌ دِيكٌ':Added, #1: 1	أَنْقَذَ مَالَ
u'نَقْرٌ غُرَابٌ':Added, #5: 5	نَقْرَ الدِّيكِ
u'نَقْرٌ غُرَابٌ':Added, #1: 1	نَقْرُ الْغُرَابِ
u'نَقْرٌ نُحَاسٌ':Added, #4: 4	نَقْرَ الْغُرَابِ
u'نَقَرَ نَقْرٌ':Predicate, #1: 1	نَقْرِ النُّحَاسِ
u'نَقْشٌ أَلْوَاحٌ':Added, #1: 1	نَقَرَ نَقْرَ
u'نَقَشَ إِناءٌ':Predicate, #1: 1	نَقْشَ الْأَلْوَاحِ
u'نَقْشٌ آيَةٌ':Added, #2: 2	نَقَشَ إنَاءَ
u'نَقَشَ بَابٌ':Predicate, #1: 1	نَقْشَ الْآيَةِ
u'نَقْشٌ بَابٌ':Added, #1: 1	نَقَشَ الْبَابَ
u'نَقْشٌ ثِيابٌ':Added, #1: 1	نَقْش الْبَابِ
u'نَقْشٌ حيطانٌ':Added, #1: 1	نَقْش الثِّيَابِ
u'نَقْشٌ خَتْمٌ':Added, #1: 1	نَقْشَ الْحِيطَانِ
u'نَقْشٌ سَقْفٌ':Added, #2: 2	نَقْشَ الْخَتْمِ
u'نَقْشٌ غير':Added, #1: 1	نَقْشُ السَّقْفِ
u'نَقْشٌ غَيْرٌ':Added, #1: 1	نَقْشُ غَيْرِهِ
u'نَقْشٌ قُرْآنٌ':Added, #1: 1	نَقْشُ غَيْرِهِ
u'نَقْشٌ مِحْرَابٌ':Added, #1: 1	نَقْشُ الْقُرْآنِ
u'نَقْشٌ مَسْجِدٌ':Added, #1: 1	نَقْشِ الْمِحْرَابِ
u'نَقْشٌ مَسْجِدٌ':Added, #1: 1	نَقْش الْمَسْجِدِ
u'نَقْشٌ مَسْجِدٌ':Added, #2: 2	نَقْشِ الْمَسْجِدِ
u'نَقْصٌ إِبِلٌ':Added, #3: 3	نَقْشُ الْمَسْجِدِ
u'نَقَصَ أَجْرٌ':Subject, #3: 3	نَقْصِ الْإِبِلِ
u'نَقَصَ أَجْرٌ':Subject, #2: 2	نَقَصَ أَجْرُهُ
u'نَقْصٌ أَجْرٌ':Added, #4: 4	نَقَصَ أَجْرُ
u'نَقْصٌ أَجْرٌ':Added, #1: 1	نَقْصِ أَجْرِ
u'نَقْصٌ أُجْرَةٌ':Added, #1: 1	نَقْصِ الْأَجْرِ
u'نَقْصٌ أُجْرَةٌ':Added, #2: 2	نَقْصِ أُجْرَةِ
u'نَقَصَ أَجَلٌ':Subject, #4: 4	نَقْصِ الْأُجْرَةِ
u'نَقَصَ إِحْسَاسٌ':Subject, #1: 1	نَقَصَ الْأَجَلُ
u'نَقَصَ إحْسَانٌ':Subject, #1: 1	نَقَصَ الْإِحْسَاسُ
u'نَقَصَ أَرْبَعَةٌ':Predicate, #1: 1	نَقَصَ الْإِحْسَانُ
u'نَقَصَ إِرْثٌ':Subject, #1: 1	نَقَصَ أَرْبَعَةَ
u'نَقَصَ أرْضٌ':Predicate, #1: 1	نَقَصَ إرْثُهُ
u'نَقْصٌ أرْضٌ':Added, #1: 1	نَقَصَ الْأَرْضَ
u'نَقْصٌ أرْضٌ':Added, #1: 1	نَقْصُ الْأَرْضِ
u'نَقْصٌ أرْضٌ':Added, #1: 1	نَقْصِ الْأَرْضِ
u'نَقْصٌ أَرْكانٌ':Added, #3: 3	نَقْصَ الْأَرْضِ
u'نَقْصٌ أَرْكَانٌ':Added, #1: 1	نَقْصَ الْأَرْكَانِ
u'نَقْصٌ أسْعَارٌ':Added, #1: 1	نَقْصَ الْأَرْكَانِ
u'نَقْصٌ أسْنَانٌ':Added, #1: 1	نَقْصُ الْأَسْعَارِ
u'نَقْصٌ أُصْبُعٌ':Added, #1: 1	نَقْصِ الْأَسْنَانِ
u'نَقْصٌ أُصْبُعٌ':Added, #1: 1	نَقْصُ الْأُصْبُعِ
u'نَقَصَ أصل':Subject, #2: 2	نَقْصِ أُصْبُعٍ
u'نَقَصَ أًصْلٌ':Subject, #1: 1	نَقَصَ الْأَصْلُ
u'نَقْصٌ أَعْضَاءٌ':Added, #1: 1	نَقَصَ الْأَصْلُ
u'نَقَصَ أَكْثَرُ':Subject, #1: 1	نَقْصُ الْأَعْضَاءِ
u'نَقْصٌ أَكْثَرُ':Added, #3: 3	نَقَصَ أَكْثَرُ
u'نَقْصٌ الْمَرْأَةُ':Added, #2: 2	نَقْصِ أَكْثَرِ
u'نَقَصَ أُمٌّ':Subject, #1: 1	نَقْصَ الْمَرْأَةِ
u'نَقْصٌ أُمٌّ':Added, #1: 1	نَقَصَ أُمُّهُ
u'نَقْصٌ أُمٌّ':Added, #2: 2	نَقْصَ الْأُمِّ
u'نَقَصَ إمَامٌ':Subject, #4: 4	نَقْصِ الْأُمِّ
u'نَقْصٌ أَمْوَالٌ':Added, #2: 2	نَقَصَ الْإِمَامُ
u'نُقْصَانٌ أَجْرٌ':Added, #1: 1	نَقْصِ الْأَمْوَالِ
u'نُقْصَانٌ أَجْرٌ':Added, #1: 1	نُقْصَانَ الْأَجْرِ
u'نُقْصَانٌ أَجْرٌ':Added, #3: 3	نُقْصَانُ الْأَجْرِ
u'نُقْصَانٌ أُجْرَةٌ':Added, #3: 3	نُقْصَانِ الْأَجْرِ
u'نُقْصَانٌ أرْضٌ':Added, #1: 1	نُقْصَانِ أُجْرَةٍ
u'نُقْصَانٌ أرْضٌ':Added, #11: 11	نُقْصَانُ الْأَرْضِ
u'نُقْصَانٌ أرْضٌ':Added, #12: 12	نُقْصَانَ الْأَرْضِ
u'نُقْصَانٌ أُصْبُعٌ':Added, #7: 7	نُقْصَانِ الْأَرْضِ
u'نُقْصَانٌ أصْغَرٌ':Added, #1: 1	نُقْصَانِ أُصْبُعٍ
u'نُقْصَانٌ أَصْغَرُ':Added, #1: 1	نُقْصَانِ الْأَصْغَرِ
u'نُقْصَانٌ أصل':Added, #1: 1	نُقْصَانِ الْأَصْغَرِ
u'نُقْصَانٌ أًصْلٌ':Added, #1: 1	نُقْصَانُ الْأَصْلِ
u'نُقْصَانٌ أصل':Added, #1: 1	نُقْصَانُ الْأَصْلِ
u'نُقْصَانٌ أًصْلٌ':Added, #3: 3	نُقْصَانِ الْأَصْلِ
u'نُقْصَانٌ إضافَةٌ':Added, #3: 3	نُقْصَانِ الْأَصْلِ
u'نُقْصَانٌ أَطْرافٌ':Added, #1: 1	نُقْصَانِ الْإِضَافَةِ
u'نُقْصَانٌ أَطْرَافٌ':Added, #1: 1	نُقْصَانُ أَطْرَافِهِ
u'نُقْصَانٌ أكل':Added, #1: 1	نُقْصَانُ أَطْرَافِهِ
u'نُقْصَانٌ أَكْلٌ':Added, #1: 1	نُقْصَانِ الْأَكْلِ
u'نُقْصَانٌ آلةٌ':Added, #1: 1	نُقْصَانِ الْأَكْلِ
u'نُقْصَانٌ أُمٌّ':Added, #1: 1	نُقْصَانِ الْآلَةِ
u'نُقْصَانٌ أُمٌّ':Added, #1: 1	نُقْصَانَ الْأُمِّ
u'نُقْصَانٌ أَهِلَّةٌ':Added, #2: 2	نُقْصَانُ الْأُمِّ
u'نُقْصَانٌ بَدَلٌ':Added, #1: 1	نُقْصَانِ الْأَهِلَّةِ
u'نُقْصَانٌ بَطْشٌ':Added, #1: 1	نُقْصَانِ بَدَلِ
u'نُقْصَانٌ بَكارَةٌ':Added, #1: 1	نُقْصَانِ الْبَطْشِ
u'نُقْصَانٌ بِنَاءٌ':Added, #1: 1	نُقْصَانَ الْبَكَارَةِ
u'نُقْصَانٌ بِنَاءٌ':Added, #1: 1	نُقْصَانِ الْبِنَاءِ
u'نُقْصَانٌ بَهيمٌ':Added, #2: 2	نُقْصَانَ الْبِنَاءِ
u'نُقْصَانٌ بَهِيمَةٌ':Added, #1: 1	نُقْصَانُ الْبَهِيمَةِ
u'نُقْصَانٌ بَيْعٌ':Added, #1: 1	نُقْصَانُ الْبَهِيمَةِ
u'نُقْصَانٌ تَأْخِيرٌ':Added, #1: 1	نُقْصَانُ الْبَيْعِ
u'نُقْصَانٌ تَأْخِيرٌ':Added, #1: 1	نُقْصَانَ التَّأْخِيرِ
u'نُقْصَانٌ تَدْبِيرٌ':Added, #1: 1	نُقْصَانِ التَّأْخِيرِ
u'نُقْصَانٌ تَدْبِيرٌ':Added, #1: 1	نُقْصَانُ التَّدْبِيرِ
u'نُقْصَانٌ تَرْكٌ':Added, #2: 2	نُقْصَانِ التَّدْبِيرِ
u'نُقْصَانٌ تَزْوِيجٌ':Added, #1: 1	نُقْصَانِ تَرْكِ
u'نُقْصَانٌ تِسْعَةٌ':Added, #1: 1	نُقْصَانَ تَزْوِيجٍ
u'نَقْصٌ اِنْتِفاعٌ':Added, #2: 2	نُقْصَانُ تِسْعَةٍ
u'نُقْصَانٌ ثَلاثَةٌ':Added, #1: 1	نَقْصُ انْتِفَاعِ
u'نُقْصَانٌ ثَمَنٌ':Added, #1: 1	نُقْصَانُ ثَلَاثَةِ
u'نُقْصَانٌ ثَمَنٌ':Added, #1: 1	نُقْصَانِ الثَّمَنِ
u'نُقْصَانٌ ثَمَنٌ':Added, #1: 1	نُقْصَانُ ثَمَنِهِ
u'نُقْصَانٌ ثَمَنٌ':Added, #2: 2	نُقْصَانُ الثَّمَنِ
u'نُقْصَانٌ ثَوْبٌ':Added, #7: 7	نُقْصَانَ الثَّمَنِ
u'نُقْصَانٌ جِدار':Added, #1: 1	نُقْصَانَ الثَّوْبِ
u'نُقْصَانٌ جِرَاحَةٌ':Added, #1: 1	نُقْصَانِ الْجِدَارِ
u'نُقْصَانٌ جِرَاحَةٌ':Added, #2: 2	نُقْصَانَ الْجِرَاحَةِ
u'نُقْصَانٌ جِسْمٌ':Added, #2: 2	نُقْصَانِ الْجِرَاحَةِ
u'نُقْصَانٌ جِنَايَةٌ':Added, #1: 1	نُقْصَانِ جِسْمٍ
u'نُقْصَانٌ حالٌ':Added, #2: 2	نُقْصَانِ الْجِنَايَةِ
u'نُقْصَانٌ حالٌ':Added, #1: 1	نُقْصَانِ الْحَالِ
u'نُقْصَانٌ حالٌ':Added, #1: 1	نُقْصَانُ حَالِ
u'نُقْصَانٌ حَرْفٌ':Added, #1: 1	نُقْصَانُ حَالِهِ
u'نُقْصَانٌ حَرْفٌ':Added, #1: 1	نُقْصَانِ حَرْفٍ
u'نُقْصَانٌ حَرْقٌ':Added, #3: 3	نُقْصَانُ الْحَرْفِ
u'نُقْصَانٌ حَرَكَةٌ':Added, #2: 2	نُقْصَانَ الْحَرْقِ
u'نُقْصَانٌ حَرَكَةٌ':Added, #1: 1	نُقْصَانِ حَرَكَةٍ
u'نُقْصَانٌ حُرْمَةٌ':Added, #2: 2	نُقْصَانُ الْحَرَكَةِ
u'نُقْصَانٌ حُروفٌ':Added, #1: 1	نُقْصَانِ حُرْمَةِ
u'نُقْصَانٌ حَفْرٌ':Added, #1: 1	نُقْصَانَ الْحُرُوفِ
u'نُقْصَانٌ حَقٌّ':Added, #1: 1	نُقْصَانَ الْحَفْرِ
u'نُقْصَانٌ حَقٌّ':Added, #1: 1	نُقْصَانَ الْحَقِّ
u'نُقْصَانٌ حَقٌّ':Added, #1: 1	نُقْصَانُ الْحَقِّ
u'نُقْصَانٌ حِلٌّ':Added, #1: 1	نُقْصَانَ حَقِّ
u'نُقْصَانٌ حِلٌّ':Added, #1: 1	نُقْصَانُ الْحِلِّ
u'نُقْصَانٌ حِلٌّ':Added, #1: 1	نُقْصَانِ الْحِلِّ
u'نُقْصَانٌ حِمَارٌ':Added, #1: 1	نُقْصَانُ حِلِّهِ
u'نُقْصَانٌ حِنْطَةٌ':Added, #1: 1	نُقْصَانَ الْحِمَارِ
u'نُقْصَانٌ حَيْضٌ':Added, #1: 1	نُقْصَانُ الْحِنْطَةِ
u'نُقْصَانٌ خرق':Added, #1: 1	نُقْصَانِ الْحَيْضِ
u'نُقْصَانٌ خرق':Added, #1: 1	نُقْصَانَ الْخَرْقِ
u'نُقْصَانٌ خَرْقٌ':Added, #1: 1	نُقْصَانِ الْخَرْقِ
u'نُقْصَانٌ خَرْقٌ':Added, #1: 1	نُقْصَانَ الْخَرْقِ
u'نُقْصَانٌ دَارٌ':Added, #1: 1	نُقْصَانِ الْخَرْقِ
u'نُقْصَانٌ دِيَةٌ':Added, #1: 1	نُقْصَانِ الدَّارِ
u'نُقْصَانٌ دِيَةٌ':Added, #1: 1	نُقْصَانَ دِيَةِ
u'نُقْصَانٌ دِيَةٌ':Added, #1: 1	نُقْصَانُ دِيَةِ
u'نُقْصَانٌ دِيَةٌ':Added, #1: 1	نُقْصَانِ دِيَةِ
u'نُقْصَانٌ دَيْنٌ':Added, #1: 1	نُقْصَانِ دِيَتِهِ
u'نُقْصَانٌ دِينٌ':Added, #1: 1	نُقْصَانِ دَيْنِ
u'نُقْصَانٌ دِينٌ':Added, #2: 2	نُقْصَانِ دِينِ
u'نُقْصَانٌ رَأْيٌ':Added, #3: 3	نُقْصَانُ الدِّينِ
u'نُقْصَانٌ رُبُعٌ':Added, #1: 1	نُقْصَانَ رَأْيِهِ
u'نُقْصَانٌ رِبَوِيّ':Added, #3: 3	نُقْصَانَ رُبُعِ
u'نُقْصَانٌ رَجَبٌ':Added, #1: 1	نُقْصَانُ الرِّبَوِيَّاتِ
u'نُقْصَانٌ رِقٌّ':Added, #1: 1	نُقْصَانِ رَجَبٍ
u'نُقْصَانٌ رِقٌّ':Added, #1: 1	نُقْصَانُ الرِّقِّ
u'نُقْصَانٌ رِقٌّ':Added, #1: 1	نُقْصَانِ الرِّقِّ
u'نُقْصَانٌ رِقٌّ':Added, #1: 1	نُقْصَانُ رِقِّهِ
u'نُقْصَانٌ روحٌ':Added, #2: 2	نُقْصَانَ الرِّقِّ
u'نُقْصَانٌ زِراعَةٌ':Added, #1: 1	نُقْصَانُ الرُّوحِ
u'نُقْصَانٌ زِقٌّ':Added, #1: 1	نُقْصَانِ الزِّرَاعَةِ
u'نُقْصَانٌ زَمَنٌ':Added, #1: 1	نُقْصَانَ الزِّقِّ
u'نُقْصَانٌ زَوْجَةٌ':Added, #1: 1	نُقْصَانِ الزَّمَنِ
u'نَقْصٌ إِنْسانٌ':Added, #1: 1	نُقْصَانَ الزَّوْجَاتِ
u'نُقْصَانٌ سَبَبٌ':Added, #1: 1	نَقْصَ الْإِنْسَانِ
u'نُقْصَانٌ سَرقَةٌ':Added, #1: 1	نُقْصَانَ السَّبَبِ
u'نُقْصَانٌ سَرِقَةٌ':Added, #2: 2	نُقْصَانَ السَّرِقَةِ
u'نُقْصَانٌ سعر':Added, #2: 2	نُقْصَانَ السَّرِقَةِ
u'نُقْصَانٌ سعر':Added, #3: 3	نُقْصَانَ السِّعْرِ
u'نُقْصَانٌ سِعْرٌ':Added, #3: 3	نُقْصَانُ السِّعْرِ
u'نُقْصَانٌ سِعْرٌ':Added, #3: 3	نُقْصَانَ السِّعْرِ
u'نُقْصَانٌ سِنٌّ':Added, #3: 3	نُقْصَانُ السِّعْرِ
u'نُقْصَانٌ سِنٌّ':Added, #2: 2	نُقْصَانُ السِّنِّ
u'نُقْصَانٌ سَهْمٌ':Added, #2: 2	نُقْصَانِ السِّنِّ
u'نُقْصَانٌ سَوْطٌ':Added, #1: 1	نُقْصَانَ سَهْمِهِ
u'نُقْصَانٌ سَوْطٌ':Added, #1: 1	نُقْصَانَ السَّوْطِ
u'نُقْصَانٌ سَوْطٌ':Added, #1: 1	نُقْصَانُ سَوْطِهِ
u'نُقْصَانٌ شَجَّةٌ':Added, #3: 3	نُقْصَانِ السَّوْطِ
u'نُقْصَانٌ شَجَّةٌ':Added, #1: 1	نُقْصَانَ الشَّجَّةِ
u'نُقْصَانٌ شَجَرٌ':Added, #1: 1	نُقْصَانُ الشَّجَّةِ
u'نُقْصَانٌ شَجَرَةٌ':Added, #1: 1	نُقْصَانَ الشَّجَرِ
u'نُقْصَانٌ شَفَقَةٌ':Added, #2: 2	نُقْصَانَ الشَّجَرَةِ
u'نُقْصَانٌ شَقٌّ':Added, #1: 1	نُقْصَانِ الشَّفَقَةِ
u'نُقْصَانٌ شَهَادَةٌ':Added, #1: 1	نُقْصَانَ الشَّقِّ
u'نُقْصَانٌ شَهْرٌ':Added, #2: 2	نُقْصَانِ الشَّهَادَةِ
u'نُقْصَانٌ شَيْءٌ':Added, #1: 1	نُقْصَانِ الشَّهْرِ
u'نُقْصَانٌ شَيْءٌ':Added, #1: 1	نُقْصَانَ الشَّيْءِ
u'نُقْصَانٌ صدقة':Added, #2: 2	نُقْصَانُ شَيْءٍ
u'نُقْصَانٌ صَدَقَةٌ':Added, #1: 1	نُقْصَانُ الصَّدَقَةِ
u'نُقْصَانٌ صِفَةٌ':Added, #1: 1	نُقْصَانُ الصَّدَقَةِ
u'نُقْصَانٌ صِفَةٌ':Added, #1: 1	نُقْصَانِ صِفَةِ
u'نُقْصَانٌ صَلاَةٌ':Added, #1: 1	نُقْصَانَ صِفَتِهِ
u'نُقْصَانٌ صَلاَةٌ':Added, #1: 1	نُقْصَانَ الصَّلَاةِ
u'نُقْصَانٌ صَلاَةٌ':Added, #1: 1	نُقْصَانِ الصَّلَاةِ
u'نُقْصَانٌ صَوْمٌ':Added, #1: 1	نُقْصَانُ صَلَاتِهِ
u'نُقْصَانٌ طواف':Added, #1: 1	نُقْصَانَ الصَّوْمِ
u'نُقْصَانٌ طَوَافٌ':Added, #1: 1	نُقْصَانُ الطَّوَافِ
u'نُقْصَانٌ طواف':Added, #1: 1	نُقْصَانُ الطَّوَافِ
u'نُقْصَانٌ طَوَافٌ':Added, #1: 1	نُقْصَانَ طَوَافِ
u'نُقْصَانٌ ظَبْيٌ':Added, #1: 1	نُقْصَانَ طَوَافِ
u'نُقْصَانٌ ظَهْرٌ':Added, #1: 1	نُقْصَانَ الظَّبْيَةِ
u'نُقْصَانٌ عَبْدٌ':Added, #1: 1	نُقْصَانِ ظَهْرٍ
u'نُقْصَانٌ عَدَدٌ':Added, #1: 1	نُقْصَانِ الْعَبْدِ
u'نُقْصَانٌ عَدَدٌ':Added, #1: 1	نُقْصَانُ الْعَدَدِ
u'نُقْصَانٌ عَدَدٌ':Added, #1: 1	نُقْصَانَ عَدَدِ
u'نُقْصَانٌ عَدَدٌ':Added, #2: 2	نُقْصَانِ الْعَدَدِ
u'نُقْصَانٌ عِرْضٌ':Added, #4: 4	نُقْصَانَ الْعَدَدِ
u'نُقْصَانٌ عُشْرٌ':Added, #1: 1	نُقْصَانِ عِرْضِ
u'نُقْصَانٌ عُضْوٌ':Added, #1: 1	نُقْصَانَ عُشْرِ
u'نُقْصَانٌ عَقْلٌ':Added, #1: 1	نُقْصَانَ الْعُضْوِ
u'نُقْصَانٌ عَقْلٌ':Added, #1: 1	نُقْصَانِ الْعَقْلِ
u'نُقْصَانٌ عَقْلٌ':Added, #3: 3	نُقْصَانَ الْعَقْلِ
u'نُقْصَانٌ عَيْبٌ':Added, #7: 7	نُقْصَانُ الْعَقْلِ
u'نُقْصَانٌ عَيْبٌ':Added, #13: 13	نُقْصَانِ الْعَيْبِ
u'نُقْصَانٌ عَيْبٌ':Added, #1: 1	نُقْصَانِ الْعَيْبَيْنِ
u'نُقْصَانٌ عَيْبٌ':Added, #1: 1	نُقْصَانَ عَيْبِ
u'نُقْصَانٌ عَيْبٌ':Added, #1: 1	نُقْصَانِ عَيْبِ
u'نُقْصَانٌ عَيْبٌ':Added, #5: 5	نُقْصَانُ الْعَيْبِ
u'نُقْصَانٌ عين':Added, #6: 6	نُقْصَانَ الْعَيْبِ
u'نُقْصَانٌ عَيْنٌ':Added, #1: 1	نُقْصَانُ الْعَيْنِ
u'نُقْصَانٌ عَيْن':Added, #1: 1	نُقْصَانُ الْعَيْنِ
u'نُقْصَانٌ عَيْنٌ':Added, #1: 1	نُقْصَانُ الْعَيْنِ
u'نُقْصَانٌ عَيْن':Added, #1: 1	نُقْصَانِ الْعَيْنَيْنِ
u'نُقْصَانٌ عين':Added, #1: 1	نُقْصَانِ الْعَيْنَيْنِ
u'نُقْصَانٌ عَيْنٌ':Added, #3: 3	نُقْصَانِ الْعَيْنِ
u'نُقْصَانٌ عَيْن':Added, #3: 3	نُقْصَانِ الْعَيْنِ
u'نُقْصَانٌ غَرْسٌ':Added, #3: 3	نُقْصَانِ الْعَيْنِ
u'نُقْصَانٌ غَزْلٌ':Added, #1: 1	نُقْصَانَ الْغَرْسِ
u'نُقْصَانٌ غَلَّةٌ':Added, #1: 1	نُقْصَانَ الْغَزْلِ
u'نُقْصَانٌ غير':Added, #1: 1	نُقْصَانُ الْغَلَّةِ
u'نُقْصَانٌ غَيْرٌ':Added, #2: 2	نُقْصَانِ غَيْرِهِ
u'نُقْصَانٌ فَاحِشٌ':Added, #2: 2	نُقْصَانِ غَيْرِهِ
u'نُقْصَانٌ فَتْقٌ':Added, #1: 1	نُقْصَانٍ فَاحِشٍ
u'نُقْصَانٌ قَدْرٌ':Added, #1: 1	نُقْصَانَ الْفَتْقِ
u'نُقْصَانٌ قَطْعٌ':Added, #2: 2	نُقْصَانَ قَدْرٍ
u'نُقْصَانٌ قَطْعٌ':Added, #1: 1	نُقْصَانُ الْقَطْعِ
u'نُقْصَانٌ قَطْعٌ':Added, #3: 3	نُقْصَانَ الْقَطْعِ
u'نُقْصَانٌ قِيمَةٌ':Added, #3: 3	نُقْصَانِ الْقَطْعِ
u'نُقْصَانٌ قِيمَةٌ':Added, #15: 15	نُقْصَانُ الْقِيمَةِ
u'نُقْصَانٌ قِيمَةٌ':Added, #1: 1	نُقْصَانَ الْقِيمَةِ
u'نُقْصَانٌ قِيمَةٌ':Added, #1: 1	نُقْصَانَ قِيمَةِ
u'نُقْصَانٌ قِيمَةٌ':Added, #2: 2	نُقْصَانِ قِيمَةِ
u'نُقْصَانٌ قِيمَةٌ':Added, #2: 2	نُقْصَانُ قِيمَتِهِ
u'نُقْصَانٌ قِيمَةٌ':Added, #3: 3	نُقْصَانِ الْقِيمَةِ
u'نُقْصَانٌ كفر':Added, #3: 3	نُقْصَانُ قِيمَةِ
u'نُقْصَانٌ كفر':Added, #1: 1	نُقْصَانَ الْكُفْرِ
u'نُقْصَانٌ كُفْرٌ':Added, #1: 1	نُقْصَانُ الْكُفْرِ
u'نُقْصَانٌ كُفْرٌ':Added, #1: 1	نُقْصَانَ الْكُفْرِ
u'نُقْصَانٌ كَيْلٌ':Added, #1: 1	نُقْصَانُ الْكُفْرِ
u'نُقْصَانٌ لُؤْلُؤٌ':Added, #1: 1	نُقْصَانِ الْكَيْلِ
u'نُقْصَانٌ مَاءٌ':Added, #1: 1	نُقْصَانَ اللُّؤْلُؤِ
u'نُقْصَانٌ مَادَّةٌ':Added, #1: 1	نُقْصَانِ الْمَاءِ
u'نُقْصَانٌ مَالٌ':Added, #1: 1	نُقْصَانِ الْمَادَّةِ
u'نُقْصَانٌ مالِك':Added, #1: 1	نُقْصَانُ مَالِهِ
u'نُقْصَانٌ مالِكِيّ':Added, #1: 1	نُقْصَانَ الْمَالِكِيَّةِ
u'نُقْصَانٌ مَالِيٌّ':Added, #1: 1	نُقْصَانَ الْمَالِكِيَّةِ
u'نُقْصَانٌ مَالِيٌّ':Added, #1: 1	نُقْصَانَ الْمَالِيَّةِ
u'نُقْصَانٌ مَالِيٌّ':Added, #1: 1	نُقْصَانِ مَالِيَّةِ
u'نُقْصَانٌ مَجْمُوعٌ':Added, #2: 2	نُقْصَانُ الْمَالِيَّةِ
u'نُقْصَانٌ مُسْلِمٌ':Added, #1: 1	نُقْصَانِ مَجْمُوعِ
u'نُقْصَانٌ مَعْلُومٌ':Added, #1: 1	نُقْصَانَ مُسْلِمٍ
u'نُقْصَانٌ مُغْتاب':Added, #1: 1	نُقْصَانٍ مَعْلُومٍ
u'نُقْصَانٌ مَفْرُوضٌ':Added, #1: 1	نُقْصَانَ الْمُغْتَابِ
u'نُقْصَانٌ مِقْدَارٌ':Added, #1: 1	نُقْصَانَ مَفْرُوضَاتِهِ
u'نُقْصَانٌ مِلْكٌ':Added, #1: 1	نُقْصَانُ مِقْدَارِ
u'نُقْصَانٌ مِلْكٌ':Added, #1: 1	نُقْصَانَ الْمِلْكِ
u'نُقْصَانٌ مِلْكٌ':Added, #1: 1	نُقْصَانُ الْمِلْكِ
u'نُقْصَانٌ مِلْكٌ':Added, #1: 1	نُقْصَانِ مِلْكِ
u'نُقْصَانٌ مَهْرٌ':Added, #2: 2	نُقْصَانِ الْمِلْكِ
u'نُقْصَانٌ مَوْهُوبٌ':Added, #2: 2	نُقْصَانِ الْمَهْرِ
u'نُقْصَانٌ نَسَبٌ':Added, #1: 1	نُقْصَانُ الْمَوْهُوبِ
u'نُقْصَانٌ نصاب':Added, #1: 1	نُقْصَانُ النَّسَبِ
u'نُقْصَانٌ نِصَابٌ':Added, #1: 1	نُقْصَانَ النِّصَابِ
u'نُقْصَانٌ نصاب':Added, #1: 1	نُقْصَانَ النِّصَابِ
u'نُقْصَانٌ نِصَابٌ':Added, #3: 3	نُقْصَانِ النِّصَابِ
u'نُقْصَانٌ نِصْفٌ':Added, #3: 3	نُقْصَانِ النِّصَابِ
u'نُقْصَانٌ نِصْفٌ':Added, #1: 1	نُقْصَانُ نِصْفِ
u'نُقْصَانٌ نَصْلٌ':Added, #3: 3	نُقْصَانَ نِصْفِ
u'نُقْصَانٌ نَصِيبٌ':Added, #1: 1	نُقْصَانِ النَّصْلِ
u'نُقْصَانٌ هزال':Added, #1: 1	نُقْصَانَ نَصِيبِهِ
u'نُقْصَانٌ هُزَالٌ':Added, #1: 1	نُقْصَانَ الْهُزَالِ
u'نُقْصَانٌ وَاجِبٌ':Added, #1: 1	نُقْصَانَ الْهُزَالِ
u'نُقْصَانٌ ورق':Added, #1: 1	نُقْصَانِ الْوَاجِبِ
u'نُقْصَانٌ وَرَقٌ':Added, #1: 1	نُقْصَانَ الْوَرَقِ
u'نُقْصَانٌ وَصْفٌ':Added, #1: 1	نُقْصَانَ الْوَرَقِ
u'نُقْصَانٌ وَصْفٌ':Added, #1: 1	نُقْصَانَ الْوَصْفِ
u'نُقْصَانٌ وَصِيٌّ':Added, #1: 1	نُقْصَانِ الْوَصْفِ
u'نُقْصَانٌ وَصِيَّةٌ':Added, #1: 1	نُقْصَانِ الْوَصِيَّةِ
u'نُقْصَانٌ وَقْت':Added, #1: 1	نُقْصَانِ الْوَصِيَّةِ
u'نُقْصَانٌ وَقْتِيّ':Added, #1: 1	نُقْصَانُ الْوَقْتِيَّةِ
u'نُقْصَانٌ وِلاَدَةٌ':Added, #1: 1	نُقْصَانُ الْوَقْتِيَّةِ
u'نُقْصَانٌ وِلاَدَةٌ':Added, #1: 1	نُقْصَانُ الْوِلَادَةِ
u'نُقْصَانٌ وِلاَدَةٌ':Added, #6: 6	نُقْصَانِ الْوِلَادَةِ
u'نُقْصَانٌ يَدٌ':Added, #7: 7	نُقْصَانَ الْوِلَادَةِ
u'نُقْصَانٌ يَوْمٌ':Added, #1: 1	نُقْصَانَ يَدِهِ
u'نَقْصٌ أهْلٌ':Added, #5: 5	نُقْصَانَ يَوْمٍ
u'نَقْصٌ بَصَرٌ':Added, #1: 1	نَقْصُ أَهْلِ
u'نَقْصٌ بَصَرٌ':Added, #1: 1	نَقْصِ الْبَصَرِ
u'نَقَصَ بَعْضٌ':Subject, #1: 1	نَقْصِ بَصَرٍ
u'نَقْصٌ بَعْضٌ':Added, #2: 2	نَقَصَ بَعْضُهُ
u'نَقْصٌ بَعْضٌ':Added, #1: 1	نَقْصُ بَعْضٍ
u'نَقَصَ بِنَاءٌ':Predicate, #1: 1	نَقْصُ بَعْضِ
u'نَقَصَ بِنَاءٌ':Subject, #1: 1	نَقَصَ الْبِنَاءَ
u'نَقْصٌ بِنَاءٌ':Added, #5: 5	نَقَصَ الْبِنَاءُ
u'نَقْصٌ بِنَاءٌ':Added, #1: 1	نَقْصُ الْبِنَاءِ
u'نَقَصَ بَيْنٌ':Predicate, #2: 2	نَقْصِ الْبِنَاءِ
u'نَقْصٌ تَصَرُّفٌ':Added, #1: 1	نَقَصَ بَيْنَ
u'نَقْصٌ تَعْلِيقٌ':Added, #2: 2	نَقْصُ التَّصَرُّفِ
u'نَقْصٌ تَعَيُّنٌ':Added, #1: 1	نَقْصُ التَّعْلِيقِ
u'نَقَصَ تَكْبِير':Predicate, #1: 1	نَقْصُ تَعَيُّنِ
u'نَقْصٌ تَكْبيرٌ':Added, #1: 1	نَقَصَ تَكْبِيرَةً
u'نَقْصٌ ثَالِثٌ':Added, #1: 1	نَقْصَ التَّكْبِيرِ
u'نَقْصٌ ثَلاثُ':Added, #1: 1	نَقْصُ الثَّالِثِ
u'نَقَصَ ثَمَنٌ':Predicate, #8: 8	نَقْصِ ثَلَاثِ
u'نَقَصَ ثَمَنٌ':Subject, #1: 1	نَقَصَ الثَّمَنَ
u'نَقَصَ ثَمَنٌ':Subject, #3: 3	نَقَصَ ثَمَنُهُ
u'نَقْصٌ ثَمَنٌ':Added, #7: 7	نَقَصَ الثَّمَنُ
u'نَقْصٌ ثَمَنٌ':Added, #1: 1	نَقْصَ الثَّمَنِ
u'نَقْصٌ ثَمَنٌ':Added, #1: 1	نَقْصُ ثَمَنٍ
u'نَقَصَ ثَوابٌ':Subject, #3: 3	نَقْصِ الثَّمَنِ
u'نَقَصَ ثَوْبٌ':Subject, #1: 1	نَقَصَ ثَوَابُهُ
u'نَقْصٌ ثَوْبٌ':Added, #1: 1	نَقَصَ الثَّوْبُ
u'نَقْصٌ ثَوْبٌ':Added, #2: 2	نَقْصُ الثَّوْبِ
u'نَقَصَ جَازٌ':Predicate, #5: 5	نَقْصَ الثَّوْبِ
u'نَقْصٌ جِرْمٌ':Added, #1: 1	نَقَصَ جَازَ
u'نَقْصٌ جِرْمٌ':Added, #1: 1	نَقْصِ الْجِرْمِ
u'نَقْصٌ جُزْءٌ':Added, #1: 1	نَقْصُ جِرْمٍ
u'نَقْصٌ جُزْءٌ':Added, #1: 1	نَقْصُ جُزْءٍ
u'نَقَصَ جلسة':Predicate, #1: 1	نَقْصِ جُزْءٍ
u'نَقَصَ جَلْسَةٌ':Predicate, #1: 1	نَقَصَ الْجَلْسَةَ
u'نَقَصَ جُمْلَةٌ':Predicate, #1: 1	نَقَصَ الْجَلْسَةَ
u'نَقَصَ حادِثٌ':Subject, #1: 1	نَقَصَ الْجُمْلَةَ
u'نَقَصَ حاكِمٌ':Subject, #2: 2	نَقَصَ الْحَادِثُ
u'نَقَصَ حَديثٌ':Predicate, #1: 1	نَقَصَ الْحَاكِمُ
u'نَقْصٌ حَرْفٌ':Added, #1: 1	نَقَصَ الْحَدِيثَ
u'نَقْصٌ حِصَّةٌ':Added, #1: 1	نَقْصَ الْحَرْفِ
u'نَقْصٌ حِصَّةٌ':Added, #1: 1	نَقْصِ حِصَّةِ
u'نَقَصَ حَفْرٌ':Subject, #1: 1	نَقْصِ حِصَّتِهِ
u'نَقَصَ حَقٌّ':Subject, #1: 1	نَقَصَ الْحَفْرُ
u'نَقْصٌ حُكُومَةٌ':Added, #2: 2	نَقَصَ حَقُّ
u'نَقْصٌ حَواسٌّ':Added, #2: 2	نَقْصُ الْحُكُومَةِ
u'نَقْصٌ حَوَاسُّ':Added, #2: 2	نَقْصُ الْحَوَاسِّ
u'نَقْصٌ خلقة':Added, #2: 2	نَقْصُ الْحَوَاسِّ
u'نَقْصٌ خِلْقَةٌ':Added, #2: 2	نَقْصُ الْخِلْقَةِ
u'نَقْصٌ دِرْهَمٌ':Added, #2: 2	نَقْصُ الْخِلْقَةِ
u'نَقْصٌ دِرْهَم':Added, #1: 1	نَقْصِ دِرْهَمٍ
u'نَقْصٌ دَقيقٌ':Added, #1: 1	نَقْصِ دِرْهَمٍ
u'نَقَصَ دُهْنٌ':Subject, #1: 1	نَقْصَ الدَّقِيقِ
u'نَقْصٌ دِيَةٌ':Added, #1: 1	نَقَصَ دُهْنُ
u'نَقْصٌ دِينٌ':Added, #1: 1	نَقْصُ دِيَتِهِ
u'نَقَصَ ذِراعٌ':Subject, #1: 1	نَقْصُ دِينِ
u'نَقْصٌ رَأْسٌ':Added, #1: 1	نَقَصَ ذِرَاعٌ
u'نَقْصٌ رُبُعٌ':Added, #1: 1	نَقْصِ رَأْسِ
u'نَقْصٌ رُطَبٌ':Added, #1: 1	نَقْصُ رُبُعِ
u'نَقْصٌ رِقٌّ':Added, #2: 2	نَقْصَ الرُّطَبِ
u'نَقْصٌ رَقيقٌ':Added, #4: 4	نَقْصَ الرِّقِّ
u'نَقْصٌ رَقيق':Added, #2: 2	نَقْصِ الرَّقِيقِ
u'نَقْصٌ ركعة':Added, #2: 2	نَقْصِ الرَّقِيقِ
u'نَقْصٌ ركعة':Added, #1: 1	نَقْصُ رَكْعَةٍ
u'نَقْصٌ رَكْعَةٌ':Added, #1: 1	نَقْصِ رَكْعَةٍ
u'نَقْصٌ رَكْعَةٌ':Added, #1: 1	نَقْصُ رَكْعَةٍ
u'نَقَصَ رَمَضانُ':Subject, #1: 1	نَقْصِ رَكْعَةٍ
u'نَقَصَ رَهْنٌ':Subject, #1: 1	نَقَصَ رَمَضَانُ
u'نَقْصٌ زَرْعٌ':Added, #1: 1	نَقَصَ الرَّهْنُ
u'نَقَصَ سعر':Subject, #1: 1	نَقْصِ زَرْعِهِ
u'نَقَصَ سِعْرٌ':Subject, #2: 2	نَقَصَ السِّعْرُ
u'نَقْصٌ سعر':Added, #2: 2	نَقَصَ السِّعْرُ
u'نَقْصٌ سِعْرٌ':Added, #1: 1	نَقْصِ السِّعْرِ
u'نَقْصٌ سِعْرٌ':Added, #1: 1	نَقْصِ السِّعْرِ
u'نَقَصَ سقط':Predicate, #1: 1	نَقْصَ سِعْرٍ
u'نَقَصَ سَقَطٌ':Predicate, #1: 1	نَقَصَ سَقَطَ
u'نَقَصَ سَمْعٌ':Subject, #1: 1	نَقَصَ سَقَطَ
u'نَقْصٌ سَمْعٌ':Added, #1: 1	نَقَصَ سَمْعُهُ
u'نَقْصٌ سُنَّةٌ':Added, #1: 1	نَقْصِ سَمْعِهِ
u'نَقْصٌ سُنَّةٌ':Added, #1: 1	نَقْصُ السُّنَّةِ
u'نَقَصَ سَهْمٌ':Subject, #1: 1	نَقْصِ السُّنَّةِ
u'نَقَصَ سُورَةٌ':Predicate, #1: 1	نَقَصَ سَهْمُهُ
u'نَقْصٌ سُورَةٌ':Added, #1: 1	نَقَصَ السُّورَةَ
u'نَقْصٌ سُورَةٌ':Added, #1: 1	نَقْصَ السُّورَةِ
u'نَقْصٌ سُوقٌ':Added, #1: 1	نَقْصِ السُّورَةِ
u'نَقَصَ سَيْرٌ':Predicate, #1: 1	نَقْصِ السُّوقِ
u'نَقْصٌ سَيْرٌ':Added, #1: 1	نَقَصَ السَّيْرَ
u'نَقْصٌ شَابٌّ':Added, #1: 1	نَقْصُ السَّيْرِ
u'نَقَصَ شِبْرٌ':Subject, #1: 1	نَقْصَ الشَّابِّ
u'نَقَصَ شَمٌّ':Subject, #1: 1	نَقَصَ شِبْرٌ
u'نَقَصَ شَهْرٌ':Subject, #1: 1	نَقَصَ شَمُّ
u'نَقْصٌ شَهْرٌ':Added, #3: 3	نَقَصَ الشَّهْرُ
u'نَقَصَ شَوَّالٌ':Subject, #1: 1	نَقْصِ الشَّهْرِ
u'نَقَصَ شَيْءٌ':Subject, #1: 1	نَقَصَ شَوَّالٌ
u'نَقْصٌ شَيْءٌ':Added, #2: 2	نَقَصَ شَيْءٌ
u'نَقَصَ صبرة':Subject, #3: 3	نَقْصِ شَيْءٍ
u'نَقَصَ صُبْرَةٌ':Subject, #1: 1	نَقَصَ الصُّبْرَةُ
u'نَقَصَ صِبْغٌ':Subject, #1: 1	نَقَصَ الصُّبْرَةُ
u'نَقْصٌ صَبْغٌ':Added, #1: 1	نَقَصَ الصِّبْغُ
u'نَقَصَ صداق':Subject, #1: 1	نَقْصِ الصَّبْغِ
u'نَقَصَ صَدَاقٌ':Subject, #2: 2	نَقَصَ الصَّدَاقُ
u'نَقْصٌ صَغِيرٌ':Added, #2: 2	نَقَصَ الصَّدَاقُ
u'نَقَصَ صِفَةٌ':Subject, #1: 1	نَقْصُ الصَّغِيرَةِ
u'نَقْصٌ صِفَةٌ':Added, #1: 1	نَقَصَ صِفَةٌ
u'نَقْصٌ صِفَةٌ':Added, #1: 1	نَقْصَ الصِّفَةِ
u'نَقْصٌ صِفَةٌ':Added, #1: 1	نَقْصُ صِفَةٍ
u'نَقْصٌ صِفَةٌ':Added, #1: 1	نَقْصِ صِفَةٍ
u'نَقْصٌ صَلاَةٌ':Added, #1: 1	نَقْصَ صِفَتِهِ
u'نَقْصٌ صَنْج':Added, #1: 1	نَقْصِ صَلَاةِ
u'نَقْصٌ صَنْج':Added, #2: 2	نَقْصِ صَنْجَةٍ
u'نَقْصٌ ضرس':Added, #3: 3	نَقْصِ الصَّنْجَةِ
u'نَقْصٌ ضِرْسٌ':Added, #1: 1	نَقْصُ الضِّرْسِ
u'نَقَصَ ضَعِيفٌ':Subject, #1: 1	نَقْصُ الضِّرْسِ
u'نَقْصٌ ضَعِيفٌ':Added, #3: 3	نَقَصَ الضَّعِيفُ
u'نَقَصَ ضَمِنٌ':Predicate, #1: 1	نَقْصِ الضَّعِيفِ
u'نَقْصٌ ضَوْءٌ':Added, #1: 1	نَقَصَ ضَمِنَ
u'نَقْصٌ طحن':Added, #1: 1	نَقْصُ الضَّوْءِ
u'نَقْصٌ طَعْمٌ':Added, #1: 1	نَقْصِ الطَّحْنِ
u'نَقَصَ طَلاَقٌ':Subject, #1: 1	نَقْصِ الطَّعْمِ
u'نَقْصٌ طَهَارَةٌ':Added, #1: 1	نَقَصَ الطَّلاَقُ
u'نَقَصَ طهر':Subject, #1: 1	نَقْصِ طَهَارَةِ
u'نَقَصَ طُهْرٌ':Subject, #1: 1	نَقَصَ الطُّهْرُ
u'نَقْصٌ طهر':Added, #1: 1	نَقَصَ الطُّهْرُ
u'نَقْصٌ طُهْرٌ':Added, #1: 1	نَقْصَ الطُّهْرِ
u'نَقْصٌ طَيْشٌ':Added, #1: 1	نَقْصَ الطُّهْرِ
u'نَقَصَ عَبْدٌ':Predicate, #1: 1	نَقْصَ الطَّيْشِ
u'نَقَصَ عَبْدٌ':Subject, #2: 2	نَقَصَ الْعَبْدَ
u'نَقْصٌ عَبْدٌ':Added, #2: 2	نَقَصَ الْعَبْدُ
u'نَقْصٌ عُجْبٌ':Added, #2: 2	نَقْصَ الْعَبْدِ
u'نَقَصَ عِدَّةٌ':Predicate, #1: 1	نَقْصِ الْعُجْبِ
u'نَقَصَ عَدَدٌ':Predicate, #1: 1	نَقَصَ الْعِدَّةَ
u'نَقَصَ عَدَدٌ':Predicate, #1: 1	نَقَصَ الْعَدَدَ
u'نَقَصَ عَدَدٌ':Subject, #1: 1	نَقَصَ عَدَدَكَ
u'نَقَصَ عَدَدٌ':Subject, #5: 5	نَقَصَ عَدَدُ
u'نَقْصٌ عَدَدٌ':Added, #8: 8	نَقَصَ الْعَدَدُ
u'نَقْصٌ عَدَدٌ':Added, #2: 2	نَقْصَ الْعَدَدِ
u'نَقَصَ عُشْرٌ':Subject, #2: 2	نَقْصِ الْعَدَدِ
u'نَقَصَ عُضْوٌ':Subject, #1: 1	نَقَصَ عُشْرُ
u'نَقْصٌ عُضْوٌ':Added, #1: 1	نَقَصَ عُضْوٌ
u'نَقَصَ عَقْلٌ':Subject, #1: 1	نَقْصَ الْعُضْوِ
u'نَقْصٌ عَقْلٌ':Added, #3: 3	نَقَصَ عَقْلُهُ
u'نَقْصٌ عَقْلٌ':Added, #1: 1	نَقْصِ الْعَقْلِ
u'نَقْصٌ عَمَلٌ':Added, #1: 1	نَقْصُ عَقْلٍ
u'نَقْصٌ عَهْدٌ':Added, #1: 1	نَقْصِ الْعَمَلِ
u'نَقْصٌ عَيْبٌ':Added, #1: 1	نَقْصُ الْعَهْدِ
u'نَقَصَ عين':Predicate, #1: 1	نَقْصِ الْعَيْبِ
u'نَقَصَ عَيْنٌ':Predicate, #3: 3	نَقَصَ الْعَيْنَ
u'نَقَصَ عَيْن':Predicate, #3: 3	نَقَصَ الْعَيْنَ
u'نَقْصٌ عين':Added, #3: 3	نَقَصَ الْعَيْنَ
u'نَقْصٌ عَيْنٌ':Added, #1: 1	نَقْصِ الْعَيْنِ
u'نَقْصٌ عَيْن':Added, #1: 1	نَقْصِ الْعَيْنِ
u'نَقْصٌ عين':Added, #1: 1	نَقْصِ الْعَيْنِ
u'نَقْصٌ عين':Added, #1: 1	نَقْصُ عَيْنِ
u'نَقْصٌ عَيْنٌ':Added, #1: 1	نَقْصِ عَيْنِ
u'نَقْصٌ عَيْنٌ':Added, #1: 1	نَقْصُ عَيْنِ
u'نَقْصٌ عَيْن':Added, #1: 1	نَقْصِ عَيْنِ
u'نَقْصٌ عَيْن':Added, #1: 1	نَقْصُ عَيْنِ
u'نَقْصٌ عين':Added, #1: 1	نَقْصِ عَيْنِ
u'نَقْصٌ عَيْنٌ':Added, #1: 1	نَقْصَ عَيْنِهِ
u'نَقْصٌ عَيْن':Added, #1: 1	نَقْصَ عَيْنِهِ
u'نَقْصٌ غِرَاسٌ':Added, #1: 1	نَقْصَ عَيْنِهِ
u'نَقْصٌ غَزْلٌ':Added, #3: 3	نَقْصِ الْغِرَاسِ
u'نَقْصٌ غير':Added, #2: 2	نَقْصِ الْغَزْلِ
u'نَقْصٌ غير':Added, #1: 1	نَقْصَ غَيْرِ
u'نَقْصٌ غَيْرٌ':Added, #1: 1	نَقْصُ غَيْرِ
u'نَقْصٌ غَيْرٌ':Added, #1: 1	نَقْصَ غَيْرِ
u'نَقْصٌ فَاحِشٌ':Added, #1: 1	نَقْصُ غَيْرِ
u'نَقْصٌ فَرَائِضُ':Added, #1: 1	نَقْصٍ فَاحِشٍ
u'نَقْصٌ فَرَائِضُ':Added, #1: 1	نَقْصَ الْفَرَائِضِ
u'نَقَصَ قَالٌ':Predicate, #1: 1	نَقْصِ الْفَرَائِضِ
u'نَقْصٌ قَبْضٌ':Added, #2: 2	نَقَصَ قَالَ
u'نَقَصَ قَدْرٌ':Subject, #1: 1	نَقْصِ الْقَبْضِ
u'نَقْصٌ قَدْرٌ':Added, #1: 1	نَقَصَ قَدْرُ
u'نَقْصٌ قَدْرٌ':Added, #1: 1	نَقْصُ الْقَدْرِ
u'نَقَصَ قَطْعٌ':Subject, #1: 1	نَقْصُ قَدْرٍ
u'نَقْصٌ قَطْعٌ':Added, #1: 1	نَقَصَ الْقَطْعُ
u'نَقَصَ قَوْمٌ':Subject, #1: 1	نَقْصَ الْقَطْعِ
u'نَقَصَ قِيمَةٌ':Predicate, #1: 1	نَقَصَ قَوْمٌ
u'نَقَصَ قِيمَةٌ':Predicate, #1: 1	نَقَصَ قِيمَةَ
u'نَقْصٌ قِيمَةٌ':Added, #2: 2	نَقَصَ الْقِيمَةَ
u'نَقْصٌ قِيمَةٌ':Added, #1: 1	نَقْص قِيمَةِ
u'نَقْصٌ قِيمَةٌ':Added, #1: 1	نَقْصُ قِيمَةِ
u'نَقْصٌ قِيمَةٌ':Added, #1: 1	نَقْصِ قِيمَةِ
u'نَقْصٌ قِيمَةٌ':Added, #2: 2	نَقْصَ قِيمَتِهِ
u'نَقْصٌ قِيمَةٌ':Added, #2: 2	نَقْصُ قِيمَتِهِ
u'نَقْصٌ قِيمَةٌ':Added, #5: 5	نَقْصَ الْقِيمَةِ
u'نَقْصٌ قِيمَةٌ':Added, #6: 6	نَقْصُ الْقِيمَةِ
u'نَقْصٌ قِيمَةٌ':Added, #6: 6	نَقْصِ قِيمَتِهِ
u'نَقْصٌ كفر':Added, #8: 8	نَقْصِ الْقِيمَةِ
u'نَقْصٌ كُفْرٌ':Added, #1: 1	نَقْصِ الْكُفْرِ
u'نَقْصٌ كفر':Added, #1: 1	نَقْصِ الْكُفْرِ
u'نَقْصٌ كُفْرٌ':Added, #2: 2	نَقْصَ الْكُفْرِ
u'نَقَصَ كَلاَمٌ':Subject, #2: 2	نَقْصَ الْكُفْرِ
u'نَقَصَ كوافر':Subject, #2: 2	نَقَصَ الْكَلَامُ
u'نَقَصَ كَوَافِرُ':Subject, #1: 1	نَقَصَ الْكَوَافِرُ
u'نَقَصَ كَيْلٌ':Subject, #1: 1	نَقَصَ الْكَوَافِرُ
u'نَقْصٌ لبن':Added, #1: 1	نَقَصَ كَيْلٌ
u'نَقْصٌ لَبَنٌ':Added, #1: 1	نَقْصِ اللَّبَنِ
u'نَقَصَ لَحْمٌ':Predicate, #1: 1	نَقْصِ اللَّبَنِ
u'نَقْصٌ لَحْمٌ':Added, #1: 1	نَقَصَ اللَّحْمَ
u'نَقَصَ لَيْلٌ':Subject, #2: 2	نَقْصِ اللَّحْمِ
u'نَقَصَ مَاءٌ':Predicate, #1: 1	نَقَصَ اللَّيْلُ
u'نَقَصَ مَاءٌ':Subject, #1: 1	نَقَصَ مَاءَ
u'نَقَصَ مَاءٌ':Subject, #1: 1	نَقَصَ الْمَاءُ
u'نَقْصٌ مَاءٌ':Added, #1: 1	نَقَصَ مَاءُ
u'نَقْصٌ مَاءٌ':Added, #1: 1	نَقْصَ الْمَاءِ
u'نَقَصَ مَالٌ':Subject, #1: 1	نَقْصِ الْمَاءِ
u'نَقَصَ مَالٌ':Subject, #2: 2	نَقَصَ مَالُ
u'نَقْصٌ مَالٌ':Added, #2: 2	نَقَصَ مَالُهُ
u'نَقْصٌ مَالٌ':Added, #1: 1	نَقْصُ مَالِهِ
u'نَقْصٌ مَالٌ':Added, #1: 1	نَقْصِ مَالِهِ
u'نَقْصٌ مَالِيٌّ':Added, #2: 2	نَقْصِ الْمَالِ
u'نَقْصٌ مَالِيٌّ':Added, #1: 1	نَقْصِ الْمَالِيَّةِ
u'نَقَصَ مَجْمُوعٌ':Subject, #2: 2	نَقْصُ الْمَالِيَّةِ
u'نَقْصٌ مَرْتَبَةٌ':Added, #1: 1	نَقَصَ مَجْمُوعُ
u'نَقْصٌ مَرْهُونٌ':Added, #1: 1	نَقْصِ الْمَرْتَبَةِ
u'نَقْصٌ مُرُوءةٌ':Added, #1: 1	نَقْصِ الْمَرْهُونِ
u'نَقْصٌ مُرُوءةٌ':Added, #1: 1	نَقْصَ مُرُوءَةٍ
u'نَقَصَ مَشْيٌ':Subject, #1: 1	نَقْصِ مُرُوءَةٍ
u'نَقَصَ مَغْصُوب':Subject, #1: 1	نَقَصَ مَشْيُهُ
u'نَقْصٌ مَغْصُوب':Added, #2: 2	نَقَصَ الْمَغْصُوبُ
u'نَقْصٌ مِقْدَارٌ':Added, #1: 1	نَقْصِ الْمَغْصُوبِ
u'نَقْصٌ مُكْرَهٌ':Added, #1: 1	نَقْصُ الْمِقْدَارِ
u'نَقَصَ مُلْحَقٌ':Subject, #2: 2	نَقْصُ الْمُكْرَهَةِ
u'نَقْصٌ مِلْكٌ':Added, #1: 1	نَقَصَ مُلْحَقٌ
u'نَقْصٌ مَنَارٌ':Added, #1: 1	نَقْصِ مِلْكِ
u'نَقْصٌ مَنَافِعُ':Added, #1: 1	نَقْصُ مَنَارَتِهِ
u'نَقْصٌ مَنْزِلَةٌ':Added, #1: 1	نَقْصَ الْمَنَافِعِ
u'نَقْصٌ مَنْزِلَةٌ':Added, #1: 1	نَقْصِ الْمَنْزِلَةِ
u'نَقْصٌ مَنْعٌ':Added, #2: 2	نَقْصَ مَنْزِلَتِهِ
u'نَقَصَ مُنْفَصِلٌ':Subject, #1: 1	نَقْصَ مَنْعٍ
u'نَقْصٌ مَهْرٌ':Added, #1: 1	نَقَصَ الْمُنْفَصِلُ
u'نَقَصَ موارد':Subject, #2: 2	نَقْصِ مَهْرِ
u'نَقَصَ مَوَارِدُ':Subject, #1: 1	نَقَصَ مَوَارِدُ
u'نَقَصَ نُجُومٌ':Subject, #1: 1	نَقَصَ مَوَارِدُ
u'نَقَصَ نخلة':Predicate, #1: 1	نَقَصَ النُّجُومُ
u'نَقَصَ نَخْلَةٌ':Predicate, #1: 1	نَقَصَ النَّخْلَةَ
u'نَقْصٌ نسج':Added, #1: 1	نَقَصَ النَّخْلَةَ
u'نَقْصٌ نَسْجٌ':Added, #1: 1	نَقْصَ النَّسْجِ
u'نَقَصَ نُسُكٌ':Subject, #1: 1	نَقْصَ النَّسْجِ
u'نَقَصَ نصاب':Predicate, #1: 1	نَقَصَ نُسُكُهُ
u'نَقَصَ نِصَابٌ':Predicate, #1: 1	نَقَصَ النِّصَابَ
u'نَقَصَ نصاب':Subject, #1: 1	نَقَصَ النِّصَابَ
u'نَقَصَ نِصَابٌ':Subject, #2: 2	نَقَصَ نِصَابُهُ
u'نَقَصَ نصاب':Subject, #2: 2	نَقَصَ نِصَابُهُ
u'نَقَصَ نِصَابٌ':Subject, #3: 3	نَقَصَ نِصَابُ
u'نَقَصَ نصاب':Subject, #3: 3	نَقَصَ نِصَابُ
u'نَقَصَ نِصَابٌ':Subject, #9: 9	نَقَصَ النِّصَابُ
u'نَقْصٌ نصاب':Added, #9: 9	نَقَصَ النِّصَابُ
u'نَقْصٌ نصاب':Added, #1: 1	نَقْصَ النِّصَابِ
u'نَقْصٌ نصاب':Added, #1: 1	نَقْصُ النِّصَابِ
u'نَقْصٌ نِصَابٌ':Added, #1: 1	نَقْصِ النِّصَابِ
u'نَقْصٌ نِصَابٌ':Added, #1: 1	نَقْصَ النِّصَابِ
u'نَقْصٌ نِصَابٌ':Added, #1: 1	نَقْصُ النِّصَابِ
u'نَقْصٌ نصاب':Added, #1: 1	نَقْصِ النِّصَابِ
u'نَقْصٌ نِصَابٌ':Added, #1: 1	نَقْصَ نِصَابِهِ
u'نَقَصَ نِصْفٌ':Subject, #1: 1	نَقْصَ نِصَابِهِ
u'نَقَصَ نَصِيبٌ':Predicate, #1: 1	نَقَصَ نِصْفُ
u'نَقَصَ نَصِيبٌ':Subject, #1: 1	نَقَصَ نَصِيبَ
u'نَقَصَ نَفْعٌ':Subject, #1: 1	نَقَصَ نَصِيبُ
u'نَقْصٌ نكاح':Added, #2: 2	نَقَصَ نَفْعُهُ
u'نَقْصٌ نِكَاحٌ':Added, #2: 2	نَقْصُ النِّكَاحِ
u'نَقْصٌ نَوْعٌ':Added, #2: 2	نَقْصُ النِّكَاحِ
u'نَقَصَ وَاجِبٌ':Subject, #1: 1	نَقْصُ النَّوْعِ
u'نَقْصٌ وَاجِبٌ':Added, #1: 1	نَقَصَ الْوَاجِبُ
u'نَقَصَ وَزْنٌ':Subject, #1: 1	نَقْصَ الْوَاجِبِ
u'نَقْصٌ وَزْنٌ':Added, #1: 1	نَقَصَ الْوَزْنُ
u'نَقَصَ وَصْفٌ':Subject, #1: 1	نَقْصُ الْوَزْنِ
u'نَقَصَ وَصْفٌ':Subject, #1: 1	نَقَصَ وَصْفٌ
u'نَقْصٌ وَقْفٌ':Added, #1: 1	نَقَصَ وَصْفُهُ
u'نَقَصَ وَكِيلٌ':Subject, #1: 1	نَقْصُ وَقْفٍ
u'نَقْصٌ وِلاَدَةٌ':Added, #3: 3	نَقَصَ وَكِيلُهُ
u'نَقْصٌ وِلاَدَةٌ':Added, #1: 1	نَقْصَ الْوِلَادَةِ
u'نَقْصٌ وِلاَدَةٌ':Added, #1: 1	نَقْصُ وِلَادَةٍ
u'نَقْصٌ وِلاَدَةٌ':Added, #3: 3	نَقْصُ الْوِلَادَةِ
u'نَقَصَ ولد':Subject, #6: 6	نَقْصِ الْوِلَادَةِ
u'نَقَصَ وَلَدٌ':Subject, #1: 1	نَقَصَ الْوَلَدُ
u'نَقْصٌ ولد':Added, #1: 1	نَقَصَ الْوَلَدُ
u'نَقْصٌ وَلَدٌ':Added, #1: 1	نَقْصَ الْوَلَدِ
u'نَقَصَ وَلِيٌّ':Subject, #1: 1	نَقْصَ الْوَلَدِ
u'نَقَصَ يَسِيرٌ':Predicate, #1: 1	نَقَصَ الْوَلِيُّ
u'نَقَصَ يَوْمٌ':Predicate, #1: 1	نَقَصَ الْيَسِيرَ
u'نَقْصٌ يَوْمٌ':Added, #2: 2	نَقَصَ يَوْمَ
u'نَقَضَ إجَارَةٌ':Predicate, #1: 1	نَقْصُ يَوْمٍ
u'نَقْضٌ إجَارَةٌ':Added, #3: 3	نَقَضَ الْإِجَارَةَ
u'نَقْضٌ إجَارَةٌ':Added, #1: 1	نَقْضِ الْإِجَارَةِ
u'نَقْضٌ إجَارَةٌ':Added, #2: 2	نَقْضَ الْإِجَارَةِ
u'نَقَضَ أحَدٌ':Subject, #2: 2	نَقْضُ الْإِجَارَةِ
u'نَقْضٌ أَحْكَامٌ':Added, #1: 1	نَقَضَ أَحَدُ
u'نَقْضٌ أَحْكَامٌ':Added, #1: 1	نَقْضِ أَحْكَامِ
u'نَقْضٌ أَحْكَامٌ':Added, #1: 1	نَقْضَ أَحْكَامِهِ
u'نَقْضٌ أَحْكَامٌ':Added, #1: 1	نَقْضِ الْأَحْكَامِ
u'نَقَضَ أَصْلِيٌّ':Subject, #2: 2	نَقْضِ أَحْكَامٍ
u'نَقْضٌ أُصولٌ':Added, #1: 1	نَقَضَ الْأَصْلِيُّ
u'نَقَضَ إقالَةٌ':Predicate, #1: 1	نَقْضُ الْأُصُولِ
u'نَقْضٌ إِقْراضٌ':Added, #2: 2	نَقَضَ الْإِقَالَةَ
u'نَقْضٌ أَقْضِيَةٌ':Added, #1: 1	نَقْضَ الْإِقْرَاضِ
u'نَقَضَ إِلْزَامٌ':Predicate, #1: 1	نَقْضِ أَقْضِيَتِهِ
u'نَقَضَ إمَامٌ':Subject, #1: 1	نَقَضَ الْإِلْزَامَ
u'نَقْضٌ إمَامٌ':Added, #1: 1	نَقَضَ الْإِمَامُ
u'نَقْضٌ إمَامٌ':Added, #1: 1	نَقْضَ الْإِمَامِ
u'نَقْضٌ أمَانٌ':Added, #1: 1	نَقْضِ الْإِمَامِ
u'نَقْضٌ أمَانٌ':Added, #1: 1	نَقْضَ الْأَمَانِ
u'نَقْضٌ أمَانَةٌ':Added, #2: 2	نَقْضِ أَمَانِهِ
u'نَقَضَ أهْلٌ':Subject, #1: 1	نَقْضَ الْأَمَانَةِ
u'نَقْضٌ أهْلٌ':Added, #3: 3	نَقَضَ أَهْلُ
u'نَقْضٌ أهْلٌ':Added, #1: 1	نَقْضُ أَهْلِ
u'نَقْضٌ بَابٌ':Added, #1: 1	نَقْضِ أَهْلِ
u'نَقَضَ بَائِعٌ':Subject, #1: 1	نَقْضِ الْبَابِ
u'نَقَضَ بَعْضٌ':Predicate, #6: 6	نَقَضَ الْبَائِعُ
u'نَقَضَ بَعْضٌ':Subject, #1: 1	نَقَضَ الْبَعْضَ
u'نَقْضٌ بَعْضٌ':Added, #1: 1	نَقَضَ بَعْضُ
u'نَقْضٌ بَعْضٌ':Added, #2: 2	نَقْضِ الْبَعْضِ
u'نَقَضَ بِنَاءٌ':Predicate, #2: 2	نَقْضُ بَعْضِ
u'نَقْضٌ بِنَاءٌ':Added, #1: 1	نَقَضَ الْبِنَاءَ
u'نَقْضٌ بِنَاءٌ':Added, #1: 1	نَقْضُ بِنَاءِ
u'نَقْضٌ بِنَاءٌ':Added, #2: 2	نَقْضِ الْبِنَاءِ
u'نَقْضٌ بِنَاءٌ':Added, #3: 3	نَقْضِ بِنَاءِ
u'نَقْضٌ بِنْيَةٌ':Added, #5: 5	نَقْضُ الْبِنَاءِ
u'نَقَضَ بَيْعٌ':Predicate, #1: 1	نَقْضِ الْبِنْيَةِ
u'نَقْضٌ بَيْعٌ':Added, #44: 44	نَقَضَ الْبَيْعَ
u'نَقْضٌ بَيْعٌ':Added, #11: 11	نَقْضَ الْبَيْعِ
u'نَقْضٌ بَيْعٌ':Added, #11: 11	نَقْضُ الْبَيْعِ
u'نَقْضٌ بَيْعٌ':Added, #14: 14	نَقْضِ الْبَيْعِ
u'نَقْضٌ بَيْعٌ':Added, #1: 1	نَقْضَ بَيْعٍ
u'نَقْضٌ بَيْعٌ':Added, #1: 1	نَقْضُ بَيْعِ
u'نَقْضٌ بَيْعٌ':Added, #1: 1	نَقْضُ بَيْعِهِ
u'نَقْضٌ بَيِّنَةٌ':Added, #3: 3	نَقْضُ بَيْعٍ
u'نَقَضَ تَائِبٌ':Subject, #1: 1	نَقْضَ الْبَيِّنَةِ
u'نَقَضَ تَسْلِيمٌ':Predicate, #1: 1	نَقَضَ التَّائِبُ
u'نَقْضٌ تَصَرُّفٌ':Added, #1: 1	نَقَضَ تَسْلِيمَ
u'نَقْضٌ تَصَرُّفٌ':Added, #1: 1	نَقْضِ التَّصَرُّفِ
u'نَقْضٌ تَصَرُّفٌ':Added, #1: 1	نَقْضَ تَصَرُّفِ
u'نَقْضٌ تَصَرُّفٌ':Added, #1: 1	نَقْضَ تَصَرُّفِهِ
u'نَقْضٌ تَصَرُّفٌ':Added, #1: 1	نَقْضُ تَصَرُّفِهِ
u'نَقْضٌ تَصَرُّفٌ':Added, #2: 2	نَقْضِ تَصَرُّفِ
u'نَقْضٌ تَعْدِيلٌ':Added, #3: 3	نَقْضِ تَصَرُّفِهِ
u'نَقْضٌ تَعْرِيفٌ':Added, #1: 1	نَقْضُ تَعْدِيلٍ
u'نَقْضٌ ثَانِي':Added, #1: 1	نَقْضُ التَّعْرِيفِ
u'نَقْضٌ ثَانِيَةٌ':Added, #1: 1	نَقْضُ الثَّانِيَةِ
u'نَقَضَ ثَمَنٌ':Predicate, #1: 1	نَقْضُ الثَّانِيَةِ
u'نَقَضَ جِدار':Predicate, #1: 1	نَقَضَ الثَّمَنَ
u'نَقْضٌ جِدار':Added, #1: 1	نَقَضَ الْجِدَارَ
u'نَقْضٌ جناح':Added, #1: 1	نَقْضَ جِدَارٍ
u'نَقْضٌ جَنَاحٌ':Added, #1: 1	نَقْضِ الْجَنَاحِ
u'نَقَضَ حافِظٌ':Subject, #1: 1	نَقْضِ الْجَنَاحِ
u'نَقَضَ حاكِمٌ':Subject, #1: 1	نَقَضَ الْحَافِظُ
u'نَقْضٌ حائِضٌ':Added, #3: 3	نَقَضَ الْحَاكِمُ
u'نَقْضٌ حائِطٌ':Added, #1: 1	نَقْضَ الْحَائِضِ
u'نَقْضٌ حائِطٌ':Added, #1: 1	نَقْضُ الْحَائِطِ
u'نَقْضٌ حائِطٌ':Added, #2: 2	نَقْضَ الْحَائِطِ
u'نَقْضٌ حَبْسٌ':Added, #4: 4	نَقْضِ الْحَائِطِ
u'نَقَضَ حَدَثٌ':Predicate, #1: 1	نَقْضِ الْحَبْسِ
u'نَقْضٌ حَصْرٌ':Added, #1: 1	نَقَضَ الْحَدَثَ
u'نَقَضَ حُكْمٌ':Predicate, #1: 1	نَقْضُ حَصْرِ
u'نَقْضٌ حُكْمٌ':Added, #2: 2	نَقَضَ الْحُكْمَ
u'نَقْضٌ حُكْمٌ':Added, #12: 12	نَقْضِ الْحُكْمِ
u'نَقْضٌ حُكْمٌ':Added, #1: 1	نَقْضُ حُكْمٍ
u'نَقْضٌ حُكْمٌ':Added, #2: 2	نَقْضَ الْحُكْمِ
u'نَقْضٌ حُكْمٌ':Added, #2: 2	نَقْضِ حُكْمِهِ
u'نَقْضٌ حُكْمٌ':Added, #3: 3	نَقْضُ حُكْمِ
u'نَقْضٌ حُكْمٌ':Added, #9: 9	نَقْضُ الْحُكْمِ
u'نَقْضٌ حُكْمٌ':Added, #9: 9	نَقْضِ حُكْمِ
u'نَقْضٌ حكمة':Added, #9: 9	نَقْضُ حُكْمِهِ
u'نَقْضٌ حكمة':Added, #1: 1	نَقْضَ الْحِكْمَةِ
u'نَقْضٌ حِكْمَةٌ':Added, #1: 1	نَقْضُ الْحِكْمَةِ
u'نَقْضٌ حِكْمَةٌ':Added, #1: 1	نَقْضَ الْحِكْمَةِ
u'نَقْضٌ خَفِيفٌ':Added, #1: 1	نَقْضُ الْحِكْمَةِ
u'نَقَضَ خَيَّاطٌ':Subject, #1: 1	نَقْضِ الْخَفِيفِ
u'نَقَضَ دَارٌ':Predicate, #1: 1	نَقَضَ الْخَيَّاطُ
u'نَقْضٌ دَارٌ':Added, #1: 1	نَقَضَ الدَّارَ
u'نَقْضٌ دَرَاهِمُ':Added, #1: 1	نَقْضِ الدَّارِ
u'نَقْضٌ دَليلٌ':Added, #1: 1	نَقْضِ الدَّرَاهِمِ
u'نَقْضٌ دَليلٌ':Added, #1: 1	نَقْضُ الدَّلِيلِ
u'نَقَضَ دَنانيرُ':Predicate, #1: 1	نَقْضَ دَلِيلِ
u'نَقَضَ ذِمِّيٌّ':Subject, #1: 1	نَقَضَ الدَّنَانِيرَ
u'نَقَضَ ذِمِّيٌّ':Subject, #2: 2	نَقَضَ ذِمِّيٌّ
u'نَقْضٌ رَأْسٌ':Added, #5: 5	نَقَضَ الذِّمِّيُّ
u'نَقْضٌ رَأْيٌ':Added, #1: 1	نَقْضِ الرَّأْسِ
u'نَقَضَ رَجُلٌ':Subject, #1: 1	نَقْضَ رَأْيِهِ
u'نَقَضَ رَدٌّ':Predicate, #1: 1	نَقَضَ رَجُلٌ
u'نَقَضَ رُكوعٌ':Predicate, #1: 1	نَقَضَ الرَّدَّ
u'نَقْضٌ رُكوعٌ':Added, #1: 1	نَقَضَ الرُّكُوعَ
u'نَقْضٌ رَهْنٌ':Added, #1: 1	نَقْضَ الرُّكُوعِ
u'نَقْضٌ رَهْنٌ':Added, #1: 1	نَقْضَ الرَّهْنِ
u'نَقَضَ رُومٌ':Subject, #3: 3	نَقْضُ الرَّهْنِ
u'نَقَضَ سُلْطَانٌ':Subject, #1: 1	نَقَضَ الرُّومُ
u'نَقَضَ سَلَمٌ':Predicate, #1: 1	نَقَضَ السُّلْطَانُ
u'نَقَضَ سُوق':Subject, #2: 2	نَقَضَ السَّلَمَ
u'نَقَضَ سُوقَة':Subject, #1: 1	نَقَضَ السُّوقَةُ
u'نَقْضٌ شركة':Added, #1: 1	نَقَضَ السُّوقَةُ
u'نَقْضٌ شَرِكَةٌ':Added, #1: 1	نَقْضَ الشَّرِكَةِ
u'نَقْضٌ شَعْرٌ':Added, #1: 1	نَقْضَ الشَّرِكَةِ
u'نَقْضٌ شَعْرٌ':Added, #1: 1	نَقْضُ الشَّعْرِ
u'نَقْضٌ شفعة':Added, #2: 2	نَقْضُ شَعْرِ
u'نَقْضٌ شُفْعَةٌ':Added, #1: 1	نَقْضِ شُفْعَتِهِ
u'نَقْضٌ شَيْءٌ':Added, #1: 1	نَقْضِ شُفْعَتِهِ
u'نَقْضٌ شَيْءٌ':Added, #1: 1	نَقْضَ الشَّيْءِ
u'نَقَضَ صَاحِبٌ':Subject, #1: 1	نَقْضَ شَيْءٍ
u'نَقْضٌ صَاحِبٌ':Added, #1: 1	نَقَضَ صَاحِبُ
u'نَقْضٌ صَحِيفَةٌ':Added, #1: 1	نَقْضِ صَاحِبِهِ
u'نَقْضٌ صَحِيفَةٌ':Added, #1: 1	نَقْضَ الصّحِيفَةِ
u'نَقْضٌ صَرْفٌ':Added, #4: 4	نَقْضِ الصّحِيفَةِ
u'نَقْضٌ صَرْف':Added, #3: 3	نَقْضِ الصَّرْفِ
u'نَقْضٌ صَلاَةٌ':Added, #3: 3	نَقْضِ الصَّرْفِ
u'نَقَضَ صلح':Predicate, #1: 1	نَقْضُ الصَّلَاةِ
u'نَقَضَ صُلْحٌ':Predicate, #1: 1	نَقَضَ الصُّلْحَ
u'نَقْضٌ صلح':Added, #1: 1	نَقَضَ الصُّلْحَ
u'نَقْضٌ صُلْحٌ':Added, #2: 2	نَقْضِ الصُّلْحِ
u'نَقْضٌ صلح':Added, #2: 2	نَقْضِ الصُّلْحِ
u'نَقْضٌ صُلْحٌ':Added, #4: 4	نَقْضَ الصُّلْحِ
u'نَقْضٌ ضفائر':Added, #4: 4	نَقْضَ الصُّلْحِ
u'نَقْضٌ ضَفَائِرُ':Added, #1: 1	نَقْضُ الضَّفَائِرِ
u'نَقْضٌ ضَفْرٌ':Added, #1: 1	نَقْضُ الضَّفَائِرِ
u'نَقْضٌ ضَفْرٌ':Added, #1: 1	نَقْضُ الضَّفْرِ
u'نَقْضٌ طَرْدٌ':Added, #1: 1	نَقْضُ ضَفْرِهِ
u'نَقَضَ طَهَارَةٌ':Predicate, #1: 1	نَقْضَ الطَّرْدِ
u'نَقْضٌ طَهَارَةٌ':Added, #1: 1	نَقَضَ الطَّهَارَةَ
u'نَقْضٌ طَهَارَةٌ':Added, #1: 1	نَقْضَ طَهَارَتِهِ
u'نَقْضٌ طَهَارَةٌ':Added, #2: 2	نَقْضُ الطَّهَارَةِ
u'نَقْضٌ طَهَارَةٌ':Added, #2: 2	نَقْضِ طَهَارَتِهِ
u'نَقْضٌ طهر':Added, #4: 4	نَقْضِ الطَّهَارَةِ
u'نَقْضٌ طُهْرٌ':Added, #2: 2	نَقْضِ طُهْرِهِ
u'نَقَضَ طواف':Predicate, #2: 2	نَقْضِ طُهْرِهِ
u'نَقَضَ طَوَافٌ':Predicate, #1: 1	نَقَضَ الطَّوَافَ
u'نَقَضَ ظُهْرٌ':Predicate, #1: 1	نَقَضَ الطَّوَافَ
u'نَقْضٌ عَادَةٌ':Added, #1: 1	نَقَضَ الظُّهْرَ
u'نَقْضٌ عَادَةٌ':Added, #1: 1	نَقْضُ الْعَادَةِ
u'نَقْضٌ عَادَةٌ':Added, #2: 2	نَقْضَ الْعَادَةِ
u'نَقْضٌ عِبَادَةٌ':Added, #3: 3	نَقْضِ الْعَادَةِ
u'نَقْضٌ عتق':Added, #2: 2	نَقْضَ الْعِبَادَةِ
u'نَقْضٌ عِتْقٌ':Added, #1: 1	نَقْضِ عِتْقِهِ
u'نَقْضٌ عتق':Added, #1: 1	نَقْضِ عِتْقِهِ
u'نَقْضٌ عِتْقٌ':Added, #3: 3	نَقْضُ الْعِتْقِ
u'نَقْضٌ عَرْصَةٌ':Added, #3: 3	نَقْضُ الْعِتْقِ
u'نَقْضٌ عَزَائِمُ':Added, #2: 2	نَقْضِ الْعَرْصَةِ
u'نَقَضَ عَقْدٌ':Predicate, #1: 1	نَقْضِ عَزَائِمِهِ
u'نَقْضٌ عَقْدٌ':Added, #1: 1	نَقَضَ الْعَقْدَ
u'نَقْضٌ عَقْدٌ':Added, #1: 1	نَقْضِ الْعَقْدِ
u'نَقْضٌ عَقْدٌ':Added, #1: 1	نَقْضَ عَقْدِ
u'نَقْضٌ عَقْدٌ':Added, #1: 1	نَقْضِ عَقْدِ
u'نَقْضٌ عَقْدٌ':Added, #1: 1	نَقْضِ عَقْدِهِ
u'نَقْضٌ عِلَّةٌ':Added, #3: 3	نَقْضِ عَقْدٍ
u'نَقْضٌ عِلَّةٌ':Added, #2: 2	نَقْضَ الْعِلَّةِ
u'نَقْضٌ عِلَّةٌ':Added, #2: 2	نَقْضِ الْعِلَّةِ
u'نَقْضٌ عَمَلٌ':Added, #3: 3	نَقْضُ الْعِلَّةِ
u'نَقَضَ عَهْدٌ':Predicate, #1: 1	نَقْضُ الْعَمَلِ
u'نَقَضَ عَهْدٌ':Predicate, #18: 18	نَقَضَ الْعَهْدَ
u'نَقْضٌ عَهْدٌ':Added, #1: 1	نَقَضَ عَهْدَ
u'نَقْضٌ عَهْدٌ':Added, #1: 1	نَقْضَ عَهْدٍ
u'نَقْضٌ عَهْدٌ':Added, #1: 1	نَقْضُ عَهْدٍ
u'نَقْضٌ عَهْدٌ':Added, #1: 1	نَقْضِ عَهْدٍ
u'نَقْضٌ عَهْدٌ':Added, #1: 1	نَقْضِ عَهْدِ
u'نَقْضٌ عَهْدٌ':Added, #1: 1	نَقْضِ عَهْدِهِ
u'نَقْضٌ عَهْدٌ':Added, #2: 2	نَقْضُ عَهْدِهِ
u'نَقْضٌ عَهْدٌ':Added, #3: 3	نَقْضَ الْعَهْدِ
u'نَقْضٌ عَهْدٌ':Added, #5: 5	نَقْضُ الْعَهْدِ
u'نَقَضَ غُسْلٌ':Predicate, #8: 8	نَقْضِ الْعَهْدِ
u'نَقْضٌ فَرْضٌ':Added, #2: 2	نَقَضَ الْغُسْلَ
u'نَقَضَ فَسْخٌ':Predicate, #2: 2	نَقْضُ الْفَرْضِ
u'نَقَضَ فلان':Predicate, #1: 1	نَقَضَ الْفَسْخَ
u'نَقَضَ فلان':Subject, #1: 1	نَقَضَ الْمَسْجِدِيَّةَ
u'نَقَضَ فلان':Subject, #1: 1	نَقَضَ الزّبَيْرُ
u'نَقَضَ قَالٌ':Predicate, #1: 1	نَقَضَ السُّوقَةُ
u'نَقَضَ قَبَاءٌ':Predicate, #1: 1	نَقَضَ قَالَ
u'نَقْضٌ قَبْضٌ':Added, #1: 1	نَقَضَ الْقَبَاءَ
u'نَقْضٌ قَبْضٌ':Added, #1: 1	نَقْضُ قَبْضِهِ
u'نَقْضٌ قَبْضٌ':Added, #2: 2	نَقْضُ الْقَبْضِ
u'نَقْضٌ قَسْمٌ':Added, #3: 3	نَقْضِ الْقَبْضِ
u'نَقَضَ قسمة':Predicate, #1: 1	نَقْضُ الْقَسْمِ
u'نَقَضَ قِسْمَةٌ':Predicate, #7: 7	نَقَضَ الْقِسْمَةَ
u'نَقْضٌ قسمة':Added, #7: 7	نَقَضَ الْقِسْمَةَ
u'نَقْضٌ قِسْمَةٌ':Added, #1: 1	نَقْضَ الْقِسْمَةِ
u'نَقْضٌ قسمة':Added, #1: 1	نَقْضَ الْقِسْمَةِ
u'نَقْضٌ قِسْمَةٌ':Added, #1: 1	نَقْضَ قِسْمَةِ
u'نَقْضٌ قسمة':Added, #1: 1	نَقْضَ قِسْمَةِ
u'نَقْضٌ قِسْمَةٌ':Added, #1: 1	نَقْضُ قِسْمَتِهِ
u'نَقْضٌ قسمة':Added, #1: 1	نَقْضُ قِسْمَتِهِ
u'نَقْضٌ قِسْمَةٌ':Added, #2: 2	نَقْضُ الْقِسْمَةِ
u'نَقْضٌ قسمة':Added, #2: 2	نَقْضُ الْقِسْمَةِ
u'نَقْضٌ قِسْمَةٌ':Added, #7: 7	نَقْضِ الْقِسْمَةِ
u'نَقَضَ قَضَاءٌ':Predicate, #7: 7	نَقْضِ الْقِسْمَةِ
u'نَقْضٌ قَضَاءٌ':Added, #1: 1	نَقَضَ قَضَاءَ
u'نَقْضٌ قَضَاءٌ':Added, #1: 1	نَقْضَ الْقَضَاءِ
u'نَقْضٌ قَضَاءٌ':Added, #2: 2	نَقْضِ الْقَضَاءِ
u'نَقَضَ قَلِيلٌ':Subject, #4: 4	نَقْضُ الْقَضَاءِ
u'نَقَضَ قَوْمٌ':Subject, #1: 1	نَقَضَ قَلِيلُهُ
u'نَقَضَ كِتَابَةٌ':Predicate, #8: 8	نَقَضَ قَوْمٌ
u'نَقْضٌ كِرَاءٌ':Added, #2: 2	نَقَضَ الْكِتَابَةَ
u'نَقْضٌ كَعْبٌ':Added, #1: 1	نَقْضُ الْكِرَاءِ
u'نَقْضٌ كعبة':Added, #1: 1	نَقْضِ كَعْبٍ
u'نَقْضٌ كَعْبَةٌ':Added, #1: 1	نَقْضِ الْكَعْبَةِ
u'نَقْضٌ كَفَنٌ':Added, #1: 1	نَقْضِ الْكَعْبَةِ
u'نَقْضٌ لَمْسٌ':Added, #1: 1	نَقْضُ الْكَفَنِ
u'نَقَضَ مُجَرَّدٌ':Subject, #1: 1	نَقْضِ اللَّمْسِ
u'نَقْضٌ مِحْبَرَةٌ':Added, #1: 1	نَقَضَ مُجَرَّدُ
u'نَقَضَ مَسْجِد':Predicate, #1: 1	نَقْضُ الْمِحْبَرَةِ
u'نَقْضٌ مَسْجِدٌ':Added, #1: 1	نَقَضَ الْمَسْجِدِيَّةَ
u'نَقْضٌ مَسْجِدٌ':Added, #1: 1	نَقْضَ الْمَسْجِدِ
u'نَقْضٌ مَسْجِدٌ':Added, #1: 1	نَقْضُ الْمَسْجِدِ
u'نَقَضَ مُضَارَبَةٌ':Predicate, #1: 1	نَقْضِ الْمَسْجِدِ
u'نَقْضٌ مُضَارَبَةٌ':Added, #1: 1	نَقَضَ الْمُضَارَبَةَ
u'نَقْضٌ مُعَارَضَةٌ':Added, #1: 1	نَقْضِ الْمُضَارَبَةِ
u'نَقْضٌ مُعَامَلَةٌ':Added, #1: 1	نَقْضُ مُعَارَضَةٍ
u'نَقَضَ مُعْتَرِضٌ':Subject, #1: 1	نَقْضَ الْمُعَامَلَةِ
u'نَقْضٌ مُفْرَدٌ':Added, #1: 1	نَقَضَ الْمُعْتَرِضُ
u'نَقْضٌ مِلْكٌ':Added, #1: 1	نَقْضِ مُفْرَدَاتِ
u'نَقْضٌ مِلْكٌ':Added, #1: 1	نَقْضُ الْمِلْكِ
u'نَقْضٌ مِلْكٌ':Added, #1: 1	نَقْضِ الْمِلْكِ
u'نَقْضٌ مَلْمُوسٌ':Added, #1: 1	نَقْضِ مِلْكِ
u'نَقْضٌ مَنَارٌ':Added, #1: 1	نَقْضِ الْمَلْمُوسِ
u'نَقْضٌ مَوْضُوعٌ':Added, #1: 1	نَقْضُ مَنَارَتِهِ
u'نَقَضَ مُوَكِّلٌ':Subject, #2: 2	نَقْضُ الْمَوْضُوعِ
u'نَقْضٌ مِيثَاقٌ':Added, #1: 1	نَقَضَ الْمُوَكِّلُ
u'نَقَضَ نَقَّاشٌ':Subject, #1: 1	نَقْضَ الْمِيثَاقِ
u'نَقْضٌ نَقْضٌ':Added, #1: 1	نَقَضَ النّقّاشُ
u'نَقَضَ نكاح':Predicate, #1: 1	نَقْضِ النَّقْضِ
u'نَقَضَ نِكَاحٌ':Predicate, #1: 1	نَقَضَ النِّكَاحَ
u'نَقَضَ نكاح':Subject, #1: 1	نَقَضَ النِّكَاحَ
u'نَقَضَ نِكَاحٌ':Subject, #1: 1	نَقَضَ النِّكَاحُ
u'نَقْضٌ نكاح':Added, #1: 1	نَقَضَ النِّكَاحُ
u'نَقْضٌ نِكَاحٌ':Added, #1: 1	نَقْضِ النِّكَاحِ
u'نَقْضٌ نكاح':Added, #1: 1	نَقْضِ النِّكَاحِ
u'نَقْضٌ نِكَاحٌ':Added, #1: 1	نَقْضَ نِكَاحِ
u'نَقْضٌ نَوْمٌ':Added, #1: 1	نَقْضَ نِكَاحِ
u'نَقَضَ هِبَةٌ':Predicate, #1: 1	نَقْضِ النَّوْمِ
u'نَقْضٌ هِبَةٌ':Added, #2: 2	نَقَضَ الْهِبَةَ
u'نَقَضَ هُدْنَةٌ':Predicate, #1: 1	نَقْضَ الْهِبَةِ
u'نَقْضٌ وَاجِبٌ':Added, #1: 1	نَقَضَ الْهُدْنَةَ
u'نَقْضٌ وَاجِبٌ':Added, #1: 1	نَقْضَ الْوَاجِبِ
u'نَقْضٌ وَاجِبٌ':Added, #1: 1	نَقْضِ الْوَاجِبِ
u'نَقَضَ وُجُودٌ':Subject, #3: 3	نَقْضُ الْوَاجِبِ
u'نَقْضٌ وَصْفٌ':Added, #2: 2	نَقَضَ وُجُودُهُ
u'نَقْضٌ وَصِيٌّ':Added, #1: 1	نَقْضِ الْوَصْفِ
u'نَقْضٌ وَصِيَّةٌ':Added, #1: 1	نَقْضُ الْوَصِيَّةِ
u'نَقَضَ وُضُوءٌ':Predicate, #1: 1	نَقْضُ الْوَصِيَّةِ
u'نَقَضَ وُضُوءٌ':Predicate, #16: 16	نَقَضَ الْوُضُوءَ
u'نَقْضٌ وُضُوءٌ':Added, #1: 1	نَقَضَ وُضُوءَ
u'نَقْضٌ وُضُوءٌ':Added, #1: 1	نَقْضَ الْوُضُوءِ
u'نَقْضٌ وُضُوءٌ':Added, #25: 25	نَقْضِ الْوُضُوءِ
u'نَقْضٌ وُضُوءٌ':Added, #2: 2	نَقْضُ وُضُوءِ
u'نَقْضٌ وُضُوءٌ':Added, #2: 2	نَقْضِ وُضُوءِ
u'نَقْضٌ وَقْفٌ':Added, #5: 5	نَقْضُ الْوُضُوءِ
u'نَقْضٌ وَقْفٌ':Added, #1: 1	نَقْضَ الْوَقْفِ
u'نَقْضٌ وَقْفٌ':Added, #1: 1	نَقْضِ الْوَقْفِ
u'نَقْضٌ وَقْفٌ':Added, #1: 1	نَقْضُ وَقْفٍ
u'نَقَضَ وَكِيلٌ':Predicate, #3: 3	نَقْضُ الْوَقْفِ
u'نَقَضَ وَكِيلٌ':Subject, #1: 1	نَقَضَ الْوَكِيلَ
u'نَقَضَ وَلاَءٌ':Predicate, #1: 1	نَقَضَ الْوَكِيلُ
u'نَقْضٌ يَدٌ':Added, #1: 1	نَقَضَ الْوَلَاءَ
u'نَقْضٌ يَمِينٌ':Added, #1: 1	نَقْضِ يَدِ
u'نَقْضٌ يَمِينٌ':Added, #1: 1	نَقْضُ الْيَمِينِ
u'نَقَطَ مُصْحَفٌ':Predicate, #2: 2	نَقْضِ الْيَمِينِ
u'نَقْعٌ بِئْرٌ':Added, #1: 1	نَقَطَ الْمُصْحَفَ
u'نَقْعٌ بِئْرٌ':Added, #1: 1	نَقْعَ الْبِئْرِ
u'نَقْعٌ بِئْرٌ':Added, #2: 2	نَقْعِ الْبِئْرِ
u'نَقْعٌ بِئْرٌ':Added, #2: 2	نَقْعُ بِئْرٍ
u'نَقْعٌ تَمْر':Added, #3: 3	نَقْعُ الْبِئْرِ
u'نَقْعٌ مَاءٌ':Added, #1: 1	نَقْعُ التَّمْرِ
u'نقل إبَاحَةٌ':Added, #1: 1	نَقْعِ مَاءٍ
u'نَقْلٌ إبَاحَةٌ':Added, #1: 1	نَقْلَ الْإِبَاحَةِ
u'نقل إِبِلٌ':Added, #1: 1	نَقْلَ الْإِبَاحَةِ
u'نَقْلٌ إِبِلٌ':Added, #1: 1	نَقْلِ الْإِبِلِ
u'نَقَلَ اِبْنٌ':Subject, #1: 1	نَقْلِ الْإِبِلِ
u'نَقَلَ اِبْنٌ':Subject, #1: 1	نَقَلَ ابْنَاهُ
u'نقل اِبْنٌ':Added, #259: 259	نَقَلَ ابْنُ
u'نَقْلٌ اِبْنٌ':Added, #10: 10	نَقْلَ ابْنِ
u'نقل اِبْنٌ':Added, #10: 10	نَقْلَ ابْنِ
u'نَقْلٌ اِبْنٌ':Added, #29: 29	نَقْلِ ابْنِ
u'نقل اِبْنٌ':Added, #29: 29	نَقْلِ ابْنِ
u'نَقْلٌ اِبْنٌ':Added, #56: 56	نَقْلُ ابْنِ
u'نَقَلَ اِتِّفَاقٌ':Predicate, #56: 56	نَقْلُ ابْنِ
u'نَقَلَ إِجْمَاعٌ':Predicate, #1: 1	نَقَلَ اتِّفَاقَ
u'نَقَلَ إِجْمَاعٌ':Predicate, #2: 2	نَقَلَ إجْمَاعَ
u'نَقَلَ إِجْمَاعٌ':Subject, #6: 6	نَقَلَ الْإِجْمَاعَ
u'نقل إِجْمَاعٌ':Added, #1: 1	نَقَلَ الْإِجْمَاعُ
u'نَقْلٌ إِجْمَاعٌ':Added, #14: 14	نَقْلِ الْإِجْمَاعِ
u'نقل إِجْمَاعٌ':Added, #14: 14	نَقْلِ الْإِجْمَاعِ
u'نَقْلٌ إِجْمَاعٌ':Added, #15: 15	نَقْلُ الْإِجْمَاعِ
u'نقل إِجْمَاعٌ':Added, #15: 15	نَقْلُ الْإِجْمَاعِ
u'نقل إِجْمَاعٌ':Added, #1: 1	نَقْلَ إجْمَاعِ
u'نقل إِجْمَاعٌ':Added, #1: 1	نَقْلِ إجْمَاعِ
u'نَقْلٌ إِجْمَاعٌ':Added, #1: 1	نَقْلُ إِجْمَاعٍ
u'نَقْلٌ إِجْمَاعٌ':Added, #1: 1	نَقْلَ إجْمَاعِ
u'نَقْلٌ إِجْمَاعٌ':Added, #1: 1	نَقْلِ إجْمَاعِ
u'نقل إِجْمَاعٌ':Added, #1: 1	نَقْلُ إِجْمَاعٍ
u'نَقْلٌ إِجْمَاعٌ':Added, #2: 2	نَقْلَ الْإِجْمَاعِ
u'نقل آحَادٌ':Added, #2: 2	نَقْلَ الْإِجْمَاعِ
u'نَقْلٌ آحَادٌ':Added, #1: 1	نَقْلُ آحَادٍ
u'نقل آحَادٌ':Added, #1: 1	نَقْلُ آحَادٍ
u'نَقْلٌ آحَادٌ':Added, #1: 1	نَقْلِ آحَادِهِ
u'نقل آحَادٌ':Added, #1: 1	نَقْلِ آحَادِهِ
u'نَقْلٌ آحَادٌ':Added, #1: 1	نَقْلَ الْآحَادِ
u'نقل آحَادٌ':Added, #1: 1	نَقْلَ الْآحَادِ
u'نَقْلٌ آحَادٌ':Added, #3: 3	نَقْلُ الْآحَادِ
u'نقل آحَادٌ':Added, #3: 3	نَقْلُ الْآحَادِ
u'نَقْلٌ آحَادٌ':Added, #4: 4	نَقْلِ الْآحَادِ
u'نقل أَحادِيثُ':Added, #4: 4	نَقْلِ الْآحَادِ
u'نَقْلٌ أَحادِيثُ':Added, #2: 2	نَقْلِ الْأَحَادِيثِ
u'نَقَلَ أَحْجارٌ':Predicate, #2: 2	نَقْلِ الْأَحَادِيثِ
u'نقل أَحْجارٌ':Added, #1: 1	نَقَلَ الْأَحْجَارَ
u'نَقْلٌ أَحْجارٌ':Added, #1: 1	نَقْلَ أَحْجَارٍ
u'نقل أخْبَارٌ':Added, #1: 1	نَقْلَ أَحْجَارٍ
u'نقل أَخْبَارٌ':Added, #1: 1	نَقْلِ الْأَخْبَارِ
u'نَقْلٌ أخْبَارٌ':Added, #1: 1	نَقْلِ الْأَخْبَارِ
u'نَقْلٌ أَخْبَارٌ':Added, #1: 1	نَقْلِ الْأَخْبَارِ
u'نَقَلَ اِخْتِيَارٌ':Predicate, #1: 1	نَقْلِ الْأَخْبَارِ
u'نقل أخْذٌ':Added, #1: 1	نَقَلَ اخْتِيَارَ
u'نَقْلٌ أخْذٌ':Added, #1: 1	نَقْلِ أَخْذِ
u'نَقَلَ آخِرُ':Predicate, #1: 1	نَقْلِ أَخْذِ
u'نقل إِذْنٌ':Added, #1: 1	نَقَلَ آخِرَ
u'نَقْلٌ إِذْنٌ':Added, #1: 1	نَقْلِ الْإِذْنِ
u'نقل أرْبَابٌ':Added, #1: 1	نَقْلِ الْإِذْنِ
u'نَقْلٌ أرْبَابٌ':Added, #1: 1	نَقْلِ أَرْبَابِ
u'نَقَلَ أَرْبَعَةٌ':Predicate, #1: 1	نَقْلِ أَرْبَابِ
u'نقل أسْبَابٌ':Added, #1: 1	نَقَلَ أَرْبَعَةَ
u'نقل أَسْبَابٌ':Added, #1: 1	نَقْلَ الْأَسْبَابِ
u'نَقْلٌ أسْبَابٌ':Added, #1: 1	نَقْلَ الْأَسْبَابِ
u'نَقْلٌ أَسْبَابٌ':Added, #1: 1	نَقْلَ الْأَسْبَابِ
u'نَقَلَ أُسْتَاذٌ':Subject, #1: 1	نَقْلَ الْأَسْبَابِ
u'نَقَلَ اِسْتِنْباطٌ':Predicate, #1: 1	نَقَلَ الْأُسْتَاذُ
u'نَقَلَ أَصْحَابٌ':Subject, #1: 1	نَقَلَ اسْتِنْبَاطَ
u'نقل أَصْحَابٌ':Added, #1: 1	نَقَلَ الْأَصْحَابُ
u'نَقْلٌ أَصْحَابٌ':Added, #3: 3	نَقْلُ الْأَصْحَابِ
u'نَقَلَ أصل':Subject, #3: 3	نَقْلُ الْأَصْحَابِ
u'نَقَلَ أًصْلٌ':Subject, #11: 11	نَقَلَ الْأَصْلُ
u'نقل أصل':Added, #11: 11	نَقَلَ الْأَصْلُ
u'نقل أصل':Added, #1: 1	نَقْلَ الْأَصْلِ
u'نقل أًصْلٌ':Added, #1: 1	نَقْلِ الْأَصْلِ
u'نقل أًصْلٌ':Added, #1: 1	نَقْلَ الْأَصْلِ
u'نَقْلٌ أصل':Added, #1: 1	نَقْلِ الْأَصْلِ
u'نَقْلٌ أصل':Added, #1: 1	نَقْلَ الْأَصْلِ
u'نَقْلٌ أًصْلٌ':Added, #1: 1	نَقْلِ الْأَصْلِ
u'نَقْلٌ أًصْلٌ':Added, #1: 1	نَقْلَ الْأَصْلِ
u'نَقَلَ إِطْلاقٌ':Predicate, #1: 1	نَقْلِ الْأَصْلِ
u'نقل اِعْتِبارٌ':Added, #1: 1	نَقَلَ إطْلَاقَ
u'نَقْلٌ اِعْتِبارٌ':Added, #1: 1	نَقْلِ اعْتِبَارِهِ
u'نقل أعْيانٌ':Added, #1: 1	نَقْلِ اعْتِبَارِهِ
u'نقل أعْيانٌ':Added, #1: 1	نَقْلَ الْأَعْيَانِ
u'نقل أَعْيَانٌ':Added, #1: 1	نَقْلِ الْأَعْيَانِ
u'نقل أَعْيَانٌ':Added, #1: 1	نَقْلَ الْأَعْيَانِ
u'نَقْلٌ أعْيانٌ':Added, #1: 1	نَقْلِ الْأَعْيَانِ
u'نَقْلٌ أعْيانٌ':Added, #1: 1	نَقْلَ الْأَعْيَانِ
u'نَقْلٌ أَعْيَانٌ':Added, #1: 1	نَقْلِ الْأَعْيَانِ
u'نَقْلٌ أَعْيَانٌ':Added, #1: 1	نَقْلَ الْأَعْيَانِ
u'نقل أَقْدَامٌ':Added, #1: 1	نَقْلِ الْأَعْيَانِ
u'نَقْلٌ أَقْدَامٌ':Added, #1: 1	نَقْلُ الْأَقْدَامِ
u'نقل إقْرَارٌ':Added, #1: 1	نَقْلُ الْأَقْدَامِ
u'نَقْلٌ إقْرَارٌ':Added, #1: 1	نَقْلِ إقْرَارِ
u'نَقَلَ أَكْثَرُ':Subject, #1: 1	نَقْلِ إقْرَارِ
u'نقل أَكْثَرُ':Added, #1: 1	نَقَلَ الْأَكْثَرُ
u'نَقْلٌ أَكْثَرُ':Added, #3: 3	نَقْلُ الْأَكْثَرِ
u'نقل آلةٌ':Added, #3: 3	نَقْلُ الْأَكْثَرِ
u'نَقْلٌ آلةٌ':Added, #1: 1	نَقْلِ الْآلَةِ
u'نقل أَلْفَاظٌ':Added, #1: 1	نَقْلِ الْآلَةِ
u'نَقْلٌ أَلْفَاظٌ':Added, #1: 1	نَقْلِ الْأَلْفَاظِ
u'نَقَلَ أُمٌّ':Predicate, #1: 1	نَقْلِ الْأَلْفَاظِ
u'نَقَلَ إمَامٌ':Subject, #2: 2	نَقَلَ أُمَّ
u'نَقَلَ إمَامٌ':Subject, #17: 17	نَقَلَ الْإِمَامُ
u'نقل إمَامٌ':Added, #5: 5	نَقَلَ إمَامُ
u'نَقْلٌ إمَامٌ':Added, #1: 1	نَقْلُ الْإِمَامِ
u'نقل إمَامٌ':Added, #1: 1	نَقْلُ الْإِمَامِ
u'نَقْلٌ إمَامٌ':Added, #1: 1	نَقْلُ إمَامِ
u'نقل إمَامٌ':Added, #1: 1	نَقْلُ إمَامِ
u'نَقْلٌ إمَامٌ':Added, #3: 3	نَقْلِ الْإِمَامِ
u'نقل إمَامٌ':Added, #3: 3	نَقْلِ الْإِمَامِ
u'نَقْلٌ إمَامٌ':Added, #3: 3	نَقْلِ إمَامِ
u'نَقَلَ أَمْتِعَةٌ':Predicate, #3: 3	نَقْلِ إمَامِ
u'نقل أَمْتِعَةٌ':Added, #2: 2	نَقَلَ الْأَمْتِعَةَ
u'نقل أَمْتِعَةٌ':Added, #1: 1	نَقْلَ الْأَمْتِعَةِ
u'نَقْلٌ أَمْتِعَةٌ':Added, #1: 1	نَقْلِ الْأَمْتِعَةِ
u'نَقْلٌ أَمْتِعَةٌ':Added, #1: 1	نَقْلَ الْأَمْتِعَةِ
u'نقل أَمْتِعَةٌ':Added, #1: 1	نَقْلِ الْأَمْتِعَةِ
u'نَقْلٌ أَمْتِعَةٌ':Added, #1: 1	نَقْلِ أَمْتِعَتِهِ
u'نقل أَمْرٌ':Added, #1: 1	نَقْلِ أَمْتِعَتِهِ
u'نَقْلٌ أَمْرٌ':Added, #1: 1	نَقْلِ الْأَمْرِ
u'نقل أَمْلاكٌ':Added, #1: 1	نَقْلِ الْأَمْرِ
u'نقل أَمْلاَكٌ':Added, #1: 1	نَقْلِ الْأَمْلَاكِ
u'نَقْلٌ أَمْلاكٌ':Added, #1: 1	نَقْلِ الْأَمْلَاكِ
u'نَقْلٌ أَمْلاَكٌ':Added, #1: 1	نَقْلِ الْأَمْلَاكِ
u'نقل أَنْوَاعٌ':Added, #1: 1	نَقْلِ الْأَمْلَاكِ
u'نَقْلٌ أَنْوَاعٌ':Added, #1: 1	نَقْلِ الْأَنْوَاعِ
u'نَقَلَ أهْلٌ':Predicate, #1: 1	نَقْلِ الْأَنْوَاعِ
u'نَقَلَ أهْلٌ':Predicate, #1: 1	نَقَلَ أَهْلَ
u'نَقَلَ أهْلٌ':Subject, #2: 2	نَقَلَ الْأَهْلَ
u'نقل أهْلٌ':Added, #1: 1	نَقَلَ أَهْلُ
u'نَقْلٌ أهْلٌ':Added, #1: 1	نَقْلُ الْأَهْلِ
u'نقل أهْلٌ':Added, #1: 1	نَقْلُ الْأَهْلِ
u'نقل أهْلٌ':Added, #1: 1	نَقْلَ أَهْلِ
u'نَقْلٌ أهْلٌ':Added, #1: 1	نَقْلِ أَهْلِ
u'نَقْلٌ أهْلٌ':Added, #1: 1	نَقْلَ أَهْلِ
u'نقل أهْلٌ':Added, #1: 1	نَقْلِ أَهْلِ
u'نَقْلٌ أهْلٌ':Added, #1: 1	نَقْلِ أَهْلِهِ
u'نقل أهْلٌ':Added, #1: 1	نَقْلِ أَهْلِهِ
u'نَقْلٌ أهْلٌ':Added, #2: 2	نَقْلَ الْأَهْلِ
u'نقل أهْلٌ':Added, #2: 2	نَقْلَ الْأَهْلِ
u'نَقْلٌ أهْلٌ':Added, #2: 2	نَقْلُ أَهْلِ
u'نقل أهْلٌ':Added, #2: 2	نَقْلُ أَهْلِ
u'نَقْلٌ أهْلٌ':Added, #2: 2	نَقْلُ أَهْلِهِ
u'نَقَلَ أَوْجُهٌ':Predicate, #2: 2	نَقْلُ أَهْلِهِ
u'نَقَلَ أَوَّلُ':Predicate, #2: 2	نَقَلَ الْأَوْجُهَ
u'نقل أَوَّلُ':Added, #2: 2	نَقَلَ الْأَوَّلَ
u'نَقْلٌ أَوَّلُ':Added, #1: 1	نَقْلَ الْأَوَّلِ
u'نَقَلَ أئِمَّةٌ':Subject, #1: 1	نَقْلَ الْأَوَّلِ
u'نقل أئِمَّةٌ':Added, #1: 1	نَقَلَ الْأَئِمَّةُ
u'نَقْلٌ أئِمَّةٌ':Added, #1: 1	نَقْلُ الْأَئِمَّةِ
u'نقل أئِمَّةٌ':Added, #1: 1	نَقْلُ الْأَئِمَّةِ
u'نَقْلٌ أئِمَّةٌ':Added, #2: 2	نَقْلِ الْأَئِمَّةِ
u'نقل آيَةٌ':Added, #2: 2	نَقْلِ الْأَئِمَّةِ
u'نَقْلٌ آيَةٌ':Added, #1: 1	نَقْلِ الْآيَةِ
u'نَقَلَ إيمَانٌ':Predicate, #1: 1	نَقْلِ الْآيَةِ
u'نقل بَابٌ':Added, #1: 1	نَقَلَ الْإِيمَانَ
u'نَقْلٌ بَابٌ':Added, #1: 1	نَقْلُ بَابِهِ
u'نَقَلَ بَحْثٌ':Predicate, #1: 1	نَقْلُ بَابِهِ
u'نقل بَحْثٌ':Added, #1: 1	نَقَلَ الْبَحْثَ
u'نَقْلٌ بَحْثٌ':Added, #1: 1	نَقْلِ بَحْثِ
u'نقل بَحْرٌ':Added, #1: 1	نَقْلِ بَحْثِ
u'نَقْلٌ بَحْرٌ':Added, #1: 1	نَقْلِ الْبَحْرِ
u'نَقَلَ بِشْرٌ':Subject, #1: 1	نَقْلِ الْبَحْرِ
u'نَقَلَ بَعْضٌ':Predicate, #1: 1	نَقَلَ بِشْرُ
u'نَقَلَ بَعْضٌ':Subject, #3: 3	نَقَلَ بَعْضَ
u'نقل بَعْضٌ':Added, #13: 13	نَقَلَ بَعْضُ
u'نَقْلٌ بَعْضٌ':Added, #1: 1	نَقْلِ الْبَعْضِ
u'نقل بَعْضٌ':Added, #1: 1	نَقْلِ الْبَعْضِ
u'نَقْلٌ بَعْضٌ':Added, #1: 1	نَقْلِ بَعْضِ
u'نقل بَعْضٌ':Added, #1: 1	نَقْلِ بَعْضِ
u'نَقْلٌ بَعْضٌ':Added, #1: 1	نَقْلُ بَعْضِهِ
u'نقل بَعْضٌ':Added, #1: 1	نَقْلُ بَعْضِهِ
u'نَقْلٌ بَعْضٌ':Added, #3: 3	نَقْلُ بَعْضِ
u'نقل بِنَاءٌ':Added, #3: 3	نَقْلُ بَعْضِ
u'نَقْلٌ بِنَاءٌ':Added, #1: 1	نَقْلِ بِنَاءِ
u'نقل بِنْتٌ':Added, #1: 1	نَقْلِ بِنَاءِ
u'نَقْلٌ بِنْتٌ':Added, #1: 1	نَقْلُ بِنْتِ
u'نَقَلَ بِيَعٌ':Predicate, #1: 1	نَقْلُ بِنْتِ
u'نَقَلَ تَاجٌ':Subject, #1: 1	نَقَلَ بِيعَ
u'نقل تَارِيخٌ':Added, #1: 1	نَقَلَ التَّاجُ
u'نَقْلٌ تَارِيخٌ':Added, #1: 1	نَقْلُ التَّارِيخِ
u'نقل تَحْرِيمٌ':Added, #1: 1	نَقْلُ التَّارِيخِ
u'نَقْلٌ تَحْرِيمٌ':Added, #1: 1	نَقْلُ تَحْرِيمِ
u'نَقَلَ تَخْصِيصٌ':Predicate, #1: 1	نَقْلُ تَحْرِيمِ
u'نقل تَدْرِيسٌ':Added, #1: 1	نَقَلَ التَّخْصِيصَ
u'نَقْلٌ تَدْرِيسٌ':Added, #1: 1	نَقْلُ التَّدْرِيسِ
u'نَقَلَ تُرَابٌ':Subject, #1: 1	نَقْلُ التَّدْرِيسِ
u'نقل تُرَابٌ':Added, #1: 1	نَقَلَ تُرَابُ
u'نقل تُرَابٌ':Added, #1: 1	نَقْلَ التُّرَابِ
u'نَقْلٌ تُرَابٌ':Added, #1: 1	نَقْلُ التُّرَابِ
u'نَقْلٌ تُرَابٌ':Added, #1: 1	نَقْلَ التُّرَابِ
u'نقل تُرَابٌ':Added, #1: 1	نَقْلُ التُّرَابِ
u'نَقْلٌ تُرَابٌ':Added, #2: 2	نَقْلُ تُرَابِ
u'نقل تُرَابٌ':Added, #2: 2	نَقْلُ تُرَابِ
u'نَقْلٌ تُرَابٌ':Added, #4: 4	نَقْلِ التُّرَابِ
u'نقل تَرَدُّدٌ':Added, #4: 4	نَقْلِ التُّرَابِ
u'نَقْلٌ تَرَدُّدٌ':Added, #1: 1	نَقْلَ التَّرَدُّدِ
u'نقل تَرِكَةٌ':Added, #1: 1	نَقْلَ التَّرَدُّدِ
u'نَقْلٌ تَرِكَةٌ':Added, #1: 1	نَقْلَ تَرِكَتِهِ
u'نقل تَزْكِيَةٌ':Added, #1: 1	نَقْلَ تَرِكَتِهِ
u'نَقْلٌ تَزْكِيَةٌ':Added, #1: 1	نَقْلَ تَزْكِيَةِ
u'نَقَلَ تَسْبِيحٌ':Predicate, #1: 1	نَقْلَ تَزْكِيَةِ
u'نقل تَسْبِيحٌ':Added, #1: 1	نَقَلَ تَسْبِيحَ
u'نقل تَسْبِيحٌ':Added, #1: 1	نَقْلَ التَّسْبِيحِ
u'نَقْلٌ تَسْبِيحٌ':Added, #1: 1	نَقْلِ التَّسْبِيحِ
u'نَقْلٌ تَسْبِيحٌ':Added, #1: 1	نَقْلَ التَّسْبِيحِ
u'نقل تَسْبِيحٌ':Added, #1: 1	نَقْلِ التَّسْبِيحِ
u'نَقْلٌ تَسْبِيحٌ':Added, #1: 1	نَقْلَ تَسْبِيحِ
u'نَقَلَ تَسْوِيَةٌ':Predicate, #1: 1	نَقْلَ تَسْبِيحِ
u'نَقَلَ تَصْحِيحٌ':Predicate, #1: 1	نَقَلَ التَّسْوِيَةَ
u'نقل تَصْحِيحٌ':Added, #1: 1	نَقَلَ التَّصْحِيحَ
u'نَقْلٌ تَصْحِيحٌ':Added, #1: 1	نَقْلِ تَصْحِيحِ
u'نقل تَصْحِيحٌ':Added, #1: 1	نَقْلِ تَصْحِيحِ
u'نقل تَصْحِيحٌ':Added, #1: 1	نَقْلَ تَصْحِيحِهِ
u'نَقْلٌ تَصْحِيحٌ':Added, #1: 1	نَقْلُ تَصْحِيحِهِ
u'نَقْلٌ تَصْحِيحٌ':Added, #1: 1	نَقْلَ تَصْحِيحِهِ
u'نقل تَصَرُّفٌ':Added, #1: 1	نَقْلُ تَصْحِيحِهِ
u'نَقْلٌ تَصَرُّفٌ':Added, #2: 2	نَقْلِ التَّصَرُّفِ
u'نَقَلَ تَصْرِيحٌ':Predicate, #2: 2	نَقْلِ التَّصَرُّفِ
u'نَقَلَ تَصْرِيحٌ':Predicate, #1: 1	نَقَلَ التَّصْرِيحَ
u'نقل تَصْرِيحٌ':Added, #1: 1	نَقَلَ تَصْرِيحَ
u'نَقْلٌ تَصْرِيحٌ':Added, #1: 1	نَقْلُ التَّصْرِيحِ
u'نَقَلَ تَطْبِيقٌ':Predicate, #1: 1	نَقْلُ التَّصْرِيحِ
u'نَقَلَ تَعْيِينٌ':Predicate, #1: 1	نَقَلَ التَّطْبِيقَ
u'نَقَلَ تَقْديمٌ':Predicate, #1: 1	نَقَلَ التَّعْيِينَ
u'نقل تَلْبيَةٌ':Added, #1: 1	نَقَلَ تَقْدِيمَ
u'نَقْلٌ تَلْبيَةٌ':Added, #1: 1	نَقْلِ تَلْبِيَتِهِ
u'نقل تَنْبِيهٌ':Added, #1: 1	نَقْلِ تَلْبِيَتِهِ
u'نَقْلٌ تَنْبِيهٌ':Added, #2: 2	نَقْلِ التَّنْبِيهَاتِ
u'نقل تَوَاتُرٌ':Added, #2: 2	نَقْلِ التَّنْبِيهَاتِ
u'نَقْلٌ تَوَاتُرٌ':Added, #1: 1	نَقْلَ التّوَاتُرِ
u'نقل تَوْرَاةٌ':Added, #1: 1	نَقْلَ التّوَاتُرِ
u'نَقْلٌ تَوْرَاةٌ':Added, #1: 1	نَقْلِ التَّوْرَاةِ
u'نَقَلَ تَوْفِيقٌ':Predicate, #1: 1	نَقْلِ التَّوْرَاةِ
u'نقل تونِسِيّ':Added, #1: 1	نَقَلَ التَّوْفِيقَ
u'نَقْلٌ تونِسِيّ':Added, #1: 1	نَقْلِ التُّونِسِيِّ
u'نَقْلٌ ثَابِتٌ':Added, #1: 1	نَقْلِ التُّونِسِيِّ
u'نَقَلَ ثَانِي':Predicate, #1: 1	نَقْلٍ ثَابِتٍ
u'نَقَلَ ثَانِيَةٌ':Predicate, #1: 1	نَقَلَ الثَّانِيَةَ
u'نَقَلَ ثِقَة':Subject, #1: 1	نَقَلَ الثَّانِيَةَ
u'نقل ثِقَة':Added, #1: 1	نَقَلَ الثِّقَاتُ
u'نَقْلٌ ثِقَة':Added, #1: 1	نَقْلِ الثِّقَاتِ
u'نقل ثَوابٌ':Added, #1: 1	نَقْلِ الثِّقَاتِ
u'نَقْلٌ ثَوابٌ':Added, #1: 1	نَقْلِ الثَّوَابِ
u'نقل ثَوابٌ':Added, #1: 1	نَقْلِ الثَّوَابِ
u'نَقْلٌ ثَوابٌ':Added, #1: 1	نَقْلِ ثَوَابٍ
u'نقل جَارِي':Added, #1: 1	نَقْلِ ثَوَابٍ
u'نَقْلٌ جَارِي':Added, #1: 1	نَقْلِ الْجَارِيَةِ
u'نقل جَارِيَةٌ':Added, #1: 1	نَقْلِ الْجَارِيَةِ
u'نَقْلٌ جَارِيَةٌ':Added, #1: 1	نَقْلِ الْجَارِيَةِ
u'نَقَلَ جَازٌ':Predicate, #1: 1	نَقْلِ الْجَارِيَةِ
u'نَقَلَ جَامِعٌ':Subject, #1: 1	نَقَلَ جَازَ
u'نقل جَبَلٌ':Added, #1: 1	نَقَلَ جَامِعُ
u'نَقْلٌ جَبَلٌ':Added, #3: 3	نَقْلَ جَبَلٍ
u'نَقَلَ جُحُود':Predicate, #3: 3	نَقْلَ جَبَلٍ
u'نقل جُزْءٌ':Added, #1: 1	نَقَلَ الْجُحُودَ
u'نَقْلٌ جُزْءٌ':Added, #1: 1	نَقْلِ جُزْءٍ
u'نَقَلَ جَصَّاصٌ':Subject, #1: 1	نَقْلِ جُزْءٍ
u'نَقَلَ جَلّاب':Subject, #1: 1	نَقَلَ الْجَصَّاصُ
u'نَقَلَ جَلاَلٌ':Subject, #1: 1	نَقَلَ الْجَلَّابُ
u'نَقَلَ جَمَاعَةٌ':Subject, #1: 1	نَقَلَ الْجَلَالُ
u'نَقَلَ جَمَاعَةٌ':Subject, #11: 11	نَقَلَ جَمَاعَةٌ
u'نقل جَمَاعَةٌ':Added, #13: 13	نَقَلَ الْجَمَاعَةُ
u'نَقْلٌ جَمَاعَةٌ':Added, #1: 1	نَقْلُ الْجَمَاعَةِ
u'نقل جَمَاعَةٌ':Added, #1: 1	نَقْلُ الْجَمَاعَةِ
u'نَقْلٌ جَمَاعَةٌ':Added, #1: 1	نَقْلِ جَمَاعَةٍ
u'نقل جَمَاعَةٌ':Added, #1: 1	نَقْلِ جَمَاعَةٍ
u'نَقْلٌ جَمَاعَةٌ':Added, #2: 2	نَقْلِ الْجَمَاعَةِ
u'نَقَلَ جَمْعٌ':Subject, #2: 2	نَقْلِ الْجَمَاعَةِ
u'نقل جُمْهُورٌ':Added, #1: 1	نَقَلَ جَمْعٌ
u'نَقْلٌ جُمْهُورٌ':Added, #1: 1	نَقْلِ الْجُمْهُورِ
u'نقل جَوَابٌ':Added, #1: 1	نَقْلِ الْجُمْهُورِ
u'نَقْلٌ جَوَابٌ':Added, #1: 1	نَقْلِ الْجَوَابِ
u'نَقَلَ جَوَازٌ':Predicate, #1: 1	نَقْلِ الْجَوَابِ
u'نقل جَوَازٌ':Added, #1: 1	نَقَلَ الْجَوَازَ
u'نَقْلٌ جَوَازٌ':Added, #1: 1	نَقْلَ جَوَازِهِ
u'نقل حاصِلٌ':Added, #1: 1	نَقْلَ جَوَازِهِ
u'نَقْلٌ حاصِلٌ':Added, #1: 1	نَقْلِ حَاصِلِ
u'نَقَلَ حافِظٌ':Subject, #1: 1	نَقْلِ حَاصِلِ
u'نَقَلَ حالَةٌ':Predicate, #1: 1	نَقَلَ الْحَافِظُ
u'نقل حَبْسٌ':Added, #1: 1	نَقَلَ حَالَةَ
u'نَقْلٌ حَبْسٌ':Added, #1: 1	نَقْلِ الْحَبْسِ
u'نَقَلَ حِجارَةٌ':Predicate, #1: 1	نَقْلِ الْحَبْسِ
u'نَقَلَ حَديثٌ':Predicate, #1: 1	نَقَلَ الْحِجَارَةَ
u'نقل حَديثٌ':Added, #2: 2	نَقَلَ الْحَدِيثَ
u'نَقْلٌ حَديثٌ':Added, #1: 1	نَقْلَ الْحَدِيثِ
u'نقل حَديثٌ':Added, #1: 1	نَقْلَ الْحَدِيثِ
u'نَقْلٌ حَديثٌ':Added, #1: 1	نَقْلُ حَدِيثٍ
u'نقل حَديثٌ':Added, #1: 1	نَقْلُ حَدِيثٍ
u'نَقْلٌ حَديثٌ':Added, #4: 4	نَقْلُ الْحَدِيثِ
u'نقل حَديثٌ':Added, #4: 4	نَقْلُ الْحَدِيثِ
u'نَقْلٌ حَديثٌ':Added, #6: 6	نَقْلِ الْحَدِيثِ
u'نَقَلَ حَرْبٌ':Subject, #6: 6	نَقْلِ الْحَدِيثِ
u'نقل حَرْبٌ':Added, #40: 40	نَقَلَ حَرْبٌ
u'نقل حَرْبٌ':Added, #1: 1	نَقْلَ حَرْبٍ
u'نَقْلٌ حَرْبٌ':Added, #1: 1	نَقْلُ حَرْبٍ
u'نَقْلٌ حَرْبٌ':Added, #1: 1	نَقْلَ حَرْبٍ
u'نقل حَرْبٌ':Added, #1: 1	نَقْلُ حَرْبٍ
u'نَقْلٌ حَرْبٌ':Added, #4: 4	نَقْلِ حَرْبٍ
u'نقل حَظٌّ':Added, #4: 4	نَقْلِ حَرْبٍ
u'نَقْلٌ حَظٌّ':Added, #1: 1	نَقْلِ حَظٍّ
u'نقل حَظْر':Added, #1: 1	نَقْلِ حَظٍّ
u'نَقْلٌ حَظْر':Added, #1: 1	نَقْلِ الْحَظْرِ
u'نَقَلَ حَقٌّ':Predicate, #1: 1	نَقْلِ الْحَظْرِ
u'نقل حَقٌّ':Added, #1: 1	نَقَلَ الْحَقَّ
u'نَقْلٌ حَقٌّ':Added, #1: 1	نَقْلِ حَقِّ
u'نقل حَقٌّ':Added, #1: 1	نَقْلِ حَقِّ
u'نَقْلٌ حَقٌّ':Added, #2: 2	نَقْلِ الْحَقِّ
u'نقل حَقٌّ':Added, #2: 2	نَقْلِ الْحَقِّ
u'نَقْلٌ حَقٌّ':Added, #2: 2	نَقْلَ حَقِّهِ
u'نقل حَقٌّ':Added, #2: 2	نَقْلَ حَقِّهِ
u'نَقْلٌ حَقٌّ':Added, #3: 3	نَقْلُ الْحَقِّ
u'نقل حَقٌّ':Added, #3: 3	نَقْلُ الْحَقِّ
u'نَقْلٌ حَقٌّ':Added, #3: 3	نَقْلُ حَقِّهِ
u'نقل حُقوقٌ':Added, #3: 3	نَقْلُ حَقِّهِ
u'نقل حُقُوقٌ':Added, #1: 1	نَقْلِ الْحُقُوقِ
u'نَقْلٌ حُقوقٌ':Added, #1: 1	نَقْلِ الْحُقُوقِ
u'نَقْلٌ حُقُوقٌ':Added, #1: 1	نَقْلِ الْحُقُوقِ
u'نقل حَقِيقٌ':Added, #1: 1	نَقْلِ الْحُقُوقِ
u'نَقْلٌ حَقِيقٌ':Added, #2: 2	نَقْلِ حَقِيقَةِ
u'نقل حَقِيقَةٌ':Added, #2: 2	نَقْلِ حَقِيقَةِ
u'نَقْلٌ حَقِيقَةٌ':Added, #2: 2	نَقْلِ حَقِيقَةِ
u'نَقَلَ حِكَايَةٌ':Predicate, #2: 2	نَقْلِ حَقِيقَةِ
u'نَقَلَ حِكَايَةٌ':Predicate, #1: 1	نَقَلَ الْحِكَايَةَ
u'نَقَلَ حُكْمٌ':Predicate, #1: 1	نَقَلَ حِكَايَةَ
u'نَقَلَ حُكْمٌ':Subject, #1: 1	نَقَلَ الْحُكْمَ
u'نقل حُكْمٌ':Added, #1: 1	نَقَلَ الْحُكْمُ
u'نَقْلٌ حُكْمٌ':Added, #10: 10	نَقْلُ حُكْمِ
u'نقل حُكْمٌ':Added, #10: 10	نَقْلُ حُكْمِ
u'نَقْلٌ حُكْمٌ':Added, #2: 2	نَقْلُ الْحُكْمِ
u'نقل حُكْمٌ':Added, #2: 2	نَقْلُ الْحُكْمِ
u'نقل حُكْمٌ':Added, #2: 2	نَقْلُ حُكْمٍ
u'نَقْلٌ حُكْمٌ':Added, #2: 2	نَقْلِ حُكْمِ
u'نَقْلٌ حُكْمٌ':Added, #2: 2	نَقْلُ حُكْمٍ
u'نقل حُكْمٌ':Added, #2: 2	نَقْلِ حُكْمِ
u'نَقْلٌ حُكْمٌ':Added, #5: 5	نَقْلِ الْحُكْمِ
u'نَقَلَ حَنْبَلٌ':Subject, #5: 5	نَقْلِ الْحُكْمِ
u'نقل حَنْبَلٌ':Added, #74: 74	نَقَلَ حَنْبَلٌ
u'نَقْلٌ حَنْبَلٌ':Added, #3: 3	نَقْلُ حَنْبَلٍ
u'نقل حَنْبَلٌ':Added, #3: 3	نَقْلُ حَنْبَلٍ
u'نَقْلٌ حَنْبَلٌ':Added, #8: 8	نَقْلِ حَنْبَلٍ
u'نقل حَنَفِيَّةٌ':Added, #8: 8	نَقْلِ حَنْبَلٍ
u'نَقْلٌ حَنَفِيَّةٌ':Added, #2: 2	نَقْلَ الْحَنَفِيَّةِ
u'نَقْلٌ خاصّ':Added, #2: 2	نَقْلَ الْحَنَفِيَّةِ
u'نَقَلَ خَبَرٌ':Predicate, #3: 3	نَقْلٍ خَاصٍّ
u'نَقَلَ خَبَر':Predicate, #1: 1	نَقَلَ الْخَبَرَ
u'نقل خَبَرٌ':Added, #1: 1	نَقَلَ الْخَبَرَ
u'نقل خَبَر':Added, #1: 1	نَقْلِ الْخَبَرِ
u'نَقْلٌ خَبَرٌ':Added, #1: 1	نَقْلِ الْخَبَرِ
u'نَقْلٌ خَبَر':Added, #1: 1	نَقْلِ الْخَبَرِ
u'نقل خَبَرٌ':Added, #1: 1	نَقْلِ الْخَبَرِ
u'نقل خَبَر':Added, #1: 1	نَقْلِ خَبَرٍ
u'نَقْلٌ خَبَرٌ':Added, #1: 1	نَقْلِ خَبَرٍ
u'نَقْلٌ خَبَر':Added, #1: 1	نَقْلِ خَبَرٍ
u'نَقَلَ خَطٌّ':Predicate, #1: 1	نَقْلِ خَبَرٍ
u'نَقَلَ خِلاَفٌ':Predicate, #1: 1	نَقَلَ الْخَطَّ
u'نَقَلَ خِلاَفٌ':Predicate, #1: 1	نَقَلَ خِلَافَ
u'نقل خِلاَفٌ':Added, #4: 4	نَقَلَ الْخِلَافَ
u'نقل خِلاَفٌ':Added, #1: 1	نَقْلَ الْخِلَافِ
u'نَقْلٌ خِلاَفٌ':Added, #1: 1	نَقْلُ الْخِلَافِ
u'نَقْلٌ خِلاَفٌ':Added, #1: 1	نَقْلَ الْخِلَافِ
u'نقل خِلاَفٌ':Added, #1: 1	نَقْلُ الْخِلَافِ
u'نقل خِلاَفٌ':Added, #1: 1	نَقْلُ خِلَافٍ
u'نَقْلٌ خِلاَفٌ':Added, #1: 1	نَقْلِ خِلَافٍ
u'نَقْلٌ خِلاَفٌ':Added, #1: 1	نَقْلُ خِلَافٍ
u'نقل خِلاَفٌ':Added, #1: 1	نَقْلِ خِلَافٍ
u'نَقْلٌ خِلاَفٌ':Added, #8: 8	نَقْلِ الْخِلَافِ
u'نَقَلَ خَمْرٌ':Predicate, #8: 8	نَقْلِ الْخِلَافِ
u'نقل خَمْرٌ':Added, #2: 2	نَقَلَ الْخَمْرَ
u'نَقْلٌ خَمْرٌ':Added, #1: 1	نَقْلَ الْخَمْرِ
u'نَقَلَ خَيْرٌ':Subject, #1: 1	نَقْلَ الْخَمْرِ
u'نَقَلَ دَابَّةٌ':Predicate, #1: 1	نَقَلَ الْخَيْرُ
u'نقل دَليلٌ':Added, #1: 1	نَقَلَ الدَّابَّةَ
u'نَقْلٌ دَليلٌ':Added, #1: 1	نَقْلِ الدَّلِيلِ
u'نقل دِيَةٌ':Added, #1: 1	نَقْلِ الدَّلِيلِ
u'نَقْلٌ دِيَةٌ':Added, #1: 1	نَقْلَ الدِّيَةِ
u'نقل دِينٌ':Added, #1: 1	نَقْلَ الدِّيَةِ
u'نَقْلٌ دِينٌ':Added, #1: 1	نَقْلُ الدِّينِ
u'نقل دَيْنٌ':Added, #1: 1	نَقْلُ الدِّينِ
u'نَقْلٌ دَيْنٌ':Added, #1: 1	نَقْلَ دَيْنٍ
u'نقل دَيْنٌ':Added, #1: 1	نَقْلَ دَيْنٍ
u'نَقْلٌ دَيْنٌ':Added, #6: 6	نَقْلِ الدَّيْنِ
u'نقل دَيْنٌ':Added, #6: 6	نَقْلِ الدَّيْنِ
u'نَقْلٌ دَيْنٌ':Added, #8: 8	نَقْلُ الدَّيْنِ
u'نقل ذَخيرَةٌ':Added, #8: 8	نَقْلُ الدَّيْنِ
u'نَقْلٌ ذَخيرَةٌ':Added, #1: 1	نَقْلُ الذَّخِيرَةِ
u'نقل ذُرِّيَّةٌ':Added, #1: 1	نَقْلُ الذَّخِيرَةِ
u'نَقْلٌ ذُرِّيَّةٌ':Added, #1: 1	نَقْلُ الذُّرِّيَّةِ
u'نقل ذِمَّةٌ':Added, #1: 1	نَقْلُ الذُّرِّيَّةِ
u'نَقْلٌ ذِمَّةٌ':Added, #1: 1	نَقْلُ ذِمَّةِ
u'نقل رَأْسٌ':Added, #1: 1	نَقْلُ ذِمَّةِ
u'نَقْلٌ رَأْسٌ':Added, #1: 1	نَقْلُ الرَّأْسِ
u'نقل رَأْسٌ':Added, #1: 1	نَقْلُ الرَّأْسِ
u'نقل رَأْسٌ':Added, #1: 1	نَقْلُ رَأْسٍ
u'نَقْلٌ رَأْسٌ':Added, #1: 1	نَقْلِ رَأْسِ
u'نَقْلٌ رَأْسٌ':Added, #1: 1	نَقْلُ رَأْسٍ
u'نقل رَجُلٌ':Added, #1: 1	نَقْلِ رَأْسِ
u'نَقْلٌ رَجُلٌ':Added, #1: 1	نَقْلُ الرَّجُلِ
u'نقل رِجْلٌ':Added, #1: 1	نَقْلُ الرَّجُلِ
u'نَقْلٌ رِجْلٌ':Added, #1: 1	نَقْلِ رِجْلٍ
u'نقل رَجْمٌ':Added, #1: 1	نَقْلِ رِجْلٍ
u'نَقْلٌ رَجْمٌ':Added, #1: 1	نَقْلِ الرَّجْمِ
u'نقل رُجُوعٌ':Added, #1: 1	نَقْلِ الرَّجْمِ
u'نَقْلٌ رُجُوعٌ':Added, #1: 1	نَقْلُ الرُّجُوعِ
u'نقل رُجُوعٌ':Added, #1: 1	نَقْلُ الرُّجُوعِ
u'نَقْلٌ رُجُوعٌ':Added, #1: 1	نَقْلُ رُجُوعِ
u'نقل رُكْنٌ':Added, #1: 1	نَقْلُ رُجُوعِ
u'نقل رُكْن':Added, #1: 1	نَقْلَ رُكْنٍ
u'نَقْلٌ رُكْنٌ':Added, #1: 1	نَقْلَ رُكْنٍ
u'نَقْلٌ رُكْن':Added, #1: 1	نَقْلَ رُكْنٍ
u'نقل رَمادٌ':Added, #1: 1	نَقْلَ رُكْنٍ
u'نَقْلٌ رَمادٌ':Added, #2: 2	نَقْلُ الرَّمَادِ
u'نَقَلَ رَمْلِيٌّ':Subject, #2: 2	نَقْلُ الرَّمَادِ
u'نقل رِواياتٌ':Added, #2: 2	نَقَلَ الرَّمْلِيُّ
u'نقل رِواياتٌ':Added, #1: 1	نَقْلَ الرِّوَايَاتِ
u'نَقْلٌ رِواياتٌ':Added, #1: 1	نَقْلِ الرِّوَايَاتِ
u'نَقْلٌ رِواياتٌ':Added, #1: 1	نَقْلَ الرِّوَايَاتِ
u'نَقَلَ رِوايَةٌ':Predicate, #1: 1	نَقْلِ الرِّوَايَاتِ
u'نقل رِوايَةٌ':Added, #3: 3	نَقَلَ رِوَايَةَ
u'نقل رِوايَةٌ':Added, #1: 1	نَقْلَ الرِّوَايَةِ
u'نَقْلٌ رِوايَةٌ':Added, #1: 1	نَقْلُ الرِّوَايَةِ
u'نَقْلٌ رِوايَةٌ':Added, #1: 1	نَقْلَ الرِّوَايَةِ
u'نقل رِوايَةٌ':Added, #1: 1	نَقْلُ الرِّوَايَةِ
u'نَقْلٌ رِوايَةٌ':Added, #2: 2	نَقْلِ الرِّوَايَةِ
u'نقل رَوْضَةٌ':Added, #2: 2	نَقْلِ الرِّوَايَةِ
u'نَقْلٌ رَوْضَةٌ':Added, #1: 1	نَقْلِ الرَّوْضَةِ
u'نقل ريعٌ':Added, #1: 1	نَقْلِ الرَّوْضَةِ
u'نَقْلٌ ريعٌ':Added, #1: 1	نَقْلِ الرِّيعِ
u'نقل زَكاةٌ':Added, #1: 1	نَقْلِ الرِّيعِ
u'نَقْلٌ زَكاةٌ':Added, #22: 22	نَقْلُ الزَّكَاةِ
u'نقل زَكاةٌ':Added, #22: 22	نَقْلُ الزَّكَاةِ
u'نَقْلٌ زَكاةٌ':Added, #2: 2	نَقْلَ الزَّكَاةِ
u'نقل زَكاةٌ':Added, #2: 2	نَقْلَ الزَّكَاةِ
u'نَقْلٌ زَكاةٌ':Added, #7: 7	نَقْلِ الزَّكَاةِ
u'نقل زَوْجَةٌ':Added, #7: 7	نَقْلِ الزَّكَاةِ
u'نَقْلٌ زَوْجَةٌ':Added, #1: 1	نَقْلَ زَوْجَتِهِ
u'نقل زِيادَةٌ':Added, #1: 1	نَقْلَ زَوْجَتِهِ
u'نَقْلٌ زِيادَةٌ':Added, #2: 2	نَقْلِ الزِّيَادَةِ
u'نقل سائِل':Added, #2: 2	نَقْلِ الزِّيَادَةِ
u'نقل سَائِلٌ':Added, #1: 1	نَقْلُ السَّائِلِ
u'نَقْلٌ سائِل':Added, #1: 1	نَقْلُ السَّائِلِ
u'نَقْلٌ سَائِلٌ':Added, #1: 1	نَقْلُ السَّائِلِ
u'نقل سَبَبٌ':Added, #1: 1	نَقْلُ السَّائِلِ
u'نَقْلٌ سَبَبٌ':Added, #1: 1	نَقْلِ سَبَبِ
u'نَقَلَ سُجُودٌ':Predicate, #1: 1	نَقْلِ سَبَبِ
u'نقل سُجُودٌ':Added, #1: 1	نَقَلَ السُّجُودَ
u'نَقْلٌ سُجُودٌ':Added, #1: 1	نَقْلِ السُّجُودِ
u'نَقَلَ سَعْدٌ':Subject, #1: 1	نَقْلِ السُّجُودِ
u'نقل سَعْدٌ':Added, #1: 1	نَقَلَ سَعْدٌ
u'نَقْلٌ سَعْدٌ':Added, #1: 1	نَقْلِ سَعْدٍ
u'نقل سلام':Added, #1: 1	نَقْلِ سَعْدٍ
u'نَقْلٌ سلام':Added, #1: 1	نَقْلَ السَّلَامِ
u'نقل سَلاَمٌ':Added, #1: 1	نَقْلَ السَّلَامِ
u'نَقْلٌ سَلاَمٌ':Added, #1: 1	نَقْلَ السَّلَامِ
u'نقل سُنْبُلٌ':Added, #1: 1	نَقْلَ السَّلَامِ
u'نَقْلٌ سُنْبُلٌ':Added, #1: 1	نَقْلِ السُّنْبُلِ
u'نقل سُنَّةٌ':Added, #1: 1	نَقْلِ السُّنْبُلِ
u'نَقْلٌ سُنَّةٌ':Added, #1: 1	نَقْلِ السُّنَّةِ
u'نَقَلَ سَنَدٌ':Subject, #1: 1	نَقْلِ السُّنَّةِ
u'نقل سَنَدٌ':Added, #1: 1	نَقَلَ سَنَدٌ
u'نَقْلٌ سَنَدٌ':Added, #1: 1	نَقْلُ سَنَدٍ
u'نَقَلَ سُؤَالٌ':Predicate, #1: 1	نَقْلُ سَنَدٍ
u'نَقَلَ سَيِّدٌ':Subject, #1: 1	نَقَلَ السُّؤَالَ
u'نَقَلَ سَيْل':Subject, #1: 1	نَقَلَ السَّيِّدُ
u'نَقَلَ شاذِلِيّ':Subject, #2: 2	نَقَلَ السَّيْلُ
u'نَقَلَ شَارِحٌ':Subject, #1: 1	نَقَلَ الشَّاذِلِيُّ
u'نَقَلَ شَارِعٌ':Subject, #2: 2	نَقَلَ الشَّارِحُ
u'نَقَلَ شافِعِيّ':Subject, #1: 1	نَقَلَ الشَّارِعُ
u'نقل شَرْعٌ':Added, #3: 3	نَقَلَ الشَّافِعِيُّ
u'نقل شَرْعٌ':Added, #1: 1	نَقْلُ الشَّرْعِ
u'نَقْلٌ شَرْعٌ':Added, #1: 1	نَقْلِ الشَّرْعِ
u'نَقْلٌ شَرْعٌ':Added, #1: 1	نَقْلُ الشَّرْعِ
u'نقل شَرْعٌ':Added, #1: 1	نَقْلِ الشَّرْعِ
u'نَقْلٌ شَرْعٌ':Added, #2: 2	نَقْلُ شَرْعٍ
u'نقل شَرِيعَةٌ':Added, #2: 2	نَقْلُ شَرْعٍ
u'نَقْلٌ شَرِيعَةٌ':Added, #1: 1	نَقْلُ الشَّرِيعَةِ
u'نقل شَرِيعَةٌ':Added, #1: 1	نَقْلُ الشَّرِيعَةِ
u'نَقْلٌ شَرِيعَةٌ':Added, #1: 1	نَقْلِ شَرِيعَةٍ
u'نقل شَعْبِيٌّ':Added, #1: 1	نَقْلِ شَرِيعَةٍ
u'نَقْلٌ شَعْبِيٌّ':Added, #1: 1	نَقْلُ الشَّعْبِيِّ
u'نقل شَهَادَةٌ':Added, #1: 1	نَقْلُ الشَّعْبِيِّ
u'نَقْلٌ شَهَادَةٌ':Added, #2: 2	نَقْلَ الشَّهَادَةِ
u'نقل شَهَادَةٌ':Added, #2: 2	نَقْلَ الشَّهَادَةِ
u'نَقْلٌ شَهَادَةٌ':Added, #2: 2	نَقْلِ شَهَادَتِهِ
u'نقل شَهَادَةٌ':Added, #2: 2	نَقْلِ شَهَادَتِهِ
u'نَقْلٌ شَهَادَةٌ':Added, #3: 3	نَقْلِ الشَّهَادَةِ
u'نقل شَهَادَةٌ':Added, #3: 3	نَقْلِ الشَّهَادَةِ
u'نقل شَهَادَةٌ':Added, #3: 3	نَقْلَ شَهَادَةِ
u'نَقْلٌ شَهَادَةٌ':Added, #3: 3	نَقْلِ شَهَادَةِ
u'نَقْلٌ شَهَادَةٌ':Added, #3: 3	نَقْلَ شَهَادَةِ
u'نقل شَهَادَةٌ':Added, #3: 3	نَقْلِ شَهَادَةِ
u'نَقْلٌ شَهَادَةٌ':Added, #4: 4	نَقْلُ الشَّهَادَةِ
u'نقل شَهَادَةٌ':Added, #4: 4	نَقْلُ الشَّهَادَةِ
u'نَقْلٌ شَهَادَةٌ':Added, #4: 4	نَقْلُ شَهَادَةٍ
u'نقل شَيْءٌ':Added, #4: 4	نَقْلُ شَهَادَةٍ
u'نَقْلٌ شَيْءٌ':Added, #1: 1	نَقْلُ الشَّيْءِ
u'نقل شَيْءٌ':Added, #1: 1	نَقْلُ الشَّيْءِ
u'نَقْلٌ شَيْءٌ':Added, #1: 1	نَقْلِ شَيْءٍ
u'نقل شَيْءٌ':Added, #1: 1	نَقْلِ شَيْءٍ
u'نَقْلٌ شَيْءٌ':Added, #4: 4	نَقْلُ شَيْءٍ
u'نَقَلَ شَيْخٌ':Subject, #4: 4	نَقْلُ شَيْءٍ
u'نَقَلَ شَيْخٌ':Subject, #13: 13	نَقَلَ الشَّيْخُ
u'نقل شَيْخٌ':Added, #1: 1	نَقَلَ شَيْخُ
u'نَقْلٌ شَيْخٌ':Added, #1: 1	نَقْلِ الشَّيْخَيْنِ
u'نقل شَيْخٌ':Added, #1: 1	نَقْلِ الشَّيْخَيْنِ
u'نقل شَيْخٌ':Added, #3: 3	نَقْلُ الشَّيْخِ
u'نَقْلٌ شَيْخٌ':Added, #3: 3	نَقْلِ الشَّيْخِ
u'نَقْلٌ شَيْخٌ':Added, #3: 3	نَقْلُ الشَّيْخِ
u'نَقَلَ صَاحِبٌ':Subject, #3: 3	نَقْلِ الشَّيْخِ
u'نقل صَاحِبٌ':Added, #10: 10	نَقَلَ صَاحِبُ
u'نَقْلٌ صَاحِبٌ':Added, #1: 1	نَقْلَ صَاحِبِ
u'نقل صَاحِبٌ':Added, #1: 1	نَقْلَ صَاحِبِ
u'نقل صَاحِبٌ':Added, #2: 2	نَقْلُ صَاحِبِ
u'نَقْلٌ صَاحِبٌ':Added, #2: 2	نَقْلِ صَاحِبِ
u'نَقْلٌ صَاحِبٌ':Added, #2: 2	نَقْلُ صَاحِبِ
u'نَقَلَ صَالِحٌ':Subject, #2: 2	نَقْلِ صَاحِبِ
u'نَقَلَ صَالِح':Subject, #46: 46	نَقَلَ صَالِحٌ
u'نقل صَالِحٌ':Added, #46: 46	نَقَلَ صَالِحٌ
u'نقل صَالِح':Added, #4: 4	نَقْلِ صَالِحٍ
u'نَقْلٌ صَالِحٌ':Added, #4: 4	نَقْلِ صَالِحٍ
u'نَقْلٌ صَالِح':Added, #4: 4	نَقْلِ صَالِحٍ
u'نقل صَحَابَةٌ':Added, #4: 4	نَقْلِ صَالِحٍ
u'نَقْلٌ صَحَابَةٌ':Added, #1: 1	نَقْلُ الصَّحَابَةِ
u'نقل صَحَابِيٌّ':Added, #1: 1	نَقْلُ الصَّحَابَةِ
u'نَقْلٌ صَحَابِيٌّ':Added, #1: 1	نَقْلِ الصَّحَابِيِّ
u'نقل صَخْرٌ':Added, #1: 1	نَقْلِ الصَّحَابِيِّ
u'نَقْلٌ صَخْرٌ':Added, #1: 1	نَقْلُ الصَّخْرِ
u'نَقَلَ صَدْرٌ':Predicate, #1: 1	نَقْلُ الصَّخْرِ
u'نَقَلَ صدقة':Predicate, #1: 1	نَقَلَ صَدْرَ
u'نَقَلَ صَدَقَةٌ':Predicate, #1: 1	نَقَلَ صَدَقَةَ
u'نقل صدقة':Added, #1: 1	نَقَلَ صَدَقَةَ
u'نَقْلٌ صدقة':Added, #1: 1	نَقْلِ الصَّدَقَةِ
u'نقل صَدَقَةٌ':Added, #1: 1	نَقْلِ الصَّدَقَةِ
u'نَقْلٌ صَدَقَةٌ':Added, #1: 1	نَقْلِ الصَّدَقَةِ
u'نَقْلٌ صَرِيحٌ':Added, #1: 1	نَقْلِ الصَّدَقَةِ
u'نقل صَرِيحٌ':Added, #10: 10	نَقْلٍ صَرِيحٍ
u'نَقْلٌ صَرِيحٌ':Added, #1: 1	نَقْلِ صَرِيحِ
u'نَقَلَ صَلاَةٌ':Predicate, #1: 1	نَقْلِ صَرِيحِ
u'نقل صَلاَةٌ':Added, #1: 1	نَقَلَ الصَّلَاةَ
u'نَقْلٌ صَلاَةٌ':Added, #1: 1	نَقْلِ الصَّلَاةِ
u'نقل صَلاَةٌ':Added, #1: 1	نَقْلِ الصَّلَاةِ
u'نَقْلٌ صَلاَةٌ':Added, #2: 2	نَقْلُ الصَّلَاةِ
u'نَقَلَ صَيْرَفِيٌّ':Subject, #2: 2	نَقْلُ الصَّلَاةِ
u'نقل ضَمَانٌ':Added, #1: 1	نَقَلَ الصَّيْرَفِيُّ
u'نَقْلٌ ضَمَانٌ':Added, #2: 2	نَقْلِ الضَّمَانِ
u'نقل ضَمَّةٌ':Added, #2: 2	نَقْلِ الضَّمَانِ
u'نَقْلٌ ضَمَّةٌ':Added, #1: 1	نَقْلُ ضَمّةِ
u'نَقَلَ ضَمِنٌ':Predicate, #1: 1	نَقْلُ ضَمّةِ
u'نقل طِبَاعٌ':Added, #1: 1	نَقَلَ ضَمِنَ
u'نَقْلٌ طِبَاعٌ':Added, #1: 1	نَقْلُ الطِّبَاعِ
u'نقل طَبِيعَةٌ':Added, #1: 1	نَقْلُ الطِّبَاعِ
u'نَقْلٌ طَبِيعَةٌ':Added, #1: 1	نَقْلِ الطَّبِيعَةِ
u'نقل طَرِيقٌ':Added, #1: 1	نَقْلِ الطَّبِيعَةِ
u'نقل طَرِيقٌ':Added, #1: 1	نَقْلَ الطَّرِيقِ
u'نَقْلٌ طَرِيقٌ':Added, #1: 1	نَقْلُ الطَّرِيقِ
u'نَقْلٌ طَرِيقٌ':Added, #1: 1	نَقْلَ الطَّرِيقِ
u'نقل طعام':Added, #1: 1	نَقْلُ الطَّرِيقِ
u'نقل طعام':Added, #1: 1	نَقْلَ الطَّعَامِ
u'نَقْلٌ طعام':Added, #1: 1	نَقْلِ الطَّعَامِ
u'نَقْلٌ طعام':Added, #1: 1	نَقْلَ الطَّعَامِ
u'نقل طَعَامٌ':Added, #1: 1	نَقْلِ الطَّعَامِ
u'نقل طَعَامٌ':Added, #1: 1	نَقْلَ الطَّعَامِ
u'نَقْلٌ طَعَامٌ':Added, #1: 1	نَقْلِ الطَّعَامِ
u'نَقْلٌ طَعَامٌ':Added, #1: 1	نَقْلَ الطَّعَامِ
u'نقل طلب':Added, #1: 1	نَقْلِ الطَّعَامِ
u'نَقْلٌ طلب':Added, #1: 1	نَقْلِ الطَّلَبِ
u'نقل طَلَبٌ':Added, #1: 1	نَقْلِ الطَّلَبِ
u'نَقْلٌ طَلَبٌ':Added, #1: 1	نَقْلِ الطَّلَبِ
u'نقل طواف':Added, #1: 1	نَقْلِ الطَّلَبِ
u'نَقْلٌ طواف':Added, #1: 1	نَقْلِ طَوَافِ
u'نقل طَوَافٌ':Added, #1: 1	نَقْلِ طَوَافِ
u'نَقْلٌ طَوَافٌ':Added, #1: 1	نَقْلِ طَوَافِ
u'نقل طِينٌ':Added, #1: 1	نَقْلِ طَوَافِ
u'نقل طِينٌ':Added, #1: 1	نَقْلَ الطِّينِ
u'نَقْلٌ طِينٌ':Added, #1: 1	نَقْلِ الطِّينِ
u'نَقْلٌ طِينٌ':Added, #1: 1	نَقْلَ الطِّينِ
u'نقل ظُهورٌ':Added, #1: 1	نَقْلِ الطِّينِ
u'نَقْلٌ ظُهورٌ':Added, #1: 1	نَقْلُ ظُهُورِهِ
u'نقل عَادَةٌ':Added, #1: 1	نَقْلُ ظُهُورِهِ
u'نَقْلٌ عَادَةٌ':Added, #3: 3	نَقْلِ الْعَادَةِ
u'نَقَلَ عِبَارَةٌ':Predicate, #3: 3	نَقْلِ الْعَادَةِ
u'نقل عِبَارَةٌ':Added, #6: 6	نَقَلَ عِبَارَةَ
u'نَقْلٌ عِبَارَةٌ':Added, #1: 1	نَقْلِ عِبَارَاتِ
u'نقل عِبَارَةٌ':Added, #1: 1	نَقْلِ عِبَارَاتِ
u'نَقْلٌ عِبَارَةٌ':Added, #1: 1	نَقْلُ عِبَارَةِ
u'نقل عِبَارَةٌ':Added, #1: 1	نَقْلُ عِبَارَةِ
u'نَقْلٌ عِبَارَةٌ':Added, #4: 4	نَقْلِ عِبَارَةِ
u'نَقَلَ عَبْدٌ':Subject, #4: 4	نَقْلِ عِبَارَةِ
u'نقل عَبْدٌ':Added, #28: 28	نَقَلَ عَبْدُ
u'نَقْلٌ عَبْدٌ':Added, #1: 1	نَقْلُ الْعَبْدِ
u'نقل عَبْدٌ':Added, #1: 1	نَقْلُ الْعَبْدِ
u'نَقْلٌ عَبْدٌ':Added, #1: 1	نَقْلُ عَبْدِ
u'نقل عَبْدٌ':Added, #1: 1	نَقْلُ عَبْدِ
u'نَقْلٌ عَبْدٌ':Added, #5: 5	نَقْلِ عَبْدِ
u'نقل عَدَدٌ':Added, #5: 5	نَقْلِ عَبْدِ
u'نَقْلٌ عَدَدٌ':Added, #1: 1	نَقْلُ عَدَدِ
u'نَقَلَ عَدَمٌ':Predicate, #1: 1	نَقْلُ عَدَدِ
u'نقل عَدَمٌ':Added, #2: 2	نَقَلَ عَدَمَ
u'نَقْلٌ عَدَمٌ':Added, #1: 1	نَقْلُ الْعَدَمِ
u'نقل عَدَمٌ':Added, #1: 1	نَقْلُ الْعَدَمِ
u'نَقْلٌ عَدَمٌ':Added, #1: 1	نَقْلُ عَدَمِ
u'نقل عُدُولٌ':Added, #1: 1	نَقْلُ عَدَمِ
u'نقل عُدُولٌ':Added, #1: 1	نَقْلَ الْعُدُولِ
u'نَقْلٌ عُدُولٌ':Added, #1: 1	نَقْلِ الْعُدُولِ
u'نَقْلٌ عُدُولٌ':Added, #1: 1	نَقْلَ الْعُدُولِ
u'نقل عَرْضٌ':Added, #1: 1	نَقْلِ الْعُدُولِ
u'نَقْلٌ عَرْضٌ':Added, #1: 1	نَقْلُ الْعَرْضِ
u'نَقَلَ عِزٌّ':Subject, #1: 1	نَقْلُ الْعَرْضِ
u'نقل عَظْمٌ':Added, #1: 1	نَقَلَ عِزُّ
u'نَقْلٌ عَظْمٌ':Added, #1: 1	نَقْلِ الْعَظْمِ
u'نقل علم':Added, #1: 1	نَقْلِ الْعَظْمِ
u'نَقْلٌ علم':Added, #1: 1	نَقْلِ الْعِلْمِ
u'نقل عِلْمٌ':Added, #1: 1	نَقْلِ الْعِلْمِ
u'نَقْلٌ عِلْمٌ':Added, #1: 1	نَقْلِ الْعِلْمِ
u'نَقَلَ علماء':Subject, #1: 1	نَقْلِ الْعِلْمِ
u'نَقَلَ عُلَمَاءُ':Subject, #2: 2	نَقَلَ الْعُلَمَاءُ
u'نَقَلَ عَلِيٌّ':Subject, #2: 2	نَقَلَ الْعُلَمَاءُ
u'نقل عَمَلٌ':Added, #2: 2	نَقَلَ عَلِيُّ
u'نَقْلٌ عَمَلٌ':Added, #1: 1	نَقْلِ الْعَمَلِ
u'نقل عُمُومٌ':Added, #1: 1	نَقْلِ الْعَمَلِ
u'نَقْلٌ عُمُومٌ':Added, #1: 1	نَقْلِ عُمُومِ
u'نَقَلَ عند':Predicate, #1: 1	نَقْلِ عُمُومِ
u'نقل عِيَالٌ':Added, #2: 2	نَقَلَ عِنْدَ
u'نَقْلٌ عِيَالٌ':Added, #1: 1	نَقْلِ الْعِيَالِ
u'نقل عَيْنٌ':Added, #1: 1	نَقْلِ الْعِيَالِ
u'نقل عَيْن':Added, #1: 1	نَقْلُ عَيْنٍ
u'نَقْلٌ عَيْنٌ':Added, #1: 1	نَقْلُ عَيْنٍ
u'نَقْلٌ عَيْن':Added, #1: 1	نَقْلُ عَيْنٍ
u'نقل غرائب':Added, #1: 1	نَقْلُ عَيْنٍ
u'نَقْلٌ غرائب':Added, #1: 1	نَقْلِ الْغَرَائِبِ
u'نَقَلَ غير':Predicate, #1: 1	نَقْلِ الْغَرَائِبِ
u'نَقَلَ غَيْرٌ':Predicate, #1: 1	نَقَلَ غَيْرَ
u'نَقَلَ غير':Subject, #1: 1	نَقَلَ غَيْرَ
u'نَقَلَ غَيْرٌ':Subject, #4: 4	نَقَلَ غَيْرُهُ
u'نَقَلَ غير':Subject, #4: 4	نَقَلَ غَيْرُهُ
u'نَقَلَ غَيْرٌ':Subject, #8: 8	نَقَلَ غَيْرُ
u'نقل غير':Added, #8: 8	نَقَلَ غَيْرُ
u'نقل غَيْرٌ':Added, #1: 1	نَقْلُ غَيْرِ
u'نَقْلٌ غير':Added, #1: 1	نَقْلُ غَيْرِ
u'نَقْلٌ غَيْرٌ':Added, #1: 1	نَقْلُ غَيْرِ
u'نقل غير':Added, #1: 1	نَقْلُ غَيْرِ
u'نقل غير':Added, #2: 2	نَقْلُ غَيْرِهِ
u'نقل غَيْرٌ':Added, #2: 2	نَقْلِ غَيْرِهِ
u'نقل غَيْرٌ':Added, #2: 2	نَقْلُ غَيْرِهِ
u'نَقْلٌ غير':Added, #2: 2	نَقْلِ غَيْرِهِ
u'نَقْلٌ غير':Added, #2: 2	نَقْلُ غَيْرِهِ
u'نَقْلٌ غَيْرٌ':Added, #2: 2	نَقْلِ غَيْرِهِ
u'نَقْلٌ غَيْرٌ':Added, #2: 2	نَقْلُ غَيْرِهِ
u'نقل غير':Added, #2: 2	نَقْلِ غَيْرِهِ
u'نقل غَيْرٌ':Added, #4: 4	نَقْلِ غَيْرِ
u'نَقْلٌ غير':Added, #4: 4	نَقْلِ غَيْرِ
u'نَقْلٌ غَيْرٌ':Added, #4: 4	نَقْلِ غَيْرِ
u'نقل فحول':Added, #4: 4	نَقْلِ غَيْرِ
u'نَقْلٌ فحول':Added, #1: 1	نَقْلِ الْفُحُولِ
u'نقل فُحُولٌ':Added, #1: 1	نَقْلِ الْفُحُولِ
u'نَقْلٌ فُحُولٌ':Added, #1: 1	نَقْلِ الْفُحُولِ
u'نقل فخر':Added, #1: 1	نَقْلِ الْفُحُولِ
u'نَقْلٌ فخر':Added, #1: 1	نَقْلِ فَخْرِ
u'نقل فَخْرٌ':Added, #1: 1	نَقْلِ فَخْرِ
u'نَقْلٌ فَخْرٌ':Added, #1: 1	نَقْلِ فَخْرِ
u'نقل فَرْضٌ':Added, #1: 1	نَقْلِ فَخْرِ
u'نَقْلٌ فَرْضٌ':Added, #1: 1	نَقْلُ فَرْضٍ
u'نقل فَرْعٌ':Added, #1: 1	نَقْلُ فَرْضٍ
u'نَقْلٌ فَرْعٌ':Added, #1: 1	نَقْلِ الْفَرْعِ
u'نَقَلَ فساد':Predicate, #1: 1	نَقْلِ الْفَرْعِ
u'نَقَلَ فَسَادٌ':Predicate, #2: 2	نَقَلَ الْفَسَادَ
u'نَقَلَ فَضْلٌ':Subject, #2: 2	نَقَلَ الْفَسَادَ
u'نقل فِعْلٌ':Added, #3: 3	نَقَلَ الْفَضْلُ
u'نَقْلٌ فِعْلٌ':Added, #1: 1	نَقْلَ فِعْلِهِ
u'نَقَلَ فِقْهٌ':Predicate, #1: 1	نَقْلَ فِعْلِهِ
u'نقل فِقْهٌ':Added, #2: 2	نَقَلَ الْفِقْهَ
u'نَقْلٌ فِقْهٌ':Added, #1: 1	نَقْلَ الْفِقْهِ
u'نَقَلَ فقهاء':Subject, #1: 1	نَقْلَ الْفِقْهِ
u'نَقَلَ فلان':Subject, #1: 1	نَقَلَ الْفُقَهَاءُ
u'نَقَلَ فلان':Subject, #11: 11	نَقَلَ جَعْفَرٌ
u'نَقَلَ فلان':Subject, #1: 1	نَقَلَ الشَّاذِلِيُّ
u'نَقَلَ فلان':Subject, #2: 2	نَقَلَ الْبَيْهَقِيُّ
u'نَقَلَ فلان':Subject, #2: 2	نَقَلَ جَعْفَرُ
u'نَقَلَ فلان':Subject, #3: 3	نَقَلَ الشَّافِعِيُّ
u'نَقَلَ فلان':Subject, #3: 3	نَقَلَ هَارُونُ
u'نَقَلَ فلان':Subject, #4: 4	نَقَلَ التِّرْمِذِيُّ
u'نَقَلَ فلان':Subject, #5: 5	نَقَلَ الْقُرْطُبِيُّ
u'نقل فلان':Added, #6: 6	نَقَلَ الْكَحَّالُ
u'نَقْلٌ فلان':Added, #1: 1	نَقْلِ التِّرْمِذِيِّ
u'نقل فلان':Added, #1: 1	نَقْلِ التِّرْمِذِيِّ
u'نَقْلٌ فلان':Added, #1: 1	نَقْلِ الْحَارِثِيِّ
u'نقل فلان':Added, #1: 1	نَقْلِ الْحَارِثِيِّ
u'نَقْلٌ فلان':Added, #1: 1	نَقْلُ الْقُرْطُبِيِّ
u'نقل فلان':Added, #1: 1	نَقْلُ الْقُرْطُبِيِّ
u'نَقْلٌ فلان':Added, #2: 2	نَقْلِ جَعْفَرٍ
u'نَقَلَ قَاتِلٌ':Predicate, #2: 2	نَقْلِ جَعْفَرٍ
u'نَقَلَ قدرة':Predicate, #1: 1	نَقَلَ الْقَاتِلَ
u'نَقَلَ قُدْرَةٌ':Predicate, #1: 1	نَقَلَ الْقُدْرَةَ
u'نقل قُرْآنٌ':Added, #1: 1	نَقَلَ الْقُدْرَةَ
u'نَقْلٌ قُرْآنٌ':Added, #4: 4	نَقْلِ الْقُرْآنِ
u'نَقَلَ قُرْطُبِيّ':Subject, #4: 4	نَقْلِ الْقُرْآنِ
u'نقل قُرْطُبِيّ':Added, #5: 5	نَقَلَ الْقُرْطُبِيُّ
u'نَقْلٌ قُرْطُبِيّ':Added, #1: 1	نَقْلُ الْقُرْطُبِيِّ
u'نقل قَنْطَرَةٌ':Added, #1: 1	نَقْلُ الْقُرْطُبِيِّ
u'نَقْلٌ قَنْطَرَةٌ':Added, #1: 1	نَقْلُ قَنْطَرَةٍ
u'نَقَلَ قول':Predicate, #1: 1	نَقْلُ قَنْطَرَةٍ
u'نَقَلَ قَوْلٌ':Predicate, #1: 1	نَقَلَ قَوْلَ
u'نَقَلَ قول':Predicate, #1: 1	نَقَلَ قَوْلَ
u'نَقَلَ قَوْلٌ':Predicate, #4: 4	نَقَلَ الْقَوْلَ
u'نقل قول':Added, #4: 4	نَقَلَ الْقَوْلَ
u'نَقْلٌ قول':Added, #1: 1	نَقْلِ الْقَوْلِ
u'نقل قَوْلٌ':Added, #1: 1	نَقْلِ الْقَوْلِ
u'نَقْلٌ قَوْلٌ':Added, #1: 1	نَقْلِ الْقَوْلِ
u'نقل قَوْلٌ':Added, #1: 1	نَقْلِ الْقَوْلِ
u'نَقْلٌ قَوْلٌ':Added, #1: 1	نَقْلُ الْقَوْلَيْنِ
u'نقل قول':Added, #1: 1	نَقْلُ الْقَوْلَيْنِ
u'نقل قول':Added, #1: 1	نَقْلَ قَوْلِ
u'نَقْلٌ قول':Added, #1: 1	نَقْلِ قَوْلِ
u'نَقْلٌ قول':Added, #1: 1	نَقْلَ قَوْلِ
u'نقل قَوْلٌ':Added, #1: 1	نَقْلِ قَوْلِ
u'نقل قَوْلٌ':Added, #1: 1	نَقْلَ قَوْلِ
u'نقل قَوْلٌ':Added, #1: 1	نَقْلُ قَوْلٍ
u'نَقْلٌ قَوْلٌ':Added, #1: 1	نَقْلِ قَوْلِ
u'نَقْلٌ قَوْلٌ':Added, #1: 1	نَقْلَ قَوْلِ
u'نَقْلٌ قَوْلٌ':Added, #1: 1	نَقْلُ قَوْلٍ
u'نقل قَوْلٌ':Added, #1: 1	نَقْلِ قَوْلِ
u'نقل قَوْلٌ':Added, #1: 1	نَقْلُ قَوْلَيْنِ
u'نَقْلٌ قَوْلٌ':Added, #1: 1	نَقْلِ قَوْلَيْنِ
u'نَقْلٌ قَوْلٌ':Added, #1: 1	نَقْلُ قَوْلَيْنِ
u'نَقَلَ قَيْدٌ':Predicate, #1: 1	نَقْلِ قَوْلَيْنِ
u'نَقَلَ كِتَابٌ':Predicate, #1: 1	نَقَلَ الْقَيْدَ
u'نقل كِتَابٌ':Added, #3: 3	نَقَلَ الْكِتَابَ
u'نَقْلٌ كِتَابٌ':Added, #1: 1	نَقْلِ كِتَابٍ
u'نقل كِتَابٌ':Added, #1: 1	نَقْلِ كِتَابٍ
u'نقل كِتَابٌ':Added, #2: 2	نَقْلُ الْكِتَابِ
u'نَقْلٌ كِتَابٌ':Added, #2: 2	نَقْلِ الْكِتَابِ
u'نَقْلٌ كِتَابٌ':Added, #2: 2	نَقْلُ الْكِتَابِ
u'نقل كُتُبٌ':Added, #2: 2	نَقْلِ الْكِتَابِ
u'نقل كُتُبٌ':Added, #1: 1	نَقْلَ الْكُتُبِ
u'نَقْلٌ كُتُبٌ':Added, #1: 1	نَقْلُ الْكُتُبِ
u'نَقْلٌ كُتُبٌ':Added, #1: 1	نَقْلَ الْكُتُبِ
u'نقل كُتُبٌ':Added, #1: 1	نَقْلُ الْكُتُبِ
u'نَقْلٌ كُتُبٌ':Added, #2: 2	نَقْلِ كُتُبِ
u'نَقَلَ كَحّال':Subject, #2: 2	نَقْلِ كُتُبِ
u'نقل كَفَّارٌ':Added, #6: 6	نَقَلَ الْكَحَّالُ
u'نَقْلٌ كَفَّارٌ':Added, #1: 1	نَقْلُ الْكَفَّارَةِ
u'نقل كَفَّارَةٌ':Added, #1: 1	نَقْلُ الْكَفَّارَةِ
u'نَقْلٌ كَفَّارَةٌ':Added, #1: 1	نَقْلُ الْكَفَّارَةِ
u'نَقَلَ كَلاَمٌ':Predicate, #1: 1	نَقْلُ الْكَفَّارَةِ
u'نقل كَلاَمٌ':Added, #10: 10	نَقَلَ كَلَامَ
u'نَقْلٌ كَلاَمٌ':Added, #11: 11	نَقْلِ كَلَامِ
u'نقل كَلاَمٌ':Added, #11: 11	نَقْلِ كَلَامِ
u'نقل كَلاَمٌ':Added, #1: 1	نَقْلَ الْكَلَامِ
u'نقل كَلاَمٌ':Added, #1: 1	نَقْلُ الْكَلَامِ
u'نَقْلٌ كَلاَمٌ':Added, #1: 1	نَقْلِ الْكَلَامِ
u'نَقْلٌ كَلاَمٌ':Added, #1: 1	نَقْلَ الْكَلَامِ
u'نَقْلٌ كَلاَمٌ':Added, #1: 1	نَقْلُ الْكَلَامِ
u'نقل كَلاَمٌ':Added, #1: 1	نَقْلِ الْكَلَامِ
u'نَقْلٌ كَلاَمٌ':Added, #1: 1	نَقْلَ كَلَامِ
u'نقل كَلاَمٌ':Added, #1: 1	نَقْلَ كَلَامِ
u'نقل كَلاَمٌ':Added, #1: 1	نَقْلُ كَلَامِهِ
u'نَقْلٌ كَلاَمٌ':Added, #1: 1	نَقْلِ كَلَامِهِ
u'نَقْلٌ كَلاَمٌ':Added, #1: 1	نَقْلُ كَلَامِهِ
u'نقل كَلاَمٌ':Added, #1: 1	نَقْلِ كَلَامِهِ
u'نَقْلٌ كَلاَمٌ':Added, #5: 5	نَقْلُ كَلَامِ
u'نقل كُلِّيٌّ':Added, #5: 5	نَقْلُ كَلَامِ
u'نَقْلٌ كُلِّيٌّ':Added, #1: 1	نَقْلِ كُلِّيَّاتِ
u'نقل كُلِّيَّاتٌ':Added, #1: 1	نَقْلِ كُلِّيَّاتِ
u'نَقْلٌ كُلِّيَّاتٌ':Added, #1: 1	نَقْلِ كُلِّيَّاتِ
u'نقل كُلِّيَّةٌ':Added, #1: 1	نَقْلِ كُلِّيَّاتِ
u'نَقْلٌ كُلِّيَّةٌ':Added, #1: 1	نَقْلِ كُلِّيَّاتِ
u'نقل لُبَابٌ':Added, #1: 1	نَقْلِ كُلِّيَّاتِ
u'نَقْلٌ لُبَابٌ':Added, #1: 1	نَقْلُ لُبَابِ
u'نقل لُغَةٌ':Added, #1: 1	نَقْلُ لُبَابِ
u'نَقْلٌ لُغَةٌ':Added, #3: 3	نَقْلِ اللُّغَةِ
u'نقل لَفْظٌ':Added, #3: 3	نَقْلِ اللُّغَةِ
u'نَقْلٌ لَفْظٌ':Added, #1: 1	نَقْلِ اللَّفْظِ
u'نقل لَفْظٌ':Added, #1: 1	نَقْلِ اللَّفْظِ
u'نَقْلٌ لَفْظٌ':Added, #1: 1	نَقْلِ لَفْظِ
u'نقل لَفْظٌ':Added, #1: 1	نَقْلِ لَفْظِ
u'نَقْلٌ لَفْظٌ':Added, #1: 1	نَقْلِ لَفْظِهِ
u'نقل لَفْظٌ':Added, #1: 1	نَقْلِ لَفْظِهِ
u'نَقْلٌ لَفْظٌ':Added, #6: 6	نَقْلُ اللَّفْظِ
u'نقل لَيْلٌ':Added, #6: 6	نَقْلُ اللَّفْظِ
u'نَقْلٌ لَيْلٌ':Added, #2: 2	نَقْلُ لَيْلَةِ
u'نقل مَاءٌ':Added, #2: 2	نَقْلُ لَيْلَةِ
u'نَقْلٌ مَاءٌ':Added, #1: 1	نَقْلُ مَاءِ
u'نقل مَاءٌ':Added, #1: 1	نَقْلُ مَاءِ
u'نَقْلٌ مَاءٌ':Added, #4: 4	نَقْلَ الْمَاءِ
u'نقل مَاءٌ':Added, #4: 4	نَقْلَ الْمَاءِ
u'نَقْلٌ مَاءٌ':Added, #6: 6	نَقْلُ الْمَاءِ
u'نقل مَاءٌ':Added, #6: 6	نَقْلُ الْمَاءِ
u'نَقْلٌ مَاءٌ':Added, #7: 7	نَقْلِ الْمَاءِ
u'نقل مَالٌ':Added, #7: 7	نَقْلِ الْمَاءِ
u'نَقْلٌ مَالٌ':Added, #1: 1	نَقْلَ الْمَالِ
u'نقل مَالٌ':Added, #1: 1	نَقْلَ الْمَالِ
u'نقل مَالٌ':Added, #1: 1	نَقْلُ مَالِ
u'نَقْلٌ مَالٌ':Added, #1: 1	نَقْلِ مَالِ
u'نَقْلٌ مَالٌ':Added, #1: 1	نَقْلُ مَالِ
u'نقل مَالٌ':Added, #1: 1	نَقْلِ مَالِ
u'نَقْلٌ مَالٌ':Added, #2: 2	نَقْلَ مَالِ
u'نقل مَالٌ':Added, #2: 2	نَقْلَ مَالِ
u'نَقْلٌ مَالٌ':Added, #2: 2	نَقْلُ مَالِهِ
u'نقل مُبَادَلَةٌ':Added, #2: 2	نَقْلُ مَالِهِ
u'نَقْلٌ مُبَادَلَةٌ':Added, #1: 1	نَقْلُ الْمُبَادَلَةِ
u'نقل مُبَاشَرَةٌ':Added, #1: 1	نَقْلُ الْمُبَادَلَةِ
u'نَقْلٌ مُبَاشَرَةٌ':Added, #1: 1	نَقْلِ الْمُبَاشَرَةِ
u'نقل مَبْسُوطٌ':Added, #1: 1	نَقْلِ الْمُبَاشَرَةِ
u'نَقْلٌ مَبْسُوطٌ':Added, #1: 1	نَقْلَ الْمَبْسُوطِ
u'نقل مَتَاعٌ':Added, #1: 1	نَقْلَ الْمَبْسُوطِ
u'نَقْلٌ مَتَاعٌ':Added, #1: 1	نَقْلُ الْمَتَاعِ
u'نقل مَتَاعٌ':Added, #1: 1	نَقْلُ الْمَتَاعِ
u'نَقْلٌ مَتَاعٌ':Added, #1: 1	نَقْلُ مَتَاعِهِ
u'نقل مَتَاعٌ':Added, #1: 1	نَقْلُ مَتَاعِهِ
u'نَقْلٌ مَتَاعٌ':Added, #2: 2	نَقْلَ الْمَتَاعِ
u'نقل مَتَاعٌ':Added, #2: 2	نَقْلَ الْمَتَاعِ
u'نَقْلٌ مَتَاعٌ':Added, #2: 2	نَقْلَ مَتَاعِهِ
u'نقل مَتَاعٌ':Added, #2: 2	نَقْلَ مَتَاعِهِ
u'نَقْلٌ مَتَاعٌ':Added, #4: 4	نَقْلِ الْمَتَاعِ
u'نقل مُتَعَلِّقٌ':Added, #4: 4	نَقْلِ الْمَتَاعِ
u'نَقْلٌ مُتَعَلِّقٌ':Added, #1: 1	نَقْلَ مُتَعَلِّقِ
u'نَقَلَ مثل':Predicate, #1: 1	نَقْلَ مُتَعَلِّقِ
u'نَقَلَ مِثْلٌ':Predicate, #1: 1	نَقَلَ مِثْلَ
u'نقل مثل':Added, #1: 1	نَقَلَ مِثْلَ
u'نَقْلٌ مثل':Added, #1: 1	نَقْلُ مِثْلِ
u'نقل مِثْلٌ':Added, #1: 1	نَقْلُ مِثْلِ
u'نَقْلٌ مِثْلٌ':Added, #1: 1	نَقْلُ مِثْلِ
u'نقل مِثْلِيٌّ':Added, #1: 1	نَقْلُ مِثْلِ
u'نَقْلٌ مِثْلِيٌّ':Added, #2: 2	نَقْلُ الْمِثْلِيِّ
u'نقل مُجَرَّدٌ':Added, #2: 2	نَقْلُ الْمِثْلِيِّ
u'نَقْلٌ مُجَرَّدٌ':Added, #2: 2	نَقْلُ مُجَرَّدِ
u'نقل مَجْمُوعٌ':Added, #2: 2	نَقْلُ مُجَرَّدِ
u'نَقْلٌ مَجْمُوعٌ':Added, #1: 1	نَقْلُ الْمَجْمُوعِ
u'نقل مَحَاسِنُ':Added, #1: 1	نَقْلُ الْمَجْمُوعِ
u'نَقْلٌ مَحَاسِنُ':Added, #1: 1	نَقْلُ مَحَاسِنِهِ
u'نقل مُحِبٌّ':Added, #1: 1	نَقْلُ مَحَاسِنِهِ
u'نَقْلٌ مُحِبٌّ':Added, #1: 1	نَقْلُ الْمُحِبِّ
u'نَقَلَ مُحَقِّقٌ':Subject, #1: 1	نَقْلُ الْمُحِبِّ
u'نقل مَحَلٌّ':Added, #1: 1	نَقَلَ الْمُحَقِّقُ
u'نَقْلٌ مَحَلٌّ':Added, #1: 1	نَقْلِ الْمَحَلِّ
u'نَقَلَ مُحَمَّدٌ':Subject, #1: 1	نَقْلِ الْمَحَلِّ
u'نقل مُحَمَّدٌ':Added, #8: 8	نَقَلَ مُحَمَّدُ
u'نَقْلٌ مُحَمَّدٌ':Added, #3: 3	نَقْلِ مُحَمَّدِ
u'نَقَلَ مَدَنِيٌّ':Subject, #3: 3	نَقْلِ مُحَمَّدِ
u'نقل مَذَاهِبُ':Added, #1: 1	نَقَلَ الْمَدَنِيُّ
u'نَقْلٌ مَذَاهِبُ':Added, #1: 1	نَقْلِ مَذَاهِبِ
u'نقل مَذَاهِبُ':Added, #1: 1	نَقْلِ مَذَاهِبِ
u'نَقْلٌ مَذَاهِبُ':Added, #3: 3	نَقْلِ الْمَذَاهِبِ
u'نَقَلَ مَذْهَبٌ':Predicate, #3: 3	نَقْلِ الْمَذَاهِبِ
u'نقل مَذْهَبٌ':Added, #1: 1	نَقَلَ الْمَذْهَبَ
u'نَقْلٌ مَذْهَبٌ':Added, #1: 1	نَقْلُ مَذْهَبِ
u'نقل مَذْهَبٌ':Added, #1: 1	نَقْلُ مَذْهَبِ
u'نَقْلٌ مَذْهَبٌ':Added, #1: 1	نَقْلُ مَذْهَبِهِ
u'نقل مَذْهَبٌ':Added, #1: 1	نَقْلُ مَذْهَبِهِ
u'نَقْلٌ مَذْهَبٌ':Added, #2: 2	نَقْلُ الْمَذْهَبِ
u'نقل مَذْهَبٌ':Added, #2: 2	نَقْلُ الْمَذْهَبِ
u'نَقْلٌ مَذْهَبٌ':Added, #3: 3	نَقْلِ الْمَذْهَبِ
u'نقل مَذْهَبٌ':Added, #3: 3	نَقْلِ الْمَذْهَبِ
u'نَقْلٌ مَذْهَبٌ':Added, #4: 4	نَقْلِ مَذْهَبِ
u'نقل مَرِيضٌ':Added, #4: 4	نَقْلِ مَذْهَبِ
u'نَقْلٌ مَرِيضٌ':Added, #1: 1	نَقْلُ الْمَرِيضِ
u'نقل مُزْدَحِمٌ':Added, #1: 1	نَقْلُ الْمَرِيضِ
u'نَقْلٌ مُزْدَحِمٌ':Added, #1: 1	نَقْلُ الْمُزْدَحِمِ
u'نَقَلَ مَسْأَلَةٌ':Predicate, #1: 1	نَقْلُ الْمُزْدَحِمِ
u'نقل مَسْأَلَةٌ':Added, #1: 1	نَقَلَ مَسْأَلَةَ
u'نَقْلٌ مَسْأَلَةٌ':Added, #1: 1	نَقْلَ مَسْأَلَةٍ
u'نقل مَسْأَلَةٌ':Added, #1: 1	نَقْلَ مَسْأَلَةٍ
u'نَقْلٌ مَسْأَلَةٌ':Added, #3: 3	نَقْلِ الْمَسْأَلَةِ
u'نقل مَسَائِلُ':Added, #3: 3	نَقْلِ الْمَسْأَلَةِ
u'نَقْلٌ مَسَائِلُ':Added, #1: 1	نَقْلُ الْمَسَائِلِ
u'نقل مُسْتَغْرِب':Added, #1: 1	نَقْلُ الْمَسَائِلِ
u'نَقْلٌ مُسْتَغْرِب':Added, #1: 1	نَقْلَ مُسْتَغْرِبٍ
u'نقل مَسْجِدٌ':Added, #1: 1	نَقْلَ مُسْتَغْرِبٍ
u'نَقْلٌ مَسْجِدٌ':Added, #3: 3	نَقْلُ الْمَسْجِدِ
u'نَقَلَ مُسْلِمٌ':Subject, #3: 3	نَقْلُ الْمَسْجِدِ
u'نقل مُصْحَفٌ':Added, #1: 1	نَقَلَ مُسْلِمٌ
u'نَقْلٌ مُصْحَفٌ':Added, #1: 1	نَقْلِ الْمُصْحَفِ
u'نَقَلَ مُصَنِّفٌ':Subject, #1: 1	نَقْلِ الْمُصْحَفِ
u'نقل مُصَنِّفٌ':Added, #5: 5	نَقَلَ الْمُصَنِّفُ
u'نقل مُصَنِّفٌ':Added, #1: 1	نَقْلَ الْمُصَنِّفِ
u'نقل مُصَنِّفٌ':Added, #1: 1	نَقْلُ الْمُصَنِّفِ
u'نَقْلٌ مُصَنِّفٌ':Added, #1: 1	نَقْلِ الْمُصَنِّفِ
u'نَقْلٌ مُصَنِّفٌ':Added, #1: 1	نَقْلَ الْمُصَنِّفِ
u'نَقْلٌ مُصَنِّفٌ':Added, #1: 1	نَقْلُ الْمُصَنِّفِ
u'نقل مُطَالَبٌ':Added, #1: 1	نَقْلِ الْمُصَنِّفِ
u'نَقْلٌ مُطَالَبٌ':Added, #1: 1	نَقْلَ الْمُطَالَبَةِ
u'نقل مُطَالَبٌ':Added, #1: 1	نَقْلَ الْمُطَالَبَةِ
u'نَقْلٌ مُطَالَبٌ':Added, #3: 3	نَقْلُ الْمُطَالَبَةِ
u'نقل مُطَالَبَةٌ':Added, #3: 3	نَقْلُ الْمُطَالَبَةِ
u'نَقْلٌ مُطَالَبَةٌ':Added, #1: 1	نَقْلَ الْمُطَالَبَةِ
u'نقل مُطَالَبَةٌ':Added, #1: 1	نَقْلَ الْمُطَالَبَةِ
u'نَقْلٌ مُطَالَبَةٌ':Added, #3: 3	نَقْلُ الْمُطَالَبَةِ
u'نقل مُغَيَّرٌ':Added, #3: 3	نَقْلُ الْمُطَالَبَةِ
u'نَقْلٌ مُغَيَّرٌ':Added, #1: 1	نَقْلُ الْمُغَيَّرِ
u'نقل مَقَالَةٌ':Added, #1: 1	نَقْلُ الْمُغَيَّرِ
u'نَقْلٌ مَقَالَةٌ':Added, #1: 1	نَقْلِ مَقَالَتِهِ
u'نَقَلَ مَقْدِسِيٌّ':Predicate, #1: 1	نَقْلِ مَقَالَتِهِ
u'نَقَلَ مِلْكٌ':Predicate, #2: 2	نَقَلَ الْمَقْدِسِيَّ
u'نقل مِلْكٌ':Added, #1: 1	نَقَلَ مِلْكَ
u'نَقْلٌ مِلْكٌ':Added, #13: 13	نَقْلُ الْمِلْكِ
u'نقل مِلْكٌ':Added, #13: 13	نَقْلُ الْمِلْكِ
u'نَقْلٌ مِلْكٌ':Added, #14: 14	نَقْلَ الْمِلْكِ
u'نقل مِلْكٌ':Added, #14: 14	نَقْلَ الْمِلْكِ
u'نقل مِلْكٌ':Added, #1: 1	نَقْلَ مِلْكٍ
u'نَقْلٌ مِلْكٌ':Added, #1: 1	نَقْلِ مِلْكٍ
u'نَقْلٌ مِلْكٌ':Added, #1: 1	نَقْلَ مِلْكٍ
u'نقل مِلْكٌ':Added, #1: 1	نَقْلِ مِلْكٍ
u'نَقْلٌ مِلْكٌ':Added, #29: 29	نَقْلِ الْمِلْكِ
u'نقل مِلْكٌ':Added, #29: 29	نَقْلِ الْمِلْكِ
u'نَقْلٌ مِلْكٌ':Added, #2: 2	نَقْلُ مِلْكٍ
u'نقل مِلْكٌ':Added, #2: 2	نَقْلُ مِلْكٍ
u'نَقْلٌ مِلْكٌ':Added, #2: 2	نَقْلُ مِلْكِهِ
u'نقل مَلِكٌ':Added, #2: 2	نَقْلُ مِلْكِهِ
u'نَقْلٌ مَلِكٌ':Added, #3: 3	نَقْلِ الْمَلِكِ
u'نقل مَنَافِعُ':Added, #3: 3	نَقْلِ الْمَلِكِ
u'نَقْلٌ مَنَافِعُ':Added, #1: 1	نَقْلِ الْمَنَافِعِ
u'نقل مِنَحٌ':Added, #1: 1	نَقْلِ الْمَنَافِعِ
u'نَقْلٌ مِنَحٌ':Added, #1: 1	نَقْلِ الْمِنَحِ
u'نقل مَنْذُور':Added, #1: 1	نَقْلِ الْمِنَحِ
u'نَقْلٌ مَنْذُور':Added, #1: 1	نَقْلِ الْمَنْذُورَةِ
u'نَقَلَ مَنْعٌ':Predicate, #1: 1	نَقْلِ الْمَنْذُورَةِ
u'نقل مَنْفَعَةٌ':Added, #2: 2	نَقَلَ الْمَنْعَ
u'نَقْلٌ مَنْفَعَةٌ':Added, #1: 1	نَقْلِ الْمَنْفَعَةِ
u'نقل مَنْقُولٌ':Added, #1: 1	نَقْلِ الْمَنْفَعَةِ
u'نَقْلٌ مَنْقُولٌ':Added, #1: 1	نَقْلِ الْمَنْقُولِ
u'نقل مُوَاظَبَةٌ':Added, #1: 1	نَقْلِ الْمَنْقُولِ
u'نَقْلٌ مُوَاظَبَةٌ':Added, #1: 1	نَقْلِ الْمُوَاظَبَةِ
u'نَقَلَ مَوْثُوقٌ':Subject, #1: 1	نَقْلِ الْمُوَاظَبَةِ
u'نَقَلَ مُوَفَّقٌ':Subject, #1: 1	نَقَلَ مَوْثُوقٌ
u'نقل مَوْقُوفٌ':Added, #1: 1	نَقَلَ الْمُوَفَّقُ
u'نَقْلٌ مَوْقُوفٌ':Added, #1: 1	نَقْلِ الْمَوْقُوفِ
u'نَقَلَ مُؤَلِّفٌ':Subject, #1: 1	نَقْلِ الْمَوْقُوفِ
u'نقل مُؤَلِّفٌ':Added, #1: 1	نَقَلَ الْمُؤَلِّفُ
u'نَقْلٌ مُؤَلِّفٌ':Added, #1: 1	نَقْلَ الْمُؤَلِّفِ
u'نَقَلَ نَاسٌ':Subject, #1: 1	نَقْلَ الْمُؤَلِّفِ
u'نقل نَاسٌ':Added, #1: 1	نَقَلَ النَّاسُ
u'نَقْلٌ نَاسٌ':Added, #1: 1	نَقْلُ النَّاسِ
u'نقل نَحْوٌ':Added, #1: 1	نَقْلُ النَّاسِ
u'نَقْلٌ نَحْوٌ':Added, #1: 1	نَقْلُ نَحْوِ
u'نقل نَحْوٌ':Added, #1: 1	نَقْلُ نَحْوِ
u'نَقْلٌ نَحْوٌ':Added, #2: 2	نَقْلِ نَحْوِ
u'نقل نذر':Added, #2: 2	نَقْلِ نَحْوِ
u'نقل نذر':Added, #1: 1	نَقْلُ النَّذْرِ
u'نَقْلٌ نذر':Added, #1: 1	نَقْلِ النَّذْرِ
u'نَقْلٌ نذر':Added, #1: 1	نَقْلُ النَّذْرِ
u'نقل نَذْرٌ':Added, #1: 1	نَقْلِ النَّذْرِ
u'نقل نَذْرٌ':Added, #1: 1	نَقْلُ النَّذْرِ
u'نَقْلٌ نَذْرٌ':Added, #1: 1	نَقْلِ النَّذْرِ
u'نَقْلٌ نَذْرٌ':Added, #1: 1	نَقْلُ النَّذْرِ
u'نَقَلَ نَصٌّ':Predicate, #1: 1	نَقْلِ النَّذْرِ
u'نقل نَفَقَةٌ':Added, #1: 1	نَقَلَ النَّصَّ
u'نَقْلٌ نَفَقَةٌ':Added, #1: 1	نَقْلُ النَّفَقَةِ
u'نقل نَفْلٌ':Added, #1: 1	نَقْلُ النَّفَقَةِ
u'نَقْلٌ نَفْلٌ':Added, #2: 2	نَقْلُ نَفْلٍ
u'نقل نَقْضٌ':Added, #2: 2	نَقْلُ نَفْلٍ
u'نَقْلٌ نَقْضٌ':Added, #1: 1	نَقْلِ نَقْضِهِ
u'نقل نَهْيٌ':Added, #1: 1	نَقْلِ نَقْضِهِ
u'نَقْلٌ نَهْيٌ':Added, #1: 1	نَقْلُ النَّهْيِ
u'نقل نَوَادِرُ':Added, #1: 1	نَقْلُ النَّهْيِ
u'نَقْلٌ نَوَادِرُ':Added, #1: 1	نَقْلِ النَّوَادِرِ
u'نقل نَوْعٌ':Added, #1: 1	نَقْلِ النَّوَادِرِ
u'نَقْلٌ نَوْعٌ':Added, #3: 3	نَقْلُ نَوْعِ
u'نَقَلَ نَوَوِيٌّ':Subject, #3: 3	نَقْلُ نَوْعِ
u'نقل نِيَّةٌ':Added, #16: 16	نَقَلَ النَّوَوِيُّ
u'نَقْلٌ نِيَّةٌ':Added, #1: 1	نَقْلُ النِّيَّةِ
u'نقل هشام':Added, #1: 1	نَقْلُ النِّيَّةِ
u'نَقْلٌ هشام':Added, #1: 1	نَقْلُ هِشَامٍ
u'نقل هِشَامٌ':Added, #1: 1	نَقْلُ هِشَامٍ
u'نَقْلٌ هِشَامٌ':Added, #1: 1	نَقْلُ هِشَامٍ
u'نقل واحد':Added, #1: 1	نَقْلُ هِشَامٍ
u'نَقْلٌ واحد':Added, #1: 1	نَقْلِ الْوَاحِدِ
u'نقل وَاحِدٌ':Added, #1: 1	نَقْلِ الْوَاحِدِ
u'نَقْلٌ وَاحِدٌ':Added, #1: 1	نَقْلِ الْوَاحِدِ
u'نقل واحد':Added, #1: 1	نَقْلِ الْوَاحِدِ
u'نَقْلٌ واحد':Added, #1: 1	نَقْلُ وَاحِدٍ
u'نقل وَاحِدٌ':Added, #1: 1	نَقْلُ وَاحِدٍ
u'نَقْلٌ وَاحِدٌ':Added, #1: 1	نَقْلُ وَاحِدٍ
u'نقل واحد':Added, #1: 1	نَقْلُ وَاحِدٍ
u'نَقْلٌ واحد':Added, #2: 2	نَقْلُ الْوَاحِدِ
u'نقل وَاحِدٌ':Added, #2: 2	نَقْلُ الْوَاحِدِ
u'نَقْلٌ وَاحِدٌ':Added, #2: 2	نَقْلُ الْوَاحِدِ
u'نقل وَثِيقٌ':Added, #2: 2	نَقْلُ الْوَاحِدِ
u'نَقْلٌ وَثِيقٌ':Added, #1: 1	نَقْلَ الْوَثِيقَةِ
u'نقل وَثِيقٌ':Added, #1: 1	نَقْلَ الْوَثِيقَةِ
u'نَقْلٌ وَثِيقٌ':Added, #2: 2	نَقْلِ الْوَثِيقَةِ
u'نقل وَجْهٌ':Added, #2: 2	نَقْلِ الْوَثِيقَةِ
u'نقل وَجْهٌ':Added, #1: 1	نَقْلُ الْوَجْهَيْنِ
u'نَقْلٌ وَجْهٌ':Added, #1: 1	نَقْلِ الْوَجْهَيْنِ
u'نَقْلٌ وَجْهٌ':Added, #1: 1	نَقْلُ الْوَجْهَيْنِ
u'نَقَلَ وُجُوبٌ':Predicate, #1: 1	نَقْلِ الْوَجْهَيْنِ
u'نقل وَصْفٌ':Added, #1: 1	نَقَلَ وُجُوبَ
u'نَقْلٌ وَصْفٌ':Added, #1: 1	نَقْلَ الْوَصْفِ
u'نقل وَصِيٌّ':Added, #1: 1	نَقْلَ الْوَصْفِ
u'نَقْلٌ وَصِيٌّ':Added, #1: 1	نَقْلِ الْوَصِيَّةِ
u'نقل وَصِيَّةٌ':Added, #1: 1	نَقْلِ الْوَصِيَّةِ
u'نَقْلٌ وَصِيَّةٌ':Added, #1: 1	نَقْلِ الْوَصِيَّةِ
u'نَقَلَ وَقْفٌ':Predicate, #1: 1	نَقْلِ الْوَصِيَّةِ
u'نَقَلَ وِلاَيَةٌ':Predicate, #1: 1	نَقَلَ الْوَقْفَ
u'نقل وِلاَيَةٌ':Added, #1: 1	نَقَلَ الْوِلَايَةَ
u'نَقْلٌ وِلاَيَةٌ':Added, #1: 1	نَقْلَ الْوِلَايَةِ
u'نقل وِلاَيَةٌ':Added, #1: 1	نَقْلَ الْوِلَايَةِ
u'نَقْلٌ وِلاَيَةٌ':Added, #1: 1	نَقْلُ وِلَايَةِ
u'نقل وِلاَيَةٌ':Added, #1: 1	نَقْلُ وِلَايَةِ
u'نَقْلٌ وِلاَيَةٌ':Added, #2: 2	نَقْلُ الْوِلَايَةِ
u'نقل ولد':Added, #2: 2	نَقْلُ الْوِلَايَةِ
u'نَقْلٌ ولد':Added, #1: 1	نَقْلَ الْوَلَدِ
u'نقل وَلَدٌ':Added, #1: 1	نَقْلَ الْوَلَدِ
u'نَقْلٌ وَلَدٌ':Added, #1: 1	نَقْلَ الْوَلَدِ
u'نقل ولد':Added, #1: 1	نَقْلَ الْوَلَدِ
u'نَقْلٌ ولد':Added, #2: 2	نَقْلُ الْوَلَدِ
u'نقل وَلَدٌ':Added, #2: 2	نَقْلُ الْوَلَدِ
u'نَقْلٌ وَلَدٌ':Added, #2: 2	نَقْلُ الْوَلَدِ
u'نقل يَدٌ':Added, #2: 2	نَقْلُ الْوَلَدِ
u'نَقْلٌ يَدٌ':Added, #2: 2	نَقْلُ يَدِهِ
u'نقل يَدٌ':Added, #2: 2	نَقْلُ يَدِهِ
u'نقل يَدٌ':Added, #3: 3	نَقْلَ الْيَدِ
u'نَقْلٌ يَدٌ':Added, #3: 3	نَقْلُ الْيَدِ
u'نَقْلٌ يَدٌ':Added, #3: 3	نَقْلَ الْيَدِ
u'نقل يَدٌ':Added, #3: 3	نَقْلُ الْيَدِ
u'نَقْلٌ يَدٌ':Added, #8: 8	نَقْلِ الْيَدِ
u'نَقَلَ يَعْقُوبٌ':Subject, #8: 8	نَقْلِ الْيَدِ
u'نقل يَمِينٌ':Added, #5: 5	نَقَلَ يَعْقُوبُ
u'نقل يَمِينٌ':Added, #1: 1	نَقْلَ الْيَمِينِ
u'نَقْلٌ يَمِينٌ':Added, #1: 1	نَقْلِ الْيَمِينِ
u'نَقْلٌ يَمِينٌ':Added, #1: 1	نَقْلَ الْيَمِينِ
u'نقل يَمِينٌ':Added, #1: 1	نَقْلِ الْيَمِينِ
u'نَقْلٌ يَمِينٌ':Added, #2: 2	نَقْلُ الْيَمِينِ
u'نقمة ظاهِرٌ':Added, #2: 2	نَقْلُ الْيَمِينِ
u'نِقْمَةٌ ظاهِرٌ':Added, #1: 1	نِقْمَةٍ ظَاهِرَةٍ
u'نقمة ظاهِرَة':Added, #1: 1	نِقْمَةٍ ظَاهِرَةٍ
u'نِقْمَةٌ ظاهِرَة':Added, #1: 1	نِقْمَةٍ ظَاهِرَةٍ
u'نُقُودٌ بَلَدٌ':Added, #1: 1	نِقْمَةٍ ظَاهِرَةٍ
u'نُقُودٌ مَوَاهِبُ':Added, #2: 2	نُقُودِ الْبَلَدِ
u'نُقُولٌ أَصْحَابٌ':Added, #1: 1	نُقُودِ مَوَاهِبِهِ
u'نَقَّى أرْضٌ':Predicate, #1: 1	نُقُولَ الْأَصْحَابِ
u'نَقَّى رَأْسٌ':Predicate, #1: 1	نَقَّى الْأَرْضَ
u'نَقَّى قُرُوحٌ':Predicate, #1: 1	نَقَّى الرَّأْسَ
u'نكاح أَبٌ':Added, #1: 1	نَقَّى الْقُرُوحَ
u'نِكَاحٌ أَبٌ':Added, #1: 1	نِكَاحَ الْأَبِ
u'نكاح أَبٌ':Added, #1: 1	نِكَاحَ الْأَبِ
u'نِكَاحٌ أَبٌ':Added, #4: 4	نِكَاحُ الْأَبِ
u'نكاح أَبٌ':Added, #4: 4	نِكَاحُ الْأَبِ
u'نِكَاحٌ أَبٌ':Added, #8: 8	نِكَاحِ الْأَبِ
u'نكاح آباءٌ':Added, #8: 8	نِكَاحِ الْأَبِ
u'نِكَاحٌ آباءٌ':Added, #1: 1	نِكَاحِ الْآبَاءِ
u'نكاح أَبْعَدُ':Added, #1: 1	نِكَاحِ الْآبَاءِ
u'نِكَاحٌ أَبْعَدُ':Added, #3: 3	نِكَاحُ الْأَبْعَدِ
u'نكاح أَبْكارٌ':Added, #3: 3	نِكَاحُ الْأَبْعَدِ
u'نِكَاحٌ أَبْكارٌ':Added, #1: 1	نِكَاحِ الْأَبْكَارِ
u'نكاح اِبْنٌ':Added, #1: 1	نِكَاحِ الْأَبْكَارِ
u'نِكَاحٌ اِبْنٌ':Added, #1: 1	نِكَاحُ ابْنِ
u'نكاح اِبْنٌ':Added, #1: 1	نِكَاحُ ابْنِ
u'نِكَاحٌ اِبْنٌ':Added, #1: 1	نِكَاحُ ابْنِهِ
u'نكاح اِبْنٌ':Added, #1: 1	نِكَاحُ ابْنِهِ
u'نِكَاحٌ اِبْنٌ':Added, #3: 3	نِكَاحِ ابْنِهِ
u'نكاح اِبْنٌ':Added, #3: 3	نِكَاحِ ابْنِهِ
u'نِكَاحٌ اِبْنٌ':Added, #4: 4	نِكَاحِ ابْنِ
u'نكاح أَبْنَاءٌ':Added, #4: 4	نِكَاحِ ابْنِ
u'نِكَاحٌ أَبْنَاءٌ':Added, #1: 1	نِكَاحِ الْأَبْنَاءِ
u'نكاح اِبْنَة':Added, #1: 1	نِكَاحِ الْأَبْنَاءِ
u'نكاح اِبْنَة':Added, #1: 1	نِكَاحَ ابْنَتِهِ
u'نِكَاحٌ اِبْنَة':Added, #1: 1	نِكَاحِ ابْنَتِهِ
u'نِكَاحٌ اِبْنَة':Added, #1: 1	نِكَاحَ ابْنَتِهِ
u'نكاح اِبْنَة':Added, #1: 1	نِكَاحِ ابْنَتِهِ
u'نِكَاحٌ اِبْنَة':Added, #2: 2	نِكَاحَ ابْنَةِ
u'نكاح أَجْنَاسٌ':Added, #2: 2	نِكَاحَ ابْنَةِ
u'نِكَاحٌ أَجْنَاسٌ':Added, #1: 1	نِكَاحِ الْأَجْنَاسِ
u'نكاح أَجْنَبِيٌّ':Added, #1: 1	نِكَاحِ الْأَجْنَاسِ
u'نِكَاحٌ أَجْنَبِيٌّ':Added, #1: 1	نِكَاحِ أَجْنَبِيَّةٍ
u'نكاح أَجْنَبِيٌّ':Added, #1: 1	نِكَاحِ أَجْنَبِيَّةٍ
u'نِكَاحٌ أَجْنَبِيٌّ':Added, #1: 1	نِكَاحَ الْأَجْنَبِيَّاتِ
u'نكاح أَجْنَبِيٌّ':Added, #1: 1	نِكَاحَ الْأَجْنَبِيَّاتِ
u'نِكَاحٌ أَجْنَبِيٌّ':Added, #3: 3	نِكَاحِ الْأَجْنَبِيَّةِ
u'نكاح أحَدٌ':Added, #3: 3	نِكَاحِ الْأَجْنَبِيَّةِ
u'نِكَاحٌ أحَدٌ':Added, #1: 1	نِكَاحُ أَحَدٍ
u'نكاح أحَدٌ':Added, #1: 1	نِكَاحُ أَحَدٍ
u'نِكَاحٌ أحَدٌ':Added, #2: 2	نِكَاحُ أَحَدِ
u'نكاح أحَدٌ':Added, #2: 2	نِكَاحُ أَحَدِ
u'نِكَاحٌ أحَدٌ':Added, #3: 3	نِكَاحَ أَحَدِ
u'نكاح أَحْرارٌ':Added, #3: 3	نِكَاحَ أَحَدِ
u'نِكَاحٌ أَحْرارٌ':Added, #1: 1	نِكَاحِ الْأَحْرَارِ
u'نكاح أَخٌ':Added, #1: 1	نِكَاحِ الْأَحْرَارِ
u'نكاح أَخٌ':Added, #1: 1	نِكَاحَ الْأَخِ
u'نِكَاحٌ أَخٌ':Added, #1: 1	نِكَاحِ الْأَخِ
u'نِكَاحٌ أَخٌ':Added, #1: 1	نِكَاحَ الْأَخِ
u'نكاح أُخْتٌ':Added, #1: 1	نِكَاحِ الْأَخِ
u'نِكَاحٌ أُخْتٌ':Added, #13: 13	نِكَاحِ الْأُخْتِ
u'نكاح أُخْتٌ':Added, #13: 13	نِكَاحِ الْأُخْتِ
u'نكاح أُخْتٌ':Added, #1: 1	نِكَاحُ أُخْتٍ
u'نِكَاحٌ أُخْتٌ':Added, #1: 1	نِكَاحُ أُخْتِ
u'نِكَاحٌ أُخْتٌ':Added, #1: 1	نِكَاحُ أُخْتٍ
u'نكاح أُخْتٌ':Added, #1: 1	نِكَاحُ أُخْتِ
u'نِكَاحٌ أُخْتٌ':Added, #1: 1	نِكَاحَ أُخْتِهِ
u'نكاح أُخْتٌ':Added, #1: 1	نِكَاحَ أُخْتِهِ
u'نِكَاحٌ أُخْتٌ':Added, #1: 1	نِكَاحَ الْأُخْتَيْنِ
u'نكاح أُخْتٌ':Added, #1: 1	نِكَاحَ الْأُخْتَيْنِ
u'نِكَاحٌ أُخْتٌ':Added, #2: 2	نِكَاحِ أُخْتِهِ
u'نكاح أُخْتٌ':Added, #2: 2	نِكَاحِ أُخْتِهِ
u'نِكَاحٌ أُخْتٌ':Added, #2: 2	نِكَاحَ أُخْتَيْنِ
u'نكاح أُخْتٌ':Added, #2: 2	نِكَاحَ أُخْتَيْنِ
u'نِكَاحٌ أُخْتٌ':Added, #3: 3	نِكَاحِ أُخْتِ
u'نكاح أُخْتٌ':Added, #3: 3	نِكَاحِ أُخْتِ
u'نِكَاحٌ أُخْتٌ':Added, #5: 5	نِكَاحِ الْأُخْتَيْنِ
u'نكاح أُخْتٌ':Added, #5: 5	نِكَاحِ الْأُخْتَيْنِ
u'نكاح أُخْتٌ':Added, #8: 8	نِكَاحَ الْأُخْتِ
u'نِكَاحٌ أُخْتٌ':Added, #8: 8	نِكَاحُ الْأُخْتِ
u'نِكَاحٌ أُخْتٌ':Added, #8: 8	نِكَاحَ الْأُخْتِ
u'نكاح أُخَرٌ':Added, #8: 8	نِكَاحُ الْأُخْتِ
u'نِكَاحٌ أُخَرٌ':Added, #1: 1	نِكَاحُ الْأُخَرِ
u'نكاح أخرَس':Added, #1: 1	نِكَاحُ الْأُخَرِ
u'نِكَاحٌ أخرَس':Added, #2: 2	نِكَاحُ الْأَخْرَسِ
u'نكاح أَخِيرٌ':Added, #2: 2	نِكَاحُ الْأَخْرَسِ
u'نِكَاحٌ أَخِيرٌ':Added, #1: 1	نِكَاحُ الْأَخِيرَةِ
u'نكاح أَرْبَعُ':Added, #1: 1	نِكَاحُ الْأَخِيرَةِ
u'نِكَاحٌ أَرْبَعُ':Added, #11: 11	نِكَاحُ الْأَرْبَعِ
u'نكاح أَرْبَعُ':Added, #11: 11	نِكَاحُ الْأَرْبَعِ
u'نِكَاحٌ أَرْبَعُ':Added, #4: 4	نِكَاحُ أَرْبَعِ
u'نكاح أَرْبَعُ':Added, #4: 4	نِكَاحُ أَرْبَعِ
u'نِكَاحٌ أَرْبَعُ':Added, #5: 5	نِكَاحِ الْأَرْبَعِ
u'نكاح أَرْبَعُ':Added, #5: 5	نِكَاحِ الْأَرْبَعِ
u'نِكَاحٌ أَرْبَعُ':Added, #6: 6	نِكَاحَ الْأَرْبَعِ
u'نكاح أَرْبَعَةٌ':Added, #6: 6	نِكَاحَ الْأَرْبَعِ
u'نِكَاحٌ أَرْبَعَةٌ':Added, #1: 1	نِكَاحِ أَرْبَعَةٍ
u'نكاح أَزْواجٌ':Added, #1: 1	نِكَاحِ أَرْبَعَةٍ
u'نِكَاحٌ أَزْواجٌ':Added, #1: 1	نِكَاحِ أَزْوَاجِ
u'نكاح أَزْواجٌ':Added, #1: 1	نِكَاحِ أَزْوَاجِ
u'نِكَاحٌ أَزْواجٌ':Added, #1: 1	نِكَاحَ أَزْوَاجِهِ
u'نكاح أَزْواجٌ':Added, #1: 1	نِكَاحَ أَزْوَاجِهِ
u'نِكَاحٌ أَزْواجٌ':Added, #2: 2	نِكَاحَ أَزْوَاجِ
u'نكاح إِسْلامٌ':Added, #2: 2	نِكَاحَ أَزْوَاجِ
u'نِكَاحٌ إِسْلامٌ':Added, #1: 1	نِكَاحَ الإِسْلاَمِ
u'نكاح أَسيرٌ':Added, #1: 1	نِكَاحَ الإِسْلاَمِ
u'نِكَاحٌ أَسيرٌ':Added, #1: 1	نِكَاحُ الْأَسِيرِ
u'نكاح أَسيرٌ':Added, #1: 1	نِكَاحُ الْأَسِيرِ
u'نِكَاحٌ أَسيرٌ':Added, #1: 1	نِكَاحِ الْأَسِيرَةِ
u'نكاح أصل':Added, #1: 1	نِكَاحِ الْأَسِيرَةِ
u'نكاح أًصْلٌ':Added, #3: 3	نِكَاحِ الْأَصْلِ
u'نِكَاحٌ أصل':Added, #3: 3	نِكَاحِ الْأَصْلِ
u'نِكَاحٌ أًصْلٌ':Added, #3: 3	نِكَاحِ الْأَصْلِ
u'نكاح أَكْثَرُ':Added, #3: 3	نِكَاحِ الْأَصْلِ
u'نِكَاحٌ أَكْثَرُ':Added, #1: 1	نِكَاحَ أَكْثَرِ
u'نكاح أكفاء':Added, #1: 1	نِكَاحَ أَكْثَرِ
u'نِكَاحٌ أكفاء':Added, #1: 1	نِكَاحِ الْأَكْفَاءِ
u'نكاح الْمَرْأَةُ':Added, #1: 1	نِكَاحِ الْأَكْفَاءِ
u'نِكَاحٌ الْمَرْأَةُ':Added, #1: 1	نِكَاحَ الْمَرْأَةِ
u'نكاح الْمَرْأَةُ':Added, #1: 1	نِكَاحَ الْمَرْأَةِ
u'نِكَاحٌ الْمَرْأَةُ':Added, #5: 5	نِكَاحُ الْمَرْأَةِ
u'نكاح الْمَرْأَةُ':Added, #5: 5	نِكَاحُ الْمَرْأَةِ
u'نِكَاحٌ الْمَرْأَةُ':Added, #9: 9	نِكَاحِ الْمَرْأَةِ
u'نكاح أُمٌّ':Added, #9: 9	نِكَاحِ الْمَرْأَةِ
u'نِكَاحٌ أُمٌّ':Added, #1: 1	نِكَاحِ الْأُمِّ
u'نكاح أُمٌّ':Added, #1: 1	نِكَاحِ الْأُمِّ
u'نِكَاحٌ أُمٌّ':Added, #2: 2	نِكَاحَ الْأُمِّ
u'نكاح أُمٌّ':Added, #2: 2	نِكَاحَ الْأُمِّ
u'نِكَاحٌ أُمٌّ':Added, #2: 2	نِكَاحُ أُمِّ
u'نكاح أُمٌّ':Added, #2: 2	نِكَاحُ أُمِّ
u'نِكَاحٌ أُمٌّ':Added, #4: 4	نِكَاحِ أُمِّ
u'نكاح أُمٌّ':Added, #4: 4	نِكَاحِ أُمِّ
u'نِكَاحٌ أُمٌّ':Added, #5: 5	نِكَاحُ الْأُمِّ
u'نكاح إمَاءٌ':Added, #5: 5	نِكَاحُ الْأُمِّ
u'نِكَاحٌ إمَاءٌ':Added, #1: 1	نِكَاحَ الإِمَاءِ
u'نكاح إمَاءٌ':Added, #1: 1	نِكَاحَ الإِمَاءِ
u'نكاح إمَاءٌ':Added, #1: 1	نِكَاحَ إمَاءِ
u'نكاح إمَاءٌ':Added, #1: 1	نِكَاحُ إمَاءٍ
u'نكاح إمَاءٌ':Added, #1: 1	نِكَاحَ إِمَاءِ
u'نكاح إمَاءٌ':Added, #1: 1	نِكَاحُ إِمَاءِ
u'نِكَاحٌ إمَاءٌ':Added, #1: 1	نِكَاحِ إِمَاءِ
u'نِكَاحٌ إمَاءٌ':Added, #1: 1	نِكَاحَ إمَاءِ
u'نِكَاحٌ إمَاءٌ':Added, #1: 1	نِكَاحُ إمَاءٍ
u'نِكَاحٌ إمَاءٌ':Added, #1: 1	نِكَاحَ إِمَاءِ
u'نِكَاحٌ إمَاءٌ':Added, #1: 1	نِكَاحُ إِمَاءِ
u'نكاح إمَاءٌ':Added, #1: 1	نِكَاحِ إِمَاءِ
u'نِكَاحٌ إمَاءٌ':Added, #25: 25	نِكَاحُ الْإِمَاءِ
u'نكاح إمَاءٌ':Added, #25: 25	نِكَاحُ الْإِمَاءِ
u'نِكَاحٌ إمَاءٌ':Added, #2: 2	نِكَاحُ الإِمَاءِ
u'نكاح إمَاءٌ':Added, #2: 2	نِكَاحُ الإِمَاءِ
u'نكاح إمَاءٌ':Added, #3: 3	نِكَاحِ الإِمَاءِ
u'نِكَاحٌ إمَاءٌ':Added, #3: 3	نِكَاحَ الْإِمَاءِ
u'نِكَاحٌ إمَاءٌ':Added, #3: 3	نِكَاحِ الإِمَاءِ
u'نكاح إمَاءٌ':Added, #3: 3	نِكَاحَ الْإِمَاءِ
u'نِكَاحٌ إمَاءٌ':Added, #9: 9	نِكَاحِ الْإِمَاءِ
u'نكاح أمَةٌ':Added, #9: 9	نِكَاحِ الْإِمَاءِ
u'نِكَاحٌ أمَةٌ':Added, #11: 11	نِكَاحُ أَمَةٍ
u'نكاح أمَةٌ':Added, #11: 11	نِكَاحُ أَمَةٍ
u'نِكَاحٌ أمَةٌ':Added, #1: 1	نِكَاحِ الأَمَةِ
u'نكاح أمَةٌ':Added, #1: 1	نِكَاحِ الأَمَةِ
u'نكاح أمَةٌ':Added, #1: 1	نِكَاحَ أَمَةٍ
u'نِكَاحٌ أمَةٌ':Added, #1: 1	نِكَاحِ أَمَةِ
u'نِكَاحٌ أمَةٌ':Added, #1: 1	نِكَاحَ أَمَةٍ
u'نكاح أمَةٌ':Added, #1: 1	نِكَاحِ أَمَةِ
u'نِكَاحٌ أمَةٌ':Added, #1: 1	نِكَاحُ أَمَتِهِ
u'نكاح أمَةٌ':Added, #1: 1	نِكَاحُ أَمَتِهِ
u'نِكَاحٌ أمَةٌ':Added, #25: 25	نِكَاحَ الْأَمَةِ
u'نكاح أمَةٌ':Added, #25: 25	نِكَاحَ الْأَمَةِ
u'نِكَاحٌ أمَةٌ':Added, #2: 2	نِكَاحُ الأَمَةِ
u'نكاح أمَةٌ':Added, #2: 2	نِكَاحُ الأَمَةِ
u'نِكَاحٌ أمَةٌ':Added, #2: 2	نِكَاحِ أَمَتِهِ
u'نكاح أمَةٌ':Added, #2: 2	نِكَاحِ أَمَتِهِ
u'نِكَاحٌ أمَةٌ':Added, #6: 6	نِكَاحِ أَمَةٍ
u'نكاح أمَةٌ':Added, #6: 6	نِكَاحِ أَمَةٍ
u'نِكَاحٌ أمَةٌ':Added, #72: 72	نِكَاحِ الْأَمَةِ
u'نكاح أمَةٌ':Added, #72: 72	نِكَاحِ الْأَمَةِ
u'نِكَاحٌ أمَةٌ':Added, #7: 7	نِكَاحُ أَمَةِ
u'نكاح أمَةٌ':Added, #7: 7	نِكَاحُ أَمَةِ
u'نِكَاحٌ أمَةٌ':Added, #84: 84	نِكَاحُ الْأَمَةِ
u'نكاح اِمْرَأَةٌ':Added, #84: 84	نِكَاحُ الْأَمَةِ
u'نِكَاحٌ اِمْرَأَةٌ':Added, #13: 13	نِكَاحِ امْرَأَةٍ
u'نكاح اِمْرَأَةٌ':Added, #13: 13	نِكَاحِ امْرَأَةٍ
u'نكاح اِمْرَأَةٌ':Added, #1: 1	نِكَاح امْرَأَةٍ
u'نِكَاحٌ اِمْرَأَةٌ':Added, #1: 1	نِكَاحَ امْرَأَةِ
u'نِكَاحٌ اِمْرَأَةٌ':Added, #1: 1	نِكَاح امْرَأَةٍ
u'نكاح اِمْرَأَةٌ':Added, #1: 1	نِكَاحَ امْرَأَةِ
u'نِكَاحٌ اِمْرَأَةٌ':Added, #2: 2	نِكَاحِ امْرَأَةِ
u'نكاح اِمْرَأَةٌ':Added, #2: 2	نِكَاحِ امْرَأَةِ
u'نِكَاحٌ اِمْرَأَةٌ':Added, #3: 3	نِكَاحَ امْرَأَتِهِ
u'نكاح اِمْرَأَةٌ':Added, #3: 3	نِكَاحَ امْرَأَتِهِ
u'نِكَاحٌ اِمْرَأَةٌ':Added, #52: 52	نِكَاحَ امْرَأَةٍ
u'نكاح اِمْرَأَةٌ':Added, #52: 52	نِكَاحَ امْرَأَةٍ
u'نِكَاحٌ اِمْرَأَةٌ':Added, #5: 5	نِكَاحُ امْرَأَةٍ
u'نكاح أُمَّهَاتٌ':Added, #5: 5	نِكَاحُ امْرَأَةٍ
u'نِكَاحٌ أُمَّهَاتٌ':Added, #3: 3	نِكَاحَ الْأُمَّهَاتِ
u'نكاح أهْلٌ':Added, #3: 3	نِكَاحَ الْأُمَّهَاتِ
u'نِكَاحٌ أهْلٌ':Added, #11: 11	نِكَاحِ أَهْلِ
u'نكاح أهْلٌ':Added, #11: 11	نِكَاحِ أَهْلِ
u'نِكَاحٌ أهْلٌ':Added, #1: 1	نِكَاحُ أَهْلِ
u'نكاح أهْلٌ':Added, #1: 1	نِكَاحُ أَهْلِ
u'نِكَاحٌ أهْلٌ':Added, #2: 2	نِكَاحَ أَهْلِ
u'نكاح أَوَّلُ':Added, #2: 2	نِكَاحَ أَهْلِ
u'نِكَاحٌ أَوَّلُ':Added, #2: 2	نِكَاحِ الْأَوَّلِ
u'نكاح أَوَّلُ':Added, #2: 2	نِكَاحِ الْأَوَّلِ
u'نِكَاحٌ أَوَّلُ':Added, #3: 3	نِكَاحَ الْأَوَّلِ
u'نكاح أَوَّلُ':Added, #3: 3	نِكَاحَ الْأَوَّلِ
u'نِكَاحٌ أَوَّلُ':Added, #4: 4	نِكَاحُ الْأَوَّلِ
u'نكاح أولى':Added, #4: 4	نِكَاحُ الْأَوَّلِ
u'نكاح أوْلَى':Added, #1: 1	نِكَاحُ الْأُولَيَيْنِ
u'نِكَاحٌ أولى':Added, #1: 1	نِكَاحُ الْأُولَيَيْنِ
u'نِكَاحٌ أوْلَى':Added, #1: 1	نِكَاحُ الْأُولَيَيْنِ
u'نكاح أَوْلِيَاءُ':Added, #1: 1	نِكَاحُ الْأُولَيَيْنِ
u'نِكَاحٌ أَوْلِيَاءُ':Added, #1: 1	نِكَاحِ الْأَوْلِيَاءِ
u'نكاح بَاطِلٌ':Added, #1: 1	نِكَاحِ الْأَوْلِيَاءِ
u'نِكَاحٌ بَاطِلٌ':Added, #3: 3	نِكَاحٍ بَاطِلٍ
u'نكاح باقَةٌ':Added, #3: 3	نِكَاحٍ بَاطِلٍ
u'نِكَاحٌ باقَةٌ':Added, #4: 4	نِكَاحُ الْبَاقِيَاتِ
u'نكاح باقِي':Added, #4: 4	نِكَاحُ الْبَاقِيَاتِ
u'نِكَاحٌ باقِي':Added, #1: 1	نِكَاحِ الْبَاقِيَتَيْنِ
u'نكاح باقِي':Added, #1: 1	نِكَاحِ الْبَاقِيَتَيْنِ
u'نِكَاحٌ باقِي':Added, #4: 4	نِكَاحُ الْبَاقِيَاتِ
u'نكاح باقِيَةٌ':Added, #4: 4	نِكَاحُ الْبَاقِيَاتِ
u'نِكَاحٌ باقِيَةٌ':Added, #4: 4	نِكَاحُ الْبَاقِيَاتِ
u'نكاح بَائِنٌ':Added, #4: 4	نِكَاحُ الْبَاقِيَاتِ
u'نكاح بَائِنٌ':Added, #2: 2	نِكَاحَ الْبَائِنِ
u'نِكَاحٌ بَائِنٌ':Added, #2: 2	نِكَاحِ الْبَائِنِ
u'نِكَاحٌ بَائِنٌ':Added, #2: 2	نِكَاحَ الْبَائِنِ
u'نكاح بَعْضٌ':Added, #2: 2	نِكَاحِ الْبَائِنِ
u'نِكَاحٌ بَعْضٌ':Added, #1: 1	نِكَاحِ بَعْضِ
u'نكاح بَقِيَّةٌ':Added, #1: 1	نِكَاحِ بَعْضِ
u'نِكَاحٌ بَقِيَّةٌ':Added, #1: 1	نِكَاحُ الْبَقِيَّةِ
u'نكاح بِكْرٌ':Added, #1: 1	نِكَاحُ الْبَقِيَّةِ
u'نِكَاحٌ بِكْرٌ':Added, #1: 1	نِكَاحُ الْبِكْرِ
u'نكاح بِكْرٌ':Added, #1: 1	نِكَاحُ الْبِكْرِ
u'نِكَاحٌ بِكْرٌ':Added, #3: 3	نِكَاحِ الْبِكْرِ
u'نكاح بِكْرٌ':Added, #3: 3	نِكَاحِ الْبِكْرِ
u'نِكَاحٌ بِكْرٌ':Added, #3: 3	نِكَاحَ بِكْرٍ
u'نكاح بناتٌ':Added, #3: 3	نِكَاحَ بِكْرٍ
u'نكاح بناتٌ':Added, #1: 1	نِكَاحُ بَنَاتٍ
u'نِكَاحٌ بناتٌ':Added, #1: 1	نِكَاحُ بَنَاتِ
u'نِكَاحٌ بناتٌ':Added, #1: 1	نِكَاحُ بَنَاتٍ
u'نكاح بِنْتٌ':Added, #1: 1	نِكَاحُ بَنَاتِ
u'نِكَاحٌ بِنْتٌ':Added, #13: 13	نِكَاحُ الْبِنْتِ
u'نكاح بِنْتٌ':Added, #13: 13	نِكَاحُ الْبِنْتِ
u'نِكَاحٌ بِنْتٌ':Added, #1: 1	نِكَاحِ الْبِنْتِ
u'نكاح بِنْتٌ':Added, #1: 1	نِكَاحِ الْبِنْتِ
u'نِكَاحٌ بِنْتٌ':Added, #1: 1	نِكَاحُ بِنْتِهِ
u'نكاح بِنْتٌ':Added, #1: 1	نِكَاحُ بِنْتِهِ
u'نِكَاحٌ بِنْتٌ':Added, #2: 2	نِكَاحَ الْبِنْتِ
u'نكاح بِنْتٌ':Added, #2: 2	نِكَاحَ الْبِنْتِ
u'نِكَاحٌ بِنْتٌ':Added, #2: 2	نِكَاحَ بِنْتِ
u'نكاح بِنْتٌ':Added, #2: 2	نِكَاحَ بِنْتِ
u'نِكَاحٌ بِنْتٌ':Added, #3: 3	نِكَاحُ بِنْتِ
u'نكاح تَاسِعٌ':Added, #3: 3	نِكَاحُ بِنْتِ
u'نِكَاحٌ تَاسِعٌ':Added, #4: 4	نِكَاحُ التَّاسِعَةِ
u'نكاح تَحْكِيمٌ':Added, #4: 4	نِكَاحُ التَّاسِعَةِ
u'نكاح تَحْكِيمٌ':Added, #1: 1	نِكَاحَ التَّحْكِيمِ
u'نِكَاحٌ تَحْكِيمٌ':Added, #1: 1	نِكَاحُ التَّحْكِيمِ
u'نِكَاحٌ تَحْكِيمٌ':Added, #1: 1	نِكَاحَ التَّحْكِيمِ
u'نكاح تَحْكِيمٌ':Added, #1: 1	نِكَاحُ التَّحْكِيمِ
u'نِكَاحٌ تَحْكِيمٌ':Added, #2: 2	نِكَاحِ التَّحْكِيمِ
u'نكاح تَسْمِيَة':Added, #2: 2	نِكَاحِ التَّحْكِيمِ
u'نِكَاحٌ تَسْمِيَة':Added, #4: 4	نِكَاحِ التَّسْمِيَةِ
u'نكاح تَفْوِيضٌ':Added, #4: 4	نِكَاحِ التَّسْمِيَةِ
u'نِكَاحٌ تَفْوِيضٌ':Added, #1: 1	نِكَاحَ التَّفْوِيضِ
u'نكاح تَفْوِيضٌ':Added, #1: 1	نِكَاحَ التَّفْوِيضِ
u'نِكَاحٌ تَفْوِيضٌ':Added, #6: 6	نِكَاحُ التَّفْوِيضِ
u'نكاح تَفْوِيضٌ':Added, #6: 6	نِكَاحُ التَّفْوِيضِ
u'نِكَاحٌ تَفْوِيضٌ':Added, #9: 9	نِكَاحِ التَّفْوِيضِ
u'نكاح ثَالِثٌ':Added, #9: 9	نِكَاحِ التَّفْوِيضِ
u'نِكَاحٌ ثَالِثٌ':Added, #3: 3	نِكَاحِ الثَّالِثَةِ
u'نكاح ثَالِثٌ':Added, #3: 3	نِكَاحِ الثَّالِثَةِ
u'نِكَاحٌ ثَالِثٌ':Added, #9: 9	نِكَاحُ الثَّالِثَةِ
u'نكاح ثَانِي':Added, #9: 9	نِكَاحُ الثَّالِثَةِ
u'نِكَاحٌ ثَانِي':Added, #10: 10	نِكَاحُ الثَّانِيَةِ
u'نكاح ثَانِي':Added, #10: 10	نِكَاحُ الثَّانِيَةِ
u'نِكَاحٌ ثَانِي':Added, #1: 1	نِكَاحِ ثَانِيَةٍ
u'نكاح ثَانِي':Added, #1: 1	نِكَاحِ ثَانِيَةٍ
u'نِكَاحٌ ثَانِي':Added, #2: 2	نِكَاحَ الثَّانِيَةِ
u'نكاح ثَانِي':Added, #2: 2	نِكَاحَ الثَّانِيَةِ
u'نِكَاحٌ ثَانِي':Added, #2: 2	نِكَاحُ ثَانِيَةٍ
u'نكاح ثَانِي':Added, #2: 2	نِكَاحُ ثَانِيَةٍ
u'نِكَاحٌ ثَانِي':Added, #5: 5	نِكَاحِ الثَّانِيَةِ
u'نكاح ثَانِيَةٌ':Added, #5: 5	نِكَاحِ الثَّانِيَةِ
u'نِكَاحٌ ثَانِيَةٌ':Added, #10: 10	نِكَاحُ الثَّانِيَةِ
u'نكاح ثَانِيَةٌ':Added, #10: 10	نِكَاحُ الثَّانِيَةِ
u'نِكَاحٌ ثَانِيَةٌ':Added, #1: 1	نِكَاحِ ثَانِيَةٍ
u'نكاح ثَانِيَةٌ':Added, #1: 1	نِكَاحِ ثَانِيَةٍ
u'نِكَاحٌ ثَانِيَةٌ':Added, #2: 2	نِكَاحَ الثَّانِيَةِ
u'نكاح ثَانِيَةٌ':Added, #2: 2	نِكَاحَ الثَّانِيَةِ
u'نِكَاحٌ ثَانِيَةٌ':Added, #2: 2	نِكَاحُ ثَانِيَةٍ
u'نكاح ثَانِيَةٌ':Added, #2: 2	نِكَاحُ ثَانِيَةٍ
u'نِكَاحٌ ثَانِيَةٌ':Added, #5: 5	نِكَاحِ الثَّانِيَةِ
u'نكاح ثَلاثُ':Added, #5: 5	نِكَاحِ الثَّانِيَةِ
u'نِكَاحٌ ثَلاثُ':Added, #2: 2	نِكَاحَ الثَّلَاثِ
u'نكاح ثَلاثُ':Added, #2: 2	نِكَاحَ الثَّلَاثِ
u'نِكَاحٌ ثَلاثُ':Added, #3: 3	نِكَاحِ الثَّلَاثِ
u'نكاح ثَلاثُ':Added, #3: 3	نِكَاحِ الثَّلَاثِ
u'نِكَاحٌ ثَلاثُ':Added, #7: 7	نِكَاحُ الثَّلَاثِ
u'نكاح ثَيِّبٌ':Added, #7: 7	نِكَاحُ الثَّلَاثِ
u'نِكَاحٌ ثَيِّبٌ':Added, #1: 1	نِكَاحِ ثَيِّبٍ
u'نكاح ثَيِّبٌ':Added, #1: 1	نِكَاحِ ثَيِّبٍ
u'نكاح ثَيِّبٌ':Added, #2: 2	نِكَاحُ الثَّيِّبِ
u'نِكَاحٌ ثَيِّبٌ':Added, #2: 2	نِكَاحِ الثَّيِّبِ
u'نِكَاحٌ ثَيِّبٌ':Added, #2: 2	نِكَاحُ الثَّيِّبِ
u'نكاح جَارِي':Added, #2: 2	نِكَاحِ الثَّيِّبِ
u'نِكَاحٌ جَارِي':Added, #1: 1	نِكَاحَ الْجَارِيَةِ
u'نكاح جَارِي':Added, #1: 1	نِكَاحَ الْجَارِيَةِ
u'نِكَاحٌ جَارِي':Added, #2: 2	نِكَاحِ جَارِيَةِ
u'نكاح جَارِيَةٌ':Added, #2: 2	نِكَاحِ جَارِيَةِ
u'نِكَاحٌ جَارِيَةٌ':Added, #1: 1	نِكَاحَ الْجَارِيَةِ
u'نكاح جَارِيَةٌ':Added, #1: 1	نِكَاحَ الْجَارِيَةِ
u'نِكَاحٌ جَارِيَةٌ':Added, #2: 2	نِكَاحِ جَارِيَةِ
u'نكاح جَامِعٌ':Added, #2: 2	نِكَاحِ جَارِيَةِ
u'نِكَاحٌ جَامِعٌ':Added, #2: 2	نِكَاحِ الْجَامِعِ
u'نكاح جَانٌّ':Added, #2: 2	نِكَاحِ الْجَامِعِ
u'نِكَاحٌ جَانٌّ':Added, #1: 1	نِكَاحِ الْجَانِّ
u'نكاح جَاهِلِيٌّ':Added, #1: 1	نِكَاحِ الْجَانِّ
u'نِكَاحٌ جَاهِلِيٌّ':Added, #1: 1	نِكَاحِ الْجَاهِلِيَّةِ
u'نكاح جَاهِلِيَّةٌ':Added, #1: 1	نِكَاحِ الْجَاهِلِيَّةِ
u'نِكَاحٌ جَاهِلِيَّةٌ':Added, #1: 1	نِكَاحِ الْجَاهِلِيَّةِ
u'نكاح جَائِزٌ':Added, #1: 1	نِكَاحِ الْجَاهِلِيَّةِ
u'نِكَاحٌ جَائِزٌ':Added, #2: 2	نِكَاحٍ جَائِزٍ
u'نكاح جَديدٌ':Added, #2: 2	نِكَاحٍ جَائِزٍ
u'نِكَاحٌ جَديدٌ':Added, #1: 1	نِكَاحٍ جَدِيدٍ
u'نكاح جَمِيع':Added, #1: 1	نِكَاحٍ جَدِيدٍ
u'نِكَاحٌ جَمِيع':Added, #5: 5	نِكَاحُ الْجَمِيعِ
u'نكاح جِنٌّ':Added, #5: 5	نِكَاحُ الْجَمِيعِ
u'نِكَاحٌ جِنٌّ':Added, #1: 1	نِكَاحُ الْجِنِّ
u'نكاح جِنٌّ':Added, #1: 1	نِكَاحُ الْجِنِّ
u'نكاح جِنٌّ':Added, #1: 1	نِكَاحَ الْجِنِّيَّةِ
u'نِكَاحٌ جِنٌّ':Added, #1: 1	نِكَاحِ الْجِنِّيَّةِ
u'نِكَاحٌ جِنٌّ':Added, #1: 1	نِكَاحَ الْجِنِّيَّةِ
u'نكاح جِنٌّ':Added, #1: 1	نِكَاحِ الْجِنِّيَّةِ
u'نِكَاحٌ جِنٌّ':Added, #1: 1	نِكَاحُ جِنِّيَّةٍ
u'نكاح جِنٌّ':Added, #1: 1	نِكَاحُ جِنِّيَّةٍ
u'نِكَاحٌ جِنٌّ':Added, #5: 5	نِكَاحِ الْجِنِّ
u'نكاح جِنِّيٌّ':Added, #5: 5	نِكَاحِ الْجِنِّ
u'نكاح جِنِّيٌّ':Added, #1: 1	نِكَاحَ الْجِنِّيِّ
u'نِكَاحٌ جِنِّيٌّ':Added, #1: 1	نِكَاحِ الْجِنِّيِّ
u'نِكَاحٌ جِنِّيٌّ':Added, #1: 1	نِكَاحَ الْجِنِّيِّ
u'نكاح جِنِّيٌّ':Added, #1: 1	نِكَاحِ الْجِنِّيِّ
u'نكاح جِنِّيٌّ':Added, #1: 1	نِكَاحَ الْجِنِّيَّةِ
u'نِكَاحٌ جِنِّيٌّ':Added, #1: 1	نِكَاحِ الْجِنِّيَّةِ
u'نِكَاحٌ جِنِّيٌّ':Added, #1: 1	نِكَاحَ الْجِنِّيَّةِ
u'نكاح جِنِّيٌّ':Added, #1: 1	نِكَاحِ الْجِنِّيَّةِ
u'نِكَاحٌ جِنِّيٌّ':Added, #1: 1	نِكَاحُ جِنِّيَّةٍ
u'نكاح حاضِرٌ':Added, #1: 1	نِكَاحُ جِنِّيَّةٍ
u'نكاح حاضِرٌ':Added, #1: 1	نِكَاحٍ حَاضِرٍ
u'نكاح حاضِرٌ':Added, #1: 1	نِكَاحَ حَاضِرٍ
u'نِكَاحٌ حاضِرٌ':Added, #1: 1	نِكَاحَ حَاضِرِ
u'نِكَاحٌ حاضِرٌ':Added, #1: 1	نِكَاحٍ حَاضِرٍ
u'نِكَاحٌ حاضِرٌ':Added, #1: 1	نِكَاحَ حَاضِرٍ
u'نكاح حاكِمٌ':Added, #1: 1	نِكَاحَ حَاضِرِ
u'نكاح حاكِمٌ':Added, #1: 1	نِكَاحَ الْحَاكِمِ
u'نِكَاحٌ حاكِمٌ':Added, #1: 1	نِكَاحُ الْحَاكِمِ
u'نِكَاحٌ حاكِمٌ':Added, #1: 1	نِكَاحَ الْحَاكِمِ
u'نكاح حامِلٌ':Added, #1: 1	نِكَاحُ الْحَاكِمِ
u'نِكَاحٌ حامِلٌ':Added, #1: 1	نِكَاحِ الْحَامِلِ
u'نكاح حامِلٌ':Added, #1: 1	نِكَاحِ الْحَامِلِ
u'نِكَاحٌ حامِلٌ':Added, #3: 3	نِكَاحُ الْحَامِلِ
u'نكاح حُرٌّ':Added, #3: 3	نِكَاحُ الْحَامِلِ
u'نِكَاحٌ حُرٌّ':Added, #10: 10	نِكَاحِ حُرَّةٍ
u'نكاح حُرٌّ':Added, #10: 10	نِكَاحِ حُرَّةٍ
u'نِكَاحٌ حُرٌّ':Added, #1: 1	نِكَاحَ الْحُرَّتَيْنِ
u'نكاح حُرٌّ':Added, #1: 1	نِكَاحَ الْحُرَّتَيْنِ
u'نِكَاحٌ حُرٌّ':Added, #1: 1	نِكَاحُ حُرٍّ
u'نكاح حُرٌّ':Added, #1: 1	نِكَاحُ حُرٍّ
u'نِكَاحٌ حُرٌّ':Added, #27: 27	نِكَاحِ الْحُرَّةِ
u'نكاح حُرٌّ':Added, #27: 27	نِكَاحِ الْحُرَّةِ
u'نكاح حُرٌّ':Added, #2: 2	نِكَاحَ الْحُرِّ
u'نِكَاحٌ حُرٌّ':Added, #2: 2	نِكَاحُ الْحُرِّ
u'نِكَاحٌ حُرٌّ':Added, #2: 2	نِكَاحَ الْحُرِّ
u'نكاح حُرٌّ':Added, #2: 2	نِكَاحُ الْحُرِّ
u'نِكَاحٌ حُرٌّ':Added, #31: 31	نِكَاحُ الْحُرَّةِ
u'نكاح حُرٌّ':Added, #31: 31	نِكَاحُ الْحُرَّةِ
u'نِكَاحٌ حُرٌّ':Added, #3: 3	نِكَاحُ حُرَّةٍ
u'نكاح حُرٌّ':Added, #3: 3	نِكَاحُ حُرَّةٍ
u'نِكَاحٌ حُرٌّ':Added, #5: 5	نِكَاحُ الْحُرَّتَيْنِ
u'نكاح حُرٌّ':Added, #5: 5	نِكَاحُ الْحُرَّتَيْنِ
u'نِكَاحٌ حُرٌّ':Added, #6: 6	نِكَاحِ الْحُرِّ
u'نكاح حُرٌّ':Added, #6: 6	نِكَاحِ الْحُرِّ
u'نِكَاحٌ حُرٌّ':Added, #9: 9	نِكَاحَ الْحُرَّةِ
u'نكاح حَرائِرُ':Added, #9: 9	نِكَاحَ الْحُرَّةِ
u'نكاح حَرَائِرُ':Added, #1: 1	نِكَاحُ حَرَائِرِ
u'نِكَاحٌ حَرائِرُ':Added, #1: 1	نِكَاحُ حَرَائِرِ
u'نِكَاحٌ حَرَائِرُ':Added, #1: 1	نِكَاحُ حَرَائِرِ
u'نكاح حَرائِرُ':Added, #1: 1	نِكَاحُ حَرَائِرِ
u'نكاح حَرَائِرُ':Added, #2: 2	نِكَاحِ حَرَائِرِ
u'نِكَاحٌ حَرائِرُ':Added, #2: 2	نِكَاحِ حَرَائِرِ
u'نِكَاحٌ حَرَائِرُ':Added, #2: 2	نِكَاحِ حَرَائِرِ
u'نكاح حَرائِرُ':Added, #2: 2	نِكَاحِ حَرَائِرِ
u'نكاح حَرائِرُ':Added, #3: 3	نِكَاحُ الْحَرَائِرِ
u'نكاح حَرَائِرُ':Added, #3: 3	نِكَاحِ الْحَرَائِرِ
u'نكاح حَرَائِرُ':Added, #3: 3	نِكَاحُ الْحَرَائِرِ
u'نِكَاحٌ حَرائِرُ':Added, #3: 3	نِكَاحِ الْحَرَائِرِ
u'نِكَاحٌ حَرائِرُ':Added, #3: 3	نِكَاحُ الْحَرَائِرِ
u'نِكَاحٌ حَرَائِرُ':Added, #3: 3	نِكَاحِ الْحَرَائِرِ
u'نِكَاحٌ حَرَائِرُ':Added, #3: 3	نِكَاحُ الْحَرَائِرِ
u'نكاح حَرائِرُ':Added, #3: 3	نِكَاحِ الْحَرَائِرِ
u'نكاح حَرَائِرُ':Added, #4: 4	نِكَاحَ الْحَرَائِرِ
u'نِكَاحٌ حَرائِرُ':Added, #4: 4	نِكَاحَ الْحَرَائِرِ
u'نِكَاحٌ حَرَائِرُ':Added, #4: 4	نِكَاحَ الْحَرَائِرِ
u'نكاح حَرْب':Added, #4: 4	نِكَاحَ الْحَرَائِرِ
u'نِكَاحٌ حَرْب':Added, #1: 1	نِكَاحَ الْحَرْبِيَّةِ
u'نكاح حَرْب':Added, #1: 1	نِكَاحَ الْحَرْبِيَّةِ
u'نِكَاحٌ حَرْب':Added, #2: 2	نِكَاحُ الْحَرْبِيَّةِ
u'نكاح حَرْبَة':Added, #2: 2	نِكَاحُ الْحَرْبِيَّةِ
u'نِكَاحٌ حَرْبَة':Added, #1: 1	نِكَاحَ الْحَرْبِيَّةِ
u'نكاح حَرْبَة':Added, #1: 1	نِكَاحَ الْحَرْبِيَّةِ
u'نِكَاحٌ حَرْبَة':Added, #2: 2	نِكَاحُ الْحَرْبِيَّةِ
u'نكاح حَرْبِيّ':Added, #2: 2	نِكَاحُ الْحَرْبِيَّةِ
u'نِكَاحٌ حَرْبِيّ':Added, #1: 1	نِكَاحَ الْحَرْبِيَّةِ
u'نكاح حَرْبِيّ':Added, #1: 1	نِكَاحَ الْحَرْبِيَّةِ
u'نِكَاحٌ حَرْبِيّ':Added, #2: 2	نِكَاحُ الْحَرْبِيَّةِ
u'نكاح حَلِيلَةٌ':Added, #2: 2	نِكَاحُ الْحَرْبِيَّةِ
u'نِكَاحٌ حَلِيلَةٌ':Added, #1: 1	نِكَاحَ حَلِيلَةِ
u'نكاح حَيْض':Added, #1: 1	نِكَاحَ حَلِيلَةِ
u'نِكَاحٌ حَيْض':Added, #1: 1	نِكَاحِ حَيْضَتَيْنِ
u'نكاح خَاطِبٌ':Added, #1: 1	نِكَاحِ حَيْضَتَيْنِ
u'نِكَاحٌ خَاطِبٌ':Added, #1: 1	نِكَاحِ الْخَاطِبِ
u'نكاح خَالٌ':Added, #1: 1	نِكَاحِ الْخَاطِبِ
u'نِكَاحٌ خَالٌ':Added, #1: 1	نِكَاحَ الْخَالِ
u'نكاح خَالٌ':Added, #1: 1	نِكَاحَ الْخَالِ
u'نِكَاحٌ خَالٌ':Added, #1: 1	نِكَاحٍ خَالٍ
u'نكاح خامس':Added, #1: 1	نِكَاحٍ خَالٍ
u'نِكَاحٌ خامس':Added, #1: 1	نِكَاحِ خَامِسَةٍ
u'نكاح خَامِسٌ':Added, #1: 1	نِكَاحِ خَامِسَةٍ
u'نِكَاحٌ خَامِسٌ':Added, #1: 1	نِكَاحِ خَامِسَةٍ
u'نكاح خامس':Added, #1: 1	نِكَاحِ خَامِسَةٍ
u'نكاح خامس':Added, #2: 2	نِكَاحُ الْخَامِسَةِ
u'نِكَاحٌ خامس':Added, #2: 2	نِكَاحِ الْخَامِسَةِ
u'نِكَاحٌ خامس':Added, #2: 2	نِكَاحُ الْخَامِسَةِ
u'نكاح خَامِسٌ':Added, #2: 2	نِكَاحِ الْخَامِسَةِ
u'نكاح خَامِسٌ':Added, #2: 2	نِكَاحُ الْخَامِسَةِ
u'نِكَاحٌ خَامِسٌ':Added, #2: 2	نِكَاحِ الْخَامِسَةِ
u'نِكَاحٌ خَامِسٌ':Added, #2: 2	نِكَاحُ الْخَامِسَةِ
u'نكاح خِزَانَةٌ':Added, #2: 2	نِكَاحِ الْخَامِسَةِ
u'نِكَاحٌ خِزَانَةٌ':Added, #1: 1	نِكَاحِ خِزَانَةِ
u'نكاح خَصِيٌّ':Added, #1: 1	نِكَاحِ خِزَانَةِ
u'نِكَاحٌ خَصِيٌّ':Added, #1: 1	نِكَاحُ الْخَصِيِّ
u'نكاح خَمْسٌ':Added, #1: 1	نِكَاحُ الْخَصِيِّ
u'نكاح خَمْسٌ':Added, #2: 2	نِكَاحُ الْخَمْسِ
u'نِكَاحٌ خَمْسٌ':Added, #2: 2	نِكَاحِ الْخَمْسِ
u'نِكَاحٌ خَمْسٌ':Added, #2: 2	نِكَاحُ الْخَمْسِ
u'نكاح خيار':Added, #2: 2	نِكَاحِ الْخَمْسِ
u'نكاح خيار':Added, #1: 1	نِكَاحَ الْخِيَارِ
u'نكاح خِيَارٌ':Added, #1: 1	نِكَاحُ الْخِيَارِ
u'نكاح خِيَارٌ':Added, #1: 1	نِكَاحَ الْخِيَارِ
u'نِكَاحٌ خيار':Added, #1: 1	نِكَاحُ الْخِيَارِ
u'نِكَاحٌ خيار':Added, #1: 1	نِكَاحَ الْخِيَارِ
u'نِكَاحٌ خِيَارٌ':Added, #1: 1	نِكَاحُ الْخِيَارِ
u'نِكَاحٌ خِيَارٌ':Added, #1: 1	نِكَاحَ الْخِيَارِ
u'نكاح خيار':Added, #1: 1	نِكَاحُ الْخِيَارِ
u'نكاح خِيَارٌ':Added, #1: 1	نِكَاحُ خِيَارٍ
u'نِكَاحٌ خيار':Added, #1: 1	نِكَاحُ خِيَارٍ
u'نِكَاحٌ خِيَارٌ':Added, #1: 1	نِكَاحُ خِيَارٍ
u'نكاح خيار':Added, #1: 1	نِكَاحُ خِيَارٍ
u'نكاح خِيَارٌ':Added, #2: 2	نِكَاحِ الْخِيَارِ
u'نِكَاحٌ خيار':Added, #2: 2	نِكَاحِ الْخِيَارِ
u'نِكَاحٌ خِيَارٌ':Added, #2: 2	نِكَاحِ الْخِيَارِ
u'نكاح دِرْهَمٌ':Added, #2: 2	نِكَاحِ الْخِيَارِ
u'نكاح دِرْهَم':Added, #1: 1	نِكَاحَ الدِّرْهَمَيْنِ
u'نِكَاحٌ دِرْهَمٌ':Added, #1: 1	نِكَاحَ الدِّرْهَمَيْنِ
u'نِكَاحٌ دِرْهَم':Added, #1: 1	نِكَاحَ الدِّرْهَمَيْنِ
u'نكاح دَيِّنٌ':Added, #1: 1	نِكَاحَ الدِّرْهَمَيْنِ
u'نِكَاحٌ دَيِّنٌ':Added, #2: 2	نِكَاحُ دَيِّنَةٍ
u'نكاح ذكر':Added, #2: 2	نِكَاحُ دَيِّنَةٍ
u'نِكَاحٌ ذكر':Added, #1: 1	نِكَاحِ الذَّكَرِ
u'نكاح ذَكَرٌ':Added, #1: 1	نِكَاحِ الذَّكَرِ
u'نِكَاحٌ ذَكَرٌ':Added, #1: 1	نِكَاحِ الذَّكَرِ
u'نكاح رابع':Added, #1: 1	نِكَاحِ الذَّكَرِ
u'نكاح رابع':Added, #2: 2	نِكَاحَ الرَّابِعَةِ
u'نِكَاحٌ رابع':Added, #2: 2	نِكَاحُ الرَّابِعَةِ
u'نِكَاحٌ رابع':Added, #2: 2	نِكَاحَ الرَّابِعَةِ
u'نكاح رَابِعٌ':Added, #2: 2	نِكَاحُ الرَّابِعَةِ
u'نكاح رَابِعٌ':Added, #2: 2	نِكَاحَ الرَّابِعَةِ
u'نِكَاحٌ رَابِعٌ':Added, #2: 2	نِكَاحُ الرَّابِعَةِ
u'نِكَاحٌ رَابِعٌ':Added, #2: 2	نِكَاحَ الرَّابِعَةِ
u'نكاح رَجُلٌ':Added, #2: 2	نِكَاحُ الرَّابِعَةِ
u'نِكَاحٌ رَجُلٌ':Added, #1: 1	نِكَاحِ الرَّجُلِ
u'نكاح رَجُلٌ':Added, #1: 1	نِكَاحِ الرَّجُلِ
u'نِكَاحٌ رَجُلٌ':Added, #2: 2	نِكَاحَ رَجُلٍ
u'نكاح رَجُلٌ':Added, #2: 2	نِكَاحَ رَجُلٍ
u'نِكَاحٌ رَجُلٌ':Added, #3: 3	نِكَاحِ رَجُلٍ
u'نكاح رَضيعٌ':Added, #3: 3	نِكَاحِ رَجُلٍ
u'نِكَاحٌ رَضيعٌ':Added, #1: 1	نِكَاحِ الرَّضِيعَةِ
u'نكاح رَغْبَةٌ':Added, #1: 1	نِكَاحِ الرَّضِيعَةِ
u'نِكَاحٌ رَغْبَةٌ':Added, #1: 1	نِكَاحُ الرَّغْبَةِ
u'نكاح رَغْبَةٌ':Added, #1: 1	نِكَاحُ الرَّغْبَةِ
u'نِكَاحٌ رَغْبَةٌ':Added, #1: 1	نِكَاحُ رَغْبَةٍ
u'نكاح رَغْبَةٌ':Added, #1: 1	نِكَاحُ رَغْبَةٍ
u'نِكَاحٌ رَغْبَةٌ':Added, #4: 4	نِكَاحَ رَغْبَةٍ
u'نكاح رَقيقٌ':Added, #4: 4	نِكَاحَ رَغْبَةٍ
u'نكاح رَقيق':Added, #16: 16	نِكَاحِ الرَّقِيقِ
u'نِكَاحٌ رَقيقٌ':Added, #16: 16	نِكَاحِ الرَّقِيقِ
u'نِكَاحٌ رَقيق':Added, #16: 16	نِكَاحِ الرَّقِيقِ
u'نكاح رَقيقٌ':Added, #16: 16	نِكَاحِ الرَّقِيقِ
u'نكاح رَقيق':Added, #1: 1	نِكَاحَ الرَّقِيقِ
u'نِكَاحٌ رَقيقٌ':Added, #1: 1	نِكَاحَ الرَّقِيقِ
u'نِكَاحٌ رَقيق':Added, #1: 1	نِكَاحَ الرَّقِيقِ
u'نكاح رَقيقٌ':Added, #1: 1	نِكَاحَ الرَّقِيقِ
u'نِكَاحٌ رَقيقٌ':Added, #1: 1	نِكَاحُ الرَّقِيقَةِ
u'نكاح رَقيقٌ':Added, #1: 1	نِكَاحُ الرَّقِيقَةِ
u'نكاح رَقيق':Added, #1: 1	نِكَاحِ رَقِيقِ
u'نِكَاحٌ رَقيقٌ':Added, #1: 1	نِكَاحِ رَقِيقِ
u'نِكَاحٌ رَقيق':Added, #1: 1	نِكَاحِ رَقِيقِ
u'نكاح رَقيقٌ':Added, #1: 1	نِكَاحِ رَقِيقِ
u'نكاح رَقيق':Added, #2: 2	نِكَاحُ الرَّقِيقِ
u'نِكَاحٌ رَقيقٌ':Added, #2: 2	نِكَاحُ الرَّقِيقِ
u'نِكَاحٌ رَقيق':Added, #2: 2	نِكَاحُ الرَّقِيقِ
u'نكاح زانِي':Added, #2: 2	نِكَاحُ الرَّقِيقِ
u'نِكَاحٌ زانِي':Added, #1: 1	نِكَاحَ الزَّانِيَةِ
u'نكاح زانِي':Added, #1: 1	نِكَاحَ الزَّانِيَةِ
u'نِكَاحٌ زانِي':Added, #5: 5	نِكَاحِ الزَّانِيَةِ
u'نكاح زناة':Added, #5: 5	نِكَاحِ الزَّانِيَةِ
u'نِكَاحٌ زناة':Added, #1: 1	نِكَاحَ الزُّنَاةِ
u'نكاح زَوْجٌ':Added, #1: 1	نِكَاحَ الزُّنَاةِ
u'نِكَاحٌ زَوْجٌ':Added, #1: 1	نِكَاحُ الزَّوْجَيْنِ
u'نكاح زَوْجٌ':Added, #1: 1	نِكَاحُ الزَّوْجَيْنِ
u'نكاح زَوْجٌ':Added, #1: 1	نِكَاحَ زَوْجٍ
u'نِكَاحٌ زَوْجٌ':Added, #1: 1	نِكَاحِ زَوْجٍ
u'نِكَاحٌ زَوْجٌ':Added, #1: 1	نِكَاحَ زَوْجٍ
u'نكاح زَوْجٌ':Added, #1: 1	نِكَاحِ زَوْجٍ
u'نكاح زَوْجٌ':Added, #2: 2	نِكَاحُ زَوْجٍ
u'نِكَاحٌ زَوْجٌ':Added, #2: 2	نِكَاحِ زَوْجِ
u'نِكَاحٌ زَوْجٌ':Added, #2: 2	نِكَاحُ زَوْجٍ
u'نكاح زَوْجٌ':Added, #2: 2	نِكَاحِ زَوْجِ
u'نِكَاحٌ زَوْجٌ':Added, #6: 6	نِكَاحُ الزَّوْجِ
u'نكاح زَوْجَةٌ':Added, #6: 6	نِكَاحُ الزَّوْجِ
u'نِكَاحٌ زَوْجَةٌ':Added, #1: 1	نِكَاحَ الزَّوْجَةِ
u'نكاح زَوْجَةٌ':Added, #1: 1	نِكَاحَ الزَّوْجَةِ
u'نِكَاحٌ زَوْجَةٌ':Added, #1: 1	نِكَاحَ زَوْجَاتِهِ
u'نكاح زَوْجَةٌ':Added, #1: 1	نِكَاحَ زَوْجَاتِهِ
u'نِكَاحٌ زَوْجَةٌ':Added, #2: 2	نِكَاحُ زَوْجَاتِهِ
u'نكاح زَوْجَةٌ':Added, #2: 2	نِكَاحُ زَوْجَاتِهِ
u'نِكَاحٌ زَوْجَةٌ':Added, #2: 2	نِكَاحُ زَوْجَتِهِ
u'نكاح سَابِقٌ':Added, #2: 2	نِكَاحُ زَوْجَتِهِ
u'نِكَاحٌ سَابِقٌ':Added, #3: 3	نِكَاحٍ سَابِقٍ
u'نكاح سِرٌّ':Added, #3: 3	نِكَاحٍ سَابِقٍ
u'نِكَاحٌ سِرٌّ':Added, #1: 1	نِكَاحُ سِرٍّ
u'نكاح سِرٌّ':Added, #1: 1	نِكَاحُ سِرٍّ
u'نكاح سِرٌّ':Added, #3: 3	نِكَاحَ السِّرِّ
u'نِكَاحٌ سِرٌّ':Added, #3: 3	نِكَاحُ السِّرِّ
u'نِكَاحٌ سِرٌّ':Added, #3: 3	نِكَاحَ السِّرِّ
u'نكاح سَفِيهٌ':Added, #3: 3	نِكَاحُ السِّرِّ
u'نِكَاحٌ سَفِيهٌ':Added, #1: 1	نِكَاحَ السَّفِيهِ
u'نكاح سَفِيهٌ':Added, #1: 1	نِكَاحَ السَّفِيهِ
u'نِكَاحٌ سَفِيهٌ':Added, #2: 2	نِكَاحُ السَّفِيهِ
u'نكاح سَفِيهٌ':Added, #2: 2	نِكَاحُ السَّفِيهِ
u'نِكَاحٌ سَفِيهٌ':Added, #3: 3	نِكَاحِ السَّفِيهِ
u'نكاح شُبْهَةٌ':Added, #3: 3	نِكَاحِ السَّفِيهِ
u'نِكَاحٌ شُبْهَةٌ':Added, #1: 1	نِكَاحُ شُبْهَةٍ
u'نكاح شَخْصٌ':Added, #1: 1	نِكَاحُ شُبْهَةٍ
u'نِكَاحٌ شَخْصٌ':Added, #1: 1	نِكَاحِ الشَّخْصِ
u'نكاح شَخْصٌ':Added, #1: 1	نِكَاحِ الشَّخْصِ
u'نِكَاحٌ شَخْصٌ':Added, #1: 1	نِكَاحِ شَخْصٍ
u'نكاح شِرْكٌ':Added, #1: 1	نِكَاحِ شَخْصٍ
u'نِكَاحٌ شِرْكٌ':Added, #1: 1	نِكَاحَ الشِّرْكِ
u'نكاح شَيْءٌ':Added, #1: 1	نِكَاحَ الشِّرْكِ
u'نِكَاحٌ شَيْءٌ':Added, #2: 2	نِكَاحُ شَيْءٍ
u'نكاح صَابِئٌ':Added, #2: 2	نِكَاحُ شَيْءٍ
u'نكاح صَابِئٌ':Added, #1: 1	نِكَاحُ الصَّابِئَةِ
u'نِكَاحٌ صَابِئٌ':Added, #1: 1	نِكَاحِ الصَّابِئَةِ
u'نِكَاحٌ صَابِئٌ':Added, #1: 1	نِكَاحُ الصَّابِئَةِ
u'نكاح صَابِئَةٌ':Added, #1: 1	نِكَاحِ الصَّابِئَةِ
u'نكاح صَابِئَةٌ':Added, #1: 1	نِكَاحُ الصَّابِئَةِ
u'نِكَاحٌ صَابِئَةٌ':Added, #1: 1	نِكَاحِ الصَّابِئَةِ
u'نِكَاحٌ صَابِئَةٌ':Added, #1: 1	نِكَاحُ الصَّابِئَةِ
u'نكاح صَبِيٌّ':Added, #1: 1	نِكَاحِ الصَّابِئَةِ
u'نِكَاحٌ صَبِيٌّ':Added, #1: 1	نِكَاحُ الصَّبِيِّ
u'نكاح صَبِيٌّ':Added, #1: 1	نِكَاحُ الصَّبِيِّ
u'نِكَاحٌ صَبِيٌّ':Added, #1: 1	نِكَاحُ الصَّبِيَّةِ
u'نكاح صَبِيٌّ':Added, #1: 1	نِكَاحُ الصَّبِيَّةِ
u'نكاح صَبِيٌّ':Added, #1: 1	نِكَاحَ صَبِيٍّ
u'نِكَاحٌ صَبِيٌّ':Added, #1: 1	نِكَاحِ صَبِيٍّ
u'نِكَاحٌ صَبِيٌّ':Added, #1: 1	نِكَاحَ صَبِيٍّ
u'نكاح صَبِيٌّ':Added, #1: 1	نِكَاحِ صَبِيٍّ
u'نِكَاحٌ صَبِيٌّ':Added, #1: 1	نِكَاحَ صَبِيَّةٍ
u'نكاح صَبِيٌّ':Added, #1: 1	نِكَاحَ صَبِيَّةٍ
u'نِكَاحٌ صَبِيٌّ':Added, #2: 2	نِكَاحَ الصَّبِيِّ
u'نكاح صَغِيرٌ':Added, #2: 2	نِكَاحَ الصَّبِيِّ
u'نكاح صَغِيرٌ':Added, #1: 1	نِكَاحَ صَغِيرٍ
u'نِكَاحٌ صَغِيرٌ':Added, #1: 1	نِكَاحِ صَغِيرٍ
u'نِكَاحٌ صَغِيرٌ':Added, #1: 1	نِكَاحَ صَغِيرٍ
u'نكاح صَغِيرٌ':Added, #1: 1	نِكَاحِ صَغِيرٍ
u'نكاح صَغِيرٌ':Added, #2: 2	نِكَاحَ الصَّغِيرِ
u'نِكَاحٌ صَغِيرٌ':Added, #2: 2	نِكَاحِ الصَّغِيرِ
u'نِكَاحٌ صَغِيرٌ':Added, #2: 2	نِكَاحَ الصَّغِيرِ
u'نكاح صَغِيرٌ':Added, #2: 2	نِكَاحِ الصَّغِيرِ
u'نِكَاحٌ صَغِيرٌ':Added, #2: 2	نِكَاحَ الصَّغِيرَةِ
u'نكاح صَغِيرٌ':Added, #2: 2	نِكَاحَ الصَّغِيرَةِ
u'نِكَاحٌ صَغِيرٌ':Added, #2: 2	نِكَاحُ الصَّغِيرَتَيْنِ
u'نكاح صَغِيرٌ':Added, #2: 2	نِكَاحُ الصَّغِيرَتَيْنِ
u'نِكَاحٌ صَغِيرٌ':Added, #3: 3	نِكَاحِ الصَّغِيرَةِ
u'نكاح صَغِيرٌ':Added, #3: 3	نِكَاحِ الصَّغِيرَةِ
u'نِكَاحٌ صَغِيرٌ':Added, #4: 4	نِكَاحُ الصَّغِيرَةِ
u'نكاح صَغِيرٌ':Added, #4: 4	نِكَاحُ الصَّغِيرَةِ
u'نِكَاحٌ صَغِيرٌ':Added, #5: 5	نِكَاحَ صَغِيرَةٍ
u'نكاح صَغِيرٌ':Added, #5: 5	نِكَاحَ صَغِيرَةٍ
u'نِكَاحٌ صَغِيرٌ':Added, #6: 6	نِكَاحُ الصَّغِيرِ
u'نكاح صِنْفٌ':Added, #6: 6	نِكَاحُ الصَّغِيرِ
u'نِكَاحٌ صِنْفٌ':Added, #1: 1	نِكَاحِ الصِّنْفَيْنِ
u'نكاح ضَرَّةٌ':Added, #1: 1	نِكَاحِ الصِّنْفَيْنِ
u'نِكَاحٌ ضَرَّةٌ':Added, #1: 1	نِكَاحِ الضَّرَّةِ
u'نكاح ضَرَّةٌ':Added, #1: 1	نِكَاحِ الضَّرَّةِ
u'نِكَاحٌ ضَرَّةٌ':Added, #2: 2	نِكَاحُ الضَّرَّةِ
u'نكاح عَبْدٌ':Added, #2: 2	نِكَاحُ الضَّرَّةِ
u'نِكَاحٌ عَبْدٌ':Added, #12: 12	نِكَاحُ الْعَبْدِ
u'نكاح عَبْدٌ':Added, #12: 12	نِكَاحُ الْعَبْدِ
u'نِكَاحٌ عَبْدٌ':Added, #15: 15	نِكَاحِ الْعَبْدِ
u'نكاح عَبْدٌ':Added, #15: 15	نِكَاحِ الْعَبْدِ
u'نِكَاحٌ عَبْدٌ':Added, #1: 1	نِكَاحِ عَبْدٍ
u'نكاح عَبْدٌ':Added, #1: 1	نِكَاحِ عَبْدٍ
u'نِكَاحٌ عَبْدٌ':Added, #1: 1	نِكَاحَ عَبْدِهِ
u'نكاح عَبْدٌ':Added, #1: 1	نِكَاحَ عَبْدِهِ
u'نِكَاحٌ عَبْدٌ':Added, #2: 2	نِكَاحُ عَبْدِ
u'نكاح عَبْدٌ':Added, #2: 2	نِكَاحُ عَبْدِ
u'نِكَاحٌ عَبْدٌ':Added, #4: 4	نِكَاحِ عَبْدِهِ
u'نكاح عَبْدٌ':Added, #4: 4	نِكَاحِ عَبْدِهِ
u'نِكَاحٌ عَبْدٌ':Added, #6: 6	نِكَاحَ الْعَبْدِ
u'نكاح عَبِيدٌ':Added, #6: 6	نِكَاحَ الْعَبْدِ
u'نِكَاحٌ عَبِيدٌ':Added, #1: 1	نِكَاحِ الْعَبِيدِ
u'نكاح عَدَدٌ':Added, #1: 1	نِكَاحِ الْعَبِيدِ
u'نِكَاحٌ عَدَدٌ':Added, #2: 2	نِكَاحُ الْعَدَدِ
u'نكاح عَقِيمٌ':Added, #2: 2	نِكَاحُ الْعَدَدِ
u'نِكَاحٌ عَقِيمٌ':Added, #1: 1	نِكَاحَ الْعَقِيمِ
u'نكاح عَمَّةٌ':Added, #1: 1	نِكَاحَ الْعَقِيمِ
u'نِكَاحٌ عَمَّةٌ':Added, #2: 2	نِكَاحُ الْعَمَّةِ
u'نكاح عَمَّةٌ':Added, #2: 2	نِكَاحُ الْعَمَّةِ
u'نِكَاحٌ عَمَّةٌ':Added, #2: 2	نِكَاحُ عَمَّتِهِ
u'نكاح غَائِبٌ':Added, #2: 2	نِكَاحُ عَمَّتِهِ
u'نكاح غَائِبٌ':Added, #1: 1	نِكَاحَ الْغَائِبِ
u'نِكَاحٌ غَائِبٌ':Added, #1: 1	نِكَاحِ الْغَائِبِ
u'نِكَاحٌ غَائِبٌ':Added, #1: 1	نِكَاحَ الْغَائِبِ
u'نكاح غُرُورٌ':Added, #1: 1	نِكَاحِ الْغَائِبِ
u'نِكَاحٌ غُرُورٌ':Added, #2: 2	نِكَاحَ غُرُورٍ
u'نكاح غُلْمَةٌ':Added, #2: 2	نِكَاحَ غُرُورٍ
u'نِكَاحٌ غُلْمَةٌ':Added, #1: 1	نِكَاحُ الْغُلْمَةِ
u'نكاح غير':Added, #1: 1	نِكَاحُ الْغُلْمَةِ
u'نكاح غَيْرٌ':Added, #1: 1	نِكَاحُ الْغَيْرِ
u'نِكَاحٌ غير':Added, #1: 1	نِكَاحُ الْغَيْرِ
u'نِكَاحٌ غَيْرٌ':Added, #1: 1	نِكَاحُ الْغَيْرِ
u'نكاح غير':Added, #1: 1	نِكَاحُ الْغَيْرِ
u'نكاح غَيْرٌ':Added, #1: 1	نِكَاحَ غَيْرِ
u'نِكَاحٌ غير':Added, #1: 1	نِكَاحَ غَيْرِ
u'نِكَاحٌ غَيْرٌ':Added, #1: 1	نِكَاحَ غَيْرِ
u'نكاح غير':Added, #1: 1	نِكَاحَ غَيْرِ
u'نكاح غَيْرٌ':Added, #2: 2	نِكَاحِ غَيْرِهِ
u'نِكَاحٌ غير':Added, #2: 2	نِكَاحِ غَيْرِهِ
u'نِكَاحٌ غَيْرٌ':Added, #2: 2	نِكَاحِ غَيْرِهِ
u'نكاح غير':Added, #2: 2	نِكَاحِ غَيْرِهِ
u'نكاح غير':Added, #3: 3	نِكَاحُ غَيْرِ
u'نكاح غَيْرٌ':Added, #3: 3	نِكَاحِ غَيْرِ
u'نكاح غَيْرٌ':Added, #3: 3	نِكَاحُ غَيْرِ
u'نِكَاحٌ غير':Added, #3: 3	نِكَاحِ غَيْرِ
u'نِكَاحٌ غير':Added, #3: 3	نِكَاحُ غَيْرِ
u'نِكَاحٌ غَيْرٌ':Added, #3: 3	نِكَاحِ غَيْرِ
u'نِكَاحٌ غَيْرٌ':Added, #3: 3	نِكَاحُ غَيْرِ
u'نكاح غير':Added, #3: 3	نِكَاحِ غَيْرِ
u'نكاح غَيْرٌ':Added, #3: 3	نِكَاحَ غَيْرِهِ
u'نِكَاحٌ غير':Added, #3: 3	نِكَاحَ غَيْرِهِ
u'نِكَاحٌ غَيْرٌ':Added, #3: 3	نِكَاحَ غَيْرِهِ
u'نكاح غير':Added, #3: 3	نِكَاحَ غَيْرِهِ
u'نكاح غَيْرٌ':Added, #4: 4	نِكَاحِ الْغَيْرِ
u'نِكَاحٌ غير':Added, #4: 4	نِكَاحِ الْغَيْرِ
u'نِكَاحٌ غَيْرٌ':Added, #4: 4	نِكَاحِ الْغَيْرِ
u'نكاح غير':Added, #4: 4	نِكَاحِ الْغَيْرِ
u'نكاح غَيْرٌ':Added, #5: 5	نِكَاحُ غَيْرِهِ
u'نِكَاحٌ غير':Added, #5: 5	نِكَاحُ غَيْرِهِ
u'نِكَاحٌ غَيْرٌ':Added, #5: 5	نِكَاحُ غَيْرِهِ
u'نكاح فَارِغٌ':Added, #5: 5	نِكَاحُ غَيْرِهِ
u'نِكَاحٌ فَارِغٌ':Added, #2: 2	نِكَاحُ الْفَارِغَةِ
u'نكاح فَاسِدٌ':Added, #2: 2	نِكَاحُ الْفَارِغَةِ
u'نِكَاحٌ فَاسِدٌ':Added, #110: 110	نِكَاحٍ فَاسِدٍ
u'نكاح فَاسِدٌ':Added, #110: 110	نِكَاحٍ فَاسِدٍ
u'نِكَاحٌ فَاسِدٌ':Added, #1: 1	نِكَاحِ الْفَاسِدِ
u'نكاح فَرِيقٌ':Added, #1: 1	نِكَاحِ الْفَاسِدِ
u'نِكَاحٌ فَرِيقٌ':Added, #1: 1	نِكَاحِ الْفَرِيقَيْنِ
u'نكاح فَرِيقٌ':Added, #1: 1	نِكَاحِ الْفَرِيقَيْنِ
u'نِكَاحٌ فَرِيقٌ':Added, #1: 1	نِكَاحِ فَرِيقٍ
u'نكاح فَسْخٌ':Added, #1: 1	نِكَاحِ فَرِيقٍ
u'نِكَاحٌ فَسْخٌ':Added, #1: 1	نِكَاحَ فَسْخٍ
u'نكاح فُضُولِيٌّ':Added, #1: 1	نِكَاحَ فَسْخٍ
u'نِكَاحٌ فُضُولِيٌّ':Added, #18: 18	نِكَاحِ الْفُضُولِيِّ
u'نكاح فُضُولِيٌّ':Added, #18: 18	نِكَاحِ الْفُضُولِيِّ
u'نكاح فُضُولِيٌّ':Added, #1: 1	نِكَاحٍ فُضُولِيٍّ
u'نِكَاحٌ فُضُولِيٌّ':Added, #1: 1	نِكَاحِ فُضُولِيٍّ
u'نِكَاحٌ فُضُولِيٌّ':Added, #1: 1	نِكَاحٍ فُضُولِيٍّ
u'نكاح فُضُولِيٌّ':Added, #1: 1	نِكَاحِ فُضُولِيٍّ
u'نِكَاحٌ فُضُولِيٌّ':Added, #3: 3	نِكَاحَ فُضُولِيٍّ
u'نكاح فُضُولِيٌّ':Added, #3: 3	نِكَاحَ فُضُولِيٍّ
u'نِكَاحٌ فُضُولِيٌّ':Added, #4: 4	نِكَاحُ الْفُضُولِيِّ
u'نكاح فلان':Added, #4: 4	نِكَاحُ الْفُضُولِيِّ
u'نِكَاحٌ فلان':Added, #1: 1	نِكَاحُ الْمَكِّيَّةِ
u'نكاح فُلاَنٌ':Added, #1: 1	نِكَاحُ الْمَكِّيَّةِ
u'نكاح فُلاَنٌ':Added, #1: 1	نِكَاحُ فُلاَنٍ
u'نِكَاحٌ فُلاَنٌ':Added, #1: 1	نِكَاحِ فُلَانٍ
u'نِكَاحٌ فُلاَنٌ':Added, #1: 1	نِكَاحُ فُلاَنٍ
u'نكاح فُلاَنٌ':Added, #1: 1	نِكَاحِ فُلَانٍ
u'نِكَاحٌ فُلاَنٌ':Added, #5: 5	نِكَاحَ فُلَانٍ
u'نكاح قَدَرُ':Added, #5: 5	نِكَاحَ فُلَانٍ
u'نكاح قَدَر':Added, #1: 1	نِكَاحِ الْقَدَرِيَّةِ
u'نِكَاحٌ قَدَرُ':Added, #1: 1	نِكَاحِ الْقَدَرِيَّةِ
u'نِكَاحٌ قَدَر':Added, #1: 1	نِكَاحِ الْقَدَرِيَّةِ
u'نكاح قَدَرِيّ':Added, #1: 1	نِكَاحِ الْقَدَرِيَّةِ
u'نِكَاحٌ قَدَرِيّ':Added, #1: 1	نِكَاحِ الْقَدَرِيَّةِ
u'نكاح قَرَابَةٌ':Added, #1: 1	نِكَاحِ الْقَدَرِيَّةِ
u'نِكَاحٌ قَرَابَةٌ':Added, #1: 1	نِكَاحِ الْقَرَابَةِ
u'نكاح قَرِيبٌ':Added, #1: 1	نِكَاحِ الْقَرَابَةِ
u'نِكَاحٌ قَرِيبٌ':Added, #1: 1	نِكَاحِ الْقَرِيبَةِ
u'نكاح قِنٌّ':Added, #1: 1	نِكَاحِ الْقَرِيبَةِ
u'نِكَاحٌ قِنٌّ':Added, #1: 1	نِكَاحُ الْقِنِّ
u'نكاح كَافِرٌ':Added, #1: 1	نِكَاحُ الْقِنِّ
u'نِكَاحٌ كَافِرٌ':Added, #10: 10	نِكَاحِ الْكَافِرِ
u'نكاح كَافِرٌ':Added, #10: 10	نِكَاحِ الْكَافِرِ
u'نِكَاحٌ كَافِرٌ':Added, #1: 1	نِكَاحِ الْكَافِرَةِ
u'نكاح كَافِرٌ':Added, #1: 1	نِكَاحِ الْكَافِرَةِ
u'نِكَاحٌ كَافِرٌ':Added, #1: 1	نِكَاحِ الْكَافِرَيْنِ
u'نكاح كَافِرٌ':Added, #1: 1	نِكَاحِ الْكَافِرَيْنِ
u'نِكَاحٌ كَافِرٌ':Added, #1: 1	نِكَاحُ كَافِرٍ
u'نكاح كَافِرٌ':Added, #1: 1	نِكَاحُ كَافِرٍ
u'نكاح كَافِرٌ':Added, #1: 1	نِكَاحَ كَافِرَةٍ
u'نِكَاحٌ كَافِرٌ':Added, #1: 1	نِكَاحُ كَافِرَةٍ
u'نِكَاحٌ كَافِرٌ':Added, #1: 1	نِكَاحَ كَافِرَةٍ
u'نكاح كَافِرٌ':Added, #1: 1	نِكَاحُ كَافِرَةٍ
u'نِكَاحٌ كَافِرٌ':Added, #2: 2	نِكَاحَ الْكَافِرِ
u'نكاح كَافِرٌ':Added, #2: 2	نِكَاحَ الْكَافِرِ
u'نِكَاحٌ كَافِرٌ':Added, #2: 2	نِكَاحُ الْكَافِرَةِ
u'نكاح كَبِيرٌ':Added, #2: 2	نِكَاحُ الْكَافِرَةِ
u'نِكَاحٌ كَبِيرٌ':Added, #1: 1	نِكَاحِ الْكَبِيرَةِ
u'نكاح كَبِيرٌ':Added, #1: 1	نِكَاحِ الْكَبِيرَةِ
u'نِكَاحٌ كَبِيرٌ':Added, #4: 4	نِكَاحُ الْكَبِيرَةِ
u'نكاح كِتاب':Added, #4: 4	نِكَاحُ الْكَبِيرَةِ
u'نِكَاحٌ كِتاب':Added, #2: 2	نِكَاحَ الْكِتَابِيَّةِ
u'نكاح كِتاب':Added, #2: 2	نِكَاحَ الْكِتَابِيَّةِ
u'نِكَاحٌ كِتاب':Added, #2: 2	نِكَاحِ كِتَابِيَّةٍ
u'نكاح كِتاب':Added, #2: 2	نِكَاحِ كِتَابِيَّةٍ
u'نِكَاحٌ كِتاب':Added, #3: 3	نِكَاحِ الْكِتَابِيَّةِ
u'نكاح كِتاب':Added, #3: 3	نِكَاحِ الْكِتَابِيَّةِ
u'نِكَاحٌ كِتاب':Added, #5: 5	نِكَاحُ الْكِتَابِيَّةِ
u'نكاح كِتابَة':Added, #5: 5	نِكَاحُ الْكِتَابِيَّةِ
u'نِكَاحٌ كِتابَة':Added, #2: 2	نِكَاحَ الْكِتَابِيَّةِ
u'نكاح كِتابَة':Added, #2: 2	نِكَاحَ الْكِتَابِيَّةِ
u'نِكَاحٌ كِتابَة':Added, #2: 2	نِكَاحِ كِتَابِيَّةٍ
u'نكاح كِتابَة':Added, #2: 2	نِكَاحِ كِتَابِيَّةٍ
u'نِكَاحٌ كِتابَة':Added, #3: 3	نِكَاحِ الْكِتَابِيَّةِ
u'نكاح كِتابَة':Added, #3: 3	نِكَاحِ الْكِتَابِيَّةِ
u'نِكَاحٌ كِتابَة':Added, #5: 5	نِكَاحُ الْكِتَابِيَّةِ
u'نكاح كِتابِيّ':Added, #5: 5	نِكَاحُ الْكِتَابِيَّةِ
u'نِكَاحٌ كِتابِيّ':Added, #2: 2	نِكَاحَ الْكِتَابِيَّةِ
u'نكاح كِتابِيّ':Added, #2: 2	نِكَاحَ الْكِتَابِيَّةِ
u'نِكَاحٌ كِتابِيّ':Added, #2: 2	نِكَاحِ كِتَابِيَّةٍ
u'نكاح كِتابِيّ':Added, #2: 2	نِكَاحِ كِتَابِيَّةٍ
u'نِكَاحٌ كِتابِيّ':Added, #3: 3	نِكَاحِ الْكِتَابِيَّةِ
u'نكاح كِتابِيّ':Added, #3: 3	نِكَاحِ الْكِتَابِيَّةِ
u'نِكَاحٌ كِتابِيّ':Added, #5: 5	نِكَاحُ الْكِتَابِيَّةِ
u'نكاح كُفَّارٌ':Added, #5: 5	نِكَاحُ الْكِتَابِيَّةِ
u'نِكَاحٌ كُفَّارٌ':Added, #13: 13	نِكَاحِ الْكُفَّارِ
u'نكاح كُفَّارٌ':Added, #13: 13	نِكَاحِ الْكُفَّارِ
u'نكاح كُفَّارٌ':Added, #1: 1	نِكَاحَ الْكُفَّارِ
u'نِكَاحٌ كُفَّارٌ':Added, #1: 1	نِكَاحُ الْكُفَّارِ
u'نِكَاحٌ كُفَّارٌ':Added, #1: 1	نِكَاحَ الْكُفَّارِ
u'نكاح لاَزِمٌ':Added, #1: 1	نِكَاحُ الْكُفَّارِ
u'نِكَاحٌ لاَزِمٌ':Added, #5: 5	نِكَاحٍ لَازِمٍ
u'نكاح مُتَخَلِّف':Added, #5: 5	نِكَاحٍ لَازِمٍ
u'نِكَاحٌ مُتَخَلِّف':Added, #1: 1	نِكَاحِ الْمُتَخَلِّفَاتِ
u'نكاح مُتْعَةٌ':Added, #1: 1	نِكَاحِ الْمُتَخَلِّفَاتِ
u'نِكَاحٌ مُتْعَةٌ':Added, #12: 12	نِكَاحَ الْمُتْعَةِ
u'نكاح مُتْعَةٌ':Added, #12: 12	نِكَاحَ الْمُتْعَةِ
u'نِكَاحٌ مُتْعَةٌ':Added, #15: 15	نِكَاحُ الْمُتْعَةِ
u'نكاح مُتْعَةٌ':Added, #15: 15	نِكَاحُ الْمُتْعَةِ
u'نِكَاحٌ مُتْعَةٌ':Added, #1: 1	نِكَاحُ مُتْعَةٍ
u'نكاح مُتْعَةٌ':Added, #1: 1	نِكَاحُ مُتْعَةٍ
u'نِكَاحٌ مُتْعَةٌ':Added, #3: 3	نِكَاحَ مُتْعَةٍ
u'نكاح مُتْعَةٌ':Added, #3: 3	نِكَاحَ مُتْعَةٍ
u'نِكَاحٌ مُتْعَةٌ':Added, #45: 45	نِكَاحِ الْمُتْعَةِ
u'نكاح مُتَّفَقٌ':Added, #45: 45	نِكَاحِ الْمُتْعَةِ
u'نِكَاحٌ مُتَّفَقٌ':Added, #1: 1	نِكَاحٍ مُتَّفَقٍ
u'نكاح مُتَقَدِّمٌ':Added, #1: 1	نِكَاحٍ مُتَّفَقٍ
u'نِكَاحٌ مُتَقَدِّمٌ':Added, #2: 2	نِكَاحِ مُتَقَدِّمٍ
u'نكاح مُجْبَرٌ':Added, #2: 2	نِكَاحِ مُتَقَدِّمٍ
u'نِكَاحٌ مُجْبَرٌ':Added, #1: 1	نِكَاحَ مُجْبَرَةٍ
u'نكاح مُجْمَعٌ':Added, #1: 1	نِكَاحَ مُجْبَرَةٍ
u'نِكَاحٌ مُجْمَعٌ':Added, #4: 4	نِكَاحٍ مُجْمَعٍ
u'نكاح مَجْمُوعٌ':Added, #4: 4	نِكَاحٍ مُجْمَعٍ
u'نِكَاحٌ مَجْمُوعٌ':Added, #1: 1	نِكَاحِ مَجْمُوعِ
u'نكاح مَجْنُونٌ':Added, #1: 1	نِكَاحِ مَجْمُوعِ
u'نِكَاحٌ مَجْنُونٌ':Added, #1: 1	نِكَاحُ الْمَجْنُونِ
u'نكاح مَجْنُونٌ':Added, #1: 1	نِكَاحُ الْمَجْنُونِ
u'نِكَاحٌ مَجْنُونٌ':Added, #1: 1	نِكَاحَ مَجْنُونٍ
u'نكاح مَجُوسٌ':Added, #1: 1	نِكَاحَ مَجْنُونٍ
u'نِكَاحٌ مَجُوسٌ':Added, #3: 3	نِكَاحِ الْمَجُوسِ
u'نكاح مَجُوسِيَّةٌ':Added, #3: 3	نِكَاحِ الْمَجُوسِ
u'نِكَاحٌ مَجُوسِيَّةٌ':Added, #1: 1	نِكَاحُ الْمَجُوسِيَّاتِ
u'نكاح مَجُوسِيَّةٌ':Added, #1: 1	نِكَاحُ الْمَجُوسِيَّاتِ
u'نِكَاحٌ مَجُوسِيَّةٌ':Added, #1: 1	نِكَاحِ مَجُوسِيَّةٍ
u'نكاح مَجُوسِيَّةٌ':Added, #1: 1	نِكَاحِ مَجُوسِيَّةٍ
u'نكاح مَجُوسِيَّةٌ':Added, #2: 2	نِكَاحَ الْمَجُوسِيَّةِ
u'نِكَاحٌ مَجُوسِيَّةٌ':Added, #2: 2	نِكَاحُ الْمَجُوسِيَّةِ
u'نِكَاحٌ مَجُوسِيَّةٌ':Added, #2: 2	نِكَاحَ الْمَجُوسِيَّةِ
u'نكاح مَجُوسِيَّةٌ':Added, #2: 2	نِكَاحُ الْمَجُوسِيَّةِ
u'نِكَاحٌ مَجُوسِيَّةٌ':Added, #4: 4	نِكَاحِ الْمَجُوسِيَّةِ
u'نكاح مَحَارِمُ':Added, #4: 4	نِكَاحِ الْمَجُوسِيَّةِ
u'نِكَاحٌ مَحَارِمُ':Added, #13: 13	نِكَاحَ الْمَحَارِمِ
u'نكاح مَحَارِمُ':Added, #13: 13	نِكَاحَ الْمَحَارِمِ
u'نِكَاحٌ مَحَارِمُ':Added, #17: 17	نِكَاحِ الْمَحَارِمِ
u'نكاح مَحَارِمُ':Added, #17: 17	نِكَاحِ الْمَحَارِمِ
u'نِكَاحٌ مَحَارِمُ':Added, #6: 6	نِكَاحُ الْمَحَارِمِ
u'نكاح مُحْدِثٌ':Added, #6: 6	نِكَاحُ الْمَحَارِمِ
u'نِكَاحٌ مُحْدِثٌ':Added, #1: 1	نِكَاحِ الْمُحْدِثَيْنِ
u'نكاح مَحْرَمٌ':Added, #1: 1	نِكَاحِ الْمُحْدِثَيْنِ
u'نكاح مُحَرَّمٌ':Added, #1: 1	نِكَاحَ الْمَحْرَمِ
u'نِكَاحٌ مَحْرَمٌ':Added, #1: 1	نِكَاحُ الْمُحَرَّمِ
u'نِكَاحٌ مُحَرَّمٌ':Added, #1: 1	نِكَاحَ الْمَحْرَمِ
u'نكاح مُحَرَّمٌ':Added, #1: 1	نِكَاحُ الْمُحَرَّمِ
u'نكاح مُحَرَّمٌ':Added, #1: 1	نِكَاحَ الْمُحَرَّمَاتِ
u'نِكَاحٌ مُحَرَّمٌ':Added, #1: 1	نِكَاحِ الْمُحَرَّمَاتِ
u'نِكَاحٌ مُحَرَّمٌ':Added, #1: 1	نِكَاحَ الْمُحَرَّمَاتِ
u'نكاح مُحَرَّمٌ':Added, #1: 1	نِكَاحِ الْمُحَرَّمَاتِ
u'نكاح مُحْرِمٌ':Added, #1: 1	نِكَاحٍ مُحَرَّمٍ
u'نِكَاحٌ مُحَرَّمٌ':Added, #1: 1	نِكَاحَ مُحْرِمٍ
u'نِكَاحٌ مُحْرِمٌ':Added, #1: 1	نِكَاحٍ مُحَرَّمٍ
u'نكاح مَحْرَمٌ':Added, #1: 1	نِكَاحَ مُحْرِمٍ
u'نِكَاحٌ مَحْرَمٌ':Added, #2: 2	نِكَاحِ الْمَحْرَمِ
u'نكاح مُحْرِمٌ':Added, #2: 2	نِكَاحِ الْمَحْرَمِ
u'نِكَاحٌ مُحْرِمٌ':Added, #4: 4	نِكَاحُ الْمُحْرِمِ
u'نكاح مُحْرِمٌ':Added, #4: 4	نِكَاحُ الْمُحْرِمِ
u'نِكَاحٌ مُحْرِمٌ':Added, #8: 8	نِكَاحِ الْمُحْرِمِ
u'نكاح مَحْض':Added, #8: 8	نِكَاحِ الْمُحْرِمِ
u'نِكَاحٌ مَحْض':Added, #1: 1	نِكَاحِ الْمَحْضَةِ
u'نكاح مُحَلِّل':Added, #1: 1	نِكَاحِ الْمَحْضَةِ
u'نِكَاحٌ مُحَلِّل':Added, #1: 1	نِكَاحُ مُحَلِّلٍ
u'نكاح مُحَلِّل':Added, #1: 1	نِكَاحُ مُحَلِّلٍ
u'نِكَاحٌ مُحَلِّل':Added, #3: 3	نِكَاحَ الْمُحَلِّلِ
u'نكاح مُحَلِّل':Added, #3: 3	نِكَاحَ الْمُحَلِّلِ
u'نِكَاحٌ مُحَلِّل':Added, #5: 5	نِكَاحُ الْمُحَلِّلِ
u'نكاح مُحَلِّل':Added, #5: 5	نِكَاحُ الْمُحَلِّلِ
u'نِكَاحٌ مُحَلِّل':Added, #6: 6	نِكَاحِ الْمُحَلِّلِ
u'نكاح مُخْتَلِفٌ':Added, #6: 6	نِكَاحِ الْمُحَلِّلِ
u'نِكَاحٌ مُخْتَلِفٌ':Added, #1: 1	نِكَاحِ الْمُخْتَلِفَةِ
u'نكاح مُخْتَلِفٌ':Added, #1: 1	نِكَاحِ الْمُخْتَلِفَةِ
u'نِكَاحٌ مُخْتَلِفٌ':Added, #1: 1	نِكَاحٍ مُخْتَلِفٍ
u'نكاح مُخْتَلَفٌ':Added, #1: 1	نِكَاحٍ مُخْتَلِفٍ
u'نِكَاحٌ مُخْتَلَفٌ':Added, #7: 7	نِكَاحٍ مُخْتَلَفٍ
u'نكاح مُدَّعِي':Added, #7: 7	نِكَاحٍ مُخْتَلَفٍ
u'نِكَاحٌ مُدَّعِي':Added, #1: 1	نِكَاحُ الْمُدَّعِيَةِ
u'نكاح مُرَاهِقٌ':Added, #1: 1	نِكَاحُ الْمُدَّعِيَةِ
u'نِكَاحٌ مُرَاهِقٌ':Added, #2: 2	نِكَاحِ الْمُرَاهِقَةِ
u'نكاح مُرْتَدٌّ':Added, #2: 2	نِكَاحِ الْمُرَاهِقَةِ
u'نِكَاحٌ مُرْتَدٌّ':Added, #1: 1	نِكَاحِ الْمُرْتَدِّ
u'نكاح مُرْتَدٌّ':Added, #1: 1	نِكَاحِ الْمُرْتَدِّ
u'نِكَاحٌ مُرْتَدٌّ':Added, #1: 1	نِكَاحَ الْمُرْتَدَّةِ
u'نكاح مُرْتَدٌّ':Added, #1: 1	نِكَاحَ الْمُرْتَدَّةِ
u'نِكَاحٌ مُرْتَدٌّ':Added, #3: 3	نِكَاحُ الْمُرْتَدَّةِ
u'نكاح مَرِيضٌ':Added, #3: 3	نِكَاحُ الْمُرْتَدَّةِ
u'نِكَاحٌ مَرِيضٌ':Added, #3: 3	نِكَاحِ الْمَرِيضِ
u'نكاح مَرِيضٌ':Added, #3: 3	نِكَاحِ الْمَرِيضِ
u'نِكَاحٌ مَرِيضٌ':Added, #5: 5	نِكَاحَ الْمَرِيضِ
u'نكاح مَرِيضٌ':Added, #5: 5	نِكَاحَ الْمَرِيضِ
u'نِكَاحٌ مَرِيضٌ':Added, #8: 8	نِكَاحُ الْمَرِيضِ
u'نكاح مُسْلِمٌ':Added, #8: 8	نِكَاحُ الْمَرِيضِ
u'نِكَاحٌ مُسْلِمٌ':Added, #1: 1	نِكَاحَ الْمُسْلِمِ
u'نكاح مُسْلِمٌ':Added, #1: 1	نِكَاحَ الْمُسْلِمِ
u'نِكَاحٌ مُسْلِمٌ':Added, #1: 1	نِكَاحِ الْمُسْلِمَاتِ
u'نكاح مُسْلِمٌ':Added, #1: 1	نِكَاحِ الْمُسْلِمَاتِ
u'نِكَاحٌ مُسْلِمٌ':Added, #1: 1	نِكَاحَ الْمُسْلِمَةِ
u'نكاح مُسْلِمٌ':Added, #1: 1	نِكَاحَ الْمُسْلِمَةِ
u'نِكَاحٌ مُسْلِمٌ':Added, #1: 1	نِكَاحُ مُسْلِمٍ
u'نكاح مُسْلِمٌ':Added, #1: 1	نِكَاحُ مُسْلِمٍ
u'نِكَاحٌ مُسْلِمٌ':Added, #1: 1	نِكَاحُ مُسْلِمَةٍ
u'نكاح مُسْلِمٌ':Added, #1: 1	نِكَاحُ مُسْلِمَةٍ
u'نِكَاحٌ مُسْلِمٌ':Added, #2: 2	نِكَاحُ الْمُسْلِمَةِ
u'نكاح مُسْلِمٌ':Added, #2: 2	نِكَاحُ الْمُسْلِمَةِ
u'نِكَاحٌ مُسْلِمٌ':Added, #3: 3	نِكَاحُ الْمُسْلِمِ
u'نكاح مُسْلِمٌ':Added, #3: 3	نِكَاحُ الْمُسْلِمِ
u'نِكَاحٌ مُسْلِمٌ':Added, #4: 4	نِكَاحِ الْمُسْلِمِ
u'نكاح مُسْلِمٌ':Added, #4: 4	نِكَاحِ الْمُسْلِمِ
u'نِكَاحٌ مُسْلِمٌ':Added, #5: 5	نِكَاحِ الْمُسْلِمَةِ
u'نكاح مُسْلِمٌ':Added, #5: 5	نِكَاحِ الْمُسْلِمَةِ
u'نكاح مُسْلِمٌ':Added, #5: 5	نِكَاحَ مُسْلِمَةٍ
u'نِكَاحٌ مُسْلِمٌ':Added, #5: 5	نِكَاحِ مُسْلِمَةٍ
u'نِكَاحٌ مُسْلِمٌ':Added, #5: 5	نِكَاحَ مُسْلِمَةٍ
u'نكاح مُشْتَرَكٌ':Added, #5: 5	نِكَاحِ مُسْلِمَةٍ
u'نِكَاحٌ مُشْتَرَكٌ':Added, #1: 1	نِكَاحُ الْمُشْتَرَكِ
u'نكاح مُشْرِك':Added, #1: 1	نِكَاحُ الْمُشْتَرَكِ
u'نِكَاحٌ مُشْرِك':Added, #1: 1	نِكَاحُ الْمُشْرِكَةِ
u'نكاح مُشْرِك':Added, #1: 1	نِكَاحُ الْمُشْرِكَةِ
u'نِكَاحٌ مُشْرِك':Added, #20: 20	نِكَاحِ الْمُشْرِكِ
u'نكاح مُشْرِك':Added, #20: 20	نِكَاحِ الْمُشْرِكِ
u'نِكَاحٌ مُشْرِك':Added, #2: 2	نِكَاحِ الْمُشْرِكَةِ
u'نكاح مُشْرِك':Added, #2: 2	نِكَاحِ الْمُشْرِكَةِ
u'نِكَاحٌ مُشْرِك':Added, #5: 5	نِكَاحِ الْمُشْرِكَاتِ
u'نكاح مُطَلَّقٌ':Added, #5: 5	نِكَاحِ الْمُشْرِكَاتِ
u'نِكَاحٌ مُطَلَّقٌ':Added, #1: 1	نِكَاحِ الْمُطَلَّقَةِ
u'نكاح مُطَلَّقٌ':Added, #1: 1	نِكَاحِ الْمُطَلَّقَةِ
u'نِكَاحٌ مُطَلَّقٌ':Added, #2: 2	نِكَاحَ مُطَلَّقَتِهِ
u'نكاح مُعْتَدٌّ':Added, #2: 2	نِكَاحَ مُطَلَّقَتِهِ
u'نِكَاحٌ مُعْتَدٌّ':Added, #1: 1	نِكَاحُ الْمُعْتَدَّةِ
u'نكاح مُعْتَدٌّ':Added, #1: 1	نِكَاحُ الْمُعْتَدَّةِ
u'نِكَاحٌ مُعْتَدٌّ':Added, #1: 1	نِكَاحُ مُعْتَدَّةِ
u'نكاح مُعْتَدٌّ':Added, #1: 1	نِكَاحُ مُعْتَدَّةِ
u'نِكَاحٌ مُعْتَدٌّ':Added, #1: 1	نِكَاحِ مُعْتَدَّتِهِ
u'نكاح مُعْتَدٌّ':Added, #1: 1	نِكَاحِ مُعْتَدَّتِهِ
u'نِكَاحٌ مُعْتَدٌّ':Added, #8: 8	نِكَاحِ الْمُعْتَدَّةِ
u'نكاح مُعْتَقٌ':Added, #8: 8	نِكَاحِ الْمُعْتَدَّةِ
u'نكاح مُعْتَقٌ':Added, #1: 1	نِكَاحَ الْمُعْتَقَةِ
u'نكاح مُعْتَقٌ':Added, #1: 1	نِكَاحُ الْمُعْتَقَةِ
u'نِكَاحٌ مُعْتَقٌ':Added, #1: 1	نِكَاحِ الْمُعْتَقَةِ
u'نِكَاحٌ مُعْتَقٌ':Added, #1: 1	نِكَاحَ الْمُعْتَقَةِ
u'نِكَاحٌ مُعْتَقٌ':Added, #1: 1	نِكَاحُ الْمُعْتَقَةِ
u'نكاح مُعْسِرٌ':Added, #1: 1	نِكَاحِ الْمُعْتَقَةِ
u'نِكَاحٌ مُعْسِرٌ':Added, #1: 1	نِكَاحِ الْمُعْسِرِ
u'نكاح مَغْرُورٌ':Added, #1: 1	نِكَاحِ الْمُعْسِرِ
u'نِكَاحٌ مَغْرُورٌ':Added, #1: 1	نِكَاحِ الْمَغْرُورِ
u'نكاح مُفَارِقٌ':Added, #1: 1	نِكَاحِ الْمَغْرُورِ
u'نِكَاحٌ مُفَارِقٌ':Added, #1: 1	نِكَاحِ مُفَارِقَتِهِ
u'نكاح مَفْقُودٌ':Added, #1: 1	نِكَاحِ مُفَارِقَتِهِ
u'نِكَاحٌ مَفْقُودٌ':Added, #1: 1	نِكَاحِ الْمَفْقُودِ
u'نكاح مَقْتُولٌ':Added, #1: 1	نِكَاحِ الْمَفْقُودِ
u'نِكَاحٌ مَقْتُولٌ':Added, #1: 1	نِكَاحِ الْمَقْتُولِ
u'نكاح مُكَاتَبَةٌ':Added, #1: 1	نِكَاحِ الْمَقْتُولِ
u'نِكَاحٌ مُكَاتَبَةٌ':Added, #1: 1	نِكَاحَ مُكَاتَبَتِهِ
u'نكاح مُكْرَهٌ':Added, #1: 1	نِكَاحَ مُكَاتَبَتِهِ
u'نِكَاحٌ مُكْرَهٌ':Added, #1: 1	نِكَاحِ الْمُكْرَهِ
u'نكاح مُكْرَهٌ':Added, #1: 1	نِكَاحِ الْمُكْرَهِ
u'نِكَاحٌ مُكْرَهٌ':Added, #1: 1	نِكَاحِ الْمُكْرَهَةِ
u'نكاح مَكِّيّ':Added, #1: 1	نِكَاحِ الْمُكْرَهَةِ
u'نِكَاحٌ مَكِّيّ':Added, #1: 1	نِكَاحُ الْمَكِّيَّةِ
u'نكاح مُلْتَقِط':Added, #1: 1	نِكَاحُ الْمَكِّيَّةِ
u'نِكَاحٌ مُلْتَقِط':Added, #1: 1	نِكَاحِ الْمُلْتَقِطِ
u'نكاح مِلْكٌ':Added, #1: 1	نِكَاحِ الْمُلْتَقِطِ
u'نِكَاحٌ مِلْكٌ':Added, #1: 1	نِكَاحَ مِلْكٍ
u'نكاح مُنْفَرِدٌ':Added, #1: 1	نِكَاحَ مِلْكٍ
u'نِكَاحٌ مُنْفَرِدٌ':Added, #1: 1	نِكَاحِ الْمُنْفَرِدَتَيْنِ
u'نكاح مَنْكُوح':Added, #1: 1	نِكَاحِ الْمُنْفَرِدَتَيْنِ
u'نِكَاحٌ مَنْكُوح':Added, #1: 1	نِكَاحُ مَنْكُوحَةِ
u'نكاح مَنْكُوح':Added, #1: 1	نِكَاحُ مَنْكُوحَةِ
u'نِكَاحٌ مَنْكُوح':Added, #2: 2	نِكَاحِ مَنْكُوحَاتِ
u'نكاح مَنْكُوح':Added, #2: 2	نِكَاحِ مَنْكُوحَاتِ
u'نِكَاحٌ مَنْكُوح':Added, #3: 3	نِكَاحَ الْمَنْكُوحَةِ
u'نكاح مُهَاجِرٌ':Added, #3: 3	نِكَاحَ الْمَنْكُوحَةِ
u'نِكَاحٌ مُهَاجِرٌ':Added, #1: 1	نِكَاحِ الْمُهَاجِرَاتِ
u'نكاح مُهَاجِرٌ':Added, #1: 1	نِكَاحِ الْمُهَاجِرَاتِ
u'نكاح مُهَاجِرٌ':Added, #1: 1	نِكَاحَ الْمُهَاجِرَةِ
u'نِكَاحٌ مُهَاجِرٌ':Added, #1: 1	نِكَاحُ الْمُهَاجِرَةِ
u'نِكَاحٌ مُهَاجِرٌ':Added, #1: 1	نِكَاحَ الْمُهَاجِرَةِ
u'نكاح مُوجِبٌ':Added, #1: 1	نِكَاحُ الْمُهَاجِرَةِ
u'نِكَاحٌ مُوجِبٌ':Added, #1: 1	نِكَاحٍ مُوجِبٍ
u'نكاح مَوْقُوفٌ':Added, #1: 1	نِكَاحٍ مُوجِبٍ
u'نِكَاحٌ مَوْقُوفٌ':Added, #2: 2	نِكَاحٍ مَوْقُوفٍ
u'نكاح مُؤْمِنٌ':Added, #2: 2	نِكَاحٍ مَوْقُوفٍ
u'نِكَاحٌ مُؤْمِنٌ':Added, #1: 1	نِكَاحَ الْمُؤْمِنَةِ
u'نكاح مَوْهُوبٌ':Added, #1: 1	نِكَاحَ الْمُؤْمِنَةِ
u'نِكَاحٌ مَوْهُوبٌ':Added, #1: 1	نِكَاحُ الْمَوْهُوبَةِ
u'نكاح نَاسٌ':Added, #1: 1	نِكَاحُ الْمَوْهُوبَةِ
u'نِكَاحٌ نَاسٌ':Added, #1: 1	نِكَاحَ النَّاسِ
u'نكاح نَاسٌ':Added, #1: 1	نِكَاحَ النَّاسِ
u'نِكَاحٌ نَاسٌ':Added, #3: 3	نِكَاحُ النَّاسِ
u'نكاح نَبِيٌّ':Added, #3: 3	نِكَاحُ النَّاسِ
u'نكاح نَبِيٌّ':Added, #1: 1	نِكَاحَ النَّبِيِّ
u'نكاح نَبِيٌّ':Added, #1: 1	نِكَاحُ النَّبِيِّ
u'نِكَاحٌ نَبِيٌّ':Added, #1: 1	نِكَاحِ النَّبِيِّ
u'نِكَاحٌ نَبِيٌّ':Added, #1: 1	نِكَاحَ النَّبِيِّ
u'نِكَاحٌ نَبِيٌّ':Added, #1: 1	نِكَاحُ النَّبِيِّ
u'نكاح نَحْوٌ':Added, #1: 1	نِكَاحِ النَّبِيِّ
u'نِكَاحٌ نَحْوٌ':Added, #1: 1	نِكَاحِ نَحْوِ
u'نكاح نِساءٌ':Added, #1: 1	نِكَاحِ نَحْوِ
u'نكاح نِساءٌ':Added, #1: 1	نِكَاحَ نِسَاءٍ
u'نِكَاحٌ نِساءٌ':Added, #1: 1	نِكَاحِ نِسَاءِ
u'نِكَاحٌ نِساءٌ':Added, #1: 1	نِكَاحَ نِسَاءٍ
u'نكاح نِساءٌ':Added, #1: 1	نِكَاحِ نِسَاءِ
u'نِكَاحٌ نِساءٌ':Added, #2: 2	نِكَاحِ النِّسَاءِ
u'نكاح نَصْرَانِيٌّ':Added, #2: 2	نِكَاحِ النِّسَاءِ
u'نِكَاحٌ نَصْرَانِيٌّ':Added, #2: 2	نِكَاحِ نَصْرَانِيَّةٍ
u'نكاح نَصْرَانِيَّةٌ':Added, #2: 2	نِكَاحِ نَصْرَانِيَّةٍ
u'نِكَاحٌ نَصْرَانِيَّةٌ':Added, #2: 2	نِكَاحِ نَصْرَانِيَّةٍ
u'نكاح نَفْسٌ':Added, #2: 2	نِكَاحِ نَصْرَانِيَّةٍ
u'نكاح نَفْسٌ':Added, #1: 1	نِكَاحَ نَفْسِهِ
u'نِكَاحٌ نَفْسٌ':Added, #1: 1	نِكَاحِ نَفْسِهِ
u'نِكَاحٌ نَفْسٌ':Added, #1: 1	نِكَاحَ نَفْسِهِ
u'نكاح هَازِلٌ':Added, #1: 1	نِكَاحِ نَفْسِهِ
u'نِكَاحٌ هَازِلٌ':Added, #1: 1	نِكَاحُ الْهَازِلِ
u'نكاح هَازِلٌ':Added, #1: 1	نِكَاحُ الْهَازِلِ
u'نِكَاحٌ هَازِلٌ':Added, #2: 2	نِكَاحِ الْهَازِلِ
u'نكاح هَاشِمٌ':Added, #2: 2	نِكَاحِ الْهَازِلِ
u'نِكَاحٌ هَاشِمٌ':Added, #1: 1	نِكَاحَ هَاشِمٍ
u'نكاح هَزْلٌ':Added, #1: 1	نِكَاحَ هَاشِمٍ
u'نِكَاحٌ هَزْلٌ':Added, #1: 1	نِكَاحِ الْهَزْلِ
u'نكاح واحد':Added, #1: 1	نِكَاحِ الْهَزْلِ
u'نكاح واحد':Added, #1: 1	نِكَاحَ وَاحِدٍ
u'نِكَاحٌ واحد':Added, #1: 1	نِكَاحُ وَاحِدٍ
u'نِكَاحٌ واحد':Added, #1: 1	نِكَاحَ وَاحِدٍ
u'نكاح وَاحِدٌ':Added, #1: 1	نِكَاحُ وَاحِدٍ
u'نكاح وَاحِدٌ':Added, #1: 1	نِكَاحَ وَاحِدٍ
u'نِكَاحٌ وَاحِدٌ':Added, #1: 1	نِكَاحُ وَاحِدٍ
u'نِكَاحٌ وَاحِدٌ':Added, #1: 1	نِكَاحَ وَاحِدٍ
u'نكاح واحد':Added, #1: 1	نِكَاحُ وَاحِدٍ
u'نِكَاحٌ واحد':Added, #1: 1	نِكَاحَ وَاحِدَةٍ
u'نكاح وَاحِدٌ':Added, #1: 1	نِكَاحَ وَاحِدَةٍ
u'نِكَاحٌ وَاحِدٌ':Added, #1: 1	نِكَاحَ وَاحِدَةٍ
u'نكاح واحد':Added, #1: 1	نِكَاحَ وَاحِدَةٍ
u'نِكَاحٌ واحد':Added, #2: 2	نِكَاحَ الْوَاحِدَةِ
u'نكاح وَاحِدٌ':Added, #2: 2	نِكَاحَ الْوَاحِدَةِ
u'نِكَاحٌ وَاحِدٌ':Added, #2: 2	نِكَاحَ الْوَاحِدَةِ
u'نكاح واحد':Added, #2: 2	نِكَاحَ الْوَاحِدَةِ
u'نِكَاحٌ واحد':Added, #2: 2	نِكَاحٍ وَاحِدٍ
u'نكاح وَاحِدٌ':Added, #2: 2	نِكَاحٍ وَاحِدٍ
u'نِكَاحٌ وَاحِدٌ':Added, #2: 2	نِكَاحٍ وَاحِدٍ
u'نكاح واحد':Added, #2: 2	نِكَاحٍ وَاحِدٍ
u'نِكَاحٌ واحد':Added, #3: 3	نِكَاحِ الْوَاحِدَةِ
u'نكاح وَاحِدٌ':Added, #3: 3	نِكَاحِ الْوَاحِدَةِ
u'نِكَاحٌ وَاحِدٌ':Added, #3: 3	نِكَاحِ الْوَاحِدَةِ
u'نكاح واحد':Added, #3: 3	نِكَاحِ الْوَاحِدَةِ
u'نِكَاحٌ واحد':Added, #4: 4	نِكَاحِ وَاحِدَةٍ
u'نكاح وَاحِدٌ':Added, #4: 4	نِكَاحِ وَاحِدَةٍ
u'نِكَاحٌ وَاحِدٌ':Added, #4: 4	نِكَاحِ وَاحِدَةٍ
u'نكاح واحد':Added, #4: 4	نِكَاحِ وَاحِدَةٍ
u'نِكَاحٌ واحد':Added, #5: 5	نِكَاحُ الْوَاحِدَةِ
u'نكاح وَاحِدٌ':Added, #5: 5	نِكَاحُ الْوَاحِدَةِ
u'نِكَاحٌ وَاحِدٌ':Added, #5: 5	نِكَاحُ الْوَاحِدَةِ
u'نكاح واحد':Added, #5: 5	نِكَاحُ الْوَاحِدَةِ
u'نِكَاحٌ واحد':Added, #6: 6	نِكَاحُ وَاحِدَةٍ
u'نكاح وَاحِدٌ':Added, #6: 6	نِكَاحُ وَاحِدَةٍ
u'نِكَاحٌ وَاحِدٌ':Added, #6: 6	نِكَاحُ وَاحِدَةٍ
u'نكاح وَاهِبٌ':Added, #6: 6	نِكَاحُ وَاحِدَةٍ
u'نِكَاحٌ وَاهِبٌ':Added, #1: 1	نِكَاحَ الْوَاهِبَةِ
u'نكاح وَثَنِيٌّ':Added, #1: 1	نِكَاحَ الْوَاهِبَةِ
u'نِكَاحٌ وَثَنِيٌّ':Added, #1: 1	نِكَاحُ الْوَثَنِيَّةِ
u'نكاح وَكِيلٌ':Added, #1: 1	نِكَاحُ الْوَثَنِيَّةِ
u'نِكَاحٌ وَكِيلٌ':Added, #1: 1	نِكَاحِ الْوَكِيلِ
u'نكاح وَكِيلٌ':Added, #1: 1	نِكَاحِ الْوَكِيلِ
u'نِكَاحٌ وَكِيلٌ':Added, #2: 2	نِكَاحُ الْوَكِيلِ
u'نكاح وِلاَيَةٌ':Added, #2: 2	نِكَاحُ الْوَكِيلِ
u'نِكَاحٌ وِلاَيَةٌ':Added, #1: 1	نِكَاحَ وِلَايَتِهِ
u'نكاح وَلِيٌّ':Added, #1: 1	نِكَاحَ وِلَايَتِهِ
u'نِكَاحٌ وَلِيٌّ':Added, #1: 1	نِكَاحَ وَلِيَّتِهِ
u'نكاح وَلِيٌّ':Added, #1: 1	نِكَاحَ وَلِيَّتِهِ
u'نِكَاحٌ وَلِيٌّ':Added, #5: 5	نِكَاحُ الْوَلِيِّ
u'نكاح وهبة':Added, #5: 5	نِكَاحُ الْوَلِيِّ
u'نِكَاحٌ وهبة':Added, #1: 1	نِكَاحٍ وَهِبَةٍ
u'نكاح يَتِيمٌ':Added, #1: 1	نِكَاحٍ وَهِبَةٍ
u'نِكَاحٌ يَتِيمٌ':Added, #1: 1	نِكَاحَ الْيَتِيمِ
u'نكاح يَتِيمٌ':Added, #1: 1	نِكَاحَ الْيَتِيمِ
u'نكاح يَتِيمٌ':Added, #1: 1	نِكَاحَ الْيَتِيمَةِ
u'نكاح يَتِيمٌ':Added, #1: 1	نِكَاحُ الْيَتِيمَةِ
u'نِكَاحٌ يَتِيمٌ':Added, #1: 1	نِكَاحِ الْيَتِيمَةِ
u'نِكَاحٌ يَتِيمٌ':Added, #1: 1	نِكَاحَ الْيَتِيمَةِ
u'نِكَاحٌ يَتِيمٌ':Added, #1: 1	نِكَاحُ الْيَتِيمَةِ
u'نكاح يَهُودِيٌّ':Added, #1: 1	نِكَاحِ الْيَتِيمَةِ
u'نِكَاحٌ يَهُودِيٌّ':Added, #2: 2	نِكَاحَ الْيَهُودِيَّةِ
u'نِكَايَةٌ جِرَاحَاتٌ':Added, #2: 2	نِكَاحَ الْيَهُودِيَّةِ
u'نِكَايَةٌ جِرَاحَةٌ':Added, #1: 1	نِكَايَةِ جِرَاحَاتٍ
u'نِكَايَةٌ جِرَاحَةٌ':Added, #1: 1	نِكَايَةُ الْجِرَاحَةِ
u'نِكَايَةٌ عَدُوٌّ':Added, #1: 1	نِكَايَةِ جِرَاحَاتٍ
u'نِكَايَةٌ عَدُوٌّ':Added, #1: 1	نِكَايَةُ الْعَدُوِّ
u'نِكَايَةٌ كُفَّارٌ':Added, #3: 3	نِكَايَةِ الْعَدُوِّ
u'نَكَبَ أُصْبُعٌ':Predicate, #1: 1	نِكَايَةِ الْكُفَّارِ
u'نَكْثٌ بَيْعَةٌ':Added, #1: 1	نَكَبَ أُصْبُعَ
u'نَكْثٌ صَفْقَةٌ':Added, #1: 1	نَكْثُ بَيْعَةِ
u'نَكْثٌ صَفْقَةٌ':Added, #2: 2	نَكْثَ الصَّفْقَةِ
u'نَكْثٌ عَهْدٌ':Added, #2: 2	نَكْثُ الصَّفْقَةِ
u'نَكَحَ أَبٌ':Subject, #1: 1	نَكْثُ عَهْدٍ
u'نَكَحَ آباءٌ':Subject, #2: 2	نَكَحَ الْأَبُ
u'نَكَحَ اِبْنٌ':Subject, #1: 1	نَكَحَ الْآبَاءُ
u'نَكَحَ اِبْنَة':Predicate, #2: 2	نَكَحَ ابْنُ
u'نَكَحَ أحَدٌ':Subject, #3: 3	نَكَحَ ابْنَةَ
u'نَكَحَ أُخْتٌ':Predicate, #2: 2	نَكَحَ أَحَدُ
u'نَكَحَ أُمٌّ':Predicate, #1: 1	نَكَحَ أُخْتَ
u'نَكَحَ أُمٌّ':Predicate, #1: 1	أَنْكَحَ أُمَّ
u'نَكَحَ أُمٌّ':Predicate, #1: 1	نَكَحَ الْأُمَّ
u'نَكَحَ أمَةٌ':Predicate, #2: 2	نَكَحَ أُمَّ
u'نَكَحَ أمَةٌ':Predicate, #2: 2	أَنْكَحَ الْأَمَةَ
u'نَكَحَ اِمْرَأَةٌ':Predicate, #3: 3	نَكَحَ الْأَمَةَ
u'نَكَحَ بَائِنٌ':Predicate, #3: 3	نَكَحَ امْرَأَةَ
u'نَكَحَ بِنْتٌ':Predicate, #4: 4	نَكَحَ الْبَائِنَ
u'نَكَحَ ثَالِثٌ':Predicate, #4: 4	نَكَحَ بِنْتَ
u'نَكَحَ جَارِي':Predicate, #1: 1	نَكَحَ ثَالِثَةً
u'نَكَحَ جَارِيَةٌ':Predicate, #3: 3	نَكَحَ جَارِيَةَ
u'نَكَحَ حُرٌّ':Predicate, #3: 3	نَكَحَ جَارِيَةَ
u'نَكَحَ حُرٌّ':Subject, #7: 7	نَكَحَ حُرَّةً
u'نَكَحَ حَرْب':Predicate, #1: 1	نَكَحَ حُرٌّ
u'نَكَحَ حَرْبَة':Predicate, #1: 1	نَكَحَ حَرْبِيَّةً
u'نَكَحَ حَرْبِيّ':Predicate, #1: 1	نَكَحَ حَرْبِيَّةً
u'نَكَحَ خَالٌ':Subject, #1: 1	نَكَحَ حَرْبِيَّةً
u'نَكَحَ خَدِيج':Predicate, #1: 1	نَكَحَ خَالُ
u'نَكَحَ ذِمِّيٌّ':Predicate, #2: 2	أَنْكَحَ خَدِيجَةَ
u'نَكَحَ ذِمِّيٌّ':Subject, #1: 1	نَكَحَ ذِمِّيَّةً
u'نَكَحَ رَجُلٌ':Subject, #4: 4	نَكَحَ ذِمِّيٌّ
u'نَكَحَ رَجُلٌ':Subject, #1: 1	نَكَحَ رَجُلٌ
u'نَكَحَ رَسُولٌ':Predicate, #2: 2	نَكَحَ الرَّجُلُ
u'نَكَحَ رَسُولٌ':Subject, #1: 1	أَنْكَحَ رَسُولَ
u'نَكَحَ زَوْجٌ':Subject, #1: 1	نَكَحَ رَسُولُ
u'نَكَحَ سَفِيهٌ':Subject, #1: 1	نَكَحَ الزَّوْجُ
u'نَكَحَ صَغِيرٌ':Predicate, #1: 1	نَكَحَ السَّفِيهُ
u'نَكَحَ عَبْدٌ':Predicate, #1: 1	نَكَحَ صَغِيرَةً
u'نَكَحَ عَبْدٌ':Subject, #1: 1	أَنْكَحَ عَبْدَ
u'نَكَحَ عَبْدٌ':Subject, #3: 3	نَكَحَ الْعَبْدُ
u'نَكَحَ عجز':Subject, #5: 5	نَكَحَ عَبْدٌ
u'نَكَحَ عَجْزٌ':Subject, #1: 1	نَكَحَ الْعَجْزُ
u'نَكَحَ فُلاَنٌ':Predicate, #1: 1	نَكَحَ الْعَجْزُ
u'نَكَحَ فلان':Predicate, #1: 1	نَكَحَ فُلَانَةَ
u'نَكَحَ قَالٌ':Predicate, #2: 2	أَنْكَحَ خَدِيجَةَ
u'نَكَحَ كَافِرٌ':Predicate, #1: 1	أَنْكَحَ قَالَ
u'نَكَحَ لاَئِقٌ':Predicate, #1: 1	نَكَحَ كَافِرَةً
u'نَكَحَ مَبْتُوت':Predicate, #1: 1	نَكَحَ لَائِقَةً
u'نَكَحَ مُتَخَلِّف':Subject, #1: 1	نَكَحَ مَبْتُوتَةً
u'نَكَحَ مَجُوسِيٌّ':Subject, #1: 1	نَكَحَ الْمُتَخَلِّفُ
u'نَكَحَ مَجُوسِيٌّ':Subject, #1: 1	نَكَحَ الْمَجُوسِيُّ
u'نَكَحَ مُرْتَدٌّ':Predicate, #1: 1	نَكَحَ مَجُوسِيٌّ
u'نَكَحَ مُسْتَأْجِرٌ':Predicate, #1: 1	نَكَحَ مُرْتَدَّةً
u'نَكَحَ مُسْلِمٌ':Predicate, #1: 1	نَكَحَ مُسْتَأْجِرَةَ
u'نَكَحَ مُسْلِمٌ':Subject, #2: 2	نَكَحَ مُسْلِمَةً
u'نَكَحَ مَشْرِقِيٌّ':Subject, #1: 1	نَكَحَ مُسْلِمٌ
u'نَكَحَ مُشْرِك':Subject, #2: 2	نَكَحَ مَشْرِقِيٌّ
u'نَكَحَ مُعْتَدٌّ':Predicate, #1: 1	نَكَحَ مُشْرِكٌ
u'نَكَحَ مُعْتَدٌّ':Predicate, #1: 1	نَكَحَ مُعْتَدَّةَ
u'نَكَحَ مُعْتَقٌ':Predicate, #2: 2	نَكَحَ مُعْتَدَّةً
u'نَكَحَ مُعْسِرٌ':Subject, #1: 1	نَكَحَ مُعْتَقَةً
u'نَكَحَ مَنْكُوح':Predicate, #1: 1	نَكَحَ الْمُعْسِرُ
u'نَكَحَ مَيْمُونٌ':Predicate, #1: 1	نَكَحَ مَنْكُوحَةَ
u'نَكَحَ نَصْرَانِيٌّ':Subject, #4: 4	نَكَحَ مَيْمُونَةَ
u'نَكَحَ نُفَسَاءُ':Predicate, #1: 1	نَكَحَ نَصْرَانِيٌّ
u'نَكَحَ نَوْمٌ':Subject, #1: 1	نَكَحَ نُفَسَاءَ
u'نَكَحَ هَالَةٌ':Predicate, #1: 1	نَكَحَ النَّوْمُ
u'نَكَحَ واحد':Predicate, #1: 1	نَكَحَ هَالَةَ
u'نَكَحَ وَاحِدٌ':Predicate, #1: 1	أَنْكَحَ وَاحِدَةً
u'نَكَحَ واحد':Predicate, #1: 1	أَنْكَحَ وَاحِدَةً
u'نَكَحَ وَاحِدٌ':Predicate, #2: 2	نَكَحَ وَاحِدَةً
u'نَكَحَ ولد':Subject, #2: 2	نَكَحَ وَاحِدَةً
u'نَكَحَ وَلَدٌ':Subject, #1: 1	نَكَحَ الْوَلَدُ
u'نَكَحَ يَهُودِيٌّ':Predicate, #1: 1	نَكَحَ الْوَلَدُ
u'نَكَحَ يَوْمٌ':Predicate, #2: 2	نَكَحَ يَهُودِيَّةً
u'نكد عَيْشٌ':Added, #1: 1	نَكَحَ الْيَوْمَ
u'نَكَدٌ عَيْشٌ':Added, #2: 2	نَكَدِ الْعَيْشِ
u'نَكِرَ إِثْبَاتٌ':Predicate, #2: 2	نَكَدِ الْعَيْشِ
u'نَكِرَ إجَارَةٌ':Predicate, #1: 1	أَنْكَرَ إِثْبَاتَ
u'نَكِرَ إِجْمَاعٌ':Predicate, #3: 3	أَنْكَرَ الْإِجَارَةَ
u'نَكِرَ إِجْهَاضٌ':Predicate, #2: 2	أَنْكَرَ الْإِجْمَاعَ
u'نَكِرَ أحَدٌ':Predicate, #1: 1	أَنْكَرَ الْإِجْهَاضَ
u'نَكِرَ أَدَاءٌ':Predicate, #2: 2	أَنْكَرَ أَحَدَ
u'نَكِرَ أَدَاءٌ':Predicate, #1: 1	أَنْكَرَ أَدَاءَ
u'نَكِرَ إِذْنٌ':Predicate, #1: 1	أَنْكَرَ الْأَدَاءَ
u'نَكِرَ إِذْنٌ':Predicate, #1: 1	أَنْكَرَ إذْنَ
u'نَكِرَ إِرْثٌ':Predicate, #3: 3	أَنْكَرَ الْإِذْنَ
u'نَكِرَ إِسْراءٌ':Predicate, #1: 1	أَنْكَرَ الْإِرْثَ
u'نَكِرَ اِشْتِراطٌ':Predicate, #2: 2	أَنْكَرَ الْإِسْرَاءَ
u'نَكِرَ اِشْتِراطٌ':Predicate, #1: 1	أَنْكَرَ اشْتِرَاطَ
u'نَكِرَ اِشْتِمالٌ':Predicate, #1: 1	أَنْكَرَ الاِشْتِرَاطَ
u'نَكِرَ أصل':Predicate, #1: 1	أَنْكَرَ اشْتِمَالَ
u'نَكِرَ أًصْلٌ':Predicate, #16: 16	أَنْكَرَ أَصْلَ
u'نَكِرَ أصل':Predicate, #16: 16	أَنْكَرَ أَصْلَ
u'نَكِرَ أًصْلٌ':Predicate, #1: 1	أَنْكَرَ الْأَصْلَ
u'نَكِرَ أُصولٌ':Predicate, #1: 1	أَنْكَرَ الْأَصْلَ
u'نَكِرَ إِعْجازٌ':Predicate, #1: 1	أَنْكَرَ أُصُولَ
u'نَكِرَ إقْرَارٌ':Predicate, #1: 1	أَنْكَرَ إعْجَازَ
u'نَكِرَ أَكْثَرُ':Predicate, #3: 3	أَنْكَرَ الْإِقْرَارَ
u'نُكْرٌ الْمَرْأَةُ':Added, #1: 1	أَنْكَرَ أَكْثَرَ
u'نَكِرَ إلَهٌ':Predicate, #1: 1	نُكْرُ الْمَرْأَةِ
u'نَكِرَ إمَامَةٌ':Predicate, #1: 1	أَنْكَرَ الْإِلَهَ
u'نَكِرَ أَمْرٌ':Predicate, #1: 1	أَنْكَرَ إمَامَةَ
u'نَكِرَ إِيدَاعٌ':Predicate, #1: 1	أَنْكَرَ الْأَمْرَ
u'نَكِرَ بَاطن':Predicate, #3: 3	أَنْكَرَ الْإِيدَاعَ
u'نَكِرَ باطِنٌ':Predicate, #1: 1	أَنْكَرَ الْبَاطِنَ
u'نَكِرَ بَعْثٌ':Predicate, #1: 1	أَنْكَرَ الْبَاطِنَ
u'نَكِرَ بَعْثٌ':Predicate, #2: 2	أَنْكَرَ بَعْثَ
u'نَكِرَ بَعْضٌ':Predicate, #4: 4	أَنْكَرَ الْبَعْثَ
u'نَكِرَ بَيْعٌ':Predicate, #2: 2	أَنْكَرَ بَعْضَ
u'نَكِرَ بَيْعٌ':Predicate, #1: 1	أَنْكَرَ بَيْعَ
u'نَكِرَ تَأْكِيدٌ':Predicate, #6: 6	أَنْكَرَ الْبَيْعَ
u'نَكِرَ تَدْبِيرٌ':Predicate, #1: 1	أَنْكَرَ تَأْكِيدَ
u'نَكِرَ تَصَوُّرٌ':Predicate, #3: 3	أَنْكَرَ التَّدْبِيرَ
u'نَكِرَ تَعَيُّنٌ':Predicate, #1: 1	أَنْكَرَ تَصَوُّرَ
u'نَكِرَ تمام':Predicate, #4: 4	أَنْكَرَ تَعَيُّنَ
u'نَكِرَ تَمامٌ':Predicate, #1: 1	أَنْكَرَ تَمَامَ
u'نَكِرَ تَمْلِيك':Predicate, #1: 1	أَنْكَرَ تَمَامَ
u'نَكِرَ تَوْكِيلٌ':Predicate, #2: 2	أَنْكَرَ التَّمْلِيكَ
u'نَكَّرَ ثَانِي':Predicate, #1: 1	أَنْكَرَ التَّوْكِيلَ
u'نَكِرَ ثُبُوتٌ':Predicate, #1: 1	نَكَّرَ الثَّانِيَ
u'نَكِرَ ثَلاثُ':Predicate, #3: 3	أَنْكَرَ ثُبُوتَ
u'نَكِرَ جَوَازٌ':Predicate, #1: 1	أَنْكَرَ الثَّلَاثَ
u'نَكِرَ حُجَّة':Predicate, #1: 1	أَنْكَرَ الْجَوَازَ
u'نَكِرَ حَجْرٌ':Predicate, #1: 1	أَنْكَرَ حُجِّيَّةَ
u'نَكِرَ حُجِّيَّة':Predicate, #1: 1	أَنْكَرَ الْحَجْرَ
u'نَكِرَ حَديثٌ':Predicate, #1: 1	أَنْكَرَ حُجِّيَّةَ
u'نَكِرَ حُرْمَةٌ':Predicate, #2: 2	أَنْكَرَ حَدِيثَ
u'نَكِرَ حَقٌّ':Predicate, #1: 1	أَنْكَرَ حُرْمَةَ
u'نَكِرَ حَقِيقٌ':Predicate, #1: 1	أَنْكَرَ الْحَقَّ
u'نَكِرَ حَقِيقَةٌ':Predicate, #1: 1	أَنْكَرَ حَقِيقَةَ
u'نَكِرَ حُكْمٌ':Predicate, #1: 1	أَنْكَرَ حَقِيقَةَ
u'نَكِرَ حَمْلٌ':Predicate, #3: 3	أَنْكَرَ الْحُكْمَ
u'نَكِرَ حَيَاةٌ':Predicate, #1: 1	أَنْكَرَ حَمْلَ
u'نَكِرَ خَبَرٌ':Predicate, #1: 1	أَنْكَرَ حَيَاةَ
u'نَكِرَ خَبَر':Predicate, #1: 1	أَنْكَرَ خَبَرَ
u'نَكِرَ خُضْرَةٌ':Predicate, #1: 1	أَنْكَرَ خَبَرَ
u'نَكِرَ خَطٌّ':Predicate, #1: 1	أَنْكَرَ الْخُضْرَةَ
u'نَكِرَ خِلاَفٌ':Predicate, #1: 1	أَنْكَرَ الْخَطَّ
u'نَكِرَ خِلاَفَةٌ':Predicate, #1: 1	أَنْكَرَ الْخِلَافَ
u'نَكِرَ خُلْعٌ':Predicate, #2: 2	أَنْكَرَ خِلَافَةَ
u'نَكِرَ دُخُولٌ':Predicate, #1: 1	أَنْكَرَ الْخُلْعَ
u'نَكِرَ دُعَاءٌ':Predicate, #5: 5	أَنْكَرَ الدُّخُولَ
u'نَكِرَ دونٌ':Predicate, #1: 1	أَنْكَرَ الدُّعَاءَ
u'نَكَّرَ دَيْنٌ':Predicate, #1: 1	أَنْكَرَ دُونَ
u'نَكِرَ دَيْنٌ':Predicate, #1: 1	نَكَّرَ الدَّيْنَ
u'نَكِرَ ذكر':Predicate, #7: 7	أَنْكَرَ الدَّيْنَ
u'نَكِرَ ذَكَرٌ':Predicate, #1: 1	أَنْكَرَ ذَكَرَ
u'نَكَّرَ ذكر':Predicate, #1: 1	أَنْكَرَ ذَكَرَ
u'نَكَّرَ ذِكْرٌ':Predicate, #1: 1	نَكَّرَ ذِكْرَ
u'نَكِرَ رِسَالَةٌ':Predicate, #1: 1	نَكَّرَ ذِكْرَ
u'نَكِرَ رِسَالَةٌ':Predicate, #1: 1	أَنْكَرَ الرِّسَالَةَ
u'نَكَّرَ رُشْدٌ':Predicate, #1: 1	أَنْكَرَ رِسَالَةَ
u'نَكِرَ رِقٌّ':Predicate, #1: 1	نَكَّرَ الرُّشْدَ
u'نَكِرَ رَهْنٌ':Predicate, #1: 1	أَنْكَرَ الرِّقَّ
u'نَكِرَ رِوايَةٌ':Predicate, #2: 2	أَنْكَرَ الرَّهْنَ
u'نَكِرَ رُؤْيَةٌ':Predicate, #1: 1	أَنْكَرَ الرِّوَايَةَ
u'نَكِرَ زَوْجِيٌّ':Predicate, #3: 3	أَنْكَرَ الرُّؤْيَةَ
u'نَكِرَ زِيادَةٌ':Predicate, #1: 1	أَنْكَرَ الزَّوْجِيَّةَ
u'نَكِرَ زِيارَةٌ':Predicate, #2: 2	أَنْكَرَ الزِّيَادَةَ
u'نَكِرَ سَبَبٌ':Predicate, #1: 1	أَنْكَرَ الزِّيَارَةَ
u'نَكِرَ سَبَبٌ':Predicate, #1: 1	أَنْكَرَ سَبَبَ
u'نَكِرَ سَرقَةٌ':Predicate, #5: 5	أَنْكَرَ السَّبَبَ
u'نَكِرَ سَرِقَةٌ':Predicate, #1: 1	أَنْكَرَ السَّرِقَةَ
u'نَكَّرَ سلام':Predicate, #1: 1	أَنْكَرَ السَّرِقَةَ
u'نَكَّرَ سَلاَمٌ':Predicate, #1: 1	نَكَّرَ السَّلَامَ
u'نَكِرَ سُنَّةٌ':Predicate, #1: 1	نَكَّرَ السَّلَامَ
u'نَكِرَ شِرَاءٌ':Predicate, #1: 1	أَنْكَرَ سُنَّةَ
u'نَكِرَ شِرَاءٌ':Predicate, #1: 1	أَنْكَرَ شِرَاءَ
u'نَكِرَ شَرْطٌ':Predicate, #9: 9	أَنْكَرَ الشِّرَاءَ
u'نَكِرَ شَرْطٌ':Predicate, #1: 1	أَنْكَرَ شَرْطَ
u'نَكِرَ شركة':Predicate, #4: 4	أَنْكَرَ الشَّرْطَ
u'نَكِرَ شَرِكَةٌ':Predicate, #1: 1	أَنْكَرَ شَرِكَةَ
u'نَكِرَ شركة':Predicate, #1: 1	أَنْكَرَ شَرِكَةَ
u'نَكِرَ شَرِكَةٌ':Predicate, #3: 3	أَنْكَرَ الشَّرِكَةَ
u'نَكِرَ شَفَاعَةٌ':Predicate, #3: 3	أَنْكَرَ الشَّرِكَةَ
u'نَكِرَ شَهَادَةٌ':Predicate, #1: 1	أَنْكَرَ الشَّفَاعَةَ
u'نَكِرَ شَهْرٌ':Predicate, #3: 3	أَنْكَرَ الشَّهَادَةَ
u'نَكِرَ شَهْوَةٌ':Predicate, #1: 1	أَنْكَرَ الشَّهْرَ
u'نَكِرَ صحبة':Predicate, #1: 1	أَنْكَرَ الشَّهْوَةَ
u'نَكِرَ صُحْبَةٌ':Predicate, #1: 1	أَنْكَرَ صُحْبَةَ
u'نَكِرَ صِحَّةٌ':Predicate, #1: 1	أَنْكَرَ صُحْبَةَ
u'نَكِرَ صِحَّةٌ':Predicate, #1: 1	أَنْكَرَ صِحَّةَ
u'نَكِرَ صَنِيعٌ':Predicate, #9: 9	أَنْكَرَ الصِّحَّةَ
u'نَكِرَ صَنِيعَةٌ':Predicate, #1: 1	أَنْكَرَ الصَّنِيعَةَ
u'نَكِرَ ضَمِنٌ':Predicate, #1: 1	أَنْكَرَ الصَّنِيعَةَ
u'نَكِرَ طَلاَقٌ':Predicate, #1: 1	أَنْكَرَ ضَمِنَ
u'نَكِرَ طلب':Predicate, #3: 3	أَنْكَرَ الطَّلَاقَ
u'نَكِرَ طَلَبٌ':Predicate, #2: 2	أَنْكَرَ طَلَبَ
u'نَكِرَ عَدَدٌ':Predicate, #2: 2	أَنْكَرَ طَلَبَ
u'نَكِرَ عَفْوٌ':Predicate, #1: 1	أَنْكَرَ الْعَدَدَ
u'نَكِرَ عَقْدٌ':Predicate, #1: 1	أَنْكَرَ عَفْوَ
u'نَكِرَ عِلَّةٌ':Predicate, #1: 1	أَنْكَرَ الْعَقْدَ
u'نَكِرَ علم':Predicate, #1: 1	أَنْكَرَ عِلَّةَ
u'نَكِرَ عِلْمٌ':Predicate, #1: 1	أَنْكَرَ الْعِلْمَ
u'نَكِرَ عُمُومٌ':Predicate, #1: 1	أَنْكَرَ الْعِلْمَ
u'نَكِرَ عُمُومٌ':Predicate, #1: 1	أَنْكَرَ الْعُمُومَ
u'نَكِرَ عند':Predicate, #1: 1	أَنْكَرَ عُمُومَ
u'نَكِرَ عَيْبٌ':Predicate, #1: 1	أَنْكَرَ عِنْدَ
u'نَكِرَ عين':Predicate, #2: 2	أَنْكَرَ الْعَيْبَ
u'نَكِرَ عَيْنٌ':Predicate, #1: 1	أَنْكَرَ الْعَيْنَ
u'نَكِرَ عَيْن':Predicate, #1: 1	أَنْكَرَ الْعَيْنَ
u'نَكِرَ فتنة':Predicate, #1: 1	أَنْكَرَ الْعَيْنَ
u'نَكِرَ فِتْنَةٌ':Predicate, #1: 1	أَنْكَرَ فِتْنَةَ
u'نَكِرَ قَالٌ':Predicate, #1: 1	أَنْكَرَ فِتْنَةَ
u'نَكِرَ قَبْضٌ':Predicate, #2: 2	أَنْكَرَ قَالَ
u'نَكِرَ قَبْضٌ':Predicate, #4: 4	أَنْكَرَ قَبْضَ
u'نَكِرَ قدرة':Predicate, #5: 5	أَنْكَرَ الْقَبْضَ
u'نَكِرَ قُدْرَةٌ':Predicate, #1: 1	أَنْكَرَ الْقُدْرَةَ
u'نَكِرَ قُرْآنٌ':Predicate, #1: 1	أَنْكَرَ الْقُدْرَةَ
u'نَكِرَ قَرْضٌ':Predicate, #2: 2	أَنْكَرَ الْقُرْآنَ
u'نَكِرَ قَصْدٌ':Predicate, #1: 1	أَنْكَرَ الْقَرْضَ
u'نَكِرَ قَضَاءٌ':Predicate, #1: 1	أَنْكَرَ قَصْدَ
u'نَكِرَ قُنُوتٌ':Predicate, #2: 2	أَنْكَرَ الْقَضَاءَ
u'نَكِرَ قول':Predicate, #1: 1	أَنْكَرَ الْقُنُوتَ
u'نَكِرَ قَوْلٌ':Predicate, #4: 4	أَنْكَرَ الْقَوْلَ
u'نَكِرَ قِيَاسٌ':Predicate, #4: 4	أَنْكَرَ الْقَوْلَ
u'نَكِرَ قيام':Predicate, #1: 1	أَنْكَرَ الْقِيَاسَ
u'نَكِرَ قِيَامٌ':Predicate, #3: 3	أَنْكَرَ قِيَامَ
u'نَكِرَ قِيَامَةٌ':Predicate, #3: 3	أَنْكَرَ قِيَامَ
u'نَكِرَ كِتَابَةٌ':Predicate, #1: 1	أَنْكَرَ الْقِيَامَةَ
u'نَكِرَ كَفَالَةٌ':Predicate, #1: 1	أَنْكَرَ الْكِتَابَةَ
u'نَكِرَ لَوْنٌ':Predicate, #1: 1	أَنْكَرَ الْكَفَالَةَ
u'نَكِرَ مَالٌ':Predicate, #1: 1	أَنْكَرَ لَوْنَ
u'نَكِرَ مُتَوَاتِرٌ':Predicate, #4: 4	أَنْكَرَ الْمَالَ
u'نَكِرَ مَجَازٌ':Predicate, #1: 1	أَنْكَرَ الْمُتَوَاتِرَ
u'نَكِرَ مَجَازٌ':Predicate, #1: 1	أَنْكَرَ مَجَازَ
u'نَكَّرَ مساكين':Predicate, #2: 2	أَنْكَرَ الْمَجَازَ
u'نَكِرَ مَسْحٌ':Predicate, #1: 1	نَكَّرَ الْمَسَاكِينَ
u'نَكِرَ مَشْهُورٌ':Predicate, #1: 1	أَنْكَرَ الْمَسْحَ
u'نَكَّرَ مُصَنِّفٌ':Subject, #1: 1	أَنْكَرَ الْمَشْهُورَ
u'نَكِرَ مُعَامَلَةٌ':Predicate, #1: 1	نَكَّرَ الْمُصَنِّفُ
u'نَكِرَ مُعانَقَة':Predicate, #1: 1	أَنْكَرَ الْمُعَامَلَةَ
u'نَكِرَ مِعْرَاجٌ':Predicate, #1: 1	أَنْكَرَ الْمُعَانَقَةَ
u'نَكِرَ مَعْرِفَةٌ':Predicate, #3: 3	أَنْكَرَ الْمِعْرَاجَ
u'نَكِرَ مَعْرِفَة':Predicate, #4: 4	أَنْكَرَ مَعْرِفَةَ
u'نَكِرَ مُغالاة':Predicate, #4: 4	أَنْكَرَ مَعْرِفَةَ
u'نَكِرَ مَفْهُومٌ':Predicate, #1: 1	أَنْكَرَ الْمُغَالَاةَ
u'نَكِرَ مِلْكٌ':Predicate, #2: 2	أَنْكَرَ الْمَفْهُومَ
u'نَكِرَ مَوْتٌ':Predicate, #2: 2	أَنْكَرَ مِلْكَ
u'نَكِرَ نُبُوَّةٌ':Predicate, #2: 2	أَنْكَرَ مَوْتَ
u'نَكِرَ نِسْبَةٌ':Predicate, #1: 1	أَنْكَرَ نُبُوَّةَ
u'نَكِرَ نَفَذٌ':Predicate, #2: 2	أَنْكَرَ نِسْبَةَ
u'نَكِرَ نكاح':Predicate, #1: 1	أَنْكَرَ نَفَذَ
u'نَكِرَ نِكَاحٌ':Predicate, #5: 5	أَنْكَرَ النِّكَاحَ
u'نَكِرَ وَجْهٌ':Predicate, #5: 5	أَنْكَرَ النِّكَاحَ
u'نَكِرَ وُجُوبٌ':Predicate, #1: 1	أَنْكَرَ وَجْهَ
u'نَكِرَ وُجُوبٌ':Predicate, #2: 2	أَنْكَرَ الْوُجُوبَ
u'نَكِرَ وُجُودٌ':Predicate, #9: 9	أَنْكَرَ وُجُوبَ
u'نَكِرَ وُصُولٌ':Predicate, #5: 5	أَنْكَرَ وُجُودَ
u'نَكِرَ وَضْعٌ':Predicate, #1: 1	أَنْكَرَ وُصُولَ
u'نَكِرَ وَضْعٌ':Predicate, #1: 1	أَنْكَرَ الْوَضْعَ
u'نَكِرَ وَطْءٌ':Predicate, #1: 1	أَنْكَرَ وَضْعَ
u'نَكِرَ وُقُوعٌ':Predicate, #1: 1	أَنْكَرَ الْوَطْءَ
u'نَكِرَ وِكَالَةٌ':Predicate, #2: 2	أَنْكَرَ وُقُوعَ
u'نَكِرَ وِلاَدَةٌ':Predicate, #1: 1	أَنْكَرَ الْوِكَالَةَ
u'نَكِرَ ولد':Predicate, #2: 2	أَنْكَرَ الْوِلَادَةَ
u'نَكِرَ وَلَدٌ':Predicate, #1: 1	أَنْكَرَ وَلَدَ
u'نَكِرَ ولد':Predicate, #1: 1	أَنْكَرَ وَلَدَ
u'نَكِرَ وَلَدٌ':Predicate, #2: 2	أَنْكَرَ الْوَلَدَ
u'نَكِرَ يَمِينٌ':Predicate, #2: 2	أَنْكَرَ الْوَلَدَ
u'نَكَّسَ بَطَلٌ':Predicate, #1: 1	أَنْكَرَ الْيَمِينَ
u'نَكَّسَ جِمَارٌ':Predicate, #1: 1	نَكَّسَ بَطَلَ
u'نَكَّسَ سلام':Predicate, #1: 1	نَكَّسَ الْجِمَارَ
u'نَكَّسَ سَلاَمٌ':Predicate, #3: 3	نَكَّسَ السَّلَامَ
u'نَكَلَ أَوَّلُ':Subject, #3: 3	نَكَّسَ السَّلَامَ
u'نَكَلَ بَائِعٌ':Subject, #2: 2	نَكَلَ الْأَوَّلُ
u'نَكِلَ بَائِعٌ':Subject, #2: 2	نَكَلَ الْبَائِعُ
u'نَكِلَ بَطَلٌ':Predicate, #2: 2	نَكِلَ الْبَائِعُ
u'نَكَلَ بَعْضٌ':Subject, #1: 1	نَكِلَ بَطَلَ
u'نَكَلَ ثَانِي':Predicate, #1: 1	نَكَلَ بَعْضُ
u'نَكَلَ ثَلاثَةٌ':Subject, #1: 1	نَكَلَ ثَانِيَةً
u'نَكَلَ جمع':Predicate, #1: 1	نَكَلَ الثَّلَاثَةُ
u'نَكَلَ جَمِيع':Subject, #1: 1	نَكَلَ جَمَعَ
u'نَكَلَ حَكَمٌ':Predicate, #1: 1	نَكَلَ الْجَمِيعُ
u'نَكَلَ خَصْمٌ':Subject, #1: 1	نَكَلَ حَكَمَ
u'نَكَلَ خَصْمٌ':Subject, #2: 2	نَكَلَ الْخَصْمُ
u'نَكَلَ دونٌ':Predicate, #3: 3	نَكَلَ خَصْمُهُ
u'نَكَلَ ذكر':Predicate, #1: 1	نَكَلَ دُونَ
u'نَكَلَ ذَكَرٌ':Predicate, #1: 1	نَكَلَ ذَكَرَ
u'نَكَلَ رَبُّ':Subject, #1: 1	نَكَلَ ذَكَرَ
u'نَكَلَ رَدٌّ':Predicate, #1: 1	نَكَلَ رَبُّ
u'نَكَلَ زَوْجٌ':Subject, #2: 2	نَكَلَ رَدَّ
u'نَكَلَ سَارِقٌ':Subject, #8: 8	نَكَلَ الزَّوْجُ
u'نَكَلَ سقط':Predicate, #3: 3	نَكَلَ السَّارِقُ
u'نَكَلَ سَقَطٌ':Predicate, #3: 3	نَكَلَ سَقَطَ
u'نَكَلَ صَاحِبٌ':Subject, #3: 3	نَكَلَ سَقَطَ
u'نَكَلَ صَبِيٌّ':Subject, #1: 1	نَكَلَ صَاحِبُهُ
u'نَكَلَ ضَمِنٌ':Predicate, #1: 1	نَكَلَ الصَّبِيُّ
u'نَكِلَ طَالِبٌ':Subject, #12: 12	نَكَلَ ضَمِنَ
u'نَكَلَ عَادٌ':Predicate, #2: 2	نَكِلَ الطَّالِبُ
u'نَكَلَ عَبْدٌ':Subject, #2: 2	نَكَلَ عَادَ
u'نَكَلَ غير':Subject, #1: 1	نَكَلَ الْعَبْدُ
u'نَكَلَ غَيْرٌ':Subject, #1: 1	نَكَلَ غَيْرُهُ
u'نَكَلَ قَالٌ':Predicate, #1: 1	نَكَلَ غَيْرُهُ
u'نَكَلَ كَفِيلٌ':Subject, #2: 2	نَكَلَ قَالَ
u'نَكَلَ مَالِكٌ':Subject, #1: 1	نَكَلَ الْكَفِيلُ
u'نَكَلَ مُبْتاع':Subject, #1: 1	نَكَلَ الْمَالِكُ
u'نَكَلَ مُتَّهَمٌ':Subject, #1: 1	نَكَلَ الْمُبْتَاعُ
u'نَكَلَ مَجْنِيٌّ':Subject, #1: 1	نَكَلَ الْمُتَّهَمُ
u'نَكَلَ مُحْتَالٌ':Subject, #1: 1	نَكَلَ الْمَجْنِيُّ
u'نَكَلَ مَحْكُومٌ':Subject, #1: 1	نَكَلَ الْمُحْتَالُ
u'نَكِلَ مَدْعُوٌّ':Subject, #1: 1	نَكَلَ الْمَحْكُومُ
u'نَكَلَ مرٌّ':Predicate, #2: 2	نَكِلَ مَدْعُوُّ
u'نَكَلَ مُضَارِبٌ':Subject, #3: 3	نَكَلَ مَرَّةً
u'نَكَلَ مَطْلُوبٌ':Subject, #1: 1	نَكَلَ الْمُضَارِبُ
u'نَكَلَ مَقْضِيّ':Subject, #2: 2	نَكَلَ الْمَطْلُوبُ
u'نَكَلَ مُودَعٌ':Subject, #1: 1	نَكَلَ الْمَقْضِيُّ
u'نَكَلَ مُوَرِّث':Subject, #1: 1	نَكَلَ الْمُودَعُ
u'نَكَلَ مُوَكِّلٌ':Subject, #1: 1	نَكَلَ مُوَرِّثُهُ
u'نَكَلَ واحد':Subject, #2: 2	نَكَلَ الْمُوَكِّلُ
u'نَكَلَ وَاحِدٌ':Subject, #5: 5	نَكَلَ وَاحِدٌ
u'نَكَلَ وَارِثٌ':Subject, #5: 5	نَكَلَ وَاحِدٌ
u'نَكَلَ وَجَبٌ':Predicate, #1: 1	نَكَلَ الْوَارِثُ
u'نَكَلَ وَرَثَةٌ':Subject, #1: 1	نَكَلَ وَجَبَ
u'نَكَلَ وقع':Predicate, #1: 1	نَكَلَ الْوَرَثَةُ
u'نَكَلَ وَكِيلٌ':Subject, #1: 1	نَكَلَ وَقَعَ
u'نَكَلَ وُلاَةٌ':Subject, #2: 2	نَكَلَ الْوَكِيلُ
u'نَكَلَ وَلِيٌّ':Subject, #2: 2	نَكَلَ وُلَاةُ
u'نَكْهَةٌ فَمٌ':Added, #2: 2	نَكَلَ الْوَلِيُّ
u'نَكِيرٌ مُنْكِرٌ':Added, #1: 1	نَكْهَةَ الْفَمِ
u'نَكِيرٌ نَبِيٌّ':Added, #5: 5	نَكِيرِ مُنْكِرٍ
u'نَمَاءٌ أرْضٌ':Added, #1: 1	نَكِيرُ النَّبِيِّ
u'نَمَاءٌ أرْضٌ':Added, #1: 1	نَمَاءِ أَرْضِ
u'نَمَاءٌ أرْضٌ':Added, #2: 2	نَمَاءُ أَرْضِهِ
u'نَمَاءٌ أرْضٌ':Added, #2: 2	نَمَاءُ الْأَرْضِ
u'نَمَاءٌ أعْيانٌ':Added, #3: 3	نَمَاءِ الْأَرْضِ
u'نَمَاءٌ أَعْيَانٌ':Added, #2: 2	نَمَاءِ الْأَعْيَانِ
u'نَمَاءٌ بَذْرٌ':Added, #2: 2	نَمَاءِ الْأَعْيَانِ
u'نَمَاءٌ تَرِكَةٌ':Added, #5: 5	نَمَاءُ بَذْرِهِ
u'نَمَاءٌ ثَمَرٌ':Added, #2: 2	نَمَاءُ التَّرِكَةِ
u'نَمَاءٌ ثَوابٌ':Added, #1: 1	نَمَاءِ الثَّمَرِ
u'نَمَاءٌ خَالِصٌ':Added, #1: 1	نَمَاءِ الثَّوَابِ
u'نَمَاءٌ خلق':Added, #2: 2	نَمَاءُ خَالِصِ
u'نَمَاءٌ خَلْقٌ':Added, #2: 2	نَمَاءُ الْخَلْقِ
u'نَمَاءٌ رَقَبَةٌ':Added, #2: 2	نَمَاءُ الْخَلْقِ
u'نَمَاءٌ رَهْنٌ':Added, #1: 1	نَمَاءِ الرَّقَبَةِ
u'نَمَاءٌ رَهْنٌ':Added, #1: 1	نَمَاءَ الرَّهْنِ
u'نَمَاءٌ رَهْنٌ':Added, #1: 1	نَمَاءُ الرَّهْنِ
u'نَمَاءٌ زِراعَةٌ':Added, #2: 2	نَمَاءِ الرَّهْنِ
u'نَمَاءٌ عَبْدٌ':Added, #1: 1	نَمَاءُ زِرَاعَةٍ
u'نَمَاءٌ عَيْبٌ':Added, #1: 1	نَمَاءَ الْعَبْدِ
u'نَمَاءٌ مَالٌ':Added, #1: 1	نَمَاءَ الْعَيْبِ
u'نَمَاءٌ مَالٌ':Added, #1: 1	نَمَاءُ الْمَالِ
u'نَمَاءٌ مَعِيبٌ':Added, #4: 4	نَمَاءِ الْمَالِ
u'نَمَاءٌ مَقْبُوضٌ':Added, #1: 1	نَمَاءَ الْمَعِيبِ
u'نَمَاءٌ مِلْكٌ':Added, #1: 1	نَمَاءِ الْمَقْبُوضِ
u'نَمَاءٌ مِلْكٌ':Added, #18: 18	نَمَاءُ مِلْكِهِ
u'نَمَاءٌ مِلْكٌ':Added, #1: 1	نَمَاءُ مِلْكِ
u'نَمَاءٌ مِلْكٌ':Added, #1: 1	نَمَاءَ مِلْكِهِ
u'نَمَاءٌ مُنْفَصِلٌ':Added, #2: 2	نَمَاءَ مِلْكِ
u'نَمَاءٌ نصاب':Added, #1: 1	نَمَاءٍ مُنْفَصِلٍ
u'نَمَاءٌ نِصَابٌ':Added, #2: 2	نَمَاءِ النِّصَابِ
u'نَمَاءٌ وَقْفٌ':Added, #2: 2	نَمَاءِ النِّصَابِ
u'نَمَا عند':Predicate, #1: 1	نَمَاءِ الْوَقْفِ
u'نَمَا مَالٌ':Subject, #2: 2	نَمَا عِنْدَ
u'نَمَا مَالٌ':Subject, #1: 1	نَمَا الْمَالُ
u'نَمَا مَالٌ':Subject, #1: 1	نَمَا مَالُ
u'نَمَا مِلْكٌ':Subject, #1: 1	نَمَا مَالُهُ
u'نهار إِجَادَةٌ':Added, #1: 1	نَمَا مِلْكُهُ
u'نهار أعاجم':Added, #1: 1	أَنْهَارِ الْإِجَادَةِ
u'نهار جَنَّةٌ':Added, #1: 1	أَنْهَارِ الْأَعَاجِمِ
u'نهار جَنَّةٌ':Added, #12: 12	أَنْهَارِ الْجَنَّةِ
u'نهار جَنَّةٌ':Added, #2: 2	أَنْهَارَ الْجَنّةِ
u'نهار جَنَّةٌ':Added, #4: 4	أَنْهَارُ الْجَنَّةِ
u'نهار خراج':Added, #5: 5	أَنْهَارَ الْجَنَّةِ
u'نهار خَرَاجٌ':Added, #1: 1	أَنْهَارِ الْخَرَاجِ
u'نهار شركاء':Added, #1: 1	أَنْهَارِ الْخَرَاجِ
u'نهار عَامٌّ':Added, #1: 1	أَنْهَارَ الشُّرَكَاءِ
u'نَهْبٌ طعام':Added, #1: 1	أَنْهَارِ الْعَامَّةِ
u'نَهْبٌ طَعَامٌ':Added, #1: 1	نَهْبِ الطَّعَامِ
u'نَهْبٌ مَدِينٌ':Added, #1: 1	نَهْبِ الطَّعَامِ
u'نَهْبٌ مَدِينَةٌ':Added, #1: 1	نَهْبِ الْمَدِينَةِ
u'نَهْجٌ أَعْمَالٌ':Added, #1: 1	نَهْبِ الْمَدِينَةِ
u'نَهْجٌ صَوَابٌ':Added, #1: 1	نَهْجِ أَعْمَالِ
u'نَهْجٌ صَوَابٌ':Added, #1: 1	نَهْجَ الصَّوَابِ
u'نَهْجٌ صَوَابٌ':Added, #1: 1	نَهْجُ الصَّوَابِ
u'نَهْجٌ طَرِيقَةٌ':Added, #1: 1	نَهْجِ الصَّوَابِ
u'نَهْجٌ عُقَلاَءُ':Added, #1: 1	نَهْجُ الطّرِيقَةِ
u'نَهْجٌ قِيَاسٌ':Added, #1: 1	نَهْجِ الْعُقَلَاءِ
u'نَهْجٌ كَلاَمٌ':Added, #1: 1	نَهْجِ الْقِيَاسِ
u'نَهْجٌ نُحَاةٌ':Added, #4: 4	نَهْجِ كَلَامِ
u'نَهْجٌ واحد':Added, #1: 1	نَهْجِ النُّحَاةِ
u'نَهْجٌ وَاحِدٌ':Added, #3: 3	نَهْجٍ وَاحِدٍ
u'نَهَدَ ثَدْيٌ':Subject, #3: 3	نَهْجٍ وَاحِدٍ
u'نَهْرٌ أرْضٌ':Added, #2: 2	نَهَدَ ثَدْيُ
u'نَهْرٌ أهْلٌ':Added, #2: 2	نَهْرِ الْأَرْضِ
u'نَهْرٌ جَارٌ':Added, #1: 1	نَهْرِ أَهْلِ
u'نَهْرٌ جَارٌ':Added, #14: 14	نَهْرٍ جَارٍ
u'نَهْرٌ جَامِدٌ':Added, #1: 1	نَهْرِ جَارِهِ
u'نَهْرٌ جَمَاعَةٌ':Added, #2: 2	نَهْرٍ جَامِدٍ
u'نَهْرٌ حَيَاةٌ':Added, #1: 1	نَهْرَ الْجَمَاعَةِ
u'نَهْرٌ حَيَاةٌ':Added, #1: 1	نَهْرُ الْحَيَاةِ
u'نَهْرٌ خاصّ':Added, #1: 1	نَهْرِ الْحَيَاةِ
u'نَهْرٌ خبال':Added, #12: 12	نَهْرٍ خَاصٍّ
u'نَهْرٌ خَبَالٌ':Added, #2: 2	نَهْرُ الْخَبَالِ
u'نَهْرٌ خبال':Added, #2: 2	نَهْرُ الْخَبَالِ
u'نَهْرٌ خَبَالٌ':Added, #4: 4	نَهْرِ الْخَبَالِ
u'نَهَرَ دَمٌ':Predicate, #4: 4	نَهْرِ الْخَبَالِ
u'نَهِرَ دَمٌ':Predicate, #30: 30	أَنْهَرَ الدَّمَ
u'نَهْرٌ رَجُلٌ':Added, #30: 30	أَنْهَرَ الدَّمَ
u'نَهْرٌ شاش':Added, #1: 1	نَهْرِ رَجُلٍ
u'نَهْرٌ صَاحِبٌ':Added, #1: 1	نَهْرِ الشَّاشِ
u'نَهْرٌ ضَيِّقٌ':Added, #4: 4	نَهْرِ صَاحِبِهِ
u'نَهْرٌ طَاحُونٌ':Added, #1: 1	نَهْرٍ ضَيِّقٍ
u'نَهْرٌ عَامٌّ':Added, #2: 2	نَهْرِ الطَّاحُونَةِ
u'نَهْرٌ عَامٌّ':Added, #14: 14	نَهْرِ الْعَامَّةِ
u'نَهْرٌ عَامٌّ':Added, #1: 1	نَهْرُ الْعَامَّةِ
u'نَهْرٌ عَظِيم':Added, #6: 6	نَهْرٍ عَامٍّ
u'نَهْرٌ غَوْط':Added, #10: 10	نَهْرٍ عَظِيمٍ
u'نَهْرٌ غَوْط':Added, #1: 1	نَهْرُ الْغَوْطَةِ
u'نَهْرٌ غُوطَة':Added, #1: 1	نَهْرِ الْغَوْطَةِ
u'نَهْرٌ غُوطَة':Added, #1: 1	نَهْرُ الْغُوطَةِ
u'نَهْرٌ غير':Added, #1: 1	نَهْرِ الْغُوطَةِ
u'نَهْرٌ غَيْرٌ':Added, #1: 1	نَهْرِ الْغَيْرِ
u'نَهْرٌ غير':Added, #1: 1	نَهْرِ الْغَيْرِ
u'نَهْرٌ غَيْرٌ':Added, #2: 2	نَهْرِ غَيْرِهِ
u'نَهْرٌ قَرْيَةٌ':Added, #2: 2	نَهْرِ غَيْرِهِ
u'نَهْرٌ قَرْيَةٌ':Added, #1: 1	نَهْرِ قَرْيَةِ
u'نَهْرٌ قَنَاةٌ':Added, #3: 3	نَهْرِ قَرْيَةٍ
u'نَهْرٌ كَوْثَرٌ':Added, #1: 1	نَهْرُ قَنَاةٍ
u'نَهْرٌ كُوفَةٌ':Added, #1: 1	نَهْرِ الْكَوْثَرِ
u'نَهْرٌ مُبَاحٌ':Added, #2: 2	نَهْرُ الْكُوفَةِ
u'نَهْرٌ مُشْتَرَكٌ':Added, #3: 3	نَهْرٍ مُبَاحٍ
u'نَهْرٌ مَعْقِلٌ':Added, #1: 1	نَهْرٍ مُشْتَرَكٍ
u'نَهْرٌ مَغْصُوب':Added, #1: 1	نَهْرِ مَعْقِلٍ
u'نَهْرٌ مَلِكٌ':Added, #1: 1	نَهْرٍ مَغْصُوبٍ
u'نَهْرٌ مَمْلُوكٌ':Added, #2: 2	نَهْرِ الْمَلِكِ
u'نَهْرٌ نَفْسٌ':Added, #2: 2	نَهْرٍ مَمْلُوكٍ
u'نَهْرٌ هِنْدٌ':Added, #1: 1	نَهْرَ نَفْسِهِ
u'نَهْرٌ وَاسِعٌ':Added, #1: 1	نَهْرُ الْهِنْدِ
u'نَهَرَ ولد':Subject, #1: 1	نَهْرٍ وَاسِعٍ
u'نَهَرَ وَلَدٌ':Subject, #1: 1	نَهَرَ الْوَلَدُ
u'نَهَشَ صَيْدٌ':Predicate, #1: 1	نَهَرَ الْوَلَدُ
u'نهضة بَعيرٌ':Added, #1: 1	نَهَشَ الصَّيْدَ
u'نَهْضَةٌ بَعيرٌ':Added, #1: 1	نَهْضَةَ الْبَعِيرِ
u'نَهَضَ رَجُلٌ':Subject, #1: 1	نَهْضَةَ الْبَعِيرِ
u'نَهَضَ رَسُولٌ':Subject, #1: 1	نَهَضَ الرَّجُلُ
u'نَهْكَةٌ أَمْوَالٌ':Added, #1: 1	نَهَضَ رَسُولُ
u'نَهْمَةٌ نَفْسٌ':Added, #1: 1	نَهْكَةِ الْأَمْوَالِ
u'نَهْيٌ إِجْمَاعٌ':Added, #1: 1	نَهْمَةِ النَّفْسِ
u'نَهْيٌ أدَب':Added, #1: 1	نَهْيُ الْإِجْمَاعِ
u'نَهْيٌ آدَمِيٌّ':Added, #2: 2	نَهْيُ أَدَبٍ
u'نَهَى أَزْواجٌ':Predicate, #2: 2	نَهْيِ الْآدَمِيِّ
u'نَهْيٌ اِعْتِقادٌ':Added, #1: 1	نَهَى الْأَزْوَاجَ
u'نَهْيٌ إقْدَامٌ':Added, #1: 1	نَهْيُ اعْتِقَادِ
u'نَهَى الْمَرْأَةُ':Predicate, #1: 1	نَهْيُ الْإِقْدَامِ
u'نَهَى إمَامٌ':Subject, #4: 4	نَهَى الْمَرْأَةَ
u'نَهَى أَميرٌ':Subject, #2: 2	نَهَى الْإِمَامُ
u'نَهَى أهْلٌ':Predicate, #2: 2	نَهَى أَمِيرُ
u'نَهَى أَوَّلُ':Predicate, #1: 1	نَهَى أَهْلَ
u'نَهْيٌ أَوْلِيَاءُ':Added, #1: 1	نَهَى الْأَوَّلَ
u'نَهَى أئِمَّةٌ':Subject, #2: 2	نَهْيُ الْأَوْلِيَاءِ
u'نَهَى بَائِعٌ':Predicate, #1: 1	نَهَى أَئِمَّةُ
u'نَهَى بَدَلٌ':Predicate, #4: 4	نَهَى الْبَائِعَ
u'نَهْيٌ بَيْعٌ':Added, #1: 1	نَهَى بَدَلَ
u'نَهْيٌ تَحْرِيمٌ':Added, #1: 1	نَهْيِ بَيْعِ
u'نَهْيٌ تَحْرِيمٌ':Added, #1: 1	نَهْيَ التَّحْرِيمِ
u'نَهْيٌ تَحْرِيمٌ':Added, #1: 1	نَهْيُ التَّحْرِيمِ
u'نَهْيٌ تَحْرِيمٌ':Added, #2: 2	نَهْيِ التَّحْرِيمِ
u'نَهْيٌ تَحْرِيمٌ':Added, #3: 3	نَهْيَ تَحْرِيمٍ
u'نَهْيٌ تَزَوُّجٌ':Added, #3: 3	نَهْيُ تَحْرِيمٍ
u'نَهِيَ تَكْبِير':Predicate, #1: 1	نَهْيِ التَّزَوُّجِ
u'نَهَى تَكْبِير':Predicate, #1: 1	أَنْهَى تَكْبِيرَةَ
u'نَهْيٌ تَكْليفٌ':Added, #1: 1	أَنْهَى تَكْبِيرَةَ
u'نَهَى تمام':Subject, #1: 1	نَهْيِ التَّكْلِيفِ
u'نَهَى تَمامٌ':Subject, #1: 1	نَهَى التَّمَامُ
u'نَهْيٌ تَنْزِيهٌ':Added, #1: 1	نَهَى التَّمَامُ
u'نَهْيٌ تَنْزِيه':Added, #1: 1	نَهْيَ تَنْزِيهٍ
u'نَهْيٌ تَنْزِيه':Added, #2: 2	نَهْيَ التَّنْزِيهِ
u'نَهْيٌ تَنْزِيهٌ':Added, #2: 2	نَهْيِ التَّنْزِيهِ
u'نَهَى ثَمِلٌ':Predicate, #7: 7	نَهْيُ تَنْزِيهٍ
u'نَهْيٌ حائِضٌ':Added, #1: 1	نَهَى الثَّمِلَ
u'نَهْيٌ حُرْمَةٌ':Added, #1: 1	نَهْيُ الْحَائِضِ
u'نَهْيٌ حُرْمَةٌ':Added, #1: 1	نَهْيِ حُرْمَةٍ
u'نَهَى حَمَّامِيٌّ':Subject, #2: 2	نَهْيِ الْحُرْمَةِ
u'نَهْيٌ خاصّ':Added, #1: 1	نَهَى الْحَمَّامِيُّ
u'نَهَى خَلِيفَةٌ':Subject, #1: 1	نَهْيٍ خَاصٍّ
u'نَهَى رَاعِي':Predicate, #1: 1	نَهَى الْخَلِيفَةُ
u'نَهْيٌ رَبُّ':Added, #1: 1	نَهَى الرَّاعِيَ
u'نَهْيٌ رَبُّ':Added, #1: 1	نَهْيَ الرَّبِّ
u'نَهَى رِجَالٌ':Predicate, #1: 1	نَهْيُ رَبِّهِ
u'نَهَى رَجُلٌ':Predicate, #5: 5	نَهَى الرِّجَالَ
u'نَهْيٌ رَجُلٌ':Added, #1: 1	نَهَى رَجُلاً
u'نَهْيٌ رَجُلٌ':Added, #1: 1	نَهْيُ الرَّجُلِ
u'نَهَى رَسُولٌ':Subject, #1: 1	نَهْيِ الرَّجُلِ
u'نَهْيٌ رَسُولٌ':Added, #465: 465	نَهَى رَسُولُ
u'نَهْيٌ رَسُولٌ':Added, #1: 1	نَهْيَ رَسُولِ
u'نَهْيٌ رَسُولٌ':Added, #2: 2	نَهْيِ رَسُولِ
u'نَهَى سَلَفٌ':Subject, #3: 3	نَهْيُ رَسُولِ
u'نَهَى شَارِعٌ':Subject, #2: 2	نَهَى السَّلَفُ
u'نَهْيٌ شَارِعٌ':Added, #7: 7	نَهَى الشَّارِعُ
u'نَهْيٌ شَارِعٌ':Added, #2: 2	نَهْيُ الشَّارِعِ
u'نَهْيٌ شافِعِيّ':Added, #2: 2	نَهْيِ الشَّارِعِ
u'نَهَى شَرْعٌ':Subject, #1: 1	نَهْيُ الشَّافِعِيِّ
u'نَهْيٌ شَرْعٌ':Added, #8: 8	نَهَى الشَّرْعُ
u'نَهْيٌ شَرِيكٌ':Added, #1: 1	نَهْيِ الشَّرْعِ
u'نَهَى شَفِيعٌ':Subject, #1: 1	نَهْيِ شَرِيكِهِ
u'نَهْيٌ شُهُودٌ':Added, #1: 1	نَهَى الشَّفِيعُ
u'نَهَى شُيُوخٌ':Subject, #1: 1	نَهْيُ الشُّهُودِ
u'نَهْيٌ صَلاَةٌ':Added, #1: 1	نَهَى شُيُوخُ
u'نَهْيٌ ضِدٌّ':Added, #1: 1	نَهْيِ الصَّلَاةِ
u'نَهَى عَامٌ':Predicate, #1: 1	نَهْيُ الضِّدِّ
u'نَهَى عَائِشٌ':Predicate, #2: 2	نَهَى عَامَ
u'نَهَى عَبْدٌ':Predicate, #1: 1	نَهَى عَائِشَةَ
u'نَهَى عَبْدٌ':Subject, #1: 1	نَهَى الْعَبْدَ
u'نَهَى عَرَبٌ':Predicate, #1: 1	نَهَى عَبْدُ
u'نَهَى عُمَرٌ':Subject, #1: 1	نَهَى الْعَرَبَ
u'نَهْيٌ غَائِبٌ':Added, #7: 7	نَهَى عُمَرُ
u'نَهْيٌ غير':Added, #1: 1	نَهْيُ الْغَائِبِ
u'نَهْيٌ غَيْرٌ':Added, #1: 1	نَهْيُ غَيْرِهِ
u'نَهَى فلان':Predicate, #1: 1	نَهْيُ غَيْرِهِ
u'نَهْيٌ فلان':Added, #1: 1	نَهَى عُثْمَانَ
u'نَهْيٌ كَرَامَةٌ':Added, #1: 1	نَهْيُ الشَّافِعِيِّ
u'نَهْيٌ كَرَاهَةٌ':Added, #1: 1	نَهْيَ كَرَامَةٍ
u'نَهْيٌ كَرَاهَةٌ':Added, #2: 2	نَهْيَ كَرَاهَةٍ
u'نَهْيٌ كَرَاهَةٌ':Added, #2: 2	نَهْيُ كَرَاهَةٍ
u'نَهْيٌ كَرَاهِيَةٌ':Added, #3: 3	نَهْيِ الْكَرَاهَةِ
u'نَهِيَ كَلاَمٌ':Predicate, #2: 2	نَهْيِ الْكَرَاهِيَةِ
u'نَهَى كَلاَمٌ':Predicate, #3: 3	أَنْهَى الْكَلَامَ
u'نَهَى مَالِكٌ':Subject, #3: 3	أَنْهَى الْكَلَامَ
u'نَهْيٌ مَالِكٌ':Added, #3: 3	نَهَى مَالِكٌ
u'نَهَى مُحْرِمٌ':Predicate, #2: 2	نَهْيِ الْمَالِكِ
u'نَهَى مُحْرِمٌ':Predicate, #1: 1	نَهَى الْمُحْرِمَةَ
u'نَهَى مُسَافِرٌ':Predicate, #3: 3	نَهَى الْمُحْرِمَ
u'نَهْيٌ مُسْتَأْجِرٌ':Added, #1: 1	نَهَى الْمُسَافِرَ
u'نَهَى مُسْلِمٌ':Predicate, #1: 1	نَهْيَ الْمُسْتَأْجِرِ
u'نَهَى مُضَارِبٌ':Predicate, #2: 2	نَهَى الْمُسْلِمِينَ
u'نَهْيٌ مُضَارِبٌ':Added, #1: 1	نَهَى الْمُضَارِبَ
u'نَهَى مُعْتَدٌّ':Predicate, #1: 1	نَهْيَ الْمُضَارِبِ
u'نَهَى مُوَكِّلٌ':Subject, #5: 5	نَهَى الْمُعْتَدَّةَ
u'نَهَى نَاسٌ':Predicate, #1: 1	نَهَى الْمُوَكِّلُ
u'نَهِيَ نَاسٌ':Predicate, #1: 1	نَهَى النّاسَ
u'نَهَى نَاسٌ':Predicate, #3: 3	أَنْهَى النَّاسَ
u'نَهَى نَاسٌ':Predicate, #3: 3	أَنْهَى النَّاسَ
u'نَهَى نَاسٌ':Subject, #3: 3	نَهَى النَّاسَ
u'نَهْيٌ نَاسٌ':Added, #1: 1	نَهَى النَّاسُ
u'نَهَى نَبِيٌّ':Subject, #1: 1	نَهْيِ النَّاسِ
u'نَهَى نَبِيٌّ':Subject, #2: 2	نَهَى نَبِيُّ
u'نَهْيٌ نَبِيٌّ':Added, #65: 65	نَهَى النَّبِيُّ
u'نَهْيٌ نَبِيٌّ':Added, #2: 2	نَهْيَ النَّبِيِّ
u'نَهْيٌ نَبِيٌّ':Added, #2: 2	نَهْيُ النَّبِيِّ
u'نَهْيٌ نَدْبٌ':Added, #2: 2	نَهْيِ النَّبِيِّ
u'نَهَى نِساءٌ':Predicate, #1: 1	نَهْيُ نَدْبٍ
u'نَهْيٌ نِساءٌ':Added, #9: 9	نَهَى النِّسَاءَ
u'نَهَى نَمَّامٌ':Predicate, #1: 1	نَهْيُ النِّسَاءِ
u'نَهَى وَاقِفٌ':Subject, #1: 1	نَهَى النَّمَّامَ
u'نَهَى وَفْدٌ':Predicate, #1: 1	نَهَى الْوَاقِفُ
u'نَهَى وَكِيلٌ':Predicate, #1: 1	نَهَى وَفْدَ
u'نَهَى وَكِيلٌ':Subject, #2: 2	نَهَى الْوَكِيلَ
u'نَهْيٌ وَكِيلٌ':Added, #2: 2	نَهَى الْوَكِيلُ
u'نَهَى وَلِيٌّ':Predicate, #1: 1	نَهْيُ الْوَكِيلِ
u'نَهَى يَوْمٌ':Predicate, #1: 1	نَهَى الْوَلِيَّ
u'نُوَاحٌ قُرَيْشٌ':Added, #15: 15	نَهَى يَوْمَ
u'نَوْبَةٌ جَاحِدٌ':Added, #1: 1	نُوَاحُ قُرَيْشٍ
u'نَوْبَةٌ حُرٌّ':Added, #1: 1	نَوْبَةِ الْجَاحِدِ
u'نَوْبَةٌ حُرٌّ':Added, #18: 18	نَوْبَةِ حُرَّةٍ
u'نَوْبَةٌ حُرِّيَّةٌ':Added, #4: 4	نَوْبَةِ الْحُرَّةِ
u'نَوْبَةٌ خَمِيسٌ':Added, #3: 3	نَوْبَةِ الْحُرِّيَّةِ
u'نَوْبَةٌ دَمٌ':Added, #1: 1	نَوْبَةِ الْخَمِيسِ
u'نَوْبَةٌ سَيِّدٌ':Added, #2: 2	نَوْبَةَ دَمٍ
u'نَوْبَةٌ سَيِّدٌ':Added, #10: 10	نَوْبَةِ سَيِّدِهِ
u'نَوْبَةٌ سَيِّدٌ':Added, #1: 1	نَوْبَةَ سَيِّدِهِ
u'نَوْبَةٌ سَيِّدٌ':Added, #1: 1	نَوْبَةُ سَيِّدِهِ
u'نَوْبَةٌ سَيِّدٌ':Added, #2: 2	نَوْبَةُ السَّيِّدِ
u'نَوْبَةٌ صَاحِبٌ':Added, #6: 6	نَوْبَةِ السَّيِّدِ
u'نَوْبَةٌ صَاحِبٌ':Added, #1: 1	نَوْبَةِ صَاحِبِ
u'نَوْبَةٌ ضَرَائِرُ':Added, #1: 1	نَوْبَةِ صَاحِبِهِ
u'نَوْبَةٌ ضَرَّةٌ':Added, #1: 1	نَوْبَةُ الضَّرَائِرِ
u'نَوْبَةٌ عَبْدٌ':Added, #1: 1	نَوْبَةِ الضَّرَّةِ
u'نَوْبَةٌ عَبْدٌ':Added, #2: 2	نَوْبَةَ الْعَبْدِ
u'نَوْبَةٌ عَبْدٌ':Added, #2: 2	نَوْبَةُ الْعَبْدِ
u'نَوْبَةٌ غير':Added, #2: 2	نَوْبَةِ الْعَبْدِ
u'نَوْبَةٌ غَيْرٌ':Added, #1: 1	نَوْبَةِ غَيْرِهِ
u'نَوْبَةٌ مَاءٌ':Added, #1: 1	نَوْبَةِ غَيْرِهِ
u'نَوْبَةٌ مَدْخُولٌ':Added, #1: 1	نَوْبَةُ مَاءِ
u'نَوْبَةٌ مُسَافِرٌ':Added, #1: 1	نَوْبَةِ الْمَدْخُولِ
u'نَوْبَةٌ مَظْلُومٌ':Added, #1: 1	نَوْبَةِ الْمُسَافِرَةِ
u'نَوْبَةٌ مَظْلُومٌ':Added, #1: 1	نَوْبَةُ الْمَظْلُومِ
u'نَوْبَةٌ مَظْلُومٌ':Added, #2: 2	نَوْبَةِ الْمَظْلُومِ
u'نَوْبَةٌ مُعْسِرٌ':Added, #2: 2	نَوْبَةَ الْمَظْلُومَةِ
u'نَوْبَةٌ نَفْسٌ':Added, #1: 1	نَوْبَةُ مُعْسِرٍ
u'نَوْبَةٌ نَفْسٌ':Added, #1: 1	نَوْبَةَ نَفْسِهِ
u'نَوْبَةٌ واحد':Added, #1: 1	نَوْبَةِ نَفْسِهِ
u'نَوْبَةٌ وَاحِدٌ':Added, #2: 2	نَوْبَةِ وَاحِدَةٍ
u'نَوْبَةٌ واحد':Added, #2: 2	نَوْبَةِ وَاحِدَةٍ
u'نَوْبَةٌ وَاحِدٌ':Added, #4: 4	نَوْبَةٍ وَاحِدَةٍ
u'نَوْبٌ دَمٌ':Added, #4: 4	نَوْبَةٍ وَاحِدَةٍ
u'نُوَبٌ دَمٌ':Added, #1: 1	نَوْبِ الدَّمِ
u'نُوَبٌ دِماءٌ':Added, #1: 1	نُوَبِ الدَّمِ
u'نُوَبٌ رَمْيٌ':Added, #2: 2	نُوَبِ الدِّمَاءِ
u'نَوْحٌ صُوفِيٌّ':Added, #1: 1	نُوَبِ الرَّمْيِ
u'نَوْحٌ صُوفِيَّةٌ':Added, #1: 1	نَوْحُ الصُّوفِيَّةِ
u'نَوْحٌ مُتَصَوِّفٌ':Added, #1: 1	نَوْحُ الصُّوفِيَّةِ
u'نَوْحٌ نَائِحٌ':Added, #1: 1	نَوْحُ الْمُتَصَوِّفَةِ
u'نَوَّرَ رَسُولٌ':Predicate, #2: 2	نَوْحُ نَائِحَةٍ
u'نَوَّعَ تَعْلِيقٌ':Predicate, #2: 2	نَوَّرَ رَسُولَ
u'نَوْمٌ أَكْثَرُ':Added, #1: 1	نَوَّعَ التَّعْلِيقَ
u'نَوْمٌ إِنْسانٌ':Added, #1: 1	نَوْمِ أَكْثَرِ
u'نَوْمٌ بَعْضٌ':Added, #1: 1	نَوْمِ الْإِنْسَانِ
u'نَوْمَةٌ صُبْحَةٌ':Added, #1: 1	نَوْمُ بَعْضِهِ
u'نَوْمَةٌ عَرُوسٌ':Added, #1: 1	نَوْمَةُ الصُّبْحَةِ
u'نَوْمَةٌ علماء':Added, #2: 2	نَوْمَةَ الْعَرُوسِ
u'نَوْمَةٌ عُلَمَاءُ':Added, #1: 1	نَوْمَةِ الْعُلَمَاءِ
u'نَوْمَةٌ قَائِلٌ':Added, #1: 1	نَوْمَةِ الْعُلَمَاءِ
u'نَوْمَةٌ قَائِلَةٌ':Added, #1: 1	نَوْمَةُ الْقَائِلَةِ
u'نَوْمَةٌ نِصْفٌ':Added, #1: 1	نَوْمَةُ الْقَائِلَةِ
u'نَوْمٌ جَالِسٌ':Added, #1: 1	نَوْمَةُ نِصْفِ
u'نَوْمٌ جَالِسٌ':Added, #1: 1	نَوْمَ الْجَالِسِ
u'نَوْمٌ جَالِسٌ':Added, #1: 1	نَوْمُ الْجَالِسِ
u'نَوْمٌ حمق':Added, #1: 1	نَوْمِ الْجَالِسِ
u'نَوْمٌ حُمْقٌ':Added, #1: 1	نَوْمُ الْحُمْقِ
u'نَوْمٌ خرق':Added, #1: 1	نَوْمُ الْحُمْقِ
u'نَوْمٌ خرق':Added, #1: 1	نَوْمُ خَرَقٍ
u'نَوْمٌ رَاكِعٌ':Added, #2: 2	نَوْمُ خُرْقٍ
u'نَوْمٌ رَاكِعٌ':Added, #1: 1	نَوْمَ الرَّاكِعِ
u'نَوْمٌ رَجُلٌ':Added, #2: 2	نَوْمُ الرَّاكِعِ
u'نَوْمٌ رَسُولٌ':Added, #1: 1	نَوْمُ الرَّجُلِ
u'نَوْمٌ سَاجِدٌ':Added, #1: 1	نَوْمِ رَسُولِ
u'نَوْمٌ سَاجِدٌ':Added, #1: 1	نَوْمُ السَّاجِدِ
u'نَوْمٌ صَحَابَةٌ':Added, #2: 2	نَوْمِ السَّاجِدِ
u'نَوْمٌ عَالَمٌ':Added, #1: 1	نَوْمُ الصَّحَابَةِ
u'نَوْمٌ علماء':Added, #1: 1	نَوْمِ الْعَالَمِ
u'نَوْمٌ عُلَمَاءُ':Added, #1: 1	نَوْمِ الْعُلَمَاءِ
u'نَوْمٌ عَلِيٌّ':Added, #1: 1	نَوْمِ الْعُلَمَاءِ
u'نَوْمٌ غفلة':Added, #1: 1	نَوْمِ عَلِيٍّ
u'نَوْمٌ غَفْلَةٌ':Added, #1: 1	نَوْمِ الْغَفْلَةِ
u'نَوْمٌ قَاعِدٌ':Added, #1: 1	نَوْمِ الْغَفْلَةِ
u'نَوْمٌ قَائِلٌ':Added, #1: 1	نَوْمَ الْقَاعِدِ
u'نَوْمٌ قَائِلٌ':Added, #1: 1	نَوْمُ الْقَائِلَةِ
u'نَوْمٌ قَائِلَةٌ':Added, #2: 2	نَوْمِ الْقَائِلَةِ
u'نَوْمٌ قَائِلَةٌ':Added, #1: 1	نَوْمُ الْقَائِلَةِ
u'نَوْمٌ قَائِمٌ':Added, #2: 2	نَوْمِ الْقَائِلَةِ
u'نَوْمٌ قَائِمٌ':Added, #2: 2	نَوْمَ الْقَائِمِ
u'نَوْمٌ لَيْلٌ':Added, #2: 2	نَوْمُ الْقَائِمِ
u'نَوْمٌ لَيْلٌ':Added, #17: 17	نَوْمِ اللَّيْلِ
u'نَوْمٌ مُجَاهِدٌ':Added, #1: 1	نَوْمِ لَيْلٍ
u'نَوْمٌ مَرِيضٌ':Added, #1: 1	نَوْمَ الْمُجَاهِدِ
u'نَوْمٌ مُسْتَنِدٌ':Added, #1: 1	نَوْمُ الْمَرِيضِ
u'نَوْمٌ نَاسٌ':Added, #1: 1	نَوْمَ الْمُسْتَنِدِ
u'نَوْمٌ نَبِيٌّ':Added, #2: 2	نَوْمِ النَّاسِ
u'نَوْمٌ نَبِيٌّ':Added, #1: 1	نَوْمَ النَّبِيِّ
u'نَوْمٌ نِساءٌ':Added, #1: 1	نَوْمُ النَّبِيِّ
u'نَوْمٌ نهار':Added, #1: 1	نَوْمُ النِّسَاءِ
u'نَوْمٌ نَهَارٌ':Added, #2: 2	نَوْمَ النَّهَارِ
u'نَوْمٌ نهار':Added, #2: 2	نَوْمَ النَّهَارِ
u'نَوْمٌ نَهَارٌ':Added, #3: 3	نَوْمُ النَّهَارِ
u'نَوْمٌ نهار':Added, #3: 3	نَوْمُ النَّهَارِ
u'نَوْمٌ نَهَارٌ':Added, #7: 7	نَوْمِ النَّهَارِ
u'نَوْمٌ وَكِيلٌ':Added, #7: 7	نَوْمِ النَّهَارِ
u'نَوَّنَ أكل':Predicate, #1: 1	نَوْمِ الْوَكِيلِ
u'نَوَّنَ قَافٌ':Predicate, #1: 1	نَوَّنَ الْأُكُلَ
u'نَوَى إِبَانَةٌ':Predicate, #1: 1	نَوَّنَ الْقَافَ
u'نَوَى أبَدٌ':Predicate, #4: 4	نَوَى الْإِبَانَةَ
u'نَوَى إِبِلٌ':Predicate, #1: 1	نَوَى الْأَبَدَ
u'نَوَى اِبْنٌ':Predicate, #1: 1	نَوَى الْإِبِلَ
u'نَوَى أَبْنَاءٌ':Predicate, #1: 1	نَوَى ابْنَ
u'نَوَى اِتِّحَادٌ':Predicate, #1: 1	نَوَى أَبْنَاءَ
u'نَوَى إتْمَامٌ':Predicate, #1: 1	نَوَى اتِّحَادَ
u'نَوَى إتْمَامٌ':Predicate, #10: 10	نَوَى الْإِتْمَامَ
u'نَوَى أَجْنَبِيٌّ':Predicate, #1: 1	نَوَى إتْمَامَ
u'نَوَى أحَدٌ':Predicate, #2: 2	نَوَى الْأَجْنَبِيَّةَ
u'نَوَى إِحْرَامٌ':Predicate, #6: 6	نَوَى أَحَدَ
u'نَوَى إِحْرَامٌ':Predicate, #13: 13	نَوَى الْإِحْرَامَ
u'نَوَى أَحْسَنُ':Predicate, #2: 2	نَوَى إحْرَامَ
u'نَوَى إِخْبَارٌ':Predicate, #1: 1	نَوَى أَحْسَنَ
u'نَوَى آخِرُ':Predicate, #3: 3	نَوَى الْإِخْبَارَ
u'نَوَى أَدَاءٌ':Predicate, #3: 3	نَوَى آخِرَ
u'نَوَى أَذَانٌ':Predicate, #1: 1	نَوَى الْأَدَاءَ
u'نَوَى إِذْنٌ':Predicate, #2: 2	نَوَى الْأَذَانَ
u'نَوَى أَرْبَعُ':Predicate, #6: 6	نَوَى الْإِذْنَ
u'نَوَى اِسْتِبَاحَةٌ':Predicate, #1: 1	نَوَى الْأَرْبَعَ
u'نَوَى اِسْتِطاعَةٌ':Predicate, #7: 7	نَوَى اسْتِبَاحَةَ
u'نَوَى إشارَة':Predicate, #1: 1	نَوَى اسْتِطَاعَةَ
u'نَوَى إصابَةٌ':Predicate, #9: 9	نَوَى الْإِشَارَةَ
u'نَوَى أصل':Predicate, #1: 1	نَوَى الْإِصَابَةَ
u'نَوَى أًصْلٌ':Predicate, #9: 9	نَوَى أَصْلَ
u'نَوَى إضافَةٌ':Predicate, #9: 9	نَوَى أَصْلَ
u'نَوَى إضْمارٌ':Predicate, #1: 1	نَوَى إضَافَةَ
u'نَوَى اِعْتِكافٌ':Predicate, #1: 1	نَوَى الْإِضْمَارَ
u'نَوَى اِفْتِتَاحٌ':Predicate, #8: 8	نَوَى اعْتِكَافَ
u'نَوَى إِفْطارٌ':Predicate, #1: 1	نَوَى افْتِتَاحَ
u'نَوَى إقامَةٌ':Predicate, #6: 6	نَوَى الْإِفْطَارَ
u'نَوَى إقامَةٌ':Predicate, #116: 116	نَوَى الْإِقَامَةَ
u'نَوَى أقَلُّ':Predicate, #17: 17	نَوَى إقَامَةَ
u'نَوَى أَكْثَرُ':Predicate, #4: 4	نَوَى أَقَلَّ
u'نَوَى أَكْثَرُ':Predicate, #12: 12	نَوَى أَكْثَرَ
u'نَوَى أكل':Predicate, #3: 3	نَوَى الْأَكْثَرَ
u'نَوَى أَكْلٌ':Predicate, #1: 1	نَوَى الْأَكْلَ
u'نَوَى أكل':Predicate, #1: 1	نَوَى الْأَكْلَ
u'نَوَى أَكْلٌ':Predicate, #4: 4	نَوَى أَكْلَ
u'نَوَى أَكْمَلُ':Predicate, #4: 4	نَوَى أَكْلَ
u'نَوَى أَكْمَلُ':Predicate, #1: 1	نَوَى الْأَكْمَلَ
u'نَوَى الْمَرْأَةُ':Predicate, #3: 3	نَوَى أَكْمَلَ
u'نَوَى إمَامٌ':Subject, #1: 1	نَوَى الْمَرْأَةَ
u'نَوَى إمَامٌ':Subject, #1: 1	نَوَى إمَامُهُ
u'نَوَى إمَامَةٌ':Predicate, #25: 25	نَوَى الْإِمَامُ
u'نَوَى إمَامَةٌ':Predicate, #16: 16	نَوَى الْإِمَامَةَ
u'نَوَى آمِرٌ':Subject, #4: 4	نَوَى إمَامَةَ
u'نَوَى أُمِّيٌّ':Subject, #4: 4	نَوَى الْآمِرُ
u'نَوَى إِناثٌ':Predicate, #1: 1	نَوَى الْأُمِّيُّ
u'نَوَى إهْدَاءٌ':Predicate, #1: 1	نَوَى الْإِنَاثَ
u'نَوَى أَوَّلُ':Predicate, #1: 1	نَوَى الْإِهْدَاءَ
u'نَوَى أَوَّلُ':Predicate, #2: 2	نَوَى الْأَوَّلَ
u'نَوَى أَوَّلُ':Subject, #4: 4	نَوَى أَوَّلَ
u'نَوَى إيابٌ':Predicate, #2: 2	نَوَى الْأَوَّلُ
u'نَوَى أيَّامٌ':Predicate, #1: 1	نَوَى الْإِيَابَ
u'نَوَى أَيَّامٌ':Predicate, #3: 3	نَوَى الْأَيَّامَ
u'نَوَى أيَّامٌ':Predicate, #3: 3	نَوَى الْأَيَّامَ
u'نَوَى أَيَّامٌ':Predicate, #3: 3	نَوَى أَيَّامَ
u'نَوَى إِيجَابٌ':Predicate, #3: 3	نَوَى أَيَّامَ
u'نَوَى إيقَاعٌ':Predicate, #1: 1	نَوَى الْإِيجَابَ
u'نَوَى إيقَاعٌ':Predicate, #2: 2	نَوَى الْإِيقَاعَ
u'نَوَى إيمَانٌ':Predicate, #2: 2	نَوَى إيقَاعَ
u'نَوَى بَائِنٌ':Predicate, #2: 2	نَوَى الْإِيمَانَ
u'نَوَى بدن':Predicate, #4: 4	نَوَى الْبَائِنَ
u'نَوَى بَدَنٌ':Predicate, #1: 1	نَوَى الْبَدَنَ
u'نَوَى بِرٌّ':Predicate, #1: 1	نَوَى الْبَدَنَ
u'نَوَى بَراءةٌ':Predicate, #1: 1	نَوَى الْبِرَّ
u'نَوَى بَعْضٌ':Predicate, #2: 2	نَوَى الْبَرَاءَةَ
u'نَوَى بَعْضٌ':Predicate, #1: 1	نَوَى الْبَعْضَ
u'نَوَى بَعْضٌ':Subject, #3: 3	نَوَى بَعْضَ
u'نَوَى بِنَاءٌ':Predicate, #1: 1	نَوَى بَعْضُ
u'نَوَى بَيَانٌ':Predicate, #1: 1	نَوَى بِنَاءَ
u'نَوَى بُيُوتٌ':Predicate, #1: 1	نَوَى بَيَانَ
u'نَوَى تَأَخُّرٌ':Predicate, #2: 2	نَوَى الْبُيُوتَ
u'نَوَى تَأْكِيدٌ':Predicate, #2: 2	نَوَى تَأَخُّرَ
u'نَوَى تَبَرُّدٌ':Predicate, #4: 4	نَوَى التَّأْكِيدَ
u'نَوَى تَبَرُّعٌ':Predicate, #3: 3	نَوَى التَّبَرُّدَ
u'نَوَى تَتَابُعٌ':Predicate, #3: 3	نَوَى التَّبَرُّعَ
u'نَوَى تَتَابُعٌ':Predicate, #1: 1	نَوَى تَتَابُعَ
u'نَوَى تِجَارَةٌ':Predicate, #2: 2	نَوَى التَّتَابُعَ
u'نَوَى تَجْدِيدٌ':Predicate, #12: 12	نَوَى التِّجَارَةَ
u'نَوَى تَجْدِيدٌ':Predicate, #1: 1	نَوَى تَجْدِيدَ
u'نَوَى تَجْوِيدٌ':Predicate, #2: 2	نَوَى التَّجْدِيدَ
u'نَوَى تَحْرِيمٌ':Predicate, #2: 2	نَوَى تَجْوِيدَ
u'نَوَى تَحْرِيمٌ':Predicate, #13: 13	نَوَى التَّحْرِيمَ
u'نَوَى تَحْرِيمٌ':Subject, #5: 5	نَوَى تَحْرِيمَ
u'نَوَى تَحْصِيلٌ':Predicate, #1: 1	نَوَى تَحْرِيمُهُ
u'نَوَى تَحَلُّلٌ':Predicate, #2: 2	نَوَى تَحْصِيلَ
u'نَوَى تَحْلِيلٌ':Predicate, #2: 2	نَوَى التَّحَلُّلَ
u'نَوَى تَحِيَّةٌ':Predicate, #1: 1	نَوَى التَّحْلِيلَ
u'نَوَى تَخْصِيصٌ':Predicate, #3: 3	نَوَى التَّحِيَّةَ
u'نَوَى تَخْصِيصٌ':Predicate, #30: 30	نَوَى التَّخْصِيصَ
u'نَوَى تَرَاخِي':Predicate, #5: 5	نَوَى تَخْصِيصَ
u'نَوَى تَرَاوِيحُ':Predicate, #1: 1	نَوَى التَّرَاخِيَ
u'نَوَى تَرْكٌ':Predicate, #1: 1	نَوَى التَّرَاوِيحَ
u'نَوَى تَشْدِيدٌ':Predicate, #4: 4	نَوَى تَرْكَ
u'نَوَى تَصَدُّقٌ':Predicate, #1: 1	نَوَى التَّشْدِيدَ
u'نَوَى تَطْلِيقٌ':Predicate, #1: 1	نَوَى التَّصَدُّقَ
u'نَوَى تَطَوُّعٌ':Predicate, #1: 1	نَوَى تَطْلِيقَ
u'نَوَى تَعْجِيل':Predicate, #14: 14	نَوَى التَّطَوُّعَ
u'نَوَى تَعَدُّدٌ':Predicate, #2: 2	نَوَى التَّعْجِيلَ
u'نَوَى تَعَدُّدٌ':Predicate, #1: 1	نَوَى التَّعَدُّدَ
u'نَوَى تَعَدِّي':Predicate, #1: 1	نَوَى تَعَدُّدَ
u'نَوَى تَعْلِيقٌ':Predicate, #1: 1	نَوَى التَّعَدِّيَ
u'نَوَى تَعْمِيمٌ':Predicate, #3: 3	نَوَى التَّعْلِيقَ
u'نَوَى تَعْمِيمٌ':Predicate, #1: 1	نَوَى التَّعْمِيمَ
u'نَوَى تَغْلِيظٌ':Predicate, #1: 1	نَوَى تَعْمِيمَ
u'نَوَى تَغْيِيرٌ':Predicate, #2: 2	نَوَى التَّغْلِيظَ
u'نَوَى تَفَرُّقٌ':Predicate, #2: 2	نَوَى تَغْيِيرَ
u'نَوَى تَفْصِيلٌ':Predicate, #1: 1	نَوَى التَّفَرُّقَ
u'نَوَى تَفْوِيضٌ':Predicate, #1: 1	نَوَى تَفْصِيلَ
u'نَوَى تَفْوِيضٌ':Predicate, #1: 1	نَوَى التَّفْوِيضَ
u'نَوَى تَقْديمٌ':Predicate, #2: 2	نَوَى تَفْوِيضَ
u'نَوَى تَقْليدٌ':Predicate, #1: 1	نَوَى تَقْدِيمَ
u'نَوَى تَقْليد':Predicate, #1: 1	نَوَى تَقْلِيدَ
u'نَوَى تَقْيِيد':Predicate, #1: 1	نَوَى تَقْلِيدَ
u'نَوَى تَكْرارٌ':Predicate, #1: 1	نَوَى تَقْيِيدَ
u'نَوَى تَكْرارٌ':Predicate, #1: 1	نَوَى تَكْرَارَ
u'نَوَى تَكَرُّرٌ':Predicate, #4: 4	نَوَى التَّكْرَارَ
u'نَوَى تَكْفيرٌ':Predicate, #1: 1	نَوَى تَكَرُّرَ
u'نَوَى تَكَلُّمٌ':Predicate, #1: 1	نَوَى التَّكْفِيرَ
u'نَوَى تَمْكِين':Predicate, #4: 4	نَوَى التَّكَلُّمَ
u'نَوَى تَمَلُّك':Predicate, #1: 1	نَوَى التَّمْكِينَ
u'نَوَى تَنْجِيزٌ':Predicate, #1: 1	نَوَى التَّمَلُّكَ
u'نَوَى تَنْصِيفٌ':Predicate, #2: 2	نَوَى تَنْجِيزَ
u'نَوَى تَنْظِيفٌ':Predicate, #1: 1	نَوَى تَنْصِيفَ
u'نَوَى تَوْزِيعٌ':Predicate, #1: 1	نَوَى التَّنْظِيفَ
u'نَوَى تَوْزِيعٌ':Predicate, #1: 1	نَوَى تَوْزِيعَهُنَّ
u'نَوَى تَوَضُّؤٌ':Predicate, #4: 4	نَوَى التَّوْزِيعَ
u'نَوَى تَيَمُّمٌ':Predicate, #1: 1	نَوَى التَّوَضُّؤَ
u'نَوَى ثَانِي':Predicate, #2: 2	نَوَى التَّيَمُّمَ
u'نَوَى ثَانِي':Predicate, #1: 1	نَوَى الثَّانِيَ
u'نَوَى ثَانِيَةٌ':Predicate, #4: 4	نَوَى الثَّانِيَةَ
u'نَوَى ثَلاثُ':Predicate, #4: 4	نَوَى الثَّانِيَةَ
u'نَوَى ثَلاثُ':Predicate, #1: 1	نَوَى ثَلَاثَ
u'نَوَى جَاهِلٌ':Predicate, #41: 41	نَوَى الثَّلَاثَ
u'نَوَى جَائِزٌ':Predicate, #1: 1	نَوَى جَاهِلَ
u'نَوَى جَزَاءٌ':Predicate, #1: 1	نَوَى الْجَائِزَ
u'نَوَى جَزْم':Predicate, #1: 1	نَوَى الْجَزَاءَ
u'نَوَى جماع':Predicate, #1: 1	نَوَى الْجَزْمَ
u'نَوَى جِمَاعٌ':Predicate, #3: 3	نَوَى الْجِمَاعَ
u'نَوَى جمع':Predicate, #3: 3	نَوَى الْجِمَاعَ
u'نَوَى جُمَعٌ':Predicate, #1: 1	نَوَى الْجُمَعَ
u'نَوَى جمع':Predicate, #1: 1	نَوَى الْجُمَعَ
u'نَوَى جَمْعٌ':Predicate, #1: 1	نَوَى جَمْعَ
u'نَوَى جمع':Predicate, #1: 1	نَوَى جَمْعَ
u'نَوَى جَمْعٌ':Predicate, #9: 9	نَوَى الْجَمْعَ
u'نَوَى جمعة':Predicate, #9: 9	نَوَى الْجَمْعَ
u'نَوَى جُمُعَةٌ':Predicate, #3: 3	نَوَى الْجُمُعَةَ
u'نَوَى جَمِيع':Predicate, #3: 3	نَوَى الْجُمُعَةَ
u'نَوَى جَنَابَةٌ':Predicate, #4: 4	نَوَى الْجَمِيعَ
u'نَوَى جَنَابَةٌ':Predicate, #1: 1	نَوَى جَنَابَةَ
u'نَوَى جِنْسٌ':Predicate, #4: 4	نَوَى الْجَنَابَةَ
u'نَوَى جِنْسٌ':Predicate, #1: 1	نَوَى الْجِنْسَ
u'نَوَى جَوَابٌ':Predicate, #1: 1	نَوَى جِنْسَ
u'نَوَى حاجٌّ':Subject, #1: 1	نَوَى الْجَوَابَ
u'نَوَى حاضِرٌ':Predicate, #1: 1	نَوَى الْحَاجُّ
u'نَوَى حاضِرٌ':Predicate, #1: 1	نَوَى الْحَاضِرَةَ
u'نَوَى حاضِرٌ':Subject, #1: 1	نَوَى حَاضِرَةً
u'نَوَى حالٌ':Predicate, #1: 1	نَوَى الْحَاضِرُ
u'نَوَى حالٌ':Predicate, #2: 2	نَوَى الْحَالَ
u'نَوَى حامِلٌ':Subject, #2: 2	نَوَى حَالَ
u'نَوَى حَبْسٌ':Predicate, #4: 4	نَوَى الْحَامِلُ
u'نَوَى حَبَشِيٌّ':Predicate, #2: 2	نَوَى الْحَبْسَ
u'نَوَى حَجٌّ':Predicate, #1: 1	نَوَى حَبَشِيَّةً
u'نَوَى حَجٌّ':Predicate, #13: 13	نَوَى الْحَجَّ
u'نَوَى حَدَثٌ':Predicate, #1: 1	نَوَى حَجَّ
u'نَوَى حُرْمَةٌ':Predicate, #1: 1	نَوَى الْحَدَثَ
u'نَوَى حُرِّيَّةٌ':Predicate, #2: 2	نَوَى الْحُرْمَةَ
u'نَوَى حساب':Predicate, #1: 1	نَوَى الْحُرِّيَّةَ
u'نَوَى حِسَابٌ':Predicate, #1: 1	نَوَى حِسَابَ
u'نَوَى حِسْبَةٌ':Predicate, #1: 1	نَوَى حِسَابَ
u'نَوَى حَقِيقٌ':Predicate, #1: 1	نَوَى الْحِسْبَةَ
u'نَوَى حَقِيقٌ':Predicate, #11: 11	نَوَى الْحَقِيقَةَ
u'نَوَى حَقِيقَةٌ':Predicate, #60: 60	نَوَى حَقِيقَةَ
u'نَوَى حَقِيقَةٌ':Predicate, #11: 11	نَوَى الْحَقِيقَةَ
u'نَوَى حُكْمٌ':Predicate, #60: 60	نَوَى حَقِيقَةَ
u'نَوَى حُكْمٌ':Predicate, #1: 1	نَوَى الْحُكْمَ
u'نَوَى حَيْضٌ':Predicate, #1: 1	نَوَى حُكْمَ
u'نَوَى خَارِجٌ':Predicate, #1: 1	نَوَى الْحَيْضَ
u'نَوَى خُبْزٌ':Predicate, #2: 2	نَوَى خَارِجَ
u'نَوَى خدمة':Predicate, #1: 1	نَوَى الْخُبْزَ
u'نَوَى خِدْمَةٌ':Predicate, #2: 2	نَوَى الْخِدْمَةَ
u'نَوَى خُرُوجٌ':Predicate, #2: 2	نَوَى الْخِدْمَةَ
u'نَوَى خِلاَفٌ':Predicate, #14: 14	نَوَى الْخُرُوجَ
u'نَوَى خِلاَفٌ':Subject, #2: 2	نَوَى خِلَافَ
u'نَوَى خَلِيفَةٌ':Subject, #1: 1	نَوَى خِلَافُ
u'نَوَى خَمْسَةٌ':Predicate, #3: 3	نَوَى الْخَلِيفَةُ
u'نَوَى خِيَانَةٌ':Predicate, #2: 2	نَوَى خَمْسَةَ
u'نَوَى خَيْرٌ':Predicate, #3: 3	نَوَى الْخِيَانَةَ
u'نَوَى خَيْلٌ':Predicate, #2: 2	نَوَى الْخَيْرَ
u'نَوَى دُخُولٌ':Predicate, #1: 1	نَوَى الْخَيْلَ
u'نَوَى دُخُولٌ':Predicate, #1: 1	نَوَى الدُّخُولَ
u'نَوَى دَنانيرُ':Predicate, #1: 1	نَوَى دُخُولَ
u'نَوَى دؤب':Predicate, #1: 1	نَوَى الدَّنَانِيرَ
u'نَوَى دَوْس':Predicate, #1: 1	نَوَى الدَّؤُبَ
u'نَوَى دونٌ':Predicate, #1: 1	نَوَى الدَّوْسَ
u'نَوَى دَيْنٌ':Predicate, #1: 1	نَوَى دُونَ
u'نَوَى ذكر':Predicate, #1: 1	نَوَى الدَّيْنَ
u'نَوَى ذكر':Predicate, #1: 1	نَوَى الذَّكَرَ
u'نَوَى ذَكَرٌ':Predicate, #1: 1	نَوَى الذِّكْرَ
u'نَوَى ذِكْرٌ':Predicate, #1: 1	نَوَى الذَّكَرَ
u'نَوَى ذُكورٌ':Predicate, #1: 1	نَوَى الذِّكْرَ
u'نَوَى رجعة':Predicate, #2: 2	نَوَى الذُّكُورَ
u'نَوَى رَجْعَةٌ':Predicate, #3: 3	نَوَى الرَّجْعَةَ
u'نَوَى رَجْعِيٌّ':Predicate, #3: 3	نَوَى الرَّجْعَةَ
u'نَوَى رَجُلٌ':Subject, #1: 1	نَوَى الرَّجْعِيَّ
u'نَوَى رَجُلٌ':Subject, #1: 1	نَوَى الرَّجُلُ
u'نَوَى رُجُوعٌ':Predicate, #1: 1	نَوَى رَجُلٌ
u'نَوَى رَدٌّ':Predicate, #30: 30	نَوَى الرُّجُوعَ
u'نَوَى رَدٌّ':Predicate, #1: 1	نَوَى الرَّدَّ
u'نَوَى رَفْضٌ':Predicate, #4: 4	نَوَى رَدَّ
u'نَوَى رَفْضٌ':Predicate, #2: 2	نَوَى رَفْضَ
u'نَوَى رَفْعٌ':Predicate, #3: 3	نَوَى الرَّفْضَ
u'نَوَى رَفيقٌ':Predicate, #21: 21	نَوَى رَفْعَ
u'نَوَى رَمَضانِيّ':Predicate, #1: 1	نَوَى الرَّفِيقَ
u'نَوَى زَكاةٌ':Predicate, #2: 2	نَوَى الرَّمَضَانِيَّةَ
u'نَوَى زَكاةٌ':Predicate, #5: 5	نَوَى زَكَاةَ
u'نَوَى زَمانٌ':Predicate, #9: 9	نَوَى الزَّكَاةَ
u'نَوَى زَوْجٌ':Subject, #1: 1	نَوَى زَمَانَ
u'نَوَى زِيادَةٌ':Predicate, #30: 30	نَوَى الزَّوْجُ
u'نَوَى زِيادَةٌ':Predicate, #1: 1	نَوَى زِيَادَةَ
u'نَوَى زِيارَةٌ':Predicate, #3: 3	نَوَى الزِّيَادَةَ
u'نَوَى سجدة':Predicate, #1: 1	نَوَى زِيَارَةَ
u'نَوَى سَجْدَةٌ':Predicate, #6: 6	نَوَى السَّجْدَةَ
u'نَوَى سُجُودٌ':Predicate, #6: 6	نَوَى السَّجْدَةَ
u'نَوَى سَفَرٌ':Predicate, #1: 1	نَوَى سُجُودَ
u'نَوَى سَفَرٌ':Predicate, #1: 1	نَوَى سَفَرَ
u'نَوَى سلام':Predicate, #8: 8	نَوَى السَّفَرَ
u'نَوَى سَلاَمٌ':Predicate, #1: 1	نَوَى السَّلَامَ
u'نَوَى سَمَكٌ':Predicate, #1: 1	نَوَى السَّلَامَ
u'نَوَى سُنَّةٌ':Predicate, #2: 2	نَوَى السَّمَكَ
u'نَوَى سُنَّةٌ':Predicate, #1: 1	نَوَى سُنَّةَ
u'نَوَى سود':Predicate, #4: 4	نَوَى السُّنَّةَ
u'نَوَى سُودٌ':Predicate, #1: 1	نَوَى السُّودَ
u'نَوَى شَخْصٌ':Subject, #1: 1	نَوَى السُّودَ
u'نَوَى شَرٌّ':Predicate, #2: 2	نَوَى شَخْصٌ
u'نَوَى شِرَاءٌ':Predicate, #1: 1	نَوَى الشَّرَّ
u'نَوَى شَرْطٌ':Predicate, #1: 1	نَوَى الشِّرَاءَ
u'نَوَى شركة':Predicate, #3: 3	نَوَى الشَّرْطَ
u'نَوَى شَرِكَةٌ':Predicate, #3: 3	نَوَى الشَّرِكَةَ
u'نَوَى شُرُوعٌ':Predicate, #3: 3	نَوَى الشَّرِكَةَ
u'نَوَى صَائِمٌ':Subject, #6: 6	نَوَى الشُّرُوعَ
u'نَوَى صَحِيحٌ':Predicate, #5: 5	نَوَى الصَّائِمُ
u'نَوَى صدقة':Predicate, #1: 1	نَوَى الصَّحِيحَ
u'نَوَى صَدَقَةٌ':Predicate, #1: 1	نَوَى صَدَقَةَ
u'نَوَى صدقة':Predicate, #1: 1	نَوَى صَدَقَةَ
u'نَوَى صَدَقَةٌ':Predicate, #4: 4	نَوَى الصَّدَقَةَ
u'نَوَى صَرْفٌ':Predicate, #4: 4	نَوَى الصَّدَقَةَ
u'نَوَى صَرْف':Predicate, #1: 1	نَوَى الصَّرْفَ
u'نَوَى صَرْفٌ':Predicate, #1: 1	نَوَى الصَّرْفَ
u'نَوَى صَرْف':Predicate, #2: 2	نَوَى صَرْفَ
u'نَوَى صَرِيحٌ':Predicate, #2: 2	نَوَى صَرْفَ
u'نَوَى صَلاَةٌ':Predicate, #2: 2	نَوَى صَرِيحَ
u'نَوَى صَلاَةٌ':Predicate, #10: 10	نَوَى صَلَاةَ
u'نَوَى صِلَةٌ':Predicate, #11: 11	نَوَى الصَّلَاةَ
u'نَوَى صَوْمٌ':Predicate, #1: 1	نَوَى صِلَةَ
u'نَوَى صَوْمٌ':Predicate, #26: 26	نَوَى صَوْمَ
u'نَوَى صِيَامٌ':Predicate, #32: 32	نَوَى الصَّوْمَ
u'نَوَى ضِدٌّ':Predicate, #1: 1	نَوَى صِيَامَ
u'نَوَى ضَرْبٌ':Predicate, #1: 1	نَوَى ضِدَّ
u'نَوَى طعام':Predicate, #3: 3	نَوَى الضَّرْبَ
u'نَوَى طَعَامٌ':Predicate, #2: 2	نَوَى الطَّعَامَ
u'نَوَى طَلاَقٌ':Predicate, #2: 2	نَوَى الطَّعَامَ
u'نَوَى طَلاَقٌ':Predicate, #3: 3	نَوَى طَلَاقَ
u'نَوَى طَهَارَةٌ':Predicate, #76: 76	نَوَى الطَّلَاقَ
u'نَوَى طواف':Predicate, #5: 5	نَوَى الطَّهَارَةَ
u'نَوَى طَوَافٌ':Predicate, #1: 1	نَوَى طَوَافَ
u'نَوَى طواف':Predicate, #1: 1	نَوَى طَوَافَ
u'نَوَى طَوَافٌ':Predicate, #5: 5	نَوَى الطَّوَافَ
u'نَوَى ظَرْف':Predicate, #5: 5	نَوَى الطَّوَافَ
u'نَوَى ظَرْفٌ':Predicate, #1: 1	نَوَى الظَّرْفِيَّةَ
u'نَوَى ظَرْفِيّ':Predicate, #5: 5	نَوَى الظَّرْفَ
u'نَوَى ظهار':Predicate, #1: 1	نَوَى الظَّرْفِيَّةَ
u'نَوَى ظُهْرٌ':Predicate, #10: 10	نَوَى الظِّهَارَ
u'نَوَى ظُهْرٌ':Predicate, #23: 23	نَوَى الظُّهْرَ
u'نَوَى عارِيَّةٌ':Predicate, #7: 7	نَوَى ظُهْرَ
u'نَوَى عَبْدٌ':Subject, #1: 1	نَوَى الْعَارِيَّةَ
u'نَوَى عتاق':Predicate, #2: 2	نَوَى الْعَبْدُ
u'نَوَى عتق':Predicate, #1: 1	نَوَى الْعَتَاقَ
u'نَوَى عِتْقٌ':Predicate, #15: 15	نَوَى الْعِتْقَ
u'نَوَى عتق':Predicate, #15: 15	نَوَى الْعِتْقَ
u'نَوَى عتق':Predicate, #1: 1	نَوَى عَتَقَ
u'نَوَى عِتْقٌ':Predicate, #3: 3	نَوَى عِتْقَ
u'نَوَى عِدَّةٌ':Predicate, #3: 3	نَوَى عِتْقَ
u'نَوَى عَدَدٌ':Predicate, #1: 1	نَوَى الْعِدَّةَ
u'نَوَى عَدَمٌ':Predicate, #1: 1	نَوَى الْعَدَدَ
u'نَوَى عَرَبِيٌّ':Predicate, #1: 1	نَوَى عَدَمَ
u'نَوَى عَسْكَرٌ':Subject, #3: 3	نَوَى عَرَبِيَّةً
u'نَوَى عَصْرٌ':Predicate, #2: 2	نَوَى عَسْكَرٌ
u'نَوَى عطف':Predicate, #3: 3	نَوَى الْعَصْرَ
u'نَوَى عَطْفٌ':Predicate, #1: 1	نَوَى الْعَطْفَ
u'نَوَى عَقْدٌ':Predicate, #1: 1	نَوَى الْعَطْفَ
u'نَوَى عمرة':Predicate, #1: 1	نَوَى الْعَقْدَ
u'نَوَى عُمْرَةٌ':Predicate, #2: 2	نَوَى الْعُمْرَةَ
u'نَوَى عَمَلٌ':Predicate, #2: 2	نَوَى الْعُمْرَةَ
u'نَوَى عُمُومٌ':Predicate, #1: 1	نَوَى الْعَمَلَ
u'نَوَى عند':Predicate, #1: 1	نَوَى عُمُومَ
u'نَوَى عَوْدٌ':Predicate, #25: 25	نَوَى عِنْدَ
u'نَوَى عِوَض':Predicate, #1: 1	نَوَى الْعَوْدَ
u'نَوَى عِيَانٌ':Predicate, #1: 1	نَوَى الْعِوَضِيَّةَ
u'نَوَى عين':Predicate, #1: 1	نَوَى الْعِيَانَ
u'نَوَى عَيْنٌ':Predicate, #1: 1	نَوَى عَيْنَ
u'نَوَى عَيْن':Predicate, #1: 1	نَوَى عَيْنَ
u'نَوَى غَايَةٌ':Predicate, #1: 1	نَوَى عَيْنَ
u'نَوَى غُرْمٌ':Predicate, #1: 1	نَوَى غَايَةَ
u'نَوَى غَزْلٌ':Predicate, #1: 1	نَوَى الْغُرْمَ
u'نَوَى غُسْلٌ':Predicate, #1: 1	نَوَى الْغَزْلَ
u'نَوَى غُسْلٌ':Predicate, #2: 2	نَوَى غُسْلَ
u'نَوَى غير':Predicate, #3: 3	نَوَى الْغُسْلَ
u'نَوَى غَيْرٌ':Predicate, #22: 22	نَوَى غَيْرَ
u'نَوَى فَاسِدٌ':Predicate, #22: 22	نَوَى غَيْرَ
u'نَوَى فَاسِدٌ':Predicate, #1: 1	نَوَى الْفَاسِدَ
u'نَوَى فَرْجٌ':Predicate, #2: 2	نَوَى الْفَاسِدَةَ
u'نَوَى فَرْضٌ':Predicate, #1: 1	نَوَى الْفَرْجَ
u'نَوَى فَرْضٌ':Predicate, #10: 10	نَوَى فَرْضَ
u'نَوَى فَرِيضَةٌ':Predicate, #13: 13	نَوَى الْفَرْضَ
u'نَوَى فَسْخٌ':Predicate, #1: 1	نَوَى الْفَرِيضَةَ
u'نَوَى فَصْلٌ':Predicate, #1: 1	نَوَى الْفَسْخَ
u'نَوَى فِضَّةٌ':Predicate, #2: 2	نَوَى الْفَصْلَ
u'نَوَى فِطْرٌ':Predicate, #1: 1	نَوَى الْفِضَّةَ
u'نَوَى فِعْلٌ':Predicate, #5: 5	نَوَى الْفِطْرَ
u'نَوَى فِعْلٌ':Predicate, #3: 3	نَوَى الْفِعْلَ
u'نَوَى فلان':Predicate, #6: 6	نَوَى فِعْلَ
u'نَوَى فلان':Predicate, #1: 1	نَوَى مَكَّةَ
u'نَوَى فَوْر':Predicate, #2: 2	نَوَى الرَّمَضَانِيَّةَ
u'نَوَى فَوْرٌ':Predicate, #1: 1	نَوَى الْفَوْرِيَّةَ
u'نَوَى فَوْرَة':Predicate, #4: 4	نَوَى الْفَوْرَ
u'نَوَى فَوْرِيّ':Predicate, #1: 1	نَوَى الْفَوْرِيَّةَ
u'نَوَى قَارِئٌ':Subject, #1: 1	نَوَى الْفَوْرِيَّةَ
u'نَوَى قَاصِرٌ':Subject, #1: 1	نَوَى الْقَارِئُ
u'نَوَى قَالٌ':Predicate, #2: 2	نَوَى الْقَاصِرُ
u'نَوَى قَائِلٌ':Subject, #2: 2	نَوَى قَالَ
u'نَوَى قَبُولٌ':Predicate, #1: 1	نَوَى الْقَائِلُ
u'نَوَى قدرة':Predicate, #2: 2	نَوَى الْقَبُولَ
u'نَوَى قُدْرَةٌ':Predicate, #1: 1	نَوَى الْقُدْرَةَ
u'نَوَى قُدْوَةٌ':Predicate, #1: 1	نَوَى الْقُدْرَةَ
u'نَوَى قِرَاءةٌ':Predicate, #2: 2	نَوَى الْقُدْوَةَ
u'نَوَى قِرَانٌ':Predicate, #1: 1	نَوَى قِرَاءَةَ
u'نَوَى قُرْبَةٌ':Predicate, #1: 1	نَوَى الْقِرَانَ
u'نَوَى قُرْبَةٌ':Predicate, #1: 1	نَوَى الْقُرْبَةَ
u'نَوَى قَرْضٌ':Predicate, #1: 1	نَوَى قُرْبَةَ
u'نَوَى قَسَمٌ':Predicate, #1: 1	نَوَى الْقَرْضَ
u'نَوَى قَصْرٌ':Predicate, #2: 2	نَوَى الْقَسَمَ
u'نَوَى قَضَاءٌ':Predicate, #22: 22	نَوَى الْقَصْرَ
u'نَوَى قَضَاءٌ':Predicate, #6: 6	نَوَى الْقَضَاءَ
u'نَوَى قَطْعٌ':Predicate, #7: 7	نَوَى قَضَاءَ
u'نَوَى قَطْعٌ':Predicate, #15: 15	نَوَى قَطْعَ
u'نَوَى قول':Subject, #2: 2	نَوَى الْقَطْعَ
u'نَوَى قَوْلٌ':Subject, #1: 1	نَوَى قَوْلُهُ
u'نَوَى قَوْمٌ':Predicate, #1: 1	نَوَى قَوْلُهُ
u'نَوَى قيام':Predicate, #1: 1	نَوَى الْقَوْمَ
u'نَوَى قِيَامٌ':Predicate, #1: 1	نَوَى الْقِيَامَ
u'نَوَى كَافِرٌ':Subject, #1: 1	نَوَى الْقِيَامَ
u'نَوَى كِتَابٌ':Predicate, #1: 1	نَوَى الْكَافِرُ
u'نَوَى كذب':Predicate, #1: 1	نَوَى كِتَابَ
u'نَوَى كَذِبٌ':Predicate, #7: 7	نَوَى الْكَذِبَ
u'نَوَى كَرَامَةٌ':Predicate, #7: 7	نَوَى الْكَذِبَ
u'نَوَى كَرْع':Predicate, #4: 4	نَوَى الْكَرَامَةَ
u'نَوَى كفر':Predicate, #1: 1	نَوَى الْكَرْعَ
u'نَوَى كُفْرٌ':Predicate, #3: 3	نَوَى الْكُفْرَ
u'نَوَى كُوفِيٌّ':Predicate, #3: 3	نَوَى الْكُفْرَ
u'نَوَى لاَحِقٌ':Subject, #3: 3	نَوَى كُوفِيَّةً
u'نَوَى لَحْمٌ':Predicate, #1: 1	نَوَى اللَّاحِقُ
u'نَوَى لُزُومٌ':Predicate, #1: 1	نَوَى اللَّحْمَ
u'نَوَى لَيْلٌ':Predicate, #1: 1	نَوَى اللُّزُومَ
u'نَوَى لَيْلٌ':Predicate, #11: 11	نَوَى لَيْلَةَ
u'نَوَى لَيْلٌ':Predicate, #1: 1	نَوَى اللَّيْلَةَ
u'نَوَى مَاءٌ':Predicate, #3: 3	نَوَى لَيْلَةً
u'نَوَى مَالٌ':Predicate, #1: 1	نَوَى الْمَاءَ
u'نَوَى مَالِكٌ':Subject, #2: 2	نَوَى الْمَالَ
u'نَوَى مُبَاشَرَةٌ':Predicate, #2: 2	نَوَى الْمَالِكُ
u'نَوَى مُبْتَدِئٌ':Subject, #2: 2	نَوَى الْمُبَاشَرَةَ
u'نَوَى مُتَابَعٌ':Predicate, #1: 1	نَوَى الْمُبْتَدِئُ
u'نَوَى مُتَابَعٌ':Predicate, #2: 2	نَوَى الْمُتَابَعَةَ
u'نَوَى مُتَابَعَةٌ':Predicate, #4: 4	نَوَى مُتَابَعَةَ
u'نَوَى مُتَابَعَةٌ':Predicate, #2: 2	نَوَى الْمُتَابَعَةَ
u'نَوَى مثل':Predicate, #4: 4	نَوَى مُتَابَعَةَ
u'نَوَى مِثْلٌ':Predicate, #1: 1	نَوَى مِثْلَ
u'نَوَى مَجَازٌ':Predicate, #1: 1	نَوَى مِثْلَ
u'نَوَى مُجَرَّدٌ':Predicate, #4: 4	نَوَى الْمَجَازَ
u'نَوَى مُجَرَّدٌ':Subject, #1: 1	نَوَى مُجَرَّدَ
u'نَوَى مُحْتَمَلٌ':Predicate, #1: 1	نَوَى مُجَرَّدُ
u'نَوَى مُحْتَمَلٌ':Subject, #6: 6	نَوَى مُحْتَمَلَ
u'نَوَى مُحْدِثٌ':Subject, #1: 1	نَوَى مُحْتَمَلُ
u'نَوَى مَحْمُولٌ':Predicate, #2: 2	نَوَى الْمُحْدِثُ
u'نَوَى مُدَّةٌ':Predicate, #1: 1	نَوَى الْمَحْمُولَ
u'نَوَى مَدْيُونٌ':Subject, #1: 1	نَوَى مُدَّةَ
u'نَوَى مَرِيضٌ':Subject, #2: 2	نَوَى مَدْيُونٌ
u'نَوَى مُسَافِرٌ':Subject, #1: 1	نَوَى الْمَرِيضُ
u'نَوَى مُسَافِرٌ':Subject, #26: 26	نَوَى الْمُسَافِرُ
u'نَوَى مَسْجِدٌ':Predicate, #2: 2	نَوَى مُسَافِرٌ
u'نَوَى مَسْحٌ':Predicate, #1: 1	نَوَى الْمَسْجِدَ
u'نَوَى مُشَافَهَةٌ':Predicate, #3: 3	نَوَى الْمَسْحَ
u'نَوَى مُضَاجَعَةٌ':Predicate, #1: 1	نَوَى الْمُشَافَهَةَ
u'نَوَى مُضَارِبٌ':Subject, #1: 1	نَوَى الْمُضَاجَعَةَ
u'نَوَى مُضَافٌ':Predicate, #1: 1	نَوَى الْمُضَارِبُ
u'نَوَى مُطَلَّقٌ':Predicate, #1: 1	نَوَى الْمُضَافَ
u'نَوَى مُطْلَقٌ':Predicate, #1: 1	نَوَى الْمُطَلَّقَةَ
u'نَوَى مَعْرِفَةٌ':Predicate, #2: 2	نَوَى مُطْلَقَ
u'نَوَى مَعْرِفَة':Predicate, #1: 1	نَوَى مَعْرِفَةَ
u'نَوَى مُعَلِّلٌ':Predicate, #1: 1	نَوَى مَعْرِفَةَ
u'نَوَى مُعَيَّنٌ':Predicate, #2: 2	نَوَى مُعَلِّلِينَ
u'نَوَى مُفَارِقٌ':Predicate, #2: 2	نَوَى مُعَيَّنَةً
u'نَوَى مُفَارَقَةٌ':Predicate, #2: 2	نَوَى الْمُفَارِقَةَ
u'نَوَى مُفَارَقَةٌ':Predicate, #2: 2	نَوَى الْمُفَارَقَةَ
u'نَوَى مُقَارَنٌ':Predicate, #3: 3	نَوَى مُفَارَقَةَ
u'نَوَى مُقَارَنَةٌ':Predicate, #1: 1	نَوَى الْمُقَارَنَةَ
u'نَوَى مَقَامٌ':Predicate, #1: 1	نَوَى الْمُقَارَنَةَ
u'نَوَى مُقَامٌ':Predicate, #2: 2	نَوَى الْمَقَامَ
u'نَوَى مَقَامٌ':Predicate, #2: 2	نَوَى الْمُقَامَ
u'نَوَى مُقَدَّمٌ':Predicate, #2: 2	نَوَى مَقَامَ
u'نَوَى مَقْدُورٌ':Predicate, #1: 1	نَوَى مُقَدَّمَةَ
u'نَوَى مَقْصُورٌ':Predicate, #1: 1	نَوَى الْمَقْدُورَ
u'نَوَى مَكْتُوبٌ':Predicate, #1: 1	نَوَى مَقْصُورَةً
u'نَوَى مُكْرَهٌ':Subject, #1: 1	نَوَى مَكْتُوبَةً
u'نَوَى مُلْتَقِط':Subject, #3: 3	نَوَى الْمُكْرَهُ
u'نَوَى مِلْكٌ':Predicate, #1: 1	نَوَى الْمُلْتَقِطُ
u'نَوَى مُمَاثَلَةٌ':Predicate, #1: 1	نَوَى الْمِلْكَ
u'نَوَى مُمَيِّزٌ':Subject, #2: 2	نَوَى الْمُمَاثَلَةَ
u'نَوَى مَنٌّ':Predicate, #2: 2	نَوَى الْمُمَيِّزُ
u'نَوَى مَنْعٌ':Predicate, #1: 1	نَوَى الْمَنَّ
u'نَوَى مُنْفَرِدٌ':Subject, #1: 1	نَوَى مَنْعَ
u'نَوَى مُوجِبٌ':Predicate, #2: 2	نَوَى الْمُنْفَرِدُ
u'نَوَى مُوَكِّلٌ':Predicate, #1: 1	نَوَى مُوجِبَ
u'نَوَى مُوَكِّلٌ':Subject, #1: 1	نَوَى الْمُوَكِّلَ
u'نَوَى مِيَاهٌ':Predicate, #5: 5	نَوَى الْمُوَكِّلُ
u'نَوَى ناذِر':Subject, #1: 1	نَوَى مِيَاهَ
u'نَوَى نَاسٌ':Predicate, #1: 1	نَوَى النَّاذِرُ
u'نَوَى نَجَاسَةٌ':Predicate, #1: 1	نَوَى النَّاسَ
u'نَوَى نذر':Predicate, #1: 1	نَوَى النَّجَاسَةَ
u'نَوَى نَذْرٌ':Predicate, #14: 14	نَوَى النَّذْرَ
u'نَوَى نُزُولٌ':Predicate, #14: 14	نَوَى النَّذْرَ
u'نَوَى نِساءٌ':Predicate, #3: 3	نَوَى النُّزُولَ
u'نَوَى نُسُكٌ':Predicate, #1: 1	نَوَى النِّسَاءَ
u'نَوَى نِصْفٌ':Predicate, #1: 1	نَوَى النُّسُكَ
u'نَوَى نَفْسٌ':Predicate, #2: 2	نَوَى نِصْفَ
u'نَوَى نَفْعٌ':Subject, #2: 2	نَوَى نَفْسَ
u'نَوَى نَفَقَةٌ':Predicate, #1: 1	نَوَى نَفْعٌ
u'نَوَى نَفَلٌ':Predicate, #2: 2	نَوَى النَّفَقَةَ
u'نَوَى نكاح':Predicate, #11: 11	نَوَى النَّفَلَ
u'نَوَى نِكَاحٌ':Predicate, #1: 1	نَوَى النِّكَاحَ
u'نَوَى نهار':Predicate, #1: 1	نَوَى النِّكَاحَ
u'نَوَى نَهَارٌ':Predicate, #3: 3	نَوَى النَّهَارَ
u'نَوَى نَوْعٌ':Predicate, #3: 3	نَوَى النَّهَارَ
u'نَوَى هِبَةٌ':Predicate, #1: 1	نَوَى النَّوْعَ
u'نَوَى وَاجِبٌ':Predicate, #1: 1	نَوَى الْهِبَةَ
u'نَوَى واحد':Predicate, #1: 1	نَوَى الْوَاجِبَ
u'نَوَى وَاحِدٌ':Predicate, #4: 4	نَوَى الْوَاحِدَةَ
u'نَوَى واحد':Predicate, #4: 4	نَوَى الْوَاحِدَةَ
u'نَوَى وَاحِدٌ':Predicate, #64: 64	نَوَى وَاحِدَةً
u'نَوَى وَجْهٌ':Predicate, #64: 64	نَوَى وَاحِدَةً
u'نَوَى وَجْهٌ':Predicate, #1: 1	نَوَى الْوَجْهَ
u'نَوَى وَرَثَةٌ':Subject, #1: 1	نَوَى وَجْهَ
u'نَوَى وُصُولٌ':Predicate, #1: 1	نَوَى الْوَرَثَةُ
u'نَوَى وَصِيٌّ':Predicate, #1: 1	نَوَى الْوُصُولَ
u'نَوَى وَصِيَّةٌ':Predicate, #1: 1	نَوَى الْوَصِيَّةَ
u'نَوَى وُضُوءٌ':Predicate, #1: 1	نَوَى الْوَصِيَّةَ
u'نَوَى وَقْتٌ':Predicate, #5: 5	نَوَى الْوُضُوءَ
u'نَوَى وَقْتٌ':Predicate, #3: 3	نَوَى الْوَقْتَ
u'نَوَى وقع':Predicate, #3: 3	نَوَى وَقْتَ
u'نَوَى وُقُوعٌ':Predicate, #3: 3	نَوَى وَقَعَ
u'نَوَى وُقُوعٌ':Predicate, #5: 5	نَوَى الْوُقُوعَ
u'نَوَى يَمِينٌ':Predicate, #5: 5	نَوَى وُقُوعَ
u'نَوَى يَوْمٌ':Predicate, #23: 23	نَوَى الْيَمِينَ
u'نَوَى يَوْمٌ':Predicate, #2: 2	نَوَى يَوْمَ
u'نِيَابَةٌ إمَامٌ':Added, #6: 6	نَوَى الْيَوْمَ
u'نِيَابَةٌ بَعْضٌ':Added, #1: 1	نِيَابَةُ إمَامِ
u'نِيَابَةٌ شَرْعِيٌّ':Added, #1: 1	نِيَابَةُ بَعْضِ
u'نِيَابَةٌ غَائِبٌ':Added, #1: 1	نِيَابَةٍ شَرْعِيَّةٍ
u'نِيَابَةٌ غير':Added, #1: 1	نِيَابَةَ الْغَائِبِ
u'نِيَابَةٌ غَيْرٌ':Added, #1: 1	نِيَابَةَ الْغَيْرِ
u'نِيَابَةٌ وَارِثٌ':Added, #1: 1	نِيَابَةَ الْغَيْرِ
u'نِيَاطٌ حُكْمٌ':Added, #1: 1	نِيَابَةِ الْوَارِثِ
u'نِيَاطٌ قلب':Added, #1: 1	نِيَاطَ الْحُكْمِ
u'نِيَاطٌ قَلْبٌ':Added, #1: 1	نِيَاطُ الْقَلْبِ
u'نِيَاطٌ قَلْب':Added, #1: 1	نِيَاطُ الْقَلْبِ
u'نِيَاطٌ قلب':Added, #1: 1	نِيَاطُ الْقَلْبِ
u'نِيَاطٌ قَلْبٌ':Added, #1: 1	نِيَاطِ قَلْبِهِ
u'نِيَاطٌ قَلْب':Added, #1: 1	نِيَاطِ قَلْبِهِ
u'نِيَّةٌ إبَاحَةٌ':Added, #1: 1	نِيَاطِ قَلْبِهِ
u'نِيَّةٌ إبَاحَةٌ':Added, #1: 1	نِيَّةَ إبَاحَةِ
u'نِيَّةٌ إِبَانَةٌ':Added, #1: 1	نِيَّةِ الْإِبَاحَةِ
u'نِيَّةٌ إِبَانَةٌ':Added, #1: 1	نِيَّةُ الْإِبَانَةِ
u'نِيَّةٌ اِتِّبَاعٌ':Added, #1: 1	نِيَّةِ الْإِبَانَةِ
u'نِيَّةٌ إِتْيانٌ':Added, #2: 2	نِيَّةُ اتِّبَاعِهِ
u'نِيَّةٌ إجْلالٌ':Added, #1: 1	نِيَّةِ الْإِتْيَانِ
u'نِيَّةٌ أحَدٌ':Added, #1: 1	نِيَّةِ إجْلَالِ
u'نِيَّةٌ إِحْرَامٌ':Added, #2: 2	نِيَّةُ أَحَدِ
u'نِيَّةٌ إِحْرَامٌ':Added, #1: 1	نِيَّةِ إحْرَامٍ
u'نِيَّةٌ إِحْرَامٌ':Added, #1: 1	نِيَّةِ إحْرَامِهِ
u'نِيَّةٌ إِحْرَامٌ':Added, #2: 2	نِيَّةُ الْإِحْرَامِ
u'نِيَّةٌ إِحْرَامٌ':Added, #2: 2	نِيَّةِ الْإِحْرَامِ
u'نِيَّةٌ أخْذٌ':Added, #4: 4	نِيَّةَ الْإِحْرَامِ
u'نِيَّةٌ آخِرُ':Added, #1: 1	نِيَّةِ الْأَخْذِ
u'نِيَّةٌ إِخْرَاجٌ':Added, #2: 2	نِيَّةُ آخِرِ
u'نِيَّةٌ إِخْرَاجٌ':Added, #1: 1	نِيَّةَ إخْرَاجِهِ
u'نِيَّةٌ آخِرَةٌ':Added, #1: 1	نِيَّةِ إخْرَاجِهِ
u'نِيَّةٌ أَدَاءٌ':Added, #1: 1	نِيَّةِ الْآخِرَةِ
u'نِيَّةٌ أَدَاءٌ':Added, #1: 1	نِيَّةَ أَدَاءِ
u'نِيَّةٌ أَدَاءٌ':Added, #1: 1	نِيَّةِ أَدَاءِ
u'نِيَّةٌ أَدَاءٌ':Added, #1: 1	نِيَّة الْأَدَاءِ
u'نِيَّةٌ أَدَاءٌ':Added, #1: 1	نِيَّةَ الْأَدَاءِ
u'نِيَّةٌ أَدَاءٌ':Added, #2: 2	نِيَّةُ الْأَدَاءِ
u'نِيَّةٌ إِذْنٌ':Added, #2: 2	نِيَّةِ الْأَدَاءِ
u'نِيَّةٌ أَرْبَعُ':Added, #2: 2	نِيَّةِ الْإِذْنِ
u'نِيَّةٌ أَرْبَعُ':Added, #1: 1	نِيَّةُ الْأَرْبَعِ
u'نِيَّةٌ اِسْتِبَاحَةٌ':Added, #3: 3	نِيَّةَ الْأَرْبَعِ
u'نِيَّةٌ اِسْتِبَاحَةٌ':Added, #1: 1	نِيَّةَ اسْتِبَاحَةِ
u'نِيَّةٌ اِسْتِقْبالٌ':Added, #1: 1	نِيَّةِ اسْتِبَاحَةِ
u'نِيَّةٌ اِسْتِقْبالٌ':Added, #1: 1	نِيَّةَ اسْتِقْبَالِ
u'نِيَّةٌ إشارَة':Added, #1: 1	نِيَّةُ اسْتِقْبَالِ
u'نِيَّةٌ أصل':Added, #1: 1	نِيَّةِ الْإِشَارَةِ
u'نِيَّةٌ أًصْلٌ':Added, #1: 1	نِيَّةَ أَصْلِ
u'نِيَّةٌ أصل':Added, #1: 1	نِيَّةَ أَصْلِ
u'نِيَّةٌ أصل':Added, #1: 1	نِيَّةَ الْأَصْلِ
u'نِيَّةٌ أًصْلٌ':Added, #1: 1	نِيَّةُ الْأَصْلِ
u'نِيَّةٌ أًصْلٌ':Added, #1: 1	نِيَّةَ الْأَصْلِ
u'نِيَّةٌ أصل':Added, #1: 1	نِيَّةُ الْأَصْلِ
u'نِيَّةٌ أًصْلٌ':Added, #2: 2	نِيَّةِ أَصْلِ
u'نِيَّةٌ أصل':Added, #2: 2	نِيَّةِ أَصْلِ
u'نِيَّةٌ أًصْلٌ':Added, #7: 7	نِيَّةُ أَصْلِ
u'نِيَّةٌ إِصْلاحٌ':Added, #7: 7	نِيَّةُ أَصْلِ
u'نِيَّةٌ إضافَةٌ':Added, #4: 4	نِيَّةَ إصْلَاحٍ
u'نِيَّةٌ إضافَةٌ':Added, #1: 1	نِيَّةِ إضَافَتِهِ
u'نِيَّةٌ إِعادَةٌ':Added, #1: 1	نِيَّةَ الْإِضَافَةِ
u'نِيَّةٌ إعْرَاضٌ':Added, #1: 1	نِيَّةِ إعَادَتِهِ
u'نِيَّةٌ اِغْتِرَافٌ':Added, #1: 1	نِيَّةُ الْإِعْرَاضِ
u'نِيَّةٌ إِفْطارٌ':Added, #2: 2	نِيَّةِ اغْتِرَافٍ
u'نِيَّةٌ إقامَةٌ':Added, #1: 1	نِيَّةَ الْإِفْطَارِ
u'نِيَّةٌ إقامَةٌ':Added, #16: 16	نِيَّةَ الْإِقَامَةِ
u'نِيَّةٌ إقامَةٌ':Added, #1: 1	نِيَّةَ إقَامَةِ
u'نِيَّةٌ إقامَةٌ':Added, #20: 20	نِيَّةِ الْإِقَامَةِ
u'نِيَّةٌ إقامَةٌ':Added, #24: 24	نِيَّةُ الْإِقَامَةِ
u'نِيَّةٌ إقامَةٌ':Added, #2: 2	نِيَّةِ إقَامَتِهِ
u'نِيَّةٌ إقامَةٌ':Added, #3: 3	نِيَّةِ إقَامَةٍ
u'نِيَّةٌ أكْبَرُ':Added, #4: 4	نِيَّةُ إقَامَةِ
u'نِيَّةٌ أَكْثَرُ':Added, #1: 1	نِيَّةِ الْأَكْبَرِ
u'نِيَّةٌ أَكْثَرُ':Added, #1: 1	نِيَّةَ أَكْثَرِهِ
u'نِيَّةٌ الْمَرْءُ':Added, #1: 1	نِيَّةُ الْأَكْثَرِ
u'نِيَّةٌ الْمَرْأَةُ':Added, #1: 1	نِيَّةُ الْمَرْءِ
u'نِيَّةٌ إمَامٌ':Added, #2: 2	نِيَّةُ الْمَرْأَةِ
u'نِيَّةٌ إمَامٌ':Added, #11: 11	نِيَّةِ الْإِمَامِ
u'نِيَّةٌ إمَامٌ':Added, #12: 12	نِيَّةُ الْإِمَامِ
u'نِيَّةٌ إمَامٌ':Added, #1: 1	نِيَّةِ الإِمَامِ
u'نِيَّةٌ إمَامٌ':Added, #2: 2	نِيَّةَ الْإِمَامِ
u'نِيَّةٌ إمَامٌ':Added, #2: 2	نِيَّةَ إمَامِهِ
u'نِيَّةٌ إمَامَةٌ':Added, #3: 3	نِيَّةِ إمَامِهِ
u'نِيَّةٌ إمَامَةٌ':Added, #1: 1	نِيَّةُ إمَامَةِ
u'نِيَّةٌ إمَامَةٌ':Added, #1: 1	نِيَّةِ إمَامَتِهِ
u'نِيَّةٌ إمَامَةٌ':Added, #3: 3	نِيَّةَ الْإِمَامَةِ
u'نِيَّةٌ إمَامَةٌ':Added, #7: 7	نِيَّةِ الْإِمَامَةِ
u'نِيَّةٌ اِمْتِثَالٌ':Added, #9: 9	نِيَّةُ الْإِمَامَةِ
u'نِيَّةٌ آمِرٌ':Added, #1: 1	نِيَّةِ امْتِثَالِ
u'نِيَّةٌ أَمْرٌ':Added, #1: 1	نِيَّةِ الْآمِرِ
u'نِيَّةٌ آمِرٌ':Added, #1: 1	نِيَّةُ الْأَمْرَيْنِ
u'نِيَّةٌ إِمْساكٌ':Added, #2: 2	نِيَّةُ الْآمِرِ
u'نِيَّةٌ إِنْفاقٌ':Added, #1: 1	نِيَّةِ الْإِمْسَاكِ
u'نِيَّةٌ أَوَّلُ':Added, #1: 1	نِيَّةِ الْإِنْفَاقِ
u'نِيَّةٌ أَوَّلُ':Added, #1: 1	نِيَّةِ الْأَوَّلِ
u'نِيَّةٌ إِيجَابٌ':Added, #2: 2	نِيَّةُ الْأَوَّلِ
u'نِيَّةٌ إيقَاعٌ':Added, #2: 2	نِيَّةِ الْإِيجَابِ
u'نِيَّةٌ إيقَاعٌ':Added, #1: 1	نِيَّةُ إيقَاعِ
u'نِيَّةٌ إيقَاعٌ':Added, #1: 1	نِيَّةِ إيقَاعِ
u'نِيَّةٌ إيقَاعٌ':Added, #1: 1	نِيَّةِ إيقَاعِهِ
u'نِيَّةٌ إيقَاعٌ':Added, #2: 2	نِيَّةُ الْإِيقَاعِ
u'نِيَّةٌ إيقَاعٌ':Added, #2: 2	نِيَّةِ الْإِيقَاعِ
u'نِيَّةٌ بَاطِلٌ':Added, #2: 2	نِيَّةَ إيقَاعِ
u'نِيَّةٌ تَأْخِيرٌ':Added, #1: 1	نِيَّةٍ بَاطِلَةٍ
u'نِيَّةٌ تَأْخِيرٌ':Added, #1: 1	نِيَّةِ التَّأْخِيرِ
u'نِيَّةٌ تَأْكِيدٌ':Added, #2: 2	نِيَّةُ التَّأْخِيرِ
u'نِيَّةٌ تَبَرُّدٌ':Added, #1: 1	نِيَّةُ التَّأْكِيدِ
u'نِيَّةٌ تَبَرُّدٌ':Added, #1: 1	نِيَّةَ التَّبَرُّدِ
u'نِيَّةٌ تَتَابُعٌ':Added, #4: 4	نِيَّةِ التَّبَرُّدِ
u'نِيَّةٌ تَتَابُعٌ':Added, #1: 1	نِيَّةُ تَتَابُعِهِ
u'نِيَّةٌ تَتَابُعٌ':Added, #2: 2	نِيَّةَ التَّتَابُعِ
u'نِيَّةٌ تَتَابُعٌ':Added, #2: 2	نِيَّةُ التَّتَابُعِ
u'نِيَّةٌ تِجَارَةٌ':Added, #2: 2	نِيَّةِ التَّتَابُعِ
u'نِيَّةٌ تِجَارَةٌ':Added, #10: 10	نِيَّةَ التِّجَارَةِ
u'نِيَّةٌ تِجَارَةٌ':Added, #13: 13	نِيَّةِ التِّجَارَةِ
u'نِيَّةٌ تَحَلُّلٌ':Added, #21: 21	نِيَّةُ التِّجَارَةِ
u'نِيَّةٌ تَحَلُّلٌ':Added, #2: 2	نِيَّةِ التَّحَلُّلِ
u'نِيَّةٌ تَحَوُّلٌ':Added, #5: 5	نِيَّةُ التَّحَلُّلِ
u'نِيَّةٌ تَحَوُّلٌ':Added, #1: 1	نِيَّةُ التَّحَوُّلِ
u'نِيَّةٌ تَخْصِيصٌ':Added, #2: 2	نِيَّةِ التَّحَوُّلِ
u'نِيَّةٌ تَخْصِيصٌ':Added, #1: 1	نِيَّةَ تَخْصِيصِ
u'نِيَّةٌ تَخْصِيصٌ':Added, #2: 2	نِيَّةَ التَّخْصِيصِ
u'نِيَّةٌ تَخْصِيصٌ':Added, #2: 2	نِيَّةِ التَّخْصِيصِ
u'نِيَّةٌ تَخْصِيصٌ':Added, #5: 5	نِيَّةُ تَخْصِيصِ
u'نِيَّةٌ تَرَاوِيحُ':Added, #7: 7	نِيَّةُ التَّخْصِيصِ
u'نِيَّةٌ تَرْكٌ':Added, #1: 1	نِيَّةُ التَّرَاوِيحِ
u'نِيَّةٌ تَرْكٌ':Added, #1: 1	نِيَّةِ التَّرْكِ
u'نِيَّةٌ تَشَهُّدٌ':Added, #1: 1	نِيَّةِ تَرْكِ
u'نِيَّةٌ تَضْحِيَةٌ':Added, #1: 1	نِيَّةِ التَّشَهُّدِ
u'نِيَّةٌ تَطْهِيرٌ':Added, #1: 1	نِيَّةَ التَّضْحِيَةِ
u'نِيَّةٌ تَطْهِيرٌ':Added, #1: 1	نِيَّةَ التَّطْهِيرِ
u'نِيَّةٌ تَطْهِيرٌ':Added, #2: 2	نِيَّةُ التَّطْهِيرِ
u'نِيَّةٌ تَطَوُّعٌ':Added, #3: 3	نِيَّةِ التَّطْهِيرِ
u'نِيَّةٌ تَطَوُّعٌ':Added, #3: 3	نِيَّةُ التَّطَوُّعِ
u'نِيَّةٌ تَعْرِيفٌ':Added, #4: 4	نِيَّةِ التَّطَوُّعِ
u'نِيَّةٌ تَعْلِيقٌ':Added, #1: 1	نِيَّةِ التَّعْرِيفِ
u'نِيَّةٌ تَعْمِيمٌ':Added, #3: 3	نِيَّةُ التَّعْلِيقِ
u'نِيَّةٌ تَعْمِيمٌ':Added, #2: 2	نِيَّةَ التَّعْمِيمِ
u'نِيَّةٌ تَعَيُّنٌ':Added, #2: 2	نِيَّةُ التَّعْمِيمِ
u'نِيَّةٌ تَعْيِينٌ':Added, #1: 1	نِيَّةَ التَّعَيُّنِ
u'نِيَّةٌ تَعْيِينٌ':Added, #13: 13	نِيَّةُ التَّعْيِينِ
u'نِيَّةٌ تَعْيِينٌ':Added, #16: 16	نِيَّةَ التَّعْيِينِ
u'نِيَّةٌ تَعْيِينٌ':Added, #1: 1	نِيَّةَ تَعْيِينِ
u'نِيَّةٌ تَعْيِينٌ':Added, #1: 1	نِيَّةُ تَعْيِينِ
u'نِيَّةٌ تَفْرِقَة':Added, #5: 5	نِيَّةِ التَّعْيِينِ
u'نِيَّةٌ تَفْوِيضٌ':Added, #1: 1	نِيَّةُ التَّفْرِقَةِ
u'نِيَّةٌ تَفْوِيضٌ':Added, #1: 1	نِيَّةِ التَّفْوِيضِ
u'نِيَّةٌ تَقْديمٌ':Added, #1: 1	نِيَّةَ تَفْوِيضِهِ
u'نِيَّةٌ تَقَرُّبٌ':Added, #1: 1	نِيَّةُ تَقْدِيمِ
u'نِيَّةٌ تَقَرُّبٌ':Added, #2: 2	نِيَّةَ التَّقَرُّبِ
u'نِيَّةٌ تَقَرُّبٌ':Added, #3: 3	نِيَّةِ التَّقَرُّبِ
u'نِيَّةٌ تَكْبيرٌ':Added, #6: 6	نِيَّةُ التَّقَرُّبِ
u'نِيَّةٌ تَكْرارٌ':Added, #1: 1	نِيَّةُ التَّكْبِيرِ
u'نِيَّةٌ تَكْفيرٌ':Added, #1: 1	نِيَّةِ التَّكْرَارِ
u'نِيَّةٌ تَمَتُّعٌ':Added, #1: 1	نِيَّةِ التَّكْفِيرِ
u'نِيَّةٌ تَمَتُّعٌ':Added, #1: 1	نِيَّةَ التَّمَتُّعِ
u'نِيَّةٌ تَمَتُّعٌ':Added, #2: 2	نِيَّةِ التَّمَتُّعِ
u'نِيَّةٌ تَمَلُّك':Added, #3: 3	نِيَّةُ التَّمَتُّعِ
u'نِيَّةٌ تَمَلُّكٌ':Added, #1: 1	نِيَّةِ التَّمَلُّكِ
u'نِيَّةٌ تَمَلُّكٌ':Added, #1: 1	نِيَّةِ تَمَلُّكِهِ
u'نِيَّةٌ تَمْلِيك':Added, #2: 2	نِيَّةِ تَمَلُّكِ
u'نِيَّةٌ تَمْييزٌ':Added, #2: 2	نِيَّةِ التَّمْلِيكِ
u'نِيَّةٌ تَمْييزٌ':Added, #1: 1	نِيَّةَ التَّمْيِيزِ
u'نِيَّةٌ تَمْييزٌ':Added, #3: 3	نِيَّةُ التَّمْيِيزِ
u'نِيَّةٌ تَنْظِيفٌ':Added, #8: 8	نِيَّةِ التَّمْيِيزِ
u'نِيَّةٌ تَنَفُّلٌ':Added, #1: 1	نِيَّةُ التَّنْظِيفِ
u'نِيَّةٌ تَوْزِيعٌ':Added, #1: 1	نِيَّةُ التَّنَفُّلِ
u'نِيَّةٌ تَوْكِيدٌ':Added, #1: 1	نِيَّةِ التَّوْزِيعِ
u'نِيَّةٌ تَيَمُّمٌ':Added, #1: 1	نِيَّةُ التَّوْكِيدِ
u'نِيَّةٌ تَيَمُّمٌ':Added, #3: 3	نِيَّةُ التَّيَمُّمِ
u'نِيَّةٌ تَيَمُّمٌ':Added, #4: 4	نِيَّةَ التَّيَمُّمِ
u'نِيَّةٌ ثَلاثُ':Added, #6: 6	نِيَّةِ التَّيَمُّمِ
u'نِيَّةٌ ثَلاثُ':Added, #12: 12	نِيَّةَ الثَّلَاثِ
u'نِيَّةٌ ثَلاثُ':Added, #14: 14	نِيَّةِ الثَّلَاثِ
u'نِيَّةٌ ثَلاثَةٌ':Added, #55: 55	نِيَّةُ الثَّلَاثِ
u'نِيَّةٌ جَازِمٌ':Added, #1: 1	نِيَّةُ الثَّلَاثَةِ
u'نِيَّةٌ جَمَاعَةٌ':Added, #1: 1	نِيَّةٍ جَازِمَةٍ
u'نِيَّةٌ جَمَاعَةٌ':Added, #1: 1	نِيَّةَ الْجَمَاعَةِ
u'نِيَّةٌ جمع':Added, #1: 1	نِيَّةُ الْجَمَاعَةِ
u'نِيَّةٌ جَمْعٌ':Added, #10: 10	نِيَّةُ الْجَمْعِ
u'نِيَّةٌ جمع':Added, #10: 10	نِيَّةُ الْجَمْعِ
u'نِيَّةٌ جَمْعٌ':Added, #1: 1	نِيَّةَ الْجَمْعِ
u'نِيَّةٌ جمع':Added, #1: 1	نِيَّةَ الْجَمْعِ
u'نِيَّةٌ جَمْعٌ':Added, #1: 1	نِيَّةُ جَمْعِ
u'نِيَّةٌ جمع':Added, #1: 1	نِيَّةُ جَمْعِ
u'نِيَّةٌ جَمْعٌ':Added, #7: 7	نِيَّةِ الْجَمْعِ
u'نِيَّةٌ جمعة':Added, #7: 7	نِيَّةِ الْجَمْعِ
u'نِيَّةٌ جُمُعَةٌ':Added, #2: 2	نِيَّةُ الْجُمُعَةِ
u'نِيَّةٌ جمعة':Added, #2: 2	نِيَّةُ الْجُمُعَةِ
u'نِيَّةٌ جُمُعَةٌ':Added, #3: 3	نِيَّةَ الْجُمُعَةِ
u'نِيَّةٌ جمعة':Added, #3: 3	نِيَّةَ الْجُمُعَةِ
u'نِيَّةٌ جُمُعَةٌ':Added, #4: 4	نِيَّةِ الْجُمُعَةِ
u'نِيَّةٌ جُمْلَةٌ':Added, #4: 4	نِيَّةِ الْجُمُعَةِ
u'نِيَّةٌ جَنَابَةٌ':Added, #1: 1	نِيَّةُ الْجُمْلَةِ
u'نِيَّةٌ جَنَابَةٌ':Added, #2: 2	نِيَّةُ الْجَنَابَةِ
u'نِيَّةٌ جِهَةٌ':Added, #2: 2	نِيَّةِ الْجَنَابَةِ
u'نِيَّةٌ جِهَةٌ':Added, #1: 1	نِيَّةُ الْجِهَةِ
u'نِيَّةٌ حاكِمٌ':Added, #2: 2	نِيَّةِ الْجِهَةِ
u'نِيَّةٌ حاكِمٌ':Added, #1: 1	نِيَّةَ الْحَاكِمِ
u'نِيَّةٌ حامِلٌ':Added, #2: 2	نِيَّةِ الْحَاكِمِ
u'نِيَّةٌ حامِلٌ':Added, #2: 2	نِيَّةِ الْحَامِلِ
u'نِيَّةٌ حَجٌّ':Added, #3: 3	نِيَّةُ الْحَامِلِ
u'نِيَّةٌ حَجٌّ':Added, #1: 1	نِيَّةُ حَجٍّ
u'نِيَّةٌ حَجٌّ':Added, #5: 5	نِيَّةُ الْحَجِّ
u'نِيَّةٌ حَجٌّ':Added, #6: 6	نِيَّةَ الْحَجِّ
u'نِيَّةٌ حَدَثٌ':Added, #6: 6	نِيَّةِ الْحَجِّ
u'نِيَّةٌ حَدَثٌ':Added, #1: 1	نِيَّةُ الْحَدَثِ
u'نِيَّةٌ حِفْظٌ':Added, #3: 3	نِيَّةِ الْحَدَثِ
u'نِيَّةٌ حَفَظَةٌ':Added, #1: 1	نِيَّةِ الْحِفْظِ
u'نِيَّةٌ حَفَظَةٌ':Added, #1: 1	نِيَّةِ الْحَفَظَةِ
u'نِيَّةٌ حَقِيقٌ':Added, #2: 2	نِيَّةَ الْحَفَظَةِ
u'نِيَّةٌ حَقِيقٌ':Added, #1: 1	نِيَّةِ الْحَقِيقَةِ
u'نِيَّةٌ حَقِيقَةٌ':Added, #1: 1	نِيَّةُ حَقِيقَةِ
u'نِيَّةٌ حَقِيقَةٌ':Added, #1: 1	نِيَّةِ الْحَقِيقَةِ
u'نِيَّةٌ حَيْضٌ':Added, #1: 1	نِيَّةُ حَقِيقَةِ
u'نِيَّةٌ حَيْضٌ':Added, #1: 1	نِيَّةِ الْحَيْضِ
u'نِيَّةٌ خَاصَّةٌ':Added, #2: 2	نِيَّةُ الْحَيْضِ
u'نِيَّةٌ خَالِصٌ':Added, #4: 4	نِيَّةٍ خَاصَّةٍ
u'نِيَّةٌ خدمة':Added, #2: 2	نِيَّةٍ خَالِصَةٍ
u'نِيَّةٌ خِدْمَةٌ':Added, #1: 1	نِيَّةِ الْخِدْمَةِ
u'نِيَّةٌ خُرُوجٌ':Added, #1: 1	نِيَّةِ الْخِدْمَةِ
u'نِيَّةٌ خُرُوجٌ':Added, #2: 2	نِيَّةَ الْخُرُوجِ
u'نِيَّةٌ خُرُوجٌ':Added, #2: 2	نِيَّةُ الْخُرُوجِ
u'نِيَّةٌ خُرُوجٌ':Added, #2: 2	نِيَّةِ خُرُوجِهِ
u'نِيَّةٌ خطبة':Added, #9: 9	نِيَّةِ الْخُرُوجِ
u'نِيَّةٌ خُطْبَةٌ':Added, #1: 1	نِيَّةُ الْخُطْبَةِ
u'نِيَّةٌ خِلاَفٌ':Added, #1: 1	نِيَّةُ الْخُطْبَةِ
u'نِيَّةٌ خَمْسٌ':Added, #1: 1	نِيَّةِ خِلَافِ
u'نِيَّةٌ خِيَانَةٌ':Added, #1: 1	نِيَّةُ الْخَمْسِ
u'نِيَّةٌ خَيْرٌ':Added, #1: 1	نِيَّةِ الْخِيَانَةِ
u'نِيَّةٌ خَيْرٌ':Added, #1: 1	نِيَّةُ الْخَيْرِ
u'نِيَّةٌ دَافِعٌ':Added, #1: 1	نِيَّةِ الْخَيْرِ
u'نِيَّةٌ دُخُولٌ':Added, #1: 1	نِيَّةُ الدَّافِعِ
u'نِيَّةٌ دُخُولٌ':Added, #1: 1	نِيَّة الدُّخُولِ
u'نِيَّةٌ دُخُولٌ':Added, #1: 1	نِيَّةُ الدُّخُولِ
u'نِيَّةٌ دُعَاءٌ':Added, #2: 2	نِيَّةَ دُخُولِهِ
u'نِيَّةٌ دفع':Added, #2: 2	نِيَّةِ الدُّعَاءِ
u'نِيَّةٌ دَفْعٌ':Added, #1: 1	نِيَّةُ الدَّفْعِ
u'نِيَّةٌ دفع':Added, #1: 1	نِيَّةُ الدَّفْعِ
u'نِيَّةٌ دَفْعٌ':Added, #2: 2	نِيَّةِ الدَّفْعِ
u'نِيَّةٌ ذَكاةٌ':Added, #2: 2	نِيَّةِ الدَّفْعِ
u'نِيَّةٌ ذَكاةٌ':Added, #1: 1	نِيَّةَ الذَّكَاةِ
u'نِيَّةٌ ذَكاةٌ':Added, #1: 1	نِيَّةُ الذَّكَاةِ
u'نِيَّةٌ ذَكاةٌ':Added, #1: 1	نِيَّةُ ذَكَاتِهِ
u'نِيَّةٌ ذَهَابٌ':Added, #3: 3	نِيَّةِ الذَّكَاةِ
u'نِيَّةٌ رَبُّ':Added, #1: 1	نِيَّةِ الذَّهَابِ
u'نِيَّةٌ رَبُّ':Added, #1: 1	نِيَّةِ رَبِّ
u'نِيَّةٌ رجعة':Added, #2: 2	نِيَّةُ رَبِّ
u'نِيَّةٌ رَجْعَةٌ':Added, #1: 1	نِيَّةِ الرَّجْعَةِ
u'نِيَّةٌ رجعة':Added, #1: 1	نِيَّةِ الرَّجْعَةِ
u'نِيَّةٌ رَجْعَةٌ':Added, #1: 1	نِيَّةِ رَجْعَةٍ
u'نِيَّةٌ رَجُلٌ':Added, #1: 1	نِيَّةِ رَجْعَةٍ
u'نِيَّةٌ رُجُوعٌ':Added, #2: 2	نِيَّةِ الرَّجُلِ
u'نِيَّةٌ رُجُوعٌ':Added, #10: 10	نِيَّةِ الرُّجُوعِ
u'نِيَّةٌ رَدٌّ':Added, #1: 1	نِيَّةُ الرُّجُوعِ
u'نِيَّةٌ رَفْضٌ':Added, #2: 2	نِيَّةُ الرَّدِّ
u'نِيَّةٌ رَفْضٌ':Added, #1: 1	نِيَّةَ الرَّفْضِ
u'نِيَّةٌ رَفْعٌ':Added, #1: 1	نِيَّةُ الرَّفْضِ
u'نِيَّةٌ رَفْعٌ':Added, #16: 16	نِيَّةُ رَفْعِ
u'نِيَّةٌ رَفْعٌ':Added, #1: 1	نِيَّةُ رَفْعِهِ
u'نِيَّةٌ رَفْعٌ':Added, #3: 3	نِيَّةُ الرَّفْعِ
u'نِيَّةٌ رَفْعٌ':Added, #3: 3	نِيَّةَ رَفْعِ
u'نِيَّةٌ زائِدٌ':Added, #4: 4	نِيَّةِ رَفْعِ
u'نِيَّةٌ زَكاةٌ':Added, #1: 1	نِيَّةُ الزَّائِدِ
u'نِيَّةٌ زَكاةٌ':Added, #1: 1	نِيَّةُ زَكَاةِ
u'نِيَّةٌ زَكاةٌ':Added, #1: 1	نِيَّةِ زَكَاةٍ
u'نِيَّةٌ زَكاةٌ':Added, #1: 1	نِيَّةِ زَكَاةِ
u'نِيَّةٌ زَوْجٌ':Added, #3: 3	نِيَّةِ الزَّكَاةِ
u'نِيَّةٌ زَوْجٌ':Added, #4: 4	نِيَّةُ الزَّوْجِ
u'نِيَّةٌ زِيادَةٌ':Added, #7: 7	نِيَّةِ الزَّوْجِ
u'نِيَّةٌ زَيْدٌ':Added, #2: 2	نِيَّةَ الزِّيَادَةِ
u'نِيَّةٌ سجدة':Added, #1: 1	نِيَّةُ زَيْدٍ
u'نِيَّةٌ سَجْدَةٌ':Added, #1: 1	نِيَّةِ السَّجْدَةِ
u'نِيَّةٌ سَفَرٌ':Added, #1: 1	نِيَّةِ السَّجْدَةِ
u'نِيَّةٌ سَفَرٌ':Added, #1: 1	نِيَّةُ سَفَرٍ
u'نِيَّةٌ سَفَرٌ':Added, #3: 3	نِيَّةَ السَّفَرِ
u'نِيَّةٌ سَفِيهٌ':Added, #6: 6	نِيَّةِ السَّفَرِ
u'نِيَّةٌ سُقُوطٌ':Added, #1: 1	نِيَّةُ السَّفِيهِ
u'نِيَّةٌ سُقُوطٌ':Added, #1: 1	نِيَّةِ سُقُوطِ
u'نِيَّةٌ سلام':Added, #1: 1	نِيَّةُ سُقُوطِهِ
u'نِيَّةٌ سَلاَمٌ':Added, #1: 1	نِيَّةَ السَّلَامِ
u'نِيَّةٌ سُنَّةٌ':Added, #1: 1	نِيَّةَ السَّلَامِ
u'نِيَّةٌ سُنَّةٌ':Added, #1: 1	نِيَّةُ السُّنَّةِ
u'نِيَّةٌ سُنَّةٌ':Added, #1: 1	نِيَّةِ سُنَّةِ
u'نِيَّةٌ سَيِّدٌ':Added, #2: 2	نِيَّةُ سُنَّةِ
u'نِيَّةٌ شَرْطٌ':Added, #1: 1	نِيَّةِ السَّيِّدِ
u'نِيَّةٌ شَرْعِيٌّ':Added, #1: 1	نِيَّةِ الشَّرْطِ
u'نِيَّةٌ شركة':Added, #1: 1	نِيَّةٍ شَرْعِيَّةٍ
u'نِيَّةٌ شَرِكَةٌ':Added, #2: 2	نِيَّةِ الشَّرِكَةِ
u'نِيَّةٌ شَيْءٌ':Added, #2: 2	نِيَّةِ الشَّرِكَةِ
u'نِيَّةٌ صَاحِبٌ':Added, #3: 3	نِيَّةُ شَيْءٍ
u'نِيَّةٌ صَاحِبٌ':Added, #1: 1	نِيَّةُ صَاحِبِ
u'نِيَّةٌ صُبْحٌ':Added, #1: 1	نِيَّةِ صَاحِبِهِ
u'نِيَّةٌ صدقة':Added, #1: 1	نِيَّةِ الصُّبْحِ
u'نِيَّةٌ صَدَقَةٌ':Added, #1: 1	نِيَّةِ الصَّدَقَةِ
u'نِيَّةٌ صدقة':Added, #1: 1	نِيَّةِ الصَّدَقَةِ
u'نِيَّةٌ صَدَقَةٌ':Added, #2: 2	نِيَّةُ الصَّدَقَةِ
u'نِيَّةٌ صَرْفٌ':Added, #2: 2	نِيَّةُ الصَّدَقَةِ
u'نِيَّةٌ صَرْف':Added, #1: 1	نِيَّةُ الصَّرْفِ
u'نِيَّةٌ صِفَةٌ':Added, #1: 1	نِيَّةُ الصَّرْفِ
u'نِيَّةٌ صَلاَةٌ':Added, #2: 2	نِيَّةِ الصِّفَةِ
u'نِيَّةٌ صَلاَةٌ':Added, #12: 12	نِيَّةُ الصَّلَاةِ
u'نِيَّةٌ صَلاَةٌ':Added, #1: 1	نِيَّةَ صَلَاةٍ
u'نِيَّةٌ صَلاَةٌ':Added, #1: 1	نِيَّةُ صَلَاتِهِ
u'نِيَّةٌ صَلاَةٌ':Added, #1: 1	نِيَّةِ صَلَاتِهِ
u'نِيَّةٌ صَلاَةٌ':Added, #25: 25	نِيَّةِ الصَّلَاةِ
u'نِيَّةٌ صَلاَةٌ':Added, #2: 2	نِيَّةِ صَلَاةٍ
u'نِيَّةٌ صَوْمٌ':Added, #8: 8	نِيَّةَ الصَّلَاةِ
u'نِيَّةٌ صَوْمٌ':Added, #1: 1	نِيَّةَ صَوْمِ
u'نِيَّةٌ صَوْمٌ':Added, #1: 1	نِيَّةِ صَوْمٍ
u'نِيَّةٌ صَوْمٌ':Added, #21: 21	نِيَّةِ الصَّوْمِ
u'نِيَّةٌ صَوْمٌ':Added, #2: 2	نِيَّةَ صَوْمِهِ
u'نِيَّةٌ صَوْمٌ':Added, #6: 6	نِيَّةُ الصَّوْمِ
u'نِيَّةٌ صَوْمٌ':Added, #6: 6	نِيَّةُ صَوْمِ
u'نِيَّةٌ صَوْمٌ':Added, #6: 6	نِيَّةِ صَوْمِ
u'نِيَّةٌ صِيَامٌ':Added, #7: 7	نِيَّةَ الصَّوْمِ
u'نِيَّةٌ صِيَامٌ':Added, #1: 1	نِيَّةُ الصِّيَامِ
u'نِيَّةٌ طَالِبٌ':Added, #1: 1	نِيَّةِ الصِّيَامِ
u'نِيَّةٌ طَرْحٌ':Added, #1: 1	نِيَّةِ الطَّالِبِ
u'نِيَّةٌ طَرْحٌ':Added, #1: 1	نِيَّةِ طَرْحِ
u'نِيَّةٌ طَلاَقٌ':Added, #3: 3	نِيَّةِ الطَّرْحِ
u'نِيَّةٌ طَلاَقٌ':Added, #10: 10	نِيَّةُ الطَّلَاقِ
u'نِيَّةٌ طَلاَقٌ':Added, #10: 10	نِيَّةِ الطَّلَاقِ
u'نِيَّةٌ طَلاَقٌ':Added, #1: 1	نِيَّةِ طَلَاقٍ
u'نِيَّةٌ طَهَارَةٌ':Added, #8: 8	نِيَّةَ الطَّلَاقِ
u'نِيَّةٌ طَهَارَةٌ':Added, #2: 2	نِيَّةُ الطَّهَارَةِ
u'نِيَّةٌ طَهَارَةٌ':Added, #2: 2	نِيَّةِ الطَّهَارَةِ
u'نِيَّةٌ طهر':Added, #3: 3	نِيَّةَ الطَّهَارَةِ
u'نِيَّةٌ طهر':Added, #1: 1	نِيَّةُ الطُّهْرِ
u'نِيَّةٌ طُهْرٌ':Added, #1: 1	نِيَّةِ الطُّهْرِ
u'نِيَّةٌ طُهْرٌ':Added, #1: 1	نِيَّةُ الطُّهْرِ
u'نِيَّةٌ طواف':Added, #1: 1	نِيَّةِ الطُّهْرِ
u'نِيَّةٌ طواف':Added, #1: 1	نِيَّةَ الطَّوَافِ
u'نِيَّةٌ طواف':Added, #1: 1	نِيَّةُ الطَّوَافِ
u'نِيَّةٌ طَوَافٌ':Added, #1: 1	نِيَّةِ الطَّوَافِ
u'نِيَّةٌ طَوَافٌ':Added, #1: 1	نِيَّةَ الطَّوَافِ
u'نِيَّةٌ طَوَافٌ':Added, #1: 1	نِيَّةُ الطَّوَافِ
u'نِيَّةٌ ظهار':Added, #1: 1	نِيَّةِ الطَّوَافِ
u'نِيَّةٌ ظهار':Added, #1: 1	نِيَّةِ الظِّهَارِ
u'نِيَّةٌ ظُهْرٌ':Added, #2: 2	نِيَّةُ الظِّهَارِ
u'نِيَّةٌ ظُهْرٌ':Added, #1: 1	نِيَّةَ الظُّهْرِ
u'نِيَّةٌ ظُهْرٌ':Added, #1: 1	نِيَّةِ الظُّهْرِ
u'نِيَّةٌ ظُهْرٌ':Added, #2: 2	نِيَّةَ ظُهْرِ
u'نِيَّةٌ ظُهْرٌ':Added, #2: 2	نِيَّةِ ظُهْرِ
u'نِيَّةٌ عارِيَّةٌ':Added, #3: 3	نِيَّةُ الظُّهْرِ
u'نِيَّةٌ عِبَادَةٌ':Added, #1: 1	نِيَّةِ الْعَارِيَّةِ
u'نِيَّةٌ عِبَادَةٌ':Added, #1: 1	نِيَّةُ الْعِبَادَةِ
u'نِيَّةٌ عَبْدٌ':Added, #4: 4	نِيَّةِ الْعِبَادَةِ
u'نِيَّةٌ عَبْدٌ':Added, #1: 1	نِيَّةَ الْعَبْدِ
u'نِيَّةٌ عتق':Added, #2: 2	نِيَّةُ الْعَبْدِ
u'نِيَّةٌ عِتْقٌ':Added, #1: 1	نِيَّةُ الْعِتْقِ
u'نِيَّةٌ عتق':Added, #1: 1	نِيَّةُ الْعِتْقِ
u'نِيَّةٌ عِتْقٌ':Added, #4: 4	نِيَّةِ الْعِتْقِ
u'نِيَّةٌ عَدَدٌ':Added, #4: 4	نِيَّةِ الْعِتْقِ
u'نِيَّةٌ عَدَدٌ':Added, #1: 1	نِيَّةَ عَدَدِ
u'نِيَّةٌ عَدَدٌ':Added, #1: 1	نِيَّةِ عَدَدِ
u'نِيَّةٌ عَدَدٌ':Added, #5: 5	نِيَّةَ الْعَدَدِ
u'نِيَّةٌ عَدَدٌ':Added, #6: 6	نِيَّةُ الْعَدَدِ
u'نِيَّةٌ عَصْرٌ':Added, #6: 6	نِيَّةِ الْعَدَدِ
u'نِيَّةٌ عطف':Added, #1: 1	نِيَّةُ عَصْرِ
u'نِيَّةٌ عَطْفٌ':Added, #1: 1	نِيَّةِ الْعَطْفِ
u'نِيَّةٌ عِفَّةٌ':Added, #1: 1	نِيَّةِ الْعَطْفِ
u'نِيَّةٌ عَقْدٌ':Added, #1: 1	نِيَّةِ عِفَّتِهِ
u'نِيَّةٌ عمرة':Added, #1: 1	نِيَّةُ عَقْدِهِ
u'نِيَّةٌ عُمْرَةٌ':Added, #4: 4	نِيَّةِ الْعُمْرَةِ
u'نِيَّةٌ عُمُومٌ':Added, #4: 4	نِيَّةِ الْعُمْرَةِ
u'نِيَّةٌ عُمُومٌ':Added, #1: 1	نِيَّةِ الْعُمُومِ
u'نِيَّةٌ عَوْدٌ':Added, #4: 4	نِيَّةُ الْعُمُومِ
u'نِيَّةٌ عَوْدٌ':Added, #2: 2	نِيَّةِ عَوْدِهِ
u'نِيَّةٌ عَوْدَةٌ':Added, #3: 3	نِيَّةِ الْعَوْدِ
u'نِيَّةٌ عَوْدَةٌ':Added, #1: 1	نِيَّةَ الْعَوْدَةِ
u'نِيَّةٌ عِوَضٌ':Added, #1: 1	نِيَّةُ عَوْدَتِهِ
u'نِيَّةٌ عِوَضٌ':Added, #1: 1	نِيَّةَ الْعِوَضِ
u'نِيَّةٌ عين':Added, #1: 1	نِيَّةِ عِوَضٍ
u'نِيَّةٌ عَيْنٌ':Added, #1: 1	نِيَّةِ الْعَيْنِ
u'نِيَّةٌ عَيْن':Added, #1: 1	نِيَّةِ الْعَيْنِ
u'نِيَّةٌ عين':Added, #1: 1	نِيَّةِ الْعَيْنِ
u'نِيَّةٌ عَيْنٌ':Added, #2: 2	نِيَّةِ عَيْنِ
u'نِيَّةٌ عَيْن':Added, #2: 2	نِيَّةِ عَيْنِ
u'نِيَّةٌ غَزْوٌ':Added, #2: 2	نِيَّةِ عَيْنِ
u'نِيَّةٌ غُسْلٌ':Added, #1: 1	نِيَّةِ الْغَزْوِ
u'نِيَّةٌ غُسْلٌ':Added, #1: 1	نِيَّةَ الْغُسْلِ
u'نِيَّةٌ غُسْلٌ':Added, #1: 1	نِيَّةُ غُسْلِ
u'نِيَّةٌ غُسْلٌ':Added, #2: 2	نِيَّةُ الْغُسْلِ
u'نِيَّةٌ غَسْلٌ':Added, #3: 3	نِيَّةِ غُسْلِ
u'نِيَّةٌ غُسْلٌ':Added, #3: 3	نِيَّةِ غَسْلِهِ
u'نِيَّةٌ غَلَّةٌ':Added, #7: 7	نِيَّةِ الْغُسْلِ
u'نِيَّةٌ غير':Added, #1: 1	نِيَّةِ غَلَّةٍ
u'نِيَّةٌ غَيْرٌ':Added, #1: 1	نِيَّةَ الْغَيْرِ
u'نِيَّةٌ غير':Added, #1: 1	نِيَّةَ الْغَيْرِ
u'نِيَّةٌ غَيْرٌ':Added, #1: 1	نِيَّةِ غَيْرِ
u'نِيَّةٌ غير':Added, #1: 1	نِيَّةِ غَيْرِ
u'نِيَّةٌ غَيْرٌ':Added, #2: 2	نِيَّةُ غَيْرِهِ
u'نِيَّةٌ فَرْضٌ':Added, #2: 2	نِيَّةُ غَيْرِهِ
u'نِيَّةٌ فَرْض':Added, #11: 11	نِيَّةُ الْفَرْضِ
u'نِيَّةٌ فَرْض':Added, #13: 13	نِيَّةِ الْفَرْضِيَّةِ
u'نِيَّةٌ فَرْضٌ':Added, #1: 1	نِيَّةَ الْفَرْضِيَّةِ
u'نِيَّةٌ فَرْضٌ':Added, #1: 1	نِيَّةَ الْفَرْضَيْنِ
u'نِيَّةٌ فَرْضٌ':Added, #1: 1	نِيَّةُ الْفَرْضَيْنِ
u'نِيَّةٌ فَرْضٌ':Added, #1: 1	نِيَّةَ فَرْضٍ
u'نِيَّةٌ فَرْضٌ':Added, #1: 1	نِيَّةَ فَرْضِ
u'نِيَّةٌ فَرْضٌ':Added, #1: 1	نِيَّةُ فَرْضٍ
u'نِيَّةٌ فَرْضٌ':Added, #1: 1	نِيَّةُ فَرْضِ
u'نِيَّةٌ فَرْضٌ':Added, #2: 2	نِيَّةَ الْفَرْضِ
u'نِيَّةٌ فَرْضٌ':Added, #3: 3	نِيَّةِ فَرْضِ
u'نِيَّةٌ فَرْض':Added, #8: 8	نِيَّةِ الْفَرْضِ
u'نِيَّةٌ فَرْضِيّ':Added, #9: 9	نِيَّةُ الْفَرْضِيَّةِ
u'نِيَّةٌ فَرْضِيّ':Added, #13: 13	نِيَّةِ الْفَرْضِيَّةِ
u'نِيَّةٌ فَرْضِيّ':Added, #1: 1	نِيَّةَ الْفَرْضِيَّةِ
u'نِيَّةٌ فَرْضِيَّة':Added, #9: 9	نِيَّةُ الْفَرْضِيَّةِ
u'نِيَّةٌ فَرْضِيَّة':Added, #13: 13	نِيَّةِ الْفَرْضِيَّةِ
u'نِيَّةٌ فَرْضِيَّة':Added, #1: 1	نِيَّةَ الْفَرْضِيَّةِ
u'نِيَّةٌ فُرْقَةٌ':Added, #9: 9	نِيَّةُ الْفَرْضِيَّةِ
u'نِيَّةٌ فَرِيضَةٌ':Added, #1: 1	نِيَّةِ الْفُرْقَةِ
u'نِيَّةٌ فَرِيضَةٌ':Added, #1: 1	نِيَّةُ الْفَرِيضَةِ
u'نِيَّةٌ فِطْرٌ':Added, #6: 6	نِيَّةِ الْفَرِيضَةِ
u'نِيَّةٌ فِعْلٌ':Added, #2: 2	نِيَّةَ الْفِطْرِ
u'نِيَّةٌ فِعْلٌ':Added, #1: 1	نِيَّةَ الْفِعْلِ
u'نِيَّةٌ فِعْلٌ':Added, #1: 1	نِيَّةَ فِعْلِ
u'نِيَّةٌ فِعْلٌ':Added, #1: 1	نِيَّةِ فِعْلِ
u'نِيَّةٌ فِعْلٌ':Added, #1: 1	نِيَّةَ فِعْلِهِ
u'نِيَّةٌ فِعْلٌ':Added, #3: 3	نِيَّةُ الْفِعْلِ
u'نِيَّةٌ فَوْر':Added, #5: 5	نِيَّةُ فِعْلِ
u'نِيَّةٌ فَوْرَة':Added, #1: 1	نِيَّةِ الْفَوْرِيَّةِ
u'نِيَّةٌ فَوْرِيّ':Added, #1: 1	نِيَّةِ الْفَوْرِيَّةِ
u'نِيَّةٌ قَابِلٌ':Added, #1: 1	نِيَّةِ الْفَوْرِيَّةِ
u'نِيَّةٌ قَائِلٌ':Added, #1: 1	نِيَّةُ الْقَابِلِ
u'نِيَّةٌ قَائِلٌ':Added, #1: 1	نِيَّةُ الْقَائِلِ
u'نِيَّةٌ قَبْضٌ':Added, #1: 1	نِيَّةِ قَائِلِهِ
u'نِيَّةٌ قتال':Added, #4: 4	نِيَّةُ قَبْضِ
u'نِيَّةٌ قِتَالٌ':Added, #1: 1	نِيَّةِ الْقِتَالِ
u'نِيَّةٌ قُدْوَةٌ':Added, #1: 1	نِيَّةِ الْقِتَالِ
u'نِيَّةٌ قِرَانٌ':Added, #1: 1	نِيَّة الْقُدْوَةِ
u'نِيَّةٌ قِرَانٌ':Added, #2: 2	نِيَّةُ الْقِرَانِ
u'نِيَّةٌ قُرْبَةٌ':Added, #3: 3	نِيَّةِ الْقِرَانِ
u'نِيَّةٌ قُرْبَةٌ':Added, #2: 2	نِيَّةُ قُرْبَةٍ
u'نِيَّةٌ قُرْبَةٌ':Added, #6: 6	نِيَّةُ الْقُرْبَةِ
u'نِيَّةٌ قَصْدٌ':Added, #9: 9	نِيَّةِ الْقُرْبَةِ
u'نِيَّةٌ قَصْدٌ':Added, #1: 1	نِيَّةِ الْقَصْدِ
u'نِيَّةٌ قَصْرٌ':Added, #1: 1	نِيَّةُ قَصْدِ
u'نِيَّةٌ قَصْرٌ':Added, #1: 1	نِيَّةَ الْقَصْرِ
u'نِيَّةٌ قَصْرٌ':Added, #2: 2	نِيَّةِ قَصْرٍ
u'نِيَّةٌ قَصْرٌ':Added, #2: 2	نِيَّةِ قَصْرِهِ
u'نِيَّةٌ قَصْرٌ':Added, #4: 4	نِيَّةُ الْقَصْرِ
u'نِيَّةٌ قَضَاءٌ':Added, #9: 9	نِيَّةِ الْقَصْرِ
u'نِيَّةٌ قَضَاءٌ':Added, #13: 13	نِيَّةُ الْقَضَاءِ
u'نِيَّةٌ قَضَاءٌ':Added, #18: 18	نِيَّةِ الْقَضَاءِ
u'نِيَّةٌ قَطْعٌ':Added, #2: 2	نِيَّةَ الْقَضَاءِ
u'نِيَّةٌ قَطْعٌ':Added, #2: 2	نِيَّةُ قَطْعِ
u'نِيَّةٌ قَطْعٌ':Added, #3: 3	نِيَّةِ الْقَطْعِ
u'نِيَّةٌ قلب':Added, #3: 3	نِيَّةَ قَطْعِ
u'نِيَّةٌ قَلْبٌ':Added, #1: 1	نِيَّةُ الْقَلْبِ
u'نِيَّةٌ قَلْب':Added, #1: 1	نِيَّةُ الْقَلْبِ
u'نِيَّةٌ قلب':Added, #1: 1	نِيَّةُ الْقَلْبِ
u'نِيَّةٌ قَلْبٌ':Added, #4: 4	نِيَّةِ الْقَلْبِ
u'نِيَّةٌ قَلْب':Added, #4: 4	نِيَّةِ الْقَلْبِ
u'نِيَّةٌ قول':Added, #4: 4	نِيَّةِ الْقَلْبِ
u'نِيَّةٌ قَوْلٌ':Added, #1: 1	نِيَّةُ قَوْلِهِ
u'نِيَّةٌ كَافِرٌ':Added, #1: 1	نِيَّةُ قَوْلِهِ
u'نِيَّةٌ كَافِرٌ':Added, #1: 1	نِيَّةَ الْكَافِرِ
u'نِيَّةٌ كَافِرٌ':Added, #1: 1	نِيَّةُ الْكَافِرَةِ
u'نِيَّةٌ كعبة':Added, #2: 2	نِيَّةِ الْكَافِرَةِ
u'نِيَّةٌ كَعْبَةٌ':Added, #1: 1	نِيَّةِ الْكَعْبَةِ
u'نِيَّةٌ كعبة':Added, #1: 1	نِيَّةِ الْكَعْبَةِ
u'نِيَّةٌ كَعْبَةٌ':Added, #2: 2	نِيَّةُ الْكَعْبَةِ
u'نِيَّةٌ كَفٌّ':Added, #2: 2	نِيَّةُ الْكَعْبَةِ
u'نِيَّةٌ كَفَّارٌ':Added, #1: 1	نِيَّةِ الْكَفِّ
u'نِيَّةٌ كَفَّارٌ':Added, #2: 2	نِيَّةِ الْكَفَّارَةِ
u'نِيَّةٌ كَفَّارَةٌ':Added, #9: 9	نِيَّةُ الْكَفَّارَةِ
u'نِيَّةٌ كَفَّارَةٌ':Added, #2: 2	نِيَّةِ الْكَفَّارَةِ
u'نِيَّةٌ كَلاَمٌ':Added, #9: 9	نِيَّةُ الْكَفَّارَةِ
u'نِيَّةٌ كِنَايَةٌ':Added, #1: 1	نِيَّةِ الْكَلَامِ
u'نِيَّةٌ كِنَايَةٌ':Added, #1: 1	نِيَّةِ الْكِنَايَةِ
u'نِيَّةٌ كَوْنٌ':Added, #1: 1	نِيَّةُ كِنَايَةٍ
u'نِيَّةٌ لُبْسٌ':Added, #1: 1	نِيَّةِ كَوْنِهِ
u'نِيَّةٌ مَالِكٌ':Added, #2: 2	نِيَّةِ لُبْسٍ
u'نِيَّةٌ مَالِكٌ':Added, #2: 2	نِيَّةُ الْمَالِكِ
u'نِيَّةٌ مَأْمُورٌ':Added, #3: 3	نِيَّةِ الْمَالِكِ
u'نِيَّةٌ مَأْمُورٌ':Added, #1: 1	نِيَّةَ الْمَأْمُورِ
u'نِيَّةٌ مُتَابَعٌ':Added, #1: 1	نِيَّةُ الْمَأْمُورِ
u'نِيَّةٌ مُتَابَعٌ':Added, #1: 1	نِيَّةَ الْمُتَابَعَةِ
u'نِيَّةٌ مُتَابَعٌ':Added, #1: 1	نِيَّةِ الْمُتَابَعَةِ
u'نِيَّةٌ مُتَابَعٌ':Added, #1: 1	نِيَّةِ مُتَابَعَةِ
u'نِيَّةٌ مُتَابَعَةٌ':Added, #2: 2	نِيَّةُ الْمُتَابَعَةِ
u'نِيَّةٌ مُتَابَعَةٌ':Added, #1: 1	نِيَّةَ الْمُتَابَعَةِ
u'نِيَّةٌ مُتَابَعَةٌ':Added, #1: 1	نِيَّةِ الْمُتَابَعَةِ
u'نِيَّةٌ مُتَابَعَةٌ':Added, #1: 1	نِيَّةِ مُتَابَعَةِ
u'نِيَّةٌ مُتَأَخِّرٌ':Added, #2: 2	نِيَّةُ الْمُتَابَعَةِ
u'نِيَّةٌ مُتَمَتِّعٌ':Added, #1: 1	نِيَّةَ الْمُتَأَخِّرَتَيْنِ
u'نِيَّةٌ مَحْدُودٌ':Added, #1: 1	نِيَّةُ الْمُتَمَتِّعِ
u'نِيَّةٌ مُحَرَّمٌ':Added, #1: 1	نِيَّةٍ مَحْدُودَةٍ
u'نِيَّةٌ مَخْصُوصٌ':Added, #1: 1	نِيَّةَ مُحَرَّمَةٍ
u'نِيَّةٌ مُدَّةٌ':Added, #1: 1	نِيَّةٍ مَخْصُوصَةٍ
u'نِيَّةٌ مراد':Added, #1: 1	نِيَّةِ الْمُدَّةِ
u'نِيَّةٌ مُرَادٌ':Added, #1: 1	نِيَّةَ مُرَادِهِ
u'نِيَّةٌ مَرَقٌ':Added, #1: 1	نِيَّةَ مُرَادِهِ
u'نِيَّةٌ مرقة':Added, #2: 2	نِيَّةُ الْمَرَقَةِ
u'نِيَّةٌ مَسَافَةٌ':Added, #2: 2	نِيَّةُ الْمَرَقَةِ
u'نِيَّةٌ مُسَافِرٌ':Added, #1: 1	نِيَّةُ الْمَسَافَةِ
u'نِيَّةٌ مُسَافِرٌ':Added, #1: 1	نِيَّةَ الْمُسَافِرِ
u'نِيَّةٌ مُسَاكَنَةٌ':Added, #1: 1	نِيَّةِ مُسَافِرٍ
u'نِيَّةٌ مَسْبُوق':Added, #1: 1	نِيَّةَ الْمُسَاكَنَةِ
u'نِيَّةٌ مُسْتَأْنَفٌ':Added, #1: 1	نِيَّةُ الْمَسْبُوقِ
u'نِيَّةٌ مُسْتَحِقٌّ':Added, #3: 3	نِيَّةٍ مُسْتَأْنَفَةٍ
u'نِيَّةٌ مُسْلِمٌ':Added, #2: 2	نِيَّةُ الْمُسْتَحِقِّ
u'نِيَّةٌ مَطْلُوبٌ':Added, #1: 1	نِيَّةِ الْمُسْلِمِ
u'نِيَّةٌ مُعْتَبَرٌ':Added, #1: 1	نِيَّةُ الْمَطْلُوبِ
u'نِيَّةٌ مُعْتَقِدٌ':Added, #5: 5	نِيَّةٍ مُعْتَبَرَةٍ
u'نِيَّةٌ مَعْصِيَةٌ':Added, #5: 5	نِيَّةِ مُعْتَقِدِ
u'نِيَّةٌ مَعِيٌّ':Added, #1: 1	نِيَّةُ الْمَعْصِيَةِ
u'نِيَّةٌ مَعِيَّةٌ':Added, #1: 1	نِيَّةِ الْمَعِيَّةِ
u'نِيَّةٌ مُعَيَّنٌ':Added, #1: 1	نِيَّةِ الْمَعِيَّةِ
u'نِيَّةٌ مَغْرِبٌ':Added, #1: 1	نِيَّةٍ مُعَيَّنَةٍ
u'نِيَّةٌ مُفَارَقَةٌ':Added, #1: 1	نِيَّةَ الْمَغْرِبِ
u'نِيَّةٌ مُفَارَقَةٌ':Added, #2: 2	نِيَّةِ مُفَارَقَةٍ
u'نِيَّةٌ مُفَارَقَةٌ':Added, #3: 3	نِيَّةِ الْمُفَارَقَةِ
u'نِيَّةٌ مُفْرَدٌ':Added, #5: 5	نِيَّةُ الْمُفَارَقَةِ
u'نِيَّةٌ مُفَسَّرٌ':Added, #1: 1	نِيَّةٍ مُفْرَدَةٍ
u'نِيَّةٌ مُقَابِلٌ':Added, #1: 1	نِيَّةِ الْمُفَسَّرِ
u'نِيَّةٌ مُقَارِنٌ':Added, #1: 1	نِيَّةَ الْمُقَابِلِ
u'نِيَّةٌ مُقَدِّمٌ':Added, #1: 1	نِيَّةٍ مُقَارِنَةٍ
u'نِيَّةٌ مُقَدِّمٌ':Added, #1: 1	نِيَّةُ الْمُقَدِّمَةِ
u'نِيَّةٌ مُقَدِّمَةٌ':Added, #2: 2	نِيَّةِ الْمُقَدِّمَةِ
u'نِيَّةٌ مُقَدِّمَةٌ':Added, #1: 1	نِيَّةُ الْمُقَدِّمَةِ
u'نِيَّةٌ مُكْرَهٌ':Added, #2: 2	نِيَّةِ الْمُقَدِّمَةِ
u'نِيَّةٌ مُكْرِهٌ':Added, #1: 1	نِيَّةِ الْمُكْرَهِ
u'نِيَّةٌ مَكْرُوهٌ':Added, #1: 1	نِيَّةَ الْمُكْرِهِ
u'نِيَّةٌ مُكَلَّفٌ':Added, #1: 1	نِيَّةُ مَكْرُوهٍ
u'نِيَّةٌ مُلْتَقِط':Added, #1: 1	نِيَّةُ الْمُكَلَّفِ
u'نِيَّةٌ مُنْفَرِدٌ':Added, #1: 1	نِيَّةُ الْمُلْتَقِطِ
u'نِيَّةٌ مُوَكِّلٌ':Added, #1: 1	نِيَّةِ الْمُنْفَرِدِ
u'نِيَّةٌ مُوَكِّلٌ':Added, #2: 2	نِيَّةِ الْمُوَكِّلِ
u'نِيَّةٌ مُؤْمِنٌ':Added, #4: 4	نِيَّةُ الْمُوَكِّلِ
u'نِيَّةٌ نَافِلَةٌ':Added, #5: 5	نِيَّةُ الْمُؤْمِنِ
u'نِيَّةٌ نَحْوٌ':Added, #1: 1	نِيَّةِ النَّافِلَةِ
u'نِيَّةٌ نذر':Added, #1: 1	نِيَّةِ نَحْوِ
u'نِيَّةٌ نَذْرٌ':Added, #1: 1	نِيَّةَ النَّذْرِ
u'نِيَّةٌ نَذْرٌ':Added, #1: 1	نِيَّةَ النَّذْرِ
u'نِيَّةٌ نذر':Added, #2: 2	نِيَّةَ نَذْرٍ
u'نِيَّةٌ نَذْرٌ':Added, #2: 2	نِيَّةِ نَذْرِهِ
u'نِيَّةٌ نذر':Added, #2: 2	نِيَّةِ نَذْرِهِ
u'نِيَّةٌ نَذْرٌ':Added, #4: 4	نِيَّةِ النَّذْرِ
u'نِيَّةٌ نُزُولٌ':Added, #4: 4	نِيَّةِ النَّذْرِ
u'نِيَّةٌ نِساءٌ':Added, #2: 2	نِيَّةِ النُّزُولِ
u'نِيَّةٌ نُسُكٌ':Added, #1: 1	نِيَّةِ النِّسَاءِ
u'نِيَّةٌ نُسُكٌ':Added, #2: 2	نِيَّةَ النُّسُكِ
u'نِيَّةٌ نَفْسٌ':Added, #8: 8	نِيَّةُ النُّسُكِ
u'نِيَّةٌ نَفَقَةٌ':Added, #1: 1	نِيَّةِ نَفْسِهِ
u'نِيَّةٌ نَفْلٌ':Added, #1: 1	نِيَّةُ النَّفَقَةِ
u'نِيَّةٌ نَفْلٌ':Added, #10: 10	نِيَّةِ النَّفْلِ
u'نِيَّةٌ نَفْلٌ':Added, #2: 2	نِيَّةِ نَفْلٍ
u'نِيَّةٌ نَفْلٌ':Added, #6: 6	نِيَّةُ النَّفْلِ
u'نِيَّةٌ نقل':Added, #7: 7	نِيَّةَ النَّفْلِ
u'نِيَّةٌ نَقْلٌ':Added, #1: 1	نِيَّةِ نَقْلِ
u'نِيَّةٌ نقلة':Added, #1: 1	نِيَّةِ نَقْلِ
u'نِيَّةٌ نهار':Added, #1: 1	نِيَّةَ النَّقْلَةِ
u'نِيَّةٌ نهار':Added, #1: 1	نِيَّةَ النَّهَارِ
u'نِيَّةٌ نَهَارٌ':Added, #1: 1	نِيَّةِ النَّهَارِ
u'نِيَّةٌ نَهَارٌ':Added, #1: 1	نِيَّةَ النَّهَارِ
u'نِيَّةٌ نَوْعٌ':Added, #1: 1	نِيَّةِ النَّهَارِ
u'نِيَّةٌ نَوْعٌ':Added, #1: 1	نِيَّةَ نَوْعٍ
u'نِيَّةٌ نِيَّةٌ':Added, #1: 1	نِيَّةُ نَوْعٍ
u'نِيَّةٌ هَدْيٌ':Added, #1: 1	نِيَّةُ النِّيَّةِ
u'نِيَّةٌ هَدْيٌ':Added, #1: 1	نِيَّةِ الْهَدْيِ
u'نِيَّةٌ وَاجِبٌ':Added, #2: 2	نِيَّةَ الْهَدْيِ
u'نِيَّةٌ واحد':Added, #2: 2	نِيَّةُ الْوَاجِبِ
u'نِيَّةٌ وَاحِدٌ':Added, #1: 1	نِيَّةٍ وَاحِدَةٍ
u'نِيَّةٌ وَاهِبٌ':Added, #1: 1	نِيَّةٍ وَاحِدَةٍ
u'نِيَّةٌ وَجْهٌ':Added, #1: 1	نِيَّةُ وَاهِبٍ
u'نِيَّةٌ وُجُوبٌ':Added, #1: 1	نِيَّةِ وَجْهِ
u'نِيَّةٌ وُجُوبٌ':Added, #1: 1	نِيَّةِ الْوُجُوبِ
u'نِيَّةٌ وَصْفٌ':Added, #3: 3	نِيَّةُ الْوُجُوبِ
u'نِيَّةٌ وُضُوءٌ':Added, #1: 1	نِيَّةُ الْوَصْفِ
u'نِيَّةٌ وُضُوءٌ':Added, #1: 1	نِيَّة الْوُضُوءِ
u'نِيَّةٌ وُضُوءٌ':Added, #1: 1	نِيَّةُ وُضُوءٍ
u'نِيَّةٌ وُضُوءٌ':Added, #22: 22	نِيَّةِ الْوُضُوءِ
u'نِيَّةٌ وُضُوءٌ':Added, #4: 4	نِيَّةَ الْوُضُوءِ
u'نِيَّةٌ وُقُوعٌ':Added, #9: 9	نِيَّةُ الْوُضُوءِ
u'نِيَّةٌ وَكِيلٌ':Added, #1: 1	نِيَّةِ الْوُقُوعِ
u'نِيَّةٌ وَكِيلٌ':Added, #3: 3	نِيَّةُ الْوَكِيلِ
u'نِيَّةٌ وَلِيٌّ':Added, #5: 5	نِيَّةِ الْوَكِيلِ
u'نِيَّةٌ يَمِينٌ':Added, #1: 1	نِيَّةُ وَلِيِّهِ
u'نَيْلٌ أَمْرٌ':Added, #1: 1	نِيَّةُ الْيَمِينِ
u'نَيْلٌ بَقِيَّةٌ':Added, #1: 1	نَيْلِ أَمْرٍ
u'نَيْلٌ بَلاغَةٌ':Added, #1: 1	نَيْلِ الْبَقِيَّةِ
u'نَيْلٌ ثَوابٌ':Added, #1: 1	نَيْلِ الْبَلَاغَةِ
u'نَيْلٌ ثَوابٌ':Added, #1: 1	نَيْلِ الثَّوَابِ
u'نَيْلٌ ثَوابٌ':Added, #1: 1	نَيْلِ ثَوَابِ
u'نَيْلٌ حُرِّيَّةٌ':Added, #3: 3	نَيْلُ الثَّوَابِ
u'نَيْلٌ حُطَامٌ':Added, #1: 1	نَيْلُ الْحُرِّيَّةِ
u'نَيْلٌ حَظٌّ':Added, #1: 1	نَيْلِ حُطَامِ
u'نَيْلٌ حُكْمٌ':Added, #1: 1	نَيْلَ حَظٍّ
u'نَيْلٌ حكمة':Added, #1: 1	نَيْلِ حُكْمٍ
u'نَيْلٌ حِكْمَةٌ':Added, #1: 1	نَيْلِ الْحِكْمَةِ
u'نَيْلٌ دَرَجَةٌ':Added, #1: 1	نَيْلِ الْحِكْمَةِ
u'نَيْلٌ درجة':Added, #1: 1	نَيْلِ الدَّرَجَاتِ
u'نَيْلٌ دَرَجَةٌ':Added, #1: 1	نَيْلُ الدَّرَجَةِ
u'نَيْلٌ رَاحَةٌ':Added, #1: 1	نَيْلُ الدَّرَجَةِ
u'نَيْلٌ زِيادَةٌ':Added, #1: 1	نَيْلُ الرَّاحَةِ
u'نَيْلٌ زِيادَةٌ':Added, #1: 1	نَيْلُ زِيَادَةِ
u'نَيْلٌ سَعَادَةٌ':Added, #3: 3	نَيْلِ الزِّيَادَةِ
u'نَيْلٌ شرف':Added, #1: 1	نَيْلُ السَّعَادَةِ
u'نَيْلٌ شَرَفٌ':Added, #1: 1	نَيْلِ شَرَفِ
u'نَيْلٌ شَهِيدٌ':Added, #1: 1	نَيْلِ شَرَفِ
u'نَيْلٌ عَظِيمٌ':Added, #1: 1	نَيْلِ الشّهِيدِ
u'نَيْلٌ عَظِيم':Added, #1: 1	نَيْلَ الْعَظِيمِ
u'نَيْلٌ غَرَضٌ':Added, #1: 1	نَيْلَ الْعَظِيمِ
u'نَيْلٌ غَرَضٌ':Added, #1: 1	نَيْلَ غَرَضِهِ
u'نَيْلٌ فَضِيلٌ':Added, #1: 1	نَيْلُ غَرَضِهِ
u'نَيْلٌ فَضِيلَةٌ':Added, #1: 1	نَيْلِ فَضِيلَةِ
u'نَيْلٌ قَلِيلٌ':Added, #1: 1	نَيْلِ فَضِيلَةِ
u'نَيْلٌ مُسْلِمٌ':Added, #1: 1	نَيْلِ الْقَلِيلِ
u'نَيْلٌ مَطَالِبُ':Added, #1: 1	نَيْلِ الْمُسْلِمِ
u'نَيْلٌ مَعَادِنُ':Added, #1: 1	نَيْلِ مَطَالِبِهِ
u'نَيْلٌ مَعْدِنٌ':Added, #1: 1	نَيْلِ الْمَعَادِنِ
u'نَيْلٌ مَعْدِنٌ':Added, #1: 1	نَيْلِ الْمَعْدِنِ
u'نَيْلٌ ولد':Added, #2: 2	نَيْلُ مَعْدِنٍ
u'نَيْلٌ وَلَدٌ':Added, #1: 1	نَيْلَ الْوَلَدِ
u'هَابَ رِجَالٌ':Predicate, #1: 1	نَيْلَ الْوَلَدِ
u'هَابَ رَجُلٌ':Subject, #1: 1	هَابَ الرِّجَالَ
u'هَاجَ أُمٌّ':Subject, #3: 3	هَابَ الرَّجُلُ
u'هَاجَ بَحْرٌ':Subject, #1: 1	هَاجَ أُمّهُ
u'هَاجَرَ أحَدٌ':Subject, #1: 1	هَاجَ الْبَحْرُ
u'هَاجَرَ أَصْحَابٌ':Subject, #1: 1	هَاجَرَ أَحَدُ
u'هَاجَرَ أَمْرٌ':Subject, #1: 1	هَاجَرَ أَصْحَابُ
u'هَاجَرَ رَجُلٌ':Subject, #1: 1	هَاجَرَ أَمْرٌ
u'هَاجَرَ رَسُولٌ':Subject, #2: 2	هَاجَرَ الرَّجُلُ
u'هَاجَرَ زَوْجٌ':Subject, #12: 12	هَاجَرَ رَسُولُ
u'هَاجَ رُطوبَةٌ':Predicate, #1: 1	هَاجَرَ الزَّوْجُ
u'هَاجَرَ عَبْدٌ':Subject, #1: 1	أَهَاجَ الرُّطُوبَةَ
u'هَاجَرَ قَالٌ':Predicate, #2: 2	هَاجَرَ عَبْدٌ
u'هَاجَرَ قِبَلٌ':Predicate, #1: 1	هَاجَرَ قَالَ
u'هَاجَرَ مُسْلِمٌ':Subject, #1: 1	هَاجَرَ قِبَلَ
u'هَاجَرَ نَبِيٌّ':Subject, #1: 1	هَاجَرَ الْمُسْلِمَاتُ
u'هَاجَرَ نِساءٌ':Subject, #3: 3	هَاجَرَ النَّبِيُّ
u'هَاجَ غَزْوَةٌ':Predicate, #1: 1	هَاجَرَ النّسَاءُ
u'هَاجَ غضب':Subject, #1: 1	هَاجَ غَزْوَةَ
u'هَاجَ غَضَبٌ':Subject, #1: 1	هَاجَ الْغَضَبُ
u'هَاجَ فَتْحٌ':Predicate, #1: 1	هَاجَ الْغَضَبُ
u'هَاجَ فراغ':Subject, #1: 1	هَاجَ فَتْحَ
u'هَاجَ فَرَاغٌ':Subject, #1: 1	أَهَاجَ الْفَرَاغُ
u'هَاجَ مرٌّ':Predicate, #1: 1	أَهَاجَ الْفَرَاغُ
u'هَاجَ مِرَّةٌ':Predicate, #1: 1	أَهَاجَ الْمِرَّةَ
u'هَاجَ مَوْجٌ':Subject, #1: 1	أَهَاجَ الْمِرَّةَ
u'هَاجَ هَيْجٌ':Subject, #1: 1	هَاجَ الْمَوْجُ
u'هَادَنَ رَسُولٌ':Subject, #1: 1	هَاجَ هَيْجٌ
u'هَادَنَ صَفْوَان':Predicate, #1: 1	هَادَنَ رَسُولُ
u'هَالَ نَاسٌ':Subject, #2: 2	هَادَنَ صَفْوَانَ
u'هَانَ حُرٌّ':Subject, #1: 1	هَالَ النَّاسُ
u'هَانَ خَطْبٌ':Subject, #1: 1	هَانَ حُرٌّ
u'هَانَ سُلْطَانٌ':Predicate, #1: 1	هَانَ الْخَطْبُ
u'هِبَاتٌ مُدَوَّنٌ':Added, #1: 1	أَهَانَ سُلْطَانَ
u'هِبَاتٌ مُدَوَّنَةٌ':Added, #1: 1	هِبَاتِ الْمُدَوَّنَةِ
u'هِبَاتٌ مُلُوكٌ':Added, #1: 1	هِبَاتِ الْمُدَوَّنَةِ
u'هِبَاتٌ نَاسٌ':Added, #1: 1	هِبَاتِ الْمُلُوكِ
u'هِبَةٌ أَبٌ':Added, #1: 1	هِبَاتِ النَّاسِ
u'هِبَةٌ أَبٌ':Added, #1: 1	هِبَةَ الْأَبِ
u'هِبَةٌ إجَارَةٌ':Added, #1: 1	هِبَةِ الْأَبِ
u'هِبَةٌ أَجْنَبِيٌّ':Added, #3: 3	هِبَةُ إجَارَةٍ
u'هِبَةٌ أَجْنَبِيٌّ':Added, #1: 1	هِبَةُ الْأَجْنَبِيِّ
u'هِبَةٌ أحَدٌ':Added, #1: 1	هِبَةِ الْأَجْنَبِيِّ
u'هِبَةٌ أحَدٌ':Added, #1: 1	هِبَةُ أَحَدِ
u'هِبَةٌ أرْضٌ':Added, #1: 1	هِبَةِ أَحَدِ
u'هِبَةٌ أرْضٌ':Added, #1: 1	هِبَةِ الْأَرْضِ
u'هِبَةٌ أَشْجَارٌ':Added, #2: 2	هِبَةُ أَرْضٍ
u'هِبَةٌ أصل':Added, #1: 1	هِبَةِ الْأَشْجَارِ
u'هِبَةٌ أًصْلٌ':Added, #5: 5	هِبَةِ الْأَصْلِ
u'هِبَةٌ ألف':Added, #5: 5	هِبَةِ الْأَصْلِ
u'هِبَةٌ ألْفٌ':Added, #1: 1	هِبَةَ الْأَلْفِ
u'هِبَةٌ أَلْفٌ':Added, #1: 1	هِبَةَ الْأَلْفِ
u'هِبَةٌ الْمَرْأَةُ':Added, #1: 1	هِبَةَ الْأَلْفِ
u'هِبَةٌ الْمَرْأَةُ':Added, #3: 3	هِبَةُ الْمَرْأَةِ
u'هِبَةٌ أُمٌّ':Added, #4: 4	هِبَةِ الْمَرْأَةِ
u'هِبَةٌ أُمٌّ':Added, #1: 1	هِبَةِ أُمِّ
u'هِبَةٌ أمَةٌ':Added, #2: 2	هِبَةُ أُمِّ
u'هِبَةٌ إيرَادٌ':Added, #1: 1	هِبَةِ الْأَمَةِ
u'هِبَةٌ بَاطِلٌ':Added, #1: 1	هِبَةِ إيرَادِ
u'هِبَةٌ بَدَلٌ':Added, #1: 1	هِبَةٍ بَاطِلَةٍ
u'هِبَةٌ بَزّاز':Added, #1: 1	هِبَةَ الْبَدَلِ
u'هِبَةٌ بَزّازَة':Added, #1: 1	هِبَةِ الْبَزَّازِيَّةِ
u'هِبَةٌ بَعْضٌ':Added, #1: 1	هِبَةِ الْبَزَّازِيَّةِ
u'هِبَةٌ بِنَاءٌ':Added, #3: 3	هِبَةَ الْبَعْضِ
u'هِبَةٌ بَيْتٌ':Added, #1: 1	هِبَةُ الْبِنَاءِ
u'هِبَةٌ ثَمَرٌ':Added, #1: 1	هِبَةَ الْبَيْتِ
u'هِبَةٌ ثَمَرٌ':Added, #1: 1	هِبَةُ الثَّمَرِ
u'هِبَةٌ ثَمَرَةٌ':Added, #1: 1	هِبَةِ ثَمَرِ
u'هِبَةٌ ثَمَرَةٌ':Added, #1: 1	هِبَةُ ثَمَرَةٍ
u'هِبَةٌ ثَمَنٌ':Added, #1: 1	هِبَةُ ثَمَرَةِ
u'هِبَةٌ ثَوابٌ':Added, #1: 1	هِبَةِ الثَّمَنِ
u'هِبَةٌ ثَوابٌ':Added, #1: 1	هِبَةُ ثَوَابٍ
u'هِبَةٌ ثَوابٌ':Added, #3: 3	هِبَةَ الثَّوَابِ
u'هِبَةٌ ثَوابٌ':Added, #5: 5	هِبَةُ الثَّوَابِ
u'هِبَةٌ ثَوْبٌ':Added, #8: 8	هِبَةِ الثَّوَابِ
u'هِبَةٌ جَارِي':Added, #1: 1	هِبَةِ الثَّوْبِ
u'هِبَةٌ جَارِي':Added, #1: 1	هِبَةِ الْجَارِيَةِ
u'هِبَةٌ جَارِيَةٌ':Added, #1: 1	هِبَةِ جَارِيَتِهِ
u'هِبَةٌ جَارِيَةٌ':Added, #1: 1	هِبَةِ الْجَارِيَةِ
u'هِبَةٌ جَائِزٌ':Added, #1: 1	هِبَةِ جَارِيَتِهِ
u'هِبَةٌ جلد':Added, #1: 1	هِبَةُ جَائِزٍ
u'هِبَةٌ جِلْدٌ':Added, #1: 1	هِبَةُ جِلْدِ
u'هِبَةٌ جُمْلَةٌ':Added, #1: 1	هِبَةُ جِلْدِ
u'هِبَةٌ جُمْلَةٌ':Added, #1: 1	هِبَةِ الْجُمْلَةِ
u'هِبَةٌ جَمِيع':Added, #3: 3	هِبَةُ الْجُمْلَةِ
u'هِبَةٌ حُلِيٌّ':Added, #1: 1	هِبَةِ الْجَمِيعِ
u'هِبَةٌ دَارٌ':Added, #1: 1	هِبَةَ الْحُلِيِّ
u'هِبَةٌ دَارٌ':Added, #2: 2	هِبَةُ الدَّارِ
u'هِبَةٌ دَارٌ':Added, #2: 2	هِبَةِ الدَّارِ
u'هِبَةٌ دَنانيرُ':Added, #3: 3	هِبَةَ الدَّارِ
u'هِبَةٌ دُهْنٌ':Added, #1: 1	هِبَةِ الدَّنَانِيرِ
u'هِبَةٌ دَيْنٌ':Added, #1: 1	هِبَةِ الدُّهْنِ
u'هِبَةٌ دَيْنٌ':Added, #12: 12	هِبَةَ الدَّيْنِ
u'هِبَةٌ دَيْنٌ':Added, #14: 14	هِبَةُ الدَّيْنِ
u'هِبَةٌ دَيْنٌ':Added, #1: 1	هِبَةِ دَيْنِ
u'هِبَةٌ دَيْنٌ':Added, #2: 2	هِبَةُ دَيْنٍ
u'هِبَةٌ رَقَبَةٌ':Added, #6: 6	هِبَةِ الدَّيْنِ
u'هِبَةٌ زَرْعٌ':Added, #1: 1	هِبَةُ الرَّقَبَةِ
u'هِبَةٌ زَوْجٌ':Added, #1: 1	هِبَةِ الزَّرْعِ
u'هِبَةٌ زِيادَةٌ':Added, #1: 1	هِبَةِ الزَّوْجِ
u'هِبَةٌ سَيِّدٌ':Added, #1: 1	هِبَةِ الزِّيَادَاتِ
u'هِبَةٌ شَاغِلٌ':Added, #1: 1	هِبَةُ السَّيِّدِ
u'هِبَةٌ شَرْحٌ':Added, #2: 2	هِبَةُ الشَّاغِلِ
u'هِبَةٌ شَيْءٌ':Added, #1: 1	هِبَةِ شَرْحِ
u'هِبَةٌ شَيْءٌ':Added, #2: 2	هِبَةَ الشَّيْءِ
u'هِبَةٌ شَيْءٌ':Added, #2: 2	هِبَةِ شَيْءٍ
u'هِبَةٌ شَيْخٌ':Added, #6: 6	هِبَةُ شَيْءٍ
u'هِبَةٌ صَاعٌ':Added, #1: 1	هِبَةِ شَيْخِ
u'هِبَةٌ صَبِيٌّ':Added, #2: 2	هِبَةَ صَاعٍ
u'هِبَةٌ صداق':Added, #1: 1	هِبَةَ الصَّبِيِّ
u'هِبَةٌ صَدَاقٌ':Added, #1: 1	هِبَةِ الصَّدَاقِ
u'هِبَةٌ صداق':Added, #1: 1	هِبَةِ الصَّدَاقِ
u'هِبَةٌ صَدَاقٌ':Added, #1: 1	هِبَةِ صَدَاقِ
u'هِبَةٌ صَغِيرٌ':Added, #1: 1	هِبَةِ صَدَاقِ
u'هِبَةٌ صَغِيرٌ':Added, #1: 1	هِبَةُ الصَّغِيرِ
u'هِبَةٌ صُوفٌ':Added, #3: 3	هِبَةَ الصَّغِيرِ
u'هِبَةٌ ضِمْنِيٌّ':Added, #1: 1	هِبَةِ الصُّوفِ
u'هِبَةٌ طِينٌ':Added, #1: 1	هِبَةُ الضِّمْنِيِّ
u'هِبَةٌ عارِيَّةٌ':Added, #1: 1	هِبَةِ الطِّينِ
u'هِبَةٌ عارِيَّةٌ':Added, #1: 1	هِبَةَ عَارِيَّةٍ
u'هِبَةٌ عَبْدٌ':Added, #1: 1	هِبَةُ عَارِيَّةٍ
u'هِبَةٌ عَبْدٌ':Added, #2: 2	هِبَةَ الْعَبْدِ
u'هِبَةٌ عَبْدٌ':Added, #2: 2	هِبَةُ الْعَبْدِ
u'هِبَةٌ عين':Added, #5: 5	هِبَةِ الْعَبْدِ
u'هِبَةٌ عَيْنٌ':Added, #1: 1	هِبَةَ الْعَيْنِ
u'هِبَةٌ عَيْن':Added, #1: 1	هِبَةَ الْعَيْنِ
u'هِبَةٌ عَيْنٌ':Added, #1: 1	هِبَةَ الْعَيْنِ
u'هِبَةٌ عَيْن':Added, #1: 1	هِبَةِ عَيْنٍ
u'هِبَةٌ عين':Added, #1: 1	هِبَةِ عَيْنٍ
u'هِبَةٌ عَيْنٌ':Added, #2: 2	هِبَةِ الْعَيْنِ
u'هِبَةٌ عَيْن':Added, #2: 2	هِبَةِ الْعَيْنِ
u'هِبَةٌ غُلاَمٌ':Added, #2: 2	هِبَةِ الْعَيْنِ
u'هِبَةٌ غَنِيٌّ':Added, #1: 1	هِبَةُ الْغُلَامِ
u'هِبَةٌ غَنِيٌّ':Added, #1: 1	هِبَةِ الْغَنِيِّ
u'هِبَةٌ غير':Added, #1: 1	هِبَةُ غَنِيٍّ
u'هِبَةٌ غَيْرٌ':Added, #1: 1	هِبَةُ غَيْرِ
u'هِبَةٌ غير':Added, #1: 1	هِبَةُ غَيْرِ
u'هِبَةٌ غَيْرٌ':Added, #2: 2	هِبَةِ غَيْرِهِ
u'هِبَةٌ فَرْعٌ':Added, #2: 2	هِبَةِ غَيْرِهِ
u'هِبَةٌ فُضُولِيٌّ':Added, #1: 1	هِبَةِ الْفَرْعِ
u'هِبَةٌ فُضُولِيٌّ':Added, #1: 1	هِبَةَ الْفُضُولِيِّ
u'هِبَةٌ فَقِيرٌ':Added, #1: 1	هِبَةِ الْفُضُولِيِّ
u'هِبَةٌ فلان':Added, #1: 1	هِبَةِ الْفَقِيرِ
u'هِبَةٌ فلان':Added, #1: 1	هِبَةِ الْبَزَّازِيَّةِ
u'هِبَةٌ فُلاَنٌ':Added, #1: 1	هِبَةُ الدَّانِقِ
u'هِبَةٌ قَرِيبٌ':Added, #1: 1	هِبَةِ فُلَانٍ
u'هِبَةٌ كَلْبٌ':Added, #1: 1	هِبَةِ الْقَرِيبِ
u'هِبَةٌ لبن':Added, #3: 3	هِبَةُ الْكَلْبِ
u'هِبَةٌ لَبَنٌ':Added, #1: 1	هِبَةُ لَبَنِ
u'هِبَةٌ لَقِيطٌ':Added, #1: 1	هِبَةُ لَبَنِ
u'هِبَةٌ مَاءٌ':Added, #1: 1	هِبَةَ اللَّقِيطِ
u'هِبَةٌ مَاءٌ':Added, #1: 1	هِبَةِ مَاءٍ
u'هِبَةٌ مَاءٌ':Added, #24: 24	هِبَةِ الْمَاءِ
u'هِبَةٌ مَاءٌ':Added, #2: 2	هِبَة الْمَاءِ
u'هِبَةٌ مازِح':Added, #2: 2	هِبَةُ الْمَاءِ
u'هِبَةٌ مَالٌ':Added, #1: 1	هِبَةَ الْمَازِحِ
u'هِبَةٌ مَالٌ':Added, #1: 1	هِبَةِ مَالٍ
u'هِبَةٌ مَالٌ':Added, #2: 2	هِبَةِ الْمَالِ
u'هِبَةٌ مُبَاحٌ':Added, #3: 3	هِبَةُ مَالِ
u'هِبَةٌ مَبِيعٌ':Added, #1: 1	هِبَةُ الْمُبَاحَاتِ
u'هِبَةٌ مَبِيعٌ':Added, #1: 1	هِبَةُ الْمَبِيعِ
u'هِبَةٌ مَتَاعٌ':Added, #2: 2	هِبَةِ الْمَبِيعِ
u'هِبَةٌ مَتَاعٌ':Added, #1: 1	هِبَةِ الْمَتَاعِ
u'هِبَةٌ مَجْنُونٌ':Added, #2: 2	هِبَةَ الْمَتَاعِ
u'هِبَةٌ مَجْهُولٌ':Added, #1: 1	هِبَةُ الْمَجْنُونِ
u'هِبَةٌ مَجْهُولٌ':Added, #1: 1	هِبَةُ مَجْهُولٍ
u'هِبَةٌ مَجْهُولٌ':Added, #2: 2	هِبَةَ مَجْهُولٍ
u'هِبَةٌ مَجْهُولٌ':Added, #3: 3	هِبَةِ الْمَجْهُولِ
u'هِبَةٌ مُحِيطٌ':Added, #6: 6	هِبَةُ الْمَجْهُولِ
u'هِبَةٌ مَدِينٌ':Added, #1: 1	هِبَةِ الْمُحِيطِ
u'هِبَةٌ مَدِينٌ':Added, #1: 1	هِبَةَ الْمَدِينِ
u'هِبَةٌ مَدْيُونٌ':Added, #9: 9	هِبَةِ الْمَدِينِ
u'هِبَةٌ مَرِيضٌ':Added, #1: 1	هِبَةِ الْمَدْيُونِ
u'هِبَةٌ مَرِيضٌ':Added, #1: 1	هِبَةَ الْمَرِيضِ
u'هِبَةٌ مَرِيضٌ':Added, #1: 1	هِبَةُ الْمَرِيضِ
u'هِبَةٌ مَسْرُوقٌ':Added, #2: 2	هِبَةِ الْمَرِيضِ
u'هِبَةٌ مُشاعٌ':Added, #2: 2	هِبَةِ الْمَسْرُوقِ
u'هِبَةٌ مُشاعٌ':Added, #16: 16	هِبَةُ الْمُشَاعِ
u'هِبَةٌ مُشاعٌ':Added, #1: 1	هِبَةَ مُشَاعٍ
u'هِبَةٌ مُشاعٌ':Added, #4: 4	هِبَةَ الْمُشَاعِ
u'هِبَةٌ مُشاعٌ':Added, #6: 6	هِبَةُ مُشَاعٍ
u'هِبَةٌ مَشْغُولٌ':Added, #9: 9	هِبَةِ الْمُشَاعِ
u'هِبَةٌ مَشْغُولٌ':Added, #1: 1	هِبَةُ الْمَشْغُولِ
u'هِبَةٌ مَعْدُومٌ':Added, #1: 1	هِبَةِ الْمَشْغُولِ
u'هِبَةٌ مَعْدُومٌ':Added, #1: 1	هِبَةَ الْمَعْدُومِ
u'هِبَةٌ مَعْدُومٌ':Added, #1: 1	هِبَةُ مَعْدُومٍ
u'هِبَةٌ مِلْكٌ':Added, #2: 2	هِبَةِ الْمَعْدُومِ
u'هِبَةٌ مَنَافِعُ':Added, #1: 1	هِبَةَ مِلْكِ
u'هِبَةٌ مَنَافِعُ':Added, #1: 1	هِبَةِ الْمَنَافِعِ
u'هِبَةٌ مَنَافِعُ':Added, #1: 1	هِبَةُ مَنَافِعِ
u'هِبَةٌ مَنَافِعُ':Added, #1: 1	هِبَةِ مَنَافِعِ
u'هِبَةٌ مَنَافِعُ':Added, #2: 2	هِبَةَ مَنَافِعِ
u'هِبَةٌ مَنْفَعَةٌ':Added, #3: 3	هِبَةُ الْمَنَافِعِ
u'هِبَةٌ مَنْفَعَةٌ':Added, #16: 16	هِبَةُ مَنْفَعَةٍ
u'هِبَةٌ مَنْفَعَةٌ':Added, #1: 1	هِبَةِ الْمَنْفَعَةِ
u'هِبَةٌ مَهْرٌ':Added, #1: 1	هِبَةَ مَنْفَعَةٍ
u'هِبَةٌ مَهْرٌ':Added, #1: 1	هِبَةُ الْمَهْرِ
u'هِبَةٌ مَهْرٌ':Added, #2: 2	هِبَةَ الْمَهْرِ
u'هِبَةٌ مَوْصُوفٌ':Added, #7: 7	هِبَةِ الْمَهْرِ
u'هِبَةٌ نصاب':Added, #1: 1	هِبَةَ الْمَوْصُوفِ
u'هِبَةٌ نصاب':Added, #1: 1	هِبَةَ النِّصَابِ
u'هِبَةٌ نِصَابٌ':Added, #1: 1	هِبَةُ النِّصَابِ
u'هِبَةٌ نِصَابٌ':Added, #1: 1	هِبَةَ النِّصَابِ
u'هِبَةٌ نصاب':Added, #1: 1	هِبَةُ النِّصَابِ
u'هِبَةٌ نِصَابٌ':Added, #3: 3	هِبَةِ النِّصَابِ
u'هِبَةٌ نِصْفٌ':Added, #3: 3	هِبَةِ النِّصَابِ
u'هِبَةٌ نِصْفٌ':Added, #2: 2	هِبَةَ نِصْفِ
u'هِبَةٌ نِصْفٌ':Added, #2: 2	هِبَةِ نِصْفِ
u'هِبَةٌ نَصِيبٌ':Added, #4: 4	هِبَةُ النِّصْفِ
u'هِبَةٌ نَفْعٌ':Added, #4: 4	هِبَةَ نَصِيبِهِ
u'هِبَةٌ نِهَايَةٌ':Added, #2: 2	هِبَةِ نَفْعِ
u'هِبَةٌ نَوَازِلُ':Added, #1: 1	هِبَةِ النِّهَايَةِ
u'هِبَةٌ واحد':Added, #1: 1	هِبَةِ النَّوَازِلِ
u'هِبَةٌ وَاحِدٌ':Added, #1: 1	هِبَةِ وَاحِدٍ
u'هِبَةٌ واحد':Added, #1: 1	هِبَةِ وَاحِدٍ
u'هِبَةٌ وَاحِدٌ':Added, #1: 1	هِبَةٍ وَاحِدَةٍ
u'هِبَةٌ وَالِدٌ':Added, #1: 1	هِبَةٍ وَاحِدَةٍ
u'هِبَةٌ وَدِيعٌ':Added, #6: 6	هِبَةِ الْوَالِدِ
u'هِبَةٌ وَدِيعَةٌ':Added, #1: 1	هِبَةُ الْوَدِيعَةِ
u'هِبَةٌ ولد':Added, #1: 1	هِبَةُ الْوَدِيعَةِ
u'هِبَةٌ ولد':Added, #1: 1	هِبَةَ الْوَلَدِ
u'هِبَةٌ وَلَدٌ':Added, #1: 1	هِبَةُ الْوَلَدِ
u'هِبَةٌ وَلَدٌ':Added, #1: 1	هِبَةَ الْوَلَدِ
u'هِبَةٌ ولد':Added, #1: 1	هِبَةُ الْوَلَدِ
u'هِبَةٌ وَلَدٌ':Added, #1: 1	هِبَةِ وَلَدِهِ
u'هِبَةٌ ولد':Added, #1: 1	هِبَةِ وَلَدِهِ
u'هِبَةٌ وَلَدٌ':Added, #3: 3	هِبَةِ الْوَلَدِ
u'هِبَةٌ وَلِيٌّ':Added, #3: 3	هِبَةِ الْوَلَدِ
u'هَبَطَ بَعيرٌ':Subject, #1: 1	هِبَةَ الْوَلِيِّ
u'هُبُوبٌ ريحٌ':Added, #1: 1	هَبَطَ الْبَعِيرُ
u'هُبُوبٌ ريحٌ':Added, #19: 19	هُبُوبِ الرِّيحِ
u'هُبُوبٌ ريحٌ':Added, #1: 1	هُبُوبِ رِيحٍ
u'هُبُوبٌ نَسِيمٌ':Added, #2: 2	هُبُوبَ الرِّيحِ
u'هُبُوطٌ رِياحٌ':Added, #1: 1	هُبُوبِ النَّسِيمِ
u'هُبُوطٌ كحل':Added, #1: 1	هُبُوطِ الرِّيَاحِ
u'هُبُوطٌ كُحْلٌ':Added, #1: 1	هُبُوطُ الْكُحْلِ
u'هَتَفَ هَاتِفٌ':Subject, #1: 1	هُبُوطُ الْكُحْلِ
u'هَتْكٌ أَسْتَارٌ':Added, #3: 3	هَتَفَ هَاتِفٌ
u'هَتَكَ حجاب':Predicate, #1: 1	هَتْكُ الْأَسْتَارِ
u'هَتَكَ حِجابٌ':Predicate, #1: 1	هَتَكَ الْحِجَابَ
u'هَتَكَ حِرْزٌ':Predicate, #1: 1	هَتَكَ الْحِجَابَ
u'هَتْكٌ حِرْزٌ':Added, #4: 4	هَتَكَ الْحِرْزَ
u'هَتْكٌ حِرْزٌ':Added, #1: 1	هَتْكِ حِرْزٍ
u'هَتْكٌ حِرْزٌ':Added, #4: 4	هَتْكَ الْحِرْزِ
u'هَتْكٌ حِرْزٌ':Added, #4: 4	هَتْكِ الْحِرْزِ
u'هَتَكَ حُرْمَةٌ':Predicate, #6: 6	هَتْكُ الْحِرْزِ
u'هَتْكٌ حُرْمَةٌ':Added, #2: 2	هَتَكَ حُرْمَةَ
u'هَتْكٌ حُرْمَةٌ':Added, #13: 13	هَتْكُ حُرْمَةِ
u'هَتْكٌ حُرْمَةٌ':Added, #1: 1	هَتْكَ الْحُرْمَةِ
u'هَتْكٌ حُرْمَةٌ':Added, #1: 1	هَتْكَ حُرْمَةِ
u'هَتْكٌ حُرْمَةٌ':Added, #1: 1	هَتْكُ حُرْمَةٍ
u'هَتْكٌ حُرْمَةٌ':Added, #23: 23	هَتْكِ حُرْمَةِ
u'هَتْكٌ حُرْمَةٌ':Added, #2: 2	هَتْكُ حُرْمَتِهِ
u'هَتْكٌ حُرْمَةٌ':Added, #3: 3	هَتْكِ الْحُرْمَةِ
u'هَتْكٌ حَرِيمٌ':Added, #4: 4	هَتْكِ حُرْمَتِهِ
u'هَتَكَ سِتْرٌ':Predicate, #1: 1	هَتْكُ حَرِيمٍ
u'هَتْكٌ سِتْرٌ':Added, #1: 1	هَتَكَ سِتْرَ
u'هَتْكٌ سِتْرٌ':Added, #1: 1	هَتْكَ السِّتْرِ
u'هَتْكٌ سِتْرٌ':Added, #1: 1	هَتْكُ السِّتْرِ
u'هَتْكٌ سِتْرٌ':Added, #1: 1	هَتْكُ سِتْرٍ
u'هَتْكٌ سَتْرٌ':Added, #1: 1	هَتْكِ سِتْرِهِ
u'هَتْكٌ سِتْرٌ':Added, #2: 2	هَتْكُ سَتْرِ
u'هَتْكٌ سَتْرٌ':Added, #2: 2	هَتْكِ سِتْرِ
u'هَتْكٌ سِتْرٌ':Added, #3: 3	هَتْكِ السَّتْرِ
u'هَتْكٌ سِرٌّ':Added, #7: 7	هَتْكِ السِّتْرِ
u'هَتْكٌ سِرٌّ':Added, #1: 1	هَتْكَ السِّرِّ
u'هَتَكَ سَرَاوِيلُ':Predicate, #2: 2	هَتْكُ السِّرِّ
u'هَتَكَ سَهْمٌ':Subject, #1: 1	هَتَكَ السَّرَاوِيلَ
u'هَتْكٌ صُنْدُوقٌ':Added, #1: 1	هَتَكَ السَّهْمُ
u'هَتْكٌ عِرْضٌ':Added, #1: 1	هَتْكُ الصُّنْدُوقِ
u'هَتْكٌ عِرْضٌ':Added, #1: 1	هَتْكِ الْعِرْضِ
u'هَتْكٌ عِرْضٌ':Added, #1: 1	هَتْكَ عِرْضٍ
u'هَتْكٌ مُسْلِمٌ':Added, #2: 2	هَتْكِ عِرْضِهِ
u'هَتْكٌ مُسْلِمٌ':Added, #1: 1	هَتْكُ الْمُسْلِمِ
u'هِجَاءٌ أنصار':Added, #1: 1	هَتْكِ الْمُسْلِمِ
u'هِجَاءٌ أَنْصارٌ':Added, #1: 1	هِجَاءُ الْأَنْصَارِ
u'هِجَاءٌ أَنْصَارٌ':Added, #1: 1	هِجَاءُ الْأَنْصَارِ
u'هِجَاءٌ شَاعِر':Added, #1: 1	هِجَاءُ الْأَنْصَارِ
u'هِجَاءٌ فلان':Added, #1: 1	هِجَاءَ الشَّاعِرِ
u'هِجَاءٌ قَيْس':Added, #1: 1	هِجَاءِ قَيْسٍ
u'هِجَاءٌ كَعْبٌ':Added, #1: 1	هِجَاءِ قَيْسٍ
u'هَجَا رَجُلٌ':Predicate, #1: 1	هِجَاءُ كَعْبٍ
u'هَجَا مُسْلِمٌ':Predicate, #1: 1	هَجَا رَجُلاً
u'هَجَرَ أهْلٌ':Predicate, #2: 2	هَجَا الْمُسْلِمِينَ
u'هجر أهْلٌ':Added, #1: 1	هَجَرَ أَهْلَ
u'هَجْرٌ أهْلٌ':Added, #1: 1	هَجْرَ أَهْلِ
u'هجر أهْلٌ':Added, #1: 1	هَجْرَ أَهْلِ
u'هَجْرٌ أهْلٌ':Added, #3: 3	هَجْرِ أَهْلِ
u'هجر آيَةٌ':Added, #3: 3	هَجْرِ أَهْلِ
u'هَجْرٌ آيَةٌ':Added, #1: 1	هَجْرِ آيَةِ
u'هَجَرَ بَعيرٌ':Predicate, #1: 1	هَجْرِ آيَةِ
u'هَجَرَ حَديثٌ':Predicate, #1: 1	هَجَرَ الْبَعِيرَ
u'هَجَرَ رَجُلٌ':Subject, #1: 1	هَجَرَ الْحَدِيثَ
u'هجر زَوْجٌ':Added, #1: 1	هَجَرَ رَجُلٌ
u'هَجْرٌ زَوْجٌ':Added, #1: 1	هَجْرُ الزَّوْجِ
u'هجر سَلَفٌ':Added, #1: 1	هَجْرُ الزَّوْجِ
u'هَجْرٌ سَلَفٌ':Added, #1: 1	هَجْرِ السَّلَفِ
u'هَجَرَ سُوءٌ':Predicate, #1: 1	هَجْرِ السَّلَفِ
u'هَجَرَ قَالٌ':Predicate, #2: 2	هَجَرَ السُّوءَ
u'هجر قول':Added, #1: 1	هَجَرَ قَالَ
u'هَجْرٌ قول':Added, #1: 1	هَجْرِ الْقَوْلِ
u'هجر قَوْلٌ':Added, #1: 1	هَجْرِ الْقَوْلِ
u'هَجْرٌ قَوْلٌ':Added, #1: 1	هَجْرِ الْقَوْلِ
u'هجر كَافِرٌ':Added, #1: 1	هَجْرِ الْقَوْلِ
u'هَجْرٌ كَافِرٌ':Added, #1: 1	هَجْرِ الْكَافِرِ
u'هجر مُبْتَدِعٌ':Added, #1: 1	هَجْرِ الْكَافِرِ
u'هَجْرٌ مُبْتَدِعٌ':Added, #1: 1	هَجْرِ الْمُبْتَدِعِ
u'هجر مُسْلِمٌ':Added, #1: 1	هَجْرِ الْمُبْتَدِعِ
u'هجر مُسْلِمٌ':Added, #1: 1	هَجْرَ الْمُسْلِمِ
u'هَجْرٌ مُسْلِمٌ':Added, #1: 1	هَجْرِ الْمُسْلِمِ
u'هَجْرٌ مُسْلِمٌ':Added, #1: 1	هَجْرَ الْمُسْلِمِ
u'هجر مُسْلِمٌ':Added, #1: 1	هَجْرِ الْمُسْلِمِ
u'هَجْرٌ مُسْلِمٌ':Added, #3: 3	هَجْرُ الْمُسْلِمِ
u'هَجَرَ مَشْهُورٌ':Subject, #3: 3	هَجْرُ الْمُسْلِمِ
u'هجر مُضَافٌ':Added, #1: 1	هَجَرَ مَشْهُورَةُ
u'هَجْرٌ مُضَافٌ':Added, #1: 1	هَجْرِ الْمُضَافِ
u'هَجَرَ نَبِيٌّ':Subject, #1: 1	هَجْرِ الْمُضَافِ
u'هجر وَطَنٌ':Added, #1: 1	هَجَرَ النَّبِيُّ
u'هَجْرٌ وَطَنٌ':Added, #1: 1	هَجْرِ الْوَطَنِ
u'هَجَعَ قَوْمٌ':Subject, #1: 1	هَجْرِ الْوَطَنِ
u'هَجَعَ نَاسٌ':Subject, #1: 1	هَجَعَ الْقَوْمُ
u'هَجَمَ خُصُومٌ':Subject, #1: 1	هَجَعَ النّاسُ
u'هَجَمَ عَدُوٌّ':Subject, #1: 1	هَجَمَ الْخُصُومُ
u'هَجَمَ عَدُوٌّ':Subject, #1: 1	هَجَمَ عَدُوٌّ
u'هُجْنَةٌ مُسَاوِي':Added, #3: 3	هَجَمَ الْعَدُوُّ
u'هَجَنَ فَرَسٌ':Predicate, #1: 1	هُجْنَةِ مُسَاوِيهِ
u'هَجَنَ مُبَرِّدٌ':Subject, #1: 1	هَجَنَ فَرَسَ
u'هَجْوٌ فَاسِقٌ':Added, #1: 1	هَجَنَ الْمُبَرِّدُ
u'هَجْوٌ كَافِرٌ':Added, #1: 1	هَجْوِ الْفَاسِقِ
u'هَجْوٌ مُرْتَدٌّ':Added, #2: 2	هَجْوِ الْكَافِرِ
u'هَجْوٌ مُسْلِمٌ':Added, #1: 1	هَجْوُ الْمُرْتَدِّ
u'هَجْوٌ مُسْلِمٌ':Added, #1: 1	هَجْوَ الْمُسْلِمِ
u'هَجْوٌ مُسْلِمٌ':Added, #1: 1	هَجْوِ الْمُسْلِمِ
u'هُجُومٌ عَدُوٌّ':Added, #2: 2	هَجْوَ مُسْلِمٍ
u'هُجُومٌ عَدُوٌّ':Added, #1: 1	هُجُومَ الْعَدُوِّ
u'هُجُومٌ غَارَةٌ':Added, #3: 3	هُجُومُ الْعَدُوِّ
u'هُجُومٌ غير':Added, #1: 1	هُجُومِ غَارَةٍ
u'هُجُومٌ غَيْرٌ':Added, #1: 1	هُجُومَ الْغَيْرِ
u'هُجُومٌ كُفَّارٌ':Added, #1: 1	هُجُومَ الْغَيْرِ
u'هُجُومٌ لَيْلٌ':Added, #1: 1	هُجُومَ الْكُفَّارِ
u'هُجُومٌ نعمة':Added, #1: 1	هُجُومِ اللَّيْلِ
u'هُجُومٌ نِعْمَةٌ':Added, #1: 1	هُجُومِ نِعْمَةٍ
u'هَدْأَةٌ رِجْلٌ':Added, #1: 1	هُجُومِ نِعْمَةٍ
u'هَدْأَةٌ عِشَاءٌ':Added, #1: 1	هَدْأَةِ الرِّجْلِ
u'هَدْأَةٌ لَيْلٌ':Added, #1: 1	هَدْأَةِ الْعِشَاءِ
u'هَدَأَ قلب':Subject, #1: 1	هَدْأَةِ اللَّيْلِ
u'هَدَأَ قَلْبٌ':Subject, #1: 1	هَدَأَ الْقَلْبُ
u'هَدَأَ قَلْب':Subject, #1: 1	هَدَأَ الْقَلْبُ
u'هِدَايَةٌ اِبْنٌ':Added, #1: 1	هَدَأَ الْقَلْبُ
u'هِدَايَةٌ أقْرَبُ':Added, #1: 1	هِدَايَةِ ابْنِ
u'هِدَايَةٌ أُمَّةٌ':Added, #1: 1	هِدَايَةِ أَقْرَبِ
u'هِدَايَةٌ أُمَّةٌ':Added, #1: 1	هِدَايَةَ الْأُمَّةِ
u'هِدَايَةٌ حَنَفِيَّةٌ':Added, #1: 1	هِدَايَةُ الْأُمَّةِ
u'هِدَايَةٌ رَاكِبٌ':Added, #1: 1	هِدَايَةِ الْحَنَفِيَّةِ
u'هِدَايَةٌ رَبُّ':Added, #1: 1	هِدَايَةِ الرَّاكِبِ
u'هِدَايَةٌ رَبُّ':Added, #1: 1	هِدَايَةُ الرَّبِّ
u'هِدَايَةٌ زَيْدٌ':Added, #1: 1	هِدَايَةِ الرَّبِّ
u'هِدَايَةٌ سَبِيلٌ':Added, #1: 1	هِدَايَةَ زَيْدِ
u'هِدَايَةٌ طَرِيقٌ':Added, #1: 1	هِدَايَةَ سَبِيلِ
u'هِدَايَةٌ مُرِيدٌ':Added, #1: 1	هِدَايَةَ الطَّرِيقِ
u'هَدَّدَ سُلْطَانٌ':Subject, #1: 1	هِدَايَةِ الْمُرِيدِ
u'هَدَّدَ مُودَعٌ':Subject, #1: 1	هَدَّدَ السُّلْطَانُ
u'هَدَرَ بَعيرٌ':Subject, #1: 1	هَدَّدَ الْمُودَعُ
u'هَدَرَ دَمٌ':Subject, #1: 1	هَدَرَ الْبَعِيرُ
u'هَدْرٌ دَمٌ':Added, #2: 2	هَدَرَ دَمُهُ
u'هَدَرَ شَرَابٌ':Subject, #1: 1	هَدْرَ دَمِهِ
u'هَدْرٌ عين':Added, #1: 1	هَدَرَ الشَّرَابُ
u'هَدْرٌ عَيْنٌ':Added, #1: 1	هَدْرَ الْعَيْنِ
u'هَدْرٌ عَيْن':Added, #1: 1	هَدْرَ الْعَيْنِ
u'هَدَرٌ فِعْلٌ':Added, #1: 1	هَدْرَ الْعَيْنِ
u'هَدَرَ قَتِيلٌ':Subject, #1: 1	هَدَرِ فِعْلِ
u'هَدَرَ مُوجِبٌ':Subject, #1: 1	هَدَرَ الْقَتِيلُ
u'هَدَرَ نِصْفٌ':Predicate, #1: 1	هَدَرَ مُوجِبُهُ
u'هَدْمٌ أبْنيَةٌ':Added, #1: 1	هَدَرَ نِصْفَ
u'هَدَمَ أَجْنَبِيٌّ':Subject, #1: 1	هَدْمُ الْأَبْنِيَةِ
u'هَدَمَ إِسْلامٌ':Subject, #1: 1	هَدَمَ أَجْنَبِيٌّ
u'هَدْمٌ إِسْلامٌ':Added, #3: 3	هَدَمَ الْإِسْلَامُ
u'هَدْمٌ إِسْلامٌ':Added, #1: 1	هَدْمُ الْإِسْلَامِ
u'هَدْمٌ أَنْقَاضٌ':Added, #7: 7	هَدْمِ الْإِسْلَامِ
u'هَدَمَ أهْلٌ':Subject, #2: 2	هَدْمِ الْأَنْقَاضِ
u'هَدْمٌ أَوَّلُ':Added, #1: 1	هَدَمَ أَهْلُ
u'هَدْمٌ بَابٌ':Added, #1: 1	هَدْمُ الْأَوَّلِ
u'هَدَمَ بِنَاءٌ':Predicate, #1: 1	هَدْمِ الْبَابِ
u'هَدْمٌ بِنَاءٌ':Added, #5: 5	هَدَمَ الْبِنَاءَ
u'هَدْمٌ بِنَاءٌ':Added, #1: 1	هَدْمُ الْبِنَاءِ
u'هَدْمٌ بِنَاءٌ':Added, #1: 1	هَدْمَ بِنَاءِ
u'هَدْمٌ بِنَاءٌ':Added, #1: 1	هَدْمُ بِنَاءٍ
u'هَدْمٌ بِنَاءٌ':Added, #3: 3	هَدْمَ الْبِنَاءِ
u'هَدَمَ بُنْيانٌ':Predicate, #4: 4	هَدْمِ الْبِنَاءِ
u'هَدْمٌ بِئْرٌ':Added, #1: 1	هَدَمَ بُنْيَانَ
u'هَدَمَ ثَلاثُ':Predicate, #1: 1	هَدْمِ الْبِئْرِ
u'هَدْمٌ جَانِبٌ':Added, #1: 1	هَدَمَ الثَّلَاثَ
u'هَدَمَ جِدار':Predicate, #1: 1	هَدْمِ جَانِبِ
u'هَدْمٌ جِدار':Added, #5: 5	هَدَمَ جِدَارَ
u'هَدَمَ جَمِيع':Predicate, #2: 2	هَدْمِ جِدَارِ
u'هَدَمَ حائِطٌ':Predicate, #1: 1	هَدَمَ الْجَمِيعَ
u'هَدَمَ حائِطٌ':Predicate, #1: 1	هَدَمَ الْحَائِطَ
u'هَدَمَ حائِطٌ':Subject, #1: 1	هَدَمَ حَائِطَ
u'هَدْمٌ حائِطٌ':Added, #1: 1	هَدَمَ حَائِطُ
u'هَدْمٌ حائِطٌ':Added, #1: 1	هَدْمَ الْحَائِطِ
u'هَدْمٌ حائِطٌ':Added, #1: 1	هَدْمِ حَائِطِ
u'هَدْمٌ حائِطٌ':Added, #3: 3	هَدْمِ الْحَائِطِ
u'هَدَمَ دَارٌ':Predicate, #3: 3	هَدْمِ حَائِطِهِ
u'هَدَمَ دَارٌ':Predicate, #1: 1	هَدَمَ الدَّارَ
u'هَدْمٌ دَارٌ':Added, #1: 1	هَدَمَ دَارَ
u'هَدْمٌ دَارٌ':Added, #1: 1	هَدْمَ دَارِ
u'هَدْمٌ دَارٌ':Added, #1: 1	هَدْمَ دَارِهِ
u'هَدْمٌ دَليلٌ':Added, #2: 2	هَدْمُ الدَّارِ
u'هَدْمٌ دَليلٌ':Added, #1: 1	هَدْمِ الدَّلِيلِ
u'هَدْمٌ دِينٌ':Added, #1: 1	هَدْمِ دَلِيلِ
u'هَدَمَ رَجُلٌ':Subject, #1: 1	هَدْمِ الدِّينِ
u'هَدَمَ رَجُلٌ':Subject, #1: 1	هَدَمَ الرَّجُلُ
u'هَدْمٌ زَوْجٌ':Added, #3: 3	هَدَمَ رَجُلٌ
u'هَدْمٌ زَوْجٌ':Added, #1: 1	هَدْمُ الزَّوْجِ
u'هَدَمَ سُفْلٌ':Predicate, #1: 1	هَدْمِ الزَّوْجِ
u'هَدْمٌ سَقْفٌ':Added, #1: 1	هَدَمَ السُّفْلَ
u'هَدْمٌ سورٌ':Added, #3: 3	هَدْمِ السَّقْفِ
u'هَدْمٌ سورٌ':Added, #1: 1	هَدْمِ سُوَرِ
u'هَدْمٌ شَرِيعَةٌ':Added, #2: 2	هَدْمَ سُورٍ
u'هَدْمٌ شَرِيعَةٌ':Added, #1: 1	هَدْمَ الشَّرِيعَةِ
u'هَدْمٌ شَرِيكٌ':Added, #1: 1	هَدْمُ الشَّرِيعَةِ
u'هَدَمَ شِقٌّ':Predicate, #1: 1	هَدْمُ الشَّرِيكِ
u'هَدْمٌ شَيْءٌ':Added, #1: 1	هَدَمَ الشِّقَّ
u'هَدْمٌ صَاحِبٌ':Added, #2: 2	هَدْمِ شَيْءٍ
u'هَدْمٌ صَنِيعٌ':Added, #1: 1	هَدْمِ صَاحِبِ
u'هَدْمٌ طَاغِي':Added, #1: 1	هَدْمُ الصَّنِيعِ
u'هَدَمَ طَائِفٌ':Predicate, #2: 2	هَدْمِ الطّاغِيَةِ
u'هَدَمَ عُمَرٌ':Subject, #1: 1	هَدَمَ طَائِفَةً
u'هَدْمٌ عَمَلٌ':Added, #1: 1	هَدَمَ عُمَرُ
u'هَدْمٌ قَدِيمٌ':Added, #1: 1	هَدْمَ عَمَلٍ
u'هَدْمٌ كعبة':Added, #1: 1	هَدْمِ الْقَدِيمَةِ
u'هَدْمٌ كَعْبَةٌ':Added, #1: 1	هَدْمَ الْكَعْبَةِ
u'هَدْمٌ كَلاَمٌ':Added, #1: 1	هَدْمَ الْكَعْبَةِ
u'هَدْمٌ كَنَائِسُ':Added, #1: 1	هَدْمِ كَلَامِ
u'هَدْمٌ كَنَائِسُ':Added, #1: 1	هَدْمِ الْكَنَائِسِ
u'هَدْمٌ لاَتٌ':Added, #1: 1	هَدْمَ كَنَائِسِ
u'هَدَمَ مُتْعَةٌ':Predicate, #1: 1	هَدْمِ اللّاتِ
u'هَدْمٌ مَذْهَبٌ':Added, #2: 2	هَدَمَ الْمُتْعَةَ
u'هَدْمٌ مَذْهَبٌ':Added, #1: 1	هَدْمِ الْمَذْهَبِ
u'هَدْمٌ مَذْهَبٌ':Added, #1: 1	هَدْمُ مَذْهَبِ
u'هَدَمَ مُسْتَأْجِرٌ':Subject, #2: 2	هَدْمِ مَذْهَبِ
u'هَدْمٌ مُسْتَأْجِرٌ':Added, #1: 1	هَدَمَ الْمُسْتَأْجِرُ
u'هَدْمٌ مَسْجِدٌ':Added, #1: 1	هَدْمِ الْمُسْتَأْجِرِ
u'هَدْمٌ مَسْجِدٌ':Added, #1: 1	هَدْمَ مَسْجِدٍ
u'هَدْمٌ مَسْجِدٌ':Added, #1: 1	هَدْمُ مَسْجِدٍ
u'هَدَمَ مِلْكٌ':Predicate, #2: 2	هَدْمُ الْمَسْجِدِ
u'هَدْمٌ مَوْجُودٌ':Added, #1: 1	هَدَمَ مِلْكَ
u'هَدْمٌ نَصِيبٌ':Added, #3: 3	هَدْمِ الْمَوْجُودِ
u'هَدَمَ نكاح':Predicate, #2: 2	هَدْمِ نَصِيبِهِ
u'هَدَمَ نِكَاحٌ':Predicate, #1: 1	هَدَمَ نِكَاحَ
u'هَدْمٌ هَدْمٌ':Added, #1: 1	هَدَمَ نِكَاحَ
u'هَدَمَ واحد':Subject, #1: 1	هَدْمُ الْهَدْمِ
u'هَدَمَ وَاحِدٌ':Subject, #1: 1	هَدَمَ وَاحِدٌ
u'هَدَمَ وَاقِعٌ':Predicate, #1: 1	هَدَمَ وَاحِدٌ
u'هُدُوءٌ أَصْوَاتٌ':Added, #1: 1	هَدَمَ الْوَاقِعَ
u'هُدُوءٌ ريحٌ':Added, #1: 1	هُدُوءُ الْأَصْوَاتِ
u'هَدْيٌ أَصْحَابٌ':Added, #1: 1	هُدُوءِ الرِّيحِ
u'هَدَى أُمَّةٌ':Predicate, #1: 1	هَدْيِ أَصْحَابِهِ
u'هَدْيٌ بدن':Added, #1: 1	هَدَى الْأُمَّةَ
u'هَدْيٌ بُدْنٌ':Added, #1: 1	هَدْيِ الْبُدْنِ
u'هَدْيٌ بدنة':Added, #1: 1	هَدْيِ الْبُدْنِ
u'هَدْيٌ بدنة':Added, #1: 1	هَدْيَ بَدَنَةٍ
u'هَدْيٌ تَطَوُّعٌ':Added, #2: 2	هَدْيُ بَدَنَةٍ
u'هَدْيٌ تَطَوُّعٌ':Added, #20: 20	هَدْيِ التَّطَوُّعِ
u'هَدْيٌ تَطَوُّعٌ':Added, #5: 5	هَدْيُ التَّطَوُّعِ
u'هَدْيٌ تَمَتُّعٌ':Added, #7: 7	هَدْيَ التَّطَوُّعِ
u'هَدْيٌ تَمَتُّعٌ':Added, #1: 1	هَدْيُ التَّمَتُّعِ
u'هَدْيٌ جَزَاءٌ':Added, #3: 3	هَدْيِ التَّمَتُّعِ
u'هَدْيٌ جَزَاءٌ':Added, #1: 1	هَدْي جَزَاءِ
u'هَدْيٌ حُرٌّ':Added, #1: 1	هَدْيَ جَزَاءِ
u'هَدَى خلق':Predicate, #1: 1	هَدْيِ الْحُرِّ
u'هَدْيٌ خلق':Added, #1: 1	هَدَى خَلَقَ
u'هَدْيٌ خَلْقٌ':Added, #1: 1	هَدْيُ الْخَلْقِ
u'هَدْيٌ رَجُلٌ':Added, #1: 1	هَدْيُ الْخَلْقِ
u'هَدْيٌ رَجُلٌ':Added, #1: 1	هَدْيِ الرَّجُلِ
u'هَدْيٌ رَسُولٌ':Added, #1: 1	هَدْيَ رَجُلٍ
u'هَدْيٌ شَاةٌ':Added, #7: 7	هَدْيِ رَسُولِ
u'هَدْيٌ شُكْرٌ':Added, #1: 1	هَدْيَ شَاةٍ
u'هَدْيٌ صَاحِبٌ':Added, #1: 1	هَدْيُ شُكْرٍ
u'هَدْيٌ صَاحِبٌ':Added, #1: 1	هَدْيَ صَاحِبِهِ
u'هَدْيٌ فُلاَنٌ':Added, #1: 1	هَدْيِ صَاحِبِهِ
u'هَدْيٌ فَوَاتٌ':Added, #1: 1	هَدْيُ فُلَانٍ
u'هَدْيٌ قِرَانٌ':Added, #1: 1	هَدْيُ الْفَوَاتِ
u'هَدْيٌ قِرَانٌ':Added, #1: 1	هَدْيَ الْقِرَانِ
u'هَدْيٌ مَتَاعٌ':Added, #1: 1	هَدْيُ الْقِرَانِ
u'هَدْيٌ مُتْعَةٌ':Added, #1: 1	هَدْيِ مَتَاعِهِ
u'هَدْيٌ مُتْعَةٌ':Added, #1: 1	هَدْيُ مُتْعَةٍ
u'هَدْيٌ مُتْعَةٌ':Added, #30: 30	هَدْيِ الْمُتْعَةِ
u'هَدْيٌ مُتْعَةٌ':Added, #4: 4	هَدْيَ مُتْعَةٍ
u'هَدْيٌ مُتْعَةٌ':Added, #5: 5	هَدْيُ الْمُتْعَةِ
u'هَدْيٌ مُحَمَّدٌ':Added, #7: 7	هَدْيَ الْمُتْعَةِ
u'هَدْيٌ مساكين':Added, #5: 5	هَدْيُ مُحَمَّدٍ
u'هَدْيٌ نَبِيٌّ':Added, #1: 1	هَدْيَ الْمَسَاكِينِ
u'هَدْيٌ نَبِيٌّ':Added, #1: 1	هَدْيُ النَّبِيِّ
u'هَدْيٌ نَبِيٌّ':Added, #2: 2	هَدْيَ النَّبِيِّ
u'هَدْيٌ نذر':Added, #2: 2	هَدْيِ النَّبِيِّ
u'هَدْيٌ نَذْرٌ':Added, #1: 1	هَدْيَ نَذْرِ
u'هَدْيٌ وَاجِبٌ':Added, #1: 1	هَدْيَ نَذْرِ
u'هَذَّبَ كَلاَمٌ':Predicate, #1: 1	هَدْيِ الْوَاجِبِ
u'هَذْرٌ مُتَكَلِّمٌ':Added, #1: 1	هَذَّبَ كَلَامَ
u'هَذَيَانٌ مَرِيضٌ':Added, #1: 1	هَذْرِ الْمُتَكَلِّمِ
u'هَرَبَ اِبْنٌ':Subject, #1: 1	هَذَيَانُ الْمَرِيضِ
u'هَرَبَ أَجِيرٌ':Subject, #1: 1	هَرَبَ ابْنُ
u'هَرَبَ أهْلٌ':Subject, #2: 2	هَرَبَ الْأَجِيرُ
u'هَرَبَ بَعْضٌ':Subject, #1: 1	هَرَبَ أَهْلُ
u'هَرَبَ جَمَّالٌ':Subject, #2: 2	هَرَبَ بَعْضُ
u'هَرَبَ حَمَّالٌ':Subject, #4: 4	هَرَبَ الْجَمَّالُ
u'هَرَبَ ذِمِّيٌّ':Subject, #1: 1	هَرَبَ الْحَمَّالُ
u'هَرَبَ رَجُلٌ':Subject, #1: 1	هَرَبَ الذِّمِّيُّ
u'هَرَبَ سَيِّدٌ':Subject, #1: 1	هَرَبَ رَجُلٌ
u'هَرَبَ شَيْطَانٌ':Subject, #2: 2	هَرَبَ السَّيِّدُ
u'هَرَبَ عَامِلٌ':Subject, #2: 2	هَرَبَ الشَّيْطَانُ
u'هَرَبَ عَبْدٌ':Subject, #5: 5	هَرَبَ الْعَامِلُ
u'هَرَبَ عَبْدٌ':Subject, #1: 1	هَرَبَ عَبْدٌ
u'هَرَبَ عَبِيدٌ':Subject, #2: 2	هَرَبَ الْعَبْدُ
u'هَرَبَ غَرِيمٌ':Subject, #1: 1	هَرَبَ عَبِيدُهُ
u'هَرَبَ غَرِيمٌ':Subject, #1: 1	هَرَبَ غَرِيمُهُ
u'هَرَبَ مَالِكٌ':Subject, #2: 2	هَرَبَ الْغَرِيمُ
u'هَرَبَ مَطْلُوبٌ':Subject, #1: 1	هَرَبَ الْمَالِكُ
u'هَرَبَ نَاسٌ':Subject, #2: 2	هَرَبَ الْمَطْلُوبُ
u'هَرَبَ وَتَرٌ':Predicate, #1: 1	هَرَبَ النَّاسُ
u'هَرَقَ اِبْنٌ':Subject, #1: 1	هَرَبَ وَتَرَكَ
u'هُرُوبٌ ولد':Added, #1: 1	هَرَقَ ابْنُ
u'هُرُوبٌ وَلَدٌ':Added, #1: 1	هُرُوبَ الْوَلَدِ
u'هزال جَارِي':Added, #1: 1	هُرُوبَ الْوَلَدِ
u'هُزَالٌ جَارِي':Added, #1: 1	هُزَالُ الْجَارِيَةِ
u'هزال جَارِيَةٌ':Added, #1: 1	هُزَالُ الْجَارِيَةِ
u'هُزَالٌ جَارِيَةٌ':Added, #1: 1	هُزَالُ الْجَارِيَةِ
u'هزال رَقيقٌ':Added, #1: 1	هُزَالُ الْجَارِيَةِ
u'هزال رَقيق':Added, #1: 1	هُزَالَ الرَّقِيقِ
u'هُزَالٌ رَقيقٌ':Added, #1: 1	هُزَالَ الرَّقِيقِ
u'هُزَالٌ رَقيق':Added, #1: 1	هُزَالَ الرَّقِيقِ
u'هَزْلٌ إيقَاعٌ':Added, #1: 1	هُزَالَ الرَّقِيقِ
u'هَزَلَ حَيَوَانٌ':Subject, #1: 1	هَزْلُ إيقَاعِ
u'هَزْلٌ طَلاَقٌ':Added, #1: 1	هَزَلَ الْحَيَوَانُ
u'هَزْلٌ عتق':Added, #1: 1	هَزْلَ الطَّلَاقِ
u'هَزْلٌ عِتْقٌ':Added, #1: 1	هَزْلَ الْعِتْقِ
u'هَزِلَ لَحْمٌ':Subject, #1: 1	هَزْلَ الْعِتْقِ
u'هَزْلٌ نكاح':Added, #1: 1	هَزِلَ لَحْمُهُ
u'هَزْلٌ نِكَاحٌ':Added, #1: 1	هَزْلَ النِّكَاحِ
u'هَزَمَ أحْزَابٌ':Predicate, #1: 1	هَزْلَ النِّكَاحِ
u'هَزَمَ أهْلٌ':Subject, #1: 1	هَزَمَ الْأَحْزَابَ
u'هَزَمَ جَيْشٌ':Predicate, #1: 1	هَزَمَ أَهْلُ
u'هَزَمَ خَالِدٌ':Subject, #1: 1	هَزَمَ جَيْشَ
u'هَزَمَ طَلْحٌ':Predicate, #1: 1	هَزَمَ خَالِدُ
u'هَزَمَ طلحة':Predicate, #1: 1	هَزَمَ طَلْحَةَ
u'هَزَمَ مُشْرِك':Predicate, #1: 1	هَزَمَ طَلْحَةَ
u'هَزِيمَةٌ قَوْمٌ':Added, #1: 1	هَزَمَ الْمُشْرِكِينَ
u'هَزِيمَةٌ قَوْمٌ':Added, #1: 1	هَزِيمَةُ الْقَوْمِ
u'هَشَّمَ إِبْرِيقٌ':Predicate, #1: 1	هَزِيمَةِ الْقَوْمِ
u'هَشَّمَ بَعْضٌ':Predicate, #1: 1	هَشَّمَ إبْرِيقَ
u'هَشَمَ ثَرِيدٌ':Predicate, #1: 1	هَشَّمَ بَعْضَ
u'هَضْبَةٌ نَظَرٌ':Added, #2: 2	هَشَمَ الثّرِيدَ
u'هضم طعام':Added, #1: 1	هَضْبَةِ النّظَرِ
u'هَضْمٌ طعام':Added, #1: 1	هَضْمَ الطَّعَامِ
u'هضم طَعَامٌ':Added, #1: 1	هَضْمَ الطَّعَامِ
u'هَضْمٌ طَعَامٌ':Added, #1: 1	هَضْمَ الطَّعَامِ
u'هضم طعام':Added, #1: 1	هَضْمَ الطَّعَامِ
u'هَضْمٌ طعام':Added, #2: 2	هَضْمِ الطَّعَامِ
u'هضم طَعَامٌ':Added, #2: 2	هَضْمِ الطَّعَامِ
u'هَضْمٌ طَعَامٌ':Added, #2: 2	هَضْمِ الطَّعَامِ
u'هضم غِذَاءٌ':Added, #2: 2	هَضْمِ الطَّعَامِ
u'هَضْمٌ غِذَاءٌ':Added, #1: 1	هَضْمُ الْغِذَاءِ
u'هضم نَفْسٌ':Added, #1: 1	هَضْمُ الْغِذَاءِ
u'هَضْمٌ نَفْسٌ':Added, #1: 1	هَضْمِ النَّفْسِ
u'هَفْوَةٌ خَاطِرٌ':Added, #1: 1	هَضْمِ النَّفْسِ
u'هَفْوَةٌ عَالِمٌ':Added, #1: 1	هَفْوَةَ الْخَاطِرِ
u'هَفْوَةٌ مُسْلِمٌ':Added, #1: 1	هَفْوَةِ عَالِمٍ
u'هلاك دَيْنٌ':Added, #1: 1	هَفْوَةَ مُسْلِمٍ
u'هَلاَكٌ دَيْنٌ':Added, #1: 1	هَلاَكِ الدَّيْنِ
u'هلاك مَالٌ':Added, #1: 1	هَلاَكِ الدَّيْنِ
u'هلاك مَالٌ':Added, #1: 1	هَلاَكَ الْمَالِ
u'هَلاَكٌ مَالٌ':Added, #1: 1	هَلاَكُ الْمَالِ
u'هَلاَكٌ مَالٌ':Added, #1: 1	هَلاَكَ الْمَالِ
u'هِلاَلٌ آخِرُ':Added, #1: 1	هَلاَكُ الْمَالِ
u'هِلاَلٌ شَوَّالٌ':Added, #1: 1	هِلاَلَ آخِرِ
u'هِلاَلٌ فِطْرٌ':Added, #1: 1	هِلاَلُ شَوَّالٍ
u'هِلاَلٌ فِطْرٌ':Added, #1: 1	هِلاَلَ الْفِطْرِ
u'هِلاَلٌ مُحَرَّمٌ':Added, #3: 3	هِلاَلِ الْفِطْرِ
u'هِلاَلٌ مُحَرَّمٌ':Added, #1: 1	هِلاَلَ الْمُحَرَّمِ
u'هَلَّ بَارِحٌ':Predicate, #1: 1	هِلاَلِ الْمُحَرَّمِ
u'هَلَّ حاجٌّ':Subject, #1: 1	أَهَلَّ الْبَارِحَةَ
u'هَلَّ حَديثٌ':Subject, #1: 1	أَهَلَّ الْحَاجُّ
u'هَلَّ رَجُلٌ':Subject, #1: 1	أَهَلَّ الْحَدِيثُ
u'هَلَّ رَسُولٌ':Subject, #1: 1	أَهَلَّ الرَّجُلُ
u'هَلَّ شَهْرٌ':Subject, #19: 19	أَهَلَّ رَسُولُ
u'هَلَّ شَهْرٌ':Subject, #1: 1	هَلَّ الشَّهْرُ
u'هَلَّ شَهْرٌ':Subject, #3: 3	أَهَلَّ الشَّهْرُ
u'هَلَّ شَوَّالٌ':Subject, #3: 3	أَهَلَّ شَهْرٌ
u'هَلَّ شَوَّالٌ':Subject, #1: 1	أَهَلَّ شَوَّالٌ
u'هَلَكَ أَبٌ':Subject, #1: 1	هَلَّ شَوَّالٌ
u'هَلَكَ أَبْعَدُ':Subject, #2: 2	هَلَكَ الْأَبُ
u'هَلَكَ أَبْعَدُ':Subject, #1: 1	هَلَكَ الْأَبْعَدُ
u'هَلَكَ أحَدٌ':Subject, #2: 2	هَلَكَ الأَبْعَدُ
u'هَلَكَ أحَدٌ':Subject, #12: 12	هَلَكَ أَحَدُ
u'هَلَكَ أصل':Subject, #3: 3	هَلَكَ أَحَدٌ
u'هَلَكَ أًصْلٌ':Subject, #7: 7	هَلَكَ الْأَصْلُ
u'هَلَّ كَافِرٌ':Subject, #7: 7	هَلَكَ الْأَصْلُ
u'هَلَكَ أَكْثَرُ':Subject, #1: 1	أَهَلَّ كَافِرٌ
u'هَلَكَ ألف':Subject, #1: 1	هَلَكَ الْأَكْثَرُ
u'هَلَكَ ألْفٌ':Subject, #1: 1	هَلَكَ أَلْفُ
u'هَلَكَ أَلْفٌ':Subject, #1: 1	هَلَكَ أَلْفُ
u'هَلَكَ ألف':Subject, #1: 1	هَلَكَ أَلْفُ
u'هَلَكَ ألْفٌ':Subject, #9: 9	هَلَكَ الْأَلْفُ
u'هَلَكَ أَلْفٌ':Subject, #9: 9	هَلَكَ الْأَلْفُ
u'هَلَكَ اِمْرُؤٌ':Subject, #9: 9	هَلَكَ الْأَلْفُ
u'هَلَكَ أهْلٌ':Subject, #1: 1	هَلَكَ امْرُؤٌ
u'هَلَكَ أَوَّلُ':Subject, #1: 1	هَلَكَ أَهْلُهُ
u'هَلَكَ بَدَلٌ':Subject, #1: 1	هَلَكَ الْأَوّلُ
u'هَلَكَ بَطَلٌ':Predicate, #2: 2	هَلَكَ بَدَلُ
u'هَلَكَ بَعْضٌ':Subject, #1: 1	هَلَكَ بَطَلَ
u'هَلَكَ بَعْضٌ':Subject, #12: 12	هَلَكَ بَعْضُ
u'هَلَكَ بَعْضٌ':Subject, #3: 3	هَلَكَ بَعْضُهُ
u'هَلَكَ بَعيرٌ':Subject, #7: 7	هَلَكَ الْبَعْضُ
u'هَلَكَ ثَمَرٌ':Subject, #1: 1	هَلَكَ بَعِيرُهُ
u'هَلَكَ ثَمَنٌ':Subject, #3: 3	هَلَكَ الثَّمَرُ
u'هَلَكَ ثَوْبٌ':Subject, #12: 12	هَلَكَ الثَّمَنُ
u'هَلَكَ جِرَابٌ':Subject, #17: 17	هَلَكَ الثَّوْبُ
u'هَلَكَ جُزْءٌ':Subject, #1: 1	هَلَكَ الْجِرَابُ
u'هَلَكَ جلد':Subject, #1: 1	هَلَكَ جُزْءٌ
u'هَلَكَ جِلْدٌ':Subject, #1: 1	هَلَكَ الْجِلْدُ
u'هَلَكَ حاطِبٌ':Subject, #1: 1	هَلَكَ الْجِلْدُ
u'هَلَكَ حالٌ':Predicate, #1: 1	هَلَكَ حَاطِبٌ
u'هَلَكَ حالَةٌ':Predicate, #2: 2	هَلَكَ حَالَ
u'هَلَكَ حُرٌّ':Subject, #2: 2	هَلَكَ حَالَةَ
u'هَلَكَ حِصَّةٌ':Predicate, #1: 1	هَلَكَ الْحُرُّ
u'هَلَكَ حِصَّةٌ':Subject, #1: 1	هَلَكَ حِصَّةَ
u'هَلَكَ حُلِيٌّ':Subject, #1: 1	هَلَكَ حِصَّةُ
u'هَلَكَ حِمَارٌ':Subject, #1: 1	هَلَكَ الْحُلِيُّ
u'هَلَكَ حَيَوَانٌ':Subject, #1: 1	هَلَكَ حِمَارُهُ
u'هَلَكَ خَارِجٌ':Subject, #1: 1	هَلَكَ الْحَيَوَانُ
u'هَلَكَ خَمْسَةٌ':Predicate, #5: 5	هَلَكَ الْخَارِجُ
u'هَلَكَ دِرْهَمٌ':Subject, #1: 1	هَلَكَ خَمْسَةَ
u'هَلَكَ دِرْهَم':Subject, #1: 1	هَلَكَ دِرْهَمٌ
u'هَلَكَ دَيْنٌ':Subject, #1: 1	هَلَكَ دِرْهَمٌ
u'هَلَكَ ذَهَبٌ':Predicate, #1: 1	هَلَكَ الدَّيْنُ
u'هَلَكَ رَاهِنٌ':Subject, #8: 8	هَلَكَ ذَهَبَ
u'هَلَكَ رَبِيعَةٌ':Subject, #1: 1	هَلَكَ الرَّاهِنُ
u'هَلَكَ رَجُلٌ':Subject, #1: 1	هَلَكَ رَبِيعَةُ
u'هَلَكَ رَجُلٌ':Subject, #13: 13	هَلَكَ الرَّجُلُ
u'هَلَكَ رَهْنٌ':Subject, #2: 2	هَلَكَ رَجُلٌ
u'هَلَكَ رَهْنٌ':Subject, #107: 107	هَلَكَ الرَّهْنُ
u'هَلَكَ زَرْعٌ':Subject, #2: 2	هَلَكَ رَهْنُ
u'هَلَكَ زَمانٌ':Subject, #6: 6	هَلَكَ الزَّرْعُ
u'هَلَكَ سَرْجٌ':Subject, #1: 1	هَلَكَ زَمَانُ
u'هَلَكَ سقط':Predicate, #1: 1	هَلَكَ السَّرْجُ
u'هَلَكَ سَقَطٌ':Predicate, #1: 1	هَلَكَ سَقَطَ
u'هَلَكَ سَواءٌ':Subject, #1: 1	هَلَكَ سَقَطَ
u'هَلَكَ سَيِّدٌ':Subject, #1: 1	هَلَكَ سَوَاءٌ
u'هَلَكَ شَاةٌ':Subject, #2: 2	هَلَكَ السَّيِّدُ
u'هَلَكَ شَعِيرٌ':Subject, #1: 1	هَلَكَ شَاةٌ
u'هَلَكَ شَيْءٌ':Subject, #1: 1	هَلَكَ الشَّعِيرُ
u'هَلَكَ شَيْءٌ':Subject, #1: 1	هَلَكَ الشَّيْءُ
u'هَلَكَ صَبِيٌّ':Subject, #6: 6	هَلَكَ شَيْءٌ
u'هَلَكَ صداق':Subject, #2: 2	هَلَكَ الصَّبِيُّ
u'هَلَكَ صَدَاقٌ':Subject, #2: 2	هَلَكَ الصَّدَاقُ
u'هَلَكَ صَيْدٌ':Subject, #2: 2	هَلَكَ الصَّدَاقُ
u'هَلَكَ ضِمَادٌ':Subject, #1: 1	هَلَكَ الصَّيْدُ
u'هَلَكَ ضمار':Subject, #2: 2	هَلَكَ الضِّمَادُ
u'هَلَكَ ضَمِنٌ':Predicate, #2: 2	هَلَكَ الضّمَارُ
u'هَلَكَ طعام':Subject, #6: 6	هَلَكَ ضَمِنَ
u'هَلَكَ طَعَامٌ':Subject, #3: 3	هَلَكَ الطَّعَامُ
u'هَلَكَ ظاهِرٌ':Subject, #3: 3	هَلَكَ الطَّعَامُ
u'هَلَكَ عَبْدٌ':Subject, #1: 1	هَلَكَ الظَّاهِرُ
u'هَلَكَ عَبْدٌ':Subject, #2: 2	هَلَكَ عَبْدُ
u'هَلَكَ عَرَضٌ':Subject, #43: 43	هَلَكَ الْعَبْدُ
u'هَلَكَ عَرْضٌ':Subject, #1: 1	هَلَكَ الْعَرَضُ
u'هَلَكَ عِشْرُون':Predicate, #2: 2	هَلَكَ الْعَرْضُ
u'هَلَكَ عَفْوٌ':Subject, #2: 2	هَلَكَ عِشْرُونَ
u'هَلَكَ عِقْدٌ':Subject, #4: 4	هَلَكَ الْعَفْوُ
u'هَلَكَ عند':Predicate, #1: 1	هَلَكَ عِقْدٌ
u'هَلَكَ عِيَالٌ':Subject, #12: 12	هَلَكَ عِنْدَ
u'هَلَكَ عين':Subject, #1: 1	هَلَكَ الْعِيَالُ
u'هَلَكَ عَيْنٌ':Subject, #5: 5	هَلَكَ الْعَيْنُ
u'هَلَكَ عَيْن':Subject, #5: 5	هَلَكَ الْعَيْنُ
u'هَلَكَ غَصْبٌ':Subject, #5: 5	هَلَكَ الْعَيْنُ
u'هَلَكَ غُلاَمٌ':Subject, #3: 3	هَلَكَ الْغَصْبُ
u'هَلَكَ فِرَاخٌ':Subject, #3: 3	هَلَكَ الْغُلَامُ
u'هَلَكَ فَرَسٌ':Subject, #2: 2	هَلَكَ فِرَاخُ
u'هَلَكَ فَرَسٌ':Subject, #1: 1	هَلَكَ الْفَرَسُ
u'هَلَكَ فُسْطَاطٌ':Subject, #1: 1	هَلَكَ فَرَسُهُ
u'هَلَكَ فلان':Subject, #1: 1	هَلَكَ الْفُسْطَاطُ
u'هَلَكَ فلان':Subject, #1: 1	هَلَكَ عُبَيْدَةُ
u'هَلَكَ قَالٌ':Predicate, #1: 1	هَلَكَ عُثْمَانُ
u'هَلَكَ قَائِمٌ':Subject, #6: 6	هَلَكَ قَالَ
u'هَلَكَ قَرْنٌ':Subject, #2: 2	هَلَكَ الْقَائِمُ
u'هَلَكَ قَفِيز':Subject, #1: 1	هَلَكَ قَرْنٌ
u'هَلَكَ قُمَاشٌ':Subject, #1: 1	هَلَكَ الْقَفِيزُ
u'هَلَكَ قَيْصَرٌ':Subject, #1: 1	هَلَكَ الْقُمَاشُ
u'هَلَكَ كُرَاعٌ':Subject, #2: 2	هَلَكَ قَيْصَرُ
u'هَلَكَ كلاب':Subject, #2: 2	هَلَكَ الْكُرَاعُ
u'هَلَكَ كِلاَبٌ':Subject, #1: 1	هَلَكَ كِلَابٌ
u'هَلَكَ لبن':Subject, #1: 1	هَلَكَ كِلَابٌ
u'هَلَكَ لَبَنٌ':Subject, #1: 1	هَلَكَ اللَّبَنُ
u'هَلَكَ مَاعِزٌ':Subject, #1: 1	هَلَكَ اللَّبَنُ
u'هَلَكَ مَالٌ':Subject, #2: 2	هَلَكَ مَاعِزٌ
u'هَلَكَ مَالٌ':Subject, #17: 17	هَلَكَ مَالُ
u'هَلَكَ مَالٌ':Subject, #3: 3	هَلَكَ مَالُهُ
u'هَلَكَ مَالِكٌ':Subject, #52: 52	هَلَكَ الْمَالُ
u'هَلَكَ مَبِيعٌ':Subject, #2: 2	هَلَكَ الْمَالِكُ
u'هَلَكَ مَتَاعٌ':Subject, #56: 56	هَلَكَ الْمَبِيعُ
u'هَلَكَ مَذْبُوحٌ':Subject, #5: 5	هَلَكَ الْمَتَاعُ
u'هَلَكَ مُرْتَهِنٌ':Subject, #2: 2	هَلَكَ الْمَذْبُوحُ
u'هَلَكَ مَرْهُونٌ':Subject, #1: 1	هَلَكَ الْمُرْتَهِنُ
u'هَلَكَ مُشْطٌ':Subject, #4: 4	هَلَكَ الْمَرْهُونُ
u'هَلَكَ مَغْصُوب':Subject, #1: 1	هَلَكَ الْمُشْطُ
u'هَلَكَ مَقْبُوضٌ':Subject, #6: 6	هَلَكَ الْمَغْصُوبُ
u'هَلَكَ مَلِكٌ':Subject, #9: 9	هَلَكَ الْمَقْبُوضُ
u'هَلَكَ مَلِكٌ':Subject, #1: 1	هَلَكَ الْمَلِكُ
u'هَلَكَ نَاسٌ':Subject, #1: 1	هَلَكَ مَلِكٌ
u'هَلَكَ نَاسٌ':Subject, #1: 1	هَلَكَ النّاسُ
u'هَلَكَ نَخْلٌ':Subject, #8: 8	هَلَكَ النَّاسُ
u'هَلَكَ نصاب':Subject, #3: 3	هَلَكَ النَّخْلُ
u'هَلَكَ نِصَابٌ':Subject, #1: 1	هَلَكَ النِّصَابُ
u'هَلَكَ نِصْفٌ':Subject, #1: 1	هَلَكَ النِّصَابُ
u'هَلَكَ نِصْفٌ':Subject, #1: 1	هَلَكَ النِّصْفُ
u'هَلَكَ نِصْفٌ':Subject, #1: 1	هَلَكَ نِصْفُهُ
u'هَلَكَ نَصِيبٌ':Subject, #3: 3	هَلَكَ نِصْفُ
u'هَلَكَ نَمَاءٌ':Subject, #7: 7	هَلَكَ نَصِيبُ
u'هَلَكَ هَاشِمٌ':Subject, #1: 1	هَلَكَ النَّمَاءُ
u'هَلَكَ هَدْيٌ':Subject, #1: 1	هَلَكَ هَاشِمُ
u'هَلَكَ هَدْيٌ':Subject, #1: 1	هَلَكَ الْهَدْيُ
u'هَلَكَ هَلَكٌ':Predicate, #1: 1	هَلَكَ هَدْيُهُ
u'هَلَكَ واحد':Subject, #22: 22	هَلَكَ هَلَكَ
u'هَلَكَ وَاحِدٌ':Subject, #2: 2	هَلَكَ وَاحِدٌ
u'هَلَكَ وَالِدٌ':Subject, #2: 2	هَلَكَ وَاحِدٌ
u'هَلَكَ وَتَرٌ':Predicate, #2: 2	هَلَكَ الْوَالِدُ
u'هَلَكَ وَجَبٌ':Predicate, #18: 18	هَلَكَ وَتَرَكَ
u'هَلَكَ ولد':Subject, #2: 2	هَلَكَ وَجَبَ
u'هَلَكَ وَلَدٌ':Subject, #17: 17	هَلَكَ الْوَلَدُ
u'هَلَكَ وَلِيدٌ':Subject, #17: 17	هَلَكَ الْوَلَدُ
u'هَلَكَ يَدٌ':Subject, #1: 1	هَلَكَ الْوَلِيدُ
u'هَلَّ لَيْلٌ':Predicate, #1: 1	هَلَكَ يَدُ
u'هَلَّ مَأْمُورٌ':Subject, #1: 1	أَهَلَّ لَيْلَةَ
u'هَلَّ نَاسٌ':Subject, #1: 1	أَهَلَّ الْمَأْمُورُ
u'هَلَّ نَبِيٌّ':Subject, #2: 2	أَهَلَّ النَّاسُ
u'هَلَّ هِلاَلٌ':Subject, #2: 2	أَهَلَّ النَّبِيُّ
u'هَلَّ هِلاَلٌ':Subject, #10: 10	أَهَلَّ الْهِلَالُ
u'هَلَّ هِلاَلٌ':Subject, #1: 1	أَهَلَّ هِلَالُ
u'هَلَّ هِلاَلٌ':Subject, #1: 1	هَلَّ الْهِلَالُ
u'هَمَّ أحَدٌ':Subject, #2: 2	أَهَلَّ هِلاَلُ
u'هَمَّ أَصْحَابٌ':Subject, #1: 1	هَمَّ أَحَدُ
u'هَمَّ بَعْضٌ':Subject, #1: 1	هَمَّ أَصْحَابُ
u'هَمَّ ذَهَبٌ':Predicate, #1: 1	هَمَّ بَعْضُ
u'هَمَّ رِجَالٌ':Subject, #1: 1	هَمَّ ذَهَبَ
u'هَمَّ رَسُولٌ':Subject, #1: 1	هَمَّ رِجَالٌ
u'هَمَزَ ألف':Predicate, #2: 2	هَمَّ رَسُولُ
u'همزة أصل':Added, #1: 1	هَمَزَ الْأَلِفَ
u'همزة أًصْلٌ':Added, #1: 1	هَمْزَةِ الْأَصْلِ
u'هَمْزَةٌ أصل':Added, #1: 1	هَمْزَةِ الْأَصْلِ
u'هَمْزَةٌ أًصْلٌ':Added, #1: 1	هَمْزَةِ الْأَصْلِ
u'همزة جَلاَلَةٌ':Added, #1: 1	هَمْزَةِ الْأَصْلِ
u'هَمْزَةٌ جَلاَلَةٌ':Added, #2: 2	هَمْزَةَ الْجَلَالَةِ
u'همزة جمع':Added, #2: 2	هَمْزَةَ الْجَلَالَةِ
u'همزة جَمْعٌ':Added, #1: 1	هَمْزَةُ الْجَمْعِ
u'هَمْزَةٌ جمع':Added, #1: 1	هَمْزَةُ الْجَمْعِ
u'هَمْزَةٌ جَمْعٌ':Added, #1: 1	هَمْزَةُ الْجَمْعِ
u'همزة قَطْعٌ':Added, #1: 1	هَمْزَةُ الْجَمْعِ
u'هَمْزَةٌ قَطْعٌ':Added, #1: 1	هَمْزَةُ قَطْعٍ
u'همزة مَاءٌ':Added, #1: 1	هَمْزَةُ قَطْعٍ
u'هَمْزَةٌ مَاءٌ':Added, #1: 1	هَمْزَةُ الْمَاءِ
u'همزة مَفْتُوحٌ':Added, #1: 1	هَمْزَةُ الْمَاءِ
u'هَمْزَةٌ مَفْتُوحٌ':Added, #1: 1	هَمْزَةٍ مَفْتُوحَةٍ
u'همزة مَمْدُودٌ':Added, #1: 1	هَمْزَةٍ مَفْتُوحَةٍ
u'هَمْزَةٌ مَمْدُودٌ':Added, #1: 1	هَمْزَةٍ مَمْدُودَةٍ
u'همزة وصل':Added, #1: 1	هَمْزَةٍ مَمْدُودَةٍ
u'همزة وصل':Added, #1: 1	هَمْزَةَ الْوَصْلِ
u'همزة وَصْلٌ':Added, #1: 1	هَمْزَةِ الْوَصْلِ
u'همزة وَصْلٌ':Added, #1: 1	هَمْزَةَ الْوَصْلِ
u'هَمْزَةٌ وصل':Added, #1: 1	هَمْزَةِ الْوَصْلِ
u'هَمْزَةٌ وصل':Added, #1: 1	هَمْزَةَ الْوَصْلِ
u'هَمْزَةٌ وَصْلٌ':Added, #1: 1	هَمْزَةِ الْوَصْلِ
u'هَمْزَةٌ وَصْلٌ':Added, #1: 1	هَمْزَةَ الْوَصْلِ
u'همزة وَصْلٌ':Added, #1: 1	هَمْزَةِ الْوَصْلِ
u'هَمْزَةٌ وَصْلٌ':Added, #1: 1	هَمْزَةِ وَصْلٍ
u'همزة وصل':Added, #1: 1	هَمْزَةِ وَصْلٍ
u'همزة وَصْلٌ':Added, #2: 2	هَمْزَةُ الْوَصْلِ
u'هَمْزَةٌ وصل':Added, #2: 2	هَمْزَةُ الْوَصْلِ
u'هَمْزَةٌ وَصْلٌ':Added, #2: 2	هَمْزَةُ الْوَصْلِ
u'همزة وَصْلٌ':Added, #2: 2	هَمْزَةُ الْوَصْلِ
u'هَمْزَةٌ وَصْلٌ':Added, #3: 3	هَمْزَةُ وَصْلٍ
u'هَمَّ شافِعِيّ':Subject, #3: 3	هَمْزَةُ وَصْلٍ
u'هَمَّ عَبْدٌ':Subject, #1: 1	هَمَّ الشَّافِعِيُّ
u'هَمَّ عُمَرٌ':Subject, #1: 1	هَمَّ عَبْدٌ
u'هَمَّ فلان':Subject, #1: 1	هَمَّ عُمَرُ
u'هَمَّ قَوْمٌ':Subject, #1: 1	هَمَّ الشَّافِعِيُّ
u'هَمَّ مَاءٌ':Subject, #2: 2	هَمَّ قَوْمٌ
u'هُوَّةٌ بَاطِلٌ':Added, #1: 1	هَمَّ الْمَاءُ
u'هُوَّةٌ شَطَطٌ':Added, #1: 1	هُوَّةِ الْبَاطِلِ
u'هُوَّةٌ مُقَابَلٌ':Added, #1: 1	هُوَّةِ الشَّطَطِ
u'هُوَّةٌ مُقَابَلَةٌ':Added, #1: 1	هُوَّةِ مُقَابَلَةِ
u'هُوَّةٌ نَدَمٌ':Added, #1: 1	هُوَّةِ مُقَابَلَةِ
u'هَوْلٌ أَخْطَارٌ':Added, #1: 1	هُوَّةِ النَّدَمِ
u'هَوْلٌ مَصْرَعٌ':Added, #1: 1	هَوْلِ أَخْطَارِ
u'هَوْلٌ مَطْلَعٌ':Added, #1: 1	هَوْلُ مَصْرَعِهِ
u'هَوْلٌ مَنِيَّة':Added, #2: 2	هَوْلَ الْمَطْلَعِ
u'هَوْلٌ مَوْقِفٌ':Added, #1: 1	هَوْلَ الْمَنِيّاتِ
u'هَوْلٌ يَوْمٌ':Added, #1: 1	هَوْلَ الْمَوْقِفِ
u'هَوَى إمَامٌ':Subject, #1: 1	هَوْلِ يَوْمِ
u'هَوَى إمَامٌ':Subject, #1: 1	هَوَى الْإِمَامُ
u'هَوِيَ اِمْرَأَةٌ':Predicate, #1: 1	هَوَى إمَامُهُ
u'هَوَى مَسْبُوق':Subject, #1: 1	هَوِيَ امْرَأَةَ
u'هَوَى مَقْصُورٌ':Subject, #1: 1	هَوَى الْمَسْبُوقُ
u'هَوِيَ نَحْوٌ':Predicate, #1: 1	هَوَى مَقْصُورٌ
u'هَيَّأَ سَاحَةٌ':Predicate, #1: 1	أَهْوَى نَحْوَ
u'هَيْبَةٌ أَحادِيثُ':Added, #1: 1	هَيَّأَ السَّاحَةَ
u'هَيْبَةٌ زَلَلٌ':Added, #1: 1	هَيْبَةُ الْأَحَادِيثِ
u'هَيْبَةٌ شَرِيعَةٌ':Added, #1: 1	هَيْبَةُ الزَّلَلِ
u'هَيْبَةٌ عَلِيٌّ':Added, #1: 1	هَيْبَةِ الشَّرِيعَةِ
u'هَيْبَةٌ قَائِلٌ':Added, #1: 1	هَيْبَةِ عَلِيٍّ
u'هَيْبَةٌ قُدُومٌ':Added, #1: 1	هَيْبَةَ قَائِلِهِ
u'هَيْبَةٌ نَاسٌ':Added, #1: 1	هَيْبَةِ الْقُدُومِ
u'هَيَّجَ دَمٌ':Predicate, #2: 2	هَيْبَةُ النَّاسِ
u'هَيَّجَ طَائِرٌ':Predicate, #1: 1	هَيَّجَ الدَّمَ
u'هَيْجٌ فتنة':Added, #1: 1	هَيَّجَ الطَّائِرَ
u'هَيْجٌ فِتْنَةٌ':Added, #1: 1	هَيْجِ فِتْنَةٍ
u'هَيَّجَ مُصِيبٌ':Predicate, #1: 1	هَيْجِ فِتْنَةٍ
u'هَيَّجَ مُصِيبَةٌ':Predicate, #2: 2	هَيَّجَ الْمُصِيبَةَ
u'هَيْئَةٌ اِجْتِمَاعٌ':Added, #2: 2	هَيَّجَ الْمُصِيبَةَ
u'هَيْئَةٌ اِجْتِمَاعِيّ':Added, #1: 1	هَيْئَةُ اجْتِمَاعٍ
u'هَيْئَةٌ إِدَارَةٌ':Added, #1: 1	هَيْئَةٍ اجْتِمَاعِيَّةٍ
u'هَيْئَةٌ أَفْعَالٌ':Added, #1: 1	هَيْئَةُ إدَارَةِ
u'هَيْئَةٌ إمَامٌ':Added, #1: 1	هَيْئَةَ الْأَفْعَالِ
u'هَيْئَةٌ أَمْرٌ':Added, #1: 1	هَيْئَةِ الْإِمَامِ
u'هَيْئَةٌ إِناءٌ':Added, #2: 2	هَيْئَةَ الْأَمْرِ
u'هَيْئَةٌ إهَانَةٌ':Added, #1: 1	هَيْئَةِ الْإِنَاءِ
u'هَيْئَةٌ بدن':Added, #1: 1	هَيْئَةِ الْإِهَانَةِ
u'هَيْئَةٌ بَدَنٌ':Added, #2: 2	هَيْئَةَ الْبَدَنِ
u'هَيْئَةٌ بِنَاءٌ':Added, #2: 2	هَيْئَةَ الْبَدَنِ
u'هَيْئَةٌ تَوَاضُعٌ':Added, #1: 1	هَيْئَةِ الْبِنَاءِ
u'هَيْئَةٌ تَوَجُّهٌ':Added, #1: 1	هَيْئَةِ التَّوَاضُعِ
u'هَيْئَةٌ جُلُوسٌ':Added, #1: 1	هَيْئَةُ التَّوَجُّهِ
u'هَيْئَةٌ جُلُوسٌ':Added, #1: 1	هَيْئَةُ الْجُلُوسِ
u'هَيْئَةٌ جَمَاعَةٌ':Added, #1: 1	هَيْئَةِ الْجُلُوسِ
u'هَيْئَةٌ حَسَنٌ':Added, #5: 5	هَيْئَةِ الْجَمَاعَةِ
u'هَيْئَةٌ حَسَنَةٌ':Added, #1: 1	هَيْئَةٍ حَسَنَةٍ
u'هَيْئَةٌ حَلالٌ':Added, #1: 1	هَيْئَةٍ حَسَنَةٍ
u'هَيْئَةٌ خُرُوجٌ':Added, #1: 1	هَيْئَةُ الْحَلَالِ
u'هَيْئَةٌ خُسُوفٌ':Added, #1: 1	هَيْئَةِ الْخُرُوجِ
u'هَيْئَةٌ خُشُوعٌ':Added, #3: 3	هَيْئَةِ الْخُسُوفِ
u'هَيْئَةٌ خَطٌّ':Added, #1: 1	هَيْئَةَ الْخُشُوعِ
u'هَيْئَةٌ خَمْرٌ':Added, #2: 2	هَيْئَةِ الْخَطِّ
u'هَيْئَةٌ دَبِيبٌ':Added, #1: 1	هَيْئَةِ الْخَمْرِ
u'هَيْئَةٌ دفن':Added, #1: 1	هَيْئَةُ الدّبِيبِ
u'هَيْئَةٌ دَفْنٌ':Added, #2: 2	هَيْئَةِ الدَّفْنِ
u'هَيْئَةٌ رَاقِصٌ':Added, #2: 2	هَيْئَةِ الدَّفْنِ
u'هَيْئَةٌ رَاكِعٌ':Added, #1: 1	هَيْئَةِ الرَّاقِصِ
u'هَيْئَةٌ رَثٌّ':Added, #1: 1	هَيْئَةِ الرَّاكِعِ
u'هَيْئَةٌ رِجَالٌ':Added, #1: 1	هَيْئَةٍ رَثَّةٍ
u'هَيْئَةٌ رَجُلٌ':Added, #1: 1	هَيْئَةِ الرِّجَالِ
u'هَيْئَةٌ رَدِيئة':Added, #1: 1	هَيْئَةُ رَجُلٍ
u'هَيْئَةٌ رَقْصٌ':Added, #2: 2	هَيْئَةٍ رَدِيئَةٍ
u'هَيْئَةٌ زُهْدٌ':Added, #1: 1	هَيْئَةِ الرَّقْصِ
u'هَيْئَةٌ سَاكِنٌ':Added, #1: 1	هَيْئَةَ الزُّهْدِ
u'هَيْئَةٌ سبحة':Added, #1: 1	هَيْئَةِ السَّاكِنِ
u'هَيْئَةٌ سُبْحَةٌ':Added, #1: 1	هَيْئَةِ السُّبْحَةِ
u'هَيْئَةٌ سُجُودٌ':Added, #1: 1	هَيْئَةِ السُّبْحَةِ
u'هَيْئَةٌ سُجُودٌ':Added, #1: 1	هَيْئَةَ السُّجُودِ
u'هَيْئَةٌ سُجُودٌ':Added, #1: 1	هَيْئَةِ سُجُودِ
u'هَيْئَةٌ سَفَرٌ':Added, #3: 3	هَيْئَةِ السُّجُودِ
u'هَيْئَةٌ سَفَرٌ':Added, #2: 2	هَيْئَةُ السَّفَرِ
u'هَيْئَةٌ سَيْرٌ':Added, #2: 2	هَيْئَةِ السَّفَرِ
u'هَيْئَةٌ شَرْعِيٌّ':Added, #1: 1	هَيْئَةِ السَّيْرِ
u'هَيْئَةٌ شَيْخٌ':Added, #1: 1	هَيْئَةٍ شَرْعِيَّةٍ
u'هَيْئَةٌ صُفُوفٌ':Added, #1: 1	هَيْئَةِ شَيْخٍ
u'هَيْئَةٌ صَلاَةٌ':Added, #1: 1	هَيْئَةِ الصُّفُوفِ
u'هَيْئَةٌ صَلاَةٌ':Added, #1: 1	هَيْئَةِ صَلَاةِ
u'هَيْئَةٌ صَلاَةٌ':Added, #2: 2	هَيْئَةَ الصَّلَاةِ
u'هَيْئَةٌ صَنَوْبَرٌ':Added, #7: 7	هَيْئَةِ الصَّلَاةِ
u'هَيْئَةٌ صِيَاغَةٌ':Added, #1: 1	هَيْئَةِ الصَّنَوْبَرَةِ
u'هَيْئَةٌ طواف':Added, #1: 1	هَيْئَةَ الصِّيَاغَةِ
u'هَيْئَةٌ طَوَافٌ':Added, #1: 1	هَيْئَةَ الطَّوَافِ
u'هَيْئَةٌ عَدَدٌ':Added, #1: 1	هَيْئَةَ الطَّوَافِ
u'هَيْئَةٌ عَصِيرٌ':Added, #1: 1	هَيْئَةِ عَدَدِ
u'هَيْئَةٌ عَنْوَة':Added, #1: 1	هَيْئَةِ الْعَصِيرِ
u'هَيْئَةٌ غَرْزٌ':Added, #1: 1	هَيْئَةِ الْعَنْوَةِ
u'هَيْئَةٌ فِعْلٌ':Added, #1: 1	هَيْئَةِ الْغَرْزِ
u'هَيْئَةٌ فِعْلٌ':Added, #1: 1	هَيْئَةُ الْفِعْلِ
u'هَيْئَةٌ فقر':Added, #1: 1	هَيْئَةِ فِعْلِ
u'هَيْئَةٌ فَقْرٌ':Added, #1: 1	هَيْئَةِ الْفَقْرِ
u'هَيْئَةٌ قتل':Added, #1: 1	هَيْئَةِ الْفَقْرِ
u'هَيْئَةٌ قَتْلٌ':Added, #1: 1	هَيْئَةِ الْقَتْلِ
u'هَيْئَةٌ قِرَاءةٌ':Added, #1: 1	هَيْئَةِ الْقَتْلِ
u'هَيْئَةٌ قُعُودٌ':Added, #1: 1	هَيْئَةُ الْقِرَاءَةِ
u'هَيْئَةٌ قِيَاسٌ':Added, #1: 1	هَيْئَةُ الْقُعُودِ
u'هَيْئَةٌ لبس':Added, #1: 1	هَيْئَةِ الْقِيَاسِ
u'هَيْئَةٌ لُبْسٌ':Added, #1: 1	هَيْئَةِ اللُّبْسِ
u'هَيْئَةٌ لُؤْلُؤٌ':Added, #1: 1	هَيْئَةِ اللُّبْسِ
u'هَيْئَةٌ مَاءٌ':Added, #2: 2	هَيْئَةِ اللُّؤْلُؤِ
u'هَيْئَةٌ مِثْقَالٌ':Added, #1: 1	هَيْئَةِ الْمَاءِ
u'هَيْئَةٌ مُحْرِمٌ':Added, #1: 1	هَيْئَةِ الْمِثْقَالِ
u'هَيْئَةٌ مُحْرِمٌ':Added, #1: 1	هَيْئَةُ الْمُحْرِمِ
u'هَيْئَةٌ مَخْصُوصٌ':Added, #1: 1	هَيْئَةُ الْمُحْرِمَيْنِ
u'هَيْئَةٌ مُزْرِي':Added, #2: 2	هَيْئَةٍ مَخْصُوصَةٍ
u'هَيْئَةٌ مَسَاجِدُ':Added, #2: 2	هَيْئَةٍ مُزْرِيَةٍ
u'هَيْئَةٌ مَسْجِدٌ':Added, #1: 1	هَيْئَةِ الْمَسَاجِدِ
u'هَيْئَةٌ مَسْجِدٌ':Added, #3: 3	هَيْئَةَ مَسْجِدٍ
u'هَيْئَةٌ مَسْرُوقٌ':Added, #5: 5	هَيْئَةِ الْمَسْجِدِ
u'هَيْئَةٌ مُنْكَرٌ':Added, #1: 1	هَيْئَةِ الْمَسْرُوقِ
u'هَيْئَةٌ مَهْدٌ':Added, #2: 2	هَيْئَةٍ مُنْكَرَةٍ
u'هَيْئَةٌ نَاقَةٌ':Added, #1: 1	هَيْئَةِ مَهْدِ
u'هَيْئَةٌ نَاقَة':Added, #1: 1	هَيْئَةُ النَّاقَةِ
u'هَيْئَةٌ نَوَافِلُ':Added, #1: 1	هَيْئَةُ النَّاقَةِ
u'هَيْئَةٌ واحد':Added, #1: 1	هَيْئَةِ النَّوَافِلِ
u'هَيْئَةٌ وَاحِدٌ':Added, #1: 1	هَيْئَةٍ وَاحِدَةٍ
u'هَيْئَةٌ وَقْفٌ':Added, #1: 1	هَيْئَةٍ وَاحِدَةٍ
u'هَيْئَةٌ وَقْفٌ':Added, #1: 1	هَيْئَةُ الْوَقْفِ
u'وَاجَهَ شيب':Subject, #2: 2	هَيْئَةَ الْوَقْفِ
u'وَاجَهَ شَيْبٌ':Subject, #1: 1	وَاجَهَ الشَّيْبُ
u'وَادَعَ أهْلٌ':Predicate, #1: 1	وَاجَهَ الشَّيْبُ
u'وَادَعَ رَسُولٌ':Predicate, #1: 1	وَادَعَ أَهْلَ
u'وَادَعَ نَبِيٌّ':Subject, #1: 1	وَادَعَ رَسُولَ
u'وَارَى بَشَرٌ':Predicate, #1: 1	وَادَعَ النَّبِيُّ
u'وَارَى تُرَابٌ':Subject, #1: 1	وَارَى الْبَشَرَ
u'وَارَى عَوْرَةٌ':Predicate, #5: 5	وَارَى التُّرَابُ
u'وَازَى بَعْضٌ':Predicate, #1: 1	وَارَى عَوْرَتَكَ
u'وَاصَلَ رَسُولٌ':Subject, #1: 1	وَازَى بَعْضَ
u'وَاصَلَ شَرٌّ':Predicate, #2: 2	وَاصَلَ رَسُولُ
u'وَاصَلَ شرب':Predicate, #1: 1	وَاصَلَ الشَّرَّ
u'وَاصَلَ نَبِيٌّ':Subject, #1: 1	وَاصَلَ شَرِبَ
u'وَاطَأَ أُمٌّ':Predicate, #3: 3	وَاصَلَ النَّبِيُّ
u'وَاطَأَ شُهُودٌ':Predicate, #1: 1	وَاطَأَ أُمَّ
u'وَاظَبَ سَلَفٌ':Subject, #2: 2	وَاطَأَ الشُّهُودَ
u'وَاظَبَ صَحَابَةٌ':Subject, #1: 1	وَاظَبَ السَّلَفُ
u'وَاظَبَ نَبِيٌّ':Subject, #1: 1	وَاظَبَ الصَّحَابَةُ
u'وَاعَدَ رَسُولٌ':Predicate, #5: 5	وَاظَبَ النَّبِيُّ
u'وَاعَدَ رَسُولٌ':Subject, #1: 1	وَاعَدَ رَسُولَ
u'وَاعَدَ مَبْعُوثٌ':Predicate, #1: 1	وَاعَدَ رَسُولُ
u'وَاعَدَ نَاسٌ':Predicate, #1: 1	وَاعَدَ الْمَبْعُوثَ
u'وَافَقَ أَبٌ':Subject, #1: 1	وَاعَدَ النَّاسَ
u'وَافَقَ اِبْتِداءٌ':Subject, #1: 1	وَافَقَ الْأَبُ
u'وَافَقَ اِبْنٌ':Predicate, #2: 2	وَافَقَ ابْتِدَاءُ
u'وَافَقَ اِبْنٌ':Subject, #1: 1	وَافَقَ ابْنَ
u'وَافَقَ اِجْتِهَادٌ':Subject, #3: 3	وَافَقَ ابْنُ
u'وَافَقَ أحَدٌ':Subject, #2: 2	وَافَقَ اجْتِهَادُهُ
u'وَافَقَ آخِرُ':Subject, #1: 1	وَافَقَ أَحَدُ
u'وَافَقَ إِذْنٌ':Predicate, #1: 1	وَافَقَ آخِرُ
u'وَافَقَ أُسْتَاذٌ':Predicate, #1: 1	وَافَقَ الْإِذْنَ
u'وَافَقَ اِسْتِدْعَاءٌ':Subject, #1: 1	وَافَقَ الْأُسْتَاذَ
u'وَافَقَ اِسْمٌ':Predicate, #1: 1	وَافَقَ اسْتِدْعَاءُ
u'وَافَقَ اِسْمٌ':Subject, #1: 1	وَافَقَ اسْمَ
u'وَافَقَ أَصْحَابٌ':Subject, #1: 1	وَافَقَ اسْمُ
u'وَافَقَ أصل':Predicate, #2: 2	وَافَقَ الْأَصْحَابُ
u'وَافَقَ أًصْلٌ':Predicate, #1: 1	وَافَقَ الْأَصْلَ
u'وَافَقَ إِطْلاقٌ':Predicate, #1: 1	وَافَقَ الْأَصْلَ
u'وَافَقَ أَكْثَرُ':Predicate, #1: 1	وَافَقَ إطْلَاقَ
u'وَافَقَ أَكْثَرُ':Subject, #1: 1	وَافَقَ الْأَكْثَرِينَ
u'وَافَقَ الْمَرْأَةُ':Predicate, #1: 1	وَافَقَ أَكْثَرُ
u'وَافَقَ إمَامٌ':Predicate, #1: 1	وَافَقَ الْمَرْأَةَ
u'وَافَقَ إمَامٌ':Subject, #2: 2	وَافَقَ الْإِمَامَ
u'وَافَقَ إمَامٌ':Subject, #2: 2	وَافَقَ الْإِمَامُ
u'وَافَقَ أَمْرٌ':Predicate, #2: 2	وَافَقَ إمَامُ
u'وَافَقَ أَمْرٌ':Predicate, #1: 1	وَافَقَ أَمْرَ
u'وَافَقَ إِنْزالٌ':Subject, #2: 2	وَافَقَ الْأَمْرَ
u'وَافَقَ أهْلٌ':Predicate, #1: 1	وَافَقَ الْإِنْزَالُ
u'وَافَقَ أوْسَطُ':Subject, #1: 1	وَافَقَ أَهْلَ
u'وَافَقَ أَوَّلُ':Predicate, #1: 1	وَافَقَ أَوْسَطُ
u'وَافَقَ أيَّامٌ':Predicate, #4: 4	وَافَقَ أَوَّلَ
u'وَافَقَ أَيَّامٌ':Predicate, #2: 2	وَافَقَ أَيَّامَ
u'وَافَقَ بَائِعٌ':Subject, #2: 2	وَافَقَ أَيَّامَ
u'وَافَقَ بَحْثٌ':Predicate, #1: 1	وَافَقَ الْبَائِعُ
u'وَافَقَ بِرٌّ':Predicate, #1: 1	وَافَقَ بَحْثَ
u'وَافَقَ بَعْضٌ':Predicate, #1: 1	وَافَقَ الْبِرَّ
u'وَافَقَ تَأْمِينٌ':Subject, #1: 1	وَافَقَ بَعْضَ
u'وَافَقَ تَأْمِينٌ':Subject, #1: 1	وَافَقَ تَأْمِينُ
u'وَافَقَ تَسْمِيَة':Predicate, #8: 8	وَافَقَ تَأْمِينُهُ
u'وَافَقَ تَفَرُّقٌ':Predicate, #1: 1	وَافَقَ التَّسْمِيَةَ
u'وَافَقَ تمام':Predicate, #1: 1	وَافَقَ تَفَرّقَ
u'وَافَقَ تَمامٌ':Predicate, #1: 1	وَافَقَ تَمَامَ
u'وَافَقَ جَازٌ':Predicate, #1: 1	وَافَقَ تَمَامَ
u'وَافَقَ جُزْءٌ':Predicate, #1: 1	وَافَقَ جَازَ
u'وَافَقَ جَمَاعَةٌ':Predicate, #2: 2	وَافَقَ الْجُزْءَ
u'وَافَقَ جمعة':Predicate, #1: 1	وَافَقَ الْجَمَاعَةَ
u'وَافَقَ جُمُعَةٌ':Predicate, #1: 1	وَافَقَ الْجُمُعَةَ
u'وَافَقَ جُمْهُورٌ':Predicate, #1: 1	وَافَقَ الْجُمُعَةَ
u'وَافَقَ جُمْهُورٌ':Predicate, #1: 1	وَافَقَ الْجُمْهُورَ
u'وَافَقَ حاكِمٌ':Predicate, #1: 1	وَافَقَ جُمْهُورَ
u'وَافَقَ حَديثٌ':Predicate, #2: 2	وَافَقَ الْحَاكِمَ
u'وَافَقَ حَديثٌ':Predicate, #1: 1	وَافَقَ الْحَدِيثَ
u'وَافَقَ حَقٌّ':Predicate, #1: 1	وَافَقَ حَدِيثَ
u'وَافَقَ خاصّ':Subject, #13: 13	وَافَقَ الْحَقَّ
u'وَافَقَ خَبَرٌ':Subject, #1: 1	وَافَقَ خَاصٌّ
u'وَافَقَ خَبَر':Subject, #1: 1	وَافَقَ خَبَرُ
u'وَافَقَ خَبَرٌ':Subject, #1: 1	وَافَقَ خَبَرُ
u'وَافَقَ خَبَر':Subject, #1: 1	وَافَقَ خَبَرُهُ
u'وَافَقَ خَطٌّ':Subject, #1: 1	وَافَقَ خَبَرُهُ
u'وَافَقَ دَاعِي':Predicate, #1: 1	وَافَقَ خَطُّهُ
u'وَافَقَ رَسُولٌ':Predicate, #1: 1	وَافَقَ دَاعِيَةَ
u'وَافَقَ رَمَضانُ':Subject, #1: 1	وَافَقَ رَسُولَ
u'وَافَقَ رِوايَةٌ':Predicate, #2: 2	وَافَقَ رَمَضَانُ
u'وَافَقَ سِنٌّ':Subject, #2: 2	وَافَقَ رِوَايَةَ
u'وَافَقَ سُنَّةٌ':Predicate, #1: 1	وَافَقَ سِنُّ
u'وَافَقَ شافِع':Subject, #3: 3	وَافَقَ السُّنَّةَ
u'وَافَقَ شافِعِيّ':Predicate, #1: 1	وَافَقَ الشَّافِعِيَّةُ
u'وَافَقَ شافِعِيّ':Subject, #1: 1	وَافَقَ الشَّافِعِيَّ
u'وَافَقَ شَرَائِطُ':Predicate, #1: 1	وَافَقَ الشَّافِعِيَّةُ
u'وَافَقَ شَرْعٌ':Predicate, #1: 1	وَافَقَ الشَّرَائِطَ
u'وَافَقَ شُرُوعٌ':Subject, #1: 1	وَافَقَ الشَّرْعَ
u'وَافَقَ شَرِيعَةٌ':Predicate, #1: 1	وَافَقَ شُرُوعُهُ
u'وَافَقَ شُعْبَةٌ':Predicate, #1: 1	وَافَقَ الشَّرِيعَةَ
u'وَافَقَ شَهْرٌ':Predicate, #1: 1	وَافَقَ شُعْبَةَ
u'وَافَقَ شَيْخٌ':Predicate, #2: 2	وَافَقَ الشَّهْرَ
u'وَافَقَ صَحِيحٌ':Predicate, #1: 1	وَافَقَ الشَّيْخَ
u'وَافَقَ صَدْرٌ':Predicate, #1: 1	وَافَقَ الصَّحِيحَ
u'وَافَقَ صِفَةٌ':Predicate, #1: 1	وَافَقَ الصَّدْرَ
u'وَافَقَ صَوَابٌ':Predicate, #1: 1	وَافَقَ صِفَةَ
u'وَافَقَ صَوْمٌ':Subject, #2: 2	وَافَقَ الصَّوَابَ
u'وَافَقَ صَوْمٌ':Subject, #2: 2	وَافَقَ صَوْمُ
u'وَافَقَ طَالِبٌ':Predicate, #5: 5	وَافَقَ صَوْمُهُ
u'وَافَقَ طَرِيقَةٌ':Predicate, #1: 1	وَافَقَ الطَّالِبَ
u'وَافَقَ ظاهِرٌ':Predicate, #1: 1	وَافَقَ طَرِيقَةَ
u'وَافَقَ ظاهِرٌ':Predicate, #2: 2	وَافَقَ الظَّاهِرَ
u'وَافَقَ ظاهِرٌ':Subject, #2: 2	وَافَقَ ظَاهِرَ
u'وَافَقَ عَادَةٌ':Predicate, #1: 1	وَافَقَ ظَاهِرُ
u'وَافَقَ عَدَدٌ':Subject, #3: 3	وَافَقَ الْعَادَةَ
u'وَافَقَ عرف':Predicate, #1: 1	وَافَقَ الْعَدَدُ
u'وَافَقَ عُرْفٌ':Predicate, #1: 1	وَافَقَ عُرْفَ
u'وَافَقَ غير':Predicate, #1: 1	وَافَقَ عُرْفَ
u'وَافَقَ غَيْرٌ':Predicate, #1: 1	وَافَقَ غَيْرَ
u'وَافَقَ فخر':Predicate, #1: 1	وَافَقَ غَيْرَ
u'وَافَقَ فَخْرٌ':Predicate, #1: 1	وَافَقَ فَخْرَ
u'وَافَقَ فراغ':Subject, #1: 1	وَافَقَ فَخْرَ
u'وَافَقَ فَرَاغٌ':Subject, #2: 2	وَافَقَ فَرَاغُ
u'وَافَقَ فلان':Predicate, #2: 2	وَافَقَ فَرَاغُ
u'وَافَقَ فلان':Predicate, #1: 1	وَافَقَ الْحَارِثِيَّ
u'وَافَقَ فلان':Predicate, #1: 1	وَافَقَ الشَّافِعِيَّ
u'وَافَقَ فلان':Subject, #1: 1	وَافَقَ سُفْيَانَ
u'وَافَقَ قَابِضٌ':Subject, #1: 1	وَافَقَ الشَّافِعِيَّةُ
u'وَافَقَ قَاضِي':Predicate, #1: 1	وَافَقَ الْقَابِضُ
u'وَافَقَ قُدُومٌ':Subject, #2: 2	وَافَقَ الْقَاضِيَ
u'وَافَقَ قُرْآنٌ':Predicate, #3: 3	وَافَقَ قُدُومُهُ
u'وَافَقَ قُرُوحٌ':Predicate, #3: 3	وَافَقَ الْقُرْآنَ
u'وَافَقَ قَصَبَةٌ':Predicate, #1: 1	وَافَقَ الْقُرُوحَ
u'وَافَقَ قول':Predicate, #1: 1	وَافَقَ قَصَبَةَ
u'وَافَقَ قَوْلٌ':Predicate, #5: 5	وَافَقَ قَوْلَ
u'وَافَقَ قول':Subject, #5: 5	وَافَقَ قَوْلَ
u'وَافَقَ قَوْلٌ':Subject, #5: 5	وَافَقَ قَوْلُهُ
u'وَافَقَ قِيَاسٌ':Predicate, #5: 5	وَافَقَ قَوْلُهُ
u'وَافَقَ قِيمَةٌ':Predicate, #3: 3	وَافَقَ الْقِيَاسَ
u'وَافَقَ كِتَابٌ':Predicate, #1: 1	وَافَقَ الْقِيمَةَ
u'وَافَقَ كِتَابٌ':Predicate, #2: 2	وَافَقَ كِتَابَ
u'وَافَقَ كَلاَمٌ':Predicate, #4: 4	وَافَقَ الْكِتَابَ
u'وَافَقَ كَلاَمٌ':Subject, #1: 1	وَافَقَ كَلاَمَ
u'وَافَقَ كَلاَمٌ':Subject, #1: 1	وَافَقَ كَلَامُ
u'وَافَقَ كَيْلٌ':Predicate, #1: 1	وَافَقَ كَلَامُهُ
u'وَافَقَ لُغَةٌ':Predicate, #1: 1	وَافَقَ الْكَيْلَ
u'وَافَقَ مالِك':Subject, #1: 1	وَافَقَ اللُّغَةَ
u'وَافَقَ مالِكِيّ':Subject, #2: 2	وَافَقَ الْمَالِكِيَّةُ
u'وَافَقَ مُبْتاع':Subject, #2: 2	وَافَقَ الْمَالِكِيَّةُ
u'وَافَقَ مَبْلَغٌ':Predicate, #1: 1	وَافَقَ الْمُبْتَاعُ
u'وَافَقَ مُتَأَخِّرٌ':Predicate, #1: 1	وَافَقَ الْمَبْلَغَ
u'وَافَقَ مُتُونٌ':Predicate, #1: 1	وَافَقَ الْمُتَأَخِّرِينَ
u'وَافَقَ مَذْهَبٌ':Predicate, #2: 2	وَافَقَ الْمُتُونَ
u'وَافَقَ مُسْتَعِيرٌ':Subject, #3: 3	وَافَقَ مَذْهَبَ
u'وَافَقَ مُصْحَفٌ':Predicate, #1: 1	وَافَقَ الْمُسْتَعِيرُ
u'وَافَقَ مُصَنِّفٌ':Predicate, #1: 1	وَافَقَ مُصْحَفَ
u'وَافَقَ مُصَنِّفٌ':Subject, #2: 2	وَافَقَ الْمُصَنِّفَ
u'وَافَقَ مُطْلَقٌ':Predicate, #1: 1	وَافَقَ الْمُصَنِّفُ
u'وَافَقَ مَهْرٌ':Predicate, #1: 1	وَافَقَ مُطْلَقَ
u'وَافَقَ مَهْرٌ':Subject, #3: 3	وَافَقَ مَهْرَ
u'وَافَقَ مُوَفَّقٌ':Predicate, #1: 1	وَافَقَ مَهْرُ
u'وَافَقَ مَوْلِدٌ':Subject, #1: 1	وَافَقَ الْمُوَفَّقَ
u'وَافَقَ مُؤَلِّفٌ':Subject, #1: 1	وَافَقَ مَوْلِدُهُ
u'وَافَقَ نَافِعٌ':Subject, #1: 1	وَافَقَ الْمُؤَلِّفُ
u'وَافَقَ نَذْرٌ':Subject, #1: 1	وَافَقَ نَافِعٌ
u'وَافَقَ نَصِيبٌ':Subject, #1: 1	وَافَقَ نَذْرٌ
u'وَافَقَ نَظْمٌ':Predicate, #1: 1	وَافَقَ نَصِيبُ
u'وَافَقَ وَاقِعٌ':Predicate, #2: 2	وَافَقَ نَظْمَ
u'وَافَقَ وَقْتٌ':Predicate, #2: 2	وَافَقَ الْوَاقِعَ
u'وَافَقَ وَهَلٌ':Predicate, #1: 1	وَافَقَ الْوَقْتَ
u'وَافَقَ يَمٌّ':Subject, #1: 1	وَافَقَ وَهَلَكَ
u'وَافَقَ يهود':Predicate, #1: 1	وَافَقَ الْيَمُّ
u'وَافَقَ يَهُودٌ':Predicate, #2: 2	وَافَقَ الْيَهُودَ
u'وَافَقَ يَوْمٌ':Predicate, #2: 2	وَافَقَ الْيَهُودَ
u'وَافَقَ يَوْمٌ':Subject, #8: 8	وَافَقَ يَوْمَ
u'وَافَى أمَانَةٌ':Predicate, #3: 3	وَافَقَ يَوْمُ
u'وَافَى حِمَامٌ':Subject, #1: 1	وَافَى الْأَمَانَةَ
u'وَافَى مَوْسِمٌ':Predicate, #1: 1	وَافَى حِمَامُ
u'وَافَى وَرَثَةٌ':Subject, #2: 2	وَافَى الْمَوْسِمَ
u'وَاقَعَ رَجُلٌ':Subject, #1: 1	وَافَى وَرَثَةُ
u'وَاقَعَ قَالٌ':Predicate, #1: 1	وَاقَعَ الرَّجُلُ
u'وَاقَفَ قِرْنٌ':Predicate, #1: 1	وَاقَعَ قَالَ
u'وَالَى أَبٌ':Predicate, #1: 1	وَاقَفَ الْقِرْنَ
u'وَالَى أَبٌ':Subject, #1: 1	وَالَى الْأَبَ
u'وَالَى اِبْنٌ':Predicate, #1: 1	وَالَى الْأَبُ
u'وَالَى أرْضٌ':Predicate, #1: 1	وَالَى ابْنَ
u'وَالَى أَسْفَلُ':Subject, #1: 1	وَالَى الْأَرْضَ
u'وَالَى بالِغٌ':Subject, #2: 2	وَالَى الْأَسْفَلُ
u'وَالَى بَيْنٌ':Predicate, #1: 1	وَالَى بَالِغٌ
u'وَالَى ذِمِّيٌّ':Subject, #5: 5	وَالَى بَيْنَ
u'وَالَى رَجُلٌ':Predicate, #2: 2	وَالَى ذِمِّيٌّ
u'وَالَى رَجُلٌ':Subject, #1: 1	وَالَى رَجُلاً
u'وَالَى عَرَبِيٌّ':Subject, #4: 4	وَالَى رَجُلٌ
u'وَالَى غير':Predicate, #1: 1	وَالَى عَرَبِيٌّ
u'وَالَى غَيْرٌ':Predicate, #1: 1	وَالَى غَيْرَ
u'وَالَى لَقِيطٌ':Subject, #1: 1	وَالَى غَيْرَ
u'وَبَاءٌ أرْضٌ':Added, #1: 1	وَالَى اللَّقِيطُ
u'وَبَاءٌ سَبَبٌ':Added, #1: 1	وَبَاءَ الأَرْضِ
u'وَبَاءٌ عِلَّةٌ':Added, #1: 1	وَبَاءُ السَّبَبِ
u'وَبَاءٌ عِلَّةٌ':Added, #1: 1	وَبَاءُ الْعِلَّةِ
u'وَبَاءٌ مَدِينٌ':Added, #1: 1	وَبَاءِ الْعِلَّةِ
u'وَبَاءٌ مَدِينَةٌ':Added, #1: 1	وَبَاءَ الْمَدِينَةِ
u'وَبَاءٌ مُعْجَمَةٌ':Added, #1: 1	وَبَاءَ الْمَدِينَةِ
u'وبال أَمْرٌ':Added, #1: 1	وَبَاءٍ مُعْجَمَةٍ
u'وَبَالٌ أَمْرٌ':Added, #9: 9	وَبَالَ أَمْرِهِ
u'وبال أَوَّلُ':Added, #9: 9	وَبَالَ أَمْرِهِ
u'وَبَالٌ أَوَّلُ':Added, #1: 1	وَبَالِ الْأَوَّلِ
u'وبال كفر':Added, #1: 1	وَبَالِ الْأَوَّلِ
u'وَبَالٌ كفر':Added, #1: 1	وَبَالُ كُفْرِهِ
u'وبال كُفْرٌ':Added, #1: 1	وَبَالُ كُفْرِهِ
u'وَبَالٌ كُفْرٌ':Added, #1: 1	وَبَالُ كُفْرِهِ
u'وبال كلاب':Added, #1: 1	وَبَالُ كُفْرِهِ
u'وَبَالٌ كلاب':Added, #1: 1	وَبَالُ الْكِلَابِ
u'وبال كِلاَبٌ':Added, #1: 1	وَبَالُ الْكِلَابِ
u'وَبَالٌ كِلاَبٌ':Added, #1: 1	وَبَالُ الْكِلَابِ
u'وبال مَعْصِيَةٌ':Added, #1: 1	وَبَالُ الْكِلَابِ
u'وَبَالٌ مَعْصِيَةٌ':Added, #1: 1	وَبَالِ الْمَعْصِيَةِ
u'وَبَّخَ كُفَّارٌ':Predicate, #1: 1	وَبَالِ الْمَعْصِيَةِ
u'وَتَدَ وَتَدٌ':Predicate, #1: 1	وَبَّخَ الْكُفَّارَ
u'وَثَبَ حِمَارٌ':Subject, #1: 1	وَتَدَ الْوَتَدَ
u'وَثَبَ عُمَرٌ':Subject, #1: 1	وَثَبَ الْحِمَارُ
u'وَثَبَ كَلْبٌ':Subject, #1: 1	وَثَبَ عُمَرُ
u'وَثِقَ وَرَثَةٌ':Subject, #3: 3	وَثَبَ الْكَلْبُ
u'وَثَّقَ وَرَثَةٌ':Subject, #1: 1	وَثِقَ الْوَرَثَةُ
u'وَجَبَ إبدالٌ':Subject, #2: 2	وَثَّقَ الْوَرَثَةُ
u'وَجَبَ إِبْقَاءٌ':Subject, #1: 1	وَجَبَ إبْدَالُهُ
u'وَجَبَ اِتِّبَاعٌ':Subject, #1: 1	وَجَبَ إبْقَاءُ
u'وَجَبَ اِتِّبَاعٌ':Subject, #2: 2	وَجَبَ اتِّبَاعُ
u'وَجَبَ إِتْلاَفٌ':Subject, #2: 2	وَجَبَ اتِّبَاعُهُ
u'وَجَبَ إتْمَامٌ':Subject, #1: 1	وَجَبَ إتْلَافُهُ
u'وَجَبَ إتْمَامٌ':Subject, #1: 1	وَجَبَ إتْمَامُهُ
u'وَجَبَ إِتْيانٌ':Subject, #1: 1	وَجَبَ الْإِتْمَامُ
u'وَجَبَ إِثْمٌ':Subject, #1: 1	وَجَبَ الْإِتْيَانُ
u'وَجَبَ اجْتِنَابٌ':Subject, #1: 1	وَجَبَ الْإِثْمُ
u'وَجَبَ أَجْرٌ':Subject, #1: 1	وَجَبَ اجْتِنَابُهُ
u'وَجَبَ أَجْرٌ':Subject, #10: 10	وَجَبَ أَجْرُ
u'وَجَبَ أَجْرٌ':Subject, #12: 12	وَجَبَ الْأَجْرُ
u'وَجَبَ إِجْرَاءٌ':Subject, #1: 1	وَجَبَ أَجْرُهُ
u'وَجَبَ إِحْرَامٌ':Subject, #1: 1	وَجَبَ إجْرَاءُ
u'وَجَبَ إحْضَارٌ':Subject, #3: 3	وَجَبَ الْإِحْرَامُ
u'وَجَبَ إِخْبَارٌ':Subject, #1: 1	وَجَبَ إحْضَارُهُ
u'وَجَبَ أخْذٌ':Subject, #1: 1	وَجَبَ الْإِخْبَارُ
u'وَجَبَ أخْذٌ':Subject, #1: 1	وَجَبَ أَخْذُ
u'وَجَبَ أخْذٌ':Subject, #5: 5	وَجَبَ أَخْذُهُ
u'وَجَبَ إِخْرَاجٌ':Subject, #6: 6	وَجَبَ الْأَخْذُ
u'وَجَبَ إِخْرَاجٌ':Subject, #3: 3	وَجَبَ إخْرَاجُهُ
u'وَجَبَ إِخْرَاجٌ':Subject, #5: 5	وَجَبَ إخْرَاجُ
u'وَجَبَ أَدَاءٌ':Subject, #5: 5	وَجَبَ الْإِخْرَاجُ
u'وَجَبَ أَدَاءٌ':Subject, #3: 3	وَجَبَ أَدَاءُ
u'وَجَبَ أَرْبَعُ':Subject, #7: 7	وَجَبَ الْأَدَاءُ
u'وَجَبَ اِرْتِفَاعٌ':Subject, #1: 1	وَجَبَ أَرْبَعُ
u'وَجَبَ اِرْتِفَاعٌ':Subject, #1: 1	وَجَبَ ارْتِفَاعُ
u'وَجَبَ إِرْثٌ':Subject, #1: 1	وَجَبَ ارْتِفَاعُهُ
u'وَجَبَ إِرْسَالٌ':Subject, #1: 1	وَجَبَ إرْثُ
u'وَجَبَ إِرْسَالٌ':Subject, #1: 1	وَجَبَ إرْسَالُهُ
u'وَجَبَ إِزَالَةٌ':Subject, #2: 2	وَجَبَ الْإِرْسَالُ
u'وَجَبَ اِسْتِحْقَاقٌ':Subject, #2: 2	وَجَبَ إزَالَتُهُ
u'وَجَبَ اِسْتِصْحابٌ':Subject, #1: 1	وَجَبَ اسْتِحْقَاقُ
u'وَجَبَ اِسْتِعْمالٌ':Subject, #1: 1	وَجَبَ اسْتِصْحَابُ
u'وَجَبَ اِسْتِعْمالٌ':Subject, #1: 1	وَجَبَ اسْتِعْمَالُ
u'وَجَبَ اِسْتِئْنَافٌ':Subject, #5: 5	وَجَبَ اسْتِعْمَالُهُ
u'وَجَبَ اِسْتِئْنَافٌ':Subject, #1: 1	وَجَبَ اسْتِئْنَافٌ
u'وَجَبَ إِسْراجٌ':Subject, #1: 1	وَجَبَ اسْتِئْنَافُ
u'وَجَبَ إِسْقاطٌ':Subject, #1: 1	وَجَبَ الْإِسْرَاجُ
u'وَجَبَ إِسْقاطٌ':Subject, #1: 1	وَجَبَ إسْقَاطُ
u'وَجَبَ أصل':Subject, #1: 1	وَجَبَ إسْقَاطُهُ
u'وَجَبَ أًصْلٌ':Subject, #1: 1	وَجَبَ الْأَصْلُ
u'وَجَبَ إِطْعامٌ':Subject, #1: 1	وَجَبَ الْأَصْلُ
u'وَجَبَ إِطْعامٌ':Subject, #1: 1	وَجَبَ إطْعَامُهُ
u'وَجَبَ إِطْلاقٌ':Subject, #2: 2	وَجَبَ الْإِطْعَامُ
u'وَجَبَ إِظْهارٌ':Subject, #1: 1	وَجَبَ إطْلَاقُ
u'وَجَبَ إِعادَةٌ':Subject, #3: 3	وَجَبَ إظْهَارُ
u'وَجَبَ إِعادَةٌ':Subject, #2: 2	وَجَبَ الْإِعَادَةُ
u'وَجَبَ إِعادَةٌ':Subject, #3: 3	وَجَبَ إعَادَتُهُ
u'وَجَبَ إِعْتاقٌ':Subject, #6: 6	وَجَبَ إعَادَةُ
u'وَجَبَ اِعْتِبارٌ':Subject, #2: 2	وَجَبَ إعْتَاقُهُ
u'وَجَبَ اِعْتِبارٌ':Subject, #13: 13	وَجَبَ اعْتِبَارُ
u'وَجَبَ اِعْتِقادٌ':Subject, #9: 9	وَجَبَ اعْتِبَارُهُ
u'وَجَبَ إعْطَاءٌ':Subject, #2: 2	وَجَبَ اعْتِقَادُ
u'وَجَبَ إعْلاَمٌ':Subject, #1: 1	وَجَبَ إعْطَاءُ
u'وَجَبَ إعْلاَمٌ':Subject, #1: 1	وَجَبَ الْإِعْلَامُ
u'وَجَبَ إعْمَالٌ':Subject, #3: 3	وَجَبَ إعْلَامُهُ
u'وَجَبَ إفْتَاءٌ':Subject, #2: 2	وَجَبَ إعْمَالُ
u'وَجَبَ إفْلاَسٌ':Subject, #2: 2	وَجَبَ الْإِفْتَاءُ
u'وَجَبَ إقامَةٌ':Subject, #1: 1	وَجَبَ إفْلَاسُ
u'وَجَبَ أقَلُّ':Subject, #3: 3	وَجَبَ إقَامَةُ
u'وَجَبَ أقَلُّ':Subject, #2: 2	وَجَبَ أَقَلُّ
u'وَجَبَ أَكْثَرُ':Subject, #3: 3	وَجَبَ الْأَقَلُّ
u'وَجَبَ أَكْثَرُ':Subject, #1: 1	وَجَبَ أَكْثَرُ
u'وَجَبَ إكْرَاهٌ':Subject, #1: 1	وَجَبَ الْأَكْثَرُ
u'وَجَبَ أكل':Subject, #1: 1	وَجَبَ الْإِكْرَاهُ
u'وَجَبَ أَكْلٌ':Subject, #3: 3	وَجَبَ أَكْلُ
u'وَجَبَ إِكْمَالٌ':Subject, #3: 3	وَجَبَ أَكْلُ
u'وَجَبَ إلْحَاقٌ':Subject, #1: 1	وَجَبَ الْإِكْمَالُ
u'وَجَبَ ألف':Subject, #2: 2	وَجَبَ إلْحَاقُهُ
u'وَجَبَ ألْفٌ':Subject, #1: 1	وَجَبَ الْأَلْفُ
u'وَجَبَ أَلْفٌ':Subject, #1: 1	وَجَبَ الْأَلْفُ
u'وَجَبَ ألْفٌ':Subject, #1: 1	وَجَبَ الْأَلْفُ
u'وَجَبَ أَلْفٌ':Subject, #1: 1	وَجَبَ أَلْفٌ
u'وَجَبَ اِمْتِثَالٌ':Subject, #1: 1	وَجَبَ أَلْفٌ
u'وَجَبَ اِمْتِثَالٌ':Subject, #1: 1	وَجَبَ امْتِثَالُهُ
u'وَجَبَ إِمْساكٌ':Subject, #5: 5	وَجَبَ امْتِثَالُ
u'وَجَبَ إِنْذارٌ':Subject, #3: 3	وَجَبَ الْإِمْسَاكُ
u'وَجَبَ إِنْصافٌ':Subject, #1: 1	وَجَبَ إنْذَارُهُ
u'وَجَبَ إِنْفاقٌ':Subject, #1: 1	وَجَبَ الْإِنْصَافُ
u'وَجَبَ إِنْكارٌ':Subject, #2: 2	وَجَبَ الْإِنْفَاقُ
u'وَجَبَ إِنْكارٌ':Subject, #2: 2	وَجَبَ إنْكَارُهُ
u'وَجَبَ إهْدَاءٌ':Subject, #5: 5	وَجَبَ الْإِنْكَارُ
u'وَجَبَ أَوَّلُ':Subject, #1: 1	وَجَبَ الْإِهْدَاءُ
u'وَجَبَ إيصَالٌ':Subject, #1: 1	وَجَبَ الْأَوَّلُ
u'وَجَبَ إيصَالٌ':Subject, #1: 1	وَجَبَ إيصَالُهُ
u'وَجَبَ إيمَانٌ':Subject, #3: 3	وَجَبَ إيصَالُ
u'وَجَبَ بَحْثٌ':Subject, #1: 1	وَجَبَ الْإِيمَانُ
u'وَجَبَ بَدَلٌ':Subject, #1: 1	وَجَبَ الْبَحْثُ
u'وَجَبَ بَدَلٌ':Subject, #1: 1	وَجَبَ بَدَلُهُ
u'وَجَبَ بَدَلٌ':Subject, #2: 2	وَجَبَ الْبَدَلُ
u'وَجَبَ بَذْلٌ':Subject, #4: 4	وَجَبَ بَدَلُ
u'وَجَبَ بَذْلٌ':Subject, #2: 2	وَجَبَ الْبَذْلُ
u'وَجَبَ بَذْلٌ':Subject, #3: 3	وَجَبَ بَذْلُ
u'وَجَبَ بَعْضٌ':Subject, #3: 3	وَجَبَ بَذْلُهُ
u'وَجَبَ بَعيرٌ':Subject, #1: 1	وَجَبَ بَعْضُ
u'وَجَبَ بَقاءٌ':Subject, #1: 1	وَجَبَ بَعِيرٌ
u'وَجَبَ بَقِيَّةٌ':Subject, #1: 1	وَجَبَ بَقَاءُ
u'وَجَبَ بِنْتٌ':Subject, #1: 1	وَجَبَ بَقِيَّةُ
u'وَجَبَ بَيَانٌ':Subject, #2: 2	وَجَبَ بِنْتُ
u'وَجَبَ بَيَانٌ':Subject, #3: 3	وَجَبَ بَيَانُهُ
u'وَجَبَ بَيَانٌ':Subject, #8: 8	وَجَبَ الْبَيَانُ
u'وَجَبَ بَيْعٌ':Subject, #8: 8	وَجَبَ بَيَانُ
u'وَجَبَ بَيْعٌ':Subject, #1: 1	وَجَبَ بَيْعُ
u'وَجَبَ بَيْعٌ':Subject, #23: 23	وَجَبَ الْبَيْعُ
u'وَجَبَ تَأَخُّرٌ':Subject, #2: 2	وَجَبَ بَيْعُهُ
u'وَجَبَ تَأْخِيرٌ':Subject, #1: 1	وَجَبَ تَأَخُّرُهُ
u'وَجَبَ تَأْخِيرٌ':Subject, #1: 1	وَجَبَ تَأْخِيرُ
u'وَجَبَ تَأْخِيرٌ':Subject, #3: 3	وَجَبَ تَأْخِيرُهُ
u'وَجَبَ تَبْلِيغٌ':Subject, #5: 5	وَجَبَ التَّأْخِيرُ
u'وَجَبَ تَبْلِيغٌ':Subject, #2: 2	وَجَبَ تَبْلِيغُ
u'وَجَبَ تَبْيِين':Subject, #2: 2	وَجَبَ تَبْلِيغُهُ
u'وَجَبَ تَتَابُعٌ':Subject, #2: 2	وَجَبَ التَّبْيِينُ
u'وَجَبَ تَجْدِيدٌ':Subject, #1: 1	وَجَبَ التَّتَابُعُ
u'وَجَبَ تَحَالُفٌ':Subject, #1: 1	وَجَبَ تَجْدِيدُ
u'وَجَبَ تَحْدِيدٌ':Subject, #1: 1	وَجَبَ التَّحَالُفُ
u'وَجَبَ تَحْرِيكٌ':Subject, #1: 1	وَجَبَ تَحْدِيدُهُ
u'وَجَبَ تَحَصُّلٌ':Subject, #1: 1	وَجَبَ تَحْرِيكُ
u'وَجَبَ تَحْصِيلٌ':Subject, #1: 1	وَجَبَ تَحَصُّلُ
u'وَجَبَ تَحْصِيلٌ':Subject, #2: 2	وَجَبَ تَحْصِيلُهُ
u'وَجَبَ تَحْلِيف':Subject, #4: 4	وَجَبَ تَحْصِيلُ
u'وَجَبَ تَخْصِيصٌ':Subject, #1: 1	وَجَبَ تَحْلِيفُهُ
u'وَجَبَ تَخْصِيصٌ':Subject, #1: 1	وَجَبَ تَخْصِيصُهُ
u'وَجَبَ تَخْلِيَة':Subject, #5: 5	وَجَبَ تَخْصِيصُ
u'وَجَبَ تَخْلِيصٌ':Subject, #1: 1	وَجَبَ تَخْلِيَةُ
u'وَجَبَ تَخْيِيرٌ':Subject, #2: 2	وَجَبَ تَخْلِيصُهُ
u'وَجَبَ تَخْيِيرٌ':Subject, #1: 1	وَجَبَ التَّخْيِيرُ
u'وَجَبَ تَدَارُكٌ':Subject, #1: 1	وَجَبَ تَخْيِيرُ
u'وَجَبَ تَرْتِيبٌ':Subject, #1: 1	وَجَبَ تَدَارُكُهُ
u'وَجَبَ تَرْجِيحٌ':Subject, #2: 2	وَجَبَ التَّرْتِيبُ
u'وَجَبَ تَرْجِيحٌ':Subject, #2: 2	وَجَبَ التَّرْجِيحُ
u'وَجَبَ تَرَدُّدٌ':Subject, #3: 3	وَجَبَ تَرْجِيحُ
u'وَجَبَ تَرْكٌ':Subject, #1: 1	وَجَبَ تَرَدُّدُهُ
u'وَجَبَ تَسْجِيلٌ':Subject, #4: 4	وَجَبَ تَرْكُ
u'وَجَبَ تَسْرِيحٌ':Subject, #1: 1	وَجَبَ التَّسْجِيلُ
u'وَجَبَ تِسْعَةٌ':Subject, #1: 1	وَجَبَ التَّسْرِيحُ
u'وَجَبَ تَسْلِيمٌ':Subject, #1: 1	وَجَبَ تِسْعَةُ
u'وَجَبَ تَسْلِيمٌ':Subject, #11: 11	وَجَبَ تَسْلِيمُ
u'وَجَبَ تَسْلِيمٌ':Subject, #1: 1	وَجَبَ تَسْلِيمُهُ
u'وَجَبَ تَسْوِيَةٌ':Subject, #3: 3	وَجَبَ التَّسْلِيمُ
u'وَجَبَ تَصَدُّقٌ':Subject, #1: 1	وَجَبَ تَسْوِيَةُ
u'وَجَبَ تَصْدِيقٌ':Subject, #4: 4	وَجَبَ التَّصَدُّقُ
u'وَجَبَ تَصْرِيحٌ':Subject, #5: 5	وَجَبَ تَصْدِيقُهُ
u'وَجَبَ تَطْهِيرٌ':Subject, #3: 3	وَجَبَ التَّصْرِيحُ
u'وَجَبَ تَعْجِيل':Subject, #2: 2	وَجَبَ التَّطْهِيرُ
u'وَجَبَ تَعَرُّضٌ':Subject, #1: 1	وَجَبَ التَّعْجِيلُ
u'وَجَبَ تَعْزِير':Subject, #1: 1	وَجَبَ التَّعَرُّضُ
u'وَجَبَ تَعْمِيمٌ':Subject, #8: 8	وَجَبَ التَّعْزِيرُ
u'وَجَبَ تَعْمِيمٌ':Subject, #1: 1	وَجَبَ تَعْمِيمُهُ
u'وَجَبَ تَعْوِيلٌ':Subject, #3: 3	وَجَبَ التَّعْمِيمُ
u'وَجَبَ تَعْيِينٌ':Subject, #1: 1	وَجَبَ التَّعْوِيلُ
u'وَجَبَ تَعْيِينٌ':Subject, #1: 1	وَجَبَ تَعْيِينُ
u'وَجَبَ تَفْرِيغٌ':Subject, #3: 3	وَجَبَ تَعْيِينُهُ
u'وَجَبَ تَفْرِيقٌ':Subject, #1: 1	وَجَبَ تَفْرِيغُهُ
u'وَجَبَ تَفْصِيلٌ':Subject, #5: 5	وَجَبَ التَّفْرِيقُ
u'وَجَبَ تَفْضِيلٌ':Subject, #4: 4	وَجَبَ التَّفْصِيلُ
u'وَجَبَ تَفْضِيلٌ':Subject, #1: 1	وَجَبَ التَّفْضِيلُ
u'وَجَبَ تَقابُض':Subject, #1: 1	وَجَبَ تَفْضِيلُ
u'وَجَبَ تَقْديرٌ':Subject, #2: 2	وَجَبَ التَّقَابُضُ
u'وَجَبَ تَقْديرٌ':Subject, #1: 1	وَجَبَ تَقْدِيرُهُ
u'وَجَبَ تَقْديمٌ':Subject, #4: 4	وَجَبَ تَقْدِيرُ
u'وَجَبَ تَقْديمٌ':Subject, #2: 2	وَجَبَ تَقْدِيمُهُ
u'وَجَبَ تَقْسِيمٌ':Subject, #8: 8	وَجَبَ تَقْدِيمُ
u'وَجَبَ تَقْليدٌ':Subject, #1: 1	وَجَبَ تَقْسِيمُ
u'وَجَبَ تَقْليد':Subject, #1: 1	وَجَبَ تَقْلِيدُ
u'وَجَبَ تَقْويمٌ':Subject, #1: 1	وَجَبَ تَقْلِيدُ
u'وَجَبَ تَقْيِيد':Subject, #2: 2	وَجَبَ تَقْوِيمُ
u'وَجَبَ تَقْيِيد':Subject, #1: 1	وَجَبَ تَقْيِيدُ
u'وَجَبَ تَكْذيبٌ':Subject, #1: 1	وَجَبَ تَقْيِيدُهُ
u'وَجَبَ تَكْميلٌ':Subject, #1: 1	وَجَبَ تَكْذِيبُ
u'وَجَبَ تمام':Subject, #3: 3	وَجَبَ تَكْمِيلُ
u'وَجَبَ تَمامٌ':Subject, #1: 1	وَجَبَ تَمَامُهُ
u'وَجَبَ تمام':Subject, #1: 1	وَجَبَ تَمَامُهُ
u'وَجَبَ تَمامٌ':Subject, #2: 2	وَجَبَ تَمَامُ
u'وَجَبَ تَمْر':Subject, #2: 2	وَجَبَ تَمَامُ
u'وَجَبَ تَمَكُّنٌ':Subject, #1: 1	وَجَبَ التَّمْرُ
u'وَجَبَ تَمْكِينٌ':Subject, #1: 1	وَجَبَ التَّمَكُّنُ
u'وَجَبَ تَمْلِيك':Subject, #1: 1	وَجَبَ تَمْكِينُهُ
u'وَجَبَ تَمْييزٌ':Subject, #1: 1	وَجَبَ التَّمْلِيكُ
u'وَجَبَ تَنَزُّهٌ':Subject, #3: 3	وَجَبَ التَّمْيِيزُ
u'وَجَبَ تَنْزِيلٌ':Subject, #2: 2	وَجَبَ تَنَزُّهُهُ
u'وَجَبَ تَنْزِيهٌ':Subject, #1: 1	وَجَبَ تَنْزِيلُ
u'وَجَبَ تَنْصِيص':Subject, #1: 1	وَجَبَ تَنْزِيهُهُ
u'وَجَبَ تَنْفِيذٌ':Subject, #1: 1	وَجَبَ التَّنْصِيصُ
u'وَجَبَ تَنْفِيذٌ':Subject, #1: 1	وَجَبَ تَنْفِيذُهُ
u'وَجَبَ تَوَجُّهٌ':Subject, #4: 4	وَجَبَ تَنْفِيذُ
u'وَجَبَ تَوْزِيعٌ':Subject, #1: 1	وَجَبَ التَّوَجُّهُ
u'وَجَبَ تَوَصُّلٌ':Subject, #1: 1	وَجَبَ التَّوْزِيعُ
u'وَجَبَ تَوَقُّفٌ':Subject, #2: 2	وَجَبَ التَّوَصُّلُ
u'وَجَبَ تَيَمُّمٌ':Subject, #11: 11	وَجَبَ التَّوَقُّفُ
u'وَجَبَ ثُبُوتٌ':Subject, #1: 1	وَجَبَ التَّيَمُّمُ
u'وَجَبَ ثُبُوتٌ':Subject, #2: 2	وَجَبَ ثُبُوتُهُ
u'وَجَبَ ثَلاثُ':Subject, #4: 4	وَجَبَ ثُبُوتُ
u'وَجَبَ ثَلاثَةٌ':Subject, #3: 3	وَجَبَ ثَلَاثُ
u'وَجَبَ ثَمَنٌ':Subject, #6: 6	وَجَبَ ثَلَاثَةُ
u'وَجَبَ جُزْءٌ':Subject, #2: 2	وَجَبَ الثَّمَنُ
u'وَجَبَ جَزَاءٌ':Subject, #2: 2	وَجَبَ جُزْءٌ
u'وَجَبَ جَزَاءٌ':Subject, #16: 16	وَجَبَ الْجَزَاءُ
u'وَجَبَ جَزَاءٌ':Subject, #1: 1	وَجَبَ جَزَاءٌ
u'وَجَبَ جَنَابَةٌ':Subject, #1: 1	وَجَبَ جَزَاءُ
u'وَجَبَ جهاد':Subject, #1: 1	وَجَبَ الْجَنَابَةُ
u'وَجَبَ جِهَادٌ':Subject, #1: 1	وَجَبَ الْجِهَادُ
u'وَجَبَ جهاد':Subject, #1: 1	وَجَبَ الْجِهَادُ
u'وَجَبَ جِهَادٌ':Subject, #1: 1	وَجَبَ جِهَادُهُ
u'وَجَبَ جهر':Subject, #1: 1	وَجَبَ جِهَادُهُ
u'وَجَبَ جَهْرٌ':Subject, #2: 2	وَجَبَ الْجَهْرُ
u'وَجَبَ حالٌ':Predicate, #2: 2	وَجَبَ الْجَهْرُ
u'وَجَبَ حَبْسٌ':Subject, #4: 4	وَجَبَ حَالَ
u'وَجَبَ حَجٌّ':Subject, #1: 1	وَجَبَ حَبْسُ
u'وَجَبَ حَدٌّ':Subject, #3: 3	وَجَبَ الْحَجُّ
u'وَجَبَ حَدٌّ':Subject, #2: 2	وَجَبَ حَدٌّ
u'وَجَبَ حَدٌّ':Subject, #2: 2	وَجَبَ حَدُّ
u'وَجَبَ حِصَّةٌ':Subject, #48: 48	وَجَبَ الْحَدُّ
u'وَجَبَ حَصْرٌ':Subject, #3: 3	وَجَبَ حِصَّةُ
u'وَجَبَ حُصُول':Subject, #1: 1	وَجَبَ الْحَصْرُ
u'وَجَبَ حَفْرٌ':Subject, #1: 1	وَجَبَ حُصُولُ
u'وَجَبَ حِفْظٌ':Subject, #1: 1	وَجَبَ الْحَفْرُ
u'وَجَبَ حَقٌّ':Subject, #2: 2	وَجَبَ حِفْظُهُ
u'وَجَبَ حَقٌّ':Subject, #1: 1	وَجَبَ الْحَقُّ
u'وَجَبَ حَقٌّ':Subject, #1: 1	وَجَبَ حَقُّهُ
u'وَجَبَ حُكْمٌ':Subject, #3: 3	وَجَبَ حَقُّ
u'وَجَبَ حُكْمٌ':Subject, #15: 15	وَجَبَ الْحُكْمُ
u'وَجَبَ حُكْمٌ':Subject, #1: 1	وَجَبَ حُكْمُ
u'وَجَبَ حَمْلٌ':Subject, #1: 1	وَجَبَ حُكْمُهُ
u'وَجَبَ حَمْلٌ':Subject, #11: 11	وَجَبَ حَمْلُهُ
u'وَجَبَ حَمْلٌ':Subject, #4: 4	وَجَبَ حَمْلُ
u'وَجَبَ خَارِجٌ':Predicate, #8: 8	وَجَبَ الْحَمْلُ
u'وَجَبَ خراج':Subject, #2: 2	وَجَبَ خَارِجَ
u'وَجَبَ خَرَاجٌ':Subject, #1: 1	وَجَبَ خَرَاجُ
u'وَجَبَ خراج':Subject, #1: 1	وَجَبَ خَرَاجُ
u'وَجَبَ خَرَاجٌ':Subject, #5: 5	وَجَبَ الْخَرَاجُ
u'وَجَبَ خُرُوجٌ':Subject, #5: 5	وَجَبَ الْخَرَاجُ
u'وَجَبَ خَلَفٌ':Subject, #5: 5	وَجَبَ الْخُرُوجُ
u'وَجَبَ خُمُسٌ':Subject, #1: 1	وَجَبَ خَلَفُ
u'وَجَبَ خُمْسٌ':Subject, #1: 1	وَجَبَ الْخُمُسُ
u'وَجَبَ خَمْسٌ':Subject, #1: 1	وَجَبَ الْخُمْسُ
u'وَجَبَ خَمْسَةٌ':Subject, #1: 1	وَجَبَ خَمْسٌ
u'وَجَبَ خَمْسَةٌ':Subject, #1: 1	وَجَبَ خَمْسَةُ
u'وَجَبَ دفع':Subject, #3: 3	وَجَبَ خَمْسَةٌ
u'وَجَبَ دَفْعٌ':Subject, #1: 1	وَجَبَ دَفْعُ
u'وَجَبَ دفع':Subject, #1: 1	وَجَبَ دَفْعُ
u'وَجَبَ دَفْعٌ':Subject, #6: 6	وَجَبَ الدَّفْعُ
u'وَجَبَ دفع':Subject, #6: 6	وَجَبَ الدَّفْعُ
u'وَجَبَ دَفْعٌ':Subject, #9: 9	وَجَبَ دَفْعُهُ
u'وَجَبَ دَمٌ':Subject, #9: 9	وَجَبَ دَفْعُهُ
u'وَجَبَ دَمٌ':Subject, #13: 13	وَجَبَ الدَّمُ
u'وَجَبَ دَمٌ':Subject, #1: 1	وَجَبَ دَمُهُ
u'وَجَبَ دَمٌ':Subject, #3: 3	وَجَبَ دَمُ
u'وَجَبَ دِيَةٌ':Subject, #7: 7	وَجَبَ دَمٌ
u'وَجَبَ دَيْنٌ':Subject, #1: 1	وَجَبَ الدِّيَةُ
u'وَجَبَ دَيْنٌ':Subject, #19: 19	وَجَبَ الدَّيْنُ
u'وَجَبَ دَيْنٌ':Subject, #1: 1	وَجَبَ دَيْنُ
u'وَجَبَ دَيْنٌ':Subject, #1: 1	وَجَبَ دَيْنُهُ
u'وَجَبَ دُيونٌ':Subject, #2: 2	وَجَبَ دَيْنٌ
u'وَجَبَ ذكر':Subject, #1: 1	وَجَبَ دُيُونٌ
u'وَجَبَ ذِكْرٌ':Subject, #2: 2	وَجَبَ الذِّكْرُ
u'وَجَبَ ذكر':Subject, #2: 2	وَجَبَ الذِّكْرُ
u'وَجَبَ ذِكْرٌ':Subject, #4: 4	وَجَبَ ذِكْرُ
u'وَجَبَ ذكر':Subject, #4: 4	وَجَبَ ذِكْرُ
u'وَجَبَ ذِكْرٌ':Subject, #4: 4	وَجَبَ ذِكْرُهُ
u'وَجَبَ رَاجِحٌ':Subject, #4: 4	وَجَبَ ذِكْرُهُ
u'وَجَبَ رُبْعٌ':Subject, #1: 1	وَجَبَ الرَّاجِحُ
u'وَجَبَ رُبُعٌ':Subject, #1: 1	وَجَبَ رُبْعُ
u'وَجَبَ رَجْمٌ':Subject, #3: 3	وَجَبَ رُبُعُ
u'وَجَبَ رَجْمٌ':Subject, #2: 2	وَجَبَ رَجْمُهُ
u'وَجَبَ رُجُوعٌ':Subject, #3: 3	وَجَبَ الرَّجْمُ
u'وَجَبَ رَدٌّ':Subject, #13: 13	وَجَبَ الرُّجُوعُ
u'وَجَبَ رَدٌّ':Subject, #11: 11	وَجَبَ الرَّدُّ
u'وَجَبَ رَدٌّ':Subject, #21: 21	وَجَبَ رَدُّ
u'وَجَبَ رَضْخ':Subject, #28: 28	وَجَبَ رَدُّهُ
u'وَجَبَ رِعايَةٌ':Subject, #2: 2	وَجَبَ الرَّضْخُ
u'وَجَبَ رَفْضٌ':Subject, #1: 1	وَجَبَ رِعَايَةُ
u'وَجَبَ رَفْعٌ':Subject, #1: 1	وَجَبَ الرَّفْضُ
u'وَجَبَ رَمْيٌ':Predicate, #1: 1	وَجَبَ الرَّفْعُ
u'وَجَبَ رَمْيٌ':Subject, #1: 1	وَجَبَ الرَّمْيَ
u'وَجَبَ زَكاةٌ':Subject, #1: 1	وَجَبَ رَمْيُ
u'وَجَبَ زَوالٌ':Subject, #3: 3	وَجَبَ زَكَاةُ
u'وَجَبَ زِيادَةٌ':Subject, #1: 1	وَجَبَ زَوَالُهُ
u'وَجَبَ سَبَبٌ':Subject, #2: 2	وَجَبَ زِيَادَةُ
u'وَجَبَ سِتْرٌ':Subject, #1: 1	وَجَبَ السَّبَبُ
u'وَجَبَ سَتْرٌ':Subject, #1: 1	وَجَبَ سِتْرُ
u'وَجَبَ سَتْرٌ':Subject, #2: 2	وَجَبَ السَّتْرُ
u'وَجَبَ سُجُودٌ':Subject, #4: 4	وَجَبَ سَتْرُ
u'وَجَبَ سُجُودٌ':Subject, #1: 1	وَجَبَ سُجُودُ
u'وَجَبَ سَدٌّ':Subject, #4: 4	وَجَبَ السُّجُودُ
u'وَجَبَ سَفْحٌ':Subject, #1: 1	وَجَبَ سَدُّ
u'وَجَبَ سَفَرٌ':Subject, #1: 1	وَجَبَ سَفْحُ
u'وَجَبَ سقط':Predicate, #1: 1	وَجَبَ السَّفَرُ
u'وَجَبَ سَقَطٌ':Predicate, #1: 1	وَجَبَ سَقَطَ
u'وَجَبَ سُقُوطٌ':Subject, #1: 1	وَجَبَ سَقَطَ
u'وَجَبَ سِنٌّ':Subject, #1: 1	وَجَبَ سُقُوطُ
u'وَجَبَ سُنَّةٌ':Subject, #1: 1	وَجَبَ سِنٌّ
u'وَجَبَ سَهْوٌ':Subject, #1: 1	وَجَبَ سُنَّةُ
u'وَجَبَ سُؤَالٌ':Subject, #4: 4	وَجَبَ السَّهْوُ
u'وَجَبَ سُؤَالٌ':Subject, #1: 1	وَجَبَ السُّؤَالُ
u'وَجَبَ سؤل':Subject, #1: 1	وَجَبَ سُؤَالُ
u'وَجَبَ شَاةٌ':Subject, #1: 1	وَجَبَ سُؤْلُ
u'وَجَبَ شَرْطٌ':Subject, #1: 1	وَجَبَ شَاةٌ
u'وَجَبَ شفعة':Subject, #2: 2	وَجَبَ شَرْطُ
u'وَجَبَ شُفْعَةٌ':Subject, #1: 1	وَجَبَ الشُّفْعَةُ
u'وَجَبَ شفق':Subject, #1: 1	وَجَبَ الشُّفْعَةُ
u'وَجَبَ شَفَقٌ':Subject, #1: 1	وَجَبَ الشَّفَقُ
u'وَجَبَ شكر':Subject, #1: 1	وَجَبَ الشَّفَقُ
u'وَجَبَ شُكْرٌ':Subject, #1: 1	وَجَبَ شُكْرُهُ
u'وَجَبَ شَيْءٌ':Subject, #1: 1	وَجَبَ شُكْرُهُ
u'وَجَبَ صداق':Subject, #1: 1	وَجَبَ شَيْءٌ
u'وَجَبَ صَدَاقٌ':Subject, #16: 16	وَجَبَ الصَّدَاقُ
u'وَجَبَ صدق':Subject, #16: 16	وَجَبَ الصَّدَاقُ
u'وَجَبَ صِدْقٌ':Subject, #2: 2	وَجَبَ صِدْقُهُ
u'وَجَبَ صَرْفٌ':Subject, #2: 2	وَجَبَ صِدْقُهُ
u'وَجَبَ صَرْف':Subject, #1: 1	وَجَبَ صَرْفُ
u'وَجَبَ صَرْفٌ':Subject, #1: 1	وَجَبَ صَرْفُ
u'وَجَبَ صَرْف':Subject, #2: 2	وَجَبَ الصَّرْفُ
u'وَجَبَ صَرْفٌ':Subject, #2: 2	وَجَبَ الصَّرْفُ
u'وَجَبَ صَرْف':Subject, #5: 5	وَجَبَ صَرْفُهُ
u'وَجَبَ صَفِيقٌ':Subject, #5: 5	وَجَبَ صَرْفُهُ
u'وَجَبَ صَوْمٌ':Subject, #1: 1	وَجَبَ صَفِيقٌ
u'وَجَبَ صَوْمٌ':Subject, #3: 3	وَجَبَ صَوْمُهُ
u'وَجَبَ صِيَامٌ':Subject, #9: 9	وَجَبَ الصَّوْمُ
u'وَجَبَ ضَرْبٌ':Subject, #1: 1	وَجَبَ صِيَامُهُ
u'وَجَبَ ضَرُورَةٌ':Predicate, #1: 1	وَجَبَ ضَرْبُهُ
u'وَجَبَ ضَرُورَةٌ':Subject, #1: 1	وَجَبَ ضَرُورَةَ
u'وَجَبَ ضَمٌّ':Subject, #1: 1	وَجَبَ ضَرُورَةُ
u'وَجَبَ ضَمٌّ':Subject, #1: 1	وَجَبَ الضَّمُّ
u'وَجَبَ ضَمٌّ':Subject, #1: 1	وَجَبَ ضَمُّ
u'وَجَبَ ضَمَانٌ':Subject, #1: 1	وَجَبَ ضَمُّهُ
u'وَجَبَ ضَمَانٌ':Subject, #11: 11	وَجَبَ ضَمَانُ
u'وَجَبَ ضَمَانٌ':Subject, #1: 1	وَجَبَ ضَمَانٌ
u'وَجَبَ ضَمَانٌ':Subject, #49: 49	وَجَبَ الضَّمَانُ
u'وَجَبَ طَالِبٌ':Subject, #4: 4	وَجَبَ ضَمَانُهُ
u'وَجَبَ طَرْحٌ':Subject, #1: 1	وَجَبَ الطَّالِبُ
u'وَجَبَ طَرْدٌ':Subject, #1: 1	وَجَبَ طَرْحُهُ
u'وَجَبَ طَلاَقٌ':Subject, #1: 1	وَجَبَ طَرْدُهُ
u'وَجَبَ طلب':Subject, #1: 1	وَجَبَ الطَّلَاقُ
u'وَجَبَ طَلَبٌ':Subject, #1: 1	وَجَبَ طَلَبُ
u'وَجَبَ طلب':Subject, #1: 1	وَجَبَ طَلَبُ
u'وَجَبَ طَلَبٌ':Subject, #1: 1	وَجَبَ طَلَبُهُ
u'وَجَبَ طلب':Subject, #1: 1	وَجَبَ طَلَبُهُ
u'وَجَبَ طَلَبٌ':Subject, #4: 4	وَجَبَ الطَّلَبُ
u'وَجَبَ ظَرْفٌ':Subject, #4: 4	وَجَبَ الطَّلَبُ
u'وَجَبَ ظُهْرٌ':Subject, #1: 1	وَجَبَ الظَّرْفُ
u'وَجَبَ عَبْدٌ':Subject, #1: 1	وَجَبَ الظُّهْرُ
u'وَجَبَ عتق':Subject, #2: 2	وَجَبَ الْعَبْدُ
u'وَجَبَ عِتْقٌ':Subject, #1: 1	وَجَبَ عِتْقُ
u'وَجَبَ عتق':Subject, #1: 1	وَجَبَ عِتْقُ
u'وَجَبَ عِتْقٌ':Subject, #2: 2	وَجَبَ الْعِتْقُ
u'وَجَبَ عَذَابٌ':Subject, #2: 2	وَجَبَ الْعِتْقُ
u'وَجَبَ عزل':Subject, #1: 1	وَجَبَ الْعَذَابُ
u'وَجَبَ عَزْمٌ':Subject, #5: 5	وَجَبَ عَزْلُهُ
u'وَجَبَ عُشْرٌ':Predicate, #1: 1	وَجَبَ الْعَزْمُ
u'وَجَبَ عُشْرٌ':Subject, #1: 1	وَجَبَ الْعُشْرَ
u'وَجَبَ عقر':Subject, #15: 15	وَجَبَ الْعُشْرُ
u'وَجَبَ عُقْرٌ':Subject, #10: 10	وَجَبَ الْعُقْرُ
u'وَجَبَ عَقْلٌ':Subject, #10: 10	وَجَبَ الْعُقْرُ
u'وَجَبَ علم':Subject, #1: 1	وَجَبَ الْعَقْلُ
u'وَجَبَ عِلْمٌ':Subject, #1: 1	وَجَبَ عِلْمٌ
u'وَجَبَ عَمَلٌ':Subject, #1: 1	وَجَبَ عِلْمٌ
u'وَجَبَ عَمَلٌ':Subject, #28: 28	وَجَبَ الْعَمَلُ
u'وَجَبَ عُمُومٌ':Subject, #3: 3	وَجَبَ عَمَلُهُ
u'وَجَبَ عند':Predicate, #1: 1	وَجَبَ الْعُمُومُ
u'وَجَبَ عَوْدٌ':Subject, #4: 4	وَجَبَ عِنْدَ
u'وَجَبَ عَوْدٌ':Subject, #1: 1	وَجَبَ عَوْدُ
u'وَجَبَ غَسْلٌ':Subject, #3: 3	وَجَبَ الْعَوْدُ
u'وَجَبَ غَسْلٌ':Subject, #17: 17	وَجَبَ غَسْلُهُ
u'وَجَبَ غُسْلٌ':Subject, #1: 1	وَجَبَ الْغَسْلُ
u'وَجَبَ غَسْلٌ':Subject, #2: 2	وَجَبَ غُسْلٌ
u'وَجَبَ غُسْلٌ':Subject, #31: 31	وَجَبَ غَسْلُ
u'وَجَبَ غُسْلٌ':Subject, #3: 3	وَجَبَ غُسْلُ
u'وَجَبَ غُسْلٌ':Subject, #56: 56	وَجَبَ الْغُسْلُ
u'وَجَبَ غير':Subject, #5: 5	وَجَبَ غُسْلُهُ
u'وَجَبَ غَيْرٌ':Subject, #1: 1	وَجَبَ غَيْرُهُ
u'وَجَبَ فِدْيَةٌ':Subject, #1: 1	وَجَبَ غَيْرُهُ
u'وَجَبَ فَرْضٌ':Predicate, #2: 2	وَجَبَ الْفِدْيَةُ
u'وَجَبَ فَرْضٌ':Subject, #1: 1	وَجَبَ فَرْضَ
u'وَجَبَ فرق':Subject, #1: 1	وَجَبَ الْفَرْضُ
u'وَجَبَ فَرْقٌ':Subject, #1: 1	وَجَبَ الْفَرْقُ
u'وَجَبَ فَسْخٌ':Subject, #1: 1	وَجَبَ الْفَرْقُ
u'وَجَبَ فَسْخٌ':Subject, #1: 1	وَجَبَ الْفَسْخُ
u'وَجَبَ فَصْلٌ':Subject, #2: 2	وَجَبَ فَسْخُهُ
u'وَجَبَ فَصْلٌ':Subject, #1: 1	وَجَبَ الْفَصْلُ
u'وَجَبَ فِطْرٌ':Subject, #1: 1	وَجَبَ فَصْلُ
u'وَجَبَ فِعْلٌ':Subject, #4: 4	وَجَبَ الْفِطْرُ
u'وَجَبَ فِعْلٌ':Subject, #2: 2	وَجَبَ الْفِعْلُ
u'وَجَبَ فَلًا':Predicate, #4: 4	وَجَبَ فِعْلُهُ
u'وَجَبَ فلان':Subject, #3: 3	وَجَبَ فَلاَ
u'وَجَبَ فَوْرٌ':Subject, #1: 1	وَجَبَ جُبْرَانُ
u'وَجَبَ قَالٌ':Predicate, #1: 1	وَجَبَ الْفَوْرُ
u'وَجَبَ قَبْضٌ':Subject, #3: 3	وَجَبَ قَالَ
u'وَجَبَ قَبْضٌ':Subject, #2: 2	وَجَبَ الْقَبْضُ
u'وَجَبَ قَبُولٌ':Subject, #2: 2	وَجَبَ قَبْضُ
u'وَجَبَ قَبُولٌ':Subject, #15: 15	وَجَبَ قَبُولُهُ
u'وَجَبَ قَبُولٌ':Subject, #4: 4	وَجَبَ الْقَبُولُ
u'وَجَبَ قتال':Subject, #9: 9	وَجَبَ قَبُولُ
u'وَجَبَ قِتَالٌ':Subject, #1: 1	وَجَبَ قِتَالُ
u'وَجَبَ قتل':Subject, #1: 1	وَجَبَ قِتَالُ
u'وَجَبَ قَتْلٌ':Subject, #15: 15	وَجَبَ قَتْلُهُ
u'وَجَبَ قِرَاءةٌ':Subject, #15: 15	وَجَبَ قَتْلُهُ
u'وَجَبَ قِسْطٌ':Subject, #1: 1	وَجَبَ الْقِرَاءَةُ
u'وَجَبَ قِسْطٌ':Subject, #1: 1	وَجَبَ الْقِسْطُ
u'وَجَبَ قَسْمٌ':Subject, #2: 2	وَجَبَ قِسْطُهُ
u'وَجَبَ قِسْمٌ':Subject, #1: 1	وَجَبَ قَسْمُ
u'وَجَبَ قسمة':Subject, #1: 1	وَجَبَ قِسْمُ
u'وَجَبَ قِسْمَةٌ':Subject, #1: 1	وَجَبَ قِسْمَةُ
u'وَجَبَ قصاص':Subject, #1: 1	وَجَبَ قِسْمَةُ
u'وَجَبَ قِصَاصٌ':Subject, #60: 60	وَجَبَ الْقِصَاصُ
u'وَجَبَ قَصْرٌ':Subject, #60: 60	وَجَبَ الْقِصَاصُ
u'وَجَبَ قَضَاءٌ':Subject, #1: 1	وَجَبَ قَصْرُهُ
u'وَجَبَ قَضَاءٌ':Subject, #17: 17	وَجَبَ قَضَاءُ
u'وَجَبَ قَضَاءٌ':Subject, #2: 2	وَجَبَ قَضَاءٌ
u'وَجَبَ قَطْعٌ':Subject, #37: 37	وَجَبَ الْقَضَاءُ
u'وَجَبَ قَطْعٌ':Subject, #18: 18	وَجَبَ الْقَطْعُ
u'وَجَبَ قَطْعٌ':Subject, #2: 2	وَجَبَ قَطْعُهُ
u'وَجَبَ قَوَد':Subject, #7: 7	وَجَبَ قَطْعُ
u'وَجَبَ قول':Subject, #13: 13	وَجَبَ الْقَوَدُ
u'وَجَبَ قَوْلٌ':Subject, #7: 7	وَجَبَ الْقَوْلُ
u'وَجَبَ قِيَاسٌ':Subject, #7: 7	وَجَبَ الْقَوْلُ
u'وَجَبَ قيام':Subject, #1: 1	وَجَبَ الْقِيَاسُ
u'وَجَبَ قِيَامٌ':Subject, #1: 1	وَجَبَ الْقِيَامُ
u'وَجَبَ قيام':Subject, #1: 1	وَجَبَ الْقِيَامُ
u'وَجَبَ قِيَامٌ':Subject, #1: 1	وَجَبَ قِيَامُ
u'وَجَبَ قِيَامٌ':Subject, #1: 1	وَجَبَ قِيَامٌ
u'وَجَبَ قِيمَةٌ':Subject, #1: 1	وَجَبَ قِيَامُ
u'وَجَبَ قِيمَةٌ':Subject, #3: 3	وَجَبَ الْقِيمَةُ
u'وَجَبَ قِيمَةٌ':Subject, #3: 3	وَجَبَ قِيمَةُ
u'وَجَبَ كَامِلٌ':Subject, #3: 3	وَجَبَ قِيمَتُهُ
u'وَجَبَ كَسْرٌ':Subject, #1: 1	وَجَبَ الْكَامِلُ
u'وَجَبَ كَسْرٌ':Subject, #1: 1	وَجَبَ الْكَسْرُ
u'وَجَبَ كَفٌّ':Subject, #1: 1	وَجَبَ كَسْرُهُ
u'وَجَبَ كَفَّارَةٌ':Subject, #5: 5	وَجَبَ الْكَفُّ
u'وَجَبَ كَفَنٌ':Subject, #2: 2	وَجَبَ كَفَّارَةٌ
u'وَجَبَ كَفَنٌ':Subject, #1: 1	وَجَبَ الْكَفَنُ
u'وَجَبَ كَلاَمٌ':Subject, #2: 2	وَجَبَ كَفَنُهُ
u'وَجَبَ كَمَالٌ':Subject, #1: 1	وَجَبَ الْكَلَامُ
u'وَجَبَ كَوْنٌ':Subject, #3: 3	وَجَبَ كَمَالُ
u'وَجَبَ كَوْنٌ':Subject, #1: 1	وَجَبَ كَوْنُ
u'وَجَبَ لعان':Subject, #3: 3	وَجَبَ كَوْنُهُ
u'وَجَبَ مَاءٌ':Subject, #8: 8	وَجَبَ اللِّعَانُ
u'وَجَبَ مَالٌ':Subject, #3: 3	وَجَبَ الْمَاءُ
u'وَجَبَ مَالٌ':Subject, #19: 19	وَجَبَ الْمَالُ
u'وَجَبَ مُبَادَرَةٌ':Subject, #2: 2	وَجَبَ مَالٌ
u'وَجَبَ مَبِيتٌ':Subject, #1: 1	وَجَبَ الْمُبَادَرَةُ
u'وَجَبَ مُتَابَعٌ':Subject, #1: 1	وَجَبَ الْمَبِيتُ
u'وَجَبَ مُتَابَعَةٌ':Subject, #1: 1	وَجَبَ مُتَابَعَتُهُ
u'وَجَبَ مُتَكَرِّرٌ':Subject, #1: 1	وَجَبَ مُتَابَعَتُهُ
u'وَجَبَ مثل':Subject, #1: 1	وَجَبَ الْمُتَكَرِّرُ
u'وَجَبَ مِثْلٌ':Subject, #1: 1	وَجَبَ مِثْلُ
u'وَجَبَ مثل':Subject, #1: 1	وَجَبَ مِثْلُ
u'وَجَبَ مِثْلٌ':Subject, #2: 2	وَجَبَ مِثْلُهُ
u'وَجَبَ مثل':Subject, #2: 2	وَجَبَ مِثْلُهُ
u'وَجَبَ مِثْلٌ':Subject, #6: 6	وَجَبَ الْمِثْلُ
u'وَجَبَ مَجَازِيٌّ':Subject, #6: 6	وَجَبَ الْمِثْلُ
u'وَجَبَ مُرَاعَاةٌ':Subject, #2: 2	وَجَبَ مَجَازِيَّتُهُ
u'وَجَبَ مُرَاعَاةٌ':Subject, #1: 1	وَجَبَ مُرَاعَاةُ
u'وَجَبَ مَسْحٌ':Subject, #1: 1	وَجَبَ مُرَاعَاتُهُ
u'وَجَبَ مَسْحٌ':Subject, #2: 2	وَجَبَ الْمَسْحُ
u'وَجَبَ مُسِنٌّ':Subject, #2: 2	وَجَبَ مَسْحُ
u'وَجَبَ مُشَارَكَةٌ':Subject, #1: 1	وَجَبَ مُسِنٌّ
u'وَجَبَ مَصِيرٌ':Subject, #1: 1	وَجَبَ الْمُشَارَكَةُ
u'وَجَبَ مُضِيٌّ':Subject, #7: 7	وَجَبَ الْمَصِيرُ
u'وَجَبَ مُطَالَبٌ':Subject, #1: 1	وَجَبَ الْمُضِيُّ
u'وَجَبَ مُطَالَبَةٌ':Subject, #1: 1	وَجَبَ مُطَالَبَتُهُ
u'وَجَبَ مَعْرِفَةٌ':Subject, #1: 1	وَجَبَ مُطَالَبَتُهُ
u'وَجَبَ مَعْرِفَة':Subject, #2: 2	وَجَبَ مَعْرِفَةُ
u'وَجَبَ مُقَارَنٌ':Subject, #2: 2	وَجَبَ مَعْرِفَةُ
u'وَجَبَ مُقَارَنَةٌ':Subject, #1: 1	وَجَبَ مُقَارَنَةُ
u'وَجَبَ مُقَدَّرٌ':Subject, #1: 1	وَجَبَ مُقَارَنَةُ
u'وَجَبَ مَنْعٌ':Subject, #1: 1	وَجَبَ مُقَدَّرٌ
u'وَجَبَ مَهْرٌ':Subject, #2: 2	وَجَبَ الْمَنْعُ
u'وَجَبَ مَهْرٌ':Subject, #19: 19	وَجَبَ الْمَهْرُ
u'وَجَبَ مَهْرٌ':Subject, #42: 42	وَجَبَ مَهْرُ
u'وَجَبَ مِيرَاثٌ':Subject, #6: 6	وَجَبَ مَهْرٌ
u'وَجَبَ نَبْذٌ':Subject, #1: 1	وَجَبَ الْمِيرَاثُ
u'وَجَبَ نذر':Subject, #1: 1	وَجَبَ نَبْذُ
u'وَجَبَ نَذْرٌ':Subject, #1: 1	وَجَبَ النَّذْرُ
u'وَجَبَ نَزَحَ':Subject, #1: 1	وَجَبَ النَّذْرُ
u'وَجَبَ نَزَح':Subject, #1: 1	وَجَبَ النَّزَحُ
u'وَجَبَ نَزْعٌ':Subject, #1: 1	وَجَبَ النَّزَحُ
u'وَجَبَ نَزْعٌ':Subject, #3: 3	وَجَبَ النَّزْعُ
u'وَجَبَ نَزْعٌ':Subject, #3: 3	وَجَبَ نَزْعُهُ
u'وَجَبَ نَصٌّ':Predicate, #4: 4	وَجَبَ نَزْعُ
u'وَجَبَ نصرة':Subject, #1: 1	وَجَبَ نَصَّ
u'وَجَبَ نُصْرَةٌ':Subject, #1: 1	وَجَبَ نُصْرَةٌ
u'وَجَبَ نِصْفٌ':Subject, #1: 1	وَجَبَ نُصْرَةٌ
u'وَجَبَ نِصْفٌ':Subject, #18: 18	وَجَبَ نِصْفُ
u'وَجَبَ نضح':Subject, #5: 5	وَجَبَ النِّصْفُ
u'وَجَبَ نَضْحٌ':Subject, #1: 1	وَجَبَ نَضْحُهُ
u'وَجَبَ نَظَرٌ':Subject, #1: 1	وَجَبَ نَضْحُهُ
u'وَجَبَ نُقْصَانٌ':Subject, #7: 7	وَجَبَ النَّظَرُ
u'وَجَبَ نَقْضٌ':Subject, #1: 1	وَجَبَ النُّقْصَانُ
u'وَجَبَ نَقْضٌ':Subject, #3: 3	وَجَبَ النَّقْضُ
u'وَجَبَ نَقْضٌ':Subject, #3: 3	وَجَبَ نَقْضُ
u'وَجَبَ نقل':Subject, #4: 4	وَجَبَ نَقْضُهُ
u'وَجَبَ نَقْلٌ':Subject, #2: 2	وَجَبَ نَقْلُهُ
u'وَجَبَ هَدْمٌ':Subject, #2: 2	وَجَبَ نَقْلُهُ
u'وَجَبَ هَدْيٌ':Subject, #2: 2	وَجَبَ هَدْمُهُ
u'وَجَبَ وَجَبٌ':Predicate, #1: 1	وَجَبَ الْهَدْيُ
u'وَجَبَ وُجُودٌ':Subject, #1: 1	وَجَبَ وَجَبَ
u'وَجَبَ وَصْفٌ':Subject, #1: 1	وَجَبَ وُجُودُهُ
u'وَجَبَ وصل':Subject, #1: 1	وَجَبَ وَصْفُهُ
u'وَجَبَ وَصْلٌ':Subject, #1: 1	وَجَبَ وَصْلُهُ
u'وَجَبَ وَضْعٌ':Subject, #1: 1	وَجَبَ وَصْلُهُ
u'وَجَبَ وُضُوءٌ':Subject, #1: 1	وَجَبَ وَضْعُهُ
u'وَجَبَ وَطْءٌ':Subject, #9: 9	وَجَبَ الْوُضُوءُ
u'وَجَبَ وَفَاءٌ':Subject, #2: 2	وَجَبَ الْوَطْءُ
u'وَجَبَ وَفَاءٌ':Subject, #1: 1	وَجَبَ وَفَاءُ
u'وَجَبَ وَقْتٌ':Subject, #3: 3	وَجَبَ الْوَفَاءُ
u'وَجَبَ وَقْفٌ':Subject, #1: 1	وَجَبَ الْوَقْتُ
u'وَجَبَ وَقْفٌ':Subject, #1: 1	وَجَبَ الْوَقْفُ
u'وَجَبَ وُقُوفٌ':Subject, #1: 1	وَجَبَ وَقْفُهُ
u'وَجَبَ وَلاَءٌ':Subject, #3: 3	وَجَبَ الْوُقُوفُ
u'وَجَبَ يَقِينٌ':Subject, #3: 3	وَجَبَ الْوَلَاءُ
u'وَجَبَ يَمِينٌ':Subject, #1: 1	وَجَبَ الْيَقِينُ
u'وَجَبَ يَوْمٌ':Predicate, #1: 1	وَجَبَ يَمِينٌ
u'وَجَدَ أَبٌ':Subject, #1: 1	وَجَبَ يَوْمَ
u'وَجَدَ اِبْنٌ':Subject, #3: 3	وَجَدَ الْأَبُ
u'وَجَدَ أثَرٌ':Predicate, #2: 2	وَجَدَ ابْنُ
u'وَجَدَ أَجِيرٌ':Predicate, #1: 1	وَجَدَ أَثَرَ
u'وَجَدَ أَجِيرٌ':Subject, #1: 1	وَجَدَ الْأَجِيرَ
u'وَجَدَ أحَدٌ':Predicate, #1: 1	وَجَدَ الْأَجِيرُ
u'وَجَدَ أحَدٌ':Subject, #4: 4	وَجَدَ أَحَدَ
u'وَجَدَ أحَدٌ':Subject, #1: 1	وَجَدَ أَحَدٌ
u'وَجَدَ أَحْسَنُ':Predicate, #3: 3	وَجَدَ أَحَدُ
u'وَجَدَ اِخْتِلاَفٌ':Predicate, #2: 2	وَجَدَ أَحْسَنَ
u'وَجَدَ آدَمُ':Predicate, #1: 1	وَجَدَ اخْتِلَافَ
u'وَجَدَ أرْضٌ':Predicate, #1: 1	وَجَدَ آدَمَ
u'وَجَدَ اِسْتِدَامَةٌ':Predicate, #2: 2	وَجَدَ الأَرْضَ
u'وَجَدَ أَشْجَارٌ':Predicate, #1: 1	وَجَدَ اسْتِدَامَةَ
u'وَجَدَ أَصْحَابٌ':Subject, #1: 1	وَجَدَ الْأَشْجَارَ
u'وَجَدَ أصل':Predicate, #1: 1	وَجَدَ أَصْحَابُهُ
u'وَجَدَ أًصْلٌ':Predicate, #1: 1	وَجَدَ الْأَصْلَ
u'وَجَدَ أَصْنَافٌ':Predicate, #1: 1	وَجَدَ الْأَصْلَ
u'وَجَدَ إقْرَارٌ':Predicate, #1: 1	وَجَدَ الْأَصْنَافَ
u'وَجَدَ أقَلُّ':Predicate, #1: 1	وَجَدَ إقْرَارَ
u'وَجَدَ أَكْثَرُ':Predicate, #2: 2	وَجَدَ أَقَلَّ
u'وَجَدَ أَكْثَرُ':Predicate, #1: 1	وَجَدَ أَكْثَرَ
u'وَجَدَ أكل':Predicate, #3: 3	وَجَدَ الْأَكْثَرَ
u'وَجَدَ أَكْلٌ':Predicate, #1: 1	وَجَدَ الْأَكْلَ
u'وَجَدَ ألف':Predicate, #1: 1	وَجَدَ الْأَكْلَ
u'وَجَدَ ألْفٌ':Predicate, #1: 1	وَجَدَ الْأَلْفَ
u'وَجَدَ أَلْفٌ':Predicate, #1: 1	وَجَدَ الْأَلْفَ
u'وَجَدَ الْمَرْأَةُ':Predicate, #1: 1	وَجَدَ الْأَلْفَ
u'وَجَدَ إلَهٌ':Subject, #1: 1	وَجَدَ الْمَرْأَةَ
u'وَجَدَ أَلْوَانٌ':Predicate, #1: 1	وَجَدَ الْإِلَهُ
u'وَجْدٌ أُمٌّ':Added, #1: 1	نَجِدَ الْأَلْوَانَ
u'وَجَدَ أمَارَةٌ':Predicate, #3: 3	وَجْدِ أُمِّهِ
u'وَجَدَ إمَامٌ':Predicate, #1: 1	وَجَدَ أَمَارَةَ
u'وَجَدَ إمَامٌ':Predicate, #1: 1	وَجَدَ الإِمَامَ
u'وَجَدَ إمَامٌ':Subject, #3: 3	وَجَدَ الْإِمَامَ
u'وَجَدَ أمَةٌ':Predicate, #2: 2	وَجَدَ الْإِمَامُ
u'وَجَدَ آمِرٌ':Subject, #1: 1	وَجَدَ الْأَمَةَ
u'وَجَدَ أُمُورٌ':Predicate, #3: 3	وَجَدَ الْآمِرُ
u'وِجْدَانٌ أحَدٌ':Added, #1: 1	وَجَدَ الْأُمُورَ
u'وِجْدَانٌ أصل':Added, #1: 1	وِجْدَانِ أَحَدِ
u'وِجْدَانٌ أًصْلٌ':Added, #1: 1	وِجْدَانِ الْأَصْلِ
u'وِجْدَانٌ حَجْمٌ':Added, #1: 1	وِجْدَانِ الْأَصْلِ
u'وِجْدَانٌ حَجْمٌ':Added, #1: 1	وِجْدَانِ الْحَجْمِ
u'وِجْدَانٌ خِصَالٌ':Added, #1: 1	وِجْدَانَ حَجْمِ
u'وَجَدَ إِنْسانٌ':Subject, #1: 1	وِجْدَانِ الْخِصَالِ
u'وِجْدَانٌ شَرْطٌ':Added, #1: 1	وَجَدَ الْإِنْسَانُ
u'وِجْدَانٌ شِقٌّ':Added, #1: 1	وِجْدَانُ الشَّرْطِ
u'وِجْدَانٌ عَبْدٌ':Added, #1: 1	وِجْدَانُ شِقٍّ
u'وَجَدَ اِنْفِجارٌ':Predicate, #1: 1	وِجْدَانِ الْعَبْدِ
u'وِجْدَانٌ مُلُوحَةٌ':Added, #1: 1	وَجَدَ انْفِجَارَ
u'وِجْدَانٌ نَصٌّ':Added, #2: 2	وِجْدَانِ الْمُلُوحَةِ
u'وَجَدَ أَوَّلُ':Predicate, #1: 1	وِجْدَانِ النَّصِّ
u'وَجَدَ أَوَّلُ':Subject, #2: 2	وَجَدَ الْأَوَّلَ
u'وَجَدَ بَابٌ':Predicate, #2: 2	وَجَدَ الْأَوَّلُ
u'وَجَدَ بَابٌ':Predicate, #1: 1	وَجَدَ الْبَابَ
u'وَجَدَ باقِي':Predicate, #1: 1	وَجَدَ بَابَ
u'وَجَدَ بَائِعٌ':Predicate, #4: 4	وَجَدَ الْبَاقِيَ
u'وَجَدَ بَائِعٌ':Subject, #1: 1	وَجَدَ الْبَائِعَ
u'وَجَدَ بَائِعٌ':Subject, #12: 12	وَجَدَ الْبَائِعُ
u'وَجَدَ بَثْر':Predicate, #2: 2	وَجَدَ بَائِعُ
u'وَجَدَ بَرْدٌ':Predicate, #1: 1	وَجَدَ الْبَثْرَةَ
u'وَجَدَ بَعْضٌ':Predicate, #1: 1	وَجَدَ بَرْدَ
u'وَجَدَ بَعْضٌ':Predicate, #17: 17	وَجَدَ بَعْضَ
u'وَجَدَ بَعْضٌ':Subject, #9: 9	وَجَدَ الْبَعْضَ
u'وَجَدَ بَعْضٌ':Subject, #1: 1	وَجَدَ الْبَعْضُ
u'وَجَدَ بَقَرٌ':Predicate, #1: 1	وَجَدَ بَعْضُ
u'وَجَدَ بَقِيَّةٌ':Predicate, #1: 1	وَجَدَ بَقَرَةً
u'وَجَدَ بِنْتٌ':Predicate, #1: 1	وَجَدَ الْبَقِيَّةَ
u'وَجَدَ بَوْلٌ':Predicate, #1: 1	وَجَدَ بِنْتَ
u'وَجَدَ بَيْتٌ':Predicate, #1: 1	وَجَدَ بَوْلَ
u'وَجَدَ بيض':Predicate, #1: 1	وَجَدَ الْبَيْتَ
u'وَجَدَ تُرَابٌ':Predicate, #2: 2	وَجَدَ بَيْضَ
u'وَجَدَ تَرْكٌ':Predicate, #1: 1	وَجَدَ التُّرَابَ
u'وَجَدَ تَصْدِيقٌ':Predicate, #1: 1	وَجَدَ تَرْكَ
u'وَجَدَ تَقابُض':Predicate, #1: 1	وَجَدَ التَّصْدِيقَ
u'وَجَدَ تَكْرارٌ':Predicate, #1: 1	وَجَدَ التَّقَابُضَ
u'وَجَدَ تَمْر':Predicate, #1: 1	وَجَدَ التَّكْرَارَ
u'وَجَدَ ثَمَنٌ':Predicate, #1: 1	وَجَدَ التَّمْرَ
u'وَجَدَ ثَمَنٌ':Predicate, #1: 1	وَجَدَ الثَّمَنَ
u'وَجَدَ ثَوْبٌ':Predicate, #3: 3	وَجَدَ ثَمَنَ
u'وَجَدَ جَارِي':Predicate, #5: 5	وَجَدَ الثَّوْبَ
u'وَجَدَ جَارِي':Predicate, #1: 1	وَجَدَ جَارِيَةً
u'وَجَدَ جَارِيَةٌ':Predicate, #4: 4	وَجَدَ الْجَارِيَةَ
u'وَجَدَ جَمَاعَةٌ':Subject, #4: 4	وَجَدَ الْجَارِيَةَ
u'وَجَدَ جِنْسٌ':Predicate, #1: 1	وَجَدَ جَمَاعَةٌ
u'وَجَدَ جهاد':Predicate, #1: 1	وَجَدَ جِنْسَ
u'وَجَدَ جِهَادٌ':Predicate, #1: 1	وَجَدَ الْجِهَادَ
u'وَجَدَ جَوْزٌ':Predicate, #1: 1	وَجَدَ الْجِهَادَ
u'وَجَدَ جوف':Predicate, #3: 3	وَجَدَ جَوْزَةً
u'وَجَدَ جَوْفٌ':Predicate, #1: 1	وَجَدَ جَوْفَ
u'وَجَدَ حائِطٌ':Predicate, #1: 1	وَجَدَ جَوْفَ
u'وَجَدَ حَبٌّ':Predicate, #1: 1	وَجَدَ الْحَائِطَ
u'وَجَدَ حَجْمٌ':Predicate, #1: 1	وَجَدَ الْحَبَّ
u'وَجَدَ حَجْمٌ':Predicate, #1: 1	وَجَدَ الْحَجْمَ
u'وَجَدَ حَدَثٌ':Predicate, #3: 3	وَجَدَ حَجْمَ
u'وَجَدَ حُرٌّ':Predicate, #1: 1	وَجَدَ الْحَدَثَ
u'وَجَدَ حَرارَةٌ':Predicate, #3: 3	وَجَدَ حُرَّةً
u'وَجَدَ حَرارَةٌ':Predicate, #1: 1	وَجَدَ الْحَرَارَةَ
u'وَجَدَ حَقٌّ':Predicate, #4: 4	وَجَدَ حَرَارَةَ
u'وَجَدَ حَقِيقٌ':Predicate, #1: 1	وَجَدَ الْحَقَّ
u'وَجَدَ حَقِيقَةٌ':Predicate, #1: 1	وَجَدَ حَقِيقَةَ
u'وَجَدَ حُكْمٌ':Predicate, #1: 1	وَجَدَ حَقِيقَةَ
u'وَجَدَ حَلاَوَةٌ':Predicate, #1: 1	وَجَدَ الْحُكْمَ
u'وَجَدَ حَلاَوَةٌ':Predicate, #1: 1	وَجَدَ الْحَلَاوَةَ
u'وَجَدَ حُلِيٌّ':Predicate, #2: 2	وَجَدَ حَلاوَةَ
u'وَجَدَ حِلْيَةٌ':Predicate, #1: 1	وَجَدَ حُلِيَّ
u'وَجَدَ حِنْطَةٌ':Predicate, #1: 1	وَجَدَ حِلْيَةَ
u'وَجَدَ خَائِفٌ':Subject, #2: 2	وَجَدَ الْحِنْطَةَ
u'وَجَدَ خَبَرٌ':Predicate, #1: 1	وَجَدَ الْخَائِفُ
u'وَجَدَ خَبَر':Predicate, #1: 1	وَجَدَ الْخَبَرَ
u'وَجَدَ خَطٌّ':Predicate, #1: 1	وَجَدَ الْخَبَرَ
u'وَجَدَ خِطَابٌ':Predicate, #2: 2	وَجَدَ خَطَّ
u'وَجَدَ خِفٌّ':Predicate, #2: 2	وَجَدَ الْخِطَابَ
u'وَجَدَ خِلاَفٌ':Predicate, #5: 5	وَجَدَ خِفَّةً
u'وَجَدَ خلط':Predicate, #1: 1	وَجَدَ الْخِلَافَ
u'وَجَدَ خَلْعٌ':Predicate, #1: 1	وَجَدَ الْخَلْطَ
u'وَجَدَ خَمْرٌ':Predicate, #1: 1	وَجَدَ الْخَلْعَ
u'وَجَدَ خَمْسَةٌ':Predicate, #1: 1	وَجَدَ الْخَمْرَ
u'وَجَدَ خَيْرٌ':Predicate, #1: 1	وَجَدَ خَمْسَةَ
u'وَجَدَ خَيْلٌ':Predicate, #1: 1	وَجَدَ الْخَيْرَ
u'وَجَدَ دَابَّةٌ':Predicate, #1: 1	وَجَدَ الْخَيْلَ
u'وَجَدَ دَابَّةٌ':Subject, #1: 1	وَجَدَ دَابَّةَ
u'وَجَدَ دُخُولٌ':Predicate, #1: 1	وَجَدَ دَابَّةٌ
u'وَجَدَ دُرٌّ':Predicate, #1: 1	وَجَدَ الدُّخُولَ
u'وَجَدَ دَرَاهِمُ':Predicate, #1: 1	وَجَدَ دُرَّةً
u'وَجَدَ دَرَاهِمُ':Predicate, #3: 3	وَجَدَ دَرَاهِمَ
u'وَجَدَ دَلالَةٌ':Predicate, #4: 4	وَجَدَ الدَّرَاهِمَ
u'وَجَدَ دَليلٌ':Predicate, #1: 1	وَجَدَ دَلَالَةَ
u'وَجَدَ دونٌ':Predicate, #1: 1	وَجَدَ دَلِيلَ
u'وَجَدَ دِينارٌ':Predicate, #1: 1	وَجَدَ دُونَ
u'وَجَدَ رَأْسٌ':Predicate, #1: 1	وَجَدَ الدِّينَارَ
u'وَجَدَ رَبُّ':Subject, #3: 3	وَجَدَ رَأْسَ
u'وَجَدَ رَجُلٌ':Predicate, #1: 1	وَجَدَ رَبُّ
u'وَجَدَ رَجُلٌ':Predicate, #2: 2	وَجَدَ الرَّجُلَ
u'وَجَدَ رَجُلٌ':Subject, #2: 2	وَجَدَ رَجُلاً
u'وَجَدَ رَجُلٌ':Subject, #4: 4	وَجَدَ رَجُلٌ
u'وَجَدَ رَسُولٌ':Subject, #7: 7	وَجَدَ الرَّجُلُ
u'وَجَدَ رَقَبَةٌ':Predicate, #9: 9	وَجَدَ رَسُولُ
u'وَجَدَ رِكاز':Predicate, #2: 2	وَجَدَ الرَّقَبَةَ
u'وَجَدَ روحٌ':Subject, #2: 2	وَجَدَ الرِّكَازَ
u'وَجَدَ ريحٌ':Predicate, #1: 1	وَجَدَ رُوحُهُ
u'وَجَدَ زادٌ':Predicate, #1: 1	وَجَدَ رِيحَ
u'وَجَدَ زِحامٌ':Predicate, #1: 1	وَجَدَ الزَّادَ
u'وَجَدَ زَمانٌ':Predicate, #1: 1	وَجَدَ الزِّحَامَ
u'وَجَدَ زَمَنٌ':Predicate, #1: 1	وَجَدَ الزَّمَانَ
u'وَجَدَ زَوْجٌ':Subject, #1: 1	وَجَدَ زَمَنَ
u'وَجَدَ زَوْجَةٌ':Predicate, #4: 4	وَجَدَ الزَّوْجُ
u'وَجَدَ سَاتِرٌ':Predicate, #1: 1	وَجَدَ الزَّوْجَةَ
u'وَجَدَ سَاتِرٌ':Predicate, #1: 1	وَجَدَ السَّاتِرَ
u'وَجَدَ سَبَبٌ':Predicate, #2: 2	وَجَدَ سَاتِرَ
u'وَجَدَ سَبِيلٌ':Predicate, #5: 5	وَجَدَ سَبَبَ
u'وَجَدَ سترة':Predicate, #1: 1	وَجَدَ السَّبِيلَ
u'وَجَدَ سُتْرَةٌ':Predicate, #3: 3	وَجَدَ السُّتْرَةَ
u'وَجَدَ سَعْدٌ':Subject, #3: 3	وَجَدَ السُّتْرَةَ
u'وَجَدَ سَفَرٌ':Predicate, #1: 1	وَجَدَ سَعْدُ
u'وَجَدَ سَمَكٌ':Predicate, #1: 1	وَجَدَ السَّفَرَ
u'وَجَدَ سُؤْرٌ':Predicate, #3: 3	وَجَدَ سَمَكَةً
u'وَجَدَ سَيِّدٌ':Subject, #4: 4	وَجَدَ سُؤْرَ
u'وَجَدَ سَيَلانٌ':Predicate, #4: 4	وَجَدَ السَّيِّدُ
u'وَجَدَ شَاهِدٌ':Subject, #1: 1	وَجَدَ السَّيَلَانَ
u'وَجَدَ شَرْطٌ':Predicate, #2: 2	وَجَدَ الشَّاهِدُ
u'وَجَدَ شَفِيعٌ':Subject, #1: 1	وَجَدَ شَرْطَ
u'وَجَدَ شَهْوَةٌ':Predicate, #1: 1	وَجَدَ الشَّفِيعُ
u'وَجَدَ شُهُودٌ':Predicate, #1: 1	وَجَدَ الشَّهْوَةَ
u'وَجَدَ شَيْخٌ':Subject, #1: 1	وَجَدَ الشُّهُودَ
u'وَجَدَ صَاحِبٌ':Subject, #1: 1	وَجَدَ الشَّيْخُ
u'وَجَدَ صَاحِبٌ':Subject, #1: 1	وَجَدَ صَاحِبُهُ
u'وَجَدَ صَبِيٌّ':Subject, #2: 2	وَجَدَ صَاحِبُ
u'وَجَدَ صِحَّةٌ':Predicate, #2: 2	وَجَدَ الصَّبِيُّ
u'وَجَدَ صداق':Predicate, #1: 1	وَجَدَ الصِّحَّةَ
u'وَجَدَ صَدَاقٌ':Predicate, #3: 3	وَجَدَ صَدَاقَ
u'وَجَدَ صَرَّافٌ':Predicate, #3: 3	وَجَدَ صَدَاقَ
u'وَجَدَ صَلاَبَةٌ':Predicate, #1: 1	وَجَدَ الصَّرَّافَ
u'وَجَدَ صَيْدٌ':Predicate, #2: 2	وَجَدَ صَلَابَةَ
u'وَجَدَ ضَالٌّ':Predicate, #2: 2	وَجَدَ الصَّيْدَ
u'وَجَدَ ضَالٌّ':Predicate, #1: 1	وَجَدَ الضَّالَّةَ
u'وَجَدَ ضَالٌّ':Predicate, #1: 1	وَجَدَ ضَالَّةَ
u'وَجَدَ ضَائِعٌ':Predicate, #7: 7	وَجَدَ ضَالَّةً
u'وَجَدَ طَالِبٌ':Subject, #1: 1	وَجَدَ الضَّائِعَ
u'وَجَدَ طَرِيقٌ':Predicate, #5: 5	وَجَدَ الطَّالِبُ
u'وَجَدَ طعام':Predicate, #1: 1	وَجَدَ الطَّرِيقَ
u'وَجَدَ طَعَامٌ':Predicate, #1: 1	وَجَدَ الطَّعَامَ
u'وَجَدَ طعام':Predicate, #1: 1	وَجَدَ الطَّعَامَ
u'وَجَدَ طَعَامٌ':Predicate, #2: 2	وَجَدَ طَعَامَ
u'وَجَدَ طَعْمٌ':Predicate, #2: 2	وَجَدَ طَعَامَ
u'وَجَدَ طَلاَقٌ':Predicate, #6: 6	وَجَدَ طَعْمَ
u'وَجَدَ طلب':Predicate, #1: 1	وَجَدَ الطَّلَاقَ
u'وَجَدَ طَلَبٌ':Predicate, #1: 1	وَجَدَ الطَّلَبَ
u'وَجَدَ طَوْلٌ':Predicate, #1: 1	وَجَدَ الطَّلَبَ
u'وَجَدَ عَبْدٌ':Predicate, #1: 1	وَجَدَ الطَّوْلَ
u'وَجَدَ عَبْدٌ':Predicate, #1: 1	وَجَدَ عَبْدَ
u'وَجَدَ عَبْدٌ':Subject, #9: 9	وَجَدَ الْعَبْدَ
u'وَجَدَ عَبْدٌ':Subject, #1: 1	وَجَدَ عَبْدٌ
u'وَجَدَ عُذْرٌ':Predicate, #6: 6	وَجَدَ الْعَبْدُ
u'وَجَدَ عَرَبٌ':Predicate, #1: 1	وَجَدَ الْعُذْرَ
u'وَجَدَ عُرْيَانٌ':Subject, #1: 1	وَجَدَ الْعَرَبَ
u'وَجَدَ عُرْيَانٌ':Subject, #1: 1	وَجَدَ الْعُرْيَانُ
u'وَجَدَ عَطْشَان':Subject, #1: 1	وَجَدَ عُرْيَانٌ
u'وَجَدَ عُمَرٌ':Subject, #1: 1	وَجَدَ الْعَطْشَانُ
u'وَجَدَ عَنْبَر':Predicate, #2: 2	وَجَدَ عُمَرُ
u'وَجَدَ عند':Predicate, #2: 2	وَجَدَ عَنْبَرَةً
u'وَجَدَ عَيْب':Predicate, #2: 2	وَجَدَ عِنْدَ
u'وَجَدَ عَيْبٌ':Predicate, #1: 1	وَجَدَ عَيْبَةً
u'وَجَدَ عين':Predicate, #5: 5	وَجَدَ الْعَيْبَ
u'وَجَدَ عَيْنٌ':Predicate, #15: 15	وَجَدَ عَيْنَ
u'وَجَدَ عَيْن':Predicate, #15: 15	وَجَدَ عَيْنَ
u'وَجَدَ عين':Predicate, #15: 15	وَجَدَ عَيْنَ
u'وَجَدَ عَيْنٌ':Predicate, #2: 2	وَجَدَ الْعَيْنَ
u'وَجَدَ عَيْن':Predicate, #2: 2	وَجَدَ الْعَيْنَ
u'وَجَدَ غَاصِبٌ':Predicate, #2: 2	وَجَدَ الْعَيْنَ
u'وَجَدَ غَاصِبٌ':Subject, #2: 2	وَجَدَ الْغَاصِبَ
u'وَجَدَ غَدَاءٌ':Predicate, #1: 1	وَجَدَ الْغَاصِبُ
u'وَجَدَ غَرِيمٌ':Subject, #1: 1	وَجَدَ غَدَاءَ
u'وَجَدَ غَصْبٌ':Predicate, #1: 1	وَجَدَ الْغَرِيمُ
u'وَجَدَ غُلاَمٌ':Predicate, #1: 1	وَجَدَ الْغَصْبَ
u'وَجَدَ غَنَمٌ':Predicate, #1: 1	وَجَدَ الْغُلَامَ
u'وَجَدَ غير':Predicate, #1: 1	وَجَدَ الْغَنَمَ
u'وَجَدَ غَيْرٌ':Predicate, #6: 6	وَجَدَ غَيْرَ
u'وَجَدَ فَرْضٌ':Predicate, #6: 6	وَجَدَ غَيْرَ
u'وَجَدَ فلان':Predicate, #1: 1	وَجَدَ فَرْضَ
u'وَجَدَ فلان':Predicate, #1: 1	وَجَدَ رِفَاعَةَ
u'وَجَدَ فُلاَنٌ':Subject, #1: 1	وَجَدَ مُعَاوِيَةَ
u'وَجَدَ فُلُوسٌ':Predicate, #4: 4	وَجَدَ فُلَانٌ
u'وَجَدَ قَارِئٌ':Subject, #1: 1	وَجَدَ الْفُلُوسَ
u'وَجَدَ قَاعِدٌ':Subject, #1: 1	وَجَدَ الْقَارِئُ
u'وَجَدَ قَرْضٌ':Predicate, #1: 1	وَجَدَ الْقَاعِدُ
u'وَجَدَ قَضَاءٌ':Predicate, #4: 4	وَجَدَ الْقَرْضَ
u'وَجَدَ قطعة':Predicate, #1: 1	وَجَدَ قَضَاءَ
u'وَجَدَ قِطْعَةٌ':Predicate, #4: 4	وَجَدَ قِطْعَةَ
u'وَجَدَ قَطِيعٌ':Predicate, #4: 4	وَجَدَ قِطْعَةَ
u'وَجَدَ قَوْمٌ':Predicate, #4: 4	وَجَدَ الْقَطِيعَ
u'وَجَدَ قِيمَةٌ':Predicate, #1: 1	وَجَدَ الْقَوْمَ
u'وَجَدَ كَافِي':Predicate, #1: 1	وَجَدَ قِيمَةَ
u'وَجَدَ كَبِيرٌ':Subject, #1: 1	وَجَدَ كَافِيَ
u'وَجَدَ كِتَابٌ':Predicate, #2: 2	وَجَدَ الْكَبِيرُ
u'وَجَدَ كَفَنٌ':Predicate, #1: 1	وَجَدَ كِتَابَ
u'وَجَدَ لَحْمٌ':Predicate, #1: 1	وَجَدَ الْكَفَنَ
u'وَجَدَ لَذَّةٌ':Predicate, #2: 2	وَجَدَ لَحْمَ
u'وَجَدَ لقطة':Predicate, #2: 2	وَجَدَ لَذَّةَ
u'وَجَدَ لُقْطَةٌ':Predicate, #1: 1	وَجَدَ لُقْطَةَ
u'وَجَدَ لقطة':Predicate, #1: 1	وَجَدَ لُقْطَةَ
u'وَجَدَ لَقِيطٌ':Predicate, #2: 2	وَجَدَ اللُّقَطَةَ
u'وَجَدَ لَقِيطٌ':Subject, #1: 1	وَجَدَ اللَّقِيطَ
u'وَجَدَ مَاءٌ':Predicate, #1: 1	وَجَدَ اللَّقِيطُ
u'وَجَدَ مَالٌ':Predicate, #85: 85	وَجَدَ الْمَاءَ
u'وَجَدَ مَالٌ':Predicate, #1: 1	وَجَدَ مَالَ
u'وَجَدَ مَالِكٌ':Subject, #7: 7	وَجَدَ الْمَالَ
u'وَجَدَ مَأْمُورٌ':Predicate, #2: 2	وَجَدَ الْمَالِكُ
u'وَجَدَ مُبْتاع':Subject, #1: 1	وَجَدَ الْمَأْمُورَ
u'وَجَدَ مَبِيعٌ':Predicate, #1: 1	وَجَدَ الْمُبْتَاعُ
u'وَجَدَ مُتَبَرِّعٌ':Predicate, #4: 4	وَجَدَ الْمَبِيعَ
u'وَجَدَ مثل':Predicate, #2: 2	وَجَدَ مُتَبَرِّعَةً
u'وَجَدَ مِثْلٌ':Predicate, #1: 1	وَجَدَ مِثْلَ
u'وَجَدَ مثل':Predicate, #1: 1	وَجَدَ مِثْلَ
u'وَجَدَ مِثْلٌ':Predicate, #3: 3	وَجَدَ الْمِثْلَ
u'وَجَدَ مُجْتَهِد':Subject, #3: 3	وَجَدَ الْمِثْلَ
u'وَجَدَ مُحْدِثٌ':Subject, #2: 2	وَجَدَ الْمُجْتَهِدُ
u'وَجَدَ مُحْرِمٌ':Subject, #1: 1	وَجَدَ الْمُحْدِثُ
u'وَجَدَ مُخْبِرٌ':Predicate, #4: 4	وَجَدَ الْمُحْرِمُ
u'وَجَدَ مَدْيُونٌ':Subject, #2: 2	وَجَدَ الْمُخْبِرَ
u'وَجَدَ مُرْتَهِنٌ':Subject, #1: 1	وَجَدَ الْمَدْيُونُ
u'وَجَدَ مُرْضِعٌ':Predicate, #1: 1	وَجَدَ الْمُرْتَهِنُ
u'وَجَدَ مَرِيضٌ':Subject, #2: 2	وَجَدَ مُرْضِعَةً
u'وَجَدَ مَسٌّ':Predicate, #1: 1	وَجَدَ الْمَرِيضُ
u'وَجَدَ مَسْأَلَةٌ':Predicate, #3: 3	وَجَدَ مَسَّ
u'وَجَدَ مُسْلِمٌ':Predicate, #1: 1	وَجَدَ الْمَسْأَلَةَ
u'وَجَدَ مُسْلِمٌ':Predicate, #1: 1	وَجَدَ مُسْلِمَةً
u'وَجَدَ مُسْلِمٌ':Subject, #2: 2	وَجَدَ الْمُسْلِمِينَ
u'وَجَدَ مَسِيلٌ':Predicate, #2: 2	وَجَدَ مُسْلِمٌ
u'وَجَدَ مَشَقَّةٌ':Predicate, #1: 1	وَجَدَ مَسِيلَ
u'وَجَدَ مَصُوغٌ':Predicate, #3: 3	وَجَدَ الْمَشَقَّةَ
u'وَجَدَ مُضْطَرٌّ':Subject, #1: 1	وَجَدَ الْمَصُوغَ
u'وَجَدَ مُعاوِيَة':Predicate, #6: 6	وَجَدَ الْمُضْطَرُّ
u'وَجَدَ مَغْصُوب':Subject, #1: 1	وَجَدَ مُعَاوِيَةَ
u'وَجَدَ مَقْبُوضٌ':Predicate, #1: 1	وَجَدَ الْمَغْصُوبُ
u'وَجَدَ مُقْرِضٌ':Subject, #1: 1	وَجَدَ الْمَقْبُوضَ
u'وَجَدَ مَقْضِيّ':Subject, #1: 1	وَجَدَ الْمُقْرِضُ
u'وَجَدَ مِلْكٌ':Predicate, #1: 1	وَجَدَ الْمَقْضِيُّ
u'وَجَدَ مُلُوحَةٌ':Predicate, #2: 2	وَجَدَ الْمِلْكَ
u'وَجَدَ مِنَّةٌ':Predicate, #1: 1	وَجَدَ الْمُلُوحَةَ
u'وَجَدَ مُوجِبٌ':Predicate, #1: 1	وَجَدَ مِنَّةَ
u'وَجَدَ مَوْصُوفٌ':Predicate, #1: 1	وَجَدَ الْمُوجِبَ
u'وَجَدَ مُوَكِّلٌ':Subject, #1: 1	وَجَدَ الْمَوْصُوفَ
u'وَجَدَ مَوْهُوبٌ':Subject, #3: 3	وَجَدَ الْمُوَكِّلُ
u'وَجَدَ نَاسٌ':Predicate, #2: 2	وَجَدَ الْمَوْهُوبُ
u'وَجَدَ نَاسٌ':Subject, #4: 4	وَجَدَ النَّاسَ
u'وَجَدَ نَاظِرٌ':Subject, #3: 3	وَجَدَ النَّاسُ
u'وَجَدَ نَبِيٌّ':Predicate, #1: 1	وَجَدَ النَّاظِرُ
u'وَجَدَ نَبِيذٌ':Predicate, #1: 1	وَجَدَ النَّبِيَّ
u'وَجَدَ نُجُومٌ':Predicate, #1: 1	وَجَدَ نَبِيذَ
u'وَجَدَ نَحْوٌ':Predicate, #1: 1	وَجَدَ النُّجُومَ
u'وَجَدَ نَصٌّ':Predicate, #1: 1	وَجَدَ نَحْوَ
u'وَجَدَ نصاب':Predicate, #2: 2	وَجَدَ النَّصَّ
u'وَجَدَ نِصَابٌ':Predicate, #2: 2	وَجَدَ نِصَابَ
u'وَجَدَ نِصْفٌ':Predicate, #2: 2	وَجَدَ نِصَابَ
u'وَجَدَ نَظَرٌ':Predicate, #1: 1	وَجَدَ نِصْفَ
u'وَجَدَ نَفَقَةٌ':Predicate, #1: 1	وَجَدَ نَظَرَ
u'وَجَدَ نَفَقَةٌ':Predicate, #1: 1	وَجَدَ النَّفَقَةَ
u'وَجَدَ نقل':Predicate, #1: 1	وَجَدَ نَفَقَةَ
u'وَجَدَ نَقْلٌ':Predicate, #1: 1	وَجَدَ النَّقْلَ
u'وَجَدَ نَيْلٌ':Predicate, #1: 1	وَجَدَ النَّقْلَ
u'وَجَدَ هَدْيٌ':Predicate, #1: 1	وَجَدَ النَّيْلَ
u'وَجَدَ وَزْنٌ':Predicate, #13: 13	وَجَدَ الْهَدْيَ
u'وَجَدَ وَصِيٌّ':Subject, #1: 1	وَجَدَ وَزْنَ
u'وَجَدَ وَكِيلٌ':Subject, #1: 1	وَجَدَ الْوَصِيُّ
u'وَجَدَ وَلِيٌّ':Subject, #3: 3	وَجَدَ الْوَكِيلُ
u'وَجَدَ يَدٌ':Predicate, #1: 1	وَجَدَ وَلِيُّ
u'وَجَدَ يهود':Predicate, #1: 1	وَجَدَ الْيَدَ
u'وَجَدَ يَهُودٌ':Predicate, #1: 1	وَجَدَ الْيَهُودَ
u'وَجَعٌ أسْنَانٌ':Added, #1: 1	وَجَدَ الْيَهُودَ
u'وَجَعٌ أسْنَانٌ':Added, #1: 1	وَجَعَ الْأَسْنَانِ
u'وَجَعٌ أَضْرَاسٌ':Added, #3: 3	وَجَعِ الْأَسْنَانِ
u'وَجَعٌ بَطْنٌ':Added, #1: 1	وَجَعِ الْأَضْرَاسِ
u'وَجَعٌ بَطْنٌ':Added, #1: 1	وَجَعَ الْبَطْنِ
u'وَجَعٌ بَطْنٌ':Added, #1: 1	وَجَعُ الْبَطْنِ
u'وَجَعٌ جَبِينٌ':Added, #1: 1	وَجَعَ بَطْنِهِ
u'وَجَعٌ جَنْبٌ':Added, #1: 1	وَجَعِ الْجَبِينِ
u'وَجَعٌ جَنْبٌ':Added, #1: 1	وَجَعُ الْجَنْبِ
u'وَجَعٌ حَلْقٌ':Added, #1: 1	وَجَعُ جَنْبٍ
u'وَجَعٌ حَلْقٌ':Added, #1: 1	وَجَعِ الْحَلْقِ
u'وَجَعٌ ذكر':Added, #2: 2	وَجَعُ الْحَلْقِ
u'وَجَعٌ ذَكَرٌ':Added, #1: 1	وَجَعَ الذَّكَرِ
u'وَجَعٌ رَأْسٌ':Added, #1: 1	وَجَعَ الذَّكَرِ
u'وَجَعٌ رَأْسٌ':Added, #1: 1	وَجَعَ الرَّأْسِ
u'وَجَعٌ رَأْسٌ':Added, #1: 1	وَجَعِ الرَّأْسِ
u'وَجَعٌ رَأْسٌ':Added, #1: 1	وَجَعَ رَأْسِهِ
u'وَجَعٌ رَجُلٌ':Added, #2: 2	وَجَعِ رَأْسٍ
u'وَجَعٌ رحم':Added, #3: 3	وَجَعُ الرَّجُلِ
u'وَجَعٌ رَحِمٌ':Added, #1: 1	وَجَعِ الرَّحِمِ
u'وَجَعٌ رَسُولٌ':Added, #1: 1	وَجَعِ الرَّحِمِ
u'وَجَعٌ رَسُولٌ':Added, #1: 1	وَجَعِ رَسُولِ
u'وَجَعٌ سِنٌّ':Added, #2: 2	وَجَعُ رَسُولِ
u'وَجَعٌ سِنٌّ':Added, #1: 1	وَجَعُ السِّنِّ
u'وَجَعٌ صَاحِبٌ':Added, #1: 1	وَجَعِ السِّنِّ
u'وَجَعٌ صَدْرٌ':Added, #1: 1	وَجَعُ صَاحِبِهِ
u'وَجَعٌ صَدْرٌ':Added, #1: 1	وَجَعِ الصَّدْرِ
u'وَجَعٌ صلْبٌ':Added, #1: 1	وَجَعِ صَدْرِ
u'وَجَعٌ ضِرْسٌ':Added, #1: 1	وَجَعُ الصُّلْبِ
u'وَجَعٌ ضرس':Added, #1: 1	وَجَعَ ضِرْسٍ
u'وَجَعٌ ضرس':Added, #4: 4	وَجَعَ الضِّرْسِ
u'وَجَعٌ ضِرْسٌ':Added, #4: 4	وَجَعُ الضِّرْسِ
u'وَجَعٌ ضِرْسٌ':Added, #4: 4	وَجَعَ الضِّرْسِ
u'وَجَعٌ طِحَالٌ':Added, #4: 4	وَجَعُ الضِّرْسِ
u'وَجَعٌ طِحَالٌ':Added, #1: 1	وَجَعُ الطِّحَالِ
u'وَجَعٌ عَصَبٌ':Added, #1: 1	وَجَعِ الطِّحَالِ
u'وَجَعٌ عين':Added, #2: 2	وَجَعَ الْعَصَبِ
u'وَجَعٌ عَيْنٌ':Added, #3: 3	وَجَعَ الْعَيْنِ
u'وَجَعٌ عَيْن':Added, #3: 3	وَجَعَ الْعَيْنِ
u'وَجَعٌ عين':Added, #3: 3	وَجَعَ الْعَيْنِ
u'وَجَعٌ عَيْنٌ':Added, #4: 4	وَجَعُ الْعَيْنِ
u'وَجَعٌ عَيْن':Added, #4: 4	وَجَعُ الْعَيْنِ
u'وَجِعَ قلب':Predicate, #4: 4	وَجَعُ الْعَيْنِ
u'وَجِعَ قَلْبٌ':Predicate, #1: 1	أَوْجَعَ قَلْبَكَ
u'وَجِعَ قَلْب':Predicate, #1: 1	أَوْجَعَ قَلْبَكَ
u'وَجَعٌ كَبِدٌ':Added, #1: 1	أَوْجَعَ قَلْبَكَ
u'وَجَعٌ كَبِدٌ':Added, #1: 1	وَجَعَ الْكَبِدِ
u'وَجَعٌ مَعِدَةٌ':Added, #2: 2	وَجَعُ الْكَبِدِ
u'وَجَعٌ وِلاَدَةٌ':Added, #1: 1	وَجَعِ الْمَعِدَةِ
u'وَجَفَ فَرَسٌ':Subject, #2: 2	وَجَعُ الْوِلَادَةِ
u'وَجْهٌ إبَاءٌ':Added, #1: 1	وَجَفَ الْفَرَسُ
u'وَجْهٌ إبَاحَةٌ':Added, #1: 1	وَجْهِ الْإِبَاءِ
u'وَجْهٌ إبَاحَةٌ':Added, #15: 15	وَجْهِ الْإِبَاحَةِ
u'وَجْهٌ اِبْتِداءٌ':Added, #1: 1	وَجْهُ إبَاحَةِ
u'وَجْهٌ اِبْتِداءٌ':Added, #1: 1	وَجْهُ ابْتِدَاءٍ
u'وَجَّهَ اِبْنٌ':Subject, #2: 2	وَجْهِ ابْتِدَاءِ
u'وَجْهٌ إِبْهَامٌ':Added, #3: 3	وَجَّهَ ابْنُ
u'وَجْهٌ اِتِّبَاعٌ':Added, #1: 1	وَجْهِ الْإِبْهَامِ
u'وَجْهٌ اِتِّبَاعٌ':Added, #1: 1	وَجْهَ اتِّبَاعِ
u'وَجْهٌ إتْمَامٌ':Added, #1: 1	وَجْهُ اتِّبَاعِ
u'وَجْهٌ إِثْبَاتٌ':Added, #1: 1	وَجْهُ الْإِتْمَامِ
u'وَجْهٌ إِجَابَةٌ':Added, #1: 1	وَجْهُ إثْبَاتِ
u'وَجْهٌ إجَارَةٌ':Added, #1: 1	وَجْهِ الْإِجَابَةِ
u'وَجْهٌ أُجْرَةٌ':Added, #7: 7	وَجْهِ الْإِجَارَةِ
u'وَجْهٌ إِجْمَالٌ':Added, #2: 2	وَجْهِ الْأُجْرَةِ
u'وَجْهٌ إِجْمَالٌ':Added, #1: 1	وَجْهُ الْإِجْمَالِ
u'وَجْهٌ أَجْنَبِيٌّ':Added, #1: 1	وَجْهِ الْإِجْمَالِ
u'وَجْهٌ أَجْنَبِيٌّ':Added, #1: 1	وَجْهَ الْأَجْنَبِيَّةِ
u'وَجْهٌ إحَاطَةٌ':Added, #9: 9	وَجْهِ الْأَجْنَبِيَّةِ
u'وَجْهٌ اِحْتِمَالٌ':Added, #2: 2	وَجْهِ الْإِحَاطَةِ
u'وَجْهٌ أحَدٌ':Added, #1: 1	وَجْهُ احْتِمَالِ
u'وَجْهٌ أحَدٌ':Added, #1: 1	وَجْهِ أَحَدٍ
u'وَجْهٌ إِخْبَارٌ':Added, #2: 2	وَجْهُ أَحَدِ
u'وَجْهٌ اِخْتِصَارٌ':Added, #3: 3	وَجْهِ الْإِخْبَارِ
u'وَجْهٌ اِخْتِصَاصٌ':Added, #1: 1	وَجْهِ الاِخْتِصَارِ
u'وَجْهٌ اِخْتِصَاصٌ':Added, #1: 1	وَجْهَ اخْتِصَاصِهِ
u'وَجْهٌ اِخْتِلاَفٌ':Added, #4: 4	وَجْهُ اخْتِصَاصِ
u'وَجْهٌ اِخْتِيَارٌ':Added, #3: 3	وَجْهِ اخْتِلَافِ
u'وَجْهٌ أخْذٌ':Added, #1: 1	وَجْهُ اخْتِيَارِ
u'وَجْهٌ أخْذٌ':Added, #1: 1	وَجْهُ أَخْذِهِ
u'وَجْهٌ أخْذٌ':Added, #1: 1	وَجْهِ أَخْذِهِ
u'وَجْهٌ أخْذٌ':Added, #1: 1	وَجْهَ الْأَخْذِ
u'وَجْهٌ إِخْلاَصٌ':Added, #1: 1	وَجْهُ الْأَخْذِ
u'وَجْهٌ أَدَاءٌ':Added, #1: 1	وَجْهِ الْإِخْلَاصِ
u'وَجْهٌ أدَب':Added, #1: 1	وَجْهَ أَدَاءِ
u'وَجْهٌ آدَمِيٌّ':Added, #3: 3	وَجْهِ الْأَدَبِ
u'وَجْهٌ آدَمِيٌّ':Added, #1: 1	وَجْهِ الْآدَمِيِّ
u'وَجْهٌ إِذْلاَلٌ':Added, #3: 3	وَجْهِ آدَمِيٍّ
u'وَجْهٌ إِرَادَةٌ':Added, #1: 1	وَجْهِ الْإِذْلَالِ
u'وَجْهٌ إِرْسَالٌ':Added, #2: 2	وَجْهُ إرَادَةِ
u'وَجْهٌ إِرْسَالٌ':Added, #1: 1	وَجْهِ إِرْسَالِ
u'وَجْهٌ إِرْسَالٌ':Added, #1: 1	وَجْهِ إرْسَالِهِ
u'وَجْهٌ إِرْشَادٌ':Added, #1: 1	وَجْهِ الْإِرْسَالِ
u'وَجْهٌ أرْضٌ':Added, #1: 1	وَجْهِ الْإِرْشَادِ
u'وَجْهٌ أرْضٌ':Added, #12: 12	وَجْهِ الأَرْضِ
u'وَجْهٌ أرْضٌ':Added, #13: 13	وَجْهُ الْأَرْضِ
u'وَجْهٌ أرْضٌ':Added, #1: 1	وَجْهِ أَرْضِهِ
u'وَجْهٌ أرْضٌ':Added, #7: 7	وَجْهَ الْأَرْضِ
u'وَجْهٌ اِسْتِحْسان':Added, #80: 80	وَجْهِ الْأَرْضِ
u'وَجْهٌ اِسْتِحْسَانٌ':Added, #1: 1	وَجْهُ اسْتِحْسَانِ
u'وَجْهٌ اِسْتِخْرَاجٌ':Added, #1: 1	وَجْهِ الاِسْتِحْسَانِ
u'وَجْهٌ اِسْتِدْلاَلٌ':Added, #1: 1	وَجْهُ اسْتِخْرَاجِ
u'وَجْهٌ اِسْتِعاذَةٌ':Added, #1: 1	وَجْهِ اسْتِدْلَالٍ
u'وَجْهٌ اِسْتِعْمالٌ':Added, #1: 1	وَجْهُ اسْتِعَاذَتِهِ
u'وَجْهٌ اِسْتِفْتاحٌ':Added, #2: 2	وَجْهُ اسْتِعْمَالِهِ
u'وَجْهٌ اِسْتِلْزامٌ':Added, #1: 1	وَجْهُ اسْتِفْتَاحِ
u'وَجْهٌ اِسْتِمْدادٌ':Added, #1: 1	وَجْهُ اسْتِلْزَامِهِ
u'وَجْهٌ إِسْرافٌ':Added, #1: 1	وَجْهِ اسْتِمْدَادِهِ
u'وَجْهٌ إشارَة':Added, #1: 1	وَجْهِ الْإِسْرَافِ
u'وَجْهٌ إشارَة':Added, #1: 1	وَجْهِ الْإِشَارَةِ
u'وَجْهٌ اِشْتِراطٌ':Added, #2: 2	وَجْهُ الْإِشَارَةِ
u'وَجْهٌ اِشْتِراطٌ':Added, #2: 2	وَجْهِ اشْتِرَاطِ
u'وَجْهٌ إِشْكالٌ':Added, #3: 3	وَجْهُ اشْتِرَاطِ
u'وَجْهٌ إِشْكالٌ':Added, #1: 1	وَجْهُ إشْكَالِهِ
u'وَجْهٌ إِشْكالٌ':Added, #1: 1	وَجْهِ الْإِشْكَالِ
u'وَجْهٌ إضافَةٌ':Added, #3: 3	وَجْهُ الْإِشْكَالِ
u'وَجْهٌ إِطْعامٌ':Added, #3: 3	وَجْهُ الْإِضَافَةِ
u'وَجْهٌ إِطْلاقٌ':Added, #3: 3	وَجْهِ الْإِطْعَامِ
u'وَجْهٌ إِطْلاقٌ':Added, #1: 1	وَجْهُ إطْلَاقِ
u'وَجْهٌ إِعادَةٌ':Added, #1: 1	وَجْهِ إطْلَاقِ
u'وَجْهٌ إِعادَةٌ':Added, #1: 1	وَجْهُ إعَادَتِهِ
u'وَجْهٌ إِعارَةٌ':Added, #1: 1	وَجْهَ الْإِعَادَةِ
u'وَجْهٌ اِعْتِبارٌ':Added, #1: 1	وَجْهِ الْإِعَارَةِ
u'وَجْهٌ اِعْتِبارٌ':Added, #1: 1	وَجْهَ اعْتِبَارِ
u'وَجْهٌ اِعْتِبارٌ':Added, #1: 1	وَجْهُ اعْتِبَارِ
u'وَجْهٌ إِعْجازٌ':Added, #1: 1	وَجْهِ اعْتِبَارِ
u'وَجْهٌ إِعْجازٌ':Added, #1: 1	وَجْهَ إعْجَازِ
u'وَجْهٌ إِعْجازٌ':Added, #1: 1	وَجْهَ إعْجَازِهِ
u'وَجْهٌ إِعْجازٌ':Added, #1: 1	وَجْهِ إِعْجَازِهِ
u'وَجْهٌ إِعْجازٌ':Added, #1: 1	وَجْهُ الْإِعْجَازِ
u'وَجْهٌ إعْلاَنٌ':Added, #1: 1	وَجْهِ الْإِعْجَازِ
u'وَجْهٌ اِفْتِرَاقٌ':Added, #3: 3	وَجْهِ الْإِعْلَانِ
u'وَجْهٌ إِفْرَادٌ':Added, #1: 1	وَجْهُ افْتِرَاقِهِ
u'وَجْهٌ إفْسَادٌ':Added, #1: 1	وَجْهِ الْإِفْرَادِ
u'وَجْهٌ أفْضَلُ':Added, #2: 2	وَجْهِ الْإِفْسَادِ
u'وَجْهٌ أفْضَلِيَّةٌ':Added, #1: 1	وَجْهِ الْأَفْضَلِ
u'وَجْهٌ أفْضَلِيَّةٌ':Added, #1: 1	وَجْهُ أَفْضَلِيَّةِ
u'وَجْهٌ إقْرَارٌ':Added, #3: 3	وَجْهِ الْأَفْضَلِيَّةِ
u'وَجْهٌ أَكْثَرُ':Added, #2: 2	وَجْهِ الْإِقْرَارِ
u'وَجْهٌ إكْرَامٌ':Added, #1: 1	وَجْهُ أَكْثَرِهِ
u'وَجْهٌ إكْرَاهٌ':Added, #1: 1	وَجْهِ الْإِكْرَامِ
u'وَجْهٌ أكل':Added, #3: 3	وَجْهِ الْإِكْرَاهِ
u'وَجْهٌ أَكْلٌ':Added, #1: 1	وَجْهِ الْأَكْلِ
u'وَجْهٌ أَكْمَلُ':Added, #1: 1	وَجْهِ الْأَكْلِ
u'وَجْهٌ اِلْتِمَاسٌ':Added, #1: 1	وَجْهِ الْأَكْمَلِ
u'وَجْهٌ إلْحَاقٌ':Added, #2: 2	وَجْهِ الْتِمَاسِ
u'وَجْهٌ إلْحَاقٌ':Added, #1: 1	وَجْهُ الْإِلْحَاقِ
u'وَجْهٌ إِلْزَامٌ':Added, #1: 1	وَجْهِ إلْحَاقِ
u'وَجْهٌ اللهُ':Added, #2: 2	وَجْهِ الْإِلْزَامِ
u'وَجْهٌ اللهُ':Added, #1: 1	وَجْهُ اللهِ
u'وَجْهٌ اللهُ':Added, #1: 1	وَجْهِ اللهِ
u'وَجْهٌ الْمَرْأَةُ':Added, #5: 5	وَجْهَ اللهِ
u'وَجْهٌ الْمَرْأَةُ':Added, #1: 1	وَجْهَ الْمَرْأَةِ
u'وَجْهٌ الْمَرْأَةُ':Added, #4: 4	وَجْهُ الْمَرْأَةِ
u'وَجَّهَ إمَامٌ':Subject, #7: 7	وَجْهِ الْمَرْأَةِ
u'وَجْهٌ إمَامٌ':Added, #1: 1	وَجَّهَ الْإِمَامُ
u'وَجْهٌ إمَامٌ':Added, #15: 15	وَجْهِ الْإِمَامِ
u'وَجْهٌ إمَامٌ':Added, #2: 2	وَجْهِ إمَامِ
u'وَجْهٌ أمَانَةٌ':Added, #2: 2	وَجْهِ إمَامِهِ
u'وَجْهٌ إمْتَاعٌ':Added, #10: 10	وَجْهِ الْأَمَانَةِ
u'وَجْهٌ اِمْتِنانٌ':Added, #2: 2	وَجْهِ الْإِمْتَاعِ
u'وَجْهٌ أَمْرٌ':Added, #1: 1	وَجْهِ امْتِنَانِهِ
u'وَجْهٌ أَمْرَد':Added, #6: 6	وَجْهِ الْأَمْرِ
u'وَجْهٌ اِنْتِهاءٌ':Added, #2: 2	وَجْهِ الْأَمْرَدِ
u'وَجْهٌ اِنْدِفاعٌ':Added, #1: 1	وَجْهِ انْتِهَاءِ
u'وَجْهٌ إِنْسانٌ':Added, #1: 1	وَجْهُ انْدِفَاعِ
u'وَجْهٌ إِنْسانٌ':Added, #1: 1	وَجْهِ الإِنْسَانِ
u'وَجْهٌ إِنْسانٌ':Added, #2: 2	وَجْهُ الْإِنْسَانِ
u'وَجْهٌ إِنْسانٌ':Added, #2: 2	وَجْهِ الْإِنْسَانِ
u'وَجْهٌ إِنْسانٌ':Added, #2: 2	وَجْهَ إنْسَانٍ
u'وَجْهٌ إِنْشاءٌ':Added, #6: 6	وَجْهِ إنْسَانٍ
u'وَجْهٌ إِنْشاءٌ':Added, #1: 1	وَجْهِ إنْشَاءِ
u'وَجْهٌ إِنْكارٌ':Added, #5: 5	وَجْهِ الْإِنْشَاءِ
u'وَجْهٌ إهَانَةٌ':Added, #4: 4	وَجْهِ الْإِنْكَارِ
u'وَجْهٌ إهْمَالٌ':Added, #3: 3	وَجْهِ الْإِهَانَةِ
u'وَجَّهَ أَوَّلُ':Predicate, #1: 1	وَجْهُ الْإِهْمَالِ
u'وَجْهٌ أَوَّلُ':Added, #1: 1	وَجَّهَ الْأَوَّلَ
u'وَجْهٌ أَوَّلُ':Added, #2: 2	وَجْهَ الْأَوَّلِ
u'وَجْهٌ أَوَّلُ':Added, #2: 2	وَجْهِ الْأَوَّلِ
u'وَجْهٌ أَوْلَوِيٌّ':Added, #61: 61	وَجْهُ الْأَوَّلِ
u'وَجْهٌ أَوْلَوِيٌّ':Added, #1: 1	وَجْهَ الْأَوْلَوِيَّةِ
u'وَجْهٌ أَوْلَوِيٌّ':Added, #1: 1	وَجْهِ أَوْلَوِيَّةِ
u'وَجْهٌ أَوْلَوِيٌّ':Added, #2: 2	وَجْهُ الْأَوْلَوِيَّةِ
u'وَجْهٌ إِيجَابٌ':Added, #3: 3	وَجْهِ الْأَوْلَوِيَّةِ
u'وَجْهٌ إِيجَارٌ':Added, #1: 1	وَجْهُ إيجَابِ
u'وَجْهٌ إيجَازٌ':Added, #1: 1	وَجْهِ الْإِيجَارِ
u'وَجْهٌ إِيدَاعٌ':Added, #1: 1	وَجْهِ الْإِيجَازِ
u'وَجْهٌ إيرَادٌ':Added, #3: 3	وَجْهِ الْإِيدَاعِ
u'وَجْهٌ إيرَادٌ':Added, #1: 1	وَجْهَ إيرَادِ
u'وَجْهٌ بَابٌ':Added, #2: 2	وَجْهُ إيرَادِ
u'وَجْهٌ بَاطِلٌ':Added, #1: 1	وَجْهِ الْبَابِ
u'وَجْهٌ بَاطِلٌ':Added, #1: 1	وَجْهِ الْبَاطِلِ
u'وَجْهٌ بَائِعٌ':Added, #1: 1	وَجْهٍ بَاطِلٍ
u'وَجْهٌ بَائِعٌ':Added, #1: 1	وَجْهِ الْبَائِعِ
u'وَجْهٌ بَحْثٌ':Added, #2: 2	وَجْهِ الْبَائِعَةِ
u'وَجْهٌ بِدْعَةٌ':Added, #1: 1	وَجْهُ بَحْثِهِ
u'وَجْهٌ بَدَلٌ':Added, #2: 2	وَجْهِ الْبِدْعَةِ
u'وَجْهٌ بِرٌّ':Added, #12: 12	وَجْهِ الْبَدَلِ
u'وَجْهٌ بِرٌّ':Added, #2: 2	وَجْهُ بِرٍّ
u'وَجْهٌ بَعْضٌ':Added, #6: 6	وَجْهِ الْبِرِّ
u'وَجْهٌ بَعْضٌ':Added, #1: 1	وَجْهِ بَعْضٍ
u'وَجْهٌ بُغْضٌ':Added, #1: 1	وَجْهِ بَعْضِ
u'وَجْهٌ بِنَاءٌ':Added, #1: 1	وَجْهِ الْبُغْضِ
u'وَجْهٌ بِنَاءٌ':Added, #1: 1	وَجْهَ الْبِنَاءِ
u'وَجْهٌ بِنَاءٌ':Added, #1: 1	وَجْهُ الْبِنَاءِ
u'وَجْهٌ بَيْتٌ':Added, #1: 1	وَجْهِ الْبِنَاءِ
u'وَجْهٌ بَيْعٌ':Added, #1: 1	وَجْهِ الْبَيْتِ
u'وَجْهٌ بَيْعٌ':Added, #11: 11	وَجْهِ الْبَيْعِ
u'وَجْهٌ بَيْعٌ':Added, #1: 1	وَجْهُ بَيْعِ
u'وَجْهٌ بَيْعٌ':Added, #1: 1	وَجْهِ بَيْعٍ
u'وَجْهٌ بَيِّنٌ':Added, #2: 2	وَجْهُ الْبَيْعِ
u'وَجْهٌ تَأْثِيرٌ':Added, #1: 1	وَجْهٍ بَيِّنٍ
u'وَجْهٌ تَأْخِيرٌ':Added, #1: 1	وَجْهِ التَّأْثِيرِ
u'وَجْهٌ تَأْخِيرٌ':Added, #1: 1	وَجْهَ تَأْخِيرِهِ
u'وَجْهٌ تَأْخِيرٌ':Added, #4: 4	وَجْهُ تَأْخِيرِهِ
u'وَجْهٌ تَأْدِيبٌ':Added, #6: 6	وَجْهُ تَأْخِيرِ
u'وَجْهٌ تَأْكِيدٌ':Added, #1: 1	وَجْهِ التَّأْدِيبِ
u'وَجْهٌ تَأَمُّلٌ':Added, #6: 6	وَجْهِ التَّأْكِيدِ
u'وَجْهٌ تَأَمُّلٌ':Added, #1: 1	وَجْهَ التَّأَمُّلِ
u'وَجْهٌ تَبَرُّدٌ':Added, #1: 1	وَجْهُ التَّأَمُّلِ
u'وَجْهٌ تَبَرُّعٌ':Added, #1: 1	وَجْهِ التَّبَرُّدِ
u'وَجْهٌ تَبَع':Added, #6: 6	وَجْهِ التَّبَرُّعِ
u'وَجْهٌ تَبَع':Added, #1: 1	وَجْهِ التَّبَعِ
u'وَجْهٌ تَبَعِيّ':Added, #4: 4	وَجْهِ التَّبَعِيَّةِ
u'وَجْهٌ تَبَعِيَّة':Added, #4: 4	وَجْهِ التَّبَعِيَّةِ
u'وَجْهٌ تَتَبُّعٌ':Added, #4: 4	وَجْهِ التَّبَعِيَّةِ
u'وَجْهٌ تَتَبُّعٌ':Added, #1: 1	وَجْهِ التَّتَبُّعِ
u'وَجْهٌ تِجَارَةٌ':Added, #1: 1	وَجْهِ تَتَبُّعِ
u'وَجْهٌ تَجَبُّرٌ':Added, #1: 1	وَجْهِ التِّجَارَةِ
u'وَجْهٌ تَجْرِبَةٌ':Added, #1: 1	وَجْهِ التَّجَبُّرِ
u'وَجْهٌ تَجْرِيح':Added, #1: 1	وَجْهِ التَّجْرِبَةِ
u'وَجْهٌ تَحَتُّمٌ':Added, #1: 1	وَجْهَ التَّجْرِيحِ
u'وَجْهٌ تَحْذِيرٌ':Added, #1: 1	وَجْهِ التَّحَتُّمِ
u'وَجْهٌ تَحْرِيرٌ':Added, #1: 1	وَجْهِ التَّحْذِيرِ
u'وَجْهٌ تَحْرِيمٌ':Added, #2: 2	وَجْهِ التَّحْرِيرِ
u'وَجْهٌ تَحْرِيمٌ':Added, #1: 1	وَجْهُ التَّحْرِيمِ
u'وَجْهٌ تَحْصِيلٌ':Added, #2: 2	وَجْهِ التَّحْرِيمِ
u'وَجْهٌ تَحْقِيقٌ':Added, #1: 1	وَجْهِ التَّحْصِيلِ
u'وَجْهٌ تَحْكِيمٌ':Added, #3: 3	وَجْهِ التَّحْقِيقِ
u'وَجْهٌ تَحِيَّةٌ':Added, #1: 1	وَجْهِ التَّحْكِيمِ
u'وَجْهٌ تَخْرِيجٌ':Added, #1: 1	وَجْهِ التَّحِيَّةِ
u'وَجْهٌ تَخْرِيجٌ':Added, #2: 2	وَجْهَ تَخْرِيجِ
u'وَجْهٌ تَخْرِيجٌ':Added, #2: 2	وَجْهُ تَخْرِيجِ
u'وَجْهٌ تَخْصِيصٌ':Added, #3: 3	وَجْهُ التَّخْرِيجِ
u'وَجْهٌ تَخْصِيصٌ':Added, #1: 1	وَجْهَ التَّخْصِيصِ
u'وَجْهٌ تَخْصِيصٌ':Added, #1: 1	وَجْهُ تَخْصِيصِهِ
u'وَجْهٌ تَخْصِيصٌ':Added, #1: 1	وَجْهِ تَخْصِيصِهِ
u'وَجْهٌ تَخْصِيصٌ':Added, #2: 2	وَجْهِ التَّخْصِيصِ
u'وَجْهٌ تَخْصِيصٌ':Added, #2: 2	وَجْهَ تَخْصِيصِ
u'وَجْهٌ تَخْصِيصٌ':Added, #2: 2	وَجْهِ تَخْصِيصِ
u'وَجْهٌ تَخْصِيصٌ':Added, #3: 3	وَجْهُ التَّخْصِيصِ
u'وَجْهٌ تَخْفِيفٌ':Added, #6: 6	وَجْهُ تَخْصِيصِ
u'وَجْهٌ تَخْيِيرٌ':Added, #2: 2	وَجْهِ التَّخْفِيفِ
u'وَجْهٌ تَخْيِيرٌ':Added, #2: 2	وَجْهُ التَّخْيِيرِ
u'وَجْهٌ تَدْبِيرٌ':Added, #7: 7	وَجْهِ التَّخْيِيرِ
u'وَجْهٌ تَذْكِيَةٌ':Added, #1: 1	وَجْهِ التَّدْبِيرِ
u'وَجْهٌ تَذْكيرٌ':Added, #1: 1	وَجْهِ التَّذْكِيَةِ
u'وَجْهٌ تَرْتِيبٌ':Added, #1: 1	وَجْهِ التَّذْكِيرِ
u'وَجْهٌ تَرْجِيحٌ':Added, #2: 2	وَجْهُ تَرْتِيبِ
u'وَجْهٌ تَرْجِيحٌ':Added, #1: 1	وَجْهِ التَّرْجِيحِ
u'وَجْهٌ تَرْجِيحٌ':Added, #1: 1	وَجْهَ تَرْجِيحِهِ
u'وَجْهٌ تَرْجِيحٌ':Added, #3: 3	وَجْهُ التَّرْجِيحِ
u'وَجْهٌ تَرْكٌ':Added, #5: 5	وَجْهُ تَرْجِيحِ
u'وَجْهٌ تَرْكٌ':Added, #1: 1	وَجْهِ تَرْكِ
u'وَجْهٌ تَرْكِيبٌ':Added, #3: 3	وَجْهُ تَرْكِ
u'وَجْهٌ تَسَتُّرٌ':Added, #1: 1	وَجْهِ التَّرْكِيبِ
u'وَجْهٌ تَسْلِيطٌ':Added, #1: 1	وَجْهِ التَّسَتُّرِ
u'وَجْهٌ تَسْمِيَة':Added, #2: 2	وَجْهِ التَّسْلِيطِ
u'وَجْهٌ تَسْمِيَة':Added, #1: 1	وَجْهُ التَّسْمِيَةِ
u'وَجْهٌ تَسْمِيَة':Added, #1: 1	وَجْهِ التَّسْمِيَةِ
u'وَجْهٌ تَسْمِيَة':Added, #1: 1	وَجْهَ تَسْمِيَةِ
u'وَجْهٌ تَسْمِيَة':Added, #2: 2	وَجْهُ تَسْمِيَةِ
u'وَجْهٌ تَسَوُّرٌ':Added, #2: 2	وَجْهِ تَسْمِيَةِ
u'وَجْهٌ تَسْوِيَةٌ':Added, #2: 2	وَجْهِ التَّسَوُّرِ
u'وَجْهٌ تَسْوِيَةٌ':Added, #1: 1	وَجْهُ التَّسْوِيَةِ
u'وَجْهٌ تَشْبِيه':Added, #1: 1	وَجْهِ التَّسْوِيَةِ
u'وَجْهٌ تَشْبِيهٌ':Added, #1: 1	وَجْهِ التَّشْبِيهِ
u'وَجْهٌ تَشْبِيهٌ':Added, #1: 1	وَجْهَ تَشْبِيهِ
u'وَجْهٌ تَشْبِيه':Added, #1: 1	وَجْهِ تَشْبِيهِ
u'وَجْهٌ تَشْدِيدٌ':Added, #4: 4	وَجْهُ التَّشْبِيهِ
u'وَجْهٌ تَشْرِيعٌ':Added, #2: 2	وَجْهِ التَّشْدِيدِ
u'وَجْهٌ تَشْرِيعٌ':Added, #1: 1	وَجْهَ التَّشْرِيعِ
u'وَجْهٌ تَشْرِيك':Added, #1: 1	وَجْهُ التَّشْرِيعِ
u'وَجْهٌ تَصْحِيحٌ':Added, #1: 1	وَجْهِ التَّشْرِيكِ
u'وَجْهٌ تَصْدِيقٌ':Added, #1: 1	وَجْهُ تَصْحِيحِ
u'وَجْهٌ تَصْدِيقٌ':Added, #1: 1	وَجْهِ التَّصْدِيقِ
u'وَجْهٌ تَضْيِيقٌ':Added, #1: 1	وَجْهُ تَصْدِيقِهِ
u'وَجْهٌ تَطَرُّقٌ':Added, #1: 1	وَجْهِ التَّضْيِيقِ
u'وَجْهٌ تَطَوُّعٌ':Added, #1: 1	وَجْهُ التَّطَرُّقِ
u'وَجْهٌ تَطَيُّبٌ':Added, #1: 1	وَجْهِ التَّطَوُّعِ
u'وَجْهٌ تَعَارُضٌ':Added, #4: 4	وَجْهِ التَّطَيُّبِ
u'وَجْهٌ تَعَبُّدٌ':Added, #1: 1	وَجْهُ التَّعَارُضِ
u'وَجْهٌ تَعْجِيل':Added, #3: 3	وَجْهِ التَّعَبُّدِ
u'وَجْهٌ تَعْجِيل':Added, #1: 1	وَجْهُ تَعْجِيلِ
u'وَجْهٌ تَعْدِيلٌ':Added, #1: 1	وَجْهِ تَعْجِيلٍ
u'وَجْهٌ تَعْرِيفٌ':Added, #1: 1	وَجْهُ التَّعْدِيلِ
u'وَجْهٌ تَعْزِير':Added, #1: 1	وَجْهِ التَّعْرِيفِ
u'وَجْهٌ تَعَطُّلٌ':Added, #1: 1	وَجْهِ التَّعْزِيرِ
u'وَجْهٌ تَعْظِيمٌ':Added, #1: 1	وَجْهُ التَّعَطُّلِ
u'وَجْهٌ تَعْقِيبٌ':Added, #11: 11	وَجْهِ التَّعْظِيمِ
u'وَجْهٌ تَعَلُّقٌ':Added, #1: 1	وَجْهُ التَّعْقِيبِ
u'وَجْهٌ تَعَلُّقٌ':Added, #1: 1	وَجْهِ التَّعَلُّقِ
u'وَجَّهَ تَعْلِيقٌ':Predicate, #1: 1	وَجْهَ تَعَلُّقِ
u'وَجْهٌ تَعْلِيقٌ':Added, #1: 1	وَجَّهَ التَّعْلِيقَ
u'وَجْهٌ تَعْلِيقٌ':Added, #1: 1	وَجْهِ تَعْلِيقِ
u'وَجْهٌ تَعْلِيلٌ':Added, #6: 6	وَجْهِ التَّعْلِيقِ
u'وَجْهٌ تَعْلِيمٌ':Added, #2: 2	وَجْهِ التَّعْلِيلِ
u'وَجْهٌ تَعْلِيمٌ':Added, #1: 1	وَجْهِ تَعْلِيمِ
u'وَجْهٌ تَعْوِيضٌ':Added, #3: 3	وَجْهِ التَّعْلِيمِ
u'وَجْهٌ تَعْيِيرٌ':Added, #1: 1	وَجْهِ التَّعْوِيضِ
u'وَجْهٌ تَعْيِينٌ':Added, #1: 1	وَجْهِ التَّعْيِيرِ
u'وَجْهٌ تَعْيِينٌ':Added, #1: 1	وَجْهِ التَّعْيِينِ
u'وَجْهٌ تَغَايُرٌ':Added, #1: 1	وَجْهُ تَعْيِينِ
u'وَجْهٌ تَغْرِير':Added, #1: 1	وَجْهِ التَّغَايُرِ
u'وَجْهٌ تَغْرِيمٌ':Added, #1: 1	وَجْهِ التَّغْرِيرِ
u'وَجْهٌ تَغَلُّبٌ':Added, #1: 1	وَجْهِ تَغْرِيمِ
u'وَجْهٌ تَغْلِيبٌ':Added, #1: 1	وَجْهِ التَّغَلُّبِ
u'وَجْهٌ تَغْلِيبٌ':Added, #1: 1	وَجْهِ التَّغْلِيبِ
u'وَجْهٌ تَفاوُت':Added, #1: 1	وَجْهُ تَغْلِيبِهِ
u'وَجْهٌ تَفْرِقَة':Added, #1: 1	وَجْهِ التَّفَاوُتِ
u'وَجْهٌ تَفْسِيرٌ':Added, #2: 2	وَجْهُ التَّفْرِقَةِ
u'وَجْهٌ تَفْسِيرٌ':Added, #1: 1	وَجْهِ التَّفْسِيرِ
u'وَجْهٌ تَفْسِيرٌ':Added, #1: 1	وَجْهُ تَفْسِيرٍ
u'وَجْهٌ تَفْصِيلٌ':Added, #1: 1	وَجْهُ تَفْسِيرِ
u'وَجْهٌ تَفَضُّلٌ':Added, #1: 1	وَجْهِ التَّفْصِيلِ
u'وَجْهٌ تَفْضِيلٌ':Added, #1: 1	وَجْهِ التَّفَضُّلِ
u'وَجْهٌ تَفْضِيلٌ':Added, #1: 1	وَجْهَ التَّفْضِيلِ
u'وَجْهٌ تَفْوِيضٌ':Added, #1: 1	وَجْهُ تَفْضِيلِهِ
u'وَجْهٌ تَقْديرٌ':Added, #3: 3	وَجْهِ التَّفْوِيضِ
u'وَجْهٌ تَقْديمٌ':Added, #2: 2	وَجْهِ التَّقْدِيرِ
u'وَجْهٌ تَقْديمٌ':Added, #1: 1	وَجْهَ تَقْدِيمِهِ
u'وَجْهٌ تَقْديمٌ':Added, #5: 5	وَجْهِ تَقْدِيمِ
u'وَجْهٌ تَقَرُّبٌ':Added, #8: 8	وَجْهُ تَقْدِيمِ
u'وَجْهٌ تَقْيِيد':Added, #2: 2	وَجْهِ التَّقَرُّبِ
u'وَجْهٌ تَقْيِيد':Added, #1: 1	وَجْهُ التَّقْيِيدِ
u'وَجْهٌ تَقْيِيد':Added, #1: 1	وَجْهِ التَّقْيِيدِ
u'وَجْهٌ تَقْيِيد':Added, #1: 1	وَجْهِ تَقْيِيدِ
u'وَجْهٌ تَكَبُّرٌ':Added, #2: 2	وَجْهَ التَّقْيِيدِ
u'وَجْهٌ تَكْريرٌ':Added, #4: 4	وَجْهِ التَّكَبُّرِ
u'وَجْهٌ تَكْريرٌ':Added, #1: 1	وَجْهُ تَكْرِيرِ
u'وَجْهٌ تَكْفيرٌ':Added, #1: 1	وَجْهِ تَكْرِيرِ
u'وَجْهٌ تَكَلُّفٌ':Added, #1: 1	وَجْهِ التَّكْفِيرِ
u'وَجْهٌ تَكْليفٌ':Added, #1: 1	وَجْهِ التَّكَلُّفِ
u'وَجْهٌ تَكْميلٌ':Added, #1: 1	وَجْهِ التَّكْلِيفِ
u'وَجْهٌ تِلاوَةٌ':Added, #1: 1	وَجْهِ التَّكْمِيلِ
u'وَجْهٌ تَلَذُّذٌ':Added, #3: 3	وَجْهِ التِّلَاوَةِ
u'وَجْهٌ تمام':Added, #1: 1	وَجْهِ التَّلَذُّذِ
u'وَجْهٌ تَمامٌ':Added, #1: 1	وَجْهَ تَمَامِ
u'وَجْهٌ تمام':Added, #1: 1	وَجْهَ تَمَامِ
u'وَجْهٌ تَمامٌ':Added, #5: 5	وَجْهِ التَّمَامِ
u'وَجْهٌ تَمايُزٌ':Added, #5: 5	وَجْهِ التَّمَامِ
u'وَجْهٌ تَمَتُّعٌ':Added, #1: 1	وَجْهَ تَمَايُزِ
u'وَجْهٌ تَمْثيلٌ':Added, #2: 2	وَجْهِ التَّمَتُّعِ
u'وَجْهٌ تَمَلُّك':Added, #1: 1	وَجْهِ التَّمْثِيلِ
u'وَجْهٌ تَمَلُّك':Added, #1: 1	وَجْهُ التَّمَلُّكِ
u'وَجْهٌ تَمْلِيك':Added, #3: 3	وَجْهِ التَّمَلُّكِ
u'وَجْهٌ تَمَوُّلٌ':Added, #13: 13	وَجْهِ التَّمْلِيكِ
u'وَجْهٌ تَمَيُّزٌ':Added, #3: 3	وَجْهِ التَّمَوُّلِ
u'وَجْهٌ تَمْييزٌ':Added, #1: 1	وَجْهِ التَّمَيُّزِ
u'وَجْهٌ تَنَزُّلٌ':Added, #3: 3	وَجْهِ التَّمْيِيزِ
u'وَجْهٌ تَنَزُّه':Added, #1: 1	وَجْه التَّنَزُّلِ
u'وَجْهٌ تَنْزِيه':Added, #1: 1	وَجْهِ التَّنَزُّهِ
u'وَجْهٌ تَنْفِيلٌ':Added, #2: 2	وَجْهِ التَّنْزِيهِ
u'وَجْهٌ تَنْقِيبٌ':Added, #1: 1	وَجْهِ التَّنْفِيلِ
u'وَجْهٌ تَنْكِيرٌ':Added, #1: 1	وَجْهِ التَّنْقِيبِ
u'وَجْهٌ تَنُّورٌ':Added, #1: 1	وَجْهِ التَّنْكِيرِ
u'وَجْهٌ تَوَاضُعٌ':Added, #2: 2	وَجْهِ تَنُّورٍ
u'وَجْهٌ تَوْجِيهٌ':Added, #2: 2	وَجْهِ التَّوَاضُعِ
u'وَجْهٌ تَوَرُّعٌ':Added, #1: 1	وَجْهُ التَّوْجِيهِ
u'وَجْهٌ تَوْرِيَةٌ':Added, #1: 1	وَجْهِ التَّوَرُّعِ
u'وَجْهٌ تَوْفِيَةٌ':Added, #1: 1	وَجْهِ التَّوْرِيَةِ
u'وَجْهٌ تَوْفِيقٌ':Added, #1: 1	وَجْهِ التَّوْفِيَةِ
u'وَجْهٌ تَوْفِيقٌ':Added, #2: 2	وَجْهَ التَّوْفِيقِ
u'وَجْهٌ تَوْفِيقٌ':Added, #3: 3	وَجْهُ التَّوْفِيقِ
u'وَجْهٌ تَوْقِيرٌ':Added, #3: 3	وَجْهِ التَّوْفِيقِ
u'وَجْهٌ تَوْكِيدٌ':Added, #1: 1	وَجْهِ التَّوْقِيرِ
u'وَجْهٌ تَيْسيرٌ':Added, #1: 1	وَجْهِ التَّوْكِيدِ
u'وَجْهٌ ثَابِتٌ':Added, #2: 2	وَجْهِ التَّيْسِيرِ
u'وَجْهٌ ثَالِثٌ':Added, #2: 2	وَجْهٍ ثَابِتٍ
u'وَجْهٌ ثَالِثٌ':Added, #2: 2	وَجْهُ الثَّالِثِ
u'وَجْهٌ ثَالِثٌ':Added, #2: 2	وَجْهُ الثَّالِثَةِ
u'وَجْهٌ ثَانِي':Added, #7: 7	وَجْهٍ ثَالِثٍ
u'وَجْهٌ ثَانِيَةٌ':Added, #1: 1	وَجْهُ الثَّانِيَةِ
u'وَجْهٌ ثَائِرٌ':Added, #1: 1	وَجْهُ الثَّانِيَةِ
u'وَجْهٌ ثُبُوتٌ':Added, #1: 1	وَجْهِ الثَّائِرَةِ
u'وَجْهٌ ثُبُوتٌ':Added, #1: 1	وَجْهُ ثُبُوتِ
u'وَجْهٌ ثُبُوتٌ':Added, #1: 1	وَجْهِ ثُبُوتِ
u'وَجْهٌ ثِقَةٌ':Added, #1: 1	وَجْهِ ثُبُوتِهِ
u'وَجْهٌ ثَمانِيَةٌ':Added, #1: 1	وَجْهَ الثِّقَةِ
u'وَجْهٌ ثَناءٌ':Added, #1: 1	وَجْهِ الثَّمَانِيَةِ
u'وَجْهٌ ثَوابٌ':Added, #2: 2	وَجْهِ الثَّنَاءِ
u'وَجْهٌ ثَوْبٌ':Added, #1: 1	وَجْهِ الثَّوَابِ
u'وَجَّهَ جَارِي':Predicate, #1: 1	وَجْهَ الثَّوْبِ
u'وَجْهٌ جَارِي':Added, #1: 1	وَجَّهَ جَارِيَةً
u'وَجْهٌ جَارِي':Added, #1: 1	وَجْهَ جَارِيَتِهِ
u'وَجْهٌ جَارِيَةٌ':Added, #4: 4	وَجْهِ الْجَارِيَةِ
u'وَجْهٌ جَارِيَةٌ':Added, #1: 1	وَجْهَ جَارِيَتِهِ
u'وَجْهٌ جَامِعٌ':Added, #4: 4	وَجْهِ الْجَارِيَةِ
u'وَجْهٌ جَائِزٌ':Added, #1: 1	وَجْهِ الْجَامِعِ
u'وَجْهٌ جَحْد':Added, #3: 3	وَجْهٍ جَائِزٍ
u'وَجْهٌ جِدار':Added, #1: 1	وَجْهِ الْجَحْدِ
u'وَجْهٌ جَرَيان':Added, #1: 1	وَجْهُ الْجِدَارِ
u'وَجْهٌ جَزْم':Added, #3: 3	وَجْهُ جَرَيَانِ
u'وَجْهٌ جُزْئِيٌّ':Added, #1: 1	وَجْهِ الْجَزْمِ
u'وَجْهٌ جُزْئِيَّةٌ':Added, #2: 2	وَجْهِ الْجُزْئِيَّةِ
u'وَجْهٌ جَمْدٌ':Added, #2: 2	وَجْهِ الْجُزْئِيَّةِ
u'وَجْهٌ جمع':Added, #1: 1	وَجْهِ الْجَمْدِ
u'وَجْهٌ جمع':Added, #5: 5	وَجْهُ الْجَمْعِ
u'وَجْهٌ جَمْعٌ':Added, #5: 5	وَجْهِ الْجَمْعِ
u'وَجْهٌ جَمْعٌ':Added, #5: 5	وَجْهُ الْجَمْعِ
u'وَجْهٌ جُمْلَةٌ':Added, #5: 5	وَجْهِ الْجَمْعِ
u'وَجْهٌ جَمِيع':Added, #1: 1	وَجْهِ الْجُمْلَةِ
u'وَجْهٌ جَنِينٌ':Added, #1: 1	وَجْهَ الْجَمِيعِ
u'وَجْهٌ جهاد':Added, #2: 2	وَجْهُ الْجَنِينِ
u'وَجْهٌ جِهَادٌ':Added, #1: 1	وَجْهِ الْجِهَادِ
u'وَجْهٌ جهر':Added, #1: 1	وَجْهِ الْجِهَادِ
u'وَجْهٌ جَهْرٌ':Added, #1: 1	وَجْهِ الْجَهْرِ
u'وَجْهٌ جَوَابٌ':Added, #1: 1	وَجْهِ الْجَهْرِ
u'وَجْهٌ جَوَازٌ':Added, #1: 1	وَجْهُ جَوَابِ
u'وَجْهٌ جَوَازٌ':Added, #1: 1	وَجْهُ الْجَوَازِ
u'وَجْهٌ جَوَازٌ':Added, #1: 1	وَجْهُ جَوَازِ
u'وَجْهٌ جَوَازٌ':Added, #1: 1	وَجْهِ جَوَازِهِ
u'وَجْهٌ جَوَازٌ':Added, #3: 3	وَجْهَ الْجَوَازِ
u'وَجْهٌ حاجَةٌ':Added, #7: 7	وَجْهِ الْجَوَازِ
u'وَجْهٌ حارِثٌ':Added, #2: 2	وَجْهِ الْحَاجَةِ
u'وَجْهٌ حارِثٌ':Added, #1: 1	وَجْهَ الْحَارِثِ
u'وَجْهٌ حائِطٌ':Added, #1: 1	وَجْهِ الْحَارِثِ
u'وَجْهٌ حَبْسٌ':Added, #3: 3	وَجْهُ الْحَائِطِ
u'وَجْهٌ حُجَّةٌ':Added, #1: 1	وَجْهِ الْحَبْسِ
u'وَجْهٌ حُجَّةٌ':Added, #1: 1	وَجْهَ الْحُجَّةِ
u'وَجْهٌ حُجَّةٌ':Added, #1: 1	وَجْهُ الْحُجَّةِ
u'وَجْهٌ حَدٌّ':Added, #1: 1	وَجْهِ الْحُجَّةِ
u'وَجْهٌ حَديثٌ':Added, #1: 1	وَجْهِ الْحَدِّ
u'وَجْهٌ حَديثٌ':Added, #1: 1	وَجْهُ الْحَدِيثَيْنِ
u'وَجْهٌ حَديثٌ':Added, #1: 1	وَجْهُ حَدِيثِ
u'وَجْهٌ حُرٌّ':Added, #2: 2	وَجْهُ الْحَدِيثِ
u'وَجْهٌ حُرٌّ':Added, #2: 2	وَجْهِ الْحُرَّةِ
u'وَجْهٌ حُرٌّ':Added, #2: 2	وَجْهِ حُرٍّ
u'وَجْهٌ حَرامٌ':Added, #4: 4	وَجْهُ حُرٍّ
u'وَجْهٌ حَرامٌ':Added, #1: 1	وَجْهِ الْحَرَامِ
u'وَجْهٌ حُرْمَةٌ':Added, #1: 1	وَجْهٍ حَرَامٍ
u'وَجْهٌ حُرْمَةٌ':Added, #1: 1	وَجْهُ الْحُرْمَةِ
u'وَجْهٌ حُرْمَةٌ':Added, #2: 2	وَجْهَ الْحُرْمَةِ
u'وَجْهٌ حِسْبَةٌ':Added, #2: 2	وَجْهِ الْحُرْمَةِ
u'وَجْهٌ حَصْرٌ':Added, #4: 4	وَجْهِ الْحِسْبَةِ
u'وَجْهٌ حَطّ':Added, #3: 3	وَجْهِ الْحَصْرِ
u'وَجْهٌ حَظٌّ':Added, #1: 1	وَجْهِ الْحَطِّ
u'وَجْهٌ حِفْظٌ':Added, #1: 1	وَجْهِ الْحَظِّ
u'وَجْهٌ حَقٌّ':Added, #1: 1	وَجْهِ الْحِفْظِ
u'وَجْهٌ حَقٌّ':Added, #2: 2	وَجْهُ الْحَقِّ
u'وَجْهٌ حَقِيقٌ':Added, #4: 4	وَجْهِ الْحَقِّ
u'وَجْهٌ حَقِيقَةٌ':Added, #2: 2	وَجْهِ الْحَقِيقَةِ
u'وَجَّهَ حُكْمٌ':Predicate, #2: 2	وَجْهِ الْحَقِيقَةِ
u'وَجَّهَ حَكَمٌ':Subject, #1: 1	وَجَّهَ الْحُكْمَ
u'وَجْهٌ حُكْمٌ':Added, #1: 1	وَجَّهَ الْحَكَمُ
u'وَجْهٌ حُكْمٌ':Added, #10: 10	وَجْهُ الْحُكْمِ
u'وَجْهٌ حُكْمٌ':Added, #11: 11	وَجْهِ الْحُكْمِ
u'وَجْهٌ حكماء':Added, #1: 1	وَجْهُ حُكْمِ
u'وَجْهٌ حكمة':Added, #1: 1	وَجْهُ الْحُكَمَاءِ
u'وَجْهٌ حِكْمَةٌ':Added, #1: 1	وَجْهَ الْحِكْمَةِ
u'وَجْهٌ حكمة':Added, #1: 1	وَجْهَ الْحِكْمَةِ
u'وَجْهٌ حِكْمَةٌ':Added, #2: 2	وَجْهُ الْحِكْمَةِ
u'وَجْهٌ حكمة':Added, #2: 2	وَجْهُ الْحِكْمَةِ
u'وَجْهٌ حِكْمَةٌ':Added, #4: 4	وَجْهِ الْحِكْمَةِ
u'وَجْهٌ حُكُومَةٌ':Added, #4: 4	وَجْهِ الْحِكْمَةِ
u'وَجْهٌ حِلٌّ':Added, #1: 1	وَجْهِ الْحُكُومَةِ
u'وَجْهٌ حِلٌّ':Added, #1: 1	وَجْهَ الْحِلِّ
u'وَجْهٌ حِلٌّ':Added, #1: 1	وَجْهِ حِلٍّ
u'وَجْهٌ حَلالٌ':Added, #1: 1	وَجْهُ حِلِّهِ
u'وَجْهٌ حِلْيَةٌ':Added, #2: 2	وَجْهٍ حَلَالٍ
u'وَجْهٌ حَمَّامٌ':Added, #1: 1	وَجْهُ الْحِلْيَةِ
u'وَجْهٌ حَمْلٌ':Added, #1: 1	وَجْهِ الْحَمَّامِ
u'وَجْهٌ حَوَالَةٌ':Added, #1: 1	وَجْهِ الْحَمْلِ
u'وَجْهٌ حِيلَةٌ':Added, #1: 1	وَجْهُ الْحَوَالَةِ
u'وَجْهٌ حَيَوَانٌ':Added, #3: 3	وَجْهِ الْحِيلَةِ
u'وَجْهٌ خَادِمٌ':Added, #1: 1	وَجْهِ الْحَيَوَانِ
u'وَجْهٌ خاصّ':Added, #1: 1	وَجْهَ خَادِمٍ
u'وَجَّهَ خَالِدٌ':Predicate, #7: 7	وَجْهٍ خَاصٍّ
u'وَجْهٌ خَالِدٌ':Added, #1: 1	وَجَّهَ خَالِدَ
u'وَجْهٌ خامس':Added, #1: 1	وَجْهِ خَالِدٍ
u'وَجْهٌ خَامِسٌ':Added, #1: 1	وَجْهٍ خَامِسٍ
u'وَجْهٌ خَبَرٌ':Added, #1: 1	وَجْهٍ خَامِسٍ
u'وَجْهٌ خَبَر':Added, #5: 5	وَجْهِ الْخَبَرِ
u'وَجْهٌ خُبْزٌ':Added, #5: 5	وَجْهِ الْخَبَرِ
u'وَجْهٌ خراج':Added, #1: 1	وَجْهِ الْخُبْزِ
u'وَجْهٌ خَرَاجٌ':Added, #2: 2	وَجْهِ الْخَرَاجِ
u'وَجْهٌ خَرْج':Added, #2: 2	وَجْهِ الْخَرَاجِ
u'وَجْهٌ خُرُوجٌ':Added, #1: 1	وَجْهِ الْخَرْجِ
u'وَجْهٌ خُرُوجٌ':Added, #1: 1	وَجْهَ خُرُوجِ
u'وَجْهٌ خُرُوجٌ':Added, #2: 2	وَجْهُ خُرُوجِ
u'وَجْهٌ خُرُوجٌ':Added, #2: 2	وَجْهَ خُرُوجِهِ
u'وَجْهٌ خَصْمٌ':Added, #3: 3	وَجْهُ خُرُوجِهِ
u'وَجْهٌ خَصْمٌ':Added, #1: 1	وَجْهِ الْخَصْمِ
u'وَجْهٌ خَصْمٌ':Added, #2: 2	وَجْهِ خَصْمِهِ
u'وَجْهٌ خُصُومَةٌ':Added, #5: 5	وَجْهِ خَصْمٍ
u'وَجْهٌ خَطَأٌ':Added, #3: 3	وَجْهِ الْخُصُومَةِ
u'وَجْهٌ خَطَأٌ':Added, #1: 1	وَجْهِ الْخَطَأِ
u'وَجْهٌ خطبة':Added, #1: 1	وَجْهٍ خَطَأٍ
u'وَجْهٌ خِطْبَةٌ':Added, #1: 1	وَجْهِ الْخِطْبَةِ
u'وَجْهٌ خِلابَة':Added, #1: 1	وَجْهِ الْخِطْبَةِ
u'وَجْهٌ خُلاصَة':Added, #1: 1	وَجْهَ الْخِلَابَةِ
u'وَجْهٌ خِلاَفٌ':Added, #1: 1	وَجْهُ خُلَاصَةٍ
u'وَجْهٌ خِلاَفٌ':Added, #1: 1	وَجْهُ الْخِلَافِ
u'وَجْهٌ خِلاَفٌ':Added, #1: 1	وَجْهَ خِلَافِهِ
u'وَجْهٌ خِلاَفَةٌ':Added, #4: 4	وَجْهَ الْخِلَافِ
u'وَجْهٌ خُلْعٌ':Added, #1: 1	وَجْهِ الْخِلَافَةِ
u'وَجْهٌ خَلَلٌ':Added, #2: 2	وَجْهِ الْخُلْعِ
u'وَجْهٌ خَلْوَةٌ':Added, #1: 1	وَجْهَ الْخَلَلِ
u'وَجْهٌ خِيَانَةٌ':Added, #1: 1	وَجْهِ الْخَلْوَةِ
u'وَجْهٌ خَيْرٌ':Added, #2: 2	وَجْهِ الْخِيَانَةِ
u'وَجْهٌ دَابَّةٌ':Added, #3: 3	وَجْهِ الْخَيْرِ
u'وَجْهٌ دَابَّةٌ':Added, #1: 1	وَجْهَ دَابَّتِهِ
u'وَجْهٌ دَابَّةٌ':Added, #1: 1	وَجْهُ دَابَّتِهِ
u'وَجْهٌ دَاحِسٌ':Added, #4: 4	وَجْهِ الدَّابَّةِ
u'وَجْهٌ دُخُولٌ':Added, #1: 1	وَجْهَ دَاحِسٍ
u'وَجْهٌ دُخُولٌ':Added, #1: 1	وَجْهُ الدُّخُولِ
u'وَجْهٌ دَرْء':Added, #1: 1	وَجْهُ دُخُولِ
u'وَجْهٌ دِرَايَةٌ':Added, #1: 1	وَجْهُ الدَّرْءِ
u'وَجْهٌ دُعَاءٌ':Added, #1: 1	وَجْهُ الدِّرَايَةِ
u'وَجْهٌ دَعْوَةٌ':Added, #3: 3	وَجْهِ الدُّعَاءِ
u'وَجْهٌ دفع':Added, #1: 1	وَجْهَ الدَّعْوَةِ
u'وَجْهٌ دَفْعٌ':Added, #1: 1	وَجْهَ الدَّفْعِ
u'وَجْهٌ دفع':Added, #1: 1	وَجْهَ الدَّفْعِ
u'وَجْهٌ دَفْعٌ':Added, #1: 1	وَجْهُ دَفْعِ
u'وَجْهٌ دفع':Added, #1: 1	وَجْهُ دَفْعِ
u'وَجْهٌ دَفْعٌ':Added, #1: 1	وَجْهُ دَفْعِهِ
u'وَجْهٌ دفع':Added, #1: 1	وَجْهُ دَفْعِهِ
u'وَجْهٌ دَفْعٌ':Added, #4: 4	وَجْهِ الدَّفْعِ
u'وَجْهٌ دَفْق':Added, #4: 4	وَجْهِ الدَّفْعِ
u'وَجْهٌ دَلالَةٌ':Added, #9: 9	وَجْهِ الدَّفْقِ
u'وَجْهٌ دَلالَةٌ':Added, #19: 19	وَجْهُ الدَّلَالَةِ
u'وَجْهٌ دَلالَةٌ':Added, #1: 1	وَجْهُ الدّلَالَةِ
u'وَجْهٌ دِلاَلَةٌ':Added, #1: 1	وَجْهِ الدَّلَالَةِ
u'وَجْهٌ دَلالَةٌ':Added, #1: 1	وَجْهُ الدّلَالَةِ
u'وَجْهٌ دَلالَةٌ':Added, #1: 1	وَجْهُ دَلَالَةِ
u'وَجْهٌ دَلالَةٌ':Added, #1: 1	وَجْهِ دَلَالَةٍ
u'وَجْهٌ دَلالَةٌ':Added, #3: 3	وَجْهِ دَلَالَتِهِ
u'وَجْهٌ دَلالَةٌ':Added, #4: 4	وَجْهَ الدَّلَالَةِ
u'وَجْهٌ دَليلٌ':Added, #4: 4	وَجْهِ دَلَالَةِ
u'وَجْهٌ دَليلٌ':Added, #1: 1	وَجْهَ الدَّلِيلِ
u'وَجْهٌ دَليلٌ':Added, #1: 1	وَجْهِ الدَّلِيلِ
u'وَجْهٌ دَليلٌ':Added, #1: 1	وَجْهَ دَلِيلِهِ
u'وَجْهٌ دَواءٌ':Added, #5: 5	وَجْهُ الدَّلِيلِ
u'وَجَّهَ دَوَابُّ':Predicate, #1: 1	وَجْهِ الدَّوَاءِ
u'وَجْهٌ دَوامٌ':Added, #1: 1	وَجَّهَ الدَّوَابَّ
u'وَجْهٌ دِينٌ':Added, #1: 1	وَجْهِ الدَّوَامِ
u'وَجْهٌ دِينٌ':Added, #1: 1	وَجْهُ دِينِهِ
u'وَجْهٌ دَيْنٌ':Added, #2: 2	وَجْهِ الدِّينِ
u'وَجْهٌ ذَكاةٌ':Added, #2: 2	وَجْهِ الدَّيْنِ
u'وَجْهٌ ذَكاةٌ':Added, #1: 1	وَجْهَ الذَّكَاةِ
u'وَجْهٌ ذكر':Added, #1: 1	وَجْهِ الذَّكَاةِ
u'وَجْهٌ ذَكَرٌ':Added, #1: 1	وَجْهِ الذَّكَرِ
u'وَجْهٌ ذكر':Added, #1: 1	وَجْهِ الذَّكَرِ
u'وَجْهٌ ذِكْرٌ':Added, #1: 1	وَجْهِ ذِكْرِهِ
u'وَجْهٌ ذكر':Added, #1: 1	وَجْهِ ذِكْرِهِ
u'وَجْهٌ ذِكْرٌ':Added, #2: 2	وَجْهُ ذِكْرِ
u'وَجْهٌ ذكر':Added, #2: 2	وَجْهُ ذِكْرِ
u'وَجْهٌ ذكر':Added, #2: 2	وَجْهَ ذِكْرِهِ
u'وَجْهٌ ذِكْرٌ':Added, #2: 2	وَجْهُ ذِكْرِهِ
u'وَجْهٌ ذِكْرٌ':Added, #2: 2	وَجْهَ ذِكْرِهِ
u'وَجْهٌ ذَمٌّ':Added, #2: 2	وَجْهُ ذِكْرِهِ
u'وَجْهٌ رابع':Added, #2: 2	وَجْهِ الذَّمِّ
u'وَجْهٌ رَابِعٌ':Added, #1: 1	وَجْهٍ رَابِعٍ
u'وَجْهٌ رَأْفَةٌ':Added, #1: 1	وَجْهٍ رَابِعٍ
u'وَجْهٌ رَبُّ':Added, #1: 1	وَجْهِ الرَّأْفَةِ
u'وَجْهٌ رِبْحٌ':Added, #2: 2	وَجْهِ رَبّهِ
u'وَجْهٌ رُبْعٌ':Added, #1: 1	وَجْهِ الرِّبْحِ
u'وَجْهٌ رُجْحانٌ':Added, #1: 1	وَجْهُ رُبْعِ
u'وَجْهٌ رَجُلٌ':Added, #1: 1	وَجْهُ الرُّجْحَانِ
u'وَجْهٌ رَجُلٌ':Added, #1: 1	وَجْهِ الرَّجُلِ
u'وَجْهٌ رَجُلٌ':Added, #2: 2	وَجْهَ الرَّجُلِ
u'وَجْهٌ رَجُلٌ':Added, #4: 4	وَجْهَ رَجُلٍ
u'وَجْهٌ رُجُوعٌ':Added, #4: 4	وَجْهِ رَجُلٍ
u'وَجْهٌ رحمة':Added, #2: 2	وَجْهَ رُجُوعِهِ
u'وَجْهٌ رَحْمَةٌ':Added, #1: 1	وَجْهِ الرَّحْمَةِ
u'وَجْهٌ رُخْصَةٌ':Added, #1: 1	وَجْهِ الرَّحْمَةِ
u'وَجْهٌ رُخْصَةٌ':Added, #1: 1	وَجْهُ الرُّخْصَةِ
u'وَجْهٌ رَدٌّ':Added, #1: 1	وَجْهِ الرُّخْصَةِ
u'وَجْهٌ رَدٌّ':Added, #1: 1	وَجْهُ الرَّدِّ
u'وَجْهٌ رَدٌّ':Added, #1: 1	وَجْهِ رَدِّ
u'وَجْهٌ رَدٌّ':Added, #1: 1	وَجْهُ رَدِّهِ
u'وَجْهٌ رَدٌّ':Added, #3: 3	وَجْهِ الرَّدِّ
u'وَجْهٌ رِسَالَةٌ':Added, #3: 3	وَجْهُ رَدِّ
u'وَجْهٌ رَسْمٌ':Added, #20: 20	وَجْهِ الرِّسَالَةِ
u'وَجْهٌ رَسُولٌ':Added, #4: 4	وَجْهِ الرَّسْمِ
u'وَجْهٌ رَسُولٌ':Added, #16: 16	وَجْهِ رَسُولِ
u'وَجْهٌ رَسُولٌ':Added, #18: 18	وَجْهُ رَسُولِ
u'وَجْهٌ رَسُولٌ':Added, #1: 1	وَجْهُ الرَّسُولِ
u'وَجْهٌ رَسُولٌ':Added, #1: 1	وَجْهَ رَسُولِهِ
u'وَجْهٌ رَغْبَةٌ':Added, #7: 7	وَجْهَ رَسُولِ
u'وَجْهٌ رَفْضٌ':Added, #1: 1	وَجْهِ الرَّغْبَةِ
u'وَجْهٌ رَفْعٌ':Added, #4: 4	وَجْهِ الرَّفْضِ
u'وَجْهٌ رِفْقٌ':Added, #1: 1	وَجْهِ الرَّفْعِ
u'وَجْهٌ رَقيقٌ':Added, #1: 1	وَجْهِ الرِّفْقِ
u'وَجْهٌ رَقيق':Added, #1: 1	وَجْهِ الرَّقِيقِ
u'وَجْهٌ رَهْنٌ':Added, #1: 1	وَجْهِ الرَّقِيقِ
u'وَجْهٌ رَهْنٌ':Added, #1: 1	وَجْهَ الرَّهْنِ
u'وَجْهٌ رِوايَةٌ':Added, #3: 3	وَجْهِ الرَّهْنِ
u'وَجْهٌ رِوايَةٌ':Added, #10: 10	وَجْهُ الرِّوَايَةِ
u'وَجْهٌ رِوايَةٌ':Added, #1: 1	وَجْهَ الرِّوَايَةِ
u'وَجْهٌ رِوايَةٌ':Added, #1: 1	وَجْهِ الرِّوَايَةِ
u'وَجْهٌ رِوايَةٌ':Added, #1: 1	وَجْهُ رِوَايَةٍ
u'وَجْهٌ زَجْرٌ':Added, #32: 32	وَجْهُ رِوَايَةِ
u'وَجْهٌ زَمَنٌ':Added, #1: 1	وَجْهِ الزَّجْرِ
u'وَجْهٌ زَوالٌ':Added, #1: 1	وَجْهِ الزَّمَنِ
u'وَجْهٌ زَوْجِيٌّ':Added, #1: 1	وَجْهِ الزَّوَالِ
u'وَجْهٌ زِيادَةٌ':Added, #1: 1	وَجْهِ الزَّوْجِيَّةِ
u'وَجْهٌ زِيادَةٌ':Added, #1: 1	وَجْهُ زِيَادَةٍ
u'وَجْهٌ زَيْدٌ':Added, #3: 3	وَجْهِ الزِّيَادَةِ
u'وَجْهٌ سَالِمٌ':Added, #1: 1	وَجْهَ زَيْدٍ
u'وَجْهٌ سَائِغٌ':Added, #1: 1	وَجْهٍ سَالِمٍ
u'وَجَّهَ سائِل':Subject, #5: 5	وَجْهٍ سَائِغٍ
u'وَجَّهَ سَائِلٌ':Subject, #1: 1	وَجَّهَ السَّائِلُ
u'وَجْهٌ سَبٌّ':Added, #1: 1	وَجَّهَ السَّائِلُ
u'وَجْهٌ سَبَقٌ':Added, #2: 2	وَجْهِ السَّبِّ
u'وَجْهٌ سَبْقٌ':Added, #1: 1	وَجْهِ السَّبَقِ
u'وَجْهٌ سِتٌّ':Added, #1: 1	وَجْهِ السَّبْقِ
u'وَجْهٌ سَتْرٌ':Added, #1: 1	وَجْهُ السِّتَّةِ
u'وَجْهٌ سَحَرٌ':Added, #1: 1	وَجْهِ السَّتْرِ
u'وَجْهٌ سُرْعَةٌ':Added, #2: 2	وَجْهِ السّحَرِ
u'وَجْهٌ سَرقَةٌ':Added, #1: 1	وَجْهِ السُّرْعَةِ
u'وَجْهٌ سَرِقَةٌ':Added, #2: 2	وَجْهِ السَّرِقَةِ
u'وَجْهٌ سَعْدٌ':Added, #2: 2	وَجْهِ السَّرِقَةِ
u'وَجْهٌ سُقُوطٌ':Added, #1: 1	وَجْهِ سَعْدِ
u'وَجْهٌ سُقُوطٌ':Added, #1: 1	وَجْهَ سُقُوطِ
u'وَجْهٌ سُقُوطٌ':Added, #1: 1	وَجْهِ سُقُوطِ
u'وَجْهٌ سَلَسٌ':Added, #1: 1	وَجْهِ سُقُوطِهِ
u'وَجْهٌ سَلَفٌ':Added, #6: 6	وَجْهِ السَّلَسِ
u'وَجْهٌ سَلَمٌ':Added, #4: 4	وَجْهِ السَّلَفِ
u'وَجْهٌ سُنَّةٌ':Added, #2: 2	وَجْهِ السَّلَمِ
u'وَجْهٌ سُنَّةٌ':Added, #1: 1	وَجْهِ سُنَّةِ
u'وَجْهٌ سُنَّةٌ':Added, #22: 22	وَجْهِ السُّنَّةِ
u'وَجْهٌ سُنِّيٌّ':Added, #2: 2	وَجْهُ السُّنَّةِ
u'وَجْهٌ سَهْوٌ':Added, #5: 5	وَجْهِ السُّنِّيَّةِ
u'وَجْهٌ سَهْوٌ':Added, #1: 1	وَجْهَ السَّهْوِ
u'وَجْهٌ سَهْوٌ':Added, #1: 1	وَجْهُ سَهْوٍ
u'وَجْهٌ سُهولَةٌ':Added, #4: 4	وَجْهِ السَّهْوِ
u'وَجْهٌ سِياسَةٌ':Added, #1: 1	وَجْهِ السُّهُولَةِ
u'وَجْهٌ سَيِّدٌ':Added, #1: 1	وَجْهِ السِّيَاسَةِ
u'وَجْهٌ شَابٌّ':Added, #1: 1	وَجْهِ سَيِّدَتِهِ
u'وَجْهٌ شَاذَّ':Added, #4: 4	وَجْهِ الشَّابَّةِ
u'وَجْهٌ شَاذّ':Added, #2: 2	وَجْهٍ شَاذٍّ
u'وَجْهٌ شافِعِيّ':Added, #2: 2	وَجْهٍ شَاذٍّ
u'وَجْهٌ شَأْنٌ':Added, #1: 1	وَجْهِ الشَّافِعِيِّ
u'وَجْهٌ شَاهِدٌ':Added, #3: 3	وَجْهُ الشَّأْنِ
u'وَجْهٌ شَبَهٌ':Added, #1: 1	وَجْهِ شَاهِدِ
u'وَجْهٌ شَبَهٌ':Added, #2: 2	وَجْهُ الشَّبَهِ
u'وَجْهٌ شَبَهٌ':Added, #2: 2	وَجْهِ الشَّبَهِ
u'وَجْهٌ شُبْهَةٌ':Added, #3: 3	وَجْهَ الشَّبَهِ
u'وَجْهٌ شُبْهَةٌ':Added, #2: 2	وَجْهُ شُبْهَةٍ
u'وَجْهٌ شُبْهَةٌ':Added, #4: 4	وَجْهِ شُبْهَةٍ
u'وَجْهٌ شَتْمٌ':Added, #5: 5	وَجْهِ الشُّبْهَةِ
u'وَجْهٌ شِدَّةٌ':Added, #1: 1	وَجْهِ الشَّتْمِ
u'وَجْهٌ شِرَاءٌ':Added, #1: 1	وَجْهِ الشِّدَّةِ
u'وَجْهٌ شَرَابٌ':Added, #2: 2	وَجْهِ الشِّرَاءِ
u'وَجْهٌ شَرْطٌ':Added, #1: 1	وَجْهِ الشّرَابِ
u'وَجْهٌ شَرْعٌ':Added, #11: 11	وَجْهِ الشَّرْطِ
u'وَجْهٌ شَرْعِيٌّ':Added, #3: 3	وَجْهِ الشَّرْعِ
u'وَجْهٌ شركة':Added, #4: 4	وَجْهٍ شَرْعِيٍّ
u'وَجْهٌ شِرْكَةٌ':Added, #1: 1	وَجْهِ الشِّرْكَةِ
u'وَجْهٌ شركة':Added, #1: 1	وَجْهِ الشِّرْكَةِ
u'وَجْهٌ شَرِكَةٌ':Added, #2: 2	وَجْهِ الشَّرِكَةِ
u'وَجْهٌ شِقٌّ':Added, #2: 2	وَجْهِ الشَّرِكَةِ
u'وَجْهٌ شَكٌّ':Added, #1: 1	وَجْهُ الشِّقِّ
u'وَجْهٌ شِكايَة':Added, #1: 1	وَجْهِ الشَّكِّ
u'وَجْهٌ شكر':Added, #1: 1	وَجْهِ الشِّكَايَةِ
u'وَجْهٌ شُكْرٌ':Added, #2: 2	وَجْهِ الشُّكْرِ
u'وَجْهٌ شمس':Added, #2: 2	وَجْهِ الشُّكْرِ
u'وَجْهٌ شمس':Added, #1: 1	وَجْهَ الشَّمْسِ
u'وَجْهٌ شَمْسٌ':Added, #1: 1	وَجْهِ الشَّمْسِ
u'وَجْهٌ شَمْسٌ':Added, #1: 1	وَجْهَ الشَّمْسِ
u'وَجْهٌ شَهَادَةٌ':Added, #1: 1	وَجْهِ الشَّمْسِ
u'وَجْهٌ شَهَادَةٌ':Added, #1: 1	وَجْهُ الشَّهَادَةِ
u'وَجْهٌ شهرة':Added, #1: 1	وَجْهِ الشَّهَادَةِ
u'وَجْهٌ شُهْرَةٌ':Added, #1: 1	وَجْهُ شُهْرَةِ
u'وَجْهٌ شَهْوَةٌ':Added, #1: 1	وَجْهُ شُهْرَةِ
u'وَجْهٌ شَيْطَانٌ':Added, #10: 10	وَجْهِ الشَّهْوَةِ
u'وَجْهٌ صَاحِبٌ':Added, #1: 1	وَجْهَ الشَّيْطَانِ
u'وَجْهٌ صَاحِبٌ':Added, #1: 1	وَجْهِ صَاحِبٍ
u'وَجْهٌ صباح':Added, #1: 1	وَجْهِ صَاحِبِهِ
u'وَجْهٌ صَبَاحٌ':Added, #1: 1	وَجْهُ الصَّبَاحِ
u'وَجْهٌ صُبْحٌ':Added, #1: 1	وَجْهُ الصَّبَاحِ
u'وَجْهٌ صبرة':Added, #6: 6	وَجْهِ الصُّبْحِ
u'وَجْهٌ صُبْرَةٌ':Added, #8: 8	وَجْهِ الصُّبْرَةِ
u'وَجْهٌ صِحَّةٌ':Added, #8: 8	وَجْهِ الصُّبْرَةِ
u'وَجْهٌ صِحَّةٌ':Added, #19: 19	وَجْهِ الصِّحَّةِ
u'وَجْهٌ صِحَّةٌ':Added, #1: 1	وَجْهَ الصِّحَّةِ
u'وَجْهٌ صِحَّةٌ':Added, #1: 1	وَجْهَ صِحَّةِ
u'وَجْهٌ صِحَّةٌ':Added, #1: 1	وَجْهُ صِحَّةٍ
u'وَجْهٌ صِحَّةٌ':Added, #3: 3	وَجْهُ الصِّحَّةِ
u'وَجْهٌ صَحِيحٌ':Added, #5: 5	وَجْهُ صِحَّةِ
u'وَجْهٌ صدق':Added, #6: 6	وَجْهُ الصَّحِيحِ
u'وَجْهٌ صِدْقٌ':Added, #1: 1	وَجْهُ الصِّدْقِ
u'وَجْهٌ صدقة':Added, #1: 1	وَجْهُ الصِّدْقِ
u'وَجْهٌ صَدَقَةٌ':Added, #1: 1	وَجْهِ صَدَقَةٍ
u'وَجْهٌ صدقة':Added, #1: 1	وَجْهِ صَدَقَةٍ
u'وَجْهٌ صَدَقَةٌ':Added, #8: 8	وَجْهِ الصَّدَقَةِ
u'وَجْهٌ صَرْفٌ':Added, #8: 8	وَجْهِ الصَّدَقَةِ
u'وَجْهٌ صَرْف':Added, #2: 2	وَجْهَ الصَّرْفِ
u'وَجْهٌ صَرِيحٌ':Added, #2: 2	وَجْهَ الصَّرْفِ
u'وَجْهٌ صِفَةٌ':Added, #2: 2	وَجْهُ صَرِيحِ
u'وَجَّهَ صَفْقَةٌ':Predicate, #1: 1	وَجْهِ الصِّفَةِ
u'وَجْهٌ صَفْقَةٌ':Added, #2: 2	وَجَّهَ الصَّفْقَةَ
u'وَجْهٌ صَفْقَةٌ':Added, #10: 10	وَجْهَ الصَّفْقَةِ
u'وَجْهٌ صَلاَحٌ':Added, #5: 5	وَجْهُ الصَّفْقَةِ
u'وَجْهٌ صِلَةٌ':Added, #1: 1	وَجْهِ الصَّلَاحِ
u'وَجْهٌ صِلَةٌ':Added, #1: 1	وَجْهَ الصِّلَةِ
u'وَجْهٌ صلح':Added, #5: 5	وَجْهِ الصِّلَةِ
u'وَجْهٌ صُلْحٌ':Added, #3: 3	وَجْهِ الصُّلْحِ
u'وَجْهٌ صَوَابٌ':Added, #3: 3	وَجْهِ الصُّلْحِ
u'وَجْهٌ صَوَابٌ':Added, #1: 1	وَجْهِ صَوَابِهِ
u'وَجْهٌ صَوَابٌ':Added, #3: 3	وَجْهُ الصَّوَابِ
u'وَجْهٌ صَوَابٌ':Added, #3: 3	وَجْهِ الصَّوَابِ
u'وَجْهٌ صُورَةٌ':Added, #4: 4	وَجْهَ الصَّوَابِ
u'وَجْهٌ ضَرَرٌ':Added, #1: 1	وَجْهَ الصُّورَةِ
u'وَجْهٌ ضَعِيفٌ':Added, #1: 1	وَجْهِ الضَّرَرِ
u'وَجْهٌ ضَمٌّ':Added, #1: 1	وَجْهُ الضَّعِيفِ
u'وَجْهٌ ضَمٌّ':Added, #1: 1	وَجْهَ الضَّمِّ
u'وَجْهٌ ضَمٌّ':Added, #2: 2	وَجْهِ الضَّمِّ
u'وَجْهٌ ضَمَانٌ':Added, #6: 6	وَجْهُ الضَّمِّ
u'وَجْهٌ ضَمَانٌ':Added, #1: 1	وَجْهُ ضَمَانِهِ
u'وَجْهٌ ضِيَافَةٌ':Added, #8: 8	وَجْهِ الضَّمَانِ
u'وَجْهٌ طَبِيبٌ':Added, #1: 1	وَجْهِ الضِّيَافَةِ
u'وَجْهٌ طَعْنٌ':Added, #1: 1	وَجْهَ الطَّبِيبِ
u'وَجْهٌ طَعْنٌ':Added, #1: 1	وَجْهَ الطَّعْنِ
u'وَجْهٌ طلب':Added, #1: 1	وَجْهُ الطَّعْنِ
u'وَجْهٌ طَلَبٌ':Added, #1: 1	وَجْهِ الطَّلَبِ
u'وَجْهٌ طلب':Added, #1: 1	وَجْهِ الطَّلَبِ
u'وَجْهٌ طَلَبٌ':Added, #1: 1	وَجْهِ طَلَبِ
u'وَجْهٌ طلب':Added, #1: 1	وَجْهِ طَلَبِ
u'وَجْهٌ طَلَبٌ':Added, #1: 1	وَجْهُ طَلَبِهِ
u'وَجَّهَ طِيبٌ':Predicate, #1: 1	وَجْهُ طَلَبِهِ
u'وَجْهٌ طِيَرَةٌ':Added, #1: 1	وَجَّهَ الطِّيبَ
u'وَجْهٌ ظاهِرٌ':Added, #1: 1	وَجْهِ الطِّيَرَةِ
u'وَجْهٌ ظاهِرٌ':Added, #2: 2	وَجْهِ الظَّاهِرِ
u'وَجْهٌ ظاهِرٌ':Added, #43: 43	وَجْهُ الظَّاهِرِ
u'وَجْهٌ ظاهِرٌ':Added, #4: 4	وَجْهَ ظَاهِرِ
u'وَجْهٌ ظُلْمٌ':Added, #66: 66	وَجْهُ ظَاهِرِ
u'وَجْهٌ ظَنٌّ':Added, #2: 2	وَجْهِ الظُّلْمِ
u'وَجْهٌ ظُهورٌ':Added, #1: 1	وَجْهِ الظَّنِّ
u'وَجْهٌ عَادَةٌ':Added, #1: 1	وَجْهُ ظُهُورِ
u'وَجْهٌ عارِيَّةٌ':Added, #4: 4	وَجْهِ الْعَادَةِ
u'وَجْهٌ عَامٌّ':Added, #7: 7	وَجْهِ الْعَارِيَّةِ
u'وَجْهٌ عِبَادَةٌ':Added, #1: 1	وَجْهُ الْعَامَّةِ
u'وَجْهٌ عَبْدٌ':Added, #4: 4	وَجْهِ الْعِبَادَةِ
u'وَجْهٌ عُبُورٌ':Added, #1: 1	وَجْهِ عَبْدِهِ
u'وَجَّهَ عتق':Predicate, #3: 3	وَجْهِ الْعُبُورِ
u'وَجَّهَ عِتْقٌ':Predicate, #2: 2	وَجَّهَ الْعِتْقَ
u'وَجْهٌ عتق':Added, #2: 2	وَجَّهَ الْعِتْقَ
u'وَجْهٌ عِتْقٌ':Added, #1: 1	وَجْهُ عِتْقِ
u'وَجْهٌ عَجَبٌ':Added, #1: 1	وَجْهُ عِتْقِ
u'وَجْهٌ عجز':Added, #1: 1	وَجْهُ الْعَجَبِ
u'وَجْهٌ عَجْزٌ':Added, #1: 1	وَجْهَ الْعَجْزِ
u'وَجْهٌ عَدٌّ':Added, #1: 1	وَجْهَ الْعَجْزِ
u'وَجْهٌ عَدَاوَةٌ':Added, #1: 1	وَجْهُ عَدِّ
u'وَجْهٌ عِدَّةٌ':Added, #1: 1	وَجْهِ الْعَدَاوَةِ
u'وَجْهٌ عِدَّةٌ':Added, #1: 1	وَجْهِ الْعِدَّةِ
u'وَجْهٌ عَدْلٌ':Added, #2: 2	وَجْهُ الْعِدَّةِ
u'وَجَّهَ عَدَمٌ':Predicate, #1: 1	وَجْهِ الْعَدْلِ
u'وَجْهٌ عَدَمٌ':Added, #2: 2	وَجَّهَ عَدَمَ
u'وَجْهٌ عَدَمٌ':Added, #4: 4	وَجْهَ عَدَمِ
u'وَجْهٌ عَدَمٌ':Added, #5: 5	وَجْهِ عَدَمِ
u'وَجْهٌ عَدُوٌّ':Added, #9: 9	وَجْهُ عَدَمِ
u'وَجْهٌ عَدُوٌّ':Added, #1: 1	وَجْهِ عَدُوٍّ
u'وَجْهٌ عُدْوَانٌ':Added, #22: 22	وَجْهِ الْعَدُوِّ
u'وَجْهٌ عُدُولٌ':Added, #2: 2	وَجْهِ الْعُدْوَانِ
u'وَجْهٌ عُدُولٌ':Added, #1: 1	وَجْهُ الْعُدُولِ
u'وَجْهٌ عَذَابٌ':Added, #2: 2	وَجْهِ الْعُدُولِ
u'وَجْهٌ عَذْرَاءُ':Added, #1: 1	وَجْهِ الْعَذَابِ
u'وَجْهٌ عَرَبٌ':Added, #1: 1	وَجْهَ الْعَذْرَاءِ
u'وَجْهٌ عَرُوسٌ':Added, #2: 2	وَجْهَ الْعَرَبِ
u'وَجْهٌ عَصَبِيٌّ':Added, #1: 1	وَجْهِ الْعَرُوسِ
u'وَجْهٌ عَصَبِيَّةٌ':Added, #1: 1	وَجْهِ الْعَصَبِيَّةِ
u'وَجْهٌ عطف':Added, #1: 1	وَجْهِ الْعَصَبِيَّةِ
u'وَجْهٌ عَطْفٌ':Added, #1: 1	وَجْهِ الْعَطْفِ
u'وَجْهٌ عَطِيَّةٌ':Added, #1: 1	وَجْهِ الْعَطْفِ
u'وَجَّهَ عَقْدٌ':Predicate, #1: 1	وَجْهِ الْعَطِيَّةِ
u'وَجْهٌ عَقْدٌ':Added, #1: 1	وَجَّهَ الْعَقْدَ
u'وَجْهٌ عَقْلٌ':Added, #2: 2	وَجْهِ الْعَقْدِ
u'وَجْهٌ عُقُوبَةٌ':Added, #1: 1	وَجْهِ الْعَقْلِ
u'وَجْهٌ عُقُوبَةٌ':Added, #1: 1	وَجْهِ الْعُقُوبَاتِ
u'وَجْهٌ عَلاَنِيَةٌ':Added, #4: 4	وَجْهِ الْعُقُوبَةِ
u'وَجْهٌ عِلَّةٌ':Added, #2: 2	وَجْهِ الْعَلَانِيَةِ
u'وَجْهٌ عِمَارَةٌ':Added, #1: 1	وَجْهُ الْعِلَّةِ
u'وَجْهٌ عَمْدٌ':Added, #2: 2	وَجْهِ عِمَارَةِ
u'وَجْهٌ عَمَلٌ':Added, #8: 8	وَجْهِ الْعَمْدِ
u'وَجْهٌ عُمُومٌ':Added, #3: 3	وَجْهُ الْعَمَلِ
u'وَجْهٌ عِوَضٌ':Added, #8: 8	وَجْهِ الْعُمُومِ
u'وَجْهٌ عَوْل':Added, #1: 1	وَجْهِ الْعِوَضِ
u'وَجْهٌ عَيْبٌ':Added, #1: 1	وَجْهِ الْعَوْلِ
u'وَجْهٌ عِيرٌ':Added, #2: 2	وَجْهِ الْعَيْبِ
u'وَجْهٌ غَارٌ':Added, #1: 1	وَجْهَ عِيرِهِ
u'وَجْهٌ غَبْرَاء':Added, #2: 2	وَجْهِ الْغَارِ
u'وَجَّهَ غُرْمٌ':Predicate, #1: 1	وَجْهَ الْغَبْرَاءِ
u'وَجْهٌ غُسْلٌ':Added, #1: 1	وَجَّهَ الْغُرْمَ
u'وَجْهٌ غَصْبٌ':Added, #1: 1	وَجْهِ غُسْلِ
u'وَجْهٌ غضب':Added, #2: 2	وَجْهِ الْغَصْبِ
u'وَجْهٌ غَضَبٌ':Added, #2: 2	وَجْهِ الْغَضَبِ
u'وَجْهٌ غَلَبَةٌ':Added, #2: 2	وَجْهِ الْغَضَبِ
u'وَجْهٌ غَلَطٌ':Added, #4: 4	وَجْهِ الْغَلَبَةِ
u'وَجْهٌ غَلَطٌ':Added, #1: 1	وَجْهَ الْغَلَطِ
u'وَجْهٌ غَنِيٌّ':Added, #1: 1	وَجْهِ الْغَلَطِ
u'وَجْهٌ غير':Added, #2: 2	وَجْهُ الْغَنِيِّ
u'وَجْهٌ غير':Added, #1: 1	وَجْهُ غَيْرِ
u'وَجْهٌ غَيْرٌ':Added, #1: 1	وَجْهِ غَيْرِ
u'وَجْهٌ غَيْرٌ':Added, #1: 1	وَجْهُ غَيْرِ
u'وَجْهٌ غير':Added, #1: 1	وَجْهِ غَيْرِ
u'وَجْهٌ غير':Added, #2: 2	وَجْهَ غَيْرِهِ
u'وَجْهٌ غَيْرٌ':Added, #2: 2	وَجْهِ غَيْرِهِ
u'وَجْهٌ غَيْرٌ':Added, #2: 2	وَجْهَ غَيْرِهِ
u'وَجْهٌ غَيْرَةٌ':Added, #2: 2	وَجْهِ غَيْرِهِ
u'وَجْهٌ فَاسِدٌ':Added, #1: 1	وَجْهِ الْغَيْرَةِ
u'وَجْهٌ فَائِدَةٌ':Added, #1: 1	وَجْهٍ فَاسِدٍ
u'وَجْهٌ فرار':Added, #1: 1	وَجْهُ الْفَائِدَةِ
u'وَجْهٌ فِرَارٌ':Added, #1: 1	وَجْهِ الْفِرَارِ
u'وَجْهٌ فَرَسٌ':Added, #1: 1	وَجْهِ الْفِرَارِ
u'وَجْهٌ فَرْضٌ':Added, #2: 2	وَجْهَ فَرَسِهِ
u'وَجْهٌ فرق':Added, #3: 3	وَجْهِ الْفَرْضِ
u'وَجْهٌ فَرْقٌ':Added, #10: 10	وَجْهُ الْفَرْقِ
u'وَجْهٌ فرق':Added, #10: 10	وَجْهُ الْفَرْقِ
u'وَجْهٌ فَرْقٌ':Added, #15: 15	وَجْهَ الْفَرْقِ
u'وَجْهٌ فرق':Added, #15: 15	وَجْهَ الْفَرْقِ
u'وَجْهٌ فَرْقٌ':Added, #9: 9	وَجْهِ الْفَرْقِ
u'وَجْهٌ فساد':Added, #9: 9	وَجْهِ الْفَرْقِ
u'وَجْهٌ فَسَادٌ':Added, #1: 1	وَجْهَ الْفَسَادِ
u'وَجْهٌ فساد':Added, #1: 1	وَجْهَ الْفَسَادِ
u'وَجْهٌ فَسَادٌ':Added, #1: 1	وَجْهَ فَسَادِ
u'وَجْهٌ فساد':Added, #1: 1	وَجْهَ فَسَادِ
u'وَجْهٌ فَسَادٌ':Added, #1: 1	وَجْهَ فَسَادِهِ
u'وَجْهٌ فساد':Added, #1: 1	وَجْهَ فَسَادِهِ
u'وَجْهٌ فَسَادٌ':Added, #2: 2	وَجْهِ الْفَسَادِ
u'وَجْهٌ فساد':Added, #2: 2	وَجْهِ الْفَسَادِ
u'وَجْهٌ فَسَادٌ':Added, #3: 3	وَجْهُ فَسَادِهِ
u'وَجْهٌ فساد':Added, #3: 3	وَجْهُ فَسَادِهِ
u'وَجْهٌ فَسَادٌ':Added, #5: 5	وَجْهُ الْفَسَادِ
u'وَجْهٌ فَسْخٌ':Added, #5: 5	وَجْهُ الْفَسَادِ
u'وَجْهٌ فَسْخٌ':Added, #1: 1	وَجْهُ فَسْخِ
u'وَجْهٌ فَسْخٌ':Added, #1: 1	وَجْهَ فَسْخِهِ
u'وَجْهٌ فَصْلٌ':Added, #4: 4	وَجْهِ الْفَسْخِ
u'وَجْهٌ فَصْلٌ':Added, #1: 1	وَجْهُ فَصْلِ
u'وَجْهٌ فَضْلٌ':Added, #2: 2	وَجْهُ الْفَصْلِ
u'وَجْهٌ فَضْلٌ':Added, #1: 1	وَجْهَ الْفَضْلِ
u'وَجْهٌ فَضْلٌ':Added, #1: 1	وَجْهُ الْفَضْلِ
u'وَجْهٌ فِعْلٌ':Added, #3: 3	وَجْهِ الْفَضْلِ
u'وَجْهٌ فِقْهٌ':Added, #1: 1	وَجْهِ فِعْلِهِ
u'وَجَّهَ فلان':Predicate, #1: 1	وَجْهُ الْفِقْهِ
u'وَجْهٌ فلان':Added, #1: 1	وَجَّهَ عُثْمَانَ
u'وَجْهٌ فَهْمٌ':Added, #1: 1	وَجْهِ الشَّافِعِيِّ
u'وَجْهٌ قَائِلٌ':Added, #1: 1	وَجْهُ فَهْمِ
u'وَجْهٌ قَائِلٌ':Added, #1: 1	وَجْهُ الْقَائِلِ
u'وَجْهٌ قَائِلٌ':Added, #1: 1	وَجْهٍ قَائِلٍ
u'وَجْهٌ قَائِمٌ':Added, #1: 1	وَجْهُ قَائِلٍ
u'وَجْهٌ قِبْلَةٌ':Added, #1: 1	وَجْهُ الْقَائِمِ
u'وَجْهٌ قَبُولٌ':Added, #2: 2	وَجْهِ الْقِبْلَةِ
u'وَجْهٌ قَبُولٌ':Added, #1: 1	وَجْهَ الْقَبُولِ
u'وَجْهٌ قَدَحٌ':Added, #2: 2	وَجْهُ الْقَبُولِ
u'وَجْهٌ قدم':Added, #1: 1	وَجْهَ الْقَدَحِ
u'وَجْهٌ قَدَمٌ':Added, #1: 1	وَجْهِ الْقَدَمِ
u'وَجْهٌ قذف':Added, #1: 1	وَجْهِ الْقَدَمِ
u'وَجْهٌ قَذْفٌ':Added, #1: 1	وَجْهِ الْقَذْفِ
u'وَجْهٌ قِرَاءةٌ':Added, #1: 1	وَجْهِ الْقَذْفِ
u'وَجْهٌ قِرَاءةٌ':Added, #1: 1	وَجْهِ الْقِرَاءَةِ
u'وَجْهٌ قرار':Added, #4: 4	وَجْهِ قِرَاءَةِ
u'وَجْهٌ قَرَارٌ':Added, #4: 4	وَجْهِ الْقَرَارِ
u'وَجْهٌ قُرْبَةٌ':Added, #4: 4	وَجْهِ الْقَرَارِ
u'وَجْهٌ قُرْبَةٌ':Added, #14: 14	وَجْهِ الْقُرْبَةِ
u'وَجْهٌ قُرْبَةٌ':Added, #1: 1	وَجْهُ الْقُرْبَةِ
u'وَجْهٌ قَرْضٌ':Added, #3: 3	وَجْهَ الْقُرْبَةِ
u'وَجْهٌ قَسْمٌ':Added, #4: 4	وَجْهِ الْقَرْضِ
u'وَجْهٌ قسمة':Added, #1: 1	وَجْهِ الْقَسْمِ
u'وَجْهٌ قِسْمَةٌ':Added, #1: 1	وَجْهُ الْقِسْمَةِ
u'وَجْهٌ قَصْدٌ':Added, #1: 1	وَجْهُ الْقِسْمَةِ
u'وَجْهٌ قَصْدٌ':Added, #1: 1	وَجْهَ الْقَصْدِ
u'وَجْهٌ قَصْدٌ':Added, #1: 1	وَجْهِ قَصْدِهِ
u'وَجْهٌ قَضَاءٌ':Added, #2: 2	وَجْهِ الْقَصْدِ
u'وَجْهٌ قَضَاءٌ':Added, #12: 12	وَجْهُ الْقَضَاءِ
u'وَجْهٌ قَضَاءٌ':Added, #17: 17	وَجْهِ الْقَضَاءِ
u'وَجْهٌ قَطْعٌ':Added, #2: 2	وَجْهَ الْقَضَاءِ
u'وَجْهٌ قَطْعٌ':Added, #1: 1	وَجْهَ الْقَطْعِ
u'وَجْهٌ قَطْعٌ':Added, #1: 1	وَجْهُ الْقَطْعِ
u'وَجْهٌ قِمَارٌ':Added, #2: 2	وَجْهِ الْقَطْعِ
u'وَجْهٌ قَهْرٌ':Added, #1: 1	وَجْهِ الْقِمَارِ
u'وَجْهٌ قُوَّةٌ':Added, #4: 4	وَجْهِ الْقَهْرِ
u'وَجْهٌ قُوَّة':Added, #1: 1	وَجْهُ قُوَّةِ
u'وَجَّهَ قول':Predicate, #1: 1	وَجْهُ قُوَّةِ
u'وَجَّهَ قَوْلٌ':Predicate, #1: 1	وَجَّهَ الْقَوْلَ
u'وَجْهٌ قول':Added, #1: 1	وَجَّهَ الْقَوْلَ
u'وَجْهٌ قَوْلٌ':Added, #120: 120	وَجْهُ قَوْلِ
u'وَجْهٌ قول':Added, #120: 120	وَجْهُ قَوْلِ
u'وَجْهٌ قَوْلٌ':Added, #18: 18	وَجْهُ الْقَوْلِ
u'وَجْهٌ قول':Added, #18: 18	وَجْهُ الْقَوْلِ
u'وَجْهٌ قَوْلٌ':Added, #1: 1	وَجْهَ الْقَوْلِ
u'وَجْهٌ قَوْلٌ':Added, #1: 1	وَجْهَ الْقَوْلِ
u'وَجْهٌ قول':Added, #1: 1	وَجْهُ الْقَوْلَيْنِ
u'وَجْهٌ قَوْلٌ':Added, #1: 1	وَجْهِ قَوْلِهِ
u'وَجْهٌ قول':Added, #1: 1	وَجْهِ قَوْلِهِ
u'وَجْهٌ قَوْلٌ':Added, #2: 2	وَجْهَ قَوْلِهِ
u'وَجْهٌ قول':Added, #2: 2	وَجْهَ قَوْلِهِ
u'وَجْهٌ قَوْلٌ':Added, #48: 48	وَجْهُ قَوْلِهِ
u'وَجْهٌ قول':Added, #48: 48	وَجْهُ قَوْلِهِ
u'وَجْهٌ قَوْلٌ':Added, #5: 5	وَجْهِ قَوْلِ
u'وَجْهٌ قَيْءٌ':Added, #5: 5	وَجْهِ قَوْلِ
u'وَجَّهَ قِيَاسٌ':Predicate, #2: 2	وَجْهِ الْقَيْءِ
u'وَجْهٌ قِيَاسٌ':Added, #1: 1	وَجَّهَ الْقِيَاسَ
u'وَجْهٌ قِيَاسٌ':Added, #10: 10	وَجْهَ الْقِيَاسِ
u'وَجْهٌ قِيَاسٌ':Added, #20: 20	وَجْهِ الْقِيَاسِ
u'وَجْهٌ قيام':Added, #43: 43	وَجْهُ الْقِيَاسِ
u'وَجْهٌ قِيَامٌ':Added, #1: 1	وَجْهِ قِيَامِهِ
u'وَجْهٌ قِيمَةٌ':Added, #1: 1	وَجْهِ قِيَامِهِ
u'وَجْهٌ كَافِرٌ':Added, #3: 3	وَجْهِ الْقِيمَةِ
u'وَجْهٌ كبر':Added, #1: 1	وَجْهَ الْكَافِرِ
u'وَجْهٌ كِبْرٌ':Added, #3: 3	وَجْهِ الْكِبْرِ
u'وَجْهٌ كِتَابَةٌ':Added, #3: 3	وَجْهِ الْكِبْرِ
u'وَجْهٌ كِتَابَةٌ':Added, #1: 1	وَجْهِ الْكِتَابَةِ
u'وَجْهٌ كِتَابَةٌ':Added, #1: 1	وَجْهُ كِتَابَتِهِ
u'وَجْهٌ كَثْرَةٌ':Added, #2: 2	وَجْهُ الْكِتَابَةِ
u'وَجْهٌ كذب':Added, #2: 2	وَجْهَ الْكَثْرَةِ
u'وَجْهٌ كَذِبٌ':Added, #2: 2	وَجْهُ الْكَذِبِ
u'وَجْهٌ كَرَاهَةٌ':Added, #2: 2	وَجْهُ الْكَذِبِ
u'وَجْهٌ كَرَاهَةٌ':Added, #1: 1	وَجْهُ الْكَرَاهَةِ
u'وَجْهٌ كَرَاهَةٌ':Added, #1: 1	وَجْهِ كَرَاهَةِ
u'وَجْهٌ كَرَاهِيَةٌ':Added, #7: 7	وَجْهِ الْكَرَاهَةِ
u'وَجْهٌ كَرَاهِيَةٌ':Added, #1: 1	وَجْهُ الْكَرَاهِيَةِ
u'وَجْهٌ كَرِيمٌ':Added, #2: 2	وَجْهِ الْكَرَاهِيَةِ
u'وَجْهٌ كَشْفٌ':Added, #2: 2	وَجْهُ الْكَرِيمِ
u'وَجْهٌ كعبة':Added, #1: 1	وَجْهِ الْكَشْفِ
u'وَجْهٌ كَعْبَةٌ':Added, #3: 3	وَجْهِ الْكَعْبَةِ
u'وَجْهٌ كِفَايَةٌ':Added, #3: 3	وَجْهِ الْكَعْبَةِ
u'وَجْهٌ كَلاَمٌ':Added, #1: 1	وَجْهِ الْكِفَايَةِ
u'وَجْهٌ كَلاَمٌ':Added, #1: 1	وَجْهَ كَلَامِ
u'وَجْهٌ كَلاَمٌ':Added, #1: 1	وَجْهُ كَلَامِ
u'وَجْهٌ كَلاَمٌ':Added, #1: 1	وَجْهِ كَلَامِ
u'وَجْهٌ كَلاَمٌ':Added, #1: 1	وَجْهُ كَلَامِهِ
u'وَجْهٌ كُلِّيٌّ':Added, #1: 1	وَجْهِ كَلَامِهِ
u'وَجْهٌ كَمَالٌ':Added, #5: 5	وَجْهٍ كُلِّيٍّ
u'وَجْهٌ كَمَالٌ':Added, #1: 1	وَجْهُ كَمَالِ
u'وَجْهٌ كَوْنٌ':Added, #22: 22	وَجْهِ الْكَمَالِ
u'وَجْهٌ كَوْنٌ':Added, #1: 1	وَجْهَ كَوْنِ
u'وَجْهٌ كَوْنٌ':Added, #1: 1	وَجْهِ كَوْنِهِ
u'وَجْهٌ كَوْنٌ':Added, #3: 3	وَجْهِ كَوْنِ
u'وَجْهٌ كَوْنٌ':Added, #4: 4	وَجْهَ كَوْنِهِ
u'وَجْهٌ كَوْنٌ':Added, #4: 4	وَجْهُ كَوْنِهِ
u'وَجْهٌ لَذَّةٌ':Added, #5: 5	وَجْهُ كَوْنِ
u'وَجْهٌ لُزُومٌ':Added, #1: 1	وَجْهِ اللَّذَّةِ
u'وَجْهٌ لُزُومٌ':Added, #1: 1	وَجْهُ لُزُومِ
u'وَجْهٌ لُزُومٌ':Added, #2: 2	وَجْهِ لُزُومِ
u'وَجْهٌ لعب':Added, #4: 4	وَجْهِ اللُّزُومِ
u'وَجْهٌ لَعِبٌ':Added, #5: 5	وَجْهِ اللَّعِبِ
u'وَجَّهَ مَاءٌ':Predicate, #5: 5	وَجْهِ اللَّعِبِ
u'وَجْهٌ مَاءٌ':Added, #1: 1	وَجَّهَ الْمَاءَ
u'وَجْهٌ مَاءٌ':Added, #12: 12	وَجْهِ الْمَاءِ
u'وَجْهٌ مَالِكٌ':Added, #2: 2	وَجْهُ الْمَاءِ
u'وَجْهٌ مَالِكٌ':Added, #1: 1	وَجْهِ الْمَالِكِ
u'وَجْهٌ مَانِعٌ':Added, #1: 1	وَجْهُ مَالِكٍ
u'وَجْهٌ مُبَاحٌ':Added, #1: 1	وَجْهُ الْمَانِعِ
u'وَجْهٌ مُبَادَلَةٌ':Added, #4: 4	وَجْهٍ مُبَاحٍ
u'وَجْهٌ مُبَالَغَةٌ':Added, #3: 3	وَجْهِ الْمُبَادَلَةِ
u'وَجْهٌ مُبَايَعَةٌ':Added, #7: 7	وَجْهِ الْمُبَالَغَةِ
u'وَجْهٌ مَبَرَّةٌ':Added, #1: 1	وَجْهِ الْمُبَايَعَةِ
u'وَجْهٌ مُبْطِلٌ':Added, #2: 2	وَجْهِ الْمَبَرَّةِ
u'وَجْهٌ مَتَاعٌ':Added, #1: 1	وَجْهِ الْمُبْطِلِ
u'وَجْهٌ مُتْعَةٌ':Added, #1: 1	وَجْهَ الْمَتَاعِ
u'وَجْهٌ مُتَّفَقٌ':Added, #1: 1	وَجْهِ الْمُتْعَةِ
u'وَجْهٌ مَجَازٌ':Added, #1: 1	وَجْهٍ مُتَّفَقٍ
u'وَجْهٌ مُجَاهَرَةٌ':Added, #2: 2	وَجْهِ الْمَجَازِ
u'وَجْهٌ مُجَرَّدٌ':Added, #1: 1	وَجْهِ الْمُجَاهَرَةِ
u'وَجْهٌ مُجْمَعٌ':Added, #1: 1	وَجْهِ مُجَرَّدِ
u'وَجْهٌ مَجِيءٌ':Added, #1: 1	وَجْهٍ مُجْمَعٍ
u'وَجْهٌ مُحَاشَاةٌ':Added, #1: 1	وَجْهِ مَجِيءِ
u'وَجْهٌ مُحْتَاجٌ':Added, #1: 1	وَجْهِ الْمُحَاشَاةِ
u'وَجْهٌ مُحْتَالٌ':Added, #1: 1	وَجْهٍ مُحْتَاجٍ
u'وَجْهٌ مَحْدُودٌ':Added, #1: 1	وَجْهِ الْمُحْتَالِ
u'وَجْهٌ مُحَرَّمٌ':Added, #1: 1	وَجْهٍ مَحْدُودٍ
u'وَجْهٌ مُحْرِمٌ':Added, #10: 10	وَجْهٍ مُحَرَّمٍ
u'وَجْهٌ مَحْرَمٌ':Added, #1: 1	وَجْهِ مُحْرِمٍ
u'وَجْهٌ مَحْظُورٌ':Added, #1: 1	وَجْهِ مَحْرَمِهِ
u'وَجْهٌ مُحَمَّدٌ':Added, #5: 5	وَجْهٍ مَحْظُورٍ
u'وَجْهٌ مُحَمَّدٌ':Added, #1: 1	وَجْهُ مُحَمَّدٍ
u'وَجْهٌ مُحِيل':Added, #3: 3	وَجْهِ مُحَمَّدٍ
u'وَجْهٌ مُخَالِفٌ':Added, #3: 3	وَجْهِ الْمُحِيلِ
u'وَجْهٌ مُخَالَفَةٌ':Added, #1: 1	وَجْهٍ مُخَالِفٍ
u'وَجْهٌ مُخَالَفَةٌ':Added, #1: 1	وَجْهَ الْمُخَالَفَةِ
u'وَجْهٌ مُخَالَفَةٌ':Added, #1: 1	وَجْهُ الْمُخَالَفَةِ
u'وَجْهٌ مُخَالَفَةٌ':Added, #1: 1	وَجْهِ مُخَالَفَةِ
u'وَجْهٌ مُخْتَارٌ':Added, #3: 3	وَجْهِ الْمُخَالَفَةِ
u'وَجْهٌ مُخْتَارٌ':Added, #2: 2	وَجْهُ الْمُخْتَارِ
u'وَجْهٌ مُخْتَصَرٌ':Added, #2: 2	وَجْهِ الْمُخْتَارِ
u'وَجْهٌ مَخْصُوصٌ':Added, #1: 1	وَجْهٍ مُخْتَصَرٍ
u'وَجْهٌ مَخْطُوبٌ':Added, #21: 21	وَجْهٍ مَخْصُوصٍ
u'وَجْهٌ مُدَاوَاةٌ':Added, #1: 1	وَجْهِ الْمَخْطُوبَةِ
u'وَجْهٌ مَذْكُورٌ':Added, #1: 1	وَجْهِ الْمُدَاوَاةِ
u'وَجْهٌ مَذْكُورٌ':Added, #1: 1	وَجْهٍ مَذْكُورٍ
u'وَجْهٌ مَذْهَبٌ':Added, #3: 3	وَجْهُ الْمَذْكُورِ
u'وَجْهٌ مَرَضٌ':Added, #1: 1	وَجْهُ الْمَذْهَبِ
u'وَجْهٌ مَرِيضٌ':Added, #1: 1	وَجْهِ الْمَرَضِ
u'وَجْهٌ مِزَاحٌ':Added, #1: 1	وَجْهُ الْمَرِيضِ
u'وَجْهٌ مَسْأَلَةٌ':Added, #5: 5	وَجْهِ الْمِزَاحِ
u'وَجْهٌ مَسْأَلَةٌ':Added, #1: 1	وَجْهِ الْمَسْأَلَةِ
u'وَجْهٌ مُسامَحَة':Added, #3: 3	وَجْهُ الْمَسْأَلَةِ
u'وَجْهٌ مُسَاوَاةٌ':Added, #1: 1	وَجْهُ الْمُسَامَحَةِ
u'وَجْهٌ مُسَاوَمَةٌ':Added, #1: 1	وَجْهُ الْمُسَاوَاةِ
u'وَجْهٌ مُسْتَحْسَنٌ':Added, #2: 2	وَجْهِ الْمُسَاوَمَةِ
u'وَجْهٌ مُسْتَحِقٌّ':Added, #3: 3	وَجْهٍ مُسْتَحْسَنٍ
u'وَجْهٌ مُسْتَقْبِلٌ':Added, #1: 1	وَجْهِ الْمُسْتَحِقِّ
u'وَجْهٌ مُسْتَقِيمٌ':Added, #1: 1	وَجْهِ الْمُسْتَقْبِلِ
u'وَجْهٌ مُسْتَلْزَمٌ':Added, #1: 1	وَجْهٍ مُسْتَقِيمٍ
u'وَجْهٌ مُسْتَلْزِمٌ':Added, #1: 1	وَجْهٍ مُسْتَلْزَمٍ
u'وَجْهٌ مُسَخَّرٌ':Added, #2: 2	وَجْهٍ مُسْتَلْزِمٍ
u'وَجْهٌ مَسْنُونٌ':Added, #1: 1	وَجْهٍ مُسَخَّرٍ
u'وَجْهٌ مُشَابَهَةٌ':Added, #1: 1	وَجْهِ الْمَسْنُونِ
u'وَجْهٌ مُشَابَهَةٌ':Added, #1: 1	وَجْهَ الْمُشَابَهَةِ
u'وَجْهٌ مُشَاتَمَةٌ':Added, #1: 1	وَجْهُ الْمُشَابَهَةِ
u'وَجْهٌ مُشَاكَلَةٌ':Added, #3: 3	وَجْهِ الْمُشَاتَمَةِ
u'وَجْهٌ مَشْرُوعٌ':Added, #1: 1	وَجْهِ الْمُشَاكَلَةِ
u'وَجْهٌ مَشْهُودٌ':Added, #3: 3	وَجْهٍ مَشْرُوعٍ
u'وَجْهٌ مَشْهُورٌ':Added, #2: 2	وَجْهِ الْمَشْهُودِ
u'وَجْهٌ مَشْهُورٌ':Added, #1: 1	وَجْهَ الْمَشْهُورِ
u'وَجْهٌ مُصَحَّحٌ':Added, #1: 1	وَجْهُ الْمَشْهُورِ
u'وَجْهٌ مَصْلَحَةٌ':Added, #1: 1	وَجْهٍ مُصَحَّحٍ
u'وَجْهٌ مَصْلَحَةٌ':Added, #5: 5	وَجْهُ الْمَصْلَحَةِ
u'وَجَّهَ مُصَنِّفٌ':Subject, #6: 6	وَجْهِ الْمَصْلَحَةِ
u'وَجْهٌ مُصَنِّفٌ':Added, #1: 1	وَجَّهَ الْمُصَنِّفُ
u'وَجْهٌ مُضَارَبَةٌ':Added, #2: 2	وَجْهُ الْمُصَنِّفِ
u'وَجْهٌ مَضْبُوطٌ':Added, #2: 2	وَجْهِ الْمُضَارَبَةِ
u'وَجْهٌ مَضْمُونٌ':Added, #1: 1	وَجْهٍ مَضْبُوطٍ
u'وَجْهٌ مَطْلَبٌ':Added, #1: 1	وَجْهٍ مَضْمُونٍ
u'وَجْهٌ مَطْلُوب':Added, #1: 1	وَجْهُ مَطْلَبٍ
u'وَجْهٌ مُعاتَبَة':Added, #1: 1	وَجْهِ الْمَطْلُوبِيَّةِ
u'وَجْهٌ مَعَاشٌ':Added, #1: 1	وَجْهِ الْمُعَاتَبَةِ
u'وَجْهٌ مُعَامَلَةٌ':Added, #1: 1	وَجْهِ الْمَعَاشِ
u'وَجْهٌ مُعَامَلَةٌ':Added, #1: 1	وَجْهِ الْمُعَامَلَاتِ
u'وَجْهٌ مُعَاهَدَةٌ':Added, #1: 1	وَجْهُ الْمُعَامَلَةِ
u'وَجْهٌ مُعَاهَدَةٌ':Added, #1: 1	وَجْهَ الْمُعَاهَدَةِ
u'وَجْهٌ مُعْتَبَرٌ':Added, #2: 2	وَجْهِ الْمُعَاهَدَةِ
u'وَجْهٌ مُعْتَدٌّ':Added, #1: 1	وَجْهٍ مُعْتَبَرٍ
u'وَجْهٌ مَعْرُوفٌ':Added, #1: 1	وَجْهٍ مُعْتَدٍّ
u'وَجْهٌ مُعَيَّنٌ':Added, #15: 15	وَجْهِ الْمَعْرُوفِ
u'وَجْهٌ مُغَايَرَةٌ':Added, #2: 2	وَجْهٍ مُعَيَّنٍ
u'وَجْهٌ مُقَابِلٌ':Added, #1: 1	وَجْهِ الْمُغَايَرَةِ
u'وَجْهٌ مَقْذُوفٌ':Added, #1: 1	وَجْهِ مُقَابِلِهِ
u'وَجْهٌ مَكْرٌ':Added, #2: 2	وَجْهِ الْمَقْذُوفِ
u'وَجْهٌ مَكْرُوهٌ':Added, #2: 2	وَجْهِ الْمَكْرِ
u'وَجْهٌ مُلاَزَمَةٌ':Added, #2: 2	وَجْهٍ مَكْرُوهٍ
u'وَجْهٌ مُلاَطَفَةٌ':Added, #1: 1	وَجْهِ الْمُلَازَمَةِ
u'وَجْهٌ مَلَكٌ':Added, #2: 2	وَجْهِ الْمُلَاطَفَةِ
u'وَجْهٌ مِلْكٌ':Added, #1: 1	وَجْهُ مَلَكٍ
u'وَجْهٌ مُمَاثَلَةٌ':Added, #4: 4	وَجْهِ الْمِلْكِ
u'وَجْهٌ مَمَرٌّ':Added, #1: 1	وَجْهِ الْمُمَاثَلَةِ
u'وَجْهٌ مُمْكِنٌ':Added, #1: 1	وَجْهِ مَمَرِّ
u'وَجْهٌ مُمْكِن':Added, #3: 3	وَجْهٍ مُمْكِنٍ
u'وَجْهٌ مَمْلَكَةٌ':Added, #3: 3	وَجْهٍ مُمْكِنٍ
u'وَجْهٌ مُمَيِّزٌ':Added, #1: 1	وَجْهِ الْمَمْلَكَةِ
u'وَجْهٌ مَنٌّ':Added, #1: 1	وَجْهَ الْمُمَيِّزِ
u'وَجْهٌ مُنَاسَبَةٌ':Added, #1: 1	وَجْهَ الْمَنِّ
u'وَجْهٌ مُنَاسَبَةٌ':Added, #1: 1	وَجْهَ مُنَاسَبَةِ
u'وَجْهٌ مُنَاسَبَةٌ':Added, #1: 1	وَجْهُ مُنَاسَبَتِهِ
u'وَجْهٌ مُنَاسَبَةٌ':Added, #4: 4	وَجْهَ الْمُنَاسَبَةِ
u'وَجْهٌ مُنَاسَبَةٌ':Added, #4: 4	وَجْهُ الْمُنَاسَبَةِ
u'وَجْهٌ مُنَاسَبَةٌ':Added, #4: 4	وَجْهِ الْمُنَاسَبَةِ
u'وَجْهٌ مُنَاقَضَةٌ':Added, #9: 9	وَجْهُ مُنَاسَبَةِ
u'وَجْهٌ مُنْبَسِطٌ':Added, #1: 1	وَجْهِ الْمُنَاقَضَةِ
u'وَجْهٌ مَنْصُوصٌ':Added, #2: 2	وَجْهٍ مُنْبَسِطٍ
u'وَجَّهَ مَنْعٌ':Predicate, #1: 1	وَجْهِ الْمَنْصُوصِ
u'وَجْهٌ مَنْعٌ':Added, #1: 1	وَجَّهَ الْمَنْعَ
u'وَجْهٌ مَنْعٌ':Added, #11: 11	وَجْهُ الْمَنْعِ
u'وَجْهٌ مَنْعٌ':Added, #1: 1	وَجْهَ الْمَنْعِ
u'وَجْهٌ مَنْعٌ':Added, #2: 2	وَجْهِ الْمَنْعِ
u'وَجْهٌ مَنْعٌ':Added, #2: 2	وَجْهَ مَنْعِ
u'وَجْهٌ مَنْفَعَةٌ':Added, #4: 4	وَجْهُ مَنْعِ
u'وَجْهٌ مُنْقَطِعٌ':Added, #1: 1	وَجْهُ مَنْفَعَةٍ
u'وَجْهٌ مَنْقُولٌ':Added, #1: 1	وَجْهٍ مُنْقَطِعٍ
u'وَجْهٌ مُنْكَرٌ':Added, #1: 1	وَجْهُ الْمَنْقُولِ
u'وَجْهٌ مَنْهِيٌّ':Added, #1: 1	وَجْهُ مُنْكَرٍ
u'وَجْهٌ مُواعَدَة':Added, #6: 6	وَجْهٍ مَنْهِيٍّ
u'وَجْهٌ مُؤَمِّلٌ':Added, #2: 2	وَجْهِ الْمُوَاعَدَةِ
u'وَجْهٌ مُؤَمِّلٌ':Added, #1: 1	وَجْهَ مُؤَمِّلٍ
u'وَجْهٌ مُؤْمِنٌ':Added, #2: 2	وَجْهَ مُؤَمِّلِ
u'وَجْهٌ مِيرَاثٌ':Added, #3: 3	وَجْهَ الْمُؤْمِنِ
u'وَجْهٌ نَاسٌ':Added, #1: 1	وَجْهِ الْمِيرَاثِ
u'وَجْهٌ نَبِيٌّ':Added, #1: 1	وَجْهَ النَّاسِ
u'وَجْهٌ نَبِيٌّ':Added, #1: 1	وَجْهُ النَّبِيِّ
u'وَجْهٌ نَبِيٌّ':Added, #1: 1	وَجْهَ نَبِيّهِ
u'وَجْهٌ نجاة':Added, #1: 1	وَجْهَ نَبِيِّهِ
u'وَجْهٌ نَجَاةٌ':Added, #1: 1	وَجْهِ النَّجَاةِ
u'وَجْهٌ نَجَاسَةٌ':Added, #1: 1	وَجْهِ النَّجَاةِ
u'وَجْهٌ نَجَسٌ':Added, #2: 2	وَجْهَ النَّجَاسَةِ
u'وَجْهٌ نِدَاءٌ':Added, #1: 1	وَجْهَ النَّجَسِ
u'وَجْهٌ نَدْبٌ':Added, #2: 2	وَجْهِ النِّدَاءِ
u'وَجْهٌ نَدْبٌ':Added, #1: 1	وَجْهُ نَدْبِ
u'وَجْهٌ نذر':Added, #3: 3	وَجْهِ النَّدْبِ
u'وَجْهٌ نَذْرٌ':Added, #4: 4	وَجْهِ النَّذْرِ
u'وَجْهٌ نَسَبٌ':Added, #4: 4	وَجْهِ النَّذْرِ
u'وَجْهٌ نِسَبٌ':Added, #1: 1	وَجْهُ النّسَبِ
u'وَجْهٌ نِسْبَةٌ':Added, #1: 1	وَجْهُ النّسَبِ
u'وَجْهٌ نِسْيَانٌ':Added, #1: 1	وَجْهُ نِسْبَتِهِ
u'وَجْهٌ نُشُوزٌ':Added, #1: 1	وَجْهِ النِّسْيَانِ
u'وَجْهٌ نصح':Added, #1: 1	وَجْهِ النُّشُوزِ
u'وَجْهٌ نَصِيحٌ':Added, #1: 1	وَجْهِ النُّصْحِ
u'وَجْهٌ نَصِيحَةٌ':Added, #2: 2	وَجْهِ النَّصِيحَةِ
u'وَجْهٌ نَظَافَةٌ':Added, #2: 2	وَجْهِ النَّصِيحَةِ
u'وَجْهٌ نَظَرٌ':Added, #1: 1	وَجْهَ النَّظَافَةِ
u'وَجْهٌ نَظَرٌ':Added, #19: 19	وَجْهِ النَّظَرِ
u'وَجْهٌ نَظَرٌ':Added, #4: 4	وَجْهَ النَّظَرِ
u'وَجْهٌ نفر':Added, #4: 4	وَجْهُ النَّظَرِ
u'وَجْهٌ نَفْرٌ':Added, #1: 1	وَجْهِ نَفْرِهِ
u'وَجْهٌ نَفْسٌ':Added, #1: 1	وَجْهِ نَفْرِهِ
u'وَجْهٌ نَفَقَةٌ':Added, #1: 1	وَجْهِ نَفْسِهِ
u'وَجْهٌ نَفْيٌ':Added, #1: 1	وَجْهِ النَّفَقَةِ
u'وَجْهٌ نَفْيٌ':Added, #1: 1	وَجْهَ النَّفْيِ
u'وَجْهٌ نَقْصٌ':Added, #1: 1	وَجْهُ نَفْيِ
u'وَجْهٌ نُقْصَانٌ':Added, #1: 1	وَجْهِ النَّقْصِ
u'وَجْهٌ نَقْضٌ':Added, #2: 2	وَجْهِ النُّقْصَانِ
u'وَجْهٌ نَقْضٌ':Added, #1: 1	وَجْهَ النَّقْضِ
u'وَجْهٌ نكاح':Added, #1: 1	وَجْهُ النَّقْضِ
u'وَجْهٌ نِكَاحٌ':Added, #1: 1	وَجْهَ النِّكَاحِ
u'وَجْهٌ نكاح':Added, #1: 1	وَجْهَ النِّكَاحِ
u'وَجْهٌ نِكَاحٌ':Added, #6: 6	وَجْهِ النِّكَاحِ
u'وَجْهٌ نُكْتَةٌ':Added, #6: 6	وَجْهِ النِّكَاحِ
u'وَجْهٌ نَكِيرٌ':Added, #1: 1	وَجْهِ نُكْتَتِهِ
u'وَجْهٌ نَمَاءٌ':Added, #1: 1	وَجْهُ نَكِيرٍ
u'وَجْهٌ نهار':Added, #1: 1	وَجْهِ النَّمَاءِ
u'وَجْهٌ نَهَارٌ':Added, #1: 1	وَجْهَ النّهَارِ
u'وَجْهٌ نَهْيٌ':Added, #1: 1	وَجْهَ النّهَارِ
u'وَجْهٌ نَهْيٌ':Added, #1: 1	وَجْهُ النَّهْيِ
u'وَجْهٌ نِيَابَةٌ':Added, #3: 3	وَجْهِ النَّهْيِ
u'وَجْهٌ هِبَةٌ':Added, #2: 2	وَجْهِ النِّيَابَةِ
u'وَجْهٌ هَتْكٌ':Added, #5: 5	وَجْهِ الْهِبَةِ
u'وَجْهٌ هَدْيٌ':Added, #1: 1	وَجْهِ الْهَتْكِ
u'وَجْهٌ هَدِيٌّ':Added, #1: 1	وَجْهَ الْهَدْيِ
u'وَجْهٌ هَدِيَّةٌ':Added, #1: 1	وَجْهِ الْهَدِيَّةِ
u'وَجْهٌ هَزْلٌ':Added, #1: 1	وَجْهِ الْهَدِيَّةِ
u'وَجْهٌ وَاثِقٌ':Added, #3: 3	وَجْهِ الْهَزْلِ
u'وَجْهٌ واحد':Added, #1: 1	وَجْهُ الْوَاثِقِ
u'وَجْهٌ وَاحِدٌ':Added, #1: 1	وَجْهَ الْوَاحِدِ
u'وَجْهٌ واحد':Added, #1: 1	وَجْهَ الْوَاحِدِ
u'وَجْهٌ وَاحِدٌ':Added, #43: 43	وَجْهٍ وَاحِدٍ
u'وَجْهٌ وَاضِحٌ':Added, #43: 43	وَجْهٍ وَاحِدٍ
u'وَجْهٌ وَاقِفٌ':Added, #1: 1	وَجْهٍ وَاضِحٍ
u'وَجْهٌ وَالِدٌ':Added, #1: 1	وَجْهِ الْوَاقِفِ
u'وَجْهٌ وَثِيقٌ':Added, #1: 1	وَجْهِ الْوَالِدَيْنِ
u'وَجْهٌ وَجْهٌ':Added, #2: 2	وَجْهِ الْوَثِيقَةِ
u'وَجْهٌ وُجُوبٌ':Added, #1: 1	وَجْهُ الْوَجْهِ
u'وَجْهٌ وُجُوهٌ':Added, #10: 10	وَجْهِ الْوُجُوبِ
u'وَجْهٌ وَدِيعٌ':Added, #1: 1	وَجْهَ الْوُجُوهِ
u'وَجْهٌ وَدِيعَةٌ':Added, #4: 4	وَجْهِ الْوَدِيعَةِ
u'وَجْهٌ وَرَعٌ':Added, #4: 4	وَجْهِ الْوَدِيعَةِ
u'وَجْهٌ وَصِيٌّ':Added, #1: 1	وَجْهِ الْوَرَعِ
u'وَجْهٌ وَصِيٌّ':Added, #2: 2	وَجْهِ الْوَصِيَّةِ
u'وَجْهٌ وَصِيَّةٌ':Added, #3: 3	وَجْهَ الْوَصِيَّةِ
u'وَجْهٌ وَصِيَّةٌ':Added, #2: 2	وَجْهِ الْوَصِيَّةِ
u'وَجْهٌ وَضْعٌ':Added, #3: 3	وَجْهَ الْوَصِيَّةِ
u'وَجْهٌ وَضْعٌ':Added, #1: 1	وَجْهُ الْوَضْعِ
u'وَجْهٌ وَعِيدٌ':Added, #1: 1	وَجْهُ وَضْعِ
u'وَجْهٌ وَقْف':Added, #1: 1	وَجْهُ الْوَعِيدِ
u'وَجْهٌ وَقْفٌ':Added, #1: 1	وَجْهِ الْوَقْفِيَّةِ
u'وَجْهٌ وَقْفَة':Added, #2: 2	وَجْهِ الْوَقْفِ
u'وَجْهٌ وَقْفِيّ':Added, #1: 1	وَجْهِ الْوَقْفِيَّةِ
u'وَجْهٌ وَقْفِيَّة':Added, #1: 1	وَجْهِ الْوَقْفِيَّةِ
u'وَجْهٌ وُقُوعٌ':Added, #1: 1	وَجْهِ الْوَقْفِيَّةِ
u'وَجْهٌ وَكِيلٌ':Added, #1: 1	وَجْهُ الْوُقُوعِ
u'وَجْهٌ وِلاَيَةٌ':Added, #1: 1	وَجْهِ وَكِيلِ
u'وَجْهٌ يُسْرٌ':Added, #1: 1	وَجْهِ الْوِلَايَةِ
u'وَجْهٌ يَمِينٌ':Added, #1: 1	وَجْهِ الْيُسْرِ
u'وَجْهٌ يَمِينٌ':Added, #1: 1	وَجْهَ يَمِينِهِ
u'وُجُوبٌ اِبْتِداءٌ':Added, #3: 3	وَجْهِ الْيَمِينِ
u'وُجُوبٌ إبدالٌ':Added, #1: 1	وُجُوبِ ابْتِدَاءِ
u'وُجُوبٌ إِبْطَالٌ':Added, #1: 1	وُجُوبِ إبْدَالٍ
u'وُجُوبٌ إِبْقَاءٌ':Added, #1: 1	وُجُوبِ إبْطَالِ
u'وُجُوبٌ اِتِّبَاعٌ':Added, #1: 1	وُجُوبَ الْإِبْقَاءِ
u'وُجُوبٌ اِتِّبَاعٌ':Added, #2: 2	وُجُوبُ اتِّبَاعِ
u'وُجُوبٌ اِتِّبَاعٌ':Added, #2: 2	وُجُوبِ اتِّبَاعِهِ
u'وُجُوبٌ اِتِّبَاعٌ':Added, #3: 3	وُجُوبَ اتِّبَاعِهِ
u'وُجُوبٌ اِتِّبَاعٌ':Added, #3: 3	وُجُوبُ اتِّبَاعِهِ
u'وُجُوبٌ اِتِّحَادٌ':Added, #6: 6	وُجُوبِ اتِّبَاعِ
u'وُجُوبٌ اِتِّصَالٌ':Added, #1: 1	وُجُوبِ اتِّحَادِ
u'وُجُوبٌ اِتِّقَاءٌ':Added, #1: 1	وُجُوبِ اتِّصَالِ
u'وُجُوبٌ إتْمَامٌ':Added, #1: 1	وُجُوب اتِّقَاءِ
u'وُجُوبٌ إتْمَامٌ':Added, #1: 1	وُجُوبُ إتْمَامِ
u'وُجُوبٌ إتْمَامٌ':Added, #2: 2	وُجُوبَ إتْمَامِ
u'وُجُوبٌ إتْمَامٌ':Added, #2: 2	وُجُوبِ إتْمَامِ
u'وُجُوبٌ إتْمَامٌ':Added, #2: 2	وُجُوبُ إتْمَامِهِ
u'وُجُوبٌ إتْمَامٌ':Added, #3: 3	وُجُوبَ الْإِتْمَامِ
u'وُجُوبٌ إِتْيانٌ':Added, #5: 5	وُجُوبِ الْإِتْمَامِ
u'وُجُوبٌ إِتْيانٌ':Added, #1: 1	وُجُوبَ الْإِتْيَانِ
u'وُجُوبٌ إِتْيانٌ':Added, #1: 1	وُجُوبُ الْإِتْيَانِ
u'وُجُوبٌ إِتْيانٌ':Added, #2: 2	وُجُوبِ إتْيَانِهِ
u'وُجُوبٌ إِثْبَاتٌ':Added, #2: 2	وُجُوبِ الْإِتْيَانِ
u'وُجُوبٌ إِجَابَةٌ':Added, #1: 1	وُجُوبِ إثْبَاتِ
u'وُجُوبٌ إِجَابَةٌ':Added, #1: 1	وُجُوبِ إجَابَتِهِ
u'وُجُوبٌ إِجَابَةٌ':Added, #2: 2	وُجُوبَ الْإِجَابَةِ
u'وُجُوبٌ إِجَابَةٌ':Added, #3: 3	وُجُوبِ إجَابَةِ
u'وُجُوبٌ إِجَابَةٌ':Added, #9: 9	وُجُوبُ الْإِجَابَةِ
u'وُجُوبٌ إجَارَةٌ':Added, #9: 9	وُجُوبِ الْإِجَابَةِ
u'وُجُوبٌ إجَارَةٌ':Added, #1: 1	وُجُوبِ إجَارَةِ
u'وُجُوبٌ اجْتِنَابٌ':Added, #1: 1	وُجُوبَ الْإِجَارَةِ
u'وُجُوبٌ اجْتِنَابٌ':Added, #1: 1	وُجُوبِ اجْتِنَابِ
u'وُجُوبٌ اِجْتِهَادٌ':Added, #1: 1	وُجُوبِ اجْتِنَابِهِ
u'وُجُوبٌ أَجْرٌ':Added, #1: 1	وُجُوبِ اجْتِهَادٍ
u'وُجُوبٌ أَجْرٌ':Added, #1: 1	وُجُوبَ الْأَجْرِ
u'وُجُوبٌ أَجْرٌ':Added, #1: 1	وُجُوبُ الْأَجْرِ
u'وُجُوبٌ أَجْرٌ':Added, #2: 2	وُجُوبَ أَجْرِ
u'وُجُوبٌ أَجْرٌ':Added, #3: 3	وُجُوبُ أَجْرِ
u'وُجُوبٌ أَجْرٌ':Added, #3: 3	وُجُوبِ أَجْرِ
u'وُجُوبٌ أُجْرَةٌ':Added, #7: 7	وُجُوبِ الْأَجْرِ
u'وُجُوبٌ أُجْرَةٌ':Added, #12: 12	وُجُوبِ الْأُجْرَةِ
u'وُجُوبٌ أُجْرَةٌ':Added, #1: 1	وُجُوبِ أُجْرَتِهِ
u'وُجُوبٌ أُجْرَةٌ':Added, #2: 2	وُجُوبُ أُجْرَةِ
u'وُجُوبٌ أُجْرَةٌ':Added, #3: 3	وُجُوبِ أُجْرَةِ
u'وُجُوبٌ أُجْرَةٌ':Added, #3: 3	وُجُوبُ الْأُجْرَةِ
u'وُجُوبٌ أُجْرَةٌ':Added, #4: 4	وُجُوبَ أُجْرَةِ
u'وُجُوبٌ أَجْوَدُ':Added, #5: 5	وُجُوبَ الْأُجْرَةِ
u'وُجُوبٌ اِحْتِيَاطٌ':Added, #1: 1	وُجُوبَ الْأَجْوَدِ
u'وُجُوبٌ إِحْرَامٌ':Added, #1: 1	وُجُوبِ احْتِيَاطٍ
u'وُجُوبٌ إِحْرَامٌ':Added, #1: 1	وُجُوبَ إحْرَامِهِ
u'وُجُوبٌ إِحْرَامٌ':Added, #2: 2	وُجُوبُ الْإِحْرَامِ
u'وُجُوبٌ إِحْرَامٌ':Added, #3: 3	وُجُوبِ الْإِحْرَامِ
u'وُجُوبٌ إحْسَانٌ':Added, #5: 5	وُجُوبَ الْإِحْرَامِ
u'وُجُوبٌ إحْضَارٌ':Added, #1: 1	وُجُوبِ الْإِحْسَانِ
u'وُجُوبٌ إحْضَارٌ':Added, #1: 1	وُجُوبُ إحْضَارِهِ
u'وُجُوبٌ إِحْيَاءٌ':Added, #2: 2	وُجُوبُ إحْضَارِ
u'وُجُوبٌ إِخْبَارٌ':Added, #1: 1	وُجُوبَ الْإِحْيَاءِ
u'وُجُوبٌ أخْذٌ':Added, #1: 1	وُجُوبِ إخْبَارِ
u'وُجُوبٌ أخْذٌ':Added, #1: 1	وُجُوبِ أَخْذِ
u'وُجُوبٌ أخْذٌ':Added, #1: 1	وُجُوبُ الْأَخْذِ
u'وُجُوبٌ إِخْرَاجٌ':Added, #2: 2	وُجُوبِ الْأَخْذِ
u'وُجُوبٌ إِخْرَاجٌ':Added, #1: 1	وُجُوبُ إخْرَاجِ
u'وُجُوبٌ إِخْرَاجٌ':Added, #1: 1	وُجُوبَ الْإِخْرَاجِ
u'وُجُوبٌ إِخْرَاجٌ':Added, #1: 1	وُجُوبُ الْإِخْرَاجِ
u'وُجُوبٌ إِخْرَاجٌ':Added, #2: 2	وُجُوبِ الْإِخْرَاجِ
u'وُجُوبٌ إِخْفَاءٌ':Added, #6: 6	وُجُوبِ إخْرَاجِ
u'وُجُوبٌ أَدَاءٌ':Added, #1: 1	وُجُوبِ الْإِخْفَاءِ
u'وُجُوبٌ أَدَاءٌ':Added, #11: 11	وُجُوبَ الْأَدَاءِ
u'وُجُوبٌ أَدَاءٌ':Added, #33: 33	وُجُوبُ الْأَدَاءِ
u'وُجُوبٌ أَدَاءٌ':Added, #3: 3	وُجُوبَ أَدَاءِ
u'وُجُوبٌ أَدَاءٌ':Added, #3: 3	وُجُوبُ أَدَاءِ
u'وُجُوبٌ أَدَاءٌ':Added, #65: 65	وُجُوبِ الْأَدَاءِ
u'وُجُوبٌ آذَانٌ':Added, #6: 6	وُجُوبِ أَدَاءِ
u'وُجُوبٌ أَذَانٌ':Added, #1: 1	وُجُوبِ الْآذَانِ
u'وُجُوبٌ إِذْنٌ':Added, #1: 1	وُجُوبِ الْأَذَانِ
u'وُجُوبٌ إِذْنٌ':Added, #1: 1	وُجُوبَ الْإِذْنِ
u'وُجُوبٌ إِرَاقَةٌ':Added, #2: 2	وُجُوبُ إذْنِهِ
u'وُجُوبٌ إِرَاقَةٌ':Added, #1: 1	وُجُوبَ إرَاقَتِهِ
u'وُجُوبٌ أَرْبَعُ':Added, #1: 1	وُجُوبُ إرَاقَتِهِ
u'وُجُوبٌ أَرْبَعُ':Added, #2: 2	وُجُوبُ الْأَرْبَعِ
u'وُجُوبٌ أَرْبَعَةٌ':Added, #2: 2	وُجُوبِ الْأَرْبَعِ
u'وُجُوبٌ اِرْتِفَاعٌ':Added, #2: 2	وُجُوبِ الْأَرْبَعَةِ
u'وُجُوبٌ اِرْتِكَابٌ':Added, #1: 1	وُجُوبِ ارْتِفَاعِ
u'وُجُوبٌ إِرْسَالٌ':Added, #1: 1	وُجُوبِ ارْتِكَابِ
u'وُجُوبٌ إِرْشَادٌ':Added, #4: 4	وُجُوبُ الْإِرْسَالِ
u'وُجُوبٌ إِرْشَادٌ':Added, #1: 1	وُجُوبُ إرْشَادٍ
u'وُجُوبٌ إِرْضاعٌ':Added, #1: 1	وُجُوبِ إرْشَادِهِ
u'وُجُوبٌ إِزَارٌ':Added, #1: 1	وُجُوبَ الْإِرْضَاعِ
u'وُجُوبٌ إِزَالَةٌ':Added, #1: 1	وُجُوبَ الْإِزَارِ
u'وُجُوبٌ إِزَالَةٌ':Added, #1: 1	وُجُوبُ إزَالَةِ
u'وُجُوبٌ إِزَالَةٌ':Added, #1: 1	وُجُوبُ إزَالَتِهِ
u'وُجُوبٌ أسْبَابٌ':Added, #2: 2	وُجُوبِ إزَالَةِ
u'وُجُوبٌ أَسْبَابٌ':Added, #1: 1	وُجُوبَ الْأَسْبَابِ
u'وُجُوبٌ اِسْتِدْلاَلٌ':Added, #1: 1	وُجُوبَ الْأَسْبَابِ
u'وُجُوبٌ اِسْتِعْمالٌ':Added, #1: 1	وُجُوبُ اسْتِدْلَالٍ
u'وُجُوبٌ اِسْتِعْمالٌ':Added, #1: 1	وُجُوبِ اسْتِعْمَالِهِ
u'وُجُوبٌ اِسْتِعْمالٌ':Added, #2: 2	وُجُوبِ اسْتِعْمَالِ
u'وُجُوبٌ اِسْتِعْمالٌ':Added, #2: 2	وُجُوبُ اسْتِعْمَالِهِ
u'وُجُوبٌ اِسْتِغْرَاقٌ':Added, #3: 3	وُجُوبُ اسْتِعْمَالِ
u'وُجُوبٌ اِسْتِفْتاحٌ':Added, #1: 1	وُجُوبِ اسْتِغْرَاقِ
u'وُجُوبٌ اِسْتِفْسارٌ':Added, #1: 1	وُجُوبُ اسْتِفْتَاحِ
u'وُجُوبٌ اِسْتِقْبالٌ':Added, #1: 1	وُجُوبُ اسْتِفْسَارِهِ
u'وُجُوبٌ اِسْتِقْبالٌ':Added, #1: 1	وُجُوبُ اسْتِقْبَالِ
u'وُجُوبٌ اِسْتِئْنَافٌ':Added, #2: 2	وُجُوبِ اسْتِقْبَالِ
u'وُجُوبٌ اِسْتيعابٌ':Added, #1: 1	وُجُوبُ اسْتِئْنَافِ
u'وُجُوبٌ اِسْتيعابٌ':Added, #1: 1	وُجُوبُ اسْتِيعَابِ
u'وُجُوبٌ إِسْكانٌ':Added, #2: 2	وُجُوبِ اسْتِيعَابِ
u'وُجُوبٌ إِسْلامٌ':Added, #1: 1	وُجُوبُ الْإِسْكَانِ
u'وُجُوبٌ اِشْتِراطٌ':Added, #1: 1	وُجُوبَ الْإِسْلَامِ
u'وُجُوبٌ أَشْيَاءٌ':Added, #1: 1	وُجُوبِ اشْتِرَاطِ
u'وُجُوبٌ أصل':Added, #2: 2	وُجُوبُ الْأَشْيَاءِ
u'وُجُوبٌ أًصْلٌ':Added, #1: 1	وُجُوبُ أَصْلِ
u'وُجُوبٌ أصل':Added, #1: 1	وُجُوبُ أَصْلِ
u'وُجُوبٌ أًصْلٌ':Added, #1: 1	وُجُوبِ أَصْلِهِ
u'وُجُوبٌ أصل':Added, #1: 1	وُجُوبِ أَصْلِهِ
u'وُجُوبٌ أًصْلٌ':Added, #4: 4	وُجُوبِ الْأَصْلِ
u'وُجُوبٌ أصل':Added, #4: 4	وُجُوبِ الْأَصْلِ
u'وُجُوبٌ أًصْلٌ':Added, #5: 5	وُجُوبِ أَصْلِ
u'وُجُوبٌ إِصْلاحٌ':Added, #5: 5	وُجُوبِ أَصْلِ
u'وُجُوبٌ إضْمارٌ':Added, #1: 1	وُجُوبِ إصْلَاحِ
u'وُجُوبٌ إِطْعامٌ':Added, #1: 1	وُجُوبِ إضْمَارِ
u'وُجُوبٌ إِظْهارٌ':Added, #1: 1	وُجُوبُ الْإِطْعَامِ
u'وُجُوبٌ إِظْهارٌ':Added, #1: 1	وُجُوبَ إظْهَارِ
u'وُجُوبٌ إِعادَةٌ':Added, #2: 2	وُجُوبِ إظْهَارِ
u'وُجُوبٌ إِعادَةٌ':Added, #16: 16	وُجُوبِ الْإِعَادَةِ
u'وُجُوبٌ إِعادَةٌ':Added, #1: 1	وُجُوبُ إعَادَتِهِ
u'وُجُوبٌ إِعادَةٌ':Added, #4: 4	وُجُوبُ إعَادَةِ
u'وُجُوبٌ إِعادَةٌ':Added, #6: 6	وُجُوبُ الْإِعَادَةِ
u'وُجُوبٌ إِعادَةٌ':Added, #8: 8	وُجُوبِ إعَادَةِ
u'وُجُوبٌ إِعْتاقٌ':Added, #9: 9	وُجُوبَ الْإِعَادَةِ
u'وُجُوبٌ إِعْتاقٌ':Added, #1: 1	وُجُوبُ إعْتَاقِ
u'وُجُوبٌ إِعْتاقٌ':Added, #1: 1	وُجُوبِ إعْتَاقِ
u'وُجُوبٌ إِعْتاقٌ':Added, #1: 1	وُجُوبَ الْإِعْتَاقِ
u'وُجُوبٌ اِعْتِبارٌ':Added, #1: 1	وُجُوبُ الْإِعْتَاقِ
u'وُجُوبٌ اِعْتِبارٌ':Added, #1: 1	وُجُوبَ اعْتِبَارِ
u'وُجُوبٌ اِعْتِبارٌ':Added, #1: 1	وُجُوبُ اعْتِبَارِ
u'وُجُوبٌ اِعْتِقادٌ':Added, #1: 1	وُجُوبِ اعْتِبَارِ
u'وُجُوبٌ اِعْتِقادٌ':Added, #11: 11	وُجُوبِ اعْتِقَادِ
u'وُجُوبٌ اِعْتِقادٌ':Added, #1: 1	وُجُوبَ اعْتِقَادِ
u'وُجُوبٌ اِعْتِكافٌ':Added, #3: 3	وُجُوبُ اعْتِقَادِ
u'وُجُوبٌ إعْطَاءٌ':Added, #1: 1	وُجُوبِ اعْتِكَافِهِ
u'وُجُوبٌ إعْطَاءٌ':Added, #1: 1	وُجُوبَ الْإِعْطَاءِ
u'وُجُوبٌ إعْلاَمٌ':Added, #1: 1	وُجُوبِ الْإِعْطَاءِ
u'وُجُوبٌ إعْلاَمٌ':Added, #1: 1	وُجُوبِ إعْلَامِ
u'وُجُوبٌ اِفْتِتَاحٌ':Added, #1: 1	وُجُوبِ إعْلَامِهِ
u'وُجُوبٌ إقامَةٌ':Added, #1: 1	وُجُوبِ افْتِتَاحِ
u'وُجُوبٌ إقامَةٌ':Added, #1: 1	وُجُوبُ إقَامَةِ
u'وُجُوبٌ إقْدَامٌ':Added, #1: 1	وُجُوبِ إقَامَةِ
u'وُجُوبٌ أقَلُّ':Added, #1: 1	وُجُوبَ الْإِقْدَامِ
u'وُجُوبٌ أقَلُّ':Added, #1: 1	وُجُوبُ أَقَلِّ
u'وُجُوبٌ أقَلُّ':Added, #1: 1	وُجُوبُ الْأَقَلِّ
u'وُجُوبٌ أَكْثَرُ':Added, #2: 2	وُجُوبِ الْأَقَلِّ
u'وُجُوبٌ أَكْثَرُ':Added, #1: 1	وُجُوبُ أَكْثَرِ
u'وُجُوبٌ أَكْثَرُ':Added, #1: 1	وُجُوبَ الْأَكْثَرِ
u'وُجُوبٌ أَكْثَرُ':Added, #1: 1	وُجُوبُ الْأَكْثَرِ
u'وُجُوبٌ أكل':Added, #1: 1	وُجُوبِ الْأَكْثَرِ
u'وُجُوبٌ أكل':Added, #1: 1	وُجُوبُ الْأَكْلِ
u'وُجُوبٌ أَكْلٌ':Added, #1: 1	وُجُوبِ الْأَكْلِ
u'وُجُوبٌ أَكْلٌ':Added, #1: 1	وُجُوبُ الْأَكْلِ
u'وُجُوبٌ أكل':Added, #1: 1	وُجُوبِ الْأَكْلِ
u'وُجُوبٌ أَكْلٌ':Added, #2: 2	وُجُوبُ أَكْلِ
u'وُجُوبٌ أكل':Added, #2: 2	وُجُوبُ أَكْلِ
u'وُجُوبٌ أَكْلٌ':Added, #3: 3	وُجُوبِ أَكْلِ
u'وُجُوبٌ إِكْمَالٌ':Added, #3: 3	وُجُوبِ أَكْلِ
u'وُجُوبٌ إِكْمَالٌ':Added, #1: 1	وُجُوبِ إكْمَالِ
u'وُجُوبٌ اِلْتِزَامٌ':Added, #1: 1	وُجُوبَ إكْمَالِهِ
u'وُجُوبٌ إِلْزَامٌ':Added, #1: 1	وُجُوبِ الْتِزَامِ
u'وُجُوبٌ ألْفٌ':Added, #1: 1	وُجُوبُ إلْزَامِ
u'وُجُوبٌ ألْفٌ':Added, #1: 1	وُجُوبُ الْأَلْفَيْنِ
u'وُجُوبٌ أَلْفٌ':Added, #1: 1	وُجُوبُ أَلْفٍ
u'وُجُوبٌ ألف':Added, #1: 1	وُجُوبُ أَلْفٍ
u'وُجُوبٌ ألْفٌ':Added, #5: 5	وُجُوبِ الْأَلْفِ
u'وُجُوبٌ أَلْفٌ':Added, #5: 5	وُجُوبِ الْأَلْفِ
u'وُجُوبٌ إمَامَةٌ':Added, #5: 5	وُجُوبِ الْأَلْفِ
u'وُجُوبٌ اِمْتِثَالٌ':Added, #1: 1	وُجُوبُ الْإِمَامَةِ
u'وُجُوبٌ أَمْرٌ':Added, #1: 1	وُجُوبُ امْتِثَالِ
u'وُجُوبٌ أَمْرٌ':Added, #1: 1	وُجُوبَ الْأَمْرِ
u'وُجُوبٌ أَمْرٌ':Added, #2: 2	وُجُوبُ الْأَمْرِ
u'وُجُوبٌ إِمْساكٌ':Added, #3: 3	وُجُوبِ الْأَمْرِ
u'وُجُوبٌ إِمْساكٌ':Added, #2: 2	وُجُوبِ الْإِمْسَاكِ
u'وُجُوبٌ إِمْساكٌ':Added, #5: 5	وُجُوبَ الْإِمْسَاكِ
u'وُجُوبٌ إِنابَةٌ':Added, #5: 5	وُجُوبُ الْإِمْسَاكِ
u'وُجُوبٌ اِنْصِرافٌ':Added, #1: 1	وُجُوبِ الْإِنَابَةِ
u'وُجُوبٌ اِنْعِقَادٌ':Added, #1: 1	وُجُوبُ الاِنْصِرَافِ
u'وُجُوبٌ إِنْفاقٌ':Added, #1: 1	وُجُوبُ انْعِقَادِ
u'وُجُوبٌ إِنْفاقٌ':Added, #3: 3	وُجُوبُ الْإِنْفَاقِ
u'وُجُوبٌ إِنْكارٌ':Added, #4: 4	وُجُوبِ الْإِنْفَاقِ
u'وُجُوبٌ إِنْكارٌ':Added, #1: 1	وُجُوبِ الْإِنْكَارِ
u'وُجُوبٌ إِنْكارٌ':Added, #1: 1	وُجُوبِ إنْكَارِهِ
u'وُجُوبٌ إنْهَاءٌ':Added, #3: 3	وُجُوبَ الْإِنْكَارِ
u'وُجُوبٌ أَوْصَافٌ':Added, #1: 1	وُجُوبُ الْإِنْهَاءِ
u'وُجُوبٌ أَوَّلُ':Added, #1: 1	وُجُوبِ أَوْصَافِهِ
u'وُجُوبٌ إِيثَارٌ':Added, #2: 2	وُجُوبِ الْأَوَّلِ
u'وُجُوبٌ إيصَالٌ':Added, #1: 1	وُجُوبِ الْإِيثَارِ
u'وُجُوبٌ إيصَالٌ':Added, #1: 1	وُجُوبُ الْإِيصَالِ
u'وُجُوبٌ إيصَالٌ':Added, #2: 2	وُجُوبِ الْإِيصَالِ
u'وُجُوبٌ أَيْمَانٌ':Added, #5: 5	وُجُوبِ إيصَالِ
u'وُجُوبٌ إيمَانٌ':Added, #1: 1	وُجُوبُ الْأَيْمَانِ
u'وُجُوبٌ إيمَانٌ':Added, #1: 1	وُجُوبُ الْإِيمَانِ
u'وُجُوبٌ إيمَانٌ':Added, #4: 4	وُجُوبَ الْإِيمَانِ
u'وُجُوبٌ بَحْثٌ':Added, #7: 7	وُجُوبِ الْإِيمَانِ
u'وُجُوبٌ بَحْثٌ':Added, #1: 1	وُجُوبَ بَحْثِهِ
u'وُجُوبٌ بَدَلٌ':Added, #8: 8	وُجُوبِ الْبَحْثِ
u'وُجُوبٌ بَدَلٌ':Added, #1: 1	وُجُوبُ بَدَلِ
u'وُجُوبٌ بَدَلٌ':Added, #2: 2	وُجُوبَ الْبَدَلِ
u'وُجُوبٌ بَدَلٌ':Added, #2: 2	وُجُوبِ بَدَلِ
u'وُجُوبٌ بَدَلٌ':Added, #4: 4	وُجُوبُ الْبَدَلِ
u'وُجُوبٌ بدنة':Added, #5: 5	وُجُوبِ الْبَدَلِ
u'وُجُوبٌ بدنة':Added, #1: 1	وُجُوبَ الْبَدَنَةِ
u'وُجُوبٌ بدنة':Added, #2: 2	وُجُوبُ الْبَدَنَةِ
u'وُجُوبٌ بَذْلٌ':Added, #2: 2	وُجُوبِ الْبَدَنَةِ
u'وُجُوبٌ بَذْلٌ':Added, #1: 1	وُجُوبَ بَذْلِ
u'وُجُوبٌ بَذْلٌ':Added, #1: 1	وُجُوبِ بَذْلِ
u'وُجُوبٌ بَذْلٌ':Added, #1: 1	وُجُوبِ بَذْلِهِ
u'وُجُوبٌ بَذْلٌ':Added, #2: 2	وُجُوبُ بَذْلِهِ
u'وُجُوبٌ بِرٌّ':Added, #4: 4	وُجُوبِ الْبَذْلِ
u'وُجُوبٌ بَرٌّ':Added, #1: 1	وُجُوبِ الْبِرِّ
u'وُجُوبٌ بِرٌّ':Added, #2: 2	وُجُوبِ الْبَرِّ
u'وُجُوبٌ بِرٌّ':Added, #2: 2	وُجُوبَ الْبِرِّ
u'وُجُوبٌ بعثة':Added, #2: 2	وُجُوبُ الْبِرِّ
u'وُجُوبٌ بَعْضٌ':Added, #2: 2	وُجُوبِ بَعْثَةِ
u'وُجُوبٌ بَعْضٌ':Added, #1: 1	وُجُوبِ الْبَعْضِ
u'وُجُوبٌ بَعْضٌ':Added, #1: 1	وُجُوبَ بَعْضِهِ
u'وُجُوبٌ بَعْضٌ':Added, #2: 2	وُجُوبِ بَعْضِ
u'وُجُوبٌ بَقاءٌ':Added, #3: 3	وُجُوبَ بَعْضِ
u'وُجُوبٌ بُلُوغٌ':Added, #2: 2	وُجُوبُ الْبَقَاءِ
u'وُجُوبٌ بِنَاءٌ':Added, #1: 1	وُجُوبِ الْبُلُوغِ
u'وُجُوبٌ بَيات':Added, #1: 1	وُجُوبِ بِنَاءِ
u'وُجُوبٌ بَيَانٌ':Added, #1: 1	وُجُوبَ الْبَيَاتِ
u'وُجُوبٌ بَيَانٌ':Added, #1: 1	وُجُوبِ بَيَانِهِ
u'وُجُوبٌ بَيَانٌ':Added, #2: 2	وُجُوبَ بَيَانِ
u'وُجُوبٌ بَيَانٌ':Added, #2: 2	وُجُوبِ بَيَانِ
u'وُجُوبٌ بَيْعٌ':Added, #4: 4	وُجُوبِ الْبَيَانِ
u'وُجُوبٌ بَيْعٌ':Added, #1: 1	وُجُوبِ الْبَيْعِ
u'وُجُوبٌ بَيْعٌ':Added, #1: 1	وُجُوبَ بَيْعِ
u'وُجُوبٌ بَيْعٌ':Added, #1: 1	وُجُوبِ بَيْعِ
u'وُجُوبٌ تَأَخُّرٌ':Added, #1: 1	وُجُوبُ بَيْعِهِ
u'وُجُوبٌ تَأْخِيرٌ':Added, #1: 1	وُجُوبِ تَأَخُّرِهِ
u'وُجُوبٌ تَأْخِيرٌ':Added, #1: 1	وُجُوبَ التَّأْخِيرِ
u'وُجُوبٌ تَأْخِيرٌ':Added, #1: 1	وُجُوبَ تَأْخِيرِهِ
u'وُجُوبٌ تَأْخِيرٌ':Added, #1: 1	وُجُوبُ تَأْخِيرِهِ
u'وُجُوبٌ تَأْخِيرٌ':Added, #2: 2	وُجُوبُ التَّأْخِيرِ
u'وُجُوبٌ تَأْدِيبٌ':Added, #2: 2	وُجُوبِ التَّأْخِيرِ
u'وُجُوبٌ تَأْدِيبٌ':Added, #1: 1	وُجُوبِ التَّأْدِيبِ
u'وُجُوبٌ تَبَع':Added, #1: 1	وُجُوبِ تَأْدِيبِ
u'وُجُوبٌ تَبَعِيّ':Added, #1: 1	وُجُوبِ تَبَعِيَّةِ
u'وُجُوبٌ تَبَعِيَّة':Added, #1: 1	وُجُوبِ تَبَعِيَّةِ
u'وُجُوبٌ تَبْلِيغٌ':Added, #1: 1	وُجُوبِ تَبَعِيَّةِ
u'وُجُوبٌ تَبْلِيغٌ':Added, #1: 1	وُجُوبُ التَّبْلِيغِ
u'وُجُوبٌ تَبْلِيغٌ':Added, #2: 2	وُجُوبَ التَّبْلِيغِ
u'وُجُوبٌ تَتَابُعٌ':Added, #2: 2	وُجُوبِ تَبْلِيغِ
u'وُجُوبٌ تَتَابُعٌ':Added, #1: 1	وُجُوبَ التَّتَابُعِ
u'وُجُوبٌ تَتَابُعٌ':Added, #1: 1	وُجُوبِ تَتَابُعِهِ
u'وُجُوبٌ تَتَابُعٌ':Added, #2: 2	وُجُوبُ التَّتَابُعِ
u'وُجُوبٌ تَتَبُّعٌ':Added, #5: 5	وُجُوبِ التَّتَابُعِ
u'وُجُوبٌ تَثَبُّت':Added, #1: 1	وُجُوبِ تَتَبُّعِ
u'وُجُوبٌ تَجْدِيدٌ':Added, #1: 1	وُجُوبُ التَّثَبُّتِ
u'وُجُوبٌ تَجْدِيدٌ':Added, #1: 1	وُجُوبِ التَّجْدِيدِ
u'وُجُوبٌ تَجْدِيدٌ':Added, #1: 1	وُجُوبِ تَجْدِيدِ
u'وُجُوبٌ تَجَرُّدٌ':Added, #3: 3	وُجُوبَ تَجْدِيدِ
u'وُجُوبٌ تَجْفِيفٌ':Added, #1: 1	وُجُوبَ التَّجَرُّدِ
u'وُجُوبٌ تَجْهِيزٌ':Added, #1: 1	وُجُوبِ التَّجْفِيفِ
u'وُجُوبٌ تَجْهِيزٌ':Added, #1: 1	وُجُوبَ تَجْهِيزِ
u'وُجُوبٌ تَجْهِيزٌ':Added, #1: 1	وُجُوبُ تَجْهِيزِ
u'وُجُوبٌ تَحَالُفٌ':Added, #1: 1	وُجُوبِ تَجْهِيزِ
u'وُجُوبٌ تَحْدِيدٌ':Added, #1: 1	وُجُوبُ التَّحَالُفِ
u'وُجُوبٌ تَحْصِيلٌ':Added, #1: 1	وُجُوبُ التَّحْدِيدِ
u'وُجُوبٌ تَحْصِيلٌ':Added, #1: 1	وُجُوبِ التَّحْصِيلِ
u'وُجُوبٌ تَحْصِيلٌ':Added, #1: 1	وُجُوبَ تَحْصِيلِ
u'وُجُوبٌ تَحْصِيلٌ':Added, #1: 1	وُجُوبِ تَحْصِيلِ
u'وُجُوبٌ تَحْكِيمٌ':Added, #2: 2	وُجُوبِ تَحْصِيلِهِ
u'وُجُوبٌ تَحَلُّلٌ':Added, #1: 1	وُجُوبِ تَحْكِيمِ
u'وُجُوبٌ تَحَمُّلٌ':Added, #1: 1	وُجُوبِ التَّحَلُّلِ
u'وُجُوبٌ تَحْمِيدٌ':Added, #2: 2	وُجُوبِ التَّحَمُّلِ
u'وُجُوبٌ تَحَوُّلٌ':Added, #1: 1	وُجُوبِ التَّحْمِيدِ
u'وُجُوبٌ تَحَوُّلٌ':Added, #1: 1	وُجُوبَ التَّحَوُّلِ
u'وُجُوبٌ تَحْوِيلٌ':Added, #1: 1	وُجُوبِ التَّحَوُّلِ
u'وُجُوبٌ تَخَلُّفٌ':Added, #1: 1	وُجُوبُ التَّحْوِيلِ
u'وُجُوبٌ تَخْلِيصٌ':Added, #1: 1	وُجُوبَ التَّخَلُّفِ
u'وُجُوبٌ تَخْيِيرٌ':Added, #2: 2	وُجُوبِ التَّخْلِيصِ
u'وُجُوبٌ تَخْيِيرٌ':Added, #1: 1	وُجُوبُ تَخْيِيرِ
u'وُجُوبٌ تَذْكِيَةٌ':Added, #1: 1	وُجُوبِ تَخْيِيرِهِ
u'وُجُوبٌ تَرَبُّصٌ':Added, #1: 1	وُجُوبِ تَذْكِيَةِ
u'وُجُوبٌ تَرْتِيبٌ':Added, #1: 1	وُجُوبِ التَّرَبُّصِ
u'وُجُوبٌ تَرْتِيبٌ':Added, #22: 22	وُجُوبِ التَّرْتِيبِ
u'وُجُوبٌ تَرْتِيبٌ':Added, #2: 2	وُجُوبِ تَرْتِيبِ
u'وُجُوبٌ تَرْتِيبٌ':Added, #7: 7	وُجُوبُ التَّرْتِيبِ
u'وُجُوبٌ تَرْجِيحٌ':Added, #9: 9	وُجُوبَ التَّرْتِيبِ
u'وُجُوبٌ تَرْكٌ':Added, #1: 1	وُجُوبُ التَّرْجِيحِ
u'وُجُوبٌ تَرْكٌ':Added, #1: 1	وُجُوبِ التَّرْكِ
u'وُجُوبٌ تَرْكٌ':Added, #1: 1	وُجُوبِ تَرْكِهِ
u'وُجُوبٌ تَرْكِيبٌ':Added, #4: 4	وُجُوبِ تَرْكِ
u'وُجُوبٌ تَزْكِيَةٌ':Added, #1: 1	وُجُوبِ تَرْكِيبِ
u'وُجُوبٌ تَزَوُّجٌ':Added, #1: 1	وُجُوبِ تَزْكِيَتِهِ
u'وُجُوبٌ تَسْلِيمٌ':Added, #2: 2	وُجُوبِ التَّزَوُّجِ
u'وُجُوبٌ تَسْلِيمٌ':Added, #11: 11	وُجُوبِ التَّسْلِيمِ
u'وُجُوبٌ تَسْلِيم':Added, #1: 1	وُجُوبُ التَّسْلِيمِ
u'وُجُوبٌ تَسْلِيمٌ':Added, #1: 1	وُجُوبُ التَّسْلِيمَةِ
u'وُجُوبٌ تَسْلِيمٌ':Added, #1: 1	وُجُوبِ تَسْلِيمِهِ
u'وُجُوبٌ تَسْلِيمٌ':Added, #2: 2	وُجُوبَ تَسْلِيمِهِ
u'وُجُوبٌ تَسْلِيمٌ':Added, #3: 3	وُجُوبَ التَّسْلِيمِ
u'وُجُوبٌ تَسْلِيمٌ':Added, #3: 3	وُجُوبَ تَسْلِيمِ
u'وُجُوبٌ تَسْلِيمٌ':Added, #3: 3	وُجُوبِ تَسْلِيمِ
u'وُجُوبٌ تَسْمِيَة':Added, #4: 4	وُجُوبُ تَسْلِيمِ
u'وُجُوبٌ تَسْمِيَة':Added, #1: 1	وُجُوبَ التَّسْمِيَةِ
u'وُجُوبٌ تَسْمِيَة':Added, #3: 3	وُجُوبُ التَّسْمِيَةِ
u'وُجُوبٌ تَسْوِيَةٌ':Added, #3: 3	وُجُوبِ التَّسْمِيَةِ
u'وُجُوبٌ تَسْوِيَةٌ':Added, #1: 1	وُجُوبِ تَسْوِيَةِ
u'وُجُوبٌ تَسْوِيَةٌ':Added, #3: 3	وُجُوبُ التَّسْوِيَةِ
u'وُجُوبٌ تَسْوِيَةٌ':Added, #4: 4	وُجُوبَ التَّسْوِيَةِ
u'وُجُوبٌ تَشْدِيدٌ':Added, #5: 5	وُجُوبِ التَّسْوِيَةِ
u'وُجُوبٌ تَشَهُّدٌ':Added, #1: 1	وُجُوبَ التَّشْدِيدِ
u'وُجُوبٌ تَشَهُّدٌ':Added, #1: 1	وُجُوبُ التَّشَهُّدِ
u'وُجُوبٌ تَصَدُّقٌ':Added, #3: 3	وُجُوبِ التَّشَهُّدِ
u'وُجُوبٌ تَصَدُّقٌ':Added, #4: 4	وُجُوبِ التَّصَدُّقِ
u'وُجُوبٌ تَصَدُّقٌ':Added, #5: 5	وُجُوبَ التَّصَدُّقِ
u'وُجُوبٌ تَصْدِيقٌ':Added, #5: 5	وُجُوبُ التَّصَدُّقِ
u'وُجُوبٌ تَصْدِيقٌ':Added, #1: 1	وُجُوبُ التَّصْدِيقِ
u'وُجُوبٌ تَصْدِيقٌ':Added, #1: 1	وُجُوبِ التَّصْدِيقِ
u'وُجُوبٌ تَصْدِيقٌ':Added, #1: 1	وُجُوبُ تَصْدِيقِ
u'وُجُوبٌ تَصْدِيقٌ':Added, #1: 1	وُجُوبَ تَصْدِيقِهِ
u'وُجُوبٌ تَضْمِينٌ':Added, #1: 1	وُجُوبُ تَصْدِيقِهِ
u'وُجُوبٌ تَطْهِيرٌ':Added, #1: 1	وُجُوبُ تَضْمِينِ
u'وُجُوبٌ تَطْهِيرٌ':Added, #1: 1	وُجُوبُ التَّطْهِيرِ
u'وُجُوبٌ تَعْجِيل':Added, #1: 1	وُجُوبَ تَطْهِيرِهِ
u'وُجُوبٌ تَعْجِيل':Added, #1: 1	وُجُوبُ تَعْجِيلِ
u'وُجُوبٌ تَعَدُّدٌ':Added, #1: 1	وُجُوبِ تَعْجِيلِ
u'وُجُوبٌ تَعْدِيَة':Added, #1: 1	وُجُوبِ تَعَدُّدِ
u'وُجُوبٌ تَعْدِيلٌ':Added, #1: 1	وُجُوبِ التَّعْدِيَةِ
u'وُجُوبٌ تَعَرُّضٌ':Added, #1: 1	وُجُوبِ تَعْدِيلِ
u'وُجُوبٌ تَعَرُّضٌ':Added, #1: 1	وُجُوبُ التَّعَرُّضِ
u'وُجُوبٌ تَعْرِيفٌ':Added, #1: 1	وُجُوبِ التَّعَرُّضِ
u'وُجُوبٌ تَعْرِيفٌ':Added, #1: 1	وُجُوبِ تَعْرِيفِهِ
u'وُجُوبٌ تَعْزِير':Added, #2: 2	وُجُوبِ التَّعْرِيفِ
u'وُجُوبٌ تَعْزِير':Added, #12: 12	وُجُوبِ التَّعْزِيرِ
u'وُجُوبٌ تَعْزِير':Added, #1: 1	وُجُوبُ التَّعْزِيرِ
u'وُجُوبٌ تَعْزِير':Added, #1: 1	وُجُوبِ تَعْزِيرِ
u'وُجُوبٌ تَعْظِيمٌ':Added, #2: 2	وُجُوبَ التَّعْزِيرِ
u'وُجُوبٌ تَعَلُّمٌ':Added, #2: 2	وُجُوبِ تَعْظِيمِ
u'وُجُوبٌ تَعَلُّمٌ':Added, #1: 1	وُجُوبُ تَعَلُّمِ
u'وُجُوبٌ تَعَلُّمٌ':Added, #1: 1	وُجُوبِ تَعَلُّمِ
u'وُجُوبٌ تَعْلِيمٌ':Added, #1: 1	وُجُوبَ تَعَلُّمِهِ
u'وُجُوبٌ تَعْلِيمٌ':Added, #1: 1	وُجُوبَ تَعْلِيمِ
u'وُجُوبٌ تَعْمِيمٌ':Added, #2: 2	وُجُوبِ تَعْلِيمِ
u'وُجُوبٌ تَعْمِيمٌ':Added, #1: 1	وُجُوبِ تَعْمِيمِهِ
u'وُجُوبٌ تَعْمِيمٌ':Added, #2: 2	وُجُوبِ تَعْمِيمِ
u'وُجُوبٌ تَعْوِيلٌ':Added, #3: 3	وُجُوبِ التَّعْمِيمِ
u'وُجُوبٌ تَعْيِينٌ':Added, #1: 1	وُجُوبِ التَّعْوِيلِ
u'وُجُوبٌ تَعْيِينٌ':Added, #1: 1	وُجُوبِ تَعْيِينِ
u'وُجُوبٌ تَعْيِينٌ':Added, #2: 2	وُجُوبَ التَّعْيِينِ
u'وُجُوبٌ تَعْيِينٌ':Added, #2: 2	وُجُوبُ التَّعْيِينِ
u'وُجُوبٌ تَعْيِينٌ':Added, #2: 2	وُجُوبُ تَعْيِينِهِ
u'وُجُوبٌ تَغْطِيَةٌ':Added, #3: 3	وُجُوبِ التَّعْيِينِ
u'وُجُوبٌ تَغْلِيظٌ':Added, #1: 1	وُجُوبُ تَغْطِيَةِ
u'وُجُوبٌ تَغْلِيظٌ':Added, #1: 1	وُجُوبُ التَّغْلِيظِ
u'وُجُوبٌ تَغْيِيرٌ':Added, #1: 1	وُجُوبِ التَّغْلِيظِ
u'وُجُوبٌ تَفْرِقَة':Added, #2: 2	وُجُوبِ تَغْيِيرِ
u'وُجُوبٌ تَفْرِيقٌ':Added, #1: 1	وُجُوبِ التَّفْرِقَةِ
u'وُجُوبٌ تَفْرِيقٌ':Added, #1: 1	وُجُوبَ التَّفْرِيقِ
u'وُجُوبٌ تَفْرِيقٌ':Added, #1: 1	وُجُوبُ التَّفْرِيقِ
u'وُجُوبٌ تَفْسِيرٌ':Added, #1: 1	وُجُوبِ التَّفْرِيقِ
u'وُجُوبٌ تَفْصِيلٌ':Added, #1: 1	وُجُوبِ تَفْسِيرِ
u'وُجُوبٌ تَفْصِيلٌ':Added, #1: 1	وُجُوبَ التَّفْصِيلِ
u'وُجُوبٌ تَفْصِيلٌ':Added, #1: 1	وُجُوبُ التَّفْصِيلِ
u'وُجُوبٌ تَقابُض':Added, #1: 1	وُجُوبِ تَفْصِيلِ
u'وُجُوبٌ تَقْديرٌ':Added, #1: 1	وُجُوبِ التَّقَابُضِ
u'وُجُوبٌ تَقْديرٌ':Added, #1: 1	وُجُوبَ التَّقْدِيرِ
u'وُجُوبٌ تَقْديمٌ':Added, #1: 1	وُجُوبُ تَقْدِيرِ
u'وُجُوبٌ تَقْديمٌ':Added, #1: 1	وُجُوبُ التَّقْدِيمِ
u'وُجُوبٌ تَقْديمٌ':Added, #1: 1	وُجُوبَ تَقْدِيمِ
u'وُجُوبٌ تَقْديمٌ':Added, #1: 1	وُجُوبَ تَقْدِيمِهِ
u'وُجُوبٌ تَقْديمٌ':Added, #1: 1	وُجُوبُ تَقْدِيمِهِ
u'وُجُوبٌ تَقْديمٌ':Added, #2: 2	وُجُوبُ تَقْدِيمِ
u'وُجُوبٌ تَقْديمٌ':Added, #2: 2	وُجُوبِ تَقْدِيمِهِ
u'وُجُوبٌ تَقْليدٌ':Added, #6: 6	وُجُوبِ تَقْدِيمِ
u'وُجُوبٌ تَقْليد':Added, #1: 1	وُجُوبَ التَّقْلِيدِ
u'وُجُوبٌ تَقْليدٌ':Added, #1: 1	وُجُوبَ التَّقْلِيدِ
u'وُجُوبٌ تَقْليدٌ':Added, #1: 1	وُجُوبُ تَقْلِيدِ
u'وُجُوبٌ تَقْليد':Added, #1: 1	وُجُوبِ تَقْلِيدِ
u'وُجُوبٌ تَقْليد':Added, #1: 1	وُجُوبُ تَقْلِيدِ
u'وُجُوبٌ تَقْليدٌ':Added, #1: 1	وُجُوبِ تَقْلِيدِ
u'وُجُوبٌ تَقْليد':Added, #3: 3	وُجُوبِ التَّقْلِيدِ
u'وُجُوبٌ تَقْيِيد':Added, #3: 3	وُجُوبِ التَّقْلِيدِ
u'وُجُوبٌ تَقْيِيد':Added, #1: 1	وُجُوبُ تَقْيِيدِ
u'وُجُوبٌ تَكْبِير':Added, #1: 1	وُجُوبِ تَقْيِيدِ
u'وُجُوبٌ تَكْرارٌ':Added, #1: 1	وُجُوبِ تَكْبِيرَةِ
u'وُجُوبٌ تَكْرارٌ':Added, #1: 1	وُجُوبُ التَّكْرَارِ
u'وُجُوبٌ تَكْرارٌ':Added, #1: 1	وُجُوبِ التَّكْرَارِ
u'وُجُوبٌ تَكَرُّرٌ':Added, #1: 1	وُجُوبِ تَكْرَارِهِ
u'وُجُوبٌ تَكْريرٌ':Added, #1: 1	وُجُوبُ تَكَرُّرِهِ
u'وُجُوبٌ تَكْريرٌ':Added, #1: 1	وُجُوبِ التَّكْرِيرِ
u'وُجُوبٌ تَكْريرٌ':Added, #1: 1	وُجُوبَ تَكْرِيرِ
u'وُجُوبٌ تَكْفيرٌ':Added, #1: 1	وُجُوبُ تَكْرِيرِ
u'وُجُوبٌ تَكْميلٌ':Added, #1: 1	وُجُوبُ التَّكْفِيرِ
u'وُجُوبٌ تَلْبيَةٌ':Added, #1: 1	وُجُوبَ تَكْمِيلِ
u'وُجُوبٌ تَلَفُّظٌ':Added, #2: 2	وُجُوبِ التَّلْبِيَةِ
u'وُجُوبٌ تَلَفُّظٌ':Added, #1: 1	وُجُوبُ التَّلَفُّظِ
u'وُجُوبٌ تَمَذْهُبٌ':Added, #2: 2	وُجُوبِ التَّلَفُّظِ
u'وُجُوبٌ تَمْكِين':Added, #1: 1	وُجُوبِ التَّمَذْهُبِ
u'وُجُوبٌ تَنْزِيهٌ':Added, #1: 1	وُجُوبِ التَّمْكِينِ
u'وُجُوبٌ تَنْفِيذٌ':Added, #1: 1	وُجُوبِ تَنْزِيهِ
u'وُجُوبٌ تَنْفِيذٌ':Added, #1: 1	وُجُوبُ تَنْفِيذِ
u'وُجُوبٌ تَنْفِيذٌ':Added, #1: 1	وُجُوبِ تَنْفِيذِهِ
u'وُجُوبٌ تَهَجُّدٌ':Added, #2: 2	وُجُوبُ تَنْفِيذِهِ
u'وُجُوبٌ تَوْبَةٌ':Added, #1: 1	وُجُوبَ التَّهَجُّدِ
u'وُجُوبٌ تَوْبَةٌ':Added, #1: 1	وُجُوبُ التَّوْبَةِ
u'وُجُوبٌ تَوْبَةٌ':Added, #2: 2	وُجُوبَ التَّوْبَةِ
u'وُجُوبٌ تَوْرِيَةٌ':Added, #4: 4	وُجُوبِ التَّوْبَةِ
u'وُجُوبٌ تَوَقُّفٌ':Added, #1: 1	وُجُوبِ التَّوْرِيَةِ
u'وُجُوبٌ تَوَقُّفٌ':Added, #1: 1	وُجُوبِ التَّوَقُّفِ
u'وُجُوبٌ تَيَمُّمٌ':Added, #4: 4	وُجُوبُ التَّوَقُّفِ
u'وُجُوبٌ تَيَمُّمٌ':Added, #1: 1	وُجُوبَ التَّيَمُّمِ
u'وُجُوبٌ تَيَمُّمٌ':Added, #1: 1	وُجُوبُ التَّيَمُّمِ
u'وُجُوبٌ تَيَمُّمٌ':Added, #1: 1	وُجُوبُ تَيَمُّمِ
u'وُجُوبٌ ثبات':Added, #2: 2	وُجُوبِ التَّيَمُّمِ
u'وُجُوبٌ ثبات':Added, #1: 1	وُجُوبُ الثَّبَاتِ
u'وُجُوبٌ ثبَاتٌ':Added, #1: 1	وُجُوبِ الثَّبَاتِ
u'وُجُوبٌ ثبَاتٌ':Added, #1: 1	وُجُوبُ الثَّبَاتِ
u'وُجُوبٌ ثُبُوتٌ':Added, #1: 1	وُجُوبِ الثَّبَاتِ
u'وُجُوبٌ ثَلاثَةٌ':Added, #1: 1	وُجُوبُ الثّبُوتِ
u'وُجُوبٌ ثَلاثَةٌ':Added, #1: 1	وُجُوبَ الثَّلَاثَةِ
u'وُجُوبٌ ثَلاثَةٌ':Added, #1: 1	وُجُوبُ الثَّلَاثَةِ
u'وُجُوبٌ ثَلاثَةٌ':Added, #1: 1	وُجُوبَ ثَلَاثَةِ
u'وُجُوبٌ ثَلاثَةٌ':Added, #1: 1	وُجُوبُ ثَلَاثَةٍ
u'وُجُوبٌ ثَلاثَةٌ':Added, #1: 1	وُجُوبِ ثَلَاثَةِ
u'وُجُوبٌ ثَمَنٌ':Added, #2: 2	وُجُوبُ ثَلَاثَةِ
u'وُجُوبٌ ثَمَنٌ':Added, #4: 4	وُجُوبِ الثَّمَنِ
u'وُجُوبٌ ثَمَنٌ':Added, #5: 5	وُجُوبَ الثَّمَنِ
u'وُجُوبٌ ثَوابٌ':Added, #5: 5	وُجُوبُ الثَّمَنِ
u'وُجُوبٌ ثَوابٌ':Added, #1: 1	وُجُوبُ الثَّوَابِ
u'وُجُوبٌ جَابِرٌ':Added, #2: 2	وُجُوبِ الثَّوَابِ
u'وُجُوبٌ جَرَيان':Added, #1: 1	وُجُوبُ جَابِرٍ
u'وُجُوبٌ جُزْءٌ':Added, #1: 1	وُجُوبِ جَرَيَانِ
u'وُجُوبٌ جَزَاءٌ':Added, #1: 1	وُجُوبَ جُزْءٍ
u'وُجُوبٌ جَزَاءٌ':Added, #22: 22	وُجُوبِ الْجَزَاءِ
u'وُجُوبٌ جَزَاءٌ':Added, #9: 9	وُجُوبَ الْجَزَاءِ
u'وُجُوبٌ جَزُورٌ':Added, #9: 9	وُجُوبُ الْجَزَاءِ
u'وُجُوبٌ جِزْيَةٌ':Added, #1: 1	وُجُوبِ الْجَزُورِ
u'وُجُوبٌ جِزْيَةٌ':Added, #1: 1	وُجُوبُ الْجِزْيَةِ
u'وُجُوبٌ جِزْيَةٌ':Added, #1: 1	وُجُوبَ جِزْيَةِ
u'وُجُوبٌ جُعَلٌ':Added, #3: 3	وُجُوبِ الْجِزْيَةِ
u'وُجُوبٌ جلد':Added, #1: 1	وُجُوبِ الْجُعَلِ
u'وُجُوبٌ جَلْدٌ':Added, #2: 2	وُجُوبُ جَلْدِ
u'وُجُوبٌ جُلُوسٌ':Added, #2: 2	وُجُوبُ جَلْدِ
u'وُجُوبٌ جَمَاعَةٌ':Added, #2: 2	وُجُوبَ الْجُلُوسِ
u'وُجُوبٌ جَمَاعَةٌ':Added, #1: 1	وُجُوبُ الْجَمَاعَةِ
u'وُجُوبٌ جمع':Added, #2: 2	وُجُوبِ الْجَمَاعَةِ
u'وُجُوبٌ جمع':Added, #1: 1	وُجُوبَ الْجَمْعِ
u'وُجُوبٌ جَمْعٌ':Added, #1: 1	وُجُوبِ الْجَمْعِ
u'وُجُوبٌ جَمْعٌ':Added, #1: 1	وُجُوبَ الْجَمْعِ
u'وُجُوبٌ جمع':Added, #1: 1	وُجُوبِ الْجَمْعِ
u'وُجُوبٌ جَمْعٌ':Added, #3: 3	وُجُوبُ الْجَمْعِ
u'وُجُوبٌ جمعة':Added, #3: 3	وُجُوبُ الْجَمْعِ
u'وُجُوبٌ جُمُعَةٌ':Added, #14: 14	وُجُوبِ الْجُمُعَةِ
u'وُجُوبٌ جمعة':Added, #14: 14	وُجُوبِ الْجُمُعَةِ
u'وُجُوبٌ جمعة':Added, #2: 2	وُجُوبَ الْجُمُعَةِ
u'وُجُوبٌ جُمُعَةٌ':Added, #2: 2	وُجُوبُ الْجُمُعَةِ
u'وُجُوبٌ جُمُعَةٌ':Added, #2: 2	وُجُوبَ الْجُمُعَةِ
u'وُجُوبٌ جَمِيع':Added, #2: 2	وُجُوبُ الْجُمُعَةِ
u'وُجُوبٌ جِنَايَةٌ':Added, #2: 2	وُجُوبُ الْجَمِيعِ
u'وُجُوبٌ جِنَايَةٌ':Added, #1: 1	وُجُوبُ الْجِنَايَةِ
u'وُجُوبٌ جَنْبٌ':Added, #2: 2	وُجُوبِ الْجِنَايَةِ
u'وُجُوبٌ جِنْسٌ':Added, #1: 1	وُجُوبَ الْجَنْبِ
u'وُجُوبٌ جهاد':Added, #1: 1	وُجُوبُ جِنْسِ
u'وُجُوبٌ جِهَادٌ':Added, #3: 3	وُجُوبَ الْجِهَادِ
u'وُجُوبٌ جهاد':Added, #3: 3	وُجُوبَ الْجِهَادِ
u'وُجُوبٌ جِهَادٌ':Added, #4: 4	وُجُوبِ الْجِهَادِ
u'وُجُوبٌ جهر':Added, #4: 4	وُجُوبِ الْجِهَادِ
u'وُجُوبٌ جهر':Added, #1: 1	وُجُوبَ الْجَهْرِ
u'وُجُوبٌ جَهْرٌ':Added, #1: 1	وُجُوبِ الْجَهْرِ
u'وُجُوبٌ جَهْرٌ':Added, #1: 1	وُجُوبَ الْجَهْرِ
u'وُجُوبٌ جَوَابٌ':Added, #1: 1	وُجُوبِ الْجَهْرِ
u'وُجُوبٌ جَوَابٌ':Added, #1: 1	وُجُوبِ الْجَوَابِ
u'وُجُوبٌ حُبٌّ':Added, #3: 3	وُجُوبُ الْجَوَابِ
u'وُجُوبٌ حَبْسٌ':Added, #1: 1	وُجُوبُ حُبِّ
u'وُجُوبٌ حَجٌّ':Added, #3: 3	وُجُوبِ حَبْسِ
u'وُجُوبٌ حَجٌّ':Added, #16: 16	وُجُوبِ الْحَجِّ
u'وُجُوبٌ حَجٌّ':Added, #1: 1	وُجُوبِ حَجِّهِ
u'وُجُوبٌ حَجٌّ':Added, #2: 2	وُجُوبَ الْحَجِّ
u'وُجُوبٌ حُجَّةٌ':Added, #6: 6	وُجُوبُ الْحَجِّ
u'وُجُوبٌ حَدٌّ':Added, #1: 1	وُجُوبِ الْحُجَّةِ
u'وُجُوبٌ حَدٌّ':Added, #1: 1	وُجُوبُ حَدِّ
u'وُجُوبٌ حَدٌّ':Added, #1: 1	وُجُوبَ حَدِّهِ
u'وُجُوبٌ حَدٌّ':Added, #20: 20	وُجُوبَ الْحَدِّ
u'وُجُوبٌ حَدٌّ':Added, #26: 26	وُجُوبُ الْحَدِّ
u'وُجُوبٌ حَدٌّ':Added, #2: 2	وُجُوبَ حَدِّ
u'وُجُوبٌ حَدٌّ':Added, #2: 2	وُجُوبِ حَدِّ
u'وُجُوبٌ حداد':Added, #68: 68	وُجُوبِ الْحَدِّ
u'وُجُوبٌ حداد':Added, #1: 1	وُجُوبَ الْحِدَادِ
u'وُجُوبٌ حِدادٌ':Added, #1: 1	وُجُوبِ الْحِدَادِ
u'وُجُوبٌ حِدادٌ':Added, #1: 1	وُجُوبَ الْحِدَادِ
u'وُجُوبٌ حَرْقٌ':Added, #1: 1	وُجُوبِ الْحِدَادِ
u'وُجُوبٌ حُرْمَةٌ':Added, #1: 1	وُجُوبَ الْحَرْقِ
u'وُجُوبٌ حَصَادٌ':Added, #1: 1	وُجُوبِ الْحُرْمَةِ
u'وُجُوبٌ حَضَانَةٌ':Added, #1: 1	وُجُوبُ الْحَصَادِ
u'وُجُوبٌ حُضورٌ':Added, #1: 1	وُجُوبِ حَضَانَتِهِ
u'وُجُوبٌ حُضُورٌ':Added, #1: 1	وُجُوبِ حُضُورِ
u'وُجُوبٌ حُضورٌ':Added, #1: 1	وُجُوبِ حُضُورِ
u'وُجُوبٌ حُضُورٌ':Added, #1: 1	وُجُوبُ حُضُورِهِ
u'وُجُوبٌ حُضورٌ':Added, #1: 1	وُجُوبُ حُضُورِهِ
u'وُجُوبٌ حُضورٌ':Added, #4: 4	وُجُوبَ الْحُضُورِ
u'وُجُوبٌ حُضُورٌ':Added, #4: 4	وُجُوبُ الْحُضُورِ
u'وُجُوبٌ حُضُورٌ':Added, #4: 4	وُجُوبَ الْحُضُورِ
u'وُجُوبٌ حَظٌّ':Added, #4: 4	وُجُوبُ الْحُضُورِ
u'وُجُوبٌ حَفْرٌ':Added, #1: 1	وُجُوبَ الْحَظِّ
u'وُجُوبٌ حِفْظٌ':Added, #1: 1	وُجُوبِ الْحَفْرِ
u'وُجُوبٌ حِفْظٌ':Added, #1: 1	وُجُوبُ الْحِفْظِ
u'وُجُوبٌ حِفْظٌ':Added, #1: 1	وُجُوبَ حِفْظِ
u'وُجُوبٌ حِفْظٌ':Added, #1: 1	وُجُوبِ حِفْظِ
u'وُجُوبٌ حِفْظٌ':Added, #1: 1	وُجُوبِ حِفْظِهِ
u'وُجُوبٌ حَقٌّ':Added, #7: 7	وُجُوبِ الْحِفْظِ
u'وُجُوبٌ حَقٌّ':Added, #1: 1	وُجُوبُ الْحَقِّ
u'وُجُوبٌ حَقٌّ':Added, #1: 1	وُجُوبُ حَقٍّ
u'وُجُوبٌ حَقٌّ':Added, #1: 1	وُجُوبُ حَقِّ
u'وُجُوبٌ حَقٌّ':Added, #1: 1	وُجُوبِ حَقِّ
u'وُجُوبٌ حَقٌّ':Added, #1: 1	وُجُوبِ حَقِّهِ
u'وُجُوبٌ حَقٌّ':Added, #2: 2	وُجُوبَ الْحَقِّ
u'وُجُوبٌ حَقٌّ':Added, #3: 3	وُجُوبَ حَقِّ
u'وُجُوبٌ حَقٌّ':Added, #4: 4	وُجُوبِ حَقٍّ
u'وُجُوبٌ حُقوقٌ':Added, #5: 5	وُجُوبِ الْحَقِّ
u'وُجُوبٌ حُقُوقٌ':Added, #1: 1	وُجُوبَ الْحُقُوقِ
u'وُجُوبٌ حُقوقٌ':Added, #1: 1	وُجُوبَ الْحُقُوقِ
u'وُجُوبٌ حُقوقٌ':Added, #1: 1	وُجُوبَ حُقُوقِ
u'وُجُوبٌ حُقُوقٌ':Added, #1: 1	وُجُوبِ حُقُوقِ
u'وُجُوبٌ حُقُوقٌ':Added, #1: 1	وُجُوبَ حُقُوقِ
u'وُجُوبٌ حُكْمٌ':Added, #1: 1	وُجُوبِ حُقُوقِ
u'وُجُوبٌ حُكْمٌ':Added, #1: 1	وُجُوبُ حُكْمِ
u'وُجُوبٌ حُكْمٌ':Added, #1: 1	وُجُوبِ حُكْمِ
u'وُجُوبٌ حُكْمٌ':Added, #4: 4	وُجُوبُ الْحُكْمِ
u'وُجُوبٌ حُكُومَةٌ':Added, #6: 6	وُجُوبِ الْحُكْمِ
u'وُجُوبٌ حُكُومَةٌ':Added, #1: 1	وُجُوبَ الْحُكُومَةِ
u'وُجُوبٌ حُكُومَةٌ':Added, #1: 1	وُجُوبُ حُكُومَةٍ
u'وُجُوبٌ حِلٌّ':Added, #4: 4	وُجُوبِ الْحُكُومَةِ
u'وُجُوبٌ حَلْقٌ':Added, #1: 1	وُجُوبُ الْحِلِّ
u'وُجُوبٌ حَلْقٌ':Added, #1: 1	وُجُوبِ حَلْقِ
u'وُجُوبٌ حَمْدٌ':Added, #3: 3	وُجُوبِ حَلْقٍ
u'وُجُوبٌ حَمْلٌ':Added, #1: 1	وُجُوبَ الْحَمْدِ
u'وُجُوبٌ حَمْلٌ':Added, #1: 1	وُجُوبَ حَمْلِ
u'وُجُوبٌ حَمْلٌ':Added, #1: 1	وُجُوبَ حَمْلِهِ
u'وُجُوبٌ حَمْلٌ':Added, #2: 2	وُجُوبِ حَمْلِهِ
u'وُجُوبٌ حَيْضَةٌ':Added, #3: 3	وُجُوبِ حَمْلِ
u'وُجُوبٌ حَيْلُولَةٌ':Added, #1: 1	وُجُوبُ الْحَيْضَةِ
u'وُجُوبٌ ختان':Added, #1: 1	وُجُوبُ الْحَيْلُولَةِ
u'وُجُوبٌ خِتَانٌ':Added, #1: 1	وُجُوبُ الْخِتَانِ
u'وُجُوبٌ خدمة':Added, #1: 1	وُجُوبُ الْخِتَانِ
u'وُجُوبٌ خِدْمَةٌ':Added, #2: 2	وُجُوبُ الْخِدْمَةِ
u'وُجُوبٌ خراج':Added, #2: 2	وُجُوبُ الْخِدْمَةِ
u'وُجُوبٌ خَرَاجٌ':Added, #2: 2	وُجُوبُ الْخَرَاجِ
u'وُجُوبٌ خراج':Added, #2: 2	وُجُوبُ الْخَرَاجِ
u'وُجُوبٌ خَرَاجٌ':Added, #4: 4	وُجُوبَ الْخَرَاجِ
u'وُجُوبٌ خراج':Added, #4: 4	وُجُوبَ الْخَرَاجِ
u'وُجُوبٌ خَرَاجٌ':Added, #7: 7	وُجُوبِ الْخَرَاجِ
u'وُجُوبٌ خُرُوجٌ':Added, #7: 7	وُجُوبِ الْخَرَاجِ
u'وُجُوبٌ خطبة':Added, #1: 1	وُجُوبُ الْخُرُوجِ
u'وُجُوبٌ خُطْبَةٌ':Added, #3: 3	وُجُوبِ الْخُطْبَةِ
u'وُجُوبٌ خُفٌّ':Added, #3: 3	وُجُوبِ الْخُطْبَةِ
u'وُجُوبٌ خَلْعٌ':Added, #1: 1	وُجُوبِ الْخُفِّ
u'وُجُوبٌ خَلَفٌ':Added, #2: 2	وُجُوبُ خَلْعِ
u'وُجُوبٌ خُمُسٌ':Added, #1: 1	وُجُوبُ الْخَلَفِ
u'وُجُوبٌ خَمْسٌ':Added, #11: 11	وُجُوبِ الْخُمُسِ
u'وُجُوبٌ خُمْسٌ':Added, #1: 1	وُجُوبَ الْخَمْسِ
u'وُجُوبٌ خُمُسٌ':Added, #1: 1	وُجُوبُ الْخُمْسِ
u'وُجُوبٌ خُمُسٌ':Added, #1: 1	وُجُوبُ خُمُسِ
u'وُجُوبٌ خَمْسٌ':Added, #2: 2	وُجُوبَ الْخُمُسِ
u'وُجُوبٌ دُخُولٌ':Added, #3: 3	وُجُوبِ الْخَمْسِ
u'وُجُوبٌ دُخُولٌ':Added, #1: 1	وُجُوبَ دُخُولِ
u'وُجُوبٌ دَرْء':Added, #1: 1	وُجُوبِ دُخُولِ
u'وُجُوبٌ دَرَاهِمُ':Added, #1: 1	وُجُوبِ دَرْءِ
u'وُجُوبٌ دِرْهَمٌ':Added, #1: 1	وُجُوبِ الدَّرَاهِمِ
u'وُجُوبٌ دِرْهَمٌ':Added, #1: 1	وُجُوبَ دِرْهَمٍ
u'وُجُوبٌ دِرْهَم':Added, #1: 1	وُجُوبِ دِرْهَمٍ
u'وُجُوبٌ دِرْهَم':Added, #1: 1	وُجُوبَ دِرْهَمٍ
u'وُجُوبٌ دِرْهَمٌ':Added, #1: 1	وُجُوبِ دِرْهَمٍ
u'وُجُوبٌ دِرْهَم':Added, #3: 3	وُجُوبُ دِرْهَمٍ
u'وُجُوبٌ دُعَاءٌ':Added, #3: 3	وُجُوبُ دِرْهَمٍ
u'وُجُوبٌ دفع':Added, #1: 1	وُجُوبِ دُعَاءِ
u'وُجُوبٌ دَفْعٌ':Added, #1: 1	وُجُوبَ الدَّفْعِ
u'وُجُوبٌ دفع':Added, #1: 1	وُجُوبَ الدَّفْعِ
u'وُجُوبٌ دَفْعٌ':Added, #2: 2	وُجُوبَ دَفْعِهِ
u'وُجُوبٌ دفع':Added, #2: 2	وُجُوبَ دَفْعِهِ
u'وُجُوبٌ دفع':Added, #4: 4	وُجُوبُ دَفْعِ
u'وُجُوبٌ دَفْعٌ':Added, #4: 4	وُجُوبِ دَفْعِ
u'وُجُوبٌ دَفْعٌ':Added, #4: 4	وُجُوبُ دَفْعِ
u'وُجُوبٌ دفع':Added, #4: 4	وُجُوبِ دَفْعِ
u'وُجُوبٌ دَفْعٌ':Added, #5: 5	وُجُوبَ دَفْعِ
u'وُجُوبٌ دفع':Added, #5: 5	وُجُوبَ دَفْعِ
u'وُجُوبٌ دَفْعٌ':Added, #7: 7	وُجُوبُ الدَّفْعِ
u'وُجُوبٌ دفع':Added, #7: 7	وُجُوبُ الدَّفْعِ
u'وُجُوبٌ دَفْعٌ':Added, #9: 9	وُجُوبِ الدَّفْعِ
u'وُجُوبٌ دفن':Added, #9: 9	وُجُوبِ الدَّفْعِ
u'وُجُوبٌ دفن':Added, #1: 1	وُجُوبُ الدَّفْنِ
u'وُجُوبٌ دَفْنٌ':Added, #1: 1	وُجُوبِ الدَّفْنِ
u'وُجُوبٌ دَفْنٌ':Added, #1: 1	وُجُوبُ الدَّفْنِ
u'وُجُوبٌ دفن':Added, #1: 1	وُجُوبِ الدَّفْنِ
u'وُجُوبٌ دفن':Added, #1: 1	وُجُوبُ دَفْنِهِ
u'وُجُوبٌ دَفْنٌ':Added, #1: 1	وُجُوبِ دَفْنِهِ
u'وُجُوبٌ دَفْنٌ':Added, #1: 1	وُجُوبُ دَفْنِهِ
u'وُجُوبٌ دلك':Added, #1: 1	وُجُوبِ دَفْنِهِ
u'وُجُوبٌ دَلْكٌ':Added, #1: 1	وُجُوبَ الدَّلْكِ
u'وُجُوبٌ دَمٌ':Added, #1: 1	وُجُوبَ الدَّلْكِ
u'وُجُوبٌ دَمٌ':Added, #1: 1	وُجُوبَ الدَّمَيْنِ
u'وُجُوبٌ دَمٌ':Added, #1: 1	وُجُوبُ الدَّمَيْنِ
u'وُجُوبٌ دَمٌ':Added, #1: 1	وُجُوبُ دَمِ
u'وُجُوبٌ دَمٌ':Added, #1: 1	وُجُوبِ دَمِ
u'وُجُوبٌ دَمٌ':Added, #2: 2	وُجُوبِ دَمٍ
u'وُجُوبٌ دَمٌ':Added, #34: 34	وُجُوبِ الدَّمِ
u'وُجُوبٌ دَمٌ':Added, #6: 6	وُجُوبَ الدَّمِ
u'وُجُوبٌ دِماءٌ':Added, #8: 8	وُجُوبُ الدَّمِ
u'وُجُوبٌ دُهْنٌ':Added, #1: 1	وُجُوبِ الدِّمَاءِ
u'وُجُوبٌ دَواءٌ':Added, #1: 1	وُجُوبِ الدُّهْنِ
u'وُجُوبٌ دِيَةٌ':Added, #1: 1	وُجُوبِ الدَّوَاءِ
u'وُجُوبٌ دِيَةٌ':Added, #10: 10	وُجُوبَ الدِّيَةِ
u'وُجُوبٌ دِيَةٌ':Added, #17: 17	وُجُوبُ الدِّيَةِ
u'وُجُوبٌ دِيَةٌ':Added, #1: 1	وُجُوبُ دِيَةٍ
u'وُجُوبٌ دِيَةٌ':Added, #1: 1	وُجُوبِ دِيَةِ
u'وُجُوبٌ دِيَةٌ':Added, #26: 26	وُجُوبِ الدِّيَةِ
u'وُجُوبٌ دِيَةٌ':Added, #2: 2	وُجُوبَ دِيَةِ
u'وُجُوبٌ دَيْنٌ':Added, #2: 2	وُجُوبُ دِيَةِ
u'وُجُوبٌ دَيْنٌ':Added, #20: 20	وُجُوبِ الدَّيْنِ
u'وُجُوبٌ دَيْنٌ':Added, #4: 4	وُجُوبَ الدَّيْنِ
u'وُجُوبٌ ذَكاةٌ':Added, #8: 8	وُجُوبُ الدَّيْنِ
u'وُجُوبٌ ذكر':Added, #1: 1	وُجُوبُ الذَّكَاةِ
u'وُجُوبٌ ذِكْرٌ':Added, #2: 2	وُجُوبِ ذِكْرِ
u'وُجُوبٌ رائِجٌ':Added, #2: 2	وُجُوبِ ذِكْرِ
u'وُجُوبٌ رَبْطٌ':Added, #1: 1	وُجُوبِ رَائِجَةٍ
u'وُجُوبٌ رُبْعٌ':Added, #1: 1	وُجُوبَ رَبْطِ
u'وُجُوبٌ رُبْعٌ':Added, #1: 1	وُجُوبُ رُبْعِ
u'وُجُوبٌ رَجْمٌ':Added, #1: 1	وُجُوبِ رُبْعِ
u'وُجُوبٌ رَجْمٌ':Added, #1: 1	وُجُوبُ الرَّجْمِ
u'وُجُوبٌ رَجْمٌ':Added, #1: 1	وُجُوبِ رَجْمِهِ
u'وُجُوبٌ رَجْمٌ':Added, #2: 2	وُجُوبِ رَجْمِ
u'وُجُوبٌ رُجُوعٌ':Added, #3: 3	وُجُوبِ الرَّجْمِ
u'وُجُوبٌ رُجُوعٌ':Added, #1: 1	وُجُوبَ الرُّجُوعِ
u'وُجُوبٌ رُجُوعٌ':Added, #3: 3	وُجُوبُ الرُّجُوعِ
u'وُجُوبٌ رُجُوعٌ':Added, #3: 3	وُجُوبِ رُجُوعِهِ
u'وُجُوبٌ رَدٌّ':Added, #4: 4	وُجُوبِ الرُّجُوعِ
u'وُجُوبٌ رَدٌّ':Added, #15: 15	وُجُوبِ الرَّدِّ
u'وُجُوبٌ رَدٌّ':Added, #17: 17	وُجُوبُ الرَّدِّ
u'وُجُوبٌ رَدٌّ':Added, #1: 1	وُجُوبَ رَدِّ
u'وُجُوبٌ رَدٌّ':Added, #4: 4	وُجُوبِ رَدِّهِ
u'وُجُوبٌ رَدٌّ':Added, #5: 5	وُجُوبُ رَدِّ
u'وُجُوبٌ رَدٌّ':Added, #6: 6	وُجُوبَ الرَّدِّ
u'وُجُوبٌ رِعايَةٌ':Added, #8: 8	وُجُوبِ رَدِّ
u'وُجُوبٌ رَفْعٌ':Added, #2: 2	وُجُوبِ رِعَايَةِ
u'وُجُوبٌ رُكوبٌ':Added, #2: 2	وُجُوبِ رَفْعِ
u'وُجُوبٌ رُكوبٌ':Added, #1: 1	وُجُوبَ رُكُوبِ
u'وُجُوبٌ رُكوعٌ':Added, #1: 1	وُجُوبِ رُكُوبِ
u'وُجُوبٌ رَمْيٌ':Added, #1: 1	وُجُوبِ الرُّكُوعِ
u'وُجُوبٌ زاجِرٌ':Added, #1: 1	وُجُوبِ رَمْيِ
u'وُجُوبٌ زائِدٌ':Added, #3: 3	وُجُوبِ الزَّاجِرِ
u'وُجُوبٌ زائِدٌ':Added, #1: 1	وُجُوبِ الزَّائِدِ
u'وُجُوبٌ زَكاةٌ':Added, #1: 1	وُجُوبَ زَائِدٍ
u'وُجُوبٌ زَكاةٌ':Added, #10: 10	وُجُوبِ زَكَاةِ
u'وُجُوبٌ زَكاةٌ':Added, #154: 154	وُجُوبِ الزَّكَاةِ
u'وُجُوبٌ زَكاةٌ':Added, #1: 1	وُجُوبُ زَكَاةِ
u'وُجُوبٌ زَكاةٌ':Added, #2: 2	وُجُوبِ زَكَاتِهِ
u'وُجُوبٌ زَكاةٌ':Added, #45: 45	وُجُوبُ الزَّكَاةِ
u'وُجُوبٌ زَكاةٌ':Added, #5: 5	وُجُوبَ زَكَاةِ
u'وُجُوبٌ زَكَواتٌ':Added, #85: 85	وُجُوبَ الزَّكَاةِ
u'وُجُوبٌ زِيادَةٌ':Added, #1: 1	وُجُوبِ الزَّكَوَاتِ
u'وُجُوبٌ زِيادَةٌ':Added, #1: 1	وُجُوبَ زِيَادَةٍ
u'وُجُوبٌ زِيادَةٌ':Added, #1: 1	وُجُوبَ زِيَادَةِ
u'وُجُوبٌ زِيادَةٌ':Added, #2: 2	وُجُوبُ الزِّيَادَةِ
u'وُجُوبٌ سَابِقٌ':Added, #2: 2	وُجُوبِ الزِّيَادَةِ
u'وُجُوبٌ سَبَبٌ':Added, #2: 2	وُجُوبٍ سَابِقٍ
u'وُجُوبٌ سَبَبٌ':Added, #1: 1	وُجُوبُ سَبَبِ
u'وُجُوبٌ سَبَبٌ':Added, #1: 1	وُجُوبِ سَبَبٍ
u'وُجُوبٌ سَبَبٌ':Added, #1: 1	وُجُوبِ سَبَبِ
u'وُجُوبٌ سِتٌّ':Added, #9: 9	وُجُوبِ السَّبَبِ
u'وُجُوبٌ سَتْرٌ':Added, #1: 1	وُجُوبُ سِتِّ
u'وُجُوبٌ سَتْرٌ':Added, #1: 1	وُجُوبَ السَّتْرِ
u'وُجُوبٌ سِتْرٌ':Added, #1: 1	وُجُوبُ السَّتْرِ
u'وُجُوبٌ سَتْرٌ':Added, #2: 2	وُجُوبَ السِّتْرِ
u'وُجُوبٌ سَتْرٌ':Added, #2: 2	وُجُوبَ سَتْرِ
u'وُجُوبٌ سَتْرٌ':Added, #2: 2	وُجُوبُ سَتْرِ
u'وُجُوبٌ سَتْرٌ':Added, #6: 6	وُجُوبِ السَّتْرِ
u'وُجُوبٌ سترة':Added, #6: 6	وُجُوبِ سَتْرِ
u'وُجُوبٌ سُتْرَةٌ':Added, #1: 1	وُجُوبِ السُّتْرَةِ
u'وُجُوبٌ سترة':Added, #1: 1	وُجُوبِ السُّتْرَةِ
u'وُجُوبٌ سُتْرَةٌ':Added, #2: 2	وُجُوبَ السُّتْرَةِ
u'وُجُوبٌ سجدة':Added, #2: 2	وُجُوبَ السُّتْرَةِ
u'وُجُوبٌ سَجْدَةٌ':Added, #1: 1	وُجُوبَ السَّجْدَةِ
u'وُجُوبٌ سجدة':Added, #1: 1	وُجُوبَ السَّجْدَةِ
u'وُجُوبٌ سجدة':Added, #1: 1	وُجُوبَ سَجْدَةِ
u'وُجُوبٌ سجدة':Added, #1: 1	وُجُوبُ سَجْدَةِ
u'وُجُوبٌ سَجْدَةٌ':Added, #1: 1	وُجُوبِ سَجْدَةِ
u'وُجُوبٌ سَجْدَةٌ':Added, #1: 1	وُجُوبَ سَجْدَةِ
u'وُجُوبٌ سَجْدَةٌ':Added, #1: 1	وُجُوبُ سَجْدَةِ
u'وُجُوبٌ سجدة':Added, #1: 1	وُجُوبِ سَجْدَةِ
u'وُجُوبٌ سَجْدَةٌ':Added, #3: 3	وُجُوبُ السَّجْدَةِ
u'وُجُوبٌ سجدة':Added, #3: 3	وُجُوبُ السَّجْدَةِ
u'وُجُوبٌ سَجْدَةٌ':Added, #4: 4	وُجُوبِ السَّجْدَةِ
u'وُجُوبٌ سُجُودٌ':Added, #4: 4	وُجُوبِ السَّجْدَةِ
u'وُجُوبٌ سُجُودٌ':Added, #1: 1	وُجُوبَ السُّجُودِ
u'وُجُوبٌ سُجُودٌ':Added, #1: 1	وُجُوبَ سُجُودِ
u'وُجُوبٌ سُجُودٌ':Added, #1: 1	وُجُوبُ سُجُودِ
u'وُجُوبٌ سُجُودٌ':Added, #4: 4	وُجُوبِ سُجُودِ
u'وُجُوبٌ سُجُودٌ':Added, #5: 5	وُجُوبُ السُّجُودِ
u'وُجُوبٌ سَدٌّ':Added, #6: 6	وُجُوبِ السُّجُودِ
u'وُجُوبٌ سَرْجٌ':Added, #1: 1	وُجُوبِ سَدِّ
u'وُجُوبٌ سِعَايَةٌ':Added, #1: 1	وُجُوبِ السَّرْجِ
u'وُجُوبٌ سِعَايَةٌ':Added, #3: 3	وُجُوبِ السِّعَايَةِ
u'وُجُوبٌ سَفَرٌ':Added, #9: 9	وُجُوبَ السِّعَايَةِ
u'وُجُوبٌ سُكُوتٌ':Added, #1: 1	وُجُوبَ السَّفَرِ
u'وُجُوبٌ سلام':Added, #1: 1	وُجُوبَ السُّكُوتِ
u'وُجُوبٌ سَلاَمٌ':Added, #2: 2	وُجُوبِ السَّلَامِ
u'وُجُوبٌ سَلِيمٌ':Added, #2: 2	وُجُوبِ السَّلَامِ
u'وُجُوبٌ سُنَّةٌ':Added, #1: 1	وُجُوبِ السَّلِيمَةِ
u'وُجُوبٌ سنن':Added, #1: 1	وُجُوبَ سُنَّةٍ
u'وُجُوبٌ سنن':Added, #1: 1	وُجُوبُ السُّنَنِ
u'وُجُوبٌ سَهْوٌ':Added, #8: 8	وُجُوبَ السُّنَنِ
u'وُجُوبٌ سَهْوٌ':Added, #1: 1	وُجُوبُ السَّهْوِ
u'وُجُوبٌ سِواكٌ':Added, #1: 1	وُجُوبِ السَّهْوِ
u'وُجُوبٌ سُؤَالٌ':Added, #2: 2	وُجُوبُ السِّوَاكِ
u'وُجُوبٌ سُؤَالٌ':Added, #1: 1	وُجُوبَ سُؤَالِ
u'وُجُوبٌ سُؤَالٌ':Added, #2: 2	وُجُوبَ السُّؤَالِ
u'وُجُوبٌ سُؤَالٌ':Added, #3: 3	وُجُوبُ السُّؤَالِ
u'وُجُوبٌ شَاةٌ':Added, #4: 4	وُجُوبِ السُّؤَالِ
u'وُجُوبٌ شَاةٌ':Added, #1: 1	وُجُوبَ الشَّاةِ
u'وُجُوبٌ شَاةٌ':Added, #1: 1	وُجُوبِ شَاةٍ
u'وُجُوبٌ شَاةٌ':Added, #2: 2	وُجُوبُ شَاةٍ
u'وُجُوبٌ شَاةٌ':Added, #4: 4	وُجُوبِ الشَّاةِ
u'وُجُوبٌ شِرَاءٌ':Added, #5: 5	وُجُوبُ الشَّاةِ
u'وُجُوبٌ شِرَاءٌ':Added, #1: 1	وُجُوبُ الشِّرَاءِ
u'وُجُوبٌ شِرَاءٌ':Added, #1: 1	وُجُوبَ شِرَاءِ
u'وُجُوبٌ شَرْطٌ':Added, #1: 1	وُجُوبُ شِرَاءِ
u'وُجُوبٌ شَرْطٌ':Added, #1: 1	وُجُوبُ الشَّرْطِ
u'وُجُوبٌ شَرْطٌ':Added, #1: 1	وُجُوبِ الشَّرْطِ
u'وُجُوبٌ شَرْطٌ':Added, #1: 1	وُجُوبَ شَرْطٍ
u'وُجُوبٌ شركة':Added, #4: 4	وُجُوبِ شَرْطِ
u'وُجُوبٌ شَرِكَةٌ':Added, #1: 1	وُجُوبُ الشَّرِكَةِ
u'وُجُوبٌ شفعة':Added, #1: 1	وُجُوبُ الشَّرِكَةِ
u'وُجُوبٌ شُفْعَةٌ':Added, #11: 11	وُجُوبِ الشُّفْعَةِ
u'وُجُوبٌ شفعة':Added, #11: 11	وُجُوبِ الشُّفْعَةِ
u'وُجُوبٌ شُفْعَةٌ':Added, #6: 6	وُجُوبُ الشُّفْعَةِ
u'وُجُوبٌ شفعة':Added, #6: 6	وُجُوبُ الشُّفْعَةِ
u'وُجُوبٌ شُفْعَةٌ':Added, #7: 7	وُجُوبَ الشُّفْعَةِ
u'وُجُوبٌ شكر':Added, #7: 7	وُجُوبَ الشُّفْعَةِ
u'وُجُوبٌ شكر':Added, #1: 1	وُجُوبُ الشُّكْرِ
u'وُجُوبٌ شُكْرٌ':Added, #1: 1	وُجُوبِ الشُّكْرِ
u'وُجُوبٌ شُكْرٌ':Added, #1: 1	وُجُوبُ الشُّكْرِ
u'وُجُوبٌ شكر':Added, #1: 1	وُجُوبِ الشُّكْرِ
u'وُجُوبٌ شكر':Added, #1: 1	وُجُوبَ شُكْرِ
u'وُجُوبٌ شُكْرٌ':Added, #1: 1	وُجُوبُ شُكْرِ
u'وُجُوبٌ شُكْرٌ':Added, #1: 1	وُجُوبَ شُكْرِ
u'وُجُوبٌ شكر':Added, #1: 1	وُجُوبُ شُكْرِ
u'وُجُوبٌ شُكْرٌ':Added, #1: 1	وُجُوبِ شُكْرِهِ
u'وُجُوبٌ شكر':Added, #1: 1	وُجُوبِ شُكْرِهِ
u'وُجُوبٌ شُكْرٌ':Added, #4: 4	وُجُوبِ شُكْرِ
u'وُجُوبٌ شَيْءٌ':Added, #4: 4	وُجُوبِ شُكْرِ
u'وُجُوبٌ شَيْءٌ':Added, #15: 15	وُجُوبِ شَيْءٍ
u'وُجُوبٌ شَيْءٌ':Added, #1: 1	وُجُوبَ شَيْءٍ
u'وُجُوبٌ شَيْءٌ':Added, #2: 2	وُجُوبَ الشَّيْءِ
u'وُجُوبٌ شَيْءٌ':Added, #3: 3	وُجُوبُ شَيْءٍ
u'وُجُوبٌ صَاعٌ':Added, #4: 4	وُجُوبِ الشَّيْءِ
u'وُجُوبٌ صَاعٌ':Added, #1: 1	وُجُوبَ الصَّاعِ
u'وُجُوبٌ صَاعٌ':Added, #1: 1	وُجُوبِ الصَّاعَيْنِ
u'وُجُوبٌ صَاعٌ':Added, #1: 1	وُجُوبِ صَاعٍ
u'وُجُوبٌ صَبٌّ':Added, #2: 2	وُجُوبُ الصَّاعِ
u'وُجُوبٌ صُبْحٌ':Added, #1: 1	وُجُوبِ الصَّبِّ
u'وُجُوبٌ صداق':Added, #1: 1	وُجُوبِ الصُّبْحِ
u'وُجُوبٌ صداق':Added, #1: 1	وُجُوبَ الصَّدَاقِ
u'وُجُوبٌ صداق':Added, #1: 1	وُجُوبُ الصَّدَاقِ
u'وُجُوبٌ صَدَاقٌ':Added, #1: 1	وُجُوبِ الصَّدَاقِ
u'وُجُوبٌ صَدَاقٌ':Added, #1: 1	وُجُوبَ الصَّدَاقِ
u'وُجُوبٌ صَدَاقٌ':Added, #1: 1	وُجُوبُ الصَّدَاقِ
u'وُجُوبٌ صدقة':Added, #1: 1	وُجُوبِ الصَّدَاقِ
u'وُجُوبٌ صَدَقَةٌ':Added, #1: 1	وُجُوبَ صَدَقَةِ
u'وُجُوبٌ صدقة':Added, #1: 1	وُجُوبَ صَدَقَةِ
u'وُجُوبٌ صَدَقَةٌ':Added, #3: 3	وُجُوبَ الصَّدَقَةِ
u'وُجُوبٌ صدقة':Added, #3: 3	وُجُوبَ الصَّدَقَةِ
u'وُجُوبٌ صَدَقَةٌ':Added, #3: 3	وُجُوبُ صَدَقَةِ
u'وُجُوبٌ صدقة':Added, #3: 3	وُجُوبُ صَدَقَةِ
u'وُجُوبٌ صَدَقَةٌ':Added, #4: 4	وُجُوبِ الصَّدَقَةِ
u'وُجُوبٌ صدقة':Added, #4: 4	وُجُوبِ الصَّدَقَةِ
u'وُجُوبٌ صَدَقَةٌ':Added, #5: 5	وُجُوبِ صَدَقَةِ
u'وُجُوبٌ صدقة':Added, #5: 5	وُجُوبِ صَدَقَةِ
u'وُجُوبٌ صَدَقَةٌ':Added, #6: 6	وُجُوبُ الصَّدَقَةِ
u'وُجُوبٌ صَرْفٌ':Added, #6: 6	وُجُوبُ الصَّدَقَةِ
u'وُجُوبٌ صَرْف':Added, #1: 1	وُجُوبِ الصَّرْفِ
u'وُجُوبٌ صَلاَةٌ':Added, #1: 1	وُجُوبِ الصَّرْفِ
u'وُجُوبٌ صَلاَةٌ':Added, #11: 11	وُجُوبَ الصَّلَاةِ
u'وُجُوبٌ صَلاَةٌ':Added, #1: 1	وُجُوبُ الصَّلاَةِ
u'وُجُوبٌ صَلاَةٌ':Added, #1: 1	وُجُوبِ الصَّلاَةِ
u'وُجُوبٌ صَلاَةٌ':Added, #1: 1	وُجُوبُ صَلَاةٍ
u'وُجُوبٌ صَلاَةٌ':Added, #1: 1	وُجُوبُ صَلَاةِ
u'وُجُوبٌ صَلاَةٌ':Added, #22: 22	وُجُوبُ الصَّلَاةِ
u'وُجُوبٌ صَلاَةٌ':Added, #2: 2	وُجُوبِ صَلَاةِ
u'وُجُوبٌ صِلَةٌ':Added, #34: 34	وُجُوبِ الصَّلَاةِ
u'وُجُوبٌ صِلَةٌ':Added, #1: 1	وُجُوبُ الصِّلَةِ
u'وُجُوبٌ صِلَةٌ':Added, #1: 1	وُجُوبِ صِلَةِ
u'وُجُوبٌ صَلَوَاتٌ':Added, #2: 2	وُجُوبَ الصِّلَةِ
u'وُجُوبٌ صَوْمٌ':Added, #1: 1	وُجُوبَ الصَّلَوَاتِ
u'وُجُوبٌ صَوْمٌ':Added, #11: 11	وُجُوبُ الصَّوْمِ
u'وُجُوبٌ صَوْمٌ':Added, #11: 11	وُجُوبِ صَوْمِ
u'وُجُوبٌ صَوْمٌ':Added, #15: 15	وُجُوبَ الصَّوْمِ
u'وُجُوبٌ صَوْمٌ':Added, #18: 18	وُجُوبِ الصَّوْمِ
u'وُجُوبٌ صَوْمٌ':Added, #1: 1	وُجُوبُ صَوْمِ
u'وُجُوبٌ صَوْمٌ':Added, #1: 1	وُجُوبَ صَوْمِهِ
u'وُجُوبٌ صَوْمٌ':Added, #2: 2	وُجُوبَ صَوْمِ
u'وُجُوبٌ صِيَامٌ':Added, #3: 3	وُجُوبِ صَوْمِهِ
u'وُجُوبٌ صِيَامٌ':Added, #1: 1	وُجُوبُ الصِّيَامِ
u'وُجُوبٌ صِيَانَةٌ':Added, #1: 1	وُجُوبِ الصِّيَامِ
u'وُجُوبٌ صِيَانَةٌ':Added, #1: 1	وُجُوبِ الصِّيَانَةِ
u'وُجُوبٌ صِيَانَةٌ':Added, #1: 1	وُجُوبَ صِيَانَةِ
u'وُجُوبٌ صِيغَةٌ':Added, #3: 3	وُجُوبِ صِيَانَتِهِ
u'وُجُوبٌ ضَرْبٌ':Added, #1: 1	وُجُوبِ الصِّيغَةِ
u'وُجُوبٌ ضَرْبٌ':Added, #1: 1	وُجُوبَ الضَّرْبَتَيْنِ
u'وُجُوبٌ ضَمٌّ':Added, #1: 1	وُجُوبَ ضَرْبِ
u'وُجُوبٌ ضَمٌّ':Added, #1: 1	وُجُوبَ الضَّمِّ
u'وُجُوبٌ ضَمٌّ':Added, #1: 1	وُجُوبُ ضَمِّ
u'وُجُوبٌ ضَمَانٌ':Added, #1: 1	وُجُوبِ ضَمِّ
u'وُجُوبٌ ضَمَانٌ':Added, #30: 30	وُجُوبَ الضَّمَانِ
u'وُجُوبٌ ضَمَانٌ':Added, #37: 37	وُجُوبُ الضَّمَانِ
u'وُجُوبٌ ضَمَانٌ':Added, #3: 3	وُجُوبِ ضَمَانِهِ
u'وُجُوبٌ ضَمَانٌ':Added, #4: 4	وُجُوبِ ضَمَانِ
u'وُجُوبٌ ضَمَانٌ':Added, #53: 53	وُجُوبِ الضَّمَانِ
u'وُجُوبٌ ضِيَافَةٌ':Added, #5: 5	وُجُوبَ ضَمَانِ
u'وُجُوبٌ طَاعَةٌ':Added, #1: 1	وُجُوبِ الضِّيَافَةِ
u'وُجُوبٌ طَاعَةٌ':Added, #1: 1	وُجُوبَ الطَّاعَاتِ
u'وُجُوبٌ طَاعَةٌ':Added, #1: 1	وُجُوبُ الطَّاعَةِ
u'وُجُوبٌ طَاعَةٌ':Added, #1: 1	وُجُوبِ طَاعَةِ
u'وُجُوبٌ طَاعَةٌ':Added, #1: 1	وُجُوبُ طَاعَتِهِ
u'وُجُوبٌ طَاعَةٌ':Added, #2: 2	وُجُوبُ طَاعَةِ
u'وُجُوبٌ طَاعَةٌ':Added, #2: 2	وُجُوبِ طَاعَتِهِ
u'وُجُوبٌ طَاعَةٌ':Added, #3: 3	وُجُوبِ الطَّاعَةِ
u'وُجُوبٌ طَاعَةٌ':Added, #3: 3	وُجُوبَ طَاعَتِهِ
u'وُجُوبٌ طَاعَةٌ':Added, #5: 5	وُجُوبَ الطَّاعَةِ
u'وُجُوبٌ طعام':Added, #7: 7	وُجُوبَ طَاعَةِ
u'وُجُوبٌ طَعَامٌ':Added, #1: 1	وُجُوبِ الطَّعَامِ
u'وُجُوبٌ طلب':Added, #1: 1	وُجُوبِ الطَّعَامِ
u'وُجُوبٌ طَلَبٌ':Added, #1: 1	وُجُوبُ الطَّلَبِ
u'وُجُوبٌ طلب':Added, #1: 1	وُجُوبُ الطَّلَبِ
u'وُجُوبٌ طَلَبٌ':Added, #2: 2	وُجُوبِ الطَّلَبِ
u'وُجُوبٌ طلب':Added, #2: 2	وُجُوبِ الطَّلَبِ
u'وُجُوبٌ طَلَبٌ':Added, #2: 2	وُجُوبِ طَلَبِ
u'وُجُوبٌ طُمَأْنِينَةٌ':Added, #2: 2	وُجُوبِ طَلَبِ
u'وُجُوبٌ طُمَأْنِينَةٌ':Added, #1: 1	وُجُوبُ الطُّمَأْنِينَةِ
u'وُجُوبٌ طَهَارَةٌ':Added, #1: 1	وُجُوبِ الطُّمَأْنِينَةِ
u'وُجُوبٌ طِهَارَةٌ':Added, #1: 1	وُجُوبِ الطّهَارَةِ
u'وُجُوبٌ طَهَارَةٌ':Added, #1: 1	وُجُوبِ الطّهَارَةِ
u'وُجُوبٌ طَهَارَةٌ':Added, #4: 4	وُجُوبُ الطَّهَارَةِ
u'وُجُوبٌ طهر':Added, #6: 6	وُجُوبِ الطَّهَارَةِ
u'وُجُوبٌ طُهْرٌ':Added, #1: 1	وُجُوبَ الطُّهْرِ
u'وُجُوبٌ طواف':Added, #1: 1	وُجُوبَ الطُّهْرِ
u'وُجُوبٌ طواف':Added, #1: 1	وُجُوبَ طَوَافِ
u'وُجُوبٌ طواف':Added, #1: 1	وُجُوبُ طَوَافِ
u'وُجُوبٌ طَوَافٌ':Added, #1: 1	وُجُوبِ طَوَافِ
u'وُجُوبٌ طَوَافٌ':Added, #1: 1	وُجُوبَ طَوَافِ
u'وُجُوبٌ طَوَافٌ':Added, #1: 1	وُجُوبُ طَوَافِ
u'وُجُوبٌ طواف':Added, #1: 1	وُجُوبِ طَوَافِ
u'وُجُوبٌ طَوَافٌ':Added, #2: 2	وُجُوبِ الطَّوَافِ
u'وُجُوبٌ ظُهْرٌ':Added, #2: 2	وُجُوبِ الطَّوَافِ
u'وُجُوبٌ ظُهْرٌ':Added, #1: 1	وُجُوبُ الظُّهْرِ
u'وُجُوبٌ عَادَةٌ':Added, #2: 2	وُجُوبَ الظُّهْرِ
u'وُجُوبٌ عَارِضٌ':Added, #1: 1	وُجُوبِ الْعَادَةِ
u'وُجُوبٌ عارِيَّةٌ':Added, #1: 1	وُجُوبِ الْعَارِضِ
u'وُجُوبٌ عِبَادَةٌ':Added, #1: 1	وُجُوبُ عَارِيَّةِ
u'وُجُوبٌ عِبَادَةٌ':Added, #1: 1	وُجُوبُ الْعِبَادَاتِ
u'وُجُوبٌ عِبَادَةٌ':Added, #1: 1	وُجُوبِ الْعِبَادَاتِ
u'وُجُوبٌ عِبَادَةٌ':Added, #1: 1	وُجُوبُ الْعِبَادَةِ
u'وُجُوبٌ عَبْدٌ':Added, #2: 2	وُجُوبِ الْعِبَادَةِ
u'وُجُوبٌ عتق':Added, #1: 1	وُجُوبَ عَبْدٍ
u'وُجُوبٌ عِتْقٌ':Added, #1: 1	وُجُوبَ الْعِتْقِ
u'وُجُوبٌ عتق':Added, #1: 1	وُجُوبَ الْعِتْقِ
u'وُجُوبٌ عِتْقٌ':Added, #2: 2	وُجُوبُ الْعِتْقِ
u'وُجُوبٌ عَدٌّ':Added, #2: 2	وُجُوبُ الْعِتْقِ
u'وُجُوبٌ عِدٌّ':Added, #1: 1	وُجُوبُ عَدِّ
u'وُجُوبٌ عِدَّةٌ':Added, #1: 1	وُجُوبِ عِدَّتَيْنِ
u'وُجُوبٌ عِدَّةٌ':Added, #17: 17	وُجُوبَ الْعِدَّةِ
u'وُجُوبٌ عِدَّةٌ':Added, #2: 2	وُجُوبِ عِدَّةِ
u'وُجُوبٌ عِدَّةٌ':Added, #38: 38	وُجُوبِ الْعِدَّةِ
u'وُجُوبٌ عَدَدٌ':Added, #8: 8	وُجُوبُ الْعِدَّةِ
u'وُجُوبٌ عَدْلٌ':Added, #1: 1	وُجُوبُ الْعَدَدِ
u'وُجُوبٌ عَدْلٌ':Added, #1: 1	وُجُوبُ الْعَدْلِ
u'وُجُوبٌ عَدْلٌ':Added, #2: 2	وُجُوبَ الْعَدْلِ
u'وُجُوبٌ عَدَمٌ':Added, #2: 2	وُجُوبِ الْعَدْلِ
u'وُجُوبٌ عَرَضٌ':Added, #1: 1	وُجُوبِ عَدَمِهِ
u'وُجُوبٌ عَرْضٌ':Added, #1: 1	وُجُوبَ عَرَضٍ
u'وُجُوبٌ عَرْضٌ':Added, #1: 1	وُجُوبُ عَرْضِ
u'وُجُوبٌ عَزْمٌ':Added, #1: 1	وُجُوبِ عَرْضِهِ
u'وُجُوبٌ عَزْمٌ':Added, #2: 2	وُجُوبُ الْعَزْمِ
u'وُجُوبٌ عَزِيمَةٌ':Added, #3: 3	وُجُوبِ الْعَزْمِ
u'وُجُوبٌ عُشْرٌ':Added, #1: 1	وُجُوبُ عَزِيمَةٍ
u'وُجُوبٌ عُشْرٌ':Added, #10: 10	وُجُوبُ الْعُشْرِ
u'وُجُوبٌ عُشْرٌ':Added, #12: 12	وُجُوبَ الْعُشْرِ
u'وُجُوبٌ عُشْرٌ':Added, #17: 17	وُجُوبِ الْعُشْرِ
u'وُجُوبٌ عُشْرٌ':Added, #1: 1	وُجُوبَ عُشْرِ
u'وُجُوبٌ عِصْمَةٌ':Added, #1: 1	وُجُوبِ عُشْرِ
u'وُجُوبٌ عقر':Added, #1: 1	وُجُوبِ الْعِصْمَةِ
u'وُجُوبٌ عقر':Added, #1: 1	وُجُوبُ الْعُقْرِ
u'وُجُوبٌ عُقْرٌ':Added, #1: 1	وُجُوبِ الْعُقْرِ
u'وُجُوبٌ عُقْرٌ':Added, #1: 1	وُجُوبُ الْعُقْرِ
u'وُجُوبٌ عَقْلٌ':Added, #1: 1	وُجُوبِ الْعُقْرِ
u'وُجُوبٌ عَقْلٌ':Added, #1: 1	وُجُوبَ الْعَقْلِ
u'وُجُوبٌ عُقُوبَةٌ':Added, #1: 1	وُجُوبُ الْعَقْلِ
u'وُجُوبٌ عَقِيقَةٌ':Added, #1: 1	وُجُوبَ الْعُقُوبَةِ
u'وُجُوبٌ علم':Added, #1: 1	وُجُوبَ الْعَقِيقَةِ
u'وُجُوبٌ علم':Added, #1: 1	وُجُوبُ الْعِلْمِ
u'وُجُوبٌ عِلْمٌ':Added, #1: 1	وُجُوبِ الْعِلْمِ
u'وُجُوبٌ عِلْمٌ':Added, #1: 1	وُجُوبُ الْعِلْمِ
u'وُجُوبٌ عِمَارَةٌ':Added, #1: 1	وُجُوبِ الْعِلْمِ
u'وُجُوبٌ عمرة':Added, #1: 1	وُجُوبِ الْعِمَارَةِ
u'وُجُوبٌ عُمْرَةٌ':Added, #1: 1	وُجُوبُ الْعُمْرَةِ
u'وُجُوبٌ عمرة':Added, #1: 1	وُجُوبُ الْعُمْرَةِ
u'وُجُوبٌ عُمْرَةٌ':Added, #2: 2	وُجُوبَ الْعُمْرَةِ
u'وُجُوبٌ عمرة':Added, #2: 2	وُجُوبَ الْعُمْرَةِ
u'وُجُوبٌ عُمْرَةٌ':Added, #7: 7	وُجُوبِ الْعُمْرَةِ
u'وُجُوبٌ عَمَلٌ':Added, #7: 7	وُجُوبِ الْعُمْرَةِ
u'وُجُوبٌ عَمَلٌ':Added, #12: 12	وُجُوبَ الْعَمَلِ
u'وُجُوبٌ عَمَلٌ':Added, #1: 1	وُجُوبَ عَمَلِ
u'وُجُوبٌ عَمَلٌ':Added, #1: 1	وُجُوبُ عَمَلِ
u'وُجُوبٌ عَمَلٌ':Added, #1: 1	وُجُوبِ عَمَلِ
u'وُجُوبٌ عَمَلٌ':Added, #26: 26	وُجُوبُ الْعَمَلِ
u'وُجُوبٌ عُمُومٌ':Added, #49: 49	وُجُوبِ الْعَمَلِ
u'وُجُوبٌ عَهْدٌ':Added, #1: 1	وُجُوبَ عُمُومِ
u'وُجُوبٌ عُهْدَةٌ':Added, #1: 1	وُجُوبِ الْعَهْدِ
u'وُجُوبٌ عَوْدٌ':Added, #1: 1	وُجُوبِ الْعُهْدَةِ
u'وُجُوبٌ عَوْدٌ':Added, #1: 1	وُجُوبَ الْعَوْدِ
u'وُجُوبٌ عِوَضٌ':Added, #1: 1	وُجُوبِ الْعَوْدِ
u'وُجُوبٌ عِوَضٌ':Added, #1: 1	وُجُوبِ الْعِوَضِ
u'وُجُوبٌ عِوَضٌ':Added, #1: 1	وُجُوبَ عِوَضٍ
u'وُجُوبٌ عين':Added, #2: 2	وُجُوبُ الْعِوَضِ
u'وُجُوبٌ عَيْنٌ':Added, #1: 1	وُجُوبِ عَيْنِ
u'وُجُوبٌ عَيْنٌ':Added, #1: 1	وُجُوبَ عَيْنٍ
u'وُجُوبٌ عَيْن':Added, #1: 1	وُجُوبِ عَيْنِ
u'وُجُوبٌ عَيْن':Added, #1: 1	وُجُوبَ عَيْنٍ
u'وُجُوبٌ غُرَّةٌ':Added, #1: 1	وُجُوبِ عَيْنِ
u'وُجُوبٌ غُرَّةٌ':Added, #1: 1	وُجُوب الْغُرَّةِ
u'وُجُوبٌ غُرَّةٌ':Added, #1: 1	وُجُوبِ الْغُرَّةِ
u'وُجُوبٌ غُرْمٌ':Added, #2: 2	وُجُوبُ الْغُرَّةِ
u'وُجُوبٌ غُسْلٌ':Added, #2: 2	وُجُوبِ الْغُرْمِ
u'وُجُوبٌ غَسْلٌ':Added, #12: 12	وُجُوبَ الْغُسْلِ
u'وُجُوبٌ غَسْلٌ':Added, #14: 14	وُجُوبُ غَسْلِ
u'وُجُوبٌ غُسْلٌ':Added, #19: 19	وُجُوبِ غَسْلِ
u'وُجُوبٌ غَسْلٌ':Added, #1: 1	وُجُوبَ غُسْلِ
u'وُجُوبٌ غُسْلٌ':Added, #1: 1	وُجُوبَ غَسْلِهِ
u'وُجُوبٌ غُسْلٌ':Added, #1: 1	وُجُوبَ غُسْلِهِ
u'وُجُوبٌ غُسْلٌ':Added, #26: 26	وُجُوبُ الْغُسْلِ
u'وُجُوبٌ غَسْلٌ':Added, #2: 2	وُجُوبُ غُسْلِ
u'وُجُوبٌ غَسْلٌ':Added, #3: 3	وُجُوبَ الْغَسْلِ
u'وُجُوبٌ غَسْلٌ':Added, #3: 3	وُجُوبُ الْغَسْلِ
u'وُجُوبٌ غُسْلٌ':Added, #3: 3	وُجُوبِ غَسْلِهِ
u'وُجُوبٌ غَسْلٌ':Added, #46: 46	وُجُوبِ الْغُسْلِ
u'وُجُوبٌ غَسْلٌ':Added, #4: 4	وُجُوبِ الْغَسْلِ
u'وُجُوبٌ غَسْلٌ':Added, #4: 4	وُجُوبَ غَسْلِ
u'وُجُوبٌ غُسْلٌ':Added, #5: 5	وُجُوبُ غَسْلِهِ
u'وُجُوبٌ غَضٌّ':Added, #6: 6	وُجُوبِ غُسْلِ
u'وُجُوبٌ غَضٌّ':Added, #1: 1	وُجُوبُ غَضِّ
u'وُجُوبٌ غَلَّةٌ':Added, #1: 1	وُجُوبِ غَضِّ
u'وُجُوبٌ غير':Added, #1: 1	وُجُوبِ الْغَلَّةِ
u'وُجُوبٌ غير':Added, #1: 1	وُجُوبَ الْغَيْرِ
u'وُجُوبٌ غَيْرٌ':Added, #1: 1	وُجُوبِ الْغَيْرِ
u'وُجُوبٌ غَيْرٌ':Added, #1: 1	وُجُوبَ الْغَيْرِ
u'وُجُوبٌ غير':Added, #1: 1	وُجُوبِ الْغَيْرِ
u'وُجُوبٌ غير':Added, #1: 1	وُجُوبَ غَيْرِهِ
u'وُجُوبٌ غَيْرٌ':Added, #1: 1	وُجُوبِ غَيْرِهِ
u'وُجُوبٌ غَيْرٌ':Added, #1: 1	وُجُوبَ غَيْرِهِ
u'وُجُوبٌ فاء':Added, #1: 1	وُجُوبِ غَيْرِهِ
u'وُجُوبٌ فَاتِحٌ':Added, #1: 1	وُجُوبِ الْفَاءِ
u'وُجُوبٌ فَاتِحٌ':Added, #1: 1	وُجُوبَ الْفَاتِحَةِ
u'وُجُوبٌ فَاتِحٌ':Added, #2: 2	وُجُوبُ الْفَاتِحَةِ
u'وُجُوبٌ فَاتِحَةٌ':Added, #4: 4	وُجُوبِ الْفَاتِحَةِ
u'وُجُوبٌ فَاتِحَةٌ':Added, #1: 1	وُجُوبَ الْفَاتِحَةِ
u'وُجُوبٌ فَاتِحَةٌ':Added, #2: 2	وُجُوبُ الْفَاتِحَةِ
u'وُجُوبٌ فَاضِلٌ':Added, #4: 4	وُجُوبِ الْفَاتِحَةِ
u'وُجُوبٌ فَتْحٌ':Added, #1: 1	وُجُوبِ فَاضِلِ
u'وُجُوبٌ فِدَاءٌ':Added, #1: 1	وُجُوبُ الْفَتْحِ
u'وُجُوبٌ فِدْيَةٌ':Added, #1: 1	وُجُوبِ الْفِدَاءِ
u'وُجُوبٌ فِدْيَةٌ':Added, #15: 15	وُجُوبِ الْفِدْيَةِ
u'وُجُوبٌ فِدْيَةٌ':Added, #1: 1	وُجُوبُ فِدْيَةِ
u'وُجُوبٌ فِدْيَةٌ':Added, #2: 2	وُجُوبَ الْفِدْيَةِ
u'وُجُوبٌ فرار':Added, #6: 6	وُجُوبُ الْفِدْيَةِ
u'وُجُوبٌ فِرَارٌ':Added, #1: 1	وُجُوبِ الْفِرَارِ
u'وُجُوبٌ فِرَاشٌ':Added, #1: 1	وُجُوبِ الْفِرَارِ
u'وُجُوبٌ فَرَائِضُ':Added, #1: 1	وُجُوبُ الْفِرَاشِ
u'وُجُوبٌ فَرَائِضُ':Added, #1: 1	وُجُوبِ الْفَرَائِضِ
u'وُجُوبٌ فَسْخٌ':Added, #6: 6	وُجُوبَ الْفَرَائِضِ
u'وُجُوبٌ فَسْخٌ':Added, #1: 1	وُجُوبُ الْفَسْخِ
u'وُجُوبٌ فَسْخٌ':Added, #1: 1	وُجُوبِ فَسْخِهِ
u'وُجُوبٌ فَسْخٌ':Added, #2: 2	وُجُوبَ الْفَسْخِ
u'وُجُوبٌ فِطْرٌ':Added, #2: 2	وُجُوبِ الْفَسْخِ
u'وُجُوبٌ فِطْرٌ':Added, #1: 1	وُجُوبُ الْفِطْرِ
u'وُجُوبٌ فطرة':Added, #1: 1	وُجُوبِ الْفِطْرِ
u'وُجُوبٌ فطرة':Added, #2: 2	وُجُوبَ الْفِطْرَةِ
u'وُجُوبٌ فِطْرَةٌ':Added, #2: 2	وُجُوبُ الْفِطْرَةِ
u'وُجُوبٌ فِطْرَةٌ':Added, #2: 2	وُجُوبَ الْفِطْرَةِ
u'وُجُوبٌ فطرة':Added, #2: 2	وُجُوبُ الْفِطْرَةِ
u'وُجُوبٌ فطرة':Added, #2: 2	وُجُوبُ فِطْرَةِ
u'وُجُوبٌ فِطْرَةٌ':Added, #2: 2	وُجُوبِ فِطْرَةِ
u'وُجُوبٌ فِطْرَةٌ':Added, #2: 2	وُجُوبُ فِطْرَةِ
u'وُجُوبٌ فطرة':Added, #2: 2	وُجُوبِ فِطْرَةِ
u'وُجُوبٌ فِطْرَةٌ':Added, #8: 8	وُجُوبِ الْفِطْرَةِ
u'وُجُوبٌ فِعْلٌ':Added, #8: 8	وُجُوبِ الْفِطْرَةِ
u'وُجُوبٌ فِعْلٌ':Added, #1: 1	وُجُوبِ فِعْلٍ
u'وُجُوبٌ فِعْلٌ':Added, #1: 1	وُجُوبِ فِعْلِهِ
u'وُجُوبٌ فِعْلٌ':Added, #3: 3	وُجُوبَ الْفِعْلِ
u'وُجُوبٌ فِعْلٌ':Added, #3: 3	وُجُوبُ الْفِعْلِ
u'وُجُوبٌ فِقْهٌ':Added, #9: 9	وُجُوبِ الْفِعْلِ
u'وُجُوبٌ فَوْرٌ':Added, #1: 1	وُجُوبِ الْفِقْهِ
u'وُجُوبٌ فَوْرٌ':Added, #1: 1	وُجُوبَ الْفَوْرِ
u'وُجُوبٌ فَوْرٌ':Added, #1: 1	وُجُوبُ الْفَوْرِ
u'وُجُوبٌ فَوْر':Added, #1: 1	وُجُوبِ الْفَوْرِ
u'وُجُوبٌ فَوْرَة':Added, #3: 3	وُجُوبِ الْفَوْرِيَّةِ
u'وُجُوبٌ فَوْرِيّ':Added, #3: 3	وُجُوبِ الْفَوْرِيَّةِ
u'وُجُوبٌ قَبْضٌ':Added, #3: 3	وُجُوبِ الْفَوْرِيَّةِ
u'وُجُوبٌ قَبْضٌ':Added, #1: 1	وُجُوبُ الْقَبْضِ
u'وُجُوبٌ قَبْضٌ':Added, #1: 1	وُجُوبِ قَبْضِ
u'وُجُوبٌ قَبْضٌ':Added, #1: 1	وُجُوبُ قَبْضِهِ
u'وُجُوبٌ قَبُولٌ':Added, #2: 2	وُجُوبِ الْقَبْضِ
u'وُجُوبٌ قَبُولٌ':Added, #1: 1	وُجُوبُ قَبُولِهِ
u'وُجُوبٌ قَبُولٌ':Added, #2: 2	وُجُوبِ الْقَبُولِ
u'وُجُوبٌ قَبُولٌ':Added, #2: 2	وُجُوبُ قَبُولِ
u'وُجُوبٌ قَبُولٌ':Added, #2: 2	وُجُوبِ قَبُولِهِ
u'وُجُوبٌ قَبُولٌ':Added, #3: 3	وُجُوبُ الْقَبُولِ
u'وُجُوبٌ قتل':Added, #4: 4	وُجُوبِ قَبُولِ
u'وُجُوبٌ قَتْلٌ':Added, #1: 1	وُجُوبُ الْقَتْلِ
u'وُجُوبٌ قتل':Added, #1: 1	وُجُوبُ الْقَتْلِ
u'وُجُوبٌ قَتْلٌ':Added, #1: 1	وُجُوبُ قَتْلِ
u'وُجُوبٌ قتل':Added, #1: 1	وُجُوبُ قَتْلِ
u'وُجُوبٌ قتل':Added, #1: 1	وُجُوبَ قَتْلِهِ
u'وُجُوبٌ قَتْلٌ':Added, #1: 1	وُجُوبُ قَتْلِهِ
u'وُجُوبٌ قَتْلٌ':Added, #1: 1	وُجُوبَ قَتْلِهِ
u'وُجُوبٌ قتل':Added, #1: 1	وُجُوبُ قَتْلِهِ
u'وُجُوبٌ قَتْلٌ':Added, #2: 2	وُجُوبَ الْقَتْلِ
u'وُجُوبٌ قتل':Added, #2: 2	وُجُوبَ الْقَتْلِ
u'وُجُوبٌ قَتْلٌ':Added, #2: 2	وُجُوبِ قَتْلِ
u'وُجُوبٌ قتل':Added, #2: 2	وُجُوبِ قَتْلِ
u'وُجُوبٌ قَتْلٌ':Added, #5: 5	وُجُوبِ الْقَتْلِ
u'وُجُوبٌ قتل':Added, #5: 5	وُجُوبِ الْقَتْلِ
u'وُجُوبٌ قَتْلٌ':Added, #6: 6	وُجُوبِ قَتْلِهِ
u'وُجُوبٌ قَدْرٌ':Added, #6: 6	وُجُوبِ قَتْلِهِ
u'وُجُوبٌ قَدْرٌ':Added, #1: 1	وُجُوبَ قَدْرِ
u'وُجُوبٌ قدم':Added, #1: 1	وُجُوبِ قَدْرِ
u'وُجُوبٌ قِدَمٌ':Added, #1: 1	وُجُوبِ الْقِدَمِ
u'وُجُوبٌ قِرَاءةٌ':Added, #1: 1	وُجُوبِ الْقِدَمِ
u'وُجُوبٌ قِرَاءةٌ':Added, #1: 1	وُجُوبَ الْقِرَاءَةِ
u'وُجُوبٌ قِرَاءةٌ':Added, #4: 4	وُجُوبُ الْقِرَاءَةِ
u'وُجُوبٌ قِرَانٌ':Added, #8: 8	وُجُوبِ الْقِرَاءَةِ
u'وُجُوبٌ قَسام':Added, #1: 1	وُجُوبُ الْقِرَانِ
u'وُجُوبٌ قَسام':Added, #2: 2	وُجُوبَ الْقَسَامَةِ
u'وُجُوبٌ قَسام':Added, #2: 2	وُجُوبُ الْقَسَامَةِ
u'وُجُوبٌ قَسامَة':Added, #3: 3	وُجُوبِ الْقَسَامَةِ
u'وُجُوبٌ قَسامَة':Added, #2: 2	وُجُوبَ الْقَسَامَةِ
u'وُجُوبٌ قَسامَة':Added, #2: 2	وُجُوبُ الْقَسَامَةِ
u'وُجُوبٌ قِسْطٌ':Added, #3: 3	وُجُوبِ الْقَسَامَةِ
u'وُجُوبٌ قَسَمٌ':Added, #3: 3	وُجُوبِ الْقِسْطِ
u'وُجُوبٌ قَسْمٌ':Added, #1: 1	وُجُوبِ الْقَسَمِ
u'وُجُوبٌ قَسْمٌ':Added, #1: 1	وُجُوبُ الْقَسْمِ
u'وُجُوبٌ قَسْمٌ':Added, #3: 3	وُجُوبَ الْقَسْمِ
u'وُجُوبٌ قصاص':Added, #3: 3	وُجُوبِ الْقَسْمِ
u'وُجُوبٌ قِصَاصٌ':Added, #17: 17	وُجُوبَ الْقِصَاصِ
u'وُجُوبٌ قصاص':Added, #17: 17	وُجُوبَ الْقِصَاصِ
u'وُجُوبٌ قِصَاصٌ':Added, #21: 21	وُجُوبُ الْقِصَاصِ
u'وُجُوبٌ قصاص':Added, #21: 21	وُجُوبُ الْقِصَاصِ
u'وُجُوبٌ قِصَاصٌ':Added, #32: 32	وُجُوبِ الْقِصَاصِ
u'وُجُوبٌ قَصْرٌ':Added, #32: 32	وُجُوبِ الْقِصَاصِ
u'وُجُوبٌ قَضَاءٌ':Added, #1: 1	وُجُوبُ الْقَصْرِ
u'وُجُوبٌ قَضَاءٌ':Added, #1: 1	وُجُوبَ قَضَاءِ
u'وُجُوبٌ قَضَاءٌ':Added, #1: 1	وُجُوبُ قَضَاءٍ
u'وُجُوبٌ قَضَاءٌ':Added, #20: 20	وُجُوبُ الْقَضَاءِ
u'وُجُوبٌ قَضَاءٌ':Added, #23: 23	وُجُوبَ الْقَضَاءِ
u'وُجُوبٌ قَضَاءٌ':Added, #37: 37	وُجُوبِ الْقَضَاءِ
u'وُجُوبٌ قَضَاءٌ':Added, #4: 4	وُجُوبُ قَضَاءِ
u'وُجُوبٌ قَطْعٌ':Added, #9: 9	وُجُوبِ قَضَاءِ
u'وُجُوبٌ قَطْعٌ':Added, #15: 15	وُجُوبِ الْقَطْعِ
u'وُجُوبٌ قَطْعٌ':Added, #1: 1	وُجُوبُ قَطْعِ
u'وُجُوبٌ قَطْعٌ':Added, #1: 1	وُجُوبِ قَطْعِهِ
u'وُجُوبٌ قَطْعٌ':Added, #2: 2	وُجُوبَ قَطْعِ
u'وُجُوبٌ قَطْعٌ':Added, #4: 4	وُجُوبَ الْقَطْعِ
u'وُجُوبٌ قعدة':Added, #8: 8	وُجُوبُ الْقَطْعِ
u'وُجُوبٌ قَعْدَةٌ':Added, #1: 1	وُجُوبِ الْقَعْدَةِ
u'وُجُوبٌ قَوَد':Added, #1: 1	وُجُوبِ الْقَعْدَةِ
u'وُجُوبٌ قَوَد':Added, #12: 12	وُجُوبِ الْقَوَدِ
u'وُجُوبٌ قَوَد':Added, #3: 3	وُجُوبَ الْقَوَدِ
u'وُجُوبٌ قول':Added, #6: 6	وُجُوبُ الْقَوَدِ
u'وُجُوبٌ قول':Added, #1: 1	وُجُوبُ الْقَوْلِ
u'وُجُوبٌ قَوْلٌ':Added, #1: 1	وُجُوبِ الْقَوْلِ
u'وُجُوبٌ قَوْلٌ':Added, #1: 1	وُجُوبُ الْقَوْلِ
u'وُجُوبٌ قول':Added, #1: 1	وُجُوبِ الْقَوْلِ
u'وُجُوبٌ قَوْلٌ':Added, #1: 1	وُجُوبُ قَوْلِهِ
u'وُجُوبٌ قَوْمَةٌ':Added, #1: 1	وُجُوبُ قَوْلِهِ
u'وُجُوبٌ قيام':Added, #1: 1	وُجُوبِ الْقَوْمَةِ
u'وُجُوبٌ قيام':Added, #1: 1	وُجُوبَ الْقِيَامِ
u'وُجُوبٌ قِيَامٌ':Added, #1: 1	وُجُوبُ الْقِيَامِ
u'وُجُوبٌ قِيَامٌ':Added, #1: 1	وُجُوبَ الْقِيَامِ
u'وُجُوبٌ قيام':Added, #1: 1	وُجُوبُ الْقِيَامِ
u'وُجُوبٌ قيام':Added, #1: 1	وُجُوبُ قِيَامِ
u'وُجُوبٌ قِيَامٌ':Added, #1: 1	وُجُوبِ قِيَامِ
u'وُجُوبٌ قِيَامٌ':Added, #1: 1	وُجُوبُ قِيَامِ
u'وُجُوبٌ قيام':Added, #1: 1	وُجُوبِ قِيَامِ
u'وُجُوبٌ قِيَامٌ':Added, #2: 2	وُجُوبِ قِيَامِهِ
u'وُجُوبٌ قيام':Added, #2: 2	وُجُوبِ قِيَامِهِ
u'وُجُوبٌ قِيَامٌ':Added, #4: 4	وُجُوبِ الْقِيَامِ
u'وُجُوبٌ قِيمَةٌ':Added, #4: 4	وُجُوبِ الْقِيَامِ
u'وُجُوبٌ قِيمَةٌ':Added, #13: 13	وُجُوبُ الْقِيمَةِ
u'وُجُوبٌ قِيمَةٌ':Added, #18: 18	وُجُوبِ الْقِيمَةِ
u'وُجُوبٌ قِيمَةٌ':Added, #1: 1	وُجُوب الْقِيمَةِ
u'وُجُوبٌ قِيمَةٌ':Added, #1: 1	وُجُوب قِيمَةِ
u'وُجُوبٌ قِيمَةٌ':Added, #1: 1	وُجُوبَ قِيمَتِهِ
u'وُجُوبٌ قِيمَةٌ':Added, #1: 1	وُجُوبُ قِيمَتِهِ
u'وُجُوبٌ قِيمَةٌ':Added, #2: 2	وُجُوبَ قِيمَةِ
u'وُجُوبٌ قِيمَةٌ':Added, #3: 3	وُجُوبُ قِيمَةِ
u'وُجُوبٌ قِيمَةٌ':Added, #5: 5	وُجُوبَ الْقِيمَةِ
u'وُجُوبٌ كِتَابَةٌ':Added, #6: 6	وُجُوبِ قِيمَةِ
u'وُجُوبٌ كِتَابَةٌ':Added, #1: 1	وُجُوبِ الْكِتَابَةِ
u'وُجُوبٌ كِرَاءٌ':Added, #1: 1	وُجُوبَ كِتَابَةِ
u'وُجُوبٌ كِرَاءٌ':Added, #1: 1	وُجُوبِ الْكِرَاءِ
u'وُجُوبٌ كَسْبٌ':Added, #2: 2	وُجُوبُ الْكِرَاءِ
u'وُجُوبٌ كَسْبٌ':Added, #1: 1	وُجُوب الْكَسْبِ
u'وُجُوبٌ كَشْفٌ':Added, #1: 1	وُجُوبِ الْكَسْبِ
u'وُجُوبٌ كَشْفٌ':Added, #1: 1	وُجُوبِ الْكَشْفِ
u'وُجُوبٌ كَعْبٌ':Added, #1: 1	وُجُوبِ كَشْفِ
u'وُجُوبٌ كَفٌّ':Added, #1: 1	وُجُوبُ الْكَعْبَيْنِ
u'وُجُوبٌ كَفَّارٌ':Added, #1: 1	وُجُوبَ الْكَفِّ
u'وُجُوبٌ كَفَّارٌ':Added, #1: 1	وُجُوبِ الْكَفَّارَاتِ
u'وُجُوبٌ كَفَّارٌ':Added, #1: 1	وُجُوبُ الْكَفَّارَتَيْنِ
u'وُجُوبٌ كَفَّارٌ':Added, #26: 26	وُجُوبَ الْكَفَّارَةِ
u'وُجُوبٌ كَفَّارٌ':Added, #2: 2	وُجُوبَ كَفَّارَةِ
u'وُجُوبٌ كَفَّارٌ':Added, #2: 2	وُجُوبُ كَفَّارَةِ
u'وُجُوبٌ كَفَّارٌ':Added, #38: 38	وُجُوبُ الْكَفَّارَةِ
u'وُجُوبٌ كَفَّارٌ':Added, #4: 4	وُجُوبِ كَفَّارَةِ
u'وُجُوبٌ كَفَّارَةٌ':Added, #61: 61	وُجُوبِ الْكَفَّارَةِ
u'وُجُوبٌ كَفَّارَةٌ':Added, #1: 1	وُجُوبِ الْكَفَّارَاتِ
u'وُجُوبٌ كَفَّارَةٌ':Added, #1: 1	وُجُوبُ كَفَّارَةٍ
u'وُجُوبٌ كَفَّارَةٌ':Added, #26: 26	وُجُوبَ الْكَفَّارَةِ
u'وُجُوبٌ كَفَّارَةٌ':Added, #2: 2	وُجُوبَ كَفَّارَةِ
u'وُجُوبٌ كَفَّارَةٌ':Added, #2: 2	وُجُوبُ كَفَّارَةِ
u'وُجُوبٌ كَفَّارَةٌ':Added, #38: 38	وُجُوبُ الْكَفَّارَةِ
u'وُجُوبٌ كَفَّارَةٌ':Added, #4: 4	وُجُوبِ كَفَّارَةِ
u'وُجُوبٌ كَفَالَةٌ':Added, #61: 61	وُجُوبِ الْكَفَّارَةِ
u'وُجُوبٌ كِفَايَةٌ':Added, #1: 1	وُجُوبِ كَفَالَةِ
u'وُجُوبٌ كِفَايَةٌ':Added, #1: 1	وُجُوبِ الْكِفَايَةِ
u'وُجُوبٌ كِفَايَةٌ':Added, #1: 1	وُجُوبِ كِفَايَةِ
u'وُجُوبٌ كِفَايَةٌ':Added, #1: 1	وُجُوبُ كِفَايَتِهِ
u'وُجُوبٌ كَمَالٌ':Added, #2: 2	وُجُوبَ كِفَايَةٍ
u'وُجُوبٌ كَمَالٌ':Added, #1: 1	وُجُوبَ كَمَالِ
u'وُجُوبٌ كَمَالٌ':Added, #1: 1	وُجُوبُ كَمَالِ
u'وُجُوبٌ كَوْنٌ':Added, #2: 2	وُجُوبِ كَمَالِ
u'وُجُوبٌ كَيْلٌ':Added, #1: 1	وُجُوبَ كَوْنِ
u'وُجُوبٌ كَيْلٌ':Added, #1: 1	وُجُوبَ الْكَيْلَيْنِ
u'وُجُوبٌ لعان':Added, #1: 1	وُجُوبُ الْكَيْلَيْنِ
u'وُجُوبٌ لعان':Added, #3: 3	وُجُوبِ اللِّعَانِ
u'وُجُوبٌ لَفٌّ':Added, #4: 4	وُجُوبَ اللِّعَانِ
u'وُجُوبٌ لَفْظٌ':Added, #1: 1	وُجُوبُ لَفِّ
u'وُجُوبٌ لَفْظٌ':Added, #1: 1	وُجُوبَ اللَّفْظِ
u'وُجُوبٌ مَاءٌ':Added, #1: 1	وُجُوبُ لَفْظٍ
u'وُجُوبٌ مَالٌ':Added, #1: 1	وُجُوبُ الْمَاءِ
u'وُجُوبٌ مَالٌ':Added, #16: 16	وُجُوبَ الْمَالِ
u'وُجُوبٌ مَالٌ':Added, #1: 1	وُجُوبَ مَالِ
u'وُجُوبٌ مَالٌ':Added, #1: 1	وُجُوبِ مَالٍ
u'وُجُوبٌ مَالٌ':Added, #1: 1	وُجُوبُ مَالَيْنِ
u'وُجُوبٌ مَالٌ':Added, #25: 25	وُجُوبِ الْمَالِ
u'وُجُوبٌ مُبَاحٌ':Added, #6: 6	وُجُوبُ الْمَالِ
u'وُجُوبٌ مُبَاحٌ':Added, #1: 1	وُجُوبِ الْمُبَاحِ
u'وُجُوبٌ مُبَادَرَةٌ':Added, #1: 1	وُجُوبَ مُبَاحَاتٍ
u'وُجُوبٌ مُبَادَرَةٌ':Added, #1: 1	وُجُوبَ الْمُبَادَرَةِ
u'وُجُوبٌ مُبَادَرَةٌ':Added, #2: 2	وُجُوبِ الْمُبَادَرَةِ
u'وُجُوبٌ مُبَاشَرَةٌ':Added, #7: 7	وُجُوبُ الْمُبَادَرَةِ
u'وُجُوبٌ مَبِيتٌ':Added, #1: 1	وُجُوبُ مُبَاشَرَتِهِ
u'وُجُوبٌ مُتَابَعٌ':Added, #1: 1	وُجُوبِ الْمَبِيتِ
u'وُجُوبٌ مُتَابَعٌ':Added, #1: 1	وُجُوبِ الْمُتَابَعَةِ
u'وُجُوبٌ مُتَابَعٌ':Added, #1: 1	وُجُوبُ مُتَابَعَةِ
u'وُجُوبٌ مُتَابَعٌ':Added, #1: 1	وُجُوبَ مُتَابَعَتِهِ
u'وُجُوبٌ مُتَابَعٌ':Added, #2: 2	وُجُوبَ الْمُتَابَعَةِ
u'وُجُوبٌ مُتَابَعٌ':Added, #2: 2	وُجُوبُ الْمُتَابَعَةِ
u'وُجُوبٌ مُتَابَعَةٌ':Added, #4: 4	وُجُوبِ مُتَابَعَةِ
u'وُجُوبٌ مُتَابَعَةٌ':Added, #1: 1	وُجُوبِ الْمُتَابَعَةِ
u'وُجُوبٌ مُتَابَعَةٌ':Added, #1: 1	وُجُوبُ مُتَابَعَةِ
u'وُجُوبٌ مُتَابَعَةٌ':Added, #1: 1	وُجُوبَ مُتَابَعَتِهِ
u'وُجُوبٌ مُتَابَعَةٌ':Added, #2: 2	وُجُوبَ الْمُتَابَعَةِ
u'وُجُوبٌ مُتَابَعَةٌ':Added, #2: 2	وُجُوبُ الْمُتَابَعَةِ
u'وُجُوبٌ مُتْعَةٌ':Added, #4: 4	وُجُوبِ مُتَابَعَةِ
u'وُجُوبٌ مُتْعَةٌ':Added, #1: 1	وُجُوبُ الْمُتْعَةِ
u'وُجُوبٌ مُتْعَةٌ':Added, #2: 2	وُجُوبَ الْمُتْعَةِ
u'وُجُوبٌ مثل':Added, #9: 9	وُجُوبِ الْمُتْعَةِ
u'وُجُوبٌ مثل':Added, #1: 1	وُجُوبَ الْمِثْلِ
u'وُجُوبٌ مِثْلٌ':Added, #1: 1	وُجُوبِ الْمِثْلِ
u'وُجُوبٌ مِثْلٌ':Added, #1: 1	وُجُوبَ الْمِثْلِ
u'وُجُوبٌ مثل':Added, #1: 1	وُجُوبِ الْمِثْلِ
u'وُجُوبٌ مِثْلٌ':Added, #1: 1	وُجُوبَ مِثْلِ
u'وُجُوبٌ مثل':Added, #1: 1	وُجُوبَ مِثْلِ
u'وُجُوبٌ مِثْلٌ':Added, #3: 3	وُجُوبُ الْمِثْلِ
u'وُجُوبٌ مثل':Added, #3: 3	وُجُوبُ الْمِثْلِ
u'وُجُوبٌ مِثْلٌ':Added, #3: 3	وُجُوبَ مِثْلِهِ
u'وُجُوبٌ مثل':Added, #3: 3	وُجُوبَ مِثْلِهِ
u'وُجُوبٌ مِثْلٌ':Added, #4: 4	وُجُوبِ مِثْلِهِ
u'وُجُوبٌ مَجَازِيٌّ':Added, #4: 4	وُجُوبِ مِثْلِهِ
u'وُجُوبٌ مَحَبَّةٌ':Added, #1: 1	وُجُوبِ الْمَجَازِيِّ
u'وُجُوبٌ مَحْذُور':Added, #1: 1	وُجُوبِ مَحَبَّةِ
u'وُجُوبٌ مُدَافَعَةٌ':Added, #1: 1	وُجُوبِ مَحْذُورِ
u'وُجُوبٌ مُدَّةٌ':Added, #1: 1	وُجُوبُ مُدَافَعَةِ
u'وُجُوبٌ مَذْكُورٌ':Added, #1: 1	وُجُوبِ الْمُدَّةِ
u'وُجُوبٌ مُرَاجَعَةٌ':Added, #1: 1	وُجُوبُ الْمَذْكُورَاتِ
u'وُجُوبٌ مُرَاجَعَةٌ':Added, #1: 1	وُجُوبَ الْمُرَاجَعَةِ
u'وُجُوبٌ مُرَاجَعَةٌ':Added, #1: 1	وُجُوبُ الْمُرَاجَعَةِ
u'وُجُوبٌ مُرَاعَاةٌ':Added, #2: 2	وُجُوبِ الْمُرَاجَعَةِ
u'وُجُوبٌ مُرَاعَاةٌ':Added, #1: 1	وُجُوبَ مُرَاعَاةِ
u'وُجُوبٌ مُرَافَعَةٌ':Added, #1: 1	وُجُوبِ مُرَاعَاةِ
u'وُجُوبٌ مَسْأَلَةٌ':Added, #1: 1	وُجُوبِ الْمُرَافَعَةِ
u'وُجُوبٌ مُسَاوَاةٌ':Added, #1: 1	وُجُوبُ الْمَسْأَلَةِ
u'وُجُوبٌ مُسَاوَاةٌ':Added, #1: 1	وُجُوبُ الْمُسَاوَاةِ
u'وُجُوبٌ مُسْتَقِرٌّ':Added, #1: 1	وُجُوبِ الْمُسَاوَاةِ
u'وُجُوبٌ مَسْحٌ':Added, #1: 1	وُجُوبٍ مُسْتَقِرٍّ
u'وُجُوبٌ مَسْحٌ':Added, #1: 1	وُجُوبَ الْمَسْحِ
u'وُجُوبٌ مَسْحٌ':Added, #1: 1	وُجُوبَ مَسْحِ
u'وُجُوبٌ مَسْحٌ':Added, #1: 1	وُجُوبُ مَسْحِ
u'وُجُوبٌ مَسْحٌ':Added, #1: 1	وُجُوبِ مَسْحِ
u'وُجُوبٌ مَسْحٌ':Added, #2: 2	وُجُوبِ الْمَسْحِ
u'وُجُوبٌ مُشَاوَرَةٌ':Added, #6: 6	وُجُوبُ الْمَسْحِ
u'وُجُوبٌ مُشْتَرَكٌ':Added, #1: 1	وُجُوبُ مُشَاوَرَتِهِ
u'وُجُوبٌ مَشْرُوبٌ':Added, #1: 1	وُجُوبِ الْمُشْتَرَكِ
u'وُجُوبٌ مَشْيٌ':Added, #1: 1	وُجُوبُ الْمَشْرُوبِ
u'وُجُوبٌ مَشْيٌ':Added, #1: 1	وُجُوبُ الْمَشْيِ
u'وُجُوبٌ مَصِيرٌ':Added, #1: 1	وُجُوبِ الْمَشْيِ
u'وُجُوبٌ مَصِيرٌ':Added, #1: 1	وُجُوبَ الْمَصِيرِ
u'وُجُوبٌ مَصِيرٌ':Added, #1: 1	وُجُوبُ الْمَصِيرِ
u'وُجُوبٌ مُضِيٌّ':Added, #2: 2	وُجُوبِ الْمَصِيرِ
u'وُجُوبٌ مُطَالَبٌ':Added, #2: 2	وُجُوبِ الْمُضِيِّ
u'وُجُوبٌ مُطَالَبٌ':Added, #1: 1	وُجُوبُ مُطَالَبَتِهِ
u'وُجُوبٌ مُطَالَبَةٌ':Added, #2: 2	وُجُوبُ الْمُطَالَبَةِ
u'وُجُوبٌ مُطَالَبَةٌ':Added, #1: 1	وُجُوبُ مُطَالَبَتِهِ
u'وُجُوبٌ مُطْلَقٌ':Added, #2: 2	وُجُوبُ الْمُطَالَبَةِ
u'وُجُوبٌ مَعْرِفَةٌ':Added, #1: 1	وُجُوبِ مُطْلَقِ
u'وُجُوبٌ مَعْرِفَة':Added, #1: 1	وُجُوبِ الْمَعْرِفَةِ
u'وُجُوبٌ مَعْرِفَةٌ':Added, #1: 1	وُجُوبِ الْمَعْرِفَةِ
u'وُجُوبٌ مَعْرِفَة':Added, #3: 3	وُجُوبِ مَعْرِفَةِ
u'وُجُوبٌ مَعْصِيَةٌ':Added, #3: 3	وُجُوبِ مَعْرِفَةِ
u'وُجُوبٌ مُعَلَّقٌ':Added, #1: 1	وُجُوبُ الْمَعْصِيَةِ
u'وُجُوبٌ مُفَارَقَةٌ':Added, #1: 1	وُجُوبِ الْمُعَلَّقِ
u'وُجُوبٌ مُفَارَقَةٌ':Added, #1: 1	وُجُوبِ الْمُفَارَقَةِ
u'وُجُوبٌ مُفَارَقَةٌ':Added, #1: 1	وُجُوبِ مُفَارَقَةِ
u'وُجُوبٌ مُقَارَنٌ':Added, #2: 2	وُجُوبَ الْمُفَارَقَةِ
u'وُجُوبٌ مُقَارَنٌ':Added, #1: 1	وُجُوبُ مُقَارَنَةِ
u'وُجُوبٌ مُقَارَنَةٌ':Added, #1: 1	وُجُوبِ مُقَارَنَةِ
u'وُجُوبٌ مُقَارَنَةٌ':Added, #1: 1	وُجُوبُ مُقَارَنَةِ
u'وُجُوبٌ مُقَامٌ':Added, #1: 1	وُجُوبِ مُقَارَنَةِ
u'وُجُوبٌ مَقْبُولٌ':Added, #1: 1	وُجُوبَ الْمُقَامِ
u'وُجُوبٌ مُقَدِّمٌ':Added, #1: 1	وُجُوبِ الْمَقْبُولِ
u'وُجُوبٌ مُقَدِّمٌ':Added, #1: 1	وُجُوبَ الْمُقَدِّمَةِ
u'وُجُوبٌ مُقَدِّمَةٌ':Added, #1: 1	وُجُوبِ الْمُقَدِّمَةِ
u'وُجُوبٌ مُقَدِّمَةٌ':Added, #1: 1	وُجُوبَ الْمُقَدِّمَةِ
u'وُجُوبٌ مَكْتُوبٌ':Added, #1: 1	وُجُوبِ الْمُقَدِّمَةِ
u'وُجُوبٌ مُمَاثَلَةٌ':Added, #1: 1	وُجُوبُ الْمَكْتُوبَاتِ
u'وُجُوبٌ مُمَاثَلَةٌ':Added, #1: 1	وُجُوبِ الْمُمَاثَلَةِ
u'وُجُوبٌ مَمْسُوح':Added, #3: 3	وُجُوبُ الْمُمَاثَلَةِ
u'وُجُوبٌ مَنْذُور':Added, #1: 1	وُجُوبَ الْمَمْسُوحِ
u'وُجُوبٌ مَنْعٌ':Added, #2: 2	وُجُوبِ الْمَنْذُورِ
u'وُجُوبٌ مَنْعٌ':Added, #1: 1	وُجُوبُ مَنْعِ
u'وُجُوبٌ مَهْرٌ':Added, #4: 4	وُجُوبِ الْمَنْعِ
u'وُجُوبٌ مَهْرٌ':Added, #10: 10	وُجُوبِ مَهْرِ
u'وُجُوبٌ مَهْرٌ':Added, #11: 11	وُجُوبُ مَهْرِ
u'وُجُوبٌ مَهْرٌ':Added, #12: 12	وُجُوبُ الْمَهْرِ
u'وُجُوبٌ مَهْرٌ':Added, #13: 13	وُجُوبَ مَهْرِ
u'وُجُوبٌ مَهْرٌ':Added, #1: 1	وُجُوبُ مَهْرٍ
u'وُجُوبٌ مَهْرٌ':Added, #22: 22	وُجُوبِ الْمَهْرِ
u'وُجُوبٌ مَهْرٌ':Added, #2: 2	وُجُوبِ مَهْرٍ
u'وُجُوبٌ مُوَاسَاةٌ':Added, #4: 4	وُجُوبَ الْمَهْرِ
u'وُجُوبٌ مُوالاة':Added, #1: 1	وُجُوبِ الْمُوَاسَاةِ
u'وُجُوبٌ مُوالاة':Added, #1: 1	وُجُوبِ مُوَالَاةِ
u'وُجُوبٌ مُوالاة':Added, #2: 2	وُجُوبُ الْمُوَالَاةِ
u'وُجُوبٌ مَوْصُوفٌ':Added, #4: 4	وُجُوبِ الْمُوَالَاةِ
u'وُجُوبٌ مُؤَنٌ':Added, #1: 1	وُجُوبِ الْمَوْصُوفِ
u'وُجُوبٌ نَبْش':Added, #1: 1	وُجُوبِ الْمُؤَنِ
u'وُجُوبٌ نَجَاسَةٌ':Added, #1: 1	وُجُوبِ النَّبْشِ
u'وُجُوبٌ نَحْرٌ':Added, #2: 2	وُجُوبِ النَّجَاسَةِ
u'وُجُوبٌ نذر':Added, #2: 2	وُجُوبِ النَّحْرِ
u'وُجُوبٌ نذر':Added, #1: 1	وُجُوبُ النَّذْرِ
u'وُجُوبٌ نَذْرٌ':Added, #1: 1	وُجُوبِ النَّذْرِ
u'وُجُوبٌ نَذْرٌ':Added, #1: 1	وُجُوبُ النَّذْرِ
u'وُجُوبٌ نُذُورٌ':Added, #1: 1	وُجُوبِ النَّذْرِ
u'وُجُوبٌ نَزْعٌ':Added, #1: 1	وُجُوبِ النُّذُورِ
u'وُجُوبٌ نَزْعٌ':Added, #1: 1	وُجُوبِ النَّزْعِ
u'وُجُوبٌ نَزْعٌ':Added, #2: 2	وُجُوبُ النَّزْعِ
u'وُجُوبٌ نُسُكٌ':Added, #2: 2	وُجُوبُ نَزْعِهِ
u'وُجُوبٌ نُسُكٌ':Added, #1: 1	وُجُوبَ النُّسُكِ
u'وُجُوبٌ نصب':Added, #2: 2	وُجُوبِ النُّسُكِ
u'وُجُوبٌ نَصْبٌ':Added, #1: 1	وُجُوبُ نَصْبِ
u'وُجُوبٌ نصب':Added, #1: 1	وُجُوبُ نَصْبِ
u'وُجُوبٌ نَصْبٌ':Added, #1: 1	وُجُوبِ نَصْبِهِ
u'وُجُوبٌ نصب':Added, #1: 1	وُجُوبِ نَصْبِهِ
u'وُجُوبٌ نَصْبٌ':Added, #2: 2	وُجُوبُ النَّصْبِ
u'وُجُوبٌ نصح':Added, #2: 2	وُجُوبُ النَّصْبِ
u'وُجُوبٌ نصح':Added, #1: 1	وُجُوبَ النُّصْحِ
u'وُجُوبٌ نِصْفٌ':Added, #2: 2	وُجُوبُ النُّصْحِ
u'وُجُوبٌ نِصْفٌ':Added, #2: 2	وُجُوبَ نِصْفِ
u'وُجُوبٌ نِصْفٌ':Added, #5: 5	وُجُوبُ نِصْفِ
u'وُجُوبٌ نَصِيحٌ':Added, #5: 5	وُجُوبِ نِصْفِ
u'وُجُوبٌ نَصِيحَةٌ':Added, #1: 1	وُجُوبِ النَّصِيحَةِ
u'وُجُوبٌ نَظَرٌ':Added, #1: 1	وُجُوبِ النَّصِيحَةِ
u'وُجُوبٌ نَظَرٌ':Added, #2: 2	وُجُوبِ النَّظَرِ
u'وُجُوبٌ نَفْسٌ':Added, #4: 4	وُجُوبُ النَّظَرِ
u'وُجُوبٌ نَفَقَةٌ':Added, #1: 1	وُجُوبِ نَفْسِ
u'وُجُوبٌ نَفَقَةٌ':Added, #13: 13	وُجُوبَ النَّفَقَةِ
u'وُجُوبٌ نَفَقَةٌ':Added, #18: 18	وُجُوبُ النَّفَقَةِ
u'وُجُوبٌ نَفَقَةٌ':Added, #18: 18	وُجُوبِ نَفَقَةِ
u'وُجُوبٌ نَفَقَةٌ':Added, #2: 2	وُجُوبَ نَفَقَةِ
u'وُجُوبٌ نَفَقَةٌ':Added, #2: 2	وُجُوبَ نَفَقَتِهِ
u'وُجُوبٌ نَفَقَةٌ':Added, #2: 2	وُجُوبِ نَفَقَتِهِ
u'وُجُوبٌ نَفَقَةٌ':Added, #48: 48	وُجُوبِ النَّفَقَةِ
u'وُجُوبٌ نَفَقَةٌ':Added, #4: 4	وُجُوبُ نَفَقَةِ
u'وُجُوبٌ نَقْدٌ':Added, #4: 4	وُجُوبُ نَفَقَتِهِ
u'وُجُوبٌ نَقْد':Added, #1: 1	وُجُوبِ النَّقْدِ
u'وُجُوبٌ نَقْدٌ':Added, #1: 1	وُجُوبِ النَّقْدِ
u'وُجُوبٌ نَقْد':Added, #1: 1	وُجُوبُ نَقْدِ
u'وُجُوبٌ نَقْدٌ':Added, #1: 1	وُجُوبُ نَقْدِ
u'وُجُوبٌ نَقْد':Added, #2: 2	وُجُوبِ نَقْدِ
u'وُجُوبٌ نَقْضٌ':Added, #2: 2	وُجُوبِ نَقْدِ
u'وُجُوبٌ نَقْضٌ':Added, #1: 1	وُجُوبِ النَّقْضِ
u'وُجُوبٌ نقل':Added, #2: 2	وُجُوبَ النَّقْضِ
u'وُجُوبٌ نَقْلٌ':Added, #1: 1	وُجُوبُ النَّقْلِ
u'وُجُوبٌ نقل':Added, #1: 1	وُجُوبُ النَّقْلِ
u'وُجُوبٌ نقل':Added, #1: 1	وُجُوبَ نَقْلِ
u'وُجُوبٌ نَقْلٌ':Added, #1: 1	وُجُوبُ نَقْلِ
u'وُجُوبٌ نَقْلٌ':Added, #1: 1	وُجُوبَ نَقْلِ
u'وُجُوبٌ نقل':Added, #1: 1	وُجُوبُ نَقْلِ
u'وُجُوبٌ نَقْلٌ':Added, #1: 1	وُجُوبِ نَقْلِهِ
u'وُجُوبٌ نقل':Added, #1: 1	وُجُوبِ نَقْلِهِ
u'وُجُوبٌ نَقْلٌ':Added, #2: 2	وُجُوبِ النَّقْلِ
u'وُجُوبٌ نقل':Added, #2: 2	وُجُوبِ النَّقْلِ
u'وُجُوبٌ نَقْلٌ':Added, #2: 2	وُجُوبِ نَقْلِ
u'وُجُوبٌ نكاح':Added, #2: 2	وُجُوبِ نَقْلِ
u'وُجُوبٌ نِكَاحٌ':Added, #1: 1	وُجُوبُ النِّكَاحِ
u'وُجُوبٌ نكاح':Added, #1: 1	وُجُوبُ النِّكَاحِ
u'وُجُوبٌ نِكَاحٌ':Added, #4: 4	وُجُوبِ النِّكَاحِ
u'وُجُوبٌ نَهْيٌ':Added, #4: 4	وُجُوبِ النِّكَاحِ
u'وُجُوبٌ نَوَافِلُ':Added, #1: 1	وُجُوبُ النَّهْيِ
u'وُجُوبٌ نَوَافِلُ':Added, #1: 1	وُجُوبَ النَّوَافِلِ
u'وُجُوبٌ نِيَّةٌ':Added, #1: 1	وُجُوبُ النَّوَافِلِ
u'وُجُوبٌ نِيَّةٌ':Added, #1: 1	وُجُوبِ نِيَّتِهِ
u'وُجُوبٌ نِيَّةٌ':Added, #2: 2	وُجُوبَ نِيَّةِ
u'وُجُوبٌ نِيَّةٌ':Added, #3: 3	وُجُوبَ النِّيَّةِ
u'وُجُوبٌ نِيَّةٌ':Added, #3: 3	وُجُوبُ النِّيَّةِ
u'وُجُوبٌ نِيَّةٌ':Added, #6: 6	وُجُوبُ نِيَّةِ
u'وُجُوبٌ نِيَّةٌ':Added, #7: 7	وُجُوبِ نِيَّةِ
u'وُجُوبٌ هَتْكٌ':Added, #9: 9	وُجُوبِ النِّيَّةِ
u'وُجُوبٌ هجر':Added, #1: 1	وُجُوبِ هَتْكِ
u'وُجُوبٌ هَجْرٌ':Added, #1: 1	وُجُوبِ هَجْرِ
u'وُجُوبٌ هجرة':Added, #1: 1	وُجُوبِ هَجْرِ
u'وُجُوبٌ هِجْرَةٌ':Added, #1: 1	وُجُوبُ الْهِجْرَةِ
u'وُجُوبٌ هجرة':Added, #1: 1	وُجُوبُ الْهِجْرَةِ
u'وُجُوبٌ هجرة':Added, #2: 2	وُجُوبَ الْهِجْرَةِ
u'وُجُوبٌ هِجْرَةٌ':Added, #2: 2	وُجُوبِ الْهِجْرَةِ
u'وُجُوبٌ هِجْرَةٌ':Added, #2: 2	وُجُوبَ الْهِجْرَةِ
u'وُجُوبٌ هَدْمٌ':Added, #2: 2	وُجُوبِ الْهِجْرَةِ
u'وُجُوبٌ هَدْيٌ':Added, #1: 1	وُجُوبُ هَدْمِ
u'وُجُوبٌ هَدْيٌ':Added, #1: 1	وُجُوبُ الْهَدْيِ
u'وُجُوبٌ هَرَب':Added, #5: 5	وُجُوبِ الْهَدْيِ
u'وُجُوبٌ هَرَب':Added, #1: 1	وُجُوبِ الْهَرَبِ
u'وُجُوبٌ وَاجِبٌ':Added, #2: 2	وُجُوبَ الْهَرَبِ
u'وُجُوبٌ واحد':Added, #1: 1	وُجُوبِ وَاجِبٍ
u'وُجُوبٌ وَاحِدٌ':Added, #1: 1	وُجُوبُ وَاحِدٍ
u'وُجُوبٌ واحد':Added, #1: 1	وُجُوبُ وَاحِدٍ
u'وُجُوبٌ وَاحِدٌ':Added, #2: 2	وُجُوبَ وَاحِدَةٍ
u'وُجُوبٌ وَتْرٌ':Added, #2: 2	وُجُوبَ وَاحِدَةٍ
u'وُجُوبٌ وُجُودٌ':Added, #1: 1	وُجُوبِ الْوَتْرِ
u'وُجُوبٌ وُجُودٌ':Added, #1: 1	وُجُوبُ الْوُجُودِ
u'وُجُوبٌ وُجُودٌ':Added, #1: 1	وُجُوبَ وُجُودِهِ
u'وُجُوبٌ وُجُودٌ':Added, #1: 1	وُجُوبُ وُجُودِهِ
u'وُجُوبٌ وُجُودٌ':Added, #2: 2	وُجُوبِ الْوُجُودِ
u'وُجُوبٌ وُجُودٌ':Added, #2: 2	وُجُوبِ وُجُودِ
u'وُجُوبٌ وداع':Added, #3: 3	وُجُوبِ وُجُودِهِ
u'وُجُوبٌ وَدَاعٌ':Added, #1: 1	وُجُوبِ الْوَدَاعِ
u'وُجُوبٌ وِصَايَةٌ':Added, #1: 1	وُجُوبِ الْوَدَاعِ
u'وُجُوبٌ وَصْفٌ':Added, #1: 1	وُجُوبِ الْوِصَايَةِ
u'وُجُوبٌ وصل':Added, #1: 1	وُجُوبِ وَصْفِ
u'وُجُوبٌ وصل':Added, #1: 1	وُجُوبَ وَصْلِ
u'وُجُوبٌ وَصْلٌ':Added, #1: 1	وُجُوبُ وَصْلِ
u'وُجُوبٌ وَصْلٌ':Added, #1: 1	وُجُوبَ وَصْلِ
u'وُجُوبٌ وَصِيٌّ':Added, #1: 1	وُجُوبُ وَصْلِ
u'وُجُوبٌ وَصِيٌّ':Added, #1: 1	وُجُوبِ وَصِيَّتِهِ
u'وُجُوبٌ وَصِيٌّ':Added, #2: 2	وُجُوبُ الْوَصِيَّةِ
u'وُجُوبٌ وَصِيٌّ':Added, #3: 3	وُجُوبِ الْوَصِيَّةِ
u'وُجُوبٌ وَصِيَّةٌ':Added, #4: 4	وُجُوبَ الْوَصِيَّةِ
u'وُجُوبٌ وَصِيَّةٌ':Added, #1: 1	وُجُوبِ وَصِيَّتِهِ
u'وُجُوبٌ وَصِيَّةٌ':Added, #2: 2	وُجُوبُ الْوَصِيَّةِ
u'وُجُوبٌ وَصِيَّةٌ':Added, #3: 3	وُجُوبِ الْوَصِيَّةِ
u'وُجُوبٌ وَضْعٌ':Added, #4: 4	وُجُوبَ الْوَصِيَّةِ
u'وُجُوبٌ وُضُوءٌ':Added, #1: 1	وُجُوبِ الْوَضْعِ
u'وُجُوبٌ وُضُوءٌ':Added, #11: 11	وُجُوبَ الْوُضُوءِ
u'وُجُوبٌ وُضُوءٌ':Added, #24: 24	وُجُوبِ الْوُضُوءِ
u'وُجُوبٌ وَطْءٌ':Added, #7: 7	وُجُوبُ الْوُضُوءِ
u'وُجُوبٌ وَطْءٌ':Added, #1: 1	وُجُوبَ الْوَطْءِ
u'وُجُوبٌ وَفَاءٌ':Added, #1: 1	وُجُوبِ الْوَطْءِ
u'وُجُوبٌ وَفَاءٌ':Added, #12: 12	وُجُوبِ الْوَفَاءِ
u'وُجُوبٌ وَقْفٌ':Added, #4: 4	وُجُوبُ الْوَفَاءِ
u'وُجُوبٌ وَقْفٌ':Added, #1: 1	وُجُوبُ الْوَقْفِ
u'وُجُوبٌ وُقُوعٌ':Added, #1: 1	وُجُوبِ وَقْفِ
u'وُجُوبٌ وُقُوفٌ':Added, #1: 1	وُجُوبِ وُقُوعِهِ
u'وُجُوبٌ يَمِينٌ':Added, #1: 1	وُجُوبِ الْوُقُوفِ
u'وُجُوبٌ يَمِينٌ':Added, #1: 1	وُجُوبُ يَمِينِهِ
u'وُجُوبٌ يَمِينٌ':Added, #2: 2	وُجُوبَ الْيَمِينِ
u'وُجُوبٌ يَمِينٌ':Added, #2: 2	وُجُوبُ الْيَمِينِ
u'وُجُودٌ أَبٌ':Added, #5: 5	وُجُوبِ الْيَمِينِ
u'وُجُودٌ اِبْنٌ':Added, #9: 9	وُجُودِ الْأَبِ
u'وُجُودٌ اِبْنٌ':Added, #1: 1	وُجُودِ ابْنِ
u'وُجُودٌ إِبْهَامٌ':Added, #2: 2	وُجُودِ ابْنٍ
u'وُجُودٌ آثَارٌ':Added, #1: 1	وُجُودِ إبْهَامٍ
u'وُجُودٌ أثَرٌ':Added, #1: 1	وُجُودِ الْآثَارِ
u'وُجُودٌ أثَرٌ':Added, #1: 1	وُجُودِ أَثَرِ
u'وُجُودٌ أثَرٌ':Added, #1: 1	وُجُودَ الْأَثَرِ
u'وُجُودٌ أثَرٌ':Added, #1: 1	وُجُودُ الْأَثَرِ
u'وُجُودٌ إجَازَةٌ':Added, #1: 1	وُجُودِ الْأَثَرِ
u'وُجُودٌ أُجْرَةٌ':Added, #2: 2	وُجُودِ الْإِجَازَةِ
u'وُجُودٌ إِجْمَاعٌ':Added, #1: 1	وُجُودِ الْأُجْرَةِ
u'وُجُودٌ أَجْنَبِيٌّ':Added, #2: 2	وُجُودُ الْإِجْمَاعِ
u'وُجُودٌ أَجْنَبِيٌّ':Added, #1: 1	وُجُودِ أَجْنَبِيٍّ
u'وُجُودٌ أحَدٌ':Added, #1: 1	وُجُودِ أَجْنَبِيَّةٍ
u'وُجُودٌ أحَدٌ':Added, #1: 1	وُجُودَ أَحَدِ
u'وُجُودٌ أحَدٌ':Added, #1: 1	وُجُودِ أَحَدِ
u'وُجُودٌ إِحْرَامٌ':Added, #2: 2	وُجُودِ أَحَدٍ
u'وُجُودٌ إِحْرَامٌ':Added, #1: 1	وُجُودِ إحْرَامِهِ
u'وُجُودٌ إِحْرَامٌ':Added, #1: 1	وُجُودَ الْإِحْرَامِ
u'وُجُودٌ إِحْرَامٌ':Added, #1: 1	وُجُودُ الْإِحْرَامِ
u'وُجُودٌ أَخٌ':Added, #1: 1	وُجُودِ الْإِحْرَامِ
u'وُجُودٌ أُخْتٌ':Added, #1: 1	وُجُودِ الْأَخِ
u'وُجُودٌ أَدَاءٌ':Added, #2: 2	وُجُودِ الْأُخْتِ
u'وُجُودٌ أَدَاءٌ':Added, #1: 1	وُجُودُ أَدَاءِ
u'وُجُودٌ أَدَاءٌ':Added, #2: 2	وُجُودُ الْأَدَاءِ
u'وُجُودٌ آدَمِيٌّ':Added, #3: 3	وُجُودِ الْأَدَاءِ
u'وُجُودٌ إِذْنٌ':Added, #1: 1	وُجُودِ الْآدَمِيِّ
u'وُجُودٌ إِذْنٌ':Added, #1: 1	وُجُودَ إذْنِهِ
u'وُجُودٌ إِذْنٌ':Added, #1: 1	وُجُودُ إذْنِهِ
u'وُجُودٌ إِذْنٌ':Added, #1: 1	وُجُودُ الْإِذْنِ
u'وُجُودٌ إِرَادَةٌ':Added, #8: 8	وُجُودِ الْإِذْنِ
u'وُجُودٌ أَرْجَحُ':Added, #1: 1	وُجُودِ إرَادَةٍ
u'وُجُودٌ أَرْكانٌ':Added, #1: 1	وُجُودِ الْأَرْجَحِ
u'وُجُودٌ أَرْكَانٌ':Added, #1: 1	وُجُودِ الْأَرْكَانِ
u'وُجُودٌ إشارَة':Added, #1: 1	وُجُودِ الْأَرْكَانِ
u'وُجُودٌ اِشْتِدادٌ':Added, #1: 1	وُجُودُ الْإِشَارَةِ
u'وُجُودٌ أَشْيَاءٌ':Added, #1: 1	وُجُودُ اشْتِدَادٍ
u'وُجُودٌ أَصابِعُ':Added, #1: 1	وُجُودِ الْأَشْيَاءِ
u'وُجُودٌ أُصْبُعٌ':Added, #1: 1	وُجُودَ الْأَصَابِعِ
u'وُجُودٌ أصل':Added, #1: 1	وُجُودُ الْأُصْبُعَيْنِ
u'وُجُودٌ أًصْلٌ':Added, #14: 14	وُجُودِ الْأَصْلِ
u'وُجُودٌ أًصْلٌ':Added, #14: 14	وُجُودِ الْأَصْلِ
u'وُجُودٌ أصل':Added, #1: 1	وُجُودِ أَصْلٍ
u'وُجُودٌ أًصْلٌ':Added, #1: 1	وُجُودُ أَصْلِهِ
u'وُجُودٌ أصل':Added, #1: 1	وُجُودُ أَصْلِهِ
u'وُجُودٌ أًصْلٌ':Added, #1: 1	وُجُودُ الْأَصْلِ
u'وُجُودٌ أصل':Added, #1: 1	وُجُودُ الْأَصْلِ
u'وُجُودٌ أًصْلٌ':Added, #2: 2	وُجُودَ أَصْلِ
u'وُجُودٌ أصل':Added, #2: 2	وُجُودَ أَصْلِ
u'وُجُودٌ أًصْلٌ':Added, #2: 2	وُجُودَ أَصْلِهِ
u'وُجُودٌ أصل':Added, #2: 2	وُجُودَ أَصْلِهِ
u'وُجُودٌ أًصْلٌ':Added, #2: 2	وُجُودَ الْأَصْلِ
u'وُجُودٌ أصل':Added, #2: 2	وُجُودَ الْأَصْلِ
u'وُجُودٌ أًصْلٌ':Added, #4: 4	وُجُودِ أَصْلِهِ
u'وُجُودٌ أصل':Added, #4: 4	وُجُودِ أَصْلِهِ
u'وُجُودٌ أًصْلٌ':Added, #5: 5	وُجُودِ أَصْلِ
u'وُجُودٌ أَصْلَحُ':Added, #5: 5	وُجُودِ أَصْلِ
u'وُجُودٌ أَصْلِيٌّ':Added, #1: 1	وُجُودِ الْأَصْلَحِ
u'وُجُودٌ أَصْنَافٌ':Added, #1: 1	وُجُودِ الْأَصْلِيِّ
u'وُجُودٌ إضافَةٌ':Added, #2: 2	وُجُودِ الْأَصْنَافِ
u'وُجُودٌ إضْمارٌ':Added, #2: 2	وُجُودُ الْإِضَافَةِ
u'وُجُودٌ إِطْلاقٌ':Added, #1: 1	وُجُودِ الْإِضْمَارِ
u'وُجُودٌ إِعْتاقٌ':Added, #1: 1	وُجُودِ إطْلَاقِهِ
u'وُجُودٌ إِعْتاقٌ':Added, #1: 1	وُجُودُ الْإِعْتَاقِ
u'وُجُودٌ اِعْتِبارٌ':Added, #1: 1	وُجُودِ الْإِعْتَاقِ
u'وُجُودٌ أَعْرَاضٌ':Added, #1: 1	وُجُودِ اعْتِبَارِ
u'وُجُودٌ أعْلَمُ':Added, #1: 1	وُجُودِ الْأَعْرَاضِ
u'وُجُودٌ أَعَمُّ':Added, #1: 1	وُجُودِ الْأَعْلَمِ
u'وُجُودٌ أَعْمَالٌ':Added, #1: 1	وُجُودَ الْأَعَمِّ
u'وُجُودٌ أَعْوَانٌ':Added, #3: 3	وُجُودُ أَعْمَالٍ
u'وُجُودٌ أفْضَلُ':Added, #1: 1	وُجُودِ أَعْوَانٍ
u'وُجُودٌ أفْضَلُ':Added, #13: 13	وُجُودِ الْأَفْضَلِ
u'وُجُودٌ إقامَةٌ':Added, #1: 1	وُجُودُ الْأَفْضَلِ
u'وُجُودٌ إقْرَارٌ':Added, #1: 1	وُجُودَ الْإِقَامَةِ
u'وُجُودٌ أقْرَبُ':Added, #1: 1	وُجُودُ الْإِقْرَارِ
u'وُجُودٌ أقْرَبُ':Added, #2: 2	وُجُودُ الْأَقْرَبِ
u'وُجُودٌ أَكْثَرُ':Added, #5: 5	وُجُودِ الْأَقْرَبِ
u'وُجُودٌ آلةٌ':Added, #1: 1	وُجُودِ أَكْثَرِ
u'وُجُودٌ آلةٌ':Added, #1: 1	وُجُودِ الْآلَةِ
u'وُجُودٌ اِلْتِزَامٌ':Added, #2: 2	وُجُودِ آلَةِ
u'وُجُودٌ اِلْتِزَامٌ':Added, #1: 1	وُجُودُ الْتِزَامٍ
u'وُجُودٌ ألَمٌ':Added, #1: 1	وُجُودَ الْتِزَامِهِ
u'وُجُودٌ الْمَرْأَةُ':Added, #2: 2	وُجُودِ الْأَلَمِ
u'وُجُودٌ إلَهٌ':Added, #1: 1	وُجُودِ الْمَرْأَةِ
u'وُجُودٌ إلَهٌ':Added, #1: 1	وُجُودُ الْإِلَهِ
u'وُجُودٌ إلَهٌ':Added, #1: 1	وُجُودِ إلَهٍ
u'وُجُودٌ أُمٌّ':Added, #1: 1	وُجُودِ إِلَهٍ
u'وُجُودٌ أُمٌّ':Added, #1: 1	وُجُودِ الْأُمِّ
u'وُجُودٌ أمَارَةٌ':Added, #2: 2	وُجُودُ الْأُمِّ
u'وُجُودٌ إمَامٌ':Added, #1: 1	وُجُودَ أَمَارَةٍ
u'وُجُودٌ أمَانَةٌ':Added, #5: 5	وُجُودِ الْإِمَامِ
u'وُجُودٌ أَمْرٌ':Added, #1: 1	وُجُودِ أَمَانَتِهِ
u'وُجُودٌ أَمْرٌ':Added, #1: 1	وُجُودُ الْأَمْرِ
u'وُجُودٌ أَمْرٌ':Added, #1: 1	وُجُودَ الْأَمْرَيْنِ
u'وُجُودٌ أَمْرٌ':Added, #1: 1	وُجُودِ الْأَمْرَيْنِ
u'وُجُودٌ أَمْرٌ':Added, #1: 1	وُجُودَ أَمْرٍ
u'وُجُودٌ أَمْرٌ':Added, #2: 2	وُجُودِ الْأَمْرِ
u'وُجُودٌ اِمْرَأَةٌ':Added, #2: 2	وُجُودِ أَمْرٍ
u'وُجُودٌ اِمْرَأَةٌ':Added, #1: 1	وُجُودُ امْرَأَةٍ
u'وُجُودٌ إِنْذارٌ':Added, #1: 1	وُجُودِ امْرَأَةٍ
u'وُجُودٌ أهْلٌ':Added, #1: 1	وُجُودِ الْإِنْذَارِ
u'وُجُودٌ أهْلٌ':Added, #1: 1	وُجُودُ الْأَهْلِ
u'وُجُودٌ أهْلٌ':Added, #1: 1	وُجُودِ الْأَهْلِ
u'وُجُودٌ أهْلٌ':Added, #1: 1	وُجُودُ أَهْلِ
u'وُجُودٌ أَهْلِيٌّ':Added, #1: 1	وُجُودِ أَهْلِ
u'وُجُودٌ أَهْلِيٌّ':Added, #1: 1	وُجُودَ الْأَهْلِيَّةِ
u'وُجُودٌ أَهْلِيٌّ':Added, #1: 1	وُجُودَ أَهْلِيَّةِ
u'وُجُودٌ أَهْلِيٌّ':Added, #1: 1	وُجُودُ أَهْلِيَّةِ
u'وُجُودٌ أَهْلِيٌّ':Added, #1: 1	وُجُودِ أَهْلِيَّتِهِ
u'وُجُودٌ أَهْلِيٌّ':Added, #2: 2	وُجُودُ الْأَهْلِيَّةِ
u'وُجُودٌ أهْلِيَّةٌ':Added, #4: 4	وُجُودِ الْأَهْلِيَّةِ
u'وُجُودٌ أهْلِيَّةٌ':Added, #1: 1	وُجُودَ الْأَهْلِيَّةِ
u'وُجُودٌ أهْلِيَّةٌ':Added, #1: 1	وُجُودَ أَهْلِيَّةِ
u'وُجُودٌ أهْلِيَّةٌ':Added, #1: 1	وُجُودُ أَهْلِيَّةِ
u'وُجُودٌ أهْلِيَّةٌ':Added, #1: 1	وُجُودِ أَهْلِيَّتِهِ
u'وُجُودٌ أهْلِيَّةٌ':Added, #2: 2	وُجُودُ الْأَهْلِيَّةِ
u'وُجُودٌ أَوَّلُ':Added, #4: 4	وُجُودِ الْأَهْلِيَّةِ
u'وُجُودٌ أَوَّلُ':Added, #1: 1	وُجُودَ الْأَوَّلِ
u'وُجُودٌ أَوَّلُ':Added, #1: 1	وُجُودُ الْأَوَّلِ
u'وُجُودٌ أَوْلاَدٌ':Added, #2: 2	وُجُودِ الْأَوَّلِ
u'وُجُودٌ أَوْلاَدٌ':Added, #1: 1	وُجُودِ الْأَوْلَادِ
u'وُجُودٌ إِيجَابٌ':Added, #1: 1	وُجُودِ أَوْلَادِ
u'وُجُودٌ إِيجَابٌ':Added, #1: 1	وُجُودُ الْإِيجَابِ
u'وُجُودٌ إيمَانٌ':Added, #1: 1	وُجُودُ إيجَابٍ
u'وُجُودٌ إيمَانٌ':Added, #1: 1	وُجُودِ إيمَانِهِ
u'وُجُودٌ باء':Added, #4: 4	وُجُودِ الْإِيمَانِ
u'وُجُودٌ بَارِئٌ':Added, #2: 2	وُجُودِ الْبَاءِ
u'وُجُودٌ بَاعِثٌ':Added, #1: 1	وُجُودِ الْبَارِئِ
u'وُجُودٌ بُرْهانٌ':Added, #1: 1	وُجُودِ الْبَاعِثِ
u'وُجُودٌ بُرْهَانٌ':Added, #1: 1	وُجُودِ بُرْهَانٍ
u'وُجُودٌ بُرْهانٌ':Added, #1: 1	وُجُودِ بُرْهَانٍ
u'وُجُودٌ بُرْهَانٌ':Added, #3: 3	وُجُودِ الْبُرْهَانِ
u'وُجُودٌ بِشارَةٌ':Added, #3: 3	وُجُودِ الْبُرْهَانِ
u'وُجُودٌ بعثة':Added, #1: 1	وُجُودُ الْبِشَارَةِ
u'وُجُودٌ بَعْضٌ':Added, #1: 1	وُجُودِ بَعْثَةِ
u'وُجُودٌ بَعْضٌ':Added, #1: 1	وُجُودُ الْبَعْضِ
u'وُجُودٌ بَعْضٌ':Added, #1: 1	وُجُودِ بَعْضِ
u'وُجُودٌ بَعْضٌ':Added, #1: 1	وُجُودِ بَعْضِهِ
u'وُجُودٌ بَعْضٌ':Added, #2: 2	وُجُودَ بَعْضِ
u'وُجُودٌ بُغْيَةٌ':Added, #3: 3	وُجُودُ بَعْضِ
u'وُجُودٌ بَقاءٌ':Added, #1: 1	وُجُودِ بُغْيَتِهِ
u'وُجُودٌ بِلادٌ':Added, #1: 1	وُجُودِ بَقَاءِ
u'وُجُودٌ بَلَّةٌ':Added, #1: 1	وُجُودَ الْبِلَادِ
u'وُجُودٌ بِنَاءٌ':Added, #1: 1	وُجُودُ بَلَّةٍ
u'وُجُودٌ بَهيمٌ':Added, #1: 1	وُجُودَ الْبِنَاءِ
u'وُجُودٌ بَهِيمَةٌ':Added, #1: 1	وُجُودُ الْبَهِيمَةِ
u'وُجُودٌ بَيْعٌ':Added, #1: 1	وُجُودُ الْبَهِيمَةِ
u'وُجُودٌ بَيْعٌ':Added, #2: 2	وُجُودَ الْبَيْعِ
u'وُجُودٌ بَيِّنَةٌ':Added, #6: 6	وُجُودِ الْبَيْعِ
u'وُجُودٌ بَيِّنَةٌ':Added, #1: 1	وُجُودِ بَيِّنَةٍ
u'وُجُودٌ بَيِّنَةٌ':Added, #1: 1	وُجُودِ بَيِّنَةِ
u'وُجُودٌ تاء':Added, #2: 2	وُجُودِ الْبَيِّنَةِ
u'وُجُودٌ تاء':Added, #1: 1	وُجُودُ التَّاءِ
u'وُجُودٌ تَابِعٌ':Added, #1: 1	وُجُودِ التّاءِ
u'وُجُودٌ تَحْرِيم':Added, #1: 1	وُجُودِ التَّابِعِ
u'وُجُودٌ تَحْرِيمٌ':Added, #1: 1	وُجُودَ التَّحْرِيمَةِ
u'وُجُودٌ تَحَقُّقٌ':Added, #2: 2	وُجُودِ التَّحْرِيمِ
u'وُجُودٌ تَحْلِيلٌ':Added, #1: 1	وُجُودِ تَحَقُّقِ
u'وُجُودٌ تَدَافُعٌ':Added, #2: 2	وُجُودِ التَّحْلِيلِ
u'وُجُودٌ تُرَابٌ':Added, #1: 1	وُجُودِ التَّدَافُعِ
u'وُجُودٌ تَرْتِيبٌ':Added, #2: 2	وُجُودِ التُّرَابِ
u'وُجُودٌ تَرْتِيبٌ':Added, #1: 1	وُجُودِ التَّرْتِيبِ
u'وُجُودٌ تَرْجِيحٌ':Added, #1: 1	وُجُودُ تَرْتِيبِهِ
u'وُجُودٌ تَرْجِيحٌ':Added, #1: 1	وُجُودُ التَّرْجِيحِ
u'وُجُودٌ تَرْغِيبٌ':Added, #1: 1	وُجُودِ التَّرْجِيحِ
u'وُجُودٌ تَزَوُّجٌ':Added, #1: 1	وُجُودِ التَّرْغِيبِ
u'وُجُودٌ تَسْمِيَة':Added, #2: 2	وُجُودِ التَّزَوُّجِ
u'وُجُودٌ تَسْمِيَة':Added, #1: 1	وُجُودَ التَّسْمِيَةِ
u'وُجُودٌ تَسْمِيَة':Added, #1: 1	وُجُودُ التَّسْمِيَةِ
u'وُجُودٌ تَشْدِيدٌ':Added, #3: 3	وُجُودِ التَّسْمِيَةِ
u'وُجُودٌ تَصْرِيحٌ':Added, #1: 1	وُجُودِ تَشْدِيدَاتٍ
u'وُجُودٌ تَصْرِيحٌ':Added, #1: 1	وُجُودَ التَّصْرِيحِ
u'وُجُودٌ تَعْزِير':Added, #2: 2	وُجُودِ التَّصْرِيحِ
u'وُجُودٌ تَعْظِيمٌ':Added, #1: 1	وُجُودِ تَعْزِيرِ
u'وُجُودٌ تَعَلُّقٌ':Added, #1: 1	وُجُودِ التَّعْظِيمِ
u'وُجُودٌ تَعْلِيقٌ':Added, #1: 1	وُجُودُ تَعَلُّقِ
u'وُجُودٌ تَعْلِيلٌ':Added, #2: 2	وُجُودِ التَّعْلِيقِ
u'وُجُودٌ تَغْيِيرٌ':Added, #1: 1	وُجُودِ التَّعْلِيلِ
u'وُجُودٌ تَفاوُت':Added, #1: 1	وُجُودُ التَّغْيِيرِ
u'وُجُودٌ تَفاوُت':Added, #2: 2	وُجُودَ التَّفَاوُتِ
u'وُجُودٌ تَقابُض':Added, #2: 2	وُجُودِ التَّفَاوُتِ
u'وُجُودٌ تَكْرارٌ':Added, #1: 1	وُجُودُ التَّقَابُضِ
u'وُجُودٌ تَكْفيرٌ':Added, #1: 1	وُجُودِ التَّكْرَارِ
u'وُجُودٌ تَكْليفٌ':Added, #1: 1	وُجُودِ التَّكْفِيرِ
u'وُجُودٌ تَلَف':Added, #1: 1	وُجُودِ التَّكْلِيفِ
u'وُجُودٌ تَمَتُّعٌ':Added, #1: 1	وُجُودِ التَّلَفِ
u'وُجُودٌ تَمَتُّعٌ':Added, #1: 1	وُجُودُ التَّمَتُّعِ
u'وُجُودٌ تَمْر':Added, #1: 1	وُجُودِ تَمَتُّعِهِ
u'وُجُودٌ تَمْييزٌ':Added, #1: 1	وُجُودُ التَّمْرِ
u'وُجُودٌ تَنَاوُلٌ':Added, #1: 1	وُجُودُ التَّمْيِيزِ
u'وُجُودٌ تُهْمَةٌ':Added, #1: 1	وُجُودَ التَّنَاوُلِ
u'وُجُودٌ تَوَافُقٌ':Added, #2: 2	وُجُودُ التُّهْمَةِ
u'وُجُودٌ تَوْبَةٌ':Added, #1: 1	وُجُودِ التَّوَافُقِ
u'وُجُودٌ تَوْكِيلٌ':Added, #1: 1	وُجُودُ التَّوْبَةِ
u'وُجُودٌ ثَالِثٌ':Added, #1: 1	وُجُودُ تَوْكِيلِ
u'وُجُودٌ ثَالِثٌ':Added, #1: 1	وُجُودَ ثَالِثٍ
u'وُجُودٌ ثَلاثَةٌ':Added, #1: 1	وُجُودِ ثَالِثٍ
u'وُجُودٌ ثَلاثَةٌ':Added, #1: 1	وُجُودِ ثَلَاثَةِ
u'وُجُودٌ ثَمَرَةٌ':Added, #2: 2	وُجُودِ الثَّلَاثَةِ
u'وُجُودٌ ثَمَرَةٌ':Added, #1: 1	وُجُودُ الثَّمَرَةِ
u'وُجُودٌ ثَوابٌ':Added, #2: 2	وُجُودِ الثَّمَرَةِ
u'وُجُودٌ ثَوْبٌ':Added, #1: 1	وُجُودِ الثَّوَابِ
u'وُجُودٌ ثَوْبٌ':Added, #1: 1	وُجُودَ الثَّوْبِ
u'وُجُودٌ ثِيابٌ':Added, #1: 1	وُجُودِ ثَوْبٍ
u'وُجُودٌ جَامِعٌ':Added, #1: 1	وُجُودِ الثِّيَابِ
u'وُجُودٌ جَامِعٌ':Added, #1: 1	وُجُودَ الْجَامِعِ
u'وُجُودٌ جَاهِلٌ':Added, #1: 1	وُجُودِ الْجَامِعِ
u'وُجُودٌ جَاهِلٌ':Added, #1: 1	وُجُودُ الْجَاهِلِ
u'وُجُودٌ جَبَلٌ':Added, #1: 1	وُجُودِ جَاهِلٍ
u'وُجُودٌ جَديدٌ':Added, #1: 1	وُجُودُ جَبَلٍ
u'وُجُودٌ جَدِيدٌ':Added, #1: 1	وُجُودِ الْجَدِيدِ
u'وُجُودٌ جُرْحٌ':Added, #1: 1	وُجُودِ الْجَدِيدِ
u'وُجُودٌ جُزْءٌ':Added, #1: 1	وُجُودِ الْجُرْحِ
u'وُجُودٌ جُزْءٌ':Added, #1: 1	وُجُودُ جُزْءٍ
u'وُجُودٌ جَزَاءٌ':Added, #1: 1	وُجُودِ جُزْءٍ
u'وُجُودٌ جَزَاءٌ':Added, #1: 1	وُجُودِ الْجَزَاءِ
u'وُجُودٌ جُزْئِيٌّ':Added, #2: 2	وُجُودَ الْجَزَاءِ
u'وُجُودٌ جُزْئِيَّةٌ':Added, #1: 1	وُجُودِ الْجُزْئِيَّةِ
u'وُجُودٌ جَمَادٌ':Added, #1: 1	وُجُودِ الْجُزْئِيَّةِ
u'وُجُودٌ جماع':Added, #1: 1	وُجُودَ الْجَمَادَاتِ
u'وُجُودٌ جماع':Added, #1: 1	وُجُودُ الْجِمَاعِ
u'وُجُودٌ جِمَاعٌ':Added, #1: 1	وُجُودِ الْجِمَاعِ
u'وُجُودٌ جِمَاعٌ':Added, #1: 1	وُجُودُ الْجِمَاعِ
u'وُجُودٌ جَمَاعَةٌ':Added, #1: 1	وُجُودِ الْجِمَاعِ
u'وُجُودٌ جَمِيع':Added, #1: 1	وُجُودِ الْجَمَاعَةِ
u'وُجُودٌ جَمِيع':Added, #1: 1	وُجُودُ الْجَمِيعِ
u'وُجُودٌ جِنٌّ':Added, #1: 1	وُجُودِ الْجَمِيعِ
u'وُجُودٌ جَنَابَةٌ':Added, #1: 1	وُجُودَ الْجِنِّ
u'وُجُودٌ جِنَايَةٌ':Added, #1: 1	وُجُودِ الْجَنَابَةِ
u'وُجُودٌ جِنَايَةٌ':Added, #1: 1	وُجُودِ الْجِنَايَةِ
u'وُجُودٌ جَنَّةٌ':Added, #1: 1	وُجُودِ جِنَايَتِهِ
u'وُجُودٌ جِنْسٌ':Added, #3: 3	وُجُودِ الْجَنَّةِ
u'وُجُودٌ جِنْسٌ':Added, #1: 1	وُجُودِ جِنْسٍ
u'وُجُودٌ جِنْسٌ':Added, #1: 1	وُجُودِ جِنْسِهِ
u'وُجُودٌ جِنْسِيٌّ':Added, #2: 2	وُجُودِ الْجِنْسِ
u'وُجُودٌ جِنْسِيٌّ':Added, #1: 1	وُجُودُ الْجِنْسِيَّةِ
u'وُجُودٌ جُنُونٌ':Added, #1: 1	وُجُودِ الْجِنْسِيَّةِ
u'وُجُودٌ جَنِينٌ':Added, #1: 1	وُجُودِ الْجُنُونِ
u'وُجُودٌ جَوَازٌ':Added, #2: 2	وُجُودِ الْجَنِينِ
u'وُجُودٌ جِيرَانٌ':Added, #1: 1	وُجُودِ الْجَوَازِ
u'وُجُودٌ حاجِبٌ':Added, #1: 1	وُجُودِ الْجِيرَانِ
u'وُجُودٌ حاجَةٌ':Added, #2: 2	وُجُودِ الْحَاجِبِ
u'وُجُودٌ حادِثٌ':Added, #2: 2	وُجُودِ الْحَاجَةِ
u'وُجُودٌ حافِظٌ':Added, #4: 4	وُجُودِ الْحَادِثِ
u'وُجُودٌ حاكِمٌ':Added, #1: 1	وُجُودِ الْحَافِظِ
u'وُجُودٌ حاكِمٌ':Added, #1: 1	وُجُودِ حَاكِمٍ
u'وُجُودٌ حائِلٌ':Added, #6: 6	وُجُودِ الْحَاكِمِ
u'وُجُودٌ حائِلٌ':Added, #1: 1	وُجُودُ الْحَائِلِ
u'وُجُودٌ حِجارَةٌ':Added, #1: 1	وُجُودِ الْحَائِلِ
u'وُجُودٌ حُجَّةٌ':Added, #1: 1	وُجُودُ الْحِجَارَةِ
u'وُجُودٌ حُجَّةٌ':Added, #1: 1	وُجُودَ الْحُجَّةِ
u'وُجُودٌ حُجَّةٌ':Added, #1: 1	وُجُودَ حُجَّةٍ
u'وُجُودٌ حَدٌّ':Added, #2: 2	وُجُودِ الْحُجَّةِ
u'وُجُودٌ حَدٌّ':Added, #1: 1	وُجُودُ الْحَدِّ
u'وُجُودٌ حَدٌّ':Added, #2: 2	وُجُودَ الْحَدِّ
u'وُجُودٌ حَدَثٌ':Added, #2: 2	وُجُودِ الْحَدِّ
u'وُجُودٌ حَدَثٌ':Added, #2: 2	وُجُودُ الْحَدَثِ
u'وُجُودٌ حُرٌّ':Added, #8: 8	وُجُودِ الْحَدَثِ
u'وُجُودٌ حُرٌّ':Added, #1: 1	وُجُودَ الْحُرَّةِ
u'وُجُودٌ حَرَجٌ':Added, #1: 1	وُجُودُ الْحُرَّةِ
u'وُجُودٌ حَرَكَةٌ':Added, #2: 2	وُجُودِ الْحَرَجِ
u'وُجُودٌ حُروفٌ':Added, #1: 1	وُجُودُ الْحَرَكَةِ
u'وُجُودٌ حُروفٌ':Added, #1: 1	وُجُودُ حُرُوفِ
u'وُجُودٌ حُرِّيَّةٌ':Added, #2: 2	وُجُودَ حُرُوفِ
u'وُجُودٌ حَرِيرٌ':Added, #2: 2	وُجُودِ الْحُرِّيَّةِ
u'وُجُودٌ حُزْنٌ':Added, #1: 1	وُجُودِ الْحَرِيرِ
u'وُجُودٌ حَظٌّ':Added, #1: 1	وُجُودَ الْحُزْنِ
u'وُجُودٌ حَقٌّ':Added, #3: 3	وُجُودُ الْحَظِّ
u'وُجُودٌ حَقِيقٌ':Added, #2: 2	وُجُودِ الْحَقِّ
u'وُجُودٌ حَقِيقٌ':Added, #1: 1	وُجُودُ حَقِيقَتِهِ
u'وُجُودٌ حَقِيقَةٌ':Added, #9: 9	وُجُودِ حَقِيقَةِ
u'وُجُودٌ حَقِيقَةٌ':Added, #1: 1	وُجُودُ حَقِيقَتِهِ
u'وُجُودٌ حَقِيقِيٌّ':Added, #9: 9	وُجُودِ حَقِيقَةِ
u'وُجُودٌ حُكْمٌ':Added, #3: 3	وُجُودِ الْحَقِيقِيِّ
u'وُجُودٌ حُكْمٌ':Added, #10: 10	وُجُودُ الْحُكْمِ
u'وُجُودٌ حُكْمٌ':Added, #13: 13	وُجُودِ الْحُكْمِ
u'وُجُودٌ حُكْمٌ':Added, #1: 1	وُجُودُ حُكْمٍ
u'وُجُودٌ حُكْمٌ':Added, #1: 1	وُجُودِ حُكْمِ
u'وُجُودٌ حُكْمٌ':Added, #2: 2	وُجُودِ حُكْمِهِ
u'وُجُودٌ حكمة':Added, #4: 4	وُجُودَ الْحُكْمِ
u'وُجُودٌ حِكْمَةٌ':Added, #1: 1	وُجُودِ الْحِكْمَةِ
u'وُجُودٌ حكمة':Added, #1: 1	وُجُودِ الْحِكْمَةِ
u'وُجُودٌ حِكْمَةٌ':Added, #1: 1	وُجُودِ حِكْمَةٍ
u'وُجُودٌ حِلٌّ':Added, #1: 1	وُجُودِ حِكْمَةٍ
u'وُجُودٌ حِلٌّ':Added, #1: 1	وُجُودَ الْحِلِّ
u'وُجُودٌ حِلٌّ':Added, #1: 1	وُجُودُ الْحِلِّ
u'وُجُودٌ حِمَايَةٌ':Added, #1: 1	وُجُودِ الْحِلِّ
u'وُجُودٌ حَمْلٌ':Added, #1: 1	وُجُودُ الْحِمَايَةِ
u'وُجُودٌ حَمْلٌ':Added, #2: 2	وُجُودِ الْحَمْلِ
u'وُجُودٌ حِنْثٌ':Added, #3: 3	وُجُودَ الْحَمْلِ
u'وُجُودٌ حول':Added, #1: 1	وُجُودِ الْحِنْثِ
u'وُجُودٌ حَوْلٌ':Added, #1: 1	وُجُودُ الْحَوْلِ
u'وُجُودٌ حَيَاةٌ':Added, #1: 1	وُجُودُ الْحَوْلِ
u'وُجُودٌ حَيَاةٌ':Added, #2: 2	وُجُودُ الْحَيَاةِ
u'وُجُودٌ حَيْض':Added, #2: 2	وُجُودِ الْحَيَاةِ
u'وُجُودٌ حَيْض':Added, #1: 1	وُجُودَ الْحَيْضَتَيْنِ
u'وُجُودٌ حَيْضٌ':Added, #1: 1	وُجُودِ حَيْضَتَيْنِ
u'وُجُودٌ حَيْضٌ':Added, #2: 2	وُجُودَ الْحَيْضِ
u'وُجُودٌ حَيْضٌ':Added, #2: 2	وُجُودِ الْحَيْضِ
u'وُجُودٌ خَارِجٌ':Added, #3: 3	وُجُودُ الْحَيْضِ
u'وُجُودٌ خَارِجٌ':Added, #1: 1	وُجُودُ الْخَارِجِ
u'وُجُودٌ خاصّ':Added, #2: 2	وُجُودِ الْخَارِجِ
u'وُجُودٌ خَاصَّةٌ':Added, #2: 2	وُجُودِ الْخَاصِّ
u'وُجُودٌ خَالِقٌ':Added, #1: 1	وُجُودِ الْخَاصَّةِ
u'وُجُودٌ خَالِقٌ':Added, #1: 1	وُجُودِ الْخَالِقِ
u'وُجُودٌ خَبَرٌ':Added, #1: 1	وُجُودِ خَالِقِهِ
u'وُجُودٌ خَبَر':Added, #1: 1	وُجُودُ الْخَبَرِ
u'وُجُودٌ خَبَرٌ':Added, #1: 1	وُجُودُ الْخَبَرِ
u'وُجُودٌ خَبَر':Added, #1: 1	وُجُودِ خَبَرٍ
u'وُجُودٌ خَبَرٌ':Added, #1: 1	وُجُودِ خَبَرٍ
u'وُجُودٌ خَبَر':Added, #2: 2	وُجُودُ خَبَرٍ
u'وُجُودٌ خَبَرٌ':Added, #2: 2	وُجُودُ خَبَرٍ
u'وُجُودٌ خَبَر':Added, #2: 2	وُجُودِ خَبَرَيْنِ
u'وُجُودٌ خرقة':Added, #2: 2	وُجُودِ خَبَرَيْنِ
u'وُجُودٌ خِرْقَةٌ':Added, #1: 1	وُجُودِ الْخِرْقَةِ
u'وُجُودٌ خُرُوجٌ':Added, #1: 1	وُجُودِ الْخِرْقَةِ
u'وُجُودٌ خَصْمٌ':Added, #1: 1	وُجُودِ الْخُرُوجِ
u'وُجُودٌ خِطَابٌ':Added, #2: 2	وُجُودِ الْخَصْمِ
u'وُجُودٌ خُفٌّ':Added, #1: 1	وُجُودُ خِطَابِ
u'وُجُودٌ خُفٌّ':Added, #1: 1	وُجُودَ الْخُفِّ
u'وُجُودٌ خِلاَفٌ':Added, #1: 1	وُجُودِ الْخُفِّ
u'وُجُودٌ خِلاَفٌ':Added, #1: 1	وُجُودُ خِلَافِ
u'وُجُودٌ خِلاَفٌ':Added, #2: 2	وُجُودَ الْخِلَافِ
u'وُجُودٌ خِلاَفٌ':Added, #2: 2	وُجُودُ الْخِلَافِ
u'وُجُودٌ خِلاَفٌ':Added, #2: 2	وُجُودِ الْخِلَافِ
u'وُجُودٌ خِلاَفٌ':Added, #2: 2	وُجُودَ خِلَافٍ
u'وُجُودٌ خَلَفٌ':Added, #2: 2	وُجُودُ خِلَافٍ
u'وُجُودٌ خَمْسٌ':Added, #1: 1	وُجُودُ الْخَلَفِ
u'وُجُودٌ خَوْفٌ':Added, #1: 1	وُجُودِ خَمْسِ
u'وُجُودٌ خيار':Added, #1: 1	وُجُودِ خَوْفِ
u'وُجُودٌ خِيَارٌ':Added, #1: 1	وُجُودِ الْخِيَارِ
u'وُجُودٌ دَاءٌ':Added, #1: 1	وُجُودِ الْخِيَارِ
u'وُجُودٌ دَاعِي':Added, #1: 1	وُجُودِ الدَّاءِ
u'وُجُودٌ دُرُوعٌ':Added, #1: 1	وُجُودِ الدَّاعِيَةِ
u'وُجُودٌ دَعْوَةٌ':Added, #1: 1	وُجُودِ الدّرُوعِ
u'وُجُودٌ دفع':Added, #1: 1	وُجُودُ الدَّعْوَةِ
u'وُجُودٌ دَفْعٌ':Added, #1: 1	وُجُودِ الدَّفْعِ
u'وُجُودٌ دفعة':Added, #1: 1	وُجُودِ الدَّفْعِ
u'وُجُودٌ دَفْعَةٌ':Added, #1: 1	وُجُودِ دَفْعَةٍ
u'وُجُودٌ دفن':Added, #1: 1	وُجُودِ دَفْعَةٍ
u'وُجُودٌ دَفْنٌ':Added, #1: 1	وُجُودِ الدَّفْنِ
u'وُجُودٌ دَلالَةٌ':Added, #1: 1	وُجُودِ الدَّفْنِ
u'وُجُودٌ دَلالَةٌ':Added, #1: 1	وُجُودُ الدَّلَالَةِ
u'وُجُودٌ دَلالَةٌ':Added, #1: 1	وُجُودِ دَلَالَةِ
u'وُجُودٌ دَليلٌ':Added, #3: 3	وُجُودِ الدَّلَالَةِ
u'وُجُودٌ دَليلٌ':Added, #1: 1	وُجُودَ الدَّلِيلِ
u'وُجُودٌ دَليلٌ':Added, #1: 1	وُجُودُ الدَّلِيلِ
u'وُجُودٌ دَليلٌ':Added, #1: 1	وُجُودَ دَلِيلِ
u'وُجُودٌ دَليلٌ':Added, #2: 2	وُجُودِ دَلِيلِ
u'وُجُودٌ دَمٌ':Added, #4: 4	وُجُودِ الدَّلِيلِ
u'وُجُودٌ دَمٌ':Added, #2: 2	وُجُودُ الدَّمِ
u'وُجُودٌ دَمٌ':Added, #3: 3	وُجُودَ الدَّمِ
u'وُجُودٌ دَيْنٌ':Added, #4: 4	وُجُودِ الدَّمِ
u'وُجُودٌ دَيْنٌ':Added, #1: 1	وُجُودِ دَيْنٍ
u'وُجُودٌ دَيْنٌ':Added, #2: 2	وُجُودُ الدَّيْنِ
u'وُجُودٌ ذَكاةٌ':Added, #7: 7	وُجُودِ الدَّيْنِ
u'وُجُودٌ رَابِطٌ':Added, #1: 1	وُجُودِ الذَّكَاةِ
u'وُجُودٌ رَاجِحٌ':Added, #1: 1	وُجُودُ رَابِطٍ
u'وُجُودٌ رَاحِلٌ':Added, #2: 2	وُجُودِ الرَّاجِحِ
u'وُجُودٌ رَاحِلَةٌ':Added, #1: 1	وُجُودُ رَاحِلَةٍ
u'وُجُودٌ رَأْسٌ':Added, #1: 1	وُجُودُ رَاحِلَةٍ
u'وُجُودٌ راغِب':Added, #1: 1	وُجُودَ الرَّأْسِ
u'وُجُودٌ رَافِضٌ':Added, #2: 2	وُجُودِ رَاغِبٍ
u'وُجُودٌ رَافِضَةٌ':Added, #1: 1	وُجُودِ الرَّافِضَةِ
u'وُجُودٌ رَائِحٌ':Added, #1: 1	وُجُودِ الرَّافِضَةِ
u'وُجُودٌ رَائِحٌ':Added, #1: 1	وُجُودِ رَائِحَةِ
u'وُجُودٌ رَائِحٌ':Added, #2: 2	وُجُودُ الرَّائِحَةِ
u'وُجُودٌ رَائِحٌ':Added, #3: 3	وُجُودَ الرَّائِحَةِ
u'وُجُودٌ رَائِحَةٌ':Added, #4: 4	وُجُودِ الرَّائِحَةِ
u'وُجُودٌ رَائِحَةٌ':Added, #1: 1	وُجُودِ رَائِحَةِ
u'وُجُودٌ رَائِحَةٌ':Added, #2: 2	وُجُودُ الرَّائِحَةِ
u'وُجُودٌ رَائِحَةٌ':Added, #3: 3	وُجُودَ الرَّائِحَةِ
u'وُجُودٌ رَبُّ':Added, #4: 4	وُجُودِ الرَّائِحَةِ
u'وُجُودٌ رِجَالٌ':Added, #2: 2	وُجُودَ الرَّبِّ
u'وُجُودٌ رَجُلٌ':Added, #5: 5	وُجُودِ الرِّجَالِ
u'وُجُودٌ رَجُلٌ':Added, #1: 1	وُجُودِ الرَّجُلِ
u'وُجُودٌ رَجُلٌ':Added, #1: 1	وُجُودِ الرَّجُلَيْنِ
u'وُجُودٌ رُخْصَةٌ':Added, #2: 2	وُجُودِ رَجُلٍ
u'وُجُودٌ رِدَّةٌ':Added, #1: 1	وُجُودِ الرُّخْصَةِ
u'وُجُودٌ رَفْعٌ':Added, #2: 2	وُجُودِ الرِّدَّةِ
u'وُجُودٌ رَقَبَةٌ':Added, #1: 1	وُجُودِ رَفْعِ
u'وُجُودٌ رُكْنٌ':Added, #1: 1	وُجُودَ الرَّقَبَةِ
u'وُجُودٌ رُكْن':Added, #1: 1	وُجُودِ رُكْنِ
u'وُجُودٌ رُكْنٌ':Added, #1: 1	وُجُودِ رُكْنِ
u'وُجُودٌ رُكْنٌ':Added, #1: 1	وُجُودُ رُكْنِهِ
u'وُجُودٌ رُكْن':Added, #1: 1	وُجُودِ رُكْنِهِ
u'وُجُودٌ رُكْن':Added, #1: 1	وُجُودُ رُكْنِهِ
u'وُجُودٌ رِيبَةٌ':Added, #1: 1	وُجُودِ رُكْنِهِ
u'وُجُودٌ زادٌ':Added, #1: 1	وُجُودِ الرِّيبَةِ
u'وُجُودٌ زَكاةٌ':Added, #3: 3	وُجُودِ الزَّادِ
u'وُجُودٌ زَكاةٌ':Added, #1: 1	وُجُودُ الزَّكَاةِ
u'وُجُودٌ زَمانٌ':Added, #1: 1	وُجُودِ الزَّكَاةِ
u'وُجُودٌ زَوْجٌ':Added, #1: 1	وُجُودِ الزَّمَانِ
u'وُجُودٌ زَوْجَةٌ':Added, #1: 1	وُجُودُ زَوْجٍ
u'وُجُودٌ زَوْجِيٌّ':Added, #1: 1	وُجُودُ زَوْجَةٍ
u'وُجُودٌ زَوْجِيٌّ':Added, #2: 2	وُجُودُ الزَّوْجِيَّةِ
u'وُجُودٌ زِيادَةٌ':Added, #3: 3	وُجُودِ الزَّوْجِيَّةِ
u'وُجُودٌ زِيادَةٌ':Added, #1: 1	وُجُودَ الزِّيَادَةِ
u'وُجُودٌ زِيادَةٌ':Added, #1: 1	وُجُودِ الزِّيَادَةِ
u'وُجُودٌ سَابِقٌ':Added, #1: 1	وُجُودِ زِيَادَةٍ
u'وُجُودٌ سَاتِرٌ':Added, #1: 1	وُجُودُ سَابِقٍ
u'وُجُودٌ سَائِرٌ':Added, #1: 1	وُجُودِ السَّاتِرِ
u'وُجُودٌ سِباعٌ':Added, #4: 4	وُجُودِ سَائِرِ
u'وُجُودٌ سَبَبٌ':Added, #1: 1	وُجُودِ السِّبَاعِ
u'وُجُودٌ سَبَبٌ':Added, #13: 13	وُجُودِ سَبَبِهِ
u'وُجُودٌ سَبَبٌ':Added, #1: 1	وُجُودُ سَبَبِ
u'وُجُودٌ سَبَبٌ':Added, #21: 21	وُجُودِ سَبَبِ
u'وُجُودٌ سَبَبٌ':Added, #2: 2	وُجُودُ سَبَبٍ
u'وُجُودٌ سَبَبٌ':Added, #39: 39	وُجُودِ السَّبَبِ
u'وُجُودٌ سَبَبٌ':Added, #3: 3	وُجُودَ السَّبَبِ
u'وُجُودٌ سَبَبٌ':Added, #4: 4	وُجُودِ سَبَبٍ
u'وُجُودٌ سَبْعٌ':Added, #6: 6	وُجُودُ السَّبَبِ
u'وُجُودٌ سَبْعٌ':Added, #1: 1	وُجُودِ السَّبْعِ
u'وُجُودٌ سترة':Added, #1: 1	وُجُودِ سَبْعِ
u'وُجُودٌ سُتْرَةٌ':Added, #1: 1	وُجُودِ السُّتْرَةِ
u'وُجُودٌ سِحْرٌ':Added, #1: 1	وُجُودِ السُّتْرَةِ
u'وُجُودٌ سَرقَةٌ':Added, #1: 1	وُجُودِ السِّحْرِ
u'وُجُودٌ سَرِقَةٌ':Added, #1: 1	وُجُودِ سَرِقَةِ
u'وُجُودٌ سَرقَةٌ':Added, #1: 1	وُجُودِ سَرِقَةِ
u'وُجُودٌ سَرِقَةٌ':Added, #3: 3	وُجُودِ السَّرِقَةِ
u'وُجُودٌ سِعَايَةٌ':Added, #3: 3	وُجُودِ السَّرِقَةِ
u'وُجُودٌ سَقْيٌ':Added, #1: 1	وُجُودِ السِّعَايَةِ
u'وُجُودٌ سكر':Added, #1: 1	وُجُودِ السَّقْيِ
u'وُجُودٌ سُكْرٌ':Added, #1: 1	وُجُودِ السُّكْرِ
u'وُجُودٌ سلام':Added, #1: 1	وُجُودِ السُّكْرِ
u'وُجُودٌ سَلاَمٌ':Added, #1: 1	وُجُودُ السَّلَامِ
u'وُجُودٌ سُلْطَانٌ':Added, #1: 1	وُجُودُ السَّلَامِ
u'وُجُودٌ سَلَمٌ':Added, #1: 1	وُجُودِ السُّلْطَانِ
u'وُجُودٌ سَلَمٌ':Added, #1: 1	وُجُودُ السَّلَمِ
u'وُجُودٌ سِنٌّ':Added, #1: 1	وُجُودِ السَّلَمِ
u'وُجُودٌ سنن':Added, #2: 2	وُجُودِ السِّنِّ
u'وُجُودٌ سَهْمٌ':Added, #1: 1	وُجُودِ السُّنَنِ
u'وُجُودٌ سِواكٌ':Added, #1: 1	وُجُودِ سَهْمِ
u'وُجُودٌ شَاةٌ':Added, #2: 2	وُجُودِ السِّوَاكِ
u'وُجُودٌ شَاةٌ':Added, #1: 1	وُجُودُ شَاةٍ
u'وُجُودٌ شَاةٌ':Added, #1: 1	وُجُودِ شَاةٍ
u'وُجُودٌ شَاهِدٌ':Added, #2: 2	وُجُودِ الشَّاةِ
u'وُجُودٌ شُبْهَةٌ':Added, #1: 1	وُجُودِ شَاهِدَيْنِ
u'وُجُودٌ شَجَرٌ':Added, #2: 2	وُجُودِ الشُّبْهَةِ
u'وُجُودٌ شِدَّةٌ':Added, #1: 1	وُجُودِ شَجَرٍ
u'وُجُودٌ شَرَائِطُ':Added, #1: 1	وُجُودِ الشِّدَّةِ
u'وُجُودٌ شَرَائِطُ':Added, #1: 1	وُجُودِ شَرَائِطِ
u'وُجُودٌ شَرَائِطُ':Added, #2: 2	وُجُودَ الشَّرَائِطِ
u'وُجُودٌ شَرَائِطُ':Added, #3: 3	وُجُودِ الشَّرَائِطِ
u'وُجُودٌ شَرْطٌ':Added, #4: 4	وُجُودِ شَرَائِطِهِ
u'وُجُودٌ شَرْطٌ':Added, #15: 15	وُجُودَ الشَّرْطِ
u'وُجُودٌ شَرْطٌ':Added, #16: 16	وُجُودِ شَرْطِهِ
u'وُجُودٌ شَرْطٌ':Added, #1: 1	وُجُودِ الشَّرْطَيْنِ
u'وُجُودٌ شَرْطٌ':Added, #1: 1	وُجُودِ شَرْطٍ
u'وُجُودٌ شَرْطٌ':Added, #263: 263	وُجُودِ الشَّرْطِ
u'وُجُودٌ شَرْطٌ':Added, #3: 3	وُجُودُ شَرْطِ
u'وُجُودٌ شَرْطٌ':Added, #3: 3	وُجُودَ شَرْطِهِ
u'وُجُودٌ شَرْطٌ':Added, #4: 4	وُجُودَ شَرْطِ
u'وُجُودٌ شَرْطٌ':Added, #9: 9	وُجُودُ الشَّرْطِ
u'وُجُودٌ شَرْعٌ':Added, #9: 9	وُجُودِ شَرْطِ
u'وُجُودٌ شُرُوطٌ':Added, #1: 1	وُجُودِ الشَّرْعِ
u'وُجُودٌ شُرُوطٌ':Added, #1: 1	وُجُودُ الشُّرُوطِ
u'وُجُودٌ شُرُوطٌ':Added, #2: 2	وُجُودُ شُرُوطِ
u'وُجُودٌ شُرُوطٌ':Added, #2: 2	وُجُودِ شُرُوطِ
u'وُجُودٌ شُرُوطٌ':Added, #3: 3	وُجُودِ شُرُوطِهِ
u'وُجُودٌ شَرِيكٌ':Added, #7: 7	وُجُودِ الشُّرُوطِ
u'وُجُودٌ شَعْرٌ':Added, #3: 3	وُجُودِ الشَّرِيكِ
u'وُجُودٌ شُعُورٌ':Added, #1: 1	وُجُودُ شَعْرٍ
u'وُجُودٌ شَكٌّ':Added, #1: 1	وُجُودِ الشُّعُورِ
u'وُجُودٌ شَكٌّ':Added, #1: 1	وُجُودَ الشَّكِّ
u'وُجُودٌ شِكايَة':Added, #1: 1	وُجُودُ الشَّكِّ
u'وُجُودٌ شَهْرٌ':Added, #1: 1	وُجُودِ الشِّكَايَةِ
u'وُجُودٌ شَهْوَةٌ':Added, #1: 1	وُجُودِ شَهْرَيْنِ
u'وُجُودٌ شَهْوَةٌ':Added, #1: 1	وُجُودِ شَهْوَةِ
u'وُجُودٌ شَهْوَةٌ':Added, #2: 2	وُجُودُ الشَّهْوَةِ
u'وُجُودٌ شُهُودٌ':Added, #2: 2	وُجُودِ الشَّهْوَةِ
u'وُجُودٌ شَيْءٌ':Added, #1: 1	وُجُودَ الشُّهُودِ
u'وُجُودٌ شَيْءٌ':Added, #12: 12	وُجُودُ الشَّيْءِ
u'وُجُودٌ شَيْءٌ':Added, #16: 16	وُجُودِ شَيْءٍ
u'وُجُودٌ شَيْءٌ':Added, #2: 2	وُجُودَ شَيْءٍ
u'وُجُودٌ شَيْءٌ':Added, #3: 3	وُجُودُ شَيْءٍ
u'وُجُودٌ صَاحِبٌ':Added, #8: 8	وُجُودِ الشَّيْءِ
u'وُجُودٌ صَالِحٌ':Added, #2: 2	وُجُودِ صَاحِبِهِ
u'وُجُودٌ صَالِح':Added, #1: 1	وُجُودِ الصَّالِحِ
u'وُجُودٌ صَانِعٌ':Added, #1: 1	وُجُودِ الصَّالِحِ
u'وُجُودٌ صَانِعٌ':Added, #1: 1	وُجُودِ الصَّانِعِ
u'وُجُودٌ صَبٌّ':Added, #1: 1	وُجُودِ صَانِعِهِ
u'وُجُودٌ صَبِيٌّ':Added, #1: 1	وُجُودِ الصَّبِّ
u'وُجُودٌ صِحَّةٌ':Added, #1: 1	وُجُودِ الصَّبِيِّ
u'وُجُودٌ صِحَّةٌ':Added, #1: 1	وُجُودِ الصِّحَّةِ
u'وُجُودٌ صِرَاطٌ':Added, #1: 1	وُجُودُ صِحَّةِ
u'وُجُودٌ صِرَاطٌ':Added, #1: 1	وُجُودَ الصِّرَاطِ
u'وُجُودٌ صُعُودٌ':Added, #1: 1	وُجُودُ الصِّرَاطِ
u'وُجُودٌ صغار':Added, #1: 1	وُجُودُ الصُّعُودِ
u'وُجُودٌ صِغَرٌ':Added, #1: 1	وُجُودِ الصِّغَارِ
u'وُجُودٌ صِغَرٌ':Added, #1: 1	وُجُودَ الصِّغَرِ
u'وُجُودٌ صِفَةٌ':Added, #1: 1	وُجُودُ الصِّغَرِ
u'وُجُودٌ صِفَةٌ':Added, #1: 1	وُجُودُ صِفَتِهِ
u'وُجُودٌ صِفَةٌ':Added, #1: 1	وُجُودِ صِفَتِهِ
u'وُجُودٌ صِفَةٌ':Added, #2: 2	وُجُودِ صِفَةِ
u'وُجُودٌ صِفَةٌ':Added, #4: 4	وُجُودَ الصِّفَةِ
u'وُجُودٌ صِفَةٌ':Added, #60: 60	وُجُودِ الصِّفَةِ
u'وُجُودٌ صَلاَةٌ':Added, #7: 7	وُجُودُ الصِّفَةِ
u'وُجُودٌ صَلاَةٌ':Added, #1: 1	وُجُودُ صَلَاةٍ
u'وُجُودٌ صَلاَةٌ':Added, #2: 2	وُجُودِ الصَّلَاةِ
u'وُجُودٌ صلح':Added, #3: 3	وُجُودُ الصَّلَاةِ
u'وُجُودٌ صُلْحٌ':Added, #1: 1	وُجُودُ الصُّلْحِ
u'وُجُودٌ صنع':Added, #1: 1	وُجُودُ الصُّلْحِ
u'وُجُودٌ صُنْعٌ':Added, #3: 3	وُجُودِ الصُّنْعِ
u'وُجُودٌ صَوْتٌ':Added, #3: 3	وُجُودِ الصُّنْعِ
u'وُجُودٌ صُورَةٌ':Added, #1: 1	وُجُودِ الصَّوْتِ
u'وُجُودٌ صُورَةٌ':Added, #1: 1	وُجُودِ صُورَةِ
u'وُجُودٌ صُورَةٌ':Added, #2: 2	وُجُودِ الصُّورَةِ
u'وُجُودٌ صَوْمٌ':Added, #2: 2	وُجُودِ صُورَتِهِ
u'وُجُودٌ صِيغَةٌ':Added, #4: 4	وُجُودُ صَوْمٍ
u'وُجُودٌ صِيغَةٌ':Added, #1: 1	وُجُودِ الصِّيغَةِ
u'وُجُودٌ ضَابِطٌ':Added, #3: 3	وُجُودُ الصِّيغَةِ
u'وُجُودٌ ضَامِنٌ':Added, #1: 1	وُجُودِ ضَابِطِ
u'وُجُودٌ ضِدٌّ':Added, #2: 2	وُجُودِ الضَّامِنِ
u'وُجُودٌ ضِدٌّ':Added, #1: 1	وُجُودَ الضِّدِّ
u'وُجُودٌ ضَرْبٌ':Added, #1: 1	وُجُودِ الضِّدَّيْنِ
u'وُجُودٌ ضَرَرٌ':Added, #1: 1	وُجُودَ الضَّرْبِ
u'وُجُودٌ ضَمَانٌ':Added, #1: 1	وُجُودُ الضَّرَرِ
u'وُجُودٌ ضَمَانٌ':Added, #1: 1	وُجُودَ الضَّمَانِ
u'وُجُودٌ طَاعَةٌ':Added, #1: 1	وُجُودِ ضَمَانِهِ
u'وُجُودٌ طَاهِرٌ':Added, #1: 1	وُجُودُ الطَّاعَةِ
u'وُجُودٌ طَرِيقٌ':Added, #1: 1	وُجُودِ طَاهِرٍ
u'وُجُودٌ طعام':Added, #1: 1	وُجُودُ طَرِيقِ
u'وُجُودٌ طَعَامٌ':Added, #1: 1	وُجُودُ الطَّعَامِ
u'وُجُودٌ طعام':Added, #1: 1	وُجُودُ الطَّعَامِ
u'وُجُودٌ طَعَامٌ':Added, #2: 2	وُجُودِ الطَّعَامِ
u'وُجُودٌ طَعْمٌ':Added, #2: 2	وُجُودِ الطَّعَامِ
u'وُجُودٌ طُعْمٌ':Added, #1: 1	وُجُودِ الطَّعْمِ
u'وُجُودٌ طَلاَقٌ':Added, #1: 1	وُجُودَ الطُّعْمِ
u'وُجُودٌ طَلاَقٌ':Added, #1: 1	وُجُودَ الطَّلَاقِ
u'وُجُودٌ طلب':Added, #1: 1	وُجُودِ الطَّلَاقِ
u'وُجُودٌ طَلَبٌ':Added, #1: 1	وُجُودِ الطَّلَبِ
u'وُجُودٌ طَلْقٌ':Added, #1: 1	وُجُودِ الطَّلَبِ
u'وُجُودٌ طَهَارَةٌ':Added, #1: 1	وُجُودُ الطَّلْقِ
u'وُجُودٌ طَهَارَةٌ':Added, #1: 1	وُجُودُ الطَّهَارَةِ
u'وُجُودٌ طَهَارَةٌ':Added, #2: 2	وُجُودَ الطَّهَارَةِ
u'وُجُودٌ طهر':Added, #2: 2	وُجُودِ الطَّهَارَةِ
u'وُجُودٌ طُهْرٌ':Added, #1: 1	وُجُودُ الطُّهْرِ
u'وُجُودٌ طَوْلٌ':Added, #1: 1	وُجُودُ الطُّهْرِ
u'وُجُودٌ طَوْلٌ':Added, #1: 1	وُجُودَ الطَّوْلِ
u'وُجُودٌ طَوْلٌ':Added, #1: 1	وُجُودُ الطَّوْلِ
u'وُجُودٌ عَارٌ':Added, #1: 1	وُجُودِ طَوْلِ
u'وُجُودٌ عَاصِمٌ':Added, #1: 1	وُجُودِ الْعَارِ
u'وُجُودٌ عَاطِفٌ':Added, #1: 1	وُجُودِ الْعَاصِمِ
u'وُجُودٌ عَاقٌّ':Added, #1: 1	وُجُودُ عَاطِفٍ
u'وُجُودٌ عَاقِلٌ':Added, #1: 1	وُجُودِ الْعَاقِّ
u'وُجُودٌ عَالَمٌ':Added, #1: 1	وُجُودِ الْعَاقِلَةِ
u'وُجُودٌ عَالَمٌ':Added, #1: 1	وُجُودُ الْعَالَمِ
u'وُجُودٌ عَالِمٌ':Added, #1: 1	وُجُودِ الْعَالَمِ
u'وُجُودٌ عَامٌّ':Added, #1: 1	وُجُودِ عَالِمٍ
u'وُجُودٌ عتق':Added, #1: 1	وُجُودُ الْعَامِّ
u'وُجُودٌ عِتْقٌ':Added, #1: 1	وُجُودِ الْعِتْقِ
u'وُجُودٌ عَدَالَةٌ':Added, #1: 1	وُجُودِ الْعِتْقِ
u'وُجُودٌ عَدَالَةٌ':Added, #1: 1	وُجُودُ الْعَدَالَةِ
u'وُجُودٌ عَدَاوَةٌ':Added, #1: 1	وُجُودِ الْعَدَالَةِ
u'وُجُودٌ عِدَّةٌ':Added, #1: 1	وُجُودُ الْعَدَاوَةِ
u'وُجُودٌ عَدَدٌ':Added, #1: 1	وُجُودِ الْعِدَّةِ
u'وُجُودٌ عَدْلٌ':Added, #1: 1	وُجُودُ الْعَدَدِ
u'وُجُودٌ عَدَمٌ':Added, #1: 1	وُجُودِ الْعَدْلَيْنِ
u'وُجُودٌ عَدُوٌّ':Added, #2: 2	وُجُودِ عَدَمِ
u'وُجُودٌ عُذْرٌ':Added, #1: 1	وُجُودِ عَدُوٍّ
u'وُجُودٌ عُذْرٌ':Added, #3: 3	وُجُودُ الْعُذْرِ
u'وُجُودٌ عُضْوٌ':Added, #5: 5	وُجُودِ الْعُذْرِ
u'وُجُودٌ عَقْدٌ':Added, #1: 1	وُجُودِ الْعُضْوِ
u'وُجُودٌ عَقْدٌ':Added, #1: 1	وُجُودَ الْعَقْدِ
u'وُجُودٌ عَقْلٌ':Added, #7: 7	وُجُودِ الْعَقْدِ
u'وُجُودٌ عَقْلٌ':Added, #1: 1	وُجُودِ عَقْلِهِ
u'وُجُودٌ عُقُوبَةٌ':Added, #3: 3	وُجُودِ الْعَقْلِ
u'وُجُودٌ عَلاَقَةٌ':Added, #1: 1	وُجُودِ الْعُقُوبَةِ
u'وُجُودٌ عَلاَقَةٌ':Added, #1: 1	وُجُودَ الْعَلَاقَةِ
u'وُجُودٌ عَلاَمَةٌ':Added, #1: 1	وُجُودُ الْعَلَاقَةِ
u'وُجُودٌ عَلاَمَةٌ':Added, #1: 1	وُجُودِ الْعَلَامَةِ
u'وُجُودٌ عِلَّةٌ':Added, #1: 1	وُجُودُ عَلَامَةٍ
u'وُجُودٌ عِلَّةٌ':Added, #1: 1	وُجُودَ عِلَّةٍ
u'وُجُودٌ عِلَّةٌ':Added, #1: 1	وُجُودَ عِلَّةِ
u'وُجُودٌ عِلَّةٌ':Added, #1: 1	وُجُودُ عِلَّةِ
u'وُجُودٌ عِلَّةٌ':Added, #3: 3	وُجُودَ عِلَّتِهِ
u'وُجُودٌ عِلَّةٌ':Added, #43: 43	وُجُودِ الْعِلَّةِ
u'وُجُودٌ عِلَّةٌ':Added, #5: 5	وُجُودَ الْعِلَّةِ
u'وُجُودٌ عِلَّةٌ':Added, #6: 6	وُجُودِ عِلَّةِ
u'وُجُودٌ علم':Added, #8: 8	وُجُودُ الْعِلَّةِ
u'وُجُودٌ علم':Added, #2: 2	وُجُودَ الْعِلْمِ
u'وُجُودٌ عِلْمٌ':Added, #2: 2	وُجُودُ الْعِلْمِ
u'وُجُودٌ عِلْمٌ':Added, #2: 2	وُجُودَ الْعِلْمِ
u'وُجُودٌ علم':Added, #2: 2	وُجُودُ الْعِلْمِ
u'وُجُودٌ عِلْمٌ':Added, #4: 4	وُجُودِ الْعِلْمِ
u'وُجُودٌ عَمَلٌ':Added, #4: 4	وُجُودِ الْعِلْمِ
u'وُجُودٌ عَمَلٌ':Added, #1: 1	وُجُودُ الْعَمَلِ
u'وُجُودٌ عَمَلٌ':Added, #1: 1	وُجُودِ الْعَمَلِ
u'وُجُودٌ عَمَلٌ':Added, #1: 1	وُجُودِ عَمَلٍ
u'وُجُودٌ عَنَاقِيدُ':Added, #1: 1	وُجُودِ عَمَلَيْنِ
u'وُجُودٌ عَوْدٌ':Added, #1: 1	وُجُودِ الْعَنَاقِيدِ
u'وُجُودٌ عِوَضٌ':Added, #1: 1	وُجُودَ عَوْدِهِ
u'وُجُودٌ عَيْبٌ':Added, #1: 1	وُجُودِ الْعِوَضِ
u'وُجُودٌ عَيْبٌ':Added, #1: 1	وُجُودَ عَيْبَيْنِ
u'وُجُودٌ عَيْبٌ':Added, #2: 2	وُجُودَ الْعَيْبِ
u'وُجُودٌ عَيْبٌ':Added, #3: 3	وُجُودِ عَيْبٍ
u'وُجُودٌ عَيْبٌ':Added, #4: 4	وُجُودُ الْعَيْبِ
u'وُجُودٌ عين':Added, #8: 8	وُجُودِ الْعَيْبِ
u'وُجُودٌ عين':Added, #1: 1	وُجُودُ عَيْنِ
u'وُجُودٌ عَيْنٌ':Added, #1: 1	وُجُودِ عَيْنِ
u'وُجُودٌ عَيْنٌ':Added, #1: 1	وُجُودُ عَيْنِ
u'وُجُودٌ عَيْنٌ':Added, #1: 1	وُجُودِ عَيْنٍ
u'وُجُودٌ عَيْن':Added, #1: 1	وُجُودِ عَيْنِ
u'وُجُودٌ عَيْن':Added, #1: 1	وُجُودُ عَيْنِ
u'وُجُودٌ عَيْن':Added, #1: 1	وُجُودِ عَيْنٍ
u'وُجُودٌ غَامِرٌ':Added, #1: 1	وُجُودِ عَيْنِ
u'وُجُودٌ غَايَةٌ':Added, #1: 1	وُجُودِ الْغَامِرِ
u'وُجُودٌ غَايَةٌ':Added, #1: 1	وُجُودِ غَايَتِهِ
u'وُجُودٌ غَدٌ':Added, #3: 3	وُجُودِ الْغَايَةِ
u'وُجُودٌ غِذَاءٌ':Added, #1: 1	وُجُودِ الْغَدِ
u'وُجُودٌ غَرَرٌ':Added, #1: 1	وُجُودِ الْغِذَاءِ
u'وُجُودٌ غضب':Added, #1: 1	وُجُودُ الْغَرَرِ
u'وُجُودٌ غَضَبٌ':Added, #1: 1	وُجُودِ الْغَضَبِ
u'وُجُودٌ غُلاَمٌ':Added, #1: 1	وُجُودِ الْغَضَبِ
u'وُجُودٌ غَلَبَةٌ':Added, #1: 1	وُجُودَ الْغُلَامِ
u'وُجُودٌ غَلَّةٌ':Added, #1: 1	وُجُودِ غَلَبَاتِ
u'وُجُودٌ غَنَمٌ':Added, #9: 9	وُجُودِ الْغَلَّةِ
u'وُجُودٌ غير':Added, #1: 1	وُجُودَ غَنَمٍ
u'وُجُودٌ غَيْرٌ':Added, #1: 1	وُجُودِ غَيْرِ
u'وُجُودٌ غير':Added, #1: 1	وُجُودِ غَيْرِ
u'وُجُودٌ غير':Added, #1: 1	وُجُودَ غَيْرِهِ
u'وُجُودٌ غَيْرٌ':Added, #1: 1	وُجُودُ غَيْرِهِ
u'وُجُودٌ غَيْرٌ':Added, #1: 1	وُجُودَ غَيْرِهِ
u'وُجُودٌ غير':Added, #1: 1	وُجُودُ غَيْرِهِ
u'وُجُودٌ غَيْرٌ':Added, #23: 23	وُجُودِ غَيْرِهِ
u'وُجُودٌ غير':Added, #23: 23	وُجُودِ غَيْرِهِ
u'وُجُودٌ غَيْرٌ':Added, #2: 2	وُجُودِ الْغَيْرِ
u'وُجُودٌ غيم':Added, #2: 2	وُجُودِ الْغَيْرِ
u'وُجُودٌ غَيْمٌ':Added, #1: 1	وُجُودِ الْغَيْمِ
u'وُجُودٌ فَأْرٌ':Added, #1: 1	وُجُودِ الْغَيْمِ
u'وُجُودٌ فَارِقٌ':Added, #1: 1	وُجُودُ الْفَأْرَةِ
u'وُجُودٌ فَارِقٌ':Added, #1: 1	وُجُودِ فَارِقٍ
u'وُجُودٌ فَاضِلٌ':Added, #3: 3	وُجُودِ الْفَارِقِ
u'وُجُودٌ فَاضِلٌ':Added, #1: 1	وُجُودِ الْفَاضِلِ
u'وُجُودٌ فَاعِلٌ':Added, #1: 1	وُجُودِ فَاضِلٍ
u'وُجُودٌ فَاعِلٌ':Added, #1: 1	وُجُودُ الْفَاعِلِ
u'وُجُودٌ فِرَاشٌ':Added, #1: 1	وُجُودِ الْفَاعِلِ
u'وُجُودٌ فرد':Added, #1: 1	وُجُودِ الْفِرَاشِ
u'وُجُودٌ فَرْدٌ':Added, #1: 1	وُجُودِ الْفَرْدِ
u'وُجُودٌ فَرْدٌ':Added, #1: 1	وُجُودِ الْفَرْدِ
u'وُجُودٌ فَرْعٌ':Added, #2: 2	وُجُودِ فَرْدٍ
u'وُجُودٌ فَرْعٌ':Added, #1: 1	وُجُودِ الْفَرْعِ
u'وُجُودٌ فَرْعٌ':Added, #1: 1	وُجُودِ فَرْعٍ
u'وُجُودٌ فرق':Added, #1: 1	وُجُودِ فَرْعِ
u'وُجُودٌ فَرْقٌ':Added, #1: 1	وُجُودِ الْفَرْقِ
u'وُجُودٌ فَسْخٌ':Added, #1: 1	وُجُودِ الْفَرْقِ
u'وُجُودٌ فَصْلٌ':Added, #1: 1	وُجُودِ الْفَسْخِ
u'وُجُودٌ فِعْلٌ':Added, #1: 1	وُجُودِ الْفَصْلِ
u'وُجُودٌ فِعْلٌ':Added, #1: 1	وُجُودُ الْفِعْلَيْنِ
u'وُجُودٌ فِعْلٌ':Added, #1: 1	وُجُودِ الْفِعْلَيْنِ
u'وُجُودٌ فِعْلٌ':Added, #1: 1	وُجُودُ فِعْلِ
u'وُجُودٌ فِعْلٌ':Added, #1: 1	وُجُودِ فِعْلِ
u'وُجُودٌ فِعْلٌ':Added, #1: 1	وُجُودُ فِعْلِهِ
u'وُجُودٌ فِعْلٌ':Added, #2: 2	وُجُودَ فِعْلٍ
u'وُجُودٌ فِعْلٌ':Added, #3: 3	وُجُودَ الْفِعْلِ
u'وُجُودٌ فِعْلٌ':Added, #4: 4	وُجُودُ الْفِعْلِ
u'وُجُودٌ فقر':Added, #5: 5	وُجُودِ الْفِعْلِ
u'وُجُودٌ فَقْرٌ':Added, #1: 1	وُجُودُ الْفَقْرِ
u'وُجُودٌ فلان':Added, #1: 1	وُجُودُ الْفَقْرِ
u'وُجُودٌ فلان':Added, #2: 2	وُجُودِ رَاغِبٍ
u'وُجُودٌ قَابِلٌ':Added, #3: 3	وُجُودِ حَاتِمٍ
u'وُجُودٌ قَادِرٌ':Added, #2: 2	وُجُودِ قَابِلٍ
u'وُجُودٌ قَاذِفٌ':Added, #1: 1	وُجُودِ الْقَادِرِ
u'وُجُودٌ قَاذِفٌ':Added, #1: 1	وُجُودُ الْقَاذِفِ
u'وُجُودٌ قَاطِعٌ':Added, #1: 1	وُجُودِ الْقَاذِفِ
u'وُجُودٌ قَائِدٌ':Added, #1: 1	وُجُودَ الْقَاطِعِ
u'وُجُودٌ قَبْضٌ':Added, #1: 1	وُجُودُ الْقَائِدِ
u'وُجُودٌ قَبْضٌ':Added, #2: 2	وُجُودُ قَبْضِهِ
u'وُجُودٌ قَبُولٌ':Added, #3: 3	وُجُودِ الْقَبْضِ
u'وُجُودٌ قَبُولٌ':Added, #1: 1	وُجُودِ الْقَبُولِ
u'وُجُودٌ قَبِيحٌ':Added, #3: 3	وُجُودُ الْقَبُولِ
u'وُجُودٌ قَتْلٌ':Added, #1: 1	وُجُودِ الْقَبِيحِ
u'وُجُودٌ قتل':Added, #1: 1	وُجُودِ قَتْلٍ
u'وُجُودٌ قَتْلٌ':Added, #3: 3	وُجُودِ الْقَتْلِ
u'وُجُودٌ قَتِيلٌ':Added, #3: 3	وُجُودِ الْقَتْلِ
u'وُجُودٌ قَتِيلٌ':Added, #1: 1	وُجُودَ الْقَتِيلِ
u'وُجُودٌ قَتِيلٌ':Added, #1: 1	وُجُودِ الْقَتِيلِ
u'وُجُودٌ قَدْرٌ':Added, #3: 3	وُجُودُ الْقَتِيلِ
u'وُجُودٌ قَدْرٌ':Added, #1: 1	وُجُودِ الْقَدْرِ
u'وُجُودٌ قدرة':Added, #1: 1	وُجُودِ قَدْرِ
u'وُجُودٌ قُدْرَةٌ':Added, #1: 1	وُجُودِ الْقُدْرَةِ
u'وُجُودٌ قدرة':Added, #1: 1	وُجُودِ الْقُدْرَةِ
u'وُجُودٌ قُدْرَةٌ':Added, #3: 3	وُجُودُ الْقُدْرَةِ
u'وُجُودٌ قَدُومٌ':Added, #3: 3	وُجُودُ الْقُدْرَةِ
u'وُجُودٌ قُدُومٌ':Added, #1: 1	وُجُودَ الْقَدُومَيْنِ
u'وُجُودٌ قُرْآنٌ':Added, #2: 2	وُجُودِ الْقُدُومِ
u'وُجُودٌ قرائن':Added, #1: 1	وُجُودَ الْقُرْآنِ
u'وُجُودٌ قُرْبَانٌ':Added, #1: 1	وُجُودَ الْقَرَائِنِ
u'وُجُودٌ قُرْبَةٌ':Added, #1: 1	وُجُودِ الْقُرْبَانِ
u'وُجُودٌ قَرِيبٌ':Added, #1: 1	وُجُودِ الْقُرْبَةِ
u'وُجُودٌ قَرِينٌ':Added, #3: 3	وُجُودِ الْقَرِيبِ
u'وُجُودٌ قَرِينٌ':Added, #1: 1	وُجُودُ الْقَرِينَةِ
u'وُجُودٌ قَرِينٌ':Added, #1: 1	وُجُودِ قَرِينَةِ
u'وُجُودٌ قِسْمٌ':Added, #2: 2	وُجُودِ الْقَرِينَةِ
u'وُجُودٌ قِسْمٌ':Added, #1: 1	وُجُودِ الْقِسْمِ
u'وُجُودٌ قصاص':Added, #1: 1	وُجُودِ قِسْمٍ
u'وُجُودٌ قِصَاصٌ':Added, #1: 1	وُجُودِ الْقِصَاصِ
u'وُجُودٌ قَصْدٌ':Added, #1: 1	وُجُودِ الْقِصَاصِ
u'وُجُودٌ قَصْدٌ':Added, #1: 1	وُجُودِ الْقَصْدِ
u'وُجُودٌ قَضَاءٌ':Added, #1: 1	وُجُودِ قَصْدِ
u'وُجُودٌ قُطْبٌ':Added, #1: 1	وُجُودِ الْقَضَاءِ
u'وُجُودٌ قَوَد':Added, #1: 1	وُجُودِ الْقُطْبِ
u'وُجُودٌ قول':Added, #1: 1	وُجُودُ الْقَوَدِ
u'وُجُودٌ قول':Added, #1: 1	وُجُودُ الْقَوْلِ
u'وُجُودٌ قَوْلٌ':Added, #1: 1	وُجُودِ الْقَوْلِ
u'وُجُودٌ قَوْلٌ':Added, #1: 1	وُجُودُ الْقَوْلِ
u'وُجُودٌ قَوْلٌ':Added, #1: 1	وُجُودِ الْقَوْلِ
u'وُجُودٌ قول':Added, #1: 1	وُجُودُ الْقَوْلَيْنِ
u'وُجُودٌ قَوْلٌ':Added, #1: 1	وُجُودِ قَوْلِ
u'وُجُودٌ قَوْلٌ':Added, #1: 1	وُجُودُ قَوْلٍ
u'وُجُودٌ قَوْلٌ':Added, #1: 1	وُجُودِ قَوْلِ
u'وُجُودٌ قَوْمٌ':Added, #2: 2	وُجُودَ قَوْلٍ
u'وُجُودٌ قِيَاسٌ':Added, #1: 1	وُجُودُ الْقَوْمِ
u'وُجُودٌ قَيْدٌ':Added, #1: 1	وُجُودِ الْقِيَاسِ
u'وُجُودٌ قَيْدٌ':Added, #1: 1	وُجُودَ الْقَيْدِ
u'وُجُودٌ قَيْدٌ':Added, #1: 1	وُجُودِ الْقَيْدِ
u'وُجُودٌ قَيْدٌ':Added, #1: 1	وُجُودِ قَيْدٍ
u'وُجُودٌ كَاتِبٌ':Added, #1: 1	وُجُودِ قَيْدِ
u'وُجُودٌ كبار':Added, #1: 1	وُجُودِ الْكَاتِبِ
u'وُجُودٌ كِتَابٌ':Added, #1: 1	وُجُودَ الْكِبَارِ
u'وُجُودٌ كَثْرَةٌ':Added, #1: 1	وُجُودِ الْكِتَابِ
u'وُجُودٌ كَرَاهِيَةٌ':Added, #1: 1	وُجُودَ كَثْرَةٍ
u'وُجُودٌ كَسْبٌ':Added, #1: 1	وُجُودِ الْكَرَاهِيَةِ
u'وُجُودٌ كَسْبٌ':Added, #1: 1	وُجُودُ الْكَسْبِ
u'وُجُودٌ كَفَاءةٌ':Added, #1: 1	وُجُودِ كَسْبِ
u'وُجُودٌ كَفَالَةٌ':Added, #1: 1	وُجُودِ الْكَفَاءَةِ
u'وُجُودٌ كفر':Added, #2: 2	وُجُودِ الْكَفَالَةِ
u'وُجُودٌ كُفْرٌ':Added, #1: 1	وُجُودِ الْكُفْرِ
u'وُجُودٌ كَلاَمٌ':Added, #1: 1	وُجُودِ الْكُفْرِ
u'وُجُودٌ كَلاَمٌ':Added, #1: 1	وُجُودَ الْكَلَامِ
u'وُجُودٌ كَلام':Added, #1: 1	وُجُودُ الْكَلَامِ
u'وُجُودٌ كَلاَمٌ':Added, #1: 1	وُجُودَ الْكَلَامَيْنِ
u'وُجُودٌ كَمَالٌ':Added, #2: 2	وُجُودِ الْكَلَامِ
u'وُجُودٌ لاَحِقٌ':Added, #1: 1	وُجُودِ كَمَالِ
u'وُجُودٌ لاَزِمٌ':Added, #1: 1	وُجُودِ اللَّاحِقِ
u'وُجُودٌ لاَزِمٌ':Added, #2: 2	وُجُودَ اللَّازِمِ
u'وُجُودٌ لَذَّةٌ':Added, #4: 4	وُجُودِ اللَّازِمِ
u'وُجُودٌ لُزُومٌ':Added, #1: 1	وُجُودِ اللَّذَّةِ
u'وُجُودٌ لِصٌّ':Added, #1: 1	وُجُودِ اللُّزُومِ
u'وُجُودٌ لَفْظٌ':Added, #1: 1	وُجُودِ اللِّصِّ
u'وُجُودٌ لَفْظٌ':Added, #1: 1	وُجُودَ اللَّفْظِ
u'وُجُودٌ لَفْظٌ':Added, #1: 1	وُجُودُ اللَّفْظِ
u'وُجُودٌ لَفْظٌ':Added, #1: 1	وُجُودُ لَفْظٍ
u'وُجُودٌ لَفْظٌ':Added, #1: 1	وُجُودُ لَفْظِهِ
u'وُجُودٌ لَيْلٌ':Added, #6: 6	وُجُودِ اللَّفْظِ
u'وُجُودٌ مَاءٌ':Added, #1: 1	وُجُودِ اللَّيْلِ
u'وُجُودٌ مَاءٌ':Added, #1: 1	وُجُودَ مَاءٍ
u'وُجُودٌ مَاءٌ':Added, #22: 22	وُجُودَ الْمَاءِ
u'وُجُودٌ مَاءٌ':Added, #31: 31	وُجُودُ الْمَاءِ
u'وُجُودٌ مَاءٌ':Added, #5: 5	وُجُودِ مَاءٍ
u'وُجُودٌ مَالٌ':Added, #95: 95	وُجُودِ الْمَاءِ
u'وُجُودٌ مَالٌ':Added, #1: 1	وُجُودَ الْمَالِ
u'وُجُودٌ مَالٌ':Added, #1: 1	وُجُودَ مَالٍ
u'وُجُودٌ مَالٌ':Added, #3: 3	وُجُودُ الْمَالِ
u'وُجُودٌ مَالِكٌ':Added, #4: 4	وُجُودِ مَالٍ
u'وُجُودٌ مَالِكٌ':Added, #1: 1	وُجُودَ الْمَالِكِ
u'وُجُودٌ مَالِكٌ':Added, #1: 1	وُجُودُ مَالِكٍ
u'وُجُودٌ مَالِكٌ':Added, #1: 1	وُجُودِ مَالِكٍ
u'وُجُودٌ مَالِيٌّ':Added, #2: 2	وُجُودِ الْمَالِكِ
u'وُجُودٌ مَأْمُورٌ':Added, #1: 1	وُجُودُ الْمَالِيَّةِ
u'وُجُودٌ مَانِعٌ':Added, #3: 3	وُجُودِ الْمَأْمُورِ
u'وُجُودٌ مَانِعٌ':Added, #21: 21	وُجُودِ الْمَانِعِ
u'وُجُودٌ مَانِعٌ':Added, #2: 2	وُجُودُ الْمَانِعِ
u'وُجُودٌ مَانِعٌ':Added, #2: 2	وُجُودَ مَانِعِ
u'وُجُودٌ مَانِعٌ':Added, #3: 3	وُجُودَ مَانِعٍ
u'وُجُودٌ مَانِعٌ':Added, #6: 6	وُجُودَ الْمَانِعِ
u'وُجُودٌ مُبَادَلَةٌ':Added, #8: 8	وُجُودِ مَانِعٍ
u'وُجُودٌ مُبَاشِرٌ':Added, #1: 1	وُجُودُ الْمُبَادَلَةِ
u'وُجُودٌ مُبَاشَرَةٌ':Added, #1: 1	وُجُودِ الْمُبَاشِرِ
u'وُجُودٌ مُبَاشَرَةٌ':Added, #1: 1	وُجُودِ الْمُبَاشَرَةِ
u'وُجُودٌ مُبَايَعَةٌ':Added, #1: 1	وُجُودِ مُبَاشَرَةِ
u'وُجُودٌ مُبِيحٌ':Added, #1: 1	وُجُودِ الْمُبَايَعَةِ
u'وُجُودٌ مُبِيحٌ':Added, #2: 2	وُجُودِ الْمُبِيحِ
u'وُجُودٌ مَبِيعٌ':Added, #4: 4	وُجُودَ الْمُبِيحِ
u'وُجُودٌ مُتَبَرِّعٌ':Added, #1: 1	وُجُودُ الْمَبِيعِ
u'وُجُودٌ مُتَبَرِّعٌ':Added, #1: 1	وُجُودُ الْمُتَبَرِّعِ
u'وُجُودٌ مُتَعَلِّقٌ':Added, #3: 3	وُجُودِ مُتَبَرِّعٍ
u'وُجُودٌ مُتَمَتِّعٌ':Added, #1: 1	وُجُودُ مُتَعَلِّقِهِ
u'وُجُودٌ مثل':Added, #1: 1	وُجُودِ الْمُتَمَتِّعِ
u'وُجُودٌ مِثْلٌ':Added, #1: 1	وُجُودُ الْمِثْلِ
u'وُجُودٌ مثل':Added, #1: 1	وُجُودُ الْمِثْلِ
u'وُجُودٌ مثل':Added, #1: 1	وُجُودُ مِثْلِ
u'وُجُودٌ مِثْلٌ':Added, #1: 1	وُجُودِ مِثْلِ
u'وُجُودٌ مِثْلٌ':Added, #1: 1	وُجُودُ مِثْلِ
u'وُجُودٌ مثل':Added, #1: 1	وُجُودِ مِثْلِ
u'وُجُودٌ مثل':Added, #1: 1	وُجُودُ مِثْلِهِ
u'وُجُودٌ مِثْلٌ':Added, #1: 1	وُجُودِ مِثْلِهِ
u'وُجُودٌ مِثْلٌ':Added, #1: 1	وُجُودُ مِثْلِهِ
u'وُجُودٌ مثل':Added, #1: 1	وُجُودِ مِثْلِهِ
u'وُجُودٌ مِثْلٌ':Added, #3: 3	وُجُودَ الْمِثْلِ
u'وُجُودٌ مثل':Added, #3: 3	وُجُودَ الْمِثْلِ
u'وُجُودٌ مِثْلٌ':Added, #4: 4	وُجُودِ الْمِثْلِ
u'وُجُودٌ مَجَازٌ':Added, #4: 4	وُجُودِ الْمِثْلِ
u'وُجُودٌ مَجَازٌ':Added, #2: 2	وُجُودُ الْمَجَازِ
u'وُجُودٌ مُجْبِرٌ':Added, #3: 3	وُجُودِ الْمَجَازِ
u'وُجُودٌ مُجْتَهِد':Added, #2: 2	وُجُودِ الْمُجْبِرِ
u'وُجُودٌ مُجْتَهِد':Added, #1: 1	وُجُودَ الْمُجْتَهِدِ
u'وُجُودٌ مُجْتَهِد':Added, #1: 1	وُجُودُ الْمُجْتَهِدِ
u'وُجُودٌ مُجْتَهِد':Added, #1: 1	وُجُودِ الْمُجْتَهِدِ
u'وُجُودٌ مُجِيزٌ':Added, #2: 2	وُجُودِ مُجْتَهِدٍ
u'وُجُودٌ مُحَابَاةٌ':Added, #1: 1	وُجُودُ الْمُجِيزِ
u'وُجُودٌ مَحَارِمُ':Added, #1: 1	وُجُودَ مُحَابَاةٍ
u'وُجُودٌ مَحَارِيبُ':Added, #1: 1	وُجُودِ الْمَحَارِمِ
u'وُجُودٌ مَحْرَمٌ':Added, #1: 1	وُجُودِ الْمَحَارِيبِ
u'وُجُودٌ مُحَرَّمٌ':Added, #1: 1	وُجُودُ الْمَحْرَمِ
u'وُجُودٌ مَحْرَمٌ':Added, #1: 1	وُجُودُ الْمُحَرَّمِ
u'وُجُودٌ مَحْرَمٌ':Added, #2: 2	وُجُودِ مَحْرَمٍ
u'وُجُودٌ مَحَلٌّ':Added, #4: 4	وُجُودِ الْمَحْرَمِ
u'وُجُودٌ مَحَلٌّ':Added, #1: 1	وُجُودَ الْمَحَلِّ
u'وُجُودٌ مَحَلٌّ':Added, #1: 1	وُجُودَ مَحَلِّهِ
u'وُجُودٌ مُخَاطَبٌ':Added, #2: 2	وُجُودِ الْمَحَلِّ
u'وُجُودٌ مُخَالِفٌ':Added, #2: 2	وُجُودِ الْمُخَاطَبِ
u'وُجُودٌ مُخَالَفَةٌ':Added, #1: 1	وُجُودِ الْمُخَالِفِ
u'وُجُودٌ مُخْبِرٌ':Added, #1: 1	وُجُودُ مُخَالَفَتِهِ
u'وُجُودٌ مُخْبِرٌ':Added, #1: 1	وُجُودِ الْمُخْبِرِ
u'وُجُودٌ مُخَصَّصٌ':Added, #1: 1	وُجُودِ مُخْبِرٍ
u'وُجُودٌ مَدْخُولٌ':Added, #2: 2	وُجُودِ الْمُخَصَّصِ
u'وُجُودٌ مُدَرِّسٌ':Added, #1: 1	وُجُودَ مَدْخُولِ
u'وُجُودٌ مَدْلُولٌ':Added, #1: 1	وُجُودُ مُدَرِّسٍ
u'وُجُودٌ مَذْكُورٌ':Added, #1: 1	وُجُودَ الْمَدْلُولِ
u'وُجُودٌ مُرَجِّحٌ':Added, #1: 1	وُجُودُ الْمَذْكُورِ
u'وُجُودٌ مُرَخَّصٌ':Added, #1: 1	وُجُودُ مُرَجِّحٍ
u'وُجُودٌ مَرَضٌ':Added, #1: 1	وُجُودُ الْمُرَخَّصِ
u'وُجُودٌ مَرَضٌ':Added, #1: 1	وُجُودِ الْمَرَضِ
u'وُجُودٌ مُرْضِعٌ':Added, #1: 1	وُجُودَ مَرَضِ
u'وُجُودٌ مُرْضِعٌ':Added, #1: 1	وُجُودِ الْمُرْضِعَةِ
u'وُجُودٌ مُرْضِعٌ':Added, #1: 1	وُجُودِ مُرْضِعَاتٍ
u'وُجُودٌ مُسَاوَاةٌ':Added, #3: 3	وُجُودِ مُرْضِعَةٍ
u'وُجُودٌ مُسَاوَاةٌ':Added, #1: 1	وُجُودَ الْمُسَاوَاةِ
u'وُجُودٌ مُسَاوِي':Added, #1: 1	وُجُودِ الْمُسَاوَاةِ
u'وُجُودٌ مُسَبِّبٌ':Added, #2: 2	وُجُودِ مُسَاوِيهِ
u'وُجُودٌ مُسْتَحِقٌّ':Added, #1: 1	وُجُودُ الْمُسَبِّبِ
u'وُجُودٌ مُسْتَحِيلٌ':Added, #1: 1	وُجُودِ الْمُسْتَحِقِّ
u'وُجُودٌ مُسْتَفاد':Added, #1: 1	وُجُودِ الْمُسْتَحِيلِ
u'وُجُودٌ مَسْجِدٌ':Added, #1: 1	وُجُودَ الْمُسْتَفَادِ
u'وُجُودٌ مُسَلَّمٌ':Added, #1: 1	وُجُودُ مَسْجِدٍ
u'وُجُودٌ مُسْلِمٌ':Added, #1: 1	وُجُودِ الْمُسَلَّمِ
u'وُجُودٌ مُسْلِمٌ':Added, #1: 1	وُجُودِ مُسْلِمٍ
u'وُجُودٌ مُسَوِّغٌ':Added, #3: 3	وُجُودِ مُسْلِمَةٍ
u'وُجُودٌ مُسَوِّغٌ':Added, #1: 1	وُجُودُ الْمُسَوِّغِ
u'وُجُودٌ مُسَوِّغٌ':Added, #1: 1	وُجُودِ الْمُسَوِّغِ
u'وُجُودٌ مُسَوِّغٌ':Added, #1: 1	وُجُودُ مُسَوِّغٍ
u'وُجُودٌ مُشَابَهَةٌ':Added, #1: 1	وُجُودِ مُسَوِّغِ
u'وُجُودٌ مُشَارَكَةٌ':Added, #1: 1	وُجُودِ الْمُشَابَهَةِ
u'وُجُودٌ مَشَاقُّ':Added, #1: 1	وُجُودِ الْمُشَارَكَةِ
u'وُجُودٌ مُشَبَّهٌ':Added, #1: 1	وُجُودِ الْمَشَاقِّ
u'وُجُودٌ مُشْتَرَكٌ':Added, #1: 1	وُجُودُ الْمُشَبَّهِ
u'وُجُودٌ مُشْتَرَكٌ':Added, #1: 1	وُجُودُ مُشْتَرَكٍ
u'وُجُودٌ مَشْرُوطٌ':Added, #2: 2	وُجُودِ الْمُشْتَرَكِ
u'وُجُودٌ مَشْرُوطٌ':Added, #3: 3	وُجُودِ الْمَشْرُوطِ
u'وُجُودٌ مَشْرُوطٌ':Added, #5: 5	وُجُودَ الْمَشْرُوطِ
u'وُجُودٌ مَشَقَّةٌ':Added, #6: 6	وُجُودُ الْمَشْرُوطِ
u'وُجُودٌ مَشَقَّةٌ':Added, #1: 1	وُجُودُ الْمَشَقَّةِ
u'وُجُودٌ مَشِيئَةٌ':Added, #1: 1	وُجُودِ الْمَشَقَّةِ
u'وُجُودٌ مَشِيئَةٌ':Added, #1: 1	وُجُودِ الْمَشِيئَةِ
u'وُجُودٌ مَشِيئَةٌ':Added, #1: 1	وُجُودُ مَشِيئَتِهِ
u'وُجُودٌ مَصٌّ':Added, #8: 8	وُجُودُ الْمَشِيئَةِ
u'وُجُودٌ مَصَالِحُ':Added, #1: 1	وُجُودَ مَصِّ
u'وُجُودٌ مُصَحِّحٌ':Added, #1: 1	وُجُودُ الْمَصَالِحِ
u'وُجُودٌ مَصْدَرٌ':Added, #1: 1	وُجُودِ مُصَحِّحٍ
u'وُجُودٌ مَصْلَحَةٌ':Added, #1: 1	وُجُودِ الْمَصْدَرِ
u'وُجُودٌ مَصْلَحَةٌ':Added, #1: 1	وُجُودِ الْمَصْلَحَةِ
u'وُجُودٌ مُصَوِّتٌ':Added, #2: 2	وُجُودُ الْمَصْلَحَةِ
u'وُجُودٌ مُضَافٌ':Added, #1: 1	وُجُودِ مُصَوِّتِهِ
u'وُجُودٌ مَضْمُونٌ':Added, #1: 1	وُجُودِ الْمُضَافِ
u'وُجُودٌ مَطَرٌ':Added, #1: 1	وُجُودِ الْمَضْمُونَيْنِ
u'وُجُودٌ مَطَرٌ':Added, #1: 1	وُجُودِ مَطَرٍ
u'وُجُودٌ مَطَرٌ':Added, #2: 2	وُجُودُ الْمَطَرِ
u'وُجُودٌ مُطْلَقٌ':Added, #2: 2	وُجُودِ الْمَطَرِ
u'وُجُودٌ مَظَانُّ':Added, #2: 2	وُجُودِ الْمُطْلَقِ
u'وُجُودٌ مُعارِضٌ':Added, #1: 1	وُجُودِ مَظَانِّ
u'وُجُودٌ مُعارِضٌ':Added, #1: 1	وُجُودِ مُعَارِضِهِ
u'وُجُودٌ مُعارِضٌ':Added, #2: 2	وُجُودِ مُعَارِضٍ
u'وُجُودٌ مُعَارَضَةٌ':Added, #6: 6	وُجُودِ الْمُعَارِضِ
u'وُجُودٌ مُعَانِدٌ':Added, #1: 1	وُجُودِ الْمُعَارَضَةِ
u'وُجُودٌ مَعْطُوف':Added, #1: 1	وُجُودَ مُعَانِدِهِ
u'وُجُودٌ مَعْقُودٌ':Added, #1: 1	وُجُودِ مَعْطُوفٍ
u'وُجُودٌ مُعَلَّقٌ':Added, #2: 2	وُجُودَ الْمَعْقُودِ
u'وُجُودٌ مُعَلَّقٌ':Added, #18: 18	وُجُودِ الْمُعَلَّقِ
u'وُجُودٌ مُعَلَّقٌ':Added, #1: 1	وُجُود الْمُعَلَّقِ
u'وُجُودٌ مُعَلَّقٌ':Added, #4: 4	وُجُودَ الْمُعَلَّقِ
u'وُجُودٌ مَعْلُولٌ':Added, #5: 5	وُجُودُ الْمُعَلَّقِ
u'وُجُودٌ مَعْلُولٌ':Added, #1: 1	وُجُودَ الْمَعْلُولِ
u'وُجُودٌ مُعَوَّضٌ':Added, #2: 2	وُجُودِ الْمَعْلُولِ
u'وُجُودٌ مُعَيَّنٌ':Added, #1: 1	وُجُودَ الْمُعَوَّضِ
u'وُجُودٌ مُعَيَّنٌ':Added, #1: 1	وُجُودُ الْمُعَيَّنِ
u'وُجُودٌ مُعَيَّنٌ':Added, #1: 1	وُجُودِ الْمُعَيَّنِ
u'وُجُودٌ مُغَيِّرٌ':Added, #2: 2	وُجُودَ مُعَيَّنٍ
u'وُجُودٌ مِفْتَاحٌ':Added, #1: 1	وُجُودِ مُغَيِّرٍ
u'وُجُودٌ مِفْتَاحٌ':Added, #1: 1	وُجُودِ مِفْتَاحِهِ
u'وُجُودٌ مُفْتَقِرٌ':Added, #2: 2	وُجُودُ الْمِفْتَاحِ
u'وُجُودٌ مُفْسِدٌ':Added, #1: 1	وُجُودُ الْمُفْتَقِرِ
u'وُجُودٌ مَفْسَدَةٌ':Added, #2: 2	وُجُودَ الْمُفْسِدِ
u'وُجُودٌ مُفْطِر':Added, #1: 1	وُجُودِ مَفْسَدَةٍ
u'وُجُودٌ مُقَارَنٌ':Added, #1: 1	وُجُودِ الْمُفْطِرِ
u'وُجُودٌ مُقَارَنَةٌ':Added, #1: 1	وُجُودُ الْمُقَارَنَةِ
u'وُجُودٌ مَقْبُولٌ':Added, #1: 1	وُجُودُ الْمُقَارَنَةِ
u'وُجُودٌ مَقْبُولٌ':Added, #1: 1	وُجُودَ الْمَقْبُولِ
u'وُجُودٌ مُقْتَضىً':Added, #1: 1	وُجُودُ الْمَقْبُولِ
u'وُجُودٌ مُقْتَضىً':Added, #1: 1	وُجُودُ مُقْتَضِيهِ
u'وُجُودٌ مَقْتُولٌ':Added, #2: 2	وُجُودِ مُقْتَضِيهِ
u'وُجُودٌ مَقْتُولٌ':Added, #1: 1	وُجُودَ الْمَقْتُولِ
u'وُجُودٌ مُقَدِّمٌ':Added, #1: 1	وُجُودُ الْمَقْتُولِ
u'وُجُودٌ مُقَدَّمٌ':Added, #1: 1	وُجُودِ مُقَدِّمَاتِ
u'وُجُودٌ مُقَدِّمَةٌ':Added, #2: 2	وُجُودِ الْمُقَدَّمِ
u'وُجُودٌ مَقْدُورٌ':Added, #1: 1	وُجُودِ مُقَدِّمَاتِ
u'وُجُودٌ مَقْضِيّ':Added, #2: 2	وُجُودِ الْمَقْدُورِ
u'وُجُودٌ مُكَلَّفٌ':Added, #1: 1	وُجُودَ الْمَقْضِيِّ
u'وُجُودٌ مُكَلَّفٌ':Added, #1: 1	وُجُودِ الْمُكَلَّفِ
u'وُجُودٌ مِكْيَالٌ':Added, #1: 1	وُجُودِ مُكَلَّفٍ
u'وُجُودٌ مُلاَزَمَةٌ':Added, #1: 1	وُجُودِ الْمِكْيَالِ
u'وُجُودٌ مَلْزُوم':Added, #1: 1	وُجُودِ الْمُلَازَمَةِ
u'وُجُودٌ مَلْزُوم':Added, #2: 2	وُجُودُ الْمَلْزُومِ
u'وُجُودٌ مَلْزُوم':Added, #2: 2	وُجُودِ الْمَلْزُومِ
u'وُجُودٌ مِلْكٌ':Added, #5: 5	وُجُودَ الْمَلْزُومِ
u'وُجُودٌ مِلْكٌ':Added, #1: 1	وُجُودِ مِلْكٍ
u'وُجُودٌ مِلْكٌ':Added, #1: 1	وُجُودِ مِلْكِ
u'وُجُودٌ مِلْكٌ':Added, #3: 3	وُجُودَ الْمِلْكِ
u'وُجُودٌ مِلْكٌ':Added, #5: 5	وُجُودُ الْمِلْكِ
u'وُجُودٌ مُمَاثَلَةٌ':Added, #8: 8	وُجُودِ الْمِلْكِ
u'وُجُودٌ مُمْكِنٌ':Added, #1: 1	وُجُودِ الْمُمَاثَلَةِ
u'وُجُودٌ مُمْكِن':Added, #1: 1	وُجُودُ الْمُمْكِنِ
u'وُجُودٌ مَنٌّ':Added, #1: 1	وُجُودُ الْمُمْكِنِ
u'وُجُودٌ مُنَاسِبٌ':Added, #1: 1	وُجُودُ الْمَنِّ
u'وُجُودٌ مُنَاسَبَةٌ':Added, #1: 1	وُجُودَ الْمُنَاسِبِ
u'وُجُودٌ مَنَاطٌ':Added, #1: 1	وُجُودِ مُنَاسَبَةِ
u'وُجُودٌ مَنَاطٌ':Added, #1: 1	وُجُودِ الْمَنَاطِ
u'وُجُودٌ مَنَاطٌ':Added, #1: 1	وُجُودِ مَنَاطِ
u'وُجُودٌ مَنْصُوبٌ':Added, #1: 1	وُجُودِ مَنَاطِهِ
u'وُجُودٌ مَنْصُوصٌ':Added, #1: 1	وُجُودُ الْمَنْصُوبِ
u'وُجُودٌ مَنْفَذٌ':Added, #2: 2	وُجُودِ الْمَنْصُوصِ
u'وُجُودٌ مَنْفَعَةٌ':Added, #1: 1	وُجُودِ الْمَنْفَذِ
u'وُجُودٌ مَنْهِيٌّ':Added, #5: 5	وُجُودِ الْمَنْفَعَةِ
u'وُجُودٌ مَنِيٌّ':Added, #3: 3	وُجُودِ الْمَنْهِيِّ
u'وُجُودٌ مَهْرٌ':Added, #1: 1	وُجُودِ الْمَنِيِّ
u'وُجُودٌ مُوَافَقَةٌ':Added, #1: 1	وُجُودَ مَهْرِ
u'وُجُودٌ مَوَانِعُ':Added, #2: 2	وُجُودِ الْمُوَافَقَةِ
u'وُجُودٌ مَوْتٌ':Added, #1: 1	وُجُودِ الْمَوَانِعِ
u'وُجُودٌ مُؤَثِّرٌ':Added, #1: 1	وُجُودِ الْمَوْتِ
u'وُجُودٌ مُؤَثِّرٌ':Added, #1: 1	وُجُودَ الْمُؤَثِّرِ
u'وُجُودٌ مُؤَثِّرٌ':Added, #1: 1	وُجُودُ الْمُؤَثِّرِ
u'وُجُودٌ مُوجِبٌ':Added, #2: 2	وُجُودِ الْمُؤَثِّرِ
u'وُجُودٌ مُوجِبٌ':Added, #1: 1	وُجُودِ مُوجِبِهِ
u'وُجُودٌ مَوْصُوفٌ':Added, #5: 5	وُجُودِ الْمُوجِبِ
u'وُجُودٌ مَوْصُوفٌ':Added, #1: 1	وُجُودَ الْمَوْصُوفِ
u'وُجُودٌ مَوْضُوعٌ':Added, #1: 1	وُجُودِ الْمَوْصُوفِ
u'وُجُودٌ مَوْقُوفٌ':Added, #3: 3	وُجُودِ الْمَوْضُوعِ
u'وُجُودٌ مَوْلُودٌ':Added, #1: 1	وُجُودِ الْمَوْقُوفِ
u'وُجُودٌ مَيْتٌ':Added, #1: 1	وُجُودَ مَوْلُودٍ
u'وُجُودٌ مَيْتَةٌ':Added, #1: 1	وُجُودِ الْمَيْتَةِ
u'وُجُودٌ نَاسِخٌ':Added, #1: 1	وُجُودِ الْمَيْتَةِ
u'وُجُودٌ نَاسِخ':Added, #2: 2	وُجُودِ النَّاسِخِ
u'وُجُودٌ نَاظِرٌ':Added, #2: 2	وُجُودِ النَّاسِخِ
u'وُجُودٌ نَاظِرٌ':Added, #2: 2	وُجُودِ نَاظِرٍ
u'وُجُودٌ نَافِي':Added, #3: 3	وُجُودِ النَّاظِرِ
u'وُجُودٌ نَجَاسَةٌ':Added, #1: 1	وُجُودِ النَّافِيَةِ
u'وُجُودٌ نَجَاسَةٌ':Added, #10: 10	وُجُودِ النَّجَاسَةِ
u'وُجُودٌ نَجَاسَةٌ':Added, #1: 1	وُجُودُ نَجَاسَةٍ
u'وُجُودٌ نَحْوٌ':Added, #2: 2	وُجُودَ النَّجَاسَةِ
u'وُجُودٌ نَدَمٌ':Added, #1: 1	وُجُودِ نَحْوِ
u'وُجُودٌ نِساءٌ':Added, #1: 1	وُجُودِ النَّدَمِ
u'وُجُودٌ نِساءٌ':Added, #1: 1	وُجُودَ النِّسَاءِ
u'وُجُودٌ نَسَبٌ':Added, #4: 4	وُجُودِ النِّسَاءِ
u'وُجُودٌ نِسْبَةٌ':Added, #2: 2	وُجُودِ النَّسَبِ
u'وُجُودٌ نِسْوَةٌ':Added, #1: 1	وُجُودُ النِّسْبَةِ
u'وُجُودٌ نَصٌّ':Added, #1: 1	وُجُودِ نِسْوَةٍ
u'وُجُودٌ نَصٌّ':Added, #1: 1	وُجُودُ النَّصِّ
u'وُجُودٌ نَصٌّ':Added, #1: 1	وُجُودَ نَصٍّ
u'وُجُودٌ نَصٌّ':Added, #2: 2	وُجُودَ النَّصِّ
u'وُجُودٌ نصاب':Added, #9: 9	وُجُودِ النَّصِّ
u'وُجُودٌ نِصَابٌ':Added, #3: 3	وُجُودِ النِّصَابِ
u'وُجُودٌ نصب':Added, #3: 3	وُجُودِ النِّصَابِ
u'وُجُودٌ نَصْبٌ':Added, #1: 1	وُجُودُ نَصْبِ
u'وُجُودٌ نَصِيبٌ':Added, #1: 1	وُجُودُ نَصْبِ
u'وُجُودٌ نَصِيبٌ':Added, #1: 1	وُجُودِ نَصِيبٍ
u'وُجُودٌ نُطْقٌ':Added, #2: 2	وُجُودَ النَّصِيبَيْنِ
u'وُجُودٌ نَعْلٌ':Added, #1: 1	وُجُودِ النُّطْقِ
u'وُجُودٌ نَعْلٌ':Added, #2: 2	وُجُودِ نَعْلٍ
u'وُجُودٌ نفرة':Added, #4: 4	وُجُودِ النَّعْلَيْنِ
u'وُجُودٌ نَفْرَةٌ':Added, #1: 1	وُجُودُ النَّفْرَةِ
u'وُجُودٌ نَفْسٌ':Added, #1: 1	وُجُودُ النَّفْرَةِ
u'وُجُودٌ نَفَقَةٌ':Added, #2: 2	وُجُودِ نَفْسِ
u'وُجُودٌ نُفُوذٌ':Added, #2: 2	وُجُودُ نَفَقَةِ
u'وُجُودٌ نُفُوسٌ':Added, #1: 1	وُجُودِ النُّفُوذِ
u'وُجُودٌ نَقْدٌ':Added, #1: 1	وُجُودِ النُّفُوسِ
u'وُجُودٌ نَقْد':Added, #1: 1	وُجُودِ النَّقْدِ
u'وُجُودٌ نقل':Added, #1: 1	وُجُودِ النَّقْدِ
u'وُجُودٌ نَقْلٌ':Added, #3: 3	وُجُودِ النَّقْلِ
u'وُجُودٌ نكاح':Added, #3: 3	وُجُودِ النَّقْلِ
u'وُجُودٌ نِكَاحٌ':Added, #1: 1	وُجُودِ نِكَاحِ
u'وُجُودٌ نكاح':Added, #1: 1	وُجُودِ نِكَاحِ
u'وُجُودٌ نِكَاحٌ':Added, #2: 2	وُجُودِ النِّكَاحِ
u'وُجُودٌ نِكَايَةٌ':Added, #2: 2	وُجُودِ النِّكَاحِ
u'وُجُودٌ نَهْيٌ':Added, #1: 1	وُجُودُ النِّكَايَةِ
u'وُجُودٌ نِيَابَةٌ':Added, #1: 1	وُجُودِ النَّهْيِ
u'وُجُودٌ نِيَّةٌ':Added, #1: 1	وُجُودِ النِّيَابَةِ
u'وُجُودٌ نِيَّةٌ':Added, #10: 10	وُجُودِ النِّيَّةِ
u'وُجُودٌ نِيَّةٌ':Added, #1: 1	وُجُودَ النِّيَّةِ
u'وُجُودٌ نِيَّةٌ':Added, #1: 1	وُجُودُ نِيَّةِ
u'وُجُودٌ نِيَّةٌ':Added, #2: 2	وُجُودَ نِيَّةِ
u'وُجُودٌ نِيَّةٌ':Added, #3: 3	وُجُودِ نِيَّةِ
u'وُجُودٌ هِجَاءٌ':Added, #7: 7	وُجُودُ النِّيَّةِ
u'وُجُودٌ هِجَاءٌ':Added, #1: 1	وُجُودَ الْهِجَاءِ
u'وُجُودٌ هَدْيٌ':Added, #1: 1	وُجُودِ الْهِجَاءِ
u'وُجُودٌ هَدِيٌّ':Added, #1: 1	وُجُودُ الْهَدْيِ
u'وُجُودٌ هَدْيٌ':Added, #1: 1	وُجُودِ الْهَدِيَّةِ
u'وُجُودٌ هَدِيَّةٌ':Added, #4: 4	وُجُودِ الْهَدْيِ
u'وُجُودٌ هِلاَلٌ':Added, #1: 1	وُجُودِ الْهَدِيَّةِ
u'وُجُودٌ وَاجِبٌ':Added, #1: 1	وُجُود الْهِلَالِ
u'وُجُودٌ وَاجِبٌ':Added, #1: 1	وُجُودُ الْوَاجِبِ
u'وُجُودٌ وَاجِبٌ':Added, #2: 2	وُجُودِ الْوَاجِبِ
u'وُجُودٌ واحد':Added, #2: 2	وُجُودِ وَاجِبِ
u'وُجُودٌ وَاحِدٌ':Added, #1: 1	وُجُودِ الْوَاحِدَةِ
u'وُجُودٌ واحد':Added, #1: 1	وُجُودِ الْوَاحِدَةِ
u'وُجُودٌ وَاحِدٌ':Added, #1: 1	وُجُودُ وَاحِدَةِ
u'وُجُودٌ واحد':Added, #1: 1	وُجُودُ وَاحِدَةِ
u'وُجُودٌ وَاحِدٌ':Added, #2: 2	وُجُودُ وَاحِدٍ
u'وُجُودٌ واحد':Added, #2: 2	وُجُودُ وَاحِدٍ
u'وُجُودٌ وَاحِدٌ':Added, #5: 5	وُجُودِ وَاحِدٍ
u'وُجُودٌ وَارِثٌ':Added, #5: 5	وُجُودِ وَاحِدٍ
u'وُجُودٌ وَارِثٌ':Added, #1: 1	وُجُودِ الْوَارِثِ
u'وُجُودٌ وَارِثٌ':Added, #1: 1	وُجُودِ وَارِثٍ
u'وُجُودٌ وَاضِحٌ':Added, #4: 4	وُجُودُ الْوَارِثِ
u'وُجُودٌ وُجُوبٌ':Added, #1: 1	وُجُودِ وَاضِحَةِ
u'وُجُودٌ وُجُوبٌ':Added, #1: 1	وُجُودُ وُجُوبِ
u'وُجُودٌ وُجُوبٌ':Added, #1: 1	وُجُودِ وُجُوبِ
u'وُجُودٌ وَرَثَةٌ':Added, #2: 2	وُجُودِ الْوُجُوبِ
u'وُجُودٌ وَصْفٌ':Added, #1: 1	وُجُودِ الْوَرَثَةِ
u'وُجُودٌ وَصْفٌ':Added, #1: 1	وُجُودُ الْوَصْفِ
u'وُجُودٌ وَصْفٌ':Added, #1: 1	وُجُودِ وَصْفِهِ
u'وُجُودٌ وَصْفٌ':Added, #2: 2	وُجُودَ الْوَصْفِ
u'وُجُودٌ وَصْفٌ':Added, #2: 2	وُجُودِ وَصْفٍ
u'وُجُودٌ وَصِيٌّ':Added, #9: 9	وُجُودِ الْوَصْفِ
u'وُجُودٌ وَصِيٌّ':Added, #1: 1	وُجُودَ الْوَصِيَّةِ
u'وُجُودٌ وَصِيٌّ':Added, #1: 1	وُجُودِ وَصِيِّهِ
u'وُجُودٌ وَصِيَّةٌ':Added, #2: 2	وُجُودِ الْوَصِيِّ
u'وُجُودٌ وُضُوءٌ':Added, #1: 1	وُجُودَ الْوَصِيَّةِ
u'وُجُودٌ وَطْءٌ':Added, #1: 1	وُجُودَ الْوُضُوءِ
u'وُجُودٌ وَطْءٌ':Added, #1: 1	وُجُودُ الْوَطْءِ
u'وُجُودٌ وَعِيدٌ':Added, #2: 2	وُجُودِ الْوَطْءِ
u'وُجُودٌ وَقْتٌ':Added, #1: 1	وُجُودِ الْوَعِيدِ
u'وُجُودٌ وَقْتٌ':Added, #1: 1	وُجُودُ الْوَقْتِ
u'وُجُودٌ وَقْتٌ':Added, #1: 1	وُجُودُ وَقْتِ
u'وُجُودٌ وَقْفٌ':Added, #4: 4	وُجُودِ الْوَقْتِ
u'وُجُودٌ وَكِيلٌ':Added, #1: 1	وُجُودِ الْوَقْفِ
u'وُجُودٌ ولد':Added, #1: 1	وُجُودِ الْوَكِيلِ
u'وُجُودٌ وَلَدٌ':Added, #12: 12	وُجُودِ الْوَلَدِ
u'وُجُودٌ ولد':Added, #12: 12	وُجُودِ الْوَلَدِ
u'وُجُودٌ ولد':Added, #1: 1	وُجُودَ الْوَلَدِ
u'وُجُودٌ وَلَدٌ':Added, #1: 1	وُجُودُ الْوَلَدِ
u'وُجُودٌ وَلَدٌ':Added, #1: 1	وُجُودَ الْوَلَدِ
u'وُجُودٌ وَلَدٌ':Added, #1: 1	وُجُودُ الْوَلَدِ
u'وُجُودٌ وَلِيٌّ':Added, #2: 2	وُجُودِ وَلَدٍ
u'وُجُودٌ وَهْمٌ':Added, #4: 4	وُجُودِ الْوَلِيِّ
u'وُجُودٌ يسار':Added, #1: 1	وُجُودُ الْوَهْمِ
u'وُجُودٌ يَسَارٌ':Added, #1: 1	وُجُودُ الْيَسَارِ
u'وُجُودٌ يَمِينٌ':Added, #1: 1	وُجُودُ الْيَسَارِ
u'وُجُودٌ يَمِينٌ':Added, #1: 1	وُجُودَ الْيَمِينِ
u'وُجُوهٌ إِبْطَالٌ':Added, #1: 1	وُجُودِ الْيَمِينِ
u'وُجُوهٌ إِثْبَاتٌ':Added, #1: 1	وُجُوهِ الْإِبْطَالِ
u'وُجُوهٌ آجُرٌّ':Added, #2: 2	وُجُوهِ الْإِثْبَاتِ
u'وُجُوهٌ إِحْرَامٌ':Added, #1: 1	وُجُوهِ الْآجُرِّ
u'وُجُوهٌ أَحْكَامٌ':Added, #3: 3	وُجُوهِ الْإِحْرَامِ
u'وُجُوهٌ آرَاءٌ':Added, #1: 1	وُجُوهِ أَحْكَامِ
u'وُجُوهٌ أَرْبَعَةٌ':Added, #1: 1	وُجُوهُ الْآرَاءِ
u'وُجُوهٌ اِسْتِرْسَالٌ':Added, #5: 5	وُجُوهٍ أَرْبَعَةٍ
u'وُجُوهٌ أسْفَارٌ':Added, #1: 1	وُجُوهِ اسْتِرْسَالِهِ
u'وُجُوهٌ أشباه':Added, #1: 1	وُجُوهُ الْأَسْفَارِ
u'وُجُوهٌ أشْبَاهٌ':Added, #3: 3	وُجُوهَ الْأَشْبَاهِ
u'وُجُوهٌ أَشْبَاهٌ':Added, #3: 3	وُجُوهَ الْأَشْبَاهِ
u'وُجُوهٌ أَصْحَابٌ':Added, #3: 3	وُجُوهَ الْأَشْبَاهِ
u'وُجُوهٌ أَصْحَابٌ':Added, #1: 1	وُجُوهَ أَصْحَابِ
u'وُجُوهٌ أَصْحَابٌ':Added, #1: 1	وُجُوهِ أَصْحَابِهِ
u'وُجُوهٌ أَعْذَارٌ':Added, #1: 1	وُجُوهُ الْأَصْحَابِ
u'وُجُوهٌ إِعْرابٌ':Added, #1: 1	وُجُوهِ الْأَعْذَارِ
u'وُجُوهٌ أَقْوَالٌ':Added, #5: 5	وُجُوهِ الْإِعْرَابِ
u'وُجُوهٌ أَقْوَامٌ':Added, #1: 1	وُجُوهَ الْأَقْوَالِ
u'وُجُوهٌ إكْرَامٌ':Added, #2: 2	وُجُوهِ أَقْوَامٍ
u'وُجُوهٌ إكْرَاهٌ':Added, #2: 2	وُجُوهِ الْإِكْرَامِ
u'وُجُوهٌ أكل':Added, #1: 1	وُجُوهِ الْإِكْرَاهِ
u'وُجُوهٌ أَكْلٌ':Added, #1: 1	وُجُوهَ أَكْلِ
u'وُجُوهٌ أكل':Added, #1: 1	وُجُوهَ أَكْلِ
u'وُجُوهٌ أَكْلٌ':Added, #1: 1	وُجُوهِ الْأَكْلِ
u'وُجُوهٌ إمَامَةٌ':Added, #1: 1	وُجُوهِ الْأَكْلِ
u'وُجُوهٌ أنصار':Added, #1: 1	وُجُوهِ الْإِمَامَةِ
u'وُجُوهٌ أَنْصارٌ':Added, #1: 1	وُجُوهُ الْأَنْصَارِ
u'وُجُوهٌ أَنْصَارٌ':Added, #1: 1	وُجُوهُ الْأَنْصَارِ
u'وُجُوهٌ أهْلٌ':Added, #1: 1	وُجُوهُ الْأَنْصَارِ
u'وُجُوهٌ أهْلٌ':Added, #1: 1	وُجُوهَ أَهْلِ
u'وُجُوهٌ أهْلٌ':Added, #1: 1	وُجُوهِ أَهْلِ
u'وُجُوهٌ إِيمَاءةٌ':Added, #3: 3	وُجُوهُ أَهْلِ
u'وُجُوهٌ بِرٌّ':Added, #1: 1	وُجُوهِ الْإِيمَاءَاتِ
u'وُجُوهٌ بصرة':Added, #22: 22	وُجُوهِ الْبِرِّ
u'وُجُوهٌ بَعْضٌ':Added, #1: 1	وُجُوهِ الْبَصْرَةِ
u'وُجُوهٌ بَعْضٌ':Added, #1: 1	وُجُوهُ الْبَعْضِ
u'وُجُوهٌ بَعْضٌ':Added, #1: 1	وُجُوهَ بَعْضٍ
u'وُجُوهٌ بَيَانٌ':Added, #1: 1	وُجُوهَ بَعْضِ
u'وُجُوهٌ بَيْعٌ':Added, #1: 1	وُجُوهِ الْبَيَانِ
u'وُجُوهٌ تَجْرِبَةٌ':Added, #2: 2	وُجُوهِ الْبَيْعِ
u'وُجُوهٌ تَدْبِيرٌ':Added, #1: 1	وُجُوهِ التَّجْرِبَةِ
u'وُجُوهٌ تَرْجِيحٌ':Added, #2: 2	وُجُوهِ التَّدْبِيرِ
u'وُجُوهٌ تَرْجِيحٌ':Added, #1: 1	وُجُوهِ التَّرْجِيحَاتِ
u'وُجُوهٌ تَرْجِيحٌ':Added, #1: 1	وُجُوهِ تَرْجِيحِ
u'وُجُوهٌ تَرْجِيحٌ':Added, #1: 1	وُجُوهِ تَرْجِيحَاتِ
u'وُجُوهٌ تَسْبِيحٌ':Added, #6: 6	وُجُوهِ التَّرْجِيحِ
u'وُجُوهٌ تَشْبِيهٌ':Added, #1: 1	وُجُوهِ التَّسْبِيحِ
u'وُجُوهٌ تَعْظِيمٌ':Added, #1: 1	وُجُوهِ التَّشْبِيهَاتِ
u'وُجُوهٌ تَفاوُت':Added, #1: 1	وُجُوهِ التَّعْظِيمِ
u'وُجُوهٌ تَفْرِيقٌ':Added, #1: 1	وُجُوهِ التَّفَاوُتِ
u'وُجُوهٌ تَنَاصُرٌ':Added, #1: 1	وُجُوهِ التَّفْرِيقِ
u'وُجُوهٌ ثَعَالِبُ':Added, #1: 1	وُجُوهِ التَّنَاصُرِ
u'وُجُوهٌ ثَلاثَةٌ':Added, #1: 1	وُجُوهُ الثّعَالِبِ
u'وُجُوهٌ جَهَلَةٌ':Added, #12: 12	وُجُوهٍ ثَلَاثَةٍ
u'وُجُوهٌ جَوَابٌ':Added, #1: 1	وُجُوهَ الْجَهَلَةِ
u'وُجُوهٌ جِيرَانٌ':Added, #1: 1	وُجُوهِ الْجَوَابِ
u'وُجُوهٌ حاجَةٌ':Added, #1: 1	وُجُوهِ الْجِيرَانِ
u'وُجُوهٌ حُرٌّ':Added, #2: 2	وُجُوهِ حَاجَاتِهِ
u'وُجُوهٌ حَرْفٌ':Added, #1: 1	وُجُوهَ حُرّاتِ
u'وُجُوهٌ حَرِيرٌ':Added, #1: 1	وُجُوهِ حَرْفِ
u'وُجُوهٌ حَقٌّ':Added, #1: 1	وُجُوهِ الْحَرِيرِ
u'وُجُوهٌ حكمة':Added, #1: 1	وُجُوهِ الْحَقِّ
u'وُجُوهٌ حِكْمَةٌ':Added, #1: 1	وُجُوهَ الْحِكْمَةِ
u'وُجُوهٌ حَيَاءٌ':Added, #1: 1	وُجُوهَ الْحِكْمَةِ
u'وُجُوهٌ خَاصَّةٌ':Added, #1: 1	وُجُوهِ الْحَيَاءِ
u'وُجُوهٌ خَرَائِدُ':Added, #1: 1	وُجُوهٍ خَاصَّةٍ
u'وُجُوهٌ خُصُومَةٌ':Added, #1: 1	وُجُوهِ خَرَائِدِهِ
u'وُجُوهٌ خَلَلٌ':Added, #2: 2	وُجُوهِ الْخُصُومَاتِ
u'وُجُوهٌ خَلَلٌ':Added, #1: 1	وُجُوهُ الْخَلَلِ
u'وُجُوهٌ خَمْسَةٌ':Added, #1: 1	وُجُوهِ الْخَلَلِ
u'وُجُوهٌ خَيْرٌ':Added, #1: 1	وُجُوهٍ خَمْسَةٍ
u'وُجُوهٌ خَيْرَاتٌ':Added, #12: 12	وُجُوهِ الْخَيْرِ
u'وُجُوهٌ خَيْرَةٌ':Added, #2: 2	وُجُوهِ الْخَيْرَاتِ
u'وُجُوهٌ خَيْلٌ':Added, #2: 2	وُجُوهِ الْخَيْرَاتِ
u'وُجُوهٌ دَخْلٌ':Added, #1: 1	وُجُوهَ الْخَيْلِ
u'وُجُوهٌ دفع':Added, #1: 1	وُجُوهُ الدَّخْلِ
u'وُجُوهٌ دفع':Added, #1: 1	وُجُوهُ الدَّفْعِ
u'وُجُوهٌ دَفْعٌ':Added, #1: 1	وُجُوهِ الدَّفْعِ
u'وُجُوهٌ دَفْعٌ':Added, #1: 1	وُجُوهُ الدَّفْعِ
u'وُجُوهٌ دفع':Added, #1: 1	وُجُوهِ الدَّفْعِ
u'وُجُوهٌ دفع':Added, #1: 1	وُجُوهَ دَفْعِ
u'وُجُوهٌ دَفْعٌ':Added, #1: 1	وُجُوهِ دَفْعِ
u'وُجُوهٌ دَفْعٌ':Added, #1: 1	وُجُوهَ دَفْعِ
u'وُجُوهٌ دَلالٌ':Added, #1: 1	وُجُوهِ دَفْعِ
u'وُجُوهٌ دَلالَةٌ':Added, #2: 2	وُجُوهِ الدَّلَالَاتِ
u'وُجُوهٌ دَلالَةٌ':Added, #1: 1	وُجُوهِ دَلَالَةِ
u'وُجُوهٌ ذكر':Added, #2: 2	وُجُوهِ الدَّلَالَاتِ
u'وُجُوهٌ ذِكْرٌ':Added, #1: 1	وُجُوهُ الذِّكْرِ
u'وُجُوهٌ رَجاء':Added, #1: 1	وُجُوهُ الذِّكْرِ
u'وُجُوهٌ رَجَاءٌ':Added, #1: 1	وُجُوهِ الرَّجَاءِ
u'وُجُوهٌ رِجَالٌ':Added, #1: 1	وُجُوهِ الرَّجَاءِ
u'وُجُوهٌ رِزْقٌ':Added, #1: 1	وُجُوهِ الرِّجَالِ
u'وُجُوهٌ رُكوبٌ':Added, #1: 1	وُجُوهِ رِزْقِ
u'وُجُوهٌ رُوَاةٌ':Added, #1: 1	وُجُوهَ رُكُوبِهِ
u'وُجُوهٌ زِيادَةٌ':Added, #1: 1	وُجُوهُ رُوَاةِ
u'وُجُوهٌ سُنَّةٌ':Added, #1: 1	وُجُوهِ الزِّيَادَةِ
u'وُجُوهٌ سنن':Added, #1: 1	وُجُوهِ السُّنَّةِ
u'وُجُوهٌ سُؤَالٌ':Added, #1: 1	وُجُوهِ السُّنَنِ
u'وُجُوهٌ شَبَهٌ':Added, #1: 1	وُجُوهَ السُّؤَالِ
u'وُجُوهٌ شَبَهٌ':Added, #1: 1	وُجُوهُ شَبَهٍ
u'وُجُوهٌ صَحَابَةٌ':Added, #1: 1	وُجُوهِ شَبَهٍ
u'وُجُوهٌ صدقة':Added, #1: 1	وُجُوهِ الصَّحَابَةِ
u'وُجُوهٌ صَدَقَةٌ':Added, #1: 1	وُجُوهِ الصَّدَقَةِ
u'وُجُوهٌ صَدَقَةٌ':Added, #1: 1	وُجُوهِ الصَّدَقَةِ
u'وُجُوهٌ صَلاَحٌ':Added, #2: 2	وُجُوهِ الصَّدَقَاتِ
u'وُجُوهٌ ضَمَانٌ':Added, #1: 1	وُجُوهَ الصَّلَاحِ
u'وُجُوهٌ ظاهِرَة':Added, #1: 1	وُجُوهِ الضَّمَانِ
u'وُجُوهٌ عِبَادٌ':Added, #1: 1	وُجُوهٍ ظَاهِرَةٍ
u'وُجُوهٌ عِبْرٌ':Added, #1: 1	وُجُوهَ عِبَادِ
u'وُجُوهٌ عَدُوٌّ':Added, #1: 1	وُجُوهُ الْعِبْرِ
u'وُجُوهٌ عُذْرٌ':Added, #1: 1	وُجُوهِ الْعَدُوِّ
u'وُجُوهٌ عِصْيَانٌ':Added, #2: 2	وُجُوهَ الْعُذْرِ
u'وُجُوهٌ عقاب':Added, #1: 1	وُجُوهِ الْعِصْيَانِ
u'وُجُوهٌ عِقَابٌ':Added, #1: 1	وُجُوهِ الْعِقَابِ
u'وُجُوهٌ عُقُودٌ':Added, #1: 1	وُجُوهِ الْعِقَابِ
u'وُجُوهٌ علم':Added, #1: 1	وُجُوهِ الْعُقُودِ
u'وُجُوهٌ عِلْمٌ':Added, #2: 2	وُجُوهِ الْعِلْمِ
u'وُجُوهٌ عُمُومٌ':Added, #2: 2	وُجُوهِ الْعِلْمِ
u'وُجُوهٌ عَنَاقِيدُ':Added, #1: 1	وُجُوهِ الْعُمُومِ
u'وُجُوهٌ غِشٌّ':Added, #1: 1	وُجُوهِ الْعَنَاقِيدِ
u'وُجُوهٌ فرق':Added, #1: 1	وُجُوهِ الْغِشِّ
u'وُجُوهٌ فَرْقٌ':Added, #1: 1	وُجُوهِ الْفَرْقِ
u'وُجُوهٌ فُرْقَةٌ':Added, #1: 1	وُجُوهِ الْفَرْقِ
u'وُجُوهٌ فساد':Added, #1: 1	وُجُوهِ الْفُرْقَةِ
u'وُجُوهٌ فَسَادٌ':Added, #1: 1	وُجُوهَ الْفَسَادِ
u'وُجُوهٌ فساد':Added, #1: 1	وُجُوهَ الْفَسَادِ
u'وُجُوهٌ فَسَادٌ':Added, #2: 2	وُجُوهِ الْفَسَادِ
u'وُجُوهٌ فِسْقٌ':Added, #2: 2	وُجُوهِ الْفَسَادِ
u'وُجُوهٌ فِسْقٌ':Added, #1: 1	وُجُوهُ الْفِسْقِ
u'وُجُوهٌ فِقْهٌ':Added, #3: 3	وُجُوهِ الْفِسْقِ
u'وُجُوهٌ فِقْهٌ':Added, #2: 2	وُجُوهَ الْفِقْهِ
u'وُجُوهٌ فَوَاتٌ':Added, #2: 2	وُجُوهِ الْفِقْهِ
u'وُجُوهٌ فَوَائِدُ':Added, #1: 1	وُجُوهِ الْفَوَاتِ
u'وُجُوهٌ قُبْحٌ':Added, #5: 5	وُجُوهِ الْفَوَائِدِ
u'وُجُوهٌ قُرَبٌ':Added, #1: 1	وُجُوهُ الْقُبْحِ
u'وُجُوهٌ قُرَبٌ':Added, #1: 1	وُجُوهِ الْقُرَبِ
u'وُجُوهٌ قُرَيْشٌ':Added, #2: 2	وُجُوهُ الْقُرَبِ
u'وُجُوهٌ قَوْمٌ':Added, #1: 1	وُجُوهَ قُرَيْشٍ
u'وُجُوهٌ قَوْمٌ':Added, #12: 12	وُجُوهِ الْقَوْمِ
u'وُجُوهٌ قَوْمٌ':Added, #1: 1	وُجُوهُ الْقَوْمِ
u'وُجُوهٌ قَوْمٌ':Added, #1: 1	وُجُوهِ قَوْمٍ
u'وُجُوهٌ كَسْبٌ':Added, #2: 2	وُجُوهَ الْقَوْمِ
u'وُجُوهٌ كِفَايَةٌ':Added, #4: 4	وُجُوهِ الْكَسْبِ
u'وُجُوهٌ كلاب':Added, #1: 1	وُجُوهِ الْكِفَايَاتِ
u'وُجُوهٌ كِلاَبٌ':Added, #1: 1	وُجُوهِ الْكِلَابِ
u'وُجُوهٌ مَجَازٌ':Added, #1: 1	وُجُوهِ الْكِلَابِ
u'وُجُوهٌ مَجَازٌ':Added, #2: 2	وُجُوهِ الْمَجَازِ
u'وُجُوهٌ مُخَالَفَةٌ':Added, #3: 3	وُجُوهُ الْمَجَازِ
u'وُجُوهٌ مَذْهَبٌ':Added, #1: 1	وُجُوهَ الْمُخَالَفَاتِ
u'وُجُوهٌ مُرابَحَة':Added, #1: 1	وُجُوهُ الْمَذْهَبِ
u'وُجُوهٌ مَسْأَلَةٌ':Added, #3: 3	وُجُوهِ الْمُرَابَحَةِ
u'وُجُوهٌ مَسْأَلَةٌ':Added, #1: 1	وُجُوهِ الْمَسْأَلَةِ
u'وُجُوهٌ مُسَاوَاةٌ':Added, #1: 1	وُجُوهُ مَسْأَلَةِ
u'وُجُوهٌ مَسَائِلُ':Added, #1: 1	وُجُوهِ الْمُسَاوَاةِ
u'وُجُوهٌ مُشَبَّهٌ':Added, #1: 1	وُجُوهِ مَسَائِلِهِ
u'وُجُوهٌ مَصَارِفُ':Added, #1: 1	وُجُوهِ الْمُشَبَّهِ
u'وُجُوهٌ مَصَالِحُ':Added, #1: 1	وُجُوهِ مَصَارِفِ
u'وُجُوهٌ مَصَالِحُ':Added, #1: 1	وُجُوهِ مَصَالِحِ
u'وُجُوهٌ مَضَارُّ':Added, #8: 8	وُجُوهِ الْمَصَالِحِ
u'وُجُوهٌ مُقَابَلٌ':Added, #2: 2	وُجُوهِ الْمَضَارِّ
u'وُجُوهٌ مُقَابَلَةٌ':Added, #1: 1	وُجُوهِ مُقَابَلَتِهِ
u'وُجُوهٌ مِلْكٌ':Added, #1: 1	وُجُوهِ مُقَابَلَتِهِ
u'وُجُوهٌ مِلْكٌ':Added, #1: 1	وُجُوهَ الْمِلْكِ
u'وُجُوهٌ مَنَافِعُ':Added, #2: 2	وُجُوهِ الْمِلْكِ
u'وُجُوهٌ مَنْفَعَةٌ':Added, #3: 3	وُجُوهِ الْمَنَافِعِ
u'وُجُوهٌ نَاسٌ':Added, #1: 1	وُجُوهُ مَنْفَعَتِهِ
u'وُجُوهٌ نَاسٌ':Added, #4: 4	وُجُوهُ النَّاسِ
u'وُجُوهٌ نَاسٌ':Added, #4: 4	وُجُوهِ النَّاسِ
u'وُجُوهٌ نَسَبٌ':Added, #7: 7	وُجُوهَ النَّاسِ
u'وُجُوهٌ نُسُكٌ':Added, #1: 1	وُجُوهِ النَّسَبِ
u'وُجُوهٌ نِسْوانٌ':Added, #1: 1	وُجُوهُ النُّسُكَيْنِ
u'وُجُوهٌ نَصٌّ':Added, #1: 1	وُجُوهِ النِّسْوَانِ
u'وُجُوهٌ نصب':Added, #1: 1	وُجُوهِ النَّصِّ
u'وُجُوهٌ نَصْبٌ':Added, #1: 1	وُجُوهِ النَّصْبِ
u'وُجُوهٌ نَظَرٌ':Added, #1: 1	وُجُوهِ النَّصْبِ
u'وُجُوهٌ نُقْصَانٌ':Added, #5: 5	وُجُوهِ النَّظَرِ
u'وُجُوهٌ نُقْصَانٌ':Added, #1: 1	وُجُوهُ النُّقْصَانِ
u'وُجُوهٌ وَصِيٌّ':Added, #1: 1	وُجُوهِ النُّقْصَانِ
u'وُجُوهٌ وَصِيَّةٌ':Added, #1: 1	وُجُوهُ وَصِيَّةِ
u'وُجُوهٌ وَقْفٌ':Added, #1: 1	وُجُوهُ وَصِيَّةِ
u'وَحْدَةٌ إِدْرَاكٌ':Added, #1: 1	وُجُوهِ الْوَقْفِ
u'وَحْدَةٌ اِعْتِبار':Added, #1: 1	وَحْدَةِ الْإِدْرَاكَاتِ
u'وَحْدَةٌ اِعْتِبارِيّ':Added, #1: 1	وَحْدَةٍ اعْتِبَارِيَّةٍ
u'وَحْدَةٌ زَمانٌ':Added, #1: 1	وَحْدَةٍ اعْتِبَارِيَّةٍ
u'وَحْدَةٌ شَرْطٌ':Added, #2: 2	وَحْدَةُ الزَّمَانِ
u'وَحْدَةٌ طلب':Added, #1: 1	وَحْدَةُ الشَّرْطِ
u'وَحْدَةٌ طَلَبٌ':Added, #1: 1	وَحْدَةِ الطَّلَبِ
u'وَحْدَةٌ غَايَةٌ':Added, #1: 1	وَحْدَةِ الطَّلَبِ
u'وَحْدَةٌ غَايَةٌ':Added, #1: 1	وَحْدَةِ الْغَايَةِ
u'وَحْدَةٌ غَايَةٌ':Added, #1: 1	وَحْدَةُ غَايَةٍ
u'وَحْدَةٌ غَايَةٌ':Added, #1: 1	وَحْدَةِ غَايَتِهِ
u'وَحْدَةٌ مُعَيَّنٌ':Added, #2: 2	وَحْدَةُ الْغَايَةِ
u'وَحْدَةٌ مَوْضُوعٌ':Added, #1: 1	وَحْدَةٍ مُعَيَّنَةٍ
u'وَحْدَةٌ مَوْضُوعٌ':Added, #1: 1	وَحْدَةَ الْمَوْضُوعِ
u'وَحْدَةٌ مَوْضُوعٌ':Added, #1: 1	وَحْدَةِ الْمَوْضُوعِ
u'وَحْدَةٌ نِسْبَةٌ':Added, #3: 3	وَحْدَةُ الْمَوْضُوعِ
u'وَحْدَةٌ نَوْعٌ':Added, #1: 1	وَحْدَةِ النِّسْبَةِ
u'وَحْدٌ سَرقَةٌ':Added, #1: 1	وَحْدَةِ النَّوْعِ
u'وَحْدٌ سَرِقَةٌ':Added, #1: 1	وَحْدُ السَّرِقَةِ
u'وَحْدٌ سَوادٌ':Added, #1: 1	وَحْدُ السَّرِقَةِ
u'وَحْدٌ شرب':Added, #1: 1	وَحْدُ السَّوَادِ
u'وَحْدٌ شُرْبٌ':Added, #1: 1	وَحْدُ الشُّرْبِ
u'وَحْدٌ قذف':Added, #1: 1	وَحْدُ الشُّرْبِ
u'وَحْدٌ قَذْفٌ':Added, #1: 1	وَحْدُ الْقَذْفِ
u'وَحْدٌ قَذْفٌ':Added, #1: 1	وَحْدُ الْقَذْفِ
u'وَحْدٌ كَثْرَةٌ':Added, #1: 1	وَحْدِ قَذْفٍ
u'وَحْدٌ وسط':Added, #1: 1	وَحْدُ الْكَثْرَةِ
u'وَحْدٌ وَسَطٌ':Added, #1: 1	وَحْدُ الْوَسَطِ
u'وَحَرٌ صَدْرٌ':Added, #1: 1	وَحْدُ الْوَسَطِ
u'وَحَرٌ صَدْرٌ':Added, #2: 2	وَحَرَ الصَّدْرِ
u'وَحَرٌ صُدُورٌ':Added, #2: 2	وَحَرِ الصَّدْرِ
u'وَحْشِيَّةٌ خلقة':Added, #1: 1	وَحَرَ الصُّدُورِ
u'وَحْشِيَّةٌ خِلْقَةٌ':Added, #1: 1	وَحْشِيَّةَ الْخِلْقَةِ
u'وَحْشِيٌّ خلقة':Added, #1: 1	وَحْشِيَّةَ الْخِلْقَةِ
u'وَحْشِيٌّ خِلْقَةٌ':Added, #1: 1	وَحْشِيَّةَ الْخِلْقَةِ
u'وَحَمٌ سجدة':Added, #1: 1	وَحْشِيَّةَ الْخِلْقَةِ
u'وَحَمٌ سَجْدَةٌ':Added, #1: 1	وَحَم السَّجْدَةِ
u'وَحْيٌ مُصَرِّحٌ':Added, #1: 1	وَحَم السَّجْدَةِ
u'وَحْيٌ مَلاَحِظُ':Added, #1: 1	وَحْيٍ مُصَرِّحٍ
u'وَخْزٌ جِنٌّ':Added, #1: 1	وَحْيَ الْمَلَاحِظِ
u'وَخْزٌ جِنٌّ':Added, #2: 2	وَخْزُ الْجِنِّ
u'وَدَاعَةٌ فلان':Added, #3: 3	وَخْزِ الْجِنِّ
u'وَدَّ صَدِيقٌ':Predicate, #1: 1	وَدَاعَةَ الْغَامِدِيِّ
u'وَدَعَ اِبْنٌ':Predicate, #1: 1	وَدَّ الصَّدِيقَ
u'وَدَعَ أَعْرابٌ':Predicate, #1: 1	دَعَا ابْنَ
u'وَدَّعَ أعْرَابِيٌّ':Subject, #1: 1	دَعَا الْأَعْرَابَ
u'وَدَعَ أكفاء':Predicate, #1: 1	وَدَّعَ أَعْرَابِيٌّ
u'وَدَعَ أُمٌّ':Predicate, #1: 1	دَعَا الْأَكْفَاءَ
u'وَدَعَ أنصار':Predicate, #1: 1	دَعَا أُمَّ
u'وَدَعَ أَنْصارٌ':Predicate, #1: 1	دَعَا الأَنْصَارَ
u'وَدَعَ أَنْصَارٌ':Predicate, #1: 1	دَعَا الأَنْصَارَ
u'وَدَعَ أنصار':Predicate, #1: 1	دَعَا الأَنْصَارَ
u'وَدَعَ أَنْصارٌ':Predicate, #2: 2	دَعَا الْأَنْصَارَ
u'وَدَعَ أَنْصَارٌ':Predicate, #2: 2	دَعَا الْأَنْصَارَ
u'وَدَعَ أَوَّلُ':Predicate, #2: 2	دَعَا الْأَنْصَارَ
u'وَدَّعَ بَيْتٌ':Predicate, #1: 1	دَعَا الْأَوَّلَ
u'وَدَعَ بَيْعٌ':Predicate, #3: 3	وَدَّعَ الْبَيْتَ
u'وَدَعَ بَيْنٌ':Predicate, #1: 1	دَعَا الْبَيْعَ
u'وَدَعَ جَارِي':Predicate, #2: 2	دَعَا بَيْنَ
u'وَدَعَ جَارِيَةٌ':Predicate, #2: 2	دَعَا الْجَارِيَةَ
u'وَدَعَ جَيْشٌ':Predicate, #2: 2	دَعَا الْجَارِيَةَ
u'وَدَعَ خَارِجٌ':Predicate, #1: 1	دَعَا الْجَيْشَ
u'وَدَعَ خَالِدٌ':Predicate, #1: 1	دَعَا خَارِجَ
u'وَدَعَ دَعْوَةٌ':Predicate, #1: 1	دَعَا خَالِدَ
u'وَدَعَ دونٌ':Predicate, #1: 1	دَعَا دَعْوَةَ
u'وَدَعَ رَأْسٌ':Predicate, #1: 1	دَعَا دُونَ
u'وَدَعَ رَجُلٌ':Predicate, #1: 1	دَعَا رَأْسَ
u'وَدَعَ رَجُلٌ':Predicate, #2: 2	دَعَا الرَّجُلَ
u'وَدَعَ رَسُولٌ':Predicate, #2: 2	دَعَا رَجُلاً
u'وَدَّعَ رَسُولٌ':Subject, #8: 8	دَعَا رَسُولَ
u'وَدَعَ سَعْدٌ':Predicate, #1: 1	وَدَّعَ رَسُولُ
u'وَدَعَ شَيْءٌ':Predicate, #2: 2	دَعَا سَعْدَ
u'وَدَعَ طَائِفٌ':Predicate, #2: 2	وَدَعَ الشَّيْءَ
u'وَدَعَ طَلْحٌ':Predicate, #2: 2	دَعَا طَائِفَةً
u'وَدَعَ طلحة':Predicate, #2: 2	دَعَا طَلْحَةَ
u'وَدَعَ عَبْدٌ':Predicate, #2: 2	دَعَا طَلْحَةَ
u'وَدَعَ عَشِيَّةٌ':Predicate, #2: 2	دَعَا عَبْدَ
u'وَدَعَ عُمَرٌ':Predicate, #3: 3	دَعَا عَشِيَّةَ
u'وَدَعَ فَاطِمٌ':Predicate, #1: 1	دَعَا عُمَرَ
u'وَدَعَ فِتْيَانٌ':Predicate, #1: 1	دَعَا فَاطِمَةَ
u'وَدَعَ فَضْلٌ':Predicate, #1: 1	دَعَا الْفِتْيَانَ
u'وَدَعَ فلان':Predicate, #1: 1	دَعَا الْفَضْلَ
u'وَدَعَ فلان':Predicate, #1: 1	دَعَا الزُّبَيْرَ
u'وَدَعَ فلان':Predicate, #1: 1	دَعَا جُبَيْرَ
u'وَدَعَ فلان':Predicate, #1: 1	دَعَا حُذَيْفَةَ
u'وَدَعَ فلان':Predicate, #1: 1	دَعَا عُبَيْدَةَ
u'وَدَعَ قَبَائِلُ':Predicate, #3: 3	دَعَا عُثْمَانَ
u'وَدَعَ قَوْمٌ':Predicate, #1: 1	دَعَا الْقَبَائِلَ
u'وَدَعَ مَشْيَخَةٌ':Predicate, #1: 1	دَعَا الْقَوْمَ
u'وَدَعَ مُغْتاب':Predicate, #1: 1	دَعَا مَشْيَخَةَ
u'وَدَّعَ نَاسٌ':Predicate, #1: 1	دَعَا الْمُغْتَابَ
u'وَدَعَ نَاسٌ':Predicate, #1: 1	وَدَّعَ النَّاسَ
u'وَدَعَ نَاسٌ':Predicate, #3: 3	دَعَا النّاسَ
u'وَدَعَ نَبِيٌّ':Predicate, #4: 4	دَعَا النَّاسَ
u'وَدَّعَ نَصٌّ':Predicate, #4: 4	دَعَا النَّبِيَّ
u'وَدَعَ هِرٌّ':Predicate, #1: 1	وَدَّعَ نَصَّ
u'وَدَعَ يهود':Predicate, #1: 1	دَعَا الْهِرَّةَ
u'وَدَعَ يَهُودٌ':Predicate, #2: 2	دَعَا الْيَهُودَ
u'وَدَّ قَوْمٌ':Subject, #2: 2	دَعَا الْيَهُودَ
u'وَدَكٌ شَرِيفٌ':Added, #1: 1	وَدَّ قَوْمٌ
u'وَدَكٌ كَلْبٌ':Added, #1: 1	وَدَكَ الشّرِيفِ
u'وَدَكٌ مَيْتٌ':Added, #1: 1	وَدَكُ كَلْبٍ
u'وَدَكٌ مَيْتَةٌ':Added, #5: 5	وَدَكُ الْمَيْتَةِ
u'وَدَكٌ مَيْتَةٌ':Added, #1: 1	وَدَكَ مَيْتَةٍ
u'وَدَى اِبْنٌ':Predicate, #5: 5	وَدَكُ الْمَيْتَةِ
u'وَدَى رَسُولٌ':Subject, #1: 1	وَدَى ابْنَكَ
u'وَدَى قَاتِلٌ':Subject, #2: 2	وَدَى رَسُولُ
u'وذر اِبْتِداءٌ':Predicate, #2: 2	وَدَى الْقَاتِلُ
u'وَذِرَ اِبْتِداءٌ':Predicate, #1: 1	نَذَرَ ابْتِدَاءَ
u'وذر أبَدٌ':Predicate, #1: 1	نَذَرَ ابْتِدَاءَ
u'وَذِرَ أبَدٌ':Predicate, #1: 1	نَذَرَ الْأَبَدَ
u'وذر إتْمَامٌ':Predicate, #1: 1	نَذَرَ الْأَبَدَ
u'وَذِرَ إتْمَامٌ':Predicate, #4: 4	نَذَرَ إتْمَامَ
u'وذر إِتْيانٌ':Predicate, #4: 4	نَذَرَ إتْمَامَ
u'وَذِرَ إِتْيانٌ':Predicate, #1: 1	نَذَرَ الْإِتْيَانَ
u'وذر إِتْيانٌ':Predicate, #1: 1	نَذَرَ الْإِتْيَانَ
u'وَذِرَ إِتْيانٌ':Predicate, #7: 7	نَذَرَ إتْيَانَ
u'وذر إِحْرَامٌ':Predicate, #7: 7	نَذَرَ إتْيَانَ
u'وَذِرَ إِحْرَامٌ':Predicate, #4: 4	نَذَرَ الْإِحْرَامَ
u'وذر أَدَاءٌ':Predicate, #4: 4	نَذَرَ الْإِحْرَامَ
u'وَذِرَ أَدَاءٌ':Predicate, #1: 1	نَذَرَ أَدَاءَ
u'وذر أَرْبَعُ':Predicate, #1: 1	نَذَرَ أَدَاءَ
u'وَذِرَ أَرْبَعُ':Predicate, #1: 1	نَذَرَ أَرْبَعَ
u'وذر أصل':Predicate, #1: 1	نَذَرَ أَرْبَعَ
u'وذر أًصْلٌ':Predicate, #1: 1	نَذَرَ أَصْلَ
u'وَذِرَ أصل':Predicate, #1: 1	نَذَرَ أَصْلَ
u'وَذِرَ أًصْلٌ':Predicate, #1: 1	نَذَرَ أَصْلَ
u'وذر إِطْعامٌ':Predicate, #1: 1	نَذَرَ أَصْلَ
u'وَذِرَ إِطْعامٌ':Predicate, #2: 2	نَذَرَ إطْعَامَ
u'وذر اِعْتاق':Predicate, #2: 2	نَذَرَ إطْعَامَ
u'وَذِرَ اِعْتاق':Predicate, #1: 1	نَذَرَ اعْتَاقَ
u'وذر إِعْتاقٌ':Predicate, #1: 1	نَذَرَ اعْتَاقَ
u'وَذِرَ إِعْتاقٌ':Predicate, #5: 5	نَذَرَ إعْتَاقَ
u'وذر اِعْتِكافٌ':Predicate, #5: 5	نَذَرَ إعْتَاقَ
u'وَذِرَ اِعْتِكافٌ':Predicate, #73: 73	نَذَرَ اعْتِكَافَ
u'وذر أَكْثَرُ':Predicate, #73: 73	نَذَرَ اعْتِكَافَ
u'وَذِرَ أَكْثَرُ':Predicate, #1: 1	نَذَرَ أَكْثَرَ
u'وذر ألف':Predicate, #1: 1	نَذَرَ أَكْثَرَ
u'وذر ألْفٌ':Predicate, #2: 2	نَذَرَ أَلْفَ
u'وذر أَلْفٌ':Predicate, #2: 2	نَذَرَ أَلْفَ
u'وَذِرَ ألف':Predicate, #2: 2	نَذَرَ أَلْفَ
u'وَذِرَ ألْفٌ':Predicate, #2: 2	نَذَرَ أَلْفَ
u'وَذِرَ أَلْفٌ':Predicate, #2: 2	نَذَرَ أَلْفَ
u'وذر إهْدَاءٌ':Predicate, #2: 2	نَذَرَ أَلْفَ
u'وَذِرَ إهْدَاءٌ':Predicate, #1: 1	نَذَرَ إهْدَاءَ
u'وذر أَوَّلُ':Predicate, #1: 1	نَذَرَ إهْدَاءَ
u'وَذِرَ أَوَّلُ':Predicate, #1: 1	نَذَرَ الْأَوَّلَ
u'وذر أيَّامٌ':Predicate, #1: 1	نَذَرَ الْأَوَّلَ
u'وذر أَيَّامٌ':Predicate, #1: 1	نَذَرَ أَيَّامَ
u'وَذِرَ أيَّامٌ':Predicate, #1: 1	نَذَرَ أَيَّامَ
u'وَذِرَ أَيَّامٌ':Predicate, #1: 1	نَذَرَ أَيَّامَ
u'وذر بَعْضٌ':Predicate, #1: 1	نَذَرَ أَيَّامَ
u'وَذِرَ بَعْضٌ':Predicate, #6: 6	نَذَرَ بَعْضَ
u'وذر تَجْدِيدٌ':Predicate, #6: 6	نَذَرَ بَعْضَ
u'وَذِرَ تَجْدِيدٌ':Predicate, #1: 1	نَذَرَ التَّجْدِيدَ
u'وذر تَصَدُّقٌ':Predicate, #1: 1	نَذَرَ التَّجْدِيدَ
u'وَذِرَ تَصَدُّقٌ':Predicate, #19: 19	نَذَرَ التَّصَدُّقَ
u'وذر تَضْحِيَةٌ':Predicate, #19: 19	نَذَرَ التَّصَدُّقَ
u'وَذِرَ تَضْحِيَةٌ':Predicate, #3: 3	نَذَرَ التَّضْحِيَةَ
u'وذر تَكْفينٌ':Predicate, #3: 3	نَذَرَ التَّضْحِيَةَ
u'وَذِرَ تَكْفينٌ':Predicate, #1: 1	نَذَرَ تَكْفِينَ
u'وذر تَمَتُّعٌ':Predicate, #1: 1	نَذَرَ تَكْفِينَ
u'وَذِرَ تَمَتُّعٌ':Predicate, #1: 1	نَذَرَ التَّمَتُّعَ
u'وذر جَذَع':Predicate, #1: 1	نَذَرَ التَّمَتُّعَ
u'وَذِرَ جَذَع':Predicate, #2: 2	نَذَرَ جَذَعَةً
u'وذر جهاد':Predicate, #2: 2	نَذَرَ جَذَعَةً
u'وَذِرَ جهاد':Predicate, #1: 1	نَذَرَ الْجِهَادَ
u'وذر جِهَادٌ':Predicate, #1: 1	نَذَرَ الْجِهَادَ
u'وَذِرَ جِهَادٌ':Predicate, #1: 1	نَذَرَ الْجِهَادَ
u'وذر جِوَارٌ':Predicate, #1: 1	نَذَرَ الْجِهَادَ
u'وَذِرَ جِوَارٌ':Predicate, #1: 1	نَذَرَ جِوَارَ
u'وذر حَجٌّ':Predicate, #1: 1	نَذَرَ جِوَارَ
u'وَذِرَ حَجٌّ':Predicate, #20: 20	نَذَرَ الْحَجَّ
u'وذر خُرُوجٌ':Predicate, #20: 20	نَذَرَ الْحَجَّ
u'وَذِرَ خُرُوجٌ':Predicate, #1: 1	نَذَرَ الْخُرُوجَ
u'وذر ذَهَابٌ':Predicate, #1: 1	نَذَرَ الْخُرُوجَ
u'وَذِرَ ذَهَابٌ':Predicate, #1: 1	نَذَرَ الذَّهَابَ
u'وذر رباط':Predicate, #1: 1	نَذَرَ الذَّهَابَ
u'وَذِرَ رباط':Predicate, #3: 3	نَذَرَ الرِّبَاطَ
u'وذر رِبَاطٌ':Predicate, #3: 3	نَذَرَ الرِّبَاطَ
u'وَذِرَ رِبَاطٌ':Predicate, #3: 3	نَذَرَ الرِّبَاطَ
u'وذر رُكوبٌ':Predicate, #3: 3	نَذَرَ الرِّبَاطَ
u'وَذِرَ رُكوبٌ':Predicate, #4: 4	نَذَرَ الرُّكُوبَ
u'وذر زِيارَةٌ':Predicate, #4: 4	نَذَرَ الرُّكُوبَ
u'وَذِرَ زِيارَةٌ':Predicate, #1: 1	نَذَرَ زِيَارَةَ
u'وذر سَتْرٌ':Predicate, #1: 1	نَذَرَ زِيَارَةَ
u'وَذِرَ سَتْرٌ':Predicate, #2: 2	نَذَرَ سَتْرَ
u'وذر سجدة':Predicate, #2: 2	نَذَرَ سَتْرَ
u'وَذِرَ سجدة':Predicate, #2: 2	نَذَرَ سَجْدَةَ
u'وذر سَجْدَةٌ':Predicate, #2: 2	نَذَرَ سَجْدَةَ
u'وَذِرَ سَجْدَةٌ':Predicate, #2: 2	نَذَرَ سَجْدَةَ
u'وذر سُجُودٌ':Predicate, #2: 2	نَذَرَ سَجْدَةَ
u'وَذِرَ سُجُودٌ':Predicate, #1: 1	نَذَرَ سُجُودَ
u'وذر سنن':Predicate, #1: 1	نَذَرَ سُجُودَ
u'وَذِرَ سنن':Predicate, #1: 1	نَذَرَ السُّنَنَ
u'وذر شرب':Predicate, #1: 1	نَذَرَ السُّنَنَ
u'وَذِرَ شرب':Predicate, #1: 1	نَذَرَ شُرْبَ
u'وذر شُرْبٌ':Predicate, #1: 1	نَذَرَ شُرْبَ
u'وَذِرَ شُرْبٌ':Predicate, #1: 1	نَذَرَ شُرْبَ
u'وذر صدقة':Predicate, #1: 1	نَذَرَ شُرْبَ
u'وَذِرَ صدقة':Predicate, #1: 1	نَذَرَ صَدَقَةَ
u'وذر صَدَقَةٌ':Predicate, #1: 1	نَذَرَ صَدَقَةَ
u'وَذِرَ صَدَقَةٌ':Predicate, #1: 1	نَذَرَ صَدَقَةَ
u'وذر صدقة':Predicate, #1: 1	نَذَرَ صَدَقَةَ
u'وَذِرَ صدقة':Predicate, #24: 24	نَذَرَ الصَّدَقَةَ
u'وذر صَدَقَةٌ':Predicate, #24: 24	نَذَرَ الصَّدَقَةَ
u'وَذِرَ صَدَقَةٌ':Predicate, #24: 24	نَذَرَ الصَّدَقَةَ
u'وذر صَرْفٌ':Predicate, #24: 24	نَذَرَ الصَّدَقَةَ
u'وذر صَرْف':Predicate, #1: 1	نَذَرَ صَرْفَ
u'وَذِرَ صَرْفٌ':Predicate, #1: 1	نَذَرَ صَرْفَ
u'وَذِرَ صَرْف':Predicate, #1: 1	نَذَرَ صَرْفَ
u'وذر صَلاَةٌ':Predicate, #1: 1	نَذَرَ صَرْفَ
u'وَذِرَ صَلاَةٌ':Predicate, #21: 21	نَذَرَ الصَّلَاةَ
u'وذر صَلاَةٌ':Predicate, #21: 21	نَذَرَ الصَّلَاةَ
u'وَذِرَ صَلاَةٌ':Predicate, #2: 2	نَذَرَ صَلَاةَ
u'وذر صَوْمٌ':Predicate, #2: 2	نَذَرَ صَلَاةَ
u'وَذِرَ صَوْمٌ':Predicate, #120: 120	نَذَرَ صَوْمَ
u'وذر صَوْمٌ':Predicate, #120: 120	نَذَرَ صَوْمَ
u'وَذِرَ صَوْمٌ':Predicate, #7: 7	نَذَرَ الصَّوْمَ
u'وذر صِيَامٌ':Predicate, #7: 7	نَذَرَ الصَّوْمَ
u'وَذِرَ صِيَامٌ':Predicate, #14: 14	نَذَرَ صِيَامَ
u'وذر صِيَامٌ':Predicate, #14: 14	نَذَرَ صِيَامَ
u'وَذِرَ صِيَامٌ':Predicate, #1: 1	نَذَرَ الصِّيَامَ
u'وذر ضَرْبٌ':Predicate, #1: 1	نَذَرَ الصِّيَامَ
u'وَذِرَ ضَرْبٌ':Predicate, #1: 1	نَذَرَ ضَرْبَ
u'وذر طواف':Predicate, #1: 1	نَذَرَ ضَرْبَ
u'وَذِرَ طواف':Predicate, #6: 6	نَذَرَ الطَّوَافَ
u'وذر طَوَافٌ':Predicate, #6: 6	نَذَرَ الطَّوَافَ
u'وَذِرَ طَوَافٌ':Predicate, #6: 6	نَذَرَ الطَّوَافَ
u'وذر عتق':Predicate, #6: 6	نَذَرَ الطَّوَافَ
u'وَذِرَ عتق':Predicate, #14: 14	نَذَرَ عِتْقَ
u'وذر عِتْقٌ':Predicate, #14: 14	نَذَرَ عِتْقَ
u'وَذِرَ عِتْقٌ':Predicate, #14: 14	نَذَرَ عِتْقَ
u'وذر عَدَمٌ':Predicate, #14: 14	نَذَرَ عِتْقَ
u'وَذِرَ عَدَمٌ':Predicate, #2: 2	نَذَرَ عَدَمَ
u'وذر عَشْرٌ':Predicate, #2: 2	نَذَرَ عَدَمَ
u'وَذِرَ عَشْرٌ':Predicate, #1: 1	نَذَرَ عَشْرَ
u'وذر عُكُوفٌ':Predicate, #1: 1	نَذَرَ عَشْرَ
u'وَذِرَ عُكُوفٌ':Predicate, #1: 1	نَذَرَ عُكُوفَ
u'وذر غير':Predicate, #1: 1	نَذَرَ عُكُوفَ
u'وذر غَيْرٌ':Predicate, #1: 1	نَذَرَ غَيْرَ
u'وَذِرَ غير':Predicate, #1: 1	نَذَرَ غَيْرَ
u'وَذِرَ غَيْرٌ':Predicate, #1: 1	نَذَرَ غَيْرَ
u'وذر فِعْلٌ':Predicate, #1: 1	نَذَرَ غَيْرَ
u'وَذِرَ فِعْلٌ':Predicate, #1: 1	نَذَرَ فِعْلَ
u'وذر قِرَاءةٌ':Predicate, #1: 1	نَذَرَ فِعْلَ
u'وَذِرَ قِرَاءةٌ':Predicate, #1: 1	نَذَرَ الْقِرَاءَةَ
u'وذر قِرَاءةٌ':Predicate, #1: 1	نَذَرَ الْقِرَاءَةَ
u'وَذِرَ قِرَاءةٌ':Predicate, #2: 2	نَذَرَ قِرَاءَةَ
u'وذر قِرَانٌ':Predicate, #2: 2	نَذَرَ قِرَاءَةَ
u'وَذِرَ قِرَانٌ':Predicate, #7: 7	نَذَرَ الْقِرَانَ
u'وذر قَضَاءٌ':Predicate, #7: 7	نَذَرَ الْقِرَانَ
u'وَذِرَ قَضَاءٌ':Predicate, #1: 1	نَذَرَ قَضَاءَ
u'وذر قِنْدِيلٌ':Predicate, #1: 1	نَذَرَ قَضَاءَ
u'وَذِرَ قِنْدِيلٌ':Predicate, #1: 1	نَذَرَ قِنْدِيلَ
u'وذر قيام':Predicate, #1: 1	نَذَرَ قِنْدِيلَ
u'وذر قِيَامٌ':Predicate, #1: 1	نَذَرَ الْقِيَامَ
u'وَذِرَ قيام':Predicate, #1: 1	نَذَرَ الْقِيَامَ
u'وَذِرَ قِيَامٌ':Predicate, #1: 1	نَذَرَ الْقِيَامَ
u'وذر قيام':Predicate, #1: 1	نَذَرَ الْقِيَامَ
u'وذر قِيَامٌ':Predicate, #2: 2	نَذَرَ قِيَامَ
u'وَذِرَ قيام':Predicate, #2: 2	نَذَرَ قِيَامَ
u'وَذِرَ قِيَامٌ':Predicate, #2: 2	نَذَرَ قِيَامَ
u'وذر لَيَالِي':Predicate, #2: 2	نَذَرَ قِيَامَ
u'وَذِرَ لَيَالِي':Predicate, #2: 2	نَذَرَ لَيَالِيَ
u'وذر لَيْلٌ':Predicate, #2: 2	نَذَرَ لَيَالِيَ
u'وَذِرَ لَيْلٌ':Predicate, #1: 1	نَذَرَ اللَّيْلَةَ
u'وذر لَيْلٌ':Predicate, #1: 1	نَذَرَ اللَّيْلَةَ
u'وَذِرَ لَيْلٌ':Predicate, #3: 3	نَذَرَ لَيْلَةً
u'وذر مُتَابَعٌ':Predicate, #3: 3	نَذَرَ لَيْلَةً
u'وَذِرَ مُتَابَعٌ':Predicate, #1: 1	نَذَرَ مُتَابَعَةَ
u'وذر مُتَابَعَةٌ':Predicate, #1: 1	نَذَرَ مُتَابَعَةَ
u'وَذِرَ مُتَابَعَةٌ':Predicate, #1: 1	نَذَرَ مُتَابَعَةَ
u'وذر مثل':Predicate, #1: 1	نَذَرَ مُتَابَعَةَ
u'وَذِرَ مثل':Predicate, #1: 1	نَذَرَ مِثْلَ
u'وذر مِثْلٌ':Predicate, #1: 1	نَذَرَ مِثْلَ
u'وَذِرَ مِثْلٌ':Predicate, #1: 1	نَذَرَ مِثْلَ
u'وذر مُحَافَظَةٌ':Predicate, #1: 1	نَذَرَ مِثْلَ
u'وَذِرَ مُحَافَظَةٌ':Predicate, #1: 1	نَذَرَ الْمُحَافَظَةَ
u'وذر مَسْحٌ':Predicate, #1: 1	نَذَرَ الْمُحَافَظَةَ
u'وَذِرَ مَسْحٌ':Predicate, #1: 1	نَذَرَ مَسْحَ
u'وذر مَشْيٌ':Predicate, #1: 1	نَذَرَ مَسْحَ
u'وَذِرَ مَشْيٌ':Predicate, #17: 17	نَذَرَ الْمَشْيَ
u'وذر نَحْرٌ':Predicate, #17: 17	نَذَرَ الْمَشْيَ
u'وَذِرَ نَحْرٌ':Predicate, #3: 3	نَذَرَ نَحْرَ
u'وذر نِصْفٌ':Predicate, #3: 3	نَذَرَ نَحْرَ
u'وَذِرَ نِصْفٌ':Predicate, #1: 1	نَذَرَ نِصْفَ
u'وذر هَدْيٌ':Predicate, #1: 1	نَذَرَ نِصْفَ
u'وَذِرَ هَدْيٌ':Predicate, #1: 1	نَذَرَ الْهَدْيَ
u'وذر هَدْيٌ':Predicate, #1: 1	نَذَرَ الْهَدْيَ
u'وَذِرَ هَدْيٌ':Predicate, #4: 4	نَذَرَ هَدْيَ
u'وذر وَتْرٌ':Predicate, #4: 4	نَذَرَ هَدْيَ
u'وَذِرَ وَتْرٌ':Predicate, #1: 1	نَذَرَ الْوَتْرَ
u'وذر وَجَبٌ':Predicate, #1: 1	نَذَرَ الْوَتْرَ
u'وَذِرَ وَجَبٌ':Predicate, #1: 1	نَذَرَ وَجَبَ
u'وذر وُضُوءٌ':Predicate, #1: 1	نَذَرَ وَجَبَ
u'وَذِرَ وُضُوءٌ':Predicate, #2: 2	نَذَرَ الْوُضُوءَ
u'وذر وُقُوفٌ':Predicate, #2: 2	نَذَرَ الْوُضُوءَ
u'وَذِرَ وُقُوفٌ':Predicate, #1: 1	نَذَرَ الْوُقُوفَ
u'وذر يَوْمٌ':Predicate, #1: 1	نَذَرَ الْوُقُوفَ
u'وَذِرَ يَوْمٌ':Predicate, #1: 1	نَذَرَ الْيَوْمَ
u'وذر يَوْمٌ':Predicate, #1: 1	نَذَرَ الْيَوْمَ
u'وَذِرَ يَوْمٌ':Predicate, #2: 2	نَذَرَ يَوْمَ
u'وِرَاثَةٌ بَيْتٌ':Added, #2: 2	نَذَرَ يَوْمَ
u'وِرَاثَةٌ شَخْصٌ':Added, #1: 1	وِرَاثَةُ الْبَيْتِ
u'وِرَاثَةٌ مَالٌ':Added, #1: 1	وِرَاثَةِ شَخْصٍ
u'وِرَاثَةٌ نُبُوَّةٌ':Added, #1: 1	وِرَاثَةَ مَالٍ
u'وَرِثَ أَبٌ':Subject, #1: 1	وِرَاثَةِ النُّبُوَّةِ
u'وَرِثَ اِبْنٌ':Subject, #1: 1	وَرِثَ الْأَبُ
u'وَرَّثَ أحَدٌ':Subject, #1: 1	وَرِثَ ابْنُ
u'وَرِثَ أَخٌ':Subject, #2: 2	وَرَّثَ أَحَدٌ
u'وَرَّثَ إِخْوَةٌ':Predicate, #1: 1	وَرِثَ أَخٌ
u'وَرَّثَ أَكْثَرُ':Predicate, #1: 1	وَرَّثَ الإِخْوَةَ
u'وَرِثَ أَكْثَرُ':Subject, #1: 1	وَرَّثَ أَكْثَرَ
u'وَرَّثَ إمَامٌ':Subject, #1: 1	وَرِثَ أَكْثَرُ
u'وَرِثَ أمَةٌ':Predicate, #1: 1	وَرَّثَ الْإِمَامُ
u'وَرِثَ اِمْرَأَةٌ':Predicate, #1: 1	وَرِثَ الْأَمَةَ
u'وَرَّثَ اِمْرَأَةٌ':Predicate, #1: 1	وَرِثَ امْرَأَةَ
u'وَرِثَ أنبياء':Subject, #1: 1	وَرَّثَ امْرَأَةَ
u'وَرَّثَ أهْلٌ':Predicate, #2: 2	وَرِثَ الأَنْبِيَاءُ
u'وَرِثَ بَائِعٌ':Subject, #1: 1	وَرَّثَ أَهْلَ
u'وَرِثَ بَعْضٌ':Predicate, #2: 2	وَرِثَ الْبَائِعُ
u'وَرِثَ بناتٌ':Subject, #3: 3	وَرِثَ بَعْضَ
u'وَرَّثَ بِنْتٌ':Predicate, #2: 2	وَرِثَ بَنَاتُ
u'وَرَّثَ ثَلاثُ':Predicate, #1: 1	وَرَّثَ بِنْتَ
u'وَرَّثَ ثَلاثُ':Predicate, #1: 1	وَرَّثَ ثَلَاثَ
u'وَرِثَ ثُمْنٌ':Predicate, #2: 2	وَرَّثَ ثَلاَثَ
u'وَرِثَ ثَوْبٌ':Predicate, #1: 1	وَرِثَ الثُّمْنَ
u'وَرِثَ جَارِي':Predicate, #1: 1	وَرِثَ الثَّوْبَ
u'وَرِثَ جَارِيَةٌ':Predicate, #1: 1	وَرِثَ الْجَارِيَةَ
u'وَرِثَ جَمَاعَةٌ':Subject, #1: 1	وَرِثَ الْجَارِيَةَ
u'وَرِثَ جَمِيع':Subject, #1: 1	وَرِثَ جَمَاعَةٌ
u'وَرِثَ حَدٌّ':Predicate, #3: 3	وَرِثَ الْجَمِيعُ
u'وَرَّثَ حَمْدٌ':Predicate, #2: 2	وَرِثَ حَدَّ
u'وَرِثَ حَمْلٌ':Predicate, #1: 1	وَرَّثَ الْحَمْدَ
u'وَرَّثَ حَمْلٌ':Predicate, #1: 1	وَرِثَ الْحَمْلَ
u'وَرِثَ حَمْلٌ':Subject, #1: 1	وَرَّثَ الْحَمْلَ
u'وَرَّثَ خَالٌ':Predicate, #1: 1	وَرِثَ الْحَمْلُ
u'وَرِثَ خَمْسَةٌ':Subject, #1: 1	وَرَّثَ الْخَالَةَ
u'وَرِثَ دَائِنٌ':Subject, #1: 1	وَرِثَ خَمْسَةٌ
u'وَرِثَ دَمٌ':Predicate, #1: 1	وَرِثَ الدَّائِنُ
u'وَرِثَ دَيْنٌ':Predicate, #1: 1	وَرِثَ دَمَ
u'وَرِثَ ذكر':Subject, #1: 1	وَرِثَ دَيْنَ
u'وَرِثَ ذَكَرٌ':Subject, #1: 1	وَرِثَ الذَّكَرُ
u'وَرِثَ ذُكورٌ':Subject, #1: 1	وَرِثَ الذَّكَرُ
u'وَرَّثَ رِجَالٌ':Subject, #1: 1	وَرِثَ الذُّكُورُ
u'وَرَّثَ رَجُلٌ':Predicate, #1: 1	وَرَّثَ الرِّجَالُ
u'وَرِثَ رَجُلٌ':Subject, #1: 1	وَرَّثَ رَجُلاً
u'وَرِثَ رَجُلٌ':Subject, #1: 1	وَرِثَ الرَّجُلُ
u'وَرِثَ زَوْجٌ':Subject, #1: 1	وَرِثَ رَجُلٌ
u'وَرِثَ زَيْدٌ':Subject, #3: 3	وَرِثَ الزَّوْجُ
u'وَرِثَ سَاكِتٌ':Subject, #1: 1	وَرِثَ زَيْدٌ
u'وَرِثَ شَخْصٌ':Subject, #1: 1	وَرِثَ السَّاكِتُ
u'وَرِثَ صَغِيرٌ':Subject, #1: 1	وَرِثَ شَخْصٌ
u'وَرِثَ ضَلاَلَةٌ':Predicate, #2: 2	وَرِثَ الصَّغِيرُ
u'وَرِثَ عُشْرٌ':Predicate, #1: 1	وَرِثَ الضّلَالَةَ
u'وَرَّثَ عَمَّةٌ':Predicate, #1: 1	وَرِثَ الْعُشْرَ
u'وَرِثَ غير':Predicate, #1: 1	وَرَّثَ الْعَمَّةَ
u'وَرِثَ غَيْرٌ':Predicate, #1: 1	وَرِثَ غَيْرَ
u'وَرَّثَ فلان':Predicate, #1: 1	وَرِثَ غَيْرَ
u'وَرَّثَ فلان':Subject, #1: 1	وَرَّثَ حَفْصَةَ
u'وَرِثَ قَاتِلٌ':Subject, #1: 1	وَرَّثَ عُثْمَانُ
u'وَرِثَ قَرِيبٌ':Subject, #3: 3	وَرِثَ الْقَاتِلُ
u'وَرِثَ قصاص':Predicate, #1: 1	وَرِثَ قَرِيبُهُ
u'وَرِثَ قِصَاصٌ':Predicate, #2: 2	وَرِثَ الْقِصَاصَ
u'وَرِثَ قَوَد':Predicate, #2: 2	وَرِثَ الْقِصَاصَ
u'وَرِثَ قَوْمٌ':Subject, #1: 1	وَرِثَ الْقَوَدَ
u'وَرِثَ كَافِرٌ':Subject, #5: 5	وَرِثَ قَوْمٌ
u'وَرِثَ كَسْبٌ':Predicate, #1: 1	وَرِثَ الْكَافِرُ
u'وَرِثَ مَاشِي':Predicate, #2: 2	وَرِثَ كَسْبَ
u'وَرِثَ مَالٌ':Predicate, #1: 1	وَرِثَ مَاشِيَةً
u'وَرِثَ مَبِيعٌ':Predicate, #6: 6	وَرِثَ الْمَالَ
u'وَرِثَ مُحْتَالٌ':Subject, #1: 1	وَرِثَ الْمَبِيعَ
u'وَرِثَ مُعْتَقٌ':Subject, #1: 1	وَرِثَ الْمُحْتَالُ
u'وَرِثَ مَغْرِبِيٌّ':Subject, #1: 1	وَرِثَ الْمُعْتَقُ
u'وَرِثَ مكارم':Predicate, #2: 2	وَرِثَ الْمَغْرِبِيُّ
u'وَرِثَ مَكَارِمُ':Predicate, #1: 1	وَرِثَ الْمَكَارِمَ
u'وَرِثَ مَوَارِيثُ':Predicate, #1: 1	وَرِثَ الْمَكَارِمَ
u'وَرِثَ نُبُوَّةٌ':Predicate, #1: 1	وَرِثَ مَوَارِيثَ
u'وَرِثَ نصاب':Predicate, #2: 2	وَرِثَ النّبُوّةَ
u'وَرِثَ نِصَابٌ':Predicate, #1: 1	وَرِثَ نِصَابَ
u'وَرِثَ نِصْفٌ':Predicate, #1: 1	وَرِثَ نِصَابَ
u'وَرِثَ نِصْفٌ':Predicate, #2: 2	وَرِثَ النِّصْفَ
u'وَرِثَ وَرَثَةٌ':Subject, #5: 5	وَرِثَ نِصْفَ
u'وَرِثَ ولد':Subject, #1: 1	وَرِثَ الْوَرَثَةُ
u'وَرِثَ وَلَدٌ':Subject, #1: 1	وَرِثَ الْوَلَدُ
u'وَرِثَ ولد':Subject, #1: 1	وَرِثَ الْوَلَدُ
u'وَرِثَ وَلَدٌ':Subject, #2: 2	وَرِثَ وَلَدُهُ
u'وَرَّدَ اِبْنٌ':Subject, #2: 2	وَرِثَ وَلَدُهُ
u'وَرَدَ آثَارٌ':Subject, #1: 1	وَرَّدَ ابْنُ
u'وَرَدَ آثَارٌ':Subject, #1: 1	وَرَدَ آثَارُ
u'وَرَدَ أثَرٌ':Subject, #2: 2	وَرَدَ الْآثَارُ
u'وَرَدَ إِحْرَامٌ':Subject, #19: 19	وَرَدَ الْأَثَرُ
u'وَرَدَ إِخْبَارٌ':Subject, #1: 1	وَرَدَ الْإِحْرَامُ
u'وَرَدَ إِذْنٌ':Subject, #1: 1	وَرَدَ الْإِخْبَارُ
u'وَرَدَ اِسْتِفْتاءٌ':Subject, #1: 1	وَرَدَ الْإِذْنُ
u'وَرَدَ إِشْكالٌ':Subject, #1: 1	وَرَدَ اسْتِفْتَاءٌ
u'وَرَدَ إِطْلاقٌ':Subject, #1: 1	وَرَدَ الْإِشْكَالُ
u'وَرَدَ إِطْلاقٌ':Subject, #1: 1	وَرَدَ إطْلَاقُ
u'وَرَدَ أَمْرٌ':Predicate, #1: 1	وَرَدَ الْإِطْلَاقُ
u'وَرَدَ أَمْرٌ':Subject, #1: 1	وَرَدَ الْأَمْرَ
u'وَرَدَ أَوَّلُ':Subject, #17: 17	وَرَدَ الْأَمْرُ
u'وَرَدَ بَرْدٌ':Subject, #1: 1	وَرَدَ الْأَوَّلُ
u'وَرَدَ بَعْضٌ':Subject, #1: 1	وَرَدَ الْبَرْدُ
u'وَرَدَ بَيَانٌ':Subject, #2: 2	وَرَدَ بَعْضُ
u'وَرَدَ بَيْعٌ':Subject, #2: 2	وَرَدَ الْبَيَانُ
u'وَرَدَ تَحْدِيدٌ':Subject, #3: 3	وَرَدَ الْبَيْعُ
u'وَرَدَ تَحْدِيدٌ':Subject, #1: 1	وَرَدَ التّحْدِيدُ
u'وَرَدَ تَخْصِيصٌ':Subject, #2: 2	وَرَدَ التَّحْدِيدُ
u'وَرَدَ تَخْصِيصٌ':Subject, #1: 1	وَرَدَ التّخْصِيصُ
u'وَرَدَ تَخْفِيفٌ':Subject, #1: 1	وَرَدَ التَّخْصِيصُ
u'وَرَدَ تَرْخِيصٌ':Subject, #1: 1	وَرَدَ التَّخْفِيفُ
u'وَرَدَ تَرْغِيبٌ':Subject, #1: 1	وَرَدَ التَّرْخِيصُ
u'وَرَدَ تَصْرِيحٌ':Subject, #1: 1	وَرَدَ التَّرْغِيبُ
u'وَرَدَ تَعَبُّدٌ':Subject, #1: 1	وَرَدَ التَّصْرِيحُ
u'وَرَدَ تَعْيِينٌ':Subject, #2: 2	وَرَدَ التَّعَبُّدُ
u'وَرَدَ تَفْسِيرٌ':Subject, #1: 1	وَرَدَ التَّعْيِينُ
u'وَرَدَ تَقْيِيد':Subject, #1: 1	وَرَدَ تَفْسِيرُهُ
u'وَرَدَ تَكْبيرٌ':Subject, #2: 2	وَرَدَ التَّقْيِيدُ
u'وَرَدَ تَكْرارٌ':Subject, #3: 3	وَرَدَ التَّكْبِيرُ
u'وَرَدَ تَكْرارٌ':Subject, #1: 1	وَرَدَ تَكْرَارُ
u'وَرَدَ جمع':Subject, #1: 1	وَرَدَ تَكْرَارُهُ
u'وَرَدَ جَمْعٌ':Subject, #1: 1	وَرَدَ الْجَمْعُ
u'وَرَدَ جَوَابٌ':Subject, #1: 1	وَرَدَ الْجَمْعُ
u'وَرَدَ حالَةٌ':Predicate, #1: 1	وَرَدَ الْجَوَابُ
u'وَرَدَ حَثّ':Subject, #1: 1	وَرَدَ حَالَةَ
u'وَرَدَ حَديثٌ':Subject, #1: 1	وَرَدَ الْحَثُّ
u'وَرَدَ حَديثٌ':Subject, #11: 11	وَرَدَ الْحَدِيثُ
u'وَرَدَ حَديثٌ':Subject, #1: 1	وَرَدَ حَدِيثٌ
u'وَرَدَ حَظْر':Subject, #1: 1	وَرَدَ حَدِيثُ
u'وَرَدَ حُكْمٌ':Subject, #1: 1	وَرَدَ حَظْرٌ
u'وَرَدَ حِمَامٌ':Predicate, #3: 3	وَرَدَ الْحُكْمُ
u'وَرَدَ حَوْضٌ':Predicate, #1: 1	وَرَدَ الْحِمَامَ
u'وَرَدَ خَارِجٌ':Predicate, #1: 1	وَرَدَ حَوْضَ
u'وَرَدَ خاصّ':Subject, #2: 2	وَرَدَ خَارِجَ
u'وَرَدَ خُبْثٌ':Subject, #1: 1	وَرَدَ الْخَاصُّ
u'وَرَدَ خَبَرٌ':Subject, #1: 1	وَرَدَ خُبْثُهُ
u'وَرَدَ خَبَر':Subject, #15: 15	وَرَدَ الْخَبَرُ
u'وَرَدَ خَبَرٌ':Subject, #15: 15	وَرَدَ الْخَبَرُ
u'وَرَدَ خَبَر':Subject, #1: 1	وَرَدَ خَبَرٌ
u'وَرَدَ خِطَابٌ':Subject, #1: 1	وَرَدَ خَبَرٌ
u'وَرَدَ دَليلٌ':Subject, #4: 4	وَرَدَ الْخِطَابُ
u'وَرَدَ ذكر':Subject, #1: 1	وَرَدَ الدَّلِيلُ
u'وَرَدَ ذِكْرٌ':Subject, #1: 1	وَرَدَ ذِكْرُهُ
u'وَرَدَ ذكر':Subject, #1: 1	وَرَدَ ذِكْرُهُ
u'وَرَدَ ذِكْرٌ':Subject, #3: 3	وَرَدَ ذِكْرُ
u'وَرَدَ ذَمٌّ':Subject, #3: 3	وَرَدَ ذِكْرُ
u'وَرَدَ رَجُلٌ':Subject, #1: 1	وَرَدَ الذَّمُّ
u'وَرَدَ رِوايَةٌ':Subject, #1: 1	وَرَدَ الرَّجُلُ
u'وَرَدَ سَبَبٌ':Subject, #1: 1	وَرَدَ رِوَايَةٌ
u'وَرَدَ سَمْعٌ':Subject, #1: 1	وَرَدَ السَّبَبُ
u'وَرَدَ سُؤَالٌ':Subject, #1: 1	وَرَدَ السَّمْعُ
u'وَرَدَ سُؤَالٌ':Subject, #2: 2	وَرَدَ السُّؤَالُ
u'وَرَدَ سُوقٌ':Predicate, #2: 2	وَرَدَ سُؤَالٌ
u'وَرَدَ شافِعِيّ':Subject, #1: 1	وَرَدَ السُّوقَ
u'وَرَدَ شَرْعٌ':Subject, #1: 1	وَرَدَ الشَّافِعِيُّ
u'وَرَدَ شَطٌّ':Predicate, #44: 44	وَرَدَ الشَّرْعُ
u'وَرَدَ شَيْءٌ':Subject, #1: 1	وَرَدَ الشَّطَّ
u'وَرَدَ ضَمِيرٌ':Subject, #2: 2	وَرَدَ شَيْءٌ
u'وَرَدَ طَلاَقٌ':Subject, #1: 1	وَرَدَ الضَّمِيرُ
u'وَرَدَ ظاهِرٌ':Subject, #3: 3	وَرَدَ الطَّلَاقُ
u'وَرَدَ عَامٌّ':Subject, #1: 1	وَرَدَ الظَّاهِرُ
u'وَرَدَ عَامٌّ':Subject, #2: 2	وَرَدَ الْعَامُّ
u'وَرَدَ عَدَمٌ':Subject, #2: 2	وَرَدَ عَامٌّ
u'وَرَدَ عَقْدٌ':Subject, #1: 1	وَرَدَ عَدَمُ
u'وَرَدَ عَقْدٌ':Subject, #1: 1	وَرَدَ عَقْدٌ
u'وَرَدَ عَقْدٌ':Subject, #2: 2	وَرَدَ عَقْدُ
u'وَرَدَ عُمُومٌ':Subject, #4: 4	وَرَدَ الْعَقْدُ
u'وَرَّدَ غير':Subject, #3: 3	وَرَدَ الْعُمُومُ
u'وَرَّدَ غَيْرٌ':Subject, #1: 1	وَرَّدَ غَيْرُهُ
u'وَرَدَ فلان':Subject, #1: 1	وَرَّدَ غَيْرُهُ
u'وَرَدَ فلان':Subject, #1: 1	وَرَدَ الشَّافِعِيُّ
u'وَرَدَ قِرَاءةٌ':Subject, #1: 1	وَرَدَ جُبَيْرُ
u'وَرَدَ قُرْآنٌ':Subject, #2: 2	وَرَدَ قِرَاءَةُ
u'وَرَدَ قَوْلٌ':Subject, #3: 3	وَرَدَ الْقُرْآنُ
u'وَرَدَ قول':Subject, #1: 1	وَرَدَ قَوْلٌ
u'وَرَدَ قَوْلٌ':Subject, #1: 1	وَرَدَ قَوْلُهُ
u'وَرَدَ كِتَابٌ':Subject, #1: 1	وَرَدَ قَوْلُهُ
u'وَرَدَ كِتَابٌ':Subject, #1: 1	وَرَدَ كِتَابُهُ
u'وَرَدَ كِتَابٌ':Subject, #2: 2	وَرَدَ كِتَابٌ
u'وَرَدَ كِتَابٌ':Subject, #2: 2	وَرَدَ كِتَابُ
u'وَرَدَ كَلاَمٌ':Subject, #5: 5	وَرَدَ الْكِتَابُ
u'وَرَدَ لَفْظٌ':Subject, #1: 1	وَرَدَ الْكَلَامُ
u'وَرَدَ لَفْظٌ':Subject, #1: 1	وَرَدَ لَفْظٌ
u'وَرَدَ مَاءٌ':Predicate, #6: 6	وَرَدَ لَفْظُ
u'وَرَدَ مَاءٌ':Predicate, #1: 1	وَرَدَ الْمَاءَ
u'وَرَدَ مثل':Subject, #1: 1	وَرَدَ مَاءَ
u'وَرَدَ مِثْلٌ':Subject, #1: 1	وَرَدَ مِثْلُهُ
u'وَرَدَ مثل':Subject, #1: 1	وَرَدَ مِثْلُهُ
u'وَرَدَ مِثْلٌ':Subject, #2: 2	وَرَدَ مِثْلُ
u'وَرَدَ مَحْمُولٌ':Subject, #2: 2	وَرَدَ مِثْلُ
u'وَرَدَ مَدِينٌ':Predicate, #1: 1	وَرَدَ مَحْمُولٌ
u'وَرَدَ مَدِينَةٌ':Predicate, #1: 1	وَرَدَ الْمَدِينَةَ
u'وَرَدَ مَسْجِدٌ':Predicate, #1: 1	وَرَدَ الْمَدِينَةَ
u'وَرَدَ مُطْلَقٌ':Subject, #1: 1	وَرَدَ الْمَسْجِدَ
u'وَرَدَ مَنْعٌ':Subject, #1: 1	وَرَدَ مُطْلَقُ
u'وَرَدَ نَصٌّ':Subject, #1: 1	وَرَدَ الْمَنْعُ
u'وَرَدَ نَصٌّ':Subject, #19: 19	وَرَدَ النَّصُّ
u'وَرَدَ نقل':Subject, #8: 8	وَرَدَ نَصٌّ
u'وَرَدَ نَقْلٌ':Subject, #4: 4	وَرَدَ النَّقْلُ
u'وَرَدَ نَهْيٌ':Subject, #4: 4	وَرَدَ النَّقْلُ
u'وَرَدَ نَهْيٌ':Subject, #1: 1	وَرَدَ نَهْيٌ
u'وَرَدَ هلاك':Subject, #36: 36	وَرَدَ النَّهْيُ
u'وَرَدَ هَلاَكٌ':Subject, #1: 1	وَرَدَ الْهَلَاكُ
u'وَرَدَ وَارِدٌ':Subject, #1: 1	وَرَدَ الْهَلَاكُ
u'وَرَدَ وَصْفٌ':Subject, #2: 2	وَرَدَ وَارِدٌ
u'وَرَدَ وَعْدٌ':Subject, #1: 1	وَرَدَ وَصْفُ
u'وَرَدَ وَعِيدٌ':Subject, #2: 2	وَرَدَ الْوَعْدُ
u'وَرَدَ وَقْفٌ':Subject, #2: 2	وَرَدَ الْوَعِيدُ
u'وَرَعٌ أَلْسِنَةٌ':Added, #2: 2	وَرَدَ الْوَقْفُ
u'وَرَعٌ خَصْمٌ':Added, #1: 1	وَرَعِ الْأَلْسِنَةِ
u'وَرَعٌ سَائِرٌ':Added, #1: 1	وَرَعِ خَصْمِهِ
u'وَرَعٌ لِسَانٌ':Added, #1: 1	وَرَعُ سَائِرِ
u'وَرَقَ لَيْلٌ':Predicate, #1: 1	وَرَعُ اللِّسَانِ
u'وَرَكَ بَيْنٌ':Predicate, #1: 1	أَرِقَ لَيْلَةً
u'وَرَمٌ أُنْثَى':Added, #1: 1	وَرَكَ بَيْنَ
u'وَرِمَ بدن':Subject, #1: 1	وَرَمِ الْأُنْثَيَيْنِ
u'وَرِمَ بَدَنٌ':Subject, #1: 1	وَرِمَ بَدَنُهُ
u'وَرَمٌ جَنْبٌ':Added, #1: 1	وَرِمَ بَدَنُهُ
u'وَرَمٌ حارٌّ':Added, #1: 1	وَرَمُ الْجَنْبِ
u'وَرَمٌ رِئَةٌ':Added, #2: 2	وَرَمٍ حَارٍّ
u'وَرَّمَ ضرع':Predicate, #1: 1	وَرَمِ الرِّئَةِ
u'وَرَّمَ ضَرْعٌ':Predicate, #1: 1	وَرَّمَ ضَرْعَ
u'وَرَمٌ طِحَالٌ':Added, #1: 1	وَرَّمَ ضَرْعَ
u'وَرَمٌ طِحَالٌ':Added, #1: 1	وَرَمَ الطِّحَالِ
u'وَرَمٌ مَعِدَةٌ':Added, #1: 1	وَرَمِ الطِّحَالِ
u'وَرَمٌ مُلْتَحِمٌ':Added, #1: 1	وَرَمِ الْمَعِدَةِ
u'وَرَى زَنْدٌ':Subject, #1: 1	وَرَمُ الْمُلْتَحِمِ
u'وزان كَلاَمٌ':Added, #1: 1	وَرَى الزّنْدُ
u'وِزْرٌ صَاحِبٌ':Added, #1: 1	أَوْزَانِ كَلَامِ
u'وِزْر صَاحِبٌ':Added, #1: 1	وِزْرِ صَاحِبِ
u'وِزْرٌ عَمَلٌ':Added, #1: 1	وِزْرِ صَاحِبِ
u'وِزْر عَمَلٌ':Added, #1: 1	وِزْرِ الْعَمَلِ
u'وِزْرٌ كفر':Added, #1: 1	وِزْرِ الْعَمَلِ
u'وِزْر كفر':Added, #1: 1	وِزْرُ الْكُفْرِ
u'وِزْرٌ كُفْرٌ':Added, #1: 1	وِزْرُ الْكُفْرِ
u'وِزْر كُفْرٌ':Added, #1: 1	وِزْرُ الْكُفْرِ
u'وِزْرٌ مُمَاطَلَةٌ':Added, #1: 1	وِزْرُ الْكُفْرِ
u'وِزْر مُمَاطَلَةٌ':Added, #1: 1	وِزْرُ مُمَاطَلَتِهِ
u'وَزْنٌ آحَادٌ':Added, #1: 1	وِزْرُ مُمَاطَلَتِهِ
u'وَزَنَ أَرْبَعَةٌ':Predicate, #1: 1	وَزْنُ آحَادِهِ
u'وَزْنٌ أَرْجُلٌ':Added, #1: 1	وَزَنَ أَرْبَعَةَ
u'وَزْنٌ اِسْمٌ':Added, #1: 1	وَزْنِ أَرْجُلٍ
u'وَزْنٌ أَعْمَالٌ':Added, #1: 1	وَزْنِ اسْمِ
u'وَزْنٌ اِفْتِعَالٌ':Added, #2: 2	وَزْنُ أَعْمَالِ
u'وَزْنٌ أَفْعَالٌ':Added, #1: 1	وَزْنِ افْتِعَالٍ
u'وَزْنٌ أَقْوَالٌ':Added, #1: 1	وَزْنِ أَفْعَالٍ
u'وَزَنَ ألف':Predicate, #1: 1	وَزْنُ أَقْوَالٍ
u'وَزَنَ ألْفٌ':Predicate, #1: 1	وَزَنَ أَلْفَ
u'وَزَنَ أَلْفٌ':Predicate, #1: 1	وَزَنَ أَلْفَ
u'وَزْنٌ ألْفٌ':Added, #1: 1	وَزَنَ أَلْفَ
u'وَزْنٌ أَلْفٌ':Added, #1: 1	وَزْنَ أَلْفٍ
u'وَزْنٌ أَمْتِعَةٌ':Added, #1: 1	وَزْنَ أَلْفٍ
u'وَزْنٌ أهْلٌ':Added, #1: 1	وَزْنِ الْأَمْتِعَةِ
u'وَزْنٌ إيقَاعٌ':Added, #3: 3	وَزْنُ أَهْلِ
u'وَزْنٌ بَعْضٌ':Added, #1: 1	وَزْنِ إِيقَاعِ
u'وَزْنٌ بَلَدٌ':Added, #1: 1	وَزْنِ بَعْضِ
u'وَزْنٌ بَيْتٌ':Added, #1: 1	وَزْنِ بَلَدِهِ
u'وَزْنٌ بيض':Added, #2: 2	وَزْنِ بَيْتٍ
u'وَزْنٌ تِبْر':Added, #2: 2	وَزْنِ الْبِيضِ
u'وَزْنٌ تَفَاعُلٌ':Added, #1: 1	وَزْنُ التِّبْرِ
u'وَزْنٌ تَلَف':Added, #1: 1	وَزْنِ التَّفَاعُلِ
u'وَزْنٌ ثَدْيٌ':Added, #1: 1	وَزْنِ التّلَفِ
u'وَزْنٌ ثَلاثَةٌ':Added, #1: 1	وَزْنِ ثَدْيٍ
u'وَزْنٌ ثَمَنٌ':Added, #2: 2	وَزْنَ ثَلَاثَةِ
u'وَزْنٌ ثَمَنٌ':Added, #1: 1	وَزْنِ الثَّمَنِ
u'وَزْنٌ جَمَالٌ':Added, #1: 1	وَزْنَ ثَمَنِهِ
u'وَزْنٌ جَمِيع':Added, #1: 1	وَزْنِ جَمَالٍ
u'وَزْنٌ حَجَرٌ':Added, #1: 1	وَزْنُ الْجَمِيعِ
u'وَزْنٌ حَجَرٌ':Added, #1: 1	وَزْنَ الْحَجَرِ
u'وَزْنٌ حُلِيٌّ':Added, #1: 1	وَزْنُ حَجَرٍ
u'وَزْنٌ حُلِيٌّ':Added, #1: 1	وَزْنُ الْحُلِيِّ
u'وَزْنٌ حِلْيَةٌ':Added, #1: 1	وَزْنِ الْحُلِيِّ
u'وَزْنٌ حُمُولَةٌ':Added, #1: 1	وَزْنَ الْحِلْيَةِ
u'وَزْنٌ حِنْطَةٌ':Added, #1: 1	وَزْنُ الْحُمُولَةِ
u'وَزْنٌ خُبْز':Added, #3: 3	وَزْنِ الْحِنْطَةِ
u'وَزْنٌ خَشَبٌ':Added, #1: 1	وَزْنُ الْخُبْزَيْنِ
u'وَزْنٌ خَمْسَةٌ':Added, #1: 1	وَزْنِ الْخَشَبِ
u'وَزْنٌ خَمْسَةٌ':Added, #11: 11	وَزْنُ خَمْسَةٍ
u'وَزْنٌ خَمْسَةٌ':Added, #1: 1	وَزْنُ الْخَمْسَةِ
u'وَزْنٌ خَمْسَةٌ':Added, #1: 1	وَزْنِ خَمْسَةِ
u'وَزْنٌ خَمْسَةٌ':Added, #2: 2	وَزْنِ خَمْسَةٍ
u'وَزْنٌ دَرَاهِمُ':Added, #3: 3	وَزْنَ خَمْسَةٍ
u'وَزْنٌ دَرَاهِمُ':Added, #1: 1	وَزْنَ دَرَاهِمِهِ
u'وَزْنٌ دَرَاهِمُ':Added, #2: 2	وَزْنُ الدَّرَاهِمِ
u'وَزْنٌ دَرَاهِمُ':Added, #2: 2	وَزْنِ الدَّرَاهِمِ
u'وَزْنٌ دِرْهَمٌ':Added, #7: 7	وَزْنَ الدَّرَاهِمِ
u'وَزْنٌ دِرْهَم':Added, #1: 1	وَزْنِ الدِّرْهَمِ
u'وَزْنٌ دِرْهَمٌ':Added, #1: 1	وَزْنِ الدِّرْهَمِ
u'وَزْنٌ دِرْهَم':Added, #1: 1	وَزْنَ الدِّرْهَمَيْنِ
u'وَزْنٌ دِرْهَمٌ':Added, #1: 1	وَزْنَ الدِّرْهَمَيْنِ
u'وَزْنٌ دِرْهَمٌ':Added, #1: 1	وَزْنَ دِرْهَمَيْنِ
u'وَزْنٌ دِرْهَم':Added, #1: 1	وَزْنُ دِرْهَمَيْنِ
u'وَزْنٌ دِرْهَم':Added, #1: 1	وَزْنَ دِرْهَمَيْنِ
u'وَزْنٌ دِرْهَمٌ':Added, #1: 1	وَزْنُ دِرْهَمَيْنِ
u'وَزْنٌ دِرْهَمٌ':Added, #2: 2	وَزْنَ دِرْهَمٍ
u'وَزْنٌ دِرْهَم':Added, #2: 2	وَزْنِ دِرْهَمٍ
u'وَزْنٌ دِرْهَم':Added, #2: 2	وَزْنَ دِرْهَمٍ
u'وَزْنٌ دِرْهَمٌ':Added, #2: 2	وَزْنِ دِرْهَمٍ
u'وَزْنٌ دِرْهَم':Added, #4: 4	وَزْنَ الدِّرْهَمِ
u'وَزْنٌ دِرْهَمٌ':Added, #4: 4	وَزْنَ الدِّرْهَمِ
u'وَزْنٌ دِرْهَم':Added, #4: 4	وَزْنُ دِرْهَمٍ
u'وَزْنٌ دِرْهَمٌ':Added, #4: 4	وَزْنُ دِرْهَمٍ
u'وَزْنٌ دِرْهَم':Added, #5: 5	وَزْنُ الدِّرْهَمِ
u'وَزْنٌ دُهْنٌ':Added, #5: 5	وَزْنُ الدِّرْهَمِ
u'وَزْنٌ دَيْنٌ':Added, #2: 2	وَزْنُ الدُّهْنِ
u'وَزْنٌ دِينارٌ':Added, #3: 3	وَزْنِ الدَّيْنِ
u'وَزْنٌ ذَرٌّ':Added, #1: 1	وَزْنَ الدِّينَارِ
u'وَزْنٌ ذَهَبٌ':Added, #1: 1	وَزْنَ ذَرٍّ
u'وَزْنٌ ذَهَبٌ':Added, #1: 1	وَزْنُ الذَّهَبَيْنِ
u'وَزْنٌ ذَهَبٌ':Added, #3: 3	وَزْنِ ذَهَبِهِ
u'وَزْنٌ رَأْسٌ':Added, #5: 5	وَزْنَ الذَّهَبِ
u'وَزْنٌ رُبُعٌ':Added, #1: 1	وَزْنِ رَأْسِ
u'وَزْنٌ رُبْعٌ':Added, #1: 1	وَزْنُ رُبُعٍ
u'وَزَنَ رَجُلٌ':Subject, #1: 1	وَزْنُ رُبْعٍ
u'وَزْنٌ رَصاصٌ':Added, #2: 2	وَزَنَ الرَّجُلُ
u'وَزْنٌ رِطْلٌ':Added, #1: 1	وَزْنِ الرَّصَاصِ
u'وَزْنٌ رِطْلٌ':Added, #1: 1	وَزْنَ رِطْلَيْنِ
u'وَزْنٌ رَغيفٌ':Added, #2: 2	وَزْنُ رِطْلٍ
u'وَزْنٌ رَهْنٌ':Added, #1: 1	وَزْنِ رَغِيفٍ
u'وَزْنٌ رَهْنٌ':Added, #1: 1	وَزْنَ الرَّهْنِ
u'وَزْنٌ سُبْعٌ':Added, #2: 2	وَزْنُ الرَّهْنِ
u'وَزْنٌ سَبْعَةٌ':Added, #1: 1	وَزْنِ سُبْعِهِ
u'وَزْنٌ سَبْعَةٌ':Added, #15: 15	وَزْنَ سَبْعَةٍ
u'وَزْنٌ سَبْعَةٌ':Added, #18: 18	وَزْنُ سَبْعَةٍ
u'وَزْنٌ سَبْعَةٌ':Added, #3: 3	وَزْنَ السَّبْعَةِ
u'وَزْنٌ سَبْعَةٌ':Added, #6: 6	وَزْنَ سَبْعَةِ
u'وَزْنٌ سَبْعَةٌ':Added, #7: 7	وَزْنُ سَبْعَةِ
u'وَزْنٌ سِتٌّ':Added, #8: 8	وَزْنِ سَبْعَةٍ
u'وَزْنٌ سِتٌّ':Added, #2: 2	وَزْنِ سِتَّةٍ
u'وَزْنٌ سِتٌّ':Added, #5: 5	وَزْنُ سِتَّةٍ
u'وَزْنٌ سَحَابٌ':Added, #9: 9	وَزْنَ سِتَّةٍ
u'وَزْنٌ سدرة':Added, #1: 1	وَزْنِ سَحَابٍ
u'وَزْنٌ سِدْرَةٌ':Added, #1: 1	وَزْنِ سِدْرَةٍ
u'وَزْنٌ سَرْجٌ':Added, #1: 1	وَزْنِ سِدْرَةٍ
u'وَزْنٌ شَامِيٌّ':Added, #1: 1	وَزْنُ السَّرْجِ
u'وَزْنٌ شَعْرٌ':Added, #2: 2	وَزْنِ الشَّامِيَّةِ
u'وَزْنٌ شَعْرٌ':Added, #1: 1	وَزْنُ الشّعْرِ
u'وَزْنٌ شِعْرٌ':Added, #1: 1	وَزْنِ الشّعْرِ
u'وَزْنٌ شِعْرٌ':Added, #1: 1	وَزْنُ الشّعْرِ
u'وَزْنٌ شِعْرٌ':Added, #1: 1	وَزْنِ الشّعْرِ
u'وَزْنٌ شَعِيرٌ':Added, #5: 5	وَزْنِ الشِّعْرِ
u'وَزْنٌ شَعِيرَةٌ':Added, #1: 1	وَزْنَ الشَّعِيرِ
u'وَزْنٌ شَعِيرَة':Added, #1: 1	وَزْنَ شَعِيرَةٍ
u'وَزْنٌ شَيْءٌ':Added, #1: 1	وَزْنَ شَعِيرَةٍ
u'وَزْنٌ ضَارِبٌ':Added, #1: 1	وَزْنِ شَيْءٍ
u'وَزْنٌ ضَارِبٌ':Added, #1: 1	وَزْنُ ضَارِبٍ
u'وَزْنٌ طُمَأْنِينَةٌ':Added, #1: 1	وَزْنِ ضَارِبٍ
u'وَزْنٌ ظَرْفٌ':Added, #1: 1	وَزْنِ الطّمَأْنِينَةِ
u'وَزْنٌ ظَرْفٌ':Added, #2: 2	وَزْنِ الظَّرْفِ
u'وَزْنٌ عُرْفِيٌّ':Added, #7: 7	وَزْنَ الظَّرْفِ
u'وَزْنٌ عَشْرٌ':Added, #1: 1	وَزْنِ الْعُرْفِيَّاتِ
u'وَزْنٌ عَشْرٌ':Added, #1: 1	وَزْنَ عَشْرَةِ
u'وَزْنٌ عَمَلٌ':Added, #1: 1	وَزْنُ عَشْرَةِ
u'وَزْنٌ عِنَبٌ':Added, #1: 1	وَزْنُ الْعَمَلِ
u'وَزْنٌ عَنْبَرٌ':Added, #1: 1	وَزْنِ الْعِنَبَةِ
u'وَزْنٌ غَلَّةٌ':Added, #1: 1	وَزْنِ الْعَنْبَرِ
u'وَزْنٌ فَاعِلٌ':Added, #1: 1	وَزْنِ غَلَّةِ
u'وَزْنٌ فَاعِلٌ':Added, #1: 1	وَزْنِ الْفَاعِلِ
u'وَزْنٌ فَاعِلٌ':Added, #1: 1	وَزْنِ فَاعِلِهِ
u'وَزْنٌ فِضَّةٌ':Added, #2: 2	وَزْنِ فَاعِلٍ
u'وَزْنٌ فِضَّةٌ':Added, #4: 4	وَزْنُ الْفِضَّةِ
u'وَزْنٌ فعال':Added, #4: 4	وَزْنِ الْفِضَّةِ
u'وَزْنٌ فِعَالٌ':Added, #2: 2	وَزْنِ فِعَالٍ
u'وَزْنٌ فعال':Added, #2: 2	وَزْنِ فِعَالٍ
u'وَزْنٌ فَعَالٌ':Added, #5: 5	وَزْنِ فَعَالٍ
u'وَزْنٌ فِعْلٌ':Added, #5: 5	وَزْنِ فَعَالٍ
u'وَزْنٌ فعلة':Added, #1: 1	وَزْنِ فِعْلٍ
u'وَزْنٌ فعلة':Added, #1: 1	وَزْنِ فَعْلَةٍ
u'وَزْنٌ فَعْلَةٌ':Added, #1: 1	وَزْنِ فُعْلَةٍ
u'وَزْنٌ قَزٌّ':Added, #1: 1	وَزْنِ فَعْلَةٍ
u'وَزْنٌ قلب':Added, #2: 2	وَزْنِ الْقَزِّ
u'وَزْنٌ قلب':Added, #1: 1	وَزْنَ الْقُلْبِ
u'وَزْنٌ قلب':Added, #1: 1	وَزْنِ الْقَلْبِ
u'وَزْنٌ قَلْبٌ':Added, #1: 1	وَزْنِ الْقُلْبِ
u'وَزْنٌ قَلْب':Added, #1: 1	وَزْنِ الْقَلْبِ
u'وَزْنٌ قلب':Added, #1: 1	وَزْنِ الْقَلْبِ
u'وَزْنٌ قول':Added, #2: 2	وَزْنُ الْقُلْبِ
u'وَزْنٌ قَوْلٌ':Added, #2: 2	وَزْنِ قَوْلِ
u'وَزْنٌ قَيْدٌ':Added, #2: 2	وَزْنِ قَوْلِ
u'وَزْنٌ قَيْدٌ':Added, #1: 1	وَزْنَ الْقَيْدِ
u'وَزْنٌ قَيْدٌ':Added, #2: 2	وَزْنُ الْقَيْدِ
u'وَزْنٌ قِيرَاطٌ':Added, #4: 4	وَزْنِ الْقَيْدِ
u'وَزْنٌ قِيمَةٌ':Added, #1: 1	وَزْنُ قِيرَاطٍ
u'وَزْنٌ كَامِلٌ':Added, #1: 1	وَزْنِ الْقِيمَةِ
u'وَزْنٌ كبر':Added, #1: 1	وَزْنِ الْكَامِلِ
u'وَزْنٌ كِتَابٌ':Added, #1: 1	وَزْنِ الْكُبَرِ
u'وَزْنٌ كَلِمَةٌ':Added, #1: 1	وَزْنِ كِتَابٍ
u'وَزْنٌ لبنة':Added, #1: 1	وَزْنِ كَلِمَةٍ
u'وَزْنٌ لَبِنَةٌ':Added, #1: 1	وَزْنِ اللَّبِنَةِ
u'وَزْنٌ لَحْمٌ':Added, #1: 1	وَزْنِ اللَّبِنَةِ
u'وَزْنٌ مَالٌ':Added, #1: 1	وَزْنِ اللَّحْمِ
u'وَزْنٌ مثاقيل':Added, #2: 2	وَزْنِ مَالٍ
u'وَزْنٌ مِثَالٌ':Added, #1: 1	وَزْنُ الْمَثَاقِيلِ
u'وَزْنٌ مِثْقَالٌ':Added, #1: 1	وَزْنُ مِثَالَيْنِ
u'وَزْنٌ مِثْقَالٌ':Added, #1: 1	وَزْنِ الْمِثْقَالِ
u'وَزْنٌ مَجْمُوعٌ':Added, #2: 2	وَزْنُ الْمِثْقَالِ
u'وَزْنٌ مَجْمُوعٌ':Added, #1: 1	وَزْنِ الْمَجْمُوعِ
u'وَزْنٌ مَجْمُوعٌ':Added, #1: 1	وَزْنُ الْمَجْمُوعَةِ
u'وَزْنٌ مَحْمُولٌ':Added, #1: 1	وَزْنِ الْمَجْمُوعَةِ
u'وَزْنٌ مُدٌّ':Added, #1: 1	وَزْنِ الْمَحْمُولِ
u'وَزْنٌ مُدٌّ':Added, #1: 1	وَزْنُ الْمُدِّ
u'وَزْنٌ مُدٌّ':Added, #2: 2	وَزْنُ مُدٍّ
u'وَزْنٌ مُشار':Added, #2: 2	وَزْنِ مُدٍّ
u'وَزْنٌ مَشْطُورٌ':Added, #1: 1	وَزْنَ الْمُشَارِ
u'وَزْنٌ مَظْرُوفٌ':Added, #1: 1	وَزْنِ مَشْطُورِ
u'وَزْنٌ مَعَالِيقُ':Added, #1: 1	وَزْنَ الْمَظْرُوفِ
u'وَزْنٌ مُعَاوَنَةٌ':Added, #1: 1	وَزْنَ الْمَعَالِيقِ
u'وَزْنٌ مَعْلُومٌ':Added, #1: 1	وَزْنِ الْمُعَاوَنَةِ
u'وَزْنٌ مُفاعِل':Added, #4: 4	وَزْنٍ مَعْلُومٍ
u'وَزْنٌ مُفْرَدٌ':Added, #1: 1	وَزْنِ مُفَاعِلَةٍ
u'وَزْنٌ ملح':Added, #1: 1	وَزْنُ الْمُفْرَدَةِ
u'وَزْنٌ مِلْحٌ':Added, #2: 2	وَزْنِ الْمِلْحِ
u'وَزْنٌ مِنْبَرٌ':Added, #2: 2	وَزْنِ الْمِلْحِ
u'وَزْنٌ مَوْزُونٌ':Added, #1: 1	وَزْنِ مِنْبَرٍ
u'وَزْنٌ نَبْقٌ':Added, #1: 1	وَزْنَ الْمَوْزُونَاتِ
u'وَزْنٌ نُحَاسٌ':Added, #1: 1	وَزْنِ نَبْقَةٍ
u'وَزْنٌ نَمِرٌ':Added, #1: 1	وَزْنِ النُّحَاسِ
u'وَزْنٌ نَوَاةٌ':Added, #1: 1	وَزْنِ نَمِرَةٍ
u'وَزْنٌ نَوَاةٌ':Added, #10: 10	وَزْنِ نَوَاةٍ
u'وَزْنٌ واحد':Added, #2: 2	وَزْنَ نَوَاةٍ
u'وَزْنٌ وَاحِدٌ':Added, #1: 1	وَزْنٍ وَاحِدٍ
u'وَزْنٌ يَمِينٌ':Added, #1: 1	وَزْنٍ وَاحِدٍ
u'وَسَاطَةٌ أمناء':Added, #1: 1	وَزْنِ يَمِينٍ
u'وَسَاطَةٌ ثَوْبٌ':Added, #1: 1	وَسَاطَةَ الْأُمَنَاءِ
u'وَسَاطَةٌ وُجُوهٌ':Added, #1: 1	وَسَاطَةَ الثَّوْبِ
u'وَسَخٌ أسْنَانٌ':Added, #1: 1	وَسَاطَةِ وُجُوهِ
u'وَسَخٌ حَديدٌ':Added, #1: 1	وَسَخَ الْأَسْنَانِ
u'وَسَخٌ ظُفْرٌ':Added, #1: 1	وَسَخِ الْحَدِيدِ
u'وَسَخٌ عين':Added, #4: 4	وَسَخِ ظُفْرٍ
u'وَسَخٌ عَيْنٌ':Added, #1: 1	وَسَخُ الْعَيْنِ
u'وَسَخٌ عَيْن':Added, #1: 1	وَسَخُ الْعَيْنِ
u'وَسَخٌ غُرْلَة':Added, #1: 1	وَسَخُ الْعَيْنِ
u'وَسَّطَ ألف':Predicate, #1: 1	وَسَخُ الْغُرْلَةِ
u'وَسَّطَ بَيْنٌ':Predicate, #1: 1	وَسَّطَ الْأَلِفَ
u'وَسَّطَ ثَانِي':Predicate, #1: 1	وَسَّطَ بَيْنَ
u'وَسَّطَ جَزَاءٌ':Predicate, #1: 1	وَسَّطَ الثَّانِيَ
u'وَسَّطَ شَرْطٌ':Predicate, #7: 7	وَسَّطَ الْجَزَاءَ
u'وَسَّطَ طَلاَقٌ':Predicate, #1: 1	وَسَّطَ الشَّرْطَ
u'وَسَّطَ مَسْأَلَةٌ':Predicate, #2: 2	وَسَّطَ الطَّلَاقَ
u'وَسِعَ اِتِّبَاعٌ':Predicate, #1: 1	وَسَّطَ مَسْأَلَةَ
u'وَسِعَ بَرِيَّةٌ':Predicate, #1: 1	وَسِعَ اتِّبَاعَ
u'وَسَّعَ بَيْنٌ':Predicate, #1: 1	وَسِعَ الْبَرِيَّةَ
u'وَسِعَ ثَمانِيَةٌ':Predicate, #1: 1	وَسَّعَ بَيْنَ
u'وَسَّعَ جُرْحٌ':Predicate, #1: 1	وَسِعَ ثَمَانِيَةَ
u'وَسِعَ حاضِرٌ':Predicate, #1: 1	وَسَّعَ جُرْحَ
u'وَسِعَ حاضِرٌ':Subject, #1: 1	وَسِعَ الْحَاضِرَ
u'وَسِعَ حَشَفَةٌ':Subject, #1: 1	وَسِعَ الْحَاضِرُ
u'وَسَّعَ دَائِرَةٌ':Predicate, #1: 1	تَسَعَ حَشَفَتُهُ
u'وَسِعَ زَوْجٌ':Subject, #1: 1	وَسَّعَ الدَّائِرَةَ
u'وَسِعَ سَمْعٌ':Subject, #1: 1	وَسِعَ الزَّوْجُ
u'وَسَّعَ شَارِعٌ':Subject, #6: 6	وَسِعَ سَمْعُهُ
u'وَسَّعَ عُمَرٌ':Subject, #1: 1	وَسَّعَ الشَّارِعُ
u'وَسَّعَ فَمٌ':Predicate, #1: 1	وَسَّعَ عُمَرُ
u'وَسِعَ كُرْسِيٌّ':Subject, #1: 1	وَسَّعَ فَمَ
u'وَسِعَ كُرْسِيٌّ':Subject, #1: 1	وَسِعَ كُرْسِيّهُ
u'وَسَعَ كَلاَمٌ':Predicate, #4: 4	وَسِعَ كُرْسِيُّهُ
u'وَسِعَ مَحَلٌّ':Predicate, #1: 1	أَوْسَعَ الْكَلَامَ
u'وَسَّعَ مَسْجِدٌ':Predicate, #1: 1	وَسِعَ الْمَحَلَّ
u'وَسَعَ مَغْفِرَةٌ':Predicate, #5: 5	وَسَّعَ الْمَسْجِدَ
u'وَسِعَ مُودَعٌ':Predicate, #1: 1	أَوْسَعَ الْمَغْفِرَةَ
u'وَسِعَ نَاسٌ':Predicate, #1: 1	وَسِعَ الْمُودَعَ
u'وَسَّعَ وَاقِفٌ':Subject, #1: 1	وَسِعَ النَّاسَ
u'وَسِعَ وَقْتٌ':Subject, #2: 2	وَسَّعَ الْوَاقِفُ
u'وَسْقٌ تَمْرٌ':Added, #4: 4	وَسِعَ الْوَقْتُ
u'وَسْقٌ تَمْرٌ':Added, #1: 1	وَسْقَ تَمْرٍ
u'وَسْمٌ إِبِلٌ':Added, #1: 1	وَسْقُ تَمْرٍ
u'وَسَمَ بَهيمٌ':Predicate, #2: 2	وَسْمُ الْإِبِلِ
u'وَسَمَ بَهِيمَةٌ':Predicate, #1: 1	وَسَمَ الْبَهِيمَةَ
u'وَسْمٌ جِزْيَةٌ':Added, #1: 1	وَسَمَ الْبَهِيمَةَ
u'وَسْمٌ جِزْيَةٌ':Added, #1: 1	وَسْمَ الْجِزْيَةِ
u'وَسْمٌ نَعَمٌ':Added, #1: 1	وَسْمَ جِزْيَةٍ
u'وَسْمٌ وَجْهٌ':Added, #2: 2	وَسْمُ نَعَمِ
u'وَسْمٌ وَجْهٌ':Added, #2: 2	وَسْمِ الْوَجْهِ
u'وَسْمٌ وَجْهٌ':Added, #2: 2	وَسْمِ وَجْهٍ
u'وَسْوَسَةٌ شَيْطَانٌ':Added, #2: 2	وَسْمِ وَجْهِهِ
u'وَسْوَسَةٌ شَيْطَانٌ':Added, #1: 1	وَسْوَسَةِ الشّيْطَانِ
u'وَسْوَسَةٌ ظاهِرٌ':Added, #2: 2	وَسْوَسَةِ الشَّيْطَانِ
u'وَسْوَسَةٌ ظاهِرَة':Added, #1: 1	وَسْوَسَةٍ ظَاهِرَةٍ
u'وَسْوَسَةٌ نَفْسٌ':Added, #1: 1	وَسْوَسَةٍ ظَاهِرَةٍ
u'وَسْوَسَةٌ نَفْسٌ':Added, #1: 1	وَسْوَسَةُ النَّفْسِ
u'وَسَى إِحْرَامٌ':Predicate, #1: 1	وَسْوَسَةِ النَّفْسِ
u'وَسَى أَرْبَعُ':Predicate, #2: 2	نَسِيَ الْإِحْرَامَ
u'وَسَى اِسْتِعْمالٌ':Predicate, #7: 7	نَسِيَ أَرْبَعَ
u'وَسَى اِسْمٌ':Predicate, #1: 1	نَسِيَ اسْتِعْمَالَ
u'وَسَى أصل':Predicate, #1: 1	نَسِيَ اسْمَ
u'وَسَى أًصْلٌ':Predicate, #1: 1	نَسِيَ الْأَصْلَ
u'وَسَى أَعْضَاءٌ':Predicate, #1: 1	نَسِيَ الْأَصْلَ
u'وَسَى أُمْنِيَّةٌ':Predicate, #1: 1	نَسِيَ أَعْضَاءَ
u'وَسَى أَوَّلُ':Predicate, #1: 1	نَسِيَ الْأُمْنِيَّةَ
u'وَسَى باقِي':Predicate, #1: 1	نَسِيَ الْأَوَّلَ
u'وَسَى بَسْمَلَةٌ':Predicate, #2: 2	نَسِيَ الْبَاقِيَ
u'وَسَى بَعْضٌ':Predicate, #1: 1	نَسِيَ الْبَسْمَلَةَ
u'وَسَى تَذْكِرَةٌ':Predicate, #1: 1	نَسِيَ بَعْضَ
u'وَسَى تَرْتِيبٌ':Predicate, #1: 1	نَسِيَ تَذْكِرَةَ
u'وَسَى تَسْبِيحٌ':Predicate, #3: 3	نَسِيَ التَّرْتِيبَ
u'وَسَى تَسْبِيحٌ':Predicate, #1: 1	نَسِيَ التَّسْبِيحَ
u'وَسَى تَسْمِيَة':Predicate, #2: 2	نَسِيَ تَسْبِيحَ
u'وَسَى تَشَهُّدٌ':Predicate, #10: 10	نَسِيَ التَّسْمِيَةَ
u'وَسَى تَعَوُّذٌ':Predicate, #5: 5	نَسِيَ التَّشَهُّدَ
u'وَسَى تَعْيِينٌ':Predicate, #1: 1	نَسِيَ التَّعَوُّذَ
u'وَسَى تَقْيِيد':Predicate, #1: 1	نَسِيَ تَعْيِينَ
u'وَسَى تَكْبِير':Predicate, #1: 1	نَسِيَ التَّقْيِيدَ
u'وَسَى تَكْبِير':Predicate, #1: 1	نَسِيَ تَكْبِيرَةً
u'وَسَى تَكْبيرٌ':Predicate, #3: 3	نَسِيَ تَكْبِيرَةَ
u'وَسَى ثَلاثُ':Predicate, #9: 9	نَسِيَ التَّكْبِيرَ
u'وَسَى ثَمانِي':Predicate, #3: 3	نَسِيَ ثَلَاثَ
u'وَسَى جُلُوسٌ':Predicate, #1: 1	نَسِيَ الثَّمَانِيَ
u'وَسَى جَنَابَةٌ':Predicate, #1: 1	نَسِيَ الْجُلُوسَ
u'وَسَى جهر':Predicate, #1: 1	نَسِيَ الْجَنَابَةَ
u'وَسَى جَهْرٌ':Predicate, #1: 1	نَسِيَ الْجَهْرَ
u'وَسَى حِرْفَةٌ':Predicate, #1: 1	نَسِيَ الْجَهْرَ
u'وَسَى خامس':Predicate, #1: 1	نَسِيَ الْحِرْفَةَ
u'وَسَى خَامِسٌ':Predicate, #1: 1	نَسِيَ الْخَامِسَ
u'وَسَى خَبَرٌ':Predicate, #1: 1	نَسِيَ الْخَامِسَ
u'وَسَى خَبَر':Predicate, #1: 1	نَسِيَ الْخَبَرَ
u'وَسَى دَليلٌ':Predicate, #1: 1	نَسِيَ الْخَبَرَ
u'وَسَى رَاوِي':Predicate, #2: 2	نَسِيَ الدَّلِيلَ
u'وَسَى رَقَبَةٌ':Predicate, #1: 1	نَسِيَ رَاوِيَ
u'وَسَى رُكوعٌ':Predicate, #4: 4	نَسِيَ الرَّقَبَةَ
u'وَسَى رَمَلٌ':Predicate, #2: 2	نَسِيَ الرُّكُوعَ
u'وَسَى سجدة':Predicate, #2: 2	نَسِيَ الرَّمَلَ
u'وَسَى سَجْدَةٌ':Predicate, #2: 2	نَسِيَ سَجْدَةَ
u'وَسَى سُجُودٌ':Predicate, #2: 2	نَسِيَ سَجْدَةَ
u'وَسَى سُجُودٌ':Predicate, #10: 10	نَسِيَ سُجُودَ
u'وَسَى سلام':Predicate, #2: 2	نَسِيَ السُّجُودَ
u'وَسَى سَلاَمٌ':Predicate, #6: 6	نَسِيَ السَّلَامَ
u'وَسَى سِواكٌ':Predicate, #6: 6	نَسِيَ السَّلَامَ
u'وَسَى سُورَةٌ':Predicate, #2: 2	نَسِيَ السِّوَاكَ
u'وَسَى شَهَادَةٌ':Predicate, #3: 3	نَسِيَ السُّورَةَ
u'وَسَى صَاحِبٌ':Predicate, #1: 1	نَسِيَ الشَّهَادَةَ
u'وَسَى صَلاَةٌ':Predicate, #1: 1	نَسِيَ صَاحِبَ
u'وَسَى صَلاَةٌ':Predicate, #1: 1	نَسِيَ الصَّلَاةَ
u'وَسَى صنعة':Predicate, #5: 5	نَسِيَ صَلَاةَ
u'وَسَى صَنْعَةٌ':Predicate, #1: 1	نَسِيَ الصَّنْعَةَ
u'وَسَى صَوْمٌ':Predicate, #1: 1	نَسِيَ الصَّنْعَةَ
u'وَسَى طَهَارَةٌ':Predicate, #2: 2	نَسِيَ الصَّوْمَ
u'وَسَى طواف':Predicate, #1: 1	نَسِيَ الطَّهَارَةَ
u'وَسَى طَوَافٌ':Predicate, #1: 1	نَسِيَ طَوَافَ
u'وَسَى ظُهْرٌ':Predicate, #1: 1	نَسِيَ طَوَافَ
u'وَسَى عِشَاءٌ':Predicate, #5: 5	نَسِيَ الظُّهْرَ
u'وَسَى عَصْرٌ':Predicate, #1: 1	نَسِيَ الْعِشَاءَ
u'وَسَى غَسْلٌ':Predicate, #1: 1	نَسِيَ الْعَصْرَ
u'وَسَى فَاتِحٌ':Predicate, #3: 3	نَسِيَ غَسْلَ
u'وَسَى فَاتِحَةٌ':Predicate, #7: 7	نَسِيَ الْفَاتِحَةَ
u'وَسَى فَجْرٌ':Predicate, #7: 7	نَسِيَ الْفَاتِحَةَ
u'وَسَى قَالٌ':Predicate, #1: 1	نَسِيَ الْفَجْرَ
u'وَسَى قِرَاءةٌ':Predicate, #1: 1	نَسِيَ قَالَ
u'وَسَى قِرَاءةٌ':Predicate, #5: 5	نَسِيَ قِرَاءَةَ
u'وَسَى قعدة':Predicate, #7: 7	نَسِيَ الْقِرَاءَةَ
u'وَسَى قَعْدَةٌ':Predicate, #1: 1	نَسِيَ الْقَعْدَةَ
u'وَسَى قُنُوتٌ':Predicate, #1: 1	نَسِيَ الْقَعْدَةَ
u'وَسَى كِتَابٌ':Predicate, #4: 4	نَسِيَ الْقُنُوتَ
u'وَسَى لَفْظٌ':Predicate, #2: 2	نَسِيَ الْكِتَابَ
u'وَسَى لَيْلٌ':Predicate, #1: 1	نَسِيَ اللَّفْظَ
u'وَسَى مَاءٌ':Predicate, #1: 1	نَسِيَ لَيْلَةَ
u'وَسَى مَاءٌ':Predicate, #13: 13	نَسِيَ الْمَاءَ
u'وَسَى مثل':Predicate, #1: 1	نَسِيَ مَاءَ
u'وَسَى مِثْلٌ':Predicate, #1: 1	نَسِيَ مِثْلَ
u'وَسَى مَسْحٌ':Predicate, #1: 1	نَسِيَ مِثْلَ
u'وَسَى مَسْحٌ':Predicate, #1: 1	نَسِيَ الْمَسْحَ
u'وَسَى مَضْمَضَةٌ':Predicate, #7: 7	نَسِيَ مَسْحَ
u'وَسَى مُطَالَبٌ':Predicate, #3: 3	نَسِيَ الْمَضْمَضَةَ
u'وَسَى مُطَالَبَةٌ':Predicate, #4: 4	نَسِيَ الْمُطَالَبَةَ
u'وَسَى مَطْلُوب':Predicate, #4: 4	نَسِيَ الْمُطَالَبَةَ
u'وَسَى مُعْتَقٌ':Predicate, #1: 1	نَسِيَ مَطْلُوبِيَّةَ
u'وَسَى نكاح':Predicate, #1: 1	نَسِيَ الْمُعْتَقَةَ
u'وَسَى نِكَاحٌ':Predicate, #1: 1	نَسِيَ النِّكَاحَ
u'وَسَى نِيَّةٌ':Predicate, #1: 1	نَسِيَ النِّكَاحَ
u'وَسَى نِيَّةٌ':Predicate, #1: 1	نَسِيَ نِيَّةَ
u'وَسَى وَدِيعٌ':Predicate, #7: 7	نَسِيَ النِّيَّةَ
u'وَسَى وَدِيعَةٌ':Predicate, #2: 2	نَسِيَ الْوَدِيعَةَ
u'وَسَى وَصِيٌّ':Predicate, #2: 2	نَسِيَ الْوَدِيعَةَ
u'وَسَى وَصِيَّةٌ':Predicate, #1: 1	نَسِيَ الْوَصِيَّةَ
u'وَسَى وَقْتٌ':Predicate, #1: 1	نَسِيَ الْوَصِيَّةَ
u'وَسَى يَمِينٌ':Predicate, #1: 1	نَسِيَ وَقْتَ
u'وَسَى يَوْمٌ':Predicate, #1: 1	نَسِيَ الْيَمِينَ
u'وَشَمَ كَافِرٌ':Subject, #2: 2	نَسِيَ الْيَوْمَ
u'وَشْيٌ بردة':Added, #1: 1	وَشَمَ الْكَافِرُ
u'وَشْيٌ بُرْدَةٌ':Added, #1: 1	وَشْيِ الْبُرْدَةِ
u'وَشَى بَيْنٌ':Predicate, #1: 1	وَشْيِ الْبُرْدَةِ
u'وَشِيجَةٌ رحم':Added, #1: 1	وَشَى بَيْنَ
u'وَشِيجَةٌ رَحِمٌ':Added, #1: 1	وَشِيجَةِ الرَّحِمِ
u'وَشْيٌ رَبِيعٌ':Added, #1: 1	وَشِيجَةِ الرَّحِمِ
u'وَشَى وَلَهٌ':Subject, #1: 1	وَشْيِ الرَّبِيعِ
u'وَشْيٌ يمن':Added, #1: 1	وَشَى وَلَهُ
u'وَشْيٌ يَمَنُ':Added, #1: 1	وَشْيِ الْيَمَنِ
u'وصال صِيَامٌ':Added, #1: 1	وَشْيِ الْيَمَنِ
u'وِصَالٌ صِيَامٌ':Added, #1: 1	وِصَالِ الصِّيَامِ
u'وصال مَلُولٌ':Added, #1: 1	وِصَالِ الصِّيَامِ
u'وِصَالٌ مَلُولٌ':Added, #1: 1	وِصَالَ الْمَلُولِ
u'وَصْفٌ إِبِلٌ':Added, #1: 1	وِصَالَ الْمَلُولِ
u'وَصَفَ أحَدٌ':Predicate, #1: 1	وَصْفِ الْإِبِلِ
u'وَصْفٌ أحَدٌ':Added, #1: 1	وَصَفَ أَحَدَ
u'وَصْفٌ أَدَاءٌ':Added, #2: 2	وَصْفُ أَحَدِ
u'وَصْفٌ إِرْثٌ':Added, #1: 1	وَصْفُ الْأَدَاءِ
u'وَصْفٌ أرْضٌ':Added, #1: 1	وَصْفِ الْإِرْثِ
u'وَصْفٌ أَسَدٌ':Added, #1: 1	وَصْفُ الْأَرْضِ
u'وَصْفٌ إِسْقاطٌ':Added, #1: 1	وَصْفِ الْأَسَدِ
u'وَصَفَ إِسْلامٌ':Predicate, #1: 1	وَصْفِ الْإِسْقَاطِ
u'وَصَفَ إِسْلامٌ':Predicate, #1: 1	وَصَفَ الإِسْلاَمَ
u'وَصْفٌ إِسْلامٌ':Added, #3: 3	وَصَفَ الْإِسْلَامَ
u'وَصْفٌ إِسْلامٌ':Added, #1: 1	وَصْفِ الإِسْلاَمِ
u'وَصْفٌ إِسْنادٌ':Added, #1: 1	وَصْفَ الْإِسْلَامِ
u'وَصْفٌ إِسْنادٌ':Added, #1: 1	وَصْفُ الْإِسْنَادِ
u'وَصْفٌ إشاعَةٌ':Added, #1: 1	وَصْفِ الْإِسْنَادِ
u'وَصَفَ أَصْحَابٌ':Subject, #1: 1	وَصْفُ الْإِشَاعَةِ
u'وَصْفٌ أصل':Added, #1: 1	وَصَفَ أَصْحَابُهُ
u'وَصْفٌ أًصْلٌ':Added, #2: 2	وَصْفِ الْأَصْلِ
u'وَصْفٌ أَعْضَاءٌ':Added, #2: 2	وَصْفِ الْأَصْلِ
u'وَصْفٌ أَعْضَاءٌ':Added, #1: 1	وَصْفَ الْأَعْضَاءِ
u'وَصْفٌ أعْظَمُ':Added, #1: 1	وَصْفِ الْأَعْضَاءِ
u'وَصْفٌ أعْيانٌ':Added, #1: 1	وَصْفِ الْأَعْظَمِ
u'وَصْفٌ أَعْيَانٌ':Added, #1: 1	وَصْفِ الْأَعْيَانِ
u'وَصْفٌ أَكْمَلُ':Added, #1: 1	وَصْفِ الْأَعْيَانِ
u'وَصَفَ الْمَرْأَةُ':Predicate, #2: 2	وَصْفَ أَكْمَلِ
u'وَصْفٌ الْمَرْأَةُ':Added, #1: 1	وَصَفَ الْمَرْأَةَ
u'وَصْفٌ إمَامٌ':Added, #3: 3	وَصْفُ الْمَرْأَةِ
u'وَصَفَ أَمْرٌ':Predicate, #1: 1	وَصْفِ الْإِمَامِ
u'وَصْفٌ أَمْنٌ':Added, #1: 1	وَصَفَ الْأَمْرَ
u'وَصْفٌ أُمَّهَاتٌ':Added, #1: 1	وَصْفِ الْأَمْنِ
u'وَصْفٌ إِنابَةٌ':Added, #1: 1	وَصْفِ الْأُمَّهَاتِ
u'وَصَفَ أنبياء':Subject, #1: 1	وَصْفَ الْإِنَابَةِ
u'وَصْفٌ اِنْتِفاء':Added, #2: 2	وَصَفَ الْأَنْبِيَاءُ
u'وَصْفٌ إِنْسانٌ':Added, #1: 1	وَصْفُ انْتِفَاءِ
u'وَصْفٌ أَنْوَاعٌ':Added, #1: 1	وَصْفِ الْإِنْسَانِ
u'وَصْفٌ أهْلٌ':Added, #1: 1	وَصْفُ أَنْوَاعٍ
u'وَصْفٌ أهْلٌ':Added, #1: 1	وَصْفُ أَهْلِ
u'وَصَفَ أَوَّلُ':Predicate, #1: 1	وَصْفِ أَهْلِ
u'وَصَفَ أَوَّلُ':Subject, #2: 2	وَصَفَ الْأَوَّلَ
u'وَصْفٌ بَارِئٌ':Added, #1: 1	وَصَفَ الْأَوَّلُ
u'وَصَفَ بَائِعٌ':Subject, #1: 1	وَصْفِ الْبَارِئِ
u'وَصْفٌ بَائِعٌ':Added, #1: 1	وَصَفَ الْبَائِعُ
u'وَصَفَ بدن':Predicate, #1: 1	وَصْفِ الْبَائِعِ
u'وَصَفَ بَدَنٌ':Predicate, #1: 1	وَصَفَ الْبَدَنَ
u'وَصَفَ بَشَرَةٌ':Predicate, #1: 1	وَصَفَ الْبَدَنَ
u'وَصَفَ بَعْضٌ':Subject, #1: 1	وَصَفَ الْبَشَرَةَ
u'وَصْفٌ بَقِيَّةٌ':Added, #3: 3	وَصَفَ بَعْضُ
u'وَصْفٌ تَابِعٌ':Added, #1: 1	وَصْفَ الْبَقِيَّةِ
u'وَصْفٌ تَابِعٌ':Added, #1: 1	وَصْفِ التَّابِعِ
u'وَصْفٌ تَبَع':Added, #2: 2	وَصْفٍ تَابِعٍ
u'وَصْفٌ تَبَعِيّ':Added, #1: 1	وَصْفِ التَّبَعِيَّةِ
u'وَصْفٌ تَبَعِيَّة':Added, #1: 1	وَصْفِ التَّبَعِيَّةِ
u'وَصَفَ تِجَارَةٌ':Predicate, #1: 1	وَصْفِ التَّبَعِيَّةِ
u'وَصَفَ تَحْوِيلٌ':Predicate, #1: 1	وَصَفَ التِّجَارَةَ
u'وَصْفٌ تَخْيِيرٌ':Added, #1: 1	وَصَفَ تَحْوِيلَ
u'وَصْفٌ تُرَابٌ':Added, #1: 1	وَصْفُ التَّخْيِيرِ
u'وَصْفٌ تَصَرُّفٌ':Added, #1: 1	وَصْفُ التُّرَابِ
u'وَصْفٌ تَعْلِيقٌ':Added, #2: 2	وَصْفِ التَّصَرُّفِ
u'وَصْفٌ تَغْلِيظٌ':Added, #1: 1	وَصْفَ التَّعْلِيقِ
u'وَصْفٌ تَفَرُّقٌ':Added, #1: 1	وَصْفِ التَّغْلِيظِ
u'وَصْفٌ تَفْوِيضٌ':Added, #1: 1	وَصْفِ التَّفَرُّقِ
u'وَصَفَ تَقاطِيعُ':Predicate, #2: 2	وَصْفُ التَّفْوِيضِ
u'وَصْفٌ تَقْديمٌ':Added, #1: 1	وَصَفَ التَّقَاطِيعَ
u'وَصْفٌ تَقَرُّبٌ':Added, #1: 1	وَصْفِ التَّقْدِيمِ
u'وَصْفٌ تَمَتُّعٌ':Added, #1: 1	وَصْفُ التَّقَرُّبِ
u'وَصْفٌ ثَابِتٌ':Added, #1: 1	وَصْفُ التَّمَتُّعِ
u'وَصْفٌ ثَامِنٌ':Added, #1: 1	وَصْفٍ ثَابِتٍ
u'وَصْفٌ ثَانَوِيٌّ':Added, #1: 1	وَصْفٍ ثَامِنٍ
u'وَصْفٌ ثَانَوِيٌّ':Added, #1: 1	وَصْفَ الثَّانَوِيَّةِ
u'وَصَفَ ثَانِي':Predicate, #1: 1	وَصْفُ الثَّانَوِيَّةِ
u'وَصَفَ ثَانِي':Predicate, #1: 1	وَصَفَ الثَّانِيَ
u'وَصَفَ ثَانِيَةٌ':Predicate, #2: 2	وَصَفَ الثَّانِيَةَ
u'وَصْفٌ ثُبُوتٌ':Added, #2: 2	وَصَفَ الثَّانِيَةَ
u'وَصْفٌ ثِقَةٌ':Added, #1: 1	وَصْفَ الثُّبُوتِ
u'وَصَفَ ثَلاثُ':Predicate, #1: 1	وَصْفَ الثِّقَةِ
u'وَصْفٌ ثَمَنٌ':Added, #2: 2	وَصَفَ الثَّلَاثَ
u'وَصْفٌ ثَمَن':Added, #1: 1	وَصْفَ الثَّمَنِ
u'وَصْفٌ ثَمَنٌ':Added, #3: 3	وَصْفُ الثَّمَنِيَّةِ
u'وَصْفٌ ثَوْبٌ':Added, #7: 7	وَصْفِ الثَّمَنِ
u'وَصْفٌ ثَوْبٌ':Added, #1: 1	وَصْفُ الثَّوْبِ
u'وَصَفَ جَارِي':Predicate, #5: 5	وَصْفِ الثَّوْبِ
u'وَصَفَ جَارِيَةٌ':Predicate, #1: 1	وَصَفَ الْجَارِيَةَ
u'وَصْفٌ جَامِعٌ':Added, #1: 1	وَصَفَ الْجَارِيَةَ
u'وَصْفٌ جِدار':Added, #1: 1	وَصْفٍ جَامِعٍ
u'وَصَفَ جدد':Predicate, #2: 2	وَصْفُ الْجِدَارِ
u'وَصْفٌ جُزْئِيٌّ':Added, #1: 1	وَصَفَ الْجُدُدَ
u'وَصْفٌ جَنَابَةٌ':Added, #1: 1	وَصْفٍ جُزْئِيٍّ
u'وَصَفَ جَنَّةٌ':Predicate, #1: 1	وَصْفَ الْجَنَابَةِ
u'وَصْفٌ حَرْبٌ':Added, #1: 1	وَصَفَ جَنَّةَ
u'وَصْفٌ حُرْمَةٌ':Added, #1: 1	وَصْفِ الْحَرْبِ
u'وَصْفٌ حُرِّيَّةٌ':Added, #1: 1	وَصْفِ الْحُرْمَةِ
u'وَصْفٌ حُرِّيَّةٌ':Added, #1: 1	وَصْفَ الْحُرِّيَّةِ
u'وَصْفٌ حُرِّيَّةٌ':Added, #2: 2	وَصْفُ الْحُرِّيَّةِ
u'وَصَفَ حَسَنٌ':Subject, #3: 3	وَصْفِ الْحُرِّيَّةِ
u'وَصْفٌ حِصَّةٌ':Added, #1: 1	وَصَفَ الْحَسَنُ
u'وَصْفٌ حِصَّةٌ':Added, #1: 1	وَصْفَ الْحِصَّةِ
u'وَصْفٌ حِفْظٌ':Added, #1: 1	وَصْفُ الْحِصَّةِ
u'وَصْفٌ حَقِيقِيٌّ':Added, #1: 1	وَصْفِ الْحِفْظِ
u'وَصْفٌ حَقِيقِيٌّ':Added, #1: 1	وَصْفِ الْحَقِيقِيِّ
u'وَصْفٌ حُكْمٌ':Added, #1: 1	وَصْفٍ حَقِيقِيٍّ
u'وَصْفٌ حُكْمٌ':Added, #1: 1	وَصْفُ حُكْمِ
u'وَصْفٌ حِلٌّ':Added, #1: 1	وَصْفِ حُكْمِ
u'وَصْفٌ حَمَامٌ':Added, #1: 1	وَصْفِ الْحِلِّ
u'وَصْفٌ حَنْظَلٌ':Added, #1: 1	وَصْفِ الْحَمَامِ
u'وَصَفَ حَيْضٌ':Predicate, #1: 1	وَصْفِ الْحَنْظَلَةِ
u'وَصْفٌ خاصّ':Added, #1: 1	وَصَفَ الْحَيْضَ
u'وَصْفٌ خُدُودٌ':Added, #1: 1	وَصْفٍ خَاصٍّ
u'وَصْفٌ خُرُوجٌ':Added, #1: 1	وَصْفِ الْخُدُودِ
u'وَصَفَ خَطٌّ':Predicate, #1: 1	وَصْفِ الْخُرُوجِ
u'وَصْفٌ خُلَفَاءُ':Added, #1: 1	وَصَفَ الْخَطَّ
u'وَصْفٌ خلقة':Added, #2: 2	وَصْفِ الْخُلَفَاءِ
u'وَصْفٌ خِلْقَةٌ':Added, #1: 1	وَصْفِ خِلْقَتِهِ
u'وَصْفٌ خُلُوصٌ':Added, #1: 1	وَصْفِ خِلْقَتِهِ
u'وَصْفٌ خَمْرٌ':Added, #1: 1	وَصْفَ الْخُلُوصِ
u'وَصْفٌ دِبَاغَةٌ':Added, #1: 1	وَصْفُ الْخَمْرِ
u'وَصْفٌ دَرْعٌ':Added, #1: 1	وَصْفَ الدِّبَاغَةِ
u'وَصْفٌ دَليلٌ':Added, #2: 2	وَصْفِ الدّرْعِ
u'وَصْفٌ ذُبابٌ':Added, #1: 1	وَصْفُ الدَّلِيلِ
u'وَصْفٌ ذُكورَةٌ':Added, #1: 1	وَصْفِ الذّبَابِ
u'وَصْفٌ ذُكورَةٌ':Added, #1: 1	وَصْفَ الذُّكُورَةِ
u'وَصْفٌ ذُكورَةٌ':Added, #1: 1	وَصْفِ الذُّكُورَةِ
u'وَصْفٌ رَأْيٌ':Added, #4: 4	وَصْفُ الذُّكُورَةِ
u'وَصْفٌ رَجُلٌ':Added, #1: 1	وَصْفِ الرَّأْيِ
u'وَصْفٌ رَجُلٌ':Added, #1: 1	وَصْفِ الرّجُلِ
u'وَصْفٌ رُجُولِيٌّ':Added, #3: 3	وَصْفِ رَجُلٍ
u'وَصْفٌ رحمة':Added, #1: 1	وَصْفُ الرُّجُولِيَّةِ
u'وَصْفٌ رحمة':Added, #1: 1	وَصْفَ الرَّحْمَةِ
u'وَصْفٌ رَحْمَةٌ':Added, #1: 1	وَصْفِ الرَّحْمَةِ
u'وَصْفٌ رَحْمَةٌ':Added, #1: 1	وَصْفَ الرَّحْمَةِ
u'وَصَفَ رَسُولٌ':Predicate, #1: 1	وَصْفِ الرَّحْمَةِ
u'وَصَفَ رَسُولٌ':Subject, #3: 3	وَصَفَ رَسُولَ
u'وَصْفٌ رِقَّةٌ':Added, #1: 1	وَصَفَ رَسُولُ
u'وَصْفٌ رُكْن':Added, #1: 1	وَصْفَ الرِّقَّةِ
u'وَصْفٌ رُكْنِيّ':Added, #1: 1	وَصْفِ الرُّكْنِيَّةِ
u'وَصْفٌ رَهْبانِيَّةٌ':Added, #1: 1	وَصْفِ الرُّكْنِيَّةِ
u'وَصَفَ رَهْنٌ':Predicate, #1: 1	وَصْفِ الرَّهْبَانِيَّةِ
u'وَصْفٌ رَوْضٌ':Added, #1: 1	وَصَفَ الرَّهْنَ
u'وَصْفٌ ريحٌ':Added, #1: 1	وَصْفِ رَوْضٍ
u'وَصْفٌ رِيقٌ':Added, #1: 1	وَصْفُ الرِّيحِ
u'وَصْفٌ زائِدٌ':Added, #1: 1	وَصْفِ الرِّيقِ
u'وَصْفٌ زائِلٌ':Added, #2: 2	وَصْفٍ زَائِدٍ
u'وَصَفَ زِينَةٌ':Predicate, #1: 1	وَصْفٍ زَائِلٍ
u'وَصْفٌ سَابِقٌ':Added, #1: 1	وَصَفَ الزِّينَةَ
u'وَصْفٌ سَتْرٌ':Added, #1: 1	وَصْفُ السَّابِقِ
u'وَصَفَ سُجُودٌ':Predicate, #1: 1	وَصْفِ السَّتْرِ
u'وَصَفَ سُجُودٌ':Predicate, #1: 1	وَصَفَ السُّجُودَ
u'وَصْفٌ سُجُودٌ':Added, #1: 1	وَصَفَ سُجُودَ
u'وَصْفٌ سَرقَةٌ':Added, #1: 1	وَصْفُ السُّجُودِ
u'وَصْفٌ سَرقَةٌ':Added, #1: 1	وَصْفُ السَّرِقَةِ
u'وَصْفٌ سَرِقَةٌ':Added, #1: 1	وَصْفِ السَّرِقَةِ
u'وَصْفٌ سَرِقَةٌ':Added, #1: 1	وَصْفُ السَّرِقَةِ
u'وَصْفٌ سَلاَمَةٌ':Added, #1: 1	وَصْفِ السَّرِقَةِ
u'وَصْفٌ سَلاَمَةٌ':Added, #17: 17	وَصْفِ السَّلَامَةِ
u'وَصْفٌ سَلاَمَةٌ':Added, #1: 1	وَصْفُ السَّلَامَةِ
u'وَصْفٌ سَلَمٌ':Added, #7: 7	وَصْفَ السَّلَامَةِ
u'وَصْفٌ سَلَمٌ':Added, #1: 1	وَصْفُ السَّلَمِ
u'وَصْفٌ سَنَةٌ':Added, #2: 2	وَصْفِ السَّلَمِ
u'وَصْفٌ سُنَّةٌ':Added, #1: 1	وَصْفِ السَّنَةِ
u'وَصْفٌ سُنَّةٌ':Added, #1: 1	وَصْفِ السُّنَّةِ
u'وَصْفٌ سُنِّيٌّ':Added, #2: 2	وَصْفَ السُّنَّةِ
u'وَصْفٌ سَهْمٌ':Added, #1: 1	وَصْفِ السُّنِّيَّةِ
u'وَصْفٌ سورٌ':Added, #1: 1	وَصْفُ سَهْمٍ
u'وَصْفٌ سُيوفٌ':Added, #1: 1	وَصْفُ السُّوَرِ
u'وَصَفَ شَاكِرٌ':Predicate, #1: 1	وَصْفِ سُيُوفٍ
u'وَصْفٌ شُحٌّ':Added, #1: 1	وَصَفَ الشَّاكِرِينَ
u'وَصْفٌ شَخْصٌ':Added, #1: 1	وَصْفَ الشُّحِّ
u'وَصَفَ شَرَابٌ':Predicate, #1: 1	وَصْفُ الشَّخْصِ
u'وَصْفٌ شَرَابٌ':Added, #1: 1	وَصَفَ شَرَابَ
u'وَصَفَ شهداء':Predicate, #1: 1	وَصْفَ شَرَابِ
u'وَصْفٌ شُهُودٌ':Added, #2: 2	وَصَفَ الشُّهَدَاءَ
u'وَصَفَ شَيْءٌ':Predicate, #1: 1	وَصْفِ الشّهُودِ
u'وَصْفٌ شَيْءٌ':Added, #1: 1	وَصَفَ الشَّيْءَ
u'وَصْفٌ شَيْءٌ':Added, #4: 4	وَصْفِ الشَّيْءِ
u'وَصْفٌ صَالِحٌ':Added, #6: 6	وَصْفَ الشَّيْءِ
u'وَصْفٌ صَالِح':Added, #2: 2	وَصْفٍ صَالِحٍ
u'وَصْفٌ صِحَّةٌ':Added, #2: 2	وَصْفٍ صَالِحٍ
u'وَصْفٌ صِحَّةٌ':Added, #1: 1	وَصْفَ الصِّحَّةِ
u'وَصْفٌ صغار':Added, #3: 3	وَصْفِ الصِّحَّةِ
u'وَصْفٌ صغار':Added, #1: 1	وَصْفُ الصِّغَارِ
u'وَصْفٌ صغار':Added, #1: 1	وَصْفِ الصِّغَارِ
u'وَصْفٌ صَغَارٌ':Added, #2: 2	وَصْفُ الصَّغَارِ
u'وَصَفَ صَلاَةٌ':Predicate, #2: 2	وَصْفُ الصَّغَارِ
u'وَصَفَ صَلاَةٌ':Predicate, #1: 1	وَصَفَ الصَّلَاةَ
u'وَصْفٌ صَلاَةٌ':Added, #7: 7	وَصَفَ صَلَاةَ
u'وَصْفٌ صَلاَةٌ':Added, #1: 1	وَصْفَ الصَّلَاةِ
u'وَصَفَ صَوْتٌ':Predicate, #2: 2	وَصْفِ الصَّلَاةِ
u'وَصْفٌ صَوْتٌ':Added, #1: 1	وَصَفَ الصَّوْتَ
u'وَصَفَ ضَرْبٌ':Predicate, #1: 1	وَصْفَ الصّوْتِ
u'وَصْفٌ ضَمَانٌ':Added, #2: 2	وَصَفَ الضَّرْبَ
u'وَصْفٌ طَاعَةٌ':Added, #1: 1	وَصْفِ الضَّمَانِ
u'وَصْفٌ طَرِيقٌ':Added, #1: 1	وَصْفَ الطَّاعَةِ
u'وَصْفٌ طعام':Added, #1: 1	وَصْفِ الطَّرِيقِ
u'وَصْفٌ طَعَامٌ':Added, #1: 1	وَصْفِ الطَّعَامِ
u'وَصْفٌ طَعْمٌ':Added, #1: 1	وَصْفِ الطَّعَامِ
u'وَصَفَ طَلاَقٌ':Predicate, #1: 1	وَصْفِ الطَّعْمِ
u'وَصْفٌ طَلاَقٌ':Added, #9: 9	وَصَفَ الطَّلَاقَ
u'وَصْفٌ طَلاَقٌ':Added, #1: 1	وَصْفَ الطَّلَاقِ
u'وَصْفٌ طَلاَقٌ':Added, #1: 1	وَصْفُ الطَّلَاقِ
u'وَصْفٌ طَهُور':Added, #2: 2	وَصْفِ الطَّلَاقِ
u'وَصْفٌ طَهُور':Added, #1: 1	وَصْفَ الطَّهُورِيَّةِ
u'وَصْفٌ طُولٌ':Added, #1: 1	وَصْفُ الطَّهُورِيَّةِ
u'وَصْفٌ ظاهِرٌ':Added, #1: 1	وَصْفِ الطُّولِ
u'وَصْفٌ عَارِضٌ':Added, #1: 1	وَصْفٍ ظَاهِرٍ
u'وَصْفٌ عَائِدٌ':Added, #1: 1	وَصْفٍ عَارِضٍ
u'وَصْفٌ عِبَادٌ':Added, #1: 1	وَصْفٍ عَائِدٍ
u'وَصْفٌ عِبَادَةٌ':Added, #1: 1	وَصْفُ الْعِبَادِ
u'وَصْفٌ عَبْدٌ':Added, #2: 2	وَصْفَ الْعِبَادَةِ
u'وَصْفٌ عَبْدٌ':Added, #1: 1	وَصْفَ الْعَبْدِ
u'وَصْفٌ عَبْدٌ':Added, #1: 1	وَصْفُ الْعَبْدِ
u'وَصْفٌ عُبُودِيَّةٌ':Added, #1: 1	وَصْفِ عَبْدِ
u'وَصَفَ عتق':Predicate, #1: 1	وَصْفَ الْعُبُودِيَّةِ
u'وَصَفَ عِتْقٌ':Predicate, #1: 1	وَصَفَ الْعِتْقَ
u'وَصْفٌ عَدَدٌ':Added, #1: 1	وَصَفَ الْعِتْقَ
u'وَصْفٌ عَدْلٌ':Added, #1: 1	وَصْفِ عَدَدِ
u'وَصْفٌ عَدَمٌ':Added, #1: 1	وَصْفِ الْعَدْلِ
u'وَصْفٌ عَرْضٌ':Added, #1: 1	وَصْفِ عَدَمِ
u'وَصَفَ عِرْقٌ':Predicate, #1: 1	وَصْفُ الْعَرْضِ
u'وَصْفٌ عِرْقٌ':Added, #1: 1	وَصَفَ الْعِرْقَ
u'وَصْفٌ عَقْدٌ':Added, #1: 1	وَصْفُ الْعِرْقِ
u'وَصْفٌ عَقْدٌ':Added, #1: 1	وَصْفَ الْعَقْدِ
u'وَصْفٌ عَقْدٌ':Added, #1: 1	وَصْفُ الْعَقْدِ
u'وَصْفٌ عَقْلٌ':Added, #2: 2	وَصْفِ الْعَقْدِ
u'وَصْفٌ عُقَلاَءُ':Added, #1: 1	وَصْفِ الْعَقْلِ
u'وَصْفٌ عِلَّةٌ':Added, #1: 1	وَصْفِ الْعُقَلَاءِ
u'وَصْفٌ عِلَّةٌ':Added, #1: 1	وَصْفُ الْعِلَّةِ
u'وَصْفٌ علم':Added, #3: 3	وَصْفِ الْعِلَّةِ
u'وَصْفٌ عِلْمٌ':Added, #1: 1	وَصْفُ الْعِلْمِ
u'وَصَفَ عُلْوٌ':Predicate, #1: 1	وَصْفُ الْعِلْمِ
u'وَصْفٌ عِلِّيٌّ':Added, #1: 1	وَصَفَ الْعُلْوَ
u'وَصْفٌ عَمْد':Added, #1: 1	وَصْفِ الْعِلِّيَّةِ
u'وَصْفٌ عَمْدِيّ':Added, #1: 1	وَصْفِ الْعَمْدِيَّةِ
u'وَصْفٌ عُمُومٌ':Added, #1: 1	وَصْفِ الْعَمْدِيَّةِ
u'وَصْفٌ عَوْرَةٌ':Added, #1: 1	وَصْفَ الْعُمُومِ
u'وَصْفٌ عِوَضٌ':Added, #1: 1	وَصْفِ الْعَوْرَةِ
u'وَصْفٌ عين':Added, #1: 1	وَصْفِ الْعِوَضِ
u'وَصْفٌ عَيْنٌ':Added, #1: 1	وَصْفِ الْعَيْنِ
u'وَصْفٌ عَيْن':Added, #1: 1	وَصْفِ الْعَيْنِ
u'وَصْفٌ غُرْبَةٌ':Added, #1: 1	وَصْفِ الْعَيْنِ
u'وَصْفٌ غير':Added, #3: 3	وَصْفِ الْغُرْبَةِ
u'وَصْفٌ غَيْرٌ':Added, #1: 1	وَصْفَ غَيْرِ
u'وَصْفٌ فَارِسٌ':Added, #1: 1	وَصْفَ غَيْرِ
u'وَصْفٌ فَارِقٌ':Added, #1: 1	وَصْفِ الْفَارِسَيْنِ
u'وَصْفٌ فِتَنٌ':Added, #1: 1	وَصْفٍ فَارِقٍ
u'وَصْفٌ فَرْض':Added, #1: 1	وَصْفِ الْفِتَنِ
u'وَصْفٌ فَرْض':Added, #2: 2	وَصْفَ الْفَرْضِيَّةِ
u'وَصْفٌ فَرْض':Added, #2: 2	وَصْفِ الْفَرْضِيَّةِ
u'وَصْفٌ فَرْضِيّ':Added, #5: 5	وَصْفُ الْفَرْضِيَّةِ
u'وَصْفٌ فَرْضِيّ':Added, #2: 2	وَصْفَ الْفَرْضِيَّةِ
u'وَصْفٌ فَرْضِيّ':Added, #2: 2	وَصْفِ الْفَرْضِيَّةِ
u'وَصْفٌ فَرْضِيَّة':Added, #5: 5	وَصْفُ الْفَرْضِيَّةِ
u'وَصْفٌ فَرْضِيَّة':Added, #2: 2	وَصْفَ الْفَرْضِيَّةِ
u'وَصْفٌ فَرْضِيَّة':Added, #2: 2	وَصْفِ الْفَرْضِيَّةِ
u'وَصْفٌ فساد':Added, #5: 5	وَصْفُ الْفَرْضِيَّةِ
u'وَصْفٌ فَسَادٌ':Added, #1: 1	وَصْفِ الْفَسَادِ
u'وَصْفٌ فِسْقٌ':Added, #1: 1	وَصْفِ الْفَسَادِ
u'وَصْفٌ فِسْقٌ':Added, #1: 1	وَصْفُ الْفِسْقِ
u'وَصْفٌ فِعْلٌ':Added, #1: 1	وَصْفِ فِسْقِهِ
u'وَصْفٌ فِعْلٌ':Added, #1: 1	وَصْفُ الْفِعْلِ
u'وَصْفٌ فِعْلٌ':Added, #1: 1	وَصْفِ فِعْلِ
u'وَصْفٌ فقر':Added, #3: 3	وَصْفِ الْفِعْلِ
u'وَصْفٌ فَقْرٌ':Added, #1: 1	وَصْفَ الْفَقْرِ
u'وَصْفٌ فَلاَةٌ':Added, #1: 1	وَصْفَ الْفَقْرِ
u'وَصْفٌ فلان':Added, #1: 1	وَصْفِ فَلَاةٍ
u'وَصْفٌ فلان':Added, #1: 1	وَصْفِ الرُّكْنِيَّةِ
u'وَصْفٌ فلان':Added, #1: 1	وَصْفِ الزّبَيْرِ
u'وَصْفٌ فلان':Added, #1: 1	وَصْفِ الْكَنْزِيَّةِ
u'وَصْفٌ فلان':Added, #1: 1	وَصْفِ الْوَاصِفِ
u'وَصَفَ قَالٌ':Predicate, #1: 1	وَصْفُ وَاصِفٍ
u'وَصْفٌ قَائِمٌ':Added, #1: 1	وَصَفَ قَالَ
u'وَصْفٌ قُبْحٌ':Added, #1: 1	وَصْفٍ قَائِمٍ
u'وَصَفَ قتل':Predicate, #1: 1	وَصْفُ الْقُبْحِ
u'وَصَفَ قَتْلٌ':Predicate, #1: 1	وَصَفَ الْقَتْلَ
u'وَصَفَ قُدُومٌ':Predicate, #1: 1	وَصَفَ الْقَتْلَ
u'وَصْفٌ قِرَاءةٌ':Added, #1: 1	وَصَفَ قُدُومَ
u'وَصْفٌ قُرْبَةٌ':Added, #1: 1	وَصْفَ الْقِرَاءَةِ
u'وَصْفٌ قصاص':Added, #3: 3	وَصْفِ الْقُرْبَةِ
u'وَصْفٌ قِصَاصٌ':Added, #2: 2	وَصْفَ الْقِصَاصِ
u'وَصْفٌ قِصَّةٌ':Added, #2: 2	وَصْفَ الْقِصَاصِ
u'وَصْفٌ قِصَّةٌ':Added, #1: 1	وَصْفِ الْقِصَّةِ
u'وَصْفٌ قَضَاءٌ':Added, #2: 2	وَصْفُ الْقِصَّةِ
u'وَصَفَ قَضِيَّةٌ':Predicate, #1: 1	وَصْفُ الْقَضَاءِ
u'وَصْفٌ قَوَاعِدُ':Added, #1: 1	وَصَفَ الْقَضِيَّةَ
u'وَصْفٌ قَوَاعِدُ':Added, #1: 1	وَصْفَ الْقَوَاعِدِ
u'وَصْفٌ قُوَّةٌ':Added, #1: 1	وَصْفِ الْقَوَاعِدِ
u'وَصْفٌ قُوَّة':Added, #1: 1	وَصْفِ الْقُوَّةِ
u'وَصْفٌ قُوتٌ':Added, #1: 1	وَصْفِ الْقُوَّةِ
u'وَصْفٌ قِيَاسٌ':Added, #1: 1	وَصْفِ الْقُوتِ
u'وَصْفٌ كبر':Added, #1: 1	وَصْفِ الْقِيَاسِ
u'وَصْفٌ كِبَرٌ':Added, #1: 1	وَصْفُ الْكِبَرِ
u'وَصْفٌ كِتَابٌ':Added, #1: 1	وَصْفُ الْكِبَرِ
u'وَصْفٌ كَتِيبَةٌ':Added, #1: 1	وَصْفِ كِتَابِهِ
u'وَصْفٌ كَفَالَةٌ':Added, #1: 1	وَصْفِ كَتِيبَةٍ
u'وَصَفَ كفر':Predicate, #1: 1	وَصْفِ الْكَفَالَةِ
u'وَصَفَ كُفْرٌ':Predicate, #4: 4	وَصَفَ الْكُفْرَ
u'وَصْفٌ كَلاَمٌ':Added, #4: 4	وَصَفَ الْكُفْرَ
u'وَصْفٌ كَلاَمٌ':Added, #1: 1	وَصْفُ الْكَلَامِ
u'وَصْفٌ كَمَالٌ':Added, #1: 1	وَصْفِ كَلَامِ
u'وَصْفٌ كَمَالٌ':Added, #1: 1	وَصْفَ الْكَمَالِ
u'وَصْفٌ كَمَالٌ':Added, #1: 1	وَصْفِ الْكَمَالِ
u'وَصْفٌ كَنْز':Added, #1: 1	وَصْفُ كَمَالٍ
u'وَصْفٌ كَوْنٌ':Added, #1: 1	وَصْفِ الْكَنْزِيَّةِ
u'وَصْفٌ كَوْنٌ':Added, #1: 1	وَصْفَ كَوْنِ
u'وَصْفٌ كَوْنٌ':Added, #1: 1	وَصْفَ كَوْنِهِ
u'وَصْفٌ كَوْنٌ':Added, #2: 2	وَصْفُ كَوْنِهِ
u'وَصْفٌ كَيْلٌ':Added, #2: 2	وَصْفِ كَوْنِهِ
u'وَصْفٌ كَيْلٌ':Added, #1: 1	وَصْفَ الْكَيْلِ
u'وَصْفٌ لاَحِقٌ':Added, #1: 1	وَصْفُ الْكَيْلِ
u'وَصْفٌ لاَزِمٌ':Added, #1: 1	وَصْفُ اللَّاحِقِ
u'وَصْفٌ لُزُومٌ':Added, #1: 1	وَصْفٍ لَازِمٍ
u'وَصْفٌ لَغْوٌ':Added, #1: 1	وَصْفُ اللُّزُومِ
u'وَصْفٌ لقطات':Added, #1: 1	وَصْفُ لَغْوٍ
u'وَصَفَ لِينٌ':Predicate, #1: 1	وَصْفِ اللُّقُطَاتِ
u'وَصْفٌ مَاءٌ':Added, #1: 1	وَصَفَ اللِّينَ
u'وَصْفٌ مَاءٌ':Added, #1: 1	وَصْفَ الْمَاءِ
u'وَصَفَ مَالِكٌ':Subject, #3: 3	وَصْفُ الْمَاءِ
u'وَصْفٌ مُبَالَغَةٌ':Added, #1: 1	وَصَفَ مَالِكٌ
u'وَصَفَ مُبْطِلٌ':Subject, #1: 1	وَصْفُ مُبَالَغَةٍ
u'وَصْفٌ مَبِيعٌ':Added, #1: 1	وَصَفَ مُبْطِلٌ
u'وَصْفٌ مُتَّصِلٌ':Added, #4: 4	وَصْفِ الْمَبِيعِ
u'وَصْفٌ مُتَعَلِّقٌ':Added, #1: 1	وَصْفٍ مُتَّصِلٍ
u'وَصْفٌ مُتَكَلِّمٌ':Added, #1: 1	وَصْفِ مُتَعَلِّقِ
u'وَصْفٌ مُحْدَثٌ':Added, #1: 1	وَصْفَ الْمُتَكَلِّمِ
u'وَصْفٌ مَحْدُودٌ':Added, #1: 1	وَصْفٍ مُحْدَثٍ
u'وَصْفٌ مَحَلٌّ':Added, #1: 1	وَصْفِ الْمَحْدُودِ
u'وَصْفٌ مُحَمَّدٌ':Added, #3: 3	وَصْفِ الْمَحَلِّ
u'وَصْفٌ مُخْتَصّ':Added, #1: 1	وَصْفِ مُحَمَّدِ
u'وَصْفٌ مُذَكَّرٌ':Added, #1: 1	وَصْفٍ مُخْتَصٍّ
u'وَصْفٌ مَذْمُومٌ':Added, #1: 1	وَصْفُ الْمُذَكَّرِ
u'وَصْفٌ مَرَارَةٌ':Added, #1: 1	وَصْفٍ مَذْمُومٍ
u'وَصْفٌ مُرَاهِقٌ':Added, #1: 1	وَصْفِ الْمَرَارَةِ
u'وَصْفٌ مَرْغُوبٌ':Added, #1: 1	وَصْفِ الْمُرَاهِقَةِ
u'وَصْفٌ مَرِيضٌ':Added, #3: 3	وَصْفٍ مَرْغُوبٍ
u'وَصْفٌ مُشْتَرَكٌ':Added, #1: 1	وَصْفُ الْمَرِيضِ
u'وَصْفٌ مُشْتَمِلٌ':Added, #1: 1	وَصْفٍ مُشْتَرَكٍ
u'وَصْفٌ مَشْرُوعٌ':Added, #1: 1	وَصْفٍ مُشْتَمِلٍ
u'وَصَفَ مُصَنِّفٌ':Subject, #12: 12	وَصْفٍ مَشْرُوعٍ
u'وَصْفٌ مَطْلُوبٌ':Added, #2: 2	وَصَفَ الْمُصَنِّفُ
u'وَصْفٌ مُعَارَضَةٌ':Added, #1: 1	وَصْفٍ مَطْلُوبٍ
u'وَصْفٌ مُعَارَضَةٌ':Added, #1: 1	وَصْفَ الْمُعَارَضَةِ
u'وَصْفٌ مُعْتَرِضٌ':Added, #3: 3	وَصْفِ الْمُعَارَضَةِ
u'وَصْفٌ مُعْتَرِضٌ':Added, #1: 1	وَصْفَ الْمُعْتَرِضِ
u'وَصْفٌ مُعْتَرِضٌ':Added, #1: 1	وَصْفُ الْمُعْتَرِضِ
u'وَصْفٌ مَعْصِيَةٌ':Added, #3: 3	وَصْفِ الْمُعْتَرِضِ
u'وَصْفٌ مُعَلَّلٌ':Added, #1: 1	وَصْفَ الْمَعْصِيَةِ
u'وَصْفٌ مَغْصُوب':Added, #1: 1	وَصْفَ الْمُعَلَّلِ
u'وَصْفٌ مَفْعُولٌ':Added, #1: 1	وَصْفِ الْمَغْصُوبِ
u'وَصْفٌ مَفْعُولٌ':Added, #1: 1	وَصْفُ الْمَفْعُولِ
u'وَصْفٌ مُقَابِلٌ':Added, #1: 1	وَصْفِ الْمَفْعُولِ
u'وَصْفٌ مَقْتُولٌ':Added, #1: 1	وَصْفَ مُقَابِلِهِ
u'وَصْفٌ مَقْصُودٌ':Added, #1: 1	وَصْفِ الْمَقْتُولِ
u'وَصْفٌ مُلاَزِمٌ':Added, #1: 1	وَصْفٍ مَقْصُودٍ
u'وَصَفَ مُمَيِّزٌ':Subject, #3: 3	وَصْفٍ مُلَازِمٍ
u'وَصْفٌ مُنَاسِبٌ':Added, #1: 1	وَصَفَ الْمُمَيِّزُ
u'وَصْفٌ مُنَاسِبٌ':Added, #1: 1	وَصْفِ الْمُنَاسِبِ
u'وَصْفٌ مَنْسُوخٌ':Added, #2: 2	وَصْفٍ مُنَاسِبٍ
u'وَصْفٌ مَنْصُوصٌ':Added, #1: 1	وَصْفُ الْمَنْسُوخِ
u'وَصْفٌ مَوْتٌ':Added, #1: 1	وَصْفٍ مَنْصُوصٍ
u'وَصْفٌ مَوْجُودٌ':Added, #1: 1	وَصْفِ الْمَوْتِ
u'وَصْفٌ مَوْضِعٌ':Added, #1: 1	وَصْفٍ مَوْجُودٍ
u'وَصْفٌ مَوْضِعٌ':Added, #1: 1	وَصْفِ مَوْضِعٍ
u'وَصْفٌ مَوْضُوعٌ':Added, #4: 4	وَصْفُ مَوْضِعٍ
u'وَصْفٌ مَوْضُوعٌ':Added, #1: 1	وَصْفُ الْمَوْضُوعِ
u'وَصْفٌ مُؤْمِنٌ':Added, #1: 1	وَصْفِ الْمَوْضُوعِ
u'وَصْفٌ مُؤَنَّثٌ':Added, #1: 1	وَصْفِ الْمُؤْمِنِ
u'وَصْفٌ نَاسِخٌ':Added, #1: 1	وَصْفِ الْمُؤَنَّثِ
u'وَصْفٌ نَاسِخ':Added, #1: 1	وَصْفُ النَّاسِخِ
u'وَصْفٌ نَاقَةٌ':Added, #1: 1	وَصْفُ النَّاسِخِ
u'وَصْفٌ نَاقَة':Added, #1: 1	وَصْفِ النّاقَةِ
u'وَصَفَ نَبِيٌّ':Predicate, #1: 1	وَصْفِ النّاقَةِ
u'وَصَفَ نَبِيٌّ':Subject, #1: 1	وَصَفَ النَّبِيَّ
u'وَصْفٌ نَبِيٌّ':Added, #3: 3	وَصَفَ النَّبِيُّ
u'وَصْفٌ نَجَاسَةٌ':Added, #1: 1	وَصْفِ النَّبِيِّ
u'وَصْفٌ نَجَاسَةٌ':Added, #2: 2	وَصْفَ النَّجَاسَةِ
u'وَصْفٌ نِساءٌ':Added, #2: 2	وَصْفِ النَّجَاسَةِ
u'وَصْفٌ نصاب':Added, #1: 1	وَصْفِ النِّسَاءِ
u'وَصْفٌ نِصَابٌ':Added, #1: 1	وَصْفِ النِّصَابِ
u'وَصْفٌ نَفْسٌ':Added, #1: 1	وَصْفِ النِّصَابِ
u'وَصْفٌ نَفْسٌ':Added, #1: 1	وَصْفِ نَفْسِ
u'وَصْفٌ نَقْدٌ':Added, #2: 2	وَصْفِ نَفْسِهِ
u'وَصْفٌ نَقْد':Added, #1: 1	وَصْفَ النَّقْدِ
u'وَصْفٌ نَقْصٌ':Added, #1: 1	وَصْفَ النَّقْدِ
u'وَصْفٌ نَمَاءٌ':Added, #2: 2	وَصْفِ نَقْصٍ
u'وَصْفٌ نَمَاءٌ':Added, #1: 1	وَصْفَ النَّمَاءِ
u'وَصْفٌ نِيَّةٌ':Added, #2: 2	وَصْفُ النَّمَاءِ
u'وَصَفَ واحد':Predicate, #3: 3	وَصْفِ النِّيَّةِ
u'وَصَفَ وَاحِدٌ':Predicate, #2: 2	وَصَفَ الْوَاحِدَةَ
u'وَصْفٌ واحد':Added, #2: 2	وَصَفَ الْوَاحِدَةَ
u'وَصْفٌ وَاحِدٌ':Added, #4: 4	وَصْفٍ وَاحِدٍ
u'وَصْفٌ واصِف':Added, #4: 4	وَصْفٍ وَاحِدٍ
u'وَصْفٌ واصِف':Added, #1: 1	وَصْفِ الْوَاصِفِ
u'وَصْفٌ وُجُوبٌ':Added, #1: 1	وَصْفُ وَاصِفٍ
u'وَصْفٌ وُجُودِيٌّ':Added, #1: 1	وَصْفُ الْوُجُوبِ
u'وَصْفٌ وَسَطٌ':Added, #1: 1	وَصْفٍ وُجُودِيٍّ
u'وَصَفَ وُضُوءٌ':Predicate, #1: 1	وَصْفٍ وَسَطٍ
u'وَصْفٌ وُضُوءٌ':Added, #4: 4	وَصَفَ وُضُوءَ
u'وَصْفٌ وُضُوءٌ':Added, #1: 1	وَصْفُ الْوُضُوءِ
u'وَصْفٌ وَطْءٌ':Added, #1: 1	وَصْفِ وُضُوءِ
u'وَصْفٌ وِفَاقٌ':Added, #1: 1	وَصْفِ الْوَطْءِ
u'وَصَفَ ولد':Predicate, #1: 1	وَصْفِ الْوِفَاقِ
u'وَصَفَ وَلَدٌ':Predicate, #1: 1	وَصَفَ الْوَلَدَ
u'وَصَفَ يَوْمٌ':Predicate, #1: 1	وَصَفَ الْوَلَدَ
u'وَصَلَ أحَدٌ':Subject, #1: 1	وَصَفَ الْيَوْمَ
u'وصل أحَدٌ':Added, #2: 2	وَصَلَ أَحَدُ
u'وَصْلٌ أحَدٌ':Added, #2: 2	وَصْلِ أَحَدِ
u'وصل أَخٌ':Added, #2: 2	وَصْلِ أَحَدِ
u'وَصْلٌ أَخٌ':Added, #1: 1	وَصْلُ أَخٍ
u'وصل أَذَانٌ':Added, #1: 1	وَصْلُ أَخٍ
u'وَصْلٌ أَذَانٌ':Added, #1: 1	وَصْلَ الْأَذَانِ
u'وَصَلَ أَسَابِيعُ':Predicate, #1: 1	وَصْلَ الْأَذَانِ
u'وصل أَسَابِيعُ':Added, #1: 1	وَصَلَ الْأَسَابِيعَ
u'وَصْلٌ أَسَابِيعُ':Added, #1: 1	وَصْلِ الْأَسَابِيعِ
u'وصل أَسَابِيعُ':Added, #1: 1	وَصْلِ الْأَسَابِيعِ
u'وَصْلٌ أَسَابِيعُ':Added, #2: 2	وَصْلُ الْأَسَابِيعِ
u'وصل إِسْنادٌ':Added, #2: 2	وَصْلُ الْأَسَابِيعِ
u'وَصْلٌ إِسْنادٌ':Added, #1: 1	وَصْلُ إِسْنَادِهِ
u'وصل إقامَةٌ':Added, #1: 1	وَصْلُ إِسْنَادِهِ
u'وَصْلٌ إقامَةٌ':Added, #1: 1	وَصْلُ الْإِقَامَةِ
u'وصل الْمَرْأَةُ':Added, #1: 1	وَصْلُ الْإِقَامَةِ
u'وَصْلٌ الْمَرْأَةُ':Added, #1: 1	وَصْلِ الْمَرْأَةِ
u'وَصَلَ إِنْسانٌ':Subject, #1: 1	وَصْلِ الْمَرْأَةِ
u'وَصَلَ أهْلٌ':Subject, #1: 1	وَصَلَ الْإِنْسَانُ
u'وَصَلَ بَلَدٌ':Predicate, #1: 1	وَصَلَ أَهْلُهُ
u'وَصَلَ بَوْلٌ':Subject, #1: 1	وَصَلَ الْبَلَدَ
u'وَصَلَ بَيَانٌ':Predicate, #2: 2	وَصَلَ الْبَوْلُ
u'وصل بَيَانٌ':Added, #1: 1	وَصَلَ بَيَانَ
u'وَصْلٌ بَيَانٌ':Added, #1: 1	وَصْلِ الْبَيَانِ
u'وصل بَيَانٌ':Added, #1: 1	وَصْلِ الْبَيَانِ
u'وَصْلٌ بَيَانٌ':Added, #1: 1	وَصْلَ بَيَانِ
u'وَصَلَ بَيْتٌ':Predicate, #1: 1	وَصْلَ بَيَانِ
u'وَصَلَ تَفْسِيرٌ':Predicate, #2: 2	وَصَلَ الْبَيْتَ
u'وَصَلَ ثَمَنٌ':Subject, #1: 1	وَصَلَ التَّفْسِيرَ
u'وَصَلَ ثَوْبٌ':Subject, #2: 2	وَصَلَ الثَّمَنُ
u'وَصَلَ جالِب':Subject, #1: 1	وَصَلَ الثَّوْبُ
u'وَصَلَ جناح':Predicate, #1: 1	وَصَلَ الْجَالِبُ
u'وَصَلَ جَنَاحٌ':Predicate, #1: 1	وَصَلَ جَنَاحَ
u'وَصَلَ حاجٌّ':Subject, #1: 1	وَصَلَ جَنَاحَ
u'وَصَلَ حالٌ':Subject, #1: 1	وَصَلَ الْحَاجُّ
u'وَصَلَ حالٌ':Subject, #1: 1	وَصَلَ حَالُهُ
u'وَصَلَ حَديثٌ':Predicate, #2: 2	وَصَلَ الْحَالُ
u'وصل حَديثٌ':Added, #2: 2	وَصَلَ الْحَدِيثَ
u'وَصْلٌ حَديثٌ':Added, #1: 1	وَصْلُ الْحَدِيثِ
u'وصل حَديثٌ':Added, #1: 1	وَصْلُ الْحَدِيثِ
u'وَصْلٌ حَديثٌ':Added, #5: 5	وَصْلِ الْحَدِيثِ
u'وصل حَرْفٌ':Added, #5: 5	وَصْلِ الْحَدِيثِ
u'وَصْلٌ حَرْفٌ':Added, #1: 1	وَصْلُ حَرْفٍ
u'وَصَلَ حَرَمٌ':Predicate, #1: 1	وَصْلُ حَرْفٍ
u'وصل حُروفٌ':Added, #2: 2	وَصَلَ الْحَرَمَ
u'وَصْلٌ حُروفٌ':Added, #1: 1	وَصْلُ الْحُرُوفِ
u'وَصَلَ حَقٌّ':Subject, #1: 1	وَصْلُ الْحُرُوفِ
u'وَصَلَ خَبَرٌ':Subject, #1: 1	وَصَلَ الْحَقُّ
u'وَصَلَ خَبَر':Subject, #1: 1	وَصَلَ الْخَبَرُ
u'وَصَلَ خَيْرٌ':Predicate, #1: 1	وَصَلَ الْخَبَرُ
u'وَصَلَ دُخَانٌ':Subject, #1: 1	وَصَلَ خَيْرَ
u'وَصَلَ دَمٌ':Subject, #1: 1	وَصَلَ دُخَانُ
u'وَصَلَ ذكر':Predicate, #1: 1	وَصَلَ الدَّمُ
u'وصل رَبُّ':Added, #1: 1	وَصَلَ ذُكِرَ
u'وَصْلٌ رَبُّ':Added, #1: 1	وَصْلِ رَبِّهِ
u'وصل زَوْجَةٌ':Added, #1: 1	وَصْلِ رَبِّهِ
u'وَصْلٌ زَوْجَةٌ':Added, #1: 1	وَصْلِ الزَّوْجَةِ
u'وصل سِتٌّ':Added, #1: 1	وَصْلِ الزَّوْجَةِ
u'وَصْلٌ سِتٌّ':Added, #1: 1	وَصْلَ سِتَّةِ
u'وَصَلَ سِلاَحٌ':Subject, #1: 1	وَصْلَ سِتَّةِ
u'وصل سُنَّةٌ':Added, #2: 2	وَصَلَ سِلَاحُ
u'وَصْلٌ سُنَّةٌ':Added, #1: 1	وَصْلُ السُّنَّةِ
u'وَصَلَ سَيِّدٌ':Predicate, #1: 1	وَصْلُ السُّنَّةِ
u'وَصَلَ شَرْطٌ':Predicate, #1: 1	وَصَلَ سَيِّدَ
u'وصل شَعْرٌ':Added, #1: 1	وَصَلَ الشَّرْطَ
u'وَصْلٌ شَعْرٌ':Added, #3: 3	وَصْلُ شَعْرٍ
u'وصل شَعْرٌ':Added, #3: 3	وَصْلُ شَعْرٍ
u'وصل شَعْرٌ':Added, #5: 5	وَصْلُ الشَّعْرِ
u'وَصْلٌ شَعْرٌ':Added, #5: 5	وَصْلِ الشَّعْرِ
u'وَصْلٌ شَعْرٌ':Added, #5: 5	وَصْلُ الشَّعْرِ
u'وَصَلَ شَيْءٌ':Subject, #5: 5	وَصْلِ الشَّعْرِ
u'وصل شَيْءٌ':Added, #1: 1	وَصَلَ شَيْءٌ
u'وَصْلٌ شَيْءٌ':Added, #1: 1	وَصْلُ الشَّيْءِ
u'وَصَلَ صَفٌّ':Predicate, #1: 1	وَصْلُ الشَّيْءِ
u'وصل صَفٌّ':Added, #1: 1	وَصَلَ الصَّفَّ
u'وَصْلٌ صَفٌّ':Added, #1: 1	وَصْلِ الصَّفِّ
u'وصل صَلاَةٌ':Added, #1: 1	وَصْلِ الصَّفِّ
u'وَصْلٌ صَلاَةٌ':Added, #1: 1	وَصْلُ الصَّلَاةِ
u'وَصَلَ عادِم':Subject, #1: 1	وَصْلُ الصَّلَاةِ
u'وصل عِبَادَةٌ':Added, #1: 1	وَصَلَ عَادِمُ
u'وَصْلٌ عِبَادَةٌ':Added, #1: 1	وَصْلَ الْعِبَادَةِ
u'وَصَلَ عَبْدٌ':Subject, #1: 1	وَصْلَ الْعِبَادَةِ
u'وَصَلَ علم':Subject, #3: 3	وَصَلَ الْعَبْدُ
u'وَصَلَ عِلْمٌ':Subject, #1: 1	وَصَلَ الْعِلْمُ
u'وَصَلَ عُمْرَانٌ':Subject, #1: 1	وَصَلَ الْعِلْمُ
u'وَصَلَ عين':Subject, #1: 1	وَصَلَ عُمْرَانُ
u'وَصَلَ عَيْنٌ':Subject, #1: 1	وَصَلَ الْعَيْنُ
u'وَصَلَ عَيْن':Subject, #1: 1	وَصَلَ الْعَيْنُ
u'وَصَلَ عين':Subject, #1: 1	وَصَلَ الْعَيْنُ
u'وَصَلَ عَيْنٌ':Subject, #1: 1	وَصَلَ عَيْنُ
u'وَصَلَ عَيْن':Subject, #1: 1	وَصَلَ عَيْنُ
u'وَصَلَ غبار':Subject, #1: 1	وَصَلَ عَيْنُ
u'وَصَلَ غُبَارٌ':Subject, #1: 1	وَصَلَ الْغُبَارُ
u'وَصَلَ غَسْلٌ':Subject, #1: 1	وَصَلَ الْغُبَارُ
u'وصل غَسْلٌ':Added, #1: 1	وَصَلَ الْغَسْلُ
u'وَصْلٌ غَسْلٌ':Added, #1: 1	وَصْلُ غَسْلِ
u'وَصَلَ فَقِيرٌ':Subject, #1: 1	وَصْلُ غَسْلِ
u'وَصَلَ قِرَاءةٌ':Predicate, #1: 1	وَصَلَ الْفَقِيرُ
u'وَصَلَ قول':Subject, #1: 1	وَصَلَ الْقِرَاءَةَ
u'وَصَلَ قَوْلٌ':Subject, #2: 2	وَصَلَ قَوْلُهُ
u'وصل قَوْمٌ':Added, #2: 2	وَصَلَ قَوْلُهُ
u'وَصْلٌ قَوْمٌ':Added, #1: 1	وَصْلَ قَوْمِهِ
u'وَصَلَ كِتَابٌ':Subject, #1: 1	وَصْلَ قَوْمِهِ
u'وَصَلَ كَعْبٌ':Predicate, #19: 19	وَصَلَ الْكِتَابُ
u'وَصَلَ كَلاَمٌ':Predicate, #1: 1	وَصَلَ الْكَعْبَ
u'وَصَلَ كَلاَمٌ':Predicate, #1: 1	وَصَلَ الْكَلاَمَ
u'وَصَلَ لُبٌّ':Subject, #4: 4	وَصَلَ الْكَلَامَ
u'وَصَلَ لبن':Subject, #2: 2	وَصَلَ اللُّبُّ
u'وَصَلَ لَبَنٌ':Subject, #1: 1	وَصَلَ اللَّبَنُ
u'وَصَلَ لبن':Subject, #1: 1	وَصَلَ اللَّبَنُ
u'وَصَلَ لَبَنٌ':Subject, #1: 1	وَصَلَ لَبَنُ
u'وَصَلَ لعاب':Subject, #1: 1	وَصَلَ لَبَنُ
u'وَصَلَ لُعَابٌ':Subject, #1: 1	وَصَلَ لُعَابُ
u'وَصَلَ لعاب':Subject, #1: 1	وَصَلَ لُعَابُ
u'وَصَلَ لُعَابٌ':Subject, #1: 1	وَصَلَ لُعَابُهُ
u'وَصَلَ لَفْظٌ':Predicate, #1: 1	وَصَلَ لُعَابُهُ
u'وَصَلَ لَفْظٌ':Predicate, #2: 2	وَصَلَ اللَّفْظَ
u'وَصَلَ مَاءٌ':Subject, #4: 4	وَصَلَ لَفْظَ
u'وَصَلَ مَالٌ':Subject, #9: 9	وَصَلَ الْمَاءُ
u'وَصَلَ مَالٌ':Subject, #1: 1	وَصَلَ مَالُهُ
u'وَصَلَ مَالٌ':Subject, #2: 2	وَصَلَ الْمَالُ
u'وَصَلَ مُبْتاع':Subject, #2: 2	وَصَلَ مَالُ
u'وَصَلَ مَبِيعٌ':Subject, #1: 1	وَصَلَ الْمُبْتَاعُ
u'وَصَلَ مُتَغَيِّرٌ':Predicate, #2: 2	وَصَلَ الْمَبِيعُ
u'وَصَلَ مَثَانَةٌ':Predicate, #1: 1	وَصَلَ مُتَغَيِّرَ
u'وَصَلَ مَحَلٌّ':Predicate, #1: 1	وَصَلَ الْمَثَانَةَ
u'وَصَلَ مَدِينٌ':Predicate, #1: 1	وَصَلَ الْمَحَلَّ
u'وَصَلَ مَدِينَةٌ':Predicate, #1: 1	وَصَلَ الْمَدِينَةَ
u'وَصَلَ مَذْبَحٌ':Predicate, #1: 1	وَصَلَ الْمَدِينَةَ
u'وَصَلَ مَسَافَةٌ':Predicate, #1: 1	وَصَلَ الْمَذْبَحَ
u'وَصَلَ مُسَافِرٌ':Subject, #1: 1	وَصَلَ مَسَافَةَ
u'وَصَلَ مُسَافِرٌ':Subject, #2: 2	وَصَلَ الْمُسَافِرُ
u'وَصَلَ مَغْصُوب':Subject, #2: 2	وَصَلَ مُسَافِرٌ
u'وَصَلَ مَقْصِدٌ':Predicate, #1: 1	وَصَلَ الْمَغْصُوبُ
u'وَصَلَ مِنْبَرٌ':Predicate, #1: 1	وَصَلَ الْمَقْصِدَ
u'وَصَلَ مَوْضِعٌ':Predicate, #1: 1	وَصَلَ الْمِنْبَرَ
u'وَصَلَ نَاسٌ':Subject, #3: 3	وَصَلَ مَوْضِعَ
u'وَصَلَ نَاظِرٌ':Subject, #1: 1	وَصَلَ النَّاسُ
u'وَصَلَ نَمِرٌ':Predicate, #1: 1	وَصَلَ النَّاظِرُ
u'وصل هجر':Added, #1: 1	وَصَلَ نَمِرَةَ
u'وَصْلٌ هجر':Added, #1: 1	وَصْلُ الْهَجْرِ
u'وصل هَجْرٌ':Added, #1: 1	وَصْلُ الْهَجْرِ
u'وَصْلٌ هَجْرٌ':Added, #1: 1	وَصْلُ الْهَجْرِ
u'وَصَلَ همزة':Predicate, #1: 1	وَصْلُ الْهَجْرِ
u'وَصَلَ هَمْزَةٌ':Predicate, #1: 1	وَصَلَ هَمْزَةَ
u'وصل همزة':Added, #1: 1	وَصَلَ هَمْزَةَ
u'وَصْلٌ همزة':Added, #1: 1	وَصْلِ هَمْزَةِ
u'وصل هَمْزَةٌ':Added, #1: 1	وَصْلِ هَمْزَةِ
u'وَصْلٌ هَمْزَةٌ':Added, #1: 1	وَصْلِ هَمْزَةِ
u'وَصَلَ وَقْتٌ':Predicate, #1: 1	وَصْلِ هَمْزَةِ
u'وصل يَوْمٌ':Added, #1: 1	وَصَلَ وَقْتَ
u'وَصْلٌ يَوْمٌ':Added, #1: 1	وَصْلُ يَوْمٍ
u'وَصْمَةٌ تَلْفيقٌ':Added, #1: 1	وَصْلُ يَوْمٍ
u'وَصْمَةٌ حَيْرَةٌ':Added, #1: 1	وَصْمَةُ التَّلْفِيقِ
u'وَصْمَةٌ شَعْرٌ':Added, #1: 1	وَصْمَةِ الْحَيْرَةِ
u'وَصْمَةٌ شِعْرٌ':Added, #1: 1	وَصْمَةُ الشَّعْرِ
u'وَصْمَةٌ عوج':Added, #1: 1	وَصْمَةُ الشِّعْرِ
u'وَصْمَةٌ عِوَجٌ':Added, #1: 1	وَصْمَةِ الْعِوَجِ
u'وَصْمَةٌ مُحَابَاةٌ':Added, #1: 1	وَصْمَةِ الْعِوَجِ
u'وَصْمَةٌ مُخَالَفَةٌ':Added, #1: 1	وَصْمَةِ مُحَابَاةِ
u'وَصْمَةٌ مَسَاوِئُ':Added, #1: 1	وَصْمَةُ الْمُخَالَفَةِ
u'وُصُولٌ آثَارٌ':Added, #1: 1	وَصْمَةِ مَسَاوِئِهِ
u'وُصُولٌ أثَرٌ':Added, #1: 1	وُصُولِ آثَارِهِ
u'وُصُولٌ أثَرٌ':Added, #1: 1	وُصُولِ أَثَرِ
u'وُصُولٌ أثَرٌ':Added, #1: 1	وُصُولِ أَثَرِهِ
u'وُصُولٌ ألَمٌ':Added, #2: 2	وُصُولِ الْأَثَرِ
u'وُصُولٌ إمَامٌ':Added, #5: 5	وُصُولَ الْأَلَمِ
u'وُصُولٌ بَائِعٌ':Added, #2: 2	وُصُولِ الْإِمَامِ
u'وُصُولٌ بَدَلٌ':Added, #1: 1	وُصُولَ الْبَائِعِ
u'وُصُولٌ بِرٌّ':Added, #3: 3	وُصُولِ الْبَدَلِ
u'وُصُولٌ بِرٌّ':Added, #1: 1	وُصُولَ بِرٍّ
u'وُصُولٌ تُرَابٌ':Added, #1: 1	وُصُولِ بِرِّهِ
u'وُصُولٌ تَرِكَةٌ':Added, #1: 1	وُصُولَ التُّرَابِ
u'وُصُولٌ تَرِكَةٌ':Added, #2: 2	وُصُولَ التَّرِكَةِ
u'وُصُولٌ ثَمَرَةٌ':Added, #4: 4	وُصُولُ التَّرِكَةِ
u'وُصُولٌ ثَمَنٌ':Added, #1: 1	وُصُولِ الثَّمَرَةِ
u'وُصُولٌ ثَمَنٌ':Added, #1: 1	وُصُولَ الثَّمَنِ
u'وُصُولٌ ثَمَنٌ':Added, #2: 2	وُصُولُ الثَّمَنِ
u'وُصُولٌ ثَوْبٌ':Added, #2: 2	وُصُولِ الثَّمَنِ
u'وُصُولٌ جَبْهَةٌ':Added, #1: 1	وُصُولَ الثَّوْبِ
u'وُصُولٌ حَرارَةٌ':Added, #1: 1	وُصُولِ الْجَبْهَةِ
u'وُصُولٌ حَرارَةٌ':Added, #1: 1	وُصُولَ حَرَارَةِ
u'وُصُولٌ حَقٌّ':Added, #3: 3	وُصُولَ الْحَرَارَةِ
u'وُصُولٌ حَقٌّ':Added, #1: 1	وُصُولِ الْحَقِّ
u'وُصُولٌ حَقٌّ':Added, #1: 1	وُصُولِ حَقِّ
u'وُصُولٌ حَقٌّ':Added, #1: 1	وُصُولُ حَقِّهِ
u'وُصُولٌ خَبَرٌ':Added, #1: 1	وُصُولِ حَقِّهِ
u'وُصُولٌ خَبَر':Added, #1: 1	وُصُولُ الْخَبَرِ
u'وُصُولٌ خَبَرٌ':Added, #1: 1	وُصُولُ الْخَبَرِ
u'وُصُولٌ خَبَر':Added, #3: 3	وُصُولِ الْخَبَرِ
u'وُصُولٌ خَلَفٌ':Added, #3: 3	وُصُولِ الْخَبَرِ
u'وُصُولٌ خَيْرٌ':Added, #2: 2	وُصُولَ الْخَلَفِ
u'وُصُولٌ دُخَانٌ':Added, #1: 1	وُصُولَ الْخَيْرِ
u'وُصُولٌ دَيْنٌ':Added, #3: 3	وُصُولُ الدُّخَانِ
u'وُصُولٌ رَأْسٌ':Added, #1: 1	وُصُولِ الدَّيْنِ
u'وُصُولٌ رَطْبٌ':Added, #2: 2	وُصُولِ رَأْسِ
u'وُصُولٌ رِياضَةٌ':Added, #1: 1	وُصُولُ الرَّطْبِ
u'وُصُولٌ سَفِينَةٌ':Added, #1: 1	وُصُولُ الرِّيَاضَةِ
u'وُصُولٌ سَفِينَةٌ':Added, #1: 1	وُصُولِ السَّفِينَةِ
u'وُصُولٌ سِكِّينٌ':Added, #1: 1	وُصُولُ سَفِينَتِهِ
u'وُصُولٌ سَهْمٌ':Added, #1: 1	وُصُولِ السِّكِّينِ
u'وُصُولٌ شمس':Added, #2: 2	وُصُولِ السَّهْمِ
u'وُصُولٌ شَمْسٌ':Added, #1: 1	وُصُولِ الشَّمْسِ
u'وُصُولٌ شَيْءٌ':Added, #1: 1	وُصُولِ الشَّمْسِ
u'وُصُولٌ شَيْءٌ':Added, #1: 1	وُصُولَ شَيْءٍ
u'وُصُولٌ شَيْءٌ':Added, #1: 1	وُصُولِ شَيْءٍ
u'وُصُولٌ ضَوْءٌ':Added, #3: 3	وُصُولُ شَيْءٍ
u'وُصُولٌ طرف':Added, #1: 1	وُصُولِ الضَّوْءِ
u'وُصُولٌ طَرَفٌ':Added, #1: 1	وُصُولُ طَرَفِ
u'وُصُولٌ طعام':Added, #1: 1	وُصُولُ طَرَفِ
u'وُصُولٌ طَعَامٌ':Added, #1: 1	وُصُولَ الطَّعَامِ
u'وُصُولٌ طعنة':Added, #1: 1	وُصُولَ الطَّعَامِ
u'وُصُولٌ طَعْنَةٌ':Added, #1: 1	وُصُولُ الطَّعْنَةِ
u'وُصُولٌ علم':Added, #1: 1	وُصُولُ الطَّعْنَةِ
u'وُصُولٌ عِلْمٌ':Added, #1: 1	وُصُولُ الْعِلْمِ
u'وُصُولٌ عين':Added, #1: 1	وُصُولُ الْعِلْمِ
u'وُصُولٌ عَيْنٌ':Added, #1: 1	وُصُولِ الْعَيْنِ
u'وُصُولٌ عَيْن':Added, #1: 1	وُصُولِ الْعَيْنِ
u'وُصُولٌ عين':Added, #1: 1	وُصُولِ الْعَيْنِ
u'وُصُولٌ عَيْنٌ':Added, #1: 1	وُصُولَ عَيْنِ
u'وُصُولٌ عَيْن':Added, #1: 1	وُصُولَ عَيْنِ
u'وُصُولٌ عين':Added, #1: 1	وُصُولَ عَيْنِ
u'وُصُولٌ عَيْنٌ':Added, #2: 2	وُصُولُ الْعَيْنِ
u'وُصُولٌ عَيْن':Added, #2: 2	وُصُولُ الْعَيْنِ
u'وُصُولٌ غِذَاءٌ':Added, #2: 2	وُصُولُ الْعَيْنِ
u'وُصُولٌ قَدْرٌ':Added, #1: 1	وُصُولُ غِذَاءٍ
u'وُصُولٌ قدم':Added, #1: 1	وُصُولُ قَدْرِ
u'وُصُولٌ قَدَمٌ':Added, #2: 2	وُصُولِ الْقَدَمِ
u'وُصُولٌ قِرَاءةٌ':Added, #2: 2	وُصُولِ الْقَدَمِ
u'وُصُولٌ قِرَاءةٌ':Added, #1: 1	وُصُولَ الْقِرَاءَةِ
u'وُصُولٌ قُرَبٌ':Added, #1: 1	وُصُولِ الْقِرَاءَةِ
u'وُصُولٌ قَطْرَةٌ':Added, #1: 1	وُصُولِ الْقُرَبِ
u'وُصُولٌ كِتَابٌ':Added, #1: 1	وُصُولَ قَطْرَةٍ
u'وُصُولٌ كِتَابٌ':Added, #10: 10	وُصُولِ الْكِتَابِ
u'وُصُولٌ كَلاَمٌ':Added, #1: 1	وُصُولِ كِتَابِهِ
u'وُصُولٌ لبن':Added, #1: 1	وُصُولِ الْكَلَامِ
u'وُصُولٌ لَبَنٌ':Added, #1: 1	وُصُولَ اللَّبَنِ
u'وُصُولٌ لبن':Added, #1: 1	وُصُولَ اللَّبَنِ
u'وُصُولٌ لَبَنٌ':Added, #2: 2	وُصُولِ اللَّبَنِ
u'وُصُولٌ لبن':Added, #2: 2	وُصُولِ اللَّبَنِ
u'وُصُولٌ لَبَنٌ':Added, #2: 2	وُصُولُ لَبَنِ
u'وُصُولٌ لبن':Added, #2: 2	وُصُولُ لَبَنِ
u'وُصُولٌ لَبَنٌ':Added, #4: 4	وُصُولُ اللَّبَنِ
u'وُصُولٌ مَاءٌ':Added, #4: 4	وُصُولُ اللَّبَنِ
u'وُصُولٌ مَاءٌ':Added, #14: 14	وُصُولِ الْمَاءِ
u'وُصُولٌ مَاءٌ':Added, #19: 19	وُصُولَ الْمَاءِ
u'وُصُولٌ مَأْكُولٌ':Added, #5: 5	وُصُولُ الْمَاءِ
u'وُصُولٌ مَالٌ':Added, #1: 1	وُصُولُ الْمَأْكُولِ
u'وُصُولٌ مَالٌ':Added, #1: 1	وُصُولُ الْمَالِ
u'وُصُولٌ مَالٌ':Added, #1: 1	وُصُولِ مَالِ
u'وُصُولٌ مَالِكٌ':Added, #8: 8	وُصُولِ الْمَالِ
u'وُصُولٌ مَالِكٌ':Added, #1: 1	وُصُولَ الْمَالِكِ
u'وُصُولٌ مَتَاعٌ':Added, #1: 1	وُصُولُ الْمَالِكِ
u'وُصُولٌ مثل':Added, #1: 1	وُصُولُ الْمَتَاعِ
u'وُصُولٌ مِثْلٌ':Added, #1: 1	وُصُولُ مِثْلِ
u'وُصُولٌ مُرْسَلٌ':Added, #1: 1	وُصُولُ مِثْلِ
u'وُصُولٌ مَزِيدٌ':Added, #1: 1	وُصُولِ الْمُرْسَلِ
u'وُصُولٌ مَسْرُوقٌ':Added, #1: 1	وُصُولِ مَزِيدِ
u'وُصُولٌ مُعَلَّقٌ':Added, #1: 1	وُصُولِ الْمَسْرُوقِ
u'وُصُولٌ مُفْطِر':Added, #1: 1	وُصُولِ الْمُعَلَّقِ
u'وُصُولٌ مَقْصُودٌ':Added, #1: 1	وُصُولَ الْمُفْطِرِ
u'وُصُولٌ مَهْرٌ':Added, #1: 1	وُصُولِ الْمَقْصُودِ
u'وُصُولٌ مِيرَاثٌ':Added, #1: 1	وُصُولُ الْمَهْرِ
u'وُصُولٌ نَاسِخٌ':Added, #1: 1	وُصُولُ الْمِيرَاثِ
u'وُصُولٌ نَاسِخ':Added, #1: 1	وُصُولِ النَّاسِخِ
u'وُصُولٌ نَائِبٌ':Added, #1: 1	وُصُولِ النَّاسِخِ
u'وُصُولٌ نَجَاسَةٌ':Added, #1: 1	وُصُولُ نَائِبِهِ
u'وُصُولٌ نَجَاسَةٌ':Added, #2: 2	وُصُولَ النَّجَاسَةِ
u'وُصُولٌ نَجَسٌ':Added, #5: 5	وُصُولِ النَّجَاسَةِ
u'وُصُولٌ نَفْسٌ':Added, #1: 1	وُصُولِ النَّجَسِ
u'وُصُولٌ نَفْسٌ':Added, #1: 1	وُصُولُ النَّفْسِ
u'وُصُولٌ نَفْعٌ':Added, #1: 1	وُصُولِ النَّفْسِ
u'وُصُولٌ نَفَقَةٌ':Added, #1: 1	وُصُولِ نَفْعٍ
u'وُصُولٌ نَفَقَةٌ':Added, #2: 2	وُصُولَ النَّفَقَةِ
u'وُصُولٌ نَفَقَةٌ':Added, #3: 3	وُصُولُ النَّفَقَةِ
u'وُصُولٌ نَوْبَةٌ':Added, #7: 7	وُصُولِ النَّفَقَةِ
u'وُصُولٌ نُورٌ':Added, #1: 1	وُصُولَ النَّوْبَةِ
u'وُصُولٌ هَوَاءٌ':Added, #1: 1	وُصُولِ نُورِهِ
u'وُصُولٌ وَقْت':Added, #1: 1	وُصُولِ الْهَوَاءِ
u'وُصُولٌ وَقْتِيّ':Added, #1: 1	وُصُولُ الْوَقْتِيَّةِ
u'وُصُولٌ يَابِسٌ':Added, #1: 1	وُصُولُ الْوَقْتِيَّةِ
u'وُصُولٌ يَدٌ':Added, #1: 1	وُصُولَ الْيَابِسِ
u'وُصُولٌ يَدٌ':Added, #1: 1	وُصُولِ يَدٍ
u'وُصُولٌ يَدٌ':Added, #1: 1	وُصُولُ يَدِهِ
u'وُصُولٌ يَدٌ':Added, #1: 1	وُصُولِ يَدِهِ
u'وُصُولٌ يَدٌ':Added, #2: 2	وُصُولَ الْيَدِ
u'وَصَّى رَسُولٌ':Subject, #2: 2	وُصُولُ يَدِ
u'وَصَّى شَيْءٌ':Predicate, #1: 1	وَصَّى رَسُولُ
u'وَصَّى فُلاَنٌ':Subject, #1: 1	وَصَّى الشَّيْءَ
u'وَصَّى وَكِيلٌ':Subject, #1: 1	وَصَّى فُلَانٌ
u'وضاح فِضَّةٌ':Added, #1: 1	وَصَّى الْوَكِيلُ
u'وضاع تَصَرُّفٌ':Added, #1: 1	أَوْضَاحَ فِضَّةٍ
u'وضاع شَرْعٌ':Added, #2: 2	أَوْضَاعِ التَّصَرُّفَاتِ
u'وضاع شَرِيعَةٌ':Added, #2: 2	أَوْضَاعِ الشَّرْعِ
u'وضاع لُغَةٌ':Added, #1: 1	أَوْضَاعِ الشَّرِيعَةِ
u'وضاع مَسَاكِنُ':Added, #2: 2	أَوْضَاعِ اللُّغَةِ
u'وضاع مَسَائِلُ':Added, #1: 1	أَوْضَاعِ الْمَسَاكِنِ
u'وَضَحَ اِنْتِفاء':Subject, #1: 1	أَوْضَاعَ الْمَسَائِلِ
u'وَضِحَ سَبِيلٌ':Predicate, #1: 1	وَضَحَ انْتِفَاءُ
u'وَضَحَ طَرِيقٌ':Subject, #2: 2	أَوْضَحَ السَّبِيلَ
u'وَضِحَ عَظْمٌ':Predicate, #2: 2	وَضَحَ الطَّرِيقُ
u'وَضَحٌ عَظْمٌ':Added, #1: 1	أَوْضَحَ الْعَظْمَ
u'وَضَحَ فَجْرٌ':Subject, #1: 1	وَضَحُ الْعَظْمِ
u'وَضِحَ فرق':Predicate, #1: 1	وَضَحَ الْفَجْرُ
u'وَضِحَ فَرْقٌ':Predicate, #1: 1	أَوْضَحَ الْفَرْقَ
u'وَضَحَ قول':Subject, #1: 1	أَوْضَحَ الْفَرْقَ
u'وَضَحَ قَوْلٌ':Subject, #1: 1	وَضَحَ الْقَوْلُ
u'وَضِحَ مُتَلاَحِمٌ':Predicate, #1: 1	وَضَحَ الْقَوْلُ
u'وَضِحَ مَحَجَّةٌ':Predicate, #1: 1	أَوْضَحَ مُتَلَاحِمَةً
u'وَضِحَ مَسْأَلَةٌ':Predicate, #1: 1	أَوْضَحَ الْمَحَجَّةَ
u'وَضِحَ مَقَامٌ':Predicate, #1: 1	أَوْضَحَ الْمَسْأَلَةَ
u'وَضِحَ وَقْتٌ':Predicate, #2: 2	أَوْضَحَ الْمَقَامَ
u'وَضْعٌ أَبٌ':Added, #1: 1	أَوْضَحَ الْوَقْتَ
u'وَضْعٌ أثْقَالٌ':Added, #1: 1	وَضْعُ الْأَبِ
u'وَضْعٌ إجَارَةٌ':Added, #1: 1	وَضْعُ الْأَثْقَالِ
u'وَضْعٌ أَجْذَاعٌ':Added, #1: 1	وَضْعَ الْإِجَارَةِ
u'وَضْعٌ إِجْمَاعٌ':Added, #1: 1	وَضْعِ أَجْذَاعٍ
u'وَضْعٌ أَحادِيثُ':Added, #1: 1	وَضْعِ الْإِجْمَاعِ
u'وَضَعَ أحَدٌ':Subject, #1: 1	وَضْعِ الْأَحَادِيثِ
u'وَضَعَ أحَدٌ':Subject, #1: 1	وَضَعَ أَحَدٌ
u'وَضْعٌ أحَدٌ':Added, #1: 1	وَضَعَ أَحَدُ
u'وَضَعَ أحْمَالٌ':Predicate, #1: 1	وَضْعُ أَحَدِ
u'وَضَعَ أَحْمَالٌ':Predicate, #1: 1	وَضَعَ الْأَحْمَالَ
u'وَضْعٌ أخْبَارٌ':Added, #1: 1	وَضَعَ الْأَحْمَالَ
u'وَضْعٌ أَخْبَارٌ':Added, #2: 2	وَضْعِ الْأَخْبَارِ
u'وَضْعٌ أَخْشَابٌ':Added, #2: 2	وَضْعِ الْأَخْبَارِ
u'وَضْعٌ أَخْشَابٌ':Added, #1: 1	وَضْعِ أَخْشَابِهِ
u'وَضْعٌ أسْبَابٌ':Added, #1: 1	وَضْعِ الْأَخْشَابِ
u'وَضْعٌ أَسْبَابٌ':Added, #1: 1	وَضْعَ الْأَسْبَابِ
u'وَضْعٌ أسْبَابٌ':Added, #1: 1	وَضْعَ الْأَسْبَابِ
u'وَضْعٌ أَسْبَابٌ':Added, #2: 2	وَضْعِ الْأَسْبَابِ
u'وَضْعٌ اِسْمٌ':Added, #2: 2	وَضْعِ الْأَسْبَابِ
u'وَضَعَ أَشْيَاءٌ':Predicate, #1: 1	وَضْعِ اسْمِ
u'وَضْعٌ أَشْيَاءٌ':Added, #1: 1	وَضَعَ الْأَشْيَاءَ
u'وَضَعَ أَصابِعُ':Predicate, #1: 1	وَضْعِ الْأَشْيَاءِ
u'وَضْعٌ أَصابِعُ':Added, #3: 3	وَضَعَ الْأَصَابِعَ
u'وَضْعٌ أَصابِعُ':Added, #1: 1	وَضْعِ أَصَابِعِ
u'وَضْعٌ أَصابِعُ':Added, #1: 1	وَضْعِ أَصَابِعِهِ
u'وَضْعٌ أُصْبُعٌ':Added, #2: 2	وَضْعُ أَصَابِعِهِ
u'وَضْعٌ أُصْبُعٌ':Added, #1: 1	وَضْعُ الْأُصْبُعِ
u'وَضْعٌ أُصْبُعٌ':Added, #1: 1	وَضْعُ الْأُصْبُعَيْنِ
u'وَضْعٌ أصل':Added, #3: 3	وَضْعُ أُصْبُعٍ
u'وَضْعٌ أًصْلٌ':Added, #1: 1	وَضْعُ أَصْلِ
u'وَضْعٌ أصل':Added, #1: 1	وَضْعُ أَصْلِ
u'وَضْعٌ أًصْلٌ':Added, #1: 1	وَضْعِ الْأَصْلِ
u'وَضْعٌ أَصْلِيٌّ':Added, #1: 1	وَضْعِ الْأَصْلِ
u'وَضَعَ أَطْرافٌ':Predicate, #1: 1	وَضْعَ الْأَصْلِيَّاتِ
u'وَضَعَ أَطْرَافٌ':Predicate, #1: 1	وَضَعَ أَطْرَافَ
u'وَضَعَ إِعْجامٌ':Predicate, #1: 1	وَضَعَ أَطْرَافَ
u'وَضَعَ إِعْرابٌ':Predicate, #1: 1	وَضَعَ الْإِعْجَامَ
u'وَضْعٌ أَعْضَاءٌ':Added, #1: 1	وَضَعَ الْإِعْرَابَ
u'وَضْعٌ أَعْضَاءٌ':Added, #1: 1	وَضْعُ أَعْضَاءِ
u'وَضَعَ أَعْلاَمٌ':Predicate, #1: 1	وَضْعُ الْأَعْضَاءِ
u'وَضَعَ أَكْثَرُ':Predicate, #1: 1	وَضَعَ الْأَعْلَامَ
u'وَضْعٌ آلةٌ':Added, #1: 1	وَضَعَ أَكْثَرَ
u'وَضَعَ أَلْفَاظٌ':Predicate, #1: 1	وَضْعَ الْآلَةِ
u'وَضْعٌ أَلْفَاظٌ':Added, #1: 1	وَضَعَ الْأَلْفَاظَ
u'وَضْعٌ أَلْفَاظٌ':Added, #1: 1	وَضْعَ الْأَلْفَاظِ
u'وَضْعٌ أَلْفَاظٌ':Added, #1: 1	وَضْعُ الْأَلْفَاظِ
u'وَضْعٌ الْمَرْأَةُ':Added, #4: 4	وَضْعِ الْأَلْفَاظِ
u'وَضْعٌ إمَامٌ':Added, #1: 1	وَضْعِ الْمَرْأَةِ
u'وَضْعٌ إمَامَةٌ':Added, #2: 2	وَضْعِ الْإِمَامِ
u'وَضْعٌ أمَانٌ':Added, #1: 1	وَضْعِ الْإِمَامَةِ
u'وَضْعٌ أمَانَةٌ':Added, #1: 1	وَضْعَ الْأَمَانِ
u'وَضْعٌ أمَةٌ':Added, #2: 2	وَضْعَ الْأَمَانَةِ
u'وَضْعٌ أمَةٌ':Added, #1: 1	وَضْعُ الْأَمَةِ
u'وَضْعٌ أَمْتِعَةٌ':Added, #1: 1	وَضْعِ أَمَتِهِ
u'وَضْعٌ أَمْتِعَةٌ':Added, #1: 1	وَضْعِ الْأَمْتِعَةِ
u'وَضْعٌ أَمْرٌ':Added, #1: 1	وَضْعُ أَمْتِعَتِهِ
u'وَضْعٌ أَمْرٌ':Added, #1: 1	وَضْعُ الْأَمْرِ
u'وَضْعٌ إِناءٌ':Added, #1: 1	وَضْعِ أَمْرَيْنِ
u'وَضَعَ إِنْسانٌ':Subject, #1: 1	وَضْعِ الْإِنَاءِ
u'وَضْعٌ أَنْفٌ':Added, #1: 1	وَضَعَ إنْسَانٌ
u'وَضْعٌ أهْلٌ':Added, #1: 1	وَضْعُ الْأَنْفِ
u'وَضْعٌ أَوَّلُ':Added, #1: 1	وَضْعِ أَهْلِ
u'وَضْعٌ أئِمَّةٌ':Added, #9: 9	وَضْعِ الْأَوَّلِ
u'وَضْعٌ بَابٌ':Added, #1: 1	وَضْعُ الْأَئِمَّةِ
u'وَضْعٌ بَابٌ':Added, #1: 1	وَضْعُ الْبَابِ
u'وَضَعَ بَائِعٌ':Subject, #2: 2	وَضْعَ الْبَابِ
u'وَضْعٌ بساط':Added, #1: 1	وَضَعَ الْبَائِعُ
u'وَضْعٌ بِساطٌ':Added, #1: 1	وَضْعُ بِسَاطٍ
u'وَضَعَ بَطْنٌ':Predicate, #1: 1	وَضْعُ بِسَاطٍ
u'وَضَعَ بَعْضٌ':Predicate, #1: 1	وَضَعَ بَطْنَ
u'وَضْعٌ بَعْضٌ':Added, #2: 2	وَضَعَ بَعْضَ
u'وَضْعٌ بَعْضٌ':Added, #1: 1	وَضْعَ الْبَعْضِ
u'وَضْعٌ بَعْضٌ':Added, #1: 1	وَضْعَ بَعْضِ
u'وَضْعٌ بَعْضٌ':Added, #1: 1	وَضْعُ بَعْضٍ
u'وَضْعٌ بَعْضٌ':Added, #1: 1	وَضْعِ بَعْضٍ
u'وَضْعٌ بَقِيَّةٌ':Added, #4: 4	وَضْعُ بَعْضِ
u'وَضْعٌ بَيْتٌ':Added, #2: 2	وَضْعِ بَقِيَّةِ
u'وَضْعٌ بَيْعٌ':Added, #1: 1	وَضْعِ الْبَيْتِ
u'وَضَعَ بَيْنٌ':Predicate, #2: 2	وَضْعَ الْبَيْعِ
u'وَضْعٌ بُيُوتٌ':Added, #3: 3	وَضَعَ بَيْنَ
u'وَضْعٌ تَأْكِيدٌ':Added, #1: 1	وَضْعِ بُيُوتِ
u'وَضْعٌ تِجَارَةٌ':Added, #1: 1	وَضْعَ التَّأْكِيدِ
u'وَضْعٌ تَجَوُّزٌ':Added, #1: 1	وَضْعَ التِّجَارَةِ
u'وَضْعٌ تَخْتٌ':Added, #1: 1	وَضْعِ التَّجَوُّزِ
u'وَضْعٌ تَخْصِيصٌ':Added, #2: 2	وَضْعِ التَّخْتِ
u'وَضْعٌ تَخْصِيصٌ':Added, #1: 1	وَضْعَ التَّخْصِيصِ
u'وَضَعَ تُرَابٌ':Predicate, #2: 2	وَضْعُ التَّخْصِيصِ
u'وَضْعٌ تُرَابٌ':Added, #3: 3	وَضَعَ التُّرَابَ
u'وَضْعٌ تُرَابٌ':Added, #1: 1	وَضْعِ التُّرَابِ
u'وَضْعٌ تَصْوِيرٌ':Added, #2: 2	وَضْعِ تُرَابٍ
u'وَضْعٌ تَعَبُّدٌ':Added, #1: 1	وَضْعُ تَصْوِيرِ
u'وَضْعٌ تَعْزِير':Added, #1: 1	وَضْعَ التَّعَبُّدِ
u'وَضْعٌ تَعْلِيقٌ':Added, #2: 2	وَضْعَ التَّعْزِيرِ
u'وَضْعٌ تَلاَمِذَةٌ':Added, #1: 1	وَضْعِ التَّعْلِيقِ
u'وَضْعٌ تَمْرٌ':Added, #1: 1	وَضْعِ التَّلَامِذَةِ
u'وَضْعٌ تَمِيمَةٌ':Added, #1: 1	وَضْعُ تَمْرٍ
u'وَضْعٌ تَوْأَمٌ':Added, #1: 1	وَضْعُ التَّمِيمَةِ
u'وَضْعٌ تَوَقُّفٌ':Added, #1: 1	وَضْعَ التَّوْأَمَيْنِ
u'وَضَعَ ثَانِي':Predicate, #1: 1	وَضْعُ التَّوَقُّفِ
u'وَضَعَ ثَلاثُ':Predicate, #1: 1	وَضَعَ الثَّانِيَ
u'وَضَعَ ثَلاثَةٌ':Predicate, #2: 2	وَضَعَ ثَلَاثَ
u'وَضْعٌ ثَمَنٌ':Added, #4: 4	وَضَعَ ثَلَاثَةَ
u'وَضْعٌ ثَمَنٌ':Added, #1: 1	وَضْعُ الثَّمَنِ
u'وَضْعٌ ثَمَنٌ':Added, #1: 1	وَضْعِ الثَّمَنِ
u'وَضْعٌ ثَوْبٌ':Added, #2: 2	وَضْعُ ثَمَنِهِ
u'وَضْعٌ ثَوْبٌ':Added, #1: 1	وَضْعَ الثَّوْبِ
u'وَضْعٌ ثَوْبٌ':Added, #1: 1	وَضْعُ الثَّوْبِ
u'وَضَعَ ثِيابٌ':Predicate, #1: 1	وَضْعَ ثَوْبٍ
u'وَضْعٌ ثِيابٌ':Added, #1: 1	وَضَعَ الثِّيَابَ
u'وَضْعٌ جَارٌ':Added, #1: 1	وَضْعِ الثِّيَابِ
u'وَضْعٌ جَارِي':Added, #1: 1	وَضْعُ الْجَارِ
u'وَضْعٌ جَارِيَةٌ':Added, #1: 1	وَضْعِ الْجَارِيَةِ
u'وَضْعٌ جَامِعٌ':Added, #1: 1	وَضْعِ الْجَارِيَةِ
u'وَضْعٌ جَامِعٌ':Added, #3: 3	وَضْعِ الْجَامِعِ
u'وَضْعٌ جَائِحٌ':Added, #4: 4	وَضْعُ الْجَامِعِ
u'وَضْعٌ جاَئِحَةٌ':Added, #1: 1	وَضْعِ الْجَائِحَةِ
u'وَضَعَ جَبْهَةٌ':Predicate, #1: 1	وَضْعِ الْجَائِحَةِ
u'وَضْعٌ جَبْهَةٌ':Added, #3: 3	وَضَعَ الْجَبْهَةَ
u'وَضْعٌ جَبْهَةٌ':Added, #10: 10	وَضْعُ الْجَبْهَةِ
u'وَضْعٌ جَبْهَةٌ':Added, #10: 10	وَضْعِ الْجَبْهَةِ
u'وَضْعٌ جَبْهَةٌ':Added, #1: 1	وَضْعَ الْجَبْهَةِ
u'وَضْعٌ جَبْهَةٌ':Added, #3: 3	وَضْعِ جَبْهَتِهِ
u'وَضَعَ جَبِيرَة':Predicate, #4: 4	وَضْعُ جَبْهَتِهِ
u'وَضْعٌ جَبِيرَة':Added, #4: 4	وَضَعَ الْجَبِيرَةَ
u'وَضَعَ جِذْعٌ':Predicate, #1: 1	وَضْعِ الْجَبِيرَةِ
u'وَضْعٌ جِذْعٌ':Added, #1: 1	وَضَعَ الْجِذْعَ
u'وَضْعٌ جِذْعٌ':Added, #1: 1	وَضْعُ الْجِذْعِ
u'وَضْعٌ جِذْعٌ':Added, #1: 1	وَضْعَ جِذْعٍ
u'وَضْعٌ جِذْعٌ':Added, #2: 2	وَضْعَ الْجِذْعِ
u'وَضْعٌ جِذْعٌ':Added, #2: 2	وَضْعِ الْجِذْعِ
u'وَضَعَ جُذُوعٌ':Predicate, #2: 2	وَضْعِ جِذْعٍ
u'وَضْعٌ جُذُوعٌ':Added, #1: 1	وَضَعَ الْجُذُوعَ
u'وَضْعٌ جُذُوعٌ':Added, #1: 1	وَضْعَ الْجُذُوعِ
u'وَضْعٌ جُذُوعٌ':Added, #2: 2	وَضْعِ جُذُوعِهِ
u'وَضَعَ جَرِيدٌ':Predicate, #8: 8	وَضْعِ الْجُذُوعِ
u'وَضْعٌ جُزْءٌ':Added, #1: 1	وَضَعَ الْجَرِيدَةَ
u'وَضْعٌ جُزْءٌ':Added, #1: 1	وَضْعِ الْجُزْءِ
u'وَضَعَ جِزْيَةٌ':Predicate, #2: 2	وَضْعُ جُزْءٍ
u'وَضْعٌ جِزْيَةٌ':Added, #1: 1	وَضَعَ الْجِزْيَةَ
u'وَضْعٌ جِزْيَةٌ':Added, #1: 1	وَضْعَ الْجِزْيَةِ
u'وَضْعٌ جِزْيَةٌ':Added, #3: 3	وَضْعُ الْجِزْيَةِ
u'وَضْعٌ جِلْبَابٌ':Added, #7: 7	وَضْعِ الْجِزْيَةِ
u'وَضَعَ جَمَاعَةٌ':Subject, #2: 2	وَضْعِ الْجِلْبَابِ
u'وَضْعٌ جَمَاعَةٌ':Added, #2: 2	وَضَعَ جَمَاعَةٌ
u'وَضْعٌ جَمِيع':Added, #2: 2	وَضْعِ الْجَمَاعَةِ
u'وَضْعٌ جَمِيع':Added, #1: 1	وَضْعَ الْجَمِيعِ
u'وَضْعٌ جناح':Added, #1: 1	وَضْعِ الْجَمِيعِ
u'وَضْعٌ جَنَاحٌ':Added, #1: 1	وَضْعِ الْجَنَاحِ
u'وَضْعٌ جَنَائِزُ':Added, #1: 1	وَضْعِ الْجَنَاحِ
u'وَضْعٌ جَنْبٌ':Added, #2: 2	وَضْعِ الْجَنَائِزِ
u'وَضَعَ جوائح':Predicate, #1: 1	وَضْعُ الْجَنْبِ
u'وَضَعَ جَوَائِحُ':Predicate, #2: 2	وَضَعَ الْجَوَائِحَ
u'وَضْعٌ جوائح':Added, #2: 2	وَضَعَ الْجَوَائِحَ
u'وَضْعٌ جَوَائِحُ':Added, #5: 5	وَضْعِ الْجَوَائِحِ
u'وَضَعَ حاجِزٌ':Predicate, #5: 5	وَضْعِ الْجَوَائِحِ
u'وَضْعٌ حَبٌّ':Added, #1: 1	وَضَعَ الْحَاجِزَ
u'وَضَعَ حَبْلٌ':Predicate, #1: 1	وَضْعِ حَبِّهِ
u'وَضَعَ حَجَرٌ':Predicate, #1: 1	وَضَعَ الْحَبْلَ
u'وَضْعٌ حَجَرٌ':Added, #8: 8	وَضَعَ الْحَجَرَ
u'وَضْعٌ حَجَرٌ':Added, #1: 1	وَضْعِ الْحَجَرِ
u'وَضْعٌ حَجَرٌ':Added, #2: 2	وَضْعَ الْحَجَرِ
u'وَضَعَ حَدٌّ':Predicate, #2: 2	وَضْعُ الْحَجَرِ
u'وَضَعَ حُدودٌ':Predicate, #1: 1	وَضَعَ الْحَدَّ
u'وَضْعٌ حَديثٌ':Added, #1: 1	وَضَعَ الْحُدُودَ
u'وَضْعٌ حَديثٌ':Added, #1: 1	وَضْعُ الْحَدِيثِ
u'وَضْعٌ حَديثٌ':Added, #1: 1	وَضْعَ حَدِيثٍ
u'وَضْعٌ حَديدٌ':Added, #5: 5	وَضْعِ الْحَدِيثِ
u'وَضْعٌ حَرْبٌ':Added, #1: 1	وَضْعُ حَدِيدٍ
u'وَضْعٌ حَرْفٌ':Added, #3: 3	وَضْعِ الْحَرْبِ
u'وَضْعٌ حُروفٌ':Added, #1: 1	وَضْعِ حَرْفٍ
u'وَضَعَ حَصَاةٌ':Predicate, #1: 1	وَضْعُ حُرُوفِ
u'وَضْعٌ حَصَاةٌ':Added, #2: 2	وَضَعَ الْحَصَاةَ
u'وَضْعٌ حَفَظَةٌ':Added, #1: 1	وَضْعُ الْحَصَاةِ
u'وَضْعٌ حَفَظَةٌ':Added, #1: 1	وَضْعَ الْحَفَظَةِ
u'وَضَعَ حُقْنَةٌ':Predicate, #1: 1	وَضْعِ الْحَفَظَةِ
u'وَضْعٌ حَقِيقٌ':Added, #1: 1	وَضَعَ الْحُقْنَةَ
u'وَضْعٌ حَقِيقَةٌ':Added, #5: 5	وَضْعِ الْحَقِيقَةِ
u'وَضْعٌ حكمة':Added, #5: 5	وَضْعِ الْحَقِيقَةِ
u'وَضْعٌ حِكْمَةٌ':Added, #1: 1	وَضْعِ الْحِكْمَةِ
u'وَضْعٌ حَلَمَةٌ':Added, #1: 1	وَضْعِ الْحِكْمَةِ
u'وَضْعٌ حَمْلٌ':Added, #1: 1	وَضْعُ حَلَمَةِ
u'وَضْعٌ حَمْلٌ':Added, #11: 11	وَضْعُ الْحَمْلِ
u'وَضْعٌ حَمْلٌ':Added, #1: 1	وَضْعُ حَمْلٍ
u'وَضْعٌ حَمْلٌ':Added, #20: 20	وَضْعِ الْحَمْلِ
u'وَضْعٌ حَمْلٌ':Added, #2: 2	وَضْعِ حَمْلٍ
u'وَضْعٌ حُمُولَةٌ':Added, #4: 4	وَضْعَ الْحَمْلِ
u'وَضَعَ حِنْطَةٌ':Predicate, #3: 3	وَضْعِ الْحُمُولَاتِ
u'وَضْعٌ حَنَفِيَّةٌ':Added, #1: 1	وَضَعَ الْحِنْطَةَ
u'وَضْعٌ حَواجِزُ':Added, #1: 1	وَضْعُ الْحَنَفِيَّةِ
u'وَضْعٌ حَوائِجُ':Added, #1: 1	وَضْعِ الْحَوَاجِزِ
u'وَضْعٌ خَابِيَةٌ':Added, #1: 1	وَضْعِ الْحَوَائِجِ
u'وَضْعٌ خاصّ':Added, #1: 1	وَضْعِ الْخَابِيَةِ
u'وَضْعٌ خُبْزٌ':Added, #1: 1	وَضْعِ الْخَاصِّ
u'وَضْعٌ خُبْزٌ':Added, #1: 1	وَضْعِ الْخُبْزِ
u'وَضْعٌ خَدٌّ':Added, #2: 2	وَضْعُ الْخُبْزِ
u'وَضْعٌ خَدٌّ':Added, #1: 1	وَضْعَ الْخَدِّ
u'وَضْعٌ خَدٌّ':Added, #1: 1	وَضْعَ الْخَدَّيْنِ
u'وَضَعَ خراج':Predicate, #2: 2	وَضْعِ الْخَدِّ
u'وَضَعَ خَرَاجٌ':Predicate, #4: 4	وَضَعَ الْخَرَاجَ
u'وَضْعٌ خراج':Added, #4: 4	وَضَعَ الْخَرَاجَ
u'وَضْعٌ خَرَاجٌ':Added, #12: 12	وَضْعِ الْخَرَاجِ
u'وَضْعٌ خراج':Added, #12: 12	وَضْعِ الْخَرَاجِ
u'وَضْعٌ خَرَاجٌ':Added, #1: 1	وَضْعَ خَرَاجٍ
u'وَضْعٌ خراج':Added, #1: 1	وَضْعَ خَرَاجٍ
u'وَضْعٌ خَرَاجٌ':Added, #5: 5	وَضْعُ الْخَرَاجِ
u'وَضْعٌ خراج':Added, #5: 5	وَضْعُ الْخَرَاجِ
u'وَضْعٌ خَرَاجٌ':Added, #6: 6	وَضْعَ الْخَرَاجِ
u'وَضْعٌ خرقة':Added, #6: 6	وَضْعَ الْخَرَاجِ
u'وَضْعٌ خِرْقَةٌ':Added, #1: 1	وَضْعِ الْخِرْقَةِ
u'وَضْعٌ خَشَبٌ':Added, #1: 1	وَضْعِ الْخِرْقَةِ
u'وَضْعٌ خَشَبٌ':Added, #1: 1	وَضْعَ خَشَبِهِ
u'وَضْعٌ خَشَبٌ':Added, #3: 3	وَضْعُ الْخَشَبِ
u'وَضْعٌ خَشَبٌ':Added, #3: 3	وَضْعِ خَشَبِهِ
u'وَضْعٌ خَشَبٌ':Added, #4: 4	وَضْعُ خَشَبِهِ
u'وَضْعٌ خَشَبٌ':Added, #5: 5	وَضْعِ الْخَشَبِ
u'وَضْعٌ خَشَبَةٌ':Added, #6: 6	وَضْعِ خَشَبٍ
u'وَضْعٌ خَشَبَةٌ':Added, #1: 1	وَضْعُ الْخَشَبَةِ
u'وَضْعٌ خَشَبَةٌ':Added, #1: 1	وَضْعِ خَشَبَةٍ
u'وَضَعَ خَطٌّ':Predicate, #2: 2	وَضْعُ خَشَبَةٍ
u'وَضْعٌ خَطٌّ':Added, #2: 2	وَضَعَ الْخَطَّ
u'وَضْعٌ خِطَابٌ':Added, #1: 1	وَضْعُ الْخَطِّ
u'وَضْعٌ خُطَبٌ':Added, #1: 1	وَضْعَ الْخِطَابِ
u'وَضَعَ خُفٌّ':Predicate, #1: 1	وَضْعُ الْخُطَبِ
u'وَضْعٌ خِلاَفٌ':Added, #1: 1	وَضَعَ الْخُفَّ
u'وَضْعٌ خِلاَفٌ':Added, #1: 1	وَضْعُ الْخِلَافِ
u'وَضْعٌ خَلِيفَةٌ':Added, #1: 1	وَضْعِ الْخِلَافِ
u'وَضْعٌ خَمْرٌ':Added, #1: 1	وَضْعِ خَلِيفَةٍ
u'وَضَعَ خَمْسَةٌ':Predicate, #1: 1	وَضْعِ الْخَمْرِ
u'وَضْعٌ خَيْرٌ':Added, #1: 1	وَضَعَ خَمْسَةَ
u'وَضَعَ دَاخِلٌ':Subject, #1: 1	وَضْعَ الْخَيْرِ
u'وَضْعٌ دُخُولٌ':Added, #2: 2	وَضَعَ الدَّاخِلُ
u'وَضْعٌ دَليلٌ':Added, #1: 1	وَضْعِ دُخُولِ
u'وَضْعٌ دَوْرٌ':Added, #1: 1	وَضْعَ الدَّلِيلِ
u'وَضَعَ دَيْنٌ':Predicate, #1: 1	وَضْعُ الدَّوْرِ
u'وَضَعَ دِيوانٌ':Predicate, #1: 1	وَضَعَ الدَّيْنَ
u'وَضْعٌ دِيوانٌ':Added, #1: 1	وَضَعَ الدِّيوَانَ
u'وَضْعٌ دِيوانٌ':Added, #1: 1	وَضْعَ الدِّيوَانِ
u'وَضْعٌ ذكر':Added, #2: 2	وَضْعِ الدِّيوَانِ
u'وَضْعٌ ذكر':Added, #1: 1	وَضْعُ الذَّكَرِ
u'وَضْعٌ ذَكَرٌ':Added, #1: 1	وَضْعِ الذَّكَرِ
u'وَضْعٌ ذَكَرٌ':Added, #1: 1	وَضْعُ الذَّكَرِ
u'وَضْعٌ راح':Added, #1: 1	وَضْعِ الذَّكَرِ
u'وَضَعَ رَأْسٌ':Predicate, #1: 1	وَضْعِ الرَّاحَتَيْنِ
u'وَضْعٌ رَافِضٌ':Added, #2: 2	وَضَعَ رَأْسَ
u'وَضْعٌ رَافِضَةٌ':Added, #1: 1	وَضْعِ الرَّافِضَةِ
u'وَضْعٌ رَبُّ':Added, #1: 1	وَضْعِ الرَّافِضَةِ
u'وَضْعٌ رُبُعٌ':Added, #1: 1	وَضْعُ رَبِّ
u'وَضَعَ رِجْلٌ':Predicate, #1: 1	وَضْعِ رُبُعِ
u'وَضَعَ رَجُلٌ':Subject, #1: 1	وَضَعَ الرِّجْلَ
u'وَضَعَ رَجُلٌ':Subject, #5: 5	وَضَعَ رَجُلٌ
u'وَضْعٌ رَجُلٌ':Added, #6: 6	وَضَعَ الرَّجُلُ
u'وَضْعٌ رَجُلٌ':Added, #1: 1	وَضْعُ الرَّجُلِ
u'وَضْعٌ رِجْلٌ':Added, #1: 1	وَضْعِ رَجُلٍ
u'وَضَعَ رحم':Predicate, #1: 1	وَضْعِ رِجْلِهِ
u'وَضَعَ رَحِمٌ':Predicate, #1: 1	وَضَعَ الرَّحِمَ
u'وَضْعٌ رِدَاءٌ':Added, #1: 1	وَضَعَ الرَّحِمَ
u'وَضْعٌ رِدَاءٌ':Added, #1: 1	وَضْعِ الرِّدَاءِ
u'وَضَعَ رَسُولٌ':Predicate, #1: 1	وَضْعِ رِدَاءِ
u'وَضَعَ رَسُولٌ':Subject, #1: 1	وَضَعَ رَسُولَ
u'وَضْعٌ رُكْنٌ':Added, #7: 7	وَضَعَ رَسُولُ
u'وَضْعٌ رُكْنٌ':Added, #1: 1	وَضْعُ الرّكْنِ
u'وَضْعٌ رُكْنٌ':Added, #1: 1	وَضْعُ الرُّكْنِ
u'وَضْعٌ رُكْن':Added, #1: 1	وَضْعِ الرّكْنِ
u'وَضْعٌ رُكْن':Added, #1: 1	وَضْعُ الرّكْنِ
u'وَضْعٌ رُكْن':Added, #1: 1	وَضْعُ الرُّكْنِ
u'وَضْعٌ رُمْحٌ':Added, #1: 1	وَضْعِ الرّكْنِ
u'وَضَعَ رَهْنٌ':Predicate, #1: 1	وَضْعِ الرُّمْحِ
u'وَضْعٌ رَهْنٌ':Added, #3: 3	وَضَعَ الرَّهْنَ
u'وَضْعٌ رَهْنٌ':Added, #2: 2	وَضْعَ الرَّهْنِ
u'وَضْعٌ رَهْنٌ':Added, #2: 2	وَضْعُ الرَّهْنِ
u'وَضْعٌ روائح':Added, #4: 4	وَضْعِ الرَّهْنِ
u'وَضْعٌ رَوائِحُ':Added, #1: 1	وَضْعُ الرَّوَائِحِ
u'وَضْعٌ رَوَائِحُ':Added, #1: 1	وَضْعُ الرَّوَائِحِ
u'وَضْعٌ زادٌ':Added, #1: 1	وَضْعُ الرَّوَائِحِ
u'وَضْعٌ زِبْلٌ':Added, #1: 1	وَضْعِ زَادِهِ
u'وَضْعٌ زَبيبٌ':Added, #1: 1	وَضْعَ زِبْلٍ
u'وَضْعٌ زَبيبٌ':Added, #1: 1	وَضْعِ الزَّبِيبِ
u'وَضَعَ زَكاةٌ':Predicate, #2: 2	وَضْعَ زَبِيبٍ
u'وَضْعٌ زَكاةٌ':Added, #1: 1	وَضَعَ الزَّكَاةَ
u'وَضْعٌ زَكاةٌ':Added, #1: 1	وَضْعَ الزَّكَاةِ
u'وَضْعٌ زَكاةٌ':Added, #1: 1	وَضْعُ الزَّكَاةِ
u'وَضْعٌ زَكاةٌ':Added, #1: 1	وَضْعِ الزَّكَاةِ
u'وَضْعٌ زَيْدٌ':Added, #1: 1	وَضْعُ زَكَاةِ
u'وَضْعٌ سَابِقٌ':Added, #1: 1	وَضْعُ زَيْدٍ
u'وَضْعٌ سَابِقٌ':Added, #1: 1	وَضْعُ سَابِقٍ
u'وَضْعٌ سَاتِرٌ':Added, #2: 2	وَضْعٍ سَابِقٍ
u'وَضْعٌ سَاقِي':Added, #1: 1	وَضْعِ السَّاتِرِ
u'وَضْعٌ سَاقِيَةٌ':Added, #1: 1	وَضْعُ سَاقِيَةٍ
u'وَضْعٌ سَائِرٌ':Added, #1: 1	وَضْعُ سَاقِيَةٍ
u'وَضْعٌ سَبَبٌ':Added, #1: 1	وَضْعِ سَائِرِ
u'وَضْعٌ سَبَبٌ':Added, #1: 1	وَضْعَ السَّبَبِ
u'وَضْعٌ سِتٌّ':Added, #1: 1	وَضْعُ السَّبَبِ
u'وَضْعٌ سترة':Added, #1: 1	وَضْعُ السِّتَّةِ
u'وَضْعٌ سُتْرَةٌ':Added, #1: 1	وَضْعِ سُتْرَةٍ
u'وَضَعَ سِرْقِين':Predicate, #1: 1	وَضْعِ سُتْرَةٍ
u'وَضْعٌ سَرِيرٌ':Added, #1: 1	وَضَعَ السِّرْقِينَ
u'وَضْعٌ سَرِيرٌ':Added, #1: 1	وَضْعِ السَّرِيرِ
u'وَضْعٌ سِقَايَةٌ':Added, #1: 1	وَضْعُ سَرِيرٍ
u'وَضَعَ سكر':Predicate, #1: 1	وَضْعَ السِّقَايَةِ
u'وَضَعَ سِلاَحٌ':Predicate, #1: 1	وَضَعَ السَّكْرَ
u'وَضْعٌ سِلاَحٌ':Added, #1: 1	وَضَعَ السِّلَاحَ
u'وَضْعٌ سَلَمٌ':Added, #1: 1	وَضْعِ السّلَاحِ
u'وَضَعَ سَهْمٌ':Predicate, #1: 1	وَضْعَ السَّلَمِ
u'وَضَعَ سَهْمٌ':Predicate, #1: 1	وَضَعَ سَهْمَ
u'وَضْعٌ سورٌ':Added, #2: 2	وَضَعَ السَّهْمَ
u'وَضْعٌ سَوْطٌ':Added, #1: 1	وَضْعِ السُّورِ
u'وَضْعٌ سِياسَةٌ':Added, #1: 1	وَضْعُ سَوْطٍ
u'وَضَعَ سَيْفٌ':Predicate, #1: 1	وَضْعِ السِّيَاسَةِ
u'وَضْعٌ سَيْفٌ':Added, #1: 1	وَضَعَ السّيْفَ
u'وَضْعٌ شَارِحٌ':Added, #1: 1	وَضْعِ سَيْفٍ
u'وَضَعَ شَارِعٌ':Subject, #1: 1	وَضْعُ شَارِحِهِ
u'وَضْعٌ شَارِعٌ':Added, #4: 4	وَضَعَ الشَّارِعُ
u'وَضْعٌ شَارِعٌ':Added, #1: 1	وَضْعَ الشَّارِعِ
u'وَضْعٌ شَارِعٌ':Added, #2: 2	وَضْعُ الشَّارِعِ
u'وَضَعَ شَخْصٌ':Subject, #2: 2	وَضْعِ الشَّارِعِ
u'وَضْعٌ شَرَائِطُ':Added, #1: 1	وَضَعَ شَخْصٌ
u'وَضَعَ شَرَائِعُ':Predicate, #1: 1	وَضْعُ الشَّرَائِطِ
u'وَضَعَ شَرْعٌ':Subject, #1: 1	وَضَعَ الشَّرَائِعَ
u'وَضْعٌ شَرْعٌ':Added, #1: 1	وَضَعَ الشَّرْعُ
u'وَضْعٌ شَرْعٌ':Added, #2: 2	وَضْعَ الشَّرْعِ
u'وَضْعٌ شَرْعٌ':Added, #2: 2	وَضْعُ الشَّرْعِ
u'وَضْعٌ شركة':Added, #7: 7	وَضْعِ الشَّرْعِ
u'وَضْعٌ شِرْكَةٌ':Added, #2: 2	وَضْعَ الشِّرْكَةِ
u'وَضْعٌ شَرِيعَةٌ':Added, #2: 2	وَضْعَ الشِّرْكَةِ
u'وَضْعٌ شَرِيعَةٌ':Added, #1: 1	وَضْعُ الشَّرِيعَةِ
u'وَضَعَ شَطْرٌ':Predicate, #1: 1	وَضْعِ الشَّرِيعَةِ
u'وَضْعٌ شَهَادَةٌ':Added, #1: 1	وَضَعَ شَطْرَ
u'وَضْعٌ شَوْكٌ':Added, #1: 1	وَضْعِ الشَّهَادَةِ
u'وَضْعٌ شَوْكِ':Added, #1: 1	وَضْعُ الشَّوْكِ
u'وَضْعٌ شَيْءٌ':Added, #1: 1	وَضْعُ الشَّوْكِ
u'وَضْعٌ شَيْءٌ':Added, #1: 1	وَضْعَ الشّيْءِ
u'وَضْعٌ شَيْءٌ':Added, #1: 1	وَضْع شَيْءٍ
u'وَضْعٌ شَيْءٌ':Added, #2: 2	وَضْعِ الشَّيْءِ
u'وَضْعٌ شَيْءٌ':Added, #2: 2	وَضْعَ شَيْءٍ
u'وَضْعٌ شَيْءٌ':Added, #3: 3	وَضْعِ شَيْءٍ
u'وَضْعٌ شَيْءٌ':Added, #6: 6	وَضْعُ شَيْءٍ
u'وَضَعَ صَاحِبٌ':Subject, #8: 8	وَضْعُ الشَّيْءِ
u'وَضْعٌ صَدَقَةٌ':Added, #2: 2	وَضَعَ صَاحِبُ
u'وَضْعٌ صِرَاطٌ':Added, #1: 1	وَضْعُ الصَّدَقَاتِ
u'وَضْعٌ صِفَةٌ':Added, #1: 1	وَضْعَ الصِّرَاطِ
u'وَضَعَ صُورٌ':Predicate, #1: 1	وَضْعِ الصِّفَةِ
u'وَضَعَ صُوَرٌ':Predicate, #1: 1	وَضَعَ الصُّوَرَ
u'وَضْعٌ صِيَغٌ':Added, #1: 1	وَضَعَ الصُّوَرَ
u'وَضْعٌ صِيَغٌ':Added, #1: 1	وَضْعِ الصِّيَغِ
u'وَضْعٌ صِيغَةٌ':Added, #1: 1	وَضْعَ صِيَغِ
u'وَضْعٌ صِيغَةٌ':Added, #1: 1	وَضْعَ الصِّيغَةِ
u'وَضْعٌ ضاد':Added, #1: 1	وَضْعِ الصِّيغَةِ
u'وَضْعٌ ضَارِبٌ':Added, #1: 1	وَضْعَ الضَّادِ
u'وَضْعٌ ضَرِيبَةٌ':Added, #1: 1	وَضْعِ الضَّارِبِ
u'وَضْعٌ ضَمِيرٌ':Added, #1: 1	وَضْعُ الضَّرِيبَةِ
u'وَضَعَ طَالِبٌ':Subject, #1: 1	وَضْعِ الضَّمِيرِ
u'وَضْعٌ طَاهِرٌ':Added, #2: 2	وَضَعَ الطَّالِبُ
u'وَضْعٌ طَاهِرٌ':Added, #1: 1	وَضْعَ طَاهِرٍ
u'وَضْعٌ طرف':Added, #1: 1	وَضْعُ طَاهِرٍ
u'وَضْعٌ طَرَفٌ':Added, #1: 1	وَضْعِ الطَّرَفِ
u'وَضْعٌ طعام':Added, #1: 1	وَضْعِ الطَّرَفِ
u'وَضْعٌ طَعَامٌ':Added, #5: 5	وَضْعِ الطَّعَامِ
u'وَضْعٌ طِفْلٌ':Added, #5: 5	وَضْعِ الطَّعَامِ
u'وَضْعٌ طِفْلٌ':Added, #1: 1	وَضْعَ الطِّفْلِ
u'وَضْعٌ طَهَارَةٌ':Added, #1: 1	وَضْعُ الطِّفْلِ
u'وَضَعَ ظاهِرٌ':Predicate, #1: 1	وَضْعَ الطَّهَارَاتِ
u'وَضْعٌ ظاهِرٌ':Added, #1: 1	وَضَعَ الظَّاهِرَ
u'وَضَعَ ظَهْرٌ':Predicate, #1: 1	وَضْعَ الظَّاهِرِ
u'وَضَعَ عارِيَّةٌ':Subject, #1: 1	وَضَعَ ظَهْرَ
u'وَضْعٌ عَالِمٌ':Added, #1: 1	وَضَعَ الْعَارِيَّةُ
u'وَضَعَ عَرَبِيٌّ':Subject, #1: 1	وَضْع الْعَالِمِ
u'وَضْعٌ عرف':Added, #1: 1	وَضَعَ الْعَرَبِيُّ
u'وَضْعٌ عُرْفٌ':Added, #1: 1	وَضْعُ الْعُرْفِ
u'وَضَعَ عُشْرٌ':Predicate, #1: 1	وَضْعُ الْعُرْفِ
u'وَضْعٌ عطف':Added, #3: 3	وَضَعَ الْعُشْرَ
u'وَضْعٌ عَطْفٌ':Added, #1: 1	وَضْعَ الْعَطْفِ
u'وَضْعٌ عَقْدٌ':Added, #1: 1	وَضْعَ الْعَطْفِ
u'وَضْعٌ عَلاَمَةٌ':Added, #3: 3	وَضْعَ الْعَقْدِ
u'وَضْعٌ علم':Added, #2: 2	وَضْعِ الْعَلَامَةِ
u'وَضْعٌ عِلْمٌ':Added, #1: 1	وَضْعَ الْعِلْمِ
u'وَضَعَ علماء':Subject, #1: 1	وَضْعَ الْعِلْمِ
u'وَضَعَ عُلَمَاءُ':Subject, #1: 1	وَضَعَ الْعُلَمَاءُ
u'وَضْعٌ عِلِّيٌّ':Added, #1: 1	وَضَعَ الْعُلَمَاءُ
u'وَضَعَ عِمَامَةٌ':Predicate, #1: 1	وَضْعِ الْعِلِّيَّةِ
u'وَضَعَ عُمَرٌ':Subject, #2: 2	وَضَعَ الْعِمَامَةَ
u'وَضْعٌ عُمُومٌ':Added, #2: 2	وَضَعَ عُمَرُ
u'وَضَعَ عند':Predicate, #1: 1	وَضْعَ عُمُومٍ
u'وَضْعٌ عُودٌ':Added, #3: 3	وَضَعَ عِنْدَ
u'وَضْعٌ عِوَضٌ':Added, #1: 1	وَضْعِ الْعُودِ
u'وَضْعٌ عَيْنٌ':Added, #1: 1	وَضْعِ الْعِوَضِ
u'وَضْعٌ عَيْن':Added, #1: 1	وَضْعُ عَيْنٍ
u'وَضْعٌ عين':Added, #1: 1	وَضْعُ عَيْنٍ
u'وَضْعٌ عَيْنٌ':Added, #1: 1	وَضْعُ عَيْنِهِ
u'وَضْعٌ عَيْن':Added, #1: 1	وَضْعُ عَيْنِهِ
u'وَضْعٌ غَسْلٌ':Added, #1: 1	وَضْعُ عَيْنِهِ
u'وَضَعَ غير':Subject, #1: 1	وَضْعُ غَسْلِهِ
u'وَضَعَ غَيْرٌ':Subject, #1: 1	وَضَعَ غَيْرُهُ
u'وَضْعٌ غير':Added, #1: 1	وَضَعَ غَيْرُهُ
u'وَضْعٌ غَيْرٌ':Added, #1: 1	وَضْعِ غَيْرِ
u'وَضْعٌ غير':Added, #1: 1	وَضْعِ غَيْرِ
u'وَضْعٌ غَيْرٌ':Added, #1: 1	وَضْعَ غَيْرِهِ
u'وَضَعَ فَتِيلٌ':Predicate, #1: 1	وَضْعَ غَيْرِهِ
u'وَضْعٌ فِرَاخٌ':Added, #1: 1	وَضَعَ الْفَتِيلَةَ
u'وَضَعَ فَرَائِضُ':Predicate, #1: 1	وَضْعُ الْفِرَاخِ
u'وَضْعٌ فِعْلٌ':Added, #1: 1	وَضَعَ الْفَرَائِضَ
u'وَضَعَ فقهاء':Subject, #1: 1	وَضْعُ فِعْلٍ
u'وَضْعٌ فَمٌ':Added, #1: 1	وَضَعَ الْفُقَهَاءُ
u'وَضَعَ قَاعِدٌ':Subject, #2: 2	وَضْعُ الْفَمِ
u'وَضَعَ قَبَاءٌ':Predicate, #1: 1	وَضَعَ الْقَاعِدُ
u'وَضَعَ قتال':Predicate, #1: 1	وَضَعَ الْقَبَاءَ
u'وَضَعَ قِتَالٌ':Predicate, #1: 1	وَضَعَ الْقِتَالَ
u'وَضْعٌ قتال':Added, #1: 1	وَضَعَ الْقِتَالَ
u'وَضْعٌ قِتَالٌ':Added, #1: 1	وَضْعِ الْقِتَالِ
u'وَضَعَ قتل':Predicate, #1: 1	وَضْعِ الْقِتَالِ
u'وَضَعَ قَتْلٌ':Predicate, #1: 1	وَضَعَ الْقَتْلَ
u'وَضَعَ قَدَحٌ':Predicate, #1: 1	وَضَعَ الْقَتْلَ
u'وَضَعَ قِدْرٌ':Predicate, #1: 1	وَضَعَ الْقَدَحَ
u'وَضْعٌ قِدْرٌ':Added, #1: 1	وَضَعَ الْقِدْرَ
u'وَضَعَ قدم':Predicate, #1: 1	وَضْعُ الْقِدْرِ
u'وَضَعَ قَدَمٌ':Predicate, #2: 2	وَضَعَ الْقَدَمَ
u'وَضْعٌ قدم':Added, #2: 2	وَضَعَ الْقَدَمَ
u'وَضْعٌ قَدَمٌ':Added, #1: 1	وَضْعُ الْقَدَمِ
u'وَضْعٌ قَدَمٌ':Added, #1: 1	وَضْعُ الْقَدَمِ
u'وَضْعٌ قَدَمٌ':Added, #1: 1	وَضْعِ الْقَدَمَيْنِ
u'وَضْعٌ قَدَمٌ':Added, #1: 1	وَضْعُ قَدَمٍ
u'وَضْعٌ قَدَمٌ':Added, #2: 2	وَضْعُ الْقَدَمَيْنِ
u'وَضْعٌ قدم':Added, #3: 3	وَضْعَ الْقَدَمَيْنِ
u'وَضْعٌ قَدَمٌ':Added, #5: 5	وَضْعِ الْقَدَمِ
u'وَضْعٌ قدم':Added, #5: 5	وَضْعِ الْقَدَمِ
u'وَضْعٌ قَدَمٌ':Added, #6: 6	وَضْعَ الْقَدَمِ
u'وَضْعٌ قراض':Added, #6: 6	وَضْعَ الْقَدَمِ
u'وَضْعٌ قِصَاعٌ':Added, #2: 2	وَضْعَ الْقِرَاضِ
u'وَضْعٌ قطعة':Added, #1: 1	وَضْعُ الْقِصَاعِ
u'وَضْعٌ قِطْعَةٌ':Added, #1: 1	وَضْعِ قِطْعَةِ
u'وَضْعٌ قُطْنٌ':Added, #1: 1	وَضْعِ قِطْعَةِ
u'وَضْعٌ قَنَاطِرُ':Added, #1: 1	وَضْعِ الْقُطْنِ
u'وَضْعٌ قَنْطَرَةٌ':Added, #1: 1	وَضْعِ الْقَنَاطِرِ
u'وَضْعٌ قَوَاعِدُ':Added, #1: 1	وَضْعِ الْقَنْطَرَةِ
u'وَضْعٌ قَوَاعِدُ':Added, #1: 1	وَضْعُ الْقَوَاعِدِ
u'وَضَعَ قول':Predicate, #1: 1	وَضْعُ قَوَاعِدِ
u'وَضَعَ قَوْلٌ':Predicate, #1: 1	وَضَعَ الْقَوْلَ
u'وَضَعَ قَوْمٌ':Subject, #1: 1	وَضَعَ الْقَوْلَ
u'وَضَعَ قَيِّمٌ':Subject, #2: 2	وَضَعَ الْقَوْمُ
u'وَضْعٌ قِيمَةٌ':Added, #1: 1	وَضَعَ الْقَيِّمُ
u'وَضْعٌ كَاغِدٌ':Added, #2: 2	وَضْعَ قِيمَةِ
u'وَضْعٌ كَافِرٌ':Added, #1: 1	وَضْعُ كَاغِدٍ
u'وَضَعَ كِتَابٌ':Predicate, #1: 1	وَضْعِ الْكَافِرِ
u'وَضَعَ كِتَابٌ':Predicate, #1: 1	وَضَعَ الْكِتَابَ
u'وَضْعٌ كِتَابٌ':Added, #1: 1	وَضَعَ كِتَابَ
u'وَضْعٌ كِتَابٌ':Added, #1: 1	وَضْعِ كِتَابٍ
u'وَضَعَ كَفٌّ':Predicate, #1: 1	وَضْعِ كِتَابِ
u'وَضْعٌ كَفٌّ':Added, #5: 5	وَضَعَ الْكَفَّ
u'وَضْعٌ كَفٌّ':Added, #1: 1	وَضْعَ الْكَفِّ
u'وَضْعٌ كَفَّارٌ':Added, #2: 2	وَضْعُ الْكَفِّ
u'وَضْعٌ كَفَّارَةٌ':Added, #1: 1	وَضْعُ الْكَفَّارَةِ
u'وَضْعٌ كَلاَمٌ':Added, #1: 1	وَضْعُ الْكَفَّارَةِ
u'وَضْعٌ كَلاَمٌ':Added, #1: 1	وَضْعَ الْكَلَامِ
u'وَضْعٌ كَلِمَةٌ':Added, #1: 1	وَضْعِ الْكَلَامِ
u'وَضْعٌ كَلِمَةٌ':Added, #1: 1	وَضْعُ الْكَلِمَةِ
u'وَضْعٌ لِسَانٌ':Added, #1: 1	وَضْعِ كَلِمَاتٍ
u'وَضْعٌ لِسَانٌ':Added, #1: 1	وَضْعُ اللِّسَانِ
u'وَضْعٌ لُغَةٌ':Added, #4: 4	وَضْعِ اللِّسَانِ
u'وَضْعٌ لُغَةٌ':Added, #13: 13	وَضْعِ اللُّغَةِ
u'وَضْعٌ لُغَةٌ':Added, #1: 1	وَضْعِ اللُّغَاتِ
u'وَضْعٌ لُغَةٌ':Added, #1: 1	وَضْعِ اللّغَةِ
u'وَضْعٌ لُغَةٌ':Added, #1: 1	وَضْعِ لُغَاتِ
u'وَضْعٌ لُغَةٌ':Added, #1: 1	وَضْعُ لُغَةٍ
u'وَضْعٌ لُغَةٌ':Added, #3: 3	وَضْعَ اللُّغَةِ
u'وَضَعَ لَفْظٌ':Predicate, #6: 6	وَضْعُ اللُّغَةِ
u'وَضَعَ لَفْظٌ':Predicate, #2: 2	وَضَعَ اللَّفْظَ
u'وَضْعٌ لَفْظٌ':Added, #2: 2	وَضَعَ لَفْظَ
u'وَضْعٌ لَفْظٌ':Added, #1: 1	وَضْعَ اللَّفْظَيْنِ
u'وَضْعٌ لَفْظٌ':Added, #1: 1	وَضْعُ لَفْظٍ
u'وَضْعٌ لَفْظٌ':Added, #1: 1	وَضْعُ لَفْظِهِ
u'وَضْعٌ لَفْظٌ':Added, #1: 1	وَضْعِ لَفْظِهِ
u'وَضْعٌ لَفْظٌ':Added, #20: 20	وَضْعِ اللَّفْظِ
u'وَضْعٌ لَفْظٌ':Added, #2: 2	وَضْعَ لَفْظِهِ
u'وَضْعٌ لَفْظٌ':Added, #3: 3	وَضْعَ اللَّفْظِ
u'وَضْعٌ لَفْظٌ':Added, #4: 4	وَضْعَ لَفْظٍ
u'وَضْعٌ لَفْظٌ':Added, #4: 4	وَضْعِ لَفْظِ
u'وَضْعٌ لُقْمَةٌ':Added, #7: 7	وَضْعُ اللَّفْظِ
u'وَضَعَ مَاءٌ':Predicate, #1: 1	وَضْعِ اللُّقْمَةِ
u'وَضْعٌ مَاءٌ':Added, #1: 1	وَضَعَ الْمَاءَ
u'وَضْعٌ مَاءٌ':Added, #1: 1	وَضْعِ الْمَاءِ
u'وَضَعَ مَارٌّ':Subject, #7: 7	وَضْعُ الْمَاءِ
u'وَضَعَ مَالٌ':Predicate, #2: 2	وَضَعَ الْمَارُّ
u'وَضْعٌ مَالٌ':Added, #3: 3	وَضَعَ الْمَالَ
u'وَضْعٌ مَالٌ':Added, #1: 1	وَضْعَ الْمَالِ
u'وَضْعٌ مَالٌ':Added, #1: 1	وَضْعُ مَالِ
u'وَضَعَ مَالِكٌ':Subject, #1: 1	وَضْعَ مَالِهِ
u'وَضْعٌ مَبْسُوطٌ':Added, #1: 1	وَضَعَ الْمَالِكُ
u'وَضْعٌ مَبْسُوطٌ':Added, #1: 1	وَضْعَ الْمَبْسُوطِ
u'وَضْعٌ مَبْسُوطٌ':Added, #1: 1	وَضْعُ الْمَبْسُوطِ
u'وَضْعٌ مَبِيعٌ':Added, #1: 1	وَضْعِ الْمَبْسُوطِ
u'وَضْعٌ مَتَاعٌ':Added, #1: 1	وَضْعِ الْمَبِيعِ
u'وَضْعٌ مُتَكَلِّمٌ':Added, #1: 1	وَضْعِ مَتَاعِهِ
u'وَضَعَ مثل':Predicate, #1: 1	وَضْعِ الْمُتَكَلِّمِ
u'وَضَعَ مِثْلٌ':Predicate, #2: 2	وَضَعَ مِثْلَ
u'وَضْعٌ مثل':Added, #2: 2	وَضَعَ مِثْلَ
u'وَضْعٌ مِثْلٌ':Added, #1: 1	وَضْعُ مِثْلِهِ
u'وَضْعٌ مَجَازٌ':Added, #1: 1	وَضْعُ مِثْلِهِ
u'وَضْعٌ مَجَازٌ':Added, #3: 3	وَضْعُ الْمَجَازِ
u'وَضَعَ مُحَمَّدٌ':Subject, #4: 4	وَضْعِ الْمَجَازِ
u'وَضْعٌ مُحَمَّدٌ':Added, #3: 3	وَضَعَ مُحَمَّدٌ
u'وَضْعٌ مَدَارِسُ':Added, #1: 1	وَضْعُ مُحَمَّدٍ
u'وَضْعٌ مَدْرَسَةٌ':Added, #1: 1	وَضْعَ الْمَدَارِسِ
u'وَضْعٌ مُرْتَهَنٌ':Added, #1: 1	وَضْعَ الْمَدْرَسَةِ
u'وَضْعٌ مِرْفَقٌ':Added, #1: 1	وَضْعِ الْمُرْتَهَنِ
u'وَضْعٌ مُرَكَّبٌ':Added, #1: 1	وَضْعِ الْمِرْفَقِ
u'وَضْعٌ مُرَكَّبَاتٌ':Added, #1: 1	وَضْعِ الْمُرَكَّبَاتِ
u'وَضْعٌ مَرْهُونٌ':Added, #1: 1	وَضْعِ الْمُرَكَّبَاتِ
u'وَضَعَ مُسَافِرٌ':Subject, #1: 1	وَضْعِ الْمَرْهُونِ
u'وَضَعَ مَسْأَلَةٌ':Predicate, #1: 1	وَضَعَ الْمُسَافِرُ
u'وَضْعٌ مَسْأَلَةٌ':Added, #28: 28	وَضَعَ الْمَسْأَلَةَ
u'وَضْعٌ مَسْأَلَةٌ':Added, #17: 17	وَضْعِ الْمَسْأَلَةِ
u'وَضْعٌ مَسْأَلَةٌ':Added, #18: 18	وَضْعَ الْمَسْأَلَةِ
u'وَضْعٌ مَسْأَلَةٌ':Added, #1: 1	وَضْعُ مَسْأَلَةِ
u'وَضْعٌ مَسْأَلَةٌ':Added, #1: 1	وَضْعِ مَسْأَلَةٍ
u'وَضْعٌ مُسْتَأْجِرٌ':Added, #22: 22	وَضْعُ الْمَسْأَلَةِ
u'وَضَعَ مُسْتَعَارٌ':Predicate, #1: 1	وَضْعِ الْمُسْتَأْجِرِ
u'وَضَعَ مُسْتَعِيرٌ':Subject, #1: 1	وَضَعَ الْمُسْتَعَارَ
u'وَضْعٌ مُشْتَرَكٌ':Added, #1: 1	وَضَعَ الْمُسْتَعِيرُ
u'وَضْعٌ مَصَاحِفُ':Added, #1: 1	وَضْعُ الْمُشْتَرَكِ
u'وَضْعٌ مُصْحَفٌ':Added, #1: 1	وَضْعُ الْمَصَاحِفِ
u'وَضْعٌ مُصْحَفٌ':Added, #1: 1	وَضْعِ الْمُصْحَفِ
u'وَضْعٌ مَصْدَرٌ':Added, #2: 2	وَضْعُ الْمُصْحَفِ
u'وَضْعٌ مُضَرَّبٌ':Added, #1: 1	وَضْعُ الْمَصْدَرِ
u'وَضْعٌ مُضَرَّبَةٌ':Added, #1: 1	وَضْعُ مُضَرَّبَةٍ
u'وَضْعٌ مُطْلَقٌ':Added, #1: 1	وَضْعُ مُضَرَّبَةٍ
u'وَضْعٌ مُظْهَرٌ':Added, #2: 2	وَضْعِ الْمُطْلَقِ
u'وَضْعٌ مَعْرُوفٌ':Added, #1: 1	وَضْعِ الْمُظْهَرِ
u'وَضْعٌ مِفْتَاحٌ':Added, #1: 1	وَضْعِ الْمَعْرُوفِ
u'وَضَعَ مُفْرَدٌ':Predicate, #2: 2	وَضْعَ الْمِفْتَاحِ
u'وَضْعٌ مُفْرَدٌ':Added, #1: 1	وَضَعَ الْمُفْرَدَ
u'وَضْعٌ مُفْرَدٌ':Added, #1: 1	وَضْعِ الْمُفْرَدِ
u'وَضْعٌ مَقَامٌ':Added, #2: 2	وَضْعِ الْمُفْرَدَاتِ
u'وَضَعَ مَقْصُورٌ':Predicate, #1: 1	وَضْعَ مَقَامِ
u'وَضْعٌ مُكُوسٌ':Added, #1: 1	وَضَعَ الْمَقْصُورَ
u'وَضْعٌ ملح':Added, #1: 1	وَضْعُ الْمُكُوسِ
u'وَضْعٌ مِلْحٌ':Added, #1: 1	وَضْعُ الْمِلْحِ
u'وَضَعَ مَلَكٌ':Subject, #1: 1	وَضْعُ الْمِلْحِ
u'وَضْعٌ مَمْلَحَةٌ':Added, #1: 1	وَضَعَ مَلَكٌ
u'وَضْعٌ مَمْلَحَةٌ':Added, #1: 1	وَضْعُ الْمَمْلَحَةِ
u'وَضْعٌ مِنْبَرٌ':Added, #2: 2	وَضْعِ الْمَمْلَحَةِ
u'وَضْعٌ مَنْدُوبٌ':Added, #1: 1	وَضْعُ مِنْبَرِهِ
u'وَضْعٌ مِنْقَارٌ':Added, #1: 1	وَضْعُ الْمَنْدُوبِ
u'وَضْعٌ مَنْقُولٌ':Added, #1: 1	وَضْعُ الْمِنْقَارِ
u'وَضَعَ مَوْضُوعٌ':Predicate, #2: 2	وَضْعَ الْمَنْقُولِ
u'وَضَعَ مَوْضُوعٌ':Predicate, #1: 1	وَضَعَ الْمَوْضُوعَ
u'وَضْعٌ مَوْضُوعٌ':Added, #1: 1	وَضَعَ مَوْضُوعَ
u'وَضَعَ مِيزَانٌ':Predicate, #1: 1	وَضْعِ مَوْضُوعٍ
u'وَضَعَ نَاسٌ':Subject, #1: 1	وَضَعَ الْمِيزَانَ
u'وَضَعَ نَبِيٌّ':Subject, #2: 2	وَضَعَ النَّاسُ
u'وَضْعٌ نَجَاسَةٌ':Added, #1: 1	وَضَعَ النَّبِيُّ
u'وَضْعٌ نَجَاسَةٌ':Added, #1: 1	وَضْعُ النَّجَاسَةِ
u'وَضْعٌ نُحَاسٌ':Added, #1: 1	وَضْعِ النَّجَاسَةِ
u'وَضْعٌ نَحْوٌ':Added, #1: 1	وَضْعِ النُّحَاسِ
u'وَضْعٌ نُطْقٌ':Added, #1: 1	وَضْعُ نَحْوِ
u'وَضَعَ نَظَرٌ':Predicate, #1: 1	وَضْعِ النُّطْقِ
u'وَضْعٌ نَعْشٌ':Added, #2: 2	وَضَعَ النَّظَرَ
u'وَضْعٌ واحد':Added, #1: 1	وَضْعِ النَّعْشِ
u'وَضْعٌ وَاحِدٌ':Added, #1: 1	وَضْعُ الْوَاحِدِ
u'وَضْعٌ واحد':Added, #1: 1	وَضْعُ الْوَاحِدِ
u'وَضْعٌ وَاحِدٌ':Added, #1: 1	وَضْعٍ وَاحِدٍ
u'وَضْعٌ واحد':Added, #1: 1	وَضْعٍ وَاحِدٍ
u'وَضْعٌ وَاحِدٌ':Added, #1: 1	وَضْعُ وَاحِدَةٍ
u'وَضَعَ وَاضِعٌ':Subject, #1: 1	وَضْعُ وَاحِدَةٍ
u'وَضْعٌ وَاضِعٌ':Added, #1: 1	وَضَعَ الْوَاضِعُ
u'وَضَعَ وَجْهٌ':Predicate, #1: 1	وَضْعُ وَاضِعِ
u'وَضْعٌ وَجْهٌ':Added, #1: 1	وَضَعَ الْوَجْهَ
u'وَضْعٌ وَجْهٌ':Added, #1: 1	وَضْعِ الْوَجْهِ
u'وَضَعَ وَدِيعٌ':Predicate, #1: 1	وَضْعِ وَجْهِهِ
u'وَضَعَ وَدِيعَةٌ':Predicate, #7: 7	وَضَعَ الْوَدِيعَةَ
u'وَضْعٌ وُرُودٌ':Added, #7: 7	وَضَعَ الْوَدِيعَةَ
u'وَضْعٌ وسط':Added, #1: 1	وَضْعُ الْوُرُودِ
u'وَضْعٌ وَسَطٌ':Added, #2: 2	وَضْعُ وَسَطِ
u'وَضْعٌ وِصَايَةٌ':Added, #2: 2	وَضْعُ وَسَطِ
u'وَضْعٌ وَقَائِعُ':Added, #1: 1	وَضْعَ الْوِصَايَةِ
u'وَضَعَ وَقْفٌ':Predicate, #1: 1	وَضْعِ الْوَقَائِعِ
u'وَضْعٌ وَقْفٌ':Added, #1: 1	وَضَعَ الْوَقْفَ
u'وَضَعَ وَكِيلٌ':Subject, #1: 1	وَضْعَ الْوَقْفِ
u'وَضَعَ ولد':Subject, #1: 1	وَضَعَ الْوَكِيلُ
u'وَضَعَ وَلَدٌ':Subject, #1: 1	وَضَعَ وَلَدُ
u'وَضَعَ ولد':Subject, #1: 1	وَضَعَ وَلَدُ
u'وَضَعَ وَلَدٌ':Subject, #1: 1	وَضَعَ وَلَدُهُ
u'وَضْعٌ ولد':Added, #1: 1	وَضَعَ وَلَدُهُ
u'وَضْعٌ وَلَدٌ':Added, #1: 1	وَضْعَ الْوَلَدِ
u'وَضْعٌ ولد':Added, #1: 1	وَضْعَ الْوَلَدِ
u'وَضْعٌ وَلَدٌ':Added, #2: 2	وَضْعِ الْوَلَدِ
u'وَضَعَ يَدٌ':Predicate, #2: 2	وَضْعِ الْوَلَدِ
u'وَضْعٌ يَدٌ':Added, #1: 1	وَضَعَ الْيَدَ
u'وَضْعٌ يَدٌ':Added, #10: 10	وَضْعِ الْيَدَيْنِ
u'وَضْعٌ يَدٌ':Added, #11: 11	وَضْعُ الْيَدِ
u'وَضْعٌ يَدٌ':Added, #13: 13	وَضْعُ يَدِهِ
u'وَضْعٌ يَدٌ':Added, #14: 14	وَضْعِ يَدِهِ
u'وَضْعٌ يَدٌ':Added, #19: 19	وَضْعِ الْيَدِ
u'وَضْعٌ يَدٌ':Added, #1: 1	وَضْع الْيَدِ
u'وَضْعٌ يَدٌ':Added, #2: 2	وَضْعِ يَدِ
u'وَضْعٌ يَدٌ':Added, #4: 4	وَضْعَ الْيَدِ
u'وَضْعٌ يَدٌ':Added, #4: 4	وَضْعَ الْيَدَيْنِ
u'وَضْعٌ يَمِينٌ':Added, #4: 4	وَضْعُ الْيَدَيْنِ
u'وَضْعٌ يَمِينٌ':Added, #1: 1	وَضْعِ الْيَمِينِ
u'وَضْعٌ يَمِينٌ':Added, #4: 4	وَضْعَ الْيَمِينِ
u'وَطْءٌ أَبٌ':Added, #5: 5	وَضْعُ الْيَمِينِ
u'وَطْءٌ أَبٌ':Added, #1: 1	وَطْءَ الْأَبِ
u'وَطْءٌ أَبٌ':Added, #1: 1	وَطْءُ الْأَبِ
u'وَطْءٌ اِبْنٌ':Added, #5: 5	وَطْءِ الْأَبِ
u'وَطْءٌ أَجْنَبِيٌّ':Added, #1: 1	وَطْءِ ابْنِهِ
u'وَطْءٌ أَجْنَبِيٌّ':Added, #1: 1	وَطْء الْأَجْنَبِيِّ
u'وَطْءٌ أَجْنَبِيٌّ':Added, #1: 1	وَطْءُ الْأَجْنَبِيِّ
u'وَطْءٌ أَجْنَبِيٌّ':Added, #2: 2	وَطْءِ أَجْنَبِيٍّ
u'وَطْءٌ أَجْنَبِيٌّ':Added, #2: 2	وَطْءِ أَجْنَبِيَّةٍ
u'وَطْءٌ إِحْلاَلٌ':Added, #3: 3	وَطْءَ الْأَجْنَبِيَّةِ
u'وَطْءٌ أَرْبَعُ':Added, #2: 2	وَطْءِ الْإِحْلَالِ
u'وَطْءٌ الْمَرْأَةُ':Added, #4: 4	وَطْءِ الْأَرْبَعِ
u'وَطْءٌ الْمَرْأَةُ':Added, #2: 2	وَطْءِ الْمَرْأَةِ
u'وَطْءٌ أُمٌّ':Added, #3: 3	وَطْءُ الْمَرْأَةِ
u'وَطْءٌ إمَاءٌ':Added, #4: 4	وَطْءُ أُمِّ
u'وَطْءٌ إمَامٌ':Added, #1: 1	وَطْءِ إمَاءِ
u'وَطْءٌ أمَةٌ':Added, #1: 1	وَطْءُ الْإِمَامِ
u'وَطْءٌ أمَةٌ':Added, #13: 13	وَطْءِ الْأَمَةِ
u'وَطْءٌ أمَةٌ':Added, #1: 1	وَطْءَ أَمَةِ
u'وَطْءٌ أمَةٌ':Added, #2: 2	وَطْءِ أَمَةٍ
u'وَطْءٌ أمَةٌ':Added, #2: 2	وَطْءِ أَمَةِ
u'وَطْءٌ أمَةٌ':Added, #2: 2	وَطْءَ أَمَتِهِ
u'وَطْءٌ أمَةٌ':Added, #3: 3	وَطْءُ أَمَةٍ
u'وَطْءٌ أمَةٌ':Added, #3: 3	وَطْءُ أَمَةِ
u'وَطْءٌ أمَةٌ':Added, #5: 5	وَطْءُ أَمَتِهِ
u'وَطْءٌ أمَةٌ':Added, #6: 6	وَطْءَ الْأَمَةِ
u'وَطْءٌ أمَةٌ':Added, #9: 9	وَطْءُ الْأَمَةِ
u'وَطْءٌ اِمْرَأَةٌ':Added, #9: 9	وَطْءِ أَمَتِهِ
u'وَطْءٌ اِمْرَأَةٌ':Added, #1: 1	وَطْءُ امْرَأَةٍ
u'وَطْءٌ اِمْرَأَةٌ':Added, #1: 1	وَطْءَ امْرَأَتِهِ
u'وَطْءٌ اِمْرَأَةٌ':Added, #1: 1	وَطْءُ امْرَأَتِهِ
u'وَطْءٌ اِمْرَأَةٌ':Added, #2: 2	وَطْءَ امْرَأَةٍ
u'وَطْءٌ اِمْرَأَةٌ':Added, #2: 2	وَطْءِ امْرَأَةٍ
u'وَطْءٌ أهْلٌ':Added, #5: 5	وَطْءِ امْرَأَتِهِ
u'وَطْءٌ أَوَّلُ':Added, #1: 1	وَطْءِ أَهْلِ
u'وَطْءٌ باقِي':Added, #2: 2	وَطْءِ الْأَوَّلِ
u'وَطْءٌ باقِي':Added, #1: 1	وَطْءُ الْبَاقِيَةِ
u'وَطْءٌ باقِيَةٌ':Added, #1: 1	وَطْءِ الْبَاقِيَةِ
u'وَطْءٌ باقِيَةٌ':Added, #1: 1	وَطْءُ الْبَاقِيَةِ
u'وَطْءٌ بالِغٌ':Added, #1: 1	وَطْءِ الْبَاقِيَةِ
u'وَطْءٌ بَائِعٌ':Added, #2: 2	وَطْءِ الْبَالِغِ
u'وَطْءٌ بَائِعٌ':Added, #1: 1	وَطْءَ الْبَائِعِ
u'وَطْءٌ بَائِعٌ':Added, #1: 1	وَطْءِ بَائِعٍ
u'وَطْءٌ بَائِعٌ':Added, #2: 2	وَطْءِ بَائِعِهِ
u'وَطْءٌ بِكْرٌ':Added, #6: 6	وَطْءِ الْبَائِعِ
u'وَطْءٌ بِنْتٌ':Added, #1: 1	وَطْءِ الْبِكْرِ
u'وَطْءٌ بِنْتٌ':Added, #1: 1	وَطْءُ بِنْتِ
u'وَطْءٌ بِنْتٌ':Added, #1: 1	وَطْءِ بِنْتِ
u'وَطْءٌ بَهيمٌ':Added, #1: 1	وَطْءَ بِنْتِهِ
u'وَطْءٌ بَهيمٌ':Added, #1: 1	وَطْءَ الْبَهِيمَةِ
u'وَطْءٌ بَهيمٌ':Added, #1: 1	وَطْءُ الْبَهِيمَةِ
u'وَطْءٌ بَهِيمَةٌ':Added, #2: 2	وَطْءِ الْبَهِيمَةِ
u'وَطْءٌ بَهِيمَةٌ':Added, #1: 1	وَطْءَ الْبَهِيمَةِ
u'وَطْءٌ بَهِيمَةٌ':Added, #1: 1	وَطْءُ الْبَهِيمَةِ
u'وَطْءٌ ثَالِثٌ':Added, #2: 2	وَطْءِ الْبَهِيمَةِ
u'وَطْءٌ ثَانِي':Added, #2: 2	وَطْءُ الثَّالِثَةِ
u'وَطْءٌ ثَانِي':Added, #1: 1	وَطْءَ الثَّانِيَةِ
u'وَطْءٌ ثَانِي':Added, #1: 1	وَطْءُ الثَّانِيَةِ
u'وَطْءٌ ثَانِيَةٌ':Added, #2: 2	وَطْءِ الثَّانِيَةِ
u'وَطْءٌ ثَانِيَةٌ':Added, #1: 1	وَطْءَ الثَّانِيَةِ
u'وَطْءٌ ثَانِيَةٌ':Added, #1: 1	وَطْءُ الثَّانِيَةِ
u'وَطْءٌ ثَيِّبٌ':Added, #2: 2	وَطْءِ الثَّانِيَةِ
u'وَطْءٌ ثَيِّبٌ':Added, #1: 1	وَطْءَ الثَّيِّبِ
u'وَطْءٌ ثَيِّبٌ':Added, #1: 1	وَطْءَ ثَيِّبٍ
u'وَطْءٌ ثَيِّبٌ':Added, #2: 2	وَطْءُ الثَّيِّبِ
u'وَطْءٌ جَارِي':Added, #4: 4	وَطْءِ الثَّيِّبِ
u'وَطْءٌ جَارِي':Added, #1: 1	وَطْءُ جَارِيَتِهِ
u'وَطْءٌ جَارِي':Added, #1: 1	وَطْءِ جَارِيَتِهِ
u'وَطْءٌ جَارِي':Added, #2: 2	وَطْءَ الْجَارِيَةِ
u'وَطْءٌ جَارِي':Added, #2: 2	وَطْءُ جَارِيَةٍ
u'وَطْءٌ جَارِي':Added, #5: 5	وَطْءِ جَارِيَةِ
u'وَطْءٌ جَارِي':Added, #6: 6	وَطْءُ الْجَارِيَةِ
u'وَطْءٌ جَارِي':Added, #6: 6	وَطْءِ الْجَارِيَةِ
u'وَطْءٌ جَارِيَةٌ':Added, #9: 9	وَطْءُ جَارِيَةِ
u'وَطْءٌ جَارِيَةٌ':Added, #1: 1	وَطْءُ جَارِيَتِهِ
u'وَطْءٌ جَارِيَةٌ':Added, #1: 1	وَطْءِ جَارِيَتِهِ
u'وَطْءٌ جَارِيَةٌ':Added, #2: 2	وَطْءَ الْجَارِيَةِ
u'وَطْءٌ جَارِيَةٌ':Added, #2: 2	وَطْءُ جَارِيَةٍ
u'وَطْءٌ جَارِيَةٌ':Added, #5: 5	وَطْءِ جَارِيَةِ
u'وَطْءٌ جَارِيَةٌ':Added, #6: 6	وَطْءُ الْجَارِيَةِ
u'وَطْءٌ جَارِيَةٌ':Added, #6: 6	وَطْءِ الْجَارِيَةِ
u'وَطْءٌ جَاهِلٌ':Added, #9: 9	وَطْءُ جَارِيَةِ
u'وَطْءٌ جَمِيع':Added, #2: 2	وَطْءِ الْجَاهِلِ
u'وَطْءٌ جِنٌّ':Added, #1: 1	وَطْءُ الْجَمِيعِ
u'وَطْءٌ جِنِّيٌّ':Added, #1: 1	وَطْءُ الْجِنِّيَّةِ
u'وَطْءٌ حاصِلٌ':Added, #1: 1	وَطْءُ الْجِنِّيَّةِ
u'وَطْءٌ حامِلٌ':Added, #1: 1	وَطْءٍ حَاصِلٍ
u'وَطْءٌ حائِضٌ':Added, #1: 1	وَطْءِ الْحَامِلِ
u'وَطْءٌ حائِضٌ':Added, #18: 18	وَطْءِ الْحَائِضِ
u'وَطْءٌ حائِضٌ':Added, #1: 1	وَطْءَ الْحَائِضِ
u'وَطْءٌ حائِضٌ':Added, #3: 3	وَطْءِ حَائِضٍ
u'وَطْءٌ حُرٌّ':Added, #7: 7	وَطْءُ الْحَائِضِ
u'وَطْءٌ حُرٌّ':Added, #1: 1	وَطْءُ الْحُرَّةِ
u'وَطْءٌ حُرٌّ':Added, #1: 1	وَطْءِ الْحُرَّةِ
u'وَطْءٌ حَرامٌ':Added, #2: 2	وَطْءِ الْحُرِّ
u'وَطْءٌ حَرامٌ':Added, #1: 1	وَطْءَ الْحَرَامِ
u'وَطْءٌ حَرامٌ':Added, #1: 1	وَطْءُ الْحَرَامِ
u'وَطْءٌ حَرامٌ':Added, #1: 1	وَطْءِ الْحَرَامِ
u'وَطْءٌ حَلالٌ':Added, #8: 8	وَطْءٍ حَرَامٍ
u'وَطْءٌ حَلالٌ':Added, #1: 1	وَطْءُ الْحَلَالِ
u'وَطْءٌ حَلِيلَةٌ':Added, #1: 1	وَطْءٍ حَلَالٍ
u'وَطْءٌ حَلِيلَةٌ':Added, #1: 1	وَطْءِ الْحَلِيلَةِ
u'وَطْءٌ خَصِيٌّ':Added, #1: 1	وَطْءَ حَلِيلَتِهِ
u'وَطْءٌ دَابَّةٌ':Added, #1: 1	وَطْءُ الْخَصِيِّ
u'وَطْءٌ دَارٌ':Added, #1: 1	وَطْءُ الدَّابَّةِ
u'وَطْءٌ دونٌ':Added, #1: 1	وَطْءِ دَارٍ
u'وَطْءٌ رابع':Added, #1: 1	وَطْءِ دُونِ
u'وَطْءٌ رابع':Added, #1: 1	وَطْءُ الرَّابِعَةِ
u'وَطْءٌ رَابِعٌ':Added, #1: 1	وَطْءِ الرَّابِعَةِ
u'وَطْءٌ رَابِعٌ':Added, #1: 1	وَطْءُ الرَّابِعَةِ
u'وَطْءٌ رَاهِنٌ':Added, #1: 1	وَطْءِ الرَّابِعَةِ
u'وَطْءٌ رَاهِنٌ':Added, #1: 1	وَطْءُ الرَّاهِنِ
u'وَطْءٌ رَجْعِيٌّ':Added, #1: 1	وَطْءِ الرَّاهِنِ
u'وَطْءٌ رَجْعِيٌّ':Added, #2: 2	وَطْءُ الرَّجْعِيَّةِ
u'وَطْءٌ رَجْعِيَّةٌ':Added, #2: 2	وَطْءِ الرَّجْعِيَّةِ
u'وَطْءٌ رَجْعِيَّةٌ':Added, #2: 2	وَطْءُ الرَّجْعِيَّةِ
u'وَطْءٌ رَجُلٌ':Added, #2: 2	وَطْءِ الرَّجْعِيَّةِ
u'وَطْءٌ رَجُلٌ':Added, #1: 1	وَطْءَ الرَّجُلِ
u'وَطْءٌ زَوْجٌ':Added, #6: 6	وَطْءُ الرَّجُلِ
u'وَطْءٌ زَوْجٌ':Added, #1: 1	وَطْءَ زَوْجٍ
u'وَطْءٌ زَوْجٌ':Added, #1: 1	وَطْءُ زَوْجٍ
u'وَطْءٌ زَوْجٌ':Added, #2: 2	وَطْءَ الزَّوْجِ
u'وَطْءٌ زَوْجٌ':Added, #2: 2	وَطْءُ الزَّوْجِ
u'وَطْءٌ زَوْجَةٌ':Added, #6: 6	وَطْءِ الزَّوْجِ
u'وَطْءٌ زَوْجَةٌ':Added, #11: 11	وَطْءِ زَوْجَتِهِ
u'وَطْءٌ زَوْجَةٌ':Added, #14: 14	وَطْءُ زَوْجَتِهِ
u'وَطْءٌ زَوْجَةٌ':Added, #1: 1	وَطْءِ زَوْجَاتِهِ
u'وَطْءٌ زَوْجَةٌ':Added, #1: 1	وَطْءُ زَوْجَةٍ
u'وَطْءٌ زَوْجَةٌ':Added, #1: 1	وَطْءِ زَوْجَةٍ
u'وَطْءٌ زَوْجَةٌ':Added, #2: 2	وَطْءَ زَوْجَتِهِ
u'وَطْءٌ زَوْجَةٌ':Added, #4: 4	وَطْءِ زَوْجَةِ
u'وَطْءٌ سَادَاتٌ':Added, #5: 5	وَطْءِ الزَّوْجَةِ
u'وَطْءٌ سَيِّدٌ':Added, #1: 1	وَطْءِ السَّادَاتِ
u'وَطْءٌ سَيِّدٌ':Added, #1: 1	وَطْءُ السَّيِّدِ
u'وَطْءٌ شُبْهَةٌ':Added, #1: 1	وَطْءِ السَّيِّدِ
u'وَطْءٌ شُبْهَةٌ':Added, #1: 1	وَطْء الشُّبْهَةِ
u'وَطْءٌ شُبْهَةٌ':Added, #1: 1	وَطْءٍ شُبْهَةٍ
u'وَطْءٌ شُبْهَةٌ':Added, #1: 1	وَطْءِ شُبْهَةِ
u'وَطْءٌ شُبْهَةٌ':Added, #23: 23	وَطْءِ الشُّبْهَةِ
u'وَطْءٌ شُبْهَةٌ':Added, #2: 2	وَطْءُ شُبْهَةٍ
u'وَطْءٌ شُبْهَةٌ':Added, #3: 3	وَطْءُ الشُّبْهَةِ
u'وَطْءٌ شُبْهَةٌ':Added, #41: 41	وَطْءِ شُبْهَةٍ
u'وَطْءٌ شُبْهَةٌ':Added, #5: 5	وَطْءَ الشُّبْهَةِ
u'وَطْءٌ شَرِيكٌ':Added, #6: 6	وَطْءَ شُبْهَةٍ
u'وَطْءٌ شَيْءٌ':Added, #1: 1	وَطْءُ الشَّرِيكِ
u'وَطْءٌ شَيْءٌ':Added, #1: 1	وَطْءِ الشَّيْءِ
u'وَطْءٌ صَائِمٌ':Added, #2: 2	وَطْءُ شَيْءٍ
u'وَطْءٌ صَبِيٌّ':Added, #3: 3	وَطْءُ الصَّائِمَةِ
u'وَطْءٌ صَبِيٌّ':Added, #1: 1	وَطْءِ الصَّبِيِّ
u'وَطْءٌ صَبِيٌّ':Added, #1: 1	وَطْءِ الصَّبِيَّةِ
u'وَطْءٌ صَبِيٌّ':Added, #1: 1	وَطْءِ صَبِيٍّ
u'وَطْءٌ صَغِيرٌ':Added, #2: 2	وَطْءُ الصَّبِيِّ
u'وَطْءٌ صَغِيرٌ':Added, #1: 1	وَطْءُ صَغِيرَةٍ
u'وَطْءٌ صَغِيرٌ':Added, #4: 4	وَطْءُ الصَّغِيرَةِ
u'وَطْءٌ طِفْلٌ':Added, #5: 5	وَطْءِ الصَّغِيرَةِ
u'وَطْءٌ عَائِدٌ':Added, #1: 1	وَطْءُ الطِّفْلِ
u'وَطْءٌ غَاصِبٌ':Added, #1: 1	وَطْءُ الْعَائِدَةِ
u'وَطْءٌ غانِم':Added, #1: 1	وَطْءِ الْغَاصِبِ
u'وَطْءٌ غَرِيمٌ':Added, #1: 1	وَطْءُ الْغَانِمِ
u'وَطْءٌ غير':Added, #1: 1	وَطْءِ الْغَرِيمِ
u'وَطْءٌ غَيْرٌ':Added, #1: 1	وَطْءِ الْغَيْرِ
u'وَطْءٌ غير':Added, #1: 1	وَطْءِ الْغَيْرِ
u'وَطْءٌ غَيْرٌ':Added, #1: 1	وَطْءَ غَيْرِ
u'وَطْءٌ غير':Added, #1: 1	وَطْءَ غَيْرِ
u'وَطْءٌ غَيْرٌ':Added, #2: 2	وَطْءِ غَيْرِهِ
u'وَطْءٌ غير':Added, #2: 2	وَطْءِ غَيْرِهِ
u'وَطْءٌ غَيْرٌ':Added, #4: 4	وَطْءُ غَيْرِ
u'وَطْءٌ فَاسِدٌ':Added, #4: 4	وَطْءُ غَيْرِ
u'وَطْءٌ فلان':Added, #3: 3	وَطْءٍ فَاسِدٍ
u'وَطْءٌ فُلاَنٌ':Added, #1: 1	وَطْءُ الْغَانِمِ
u'وَطْءٌ قُبُورٌ':Added, #1: 1	وَطْءِ فُلَانٍ
u'وَطْءٌ كَافِرٌ':Added, #2: 2	وَطْءِ الْقُبُورِ
u'وَطْءٌ كِتاب':Added, #2: 2	وَطْءَ الْكَافِرِ
u'وَطْءٌ كِتابَة':Added, #1: 1	وَطْءُ الْكِتَابِيَّةِ
u'وَطْءٌ كِتابِيّ':Added, #1: 1	وَطْءُ الْكِتَابِيَّةِ
u'وَطْءٌ كُفَّارٌ':Added, #1: 1	وَطْءُ الْكِتَابِيَّةِ
u'وَطْءٌ كوافر':Added, #1: 1	وَطْءِ الْكُفَّارِ
u'وَطْءٌ كَوَافِرُ':Added, #3: 3	وَطْءَ الْكَوَافِرِ
u'وَطْءٌ لَيْلٌ':Added, #3: 3	وَطْءَ الْكَوَافِرِ
u'وَطْءٌ مَالِكٌ':Added, #2: 2	وَطْءِ لَيْلٍ
u'وَطْءٌ مَالِكٌ':Added, #1: 1	وَطْءُ الْمَالِكِ
u'وَطْءٌ مَالِكٌ':Added, #1: 1	وَطْءِ الْمَالِكِ
u'وَطْءٌ مُبْتاع':Added, #1: 1	وَطْءِ مَالِكِ
u'وَطْءٌ مَجْنُونٌ':Added, #1: 1	وَطْءِ مُبْتَاعِ
u'وَطْءٌ مَجْنُونٌ':Added, #1: 1	وَطْءُ الْمَجْنُونِ
u'وَطْءٌ مَجْنُونٌ':Added, #1: 1	وَطْءُ الْمَجْنُونَةِ
u'وَطْءٌ مَجُوسِيَّةٌ':Added, #2: 2	وَطْءَ الْمَجْنُونِ
u'وَطْءٌ مُحْرِمٌ':Added, #1: 1	وَطْءِ الْمَجُوسِيّةِ
u'وَطْءٌ مَحْرَمٌ':Added, #1: 1	وَطْءِ الْمُحْرِمِ
u'وَطْءٌ مُحَلِّل':Added, #1: 1	وَطْءِ مَحْرَمٍ
u'وَطْءٌ مُدَبَّرٌ':Added, #1: 1	وَطْءِ الْمُحَلِّلِ
u'وَطْءٌ مُدَبَّرٌ':Added, #1: 1	وَطْءِ الْمُدَبَّرَةِ
u'وَطْءٌ مُدَبَّرٌ':Added, #1: 1	وَطْءُ مُدَبَّرَتِهِ
u'وَطْءٌ مُرْضِعٌ':Added, #2: 2	وَطْءُ الْمُدَبَّرَةِ
u'وَطْءٌ مُرْضِعٌ':Added, #1: 1	وَطْءَ الْمُرْضِعِ
u'وَطْءٌ مَرْهُونٌ':Added, #3: 3	وَطْءُ الْمُرْضِعِ
u'وَطْءٌ مَرْهُونٌ':Added, #1: 1	وَطْءُ مَرْهُونَةٍ
u'وَطْءٌ مُسْلِمٌ':Added, #3: 3	وَطْءِ الْمَرْهُونَةِ
u'وَطْءٌ مُسْلِمٌ':Added, #1: 1	وَطْءَ الْمُسْلِمِ
u'وَطْءٌ مُسْلِمٌ':Added, #1: 1	وَطْءُ الْمُسْلِمِ
u'وَطْءٌ مُسْلِمٌ':Added, #1: 1	وَطْءِ الْمُسْلِمِ
u'وَطْءٌ مُسْلِمٌ':Added, #1: 1	وَطْءِ الْمُسْلِمَةِ
u'وَطْءٌ مُسْلِمٌ':Added, #1: 1	وَطْءُ مُسْلِمٍ
u'وَطْءٌ مُشْتَرَكٌ':Added, #2: 2	وَطْءُ الْمُسْلِمَةِ
u'وَطْءٌ مُشْتَهاة':Added, #1: 1	وَطْءَ الْمُشْتَرَكَةِ
u'وَطْءٌ مُطَلَّقٌ':Added, #1: 1	وَطْءَ الْمُشْتَهَاةِ
u'وَطْءٌ مُعْتَدٌّ':Added, #3: 3	وَطْءِ الْمُطَلَّقَةِ
u'وَطْءٌ مُعْتَدٌّ':Added, #1: 1	وَطْءَ الْمُعْتَدَّةِ
u'وَطْءٌ مُعْتَقٌ':Added, #3: 3	وَطْءِ الْمُعْتَدَّةِ
u'وَطْءٌ مَغْصُوب':Added, #2: 2	وَطْءُ الْمُعْتَقَةِ
u'وَطْءٌ مُقَدَّمٌ':Added, #1: 1	وَطْءِ الْمَغْصُوبَةِ
u'وَطْءٌ مُقَيَّدٌ':Added, #1: 1	وَطْءِ الْمُقَدَّمَاتِ
u'وَطْءٌ مُكَاتَبَةٌ':Added, #1: 1	وَطْءٍ مُقَيَّدٍ
u'وَطْءٌ مُكَاتَبَةٌ':Added, #1: 1	وَطْءُ مُكَاتَبَةٍ
u'وَطْءٌ مُكَاتَبَةٌ':Added, #2: 2	وَطْءَ الْمُكَاتَبَةِ
u'وَطْءٌ مُكَاتَبَةٌ':Added, #2: 2	وَطْءِ مُكَاتَبَتِهِ
u'وَطْءٌ مُكَاتَبَةٌ':Added, #4: 4	وَطْءُ الْمُكَاتَبَةِ
u'وَطْءٌ مُكَاتَبَةٌ':Added, #4: 4	وَطْءِ الْمُكَاتَبَةِ
u'وَطْءٌ مُكْرَهٌ':Added, #4: 4	وَطْءُ مُكَاتَبَتِهِ
u'وَطْءٌ مُكْرَهٌ':Added, #1: 1	وَطْءَ الْمُكْرَهِ
u'وَطْءٌ مُكْرَهٌ':Added, #1: 1	وَطْءُ الْمُكْرَهَةِ
u'وَطْءٌ مُكَلَّفٌ':Added, #2: 2	وَطْءُ الْمُكْرَهِ
u'وَطْءٌ مِلْكٌ':Added, #2: 2	وَطْءُ مُكَلَّفٍ
u'وَطْءٌ مِلْكٌ':Added, #1: 1	وَطْءَ الْمِلْكِ
u'وَطْءٌ مِلْكٌ':Added, #1: 1	وَطْءِ مِلْكِ
u'وَطْءٌ مَمْلُوكٌ':Added, #4: 4	وَطْءِ الْمِلْكِ
u'وَطْءٌ مَنْكُوح':Added, #1: 1	وَطْءُ مَمْلُوكَتِهِ
u'وَطْءٌ مَنْكُوح':Added, #2: 2	وَطْءِ الْمَنْكُوحَةِ
u'وَطْءٌ مَوْقُوفٌ':Added, #3: 3	وَطْءُ الْمَنْكُوحَةِ
u'وَطْءٌ مَوْهُوبٌ':Added, #1: 1	وَطْءُ الْمَوْقُوفِ
u'وَطْءٌ مَيْتٌ':Added, #1: 1	وَطْءِ الْمَوْهُوبِ
u'وَطْءٌ مَيْتَةٌ':Added, #1: 1	وَطْءُ الْمَيْتَةِ
u'وَطْءٌ نَجَاسَةٌ':Added, #1: 1	وَطْءُ الْمَيْتَةِ
u'وَطْءٌ نِساءٌ':Added, #1: 1	وَطْءَ النَّجَاسَةِ
u'وَطْءٌ نِساءٌ':Added, #1: 1	وَطْءَ النِّسَاءِ
u'وَطْءٌ نَصْرَانِيٌّ':Added, #1: 1	وَطْءِ النِّسَاءِ
u'وَطْءٌ نُفَسَاءُ':Added, #1: 1	وَطْءُ نَصْرَانِيٍّ
u'وَطْءٌ نكاح':Added, #1: 1	وَطْءَ النُّفَسَاءِ
u'وَطْءٌ نِكَاحٌ':Added, #1: 1	وَطْءِ نِكَاحٍ
u'وَطْءٌ واحد':Added, #1: 1	وَطْءِ نِكَاحٍ
u'وَطْءٌ واحد':Added, #1: 1	وَطْءٍ وَاحِدٍ
u'وَطْءٌ وَاحِدٌ':Added, #1: 1	وَطْءِ وَاحِدٍ
u'وَطْءٌ وَاحِدٌ':Added, #1: 1	وَطْءٍ وَاحِدٍ
u'وَطْءٌ واحد':Added, #1: 1	وَطْءِ وَاحِدٍ
u'وَطْءٌ وَاحِدٌ':Added, #1: 1	وَطْءَ وَاحِدَةٍ
u'وَطْءٌ واحد':Added, #1: 1	وَطْءَ وَاحِدَةٍ
u'وَطْءٌ وَاحِدٌ':Added, #3: 3	وَطْءُ وَاحِدَةٍ
u'وَطْءٌ واحد':Added, #3: 3	وَطْءُ وَاحِدَةٍ
u'وَطْءٌ وَاحِدٌ':Added, #8: 8	وَطْءِ وَاحِدَةٍ
u'وَطْءٌ وَارِثٌ':Added, #8: 8	وَطْءِ وَاحِدَةٍ
u'وَطْءٌ وَثَنِيٌّ':Added, #1: 1	وَطْءُ الْوَارِثِ
u'وَطْءٌ ولد':Added, #1: 1	وَطْءُ وَثَنِيّةٍ
u'وَطْءٌ وَلَدٌ':Added, #1: 1	وَطْءُ الْوَلَدِ
u'وطأة واحد':Added, #1: 1	وَطْءُ الْوَلَدِ
u'وطأة وَاحِدٌ':Added, #1: 1	وَطْأَةٍ وَاحِدَةٍ
u'وَطْأَةٌ واحد':Added, #1: 1	وَطْأَةٍ وَاحِدَةٍ
u'وَطْأَةٌ وَاحِدٌ':Added, #1: 1	وَطْأَةٍ وَاحِدَةٍ
u'وَطَنَ مَذْكُورٌ':Predicate, #1: 1	وَطْأَةٍ وَاحِدَةٍ
u'وَطُؤَ فِرَاشٌ':Subject, #1: 1	وَطَنَ الْمَذْكُورِينَ
u'وَطِئَ أَبٌ':Subject, #1: 1	وَطُؤَ الْفِرَاشُ
u'وَطِئَ أَبٌ':Subject, #1: 1	وَطِئَ أَبٌ
u'وَطِئَ اِبْنٌ':Subject, #3: 3	وَطِئَ الْأَبُ
u'وَطِئَ أَجْنَبِيٌّ':Predicate, #1: 1	وَطِئَ ابْنُ
u'وَطِئَ أَجْنَبِيٌّ':Predicate, #1: 1	وَطِئَ الْأَجْنَبِيَّةَ
u'وَطِئَ أَجْنَبِيٌّ':Subject, #8: 8	وَطِئَ أَجْنَبِيَّةً
u'وَطِئَ أَجْنَبِيٌّ':Subject, #1: 1	وَطِئَ أَجْنَبِيٌّ
u'وَطِئَ أحَدٌ':Subject, #1: 1	وَطِئَ الْأَجْنَبِيُّ
u'وَطِئَ أُخْتٌ':Predicate, #8: 8	وَطِئَ أَحَدُ
u'وَطِئَ آخِرُ':Subject, #4: 4	وَطِئَ أُخْتَ
u'وَطِئَ أَرْبَعُ':Predicate, #1: 1	وَطِئَ الْآخِرُ
u'وَطِئَ أرْضٌ':Predicate, #1: 1	وَطِئَ الْأَرْبَعَ
u'وَطِئَ الْمَرْأَةُ':Predicate, #1: 1	وَطِئَ أَرْضَ
u'وَطِئَ أُمٌّ':Predicate, #3: 3	وَطِئَ الْمَرْأَةَ
u'وَطِئَ أُمٌّ':Predicate, #2: 2	وَطِئَ الْأُمَّ
u'وَطِئَ أمَةٌ':Predicate, #9: 9	وَطِئَ أُمَّ
u'وَطِئَ أمَةٌ':Predicate, #10: 10	وَطِئَ الْأَمَةَ
u'وَطِئَ أَوَّلُ':Subject, #29: 29	وَطِئَ أَمَةَ
u'وَطِئَ باقِي':Predicate, #1: 1	وَطِئَ أَوَّلُ
u'وَطِئَ باقِيَةٌ':Predicate, #1: 1	وَطِئَ الْبَاقِيَةَ
u'وَطِئَ بالِغٌ':Subject, #1: 1	وَطِئَ الْبَاقِيَةَ
u'وَطِئَ بَائِعٌ':Subject, #1: 1	وَطِئَ الْبَالِغُ
u'وَطِئَ بَائِنٌ':Predicate, #3: 3	وَطِئَ الْبَائِعُ
u'وَطِئَ بَعْضٌ':Predicate, #1: 1	وَطِئَ الْبَائِنَ
u'وَطِئَ بَعيرٌ':Subject, #1: 1	وَطِئَ بَعْضَهُنَّ
u'وَطِئَ بَعيرٌ':Subject, #1: 1	وَطِئَ الْبَعِيرُ
u'وَطِئَ بَعيرٌ':Subject, #1: 1	وَطِئَ بَعِيرُ
u'وَطِئَ بِكْرٌ':Predicate, #4: 4	وَطِئَ بَعِيرٌ
u'وَطِئَ بَيْنٌ':Predicate, #3: 3	وَطِئَ الْبِكْرَ
u'وَطِئَ ثَانِي':Predicate, #1: 1	وَطِئَ بَيْنَ
u'وَطِئَ ثَانِيَةٌ':Predicate, #8: 8	وَطِئَ الثَّانِيَةَ
u'وَطِئَ ثَلاثُ':Predicate, #8: 8	وَطِئَ الثَّانِيَةَ
u'وَطِئَ ثَيِّبٌ':Predicate, #1: 1	وَطِئَ الثَّلَاثَ
u'وَطِئَ جَارِي':Predicate, #1: 1	وَطِئَ الثَّيِّبَ
u'وَطِئَ جَارِي':Predicate, #18: 18	وَطِئَ الْجَارِيَةَ
u'وَطِئَ جَارِي':Predicate, #29: 29	وَطِئَ جَارِيَةً
u'وَطِئَ جَارِيَةٌ':Predicate, #63: 63	وَطِئَ جَارِيَةَ
u'وَطِئَ جَارِيَةٌ':Predicate, #18: 18	وَطِئَ الْجَارِيَةَ
u'وَطِئَ جَائِزٌ':Subject, #63: 63	وَطِئَ جَارِيَةَ
u'وَطِئَ جِنٌّ':Predicate, #2: 2	وَطِئَ جَائِزٌ
u'وَطِئَ جِنِّيٌّ':Predicate, #1: 1	وَطِئَ الْجِنِّيَّةَ
u'وَطِئَ جِنِّيٌّ':Subject, #1: 1	وَطِئَ الْجِنِّيَّةَ
u'وَطِئَ حالٌ':Predicate, #1: 1	وَطِئَ الْجِنِّيُّ
u'وَطِئَ حُرٌّ':Predicate, #1: 1	وَطِئَ حَالَ
u'وَطِئَ حُرٌّ':Subject, #2: 2	وَطِئَ حُرَّةً
u'وَطِئَ حَرْب':Predicate, #2: 2	وَطِئَ حُرٌّ
u'وَطِئَ حَرْبَة':Predicate, #1: 1	وَطِئَ حَرْبِيَّةً
u'وَطِئَ حَرْبِيّ':Predicate, #1: 1	وَطِئَ حَرْبِيَّةً
u'وَطِئَ دونٌ':Predicate, #1: 1	وَطِئَ حَرْبِيَّةً
u'وَطِئَ ذُبابٌ':Predicate, #6: 6	وَطِئَ دُونَ
u'وَطِئَ رَاهِنٌ':Subject, #1: 1	وَطِئَ الذُّبَابَ
u'وَطِئَ رَجُلٌ':Subject, #3: 3	وَطِئَ الرَّاهِنُ
u'وَطِئَ رَجُلٌ':Subject, #11: 11	وَطِئَ الرَّجُلُ
u'وَطِئَ رَقيقٌ':Subject, #1: 1	وَطِئَ رَجُلٌ
u'وَطِئَ رَقيق':Subject, #2: 2	وَطِئَ الرَّقِيقُ
u'وَطِئَ رَوْث':Predicate, #2: 2	وَطِئَ الرَّقِيقُ
u'وَطِئَ زَوْجٌ':Subject, #2: 2	وَطِئَ رَوْثَةً
u'وَطِئَ زَوْجٌ':Subject, #1: 1	وَطِئَ الزَّوْجُ
u'وَطِئَ زَوْجَةٌ':Predicate, #1: 1	وَطِئَ زَوْجُ
u'وَطِئَ سقط':Predicate, #3: 3	وَطِئَ زَوْجَةَ
u'وَطِئَ سَقَطٌ':Predicate, #1: 1	وَطِئَ سَقَطَ
u'وَطِئَ سَيِّدٌ':Subject, #1: 1	وَطِئَ سَقَطَ
u'وَطِئَ شَرِيكٌ':Subject, #4: 4	وَطِئَ السَّيِّدُ
u'وَطِئَ صَائِمٌ':Subject, #1: 1	وَطِئَ شَرِيكُهُ
u'وَطِئَ صَبِيٌّ':Predicate, #1: 1	وَطِئَ الصَّائِمُ
u'وَطِئَ صَغِيرٌ':Predicate, #1: 1	وَطِئَ صَبِيَّةً
u'وَطِئَ صَغِيرٌ':Subject, #2: 2	وَطِئَ صَغِيرَةً
u'وَطِئَ ضَعِيفٌ':Subject, #1: 1	وَطِئَ الصَّغِيرُ
u'وَطِئَ عَالِمٌ':Predicate, #1: 1	وَطِئَ الضّعِيفُ
u'وَطِئَ عَامِلٌ':Subject, #1: 1	وَطِئَ عَالِمَةً
u'وَطِئَ عَبْدٌ':Subject, #3: 3	وَطِئَ الْعَامِلُ
u'وَطِئَ عَبْدٌ':Subject, #1: 1	وَطِئَ عَبْدٌ
u'وَطِئَ غانِم':Subject, #2: 2	وَطِئَ الْعَبْدُ
u'وَطِئَ غُلاَمٌ':Predicate, #1: 1	وَطِئَ غَانِمٌ
u'وَطِئَ غير':Subject, #1: 1	وَطِئَ الْغُلَامَ
u'وَطِئَ غَيْرٌ':Subject, #1: 1	وَطِئَ غَيْرُهُ
u'وَطِئَ فلان':Subject, #1: 1	وَطِئَ غَيْرُهُ
u'وَطِئَ قُرْبٌ':Predicate, #1: 1	وَطِئَ غَانِمٌ
u'وَطِئَ كَافِرٌ':Predicate, #1: 1	وَطِئَ قُرْبَ
u'وَطِئَ كَافِرٌ':Subject, #1: 1	وَطِئَ الْكَافِرَةَ
u'وَطِئَ كُفَّارٌ':Subject, #1: 1	وَطِئَ كَافِرٌ
u'وَطِئَ مَارٌّ':Subject, #1: 1	وَطِئَ الْكُفَّارُ
u'وَطِئَ مَجْنُونٌ':Subject, #1: 1	وَطِئَ الْمَارُّ
u'وَطِئَ مَجُوسِيٌّ':Subject, #1: 1	وَطِئَ الْمَجْنُونُ
u'وَطِئَ مُخَاطَبٌ':Predicate, #1: 1	وَطِئَ مَجُوسِيٌّ
u'وَطِئَ مُخَاطَبَةٌ':Predicate, #1: 1	وَطِئَ الْمُخَاطَبَةَ
u'وَطِئَ مَداس':Predicate, #1: 1	وَطِئَ الْمُخَاطَبَةَ
u'وَطِئَ مَرْبُوط':Subject, #1: 1	وَطِئَ مَدَاسَ
u'وَطِئَ مُرْتَدٌّ':Predicate, #1: 1	وَطِئَ الْمَرْبُوطُ
u'وَطِئَ مُرْتَدٌّ':Subject, #1: 1	وَطِئَ مُرْتَدَّةً
u'وَطِئَ مُرْتَهِنٌ':Subject, #3: 3	وَطِئَ الْمُرْتَدُّ
u'وَطِئَ مُرْضِعٌ':Predicate, #4: 4	وَطِئَ الْمُرْتَهِنُ
u'وَطِئَ مُرْضِعٌ':Predicate, #1: 1	وَطِئَ الْمُرْضِعَةَ
u'وَطِئَ مَرْهُونٌ':Predicate, #1: 1	وَطِئَ مُرْضِعَةَ
u'وَطِئَ مُسْلِمٌ':Predicate, #1: 1	وَطِئَ الْمَرْهُونَةَ
u'وَطِئَ مُسْلِمٌ':Subject, #1: 1	وَطِئَ مُسْلِمَةً
u'وَطِئَ مُسْلِمٌ':Subject, #1: 1	وَطِئَ الْمُسْلِمُ
u'وَطِئَ مُضَارِبٌ':Subject, #2: 2	وَطِئَ مُسْلِمٌ
u'وَطِئَ مُطْلَقٌ':Predicate, #1: 1	وَطِئَ الْمُضَارِبُ
u'وَطِئَ مُطَلَّقٌ':Predicate, #1: 1	وَطِئَ مُطْلَقَ
u'وَطِئَ مُعْتَدٌّ':Predicate, #3: 3	وَطِئَ الْمُطَلَّقَةَ
u'وَطِئَ مُعْتَدٌّ':Predicate, #3: 3	وَطِئَ مُعْتَدَّةً
u'وَطِئَ مُفْلِسٌ':Subject, #4: 4	وَطِئَ الْمُعْتَدَّةَ
u'وَطِئَ مَقْذُوفٌ':Subject, #1: 1	وَطِئَ الْمُفْلِسُ
u'وَطِئَ مُكَاتَبَةٌ':Predicate, #1: 1	وَطِئَ الْمَقْذُوفُ
u'وَطِئَ مِلْكٌ':Predicate, #3: 3	وَطِئَ الْمُكَاتَبَةَ
u'وَطِئَ مَمْلُوكٌ':Predicate, #1: 1	وَطِئَ مِلْكَ
u'وَطِئَ مَنْكُوح':Predicate, #3: 3	وَطِئَ الْمَمْلُوكَةَ
u'وَطِئَ مَوْقُوفٌ':Predicate, #2: 2	وَطِئَ الْمَنْكُوحَةَ
u'وَطِئَ مَوْقُوفٌ':Subject, #1: 1	وَطِئَ الْمَوْقُوفَةَ
u'وَطِئَ واحد':Predicate, #1: 1	وَطِئَ الْمَوْقُوفُ
u'وَطِئَ وَاحِدٌ':Predicate, #11: 11	وَطِئَ وَاحِدَةً
u'وَطِئَ وَارِثٌ':Subject, #11: 11	وَطِئَ وَاحِدَةً
u'وَطِئَ وَاقِفٌ':Subject, #2: 2	وَطِئَ الْوَارِثُ
u'وَطِئَ وَاهِبٌ':Subject, #1: 1	وَطِئَ الْوَاقِفُ
u'وَطِئَ وَطْءٌ':Predicate, #1: 1	وَطِئَ الْوَاهِبُ
u'وَطِئَ وَنِيَّةٌ':Subject, #1: 1	وَطِئَ وَطْءَ
u'وَطِئَ يَوْمٌ':Predicate, #1: 1	وَطِئَ وَنِيَّتُهُ
u'وَظَّفَ إمَامٌ':Subject, #3: 3	وَطِئَ يَوْمَ
u'وَظَّفَ خراج':Predicate, #1: 1	وَظَّفَ الْإِمَامُ
u'وَظَّفَ خَرَاجٌ':Predicate, #1: 1	وَظَّفَ الْخَرَاجَ
u'وَعَبَ كرام':Subject, #1: 1	وَظَّفَ الْخَرَاجَ
u'وَعْثٌ صُفُوفٌ':Added, #1: 1	تَعِبَ الْكِرَامُ
u'وَعَدَ بَائِعٌ':Predicate, #1: 1	وَعْثُ الصّفُوفِ
u'وَعْدٌ حَقٌّ':Added, #1: 1	وَعَدَ الْبَائِعَ
u'وَعَدَ خَلَفٌ':Predicate, #1: 1	وَعْدُ حَقٍّ
u'وَعَدَ رَجُلٌ':Predicate, #1: 1	وَعَدَ خَلَفَ
u'وَعَدَ رَجُلٌ':Subject, #1: 1	وَعَدَ رَجُلاً
u'وَعَدَ رَحْمَن':Subject, #3: 3	وَعَدَ الرَّجُلُ
u'وَعَدَ رَسُولٌ':Subject, #2: 2	وَعَدَ الرَّحْمَنُ
u'وَعَدَ رَسُولٌ':Subject, #1: 1	وَعَدَ الرّسُولُ
u'وَعْدٌ صَادِقٌ':Added, #2: 2	وَعَدَ رَسُولُ
u'وَعَدَ عَبْدٌ':Subject, #1: 1	وَعْدِ الصَّادِقِ
u'وَعَدَ فلان':Subject, #1: 1	وَعَدَ عَبْدُ
u'وَعَدَ قَاعِدٌ':Predicate, #2: 2	وَعَدَ الرَّحْمَنُ
u'وَعَدَ قَالٌ':Predicate, #2: 2	وَعَدَ الْقَاعِدِينَ
u'وَعْدٌ قُرْآنٌ':Added, #1: 1	وَعَدَ قَالَ
u'وَعَدَ قَوْمٌ':Predicate, #1: 1	وَعْدِ الْقُرْآنِ
u'وَعَدَ مَدِينٌ':Subject, #1: 1	وَعَدَ قَوْمَ
u'وَعْدٌ مَغْفِرَةٌ':Added, #1: 1	وَعَدَ الْمَدِينُ
u'وَعْدٌ مَلِكٌ':Added, #2: 2	وَعْدُ الْمَغْفِرَةِ
u'وَعَدَ نَبِيٌّ':Subject, #1: 1	وَعْدُ الْمَلِكِ
u'وَعْدٌ هِبَةٌ':Added, #1: 1	وَعَدَ النَّبِيُّ
u'وَعْدٌ وَاجِبٌ':Added, #1: 1	وَعْدُ هِبَةٍ
u'وَعْظٌ رَسُولٌ':Added, #1: 1	وَعْدٍ وَاجِبٍ
u'وَعَظَ عِبَادٌ':Predicate, #1: 1	وَعْظِ الرّسُولِ
u'وَعَظَ عَوَامُّ':Predicate, #1: 1	وَعَظَ الْعِبَادَ
u'وَعَظَ نَاسٌ':Predicate, #1: 1	وَعَظَ الْعَوَامَّ
u'وَعْظٌ نَاسٌ':Added, #1: 1	وَعَظَ النَّاسَ
u'وَعْظٌ نَاسٌ':Added, #1: 1	وَعْظَ النَّاسِ
u'وَعِيدٌ آخِرَةٌ':Added, #1: 1	وَعْظُ النَّاسِ
u'وَعِيدٌ إِرْهَابٌ':Added, #1: 1	وَعِيدِ الْآخِرَةِ
u'وَعِيدٌ بَارِئٌ':Added, #1: 1	وَعِيدُ إرْهَابٍ
u'وَعِيدٌ حَقٌّ':Added, #1: 1	وَعِيدَ الْبَارِئِ
u'وَعِيدٌ خَمْرٌ':Added, #1: 1	وَعِيدِ الْحَقِّ
u'وَعِيدٌ ذَنْبٌ':Added, #1: 1	وَعِيدُ الْخَمْرِ
u'وَعِيدٌ رَسُولٌ':Added, #1: 1	وَعِيدِ ذَنْبِهِ
u'وَعِيدٌ شَرْعٌ':Added, #1: 1	وَعِيدَ الرَّسُولِ
u'وَعِيدٌ عَذَابٌ':Added, #3: 3	وَعِيدِ الشَّرْعِ
u'وَعِيدٌ غَاصِبٌ':Added, #1: 1	وَعِيدَ عَذَابِ
u'وَعِيدٌ فُسَّاقٌ':Added, #1: 1	وَعِيدِ الْغَاصِبِ
u'وَعِيدٌ فَطِيرٌ':Added, #1: 1	وَعِيدِ الْفُسَّاقِ
u'وَعِيدٌ يَوْمٌ':Added, #1: 1	وَعِيدِ الْفَطِيرِ
u'وَعَى مُجَرَّدٌ':Subject, #1: 1	وَعِيدَ الْيَوْمِ
u'وَغَرٌ صَدْرٌ':Added, #1: 1	وَعَى الْمُجَرَّدُ
u'وَفَاءٌ اِبْنٌ':Added, #1: 1	وَغَرِ الصَّدْرِ
u'وَفَاءٌ إِخْوَانٌ':Added, #1: 1	وَفَاءِ ابْنِ
u'وَفَاءٌ بَعْضٌ':Added, #1: 1	وَفَاءَ الْإِخْوَانِ
u'وَفَاءٌ بَقِيَّةٌ':Added, #1: 1	وَفَاءِ بَعْضِهِ
u'وَفَاءٌ ثَمَنٌ':Added, #1: 1	وَفَاءِ بَقِيَّةِ
u'وَفَاءٌ ثَمَنٌ':Added, #1: 1	وَفَاءِ الثَّمَنِ
u'وَفَاءٌ ثَمَنٌ':Added, #1: 1	وَفَاءِ ثَمَنِهِ
u'وَفَاءٌ حِصَّةٌ':Added, #2: 2	وَفَاءَ الثَّمَنِ
u'وَفَاءٌ حَقٌّ':Added, #1: 1	وَفَاءِ حِصَّتِهِ
u'وَفَاءٌ حَقٌّ':Added, #1: 1	وَفَاءُ الْحَقِّ
u'وَفَاءٌ حَقٌّ':Added, #1: 1	وَفَاءِ الْحَقِّ
u'وَفَاءٌ حُقوقٌ':Added, #1: 1	وَفَاءِ حَقِّهِ
u'وَفَاءٌ حُقُوقٌ':Added, #1: 1	وَفَاءُ الْحُقُوقِ
u'وَفَاءٌ دَيْنٌ':Added, #1: 1	وَفَاءُ الْحُقُوقِ
u'وَفَاءٌ دَيْنٌ':Added, #17: 17	وَفَاءِ دَيْنِهِ
u'وَفَاءٌ دَيْنٌ':Added, #1: 1	وَفَاءَ دَيْنٍ
u'وَفَاءٌ دَيْنٌ':Added, #21: 21	وَفَاءِ الدَّيْنِ
u'وَفَاءٌ دَيْنٌ':Added, #2: 2	وَفَاءُ دَيْنِ
u'وَفَاءٌ دَيْنٌ':Added, #2: 2	وَفَاءُ دَيْنِهِ
u'وَفَاءٌ دَيْنٌ':Added, #3: 3	وَفَاءُ الدَّيْنِ
u'وَفَاءٌ دَيْنٌ':Added, #4: 4	وَفَاءَ الدَّيْنِ
u'وَفَاءٌ دَيْنٌ':Added, #4: 4	وَفَاءِ دَيْنِ
u'وَفَاءٌ دُيونٌ':Added, #4: 4	وَفَاءَ دَيْنِهِ
u'وَفَاءٌ رَجُلٌ':Added, #1: 1	وَفَاءُ الدُّيُونِ
u'وَفَاءٌ رَجُلٌ':Added, #1: 1	وَفَاءَ الرَّجُلِ
u'وَفَاءٌ رَقَبَةٌ':Added, #1: 1	وَفَاءُ الرَّجُلِ
u'وَفَاءٌ شَرَائِطُ':Added, #3: 3	وَفَاءِ الرَّقَبَةِ
u'وَفَاءٌ شَيْءٌ':Added, #1: 1	وَفَاءِ شَرَائِطِ
u'وَفَاءٌ شَيْءٌ':Added, #1: 1	وَفَاءُ شَيْءٍ
u'وَفَاءٌ فِدْيَةٌ':Added, #1: 1	وَفَاءِ شَيْءٍ
u'وَفَاءٌ كَيْلٌ':Added, #1: 1	وَفَاءَ فِدْيَتِهِ
u'وَفَاءٌ كَيْلٌ':Added, #1: 1	وَفَاءَ الْكَيْلِ
u'وَفَاءٌ مَجْلِسٌ':Added, #1: 1	وَفَاءِ الْكَيْلِ
u'وَفَاءٌ مَوْعُودٌ':Added, #1: 1	وَفَاءِ مَجْلِسٍ
u'وَفَاءٌ نَاسٌ':Added, #1: 1	وَفَاءِ الْمَوْعُودِ
u'وَفَاءٌ نُجُومٌ':Added, #1: 1	وَفَاءَ النَّاسِ
u'وَفَاءٌ نذر':Added, #1: 1	وَفَاءِ نُجُومِ
u'وَفَاءٌ نَذْرٌ':Added, #1: 1	وَفَاءَ النَّذْرِ
u'وَفَاءٌ نذر':Added, #1: 1	وَفَاءَ النَّذْرِ
u'وَفَاءٌ نَذْرٌ':Added, #1: 1	وَفَاءُ نَذْرِهِ
u'وَفَاءٌ نُقْصَانٌ':Added, #1: 1	وَفَاءُ نَذْرِهِ
u'وَفَاءٌ وثائق':Added, #1: 1	وَفَاءُ نُقْصَانِ
u'وَفَاءٌ وَثَائِقُ':Added, #1: 1	وَفَاءَ الْوَثَائِقِ
u'وَفَاءٌ وَعْدٌ':Added, #1: 1	وَفَاءَ الْوَثَائِقِ
u'وَفَدَ أهْلٌ':Subject, #1: 1	وَفَاءِ الْوَعْدِ
u'وَفْدٌ أهْلٌ':Added, #1: 1	وَفَدَ أَهْلُ
u'وَفْدٌ أهْلٌ':Added, #1: 1	وَفْدَ أَهْلِ
u'وَفَدَ جَرِيرٌ':Subject, #1: 1	وَفْدُ أَهْلِ
u'وَفَدَ جَرِيرٌ':Subject, #1: 1	وَفَدَ جَرِيرُ
u'وَفْدٌ جِنٌّ':Added, #2: 2	وَفَدَ جَرِيرٌ
u'وَفْدٌ جِنٌّ':Added, #1: 1	وَفْدُ الْجِنِّ
u'وَفَدَ دِمَشْقُ':Predicate, #1: 1	وَفْدُ جِنِّ
u'وَفْدٌ طَائِفٌ':Added, #1: 1	وَفَدَ دِمَشْقَ
u'وَفْدٌ طَائِفٌ':Added, #1: 1	وَفْدُ الطّائِفِ
u'وَفْدٌ عَبْدٌ':Added, #1: 1	وَفْدُ الطَّائِفِ
u'وَفْدٌ عَبْدٌ':Added, #11: 11	وَفْدَ عَبْدِ
u'وَفْدٌ عَبْدٌ':Added, #14: 14	وَفْدِ عَبْدِ
u'وَفْدٌ عِرَاقٌ':Added, #7: 7	وَفْدُ عَبْدِ
u'وَفْدٌ عَرَبٌ':Added, #1: 1	وَفْدُ الْعِرَاقِ
u'وَفْدٌ عَظِيم':Added, #1: 1	وَفْدَ الْعَرَبِ
u'وَفْدٌ فلان':Added, #1: 1	وَفْدٍ عَظِيمٍ
u'وَفْدٌ فلان':Added, #1: 1	وَفْدُ تَمِيمٍ
u'وَفَدَ مِقْدَامٌ':Subject, #1: 1	وَفْدِ تَمِيمٍ
u'وَفْدٌ يَمَامٌ':Added, #2: 2	وَفَدَ الْمِقْدَامُ
u'وَفْدٌ يمن':Added, #1: 1	وَفْدِ الْيَمَامَةِ
u'وَفْدٌ يَمَنُ':Added, #1: 1	وَفْدِ الْيَمَنِ
u'وفر فَوَائِدُ':Added, #1: 1	وَفْدِ الْيَمَنِ
u'وَفْرٌ فَوَائِدُ':Added, #1: 1	وَفْرِ فَوَائِدِ
u'وَفَّرَ نَصِيبٌ':Predicate, #1: 1	وَفْرِ فَوَائِدِ
u'وَفْقٌ اِجْتِهَادٌ':Added, #1: 1	وَفَّرَ نَصِيبَ
u'وَفْقٌ أحَدٌ':Added, #1: 1	وَفْقِ اجْتِهَادِهِ
u'وَفْقٌ أَدَاءٌ':Added, #1: 1	وَفْقِ أَحَدِ
u'وَفْقٌ إِذْنٌ':Added, #1: 1	وَفْقِ الْأَدَاءِ
u'وَفْقٌ إِذْنٌ':Added, #1: 1	وَفْقِ إذْنِ
u'وَفْقٌ إِرَادَةٌ':Added, #1: 1	وَفْقِ الْإِذْنِ
u'وَفْقٌ إِرَادَةٌ':Added, #1: 1	وَفْقِ إرَادَتِهِ
u'وَفْقٌ اِسْتِعْمالٌ':Added, #2: 2	وَفْقِ الْإِرَادَةِ
u'وَفْقٌ أصل':Added, #1: 1	وَفْقِ اسْتِعْمَالِهِ
u'وَفْقٌ أًصْلٌ':Added, #2: 2	وَفْقِ الْأَصْلِ
u'وَفْقٌ أُصولٌ':Added, #2: 2	وَفْقِ الْأَصْلِ
u'وَفْقٌ إِطْلاقٌ':Added, #3: 3	وَفْقِ الْأُصُولِ
u'وَفْقٌ اِعْتِبارٌ':Added, #1: 1	وَفْقُ إطْلَاقِ
u'وَفْقٌ اِعْتِقادٌ':Added, #1: 1	وَفْقِ اعْتِبَارِهِ
u'وَفْقٌ إقْرَارٌ':Added, #1: 1	وَفْقَ اعْتِقَادِهِ
u'وَفْقٌ أَمْرٌ':Added, #1: 1	وَفْقِ الْإِقْرَارِ
u'وَفْقٌ أَنْباءٌ':Added, #1: 1	وَفْقِ أَمْرِهِ
u'وَفْقٌ أَنْبَاءٌ':Added, #2: 2	وَفْقِ الْأَنْبَاءِ
u'وَفَّقَ بَيْنٌ':Predicate, #2: 2	وَفْقِ الْأَنْبَاءِ
u'وَفْقٌ تَرِكَةٌ':Added, #7: 7	وَفَّقَ بَيْنَ
u'وَفْقٌ تَرِكَةٌ':Added, #1: 1	وَفْقَ التَّرِكَةِ
u'وَفْقٌ تَرِكَةٌ':Added, #1: 1	وَفْقِ تَرِكَةِ
u'وَفْقٌ تَصْحِيحٌ':Added, #4: 4	وَفْقِ التَّرِكَةِ
u'وَفْقٌ تَصْحِيحٌ':Added, #1: 1	وَفْقَ التَّصْحِيحِ
u'وَفْقٌ ثَانِي':Added, #3: 3	وَفْقِ التَّصْحِيحِ
u'وَفْقٌ ثَانِي':Added, #1: 1	وَفْقَ الثَّانِيَةِ
u'وَفْقٌ ثَانِيَةٌ':Added, #2: 2	وَفْقِ الثَّانِيَةِ
u'وَفْقٌ ثَانِيَةٌ':Added, #1: 1	وَفْقَ الثَّانِيَةِ
u'وَفْقٌ ثُبُوتٌ':Added, #2: 2	وَفْقِ الثَّانِيَةِ
u'وَفْقٌ ثَلاثَةٌ':Added, #2: 2	وَفْقِ الثُّبُوتِ
u'وَفْقٌ ثَمَنٌ':Added, #1: 1	وَفْقِ الثَّلَاثَةِ
u'وَفْقٌ جَوَابٌ':Added, #1: 1	وَفْقَ الثَّمَنِ
u'وَفْقٌ حاجَةٌ':Added, #1: 1	وَفْقُ الْجَوَابِ
u'وَفَّقَ حانوتِيٌّ':Subject, #1: 1	وَفْقَ حَاجَتِهِ
u'وَفْقٌ حُجَّةٌ':Added, #1: 1	وَفَّقَ الْحَانُوتِيُّ
u'وَفْقٌ حَديثٌ':Added, #2: 2	وَفْقِ الْحُجَّةِ
u'وَفْقٌ حَقٌّ':Added, #1: 1	وَفْقِ حَدِيثٍ
u'وَفْقٌ حُكْمٌ':Added, #2: 2	وَفْقَ حَقِّهِ
u'وَفْقٌ خَبَرٌ':Added, #2: 2	وَفْقِ الْحُكْمِ
u'وَفْقٌ خَبَر':Added, #3: 3	وَفْقِ خَبَرٍ
u'وَفْقٌ خَبَرٌ':Added, #3: 3	وَفْقِ خَبَرٍ
u'وَفْقٌ خَبَر':Added, #5: 5	وَفْقِ الْخَبَرِ
u'وَفْقٌ دَليلٌ':Added, #5: 5	وَفْقِ الْخَبَرِ
u'وَفْقٌ رَاجِحٌ':Added, #1: 1	وَفْقِ الدَّلِيلِ
u'وَفْقٌ رَاجِحٌ':Added, #1: 1	وَفْقِ الرَّاجِحِ
u'وَفَّقَ رَسُولٌ':Predicate, #1: 1	وَفْقٍ رَاجِحٍ
u'وَفْقٌ رِوايَةٌ':Added, #6: 6	وَفَّقَ رَسُولَ
u'وَفْقٌ سلام':Added, #1: 1	وَفْقُ رِوَايَةِ
u'وَفْقٌ سَلاَمٌ':Added, #1: 1	وَفْقِ سَلَامِ
u'وَفْقٌ سَمَاعٌ':Added, #1: 1	وَفْقِ سَلَامِ
u'وَفْقٌ سهام':Added, #1: 1	وَفْقِ السَّمَاعِ
u'وَفْقٌ سِهَامٌ':Added, #1: 1	وَفْقِ سِهَامِ
u'وَفْقٌ سهام':Added, #1: 1	وَفْقِ سِهَامِ
u'وَفْقٌ سِهَامٌ':Added, #1: 1	وَفْقِ سِهَامِهِ
u'وَفْقٌ شَرْطٌ':Added, #1: 1	وَفْقِ سِهَامِهِ
u'وَفْقٌ شَرْعٌ':Added, #1: 1	وَفْقِ الشَّرْطِ
u'وَفَّقَ شَهَادَةٌ':Predicate, #4: 4	وَفْقِ الشَّرْعِ
u'وَفْقٌ عَادَةٌ':Added, #1: 1	وَفَّقَ الشَّهَادَةَ
u'وَفْقٌ عَادَةٌ':Added, #1: 1	وَفْقُ الْعَادَةِ
u'وَفْقٌ عَدَدٌ':Added, #3: 3	وَفْقِ الْعَادَةِ
u'وَفْقٌ عَدَدٌ':Added, #1: 1	وَفْقَ الْعَدَدِ
u'وَفْقٌ عَدَدٌ':Added, #1: 1	وَفْقَ عَدَدِ
u'وَفْقٌ عَدَدٌ':Added, #1: 1	وَفْقَ عَدَدِهِ
u'وَفْقٌ عِلَّةٌ':Added, #1: 1	وَفْقُ عَدَدِهِ
u'وَفْقٌ علم':Added, #1: 1	وَفْقِ عِلَّتِهِ
u'وَفْقٌ عِلْمٌ':Added, #3: 3	وَفْقِ عِلْمِهِ
u'وَفْقٌ عِيَالٌ':Added, #3: 3	وَفْقِ عِلْمِهِ
u'وَفْقٌ غَالِبٌ':Added, #1: 1	وَفْقَ الْعِيَالِ
u'وَفْقٌ غَايَةٌ':Added, #1: 1	وَفْقِ الْغَالِبِ
u'وَفْقٌ غِبْطَةٌ':Added, #1: 1	وَفْقِ الْغَايَاتِ
u'وَفْقٌ فَرِيضَةٌ':Added, #1: 1	وَفْقِ الْغِبْطَةِ
u'وَفْقٌ فَرِيضَةٌ':Added, #1: 1	وَفْقَ فَرِيضَةِ
u'وَفْقٌ فِقْهٌ':Added, #1: 1	وَفْقَ فَرِيضَتِهِ
u'وَفْقٌ قَصْدٌ':Added, #1: 1	وَفْقِ الْفِقْهِ
u'وَفْقٌ قول':Added, #1: 1	وَفْقِ قَصْدِهِ
u'وَفْقٌ قَوْلٌ':Added, #1: 1	وَفْقِ قَوْلِهِ
u'وَفْقٌ قِيَاسٌ':Added, #1: 1	وَفْقِ قَوْلِهِ
u'وَفْقٌ كِتَابٌ':Added, #11: 11	وَفْقِ الْقِيَاسِ
u'وَفْقٌ كِفَايَةٌ':Added, #1: 1	وَفْقِ الْكِتَابِ
u'وَفْقٌ مَجْمُوعٌ':Added, #1: 1	وَفْقَ كِفَايَتِهِ
u'وَفْقٌ مُخْبِرٌ':Added, #1: 1	وَفْقِ مَجْمُوعِ
u'وَفْقٌ مَذْهَبٌ':Added, #1: 1	وَفْقِ مُخْبِرِهِ
u'وَفْقٌ مَذْهَبٌ':Added, #1: 1	وَفْقُ الْمَذْهَبِ
u'وَفْقٌ مراد':Added, #4: 4	وَفْقِ مَذْهَبِهِ
u'وَفْقٌ مُرَادٌ':Added, #1: 1	وَفْقِ مُرَادِ
u'وَفْقٌ مراد':Added, #1: 1	وَفْقِ مُرَادِ
u'وَفْقٌ مُرَادٌ':Added, #1: 1	وَفْقِ مُرَادِهِ
u'وَفْقٌ مَسْأَلَةٌ':Added, #1: 1	وَفْقِ مُرَادِهِ
u'وَفْقٌ مَسْأَلَةٌ':Added, #1: 1	وَفْقَ الْمَسْأَلَةِ
u'وَفْقٌ مَسْأَلَةٌ':Added, #1: 1	وَفْقَ مَسْأَلَةِ
u'وَفْقٌ مَسْأَلَةٌ':Added, #1: 1	وَفْقِ مَسْأَلَةِ
u'وَفْقٌ مَسْأَلَةٌ':Added, #1: 1	وَفْقُ مَسْأَلَتِهِ
u'وَفْقٌ مَصَالِحُ':Added, #3: 3	وَفْقِ الْمَسْأَلَةِ
u'وَفْقٌ مَصْلَحَةٌ':Added, #1: 1	وَفْقِ الْمَصَالِحِ
u'وَفْقٌ مُضَارَبَةٌ':Added, #1: 1	وَفْقِ الْمَصْلَحَةِ
u'وَفْقٌ مُعْتَادٌ':Added, #1: 1	وَفْقِ الْمُضَارَبَةِ
u'وَفَّقَ مَقْدِسِيٌّ':Predicate, #1: 1	وَفْقِ الْمُعْتَادِ
u'وَفْقٌ مُؤَثِّرٌ':Added, #1: 1	وَفَّقَ الْمَقْدِسِيَّ
u'وَفْقٌ مُوجَبٌ':Added, #1: 1	وَفْقِ الْمُؤَثِّرِ
u'وَفْقٌ نَدْبٌ':Added, #1: 1	وَفْقِ الْمُوجَبِ
u'وَفْقٌ نَصٌّ':Added, #1: 1	وَفْقِ النَّدْبِ
u'وَفْقٌ وَصْفٌ':Added, #1: 1	وَفْقِ النَّصِّ
u'وُفُودٌ أعاجم':Added, #1: 1	وَفْقَ الْوَصْفِ
u'وُفُودٌ عَرَبٌ':Added, #1: 1	وُفُودِ الْأَعَاجِمِ
u'وُفُودٌ عَرَبٌ':Added, #1: 1	وُفُودَ الْعَرَبِ
u'وُفُورٌ حالٌ':Added, #3: 3	وُفُودُ الْعَرَبِ
u'وُفُورٌ شفعة':Added, #1: 1	وُفُورِ حَالِهِ
u'وُفُورٌ شفعة':Added, #1: 1	وُفُورِ الشَّفَعَةِ
u'وُفُورٌ شُفْعَةٌ':Added, #1: 1	وُفُورِ الشُّفْعَةِ
u'وُفُورٌ شَفَقَةٌ':Added, #1: 1	وُفُورِ الشُّفْعَةِ
u'وُفُورٌ شَفَقَةٌ':Added, #1: 1	وُفُورِ شَفَقَةِ
u'وُفُورٌ شَفَقَةٌ':Added, #2: 2	وُفُورِ الشَّفَقَةِ
u'وُفُورٌ شَهَوَاتٌ':Added, #2: 2	وُفُورِ شَفَقَتِهِ
u'وُفُورٌ صَحَابَةٌ':Added, #1: 1	وُفُورُ شَهَوَاتِهِ
u'وُفُورٌ عَدَدٌ':Added, #1: 1	وُفُورِ الصَّحَابَةِ
u'وُفُورٌ عَقْلٌ':Added, #1: 1	وُفُورَ عَدَدٍ
u'وُفُورٌ عَقْلٌ':Added, #2: 2	وُفُورُ الْعَقْلِ
u'وُفُورٌ علم':Added, #3: 3	وُفُورِ الْعَقْلِ
u'وُفُورٌ عِلْمٌ':Added, #1: 1	وُفُورِ عِلْمِهِ
u'وُفُورٌ مَنْفَعَةٌ':Added, #1: 1	وُفُورِ عِلْمِهِ
u'وُفُورٌ نعمة':Added, #4: 4	وُفُورِ الْمَنْفَعَةِ
u'وُفُورٌ نِعْمَةٌ':Added, #1: 1	وُفُورِ النِّعْمَةِ
u'وَفَّى أَجَلٌ':Predicate, #1: 1	وُفُورِ النِّعْمَةِ
u'وَفَّى أحَدٌ':Subject, #1: 1	وَفَّى الأَجَلَ
u'وَفَّى ثَانِي':Predicate, #1: 1	وَفَّى أَحَدُ
u'وَفَّى ثَانِيَةٌ':Predicate, #1: 1	وَفَّى الثَّانِيَةَ
u'وَفَّى جَدِيدٌ':Predicate, #1: 1	وَفَّى الثَّانِيَةَ
u'وَفَّى حِصَّةٌ':Predicate, #3: 3	وَفَّى الْجَدِيدَةَ
u'وَفَّى حَقٌّ':Predicate, #1: 1	وَفَّى حِصَّةَ
u'وَفَّى خَمْسَةٌ':Predicate, #1: 1	وَفَّى حَقَّ
u'وَفَّى دَيْنٌ':Predicate, #1: 1	وَفَّى خَمْسَةَ
u'وَفَّى دَيْنٌ':Predicate, #1: 1	وَفَّى الدَّيْنَ
u'وَفَّى دَيْنٌ':Subject, #2: 2	وَفَّى دَيْنَ
u'وَفَّى رَدٌّ':Predicate, #2: 2	وَفَّى الدَّيْنُ
u'وَفَّى زَوْجٌ':Subject, #1: 1	وَفَّى رَدَّ
u'وَفَّى عَبْدٌ':Subject, #1: 1	وَفَّى الزَّوْجُ
u'وَفَّى عِمَالَةٌ':Predicate, #1: 1	وَفَّى الْعَبْدُ
u'وَفَّى عَمَلٌ':Predicate, #1: 1	وَفَّى الْعِمَالَةَ
u'وَفَّى قَدْرٌ':Predicate, #2: 2	وَفَّى الْعَمَلَ
u'وَفَّى قَدِيمٌ':Predicate, #1: 1	وَفَّى قَدْرَ
u'وَفَّى كَلاَمٌ':Subject, #1: 1	وَفَّى الْقَدِيمَةَ
u'وَفَّى مَالٌ':Subject, #1: 1	وَفَّى كَلَامُهُ
u'وَفَّى مَبِيعٌ':Predicate, #1: 1	وَفَّى الْمَالُ
u'وَفَّى مُغِلّ':Subject, #2: 2	وَفَّى الْمَبِيعَ
u'وَفَّى مُغِلّ':Subject, #1: 1	وَفَّى الْمُغِلُّ
u'وَفَّى مُوَرِّث':Subject, #1: 1	وَفَّى مُغِلُّ
u'وَفَّى وَظِيفٌ':Predicate, #1: 1	وَفَّى مُوَرِّثُهُ
u'وَفَّى وَظِيفَةٌ':Predicate, #1: 1	وَفَّى الْوَظِيفَةَ
u'وقاف إمَامٌ':Added, #1: 1	وَفَّى الْوَظِيفَةَ
u'وقاف إمَامَةٌ':Added, #2: 2	أَوْقَافِ الْإِمَامِ
u'وقاف صَحَابَةٌ':Added, #1: 1	أَوْقَافِ الْإِمَامَةِ
u'وقاف قَاهِرٌ':Added, #1: 1	أَوْقَافُ الصَّحَابَةِ
u'وقاف مَدَارِسُ':Added, #1: 1	أَوْقَافِ الْقَاهِرَةِ
u'وقاف مَسَاجِدُ':Added, #1: 1	أَوْقَافِ الْمَدَارِسِ
u'وقاف مَسْجِدٌ':Added, #1: 1	أَوْقَافِ الْمَسَاجِدِ
u'وقاف هِلاَلٌ':Added, #13: 13	أَوْقَافِ الْمَسْجِدِ
u'وِقَايَةٌ أَنْفُسٌ':Added, #1: 1	أَوْقَافِ هِلَالٍ
u'وِقَايَةٌ رَأْسٌ':Added, #2: 2	وِقَايَةُ الْأَنْفُسِ
u'وِقَايَةٌ رَجُلٌ':Added, #1: 1	وِقَايَةُ رَأْسِ
u'وِقَايَةٌ عِرْضٌ':Added, #1: 1	وِقَايَةِ الرَّجُلِ
u'وِقَايَةٌ عِرْضٌ':Added, #1: 1	وِقَايَةُ الْعِرْضِ
u'وِقَايَةٌ مَالٌ':Added, #1: 1	وِقَايَةِ عِرْضٍ
u'وِقَايَةٌ نَفْسٌ':Added, #1: 1	وِقَايَةُ الْمَالِ
u'وِقَايَةٌ نَفْسٌ':Added, #1: 1	وِقَايَةُ نَفْسِهِ
u'وَقْبٌ عين':Added, #2: 2	وِقَايَةُ النَّفْسِ
u'وَقْبٌ عَيْنٌ':Added, #2: 2	وَقْبِ عَيْنِهِ
u'وَقْبٌ عَيْن':Added, #2: 2	وَقْبِ عَيْنِهِ
u'وَقْتٌ إبَاحَةٌ':Added, #2: 2	وَقْبِ عَيْنِهِ
u'وَقْتٌ إبَاحَةٌ':Added, #1: 1	وَقْتَ إبَاحَةِ
u'وَقْتٌ اِبْتِداءٌ':Added, #1: 1	وَقْتِ إبَاحَةِ
u'وَقْتٌ اِبْتِداءٌ':Added, #3: 3	وَقْتَ ابْتِدَاءِ
u'وَقْتٌ إِتْلاَفٌ':Added, #3: 3	وَقْتِ ابْتِدَاءِ
u'وَقْتٌ إِتْلاَفٌ':Added, #1: 1	وَقْتِ إتْلَافِهِ
u'وَقْتٌ إِتْلاَفٌ':Added, #1: 1	وَقْتَ الْإِتْلَافِ
u'وَقْتٌ إِتْلاَفٌ':Added, #1: 1	وَقْتُ الْإِتْلَافِ
u'وَقْتٌ إِثْبَاتٌ':Added, #3: 3	وَقْتَ إتْلَافِهِ
u'وَقْتٌ إِثْخَانٌ':Added, #1: 1	وَقْتُ إثْبَاتِ
u'وَقْتٌ إِثْخَانٌ':Added, #1: 1	وَقْتَ الْإِثْخَانِ
u'وَقْتٌ إِجَابَةٌ':Added, #1: 1	وَقْتُ الْإِثْخَانِ
u'وَقْتٌ إجَارَةٌ':Added, #1: 1	وَقْتُ إجَابَةِ
u'وَقْتٌ إجَازَةٌ':Added, #4: 4	وَقْتِ الْإِجَارَةِ
u'وَقْتٌ إجَازَةٌ':Added, #12: 12	وَقْتِ الْإِجَازَةِ
u'وَقْتٌ إجَازَةٌ':Added, #13: 13	وَقْتَ الْإِجَازَةِ
u'وَقْتٌ اِجْتِمَاعٌ':Added, #1: 1	وَقْتُ الْإِجَازَةِ
u'وَقْتٌ اِجْتِمَاعٌ':Added, #1: 1	وَقْتُ اجْتِمَاعٍ
u'وَقْتٌ اِجْتِمَاعٌ':Added, #1: 1	وَقْتُ اجْتِمَاعِ
u'وَقْتٌ أَجَلٌ':Added, #3: 3	وَقْتَ اجْتِمَاعِ
u'وَقْتٌ أَجَلٌ':Added, #1: 1	وَقْتِ أَجَلِهِ
u'وَقْتٌ اِحْتِمَالٌ':Added, #1: 1	وَقْتِ الْأَجَلِ
u'وَقْتٌ اِحْتِمَالٌ':Added, #1: 1	وَقْتِ احْتِمَالِ
u'وَقَّتَ أحَدٌ':Subject, #1: 1	وَقْتِ احْتِمَالِهِ
u'وَقْتٌ إِحْرَامٌ':Added, #1: 1	وَقَّتَ أَحَدٌ
u'وَقْتٌ إِحْرَامٌ':Added, #1: 1	وَقْتُ إحْرَامِ
u'وَقْتٌ إِحْرَامٌ':Added, #2: 2	وَقْتِ إحْرَامِ
u'وَقْتٌ إِحْرَامٌ':Added, #2: 2	وَقْتُ إحْرَامِهِ
u'وَقْتٌ إِحْرَامٌ':Added, #3: 3	وَقْتُ الْإِحْرَامِ
u'وَقْتٌ إِحْرَامٌ':Added, #4: 4	وَقْتَ إحْرَامِهِ
u'وَقْتٌ إِحْرَامٌ':Added, #7: 7	وَقْتِ الْإِحْرَامِ
u'وَقْتٌ إِحْلاَلٌ':Added, #8: 8	وَقْتَ الْإِحْرَامِ
u'وَقْتٌ اِحْمِرَارٌ':Added, #3: 3	وَقْتُ الْإِحْلَالِ
u'وَقْتٌ إِحْيَاءٌ':Added, #1: 1	وَقْتَ احْمِرَارِهِ
u'وَقْتٌ إِخْبَارٌ':Added, #2: 2	وَقْتَ الْإِحْيَاءِ
u'وَقْتٌ إِخْبَارٌ':Added, #1: 1	وَقْتِ إخْبَارِهِ
u'وَقْتٌ إِخْبَارٌ':Added, #1: 1	وَقْتِ الْإِخْبَارِ
u'وَقْتٌ اِخْتِيَارٌ':Added, #2: 2	وَقْتَ الْإِخْبَارِ
u'وَقْتٌ اِخْتِيَارٌ':Added, #1: 1	وَقْتِ اخْتِيَارِ
u'وَقْتٌ اِخْتِيَارٌ':Added, #1: 1	وَقْتِ اخْتِيَارِهِ
u'وَقْتٌ اِخْتِيَارٌ':Added, #2: 2	وَقْتِ الاِخْتِيَارِ
u'وَقْتٌ أخْذٌ':Added, #3: 3	وَقْتُ اخْتِيَارٍ
u'وَقْتٌ أخْذٌ':Added, #1: 1	وَقْتِ أَخْذِ
u'وَقْتٌ أخْذٌ':Added, #1: 1	وَقْتَ أَخْذِهِ
u'وَقْتٌ أخْذٌ':Added, #1: 1	وَقْتُ أَخْذِهِ
u'وَقْتٌ أخْذٌ':Added, #26: 26	وَقْتَ الْأَخْذِ
u'وَقْتٌ أخْذٌ':Added, #4: 4	وَقْتِ أَخْذِهِ
u'وَقْتٌ إِخْرَاجٌ':Added, #9: 9	وَقْتِ الْأَخْذِ
u'وَقْتٌ إِخْرَاجٌ':Added, #1: 1	وَقْتِ إخْرَاجِ
u'وَقْتٌ إِخْرَاجٌ':Added, #1: 1	وَقْتِ إِخْرَاجِ
u'وَقْتٌ إِخْرَاجٌ':Added, #1: 1	وَقْتِ إخْرَاجِهِ
u'وَقْتٌ إِخْرَاجٌ':Added, #2: 2	وَقْتِ الْإِخْرَاجِ
u'وَقْتٌ آخِرَةٌ':Added, #7: 7	وَقْتَ الْإِخْرَاجِ
u'وَقْتٌ أَدَاءٌ':Added, #1: 1	وَقْتِ الْآخِرَةِ
u'وَقْتٌ أَدَاءٌ':Added, #19: 19	وَقْتُ الْأَدَاءِ
u'وَقْتٌ أَدَاءٌ':Added, #1: 1	وَقْتُ أَدَاءِ
u'وَقْتٌ أَدَاءٌ':Added, #25: 25	وَقْتَ الْأَدَاءِ
u'وَقْتٌ أَدَاءٌ':Added, #2: 2	وَقْتُ أَدَاءٍ
u'وَقْتٌ أَدَاءٌ':Added, #36: 36	وَقْتِ الْأَدَاءِ
u'وَقْتٌ أَدَاءٌ':Added, #5: 5	وَقْتِ أَدَاءِ
u'وَقْتٌ إِدَانَةٌ':Added, #9: 9	وَقْتَ أَدَاءِ
u'وَقْتٌ إدْخَالٌ':Added, #3: 3	وَقْتَ الْإِدَانَةِ
u'وَقْتٌ إِدْرَاكٌ':Added, #1: 1	وَقْتَ الْإِدْخَالِ
u'وَقْتٌ إِدْرَاكٌ':Added, #15: 15	وَقْتِ الْإِدْرَاكِ
u'وَقْتٌ إِدْرَاكٌ':Added, #1: 1	وَقْتَ إدْرَاكِ
u'وَقْتٌ إِدْرَاكٌ':Added, #1: 1	وَقْتُ إدْرَاكِ
u'وَقْتٌ إِدْرَاكٌ':Added, #1: 1	وَقْتَ إدْرَاكِهِ
u'وَقْتٌ إِدْرَاكٌ':Added, #1: 1	وَقْتِ إدْرَاكِهِ
u'وَقْتٌ إِدْرَاكٌ':Added, #2: 2	وَقْتِ إدْرَاكِ
u'وَقْتٌ إِدْرَاكٌ':Added, #2: 2	وَقْتَ الْإِدْرَاكِ
u'وَقْتٌ أَذَانٌ':Added, #4: 4	وَقْتُ الْإِدْرَاكِ
u'وَقْتٌ أَذَانٌ':Added, #1: 1	وَقْتَ أَذَانِهِ
u'وَقْتٌ أَذَانٌ':Added, #1: 1	وَقْتِ الأَذَانِ
u'وَقْتٌ أَذَانٌ':Added, #1: 1	وَقْتِ الْأَذَانِ
u'وَقْتٌ إِذْنٌ':Added, #3: 3	وَقْتَ الْأَذَانِ
u'وَقْتٌ إِرَاقَةٌ':Added, #1: 1	وَقْتِ الْإِذْنِ
u'وَقْتٌ أَرْبَعَةٌ':Added, #1: 1	وَقْتِ الْإِرَاقَةِ
u'وَقْتٌ اِرْتِكَابٌ':Added, #1: 1	وَقْتِ الْأَرْبَعَةِ
u'وَقْتٌ إِرْسَالٌ':Added, #1: 1	وَقْتُ ارْتِكَابِ
u'وَقْتٌ إِرْسَالٌ':Added, #1: 1	وَقْتُ الْإِرْسَالِ
u'وَقْتٌ اِسْتِحْقَاقٌ':Added, #4: 4	وَقْتَ الْإِرْسَالِ
u'وَقْتٌ اِسْتِحْكَامٌ':Added, #3: 3	وَقْتِ اسْتِحْقَاقِ
u'وَقْتٌ اِسْتِعْمالٌ':Added, #1: 1	وَقْتُ اسْتِحْكَامِ
u'وَقْتٌ اِسْتِغْلاَلٌ':Added, #1: 1	وَقْتَ اسْتِعْمَالِهِ
u'وَقْتٌ اِسْتِقْرارٌ':Added, #2: 2	وَقْتُ اسْتِغْلَالِ
u'وَقْتٌ اِسْتيلاءٌ':Added, #1: 1	وَقْتِ اسْتِقْرَارِ
u'وَقْتٌ أَسْرٌ':Added, #1: 1	وَقْتَ اسْتِيلَاءِ
u'وَقْتٌ إِسْقاطٌ':Added, #1: 1	وَقْتَ الْأَسْرِ
u'وَقْتٌ إِسْلامٌ':Added, #2: 2	وَقْتِ الْإِسْقَاطِ
u'وَقْتٌ إِسْلامٌ':Added, #1: 1	وَقْتِ الْإِسْلَامِ
u'وَقْتٌ إِسْلامٌ':Added, #2: 2	وَقْتِ إسْلَامِ
u'وَقْتٌ إِسْلامٌ':Added, #3: 3	وَقْتَ إسْلَامِهِ
u'وَقْتٌ إِسْلامٌ':Added, #3: 3	وَقْتَ الْإِسْلَامِ
u'وَقْتٌ إِسْهالٌ':Added, #5: 5	وَقْتِ إسْلَامِهِ
u'وَقْتٌ أشرف':Added, #1: 1	وَقْتَ إسْهَالِ
u'وَقْتٌ أَشْرَفُ':Added, #1: 1	وَقْتِ أَشْرَفِ
u'وَقْتٌ إِشْكالٌ':Added, #1: 1	وَقْتِ أَشْرَفِ
u'وَقْتٌ إصابَةٌ':Added, #1: 1	وَقْتَ الْإِشْكَالِ
u'وَقْتٌ إصابَةٌ':Added, #1: 1	وَقْتِ إصَابَةِ
u'وَقْتٌ إصابَةٌ':Added, #1: 1	وَقْتِ الْإِصَابَةِ
u'وَقْتٌ إصابَةٌ':Added, #2: 2	وَقْتُ الْإِصَابَةِ
u'وَقْتٌ اِصْفِرارٌ':Added, #7: 7	وَقْتَ الْإِصَابَةِ
u'وَقْتٌ إضافَةٌ':Added, #1: 1	وَقْتِ اصْفِرَارِ
u'وَقْتٌ إِطْلاعٌ':Added, #1: 1	وَقْتِ الْإِضَافَةِ
u'وَقْتٌ اِطِّلاعٌ':Added, #1: 1	وَقْتُ إطْلَاعِهِ
u'وَقْتٌ إِعادَةٌ':Added, #1: 1	وَقْتَ اطِّلَاعِهِ
u'وَقْتٌ إِعادَةٌ':Added, #1: 1	وَقْتَ الْإِعَادَةِ
u'وَقْتٌ إِعادَةٌ':Added, #1: 1	وَقْتُ الْإِعَادَةِ
u'وَقْتٌ إِعْتاقٌ':Added, #1: 1	وَقْتِ الْإِعَادَةِ
u'وَقْتٌ إِعْتاقٌ':Added, #19: 19	وَقْتَ الْإِعْتَاقِ
u'وَقْتٌ إِعْتاقٌ':Added, #1: 1	وَقْتُ الْإِعْتَاقِ
u'وَقْتٌ إِعْتاقٌ':Added, #4: 4	وَقْتَ إعْتَاقِهِ
u'وَقْتٌ اِعْتِبارٌ':Added, #4: 4	وَقْتِ الْإِعْتَاقِ
u'وَقْتٌ اِعْتِبارٌ':Added, #1: 1	وَقْتَ اعْتِبَارِهِ
u'وَقْتٌ اِعْتِيادٌ':Added, #2: 2	وَقْتِ اعْتِبَارِهِ
u'وَقْتٌ إعْطَاءٌ':Added, #1: 1	وَقْتَ اعْتِيَادِ
u'وَقْتٌ إعْطَاءٌ':Added, #1: 1	وَقْتَ الْإِعْطَاءِ
u'وَقْتٌ إعْطَاءٌ':Added, #2: 2	وَقْتُ إعْطَاءِ
u'وَقْتٌ إِفَاضَةٌ':Added, #2: 2	وَقْتِ الْإِعْطَاءِ
u'وَقْتٌ إِفْطارٌ':Added, #2: 2	وَقْتَ الْإِفَاضَةِ
u'وَقْتٌ إِفْطارٌ':Added, #1: 1	وَقْتُ إفْطَارِهِ
u'وَقْتٌ إِفْطارٌ':Added, #1: 1	وَقْتَ الْإِفْطَارِ
u'وَقْتٌ أَفْعَالٌ':Added, #2: 2	وَقْتِ الْإِفْطَارِ
u'وَقْتٌ إقالَةٌ':Added, #1: 1	وَقْتِ أَفْعَالِ
u'وَقْتٌ إقامَةٌ':Added, #12: 12	وَقْتَ الْإِقَالَةِ
u'وَقْتٌ إقامَةٌ':Added, #1: 1	وَقْتَ الْإِقَامَةِ
u'وَقْتٌ إقامَةٌ':Added, #3: 3	وَقْتِ إقَامَةِ
u'وَقْتٌ إقْبالٌ':Added, #4: 4	وَقْتَ إقَامَةِ
u'وَقْتٌ إقْبالٌ':Added, #1: 1	وَقْتُ إقْبَالِ
u'وَقْتٌ إقْرَارٌ':Added, #2: 2	وَقْتَ إقْبَالِهِ
u'وَقْتٌ إقْرَارٌ':Added, #1: 1	وَقْتَ إقْرَارِ
u'وَقْتٌ إقْرَارٌ':Added, #1: 1	وَقْتِ إقْرَارِ
u'وَقْتٌ إقْرَارٌ':Added, #1: 1	وَقْتِ إقْرَارِهِ
u'وَقْتٌ إقْرَارٌ':Added, #1: 1	وَقْتَ الْإِقْرَارَيْنِ
u'وَقْتٌ إقْرَارٌ':Added, #3: 3	وَقْتَ إقْرَارِهِ
u'وَقْتٌ إقْرَارٌ':Added, #46: 46	وَقْتَ الْإِقْرَارِ
u'وَقْتٌ أكل':Added, #54: 54	وَقْتِ الْإِقْرَارِ
u'وَقْتٌ أَكْلٌ':Added, #5: 5	وَقْتَ الْأَكْلِ
u'وَقْتٌ إِلْقَاءٌ':Added, #5: 5	وَقْتَ الْأَكْلِ
u'وَقْتٌ إمَامٌ':Added, #1: 1	وَقْتَ إلْقَاءِ
u'وَقْتٌ إمَامَةٌ':Added, #1: 1	وَقْتِ الْإِمَامِ
u'وَقْتٌ أمَانٌ':Added, #2: 2	وَقْتِ الْإِمَامَةِ
u'وَقْتٌ أمَانٌ':Added, #1: 1	وَقْتَ الْأَمَانِ
u'وَقَّتَ أَمْرٌ':Predicate, #1: 1	وَقْتَ أَمَانِهِ
u'وَقْتٌ أَمْرٌ':Added, #1: 1	وَقَّتَ الْأَمْرَ
u'وَقْتٌ أَمْرٌ':Added, #1: 1	وَقْت الْأَمْرِ
u'وَقْتٌ أَمْرٌ':Added, #1: 1	وَقْتَ الْأَمْرِ
u'وَقْتٌ أَمْرٌ':Added, #1: 1	وَقْتِ الْأَمْرِ
u'وَقْتٌ إِمْكانٌ':Added, #1: 1	وَقْتُ أَمْرٍ
u'وَقْتٌ إِمْكانٌ':Added, #1: 1	وَقْتَ الْإِمْكَانِ
u'وَقْتٌ إِمْكانٌ':Added, #1: 1	وَقْتَ إمْكَانِ
u'وَقْتٌ إِمْكانٌ':Added, #1: 1	وَقْتَ إمْكَانِهِ
u'وَقْتٌ إِمْكانٌ':Added, #2: 2	وَقْتُ إمْكَانِ
u'وَقْتٌ إِمْكانٌ':Added, #4: 4	وَقْتِ إمْكَانِ
u'وَقْتٌ إِمْكانٌ':Added, #6: 6	وَقْتُ الْإِمْكَانِ
u'وَقْتٌ إِمْكانٌ':Added, #6: 6	وَقْتِ الْإِمْكَانِ
u'وَقْتٌ أنبياء':Added, #8: 8	وَقْتِ إمْكَانِهِ
u'وَقْتٌ أنبياء':Added, #2: 2	وَقْتُ الأَنْبِيَاءِ
u'وَقْتٌ اِنْتِباهٌ':Added, #4: 4	وَقْتُ الْأَنْبِيَاءِ
u'وَقْتٌ اِنْتِباهٌ':Added, #1: 1	وَقْتِ انْتِبَاهٍ
u'وَقْتٌ اِنْتِشارٌ':Added, #1: 1	وَقْتِ انْتِبَاهِهِ
u'وَقْتٌ اِنْتِقالٌ':Added, #1: 1	وَقْتُ انْتِشَارِ
u'وَقْتٌ اِنْحِطاطٌ':Added, #1: 1	وَقْتِ انْتِقَالِ
u'وَقْتٌ إِنْزالٌ':Added, #1: 1	وَقْتَ انْحِطَاطِ
u'وَقْتٌ اِنْصِرافٌ':Added, #1: 1	وَقْتُ الْإِنْزَالِ
u'وَقْتٌ اِنْعِقَادٌ':Added, #1: 1	وَقْتِ انْصِرَافِهِ
u'وَقْتٌ اِنْعِقَادٌ':Added, #1: 1	وَقْتَ انْعِقَادِ
u'وَقْتٌ إِنْفاقٌ':Added, #1: 1	وَقْتِ انْعِقَادِ
u'وَقْتٌ اِنْفِجارٌ':Added, #1: 1	وَقْتَ الْإِنْفَاقِ
u'وَقْتٌ اِنْقِضاءٌ':Added, #1: 1	وَقْتُ انْفِجَارِ
u'وَقْتٌ اِنْقِضاءٌ':Added, #1: 1	وَقْتَ انْقِضَاءِ
u'وَقْتٌ اِنْقِطاعٌ':Added, #4: 4	وَقْتِ انْقِضَاءِ
u'وَقْتٌ اِنْقِطاعٌ':Added, #1: 1	وَقْتِ انْقِطَاعِ
u'وَقْتٌ اِنْقِطاعٌ':Added, #1: 1	وَقْتَ انْقِطَاعِهِ
u'وَقْتٌ إِنْكارٌ':Added, #3: 3	وَقْتَ انْقِطَاعِ
u'وَقْتٌ إهْلاَلٌ':Added, #2: 2	وَقْتَ الْإِنْكَارِ
u'وَقْتٌ أَهْلِيٌّ':Added, #1: 1	وَقْتَ الْإِهْلَالِ
u'وَقْتٌ أهْلِيَّةٌ':Added, #1: 1	وَقْتَ الْأَهْلِيَّةِ
u'وَقْتٌ أَوْرَاقٌ':Added, #1: 1	وَقْتَ الْأَهْلِيَّةِ
u'وَقْتٌ أَوْسَاخٌ':Added, #1: 1	وَقْتُ الْأَوْرَاقِ
u'وَقْتٌ أَوَّلُ':Added, #1: 1	وَقْتَ الْأَوْسَاخِ
u'وَقْتٌ أَوَّلُ':Added, #1: 1	وَقْتُ أَوَّلِ
u'وَقْتٌ إِيجَابٌ':Added, #3: 3	وَقْتِ الْأَوَّلِ
u'وَقْتٌ إِيجَابٌ':Added, #1: 1	وَقْتُ الْإِيجَابِ
u'وَقْتٌ إِيجَابٌ':Added, #1: 1	وَقْتَ إيجَابِهِ
u'وَقْتٌ إِيجَابٌ':Added, #1: 1	وَقْتِ إيجَابِهِ
u'وَقْتٌ إِيجَابٌ':Added, #2: 2	وَقْتَ الْإِيجَابِ
u'وَقْتٌ إِيجَارٌ':Added, #3: 3	وَقْتِ الْإِيجَابِ
u'وَقْتٌ إِيدَاعٌ':Added, #2: 2	وَقْتَ الْإِيجَارِ
u'وَقْتٌ إيقَاعٌ':Added, #3: 3	وَقْتَ الْإِيدَاعِ
u'وَقْتٌ أَيْمَانٌ':Added, #3: 3	وَقْتِ الْإِيقَاعِ
u'وَقْتٌ إِيواءٌ':Added, #1: 1	وَقْتَ الْأَيْمَانِ
u'وَقْتٌ بَحْثٌ':Added, #1: 1	وَقْتُ الْإِيوَاءِ
u'وَقْتٌ بِدْعَةٌ':Added, #1: 1	وَقْتَ الْبَحْثِ
u'وَقْتٌ بَدَلٌ':Added, #4: 4	وَقْتَ بِدْعَةٍ
u'وَقْتٌ بَذْرٌ':Added, #1: 1	وَقْتِ الْبَدَلِ
u'وَقْتٌ بِرٌّ':Added, #1: 1	وَقْتُ الْبَذْرِ
u'وَقْتٌ بُرْء':Added, #1: 1	وَقْتُ الْبِرِّ
u'وَقْتٌ بَرْدٌ':Added, #1: 1	وَقْتِ الْبُرْءِ
u'وَقْتٌ بروزٌ':Added, #1: 1	وَقْتِ الْبَرْدِ
u'وَقْتٌ بُلُوغٌ':Added, #1: 1	وَقْتِ الْبُرُوزِ
u'وَقْتٌ بُلُوغٌ':Added, #1: 1	وَقْتِ بُلُوغِ
u'وَقْتٌ بُلُوغٌ':Added, #2: 2	وَقْتِ بُلُوغِهِ
u'وَقْتٌ بِنَاءٌ':Added, #4: 4	وَقْتِ الْبُلُوغِ
u'وَقْتٌ بَيَانٌ':Added, #3: 3	وَقْتَ الْبِنَاءِ
u'وَقْتٌ بَيَانٌ':Added, #1: 1	وَقْتُ بَيَانِ
u'وَقْتٌ بِيَعٌ':Added, #4: 4	وَقْتِ الْبَيَانِ
u'وَقْتٌ بَيْعٌ':Added, #1: 1	وَقْتِ الْبِيَعِ
u'وَقْتٌ بَيْعٌ':Added, #2: 2	وَقْتَ بَيْعِ
u'وَقْتٌ بَيْعٌ':Added, #2: 2	وَقْتَ بَيْعِهِ
u'وَقْتٌ بَيْعٌ':Added, #36: 36	وَقْتِ الْبَيْعِ
u'وَقْتٌ بَيْعٌ':Added, #3: 3	وَقْتِ بَيْعِ
u'وَقْتٌ بَيْعَةٌ':Added, #72: 72	وَقْتَ الْبَيْعِ
u'وَقْتٌ تَأْجِيلٌ':Added, #1: 1	وَقْتَ الْبَيْعَةِ
u'وَقْتٌ تَارِيخٌ':Added, #1: 1	وَقْتِ التَّأْجِيلِ
u'وَقْتٌ تَارِيخٌ':Added, #1: 1	وَقْتِ تَارِيخِ
u'وَقْتٌ تَأْسِيسٌ':Added, #4: 4	وَقْتِ التَّارِيخِ
u'وَقْتٌ تَأَكُّدٌ':Added, #1: 1	وَقْتِ تَأْسِيسِ
u'وَقْتٌ تَأْلِيفٌ':Added, #4: 4	وَقْتَ تَأَكُّدِ
u'وَقْتٌ تَأْمِينٌ':Added, #1: 1	وَقْتَ تَأْلِيفِ
u'وَقْتٌ تَبَع':Added, #1: 1	وَقْتَ تَأْمِينِهِ
u'وَقْتٌ تَبَعِيّ':Added, #1: 1	وَقْتِ التَّبَعِيَّةِ
u'وَقْتٌ تَبَعِيَّة':Added, #1: 1	وَقْتِ التَّبَعِيَّةِ
u'وَقْتٌ تَثَاقُلٌ':Added, #1: 1	وَقْتِ التَّبَعِيَّةِ
u'وَقْتٌ تَجْدِيدٌ':Added, #1: 1	وَقْتِ التَّثَاقُلِ
u'وَقْتٌ تَجْهِيزٌ':Added, #1: 1	وَقْتَ تَجْدِيدِهِ
u'وَقْتٌ تَحَالُفٌ':Added, #1: 1	وَقْتَ التَّجْهِيزِ
u'وَقْتٌ تَحْرِيرٌ':Added, #1: 1	وَقْتَ التَّحَالُفِ
u'وَقْتٌ تَحْرِيك':Added, #1: 1	وَقْتَ التَّحْرِيرِ
u'وَقَّتَ تَحْرِيمٌ':Predicate, #1: 1	وَقْتَ التَّحْرِيكِ
u'وَقْتٌ تَحْرِيمٌ':Added, #1: 1	وَقَّتَ تَحْرِيمَ
u'وَقْتٌ تَحْرِيمٌ':Added, #1: 1	وَقْتِ التَّحْرِيمِ
u'وَقْتٌ تَحَقُّقٌ':Added, #1: 1	وَقْتِ تَحْرِيمِ
u'وَقْتٌ تَحْكِيمٌ':Added, #1: 1	وَقْتُ تَحَقُّقِ
u'وَقْتٌ تَحَلُّلٌ':Added, #5: 5	وَقْتَ التَّحْكِيمِ
u'وَقْتٌ تَحَلُّلٌ':Added, #1: 1	وَقْتَ تَحَلُّلِهِ
u'وَقْتٌ تَحَمُّلٌ':Added, #2: 2	وَقْتُ التَّحَلُّلِ
u'وَقْتٌ تَحَمُّلٌ':Added, #19: 19	وَقْتَ التَّحَمُّلِ
u'وَقْتٌ تَحَمُّلٌ':Added, #1: 1	وَقْتَ تَحَمُّلِ
u'وَقْتٌ تَحْوِيلٌ':Added, #2: 2	وَقْتِ التَّحَمُّلِ
u'وَقْتٌ تَحْوِيلٌ':Added, #1: 1	وَقْتِ تَحْوِيلِ
u'وَقْتٌ تَخَلُّصٌ':Added, #2: 2	وَقْتَ تَحْوِيلِ
u'وَقْتٌ تَخَلُّقٌ':Added, #1: 1	وَقْتِ التَّخَلُّصِ
u'وَقْتٌ تَخَوُّفٌ':Added, #1: 1	وَقْتَ التَّخَلُّقِ
u'وَقْتٌ تَخْيِيرٌ':Added, #1: 1	وَقْتُ التَّخَوُّفِ
u'وَقْتٌ تَدْبِيرٌ':Added, #1: 1	وَقْتِ التَّخْيِيرِ
u'وَقْتٌ تَدْبِيرٌ':Added, #3: 3	وَقْتِ التَّدْبِيرِ
u'وَقْتٌ تَدْرِيسٌ':Added, #8: 8	وَقْتَ التَّدْبِيرِ
u'وَقْتٌ تَذَكُّرٌ':Added, #1: 1	وَقْتَ التَّدْرِيسِ
u'وَقْتٌ تَذَكُّرٌ':Added, #1: 1	وَقْتُ التَّذَكُّرِ
u'وَقْتٌ تَذَكُّرٌ':Added, #2: 2	وَقْتَ التَّذَكُّرِ
u'وَقْتٌ تَرَاوِيحُ':Added, #2: 2	وَقْتِ التَّذَكُّرِ
u'وَقْتٌ تَرَاوِيحُ':Added, #1: 1	وَقْتَ التَّرَاوِيحِ
u'وَقْتٌ تَرَاوِيحُ':Added, #1: 1	وَقْتِ التَّرَاوِيحِ
u'وَقْتٌ تَرَبُّصٌ':Added, #2: 2	وَقْتُ التَّرَاوِيحِ
u'وَقْتٌ تَرْكٌ':Added, #1: 1	وَقْتِ التَّرَبُّصِ
u'وَقْتٌ تَرْكِيبٌ':Added, #1: 1	وَقْتَ التَّرْكِ
u'وَقْتٌ تَزَوُّجٌ':Added, #2: 2	وَقْتَ التَّرْكِيبِ
u'وَقْتٌ تَزَوُّجٌ':Added, #14: 14	وَقْتِ التَّزَوُّجِ
u'وَقْتٌ تَزْوِيجٌ':Added, #2: 2	وَقْتَ التَّزَوُّجِ
u'وَقْتٌ تَزْوِيجٌ':Added, #1: 1	وَقْتِ التَّزْوِيجِ
u'وَقْتٌ تَسَلُّطٌ':Added, #2: 2	وَقْتَ التَّزْوِيجِ
u'وَقْتٌ تَسْلِيطٌ':Added, #1: 1	وَقْتُ تَسَلُّطِهِ
u'وَقْتٌ تَسْلِيمٌ':Added, #1: 1	وَقْتِ التَّسْلِيطِ
u'وَقْتٌ تَسْلِيمٌ':Added, #1: 1	وَقْتِ تَسْلِيمِ
u'وَقْتٌ تَسْلِيمٌ':Added, #3: 3	وَقْتِ التَّسْلِيمِ
u'وَقْتٌ تَسْمِيَة':Added, #9: 9	وَقْتَ التَّسْلِيمِ
u'وَقْتٌ تَسْمِيَة':Added, #1: 1	وَقْتَ التَّسْمِيَةِ
u'وَقْتٌ تَسْمِيَة':Added, #1: 1	وَقْتُ التَّسْمِيَةِ
u'وَقْتٌ تَسْوِيَةٌ':Added, #1: 1	وَقْتَ تَسْمِيَةٍ
u'وَقْتٌ تَصْبِيحٌ':Added, #1: 1	وَقْتِ تَسْوِيَتِهِ
u'وَقْتٌ تَصَدُّقٌ':Added, #2: 2	وَقْتُ التَّصْبِيحِ
u'وَقْتٌ تَصَرُّفٌ':Added, #1: 1	وَقْتِ التَّصَدُّقِ
u'وَقْتٌ تَصَرُّفٌ':Added, #1: 1	وَقْتُ التَّصَرُّفِ
u'وَقْتٌ تَصَرُّفٌ':Added, #1: 1	وَقْتِ التَّصَرُّفِ
u'وَقْتٌ تَصَرُّفٌ':Added, #1: 1	وَقْتَ تَصَرُّفِهِ
u'وَقْتٌ تَصْفِيَةٌ':Added, #3: 3	وَقْتَ التَّصَرُّفِ
u'وَقْتٌ تَضَايُقٌ':Added, #1: 1	وَقْتَ تَصْفِيَةِ
u'وَقْتٌ تَضْحِيَةٌ':Added, #1: 1	وَقْتَ تَضَايُقِ
u'وَقْتٌ تَطَوُّعٌ':Added, #2: 2	وَقْتُ التَّضْحِيَةِ
u'وَقْتٌ تَعْجِيل':Added, #1: 1	وَقْتُ التَّطَوُّعِ
u'وَقْتٌ تَعْجِيل':Added, #1: 1	وَقْتِ التَّعْجِيلِ
u'وَقْتٌ تَعْدِيلٌ':Added, #4: 4	وَقْتَ التَّعْجِيلِ
u'وَقْتٌ تَعَذُّرٌ':Added, #1: 1	وَقْتَ التَّعْدِيلِ
u'وَقْتٌ تَعْرِيفٌ':Added, #1: 1	وَقْتِ التَّعَذُّرِ
u'وَقْتٌ تَعْزِيَةٌ':Added, #1: 1	وَقْتَ التَّعْرِيفِ
u'وَقْتٌ تَعَلُّقٌ':Added, #2: 2	وَقْتِ التَّعْزِيَةِ
u'وَقْتٌ تَعَلُّقٌ':Added, #1: 1	وَقْتَ تَعَلُّقِ
u'وَقْتٌ تَعَلُّقٌ':Added, #1: 1	وَقْتُ تَعَلُّقِ
u'وَقْتٌ تَعَلُّمٌ':Added, #2: 2	وَقْتِ تَعَلُّقِ
u'وَقْتٌ تَعْلِيقٌ':Added, #1: 1	وَقْتُ التَّعَلُّمِ
u'وَقْتٌ تَعْلِيقٌ':Added, #1: 1	وَقْتُ تَعْلِيقِ
u'وَقْتٌ تَعْلِيقٌ':Added, #20: 20	وَقْتَ التَّعْلِيقِ
u'وَقْتٌ تَعْمِيرٌ':Added, #7: 7	وَقْتِ التَّعْلِيقِ
u'وَقْتٌ تَعْيِينٌ':Added, #1: 1	وَقْتَ التَّعْمِيرِ
u'وَقْتٌ تَغَيُّرٌ':Added, #1: 1	وَقْتِ التَّعْيِينِ
u'وَقْتٌ تَغَيُّرٌ':Added, #1: 1	وَقْتُ التَّغَيُّرِ
u'وَقْتٌ تَغَيُّرٌ':Added, #1: 1	وَقْتِ التَّغَيُّرِ
u'وَقْتٌ تَغَيُّرٌ':Added, #1: 1	وَقْتَ تَغَيُّرِ
u'وَقْتٌ تَغَيُّرٌ':Added, #1: 1	وَقْتُ تَغَيُّرِ
u'وَقْتٌ تَغَيُّرٌ':Added, #1: 1	وَقْتِ تَغَيُّرِ
u'وَقْتٌ تَفَرُّغٌ':Added, #3: 3	وَقْتَ التَّغَيُّرِ
u'وَقْتٌ تَفَرُّقٌ':Added, #1: 1	وَقْتِ التَّفَرُّغِ
u'وَقْتٌ تَفْرِيقٌ':Added, #1: 1	وَقْتَ التَّفَرُّقِ
u'وَقْتٌ تَفْرِيقٌ':Added, #16: 16	وَقْتِ التَّفْرِيقِ
u'وَقْتٌ تَفْرِيقٌ':Added, #1: 1	وَقْتُ التَّفْرِيقِ
u'وَقْتٌ تَفْوِيضٌ':Added, #1: 1	وَقْتِ تَفْرِيقِ
u'وَقْتٌ تَقَدُّمٌ':Added, #1: 1	وَقْتَ التَّفْوِيضِ
u'وَقْتٌ تَقْديرٌ':Added, #1: 1	وَقْتِ التَّقَدُّمِ
u'وَقْتٌ تَقْديمٌ':Added, #1: 1	وَقْتَ تَقْدِيرِ
u'وَقْتٌ تَقَرُّبٌ':Added, #1: 1	وَقْتَ التَّقْدِيمِ
u'وَقْتٌ تَقْليدٌ':Added, #1: 1	وَقْتُ التَّقَرُّبِ
u'وَقْتٌ تَقْليد':Added, #1: 1	وَقْتَ تَقْلِيدِ
u'وَقْتٌ تَقْليدٌ':Added, #1: 1	وَقْتَ تَقْلِيدِ
u'وَقْتٌ تَقْليد':Added, #4: 4	وَقْتَ التَّقْلِيدِ
u'وَقْتٌ تَقْيِيد':Added, #4: 4	وَقْتَ التَّقْلِيدِ
u'وَقْتٌ تَكْبيرٌ':Added, #1: 1	وَقْتِ التَّقْيِيدِ
u'وَقْتٌ تَكْبيرٌ':Added, #1: 1	وَقْتُ التَّكْبِيرِ
u'وَقْتٌ تَكْفيرٌ':Added, #2: 2	وَقْتَ التَّكْبِيرِ
u'وَقْتٌ تَكْفيرٌ':Added, #2: 2	وَقْتُ التَّكْفِيرِ
u'وَقْتٌ تَكَلُّمٌ':Added, #3: 3	وَقْتَ التَّكْفِيرِ
u'وَقْتٌ تَكَلُّمٌ':Added, #1: 1	وَقْتَ تَكَلُّمِهِ
u'وَقْتٌ تَكَلُّمٌ':Added, #3: 3	وَقْتِ التَّكَلُّمِ
u'وَقْتٌ تَكْليفٌ':Added, #4: 4	وَقْتَ التَّكَلُّمِ
u'وَقْتٌ تَلْبيَةٌ':Added, #1: 1	وَقْتَ التَّكْلِيفِ
u'وَقْتٌ تَلْبيَةٌ':Added, #1: 1	وَقْتِ التَّلْبِيَةِ
u'وَقْتٌ تَلَف':Added, #4: 4	وَقْتِ تَلْبِيَةِ
u'وَقْتٌ تَلَف':Added, #1: 1	وَقْتَ التَّلَفِ
u'وَقْتٌ تَلَفٌ':Added, #1: 1	وَقْتُ التَّلَفِ
u'وَقْتٌ تَلَف':Added, #1: 1	وَقْتَ تَلَفِهِ
u'وَقْتٌ تمام':Added, #3: 3	وَقْتِ التَّلَفِ
u'وَقْتٌ تَمامٌ':Added, #1: 1	وَقْتِ التَّمَامِ
u'وَقْتٌ تَمَكُّنٌ':Added, #1: 1	وَقْتِ التَّمَامِ
u'وَقْتٌ تَمَكُّنٌ':Added, #1: 1	وَقْتَ التَّمَكُّنِ
u'وَقْتٌ تَمَكُّنٌ':Added, #1: 1	وَقْتَ تَمَكُّنِهِ
u'وَقْتٌ تَمْكِين':Added, #2: 2	وَقْتِ التَّمَكُّنِ
u'وَقْتٌ تَمَلُّك':Added, #1: 1	وَقْتِ التَّمْكِينِ
u'وَقْتٌ تَمَلُّك':Added, #1: 1	وَقْتَ التَّمَلُّكِ
u'وَقْتٌ تَنَازُعٌ':Added, #1: 1	وَقْتِ التَّمَلُّكِ
u'وَقْتٌ تَنَاوُلٌ':Added, #1: 1	وَقْتِ التَّنَازُعِ
u'وَقْتٌ تَنْجِيزٌ':Added, #1: 1	وَقْتَ التَّنَاوُلِ
u'وَقْتٌ تَنْجِيزٌ':Added, #1: 1	وَقْتَ تَنْجِيزِ
u'وَقْتٌ تَنَفُّسٌ':Added, #1: 1	وَقْتُ تَنْجِيزِ
u'وَقْتٌ تَنَفُّسٌ':Added, #1: 1	وَقْتُ تَنَفُّسِ
u'وَقْتٌ تَنْفِيذٌ':Added, #1: 1	وَقْتَ تَنَفُّسِهِ
u'وَقْتٌ تَنَقُّبٌ':Added, #1: 1	وَقْتِ التَّنْفِيذِ
u'وَقْتٌ تَهَجُّدٌ':Added, #1: 1	وَقْتَ التَّنَقُّبِ
u'وَقْتٌ تَهْنِئَةٌ':Added, #1: 1	وَقْتُ التَّهَجُّدِ
u'وَقْتٌ تَوَاضُعٌ':Added, #1: 1	وَقْتُ التَّهْنِئَةِ
u'وَقْتٌ تَوَجُّهٌ':Added, #1: 1	وَقْتُ تَوَاضُعٍ
u'وَقْتٌ تَوْزِيعٌ':Added, #2: 2	وَقْتُ تَوَجُّهِ
u'وَقْتٌ تَوَسُّع':Added, #1: 1	وَقْتَ تَوْزِيعِ
u'وَقْتٌ تَوَسُّلٌ':Added, #1: 1	وَقْتُ التَّوَسُّعَةِ
u'وَقْتٌ تَوْقِيفٌ':Added, #1: 1	وَقْتُ التَّوَسُّلِ
u'وَقْتٌ تَوْكِيلٌ':Added, #1: 1	وَقْتُ التّوْقِيفِ
u'وَقْتٌ تَوْكِيلٌ':Added, #1: 1	وَقْتَ تَوْكِيلِهِ
u'وَقْتٌ تَوَهُّمٌ':Added, #8: 8	وَقْتَ التَّوْكِيلِ
u'وَقْتٌ تَيَسُّرٌ':Added, #1: 1	وَقْتَ تَوَهُّمِ
u'وَقْتٌ تَيَقُّنٌ':Added, #1: 1	وَقْتِ تَيَسُّرِهِ
u'وَقْتٌ تَيَمُّمٌ':Added, #1: 1	وَقْتَ التَّيَقُّنِ
u'وَقْتٌ ثَانِي':Added, #1: 1	وَقْتِ التَّيَمُّمِ
u'وَقْتٌ ثَانِي':Added, #2: 2	وَقْتَ الثَّانِيَةِ
u'وَقْتٌ ثَانِي':Added, #49: 49	وَقْتِ الثَّانِيَةِ
u'وَقْتٌ ثَانِيَةٌ':Added, #7: 7	وَقْتُ الثَّانِيَةِ
u'وَقْتٌ ثَانِيَةٌ':Added, #2: 2	وَقْتَ الثَّانِيَةِ
u'وَقْتٌ ثَانِيَةٌ':Added, #49: 49	وَقْتِ الثَّانِيَةِ
u'وَقْتٌ ثُبُوتٌ':Added, #7: 7	وَقْتُ الثَّانِيَةِ
u'وَقْتٌ ثُبُوتٌ':Added, #1: 1	وَقْتَ الثُّبُوتِ
u'وَقْتٌ ثُبُوتٌ':Added, #1: 1	وَقْتِ ثُبُوتِهِ
u'وَقْتٌ ثُبُوتٌ':Added, #3: 3	وَقْتَ ثُبُوتِ
u'وَقْتٌ ثُبُوتٌ':Added, #4: 4	وَقْتِ ثُبُوتِ
u'وَقْتٌ ثَمَرَةٌ':Added, #5: 5	وَقْتُ ثُبُوتِ
u'وَقَّتَ جَازٌ':Predicate, #2: 2	وَقْتِ الثَّمَرَةِ
u'وَقْتٌ جِدٌّ':Added, #1: 1	وَقَّتَ جَازَ
u'وَقْتٌ جداد':Added, #1: 1	وَقْتُ جِدٍّ
u'وَقْتٌ جداد':Added, #1: 1	وَقْتِ الْجِدَادِ
u'وَقْتٌ جداد':Added, #1: 1	وَقْتُ جَدَادِ
u'وَقْتٌ جداد':Added, #2: 2	وَقْتَ الْجِدَادِ
u'وَقْتٌ جَدْب':Added, #2: 2	وَقْتِ الْجَدَادِ
u'وَقْتٌ جَذٌّ':Added, #1: 1	وَقْتَ جَدْبِ
u'وَقْتٌ جُذَاذٌ':Added, #1: 1	وَقْتُ جَذِّهِ
u'وَقْتٌ جُرْحٌ':Added, #4: 4	وَقْتِ الْجُذَاذِ
u'وَقْتٌ جُرْحٌ':Added, #2: 2	وَقْتَ الْجُرْحِ
u'وَقْتٌ جَرَيان':Added, #4: 4	وَقْتِ الْجُرْحِ
u'وَقْتٌ جفاف':Added, #2: 2	وَقْتَ جَرَيَانِ
u'وَقْتٌ جَفَافٌ':Added, #2: 2	وَقْتَ الْجَفَافِ
u'وَقْتٌ جفاف':Added, #2: 2	وَقْتَ الْجَفَافِ
u'وَقْتٌ جَفَافٌ':Added, #3: 3	وَقْتِ الْجَفَافِ
u'وَقْتٌ جَلْبٌ':Added, #3: 3	وَقْتِ الْجَفَافِ
u'وَقْتٌ جُلُوسٌ':Added, #1: 1	وَقْتَ الْجَلْبِ
u'وَقْتٌ جماع':Added, #1: 1	وَقْتَ جُلُوسِهِ
u'وَقْتٌ جِمَاعٌ':Added, #1: 1	وَقْتَ الْجِمَاعِ
u'وَقْتٌ جماع':Added, #1: 1	وَقْتَ الْجِمَاعِ
u'وَقْتٌ جِمَاعٌ':Added, #1: 1	وَقْتُ جِمَاعٍ
u'وَقْتٌ جماع':Added, #1: 1	وَقْتُ جِمَاعٍ
u'وَقْتٌ جِمَاعٌ':Added, #1: 1	وَقْتَ جِمَاعِهِ
u'وَقْتٌ جمع':Added, #1: 1	وَقْتَ جِمَاعِهِ
u'وَقْتٌ جَمْعٌ':Added, #2: 2	وَقْتُ الْجَمْعِ
u'وَقْتٌ جمع':Added, #2: 2	وَقْتُ الْجَمْعِ
u'وَقْتٌ جَمْعٌ':Added, #3: 3	وَقْتِ الْجَمْعِ
u'وَقْتٌ جمعة':Added, #3: 3	وَقْتِ الْجَمْعِ
u'وَقْتٌ جُمُعَةٌ':Added, #15: 15	وَقْتِ الْجُمُعَةِ
u'وَقْتٌ جمعة':Added, #15: 15	وَقْتِ الْجُمُعَةِ
u'وَقْتٌ جُمُعَةٌ':Added, #3: 3	وَقْتَ الْجُمُعَةِ
u'وَقْتٌ جمعة':Added, #3: 3	وَقْتَ الْجُمُعَةِ
u'وَقْتٌ جُمُعَةٌ':Added, #7: 7	وَقْتُ الْجُمُعَةِ
u'وَقْتٌ جَنَابَةٌ':Added, #7: 7	وَقْتُ الْجُمُعَةِ
u'وَقْتٌ جِنَايَةٌ':Added, #1: 1	وَقْتُ الْجَنَابَةِ
u'وَقْتٌ جِنَايَةٌ':Added, #1: 1	وَقْتِ الْجِنَايَةِ
u'وَقْتٌ جِنَايَةٌ':Added, #1: 1	وَقْتِ جِنَايَتِهِ
u'وَقْتٌ جِنَايَةٌ':Added, #4: 4	وَقْتَ جِنَايَتِهِ
u'وَقْتٌ جِنْسٌ':Added, #9: 9	وَقْتَ الْجِنَايَةِ
u'وَقْتٌ جِنْسٌ':Added, #1: 1	وَقْتُ جِنْسِ
u'وَقْتٌ جُنُونٌ':Added, #1: 1	وَقْتِ جِنْسِ
u'وَقْتٌ جهر':Added, #1: 1	وَقْتَ جُنُونِهِ
u'وَقْتٌ جَهْرٌ':Added, #1: 1	وَقْتَ الْجَهْرِ
u'وَقْتٌ جَوَابٌ':Added, #1: 1	وَقْتَ الْجَهْرِ
u'وَقْتٌ جَوَازٌ':Added, #1: 1	وَقْتُ الْجَوَابِ
u'وَقْتٌ جَوَازٌ':Added, #10: 10	وَقْتُ الْجَوَازِ
u'وَقْتٌ جَوَازٌ':Added, #13: 13	وَقْتِ الْجَوَازِ
u'وَقْتٌ جَوَازٌ':Added, #1: 1	وَقْتِ الْجَوَاَزِ
u'وَقْتٌ جَوَازٌ':Added, #2: 2	وَقْتَ الْجَوَازِ
u'وَقْتٌ جَوَازٌ':Added, #2: 2	وَقْتَ جَوَازٍ
u'وَقْتٌ جَوَازٌ':Added, #2: 2	وَقْتَ جَوَازِ
u'وَقْتٌ جَوَازٌ':Added, #6: 6	وَقْتُ جَوَازٍ
u'وَقْتٌ جَوَازٌ':Added, #6: 6	وَقْتِ جَوَازِ
u'وَقْتٌ حاجَةٌ':Added, #7: 7	وَقْتُ جَوَازِ
u'وَقْتٌ حاجَةٌ':Added, #12: 12	وَقْتَ الْحَاجَةِ
u'وَقْتٌ حاجَةٌ':Added, #1: 1	وَقْتَ حَاجَةِ
u'وَقْتٌ حاجَةٌ':Added, #1: 1	وَقْتُ حَاجَةِ
u'وَقْتٌ حاجَةٌ':Added, #2: 2	وَقْتُ الْحَاجَةِ
u'وَقْتٌ حاجَةٌ':Added, #3: 3	وَقْتَ حَاجَتِهِ
u'وَقْتٌ حاجَةٌ':Added, #61: 61	وَقْتِ الْحَاجَةِ
u'وَقْتٌ حاضِرٌ':Added, #6: 6	وَقْتِ حَاجَتِهِ
u'وَقْتٌ حاضِرٌ':Added, #1: 1	وَقْتَ حَاضِرَةٍ
u'وَقْتٌ حاضِرٌ':Added, #4: 4	وَقْتُ الْحَاضِرَةِ
u'وَقْتٌ حَجٌّ':Added, #4: 4	وَقْتِ الْحَاضِرَةِ
u'وَقْتٌ حَجٌّ':Added, #17: 17	وَقْتُ الْحَجِّ
u'وَقْتٌ حَجٌّ':Added, #38: 38	وَقْتِ الْحَجِّ
u'وَقْتٌ حِجَامَةٌ':Added, #4: 4	وَقْتَ الْحَجِّ
u'وَقْتٌ حِجَامَةٌ':Added, #1: 1	وَقْتَ الْحِجَامَةِ
u'وَقْتٌ حَجْرٌ':Added, #1: 1	وَقْتِ الْحِجَامَةِ
u'وَقْتٌ حَجْرٌ':Added, #1: 1	وَقْتِ الْحَجْرِ
u'وَقْتٌ حَدٌّ':Added, #3: 3	وَقْتَ الْحَجْرِ
u'وَقْتٌ حَدَثٌ':Added, #1: 1	وَقْتَ الْحَدِّ
u'وَقْتٌ حَدَثٌ':Added, #12: 12	وَقْتَ الْحَدَثِ
u'وَقْتٌ حَدَثٌ':Added, #17: 17	وَقْتِ الْحَدَثِ
u'وَقْتٌ حُدوثٌ':Added, #1: 1	وَقْتُ الْحَدَثِ
u'وَقْتٌ حُدوثٌ':Added, #1: 1	وَقْتَ حُدُوثِهِ
u'وَقْتٌ حَرٌّ':Added, #4: 4	وَقْتَ حُدُوثِ
u'وَقْتٌ حِراسَةٌ':Added, #1: 1	وَقْتِ الْحَرِّ
u'وَقْتٌ حَرْبٌ':Added, #1: 1	وَقْتَ حِرَاسَةِ
u'وَقْتٌ حَرْبٌ':Added, #1: 1	وَقْتِ الْحَرْبِ
u'وَقْتٌ حَرْثٌ':Added, #2: 2	وَقْتَ الْحَرْبِ
u'وَقْتٌ حَرْقٌ':Added, #1: 1	وَقْتِ الْحَرْثِ
u'وَقْتٌ حُرِّيَّةٌ':Added, #1: 1	وَقْتِ الْحَرْقِ
u'وَقْتٌ حُرِّيَّةٌ':Added, #1: 1	وَقْتَ الْحُرِّيَّةِ
u'وَقْتٌ حُسْنٌ':Added, #1: 1	وَقْتِ حُرِّيَّةِ
u'وَقْتٌ حَشْرٌ':Added, #1: 1	وَقْتِ الْحُسْنِ
u'وَقْتٌ حَصَادٌ':Added, #1: 1	وَقْتِ الْحَشْرِ
u'وَقْتٌ حَصَادٌ':Added, #1: 1	وَقْتُ الْحَصَادِ
u'وَقْتٌ حَصَادٌ':Added, #1: 1	وَقْتَ حَصَادٍ
u'وَقْتٌ حَصَادٌ':Added, #2: 2	وَقْتِ الْحَصَادِ
u'وَقْتٌ حُصُول':Added, #5: 5	وَقْتَ الْحَصَادِ
u'وَقْتٌ حُصُول':Added, #1: 1	وَقْتُ حُصُولِ
u'وَقْتٌ حُضورٌ':Added, #3: 3	وَقْتِ حُصُولِ
u'وَقْتٌ حُضورٌ':Added, #1: 1	وَقْتَ حُضُورِ
u'وَقْتٌ حُضورٌ':Added, #1: 1	وَقْتُ حُضُورٍ
u'وَقْتٌ حُضُورٌ':Added, #1: 1	وَقْتُ حُضُورِ
u'وَقْتٌ حُضُورٌ':Added, #1: 1	وَقْتَ حُضُورِ
u'وَقْتٌ حُضُورٌ':Added, #1: 1	وَقْتُ حُضُورٍ
u'وَقْتٌ حُضورٌ':Added, #1: 1	وَقْتُ حُضُورِ
u'وَقْتٌ حُضُورٌ':Added, #1: 1	وَقْتِ حُضُورِهِ
u'وَقْتٌ حُضورٌ':Added, #1: 1	وَقْتِ حُضُورِهِ
u'وَقْتٌ حُضُورٌ':Added, #2: 2	وَقْتَ حُضُورِهِ
u'وَقْتٌ حَطّ':Added, #2: 2	وَقْتَ حُضُورِهِ
u'وَقْتٌ حَفْرٌ':Added, #3: 3	وَقْتَ الْحَطِّ
u'وَقْتٌ حَقٌّ':Added, #4: 4	وَقْتِ الْحَفْرِ
u'وَقْتٌ حُكْمٌ':Added, #1: 1	وَقْتُ الْحَقَّيْنِ
u'وَقْتٌ حُكْمٌ':Added, #18: 18	وَقْتَ الْحُكْمِ
u'وَقْتٌ حُكْمٌ':Added, #1: 1	وَقْتَ حُكْمِهِ
u'وَقْتٌ حُكْمٌ':Added, #2: 2	وَقْتِ حُكْمِهِ
u'وَقْتٌ حُكْمٌ':Added, #4: 4	وَقْتُ الْحُكْمِ
u'وَقْتٌ حِلٌّ':Added, #6: 6	وَقْتِ الْحُكْمِ
u'وَقْتٌ حَلٌّ':Added, #1: 1	وَقْتُ الْحِلِّ
u'وَقْتٌ حِلٌّ':Added, #1: 1	وَقْتُ حَلِّ
u'وَقْتٌ حِلٌّ':Added, #1: 1	وَقْتُ حِلِّ
u'وَقْتٌ حلاب':Added, #1: 1	وَقْتِ حِلِّ
u'وَقْتٌ حلب':Added, #1: 1	وَقْتِ الْحِلَابِ
u'وَقْتٌ حَلْقٌ':Added, #1: 1	وَقْتَ الْحَلْبِ
u'وَقْتٌ حَلْقٌ':Added, #1: 1	وَقْتُ الْحَلْقِ
u'وَقْتٌ حَلْقٌ':Added, #1: 1	وَقْتِ الْحَلْقِ
u'وَقْتٌ حُلُولٌ':Added, #2: 2	وَقْتَ الْحَلْقِ
u'وَقْتٌ حُلُولٌ':Added, #1: 1	وَقْتَ حُلُولِ
u'وَقْتٌ حُلُولٌ':Added, #1: 1	وَقْتُ حُلُولِ
u'وَقْتٌ حُلُولٌ':Added, #2: 2	وَقْتَ الْحُلُولِ
u'وَقْتٌ حُلُولٌ':Added, #2: 2	وَقْتِ الْحُلُولِ
u'وَقْتٌ حَمْلٌ':Added, #3: 3	وَقْتِ حُلُولِ
u'وَقْتٌ حِنْثٌ':Added, #1: 1	وَقْتَ الْحَمْلِ
u'وَقْتٌ حِنْثٌ':Added, #1: 1	وَقْتُ حِنْثِهِ
u'وَقْتٌ حِنْثٌ':Added, #2: 2	وَقْتَ حِنْثِهِ
u'وَقْتٌ حِنْثٌ':Added, #2: 2	وَقْتِ حِنْثِهِ
u'وَقْتٌ حِنْثٌ':Added, #3: 3	وَقْتَ الْحِنْثِ
u'وَقْتٌ حَوَالَةٌ':Added, #3: 3	وَقْتُ الْحِنْثِ
u'وَقْتٌ حول':Added, #3: 3	وَقْتَ الْحَوَالَةِ
u'وَقْتٌ حَوْلٌ':Added, #2: 2	وَقْتَ الْحَوْلِ
u'وَقْتٌ حَيَاةٌ':Added, #2: 2	وَقْتَ الْحَوْلِ
u'وَقْتٌ حَيَاةٌ':Added, #1: 1	وَقْتَ الْحَيَاةِ
u'وَقْتٌ حَيْضٌ':Added, #1: 1	وَقْتِ الْحَيَاةِ
u'وَقْتٌ حَيْضٌ':Added, #1: 1	وَقْتُ الْحَيْضِ
u'وَقْتٌ حَيْضٌ':Added, #2: 2	وَقْتَ الْحَيْضِ
u'وَقْتٌ حَيْضٌ':Added, #2: 2	وَقْتُ حَيْضٍ
u'وَقْتٌ خَارِجٌ':Added, #4: 4	وَقْتِ الْحَيْضِ
u'وَقْتٌ خَارِجٌ':Added, #1: 1	وَقْتَ الْخَارِجِ
u'وَقْتٌ خَارِجٌ':Added, #1: 1	وَقْتِ الْخَارِجِ
u'وَقْتٌ خاصّ':Added, #2: 2	وَقْتُ الْخَارِجِ
u'وَقْتٌ خامس':Added, #3: 3	وَقْتٍ خَاصٍّ
u'وَقْتٌ خَامِسٌ':Added, #2: 2	وَقْتُ الْخَامِسَةِ
u'وَقْتٌ خامس':Added, #2: 2	وَقْتُ الْخَامِسَةِ
u'وَقْتٌ خَامِسٌ':Added, #3: 3	وَقْتِ الْخَامِسَةِ
u'وَقْتٌ خَبَرٌ':Added, #3: 3	وَقْتِ الْخَامِسَةِ
u'وَقْتٌ خَبَر':Added, #1: 1	وَقْتِ الْخَبَرِ
u'وَقْتٌ ختان':Added, #1: 1	وَقْتِ الْخَبَرِ
u'وَقْتٌ خِتَانٌ':Added, #1: 1	وَقْتِ خِتَانِ
u'وَقْتٌ ختان':Added, #1: 1	وَقْتِ خِتَانِ
u'وَقْتٌ خِتَانٌ':Added, #2: 2	وَقْتُ الْخِتَانِ
u'وَقْتٌ خدمة':Added, #2: 2	وَقْتُ الْخِتَانِ
u'وَقْتٌ خِدْمَةٌ':Added, #1: 1	وَقْتُ الْخِدْمَةِ
u'وَقْتٌ خدمة':Added, #1: 1	وَقْتُ الْخِدْمَةِ
u'وَقْتٌ خِدْمَةٌ':Added, #2: 2	وَقْتِ الْخِدْمَةِ
u'وَقْتٌ خُرُوجٌ':Added, #2: 2	وَقْتِ الْخِدْمَةِ
u'وَقْتٌ خُرُوجٌ':Added, #10: 10	وَقْتِ الْخُرُوجِ
u'وَقْتٌ خُرُوجٌ':Added, #10: 10	وَقْتُ خُرُوجِ
u'وَقْتٌ خُرُوجٌ':Added, #1: 1	وَقْتَ خُرُوجٍ
u'وَقْتٌ خُرُوجٌ':Added, #2: 2	وَقْتِ خُرُوجِ
u'وَقْتٌ خُرُوجٌ':Added, #2: 2	وَقْتَ خُرُوجِهِ
u'وَقْتٌ خُرُوجٌ':Added, #3: 3	وَقْتَ الْخُرُوجِ
u'وَقْتٌ خُرُوجٌ':Added, #4: 4	وَقْتُ الْخُرُوجِ
u'وَقْتٌ خُرُوجٌ':Added, #6: 6	وَقْتِ خُرُوجِهِ
u'وَقْتٌ خَرِيفٌ':Added, #7: 7	وَقْتَ خُرُوجِ
u'وَقْتٌ خَرِيفٌ':Added, #1: 1	وَقْتِ الْخَرِيفِ
u'وَقْتٌ خُصُومَةٌ':Added, #3: 3	وَقْتَ الْخَرِيفِ
u'وَقْتٌ خُصُومَةٌ':Added, #11: 11	وَقْتِ الْخُصُومَةِ
u'وَقْتٌ خِطَابٌ':Added, #15: 15	وَقْتَ الْخُصُومَةِ
u'وَقْتٌ خِطَابٌ':Added, #17: 17	وَقْتِ الْخِطَابِ
u'وَقْتٌ خِطَابٌ':Added, #1: 1	وَقْتُ الْخِطَابِ
u'وَقْتٌ خطبة':Added, #3: 3	وَقْتَ الْخِطَابِ
u'وَقْتٌ خُطْبَةٌ':Added, #1: 1	وَقْتِ الْخُطْبَةِ
u'وَقْتٌ خطبة':Added, #1: 1	وَقْتِ الْخُطْبَةِ
u'وَقْتٌ خُطْبَةٌ':Added, #20: 20	وَقْتَ الْخُطْبَةِ
u'وَقْتٌ خُلْع':Added, #20: 20	وَقْتَ الْخُطْبَةِ
u'وَقْتٌ خُلْعٌ':Added, #1: 1	وَقْتَ الْخُلْعَةِ
u'وَقْتٌ خِلْعَة':Added, #2: 2	وَقْتَ الْخُلْعِ
u'وَقْتٌ خَلَوَاتٌ':Added, #1: 1	وَقْتِ الْخِلْعَةِ
u'وَقْتٌ خَلْوَةٌ':Added, #1: 1	وَقْتِ خَلَوَاتِهِ
u'وَقْتٌ خَلْوَةٌ':Added, #1: 1	وَقْتَ الْخَلْوَةِ
u'وَقْتٌ خَلْوَةٌ':Added, #1: 1	وَقْتُ خَلْوَةٍ
u'وَقْتٌ خَلِيلٌ':Added, #2: 2	وَقْتُ الْخَلْوَةِ
u'وَقْتٌ خيار':Added, #3: 3	وَقْتِ الْخَلِيلِ
u'وَقْتٌ خِيَارٌ':Added, #1: 1	وَقْتُ الْخِيَارِ
u'وَقْتٌ خيار':Added, #1: 1	وَقْتُ الْخِيَارِ
u'وَقْتٌ خِيَارٌ':Added, #7: 7	وَقْتِ الْخِيَارِ
u'وَقْتٌ خِيرَةٌ':Added, #7: 7	وَقْتِ الْخِيَارِ
u'وَقْتٌ دَاخِلٌ':Added, #1: 1	وَقْتَ الْخِيرَةِ
u'وَقْتٌ دُخُولٌ':Added, #1: 1	وَقْتُ الدَّاخِلِ
u'وَقْتٌ دُخُولٌ':Added, #11: 11	وَقْتَ الدُّخُولِ
u'وَقْتٌ دُخُولٌ':Added, #18: 18	وَقْتِ الدُّخُولِ
u'وَقْتٌ دُخُولٌ':Added, #1: 1	وَقْتُ دُخُولِ
u'وَقْتٌ دُخُولٌ':Added, #1: 1	وَقْتِ دُخُولِهِ
u'وَقْتٌ دُخُولٌ':Added, #2: 2	وَقْتُ الدُّخُولِ
u'وَقْتٌ دُعَاءٌ':Added, #3: 3	وَقْتِ دُخُولِ
u'وَقْتٌ دَعَةٌ':Added, #3: 3	وَقْتَ الدُّعَاءِ
u'وَقْتٌ دَعْوَةٌ':Added, #1: 1	وَقْتِ الدَّعَةِ
u'وَقْتٌ دَعْوَةٌ':Added, #12: 12	وَقْتِ الدَّعْوَةِ
u'وَقْتٌ دَعْوَةٌ':Added, #1: 1	وَقْتُ الدَّعْوَةِ
u'وَقْتٌ دَعْوَةٌ':Added, #1: 1	وَقْتَ دَعْوَتِهِ
u'وَقْتٌ دَعْوَةٌ':Added, #1: 1	وَقْتِ دَعْوَتِهِ
u'وَقْتٌ دَعْوَةٌ':Added, #2: 2	وَقْتَ دَعْوَةِ
u'وَقْتٌ دفع':Added, #4: 4	وَقْتَ الدَّعْوَةِ
u'وَقْتٌ دَفْعٌ':Added, #1: 1	وَقْتِ الدَّفْعِ
u'وَقْتٌ دفع':Added, #1: 1	وَقْتِ الدَّفْعِ
u'وَقْتٌ دفع':Added, #1: 1	وَقْتَ دَفْعِ
u'وَقْتٌ دَفْعٌ':Added, #1: 1	وَقْتُ دَفْعِ
u'وَقْتٌ دَفْعٌ':Added, #1: 1	وَقْتَ دَفْعِ
u'وَقْتٌ دفع':Added, #1: 1	وَقْتُ دَفْعِ
u'وَقْتٌ دَفْعٌ':Added, #2: 2	وَقْتُ الدَّفْعِ
u'وَقْتٌ دفع':Added, #2: 2	وَقْتُ الدَّفْعِ
u'وَقْتٌ دَفْعٌ':Added, #9: 9	وَقْتَ الدَّفْعِ
u'وَقْتٌ دفن':Added, #9: 9	وَقْتَ الدَّفْعِ
u'وَقْتٌ دَفْنٌ':Added, #1: 1	وَقْتَ الدَّفْنِ
u'وَقْتٌ دفن':Added, #1: 1	وَقْتَ الدَّفْنِ
u'وَقْتٌ دَفْنٌ':Added, #1: 1	وَقْتِ دَفْنِهِ
u'وَقْتٌ دفن':Added, #1: 1	وَقْتِ دَفْنِهِ
u'وَقْتٌ دَفْنٌ':Added, #2: 2	وَقْتَ دَفْنِهِ
u'وَقْتٌ دَمٌ':Added, #2: 2	وَقْتَ دَفْنِهِ
u'وَقْتٌ دَهْشَةٌ':Added, #1: 1	وَقْتَ دَمِ
u'وَقْتٌ ذكر':Added, #1: 1	وَقْتُ دَهْشَةٍ
u'وَقْتٌ ذِكْرٌ':Added, #1: 1	وَقْتِ الذِّكْرِ
u'وَقْتٌ ذكر':Added, #1: 1	وَقْتِ الذِّكْرِ
u'وَقْتٌ ذِكْرٌ':Added, #2: 2	وَقْتَ ذِكْرِهِ
u'وَقْتٌ ذَهَابٌ':Added, #2: 2	وَقْتَ ذِكْرِهِ
u'وَقْتٌ ذَهَابٌ':Added, #1: 1	وَقْتَ الذَّهَابِ
u'وَقْتٌ ذَهَابٌ':Added, #1: 1	وَقْتِ الذَّهَابِ
u'وَقْتٌ رابع':Added, #1: 1	وَقْتِ ذَهَابِهِ
u'وَقْتٌ رَابِعٌ':Added, #1: 1	وَقْتِ الرَّابِعَةِ
u'وَقْتٌ رابع':Added, #1: 1	وَقْتِ الرَّابِعَةِ
u'وَقْتٌ رَابِعٌ':Added, #3: 3	وَقْتُ الرَّابِعَةِ
u'وَقْتٌ رَاحَةٌ':Added, #3: 3	وَقْتُ الرَّابِعَةِ
u'وَقْتٌ رَبِيعٌ':Added, #1: 1	وَقْتَ الرَّاحَةِ
u'وَقْتٌ رَبِيعٌ':Added, #1: 1	وَقْتِ الرَّبِيعِ
u'وَقْتٌ رُجُوعٌ':Added, #2: 2	وَقْتَ الرَّبِيعِ
u'وَقْتٌ رُجُوعٌ':Added, #1: 1	وَقْتَ رُجُوعِهِ
u'وَقْتٌ رُجُوعٌ':Added, #2: 2	وَقْتِ رُجُوعِهِ
u'وَقْتٌ رُجُوعٌ':Added, #4: 4	وَقْتِ الرُّجُوعِ
u'وَقْتٌ رُخْصَةٌ':Added, #7: 7	وَقْتَ الرُّجُوعِ
u'وَقْتٌ رَدٌّ':Added, #1: 1	وَقْتُ رُخْصَةٍ
u'وَقْتٌ رَدٌّ':Added, #1: 1	وَقْتُ الرَّدِّ
u'وَقْتٌ رَدٌّ':Added, #1: 1	وَقْتِ رَدِّ
u'وَقْتٌ رَدٌّ':Added, #2: 2	وَقْتِ الرَّدِّ
u'وَقْتٌ رِدَّةٌ':Added, #6: 6	وَقْتَ الرَّدِّ
u'وَقْتٌ رِدَّةٌ':Added, #10: 10	وَقْتِ الرِّدَّةِ
u'وَقْتٌ رِدَّةٌ':Added, #1: 1	وَقْتَ رِدَّةِ
u'وَقْتٌ رِدَّةٌ':Added, #2: 2	وَقْتِ رِدَّتِهِ
u'وَقَّتَ رَسُولٌ':Subject, #9: 9	وَقْتَ الرِّدَّةِ
u'وَقْتٌ رضاع':Added, #11: 11	وَقَّتَ رَسُولُ
u'وَقْتٌ رَطْبٌ':Added, #1: 1	وَقْتَ الرَّضَاعِ
u'وَقْتٌ رُطَبٌ':Added, #2: 2	وَقْتِ الرَّطْبِ
u'وَقْتٌ رَعْيٌ':Added, #2: 2	وَقْتِ الرُّطَبِ
u'وَقْتٌ رَفاهِيَةٌ':Added, #1: 1	وَقْتَ الرَّعْيِ
u'وَقْتٌ رَفْضٌ':Added, #1: 1	وَقْتِ الرَّفَاهِيَةِ
u'وَقْتٌ رَفْعٌ':Added, #1: 1	وَقْتِ الرَّفْضِ
u'وَقْتٌ رَفْعٌ':Added, #1: 1	وَقْتِ الرَّفْعِ
u'وَقْتٌ رَفْعٌ':Added, #1: 1	وَقْتَ رَفْعِهِ
u'وَقْتٌ رَفْعٌ':Added, #1: 1	وَقْتِ رَفْعِهِ
u'وَقْتٌ رُكْنٌ':Added, #4: 4	وَقْتَ الرَّفْعِ
u'وَقْتٌ رُكْن':Added, #3: 3	وَقْتِ رُكْنِ
u'وَقْتٌ رُكوعٌ':Added, #3: 3	وَقْتِ رُكْنِ
u'وَقْتٌ رمد':Added, #1: 1	وَقْتُ الرُّكُوعِ
u'وَقْتٌ رَمَدٌ':Added, #1: 1	وَقْتَ الرَّمَدِ
u'وَقْتٌ رَمْيٌ':Added, #1: 1	وَقْتَ الرَّمَدِ
u'وَقْتٌ رَمْيٌ':Added, #11: 11	وَقْتِ الرَّمْيِ
u'وَقْتٌ رَمْيٌ':Added, #13: 13	وَقْتَ الرَّمْيِ
u'وَقْتٌ رَمْيٌ':Added, #1: 1	وَقْتُ رَمْيٍ
u'وَقْتٌ رَمْيٌ':Added, #1: 1	وَقْتُ رَمْيِ
u'وَقْتٌ رَمْيٌ':Added, #1: 1	وَقْتِ رَمْيِ
u'وَقْتٌ رَمْيٌ':Added, #23: 23	وَقْتُ الرَّمْيِ
u'وَقْتٌ رَهْن':Added, #2: 2	وَقْتَ رَمْيِ
u'وَقْتٌ رَهْنٌ':Added, #1: 1	وَقْتَ الرَّهْنِيَّةِ
u'وَقْتٌ رَهْنٌ':Added, #3: 3	وَقْتِ الرَّهْنِ
u'وَقْتٌ رَهْنِيَّة':Added, #7: 7	وَقْتَ الرَّهْنِ
u'وَقْتٌ رَواتِبُ':Added, #1: 1	وَقْتَ الرَّهْنِيَّةِ
u'وَقْتٌ رَوَاتِبُ':Added, #1: 1	وَقْتُ الرَّوَاتِبِ
u'وَقْتٌ رَواحٌ':Added, #1: 1	وَقْتُ الرَّوَاتِبِ
u'وَقْتٌ رِوايَةٌ':Added, #2: 2	وَقْتَ الرَّوَاحِ
u'وَقْتٌ رِوايَةٌ':Added, #1: 1	وَقْتِ الرِّوَايَةِ
u'وَقْتٌ رُؤْيَةٌ':Added, #1: 1	وَقْتَ رِوَايَتِهِ
u'وَقْتٌ رُؤْيَةٌ':Added, #1: 1	وَقْتِ الرُّؤْيَةِ
u'وَقْتٌ رُؤْيَةٌ':Added, #1: 1	وَقْتَ رُؤْيَةِ
u'وَقْتٌ رُؤْيَةٌ':Added, #1: 1	وَقْتِ رُؤْيَةِ
u'وَقْتٌ زِحامٌ':Added, #1: 1	وَقْتِ رُؤْيَتِهِ
u'وَقْتٌ زِراعَةٌ':Added, #1: 1	وَقْتِ الزِّحَامِ
u'وَقْتٌ زِراعَةٌ':Added, #1: 1	وَقْتَ الزِّرَاعَةِ
u'وَقْتٌ زَرْعٌ':Added, #3: 3	وَقْتُ الزِّرَاعَةِ
u'وَقْتٌ زَلْزَلَةٌ':Added, #2: 2	وَقْتِ الزَّرْعِ
u'وَقْتٌ زَمانٌ':Added, #1: 1	وَقْتَ الزَّلْزَلَةِ
u'وَقْتٌ زَوالٌ':Added, #1: 1	وَقْتُ الزَّمَانِ
u'وَقْتٌ زَوالٌ':Added, #14: 14	وَقْتَ الزَّوَالِ
u'وَقْتٌ زَوالٌ':Added, #14: 14	وَقْتِ الزَّوَالِ
u'وَقْتٌ زَوالٌ':Added, #1: 1	وَقْتُ زَوَالِ
u'وَقْتٌ زَوالٌ':Added, #1: 1	وَقْتِ زَوَالِ
u'وَقْتٌ زَوالٌ':Added, #1: 1	وَقْتِ زَوَالِهِ
u'وَقْتٌ زَوالٌ':Added, #2: 2	وَقْتَ زَوَالِهِ
u'وَقْتٌ زَوْجٌ':Added, #6: 6	وَقْتُ الزَّوَالِ
u'وَقْتٌ زِيادَةٌ':Added, #1: 1	وَقْتِ الزَّوْجِ
u'وَقْتٌ زِيادَةٌ':Added, #1: 1	وَقْتَ الزِّيَادَةِ
u'وَقْتٌ زِيادَةٌ':Added, #1: 1	وَقْتِ زِيَادَتِهِ
u'وَقْتٌ سابع':Added, #4: 4	وَقْتِ الزِّيَادَةِ
u'وَقْتٌ سَابعٌ':Added, #3: 3	وَقْتُ السَّابِعَةِ
u'وَقْتٌ سابع':Added, #3: 3	وَقْتُ السَّابِعَةِ
u'وَقْتٌ سَابعٌ':Added, #7: 7	وَقْتِ السَّابِعَةِ
u'وَقْتٌ سَابِقٌ':Added, #7: 7	وَقْتِ السَّابِعَةِ
u'وَقْتٌ سادس':Added, #2: 2	وَقْتٍ سَابِقٍ
u'وَقْتٌ سَادِسٌ':Added, #15: 15	وَقْتِ السَّادِسَةِ
u'وَقْتٌ سادس':Added, #15: 15	وَقْتِ السَّادِسَةِ
u'وَقْتٌ سادس':Added, #1: 1	وَقْتَ السَّادِسَةِ
u'وَقْتٌ سَادِسٌ':Added, #1: 1	وَقْتُ السَّادِسَةِ
u'وَقْتٌ سَادِسٌ':Added, #1: 1	وَقْتَ السَّادِسَةِ
u'وَقْتٌ سباق':Added, #1: 1	وَقْتُ السَّادِسَةِ
u'وَقْتٌ سِبَاقٌ':Added, #2: 2	وَقْتِ سِبَاقِهِ
u'وَقْتٌ سَبَبٌ':Added, #2: 2	وَقْتِ سِبَاقِهِ
u'وَقْتٌ سَبَبٌ':Added, #1: 1	وَقْتَ السَّبَبِ
u'وَقْتٌ سَبَبٌ':Added, #1: 1	وَقْتُ سَبَبِهِ
u'وَقْتٌ سَتْرٌ':Added, #2: 2	وَقْتِ السَّبَبِ
u'وَقْتٌ سُجُودٌ':Added, #2: 2	وَقْتِ السَّتْرِ
u'وَقْتٌ سُجُودٌ':Added, #1: 1	وَقْتَ السُّجُودِ
u'وَقْتٌ سَحَرٌ':Added, #1: 1	وَقْتِ السُّجُودِ
u'وَقْتٌ سَحَرٌ':Added, #1: 1	وَقْتُ السَّحَرِ
u'وَقْتٌ سَحَرٌ':Added, #2: 2	وَقْتِ السَّحَرِ
u'وَقْتٌ سُحُورٌ':Added, #6: 6	وَقْتَ السَّحَرِ
u'وَقْتٌ سَرقَةٌ':Added, #3: 3	وَقْتِ السُّحُورِ
u'وَقْتٌ سَرِقَةٌ':Added, #3: 3	وَقْتَ السَّرِقَةِ
u'وَقْتٌ سَفَرٌ':Added, #3: 3	وَقْتَ السَّرِقَةِ
u'وَقْتٌ سُقُوطٌ':Added, #2: 2	وَقْتِ سَفَرٍ
u'وَقْتٌ سُقُوطٌ':Added, #1: 1	وَقْتَ السُّقُوطِ
u'وَقْتٌ سُقُوطٌ':Added, #1: 1	وَقْتِ سُقُوطِهِ
u'وَقْتٌ سُقُوطٌ':Added, #2: 2	وَقْتِ السُّقُوطِ
u'وَقْتٌ سُقُوطٌ':Added, #2: 2	وَقْتُ سُقُوطِ
u'وَقْتٌ سَقْيٌ':Added, #3: 3	وَقْتِ سُقُوطِ
u'وَقْتٌ سَقْيٌ':Added, #1: 1	وَقْتَ السَّقْيِ
u'وَقْتٌ سكر':Added, #1: 1	وَقْتِ السَّقْيِ
u'وَقْتٌ سُكْرٌ':Added, #1: 1	وَقْتِ السُّكْرِ
u'وَقْتٌ سُكُونٌ':Added, #1: 1	وَقْتِ السُّكْرِ
u'وَقْتٌ سُكُونٌ':Added, #1: 1	وَقْتُ السُّكُونِ
u'وَقْتٌ سلام':Added, #1: 1	وَقْتُ سُكُونِهِ
u'وَقْتٌ سَلاَمٌ':Added, #1: 1	وَقْتَ السَّلَامِ
u'وَقْتٌ سلام':Added, #1: 1	وَقْتَ السَّلَامِ
u'وَقْتٌ سَلاَمٌ':Added, #2: 2	وَقْتُ السَّلَامِ
u'وَقْتٌ سَلْطَنَةٌ':Added, #2: 2	وَقْتُ السَّلَامِ
u'وَقْتٌ سَمَاعٌ':Added, #1: 1	وَقْتِ سَلْطَنَتِهِ
u'وَقْتٌ سَمَاعٌ':Added, #2: 2	وَقْتَ السَّمَاعِ
u'وَقْتٌ سَنَةٌ':Added, #4: 4	وَقْتِ السَّمَاعِ
u'وَقْتٌ سُنَّةٌ':Added, #1: 1	وَقْتُ السَّنَةِ
u'وَقْتٌ سُنَّةٌ':Added, #1: 1	وَقْتُ سُنَّةٍ
u'وَقْتٌ سَنَةٌ':Added, #21: 21	وَقْتِ السُّنَّةِ
u'وَقْتٌ سُنَّةٌ':Added, #4: 4	وَقْتِ السَّنَةِ
u'وَقْتٌ سُنَّةٌ':Added, #5: 5	وَقْتَ السُّنَّةِ
u'وَقْتٌ سُنِّيٌّ':Added, #6: 6	وَقْتُ السُّنَّةِ
u'وَقْتٌ سَهْوٌ':Added, #1: 1	وَقْتِ السُّنِّيِّ
u'وَقْتٌ سُؤَالٌ':Added, #2: 2	وَقْتَ السَّهْوِ
u'وَقْتٌ سُؤَالٌ':Added, #1: 1	وَقْتُ سُؤَالِ
u'وَقْتٌ سُؤَالٌ':Added, #1: 1	وَقْتَ سُؤَالِهِ
u'وَقْتٌ سَيْرٌ':Added, #3: 3	وَقْتِ السُّؤَالِ
u'وَقْتٌ شِتَاءٌ':Added, #2: 2	وَقْتَ السَّيْرِ
u'وَقْتٌ شِتَاءٌ':Added, #1: 1	وَقْتَ الشِّتَاءِ
u'وَقْتٌ شِدَّةٌ':Added, #1: 1	وَقْتِ الشِّتَاءِ
u'وَقْتٌ شِرَاءٌ':Added, #1: 1	وَقْتِ الشِّدَّةِ
u'وَقْتٌ شِرَاءٌ':Added, #1: 1	وَقْتَ شِرَاءِ
u'وَقْتٌ شِرَاءٌ':Added, #2: 2	وَقْتِ شِرَاءِ
u'وَقْتٌ شِرَاءٌ':Added, #3: 3	وَقْتُ الشِّرَاءِ
u'وَقْتٌ شِرَاءٌ':Added, #42: 42	وَقْتِ الشِّرَاءِ
u'وَقْتٌ شرب':Added, #55: 55	وَقْتَ الشِّرَاءِ
u'وَقْتٌ شُرْبٌ':Added, #1: 1	وَقْتَ الشُّرْبِ
u'وَقْتٌ شَرْطٌ':Added, #1: 1	وَقْتَ الشُّرْبِ
u'وَقْتٌ شَرْطٌ':Added, #1: 1	وَقْتَ شَرْطِ
u'وَقْتٌ شَرْطٌ':Added, #1: 1	وَقْتِ شَرْطِ
u'وَقْتٌ شَرْطٌ':Added, #2: 2	وَقْتَ الشَّرْطِ
u'وَقْتٌ شركة':Added, #2: 2	وَقْتِ الشَّرْطِ
u'وَقْتٌ شَرِكَةٌ':Added, #2: 2	وَقْتَ الشَّرِكَةِ
u'وَقْتٌ شُرُوعٌ':Added, #2: 2	وَقْتَ الشَّرِكَةِ
u'وَقْتٌ شُرُوعٌ':Added, #1: 1	وَقْتُ الشُّرُوعِ
u'وَقْتٌ شُرُوعٌ':Added, #1: 1	وَقْتِ الشُّرُوعِ
u'وَقْتٌ شُرُوقٌ':Added, #7: 7	وَقْتَ الشُّرُوعِ
u'وَقْتٌ شُغْلٌ':Added, #1: 1	وَقْتُ الشُّرُوقِ
u'وَقْتٌ شُغْلٌ':Added, #1: 1	وَقْتُ شُغْلٍ
u'وَقْتٌ شُغْل':Added, #1: 1	وَقْتِ شُغْلٍ
u'وَقْتٌ شُغْل':Added, #1: 1	وَقْتُ شُغْلٍ
u'وَقْتٌ شَكٌّ':Added, #1: 1	وَقْتِ شُغْلٍ
u'وَقْتٌ شَكٌّ':Added, #2: 2	وَقْتَ الشَّكِّ
u'وَقْتٌ شَهَادَةٌ':Added, #2: 2	وَقْتِ الشَّكِّ
u'وَقْتٌ شَهَادَةٌ':Added, #15: 15	وَقْتَ الشَّهَادَةِ
u'وَقَّتَ شُهُودٌ':Subject, #3: 3	وَقْتِ الشَّهَادَةِ
u'وَقَّتَ شُهُودٌ':Subject, #1: 1	وَقَّتَ شُهُودُ
u'وَقَّتَ شُهُودٌ':Subject, #1: 1	وَقَّتَ شُهُودُهُ
u'وَقَّتَ صَاحِبٌ':Subject, #3: 3	وَقَّتَ الشُّهُودُ
u'وَقْتٌ صَاحِبٌ':Added, #1: 1	وَقَّتَ صَاحِبُهُ
u'وَقْتٌ صباح':Added, #3: 3	وَقْتُ صَاحِبِ
u'وَقْتٌ صَبَاحٌ':Added, #1: 1	وَقْتَ الصَّبَاحِ
u'وَقْتٌ صُبْحٌ':Added, #1: 1	وَقْتَ الصَّبَاحِ
u'وَقْتٌ صُبْحٌ':Added, #1: 1	وَقْتُ الصُّبْحِ
u'وَقْتٌ صُبْحٌ':Added, #3: 3	وَقْتَ الصُّبْحِ
u'وَقْتٌ صِحَّةٌ':Added, #9: 9	وَقْتِ الصُّبْحِ
u'وَقْتٌ صِحَّةٌ':Added, #1: 1	وَقْتِ صِحَّةِ
u'وَقْتٌ صدقة':Added, #1: 1	وَقْتِ صِحَّتِهِ
u'وَقْتٌ صَدَقَةٌ':Added, #1: 1	وَقْتُ الصَّدَقَةِ
u'وَقْتٌ صَرْفٌ':Added, #1: 1	وَقْتُ الصَّدَقَةِ
u'وَقْتٌ صَرْفٌ':Added, #1: 1	وَقْتَ الصَّرْفِ
u'وَقْتٌ صَرْف':Added, #1: 1	وَقْتُ الصَّرْفِ
u'وَقْتٌ صَرْف':Added, #1: 1	وَقْتَ الصَّرْفِ
u'وَقْتٌ صَلاَةٌ':Added, #1: 1	وَقْتُ الصَّرْفِ
u'وَقْتٌ صَلاَةٌ':Added, #12: 12	وَقْتِ الصَّلاَةِ
u'وَقْتٌ صَلاَةٌ':Added, #15: 15	وَقْتَ الصَّلَاةِ
u'وَقْتٌ صَلاَةٌ':Added, #17: 17	وَقْتُ صَلَاةِ
u'وَقْتٌ صَلاَةٌ':Added, #19: 19	وَقْتَ صَلَاةٍ
u'وَقْتٌ صَلاَةٌ':Added, #1: 1	وَقْتُ الصَّلاةِ
u'وَقْتٌ صَلاَةٌ':Added, #1: 1	وَقْتُ الصَّلاَةِ
u'وَقْتٌ صَلاَةٌ':Added, #1: 1	وَقْتِ صَلاةٍ
u'وَقْتٌ صَلاَةٌ':Added, #1: 1	وَقْتِ صَلاةِ
u'وَقْتٌ صَلاَةٌ':Added, #1: 1	وَقْت صَلَاةِ
u'وَقْتٌ صَلاَةٌ':Added, #1: 1	وَقْتِ صَلاَتِهِ
u'وَقْتٌ صَلاَةٌ':Added, #34: 34	وَقْتِ صَلَاةٍ
u'وَقْتٌ صَلاَةٌ':Added, #3: 3	وَقْتِ الصَّلاةِ
u'وَقْتٌ صَلاَةٌ':Added, #4: 4	وَقْتُ صَلاَةِ
u'وَقْتٌ صَلاَةٌ':Added, #4: 4	وَقْتِ صَلاَةٍ
u'وَقْتٌ صَلاَةٌ':Added, #5: 5	وَقْتَ الصَّلاَةِ
u'وَقْتٌ صَلاَةٌ':Added, #67: 67	وَقْتُ صَلَاةٍ
u'وَقْتٌ صَلاَةٌ':Added, #73: 73	وَقْتُ الصَّلَاةِ
u'وَقْتٌ صَلاَةٌ':Added, #7: 7	وَقْتِ صَلاَةِ
u'وَقْتٌ صَلاَةٌ':Added, #96: 96	وَقْتِ الصَّلَاةِ
u'وَقْتٌ صَلاَةٌ':Added, #9: 9	وَقْتَ صَلَاةِ
u'وَقْتٌ صَلاَحٌ':Added, #9: 9	وَقْتِ صَلَاةِ
u'وَقْتٌ صَلاَحٌ':Added, #1: 1	وَقْتَ صَلَاحِ
u'وَقْتٌ صَلاَحٌ':Added, #1: 1	وَقْتُ صَلَاحِ
u'وَقْتٌ صلح':Added, #1: 1	وَقْتِ صَلَاحِهِ
u'وَقْتٌ صُلْحٌ':Added, #2: 2	وَقْتِ الصُّلْحِ
u'وَقْتٌ صلح':Added, #2: 2	وَقْتِ الصُّلْحِ
u'وَقْتٌ صُلْحٌ':Added, #5: 5	وَقْتَ الصُّلْحِ
u'وَقْتٌ صَلَوَاتٌ':Added, #5: 5	وَقْتَ الصُّلْحِ
u'وَقْتٌ صَلَوَاتٌ':Added, #1: 1	وَقْتَ الصَّلَوَاتِ
u'وَقْتٌ صَوْمٌ':Added, #1: 1	وَقْتِ الصَّلَوَاتِ
u'وَقْتٌ صَوْمٌ':Added, #3: 3	وَقْتُ الصَّوْمِ
u'وَقْتٌ صَوْمٌ':Added, #4: 4	وَقْتَ الصَّوْمِ
u'وَقْتٌ صِيَامٌ':Added, #9: 9	وَقْتِ الصَّوْمِ
u'وَقْتٌ صِيَامٌ':Added, #1: 1	وَقْتِ الصِّيَامِ
u'وَقْتٌ ضَحْوَةٌ':Added, #2: 2	وَقْتُ الصِّيَامِ
u'وَقْتٌ ضَحْوَةٌ':Added, #1: 1	وَقْتُ الضَّحْوَةِ
u'وَقْتٌ ضَحْوَةٌ':Added, #3: 3	وَقْتَ الضَّحْوَةِ
u'وَقْتٌ ضراب':Added, #4: 4	وَقْتِ الضَّحْوَةِ
u'وَقْتٌ ضَرْبٌ':Added, #1: 1	وَقْتِ الضّرَابِ
u'وَقْتٌ ضَرْبٌ':Added, #1: 1	وَقْتِ ضَرْبِهِ
u'وَقْتٌ ضَرْبٌ':Added, #2: 2	وَقْتَ ضَرْبِهِ
u'وَقْتٌ ضَرْبٌ':Added, #3: 3	وَقْتَ الضَّرْبِ
u'وَقْتٌ ضَرُورَةٌ':Added, #4: 4	وَقْتِ الضَّرْبِ
u'وَقْتٌ ضَرُورَةٌ':Added, #13: 13	وَقْتِ الضَّرُورَةِ
u'وَقْتٌ ضَرُورَةٌ':Added, #1: 1	وَقْتَ الضَّرُورَةِ
u'وَقْتٌ ضَرُورَةٌ':Added, #2: 2	وَقْتَ ضَرُورَةٍ
u'وَقْتٌ ضَرُورَةٌ':Added, #3: 3	وَقْتُ الضَّرُورَةِ
u'وَقْتٌ ضَرُورَةٌ':Added, #3: 3	وَقْتِ ضَرُورَةٍ
u'وَقْتٌ ضَمٌّ':Added, #6: 6	وَقْتُ ضَرُورَةٍ
u'وَقْتٌ ضَمَانٌ':Added, #1: 1	وَقْتِ الضَّمِّ
u'وَقْتٌ ضَمَانٌ':Added, #1: 1	وَقْتِ الضَّمَانِ
u'وَقْتٌ ضَمَانٌ':Added, #1: 1	وَقْتِ ضَمَانِهِ
u'وَقْتٌ ضَمَانٌ':Added, #2: 2	وَقْتَ الضَّمَانِ
u'وَقْتٌ ضَيَاعٌ':Added, #2: 2	وَقْتَ ضَمَانِ
u'وَقْتٌ طَاعُونٌ':Added, #1: 1	وَقْتَ ضَيَاعِهِ
u'وَقْتٌ طَلاَقٌ':Added, #1: 1	وَقْتَ الطَّاعُونِ
u'وَقْتٌ طَلاَقٌ':Added, #1: 1	وَقْتُ الطَّلَاقِ
u'وَقْتٌ طَلاَقٌ':Added, #1: 1	وَقْت طَلَاقِ
u'وَقْتٌ طَلاَقٌ':Added, #1: 1	وَقْتُ طَلَاقٍ
u'وَقْتٌ طَلاَقٌ':Added, #1: 1	وَقْتُ طَلَاقِ
u'وَقْتٌ طَلاَقٌ':Added, #1: 1	وَقْتُ طَلَاقِهِ
u'وَقْتٌ طَلاَقٌ':Added, #21: 21	وَقْتَ الطَّلَاقِ
u'وَقْتٌ طَلاَقٌ':Added, #4: 4	وَقْتِ طَلَاقِ
u'وَقْتٌ طلب':Added, #89: 89	وَقْتِ الطَّلَاقِ
u'وَقْتٌ طَلَبٌ':Added, #1: 1	وَقْتُ الطَّلَبِ
u'وَقْتٌ طلب':Added, #1: 1	وَقْتُ الطَّلَبِ
u'وَقْتٌ طَلَبٌ':Added, #1: 1	وَقْتُ طَلَبِ
u'وَقْتٌ طَلَبٌ':Added, #1: 1	وَقْتَ طَلَبٍ
u'وَقْتٌ طلب':Added, #1: 1	وَقْتُ طَلَبِ
u'وَقْتٌ طَلَبٌ':Added, #5: 5	وَقْتَ الطَّلَبِ
u'وَقْتٌ طَلْعٌ':Added, #5: 5	وَقْتَ الطَّلَبِ
u'وَقْتٌ طُلُوعٌ':Added, #2: 2	وَقْتِ الطَّلْعِ
u'وَقْتٌ طُلُوعٌ':Added, #11: 11	وَقْتِ طُلُوعِ
u'وَقْتٌ طُلُوعٌ':Added, #12: 12	وَقْتَ طُلُوعِ
u'وَقْتٌ طُلُوعٌ':Added, #1: 1	وَقْتُ الطُّلُوعِ
u'وَقْتٌ طُلُوعٌ':Added, #1: 1	وَقْتَ طُلُوعِهِ
u'وَقْتٌ طُلُوعٌ':Added, #3: 3	وَقْتِ الطُّلُوعِ
u'وَقْتٌ طُلُوعٌ':Added, #3: 3	وَقْتُ طُلُوعِ
u'وَقْتٌ طَهَارَةٌ':Added, #5: 5	وَقْتَ الطُّلُوعِ
u'وَقْتٌ طهر':Added, #3: 3	وَقْتَ الطَّهَارَةِ
u'وَقْتٌ طهر':Added, #2: 2	وَقْتَ الطُّهْرِ
u'وَقْتٌ طُهْرٌ':Added, #2: 2	وَقْتُ الطُّهْرِ
u'وَقْتٌ طُهْرٌ':Added, #2: 2	وَقْتَ الطُّهْرِ
u'وَقْتٌ طواف':Added, #2: 2	وَقْتُ الطُّهْرِ
u'وَقْتٌ طَوَافٌ':Added, #1: 1	وَقْتَ طَوَافِهِ
u'وَقْتٌ طواف':Added, #1: 1	وَقْتَ طَوَافِهِ
u'وَقْتٌ طواف':Added, #2: 2	وَقْتُ الطَّوَافِ
u'وَقْتٌ طَوَافٌ':Added, #2: 2	وَقْتِ الطَّوَافِ
u'وَقْتٌ طَوَافٌ':Added, #2: 2	وَقْتُ الطَّوَافِ
u'وَقْتٌ طواف':Added, #2: 2	وَقْتِ الطَّوَافِ
u'وَقْتٌ طَوَافٌ':Added, #2: 2	وَقْتِ طَوَافِ
u'وَقْتٌ طواف':Added, #2: 2	وَقْتِ طَوَافِ
u'وَقْتٌ طَوَافٌ':Added, #2: 2	وَقْتُ طَوَافِهِ
u'وَقْتٌ طواف':Added, #2: 2	وَقْتُ طَوَافِهِ
u'وَقْتٌ طَوَافٌ':Added, #3: 3	وَقْتَ الطَّوَافِ
u'وَقْتٌ طواف':Added, #3: 3	وَقْتَ الطَّوَافِ
u'وَقْتٌ طَوَافٌ':Added, #3: 3	وَقْتُ طَوَافِ
u'وَقْتٌ طواف':Added, #3: 3	وَقْتُ طَوَافِ
u'وَقْتٌ طَوَافٌ':Added, #4: 4	وَقْتَ طَوَافِ
u'وَقْتٌ طِيبٌ':Added, #4: 4	وَقْتَ طَوَافِ
u'وَقْتٌ ظلمة':Added, #1: 1	وَقْتِ الطِّيبِ
u'وَقْتٌ ظُلْمَةٌ':Added, #1: 1	وَقْتُ الظُّلْمَةِ
u'وَقْتٌ ظهار':Added, #1: 1	وَقْتُ الظُّلْمَةِ
u'وَقْتٌ ظهار':Added, #1: 1	وَقْتَ الظِّهَارِ
u'وَقْتٌ ظُهْرٌ':Added, #2: 2	وَقْتُ الظِّهَارِ
u'وَقْتٌ ظُهْرٌ':Added, #1: 1	وَقْتَ ظُهْرٍ
u'وَقْتٌ ظُهْرٌ':Added, #1: 1	وَقْتِ ظُهْرٍ
u'وَقْتٌ ظُهْرٌ':Added, #20: 20	وَقْتَ الظُّهْرِ
u'وَقْتٌ ظُهْرٌ':Added, #2: 2	وَقْتِ ظُهْرِ
u'وَقْتٌ ظُهْرٌ':Added, #75: 75	وَقْتُ الظُّهْرِ
u'وَقْتٌ ظُهورٌ':Added, #98: 98	وَقْتِ الظُّهْرِ
u'وَقْتٌ ظُهورٌ':Added, #1: 1	وَقْتُ ظُهُورِ
u'وَقْتٌ ظُهورٌ':Added, #2: 2	وَقْتِ الظُّهُورِ
u'وَقْتٌ عَادَةٌ':Added, #2: 2	وَقْتَ ظُهُورِ
u'وَقْتٌ عَادَةٌ':Added, #2: 2	وَقْتَ الْعَادَةِ
u'وَقَّتَ عارِيَّةٌ':Predicate, #4: 4	وَقْتِ الْعَادَةِ
u'وَقْتٌ عِبَادَةٌ':Added, #4: 4	وَقَّتَ الْعَارِيَّةَ
u'وَقْتٌ عِبَادَةٌ':Added, #2: 2	وَقْتَ الْعِبَادَةِ
u'وَقْتٌ عتاق':Added, #2: 2	وَقْتِ الْعِبَادَةِ
u'وَقْتٌ عتق':Added, #1: 1	وَقْتَ الْعَتَاقِ
u'وَقْتٌ عِتْقٌ':Added, #16: 16	وَقْتِ الْعِتْقِ
u'وَقْتٌ عتق':Added, #16: 16	وَقْتِ الْعِتْقِ
u'وَقْتٌ عتق':Added, #1: 1	وَقْتِ الْعَتْقِ
u'وَقْتٌ عِتْقٌ':Added, #1: 1	وَقْتِ عِتْقِهِ
u'وَقْتٌ عتق':Added, #1: 1	وَقْتِ عِتْقِهِ
u'وَقْتٌ عِتْقٌ':Added, #2: 2	وَقْتَ عِتْقِهِ
u'وَقْتٌ عتق':Added, #2: 2	وَقْتَ عِتْقِهِ
u'وَقْتٌ عِتْقٌ':Added, #4: 4	وَقْتِ عِتْقِ
u'وَقْتٌ عتق':Added, #4: 4	وَقْتِ عِتْقِ
u'وَقْتٌ عِتْقٌ':Added, #5: 5	وَقْتَ الْعِتْقِ
u'وَقْتٌ عجز':Added, #5: 5	وَقْتَ الْعِتْقِ
u'وَقْتٌ عَجْزٌ':Added, #2: 2	وَقْتَ عَجْزِ
u'وَقْتٌ عِدَّةٌ':Added, #2: 2	وَقْتَ عَجْزِ
u'وَقْتٌ عَدَمٌ':Added, #1: 1	وَقْتِ الْعِدَّةِ
u'وَقْتٌ عَدَمٌ':Added, #1: 1	وَقْتِ الْعَدَمِ
u'وَقْتٌ عُدُولٌ':Added, #1: 1	وَقْتِ عَدَمِ
u'وَقْتٌ عُذْرٌ':Added, #1: 1	وَقْتُ الْعُدُولِ
u'وَقْتٌ عُذْرٌ':Added, #1: 1	وَقْتُ عُذْرٍ
u'وَقْتٌ عُذْرٌ':Added, #1: 1	وَقْتِ عُذْرٍ
u'وَقْتٌ عِزَّةٌ':Added, #2: 2	وَقْتِ الْعُذْرِ
u'وَقْتٌ عزل':Added, #1: 1	وَقْتِ عِزَّةِ
u'وَقْتٌ عَزْمٌ':Added, #1: 1	وَقْتِ الْعَزْلِ
u'وَقْتٌ عِشَاءٌ':Added, #1: 1	وَقْتَ الْعَزْمِ
u'وَقْتٌ عِشَاءٌ':Added, #18: 18	وَقْتُ الْعِشَاءِ
u'وَقْتٌ عِشَاءٌ':Added, #60: 60	وَقْتِ الْعِشَاءِ
u'وَقْتٌ عَصْرٌ':Added, #8: 8	وَقْتَ الْعِشَاءِ
u'وَقْتٌ عَصْرٌ':Added, #14: 14	وَقْتَ الْعَصْرِ
u'وَقْتٌ عَصْرٌ':Added, #1: 1	وَقْتُ عَصْرِ
u'وَقْتٌ عَصْرٌ':Added, #52: 52	وَقْتُ الْعَصْرِ
u'وَقْتٌ عَطَاءٌ':Added, #99: 99	وَقْتِ الْعَصْرِ
u'وَقْتٌ عَطَاءٌ':Added, #2: 2	وَقْتَ الْعَطَاءِ
u'وَقْتٌ عَطَاءٌ':Added, #2: 2	وَقْتِ الْعَطَاءِ
u'وَقَّتَ عَفْوٌ':Predicate, #3: 3	وَقْتُ الْعَطَاءِ
u'وَقْتٌ عَقْدٌ':Added, #1: 1	وَقَّتَ الْعَفْوَ
u'وَقْتٌ عَقْدٌ':Added, #136: 136	وَقْتَ الْعَقْدِ
u'وَقْتٌ عَقْدٌ':Added, #1: 1	وَقْتِ عَقْدِ
u'وَقْتٌ عَقْدٌ':Added, #53: 53	وَقْتِ الْعَقْدِ
u'وَقْتٌ عَقْدٌ':Added, #5: 5	وَقْتُ الْعَقْدِ
u'وَقْتٌ عَقِيقَةٌ':Added, #7: 7	وَقْتَ عَقْدِ
u'وَقْتٌ علم':Added, #1: 1	وَقْتِ الْعَقِيقَةِ
u'وَقْتٌ علم':Added, #1: 1	وَقْتَ الْعِلْمِ
u'وَقْتٌ علم':Added, #1: 1	وَقْتُ الْعِلْمِ
u'وَقْتٌ عِلْمٌ':Added, #1: 1	وَقْتِ الْعِلْمِ
u'وَقْتٌ عِلْمٌ':Added, #1: 1	وَقْتَ الْعِلْمِ
u'وَقْتٌ عِلْمٌ':Added, #1: 1	وَقْتُ الْعِلْمِ
u'وَقْتٌ علم':Added, #1: 1	وَقْتِ الْعِلْمِ
u'وَقْتٌ عِلْمٌ':Added, #1: 1	وَقْتُ عِلْمٍ
u'وَقْتٌ علم':Added, #1: 1	وَقْتُ عِلْمٍ
u'وَقْتٌ علم':Added, #3: 3	وَقْتَ عِلْمِهِ
u'وَقْتٌ عِلْمٌ':Added, #3: 3	وَقْتِ عِلْمِهِ
u'وَقْتٌ عِلْمٌ':Added, #3: 3	وَقْتَ عِلْمِهِ
u'وَقْتٌ عُلُوقٌ':Added, #3: 3	وَقْتِ عِلْمِهِ
u'وَقْتٌ عُلُوقٌ':Added, #1: 1	وَقْتُ الْعُلُوقِ
u'وَقْتٌ عُلُوقٌ':Added, #40: 40	وَقْتِ الْعُلُوقِ
u'وَقْتٌ عمرة':Added, #5: 5	وَقْتَ الْعُلُوقِ
u'وَقْتٌ عُمْرَةٌ':Added, #2: 2	وَقْتَ الْعُمْرَةِ
u'وَقْتٌ عمرة':Added, #2: 2	وَقْتَ الْعُمْرَةِ
u'وَقْتٌ عُمْرَةٌ':Added, #6: 6	وَقْتُ الْعُمْرَةِ
u'وَقْتٌ عَمَلٌ':Added, #6: 6	وَقْتُ الْعُمْرَةِ
u'وَقْتٌ عَمَلٌ':Added, #1: 1	وَقْتُ عَمَلِ
u'وَقْتٌ عَمَلٌ':Added, #1: 1	وَقْتِ عَمَلِهِ
u'وَقْتٌ عَمَلٌ':Added, #28: 28	وَقْتِ الْعَمَلِ
u'وَقْتٌ عَمَلٌ':Added, #2: 2	وَقْتَ الْعَمَلِ
u'وَقْتٌ عُمُومٌ':Added, #6: 6	وَقْتُ الْعَمَلِ
u'وَقْتٌ عَهْدٌ':Added, #1: 1	وَقْتِ عُمُومِ
u'وَقْتٌ عَهْدٌ':Added, #1: 1	وَقْتَ الْعَهْدِ
u'وَقْتٌ عُهْدَةٌ':Added, #1: 1	وَقْتِ الْعَهْدِ
u'وَقْتٌ عَوْدٌ':Added, #1: 1	وَقْتُ الْعُهْدَةِ
u'وَقْتٌ عِيَادَةٌ':Added, #1: 1	وَقْتُ الْعَوْدِ
u'وَقْتٌ عِيَادَةٌ':Added, #1: 1	وَقْتَ عِيَادَةٍ
u'وَقْتٌ عِيدٌ':Added, #2: 2	وَقْتُ عِيَادَةٍ
u'وَقْتٌ عِيدٌ':Added, #1: 1	وَقْتِ الْعِيدِ
u'وَقْتٌ غَدَاءٌ':Added, #5: 5	وَقْتَ الْعِيدِ
u'وَقْتٌ غَدَاءٌ':Added, #1: 1	وَقْتِ الْغَدَاءِ
u'وَقْتٌ غِرَاسٌ':Added, #2: 2	وَقْتُ الْغَدَاءِ
u'وَقْتٌ غُرَّةٌ':Added, #1: 1	وَقْتَ الْغِرَاسِ
u'وَقْتٌ غَرْسٌ':Added, #1: 1	وَقْتَ الْغُرَّةِ
u'وَقْتٌ غُرُوبٌ':Added, #2: 2	وَقْتَ الْغَرْسِ
u'وَقْتٌ غُرُوبٌ':Added, #11: 11	وَقْتَ الْغُرُوبِ
u'وَقْتٌ غُرُوبٌ':Added, #2: 2	وَقْتِ الْغُرُوبِ
u'وَقْتٌ غُرُوبٌ':Added, #2: 2	وَقْتُ غُرُوبِ
u'وَقْتٌ غُرُوبٌ':Added, #4: 4	وَقْتُ الْغُرُوبِ
u'وَقْتٌ غَسْلٌ':Added, #5: 5	وَقْتِ غُرُوبِ
u'وَقْتٌ غُسْلٌ':Added, #1: 1	وَقْتِ الْغَسْلِ
u'وَقْتٌ غُسْلٌ':Added, #2: 2	وَقْتُ الْغُسْلِ
u'وَقْتٌ غُسْلٌ':Added, #2: 2	وَقْتِ الْغُسْلِ
u'وَقْتٌ غَشَيان':Added, #3: 3	وَقْتَ الْغُسْلِ
u'وَقْتٌ غَصْبٌ':Added, #1: 1	وَقْتَ الْغَشَيَانِ
u'وَقْتٌ غَصْبٌ':Added, #13: 13	وَقْتِ الْغَصْبِ
u'وَقْتٌ غَصْبٌ':Added, #1: 1	وَقْتِ غَصْبِهِ
u'وَقْتٌ غضب':Added, #9: 9	وَقْتَ الْغَصْبِ
u'وَقْتٌ غَضَبٌ':Added, #1: 1	وَقْتَ الْغَضَبِ
u'وَقْتٌ غضب':Added, #1: 1	وَقْتَ الْغَضَبِ
u'وَقْتٌ غَضَبٌ':Added, #1: 1	وَقْتَ غَضَبِهِ
u'وَقْتٌ غَضَبٌ':Added, #1: 1	وَقْتَ غَضَبِهِ
u'وَقْتٌ غُفْرَانٌ':Added, #2: 2	وَقْتَ غَضَبٍ
u'وَقْتٌ غفلة':Added, #1: 1	وَقْتُ غُفْرَانِ
u'وَقْتٌ غَفْلَةٌ':Added, #1: 1	وَقْتِ الْغَفْلَةِ
u'وَقْتٌ غفلة':Added, #1: 1	وَقْتِ الْغَفْلَةِ
u'وَقْتٌ غَفْلَةٌ':Added, #1: 1	وَقْتَ غَفْلَتِهِ
u'وَقْتٌ غَلاَءٌ':Added, #1: 1	وَقْتَ غَفْلَتِهِ
u'وَقْتٌ غَلاَءٌ':Added, #1: 1	وَقْتَ الْغَلَاءِ
u'وَقْتٌ غَلَبَةٌ':Added, #7: 7	وَقْتِ الْغَلَاءِ
u'وَقْتٌ غَلَبَةٌ':Added, #1: 1	وَقْتَ غَلَبَةِ
u'وَقْتٌ غَلَّةٌ':Added, #2: 2	وَقْتِ غَلَبَةِ
u'وَقْتٌ غَلَّةٌ':Added, #1: 1	وَقْتَ الْغَلَّةِ
u'وَقْتٌ غيم':Added, #2: 2	وَقْتِ الْغَلَّةِ
u'وَقْتٌ غَيْمٌ':Added, #1: 1	وَقْتِ الْغَيْمِ
u'وَقْتٌ فَاضِلٌ':Added, #1: 1	وَقْتِ الْغَيْمِ
u'وَقْتٌ فَتْحٌ':Added, #1: 1	وَقْتٍ فَاضِلٍ
u'وَقْتٌ فَتْحٌ':Added, #1: 1	وَقْت فَتْحِهِ
u'وَقْتٌ فَجْرٌ':Added, #1: 1	وَقْتَ فَتْحِهِ
u'وَقْتٌ فَجْرٌ':Added, #12: 12	وَقْتِ الْفَجْرِ
u'وَقْتٌ فَجْرٌ':Added, #5: 5	وَقْتُ الْفَجْرِ
u'وَقْتٌ فراغ':Added, #8: 8	وَقْتَ الْفَجْرِ
u'وَقْتٌ فراغ':Added, #1: 1	وَقْتَ فَرَاغِ
u'وَقْتٌ فَرَاغٌ':Added, #1: 1	وَقْتُ فَرَاغِ
u'وَقْتٌ فَرَاغٌ':Added, #1: 1	وَقْتَ فَرَاغِ
u'وَقْتٌ فراغ':Added, #1: 1	وَقْتُ فَرَاغِ
u'وَقْتٌ فَرَاغٌ':Added, #1: 1	وَقْتِ فَرَاغِهِ
u'وَقْتٌ فراغ':Added, #1: 1	وَقْتِ فَرَاغِهِ
u'وَقْتٌ فَرَاغٌ':Added, #2: 2	وَقْتِ الْفَرَاغِ
u'وَقْتٌ فراغ':Added, #2: 2	وَقْتِ الْفَرَاغِ
u'وَقْتٌ فَرَاغٌ':Added, #2: 2	وَقْتِ فَرَاغِ
u'وَقْتٌ فراغ':Added, #2: 2	وَقْتِ فَرَاغِ
u'وَقْتٌ فَرَاغٌ':Added, #3: 3	وَقْتَ الْفَرَاغِ
u'وَقْتٌ فِرَاقٌ':Added, #3: 3	وَقْتَ الْفَرَاغِ
u'وَقْتٌ فِرَاقٌ':Added, #1: 1	وَقْتَ فِرَاقِ
u'وَقْتٌ فَرَائِضُ':Added, #9: 9	وَقْتِ الْفِرَاقِ
u'وَقْتٌ فَرْض':Added, #1: 1	وَقْتِ الْفَرَائِضِ
u'وَقْتٌ فَرْضٌ':Added, #1: 1	وَقْتِ الْفَرْضِيَّةِ
u'وَقْتٌ فَرْضٌ':Added, #1: 1	وَقْتِ فَرْضٍ
u'وَقْتٌ فَرْضٌ':Added, #1: 1	وَقْتِ فَرْضِ
u'وَقْتٌ فَرْضٌ':Added, #2: 2	وَقْتَ الْفَرْضِ
u'وَقْتٌ فَرْضٌ':Added, #3: 3	وَقْتُ الْفَرْضِ
u'وَقْتٌ فَرْضٌ':Added, #3: 3	وَقْتُ فَرْضٍ
u'وَقْتٌ فَرْضِيّ':Added, #4: 4	وَقْتِ الْفَرْضِ
u'وَقْتٌ فَرْضِيَّة':Added, #1: 1	وَقْتِ الْفَرْضِيَّةِ
u'وَقْتٌ فُرْقَةٌ':Added, #1: 1	وَقْتِ الْفَرْضِيَّةِ
u'وَقْتٌ فُرْقَةٌ':Added, #3: 3	وَقْتَ الْفُرْقَةِ
u'وَقْتٌ فَرِيضَةٌ':Added, #6: 6	وَقْتِ الْفُرْقَةِ
u'وَقْتٌ فساد':Added, #5: 5	وَقْتِ الْفَرِيضَةِ
u'وَقْتٌ فَسَادٌ':Added, #1: 1	وَقْتِ الْفَسَادِ
u'وَقْتٌ فساد':Added, #1: 1	وَقْتِ الْفَسَادِ
u'وَقْتٌ فَسَادٌ':Added, #1: 1	وَقْتُ فَسَادٍ
u'وَقْتٌ فَسْخٌ':Added, #1: 1	وَقْتُ فَسَادٍ
u'وَقْتٌ فَسْخٌ':Added, #10: 10	وَقْتِ الْفَسْخِ
u'وَقْتٌ فَسْخٌ':Added, #1: 1	وَقْت الْفَسْخِ
u'وَقْتٌ فَسْخٌ':Added, #1: 1	وَقْتِ فَسْخِ
u'وَقْتٌ فَسْخٌ':Added, #2: 2	وَقْتَ الْفَسْخِ
u'وَقْتٌ فَسْو':Added, #2: 2	وَقْتُ الْفَسْخِ
u'وَقْتٌ فَضِيلٌ':Added, #1: 1	وَقْتَ الْفَسْوَةِ
u'وَقْتٌ فَضِيلٌ':Added, #1: 1	وَقْتُ فَضِيلَةِ
u'وَقْتٌ فَضِيلٌ':Added, #2: 2	وَقْتَ الْفَضِيلَةِ
u'وَقْتٌ فَضِيلَةٌ':Added, #3: 3	وَقْتِ الْفَضِيلَةِ
u'وَقْتٌ فَضِيلَةٌ':Added, #1: 1	وَقْتُ فَضِيلَةِ
u'وَقْتٌ فَضِيلَةٌ':Added, #2: 2	وَقْتَ الْفَضِيلَةِ
u'وَقْتٌ فَضِيلَةٌ':Added, #3: 3	وَقْتِ الْفَضِيلَةِ
u'وَقْتٌ فِطْرٌ':Added, #9: 9	وَقْتُ فَضِيلَةٍ
u'وَقْتٌ فِطْرٌ':Added, #2: 2	وَقْتَ الْفِطْرِ
u'وَقْتٌ فِطْرٌ':Added, #3: 3	وَقْتِ الْفِطْرِ
u'وَقْتٌ فِعْلٌ':Added, #4: 4	وَقْتُ الْفِطْرِ
u'وَقْتٌ فِعْلٌ':Added, #17: 17	وَقْتِ الْفِعْلِ
u'وَقْتٌ فِعْلٌ':Added, #1: 1	وَقْتُ الْفِعْلِ
u'وَقْتٌ فِعْلٌ':Added, #1: 1	وَقْتَ فِعْلِ
u'وَقْتٌ فِعْلٌ':Added, #1: 1	وَقْتَ فِعْلِهِ
u'وَقْتٌ فِعْلٌ':Added, #2: 2	وَقْتِ فِعْلِ
u'وَقْتٌ فِعْلٌ':Added, #2: 2	وَقْتِ فِعْلِهِ
u'وَقْتٌ فَقْدٌ':Added, #6: 6	وَقْتَ الْفِعْلِ
u'وَقْتٌ فقر':Added, #1: 1	وَقْتِ فَقْدِ
u'وَقْتٌ فَقْرٌ':Added, #1: 1	وَقْتَ فَقْرِ
u'وَقْتٌ فِكَاكٌ':Added, #1: 1	وَقْتَ فَقْرِ
u'وَقْتٌ فِكَاكٌ':Added, #10: 10	وَقْتِ الْفِكَاكِ
u'وَقْتٌ فَوَاتٌ':Added, #3: 3	وَقْتَ الْفِكَاكِ
u'وَقْتٌ فَيْءٌ':Added, #1: 1	وَقْتِ الْفَوَاتِ
u'وَقْتٌ قَائِلٌ':Added, #2: 2	وَقْتَ الْفَيْءِ
u'وَقْتٌ قَائِلٌ':Added, #1: 1	وَقْتَ قَائِلَةٍ
u'وَقْتٌ قَائِلَةٌ':Added, #2: 2	وَقْتَ الْقَائِلَةِ
u'وَقْتٌ قَائِلَةٌ':Added, #1: 1	وَقْتَ قَائِلَةٍ
u'وَقْتٌ قَبْضٌ':Added, #2: 2	وَقْتَ الْقَائِلَةِ
u'وَقْتٌ قَبْضٌ':Added, #12: 12	وَقْتِ الْقَبْضِ
u'وَقْتٌ قَبْضٌ':Added, #1: 1	وَقْتِ قَبْضِ
u'وَقْتٌ قَبْضٌ':Added, #28: 28	وَقْتَ الْقَبْضِ
u'وَقْتٌ قَبْضٌ':Added, #2: 2	وَقْتَ قَبْضِ
u'وَقْتٌ قَبْضٌ':Added, #3: 3	وَقْتُ الْقَبْضِ
u'وَقْتٌ قَبُولٌ':Added, #5: 5	وَقْتِ قَبْضِهِ
u'وَقْتٌ قَبُولٌ':Added, #1: 1	وَقْتُ الْقَبُولِ
u'وَقْتٌ قتال':Added, #1: 1	وَقْتَ قَبُولِ
u'وَقْتٌ قِتَالٌ':Added, #1: 1	وَقْتِ الْقِتَالِ
u'وَقْتٌ قتال':Added, #1: 1	وَقْتِ الْقِتَالِ
u'وَقْتٌ قِتَالٌ':Added, #2: 2	وَقْتَ الْقِتَالِ
u'وَقْتٌ قتل':Added, #2: 2	وَقْتَ الْقِتَالِ
u'وَقْتٌ قَتْلٌ':Added, #1: 1	وَقْتِ الْقَتْلِ
u'وَقْتٌ قَتْلٌ':Added, #1: 1	وَقْتِ الْقَتْلِ
u'وَقْتٌ قتل':Added, #1: 1	وَقْتُ قَتْلٍ
u'وَقْتٌ قَتْلٌ':Added, #5: 5	وَقْتَ الْقَتْلِ
u'وَقْتٌ قَحْطٌ':Added, #5: 5	وَقْتَ الْقَتْلِ
u'وَقْتٌ قدرة':Added, #1: 1	وَقْتَ الْقَحْطِ
u'وَقْتٌ قُدْرَةٌ':Added, #1: 1	وَقْتُ الْقُدْرَةِ
u'وَقْتٌ قُدُومٌ':Added, #1: 1	وَقْتُ الْقُدْرَةِ
u'وَقْتٌ قُدُومٌ':Added, #1: 1	وَقْتُ الْقُدُومِ
u'وَقْتٌ قُدُومٌ':Added, #1: 1	وَقْتُ قُدُومِهِ
u'وَقْتٌ قُدُومٌ':Added, #1: 1	وَقْتِ قُدُومِهِ
u'وَقْتٌ قُدُومٌ':Added, #2: 2	وَقْتِ الْقُدُومِ
u'وَقْتٌ قذف':Added, #2: 2	وَقْتِ قُدُومِ
u'وَقْتٌ قَذْفٌ':Added, #1: 1	وَقْتَ الْقَذْفِ
u'وَقْتٌ قذف':Added, #1: 1	وَقْتَ الْقَذْفِ
u'وَقْتٌ قَذْفٌ':Added, #1: 1	وَقْتِ قَذْفِهِ
u'وَقْتٌ قِرَاءةٌ':Added, #1: 1	وَقْتِ قَذْفِهِ
u'وَقْتٌ قِرَاءةٌ':Added, #1: 1	وَقْتِ الْقِرَاءَةِ
u'وَقْتٌ قِرَاءةٌ':Added, #2: 2	وَقْتَ الْقِرَاءَةِ
u'وَقْتٌ قرار':Added, #2: 2	وَقْتَ قِرَاءَةِ
u'وَقْتٌ قَرَارٌ':Added, #1: 1	وَقْتَ الْقَرَارِ
u'وَقْتٌ قَرْضٌ':Added, #1: 1	وَقْتَ الْقَرَارِ
u'وَقْتٌ قسمة':Added, #1: 1	وَقْتَ الْقَرْضِ
u'وَقْتٌ قِسْمَةٌ':Added, #10: 10	وَقْتَ الْقِسْمَةِ
u'وَقْتٌ قسمة':Added, #10: 10	وَقْتَ الْقِسْمَةِ
u'وَقْتٌ قِسْمَةٌ':Added, #1: 1	وَقْتُ الْقِسْمَةِ
u'وَقْتٌ قسمة':Added, #1: 1	وَقْتُ الْقِسْمَةِ
u'وَقْتٌ قِسْمَةٌ':Added, #2: 2	وَقْتَ قِسْمَةِ
u'وَقْتٌ قصاص':Added, #2: 2	وَقْتَ قِسْمَةِ
u'وَقْتٌ قِصَاصٌ':Added, #2: 2	وَقْتِ الْقِصَاصِ
u'وَقْتٌ قَضَاءٌ':Added, #2: 2	وَقْتِ الْقِصَاصِ
u'وَقْتٌ قَضَاءٌ':Added, #13: 13	وَقْتُ الْقَضَاءِ
u'وَقْتٌ قَضَاءٌ':Added, #1: 1	وَقْتَ قَضَاءٍ
u'وَقْتٌ قَضَاءٌ':Added, #21: 21	وَقْتِ الْقَضَاءِ
u'وَقْتٌ قَضَاءٌ':Added, #26: 26	وَقْتَ الْقَضَاءِ
u'وَقْتٌ قَطْعٌ':Added, #2: 2	وَقْتِ قَضَاءِ
u'وَقْتٌ قَطْعٌ':Added, #11: 11	وَقْتَ الْقَطْعِ
u'وَقْتٌ قَطْعٌ':Added, #1: 1	وَقْتِ قَطْعِهِ
u'وَقْتٌ قَطْعٌ':Added, #2: 2	وَقْتَ قَطْعِ
u'وَقْتٌ قُنُوتٌ':Added, #2: 2	وَقْتُ قَطْعِ
u'وَقْتٌ قول':Added, #1: 1	وَقْتِ الْقُنُوتِ
u'وَقْتٌ قَوْلٌ':Added, #1: 1	وَقْتِ الْقَوْلِ
u'وَقْتٌ قول':Added, #1: 1	وَقْتِ الْقَوْلِ
u'وَقْتٌ قَوْلٌ':Added, #1: 1	وَقْتَ قَوْلِهِ
u'وَقْتٌ قول':Added, #1: 1	وَقْتَ قَوْلِهِ
u'وَقْتٌ قَوْلٌ':Added, #2: 2	وَقْتَ الْقَوْلِ
u'وَقْتٌ قيام':Added, #2: 2	وَقْتَ الْقَوْلِ
u'وَقْتٌ قِيَامٌ':Added, #1: 1	وَقْتَ الْقِيَامِ
u'وَقْتٌ قيام':Added, #1: 1	وَقْتَ الْقِيَامِ
u'وَقْتٌ قِيَامٌ':Added, #1: 1	وَقْتِ قِيَامِهِ
u'وَقْتٌ قَيْلُولَةٌ':Added, #1: 1	وَقْتِ قِيَامِهِ
u'وَقْتٌ قِيمَةٌ':Added, #2: 2	وَقْتَ الْقَيْلُولَةِ
u'وَقْتٌ كَامِلٌ':Added, #1: 1	وَقْتِ الْقِيمَةِ
u'وَقْتٌ كِتَابَةٌ':Added, #1: 1	وَقْتٍ كَامِلٍ
u'وَقْتٌ كِتَابَةٌ':Added, #1: 1	وَقْتِ كِتَابَتِهِ
u'وَقْتٌ كِتَابَةٌ':Added, #3: 3	وَقْتِ الْكِتَابَةِ
u'وَقْتٌ كِتَابَةٌ':Added, #3: 3	وَقْتَ كِتَابَتِهِ
u'وَقْتٌ كِرَاءٌ':Added, #4: 4	وَقْتَ الْكِتَابَةِ
u'وَقْتٌ كَرَاهَةٌ':Added, #1: 1	وَقْتِ الْكِرَاءِ
u'وَقْتٌ كَرَاهَةٌ':Added, #13: 13	وَقْتُ الْكَرَاهَةِ
u'وَقْتٌ كَرَاهَةٌ':Added, #1: 1	وَقْتُ كَرَاهَةٍ
u'وَقْتٌ كَرَاهَةٌ':Added, #1: 1	وَقْتِ كَرَاهَةِ
u'وَقْتٌ كَرَاهَةٌ':Added, #27: 27	وَقْتِ الْكَرَاهَةِ
u'وَقْتٌ كَرَاهَةٌ':Added, #4: 4	وَقْتَ الْكَرَاهَةِ
u'وَقْتٌ كَرَاهِيَةٌ':Added, #4: 4	وَقْتَ كَرَاهَةٍ
u'وَقْتٌ كَرَاهِيَةٌ':Added, #1: 1	وَقْتِ الْكَرَاهِيَةِ
u'وَقْتٌ كَسْرٌ':Added, #1: 1	وَقْتَ كَرَاهِيَةِ
u'وَقْتٌ كَسْرٌ':Added, #1: 1	وَقْتَ الْكَسْرِ
u'وَقْتٌ كُسُوفٌ':Added, #1: 1	وَقْتِ كَسْرِهِ
u'وَقْتٌ كَشْفٌ':Added, #1: 1	وَقْتِ الْكُسُوفِ
u'وَقْتٌ كَفٌّ':Added, #1: 1	وَقْتُ كَشْفِ
u'وَقْتٌ كَفَّارٌ':Added, #1: 1	وَقْتَ الْكَفِّ
u'وَقْتٌ كَفَّارَةٌ':Added, #1: 1	وَقْتِ الْكَفَّارَةِ
u'وَقْتٌ كَفَالَةٌ':Added, #1: 1	وَقْتِ الْكَفَّارَةِ
u'وَقْتٌ كَلاَمٌ':Added, #2: 2	وَقْتَ الْكَفَالَةِ
u'وَقْتٌ كَلاَمٌ':Added, #2: 2	وَقْتَ كَلَامِهِ
u'وَقْتٌ كَلاَمٌ':Added, #3: 3	وَقْتَ الْكَلَامِ
u'وَقْتٌ كَمَالٌ':Added, #3: 3	وَقْتِ الْكَلَامِ
u'وَقْتٌ كَمَالٌ':Added, #1: 1	وَقْتِ كَمَالِ
u'وَقْتٌ كَمَالٌ':Added, #2: 2	وَقْتَ كَمَالِ
u'وَقْتٌ كَمَالٌ':Added, #2: 2	وَقْتُ كَمَالِهِ
u'وَقْتٌ كَوْنٌ':Added, #2: 2	وَقْتِ كَمَالِهِ
u'وَقْتٌ كَوْنٌ':Added, #1: 1	وَقْتَ كَوْنِ
u'وَقْتٌ كَوْنٌ':Added, #1: 1	وَقْتِ كَوْنِ
u'وَقْتٌ لبس':Added, #1: 1	وَقْتِ كَوْنِهِ
u'وَقْتٌ لِبْسٌ':Added, #1: 1	وَقْتَ اللِّبْسِ
u'وَقْتٌ لبس':Added, #1: 1	وَقْتَ اللِّبْسِ
u'وَقْتٌ لُبْسٌ':Added, #1: 1	وَقْتُ لُبْسِهِ
u'وَقْتٌ لبس':Added, #1: 1	وَقْتُ لُبْسِهِ
u'وَقْتٌ لُبْسٌ':Added, #2: 2	وَقْتُ اللُّبْسِ
u'وَقْتٌ لبس':Added, #2: 2	وَقْتُ اللُّبْسِ
u'وَقْتٌ لُبْسٌ':Added, #5: 5	وَقْتِ اللُّبْسِ
u'وَقْتٌ لبس':Added, #5: 5	وَقْتِ اللُّبْسِ
u'وَقْتٌ لُبْسٌ':Added, #6: 6	وَقْتَ اللُّبْسِ
u'وَقْتٌ لحاق':Added, #6: 6	وَقْتَ اللُّبْسِ
u'وَقْتٌ لِحَاقٌ':Added, #1: 1	وَقْتَ اللِّحَاقِ
u'وَقْتٌ لحاق':Added, #1: 1	وَقْتَ اللِّحَاقِ
u'وَقْتٌ لِحَاقٌ':Added, #2: 2	وَقْتُ لِحَاقِهِ
u'وَقْتٌ لُزُومٌ':Added, #2: 2	وَقْتُ لِحَاقِهِ
u'وَقْتٌ لُزُومٌ':Added, #1: 1	وَقْتُ اللُّزُومِ
u'وَقْتٌ لُزُومٌ':Added, #1: 1	وَقْتُ لُزُومِ
u'وَقْتٌ لُزُومٌ':Added, #1: 1	وَقْتِ لُزُومِ
u'وَقْتٌ لُزُومٌ':Added, #1: 1	وَقْتَ لُزُومِهِ
u'وَقْتٌ لعان':Added, #2: 2	وَقْتَ لُزُومِ
u'وَقْتٌ لَفْظٌ':Added, #4: 4	وَقْتَ اللِّعَانِ
u'وَقْتٌ لِقَاءٌ':Added, #2: 2	وَقْتِ اللَّفْظِ
u'وَقْتٌ مَأْمُورٌ':Added, #1: 1	وَقْتَ لِقَاءِ
u'وَقْتٌ مَأْمُورٌ':Added, #1: 1	وَقْتُ الْمَأْمُورِ
u'وَقْتٌ مُبَاحٌ':Added, #4: 4	وَقْتِ الْمَأْمُورِ
u'وَقْتٌ مُبَاشَرَةٌ':Added, #10: 10	وَقْتٍ مُبَاحٍ
u'وَقْتٌ مُبَاشَرَةٌ':Added, #3: 3	وَقْتَ الْمُبَاشَرَةِ
u'وَقْتٌ مُبَايَعَةٌ':Added, #3: 3	وَقْتَ مُبَاشَرَةِ
u'وَقْتٌ مَبْعَثٌ':Added, #1: 1	وَقْتَ الْمُبَايَعَةِ
u'وَقْتٌ مَبِيعٌ':Added, #1: 1	وَقْتَ مَبْعَثِهِ
u'وَقْتٌ مُتَّسِعٌ':Added, #2: 2	وَقْتَ الْمَبِيعِ
u'وَقْتٌ مُتَقَدِّمٌ':Added, #1: 1	وَقْتٍ مُتَّسِعٍ
u'وَقْتٌ مُتَوَسِّطٌ':Added, #1: 1	وَقْتٍ مُتَقَدِّمٍ
u'وَقْتٌ مُجَامَعَةٌ':Added, #1: 1	وَقْتٍ مُتَوَسِّطٍ
u'وَقْتٌ مُجَاوَزَةٌ':Added, #1: 1	وَقْتِ الْمُجَامَعَةِ
u'وَقْتٌ مَجْهُولٌ':Added, #1: 1	وَقْتُ مُجَاوَزَةِ
u'وَقْتٌ مَجِيءٌ':Added, #1: 1	وَقْتٍ مَجْهُولٍ
u'وَقْتٌ مُحَاسَبَةٌ':Added, #1: 1	وَقْتَ مَجِيءِ
u'وَقْتٌ مُحَاكَمَةٌ':Added, #1: 1	وَقْتَ الْمُحَاسَبَةِ
u'وَقْتٌ مَحْدُودٌ':Added, #1: 1	وَقْتَ الْمُحَاكَمَةِ
u'وَقْتٌ مُحَرَّمٌ':Added, #1: 1	وَقْتٍ مَحْدُودٍ
u'وَقْتٌ مَحْكُومٌ':Added, #1: 1	وَقْتٍ مُحَرَّمٍ
u'وَقْتٌ مَحَلٌّ':Added, #1: 1	وَقْتِ الْمَحْكُومِ
u'وَقْتٌ مَحَلٌّ':Added, #1: 1	وَقْتِ الْمَحَلِّ
u'وَقْتٌ مُخَاصَمَةٌ':Added, #1: 1	وَقْتِ مَحَلِّ
u'وَقْتٌ مُخَالَفَةٌ':Added, #1: 1	وَقْتِ الْمُخَاصَمَةِ
u'وَقْتٌ مَخْصُوصٌ':Added, #1: 1	وَقْتِ الْمُخَالَفَةِ
u'وَقْتٌ مُدَافَعَةٌ':Added, #22: 22	وَقْتٍ مَخْصُوصٍ
u'وَقْتٌ مُدَافَعَةٌ':Added, #1: 1	وَقْتَ مُدَافَعَةِ
u'وَقْتٌ مَرَضٌ':Added, #1: 1	وَقْتُ مُدَافَعَةِ
u'وَقْتٌ مُسَاوَمَةٌ':Added, #1: 1	وَقْتَ الْمَرَضِ
u'وَقْتٌ مُسْتَحَبٌّ':Added, #2: 2	وَقْتَ الْمُسَاوَمَةِ
u'وَقْتٌ مُسْتَقْبَلٌ':Added, #5: 5	وَقْتٍ مُسْتَحَبٍّ
u'وَقْتٌ مُسْتَقْبَلٌ':Added, #1: 1	وَقْتِ الْمُسْتَقْبَلِ
u'وَقْتٌ مَسْحٌ':Added, #2: 2	وَقْتٍ مُسْتَقْبَلٍ
u'وَقْتٌ مَسْحٌ':Added, #2: 2	وَقْتُ مَسْحِهِ
u'وَقْتٌ مَسْحٌ':Added, #3: 3	وَقْتُ الْمَسْحِ
u'وَقْتٌ مَسْنُون':Added, #5: 5	وَقْتِ الْمَسْحِ
u'وَقْتٌ مَسِيرٌ':Added, #1: 1	وَقْتُ مَسْنُونِيَّةِ
u'وَقْتٌ مَشْرُوطٌ':Added, #2: 2	وَقْتِ الْمَسِيرِ
u'وَقْتٌ مَشْرُوعٌ':Added, #1: 1	وَقْتٍ مَشْرُوطٍ
u'وَقْتٌ مَشْيٌ':Added, #1: 1	وَقْتٍ مَشْرُوعٍ
u'وَقْتٌ مَصِيرٌ':Added, #2: 2	وَقْتَ الْمَشْيِ
u'وَقْتٌ مُضَافٌ':Added, #1: 1	وَقْتِ مَصِيرِهِ
u'وَقْتٌ مَضْمَضَةٌ':Added, #1: 1	وَقْتِ الْمُضَافِ
u'وَقْتٌ مُطَالَبٌ':Added, #1: 1	وَقْتُ الْمَضْمَضَةِ
u'وَقْتٌ مُطَالَبَةٌ':Added, #1: 1	وَقْتِ الْمُطَالَبَةِ
u'وَقْتٌ مَطَرٌ':Added, #1: 1	وَقْتِ الْمُطَالَبَةِ
u'وَقْتٌ مُطْلَقٌ':Added, #1: 1	وَقْتَ الْمَطَرِ
u'وَقْتٌ مُظَاهَرَةٌ':Added, #1: 1	وَقْتٍ مُطْلَقٍ
u'وَقْتٌ مَعَاشٌ':Added, #1: 1	وَقْتِ الْمُظَاهَرَةِ
u'وَقْتٌ مَعَاشٌ':Added, #1: 1	وَقْتُ الْمَعَاشِ
u'وَقْتٌ مُعَامَلَةٌ':Added, #1: 1	وَقْتُ مَعَاشِهِ
u'وَقْتٌ مُعَاهَدَةٌ':Added, #1: 1	وَقْتُ الْمُعَامَلَةِ
u'وَقْتٌ مُعَاهَدَةٌ':Added, #1: 1	وَقْتَ الْمُعَاهَدَةِ
u'وَقْتٌ مَعْرُوفٌ':Added, #1: 1	وَقْتِ الْمُعَاهَدَةِ
u'وَقْتٌ مَعْلُومٌ':Added, #1: 1	وَقْتٍ مَعْرُوفٍ
u'وَقْتٌ مُعَيَّنٌ':Added, #14: 14	وَقْتٍ مَعْلُومٍ
u'وَقْتٌ مَغْرِبٌ':Added, #20: 20	وَقْتٍ مُعَيَّنٍ
u'وَقْتٌ مَغْرِبٌ':Added, #10: 10	وَقْتَ الْمَغْرِبِ
u'وَقْتٌ مَغْرِبٌ':Added, #22: 22	وَقْتُ الْمَغْرِبِ
u'وَقْتٌ مُفَارَقَةٌ':Added, #28: 28	وَقْتِ الْمَغْرِبِ
u'وَقْتٌ مُفْرَدٌ':Added, #1: 1	وَقْتَ الْمُفَارَقَةِ
u'وَقْتٌ مَفْرُوضٌ':Added, #2: 2	وَقْتٍ مُفْرَدٍ
u'وَقْتٌ مَفْرُوضٌ':Added, #2: 2	وَقْتِ الْمَفْرُوضَةِ
u'وَقْتٌ مُقَابَلٌ':Added, #3: 3	وَقْتُ الْمَفْرُوضَةِ
u'وَقْتٌ مُقَابَلَةٌ':Added, #1: 1	وَقْتُ الْمُقَابَلَةِ
u'وَقْتٌ مُقَارَنٌ':Added, #1: 1	وَقْتُ الْمُقَابَلَةِ
u'وَقْتٌ مُقَارَنَةٌ':Added, #1: 1	وَقْتِ الْمُقَارَنَةِ
u'وَقْتٌ مَقَالٌ':Added, #1: 1	وَقْتِ الْمُقَارَنَةِ
u'وَقْتٌ مَقَالَةٌ':Added, #2: 2	وَقْتِ الْمَقَالَتَيْنِ
u'وَقْتٌ مَقَالَةٌ':Added, #1: 1	وَقْتَ الْمَقَالَةِ
u'وَقْتٌ مُقَدَّرٌ':Added, #2: 2	وَقْتِ الْمَقَالَةِ
u'وَقْتٌ مُقَدَّمٌ':Added, #2: 2	وَقْتٍ مُقَدَّرٍ
u'وَقْتٌ مَقْصُورٌ':Added, #1: 1	وَقْتٍ مُقَدَّمٍ
u'وَقْتٌ مَقْصُورَةٌ':Added, #1: 1	وَقْتِ الْمَقْصُورَةِ
u'وَقْتٌ مُكَاتَبَةٌ':Added, #1: 1	وَقْتِ الْمَقْصُورَةِ
u'وَقْتٌ مَكْتُوبٌ':Added, #1: 1	وَقْتَ الْمُكَاتَبَةِ
u'وَقْتٌ مَكْتُوبٌ':Added, #1: 1	وَقْتِ الْمَكْتُوبَاتِ
u'وَقْتٌ مَكْتُوبٌ':Added, #1: 1	وَقْتِ الْمَكْتُوبَةِ
u'وَقْتٌ مَكْتُوبٌ':Added, #1: 1	وَقْتُ مَكْتُوبَةٍ
u'وَقْتٌ مَكْرُوهٌ':Added, #3: 3	وَقْتُ الْمَكْتُوبَةِ
u'وَقْتٌ مِلْكٌ':Added, #20: 20	وَقْتٍ مَكْرُوهٍ
u'وَقْتٌ مِلْكٌ':Added, #1: 1	وَقْتِ مِلْكِ
u'وَقْتٌ مِلْكٌ':Added, #1: 1	وَقْتُ مِلْكِهِ
u'وَقْتٌ مِلْكٌ':Added, #2: 2	وَقْتِ الْمِلْكِ
u'وَقْتٌ مُنَاجَاةٌ':Added, #6: 6	وَقْتَ الْمِلْكِ
u'وَقْتٌ مُنَازَعٌ':Added, #1: 1	وَقْتُ الْمُنَاجَاةِ
u'وَقْتٌ مُنَازَعَةٌ':Added, #4: 4	وَقْتَ الْمُنَازَعَةِ
u'وَقْتٌ مُنْتَظَر':Added, #4: 4	وَقْتَ الْمُنَازَعَةِ
u'وَقْتٌ مَنْذُور':Added, #5: 5	وَقْتٍ مُنْتَظَرٍ
u'وَقْتٌ مَنْسُوخٌ':Added, #1: 1	وَقْتُ الْمَنْذُورَةِ
u'وَقْتٌ مَنْعٌ':Added, #1: 1	وَقْتِ الْمَنْسُوخِ
u'وَقْتٌ مَنْعٌ':Added, #3: 3	وَقْتَ الْمَنْعِ
u'وَقْتٌ مُهْمَلٌ':Added, #3: 3	وَقْتِ الْمَنْعِ
u'وَقْتٌ مِهْنَةٌ':Added, #2: 2	وَقْتٍ مُهْمَلٍ
u'وَقَّتَ مَوَاقِيتُ':Predicate, #1: 1	وَقْتَ مِهْنَةٍ
u'وَقْتٌ مَوْتٌ':Added, #2: 2	وَقَّتَ الْمَوَاقِيتَ
u'وَقْتٌ مَوْتٌ':Added, #12: 12	وَقْتَ مَوْتِ
u'وَقْتٌ مَوْتٌ':Added, #12: 12	وَقْتِ مَوْتِهِ
u'وَقْتٌ مَوْتٌ':Added, #1: 1	وَقْت الْمَوْتِ
u'وَقْتٌ مَوْتٌ':Added, #1: 1	وَقْتَ مَوْتٍ
u'وَقْتٌ مَوْتٌ':Added, #46: 46	وَقْتِ الْمَوْتِ
u'وَقْتٌ مَوْتٌ':Added, #4: 4	وَقْتُ مَوْتِهِ
u'وَقْتٌ مَوْتٌ':Added, #55: 55	وَقْتَ الْمَوْتِ
u'وَقْتٌ مَوْتٌ':Added, #5: 5	وَقْتُ الْمَوْتِ
u'وَقْتٌ مَوْتٌ':Added, #7: 7	وَقْتَ مَوْتِهِ
u'وَقْتٌ مُؤَدّاة':Added, #9: 9	وَقْتِ مَوْتِ
u'وَقْتٌ مَوْصُوفٌ':Added, #2: 2	وَقْتِ الْمُؤَدَّاةِ
u'وَقْتٌ مَوْقِفٌ':Added, #1: 1	وَقْتٍ مَوْصُوفٍ
u'وَقْتٌ نَاسٌ':Added, #1: 1	وَقْتَ الْمَوْقِفِ
u'وَقْتٌ نَاقِصٌ':Added, #1: 1	وَقْتِ النَّاسِ
u'وَقْتٌ نبات':Added, #2: 2	وَقْتٍ نَاقِصٍ
u'وَقْتٌ نبات':Added, #1: 1	وَقْتَ النَّبَاتِ
u'وَقْتٌ نَبَاتٌ':Added, #1: 1	وَقْتِ النَّبَاتِ
u'وَقْتٌ نَبَاتٌ':Added, #1: 1	وَقْتَ النَّبَاتِ
u'وَقَّتَ نَبِيٌّ':Subject, #1: 1	وَقْتِ النَّبَاتِ
u'وَقْتٌ نَبِيٌّ':Added, #3: 3	وَقَّتَ النَّبِيُّ
u'وَقْتٌ نَثْرٌ':Added, #1: 1	وَقْتِ النَّبِيِّ
u'وَقْتٌ نَجْمٌ':Added, #1: 1	وَقْتَ النَّثْرِ
u'وَقْتٌ نَحْرٌ':Added, #1: 1	وَقْتِ النَّجْمِ
u'وَقْتٌ نَحْوٌ':Added, #1: 1	وَقْتُ نَحْرِ
u'وَقْتٌ نِدَاءٌ':Added, #1: 1	وَقْتَ نَحْوِ
u'وَقْتٌ نِدَاءٌ':Added, #1: 1	وَقْتَ نِدَاءِ
u'وَقْتٌ نِدَاءٌ':Added, #20: 20	وَقْتَ النِّدَاءِ
u'وَقْتٌ نَدَمٌ':Added, #3: 3	وَقْتِ النِّدَاءِ
u'وَقْتٌ نذر':Added, #1: 1	وَقْتَ النَّدَمِ
u'وَقْتٌ نَذْرٌ':Added, #1: 1	وَقْت النَّذْرِ
u'وَقْتٌ نذر':Added, #1: 1	وَقْت النَّذْرِ
u'وَقْتٌ نَذْرٌ':Added, #2: 2	وَقْتِ النَّذْرِ
u'وَقْتٌ نذر':Added, #2: 2	وَقْتِ النَّذْرِ
u'وَقْتٌ نَذْرٌ':Added, #7: 7	وَقْتَ النَّذْرِ
u'وَقْتٌ نُزُولٌ':Added, #7: 7	وَقْتَ النَّذْرِ
u'وَقْتٌ نُزُولٌ':Added, #1: 1	وَقْتُ النُّزُولِ
u'وَقْتٌ نُزُولٌ':Added, #1: 1	وَقْتَ نُزُولِ
u'وَقْتٌ نُزُولٌ':Added, #1: 1	وَقْتِ نُزُولِ
u'وَقْتٌ نُزُولٌ':Added, #1: 1	وَقْتِ نُزُولِهِ
u'وَقْتٌ نِسْيَانٌ':Added, #3: 3	وَقْتَ نُزُولِهِ
u'وَقْتٌ نشاط':Added, #1: 1	وَقْتَ النِّسْيَانِ
u'وَقْتٌ نَشَاطٌ':Added, #1: 1	وَقْتَ النَّشَاطِ
u'وَقْتٌ نَظَرٌ':Added, #1: 1	وَقْتَ النَّشَاطِ
u'وَقْتٌ نَظَرٌ':Added, #1: 1	وَقْتِ النَّظَرِ
u'وَقْتٌ نَظَرٌ':Added, #1: 1	وَقْتَ نَظَرِهِ
u'وَقْتٌ نفاذ':Added, #3: 3	وَقْتِ نَظَرِهِ
u'وَقْتٌ نَفَاذٌ':Added, #2: 2	وَقْتِ نَفَاذِ
u'وَقْتٌ نفاس':Added, #2: 2	وَقْتِ نَفَاذِ
u'وَقْتٌ نِفَاسٌ':Added, #3: 3	وَقْتِ النِّفَاسِ
u'وَقْتٌ نُفَسَاءُ':Added, #3: 3	وَقْتِ النِّفَاسِ
u'وَقْتٌ نُفُوذٌ':Added, #1: 1	وَقْتُ النُّفَسَاءِ
u'وَقْتٌ نُفُوذٌ':Added, #1: 1	وَقْتَ نُفُوذِ
u'وَقْتٌ نَفْيٌ':Added, #1: 1	وَقْتَ نُفُوذِهِ
u'وَقْتٌ نَقْدٌ':Added, #1: 1	وَقْتِ النَّفْيِ
u'وَقْتٌ نَقْد':Added, #2: 2	وَقْتَ نَقْدِ
u'وَقْتٌ نقل':Added, #2: 2	وَقْتَ نَقْدِ
u'وَقْتٌ نَقْلٌ':Added, #2: 2	وَقْتَ نَقْلِ
u'وَقْتٌ نكاح':Added, #2: 2	وَقْتَ نَقْلِ
u'وَقْتٌ نِكَاحٌ':Added, #10: 10	وَقْتَ النِّكَاحِ
u'وَقْتٌ نكاح':Added, #10: 10	وَقْتَ النِّكَاحِ
u'وَقْتٌ نِكَاحٌ':Added, #1: 1	وَقْتَ نِكَاحِهِ
u'وَقْتٌ نكاح':Added, #1: 1	وَقْتَ نِكَاحِهِ
u'وَقْتٌ نِكَاحٌ':Added, #29: 29	وَقْتِ النِّكَاحِ
u'وَقْتٌ نكاح':Added, #29: 29	وَقْتِ النِّكَاحِ
u'وَقْتٌ نِكَاحٌ':Added, #4: 4	وَقْتِ نِكَاحِ
u'وَقْتٌ نهار':Added, #4: 4	وَقْتِ نِكَاحِ
u'وَقْتٌ نَهَارٌ':Added, #1: 1	وَقْتَ النَّهَارِ
u'وَقْتٌ نَهْبٌ':Added, #1: 1	وَقْتَ النَّهَارِ
u'وَقْتٌ نَهْبٌ':Added, #1: 1	وَقْتِ النَّهْبِ
u'وَقْتٌ نَهْبٌ':Added, #1: 1	وَقْتَ نَهْبٍ
u'وَقْتٌ نَهْيٌ':Added, #1: 1	وَقْتِ نَهْبٍ
u'وَقْتٌ نَهْيٌ':Added, #11: 11	وَقْتَ نَهْيٍ
u'وَقْتٌ نَهْيٌ':Added, #15: 15	وَقْتِ نَهْيٍ
u'وَقْتٌ نَهْيٌ':Added, #1: 1	وَقْتُ النَّهْيِ
u'وَقْتٌ نَهْيٌ':Added, #1: 1	وَقْتَ نَهْيِ
u'وَقْتٌ نَهْيٌ':Added, #1: 1	وَقْتِ نَهْيِ
u'وَقْتٌ نَهْيٌ':Added, #27: 27	وَقْتِ النَّهْيِ
u'وَقْتٌ نَهْيٌ':Added, #2: 2	وَقْتُ نَهْيٍ
u'وَقْتٌ نَوْءٌ':Added, #7: 7	وَقْتَ النَّهْيِ
u'وَقْتٌ نَوْمٌ':Added, #1: 1	وَقْتِ نَوءِ
u'وَقْتٌ نَوْمٌ':Added, #11: 11	وَقْتُ نَوْمٍ
u'وَقْتٌ نَوْمٌ':Added, #3: 3	وَقْتُ النَّوْمِ
u'وَقْتٌ نَوْمٌ':Added, #5: 5	وَقْتِ النَّوْمِ
u'وَقْتٌ نِيَامٌ':Added, #7: 7	وَقْتَ النَّوْمِ
u'وَقْتٌ نِيَّةٌ':Added, #1: 1	وَقْتِ نِيَامِ
u'وَقْتٌ نِيَّةٌ':Added, #13: 13	وَقْتِ النِّيَّةِ
u'وَقْتٌ نِيَّةٌ':Added, #1: 1	وَقْتُ النِّيَّةِ
u'وَقْتٌ نِيَّةٌ':Added, #1: 1	وَقْتِ نِيَّتِهِ
u'وَقْتٌ نِيَّةٌ':Added, #2: 2	وَقْتِ نِيَّةِ
u'وَقْتٌ هَاجِرٌ':Added, #3: 3	وَقْتَ النِّيَّةِ
u'وَقْتٌ هَاجِرٌ':Added, #1: 1	وَقْتِ الْهَاجِرَةِ
u'وَقْتٌ هِبَةٌ':Added, #2: 2	وَقْتَ الْهَاجِرَةِ
u'وَقْتٌ هِبَةٌ':Added, #10: 10	وَقْتَ الْهِبَةِ
u'وَقْتٌ هُبُوبٌ':Added, #2: 2	وَقْتِ الْهِبَةِ
u'وَقْتٌ هلاك':Added, #1: 1	وَقْتِ هُبُوبِ
u'وَقْتٌ هَلاَكٌ':Added, #1: 1	وَقْتِ هَلَاكِ
u'وَقْتٌ هلاك':Added, #1: 1	وَقْتِ هَلَاكِ
u'وَقْتٌ هَلاَكٌ':Added, #3: 3	وَقْتَ الْهَلَاكِ
u'وَقْتٌ هلاك':Added, #3: 3	وَقْتَ الْهَلَاكِ
u'وَقْتٌ هَلاَكٌ':Added, #5: 5	وَقْتِ الْهَلَاكِ
u'وَقْتٌ هَوْلٌ':Added, #5: 5	وَقْتِ الْهَلَاكِ
u'وَقْتٌ وَاجِبٌ':Added, #1: 1	وَقْتَ الْهَوْلِ
u'وَقْتٌ واحد':Added, #1: 1	وَقْتُ الْوَاجِبِ
u'وَقْتٌ وَاحِدٌ':Added, #133: 133	وَقْتٍ وَاحِدٍ
u'وَقْتٌ واحد':Added, #133: 133	وَقْتٍ وَاحِدٍ
u'وَقْتٌ وَاحِدٌ':Added, #1: 1	وَقْتِ وَاحِدٍ
u'وَقَّتَ وَاهِبٌ':Subject, #1: 1	وَقْتِ وَاحِدٍ
u'وَقْتٌ وَتْرٌ':Added, #1: 1	وَقَّتَ الْوَاهِبُ
u'وَقْتٌ وُجُوبٌ':Added, #1: 1	وَقْتِ الْوَتْرِ
u'وَقْتٌ وُجُوبٌ':Added, #15: 15	وَقْتِ وُجُوبِ
u'وَقْتٌ وُجُوبٌ':Added, #1: 1	وَقْتُ وُجُوبٍ
u'وَقْتٌ وُجُوبٌ':Added, #20: 20	وَقْتُ الْوُجُوبِ
u'وَقْتٌ وُجُوبٌ':Added, #30: 30	وَقْتِ الْوُجُوبِ
u'وَقْتٌ وُجُوبٌ':Added, #4: 4	وَقْتُ وُجُوبِهِ
u'وَقْتٌ وُجُوبٌ':Added, #74: 74	وَقْتَ الْوُجُوبِ
u'وَقْتٌ وُجُوبٌ':Added, #8: 8	وَقْتُ وُجُوبِ
u'وَقْتٌ وُجُوبٌ':Added, #9: 9	وَقْتَ وُجُوبِ
u'وَقْتٌ وُجُوبٌ':Added, #9: 9	وَقْتَ وُجُوبِهِ
u'وَقْتٌ وُجُودٌ':Added, #9: 9	وَقْتِ وُجُوبِهِ
u'وَقْتٌ وُجُودٌ':Added, #10: 10	وَقْتِ وُجُودِهِ
u'وَقْتٌ وُجُودٌ':Added, #14: 14	وَقْتَ وُجُودِ
u'وَقْتٌ وُجُودٌ':Added, #1: 1	وَقْتَ الْوُجُودِ
u'وَقْتٌ وُجُودٌ':Added, #1: 1	وَقْتُ وُجُودِ
u'وَقْتٌ وَرْدٌ':Added, #24: 24	وَقْتِ وُجُودِ
u'وَقْتٌ وُرُودٌ':Added, #1: 1	وَقْتِ الْوَرْدِ
u'وَقْتٌ وُرُودٌ':Added, #1: 1	وَقْتِ الْوُرُودِ
u'وَقْتٌ وُرُودٌ':Added, #1: 1	وَقْتَ وُرُودِ
u'وَقْتٌ وُرُودٌ':Added, #1: 1	وَقْتِ وُرُودِ
u'وَقْتٌ وَزْنٌ':Added, #1: 1	وَقْتَ وُرُودِهِ
u'وَقْتٌ وُصُولٌ':Added, #1: 1	وَقْتُ الْوَزْنِ
u'وَقْتٌ وُصُولٌ':Added, #1: 1	وَقْتَ وُصُولِهِ
u'وَقْتٌ وَصِيٌّ':Added, #1: 1	وَقْتُ وُصُولِهِ
u'وَقْتٌ وَصِيٌّ':Added, #11: 11	وَقْتِ الْوَصِيَّةِ
u'وَقْتٌ وَصِيٌّ':Added, #1: 1	وَقْتُ الْوَصِيَّةِ
u'وَقْتٌ وَصِيٌّ':Added, #1: 1	وَقْتَ وَصِيَّةٍ
u'وَقْتٌ وَصِيٌّ':Added, #1: 1	وَقْتُ وَصِيَّتِهِ
u'وَقْتٌ وَصِيَّةٌ':Added, #26: 26	وَقْتَ الْوَصِيَّةِ
u'وَقْتٌ وَصِيَّةٌ':Added, #11: 11	وَقْتِ الْوَصِيَّةِ
u'وَقْتٌ وَصِيَّةٌ':Added, #1: 1	وَقْتُ الْوَصِيَّةِ
u'وَقْتٌ وَصِيَّةٌ':Added, #1: 1	وَقْتَ وَصِيَّةٍ
u'وَقْتٌ وَصِيَّةٌ':Added, #1: 1	وَقْتُ وَصِيَّتِهِ
u'وَقْتٌ وَضْعٌ':Added, #26: 26	وَقْتَ الْوَصِيَّةِ
u'وَقْتٌ وَضْعٌ':Added, #1: 1	وَقْتِ وَضْعِ
u'وَقْتٌ وَضْعٌ':Added, #2: 2	وَقْتَ الْوَضْعِ
u'وَقْتٌ وُضُوءٌ':Added, #2: 2	وَقْتِ الْوَضْعِ
u'وَقْتٌ وُضُوءٌ':Added, #1: 1	وَقْتَ وُضُوءٍ
u'وَقْتٌ وُضُوءٌ':Added, #1: 1	وَقْتُ وُضُوءٍ
u'وَقْتٌ وَطْءٌ':Added, #6: 6	وَقْتَ الْوُضُوءِ
u'وَقْتٌ وَطْءٌ':Added, #1: 1	وَقْتَ الْوَطْءِ
u'وَقْتٌ وفاة':Added, #5: 5	وَقْتِ الْوَطْءِ
u'وَقْتٌ وَفَاةٌ':Added, #2: 2	وَقْتَ الْوَفَاةِ
u'وَقْتٌ وفاة':Added, #2: 2	وَقْتَ الْوَفَاةِ
u'وَقْتٌ وَفَاةٌ':Added, #3: 3	وَقْتِ وَفَاتِهِ
u'وَقْتٌ وفاة':Added, #3: 3	وَقْتِ وَفَاتِهِ
u'وَقْتٌ وَفَاةٌ':Added, #5: 5	وَقْتِ الْوَفَاةِ
u'وَقْتٌ وقاع':Added, #5: 5	وَقْتِ الْوَفَاةِ
u'وَقْتٌ وَقْت':Added, #2: 2	وَقْتَ الْوِقَاعِ
u'وَقْتٌ وَقْتٌ':Added, #1: 1	وَقْتُ الْوَقْتِيَّةِ
u'وَقْتٌ وَقْت':Added, #1: 1	وَقْتَ وَقْتِ
u'وَقْتٌ وَقْتِيّ':Added, #2: 2	وَقْتِ الْوَقْتِيَّةِ
u'وَقْتٌ وَقْتِيّ':Added, #1: 1	وَقْتُ الْوَقْتِيَّةِ
u'وَقْتٌ وَقْفٌ':Added, #2: 2	وَقْتِ الْوَقْتِيَّةِ
u'وَقْتٌ وُقُوعٌ':Added, #8: 8	وَقْتَ الْوَقْفِ
u'وَقْتٌ وُقُوعٌ':Added, #10: 10	وَقْتِ وُقُوعِ
u'وَقْتٌ وُقُوعٌ':Added, #1: 1	وَقْتَ الْوُقُوعِ
u'وَقْتٌ وُقُوعٌ':Added, #1: 1	وَقْتُ الْوُقُوعِ
u'وَقْتٌ وُقُوعٌ':Added, #2: 2	وَقْتُ وُقُوعِ
u'وَقْتٌ وُقُوعٌ':Added, #3: 3	وَقْتِ وُقُوعِهِ
u'وَقْتٌ وُقُوعٌ':Added, #5: 5	وَقْتِ الْوُقُوعِ
u'وَقَّتَ وُقُوفٌ':Predicate, #6: 6	وَقْتَ وُقُوعِ
u'وَقْتٌ وُقُوفٌ':Added, #1: 1	وَقَّتَ الْوُقُوفَ
u'وَقْتٌ وُقُوفٌ':Added, #14: 14	وَقْتُ الْوُقُوفِ
u'وَقْتٌ وُقُوفٌ':Added, #25: 25	وَقْتِ الْوُقُوفِ
u'وَقْتٌ وِلاَدَةٌ':Added, #8: 8	وَقْتَ الْوُقُوفِ
u'وَقْتٌ وِلاَدَةٌ':Added, #12: 12	وَقْتِ الْوِلَادَةِ
u'وَقْتٌ وِلاَدَةٌ':Added, #1: 1	وَقْتُ الْوِلَادَةِ
u'وَقْتٌ وِلاَدَةٌ':Added, #2: 2	وَقْتَ الْوِلَادَةِ
u'وَقْتٌ وِلاَيَةٌ':Added, #2: 2	وَقْتِ وِلَادَتِهِ
u'وَقْتٌ وَلِيمَةٌ':Added, #1: 1	وَقْتَ وِلَايَتِهِ
u'وَقْتٌ يسار':Added, #1: 1	وَقْتِ الْوَلِيمَةِ
u'وَقْتٌ يَسَارٌ':Added, #2: 2	وَقْتِ الْيَسَارِ
u'وَقْتٌ يَسِيرٌ':Added, #2: 2	وَقْتِ الْيَسَارِ
u'وَقَّتَ يَمِينٌ':Predicate, #1: 1	وَقْتٍ يَسِيرٍ
u'وَقْتٌ يَمِينٌ':Added, #1: 1	وَقَّتَ الْيَمِينَ
u'وَقْتٌ يَمِينٌ':Added, #1: 1	وَقْتُ يَمِينِهِ
u'وَقْتٌ يَمِينٌ':Added, #21: 21	وَقْتِ الْيَمِينِ
u'وَقْتٌ يَمِينٌ':Added, #2: 2	وَقْتُ الْيَمِينِ
u'وَقْتٌ يَمِينٌ':Added, #2: 2	وَقْتِ يَمِينِهِ
u'وَقْتٌ يَمِينٌ':Added, #47: 47	وَقْتَ الْيَمِينِ
u'وَقَرَ إيمَانٌ':Subject, #7: 7	وَقْتَ يَمِينِهِ
u'وقر حَطَبٌ':Added, #1: 1	وَقَرَ الإِيمَانُ
u'وَقْرٌ حَطَبٌ':Added, #1: 1	وَقْرُ حَطَبٍ
u'وقر حِنْطَةٌ':Added, #1: 1	وَقْرُ حَطَبٍ
u'وَقْرٌ حِنْطَةٌ':Added, #1: 1	وَقْرِ الْحِنْطَةِ
u'وقر دُهْنٌ':Added, #1: 1	وَقْرِ الْحِنْطَةِ
u'وَقْرٌ دُهْنٌ':Added, #1: 1	وَقْرِ دُهْنٍ
u'وقر دَوَابُّ':Added, #1: 1	وَقْرِ دُهْنٍ
u'وَقْرٌ دَوَابُّ':Added, #1: 1	وَقْرُ الدَّوَابِّ
u'وَقَّرَ صَاحِبٌ':Predicate, #1: 1	وَقْرُ الدَّوَابِّ
u'وَقَّرَ نُبُوَّةٌ':Predicate, #1: 1	وَقَّرَ صَاحِبَ
u'وَقْرٌ واحد':Added, #1: 1	وَقَّرَ النُّبُوَّةَ
u'وَقْرٌ وَاحِدٌ':Added, #1: 1	وَقْرٍ وَاحِدٍ
u'وَقَعَ إِبْهَامٌ':Subject, #1: 1	وَقْرٍ وَاحِدٍ
u'وَقَعَ اِتِّهَامٌ':Subject, #1: 1	وَقَعَ الْإِبْهَامُ
u'وَقَعَ أثَرٌ':Subject, #1: 1	وَقَعَ اتِّهَامٌ
u'وَقِعَ إجَارَةٌ':Predicate, #1: 1	وَقَعَ أَثَرُ
u'وَقَعَ اِجْتِهَادٌ':Subject, #1: 1	أَوْقَعَ الْإِجَارَةَ
u'وَقَعَ أَجْرٌ':Subject, #2: 2	وَقَعَ اجْتِهَادُهُ
u'وَقِعَ أَجْزَاءٌ':Predicate, #12: 12	وَقَعَ أَجْرُهُ
u'وَقَعَ إِجْمَاعٌ':Subject, #1: 1	أَوْقَعَ أَجْزَاءَ
u'وَقَعَ أَجِيرٌ':Subject, #7: 7	وَقَعَ الْإِجْمَاعُ
u'وَقِعَ أحَدٌ':Predicate, #1: 1	وَقَعَ الْأَجِيرُ
u'وَقَعَ إِحْرَامٌ':Subject, #1: 1	أَوْقَعَ أَحَدَ
u'وَقَعَ إِحْيَاءٌ':Subject, #1: 1	وَقَعَ إحْرَامُهُ
u'وَقَعَ إِخْبَارٌ':Subject, #1: 1	وَقَعَ الْإِحْيَاءُ
u'وَقَعَ اِخْتِصَارٌ':Subject, #1: 1	وَقَعَ الْإِخْبَارُ
u'وَقَعَ اِخْتِلاَفٌ':Subject, #1: 1	وَقَعَ اخْتِصَارٌ
u'وَقَعَ اِخْتِلاَفٌ':Subject, #1: 1	وَقَعَ اخْتِلَافُ
u'وَقَعَ اِخْتِيَارٌ':Subject, #2: 2	وَقَعَ اخْتِلَافٌ
u'وَقَعَ اِخْتِيَارٌ':Subject, #1: 1	وَقَعَ اخْتِيَارُ
u'وَقَعَ آخِرُ':Subject, #1: 1	وَقَعَ اخْتِيَارُهُ
u'وَقَعَ إِخْلالٌ':Subject, #1: 1	وَقَعَ آخِرُ
u'وَقَعَ أَدَاءٌ':Subject, #1: 1	وَقَعَ الْإِخْلَالُ
u'وَقَعَ آدَمِيٌّ':Subject, #1: 1	وَقَعَ أَدَاءُ
u'وَقَعَ آذَانٌ':Subject, #1: 1	وَقَعَ الْآدَمِيُّ
u'وَقَعَ إِذْنٌ':Subject, #1: 1	وَقَعَ الْآذَانُ
u'وَقَعَ اِسْتِعْمالٌ':Subject, #1: 1	وَقَعَ الْإِذْنُ
u'وَقَعَ إِسْفارٌ':Subject, #1: 1	وَقَعَ اسْتِعْمَالُهُ
u'وَقَعَ إِسْلامٌ':Subject, #1: 1	وَقَعَ الْإِسْفَارُ
u'وَقَعَ إِسْلامٌ':Subject, #1: 1	وَقَعَ إسْلَامٌ
u'وَقَعَ اِسْمٌ':Subject, #1: 1	وَقَعَ الْإِسْلَامُ
u'وَقَعَ اِشْتِراطٌ':Subject, #3: 3	وَقَعَ اسْمُ
u'وَقَعَ أَشْجَارٌ':Subject, #1: 1	وَقَعَ اشْتِرَاطُ
u'وَقِعَ إِشْكالٌ':Predicate, #1: 1	وَقَعَ الْأَشْجَارُ
u'وَقَعَ إِشْكالٌ':Subject, #1: 1	أَوْقَعَ الْإِشْكَالَ
u'وَقَعَ أصل':Subject, #2: 2	وَقَعَ الْإِشْكَالُ
u'وَقَعَ أًصْلٌ':Subject, #1: 1	وَقَعَ أَصْلُ
u'وَقَعَ أصل':Subject, #1: 1	وَقَعَ أَصْلُ
u'وَقَعَ أًصْلٌ':Subject, #1: 1	وَقَعَ الأَصْلُ
u'وَقَعَ اِضْطِرابٌ':Subject, #1: 1	وَقَعَ الأَصْلُ
u'وَقَعَ إِطْلاقٌ':Subject, #2: 2	وَقَعَ اضْطِرَابٌ
u'وَقِعَ إِعْتاقٌ':Predicate, #1: 1	وَقَعَ الْإِطْلَاقُ
u'وَقَعَ إعْلاَمٌ':Subject, #1: 1	أَوْقَعَ الْإِعْتَاقَ
u'وَقَعَ أَغْلاَطٌ':Subject, #1: 1	وَقَعَ الْإِعْلَامُ
u'وَقَعَ إِفْرَاطٌ':Subject, #1: 1	وَقَعَ أَغْلَاطٌ
u'وَقَعَ إقْرَارٌ':Subject, #1: 1	وَقَعَ الْإِفْرَاطُ
u'وَقِعَ أقَلُّ':Predicate, #1: 1	وَقَعَ إقْرَارُهُ
u'وَقَعَ أقَلُّ':Predicate, #1: 1	أَوْقَعَ أَقَلَّ
u'وَقَعَ أقَلُّ':Subject, #1: 1	وَقَعَ أَقَلَّ
u'وَقَعَ أكْبَرُ':Subject, #1: 1	وَقَعَ الْأَقَلُّ
u'وَقَعَ أَكْثَرُ':Subject, #1: 1	وَقَعَ أَكْبَرُ
u'وَقَعَ إكْرَاهٌ':Subject, #1: 1	وَقَعَ أَكْثَرُهُ
u'وَقَعَ أمَانٌ':Subject, #2: 2	وَقَعَ الْإِكْرَاهُ
u'وَقَعَ أَمْرٌ':Subject, #2: 2	وَقَعَ الْأَمَانُ
u'وَقَعَ أَمْرٌ':Subject, #1: 1	وَقَعَ أَمْرٌ
u'وَقَعَ أَمْنٌ':Subject, #8: 8	وَقَعَ الْأَمْرُ
u'وَقَعَ إِناءٌ':Subject, #4: 4	وَقَعَ الْأَمْنُ
u'وَقَعَ أُنْسٌ':Subject, #1: 1	وَقَعَ الْإِنَاءُ
u'وَقَعَ إِنْسانٌ':Subject, #1: 1	وَقَعَ الْأُنْسُ
u'وَقَعَ إِنْسانٌ':Subject, #1: 1	وَقَعَ الْإِنْسَانُ
u'وَقَعَ إِنْكارٌ':Subject, #5: 5	وَقَعَ إنْسَانٌ
u'وَقَعَ أَوَّلُ':Subject, #1: 1	وَقَعَ إِنْكَارُهُ
u'وَقَعَ إِيجَابٌ':Subject, #3: 3	وَقَعَ الْأَوَّلُ
u'وَقَعَ بَائِنٌ':Subject, #1: 1	وَقَعَ الْإِيجَابُ
u'وَقَعَ بَائِنٌ':Subject, #1: 1	وَقَعَ بَائِنٌ
u'وَقَعَ بَحْثٌ':Subject, #3: 3	وَقَعَ الْبَائِنُ
u'وَقَعَ بَحْثٌ':Subject, #1: 1	وَقَعَ بَحْثٌ
u'وَقَعَ بَذْرٌ':Subject, #4: 4	وَقَعَ الْبَحْثُ
u'وَقَعَ بسط':Subject, #1: 1	وَقَعَ الْبَذْرُ
u'وَقَعَ بَسْطٌ':Subject, #1: 1	وَقَعَ بَسْطُهُ
u'وَقَعَ بَصَرٌ':Subject, #1: 1	وَقَعَ بَسْطُهُ
u'وَقَعَ بَصَرٌ':Subject, #11: 11	وَقَعَ بَصَرُهُ
u'وَقَعَ بَصَرٌ':Subject, #1: 1	وَقَعَ الْبَصَرُ
u'وَقِعَ بَعْضٌ':Predicate, #1: 1	وَقَعَ بَصَرُ
u'وَقَعَ بَعْضٌ':Subject, #3: 3	أَوْقَعَ بَعْضَ
u'وَقَعَ بَعْضٌ':Subject, #3: 3	وَقَعَ بَعْضُ
u'وَقَعَ بَقِيَّةٌ':Subject, #5: 5	وَقَعَ بَعْضُهُ
u'وَقَعَ بَلْغَم':Subject, #1: 1	وَقَعَ بَقِيَّةُ
u'وَقَعَ بِنَاءٌ':Subject, #1: 1	وَقَعَ الْبَلْغَمُ
u'وَقَعَ بَوْلٌ':Subject, #13: 13	وَقَعَ الْبِنَاءُ
u'وَقَعَ بَيَانٌ':Subject, #1: 1	وَقَعَ الْبَوْلُ
u'وَقَعَ بَيَانٌ':Subject, #1: 1	وَقَعَ بَيَانُ
u'وَقَعَ بَيَانٌ':Subject, #1: 1	وَقَعَ بَيَانُهُ
u'وَقَعَ بَيْتٌ':Subject, #7: 7	وَقَعَ الْبَيَانُ
u'وَقَعَ بَيْعٌ':Subject, #11: 11	وَقَعَ الْبَيْتُ
u'وَقَعَ بَيْعٌ':Subject, #1: 1	وَقَعَ بَيْعُهُ
u'وَقَعَ بَيْعٌ':Subject, #31: 31	وَقَعَ الْبَيْعُ
u'وَقَعَ بَيْنٌ':Predicate, #3: 3	وَقَعَ بَيْعُ
u'وَقِعَ بَيْنٌ':Predicate, #22: 22	وَقَعَ بَيْنَ
u'وَقِعَ بَيْنٌ':Predicate, #2: 2	أَوْقَعَ بَيْنَ
u'وقعة بَدْرٌ':Added, #3: 3	أَوْقَعَ بَيْنَهُنَّ
u'وقعة بَدْرٌ':Added, #3: 3	وَقْعَةَ بَدْرٍ
u'وَقْعَةٌ بَدْرٌ':Added, #3: 3	وَقْعَةُ بَدْرٍ
u'وَقْعَةٌ بَدْرٌ':Added, #3: 3	وَقْعَةَ بَدْرٍ
u'وقعة بَدْرٌ':Added, #3: 3	وَقْعَةُ بَدْرٍ
u'وَقْعَةٌ بَدْرٌ':Added, #7: 7	وَقْعَةِ بَدْرٍ
u'وقعة بعاث':Added, #7: 7	وَقْعَةِ بَدْرٍ
u'وَقْعَةٌ بعاث':Added, #1: 1	وَقْعَةُ بُعَاثٍ
u'وقعة جَمَلٌ':Added, #1: 1	وَقْعَةُ بُعَاثٍ
u'وَقْعَةٌ جَمَلٌ':Added, #1: 1	وَقْعَةُ الْجَمَلِ
u'وقعة جَمَلٌ':Added, #1: 1	وَقْعَةُ الْجَمَلِ
u'وَقْعَةٌ جَمَلٌ':Added, #5: 5	وَقْعَةِ الْجَمَلِ
u'وقعة خَنْدَقٌ':Added, #5: 5	وَقْعَةِ الْجَمَلِ
u'وَقْعَةٌ خَنْدَقٌ':Added, #2: 2	وَقْعَةُ الْخَنْدَقِ
u'وقعة عَبْدٌ':Added, #2: 2	وَقْعَةُ الْخَنْدَقِ
u'وَقْعَةٌ عَبْدٌ':Added, #1: 1	وَقْعَةِ عَبْدِ
u'وقعة فَتْحٌ':Added, #1: 1	وَقْعَةِ عَبْدِ
u'وَقْعَةٌ فَتْحٌ':Added, #1: 1	وَقْعَةُ الْفَتْحِ
u'وَقَعَ تَأْخِيرٌ':Subject, #1: 1	وَقْعَةُ الْفَتْحِ
u'وَقَعَ تَبَادُلٌ':Subject, #2: 2	وَقَعَ التَّأْخِيرُ
u'وَقِعَ تَبَرُّعٌ':Predicate, #1: 1	وَقَعَ التَّبَادُلُ
u'وَقَعَ تَجَوُّزٌ':Subject, #1: 1	أَوْقَعَ التَّبَرُّعَ
u'وَقَعَ تَحَالُفٌ':Subject, #2: 2	وَقَعَ التَّجَوُّزُ
u'وَقَعَ تَحْذِيرٌ':Subject, #1: 1	وَقَعَ التَّحَالُفُ
u'وَقَعَ تَحْرِيمٌ':Subject, #1: 1	وَقَعَ التَّحْذِيرُ
u'وَقَعَ تَحْكِيمٌ':Subject, #5: 5	وَقَعَ التَّحْرِيمُ
u'وَقَعَ تَخَاطُبٌ':Subject, #1: 1	وَقَعَ التَّحْكِيمُ
u'وَقَعَ تَخَبُّطٌ':Subject, #1: 1	وَقَعَ التَّخَاطُبُ
u'وَقَعَ تَخْصِيصٌ':Subject, #1: 1	وَقَعَ التَّخَبُّطُ
u'وَقَعَ تَخَلُّصٌ':Subject, #2: 2	وَقَعَ التَّخْصِيصُ
u'وَقَعَ تَخْيِيرٌ':Subject, #1: 1	وَقَعَ التَّخَلُّصُ
u'وَقَعَ تَخْيِيرٌ':Subject, #1: 1	وَقَعَ التَّخْيِيرُ
u'وَقَعَ تَدْبِيرٌ':Subject, #1: 1	وَقَعَ تَخْيِيرُهُ
u'وَقَعَ تَذَكُّرٌ':Subject, #1: 1	وَقَعَ التَّدْبِيرُ
u'وَقَعَ تُرَابٌ':Subject, #1: 1	وَقَعَ التَّذَكُّرُ
u'وَقَعَ تَرْتِيبٌ':Subject, #2: 2	وَقَعَ التُّرَابُ
u'وَقَعَ تَرَدُّدٌ':Subject, #1: 1	وَقَعَ تَرْتِيبٌ
u'وَقَعَ تَرَدُّدٌ':Subject, #1: 1	وَقَعَ تَرَدُّدُ
u'وَقَعَ تَرَدُّدٌ':Subject, #2: 2	وَقَعَ تَرَدُّدٌ
u'وَقَعَ تَرْكِيبٌ':Subject, #9: 9	وَقَعَ التَّرَدُّدُ
u'وَقَعَ تَزَوُّجٌ':Subject, #1: 1	وَقَعَ التَّرْكِيبُ
u'وَقَعَ تَسْلِيمٌ':Subject, #1: 1	وَقَعَ التَّزَوُّجُ
u'وَقَعَ تَشْبِيه':Subject, #8: 8	وَقَعَ التَّسْلِيمُ
u'وَقَعَ تَشْنِيعٌ':Subject, #1: 1	وَقَعَ التَّشْبِيهُ
u'وَقَعَ تَصَرُّفٌ':Subject, #2: 2	وَقَعَ التَّشْنِيعُ
u'وَقَعَ تَصْرِيحٌ':Subject, #1: 1	وَقَعَ التَّصَرُّفُ
u'وَقَعَ تَصْوِيرٌ':Subject, #7: 7	وَقَعَ التَّصْرِيحُ
u'وَقَعَ تَعَارُضٌ':Subject, #1: 1	وَقَعَ التَّصْوِيرُ
u'وَقَعَ تَعَامُلٌ':Subject, #22: 22	وَقَعَ التَّعَارُضُ
u'وَقَعَ تَعَبُّدٌ':Subject, #2: 2	وَقَعَ التَّعَامُلُ
u'وَقَعَ تَعْبِيرٌ':Subject, #2: 2	وَقَعَ التَّعَبُّدُ
u'وَقَعَ تَعْجِيل':Subject, #3: 3	وَقَعَ التَّعْبِيرُ
u'وَقَعَ تَعَدُّدٌ':Subject, #1: 1	وَقَعَ التَّعْجِيلُ
u'وَقَعَ تَعَرُّضٌ':Subject, #1: 1	وَقَعَ تَعَدُّدٌ
u'وَقَعَ تَعْرِيفٌ':Subject, #2: 2	وَقَعَ التَّعَرُّضُ
u'وَقَعَ تَعْلِيقٌ':Subject, #1: 1	وَقَعَ التَّعْرِيفُ
u'وَقَعَ تَعْلِيقٌ':Subject, #1: 1	وَقَعَ التَّعْلِيقُ
u'وَقَعَ تَعْيِينٌ':Subject, #1: 1	وَقَعَ تَعْلِيقُهُ
u'وَقَعَ تَغَيُّرٌ':Subject, #1: 1	وَقَعَ التَّعْيِينُ
u'وَقَعَ تَغْيِيرٌ':Subject, #1: 1	وَقَعَ التَّغَيُّرُ
u'وَقَعَ تَغْيِيرٌ':Subject, #1: 1	وَقَعَ تَغْيِيرٌ
u'وَقَعَ تَفْرِيقٌ':Subject, #3: 3	وَقَعَ التَّغْيِيرُ
u'وَقَعَ تَفْرِيقٌ':Subject, #1: 1	وَقَعَ التَّفْرِيقُ
u'وَقَعَ تَفْسِيرٌ':Subject, #1: 1	وَقَعَ تَفْرِيقُ
u'وَقَعَ تَفْصِيلٌ':Subject, #1: 1	وَقَعَ التَّفْسِيرُ
u'وَقَعَ تَفْضِيلٌ':Subject, #2: 2	وَقَعَ التَّفْصِيلُ
u'وَقَعَ تَفْوِيضٌ':Subject, #1: 1	وَقَعَ التَّفْضِيلُ
u'وَقَعَ تَقَدُّمٌ':Subject, #1: 1	وَقَعَ تَفْوِيضٌ
u'وَقَعَ تَقْديرٌ':Subject, #1: 1	وَقَعَ التَّقَدُّمُ
u'وَقَعَ تَقْريرٌ':Subject, #1: 1	وَقَعَ التَّقْدِيرُ
u'وَقَعَ تَقْيِيد':Subject, #1: 1	وَقَعَ التَّقْرِيرُ
u'وَقَعَ تَقْيِيد':Subject, #1: 1	وَقَعَ تَقْيِيدُ
u'وَقَعَ تَكَلُّمٌ':Subject, #5: 5	وَقَعَ التَّقْيِيدُ
u'وَقَعَ تَكْليفٌ':Subject, #1: 1	وَقَعَ التَّكَلُّمُ
u'وَقَعَ تَلَف':Subject, #1: 1	وَقَعَ التَّكْلِيفُ
u'وَقَعَ تَلَفٌ':Subject, #2: 2	وَقَعَ التَّلَفُ
u'وَقَعَ تَمْييزٌ':Subject, #2: 2	وَقَعَ تَلَفٌ
u'وَقَعَ تَناجُز':Subject, #1: 1	وَقَعَ التَّمْيِيزُ
u'وَقَعَ تَنَازُعٌ':Subject, #1: 1	وَقَعَ التَّنَاجُزُ
u'وَقَعَ تَنَازُعٌ':Subject, #2: 2	وَقَعَ تَنَازُعٌ
u'وَقَعَ تَنْبِيه':Subject, #6: 6	وَقَعَ التَّنَازُعُ
u'وَقَعَ تَنْصِيص':Subject, #1: 1	وَقَعَ التَّنْبِيهُ
u'وَقَعَ تَنْفِيلٌ':Subject, #3: 3	وَقَعَ التَّنْصِيصُ
u'وَقَعَ تَوَافُقٌ':Subject, #1: 1	وَقَعَ التَّنْفِيلُ
u'وَقَعَ تَوَقُّفٌ':Subject, #1: 1	وَقَعَ تَوَافُقٌ
u'وَقَعَ تَوْقِيفٌ':Subject, #4: 4	وَقَعَ التَّوَقُّفُ
u'وَقَعَ تَوْكِيلٌ':Subject, #2: 2	وَقَعَ التَّوْقِيفُ
u'وَقَعَ تَيَمُّمٌ':Subject, #2: 2	وَقَعَ التَّوْكِيلُ
u'وَقِعَ ثَانِي':Predicate, #1: 1	وَقَعَ التَّيَمُّمُ
u'وَقِعَ ثَانِيَةٌ':Predicate, #3: 3	أَوْقَعَ الثَّانِيَةَ
u'وَقِعَ ثَلاثُ':Predicate, #3: 3	أَوْقَعَ الثَّانِيَةَ
u'وَقِعَ ثَلاثُ':Predicate, #17: 17	أَوْقَعَ الثَّلَاثَ
u'وَقَعَ ثَلاثُ':Predicate, #1: 1	أَوْقَعَ ثَلَاثَ
u'وَقَعَ ثَلاثُ':Subject, #1: 1	وَقَعَ الثَّلَاثَ
u'وَقَعَ ثَلاثُ':Subject, #2: 2	وَقَعَ ثَلَاثُ
u'وَقَعَ ثَلاثَةٌ':Subject, #52: 52	وَقَعَ الثَّلَاثُ
u'وَقَعَ ثَلْجٌ':Subject, #1: 1	وَقَعَ ثَلَاثَةٌ
u'وَقَعَ ثَمَرٌ':Subject, #2: 2	وَقَعَ الثَّلْجُ
u'وَقِعَ ثَمَنٌ':Predicate, #1: 1	وَقَعَ ثَمَرُ
u'وَقَعَ ثَمَنٌ':Subject, #1: 1	أَوْقَعَ الثَّمَنَ
u'وَقَعَ ثَناءٌ':Subject, #1: 1	وَقَعَ الثَّمَنُ
u'وَقَعَ ثَوابٌ':Subject, #1: 1	وَقَعَ الثَّنَاءُ
u'وَقَعَ ثَوْبٌ':Subject, #1: 1	وَقَعَ الثَّوَابُ
u'وَقَعَ ثَوْبٌ':Subject, #2: 2	وَقَعَ ثَوْبُ
u'وَقَعَ جُزْءٌ':Subject, #3: 3	وَقَعَ الثَّوْبُ
u'وَقَعَ جَزَاءٌ':Subject, #1: 1	وَقَعَ جُزْءُ
u'وَقَعَ جِلْدٌ':Subject, #1: 1	وَقَعَ الْجَزَاءُ
u'وَقَعَ جماع':Subject, #1: 1	وَقَعَ جِلْدٌ
u'وَقَعَ جِمَاعٌ':Subject, #2: 2	وَقَعَ الْجِمَاعُ
u'وَقَعَ جَمِيع':Subject, #2: 2	وَقَعَ الْجِمَاعُ
u'وَقَعَ جناح':Subject, #4: 4	وَقَعَ الْجَمِيعُ
u'وَقَعَ جَنَاحٌ':Subject, #1: 1	وَقَعَ الْجَنَاحُ
u'وَقَعَ جَوَابٌ':Subject, #1: 1	وَقَعَ الْجَنَاحُ
u'وَقَعَ حالٌ':Predicate, #1: 1	وَقَعَ الْجَوَابُ
u'وَقَعَ حائِطٌ':Subject, #2: 2	وَقَعَ حَالَ
u'وَقَعَ حَجٌّ':Subject, #6: 6	وَقَعَ الْحَائِطُ
u'وَقَعَ حَجٌّ':Subject, #1: 1	وَقَعَ حَجُّ
u'وَقَعَ حِجاجٌ':Subject, #7: 7	وَقَعَ الْحَجُّ
u'وَقَعَ حَدٌّ':Subject, #1: 1	وَقَعَ الْحِجَاجُ
u'وَقَعَ حَدَثٌ':Subject, #1: 1	وَقَعَ الْحَدُّ
u'وَقَّعَ حُدوثٌ':Subject, #1: 1	وَقَعَ الْحَدَثُ
u'وَقَعَ حَديثٌ':Subject, #1: 1	وَقَّعَ حُدُوثُ
u'وَقَعَ حَرِيقٌ':Subject, #1: 1	وَقَعَ حَدِيثُ
u'وَقَعَ حَطّ':Subject, #7: 7	وَقَعَ الْحَرِيقُ
u'وَقَعَ حُكْمٌ':Subject, #1: 1	وَقَعَ الْحَطُّ
u'وَقَعَ حُكْمٌ':Subject, #3: 3	وَقَعَ الْحُكْمُ
u'وَقَعَ حَلْقٌ':Subject, #4: 4	وَقَعَ حُكْمُ
u'وَقَعَ حِنْثٌ':Subject, #1: 1	وَقَعَ حَلْقُ
u'وَقَعَ خَارِجٌ':Predicate, #5: 5	وَقَعَ الْحِنْثُ
u'وَقَعَ خَرَابٌ':Subject, #1: 1	وَقَعَ خَارِجَ
u'وَقَعَ خَرَابٌ':Subject, #1: 1	وَقَعَ الْخَرَابُ
u'وَقَعَ خَشَاشٌ':Subject, #1: 1	وَقَعَ خَرَابٌ
u'وَقَعَ خِصَامٌ':Subject, #1: 1	وَقَعَ خَشَاشٌ
u'وَقَعَ خَطَأٌ':Subject, #1: 1	وَقَعَ الْخِصَامُ
u'وَقَعَ خِلاَفٌ':Predicate, #2: 2	وَقَعَ الْخَطَأُ
u'وَقَعَ خِلاَفٌ':Subject, #1: 1	وَقَعَ خِلَافَ
u'وَقَعَ خِلاَفٌ':Subject, #15: 15	وَقَعَ خِلَافٌ
u'وَقَعَ خلط':Subject, #39: 39	وَقَعَ الْخِلَافُ
u'وَقَعَ خُلْعٌ':Subject, #1: 1	وَقَعَ الْخَلْطُ
u'وَقَعَ خَلَلٌ':Subject, #13: 13	وَقَعَ الْخُلْعُ
u'وَقَعَ خَلَلٌ':Subject, #1: 1	وَقَعَ الْخَلَلُ
u'وَقَعَ خَمْرٌ':Subject, #2: 2	وَقَعَ خَلَلٌ
u'وَقَعَ خِنْزِيرٌ':Subject, #1: 1	وَقَعَ الْخَمْرُ
u'وَقَعَ خَوْفٌ':Subject, #1: 1	وَقَعَ الْخِنْزِيرُ
u'وَقَعَ دُخُولٌ':Subject, #3: 3	وَقَعَ خَوْفٌ
u'وَقَعَ دَرَاهِمُ':Subject, #2: 2	وَقَعَ الدُّخُولُ
u'وَقَعَ دِرْهَمٌ':Subject, #1: 1	وَقَعَ الدَّرَاهِمُ
u'وَقَعَ دِرْهَم':Subject, #2: 2	وَقَعَ دِرْهَمٌ
u'وَقَعَ دفع':Subject, #2: 2	وَقَعَ دِرْهَمٌ
u'وَقَعَ دَفْعٌ':Subject, #2: 2	وَقَعَ الدَّفْعُ
u'وَقَعَ دَمٌ':Subject, #2: 2	وَقَعَ الدَّفْعُ
u'وَقَعَ دَوْرٌ':Subject, #1: 1	وَقَعَ دَمُهُ
u'وَقَعَ دَوَرانٌ':Subject, #1: 1	وَقَعَ الدَّوْرُ
u'وَقَعَ دونٌ':Predicate, #1: 1	وَقَعَ الدَّوَرَانُ
u'وَقَعَ دِينارٌ':Subject, #1: 1	وَقَعَ دُونَ
u'وَقَعَ دِينارٌ':Subject, #1: 1	وَقَعَ الدِّينَارُ
u'وَقَعَ دِينارٌ':Subject, #1: 1	وَقَعَ دِينَارٌ
u'وَقَعَ ذُبابٌ':Subject, #1: 1	وَقَعَ دِينَارُ
u'وَقَعَ ذُبابٌ':Subject, #10: 10	وَقَعَ الذُّبَابُ
u'وَقَعَ ذَكاةٌ':Subject, #1: 1	وَقَعَ ذُبَابٌ
u'وَقَعَ ذكر':Subject, #1: 1	وَقَعَ الذَّكَاةُ
u'وَقَعَ ذِكْرٌ':Subject, #5: 5	وَقَعَ ذِكْرُهُ
u'وَقَعَ ذكر':Subject, #5: 5	وَقَعَ ذِكْرُهُ
u'وَقَعَ ذِكْرٌ':Subject, #6: 6	وَقَعَ ذِكْرُ
u'وَقَعَ ذَمٌّ':Subject, #6: 6	وَقَعَ ذِكْرُ
u'وَقَعَ ذَنْبٌ':Subject, #1: 1	وَقَعَ الذَّمُّ
u'وَقَعَ ذَنَبٌ':Subject, #1: 1	وَقَعَ الذَّنْبُ
u'وَقَعَ ذُهُولٌ':Subject, #1: 1	وَقَعَ ذَنَبُ
u'وَقَعَ رَأْسٌ':Subject, #1: 1	وَقَعَ الذُّهُولُ
u'وَقِعَ رَافِضٌ':Predicate, #1: 1	وَقَعَ رَأْسُهُ
u'وَقِعَ رَافِضَةٌ':Predicate, #1: 1	أَوْقَعَ الرَّافِضَةَ
u'وَقَعَ رِجْزٌ':Subject, #1: 1	أَوْقَعَ الرَّافِضَةَ
u'وَقَعَ رَجْعِيٌّ':Subject, #1: 1	وَقَعَ الرِّجْزُ
u'وَقَعَ رَجُلٌ':Subject, #1: 1	وَقَعَ رَجْعِيٌّ
u'وَقَعَ رَجُلٌ':Subject, #2: 2	وَقَعَ الرَّجُلُ
u'وَقَعَ رَدٌّ':Subject, #2: 2	وَقَعَ رَجُلٌ
u'وَقَعَ رضاع':Subject, #1: 1	وَقَعَ الرَّدُّ
u'وَقَعَ رَمْيٌ':Subject, #2: 2	وَقَعَ الرَّضَاعُ
u'وَقَعَ رَهْنٌ':Subject, #2: 2	وَقَعَ الرَّمْيُ
u'وَقَعَ رِوايَةٌ':Subject, #2: 2	وَقَعَ الرَّهْنُ
u'وَقَعَ رَيْبٌ':Subject, #1: 1	وَقَعَ رِوَايَةٌ
u'وَقَعَ زائِدٌ':Subject, #1: 1	وَقَعَ الرَّيْبُ
u'وَقَعَ سَاعَةٌ':Predicate, #1: 1	وَقَعَ الزَّائِدُ
u'وَقَعَ سَاعَةٌ':Predicate, #1: 1	وَقَعَ سَاعَةَ
u'وَقَعَ سَبٌّ':Subject, #3: 3	وَقَعَ السَّاعَةَ
u'وَقَعَ سَبَبٌ':Subject, #2: 2	وَقَعَ السَّبُّ
u'وَقَعَ سَبَبٌ':Subject, #1: 1	وَقَعَ سَبَبُ
u'وَقَعَ سَرْدٌ':Subject, #1: 1	وَقَعَ سَبَبُهُ
u'وَقَعَ سقط':Subject, #1: 1	وَقَعَ سَرْدُ
u'وَقَعَ سِقْطٌ':Subject, #1: 1	وَقَعَ السِّقْطُ
u'وَقَعَ سِكِّينٌ':Subject, #1: 1	وَقَعَ السِّقْطُ
u'وَقَعَ سلام':Subject, #2: 2	وَقَعَ السِّكِّينُ
u'وَقَعَ سَلاَمٌ':Subject, #2: 2	وَقَعَ السَّلَامُ
u'وَقَعَ سَمَاءٌ':Subject, #2: 2	وَقَعَ السَّلَامُ
u'وَقَعَ سَمَاعٌ':Subject, #1: 1	وَقَعَ السَّمَاءُ
u'وَقَعَ سَهْمٌ':Subject, #1: 1	وَقَعَ السَّمَاعُ
u'وَقَعَ سَهْمٌ':Subject, #1: 1	وَقَعَ سَهْمٌ
u'وَقَعَ سَهْمٌ':Subject, #2: 2	وَقَعَ سَهْمُ
u'وَقَعَ سَهْمٌ':Subject, #2: 2	وَقَعَ سَهْمُهُ
u'وَقَعَ سُؤَالٌ':Subject, #8: 8	وَقَعَ السَّهْمُ
u'وَقَعَ سُؤْرٌ':Subject, #13: 13	وَقَعَ السُّؤَالُ
u'وَقِعَ سَوْطٌ':Predicate, #2: 2	وَقَعَ سُؤْرُ
u'وَقَعَ سَوْطٌ':Subject, #1: 1	أَوْقَعَ السَّوْطَ
u'وَقَعَ سيرَةٌ':Subject, #1: 1	وَقَعَ سَوْطُهُ
u'وقع سَيْفٌ':Added, #1: 1	وَقَعَ السّيرَةُ
u'وَقْعٌ سَيْفٌ':Added, #1: 1	وَقْعِ السَّيْفِ
u'وَقِعَ شَارِحٌ':Predicate, #1: 1	وَقْعِ السَّيْفِ
u'وَقَعَ شِرَاءٌ':Subject, #1: 1	أَوْقَعَ الشَّارِحَ
u'وَقَعَ شِرَاءٌ':Subject, #29: 29	وَقَعَ الشِّرَاءُ
u'وَقَعَ شَرْطٌ':Subject, #4: 4	وَقَعَ شِرَاءُ
u'وَقَعَ شَرْطٌ':Subject, #1: 1	وَقَعَ شَرْطٌ
u'وَقَعَ شَرْعٌ':Subject, #3: 3	وَقَعَ الشَّرْطُ
u'وَقَعَ شَعْرٌ':Subject, #1: 1	وَقَعَ شَرْعُهُ
u'وَقَعَ شَكٌّ':Subject, #1: 1	وَقَعَ شَعْرُهُ
u'وَقَعَ شَكٌّ':Subject, #1: 1	وَقَعَ شَكٌّ
u'وَقَعَ شَهِيدٌ':Subject, #39: 39	وَقَعَ الشَّكُّ
u'وَقَعَ شَيْءٌ':Subject, #1: 1	وَقَعَ الشَّهِيدُ
u'وَقَعَ شَيْطَانٌ':Subject, #8: 8	وَقَعَ شَيْءٌ
u'وَقَعَ صَاحِبٌ':Subject, #2: 2	وَقَعَ الشَّيْطَانُ
u'وَقَعَ صَبِيٌّ':Subject, #1: 1	وَقَعَ صَاحِبُ
u'وَقَعَ صَحِيحٌ':Subject, #1: 1	وَقَعَ صَبِيٌّ
u'وَقَعَ صَرْفٌ':Subject, #1: 1	وَقَعَ الصَّحِيحُ
u'وَقَعَ صَرْف':Subject, #1: 1	وَقَعَ الصَّرْفُ
u'وَقَعَ صُعُودٌ':Subject, #1: 1	وَقَعَ الصَّرْفُ
u'وَقَعَ صِفَةٌ':Predicate, #1: 1	وَقَعَ الصُّعُودُ
u'وَقِعَ صَلاَةٌ':Predicate, #1: 1	وَقَعَ صِفَةَ
u'وَقَعَ صلح':Subject, #1: 1	أَوْقَعَ الصَّلَاةَ
u'وَقَعَ صُلْحٌ':Subject, #118: 118	وَقَعَ الصُّلْحُ
u'وَقَعَ صُلْحٌ':Subject, #118: 118	وَقَعَ الصُّلْحُ
u'وَقَعَ صَوْمٌ':Subject, #1: 1	وَقَعَ صُلْحٌ
u'وَقَعَ ضَرْبٌ':Subject, #1: 1	وَقَعَ صَوْمُهُ
u'وَقَعَ ضَرَرٌ':Subject, #1: 1	وَقَعَ ضَرْبُ
u'وَقَعَ طَاعُونٌ':Subject, #1: 1	وَقَعَ الضَّرَرُ
u'وَقَعَ طرف':Subject, #8: 8	وَقَعَ الطَّاعُونُ
u'وَقَعَ طَرَفٌ':Subject, #1: 1	وَقَعَ طَرَفُهُ
u'وَقَعَ طَرِيقٌ':Subject, #1: 1	وَقَعَ طَرَفُهُ
u'وَقِعَ طَلاَقٌ':Predicate, #1: 1	وَقَعَ الطَّرِيقُ
u'وَقَعَ طَلاَقٌ':Subject, #36: 36	أَوْقَعَ الطَّلَاقَ
u'وَقَعَ طَلاَقٌ':Subject, #10: 10	وَقَعَ طَلَاقُهُ
u'وَقَعَ طَلاَقٌ':Subject, #277: 277	وَقَعَ الطَّلَاقُ
u'وَقَعَ طَلاَقٌ':Subject, #5: 5	وَقَعَ طَلَاقُ
u'وَقِعَ طواف':Predicate, #6: 6	وَقَعَ طَلَاقٌ
u'وَقِعَ طَوَافٌ':Predicate, #1: 1	أَوْقَعَ الطَّوَافَ
u'وَقَعَ طواف':Subject, #1: 1	أَوْقَعَ الطَّوَافَ
u'وَقَعَ طَوَافٌ':Subject, #1: 1	وَقَعَ الطَّوَافُ
u'وَقَعَ طواف':Subject, #1: 1	وَقَعَ الطَّوَافُ
u'وَقَعَ طَوَافٌ':Subject, #1: 1	وَقَعَ طَوَافُ
u'وَقَعَ طواف':Subject, #1: 1	وَقَعَ طَوَافُ
u'وَقَعَ طَوَافٌ':Subject, #2: 2	وَقَعَ طَوَافُهُ
u'وَقَعَ طَيْرٌ':Subject, #2: 2	وَقَعَ طَوَافُهُ
u'وَقَعَ ظَنٌّ':Subject, #1: 1	وَقَعَ طَيْرٌ
u'وَقَعَ ظُهورٌ':Subject, #2: 2	وَقَعَ الظَّنُّ
u'وَقَعَ عَبْدٌ':Subject, #2: 2	وَقَعَ الظُّهُورُ
u'وَقَعَ عَبْدٌ':Subject, #1: 1	وَقَعَ عَبْدٌ
u'وَقَعَ عَتَبٌ':Subject, #6: 6	وَقَعَ الْعَبْدُ
u'وَقِعَ عتق':Predicate, #1: 1	وَقَعَ الْعَتَبُ
u'وَقِعَ عِتْقٌ':Predicate, #10: 10	أَوْقَعَ الْعِتْقَ
u'وَقِعَ عتق':Predicate, #10: 10	أَوْقَعَ الْعِتْقَ
u'وَقَعَ عتق':Subject, #1: 1	أَوْقَعَ عَتَقَ
u'وَقَعَ عِتْقٌ':Subject, #14: 14	وَقَعَ الْعِتْقُ
u'وَقَعَ عتق':Subject, #14: 14	وَقَعَ الْعِتْقُ
u'وَقَعَ عِتْقٌ':Subject, #1: 1	وَقَعَ عِتْقُ
u'وَقَعَ عتق':Subject, #1: 1	وَقَعَ عِتْقُ
u'وَقَعَ عِتْقٌ':Subject, #1: 1	وَقَعَ عِتْقُهُ
u'وَقَعَ عجز':Subject, #1: 1	وَقَعَ عِتْقُهُ
u'وَقَعَ عَجْزٌ':Subject, #3: 3	وَقَعَ الْعَجْزُ
u'وَقَعَ عِصْيَانٌ':Subject, #3: 3	وَقَعَ الْعَجْزُ
u'وَقَعَ عَفْوٌ':Subject, #1: 1	وَقَعَ الْعِصْيَانُ
u'وَقَعَ عَقِبٌ':Predicate, #5: 5	وَقَعَ الْعَفْوُ
u'وَقِعَ عَقْدٌ':Predicate, #2: 2	وَقَعَ عَقِبَ
u'وَقَعَ عَقْدٌ':Subject, #1: 1	أَوْقَعَ الْعَقْدَ
u'وَقَعَ عَقْدٌ':Subject, #3: 3	وَقَعَ عَقْدُهُ
u'وَقَعَ عَقْدٌ':Subject, #74: 74	وَقَعَ الْعَقْدُ
u'وَقَّعَ عقدة':Predicate, #9: 9	وَقَعَ عَقْدُ
u'وَقَّعَ عُقْدَةٌ':Predicate, #1: 1	وَقَّعَ عُقْدَةَ
u'وَقَعَ عَقِيبٌ':Predicate, #1: 1	وَقَّعَ عُقْدَةَ
u'وَقَعَ علم':Subject, #9: 9	وَقَعَ عَقِيبَ
u'وَقَعَ عِلْمٌ':Subject, #3: 3	وَقَعَ الْعِلْمُ
u'وقع عِمَامَةٌ':Added, #3: 3	وَقَعَ الْعِلْمُ
u'وَقْعٌ عِمَامَةٌ':Added, #1: 1	وَقْعِ عِمَامَةٍ
u'وَقَعَ عَمَلٌ':Subject, #1: 1	وَقْعِ عِمَامَةٍ
u'وَقَعَ عَمَلٌ':Subject, #1: 1	وَقَعَ عَمَلُهُ
u'وَقَعَ عند':Predicate, #3: 3	وَقَعَ الْعَمَلُ
u'وَقَعَ عِوَضٌ':Subject, #37: 37	وَقَعَ عِنْدَ
u'وَقَعَ عَيْبٌ':Subject, #1: 1	وَقَعَ الْعِوَضُ
u'وَقَعَ عِيدٌ':Subject, #1: 1	وَقَعَ الْعَيْبُ
u'وَقَعَ غبار':Subject, #1: 1	وَقَعَ الْعِيدُ
u'وَقَعَ غُبَارٌ':Subject, #2: 2	وَقَعَ الْغُبَارُ
u'وَقَعَ غُسْلٌ':Subject, #2: 2	وَقَعَ الْغُبَارُ
u'وَقَعَ غَصْبٌ':Subject, #1: 1	وَقَعَ غُسْلُهُ
u'وَقِعَ غضب':Predicate, #1: 1	وَقَعَ الْغَصْبُ
u'وَقِعَ غَضَبٌ':Predicate, #1: 1	أَوْقَعَ الْغَضَبَ
u'وَقَعَ غَلَطٌ':Subject, #1: 1	أَوْقَعَ الْغَضَبَ
u'وَقَعَ غَلَطٌ':Subject, #1: 1	وَقَعَ غَلَطٌ
u'وَقَعَ غير':Predicate, #8: 8	وَقَعَ الْغَلَطُ
u'وَقَعَ غَيْرٌ':Predicate, #7: 7	وَقَعَ غَيْرَ
u'وَقَعَ فَتْحٌ':Subject, #7: 7	وَقَعَ غَيْرَ
u'وَقَعَ فرار':Subject, #1: 1	وَقَعَ الْفَتْحُ
u'وَقَعَ فِرَارٌ':Subject, #1: 1	وَقَعَ الْفِرَارُ
u'وَقَعَ فراغ':Subject, #1: 1	وَقَعَ الْفِرَارُ
u'وَقَعَ فَرَاغٌ':Subject, #1: 1	وَقَعَ الْفَرَاغُ
u'وَقَعَ فِرَاقٌ':Subject, #1: 1	وَقَعَ الْفَرَاغُ
u'وَقَعَ فَرْضٌ':Subject, #3: 3	وَقَعَ الْفِرَاقُ
u'وَقَعَ فَرْضٌ':Subject, #1: 1	وَقَعَ فَرْضُهُ
u'وَقَعَ فرق':Subject, #2: 2	وَقَعَ الْفَرْضُ
u'وَقَعَ فَرْقٌ':Subject, #9: 9	وَقَعَ الْفَرْقُ
u'وَقَعَ فَسْخٌ':Subject, #9: 9	وَقَعَ الْفَرْقُ
u'وَقَعَ فَسْخٌ':Subject, #2: 2	وَقَعَ فَسْخٌ
u'وَقَعَ فَصِيلٌ':Subject, #4: 4	وَقَعَ الْفَسْخُ
u'وَقَعَ فِطَامٌ':Subject, #2: 2	وَقَعَ فَصِيلٌ
u'وَقَعَ فِعْلٌ':Subject, #1: 1	وَقَعَ الْفِطَامُ
u'وَقَعَ فِعْلٌ':Subject, #1: 1	وَقَعَ فِعْلُ
u'وَقَعَ فَهْمٌ':Subject, #3: 3	وَقَعَ الْفِعْلُ
u'وَقَعَ قَالٌ':Predicate, #1: 1	وَقَعَ فَهْمُ
u'وَقَعَ قَبْضٌ':Subject, #3: 3	وَقَعَ قَالَ
u'وَقَعَ قَبُولٌ':Subject, #1: 1	وَقَعَ الْقَبْضُ
u'وَقَعَ قتال':Subject, #2: 2	وَقَعَ الْقَبُولُ
u'وَقَعَ قِتَالٌ':Subject, #1: 1	وَقَعَ الْقِتَالُ
u'وَقَعَ قتال':Subject, #1: 1	وَقَعَ الْقِتَالُ
u'وَقَعَ قِتَالٌ':Subject, #2: 2	وَقَعَ قِتَالٌ
u'وَقَعَ قتل':Subject, #2: 2	وَقَعَ قِتَالٌ
u'وَقَعَ قَتْلٌ':Subject, #2: 2	وَقَعَ قَتْلُ
u'وَقَعَ قتل':Subject, #2: 2	وَقَعَ قَتْلُ
u'وَقَعَ قَتْلٌ':Subject, #3: 3	وَقَعَ الْقَتْلُ
u'وقع قَدَمٌ':Added, #3: 3	وَقَعَ الْقَتْلُ
u'وَقْعٌ قَدَمٌ':Added, #2: 2	وَقْعَ قَدَمٍ
u'وَقَعَ قذف':Subject, #2: 2	وَقْعَ قَدَمٍ
u'وَقَعَ قَذْفٌ':Subject, #1: 1	وَقَعَ الْقَذْفُ
u'وَقَعَ قراض':Subject, #1: 1	وَقَعَ الْقَذْفُ
u'وَقَعَ قَرْضٌ':Subject, #2: 2	وَقَعَ الْقِرَاضُ
u'وَقَعَ قَسْمٌ':Subject, #1: 1	وَقَعَ الْقَرْضُ
u'وَقَعَ قصاص':Subject, #1: 1	وَقَعَ الْقَسْمُ
u'وَقَعَ قِصَاصٌ':Subject, #2: 2	وَقَعَ الْقِصَاصُ
u'وَقَعَ قَضَاءٌ':Subject, #2: 2	وَقَعَ الْقِصَاصُ
u'وَقَعَ قَضَاءٌ':Subject, #16: 16	وَقَعَ الْقَضَاءُ
u'وَقَعَ قَطْرَةٌ':Subject, #1: 1	وَقَعَ قَضَاءُ
u'وَقَعَ قَطْعٌ':Subject, #1: 1	وَقَعَ قَطْرَةٌ
u'وَقَعَ قَلِيلٌ':Subject, #1: 1	وَقَعَ الْقَطْعُ
u'وَقَعَ قِنْدِيلٌ':Subject, #1: 1	وَقَعَ الْقَلِيلُ
u'وَقَعَ قول':Subject, #2: 2	وَقَعَ الْقِنْدِيلُ
u'وَقَعَ قَوْلٌ':Subject, #5: 5	وَقَعَ الْقَوْلُ
u'وَقَعَ قَوْمٌ':Subject, #5: 5	وَقَعَ الْقَوْلُ
u'وَقَعَ قِيَاسٌ':Subject, #1: 1	وَقَعَ الْقَوْمُ
u'وَقَعَ قيام':Subject, #1: 1	وَقَعَ قِيَاسُ
u'وَقَعَ قِيَامٌ':Subject, #1: 1	وَقَعَ الْقِيَامُ
u'وَقَعَ كَثِيرٌ':Subject, #1: 1	وَقَعَ الْقِيَامُ
u'وَقَعَ كُرْهٌ':Subject, #1: 1	وَقَعَ الْكَثِيرُ
u'وَقَعَ كَسْرٌ':Subject, #1: 1	وَقَعَ الْكُرْهُ
u'وَقَعَ كَلاَمٌ':Subject, #2: 2	وَقَعَ كَسْرٌ
u'وقع كَلِمَةٌ':Added, #3: 3	وَقَعَ الْكَلَامُ
u'وَقْعٌ كَلِمَةٌ':Added, #1: 1	وَقْعَ الْكَلِمَةِ
u'وَقَعَ كَنِيفٌ':Subject, #1: 1	وَقْعَ الْكَلِمَةِ
u'وَقَعَ كُوزٌ':Subject, #2: 2	وَقَعَ الْكَنِيفُ
u'وَقَعَ لبنة':Subject, #2: 2	وَقَعَ الْكُوزُ
u'وَقَعَ لَبِنَةٌ':Subject, #1: 1	وَقَعَ لَبِنَةٌ
u'وَقَعَ لعان':Subject, #1: 1	وَقَعَ لَبِنَةٌ
u'وَقَعَ لَفْظٌ':Subject, #4: 4	وَقَعَ اللِّعَانُ
u'وَقَعَ لَمْسٌ':Subject, #1: 1	وَقَعَ اللَّفْظُ
u'وَقَعَ لِوَاءٌ':Subject, #1: 1	وَقَعَ اللَّمْسُ
u'وَقَعَ لَيْلٌ':Predicate, #1: 1	وَقَعَ اللّوَاءُ
u'وَقَعَ مَاءٌ':Subject, #1: 1	وَقَعَ لَيْلاً
u'وَقَعَ مثل':Subject, #9: 9	وَقَعَ الْمَاءُ
u'وَقَعَ مِثْلٌ':Subject, #1: 1	وَقَعَ مِثْلُهُ
u'وَقَعَ مثل':Subject, #1: 1	وَقَعَ مِثْلُهُ
u'وَقَعَ مِثْلٌ':Subject, #9: 9	وَقَعَ مِثْلُ
u'وقع مثل':Added, #9: 9	وَقَعَ مِثْلُ
u'وَقْعٌ مثل':Added, #1: 1	وَقْعُ مِثْلِ
u'وقع مِثْلٌ':Added, #1: 1	وَقْعُ مِثْلِ
u'وَقْعٌ مِثْلٌ':Added, #1: 1	وَقْعُ مِثْلِ
u'وَقَعَ مَجَازٌ':Subject, #1: 1	وَقْعُ مِثْلِ
u'وَقِعَ مَحْظُورٌ':Predicate, #2: 2	وَقَعَ الْمَجَازُ
u'وَقَعَ مُخَالِفٌ':Subject, #1: 1	أَوْقَعَ الْمَحْظُورَ
u'وَقَعَ مَدْحٌ':Subject, #1: 1	وَقَعَ مُخَالِفٌ
u'وَقَعَ مَذْهَبٌ':Subject, #1: 1	وَقَعَ مَدْحُهُ
u'وَقَعَ مَطَرٌ':Subject, #1: 1	وَقَعَ الْمَذْهَبُ
u'وَقَعَ مَطَرٌ':Subject, #2: 2	وَقَعَ الْمَطَرُ
u'وَقَعَ مُعَلَّقٌ':Subject, #3: 3	وَقَعَ مَطَرٌ
u'وَقَعَ مُفْسِدٌ':Subject, #7: 7	وَقَعَ الْمُعَلَّقُ
u'وَقَعَ مَفْهُومٌ':Subject, #1: 1	وَقَعَ الْمُفْسِدُ
u'وَقِعَ مِلْكٌ':Predicate, #1: 1	وَقَعَ الْمَفْهُومُ
u'وَقَعَ مِلْكٌ':Subject, #1: 1	أَوْقَعَ مِلْكَ
u'وَقَعَ مَنْعٌ':Subject, #4: 4	وَقَعَ الْمِلْكُ
u'وقع مُهَنَّدٌ':Added, #1: 1	وَقَعَ الْمَنْعُ
u'وَقْعٌ مُهَنَّدٌ':Added, #1: 1	وَقْعَ مُهَنّدٍ
u'وَقَعَ مَوْتٌ':Subject, #1: 1	وَقْعَ مُهَنّدٍ
u'وَقَعَ مَوْتٌ':Subject, #1: 1	وَقَعَ مَوْتٌ
u'وَقَعَ مُوَرِّث':Subject, #2: 2	وَقَعَ الْمَوْتُ
u'وَقَعَ مَوْضِعٌ':Subject, #1: 1	وَقَعَ مُوَرِّثُهُ
u'وَقَعَ مَوْقِعٌ':Predicate, #1: 1	وَقَعَ مَوْضِعُ
u'وَقَعَ مَوْقِعٌ':Predicate, #4: 4	وَقَعَ مَوْقِعَ
u'وَقَعَ مَوْقِعٌ':Subject, #8: 8	وَقَعَ الْمَوْقِعَ
u'وَقَعَ مَوْقِعٌ':Subject, #1: 1	وَقَعَ مَوْقِعُهُ
u'وَقَعَ مِيرَاثٌ':Subject, #4: 4	وَقَعَ الْمَوْقِعُ
u'وَقِعَ نَاسٌ':Predicate, #1: 1	وَقَعَ الْمِيرَاثُ
u'وَقَعَ نَاسٌ':Subject, #1: 1	أَوْقَعَ النَّاسَ
u'وَقَّعَ نَاظِرٌ':Subject, #1: 1	وَقَعَ النَّاسُ
u'وقع نَبْلٌ':Added, #1: 1	وَقَّعَ النَّاظِرُ
u'وَقْعٌ نَبْلٌ':Added, #1: 1	وَقْعِ النَّبْلِ
u'وَقَعَ نَحْوٌ':Subject, #1: 1	وَقْعِ النَّبْلِ
u'وَقَعَ نَدْبٌ':Subject, #3: 3	وَقَعَ نَحْوُ
u'وَقَعَ نزاع':Subject, #1: 1	وَقَعَ النَّدْبُ
u'وَقَعَ نِزَاعٌ':Subject, #14: 14	وَقَعَ النِّزَاعُ
u'وَقَعَ نزاع':Subject, #14: 14	وَقَعَ النِّزَاعُ
u'وَقَعَ نِزَاعٌ':Subject, #1: 1	وَقَعَ نِزَاعُهُ
u'وَقَعَ نزاع':Subject, #1: 1	وَقَعَ نِزَاعُهُ
u'وَقَعَ نِزَاعٌ':Subject, #4: 4	وَقَعَ نِزَاعٌ
u'وَقَعَ نَسَبٌ':Subject, #4: 4	وَقَعَ نِزَاعٌ
u'وَقَعَ نِسْبَةٌ':Subject, #1: 1	وَقَعَ نَسَبُهُ
u'وَقَعَ نَظَرٌ':Subject, #1: 1	وَقَعَ نِسْبَتُهُ
u'وَقَعَ نَظَرٌ':Subject, #2: 2	وَقَعَ نَظَرُهُ
u'وَقَعَ نَظِيرٌ':Subject, #6: 6	وَقَعَ النَّظَرُ
u'وَقَعَ نَظِيرٌ':Subject, #1: 1	وَقَعَ نَظِيرُهُ
u'وقع نَعْلٌ':Added, #2: 2	وَقَعَ نَظِيرُ
u'وَقْعٌ نَعْلٌ':Added, #1: 1	وَقْعَ نَعْلٍ
u'وقع نَعْلٌ':Added, #1: 1	وَقْعَ نَعْلٍ
u'وَقْعٌ نَعْلٌ':Added, #1: 1	وَقْعَ نَعْلَيْنِ
u'وَقَعَ نَفَذٌ':Predicate, #1: 1	وَقْعَ نَعْلَيْنِ
u'وَقَعَ نَفَلٌ':Subject, #1: 1	وَقَعَ نَفَذَ
u'وَقَعَ نَفِيرٌ':Subject, #1: 1	وَقَعَ النَّفَلُ
u'وَقَعَ نُقْصَانٌ':Subject, #1: 1	وَقَعَ النَّفِيرُ
u'وَقَعَ نقل':Subject, #2: 2	وَقَعَ النُّقْصَانُ
u'وَقَعَ نَقْلٌ':Subject, #1: 1	وَقَعَ النَّقْلُ
u'وَقَعَ نكاح':Subject, #1: 1	وَقَعَ النَّقْلُ
u'وَقَعَ نِكَاحٌ':Subject, #11: 11	وَقَعَ النِّكَاحُ
u'وَقَعَ نكاح':Subject, #11: 11	وَقَعَ النِّكَاحُ
u'وَقَعَ نِكَاحٌ':Subject, #3: 3	وَقَعَ نِكَاحُ
u'وَقَعَ نَهْبٌ':Subject, #3: 3	وَقَعَ نِكَاحُ
u'وَقَعَ نَهْيٌ':Subject, #1: 1	وَقَعَ نَهْبٌ
u'وَقَعَ نُورٌ':Subject, #5: 5	وَقَعَ النَّهْيُ
u'وَقَعَ نَوْعٌ':Subject, #1: 1	وَقَعَ نُورٌ
u'وَقَعَ هَرَجٌ':Subject, #1: 1	وَقَعَ نَوْعُ
u'وَقِعَ واحد':Predicate, #1: 1	وَقَعَ الْهَرَجُ
u'وَقِعَ وَاحِدٌ':Predicate, #3: 3	أَوْقَعَ الْوَاحِدَةَ
u'وَقَعَ واحد':Predicate, #3: 3	أَوْقَعَ الْوَاحِدَةَ
u'وَقَعَ وَاحِدٌ':Predicate, #4: 4	وَقَعَ وَاحِدَةً
u'وَقِعَ واحد':Predicate, #4: 4	وَقَعَ وَاحِدَةً
u'وَقِعَ وَاحِدٌ':Predicate, #5: 5	أَوْقَعَ وَاحِدَةً
u'وَقَعَ واحد':Subject, #5: 5	أَوْقَعَ وَاحِدَةً
u'وَقَعَ وَاحِدٌ':Subject, #1: 1	وَقَعَ وَاحِدٌ
u'وَقَعَ واحد':Subject, #1: 1	وَقَعَ وَاحِدٌ
u'وَقَعَ وَاحِدٌ':Subject, #3: 3	وَقَعَ وَاحِدَةٌ
u'وَقَعَ وَبَاءٌ':Subject, #3: 3	وَقَعَ وَاحِدَةٌ
u'وقع وبال':Added, #3: 3	وَقَعَ الْوَبَاءُ
u'وَقْعٌ وبال':Added, #1: 1	وَقْعُ وَبَالٍ
u'وقع وَبَالٌ':Added, #1: 1	وَقْعُ وَبَالٍ
u'وَقْعٌ وَبَالٌ':Added, #1: 1	وَقْعُ وَبَالٍ
u'وَقَعَ وَجَبٌ':Predicate, #1: 1	وَقْعُ وَبَالٍ
u'وَقَعَ وَجَعٌ':Subject, #1: 1	وَقَعَ وَجَبَ
u'وَقَعَ وَجْهٌ':Subject, #1: 1	وَقَعَ الْوَجَعُ
u'وَقَعَ وَراء':Predicate, #2: 2	وَقَعَ وَجْهُهُ
u'وَقَعَ وَزْنٌ':Subject, #1: 1	وَقَعَ وَرَاءَ
u'وَقَعَ وصل':Subject, #1: 1	وَقَعَ الْوَزْنُ
u'وَقَعَ وَصْلٌ':Subject, #1: 1	وَقَعَ وَصْلُهُ
u'وَقَعَ وَصِيٌّ':Predicate, #1: 1	وَقَعَ وَصْلُهُ
u'وَقَعَ وَطْءٌ':Subject, #3: 3	وَقَعَ وَصِيَّةً
u'وَقَعَ وَفَاءٌ':Subject, #4: 4	وَقَعَ الْوَطْءُ
u'وَقَعَ وقع':Predicate, #1: 1	وَقَعَ الْوَفَاءُ
u'وَقَعَ يَأْسٌ':Subject, #15: 15	وَقَعَ وَقَعَ
u'وَقَعَ يَمِينٌ':Subject, #19: 19	وَقَعَ الْيَأْسُ
u'وَقَعَ يَمِينٌ':Subject, #1: 1	وَقَعَ يَمِينٌ
u'وَقَعَ يَوْمٌ':Predicate, #2: 2	وَقَعَ يَمِينُهُ
u'وَقَعَ يَوْمٌ':Predicate, #1: 1	وَقَعَ الْيَوْمَ
u'وَقَفَ اِبْنٌ':Subject, #2: 2	وَقَعَ يَوْمَ
u'وَقَفَ أَثْمانٌ':Predicate, #1: 1	وَقَفَ ابْنُ
u'وَقَفَ أحَدٌ':Predicate, #1: 1	وَقَفَ الْأَثْمَانَ
u'وَقَفَ أحَدٌ':Subject, #1: 1	وَقَفَ أَحَدَ
u'وَقْفٌ أحَدٌ':Added, #1: 1	وَقَفَ أَحَدُ
u'وَقَفَ أَحَقُّ':Subject, #1: 1	وَقْفِ أَحَدِ
u'وَقْفٌ أَدْوِيَةٌ':Added, #1: 1	وَقَفَ أَحَقُّ
u'وَقَفَ أرْضٌ':Predicate, #2: 2	وَقْفُ الْأَدْوِيَةِ
u'وَقْفٌ أرْضٌ':Added, #3: 3	وَقَفَ الْأَرْضَ
u'وَقْفٌ أرْضٌ':Added, #1: 1	وَقْفُ أَرْضِ
u'وَقْفٌ أرْضٌ':Added, #1: 1	وَقْفِ أَرْضٍ
u'وَقْفٌ أرْضٌ':Added, #1: 1	وَقْفُ أَرْضِهِ
u'وَقْفٌ أرْضٌ':Added, #1: 1	وَقْفُ الْأَرْضِ
u'وَقَفَ أَشْجَارٌ':Predicate, #7: 7	وَقْفِ الْأَرْضِ
u'وَقْفٌ أَشْجَارٌ':Added, #1: 1	وَقَفَ الْأَشْجَارَ
u'وَقْفٌ أَشْجَارٌ':Added, #1: 1	وَقْفُ الْأَشْجَارِ
u'وَقْفٌ أصل':Added, #1: 1	وَقْفِ الْأَشْجَارِ
u'وَقْفٌ أًصْلٌ':Added, #4: 4	وَقْفِ الْأَصْلِ
u'وَقَفَ أعْرَابِيٌّ':Subject, #4: 4	وَقْفِ الْأَصْلِ
u'وَقْفٌ إقْطَاعٌ':Added, #1: 1	وَقَفَ أَعْرَابِيٌّ
u'وَقْفٌ إقْطَاعَةٌ':Added, #2: 2	وَقْفُ الْإِقْطَاعَاتِ
u'وَقَفَ أَكْثَرُ':Predicate, #2: 2	وَقْفُ الْإِقْطَاعَاتِ
u'وَقْفٌ أَكْفَانٌ':Added, #1: 1	وَقَفَ الْأَكْثَرَ
u'وَقَفَ ألف':Subject, #1: 1	وَقْفِ الْأَكْفَانِ
u'وَقْفٌ أُمٌّ':Added, #1: 1	وَقَفَ الْأَلِفُ
u'وَقَفَ إمَامٌ':Subject, #1: 1	وَقْفُ أُمِّ
u'وَقَفَ إمَامٌ':Subject, #13: 13	وَقَفَ الْإِمَامُ
u'وَقْفٌ إمَامٌ':Added, #1: 1	وَقَفَ إمَامٌ
u'وَقْفٌ إمَامٌ':Added, #1: 1	وَقْفُ الْإِمَامِ
u'وَقَفَ أَمْرٌ':Subject, #1: 1	وَقْفِ الْإِمَامِ
u'وَقَفَ أَمْرٌ':Subject, #11: 11	وَقَفَ الْأَمْرُ
u'وَقَفَ إِنْسانٌ':Subject, #2: 2	وَقَفَ أَمْرُهُ
u'وَقْفٌ اِنْعِقَادٌ':Added, #6: 6	وَقَفَ إنْسَانٌ
u'وَقَفَ أهْلٌ':Subject, #1: 1	وَقْفُ انْعِقَادٍ
u'وَقَفَ بُرْجٌ':Predicate, #1: 1	وَقَفَ أَهْلُ
u'وَقْفٌ بَزّاز':Added, #1: 1	وَقَفَ بُرْجَ
u'وَقْفٌ بَزّازَة':Added, #1: 1	وَقْفِ الْبَزَّازِيَّةِ
u'وَقَفَ بَعْضٌ':Predicate, #1: 1	وَقْفِ الْبَزَّازِيَّةِ
u'وَقْفٌ بَعْضٌ':Added, #1: 1	وَقَفَ بَعْضَ
u'وَقْفٌ بَعْضٌ':Added, #1: 1	وَقْفَ الْبَعْضِ
u'وَقَفَ بَقَرٌ':Predicate, #2: 2	وَقْفُ بَعْضِ
u'وَقْفٌ بَلَدٌ':Added, #4: 4	وَقَفَ بَقَرَةً
u'وَقَفَ بِنَاءٌ':Predicate, #1: 1	وَقْفُ بَلَدٍ
u'وَقْفٌ بِنَاءٌ':Added, #4: 4	وَقَفَ الْبِنَاءَ
u'وَقْفٌ بِنَاءٌ':Added, #1: 1	وَقْف الْبِنَاءِ
u'وَقْفٌ بِنَاءٌ':Added, #1: 1	وَقْفَ الْبِنَاءِ
u'وَقْفٌ بِنَاءٌ':Added, #1: 1	وَقْفَ بِنَاءِ
u'وَقْفٌ بِنَاءٌ':Added, #1: 1	وَقْفِ بِنَاءٍ
u'وَقْفٌ بِنَاءٌ':Added, #7: 7	وَقْفِ الْبِنَاءِ
u'وَقَفَ بِئْرٌ':Predicate, #9: 9	وَقْفُ الْبِنَاءِ
u'وَقْفٌ بِئْرٌ':Added, #1: 1	وَقَفَ بِئْرَ
u'وَقَفَ بَيْنٌ':Predicate, #1: 1	وَقْفِ الْبِئْرِ
u'وقفة جمعة':Added, #4: 4	وَقَفَ بَيْنَ
u'وَقْفَةٌ جمعة':Added, #1: 1	وَقْفَةِ الْجُمُعَةِ
u'وقفة جُمُعَةٌ':Added, #1: 1	وَقْفَةِ الْجُمُعَةِ
u'وَقْفَةٌ جُمُعَةٌ':Added, #1: 1	وَقْفَةِ الْجُمُعَةِ
u'وقفة دَابَّةٌ':Added, #1: 1	وَقْفَةِ الْجُمُعَةِ
u'وَقْفَةٌ دَابَّةٌ':Added, #1: 1	وَقْفَةُ الدَّابَّةِ
u'وقفة رَجُلٌ':Added, #1: 1	وَقْفَةُ الدَّابَّةِ
u'وَقْفَةٌ رَجُلٌ':Added, #1: 1	وَقْفَةَ رَجُلٍ
u'وقفة قَاطِعٌ':Added, #1: 1	وَقْفَةَ رَجُلٍ
u'وَقْفَةٌ قَاطِعٌ':Added, #1: 1	وَقْفَةَ قَاطِعٍ
u'وقفة مُشَيِّعٌ':Added, #1: 1	وَقْفَةَ قَاطِعٍ
u'وَقْفَةٌ مُشَيِّعٌ':Added, #1: 1	وَقْفَةِ الْمُشَيِّعِ
u'وَقْفٌ تَبَيُّنٌ':Added, #1: 1	وَقْفَةِ الْمُشَيِّعِ
u'وَقْفٌ تَبَيُّنٌ':Added, #1: 1	وَقْفَ التَّبَيُّنِ
u'وَقْفٌ تَبَيُّنٌ':Added, #1: 1	وَقْفَ تَبَيُّنٍ
u'وَقْفٌ تَبْيِين':Added, #2: 2	وَقْفُ تَبَيُّنٍ
u'وَقْفٌ تَحْرِيرٌ':Added, #2: 2	وَقْفُ تَبْيِينٍ
u'وَقْفٌ تَرْتِيبٌ':Added, #1: 1	وَقْفِ التَّحْرِيرِ
u'وَقْفٌ تَرْتِيبٌ':Added, #2: 2	وَقْفِ التَّرْتِيبِ
u'وَقْفٌ تَرْتِيبٌ':Added, #2: 2	وَقْفُ تَرْتِيبٍ
u'وَقْفٌ تَشْرِيك':Added, #6: 6	وَقْفَ تَرْتِيبٍ
u'وَقْفٌ تَشْرِيكٌ':Added, #1: 1	وَقْفِ التَّشْرِيكِ
u'وَقْفٌ تَصَرُّفٌ':Added, #2: 2	وَقْفُ تَشْرِيكٍ
u'وَقْفٌ تَصَرُّفٌ':Added, #1: 1	وَقْفِ تَصَرُّفِ
u'وَقْفٌ ثَغْرٌ':Added, #1: 1	وَقْفَ تَصَرُّفِهِ
u'وَقَفَ ثَلاثَةٌ':Subject, #3: 3	وَقْفِ الثَّغْرِ
u'وَقْفٌ ثَمَنٌ':Added, #1: 1	وَقَفَ ثَلَاثَةٌ
u'وَقْفٌ ثَمَنٌ':Added, #1: 1	وَقْفَ الثَّمَنِ
u'وَقْفٌ ثِيابٌ':Added, #2: 2	وَقْفِ الثَّمَنِ
u'وَقَفَ جَازٌ':Predicate, #1: 1	وَقْفُ الثِّيَابِ
u'وَقْفٌ جِذْعٌ':Added, #1: 1	وَقَفَ جَازَ
u'وَقْفٌ جَهالَة':Added, #1: 1	وَقْفِ الْجِذْعِ
u'وَقَفَ حاجٌّ':Subject, #1: 1	وَقْفُ جَهَالَةٍ
u'وَقْفٌ حالِيٌّ':Added, #2: 2	وَقَفَ الْحَاجُّ
u'وَقَفَ حامِلٌ':Predicate, #1: 1	وَقْفِ الْحَالِيِّ
u'وَقْفٌ حانوتٌ':Added, #1: 1	وَقَفَ الْحَامِلَ
u'وَقْفٌ حُرٌّ':Added, #1: 1	وَقْفِ الْحَانُوتِ
u'وَقْفٌ حَرَمٌ':Added, #1: 1	وَقْفُ الْحُرِّ
u'وَقْفٌ حِصَّةٌ':Added, #1: 1	وَقْفِ الْحَرَمَيْنِ
u'وَقْفٌ حُصُرٌ':Added, #1: 1	وَقْفِ حِصَّةٍ
u'وَقَفَ حَظٌّ':Subject, #1: 1	وَقْفِ الْحُصُرِ
u'وَقْفٌ حُكْمٌ':Added, #1: 1	وَقَفَ حَظُّ
u'وَقْفٌ حُلِيٌّ':Added, #1: 1	وَقْفُ الْحُكْمِ
u'وَقْفٌ حُلِيٌّ':Added, #1: 1	وَقْفَ الْحُلِيِّ
u'وَقَفَ حِمَارٌ':Subject, #1: 1	وَقْفُ الْحُلِيِّ
u'وَقْفٌ حَمَامٌ':Added, #1: 1	وَقَفَ حِمَارُ
u'وَقْفٌ حَمَّامٌ':Added, #1: 1	وَقْفِ الْحَمَامِ
u'وَقَفَ حَمَلٌ':Predicate, #1: 1	وَقْفِ الْحَمَّامِ
u'وَقْفٌ حَمْلٌ':Added, #1: 1	وَقَفَ حَمَلَ
u'وَقْفٌ حَوانِيتُ':Added, #1: 1	وَقْفُ الْحَمْلِ
u'وَقْفٌ حَوانِيتُ':Added, #1: 1	وَقْفِ الْحَوَانِيتِ
u'وَقَفَ خَارِجٌ':Predicate, #1: 1	وَقْفَ حَوَانِيتِ
u'وَقْفٌ خَبَرٌ':Added, #1: 1	وَقَفَ خَارِجَ
u'وَقْفٌ خَبَر':Added, #1: 1	وَقْفُ خَبَرِهِ
u'وَقْفٌ خَرَابٌ':Added, #1: 1	وَقْفُ خَبَرِهِ
u'وَقْفٌ خِزَانَةٌ':Added, #1: 1	وَقْفٍ خَرَابٍ
u'وَقَفَ خَطِيبٌ':Subject, #1: 1	وَقْفِ خِزَانَةِ
u'وَقَفَ خَلْفٌ':Predicate, #1: 1	وَقَفَ الْخَطِيبُ
u'وَقْفٌ خَلِيلٌ':Added, #5: 5	وَقَفَ خَلْفَ
u'وَقَفَ دَارٌ':Predicate, #1: 1	وَقْفُ الْخَلِيلِ
u'وَقَفَ دَارٌ':Predicate, #1: 1	وَقَفَ دَارَ
u'وَقْفٌ دَارٌ':Added, #2: 2	وَقَفَ الدَّارَ
u'وَقْفٌ دَارٌ':Added, #1: 1	وَقْفُ الدَّارِ
u'وَقْفٌ دَارٌ':Added, #1: 1	وَقْفَ دَارٍ
u'وَقْفٌ دَارٌ':Added, #1: 1	وَقْفِ دَارِ
u'وَقَفَ دَرَاهِمُ':Predicate, #2: 2	وَقْفِ الدَّارِ
u'وَقَفَ دَرَاهِمُ':Predicate, #1: 1	وَقَفَ دَرَاهِمَ
u'وَقْفٌ دَرَاهِمُ':Added, #2: 2	وَقَفَ الدَّرَاهِمَ
u'وَقْفٌ دفع':Added, #1: 1	وَقْفُ الدَّرَاهِمِ
u'وَقْفٌ دَفْعٌ':Added, #1: 1	وَقْفِ الدَّفْعِ
u'وَقَفَ ذِمِّيٌّ':Subject, #1: 1	وَقْفِ الدَّفْعِ
u'وَقَفَ ذِمِّيٌّ':Subject, #1: 1	وَقَفَ ذِمِّيٌّ
u'وَقْفٌ ذِمِّيٌّ':Added, #2: 2	وَقَفَ الذِّمِّيُّ
u'وَقْفٌ ذِمِّيٌّ':Added, #1: 1	وَقْفَ الذِّمِّيِّ
u'وَقْفٌ ذِمِّيٌّ':Added, #2: 2	وَقْفُ الذِّمِّيِّ
u'وَقَفَ رَاكِبٌ':Subject, #3: 3	وَقْفِ الذِّمِّيِّ
u'وَقَفَ رَاهِنٌ':Subject, #1: 1	وَقَفَ الرَّاكِبُ
u'وَقْفٌ رباط':Added, #1: 1	وَقَفَ الرَّاهِنُ
u'وَقْفٌ رِبَاطٌ':Added, #1: 1	وَقْفِ الرِّبَاطِ
u'وَقَفَ رِجَالٌ':Subject, #1: 1	وَقْفِ الرِّبَاطِ
u'وَقَفَ رَجُلٌ':Subject, #1: 1	وَقَفَ الرِّجَالُ
u'وَقَفَ رَجُلٌ':Subject, #2: 2	وَقَفَ رَجُلٌ
u'وَقْفٌ رَجُلٌ':Added, #3: 3	وَقَفَ الرَّجُلُ
u'وَقْفٌ رَجُلٌ':Added, #1: 1	وَقْفَ الرَّجُلِ
u'وَقَفَ رَسُولٌ':Subject, #2: 2	وَقْفِ الرَّجُلِ
u'وَقْفٌ رَقيقٌ':Added, #13: 13	وَقَفَ رَسُولُ
u'وَقْفٌ رَقيق':Added, #1: 1	وَقْفُ الرَّقِيقِ
u'وَقَفَ رَكْبٌ':Subject, #1: 1	وَقْفُ الرَّقِيقِ
u'وَقَفَ رُمَاةٌ':Subject, #1: 1	وَقَفَ رَكْبٌ
u'وَقْفٌ زائِدٌ':Added, #1: 1	وَقَفَ الرُّمَاةُ
u'وَقْفٌ زائِدٌ':Added, #1: 1	وَقْفُ الزَّائِدِ
u'وَقْفٌ سَابِقٌ':Added, #1: 1	وَقْفُ زَائِدٍ
u'وَقْفٌ سُتُورٌ':Added, #1: 1	وَقْفٍ سَابِقٍ
u'وَقْفٌ سُتُورٌ':Added, #1: 1	وَقْفَ السُّتُورِ
u'وَقْفٌ سُتُورٌ':Added, #1: 1	وَقْفَ سُتُورٍ
u'وَقْفٌ سَفِينَةٌ':Added, #1: 1	وَقْفُ سُتُورٍ
u'وَقْفٌ سِلاَحٌ':Added, #1: 1	وَقْفَ السَّفِينَةِ
u'وَقْفٌ سِلاَحٌ':Added, #1: 1	وَقْفُ السِّلَاحِ
u'وَقَفَ سَوادٌ':Predicate, #1: 1	وَقْفُ سِلَاحٍ
u'وَقَفَ شافِعِيّ':Subject, #1: 1	وَقَفَ السَّوَادَ
u'وَقَفَ شَاهِدٌ':Subject, #1: 1	وَقَفَ الشَّافِعِيُّ
u'وَقْفٌ شَجَرٌ':Added, #1: 1	وَقَفَ الشَّاهِدُ
u'وَقْفٌ شَجَرَةٌ':Added, #1: 1	وَقْفُ الشَّجَرِ
u'وَقْفٌ شَجَرَةٌ':Added, #1: 1	وَقْفَ الشَّجَرَةِ
u'وَقَفَ شَخْصٌ':Subject, #1: 1	وَقْفُ الشَّجَرَةِ
u'وَقْفٌ شَرْطٌ':Added, #2: 2	وَقَفَ شَخْصٌ
u'وَقْفٌ شَفِيعٌ':Added, #1: 1	وَقْفِ شَرْطٍ
u'وَقْفٌ شُهُودٌ':Added, #2: 2	وَقْفُ الشَّفِيعِ
u'وَقَفَ شَيْءٌ':Subject, #1: 1	وَقْفِ الشُّهُودِ
u'وَقْفٌ شَيْءٌ':Added, #1: 1	وَقَفَ شَيْءٌ
u'وَقَفَ شَيْخٌ':Subject, #4: 4	وَقْفِ شَيْءٍ
u'وَقَفَ صِحَّةٌ':Predicate, #1: 1	وَقَفَ الشَّيْخُ
u'وَقْفٌ صِحَّةٌ':Added, #1: 1	وَقَفَ صِحَّةَ
u'وَقْفٌ صِحَّةٌ':Added, #1: 1	وَقْفُ الصِّحَّةِ
u'وَقَفَ صداق':Predicate, #2: 2	وَقْفُ صِحَّةٍ
u'وَقَفَ صَدَاقٌ':Predicate, #1: 1	وَقَفَ صَدَاقَ
u'وَقَفَ صَفٌّ':Subject, #1: 1	وَقَفَ صَدَاقَ
u'وَقْفٌ صَلاَحٌ':Added, #1: 1	وَقَفَ صَفٌّ
u'وَقَفَ صَوْمٌ':Subject, #1: 1	وَقْفِ صَلَاحِ
u'وَقَفَ ضَيْعَةٌ':Predicate, #1: 1	وَقَفَ صَوْمُ
u'وَقَفَ ضَيْعَةٌ':Predicate, #1: 1	وَقَفَ الضَّيْعَةَ
u'وَقْفٌ ضَيْعَةٌ':Added, #2: 2	وَقَفَ ضَيْعَةَ
u'وَقْفٌ ضَيْعَةٌ':Added, #1: 1	وَقْفِ الضَّيْعَةِ
u'وَقْفٌ ظَهِير':Added, #2: 2	وَقْفُ الضَّيْعَةِ
u'وَقْفٌ ظَهِيرَة':Added, #1: 1	وَقْفِ الظَّهِيرِيَّةِ
u'وَقْفٌ عَارِفٌ':Added, #1: 1	وَقْفِ الظَّهِيرِيَّةِ
u'وَقْفٌ عَامٌّ':Added, #1: 1	وَقْفُ عَارِفٍ
u'وَقَفَ عِبَادٌ':Predicate, #7: 7	وَقْفٍ عَامٍّ
u'وَقْفٌ عَبْدٌ':Added, #1: 1	وَقَفَ الْعِبَادَ
u'وَقْفٌ عَبْدٌ':Added, #1: 1	وَقْفُ عَبْدٍ
u'وَقَفَ عَبِيدٌ':Predicate, #1: 1	وَقْفُ عَبْدِهِ
u'وَقْفٌ عَبِيدٌ':Added, #1: 1	وَقَفَ الْعَبِيدَ
u'وَقَفَ عتق':Subject, #2: 2	وَقْفُ الْعَبِيدِ
u'وَقَفَ عِتْقٌ':Subject, #1: 1	وَقَفَ عِتْقُهُ
u'وَقْفٌ عتق':Added, #1: 1	وَقَفَ عِتْقُهُ
u'وَقْفٌ عِتْقٌ':Added, #1: 1	وَقْفِ الْعِتْقِ
u'وَقْفٌ عَفْوٌ':Added, #1: 1	وَقْفِ الْعِتْقِ
u'وَقْفٌ عَقَارٌ':Added, #1: 1	وَقْفِ عَفْوِهِ
u'وَقْفٌ عَقَارٌ':Added, #1: 1	وَقْفِ الْعَقَارَاتِ
u'وَقْفٌ عَقَارٌ':Added, #2: 2	وَقْفِ الْعَقَارِ
u'وَقْفٌ عَقْدٌ':Added, #7: 7	وَقْفُ الْعَقَارِ
u'وَقَفَ عَقْلٌ':Subject, #2: 2	وَقْفُ الْعَقْدِ
u'وَقْفٌ عُقُودٌ':Added, #1: 1	وَقَفَ عَقْلُهُ
u'وَقْفٌ عُقُودٌ':Added, #1: 1	وَقْفُ الْعُقُودِ
u'وَقَفَ علماء':Subject, #4: 4	وَقْفِ الْعُقُودِ
u'وَقَفَ عُلَمَاءُ':Subject, #1: 1	وَقَفَ الْعُلَمَاءُ
u'وَقَفَ علماء':Subject, #1: 1	وَقَفَ الْعُلَمَاءُ
u'وَقَفَ عُلَمَاءُ':Subject, #1: 1	وَقَفَ عُلَمَاءُ
u'وَقَفَ عُلْوٌ':Predicate, #1: 1	وَقَفَ عُلَمَاءُ
u'وَقْفٌ عُلُوٌّ':Added, #1: 1	وَقَفَ عُلْوَ
u'وَقْفٌ عُلْوٌ':Added, #1: 1	وَقْفَ عُلُوِّ
u'وَقْفٌ عُلْوٌ':Added, #2: 2	وَقْفُ الْعُلْوِ
u'وَقَفَ عَلِيٌّ':Subject, #2: 2	وَقْفِ الْعُلْوِ
u'وَقْفٌ عِمَارَةٌ':Added, #1: 1	وَقَفَ عَلِيُّ
u'وَقَفَ عُمَرٌ':Subject, #1: 1	وَقْفِ عِمَارَةِ
u'وَقْفٌ عُمُومٌ':Added, #1: 1	وَقَفَ عُمَرُ
u'وَقَفَ عند':Predicate, #3: 3	وَقْفِ الْعُمُومِ
u'وَقَفَ غَرِيمٌ':Subject, #10: 10	وَقَفَ عِنْدَ
u'وَقْفٌ غِلْمَانٌ':Added, #1: 1	وَقَفَ الْغَرِيمُ
u'وَقْفٌ غير':Added, #3: 3	وَقْفُ الْغِلْمَانِ
u'وَقْفٌ غَيْرٌ':Added, #1: 1	وَقْفُ الْغَيْرِ
u'وَقْفٌ غير':Added, #1: 1	وَقْفُ الْغَيْرِ
u'وَقْفٌ غَيْرٌ':Added, #1: 1	وَقْفِ غَيْرِ
u'وَقْفٌ غير':Added, #1: 1	وَقْفِ غَيْرِ
u'وَقْفٌ غَيْرٌ':Added, #1: 1	وَقْفُ غَيْرِهِ
u'وَقْفٌ غير':Added, #1: 1	وَقْفُ غَيْرِهِ
u'وَقْفٌ غَيْرٌ':Added, #3: 3	وَقْفُ غَيْرِ
u'وَقْفٌ فَحْلٌ':Added, #3: 3	وَقْفُ غَيْرِ
u'وَقْفٌ فَرَسٌ':Added, #1: 1	وَقْفُ فَحْلِ
u'وَقَفَ فَرْضٌ':Subject, #1: 1	وَقْفِ الْفَرَسِ
u'وَقْفٌ فُضُولِيٌّ':Added, #1: 1	وَقَفَ الْفَرْضُ
u'وَقْفٌ فقراء':Added, #1: 1	وَقْفِ الْفُضُولِيِّ
u'وَقْفٌ فقراء':Added, #1: 1	وَقْفَ الْفُقَرَاءِ
u'وَقَفَ فلان':Subject, #2: 2	وَقْفِ الْفُقَرَاءِ
u'وَقَفَ فلان':Subject, #1: 1	وَقَفَ الزُّبَيْرُ
u'وَقَفَ فلان':Subject, #1: 1	وَقَفَ الشَّافِعِيُّ
u'وَقَفَ فُلاَنٌ':Subject, #3: 3	وَقَفَ عُثْمَانُ
u'وَقْفٌ فلان':Added, #3: 3	وَقَفَ فُلَانٌ
u'وَقْفٌ فلان':Added, #1: 1	وَقْفِ الْبَزَّازِيَّةِ
u'وَقْفٌ فُلاَنٌ':Added, #1: 1	وَقْفُ الزُّبَيْرِ
u'وَقَفَ قضاة':Subject, #3: 3	وَقْفُ فُلَانِ
u'وَقَفَ قطعة':Predicate, #1: 1	وَقَفَ الْقُضَاةُ
u'وَقَفَ قِطْعَةٌ':Predicate, #2: 2	وَقَفَ قِطْعَةَ
u'وَقَفَ قَلَمٌ':Subject, #2: 2	وَقَفَ قِطْعَةَ
u'وَقَفَ قِنْدِيلٌ':Predicate, #1: 1	وَقَفَ قَلَمُهُ
u'وَقَفَ قَوْمٌ':Subject, #2: 2	وَقَفَ قِنْدِيلَ
u'وَقْفٌ كَافِرٌ':Added, #1: 1	وَقَفَ قَوْمٌ
u'وَقْفٌ كَافِرٌ':Added, #1: 1	وَقْفَ الْكَافِرِ
u'وَقَفَ كِتَابٌ':Predicate, #2: 2	وَقْفِ الْكَافِرِ
u'وَقْفٌ كُتُبٌ':Added, #1: 1	وَقَفَ الْكِتَابَ
u'وَقْفٌ كُتُبٌ':Added, #1: 1	وَقْفَ الْكُتُبِ
u'وَقْفٌ كُتُبٌ':Added, #1: 1	وَقْفُ كُتُبٍ
u'وَقْفٌ كُرَّاسٌ':Added, #2: 2	وَقْفِ الْكُتُبِ
u'وَقْفٌ كُرَاعٌ':Added, #1: 1	وَقْفِ الْكُرَّاسَةِ
u'وَقَفَ كَرْمٌ':Predicate, #1: 1	وَقْفُ الْكُرَاعِ
u'وَقْفٌ كُفَّارٌ':Added, #1: 1	وَقَفَ الْكَرْمَ
u'وَقَفَ كَلاَمٌ':Subject, #1: 1	وَقْفِ الْكُفَّارِ
u'وَقَفَ كَلْبٌ':Subject, #1: 1	وَقَفَ الْكَلَامُ
u'وَقْفٌ كَلْبٌ':Added, #3: 3	وَقَفَ الْكَلْبُ
u'وَقْفٌ كَنِيسَةٌ':Added, #2: 2	وَقْفُ الْكَلْبِ
u'وَقْفٌ كَنِيسَةٌ':Added, #1: 1	وَقْفِ الْكَنِيسَةِ
u'وَقْفٌ لقطاء':Added, #2: 2	وَقْفَ الْكَنِيسَةِ
u'وَقْفٌ مَاءٌ':Added, #1: 1	وَقْفِ اللُّقَطَاءِ
u'وَقْفٌ مَاءٌ':Added, #5: 5	وَقْفِ الْمَاءِ
u'وَقَفَ مَالٌ':Predicate, #7: 7	وَقْفُ الْمَاءِ
u'وَقَفَ مَالِكٌ':Subject, #1: 1	وَقَفَ مَالَ
u'وَقْفٌ مَالِكٌ':Added, #1: 1	وَقَفَ مَالِكٌ
u'وَقَفَ مَبِيعٌ':Predicate, #1: 1	وَقْفِ مَالِكٍ
u'وَقْفٌ مَبِيعٌ':Added, #3: 3	وَقَفَ الْمَبِيعَ
u'وَقَفَ مُجَرَّدٌ':Subject, #1: 1	وَقْفَ الْمَبِيعِ
u'وَقَفَ مَجُوسِيٌّ':Subject, #1: 1	وَقَفَ الْمُجَرَّدُ
u'وَقْفٌ مَجُوسِيٌّ':Added, #1: 1	وَقَفَ الْمَجُوسِيُّ
u'وَقْفٌ مُدَبَّرٌ':Added, #1: 1	وَقْفُ الْمَجُوسِيِّ
u'وَقْفٌ مُدَبَّرٌ':Added, #1: 1	وَقْفُ الْمُدَبَّرِ
u'وَقْفٌ مَدْرَسَةٌ':Added, #2: 2	وَقْفِ الْمُدَبَّرِ
u'وَقْفٌ مَدْيُونٌ':Added, #1: 1	وَقْفِ الْمَدْرَسَةِ
u'وَقْفٌ مُرْتَدٌّ':Added, #1: 1	وَقْفِ الْمَدْيُونِ
u'وَقْفٌ مُرْتَدٌّ':Added, #1: 1	وَقْفُ الْمُرْتَدِّ
u'وَقْفٌ مُرْتَدٌّ':Added, #1: 1	وَقْفِ الْمُرْتَدِّ
u'وَقَفَ مَرَضٌ':Subject, #2: 2	وَقْفُ الْمُرْتَدَّةِ
u'وَقَفَ مَرْهُونٌ':Predicate, #1: 1	وَقَفَ مَرَضُهُ
u'وَقْفٌ مَرْهُونٌ':Added, #1: 1	وَقَفَ الْمَرْهُونَ
u'وَقَفَ مَرِيضٌ':Subject, #1: 1	وَقْفُ الْمَرْهُونِ
u'وَقْفٌ مَرِيضٌ':Added, #3: 3	وَقَفَ الْمَرِيضُ
u'وَقْفٌ مَرِيضٌ':Added, #1: 1	وَقْفِ الْمَرِيضِ
u'وَقْفٌ مُسْتَأْجِرٌ':Added, #2: 2	وَقْفُ الْمَرِيضِ
u'وَقْفٌ مُسْتَأْجِرٌ':Added, #1: 1	وَقْفُ الْمُسْتَأْجِرِ
u'وَقَفَ مَسْجِدٌ':Predicate, #1: 1	وَقْفِ الْمُسْتَأْجِرِ
u'وَقْفٌ مَسْجِدٌ':Added, #1: 1	وَقَفَ الْمَسْجِدَ
u'وَقْفٌ مَسْجِدٌ':Added, #16: 16	وَقْفِ الْمَسْجِدِ
u'وَقْفٌ مَسْجِدٌ':Added, #2: 2	وَقْفَ الْمَسْجِدِ
u'وَقْفٌ مَسْجِدٌ':Added, #2: 2	وَقْفُ الْمَسْجِدِ
u'وَقْفٌ مَسْجِدٌ':Added, #2: 2	وَقْفَ مَسْجِدٍ
u'وَقْفٌ مَسْجِدٌ':Added, #2: 2	وَقْفُ مَسْجِدٍ
u'وَقَفَ مُسْلِمٌ':Subject, #3: 3	وَقْفُ مَسْجِدِ
u'وَقْفٌ مُسْلِمٌ':Added, #2: 2	وَقَفَ الْمُسْلِمُ
u'وَقْفٌ مُسْلِمٌ':Added, #1: 1	وَقْفَ الْمُسْلِمِ
u'وَقْفٌ مُشاعٌ':Added, #3: 3	وَقْفُ الْمُسْلِمِ
u'وَقْفٌ مُشاعٌ':Added, #2: 2	وَقْفَ الْمُشَاعِ
u'وَقْفٌ مُشاعٌ':Added, #6: 6	وَقْفُ الْمُشَاعِ
u'وَقْفٌ مَشْمُومٌ':Added, #8: 8	وَقْفِ الْمُشَاعِ
u'وَقْفٌ مَشْهُورٌ':Added, #1: 1	وَقْفُ الْمَشْمُومِ
u'وَقْفٌ مَصَاحِفُ':Added, #1: 1	وَقْفٍ مَشْهُورٍ
u'وَقْفٌ مَصَالِحُ':Added, #1: 1	وَقْفَ الْمَصَاحِفِ
u'وَقْفٌ مُصْحَفٌ':Added, #1: 1	وَقْفِ الْمَصَالِحِ
u'وَقْفٌ مُصْحَفٌ':Added, #1: 1	وَقْفِ الْمُصْحَفِ
u'وَقْفٌ مَطْعُوم':Added, #2: 2	وَقْفُ الْمُصْحَفِ
u'وَقَفَ مَطْلُوبٌ':Subject, #1: 1	وَقْفُ مَطْعُومٍ
u'وَقْفٌ مُعْتَزِلٌ':Added, #1: 1	وَقَفَ الْمَطْلُوبُ
u'وَقْفٌ مُعْتَزِلَةٌ':Added, #1: 1	وَقْفِ الْمُعْتَزِلَةِ
u'وَقْفٌ مُعَلَّمٌ':Added, #1: 1	وَقْفِ الْمُعْتَزِلَةِ
u'وَقْفٌ مُعَيَّنٌ':Added, #2: 2	وَقْفُ الْمُعَلَّمِ
u'وَقْفٌ مَغْصُوب':Added, #1: 1	وَقْفٍ مُعَيَّنٍ
u'وَقْفٌ مَقَابِرُ':Added, #1: 1	وَقْفُ الْمَغْصُوبِ
u'وَقْفٌ مَقْبَرَةٌ':Added, #1: 1	وَقْفَ الْمَقَابِرِ
u'وَقْفٌ مَقْبَرَةٌ':Added, #1: 1	وَقْفَ الْمَقْبَرَةِ
u'وَقْفٌ مَكَانٌ':Added, #2: 2	وَقْفُ الْمَقْبَرَةِ
u'وَقْفٌ مَكْتَبٌ':Added, #2: 2	وَقْفِ مَكَانِهِ
u'وَقْفٌ مَمْلُوكٌ':Added, #2: 2	وَقْفِ مَكْتَبٍ
u'وَقْفٌ مَنَافِعُ':Added, #1: 1	وَقْفُ مَمْلُوكٍ
u'وَقْفٌ مَنَافِعُ':Added, #1: 1	وَقْفَ الْمَنَافِعِ
u'وَقْفٌ مَنَافِعُ':Added, #1: 1	وَقْفِ الْمَنَافِعِ
u'وَقْفٌ مَنْفَعَةٌ':Added, #1: 1	وَقْفُ مَنَافِعِ
u'وَقْفٌ مَنْقُولٌ':Added, #1: 1	وَقْفُ مَنْفَعَةِ
u'وَقْفٌ مَنْقُولٌ':Added, #2: 2	وَقْفَ الْمَنْقُولِ
u'وَقْفٌ مَنْقُولٌ':Added, #4: 4	وَقْفِ الْمَنْقُولِ
u'وَقَفَ مَوْقِفٌ':Predicate, #7: 7	وَقْفُ الْمَنْقُولِ
u'وَقَفَ مَوْهُوبٌ':Subject, #1: 1	وَقَفَ مَوْقِفَ
u'وَقَفَ مِيرَاثٌ':Subject, #1: 1	وَقَفَ الْمَوْهُوبُ
u'وَقَفَ نَاسٌ':Subject, #1: 1	وَقَفَ مِيرَاثُهُ
u'وَقَفَ نَاظِرٌ':Subject, #3: 3	وَقَفَ النَّاسُ
u'وَقْفٌ نَخْلٌ':Added, #1: 1	وَقَفَ النَّاظِرُ
u'وَقَفَ نِصْفٌ':Predicate, #1: 1	وَقْفِ نَخْلٍ
u'وَقَفَ نِصْفٌ':Subject, #5: 5	وَقَفَ نِصْفَ
u'وَقَفَ نَصِيبٌ':Subject, #1: 1	وَقَفَ النِّصْفُ
u'وَقَفَ نَظَرٌ':Subject, #1: 1	وَقَفَ نَصِيبُ
u'وَقْفٌ نَعَمٌ':Added, #1: 1	وَقَفَ نَظَرُهُ
u'وَقَفَ نَفَرٌ':Subject, #1: 1	وَقْفَ النَّعَمِ
u'وَقْفٌ نَفْسٌ':Added, #1: 1	وَقَفَ نَفَرٌ
u'وَقْفٌ نُفُوذٌ':Added, #1: 1	وَقْفُ نَفْسِهِ
u'وَقَفَ نكاح':Predicate, #1: 1	وَقْفُ نُفُوذِهِ
u'وَقَفَ نِكَاحٌ':Predicate, #1: 1	وَقَفَ نِكَاحَهُنَّ
u'وَقْفٌ نَوَازِلُ':Added, #1: 1	وَقَفَ نِكَاحَهُنَّ
u'وَقْفٌ هِلاَلٌ':Added, #1: 1	وَقْفِ النَّوَازِلِ
u'وَقَفَ واحد':Subject, #3: 3	وَقْفِ هِلَالٍ
u'وَقَفَ وَاحِدٌ':Subject, #2: 2	وَقَفَ وَاحِدٌ
u'وَقْفٌ وَارِثٌ':Added, #2: 2	وَقَفَ وَاحِدٌ
u'وَقَفَ وَاقِفٌ':Subject, #1: 1	وَقْفَ الْوَارِثِ
u'وَقْفٌ وَاقِفٌ':Added, #2: 2	وَقَفَ الْوَاقِفُ
u'وَقْفٌ ورق':Added, #3: 3	وَقْفُ الْوَاقِفِ
u'وَقْفٌ وَرَقٌ':Added, #1: 1	وَقْفِ الْوَرَقِ
u'وَقَفَ وُقُوعٌ':Subject, #1: 1	وَقْفِ الْوَرَقِ
u'وَقْفٌ وَلِيٌّ':Added, #1: 1	وَقَفَ وُقُوعُهُ
u'وَقَفَ يَوْمٌ':Predicate, #1: 1	وَقْفَ الْوَلِيِّ
u'وُقُودٌ أهْلٌ':Added, #5: 5	وَقَفَ يَوْمَ
u'وُقُوعٌ إجَارَةٌ':Added, #2: 2	وُقُودُ أَهْلِ
u'وُقُوعٌ إجَارَةٌ':Added, #1: 1	وُقُوعُ الْإِجَارَاتِ
u'وُقُوعٌ إجَازَةٌ':Added, #1: 1	وُقُوعُ الْإِجَارَةِ
u'وُقُوعٌ إِجْزَاءٌ':Added, #1: 1	وُقُوعُ الْإِجَازَةِ
u'وُقُوعٌ إِجْمَاعٌ':Added, #2: 2	وُقُوعَ الْإِجْزَاءِ
u'وُقُوعٌ إِجْمَاعٌ':Added, #1: 1	وُقُوعُ الْإِجْمَاعِ
u'وُقُوعٌ إِجْمَاعٌ':Added, #2: 2	وُقُوعَ الْإِجْمَاعِ
u'وُقُوعٌ اِحْتِمَالٌ':Added, #2: 2	وُقُوعِ الْإِجْمَاعِ
u'وُقُوعٌ أحَدٌ':Added, #1: 1	وُقُوعَ احْتِمَالٍ
u'وُقُوعٌ أحَدٌ':Added, #1: 1	وُقُوعَ أَحَدِ
u'وُقُوعٌ إِحْرَامٌ':Added, #3: 3	وُقُوعِ أَحَدِ
u'وُقُوعٌ إِحْرَامٌ':Added, #1: 1	وُقُوعَ إحْرَامِهِ
u'وُقُوعٌ إِحْرَامٌ':Added, #1: 1	وُقُوعَ الْإِحْرَامِ
u'وُقُوعٌ أَدَاءٌ':Added, #2: 2	وُقُوعُ الْإِحْرَامِ
u'وُقُوعٌ آدَمِيٌّ':Added, #2: 2	وُقُوعِ الْأَدَاءِ
u'وُقُوعٌ أَذَانٌ':Added, #1: 1	وُقُوعَ آدَمِيٍّ
u'وُقُوعٌ إِسْلامٌ':Added, #1: 1	وُقُوعِ الْأَذَانِ
u'وُقُوعٌ اِسْمٌ':Added, #1: 1	وُقُوعُ الْإِسْلَامِ
u'وُقُوعٌ أَسْماءٌ':Added, #2: 2	وُقُوعِ اسْمِ
u'وُقُوعٌ أَسْماءٌ':Added, #1: 1	وُقُوعَ الْأَسْمَاءِ
u'وُقُوعٌ أصل':Added, #2: 2	وُقُوعِ الْأَسْمَاءِ
u'وُقُوعٌ أًصْلٌ':Added, #1: 1	وُقُوعُ أَصْلِ
u'وُقُوعٌ أصل':Added, #1: 1	وُقُوعُ أَصْلِ
u'وُقُوعٌ أًصْلٌ':Added, #3: 3	وُقُوعِ الْأَصْلِ
u'وُقُوعٌ أَصْلَحُ':Added, #3: 3	وُقُوعِ الْأَصْلِ
u'وُقُوعٌ أَعْمَالٌ':Added, #1: 1	وُقُوعُ الْأَصْلَحِ
u'وُقُوعٌ أَفْعَالٌ':Added, #1: 1	وُقُوعِ الْأَعْمَالِ
u'وُقُوعٌ إقْرَارٌ':Added, #1: 1	وُقُوعِ أَفْعَالٍ
u'وُقُوعٌ إقْرَارٌ':Added, #1: 1	وُقُوعُ الْإِقْرَارِ
u'وُقُوعٌ أُلْفَةٌ':Added, #2: 2	وُقُوعِ الْإِقْرَارِ
u'وُقُوعٌ ألَمٌ':Added, #1: 1	وُقُوعِ الْأُلْفَةِ
u'وُقُوعٌ أَمْرٌ':Added, #1: 1	وُقُوعُ الْأَلَمِ
u'وُقُوعٌ أَمْرٌ':Added, #1: 1	وُقُوعُ أَمْرٍ
u'وُقُوعٌ أَمْرٌ':Added, #1: 1	وُقُوعِ أَمْرٍ
u'وُقُوعٌ أَمْرٌ':Added, #2: 2	وُقُوعُ الْأَمْرِ
u'وُقُوعٌ أَمْنٌ':Added, #2: 2	وُقُوعِ الْأَمْرِ
u'وُقُوعٌ أَوَّلُ':Added, #1: 1	وُقُوعِ الْأَمْنِ
u'وُقُوعٌ أَوَّلُ':Added, #1: 1	وُقُوعَ الْأَوَّلِ
u'وُقُوعٌ أَوَّلُ':Added, #2: 2	وُقُوعُ الْأَوَّلِ
u'وُقُوعٌ بَائِنٌ':Added, #6: 6	وُقُوعِ الْأَوَّلِ
u'وُقُوعٌ بَائِنٌ':Added, #1: 1	وُقُوعَ الْبَائِنِ
u'وُقُوعٌ بَائِنٌ':Added, #2: 2	وُقُوعِ الْبَائِنِ
u'وُقُوعٌ بَراءةٌ':Added, #3: 3	وُقُوعُ الْبَائِنِ
u'وُقُوعٌ بَراءةٌ':Added, #1: 1	وُقُوعِ الْبَرَاءَةِ
u'وُقُوعٌ بَصَرٌ':Added, #2: 2	وُقُوعُ الْبَرَاءَةِ
u'وُقُوعٌ بَصَرٌ':Added, #1: 1	وُقُوعَ بَصَرِهِ
u'وُقُوعٌ بَعْضٌ':Added, #2: 2	وُقُوعِ بَصَرِهِ
u'وُقُوعٌ بَعْضٌ':Added, #1: 1	وُقُوعِ بَعْضِ
u'وُقُوعٌ بَعْضٌ':Added, #1: 1	وُقُوعِ بَعْضِهِ
u'وُقُوعٌ بَلاءٌ':Added, #2: 2	وُقُوعُ بَعْضِ
u'وُقُوعٌ بَيْتٌ':Added, #1: 1	وُقُوعِ الْبَلَاءِ
u'وُقُوعٌ بَيْعٌ':Added, #1: 1	وُقُوعِ الْبَيْتِ
u'وُقُوعٌ بِيَعٌ':Added, #1: 1	وُقُوعُ الْبَيْعِ
u'وُقُوعٌ بَيْعٌ':Added, #1: 1	وُقُوعِ الْبِيَعِ
u'وُقُوعٌ تَبَرُّعٌ':Added, #5: 5	وُقُوعِ الْبَيْعِ
u'وُقُوعٌ تِبْن':Added, #1: 1	وُقُوعَ التَّبَرُّعَاتِ
u'وُقُوعٌ تِجَارَةٌ':Added, #1: 1	وُقُوعُ التِّبْنِ
u'وُقُوعٌ تَجْرِيح':Added, #1: 1	وُقُوعِ التِّجَارَاتِ
u'وُقُوعٌ تَحْرِيمٌ':Added, #1: 1	وُقُوعُ تَجْرِيحٍ
u'وُقُوعٌ تَخْصِيصٌ':Added, #1: 1	وُقُوعِ التَّحْرِيمِ
u'وُقُوعٌ تَسَلْسُلٌ':Added, #1: 1	وُقُوعَ التَّخْصِيصِ
u'وُقُوعٌ تَشَبُّه':Added, #1: 1	وُقُوعُ التَّسَلْسُلِ
u'وُقُوعٌ تَصَرُّفٌ':Added, #1: 1	وُقُوعُ التَّشَبُّهِ
u'وُقُوعٌ تَصَرُّفٌ':Added, #1: 1	وُقُوعُ التَّصَرُّفِ
u'وُقُوعٌ تَصْرِيحٌ':Added, #1: 1	وُقُوعَ تَصَرُّفِهِ
u'وُقُوعٌ تَطْلِيقٌ':Added, #1: 1	وُقُوعِ التَّصْرِيحِ
u'وُقُوعٌ تَطْهِيرٌ':Added, #2: 2	وُقُوعِ التَّطْلِيقَاتِ
u'وُقُوعٌ تَعَارُضٌ':Added, #1: 1	وُقُوعَ التَّطْهِيرِ
u'وُقُوعٌ تَعَارُضٌ':Added, #1: 1	وُقُوعِ التَّعَارُضِ
u'وُقُوعٌ تَعْجِيل':Added, #3: 3	وُقُوعُ التَّعَارُضِ
u'وُقُوعٌ تَعَدُّدٌ':Added, #1: 1	وُقُوعُ التَّعْجِيلِ
u'وُقُوعٌ تَعَدُّدٌ':Added, #1: 1	وُقُوعَ تَعَدُّدِ
u'وُقُوعٌ تَعْلِيقٌ':Added, #1: 1	وُقُوعُ تَعَدُّدِ
u'وُقُوعٌ تَغْلِيظٌ':Added, #1: 1	وُقُوعِ التَّعْلِيقِ
u'وُقُوعٌ تَغَيُّرٌ':Added, #1: 1	وُقُوعُ التَّغْلِيظِ
u'وُقُوعٌ تَفْوِيضٌ':Added, #2: 2	وُقُوعِ التَّغَيُّرِ
u'وُقُوعٌ تَقْصيرٌ':Added, #1: 1	وُقُوعَ التَّفْوِيضِ
u'وُقُوعٌ تَكَلُّفٌ':Added, #1: 1	وُقُوعُ التَّقْصِيرِ
u'وُقُوعٌ تَكْليفٌ':Added, #1: 1	وُقُوعُ التَّكَلُّفِ
u'وُقُوعٌ تَكْليفٌ':Added, #1: 1	وُقُوعُ تَكْلِيفِ
u'وُقُوعٌ تَكْليفٌ':Added, #2: 2	وُقُوعِ التَّكْلِيفِ
u'وُقُوعٌ تَمْلِيك':Added, #2: 2	وُقُوعِ تَكْلِيفِ
u'وُقُوعٌ تَنَازُعٌ':Added, #1: 1	وُقُوعُ التَّمْلِيكِ
u'وُقُوعٌ تَنَازُعٌ':Added, #1: 1	وُقُوعُ التَّنَازُعِ
u'وُقُوعٌ تَنَاقُضٌ':Added, #1: 1	وُقُوعِ التَّنَازُعِ
u'وُقُوعٌ تَنْجِيسٌ':Added, #1: 1	وُقُوعِ تَنَاقُضٍ
u'وُقُوعٌ تَوَاتُرٌ':Added, #1: 1	وُقُوعِ التَّنْجِيسِ
u'وُقُوعٌ تَوْبَةٌ':Added, #1: 1	وُقُوعِ التَّوَاتُرِ
u'وُقُوعٌ تَيَمُّمٌ':Added, #1: 1	وُقُوعُ التَّوْبَةِ
u'وُقُوعٌ ثَالِثٌ':Added, #2: 2	وُقُوعِ التَّيَمُّمِ
u'وُقُوعٌ ثَالِثٌ':Added, #2: 2	وُقُوعُ الثَّالِثَةِ
u'وُقُوعٌ ثَانِي':Added, #3: 3	وُقُوعِ الثَّالِثِ
u'وُقُوعٌ ثَانِي':Added, #1: 1	وُقُوعَ الثَّانِيَةِ
u'وُقُوعٌ ثَانِي':Added, #1: 1	وُقُوعُ الثَّانِيَةِ
u'وُقُوعٌ ثَانِيَةٌ':Added, #2: 2	وُقُوعِ الثَّانِيَةِ
u'وُقُوعٌ ثَانِيَةٌ':Added, #1: 1	وُقُوعَ الثَّانِيَةِ
u'وُقُوعٌ ثَانِيَةٌ':Added, #1: 1	وُقُوعُ الثَّانِيَةِ
u'وُقُوعٌ ثَلاثُ':Added, #2: 2	وُقُوعِ الثَّانِيَةِ
u'وُقُوعٌ ثَلاثُ':Added, #17: 17	وُقُوعُ الثَّلَاثِ
u'وُقُوعٌ ثَلاثُ':Added, #19: 19	وُقُوعَ الثَّلَاثِ
u'وُقُوعٌ ثَلاثُ':Added, #1: 1	وُقُوعُ ثَلَاثِ
u'وُقُوعٌ ثَلاثُ':Added, #1: 1	وُقُوعِ ثَلَاثِ
u'وُقُوعٌ ثَلاثَةٌ':Added, #33: 33	وُقُوعِ الثَّلَاثِ
u'وُقُوعٌ ثَلاثَةٌ':Added, #1: 1	وُقُوعَ الثَّلَاثَةِ
u'وُقُوعٌ ثَلْجٌ':Added, #1: 1	وُقُوعِ ثَلَاثَةٍ
u'وُقُوعٌ ثَمَرَةٌ':Added, #3: 3	وُقُوعِ الثَّلْجِ
u'وُقُوعٌ ثَناءٌ':Added, #2: 2	وُقُوعُ الثَّمَرَةِ
u'وُقُوعٌ جَزَاءٌ':Added, #1: 1	وُقُوعُ الثَّنَاءِ
u'وُقُوعٌ جمعة':Added, #1: 1	وُقُوعَ الْجَزَاءِ
u'وُقُوعٌ جُمُعَةٌ':Added, #1: 1	وُقُوعِ الْجُمُعَةِ
u'وُقُوعٌ جمعة':Added, #1: 1	وُقُوعِ الْجُمُعَةِ
u'وُقُوعٌ جُمُعَةٌ':Added, #2: 2	وُقُوعِ جُمُعَةٍ
u'وُقُوعٌ جَمَلٌ':Added, #2: 2	وُقُوعِ جُمُعَةٍ
u'وُقُوعٌ جُمْلَةٌ':Added, #1: 1	وُقُوعُ الْجَمَلِ
u'وُقُوعٌ جَمِيع':Added, #1: 1	وُقُوعَ الْجُمْلَةِ
u'وُقُوعٌ جهاد':Added, #1: 1	وُقُوعُ الْجَمِيعِ
u'وُقُوعٌ جِهَادٌ':Added, #1: 1	وُقُوعَ الْجِهَادِ
u'وُقُوعٌ جَوَابٌ':Added, #1: 1	وُقُوعَ الْجِهَادِ
u'وُقُوعٌ جَوَازٌ':Added, #1: 1	وُقُوعِ الْجَوَابِ
u'وُقُوعٌ حاجَةٌ':Added, #1: 1	وُقُوعُ الْجَوَازِ
u'وُقُوعٌ حادِثٌ':Added, #1: 1	وُقُوعِ الْحَاجَةِ
u'وُقُوعٌ حائِطٌ':Added, #2: 2	وُقُوعَ حَادِثَةٍ
u'وُقُوعٌ حائِطٌ':Added, #1: 1	وُقُوعَ الْحَائِطِ
u'وُقُوعٌ حَجٌّ':Added, #1: 1	وُقُوعِ الْحَائِطِ
u'وُقُوعٌ حَجٌّ':Added, #1: 1	وُقُوعَ الْحَجِّ
u'وُقُوعٌ حَجٌّ':Added, #1: 1	وُقُوعُ حَجِّ
u'وُقُوعٌ حَجّ':Added, #2: 2	وُقُوعِ الْحَجِّ
u'وُقُوعٌ حَجٌّ':Added, #2: 2	وُقُوع حَجَّتَيْنِ
u'وُقُوعٌ حجاب':Added, #3: 3	وُقُوعُ الْحَجِّ
u'وُقُوعٌ حِجابٌ':Added, #1: 1	وُقُوعُ الْحِجَابِ
u'وُقُوعٌ حِجاجٌ':Added, #1: 1	وُقُوعُ الْحِجَابِ
u'وُقُوعٌ حِجارَةٌ':Added, #1: 1	وُقُوعُ الْحِجَاجِ
u'وُقُوعٌ حُدودٌ':Added, #1: 1	وُقُوعَ الْحِجَارَةِ
u'وُقُوعٌ حَرْبٌ':Added, #2: 2	وُقُوعِ الْحُدُودِ
u'وُقُوعٌ حُرِّيَّةٌ':Added, #1: 1	وُقُوعَ الْحَرْبِ
u'وُقُوعٌ حُرِّيَّةٌ':Added, #1: 1	وُقُوعَ الْحُرِّيَّةِ
u'وُقُوعٌ حَصَادٌ':Added, #1: 1	وُقُوعُ الْحُرِّيَّةِ
u'وُقُوعٌ حَصىً':Added, #1: 1	وُقُوعُ الْحَصَادِ
u'وُقُوعٌ حَصَياتٌ':Added, #1: 1	وُقُوعِ الْحَصَيَاتِ
u'وُقُوعٌ حَصَيَاتٌ':Added, #1: 1	وُقُوعِ الْحَصَيَاتِ
u'وُقُوعٌ حَقِيقٌ':Added, #1: 1	وُقُوعِ الْحَصَيَاتِ
u'وُقُوعٌ حَقِيقَةٌ':Added, #1: 1	وُقُوعُ حَقِيقَةِ
u'وُقُوعٌ حُكْمٌ':Added, #1: 1	وُقُوعُ حَقِيقَةِ
u'وُقُوعٌ حِنْثٌ':Added, #1: 1	وُقُوعُ حُكْمِهِ
u'وُقُوعٌ حوادِثُ':Added, #1: 1	وُقُوعَ الْحِنْثِ
u'وُقُوعٌ حَوَالَةٌ':Added, #1: 1	وُقُوعُ الْحَوَادِثِ
u'وُقُوعٌ حَيْضٌ':Added, #1: 1	وُقُوعِ الْحَوَالَةِ
u'وُقُوعٌ حَيَوَانٌ':Added, #1: 1	وُقُوعِ الْحَيْضِ
u'وُقُوعٌ خَبَرٌ':Added, #1: 1	وُقُوعِ الْحَيَوَانِ
u'وُقُوعٌ خَبَر':Added, #2: 2	وُقُوعُ خَبَرِ
u'وُقُوعٌ خُرُوجٌ':Added, #2: 2	وُقُوعُ خَبَرِ
u'وُقُوعٌ خُسُوفٌ':Added, #1: 1	وُقُوعِ خُرُوجِهِ
u'وُقُوعٌ خِطَابٌ':Added, #1: 1	وُقُوعِ الْخُسُوفِ
u'وُقُوعٌ خِلاَفٌ':Added, #1: 1	وُقُوعُ الْخِطَابِ
u'وُقُوعٌ خِلاَفٌ':Added, #1: 1	وُقُوعَ الْخِلَافِ
u'وُقُوعٌ خِلاَفٌ':Added, #1: 1	وُقُوعِ خِلَافٍ
u'وُقُوعٌ خِلاَفٌ':Added, #2: 2	وُقُوعُ الْخِلَافِ
u'وُقُوعٌ خِلاَفٌ':Added, #2: 2	وُقُوعِ الْخِلَافِ
u'وُقُوعٌ خِلاَفٌ':Added, #2: 2	وُقُوعُ خِلَافِ
u'وُقُوعٌ خُلْعٌ':Added, #2: 2	وُقُوعِ خِلَافِ
u'وُقُوعٌ خُلْعٌ':Added, #1: 1	وُقُوعُ الْخُلْعِ
u'وُقُوعٌ خَلْفٌ':Added, #2: 2	وُقُوعِ الْخُلْعِ
u'وُقُوعٌ خلق':Added, #1: 1	وُقُوعَ خَلْفٍ
u'وُقُوعٌ خَلْقٌ':Added, #1: 1	وُقُوعِ الْخَلْقِ
u'وُقُوعٌ خَوْفٌ':Added, #1: 1	وُقُوعِ الْخَلْقِ
u'وُقُوعٌ خَوْفٌ':Added, #1: 1	وُقُوعُ الْخَوْفِ
u'وُقُوعٌ دَافِعٌ':Added, #2: 2	وُقُوعِ الْخَوْفِ
u'وُقُوعٌ دَائِرَةٌ':Added, #1: 1	وُقُوعِ الدَّافِعِ
u'وُقُوعٌ دِبَاغٌ':Added, #1: 1	وُقُوعَ دَائِرَةٍ
u'وُقُوعٌ دُرٌّ':Added, #1: 1	وُقُوعِ الدِّبَاغِ
u'وُقُوعٌ دُرٌّ':Added, #1: 1	وُقُوعِ الدُّرَّةِ
u'وُقُوعٌ دُرَّةٌ':Added, #2: 2	وُقُوعُ الدُّرَّةِ
u'وُقُوعٌ دُرَّةٌ':Added, #1: 1	وُقُوعِ الدُّرَّةِ
u'وُقُوعٌ دُعَاءٌ':Added, #2: 2	وُقُوعُ الدُّرَّةِ
u'وُقُوعٌ رَجْعِيٌّ':Added, #1: 1	وُقُوعُ الدُّعَاءِ
u'وُقُوعٌ رَجْعِيٌّ':Added, #1: 1	وُقُوعَ الرَّجْعِيَّةِ
u'وُقُوعٌ رَجْعِيٌّ':Added, #2: 2	وُقُوعُ الرَّجْعِيِّ
u'وُقُوعٌ رَجْعِيٌّ':Added, #3: 3	وُقُوعَ الرَّجْعِيِّ
u'وُقُوعٌ رَجْعِيَّةٌ':Added, #3: 3	وُقُوعِ الرَّجْعِيِّ
u'وُقُوعٌ رحمة':Added, #1: 1	وُقُوعَ الرَّجْعِيَّةِ
u'وُقُوعٌ رَحْمَةٌ':Added, #1: 1	وُقُوعِ الرَّحْمَةِ
u'وُقُوعٌ رحمة':Added, #1: 1	وُقُوعِ الرَّحْمَةِ
u'وُقُوعٌ رَحْمَةٌ':Added, #1: 1	وُقُوعِ رَحْمَتِهِ
u'وُقُوعٌ رحمة':Added, #1: 1	وُقُوعِ رَحْمَتِهِ
u'وُقُوعٌ رَحْمَةٌ':Added, #2: 2	وُقُوعُ الرَّحْمَةِ
u'وُقُوعٌ رِدَّةٌ':Added, #2: 2	وُقُوعُ الرَّحْمَةِ
u'وُقُوعٌ رِقٌّ':Added, #1: 1	وُقُوعِ الرِّدَّةِ
u'وُقُوعٌ رُكْنٌ':Added, #1: 1	وُقُوعَ الرِّقِّ
u'وُقُوعٌ رُكْن':Added, #1: 1	وُقُوعُ الرُّكْنِ
u'وُقُوعٌ زائِدٌ':Added, #1: 1	وُقُوعُ الرُّكْنِ
u'وُقُوعٌ زَرْعٌ':Added, #1: 1	وُقُوعِ الزَّائِدِ
u'وُقُوعٌ زِيادَةٌ':Added, #1: 1	وُقُوعِ الزَّرْعَيْنِ
u'وُقُوعٌ سَبَبٌ':Added, #1: 1	وُقُوعُ الزِّيَادَةِ
u'وُقُوعٌ سَبَبٌ':Added, #1: 1	وُقُوعَ السَّبَبِ
u'وُقُوعٌ سَفَرْجَلٌ':Added, #1: 1	وُقُوعِ سَبَبِ
u'وُقُوعٌ سَلَمٌ':Added, #1: 1	وُقُوعُ السَّفَرْجَلَةِ
u'وُقُوعٌ سُنَّةٌ':Added, #1: 1	وُقُوعِ السَّلَمِ
u'وُقُوعٌ سَهْمٌ':Added, #2: 2	وُقُوعُ سُنَّةِ
u'وُقُوعٌ سَهْوٌ':Added, #4: 4	وُقُوعِ السَّهْمِ
u'وُقُوعٌ شِرَاءٌ':Added, #1: 1	وُقُوعِ السَّهْوِ
u'وُقُوعٌ شَرْطٌ':Added, #2: 2	وُقُوعِ الشِّرَاءِ
u'وُقُوعٌ شَرْطٌ':Added, #1: 1	وُقُوع الشَّرْطِ
u'وُقُوعٌ شَرْطٌ':Added, #1: 1	وُقُوعَ الشَّرْطِ
u'وُقُوعٌ شَرْطٌ':Added, #1: 1	وُقُوعُ الشَّرْطِ
u'وُقُوعٌ شَرْعِيٌّ':Added, #3: 3	وُقُوعِ الشَّرْطِ
u'وُقُوعٌ شركة':Added, #1: 1	وُقُوعِ الشَّرْعِيَّةِ
u'وُقُوعٌ شَرِكَةٌ':Added, #4: 4	وُقُوعِ الشَّرِكَةِ
u'وُقُوعٌ شُرُوعٌ':Added, #4: 4	وُقُوعِ الشَّرِكَةِ
u'وُقُوعٌ شَكٌّ':Added, #1: 1	وُقُوعِ الشُّرُوعِ
u'وُقُوعٌ شَكٌّ':Added, #1: 1	وُقُوعَ الشَّكِّ
u'وُقُوعٌ شَكٌّ':Added, #1: 1	وُقُوعِ شَكٍّ
u'وُقُوعٌ شَهَادَةٌ':Added, #2: 2	وُقُوعِ الشَّكِّ
u'وُقُوعٌ شَيْءٌ':Added, #1: 1	وُقُوعُ الشَّهَادَةِ
u'وُقُوعٌ شَيْءٌ':Added, #1: 1	وُقُوع شَيْءٍ
u'وُقُوعٌ شَيْءٌ':Added, #1: 1	وُقُوعَ شَيْءٍ
u'وُقُوعٌ شَيْءٌ':Added, #3: 3	وُقُوعُ شَيْءٍ
u'وُقُوعٌ شِيَاهٌ':Added, #5: 5	وُقُوعِ شَيْءٍ
u'وُقُوعٌ صَبِيٌّ':Added, #1: 1	وُقُوعِ الشِّيَاهِ
u'وُقُوعٌ صِحَّةٌ':Added, #1: 1	وُقُوعِ صَبِيٍّ
u'وُقُوعٌ صَخْرَةٌ':Added, #1: 1	وُقُوعِ صِحَّةِ
u'وُقُوعٌ صغائر':Added, #1: 1	وُقُوعُ صَخْرَةٍ
u'وُقُوعٌ صَغَائِرُ':Added, #1: 1	وُقُوعِ الصَّغَائِرِ
u'وُقُوعٌ صَغِيرٌ':Added, #1: 1	وُقُوعِ الصَّغَائِرِ
u'وُقُوعٌ صَلاَةٌ':Added, #1: 1	وُقُوعَ الصَّغِيرَةِ
u'وُقُوعٌ صَلاَةٌ':Added, #1: 1	وُقُوعُ الصَّلَاةِ
u'وُقُوعٌ صَلاَةٌ':Added, #1: 1	وُقُوعِ صَلَاةِ
u'وُقُوعٌ صلح':Added, #2: 2	وُقُوعِ الصَّلَاةِ
u'وُقُوعٌ صُلْحٌ':Added, #1: 1	وُقُوعِ الصُّلْحِ
u'وُقُوعٌ صَوْمٌ':Added, #1: 1	وُقُوعِ الصُّلْحِ
u'وُقُوعٌ ضَرَرٌ':Added, #1: 1	وُقُوعَ الصَّوْمِ
u'وُقُوعٌ ضَغَائِنُ':Added, #1: 1	وُقُوعِ الضَّرَرِ
u'وُقُوعٌ طَاعُونٌ':Added, #1: 1	وُقُوعِ الضَّغَائِنِ
u'وُقُوعٌ طَاعُونٌ':Added, #1: 1	وُقُوعِ الطَّاعُونِ
u'وُقُوعٌ طَعْنٌ':Added, #1: 1	وُقُوعَ طَاعُونٍ
u'وُقُوعٌ طَلاَقٌ':Added, #1: 1	وُقُوعِ الطَّعْنِ
u'وُقُوعٌ طَلاَقٌ':Added, #10: 10	وُقُوعِ طَلَاقِهِ
u'وُقُوعٌ طَلاَقٌ':Added, #193: 193	وُقُوعِ الطَّلَاقِ
u'وُقُوعٌ طَلاَقٌ':Added, #1: 1	وُقُوعَ طَلَاقِ
u'وُقُوعٌ طَلاَقٌ':Added, #2: 2	وُقُوع الطَّلَاقِ
u'وُقُوعٌ طَلاَقٌ':Added, #2: 2	وُقُوعُ طَلَاقٍ
u'وُقُوعٌ طَلاَقٌ':Added, #3: 3	وُقُوعُ طَلَاقِهِ
u'وُقُوعٌ طَلاَقٌ':Added, #7: 7	وُقُوعِ طَلَاقٍ
u'وُقُوعٌ طَلاَقٌ':Added, #7: 7	وُقُوعِ طَلَاقِ
u'وُقُوعٌ طَلاَقٌ':Added, #83: 83	وُقُوعُ الطَّلَاقِ
u'وُقُوعٌ طلب':Added, #96: 96	وُقُوعَ الطَّلَاقِ
u'وُقُوعٌ طَلَبٌ':Added, #1: 1	وُقُوعُ الطَّلَبِ
u'وُقُوعٌ عِبَادَةٌ':Added, #1: 1	وُقُوعُ الطَّلَبِ
u'وُقُوعٌ عتق':Added, #2: 2	وُقُوعِ الْعِبَادَةِ
u'وُقُوعٌ عِتْقٌ':Added, #11: 11	وُقُوعِ الْعِتْقِ
u'وُقُوعٌ عتق':Added, #11: 11	وُقُوعِ الْعِتْقِ
u'وُقُوعٌ عتق':Added, #1: 1	وُقُوع الْعِتْقِ
u'وُقُوعٌ عِتْقٌ':Added, #1: 1	وُقُوعَ الْعِتْقِ
u'وُقُوعٌ عِتْقٌ':Added, #1: 1	وُقُوع الْعِتْقِ
u'وُقُوعٌ عتق':Added, #1: 1	وُقُوعَ الْعِتْقِ
u'وُقُوعٌ عِتْقٌ':Added, #1: 1	وُقُوعِ عِتْقِ
u'وُقُوعٌ عتق':Added, #1: 1	وُقُوعِ عِتْقِ
u'وُقُوعٌ عِتْقٌ':Added, #5: 5	وُقُوعُ الْعِتْقِ
u'وُقُوعٌ عَدَدٌ':Added, #5: 5	وُقُوعُ الْعِتْقِ
u'وُقُوعٌ عَدَمٌ':Added, #1: 1	وُقُوعِ الْعَدَدِ
u'وُقُوعٌ عَذَابٌ':Added, #1: 1	وُقُوعُ عَدَمِ
u'وُقُوعٌ عَذَابٌ':Added, #1: 1	وُقُوعِ الْعَذَابِ
u'وُقُوعٌ عَصْرٌ':Added, #1: 1	وُقُوعِ عَذَابِ
u'وُقُوعٌ عَفْوٌ':Added, #1: 1	وُقُوعَ الْعَصْرِ
u'وُقُوعٌ عَقْدٌ':Added, #2: 2	وُقُوعِ الْعَفْوِ
u'وُقُوعٌ عَقْدٌ':Added, #11: 11	وُقُوعِ الْعَقْدِ
u'وُقُوعٌ عَقْدٌ':Added, #1: 1	وُقُوعِ الْعَقْدَيْنِ
u'وُقُوعٌ عَقْدٌ':Added, #1: 1	وُقُوعَ عَقْدِ
u'وُقُوعٌ عَقْدٌ':Added, #1: 1	وُقُوعِ عَقْدَيْنِ
u'وُقُوعٌ عَقْدٌ':Added, #5: 5	وُقُوعَ الْعَقْدِ
u'وُقُوعٌ عُقُودٌ':Added, #7: 7	وُقُوعُ الْعَقْدِ
u'وُقُوعٌ عِلَّةٌ':Added, #3: 3	وُقُوعُ الْعُقُودِ
u'وُقُوعٌ علم':Added, #1: 1	وُقُوعِ الْعِلَّةِ
u'وُقُوعٌ عِلْمٌ':Added, #1: 1	وُقُوعُ الْعِلْمِ
u'وُقُوعٌ علم':Added, #1: 1	وُقُوعُ الْعِلْمِ
u'وُقُوعٌ عِلْمٌ':Added, #2: 2	وُقُوعَ الْعِلْمِ
u'وُقُوعٌ علم':Added, #2: 2	وُقُوعَ الْعِلْمِ
u'وُقُوعٌ عِلْمٌ':Added, #5: 5	وُقُوعِ الْعِلْمِ
u'وُقُوعٌ عَمَلٌ':Added, #5: 5	وُقُوعِ الْعِلْمِ
u'وُقُوعٌ عَمَلٌ':Added, #1: 1	وُقُوعُ عَمَلِهِ
u'وُقُوعٌ عَمَلٌ':Added, #2: 2	وُقُوعِ الْعَمَلِ
u'وُقُوعٌ عِوَضٌ':Added, #6: 6	وُقُوعُ الْعَمَلِ
u'وُقُوعٌ عِيدٌ':Added, #1: 1	وُقُوعُ الْعِوَضِ
u'وُقُوعٌ غدرة':Added, #1: 1	وُقُوعَ الْعِيدِ
u'وُقُوعٌ غُسْلٌ':Added, #1: 1	وُقُوعَ غَدْرَةٍ
u'وُقُوعٌ غَلَطٌ':Added, #2: 2	وُقُوعِ الْغُسْلِ
u'وُقُوعٌ غَلَطٌ':Added, #1: 1	وُقُوعُ الْغَلَطِ
u'وُقُوعٌ فَاحِشٌ':Added, #1: 1	وُقُوعِ الْغَلَطِ
u'وُقُوعٌ فَأْرٌ':Added, #1: 1	وُقُوعِ فَاحِشَةٍ
u'وُقُوعٌ فَأْرٌ':Added, #1: 1	وُقُوعُ الْفَأْرَةِ
u'وُقُوعٌ فِتَنٌ':Added, #2: 2	وُقُوعِ الْفَأْرَةِ
u'وُقُوعٌ فتنة':Added, #1: 1	وُقُوعِ الْفِتَنِ
u'وُقُوعٌ فِتْنَةٌ':Added, #2: 2	وُقُوعِ الْفِتْنَةِ
u'وُقُوعٌ فِرَاقٌ':Added, #2: 2	وُقُوعِ الْفِتْنَةِ
u'وُقُوعٌ فرق':Added, #1: 1	وُقُوعُ الْفِرَاقِ
u'وُقُوعٌ فَرْقٌ':Added, #1: 1	وُقُوعِ الْفَرْقِ
u'وُقُوعٌ فُرْقَةٌ':Added, #1: 1	وُقُوعِ الْفَرْقِ
u'وُقُوعٌ فُرْقَةٌ':Added, #16: 16	وُقُوعِ الْفُرْقَةِ
u'وُقُوعٌ فُرْقَةٌ':Added, #1: 1	وُقُوعِ فُرْقَةٍ
u'وُقُوعٌ فُرْقَةٌ':Added, #5: 5	وُقُوعَ الْفُرْقَةِ
u'وُقُوعٌ فَسْخٌ':Added, #6: 6	وُقُوعُ الْفُرْقَةِ
u'وُقُوعٌ فَسْخٌ':Added, #1: 1	وُقُوعَ الْفَسْخِ
u'وُقُوعٌ فَصْلٌ':Added, #1: 1	وُقُوعُ الْفَسْخِ
u'وُقُوعٌ فِطْرٌ':Added, #1: 1	وُقُوعِ الْفَصْلِ
u'وُقُوعٌ فِطْرٌ':Added, #1: 1	وُقُوعُ الْفِطْرِ
u'وُقُوعٌ فِعْلٌ':Added, #3: 3	وُقُوعِ الْفِطْرِ
u'وُقُوعٌ فِعْلٌ':Added, #1: 1	وُقُوعَ الْفِعْلِ
u'وُقُوعٌ فِعْلٌ':Added, #1: 1	وُقُوعِ فِعْلٍ
u'وُقُوعٌ فِعْلٌ':Added, #1: 1	وُقُوعُ فِعْلِهِ
u'وُقُوعٌ فِعْلٌ':Added, #5: 5	وُقُوعُ الْفِعْلِ
u'وُقُوعٌ فقر':Added, #8: 8	وُقُوعِ الْفِعْلِ
u'وُقُوعٌ فَقْرٌ':Added, #1: 1	وُقُوعَ الْفَقْرِ
u'وُقُوعٌ فلان':Added, #1: 1	وُقُوعَ الْفَقْرِ
u'وُقُوعٌ قِرَاءةٌ':Added, #1: 1	وُقُوعُ الصَّلَاتَيْنِ
u'وُقُوعٌ قُرْعَةٌ':Added, #1: 1	وُقُوعُ الْقِرَاءَةِ
u'وُقُوعٌ قسمة':Added, #1: 1	وُقُوعِ الْقُرْعَةِ
u'وُقُوعٌ قِسْمَةٌ':Added, #1: 1	وُقُوعِ قِسْمَةِ
u'وُقُوعٌ قَضَاءٌ':Added, #1: 1	وُقُوعِ قِسْمَةِ
u'وُقُوعٌ قَضَاءٌ':Added, #1: 1	وُقُوعُ قَضَاءِ
u'وُقُوعٌ قَطْعٌ':Added, #2: 2	وُقُوعِ الْقَضَاءِ
u'وُقُوعٌ قَهْقَه':Added, #1: 1	وُقُوعَ الْقَطْعِ
u'وُقُوعٌ قَهْقَهَة':Added, #1: 1	وُقُوعِ الْقَهْقَهَةِ
u'وُقُوعٌ قيام':Added, #1: 1	وُقُوعِ الْقَهْقَهَةِ
u'وُقُوعٌ قِيَامٌ':Added, #1: 1	وُقُوعَ الْقِيَامِ
u'وُقُوعٌ كذب':Added, #1: 1	وُقُوعَ الْقِيَامِ
u'وُقُوعٌ كذب':Added, #1: 1	وُقُوعَ الْكَذِبِ
u'وُقُوعٌ كَذِبٌ':Added, #1: 1	وُقُوعُ الْكَذِبِ
u'وُقُوعٌ كَذِبٌ':Added, #1: 1	وُقُوعَ الْكَذِبِ
u'وُقُوعٌ كِفَايَةٌ':Added, #1: 1	وُقُوعُ الْكَذِبِ
u'وُقُوعٌ كَلاَمٌ':Added, #1: 1	وُقُوعَ الْكِفَايَةِ
u'وُقُوعٌ لاَزِمٌ':Added, #1: 1	وُقُوعَ كَلَامِ
u'وُقُوعٌ لَبِنَةٌ':Added, #1: 1	وُقُوعُ اللَّازِمِ
u'وُقُوعٌ لَعْن':Added, #1: 1	وُقُوعِ اللَّبِنَاتِ
u'وُقُوعٌ لَفْظَةٌ':Added, #1: 1	وُقُوعِ اللَّعْنِ
u'وُقُوعٌ لَهْوٌ':Added, #1: 1	وُقُوعِ اللَّفْظَةِ
u'وُقُوعٌ مَاءٌ':Added, #1: 1	وُقُوعَ اللَّهْوِ
u'وُقُوعٌ مَاءٌ':Added, #1: 1	وُقُوعَ الْمَاءِ
u'وُقُوعٌ مَاءٌ':Added, #1: 1	وُقُوعِ الْمَاءِ
u'وُقُوعٌ مَالٌ':Added, #1: 1	وُقُوعِ مَاءٍ
u'وُقُوعٌ مثل':Added, #1: 1	وُقُوعُ الْمَالِ
u'وُقُوعٌ مِثْلٌ':Added, #1: 1	وُقُوعُ مِثْلِ
u'وُقُوعٌ مثل':Added, #1: 1	وُقُوعُ مِثْلِ
u'وُقُوعٌ مِثْلٌ':Added, #1: 1	وُقُوعِ مِثْلِهِ
u'وُقُوعٌ مثل':Added, #1: 1	وُقُوعِ مِثْلِهِ
u'وُقُوعٌ مِثْلٌ':Added, #2: 2	وُقُوعَ مِثْلِهِ
u'وُقُوعٌ مثل':Added, #2: 2	وُقُوعَ مِثْلِهِ
u'وُقُوعٌ مِثْلٌ':Added, #4: 4	وُقُوعُ مِثْلِهِ
u'وُقُوعٌ مَجَازٌ':Added, #4: 4	وُقُوعُ مِثْلِهِ
u'وُقُوعٌ مُحَرَّمٌ':Added, #2: 2	وُقُوعِ الْمَجَازِ
u'وُقُوعٌ مَحْظُورٌ':Added, #1: 1	وُقُوعُ الْمُحَرَّمِ
u'وُقُوعٌ مُخَالَفَةٌ':Added, #1: 1	وُقُوعَ الْمَحْظُورِ
u'وُقُوعٌ مُرَاجَعَةٌ':Added, #1: 1	وُقُوعِ الْمُخَالَفَةِ
u'وُقُوعٌ مراد':Added, #1: 1	وُقُوعَ الْمُرَاجَعَةِ
u'وُقُوعٌ مُرَادٌ':Added, #1: 1	وُقُوعِ الْمُرَادِ
u'وُقُوعٌ مَسْأَلَةٌ':Added, #1: 1	وُقُوعِ الْمُرَادِ
u'وُقُوعٌ مُسامَحَة':Added, #1: 1	وُقُوعِ الْمَسْأَلَةِ
u'وُقُوعٌ مُسْتَقْبَلٌ':Added, #1: 1	وُقُوعِ الْمُسَامَحَةِ
u'وُقُوعٌ مَسْحٌ':Added, #1: 1	وُقُوعَ الْمُسْتَقْبَلِ
u'وُقُوعٌ مُسْلِمٌ':Added, #1: 1	وُقُوعُ الْمَسْحِ
u'وُقُوعٌ مُشَاحَّةٌ':Added, #1: 1	وُقُوعِ الْمُسْلِمِ
u'وُقُوعٌ مُشَافَهَةٌ':Added, #1: 1	وُقُوعِ الْمُشَاحَّةِ
u'وُقُوعٌ مُشْتَرَكٌ':Added, #1: 1	وُقُوعِ الْمُشَافَهَةِ
u'وُقُوعٌ مَشْهُودٌ':Added, #1: 1	وُقُوعِ الْمُشْتَرَكِ
u'وُقُوعٌ مَصَادِرُ':Added, #1: 1	وُقُوعِ الْمَشْهُودِ
u'وُقُوعٌ مَضْمُونٌ':Added, #1: 1	وُقُوعَ الْمَصَادِرِ
u'وُقُوعٌ مَضْمُونٌ':Added, #1: 1	وُقُوعِ مَضْمُونِ
u'وُقُوعٌ مَطَرٌ':Added, #1: 1	وُقُوعِ مَضْمُونِهِ
u'وُقُوعٌ مَطَرٌ':Added, #1: 1	وُقُوعُ الْمَطَرِ
u'وُقُوعٌ مُطْلَقٌ':Added, #1: 1	وُقُوعِ الْمَطَرِ
u'وُقُوعٌ مُعَامَلَةٌ':Added, #1: 1	وُقُوعُ مُطْلَقِ
u'وُقُوعٌ مُعَامَلَةٌ':Added, #1: 1	وُقُوعُ الْمُعَامَلَةِ
u'وُقُوعٌ مُعْتَقَدٌ':Added, #3: 3	وُقُوعِ الْمُعَامَلَاتِ
u'وُقُوعٌ مُعَجَّلٌ':Added, #1: 1	وُقُوعَ مُعْتَقَدِهِ
u'وُقُوعٌ مُعَرَّبٌ':Added, #1: 1	وُقُوعِ الْمُعَجَّلِ
u'وُقُوعٌ مَعْصِيَةٌ':Added, #1: 1	وُقُوعِ الْمُعَرَّبِ
u'وُقُوعٌ مَعْصِيَةٌ':Added, #1: 1	وُقُوعِ الْمَعْصِيَةِ
u'وُقُوعٌ مُعَلَّقٌ':Added, #1: 1	وُقُوعَ مَعْصِيَةٍ
u'وُقُوعٌ مُعَلَّقٌ':Added, #1: 1	وُقُوعِ الْمُعَلَّقَةِ
u'وُقُوعٌ مُعَلَّقٌ':Added, #2: 2	وُقُوعَ الْمُعَلَّقِ
u'وُقُوعٌ مُعَلَّقٌ':Added, #2: 2	وُقُوعُ الْمُعَلَّقِ
u'وُقُوعٌ مَفْسَدَةٌ':Added, #5: 5	وُقُوعِ الْمُعَلَّقِ
u'وُقُوعٌ مُقَاصَّةٌ':Added, #1: 1	وُقُوعَ مَفْسَدَةِ
u'وُقُوعٌ مَقْدُورٌ':Added, #1: 1	وُقُوعِ الْمُقَاصَّةِ
u'وُقُوعٌ مَقُولٌ':Added, #2: 2	وُقُوعَ الْمَقْدُورِ
u'وُقُوعٌ مَلْزُوم':Added, #1: 1	وُقُوعِ الْمَقُولِ
u'وُقُوعٌ مِلْكٌ':Added, #1: 1	وُقُوعِ الْمَلْزُومِ
u'وُقُوعٌ مِلْكٌ':Added, #7: 7	وُقُوعُ الْمِلْكِ
u'وُقُوعٌ مِلْكٌ':Added, #7: 7	وُقُوعِ الْمِلْكِ
u'وُقُوعٌ مُنَازَعٌ':Added, #9: 9	وُقُوعَ الْمِلْكِ
u'وُقُوعٌ مُنَازَعَةٌ':Added, #1: 1	وُقُوعِ الْمُنَازَعَةِ
u'وُقُوعٌ مَنْثُورٌ':Added, #1: 1	وُقُوعِ الْمُنَازَعَةِ
u'وُقُوعٌ مُنْجَزٌ':Added, #1: 1	وُقُوعِ الْمَنْثُورِ
u'وُقُوعٌ مُنْكَرٌ':Added, #1: 1	وُقُوعَ الْمُنْجَزِ
u'وُقُوعٌ مُنْكَرٌ':Added, #1: 1	وُقُوعِ الْمُنْكَرِ
u'وُقُوعٌ مَوْتٌ':Added, #2: 2	وُقُوعِ مُنْكَرٍ
u'وُقُوعٌ ميل':Added, #1: 1	وُقُوعُ مَوْتٍ
u'وُقُوعٌ مَيْلٌ':Added, #1: 1	وُقُوعَ مَيْلِ
u'وُقُوعٌ نَازِلٌ':Added, #1: 1	وُقُوعَ مَيْلِ
u'وُقُوعٌ نَازِلَةٌ':Added, #1: 1	وُقُوعِ نَازِلَةٍ
u'وُقُوعٌ نَاسٌ':Added, #1: 1	وُقُوعِ نَازِلَةٍ
u'وُقُوعٌ نَجَاسَةٌ':Added, #1: 1	وُقُوعِ النَّاسِ
u'وُقُوعٌ نَجَاسَةٌ':Added, #1: 1	وُقُوعُ نَجَاسَةٍ
u'وُقُوعٌ نَجَاسَةٌ':Added, #1: 1	وُقُوعِ نَجَاسَةٍ
u'وُقُوعٌ نَجَاسَةٌ':Added, #3: 3	وُقُوعَ نَجَاسَةٍ
u'وُقُوعٌ نَحْوٌ':Added, #6: 6	وُقُوعِ النَّجَاسَةِ
u'وُقُوعٌ نذر':Added, #1: 1	وُقُوعُ نَحْوِ
u'وُقُوعٌ نذر':Added, #1: 1	وُقُوعُ النَّذْرِ
u'وُقُوعٌ نَذْرٌ':Added, #1: 1	وُقُوعِ النَّذْرِ
u'وُقُوعٌ نَذْرٌ':Added, #1: 1	وُقُوعُ النَّذْرِ
u'وُقُوعٌ نِسْبَةٌ':Added, #1: 1	وُقُوعِ النَّذْرِ
u'وُقُوعٌ نِسْبَةٌ':Added, #1: 1	وُقُوعِ نِسْبَةِ
u'وُقُوعٌ نُسُكٌ':Added, #5: 5	وُقُوعِ النِّسْبَةِ
u'وُقُوعٌ نُسُكٌ':Added, #1: 1	وُقُوعِ النُّسُكِ
u'وُقُوعٌ نُسُكٌ':Added, #1: 1	وُقُوعَ النُّسُكَيْنِ
u'وُقُوعٌ نِسْيَانٌ':Added, #2: 2	وُقُوعُ النُّسُكَيْنِ
u'وُقُوعٌ نَصْرَانِيٌّ':Added, #1: 1	وُقُوعُ النِّسْيَانِ
u'وُقُوعٌ نَصْرَانِيَّةٌ':Added, #1: 1	وُقُوعِ النّصْرَانِيّةِ
u'وُقُوعٌ نُطْفَةٌ':Added, #1: 1	وُقُوعِ النّصْرَانِيّةِ
u'وُقُوعٌ نَعِيمٌ':Added, #1: 1	وُقُوعِ النُّطْفَةِ
u'وُقُوعٌ نَفْسٌ':Added, #1: 1	وُقُوعِ نَعِيمِ
u'وُقُوعٌ نَفْلٌ':Added, #2: 2	وُقُوعِ نَفْسِ
u'وُقُوعٌ نَقِيضٌ':Added, #1: 1	وُقُوعُ النَّفْلِ
u'وُقُوعٌ نَقِيضٌ':Added, #1: 1	وُقُوعِ النَّقِيضَيْنِ
u'وُقُوعٌ نكاح':Added, #1: 1	وُقُوعَ نَقِيضِ
u'وُقُوعٌ نكاح':Added, #1: 1	وُقُوعَ النِّكَاحِ
u'وُقُوعٌ نِكَاحٌ':Added, #1: 1	وُقُوعِ النِّكَاحِ
u'وُقُوعٌ نِكَاحٌ':Added, #1: 1	وُقُوعَ النِّكَاحِ
u'وُقُوعٌ نكاح':Added, #1: 1	وُقُوعِ النِّكَاحِ
u'وُقُوعٌ نِكَاحٌ':Added, #1: 1	وُقُوعَ نِكَاحٍ
u'وُقُوعٌ نَوْحٌ':Added, #1: 1	وُقُوعَ نِكَاحٍ
u'وُقُوعٌ نَوْمٌ':Added, #1: 1	وُقُوعِ النَّوْحِ
u'وُقُوعٌ نِيَّةٌ':Added, #3: 3	وُقُوعُ النَّوْمِ
u'وُقُوعٌ هِبَةٌ':Added, #1: 1	وُقُوعِ نِيَّةِ
u'وُقُوعٌ واحد':Added, #1: 1	وُقُوعِ الْهِبَةِ
u'وُقُوعٌ وَاحِدٌ':Added, #1: 1	وُقُوعَ وَاحِدٍ
u'وُقُوعٌ واحد':Added, #1: 1	وُقُوعَ وَاحِدٍ
u'وُقُوعٌ واحد':Added, #1: 1	وُقُوعِ وَاحِدَةٍ
u'وُقُوعٌ وَاحِدٌ':Added, #1: 1	وُقُوعِ وَاحِدَةِ
u'وُقُوعٌ وَاحِدٌ':Added, #1: 1	وُقُوعِ وَاحِدَةٍ
u'وُقُوعٌ واحد':Added, #1: 1	وُقُوعِ وَاحِدَةِ
u'وُقُوعٌ وَاحِدٌ':Added, #2: 2	وُقُوعَ الْوَاحِدَةِ
u'وُقُوعٌ واحد':Added, #2: 2	وُقُوعَ الْوَاحِدَةِ
u'وُقُوعٌ وَاحِدٌ':Added, #3: 3	وُقُوعِ وَاحِدٍ
u'وُقُوعٌ واحد':Added, #3: 3	وُقُوعِ وَاحِدٍ
u'وُقُوعٌ وَاحِدٌ':Added, #3: 3	وُقُوعَ وَاحِدَةٍ
u'وُقُوعٌ واحد':Added, #3: 3	وُقُوعَ وَاحِدَةٍ
u'وُقُوعٌ واحد':Added, #4: 4	وُقُوعُ الْوَاحِدَةِ
u'وُقُوعٌ وَاحِدٌ':Added, #4: 4	وُقُوعِ الْوَاحِدَةِ
u'وُقُوعٌ وَاحِدٌ':Added, #4: 4	وُقُوعُ الْوَاحِدَةِ
u'وُقُوعٌ واحد':Added, #4: 4	وُقُوعِ الْوَاحِدَةِ
u'وُقُوعٌ وَاحِدٌ':Added, #4: 4	وُقُوعُ وَاحِدَةٍ
u'وُقُوعٌ وَاقِعٌ':Added, #4: 4	وُقُوعُ وَاحِدَةٍ
u'وُقُوعٌ وَاقِعَةٌ':Added, #1: 1	وُقُوعُ الْوَاقِعَةِ
u'وُقُوعٌ وَطْءٌ':Added, #1: 1	وُقُوعُ الْوَاقِعَةِ
u'وُقُوعٌ وَطْءٌ':Added, #1: 1	وُقُوعُ الْوَطْءِ
u'وُقُوعٌ وَهْمٌ':Added, #2: 2	وُقُوعِ الْوَطْءِ
u'وُقُوعٌ يَأْسٌ':Added, #1: 1	وُقُوعِ الْوَهْمِ
u'وُقُوعٌ يَأْسٌ':Added, #1: 1	وُقُوعُ الْيَأْسِ
u'وُقُوعٌ يَدٌ':Added, #5: 5	وُقُوعِ الْيَأْسِ
u'وُقُوعٌ يَقِينٌ':Added, #1: 1	وُقُوعِ يَدِهِ
u'وُقُوفٌ أرْضٌ':Added, #1: 1	وُقُوعِ الْيَقِينِ
u'وُقُوفٌ الْمَرْأَةُ':Added, #1: 1	وُقُوفِ الْأَرْضِ
u'وُقُوفٌ الْمَرْأَةُ':Added, #1: 1	وُقُوفِ الْمَرْأَةِ
u'وُقُوفٌ إمَامٌ':Added, #3: 3	وُقُوفَ الْمَرْأَةِ
u'وُقُوفٌ إمَامٌ':Added, #1: 1	وُقُوفِ الْإِمَامِ
u'وُقُوفٌ اِمْرَأَةٌ':Added, #2: 2	وُقُوفُ الْإِمَامِ
u'وُقُوفٌ بَهائِمُ':Added, #1: 1	وُقُوفُ امْرَأَةٍ
u'وُقُوفٌ بَهيمٌ':Added, #1: 1	وُقُوفِ الْبَهَائِمِ
u'وُقُوفٌ بَهِيمَةٌ':Added, #1: 1	وُقُوفُ الْبَهِيمَةِ
u'وُقُوفٌ بَيْعٌ':Added, #1: 1	وُقُوفُ الْبَهِيمَةِ
u'وُقُوفٌ جَمَاعَةٌ':Added, #3: 3	وُقُوفَ الْبَيْعِ
u'وُقُوفٌ رَجُلٌ':Added, #1: 1	وُقُوفُ الْجَمَاعَةِ
u'وُقُوفٌ رَجُلٌ':Added, #1: 1	وُقُوفَ الرَّجُلِ
u'وُقُوفٌ رَجُلٌ':Added, #1: 1	وُقُوفُ الرَّجُلِ
u'وُقُوفٌ رَجُلٌ':Added, #1: 1	وُقُوفَ رَجُلٍ
u'وُقُوفٌ سَكْرَان':Added, #1: 1	وُقُوفِ رَجُلٍ
u'وُقُوفٌ سَكْرَان':Added, #1: 1	وُقُوفِ السَّكْرَانِ
u'وُقُوفٌ شَخْصٌ':Added, #2: 2	وُقُوفُ السَّكْرَانِ
u'وُقُوفٌ شُهُودٌ':Added, #1: 1	وُقُوفُ الشَّخْصِ
u'وُقُوفٌ صَحَابَةٌ':Added, #2: 2	وُقُوفَ الشُّهُودِ
u'وُقُوفٌ عِلَّةٌ':Added, #1: 1	وُقُوفَ الصَّحَابَةِ
u'وُقُوفٌ عَلِيٌّ':Added, #1: 1	وُقُوفُ الْعِلَّةِ
u'وُقُوفٌ عَمَلٌ':Added, #1: 1	وُقُوفَ عَلِيٍّ
u'وُقُوفٌ مرٌّ':Added, #1: 1	وُقُوفِ عَمَلِهِ
u'وُقُوفٌ مُضْطَرٌّ':Added, #1: 1	وُقُوفُ مَرَّتَيْنِ
u'وُقُوفٌ مُنْفَرِدٌ':Added, #1: 1	وُقُوفَ الْمُضْطَرِّ
u'وُقُوفٌ نَاسٌ':Added, #1: 1	وُقُوفِ الْمُنْفَرِدِ
u'وُقُوفٌ واحد':Added, #1: 1	وُقُوفُ النَّاسِ
u'وُقُوفٌ وَاحِدٌ':Added, #1: 1	وُقُوفُ الْوَاحِدِ
u'وُقُوفٌ واحد':Added, #1: 1	وُقُوفُ الْوَاحِدِ
u'وُقُوفٌ وَاحِدٌ':Added, #1: 1	وُقُوفُ وَاحِدَةٍ
u'وَقَى مَالٌ':Predicate, #1: 1	وُقُوفُ وَاحِدَةٍ
u'وَكَّدَ إِجَابَةٌ':Predicate, #1: 1	وَقَى الْمَالَ
u'وَكَّدَ يَمِينٌ':Predicate, #1: 1	وَكَّدَ إجَابَةَ
u'وَكْرٌ طَيْرٌ':Added, #2: 2	وَكَّدَ الْيَمِينَ
u'وَكَفَ مَاءٌ':Subject, #1: 1	وَكْرِ الطَّيْرِ
u'وَكَفَ مَسْجِدٌ':Subject, #1: 1	وَكَفَ الْمَاءُ
u'وَكَّلَ أَبٌ':Subject, #1: 1	وَكَفَ الْمَسْجِدُ
u'وَكَّلَ أَجْنَبِيٌّ':Predicate, #7: 7	وَكَّلَ الْأَبُ
u'وَكَّلَ أَجْنَبِيٌّ':Subject, #1: 1	وَكَّلَ الْأَجْنَبِيَّ
u'وَكَّلَ أَجْنَبِيٌّ':Subject, #1: 1	وَكَّلَ الْأَجْنَبِيُّ
u'وَكَّلَ أحَدٌ':Subject, #2: 2	وَكَّلَ أَجْنَبِيٌّ
u'وَكَّلَ أَصيلٌ':Predicate, #16: 16	وَكَّلَ أَحَدُ
u'وَكَّلَ أَمْرٌ':Predicate, #1: 1	وَكَّلَ الْأَصِيلَ
u'وَكَلَ أُمُورٌ':Predicate, #1: 1	وَكَّلَ الْأَمْرَ
u'وَكَّلَ أَوَّلُ':Predicate, #2: 2	وَكَلَ أُمُورَ
u'وَكَّلَ أَوَّلُ':Subject, #2: 2	وَكَّلَ الْأَوَّلَ
u'وَكَّلَ بَائِعٌ':Predicate, #1: 1	وَكَّلَ الْأَوَّلُ
u'وَكَّلَ بَائِعٌ':Subject, #2: 2	وَكَّلَ الْبَائِعَ
u'وَكَلَ بَطَلٌ':Predicate, #2: 2	وَكَّلَ الْبَائِعُ
u'وَكَّلَ بَعْضٌ':Subject, #1: 1	نَكِلَ بَطَلَ
u'وَكَّلَ تارِك':Predicate, #1: 1	وَكَّلَ بَعْضُ
u'وَكَّلَ تَقْديرٌ':Predicate, #1: 1	وَكَّلَ تَارِكَ
u'وَكَّلَ ثَانِي':Predicate, #1: 1	وَكَّلَ التَّقْدِيرَ
u'وَكَّلَ ثَلاثَةٌ':Predicate, #2: 2	وَكَّلَ الثَّانِيَ
u'وَكَّلَ جَابِي':Predicate, #1: 1	وَكَّلَ ثَلَاثَةَ
u'وَكَّلَ جَمَاعَةٌ':Subject, #1: 1	وَكَّلَ الْجَابِيَ
u'وَكَّلَ حالٌ':Predicate, #1: 1	وَكَّلَ جَمَاعَةٌ
u'وَكَّلَ حُرٌّ':Subject, #1: 1	وَكَّلَ حَالَ
u'وَكَلَ حِفْظٌ':Predicate, #5: 5	وَكَّلَ الْحُرُّ
u'وَكَّلَ حُكْمٌ':Predicate, #1: 1	وَكَلَ حِفْظَ
u'وَكَّلَ حَكِيمٌ':Predicate, #1: 1	وَكَّلَ الْحُكْمَ
u'وَكَّلَ حَلالٌ':Subject, #1: 1	وَكَّلَ حَكِيمَ
u'وَكَّلَ حَلالٌ':Subject, #1: 1	وَكَّلَ الْحَلَالُ
u'وَكَّلَ دَائِنٌ':Predicate, #3: 3	وَكَّلَ حَلَالٌ
u'وَكَّلَ دَائِنٌ':Subject, #1: 1	وَكَّلَ الدَّائِنَ
u'وَكَّلَ ذِمِّيٌّ':Subject, #2: 2	وَكَّلَ الدَّائِنُ
u'وَكَّلَ رَاهِنٌ':Subject, #5: 5	وَكَّلَ الذِّمِّيُّ
u'وَكَّلَ رَبُّ':Subject, #6: 6	وَكَّلَ الرَّاهِنُ
u'وَكَّلَ رَجُلٌ':Predicate, #4: 4	وَكَّلَ رَبُّ
u'وَكَّلَ رَجُلٌ':Subject, #2: 2	وَكَّلَ الرَّجُلَ
u'وَكَّلَ رَجُلٌ':Subject, #20: 20	وَكَّلَ رَجُلٌ
u'وَكَّلَ رَسُولٌ':Predicate, #22: 22	وَكَّلَ الرَّجُلُ
u'وَكَّلَ زَوْجٌ':Subject, #1: 1	وَكَّلَ الرَّسُولَ
u'وَكَّلَ سُعَاةٌ':Predicate, #6: 6	وَكَّلَ الزَّوْجُ
u'وَكَّلَ سَيِّدٌ':Subject, #1: 1	وَكَّلَ السُّعَاةَ
u'وَكَّلَ شَاهِدٌ':Predicate, #1: 1	وَكَّلَ سَيِّدُ
u'وَكَّلَ شَخْصٌ':Subject, #1: 1	وَكَّلَ الشَّاهِدَ
u'وَكَّلَ شَرِيكٌ':Predicate, #1: 1	وَكَّلَ شَخْصٌ
u'وَكَّلَ شَرِيكٌ':Subject, #1: 1	وَكَّلَ شَرِيكَ
u'وَكَّلَ شَفِيعٌ':Subject, #2: 2	وَكَّلَ الشَّرِيكُ
u'وَكَّلَ صَاحِبٌ':Subject, #1: 1	وَكَّلَ الشَّفِيعُ
u'وَكَّلَ صَغِيرٌ':Subject, #2: 2	وَكَّلَ صَاحِبُ
u'وَكَّلَ ضَمِنٌ':Predicate, #1: 1	وَكَّلَ الصَّغِيرُ
u'وَكَّلَ طَالِبٌ':Predicate, #1: 1	وَكَّلَ ضَمِنَ
u'وَكَّلَ طَالِبٌ':Subject, #2: 2	وَكَّلَ الطَّالِبَ
u'وَكَلَ عِبَادٌ':Subject, #3: 3	وَكَّلَ الطَّالِبُ
u'وَكَّلَ عَبْدٌ':Predicate, #1: 1	وَكَلَ عِبَادُهُ
u'وَكَّلَ عَبْدٌ':Predicate, #6: 6	وَكَّلَ الْعَبْدَ
u'وَكَّلَ عَبْدٌ':Subject, #8: 8	وَكَّلَ عَبْدَ
u'وَكَّلَ عَبْدٌ':Subject, #11: 11	وَكَّلَ الْعَبْدُ
u'وَكَّلَ عَدْلٌ':Subject, #2: 2	وَكَّلَ عَبْدٌ
u'وَكَّلَ عُرْوَةٌ':Predicate, #2: 2	وَكَّلَ الْعَدْلُ
u'وَكَّلَ علم':Predicate, #1: 1	وَكَّلَ عُرْوَةَ
u'وَكَّلَ عُمَرٌ':Predicate, #1: 1	وَكَّلَ عَلِمَ
u'وَكَّلَ غَرِيمٌ':Subject, #1: 1	وَكَّلَ عُمَرَ
u'وَكَّلَ غير':Subject, #3: 3	وَكَّلَ الْغَرِيمُ
u'وَكَّلَ غَيْرٌ':Subject, #1: 1	وَكَّلَ غَيْرُهُ
u'وَكَّلَ فَاسِقٌ':Predicate, #1: 1	وَكَّلَ غَيْرُهُ
u'وَكَّلَ فُلاَنٌ':Predicate, #1: 1	وَكَّلَ الْفَاسِقَ
u'وَكَّلَ فُلاَنٌ':Subject, #4: 4	وَكَّلَ فُلَانَ
u'وَكَّلَ قَابِضٌ':Predicate, #15: 15	وَكَّلَ فُلَانٌ
u'وَكَّلَ مَالِكٌ':Subject, #1: 1	وَكَّلَ الْقَابِضَ
u'وَكَّلَ مَالِكٌ':Subject, #1: 1	وَكَّلَ مَالِكُ
u'وَكَّلَ مُجْبِرٌ':Subject, #2: 2	وَكَّلَ الْمَالِكُ
u'وَكَّلَ مُحْرِمٌ':Subject, #2: 2	وَكَّلَ الْمُجْبِرُ
u'وَكَّلَ مُحِيل':Predicate, #5: 5	وَكَّلَ مُحْرِمٌ
u'وَكَّلَ مَدِينٌ':Subject, #3: 3	وَكَّلَ الْمُحِيلَ
u'وَكَّلَ مَدْيُونٌ':Predicate, #1: 1	وَكَّلَ الْمَدِينُ
u'وَكَّلَ مَدْيُونٌ':Subject, #2: 2	وَكَّلَ الْمَدْيُونَ
u'وَكَّلَ مُرْتَدٌّ':Subject, #1: 1	وَكَّلَ الْمَدْيُونُ
u'وَكَّلَ مُسْتَأْجِرٌ':Predicate, #1: 1	وَكَّلَ الْمُرْتَدُّ
u'وَكَّلَ مُسْتَحِقٌّ':Subject, #1: 1	وَكَّلَ الْمُسْتَأْجِرَ
u'وَكَّلَ مُسْتَعِيرٌ':Subject, #1: 1	وَكَّلَ الْمُسْتَحِقُّ
u'وَكَّلَ مُسْلِمٌ':Subject, #1: 1	وَكَّلَ الْمُسْتَعِيرُ
u'وَكَّلَ مُسْلِمٌ':Subject, #4: 4	وَكَّلَ الْمُسْلِمُ
u'وَكَّلَ مُضَارِبٌ':Subject, #5: 5	وَكَّلَ مُسْلِمٌ
u'وَكَّلَ مَطْلُوبٌ':Predicate, #9: 9	وَكَّلَ الْمُضَارِبُ
u'وَكَّلَ مَطْلُوبٌ':Subject, #1: 1	وَكَّلَ الْمَطْلُوبَ
u'وَكَّلَ مَعْذُورٌ':Subject, #4: 4	وَكَّلَ الْمَطْلُوبُ
u'وَكَّلَ مُفَاوِضٌ':Subject, #1: 1	وَكَّلَ الْمَعْذُورُ
u'وَكَّلَ مُوَكِّلٌ':Subject, #1: 1	وَكَّلَ الْمُفَاوِضُ
u'وَكَّلَ مَوْهُوبٌ':Subject, #1: 1	وَكَّلَ الْمُوَكِّلُ
u'وَكَّلَ واحد':Subject, #4: 4	وَكَّلَ الْمَوْهُوبُ
u'وَكَّلَ وَاحِدٌ':Subject, #1: 1	وَكَّلَ وَاحِدٌ
u'وَكَّلَ وَالِدٌ':Subject, #1: 1	وَكَّلَ وَاحِدٌ
u'وَكَّلَ وَاهِبٌ':Subject, #1: 1	وَكَّلَ وَالِدُهُ
u'وَكَّلَ وَصِيٌّ':Subject, #3: 3	وَكَّلَ الْوَاهِبُ
u'وَكَّلَ وَكِيلٌ':Predicate, #2: 2	وَكَّلَ الْوَصِيُّ
u'وَكَّلَ وَكِيلٌ':Predicate, #1: 1	وَكَّلَ الْوَكِيلَ
u'وَكَّلَ وَكِيلٌ':Subject, #1: 1	وَكَّلَ وَكِيلَ
u'وَكَّلَ وَكِيلٌ':Subject, #1: 1	وَكَّلَ وَكِيلُ
u'وَكَّلَ وَكِيلٌ':Subject, #1: 1	وَكَّلَ وَكِيلُهُ
u'وَكَّلَ وَلِيٌّ':Subject, #9: 9	وَكَّلَ الْوَكِيلُ
u'وَكَّلَ يَتِيمٌ':Predicate, #2: 2	وَكَّلَ الْوَلِيُّ
u'وِلاَدَةٌ جَاهِلِيٌّ':Added, #1: 1	وَكَّلَ الْيَتِيمَ
u'وِلاَدَةٌ جَاهِلِيَّةٌ':Added, #1: 1	وِلاَدَةِ الْجَاهِلِيَّةِ
u'وِلاَيَةٌ اِبْنٌ':Added, #1: 1	وِلاَدَةِ الْجَاهِلِيَّةِ
u'وِلاَيَةٌ أَخٌ':Added, #1: 1	وِلاَيَةِ ابْنِ
u'وِلاَيَةٌ نكاح':Added, #1: 1	وِلاَيَةِ الأَخِ
u'وِلاَيَةٌ نِكَاحٌ':Added, #1: 1	وِلاَيَةِ النِّكَاحِ
u'وَلَجَ رَجُلٌ':Subject, #1: 1	وِلاَيَةِ النِّكَاحِ
u'وَلَدَ أمَةٌ':Subject, #2: 2	وَلَجَ الرَّجُلُ
u'وَلَدَ أمَةٌ':Subject, #1: 1	تَلِدَ أَمَتُهُ
u'وَلَدَ أمَةٌ':Subject, #2: 2	تَلِدَ الأَمَةُ
u'وَلَدَ حَيَوَانٌ':Subject, #4: 4	تَلِدَ الْأَمَةُ
u'وَلَدَ شَيَاطِينُ':Subject, #1: 1	وَلَدَ الْحَيَوَانُ
u'وَلَدَ عتق':Predicate, #1: 1	وَلَدَ الشَّيَاطِينُ
u'وَلَدَ عَشْرٌ':Predicate, #1: 1	تَلِدَ عَتَقَ
u'وَلَدَ عند':Predicate, #3: 3	وَلَدَ عَشْرَةً
u'وَلَدَ عند':Predicate, #1: 1	تَلِدَ عِنْدَ
u'وَلَدَ فَاطِمٌ':Predicate, #1: 1	تَلِدَ عِنْدَكَ
u'وَلَّدَ فَالِجٌ':Predicate, #1: 1	وَلَدَ فَاطِمَةَ
u'وَلَدَ قَصَرٌ':Predicate, #1: 1	وَلَّدَ الْفَالِجَ
u'وَلَّدَ لَقْوَةٌ':Predicate, #1: 1	وَلَدَ قَصَرَ
u'وَلَدَ مَالِكٌ':Subject, #1: 1	وَلَّدَ اللَّقْوَةَ
u'وَلَدَ مُدَبَّرٌ':Subject, #1: 1	وَلَدَ مَالِكُ
u'وَلَدَ مراد':Subject, #1: 1	وَلَدَ الْمُدَبَّرُ
u'وَلَدَ مُرَادٌ':Subject, #1: 1	وَلَدَ مُرَادُهُ
u'وَلَدَ ولد':Subject, #1: 1	وَلَدَ مُرَادُهُ
u'وَلَدَ وَلَدٌ':Subject, #1: 1	وَلَدَ الْوَلَدُ
u'وَلَغَ سَبْرٌ':Predicate, #1: 1	وَلَدَ الْوَلَدُ
u'وَلَغَ سِنَّوْرٌ':Subject, #1: 1	لَغَا السَّبْرَ
u'وَلَغَ كَلْبٌ':Subject, #2: 2	وَلَغَ السِّنَّوْرُ
u'وَلَغَ نِيَّةٌ':Predicate, #46: 46	وَلَغَ الْكَلْبُ
u'وَلَغَ هِرٌّ':Subject, #1: 1	لَغَا نِيَّةَ
u'وَلَفَ أحَدٌ':Subject, #1: 1	وَلَغَ الْهِرُّ
u'وَلَفَ أكْبَرُ':Predicate, #3: 3	تَلِفَ أَحَدُ
u'وَلَفَ ألف':Subject, #2: 2	أَلِفَ أَكْبَرَ
u'وَلَفَ ألْفٌ':Subject, #1: 1	تَلِفَ أَلْفُ
u'وَلَفَ أَلْفٌ':Subject, #1: 1	تَلِفَ أَلْفُ
u'وَلَفَ بَعْضٌ':Subject, #1: 1	تَلِفَ أَلْفُ
u'وَلَفَ بَعْضٌ':Subject, #13: 13	تَلِفَ بَعْضُهُ
u'وَلَفَ بَعْضٌ':Subject, #24: 24	تَلِفَ بَعْضُ
u'وَلَفَ بَعيرٌ':Subject, #2: 2	تَلِفَ الْبَعْضُ
u'وَلَفَ بيض':Subject, #2: 2	تَلِفَ بَعِيرٌ
u'وَلَفَ تَرَدُّدٌ':Subject, #1: 1	تَلِفَ بَيْضُ
u'وَلَفَ ثَلاثَةٌ':Subject, #1: 1	تَلِفَ تَرَدُّدٌ
u'وَلَفَ ثَمَنٌ':Predicate, #1: 1	تَلِفَ ثَلَاثَةٌ
u'وَلَفَ ثَمَنٌ':Subject, #1: 1	تَلِفَ الثَّمَنَ
u'وَلَفَ ثَوْبٌ':Subject, #3: 3	تَلِفَ الثَّمَنُ
u'وَلَفَ ثَوْبٌ':Subject, #1: 1	تَلِفَ ثَوْبٌ
u'وَلَفَ جُزْءٌ':Subject, #8: 8	تَلِفَ الثَّوْبُ
u'وَلَفَ جلد':Subject, #1: 1	تَلِفَ جُزْءُ
u'وَلَفَ جِلْدٌ':Subject, #1: 1	تَلِفَ الْجِلْدُ
u'وَلَفَ حالٌ':Predicate, #1: 1	تَلِفَ الْجِلْدُ
u'وَلَفَ دونٌ':Predicate, #3: 3	تَلِفَ حَالَ
u'وَلَفَ دِينارٌ':Subject, #1: 1	تَلِفَ دُونَ
u'وَلَفَ رَدٌّ':Predicate, #1: 1	تَلِفَ الدِّينَارُ
u'وَلَفَ رَغيفٌ':Subject, #2: 2	تَلِفَ رَدَّ
u'وَلَفَ رِقٌّ':Subject, #2: 2	تَلِفَ الرَّغِيفُ
u'وَلَفَ رَقيقٌ':Subject, #1: 1	تَلِفَ الرِّقُّ
u'وَلَفَ رَقيق':Subject, #1: 1	تَلِفَ رَقِيقُهُ
u'وَلَفَ رَهْنٌ':Subject, #1: 1	تَلِفَ رَقِيقُهُ
u'وَلَفَ زادٌ':Subject, #1: 1	تَلِفَ الرَّهْنُ
u'وَلَفَ زَرْعٌ':Subject, #1: 1	تَلِفَ زَادُهُ
u'وَلَفَ سقط':Predicate, #1: 1	تَلِفَ الزَّرْعُ
u'وَلَفَ سَقَطٌ':Predicate, #1: 1	تَلِفَ سَقَطَ
u'وَلَفَ سَقْفٌ':Subject, #1: 1	تَلِفَ سَقَطَ
u'وَلَفَ شَيْءٌ':Subject, #1: 1	تَلِفَ سَقْفُ
u'وَلَفَ صداق':Subject, #5: 5	تَلِفَ شَيْءٌ
u'وَلَفَ صَدَاقٌ':Subject, #1: 1	تَلِفَ الصَّدَاقُ
u'وَلَفَ طعام':Subject, #1: 1	تَلِفَ الصَّدَاقُ
u'وَلَفَ طَعَامٌ':Subject, #2: 2	تَلِفَ الطَّعَامُ
u'وَلَفَ عَبْدٌ':Subject, #2: 2	تَلِفَ الطَّعَامُ
u'وَلَفَ عِشْرُون':Predicate, #5: 5	تَلِفَ الْعَبْدُ
u'وَلَفَ عُضْوٌ':Subject, #2: 2	تَلِفَ عِشْرُونَ
u'وَلَفَ عند':Predicate, #1: 1	تَلِفَ الْعُضْوُ
u'وَلَفَ عِوَضٌ':Subject, #8: 8	تَلِفَ عِنْدَ
u'وَلَفَ غَائِبٌ':Subject, #1: 1	تَلِفَ الْعِوَضُ
u'وَلَفَ غير':Subject, #1: 1	تَلِفَ الْغَائِبُ
u'وَلَفَ غَيْرٌ':Subject, #1: 1	تَلِفَ غَيْرُهُ
u'وَلَفَ فِرَاخٌ':Subject, #1: 1	تَلِفَ غَيْرُهُ
u'وَلَفَ كَرَمٌ':Predicate, #1: 1	تَلِفَ فِرَاخُهُ
u'وَلَفَ لبن':Subject, #1: 1	أَلِفَ الْكَرَمَ
u'وَلَفَ لبن':Subject, #2: 2	تَلِفَ اللَّبَنُ
u'وَلَفَ لَبَنٌ':Subject, #2: 2	تَلِفَ اللَّبِنُ
u'وَلَفَ لَبِنٌ':Subject, #2: 2	تَلِفَ اللَّبَنُ
u'وَلَفَ مَاءٌ':Subject, #2: 2	تَلِفَ اللَّبِنُ
u'وَلَفَ مَالٌ':Subject, #1: 1	تَلِفَ مَاءٌ
u'وَلَفَ مَالٌ':Subject, #2: 2	تَلِفَ مَالٌ
u'وَلَفَ مَالٌ':Subject, #30: 30	تَلِفَ الْمَالُ
u'وَلَفَ مَالٌ':Subject, #3: 3	تَلِفَ مَالُ
u'وَلَفَ مَبِيعٌ':Subject, #3: 3	تَلِفَ مَالُهُ
u'وَلَفَ مَتَاعٌ':Subject, #25: 25	تَلِفَ الْمَبِيعُ
u'وَلَفَ مَتَاعٌ':Subject, #1: 1	تَلِفَ الْمَتَاعُ
u'وَلَفَ مَجْرُوحٌ':Subject, #1: 1	تَلِفَ مَتَاعُهُ
u'وَلَفَ مَحْمُولٌ':Subject, #1: 1	تَلِفَ الْمَجْرُوحُ
u'وَلَفَ مَدْفُوعٌ':Subject, #2: 2	تَلِفَ الْمَحْمُولُ
u'وَلَفَ مَرْهُونٌ':Subject, #2: 2	تَلِفَ الْمَدْفُوعُ
u'وَلَفَ مَسْأَلَةٌ':Predicate, #2: 2	تَلِفَ الْمَرْهُونُ
u'وَلَفَ مَسْجِدٌ':Subject, #1: 1	أَلِفَ الْمَسْأَلَةَ
u'وَلَفَ مُعَجَّلٌ':Subject, #1: 1	تَلِفَ الْمَسْجِدُ
u'وَلَفَ مَعْقُودٌ':Subject, #2: 2	تَلِفَ الْمُعَجَّلُ
u'وَلَفَ مُعَيَّنٌ':Subject, #1: 1	تَلِفَ الْمَعْقُودُ
u'وَلَفَ مَغْصُوب':Subject, #1: 1	تَلِفَ الْمُعَيَّنُ
u'وَلَفَ مَقْبُوضٌ':Subject, #4: 4	تَلِفَ الْمَغْصُوبُ
u'وَلَفَ مَكْسُورٌ':Subject, #3: 3	تَلِفَ الْمَقْبُوضُ
u'وَلَفَ مَهْرٌ':Subject, #1: 1	تَلِفَ الْمَكْسُورُ
u'وَلَفَ مَوْجُودٌ':Subject, #1: 1	تَلِفَ الْمَهْرُ
u'وَلَفَ مَوْهُوبٌ':Subject, #1: 1	تَلِفَ الْمَوْجُودُ
u'وَلَفَ نصاب':Subject, #1: 1	تَلِفَ الْمَوْهُوبُ
u'وَلَفَ نِصَابٌ':Subject, #9: 9	تَلِفَ النِّصَابُ
u'وَلَفَ نِصْفٌ':Subject, #9: 9	تَلِفَ النِّصَابُ
u'وَلَفَ نَصِيبٌ':Subject, #1: 1	تَلِفَ نِصْفُ
u'وَلَفَ نَقْدٌ':Subject, #1: 1	تَلِفَ نَصِيبُ
u'وَلَفَ نَقْد':Subject, #1: 1	تَلِفَ نَقْدٌ
u'وَلَفَ وَاقِعٌ':Subject, #1: 1	تَلِفَ نَقْدٌ
u'وَلَفَ وَتَرٌ':Subject, #1: 1	تَلِفَ الْوَاقِعُ
u'وَلَفَ وَجَبٌ':Predicate, #1: 1	تَلِفَ الْوَتَرُ
u'وَلَفَ ولد':Subject, #1: 1	تَلِفَ وَجَبَ
u'وَلَفَ وَلَدٌ':Subject, #1: 1	تَلِفَ الْوَلَدُ
u'وَلَفَ ولد':Subject, #1: 1	تَلِفَ الْوَلَدُ
u'وَلَفَ وَلَدٌ':Subject, #1: 1	تَلِفَ وَلَدُ
u'وَلَهٌ تَهَجِّي':Added, #1: 1	تَلِفَ وَلَدُ
u'وَلَهٌ طَرِيقٌ':Added, #1: 1	وَلَهُ تَهَجِّيهِ
u'وَلَهٌ عَمَّانُ':Added, #1: 1	وَلَهُ طَرِيقِ
u'وَلْوَلَةٌ نِساءٌ':Added, #5: 5	وَلَهُ عَمَّانِ
u'وَلِيَ اِبْنٌ':Subject, #2: 2	وَلْوَلَةَ النِّسَاءِ
u'وَلَّى اِبْنٌ':Subject, #1: 1	وَلِيَ ابْنُ
u'وَلِيَ أحَدٌ':Subject, #1: 1	وَلَّى ابْنُ
u'وَلِيَ أحَدٌ':Subject, #1: 1	وَلِيَ أَحَدُ
u'وَلِيَ إِدَانَةٌ':Predicate, #2: 2	وَلِيَ أَحَدٌ
u'وَلَى إِدَانَةٌ':Predicate, #4: 4	وَلِيَ الْإِدَانَةَ
u'وَلَّى إِسْلامٌ':Predicate, #4: 4	وَلِيَ الْإِدَانَةَ
u'وَلَّى إِسْلامٌ':Predicate, #1: 1	وَلَّى الإِسْلاَمَ
u'وَلِيَ أعاجم':Predicate, #2: 2	وَلَّى الْإِسْلَامَ
u'وَلَى أعاجم':Predicate, #1: 1	وَلِيَ الأَعَاجِمَ
u'وَلَّى إمَامٌ':Subject, #1: 1	وَلِيَ الأَعَاجِمَ
u'وَلِيَ إمَامَةٌ':Predicate, #2: 2	وَلَّى الْإِمَامُ
u'وَلَى إمَامَةٌ':Predicate, #1: 1	وَلِيَ إمَامَةَ
u'وَلِيَ أَمْرٌ':Predicate, #1: 1	وَلِيَ إمَامَةَ
u'وَلَى أَمْرٌ':Predicate, #2: 2	وَلِيَ الْأَمْرَ
u'وَلِيَ أَمْرٌ':Predicate, #2: 2	وَلِيَ الْأَمْرَ
u'وَلَى أَمْرٌ':Predicate, #5: 5	وَلِيَ أَمْرَ
u'وَلِيَ بَأسٌ':Predicate, #5: 5	وَلِيَ أَمْرَ
u'وَلَى بَأسٌ':Predicate, #1: 1	وَلِيَ الْبَأْسَ
u'وَلِيَ بَعْضٌ':Subject, #1: 1	وَلِيَ الْبَأْسَ
u'وَلَّى بُغاةٌ':Subject, #1: 1	وَلِيَ بَعْضُ
u'وَلِيَ بَيْتٌ':Predicate, #1: 1	وَلَّى الْبُغَاةُ
u'وَلَى بَيْتٌ':Predicate, #2: 2	وَلِيَ الْبَيْتَ
u'وَلِيَ بَيْعٌ':Predicate, #2: 2	وَلِيَ الْبَيْتَ
u'وَلَى بَيْعٌ':Predicate, #1: 1	وَلِيَ الْبَيْعَ
u'وَلِيَ بَيِّنَةٌ':Subject, #1: 1	وَلِيَ الْبَيْعَ
u'وَلِيَ بُيُوتٌ':Predicate, #1: 1	وَلِيَ الْبَيِّنَةُ
u'وَلَى بُيُوتٌ':Predicate, #1: 1	وَلِيَ الْبُيُوتَ
u'وَلِيَ تَدْرِيسٌ':Predicate, #1: 1	وَلِيَ الْبُيُوتَ
u'وَلَى تَدْرِيسٌ':Predicate, #1: 1	وَلِيَ تَدْرِيسَ
u'وَلِيَ تَصَرُّفٌ':Predicate, #1: 1	وَلِيَ تَدْرِيسَ
u'وَلَى تَصَرُّفٌ':Predicate, #2: 2	وَلِيَ التَّصَرُّفَ
u'وَلِيَ تَعَاهُدٌ':Predicate, #2: 2	وَلِيَ التَّصَرُّفَ
u'وَلَى تَعَاهُدٌ':Predicate, #1: 1	وَلِيَ تَعَاهُدَ
u'وَلِيَ جِبَايَةٌ':Predicate, #1: 1	وَلِيَ تَعَاهُدَ
u'وَلَى جِبَايَةٌ':Predicate, #2: 2	وَلِيَ جِبَايَةَ
u'وَلِيَ جُمْلَةٌ':Predicate, #2: 2	وَلِيَ جِبَايَةَ
u'وَلَى جُمْلَةٌ':Predicate, #1: 1	وَلِيَ الْجُمْلَةَ
u'وَلِيَ حاضِرٌ':Subject, #1: 1	وَلِيَ الْجُمْلَةَ
u'وَلِيَ حُكْمٌ':Predicate, #1: 1	وَلِيَ حَاضِرٌ
u'وَلَى حُكْمٌ':Predicate, #1: 1	وَلِيَ الْحُكْمَ
u'وَلِيَ خُصُومَةٌ':Predicate, #1: 1	وَلِيَ الْحُكْمَ
u'وَلَى خُصُومَةٌ':Predicate, #1: 1	وَلِيَ الْخُصُومَةَ
u'وَلِيَ خَفِيفٌ':Predicate, #1: 1	وَلِيَ الْخُصُومَةَ
u'وَلَى خَفِيفٌ':Predicate, #1: 1	وَلِيَ الْخَفِيفَةَ
u'وَلِيَ خِلاَفَةٌ':Predicate, #1: 1	وَلِيَ الْخَفِيفَةَ
u'وَلَى خِلاَفَةٌ':Predicate, #2: 2	وَلِيَ الْخِلَافَةَ
u'وَلَّى خَلِيفَةٌ':Predicate, #2: 2	وَلِيَ الْخِلَافَةَ
u'وَلَّى خوارج':Subject, #1: 1	وَلَّى الْخَلِيفَةَ
u'وَلَّى خَوَارِجُ':Subject, #1: 1	وَلَّى الْخَوَارِجُ
u'وَلِيَ خيار':Subject, #1: 1	وَلَّى الْخَوَارِجُ
u'وَلِيَ خِيَارٌ':Subject, #4: 4	وَلِيَ الْخِيَارُ
u'وَلِيَ دَارٌ':Predicate, #4: 4	وَلِيَ الْخِيَارُ
u'وَلَى دَارٌ':Predicate, #1: 1	وَلِيَ دَارَ
u'وَلِيَ دفن':Predicate, #1: 1	وَلِيَ دَارَ
u'وَلِيَ دَفْنٌ':Predicate, #1: 1	وَلِيَ دَفْنَ
u'وَلَى دفن':Predicate, #1: 1	وَلِيَ دَفْنَ
u'وَلَى دَفْنٌ':Predicate, #1: 1	وَلِيَ دَفْنَ
u'وَلِيَ رَجُلٌ':Subject, #1: 1	وَلِيَ دَفْنَ
u'وَلِيَ رَجُلٌ':Subject, #1: 1	وَلِيَ الرَّجُلُ
u'وَلَّى رَجُلٌ':Subject, #2: 2	وَلِيَ رَجُلٌ
u'وَلَّى رَسُولٌ':Subject, #5: 5	وَلَّى الرَّجُلُ
u'وَلِيَ رُومٌ':Predicate, #3: 3	وَلَّى رَسُولُ
u'وَلَى رُومٌ':Predicate, #1: 1	وَلِيَ الرّومَ
u'وَلَّى زَمانٌ':Subject, #1: 1	وَلِيَ الرّومَ
u'وَلَّى سائِل':Subject, #1: 1	وَلَّى الزَّمَانُ
u'وَلَّى سَائِلٌ':Subject, #3: 3	وَلَّى السَّائِلُ
u'وَلِيَ سُعَاةٌ':Subject, #3: 3	وَلَّى السَّائِلُ
u'وَلِيَ سقط':Predicate, #1: 1	وَلِيَ السُّعَاةُ
u'وَلِيَ سَقَطٌ':Predicate, #1: 1	وَلِيَ سَقَطَ
u'وَلَى سقط':Predicate, #1: 1	وَلِيَ سَقَطَ
u'وَلَى سَقَطٌ':Predicate, #1: 1	وَلِيَ سَقَطَ
u'وَلَّى سُلْطَانٌ':Subject, #1: 1	وَلِيَ سَقَطَ
u'وَلِيَ سَلَمٌ':Predicate, #3: 3	وَلَّى السُّلْطَانُ
u'وَلَى سَلَمٌ':Predicate, #1: 1	وَلِيَ السَّلَمَ
u'وَلَّى شَاهِدٌ':Subject, #1: 1	وَلِيَ السَّلَمَ
u'وَلِيَ شفعة':Subject, #1: 1	وَلَّى الشَّاهِدُ
u'وَلِيَ شُفْعَةٌ':Subject, #1: 1	وَلِيَ الشُّفْعَةُ
u'وَلِيَ شَيْءٌ':Predicate, #1: 1	وَلِيَ الشُّفْعَةُ
u'وَلَى شَيْءٌ':Predicate, #1: 1	وَلِيَ الشَّيْءَ
u'وَلِيَ صَدْرٌ':Predicate, #1: 1	وَلِيَ الشَّيْءَ
u'وَلَى صَدْرٌ':Predicate, #1: 1	وَلِيَ الصَّدْرَ
u'وَلِيَ ظاهِرٌ':Predicate, #1: 1	وَلِيَ الصَّدْرَ
u'وَلَى ظاهِرٌ':Predicate, #1: 1	وَلِيَ الظَّاهِرَ
u'وَلِيَ عَبْدٌ':Subject, #1: 1	وَلِيَ الظَّاهِرَ
u'وَلِيَ عِرَاقٌ':Predicate, #2: 2	وَلِيَ عَبْدُ
u'وَلَى عِرَاقٌ':Predicate, #1: 1	وَلِيَ الْعِرَاقَ
u'وَلِيَ عَقْدٌ':Predicate, #1: 1	وَلِيَ الْعِرَاقَ
u'وَلَى عَقْدٌ':Predicate, #1: 1	وَلِيَ عَقْدَ
u'وَلِيَ عَقْدٌ':Predicate, #1: 1	وَلِيَ عَقْدَ
u'وَلَى عَقْدٌ':Predicate, #4: 4	وَلِيَ الْعَقْدَ
u'وَلَّى عُمَرٌ':Predicate, #4: 4	وَلِيَ الْعَقْدَ
u'وَلِيَ عُمَرٌ':Subject, #2: 2	وَلَّى عُمَرَ
u'وَلِيَ غير':Subject, #6: 6	وَلِيَ عُمَرُ
u'وَلِيَ غَيْرٌ':Subject, #1: 1	وَلِيَ غَيْرُهُ
u'وَلِيَ فلان':Predicate, #1: 1	وَلِيَ غَيْرُهُ
u'وَلَى فلان':Predicate, #1: 1	وَلِيَ مَكَّةَ
u'وَلِيَ فلان':Subject, #1: 1	وَلِيَ مَكَّةَ
u'وَلَّى قَاضِي':Predicate, #1: 1	وَلِيَ زِيَادٌ
u'وَلِيَ قَالٌ':Predicate, #1: 1	وَلَّى الْقَاضِيَ
u'وَلَى قَالٌ':Predicate, #1: 1	وَلِيَ قَالَ
u'وَلَّى قَالٌ':Predicate, #1: 1	وَلِيَ قَالَ
u'وَلِيَ قتل':Predicate, #7: 7	وَلَّى قَالَ
u'وَلِيَ قَتْلٌ':Predicate, #7: 7	وَلِيَ الْقَتْلَ
u'وَلَى قتل':Predicate, #7: 7	وَلِيَ الْقَتْلَ
u'وَلَى قَتْلٌ':Predicate, #7: 7	وَلِيَ الْقَتْلَ
u'وَلَّى قَضَاءٌ':Predicate, #7: 7	وَلِيَ الْقَتْلَ
u'وَلِيَ قَضَاءٌ':Predicate, #1: 1	وَلَّى الْقَضَاءَ
u'وَلَى قَضَاءٌ':Predicate, #3: 3	وَلِيَ قَضَاءَ
u'وَلِيَ قَضَاءٌ':Predicate, #3: 3	وَلِيَ قَضَاءَ
u'وَلَى قَضَاءٌ':Predicate, #8: 8	وَلِيَ الْقَضَاءَ
u'وَلِيَ قضاة':Predicate, #8: 8	وَلِيَ الْقَضَاءَ
u'وَلَى قضاة':Predicate, #1: 1	وَلِيَ الْقُضَاةَ
u'وَلِيَ قَطْعٌ':Predicate, #1: 1	وَلِيَ الْقُضَاةَ
u'وَلَى قَطْعٌ':Predicate, #1: 1	وَلِيَ قَطْعَ
u'وَلِيَ قول':Subject, #1: 1	وَلِيَ قَطْعَ
u'وَلِيَ قَوْلٌ':Subject, #1: 1	وَلِيَ قَوْلُهُ
u'وَلَّى قَوْمٌ':Subject, #1: 1	وَلِيَ قَوْلُهُ
u'وَلِيَ قيام':Predicate, #1: 1	وَلَّى قَوْمُهُ
u'وَلِيَ قِيَامٌ':Predicate, #1: 1	وَلِيَ الْقِيَامَ
u'وَلَى قيام':Predicate, #1: 1	وَلِيَ الْقِيَامَ
u'وَلَى قِيَامٌ':Predicate, #1: 1	وَلِيَ الْقِيَامَ
u'وَلِيَ مَالٌ':Predicate, #1: 1	وَلِيَ الْقِيَامَ
u'وَلَى مَالٌ':Predicate, #1: 1	وَلِيَ مَالَ
u'وَلِيَ مُبَايَعَةٌ':Predicate, #1: 1	وَلِيَ مَالَ
u'وَلَى مُبَايَعَةٌ':Predicate, #1: 1	وَلِيَ الْمُبَايَعَةَ
u'وَلِيَ مُسْلِمٌ':Subject, #1: 1	وَلِيَ الْمُبَايَعَةَ
u'وَلِيَ مِصْرٌ':Predicate, #2: 2	وَلِيَ الْمُسْلِمُ
u'وَلَى مِصْرٌ':Predicate, #1: 1	وَلِيَ مِصْرَ
u'وَلِيَ مَعَارِفُ':Predicate, #1: 1	وَلِيَ مِصْرَ
u'وَلَى مَعَارِفُ':Predicate, #1: 1	تَلِيَ الْمَعَارِفَ
u'وَلَّى مَنْصُورٌ':Subject, #1: 1	تَلِيَ الْمَعَارِفَ
u'وَلِيَ مِيرَاثٌ':Subject, #1: 1	وَلَّى الْمَنْصُورُ
u'وَلِيَ نَاسٌ':Subject, #1: 1	وَلِيَ الْمِيرَاثُ
u'وَلَّى نَاسٌ':Subject, #1: 1	وَلِيَ النّاسُ
u'وَلِيَ نَظَرٌ':Predicate, #2: 2	وَلَّى النَّاسُ
u'وَلَى نَظَرٌ':Predicate, #1: 1	وَلِيَ النَّظَرَ
u'وَلِيَ نَظَرٌ':Subject, #1: 1	وَلِيَ النَّظَرَ
u'وَلِيَ نَعْجَةٌ':Subject, #2: 2	وَلِيَ النَّظَرُ
u'وَلِيَ نكاح':Predicate, #1: 1	وَلِيَ نَعْجَةٌ
u'وَلِيَ نِكَاحٌ':Predicate, #1: 1	وَلِيَ النِّكَاحَ
u'وَلَى نكاح':Predicate, #1: 1	وَلِيَ النِّكَاحَ
u'وَلَى نِكَاحٌ':Predicate, #1: 1	وَلِيَ النِّكَاحَ
u'وَلِيَ وَقْفٌ':Predicate, #1: 1	وَلِيَ النِّكَاحَ
u'وَلَى وَقْفٌ':Predicate, #1: 1	وَلِيَ الْوَقْفَ
u'وَلِيَ وِلاَيَةٌ':Predicate, #1: 1	وَلِيَ الْوَقْفَ
u'وَلَى وِلاَيَةٌ':Predicate, #1: 1	وَلِيَ وِلَايَةَ
u'وَلِيَ يمن':Predicate, #1: 1	وَلِيَ وِلَايَةَ
u'وَلِيَ يَمَنُ':Predicate, #1: 1	وَلِيَ الْيَمَنَ
u'وَلَى يمن':Predicate, #1: 1	وَلِيَ الْيَمَنَ
u'وَلَى يَمَنُ':Predicate, #1: 1	وَلِيَ الْيَمَنَ
u'وَمِيضٌ جَمْرٌ':Added, #1: 1	وَلِيَ الْيَمَنَ
u'وَمِيضٌ عَقِيقَةٌ':Added, #1: 1	وَمِيضَ جَمْرٍ
u'وَهَبَ أَبٌ':Subject, #1: 1	وَمِيضُ عَقِيقَةٍ
u'وَهَبَ اِبْنٌ':Subject, #6: 6	وَهَبَ الْأَبُ
u'وَهَبَ أَجْرٌ':Predicate, #1: 1	وَهَبَ ابْنُ
u'وَهَبَ أُجْرَةٌ':Predicate, #2: 2	وَهَبَ الْأَجْرَ
u'وَهَبَ أحَدٌ':Predicate, #1: 1	وَهَبَ الْأُجْرَةَ
u'وَهَبَ أحَدٌ':Subject, #2: 2	وَهَبَ أَحَدَ
u'وَهَبَ أرْضٌ':Predicate, #7: 7	وَهَبَ أَحَدُ
u'وَهَبَ أَشْجَارٌ':Predicate, #2: 2	وَهَبَ الْأَرْضَ
u'وَهَبَ أصل':Subject, #1: 1	وَهَبَ الْأَشْجَارَ
u'وَهَبَ أًصْلٌ':Subject, #2: 2	وَهَبَ الْأَصْلُ
u'وَهَبَ أَكْثَرُ':Predicate, #2: 2	وَهَبَ الْأَصْلُ
u'وَهَبَ ألف':Predicate, #1: 1	وَهَبَ أَكْثَرَ
u'وَهَبَ ألْفٌ':Predicate, #2: 2	وَهَبَ الْأَلْفَ
u'وَهَبَ أَلْفٌ':Predicate, #2: 2	وَهَبَ الْأَلْفَ
u'وَهَبَ المُشْتَرِي':Predicate, #2: 2	وَهَبَ الْأَلْفَ
u'وَهَبَ أُمٌّ':Predicate, #1: 1	وَهَبَ الْمُشْتَرِيَ
u'وَهَبَ أمَةٌ':Predicate, #7: 7	وَهَبَ الْأُمَّ
u'وَهَبَ إِنْسانٌ':Subject, #2: 2	وَهَبَ الْأَمَةَ
u'وَهَبَ إِنْسانٌ':Subject, #1: 1	وَهَبَ الْإِنْسَانُ
u'وَهَبَ بَائِعٌ':Predicate, #1: 1	وَهَبَ إنْسَانٌ
u'وَهَبَ بَائِعٌ':Subject, #1: 1	وَهَبَ الْبَائِعَ
u'وَهَبَ بَعْضٌ':Predicate, #10: 10	وَهَبَ الْبَائِعُ
u'وَهَبَ بِنَاءٌ':Predicate, #7: 7	وَهَبَ بَعْضَ
u'وَهَبَ بَيْتٌ':Predicate, #2: 2	وَهَبَ الْبِنَاءَ
u'وَهَبَ تَمْر':Predicate, #1: 1	وَهَبَ الْبَيْتَ
u'وَهَبَ ثَمَرٌ':Predicate, #1: 1	وَهَبَ التَّمْرَ
u'وَهَبَ ثَمَنٌ':Predicate, #1: 1	وَهَبَ ثَمَرَ
u'وَهَبَ ثَمَنٌ':Predicate, #11: 11	وَهَبَ الثَّمَنَ
u'وَهَبَ جَارِي':Predicate, #1: 1	وَهَبَ ثَمَنَ
u'وَهَبَ جَارِي':Predicate, #10: 10	وَهَبَ جَارِيَةً
u'وَهَبَ جَارِيَةٌ':Predicate, #9: 9	وَهَبَ الْجَارِيَةَ
u'وَهَبَ جَازٌ':Predicate, #9: 9	وَهَبَ الْجَارِيَةَ
u'وَهَبَ جِرَابٌ':Predicate, #1: 1	وَهَبَ جَازَ
u'وَهَبَ جلد':Predicate, #1: 1	وَهَبَ الْجِرَابَ
u'وَهَبَ جِلْدٌ':Predicate, #1: 1	وَهَبَ الْجِلْدَ
u'وَهَبَ جَمِيع':Predicate, #1: 1	وَهَبَ الْجِلْدَ
u'وَهَبَ حُلِيٌّ':Predicate, #1: 1	وَهَبَ الْجَمِيعَ
u'وَهَبَ حَمْلٌ':Predicate, #1: 1	وَهَبَ الْحُلِيَّ
u'وَهَبَ حِمْلٌ':Predicate, #1: 1	وَهَبَ الْحَمْلَ
u'وَهَبَ خَارِجٌ':Predicate, #1: 1	وَهَبَ الْحِمْلَ
u'وَهَبَ خَمْرٌ':Predicate, #1: 1	وَهَبَ الْخَارِجَ
u'وَهَبَ دَابَّةٌ':Predicate, #1: 1	وَهَبَ الْخَمْرَ
u'وَهَبَ دَارٌ':Predicate, #1: 1	وَهَبَ الدَّابَّةَ
u'وَهَبَ دَارٌ':Predicate, #2: 2	وَهَبَ دَارَ
u'وَهَبَ دَائِنٌ':Subject, #6: 6	وَهَبَ الدَّارَ
u'وَهَبَ دَرَاهِمُ':Predicate, #2: 2	وَهَبَ الدَّائِنُ
u'وَهَبَ دَيْنٌ':Predicate, #1: 1	وَهَبَ دَرَاهِمَ
u'وَهَبَ دِينارٌ':Predicate, #13: 13	وَهَبَ الدَّيْنَ
u'وَهَبَ ذِمِّيٌّ':Subject, #1: 1	وَهَبَ الدِّينَارَ
u'وَهَبَ ذَهَبٌ':Predicate, #1: 1	وَهَبَ الذِّمِّيُّ
u'وَهَبَ رَأْسٌ':Predicate, #1: 1	وَهَبَ الذَّهَبَ
u'وَهَبَ رَاهِنٌ':Subject, #1: 1	وَهَبَ رَأْسَ
u'وَهَبَ رَبُّ':Subject, #1: 1	وَهَبَ الرَّاهِنُ
u'وَهَبَ رَجُلٌ':Predicate, #2: 2	وَهَبَ رَبُّ
u'وَهَبَ رَجُلٌ':Subject, #1: 1	وَهَبَ الرَّجُلَ
u'وَهَبَ رَجُلٌ':Subject, #8: 8	وَهَبَ رَجُلٌ
u'وَهَبَ رَدٌّ':Predicate, #9: 9	وَهَبَ الرَّجُلُ
u'وَهَبَ سَالِمٌ':Subject, #1: 1	وَهَبَ رَدَّ
u'وَهَبَ سَرْجٌ':Predicate, #1: 1	وَهَبَ سَالِمُ
u'وَهَبَ سَفِيهٌ':Subject, #1: 1	وَهَبَ السَّرْجَ
u'وَهَبَ سَكْرَان':Subject, #1: 1	وَهَبَ السَّفِيهُ
u'وَهَبَ سُلْطَانٌ':Subject, #1: 1	وَهَبَ السَّكْرَانُ
u'وَهَبَ سِلْعَةٌ':Predicate, #1: 1	وَهَبَ السُّلْطَانُ
u'وَهَبَ سَيِّدٌ':Subject, #1: 1	وَهَبَ السِّلْعَةَ
u'وَهَبَ شَخْصٌ':Subject, #1: 1	وَهَبَ السَّيِّدُ
u'وَهَبَ شَفِيعٌ':Subject, #1: 1	وَهَبَ الشَّخْصُ
u'وَهَبَ صَاحِبٌ':Subject, #1: 1	وَهَبَ الشَّفِيعُ
u'وَهَبَ صِبْغٌ':Predicate, #1: 1	وَهَبَ صَاحِبُ
u'وَهَبَ صَبِيٌّ':Predicate, #2: 2	وَهَبَ الصِّبْغَ
u'وَهَبَ صُوفٌ':Predicate, #1: 1	وَهَبَ الصَّبِيَّ
u'وَهَبَ طَالِبٌ':Subject, #1: 1	وَهَبَ الصُّوفَ
u'وَهَبَ طعام':Predicate, #5: 5	وَهَبَ الطَّالِبُ
u'وَهَبَ طَعَامٌ':Predicate, #1: 1	وَهَبَ الطَّعَامَ
u'وَهَبَ عَامِرٌ':Subject, #1: 1	وَهَبَ الطَّعَامَ
u'وَهَبَ عَبْدٌ':Predicate, #1: 1	وَهَبَ الْعَامِرُ
u'وَهَبَ عَبْدٌ':Predicate, #1: 1	وَهَبَ عَبْدَ
u'وَهَبَ عَبْدٌ':Subject, #7: 7	وَهَبَ الْعَبْدَ
u'وَهَبَ عند':Predicate, #2: 2	وَهَبَ الْعَبْدُ
u'وَهَبَ عين':Predicate, #1: 1	وَهَبَ عِنْدَ
u'وَهَبَ عَيْنٌ':Predicate, #2: 2	وَهَبَ الْعَيْنَ
u'وَهَبَ عَيْن':Predicate, #2: 2	وَهَبَ الْعَيْنَ
u'وَهَبَ غَاصِبٌ':Subject, #2: 2	وَهَبَ الْعَيْنَ
u'وَهَبَ غَائِبٌ':Subject, #4: 4	وَهَبَ الْغَاصِبُ
u'وَهَبَ غَرِيمٌ':Subject, #1: 1	وَهَبَ الْغَائِبُ
u'وَهَبَ غير':Predicate, #1: 1	وَهَبَ الْغَرِيمُ
u'وَهَبَ غَيْرٌ':Predicate, #1: 1	وَهَبَ غَيْرَ
u'وَهَبَ فَقِيرٌ':Predicate, #1: 1	وَهَبَ غَيْرَ
u'وَهَبَ فلان':Predicate, #1: 1	وَهَبَ الْفَقِيرَ
u'وَهَبَ فُلاَنٌ':Subject, #1: 1	وَهَبَ الدَّانِقَ
u'وَهَبَ فُلاَنٌ':Subject, #10: 10	وَهَبَ فُلَانٌ
u'وَهَبَ قُمْقُمَةٌ':Predicate, #2: 2	وَهَبَ فُلَانُ
u'وَهَبَ كَافِرٌ':Subject, #1: 1	وَهَبَ الْقُمْقُمَةَ
u'وَهَبَ مَاءٌ':Predicate, #2: 2	وَهَبَ الْكَافِرُ
u'وَهَبَ مَالٌ':Predicate, #2: 2	وَهَبَ الْمَاءَ
u'وَهَبَ مَالٌ':Predicate, #3: 3	وَهَبَ مَالَ
u'وَهَبَ مَالِكٌ':Subject, #4: 4	وَهَبَ الْمَالَ
u'وَهَبَ مَأْمُورٌ':Subject, #1: 1	وَهَبَ الْمَالِكُ
u'وَهَبَ مُبْتاع':Subject, #1: 1	وَهَبَ الْمَأْمُورُ
u'وَهَبَ مَبِيعٌ':Predicate, #1: 1	وَهَبَ الْمُبْتَاعُ
u'وَهَبَ مَتَاعٌ':Predicate, #2: 2	وَهَبَ الْمَبِيعَ
u'وَهَبَ مُحَمَّدٌ':Subject, #7: 7	وَهَبَ الْمَتَاعَ
u'وَهَبَ مُرْتَدٌّ':Subject, #1: 1	وَهَبَ مُحَمَّدٌ
u'وَهَبَ مُرْتَهِنٌ':Subject, #1: 1	وَهَبَ الْمُرْتَدُّ
u'وَهَبَ مَرْهُونٌ':Predicate, #2: 2	وَهَبَ الْمُرْتَهِنُ
u'وَهَبَ مَرِيضٌ':Subject, #1: 1	وَهَبَ الْمَرْهُونَ
u'وَهَبَ مَسَامِيرُ':Predicate, #12: 12	وَهَبَ الْمَرِيضُ
u'وَهَبَ مُسْلِمٌ':Subject, #1: 1	وَهَبَ الْمَسَامِيرَ
u'وَهَبَ مُشْتَرِي':Predicate, #1: 1	وَهَبَ مُسْلِمٌ
u'وَهَبَ مَشْهُودٌ':Subject, #1: 1	وَهَبَ الْمُشْتَرِيَ
u'وَهَبَ مُعِير':Subject, #1: 1	وَهَبَ الْمَشْهُودُ
u'وَهَبَ مَغْصُوب':Predicate, #1: 1	وَهَبَ الْمُعِيرُ
u'وَهَبَ مَغْصُوب':Subject, #3: 3	وَهَبَ الْمَغْصُوبَ
u'وَهَبَ مَنَافِعُ':Predicate, #1: 1	وَهَبَ الْمَغْصُوبُ
u'وَهَبَ مَنْفَعَةٌ':Predicate, #1: 1	وَهَبَ الْمَنَافِعَ
u'وَهَبَ مَنْكُوح':Predicate, #1: 1	وَهَبَ مَنْفَعَةَ
u'وَهَبَ مُؤَجِّرٌ':Subject, #1: 1	وَهَبَ الْمَنْكُوحَةَ
u'وَهَبَ مُودَعٌ':Subject, #2: 2	وَهَبَ الْمُؤَجِّرُ
u'وَهَبَ مَوْهُوبٌ':Predicate, #1: 1	وَهَبَ الْمُودَعُ
u'وَهَبَ مَوْهُوبٌ':Subject, #1: 1	وَهَبَ الْمَوْهُوبَ
u'وَهَبَ نصاب':Predicate, #3: 3	وَهَبَ الْمَوْهُوبُ
u'وَهَبَ نِصَابٌ':Predicate, #4: 4	وَهَبَ النِّصَابَ
u'وَهَبَ نَصْرَانِيٌّ':Subject, #4: 4	وَهَبَ النِّصَابَ
u'وَهَبَ نِصْفٌ':Predicate, #1: 1	وَهَبَ نَصْرَانِيٌّ
u'وَهَبَ نِصْفٌ':Predicate, #11: 11	وَهَبَ النِّصْفَ
u'وَهَبَ واحد':Subject, #12: 12	وَهَبَ نِصْفَ
u'وَهَبَ وَاحِدٌ':Subject, #1: 1	وَهَبَ وَاحِدٌ
u'وَهَبَ وَاقِفٌ':Subject, #1: 1	وَهَبَ وَاحِدٌ
u'وَهَبَ وَالِدٌ':Subject, #1: 1	وَهَبَ الْوَاقِفُ
u'وَهَبَ وَدِيعٌ':Predicate, #2: 2	وَهَبَ الْوَالِدُ
u'وَهَبَ وَدِيعَةٌ':Predicate, #1: 1	وَهَبَ الْوَدِيعَةَ
u'وَهَبَ وَلِيٌّ':Subject, #1: 1	وَهَبَ الْوَدِيعَةَ
u'وَهَبَ وَلِيٌّ':Subject, #1: 1	وَهَبَ الْوَلِيُّ
u'وَهِلَ اِبْنٌ':Subject, #1: 1	وَهَبَ وَلِيُّ
u'وَهِلَ رَجُلٌ':Subject, #1: 1	وَهِلَ ابْنُ
u'وَهَلَ عَبْدٌ':Subject, #1: 1	وَهِلَ الرّجُلُ
u'وَهِمَ اِبْنٌ':Subject, #1: 1	وَهَلَ الْعَبْدُ
u'وَهْمٌ اِبْنٌ':Added, #2: 2	وَهِمَ ابْنُ
u'وَهْمٌ اِبْنٌ':Added, #1: 1	وَهْمِ ابْنِ
u'وَهْمٌ بَراءةٌ':Added, #2: 2	وَهْمُ ابْنِ
u'وَهَمَ بَعْضٌ':Subject, #1: 1	وَهْمُ الْبَرَاءَةِ
u'وَهِمَ بَعْضٌ':Subject, #1: 1	وَهَمَ بَعْضُ
u'وَهْمٌ تَجَوُّزٌ':Added, #2: 2	وَهِمَ بَعْضُ
u'وَهْمٌ تَلَف':Added, #1: 1	وَهْمِ التَّجَوُّزِ
u'وَهِمَ حاكِمٌ':Subject, #1: 1	وَهْمُ التَّلَفِ
u'وَهِمَ حَكَمٌ':Subject, #1: 1	وَهِمَ الْحَاكِمُ
u'وَهْمٌ رضاع':Added, #1: 1	وَهِمَ الْحَكَمُ
u'وَهَمَ شافِعِيّ':Subject, #1: 1	وَهْمِ الرَّضَاعِ
u'وَهِمَ شُعْبَةٌ':Subject, #1: 1	وَهَمَ الشَّافِعِيُّ
u'وَهْمٌ ضَرَرٌ':Added, #1: 1	وَهِمَ شُعْبَةُ
u'وَهَمَ عَبْدٌ':Subject, #1: 1	وَهْمُ الضَّرَرِ
u'وَهِمَ عُمَرٌ':Subject, #1: 1	وَهَمَ عَبْدُ
u'وَهْمٌ عَوَامُّ':Added, #1: 1	وَهِمَ عُمَرُ
u'وَهَمَ فلان':Subject, #1: 1	وَهْمُ الْعَوَامِّ
u'وَهِمَ فلان':Subject, #1: 1	وَهَمَ الشَّافِعِيُّ
u'وَهْمٌ قَائِلٌ':Added, #1: 1	وَهِمَ زُهَيْرٌ
u'وَهَمَ قُدْوَةٌ':Subject, #1: 1	وَهْمِ الْقَائِلِ
u'وَهَّمَ قول':Predicate, #1: 1	وَهَمَ قُدْوَةُ
u'وَهَّمَ قَوْلٌ':Predicate, #1: 1	وَهَّمَ قَوْلَ
u'وَهْمٌ كَوْنٌ':Added, #1: 1	وَهَّمَ قَوْلَ
u'وَهْمٌ نَاقِلٌ':Added, #1: 1	وَهْمُ كَوْنِ
u'وَهْمٌ نَاقِلٌ':Added, #1: 1	وَهْمُ النَّاقِلِ
u'وَهْمٌ هَوَامٌّ':Added, #1: 1	وَهْمَ نَاقِلِ
u'وَهْمٌ وُقُوعٌ':Added, #2: 2	وَهْمِ الْهَوَامِّ
u'وَهْمٌ وُقُوعٌ':Added, #1: 1	وَهْمَ وُقُوعِ
u'وَهْمٌ وُقُوعٌ':Added, #2: 2	وَهْمُ الْوُقُوعِ
u'وَهَنٌ إِسْلامٌ':Added, #2: 2	وَهْمِ الْوُقُوعِ
u'وَهَّنَ حَديثٌ':Predicate, #1: 1	وَهَنِ الْإِسْلَامِ
u'وَهَنٌ حَديثٌ':Added, #1: 1	وَهَّنَ حَدِيثَ
u'وَهْنٌ حَديثٌ':Added, #1: 1	وَهَنِ الْحَدِيثِ
u'وَهَّنَ رِوايَةٌ':Predicate, #1: 1	وَهْنِ حَدِيثِهِ
u'وَهُنَ فَضِيلٌ':Predicate, #1: 1	وَهَّنَ رِوَايَةَ
u'وَهُنَ فَضِيلَةٌ':Predicate, #1: 1	أَوْهَنَ فَضِيلَةَ
u'وَهَنٌ قَوْمٌ':Added, #1: 1	أَوْهَنَ فَضِيلَةَ
u'وَهِيَ إبَاحَةٌ':Subject, #1: 1	وَهَنِ قَوْمِهِ
u'وَهِيَ إبَاحَةٌ':Subject, #1: 1	وَهِيَ إبَاحَةُ
u'وَهِيَ آبارٌ':Subject, #1: 1	وَهِيَ الْإِبَاحَةُ
u'وَهِيَ اِبْتِداعٌ':Subject, #1: 1	وَهِيَ آبَارٌ
u'وَهِيَ أبدانٌ':Subject, #1: 1	وَهِيَ ابْتِدَاعَاتُ
u'وَهِيَ أَبْعَدُ':Subject, #1: 1	وَهِيَ الْأَبْدَانُ
u'وَهِيَ إِبِلٌ':Subject, #4: 4	وَهِيَ أَبْعَدُ
u'وَهِيَ اِبْنَة':Subject, #13: 13	وَهِيَ الْإِبِلُ
u'وَهِيَ اِبْنَة':Subject, #1: 1	وَهِيَ ابْنَتُهُ
u'وَهِيَ أَبْوَابٌ':Subject, #3: 3	وَهِيَ ابْنَةُ
u'وَهِيَ أُبُوَّةٌ':Subject, #1: 1	وَهِيَ الْأَبْوَابُ
u'وَهِيَ أتْرُجَّةٌ':Subject, #2: 2	وَهِيَ الْأُبُوَّةُ
u'وَهِيَ اِتِّساعٌ':Subject, #1: 1	وَهِيَ الْأُتْرُجَّةُ
u'وَهِيَ آتِي':Subject, #1: 1	وَهِيَ اتِّسَاعُ
u'وَهِيَ إِتْيانٌ':Subject, #2: 2	وَهِيَ الْآتِيَةُ
u'وَهِيَ إِتْيانٌ':Subject, #2: 2	وَهِيَ إتْيَانُ
u'وَهِيَ إِثْبَاتٌ':Subject, #4: 4	وَهِيَ الْإِتْيَانُ
u'وَهِيَ إِثْبَاتٌ':Subject, #1: 1	وَهِيَ إثْبَاتٌ
u'وَهِيَ إجَارَةٌ':Subject, #3: 3	وَهِيَ إثْبَاتُ
u'وَهِيَ إجَارَةٌ':Subject, #3: 3	وَهِيَ إجَارَةٌ
u'وَهِيَ اِجْتِمَاعٌ':Subject, #4: 4	وَهِيَ إجَارَةُ
u'وَهِيَ أَجْرٌ':Subject, #1: 1	وَهِيَ اجْتِمَاعُ
u'وَهِيَ أَجْرٌ':Subject, #1: 1	وَهِيَ أَجْرُ
u'وَهِيَ أُجْرَةٌ':Subject, #1: 1	وَهِيَ الْأَجْرُ
u'وَهِيَ أُجْرَةٌ':Subject, #2: 2	وَهِيَ الْأُجْرَةُ
u'وَهِيَ أَجْزَاءٌ':Subject, #3: 3	وَهِيَ أُجْرَةُ
u'وَهِيَ أَجْسَامٌ':Subject, #1: 1	وَهِيَ الْأَجْزَاءُ
u'وَهِيَ أَجْنَاسٌ':Subject, #1: 1	وَهِيَ الْأَجْسَامُ
u'وَهِيَ أَجْنَبِيٌّ':Subject, #5: 5	وَهِيَ أَجْنَاسٌ
u'وَهِيَ أُجُورٌ':Subject, #16: 16	وَهِيَ أَجْنَبِيَّةٌ
u'وَهِيَ آحَادٌ':Subject, #1: 1	وَهِيَ أُجُورُ
u'وَهِيَ اِحْتِمَالٌ':Subject, #1: 1	وَهِيَ الْآحَادُ
u'وَهِيَ اِحْتِمَالٌ':Subject, #2: 2	وَهِيَ احْتِمَالٌ
u'وَهِيَ أَحْجارٌ':Subject, #2: 2	وَهِيَ احْتِمَالُ
u'وَهِيَ أحَدٌ':Predicate, #1: 1	وَهِيَ الْأَحْجَارُ
u'وَهَى أحَدٌ':Predicate, #1: 1	وَهِيَ أَحَدَ
u'وَهِيَ أحَدٌ':Subject, #1: 1	وَهِيَ أَحَدَ
u'وَهِيَ أحَدٌ':Subject, #1: 1	وَهِيَ أَحَدٌ
u'وَهِيَ إِحْرَامٌ':Subject, #7: 7	وَهِيَ أَحَدُ
u'وَهِيَ أَحْسَنُ':Subject, #2: 2	وَهِيَ الْإِحْرَامُ
u'وَهِيَ إحْضَارٌ':Subject, #17: 17	وَهِيَ أَحْسَنُ
u'وَهِيَ أَحَقُّ':Subject, #1: 1	وَهِيَ إحْضَارُ
u'وَهِيَ أَحْكَامٌ':Subject, #11: 11	وَهِيَ أَحَقُّ
u'وَهِيَ أَحْكَامٌ':Subject, #3: 3	وَهِيَ أَحْكَامُ
u'وَهِيَ أَحْيَاءٌ':Subject, #3: 3	وَهِيَ الْأَحْكَامُ
u'وَهِيَ إِحْيَاءٌ':Subject, #1: 1	وَهِيَ أَحْيَاءٌ
u'وَهِيَ أخْبَارٌ':Subject, #1: 1	وَهِيَ إحْيَاءُ
u'وَهِيَ أخْبَارٌ':Subject, #1: 1	وَهِيَ أَخْبَارٌ
u'وَهِيَ أَخْبَارٌ':Subject, #1: 1	وَهِيَ أَخْبَارُ
u'وَهِيَ أَخْبَارٌ':Subject, #1: 1	وَهِيَ أَخْبَارٌ
u'وَهِيَ إِخْبَارٌ':Subject, #1: 1	وَهِيَ أَخْبَارُ
u'وَهِيَ إِخْبَارٌ':Subject, #1: 1	وَهِيَ إخْبَارُ
u'وَهِيَ أَخْبَثٌ':Subject, #2: 2	وَهِيَ إخْبَارٌ
u'وَهِيَ أخْبِيَةٌ':Subject, #3: 3	وَهِيَ أَخْبَثُ
u'وَهِيَ أُخْتٌ':Subject, #1: 1	وَهِيَ الْأَخْبِيَةُ
u'وَهِيَ أُخْتٌ':Subject, #10: 10	وَهِيَ أُخْتُهُ
u'وَهِيَ أُخْتٌ':Subject, #11: 11	وَهِيَ أُخْتُ
u'وَهِيَ اِخْتِصَاصٌ':Subject, #2: 2	وَهِيَ الْأُخْتُ
u'وَهِيَ اِخْتِلاطٌ':Subject, #1: 1	وَهِيَ اخْتِصَاصُ
u'وَهِيَ اِخْتِيَارٌ':Subject, #1: 1	وَهِيَ اخْتِلَاطُ
u'وَهِيَ اِخْتِيَارِيٌّ':Subject, #27: 27	وَهِيَ اخْتِيَارُ
u'وَهِيَ أخْذٌ':Subject, #2: 2	وَهِيَ اخْتِيَارِيَّةٌ
u'وَهِيَ أخْذٌ':Subject, #2: 2	وَهِيَ الْأَخْذُ
u'وَهِيَ آخِرُ':Subject, #6: 6	وَهِيَ أَخْذُ
u'وَهِيَ إِخْرَاجٌ':Subject, #11: 11	وَهِيَ آخِرُ
u'وَهِيَ إِخْرَاجٌ':Subject, #1: 1	وَهِيَ الْإِخْرَاجُ
u'وَهِيَ آخِرَةٌ':Subject, #2: 2	وَهِيَ إخْرَاجُ
u'وَهِيَ أَخْشَابٌ':Subject, #1: 1	وَهِيَ الْآخِرَةُ
u'وَهِيَ أَخَصُّ':Subject, #1: 1	وَهِيَ أَخْشَابٌ
u'وَهِيَ أخفُّ':Subject, #5: 5	وَهِيَ أَخَصُّ
u'وَهِيَ أخْلاقٌ':Subject, #1: 1	وَهِيَ أَخَفُّ
u'وَهِيَ أَخْلاَقٌ':Subject, #1: 1	وَهِيَ الْأَخْلَاقُ
u'وَهِيَ أُخُوَّةٌ':Subject, #1: 1	وَهِيَ الْأَخْلَاقُ
u'وَهِيَ إِخْوَةٌ':Subject, #1: 1	وَهِيَ أُخُوَّةُ
u'وَهِيَ أُخُوَّةٌ':Subject, #1: 1	وَهِيَ الْإِخْوَةُ
u'وَهِيَ أَخِيرٌ':Subject, #2: 2	وَهِيَ الْأُخُوَّةُ
u'وَهِيَ أَدَاءٌ':Subject, #2: 2	وَهِيَ الْأَخِيرَةُ
u'وَهِيَ أَدَاءٌ':Subject, #1: 1	وَهِيَ أَدَاءٌ
u'وَهِيَ أَدَاءٌ':Subject, #1: 1	وَهِيَ الْأَدَاءُ
u'وَهِيَ آدابٌ':Subject, #2: 2	وَهِيَ أَدَاءُ
u'وَهِيَ اِدِّعَاءٌ':Subject, #1: 1	وَهِيَ الْآدَابُ
u'وَهِيَ أدْعِيَةٌ':Subject, #1: 1	وَهِيَ ادِّعَاءُ
u'وَهِيَ إِدْلاَءٌ':Subject, #1: 1	وَهِيَ الْأَدْعِيَةُ
u'وَهِيَ آدَمِيٌّ':Subject, #1: 1	وَهِيَ الْإِدْلَاءُ
u'وَهِيَ أَدْوِيَةٌ':Subject, #1: 1	وَهِيَ الْآدَمِيَّةُ
u'وَهِيَ أَدْوِيَةٌ':Subject, #1: 1	وَهِيَ أَدْوِيَةٌ
u'وَهِيَ أَذَانٌ':Subject, #1: 1	وَهِيَ الْأَدْوِيَةُ
u'وَهِيَ إِذْنٌ':Subject, #1: 1	وَهِيَ أَذَانُ
u'وَهِيَ إِذْنٌ':Subject, #1: 1	وَهِيَ إذْنُ
u'وَهِيَ إِرَادَةٌ':Subject, #1: 1	وَهِيَ الْإِذْنُ
u'وَهِيَ إِرَاقَةٌ':Subject, #3: 3	وَهِيَ إرَادَةُ
u'وَهِيَ أَرْبَعُ':Predicate, #1: 1	وَهِيَ إرَاقَةُ
u'وَهَى أَرْبَعُ':Predicate, #1: 1	وَهِيَ أَرْبَعَ
u'وَهِيَ أَرْبَعُ':Subject, #1: 1	وَهِيَ أَرْبَعَ
u'وَهِيَ أَرْبَعُ':Subject, #1: 1	وَهِيَ الْأَرْبَعُ
u'وَهِيَ أَرْبَعَةٌ':Predicate, #7: 7	وَهِيَ أَرْبَعُ
u'وَهَى أَرْبَعَةٌ':Predicate, #1: 1	وَهِيَ أَرْبَعَةَ
u'وَهِيَ أَرْبَعَةٌ':Subject, #1: 1	وَهِيَ أَرْبَعَةَ
u'وَهِيَ أَرْبَعَةٌ':Subject, #13: 13	وَهِيَ أَرْبَعَةُ
u'وَهِيَ أَرْبَعَةٌ':Subject, #2: 2	وَهِيَ الْأَرْبَعَةُ
u'وَهِيَ أَرْجَحُ':Subject, #46: 46	وَهِيَ أَرْبَعَةٌ
u'وَهِيَ أَرْدَأَ':Subject, #2: 2	وَهِيَ أَرْجَحُ
u'وَهِيَ أرْضٌ':Subject, #1: 1	وَهِيَ أَرْدَأُ
u'وَهِيَ أرْضٌ':Subject, #11: 11	وَهِيَ أَرْضٌ
u'وَهِيَ أرْضٌ':Subject, #13: 13	وَهِيَ الْأَرْضُ
u'وَهِيَ أَرْنَبٌ':Subject, #7: 7	وَهِيَ أَرْضُ
u'وَهِيَ أَرْنَبَةٌ':Subject, #1: 1	وَهِيَ أَرْنَبَتُهُ
u'وَهِيَ اِزْدِحَامٌ':Subject, #1: 1	وَهِيَ أَرْنَبَتُهُ
u'وَهِيَ أسْبَابٌ':Subject, #1: 1	وَهِيَ ازْدِحَامُ
u'وَهِيَ أَسْبَابٌ':Subject, #1: 1	وَهِيَ الْأَسْبَابُ
u'وَهِيَ أَسْبَقُ':Subject, #1: 1	وَهِيَ الْأَسْبَابُ
u'وَهِيَ اِسْتِبْدَادٌ':Subject, #1: 1	وَهِيَ أَسْبَقُ
u'وَهِيَ اِسْتِحْقَاقٌ':Subject, #1: 1	وَهِيَ اسْتِبْدَادُهُ
u'وَهِيَ اِسْتِدْراك':Subject, #1: 1	وَهِيَ اسْتِحْقَاقُ
u'وَهِيَ اِسْتِعارَةٌ':Subject, #1: 1	وَهِيَ اسْتِدْرَاكُ
u'وَهِيَ اِسْتِعْمالٌ':Subject, #1: 1	وَهِيَ اسْتِعَارَةُ
u'وَهِيَ اِسْتِعْمالٌ':Subject, #1: 1	وَهِيَ اسْتِعْمَالٌ
u'وَهِيَ اِسْتِكْمالٌ':Subject, #1: 1	وَهِيَ اسْتِعْمَالُ
u'وَهِيَ اِسْتِواءٌ':Subject, #1: 1	وَهِيَ اسْتِكْمَالُ
u'وَهِيَ اِسْتيلاءٌ':Subject, #1: 1	وَهِيَ اسْتِوَاءُ
u'وَهِيَ إِسْراءٌ':Subject, #1: 1	وَهِيَ اسْتِيلَاءُ
u'وَهِيَ إِسْراعٌ':Subject, #1: 1	وَهِيَ الْإِسْرَاءُ
u'وَهِيَ أَسْفَلُ':Subject, #1: 1	وَهِيَ الْإِسْرَاعُ
u'وَهِيَ إِسْقاطٌ':Subject, #1: 1	وَهِيَ أَسْفَلُ
u'وَهِيَ إِسْقاطٌ':Subject, #1: 1	وَهِيَ إسْقَاطُ
u'وَهِيَ إِسْكارٌ':Subject, #1: 1	وَهِيَ الْإِسْقَاطُ
u'وَهِيَ إِسْلامٌ':Subject, #1: 1	وَهِيَ الْإِسْكَارُ
u'وَهِيَ إِسْلامِيُّ':Subject, #3: 3	وَهِيَ الْإِسْلَامُ
u'وَهِيَ أسْلِحَةٌ':Subject, #2: 2	وَهِيَ إسْلَامِيَّةٌ
u'وَهِيَ اِسْمٌ':Subject, #1: 1	وَهِيَ أَسْلِحَةُ
u'وَهِيَ اِسْمٌ':Subject, #16: 16	وَهِيَ اسْمٌ
u'وَهِيَ أَسْماءٌ':Subject, #2: 2	وَهِيَ اسْمُ
u'وَهِيَ أَسْماءٌ':Subject, #1: 1	وَهِيَ الْأَسْمَاءُ
u'وَهِيَ أسْنَانٌ':Subject, #4: 4	وَهِيَ أَسْمَاءُ
u'وَهِيَ أُسْوَةٌ':Subject, #2: 2	وَهِيَ الْأَسْنَانُ
u'وَهِيَ أَسيرٌ':Subject, #1: 1	وَهِيَ أُسْوَةُ
u'وَهِيَ إشارَة':Subject, #1: 1	وَهِيَ الْأَسِيرَةُ
u'وَهِيَ أشْبَهُ':Subject, #1: 1	وَهِيَ الْإِشَارَةُ
u'وَهِيَ اِشْتِراطٌ':Subject, #1: 1	وَهِيَ أَشْبَهُ
u'وَهِيَ اِشْتِمالٌ':Subject, #1: 1	وَهِيَ اشْتِرَاطُ
u'وَهِيَ اِشْتِهارٌ':Subject, #1: 1	وَهِيَ اشْتِمَالُ
u'وَهِيَ أَشْجَارٌ':Subject, #1: 1	وَهِيَ اشْتِهَارُ
u'وَهِيَ أَشَدُّ':Subject, #1: 1	وَهِيَ أَشْجَارٌ
u'وَهِيَ إِشْراكٌ':Subject, #4: 4	وَهِيَ أَشَدُّ
u'وَهِيَ أشرف':Subject, #1: 1	وَهِيَ الْإِشْرَاكُ
u'وَهِيَ أَشْرَفُ':Subject, #3: 3	وَهِيَ أَشْرَفُ
u'وَهِيَ إِشْهارٌ':Subject, #3: 3	وَهِيَ أَشْرَفُ
u'وَهِيَ أشْهَرُ':Subject, #1: 1	وَهِيَ إشْهَارُ
u'وَهِيَ أَشْهُرٌ':Subject, #28: 28	وَهِيَ أَشْهَرُ
u'وَهِيَ أَشْهُرٌ':Subject, #2: 2	وَهِيَ أَشْهُرُ
u'وَهِيَ أشْهَرُ':Subject, #4: 4	وَهِيَ الْأَشْهُرُ
u'وَهِيَ أَشْيَاءٌ':Subject, #5: 5	وَهِيَ الْأَشْهَرُ
u'وَهِيَ أَشْيَاءٌ':Subject, #1: 1	وَهِيَ أَشْيَاءُ
u'وَهِيَ أَصابِعُ':Subject, #1: 1	وَهِيَ الْأَشْيَاءُ
u'وَهِيَ اِصْطِلاحٌ':Subject, #1: 1	وَهِيَ الْأَصَابِعُ
u'وَهِيَ أَصْعَبُ':Subject, #1: 1	وَهِيَ اصْطِلَاحُ
u'وَهِيَ أصْغَرٌ':Subject, #1: 1	وَهِيَ أَصْعَبُ
u'وَهِيَ أَصْغَرُ':Subject, #1: 1	وَهِيَ أَصْغَرُ
u'وَهِيَ أصل':Subject, #1: 1	وَهِيَ أَصْغَرُ
u'وَهِيَ أًصْلٌ':Subject, #4: 4	وَهِيَ أَصْلُ
u'وَهِيَ أًصْلٌ':Subject, #4: 4	وَهِيَ أَصْلُ
u'وَهِيَ أصل':Subject, #6: 6	وَهِيَ أَصْلٌ
u'وَهِيَ أًصْلٌ':Subject, #7: 7	وَهِيَ الْأَصْلُ
u'وَهِيَ أَصْلِيٌّ':Subject, #7: 7	وَهِيَ الْأَصْلُ
u'وَهِيَ أُصولٌ':Subject, #2: 2	وَهِيَ الْأَصْلِيَّةُ
u'وَهِيَ إضافَةٌ':Subject, #2: 2	وَهِيَ أُصُولُ
u'وَهِيَ إضافَةٌ':Subject, #1: 1	وَهِيَ إضَافَةُ
u'وَهِيَ أَضْخَمُ':Subject, #1: 1	وَهِيَ الْإِضَافَةُ
u'وَهِيَ أَضْيَقُ':Subject, #1: 1	وَهِيَ أَضْخَمُ
u'وَهِيَ أَطْباقٌ':Subject, #1: 1	وَهِيَ أَضْيَقُ
u'وَهِيَ أَطْبَاقٌ':Subject, #1: 1	وَهِيَ أَطْبَاقُ
u'وَهِيَ أَطْرافٌ':Subject, #1: 1	وَهِيَ أَطْبَاقُ
u'وَهِيَ أَطْرَافٌ':Subject, #3: 3	وَهِيَ أَطْرَافُ
u'وَهِيَ إِطْعامٌ':Subject, #3: 3	وَهِيَ أَطْرَافُ
u'وَهِيَ إِطْعامٌ':Subject, #1: 1	وَهِيَ إطْعَامُ
u'وَهِيَ إِطْلاقٌ':Subject, #1: 1	وَهِيَ الْإِطْعَامُ
u'وَهِيَ إِطْلاقٌ':Subject, #1: 1	وَهِيَ الْإِطْلَاقُ
u'وَهِيَ أَطْمَاعٌ':Subject, #6: 6	وَهِيَ إطْلَاقُ
u'وَهِيَ أَطْهَارٌ':Subject, #1: 1	وَهِيَ الْأَطْمَاعُ
u'وَهِيَ أَطْوَلُ':Subject, #1: 1	وَهِيَ الْأَطْهَارُ
u'وَهِيَ إِظْهارٌ':Subject, #4: 4	وَهِيَ أَطْوَلُ
u'وَهِيَ أظهر':Subject, #1: 1	وَهِيَ إظْهَارُ
u'وَهِيَ أظهر':Subject, #1: 1	وَهِيَ الْأَظْهَرُ
u'وَهِيَ إِعْتاقٌ':Subject, #54: 54	وَهِيَ أَظْهَرُ
u'وَهِيَ إِعْتاقٌ':Subject, #1: 1	وَهِيَ إعْتَاقٌ
u'وَهِيَ إِعْتاقٌ':Subject, #1: 1	وَهِيَ إعْتَاقُ
u'وَهِيَ اِعْتِبارٌ':Subject, #1: 1	وَهِيَ الْإِعْتَاقُ
u'وَهِيَ أَعْجَميٌّ':Subject, #2: 2	وَهِيَ اعْتِبَارُ
u'وَهِيَ أَعْدَادٌ':Subject, #3: 3	وَهِيَ أَعْجَمِيَّةٌ
u'وَهِيَ أَعْرَاضٌ':Subject, #1: 1	وَهِيَ أَعْدَادٌ
u'وَهِيَ أعَزُّ':Subject, #1: 1	وَهِيَ أَعْرَاضٌ
u'وَهِيَ إعْزَازٌ':Subject, #1: 1	وَهِيَ أَعَزُّ
u'وَهِيَ أَعْضَاءٌ':Subject, #1: 1	وَهِيَ الْإِعْزَازُ
u'وَهِيَ إعْطَاءٌ':Subject, #1: 1	وَهِيَ الْأَعْضَاءُ
u'وَهِيَ أعْظَمُ':Subject, #6: 6	وَهِيَ إعْطَاءُ
u'وَهِيَ إعْلاَمٌ':Subject, #3: 3	وَهِيَ أَعْظَمُ
u'وَهِيَ أَعَمُّ':Subject, #1: 1	وَهِيَ إعْلَامُهُ
u'وَهِيَ أَعْمَالٌ':Subject, #16: 16	وَهِيَ أَعَمُّ
u'وَهِيَ أَعْنَاقٌ':Subject, #1: 1	وَهِيَ الْأَعْمَالُ
u'وَهِيَ إِفْرَادٌ':Subject, #1: 1	وَهِيَ الْأَعْنَاقُ
u'وَهِيَ إِفْرَادٌ':Subject, #1: 1	وَهِيَ إفْرَادُ
u'وَهِيَ إِفْرَازٌ':Subject, #1: 1	وَهِيَ الْإِفْرَادُ
u'وَهِيَ إفْرِيقِي':Subject, #1: 1	وَهِيَ إفْرَازٌ
u'وَهِيَ أفْضَلُ':Subject, #1: 1	وَهِيَ إفْرِيقِيَةُ
u'وَهِيَ أَفْعَالٌ':Subject, #23: 23	وَهِيَ أَفْضَلُ
u'وَهِيَ إفْناءٌ':Subject, #1: 1	وَهِيَ أَفْعَالُ
u'وَهِيَ أقارب':Subject, #1: 1	وَهِيَ إفْنَاءُ
u'وَهِيَ إقالَةٌ':Subject, #1: 1	وَهِيَ أَقَارِبُ
u'وَهِيَ إقالَةٌ':Subject, #1: 1	وَهِيَ إقَالَةُ
u'وَهِيَ إقامَةٌ':Subject, #1: 1	وَهِيَ الْإِقَالَةُ
u'وَهِيَ إقامَةٌ':Subject, #1: 1	وَهِيَ إقَامَةُ
u'وَهِيَ إقْدَامٌ':Subject, #1: 1	وَهِيَ إِقَامَةُ
u'وَهِيَ إقْرَارٌ':Subject, #1: 1	وَهِيَ إقْدَامُهُ
u'وَهِيَ إقْرَارٌ':Subject, #2: 2	وَهِيَ إقْرَارُهُ
u'وَهِيَ أقْرَبُ':Subject, #3: 3	وَهِيَ الْإِقْرَارُ
u'وَهِيَ أقَلُّ':Subject, #3: 3	وَهِيَ أَقْرَبُ
u'وَهِيَ أقَلُّ':Subject, #1: 1	وَهِيَ الْأَقَلُّ
u'وَهِيَ إقْلاعٌ':Subject, #9: 9	وَهِيَ أَقَلُّ
u'وَهِيَ أَقْلاَمٌ':Subject, #1: 1	وَهِيَ الْإِقْلَاعُ
u'وَهِيَ أَقْوَالٌ':Subject, #1: 1	وَهِيَ الْأَقْلَامُ
u'وَهِيَ أكْبَرُ':Subject, #2: 2	وَهِيَ أَقْوَالٌ
u'وَهِيَ أَكْثَرُ':Subject, #4: 4	وَهِيَ أَكْبَرُ
u'وَهِيَ أَكْثَرُ':Subject, #10: 10	وَهِيَ أَكْثَرُ
u'وَهِيَ أَكْثَرُ':Subject, #1: 1	وَهِيَ أَكْثَرُهُ
u'وَهِيَ أَكْسِيَةٌ':Subject, #1: 1	وَهِيَ الْأَكْثَرُ
u'وَهِيَ أكل':Subject, #1: 1	وَهِيَ الْأَكْسِيَةُ
u'وَهِيَ أَكْلٌ':Subject, #3: 3	وَهِيَ الْأَكْلُ
u'وَهِيَ أَكَمَةٌ':Subject, #3: 3	وَهِيَ الْأَكْلُ
u'وَهِيَ آلةٌ':Subject, #1: 1	وَهِيَ الْأَكَمَةُ
u'وَهِيَ آلةٌ':Subject, #1: 1	وَهِيَ آلَةُ
u'وَهِيَ آلةٌ':Subject, #2: 2	وَهِيَ الْآلَةُ
u'وَهِيَ اِلْتِزَامٌ':Subject, #2: 2	وَهِيَ آلَةٌ
u'وَهِيَ اِلْتِقَاءٌ':Subject, #2: 2	وَهِيَ الْتِزَامُ
u'وَهِيَ اِلْتِمَاسٌ':Subject, #1: 1	وَهِيَ الْتِقَاءُ
u'وَهِيَ إلْحَاقٌ':Subject, #2: 2	وَهِيَ الْتِمَاسُ
u'وَهِيَ ألْفٌ':Subject, #1: 1	وَهِيَ إلْحَاقُ
u'وَهِيَ أَلْفٌ':Subject, #15: 15	وَهِيَ أَلْفٌ
u'وَهِيَ ألف':Subject, #15: 15	وَهِيَ أَلْفٌ
u'وَهِيَ ألف':Subject, #1: 1	وَهِيَ الْأَلِفُ
u'وَهِيَ ألْفٌ':Subject, #3: 3	وَهِيَ الْأَلْفُ
u'وَهِيَ أَلْفٌ':Subject, #3: 3	وَهِيَ الْأَلْفُ
u'وَهِيَ ألف':Subject, #3: 3	وَهِيَ الْأَلْفُ
u'وَهِيَ ألْفٌ':Subject, #5: 5	وَهِيَ أَلْفُ
u'وَهِيَ أَلْفٌ':Subject, #5: 5	وَهِيَ أَلْفُ
u'وَهِيَ أَلْفَاظٌ':Subject, #5: 5	وَهِيَ أَلْفُ
u'وَهِيَ أُلْفَةٌ':Subject, #3: 3	وَهِيَ أَلْفَاظٌ
u'وَهِيَ الْمَرْأَةُ':Subject, #1: 1	وَهِيَ الْأُلْفَةُ
u'وَهِيَ أَلْوَاحٌ':Subject, #5: 5	وَهِيَ الْمَرْأَةُ
u'وَهِيَ أَلْوَانٌ':Subject, #1: 1	وَهِيَ أَلْوَاحُهُ
u'وَهِيَ أُمٌّ':Subject, #1: 1	وَهِيَ أَلْوَانٌ
u'وَهِيَ أُمٌّ':Subject, #4: 4	وَهِيَ أُمٌّ
u'وَهِيَ أُمٌّ':Subject, #4: 4	وَهِيَ أُمّهُ
u'وَهِيَ أُمٌّ':Subject, #4: 4	وَهِيَ أُمُّهُ
u'وَهِيَ أُمٌّ':Subject, #52: 52	وَهِيَ أُمُّ
u'وَهِيَ إمَارَةٌ':Subject, #7: 7	وَهِيَ الْأُمُّ
u'وَهِيَ أمَارَةٌ':Subject, #1: 1	وَهِيَ إمَارَةُ
u'وَهِيَ أمَانَةٌ':Subject, #2: 2	وَهِيَ أَمَارَةُ
u'وَهِيَ أُمَّةٌ':Subject, #8: 8	وَهِيَ أَمَانَةٌ
u'وَهِيَ أمَةٌ':Subject, #1: 1	وَهِيَ الْأُمَّةُ
u'وَهِيَ أمَةٌ':Subject, #1: 1	وَهِيَ أَمَتُهُ
u'وَهِيَ أمَةٌ':Subject, #3: 3	وَهِيَ الْأَمَةُ
u'وَهِيَ أمَةٌ':Subject, #4: 4	وَهِيَ أَمَةُ
u'وَهِيَ اِمْتِثَالٌ':Subject, #50: 50	وَهِيَ أَمَةٌ
u'وَهِيَ اِمْتِناعٌ':Subject, #1: 1	وَهِيَ امْتِثَالُ
u'وَهِيَ أَمْثَلُ':Subject, #1: 1	وَهِيَ امْتِنَاعُ
u'وَهِيَ أَمْرٌ':Subject, #2: 2	وَهِيَ أَمْثَلُ
u'وَهِيَ أَمْرٌ':Subject, #2: 2	وَهِيَ أَمْرٌ
u'وَهِيَ اِمْرَأَةٌ':Subject, #5: 5	وَهِيَ الْأَمْرُ
u'وَهِيَ اِمْرَأَةٌ':Subject, #12: 12	وَهِيَ امْرَأَةُ
u'وَهِيَ اِمْرَأَةٌ':Subject, #13: 13	وَهِيَ امْرَأَةٌ
u'وَهِيَ إِمْساكٌ':Subject, #14: 14	وَهِيَ امْرَأَتُهُ
u'وَهِيَ إِمْكانٌ':Subject, #2: 2	وَهِيَ إمْسَاكُ
u'وَهِيَ إِمْكانٌ':Subject, #1: 1	وَهِيَ الْإِمْكَانُ
u'وَهِيَ أُمَّهَاتٌ':Subject, #2: 2	وَهِيَ إمْكَانُ
u'وَهِيَ أَمْوَالٌ':Subject, #1: 1	وَهِيَ أُمَّهَاتُ
u'وَهِيَ أُمُورٌ':Subject, #2: 2	وَهِيَ أَمْوَالُ
u'وَهِيَ أُمُورٌ':Subject, #2: 2	وَهِيَ أُمُورٌ
u'وَهِيَ أَنْبَازٌ':Subject, #3: 3	وَهِيَ الْأُمُورُ
u'وَهِيَ أَنْسَبُ':Subject, #1: 1	وَهِيَ الْأَنْبَازُ
u'وَهِيَ إِنْعامٌ':Subject, #1: 1	وَهِيَ أَنْسَبُ
u'وَهِيَ أَنْفَسُ':Subject, #1: 1	وَهِيَ الْإِنْعَامُ
u'وَهِيَ أَنْفَعُ':Subject, #1: 1	وَهِيَ أَنْفَسُ
u'وَهِيَ اِنْقِضاءٌ':Subject, #2: 2	وَهِيَ أَنْفَعُ
u'وَهِيَ اِنْقِطاعٌ':Subject, #1: 1	وَهِيَ انْقِضَاءُ
u'وَهِيَ أَنْوَاعٌ':Subject, #1: 1	وَهِيَ انْقِطَاعُ
u'وَهِيَ اِهْتِدَاءٌ':Subject, #8: 8	وَهِيَ أَنْوَاعٌ
u'وَهِيَ أهْلٌ':Subject, #1: 1	وَهِيَ اهْتِدَاءُ
u'وَهِيَ أهْلٌ':Subject, #1: 1	وَهِيَ أَهْلُ
u'وَهِيَ أَهِلَّةٌ':Subject, #4: 4	وَهِيَ أَهْلٌ
u'وَهِيَ أَهْلِيٌّ':Subject, #1: 1	وَهِيَ الْأَهِلَّةُ
u'وَهِيَ أهْلِيَّةٌ':Subject, #1: 1	وَهِيَ أَهْلِيَّةُ
u'وَهِيَ إهْمَالٌ':Subject, #1: 1	وَهِيَ أَهْلِيَّةُ
u'وَهِيَ إهْمَالٌ':Subject, #1: 1	وَهِيَ الْإِهْمَالُ
u'وَهِيَ أَوْثَانٌ':Subject, #1: 1	وَهِيَ إهْمَالٌ
u'وَهِيَ أوْجَهُ':Subject, #1: 1	وَهِيَ الْأَوْثَانُ
u'وَهِيَ أوْضَحُ':Subject, #1: 1	وَهِيَ أَوْجَهُ
u'وَهِيَ أَوْعِيَةٌ':Subject, #4: 4	وَهِيَ أَوْضَحُ
u'وَهِيَ أَوْقَاتٌ':Subject, #1: 1	وَهِيَ أَوْعِيَةُ
u'وَهِيَ أَوَّلُ':Subject, #1: 1	وَهِيَ أَوْقَاتُ
u'وَهِيَ أَوَّلُ':Subject, #22: 22	وَهِيَ أَوَّلُ
u'وَهِيَ أَوَّلُ':Subject, #2: 2	وَهِيَ أَوَّلُهُ
u'وَهِيَ أَوْلاَدٌ':Subject, #9: 9	وَهِيَ أَوّلُ
u'وَهِيَ أَوَّلِيٌّ':Subject, #4: 4	وَهِيَ أَوْلَادُ
u'وَهِيَ أئِمَّةٌ':Subject, #1: 1	وَهِيَ الْأَوَّلِيَّةُ
u'وَهِيَ أيَّامٌ':Subject, #1: 1	وَهِيَ الْأَئِمَّةُ
u'وَهِيَ أَيَّامٌ':Subject, #14: 14	وَهِيَ أَيَّامُ
u'وَهِيَ أيَّامٌ':Subject, #14: 14	وَهِيَ أَيَّامُ
u'وَهِيَ أَيَّامٌ':Subject, #1: 1	وَهِيَ الْأَيَّامُ
u'وَهِيَ أيَّامٌ':Subject, #1: 1	وَهِيَ الْأَيَّامُ
u'وَهِيَ أَيَّامٌ':Subject, #1: 1	وَهِيَ أَيّامُ
u'وَهِيَ آيَةٌ':Subject, #1: 1	وَهِيَ أَيّامُ
u'وَهِيَ آيَةٌ':Subject, #4: 4	وَهِيَ آيَةُ
u'وَهِيَ آيَةٌ':Subject, #6: 6	وَهِيَ آيَةٌ
u'وَهِيَ إيصَالٌ':Subject, #8: 8	وَهِيَ الْآيَةُ
u'وَهِيَ إيقَاعٌ':Subject, #1: 1	وَهِيَ إيصَالُ
u'وَهِيَ أَيْمَانٌ':Subject, #2: 2	وَهِيَ إيقَاعُ
u'وَهِيَ إيمَانٌ':Subject, #1: 1	وَهِيَ أَيْمَانٌ
u'وَهِيَ أَيْمَانٌ':Subject, #1: 1	وَهِيَ إيمَانُ
u'وَهِيَ باء':Subject, #2: 2	وَهِيَ الْأَيْمَانُ
u'وَهِيَ بابِلُ':Subject, #1: 1	وَهِيَ الْبَاءُ
u'وَهِيَ بادِي':Subject, #1: 1	وَهِيَ بَابِلُ
u'وَهِيَ بَادِيَةٌ':Subject, #1: 1	وَهِيَ بَادِيَةٌ
u'وَهِيَ باذِلٌ':Subject, #1: 1	وَهِيَ بَادِيَةٌ
u'وَهِيَ بَارِدٌ':Subject, #1: 1	وَهِيَ بَاذِلَةٌ
u'وَهِيَ بَاطِلٌ':Subject, #2: 2	وَهِيَ بَارِدَةٌ
u'وَهِيَ باقِي':Subject, #6: 6	وَهِيَ بَاطِلَةٌ
u'وَهِيَ باقِي':Subject, #1: 1	وَهِيَ الْبَاقِيَةُ
u'وَهِيَ باقِيَةٌ':Subject, #20: 20	وَهِيَ بَاقِيَةٌ
u'وَهِيَ باقِيَةٌ':Subject, #1: 1	وَهِيَ الْبَاقِيَةُ
u'وَهِيَ بالِغٌ':Subject, #20: 20	وَهِيَ بَاقِيَةٌ
u'وَهِيَ بالِغٌ':Subject, #2: 2	وَهِيَ الْبَالِغَةُ
u'وَهِيَ بَائِعٌ':Subject, #5: 5	وَهِيَ بَالِغَةٌ
u'وَهِيَ بَائِنٌ':Subject, #1: 1	وَهِيَ الْبَائِعُ
u'وَهِيَ بَائِنٌ':Subject, #2: 2	وَهِيَ بَائِنَةٌ
u'وَهِيَ بِحارٌ':Subject, #7: 7	وَهِيَ بَائِنٌ
u'وَهِيَ بُخْلٌ':Subject, #1: 1	وَهِيَ الْبِحَارُ
u'وَهِيَ بِدَايَةٌ':Subject, #1: 1	وَهِيَ الْبُخْلُ
u'وَهِيَ بِدَعٌ':Subject, #1: 1	وَهِيَ الْبِدَايَةُ
u'وَهِيَ بِدْعَةٌ':Subject, #2: 2	وَهِيَ الْبِدَعُ
u'وَهِيَ بدعيٌّ':Subject, #4: 4	وَهِيَ بِدْعَةٌ
u'وَهِيَ بَدَلٌ':Subject, #1: 1	وَهِيَ بِدْعِيَّةٌ
u'وَهِيَ بَدَلٌ':Subject, #2: 2	وَهِيَ بَدَلٌ
u'وَهِيَ بدنة':Subject, #2: 2	وَهِيَ بَدَلُ
u'وَهِيَ بدنة':Subject, #1: 1	وَهِيَ الْبَدَنَةُ
u'وَهِيَ بَذْرٌ':Subject, #2: 2	وَهِيَ بَدَنَةٌ
u'وَهِيَ بَذْلٌ':Subject, #3: 3	وَهِيَ بَذْرٌ
u'وَهِيَ بَراءةٌ':Subject, #2: 2	وَهِيَ بَذْلُ
u'وَهِيَ بَرْدَعَة':Subject, #1: 1	وَهِيَ الْبَرَاءَةُ
u'وَهِيَ برزة':Subject, #1: 1	وَهِيَ الْبَرْدَعِيَّةُ
u'وَهِيَ بِرْسِيم':Subject, #2: 2	وَهِيَ بَرْزَةٌ
u'وَهِيَ بَرَكَةٌ':Subject, #1: 1	وَهِيَ الْبِرْسِيمُ
u'وَهِيَ بَرِيَّةٌ':Subject, #1: 1	وَهِيَ بَرَكَةُ
u'وَهِيَ بَشِم':Subject, #1: 1	وَهِيَ بَرِيَّةٌ
u'وَهِيَ بَصيرَةٌ':Subject, #1: 1	وَهِيَ الْبَشِمَةُ
u'وَهِيَ بَطائِقُ':Subject, #3: 3	وَهِيَ بَصِيرَةٌ
u'وَهِيَ بَطْش':Subject, #1: 1	وَهِيَ الْبَطَائِقُ
u'وَهِيَ بَطْشٌ':Subject, #1: 1	وَهِيَ الْبَطْشَةُ
u'وَهِيَ بَطْشَة':Subject, #2: 2	وَهِيَ الْبَطْشُ
u'وَهِيَ بَطْنٌ':Subject, #1: 1	وَهِيَ الْبَطْشَةُ
u'وَهِيَ بَعْثٌ':Subject, #1: 1	وَهِيَ بَطْنٌ
u'وَهِيَ بَعْض':Subject, #1: 1	وَهِيَ الْبَعْثُ
u'وَهِيَ بَعْضٌ':Subject, #1: 1	وَهِيَ الْبَعْضِيَّةُ
u'وَهَى بَعْضٌ':Subject, #1: 1	وَهِيَ بَعْضُهُ
u'وَهِيَ بَعْضٌ':Subject, #1: 1	وَهَى بَعْضُهُ
u'وَهِيَ بَقاءٌ':Subject, #3: 3	وَهِيَ بَعْضُ
u'وَهِيَ بِقاعٌ':Subject, #1: 1	وَهِيَ بَقَاءُ
u'وَهِيَ بَقَرٌ':Subject, #2: 2	وَهِيَ الْبِقَاعُ
u'وَهِيَ بَقِيَّةٌ':Subject, #2: 2	وَهِيَ الْبَقَرُ
u'وَهِيَ بَقِيَّةٌ':Subject, #1: 1	وَهِيَ بَقِيّةُ
u'وَهِيَ بَكارَةٌ':Subject, #4: 4	وَهِيَ بَقِيَّةُ
u'وَهِيَ بِكْرٌ':Subject, #2: 2	وَهِيَ الْبَكَارَةُ
u'وَهِيَ بَكَرَةٌ':Subject, #49: 49	وَهِيَ بِكْرٌ
u'وَهِيَ بِلادٌ':Subject, #1: 1	وَهِيَ الْبَكَرَةُ
u'وَهِيَ بِلادٌ':Subject, #1: 1	وَهِيَ الْبِلَادُ
u'وَهِيَ بَلَدٌ':Subject, #1: 1	وَهِيَ بِلَادٌ
u'وَهِيَ بُلُوغٌ':Subject, #1: 1	وَهِيَ بَلَدُ
u'وَهِيَ بِنَاءٌ':Subject, #2: 2	وَهِيَ بُلُوغُ
u'وَهِيَ بِنَاءٌ':Subject, #1: 1	وَهِيَ بِنَاءٌ
u'وَهِيَ بِنَاءٌ':Subject, #3: 3	وَهِيَ الْبِنَاءُ
u'وَهِيَ بناتٌ':Subject, #4: 4	وَهِيَ بِنَاءُ
u'وَهِيَ بِنْتٌ':Subject, #3: 3	وَهِيَ بَنَاتُ
u'وَهِيَ بِنْتٌ':Subject, #1: 1	وَهِيَ الْبِنْتُ
u'وَهِيَ بِنْتٌ':Subject, #1: 1	وَهِيَ بِنْتٌ
u'وَهِيَ بِنْصِرٌ':Subject, #60: 60	وَهِيَ بِنْتُ
u'وَهِيَ بُنُوَّة':Subject, #1: 1	وَهِيَ الْبِنْصِرُ
u'وَهِيَ بُومٌ':Subject, #2: 2	وَهِيَ بُنُوَّةُ
u'وَهِيَ بِئْرٌ':Subject, #1: 1	وَهِيَ الْبُومُ
u'وَهِيَ بِئْرٌ':Subject, #5: 5	وَهِيَ بِئْرٌ
u'وَهِيَ بِئْرٌ':Subject, #6: 6	وَهِيَ الْبِئْرُ
u'وَهِيَ بَيَاضٌ':Subject, #9: 9	وَهِيَ بِئْرُ
u'وَهِيَ بَيَاضٌ':Subject, #1: 1	وَهِيَ الْبَيَاضُ
u'وَهِيَ بَيَانٌ':Subject, #2: 2	وَهِيَ بَيَاضٌ
u'وَهِيَ بَيَانٌ':Subject, #1: 1	وَهِيَ بَيَانُ
u'وَهِيَ بَيْتٌ':Subject, #2: 2	وَهِيَ بَيَانٌ
u'وَهِيَ بَيْتٌ':Subject, #1: 1	وَهِيَ الْبَيْتُ
u'وَهِيَ بَيْضاء':Subject, #2: 2	وَهِيَ بَيْتُ
u'وَهِيَ بَيْضَةٌ':Subject, #5: 5	وَهِيَ بَيْضَاءُ
u'وَهِيَ بَيْعٌ':Subject, #2: 2	وَهِيَ بَيْضَةُ
u'وَهِيَ بَيْعٌ':Subject, #1: 1	وَهِيَ الْبَيْعُ
u'وَهِيَ بَيْعٌ':Subject, #22: 22	وَهِيَ بَيْعُ
u'وَهِيَ بَيْنٌ':Predicate, #3: 3	وَهِيَ بَيْعٌ
u'وَهَى بَيْنٌ':Predicate, #15: 15	وَهِيَ بَيْنَ
u'وَهِيَ بَيِّنَةٌ':Subject, #15: 15	وَهِيَ بَيْنَ
u'وَهِيَ بَيِّنَةٌ':Subject, #1: 1	وَهِيَ بَيِّنَةُ
u'وَهِيَ بُيُوتٌ':Subject, #5: 5	وَهِيَ الْبَيِّنَةُ
u'وَهِيَ بيوع':Subject, #2: 2	وَهِيَ بُيُوتٌ
u'وَهِيَ تَابِعٌ':Subject, #2: 2	وَهِيَ بُيُوعُ
u'وَهِيَ تَابِعٌ':Subject, #1: 1	وَهِيَ التَّابِعُ
u'وَهِيَ تَابِعٌ':Subject, #1: 1	وَهِيَ التَّابِعَةُ
u'وَهِيَ تَأْثِيرٌ':Subject, #3: 3	وَهِيَ تَابِعَةٌ
u'وَهِيَ تَأَخُّرٌ':Subject, #1: 1	وَهِيَ التَّأْثِيرُ
u'وَهِيَ تَأْخِيرٌ':Subject, #2: 2	وَهِيَ التَّأَخُّرُ
u'وَهِيَ تَأْخِيرٌ':Subject, #1: 1	وَهِيَ التَّأْخِيرُ
u'وَهِيَ تَأَدُّبٌ':Subject, #1: 1	وَهِيَ تَأْخِيرُ
u'وَهِيَ تَأْكِيدٌ':Subject, #1: 1	وَهِيَ التَّأَدُّبُ
u'وَهِيَ تالِف':Subject, #1: 1	وَهِيَ تَأْكِيدٌ
u'وَهِيَ تَامٌّ':Subject, #4: 4	وَهِيَ تَالِفَةٌ
u'وَهِيَ تَبَايُنٌ':Subject, #2: 2	وَهِيَ تَامَّةٌ
u'وَهِيَ تَبْدِيلٌ':Subject, #1: 1	وَهِيَ تَبَايُنُ
u'وَهِيَ تَبَرُّعٌ':Subject, #1: 1	وَهِيَ التَّبْدِيلُ
u'وَهِيَ تَبَع':Subject, #1: 1	وَهِيَ تَبَرُّعُ
u'وَهِيَ تَتَابُعٌ':Subject, #2: 2	وَهِيَ تَبَعٌ
u'وَهِيَ تَتِمَّةٌ':Subject, #1: 1	وَهِيَ التَّتَابُعُ
u'وَهِيَ تَثْلِيثٌ':Subject, #1: 1	وَهِيَ تَتِمَّةُ
u'وَهِيَ تَثْنِيَةٌ':Subject, #1: 1	وَهِيَ التَّثْلِيثُ
u'وَهِيَ تَثْنِيَةٌ':Subject, #1: 1	وَهِيَ التَّثْنِيَةُ
u'وَهِيَ تَثْنِيَةٌ':Subject, #1: 1	وَهِيَ تَثْنِيَةٌ
u'وَهِيَ تِجَارَةٌ':Subject, #1: 1	وَهِيَ تَثْنِيَةُ
u'وَهِيَ تَجْدِيدٌ':Subject, #1: 1	وَهِيَ التِّجَارَةُ
u'وَهِيَ تَجْرِبَةٌ':Subject, #1: 1	وَهِيَ تَجْدِيدُ
u'وَهِيَ تَجَرُّدٌ':Subject, #1: 1	وَهِيَ التَّجْرِبَةُ
u'وَهِيَ تَحَتُّمٌ':Subject, #1: 1	وَهِيَ التَّجَرُّدُ
u'وَهِيَ تَحْجِيرٌ':Subject, #1: 1	وَهِيَ تَحَتُّمُ
u'وَهِيَ تَحْذِيرٌ':Subject, #1: 1	وَهِيَ تَحْجِيرُ
u'وَهِيَ تَحَرُّكٌ':Subject, #1: 1	وَهِيَ التَّحْذِيرُ
u'وَهِيَ تَحْرِيرٌ':Subject, #1: 1	وَهِيَ تَحَرُّكُ
u'وَهِيَ تَحْرِيمٌ':Subject, #1: 1	وَهِيَ تَحْرِيرُ
u'وَهِيَ تَحْصِيلٌ':Subject, #2: 2	وَهِيَ تَحْرِيمُ
u'وَهِيَ تَحَقُّقٌ':Subject, #2: 2	وَهِيَ تَحْصِيلُ
u'وَهِيَ تَحْقِيقٌ':Subject, #2: 2	وَهِيَ تَحَقُّقُ
u'وَهِيَ تَخْرِيجٌ':Subject, #3: 3	وَهِيَ تَحْقِيقُ
u'وَهِيَ تَخْرِيجٌ':Subject, #1: 1	وَهِيَ تَخْرِيجُ
u'وَهِيَ تَخْصِيصٌ':Subject, #2: 2	وَهِيَ تَخْرِيجٌ
u'وَهِيَ تَخْفِيفٌ':Subject, #1: 1	وَهِيَ تَخْصِيصُ
u'وَهِيَ تَدْبِيرٌ':Subject, #1: 1	وَهِيَ التَّخْفِيفُ
u'وَهِيَ تُرَابٌ':Subject, #1: 1	وَهِيَ التَّدْبِيرُ
u'وَهِيَ تُرَاثٌ':Subject, #1: 1	وَهِيَ التُّرَابُ
u'وَهِيَ تَرْجَمَةٌ':Subject, #1: 1	وَهِيَ تُرَاثٌ
u'وَهِيَ تَرْكٌ':Subject, #1: 1	وَهِيَ تَرْجَمَةُ
u'وَهِيَ تَزَوُّجٌ':Subject, #4: 4	وَهِيَ تَرْكُ
u'وَهِيَ تَسَبُّبٌ':Subject, #1: 1	وَهِيَ التَّزَوُّجُ
u'وَهِيَ تِسْعَةٌ':Subject, #1: 1	وَهِيَ التَّسَبُّبُ
u'وَهِيَ تِسْعَةٌ':Subject, #1: 1	وَهِيَ تِسْعَةُ
u'وَهِيَ تَسْلِيَةٌ':Subject, #3: 3	وَهِيَ تِسْعَةٌ
u'وَهِيَ تَسْمِيَة':Subject, #1: 1	وَهِيَ التَّسْلِيَةُ
u'وَهِيَ تَشَبُّه':Subject, #3: 3	وَهِيَ تَسْمِيَةُ
u'وَهِيَ تَشَبُّهٌ':Subject, #2: 2	وَهِيَ التَّشَبُّهُ
u'وَهِيَ تَشْبِيهٌ':Subject, #2: 2	وَهِيَ تَشَبُّهُ
u'وَهِيَ تَشْرِيعٌ':Subject, #1: 1	وَهِيَ تَشْبِيهُ
u'وَهِيَ تَصْدِيقٌ':Subject, #1: 1	وَهِيَ التَّشْرِيعُ
u'وَهِيَ تَصْدِيقٌ':Subject, #1: 1	وَهِيَ التَّصْدِيقُ
u'وَهِيَ تَصَرُّفٌ':Subject, #1: 1	وَهِيَ تَصْدِيقٌ
u'وَهِيَ تَصْغِيرٌ':Subject, #1: 1	وَهِيَ التَّصَرُّفَاتُ
u'وَهِيَ تَصْمِيمٌ':Subject, #2: 2	وَهِيَ تَصْغِيرُ
u'وَهِيَ تَضْيِيعٌ':Subject, #1: 1	وَهِيَ التَّصْمِيمُ
u'وَهِيَ تَطْلِيقٌ':Subject, #1: 1	وَهِيَ تَضْيِيعُ
u'وَهِيَ تَطْلِيقٌ':Subject, #1: 1	وَهِيَ التَّطْلِيقُ
u'وَهِيَ تَطْهِيرٌ':Subject, #1: 1	وَهِيَ تَطْلِيقُ
u'وَهِيَ تَعَدُّدٌ':Subject, #1: 1	وَهِيَ التَّطْهِيرُ
u'وَهِيَ تَعَدُّدٌ':Subject, #1: 1	وَهِيَ التَّعَدُّدُ
u'وَهِيَ تَعْدِيد':Subject, #3: 3	وَهِيَ تَعَدُّدُ
u'وَهِيَ تَعْرِيفٌ':Subject, #1: 1	وَهِيَ تَعْدِيدُ
u'وَهِيَ تَعْقِيبٌ':Subject, #1: 1	وَهِيَ التَّعْرِيفُ
u'وَهِيَ تَعَلُّقٌ':Subject, #1: 1	وَهِيَ التَّعْقِيبُ
u'وَهِيَ تَعَلُّقٌ':Subject, #2: 2	وَهِيَ تَعَلُّقٌ
u'وَهِيَ تَعْلِيقٌ':Subject, #2: 2	وَهِيَ تَعَلُّقُ
u'وَهِيَ تَعْلِيلٌ':Subject, #1: 1	وَهِيَ تَعْلِيقُ
u'وَهِيَ تَعْلِيمٌ':Subject, #1: 1	وَهِيَ تَعْلِيلٌ
u'وَهِيَ تَعْمِيمٌ':Subject, #1: 1	وَهِيَ تَعْلِيمٌ
u'وَهِيَ تَعَيُّنٌ':Subject, #1: 1	وَهِيَ التَّعْمِيمُ
u'وَهِيَ تَعْيِينٌ':Subject, #1: 1	وَهِيَ التَّعَيُّنُ
u'وَهِيَ تَغَايُرٌ':Subject, #1: 1	وَهِيَ التَّعْيِينُ
u'وَهِيَ تَغْطِيَةٌ':Subject, #1: 1	وَهِيَ تَغَايُرُ
u'وَهِيَ تَغْطِيَةٌ':Subject, #1: 1	وَهِيَ التّغْطِيَةُ
u'وَهِيَ تَغَوُّطٌ':Subject, #1: 1	وَهِيَ تَغْطِيَةُ
u'وَهِيَ تَغْيِيبٌ':Subject, #1: 1	وَهِيَ التَّغَوُّطُ
u'وَهِيَ تَفْرِيجٌ':Subject, #2: 2	وَهِيَ تَغْيِيبُ
u'وَهِيَ تَقَدُّمٌ':Predicate, #1: 1	وَهِيَ تَفْرِيجُ
u'وَهَى تَقَدُّمٌ':Predicate, #1: 1	وَهِيَ تَقَدُّمَ
u'وَهِيَ تَقْسيطٌ':Subject, #1: 1	وَهِيَ تَقَدُّمَ
u'وَهِيَ تَقْليبٌ':Subject, #1: 1	وَهِيَ تَقْسِيطُهُ
u'وَهِيَ تَقْليدٌ':Subject, #1: 1	وَهِيَ تَقْلِيبُ
u'وَهِيَ تَقْليد':Subject, #1: 1	وَهِيَ تَقْلِيدُهُ
u'وَهِيَ تَقْيِيد':Subject, #1: 1	وَهِيَ تَقْلِيدُهُ
u'وَهِيَ تَكْثيرٌ':Subject, #1: 1	وَهِيَ التَّقْيِيدُ
u'وَهِيَ تَلٌّ':Subject, #1: 1	وَهِيَ تَكْثِيرُ
u'وَهِيَ تَلَبُّسٌ':Subject, #1: 1	وَهِيَ التَّلُّ
u'وَهِيَ تَلَفُّظٌ':Subject, #1: 1	وَهِيَ تَلَبُّسُهُ
u'وَهِيَ تَلْويثٌ':Subject, #1: 1	وَهِيَ تَلَفُّظُ
u'وَهِيَ تمام':Subject, #1: 1	وَهِيَ التَّلْوِيثُ
u'وَهِيَ تَمامٌ':Subject, #1: 1	وَهِيَ تَمَامٌ
u'وَهِيَ تمام':Subject, #1: 1	وَهِيَ تَمَامٌ
u'وَهِيَ تَمامٌ':Subject, #2: 2	وَهِيَ تَمَامُ
u'وَهِيَ تَمَلُّكٌ':Subject, #2: 2	وَهِيَ تَمَامُ
u'وَهِيَ تَمْلِيك':Subject, #2: 2	وَهِيَ تَمَلُّكُ
u'وَهِيَ تَمْلِيكٌ':Subject, #1: 1	وَهِيَ التَّمْلِيكُ
u'وَهِيَ تَمْلِيكٌ':Subject, #3: 3	وَهِيَ تَمْلِيكٌ
u'وَهِيَ تَمَيُّزٌ':Subject, #3: 3	وَهِيَ تَمْلِيكُ
u'وَهِيَ تَمِيمَةٌ':Subject, #1: 1	وَهِيَ تَمَيُّزُ
u'وَهِيَ تَمِيمَةٌ':Subject, #1: 1	وَهِيَ التَّمِيمَةُ
u'وَهِيَ تَمْييزٌ':Subject, #1: 1	وَهِيَ تَمِيمَةُ
u'وَهِيَ تَنْجِيسٌ':Subject, #1: 1	وَهِيَ تَمْيِيزُ
u'وَهِيَ تَنْزِيه':Subject, #1: 1	وَهِيَ التّنْجِيسُ
u'وَهِيَ تَنْصِيص':Subject, #2: 2	وَهِيَ تَنْزِيهِيَّةٌ
u'وَهِيَ تَنْظِيمٌ':Subject, #1: 1	وَهِيَ التَّنْصِيصُ
u'وَهِيَ تَنْفِيذٌ':Subject, #1: 1	وَهِيَ تَنْظِيمُ
u'وَهِيَ تَنْفِيذٌ':Subject, #1: 1	وَهِيَ تَنْفِيذٌ
u'وَهِيَ تَنْفِيقٌ':Subject, #1: 1	وَهِيَ تَنْفِيذُ
u'وَهِيَ تَوْبَةٌ':Subject, #1: 1	وَهِيَ التَّنْفِيقُ
u'وَهِيَ تَوْبَةٌ':Subject, #1: 1	وَهِيَ تَوْبَةُ
u'وَهِيَ تَوَجُّهٌ':Subject, #2: 2	وَهِيَ التَّوْبَةُ
u'وَهِيَ تَوْرَاةٌ':Subject, #1: 1	وَهِيَ تَوَجُّهُ
u'وَهِيَ تَوْظِيفٌ':Subject, #1: 1	وَهِيَ تَوْرَاةٌ
u'وَهِيَ تَوْفِيقٌ':Subject, #1: 1	وَهِيَ تَوْظِيفُ
u'وَهِيَ تَوَقُّعٌ':Subject, #1: 1	وَهِيَ تَوْفِيقُهُ
u'وَهِيَ تَوْكِيلٌ':Subject, #1: 1	وَهِيَ تَوَقُّعُ
u'وَهِيَ تَيامُنٌ':Subject, #2: 2	وَهِيَ تَوْكِيلٌ
u'وَهِيَ تَيَقُّنٌ':Subject, #1: 1	وَهِيَ التَّيَامُنُ
u'وَهِيَ تَيَمُّمٌ':Subject, #1: 1	وَهِيَ تَيَقُّنُ
u'وَهِيَ ثَابِتٌ':Subject, #1: 1	وَهِيَ التَّيَمُّمُ
u'وَهِيَ ثَابِتٌ':Subject, #13: 13	وَهِيَ ثَابِتَةٌ
u'وَهِيَ ثابتة':Subject, #2: 2	وَهِيَ الثَّابِتَةُ
u'وَهِيَ ثابتة':Subject, #13: 13	وَهِيَ ثَابِتَةٌ
u'وَهِيَ ثَالِثٌ':Predicate, #2: 2	وَهِيَ الثَّابِتَةُ
u'وَهَى ثَالِثٌ':Predicate, #1: 1	وَهِيَ الثَّالِثَةَ
u'وَهِيَ ثَالِثٌ':Subject, #1: 1	وَهِيَ الثَّالِثَةَ
u'وَهِيَ ثَالِثٌ':Subject, #1: 1	وَهِيَ ثَالِثَةٌ
u'وَهِيَ ثَالِثٌ':Subject, #1: 1	وَهِيَ ثَالِثَةُ
u'وَهِيَ ثَالِثٌ':Subject, #2: 2	وَهِيَ الثَّالِثُ
u'وَهِيَ ثَانِي':Predicate, #8: 8	وَهِيَ الثَّالِثَةُ
u'وَهَى ثَانِي':Predicate, #1: 1	وَهِيَ الثَّانِيَةَ
u'وَهِيَ ثَانِي':Subject, #1: 1	وَهِيَ الثَّانِيَةَ
u'وَهِيَ ثَانِي':Subject, #1: 1	وَهِيَ ثَانِيَةٌ
u'وَهِيَ ثَانِيَةٌ':Predicate, #3: 3	وَهِيَ الثَّانِيَةُ
u'وَهَى ثَانِيَةٌ':Predicate, #1: 1	وَهِيَ الثَّانِيَةَ
u'وَهِيَ ثَانِيَةٌ':Subject, #1: 1	وَهِيَ الثَّانِيَةَ
u'وَهِيَ ثَانِيَةٌ':Subject, #1: 1	وَهِيَ ثَانِيَةٌ
u'وَهِيَ ثَدْيٌ':Subject, #3: 3	وَهِيَ الثَّانِيَةُ
u'وَهِيَ ثُغْرَةٌ':Subject, #1: 1	وَهِيَ الثَّدْيُ
u'وَهِيَ ثُقْبٌ':Subject, #1: 1	وَهِيَ الثُّغْرَةُ
u'وَهِيَ ثِقَةٌ':Subject, #1: 1	وَهِيَ الثُّقْبُ
u'وَهِيَ ثَلاثُ':Predicate, #1: 1	وَهِيَ ثِقَةٌ
u'وَهَى ثَلاثُ':Predicate, #2: 2	وَهِيَ ثَلَاثَ
u'وَهِيَ ثَلاثُ':Subject, #2: 2	وَهِيَ ثَلَاثَ
u'وَهِيَ ثَلاثُ':Subject, #1: 1	وَهِيَ الثَّلَاثُ
u'وَهِيَ ثَلاثَةٌ':Predicate, #6: 6	وَهِيَ ثَلَاثُ
u'وَهَى ثَلاثَةٌ':Predicate, #4: 4	وَهِيَ ثَلَاثَةَ
u'وَهِيَ ثَلاثَةٌ':Subject, #4: 4	وَهِيَ ثَلَاثَةَ
u'وَهِيَ ثَلاثَةٌ':Subject, #25: 25	وَهِيَ ثَلَاثَةُ
u'وَهِيَ ثَلاثَةٌ':Subject, #39: 39	وَهِيَ ثَلَاثَةٌ
u'وَهِيَ ثَلاثُون':Predicate, #4: 4	وَهِيَ الثَّلَاثَةُ
u'وَهَى ثَلاثُون':Predicate, #3: 3	وَهِيَ ثَلَاثُونَ
u'وَهِيَ ثِمارٌ':Subject, #3: 3	وَهِيَ ثَلَاثُونَ
u'وَهِيَ ثَمانِيَةٌ':Predicate, #1: 1	وَهِيَ ثِمَارٌ
u'وَهَى ثَمانِيَةٌ':Predicate, #4: 4	وَهِيَ ثَمَانِيَةَ
u'وَهِيَ ثَمانِيَةٌ':Subject, #4: 4	وَهِيَ ثَمَانِيَةَ
u'وَهِيَ ثَمانِيَةٌ':Subject, #21: 21	وَهِيَ ثَمَانِيَةٌ
u'وَهِيَ ثَمَرَةٌ':Subject, #3: 3	وَهِيَ ثَمَانِيَةُ
u'وَهِيَ ثَمَن':Subject, #1: 1	وَهِيَ ثَمَرَاتُ
u'وَهِيَ ثَمَنٌ':Subject, #1: 1	وَهِيَ الثَّمَنِيَّةُ
u'وَهِيَ ثُمْنٌ':Subject, #1: 1	وَهِيَ ثَمَنُ
u'وَهِيَ ثَمَنٌ':Subject, #1: 1	وَهِيَ ثُمْنُ
u'وَهِيَ ثَنِيَّةٌ':Subject, #4: 4	وَهِيَ الثَّمَنُ
u'وَهِيَ ثَنِيَّةٌ':Subject, #1: 1	وَهِيَ ثَنِيَّةُ
u'وَهِيَ ثَنِيَّةٌ':Subject, #2: 2	وَهِيَ الثَّنِيَّةُ
u'وَهِيَ ثَوابٌ':Subject, #2: 2	وَهِيَ ثَنِيَّةٌ
u'وَهِيَ ثِيابٌ':Subject, #1: 1	وَهِيَ الثَّوَابُ
u'وَهِيَ ثِيابٌ':Subject, #1: 1	وَهِيَ الثِّيَابُ
u'وَهِيَ ثَيِّبٌ':Subject, #2: 2	وَهِيَ ثِيَابٌ
u'وَهِيَ ثَيِّبٌ':Subject, #15: 15	وَهِيَ ثَيِّبٌ
u'وَهِيَ جَاحِدٌ':Subject, #1: 1	وَهِيَ الثَّيِّبُ
u'وَهِيَ جَارِي':Subject, #2: 2	وَهِيَ جَاحِدَةٌ
u'وَهِيَ جَارِي':Subject, #1: 1	وَهِيَ الْجَارِيَةُ
u'وَهِيَ جَارِيَةٌ':Subject, #6: 6	وَهِيَ جَارِيَةٌ
u'وَهِيَ جَارِيَةٌ':Subject, #1: 1	وَهِيَ الْجَارِيَةُ
u'وَهِيَ جَالِسٌ':Subject, #6: 6	وَهِيَ جَارِيَةٌ
u'وَهِيَ جَاهِلٌ':Subject, #1: 1	وَهِيَ جَالِسَةٌ
u'وَهِيَ جَائِزٌ':Subject, #2: 2	وَهِيَ جَاهِلَةٌ
u'وَهِيَ جَائِزٌ':Subject, #1: 1	وَهِيَ الْجَائِزَةُ
u'وَهِيَ جَائِزٌ':Subject, #2: 2	وَهِيَ جَائِزَةُ
u'وَهِيَ جَائِزَةٌ':Subject, #35: 35	وَهِيَ جَائِزَةٌ
u'وَهِيَ جَائِزَةٌ':Subject, #1: 1	وَهِيَ الْجَائِزَةُ
u'وَهِيَ جَائِزَةٌ':Subject, #2: 2	وَهِيَ جَائِزَةُ
u'وَهِيَ جَائِعٌ':Subject, #35: 35	وَهِيَ جَائِزَةٌ
u'وَهِيَ جِبَالٌ':Subject, #1: 1	وَهِيَ جَائِعَةٌ
u'وَهِيَ جِبَالٌ':Subject, #1: 1	وَهِيَ جِبَالٌ
u'وَهِيَ جَبْهَةٌ':Subject, #1: 1	وَهِيَ جِبَالُ
u'وَهِيَ جَدْوَلٌ':Subject, #1: 1	وَهِيَ الْجَبْهَةُ
u'وَهِيَ جُذَامٌ':Subject, #1: 1	وَهِيَ الْجَدْوَلُ
u'وَهِيَ جِرَارٌ':Subject, #1: 1	وَهِيَ الْجُذَامُ
u'وَهِيَ جُرْحٌ':Subject, #1: 1	وَهِيَ الْجِرَارُ
u'وَهِيَ جَرِيمَةٌ':Subject, #1: 1	وَهِيَ الْجُرْحُ
u'وَهِيَ جُزْءٌ':Subject, #1: 1	وَهِيَ جَرِيمَةٌ
u'وَهِيَ جُزْءٌ':Subject, #1: 1	وَهِيَ جُزْءُ
u'وَهِيَ جَزَاءٌ':Subject, #5: 5	وَهِيَ جُزْءٌ
u'وَهِيَ جَزُورٌ':Subject, #3: 3	وَهِيَ الْجَزَاءُ
u'وَهِيَ جُزْئِيٌّ':Subject, #1: 1	وَهِيَ جَزُورٌ
u'وَهِيَ جُزْئِيَّةٌ':Subject, #1: 1	وَهِيَ جُزْئِيَّةٌ
u'وَهِيَ جِزْيَةٌ':Subject, #1: 1	وَهِيَ جُزْئِيَّةٌ
u'وَهِيَ جَزِيرَةٌ':Subject, #1: 1	وَهِيَ الْجِزْيَةُ
u'وَهِيَ جِسْمٌ':Subject, #1: 1	وَهِيَ جَزِيرَةُ
u'وَهِيَ جُفُونٌ':Subject, #1: 1	وَهِيَ جِسْمٌ
u'وَهِيَ جُلّ':Subject, #1: 1	وَهِيَ جُفُونُ
u'وَهِيَ جُلَّة':Subject, #1: 1	وَهِيَ جُلّةُ
u'وَهِيَ جلد':Subject, #1: 1	وَهِيَ جُلّةُ
u'وَهِيَ جِلْدٌ':Subject, #1: 1	وَهِيَ الْجِلْدُ
u'وَهِيَ جِلْدَةٌ':Subject, #1: 1	وَهِيَ الْجِلْدُ
u'وَهِيَ جِلْدَةٌ':Subject, #1: 1	وَهِيَ جِلْدَةُ
u'وَهِيَ جِلْدَةٌ':Subject, #2: 2	وَهِيَ جِلْدَةٌ
u'وَهِيَ جلسة':Subject, #3: 3	وَهِيَ الْجِلْدَةُ
u'وَهِيَ جِلْسَةٌ':Subject, #1: 1	وَهِيَ الْجِلْسَةُ
u'وَهِيَ جماع':Subject, #1: 1	وَهِيَ الْجِلْسَةُ
u'وَهِيَ جِمَاعٌ':Subject, #2: 2	وَهِيَ الْجِمَاعُ
u'وَهِيَ جَمَاعَةٌ':Subject, #2: 2	وَهِيَ الْجِمَاعُ
u'وَهِيَ جَمَاعَةٌ':Subject, #1: 1	وَهِيَ الْجَمَاعَاتُ
u'وَهِيَ جَمَاعَةٌ':Subject, #1: 1	وَهِيَ جَمَاعَاتٌ
u'وَهِيَ جَمْرَةٌ':Subject, #6: 6	وَهِيَ الْجَمَاعَةُ
u'وَهِيَ جَمْرَة':Subject, #1: 1	وَهِيَ جَمْرَةُ
u'وَهِيَ جمع':Subject, #1: 1	وَهِيَ جَمْرَةُ
u'وَهِيَ جَمْعٌ':Subject, #16: 16	وَهِيَ جَمْعُ
u'وَهِيَ جمع':Subject, #16: 16	وَهِيَ جَمْعُ
u'وَهِيَ جَمْعٌ':Subject, #2: 2	وَهِيَ الْجَمْعُ
u'وَهِيَ جَمْعٌ':Subject, #2: 2	وَهِيَ الْجَمْعُ
u'وَهِيَ جمعة':Subject, #3: 3	وَهِيَ جَمْعٌ
u'وَهِيَ جُمُعَةٌ':Subject, #1: 1	وَهِيَ جُمُعَةٌ
u'وَهِيَ جَمْعِيَّةٌ':Subject, #1: 1	وَهِيَ جُمُعَةٌ
u'وَهِيَ جُمْلَةٌ':Subject, #1: 1	وَهِيَ الْجَمْعِيَّةُ
u'وَهِيَ جُمْلَةٌ':Subject, #2: 2	وَهِيَ الْجُمْلَةُ
u'وَهِيَ جَمِيلٌ':Subject, #2: 2	وَهِيَ جُمْلَةُ
u'وَهِيَ جِنٌّ':Subject, #1: 1	وَهِيَ جَمِيلَةُ
u'وَهِيَ جِنَايَةٌ':Subject, #1: 1	وَهِيَ جِنِّيَّةٌ
u'وَهِيَ جِنَايَةٌ':Subject, #2: 2	وَهِيَ الْجِنَايَاتُ
u'وَهِيَ جِنَايَةٌ':Subject, #2: 2	وَهِيَ جِنَايَةٌ
u'وَهِيَ جِنَايَةٌ':Subject, #2: 2	وَهِيَ جِنَايَةُ
u'وَهِيَ جَنَّةٌ':Subject, #3: 3	وَهِيَ الْجِنَايَةُ
u'وَهِيَ جِنْسٌ':Subject, #3: 3	وَهِيَ الْجَنَّةُ
u'وَهِيَ جَنُوبٌ':Subject, #2: 2	وَهِيَ جِنْسٌ
u'وَهِيَ جُنُودٌ':Subject, #1: 1	وَهِيَ الْجَنُوبُ
u'وَهِيَ جِنِّيٌّ':Subject, #1: 1	وَهِيَ جُنُودُهُ
u'وَهِيَ جَنِينٌ':Subject, #1: 1	وَهِيَ جِنِّيَّةٌ
u'وَهِيَ جَهالَة':Subject, #1: 1	وَهِيَ الْجَنِينُ
u'وَهِيَ جِهَةٌ':Subject, #4: 4	وَهِيَ جَهَالَةُ
u'وَهِيَ جِهَةٌ':Subject, #1: 1	وَهِيَ الْجِهَةُ
u'وَهِيَ جِهَةٌ':Subject, #1: 1	وَهِيَ جِهَةٌ
u'وَهِيَ جهل':Subject, #3: 3	وَهِيَ جِهَةُ
u'وَهِيَ جَهْلٌ':Subject, #2: 2	وَهِيَ الْجَهْلُ
u'وَهِيَ جَهَنَّمُ':Subject, #2: 2	وَهِيَ الْجَهْلُ
u'وَهِيَ جَوَابٌ':Subject, #1: 1	وَهِيَ جَهَنَّمُ
u'وَهِيَ جَوَابٌ':Subject, #1: 1	وَهِيَ الْجَوَابُ
u'وَهِيَ جَوَابٌ':Subject, #1: 1	وَهِيَ جَوَابٌ
u'وَهِيَ جوارح':Subject, #1: 1	وَهِيَ جَوَابُ
u'وَهِيَ جَوَارِحُ':Subject, #1: 1	وَهِيَ جَوَارِحُ
u'وَهِيَ جَوَازٌ':Subject, #1: 1	وَهِيَ جَوَارِحُ
u'وَهِيَ جَوَازٌ':Subject, #1: 1	وَهِيَ جَوَازُهُ
u'وَهِيَ جَوَامِعُ':Subject, #6: 6	وَهِيَ جَوَازُ
u'وَهِيَ حاجَةٌ':Subject, #2: 2	وَهِيَ الْجَوَامِعُ
u'وَهِيَ حاجَةٌ':Subject, #2: 2	وَهِيَ حَاجَةُ
u'وَهِيَ حادٌّ':Subject, #3: 3	وَهِيَ الْحَاجَةُ
u'وَهِيَ حادِثٌ':Subject, #2: 2	وَهِيَ حَادَّةٌ
u'وَهِيَ حادِثٌ':Subject, #5: 5	وَهِيَ حَادِثَةٌ
u'وَهِيَ حادِي':Subject, #5: 5	وَهِيَ حَادِثَةُ
u'وَهِيَ حارٌّ':Subject, #1: 1	وَهِيَ الْحَادِيَةُ
u'وَهِيَ حازِمٌ':Subject, #2: 2	وَهِيَ حَارَّةٌ
u'وَهِيَ حاصِلٌ':Subject, #1: 1	وَهِيَ حَازِمَةٌ
u'وَهِيَ حاصِلٌ':Subject, #1: 1	وَهِيَ الْحَاصِلَةُ
u'وَهِيَ حاضِرٌ':Subject, #9: 9	وَهِيَ حَاصِلَةٌ
u'وَهِيَ حاضِرٌ':Subject, #1: 1	وَهِيَ الْحَاضِرَةُ
u'وَهِيَ حافِظٌ':Subject, #9: 9	وَهِيَ حَاضِرَةٌ
u'وَهِيَ حافِظَةٌ':Subject, #1: 1	وَهِيَ حَافِظَةٌ
u'وَهِيَ حالٌ':Predicate, #1: 1	وَهِيَ حَافِظَةٌ
u'وَهَى حالٌ':Predicate, #1: 1	وَهِيَ حَالَ
u'وَهِيَ حالٌ':Subject, #1: 1	وَهِيَ حَالَ
u'وَهِيَ حالٌ':Subject, #1: 1	وَهِيَ الْحَالُ
u'وَهِيَ حالَةٌ':Subject, #4: 4	وَهِيَ حَالٌ
u'وَهِيَ حالَةٌ':Subject, #19: 19	وَهِيَ حَالَةُ
u'وَهِيَ حالَةٌ':Subject, #3: 3	وَهِيَ حَالَةٌ
u'وَهِيَ حامِلٌ':Subject, #4: 4	وَهِيَ الْحَالَةُ
u'وَهِيَ حامِلٌ':Subject, #118: 118	وَهِيَ حَامِلٌ
u'وَهِيَ حامِلٌ':Subject, #1: 1	وَهِيَ الْحَامِلَةُ
u'وَهِيَ حامِلٌ':Subject, #1: 1	وَهِيَ حَامِلَةٌ
u'وَهِيَ حامِلٌ':Subject, #2: 2	وَهِيَ الْحَامِلُ
u'وَهِيَ حائِضٌ':Subject, #2: 2	وَهِيَ حَامِلَتُهُ
u'وَهِيَ حَبٌّ':Subject, #94: 94	وَهِيَ حَائِضٌ
u'وَهِيَ حَبٌّ':Subject, #1: 1	وَهِيَ الْحَبَّةُ
u'وَهِيَ حَبٌّ':Subject, #1: 1	وَهِيَ حَبُّ
u'وَهِيَ حَبَّةٌ':Subject, #1: 1	وَهِيَ حَبَّةٌ
u'وَهِيَ حَبَّةٌ':Subject, #1: 1	وَهِيَ الْحَبَّةُ
u'وَهِيَ حَبْلٌ':Subject, #1: 1	وَهِيَ حَبَّةٌ
u'وَهِيَ حَجٌّ':Subject, #1: 1	وَهِيَ الْحَبْلُ
u'وَهِيَ حِجارَةٌ':Subject, #2: 2	وَهِيَ حَجٌّ
u'وَهِيَ حِجارَةٌ':Subject, #5: 5	وَهِيَ حِجَارَةٌ
u'وَهِيَ حِجَّةٌ':Subject, #9: 9	وَهِيَ الْحِجَارَةُ
u'وَهِيَ حُجَّةٌ':Subject, #1: 1	وَهِيَ حِجَّةُ
u'وَهِيَ حَجَرٌ':Subject, #4: 4	وَهِيَ حُجَّةٌ
u'وَهِيَ حَدٌّ':Subject, #2: 2	وَهِيَ الْحَجَرُ
u'وَهِيَ حَدٌّ':Subject, #1: 1	وَهِيَ الْحَدُّ
u'وَهِيَ حَدَثٌ':Subject, #1: 1	وَهِيَ حَدٌّ
u'وَهِيَ حَدَثٌ':Subject, #2: 2	وَهِيَ حَدَثٌ
u'وَهِيَ حُدودٌ':Subject, #3: 3	وَهِيَ الْحَدَثُ
u'وَهِيَ حَديثٌ':Subject, #1: 1	وَهِيَ الْحُدُودُ
u'وَهِيَ حَديدَةٌ':Subject, #1: 1	وَهِيَ حَدِيثَةُ
u'وَهِيَ حَديدَةٌ':Subject, #1: 1	وَهِيَ الْحَدِيدَةُ
u'وَهِيَ حَديقَةٌ':Subject, #1: 1	وَهِيَ حَدِيدَةٌ
u'وَهِيَ حُرٌّ':Predicate, #1: 1	وَهِيَ حَدِيقَةُ
u'وَهَى حُرٌّ':Predicate, #1: 1	وَهِيَ حُرَّةً
u'وَهِيَ حُرٌّ':Subject, #1: 1	وَهِيَ حُرَّةً
u'وَهِيَ حُرٌّ':Subject, #1: 1	وَهِيَ الْحُرُّ
u'وَهِيَ حُرٌّ':Subject, #1: 1	وَهِيَ حُرّةٌ
u'وَهِيَ حُرٌّ':Subject, #2: 2	وَهِيَ الْحُرَّةُ
u'وَهِيَ حَرامٌ':Subject, #47: 47	وَهِيَ حُرَّةٌ
u'وَهِيَ حَرْبٌ':Subject, #12: 12	وَهِيَ حَرَامٌ
u'وَهِيَ حَرَكَةٌ':Subject, #1: 1	وَهِيَ حَرْبُ
u'وَهِيَ حَرَكَةٌ':Subject, #1: 1	وَهِيَ حَرَكَاتُ
u'وَهِيَ حَرَمٌ':Subject, #2: 2	وَهِيَ الْحَرَكَاتُ
u'وَهِيَ حُرْمَةٌ':Subject, #2: 2	وَهِيَ حَرَمُ
u'وَهِيَ حُرْمَةٌ':Subject, #1: 1	وَهِيَ حُرْمَتُهُ
u'وَهِيَ حُرْمَةٌ':Subject, #2: 2	وَهِيَ الْحُرْمَةُ
u'وَهِيَ حُروفٌ':Subject, #2: 2	وَهِيَ حُرْمَةُ
u'وَهِيَ حُرِّيَّةٌ':Subject, #1: 1	وَهِيَ حُرُوفُ
u'وَهِيَ حُرِّيَّةٌ':Subject, #1: 1	وَهِيَ حُرِّيَّةُ
u'وَهِيَ حزمة':Subject, #5: 5	وَهِيَ الْحُرِّيَّةُ
u'وَهِيَ حُزْمَةٌ':Subject, #1: 1	وَهِيَ الْحُزْمَةُ
u'وَهِيَ حِسٌّ':Subject, #1: 1	وَهِيَ الْحُزْمَةُ
u'وَهِيَ حَسَنٌ':Subject, #1: 1	وَهِيَ الْحِسُّ
u'وَهِيَ حُسْنٌ':Subject, #1: 1	وَهِيَ حَسَنٌ
u'وَهِيَ حَسَنٌ':Subject, #2: 2	وَهِيَ الْحُسْنُ
u'وَهِيَ حَسَنَةٌ':Subject, #2: 2	وَهِيَ حَسَنَةٌ
u'وَهِيَ حِسِّيٌّ':Subject, #2: 2	وَهِيَ حَسَنَةٌ
u'وَهِيَ حِصَّةٌ':Subject, #1: 1	وَهِيَ حِسِّيَّةٌ
u'وَهِيَ حَصْرٌ':Subject, #1: 1	وَهِيَ حِصَّةُ
u'وَهِيَ حُصُول':Subject, #1: 1	وَهِيَ الْحَصْرُ
u'وَهِيَ حُصُول':Subject, #1: 1	وَهِيَ حُصُولُهُ
u'وَهِيَ حَطَبٌ':Subject, #3: 3	وَهِيَ حُصُولُ
u'وَهِيَ حَظِيرَةٌ':Subject, #1: 1	وَهِيَ حَطَبٌ
u'وَهِيَ حَفْرٌ':Subject, #2: 2	وَهِيَ حَظِيرَةُ
u'وَهِيَ حِفْظٌ':Subject, #2: 2	وَهِيَ حَفْرُ
u'وَهِيَ حَفِيرَةٌ':Subject, #1: 1	وَهِيَ حِفْظُ
u'وَهِيَ حَقٌّ':Subject, #1: 1	وَهِيَ الْحَفِيرَةُ
u'وَهِيَ حَقٌّ':Subject, #1: 1	وَهِيَ الْحَقُّ
u'وَهِيَ حَقٌّ':Subject, #1: 1	وَهِيَ حَقُّهُ
u'وَهِيَ حَقٌّ':Subject, #3: 3	وَهِيَ حَقٌّ
u'وَهِيَ حقائق':Subject, #6: 6	وَهِيَ حَقُّ
u'وَهِيَ حَقَائِقُ':Subject, #1: 1	وَهِيَ حَقَائِقُ
u'وَهِيَ حَقِيقٌ':Subject, #1: 1	وَهِيَ حَقَائِقُ
u'وَهِيَ حَقِيقٌ':Subject, #1: 1	وَهِيَ حَقِيقَتُهُ
u'وَهِيَ حَقِيقَةٌ':Subject, #3: 3	وَهِيَ حَقِيقَةُ
u'وَهِيَ حَقِيقَةٌ':Subject, #1: 1	وَهِيَ حَقِيقَتُهُ
u'وَهِيَ حَقِيقَةٌ':Subject, #3: 3	وَهِيَ حَقِيقَةُ
u'وَهِيَ حِكَمٌ':Subject, #4: 4	وَهِيَ حَقِيقَةٌ
u'وَهِيَ حُكْمٌ':Subject, #1: 1	وَهِيَ الْحِكَمُ
u'وَهِيَ حكمة':Subject, #4: 4	وَهِيَ الْحُكْمُ
u'وَهِيَ حِكْمَةٌ':Subject, #1: 1	وَهِيَ الْحِكْمَةُ
u'وَهِيَ حكمة':Subject, #1: 1	وَهِيَ الْحِكْمَةُ
u'وَهِيَ حِكْمَةٌ':Subject, #1: 1	وَهِيَ حِكْمَةٌ
u'وَهِيَ حِلٌّ':Subject, #1: 1	وَهِيَ حِكْمَةٌ
u'وَهِيَ حِلٌّ':Subject, #1: 1	وَهِيَ الْحِلُّ
u'وَهِيَ حِلٌّ':Subject, #1: 1	وَهِيَ حِلٌّ
u'وَهِيَ حَلالٌ':Subject, #2: 2	وَهِيَ حِلُّ
u'وَهِيَ حَلْقَةٌ':Subject, #7: 7	وَهِيَ حَلَالٌ
u'وَهِيَ حَلَمَةٌ':Subject, #1: 1	وَهِيَ حَلْقَةٌ
u'وَهِيَ حَمَامَةٌ':Subject, #1: 1	وَهِيَ الْحَلَمَةُ
u'وَهِيَ حُمْرَةٌ':Subject, #1: 1	وَهِيَ الْحَمَامَةُ
u'وَهِيَ حُمْرَةٌ':Subject, #1: 1	وَهِيَ الْحُمْرَةُ
u'وَهِيَ حَمْلٌ':Subject, #3: 3	وَهِيَ حُمْرَةٌ
u'وَهِيَ حَمْلٌ':Subject, #1: 1	وَهِيَ الْحَمْلُ
u'وَهِيَ حِمْلٌ':Subject, #1: 1	وَهِيَ حَمْلٌ
u'وَهِيَ حَمِيرٌ':Subject, #1: 1	وَهِيَ حِمْلٌ
u'وَهِيَ حَنْظَلٌ':Subject, #1: 1	وَهِيَ الْحَمِيرُ
u'وَهِيَ حَواجِزُ':Subject, #1: 1	وَهِيَ الْحَنْظَلَةُ
u'وَهِيَ حَواسٌّ':Subject, #1: 1	وَهِيَ الْحَوَاجِزُ
u'وَهِيَ حَوَاسُّ':Subject, #1: 1	وَهِيَ الْحَوَاسُّ
u'وَهِيَ حَوَالَةٌ':Subject, #1: 1	وَهِيَ الْحَوَاسُّ
u'وَهِيَ حَوَالَةٌ':Subject, #1: 1	وَهِيَ الْحَوَالَةُ
u'وَهِيَ حَوامِلُ':Subject, #1: 1	وَهِيَ حَوَالَةُ
u'وَهِيَ حَوْضٌ':Subject, #1: 1	وَهِيَ الْحَوَامِلُ
u'وَهِيَ حول':Subject, #2: 2	وَهِيَ الْحَوْضُ
u'وَهِيَ حَوْلٌ':Subject, #1: 1	وَهِيَ الْحَوْلُ
u'وَهِيَ حَيٌّ':Subject, #1: 1	وَهِيَ الْحَوْلُ
u'وَهِيَ حَيٌّ':Subject, #1: 1	وَهِيَ الْحَيُّ
u'وَهِيَ حَيَاءٌ':Subject, #39: 39	وَهِيَ حَيَّةٌ
u'وَهِيَ حَيَاةٌ':Subject, #1: 1	وَهِيَ الْحَيَاءُ
u'وَهِيَ حِيازَة':Subject, #1: 1	وَهِيَ الْحَيَاةُ
u'وَهِيَ حَيَّةٌ':Subject, #1: 1	وَهِيَ حِيَازَةٌ
u'وَهِيَ حِيتَانٌ':Subject, #39: 39	وَهِيَ حَيَّةٌ
u'وَهِيَ حَيْضٌ':Subject, #1: 1	وَهِيَ حِيتَانُهُ
u'وَهِيَ حَيْضٌ':Subject, #1: 1	وَهِيَ حَيْضٌ
u'وَهِيَ حَيْضَةٌ':Subject, #2: 2	وَهِيَ الْحَيْضُ
u'وَهِيَ حِيلَةٌ':Subject, #1: 1	وَهِيَ حَيْضَةٌ
u'وَهِيَ حِيلَةٌ':Subject, #2: 2	وَهِيَ حِيلَةٌ
u'وَهِيَ حِيلَةٌ':Subject, #4: 4	وَهِيَ حِيلَةُ
u'وَهِيَ خَابِيَةٌ':Subject, #7: 7	وَهِيَ الْحِيلَةُ
u'وَهِيَ خَارِجٌ':Subject, #1: 1	وَهِيَ الْخَابِيَةُ
u'وَهِيَ خَارِجٌ':Subject, #1: 1	وَهِيَ الْخَارِجَةُ
u'وَهِيَ خَاصَّةٌ':Subject, #3: 3	وَهِيَ خَارِجَةٌ
u'وَهِيَ خَاصَّةٌ':Subject, #1: 1	وَهِيَ خَاصَّةٌ
u'وَهِيَ خَاصِّيَّةٌ':Subject, #1: 1	وَهِيَ خَاصَّةُ
u'وَهِيَ خَاصِّيَّةٌ':Subject, #1: 1	وَهِيَ الْخَاصِّيَّةُ
u'وَهِيَ خَالٌ':Subject, #1: 1	وَهِيَ خَاصِّيَّةُ
u'وَهِيَ خَالٌ':Subject, #1: 1	وَهِيَ الْخَالُ
u'وَهِيَ خَالٌ':Subject, #1: 1	وَهِيَ الْخَالَةُ
u'وَهِيَ خَالٌ':Subject, #1: 1	وَهِيَ خَالَةُ
u'وَهِيَ خامس':Predicate, #4: 4	وَهِيَ خَالَتُهُ
u'وَهِيَ خَامِسٌ':Predicate, #1: 1	وَهِيَ الْخَامِسَةَ
u'وَهَى خامس':Predicate, #1: 1	وَهِيَ الْخَامِسَةَ
u'وَهَى خَامِسٌ':Predicate, #1: 1	وَهِيَ الْخَامِسَةَ
u'وَهِيَ خامس':Subject, #1: 1	وَهِيَ الْخَامِسَةَ
u'وَهِيَ خَامِسٌ':Subject, #1: 1	وَهِيَ الْخَامِسَةُ
u'وَهِيَ خَانٌ':Subject, #1: 1	وَهِيَ الْخَامِسَةُ
u'وَهِيَ خُبْثٌ':Subject, #1: 1	وَهِيَ خَانٌ
u'وَهِيَ خَبَرٌ':Subject, #1: 1	وَهِيَ الْخُبْثُ
u'وَهِيَ خَبَر':Subject, #1: 1	وَهِيَ خَبَرٌ
u'وَهِيَ خَبِيث':Subject, #1: 1	وَهِيَ خَبَرٌ
u'وَهِيَ خدمة':Subject, #1: 1	وَهِيَ خَبِيثَةُ
u'وَهِيَ خِدْمَةٌ':Subject, #4: 4	وَهِيَ خِدْمَةُ
u'وَهِيَ خَدِيج':Subject, #4: 4	وَهِيَ خِدْمَةُ
u'وَهِيَ خَدِيعَةٌ':Subject, #1: 1	وَهِيَ خَدِيجَةُ
u'وَهِيَ خَرَائِطُ':Subject, #1: 1	وَهِيَ الْخَدِيعَةُ
u'وَهِيَ خَرَزَةٌ':Subject, #1: 1	وَهِيَ الْخَرَائِطُ
u'وَهِيَ خَرْقَاء':Subject, #1: 1	وَهِيَ خَرَزَاتٌ
u'وَهِيَ خرقة':Subject, #1: 1	وَهِيَ الْخَرْقَاءُ
u'وَهِيَ خِرْقَةٌ':Subject, #1: 1	وَهِيَ خِرْقَةُ
u'وَهِيَ خرقة':Subject, #1: 1	وَهِيَ خِرْقَةُ
u'وَهِيَ خِرْقَةٌ':Subject, #2: 2	وَهِيَ الْخِرْقَةُ
u'وَهِيَ خرقة':Subject, #2: 2	وَهِيَ الْخِرْقَةُ
u'وَهِيَ خِرْقَةٌ':Subject, #2: 2	وَهِيَ خِرْقَةٌ
u'وَهِيَ خُرُوجٌ':Subject, #2: 2	وَهِيَ خِرْقَةٌ
u'وَهِيَ خَشَبَةٌ':Subject, #2: 2	وَهِيَ الْخُرُوجُ
u'وَهِيَ خَشَبَةٌ':Subject, #1: 1	وَهِيَ خَشَبَةُ
u'وَهِيَ خَشَبَةٌ':Subject, #2: 2	وَهِيَ الْخَشَبَةُ
u'وَهِيَ خُشُوعٌ':Subject, #2: 2	وَهِيَ خَشَبَةٌ
u'وَهِيَ خِصَامٌ':Subject, #1: 1	وَهِيَ الْخُشُوعُ
u'وَهِيَ خُصُومَةٌ':Subject, #1: 1	وَهِيَ الْخِصَامُ
u'وَهِيَ خُضْرَةٌ':Subject, #1: 1	وَهِيَ الْخُصُومَةُ
u'وَهِيَ خَطَأٌ':Subject, #1: 1	وَهِيَ الْخُضْرَةُ
u'وَهِيَ خطبة':Subject, #2: 2	وَهِيَ خَطَأٌ
u'وَهِيَ خُطْبَةٌ':Subject, #2: 2	وَهِيَ الْخُطْبَةُ
u'وَهِيَ خطبة':Subject, #2: 2	وَهِيَ الْخُطْبَةُ
u'وَهِيَ خُطْبَةٌ':Subject, #3: 3	وَهِيَ خُطْبَةُ
u'وَهِيَ خِلاَفٌ':Subject, #3: 3	وَهِيَ خُطْبَةُ
u'وَهِيَ خِلاَفٌ':Subject, #1: 1	وَهِيَ الْخِلَافُ
u'وَهِيَ خِلاَفَةٌ':Subject, #4: 4	وَهِيَ خِلَافُ
u'وَهِيَ خِلاَفِيٌّ':Subject, #2: 2	وَهِيَ الْخِلَافَةُ
u'وَهِيَ خُلْعٌ':Subject, #1: 1	وَهِيَ الْخِلَافِيَّةُ
u'وَهِيَ خَلْوَةٌ':Subject, #1: 1	وَهِيَ الْخُلْعُ
u'وَهِيَ خَمْرٌ':Subject, #3: 3	وَهِيَ الْخَلْوَةُ
u'وَهِيَ خُمُسٌ':Subject, #1: 1	وَهِيَ الْخَمْرُ
u'وَهِيَ خَمْسٌ':Subject, #1: 1	وَهِيَ الْخُمُسُ
u'وَهِيَ خُمُسٌ':Subject, #2: 2	وَهِيَ الْخَمْسُ
u'وَهِيَ خَمْسٌ':Subject, #2: 2	وَهِيَ خُمُسٌ
u'وَهِيَ خَمْسٌ':Subject, #4: 4	وَهِيَ خَمْسُ
u'وَهِيَ خَمْسَةٌ':Predicate, #6: 6	وَهِيَ خَمْسٌ
u'وَهَى خَمْسَةٌ':Predicate, #3: 3	وَهِيَ خَمْسَةَ
u'وَهِيَ خَمْسَةٌ':Subject, #3: 3	وَهِيَ خَمْسَةَ
u'وَهِيَ خَمْسَةٌ':Subject, #33: 33	وَهِيَ خَمْسَةٌ
u'وَهِيَ خَمْسَةٌ':Subject, #5: 5	وَهِيَ الْخَمْسَةُ
u'وَهِيَ خَوْخٌ':Subject, #9: 9	وَهِيَ خَمْسَةُ
u'وَهِيَ خَوْفٌ':Subject, #1: 1	وَهِيَ الْخَوْخُ
u'وَهِيَ خيار':Subject, #2: 2	وَهِيَ خَوْفُ
u'وَهِيَ خِيَارٌ':Subject, #2: 2	وَهِيَ الْخِيَارُ
u'وَهِيَ خَيْرٌ':Subject, #2: 2	وَهِيَ الْخِيَارُ
u'وَهِيَ خَيْرٌ':Subject, #1: 1	وَهِيَ خَيْرٌ
u'وَهِيَ خَيْطٌ':Subject, #1: 1	وَهِيَ خَيْرُ
u'وَهِيَ خَيْطٌ':Subject, #1: 1	وَهِيَ الْخَيْطُ
u'وَهِيَ خَيْلٌ':Subject, #1: 1	وَهِيَ خَيْطُ
u'وَهِيَ خُيُوطٌ':Subject, #1: 1	وَهِيَ خَيْلُ
u'وَهِيَ دَاءٌ':Subject, #1: 1	وَهِيَ خُيُوطٌ
u'وَهِيَ دَابَّةٌ':Subject, #1: 1	وَهِيَ دَاءٌ
u'وَهِيَ دَابَّةٌ':Subject, #2: 2	وَهِيَ الدّابّةُ
u'وَهِيَ دَاخِلٌ':Subject, #3: 3	وَهِيَ دَابَّةٌ
u'وَهِيَ دَاخِلٌ':Subject, #2: 2	وَهِيَ الدَّاخِلَةُ
u'وَهِيَ دَاخِلَةٌ':Subject, #6: 6	وَهِيَ دَاخِلَةٌ
u'وَهِيَ دَاخِلَةٌ':Subject, #2: 2	وَهِيَ الدَّاخِلَةُ
u'وَهِيَ دَارٌ':Subject, #6: 6	وَهِيَ دَاخِلَةٌ
u'وَهِيَ دَارٌ':Subject, #1: 1	وَهِيَ الدّارُ
u'وَهِيَ دَارٌ':Subject, #3: 3	وَهِيَ دَارٌ
u'وَهِيَ دَارٌ':Subject, #5: 5	وَهِيَ الدَّارُ
u'وَهِيَ دَاعِي':Subject, #7: 7	وَهِيَ دَارُ
u'وَهِيَ دَالَّةٌ':Subject, #1: 1	وَهِيَ الدَّاعِيَةُ
u'وَهِيَ دَالَّةٌ':Subject, #1: 1	وَهِيَ دَالَّةٌ
u'وَهِيَ دَامِغٌ':Subject, #2: 2	وَهِيَ الدَّالَّةُ
u'وَهِيَ دَامِي':Subject, #1: 1	وَهِيَ الدَّامِغَةُ
u'وَهِيَ دَاهِي':Subject, #1: 1	وَهِيَ دَامِيَةُ
u'وَهِيَ دَاهِيَةٌ':Subject, #2: 2	وَهِيَ الدّاهِيَةُ
u'وَهِيَ دَائِرَةٌ':Subject, #2: 2	وَهِيَ الدّاهِيَةُ
u'وَهِيَ دَائِرَةٌ':Subject, #1: 1	وَهِيَ الدَّائِرَةُ
u'وَهِيَ دَائِرَةٌ':Subject, #1: 1	وَهِيَ دَائِرَةُ
u'وَهِيَ دُبُرٌ':Subject, #2: 2	وَهِيَ دَائِرَةٌ
u'وَهِيَ دُبُرٌ':Subject, #1: 1	وَهِيَ دُبُرُ
u'وَهِيَ دِثَارٌ':Subject, #2: 2	وَهِيَ الدُّبُرُ
u'وَهِيَ دُخَانٌ':Subject, #1: 1	وَهِيَ دِثَارٌ
u'وَهِيَ دَخَنٌ':Subject, #2: 2	وَهِيَ دُخَانٌ
u'وَهِيَ دُخُولٌ':Subject, #1: 1	وَهِيَ الدَّخَنُ
u'وَهِيَ دَرْء':Subject, #3: 3	وَهِيَ دُخُولُ
u'وَهِيَ دَرَاهِمُ':Subject, #1: 1	وَهِيَ دَرْءُ
u'وَهِيَ دَرَاهِمُ':Subject, #2: 2	وَهِيَ الدَّرَاهِمُ
u'وَهِيَ دِرْهَمٌ':Subject, #7: 7	وَهِيَ دَرَاهِمُ
u'وَهِيَ دِرْهَم':Subject, #3: 3	وَهِيَ دِرْهَمٌ
u'وَهِيَ دَعْوَةٌ':Subject, #3: 3	وَهِيَ دِرْهَمٌ
u'وَهِيَ دَعْوَةٌ':Subject, #1: 1	وَهِيَ الدَّعْوَةُ
u'وَهِيَ دفع':Subject, #1: 1	وَهِيَ دَعْوَةُ
u'وَهِيَ دَفْعٌ':Subject, #8: 8	وَهِيَ دَفْعُ
u'وَهِيَ دَفْنٌ':Subject, #8: 8	وَهِيَ دَفْعُ
u'وَهِيَ دَفِينٌ':Subject, #1: 1	وَهِيَ دَفْنٌ
u'وَهِيَ دَفِين':Subject, #1: 1	وَهِيَ دَفِينُ
u'وَهِيَ دَلالَةٌ':Subject, #1: 1	وَهِيَ دَفِينُ
u'وَهِيَ دَلالَةٌ':Subject, #1: 1	وَهِيَ الدَّلَالَةُ
u'وَهِيَ دَمٌ':Subject, #2: 2	وَهِيَ دَلَالَةُ
u'وَهِيَ دَمٌ':Subject, #2: 2	وَهِيَ دَمٌ
u'وَهِيَ دُمْيَةٌ':Subject, #3: 3	وَهِيَ الدَّمُ
u'وَهِيَ دَنانيرُ':Subject, #1: 1	وَهِيَ الدُّمْيَةُ
u'وَهِيَ دَواءٌ':Subject, #1: 1	وَهِيَ دَنَانِيرُ
u'وَهِيَ دواة':Subject, #1: 1	وَهِيَ دَوَاءٌ
u'وَهِيَ دَواةٌ':Subject, #1: 1	وَهِيَ الدَّوَاةُ
u'وَهِيَ دَوامٌ':Subject, #1: 1	وَهِيَ الدَّوَاةُ
u'وَهِيَ دُودَةٌ':Subject, #2: 2	وَهِيَ دَوَامُ
u'وَهِيَ دونٌ':Predicate, #2: 2	وَهِيَ دُودَةٌ
u'وَهَى دونٌ':Predicate, #8: 8	وَهِيَ دُونَ
u'وَهِيَ دُوَيْبَّةٌ':Subject, #8: 8	وَهِيَ دُونَ
u'وَهِيَ دِيَةٌ':Subject, #3: 3	وَهِيَ دُوَيْبّةٌ
u'وَهِيَ دِيَةٌ':Subject, #2: 2	وَهِيَ دِيَةُ
u'وَهِيَ دِينٌ':Subject, #6: 6	وَهِيَ الدِّيَةُ
u'وَهِيَ دَيْنٌ':Subject, #1: 1	وَهِيَ الدِّينُ
u'وَهِيَ دَيْنٌ':Subject, #1: 1	وَهِيَ الدَّيْنُ
u'وَهِيَ دِينِيٌّ':Subject, #1: 1	وَهِيَ دَيْنٌ
u'وَهِيَ دُيونٌ':Subject, #1: 1	وَهِيَ الدِّينِيَّةُ
u'وَهِيَ ذاكِرٌ':Subject, #2: 2	وَهِيَ الدُّيُونُ
u'وَهِيَ ذاكِرَة':Subject, #1: 1	وَهِيَ ذَاكِرَةٌ
u'وَهِيَ ذاهِب':Subject, #1: 1	وَهِيَ ذَاكِرَةٌ
u'وَهِيَ ذُبابٌ':Subject, #1: 1	وَهِيَ ذَاهِبَةُ
u'وَهِيَ ذَبائِحُ':Subject, #1: 1	وَهِيَ ذُبَابٌ
u'وَهِيَ ذَبيحٌ':Subject, #1: 1	وَهِيَ الذَّبَائِحُ
u'وَهِيَ ذَبيحَةٌ':Subject, #1: 1	وَهِيَ ذَبِيحَةُ
u'وَهِيَ ذِراعٌ':Subject, #1: 1	وَهِيَ ذَبِيحَةُ
u'وَهِيَ ذِراعٌ':Subject, #1: 1	وَهِيَ الذِّرَاعُ
u'وَهِيَ ذِراعٌ':Subject, #1: 1	وَهِيَ ذِرَاعٌ
u'وَهِيَ ذَكاءٌ':Subject, #1: 1	وَهِيَ ذِرَاعُ
u'وَهِيَ ذُكاءٌ':Subject, #1: 1	وَهِيَ الذّكَاءُ
u'وَهِيَ ذِكْرٌ':Subject, #1: 1	وَهِيَ الذّكَاءُ
u'وَهِيَ ذكر':Subject, #1: 1	وَهِيَ ذِكْرٌ
u'وَهِيَ ذِكْرٌ':Subject, #7: 7	وَهِيَ ذِكْرُ
u'وَهِيَ ذُكورَةٌ':Subject, #7: 7	وَهِيَ ذِكْرُ
u'وَهِيَ ذُلٌّ':Subject, #1: 1	وَهِيَ الذُّكُورَةُ
u'وَهِيَ ذِمَّةٌ':Subject, #1: 1	وَهِيَ الذُّلُّ
u'وَهِيَ ذِمَّةٌ':Subject, #1: 1	وَهِيَ ذِمَّةُ
u'وَهِيَ ذِمِّيٌّ':Subject, #2: 2	وَهِيَ الذِّمَّةُ
u'وَهِيَ ذَهَابٌ':Subject, #4: 4	وَهِيَ ذِمِّيَّةٌ
u'وَهِيَ ذَهَبٌ':Subject, #1: 1	وَهِيَ الذَّهَابُ
u'وَهِيَ ذَوْقٌ':Subject, #3: 3	وَهِيَ الذَّهَبُ
u'وَهِيَ راء':Subject, #1: 1	وَهِيَ الذَّوْقُ
u'وَهِيَ رابع':Predicate, #1: 1	وَهِيَ الرّاءُ
u'وَهِيَ رَابِعٌ':Predicate, #1: 1	وَهِيَ الرَّابِعَةَ
u'وَهَى رابع':Predicate, #1: 1	وَهِيَ الرَّابِعَةَ
u'وَهَى رَابِعٌ':Predicate, #1: 1	وَهِيَ الرَّابِعَةَ
u'وَهِيَ رابع':Subject, #1: 1	وَهِيَ الرَّابِعَةَ
u'وَهِيَ رَابِعٌ':Subject, #1: 1	وَهِيَ الرَّابِعُ
u'وَهِيَ رابع':Subject, #1: 1	وَهِيَ الرَّابِعُ
u'وَهِيَ رَابِعٌ':Subject, #1: 1	وَهِيَ رَابِعَةُ
u'وَهِيَ رابع':Subject, #1: 1	وَهِيَ رَابِعَةُ
u'وَهِيَ رَابِعٌ':Subject, #2: 2	وَهِيَ الرَّابِعَةُ
u'وَهِيَ رَاجِحٌ':Subject, #2: 2	وَهِيَ الرَّابِعَةُ
u'وَهِيَ رَاجِعٌ':Subject, #1: 1	وَهِيَ رَاجِحَةٌ
u'وَهِيَ رَاحَةٌ':Subject, #2: 2	وَهِيَ رَاجِعَةٌ
u'وَهِيَ رَاحِلٌ':Subject, #1: 1	وَهِيَ الرَّاحَةُ
u'وَهِيَ رَاحِلَةٌ':Subject, #1: 1	وَهِيَ الرَّاحِلَةُ
u'وَهِيَ رَأْسٌ':Subject, #1: 1	وَهِيَ الرَّاحِلَةُ
u'وَهِيَ رَأْسٌ':Subject, #1: 1	وَهِيَ الرَّأْسُ
u'وَهِيَ رَأْسٌ':Subject, #1: 1	وَهِيَ رَأْسٌ
u'وَهِيَ راغِب':Subject, #3: 3	وَهِيَ رَأْسُ
u'وَهِيَ راغِم':Subject, #2: 2	وَهِيَ رَاغِبَةٌ
u'وَهِيَ رَافِعٌ':Subject, #2: 2	وَهِيَ رَاغِمَةٌ
u'وَهِيَ رَافِعَةٌ':Subject, #1: 1	وَهِيَ الرّافِعَةُ
u'وَهِيَ رَاكِبٌ':Subject, #1: 1	وَهِيَ الرّافِعَةُ
u'وَهِيَ رائِجٌ':Subject, #3: 3	وَهِيَ رَاكِبَةٌ
u'وَهِيَ رَائِدٌ':Subject, #5: 5	وَهِيَ رَائِجَةٌ
u'وَهِيَ رايَة':Subject, #1: 1	وَهِيَ رَائِدٌ
u'وَهِيَ رُبَاعِيُّ':Subject, #1: 1	وَهِيَ الرّايَةُ
u'وَهِيَ رَبْطٌ':Subject, #2: 2	وَهِيَ رُبَاعِيَّةٌ
u'وَهِيَ رُبُعٌ':Subject, #1: 1	وَهِيَ رَبْطُ
u'وَهِيَ رُبْعٌ':Subject, #1: 1	وَهِيَ الرُّبُعُ
u'وَهِيَ رُبْعٌ':Subject, #1: 1	وَهِيَ رُبْعُ
u'وَهِيَ رَبِيبَةٌ':Subject, #2: 2	وَهِيَ الرُّبْعُ
u'وَهِيَ رَبِيعٌ':Subject, #2: 2	وَهِيَ الرَّبِيبَةُ
u'وَهِيَ رُتْبَةٌ':Subject, #1: 1	وَهِيَ الرّبِيعُ
u'وَهِيَ رُتْبَةٌ':Subject, #1: 1	وَهِيَ الرُّتْبَةُ
u'وَهِيَ رَتْقٌ':Subject, #1: 1	وَهِيَ رُتْبَةُ
u'وَهِيَ رَجَب':Subject, #1: 1	وَهِيَ الرَّتْقُ
u'وَهِيَ رجعة':Subject, #1: 1	وَهِيَ الرّجَبِيّةُ
u'وَهِيَ رَجْعَةٌ':Subject, #2: 2	وَهِيَ الرَّجْعَةُ
u'وَهِيَ رَجْعِيٌّ':Subject, #2: 2	وَهِيَ الرَّجْعَةُ
u'وَهِيَ رَجْعِيَّةٌ':Subject, #2: 2	وَهِيَ رَجْعِيَّةٌ
u'وَهِيَ رَجُلٌ':Subject, #2: 2	وَهِيَ رَجْعِيَّةٌ
u'وَهِيَ رُجُوعٌ':Subject, #6: 6	وَهِيَ رَجُلٌ
u'وَهِيَ رَجِيعٌ':Subject, #1: 1	وَهِيَ الرُّجُوعُ
u'وَهِيَ رَحْبَةٌ':Subject, #1: 1	وَهِيَ رَجِيعُ
u'وَهِيَ رحم':Subject, #1: 1	وَهِيَ رَحْبَةٌ
u'وَهِيَ رَحِمٌ':Subject, #2: 2	وَهِيَ الرَّحِمُ
u'وَهِيَ رحمة':Subject, #2: 2	وَهِيَ الرَّحِمُ
u'وَهِيَ رَحْمَةٌ':Subject, #1: 1	وَهِيَ رَحْمَةٌ
u'وَهِيَ رُخْصَةٌ':Subject, #1: 1	وَهِيَ رَحْمَةٌ
u'وَهِيَ رَدٌّ':Subject, #4: 4	وَهِيَ رُخْصَةٌ
u'وَهِيَ رِدَاءٌ':Subject, #1: 1	وَهِيَ الرَّدُّ
u'وَهِيَ رَدِيفٌ':Subject, #2: 2	وَهِيَ الرِّدَاءُ
u'وَهِيَ رِسَالَةٌ':Subject, #1: 1	وَهِيَ رَدِيفَةُ
u'وَهِيَ رِسَالَةٌ':Subject, #2: 2	وَهِيَ الرِّسَالَةُ
u'وَهِيَ رَشيدٌ':Subject, #3: 3	وَهِيَ الرّسَالَةُ
u'وَهِيَ رَطْبَةٌ':Subject, #2: 2	وَهِيَ رَشِيدَةٌ
u'وَهِيَ رُطوبَةٌ':Subject, #9: 9	وَهِيَ رَطْبَةٌ
u'وَهِيَ رَعْيٌ':Subject, #1: 1	وَهِيَ الرُّطُوبَةُ
u'وَهِيَ رَغْوَةٌ':Subject, #1: 1	وَهِيَ الرَّعْيُ
u'وَهِيَ رَغيبَةٌ':Subject, #1: 1	وَهِيَ الرّغْوَةُ
u'وَهِيَ رَفْعٌ':Subject, #3: 3	وَهِيَ رَغِيبَةٌ
u'وَهِيَ رفعة':Subject, #4: 4	وَهِيَ رَفْعُ
u'وَهِيَ رِفْعَةٌ':Subject, #1: 1	وَهِيَ الرِّفْعَةُ
u'وَهِيَ رِقٌّ':Subject, #1: 1	وَهِيَ الرِّفْعَةُ
u'وَهِيَ رَقَبَةٌ':Subject, #3: 3	وَهِيَ الرِّقُّ
u'وَهِيَ رَقَبَةٌ':Subject, #1: 1	وَهِيَ رَقَبَتُهُ
u'وَهِيَ رِقَّةٌ':Subject, #2: 2	وَهِيَ الرَّقَبَةُ
u'وَهِيَ رُقْعَةٌ':Subject, #1: 1	وَهِيَ رِقَّةُ
u'وَهِيَ رَقيقٌ':Subject, #2: 2	وَهِيَ الرُّقْعَةُ
u'وَهِيَ ركعة':Subject, #4: 4	وَهِيَ رَقِيقَةٌ
u'وَهِيَ ركعة':Subject, #1: 1	وَهِيَ رَكْعَةٌ
u'وَهِيَ رَكْعَةٌ':Subject, #1: 1	وَهِيَ رَكْعَةُ
u'وَهِيَ رَكْعَةٌ':Subject, #1: 1	وَهِيَ رَكْعَةٌ
u'وَهِيَ ركعة':Subject, #1: 1	وَهِيَ رَكْعَةُ
u'وَهِيَ رَكْعَةٌ':Subject, #4: 4	وَهِيَ الرَّكْعَةُ
u'وَهِيَ رُكْنٌ':Subject, #4: 4	وَهِيَ الرَّكْعَةُ
u'وَهِيَ رُكْن':Subject, #2: 2	وَهِيَ رُكْنُ
u'وَهِيَ رُكْنٌ':Subject, #2: 2	وَهِيَ رُكْنُ
u'وَهِيَ رُكْن':Subject, #4: 4	وَهِيَ رُكْنٌ
u'وَهِيَ رماح':Subject, #4: 4	وَهِيَ رُكْنٌ
u'وَهِيَ رِماحٌ':Subject, #1: 1	وَهِيَ الرِّمَاحُ
u'وَهِيَ رَمادٌ':Subject, #1: 1	وَهِيَ الرِّمَاحُ
u'وَهِيَ رَمْزٌ':Subject, #1: 1	وَهِيَ الرَّمَادُ
u'وَهِيَ رَمَضانُ':Subject, #1: 1	وَهِيَ رَمْزٌ
u'وَهِيَ رَمْيٌ':Subject, #2: 2	وَهِيَ رَمَضَانُ
u'وَهِيَ رَميمٌ':Subject, #2: 2	وَهِيَ الرَّمْيُ
u'وَهِيَ رَهْنٌ':Subject, #13: 13	وَهِيَ رَمِيمٌ
u'وَهِيَ رِواياتٌ':Subject, #1: 1	وَهِيَ الرَّهْنُ
u'وَهِيَ رِوايَةٌ':Subject, #1: 1	وَهِيَ رِوَايَاتٌ
u'وَهِيَ رِوايَةٌ':Subject, #1: 1	وَهِيَ الرّوَايَةُ
u'وَهِيَ رِوايَةٌ':Subject, #1: 1	وَهِيَ رِوَايَتُهُ
u'وَهِيَ رِوايَةٌ':Subject, #36: 36	وَهِيَ رِوَايَةٌ
u'وَهِيَ رِوايَةٌ':Subject, #66: 66	وَهِيَ رِوَايَةُ
u'وَهِيَ روحٌ':Subject, #6: 6	وَهِيَ الرِّوَايَةُ
u'وَهِيَ رُؤْيَةٌ':Subject, #1: 1	وَهِيَ رُوحُ
u'وَهِيَ ريحٌ':Subject, #2: 2	وَهِيَ رُؤْيَةُ
u'وَهِيَ ريحٌ':Subject, #1: 1	وَهِيَ رِيحٌ
u'وَهِيَ زاجِرٌ':Subject, #1: 1	وَهِيَ رِيحُ
u'وَهِيَ زانِي':Subject, #1: 1	وَهِيَ الزّاجِرُ
u'وَهِيَ زانِي':Subject, #1: 1	وَهِيَ الزّانِيَةُ
u'وَهِيَ زائِدٌ':Subject, #1: 1	وَهِيَ الزَّانِيَةُ
u'وَهِيَ زُبْدِيَّةٌ':Subject, #3: 3	وَهِيَ زَائِدَةٌ
u'وَهِيَ زَجْرٌ':Subject, #1: 1	وَهِيَ الزُّبْدِيَّةُ
u'وَهِيَ زِراعَةٌ':Subject, #2: 2	وَهِيَ الزَّجْرُ
u'وَهِيَ زَرْبٌ':Subject, #1: 1	وَهِيَ الزِّرَاعَةُ
u'وَهِيَ زَكاةٌ':Subject, #1: 1	وَهِيَ الزَّرْبُ
u'وَهِيَ زَكاةٌ':Subject, #1: 1	وَهِيَ زَكَاةُ
u'وَهِيَ زَلَّةٌ':Subject, #2: 2	وَهِيَ الزَّكَاةُ
u'وَهِيَ زَمان':Subject, #1: 1	وَهِيَ زَلَّةٌ
u'وَهِيَ زَمانَة':Subject, #1: 1	وَهِيَ زَمَانِيَّةٌ
u'وَهِيَ زَمانِيّ':Subject, #1: 1	وَهِيَ زَمَانِيَّةٌ
u'وَهِيَ زَمِن':Subject, #1: 1	وَهِيَ زَمَانِيَّةٌ
u'وَهِيَ زَوْجٌ':Subject, #1: 1	وَهِيَ زَمِنَةٌ
u'وَهِيَ زَوْجٌ':Subject, #10: 10	وَهِيَ زَوْجٌ
u'وَهِيَ زَوْجَةٌ':Subject, #1: 1	وَهِيَ الزَّوْجُ
u'وَهِيَ زَوْجَةٌ':Subject, #14: 14	وَهِيَ زَوْجَتُهُ
u'وَهِيَ زَوْجَةٌ':Subject, #15: 15	وَهِيَ زَوْجَةٌ
u'وَهِيَ زَوْجَةٌ':Subject, #3: 3	وَهِيَ الزَّوْجَةُ
u'وَهِيَ زِيادَةٌ':Subject, #3: 3	وَهِيَ زَوْجَةُ
u'وَهِيَ زِيادَةٌ':Subject, #11: 11	وَهِيَ زِيَادَةٌ
u'وَهِيَ زِيادَة':Subject, #1: 1	وَهِيَ الزِّيَادَةُ
u'وَهِيَ زِيادَةٌ':Subject, #1: 1	وَهِيَ الزِّيَادِيَّةُ
u'وَهِيَ زَيْنَبٌ':Subject, #2: 2	وَهِيَ زِيَادَةُ
u'وَهِيَ زُيوفٌ':Subject, #9: 9	وَهِيَ زَيْنَبُ
u'وَهِيَ زُيُوفٌ':Subject, #1: 1	وَهِيَ زُيُوفٌ
u'وَهِيَ ساباط':Subject, #1: 1	وَهِيَ زُيُوفٌ
u'وَهِيَ سابع':Subject, #2: 2	وَهِيَ السَّابَاطُ
u'وَهِيَ سابع':Subject, #1: 1	وَهِيَ سَابِعَةٌ
u'وَهِيَ سَابعٌ':Subject, #1: 1	وَهِيَ سَابِعَةُ
u'وَهِيَ سَابعٌ':Subject, #1: 1	وَهِيَ سَابِعَةٌ
u'وَهِيَ سَابِقٌ':Subject, #1: 1	وَهِيَ سَابِعَةُ
u'وَهِيَ سَاجِدٌ':Subject, #2: 2	وَهِيَ السَّابِقَةُ
u'وَهِيَ سَاحَةٌ':Subject, #1: 1	وَهِيَ سَاجِدَةٌ
u'وَهِيَ سَاحَةٌ':Subject, #1: 1	وَهِيَ السَّاحَاتُ
u'وَهِيَ سَارٌّ':Subject, #1: 1	وَهِيَ السَّاحَةُ
u'وَهِيَ سَاعَةٌ':Predicate, #1: 1	وَهِيَ سَارّةُ
u'وَهَى سَاعَةٌ':Predicate, #1: 1	وَهِيَ السَّاعَةَ
u'وَهِيَ سَاعَةٌ':Subject, #1: 1	وَهِيَ السَّاعَةَ
u'وَهِيَ سَاعَةٌ':Subject, #2: 2	وَهِيَ السَّاعَةُ
u'وَهِيَ سَاقِطٌ':Subject, #3: 3	وَهِيَ سَاعَةٌ
u'وَهِيَ سَاقِطٌ':Subject, #1: 1	وَهِيَ السَّاقِطَةُ
u'وَهِيَ سَاقِطٌ':Subject, #1: 1	وَهِيَ سَاقِطَةٌ
u'وَهِيَ سَاكِتٌ':Predicate, #2: 2	وَهِيَ سَاقِطَةُ
u'وَهَى سَاكِتٌ':Predicate, #1: 1	وَهِيَ سَاكِتَةً
u'وَهِيَ سَاكِتٌ':Subject, #1: 1	وَهِيَ سَاكِتَةً
u'وَهِيَ سَاكِنٌ':Subject, #3: 3	وَهِيَ سَاكِتَةٌ
u'وَهِيَ سَالِمٌ':Subject, #5: 5	وَهِيَ سَاكِنَةٌ
u'وَهِيَ سَائِرٌ':Subject, #4: 4	وَهِيَ سَالِمَةٌ
u'وَهِيَ سَائِمَةٌ':Subject, #1: 1	وَهِيَ سَائِرَةٌ
u'وَهِيَ سَائِمَةٌ':Subject, #1: 1	وَهِيَ السَّائِمَةُ
u'وَهِيَ سَبَبٌ':Subject, #1: 1	وَهِيَ سَائِمَةٌ
u'وَهِيَ سَبَبٌ':Subject, #1: 1	وَهِيَ سَبَبٌ
u'وَهِيَ سَبَبٌ':Subject, #1: 1	وَهِيَ سَبَبُهُ
u'وَهِيَ سَبَبٌ':Subject, #2: 2	وَهِيَ السَّبَبُ
u'وَهِيَ سَبْعٌ':Subject, #5: 5	وَهِيَ سَبَبُ
u'وَهِيَ سَبْعٌ':Subject, #2: 2	وَهِيَ السَّبْعُ
u'وَهِيَ سَبْعٌ':Subject, #3: 3	وَهِيَ سَبْعٌ
u'وَهِيَ سَبْعَةٌ':Predicate, #4: 4	وَهِيَ سَبْعُ
u'وَهَى سَبْعَةٌ':Predicate, #5: 5	وَهِيَ سَبْعَةَ
u'وَهِيَ سَبْعَةٌ':Subject, #5: 5	وَهِيَ سَبْعَةَ
u'وَهِيَ سَبْعَةٌ':Subject, #16: 16	وَهِيَ سَبْعَةٌ
u'وَهِيَ سَبْعَةٌ':Subject, #2: 2	وَهِيَ سَبْعَةُ
u'وَهِيَ سَبْقٌ':Subject, #3: 3	وَهِيَ السَّبْعَةُ
u'وَهِيَ سَبْيٌ':Subject, #1: 1	وَهِيَ سَبْقُ
u'وَهِيَ سَبِيكةٌ':Subject, #1: 1	وَهِيَ سَبْيٌ
u'وَهِيَ سَبِيلٌ':Subject, #1: 1	وَهِيَ السّبِيكَةُ
u'وَهِيَ سِتٌّ':Subject, #1: 1	وَهِيَ سَبِيلٌ
u'وَهِيَ سِتٌّ':Subject, #1: 1	وَهِيَ سِتّةُ
u'وَهِيَ سِتٌّ':Subject, #20: 20	وَهِيَ سِتَّةٌ
u'وَهِيَ سِتٌّ':Subject, #2: 2	وَهِيَ السِّتُّ
u'وَهِيَ سِتٌّ':Subject, #3: 3	وَهِيَ السِّتَّةُ
u'وَهِيَ سِتٌّ':Subject, #5: 5	وَهِيَ سِتٌّ
u'وَهِيَ سِتٌّ':Subject, #5: 5	وَهِيَ سِتُّ
u'وَهِيَ سِتَارَةٌ':Subject, #8: 8	وَهِيَ سِتَّةُ
u'وَهِيَ سَتْرٌ':Subject, #1: 1	وَهِيَ سِتَارَةٌ
u'وَهِيَ سِتْرٌ':Subject, #1: 1	وَهِيَ سَتْرُ
u'وَهِيَ سجدة':Subject, #1: 1	وَهِيَ سِتْرُ
u'وَهِيَ سَجْدَةٌ':Subject, #1: 1	وَهِيَ سَجْدَةُ
u'وَهِيَ سجدة':Subject, #1: 1	وَهِيَ سَجْدَةُ
u'وَهِيَ سَجْدَةٌ':Subject, #2: 2	وَهِيَ السَّجْدَةُ
u'وَهِيَ سُجُودٌ':Subject, #2: 2	وَهِيَ السَّجْدَةُ
u'وَهِيَ سَحْرٌ':Subject, #1: 1	وَهِيَ سُجُودُ
u'وَهِيَ سُحْرٌ':Subject, #1: 1	وَهِيَ السّحْرُ
u'وَهِيَ سِحْرٌ':Subject, #1: 1	وَهِيَ السّحْرُ
u'وَهِيَ سَدٌّ':Subject, #1: 1	وَهِيَ السّحْرُ
u'وَهِيَ سُرْعَةٌ':Subject, #1: 1	وَهِيَ سَدُّ
u'وَهِيَ سُرْعَةٌ':Subject, #1: 1	وَهِيَ السّرْعَةُ
u'وَهِيَ سَرِيعٌ':Subject, #1: 1	وَهِيَ سُرْعَةُ
u'وَهِيَ سَعَةٌ':Subject, #1: 1	وَهِيَ السَّرِيعُ
u'وَهِيَ سُعْلَة':Subject, #1: 1	وَهِيَ السّعَةُ
u'وَهِيَ سفاسف':Subject, #1: 1	وَهِيَ سُعْلَةٌ
u'وَهِيَ سُفْلٌ':Subject, #1: 1	وَهِيَ سَفَاسِفُ
u'وَهِيَ سَفِينَةٌ':Subject, #1: 1	وَهِيَ السُّفْلُ
u'وَهِيَ سُقَاطَةٌ':Subject, #1: 1	وَهِيَ سَفِينَةٌ
u'وَهِيَ سُقُوطٌ':Predicate, #1: 1	وَهِيَ السُّقَاطَةُ
u'وَهَى سُقُوطٌ':Predicate, #1: 1	وَهِيَ السُّقُوطَ
u'وَهِيَ سُقُوطٌ':Subject, #1: 1	وَهِيَ السُّقُوطَ
u'وَهِيَ سُقُوطٌ':Subject, #1: 1	وَهِيَ السُّقُوطُ
u'وَهِيَ سَقِيفَةٌ':Subject, #1: 1	وَهِيَ سُقُوطُ
u'وَهِيَ سِكَّةٌ':Subject, #1: 1	وَهِيَ سَقِيفَةٌ
u'وَهِيَ سُكُوتٌ':Subject, #1: 1	وَهِيَ سِكَّةٌ
u'وَهِيَ سُكُونٌ':Subject, #1: 1	وَهِيَ السُّكُوتُ
u'وَهِيَ سِكِّينٌ':Subject, #1: 1	وَهِيَ السُّكُونُ
u'وَهِيَ سِلاَحٌ':Subject, #1: 1	وَهِيَ السِّكِّينُ
u'وَهِيَ سِلاَحٌ':Subject, #1: 1	وَهِيَ سِلَاحٌ
u'وَهِيَ سِلاَحٌ':Subject, #1: 1	وَهِيَ سِلَاحُ
u'وَهِيَ سلام':Subject, #2: 2	وَهِيَ السِّلَاحُ
u'وَهِيَ سَلاَمٌ':Subject, #1: 1	وَهِيَ السَّلَامُ
u'وَهِيَ سَلاَمَةٌ':Subject, #1: 1	وَهِيَ السَّلَامُ
u'وَهِيَ سَلَبٌ':Subject, #5: 5	وَهِيَ سَلَامَةُ
u'وَهِيَ سَلَّةٌ':Subject, #1: 1	وَهِيَ سَلَبُ
u'وَهِيَ سِلْسلَةٌ':Subject, #1: 1	وَهِيَ السّلّةُ
u'وَهِيَ سُلْطَانٌ':Subject, #1: 1	وَهِيَ سِلْسِلَةُ
u'وَهِيَ سَلَفٌ':Subject, #1: 1	وَهِيَ سُلْطَانُ
u'وَهِيَ سَلَمٌ':Subject, #1: 1	وَهِيَ سَلَفٌ
u'وَهِيَ سمرة':Subject, #1: 1	وَهِيَ السَّلَمُ
u'وَهِيَ سَمْعٌ':Subject, #1: 1	وَهِيَ سَمُرَةٌ
u'وَهِيَ سَمْعٌ':Subject, #1: 1	وَهِيَ سَمْعٌ
u'وَهِيَ سَمِينٌ':Subject, #2: 2	وَهِيَ السَّمْعُ
u'وَهِيَ سَنَةٌ':Predicate, #3: 3	وَهِيَ السَّمِينَةُ
u'وَهَى سَنَةٌ':Predicate, #1: 1	وَهِيَ سَنَةَ
u'وَهِيَ سَنَةٌ':Subject, #1: 1	وَهِيَ سَنَةَ
u'وَهِيَ سُنَّةٌ':Subject, #1: 1	وَهِيَ السَّنَةُ
u'وَهِيَ سُنَّةٌ':Subject, #23: 23	وَهِيَ سُنَّةٌ
u'وَهِيَ سَنَةٌ':Subject, #2: 2	وَهِيَ السُّنَّةُ
u'وَهِيَ سَنَةٌ':Subject, #2: 2	وَهِيَ سَنَةُ
u'وَهِيَ سُنَّةٌ':Subject, #3: 3	وَهِيَ سَنَةٌ
u'وَهِيَ سهام':Subject, #3: 3	وَهِيَ سُنَّةُ
u'وَهِيَ سِهَامٌ':Subject, #1: 1	وَهِيَ سِهَامُ
u'وَهِيَ سَهْلٌ':Subject, #1: 1	وَهِيَ سِهَامُ
u'وَهِيَ سَهْوٌ':Subject, #1: 1	وَهِيَ سَهْلَةٌ
u'وَهِيَ سَهْوٌ':Subject, #1: 1	وَهِيَ السَّهْوُ
u'وَهِيَ سَواءٌ':Subject, #3: 3	وَهِيَ سَهْوٌ
u'وَهِيَ سَوَاحِلُ':Subject, #1: 1	وَهِيَ سَوَاءٌ
u'وَهِيَ سَوادٌ':Subject, #1: 1	وَهِيَ السّوَاحِلُ
u'وَهِيَ سَوادٌ':Subject, #2: 2	وَهِيَ السّوَادُ
u'وَهِيَ سِواكٌ':Subject, #2: 2	وَهِيَ سَوَادٌ
u'وَهِيَ سُؤَالٌ':Subject, #1: 1	وَهِيَ السِّوَاكُ
u'وَهِيَ سَوائِمُ':Subject, #2: 2	وَهِيَ السُّؤَالُ
u'وَهِيَ سَوَائِمُ':Subject, #2: 2	وَهِيَ السَّوَائِمُ
u'وَهِيَ سَوْداء':Subject, #2: 2	وَهِيَ السَّوَائِمُ
u'وَهِيَ سُؤْرٌ':Subject, #4: 4	وَهِيَ سَوْدَاءُ
u'وَهِيَ سُورَةٌ':Subject, #1: 1	وَهِيَ سُؤْرُ
u'وَهِيَ سُورَةٌ':Subject, #1: 1	وَهِيَ السُّورَةُ
u'وَهِيَ سِياحَةٌ':Subject, #1: 1	وَهِيَ سُورَةُ
u'وَهِيَ سِياسَةٌ':Subject, #1: 1	وَهِيَ السِّيَاحَةُ
u'وَهِيَ سَيْرٌ':Subject, #1: 1	وَهِيَ السِّيَاسَةُ
u'وَهِيَ سَيْرٌ':Subject, #1: 1	وَهِيَ السَّيْرُ
u'وَهِيَ سَيْرٌ':Subject, #1: 1	وَهِيَ سَيْرٌ
u'وَهِيَ سِين':Subject, #1: 1	وَهِيَ سَيْرُ
u'وَهِيَ شَابٌّ':Subject, #1: 1	وَهِيَ السِّينُ
u'وَهِيَ شَاةٌ':Subject, #3: 3	وَهِيَ شَابَّةٌ
u'وَهِيَ شَاةٌ':Subject, #1: 1	وَهِيَ الشّاةُ
u'وَهِيَ شَاةٌ':Subject, #2: 2	وَهِيَ الشَّاةُ
u'وَهِيَ شَاذَّ':Subject, #2: 2	وَهِيَ شَاةٌ
u'وَهِيَ شَاذّ':Subject, #3: 3	وَهِيَ شَاذَّةٌ
u'وَهِيَ شَاقٌّ':Subject, #3: 3	وَهِيَ شَاذَّةٌ
u'وَهِيَ شَامِلٌ':Subject, #1: 1	وَهِيَ الشّاقّةُ
u'وَهِيَ شَائِعٌ':Subject, #1: 1	وَهِيَ شَامِلَةٌ
u'وَهِيَ شَائِعَةٌ':Subject, #1: 1	وَهِيَ شَائِعَةٌ
u'وَهِيَ شَبّابَة':Subject, #1: 1	وَهِيَ شَائِعَةٌ
u'وَهِيَ شباك':Subject, #1: 1	وَهِيَ شَبَّابَةٌ
u'وَهِيَ شباك':Subject, #1: 1	وَهِيَ شِبَاكٌ
u'وَهِيَ شِبَاكٌ':Subject, #1: 1	وَهِيَ شِبَاكُ
u'وَهِيَ شِبَاكٌ':Subject, #1: 1	وَهِيَ شِبَاكٌ
u'وَهِيَ شِبْهٌ':Subject, #1: 1	وَهِيَ شِبَاكُ
u'وَهِيَ شُبْهَةٌ':Subject, #1: 1	وَهِيَ شِبْهُ
u'وَهِيَ شَبِيهٌ':Subject, #2: 2	وَهِيَ شُبْهَةُ
u'وَهِيَ شجَاعٌ':Subject, #1: 1	وَهِيَ شَبِيهَةُ
u'وَهِيَ شَجْبٌ':Subject, #1: 1	وَهِيَ الشُّجَاعَةُ
u'وَهِيَ شَجَرَةٌ':Subject, #1: 1	وَهِيَ الشّجْبُ
u'وَهِيَ شَجَرَةٌ':Subject, #2: 2	وَهِيَ الشَّجَرَةُ
u'وَهِيَ شجعان':Subject, #3: 3	وَهِيَ شَجَرَةٌ
u'وَهِيَ شِدَّةٌ':Subject, #1: 1	وَهِيَ الشُّجْعَانُ
u'وَهِيَ شِدَّةٌ':Subject, #1: 1	وَهِيَ شِدّتُهُ
u'وَهِيَ شِدَّةٌ':Subject, #2: 2	وَهِيَ شِدّةُ
u'وَهِيَ شَدِيدٌ':Subject, #3: 3	وَهِيَ شِدَّةُ
u'وَهِيَ شِرَاءٌ':Subject, #1: 1	وَهِيَ الشّدِيدَةُ
u'وَهِيَ شرب':Subject, #4: 4	وَهِيَ شِرَاءُ
u'وَهِيَ شُرْبٌ':Subject, #1: 1	وَهِيَ الشُّرْبُ
u'وَهِيَ شَرْطٌ':Subject, #1: 1	وَهِيَ الشُّرْبُ
u'وَهِيَ شَرْطٌ':Subject, #18: 18	وَهِيَ شَرْطٌ
u'وَهِيَ شَرْطٌ':Subject, #4: 4	وَهِيَ الشَّرْطُ
u'وَهِيَ شَرْعٌ':Subject, #9: 9	وَهِيَ شَرْطُ
u'وَهِيَ شَرْعِيٌّ':Subject, #1: 1	وَهِيَ شَرْعُ
u'وَهِيَ شَرْعِيٌّ':Subject, #1: 1	وَهِيَ شَرْعِيَّةٌ
u'وَهِيَ شرف':Subject, #3: 3	وَهِيَ الشَّرْعِيَّةُ
u'وَهِيَ شَرَفٌ':Subject, #1: 1	وَهِيَ الشَّرَفُ
u'وَهِيَ شرف':Subject, #1: 1	وَهِيَ الشَّرَفُ
u'وَهِيَ شَرَفٌ':Subject, #1: 1	وَهِيَ شَرَفُ
u'وَهِيَ شَرْقِيٌّ':Subject, #1: 1	وَهِيَ شَرَفُ
u'وَهِيَ شِرْكٌ':Subject, #1: 1	وَهِيَ الشَّرْقِيَّةُ
u'وَهِيَ شركة':Subject, #1: 1	وَهِيَ الشِّرْكُ
u'وَهِيَ شَرِكَةٌ':Subject, #1: 1	وَهِيَ الشَّرِكَةُ
u'وَهِيَ شركة':Subject, #1: 1	وَهِيَ الشَّرِكَةُ
u'وَهِيَ شَرِكَةٌ':Subject, #4: 4	وَهِيَ شَرِكَةُ
u'وَهِيَ شُرُوطٌ':Subject, #4: 4	وَهِيَ شَرِكَةُ
u'وَهِيَ شَرِيعَةٌ':Subject, #1: 1	وَهِيَ الشُّرُوطُ
u'وَهِيَ شعار':Subject, #1: 1	وَهِيَ شَرِيعَةُ
u'وَهِيَ شِعَارٌ':Subject, #2: 2	وَهِيَ شِعَارُ
u'وَهِيَ شُعْبَةٌ':Subject, #2: 2	وَهِيَ شِعَارُ
u'وَهِيَ شَعْرٌ':Subject, #1: 1	وَهِيَ الشُّعْبَةُ
u'وَهِيَ شَعْرٌ':Subject, #2: 2	وَهِيَ شَعْرُ
u'وَهِيَ شَعِيرَةٌ':Subject, #3: 3	وَهِيَ الشَّعْرُ
u'وَهِيَ شَعِيرَة':Subject, #2: 2	وَهِيَ شَعِيرَةٌ
u'وَهِيَ شِفَاءٌ':Subject, #2: 2	وَهِيَ شَعِيرَةٌ
u'وَهِيَ شَفَاعَةٌ':Subject, #1: 1	وَهِيَ شِفَاءٌ
u'وَهِيَ شَفْرَةٌ':Subject, #3: 3	وَهِيَ الشَّفَاعَةُ
u'وَهِيَ شِقَّةٌ':Subject, #1: 1	وَهِيَ الشَّفْرَةُ
u'وَهِيَ شمس':Subject, #1: 1	وَهِيَ شِقّةٌ
u'وَهِيَ شَمْسٌ':Subject, #1: 1	وَهِيَ الشَّمْسُ
u'وَهِيَ شَنْشَن':Subject, #1: 1	وَهِيَ الشَّمْسُ
u'وَهِيَ شَنْشَنَة':Subject, #1: 1	وَهِيَ شَنْشَنَةٌ
u'وَهِيَ شَهَادَةٌ':Subject, #1: 1	وَهِيَ شَنْشَنَةٌ
u'وَهِيَ شَهَادَةٌ':Subject, #1: 1	وَهِيَ شَهَادَاتٌ
u'وَهِيَ شَهَادَةٌ':Subject, #2: 2	وَهِيَ شَهَادَةٌ
u'وَهِيَ شَهَادَةٌ':Subject, #3: 3	وَهِيَ الشَّهَادَةُ
u'وَهِيَ شَهْوَةٌ':Subject, #8: 8	وَهِيَ شَهَادَةُ
u'وَهِيَ شُهُودٌ':Subject, #1: 1	وَهِيَ الشَّهْوَةُ
u'وَهِيَ شَوَّالٌ':Subject, #1: 1	وَهِيَ شُهُودُ
u'وَهِيَ شَوَّالٌ':Subject, #1: 1	وَهِيَ شَوَّالُ
u'وَهِيَ شَوْكَةٌ':Subject, #2: 2	وَهِيَ شَوَّالٌ
u'وَهِيَ شَيْءٌ':Subject, #1: 1	وَهِيَ شَوْكَةٌ
u'وَهِيَ شَيْءٌ':Subject, #1: 1	وَهِيَ الشَّيْءُ
u'وَهِيَ شَيْخٌ':Subject, #7: 7	وَهِيَ شَيْءٌ
u'وَهِيَ شَيْخ':Subject, #1: 1	وَهِيَ الشَّيْخُ
u'وَهِيَ شَيْخَة':Subject, #1: 1	وَهِيَ شَيْخَةٌ
u'وَهِيَ صَاحِبٌ':Subject, #1: 1	وَهِيَ شَيْخَةٌ
u'وَهِيَ صَادِرٌ':Subject, #1: 1	وَهِيَ صَاحِبَةُ
u'وَهِيَ صَادِقٌ':Subject, #2: 2	وَهِيَ صَادِرَةٌ
u'وَهِيَ صَاعٌ':Subject, #4: 4	وَهِيَ صَادِقَةٌ
u'وَهِيَ صَالِحٌ':Subject, #1: 1	وَهِيَ صَاعٌ
u'وَهِيَ صَالِح':Subject, #5: 5	وَهِيَ صَالِحَةٌ
u'وَهِيَ صَائِمٌ':Subject, #5: 5	وَهِيَ صَالِحَةٌ
u'وَهِيَ صُبْحٌ':Subject, #8: 8	وَهِيَ صَائِمَةٌ
u'وَهِيَ صُبْحَةٌ':Subject, #1: 1	وَهِيَ الصُّبْحُ
u'وَهِيَ صِحَّةٌ':Subject, #1: 1	وَهِيَ الصُّبْحَةُ
u'وَهِيَ صِحَّةٌ':Subject, #2: 2	وَهِيَ الصِّحَّةُ
u'وَهِيَ صَحْرَاءُ':Subject, #4: 4	وَهِيَ صِحَّةُ
u'وَهِيَ صَحِيحٌ':Subject, #1: 1	وَهِيَ صَحْرَاءُ
u'وَهِيَ صَحِيحٌ':Subject, #1: 1	وَهِيَ الصَّحِيحُ
u'وَهِيَ صَحِيحٌ':Subject, #27: 27	وَهِيَ الصَّحِيحَةُ
u'وَهِيَ صَحِيفَةٌ':Subject, #3: 3	وَهِيَ صَحِيحَةُ
u'وَهِيَ صَحِيفَةٌ':Subject, #1: 1	وَهِيَ الصّحِيفَةُ
u'وَهِيَ صَخْرَةٌ':Subject, #1: 1	وَهِيَ صَحِيفَةٌ
u'وَهِيَ صَخْرَةٌ':Subject, #1: 1	وَهِيَ الصّخْرَةُ
u'وَهِيَ صَدْرٌ':Subject, #2: 2	وَهِيَ صَخْرَةٌ
u'وَهِيَ صدق':Subject, #1: 1	وَهِيَ الصَّدْرُ
u'وَهِيَ صِدْقٌ':Subject, #1: 1	وَهِيَ الصِّدْقُ
u'وَهِيَ صدقة':Subject, #1: 1	وَهِيَ الصِّدْقُ
u'وَهِيَ صَدَقَةٌ':Subject, #1: 1	وَهِيَ صَدَقَةُ
u'وَهِيَ صدقة':Subject, #1: 1	وَهِيَ صَدَقَةُ
u'وَهِيَ صَدَقَةٌ':Subject, #2: 2	وَهِيَ الصَّدَقَةُ
u'وَهِيَ صدقة':Subject, #2: 2	وَهِيَ الصَّدَقَةُ
u'وَهِيَ صَدَقَةٌ':Subject, #5: 5	وَهِيَ صَدَقَةٌ
u'وَهِيَ صَرْفٌ':Subject, #5: 5	وَهِيَ صَدَقَةٌ
u'وَهِيَ صَرْف':Subject, #1: 1	وَهِيَ صَرْفُ
u'وَهِيَ صَرِيحٌ':Subject, #1: 1	وَهِيَ صَرْفُ
u'وَهِيَ صعاب':Subject, #12: 12	وَهِيَ صَرِيحَةٌ
u'وَهِيَ صغار':Subject, #2: 2	وَهِيَ صِعَابُ
u'وَهِيَ صغار':Subject, #1: 1	وَهِيَ الصِّغَارُ
u'وَهِيَ صغار':Subject, #2: 2	وَهِيَ صِغَارٌ
u'وَهِيَ صِغَرٌ':Subject, #3: 3	وَهِيَ صِغَارُ
u'وَهِيَ صَغِيرٌ':Predicate, #2: 2	وَهِيَ الصِّغَرُ
u'وَهَى صَغِيرٌ':Predicate, #2: 2	وَهِيَ صَغِيرَةً
u'وَهِيَ صَغِيرٌ':Subject, #2: 2	وَهِيَ صَغِيرَةً
u'وَهِيَ صَغِيرٌ':Subject, #1: 1	وَهِيَ صَغِيرَةُ
u'وَهِيَ صَغِيرٌ':Subject, #3: 3	وَهِيَ الصَّغِيرَةُ
u'وَهِيَ صِفَةٌ':Subject, #49: 49	وَهِيَ صَغِيرَةٌ
u'وَهِيَ صِفَةٌ':Subject, #1: 1	وَهِيَ صِفَاتُ
u'وَهِيَ صِفَةٌ':Subject, #2: 2	وَهِيَ صِفَةُ
u'وَهِيَ صَفْراوِيّ':Subject, #9: 9	وَهِيَ صِفَةٌ
u'وَهِيَ صَكٌّ':Subject, #1: 1	وَهِيَ صَفْرَاوِيَّةٌ
u'وَهِيَ صَلاَةٌ':Subject, #1: 1	وَهِيَ الصَّكُّ
u'وَهِيَ صَلاَةٌ':Subject, #22: 22	وَهِيَ صَلَاةُ
u'وَهِيَ صَلاَةٌ':Subject, #2: 2	وَهِيَ صَلَاتُهُ
u'وَهِيَ صَلاَةٌ':Subject, #4: 4	وَهِيَ صَلَاةٌ
u'وَهِيَ صلح':Subject, #7: 7	وَهِيَ الصَّلَاةُ
u'وَهِيَ صُلْحٌ':Subject, #1: 1	وَهِيَ الصُّلْحُ
u'وَهِيَ صُلْحٌ':Subject, #1: 1	وَهِيَ الصُّلْحُ
u'وَهِيَ صَلْصَلَةٌ':Subject, #1: 1	وَهِيَ صُلْحٌ
u'وَهِيَ صَلَوَاتٌ':Subject, #1: 1	وَهِيَ صَلْصَلَةُ
u'وَهِيَ صَمَّاء':Subject, #1: 1	وَهِيَ الصَّلَوَاتُ
u'وَهِيَ صِنَاعَةٌ':Subject, #1: 1	وَهِيَ الصَّمَّاءُ
u'وَهِيَ صِنْفٌ':Subject, #1: 1	وَهِيَ الصِّنَاعَةُ
u'وَهِيَ صَنَمٌ':Subject, #1: 1	وَهِيَ صِنْفٌ
u'وَهِيَ صَوَابٌ':Subject, #1: 1	وَهِيَ الصَّنَمُ
u'وَهِيَ صَوْتٌ':Subject, #13: 13	وَهِيَ الصَّوَابُ
u'وَهِيَ صَوْتٌ':Subject, #1: 1	وَهِيَ صَوْتُهُ
u'وَهِيَ صُورٌ':Subject, #2: 2	وَهِيَ الصَّوْتُ
u'وَهِيَ صُوَرٌ':Subject, #1: 1	وَهِيَ الصُّوَرُ
u'وَهِيَ صُورٌ':Subject, #1: 1	وَهِيَ الصُّوَرُ
u'وَهِيَ صُوَرٌ':Subject, #1: 1	وَهِيَ صُوَرُ
u'وَهِيَ صُورَةٌ':Subject, #1: 1	وَهِيَ صُوَرُ
u'وَهِيَ صُورَةٌ':Subject, #1: 1	وَهِيَ صُورَةٌ
u'وَهِيَ صُورَةٌ':Subject, #2: 2	وَهِيَ الصُّورَةُ
u'وَهِيَ صَوْمٌ':Subject, #4: 4	وَهِيَ صُورَةُ
u'وَهِيَ صَوْنٌ':Subject, #1: 1	وَهِيَ الصَّوْمُ
u'وَهِيَ صِيَانَةٌ':Subject, #1: 1	وَهِيَ صَوْنُ
u'وَهِيَ صَيْدٌ':Subject, #1: 1	وَهِيَ صِيَانَةُ
u'وَهِيَ صَيْرُورَة':Subject, #2: 2	وَهِيَ الصَّيْدُ
u'وَهِيَ صِيغَةٌ':Subject, #1: 1	وَهِيَ صَيْرُورَةُ
u'وَهِيَ صِيغَةٌ':Subject, #1: 1	وَهِيَ الصِّيغَةُ
u'وَهِيَ صِيغَةٌ':Subject, #2: 2	وَهِيَ صِيغَةٌ
u'وَهِيَ ضَامِنٌ':Subject, #3: 3	وَهِيَ صِيغَةُ
u'وَهِيَ ضَأْنٌ':Subject, #1: 1	وَهِيَ ضَامِنَةٌ
u'وَهِيَ ضَائِعٌ':Subject, #1: 1	وَهِيَ ضَأْنٌ
u'وَهِيَ ضَبْطٌ':Subject, #1: 1	وَهِيَ ضَائِعَةٌ
u'وَهِيَ ضَخَامَةٌ':Subject, #1: 1	وَهِيَ ضَبْطُ
u'وَهِيَ ضِدٌّ':Subject, #2: 2	وَهِيَ الضَّخَامَةُ
u'وَهِيَ ضَرْبٌ':Subject, #4: 4	وَهِيَ ضِدُّ
u'وَهِيَ ضَرْبٌ':Subject, #1: 1	وَهِيَ ضَرْبٌ
u'وَهِيَ ضَرُورَةٌ':Subject, #1: 1	وَهِيَ ضَرْبُ
u'وَهِيَ ضَرُورَةٌ':Subject, #1: 1	وَهِيَ ضَرُورَةٌ
u'وَهِيَ ضِعْفٌ':Subject, #1: 1	وَهِيَ ضَرُورَةُ
u'وَهِيَ ضَعِيفٌ':Subject, #1: 1	وَهِيَ ضِعْفُ
u'وَهِيَ ضلع':Subject, #1: 1	وَهِيَ ضَعِيفَةُ
u'وَهِيَ ضِلْعٌ':Subject, #1: 1	وَهِيَ الضِّلْعُ
u'وَهِيَ ضَمٌّ':Subject, #1: 1	وَهِيَ الضِّلْعُ
u'وَهِيَ ضَمَانٌ':Subject, #1: 1	وَهِيَ الضَّمُّ
u'وَهِيَ ضَمَانٌ':Subject, #1: 1	وَهِيَ الضَّمَانُ
u'وَهِيَ ضَمِيرٌ':Subject, #2: 2	وَهِيَ ضَمَانُ
u'وَهِيَ ضِيَافَةٌ':Subject, #1: 1	وَهِيَ ضَمِيرُ
u'وَهِيَ ضِيَافَةٌ':Subject, #1: 1	وَهِيَ الضِّيَافَةُ
u'وَهِيَ طَارِئٌ':Subject, #1: 1	وَهِيَ ضِيَافَةُ
u'وَهِيَ طَاعَةٌ':Subject, #1: 1	وَهِيَ طَارِئَةٌ
u'وَهِيَ طَاقَةٌ':Subject, #1: 1	وَهِيَ طَاعَةُ
u'وَهِيَ طَالِقٌ':Subject, #1: 1	وَهِيَ الطَّاقَةُ
u'وَهِيَ طَاهِرٌ':Subject, #3: 3	وَهِيَ طَالِقٌ
u'وَهِيَ طَاهِرٌ':Subject, #12: 12	وَهِيَ طَاهِرٌ
u'وَهِيَ طَائِرٌ':Subject, #15: 15	وَهِيَ طَاهِرَةٌ
u'وَهِيَ طَائِعٌ':Subject, #3: 3	وَهِيَ طَائِرٌ
u'وَهِيَ طَائِفٌ':Subject, #3: 3	وَهِيَ طَائِعَةٌ
u'وَهِيَ طَبَر':Subject, #1: 1	وَهِيَ طَائِفَةٌ
u'وَهِيَ طَبَرِيّ':Subject, #1: 1	وَهِيَ طَبَرِيَّةٌ
u'وَهِيَ طَبَقَةٌ':Subject, #1: 1	وَهِيَ طَبَرِيَّةٌ
u'وَهِيَ طَبْلٌ':Subject, #1: 1	وَهِيَ الطَّبَقَةُ
u'وَهِيَ طرف':Subject, #1: 1	وَهِيَ طَبْلٌ
u'وَهِيَ طَرَفٌ':Subject, #1: 1	وَهِيَ الطَّرَفُ
u'وَهِيَ طرف':Subject, #1: 1	وَهِيَ الطَّرَفُ
u'وَهِيَ طَرَفٌ':Subject, #1: 1	وَهِيَ طَرَفُ
u'وَهِيَ طُرُقٌ':Subject, #1: 1	وَهِيَ طَرَفُ
u'وَهِيَ طَرِيٌّ':Subject, #1: 1	وَهِيَ طُرُقُ
u'وَهِيَ طَرِيقٌ':Subject, #1: 1	وَهِيَ طَرِيَّةٌ
u'وَهِيَ طَرِيقٌ':Subject, #1: 1	وَهِيَ الطّرِيقُ
u'وَهِيَ طَرِيقٌ':Subject, #2: 2	وَهِيَ الطَّرِيقُ
u'وَهِيَ طَرِيقٌ':Subject, #2: 2	وَهِيَ طَرِيقُهُ
u'وَهِيَ طَرِيقٌ':Subject, #3: 3	وَهِيَ طَرِيقٌ
u'وَهِيَ طَرِيقَةٌ':Subject, #4: 4	وَهِيَ طَرِيقُ
u'وَهِيَ طَرِيقَةٌ':Subject, #11: 11	وَهِيَ الطَّرِيقَةُ
u'وَهِيَ طَرِيقَةٌ':Subject, #21: 21	وَهِيَ طَرِيقَتُهُ
u'وَهِيَ طَرِيقَةٌ':Subject, #259: 259	وَهِيَ طَرِيقَةُ
u'وَهِيَ طعام':Subject, #9: 9	وَهِيَ طَرِيقَةٌ
u'وَهِيَ طَعَامٌ':Subject, #1: 1	وَهِيَ طَعَامٌ
u'وَهِيَ طعام':Subject, #1: 1	وَهِيَ طَعَامٌ
u'وَهِيَ طَعَامٌ':Subject, #2: 2	وَهِيَ الطَّعَامُ
u'وَهِيَ طعام':Subject, #2: 2	وَهِيَ الطَّعَامُ
u'وَهِيَ طَعَامٌ':Subject, #2: 2	وَهِيَ طَعَامُ
u'وَهِيَ طُعْمٌ':Subject, #2: 2	وَهِيَ طَعَامُ
u'وَهِيَ طَعْنٌ':Subject, #1: 1	وَهِيَ الطُّعْمُ
u'وَهِيَ طِفْلٌ':Predicate, #1: 1	وَهِيَ طَعْنُ
u'وَهَى طِفْلٌ':Predicate, #1: 1	وَهِيَ طِفْلَةً
u'وَهِيَ طَلاَقٌ':Subject, #1: 1	وَهِيَ طِفْلَةً
u'وَهِيَ طُلُوعٌ':Subject, #3: 3	وَهِيَ الطَّلَاقُ
u'وَهِيَ طَهَارَةٌ':Subject, #1: 1	وَهِيَ طُلُوعُ
u'وَهِيَ طَهَارَةٌ':Subject, #1: 1	وَهِيَ طَهَارَةٌ
u'وَهِيَ طهرة':Subject, #9: 9	وَهِيَ الطَّهَارَةُ
u'وَهِيَ طُهْرَةٌ':Subject, #1: 1	وَهِيَ طُهْرَةٌ
u'وَهِيَ طواف':Subject, #1: 1	وَهِيَ طُهْرَةٌ
u'وَهِيَ طَوَافٌ':Subject, #1: 1	وَهِيَ طَوَافٌ
u'وَهِيَ طواف':Subject, #1: 1	وَهِيَ طَوَافٌ
u'وَهِيَ طَوَافٌ':Subject, #3: 3	وَهِيَ الطَّوَافُ
u'وَهِيَ طوال':Subject, #3: 3	وَهِيَ الطَّوَافُ
u'وَهِيَ طُوَالٌ':Subject, #1: 1	وَهِيَ الطّوَالُ
u'وَهِيَ طَوَائِفُ':Subject, #1: 1	وَهِيَ الطّوَالُ
u'وَهِيَ طَوْرٌ':Subject, #1: 1	وَهِيَ طَوَائِفُ
u'وَهِيَ طَوْفٌ':Subject, #1: 1	وَهِيَ طَوْرُ
u'وَهِيَ طُولٌ':Subject, #1: 1	وَهِيَ الطَّوْفُ
u'وَهِيَ طَوِيلٌ':Subject, #1: 1	وَهِيَ طُولُ
u'وَهِيَ طَيِّبٌ':Subject, #1: 1	وَهِيَ الطَّوِيلُ
u'وَهِيَ طِينٌ':Subject, #2: 2	وَهِيَ الطَّيِّبَةُ
u'وَهِيَ ظالِمٌ':Subject, #2: 2	وَهِيَ الطِّينُ
u'وَهِيَ ظاهِرٌ':Subject, #5: 5	وَهِيَ ظَالِمَةٌ
u'وَهِيَ ظاهِرٌ':Subject, #23: 23	وَهِيَ ظَاهِرُ
u'وَهِيَ ظاهِرٌ':Subject, #2: 2	وَهِيَ الظَّاهِرَةُ
u'وَهِيَ ظاهِرٌ':Subject, #2: 2	وَهِيَ ظَاهِرَةُ
u'وَهِيَ ظاهِرَة':Subject, #6: 6	وَهِيَ ظَاهِرَةٌ
u'وَهِيَ ظاهِرَة':Subject, #2: 2	وَهِيَ الظَّاهِرَةُ
u'وَهِيَ ظاهِرَة':Subject, #2: 2	وَهِيَ ظَاهِرَةُ
u'وَهِيَ ظَرْف':Subject, #6: 6	وَهِيَ ظَاهِرَةٌ
u'وَهِيَ ظَرْفِيّ':Subject, #1: 1	وَهِيَ الظَّرْفِيَّةُ
u'وَهِيَ ظُروفٌ':Subject, #1: 1	وَهِيَ الظَّرْفِيَّةُ
u'وَهِيَ ظُلْمٌ':Subject, #1: 1	وَهِيَ ظُرُوفُ
u'وَهِيَ ظلمة':Subject, #1: 1	وَهِيَ ظُلْمٌ
u'وَهِيَ ظُلْمَةٌ':Subject, #1: 1	وَهِيَ الظّلْمَةُ
u'وَهِيَ ظَنٌّ':Subject, #1: 1	وَهِيَ الظّلْمَةُ
u'وَهِيَ ظَنّ':Subject, #1: 1	وَهِيَ الظَّنُّ
u'وَهِيَ ظَنِّيّ':Subject, #1: 1	وَهِيَ ظَنِّيَّةٌ
u'وَهِيَ ظُهْرٌ':Subject, #1: 1	وَهِيَ ظَنِّيَّةٌ
u'وَهِيَ ظُهْرٌ':Subject, #1: 1	وَهِيَ ظُهْرُ
u'وَهِيَ ظُهورٌ':Subject, #8: 8	وَهِيَ الظُّهْرُ
u'وَهِيَ عَاجِزٌ':Subject, #1: 1	وَهِيَ ظُهُورُ
u'وَهِيَ عَادَةٌ':Subject, #1: 1	وَهِيَ عَاجِزَةٌ
u'وَهِيَ عادِم':Subject, #1: 1	وَهِيَ الْعَادَةُ
u'وَهِيَ عَارِضٌ':Subject, #1: 1	وَهِيَ عَادِمَةٌ
u'وَهِيَ عارِيَّةٌ':Subject, #1: 1	وَهِيَ عَارِضٌ
u'وَهِيَ عارِيَّةٌ':Subject, #1: 1	وَهِيَ عَارِيَّةٌ
u'وَهِيَ عَاشِرٌ':Subject, #2: 2	وَهِيَ الْعَارِيَّةُ
u'وَهِيَ عَاصِي':Subject, #4: 4	وَهِيَ الْعَاشِرَةُ
u'وَهِيَ عاطِش':Subject, #1: 1	وَهِيَ عَاصِيَةٌ
u'وَهِيَ عَاطِفٌ':Subject, #1: 1	وَهِيَ عَاطِشَةٌ
u'وَهِيَ عَاطِفَةٌ':Subject, #1: 1	وَهِيَ عَاطِفَةٌ
u'وَهِيَ عَاقِبٌ':Subject, #1: 1	وَهِيَ عَاطِفَةٌ
u'وَهِيَ عَاقِبَةٌ':Subject, #1: 1	وَهِيَ الْعَاقِبَةُ
u'وَهِيَ عَاقِدٌ':Subject, #1: 1	وَهِيَ الْعَاقِبَةُ
u'وَهِيَ عَاقِلٌ':Subject, #3: 3	وَهِيَ عَاقِدَةٌ
u'وَهِيَ عَالَمٌ':Subject, #2: 2	وَهِيَ عَاقِلَةٌ
u'وَهِيَ عَالِمٌ':Subject, #1: 1	وَهِيَ الْعَالَمُ
u'وَهِيَ عَامٌ':Subject, #1: 1	وَهِيَ عَالِمَةٌ
u'وَهِيَ عَامٌّ':Subject, #1: 1	وَهِيَ الْعَامُ
u'وَهِيَ عَامٌّ':Subject, #2: 2	وَهِيَ عَامَّةُ
u'وَهِيَ عَامِلٌ':Subject, #9: 9	وَهِيَ عَامَّةٌ
u'وَهِيَ عَائِدٌ':Subject, #2: 2	وَهِيَ عَامِلَةٌ
u'وَهِيَ عِبَادَةٌ':Subject, #1: 1	وَهِيَ عَائِدَةٌ
u'وَهِيَ عِبَادَةٌ':Subject, #1: 1	وَهِيَ عِبَادَةُ
u'وَهِيَ عِبَادَةٌ':Subject, #2: 2	وَهِيَ الْعِبَادَاتُ
u'وَهِيَ عِبَارَةٌ':Subject, #6: 6	وَهِيَ عِبَادَةٌ
u'وَهِيَ عِبَارَةٌ':Subject, #12: 12	وَهِيَ عِبَارَةُ
u'وَهِيَ عِبَارَةٌ':Subject, #1: 1	وَهِيَ الْعِبَارَةُ
u'وَهِيَ عَبْد':Subject, #26: 26	وَهِيَ عِبَارَةٌ
u'وَهِيَ عَبْدٌ':Subject, #1: 1	وَهِيَ الْعَبْدِيَّةُ
u'وَهِيَ عَبْدِيّ':Subject, #3: 3	وَهِيَ عَبْدٌ
u'وَهِيَ عِتْقٌ':Subject, #1: 1	وَهِيَ الْعَبْدِيَّةُ
u'وَهِيَ عتق':Subject, #1: 1	وَهِيَ عِتْقٌ
u'وَهِيَ عِتْقٌ':Subject, #2: 2	وَهِيَ عِتْقُ
u'وَهِيَ عتق':Subject, #2: 2	وَهِيَ عِتْقُ
u'وَهِيَ عِتْقٌ':Subject, #3: 3	وَهِيَ الْعِتْقُ
u'وَهِيَ عتمة':Subject, #3: 3	وَهِيَ الْعِتْقُ
u'وَهِيَ عَتَمَةٌ':Subject, #2: 2	وَهِيَ الْعَتَمَةُ
u'وَهِيَ عَثْرَةٌ':Subject, #2: 2	وَهِيَ الْعَتَمَةُ
u'وَهِيَ عجز':Subject, #2: 2	وَهِيَ عَثْرَةٌ
u'وَهِيَ عَجْزٌ':Subject, #1: 1	وَهِيَ عَجْزُ
u'وَهِيَ عجز':Subject, #1: 1	وَهِيَ عَجْزُ
u'وَهِيَ عَجْزٌ':Subject, #2: 2	وَهِيَ الْعَجْزُ
u'وَهِيَ عجماء':Subject, #2: 2	وَهِيَ الْعَجْزُ
u'وَهِيَ عَجْمَاءُ':Subject, #1: 1	وَهِيَ عَجْمَاءُ
u'وَهِيَ عَجْوَةٌ':Subject, #1: 1	وَهِيَ عَجْمَاءُ
u'وَهِيَ عَجُوزٌ':Subject, #1: 1	وَهِيَ عَجْوَةٌ
u'وَهِيَ عَدٌّ':Subject, #1: 1	وَهِيَ الْعَجُوزُ
u'وَهِيَ عَدَالَةٌ':Subject, #1: 1	وَهِيَ عَدُّ
u'وَهِيَ عَدَاوَةٌ':Subject, #1: 1	وَهِيَ عَدَالَةُ
u'وَهِيَ عِدَّةٌ':Subject, #1: 1	وَهِيَ الْعَدَاوَةُ
u'وَهِيَ عِدَّةٌ':Subject, #3: 3	وَهِيَ عِدَّةُ
u'وَهِيَ عَدَدٌ':Subject, #5: 5	وَهِيَ الْعِدَّةُ
u'وَهِيَ عَدَدِيٌّ':Subject, #2: 2	وَهِيَ عَدَدُ
u'وَهِيَ عَدَدِيٌّ':Subject, #1: 1	وَهِيَ عَدَدِيٌّ
u'وَهِيَ عدلة':Subject, #1: 1	وَهِيَ عَدَدِيَّةٌ
u'وَهِيَ عَدَمٌ':Subject, #1: 1	وَهِيَ عَدْلَةٌ
u'وَهِيَ عَدَم':Subject, #11: 11	وَهِيَ عَدَمُ
u'وَهِيَ عَدَمِيّ':Subject, #1: 1	وَهِيَ عَدَمِيَّةٌ
u'وَهِيَ عَدَمِيَّة':Subject, #1: 1	وَهِيَ عَدَمِيَّةٌ
u'وَهِيَ عَذْرَاءُ':Subject, #1: 1	وَهِيَ عَدَمِيَّةٌ
u'وَهِيَ عَرَضٌ':Subject, #2: 2	وَهِيَ عَذْرَاءُ
u'وَهِيَ عَرْضٌ':Subject, #1: 1	وَهِيَ عَرَضٌ
u'وَهِيَ عَرْضٌ':Subject, #1: 1	وَهِيَ عَرْضُ
u'وَهِيَ عُرْفِيٌّ':Subject, #3: 3	وَهِيَ عَرْضٌ
u'وَهِيَ عُرْوَةٌ':Subject, #2: 2	وَهِيَ الْعُرْفِيَّةُ
u'وَهِيَ عَرُوسٌ':Subject, #1: 1	وَهِيَ عُرْوَةُ
u'وَهِيَ عَرُوسٌ':Subject, #2: 2	وَهِيَ الْعَرُوسُ
u'وَهِيَ عُرُوقٌ':Subject, #2: 2	وَهِيَ عَرُوسٌ
u'وَهِيَ عُرُوقٌ':Subject, #1: 1	وَهِيَ الْعُرُوقُ
u'وَهِيَ عُرْيَانٌ':Subject, #1: 1	وَهِيَ عُرُوقُ
u'وَهِيَ عَرِيضَةٌ':Subject, #5: 5	وَهِيَ عُرْيَانَةٌ
u'وَهِيَ عَزَائِمُ':Subject, #1: 1	وَهِيَ عَرِيضَةٌ
u'وَهِيَ عَزِيمَةٌ':Subject, #1: 1	وَهِيَ الْعَزَائِمُ
u'وَهِيَ عُسْرَةٌ':Subject, #1: 1	وَهِيَ عَزِيمَةٌ
u'وَهِيَ عَشَاءٌ':Subject, #1: 1	وَهِيَ الْعُسْرَةُ
u'وَهِيَ عِشَاءٌ':Subject, #1: 1	وَهِيَ الْعَشَاءُ
u'وَهِيَ عَشْرٌ':Subject, #4: 4	وَهِيَ الْعِشَاءُ
u'وَهِيَ عُشْرٌ':Subject, #1: 1	وَهِيَ عَشْرٌ
u'وَهِيَ عَشْرٌ':Subject, #1: 1	وَهِيَ عُشْرُ
u'وَهِيَ عَشْرٌ':Subject, #1: 1	وَهِيَ عَشْرَةٌ
u'وَهِيَ عَشْرٌ':Subject, #1: 1	وَهِيَ عَشْرَةُ
u'وَهِيَ عَشْرٌ':Subject, #2: 2	وَهِيَ عَشْرُ
u'وَهِيَ عِشْرُون':Predicate, #3: 3	وَهِيَ الْعَشْرُ
u'وَهَى عِشْرُون':Predicate, #10: 10	وَهِيَ عِشْرُونَ
u'وَهِيَ عِشْرُون':Predicate, #10: 10	وَهِيَ عِشْرُونَ
u'وَهَى عِشْرُون':Predicate, #3: 3	وَهِيَ الْعِشْرُونَ
u'وَهِيَ عِشْقٌ':Subject, #3: 3	وَهِيَ الْعِشْرُونَ
u'وَهِيَ عصبة':Subject, #1: 1	وَهِيَ الْعِشْقُ
u'وَهِيَ عَصَبَةٌ':Subject, #1: 1	وَهِيَ الْعَصَبَةُ
u'وَهِيَ عصبة':Subject, #1: 1	وَهِيَ الْعَصَبَةُ
u'وَهِيَ عَصَبَةٌ':Subject, #1: 1	وَهِيَ عَصَبَتُهُ
u'وَهِيَ عصبة':Subject, #1: 1	وَهِيَ عَصَبَتُهُ
u'وَهِيَ عَصَبَةٌ':Subject, #3: 3	وَهِيَ عَصَبَةٌ
u'وَهِيَ عَصْرٌ':Subject, #3: 3	وَهِيَ عَصَبَةٌ
u'وَهِيَ عِصْمَةٌ':Subject, #4: 4	وَهِيَ الْعَصْرُ
u'وَهِيَ عَصِيرٌ':Subject, #1: 1	وَهِيَ الْعِصْمَةُ
u'وَهِيَ عَصِيرٌ':Subject, #1: 1	وَهِيَ عَصِيرٌ
u'وَهِيَ عَضَلَةٌ':Subject, #2: 2	وَهِيَ عَصِيرُ
u'وَهِيَ عُضْوٌ':Subject, #1: 1	وَهِيَ الْعَضَلَةُ
u'وَهِيَ عُضْوٌ':Subject, #1: 1	وَهِيَ الْعُضْوُ
u'وَهِيَ عطاش':Subject, #1: 1	وَهِيَ عُضْوٌ
u'وَهِيَ عَطِيَّةٌ':Subject, #1: 1	وَهِيَ الْعِطَاشُ
u'وَهِيَ عَطِيَّةٌ':Subject, #2: 2	وَهِيَ عَطِيَّةٌ
u'وَهِيَ عظام':Subject, #4: 4	وَهِيَ الْعَطِيَّةُ
u'وَهِيَ عِظَامٌ':Subject, #2: 2	وَهِيَ عِظَامُ
u'وَهِيَ عِظَمٌ':Subject, #2: 2	وَهِيَ عِظَامُ
u'وَهِيَ عَفْوٌ':Subject, #1: 1	وَهِيَ عِظَمُ
u'وَهِيَ عقاب':Subject, #1: 1	وَهِيَ الْعَفْوُ
u'وَهِيَ عِقَابٌ':Subject, #1: 1	وَهِيَ الْعِقَابُ
u'وَهِيَ عقبة':Subject, #1: 1	وَهِيَ الْعِقَابُ
u'وَهِيَ عَقَبَةٌ':Subject, #1: 1	وَهِيَ الْعَقَبَةُ
u'وَهِيَ عَقْدٌ':Subject, #1: 1	وَهِيَ الْعَقَبَةُ
u'وَهِيَ عَقْدٌ':Subject, #12: 12	وَهِيَ عَقْدٌ
u'وَهِيَ عُقَدٌ':Subject, #2: 2	وَهِيَ الْعَقْدُ
u'وَهِيَ عَقْدٌ':Subject, #2: 2	وَهِيَ عُقَدُ
u'وَهِيَ عقدة':Subject, #3: 3	وَهِيَ عَقْدُ
u'وَهِيَ عُقْدَةٌ':Subject, #2: 2	وَهِيَ الْعُقْدَةُ
u'وَهِيَ عَقْلٌ':Subject, #2: 2	وَهِيَ الْعُقْدَةُ
u'وَهِيَ عَكْسٌ':Subject, #4: 4	وَهِيَ الْعَقْلُ
u'وَهِيَ عَكْسٌ':Subject, #1: 1	وَهِيَ عَكْسٌ
u'وَهِيَ عَلاَقَةٌ':Subject, #2: 2	وَهِيَ عَكْسُ
u'وَهِيَ عَلاَمَةٌ':Subject, #1: 1	وَهِيَ عَلَاقَةُ
u'وَهِيَ عِلَّةٌ':Subject, #3: 3	وَهِيَ الْعَلَامَةُ
u'وَهِيَ عِلَّةٌ':Subject, #3: 3	وَهِيَ عِلَّةٌ
u'وَهِيَ عِلَلٌ':Subject, #6: 6	وَهِيَ الْعِلَّةُ
u'وَهِيَ عِلَلٌ':Subject, #1: 1	وَهِيَ الْعِلَلُ
u'وَهِيَ علم':Subject, #1: 1	وَهِيَ عِلَلٌ
u'وَهِيَ عَلَمٌ':Subject, #1: 1	وَهِيَ عَلَمٌ
u'وَهِيَ علم':Subject, #1: 1	وَهِيَ عَلَمٌ
u'وَهِيَ عِلْمٌ':Subject, #6: 6	وَهِيَ الْعِلْمُ
u'وَهِيَ عُلُومٌ':Subject, #6: 6	وَهِيَ الْعِلْمُ
u'وَهِيَ عِمَارَةٌ':Subject, #1: 1	وَهِيَ الْعُلُومُ
u'وَهِيَ عَمَّةٌ':Subject, #1: 1	وَهِيَ عِمَارَةُ
u'وَهِيَ عَمَّةٌ':Subject, #1: 1	وَهِيَ الْعَمَّةُ
u'وَهِيَ عُمْدَةٌ':Subject, #3: 3	وَهِيَ عَمَّةُ
u'وَهِيَ عُمْدَةٌ':Subject, #1: 1	وَهِيَ الْعُمْدَةُ
u'وَهِيَ عمرة':Subject, #1: 1	وَهِيَ عُمْدَةُ
u'وَهِيَ عُمْرَةٌ':Subject, #1: 1	وَهِيَ عُمْرَةُ
u'وَهِيَ عمرة':Subject, #1: 1	وَهِيَ عُمْرَةُ
u'وَهِيَ عَمَلٌ':Subject, #4: 4	وَهِيَ عَمْرَةُ
u'وَهِيَ عُمُومٌ':Subject, #1: 1	وَهِيَ الْعَمَلُ
u'وَهِيَ عمياء':Subject, #2: 2	وَهِيَ الْعُمُومُ
u'وَهِيَ عند':Predicate, #3: 3	وَهِيَ عَمْيَاءُ
u'وَهَى عند':Predicate, #26: 26	وَهِيَ عِنْدَ
u'وَهِيَ عَهْدٌ':Subject, #26: 26	وَهِيَ عِنْدَ
u'وَهِيَ عُودٌ':Subject, #1: 1	وَهِيَ عَهْدُ
u'وَهِيَ عَوْدٌ':Subject, #1: 1	وَهِيَ الْعُودُ
u'وَهِيَ عُوذَةٌ':Subject, #1: 1	وَهِيَ الْعَوْدُ
u'وَهِيَ عَوْرَاء':Subject, #1: 1	وَهِيَ عُوذَةٌ
u'وَهِيَ عِيَارٌ':Subject, #1: 1	وَهِيَ عَوْرَاءُ
u'وَهِيَ عَيْبٌ':Subject, #1: 1	وَهِيَ عِيَارٌ
u'وَهِيَ عِيدَانٌ':Subject, #1: 1	وَهِيَ عَيْبٌ
u'وَهِيَ عين':Subject, #1: 1	وَهِيَ الْعِيدَانُ
u'وَهِيَ عَيْنٌ':Subject, #2: 2	وَهِيَ الْعَيْنُ
u'وَهِيَ عَيْن':Subject, #2: 2	وَهِيَ الْعَيْنُ
u'وَهِيَ عين':Subject, #2: 2	وَهِيَ الْعَيْنُ
u'وَهِيَ عَيْنٌ':Subject, #3: 3	وَهِيَ عَيْنُ
u'وَهِيَ عَيْن':Subject, #3: 3	وَهِيَ عَيْنُ
u'وَهِيَ عَيْنٌ':Subject, #3: 3	وَهِيَ عَيْنُ
u'وَهِيَ عَيْن':Subject, #5: 5	وَهِيَ عَيْنٌ
u'وَهِيَ عَيِّنَةٌ':Subject, #5: 5	وَهِيَ عَيْنٌ
u'وَهِيَ عُيُونٌ':Subject, #1: 1	وَهِيَ الْعَيِّنَةُ
u'وَهِيَ غَالِبٌ':Subject, #1: 1	وَهِيَ عُيُونُ
u'وَهِيَ غَائِبٌ':Subject, #1: 1	وَهِيَ الْغَالِبُ
u'وَهِيَ غَائِبٌ':Subject, #19: 19	وَهِيَ غَائِبَةٌ
u'وَهِيَ غَايَةٌ':Subject, #2: 2	وَهِيَ الْغَائِبَةُ
u'وَهِيَ غَايَةٌ':Subject, #2: 2	وَهِيَ الْغَايَةُ
u'وَهِيَ غبرة':Subject, #4: 4	وَهِيَ غَايَةُ
u'وَهِيَ غُبْرَةٌ':Subject, #1: 1	وَهِيَ الْغُبْرَةُ
u'وَهِيَ غِبْطَةٌ':Subject, #1: 1	وَهِيَ الْغُبْرَةُ
u'وَهِيَ غُرَابٌ':Subject, #1: 1	وَهِيَ الْغِبْطَةُ
u'وَهِيَ غُرْبَةٌ':Subject, #1: 1	وَهِيَ الْغُرَابُ
u'وَهِيَ غَزْوَةٌ':Subject, #1: 1	وَهِيَ غُرْبَةُ
u'وَهِيَ غَزْوَةٌ':Subject, #10: 10	وَهِيَ غَزْوَةُ
u'وَهِيَ غُسَالَةٌ':Subject, #2: 2	وَهِيَ الْغَزْوَةُ
u'وَهِيَ غُسْلٌ':Subject, #1: 1	وَهِيَ غُسَالَةُ
u'وَهِيَ غَسْلٌ':Subject, #1: 1	وَهِيَ الْغُسْلُ
u'وَهِيَ غُسْلٌ':Subject, #2: 2	وَهِيَ غَسْلُ
u'وَهِيَ غَضْنٌ':Subject, #3: 3	وَهِيَ غُسْلُ
u'وَهِيَ غفلة':Subject, #1: 1	وَهِيَ غَضْنٌ
u'وَهِيَ غَفْلَةٌ':Subject, #1: 1	وَهِيَ غَفْلَةٌ
u'وَهِيَ غِلاَفٌ':Subject, #1: 1	وَهِيَ غَفْلَةٌ
u'وَهِيَ غَلَطٌ':Subject, #1: 1	وَهِيَ غِلَافُ
u'وَهِيَ غَنَمٌ':Subject, #1: 1	وَهِيَ غَلَطٌ
u'وَهِيَ غَنِيمَةٌ':Subject, #1: 1	وَهِيَ الْغَنَمُ
u'وَهِيَ غُولٌ':Subject, #1: 1	وَهِيَ الْغَنِيمَةُ
u'وَهِيَ غِيبَةٌ':Subject, #1: 1	وَهِيَ الْغُولُ
u'وَهِيَ غير':Subject, #1: 1	وَهِيَ الْغِيبَةُ
u'وَهِيَ غَيْرٌ':Subject, #134: 134	وَهِيَ غَيْرُ
u'وَهِيَ غَيْظٌ':Subject, #134: 134	وَهِيَ غَيْرُ
u'وَهِيَ غيم':Subject, #1: 1	وَهِيَ الْغَيْظُ
u'وَهِيَ غَيْمٌ':Subject, #1: 1	وَهِيَ الْغَيْمُ
u'وَهِيَ فاء':Subject, #1: 1	وَهِيَ الْغَيْمُ
u'وَهِيَ فَاتِحٌ':Subject, #1: 1	وَهِيَ الْفَاءُ
u'وَهِيَ فَاتِحَةٌ':Subject, #2: 2	وَهِيَ فَاتِحَةُ
u'وَهِيَ فَاحِشٌ':Subject, #2: 2	وَهِيَ فَاتِحَةُ
u'وَهِيَ فَارِسِيٌّ':Subject, #1: 1	وَهِيَ الْفَاحِشَةُ
u'وَهِيَ فَارِغٌ':Subject, #1: 1	وَهِيَ فَارِسِيَّةٌ
u'وَهِيَ فَاسِدٌ':Subject, #8: 8	وَهِيَ فَارِغَةٌ
u'وَهِيَ فَاسِدٌ':Subject, #1: 1	وَهِيَ فَاسِدَةُ
u'وَهِيَ فَاسِقٌ':Subject, #6: 6	وَهِيَ فَاسِدَةٌ
u'وَهِيَ فَاطِمٌ':Subject, #2: 2	وَهِيَ فَاسِقَةٌ
u'وَهِيَ فَاعِلٌ':Subject, #1: 1	وَهِيَ فَاطِمَةُ
u'وَهِيَ فَاعِلٌ':Subject, #1: 1	وَهِيَ الْفَاعِلَةُ
u'وَهِيَ فَاقِدٌ':Subject, #1: 1	وَهِيَ فَاعِلَةٌ
u'وَهِيَ فَائِدَةٌ':Subject, #1: 1	وَهِيَ فَاقِدَةُ
u'وَهِيَ فَائِدَةٌ':Subject, #12: 12	وَهِيَ فَائِدَةٌ
u'وَهِيَ فَائِدَةٌ':Subject, #1: 1	وَهِيَ الْفَائِدَةُ
u'وَهِيَ فَجْرٌ':Subject, #3: 3	وَهِيَ فَائِدَةُ
u'وَهِيَ فَحْمَةٌ':Subject, #1: 1	وَهِيَ الْفَجْرُ
u'وَهِيَ فِدْيَةٌ':Subject, #1: 1	وَهِيَ الْفَحْمَةُ
u'وَهِيَ فِرَاشٌ':Subject, #1: 1	وَهِيَ فِدْيَةُ
u'وَهِيَ فِرَاشٌ':Subject, #1: 1	وَهِيَ الْفِرَاشُ
u'وَهِيَ فَرَائِضُ':Subject, #1: 1	وَهِيَ فِرَاشٌ
u'وَهِيَ فَرْدٌ':Subject, #1: 1	وَهِيَ فَرَائِضُ
u'وَهِيَ فَرْدٌ':Subject, #1: 1	وَهِيَ الْفَرْدِيَّةُ
u'وَهِيَ فَرْدِيٌّ':Subject, #3: 3	وَهِيَ فَرْدٌ
u'وَهِيَ فَرْدِيَّةٌ':Subject, #1: 1	وَهِيَ الْفَرْدِيَّةُ
u'وَهِيَ فَرَسٌ':Subject, #1: 1	وَهِيَ الْفَرْدِيَّةُ
u'وَهِيَ فَرَسٌ':Subject, #1: 1	وَهِيَ الْفَرَسُ
u'وَهِيَ فَرْضٌ':Subject, #1: 1	وَهِيَ فَرَسٌ
u'وَهِيَ فَرْضٌ':Subject, #13: 13	وَهِيَ فَرْضُ
u'وَهِيَ فَرْعٌ':Subject, #14: 14	وَهِيَ فَرْضٌ
u'وَهِيَ فَرْعٌ':Subject, #4: 4	وَهِيَ فَرْعٌ
u'وَهِيَ فَرْعِيٌّ':Subject, #6: 6	وَهِيَ فَرْعُ
u'وَهِيَ فرق':Subject, #1: 1	وَهِيَ فَرْعِيَّةٌ
u'وَهِيَ فَرْقٌ':Subject, #1: 1	وَهِيَ الْفَرْقُ
u'وَهِيَ فُرْقَةٌ':Subject, #1: 1	وَهِيَ الْفَرْقُ
u'وَهِيَ فِرْقَةٌ':Subject, #1: 1	وَهِيَ الْفُرْقَةُ
u'وَهِيَ فُرْقَةٌ':Subject, #1: 1	وَهِيَ الْفِرْقَةُ
u'وَهِيَ فُرُوعٌ':Subject, #1: 1	وَهِيَ فُرْقَةُ
u'وَهِيَ فَرِيضَةٌ':Subject, #1: 1	وَهِيَ فُرُوعُ
u'وَهِيَ فَرِيضَةٌ':Subject, #3: 3	وَهِيَ الْفَرِيضَةُ
u'وَهِيَ فساد':Subject, #5: 5	وَهِيَ فَرِيضَةٌ
u'وَهِيَ فَسَادٌ':Subject, #1: 1	وَهِيَ فَسَادُ
u'وَهِيَ فَسْخٌ':Subject, #1: 1	وَهِيَ فَسَادُ
u'وَهِيَ فِسْقٌ':Subject, #6: 6	وَهِيَ فَسْخٌ
u'وَهِيَ فَصْلٌ':Subject, #1: 1	وَهِيَ الْفِسْقُ
u'وَهِيَ فَضَاءٌ':Subject, #1: 1	وَهِيَ فَصْلُ
u'وَهِيَ فِضَّةٌ':Subject, #1: 1	وَهِيَ فَضَاءٌ
u'وَهِيَ فَضْلٌ':Subject, #2: 2	وَهِيَ الْفِضَّةُ
u'وَهِيَ فِعْلٌ':Subject, #1: 1	وَهِيَ فَضْلُ
u'وَهِيَ فِعْلٌ':Subject, #1: 1	وَهِيَ فِعْلٌ
u'وَهِيَ فِعْلٌ':Subject, #2: 2	وَهِيَ فِعْلُهُ
u'وَهِيَ فعلة':Subject, #3: 3	وَهِيَ فِعْلُ
u'وَهِيَ فَقْء':Subject, #1: 1	وَهِيَ فِعْلَةٌ
u'وَهِيَ فِقْهٌ':Subject, #1: 1	وَهِيَ الْفَقْءُ
u'وَهِيَ فُلاَنٌ':Subject, #1: 1	وَهِيَ الْفِقْهُ
u'وَهِيَ فلان':Subject, #10: 10	وَهِيَ فُلَانَةُ
u'وَهِيَ فلان':Subject, #1: 1	وَهِيَ الدّيلُ
u'وَهِيَ فلان':Subject, #1: 1	وَهِيَ الرّايَةُ
u'وَهِيَ فلان':Subject, #1: 1	وَهِيَ الرّجَبِيّةُ
u'وَهِيَ فلان':Subject, #1: 1	وَهِيَ الزِّيَادِيَّةُ
u'وَهِيَ فلان':Subject, #1: 1	وَهِيَ الْعَبْدِيَّةُ
u'وَهِيَ فلان':Subject, #1: 1	وَهِيَ تُمَاضِرُ
u'وَهِيَ فلان':Subject, #1: 1	وَهِيَ حَفْصَةُ
u'وَهِيَ فلان':Subject, #1: 1	وَهِيَ خَدِيجَةُ
u'وَهِيَ فلان':Subject, #1: 1	وَهِيَ شَيْخَةٌ
u'وَهِيَ فلان':Subject, #1: 1	وَهِيَ طَبَرِيَّةٌ
u'وَهِيَ فلان':Subject, #1: 1	وَهِيَ مَرْوِيّةٌ
u'وَهِيَ فلان':Subject, #1: 1	وَهِيَ مَرْوِيَّةٌ
u'وَهِيَ فلان':Subject, #1: 1	وَهِيَ مَكّيّةٌ
u'وَهِيَ فلان':Subject, #1: 1	وَهِيَ نُسَيْبَةُ
u'وَهِيَ فلان':Subject, #1: 1	وَهِيَ نَهَارِيَّةٌ
u'وَهِيَ فلان':Subject, #2: 2	وَهِيَ الْبِلَالِيَّةُ
u'وَهِيَ فلان':Subject, #2: 2	وَهِيَ الْبُوَيْرَةُ
u'وَهِيَ فلان':Subject, #2: 2	وَهِيَ رَاغِبَةٌ
u'وَهِيَ فِلَسْطِين':Subject, #3: 3	وَهِيَ صَلَاتِيَّةٌ
u'وَهِيَ فِلْقَةٌ':Subject, #2: 2	وَهِيَ فِلَسْطِينُ
u'وَهِيَ فَنَادِقُ':Subject, #1: 1	وَهِيَ الْفِلْقَةُ
u'وَهِيَ فَهْمٌ':Subject, #1: 1	وَهِيَ الْفَنَادِقُ
u'وَهِيَ فَوَاتٌ':Subject, #1: 1	وَهِيَ فَهْمُ
u'وَهِيَ فَوَائِدُ':Subject, #2: 2	وَهِيَ فَوَاتُ
u'وَهِيَ فَيْءٌ':Subject, #2: 2	وَهِيَ فَوَائِدُ
u'وَهِيَ قَابِلٌ':Subject, #1: 1	وَهِيَ فَيْءٌ
u'وَهِيَ قَابِلٌ':Subject, #2: 2	وَهِيَ الْقَابِلَةُ
u'وَهِيَ قَاتِلٌ':Subject, #4: 4	وَهِيَ قَابِلَةٌ
u'وَهِيَ قَادِرٌ':Subject, #2: 2	وَهِيَ قَاتِلَةٌ
u'وَهِيَ قَاصِرٌ':Subject, #1: 1	وَهِيَ قَادِرَةٌ
u'وَهِيَ قَاضِي':Subject, #1: 1	وَهِيَ قَاصِرَةٌ
u'وَهِيَ قَاضِيَةٌ':Subject, #3: 3	وَهِيَ قَاضِيَةٌ
u'وَهِيَ قَاطِعٌ':Subject, #3: 3	وَهِيَ قَاضِيَةٌ
u'وَهِيَ قَاعِدٌ':Subject, #1: 1	وَهِيَ قَاطِعَةٌ
u'وَهِيَ قَاعِدٌ':Subject, #1: 1	وَهِيَ الْقَاعِدَةُ
u'وَهِيَ قَالٌ':Predicate, #7: 7	وَهِيَ قَاعِدَةٌ
u'وَهَى قَالٌ':Predicate, #1: 1	وَهِيَ قَالَ
u'وَهِيَ قَالِعٌ':Subject, #1: 1	وَهِيَ قَالَ
u'وَهِيَ قَائِلٌ':Subject, #1: 1	وَهِيَ قَالِعَةٌ
u'وَهِيَ قَائِلَةٌ':Subject, #3: 3	وَهِيَ الْقَائِلَةُ
u'وَهِيَ قَائِمٌ':Subject, #3: 3	وَهِيَ الْقَائِلَةُ
u'وَهِيَ قَائِمَةٌ':Subject, #42: 42	وَهِيَ قَائِمَةٌ
u'وَهِيَ قَبَائِلُ':Subject, #42: 42	وَهِيَ قَائِمَةٌ
u'وَهِيَ قُبَّةٌ':Subject, #1: 1	وَهِيَ قَبَائِلُ
u'وَهِيَ قَبْضٌ':Subject, #2: 2	وَهِيَ قُبَّةٌ
u'وَهِيَ قبضة':Subject, #1: 1	وَهِيَ الْقَبْضُ
u'وَهِيَ قَبْضَةٌ':Subject, #2: 2	وَهِيَ الْقَبْضَةُ
u'وَهِيَ قِبْلَةٌ':Subject, #2: 2	وَهِيَ الْقَبْضَةُ
u'وَهِيَ قُبْلَةٌ':Subject, #1: 1	وَهِيَ قِبْلَةُ
u'وَهِيَ قَبُولٌ':Subject, #2: 2	وَهِيَ قُبْلَةُ
u'وَهِيَ قَبِيلَةٌ':Subject, #1: 1	وَهِيَ قَبُولُ
u'وَهِيَ قَبِيلَةٌ':Subject, #3: 3	وَهِيَ الْقَبِيلَةُ
u'وَهِيَ قَتٌّ':Subject, #4: 4	وَهِيَ قَبِيلَةٌ
u'وَهِيَ قتل':Subject, #1: 1	وَهِيَ الْقَتُّ
u'وَهِيَ قَتْلٌ':Subject, #1: 1	وَهِيَ قَتْلُ
u'وَهِيَ قَتْلٌ':Subject, #1: 1	وَهِيَ قَتْلٌ
u'وَهِيَ قتل':Subject, #1: 1	وَهِيَ قَتْلُ
u'وَهِيَ قَتْلٌ':Subject, #6: 6	وَهِيَ الْقَتْلُ
u'وَهِيَ قَدْرٌ':Subject, #6: 6	وَهِيَ الْقَتْلُ
u'وَهِيَ قَدْرٌ':Subject, #1: 1	وَهِيَ الْقَدْرُ
u'وَهِيَ قَدْرٌ':Subject, #1: 1	وَهِيَ قَدْرٌ
u'وَهِيَ قدرة':Subject, #5: 5	وَهِيَ قَدْرُ
u'وَهِيَ قُدْرَةٌ':Subject, #1: 1	وَهِيَ الْقُدْرَةُ
u'وَهِيَ قذف':Subject, #1: 1	وَهِيَ الْقُدْرَةُ
u'وَهِيَ قَذْفٌ':Subject, #1: 1	وَهِيَ الْقَذْفُ
u'وَهِيَ قِرَاءةٌ':Subject, #1: 1	وَهِيَ الْقَذْفُ
u'وَهِيَ قِرَاءةٌ':Subject, #2: 2	وَهِيَ الْقِرَاءَةُ
u'وَهِيَ قَرَابَةٌ':Subject, #8: 8	وَهِيَ قِرَاءَةُ
u'وَهِيَ قَرَابَةٌ':Subject, #1: 1	وَهِيَ قَرَابَةٌ
u'وَهِيَ قُرَادٌ':Subject, #4: 4	وَهِيَ الْقَرَابَةُ
u'وَهِيَ قُرْآنٌ':Subject, #1: 1	وَهِيَ الْقُرَادُ
u'وَهِيَ قُرْآنٌ':Subject, #1: 1	وَهِيَ الْقُرْآنُ
u'وَهِيَ قُرَبٌ':Subject, #2: 2	وَهِيَ قُرْآنٌ
u'وَهِيَ قُرَبٌ':Subject, #1: 1	وَهِيَ الْقُرَبُ
u'وَهِيَ قُرْبٌ':Subject, #1: 1	وَهِيَ قُرَبٌ
u'وَهِيَ قُرْبَةٌ':Subject, #2: 2	وَهِيَ الْقُرْبُ
u'وَهِيَ قُرْبَةٌ':Subject, #1: 1	وَهِيَ الْقُرْبَةُ
u'وَهِيَ قُرَشِيٌّ':Subject, #1: 1	وَهِيَ قُرْبَةٌ
u'وَهِيَ قَرْضٌ':Subject, #2: 2	وَهِيَ قُرَشِيَّةٌ
u'وَهِيَ قَرْضٌ':Subject, #1: 1	وَهِيَ الْقَرْضُ
u'وَهِيَ قرع':Subject, #1: 1	وَهِيَ قَرْضٌ
u'وَهِيَ قَرْعٌ':Subject, #1: 1	وَهِيَ الْقَرْعُ
u'وَهِيَ قُرْعَةٌ':Subject, #1: 1	وَهِيَ الْقَرْعُ
u'وَهِيَ قِرْمِز':Subject, #1: 1	وَهِيَ الْقُرْعَةُ
u'وَهِيَ قُرُوحٌ':Subject, #1: 1	وَهِيَ الْقِرْمِزُ
u'وَهِيَ قُرُوحٌ':Subject, #1: 1	وَهِيَ الْقُرُوحُ
u'وَهِيَ قُرُونٌ':Subject, #2: 2	وَهِيَ قُرُوحٌ
u'وَهِيَ قَرِيبٌ':Subject, #1: 1	وَهِيَ الْقُرُونُ
u'وَهِيَ قَرْيَةٌ':Subject, #1: 1	وَهِيَ قَرِيبَةُ
u'وَهِيَ قَسَمٌ':Subject, #15: 15	وَهِيَ قَرْيَةٌ
u'وَهِيَ قسمة':Subject, #1: 1	وَهِيَ الْقَسَمُ
u'وَهِيَ قِسْمَةٌ':Subject, #1: 1	وَهِيَ قِسْمَةٌ
u'وَهِيَ قسمة':Subject, #1: 1	وَهِيَ قِسْمَةٌ
u'وَهِيَ قِسْمَةٌ':Subject, #2: 2	وَهِيَ الْقِسْمَةُ
u'وَهِيَ قسمة':Subject, #2: 2	وَهِيَ الْقِسْمَةُ
u'وَهِيَ قِسْمَةٌ':Subject, #9: 9	وَهِيَ قِسْمَةُ
u'وَهِيَ قِشْرٌ':Subject, #9: 9	وَهِيَ قِسْمَةُ
u'وَهِيَ قِشْرَةٌ':Subject, #1: 1	وَهِيَ قِشْرُهُ
u'وَهِيَ قَصَبَةٌ':Subject, #1: 1	وَهِيَ الْقِشْرَةُ
u'وَهِيَ قَصَبَةٌ':Subject, #1: 1	وَهِيَ قَصَبَاتٌ
u'وَهِيَ قِصَّةٌ':Subject, #1: 1	وَهِيَ قَصَبَةٌ
u'وَهِيَ قَصْدٌ':Subject, #1: 1	وَهِيَ قِصَّةٌ
u'وَهِيَ قَصْدٌ':Subject, #1: 1	وَهِيَ قَصْدُ
u'وَهِيَ قَصْرٌ':Subject, #3: 3	وَهِيَ الْقَصْدُ
u'وَهِيَ قَصْعَةٌ':Subject, #2: 2	وَهِيَ قَصْرُ
u'وَهِيَ قَضَاءٌ':Subject, #2: 2	وَهِيَ الْقَصْعَةُ
u'وَهِيَ قَضَاءٌ':Subject, #1: 1	وَهِيَ الْقَضَاءُ
u'وَهِيَ قَضَاءٌ':Subject, #2: 2	وَهِيَ قَضَاءٌ
u'وَهِيَ قَضِيَّةٌ':Subject, #5: 5	وَهِيَ قَضَاءُ
u'وَهِيَ قَطْع':Subject, #2: 2	وَهِيَ قَضِيَّةٌ
u'وَهِيَ قَطْعٌ':Subject, #1: 1	وَهِيَ قَطْعِيَّةٌ
u'وَهِيَ قَطْعٌ':Subject, #2: 2	وَهِيَ الْقَطْعُ
u'وَهِيَ قطعة':Subject, #4: 4	وَهِيَ قَطْعُ
u'وَهِيَ قِطْعَةٌ':Subject, #1: 1	وَهِيَ قِطْعَةُ
u'وَهِيَ قَطْعَة':Subject, #1: 1	وَهِيَ قِطْعَةُ
u'وَهِيَ قطعة':Subject, #1: 1	وَهِيَ قَطْعِيَّةٌ
u'وَهِيَ قِطْعَةٌ':Subject, #3: 3	وَهِيَ قِطْعَةٌ
u'وَهِيَ قطعة':Subject, #3: 3	وَهِيَ قِطْعَةٌ
u'وَهِيَ قِطْعَةٌ':Subject, #7: 7	وَهِيَ الْقِطْعَةُ
u'وَهِيَ قَطْعِيّ':Subject, #7: 7	وَهِيَ الْقِطْعَةُ
u'وَهِيَ قَطْعِيَّة':Subject, #1: 1	وَهِيَ قَطْعِيَّةٌ
u'وَهِيَ قُطْنٌ':Subject, #1: 1	وَهِيَ قَطْعِيَّةٌ
u'وَهِيَ قعدة':Subject, #1: 1	وَهِيَ قُطْنٌ
u'وَهِيَ قَعْدَةٌ':Subject, #4: 4	وَهِيَ قَعْدَةُ
u'وَهِيَ قُفَّةٌ':Subject, #4: 4	وَهِيَ قَعْدَةُ
u'وَهِيَ قلب':Subject, #1: 1	وَهِيَ الْقُفّةُ
u'وَهِيَ قَلْبٌ':Subject, #2: 2	وَهِيَ الْقَلْبُ
u'وَهِيَ قَلْب':Subject, #2: 2	وَهِيَ الْقَلْبُ
u'وَهِيَ قِلَّةٌ':Subject, #2: 2	وَهِيَ الْقَلْبُ
u'وَهِيَ قُلُوبٌ':Subject, #1: 1	وَهِيَ قِلَّةُ
u'وَهِيَ قَلِيلٌ':Subject, #1: 1	وَهِيَ الْقُلُوبُ
u'وَهِيَ قُمَامَةٌ':Subject, #2: 2	وَهِيَ الْقَلِيلَةُ
u'وَهِيَ قَمِيصٌ':Subject, #1: 1	وَهِيَ الْقُمَامَةُ
u'وَهِيَ قَمِيصٌ':Subject, #1: 1	وَهِيَ الْقَمِيصُ
u'وَهِيَ قَنْطَرَةٌ':Subject, #1: 1	وَهِيَ قَمِيصٌ
u'وَهِيَ قوائم':Subject, #1: 1	وَهِيَ قَنْطَرَةٌ
u'وَهِيَ قَوَائِمُ':Subject, #1: 1	وَهِيَ الْقَوَائِمُ
u'وَهِيَ قُوَّةٌ':Subject, #1: 1	وَهِيَ الْقَوَائِمُ
u'وَهِيَ قُوَّة':Subject, #10: 10	وَهِيَ قُوَّةٌ
u'وَهِيَ قُوَّةٌ':Subject, #10: 10	وَهِيَ قُوَّةٌ
u'وَهِيَ قُوَّة':Subject, #3: 3	وَهِيَ الْقُوّةُ
u'وَهِيَ قُوَّةٌ':Subject, #3: 3	وَهِيَ الْقُوّةُ
u'وَهِيَ قُوَّة':Subject, #3: 3	وَهِيَ قُوَّةُ
u'وَهِيَ قول':Subject, #3: 3	وَهِيَ قُوَّةُ
u'وَهِيَ قَوْلٌ':Subject, #12: 12	وَهِيَ قَوْلُ
u'وَهِيَ قول':Subject, #12: 12	وَهِيَ قَوْلُ
u'وَهِيَ قَوْلٌ':Subject, #1: 1	وَهِيَ الْقَوْلُ
u'وَهِيَ قَوْل':Subject, #1: 1	وَهِيَ الْقَوْلُ
u'وَهِيَ قَوْلٌ':Subject, #1: 1	وَهِيَ الْقَوْلِيَّةُ
u'وَهِيَ قول':Subject, #5: 5	وَهِيَ قَوْلٌ
u'وَهِيَ قَوْلٌ':Subject, #78: 78	وَهِيَ قَوْلُهُ
u'وَهِيَ قَوْلَة':Subject, #78: 78	وَهِيَ قَوْلُهُ
u'وَهِيَ قَوْمٌ':Subject, #1: 1	وَهِيَ الْقَوْلِيَّةُ
u'وَهِيَ قَوْمَةٌ':Subject, #1: 1	وَهِيَ قَوْمٌ
u'وَهِيَ قَوِيٌّ':Subject, #1: 1	وَهِيَ الْقَوْمَةُ
u'وَهِيَ قِيَادَةٌ':Subject, #1: 1	وَهِيَ الْقَوِيّةُ
u'وَهِيَ قِيَاسٌ':Subject, #1: 1	وَهِيَ الْقِيَادَةُ
u'وَهِيَ قِيَاسٌ':Subject, #1: 1	وَهِيَ قِيَاسٌ
u'وَهِيَ قيام':Subject, #1: 1	وَهِيَ قِيَاسُ
u'وَهِيَ قِيَامٌ':Subject, #3: 3	وَهِيَ قِيَامُ
u'وَهِيَ قِيَامَةٌ':Subject, #3: 3	وَهِيَ قِيَامُ
u'وَهِيَ قَيْدٌ':Subject, #1: 1	وَهِيَ الْقِيَامَةُ
u'وَهِيَ قِيمَةٌ':Subject, #1: 1	وَهِيَ قَيْدٌ
u'وَهِيَ قِيمَةٌ':Subject, #10: 10	وَهِيَ قِيمَتُهُ
u'وَهِيَ قِيمَةٌ':Subject, #1: 1	وَهِيَ الْقِيمَةُ
u'وَهِيَ كَاذِبٌ':Subject, #1: 1	وَهِيَ قِيمَةُ
u'وَهِيَ كَارِهٌ':Subject, #5: 5	وَهِيَ كَاذِبَةٌ
u'وَهِيَ كَاسِدٌ':Subject, #7: 7	وَهِيَ كَارِهَةٌ
u'وَهِيَ كَاسِفٌ':Subject, #1: 1	وَهِيَ كَاسِدَةٌ
u'وَهِيَ كَافِرٌ':Subject, #2: 2	وَهِيَ كَاسِفَةٌ
u'وَهِيَ كَافِي':Subject, #2: 2	وَهِيَ كَافِرَةٌ
u'وَهِيَ كَامِلٌ':Subject, #6: 6	وَهِيَ كَافِيَةٌ
u'وَهِيَ كَاهِنٌ':Subject, #1: 1	وَهِيَ الْكَامِلَةُ
u'وَهِيَ كَائِنٌ':Subject, #1: 1	وَهِيَ الْكَاهِنَةُ
u'وَهِيَ كَائِنٌ':Subject, #1: 1	وَهِيَ الْكَائِنَةُ
u'وَهِيَ كبار':Subject, #1: 1	وَهِيَ كَائِنَةٌ
u'وَهِيَ كبار':Subject, #1: 1	وَهِيَ الْكِبَارُ
u'وَهِيَ كبائر':Subject, #1: 1	وَهِيَ كِبَارُ
u'وَهِيَ كُبَّةٌ':Subject, #1: 1	وَهِيَ الْكَبَائِرُ
u'وَهِيَ كَبْشَةٌ':Subject, #2: 2	وَهِيَ الْكُبَّةُ
u'وَهِيَ كِتَابٌ':Subject, #1: 1	وَهِيَ كَبْشَةُ
u'وَهِيَ كِتاب':Subject, #1: 1	وَهِيَ الْكِتَابُ
u'وَهِيَ كِتَابٌ':Subject, #1: 1	وَهِيَ الْكِتَابِيَّةُ
u'وَهِيَ كِتاب':Subject, #1: 1	وَهِيَ كِتَابُ
u'وَهِيَ كِتابَة':Subject, #3: 3	وَهِيَ كِتَابِيَّةٌ
u'وَهِيَ كِتَابَةٌ':Subject, #1: 1	وَهِيَ الْكِتَابِيَّةُ
u'وَهِيَ كِتابَة':Subject, #3: 3	وَهِيَ الْكِتَابَةُ
u'وَهِيَ كِتابِيّ':Subject, #3: 3	وَهِيَ كِتَابِيَّةٌ
u'وَهِيَ كِتابِيّ':Subject, #1: 1	وَهِيَ الْكِتَابِيَّةُ
u'وَهِيَ كُتُبٌ':Subject, #3: 3	وَهِيَ كِتَابِيَّةٌ
u'وَهِيَ كَثْرَةٌ':Subject, #2: 2	وَهِيَ الْكُتُبُ
u'وَهِيَ كَثْرَةٌ':Subject, #1: 1	وَهِيَ كَثْرَةُ
u'وَهِيَ كَثِيرٌ':Subject, #3: 3	وَهِيَ الْكَثْرَةُ
u'وَهِيَ كذب':Subject, #9: 9	وَهِيَ كَثِيرَةُ
u'وَهِيَ كَذِبٌ':Subject, #1: 1	وَهِيَ الْكَذِبُ
u'وَهِيَ كَذِبٌ':Subject, #1: 1	وَهِيَ الْكَذِبُ
u'وَهِيَ كِرَاءٌ':Subject, #1: 1	وَهِيَ كَذِبٌ
u'وَهِيَ كَرَارِيسُ':Subject, #1: 1	وَهِيَ كِرَاءُ
u'وَهِيَ كَرَاهَةٌ':Subject, #2: 2	وَهِيَ الْكَرَارِيسُ
u'وَهِيَ كَرَاهَةٌ':Subject, #11: 11	وَهِيَ كَرَاهَةُ
u'وَهِيَ كُزْبَرَةٌ':Subject, #1: 1	وَهِيَ كَرَاهَةٌ
u'وَهِيَ كِسَاءٌ':Subject, #1: 1	وَهِيَ الْكُزْبَرَةُ
u'وَهِيَ كَسْرٌ':Subject, #2: 2	وَهِيَ كِسَاءٌ
u'وَهِيَ كعبة':Subject, #1: 1	وَهِيَ كَسْرُ
u'وَهِيَ كَعْبَةٌ':Subject, #1: 1	وَهِيَ الْكَعْبَةُ
u'وَهِيَ كَفٌّ':Subject, #1: 1	وَهِيَ الْكَعْبَةُ
u'وَهِيَ كَفَّارٌ':Subject, #1: 1	وَهِيَ كَفُّ
u'وَهِيَ كَفَّارٌ':Subject, #1: 1	وَهِيَ الْكَفَّارَاتُ
u'وَهِيَ كَفَّارٌ':Subject, #3: 3	وَهِيَ الْكَفَّارَةُ
u'وَهِيَ كَفَّارَةٌ':Subject, #3: 3	وَهِيَ كَفَّارَةُ
u'وَهِيَ كَفَّارَةٌ':Subject, #1: 1	وَهِيَ الْكَفَّارَاتُ
u'وَهِيَ كَفَّارَةٌ':Subject, #3: 3	وَهِيَ الْكَفَّارَةُ
u'وَهِيَ كَفَالَةٌ':Subject, #3: 3	وَهِيَ كَفَّارَةُ
u'وَهِيَ كِفَايَةٌ':Subject, #3: 3	وَهِيَ الْكَفَالَةُ
u'وَهِيَ كفر':Subject, #1: 1	وَهِيَ كِفَايَةُ
u'وَهِيَ كُفْرٌ':Subject, #3: 3	وَهِيَ الْكُفْرُ
u'وَهِيَ كلاب':Subject, #3: 3	وَهِيَ الْكُفْرُ
u'وَهِيَ كِلاَبٌ':Subject, #1: 1	وَهِيَ الْكِلَابُ
u'وَهِيَ كَلاَمٌ':Subject, #1: 1	وَهِيَ الْكِلَابُ
u'وَهِيَ كَلاَمٌ':Subject, #1: 1	وَهِيَ الْكَلَامُ
u'وَهِيَ كَلِمَةٌ':Subject, #2: 2	وَهِيَ كَلَامُ
u'وَهِيَ كَلِمَةٌ':Subject, #14: 14	وَهِيَ كَلِمَةٌ
u'وَهِيَ كُلِّيٌّ':Subject, #5: 5	وَهِيَ كَلِمَةُ
u'وَهِيَ كُلِّيَّاتٌ':Subject, #1: 1	وَهِيَ الْكُلِّيَّاتُ
u'وَهِيَ كُلِّيَّةٌ':Subject, #1: 1	وَهِيَ الْكُلِّيَّاتُ
u'وَهِيَ كَمَالٌ':Subject, #1: 1	وَهِيَ الْكُلِّيَّاتُ
u'وَهِيَ كَمُّونٌ':Subject, #2: 2	وَهِيَ كَمَالُ
u'وَهِيَ كِنَايَةٌ':Subject, #1: 1	وَهِيَ الْكَمُّونُ
u'وَهِيَ كَنِيسَةٌ':Subject, #1: 1	وَهِيَ كِنَايَةٌ
u'وَهِيَ كَوْثَرٌ':Subject, #1: 1	وَهِيَ الْكَنِيسَةُ
u'وَهِيَ كَوْنٌ':Subject, #2: 2	وَهِيَ الْكَوْثَرُ
u'وَهِيَ كَوْنٌ':Subject, #4: 4	وَهِيَ كَوْنُهُ
u'وَهِيَ كَيٌّ':Subject, #8: 8	وَهِيَ كَوْنُ
u'وَهِيَ كَيْفِيَّةٌ':Subject, #1: 1	وَهِيَ الْكَيُّ
u'وَهِيَ لاَتٌ':Subject, #1: 1	وَهِيَ كَيْفِيَّةٌ
u'وَهِيَ لاَتٌ':Subject, #1: 1	وَهِيَ اللَّاتُ
u'وَهِيَ لاَحِقٌ':Subject, #2: 2	وَهِيَ اللّاتُ
u'وَهِيَ لاَزِمٌ':Subject, #1: 1	وَهِيَ لَاحِقَةٌ
u'وَهِيَ لاَزِمَة':Subject, #9: 9	وَهِيَ لَازِمَةٌ
u'وَهِيَ لاَمٌ':Subject, #9: 9	وَهِيَ لَازِمَةٌ
u'وَهِيَ لاَمٌ':Subject, #1: 1	وَهِيَ اللَّامُ
u'وَهِيَ لاَهِي':Subject, #3: 3	وَهِيَ لَامُ
u'وَهِيَ لِبَاسٌ':Subject, #1: 1	وَهِيَ لَاهِيَةٌ
u'وَهِيَ لبس':Subject, #1: 1	وَهِيَ لِبَاسُ
u'وَهِيَ لِبْسٌ':Subject, #1: 1	وَهِيَ اللِّبْسُ
u'وَهِيَ لِبْسٌ':Subject, #1: 1	وَهِيَ اللِّبْسُ
u'وَهِيَ لُبْسَةٌ':Subject, #1: 1	وَهِيَ لِبْسَةُ
u'وَهِيَ لبن':Subject, #1: 1	وَهِيَ لُبْسَةُ
u'وَهِيَ لَبَنٌ':Subject, #1: 1	وَهِيَ لَبَنُ
u'وَهِيَ لَبَنٌ':Subject, #1: 1	وَهِيَ لَبَنٌ
u'وَهِيَ لُبُودٌ':Subject, #1: 1	وَهِيَ لَبَنُ
u'وَهِيَ لَبَّيْكَ':Predicate, #1: 1	وَهِيَ اللُّبُودُ
u'وَهَى لَبَّيْكَ':Predicate, #2: 2	وَهِيَ لَبَّيْكَ
u'وَهِيَ لَجَّةٌ':Subject, #2: 2	وَهِيَ لَبَّيْكَ
u'وَهِيَ لَحْمٌ':Subject, #1: 1	وَهِيَ اللَّجَّةُ
u'وَهِيَ لحمة':Subject, #1: 1	وَهِيَ اللَّحْمُ
u'وَهِيَ لُحْمَةٌ':Subject, #2: 2	وَهِيَ اللُّحْمَةُ
u'وَهِيَ لحمة':Subject, #2: 2	وَهِيَ اللُّحْمَةُ
u'وَهِيَ لَحْمَةٌ':Subject, #2: 2	وَهِيَ لَحْمَةٌ
u'وَهِيَ لَحْيٌ':Subject, #2: 2	وَهِيَ لَحْمَةٌ
u'وَهِيَ لُزُومٌ':Subject, #1: 1	وَهِيَ اللَّحْيُ
u'وَهِيَ لِسَانٌ':Subject, #1: 1	وَهِيَ لُزُومُ
u'وَهِيَ لعب':Subject, #1: 1	وَهِيَ اللِّسَانُ
u'وَهِيَ لَعِبٌ':Subject, #1: 1	وَهِيَ اللَّعِبُ
u'وَهِيَ لُغَةٌ':Subject, #1: 1	وَهِيَ اللَّعِبُ
u'وَهِيَ لُغَةٌ':Subject, #3: 3	وَهِيَ لُغَةُ
u'وَهِيَ لُغَوِيٌّ':Subject, #6: 6	وَهِيَ لُغَةٌ
u'وَهِيَ لَفْظٌ':Subject, #2: 2	وَهِيَ اللُّغَوِيَّةُ
u'وَهِيَ لَفْظَةٌ':Subject, #1: 1	وَهِيَ اللَّفْظُ
u'وَهِيَ لَفْظَةٌ':Subject, #1: 1	وَهِيَ اللَّفْظَةُ
u'وَهِيَ لَوْنٌ':Subject, #1: 1	وَهِيَ لَفْظَةٌ
u'وَهِيَ لَيْلٌ':Subject, #2: 2	وَهِيَ لَوْنٌ
u'وَهِيَ لَيْلٌ':Subject, #1: 1	وَهِيَ لَيْلَةٌ
u'وَهِيَ لَيْلٌ':Subject, #3: 3	وَهِيَ اللَّيْلَةُ
u'وَهِيَ مَاءٌ':Subject, #4: 4	وَهِيَ لَيْلَةُ
u'وَهِيَ مَاءٌ':Subject, #1: 1	وَهِيَ الْمَاءُ
u'وَهِيَ مَاءٌ':Subject, #1: 1	وَهِيَ مَاءٌ
u'وَهِيَ ماحِيَة':Subject, #2: 2	وَهِيَ مَاءُ
u'وَهِيَ مَادَّةٌ':Subject, #1: 1	وَهِيَ مَاحِيَةٌ
u'وَهِيَ مَادَّةٌ':Subject, #1: 1	وَهِيَ الْمَادَّةُ
u'وَهِيَ مَاشِي':Subject, #2: 2	وَهِيَ مَادَّةُ
u'وَهِيَ مَاشِي':Subject, #1: 1	وَهِيَ الْمَاشِيَةُ
u'وَهِيَ مَاشِيَةٌ':Subject, #2: 2	وَهِيَ مَاشِيَةٌ
u'وَهِيَ مَاشِيَةٌ':Subject, #1: 1	وَهِيَ الْمَاشِيَةُ
u'وَهِيَ مَاضِي':Subject, #2: 2	وَهِيَ مَاشِيَةٌ
u'وَهِيَ مَاضِي':Subject, #1: 1	وَهِيَ مَاضِيَةٌ
u'وَهِيَ مَأْكُولٌ':Subject, #1: 1	وَهِيَ مَاضِيَةُ
u'وَهِيَ مَالٌ':Subject, #1: 1	وَهِيَ مَأْكُولَةٌ
u'وَهِيَ مَالٌ':Subject, #2: 2	وَهِيَ مَالٌ
u'وَهِيَ مَالٌ':Subject, #2: 2	وَهِيَ مَالُ
u'وَهِيَ مالِك':Subject, #5: 5	وَهِيَ الْمَالُ
u'وَهِيَ مالِكِيّ':Subject, #1: 1	وَهِيَ مَالِكِيَّتُهُ
u'وَهِيَ مَالِيٌّ':Subject, #1: 1	وَهِيَ مَالِكِيَّتُهُ
u'وَهِيَ مَأْمُورٌ':Subject, #2: 2	وَهِيَ الْمَالِيَّةُ
u'وَهِيَ مَأْمُونٌ':Subject, #1: 1	وَهِيَ مَأْمُورَةٌ
u'وَهِيَ مَانِعٌ':Subject, #1: 1	وَهِيَ مَأْمُونَةٌ
u'وَهِيَ مُبَاحٌ':Subject, #6: 6	وَهِيَ مَانِعَةٌ
u'وَهِيَ مُبَاحٌ':Subject, #1: 1	وَهِيَ الْمُبَاحُ
u'وَهِيَ مُبَاحٌ':Subject, #1: 1	وَهِيَ الْمُبَاحَاتُ
u'وَهِيَ مُبَاحٌ':Subject, #1: 1	وَهِيَ مُبَاحَةُ
u'وَهِيَ مُبَادَرَةٌ':Subject, #2: 2	وَهِيَ مُبَاحَةٌ
u'وَهِيَ مُبَادَلَةٌ':Subject, #1: 1	وَهِيَ الْمُبَادَرَةُ
u'وَهِيَ مُبَادَلَةٌ':Subject, #1: 1	وَهِيَ الْمُبَادَلَةُ
u'وَهِيَ مُبَارَكٌ':Subject, #1: 1	وَهِيَ مُبَادَلَةُ
u'وَهِيَ مُبَارَكَةٌ':Subject, #1: 1	وَهِيَ الْمُبَارَكَاتُ
u'وَهِيَ مُبَاشِرٌ':Subject, #1: 1	وَهِيَ الْمُبَارَكَاتُ
u'وَهِيَ مُبَاشَرَةٌ':Subject, #1: 1	وَهِيَ مُبَاشِرَةٌ
u'وَهِيَ مُبَالَغَةٌ':Subject, #2: 2	وَهِيَ الْمُبَاشَرَةُ
u'وَهِيَ مُبَايَعَةٌ':Subject, #1: 1	وَهِيَ الْمُبَالَغَةُ
u'وَهِيَ مُبْتَلٌّ':Subject, #1: 1	وَهِيَ الْمُبَايَعَةُ
u'وَهِيَ مَبْتُوت':Subject, #1: 1	وَهِيَ مُبْتَلَّةٌ
u'وَهِيَ مُبْطَلٌ':Subject, #2: 2	وَهِيَ مَبْتُوتَةٌ
u'وَهِيَ مَبْنِيٌّ':Subject, #1: 1	وَهِيَ مُبْطَلَةٌ
u'وَهِيَ مَبِيتٌ':Subject, #11: 11	وَهِيَ مَبْنِيَّةٌ
u'وَهِيَ مُبَيَّنٌ':Subject, #1: 1	وَهِيَ مَبِيتُ
u'وَهِيَ مُتَأَخِّرٌ':Subject, #1: 1	وَهِيَ مُبَيَّنَةٌ
u'وَهِيَ مُتَأَخِّرٌ':Subject, #3: 3	وَهِيَ مُتَأَخِّرَةٌ
u'وَهِيَ مُتارَكَة':Subject, #4: 4	وَهِيَ الْمُتَأَخِّرَةُ
u'وَهِيَ مُتَأَكِّدٌ':Subject, #1: 1	وَهِيَ الْمُتَارَكَةُ
u'وَهِيَ مُتَبايِن':Subject, #1: 1	وَهِيَ الْمُتَأَكِّدَةُ
u'وَهِيَ مُتَّبَعٌ':Subject, #1: 1	وَهِيَ مُتَبَايِنَةٌ
u'وَهِيَ مُتَجَدِّدٌ':Subject, #1: 1	وَهِيَ الْمُتَّبَعُ
u'وَهِيَ مُتَّجِهٌ':Subject, #1: 1	وَهِيَ مُتَجَدِّدَةٌ
u'وَهِيَ مُتَّحِدٌ':Subject, #1: 1	وَهِيَ مُتَّجِهَةٌ
u'وَهِيَ مُتَحَرِّكٌ':Subject, #1: 1	وَهِيَ مُتَّحِدَةٌ
u'وَهِيَ مُتَحَقِّق':Subject, #1: 1	وَهِيَ مُتَحَرّكَةٌ
u'وَهِيَ مُتَحَيِّرٌ':Subject, #4: 4	وَهِيَ مُتَحَقِّقَةٌ
u'وَهِيَ مُتَحَيِّرٌ':Subject, #1: 1	وَهِيَ الْمُتَحَيِّرَةُ
u'وَهِيَ مُتَّخَذ':Subject, #1: 1	وَهِيَ مُتَحَيِّرَةٌ
u'وَهِيَ مُتَرَتِّب':Subject, #2: 2	وَهِيَ الْمُتَّخَذَةُ
u'وَهِيَ مُتَرَدِّدٌ':Subject, #1: 1	وَهِيَ الْمُتَرَتِّبَةُ
u'وَهِيَ مُتَزَوِّجٌ':Subject, #2: 2	وَهِيَ مُتَرَدِّدَةٌ
u'وَهِيَ مُتَسَاوِي':Subject, #2: 2	وَهِيَ مُتَزَوِّجَةٌ
u'وَهِيَ مُتَسَبِّبٌ':Subject, #2: 2	وَهِيَ مُتَسَاوِيَةٌ
u'وَهِيَ مُتَصَرِّفٌ':Subject, #1: 1	وَهِيَ مُتَسَبِّبَةٌ
u'وَهِيَ مُتَضَرِّرٌ':Subject, #2: 2	وَهِيَ الْمُتَصَرِّفَةُ
u'وَهِيَ مُتَضَمِّن':Subject, #1: 1	وَهِيَ مُتَضَرِّرَةٌ
u'وَهِيَ مُتَعَدِّدٌ':Subject, #2: 2	وَهِيَ مُتَضَمِّنَةٌ
u'وَهِيَ مُتَعَدِّي':Subject, #1: 1	وَهِيَ مُتَعَدِّدَةٌ
u'وَهِيَ مُتَعَلِّقٌ':Subject, #2: 2	وَهِيَ مُتَعَدِّيَةٌ
u'وَهِيَ مُتَعَلِّقٌ':Subject, #1: 1	وَهِيَ الْمُتَعَلِّقَةُ
u'وَهِيَ مُتَعَلِّقٌ':Subject, #1: 1	وَهِيَ مُتَعَلّقَةٌ
u'وَهِيَ مُتَفاوِت':Subject, #4: 4	وَهِيَ مُتَعَلِّقَةٌ
u'وَهِيَ مُتَفاوِت':Subject, #1: 1	وَهِيَ مُتَفَاوِتَةٌ
u'وَهِيَ مُتَّفِقٌ':Subject, #1: 1	وَهِيَ مُتَفَاوِتَةُ
u'وَهِيَ مُتَّفِقٌ':Subject, #1: 1	وَهِيَ الْمُتَّفِقَةُ
u'وَهِيَ مُتَقَارِبٌ':Subject, #1: 1	وَهِيَ مُتَّفِقَةٌ
u'وَهِيَ مُتَقَارِبٌ':Subject, #1: 1	وَهِيَ الْمُتَقَارِبُ
u'وَهِيَ مُتَقَارِبٌ':Subject, #1: 1	وَهِيَ مُتَقَارِبَةُ
u'وَهِيَ مُتَقَدِّمٌ':Subject, #2: 2	وَهِيَ مُتَقَارِبَةٌ
u'وَهِيَ مُتَكامِل':Subject, #5: 5	وَهِيَ الْمُتَقَدِّمَةُ
u'وَهِيَ مُتَّكِئٌ':Subject, #1: 1	وَهِيَ مُتَكَامِلَةٌ
u'وَهِيَ مُتَلاَزِمٌ':Subject, #1: 1	وَهِيَ مُتَّكِئَةٌ
u'وَهِيَ مُتَمَتِّعٌ':Subject, #1: 1	وَهِيَ مُتَلَازِمَةٌ
u'وَهِيَ مُتَناهِي':Subject, #1: 1	وَهِيَ مُتَمَتِّعَةٌ
u'وَهِيَ مُتَنَوِّعٌ':Subject, #1: 1	وَهِيَ مُتَنَاهِيَةٌ
u'وَهِيَ مُتَّهَمٌ':Subject, #4: 4	وَهِيَ مُتَنَوِّعَةٌ
u'وَهِيَ مُتَوَاتِرٌ':Subject, #2: 2	وَهِيَ مُتَّهَمَةٌ
u'وَهِيَ مُتَوَقِّف':Subject, #1: 1	وَهِيَ مُتَوَاتِرَةٌ
u'وَهِيَ مُتَيَقِّن':Subject, #6: 6	وَهِيَ مُتَوَقِّفَةٌ
u'وَهِيَ مِثَالٌ':Subject, #1: 1	وَهِيَ مُتَيَقِّنَةٌ
u'وَهِيَ مُثْقَلٌ':Subject, #1: 1	وَهِيَ مِثَالٌ
u'وَهِيَ مثل':Subject, #1: 1	وَهِيَ الْمُثْقَلَةُ
u'وَهِيَ مِثْلٌ':Subject, #12: 12	وَهِيَ مِثْلُ
u'وَهِيَ مثل':Subject, #12: 12	وَهِيَ مِثْلُ
u'وَهِيَ مِثْلٌ':Subject, #2: 2	وَهِيَ مِثْلُهُ
u'وَهِيَ مُجَادِلٌ':Subject, #2: 2	وَهِيَ مِثْلُهُ
u'وَهِيَ مَجَازٌ':Subject, #1: 1	وَهِيَ الْمُجَادِلَةُ
u'وَهِيَ مُجَاوَزَةٌ':Subject, #3: 3	وَهِيَ مَجَازٌ
u'وَهِيَ مُجْتَمَعٌ':Subject, #1: 1	وَهِيَ مُجَاوَزَةُ
u'وَهِيَ مُجَرَّدٌ':Subject, #2: 2	وَهِيَ مُجْتَمَعُ
u'وَهِيَ مُجْمَعٌ':Subject, #1: 1	وَهِيَ مُجَرَّدُ
u'وَهِيَ مَجْمُوعٌ':Subject, #1: 1	وَهِيَ الْمُجْمَعُ
u'وَهِيَ مَجْنُونٌ':Subject, #1: 1	وَهِيَ الْمَجْمُوعُ
u'وَهِيَ مَجْنُونٌ':Subject, #1: 1	وَهِيَ مَجْنُونٌ
u'وَهِيَ مَجْنُونٌ':Subject, #5: 5	وَهِيَ الْمَجْنُونَةُ
u'وَهِيَ مَجْهُولٌ':Subject, #5: 5	وَهِيَ مَجْنُونَةٌ
u'وَهِيَ مَجْهُولٌ':Subject, #17: 17	وَهِيَ مَجْهُولَةٌ
u'وَهِيَ مَجُوسِيَّةٌ':Subject, #5: 5	وَهِيَ مَجْهُولَةُ
u'وَهِيَ مُحَاشَاةٌ':Subject, #15: 15	وَهِيَ مَجُوسِيَّةٌ
u'وَهِيَ مُحاصَّة':Subject, #2: 2	وَهِيَ الْمُحَاشَاةُ
u'وَهِيَ مَحَالَةٌ':Subject, #1: 1	وَهِيَ الْمُحَاصَّةُ
u'وَهِيَ مُحالَفَة':Subject, #1: 1	وَهِيَ مَحَالَةٌ
u'وَهِيَ مَحَبَّةٌ':Subject, #1: 1	وَهِيَ الْمُحَالَفَةُ
u'وَهِيَ مَحْبُوبٌ':Subject, #3: 3	وَهِيَ الْمَحَبَّةُ
u'وَهِيَ مَحْبُوسٌ':Subject, #1: 1	وَهِيَ مَحْبُوبَةٌ
u'وَهِيَ مُحْتَاجٌ':Subject, #7: 7	وَهِيَ مَحْبُوسَةٌ
u'وَهِيَ مُحْتَسَبٌ':Subject, #4: 4	وَهِيَ مُحْتَاجَةٌ
u'وَهِيَ مُحْتَمَلٌ':Subject, #1: 1	وَهِيَ مُحْتَسَبَةٌ
u'وَهِيَ مَحْدُودٌ':Subject, #4: 4	وَهِيَ مُحْتَمَلَةٌ
u'وَهِيَ مَحْذُوفٌ':Subject, #1: 1	وَهِيَ مَحْدُودَةٌ
u'وَهِيَ مُحَرِّكٌ':Subject, #1: 1	وَهِيَ مَحْذُوفَةٌ
u'وَهِيَ مُحْرِمٌ':Subject, #1: 1	وَهِيَ الْمُحَرِّكَةُ
u'وَهِيَ مُحَرَّمٌ':Subject, #10: 10	وَهِيَ مُحْرِمَةٌ
u'وَهِيَ مَحْرَم':Subject, #1: 1	وَهِيَ الْمُحَرَّمَةُ
u'وَهِيَ مُحَرَّمٌ':Subject, #1: 1	وَهِيَ الْمَحْرَمِيَّةُ
u'وَهِيَ مُحَرَّمٌ':Subject, #3: 3	وَهِيَ مُحَرَّمَةُ
u'وَهِيَ مَحْرَمَة':Subject, #9: 9	وَهِيَ مُحَرَّمَةٌ
u'وَهِيَ مَحْسُوبٌ':Subject, #1: 1	وَهِيَ الْمَحْرَمِيَّةُ
u'وَهِيَ مَحْشُوّ':Subject, #1: 1	وَهِيَ مَحْسُوبَةٌ
u'وَهِيَ مُحْصَنٌ':Subject, #1: 1	وَهِيَ مَحْشُوَّةٌ
u'وَهِيَ مَحْصُورٌ':Subject, #2: 2	وَهِيَ مُحْصَنَةٌ
u'وَهِيَ مَحْفُوفٌ':Subject, #2: 2	وَهِيَ مَحْصُورَةٌ
u'وَهِيَ مُحَقَّقٌ':Subject, #1: 1	وَهِيَ مَحْفُوفَةٌ
u'وَهِيَ مُحَقَّقٌ':Subject, #1: 1	وَهِيَ مُحَقَّقَةٌ
u'وَهِيَ مَحَلٌّ':Subject, #1: 1	وَهِيَ مُحَقَّقَةُ
u'وَهِيَ مَحَلٌّ':Subject, #1: 1	وَهِيَ الْمَحَلُّ
u'وَهِيَ مَحَلٌّ':Subject, #1: 1	وَهِيَ مَحَلُّهُ
u'وَهِيَ مَحَلٌّ':Subject, #5: 5	وَهِيَ مَحَلٌّ
u'وَهِيَ مَحَلَّةٌ':Subject, #7: 7	وَهِيَ مَحَلُّ
u'وَهِيَ مَحْمَلٌ':Subject, #1: 1	وَهِيَ الْمَحَلَّةُ
u'وَهِيَ مَحْمُودٌ':Subject, #3: 3	وَهِيَ الْمَحْمَلُ
u'وَهِيَ مَحْمُولٌ':Subject, #1: 1	وَهِيَ الْمَحْمُودَةُ
u'وَهِيَ مَحْمُومٌ':Subject, #5: 5	وَهِيَ مَحْمُولَةٌ
u'وَهِيَ مُخَابَرَةٌ':Subject, #1: 1	وَهِيَ مَحْمُومَةٌ
u'وَهِيَ مُخَاطَبٌ':Subject, #1: 1	وَهِيَ الْمُخَابَرَةُ
u'وَهِيَ مُخَاطَبَةٌ':Subject, #1: 1	وَهِيَ مُخَاطَبَةُ
u'وَهِيَ مُخَالَطَةٌ':Subject, #1: 1	وَهِيَ مُخَاطَبَةُ
u'وَهِيَ مُخَالِفٌ':Subject, #1: 1	وَهِيَ مُخَالَطَةُ
u'وَهِيَ مُخَالِفٌ':Subject, #1: 1	وَهِيَ الْمُخَالِفَةُ
u'وَهِيَ مُخَالَفَةٌ':Subject, #5: 5	وَهِيَ مُخَالِفَةٌ
u'وَهِيَ مُخْتَارٌ':Subject, #1: 1	وَهِيَ مُخَالَفَةُ
u'وَهِيَ مُخْتَارٌ':Subject, #1: 1	وَهِيَ مُخْتَارَةٌ
u'وَهِيَ مُخْتَارٌ':Subject, #2: 2	وَهِيَ الْمُخْتَارَةُ
u'وَهِيَ مُخْتَصّ':Subject, #3: 3	وَهِيَ الْمُخْتَارُ
u'وَهِيَ مُخْتَصَرٌ':Subject, #1: 1	وَهِيَ مُخْتَصَّةٌ
u'وَهِيَ مُخْتَصَرٌ':Subject, #1: 1	وَهِيَ مُخْتَصَرَةُ
u'وَهِيَ مُخْتَلَفٌ':Subject, #2: 2	وَهِيَ مُخْتَصَرَةٌ
u'وَهِيَ مُخْتَلِفٌ':Subject, #2: 2	وَهِيَ مُخْتَلَفٌ
u'وَهِيَ مِخَدَّةٌ':Subject, #2: 2	وَهِيَ مُخْتَلِفَةٌ
u'وَهِيَ مَخْصُوصٌ':Subject, #1: 1	وَهِيَ الْمِخَدَّةُ
u'وَهِيَ مَخْصُوصٌ':Subject, #1: 1	وَهِيَ الْمَخْصُوصَةُ
u'وَهِيَ مَخْلُوق':Subject, #2: 2	وَهِيَ مَخْصُوصَةٌ
u'وَهِيَ مَخُوفٌ':Subject, #1: 1	وَهِيَ الْمَخْلُوقِيَّةُ
u'وَهِيَ مُخَيَّرٌ':Subject, #1: 1	وَهِيَ الْمَخُوفَةُ
u'وَهِيَ مَدَارِسُ':Subject, #1: 1	وَهِيَ مُخَيَّرٌ
u'وَهِيَ مُدَاهَنَةٌ':Subject, #1: 1	وَهِيَ الْمَدَارِسُ
u'وَهِيَ مُدَبِّرٌ':Subject, #1: 1	وَهِيَ مُدَاهَنَةٌ
u'وَهِيَ مُدَبِّرٌ':Subject, #1: 1	وَهِيَ الْمُدَبِّرَةُ
u'وَهِيَ مَدْبَغَةٌ':Subject, #1: 1	وَهِيَ مُدَبِّرَةٌ
u'وَهِيَ مُدَّةٌ':Subject, #2: 2	وَهِيَ الْمَدْبَغَةُ
u'وَهِيَ مُدَّةٌ':Subject, #1: 1	وَهِيَ الْمُدَّةُ
u'وَهِيَ مُدَّةٌ':Subject, #3: 3	وَهِيَ مُدَّةُ
u'وَهِيَ مَدْخُولٌ':Subject, #5: 5	وَهِيَ مُدَّةٌ
u'وَهِيَ مَدْخُولٌ':Subject, #10: 10	وَهِيَ مَدْخُولٌ
u'وَهِيَ مَدَنِيٌّ':Subject, #1: 1	وَهِيَ مَدْخُولَةٌ
u'وَهِيَ مَدِينٌ':Subject, #1: 1	وَهِيَ مَدَنِيَّةٌ
u'وَهِيَ مَدِينَةٌ':Subject, #2: 2	وَهِيَ الْمَدِينَةُ
u'وَهِيَ مَدْيُونٌ':Subject, #2: 2	وَهِيَ الْمَدِينَةُ
u'وَهِيَ مَذْبُوحٌ':Subject, #3: 3	وَهِيَ مَدْيُونَةٌ
u'وَهِيَ مَذْعُورٌ':Subject, #1: 1	وَهِيَ مَذْبُوحَةٌ
u'وَهِيَ مَذْكُورٌ':Subject, #1: 1	وَهِيَ مَذْعُورَةٌ
u'وَهِيَ مَذْكُورٌ':Subject, #12: 12	وَهِيَ مَذْكُورَةٌ
u'وَهِيَ مَذْمُومٌ':Subject, #5: 5	وَهِيَ الْمَذْكُورَةُ
u'وَهِيَ مَذْهَبٌ':Subject, #2: 2	وَهِيَ مَذْمُومَةٌ
u'وَهِيَ مرٌّ':Subject, #74: 74	وَهِيَ الْمَذْهَبُ
u'وَهِيَ مرٌّ':Subject, #1: 1	وَهِيَ الْمَرّةُ
u'وَهِيَ مَرْء':Subject, #2: 2	وَهِيَ مَرَّةٌ
u'وَهِيَ مِرْآةٌ':Subject, #2: 2	وَهِيَ مَرْئِيَّةٌ
u'وَهِيَ مُرَادٌ':Subject, #1: 1	وَهِيَ الْمِرْآةُ
u'وَهِيَ مُرَادٌ':Subject, #12: 12	وَهِيَ الْمُرَادَةُ
u'وَهِيَ مراد':Subject, #1: 1	وَهِيَ مُرَادَةٌ
u'وَهِيَ مُرَادٌ':Subject, #3: 3	وَهِيَ مُرَادُ
u'وَهِيَ مراد':Subject, #3: 3	وَهِيَ مُرَادُ
u'وَهِيَ مُرَادٌ':Subject, #5: 5	وَهِيَ الْمُرَادُ
u'وَهِيَ مُرَاهِقٌ':Subject, #5: 5	وَهِيَ الْمُرَادُ
u'وَهِيَ مُرَبِّي':Subject, #1: 1	وَهِيَ الْمُرَاهِقَةُ
u'وَهِيَ مَرَّةٌ':Subject, #1: 1	وَهِيَ الْمُرَبِّيَةُ
u'وَهِيَ مَرَّةٌ':Subject, #1: 1	وَهِيَ الْمَرّةُ
u'وَهِيَ مُرْتاب':Subject, #2: 2	وَهِيَ مَرَّةٌ
u'وَهِيَ مُرَتَّبٌ':Subject, #5: 5	وَهِيَ مُرْتَابَةٌ
u'وَهِيَ مَرْتَبَةٌ':Subject, #3: 3	وَهِيَ مُرَتَّبَةٌ
u'وَهِيَ مَرْتَبَةٌ':Subject, #1: 1	وَهِيَ مَرْتَبَةٌ
u'وَهِيَ مُرْتَبِطٌ':Subject, #2: 2	وَهِيَ الْمَرْتَبَةُ
u'وَهِيَ مُرْتَدٌّ':Subject, #1: 1	وَهِيَ مُرْتَبِطَةٌ
u'وَهِيَ مُرَجَّحٌ':Subject, #5: 5	وَهِيَ مُرْتَدَّةٌ
u'وَهِيَ مُرَجَّحٌ':Subject, #1: 1	وَهِيَ الْمُرَجَّحَةُ
u'وَهِيَ مُرَجِّحٌ':Subject, #1: 1	وَهِيَ مُرَجَّحَةٌ
u'وَهِيَ مَرْدُودٌ':Subject, #1: 1	وَهِيَ مُرَجِّحَةٌ
u'وَهِيَ مُرْسَلٌ':Subject, #3: 3	وَهِيَ مَرْدُودَةٌ
u'وَهِيَ مَرَضٌ':Subject, #1: 1	وَهِيَ مُرْسَلَةٌ
u'وَهِيَ مُرْضِعٌ':Subject, #1: 1	وَهِيَ الْمَرَضُ
u'وَهِيَ مُرَكَّبٌ':Subject, #2: 2	وَهِيَ الْمُرْضِعَةُ
u'وَهِيَ مُرَكَّبٌ':Subject, #1: 1	وَهِيَ الْمُرَكَّبَةُ
u'وَهِيَ مَرْهُونٌ':Subject, #2: 2	وَهِيَ مُرَكَّبَةٌ
u'وَهِيَ مُرُوءةٌ':Subject, #3: 3	وَهِيَ مَرْهُونَةٌ
u'وَهِيَ مَرْوَة':Subject, #1: 1	وَهِيَ مُرُوءَةٌ
u'وَهِيَ مَرْوَة':Subject, #1: 1	وَهِيَ مَرْوِيّةٌ
u'وَهِيَ مُرُورٌ':Subject, #1: 1	وَهِيَ مَرْوِيَّةٌ
u'وَهِيَ مَرْوِيّ':Subject, #1: 1	وَهِيَ الْمُرُورُ
u'وَهِيَ مَرْوِيّ':Subject, #1: 1	وَهِيَ مَرْوِيّةٌ
u'وَهِيَ مَزْرُوعٌ':Subject, #1: 1	وَهِيَ مَرْوِيَّةٌ
u'وَهِيَ مَسّ':Subject, #3: 3	وَهِيَ مَزْرُوعَةٌ
u'وَهِيَ مَسَاجِدُ':Subject, #1: 1	وَهِيَ الْمَسَّةُ
u'وَهِيَ مَسَافَةٌ':Subject, #2: 2	وَهِيَ الْمَسَاجِدُ
u'وَهِيَ مُسَافِرٌ':Subject, #1: 1	وَهِيَ مَسَافَةُ
u'وَهِيَ مُسَافِرٌ':Subject, #1: 1	وَهِيَ الْمُسَافِرُ
u'وَهِيَ مُساقاة':Subject, #2: 2	وَهِيَ مُسَافِرَةٌ
u'وَهِيَ مُساقاة':Subject, #1: 1	وَهِيَ مُسَاقَاةُ
u'وَهِيَ مُسَاكَنَةٌ':Subject, #2: 2	وَهِيَ الْمُسَاقَاةُ
u'وَهِيَ مَسْأَلَةٌ':Subject, #1: 1	وَهِيَ الْمُسَاكَنَةُ
u'وَهِيَ مَسْأَلَةٌ':Subject, #129: 129	وَهِيَ مَسْأَلَةُ
u'وَهِيَ مَسْأَلَةٌ':Subject, #38: 38	وَهِيَ الْمَسْأَلَةُ
u'وَهِيَ مُسَالَمَةٌ':Subject, #50: 50	وَهِيَ مَسْأَلَةٌ
u'وَهِيَ مُسَاهَلَةٌ':Subject, #1: 1	وَهِيَ الْمُسَالَمَةُ
u'وَهِيَ مُسَاوَاةٌ':Subject, #1: 1	وَهِيَ الْمُسَاهَلَةُ
u'وَهِيَ مَسَائِلُ':Subject, #3: 3	وَهِيَ الْمُسَاوَاةُ
u'وَهِيَ مَسْبُوق':Subject, #4: 4	وَهِيَ مَسَائِلُ
u'وَهِيَ مَسَّة':Subject, #1: 1	وَهِيَ مَسْبُوقٌ
u'وَهِيَ مُسْتَثْناة':Subject, #1: 1	وَهِيَ الْمَسَّةُ
u'وَهِيَ مُسْتَحَبٌّ':Subject, #9: 9	وَهِيَ مُسْتَثْنَاةٌ
u'وَهِيَ مُسْتَحَقٌّ':Subject, #20: 20	وَهِيَ مُسْتَحَبَّةٌ
u'وَهِيَ مُسْتَحَقٌّ':Subject, #1: 1	وَهِيَ مُسْتَحَقَّةٌ
u'وَهِيَ مُسْتَحِيلٌ':Subject, #2: 2	وَهِيَ الْمُسْتَحَقَّةُ
u'وَهِيَ مُسْتَدِيرٌ':Subject, #3: 3	وَهِيَ مُسْتَحِيلَةٌ
u'وَهِيَ مُسْتَطِيلٌ':Subject, #2: 2	وَهِيَ مُسْتَدِيرُ
u'وَهِيَ مُسْتَعْمَلٌ':Subject, #1: 1	وَهِيَ مُسْتَطِيلَةٌ
u'وَهِيَ مُسْتَغْرِقٌ':Subject, #3: 3	وَهِيَ مُسْتَعْمَلَةٌ
u'وَهِيَ مُسْتَقْبِلٌ':Subject, #2: 2	وَهِيَ مُسْتَغْرِقَةٌ
u'وَهِيَ مُسْتَقِرٌّ':Subject, #1: 1	وَهِيَ مُسْتَقْبِلَةٌ
u'وَهِيَ مُسْتَلْزِمٌ':Subject, #1: 1	وَهِيَ مُسْتَقِرَّةٌ
u'وَهِيَ مُسْتَمِرٌّ':Subject, #1: 1	وَهِيَ مُسْتَلْزِمَةٌ
u'وَهِيَ مُسْتَنِدٌ':Subject, #1: 1	وَهِيَ مُسْتَمِرَّةٌ
u'وَهِيَ مَسْتُورٌ':Subject, #1: 1	وَهِيَ مُسْتَنِدَةٌ
u'وَهِيَ مُسْتَوْعِبٌ':Subject, #1: 1	وَهِيَ مَسْتُورَةٌ
u'وَهِيَ مَسْجِدٌ':Subject, #1: 1	وَهِيَ الْمُسْتَوْعِبُ
u'وَهِيَ مَسْجِدٌ':Subject, #1: 1	وَهِيَ مَسْجِدٌ
u'وَهِيَ مَسْكَنٌ':Subject, #1: 1	وَهِيَ مَسْجِدُ
u'وَهِيَ مُسْلِمٌ':Subject, #1: 1	وَهِيَ مَسْكَنُهُ
u'وَهِيَ مَسْلُوبٌ':Subject, #8: 8	وَهِيَ مُسْلِمَةٌ
u'وَهِيَ مَسْلُوكٌ':Subject, #1: 1	وَهِيَ مَسْلُوبَةُ
u'وَهِيَ مُسَمّاة':Subject, #1: 1	وَهِيَ مَسْلُوكَةٌ
u'وَهِيَ مَسْمُوعٌ':Subject, #5: 5	وَهِيَ الْمُسَمَّاةُ
u'وَهِيَ مُسَمَّى':Subject, #1: 1	وَهِيَ مَسْمُوعَةٌ
u'وَهِيَ مُسَنَّم':Subject, #1: 1	وَهِيَ الْمُسَمَّيَاتُ
u'وَهِيَ مَسِيرَةٌ':Subject, #1: 1	وَهِيَ مُسَنَّمَةٌ
u'وَهِيَ مَسِيلٌ':Subject, #3: 3	وَهِيَ مَسِيرَةُ
u'وَهِيَ مُسِيئَةٌ':Subject, #1: 1	وَهِيَ مَسِيلُ
u'وَهِيَ مُشَاحَّةٌ':Subject, #1: 1	وَهِيَ مُسِيئَةٌ
u'وَهِيَ مُشار':Subject, #1: 1	وَهِيَ مُشَاحَّةٌ
u'وَهِيَ مُشَارَكَةٌ':Subject, #1: 1	وَهِيَ الْمُشَارُ
u'وَهِيَ مُشَارَكَةٌ':Subject, #1: 1	وَهِيَ الْمُشَارَكَاتُ
u'وَهِيَ مُشَارَكَةٌ':Subject, #1: 1	وَهِيَ الْمُشَارَكَةُ
u'وَهِيَ مُشاق':Subject, #1: 1	وَهِيَ مُشَارَكَةٌ
u'وَهِيَ مُشَاهَدٌ':Subject, #1: 1	وَهِيَ مُشَاقَةُ
u'وَهِيَ مُشَاهَدٌ':Subject, #1: 1	وَهِيَ الْمُشَاهَدَةُ
u'وَهِيَ مُشَاهَدَةٌ':Subject, #1: 1	وَهِيَ مُشَاهَدَةُ
u'وَهِيَ مُشَاهَدَةٌ':Subject, #1: 1	وَهِيَ الْمُشَاهَدَةُ
u'وَهِيَ مُشَاوَرَةٌ':Subject, #1: 1	وَهِيَ مُشَاهَدَةُ
u'وَهِيَ مُشَبَّهٌ':Subject, #1: 1	وَهِيَ الْمُشَاوَرَةُ
u'وَهِيَ مُشَبَّهٌ':Subject, #1: 1	وَهِيَ الْمُشَبَّهُ
u'وَهِيَ مُشْتَرَكٌ':Subject, #1: 1	وَهِيَ الْمُشَبَّهَةُ
u'وَهِيَ مُشْتَرِي':Subject, #12: 12	وَهِيَ مُشْتَرَكَةٌ
u'وَهِيَ مُشْتَقٌّ':Subject, #1: 1	وَهِيَ الْمُشْتَرِيَةُ
u'وَهِيَ مُشْتَمِلٌ':Subject, #8: 8	وَهِيَ مُشْتَقَّةٌ
u'وَهِيَ مَشْحُونٌ':Subject, #5: 5	وَهِيَ مُشْتَمِلَةٌ
u'وَهِيَ مُشْرِك':Subject, #1: 1	وَهِيَ مَشْحُونَةٌ
u'وَهِيَ مُشْرِك':Subject, #1: 1	وَهِيَ الْمُشْرِكَةُ
u'وَهِيَ مَشْرُوطٌ':Subject, #7: 7	وَهِيَ مُشْرِكَةٌ
u'وَهِيَ مَشْرُوعٌ':Subject, #1: 1	وَهِيَ مَشْرُوطَةٌ
u'وَهِيَ مَشْرُوعٌ':Subject, #10: 10	وَهِيَ مَشْرُوعَةٌ
u'وَهِيَ مشطة':Subject, #1: 1	وَهِيَ الْمَشْرُوعَةُ
u'وَهِيَ مَشْعَرٌ':Subject, #1: 1	وَهِيَ مِشْطَةُ
u'وَهِيَ مَشْعَر':Subject, #1: 1	وَهِيَ الْمَشْعَرُ
u'وَهِيَ مَشْغُولٌ':Subject, #1: 1	وَهِيَ الْمَشْعَرُ
u'وَهِيَ مَشَقَّةٌ':Subject, #8: 8	وَهِيَ مَشْغُولَةٌ
u'وَهِيَ مَشَقَّةٌ':Subject, #1: 1	وَهِيَ مَشَقَّةٌ
u'وَهِيَ مَشَقَّةٌ':Subject, #2: 2	وَهِيَ مَشَقَّةُ
u'وَهِيَ مَشْقُوقٌ':Subject, #3: 3	وَهِيَ الْمَشَقَّةُ
u'وَهِيَ مَشْقُوقٌ':Subject, #1: 1	وَهِيَ الْمَشْقُوقَةُ
u'وَهِيَ مُشْكِلٌ':Subject, #2: 2	وَهِيَ مَشْقُوقَةُ
u'وَهِيَ مُشْكِلٌ':Subject, #1: 1	وَهِيَ الْمُشْكِلَةُ
u'وَهِيَ مَشْهُورٌ':Subject, #8: 8	وَهِيَ مُشْكِلَةٌ
u'وَهِيَ مَشْهُورٌ':Subject, #11: 11	وَهِيَ مَشْهُورَةٌ
u'وَهِيَ مَشْهُورٌ':Subject, #1: 1	وَهِيَ مَشْهُورٌ
u'وَهِيَ مَشْهُورٌ':Subject, #2: 2	وَهِيَ الْمَشْهُورُ
u'وَهِيَ مَشِيئَةٌ':Subject, #9: 9	وَهِيَ الْمَشْهُورَةُ
u'وَهِيَ مَشِيئَةٌ':Subject, #1: 1	وَهِيَ مَشِيئَةُ
u'وَهِيَ مَصّ':Subject, #3: 3	وَهِيَ الْمَشِيئَةُ
u'وَهِيَ مُصافاة':Subject, #1: 1	وَهِيَ الْمَصَّةُ
u'وَهِيَ مَصْدَر':Subject, #1: 1	وَهِيَ الْمُصَافَاةُ
u'وَهِيَ مَصْدَرٌ':Subject, #1: 1	وَهِيَ مَصْدَرِيَّةٌ
u'وَهِيَ مَصْدَرٌ':Subject, #2: 2	وَهِيَ مَصْدَرٌ
u'وَهِيَ مُصَدَّقٌ':Subject, #4: 4	وَهِيَ مَصْدَرُ
u'وَهِيَ مُصَدِّقٌ':Subject, #1: 1	وَهِيَ مُصَدَّقَةٌ
u'وَهِيَ مَصْدُوعٌ':Subject, #3: 3	وَهِيَ مُصَدِّقَةٌ
u'وَهِيَ مِصْرٌ':Subject, #1: 1	وَهِيَ مَصْدُوعَةٌ
u'وَهِيَ مُصَرِّحٌ':Subject, #1: 1	وَهِيَ مِصْرُ
u'وَهِيَ مَصْلَحَةٌ':Subject, #1: 1	وَهِيَ مُصَرِّحَةٌ
u'وَهِيَ مَصْلَحَةٌ':Subject, #1: 1	وَهِيَ مَصْلَحَةُ
u'وَهِيَ مُصْمَت':Subject, #2: 2	وَهِيَ مَصْلَحَةٌ
u'وَهِيَ مُصَوَّرٌ':Subject, #1: 1	وَهِيَ مُصْمَتٌ
u'وَهِيَ مُصِيبٌ':Subject, #1: 1	وَهِيَ مُصَوَّرَةٌ
u'وَهِيَ مُصِيبَةٌ':Subject, #1: 1	وَهِيَ مُصِيبَةٌ
u'وَهِيَ مُضَافٌ':Subject, #1: 1	وَهِيَ مُصِيبَةٌ
u'وَهِيَ مُضَافٌ':Subject, #1: 1	وَهِيَ الْمُضَافُ
u'وَهِيَ مَضَامِينُ':Subject, #3: 3	وَهِيَ مُضَافَةٌ
u'وَهِيَ مُضِرٌّ':Subject, #1: 1	وَهِيَ الْمَضَامِينُ
u'وَهِيَ مَضَرَّةٌ':Subject, #2: 2	وَهِيَ مُضِرَّةٌ
u'وَهِيَ مُضْطَرٌّ':Subject, #1: 1	وَهِيَ مَضَرَّةُ
u'وَهِيَ مُضْطَرٌّ':Subject, #1: 1	وَهِيَ الْمُضْطَرُّ
u'وَهِيَ مُضْطَرِبٌ':Subject, #1: 1	وَهِيَ مُضْطَرَّةٌ
u'وَهِيَ مَضْمُونٌ':Subject, #1: 1	وَهِيَ مُضْطَرِبَةٌ
u'وَهِيَ مَضْمُونٌ':Subject, #1: 1	وَهِيَ الْمَضْمُونَةُ
u'وَهِيَ مُضِيٌّ':Subject, #5: 5	وَهِيَ مَضْمُونَةٌ
u'وَهِيَ مُطَابَقَةٌ':Subject, #1: 1	وَهِيَ مُضِيُّ
u'وَهِيَ مَطَافٌ':Subject, #1: 1	وَهِيَ الْمُطَابَقَةُ
u'وَهِيَ مُطَالَبٌ':Subject, #1: 1	وَهِيَ الْمَطَافُ
u'وَهِيَ مُطَالَبٌ':Subject, #1: 1	وَهِيَ الْمُطَالَبَةُ
u'وَهِيَ مُطَالَبَةٌ':Subject, #2: 2	وَهِيَ مُطَالَبَةُ
u'وَهِيَ مُطَالَبَةٌ':Subject, #1: 1	وَهِيَ الْمُطَالَبَةُ
u'وَهِيَ مُطاوِع':Subject, #2: 2	وَهِيَ مُطَالَبَةُ
u'وَهِيَ مُطاوَعَة':Subject, #6: 6	وَهِيَ مُطَاوِعَةٌ
u'وَهِيَ مَطْبُوعٌ':Subject, #1: 1	وَهِيَ مُطَاوَعَةٌ
u'وَهِيَ مَطْبُوعَةٌ':Subject, #1: 1	وَهِيَ مَطْبُوعَةٌ
u'وَهِيَ مُطْرِبٌ':Subject, #1: 1	وَهِيَ مَطْبُوعَةٌ
u'وَهِيَ مُطَلَّقٌ':Subject, #1: 1	وَهِيَ مُطْرِبَةٌ
u'وَهِيَ مُطَلَّقٌ':Subject, #5: 5	وَهِيَ مُطَلَّقَةٌ
u'وَهِيَ مَطْلُوبٌ':Subject, #6: 6	وَهِيَ الْمُطَلَّقَةُ
u'وَهِيَ مَطْلُوبٌ':Subject, #2: 2	وَهِيَ مَطْلُوبٌ
u'وَهِيَ مَظْنُون':Subject, #5: 5	وَهِيَ مَطْلُوبَةٌ
u'وَهِيَ مَظْنُون':Subject, #1: 1	وَهِيَ الْمَظْنُونَاتُ
u'وَهِيَ مَظْنُون':Subject, #1: 1	وَهِيَ الْمَظْنُونَةُ
u'وَهِيَ مُعَارَضَةٌ':Subject, #1: 1	وَهِيَ مَظْنُونَةٌ
u'وَهِيَ مُعَارَضَةٌ':Subject, #1: 1	وَهِيَ الْمُعَارَضَاتُ
u'وَهِيَ مُعَارَضَةٌ':Subject, #1: 1	وَهِيَ الْمُعَارَضَةُ
u'وَهِيَ مُعَارَضَةٌ':Subject, #1: 1	وَهِيَ مُعَارَضَةٌ
u'وَهِيَ معاصر':Subject, #1: 1	وَهِيَ مُعَارَضَةُ
u'وَهِيَ مَعَاصِرُ':Subject, #1: 1	وَهِيَ الْمَعَاصِرُ
u'وَهِيَ مُعَامَلَةٌ':Subject, #1: 1	وَهِيَ الْمَعَاصِرُ
u'وَهِيَ مُعانَقَة':Subject, #1: 1	وَهِيَ الْمُعَامَلَاتُ
u'وَهِيَ مُعَاوَنَةٌ':Subject, #1: 1	وَهِيَ الْمُعَانَقَةُ
u'وَهِيَ مُعْتَادٌ':Subject, #1: 1	وَهِيَ الْمُعَاوَنَةُ
u'وَهِيَ مُعْتَبَرٌ':Subject, #2: 2	وَهِيَ مُعْتَادَةٌ
u'وَهِيَ مُعْتَبَرٌ':Subject, #15: 15	وَهِيَ مُعْتَبَرَةٌ
u'وَهِيَ مُعْتَدٌّ':Subject, #5: 5	وَهِيَ الْمُعْتَبَرَةُ
u'وَهِيَ مُعْتَدٌّ':Subject, #13: 13	وَهِيَ مُعْتَدَّةٌ
u'وَهِيَ مُعْتَدٌّ':Subject, #1: 1	وَهِيَ مُعْتَدَّةُ
u'وَهِيَ مُعْتَرِضٌ':Subject, #3: 3	وَهِيَ الْمُعْتَدَّةُ
u'وَهِيَ مُعْتَمَدٌ':Subject, #2: 2	وَهِيَ مُعْتَرِضَةٌ
u'وَهِيَ مُعْتَمَدٌ':Subject, #1: 1	وَهِيَ الْمُعْتَمَدُ
u'وَهِيَ مَعْتُوهٌ':Subject, #1: 1	وَهِيَ الْمُعْتَمَدَةُ
u'وَهِيَ مُعْجِزٌ':Subject, #2: 2	وَهِيَ مَعْتُوهَةٌ
u'وَهِيَ مُعْجِزَةٌ':Subject, #1: 1	وَهِيَ الْمُعْجِزَةُ
u'وَهِيَ مُعَجَّلٌ':Subject, #1: 1	وَهِيَ الْمُعْجِزَةُ
u'وَهِيَ مُعَدٌّ':Subject, #1: 1	وَهِيَ مُعَجَّلَةٌ
u'وَهِيَ مَعِدَةٌ':Subject, #1: 1	وَهِيَ مُعَدَّةٌ
u'وَهِيَ مَعْدُودٌ':Subject, #1: 1	وَهِيَ مَعِدَةُ
u'وَهِيَ مَعْدُومٌ':Subject, #3: 3	وَهِيَ مَعْدُودَةٌ
u'وَهِيَ مَعْذُورٌ':Subject, #6: 6	وَهِيَ مَعْدُومَةٌ
u'وَهِيَ مُعَرَّبٌ':Subject, #2: 2	وَهِيَ مَعْذُورَةٌ
u'وَهِيَ مُعَرَّضٌ':Subject, #1: 1	وَهِيَ مُعَرَّبَةُ
u'وَهِيَ مَعْرِفَةٌ':Subject, #1: 1	وَهِيَ مُعَرَّضَةٌ
u'وَهِيَ مَعْرِفَة':Subject, #1: 1	وَهِيَ الْمَعْرِفَةُ
u'وَهِيَ مَعْرِفَةٌ':Subject, #1: 1	وَهِيَ الْمَعْرِفَةُ
u'وَهِيَ مَعْرِفَة':Subject, #2: 2	وَهِيَ مَعْرِفَةُ
u'وَهِيَ مَعْرُوفٌ':Subject, #2: 2	وَهِيَ مَعْرِفَةُ
u'وَهِيَ مَعْرُوفٌ':Subject, #17: 17	وَهِيَ مَعْرُوفَةٌ
u'وَهِيَ مَعْرُوفٌ':Subject, #2: 2	وَهِيَ الْمَعْرُوفَةُ
u'وَهِيَ مُعْسِرٌ':Subject, #5: 5	وَهِيَ مَعْرُوفَةُ
u'وَهِيَ مَعْصِيَةٌ':Subject, #9: 9	وَهِيَ مُعْسِرَةٌ
u'وَهِيَ مُعْضِلٌ':Subject, #6: 6	وَهِيَ مَعْصِيَةٌ
u'وَهِيَ مُعْضِلَةٌ':Subject, #3: 3	وَهِيَ مُعْضِلَةٌ
u'وَهِيَ مَعْطُوف':Subject, #3: 3	وَهِيَ مُعْضِلَةٌ
u'وَهِيَ مُعْظَمٌ':Subject, #1: 1	وَهِيَ مَعْطُوفٌ
u'وَهِيَ مُعَقَّبٌ':Subject, #2: 2	وَهِيَ مُعْظَمُ
u'وَهِيَ مَعْقُودٌ':Subject, #1: 1	وَهِيَ مُعَقَّبَةٌ
u'وَهِيَ مَعْقُودٌ':Subject, #1: 1	وَهِيَ الْمَعْقُودَةُ
u'وَهِيَ مَعْقُولٌ':Subject, #4: 4	وَهِيَ الْمَعْقُودُ
u'وَهِيَ مَعْقُولٌ':Subject, #1: 1	وَهِيَ الْمَعْقُولَةُ
u'وَهِيَ مَعْلُولٌ':Subject, #1: 1	وَهِيَ مَعْقُولَةٌ
u'وَهِيَ مَعْلُومٌ':Subject, #1: 1	وَهِيَ مَعْلُولَةٌ
u'وَهِيَ مَعْلُومٌ':Subject, #1: 1	وَهِيَ مَعْلُومَاتُ
u'وَهِيَ مَعْلُومٌ':Subject, #2: 2	وَهِيَ مَعْلُومٌ
u'وَهِيَ مُعَوَّلٌ':Subject, #6: 6	وَهِيَ مَعْلُومَةٌ
u'وَهِيَ مَعِيبٌ':Subject, #1: 1	وَهِيَ الْمُعَوَّلُ
u'وَهِيَ مَعِيبٌ':Subject, #1: 1	وَهِيَ الْمَعِيبَةُ
u'وَهِيَ مُعِينٌ':Subject, #1: 1	وَهِيَ مَعِيبَةٌ
u'وَهِيَ مُعَيَّنٌ':Subject, #1: 1	وَهِيَ مُعِينَةٌ
u'وَهِيَ مُغارَسَة':Subject, #4: 4	وَهِيَ مُعَيَّنَةٌ
u'وَهِيَ مَغَانِمُ':Subject, #2: 2	وَهِيَ الْمُغَارَسَةُ
u'وَهِيَ مُغْتَبِطٌ':Subject, #1: 1	وَهِيَ مَغَانِمُ
u'وَهِيَ مَغْرِبٌ':Subject, #1: 1	وَهِيَ مُغْتَبِطَةٌ
u'وَهِيَ مِغْرَفَةٌ':Subject, #6: 6	وَهِيَ الْمَغْرِبُ
u'وَهِيَ مَغْصُوب':Subject, #1: 1	وَهِيَ الْمِغْرَفَةُ
u'وَهِيَ مُغَلَّب':Subject, #1: 1	وَهِيَ مَغْصُوبَةٌ
u'وَهِيَ مُغْلَقٌ':Subject, #1: 1	وَهِيَ الْمُغَلَّبَةُ
u'وَهِيَ مَغْلُوقٌ':Subject, #1: 1	وَهِيَ مُغْلَقَةٌ
u'وَهِيَ مُغَنِّي':Subject, #1: 1	وَهِيَ مَغْلُوقَةٌ
u'وَهِيَ مُفَارَقَةٌ':Subject, #1: 1	وَهِيَ الْمُغَنِّيَةُ
u'وَهِيَ مُفَاوَضَةٌ':Subject, #1: 1	وَهِيَ مُفَارَقَةُ
u'وَهِيَ مُفْتَقِرٌ':Subject, #2: 2	وَهِيَ مُفَاوَضَةٌ
u'وَهِيَ مُفَرَّع':Subject, #1: 1	وَهِيَ الْمُفْتَقِرَةُ
u'وَهِيَ مُفْرَغٌ':Subject, #1: 1	وَهِيَ مُفَرَّعَةٌ
u'وَهِيَ مَفْرُوضٌ':Subject, #1: 1	وَهِيَ مُفْرَغَةٌ
u'وَهِيَ مُفْسِدٌ':Subject, #1: 1	وَهِيَ مَفْرُوضَةٌ
u'وَهِيَ مَفْسَدَةٌ':Subject, #2: 2	وَهِيَ مُفْسِدَةٌ
u'وَهِيَ مُفَسَّرٌ':Subject, #1: 1	وَهِيَ مَفْسَدَةٌ
u'وَهِيَ مُفَسِّرٌ':Subject, #1: 1	وَهِيَ الْمُفَسَّرَةُ
u'وَهِيَ مُفْضِي':Subject, #1: 1	وَهِيَ مُفَسِّرَةٌ
u'وَهِيَ مُفْطِر':Subject, #2: 2	وَهِيَ مُفْضِيَةٌ
u'وَهِيَ مَفْعُولٌ':Subject, #1: 1	وَهِيَ مُفْطِرَةٌ
u'وَهِيَ مَفْقُودٌ':Subject, #1: 1	وَهِيَ مَفْعُولٌ
u'وَهِيَ مُفْلِسٌ':Subject, #6: 6	وَهِيَ مَفْقُودَةٌ
u'وَهِيَ مَفْهُومٌ':Subject, #2: 2	وَهِيَ مُفْلِسَةٌ
u'وَهِيَ مُفَوَّضٌ':Subject, #2: 2	وَهِيَ مَفْهُومَةٌ
u'وَهِيَ مُفِيدٌ':Subject, #1: 1	وَهِيَ مُفَوَّضَةٌ
u'وَهِيَ مُفِيدٌ':Subject, #1: 1	وَهِيَ الْمُفِيدَةُ
u'وَهِيَ مُقَابَلٌ':Subject, #1: 1	وَهِيَ مُفِيدَةٌ
u'وَهِيَ مُقَابَلٌ':Subject, #1: 1	وَهِيَ الْمُقَابَلَةُ
u'وَهِيَ مُقَابَلَةٌ':Subject, #2: 2	وَهِيَ مُقَابَلَةٌ
u'وَهِيَ مُقَابَلَةٌ':Subject, #1: 1	وَهِيَ الْمُقَابَلَةُ
u'وَهِيَ مُقَارِبٌ':Subject, #2: 2	وَهِيَ مُقَابَلَةٌ
u'وَهِيَ مُقَارِنٌ':Subject, #1: 1	وَهِيَ الْمُقَارِبَةُ
u'وَهِيَ مَقَاصِدُ':Subject, #1: 1	وَهِيَ الْمُقَارِنَةُ
u'وَهِيَ مُقْبِلٌ':Subject, #1: 1	وَهِيَ الْمَقَاصِدُ
u'وَهِيَ مَقْبُوضٌ':Subject, #1: 1	وَهِيَ مُقْبِلَةٌ
u'وَهِيَ مَقْبُولٌ':Subject, #3: 3	وَهِيَ مَقْبُوضَةٌ
u'وَهِيَ مِقْدَارٌ':Subject, #4: 4	وَهِيَ مَقْبُولَةٌ
u'وَهِيَ مُقَدَّرٌ':Subject, #3: 3	وَهِيَ مِقْدَارُ
u'وَهِيَ مُقَدَّمٌ':Subject, #2: 2	وَهِيَ مُقَدَّرَةٌ
u'وَهِيَ مُقَدَّمٌ':Subject, #1: 1	وَهِيَ الْمُقَدَّمُ
u'وَهِيَ مُقَدِّمٌ':Subject, #1: 1	وَهِيَ الْمُقَدَّمَةُ
u'وَهِيَ مُقَدَّمٌ':Subject, #1: 1	وَهِيَ الْمُقَدِّمَةُ
u'وَهِيَ مُقَدَّمٌ':Subject, #1: 1	وَهِيَ مُقَدَّمُ
u'وَهِيَ مُقَدَّمٌ':Subject, #1: 1	وَهِيَ مُقَدَّمُهُ
u'وَهِيَ مُقَدِّمَةٌ':Subject, #5: 5	وَهِيَ مُقَدَّمَةٌ
u'وَهِيَ مُقِرّ':Subject, #1: 1	وَهِيَ الْمُقَدِّمَةُ
u'وَهِيَ مُقَرَّرٌ':Subject, #2: 2	وَهِيَ مُقِرَّةٌ
u'وَهِيَ مَقْرُونٌ':Subject, #1: 1	وَهِيَ مُقَرَّرَةٌ
u'وَهِيَ مَقْسُومٌ':Subject, #1: 1	وَهِيَ مَقْرُونَةٌ
u'وَهِيَ مُقَصِّرٌ':Subject, #1: 1	وَهِيَ مَقْسُومَةٌ
u'وَهِيَ مَقْصُودٌ':Subject, #1: 1	وَهِيَ الْمُقَصِّرَةُ
u'وَهِيَ مَقْصُودٌ':Subject, #1: 1	وَهِيَ مَقْصُودُ
u'وَهِيَ مَقْصُودٌ':Subject, #1: 1	وَهِيَ مَقْصُودَةٌ
u'وَهِيَ مَقْصُودٌ':Subject, #2: 2	وَهِيَ الْمَقْصُودُ
u'وَهِيَ مَقْصُورٌ':Subject, #3: 3	وَهِيَ الْمَقْصُودَةُ
u'وَهِيَ مَقْصُورَةٌ':Subject, #1: 1	وَهِيَ مَقْصُورَةٌ
u'وَهِيَ مَقْطُوعٌ':Subject, #1: 1	وَهِيَ مَقْصُورَةٌ
u'وَهِيَ مَقْطُوعٌ':Subject, #1: 1	وَهِيَ مَقْطُوعٌ
u'وَهِيَ مَقْطُوعٌ':Subject, #1: 1	وَهِيَ مَقْطُوعَةٌ
u'وَهِيَ مَقْطُوعٌ':Subject, #1: 1	وَهِيَ مَقْطُوعَةُ
u'وَهِيَ مَقْطُوعَةٌ':Subject, #2: 2	وَهِيَ الْمَقْطُوعَةُ
u'وَهِيَ مَقْطُوعَةٌ':Subject, #1: 1	وَهِيَ مَقْطُوعَةٌ
u'وَهِيَ مَقْطُوعَةٌ':Subject, #1: 1	وَهِيَ مَقْطُوعَةُ
u'وَهِيَ مُقْفَلٌ':Subject, #2: 2	وَهِيَ الْمَقْطُوعَةُ
u'وَهِيَ مَقْلُوبٌ':Subject, #1: 1	وَهِيَ مُقْفَلَةٌ
u'وَهِيَ مَقُولٌ':Subject, #2: 2	وَهِيَ مَقْلُوبَةٌ
u'وَهِيَ مُقَيَّدٌ':Subject, #1: 1	وَهِيَ الْمَقُولَةُ
u'وَهِيَ مُقَيَّدٌ':Subject, #2: 2	وَهِيَ الْمُقَيَّدَةُ
u'وَهِيَ مُقِيمٌ':Subject, #8: 8	وَهِيَ مُقَيَّدَةٌ
u'وَهِيَ مُكَاتَبَةٌ':Subject, #2: 2	وَهِيَ مُقِيمَةٌ
u'وَهِيَ مُكَاتَبَةٌ':Subject, #15: 15	وَهِيَ مُكَاتَبَةٌ
u'وَهِيَ مَكَانٌ':Subject, #1: 1	وَهِيَ مُكَاتَبَتُهُ
u'وَهِيَ مَكَانٌ':Subject, #1: 1	وَهِيَ مَكَانٌ
u'وَهِيَ مَكْتُوبٌ':Subject, #1: 1	وَهِيَ مَكَانُ
u'وَهِيَ مُكَرَّرٌ':Subject, #1: 1	وَهِيَ الْمَكْتُوبَةُ
u'وَهِيَ مُكْرَهٌ':Subject, #1: 1	وَهِيَ مُكَرَّرَةٌ
u'وَهِيَ مَكْرُوهٌ':Subject, #12: 12	وَهِيَ مُكْرَهَةٌ
u'وَهِيَ مَكْرُوهَةٌ':Subject, #9: 9	وَهِيَ مَكْرُوهَةٌ
u'وَهِيَ مَكْشُوفٌ':Subject, #9: 9	وَهِيَ مَكْرُوهَةٌ
u'وَهِيَ مُكَلَّفٌ':Subject, #2: 2	وَهِيَ مَكْشُوفَةُ
u'وَهِيَ مَكِّيّ':Subject, #2: 2	وَهِيَ مُكَلَّفَةٌ
u'وَهِيَ مِكْيَالٌ':Subject, #1: 1	وَهِيَ مَكّيّةٌ
u'وَهِيَ مِلْءٌ':Subject, #1: 1	وَهِيَ مِكْيَالٌ
u'وَهِيَ مُلاَقَاةٌ':Subject, #2: 2	وَهِيَ مِلْءُ
u'وَهِيَ مِلَّةٌ':Subject, #1: 1	وَهِيَ الْمُلَاقَاةُ
u'وَهِيَ مُلْتَبِسٌ':Subject, #1: 1	وَهِيَ مِلَّةُ
u'وَهِيَ مُلْغاة':Subject, #1: 1	وَهِيَ مُلْتَبِسَةٌ
u'وَهِيَ مُلَقَّب':Subject, #1: 1	وَهِيَ مُلْغَاةٌ
u'وَهِيَ مُلَقَّب':Subject, #1: 1	وَهِيَ الْمُلَقَّبَةُ
u'وَهِيَ مِلْكٌ':Subject, #1: 1	وَهِيَ مُلَقَّبَةٌ
u'وَهِيَ مِلْكٌ':Subject, #1: 1	وَهِيَ الْمِلْكُ
u'وَهِيَ مِلْكٌ':Subject, #20: 20	وَهِيَ مِلْكُهُ
u'وَهِيَ مِلْكٌ':Subject, #6: 6	وَهِيَ مِلْكٌ
u'وَهِيَ مُمَاثَلَةٌ':Subject, #8: 8	وَهِيَ مِلْكُ
u'وَهِيَ مُمْتَنِعٌ':Subject, #2: 2	وَهِيَ الْمُمَاثَلَةُ
u'وَهِيَ مُمْكِنٌ':Subject, #1: 1	وَهِيَ مُمْتَنِعَةٌ
u'وَهِيَ مَمْلُوكٌ':Predicate, #2: 2	وَهِيَ مُمْكِنَةٌ
u'وَهَى مَمْلُوكٌ':Predicate, #1: 1	وَهِيَ مَمْلُوكَةً
u'وَهِيَ مَمْلُوكٌ':Subject, #1: 1	وَهِيَ مَمْلُوكَةً
u'وَهِيَ مَمْلُوكٌ':Subject, #10: 10	وَهِيَ مَمْلُوكَةٌ
u'وَهِيَ مَمْلُوكٌ':Subject, #1: 1	وَهِيَ مَمْلُوكَتُهُ
u'وَهِيَ مَمْلُوكٌ':Subject, #2: 2	وَهِيَ الْمَمْلُوكَةُ
u'وَهِيَ مَمْنُوعٌ':Subject, #2: 2	وَهِيَ مَمْلُوكَةُ
u'وَهِيَ مُمَيِّزٌ':Subject, #11: 11	وَهِيَ مَمْنُوعَةٌ
u'وَهِيَ مُنَاخٌ':Subject, #2: 2	وَهِيَ مُمَيِّزَةٌ
u'وَهِيَ مُنَازَعٌ':Subject, #1: 1	وَهِيَ مُنَاخُ
u'وَهِيَ مُنَازَعٌ':Subject, #1: 1	وَهِيَ الْمُنَازَعَةُ
u'وَهِيَ مُنَازَعَةٌ':Subject, #3: 3	وَهِيَ مُنَازَعَةٌ
u'وَهِيَ مُنَازَعَةٌ':Subject, #1: 1	وَهِيَ الْمُنَازَعَةُ
u'وَهِيَ مَنَازِلُ':Subject, #3: 3	وَهِيَ مُنَازَعَةٌ
u'وَهِيَ مُنَاسِبٌ':Subject, #5: 5	وَهِيَ مَنَازِلُ
u'وَهِيَ مَنَاطٌ':Subject, #1: 1	وَهِيَ مُنَاسِبَةٌ
u'وَهِيَ مُنَاظِرٌ':Subject, #1: 1	وَهِيَ الْمَنَاطُ
u'وَهِيَ مَنَافِعُ':Subject, #1: 1	وَهِيَ مُنَاظِرَةٌ
u'وَهِيَ مَنَافِعُ':Subject, #2: 2	وَهِيَ مَنَافِعُ
u'وَهِيَ مُنَافِي':Subject, #3: 3	وَهِيَ الْمَنَافِعُ
u'وَهِيَ مُنَاقَشَةٌ':Subject, #2: 2	وَهِيَ مُنَافِيَةٌ
u'وَهِيَ مُنَاقَضَةٌ':Subject, #1: 1	وَهِيَ مُنَاقَشَةٌ
u'وَهِيَ مَنَاهِلُ':Subject, #1: 1	وَهِيَ مُنَاقَضَةٌ
u'وَهِيَ مُناوَلَة':Subject, #1: 1	وَهِيَ مَنَاهِلُ
u'وَهِيَ مِنْبَر':Subject, #1: 1	وَهِيَ الْمُنَاوَلَةُ
u'وَهِيَ مُنْتَفِعٌ':Subject, #3: 3	وَهِيَ الْمِنْبَرِيَّةُ
u'وَهِيَ مُنْتَقِي':Subject, #1: 1	وَهِيَ الْمُنْتَفِعَةُ
u'وَهِيَ مُنْحَصِرٌ':Subject, #1: 1	وَهِيَ مُنْتَقِيَةٌ
u'وَهِيَ مُنْدَفِع':Subject, #2: 2	وَهِيَ مُنْحَصِرَةٌ
u'وَهِيَ مُنْدَفِع':Subject, #1: 1	وَهِيَ الْمُنْدَفِعَةُ
u'وَهِيَ مَنْدُوبٌ':Subject, #1: 1	وَهِيَ مُنْدَفِعَةٌ
u'وَهِيَ مَنْزِلٌ':Subject, #3: 3	وَهِيَ مَنْدُوبَةٌ
u'وَهِيَ مَنْزِلٌ':Subject, #1: 1	وَهِيَ الْمَنْزِلُ
u'وَهِيَ مَنْزِلَةٌ':Subject, #1: 1	وَهِيَ مَنْزِلُ
u'وَهِيَ مَنْسُوبٌ':Subject, #1: 1	وَهِيَ مَنْزِلَةُ
u'وَهِيَ مَنْسُوبٌ':Subject, #1: 1	وَهِيَ الْمَنْسُوبَةُ
u'وَهِيَ مَنْسُوخٌ':Subject, #1: 1	وَهِيَ مَنْسُوبَةٌ
u'وَهِيَ مَنْصُوبٌ':Subject, #2: 2	وَهِيَ مَنْسُوخَةٌ
u'وَهِيَ مَنْصُورٌ':Subject, #1: 1	وَهِيَ مَنْصُوبَةٌ
u'وَهِيَ مَنْصُوصٌ':Subject, #1: 1	وَهِيَ الْمَنْصُورَةُ
u'وَهِيَ مَنْصُوصٌ':Subject, #1: 1	وَهِيَ الْمَنْصُوصَةُ
u'وَهِيَ مَنْصُوصٌ':Subject, #2: 2	وَهِيَ مَنْصُوصَةٌ
u'وَهِيَ مَنْطِقِيٌّ':Subject, #3: 3	وَهِيَ مَنْصُوصٌ
u'وَهِيَ مَنْعٌ':Subject, #1: 1	وَهِيَ الْمَنْطِقِيُّ
u'وَهِيَ مَنْعٌ':Subject, #2: 2	وَهِيَ الْمَنْعُ
u'وَهِيَ مُنْعَدِمٌ':Subject, #3: 3	وَهِيَ مَنْعُ
u'وَهِيَ مُنْفَرِدٌ':Subject, #3: 3	وَهِيَ مُنْعَدِمَةٌ
u'وَهِيَ مُنْفَصِلٌ':Subject, #1: 1	وَهِيَ مُنْفَرِدَةٌ
u'وَهِيَ مَنْفَعَةٌ':Subject, #2: 2	وَهِيَ مُنْفَصِلَةٌ
u'وَهِيَ مَنْفَعَةٌ':Subject, #2: 2	وَهِيَ الْمَنْفَعَةُ
u'وَهِيَ مَنْفِيٌّ':Subject, #4: 4	وَهِيَ مَنْفَعَةُ
u'وَهِيَ مُنْقَسِم':Subject, #1: 1	وَهِيَ مَنْفِيَّةٌ
u'وَهِيَ مُنْقَضِي':Subject, #2: 2	وَهِيَ مُنْقَسِمَةٌ
u'وَهِيَ مُنْقَطِعٌ':Subject, #1: 1	وَهِيَ مُنْقَضِيَةٌ
u'وَهِيَ مُنْقَطِعٌ':Subject, #1: 1	وَهِيَ مُنْقَطِعَةُ
u'وَهِيَ مَنْقُولٌ':Subject, #4: 4	وَهِيَ مُنْقَطِعَةٌ
u'وَهِيَ مُنْكَبٌّ':Subject, #2: 2	وَهِيَ مَنْقُولَةٌ
u'وَهِيَ مُنْكِرٌ':Subject, #1: 1	وَهِيَ مُنْكَبَّةٌ
u'وَهِيَ مُنْكَسِر':Subject, #6: 6	وَهِيَ مُنْكِرَةٌ
u'وَهِيَ مَنْكُوح':Subject, #1: 1	وَهِيَ مُنْكَسِرَةٌ
u'وَهِيَ مَنْكُوح':Subject, #3: 3	وَهِيَ الْمَنْكُوحَةُ
u'وَهِيَ مَنْكُوح':Subject, #4: 4	وَهِيَ مَنْكُوحَةٌ
u'وَهِيَ مَنْكُوح':Subject, #4: 4	وَهِيَ مَنْكُوحَةُ
u'وَهِيَ مَنْهِيٌّ':Subject, #7: 7	وَهِيَ مَنْكُوحَتُهُ
u'وَهِيَ مَنْهِيٌّ':Subject, #2: 2	وَهِيَ مَنْهِيَّةٌ
u'وَهِيَ مَهَالِكُ':Subject, #3: 3	وَهِيَ مَنْهِيٌّ
u'وَهِيَ مُهْدَر':Subject, #1: 1	وَهِيَ الْمَهَالِكُ
u'وَهِيَ مَهْرٌ':Subject, #1: 1	وَهِيَ مُهْدَرَةٌ
u'وَهِيَ مُهِمٌّ':Subject, #1: 1	وَهِيَ مَهْرُ
u'وَهِيَ مُهِمَّةٌ':Subject, #2: 2	وَهِيَ مُهِمَّةٌ
u'وَهِيَ مَوَاتٌ':Subject, #2: 2	وَهِيَ مُهِمَّةٌ
u'وَهِيَ مُؤَاخَاةٌ':Subject, #1: 1	وَهِيَ الْمَوَاتُ
u'وَهِيَ مَوَاضِعُ':Subject, #1: 1	وَهِيَ الْمُؤَاخَاةُ
u'وَهِيَ مَوَاعِظُ':Subject, #1: 1	وَهِيَ مَوَاضِعُ
u'وَهِيَ مُوَافِقٌ':Subject, #1: 1	وَهِيَ مَوَاعِظُ
u'وَهِيَ مُوَافِقٌ':Subject, #4: 4	وَهِيَ مُوَافِقَةٌ
u'وَهِيَ مُوَافَقَةٌ':Subject, #8: 8	وَهِيَ الْمُوَافِقَةُ
u'وَهِيَ مُوَافَقَةٌ':Subject, #1: 1	وَهِيَ مُوَافَقَةٌ
u'وَهِيَ مُؤَبَّدٌ':Subject, #9: 9	وَهِيَ الْمُوَافَقَةُ
u'وَهِيَ مُوبِقَةٌ':Subject, #1: 1	وَهِيَ مُؤَبَّدَةٌ
u'وَهِيَ مَوْتٌ':Subject, #1: 1	وَهِيَ الْمُوبِقَاتُ
u'وَهِيَ مُؤْتَمَنٌ':Subject, #2: 2	وَهِيَ الْمَوْتُ
u'وَهِيَ مُؤَثِّرٌ':Subject, #1: 1	وَهِيَ مُؤْتَمَنَةٌ
u'وَهِيَ مُوجِبٌ':Subject, #2: 2	وَهِيَ مُؤَثِّرَةٌ
u'وَهِيَ مُوجِبٌ':Subject, #1: 1	وَهِيَ الْمُوجِبُ
u'وَهِيَ مُؤَجَّلٌ':Subject, #2: 2	وَهِيَ مُوجِبَةٌ
u'وَهِيَ مَوْجُودٌ':Subject, #1: 1	وَهِيَ مُؤَجَّلَةٌ
u'وَهِيَ مَوْجُودٌ':Subject, #1: 1	وَهِيَ الْمَوْجُودَةُ
u'وَهِيَ مَوَدَّةٌ':Subject, #40: 40	وَهِيَ مَوْجُودَةٌ
u'وَهِيَ مُوسِرٌ':Subject, #1: 1	وَهِيَ الْمَوَدَّةُ
u'وَهِيَ مَوْصُوفٌ':Subject, #5: 5	وَهِيَ مُوسِرَةٌ
u'وَهِيَ مَوْصُولٌ':Subject, #1: 1	وَهِيَ مَوْصُوفَةٌ
u'وَهِيَ مَوْضِعٌ':Subject, #1: 1	وَهِيَ مَوْصُولَةٌ
u'وَهِيَ مَوْضِعٌ':Subject, #1: 1	وَهِيَ مَوْضِعٌ
u'وَهِيَ مَوْضُوعٌ':Subject, #4: 4	وَهِيَ مَوْضِعُ
u'وَهِيَ مَوْضُوعٌ':Subject, #1: 1	وَهِيَ الْمَوْضُوعَةُ
u'وَهِيَ مَوْضُوعَةٌ':Subject, #1: 1	وَهِيَ مَوْضُوعَةٌ
u'وَهِيَ مَوْضُوعَةٌ':Subject, #1: 1	وَهِيَ الْمَوْضُوعَةُ
u'وَهِيَ مُوقِدٌ':Subject, #1: 1	وَهِيَ مَوْضُوعَةٌ
u'وَهِيَ مَوْقِفٌ':Subject, #1: 1	وَهِيَ مُوقِدَةٌ
u'وَهِيَ مَوْقُوفٌ':Subject, #2: 2	وَهِيَ مَوْقِفٌ
u'وَهِيَ مُؤَكَّدٌ':Subject, #1: 1	وَهِيَ مَوْقُوفَةٌ
u'وَهِيَ مُوَكِّلٌ':Subject, #1: 1	وَهِيَ مُؤَكَّدَةٌ
u'وَهِيَ مَوْلَاةٌ':Subject, #1: 1	وَهِيَ مُوَكِّلَةُ
u'وَهِيَ مُوَلَّدٌ':Subject, #1: 1	وَهِيَ مَوْلَاةُ
u'وَهِيَ مُؤَنَّثٌ':Subject, #1: 1	وَهِيَ مُوَلَّدَةٌ
u'وَهِيَ مُؤَنَّثٌ':Subject, #1: 1	وَهِيَ مُؤَنَّثٌ
u'وَهِيَ مُؤَنَّثٌ':Subject, #1: 1	وَهِيَ مُؤَنّثَةٌ
u'وَهِيَ مُؤَيِّدٌ':Subject, #6: 6	وَهِيَ مُؤَنَّثَةٌ
u'وَهِيَ مِيَاهٌ':Subject, #2: 2	وَهِيَ مُؤَيِّدَةٌ
u'وَهِيَ مَيْتَةٌ':Subject, #1: 1	وَهِيَ مِيَاهُ
u'وَهِيَ مِيرَاثٌ':Subject, #2: 2	وَهِيَ مَيْتَةٌ
u'وَهِيَ مِيزَانٌ':Subject, #1: 1	وَهِيَ مِيرَاثٌ
u'وَهِيَ مِيقَاتٌ':Subject, #1: 1	وَهِيَ الْمِيزَانُ
u'وَهِيَ ميل':Subject, #1: 1	وَهِيَ مِيقَاتُ
u'وَهِيَ مَيْلٌ':Subject, #1: 1	وَهِيَ الْمَيْلُ
u'وَهِيَ مِيمٌ':Subject, #1: 1	وَهِيَ الْمَيْلُ
u'وَهِيَ نَاجِي':Subject, #2: 2	وَهِيَ الْمِيمُ
u'وَهِيَ نَاحِي':Subject, #1: 1	وَهِيَ النَّاجِيَةُ
u'وَهِيَ نَاحِي':Subject, #1: 1	وَهِيَ نَاحِيَةٌ
u'وَهِيَ نَاحِيَةٌ':Subject, #2: 2	وَهِيَ النّاحِيَةُ
u'وَهِيَ نَاحِيَةٌ':Subject, #1: 1	وَهِيَ نَاحِيَةٌ
u'وَهِيَ نَازِحٌ':Subject, #2: 2	وَهِيَ النّاحِيَةُ
u'وَهِيَ نَازِلٌ':Subject, #1: 1	وَهِيَ نَازِحَةٌ
u'وَهِيَ نَازِلٌ':Subject, #1: 1	وَهِيَ النَّازِلَةُ
u'وَهِيَ نَازِلَةٌ':Subject, #1: 1	وَهِيَ نَازِلَةٌ
u'وَهِيَ نَازِلَةٌ':Subject, #1: 1	وَهِيَ النَّازِلَةُ
u'وَهِيَ نَاشِزٌ':Subject, #1: 1	وَهِيَ نَازِلَةٌ
u'وَهِيَ نَافِذٌ':Subject, #6: 6	وَهِيَ نَاشِزَةٌ
u'وَهِيَ نَافِذَةٌ':Subject, #3: 3	وَهِيَ نَافِذَةٌ
u'وَهِيَ نَافِقٌ':Subject, #3: 3	وَهِيَ نَافِذَةٌ
u'وَهِيَ نَافِلَةٌ':Subject, #2: 2	وَهِيَ نَافِقَةٌ
u'وَهِيَ نَاقَةٌ':Subject, #1: 1	وَهِيَ نَافِلَةٌ
u'وَهِيَ نَاقَة':Subject, #2: 2	وَهِيَ النَّاقَةُ
u'وَهِيَ نَاقَةٌ':Subject, #2: 2	وَهِيَ النَّاقَةُ
u'وَهِيَ نَاقَة':Subject, #3: 3	وَهِيَ النّاقَةُ
u'وَهِيَ نَاقِصٌ':Subject, #3: 3	وَهِيَ النّاقَةُ
u'وَهِيَ نَاكِحٌ':Subject, #1: 1	وَهِيَ نَاقِصَةٌ
u'وَهِيَ نَائِبٌ':Subject, #1: 1	وَهِيَ نَاكِحٌ
u'وَهِيَ نَائِبَةٌ':Subject, #1: 1	وَهِيَ نَائِبَةٌ
u'وَهِيَ نَائِمٌ':Subject, #1: 1	وَهِيَ نَائِبَةٌ
u'وَهِيَ نُبُوَّةٌ':Subject, #16: 16	وَهِيَ نَائِمَةٌ
u'وَهِيَ نَجَاسَةٌ':Subject, #4: 4	وَهِيَ النُّبُوَّةُ
u'وَهِيَ نَجِسٌ':Subject, #3: 3	وَهِيَ النَّجَاسَةُ
u'وَهِيَ نُجُومٌ':Subject, #1: 1	وَهِيَ النَّجِسَةُ
u'وَهِيَ نَحْوٌ':Subject, #1: 1	وَهِيَ النُّجُومُ
u'وَهِيَ نَحْوٌ':Subject, #3: 3	وَهِيَ نَحْوٌ
u'وَهِيَ نُخَاعَةٌ':Subject, #3: 3	وَهِيَ نَحْوُ
u'وَهِيَ نُخَالَةٌ':Subject, #1: 1	وَهِيَ النُّخَاعَةُ
u'وَهِيَ نخلة':Subject, #2: 2	وَهِيَ نُخَالَةٌ
u'وَهِيَ نَخْلَةٌ':Subject, #1: 1	وَهِيَ نَخْلَةٌ
u'وَهِيَ نخلة':Subject, #1: 1	وَهِيَ نَخْلَةٌ
u'وَهِيَ نَخْلَةٌ':Subject, #2: 2	وَهِيَ النّخْلَةُ
u'وَهِيَ نَدَمٌ':Subject, #2: 2	وَهِيَ النّخْلَةُ
u'وَهِيَ نَزَاهَةٌ':Subject, #1: 1	وَهِيَ النَّدَمُ
u'وَهِيَ نُزُولٌ':Subject, #1: 1	وَهِيَ النَّزَاهَةُ
u'وَهِيَ نَسَبٌ':Subject, #1: 1	وَهِيَ نُزُولُ
u'وَهِيَ نِسَبٌ':Subject, #1: 1	وَهِيَ النَّسَبُ
u'وَهِيَ نِسْبَةٌ':Subject, #1: 1	وَهِيَ النِّسَبُ
u'وَهِيَ نِسْبَةٌ':Subject, #1: 1	وَهِيَ النِّسْبَةُ
u'وَهِيَ نسج':Subject, #2: 2	وَهِيَ نِسْبَةٌ
u'وَهِيَ نَسْجٌ':Subject, #1: 1	وَهِيَ النَّسْجُ
u'وَهِيَ نُسَخٌ':Subject, #1: 1	وَهِيَ النَّسْجُ
u'وَهِيَ نسخة':Subject, #1: 1	وَهِيَ نُسَخٌ
u'وَهِيَ نُسْخَةٌ':Subject, #2: 2	وَهِيَ نُسْخَةٌ
u'وَهِيَ نُسُكٌ':Subject, #2: 2	وَهِيَ نُسْخَةٌ
u'وَهِيَ نسمة':Subject, #1: 1	وَهِيَ نُسُكٌ
u'وَهِيَ نَصٌّ':Subject, #1: 1	وَهِيَ نَسْمَةُ
u'وَهِيَ نَصٌّ':Subject, #1: 1	وَهِيَ نَصٌّ
u'وَهِيَ نصاب':Subject, #1: 1	وَهِيَ نَصُّهُ
u'وَهِيَ نصاب':Subject, #1: 1	وَهِيَ نِصَابٌ
u'وَهِيَ نِصَابٌ':Subject, #1: 1	وَهِيَ نِصَابُ
u'وَهِيَ نِصَابٌ':Subject, #1: 1	وَهِيَ نِصَابٌ
u'وَهِيَ نَصْرَانِيٌّ':Subject, #1: 1	وَهِيَ نِصَابُ
u'وَهِيَ نَصْرَانِيٌّ':Subject, #1: 1	وَهِيَ نَصْرَانِيٌّ
u'وَهِيَ نَصْرَانِيَّةٌ':Subject, #5: 5	وَهِيَ نَصْرَانِيَّةٌ
u'وَهِيَ نِصْفٌ':Subject, #5: 5	وَهِيَ نَصْرَانِيَّةٌ
u'وَهِيَ نِصْفٌ':Subject, #12: 12	وَهِيَ نِصْفُ
u'وَهِيَ نُصُوصِيّ':Subject, #8: 8	وَهِيَ النِّصْفُ
u'وَهِيَ نَصِيبٌ':Subject, #1: 1	وَهِيَ النُّصُوصِيَّةُ
u'وَهِيَ نَظَافَةٌ':Subject, #1: 1	وَهِيَ نَصِيبُ
u'وَهِيَ نَظَافَةٌ':Subject, #1: 1	وَهِيَ النّظَافَةُ
u'وَهِيَ نَظَرٌ':Subject, #4: 4	وَهِيَ النَّظَافَةُ
u'وَهِيَ نَظِيرٌ':Subject, #1: 1	وَهِيَ النَّظَرُ
u'وَهِيَ نَعْتٌ':Subject, #10: 10	وَهِيَ نَظِيرُ
u'وَهِيَ نَعَمٌ':Subject, #1: 1	وَهِيَ النَّعْتُ
u'وَهِيَ نِعَمٌ':Subject, #1: 1	وَهِيَ النَّعَمُ
u'وَهِيَ نعمة':Subject, #1: 1	وَهِيَ النِّعَمُ
u'وَهِيَ نِعْمَةٌ':Subject, #1: 1	وَهِيَ النِّعْمَةُ
u'وَهِيَ نعمة':Subject, #1: 1	وَهِيَ النِّعْمَةُ
u'وَهِيَ نِعْمَةٌ':Subject, #1: 1	وَهِيَ نِعْمَةٌ
u'وَهِيَ نُفَّاخَةٌ':Subject, #1: 1	وَهِيَ نِعْمَةٌ
u'وَهِيَ نَفْثٌ':Subject, #1: 1	وَهِيَ النّفّاخَاتُ
u'وَهِيَ نَفْخ':Subject, #1: 1	وَهِيَ النَّفْثُ
u'وَهِيَ نَفْسٌ':Subject, #1: 1	وَهِيَ نَفْخٌ
u'وَهِيَ نَفْسٌ':Subject, #2: 2	وَهِيَ نَفْسُهُ
u'وَهِيَ نُفَسَاءُ':Subject, #3: 3	وَهِيَ النَّفْسُ
u'وَهِيَ نَفْسِيٌّ':Subject, #4: 4	وَهِيَ نُفَسَاءُ
u'وَهِيَ نَفْعٌ':Subject, #1: 1	وَهِيَ نَفْسِيَّةٌ
u'وَهِيَ نَفَقَةٌ':Subject, #2: 2	وَهِيَ نَفْعٌ
u'وَهِيَ نَفَقَةٌ':Subject, #1: 1	وَهِيَ النَّفَقَةُ
u'وَهِيَ نَفْلٌ':Subject, #2: 2	وَهِيَ نَفَقَةُ
u'وَهِيَ نَفْيٌ':Subject, #1: 1	وَهِيَ نَفْلٌ
u'وَهِيَ نَفْيٌ':Subject, #2: 2	وَهِيَ نَفْيٌ
u'وَهِيَ نقرة':Subject, #2: 2	وَهِيَ نَفْيُ
u'وَهِيَ نُقْرَةٌ':Subject, #1: 1	وَهِيَ نُقْرَةُ
u'وَهِيَ نَقْصٌ':Subject, #1: 1	وَهِيَ نُقْرَةُ
u'وَهِيَ نَقْصٌ':Subject, #1: 1	وَهِيَ النَّقْصُ
u'وَهِيَ نُقْصَانٌ':Subject, #1: 1	وَهِيَ نَقْصٌ
u'وَهِيَ نُقَطٌ':Subject, #2: 2	وَهِيَ نُقْصَانُ
u'وَهِيَ نقل':Subject, #1: 1	وَهِيَ النّقَطُ
u'وَهِيَ نَقْلٌ':Subject, #1: 1	وَهِيَ النَّقْلُ
u'وَهِيَ نقل':Subject, #1: 1	وَهِيَ النَّقْلُ
u'وَهِيَ نَقْلٌ':Subject, #4: 4	وَهِيَ نَقْلُ
u'وَهِيَ نُقُودٌ':Subject, #4: 4	وَهِيَ نَقْلُ
u'وَهِيَ نكاح':Subject, #1: 1	وَهِيَ النُّقُودُ
u'وَهِيَ نكاح':Subject, #1: 1	وَهِيَ نِكَاحٌ
u'وَهِيَ نِكَاحٌ':Subject, #1: 1	وَهِيَ نِكَاحُ
u'وَهِيَ نِكَاحٌ':Subject, #1: 1	وَهِيَ نِكَاحٌ
u'وَهِيَ نكاح':Subject, #1: 1	وَهِيَ نِكَاحُ
u'وَهِيَ نِكَاحٌ':Subject, #2: 2	وَهِيَ النِّكَاحُ
u'وَهِيَ نُكْتَةٌ':Subject, #2: 2	وَهِيَ النِّكَاحُ
u'وَهِيَ نَكِرٌ':Subject, #1: 1	وَهِيَ نُكْتَةٌ
u'وَهِيَ نكرة':Subject, #1: 1	وَهِيَ النَّكِرَةُ
u'وَهِيَ نَكِرَةٌ':Subject, #1: 1	وَهِيَ النَّكِرَةُ
u'وَهِيَ نكرة':Subject, #1: 1	وَهِيَ النَّكِرَةُ
u'وَهِيَ نَكِرَةٌ':Subject, #2: 2	وَهِيَ نَكِرَةٌ
u'وَهِيَ نَهار':Subject, #2: 2	وَهِيَ نَكِرَةٌ
u'وَهِيَ نَهارِيّ':Subject, #1: 1	وَهِيَ نَهَارِيَّةٌ
u'وَهِيَ نِهَايَةٌ':Subject, #1: 1	وَهِيَ نَهَارِيَّةٌ
u'وَهِيَ نَوَاةٌ':Subject, #1: 1	وَهِيَ نِهَايَةُ
u'وَهِيَ نَوَافِلُ':Subject, #1: 1	وَهِيَ النّوَاةُ
u'وَهِيَ نَوْرٌ':Subject, #1: 1	وَهِيَ النَّوَافِلُ
u'وَهِيَ نَوْعٌ':Subject, #1: 1	وَهِيَ نَوْرُ
u'وَهِيَ نَوْعٌ':Subject, #1: 1	وَهِيَ نَوْعُ
u'وَهِيَ نَوْمٌ':Subject, #7: 7	وَهِيَ نَوْعٌ
u'وَهِيَ نِيْءٌ':Subject, #1: 1	وَهِيَ نَوْمُ
u'وَهِيَ نِيَابَةٌ':Subject, #3: 3	وَهِيَ النِّيءُ
u'وَهِيَ نِيَّاتٌ':Subject, #1: 1	وَهِيَ النِّيَابَةُ
u'وَهِيَ نِيَّةٌ':Subject, #1: 1	وَهِيَ النِّيَّاتُ
u'وَهِيَ نِيَّةٌ':Subject, #2: 2	وَهِيَ النِّيَّةُ
u'وَهِيَ نَيْلٌ':Subject, #2: 2	وَهِيَ نِيَّةُ
u'وَهِيَ هَاشِمٌ':Subject, #1: 1	وَهِيَ نَيْلُ
u'وَهِيَ هِبَةٌ':Subject, #3: 3	وَهِيَ الْهَاشِمَةُ
u'وَهِيَ هِبَةٌ':Subject, #1: 1	وَهِيَ هِبَةٌ
u'وَهِيَ هَتْكٌ':Subject, #1: 1	وَهِيَ هِبَةُ
u'وَهِيَ هجرة':Subject, #1: 1	وَهِيَ هَتْكُ
u'وَهِيَ هِجْرَةٌ':Subject, #1: 1	وَهِيَ الْهِجْرَةُ
u'وَهِيَ هَدَرٌ':Subject, #1: 1	وَهِيَ الْهِجْرَةُ
u'وَهِيَ هَدْيٌ':Subject, #1: 1	وَهِيَ هَدَرٌ
u'وَهِيَ هَدِيٌّ':Subject, #1: 1	وَهِيَ هَدْيٌ
u'وَهِيَ هَدِيَّةٌ':Subject, #2: 2	وَهِيَ الْهَدِيَّةُ
u'وَهِيَ هَزِيلٌ':Subject, #2: 2	وَهِيَ الْهَدِيَّةُ
u'وَهِيَ همزة':Subject, #1: 1	وَهِيَ الْهَزِيلَةُ
u'وَهِيَ هَمْزَةٌ':Subject, #1: 1	وَهِيَ هَمْزَةُ
u'وَهِيَ هَنَةٌ':Subject, #1: 1	وَهِيَ هَمْزَةُ
u'وَهِيَ هيفاء':Subject, #1: 1	وَهِيَ الْهَنَةُ
u'وَهِيَ هَيْفَاءُ':Subject, #1: 1	وَهِيَ هَيْفَاءُ
u'وَهِيَ هَيْئَةٌ':Subject, #1: 1	وَهِيَ هَيْفَاءُ
u'وَهِيَ هَيْئَةٌ':Subject, #1: 1	وَهِيَ هَيْئَةٌ
u'وَهِيَ هَيْئَةٌ':Subject, #1: 1	وَهِيَ هَيْئَةُ
u'وَهِيَ وَاجِبٌ':Subject, #2: 2	وَهِيَ الْهَيْئَةُ
u'وَهِيَ وَاجِبٌ':Subject, #1: 1	وَهِيَ الْوَاجِبَةُ
u'وَهِيَ واحد':Subject, #27: 27	وَهِيَ وَاجِبَةٌ
u'وَهِيَ وَاحِدٌ':Subject, #1: 1	وَهِيَ الْوَاحِدُ
u'وَهِيَ واحد':Subject, #1: 1	وَهِيَ الْوَاحِدُ
u'وَهِيَ وَاحِدٌ':Subject, #1: 1	وَهِيَ وَاحِدَةُ
u'وَهِيَ واحد':Subject, #1: 1	وَهِيَ وَاحِدَةُ
u'وَهِيَ وَاحِدٌ':Subject, #3: 3	وَهِيَ الْوَاحِدَةُ
u'وَهِيَ واحد':Subject, #3: 3	وَهِيَ الْوَاحِدَةُ
u'وَهِيَ وَاحِدٌ':Subject, #6: 6	وَهِيَ وَاحِدَةٌ
u'وَهِيَ وَارِثٌ':Subject, #6: 6	وَهِيَ وَاحِدَةٌ
u'وَهِيَ وَارِدٌ':Subject, #4: 4	وَهِيَ وَارِثَةٌ
u'وَهِيَ وَازِنٌ':Subject, #17: 17	وَهِيَ وَارِدَةٌ
u'وَهِيَ وَاسِعٌ':Subject, #1: 1	وَهِيَ الْوَازِنَةُ
u'وَهِيَ وَاصِلٌ':Subject, #1: 1	وَهِيَ وَاسِعَةٌ
u'وَهِيَ وَاضِحٌ':Subject, #1: 1	وَهِيَ الْوَاصِلَةُ
u'وَهِيَ وَاضِحٌ':Subject, #1: 1	وَهِيَ وَاضِحَةُ
u'وَهِيَ وَاضِعٌ':Subject, #4: 4	وَهِيَ وَاضِحَةٌ
u'وَهِيَ وَاقِعٌ':Subject, #1: 1	وَهِيَ وَاضِعَةٌ
u'وَهِيَ وَاقِعٌ':Subject, #1: 1	وَهِيَ الْوَاقِعَةُ
u'وَهِيَ وَاقِعٌ':Subject, #26: 26	وَهِيَ وَاقِعَةُ
u'وَهِيَ وَاقِعَةٌ':Subject, #4: 4	وَهِيَ وَاقِعَةٌ
u'وَهِيَ وَاقِعَةٌ':Subject, #1: 1	وَهِيَ الْوَاقِعَةُ
u'وَهِيَ وَاقِعَةٌ':Subject, #26: 26	وَهِيَ وَاقِعَةُ
u'وَهِيَ وَاقِفٌ':Subject, #4: 4	وَهِيَ وَاقِعَةٌ
u'وَهِيَ وَالِدٌ':Subject, #7: 7	وَهِيَ وَاقِفَةٌ
u'وَهِيَ وَاهِبٌ':Subject, #1: 1	وَهِيَ وَالِدَةُ
u'وَهِيَ وَثَنِيٌّ':Subject, #1: 1	وَهِيَ الْوَاهِبَةُ
u'وَهِيَ وَجَعٌ':Subject, #1: 1	وَهِيَ وَثَنِيَّةٌ
u'وَهِيَ وَجْهٌ':Subject, #1: 1	وَهِيَ وَجَعٌ
u'وَهِيَ وَجْهٌ':Subject, #1: 1	وَهِيَ الْوَجْهُ
u'وَهِيَ وُجُوبٌ':Subject, #4: 4	وَهِيَ وَجْهٌ
u'وَهِيَ وُجُودٌ':Subject, #4: 4	وَهِيَ وُجُوبُ
u'وَهِيَ وُجُوهٌ':Subject, #2: 2	وَهِيَ وُجُودُ
u'وَهِيَ وُجُوهٌ':Subject, #1: 1	وَهِيَ الْوُجُوهُ
u'وَهِيَ وَجِيبَةٌ':Subject, #1: 1	وَهِيَ وُجُوهٌ
u'وَهِيَ وَحْدَانِيٌّ':Subject, #1: 1	وَهِيَ الْوَجِيبَةُ
u'وَهِيَ وَحْدَانِيَّةٌ':Subject, #1: 1	وَهِيَ الْوَحْدَانِيَّةُ
u'وَهِيَ وَحْدَةٌ':Subject, #1: 1	وَهِيَ الْوَحْدَانِيَّةُ
u'وَهِيَ وَحْيٌ':Subject, #1: 1	وَهِيَ وَحْدَةُ
u'وَهِيَ وَدِيعٌ':Subject, #1: 1	وَهِيَ الْوَحْيُ
u'وَهِيَ وَدِيعَةٌ':Subject, #1: 1	وَهِيَ الْوَدِيعَةُ
u'وَهِيَ ورق':Subject, #1: 1	وَهِيَ الْوَدِيعَةُ
u'وَهِيَ وَرِقٌ':Subject, #1: 1	وَهِيَ الْوَرِقُ
u'وَهِيَ وَزْنٌ':Subject, #1: 1	وَهِيَ الْوَرِقُ
u'وَهِيَ وسط':Predicate, #1: 1	وَهِيَ وَزْنُ
u'وَهِيَ وَسَطٌ':Predicate, #1: 1	وَهِيَ وَسَطَ
u'وَهَى وسط':Predicate, #1: 1	وَهِيَ وَسَطَ
u'وَهَى وَسَطٌ':Predicate, #1: 1	وَهِيَ وَسَطَ
u'وَهِيَ وسط':Subject, #1: 1	وَهِيَ وَسَطَ
u'وَهِيَ وَسَطٌ':Subject, #1: 1	وَهِيَ الْوَسَطُ
u'وَهِيَ وَسْمٌ':Subject, #1: 1	وَهِيَ الْوَسَطُ
u'وَهِيَ وَصْفٌ':Subject, #1: 1	وَهِيَ الْوَسْمُ
u'وَهِيَ وصلة':Subject, #3: 3	وَهِيَ وَصْفٌ
u'وَهِيَ وَصِيٌّ':Subject, #1: 1	وَهِيَ الْوَصْلَةُ
u'وَهِيَ وَصِيٌّ':Subject, #2: 2	وَهِيَ وَصِيَّةُ
u'وَهِيَ وَصِيٌّ':Subject, #3: 3	وَهِيَ الْوَصِيَّةُ
u'وَهِيَ وَصِيَّةٌ':Subject, #8: 8	وَهِيَ وَصِيَّةٌ
u'وَهِيَ وَصِيَّةٌ':Subject, #2: 2	وَهِيَ وَصِيَّةُ
u'وَهِيَ وَصِيَّةٌ':Subject, #3: 3	وَهِيَ الْوَصِيَّةُ
u'وَهِيَ وَضْعٌ':Subject, #8: 8	وَهِيَ وَصِيَّةٌ
u'وَهِيَ وَطْءٌ':Subject, #3: 3	وَهِيَ وَضْعُ
u'وَهِيَ وِعَاءٌ':Subject, #1: 1	وَهِيَ وَطْءُ
u'وَهِيَ وِعَاءٌ':Subject, #1: 1	وَهِيَ الْوِعَاءُ
u'وَهِيَ وِعَاءٌ':Subject, #1: 1	وَهِيَ وِعَاءٌ
u'وَهِيَ وَفْقٌ':Predicate, #1: 1	وَهِيَ وِعَاءُ
u'وَهَى وَفْقٌ':Predicate, #1: 1	وَهِيَ وَفْقَ
u'وَهِيَ وَقْفٌ':Subject, #1: 1	وَهِيَ وَفْقَ
u'وَهِيَ وَقْفٌ':Subject, #1: 1	وَهِيَ الْوَقْفُ
u'وَهِيَ وُقُوعٌ':Subject, #3: 3	وَهِيَ وَقْفٌ
u'وَهِيَ وُقُوفٌ':Subject, #2: 2	وَهِيَ وُقُوعُ
u'وَهِيَ وَلاَءٌ':Subject, #1: 1	وَهِيَ الْوُقُوفُ
u'وَهِيَ وِلاَدَةٌ':Subject, #1: 1	وَهِيَ الْوَلَاءُ
u'وَهِيَ وِلاَيَةٌ':Subject, #1: 1	وَهِيَ وِلَادَةُ
u'وَهِيَ وِلاَيَةٌ':Subject, #1: 1	وَهِيَ وِلَايَةٌ
u'وَهِيَ وِلاَيَةٌ':Subject, #2: 2	وَهِيَ الْوِلَايَةُ
u'وَهِيَ وَهْمٌ':Subject, #4: 4	وَهِيَ وِلَايَةُ
u'وَهِيَ يَابِسٌ':Subject, #2: 2	وَهِيَ وَهْمٌ
u'وَهِيَ يَدٌ':Subject, #1: 1	وَهِيَ يَابِسَةٌ
u'وَهِيَ يَدٌ':Subject, #3: 3	وَهِيَ الْيَدُ
u'وَهِيَ يَدٌ':Subject, #3: 3	وَهِيَ يَدٌ
u'وَهِيَ يمن':Subject, #7: 7	وَهِيَ يَدُ
u'وَهِيَ يَمَنُ':Subject, #1: 1	وَهِيَ الْيَمَنُ
u'وَهِيَ يَمِينٌ':Subject, #1: 1	وَهِيَ الْيَمَنُ
u'وَهِيَ يَمِينٌ':Subject, #12: 12	وَهِيَ الْيَمِينُ
u'وَهِيَ يَمِينٌ':Subject, #3: 3	وَهِيَ يَمِينٌ
u'وَهِيَ يَوْمٌ':Predicate, #3: 3	وَهِيَ يَمِينُ
u'وَهَى يَوْمٌ':Predicate, #1: 1	وَهِيَ يَوْمَ
u'وَهِيَ يَوْمٌ':Predicate, #1: 1	وَهِيَ يَوْمَ
u'وَهَى يَوْمٌ':Predicate, #2: 2	وَهِيَ الْيَوْمَ
u'وَهِيَ يَوْمٌ':Subject, #2: 2	وَهِيَ الْيَوْمَ
u'يَبِسَ بَحْرٌ':Predicate, #2: 2	وَهِيَ يَوْمُ
u'يَبِسَ بَعْضٌ':Subject, #1: 1	أَيْبَسَ الْبَحْرَ
u'يُبْسٌ ثَمَرَةٌ':Added, #1: 1	يَبِسَ بَعْضُهُ
u'يُبْسٌ حَبٌّ':Added, #1: 1	يُبْسِ الثَّمَرَةِ
u'يُبْسٌ دِماغٌ':Added, #1: 1	يُبْسِ حَبِّ
u'يَبِسَ زَرْعٌ':Subject, #1: 1	يُبْسِ الدِّمَاغِ
u'يُبْسٌ زُهَّادٌ':Added, #1: 1	يَبِسَ الزَّرْعُ
u'يَبِسَ طهر':Predicate, #1: 1	يُبْسُ الزُّهَّادِ
u'يُبُوسَةٌ جلد':Added, #2: 2	يَبِسَ طَهُرَ
u'يُبُوسَةٌ جِلْدٌ':Added, #1: 1	يُبُوسَةُ الْجِلْدِ
u'يُبُوسَةٌ مُتَناهِي':Added, #1: 1	يُبُوسَةُ الْجِلْدِ
u'يُتْمٌ أَوْلاَدٌ':Added, #1: 1	يُبُوسَةٍ مُتَنَاهِيَةٍ
u'يُتْمٌ فُلاَنٌ':Added, #1: 1	يُتْمُ أَوْلَادِ
u'يُتْمٌ يَتِيمٌ':Added, #1: 1	يُتْمُ فُلَانٍ
u'يُتْمٌ يَتِيمٌ':Added, #1: 1	يُتْمَ الْيَتِيمِ
u'يُتْمٌ يَتِيمٌ':Added, #2: 2	يُتْمِ الْيَتِيمِ
u'يُسْرٌ أَبٌ':Added, #7: 7	يُتْمُ الْيَتِيمِ
u'يَسَّرَ إعْطَاءٌ':Predicate, #1: 1	يُسْرَ الْأَبِ
u'يَسِرَ أيَّامٌ':Predicate, #1: 1	يَسَّرَ الْإِعْطَاءَ
u'يَسِرَ أَيَّامٌ':Predicate, #2: 2	أَيْسَرَ أَيَّامَ
u'يَسِرَ حالَةٌ':Predicate, #2: 2	أَيْسَرَ أَيَّامَ
u'يُسْرٌ دِينٌ':Added, #1: 1	أَيْسَرَ حَالَةَ
u'يُسْرٌ عَامِلٌ':Added, #1: 1	يُسْرِ الدِّينِ
u'يَسِرَ قَالٌ':Predicate, #1: 1	يُسْرِ الْعَامِلِ
u'يَسِرَ قَضَاءٌ':Predicate, #1: 1	أَيْسَرَ قَالَ
u'يَسِرَ لَيْلٌ':Predicate, #1: 1	أَيْسَرَ قَضَاءَ
u'يُسْرٌ مُتَّصِلٌ':Added, #2: 2	أَيْسَرَ لَيْلَةَ
u'يُسْرٌ مَدِينٌ':Added, #1: 1	يُسْرٍ مُتَّصِلٍ
u'يُسْرٌ نَاسٌ':Added, #1: 1	يُسْرِ الْمَدِينِ
u'يَسِرَ نَفَذٌ':Predicate, #1: 1	يُسْرِ النَّاسِ
u'يَسِرَ يَوْمٌ':Predicate, #1: 1	أَيْسَرَ نَفَذَ
u'يُسْرٌ يَوْمٌ':Added, #2: 2	أَيْسَرَ يَوْمَ
u'يَقِظَ عُقُولٌ':Predicate, #4: 4	يُسْرَ يَوْمِهِ
u'يَقِظَ نَبِيٌّ':Predicate, #1: 1	أَيْقَظَ الْعُقُولَ
u'يَقِينٌ أَحْكَامٌ':Added, #1: 1	أَيْقَظَ النَّبِيَّ
u'يَقِينٌ إكْرَاهٌ':Added, #1: 1	يَقِينِ الْأَحْكَامِ
u'يَقِينٌ بَراءةٌ':Added, #1: 1	يَقِينَ الْإِكْرَاهِ
u'يَقِينٌ تَرْكٌ':Added, #1: 1	يَقِينِ الْبَرَاءَةِ
u'يَقِينٌ تَفَاضُلٌ':Added, #1: 1	يَقِينُ التَّرْكِ
u'يَقِينٌ حَدَثٌ':Added, #1: 1	يَقِينِ التَّفَاضُلِ
u'يَقِينٌ حَدَثٌ':Added, #1: 1	يَقِينَ الْحَدَثِ
u'يَقِينٌ حَدَثٌ':Added, #1: 1	يَقِينِ الْحَدَثِ
u'يَقِينٌ حَديثٌ':Added, #2: 2	يَقِينُ الْحَدَثِ
u'يَقِينٌ حَيْضٌ':Added, #1: 1	يَقِينُ الْحَدِيثِ
u'يَقِينٌ حَيْضٌ':Added, #1: 1	يَقِينُ حَيْضٍ
u'يَقِينٌ حَيْضٌ':Added, #2: 2	يَقِينُ الْحَيْضِ
u'يَقِينٌ خَطَأٌ':Added, #3: 3	يَقِينَ الْحَيْضِ
u'يَقِينٌ رُؤْيَةٌ':Added, #1: 1	يَقِينُ الْخَطَأِ
u'يَقِينٌ صِحَّةٌ':Added, #2: 2	يَقِينِ رُؤْيَتِهِ
u'يَقِينٌ طَهَارَةٌ':Added, #1: 1	يَقِينِ الصِّحَّةِ
u'يَقِينٌ طَهَارَةٌ':Added, #2: 2	يَقِينِ الطَّهَارَةِ
u'يَقِينٌ طهر':Added, #3: 3	يَقِينَ الطَّهَارَةِ
u'يَقِينٌ طُهْرٌ':Added, #2: 2	يَقِينَ الطُّهْرِ
u'يَقِينٌ طُهْرٌ':Added, #2: 2	يَقِينَ الطُّهْرِ
u'يَقِينٌ طهر':Added, #2: 2	يَقِينُ طُهْرٍ
u'يَقِينٌ طُهْرٌ':Added, #6: 6	يَقِينُ الطُّهْرِ
u'يَقِينٌ عَدَمٌ':Added, #6: 6	يَقِينُ الطُّهْرِ
u'يَقِينٌ علم':Added, #1: 1	يَقِينُ الْعَدَمِ
u'يَقِينٌ عِلْمٌ':Added, #1: 1	يَقِينَ الْعِلْمِ
u'يَقِينٌ عَهْدٌ':Added, #1: 1	يَقِينَ الْعِلْمِ
u'يَقِينٌ غير':Added, #1: 1	يَقِينُ الْعَهْدِ
u'يَقِينٌ غَيْرٌ':Added, #1: 1	يَقِينِ غَيْرِهِ
u'يَقِينٌ فِرَاقٌ':Added, #1: 1	يَقِينِ غَيْرِهِ
u'يَقِينٌ قِبْلَةٌ':Added, #1: 1	يَقِينُ الْفِرَاقِ
u'يَقِينٌ مُتَابَعٌ':Added, #2: 2	يَقِينِ الْقِبْلَةِ
u'يَقِينٌ مُتَابَعَةٌ':Added, #1: 1	يَقِينَ الْمُتَابَعَةِ
u'يَقِينٌ مُشَاهَدٌ':Added, #1: 1	يَقِينَ الْمُتَابَعَةِ
u'يَقِينٌ مُشَاهَدَةٌ':Added, #1: 1	يَقِينِ مُشَاهَدَةٍ
u'يَقِينٌ مِلْكٌ':Added, #1: 1	يَقِينِ مُشَاهَدَةٍ
u'يَقِينٌ مَوْتٌ':Added, #1: 1	يَقِينَ الْمِلْكِ
u'يَقِينٌ نَفْسٌ':Added, #5: 5	يَقِينُ مَوْتِهِ
u'يَقِينٌ نكاح':Added, #2: 2	يَقِينَ نَفْسِهِ
u'يَقِينٌ نِكَاحٌ':Added, #2: 2	يَقِينُ النِّكَاحِ
u'يَقِينٌ نكاح':Added, #2: 2	يَقِينُ النِّكَاحِ
u'يَقِينٌ نِكَاحٌ':Added, #2: 2	يَقِينِ نِكَاحِهِ
u'يَقِينٌ وفاة':Added, #2: 2	يَقِينِ نِكَاحِهِ
u'يَقِينٌ وَفَاةٌ':Added, #1: 1	يَقِينُ وَفَاتِهِ
u'يَمَّمَ أَجْنَبِيٌّ':Subject, #1: 1	يَقِينُ وَفَاتِهِ
u'يَمَّمَ نِساءٌ':Subject, #1: 1	يَمَّمَ الْأَجْنَبِيُّ
u'يَمِنَ اِبْنٌ':Predicate, #1: 1	يَمَّمَ النِّسَاءُ
u'يمن الْمَرْأَةُ':Added, #2: 2	أَيْمَنَ ابْنَ
u'يُمْنٌ الْمَرْأَةُ':Added, #4: 4	يُمْنِ الْمَرْأَةِ
u'يَمِنَ حَبَشِيٌّ':Predicate, #4: 4	يُمْنِ الْمَرْأَةِ
u'يمن خَيْلٌ':Added, #1: 1	أَيْمَنَ الْحَبَشِيَّةَ
u'يُمْنٌ خَيْلٌ':Added, #2: 2	يُمْنُ الْخَيْلِ
u'يَمِنَ قَالٌ':Predicate, #2: 2	يُمْنُ الْخَيْلِ
u'يَمِنَ مَوْلَاةٌ':Predicate, #5: 5	أَيْمَنَ قَالَ
u'يَنَعَ أقَلُّ':Subject, #1: 1	أَيْمَنَ مَوْلَاةَ
u'يَنَعَ أقَلُّ':Subject, #1: 1	يَنَعَ أَقَلُّ


}

# SemanticTable2={
# u'شَرَّحَ جَسَدٌ':Predicate,
# }
 
